#include <string_view>
namespace divine::str::dios {
extern const std::string_view divine_Instruction_def( 
"//===-- llvm/Instruction.def - File that describes Instructions -*- C++ -*-===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is distributed under the University of Illinois Open Source\x0a"
"// License. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"//\x0a"
"// This file contains descriptions of the various LLVM instructions.  This is\x0a"
"// used as a central place for enumerating the different instructions and\x0a"
"// should eventually be the place to put comments about the instructions.\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"// NOTE\x3a NO INCLUDE GUARD DESIRED\x21\x0a"
"\x0a"
"// Provide definitions of macros so that users of this file do not have to\x0a"
"// define everything to use it...\x0a"
"//\x0a"
"#ifndef FIRST_TERM_INST\x0a"
"#define FIRST_TERM_INST(num)\x0a"
"#endif\x0a"
"#ifndef HANDLE_TERM_INST\x0a"
"#ifndef HANDLE_INST\x0a"
"#define HANDLE_TERM_INST(num, opcode, Class)\x0a"
"#else\x0a"
"#define HANDLE_TERM_INST(num, opcode, Class) HANDLE_INST(num, opcode, Class)\x0a"
"#endif\x0a"
"#endif\x0a"
"#ifndef LAST_TERM_INST\x0a"
"#define LAST_TERM_INST(num)\x0a"
"#endif\x0a"
"\x0a"
"#ifndef FIRST_BINARY_INST\x0a"
"#define FIRST_BINARY_INST(num)\x0a"
"#endif\x0a"
"#ifndef HANDLE_BINARY_INST\x0a"
"#ifndef HANDLE_INST\x0a"
"#define HANDLE_BINARY_INST(num, opcode, instclass)\x0a"
"#else\x0a"
"#define HANDLE_BINARY_INST(num, opcode, Class) HANDLE_INST(num, opcode, Class)\x0a"
"#endif\x0a"
"#endif\x0a"
"#ifndef LAST_BINARY_INST\x0a"
"#define LAST_BINARY_INST(num)\x0a"
"#endif\x0a"
"\x0a"
"#ifndef FIRST_MEMORY_INST\x0a"
"#define FIRST_MEMORY_INST(num)\x0a"
"#endif\x0a"
"#ifndef HANDLE_MEMORY_INST\x0a"
"#ifndef HANDLE_INST\x0a"
"#define HANDLE_MEMORY_INST(num, opcode, Class)\x0a"
"#else\x0a"
"#define HANDLE_MEMORY_INST(num, opcode, Class) HANDLE_INST(num, opcode, Class)\x0a"
"#endif\x0a"
"#endif\x0a"
"#ifndef LAST_MEMORY_INST\x0a"
"#define LAST_MEMORY_INST(num)\x0a"
"#endif\x0a"
"\x0a"
"#ifndef FIRST_CAST_INST\x0a"
"#define FIRST_CAST_INST(num)\x0a"
"#endif\x0a"
"#ifndef HANDLE_CAST_INST\x0a"
"#ifndef HANDLE_INST\x0a"
"#define HANDLE_CAST_INST(num, opcode, Class)\x0a"
"#else\x0a"
"#define HANDLE_CAST_INST(num, opcode, Class) HANDLE_INST(num, opcode, Class)\x0a"
"#endif\x0a"
"#endif\x0a"
"#ifndef LAST_CAST_INST\x0a"
"#define LAST_CAST_INST(num)\x0a"
"#endif\x0a"
"\x0a"
"#ifndef FIRST_FUNCLETPAD_INST\x0a"
"#define FIRST_FUNCLETPAD_INST(num)\x0a"
"#endif\x0a"
"#ifndef HANDLE_FUNCLETPAD_INST\x0a"
"#ifndef HANDLE_INST\x0a"
"#define HANDLE_FUNCLETPAD_INST(num, opcode, Class)\x0a"
"#else\x0a"
"#define HANDLE_FUNCLETPAD_INST(num, opcode, Class) HANDLE_INST(num, opcode, Class)\x0a"
"#endif\x0a"
"#endif\x0a"
"#ifndef LAST_FUNCLETPAD_INST\x0a"
"#define LAST_FUNCLETPAD_INST(num)\x0a"
"#endif\x0a"
"\x0a"
"#ifndef FIRST_OTHER_INST\x0a"
"#define FIRST_OTHER_INST(num)\x0a"
"#endif\x0a"
"#ifndef HANDLE_OTHER_INST\x0a"
"#ifndef HANDLE_INST\x0a"
"#define HANDLE_OTHER_INST(num, opcode, Class)\x0a"
"#else\x0a"
"#define HANDLE_OTHER_INST(num, opcode, Class) HANDLE_INST(num, opcode, Class)\x0a"
"#endif\x0a"
"#endif\x0a"
"#ifndef LAST_OTHER_INST\x0a"
"#define LAST_OTHER_INST(num)\x0a"
"#endif\x0a"
"\x0a"
"#ifndef HANDLE_USER_INST\x0a"
"#define HANDLE_USER_INST(num, opc, Class) HANDLE_OTHER_INST(num, opc, Class)\x0a"
"#endif\x0a"
"\x0a"
"// Terminator Instructions - These instructions are used to terminate a basic\x0a"
"// block of the program.   Every basic block must end with one of these\x0a"
"// instructions for it to be a well formed basic block.\x0a"
"//\x0a"
" FIRST_TERM_INST  ( 1)\x0a"
"HANDLE_TERM_INST  ( 1, Ret           , ReturnInst)\x0a"
"HANDLE_TERM_INST  ( 2, Br            , BranchInst)\x0a"
"HANDLE_TERM_INST  ( 3, Switch        , SwitchInst)\x0a"
"HANDLE_TERM_INST  ( 4, IndirectBr    , IndirectBrInst)\x0a"
"HANDLE_TERM_INST  ( 5, Invoke        , InvokeInst)\x0a"
"HANDLE_TERM_INST  ( 6, Resume        , ResumeInst)\x0a"
"HANDLE_TERM_INST  ( 7, Unreachable   , UnreachableInst)\x0a"
"HANDLE_TERM_INST  ( 8, CleanupRet    , CleanupReturnInst)\x0a"
"HANDLE_TERM_INST  ( 9, CatchRet      , CatchReturnInst)\x0a"
"HANDLE_TERM_INST  (10, CatchSwitch   , CatchSwitchInst)\x0a"
"  LAST_TERM_INST  (10)\x0a"
"\x0a"
"// Standard binary operators...\x0a"
" FIRST_BINARY_INST(11)\x0a"
"HANDLE_BINARY_INST(11, Add  , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(12, FAdd , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(13, Sub  , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(14, FSub , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(15, Mul  , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(16, FMul , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(17, UDiv , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(18, SDiv , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(19, FDiv , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(20, URem , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(21, SRem , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(22, FRem , BinaryOperator)\x0a"
"\x0a"
"// Logical operators (integer operands)\x0a"
"HANDLE_BINARY_INST(23, Shl  , BinaryOperator) // Shift left  (logical)\x0a"
"HANDLE_BINARY_INST(24, LShr , BinaryOperator) // Shift right (logical)\x0a"
"HANDLE_BINARY_INST(25, AShr , BinaryOperator) // Shift right (arithmetic)\x0a"
"HANDLE_BINARY_INST(26, And  , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(27, Or   , BinaryOperator)\x0a"
"HANDLE_BINARY_INST(28, Xor  , BinaryOperator)\x0a"
"  LAST_BINARY_INST(28)\x0a"
"\x0a"
"// Memory operators...\x0a"
" FIRST_MEMORY_INST(29)\x0a"
"HANDLE_MEMORY_INST(29, Alloca, AllocaInst)  // Stack management\x0a"
"HANDLE_MEMORY_INST(30, Load  , LoadInst  )  // Memory manipulation instrs\x0a"
"HANDLE_MEMORY_INST(31, Store , StoreInst )\x0a"
"HANDLE_MEMORY_INST(32, GetElementPtr, GetElementPtrInst)\x0a"
"HANDLE_MEMORY_INST(33, Fence , FenceInst )\x0a"
"HANDLE_MEMORY_INST(34, AtomicCmpXchg , AtomicCmpXchgInst )\x0a"
"HANDLE_MEMORY_INST(35, AtomicRMW , AtomicRMWInst )\x0a"
"  LAST_MEMORY_INST(35)\x0a"
"\x0a"
"// Cast operators ...\x0a"
"// NOTE\x3a The order matters here because CastInst\x3a\x3aisEliminableCastPair\x0a"
"// NOTE\x3a (see Instructions.cpp) encodes a table based on this ordering.\x0a"
" FIRST_CAST_INST(36)\x0a"
"HANDLE_CAST_INST(36, Trunc   , TruncInst   )  // Truncate integers\x0a"
"HANDLE_CAST_INST(37, ZExt    , ZExtInst    )  // Zero extend integers\x0a"
"HANDLE_CAST_INST(38, SExt    , SExtInst    )  // Sign extend integers\x0a"
"HANDLE_CAST_INST(39, FPToUI  , FPToUIInst  )  // floating point -> UInt\x0a"
"HANDLE_CAST_INST(40, FPToSI  , FPToSIInst  )  // floating point -> SInt\x0a"
"HANDLE_CAST_INST(41, UIToFP  , UIToFPInst  )  // UInt -> floating point\x0a"
"HANDLE_CAST_INST(42, SIToFP  , SIToFPInst  )  // SInt -> floating point\x0a"
"HANDLE_CAST_INST(43, FPTrunc , FPTruncInst )  // Truncate floating point\x0a"
"HANDLE_CAST_INST(44, FPExt   , FPExtInst   )  // Extend floating point\x0a"
"HANDLE_CAST_INST(45, PtrToInt, PtrToIntInst)  // Pointer -> Integer\x0a"
"HANDLE_CAST_INST(46, IntToPtr, IntToPtrInst)  // Integer -> Pointer\x0a"
"HANDLE_CAST_INST(47, BitCast , BitCastInst )  // Type cast\x0a"
"HANDLE_CAST_INST(48, AddrSpaceCast, AddrSpaceCastInst)  // addrspace cast\x0a"
"  LAST_CAST_INST(48)\x0a"
"\x0a"
" FIRST_FUNCLETPAD_INST(49)\x0a"
"HANDLE_FUNCLETPAD_INST(49, CleanupPad, CleanupPadInst)\x0a"
"HANDLE_FUNCLETPAD_INST(50, CatchPad  , CatchPadInst)\x0a"
"  LAST_FUNCLETPAD_INST(50)\x0a"
"\x0a"
"// Other operators...\x0a"
" FIRST_OTHER_INST(51)\x0a"
"HANDLE_OTHER_INST(51, ICmp   , ICmpInst   )  // Integer comparison instruction\x0a"
"HANDLE_OTHER_INST(52, FCmp   , FCmpInst   )  // Floating point comparison instr.\x0a"
"HANDLE_OTHER_INST(53, PHI    , PHINode    )  // PHI node instruction\x0a"
"HANDLE_OTHER_INST(54, Call   , CallInst   )  // Call a function\x0a"
"HANDLE_OTHER_INST(55, Select , SelectInst )  // select instruction\x0a"
"HANDLE_USER_INST (56, UserOp1, Instruction)  // May be used internally in a pass\x0a"
"HANDLE_USER_INST (57, UserOp2, Instruction)  // Internal to passes only\x0a"
"HANDLE_OTHER_INST(58, VAArg  , VAArgInst  )  // vaarg instruction\x0a"
"HANDLE_OTHER_INST(59, ExtractElement, ExtractElementInst)// extract from vector\x0a"
"HANDLE_OTHER_INST(60, InsertElement, InsertElementInst)  // insert into vector\x0a"
"HANDLE_OTHER_INST(61, ShuffleVector, ShuffleVectorInst)  // shuffle two vectors.\x0a"
"HANDLE_OTHER_INST(62, ExtractValue, ExtractValueInst)// extract from aggregate\x0a"
"HANDLE_OTHER_INST(63, InsertValue, InsertValueInst)  // insert into aggregate\x0a"
"HANDLE_OTHER_INST(64, LandingPad, LandingPadInst)  // Landing pad instruction.\x0a"
"  LAST_OTHER_INST(64)\x0a"
"\x0a"
"#undef  FIRST_TERM_INST\x0a"
"#undef HANDLE_TERM_INST\x0a"
"#undef   LAST_TERM_INST\x0a"
"\x0a"
"#undef  FIRST_BINARY_INST\x0a"
"#undef HANDLE_BINARY_INST\x0a"
"#undef   LAST_BINARY_INST\x0a"
"\x0a"
"#undef  FIRST_MEMORY_INST\x0a"
"#undef HANDLE_MEMORY_INST\x0a"
"#undef   LAST_MEMORY_INST\x0a"
"\x0a"
"#undef  FIRST_CAST_INST\x0a"
"#undef HANDLE_CAST_INST\x0a"
"#undef   LAST_CAST_INST\x0a"
"\x0a"
"#undef  FIRST_FUNCLETPAD_INST\x0a"
"#undef HANDLE_FUNCLETPAD_INST\x0a"
"#undef   LAST_FUNCLETPAD_INST\x0a"
"\x0a"
"#undef  FIRST_OTHER_INST\x0a"
"#undef HANDLE_OTHER_INST\x0a"
"#undef   LAST_OTHER_INST\x0a"
"\x0a"
"#undef HANDLE_USER_INST\x0a"
"\x0a"
"#ifdef HANDLE_INST\x0a"
"#undef HANDLE_INST\x0a"
"#endif\x0a"
"", 8051 ); }