#include <string_view>
namespace divine::str::dios {
extern const std::string_view include__PDCLIB_encoding_h( 
"/* Encoding support <_PDCLIB_encoding.h>\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#ifndef __PDCLIB_ENCODING_H\x0a"
"#define __PDCLIB_ENCODING_H __PDCLIB_ENCODING_H\x0a"
"\x0a"
"#include <uchar.h>\x0a"
"\x0a"
"/* Must be cauued with bufsize >= 1, in \x21= NULL, out \x21= NULL, ps \x21= NULL\x0a"
" *\x0a"
" * Converts a UTF-16 (char16_t) to a UCS4 (char32_t) value. Returns\x0a"
" *   1, 2   \x3a Valid character (converted to UCS-4)\x0a"
" *   -1     \x3a Encoding error\x0a"
" *   -2     \x3a Partial character (only lead surrogate in buffer)\x0a"
" */\x0a"
"static inline int _PDCLIB_c16rtoc32(\x0a"
"            _PDCLIB_char32_t    *_PDCLIB_restrict   out, \x0a"
"    const   _PDCLIB_char16_t    *_PDCLIB_restrict   in,\x0a"
"            _PDCLIB_size_t                          bufsize,\x0a"
"            _PDCLIB_mbstate_t   *_PDCLIB_restrict   ps  \x0a"
")\x0a"
"{\x0a"
"    if(ps->_Surrogate) {\x0a"
"        // We already have a lead surrogate\x0a"
"        if((*in \x26 \x7e""0x3FF) \x21= 0xDC00) {\x0a"
"            // Encoding error\x0a"
"            return -1;\x0a"
"        } else {\x0a"
"            // Decode and reset state\x0a"
"            *out = (ps->_Surrogate \x26 0x3FF) << 10 \x7c (*in \x26 0x3FF);\x0a"
"            ps->_Surrogate = 0;\x0a"
"            return 1;\x0a"
"        }\x0a"
"    } if((*in \x26 \x7e""0x3FF) == 0xD800) {\x0a"
"        // Lead surrogate\x0a"
"        if(bufsize >= 2) {\x0a"
"            // Buffer big enough\x0a"
"            if((in\x5b""1\x5d \x26 \x7e""0x3FF) \x21= 0xDC00) {\x0a"
"                // Encoding error\x0a"
"                return -1;\x0a"
"            } else {\x0a"
"                *out = (in\x5b""0\x5d \x26 0x3FF) << 10 \x7c (in\x5b""1\x5d \x26 0x3FF);\x0a"
"                return 2;\x0a"
"            }\x0a"
"        } else {\x0a"
"            // Buffer too small - update state\x0a"
"            ps->_Surrogate = *in;\x0a"
"            return -2;\x0a"
"        }\x0a"
"    } else {\x0a"
"        // BMP character\x0a"
"        *out = *in;\x0a"
"        return 1;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"static inline _PDCLIB_size_t _PDCLIB_c32rtoc16(\x0a"
"            _PDCLIB_wchar_t     *_PDCLIB_restrict   out,\x0a"
"    const   _PDCLIB_char32_t    *_PDCLIB_restrict   in,\x0a"
"            _PDCLIB_size_t                          bufsize,\x0a"
"            _PDCLIB_mbstate_t   *_PDCLIB_restrict   ps\x0a"
")\x0a"
"{\x0a"
"    if(ps->_Surrogate) {\x0a"
"        *out = ps->_Surrogate;\x0a"
"        ps->_Surrogate = 0;\x0a"
"        return 0;\x0a"
"    }\x0a"
"\x0a"
"    if(*in <= 0xFFFF) {\x0a"
"        // BMP character\x0a"
"        *out = *in;\x0a"
"        return 1;\x0a"
"    } else {\x0a"
"        // Supplementary plane character\x0a"
"        *out = 0xD800 \x7c (*in >> 10);\x0a"
"        if(bufsize >= 2) {\x0a"
"            out\x5b""1\x5d = 0xDC00 \x7c (*in \x26 0x3FF);\x0a"
"            return 2;\x0a"
"        } else {\x0a"
"            ps->_Surrogate = 0xDC00 \x7c (*in \x26 0x3FF);\x0a"
"            return 1;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"struct _PDCLIB_charcodec_t {\x0a"
"    /* Reads at most *_P_insz code units from *_P_inbuf and writes the result \x0a"
"     * into *_P_outbuf, writing at most *_P_outsz code units. Updates \x0a"
"     * *_P_outbuf, *_P_outsz, *_P_inbuf, *_P_outsz with the resulting state\x0a"
"     *\x0a"
"     * If _P_outbuf is NULL, then the input must be processed but no output \x0a"
"     * generated. _P_outsz may be processed as normal.\x0a"
"     *\x0a"
"     * Returns true if the conversion completed successfully (i.e. one of \x0a"
"     * _P_outsize or _P_insize reached zero and no coding errors were \x0a"
"     * encountered), else return false.\x0a"
"     */\x0a"
"\x0a"
"    /* mbsinit. Mandatory. */\x0a"
"    _PDCLIB_bool (*__mbsinit)(const _PDCLIB_mbstate_t *_P_ps);\x0a"
"\x0a"
"    /* UCS-4 variants. Mandatory. */\x0a"
"\x0a"
"    _PDCLIB_bool (*__mbstoc32s)(\x0a"
"        _PDCLIB_char32_t       *_PDCLIB_restrict *_PDCLIB_restrict   _P_outbuf,\x0a"
"        _PDCLIB_size_t                           *_PDCLIB_restrict   _P_outsz,\x0a"
"        const char             *_PDCLIB_restrict *_PDCLIB_restrict   _P_inbuf,\x0a"
"        _PDCLIB_size_t                           *_PDCLIB_restrict   _P_insz,\x0a"
"        _PDCLIB_mbstate_t                        *_PDCLIB_restrict   _P_ps\x0a"
"    );\x0a"
"\x0a"
"    _PDCLIB_bool (*__c32stombs)(\x0a"
"        char                   *_PDCLIB_restrict *_PDCLIB_restrict  _P_outbuf,\x0a"
"        _PDCLIB_size_t                           *_PDCLIB_restrict  _P_outsz,\x0a"
"        const _PDCLIB_char32_t *_PDCLIB_restrict *_PDCLIB_restrict  _P_inbuf,\x0a"
"        _PDCLIB_size_t                           *_PDCLIB_restrict  _P_insz,\x0a"
"        _PDCLIB_mbstate_t                        *_PDCLIB_restrict  _P_ps\x0a"
"    );\x0a"
"\x0a"
"    /* UTF-16 variants; same as above except optional. \x0a"
"     *\x0a"
"     * If not provided, _PDCLib will internally synthesize on top of the UCS-4\x0a"
"     * variants above, albeit at a performance cost.\x0a"
"     */\x0a"
"\x0a"
"    _PDCLIB_bool (*__mbstoc16s)(\x0a"
"        _PDCLIB_char16_t       *_PDCLIB_restrict *_PDCLIB_restrict   _P_outbuf,\x0a"
"        _PDCLIB_size_t                           *_PDCLIB_restrict   _P_outsz,\x0a"
"        const char             *_PDCLIB_restrict *_PDCLIB_restrict   _P_inbuf,\x0a"
"        _PDCLIB_size_t                           *_PDCLIB_restrict   _P_insz,\x0a"
"        _PDCLIB_mbstate_t                        *_PDCLIB_restrict   _P_ps\x0a"
"    );\x0a"
"\x0a"
"    _PDCLIB_bool (*__c16stombs)(\x0a"
"        char                   *_PDCLIB_restrict *_PDCLIB_restrict  _P_outbuf,\x0a"
"        _PDCLIB_size_t                           *_PDCLIB_restrict  _P_outsz,\x0a"
"        const _PDCLIB_char16_t *_PDCLIB_restrict *_PDCLIB_restrict  _P_inbuf,\x0a"
"        _PDCLIB_size_t                           *_PDCLIB_restrict  _P_insz,\x0a"
"        _PDCLIB_mbstate_t                        *_PDCLIB_restrict  _P_ps\x0a"
"    );\x0a"
"\x0a"
"    size_t __mb_max;\x0a"
"};\x0a"
"\x0a"
"/* mbstate _PendState values */\x0a"
"enum {\x0a"
"    /* Nothing pending; _PendChar ignored */\x0a"
"    _PendClear = 0, \x0a"
"\x0a"
"    /* Process the character stored in _PendChar before reading the buffer \x0a"
"     * passed for the conversion\x0a"
"     */\x0a"
"    _PendPrefix = 1,\x0a"
"};\x0a"
"\x0a"
"/* XXX Defining these here is temporary - will move to xlocale in future */\x0a"
"size_t mbrtoc16_l(\x0a"
"        char16_t    *_PDCLIB_restrict   pc16,\x0a"
"        const char  *_PDCLIB_restrict   s, \x0a"
"        size_t                          n,\x0a"
"        mbstate_t   *_PDCLIB_restrict   ps,\x0a"
"_PDCLIB_locale_t     _PDCLIB_restrict   l);\x0a"
"\x0a"
"size_t c16rtomb_l(\x0a"
"        char        *_PDCLIB_restrict   s, \x0a"
"        char16_t                        c16, \x0a"
"        mbstate_t   *_PDCLIB_restrict   ps,\x0a"
"_PDCLIB_locale_t     _PDCLIB_restrict   l);\x0a"
"\x0a"
"size_t mbrtoc32_l(\x0a"
"        char32_t    *_PDCLIB_restrict   pc32,\x0a"
"        const char  *_PDCLIB_restrict   s, \x0a"
"        size_t                          n,\x0a"
"        mbstate_t   *_PDCLIB_restrict   ps,\x0a"
"_PDCLIB_locale_t     _PDCLIB_restrict   l);\x0a"
"\x0a"
"size_t c32rtomb_l(\x0a"
"        char        *_PDCLIB_restrict   s, \x0a"
"        char32_t                        c32,\x0a"
"        mbstate_t   *_PDCLIB_restrict   ps,\x0a"
"_PDCLIB_locale_t     _PDCLIB_restrict   l);\x0a"
"\x0a"
"#define _PDCLIB_WCHAR_ENCODING_UTF16 16\x0a"
"#define _PDCLIB_WCHAR_ENCODING_UCS4  32\x0a"
"\x0a"
"#if \x21""defined(_PDCLIB_WCHAR_ENCODING)\x0a"
"    #define _PDCLIB_WCHAR_ENCODING 0\x0a"
"#endif\x0a"
"\x0a"
"#if _PDCLIB_WCHAR_ENCODING == _PDCLIB_WCHAR_ENCODING_UTF16\x0a"
"    #define _PDCLIB_mbrtocwc_l mbrtoc16_l\x0a"
"    #define _PDCLIB_mbrtocwc   mbrtoc16\x0a"
"    #define _PDCLIB_cwcrtomb_l c16rtomb_l\x0a"
"    #define _PDCLIB_cwcrtomb   c16rtomb\x0a"
"#elif _PDCLIB_WCHAR_ENCODING == _PDCLIB_WCHAR_ENCODING_UCS4\x0a"
"    #define _PDCLIB_mbrtocwc_l mbrtoc32_l\x0a"
"    #define _PDCLIB_mbrtocwc   mbrtoc32\x0a"
"    #define _PDCLIB_cwcrtomb_l c32rtomb_l\x0a"
"    #define _PDCLIB_cwcrtomb   c32rtomb\x0a"
"#else\x0a"
"    #error _PDCLIB_WCHAR_ENCODING not defined correctly\x0a"
"    #error Define to one of _PDCLIB_WCHAR_ENCODING_UCS4 or _PDCLIB_WCHAR_ENCODING_UTF16\x0a"
"#endif\x0a"
"\x0a"
"#endif\x0a"
"", 7183 ); }