#include <string_view>
namespace divine::str::dios {
extern const std::string_view include__PDCLIB_int_h( 
"/* PDCLib internal integer logic <_PDCLIB_int.h>\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#ifndef __PDCLIB_INT_H\x0a"
"#define __PDCLIB_INT_H __PDCLIB_INT_H\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* You should not have to edit anything in this file; if you DO have to, it   */\x0a"
"/* would be considered a bug / missing feature\x3a notify the author(s).         */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"\x0a"
"#include <_PDCLIB/config.h>\x0a"
"#include <_PDCLIB/cdefs.h>\x0a"
"\x0a"
"/* null pointer constant */\x0a"
"#define _PDCLIB_NULL 0\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* Limits of native datatypes                                                 */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* The definition of minimum limits for unsigned datatypes is done because    */\x0a"
"/* later on we will \x22""construct\x22 limits for other abstract types\x3a              */\x0a"
"/* USHRT -> _PDCLIB_ + USHRT + _MIN -> _PDCLIB_USHRT_MIN -> 0                 */\x0a"
"/* INT -> _PDCLIB_ + INT + _MIN -> _PDCLIB_INT_MIN -> ... you get the idea.   */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"\x0a"
"/* Setting 'char' limits                                                      */\x0a"
"#define _PDCLIB_CHAR_BIT    8\x0a"
"#define _PDCLIB_UCHAR_MIN   0\x0a"
"#define _PDCLIB_UCHAR_MAX   0xff\x0a"
"#define _PDCLIB_SCHAR_MIN   (-0x7f - 1)\x0a"
"#define _PDCLIB_SCHAR_MAX   0x7f\x0a"
"#if _PDCLIB_CHAR_SIGNED == 1\x0a"
"#define _PDCLIB_CHAR_MIN    _PDCLIB_SCHAR_MIN\x0a"
"#define _PDCLIB_CHAR_MAX    _PDCLIB_SCHAR_MAX\x0a"
"#else\x0a"
"#define _PDCLIB_CHAR_MIN    0\x0a"
"#define _PDCLIB_CHAR_MAX    _PDCLIB_UCHAR_MAX\x0a"
"#endif\x0a"
"\x0a"
"/* Setting 'short' limits                                                     */\x0a"
"#if     _PDCLIB_SHRT_BYTES == 2\x0a"
"#define _PDCLIB_SHRT_MAX      0x7fff\x0a"
"#define _PDCLIB_SHRT_MIN      (-0x7fff - 1)\x0a"
"#define _PDCLIB_USHRT_MAX     0xffff\x0a"
"#else\x0a"
"#error Unsupported width of 'short' (not 16 bit).\x0a"
"#endif\x0a"
"#define _PDCLIB_USHRT_MIN 0\x0a"
"\x0a"
"#if _PDCLIB_INT_BYTES < _PDCLIB_SHRT_BYTES\x0a"
"#error Bogus setting\x3a short > int\x3f Check _PDCLIB_config.h.\x0a"
"#endif\x0a"
"\x0a"
"/* Setting 'int' limits                                                       */\x0a"
"#if     _PDCLIB_INT_BYTES == 2\x0a"
"#define _PDCLIB_INT_MAX   0x7fff\x0a"
"#define _PDCLIB_INT_MIN   (-0x7fff - 1)\x0a"
"#define _PDCLIB_UINT_MAX  0xffffU\x0a"
"#elif   _PDCLIB_INT_BYTES == 4\x0a"
"#define _PDCLIB_INT_MAX   0x7fffffff\x0a"
"#define _PDCLIB_INT_MIN   (-0x7fffffff - 1)\x0a"
"#define _PDCLIB_UINT_MAX  0xffffffffU\x0a"
"#elif _PDCLIB_INT_BYTES   == 8\x0a"
"#define _PDCLIB_INT_MAX   0x7fffffffffffffff\x0a"
"#define _PDCLIB_INT_MIN   (-0x7fffffffffffffff - 1)\x0a"
"#define _PDCLIB_UINT_MAX  0xffffffffffffffff\x0a"
"#else\x0a"
"#error Unsupported width of 'int' (neither 16, 32, nor 64 bit).\x0a"
"#endif\x0a"
"#define _PDCLIB_UINT_MIN 0\x0a"
"\x0a"
"/* Setting 'long' limits                                                      */\x0a"
"#if   _PDCLIB_LONG_BYTES   == 4\x0a"
"#define _PDCLIB_LONG_MAX   0x7fffffffL\x0a"
"#define _PDCLIB_LONG_MIN   (-0x7fffffffL - 1L)\x0a"
"#define _PDCLIB_ULONG_MAX  0xffffffffUL\x0a"
"#elif   _PDCLIB_LONG_BYTES == 8\x0a"
"#define _PDCLIB_LONG_MAX   0x7fffffffffffffffL\x0a"
"#define _PDCLIB_LONG_MIN   (-0x7fffffffffffffffL - 1L)\x0a"
"#define _PDCLIB_ULONG_MAX  0xffffffffffffffffUL\x0a"
"#else\x0a"
"#error Unsupported width of 'long' (neither 32 nor 64 bit).\x0a"
"#endif\x0a"
"#define _PDCLIB_ULONG_MIN 0\x0a"
"\x0a"
"/* Setting 'long long' limits                                                 */\x0a"
"#if _PDCLIB_LLONG_BYTES    == 8\x0a"
"#define _PDCLIB_LLONG_MAX  0x7fffffffffffffffLL\x0a"
"#define _PDCLIB_LLONG_MIN  (-0x7fffffffffffffffLL - 1LL)\x0a"
"#define _PDCLIB_ULLONG_MAX 0xffffffffffffffffULL\x0a"
"#elif _PDCLIB_LLONG_BYTES  == 16\x0a"
"#define _PDCLIB_LLONG_MAX  0x7fffffffffffffffffffffffffffffffLL\x0a"
"#define _PDCLIB_LLONG_MIN  (-0x7fffffffffffffffffffffffffffffffLL - 1LL)\x0a"
"#define _PDCLIB_ULLONG_MAX 0xffffffffffffffffffffffffffffffffULL\x0a"
"#else\x0a"
"#error Unsupported width of 'long long' (neither 64 nor 128 bit).\x0a"
"#endif\x0a"
"#define _PDCLIB_ULLONG_MIN 0\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"extern \x22""C\x22 {\x0a"
"#endif\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* <stdint.h> exact-width types and their limits                              */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* Note that, for the \x22standard\x22 widths of 8, 16, 32 and 64 bit, the \x22LEAST\x22  */\x0a"
"/* types are identical to the \x22""exact-width\x22 types, by definition.             */\x0a"
"\x0a"
"/* Setting 'int8_t', its limits, its literal, and conversion macros.          */\x0a"
"#if     _PDCLIB_CHAR_BIT == 8\x0a"
"typedef signed char        _PDCLIB_int8_t;\x0a"
"typedef unsigned char      _PDCLIB_uint8_t;\x0a"
"typedef signed char        _PDCLIB_int_least8_t;\x0a"
"typedef unsigned char      _PDCLIB_uint_least8_t;\x0a"
"#define _PDCLIB_INT8_MAX   _PDCLIB_CHAR_MAX\x0a"
"#define _PDCLIB_INT8_MIN   _PDCLIB_CHAR_MIN\x0a"
"#define _PDCLIB_UINT8_MAX  _PDCLIB_UCHAR_MAX\x0a"
"#define _PDCLIB_8_CONV     hh\x0a"
"#else\x0a"
"#error Unsupported width of char (not 8 bits).\x0a"
"#endif\x0a"
"\x0a"
"/* Setting 'int16_t', its limits, its literal, and conversion macros.         */\x0a"
"#if     _PDCLIB_INT_BYTES  == 2\x0a"
"typedef signed int         _PDCLIB_int16_t;\x0a"
"typedef unsigned int       _PDCLIB_uint16_t;\x0a"
"typedef signed int         _PDCLIB_int_least16_t;\x0a"
"typedef unsigned int       _PDCLIB_uint_least16_t;\x0a"
"#define _PDCLIB_INT16_MAX  _PDCLIB_INT_MAX\x0a"
"#define _PDCLIB_INT16_MIN  _PDCLIB_INT_MIN\x0a"
"#define _PDCLIB_UINT16_MAX _PDCLIB_UINT_MAX\x0a"
"#define _PDCLIB_16_CONV\x0a"
"#elif   _PDCLIB_SHRT_BYTES == 2\x0a"
"typedef signed short       _PDCLIB_int16_t;\x0a"
"typedef unsigned short     _PDCLIB_uint16_t;\x0a"
"typedef signed short       _PDCLIB_int_least16_t;\x0a"
"typedef unsigned short     _PDCLIB_uint_least16_t;\x0a"
"#define _PDCLIB_INT16_MAX  _PDCLIB_SHRT_MAX\x0a"
"#define _PDCLIB_INT16_MIN  _PDCLIB_SHRT_MIN\x0a"
"#define _PDCLIB_UINT16_MAX _PDCLIB_USHRT_MAX\x0a"
"#define _PDCLIB_16_CONV    h\x0a"
"#else\x0a"
"#error Neither 'short' nor 'int' are 16-bit.\x0a"
"#endif\x0a"
"\x0a"
"/* Setting 'int32_t', its limits, its literal, and conversion macros.         */\x0a"
"#if     _PDCLIB_INT_BYTES  == 4\x0a"
"typedef signed int         _PDCLIB_int32_t;\x0a"
"typedef unsigned int       _PDCLIB_uint32_t;\x0a"
"typedef signed int         _PDCLIB_int_least32_t;\x0a"
"typedef unsigned int       _PDCLIB_uint_least32_t;\x0a"
"#define _PDCLIB_INT32_MAX  _PDCLIB_INT_MAX\x0a"
"#define _PDCLIB_INT32_MIN  _PDCLIB_INT_MIN\x0a"
"#define _PDCLIB_UINT32_MAX _PDCLIB_UINT_MAX\x0a"
"#define _PDCLIB_INT32_LITERAL\x0a"
"#define _PDCLIB_UINT32_LITERAL\x0a"
"#define _PDCLIB_32_CONV\x0a"
"#elif   _PDCLIB_LONG_BYTES == 4\x0a"
"typedef signed long        _PDCLIB_int32_t;\x0a"
"typedef unsigned long      _PDCLIB_uint32_t;\x0a"
"typedef signed long        _PDCLIB_int_least32_t;\x0a"
"typedef unsigned long      _PDCLIB_uint_least32_t;\x0a"
"#define _PDCLIB_INT32_MAX  _PDCLIB_LONG_MAX\x0a"
"#define _PDCLIB_INT32_MIN  _PDCLIB_LONG_MIN\x0a"
"#define _PDCLIB_UINT32_MAX _PDCLIB_LONG_MAX\x0a"
"#define _PDCLIB_INT32_LITERAL  l\x0a"
"#define _PDCLIB_UINT32_LITERAL ul\x0a"
"#define _PDCLIB_32_CONV        l\x0a"
"#else\x0a"
"#error Neither 'int' nor 'long' are 32-bit.\x0a"
"#endif\x0a"
"\x0a"
"/* Setting 'int64_t', its limits, its literal, and conversion macros.         */\x0a"
"#if     _PDCLIB_LONG_BYTES == 8 \x26\x26 \x21""defined(_PDCLIB_INT64_IS_LLONG)\x0a"
"typedef signed long        _PDCLIB_int64_t;\x0a"
"typedef unsigned long      _PDCLIB_uint64_t;\x0a"
"typedef signed long        _PDCLIB_int_least64_t;\x0a"
"typedef unsigned long      _PDCLIB_uint_least64_t;\x0a"
"#define _PDCLIB_INT64_MAX  _PDCLIB_LONG_MAX\x0a"
"#define _PDCLIB_INT64_MIN  _PDCLIB_LONG_MIN\x0a"
"#define _PDCLIB_UINT64_MAX  _PDCLIB_ULONG_MAX\x0a"
"#define _PDCLIB_INT64_LITERAL  l\x0a"
"#define _PDCLIB_UINT64_LITERAL ul\x0a"
"#define _PDCLIB_64_CONV        l\x0a"
"#elif _PDCLIB_LLONG_BYTES  == 8\x0a"
"typedef signed long long   _PDCLIB_int64_t;\x0a"
"typedef unsigned long long _PDCLIB_uint64_t;\x0a"
"typedef signed long long   _PDCLIB_int_least64_t;\x0a"
"typedef unsigned long long _PDCLIB_uint_least64_t;\x0a"
"#define _PDCLIB_INT64_MAX  _PDCLIB_LLONG_MAX\x0a"
"#define _PDCLIB_INT64_MIN  _PDCLIB_LLONG_MIN\x0a"
"#define _PDCLIB_UINT64_MAX  _PDCLIB_ULLONG_MAX\x0a"
"#define _PDCLIB_INT64_LITERAL  ll\x0a"
"#define _PDCLIB_UINT64_LITERAL ull\x0a"
"#define _PDCLIB_64_CONV        ll\x0a"
"#else\x0a"
"#error Neither 'long' nor 'long long' are 64-bit.\x0a"
"#endif\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* <stdint.h> \x22""fastest\x22 types and their limits                                */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* This is, admittedly, butt-ugly. But at least it's ugly where the average   */\x0a"
"/* user of PDCLib will never see it, and makes <_PDCLIB_config.h> much        */\x0a"
"/* cleaner.                                                                   */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"\x0a"
"typedef _PDCLIB_fast8          _PDCLIB_int_fast8_t;\x0a"
"typedef unsigned _PDCLIB_fast8 _PDCLIB_uint_fast8_t;\x0a"
"#define _PDCLIB_INT_FAST8_MIN  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_FAST8 ), _MIN )\x0a"
"#define _PDCLIB_INT_FAST8_MAX  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_FAST8 ), _MAX )\x0a"
"#define _PDCLIB_UINT_FAST8_MAX _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_U, _PDCLIB_FAST8 ), _MAX )\x0a"
"\x0a"
"typedef _PDCLIB_fast16          _PDCLIB_int_fast16_t;\x0a"
"typedef unsigned _PDCLIB_fast16 _PDCLIB_uint_fast16_t;\x0a"
"#define _PDCLIB_INT_FAST16_MIN  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_FAST16 ), _MIN )\x0a"
"#define _PDCLIB_INT_FAST16_MAX  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_FAST16 ), _MAX )\x0a"
"#define _PDCLIB_UINT_FAST16_MAX _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_U, _PDCLIB_FAST16 ), _MAX )\x0a"
"\x0a"
"typedef _PDCLIB_fast32          _PDCLIB_int_fast32_t;\x0a"
"typedef unsigned _PDCLIB_fast32 _PDCLIB_uint_fast32_t;\x0a"
"#define _PDCLIB_INT_FAST32_MIN  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_FAST32 ), _MIN )\x0a"
"#define _PDCLIB_INT_FAST32_MAX  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_FAST32 ), _MAX )\x0a"
"#define _PDCLIB_UINT_FAST32_MAX _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_U, _PDCLIB_FAST32 ), _MAX )\x0a"
"\x0a"
"typedef _PDCLIB_fast64          _PDCLIB_int_fast64_t;\x0a"
"typedef unsigned _PDCLIB_fast64 _PDCLIB_uint_fast64_t;\x0a"
"#define _PDCLIB_INT_FAST64_MIN  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_FAST64 ), _MIN )\x0a"
"#define _PDCLIB_INT_FAST64_MAX  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_FAST64 ), _MAX )\x0a"
"#define _PDCLIB_UINT_FAST64_MAX _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_U, _PDCLIB_FAST64 ), _MAX )\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* Various <stddef.h> typedefs and limits                                     */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"\x0a"
"typedef _PDCLIB_ptrdiff     _PDCLIB_ptrdiff_t;\x0a"
"#define _PDCLIB_PTRDIFF_MIN _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_PTRDIFF ), _MIN )\x0a"
"#define _PDCLIB_PTRDIFF_MAX _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_PTRDIFF ), _MAX )\x0a"
"\x0a"
"typedef _PDCLIB_size     _PDCLIB_size_t;\x0a"
"#define _PDCLIB_SIZE_MAX _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_SIZE ), _MAX )\x0a"
"\x0a"
"typedef _PDCLIB_wint      _PDCLIB_wint_t;\x0a"
"\x0a"
"#ifndef __cplusplus\x0a"
"    typedef _PDCLIB_wchar     _PDCLIB_wchar_t;\x0a"
"#else\x0a"
"    typedef wchar_t _PDCLIB_wchar_t;\x0a"
"#endif\x0a"
"#define _PDCLIB_WCHAR_MIN _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_WCHAR ), _MIN )\x0a"
"#define _PDCLIB_WCHAR_MAX _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_WCHAR ), _MAX )\x0a"
"\x0a"
"#define _PDCLIB_SIG_ATOMIC_MIN _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_SIG_ATOMIC ), _MIN )\x0a"
"#define _PDCLIB_SIG_ATOMIC_MAX _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_SIG_ATOMIC ), _MAX )\x0a"
"\x0a"
"typedef _PDCLIB_intptr          _PDCLIB_intptr_t;\x0a"
"typedef unsigned _PDCLIB_intptr _PDCLIB_uintptr_t;\x0a"
"#define _PDCLIB_INTPTR_MIN  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_INTPTR ), _MIN )\x0a"
"#define _PDCLIB_INTPTR_MAX  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_INTPTR ), _MAX )\x0a"
"#define _PDCLIB_UINTPTR_MAX _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_U, _PDCLIB_INTPTR ), _MAX )\x0a"
"\x0a"
"typedef _PDCLIB_intmax          _PDCLIB_intmax_t;\x0a"
"typedef unsigned _PDCLIB_intmax _PDCLIB_uintmax_t;\x0a"
"#define _PDCLIB_INTMAX_MIN  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_INTMAX ), _MIN )\x0a"
"#define _PDCLIB_INTMAX_MAX  _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_, _PDCLIB_INTMAX ), _MAX )\x0a"
"#define _PDCLIB_UINTMAX_MAX _PDCLIB_concat( _PDCLIB_concat( _PDCLIB_U, _PDCLIB_INTMAX ), _MAX )\x0a"
"#define _PDCLIB_INTMAX_C( value )  _PDCLIB_concat( value, _PDCLIB_INTMAX_LITERAL )\x0a"
"#define _PDCLIB_UINTMAX_C( value ) _PDCLIB_concat( value, _PDCLIB_concat( u, _PDCLIB_INTMAX_LITERAL ) )\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* Various <time.h> internals                                                 */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"\x0a"
"typedef _PDCLIB_time            _PDCLIB_time_t;\x0a"
"typedef _PDCLIB_clock           _PDCLIB_clock_t;\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* Internal data types                                                        */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"\x0a"
"/* Structure required by both atexit() and exit() for handling atexit functions */\x0a"
"struct _PDCLIB_exitfunc_t\x0a"
"{\x0a"
"    struct _PDCLIB_exitfunc_t * next;\x0a"
"    void (*func)( void );\x0a"
"};\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* Declaration of helper functions (implemented in functions/_PDCLIB).        */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"\x0a"
"/* This is the main function called by atoi(), atol() and atoll().            */\x0a"
"_PDCLIB_intmax_t _PDCLIB_atomax( const char * s );\x0a"
"\x0a"
"/* Two helper functions used by strtol(), strtoul() and long long variants.   */\x0a"
"const char * _PDCLIB_strtox_prelim( const char * p, char * sign, int * base );\x0a"
"_PDCLIB_uintmax_t _PDCLIB_strtox_main( const char ** p, unsigned int base, _PDCLIB_uintmax_t error, _PDCLIB_uintmax_t limval, int limdigit, char * sign );\x0a"
"\x0a"
"/* Digits arrays used by various integer conversion functions */\x0a"
"extern const char * const _PDCLIB_digits;\x0a"
"extern const char * const _PDCLIB_Xdigits;\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* Sanity checks                                                              */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"\x0a"
"#if _PDCLIB_C_VERSION >= 2011\x0a"
"_Static_assert( sizeof( short ) == _PDCLIB_SHRT_BYTES, \x22""Compiler disagrees on _PDCLIB_SHRT_BYTES.\x22 );\x0a"
"_Static_assert( sizeof( int ) == _PDCLIB_INT_BYTES, \x22""Compiler disagrees on _PDCLIB_INT_BYTES.\x22 );\x0a"
"_Static_assert( sizeof( long ) == _PDCLIB_LONG_BYTES, \x22""Compiler disagrees on _PDCLIB_LONG_BYTES.\x22 );\x0a"
"_Static_assert( sizeof( long long ) == _PDCLIB_LLONG_BYTES, \x22""Compiler disagrees on _PDCLIB_LLONG_BYTES.\x22 );\x0a"
"\x0a"
"_Static_assert( ( (char)-1 < 0 ) == _PDCLIB_CHAR_SIGNED, \x22""Compiler disagrees on _PDCLIB_CHAR_SIGNED.\x22 );\x0a"
"_Static_assert( sizeof( sizeof( int ) ) == sizeof( _PDCLIB_size ), \x22""Compiler disagrees on _PDCLIB_size.\x22 );\x0a"
"\x0a"
"_Static_assert( sizeof( _PDCLIB_wchar ) == sizeof( L'x' ), \x22""Compiler disagrees on _PDCLIB_wchar.\x22 );\x0a"
"\x0a"
"_Static_assert( sizeof( void * ) == sizeof( _PDCLIB_intptr ), \x22""Compiler disagrees on _PDCLIB_intptr.\x22 );\x0a"
"\x0a"
"_Static_assert( sizeof( \x26_PDCLIB_digits\x5b""1\x5d - \x26_PDCLIB_digits\x5b""0\x5d ) == sizeof( _PDCLIB_ptrdiff ), \x22""Compiler disagrees on _PDCLIB_ptrdiff.\x22 );\x0a"
"#endif\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* locale / wchar / uchar                                                     */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"\x0a"
"#if \x21""defined( __cplusplus  ) \x7c\x7c _PDCLIB_CXX_VERSION < 2011\x0a"
"typedef _PDCLIB_uint16_t        _PDCLIB_char16_t;\x0a"
"typedef _PDCLIB_uint32_t        _PDCLIB_char32_t;\x0a"
"#else\x0a"
"typedef char16_t                _PDCLIB_char16_t;\x0a"
"typedef char32_t                _PDCLIB_char32_t;\x0a"
"#endif\x0a"
"\x0a"
"typedef struct __mbstate_t {\x0a"
"    union {\x0a"
"        /* Is this the best way to represent this\x3f Is this big enough\x3f */\x0a"
"        _PDCLIB_uint64_t _St64\x5b""15\x5d;\x0a"
"        _PDCLIB_uint32_t _St32\x5b""31\x5d;\x0a"
"        _PDCLIB_uint16_t _St16\x5b""62\x5d;\x0a"
"        unsigned char    _StUC\x5b""124\x5d;\x0a"
"        signed   char    _StSC\x5b""124\x5d;\x0a"
"                 char    _StC \x5b""124\x5d;\x0a"
"    };\x0a"
"\x0a"
"    /* c16/related functions\x3a Surrogate storage\x0a"
"     *\x0a"
"     * If zero, no surrogate pending. If nonzero, surrogate.\x0a"
"     */\x0a"
"    _PDCLIB_uint16_t     _Surrogate;\x0a"
"\x0a"
"    /* In cases where the underlying codec is capable of regurgitating a\x0a"
"     * character without consuming any extra input (e.g. a surrogate pair in a\x0a"
"     * UCS-4 to UTF-16 conversion) then these fields are used to track that\x0a"
"     * state. In particular, they are used to buffer/fake the input for mbrtowc\x0a"
"     * and similar functions.\x0a"
"     *\x0a"
"     * See _PDCLIB_encoding.h for values of _PendState and the resultant value\x0a"
"     * in _PendChar.\x0a"
"     */\x0a"
"    unsigned char _PendState;\x0a"
"             char _PendChar;\x0a"
"} _PDCLIB_mbstate_t;\x0a"
"\x0a"
"typedef struct _PDCLIB_locale    *_PDCLIB_locale_t;\x0a"
"typedef struct lconv              _PDCLIB_lconv_t;\x0a"
"\x0a"
"_PDCLIB_size_t __ctype_get_mb_cur_max ( void );\x0a"
"\x0a"
"/* wide-character EOF */\x0a"
"#define _PDCLIB_WEOF ((wint_t) -1)\x0a"
"\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* stdio                                                                      */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"\x0a"
"/* Position / status structure for getpos() / fsetpos(). */\x0a"
"typedef struct _PDCLIB_fpos\x0a"
"{\x0a"
"    _PDCLIB_int_fast64_t offset; /* File position offset */\x0a"
"    _PDCLIB_mbstate_t    mbs;    /* Multibyte parsing state */\x0a"
"} _PDCLIB_fpos_t;\x0a"
"\x0a"
"typedef struct _PDCLIB_fileops  _PDCLIB_fileops_t;\x0a"
"typedef union  _PDCLIB_fd       _PDCLIB_fd_t;\x0a"
"typedef struct _PDCLIB_file     _PDCLIB_file_t; // Rename to _PDCLIB_FILE\x3f\x0a"
"\x0a"
"/* Status structure required by _PDCLIB_print(). */\x0a"
"struct _PDCLIB_status_t\x0a"
"{\x0a"
"    /* XXX This structure is horrible now. scanf needs its own */\x0a"
"\x0a"
"    int              base;   /* base to which the value shall be converted   */\x0a"
"    _PDCLIB_int_fast32_t flags; /* flags and length modifiers                */\x0a"
"    unsigned         n;      /* print\x3a maximum characters to be written (snprintf) */\x0a"
"                             /* scan\x3a  number matched conversion specifiers  */\x0a"
"    unsigned         i;      /* number of characters read/written            */\x0a"
"    unsigned         current;/* chars read/written in the CURRENT conversion */\x0a"
"    unsigned         width;  /* specified field width                        */\x0a"
"    int              prec;   /* specified field precision                    */\x0a"
"\x0a"
"    union {\x0a"
"        void *           ctx;    /* context for callback */\x0a"
"        const char *     s;      /* input string for scanf */\x0a"
"    };\x0a"
"\x0a"
"    union {\x0a"
"        _PDCLIB_size_t ( *write ) ( void *p, const char *buf, _PDCLIB_size_t size );\x0a"
"        _PDCLIB_file_t *stream;  /* for scanf */\x0a"
"    };\x0a"
"    _PDCLIB_va_list  arg;    /* argument stack                               */\x0a"
"};\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#endif\x0a"
"", 18807 ); }