#include <string_view>
namespace divine::str::dios {
extern const std::string_view include__PDCLIB_io_h( 
"/* PDCLib I/O support <_PDCLIB_io.h>\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#ifndef __PDCLIB_IO_H\x0a"
"#define __PDCLIB_IO_H __PDCLIB_IO_H\x0a"
"\x0a"
"#include <_PDCLIB/int.h>\x0a"
"#include <_PDCLIB/threadconfig.h>\x0a"
"\x0a"
"/* Flags for representing mode (see fopen()). Note these must fit the same\x0a"
"   status field as the _IO\x3f""BF flags in <stdio.h> and the internal flags below.\x0a"
"*/\x0a"
"#define _PDCLIB_FREAD     8u\x0a"
"#define _PDCLIB_FWRITE   16u\x0a"
"#define _PDCLIB_FAPPEND  32u\x0a"
"#define _PDCLIB_FRW      64u\x0a"
"#define _PDCLIB_FBIN    128u\x0a"
"\x0a"
"/* Internal flags, made to fit the same status field as the flags above. */\x0a"
"/* -------------------------------------------------------------------------- */\x0a"
"/* free() the buffer memory on closing (false for user-supplied buffer) */\x0a"
"#define _PDCLIB_FREEBUFFER   512u\x0a"
"/* stream has encountered error / EOF */\x0a"
"#define _PDCLIB_ERRORFLAG   1024u\x0a"
"#define _PDCLIB_EOFFLAG     2048u\x0a"
"/* stream is wide-oriented */\x0a"
"#define _PDCLIB_WIDESTREAM  4096u\x0a"
"/* stream is byte-oriented */\x0a"
"#define _PDCLIB_BYTESTREAM  8192u\x0a"
"/* file associated with stream should be remove()d on closing (tmpfile()) */\x0a"
"#define _PDCLIB_DELONCLOSE 16384u\x0a"
"/* stream handle should not be free()d on close (stdin, stdout, stderr) */\x0a"
"#define _PDCLIB_STATIC     32768u\x0a"
"\x0a"
"/* See setvbuf(), third argument */\x0a"
"#define _IOFBF 1\x0a"
"#define _IOLBF 2\x0a"
"#define _IONBF 4\x0a"
"\x0a"
"#define EOF -1\x0a"
"\x0a"
"\x0a"
"union _PDCLIB_fd\x0a"
"{\x0a"
"#if defined(_PDCLIB_OSFD_T)\x0a"
"    _PDCLIB_OSFD_T      osfd;\x0a"
"#endif\x0a"
"    void *              pointer;\x0a"
"    _PDCLIB_uintptr_t   uval;\x0a"
"    _PDCLIB_intptr_t    sval;\x0a"
"};\x0a"
"\x0a"
"__BEGIN_DECLS\x0a"
"\x0a"
"/******************************************************************************/\x0a"
"/* Internal functions                                                         */\x0a"
"/******************************************************************************/\x0a"
"\x0a"
"/* The worker for all printf() type of functions. The pointer spec should point\x0a"
"   to the introducing '\x25' of a conversion specifier. The status structure is to\x0a"
"   be that of the current printf() function, of which the members n, s, stream\x0a"
"   and arg will be preserved; i will be updated; and all others will be trashed\x0a"
"   by the function.\x0a"
"   Returns the number of characters parsed as a conversion specifier (0 if none\x0a"
"   parsed); returns -1 if the underlying I/O callback returns failure.\x0a"
"*/\x0a"
"int _PDCLIB_print( const char * spec, struct _PDCLIB_status_t * status );\x0a"
"\x0a"
"/* Simple implementation of strtol, which expects base 10 positive number. Used\x0a"
"   in _PDCLIB_print - strtol uses pthread local storage and breaks __dios_trace.\x0a"
"   Implementation is simple and naive (as the rest of _PDCLIB_print)\x0a"
"*/\x0a"
"long int _DIVINE_strtol( const char *s, int size, char **endptr );\x0a"
"\x0a"
"/* The worker for all scanf() type of functions. The pointer spec should point\x0a"
"   to the introducing '\x25' of a conversion specifier. The status structure is to\x0a"
"   be that of the current scanf() function, of which the member stream will be\x0a"
"   preserved; n, i, and s will be updated; and all others will be trashed by\x0a"
"   the function.\x0a"
"   Returns a pointer to the first character not parsed as conversion specifier,\x0a"
"   or NULL in case of error.\x0a"
"   FIXME\x3a Should distinguish between matching and input error\x0a"
"*/\x0a"
"const char * _PDCLIB_scan( const char * spec, struct _PDCLIB_status_t * status );\x0a"
"\x0a"
"/* Parsing any fopen() style filemode string into a number of flags. */\x0a"
"unsigned int _PDCLIB_filemode( const char * mode );\x0a"
"\x0a"
"/* Sanity checking and preparing of read buffer, should be called first thing\x0a"
"   by any stdio read-data function.\x0a"
"   Returns 0 on success, EOF on error.\x0a"
"   On error, EOF / error flags and errno are set appropriately.\x0a"
"*/\x0a"
"int _PDCLIB_prepread( _PDCLIB_file_t * stream );\x0a"
"\x0a"
"/* Sanity checking, should be called first thing by any stdio write-data\x0a"
"   function.\x0a"
"   Returns 0 on success, EOF on error.\x0a"
"   On error, error flags and errno are set appropriately.\x0a"
"*/\x0a"
"int _PDCLIB_prepwrite( _PDCLIB_file_t * stream );\x0a"
"\x0a"
"/* Closing all streams on program exit */\x0a"
"void _PDCLIB_closeall( void );\x0a"
"\x0a"
"/* Writes a stream's buffer.\x0a"
"   Returns 0 on success, EOF on write error.\x0a"
"   Sets stream error flags and errno appropriately on error.\x0a"
"*/\x0a"
"int _PDCLIB_flushbuffer( _PDCLIB_file_t * stream );\x0a"
"\x0a"
"/* Fills a stream's buffer.\x0a"
"   Returns 0 on success, EOF on read error / EOF.\x0a"
"   Sets stream EOF / error flags and errno appropriately on error.\x0a"
"*/\x0a"
"int _PDCLIB_fillbuffer( _PDCLIB_file_t * stream );\x0a"
"\x0a"
"/* Repositions within a file. Returns new offset on success,\x0a"
"   -1 / errno on error.\x0a"
"*/\x0a"
"_PDCLIB_int_fast64_t _PDCLIB_seek( _PDCLIB_file_t * stream,\x0a"
"                                  _PDCLIB_int_fast64_t offset, int whence );\x0a"
"\x0a"
"/* File backend I/O operations\x0a"
" *\x0a"
" * PDCLib will call through to these methods as needed to implement the stdio\x0a"
" * functions.\x0a"
" */\x0a"
"struct _PDCLIB_fileops\x0a"
"{\x0a"
"    /*\x21 Read length bytes from the file into buf; returning the number of bytes\x0a"
"     *  actually read in *numBytesRead.\x0a"
"     *\x0a"
"     *  Returns true if bytes were read successfully; on end of file, returns\x0a"
"     *  true with *numBytesRead == 0.\x0a"
"     *\x0a"
"     *  On error, returns false and sets errno appropriately. *numBytesRead is\x0a"
"     *  ignored in this situation.\x0a"
"     */\x0a"
"    _PDCLIB_bool (*read)( _PDCLIB_fd_t self,\x0a"
"                          void * buf,\x0a"
"                          _PDCLIB_size_t length,\x0a"
"                          _PDCLIB_size_t * numBytesRead );\x0a"
"\x0a"
"    /*\x21 Write length bytes to the file from buf; returning the number of bytes\x0a"
"     *  actually written in *numBytesWritten\x0a"
"     *\x0a"
"     *  Returns true if bytes were written successfully. On error, returns false\x0a"
"     *  and setss errno appropriately (as with read, *numBytesWritten is\x0a"
"     *  ignored)\x0a"
"     */\x0a"
"    _PDCLIB_bool (*write)( _PDCLIB_fd_t self, const void * buf,\x0a"
"                   _PDCLIB_size_t length, _PDCLIB_size_t * numBytesWritten );\x0a"
"\x0a"
"    /* Seek to the file offset specified by offset, from location whence, which\x0a"
"     * may be one of the standard constants SEEK_SET/SEEK_CUR/SEEK_END\x0a"
"     */\x0a"
"    _PDCLIB_bool (*seek)( _PDCLIB_fd_t self, _PDCLIB_int_fast64_t offset,\x0a"
"                          int whence, _PDCLIB_int_fast64_t *newPos );\x0a"
"\x0a"
"    void (*close)( _PDCLIB_fd_t self );\x0a"
"\x0a"
"    /*\x21 Behaves as read does, except for wide characters. Both length and\x0a"
"     *  *numCharsRead represent counts of characters, not bytes.\x0a"
"     *\x0a"
"     *  This function is optional; if missing, PDCLib will buffer the character\x0a"
"     *  data as bytes and perform translation directly into the user's buffers.\x0a"
"     *  It is useful if your backend can directly take wide characters (for\x0a"
"     *  example, the Windows console)\x0a"
"     */\x0a"
"    _PDCLIB_bool (*wread)( _PDCLIB_fd_t self, _PDCLIB_wchar_t * buf,\x0a"
"                     _PDCLIB_size_t length, _PDCLIB_size_t * numCharsRead );\x0a"
"\x0a"
"    /* Behaves as write does, except for wide characters. As with wread, both\x0a"
"     * length and *numCharsWritten are character counts.\x0a"
"     *\x0a"
"     * This function is also optional; if missing, PDCLib will buffer the\x0a"
"     * character data as bytes and do translation directly from the user's\x0a"
"     * buffers. You only need to implement this if your backend can directly\x0a"
"     * take wide characters (for example, the Windows console)\x0a"
"     */\x0a"
"    _PDCLIB_bool (*wwrite)( _PDCLIB_fd_t self, const _PDCLIB_wchar_t * buf,\x0a"
"                     _PDCLIB_size_t length, _PDCLIB_size_t * numCharsWritten );\x0a"
"};\x0a"
"\x0a"
"/* struct _PDCLIB_file structure */\x0a"
"struct _PDCLIB_file\x0a"
"{\x0a"
"    const _PDCLIB_fileops_t * ops;\x0a"
"    _PDCLIB_fd_t              handle;   /* OS file handle */\x0a"
"    _PDCLIB_MTX_T             lock;     /* file lock */\x0a"
"    char *                    buffer;   /* Pointer to buffer memory */\x0a"
"    _PDCLIB_size_t            bufsize;  /* Size of buffer */\x0a"
"    _PDCLIB_size_t            bufidx;   /* Index of current position in buffer */\x0a"
"    _PDCLIB_size_t            bufend;   /* Index of last pre-read character in buffer */\x0a"
"#ifdef _PDCLIB_NEED_EOL_TRANSLATION\x0a"
"    _PDCLIB_size_t            bufnlexp; /* Current position of buffer newline expansion */\x0a"
"#endif\x0a"
"    _PDCLIB_size_t            ungetidx; /* Number of ungetc()'ed characters */\x0a"
"    unsigned char *           ungetbuf; /* ungetc() buffer */\x0a"
"    unsigned int              status;   /* Status flags; see above */\x0a"
"    /* multibyte parsing status to be added later */\x0a"
"    _PDCLIB_fpos_t            pos;      /* Offset and multibyte parsing state */\x0a"
"    char *                    filename; /* Name the current stream has been opened with */\x0a"
"    _PDCLIB_file_t *          next;     /* Pointer to next struct (internal) */\x0a"
"};\x0a"
"\x0a"
"static inline _PDCLIB_size_t _PDCLIB_getchars( char * out, _PDCLIB_size_t n,\x0a"
"                                               int stopchar,\x0a"
"                                               _PDCLIB_file_t * stream )\x0a"
"{\x0a"
"    _PDCLIB_size_t i = 0;\x0a"
"    int c;\x0a"
"    while ( stream->ungetidx > 0 \x26\x26 i \x21= n )\x0a"
"    {\x0a"
"        c = (unsigned char)\x0a"
"                ( out\x5b i++ \x5d = stream->ungetbuf\x5b --(stream->ungetidx) \x5d );\x0a"
"        if( c == stopchar \x7c\x7c i == n )\x0a"
"            return i;\x0a"
"    }\x0a"
"\x0a"
"    if ( stream->status \x26 _IONBF )\x0a"
"    {\x0a"
"        size_t bytesRead;\x0a"
"        do\x0a"
"        {\x0a"
"            int ok = stream->ops->read( stream->handle, out+i, stopchar == EOF \x3f n-i \x3a 1, \x26""bytesRead );\x0a"
"            i += bytesRead;\x0a"
"\x0a"
"            if( ok ) {\x0a"
"                if( bytesRead == 0 ) {\x0a"
"                    stream->status \x7c= _PDCLIB_EOFFLAG;\x0a"
"                    return i;\x0a"
"                }\x0a"
"                stream->pos.offset += bytesRead;\x0a"
"                if ( stopchar == EOF )\x0a"
"                    return i;\x0a"
"            } else {\x0a"
"                stream->status \x7c= _PDCLIB_ERRORFLAG;\x0a"
"                return i;\x0a"
"            }\x0a"
"        } while( out\x5bi-1\x5d \x21= stopchar \x26\x26 --n > 0 );\x0a"
"        return i;\x0a"
"    }\x0a"
"\x0a"
"    while ( i \x21= n )\x0a"
"    {\x0a"
"        while ( stream->bufidx \x21= stream->bufend \x26\x26 i \x21= n )\x0a"
"        {\x0a"
"            c = (unsigned char) stream->buffer\x5b stream->bufidx++ \x5d;\x0a"
"            out\x5b i++ \x5d = c;\x0a"
"\x0a"
"            if( c == stopchar )\x0a"
"                return i;\x0a"
"        }\x0a"
"\x0a"
"        if ( i \x21= n )\x0a"
"        {\x0a"
"            if( _PDCLIB_fillbuffer( stream ) == -1 )\x0a"
"            {\x0a"
"                break;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    return i;\x0a"
"}\x0a"
"\x0a"
"/* Unlocked functions - internal names\x0a"
" *\x0a"
" * We can't use the functions using their \x22normal\x22 names internally because that\x0a"
" * would cause namespace leakage. Therefore, we use them by prefixed internal\x0a"
" * names\x0a"
" */\x0a"
"void _PDCLIB_flockfile(struct _PDCLIB_file *file) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_ftrylockfile(struct _PDCLIB_file *file) _PDCLIB_nothrow;\x0a"
"void _PDCLIB_funlockfile(struct _PDCLIB_file *file) _PDCLIB_nothrow;\x0a"
"\x0a"
"int _PDCLIB_getchar_unlocked(void) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_fgetpos_unlocked( struct _PDCLIB_file * _PDCLIB_restrict stream, _PDCLIB_fpos_t * _PDCLIB_restrict pos ) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_fsetpos_unlocked( struct _PDCLIB_file * stream, const _PDCLIB_fpos_t * pos ) _PDCLIB_nothrow;\x0a"
"long int _PDCLIB_ftell_unlocked( struct _PDCLIB_file * stream ) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_fseek_unlocked( struct _PDCLIB_file * stream, long int offset, int whence ) _PDCLIB_nothrow;\x0a"
"void _PDCLIB_rewind_unlocked( struct _PDCLIB_file * stream ) _PDCLIB_nothrow;\x0a"
"\x0a"
"int _PDCLIB_puts_unlocked( const char * s ) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_ungetc_unlocked( int c, struct _PDCLIB_file * stream ) _PDCLIB_nothrow;\x0a"
"\x0a"
"\x0a"
"int _PDCLIB_printf_unlocked( const char * _PDCLIB_restrict format, ... ) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_vprintf_unlocked( const char * _PDCLIB_restrict format, _PDCLIB_va_list arg ) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_fprintf_unlocked( struct _PDCLIB_file * _PDCLIB_restrict stream, const char * _PDCLIB_restrict format, ... ) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_vfprintf_unlocked( struct _PDCLIB_file * _PDCLIB_restrict stream, const char * _PDCLIB_restrict format, _PDCLIB_va_list arg ) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_scanf_unlocked( const char * _PDCLIB_restrict format, ... ) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_vscanf_unlocked( const char * _PDCLIB_restrict format, _PDCLIB_va_list arg ) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_fscanf_unlocked( struct _PDCLIB_file * _PDCLIB_restrict stream, const char * _PDCLIB_restrict format, ... ) _PDCLIB_nothrow;\x0a"
"int _PDCLIB_vfscanf_unlocked( struct _PDCLIB_file * _PDCLIB_restrict stream, const char * _PDCLIB_restrict format, _PDCLIB_va_list arg ) _PDCLIB_nothrow;\x0a"
"\x0a"
"__END_DECLS\x0a"
"\x0a"
"#endif\x0a"
"", 12227 ); }