#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_machine_fenv_h( 
"/*\x09\x24OpenBSD\x3a fenv.h,v 1.4 2011/05/25 21\x3a""46\x3a""49 martynas Exp \x24\x09*/\x0a"
"/*\x09\x24NetBSD\x3a fenv.h,v 1.1 2010/07/31 21\x3a""47\x3a""54 joerg Exp \x24\x09*/\x0a"
"\x0a"
"/*-\x0a"
" * Copyright (c) 2004-2005 David Schultz <das (at) FreeBSD.ORG>\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#ifndef\x09_AMD64_FENV_H_\x0a"
"#define\x09_AMD64_FENV_H_\x0a"
"\x0a"
"/*\x0a"
" * Each symbol representing a floating point exception expands to an integer\x0a"
" * constant expression with values, such that bitwise-inclusive ORs of _all\x0a"
" * combinations_ of the constants result in distinct values.\x0a"
" *\x0a"
" * We use such values that allow direct bitwise operations on FPU/SSE registers.\x0a"
" */\x0a"
"#define\x09""FE_INVALID\x09\x09""0x01\x0a"
"#define\x09""FE_DENORMAL\x09\x09""0x02\x0a"
"#define\x09""FE_DIVBYZERO\x09\x09""0x04\x0a"
"#define\x09""FE_OVERFLOW\x09\x09""0x08\x0a"
"#define\x09""FE_UNDERFLOW\x09\x09""0x10\x0a"
"#define\x09""FE_INEXACT\x09\x09""0x20\x0a"
"\x0a"
"/*\x0a"
" * The following symbol is simply the bitwise-inclusive OR of all floating-point\x0a"
" * exception constants defined above.\x0a"
" */\x0a"
"#define\x09""FE_ALL_EXCEPT\x09\x09(FE_INVALID \x7c FE_DENORMAL \x7c FE_DIVBYZERO \x7c \x5c\x0a"
"\x09\x09\x09\x09 FE_OVERFLOW \x7c FE_UNDERFLOW \x7c FE_INEXACT)\x0a"
"#define\x09_SSE_MASK_SHIFT\x09\x09""7\x0a"
"\x0a"
"/*\x0a"
" * Each symbol representing the rounding direction, expands to an integer\x0a"
" * constant expression whose value is distinct non-negative value.\x0a"
" *\x0a"
" * We use such values that allow direct bitwise operations on FPU/SSE registers.\x0a"
" */\x0a"
"#define\x09""FE_TONEAREST\x09\x09""0x000\x0a"
"#define\x09""FE_DOWNWARD\x09\x09""0x400\x0a"
"#define\x09""FE_UPWARD\x09\x09""0x800\x0a"
"#define\x09""FE_TOWARDZERO\x09\x09""0xc00\x0a"
"\x0a"
"/*\x0a"
" * The following symbol is simply the bitwise-inclusive OR of all floating-point\x0a"
" * rounding direction constants defined above.\x0a"
" */\x0a"
"#define\x09_X87_ROUND_MASK\x09\x09(FE_TONEAREST \x7c FE_DOWNWARD \x7c FE_UPWARD \x7c \x5c\x0a"
"\x09\x09\x09\x09 FE_TOWARDZERO)\x0a"
"#define\x09_SSE_ROUND_SHIFT\x09""3\x0a"
"\x0a"
"/*\x0a"
" * fenv_t represents the entire floating-point environment.\x0a"
" */\x0a"
"typedef\x09struct {\x0a"
"\x09struct {\x0a"
"\x09\x09unsigned int __control;\x09\x09/* Control word register */\x0a"
"\x09\x09unsigned int __status;\x09\x09/* Status word register */\x0a"
"\x09\x09unsigned int __tag;\x09\x09/* Tag word register */\x0a"
"\x09\x09unsigned int __others\x5b""4\x5d;\x09/* EIP, Pointer Selector, etc */\x0a"
"\x09} __x87;\x0a"
"\x09unsigned int __mxcsr;\x09\x09\x09/* Control, status register */\x0a"
"} fenv_t;\x0a"
"\x0a"
"/*\x0a"
" * The following constant represents the default floating-point environment\x0a"
" * (that is, the one installed at program startup) and has type pointer to\x0a"
" * const-qualified fenv_t.\x0a"
" *\x0a"
" * It can be used as an argument to the functions within the <fenv.h> header\x0a"
" * that manage the floating-point environment, namely fesetenv() and\x0a"
" * feupdateenv().\x0a"
" */\x0a"
"__BEGIN_DECLS\x0a"
"extern\x09""fenv_t\x09\x09\x09__fe_dfl_env;\x0a"
"__END_DECLS\x0a"
"#define\x09""FE_DFL_ENV\x09\x09((const fenv_t *)\x26__fe_dfl_env)\x0a"
"\x0a"
"/*\x0a"
" * fexcept_t represents the floating-point status flags collectively, including\x0a"
" * any status the implementation associates with the flags.\x0a"
" *\x0a"
" * A floating-point status flag is a system variable whose value is set (but\x0a"
" * never cleared) when a floating-point exception is raised, which occurs as a\x0a"
" * side effect of exceptional floating-point arithmetic to provide auxiliary\x0a"
" * information.\x0a"
" *\x0a"
" * A floating-point control mode is a system variable whose value may be set by\x0a"
" * the user to affect the subsequent behavior of floating-point arithmetic.\x0a"
" */\x0a"
"typedef\x09unsigned int\x09\x09""fexcept_t;\x0a"
"\x0a"
"#endif\x09/* \x21_AMD64_FENV_H_ */\x0a"
"", 4349 ); }