#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_pthread_h( 
"#ifndef USR_PTHREAD_H\x0a"
"#define USR_PTHREAD_H\x0a"
"\x0a"
"/* Includes */\x0a"
"\x0a"
"#include <sys/task.h>\x0a"
"#include <sys/hostabi.h>\x0a"
"\x0a"
"/* Macros */\x0a"
"\x0a"
"// internal macros\x0a"
"#define _INITIALIZED_RWLOCK ( 1 << 17 )\x0a"
"\x0a"
"// pthread-specified macros\x0a"
"#define PTHREAD_CREATE_JOINABLE        0\x0a"
"#define PTHREAD_CREATE_DETACHED        1\x0a"
"\x0a"
"#define PTHREAD_PRIO_INHERIT           0 /* TODO */\x0a"
"#define PTHREAD_PRIO_NONE              0 /* TODO */\x0a"
"#define PTHREAD_PRIO_PROTECT           0 /* TODO */\x0a"
"\x0a"
"enum {\x0a"
"    PTHREAD_SCOPE_SYSTEM,\x0a"
"#define PTHREAD_SCOPE_SYSTEM           PTHREAD_SCOPE_SYSTEM\x0a"
"    PTHREAD_SCOPE_PROCESS\x0a"
"#define PTHREAD_SCOPE_PROCESS          PTHREAD_SCOPE_PROCESS\x0a"
"};\x0a"
"\x0a"
"enum {\x0a"
"    PTHREAD_INHERIT_SCHED,\x0a"
"#define PTHREAD_INHERIT_SCHED          PTHREAD_INHERIT_SCHED\x0a"
"    PTHREAD_EXPLICIT_SCHED\x0a"
"#define PTHREAD_EXPLICIT_SCHED         PTHREAD_EXPLICIT_SCHED\x0a"
"};\x0a"
"  /* Single UNIX Specification v. 2  and later */\x0a"
"#define PTHREAD_MUTEX_NORMAL           0\x0a"
"#define PTHREAD_MUTEX_RECURSIVE        1\x0a"
"#define PTHREAD_MUTEX_ERRORCHECK       2\x0a"
"#define PTHREAD_MUTEX_DEFAULT          PTHREAD_MUTEX_NORMAL\x0a"
"\x0a"
"  /* for compatibility (prior to SUS v.2) */\x0a"
"#define PTHREAD_MUTEX_TIMED_NP         PTHREAD_MUTEX_NORMAL\x0a"
"#define PTHREAD_MUTEX_RECURSIVE_NP     PTHREAD_MUTEX_RECURSIVE\x0a"
"#define PTHREAD_MUTEX_ERRORCHECK_NP    PTHREAD_MUTEX_ERRORCHECK\x0a"
"#define PTHREAD_MUTEX_FAST_NP          PTHREAD_MUTEX_NORMAL\x0a"
"#define PTHREAD_MUTEX_ADAPTIVE_NP      PTHREAD_MUTEX_FAST_NP\x0a"
"\x0a"
"#define PTHREAD_MUTEX_INITIALIZER      { .__owner = NULL, .__bitflags = 0x1 }\x0a"
"\x0a"
"#define PTHREAD_COND_INITIALIZER       { .__mutex = NULL, .__counter = 0 }\x0a"
"\x0a"
"#define PTHREAD_ONCE_INIT              { .__mtx = { .__bitflags = 0x3 } }\x0a"
"\x0a"
"#define PTHREAD_DESTRUCTOR_ITERATIONS  8\x0a"
"\x0a"
"#define PTHREAD_CANCELED               ( (void *) -1 )\x0a"
"#define PTHREAD_CANCEL_ENABLE          0\x0a"
"#define PTHREAD_CANCEL_DISABLE         1\x0a"
"#define PTHREAD_CANCEL_DEFERRED        0\x0a"
"#define PTHREAD_CANCEL_ASYNCHRONOUS    1\x0a"
"\x0a"
"#define PTHREAD_PROCESS_PRIVATE        0\x0a"
"#define PTHREAD_PROCESS_SHARED         1\x0a"
"\x0a"
"#define PTHREAD_RWLOCK_INITIALIZER     { .__wrowner = 0, .__processShared = 0, .__rlocks = NULL }\x0a"
"#define PTHREAD_RWLOCK_WRITER_NONRECURSIVE_INITIALIZER_NP   PTHREAD_RWLOCK_INITIALIZER\x0a"
"\x0a"
"#define PTHREAD_BARRIER_SERIAL_THREAD  1\x0a"
"\x0a"
"#if __has_attribute( error ) \x26\x26 __has_attribute( warning )\x0a"
"#define _PTHREAD_UNSUPPORTED  __attribute__(( error(\x22this function is not yet implemented\x22) ))\x0a"
"#define _PTHREAD_NO_EFFECT    __attribute__(( warning(\x22this function currently has no effect\x22) ))\x0a"
"#else\x0a"
"#define _PTHREAD_UNSUPPORTED\x0a"
"#define _PTHREAD_NO_EFFECT\x0a"
"#endif\x0a"
"\x0a"
"#define _PTHREAD_NOINLINE     __attribute__(( noinline ))\x0a"
"#if defined( __cplusplus ) \x26\x26 __cplusplus >= 201103L\x0a"
"#define _PTHREAD_NOEXCEPT noexcept\x0a"
"#else\x0a"
"#define _PTHREAD_NOEXCEPT __attribute__((nothrow))\x0a"
"#endif\x0a"
"\x0a"
"/* Data types */\x0a"
"\x0a"
"typedef int pthread_attr_t;\x0a"
"\x0a"
"/* Thread in DiOS is defined as a task.\x0a"
" * All its data and metadata are stored in task local storage.\x0a"
" *\x0a"
" * For \x60pthread_t\x60 the \x60__dios_tls\x60 holds in \x60__data\x60 attribute\x0a"
" * the _PthreadTLS data.\x0a"
" *\x0a"
" * Thread metadata are stored in form of _PThread in the _PthreadTLS.\x0a"
" * */\x0a"
"typedef struct __dios_tls *pthread_t;\x0a"
"//typedef uint32_t pthread_t; TODO\x0a"
"\x0a"
"struct _PThread;\x0a"
"\x0a"
"/* Each mutex tracks its owner to detect if another thread wants to unlock it.\x0a"
" *\x0a"
" * Attribute __once is used to detect a single execution of a thread\x0a"
" * subroutine (see pthread_once implementation).\x0a"
" *\x0a"
" * Attribute __type stores type of mutex{PTHREAD_MUTEX_INITIALIZER,\x0a"
" * PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP, PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP}\x0a"
" *\x0a"
" * Attribute __lockCounter maintains number of thread owners of this mutex {0,1}.\x0a"
" * */\x0a"
"typedef struct\x0a"
"{\x0a"
"    union\x0a"
"    {\x0a"
"        struct\x0a"
"        {\x0a"
"            pthread_t __owner;\x0a"
"            union\x0a"
"            {\x0a"
"                struct\x0a"
"                {\x0a"
"                    unsigned short __once\x3a""1;\x0a"
"                    unsigned short __type\x3a""2;\x0a"
"                    unsigned int __lockCounter\x3a""28; // change _mutex_adjust_count if bitfield size changes\x0a"
"                };\x0a"
"                int32_t __bitflags;\x0a"
"            };\x0a"
"        };\x0a"
"        uint8_t __padding\x5b _HOST_pthr_mutex_t_size \x5d;\x0a"
"    };\x0a"
"} pthread_mutex_t;\x0a"
"\x0a"
"typedef struct {\x0a"
"    unsigned __type; // just 2 bits needed\x0a"
"} pthread_mutexattr_t;\x0a"
"\x0a"
"typedef pthread_mutex_t pthread_spinlock_t;\x0a"
"\x0a"
"typedef struct {\x0a"
"    pthread_mutex_t *__mutex; // waits on mutex\x0a"
"    unsigned short __counter;\x0a"
"} pthread_cond_t;\x0a"
"\x0a"
"typedef int pthread_condattr_t;\x0a"
"typedef struct { pthread_mutex_t __mtx; } pthread_once_t;\x0a"
"\x0a"
"typedef int pthread_key_t;\x0a"
"\x0a"
"typedef struct _ReadLock {\x0a"
"    struct _PThread *__owner;\x0a"
"    int __count;\x0a"
"    struct _ReadLock *__next;\x0a"
"} _ReadLock;\x0a"
"\x0a"
"typedef struct {\x0a"
"    struct _PThread *__wrowner;\x0a"
"    _ReadLock* __rlocks;\x0a"
"    // not bitfield, struct is padded anyway\x0a"
"    char __processShared;\x0a"
"} pthread_rwlock_t;\x0a"
"typedef int pthread_rwlockattr_t;\x0a"
"\x0a"
"typedef struct {\x0a"
"    unsigned short __counter;\x0a"
"    unsigned short __nthreads;\x0a"
"} pthread_barrier_t;\x0a"
"\x0a"
"typedef int pthread_barrierattr_t;\x0a"
"\x0a"
"#include <sched.h> /* sched_param */\x0a"
"#include <sys/types.h> /* pid_t */\x0a"
"\x0a"
"/* Function prototypes */\x0a"
"\x0a"
"__BEGIN_DECLS\x0a"
"\x0a"
"/* Implementation prototypes */\x0a"
"void __pthread_initialize() _PTHREAD_NOEXCEPT;\x0a"
"void __pthread_finalize() _PTHREAD_NOEXCEPT;\x0a"
"\x0a"
"int pthread_atfork( void (*)(void), void (*)(void), void(*)(void) ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"\x0a"
"int pthread_create( pthread_t *, const pthread_attr_t *, void *(*)(void *), void * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"_PDCLIB_noreturn void pthread_exit( void * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_join( pthread_t, void ** ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_detach( pthread_t thread ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_yield(void) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"\x0a"
"int pthread_attr_destroy( pthread_attr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_attr_init( pthread_attr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_attr_getdetachstate( const pthread_attr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_attr_getguardsize( const pthread_attr_t *, size_t *) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_getinheritsched( const pthread_attr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_getschedparam( const pthread_attr_t *, struct sched_param * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_getschedpolicy( const pthread_attr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_getscope( const pthread_attr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_getstack( const pthread_attr_t *, void **, size_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_getstackaddr( const pthread_attr_t *, void ** ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_getstacksize( const pthread_attr_t *, size_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_setdetachstate( pthread_attr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_attr_setguardsize( pthread_attr_t *, size_t ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_setinheritsched( pthread_attr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_setschedparam( pthread_attr_t *, const struct sched_param * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_setschedpolicy( pthread_attr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_setscope( pthread_attr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_setstack( pthread_attr_t *, void *, size_t ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_setstackaddr( pthread_attr_t *, void * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_attr_setstacksize( pthread_attr_t *, size_t ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"\x0a"
"int pthread_getconcurrency( void ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_getcpuclockid( pthread_t, clockid_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_getschedparam( pthread_t, int *, struct sched_param * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_setconcurrency( int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_setschedparam( pthread_t, int, const struct sched_param * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_setschedprio( pthread_t, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"\x0a"
"pthread_t pthread_self( void ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_equal( pthread_t, pthread_t ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"\x0a"
"int pthread_mutex_destroy( pthread_mutex_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_mutex_init( pthread_mutex_t *, const pthread_mutexattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_mutex_lock( pthread_mutex_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_mutex_trylock( pthread_mutex_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_mutex_unlock( pthread_mutex_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_mutex_getprioceiling( const pthread_mutex_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_mutex_setprioceiling( pthread_mutex_t *, int, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_mutex_timedlock( pthread_mutex_t *, const struct timespec * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"\x0a"
"int pthread_mutexattr_destroy( pthread_mutexattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_mutexattr_init( pthread_mutexattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_mutexattr_gettype( const pthread_mutexattr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_mutexattr_getprioceiling( const pthread_mutexattr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_mutexattr_getprotocol( const pthread_mutexattr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_mutexattr_getpshared( const pthread_mutexattr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_mutexattr_settype( pthread_mutexattr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_mutexattr_setprioceiling( pthread_mutexattr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_mutexattr_setprotocol( pthread_mutexattr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_mutexattr_setpshared( pthread_mutexattr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"\x0a"
"int pthread_spin_destroy( pthread_spinlock_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_spin_init( pthread_spinlock_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_spin_lock( pthread_spinlock_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_spin_trylock( pthread_spinlock_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_spin_unlock( pthread_spinlock_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"\x0a"
"int pthread_key_create( pthread_key_t *, void (*)(void *) ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_key_delete( pthread_key_t ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_setspecific( pthread_key_t, const void * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"void *pthread_getspecific( pthread_key_t ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"\x0a"
"int pthread_cond_destroy( pthread_cond_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_cond_init( pthread_cond_t *, const pthread_condattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_cond_signal( pthread_cond_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_cond_broadcast( pthread_cond_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_cond_wait( pthread_cond_t *, pthread_mutex_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_cond_timedwait( pthread_cond_t *, pthread_mutex_t *, const struct timespec * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"\x0a"
"int pthread_condattr_destroy( pthread_condattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"int pthread_condattr_getclock( const pthread_condattr_t *, clockid_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_condattr_getpshared( const pthread_condattr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_condattr_init( pthread_condattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"int pthread_condattr_setclock( pthread_condattr_t *, clockid_t ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_condattr_setpshared( pthread_condattr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"\x0a"
"int pthread_once( pthread_once_t *, void (*)(void) ) _PTHREAD_NOINLINE;\x0a"
"\x0a"
"int pthread_setcancelstate( int, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_setcanceltype( int, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"int pthread_cancel( pthread_t ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"void pthread_testcancel( void ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"void pthread_cleanup_push( void (*)(void *), void * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"void pthread_cleanup_pop( int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"\x0a"
"int pthread_rwlock_destroy( pthread_rwlock_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_rwlock_init( pthread_rwlock_t *, const pthread_rwlockattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_rwlock_rdlock( pthread_rwlock_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_rwlock_wrlock( pthread_rwlock_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_rwlock_tryrdlock( pthread_rwlock_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_rwlock_trywrlock( pthread_rwlock_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_rwlock_unlock( pthread_rwlock_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"\x0a"
"int pthread_rwlockattr_destroy( pthread_rwlockattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_rwlockattr_getpshared( const pthread_rwlockattr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"int pthread_rwlockattr_init( pthread_rwlockattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_rwlockattr_setpshared( pthread_rwlockattr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"\x0a"
"int pthread_barrier_destroy( pthread_barrier_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_barrier_init( pthread_barrier_t *, const pthread_barrierattr_t *, unsigned ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"int pthread_barrier_wait( pthread_barrier_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE;\x0a"
"\x0a"
"int pthread_barrierattr_destroy( pthread_barrierattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_barrierattr_getpshared( const pthread_barrierattr_t *, int * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_barrierattr_init( pthread_barrierattr_t * ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"int pthread_barrierattr_setpshared( pthread_barrierattr_t *, int ) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_UNSUPPORTED;\x0a"
"\x0a"
"int sched_get_priority_max(int) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"int sched_get_priority_min(int) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"int sched_getparam(pid_t, struct sched_param *) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"int sched_getscheduler(pid_t) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"int sched_rr_get_interval(pid_t, struct timespec *) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"int sched_setparam(pid_t, const struct sched_param *) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"int sched_setscheduler(pid_t, int, const struct sched_param *) _PTHREAD_NOEXCEPT _PTHREAD_NOINLINE _PTHREAD_NO_EFFECT;\x0a"
"\x0a"
"__END_DECLS\x0a"
"\x0a"
"#endif\x0a"
"", 16078 ); }