#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_signal_h( 
"/* \x24Id\x24 */\x0a"
"\x0a"
"/* 7.14 Signal handling <string.h>\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#ifndef _PDCLIB_SIGNAL_H\x0a"
"#define _PDCLIB_SIGNAL_H _PDCLIB_SIGNAL_H\x0a"
"#include <_PDCLIB/config.h>\x0a"
"#include <_PDCLIB/glue.h>\x0a"
"#include <sys/cdefs.h>\x0a"
"\x0a"
"__BEGIN_DECLS\x0a"
"\x0a"
"/* Signals ------------------------------------------------------------------ */\x0a"
"\x0a"
"/* A word on signals, to the people using PDCLib in their OS projects.\x0a"
"\x0a"
"   The definitions of the C standard leave about everything that *could* be\x0a"
"   useful to be \x22implementation defined\x22. Without additional, non-standard\x0a"
"   arrangements, it is not possible to turn them into a useful tool.\x0a"
"\x0a"
"   This example implementation chose to \x22not generate any of these signals,\x0a"
"   except as a result of explicit calls to the raise function\x22, which is\x0a"
"   allowed by the standard but of course does nothing for the usefulness of\x0a"
"   <signal.h>.\x0a"
"\x0a"
"   A useful signal handling would\x3a\x0a"
"   1) make signal() a system call that registers the signal handler with the OS\x0a"
"   2) make raise() a system call triggering an OS signal to the running process\x0a"
"   3) make provisions that further signals of the same type are blocked until\x0a"
"      the signal handler returns (optional for SIGILL)\x0a"
"*/\x0a"
"\x0a"
"#define _NSIG _HOST__NSIG\x0a"
"\x0a"
"#if __BSD_VISIBLE\x0a"
"#define NSIG _NSIG\x0a"
"#endif\x0a"
"\x0a"
"/* These are the values used by Linux. */\x0a"
"\x0a"
"/* Abnormal termination / abort() */\x0a"
"#define SIGABRT _HOST_SIGABRT\x0a"
"/* Arithmetic exception / division by zero / overflow */\x0a"
"#define SIGFPE  _HOST_SIGFPE\x0a"
"/* Illegal instruction */\x0a"
"#define SIGILL  _HOST_SIGILL\x0a"
"/* Interactive attention signal */\x0a"
"#define SIGINT  _HOST_SIGINT\x0a"
"/* Invalid memory access */\x0a"
"#define SIGSEGV _HOST_SIGSEGV\x0a"
"/* Invalid pipe usage */\x0a"
"#define SIGPIPE _HOST_SIGPIPE\x0a"
"/* Termination request */\x0a"
"#define SIGTERM _HOST_SIGTERM\x0a"
"\x0a"
"/* Quit from keyboard */\x0a"
"#define SIGQUIT _HOST_SIGQUIT\x0a"
"/* Bus error (bad memory access) */\x0a"
"#define SIGBUS _HOST_SIGBUS\x0a"
"/* Bad argument to routine */\x0a"
"#define SIGSYS _HOST_SIGSYS\x0a"
"/* Trace/breakpoint trap */\x0a"
"#define SIGTRAP _HOST_SIGTRAP\x0a"
"/* CPU time limit exceeded */\x0a"
"#define SIGXCPU _HOST_SIGXCPU\x0a"
"/* File size limit exceeded */\x0a"
"#define SIGXFSZ _HOST_SIGXFSZ\x0a"
"/* IOT trap. A synonym for SIGABRT */\x0a"
"#define SIGIOT SIGABRT\x0a"
"/* Synonymous with SIGSYS */\x0a"
"#define SIGUNUSED SIGSYS\x0a"
"/* Kill signal */\x0a"
"#define SIGKILL _HOST_SIGKILL\x0a"
"/* Stop process */\x0a"
"#define SIGSTOP _HOST_SIGSTOP\x0a"
"/* Timer expired */\x0a"
"#define SIGALRM _HOST_SIGALRM\x0a"
"/* Signal hang up */\x0a"
"#define SIGHUP _HOST_SIGHUP\x0a"
"#define SIGTSTP _HOST_SIGTSTP\x0a"
"\x0a"
"#define SIGUSR1 _HOST_SIGUSR1\x0a"
"#define SIGUSR2 _HOST_SIGUSR2\x0a"
"\x0a"
"#define SIGCHLD _HOST_SIGCHLD\x0a"
"\x0a"
"#if __POSIX_VISIBLE \x7c\x7c __XPG_VISIBLE\x0a"
"/*\x0a"
" * Flags for sigprocmask\x3a\x0a"
" */\x0a"
"#define SIG_BLOCK   _HOST_SIG_BLOCK /* block specified signal set */\x0a"
"#define SIG_UNBLOCK _HOST_SIG_UNBLOCK /* unblock specified signal set */\x0a"
"#define SIG_SETMASK _HOST_SIG_SETMASK /* set specified signal set */\x0a"
"#endif /* __POSIX_VISIBLE \x7c\x7c __XPG_VISIBLE */\x0a"
"\x0a"
"/* The following should be defined to pointer values that could NEVER point to\x0a"
"   a valid signal handler function. (They are used as special arguments to\x0a"
"   signal().) Again, these are the values used by Linux.\x0a"
"*/\x0a"
"#define SIG_DFL (void (*)( int ))0\x0a"
"#define SIG_ERR (void (*)( int ))-1\x0a"
"#define SIG_IGN (void (*)( int ))1\x0a"
"\x0a"
"#define SA_RESTART 0x10000000  // Linux definition\x0a"
"\x0a"
"typedef _PDCLIB_sig_atomic sig_atomic_t;\x0a"
"\x0a"
"/* Installs a signal handler \x22""func\x22 for the given signal.\x0a"
"   A signal handler is a function that takes an integer as argument (the signal\x0a"
"   number) and returns void.\x0a"
"\x0a"
"   Note that a signal handler can do very little else than\x3a\x0a"
"   1) assign a value to a static object of type \x22volatile sig_atomic_t\x22,\x0a"
"   2) call signal() with the value of sig equal to the signal received,\x0a"
"   3) call _Exit(),\x0a"
"   4) call abort().\x0a"
"   Virtually everything else is undefind.\x0a"
"\x0a"
"   The signal() function returns the previous installed signal handler, which\x0a"
"   at program start may be SIG_DFL or SIG_ILL. (This implementation uses\x0a"
"   SIG_DFL for all handlers.) If the request cannot be honored, SIG_ERR is\x0a"
"   returned and errno is set to an unspecified positive value.\x0a"
"*/\x0a"
"void (*signal( int sig, void (*func)( int ) ) )( int );\x0a"
"\x0a"
"/* Raises the given signal (executing the registered signal handler with the\x0a"
"   given signal number as parameter).\x0a"
"   This implementation does not prevent further signals of the same time from\x0a"
"   occuring, but executes signal( sig, SIG_DFL ) before entering the signal\x0a"
"   handler (i.e., a second signal before the signal handler re-registers itself\x0a"
"   or SIG_IGN will end the program).\x0a"
"   Returns zero if successful, nonzero otherwise. */\x0a"
"int raise( int sig ) __nothrow;\x0a"
"\x0a"
"int kill(pid_t pid, int sig) __nothrow;\x0a"
"\x0a"
"#ifndef _SIGSET_T_DEFINED_\x0a"
"#define _SIGSET_T_DEFINED_\x0a"
"typedef __uint64_t sigset_t;\x0a"
"#endif\x0a"
"\x0a"
"typedef union sigval\x0a"
"{\x0a"
"    int sigval_int;\x0a"
"    void *sigval_ptr;\x0a"
"} sigval_t;\x0a"
"\x0a"
"typedef struct siginfo\x0a"
"{\x0a"
"    sigval_t si_action;\x0a"
"} siginfo_t;\x0a"
"\x0a"
"typedef void ( *__sa_handler_t )( int );\x0a"
"typedef void ( *__sa_sigaction_t )( int, siginfo_t *, void * );\x0a"
"typedef void ( *__sa_restorer_t )( void );\x0a"
"\x0a"
"#define _HOST_sigaction sigaction\x0a"
"#include <sys/hostabi.h>\x0a"
"#undef _HOST_sigaction\x0a"
"\x0a"
"int sigaction( int signum, const struct sigaction *act, struct sigaction *oldact ) __nothrow;\x0a"
"int rt_sigaction( int signum, const struct sigaction *act, struct sigaction *oldact,\x0a"
"                  size_t sigsetsize ) __nothrow;\x0a"
"\x0a"
"int sigprocmask( int how, const sigset_t *set, sigset_t *oldset );\x0a"
"int sigemptyset( sigset_t * );\x0a"
"int sigfillset( sigset_t * );\x0a"
"int sigaddset( sigset_t *, int );\x0a"
"int sigdelset( sigset_t *, int );\x0a"
"int sigismember( const sigset_t *, int );\x0a"
"\x0a"
"__END_DECLS\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"", 5655 ); }