#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_stdatomic_h( 
"/*===---- stdatomic.h - Standard header for atomic types and operations -----===\x0a"
" *\x0a"
" * Permission is hereby granted, free of charge, to any person obtaining a copy\x0a"
" * of this software and associated documentation files (the \x22Software\x22), to deal\x0a"
" * in the Software without restriction, including without limitation the rights\x0a"
" * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\x0a"
" * copies of the Software, and to permit persons to whom the Software is\x0a"
" * furnished to do so, subject to the following conditions\x3a\x0a"
" *\x0a"
" * The above copyright notice and this permission notice shall be included in\x0a"
" * all copies or substantial portions of the Software.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\x0a"
" * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\x0a"
" * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\x0a"
" * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\x0a"
" * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\x0a"
" * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\x0a"
" * THE SOFTWARE.\x0a"
" *\x0a"
" *===-----------------------------------------------------------------------===\x0a"
" */\x0a"
"\x0a"
"#ifndef __CLANG_STDATOMIC_H\x0a"
"#define __CLANG_STDATOMIC_H\x0a"
"\x0a"
"/* If we're hosted, fall back to the system's stdatomic.h. FreeBSD, for\x0a"
" * example, already has a Clang-compatible stdatomic.h header.\x0a"
" */\x0a"
"#if __STDC_HOSTED__ \x26\x26 __has_include_next(<stdatomic.h>)\x0a"
"# include_next <stdatomic.h>\x0a"
"#else\x0a"
"\x0a"
"#include <stddef.h>\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"extern \x22""C\x22 {\x0a"
"#endif\x0a"
"\x0a"
"/* 7.17.1 Introduction */\x0a"
"\x0a"
"#define ATOMIC_BOOL_LOCK_FREE       __CLANG_ATOMIC_BOOL_LOCK_FREE\x0a"
"#define ATOMIC_CHAR_LOCK_FREE       __CLANG_ATOMIC_CHAR_LOCK_FREE\x0a"
"#define ATOMIC_CHAR16_T_LOCK_FREE   __CLANG_ATOMIC_CHAR16_T_LOCK_FREE\x0a"
"#define ATOMIC_CHAR32_T_LOCK_FREE   __CLANG_ATOMIC_CHAR32_T_LOCK_FREE\x0a"
"#define ATOMIC_WCHAR_T_LOCK_FREE    __CLANG_ATOMIC_WCHAR_T_LOCK_FREE\x0a"
"#define ATOMIC_SHORT_LOCK_FREE      __CLANG_ATOMIC_SHORT_LOCK_FREE\x0a"
"#define ATOMIC_INT_LOCK_FREE        __CLANG_ATOMIC_INT_LOCK_FREE\x0a"
"#define ATOMIC_LONG_LOCK_FREE       __CLANG_ATOMIC_LONG_LOCK_FREE\x0a"
"#define ATOMIC_LLONG_LOCK_FREE      __CLANG_ATOMIC_LLONG_LOCK_FREE\x0a"
"#define ATOMIC_POINTER_LOCK_FREE    __CLANG_ATOMIC_POINTER_LOCK_FREE\x0a"
"\x0a"
"/* 7.17.2 Initialization */\x0a"
"\x0a"
"#define ATOMIC_VAR_INIT(value) (value)\x0a"
"#define atomic_init __c11_atomic_init\x0a"
"\x0a"
"/* 7.17.3 Order and consistency */\x0a"
"\x0a"
"typedef enum memory_order {\x0a"
"  memory_order_relaxed = __ATOMIC_RELAXED,\x0a"
"  memory_order_consume = __ATOMIC_CONSUME,\x0a"
"  memory_order_acquire = __ATOMIC_ACQUIRE,\x0a"
"  memory_order_release = __ATOMIC_RELEASE,\x0a"
"  memory_order_acq_rel = __ATOMIC_ACQ_REL,\x0a"
"  memory_order_seq_cst = __ATOMIC_SEQ_CST\x0a"
"} memory_order;\x0a"
"\x0a"
"#define kill_dependency(y) (y)\x0a"
"\x0a"
"/* 7.17.4 Fences */\x0a"
"\x0a"
"/* These should be provided by the libc implementation. */\x0a"
"void atomic_thread_fence(memory_order);\x0a"
"void atomic_signal_fence(memory_order);\x0a"
"\x0a"
"#define atomic_thread_fence(order) __c11_atomic_thread_fence(order)\x0a"
"#define atomic_signal_fence(order) __c11_atomic_signal_fence(order)\x0a"
"\x0a"
"/* 7.17.5 Lock-free property */\x0a"
"\x0a"
"#define atomic_is_lock_free(obj) __c11_atomic_is_lock_free(sizeof(*(obj)))\x0a"
"\x0a"
"/* 7.17.6 Atomic integer types */\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"typedef _Atomic(bool)               atomic_bool;\x0a"
"#else\x0a"
"typedef _Atomic(_Bool)              atomic_bool;\x0a"
"#endif\x0a"
"typedef _Atomic(char)               atomic_char;\x0a"
"typedef _Atomic(signed char)        atomic_schar;\x0a"
"typedef _Atomic(unsigned char)      atomic_uchar;\x0a"
"typedef _Atomic(short)              atomic_short;\x0a"
"typedef _Atomic(unsigned short)     atomic_ushort;\x0a"
"typedef _Atomic(int)                atomic_int;\x0a"
"typedef _Atomic(unsigned int)       atomic_uint;\x0a"
"typedef _Atomic(long)               atomic_long;\x0a"
"typedef _Atomic(unsigned long)      atomic_ulong;\x0a"
"typedef _Atomic(long long)          atomic_llong;\x0a"
"typedef _Atomic(unsigned long long) atomic_ullong;\x0a"
"typedef _Atomic(uint_least16_t)     atomic_char16_t;\x0a"
"typedef _Atomic(uint_least32_t)     atomic_char32_t;\x0a"
"typedef _Atomic(wchar_t)            atomic_wchar_t;\x0a"
"typedef _Atomic(int_least8_t)       atomic_int_least8_t;\x0a"
"typedef _Atomic(uint_least8_t)      atomic_uint_least8_t;\x0a"
"typedef _Atomic(int_least16_t)      atomic_int_least16_t;\x0a"
"typedef _Atomic(uint_least16_t)     atomic_uint_least16_t;\x0a"
"typedef _Atomic(int_least32_t)      atomic_int_least32_t;\x0a"
"typedef _Atomic(uint_least32_t)     atomic_uint_least32_t;\x0a"
"typedef _Atomic(int_least64_t)      atomic_int_least64_t;\x0a"
"typedef _Atomic(uint_least64_t)     atomic_uint_least64_t;\x0a"
"typedef _Atomic(int_fast8_t)        atomic_int_fast8_t;\x0a"
"typedef _Atomic(uint_fast8_t)       atomic_uint_fast8_t;\x0a"
"typedef _Atomic(int_fast16_t)       atomic_int_fast16_t;\x0a"
"typedef _Atomic(uint_fast16_t)      atomic_uint_fast16_t;\x0a"
"typedef _Atomic(int_fast32_t)       atomic_int_fast32_t;\x0a"
"typedef _Atomic(uint_fast32_t)      atomic_uint_fast32_t;\x0a"
"typedef _Atomic(int_fast64_t)       atomic_int_fast64_t;\x0a"
"typedef _Atomic(uint_fast64_t)      atomic_uint_fast64_t;\x0a"
"typedef _Atomic(intptr_t)           atomic_intptr_t;\x0a"
"typedef _Atomic(uintptr_t)          atomic_uintptr_t;\x0a"
"typedef _Atomic(size_t)             atomic_size_t;\x0a"
"typedef _Atomic(ptrdiff_t)          atomic_ptrdiff_t;\x0a"
"typedef _Atomic(intmax_t)           atomic_intmax_t;\x0a"
"typedef _Atomic(uintmax_t)          atomic_uintmax_t;\x0a"
"\x0a"
"/* 7.17.7 Operations on atomic types */\x0a"
"\x0a"
"#define atomic_store(object, desired) __c11_atomic_store(object, desired, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_store_explicit __c11_atomic_store\x0a"
"\x0a"
"#define atomic_load(object) __c11_atomic_load(object, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_load_explicit __c11_atomic_load\x0a"
"\x0a"
"#define atomic_exchange(object, desired) __c11_atomic_exchange(object, desired, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_exchange_explicit __c11_atomic_exchange\x0a"
"\x0a"
"#define atomic_compare_exchange_strong(object, expected, desired) __c11_atomic_compare_exchange_strong(object, expected, desired, __ATOMIC_SEQ_CST, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_compare_exchange_strong_explicit __c11_atomic_compare_exchange_strong\x0a"
"\x0a"
"#define atomic_compare_exchange_weak(object, expected, desired) __c11_atomic_compare_exchange_weak(object, expected, desired, __ATOMIC_SEQ_CST, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_compare_exchange_weak_explicit __c11_atomic_compare_exchange_weak\x0a"
"\x0a"
"#define atomic_fetch_add(object, operand) __c11_atomic_fetch_add(object, operand, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_fetch_add_explicit __c11_atomic_fetch_add\x0a"
"\x0a"
"#define atomic_fetch_sub(object, operand) __c11_atomic_fetch_sub(object, operand, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_fetch_sub_explicit __c11_atomic_fetch_sub\x0a"
"\x0a"
"#define atomic_fetch_or(object, operand) __c11_atomic_fetch_or(object, operand, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_fetch_or_explicit __c11_atomic_fetch_or\x0a"
"\x0a"
"#define atomic_fetch_xor(object, operand) __c11_atomic_fetch_xor(object, operand, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_fetch_xor_explicit __c11_atomic_fetch_xor\x0a"
"\x0a"
"#define atomic_fetch_and(object, operand) __c11_atomic_fetch_and(object, operand, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_fetch_and_explicit __c11_atomic_fetch_and\x0a"
"\x0a"
"/* 7.17.8 Atomic flag type and operations */\x0a"
"\x0a"
"typedef struct atomic_flag { atomic_bool _Value; } atomic_flag;\x0a"
"\x0a"
"#define ATOMIC_FLAG_INIT { 0 }\x0a"
"\x0a"
"/* These should be provided by the libc implementation. */\x0a"
"#ifdef __cplusplus\x0a"
"bool atomic_flag_test_and_set(volatile atomic_flag *);\x0a"
"bool atomic_flag_test_and_set_explicit(volatile atomic_flag *, memory_order);\x0a"
"#else\x0a"
"_Bool atomic_flag_test_and_set(volatile atomic_flag *);\x0a"
"_Bool atomic_flag_test_and_set_explicit(volatile atomic_flag *, memory_order);\x0a"
"#endif\x0a"
"void atomic_flag_clear(volatile atomic_flag *);\x0a"
"void atomic_flag_clear_explicit(volatile atomic_flag *, memory_order);\x0a"
"\x0a"
"#define atomic_flag_test_and_set(object) __c11_atomic_exchange(\x26(object)->_Value, 1, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_flag_test_and_set_explicit(object, order) __c11_atomic_exchange(\x26(object)->_Value, 1, order)\x0a"
"\x0a"
"#define atomic_flag_clear(object) __c11_atomic_store(\x26(object)->_Value, 0, __ATOMIC_SEQ_CST)\x0a"
"#define atomic_flag_clear_explicit(object, order) __c11_atomic_store(\x26(object)->_Value, 0, order)\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#endif /* __STDC_HOSTED__ */\x0a"
"#endif /* __CLANG_STDATOMIC_H */\x0a"
"\x0a"
"", 8172 ); }