#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_stdint_h( 
"/* Integer types <stdint.h>\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#ifndef _PDCLIB_STDINT_H\x0a"
"#define _PDCLIB_STDINT_H _PDCLIB_STDINT_H\x0a"
"#include \x22_PDCLIB/int.h\x22\x0a"
"\x0a"
"/* Exact-width integer types. */\x0a"
"\x0a"
"typedef _PDCLIB_int8_t  int8_t;\x0a"
"typedef _PDCLIB_int16_t int16_t;\x0a"
"typedef _PDCLIB_int32_t int32_t;\x0a"
"typedef _PDCLIB_int64_t int64_t;\x0a"
"\x0a"
"typedef _PDCLIB_uint8_t  uint8_t;\x0a"
"typedef _PDCLIB_uint16_t uint16_t;\x0a"
"typedef _PDCLIB_uint32_t uint32_t;\x0a"
"typedef _PDCLIB_uint64_t uint64_t;\x0a"
"\x0a"
"/* Minimum-width integer types */\x0a"
"\x0a"
"/* You are allowed to add more types here, e.g. int_least24_t. For the standard\x0a"
"   types, int_leastN_t is equivalent to the corresponding exact type intN_t by\x0a"
"   definition.\x0a"
"*/\x0a"
"\x0a"
"typedef _PDCLIB_int8_t  int_least8_t;\x0a"
"typedef _PDCLIB_int16_t int_least16_t;\x0a"
"typedef _PDCLIB_int32_t int_least32_t;\x0a"
"typedef _PDCLIB_int64_t int_least64_t;\x0a"
"\x0a"
"typedef _PDCLIB_uint8_t  uint_least8_t;\x0a"
"typedef _PDCLIB_uint16_t uint_least16_t;\x0a"
"typedef _PDCLIB_uint32_t uint_least32_t;\x0a"
"typedef _PDCLIB_uint64_t uint_least64_t;\x0a"
"\x0a"
"/* Fastest minimum-width integer types */\x0a"
"\x0a"
"/* You are allowed to add more types here, e.g. int_fast24_t. */\x0a"
"\x0a"
"typedef _PDCLIB_int_fast8_t  int_fast8_t;\x0a"
"typedef _PDCLIB_int_fast16_t int_fast16_t;\x0a"
"typedef _PDCLIB_int_fast32_t int_fast32_t;\x0a"
"typedef _PDCLIB_int_fast64_t int_fast64_t;\x0a"
"\x0a"
"typedef _PDCLIB_uint_fast8_t  uint_fast8_t;\x0a"
"typedef _PDCLIB_uint_fast16_t uint_fast16_t;\x0a"
"typedef _PDCLIB_uint_fast32_t uint_fast32_t;\x0a"
"typedef _PDCLIB_uint_fast64_t uint_fast64_t;\x0a"
"\x0a"
"/* Integer types capable of holding object pointers */\x0a"
"\x0a"
"typedef _PDCLIB_intptr_t  intptr_t;\x0a"
"typedef _PDCLIB_uintptr_t uintptr_t;\x0a"
"\x0a"
"/* Greatest-width integer types */\x0a"
"\x0a"
"typedef _PDCLIB_intmax_t  intmax_t;\x0a"
"typedef _PDCLIB_uintmax_t uintmax_t;\x0a"
"\x0a"
"/* Limits of specified-width integer types */\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"#ifndef __STDC_LIMIT_MACROS\x0a"
"#define _PDCLIB_NO_LIMIT_MACROS\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _PDCLIB_NO_LIMIT_MACROS\x0a"
"\x0a"
"/* Limits of exact-width integer types */\x0a"
"\x0a"
"#define INT8_MIN  _PDCLIB_INT8_MIN\x0a"
"#define INT8_MAX  _PDCLIB_INT8_MAX\x0a"
"#define UINT8_MAX _PDCLIB_UINT8_MAX\x0a"
"\x0a"
"#define INT16_MIN  _PDCLIB_INT16_MIN\x0a"
"#define INT16_MAX  _PDCLIB_INT16_MAX\x0a"
"#define UINT16_MAX _PDCLIB_UINT16_MAX\x0a"
"\x0a"
"#define INT32_MIN  _PDCLIB_INT32_MIN\x0a"
"#define INT32_MAX  _PDCLIB_INT32_MAX\x0a"
"#define UINT32_MAX _PDCLIB_UINT32_MAX\x0a"
"\x0a"
"#define INT64_MIN  _PDCLIB_INT64_MIN\x0a"
"#define INT64_MAX  _PDCLIB_INT64_MAX\x0a"
"#define UINT64_MAX _PDCLIB_UINT64_MAX\x0a"
"\x0a"
"/* Limits of minimum-width integer types */\x0a"
"\x0a"
"/* For the standard widths, least and exact types are equivalent.\x0a"
"   You are allowed to add more types here, e.g. int_least24_t.\x0a"
"*/\x0a"
"\x0a"
"#define INT_LEAST8_MIN  INT8_MIN\x0a"
"#define INT_LEAST8_MAX  INT8_MAX\x0a"
"#define UINT_LEAST8_MAX UINT8_MAX\x0a"
"\x0a"
"#define INT_LEAST16_MIN  INT16_MIN\x0a"
"#define INT_LEAST16_MAX  INT16_MAX\x0a"
"#define UINT_LEAST16_MAX UINT16_MAX\x0a"
"\x0a"
"#define INT_LEAST32_MIN  INT32_MIN\x0a"
"#define INT_LEAST32_MAX  INT32_MAX\x0a"
"#define UINT_LEAST32_MAX UINT32_MAX\x0a"
"\x0a"
"#define INT_LEAST64_MIN  INT64_MIN\x0a"
"#define INT_LEAST64_MAX  INT64_MAX\x0a"
"#define UINT_LEAST64_MAX UINT64_MAX\x0a"
"\x0a"
"/* Limits of fastest minimum-width integer types */\x0a"
"\x0a"
"#define INT_FAST8_MIN  _PDCLIB_INT_FAST8_MIN\x0a"
"#define INT_FAST8_MAX  _PDCLIB_INT_FAST8_MAX\x0a"
"#define UINT_FAST8_MAX _PDCLIB_UINT_FAST8_MAX\x0a"
"\x0a"
"#define INT_FAST16_MIN  _PDCLIB_INT_FAST16_MIN\x0a"
"#define INT_FAST16_MAX  _PDCLIB_INT_FAST16_MAX\x0a"
"#define UINT_FAST16_MAX _PDCLIB_UINT_FAST16_MAX\x0a"
"\x0a"
"#define INT_FAST32_MIN  _PDCLIB_INT_FAST32_MIN\x0a"
"#define INT_FAST32_MAX  _PDCLIB_INT_FAST32_MAX\x0a"
"#define UINT_FAST32_MAX _PDCLIB_UINT_FAST32_MAX\x0a"
"\x0a"
"#define INT_FAST64_MIN  _PDCLIB_INT_FAST64_MIN\x0a"
"#define INT_FAST64_MAX  _PDCLIB_INT_FAST64_MAX\x0a"
"#define UINT_FAST64_MAX _PDCLIB_UINT_FAST64_MAX\x0a"
"\x0a"
"/* Limits of integer types capable of holding object pointers */\x0a"
"\x0a"
"#define INTPTR_MIN  _PDCLIB_INTPTR_MIN\x0a"
"#define INTPTR_MAX  _PDCLIB_INTPTR_MAX\x0a"
"#define UINTPTR_MAX _PDCLIB_UINTPTR_MAX\x0a"
"\x0a"
"/* Limits of greatest-width integer types */\x0a"
"\x0a"
"#define INTMAX_MIN  _PDCLIB_INTMAX_MIN\x0a"
"#define INTMAX_MAX  _PDCLIB_INTMAX_MAX\x0a"
"#define UINTMAX_MAX _PDCLIB_UINTMAX_MAX\x0a"
"\x0a"
"/* Limits of other integer types */\x0a"
"\x0a"
"#define PTRDIFF_MIN _PDCLIB_PTRDIFF_MIN\x0a"
"#define PTRDIFF_MAX _PDCLIB_PTRDIFF_MAX\x0a"
"\x0a"
"#define SIG_ATOMIC_MIN _PDCLIB_SIG_ATOMIC_MIN\x0a"
"#define SIG_ATOMIC_MAX _PDCLIB_SIG_ATOMIC_MAX\x0a"
"\x0a"
"#define SIZE_MAX _PDCLIB_SIZE_MAX\x0a"
"\x0a"
"#ifndef _PDCLIB_WCHAR_MIN_MAX_DEFINED\x0a"
"#define _PDCLIB_WCHAR_MIN_MAX_DEFINED\x0a"
"#define WCHAR_MIN _PDCLIB_WCHAR_MIN\x0a"
"#define WCHAR_MAX _PDCLIB_WCHAR_MAX\x0a"
"#endif\x0a"
"\x0a"
"#define WINT_MIN _PDCLIB_WINT_MIN\x0a"
"#define WINT_MAX _PDCLIB_WINT_MAX\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"/* Macros for integer constants */\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"#ifndef __STDC_CONSTANT_MACROS\x0a"
"#define _PDCLIB_NO_CONSTANT_MACROS\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _PDCLIB_NO_CONSTANT_MACROS\x0a"
"\x0a"
"/* Macros for minimum-width integer constants */\x0a"
"\x0a"
"/* As the minimum-width types - for the required widths of 8, 16, 32, and 64\x0a"
"   bits - are expressed in terms of the exact-width types, the mechanism for\x0a"
"   these macros is to append the literal of that exact-width type to the macro\x0a"
"   parameter.\x0a"
"   This is considered a hack, as the author is not sure his understanding of\x0a"
"   the requirements of this macro is correct. Any input appreciated.\x0a"
"*/\x0a"
"\x0a"
"/* Expand to an integer constant of specified value and type int_leastN_t */\x0a"
"\x0a"
"#define INT8_C( value )  value\x0a"
"#define INT16_C( value ) value\x0a"
"#define INT32_C( value ) _PDCLIB_concat( value, _PDCLIB_INT32_LITERAL )\x0a"
"#define INT64_C( value ) _PDCLIB_concat( value, _PDCLIB_INT64_LITERAL )\x0a"
"\x0a"
"/* Expand to an integer constant of specified value and type uint_leastN_t */\x0a"
"\x0a"
"#define UINT8_C( value )  value\x0a"
"#define UINT16_C( value ) value\x0a"
"#define UINT32_C( value ) _PDCLIB_concat( value, _PDCLIB_UINT32_LITERAL )\x0a"
"#define UINT64_C( value ) _PDCLIB_concat( value, _PDCLIB_UINT64_LITERAL )\x0a"
"\x0a"
"/* Macros for greatest-width integer constants */\x0a"
"\x0a"
"/* Expand to an integer constant of specified value and type intmax_t */\x0a"
"#define INTMAX_C( value ) _PDCLIB_INTMAX_C( value )\x0a"
"\x0a"
"/* Expand to an integer constant of specified value and type uintmax_t */\x0a"
"#define UINTMAX_C( value ) _PDCLIB_UINTMAX_C( value )\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#endif\x0a"
"", 6028 ); }