#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_string_h( 
"/* String handling <string.h>\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"#include <sys/cdefs.h>\x0a"
"\x0a"
"#ifndef _PDCLIB_STRING_H\x0a"
"#define _PDCLIB_STRING_H _PDCLIB_STRING_H\x0a"
"#include \x22_PDCLIB/int.h\x22\x0a"
"\x0a"
"#include \x22_PDCLIB/cdefs.h\x22\x0a"
"#include <sys/hostabi.h>\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"extern \x22""C\x22 {\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _PDCLIB_SIZE_T_DEFINED\x0a"
"#define _PDCLIB_SIZE_T_DEFINED _PDCLIB_SIZE_T_DEFINED\x0a"
"typedef _PDCLIB_size_t size_t;\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _PDCLIB_NULL_DEFINED\x0a"
"#define _PDCLIB_NULL_DEFINED _PDCLIB_NULL_DEFINED\x0a"
"#define NULL _PDCLIB_NULL\x0a"
"#endif\x0a"
"\x0a"
"/* String function conventions */\x0a"
"\x0a"
"/*\x0a"
"   In any of the following functions taking a size_t n to specify the length of\x0a"
"   an array or size of a memory region, n may be 0, but the pointer arguments to\x0a"
"   the call shall still be valid unless otherwise stated.\x0a"
"*/\x0a"
"\x0a"
"/* Copying functions */\x0a"
"\x0a"
"/* Copy a number of n characters from the memory area pointed to by s2 to the\x0a"
"   area pointed to by s1. If the two areas overlap, behaviour is undefined.\x0a"
"   Returns the value of s1.\x0a"
"*/\x0a"
"void * memcpy( void * _PDCLIB_restrict s1, const void * _PDCLIB_restrict s2, size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Copy a number of n characters from the memory area pointed to by s2 to the\x0a"
"   area pointed to by s1. If the two areas overlap, behaviour is undefined.\x0a"
"   Returns a pointer to the byte following the last written byte.\x0a"
"*/\x0a"
"void *mempcpy( void * _PDCLIB_restrict s1, const void * _PDCLIB_restrict s2, size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Copy a number of n characters from the memory area pointed to by s2 to the\x0a"
"   area pointed to by s1. The two areas may overlap.\x0a"
"   Returns the value of s1.\x0a"
"*/\x0a"
"void * memmove( void * s1, const void * , size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Copy the character array s2 (including terminating '\x5c""0' byte) into the\x0a"
"   character array s1.\x0a"
"   Returns the value of s1.\x0a"
"*/\x0a"
"char * strcpy( char * _PDCLIB_restrict s1, const char * _PDCLIB_restrict s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Copy the character array s2 (including terminating '\x5c""0' byte) into the\x0a"
"   character array s1.\x0a"
"   Returns a pointer to the terminating NULL character copied into the s1 buffer.\x0a"
"*/\x0a"
"char *stpcpy( char * _PDCLIB_restrict s1, const char * _PDCLIB_restrict s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Copy a maximum of n characters from the character array s2 into the character\x0a"
"   array s1. If s2 is shorter than n characters, '\x5c""0' bytes will be appended to\x0a"
"   the copy in s1 until n characters have been written. If s2 is longer than n\x0a"
"   characters, NO terminating '\x5c""0' will be written to s1. If the arrays overlap,\x0a"
"   behaviour is undefined.\x0a"
"   Returns the value of s1.\x0a"
"*/\x0a"
"char * strncpy( char * _PDCLIB_restrict s1, const char * _PDCLIB_restrict s2, size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Concatenation functions */\x0a"
"\x0a"
"/* Append the contents of the character array s2 (including terminating '\x5c""0') to\x0a"
"   the character array s1 (first character of s2 overwriting the '\x5c""0' of s1). If\x0a"
"   the arrays overlap, behaviour is undefined.\x0a"
"   Returns the value of s1.\x0a"
"*/\x0a"
"char * strcat( char * _PDCLIB_restrict s1, const char * _PDCLIB_restrict s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Append a maximum of n characters from the character array s1 to the character\x0a"
"   array s1 (first character of s2 overwriting the '\x5c""0' of s1). A terminating\x0a"
"   '\x5c""0' is ALWAYS appended, even if the full n characters have already been\x0a"
"   written. If the arrays overlap, behaviour is undefined.\x0a"
"   Returns the value of s1.\x0a"
"*/\x0a"
"char * strncat( char * _PDCLIB_restrict s1, const char * _PDCLIB_restrict s2, size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Comparison functions */\x0a"
"\x0a"
"/* Compare the first n characters of the memory areas pointed to by s1 and s2.\x0a"
"   Returns 0 if s1 == s2, a negative number if s1 < s2, and a positive number if\x0a"
"   s1 > s2.\x0a"
"*/\x0a"
"int memcmp( const void * s1, const void * s2, size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Compare the character arrays s1 and s2.\x0a"
"   Returns 0 if s1 == s2, a negative number if s1 < s2, and a positive number if\x0a"
"   s1 > s2.\x0a"
"*/\x0a"
"int strcmp( const char * s1, const char * s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Compare the character arrays s1 and s2, interpreted as specified by the\x0a"
"   LC_COLLATE category of the current locale.\x0a"
"   Returns 0 if s1 == s2, a negative number if s1 < s2, and a positive number if\x0a"
"   s1 > s2.\x0a"
"   TODO\x3a Currently a dummy wrapper for strcmp() as PDCLib does not yet support\x0a"
"   locales.\x0a"
"*/\x0a"
"int strcoll( const char * s1, const char * s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Compare no more than the first n characters of the character arrays s1 and\x0a"
"   s2.\x0a"
"   Returns 0 if s1 == s2, a negative number if s1 < s2, and a positive number if\x0a"
"   s1 > s2.\x0a"
"*/\x0a"
"int strncmp( const char * s1, const char * s2, size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"#ifndef _PDCLIB_STRINGS_H\x0a"
"/* The following is defined in both string.h and strings.h. */\x0a"
"\x0a"
"/* The strcasecmp() function shall compare, while ignoring differences in case,\x0a"
"   the string pointed to by s1 to the string pointed to by s2.\x0a"
"\x0a"
"   Upon completion, strcasecmp() shall return an integer greater than, equal to,\x0a"
"   or less than 0, if the string pointed to by s1 is, ignoring case, greater than,\x0a"
"   equal to, or less than the string pointed to by s2, respectively.\x0a"
" */\x0a"
"int strcasecmp( const char *s1, const char *s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* The strncasecmp() function is similar to strcasecmp, except it only compares\x0a"
"   the first n bytes of s1.\x0a"
"\x0a"
"   Upon completion, strncasecmp() shall return an integer greater than, equal to,\x0a"
"   or less than 0, if the string pointed to by s1 is, ignoring case, greater than,\x0a"
"   equal to, or less than the string pointed to by s2, respectively.\x0a"
" */\x0a"
"int strncasecmp( const char *s1, const char *s2, size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"#endif /* strings.h */\x0a"
"\x0a"
"/* Transform the character array s2 as appropriate for the LC_COLLATE setting of\x0a"
"   the current locale. If length of resulting string is less than n, store it in\x0a"
"   the character array pointed to by s1. Return the length of the resulting\x0a"
"   string.\x0a"
"*/\x0a"
"size_t strxfrm( char * _PDCLIB_restrict s1, const char * _PDCLIB_restrict s2, size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Search functions */\x0a"
"\x0a"
"/* Search the first n characters in the memory area pointed to by s for the\x0a"
"   character c (interpreted as unsigned char).\x0a"
"   Returns a pointer to the first instance found, or NULL.\x0a"
"*/\x0a"
"void * memchr( const void * s, int c, size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* The rawmemchr() function is similar to memchr()\x3a it assumes (i.e., the programmer\x0a"
"   knows for certain) that an instance of c lies somewhere in the memory area starting\x0a"
"   at the location pointed to by s, and so performs an optimized search for c\x0a"
"  (i.e., no use of a count argument to limit the range of the search).\x0a"
"  If an instance of c is not found, the results are unpredictable.\x0a"
"\x0a"
"  The rawmemchr() function returns a pointer to the matching byte, if one is found.\x0a"
"  If no matching byte is found, the result is unspecified.\x0a"
"  */\x0a"
"void * rawmemchr(const void *s, int c) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Search the character array s (including terminating '\x5c""0') for the character c\x0a"
"   (interpreted as char).\x0a"
"   Returns a pointer to the first instance found, or NULL.\x0a"
"*/\x0a"
"char * strchr( const char * s, int c ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Search the character array s (including terminating '\x5c""0') for the character c\x0a"
"   (interpreted as char).\x0a"
"   Returns a pointer to the matched character, or a pointer to the null byte at the end\x0a"
"   of s (i.e., s+strlen(s)) if the character is not found.\x0a"
"*/\x0a"
"char * strchrnul( const char *s, int c ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Determine the length of the initial substring of character array s1 which\x0a"
"   consists only of characters not from the character array s2.\x0a"
"   Returns the length of that substring.\x0a"
"*/\x0a"
"size_t strcspn( const char * s1, const char * s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Search the character array s1 for any character from the character array s2.\x0a"
"   Returns a pointer to the first occurrence, or NULL.\x0a"
"*/\x0a"
"char * strpbrk( const char * s1, const char * s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Search the character array s (including terminating '\x5c""0') for the character c\x0a"
"   (interpreted as char).\x0a"
"   Returns a pointer to the last instance found, or NULL.\x0a"
"*/\x0a"
"char * strrchr( const char * s, int c ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Determine the length of the initial substring of character array s1 which\x0a"
"   consists only of characters from the character array s2.\x0a"
"   Returns the length of that substring.\x0a"
"*/\x0a"
"size_t strspn( const char * s1, const char * s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Search the character array s1 for the substring in character array s2.\x0a"
"   Returns a pointer to that sbstring, or NULL. If s2 is of length zero,\x0a"
"   returns s1.\x0a"
"*/\x0a"
"char * strstr( const char * s1, const char * s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* In a series of subsequent calls, parse a C string into tokens.\x0a"
"   On the first call to strtok(), the first argument is a pointer to the to-be-\x0a"
"   parsed C string. On subsequent calls, the first argument is NULL unless you\x0a"
"   want to start parsing a new string. s2 holds an array of seperator characters\x0a"
"   which can differ from call to call. Leading seperators are skipped, the first\x0a"
"   trailing seperator overwritten with '\x5c""0'.\x0a"
"   Returns a pointer to the next token.\x0a"
"   WARNING\x3a This function uses static storage, and as such is not reentrant.\x0a"
"*/\x0a"
"char * strtok( char * _PDCLIB_restrict s1, const char * _PDCLIB_restrict s2 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Miscellaneous functions */\x0a"
"\x0a"
"/* Write the character c (interpreted as unsigned char) to the first n\x0a"
"   characters of the memory area pointed to by s.\x0a"
"   Returns s.\x0a"
"*/\x0a"
"void * memset( void * s, int c, size_t n ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Map an error number to a (locale-specific) error message string. Error\x0a"
"   numbers are typically errno values, but any number is mapped to a message.\x0a"
"   TODO\x3a PDCLib does not yet support locales.\x0a"
"*/\x0a"
"char * strerror( int errnum ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* The strerror_r() function is similar to strerror(), but is thread safe.\x0a"
"   TODO\x3a PDCLib does not yet support locales.\x0a"
"   Support both strerror_r returning int (POSIX) and char * (GNU).\x0a"
"  */\x0a"
"#if _HOST_is_glibc\x0a"
"    #if _PDCLIB_GNU_SOURCE\x0a"
"        char * strerror_r( int errnum, char *buf, size_t buflen );\x0a"
"    #else //_XOPEN_SOURCE\x0a"
"        int __xpg_strerror_r( int errnum, char *buf, size_t buflen );\x0a"
"        #define strerror_r( errnum, buf, buflen ) __xpg_strerror_r( errnum, buf, buflen )\x0a"
"    #endif\x0a"
"#else\x0a"
"    int strerror_r( int errnum, char *buf, size_t buflen );\x0a"
"#endif\x0a"
"\x0a"
"/* Returns the length of the string s (excluding terminating '\x5c""0').\x0a"
"*/\x0a"
"size_t strlen( const char * s ) _PDCLIB_nothrow;\x0a"
"\x0a"
"#if __POSIX_VISIBLE >= 200809L\x0a"
"/* Returns the length of the string s (excluding terminating '\x5c""0') or maxlen if\x0a"
" * no terminating '\x5c""0' is found in the first maxlen characters.\x0a"
" */\x0a"
"size_t strnlen( const char * s, size_t maxlen ) _PDCLIB_nothrow;\x0a"
"#endif\x0a"
"\x0a"
"#if __POSIX_VISIBLE >= 200112L \x7c\x7c _PDCLIB_XOPEN_MIN(0)\x0a"
"char * strdup( const char* src ) _PDCLIB_nothrow;\x0a"
"#endif\x0a"
"\x0a"
"#if __POSIX_VISIBLE >= 200809L \x7c\x7c _PDCLIB_XOPEN_MIN(0)\x0a"
"char * strndup( const char* src, size_t n ) _PDCLIB_nothrow;\x0a"
"#endif\x0a"
"\x0a"
"#if _PDCLIB_BSD_SOURCE\x0a"
"size_t strlcpy(\x0a"
"   char *_PDCLIB_restrict _Dst,\x0a"
"   const char *_PDCLIB_restrict _Src,\x0a"
"   size_t _DstSize) _PDCLIB_nothrow;\x0a"
"\x0a"
"size_t strlcat(\x0a"
"   char *_PDCLIB_restrict _Dst,\x0a"
"   const char *_PDCLIB_restrict _Src,\x0a"
"   size_t _DstSize) _PDCLIB_nothrow;\x0a"
"#endif\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#endif\x0a"
"", 11208 ); }