#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_sys_divm_h( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2012-2019 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/* The values of constants defined in this file are used in the VM\x0a"
" * implementation itself -- hence the funny include guards. */\x0a"
"\x0a"
"#if \x21""defined(__DIVM_H_CONST__) \x26\x26 ( \x21""defined(__divm__) \x7c\x7c defined(__divm_const__) )\x0a"
"#define __DIVM_H_CONST__\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"/* Constants related to pointer layout and object types. The _VM_PM_* are\x0a"
" * simply masks for the 2 parts of a pointer (object identifier and an offset).\x0a"
" * The _VM_PB_* are number of bits. */\x0a"
"\x0a"
"enum { _VM_PM_Off  = 0x00000000FFFFFFFFull,\x0a"
"       _VM_PM_Obj  = 0xFFFFFFFF00000000ull };\x0a"
"enum { _VM_PB_Full = 64,\x0a"
"       _VM_PB_Obj = 32,\x0a"
"       _VM_PB_Off  = _VM_PB_Full - _VM_PB_Obj };\x0a"
"\x0a"
"/* The _VM_PT_* classify objects (and hence pointers to those objects) into a\x0a"
" * number of classes. Global pointers are addresses of global variables, code\x0a"
" * pointers are addresses of functions and labels, alloca pointers are\x0a"
" * addresses of local variables, heap pointers are for heap allocations (this\x0a"
" * includes both \x60malloc\x60 memory and function frames and similar VM-allocated\x0a"
" * objects), marked objects are like heap, but are treated specially when\x0a"
" * states are compared in the model checker (see \x60""divine/mc/hasher.hpp\x60).\x0a"
" * Finally, weak objects don't enter state comparison at all -- any two weak\x0a"
" * objects are considered equal. */\x0a"
"\x0a"
"enum _VM_PointerType { _VM_PT_Global, _VM_PT_Code, _VM_PT_Alloca, _VM_PT_Heap,\x0a"
"                       _VM_PT_Marked, _VM_PT_Weak };\x0a"
"\x0a"
"/* The VM keeps certain metadata about all allocated memory\x3a whether a\x0a"
" * particular address stores an object ID, whether a particular byte is defined\x0a"
" * (initialized) or whether it is tainted. Additionally, the userspace can\x0a"
" * attach metadata to memory locations and the VM will keep track of it. The\x0a"
" * interface to access and possibly modify the metadata is via \x60__vm_peek\x60 and\x0a"
" * \x60__vm_poke\x60, which both take the metadata layer to operate on as one of its\x0a"
" * parameters. The available layers are listed in the _VM_MemLayer enum below.\x0a"
" * There may be more than one user-defined metadata layer, in which case they\x0a"
" * are numbered sequentially starting from _VM_ML_User. */\x0a"
"\x0a"
"enum _VM_MemLayer { _VM_ML_Pointers, _VM_ML_Definedness, _VM_ML_Taints, _VM_ML_User };\x0a"
"\x0a"
"/* The object identifier part of the pointer is a 32 bit number, but each\x0a"
" * object type has a range of values from which the VM allocates object\x0a"
" * identifiers for the given object types. The specific ranges are described\x0a"
" * here. The _VM_PL* constants are the upper limit of each range (but the\x0a"
" * ranges are not guaranteed to be in any particular order and may be\x0a"
" * rearranged in a later version); a more convenient way to obtain the limits\x0a"
" * is via the __vm_pointer_limits array below. */\x0a"
"\x0a"
"enum { _VM_PL_Global = 0x00080000,\x0a"
"       _VM_PL_Code   = 0x00100000,\x0a"
"       _VM_PL_Alloca = 0x10000000,\x0a"
"       _VM_PL_Heap   = 0xF0000000,\x0a"
"       _VM_PL_Marked = 0xF7000000 };\x0a"
"\x0a"
"/* Each entry of __vm_pointer_limits describes the lower and upper bound of\x0a"
" * object identifier values that correspond to the given object type. The\x0a"
" * interval is closed from left but open at the end (like C++ iterators). */\x0a"
"\x0a"
"struct _VM_PointerLimits { uint32_t low, high; };\x0a"
"static const struct _VM_PointerLimits __vm_pointer_limits\x5b\x5d =\x0a"
"{\x0a"
"    \x5b_VM_PT_Global\x5d = { 0,             _VM_PL_Global },\x0a"
"    \x5b_VM_PT_Code\x5d   = { _VM_PL_Global, _VM_PL_Code   },\x0a"
"    \x5b_VM_PT_Alloca\x5d = { _VM_PL_Code,   _VM_PL_Alloca },\x0a"
"    \x5b_VM_PT_Heap\x5d   = { _VM_PL_Alloca, _VM_PL_Heap   },\x0a"
"    \x5b_VM_PT_Marked\x5d = { _VM_PL_Heap,   _VM_PL_Marked },\x0a"
"    \x5b_VM_PT_Weak\x5d   = { _VM_PL_Marked, 0xFFFFFFFF    }\x0a"
"};\x0a"
"\x0a"
"/* Obtain the type of object associated to a given object identifier (an\x0a"
" * efficient implementation depends on the range ordering, hence it's part of\x0a"
" * this file and not part of dios). */\x0a"
"\x0a"
"static inline int __vm_pointer_type( uint32_t objid )\x0a"
"{\x0a"
"    if ( objid < _VM_PL_Global )\x0a"
"        return _VM_PT_Global;\x0a"
"    if ( objid < _VM_PL_Code )\x0a"
"        return _VM_PT_Code;\x0a"
"    if ( objid < _VM_PL_Alloca )\x0a"
"        return _VM_PT_Alloca;\x0a"
"    if ( objid < _VM_PL_Heap )\x0a"
"        return _VM_PT_Heap;\x0a"
"    if ( objid < _VM_PL_Marked )\x0a"
"        return _VM_PT_Marked;\x0a"
"    if ( 1 )\x0a"
"        return _VM_PT_Weak;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"/* Definitions of data structures and hypercalls follow. The __divm__ macro is\x0a"
" * defined when DiVM itself is being built, while __divine__ is defined when\x0a"
" * \x60""divine cc\x60 or \x60""divcc\x60 is compiling code to be executed in DiVM. */\x0a"
"\x0a"
"#if \x21""defined(__DIVM_H__) \x26\x26 \x21""defined(__divm_const__)\x0a"
"#define __DIVM_H__\x0a"
"\x0a"
"#ifdef __divm__ /* #included in divine/vm */\x0a"
"#include <divine/vm/pointer.hpp>\x0a"
"#endif\x0a"
"\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"#define EXTERN_C extern \x22""C\x22 {\x0a"
"#define EXTERN_END }\x0a"
"#if __cplusplus >= 201103L\x0a"
"#define NOTHROW noexcept\x0a"
"#else\x0a"
"#define NOTHROW throw()\x0a"
"#endif\x0a"
"#else\x0a"
"#define EXTERN_C\x0a"
"#define EXTERN_END\x0a"
"#define NOTHROW __attribute__((__nothrow__))\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _VMUTIL_INLINE\x0a"
"#define _VMUTIL_INLINE static inline __attribute__((always_inline))\x0a"
"#define _VMUTIL_INLINE_UNDEF\x0a"
"#endif\x0a"
"\x0a"
"#ifndef __divm__\x0a"
"typedef void (*_VM_CodePointer)( void );\x0a"
"typedef int (*_VM_Personality)( void *, void *, void * ); // \x3f\x0a"
"typedef void *_VM_Pointer;\x0a"
"#else\x0a"
"typedef divine\x3a\x3avm\x3a\x3a""CodePointer _VM_CodePointer;\x0a"
"typedef divine\x3a\x3avm\x3a\x3a""CodePointer _VM_Personality;\x0a"
"typedef divine\x3a\x3avm\x3a\x3aGenericPointer _VM_Pointer;\x0a"
"#endif\x0a"
"\x0a"
"/* Instruction and operand encoding. The VM currently uses a Harvard\x0a"
" * architecture -- instructions are not visible to the executing program. This\x0a"
" * might change in the future. */\x0a"
"\x0a"
"struct _VM_Instruction\x0a"
"{\x0a"
"    uint32_t is_instruction\x3a""1; /* always 1 */\x0a"
"    uint32_t opcode\x3a""8;\x0a"
"    uint32_t subcode\x3a""14;\x0a"
"    uint32_t valuecount\x3a""6;\x0a"
"    uint32_t extcount\x3a""2;\x0a"
"    uint32_t immediate\x3a""1; /* second argument is an immediate constant */\x0a"
"#if __cplusplus >= 201103L\x0a"
"    explicit _VM_Instruction( int opc = 0, int subc = 0, int valc = 0, int extc = 0 )\x0a"
"        \x3a is_instruction( 1 ), opcode( opc ), subcode( subc ),\x0a"
"          valuecount( valc ), extcount( extc ), immediate( 0 ) {}\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"struct _VM_Operand\x0a"
"{\x0a"
"    uint32_t is_instruction\x3a""1; /* always 0 */\x0a"
"    enum Type { I1, I8, I16, I32, I64, I128, IX,\x0a"
"                F32, F64, F80, Ptr, PtrC, PtrA, Agg, Void, Other } type\x3a""4;\x0a"
"    /* NB. The numeric value of Location has to agree with the\x0a"
"           corresponding register's index in the _VM_ControlRegister enum */\x0a"
"    enum Location { Const, Global, Local, Invalid } location\x3a""3;\x0a"
"    uint32_t offset\x3a""24;\x0a"
"#if __cplusplus >= 201103L\x0a"
"    _VM_Operand() \x3a is_instruction( 0 ), type( Void ), location( Invalid ), offset( 0 ) {}\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"struct _VM_OperandExt\x0a"
"{\x0a"
"    uint32_t is_instruction\x3a""1; /* always 0 */\x0a"
"    uint32_t width\x3a""27;\x0a"
"    uint32_t unused\x3a""4;\x0a"
"#if __cplusplus >= 201103L\x0a"
"    _VM_OperandExt() \x3a is_instruction( 0 ), width( 0 ), unused( 0 ) {}\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"/* Representation of a function. Not (yet) exposed, same as above. */\x0a"
"\x0a"
"struct _VM_Function\x0a"
"{\x0a"
"    /* where the code for the function lives, relative to start of the heap\x0a"
"       object holding the RR */\x0a"
"    uint32_t code_offset, code_size, frame_size;\x0a"
"    uint32_t argcount\x3a""31;\x0a"
"    uint32_t vararg\x3a""1;\x0a"
"    struct _VM_Operand result;\x0a"
"    struct _VM_OperandExt result_ext;\x0a"
"    /* arguments are encoded as OpArg instructions at the start of the first\x0a"
"     * basic block of the function */\x0a"
"    _VM_Personality personality;\x0a"
"    _VM_Pointer lsda;\x0a"
"};\x0a"
"\x0a"
"/* Encoding of types (operands, constants, ...) in the form they are used in\x0a"
" * the VM. Mainly useful for computing GEP (GetElementPtr) offsets. Not exposed\x0a"
" * either. */\x0a"
"\x0a"
"struct _VM_Type\x0a"
"{\x0a"
"    enum { Array, Struct, Scalar } type\x3a""2;\x0a"
"    unsigned items\x3a""30;\x0a"
"    unsigned size;\x0a"
"};\x0a"
"\x0a"
"struct _VM_TypeItem\x0a"
"{\x0a"
"    unsigned offset;\x0a"
"    int type_id;\x0a"
"};\x0a"
"\x0a"
"union _VM_TypeTable\x0a"
"{\x0a"
"    struct _VM_Type type;\x0a"
"    struct _VM_TypeItem item;\x0a"
"};\x0a"
"\x0a"
"/* The header of a function activation frame. The stack in DiVM is a linked\x0a"
" * list of such frames. The 'pc' holds the current instruction pointer (updted\x0a"
" * at the discretion of the VM, but at least when a call or an invoke\x0a"
" * instruction is executed, creating a new frame). The 'parent' pointer is a\x0a"
" * pointer to the frame of the caller. The remainder of the frame contains\x0a"
" * function arguments and values of local LLVM registers. */\x0a"
"\x0a"
"struct _VM_Frame\x0a"
"{\x0a"
"    _VM_CodePointer pc;\x0a"
"    struct _VM_Frame *parent;\x0a"
"};\x0a"
"\x0a"
"/* Fault classes generated by the VM. To be interpreted by the fault handler.\x0a"
" * The OS may define further classes for its own use. The VM does not read or\x0a"
" * otherwise recognize values of this type, it only emits them. */\x0a"
"\x0a"
"enum _VM_Fault\x0a"
"{\x0a"
"    _VM_F_NoFault,\x0a"
"    _VM_F_Assert,\x0a"
"    _VM_F_Integer, /* division by zero */\x0a"
"    _VM_F_Float,   /* division by zero */\x0a"
"    _VM_F_Memory,\x0a"
"    _VM_F_Leak,\x0a"
"    _VM_F_Control,\x0a"
"    _VM_F_Locking,\x0a"
"    _VM_F_Hypercall,\x0a"
"    _VM_F_Access, /* access violation */\x0a"
"    _VM_F_PtrCompare,\x0a"
"    _VM_F_NotImplemented,\x0a"
"    _VM_F_Last\x0a"
"};\x0a"
"\x0a"
"/* XXX. Trace types. See also __vm_trace below. */\x0a"
"\x0a"
"enum _VM_Trace\x0a"
"{\x0a"
"    _VM_T_Text,        /* ( const char *text ) */\x0a"
"    _VM_T_Fault,       /* ( const char *text ) */\x0a"
"    _VM_T_SchedChoice, /* ( void *info ) */\x0a"
"    _VM_T_SchedInfo,   /* ( int pid, int tid ) */\x0a"
"    _VM_T_TaskID,      /* ( void *id ) */\x0a"
"    _VM_T_StateType,   /* ( void *state ) */\x0a"
"    _VM_T_Info,        /* ( const char *yaml ) */\x0a"
"    _VM_T_Assume,      /* ( weak void *path_condition ) */\x0a"
"    _VM_T_Constraints, /* ( weak void * ) */\x0a"
"    _VM_T_LeakCheck,   /* () */\x0a"
"    _VM_T_TypeAlias,   /* ( void *, const char * )\x3a create a type alias */\x0a"
"    _VM_T_DebugPersist /* ( void **, weak void * ) */\x0a"
"};\x0a"
"\x0a"
"/* XXX. Flags stored in _VM_CR_Flags, set/cleared by __vm_ctl_flag(). */\x0a"
"\x0a"
"static const uint64_t _VM_CF_None        = 0;\x0a"
"static const uint64_t _VM_CF_IgnoreLoop  = 0b1;\x0a"
"static const uint64_t _VM_CF_IgnoreCrit  = 0b10;\x0a"
"static const uint64_t _VM_CF_Accepting   = 0b100;\x0a"
"static const uint64_t _VM_CF_Error       = 0b1000;\x0a"
"static const uint64_t _VM_CF_Cancel      = 0b10000;\x0a"
"static const uint64_t _VM_CF_KernelMode  = 0b100000;\x0a"
"static const uint64_t _VM_CF_DebugMode   = 0b1000000;\x0a"
"static const uint64_t _VM_CF_AutoSuspend = 0b10000000;\x0a"
"static const uint64_t _VM_CF_KeepFrame   = 0b100000000;\x0a"
"static const uint64_t _VM_CF_Booting     = 0b1000000000;\x0a"
"static const uint64_t _VM_CF_Stop        = 0b10000000000;\x0a"
"\x0a"
"/* Control flags are split up into 4 blocks of 16 bits, each reserved for a\x0a"
" * different area of use. The first block is reserved for VM use (see above),\x0a"
" * the second block is for operating system use, third one for bitcode\x0a"
" * transformations that require runtime support (such as relaxed memory) and\x0a"
" * the final block is reserved for use by model checking algorithms. */\x0a"
"\x0a"
"static const uint64_t _VM_CFB_VM        = 1ull <<  0;\x0a"
"static const uint64_t _VM_CFB_OS        = 1ull << 16;\x0a"
"static const uint64_t _VM_CFB_Transform = 1ull << 32;\x0a"
"static const uint64_t _VM_CFB_Alg       = 1ull << 48;\x0a"
"\x0a"
"/* The VM maintains a number of control registers (out of which, 4 are\x0a"
" * available for OS use) The __vm_ctl_* family of hypercalls can be used to get\x0a"
" * and set register values (as applicable). Bitwise changes to the _VM_CR_Flags\x0a"
" * register are also possible, using the __vm_ctl_flag call. */\x0a"
"\x0a"
"enum _VM_ControlRegister\x0a"
"{\x0a"
"    _VM_CR_Constants,        /* read-only,  pointer */\x0a"
"    _VM_CR_Globals,          /* read-write, pointer */\x0a"
"    _VM_CR_Frame,            /* read-write, pointer */\x0a"
"\x0a"
"    _VM_CR_User1,\x0a"
"    _VM_CR_User2,\x0a"
"    _VM_CR_User3,\x0a"
"    _VM_CR_User4, /* TODO remove */\x0a"
"\x0a"
"    _VM_CR_Flags,            /* read-write, _VM_Flags */\x0a"
"    _VM_CR_ObjIdShuffle,\x0a"
"\x0a"
"    _VM_CR_PersistLast,\x0a"
"\x0a"
"    _VM_CR_PC = _VM_CR_PersistLast, /* read-write, code pointer */\x0a"
"    _VM_CR_Scheduler,        /* write-once, function pointer */\x0a"
"    _VM_CR_State,            /* write-once, pointer */\x0a"
"    _VM_CR_FaultHandler,     /* write-once, function pointer */\x0a"
"\x0a"
"    _VM_CR_Last\x0a"
"};\x0a"
"\x0a"
"static const int _VM_CR_PtrCount = 3;\x0a"
"static const int _VM_CR_UserCount = 4;\x0a"
"\x0a"
"/* The data structure which holds the initial environment passed to __boot. The\x0a"
" * keys are null-terminated ASCII strings, while the values might contain\x0a"
" * binary data, hence their size is specified in the structure. The environment\x0a"
" * is passed as an array of _VM_Env, terminated by an item with a null key. */\x0a"
"\x0a"
"struct _VM_Env\x0a"
"{\x0a"
"    const char *key;\x0a"
"    const char *value;\x0a"
"    int size;\x0a"
"};\x0a"
"\x0a"
"enum _VM_MemAccessType { _VM_MAT_Load = 0x1, _VM_MAT_Store = 0x2, _VM_MAT_Both = 0x3 };\x0a"
"\x0a"
"enum _VM_SC_ValueType\x0a"
"{\x0a"
"    _VM_SC_Int32 = 0, _VM_SC_Int64 = 1, _VM_SC_Mem = 2,\x0a"
"    _VM_SC_In = 0x100, _VM_SC_Out = 0x200\x0a"
"};\x0a"
"\x0a"
"#if defined( __divine__ )\x0a"
"\x0a"
"EXTERN_C\x0a"
"\x0a"
"/* The main task of the __boot procedure is to set up the scheduler. After\x0a"
" * __boot returns, the VM will repeatedly call the scheduler (every time with a\x0a"
" * blank frame). The scheduler may use __vm_ctl_set to invoke suspended threads\x0a"
" * of execution. After a __vm_suspend(), the scheduler is started again.\x0a"
" *\x0a"
" * Additionally, __boot can (and probably should) set up a fault handler, using\x0a"
" * \x60__vm_cfl_set( _VM_CR_FaultHandler, \x26handler_function )\x60. See also below. */\x0a"
"\x0a"
"void __boot( const struct _VM_Env *env )\x0a"
"    __attribute__((__annotate__(\x22""brick.llvm.prune.root\x22)));\x0a"
"\x0a"
"/* The type of the fault handler. The 'type' parameter exists to make it easier\x0a"
" * for the handler to quickly decide whether to continue execution and whether\x0a"
" * to raise a user-reported error. In case the handler decides to continue\x0a"
" * execution, it should transfer control to the cont_frame at the cont_pc\x0a"
" * location\x3a __vm_ctl_set( _VM_CR_Frame, cont_frame, cont_pc ) */\x0a"
"\x0a"
"typedef void (*__vm_fault_t)( enum _VM_Fault type,\x0a"
"                              struct _VM_Frame *cont_frame,\x0a"
"                              void (*cont_pc)(void) )\x0a"
"    __attribute__((__noreturn__));\x0a"
"\x0a"
"/* Read and write the control registers of the VM. See the definition of\x0a"
" * _VM_ControlRegister above for details on the registers themselves. The\x0a"
" * __vm_ctl_flag call clears and sets individual flags in the _VM_CR_Flags\x0a"
" * register and returns the value of the flags register as it was before the\x0a"
" * changes were performed. Depending on the particular register, __vm_ctl_set\x0a"
" * might have side-effects (specifically, setting _VM_CR_Frame transfers\x0a"
" * control to the specified frame; in this case, a third argument might be\x0a"
" * given to __vm_ctl_set, which specifies the value of the program counter to\x0a"
" * jump to within the function associated with the target frame). */\x0a"
"\x0a"
"void     __vm_ctl_set( enum _VM_ControlRegister reg, void *val, ... ) NOTHROW;\x0a"
"void    *__vm_ctl_get( enum _VM_ControlRegister reg ) NOTHROW;\x0a"
"uint64_t __vm_ctl_flag( uint64_t clear, uint64_t set ) NOTHROW;\x0a"
"\x0a"
"/* Conditionally call a function on criteria tracked by the VM related to state\x0a"
" * space generation. An effect of both functions is to make a note of the call.\x0a"
" * In case of \x60__vm_test_crit\x60, if a conflicting (critical) memory operation\x0a"
" * was already tested on this edge, the condition is satisfied and the function\x0a"
" * 'yes' is called. In the case of \x60__vm_test_loop\x60, if the same call is\x0a"
" * performed a second time within a single state space edge and with the same\x0a"
" * call stack and the same 'counter' argument, the function is called. In both\x0a"
" * cases, the function is expected to cause a reschedule and call\x0a"
" * \x60__vm_suspend\x60 to restart the scheduler. */\x0a"
"\x0a"
"void __vm_test_crit( void *addr, int size, enum _VM_MemAccessType access,\x0a"
"                     void (*yes)( void ) ) NOTHROW;\x0a"
"void __vm_test_loop( int counter, void (*yes)( void ) ) NOTHROW;\x0a"
"\x0a"
"/* Non-deterministic choice\x3a when __vm_choose is encountered, the 'universe' of\x0a"
" * the program splits into n copies (n is the first argument of __vm_choose).\x0a"
" * In each such 'universe', the program will see a different return value from\x0a"
" * __vm_choose, starting from 0. The remaining arguments specify the\x0a"
" * probability of each outcome, but no model checking algorithm can currently\x0a"
" * use those values. */\x0a"
"\x0a"
"int __vm_choose( int n, ... ) NOTHROW;\x0a"
"\x0a"
"/* Provides meta-information about the executing code. The 'type' parameter\x0a"
" * distinguishes between multiple categories of said meta-information. How the\x0a"
" * trace info is used or presented to the user depends on the particular\x0a"
" * frontend\x3a text traces may be printed out as the program executes, or they\x0a"
" * may show up as arrow labels in visual state space representation. The\x0a"
" * scheduling trace data can be used for annotating counterexamples, for\x0a"
" * guiding heuristic searches (minimising the number of context switches, for\x0a"
" * example) or in an interactive simulator/debugger for constructing a\x0a"
" * high-level view of thread/process structure of the program. The details of\x0a"
" * individual trace types are documented at the _VM_Trace enum. */\x0a"
"\x0a"
"void __vm_trace( enum _VM_Trace type, ... ) NOTHROW;\x0a"
"\x0a"
"/*\x0a"
" * Create and destroy heap objects.\x0a"
" */\x0a"
"void *__vm_obj_make( int size, int type ) NOTHROW;\x0a"
"void  __vm_obj_resize( void *ptr, int size ) NOTHROW;\x0a"
"void  __vm_obj_free( void *ptr ) NOTHROW;\x0a"
"int   __vm_obj_size( const void * ) NOTHROW;\x0a"
"void *__vm_obj_clone( const void *root, const void **block ) NOTHROW;\x0a"
"\x0a"
"/* Read and write additional metadata, indexed by an address and a key. The\x0a"
" * metadata is only valid as long as the corresponding address is. There are a\x0a"
" * few reserved keys that allow access to metadata automatically tracked by the\x0a"
" * VM (see _VM_MemLayer above). User-specified metadata (i.e. attached to\x0a"
" * _VM_ML_User and higher-valued keys) does not propagate automatically. */\x0a"
"\x0a"
"typedef struct { uint32_t offset, length, value; } __vm_meta_t;\x0a"
"__vm_meta_t __vm_peek( int key, uint32_t objid, int offset, int len ) NOTHROW;\x0a"
"void        __vm_poke( int key, uint32_t objid, int offset, int len, uint32_t val ) NOTHROW;\x0a"
"\x0a"
"/* Pass a syscall through the VM to the host system. The parameters must\x0a"
" * describe the parameters of the actual operating system on the outside,\x0a"
" * corresponding to the syscall with a given id.\x0a"
" *\x0a"
" * For example\x3a\x0a"
" *\x0a"
" *   const char file\x5b\x5d = \x22""filename.c\x22;\x0a"
" *   int fileno;\x0a"
" *   int errno = __vm_syscall( SYS_open, _VM_SC_Int32, \x26""fileno,\x0a"
" *                                       _VM_SC_Mem \x7c _VM_SC_In,\x0a"
" *                                       sizeof( filename ), filename );\x0a"
" *\x0a"
" *   long rl_ret;\x0a"
" *   char buffer\x5b""100\x5d;\x0a"
" *   errno = __vm_syscall( SYS_readlink, _VM_SC_Int64, \x26rl_ret,\x0a"
" *                                       _VM_SC_Mem \x7c _VM_SC_In,\x0a"
" *                                       sizeof( filename ), filename,\x0a"
" *                                       _VM_SC_Mem \x7c _VM_SC_Out,\x0a"
" *                                       100, buffer,\x0a"
" *                                       _VM_SC_Int64 \x7c _VM_SC_In,\x0a"
" *                                       100 );\x0a"
" *   int close_err;\x0a"
" *   errno = __vm_syscall( SYS_close, _VM_SC_Int32, \x26""close_err,\x0a"
" *                                    _VM_SC_Int32 \x7c _VM_SC_In, fileno ); */\x0a"
"\x0a"
"int __vm_syscall( int id, int retval_type, ... ) NOTHROW;\x0a"
"\x0a"
"/* Suspend execution of the VM. This will cause the scheduler to be called again. */\x0a"
"\x0a"
"_VMUTIL_INLINE void __vm_suspend( void ) NOTHROW\x0a"
"{\x0a"
"    __vm_ctl_set( _VM_CR_Frame, 0 );\x0a"
"}\x0a"
"\x0a"
"/* Abandon the current execution. Everything since the last invocation of the\x0a"
" * scheduler is thrown away and not considered part of the state space of the\x0a"
" * program. Can be used to implement assume() and similar constructs. */\x0a"
"\x0a"
"_VMUTIL_INLINE void __vm_cancel( void ) NOTHROW\x0a"
"{\x0a"
"    __vm_ctl_flag( 0, _VM_CF_Cancel );\x0a"
"    __vm_ctl_set( _VM_CR_Frame, 0 );\x0a"
"}\x0a"
"\x0a"
"typedef struct { uint32_t off, obj; } __vm_pointer_t;\x0a"
"void *memcpy( void *dest, const void * src, unsigned long n ) NOTHROW;\x0a"
"\x0a"
"_VMUTIL_INLINE __vm_pointer_t __vm_pointer_split( void *ptr )\x0a"
"{\x0a"
"    __vm_pointer_t rv;\x0a"
"    memcpy( \x26rv, \x26ptr, sizeof( rv ) );\x0a"
"    return rv;\x0a"
"}\x0a"
"\x0a"
"_VMUTIL_INLINE void *__vm_pointer_make( uint32_t obj, uint32_t off )\x0a"
"{\x0a"
"    __vm_pointer_t ptr = { off, obj };\x0a"
"    void *rv;\x0a"
"    memcpy( \x26rv, \x26ptr, sizeof( rv ) );\x0a"
"    return rv;\x0a"
"}\x0a"
"\x0a"
"EXTERN_END\x0a"
"\x0a"
"#endif // __divine__\x0a"
"\x0a"
"#undef EXTERN_C\x0a"
"#undef EXTERN_END\x0a"
"#undef NOTHROW\x0a"
"\x0a"
"#ifdef _VMUTIL_INLINE_UNDEF\x0a"
"#undef _VMUTIL_INLINE_UNDEF\x0a"
"#undef _VMUTIL_INLINE\x0a"
"#endif\x0a"
"\x0a"
"#endif // __DIVINE_H__\x0a"
"", 20656 ); }