#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_sys_fault_h( 
"#ifndef __SYS_FAULT_H__\x0a"
"#define __SYS_FAULT_H__\x0a"
"\x0a"
"#include <sys/divm.h>\x0a"
"#include <_PDCLIB/cdefs.h>\x0a"
"\x0a"
"static const uint64_t _DiOS_CF_Fault       = _VM_CFB_OS << 2;\x0a"
"static const uint64_t _DiOS_CF_IgnoreFault = _VM_CFB_OS << 3;\x0a"
"\x0a"
"enum _DiOS_Fault\x0a"
"{\x0a"
"    _DiOS_F_Threading = _VM_F_Last,\x0a"
"    _DiOS_F_Assert,\x0a"
"    _DiOS_F_Config,\x0a"
"    _DiOS_F_Exit,\x0a"
"    _DiOS_F_Syscall,\x0a"
"    _DiOS_F_Last\x0a"
"};\x0a"
"\x0a"
"enum _DiOS_SimFail\x0a"
"{\x0a"
"    _DiOS_SF_First = _DiOS_F_Last,\x0a"
"    _DiOS_SF_Malloc = _DiOS_F_Last,\x0a"
"    _DiOS_SF_Last\x0a"
"};\x0a"
"\x0a"
"enum _DiOS_FaultConfig\x0a"
"{\x0a"
"    _DiOS_FC_EInvalidCfg = -3,\x0a"
"    _DiOS_FC_EInvalidFault = -2,\x0a"
"    _DiOS_FC_ELocked = -1,\x0a"
"    _DiOS_FC_Ignore = 0,\x0a"
"    _DiOS_FC_Report,\x0a"
"    _DiOS_FC_Detect,\x0a"
"    _DiOS_FC_Abort,\x0a"
"    _DiOS_FC_NoFail,\x0a"
"    _DiOS_FC_SimFail,\x0a"
"};\x0a"
"\x0a"
"_PDCLIB_EXTERN_C\x0a"
"\x0a"
"extern uint8_t __dios_simfail_flags;\x0a"
"\x0a"
"/*\x0a"
" * Configures given fault or symfail and returns original value. Possible\x0a"
" * configurations are _DiOS_FC_{Ignore, Report, Abort, NoFail, SimFail}.\x0a"
" *\x0a"
" * Return original configuration or error.\x0a"
" * Possible errors\x3a\x0a"
" *   - _DiOS_FC_ELocked if user forced cofiguration,\x0a"
" *   - _DiOS_FC_EInvalidFault if invalid fault number was specified\x0a"
" *   - _DiOS_FC_EInvalidCfg if simfail configuration was passed for fault or\x0a"
" *     fault confiugation was passed for simfail.\x0a"
" */\x0a"
"int __dios_configure_fault( int fault, int cfg ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/*\x0a"
" * Return fault configuration. Possible configurations are\x0a"
" * _DiOS_FC_{Ignore, Report, Abort, NoFail, SimFail}.\x0a"
" *\x0a"
" * Can return _DiOS_FC_EInvalidFault if invalid fault was specified.\x0a"
" */\x0a"
"int __dios_get_fault_config( int fault ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/*\x0a"
" * Cause program fault by calling fault handler.\x0a"
" */\x0a"
"void __dios_fault( int f, const char *msg ) _PDCLIB_nothrow __attribute__(( __noinline__ ));\x0a"
"\x0a"
"static inline int __dios_sim_fail( enum _DiOS_SimFail x )\x0a"
"{\x0a"
"    return __dios_simfail_flags \x26 ( 1 << ( x - _DiOS_SF_First ) );\x0a"
"}\x0a"
"\x0a"
"static inline void __dios_safe_free( void * v )\x0a"
"{\x0a"
"    auto old = __vm_ctl_flag( 0, _DiOS_CF_IgnoreFault );\x0a"
"    __vm_obj_free( v );\x0a"
"    if ( ( old \x26 _DiOS_CF_IgnoreFault ) == 0 )\x0a"
"        __vm_ctl_flag( _DiOS_CF_IgnoreFault, 0 );\x0a"
"}\x0a"
"\x0a"
"_PDCLIB_EXTERN_END\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"\x0a"
"namespace __dios {\x0a"
"\x0a"
"struct DetectFault\x0a"
"{\x0a"
"    DetectFault( int fault ) _PDCLIB_nothrow \x3a\x0a"
"        _fault( fault ), _orig( __dios_configure_fault( fault, _DiOS_FC_Detect ) )\x0a"
"    { }\x0a"
"\x0a"
"#if __cplusplus >= 201103L\x0a"
"    DetectFault( const DetectFault \x26 ) = delete;\x0a"
"#endif\x0a"
"\x0a"
"    \x7e""DetectFault() _PDCLIB_nothrow\x0a"
"    {\x0a"
"        __dios_configure_fault( _fault, _orig );\x0a"
"        __vm_ctl_flag( _DiOS_CF_Fault, 0 );\x0a"
"    }\x0a"
"\x0a"
"    static bool triggered()\x0a"
"    {\x0a"
"        return uintptr_t( __vm_ctl_get( _VM_CR_Flags ) ) \x26 _DiOS_CF_Fault;\x0a"
"    }\x0a"
"\x0a"
"  private\x3a\x0a"
"    int _fault;\x0a"
"    int _orig;\x0a"
"};\x0a"
"\x0a"
"} // namespace __dios\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#endif\x0a"
"", 2741 ); }