#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_sys_interrupt_h( 
"#ifndef __SYS_INTERRUPT_H__\x0a"
"#define __SYS_INTERRUPT_H__\x0a"
"\x0a"
"#include <sys/divm.h>\x0a"
"#include <assert.h>\x0a"
"\x0a"
"#include <_PDCLIB/cdefs.h>\x0a"
"\x0a"
"static const uint64_t _DiOS_CF_Mask       = _VM_CFB_OS << 0;\x0a"
"static const uint64_t _DiOS_CF_Deferred   = _VM_CFB_OS << 1;\x0a"
"static const uint64_t _DiOS_CF_Fairness   = _VM_CFB_OS << 4;\x0a"
"\x0a"
"__BEGIN_DECLS\x0a"
"void __dios_suspend( void ) __nothrow;\x0a"
"void __dios_reschedule( void ) __nothrow;\x0a"
"int __dios_mask( int ) __nothrow;\x0a"
"__END_DECLS\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"template< bool fenced >\x0a"
"struct _InterruptMask\x0a"
"{\x0a"
"    __attribute__((always_inline))\x0a"
"    _InterruptMask() _PDCLIB_nothrow\x0a"
"    {\x0a"
"        _orig_state = __vm_ctl_flag( 0, _DiOS_CF_Mask ) \x26 _DiOS_CF_Mask;\x0a"
"        if ( fenced )\x0a"
"            __sync_synchronize();\x0a"
"    }\x0a"
"\x0a"
"    __attribute__((always_inline))\x0a"
"    \x7e_InterruptMask() _PDCLIB_nothrow\x0a"
"    {\x0a"
"        if ( fenced )\x0a"
"            __sync_synchronize();\x0a"
"        if ( \x21_orig_state )\x0a"
"        {\x0a"
"            __vm_ctl_flag( _DiOS_CF_Mask, 0 );\x0a"
"            if ( uintptr_t( __vm_ctl_get( _VM_CR_Flags ) ) \x26 _DiOS_CF_Deferred )\x0a"
"                __dios_reschedule();\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"  private\x3a\x0a"
"\x0a"
"    struct Without\x0a"
"    {\x0a"
"        Without( _InterruptMask \x26self ) _PDCLIB_nothrow \x3a self( self )\x0a"
"        {\x0a"
"            if ( \x21self._orig_state )\x0a"
"            {\x0a"
"                if ( fenced )\x0a"
"                    __sync_synchronize();\x0a"
"                __vm_ctl_flag( _DiOS_CF_Mask, 0 );\x0a"
"                if ( uintptr_t( __vm_ctl_get( _VM_CR_Flags ) ) \x26 _DiOS_CF_Deferred )\x0a"
"                    __dios_reschedule();\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"        // acquire mask if not masked already\x0a"
"        \x7eWithout() _PDCLIB_nothrow\x0a"
"        {\x0a"
"            if ( \x21self._orig_state )\x0a"
"            {\x0a"
"                if ( fenced )\x0a"
"                    __sync_synchronize();\x0a"
"                __vm_ctl_flag( 0, _DiOS_CF_Mask );\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"        _InterruptMask \x26self;\x0a"
"    };\x0a"
"\x0a"
"  public\x3a\x0a"
"\x0a"
"#if __cplusplus >= 201103L\x0a"
"    _InterruptMask( const _InterruptMask \x26 ) = delete;\x0a"
"    _InterruptMask( _InterruptMask \x26\x26 ) = delete;\x0a"
"#else\x0a"
"  private\x3a\x0a"
"    _InterruptMask( const _InterruptMask \x26 );\x0a"
"    _InterruptMask \x26operator=( const _InterruptMask \x26 );\x0a"
"  public\x3a\x0a"
"#endif\x0a"
"\x0a"
"#if __cplusplus >= 201402L\x0a"
"    // break mask (if it is held by this guard), call given function and then\x0a"
"    // return mask to original state\x0a"
"    template< typename Fun >\x0a"
"    auto without( Fun \x26\x26""f, bool mustBreakMask = false ) _PDCLIB_nothrow\x0a"
"    {\x0a"
"        assert( ( \x21mustBreakMask \x7c\x7c \x21_orig_state ) \x26\x26\x0a"
"                \x22InterruptMask is required to own the mask in InterruptMask\x3a\x3awithout\x22 );\x0a"
"        Without _( *this );\x0a"
"        return f();\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    // beware, this is dangerous\x0a"
"    void _setOrigState( bool state ) _PDCLIB_nothrow { _orig_state = state; }\x0a"
"    bool _origState() const _PDCLIB_nothrow { return _orig_state; }\x0a"
"\x0a"
"  private\x3a\x0a"
"\x0a"
"    bool _orig_state;\x0a"
"};\x0a"
"\x0a"
"typedef _InterruptMask< false > InterruptMask;\x0a"
"typedef _InterruptMask< true >  FencedInterruptMask;\x0a"
"\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"#endif\x0a"
"", 2953 ); }