#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_sys_lart_h( 
"/*\x0a"
" * (c) 2017 Vladim\xc3\xadr \xc5\xa0till <xstill\x40""fi.muni.cz>\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" * (c) 2018 Henrich Lauko <xlauko\x40mail.muni.cz>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * This file defines the interface between various lart-provided program\x0a"
" * transformations and their runtime support code (which resides in dios/pts).\x0a"
" */\x0a"
"\x0a"
"#ifndef _SYS_LART_H_\x0a"
"#define _SYS_LART_H_\x0a"
"\x0a"
"#ifdef __divine__\x0a"
"#include <sys/divm.h>\x0a"
"#include <dios.h>\x0a"
"#else\x0a"
"#include <divine/vm/divm.h>\x0a"
"#endif\x0a"
"\x0a"
"#if __cplusplus >= 201402L\x0a"
"#include <type_traits>\x0a"
"#include <limits>\x0a"
"\x0a"
"namespace lart\x3a\x3aweakmem\x0a"
"{\x0a"
"\x0a"
"    enum class MemoryOrder \x3a uint8_t\x0a"
"    {\x0a"
"        NotAtomic = 0,\x0a"
"        Unordered  = (1 << 0),\x0a"
"        Monotonic  = (1 << 1) \x7c Unordered,\x0a"
"        Acquire    = (1 << 2) \x7c Monotonic,\x0a"
"        Release    = (1 << 3) \x7c Monotonic,\x0a"
"        AcqRel     = Acquire \x7c Release,\x0a"
"        SeqCst     = (1 << 4) \x7c AcqRel,\x0a"
"        AtomicOp   = (1 << 5),\x0a"
"        WeakCAS    = (1 << 6),\x0a"
"    };\x0a"
"\x0a"
"    inline MemoryOrder operator\x7c( MemoryOrder a, MemoryOrder b )\x0a"
"    {\x0a"
"        using uint = typename std\x3a\x3aunderlying_type< MemoryOrder >\x3a\x3atype;\x0a"
"        return MemoryOrder( uint( a ) \x7c uint( b ) );\x0a"
"    }\x0a"
"\x0a"
"    inline MemoryOrder operator\x26( MemoryOrder a, MemoryOrder b )\x0a"
"    {\x0a"
"        using uint = typename std\x3a\x3aunderlying_type< MemoryOrder >\x3a\x3atype;\x0a"
"        return MemoryOrder( uint( a ) \x26 uint( b ) );\x0a"
"    }\x0a"
"\x0a"
"    inline bool subseteq( MemoryOrder a, MemoryOrder b )\x0a"
"    {\x0a"
"        return a == (a \x26 b);\x0a"
"    }\x0a"
"\x0a"
"}\x0a"
"\x0a"
"namespace lart\x3a\x3asym\x0a"
"{\x0a"
"\x0a"
"    using VarID = int32_t;\x0a"
"\x0a"
"    using RefCount = uint8_t;\x0a"
"\x0a"
"    enum class Op \x3a uint8_t\x0a"
"    {\x0a"
"        Invalid,\x0a"
"\x0a"
"        Variable,\x0a"
"        Constant,\x0a"
"\x0a"
"        BitCast, FirstUnary = BitCast,\x0a"
"\x0a"
"        SExt,\x0a"
"        ZExt,\x0a"
"        Trunc,\x0a"
"\x0a"
"        IntToPtr,\x0a"
"        PtrToInt,\x0a"
"\x0a"
"        FPExt,\x0a"
"        FPTrunc,\x0a"
"        FPToSInt,\x0a"
"        FPToUInt,\x0a"
"        SIntToFP,\x0a"
"        UIntToFP,\x0a"
"\x0a"
"        BoolNot,\x0a"
"        Extract, LastUnary = Extract,\x0a"
"\x0a"
"        Add, FirstBinary = Add,\x0a"
"        Sub,\x0a"
"        Mul,\x0a"
"        UDiv,\x0a"
"        SDiv,\x0a"
"        URem,\x0a"
"        SRem,\x0a"
"\x0a"
"        FpAdd,\x0a"
"        FpSub,\x0a"
"        FpMul,\x0a"
"        FpDiv,\x0a"
"        FpRem,\x0a"
"\x0a"
"        Shl,\x0a"
"        LShr,\x0a"
"        AShr,\x0a"
"        And,\x0a"
"        Or,\x0a"
"        Xor,\x0a"
"\x0a"
"        // Icmp\x0a"
"        EQ,\x0a"
"        NE,\x0a"
"        UGT,\x0a"
"        UGE,\x0a"
"        ULT,\x0a"
"        ULE,\x0a"
"        SGT,\x0a"
"        SGE,\x0a"
"        SLT,\x0a"
"        SLE,\x0a"
"\x0a"
"        // Fcmp\x0a"
"        FpFalse, // no comparison, always returns false\x0a"
"        FpOEQ,   // ordered and equal\x0a"
"        FpOGT,   // ordered and greater than\x0a"
"        FpOGE,   // ordered and greater than or equal\x0a"
"        FpOLT,   // ordered and less than\x0a"
"        FpOLE,   // ordered and less than or equal\x0a"
"        FpONE,   // ordered and not equal\x0a"
"        FpORD,   // ordered (no nans)\x0a"
"        FpUEQ,   // unordered or equal\x0a"
"        FpUGT,   // unordered or greater than\x0a"
"        FpUGE,   // unordered or greater than or equal\x0a"
"        FpULT,   // unordered or less than\x0a"
"        FpULE,   // unordered or less than or equal\x0a"
"        FpUNE,   // unordered or not equal\x0a"
"        FpUNO,   // unordered (either nans)\x0a"
"        FpTrue,  // no comparison, always returns true\x0a"
"        Constraint, // behaves as binary logical and\x0a"
"\x0a"
"        Concat, LastBinary = Concat,\x0a"
"    };\x0a"
"\x0a"
"    struct Type\x0a"
"    {\x0a"
"        enum T \x3a uint8_t\x0a"
"        {\x0a"
"            Int,\x0a"
"            Float\x0a"
"        };\x0a"
"\x0a"
"        static const int bwmask = 0x7fff;\x0a"
"\x0a"
"        Type() = default;\x0a"
"        Type( T g, int bitwidth ) \x3a _data( (g << 15) \x7c bitwidth ) { }\x0a"
"\x0a"
"        T type() { return T( _data >> 15 ); }\x0a"
"        int bitwidth() { return _data \x26 bwmask; }\x0a"
"        void bitwidth( int x ) {\x0a"
"            _data \x26= \x7e""bwmask;\x0a"
"            _data \x7c= bwmask \x26 x;\x0a"
"        }\x0a"
"\x0a"
"        uint16_t _data;\x0a"
"    };\x0a"
"\x0a"
"    static_assert( sizeof( VarID ) == 4, \x22\x22 );\x0a"
"    static_assert( sizeof( Type ) == 2, \x22\x22 );\x0a"
"\x0a"
"    struct Variable {\x0a"
"        Variable( Type type, VarID id ) \x3a\x0a"
"            op( Op\x3a\x3aVariable ), refcount( 0 ), type( type ), id( id )\x0a"
"        { }\x0a"
"\x0a"
"        Op op;              // 8B\x0a"
"        RefCount refcount;  // 8B\x0a"
"        Type type;          // 16B\x0a"
"        VarID id;           // 32B\x0a"
"    };\x0a"
"\x0a"
"    static_assert( sizeof( Variable ) == 8, \x22\x22 );\x0a"
"\x0a"
"    union ValueU {\x0a"
"        //    ValueT raw;\x0a"
"        uint8_t i8;\x0a"
"        uint16_t i16;\x0a"
"        uint32_t i32;\x0a"
"        uint64_t i64;\x0a"
"        float fp32;\x0a"
"        double fp64;\x0a"
"        //    long double fp80;\x0a"
"    };\x0a"
"\x0a"
"    struct Constant {\x0a"
"        Constant( Type type, uint64_t value ) \x3a\x0a"
"            op( Op\x3a\x3a""Constant ), refcount( 0 ), type( type ), value( value )\x0a"
"        { }\x0a"
"\x0a"
"        Op op;            // 8B\x0a"
"        RefCount refcount;// 8B\x0a"
"        Type type;        // 16B\x0a"
"        uint64_t value;\x0a"
"        //    std\x3a\x3a""array< uint32_t, 3 > value; // 96B - enough to hold long double\x0a"
"    };\x0a"
"\x0a"
"    static_assert( sizeof( Constant ) == 16, \x22\x22 );\x0a"
"\x0a"
"    union Formula;\x0a"
"\x0a"
"#ifdef __divine__\x0a"
"    static inline void refcount_increment( Formula * ptr );\x0a"
"#endif\x0a"
"\x0a"
"    template< typename Formula >\x0a"
"    struct Unary_ {\x0a"
"        Unary_( Op op, Type t, Formula child ) \x3a\x0a"
"            op( op ), refcount( 0 ), type( t ), child( child )\x0a"
"        {\x0a"
"#ifdef __divine__\x0a"
"            refcount_increment( child );\x0a"
"#endif\x0a"
"        }\x0a"
"\x0a"
"        Unary_( Op op, Type t, unsigned short from, unsigned short to, Formula child ) \x3a\x0a"
"            op( op ), refcount( 0 ), type( t ), from( from ), to( to ), child( child )\x0a"
"        {\x0a"
"#ifdef __divine__\x0a"
"            refcount_increment( child );\x0a"
"#endif\x0a"
"        }\x0a"
"\x0a"
"        Op op;                   // 8B\x0a"
"        RefCount refcount;       // 8B\x0a"
"        Type type;               // 16B\x0a"
"        unsigned short from, to; // 32B, only for Extract\x0a"
"        Formula child;           // 64B\x0a"
"    };\x0a"
"\x0a"
"    static_assert( sizeof( Unary_< void * > ) == 16, \x22\x22 );\x0a"
"\x0a"
"    template< typename Formula >\x0a"
"    struct Binary_ {\x0a"
"        Binary_( Op op, Type t, Formula left, Formula right ) \x3a\x0a"
"            op( op ), type( t ), refcount( 0 ), left( left ), right( right )\x0a"
"        {\x0a"
"#ifdef __divine__\x0a"
"            refcount_increment( left );\x0a"
"            refcount_increment( right );\x0a"
"#endif\x0a"
"        }\x0a"
"\x0a"
"        Op op;            // 8B\x0a"
"        RefCount refcount;// 8B\x0a"
"        Type type;        // 16B\x0a"
"        Formula left;     // 64B\x0a"
"        Formula right;    // 64B\x0a"
"    };\x0a"
"\x0a"
"    static_assert( sizeof( Binary_< void * > ) == 24, \x22\x22 );\x0a"
"\x0a"
"    union Formula;\x0a"
"\x0a"
"#ifdef __divine__\x0a"
"    using Binary = Binary_< Formula * >;\x0a"
"    using Unary = Unary_< Formula * >;\x0a"
"#else\x0a"
"    using Unary = Unary_< divine\x3a\x3avm\x3a\x3aHeapPointer >;\x0a"
"    using Binary = Binary_< divine\x3a\x3avm\x3a\x3aHeapPointer >;\x0a"
"#endif\x0a"
"\x0a"
"    union Formula\x0a"
"    {\x0a"
"        Formula() \x3a hdr{ Op\x3a\x3aInvalid, 0, Type() } { }\x0a"
"\x0a"
"        struct\x0a"
"        {\x0a"
"            Op op;                   // 8B\x0a"
"            RefCount refcount;       // 8B\x0a"
"            Type type;               // 16B\x0a"
"        } hdr;\x0a"
"\x0a"
"        Op op() const { return hdr.op; }\x0a"
"        RefCount refcount() const { return hdr.refcount; }\x0a"
"        Type type() const { return hdr.type; }\x0a"
"\x0a"
"        void refcount_increment() {\x0a"
"            if ( hdr.refcount \x21= std\x3a\x3anumeric_limits<RefCount>\x3a\x3amax() )\x0a"
"                ++hdr.refcount;\x0a"
"        }\x0a"
"\x0a"
"        void refcount_decrement() {\x0a"
"            if ( hdr.refcount \x21= std\x3a\x3anumeric_limits<RefCount>\x3a\x3amax() )\x0a"
"                --hdr.refcount;\x0a"
"        }\x0a"
"\x0a"
"        Variable var;\x0a"
"        Constant con;\x0a"
"        Unary unary;\x0a"
"        Binary binary;\x0a"
"    };\x0a"
"\x0a"
"#ifdef __divine__\x0a"
"    __invisible static inline void refcount_increment( Formula * ptr ) {\x0a"
"        if ( ptr )\x0a"
"            ptr->refcount_increment();\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    inline bool isConstant( Op x ) { return x == Op\x3a\x3a""Constant; }\x0a"
"    inline bool isConstant( Formula * f ) { return isConstant( f->op() ); }\x0a"
"\x0a"
"    inline bool isVariable( Op x ) { return x == Op\x3a\x3aVariable; }\x0a"
"    inline bool isVariable( Formula * f ) { return isVariable( f->op() ); }\x0a"
"\x0a"
"    inline bool isUnary( Op x ) { return x >= Op\x3a\x3a""FirstUnary \x26\x26 x <= Op\x3a\x3aLastUnary; }\x0a"
"    inline bool isUnary( Formula * f ) { return isUnary( f->op() ); }\x0a"
"\x0a"
"    inline bool isBinary( Op x ) { return x >= Op\x3a\x3a""FirstBinary \x26\x26 x <= Op\x3a\x3aLastBinary; }\x0a"
"    inline bool isBinary( Formula * f ) { return isBinary( f->op() ); }\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"extern \x22""C\x22 {\x0a"
"#endif\x0a"
"\x0a"
"// there are 16 flags reserved for transformations, see <sys/divm.h>\x0a"
"static const uint64_t _LART_CF_RelaxedMemRuntime  = _VM_CFB_Transform << 0;\x0a"
"static const uint64_t _LART_CF_RelaxedMemCritSeen = _VM_CFB_Transform << 1;\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#endif // _SYS_LART_H_\x0a"
"", 9023 ); }