#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_sys_metadata_h( 
"#ifndef _SYS_METADATA_H\x0a"
"#define _SYS_METADATA_H\x0a"
"\x0a"
"#include <sys/divm.h>\x0a"
"#include <dios.h>\x0a"
"#include <stdint.h>\x0a"
"#include <sys/cdefs.h>\x0a"
"\x0a"
"#define _ROOT __attribute__((__annotate__(\x22""divine.link.always\x22)))\x0a"
"\x0a"
"__BEGIN_DECLS\x0a"
"\x0a"
"/*\x0a"
" * This file contains the structures used for introspection.\x0a"
" * They are generated by LART pass \x60IndexFunctions\x60 over at\x0a"
" * \x60lart/divine/functionmeta.cpp\x60.\x0a"
" * - _MD_InstInfo - a single LLVM instruction\x0a"
" * - _MD_Function - a function\x0a"
" * - _MD_RegInfo - an LLVM register (stored in a function frame)\x0a"
" * - _MD_Global - a global variable\x0a"
" * Functions stored in \x60__md_functions\x60 array of size \x60__md_functions_count\x60.\x0a"
" * Globals stored in \x60__md_globals\x60 array of size \x60__md_globals_count\x60.\x0a"
" *\x0a"
" * Several DiOS systems (scheduling, stack management, exception handling\x0a"
" * support) depend on this system. For more information see \x60README\x60.\x0a"
" */\x0a"
"\x0a"
"typedef struct\x0a"
"{\x0a"
"    /* LLVM instruction opcode (use divine/opcodes.h, enum OpCode to decode) */\x0a"
"    int opcode;\x0a"
"    /* suboperation for cmp, armw, and ivoke (in case of invoke it is the\x0a"
"     * offset of landing block from the beginning of the function (that is,\x0a"
"     * instruction index of landing block)) */\x0a"
"    int subop;\x0a"
"    /* offset of return value in frame, do not use directly, use\x0a"
"     * __md_get_register_info instead */\x0a"
"    int val_offset;\x0a"
"    /* width of return value in frame, do not use directly, use\x0a"
"     * __md_get_register_info instead */\x0a"
"    int val_width;\x0a"
"} _MD_InstInfo;\x0a"
"\x0a"
"typedef struct\x0a"
"{\x0a"
"    char *name;\x0a"
"    void (*entry_point)( void );\x0a"
"    int frame_size;\x0a"
"    int arg_count;\x0a"
"    int is_variadic;\x0a"
"    char *type; /* similar to Itanium ABI mangle, first return type, then\x0a"
"                *  arguments, all pointers are under p, all integers except for\x0a"
"                *  char are set as unsigned, all chars are 'c' (char) */\x0a"
"    int inst_table_size;\x0a"
"    _MD_InstInfo *inst_table;\x0a"
"    void (*ehPersonality)( void ); /* language-specific personality routine */\x0a"
"    void *ehLSDA; /* language-specific exception handling tables */\x0a"
"    int is_nounwind; /* nounwind functions never raise an exception */\x0a"
"    int is_trap; /* trap functions can trap into the kernel */\x0a"
"} _MD_Function;\x0a"
"\x0a"
"typedef struct\x0a"
"{\x0a"
"    void *start;\x0a"
"    int width;\x0a"
"} _MD_RegInfo;\x0a"
"\x0a"
"typedef struct\x0a"
"{\x0a"
"    char *name;\x0a"
"    void *address;\x0a"
"    long size;\x0a"
"    int is_constant;\x0a"
"} _MD_Global;\x0a"
"\x0a"
"/* Query function metadata by function name, this is the mangled name in case\x0a"
" * of C++ or other languages which employ name mangling */\x0a"
"// const _MD_Function *__md_get_function_meta( const char *name ) NOTHROW _ROOT;\x0a"
"\x0a"
"/* Query function metadata program counter value */\x0a"
"const _MD_Function *__md_get_pc_meta( _VM_CodePointer pc ) __nothrow _ROOT;\x0a"
"\x0a"
"/* Given function frame, program counter and metadata extracts pointer to\x0a"
" * register corresponding to instruction with given PC from the frame.\x0a"
" *\x0a"
" * If the PC is out of range, or any argument is invalid return { nullptr, 0 },\x0a"
" * while for void values (registers of instructions which do no return) returns\x0a"
" * { ptr-somewhere-to-the-frame, 0 }.\x0a"
" *\x0a"
" * Be aware that registers can be reused/overlapping if they do not interfere\x0a"
" * or are guaranteed to have same value any time they are both defined in a\x0a"
" * valid run.\x0a"
" * Examples of safe use\x3a\x0a"
" * * writing landingpad's register before jumping to the instruction after the\x0a"
" *   landingpad\x0a"
" * * reading register of value of call/invoke\x0a"
" * */\x0a"
"_MD_RegInfo __md_get_register_info( struct _VM_Frame *frame, _VM_CodePointer pc,\x0a"
"                                    const _MD_Function *funMeta ) __nothrow _ROOT;\x0a"
"\x0a"
"const _MD_Global *__md_get_global_meta( const char *name ) __nothrow _ROOT;\x0a"
"\x0a"
"__END_DECLS\x0a"
"\x0a"
"#undef _ROOT\x0a"
"\x0a"
"#endif\x0a"
"", 3633 ); }