#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_sys_resource_h( 
"/*\x0a"
" * Copyright (c) 1982, 1986, 1993\x0a"
" *\x09The Regents of the University of California.  All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" * 3. Neither the name of the University nor the names of its contributors\x0a"
" *    may be used to endorse or promote products derived from this software\x0a"
" *    without specific prior written permission.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" *\x0a"
" *\x09\x40(#)resource.h\x09""8.2 (Berkeley) 1/4/94\x0a"
" */\x0a"
"\x0a"
"\x0a"
"#ifndef _SYS_RESOURCE_H_\x0a"
"#define\x09_SYS_RESOURCE_H_\x0a"
"\x0a"
"#include <sys/time.h>\x0a"
"#include <sys/types.h>\x0a"
"#include <_PDCLIB/cdefs.h>\x0a"
"\x0a"
"/*\x0a"
" * Process priority specifications to get/setpriority.\x0a"
" */\x0a"
"#define\x09PRIO_MIN\x09(-20)\x0a"
"#define\x09PRIO_MAX\x09""20\x0a"
"\x0a"
"#define\x09PRIO_PROCESS\x09""0\x0a"
"#define\x09PRIO_PGRP\x09""1\x0a"
"#define\x09PRIO_USER\x09""2\x0a"
"\x0a"
"/*\x0a"
" * Resource utilization information.\x0a"
" */\x0a"
"\x0a"
"#define\x09RUSAGE_SELF\x09""0\x0a"
"#define\x09RUSAGE_CHILDREN\x09(-1)\x0a"
"#define\x09RUSAGE_THREAD\x09""1\x0a"
"\x0a"
"typedef __uint64_t rlim_t;\x0a"
"typedef __uint32_t id_t;\x0a"
"\x0a"
"struct\x09rusage {\x0a"
"\x09struct timeval ru_utime;\x09/* user time used */\x0a"
"\x09struct timeval ru_stime;\x09/* system time used */\x0a"
"\x09long\x09ru_maxrss;\x09\x09/* max resident set size */\x0a"
"#define\x09ru_first\x09ru_ixrss\x0a"
"\x09long\x09ru_ixrss;\x09\x09/* integral shared text memory size */\x0a"
"\x09long\x09ru_idrss;\x09\x09/* integral unshared data \x22 */\x0a"
"\x09long\x09ru_isrss;\x09\x09/* integral unshared stack \x22 */\x0a"
"\x09long\x09ru_minflt;\x09\x09/* page reclaims */\x0a"
"\x09long\x09ru_majflt;\x09\x09/* page faults */\x0a"
"\x09long\x09ru_nswap;\x09\x09/* swaps */\x0a"
"\x09long\x09ru_inblock;\x09\x09/* block input operations */\x0a"
"\x09long\x09ru_oublock;\x09\x09/* block output operations */\x0a"
"\x09long\x09ru_msgsnd;\x09\x09/* messages sent */\x0a"
"\x09long\x09ru_msgrcv;\x09\x09/* messages received */\x0a"
"\x09long\x09ru_nsignals;\x09\x09/* signals received */\x0a"
"\x09long\x09ru_nvcsw;\x09\x09/* voluntary context switches */\x0a"
"\x09long\x09ru_nivcsw;\x09\x09/* involuntary \x22 */\x0a"
"#define\x09ru_last\x09\x09ru_nivcsw\x0a"
"};\x0a"
"\x0a"
"/*\x0a"
" * Resource limits\x0a"
" */\x0a"
"#define RLIMIT_CPU      _HOST_RLIMIT_CPU      /* cpu time in milliseconds */\x0a"
"#define RLIMIT_FSIZE    _HOST_RLIMIT_FSIZE    /* maximum file size */\x0a"
"#define RLIMIT_DATA     _HOST_RLIMIT_DATA     /* data size */\x0a"
"#define RLIMIT_STACK    _HOST_RLIMIT_STACK    /* stack size */\x0a"
"#define RLIMIT_CORE     _HOST_RLIMIT_CORE     /* core file size */\x0a"
"#define RLIMIT_RSS      _HOST_RLIMIT_RSS      /* resident set size */\x0a"
"#define RLIMIT_MEMLOCK  _HOST_RLIMIT_MEMLOCK  /* locked-in-memory address space */\x0a"
"#define RLIMIT_NPROC    _HOST_RLIMIT_NPROC    /* number of processes */\x0a"
"#define RLIMIT_NOFILE   _HOST_RLIMIT_NOFILE   /* number of open files */\x0a"
"\x0a"
"#define RLIM_NLIMITS    _HOST_RLIM_NLIMITS    /* number of resource limits */\x0a"
"\x0a"
"#define\x09RLIM_INFINITY\x09(((rlim_t)1 << 63) - 1)\x0a"
"#define\x09RLIM_SAVED_MAX\x09RLIM_INFINITY\x0a"
"#define\x09RLIM_SAVED_CUR\x09RLIM_INFINITY\x0a"
"\x0a"
"struct rlimit {\x0a"
"\x09rlim_t\x09rlim_cur;\x09\x09/* current (soft) limit */\x0a"
"\x09rlim_t\x09rlim_max;\x09\x09/* maximum value for rlim_cur */\x0a"
"};\x0a"
"\x0a"
"#if __BSD_VISIBLE\x0a"
"/* Load average structure. */\x0a"
"struct loadavg {\x0a"
"\x09""fixpt_t\x09ldavg\x5b""3\x5d;\x0a"
"\x09long\x09""fscale;\x0a"
"};\x0a"
"#endif /* __BSD_VISIBLE */\x0a"
"\x0a"
"_PDCLIB_EXTERN_C\x0a"
"int\x09getpriority(int, id_t);\x0a"
"int\x09getrlimit(int, struct rlimit *);\x0a"
"int\x09getrusage(int, struct rusage *);\x0a"
"int\x09setpriority(int, id_t, int);\x0a"
"int\x09setrlimit(int, const struct rlimit *);\x0a"
"_PDCLIB_EXTERN_END\x0a"
"\x0a"
"#endif\x09/* \x21_SYS_RESOURCE_H_ */\x0a"
"", 4249 ); }