#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_sys_thread_h( 
"// -*- C++ -*- (c) 2013 Milan Lenco <lencomilan\x40gmail.com>\x0a"
"//             (c) 2014-2018 Vladim\xc3\xadr \xc5\xa0till <xstill\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Henrich Lauko <xlauko\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"/* Includes */\x0a"
"#include <pthread.h>\x0a"
"#include <sys/divm.h>\x0a"
"#include <sys/interrupt.h>\x0a"
"#include <sys/start.h>\x0a"
"#include <sys/fault.h>\x0a"
"#include <assert.h>\x0a"
"#include <errno.h>\x0a"
"#include <limits.h>\x0a"
"#include <signal.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"#include <dios.h>\x0a"
"\x0a"
"#pragma GCC diagnostic push\x0a"
"#pragma GCC diagnostic ignored \x22-Wgcc-compat\x22\x0a"
"\x0a"
"/* MILLIARD defines a maximal threshold for time arguments\x0a"
" * of pthread waiting functions. */\x0a"
"#define MILLIARD 1000000000\x0a"
"\x0a"
"// bit masks\x0a"
"#define _THREAD_ATTR_DETACH_MASK 0x1\x0a"
"#define _MUTEX_ATTR_TYPE_MASK 0x3\x0a"
"#define _RWLOCK_ATTR_SHARING_MASK 0x1\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"struct CleanupHandler\x0a"
"{\x0a"
"    void ( *routine )( void * );\x0a"
"    void *arg;\x0a"
"    CleanupHandler *next;\x0a"
"};\x0a"
"\x0a"
"/* SleepingOn state keeps track on what primitive the thread was put to sleep */\x0a"
"enum SleepingOn { NotSleeping = 0, Condition, Barrier };\x0a"
"\x0a"
"/* The entry point for thread holds its start routine \x60""entry\x60 and\x0a"
" * arguments \x60""arg\x60 that are passed to it.\x0a"
" *\x0a"
" * The new thread starts execution by invoking entry;\x0a"
" * arg is passed as the sole argument of entry().\x0a"
" **/\x0a"
"struct Entry\x0a"
"{\x0a"
"    void *( *entry )( void * );\x0a"
"    void *arg;\x0a"
"};\x0a"
"\x0a"
"} // namespace __dios\x0a"
"\x0a"
"/* _PThread maintains user-space information about an existing POSIX thread.\x0a"
" * It is not directly used/created by a user, instead _PThread is wrapped by\x0a"
" * _PthreadTLS which is further used as pthread_t, see below. _PThread just\x0a"
" * keeps following information about thread\x3a\x0a"
" *\x0a"
" * entry/result\x3a\x0a"
" *  entry point of the thread is maintained as \x60__dios\x3a\x3a""Entry\x60, which shares\x0a"
" *  place with the result of the thread.\x0a"
" *\x0a"
" * state flags\x3a thread keeps track of its state, with multiple flags\x0a"
" *  1. started\x3a is set by __pthread_start\x0a"
" *\x0a"
" *  2. running\x3a is set by __pthread_init\x0a"
" *\x0a"
" *  3. detached\x3a is set by pthread_detach.\x0a"
" *     When a detached thread terminates, its resources are automatically\x0a"
" *     released back to the system without the need for another thread\x0a"
" *     to join with the terminated thread.\x0a"
" *\x0a"
" *  4. sleeping\x3a holds what primitive put the thread to sleep\x0a"
" *   - can be changed using a setSleeping method\x0a"
" *\x0a"
" *  5. cancelled\x3a\x0a"
" *   - \x60""cancel_state\x60 holds whether cancelation is enabled\x0a"
" *   - \x60""cancel_type\x60 holds is either PTHREAD_CANCEL_DEFERRED\x0a"
" *                                or PTHREAD_CANCEL_ASYNCHRONOUS\x0a"
" *\x0a"
" *  6. is_main\x3a holds whether the entry point is main, the main thread\x0a"
" *     waits until all its threads terminates\x0a"
" *\x0a"
" *  7. deadlocked\x3a to detect deadlock on mutex,\x0a"
" *     if true pruduces fault _VM_F_Locking\x0a"
" *\x0a"
" * condition/barrier\x3a\x0a"
" *  holds a primitive that put the thread to sleep state\x0a"
" *\x0a"
" * mutex\x3a\x0a"
" *  the thread holds a pointer to a mutex on which it is waiting to detect\x0a"
" *  cyclic dependencies (deadlock)\x0a"
" * XXX refcounted\x3a\x0a"
" *  \x60refcnf\x60 holds number of references to this thread. When the reference\x0a"
" *  count drops to zero, _PThread frees its memory. To decrease/increase\x0a"
" *  the reference count use dedicated functions acquireThread/releaseThread.\x0a"
" *\x0a"
" */\x0a"
"struct _PThread\x0a"
"{\x0a"
"    _PThread() noexcept\x0a"
"    {\x0a"
"        memset( this, 0, sizeof( _PThread ) );\x0a"
"        ++refcnt;\x0a"
"    }\x0a"
"\x0a"
"    static void* operator new( size_t s ) noexcept { return __vm_obj_make( s, _VM_PT_Heap ); }\x0a"
"    static void operator delete( void *p ) noexcept { return __vm_obj_free( p ); }\x0a"
"\x0a"
"    /* avoid accidental copies */\x0a"
"    _PThread( const _PThread \x26 ) = delete;\x0a"
"    _PThread( _PThread \x26\x26 ) = delete;\x0a"
"\x0a"
"    \x7e_PThread()\x0a"
"    {\x0a"
"        if ( \x21started )\x0a"
"            __vm_obj_free( entry );\x0a"
"    }\x0a"
"\x0a"
"    /* entry point for thread and place for its result */\x0a"
"    union\x0a"
"    {\x0a"
"        void *result;\x0a"
"        __dios\x3a\x3a""Entry *entry;\x0a"
"    };\x0a"
"\x0a"
"    /* used when thread waits for mutex\x0a"
"     *\x0a"
"     * waiting_mutex is used in detection of deadlock (see pthread-mutex.cpp)\x0a"
"     * */\x0a"
"    pthread_mutex_t *waiting_mutex;\x0a"
"\x0a"
"    /* cleanup handlers linked-list */\x0a"
"    __dios\x3a\x3a""CleanupHandler *cleanup_handlers;\x0a"
"\x0a"
"    /* used when thread sleeps on condition/barrier */\x0a"
"    union {\x0a"
"        pthread_cond_t *condition;\x0a"
"        pthread_barrier_t *barrier;\x0a"
"    };\x0a"
"\x0a"
"    /* state flags */\x0a"
"    bool started \x3a 1;\x0a"
"    bool running \x3a 1;\x0a"
"    bool detached \x3a 1;\x0a"
"    __dios\x3a\x3aSleepingOn sleeping \x3a 2;\x0a"
"    bool cancelled \x3a 1;\x0a"
"\x0a"
"    bool cancel_state \x3a 1;\x0a"
"    bool cancel_type \x3a 1;\x0a"
"    bool is_main \x3a 1;\x0a"
"    bool deadlocked \x3a 1;\x0a"
"\x0a"
"    /* reference count */\x0a"
"    uint32_t refcnt;\x0a"
"\x0a"
"    /* sleep state modifiers */\x0a"
"    void setSleeping( pthread_cond_t *cond ) noexcept {\x0a"
"        sleeping = __dios\x3a\x3a""Condition;\x0a"
"        condition = cond;\x0a"
"    }\x0a"
"\x0a"
"    void setSleeping( pthread_barrier_t *bar ) noexcept {\x0a"
"        sleeping = __dios\x3a\x3a""Barrier;\x0a"
"        barrier = bar;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"void __pthread_atfork_fini() noexcept;\x0a"
"void __pthread_tls_fini() noexcept;\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"static_assert( sizeof( _PThread ) == 5 * sizeof( void * ) );\x0a"
"\x0a"
"/* A container of PthreadHandlers used to hold TLS destructors or ForkHandlers. */\x0a"
"template< typename Handler >\x0a"
"struct _PthreadHandlers\x0a"
"{\x0a"
"    _PthreadHandlers() noexcept = default;\x0a"
"    _PthreadHandlers( const _PthreadHandlers \x26 ) noexcept = delete;\x0a"
"    _PthreadHandlers( _PthreadHandlers \x26\x26 ) noexcept = delete;\x0a"
"\x0a"
"    void fini() noexcept\x0a"
"    {\x0a"
"        if ( _dtors )\x0a"
"            __vm_obj_free( _dtors );\x0a"
"    }\x0a"
"\x0a"
"    int count() noexcept\x0a"
"    {\x0a"
"        return __vm_obj_size( _dtors ) / sizeof( Handler );\x0a"
"    }\x0a"
"\x0a"
"    int getFirstAvailable() noexcept {\x0a"
"        int k = -1;\x0a"
"        int c = count();\x0a"
"        for ( int i = 0; i < c; ++i )\x0a"
"            if ( \x21_dtors\x5b i \x5d )\x0a"
"            {\x0a"
"                k = i;\x0a"
"                break;\x0a"
"            }\x0a"
"\x0a"
"        if ( k < 0 ) {\x0a"
"            k = c;\x0a"
"            __vm_obj_resize( _dtors, sizeof( Handler ) * (k + 1) );\x0a"
"        }\x0a"
"        return k;\x0a"
"    }\x0a"
"\x0a"
"    void shrink() noexcept\x0a"
"    {\x0a"
"        int toDrop = 0;\x0a"
"        int c = count();\x0a"
"\x0a"
"        for ( int i = c - 1; i >= 0; --i )\x0a"
"        {\x0a"
"            if ( \x21_dtors\x5b i \x5d )\x0a"
"                ++ toDrop;\x0a"
"            else\x0a"
"                break;\x0a"
"        }\x0a"
"\x0a"
"        int newsz = c - toDrop;\x0a"
"        if ( newsz < 1 ) newsz = 1;\x0a"
"\x0a"
"        if ( toDrop )\x0a"
"            __vm_obj_resize( _dtors, newsz * sizeof( Handler ) );\x0a"
"    }\x0a"
"\x0a"
"    void init() noexcept\x0a"
"    {\x0a"
"        if ( \x21_dtors )\x0a"
"            // placeholder so that resize works\x0a"
"            _dtors = static_cast< Handler * >( __vm_obj_make( 1, _VM_PT_Heap ) );\x0a"
"    }\x0a"
"\x0a"
"    Handler \x26operator\x5b\x5d( size_t x ) noexcept { return _dtors\x5b x \x5d; }\x0a"
"    Handler *_dtors;\x0a"
"};\x0a"
"\x0a"
"/* destructor handle used in _PthreadHandlers */\x0a"
"using Destructor = void (*)( void * );\x0a"
"\x0a"
"struct ForkHandler\x0a"
"{\x0a"
"    void (*prepare)();\x0a"
"    void (*parent)();\x0a"
"    void (*child)();\x0a"
"    bool operator\x21() const { return \x21prepare \x26\x26 \x21parent \x26\x26 \x21""child; }\x0a"
"};\x0a"
"\x0a"
"using _PthreadAtFork = _PthreadHandlers< ForkHandler >;\x0a"
"\x0a"
"/* _PthreadTLS holds pthread_t data of thread (see pthread documentation)\x3a\x0a"
" *\x0a"
" *  pointer to thread data _PThread\x60\x0a"
" *  pointer to thread local storage \x60keys\x60\x0a"
" *\x0a"
" *  implementation is located in \x60libc/pthread/pthread-tls.cpp\x60\x0a"
" */\x0a"
"struct _PthreadTLS\x0a"
"{\x0a"
"    _PthreadTLS( const _PthreadTLS \x26 ) noexcept = delete;\x0a"
"    _PthreadTLS( _PthreadTLS \x26\x26 ) noexcept = delete;\x0a"
"\x0a"
"    _PThread *thread;\x0a"
"    void *keys\x5b""0\x5d;\x0a"
"\x0a"
"    void *raw() noexcept;\x0a"
"    static int raw_size( int cnt ) noexcept {\x0a"
"        return sizeof( __dios_tls ) + sizeof( _PThread * ) + cnt * sizeof( void * );\x0a"
"    }\x0a"
"\x0a"
"    /* size of keys array */\x0a"
"    int keyCount() noexcept;\x0a"
"\x0a"
"    /* resize keys array to \x60""count\x60 size and initialize it by nullptr */\x0a"
"    void makeFit( int count ) noexcept;\x0a"
"\x0a"
"    /* deletes nullptr keys from the back of the keys array */\x0a"
"    void shrink() noexcept;\x0a"
"\x0a"
"    /* returns keys\x5b key \x5d if exists else nullptr\x0a"
"     *\x0a"
"     * requires key >= 0 and key < tlsDestructor.count */\x0a"
"    void *getKey( int key ) noexcept;\x0a"
"\x0a"
"    /* associates value to key\x0a"
"     *\x0a"
"     * if key is higher than keyCount, extends keys array\x0a"
"     * if value is nullptr then shinks keys if possible\x0a"
"     *\x0a"
"     * requires key >= 0 and key < tlsDestructor.count */\x0a"
"    void setKey( int key, const void *value ) noexcept;\x0a"
"\x0a"
"    /* calls destructor on value associated with key */\x0a"
"    void destroy( int key ) noexcept;\x0a"
"};\x0a"
"\x0a"
"/* extract thread data from dios task */\x0a"
"static inline _PthreadTLS \x26tls( __dios_task tid ) noexcept\x0a"
"{\x0a"
"    return *reinterpret_cast< _PthreadTLS * >( \x26( tid->__data ) );\x0a"
"}\x0a"
"\x0a"
"/* TODO\x3a conversion functions\x3a\x0a"
" * __dios_task get_task( pthread_t tid );\x0a"
" * pthread_t get_tid( __dios_task task );\x0a"
" * for now left as identities, we possibly want a hypercall\x0a"
" * */\x0a"
"static inline pthread_t get_task( pthread_t tid ) { return tid; }\x0a"
"static inline __dios_task get_tid( __dios_task task ) { return task; }\x0a"
"\x0a"
"static inline _PThread \x26getThread( __dios_task tid ) noexcept\x0a"
"{\x0a"
"    return *tls( tid ).thread;\x0a"
"}\x0a"
"\x0a"
"/* TODO\x3a\x0a"
"static inline _PThread \x26getThread( pthread_t tid ) noexcept\x0a"
"{\x0a"
"    return getThread( get_task( tid ) );\x0a"
"}\x0a"
"*/\x0a"
"\x0a"
"static inline _PThread \x26getThread() noexcept\x0a"
"{\x0a"
"    return getThread( __dios_this_task() );\x0a"
"}\x0a"
"\x0a"
"/* reference modifiers for thread */\x0a"
"static inline void acquireThread( _PThread \x26thread )\x0a"
"{\x0a"
"    ++thread.refcnt;\x0a"
"}\x0a"
"\x0a"
"static inline void releaseThread( _PThread \x26thread )\x0a"
"{\x0a"
"    --thread.refcnt;\x0a"
"    if ( thread.refcnt == 0 )\x0a"
"        __vm_obj_free( \x26thread );\x0a"
"}\x0a"
"\x0a"
"static inline void releaseAndKillThread( __dios_task tid )\x0a"
"{\x0a"
"    auto \x26thread = getThread( tid );\x0a"
"    if ( thread.refcnt \x21= 1 )\x0a"
"        __dios_trace_t( \x22warning\x3a thread terminated while holding a lock\x22 );\x0a"
"    releaseThread( thread );\x0a"
"    __dios_kill( tid );\x0a"
"}\x0a"
"\x0a"
"template< typename Yield >\x0a"
"static void iterateThreads( Yield yield ) noexcept\x0a"
"{\x0a"
"    auto *threads = __dios_this_process_tasks();\x0a"
"    int cnt = __vm_obj_size( threads ) / sizeof( __dios_task );\x0a"
"    for ( int i = 0; i < cnt; ++i )\x0a"
"        yield( threads\x5b i \x5d );\x0a"
"    __vm_obj_free( threads );\x0a"
"}\x0a"
"\x0a"
"int _mutex_lock( __dios\x3a\x3a""FencedInterruptMask \x26mask, pthread_mutex_t *mutex, bool wait ) noexcept;\x0a"
"void __init_thread( const __dios_task gtid, const pthread_attr_t attr ) noexcept;\x0a"
"_Noreturn void _clean_and_become_zombie( __dios\x3a\x3a""FencedInterruptMask \x26mask, __dios_task tid ) noexcept;\x0a"
"\x0a"
"template < typename Cond >\x0a"
"__attribute__( ( __always_inline__, __flatten__ ) )\x0a"
"static void wait( __dios\x3a\x3a""FencedInterruptMask \x26mask, Cond cond ) noexcept\x0a"
"{\x0a"
"    if ( cond() )\x0a"
"        mask.without( \x5b\x5d{ __dios_reschedule(); } );\x0a"
"    if ( cond() )\x0a"
"        __vm_cancel();\x0a"
"}\x0a"
"\x0a"
"static bool _canceled() noexcept {\x0a"
"    return getThread().cancelled;\x0a"
"}\x0a"
"\x0a"
"void _cancel( __dios\x3a\x3a""FencedInterruptMask \x26mask ) noexcept;\x0a"
"\x0a"
"template < typename Cond >\x0a"
"__attribute__( ( __always_inline__, __flatten__ ) )\x0a"
"static void waitOrCancel( __dios\x3a\x3a""FencedInterruptMask \x26mask, Cond cond ) noexcept\x0a"
"{\x0a"
"    if ( _canceled() )\x0a"
"        _cancel( mask );\x0a"
"    else\x0a"
"        wait( mask, cond );\x0a"
"}\x0a"
"\x0a"
"template < typename CondOrBarrier > int _cond_adjust_count( CondOrBarrier *cond, int adj ) noexcept\x0a"
"{\x0a"
"    int count = cond->__counter;\x0a"
"    count += adj;\x0a"
"    assert( count < ( 1 << 16 ) );\x0a"
"    assert( count >= 0 );\x0a"
"\x0a"
"    cond->__counter = count;\x0a"
"    return count;\x0a"
"}\x0a"
"\x0a"
"template < typename CondOrBarrier > int _destroy_cond_or_barrier( CondOrBarrier *cond ) noexcept\x0a"
"{\x0a"
"    if ( cond == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    // make sure that no thread is waiting on this condition\x0a"
"    // (probably better alternative when compared to\x3a return EBUSY)\x0a"
"    assert( cond->__counter == 0 );\x0a"
"\x0a"
"    CondOrBarrier uninit;\x0a"
"    *cond = uninit;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"template < typename > static inline SleepingOn _sleepCond() noexcept;\x0a"
"template <> inline SleepingOn _sleepCond< pthread_barrier_t >() noexcept {\x0a"
"    return Barrier;\x0a"
"}\x0a"
"template <> inline SleepingOn _sleepCond< pthread_cond_t >() noexcept {\x0a"
"    return Condition;\x0a"
"}\x0a"
"\x0a"
"static inline bool _eqSleepTrait( _PThread \x26t, pthread_cond_t *cond ) noexcept {\x0a"
"    return t.condition == cond;\x0a"
"}\x0a"
"\x0a"
"static inline bool _eqSleepTrait( _PThread \x26t, pthread_barrier_t *bar ) noexcept\x0a"
"{\x0a"
"    return t.barrier == bar;\x0a"
"}\x0a"
"\x0a"
"template< bool broadcast, typename CondOrBarrier >\x0a"
"static int _cond_signal( CondOrBarrier *cond ) noexcept\x0a"
"{\x0a"
"    if ( cond == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    int count = cond->__counter;\x0a"
"    if ( count ) { // some threads are waiting for condition\x0a"
"        int waiting = 0, wokenup = 0, choice;\x0a"
"\x0a"
"        if ( \x21""broadcast ) {\x0a"
"            /* non-determinism */\x0a"
"            choice = __vm_choose( ( 1 << count ) - 1 );\x0a"
"        }\x0a"
"\x0a"
"        iterateThreads( \x5b\x26\x5d( __dios_task tid ) {\x0a"
"\x0a"
"            _PThread \x26thread = getThread( tid );\x0a"
"\x0a"
"            if ( thread.sleeping == _sleepCond< CondOrBarrier >() \x26\x26 _eqSleepTrait( thread, cond ) ) {\x0a"
"                ++waiting;\x0a"
"                if ( broadcast \x7c\x7c ( ( choice + 1 ) \x26 ( 1 << ( waiting - 1 ) ) ) ) {\x0a"
"                    // wake up the thread\x0a"
"                    thread.sleeping = NotSleeping;\x0a"
"                    thread.condition = NULL;\x0a"
"                    ++wokenup;\x0a"
"                }\x0a"
"            }\x0a"
"        } );\x0a"
"\x0a"
"        assert( count == waiting );\x0a"
"\x0a"
"        _cond_adjust_count( cond, -wokenup );\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"}\x0a"
"\x0a"
"#pragma GCC diagnostic pop\x0a"
"", 13008 ); }