#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_sys_wait_h( 
"/*\x09\x24OpenBSD\x3a wait.h,v 1.17 2014/06/13 22\x3a""40\x3a""31 matthew Exp \x24\x09*/\x0a"
"/*\x09\x24NetBSD\x3a wait.h,v 1.11 1996/04/09 20\x3a""55\x3a""51 cgd Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 1982, 1986, 1989, 1993, 1994\x0a"
" *\x09The Regents of the University of California.  All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" * 3. Neither the name of the University nor the names of its contributors\x0a"
" *    may be used to endorse or promote products derived from this software\x0a"
" *    without specific prior written permission.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" *\x0a"
" *\x09\x40(#)wait.h\x09""8.2 (Berkeley) 7/10/94\x0a"
" */\x0a"
"\x0a"
"#ifndef _SYS_WAIT_H_\x0a"
"#define _SYS_WAIT_H_\x0a"
"\x0a"
"#include <sys/cdefs.h>\x0a"
"#include <sys/resource.h>\x0a"
"#include <sys/types.h>\x0a"
"#include <_PDCLIB/cdefs.h>\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"extern \x22""C\x22 {\x0a"
"#endif\x0a"
"\x0a"
"/*\x0a"
" * This file holds definitions relevant to the wait4 system call\x0a"
" * and the alternate interfaces that use it (wait, wait3, waitpid).\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * Macros to test the exit status returned by wait\x0a"
" * and extract the relevant values.\x0a"
" */\x0a"
"#define\x09_WSTATUS(x)\x09((x) \x26 0177)\x0a"
"#define\x09_WSTOPPED\x09""0177\x09\x09/* _WSTATUS if process is stopped */\x0a"
"#define\x09_WCONTINUED\x09""0177777\x09\x09/* process has continued */\x0a"
"#define WIFSTOPPED(x)\x09(((x) \x26 0xff) == _WSTOPPED)\x0a"
"#define WSTOPSIG(x)\x09(int)(((unsigned)(x) >> 8) \x26 0xff)\x0a"
"#define WIFSIGNALED(x)\x09(_WSTATUS(x) \x21= _WSTOPPED \x26\x26 _WSTATUS(x) \x21= 0)\x0a"
"#define WTERMSIG(x)\x09(_WSTATUS(x))\x0a"
"#define WIFEXITED(x)\x09(_WSTATUS(x) == 0)\x0a"
"#define WEXITSTATUS(x)\x09(int)(((unsigned)(x) >> 8) \x26 0xff)\x0a"
"#define WIFCONTINUED(x)\x09(((x) \x26 _WCONTINUED) == _WCONTINUED)\x0a"
"#if __XPG_VISIBLE\x0a"
"#define\x09WCOREFLAG\x09""0200\x0a"
"#define WCOREDUMP(x)\x09((x) \x26 WCOREFLAG)\x0a"
"\x0a"
"#define\x09W_EXITCODE(ret, sig)\x09((ret) << 8 \x7c (sig))\x0a"
"#define\x09W_STOPCODE(sig)\x09\x09((sig) << 8 \x7c _WSTOPPED)\x0a"
"#endif\x0a"
"\x0a"
"/*\x0a"
" * Option bits for the third argument of wait4.  WNOHANG causes the\x0a"
" * wait to not hang if there are no stopped or terminated processes, rather\x0a"
" * returning an error indication in this case (pid==0).  WUNTRACED\x0a"
" * indicates that the caller should receive status about untraced children\x0a"
" * which stop due to signals.  If children are stopped and a wait without\x0a"
" * this option is done, it is as though they were still running... nothing\x0a"
" * about them is returned.\x0a"
" */\x0a"
"#define WNOHANG\x09\x09""1\x09/* don't hang in wait */\x0a"
"#define WUNTRACED\x09""2\x09/* tell about stopped, untraced children */\x0a"
"#define\x09WCONTINUED\x09""8\x09/* report a job control continued process */\x0a"
"\x0a"
"#if __BSD_VISIBLE\x0a"
"/*\x0a"
" * Tokens for special values of the \x22pid\x22 parameter to wait4.\x0a"
" */\x0a"
"#define\x09WAIT_ANY\x09(-1)\x09/* any process */\x0a"
"#define\x09WAIT_MYPGRP\x09""0\x09/* any process in my process group */\x0a"
"#endif /* __BSD_VISIBLE */\x0a"
"\x0a"
"_PDCLIB_EXTERN_C\x0a"
"struct rusage;\x09/* forward declaration */\x0a"
"\x0a"
"pid_t\x09wait(int *) __nothrow;\x0a"
"pid_t\x09waitpid(pid_t, int *, int) __nothrow;\x0a"
"#if __BSD_VISIBLE\x0a"
"pid_t\x09wait3(int *, int, struct rusage *) __nothrow;\x0a"
"pid_t\x09wait4(pid_t, int *, int, struct rusage *) __nothrow;\x0a"
"#endif /* __BSD_VISIBLE */\x0a"
"_PDCLIB_EXTERN_END\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"} // extern \x22""C\x22\x0a"
"#endif\x0a"
"#endif // __SYS_WAIT_H__\x0a"
"", 4137 ); }