#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_syslog_h( 
"/*\x09\x24OpenBSD\x3a syslog.h,v 1.16 2017/08/08 14\x3a""23\x3a""23 bluhm Exp \x24\x09*/\x0a"
"/*\x09\x24NetBSD\x3a syslog.h,v 1.14 1996/04/03 20\x3a""46\x3a""44 christos Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 1982, 1986, 1988, 1993\x0a"
" *\x09The Regents of the University of California.  All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" * 3. Neither the name of the University nor the names of its contributors\x0a"
" *    may be used to endorse or promote products derived from this software\x0a"
" *    without specific prior written permission.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" *\x0a"
" *\x09\x40(#)syslog.h\x09""8.1 (Berkeley) 6/2/93\x0a"
" */\x0a"
"\x0a"
"#ifndef _SYS_SYSLOG_H_\x0a"
"#define _SYS_SYSLOG_H_\x0a"
"\x0a"
"#define\x09_PATH_LOG\x09\x22/dev/log\x22\x0a"
"\x0a"
"#define\x09LIOCSFD\x09\x09_IOW('l', 127, int)\x09/* set sendsyslog() fd */\x0a"
"\x0a"
"#define LOG_MAXLINE\x09""8192\x09\x09\x09/* maximum line length */\x0a"
"\x0a"
"/*\x0a"
" * priorities/facilities are encoded into a single 32-bit quantity, where the\x0a"
" * bottom 3 bits are the priority (0-7) and the top 28 bits are the facility\x0a"
" * (0-big number).  Both the priorities and the facilities map roughly\x0a"
" * one-to-one to strings in the syslogd(8) source code.  This mapping is\x0a"
" * included in this file.\x0a"
" *\x0a"
" * priorities (these are ordered)\x0a"
" */\x0a"
"#define\x09LOG_EMERG\x09""0\x09/* system is unusable */\x0a"
"#define\x09LOG_ALERT\x09""1\x09/* action must be taken immediately */\x0a"
"#define\x09LOG_CRIT\x09""2\x09/* critical conditions */\x0a"
"#define\x09LOG_ERR\x09\x09""3\x09/* error conditions */\x0a"
"#define\x09LOG_WARNING\x09""4\x09/* warning conditions */\x0a"
"#define\x09LOG_NOTICE\x09""5\x09/* normal but significant condition */\x0a"
"#define\x09LOG_INFO\x09""6\x09/* informational */\x0a"
"#define\x09LOG_DEBUG\x09""7\x09/* debug-level messages */\x0a"
"\x0a"
"#define\x09LOG_PRIMASK\x09""0x07\x09/* mask to extract priority part (internal) */\x0a"
"\x09\x09\x09\x09/* extract priority */\x0a"
"#define\x09LOG_PRI(p)\x09((p) \x26 LOG_PRIMASK)\x0a"
"\x0a"
"#ifdef SYSLOG_NAMES\x0a"
"#define\x09INTERNAL_NOPRI\x09""0x10\x09/* the \x22no priority\x22 priority */\x0a"
"\x09\x09\x09\x09/* mark \x22""facility\x22 */\x0a"
"#define\x09INTERNAL_MARK\x09(LOG_NFACILITIES<<3)\x0a"
"typedef struct _code {\x0a"
"\x09""char\x09*c_name;\x0a"
"\x09int\x09""c_val;\x0a"
"} CODE;\x0a"
"\x0a"
"CODE prioritynames\x5b\x5d = {\x0a"
"\x09{ \x22""alert\x22,\x09LOG_ALERT },\x0a"
"\x09{ \x22""crit\x22,\x09LOG_CRIT },\x0a"
"\x09{ \x22""debug\x22,\x09LOG_DEBUG },\x0a"
"\x09{ \x22""emerg\x22,\x09LOG_EMERG },\x0a"
"\x09{ \x22""err\x22,\x09LOG_ERR },\x0a"
"\x09{ \x22""error\x22,\x09LOG_ERR },\x09\x09/* DEPRECATED */\x0a"
"\x09{ \x22info\x22,\x09LOG_INFO },\x0a"
"\x09{ \x22none\x22,\x09INTERNAL_NOPRI },\x09/* INTERNAL */\x0a"
"\x09{ \x22notice\x22,\x09LOG_NOTICE },\x0a"
"\x09{ \x22panic\x22, \x09LOG_EMERG },\x09\x09/* DEPRECATED */\x0a"
"\x09{ \x22warn\x22,\x09LOG_WARNING },\x09\x09/* DEPRECATED */\x0a"
"\x09{ \x22warning\x22,\x09LOG_WARNING },\x0a"
"\x09{ NULL,\x09\x09-1 },\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"/* facility codes */\x0a"
"#define\x09LOG_KERN\x09(0<<3)\x09/* kernel messages */\x0a"
"#define\x09LOG_USER\x09(1<<3)\x09/* random user-level messages */\x0a"
"#define\x09LOG_MAIL\x09(2<<3)\x09/* mail system */\x0a"
"#define\x09LOG_DAEMON\x09(3<<3)\x09/* system daemons */\x0a"
"#define\x09LOG_AUTH\x09(4<<3)\x09/* security/authorization messages */\x0a"
"#define\x09LOG_SYSLOG\x09(5<<3)\x09/* messages generated internally by syslogd */\x0a"
"#define\x09LOG_LPR\x09\x09(6<<3)\x09/* line printer subsystem */\x0a"
"#define\x09LOG_NEWS\x09(7<<3)\x09/* network news subsystem */\x0a"
"#define\x09LOG_UUCP\x09(8<<3)\x09/* UUCP subsystem */\x0a"
"#define\x09LOG_CRON\x09(9<<3)\x09/* clock daemon */\x0a"
"#define\x09LOG_AUTHPRIV\x09(10<<3)\x09/* security/authorization messages (private) */\x0a"
"#define\x09LOG_FTP\x09\x09(11<<3)\x09/* ftp daemon */\x0a"
"\x0a"
"\x09/* other codes through 15 reserved for system use */\x0a"
"#define\x09LOG_LOCAL0\x09(16<<3)\x09/* reserved for local use */\x0a"
"#define\x09LOG_LOCAL1\x09(17<<3)\x09/* reserved for local use */\x0a"
"#define\x09LOG_LOCAL2\x09(18<<3)\x09/* reserved for local use */\x0a"
"#define\x09LOG_LOCAL3\x09(19<<3)\x09/* reserved for local use */\x0a"
"#define\x09LOG_LOCAL4\x09(20<<3)\x09/* reserved for local use */\x0a"
"#define\x09LOG_LOCAL5\x09(21<<3)\x09/* reserved for local use */\x0a"
"#define\x09LOG_LOCAL6\x09(22<<3)\x09/* reserved for local use */\x0a"
"#define\x09LOG_LOCAL7\x09(23<<3)\x09/* reserved for local use */\x0a"
"\x0a"
"#define\x09LOG_NFACILITIES\x09""24\x09/* current number of facilities */\x0a"
"#define\x09LOG_FACMASK\x09""0x03f8\x09/* mask to extract facility part */\x0a"
"\x09\x09\x09\x09/* facility of pri */\x0a"
"#define\x09LOG_FAC(p)\x09(((p) \x26 LOG_FACMASK) >> 3)\x0a"
"\x0a"
"#ifdef SYSLOG_NAMES\x0a"
"CODE facilitynames\x5b\x5d = {\x0a"
"\x09{ \x22""auth\x22,\x09LOG_AUTH },\x0a"
"\x09{ \x22""authpriv\x22,\x09LOG_AUTHPRIV },\x0a"
"\x09{ \x22""cron\x22, \x09LOG_CRON },\x0a"
"\x09{ \x22""daemon\x22,\x09LOG_DAEMON },\x0a"
"\x09{ \x22""ftp\x22,\x09LOG_FTP },\x0a"
"\x09{ \x22kern\x22,\x09LOG_KERN },\x0a"
"\x09{ \x22lpr\x22,\x09LOG_LPR },\x0a"
"\x09{ \x22mail\x22,\x09LOG_MAIL },\x0a"
"\x09{ \x22mark\x22, \x09INTERNAL_MARK },\x09/* INTERNAL */\x0a"
"\x09{ \x22news\x22,\x09LOG_NEWS },\x0a"
"\x09{ \x22security\x22,\x09LOG_AUTH },\x09\x09/* DEPRECATED */\x0a"
"\x09{ \x22syslog\x22,\x09LOG_SYSLOG },\x0a"
"\x09{ \x22user\x22,\x09LOG_USER },\x0a"
"\x09{ \x22uucp\x22,\x09LOG_UUCP },\x0a"
"\x09{ \x22local0\x22,\x09LOG_LOCAL0 },\x0a"
"\x09{ \x22local1\x22,\x09LOG_LOCAL1 },\x0a"
"\x09{ \x22local2\x22,\x09LOG_LOCAL2 },\x0a"
"\x09{ \x22local3\x22,\x09LOG_LOCAL3 },\x0a"
"\x09{ \x22local4\x22,\x09LOG_LOCAL4 },\x0a"
"\x09{ \x22local5\x22,\x09LOG_LOCAL5 },\x0a"
"\x09{ \x22local6\x22,\x09LOG_LOCAL6 },\x0a"
"\x09{ \x22local7\x22,\x09LOG_LOCAL7 },\x0a"
"\x09{ NULL,\x09\x09-1 },\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"/* Used by reentrant functions */\x0a"
"\x0a"
"struct syslog_data {\x0a"
"\x09int\x09log_stat;\x0a"
"\x09""const char \x09*log_tag;\x0a"
"\x09int \x09log_fac;\x0a"
"\x09int \x09log_mask;\x0a"
"};\x0a"
"\x0a"
"#define SYSLOG_DATA_INIT {0, (const char *)0, LOG_USER, 0xff}\x0a"
"\x0a"
"#ifdef _KERNEL\x0a"
"#define\x09LOG_PRINTF\x09-1\x09/* pseudo-priority to indicate use of printf */\x0a"
"#endif\x0a"
"\x0a"
"/*\x0a"
" * arguments to setlogmask.\x0a"
" */\x0a"
"#define\x09LOG_MASK(pri)\x09(1 << (pri))\x09\x09/* mask for one priority */\x0a"
"#define\x09LOG_UPTO(pri)\x09((1 << ((pri)+1)) - 1)\x09/* all priorities through pri */\x0a"
"\x0a"
"/*\x0a"
" * Option flags for openlog.\x0a"
" *\x0a"
" * LOG_ODELAY no longer does anything.\x0a"
" * LOG_NDELAY is the inverse of what it used to be.\x0a"
" */\x0a"
"#define\x09LOG_PID\x09\x09""0x01\x09/* log the pid with each message */\x0a"
"#define\x09LOG_CONS\x09""0x02\x09/* log on the console if errors in sending */\x0a"
"#define\x09LOG_ODELAY\x09""0x04\x09/* delay open until first syslog() (default) */\x0a"
"#define\x09LOG_NDELAY\x09""0x08\x09/* don't delay open */\x0a"
"#define\x09LOG_NOWAIT\x09""0x10\x09/* don't wait for console forks\x3a DEPRECATED */\x0a"
"#define\x09LOG_PERROR\x09""0x20\x09/* log to stderr as well */\x0a"
"\x0a"
"#ifndef _KERNEL\x0a"
"\x0a"
"/*\x0a"
" * Don't use va_list in the vsyslog() prototype.   Va_list is typedef'd in two\x0a"
" * places (<machine/varargs.h> and <machine/stdarg.h>), so if we include one\x0a"
" * of them here we may collide with the utility's includes.  It's unreasonable\x0a"
" * for utilities to have to include one of them to include syslog.h, so we get\x0a"
" * __va_list from <machine/_types.h> and use it.\x0a"
" */\x0a"
"#include <sys/cdefs.h>\x0a"
"#include <machine/_types.h>\x0a"
"\x0a"
"__BEGIN_DECLS\x0a"
"void\x09""closelog(void);\x0a"
"void\x09openlog(const char *, int, int);\x0a"
"int\x09setlogmask(int);\x0a"
"void\x09syslog(int, const char *, ...)\x0a"
"    __attribute__((__format__(__syslog__,2,3)));\x0a"
"void\x09vsyslog(int, const char *, __va_list);\x0a"
"void\x09""closelog_r(struct syslog_data *);\x0a"
"void\x09openlog_r(const char *, int, int, struct syslog_data *);\x0a"
"int\x09setlogmask_r(int, struct syslog_data *);\x0a"
"void\x09syslog_r(int, struct syslog_data *, const char *, ...)\x0a"
"     __attribute__((__format__(__syslog__,3,4)));\x0a"
"void\x09vsyslog_r(int, struct syslog_data *, const char *, __va_list);\x0a"
"__END_DECLS\x0a"
"\x0a"
"#else /* \x21_KERNEL */\x0a"
"\x0a"
"void\x09logpri(int);\x0a"
"void\x09log(int, const char *, ...)\x0a"
"    __attribute__((__format__(__kprintf__,2,3)));\x0a"
"int\x09""addlog(const char *, ...)\x0a"
"    __attribute__((__format__(__kprintf__,1,2)));\x0a"
"void\x09logwakeup(void);\x0a"
"\x0a"
"#endif /* \x21_KERNEL */\x0a"
"#endif /* \x21_SYS_SYSLOG_H_ */\x0a"
"\x0a"
"", 7767 ); }