#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_threads_h( 
"/* Threads <threads.h>\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#ifndef _PDCLIB_THREADS_H\x0a"
"#define _PDCLIB_THREADS_H _PDCLIB_THREADS_H\x0a"
"#include \x22_PDCLIB/int.h\x22\x0a"
"#include \x22_PDCLIB/threadconfig.h\x22\x0a"
"\x0a"
"#include <time.h>\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"extern \x22""C\x22 {\x0a"
"#endif\x0a"
"\x0a"
"#define thread_local _Thread_local\x0a"
"\x0a"
"typedef _PDCLIB_once_flag once_flag;\x0a"
"\x0a"
"enum\x0a"
"{\x0a"
"    mtx_plain       = 0,\x0a"
"    mtx_recursive   = (1 << 0),\x0a"
"    mtx_timed       = (1 << 1),\x0a"
"\x0a"
"    _PDCLIB_mtx_valid_mask = mtx_recursive \x7c mtx_timed\x0a"
"};\x0a"
"\x0a"
"enum\x0a"
"{\x0a"
"    thrd_success    = 0,\x0a"
"    thrd_timeout    = 1,\x0a"
"    thrd_busy       = 2,\x0a"
"    thrd_error      = 3,\x0a"
"    thrd_nomem      = 4,\x0a"
"};\x0a"
"\x0a"
"#define ONCE_FLAG_INIT _PDCLIB_ONCE_FLAG_INIT\x0a"
"#ifdef _PDCLIB_ONCE_FLAG_IS_DONE\x0a"
"static inline void call_once( once_flag * flag, void (*func)( void ) )\x0a"
"{\x0a"
"    if ( \x21 _PDCLIB_ONCE_FLAG_IS_DONE( flag ) )\x0a"
"    {\x0a"
"        _PDCLIB_call_once( flag, func );\x0a"
"    }\x0a"
"}\x0a"
"#else\x0a"
"void call_once( once_flag * flag, void (*func)( void ) );\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _PDCLIB_MTX_T\x0a"
"typedef _PDCLIB_MTX_T mtx_t;\x0a"
"void mtx_destroy( mtx_t * mtx ) _PDCLIB_nothrow;\x0a"
"int mtx_init( mtx_t * mtx, int type ) _PDCLIB_nothrow;\x0a"
"int mtx_lock( mtx_t * mtx ) _PDCLIB_nothrow;\x0a"
"int mtx_timedlock( mtx_t * _PDCLIB_restrict mtx, const struct timespec * _PDCLIB_restrict ts ) _PDCLIB_nothrow;\x0a"
"int mtx_trylock( mtx_t * mtx ) _PDCLIB_nothrow;\x0a"
"int mtx_unlock( mtx_t * mtx ) _PDCLIB_nothrow;\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _PDCLIB_CND_T\x0a"
"typedef _PDCLIB_CND_T cnd_t;\x0a"
"int cnd_broadcast( cnd_t * cond ) _PDCLIB_nothrow;\x0a"
"void cnd_destroy( cnd_t * cond ) _PDCLIB_nothrow;\x0a"
"int cnd_init( cnd_t * cond ) _PDCLIB_nothrow;\x0a"
"int cnd_signal( cnd_t * cond ) _PDCLIB_nothrow;\x0a"
"int cnd_timedwait( cnd_t *_PDCLIB_restrict cond, mtx_t * _PDCLIB_restrict mtx, const struct timespec * _PDCLIB_restrict ts ) _PDCLIB_nothrow;\x0a"
"int cnd_wait( cnd_t * cond, mtx_t * mtx ) _PDCLIB_nothrow;\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _PDCLIB_THRD_T\x0a"
"#define _PDCLIB_THRD_HAVE_MISC\x0a"
"typedef _PDCLIB_THRD_T thrd_t;\x0a"
"typedef int (*thrd_start_t)( void * );\x0a"
"\x0a"
"int thrd_create( thrd_t * thr, thrd_start_t func, void * arg ) _PDCLIB_nothrow;\x0a"
"thrd_t thrd_current( void ) _PDCLIB_nothrow;\x0a"
"int thrd_detach( thrd_t thr ) _PDCLIB_nothrow;\x0a"
"int thrd_equal( thrd_t thr0, thrd_t thr1 ) _PDCLIB_nothrow;\x0a"
"\x0a"
"/* Not nothrow\x3a systems may use exceptions at thread exit */\x0a"
"_PDCLIB_noreturn void thrd_exit( int res );\x0a"
"/* Not nothrow\x3a systems may potentially propogate exceptions out of thrd_join\x3f */\x0a"
"int thrd_join( thrd_t thr, int * res );\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _PDCLIB_THRD_HAVE_MISC\x0a"
"int thrd_sleep( const struct timespec * duration, struct timespec * remaining ) _PDCLIB_nothrow;\x0a"
"void thrd_yield( void ) _PDCLIB_nothrow;\x0a"
"#endif\x0a"
"\x0a"
"/* The behaviour of tss_t is woefully underspecified in the C11 standard. In\x0a"
"   particular, it never specifies where/when/<b>if</b> destructors are called.\x0a"
"\x0a"
"   In lieu of any clarification, we assume the behaviour of POSIX pthread_key_t\x0a"
"*/\x0a"
"\x0a"
"#ifdef _PDCLIB_TSS_T\x0a"
"#define TSS_DTOR_ITERATIONS _PDCLIB_TSS_DTOR_ITERATIONS\x0a"
"\x0a"
"typedef _PDCLIB_TSS_T tss_t;\x0a"
"typedef void (*tss_dtor_t)( void * );\x0a"
"\x0a"
"int tss_create( tss_t * key, tss_dtor_t dtor ) _PDCLIB_nothrow;\x0a"
"void tss_delete( tss_t key ) _PDCLIB_nothrow;\x0a"
"void * tss_get( tss_t key ) _PDCLIB_nothrow;\x0a"
"int tss_set( tss_t key, void * val ) _PDCLIB_nothrow;\x0a"
"#endif\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#endif\x0a"
"", 3319 ); }