#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_unwind_h( 
"//===------------------------------- unwind.h -----------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//\x0a"
"// C++ ABI Level 1 ABI documented at\x3a\x0a"
"//   http\x3a//mentorembedded.github.io/cxx-abi/abi-eh.html\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef __UNWIND_H__\x0a"
"#define __UNWIND_H__\x0a"
"\x0a"
"#define _LIBUNWIND_ARM_EHABI 0\x0a"
"\x0a"
"#include <stdint.h>\x0a"
"#include <stddef.h>\x0a"
"\x0a"
"typedef enum {\x0a"
"  _URC_NO_REASON = 0,\x0a"
"  _URC_OK = 0,\x0a"
"  _URC_FOREIGN_EXCEPTION_CAUGHT = 1,\x0a"
"  _URC_FATAL_PHASE2_ERROR = 2,\x0a"
"  _URC_FATAL_PHASE1_ERROR = 3,\x0a"
"  _URC_NORMAL_STOP = 4,\x0a"
"  _URC_END_OF_STACK = 5,\x0a"
"  _URC_HANDLER_FOUND = 6,\x0a"
"  _URC_INSTALL_CONTEXT = 7,\x0a"
"  _URC_CONTINUE_UNWIND = 8,\x0a"
"#if _LIBUNWIND_ARM_EHABI\x0a"
"  _URC_FAILURE = 9\x0a"
"#endif\x0a"
"} _Unwind_Reason_Code;\x0a"
"\x0a"
"typedef enum {\x0a"
"  _UA_SEARCH_PHASE = 1,\x0a"
"  _UA_CLEANUP_PHASE = 2,\x0a"
"  _UA_HANDLER_FRAME = 4,\x0a"
"  _UA_FORCE_UNWIND = 8,\x0a"
"  _UA_END_OF_STACK = 16 // gcc extension to C++ ABI\x0a"
"} _Unwind_Action;\x0a"
"\x0a"
"typedef struct _Unwind_Context _Unwind_Context;   // opaque\x0a"
"\x0a"
"struct _Unwind_Context;   // opaque\x0a"
"struct _Unwind_Exception; // forward declaration\x0a"
"typedef struct _Unwind_Exception _Unwind_Exception;\x0a"
"\x0a"
"struct _Unwind_Exception {\x0a"
"  uint64_t exception_class;\x0a"
"  void (*exception_cleanup)(_Unwind_Reason_Code reason,\x0a"
"                            _Unwind_Exception *exc);\x0a"
"  uintptr_t private_1; // non-zero means forced unwind\x0a"
"  uintptr_t private_2; // holds sp that phase1 found for phase2 to use\x0a"
"} __attribute__((aligned(16)));\x0a"
"\x0a"
"typedef _Unwind_Reason_Code (*_Unwind_Stop_Fn)\x0a"
"    (int version,\x0a"
"     _Unwind_Action actions,\x0a"
"     uint64_t exceptionClass,\x0a"
"     _Unwind_Exception* exceptionObject,\x0a"
"     struct _Unwind_Context* context,\x0a"
"     void* stop_parameter );\x0a"
"\x0a"
"typedef _Unwind_Reason_Code (*__personality_routine)\x0a"
"      (int version,\x0a"
"       _Unwind_Action actions,\x0a"
"       uint64_t exceptionClass,\x0a"
"       _Unwind_Exception* exceptionObject,\x0a"
"       struct _Unwind_Context* context);\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"extern \x22""C\x22 {\x0a"
"#endif\x0a"
"\x0a"
"//\x0a"
"// The following are the base functions documented by the C++ ABI\x0a"
"//\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_SjLj_RaiseException(_Unwind_Exception *exception_object);\x0a"
"extern void _Unwind_SjLj_Resume(_Unwind_Exception *exception_object);\x0a"
"#else\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_RaiseException(_Unwind_Exception *exception_object);\x0a"
"extern void _Unwind_Resume(_Unwind_Exception *exception_object);\x0a"
"#endif\x0a"
"extern void _Unwind_DeleteException(_Unwind_Exception *exception_object);\x0a"
"\x0a"
"#if _LIBUNWIND_ARM_EHABI\x0a"
"typedef enum {\x0a"
"  _UVRSC_CORE = 0, /* integer register */\x0a"
"  _UVRSC_VFP = 1, /* vfp */\x0a"
"  _UVRSC_WMMXD = 3, /* Intel WMMX data register */\x0a"
"  _UVRSC_WMMXC = 4 /* Intel WMMX control register */\x0a"
"} _Unwind_VRS_RegClass;\x0a"
"\x0a"
"typedef enum {\x0a"
"  _UVRSD_UINT32 = 0,\x0a"
"  _UVRSD_VFPX = 1,\x0a"
"  _UVRSD_UINT64 = 3,\x0a"
"  _UVRSD_FLOAT = 4,\x0a"
"  _UVRSD_DOUBLE = 5\x0a"
"} _Unwind_VRS_DataRepresentation;\x0a"
"\x0a"
"typedef enum {\x0a"
"  _UVRSR_OK = 0,\x0a"
"  _UVRSR_NOT_IMPLEMENTED = 1,\x0a"
"  _UVRSR_FAILED = 2\x0a"
"} _Unwind_VRS_Result;\x0a"
"\x0a"
"extern void _Unwind_Complete(_Unwind_Exception* exception_object);\x0a"
"\x0a"
"extern _Unwind_VRS_Result\x0a"
"_Unwind_VRS_Get(_Unwind_Context *context, _Unwind_VRS_RegClass regclass,\x0a"
"                uint32_t regno, _Unwind_VRS_DataRepresentation representation,\x0a"
"                void *valuep);\x0a"
"\x0a"
"extern _Unwind_VRS_Result\x0a"
"_Unwind_VRS_Set(_Unwind_Context *context, _Unwind_VRS_RegClass regclass,\x0a"
"                uint32_t regno, _Unwind_VRS_DataRepresentation representation,\x0a"
"                void *valuep);\x0a"
"\x0a"
"extern _Unwind_VRS_Result\x0a"
"_Unwind_VRS_Pop(_Unwind_Context *context, _Unwind_VRS_RegClass regclass,\x0a"
"                uint32_t discriminator,\x0a"
"                _Unwind_VRS_DataRepresentation representation);\x0a"
"#endif\x0a"
"\x0a"
"#if \x21_LIBUNWIND_ARM_EHABI\x0a"
"\x0a"
"extern uintptr_t _Unwind_GetGR(struct _Unwind_Context *context, int index);\x0a"
"extern void _Unwind_SetGR(struct _Unwind_Context *context, int index,\x0a"
"                          uintptr_t new_value);\x0a"
"extern uintptr_t _Unwind_GetIP(struct _Unwind_Context *context);\x0a"
"extern void _Unwind_SetIP(struct _Unwind_Context *, uintptr_t new_value);\x0a"
"\x0a"
"#else  // _LIBUNWIND_ARM_EHABI\x0a"
"\x0a"
"#if defined(_LIBUNWIND_UNWIND_LEVEL1_EXTERNAL_LINKAGE)\x0a"
"#define _LIBUNWIND_EXPORT_UNWIND_LEVEL1 extern\x0a"
"#else\x0a"
"#define _LIBUNWIND_EXPORT_UNWIND_LEVEL1 static __inline__\x0a"
"#endif\x0a"
"\x0a"
"// These are de facto helper functions for ARM, which delegate the function\x0a"
"// calls to _Unwind_VRS_Get/Set().  These are not a part of ARM EHABI\x0a"
"// specification, thus these function MUST be inlined.  Please don't replace\x0a"
"// these with the \x22""extern\x22 function declaration; otherwise, the program\x0a"
"// including this <unwind.h> header won't be ABI compatible and will result in\x0a"
"// link error when we are linking the program with libgcc.\x0a"
"\x0a"
"_LIBUNWIND_EXPORT_UNWIND_LEVEL1\x0a"
"uintptr_t _Unwind_GetGR(struct _Unwind_Context *context, int index) {\x0a"
"  uintptr_t value = 0;\x0a"
"  _Unwind_VRS_Get(context, _UVRSC_CORE, (uint32_t)index, _UVRSD_UINT32, \x26value);\x0a"
"  return value;\x0a"
"}\x0a"
"\x0a"
"_LIBUNWIND_EXPORT_UNWIND_LEVEL1\x0a"
"void _Unwind_SetGR(struct _Unwind_Context *context, int index,\x0a"
"                   uintptr_t value) {\x0a"
"  _Unwind_VRS_Set(context, _UVRSC_CORE, (uint32_t)index, _UVRSD_UINT32, \x26value);\x0a"
"}\x0a"
"\x0a"
"_LIBUNWIND_EXPORT_UNWIND_LEVEL1\x0a"
"uintptr_t _Unwind_GetIP(struct _Unwind_Context *context) {\x0a"
"  // remove the thumb-bit before returning\x0a"
"  return _Unwind_GetGR(context, 15) \x26 (\x7e(uintptr_t)0x1);\x0a"
"}\x0a"
"\x0a"
"_LIBUNWIND_EXPORT_UNWIND_LEVEL1\x0a"
"void _Unwind_SetIP(struct _Unwind_Context *context, uintptr_t value) {\x0a"
"  uintptr_t thumb_bit = _Unwind_GetGR(context, 15) \x26 ((uintptr_t)0x1);\x0a"
"  _Unwind_SetGR(context, 15, value \x7c thumb_bit);\x0a"
"}\x0a"
"#endif  // _LIBUNWIND_ARM_EHABI\x0a"
"\x0a"
"extern uintptr_t _Unwind_GetRegionStart(struct _Unwind_Context *context);\x0a"
"extern uintptr_t\x0a"
"    _Unwind_GetLanguageSpecificData(struct _Unwind_Context *context);\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_SjLj_ForcedUnwind(_Unwind_Exception *exception_object,\x0a"
"                              _Unwind_Stop_Fn stop, void *stop_parameter);\x0a"
"#else\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_ForcedUnwind(_Unwind_Exception *exception_object,\x0a"
"                         _Unwind_Stop_Fn stop, void *stop_parameter);\x0a"
"#endif\x0a"
"\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"typedef struct _Unwind_FunctionContext *_Unwind_FunctionContext_t;\x0a"
"extern void _Unwind_SjLj_Register(_Unwind_FunctionContext_t fc);\x0a"
"extern void _Unwind_SjLj_Unregister(_Unwind_FunctionContext_t fc);\x0a"
"#endif\x0a"
"\x0a"
"//\x0a"
"// The following are semi-suppoted extensions to the C++ ABI\x0a"
"//\x0a"
"\x0a"
"//\x0a"
"//  called by __cxa_rethrow().\x0a"
"//\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_SjLj_Resume_or_Rethrow(_Unwind_Exception *exception_object);\x0a"
"#else\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_Resume_or_Rethrow(_Unwind_Exception *exception_object);\x0a"
"#endif\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#endif // __UNWIND_H__\x0a"
"", 6912 ); }