#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_util_array_hpp( 
"// -*- C++ -*- (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"//             (c) 2018 Vladim\xc3\xadr \xc5\xa0till <xstill\x40""fi.muni.cz>\x0a"
"\x0a"
"#ifndef __DIOS_ARRAY_HPP__\x0a"
"#define __DIOS_ARRAY_HPP__\x0a"
"\x0a"
"#include <sys/divm.h>\x0a"
"#include <iterator>\x0a"
"#include <cstring>\x0a"
"#include <brick-order>\x0a"
"#include <initializer_list>\x0a"
"#include <memory>\x0a"
"#include <algorithm>\x0a"
"\x0a"
"namespace __dios {\x0a"
"\x0a"
"struct construct_shared_t {};\x0a"
"\x0a"
"template < typename T, int PT = _VM_PT_Heap >\x0a"
"struct Array \x3a brq\x3a\x3a""derive_ord, brq\x3a\x3a""derive_eq\x0a"
"{\x0a"
"    using size_type = int;\x0a"
"    using value_type = T;\x0a"
"    using iterator = T *;\x0a"
"    using const_iterator = const T *;\x0a"
"    using reverse_iterator = std\x3a\x3areverse_iterator< iterator >;\x0a"
"    using const_reverse_iterator = std\x3a\x3areverse_iterator< const_iterator >;\x0a"
"    using difference_type = std\x3a\x3aptrdiff_t;\x0a"
"    using reference = T\x26;\x0a"
"    using const_reference = T const\x26;\x0a"
"\x0a"
"    /* Allow construction of multiple array instances that point to the same\x0a"
"     * memory. Objects constructed in this manner must never be destroyed but\x0a"
"     * must be disowned instead. */\x0a"
"\x0a"
"    static constexpr construct_shared_t construct_shared;\x0a"
"\x0a"
"    static constexpr bool nothrow_dtor = std\x3a\x3ais_nothrow_destructible_v< T >;\x0a"
"    static constexpr bool nothrow_copy = std\x3a\x3ais_nothrow_copy_constructible_v< T >;\x0a"
"    static constexpr bool nothrow_move = std\x3a\x3ais_nothrow_move_constructible_v< T >;\x0a"
"    static constexpr bool is_trivial   = std\x3a\x3ais_trivial_v< T >;\x0a"
"\x0a"
"    Array() noexcept = default;\x0a"
"    \x7e""Array() noexcept( nothrow_dtor ) { clear(); }\x0a"
"\x0a"
"    template< int PTI >\x0a"
"    Array( const Array< T, PTI > \x26other, construct_shared_t ) noexcept\x0a"
"        \x3a _data( other._data )\x0a"
"    {}\x0a"
"\x0a"
"    Array( void *ptr, construct_shared_t ) noexcept\x0a"
"        \x3a _data( static_cast< _Item * >( ptr ) )\x0a"
"    {}\x0a"
"\x0a"
"    Array( const Array\x26 other ) noexcept ( nothrow_copy )\x0a"
"        \x3a Array( other.size(), other.begin(), other.end() )\x0a"
"    { }\x0a"
"\x0a"
"    Array( Array\x26\x26 other ) noexcept { swap( other ); };\x0a"
"\x0a"
"    Array( std\x3a\x3ainitializer_list< T > ilist ) noexcept ( nothrow_copy ) \x3a\x0a"
"        Array( ilist.size(), ilist.begin(), ilist.end() )\x0a"
"    { }\x0a"
"\x0a"
"    Array( size_type size, const T \x26val = T() ) noexcept( nothrow_copy )\x0a"
"    {\x0a"
"        _resize( size );\x0a"
"        uninit_fill( begin(), end(), val );\x0a"
"    }\x0a"
"\x0a"
"    template< typename It >\x0a"
"    Array( size_type size, It b, It e ) noexcept ( nothrow_copy )\x0a"
"    {\x0a"
"        append( size, b, e );\x0a"
"    }\x0a"
"\x0a"
"    Array\x26 operator=( Array other ) noexcept ( nothrow_copy )\x0a"
"    {\x0a"
"        swap( other );\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    void *disown() { void *rv = begin(); _data = nullptr; return rv; }\x0a"
"\x0a"
"    template< typename It >\x0a"
"    void assign( size_type size, It b, It e ) noexcept ( nothrow_copy )\x0a"
"    {\x0a"
"        _clear();\x0a"
"        _resize( size );\x0a"
"        uninit_copy( b, e, begin() );\x0a"
"    }\x0a"
"\x0a"
"    void swap( Array\x26 other ) noexcept\x0a"
"    {\x0a"
"        using std\x3a\x3aswap;\x0a"
"        swap( _data, other._data );\x0a"
"    }\x0a"
"\x0a"
"    struct _Item\x0a"
"    {\x0a"
"        T _items\x5b 0 \x5d;\x0a"
"        T *get() noexcept { return _items; }\x0a"
"    };\x0a"
"\x0a"
"    iterator begin() noexcept { return _data \x3f_data->get() \x3a nullptr; }\x0a"
"    const_iterator begin() const noexcept { return _data \x3f_data->get() \x3a nullptr; }\x0a"
"    const_iterator cbegin() const noexcept { return _data \x3f_data->get() \x3a nullptr; }\x0a"
"\x0a"
"    __inline iterator end() noexcept { return _data \x3f _data->get() + size() \x3a nullptr; }\x0a"
"    __inline const_iterator end() const noexcept { return _data \x3f _data->get() + size() \x3a nullptr; }\x0a"
"    __inline const_iterator cend() const noexcept { return _data \x3f _data->get() + size() \x3a nullptr; }\x0a"
"\x0a"
"    reverse_iterator rbegin() noexcept { return reverse_iterator( end() ); }\x0a"
"    const_reverse_iterator rbegin() const noexcept { return const_reverse_iterator( end() ); }\x0a"
"    const_reverse_iterator crbegin() const noexcept { return const_reverse_iterator( end() ); }\x0a"
"\x0a"
"    reverse_iterator rend() noexcept { return reverse_iterator( begin() ); }\x0a"
"    const_reverse_iterator rend() const noexcept { return const_reverse_iterator( begin() ); }\x0a"
"    const_reverse_iterator crend() const noexcept { return const_reverse_iterator( begin() ); }\x0a"
"\x0a"
"    T\x26 back() noexcept { return *( end() - 1 ); }\x0a"
"    const T\x26 back() const noexcept { return *( end() - 1 ); }\x0a"
"    T\x26 front() noexcept { return *begin(); }\x0a"
"    const T\x26 front() const noexcept { return *begin(); }\x0a"
"\x0a"
"    bool empty() const noexcept { return \x21_data; }\x0a"
"    __inline size_type size() const noexcept\x0a"
"    {\x0a"
"        return empty() \x3f 0 \x3a __vm_obj_size( _data ) / sizeof( T );\x0a"
"    }\x0a"
"\x0a"
"    __inline void clear() noexcept ( nothrow_dtor )\x0a"
"    {\x0a"
"        if ( empty() )\x0a"
"            return;\x0a"
"        _clear();\x0a"
"        __vm_obj_free( _data );\x0a"
"        _data = nullptr;\x0a"
"    }\x0a"
"\x0a"
"    void push_back( const T\x26 t ) noexcept ( nothrow_copy )\x0a"
"    {\x0a"
"        _resize( size() + 1 );\x0a"
"        new ( \x26""back() ) T( t );\x0a"
"    }\x0a"
"\x0a"
"    template< typename It >\x0a"
"    void append( size_type count, It b, It e ) noexcept ( is_trivial )\x0a"
"    {\x0a"
"        size_type oldsz = size();\x0a"
"        _resize( oldsz + count );\x0a"
"        uninit_copy( b, e, begin() + oldsz );\x0a"
"    }\x0a"
"\x0a"
"    template < typename... Args >\x0a"
"    T\x26 emplace_back( Args\x26\x26... args )\x0a"
"    {\x0a"
"        _resize( size() + 1 );\x0a"
"        new ( \x26""back() ) T( std\x3a\x3a""forward< Args >( args )... );\x0a"
"        return back();\x0a"
"    }\x0a"
"\x0a"
"    void pop_back() noexcept ( nothrow_dtor )\x0a"
"    {\x0a"
"        back().\x7eT();\x0a"
"        _resize( size() - 1 );\x0a"
"    }\x0a"
"\x0a"
"    iterator erase( iterator it ) noexcept ( nothrow_dtor )\x0a"
"    {\x0a"
"        return erase( it, std\x3a\x3anext( it ) );\x0a"
"    }\x0a"
"\x0a"
"    iterator erase( iterator first, iterator last ) noexcept ( nothrow_dtor )\x0a"
"    {\x0a"
"        if ( empty() )\x0a"
"            return;\x0a"
"        int origSize = size();\x0a"
"        int shift = std\x3a\x3a""distance( first, last );\x0a"
"        for ( iterator it = first; it \x21= last; it++ )\x0a"
"            it->\x7eT();\x0a"
"        memmove( first, last, ( end() - last ) * sizeof( T ) );\x0a"
"        _resize( origSize - shift );\x0a"
"        return last;\x0a"
"    }\x0a"
"\x0a"
"    iterator insert( iterator where, const T \x26val ) noexcept ( nothrow_copy \x26\x26 nothrow_move )\x0a"
"    {\x0a"
"        _resize( size() + 1 );\x0a"
"        for ( iterator i = end() - 1; i > where; --i )\x0a"
"        {\x0a"
"            new ( i ) T( std\x3a\x3amove( *( i - 1 ) ) );\x0a"
"            ( i - 1 )->\x7eT();\x0a"
"        }\x0a"
"        new ( where ) T( val );\x0a"
"        return where;\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    T\x26 operator\x5b\x5d( size_type idx ) noexcept { return _data->get()\x5b idx \x5d; }\x0a"
"    const T\x26 operator\x5b\x5d( size_type idx ) const noexcept { return _data->get()\x5b idx \x5d; }\x0a"
"\x0a"
"    void uninit_fill( iterator b, iterator e, const T \x26val ) noexcept ( nothrow_copy )\x0a"
"    {\x0a"
"        if constexpr ( nothrow_copy )\x0a"
"            for ( auto i = b; i \x21= e; ++i )\x0a"
"                new ( i ) T( val );\x0a"
"        else\x0a"
"            std\x3a\x3auninitialized_fill( b, e, val );\x0a"
"    }\x0a"
"\x0a"
"    template< typename from_t >\x0a"
"    void uninit_copy( from_t b, from_t e, iterator to ) noexcept ( nothrow_copy )\x0a"
"    {\x0a"
"        if constexpr ( nothrow_copy )\x0a"
"            for ( auto i = b; i \x21= e; ++i )\x0a"
"                new ( to++ ) T( *i );\x0a"
"        else\x0a"
"            std\x3a\x3auninitialized_copy( b, e, to );\x0a"
"    }\x0a"
"\x0a"
"    void resize( size_type n, const T \x26val = T() ) noexcept( nothrow_copy )\x0a"
"    {\x0a"
"        size_type old = size();\x0a"
"        _resize( n );\x0a"
"\x0a"
"        if ( n > old )\x0a"
"            uninit_fill( begin() + old, end(), val );\x0a"
"    }\x0a"
"\x0a"
"    void _resize( size_type n ) noexcept\x0a"
"    {\x0a"
"        if ( n == 0 )\x0a"
"        {\x0a"
"            if ( _data )\x0a"
"                __vm_obj_free( _data );\x0a"
"            _data = nullptr;\x0a"
"        }\x0a"
"        else if ( empty() )\x0a"
"            _data = static_cast< _Item * >( __vm_obj_make( n * sizeof( T ), PT ) );\x0a"
"        else\x0a"
"            __vm_obj_resize( _data, n * sizeof( T ) );\x0a"
"    }\x0a"
"\x0a"
"    __local_skipcfl void _clear() noexcept ( nothrow_dtor )\x0a"
"    {\x0a"
"        auto s = size();\x0a"
"        for ( auto i = begin(); i < begin() + s; ++i )\x0a"
"            i->\x7eT();\x0a"
"    }\x0a"
"\x0a"
"    bool operator==( const Array \x26o ) const noexcept\x0a"
"    {\x0a"
"        return size() == o.size() \x26\x26 std\x3a\x3a""equal( begin(), end(), o.begin() );\x0a"
"    }\x0a"
"\x0a"
"    bool operator<( const Array \x26o ) const noexcept\x0a"
"    {\x0a"
"        return std\x3a\x3alexicographical_compare( begin(), end(), o.begin(), o.end() );\x0a"
"    }\x0a"
"\x0a"
"    _Item *_data = nullptr;\x0a"
"};\x0a"
"\x0a"
"} // namespace __dios\x0a"
"\x0a"
"# endif // __DIOS_ARRAY_HPP__\x0a"
"", 8042 ); }