#include <string_view>
namespace divine::str::dios {
extern const std::string_view include_util_degeneralizer_hpp( 
"/*\x0a"
" * (c) 2018 Tade\xc3\xa1\xc5\xa1 Ku\xc4\x8d""era <kucerat\x40mail.muni.cz>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"#include<set>\x0a"
"#include<map>\x0a"
"#include<optional>\x0a"
"#include<dios.h>\x0a"
"#include<sys/monitor.h>\x0a"
"\x0a"
"//Degeneralizer with level reset and level caching, based on\x3a\x0a"
"//\x22""Compositional Approach to Suspension and Other Improvements to LTL Translation\x22\x0a"
"struct Degeneralizer2\x0a"
"{\x0a"
"    size_t current, last;\x0a"
"    std\x3a\x3amap< size_t, size_t > visited;\x0a"
"\x0a"
"    Degeneralizer2() = delete;\x0a"
"    Degeneralizer2( size_t _numberOfAcceptingSets )\x0a"
"        \x3a current( _numberOfAcceptingSets )\x0a"
"        , last( _numberOfAcceptingSets )\x0a"
"    {\x0a"
"    }\x0a"
"    size_t knownLevelFor( size_t dest ) {\x0a"
"        auto it = visited.find( dest );\x0a"
"        if( it \x21= visited.end() )\x0a"
"            return it->second;\x0a"
"        markVisited( dest, 0 );\x0a"
"        return 0;\x0a"
"    }\x0a"
"    void markVisited( size_t state, size_t level ) {\x0a"
"        visited.emplace( std\x3a\x3amake_pair( state, level ) );\x0a"
"    }\x0a"
"    // \x40""acc_sets\x3a ids of accepting sets, that current transition belongs to\x0a"
"    // \x40scc1,\x40scc2\x3a optional id of the accepting SCC that the first/second node belongs to\x0a"
"    // \x40""dest\x3a id of the target of fired tgba transition\x0a"
"    bool step( const std\x3a\x3aset< size_t >\x26 acc_sets, std\x3a\x3aoptional< size_t > scc1, std\x3a\x3aoptional< size_t > scc2, size_t dest ) {\x0a"
"        if( \x21scc2.has_value() )\x0a"
"            current = 0;\x0a"
"        else if( scc1 \x21= scc2 )\x0a"
"            current = knownLevelFor( dest );\x0a"
"        else if( scc1 == scc2 )\x0a"
"        {\x0a"
"            assert( scc1.has_value() \x26\x26 scc2.has_value() );\x0a"
"            if( current == last )\x0a"
"                current = 0;\x0a"
"            auto it = acc_sets.begin();\x0a"
"            if( current \x21= 0 )\x0a"
"                it = acc_sets.find( current );\x0a"
"            for( ; it \x21= acc_sets.end(); ++it, ++current )\x0a"
"                if( *it \x21= current )\x0a"
"                    break;\x0a"
"        }\x0a"
"        markVisited( dest, current );\x0a"
"        return current == last;\x0a"
"    }\x0a"
"};\x0a"
"template< typename TGBA >\x0a"
"struct Monitor \x3a public __dios\x3a\x3aMonitor {\x0a"
"    TGBA tgba;\x0a"
"    Degeneralizer2 deg;\x0a"
"\x0a"
"    Monitor( TGBA\x26\x26 _tgba )\x0a"
"        \x3a tgba( _tgba )\x0a"
"        , deg( _tgba.numberAcc )\x0a"
"    {\x0a"
"    }\x0a"
"    // preformes step on tgba, if succesful then degeneralizer.step() too.\x0a"
"    void step() override {\x0a"
"        std\x3a\x3aset< size_t > acc;\x0a"
"        std\x3a\x3aoptional< size_t > scc1;\x0a"
"        std\x3a\x3aoptional< size_t > scc2;\x0a"
"        size_t dest;\x0a"
"        if( \x21tgba.step( acc, scc1, scc2, dest ) ) //step was not succesful\x0a"
"        {\x0a"
"            monitor_cancel();\x0a"
"            return;\x0a"
"        }\x0a"
"        if( deg.step( acc, scc1, scc2, dest ) ) // we got to accepting state\x0a"
"            monitor_accept();\x0a"
"    }\x0a"
"};\x0a"
"", 3290 ); }