#include <string_view>
namespace divine::str::dios {
extern const std::string_view lamp_wrapper_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2020 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/* This file is supposed to be included, but is not really a header. Instead,\x0a"
" * it implements the LART-facing metadomain wrapper. Each metadomain should be\x0a"
" * compiled into a separate bitcode file which contains exactly one copy\x0a"
" * (build) of this file. See e.g. dios/metadom/trivial.cpp for an example. */\x0a"
"\x0a"
"#include <sys/lamp.h>\x0a"
"#include <dios/lava/base.hpp> /* iN */\x0a"
"\x0a"
"using ptr = __lamp_ptr;\x0a"
"using dom = __lamp\x3a\x3ameta_domain;\x0a"
"using bw = __lava\x3a\x3a""bitwidth_t;\x0a"
"\x0a"
"using namespace __lava; /* iN */\x0a"
"\x0a"
"struct wrapper\x0a"
"{\x0a"
"    template< typename op_t >\x0a"
"    __inline static ptr wrap( op_t op ) { return { op().disown() }; }\x0a"
"\x0a"
"    template< typename op_t, typename... args_t >\x0a"
"    __inline static ptr wrap( op_t op, ptr arg, args_t... args )\x0a"
"    {\x0a"
"        dom a( arg.ptr, dom\x3a\x3a""construct_shared );\x0a"
"        auto rv = wrap( \x5b\x26\x5d( const auto \x26 ... args ) __inline { return op( a, args... ); }, args... );\x0a"
"        a.disown();\x0a"
"        return rv;\x0a"
"    }\x0a"
"\x0a"
"    template< typename op_t, typename arg_t, typename... args_t >\x0a"
"    __inline static auto wrap( op_t op, const arg_t \x26""arg, args_t... args )\x0a"
"        -> std\x3a\x3a""enable_if_t< \x21std\x3a\x3ais_same_v< arg_t, dom >, ptr >\x0a"
"    {\x0a"
"        return wrap( \x5b\x26\x5d ( const auto \x26 ... args ) __inline { return op( arg, args... ); }, args... );\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template< typename... args_t >\x0a"
"__inline static auto wrap( const args_t \x26 ... args ) { return wrapper\x3a\x3awrap( args... ); }\x0a"
"\x0a"
"static uint32_t tainted = 0;\x0a"
"\x0a"
"\x5b\x5bgnu\x3a\x3a""constructor\x5d\x5d void tainted_init()\x0a"
"{\x0a"
"    __vm_pointer_t ptr = __vm_pointer_split( \x26tainted );\x0a"
"    __vm_poke( _VM_ML_Taints, ptr.obj, ptr.off, 4, 0xF );\x0a"
"}\x0a"
"\x0a"
"template< typename op_t, typename arg_t, typename... args_t >\x0a"
"static arg_t lift( op_t op, arg_t arg, args_t... args )\x0a"
"{\x0a"
"    __lart_stash( op( arg, args... ).disown() );\x0a"
"    if constexpr ( std\x3a\x3ais_arithmetic_v< arg_t > )\x0a"
"        return arg + tainted;\x0a"
"    if constexpr ( std\x3a\x3ais_pointer_v< arg_t > )\x0a"
"        return static_cast< char * >( arg ) + tainted;\x0a"
"}\x0a"
"\x0a"
"template< typename dom, typename type >\x0a"
"static auto any()\x0a"
"{\x0a"
"    __lart_stash( dom\x3a\x3atemplate any< type >().disown() );\x0a"
"    if constexpr ( std\x3a\x3ais_pointer_v< type > )\x0a"
"        return reinterpret_cast< type >( uint64_t( tainted ) );\x0a"
"    else\x0a"
"        return static_cast< type >( tainted );\x0a"
"}\x0a"
"\x0a"
"#define export __invisible __flatten\x0a"
"#define scalar export __annotate( lart.abstract.return.scalar )\x0a"
"#define array  export __annotate( lart.abstract.return.aggregate )\x0a"
"\x0a"
"extern \x22""C\x22\x0a"
"{\x0a"
"    scalar i1  __lamp_lift_i1 ( i1  v )     { return lift( dom\x3a\x3alift_i1,  v ); }\x0a"
"    scalar i8  __lamp_lift_i8 ( i8  v )     { return lift( dom\x3a\x3alift_i8,  v ); }\x0a"
"    scalar i16 __lamp_lift_i16( i16 v )     { return lift( dom\x3a\x3alift_i16, v ); }\x0a"
"    scalar i32 __lamp_lift_i32( i32 v )     { return lift( dom\x3a\x3alift_i32, v ); }\x0a"
"    scalar i64 __lamp_lift_i64( i64 v )     { return lift( dom\x3a\x3alift_i64, v ); }\x0a"
"    scalar f32 __lamp_lift_f32( f32 v )     { return lift( dom\x3a\x3alift_f64, v ); }\x0a"
"    scalar f64 __lamp_lift_f64( f64 v )     { return lift( dom\x3a\x3alift_f64, v ); }\x0a"
"\x0a"
"    scalar ptr __lamp_wrap_i1 ( i1  v )     { return wrap( dom\x3a\x3alift_i1,  v ); }\x0a"
"    scalar ptr __lamp_wrap_i8 ( i8  v )     { return wrap( dom\x3a\x3alift_i8,  v ); }\x0a"
"    scalar ptr __lamp_wrap_i16( i16 v )     { return wrap( dom\x3a\x3alift_i16, v ); }\x0a"
"    scalar ptr __lamp_wrap_i32( i32 v )     { return wrap( dom\x3a\x3alift_i32, v ); }\x0a"
"    scalar ptr __lamp_wrap_i64( i64 v )     { return wrap( dom\x3a\x3alift_i64, v ); }\x0a"
"    scalar ptr __lamp_wrap_f32( f32 v )     { return wrap( dom\x3a\x3alift_f64, v ); }\x0a"
"    scalar ptr __lamp_wrap_f64( f64 v )     { return wrap( dom\x3a\x3alift_f64, v ); }\x0a"
"\x0a"
"    export ptr   __lamp_wrap_ptr( void *v ) { return wrap( dom\x3a\x3alift_ptr, v ); }\x0a"
"    export void *__lamp_lift_ptr( void *v ) { return lift( dom\x3a\x3alift_ptr, v ); }\x0a"
"\x0a"
"    array void *__lamp_lift_arr( void *v, int s ) { return lift( dom\x3a\x3alift_arr, v, s ); }\x0a"
"    array char *__lamp_lift_str( char *s ) { return lift( dom\x3a\x3alift_arr, s, strlen( s ) + 1 ); }\x0a"
"\x0a"
"    scalar i8    __lamp_any_i8()    { return any< dom, i8  >(); }\x0a"
"    scalar i16   __lamp_any_i16()   { return any< dom, i16 >(); }\x0a"
"    scalar i32   __lamp_any_i32()   { return any< dom, i32 >(); }\x0a"
"    scalar i64   __lamp_any_i64()   { return any< dom, i64 >(); }\x0a"
"    array  char *__lamp_any_array() { return any< dom, char * >(); }\x0a"
"\x0a"
"    /* TODO freeze, melt */\x0a"
"    export void __lamp_freeze( void *val, void *addr_ )\x0a"
"    {\x0a"
"        __vm_pointer_t addr = __vm_pointer_split( addr_ ),\x0a"
"                       ptr  = __vm_pointer_split( val );\x0a"
"        __vm_poke( _VM_ML_User, addr.obj, addr.off, 1, ptr.obj );\x0a"
"    }\x0a"
"\x0a"
"    export void *__lamp_melt( void *addr_ )\x0a"
"    {\x0a"
"        __vm_pointer_t addr = __vm_pointer_split( addr_ );\x0a"
"        auto m = __vm_peek( _VM_ML_User, addr.obj, addr.off, 1 );\x0a"
"        return __vm_pointer_make( m.value, 0 );\x0a"
"    }\x0a"
"\x0a"
"    export ptr __lamp_add ( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_add, a, b ); }\x0a"
"    export ptr __lamp_sub ( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_sub, a, b ); }\x0a"
"    export ptr __lamp_mul ( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_mul, a, b ); }\x0a"
"    export ptr __lamp_sdiv( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_sdiv, a, b ); }\x0a"
"    export ptr __lamp_udiv( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_udiv, a, b ); }\x0a"
"    export ptr __lamp_srem( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_srem, a, b ); }\x0a"
"    export ptr __lamp_urem( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_urem, a, b ); }\x0a"
"\x0a"
"    export ptr __lamp_fadd( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fadd, a, b ); }\x0a"
"    export ptr __lamp_fsub( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fsub, a, b ); }\x0a"
"    export ptr __lamp_fmul( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fmul, a, b ); }\x0a"
"    export ptr __lamp_fdiv( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fdiv, a, b ); }\x0a"
"    export ptr __lamp_frem( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_frem, a, b ); }\x0a"
"\x0a"
"    export ptr __lamp_shl ( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_shl,  a, b ); }\x0a"
"    export ptr __lamp_ashr( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_ashr, a, b ); }\x0a"
"    export ptr __lamp_lshr( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_lshr, a, b ); }\x0a"
"    export ptr __lamp_and ( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_and,  a, b ); }\x0a"
"    export ptr __lamp_or  ( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_or,   a, b ); }\x0a"
"    export ptr __lamp_xor ( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_xor,  a, b ); }\x0a"
"\x0a"
"    export ptr __lamp_eq ( ptr a, ptr b )  { return wrap( dom\x3a\x3aop_eq,  a, b ); }\x0a"
"    export ptr __lamp_ne ( ptr a, ptr b )  { return wrap( dom\x3a\x3aop_ne,  a, b ); }\x0a"
"    export ptr __lamp_ugt( ptr a, ptr b )  { return wrap( dom\x3a\x3aop_ugt, a, b ); }\x0a"
"    export ptr __lamp_uge( ptr a, ptr b )  { return wrap( dom\x3a\x3aop_uge, a, b ); }\x0a"
"    export ptr __lamp_ult( ptr a, ptr b )  { return wrap( dom\x3a\x3aop_ult, a, b ); }\x0a"
"    export ptr __lamp_ule( ptr a, ptr b )  { return wrap( dom\x3a\x3aop_ule, a, b ); }\x0a"
"    export ptr __lamp_sgt( ptr a, ptr b )  { return wrap( dom\x3a\x3aop_sgt, a, b ); }\x0a"
"    export ptr __lamp_sge( ptr a, ptr b )  { return wrap( dom\x3a\x3aop_sge, a, b ); }\x0a"
"    export ptr __lamp_slt( ptr a, ptr b )  { return wrap( dom\x3a\x3aop_slt, a, b ); }\x0a"
"    export ptr __lamp_sle( ptr a, ptr b )  { return wrap( dom\x3a\x3aop_sle, a, b ); }\x0a"
"\x0a"
"    export ptr __lamp_foeq( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_foeq, a, b ); }\x0a"
"    export ptr __lamp_fogt( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fogt, a, b ); }\x0a"
"    export ptr __lamp_foge( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_foge, a, b ); }\x0a"
"    export ptr __lamp_folt( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_folt, a, b ); }\x0a"
"    export ptr __lamp_fole( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fole, a, b ); }\x0a"
"    export ptr __lamp_ford( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_ford, a, b ); }\x0a"
"    export ptr __lamp_funo( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_funo, a, b ); }\x0a"
"    export ptr __lamp_fueq( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fueq, a, b ); }\x0a"
"    export ptr __lamp_fugt( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fugt, a, b ); }\x0a"
"    export ptr __lamp_fuge( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fuge, a, b ); }\x0a"
"    export ptr __lamp_fult( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fult, a, b ); }\x0a"
"    export ptr __lamp_fule( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_fule, a, b ); }\x0a"
"\x0a"
"    export ptr __lamp_ffalse( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_ffalse, a, b ); }\x0a"
"    export ptr __lamp_ftrue ( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_ftrue,  a, b ); }\x0a"
"\x0a"
"    export ptr __lamp_concat ( ptr a, ptr b ) { return wrap( dom\x3a\x3aop_concat,  a, b ); }\x0a"
"    export ptr __lamp_trunc  ( ptr a, bw  b ) { return wrap( dom\x3a\x3aop_trunc,   a, b ); }\x0a"
"    export ptr __lamp_fptrunc( ptr a, bw  b ) { return wrap( dom\x3a\x3aop_fptrunc, a, b ); }\x0a"
"    export ptr __lamp_sitofp ( ptr a, bw  b ) { return wrap( dom\x3a\x3aop_sitofp,  a, b ); }\x0a"
"    export ptr __lamp_uitofp ( ptr a, bw  b ) { return wrap( dom\x3a\x3aop_uitofp,  a, b ); }\x0a"
"    export ptr __lamp_zext   ( ptr a, bw  b ) { return wrap( dom\x3a\x3aop_zext,    a, b ); }\x0a"
"    export ptr __lamp_zfit   ( ptr a, bw  b ) { return wrap( dom\x3a\x3aop_zfit,    a, b ); }\x0a"
"    export ptr __lamp_sext   ( ptr a, bw  b ) { return wrap( dom\x3a\x3aop_sext,    a, b ); }\x0a"
"    export ptr __lamp_fpext  ( ptr a, bw  b ) { return wrap( dom\x3a\x3aop_fpext,   a, b ); }\x0a"
"    export ptr __lamp_fptosi ( ptr a, bw  b ) { return wrap( dom\x3a\x3aop_fptosi,  a, b ); }\x0a"
"    export ptr __lamp_fptoui ( ptr a, bw  b ) { return wrap( dom\x3a\x3aop_fptoui,  a, b ); }\x0a"
"\x0a"
"    export ptr __lamp_gep( ptr a, ptr b, uint64_t s )\x0a"
"    {\x0a"
"        return wrap( \x5b\x5d( auto... x ) { return dom\x3a\x3aop_gep( x ... ); }, a, b, s );\x0a"
"    }\x0a"
"\x0a"
"    export ptr __lamp_store( ptr a, ptr b, bw w )\x0a"
"    {\x0a"
"        return wrap( \x5b\x5d( auto... x ) { return dom\x3a\x3aop_store( x ... ); }, a, b, w );\x0a"
"    }\x0a"
"\x0a"
"    export ptr __lamp_load( ptr a, bw w ) { return wrap( dom\x3a\x3aop_load, a, w ); }\x0a"
"\x0a"
"    export uint8_t __lamp_to_tristate( ptr v )\x0a"
"    {\x0a"
"        dom a( v.ptr, dom\x3a\x3a""construct_shared );\x0a"
"        auto tri = dom\x3a\x3ato_tristate( a );\x0a"
"        a.disown();\x0a"
"        return tri.value;\x0a"
"    }\x0a"
"\x0a"
"    export ptr __lamp_assume( ptr a, ptr b, bool c ) { return wrap( dom\x3a\x3a""assume, a, b, c ); }\x0a"
"    export ptr __lamp_extract( ptr a, bw s, bw e ) { return wrap( dom\x3a\x3aop_extract, a, s, e ); }\x0a"
"    export bool __lamp_decide( uint8_t tr ) { return bool( __lava\x3a\x3atristate( tr ) ); }\x0a"
"\x0a"
"    scalar ptr __lamp_fn_strcmp( ptr a, ptr b ) { return wrap( dom\x3a\x3a""fn_strcmp, a, b ); }\x0a"
"    scalar ptr __lamp_fn_strcat( ptr a, ptr b ) { return wrap( dom\x3a\x3a""fn_strcat, a, b ); }\x0a"
"    scalar ptr __lamp_fn_strcpy( ptr a, ptr b ) { return wrap( dom\x3a\x3a""fn_strcpy, a, b ); }\x0a"
"    scalar ptr __lamp_fn_strlen( ptr a ) { return wrap( dom\x3a\x3a""fn_strlen, a ); }\x0a"
"\x0a"
"    scalar ptr __lamp_fn_strchr( ptr a, ptr b )\x0a"
"    {\x0a"
"        return wrap( \x5b\x5d( auto... x ) { return dom\x3a\x3a""fn_strchr( x... ); }, a, b );\x0a"
"    }\x0a"
"\x0a"
"    scalar ptr __lamp_fn_memcpy( ptr a, ptr b, ptr c )\x0a"
"    {\x0a"
"        return wrap( \x5b\x5d( auto... x ) { return dom\x3a\x3a""fn_memcpy( x... ); }, a, b, c );\x0a"
"    }\x0a"
"}\x0a"
"", 11474 ); }