#include <string_view>
namespace divine::str::dios {
extern const std::string_view lava_base_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2019 Henrich Lauko <xlauko\x40mail.muni.cz>\x0a"
" * (c) 2020 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"#include <sys/cdefs.h>\x0a"
"#include <sys/fault.h>\x0a"
"#include <util/array.hpp>\x0a"
"#include <cstdint>\x0a"
"\x0a"
"namespace __lava\x0a"
"{\x0a"
"    using bitwidth_t = uint8_t;\x0a"
"    using tag_t = uint8_t;\x0a"
"\x0a"
"    using pointer_type = _VM_PointerType;\x0a"
"\x0a"
"    template< pointer_type PT = _VM_PT_Heap >\x0a"
"    using array = __dios\x3a\x3a""Array< uint8_t, PT >;\x0a"
"\x0a"
"    template< pointer_type PT = _VM_PT_Heap >\x0a"
"    struct tagged_array \x3a array< PT >\x0a"
"    {\x0a"
"        using base = array< PT >;\x0a"
"        using typename base\x3a\x3aiterator;\x0a"
"\x0a"
"        template< typename F >\x0a"
"        void move_tag( F f )\x0a"
"        {\x0a"
"            uint8_t tag = base\x3a\x3a""back();\x0a"
"            f();\x0a"
"            base\x3a\x3a""back() = tag;\x0a"
"        }\x0a"
"\x0a"
"        using base\x3a\x3a""base;\x0a"
"\x0a"
"        tagged_array() { base\x3a\x3aresize( 1, -1 ); }\x0a"
"        tagged_array( const tagged_array \x26o, __dios\x3a\x3a""construct_shared_t s ) \x3a base( o, s ) {}\x0a"
"\x0a"
"        auto  end()       { return base\x3a\x3a""end() - 1; }\x0a"
"        auto  end() const { return base\x3a\x3a""end() - 1; }\x0a"
"        auto cend() const { return base\x3a\x3a""end() - 1; }\x0a"
"\x0a"
"        auto  rbegin()       { return base\x3a\x3arbegin() + 1; }\x0a"
"        auto  rbegin() const { return base\x3a\x3arbegin() + 1; }\x0a"
"        auto crbegin() const { return base\x3a\x3arbegin() + 1; }\x0a"
"\x0a"
"        auto       \x26""back()       { return *( end() - 1 ); }\x0a"
"        const auto \x26""back() const { return *( end() - 1 ); }\x0a"
"        uint8_t    \x26tag()        { return base\x3a\x3a""back(); }\x0a"
"        uint8_t     tag()  const { return base\x3a\x3a""back(); }\x0a"
"\x0a"
"        int  size()  const { return base\x3a\x3asize() - 1; }\x0a"
"        bool empty() const { return size() == 0; }\x0a"
"        void _grow() { base\x3a\x3apush_back( 0 ); }\x0a"
"        base       \x26raw()       { return *this; }\x0a"
"        const base \x26raw() const { return *this; }\x0a"
"\x0a"
"        void *unsafe_ptr() const\x0a"
"        {\x0a"
"            auto ptr = static_cast< const void * >( \x26*base\x3a\x3a""begin() );\x0a"
"            return const_cast< void * >( ptr );\x0a"
"        }\x0a"
"\x0a"
"        void push_back( uint8_t v )          { move_tag( \x5b\x26\x5d{ base\x3a\x3a""back() = v; _grow(); } ); }\x0a"
"        void emplace_back( uint8_t v )       { move_tag( \x5b\x26\x5d{ base\x3a\x3a""back() = v; _grow(); } ); }\x0a"
"        void resize( int sz )                { move_tag( \x5b\x26\x5d{ base\x3a\x3aresize( sz + 1 ); } ); }\x0a"
"        void clear()                         { move_tag( \x5b\x26\x5d{ base\x3a\x3aresize( 1 ); } ); }\x0a"
"        void pop_back()                      { move_tag( \x5b\x26\x5d{ base\x3a\x3apop_back(); } ); }\x0a"
"        void erase( iterator it )            { move_tag( \x5b\x26\x5d{ base\x3a\x3a""erase( it ); } ); }\x0a"
"        void erase( iterator b, iterator e ) { move_tag( \x5b\x26\x5d{ base\x3a\x3a""erase( b, e ); } ); }\x0a"
"        void insert( iterator i, uint8_t v ) { move_tag( \x5b\x26\x5d{ base\x3a\x3ainsert( i, v ); } ); }\x0a"
"    };\x0a"
"\x0a"
"    template< typename type >\x0a"
"    struct tagged_storage \x3a tagged_array<>\x0a"
"    {\x0a"
"        using base = tagged_array<>;\x0a"
"\x0a"
"        tagged_storage( void *v, __dios\x3a\x3a""construct_shared_t s ) \x3a base( v, s ) {}\x0a"
"\x0a"
"        template< typename... args_t >\x0a"
"        tagged_storage( args_t \x26\x26 ... args )\x0a"
"        {\x0a"
"            resize( sizeof( type ) );\x0a"
"            new ( \x26**this ) type( std\x3a\x3a""forward< args_t >( args ) ... );\x0a"
"        }\x0a"
"\x0a"
"        tagged_storage( const tagged_storage \x26o ) \x3a tagged_storage( o.get() ) {}\x0a"
"        tagged_storage( tagged_storage \x26\x26o ) \x3a tagged_storage( std\x3a\x3amove( o.get() ) ) {}\x0a"
"        tagged_storage \x26operator=( const tagged_storage \x26o ) { get() = o.get(); return *this; }\x0a"
"\x0a"
"        \x7etagged_storage()\x0a"
"        {\x0a"
"            if ( begin() )\x0a"
"                get().\x7etype();\x0a"
"        }\x0a"
"\x0a"
"        const type \x26operator*() const { return *reinterpret_cast< const type * >( begin() ); }\x0a"
"        type       \x26operator*()       { return *reinterpret_cast< type * >( begin() ); }\x0a"
"\x0a"
"        const type *operator->() const { return \x26**this; }\x0a"
"        type       *operator->()       { return \x26**this; }\x0a"
"\x0a"
"        type       \x26get()       { return **this; }\x0a"
"        const type \x26get() const { return **this; }\x0a"
"    };\x0a"
"\x0a"
"    using i1  = bool;\x0a"
"    using i8  = uint8_t;\x0a"
"    using i16 = uint16_t;\x0a"
"    using i32 = uint32_t;\x0a"
"    using i64 = uint64_t;\x0a"
"    using f32 = float;\x0a"
"    using f64 = double;\x0a"
"\x0a"
"    struct array_ref { void *base; size_t size; };\x0a"
"\x0a"
"    template< typename type >\x0a"
"    constexpr int bitwidth_v = std\x3a\x3ais_same_v< type, bool > \x3f 1 \x3a sizeof( type ) * 8;\x0a"
"\x0a"
"    template< typename self_t >\x0a"
"    struct domain_mixin\x0a"
"    {\x0a"
"        using st = self_t;\x0a"
"        using sr = const self_t \x26;\x0a"
"        using bw = bitwidth_t;\x0a"
"\x0a"
"        using index_dom = self_t;\x0a"
"        using scalar_dom = self_t;\x0a"
"\x0a"
"        static st lift_i1( i1 v )   { return st\x3a\x3alift( v ); }\x0a"
"        static st lift_i8( i8 v )   { return st\x3a\x3alift( v ); }\x0a"
"        static st lift_i16( i16 v ) { return st\x3a\x3alift( v ); }\x0a"
"        static st lift_i32( i32 v ) { return st\x3a\x3alift( v ); }\x0a"
"        static st lift_i64( i64 v ) { return st\x3a\x3alift( v ); }\x0a"
"        static st lift_f32( f32 v ) { return st\x3a\x3alift( v ); }\x0a"
"        static st lift_f64( f64 v ) { return st\x3a\x3alift( v ); }\x0a"
"\x0a"
"        static st lift_arr( void *v, size_t s ) { return st\x3a\x3alift( array_ref{ v, s } ); }\x0a"
"        static st lift_ptr( void *v )\x0a"
"        {\x0a"
"            return st\x3a\x3alift( reinterpret_cast< uintptr_t >( v ) );\x0a"
"        }\x0a"
"\x0a"
"        static st fail()\x0a"
"        {\x0a"
"            __dios_fault( _VM_F_NotImplemented, \x22unsupported abstract operation\x22 );\x0a"
"            __builtin_trap();\x0a"
"            // return st\x3a\x3a""any();\x0a"
"        }\x0a"
"\x0a"
"        static st op_not ( sr ) { return fail(); }\x0a"
"        static st op_neg ( sr ) { return fail(); }\x0a"
"\x0a"
"        static st op_add ( sr, sr ) { return fail(); }\x0a"
"        static st op_sub ( sr, sr ) { return fail(); }\x0a"
"        static st op_mul ( sr, sr ) { return fail(); }\x0a"
"        static st op_sdiv( sr, sr ) { return fail(); }\x0a"
"        static st op_udiv( sr, sr ) { return fail(); }\x0a"
"        static st op_srem( sr, sr ) { return fail(); }\x0a"
"        static st op_urem( sr, sr ) { return fail(); }\x0a"
"\x0a"
"        static st op_fadd( sr, sr ) { return fail(); }\x0a"
"        static st op_fsub( sr, sr ) { return fail(); }\x0a"
"        static st op_fmul( sr, sr ) { return fail(); }\x0a"
"        static st op_fdiv( sr, sr ) { return fail(); }\x0a"
"        static st op_frem( sr, sr ) { return fail(); }\x0a"
"\x0a"
"        static st op_shl ( sr, sr ) { return fail(); }\x0a"
"        static st op_ashr( sr, sr ) { return fail(); }\x0a"
"        static st op_lshr( sr, sr ) { return fail(); }\x0a"
"        static st op_and ( sr, sr ) { return fail(); }\x0a"
"        static st op_or  ( sr, sr ) { return fail(); }\x0a"
"        static st op_xor ( sr, sr ) { return fail(); }\x0a"
"\x0a"
"        static st op_eq ( sr, sr ) { return fail(); }\x0a"
"        static st op_ne ( sr, sr ) { return fail(); }\x0a"
"        static st op_ugt( sr, sr ) { return fail(); }\x0a"
"        static st op_uge( sr, sr ) { return fail(); }\x0a"
"        static st op_ult( sr, sr ) { return fail(); }\x0a"
"        static st op_ule( sr, sr ) { return fail(); }\x0a"
"        static st op_sgt( sr, sr ) { return fail(); }\x0a"
"        static st op_sge( sr, sr ) { return fail(); }\x0a"
"        static st op_slt( sr, sr ) { return fail(); }\x0a"
"        static st op_sle( sr, sr ) { return fail(); }\x0a"
"\x0a"
"        static st op_foeq( sr, sr ) { return fail(); }\x0a"
"        static st op_fogt( sr, sr ) { return fail(); }\x0a"
"        static st op_foge( sr, sr ) { return fail(); }\x0a"
"        static st op_folt( sr, sr ) { return fail(); }\x0a"
"        static st op_fole( sr, sr ) { return fail(); }\x0a"
"        static st op_ford( sr, sr ) { return fail(); }\x0a"
"        static st op_funo( sr, sr ) { return fail(); }\x0a"
"        static st op_fueq( sr, sr ) { return fail(); }\x0a"
"        static st op_fugt( sr, sr ) { return fail(); }\x0a"
"        static st op_fuge( sr, sr ) { return fail(); }\x0a"
"        static st op_fult( sr, sr ) { return fail(); }\x0a"
"        static st op_fule( sr, sr ) { return fail(); }\x0a"
"\x0a"
"        static st op_ffalse( sr, sr ) { return fail(); }\x0a"
"        static st op_ftrue ( sr, sr ) { return fail(); }\x0a"
"\x0a"
"        static st op_trunc  ( sr, bw ) { return fail(); }\x0a"
"        static st op_fptrunc( sr, bw ) { return fail(); }\x0a"
"        static st op_sitofp ( sr, bw ) { return fail(); }\x0a"
"        static st op_uitofp ( sr, bw ) { return fail(); }\x0a"
"        static st op_zext   ( sr, bw ) { return fail(); }\x0a"
"        static st op_zfit   ( sr, bw ) { return fail(); }\x0a"
"        static st op_sext   ( sr, bw ) { return fail(); }\x0a"
"        static st op_fpext  ( sr, bw ) { return fail(); }\x0a"
"        static st op_fptosi ( sr, bw ) { return fail(); }\x0a"
"        static st op_fptoui ( sr, bw ) { return fail(); }\x0a"
"\x0a"
"        static st op_concat ( sr, sr ) { return fail(); }\x0a"
"        static st op_extract( sr, bw, bw ) { return fail(); }\x0a"
"\x0a"
"        template< typename idx > static st op_gep( sr, idx, uint64_t ) { return fail(); }\x0a"
"        template< typename scal > static st op_store( sr, scal, bw ) { return fail(); }\x0a"
"        static st op_load( sr, bw ) { return fail(); }\x0a"
"\x0a"
"        static st fn_strcmp( sr, sr ) { return fail(); }\x0a"
"        static st fn_strcat( sr, sr ) { return fail(); }\x0a"
"        static st fn_strcpy( sr, sr ) { return fail(); }\x0a"
"        static st fn_strlen( sr ) { return fail(); }\x0a"
"\x0a"
"        template< typename chr > static st fn_strchr( sr, chr ) { return fail(); }\x0a"
"        template< typename idx > static st fn_memcpy( sr, sr, idx ) { return fail(); }\x0a"
"    };\x0a"
"}\x0a"
"", 9830 ); }