#include <string_view>
namespace divine::str::dios {
extern const std::string_view lava_constant_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2020 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" * (c) 2019 Henrich Lauko <xlauko\x40mail.muni.cz>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"#include \x22tristate.hpp\x22\x0a"
"#include \x22""base.hpp\x22\x0a"
"\x0a"
"#include <brick-assert>\x0a"
"\x0a"
"namespace __lava\x0a"
"{\x0a"
"    struct \x5b\x5bgnu\x3a\x3apacked\x5d\x5d constant_data\x0a"
"    {\x0a"
"        uint64_t value;\x0a"
"        enum type_t { bv, fp, ptr } type;\x0a"
"        bitwidth_t bw;\x0a"
"    };\x0a"
"\x0a"
"    using constant_storage = tagged_storage< constant_data >;\x0a"
"\x0a"
"    template< typename T > struct number_type { using type = T; };\x0a"
"    template< bool, int > struct number_;\x0a"
"\x0a"
"    template<> struct number_< true, 1 >  \x3a number_type< bool > {};\x0a"
"    template<> struct number_< true, 8 >  \x3a number_type< int8_t > {};\x0a"
"    template<> struct number_< true, 16 > \x3a number_type< int16_t > {};\x0a"
"    template<> struct number_< true, 32 > \x3a number_type< int32_t > {};\x0a"
"    template<> struct number_< true, 64 > \x3a number_type< int64_t > {};\x0a"
"\x0a"
"    template<> struct number_< false, 1 >  \x3a number_type< bool > {};\x0a"
"    template<> struct number_< false, 8 >  \x3a number_type< uint8_t > {};\x0a"
"    template<> struct number_< false, 16 > \x3a number_type< uint16_t > {};\x0a"
"    template<> struct number_< false, 32 > \x3a number_type< uint32_t > {};\x0a"
"    template<> struct number_< false, 64 > \x3a number_type< uint64_t > {};\x0a"
"\x0a"
"    template< bool s, int w >\x0a"
"    using number = typename number_< s, w >\x3a\x3atype;\x0a"
"\x0a"
"    struct constant \x3a constant_storage, domain_mixin< constant >\x0a"
"    {\x0a"
"        constant() = default;\x0a"
"        constant( void *v, __dios\x3a\x3a""construct_shared_t s ) \x3a constant_storage( v, s ) {}\x0a"
"        constant( constant_data\x3a\x3atype_t t, bitwidth_t bw, uint64_t v )\x0a"
"            \x3a tagged_storage< constant_data >( constant_data{ v, t, bw } )\x0a"
"        {}\x0a"
"\x0a"
"        template< typename concrete_t >\x0a"
"        static auto lift( concrete_t value )\x0a"
"            -> std\x3a\x3a""enable_if_t< std\x3a\x3ais_trivial_v< concrete_t >, constant >\x0a"
"        {\x0a"
"            static_assert( sizeof( concrete_t ) <= 8 );\x0a"
"\x0a"
"            uint64_t val;\x0a"
"            constant_data\x3a\x3atype_t type;\x0a"
"\x0a"
"            if constexpr ( std\x3a\x3ais_pointer_v< concrete_t > )\x0a"
"            {\x0a"
"                val = reinterpret_cast< uintptr_t >( value );\x0a"
"                type = constant_data\x3a\x3aptr;\x0a"
"            }\x0a"
"            else\x0a"
"                val = value;\x0a"
"\x0a"
"            if constexpr ( std\x3a\x3ais_integral_v< concrete_t > )\x0a"
"                type = constant_data\x3a\x3a""bv;\x0a"
"            if constexpr ( std\x3a\x3ais_floating_point_v< concrete_t > )\x0a"
"                type = constant_data\x3a\x3a""fp;\x0a"
"\x0a"
"            return { type, bitwidth_v< concrete_t >, val };\x0a"
"        }\x0a"
"\x0a"
"        static constant lift( array_ref ) { NOT_IMPLEMENTED(); }\x0a"
"\x0a"
"        template< typename > static constant any()\x0a"
"        {\x0a"
"            // UNREACHABLE( \x22""Constant domain does not provide lift_any operation\x22 );\x0a"
"        }\x0a"
"\x0a"
"        template< bool _signed, int bw >\x0a"
"        static number< _signed, bw > cast( const constant \x26""c )\x0a"
"        {\x0a"
"            return c->value;\x0a"
"        }\x0a"
"\x0a"
"        template< bool _signed, typename F, typename... val_t  >\x0a"
"        static constant with_type( F f_, const val_t \x26 ... vals )\x0a"
"        {\x0a"
"            bitwidth_t bw = std\x3a\x3amax( { vals->bw ... } );\x0a"
"            assert( ( ( bw == vals->bw ) \x26\x26 ... ) );\x0a"
"            const auto t_bv = constant_data\x3a\x3a""bv;\x0a"
"            auto f = \x5b\x26\x5d( const auto \x26 ... x ) -> uint64_t { return f_( x... ); };\x0a"
"\x0a"
"            if ( ( ( vals->type == constant_data\x3a\x3a""bv ) \x26\x26 ... ) )\x0a"
"                switch ( bw )\x0a"
"                {\x0a"
"                    case  1\x3a return { t_bv, bw, f( cast< _signed,  1 >( vals ) ... ) };\x0a"
"                    case  8\x3a return { t_bv, bw, f( cast< _signed,  8 >( vals ) ... ) };\x0a"
"                    case 16\x3a return { t_bv, bw, f( cast< _signed, 16 >( vals ) ... ) };\x0a"
"                    case 32\x3a return { t_bv, bw, f( cast< _signed, 32 >( vals ) ... ) };\x0a"
"                    case 64\x3a return { t_bv, bw, f( cast< _signed, 64 >( vals ) ... ) };\x0a"
"                }\x0a"
"\x0a"
"            __builtin_trap();\x0a"
"        }\x0a"
"\x0a"
"        static constexpr auto wtu = \x5b\x5d( const auto \x26 ... xs ) { return with_type< false >( xs... ); };\x0a"
"        static constexpr auto wts = \x5b\x5d( const auto \x26 ... xs ) { return with_type< true  >( xs... ); };\x0a"
"\x0a"
"        static uint64_t mask( bitwidth_t bw )\x0a"
"        {\x0a"
"            return bw \x3f ( ( 1ull << ( bw - 1 ) ) \x7c mask( bw - 1 ) ) \x3a 0;\x0a"
"        }\x0a"
"\x0a"
"        static constant set_bw( const constant \x26""c, bitwidth_t bw )\x0a"
"        {\x0a"
"            auto rv = c;\x0a"
"            rv->bw = bw;\x0a"
"            rv->value \x26= mask( bw );\x0a"
"            return rv;\x0a"
"        }\x0a"
"\x0a"
"        static tristate to_tristate( const constant \x26val )\x0a"
"        {\x0a"
"            if ( val->value )\x0a"
"                return { tristate\x3a\x3ayes };\x0a"
"            else\x0a"
"                return { tristate\x3a\x3ano };\x0a"
"        }\x0a"
"\x0a"
"        static constant assume( const constant \x26v, const constant \x26""c, bool expect )\x0a"
"        {\x0a"
"            if ( c->value \x21= expect )\x0a"
"                __vm_cancel();\x0a"
"            return v;\x0a"
"        }\x0a"
"\x0a"
"        using cv = constant;\x0a"
"        using cr = const constant \x26;\x0a"
"\x0a"
"        static cv op_not ( cr a ) { return wtu( std\x3a\x3alogical_not(), a ); }\x0a"
"        static cv op_neg ( cr a ) { return wtu( std\x3a\x3a""bit_not(), a ); }\x0a"
"\x0a"
"        static cv op_add ( cr a, cr b ) { return wtu( std\x3a\x3aplus(), a, b ); }\x0a"
"        static cv op_sub ( cr a, cr b ) { return wtu( std\x3a\x3aminus(), a, b ); }\x0a"
"        static cv op_mul ( cr a, cr b ) { return wtu( std\x3a\x3amultiplies(), a, b ); }\x0a"
"        static cv op_sdiv( cr a, cr b ) { return wts( std\x3a\x3a""divides(), a, b ); }\x0a"
"        static cv op_udiv( cr a, cr b ) { return wtu( std\x3a\x3a""divides(), a, b ); }\x0a"
"        static cv op_srem( cr a, cr b ) { return wts( std\x3a\x3amodulus(), a, b ); }\x0a"
"        static cv op_urem( cr a, cr b ) { return wtu( std\x3a\x3amodulus(), a, b ); }\x0a"
"\x0a"
"        static cv op_and( cr a, cr b ) { return wtu( std\x3a\x3a""bit_and(), a, b ); }\x0a"
"        static cv op_or ( cr a, cr b ) { return wtu( std\x3a\x3a""bit_or(), a, b ); }\x0a"
"        static cv op_xor( cr a, cr b ) { return wtu( std\x3a\x3a""bit_xor(), a, b ); }\x0a"
"\x0a"
"        static constexpr auto shl = \x5b\x5d( auto a, auto b ) { return a << b; };\x0a"
"        static constexpr auto shr = \x5b\x5d( auto a, auto b ) { return a >> b; };\x0a"
"\x0a"
"        static cv op_shl ( cr a, cr b ) { return wtu( shl, a, b ); }\x0a"
"        static cv op_ashr( cr a, cr b ) { return wts( shr, a, b ); }\x0a"
"        static cv op_lshr( cr a, cr b ) { return wtu( shr, a, b ); }\x0a"
"\x0a"
"        static cv op_eq ( cr a, cr b ) { return wtu( std\x3a\x3a""equal_to(), a, b ); }\x0a"
"        static cv op_ne ( cr a, cr b ) { return wtu( std\x3a\x3anot_equal_to(), a, b ); }\x0a"
"        static cv op_ult( cr a, cr b ) { return wtu( std\x3a\x3aless(), a, b ); }\x0a"
"        static cv op_ugt( cr a, cr b ) { return wtu( std\x3a\x3agreater(), a, b ); }\x0a"
"        static cv op_ule( cr a, cr b ) { return wtu( std\x3a\x3aless_equal(), a, b ); }\x0a"
"        static cv op_uge( cr a, cr b ) { return wtu( std\x3a\x3agreater_equal(), a, b ); }\x0a"
"\x0a"
"        static cv op_slt( cr a, cr b ) { return wts( std\x3a\x3aless(), a, b ); }\x0a"
"        static cv op_sgt( cr a, cr b ) { return wts( std\x3a\x3agreater(), a, b ); }\x0a"
"        static cv op_sle( cr a, cr b ) { return wts( std\x3a\x3aless_equal(), a, b ); }\x0a"
"        static cv op_sge( cr a, cr b ) { return wts( std\x3a\x3agreater_equal(), a, b ); }\x0a"
"\x0a"
"        static cv op_trunc( cv c, bw w ) { return set_bw( c, w ); }\x0a"
"        static cv op_zext( cv c, bw w )  { return set_bw( c, w ); }\x0a"
"        static cv op_zfit( cv c, bw w )  { return set_bw( c, w ); }\x0a"
"        static cv op_sext( cv c, bw w )\x0a"
"        {\x0a"
"            return set_bw( wts( \x5b\x5d( auto v ) { return int64_t( v ); }, c ), w );\x0a"
"        }\x0a"
"\x0a"
"        static void trace( constant ptr, const char * msg = \x22\x22 )\x0a"
"        {\x0a"
"            __dios_trace_f( \x22\x25s\x25""d\x22, msg, ptr->value );\x0a"
"        };\x0a"
"    };\x0a"
"\x0a"
"    static_assert( sizeof( constant ) == 8 );\x0a"
"}\x0a"
"", 8327 ); }