#include <string_view>
namespace divine::str::dios {
extern const std::string_view lava_mstring_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2020 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" * (c) 2019 Henrich Lauko <xlauko\x40mail.muni.cz>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"#include \x22""base.hpp\x22\x0a"
"#include \x22scalar.hpp\x22\x0a"
"#include <brick-ptr>\x0a"
"\x0a"
"namespace __lava\x0a"
"{\x0a"
"    struct base \x3a brq\x3a\x3arefcount_base< uint16_t, false /* atomic */ >\x0a"
"    {\x0a"
"        static void* operator new( size_t s ) { return __vm_obj_make( s, _VM_PT_Heap ); }\x0a"
"        static void operator delete( void *p ) { return __vm_obj_free( p ); }\x0a"
"    };\x0a"
"\x0a"
"    template< typename index_t, typename char_t >\x0a"
"    struct mstring_data\x0a"
"    {\x0a"
"        using values_t = __dios\x3a\x3a""Array< char_t, _VM_PT_Weak >;\x0a"
"        using bounds_t = __dios\x3a\x3a""Array< index_t, _VM_PT_Weak >;\x0a"
"\x0a"
"        struct content_t \x3a base\x0a"
"        {\x0a"
"            values_t values;\x0a"
"            bounds_t bounds;\x0a"
"            index_t size;\x0a"
"\x0a"
"            explicit content_t( index_t sz ) \x3a size( sz ) {}\x0a"
"        };\x0a"
"\x0a"
"        using content_ptr = brq\x3a\x3arefcount_ptr< content_t >;\x0a"
"\x0a"
"        index_t offset;\x0a"
"        content_ptr content;\x0a"
"\x0a"
"        mstring_data( content_ptr c, index_t off ) \x3a offset( off ), content( c ) {}\x0a"
"    };\x0a"
"\x0a"
"    template< typename index_dom_, typename char_dom >\x0a"
"    struct mstring \x3a tagged_storage< mstring_data< scalar< index_dom_ >, scalar< char_dom > > >,\x0a"
"                     domain_mixin< mstring< index_dom_, char_dom > >\x0a"
"    {\x0a"
"        using index_dom = index_dom_;\x0a"
"        using scalar_dom = char_dom;\x0a"
"\x0a"
"        using index_t = scalar< index_dom >;\x0a"
"        using char_t  = scalar< char_dom >;\x0a"
"        using data_t  = mstring_data< index_t, char_t >;\x0a"
"        using base    = tagged_storage< data_t >;\x0a"
"        using mref    = const mstring \x26;\x0a"
"\x0a"
"        using content_ptr = typename data_t\x3a\x3a""content_ptr;\x0a"
"        using content_t   = typename data_t\x3a\x3a""content_t;\x0a"
"        using values_t    = typename data_t\x3a\x3avalues_t;\x0a"
"        using bounds_t    = typename data_t\x3a\x3a""bounds_t;\x0a"
"\x0a"
"        using values_iterator = typename values_t\x3a\x3aiterator;\x0a"
"        using bounds_iterator = typename bounds_t\x3a\x3aiterator;\x0a"
"\x0a"
"        using base\x3a\x3aget;\x0a"
"\x0a"
"        static void fault( const char * msg, _VM_Fault fault_v = _VM_F_Assert )\x0a"
"        {\x0a"
"            __dios_fault( fault_v, msg );\x0a"
"        }\x0a"
"\x0a"
"        static void out_of_bounds_fault()\x0a"
"        {\x0a"
"            fault( \x22""Access out of bounds.\x22, _VM_F_Memory );\x0a"
"        }\x0a"
"\x0a"
"        auto        data()    const { return get().content; }\x0a"
"        auto       \x26""content() const { return *data(); }\x0a"
"        auto       \x26""bounds()        { return content().bounds; }\x0a"
"        const auto \x26""bounds()  const { return content().bounds; }\x0a"
"        auto       \x26values()        { return content().values; }\x0a"
"        const auto \x26values()  const { return content().values; }\x0a"
"\x0a"
"        const index_t \x26size()   const { return content().size; }\x0a"
"        const index_t \x26offset() const { return get().offset; }\x0a"
"\x0a"
"        const index_t \x26""checked_offset() const\x0a"
"        {\x0a"
"            if ( offset() >= size() )\x0a"
"                out_of_bounds_fault();\x0a"
"            return offset();\x0a"
"        }\x0a"
"\x0a"
"        void push_bound( index_t bound ) { bounds().push_back( bound ); }\x0a"
"        void push_bound( uint64_t b ) { push_bound( index_t\x3a\x3alift( b ) ); }\x0a"
"        void push_char( char_t ch ) { values().push_back( ch ); }\x0a"
"        void push_char( char ch ) { push_char( char_t\x3a\x3alift( ch ) ); }\x0a"
"\x0a"
"        mstring( content_ptr content, index_t offset )\x0a"
"            \x3a base( data_t{ content, offset } )\x0a"
"        {}\x0a"
"\x0a"
"        mstring( index_t size )\x0a"
"            \x3a mstring( brq\x3a\x3amake_refcount< content_t >( size ), index_t\x3a\x3alift( 0ul ) )\x0a"
"        {}\x0a"
"\x0a"
"        mstring( void *v, __dios\x3a\x3a""construct_shared_t s ) \x3a base( v, s ) {}\x0a"
"\x0a"
"        template< typename T >\x0a"
"        static mstring any()\x0a"
"        {\x0a"
"            return { index_t\x3a\x3atemplate any< size_t >() };\x0a"
"        }\x0a"
"\x0a"
"        static mstring assume( mref s, mref, bool ) { return s; }\x0a"
"        static tristate to_tristate( mref ) { return tristate\x3a\x3ayes; }\x0a"
"\x0a"
"        template< typename T >\x0a"
"        static std\x3a\x3a""enable_if_t< std\x3a\x3ais_integral_v< T >, mstring > lift( T t )\x0a"
"        {\x0a"
"            return { nullptr, index_t\x3a\x3alift( t ) };\x0a"
"        }\x0a"
"\x0a"
"        static mstring lift( float ) { NOT_IMPLEMENTED(); }\x0a"
"        static mstring lift( const index_dom \x26idx ) { return { nullptr, index_t( idx ) }; }\x0a"
"\x0a"
"        static mstring lift( array_ref arr )\x0a"
"        {\x0a"
"            auto str = static_cast< char * >( arr.base );\x0a"
"\x0a"
"            mstring mstr( index_t\x3a\x3alift( arr.size ) );\x0a"
"            mstr.push_bound( uint64_t( 0 ) );\x0a"
"\x0a"
"            if ( arr.size == 0 )\x0a"
"                return mstr;\x0a"
"\x0a"
"            char prev = str\x5b 0 \x5d;\x0a"
"\x0a"
"            for ( uint64_t i = 1; i < arr.size; ++i )\x0a"
"            {\x0a"
"                if ( prev \x21= str\x5b i \x5d )\x0a"
"                {\x0a"
"                    mstr.push_char( prev );\x0a"
"                    mstr.push_bound( i );\x0a"
"                    prev = str\x5b i \x5d;\x0a"
"                }\x0a"
"            }\x0a"
"\x0a"
"            mstr.push_char( prev );\x0a"
"            mstr.push_bound( arr.size );\x0a"
"\x0a"
"            return mstr;\x0a"
"        }\x0a"
"\x0a"
"        /* implementation of abstraction interface */\x0a"
"\x0a"
"        struct segment_t\x0a"
"        {\x0a"
"            bounds_iterator _from;\x0a"
"            values_iterator _value;\x0a"
"\x0a"
"            bounds_iterator begin() { return _from; }\x0a"
"            bounds_iterator begin() const { return _from; }\x0a"
"            bounds_iterator end() { return std\x3a\x3anext( begin(), 2 ); }\x0a"
"            bounds_iterator end() const { return std\x3a\x3anext( begin(), 2 ); }\x0a"
"\x0a"
"            index_t \x26""from()  const { return *begin(); }\x0a"
"            index_t \x26to()    const { return *std\x3a\x3anext( begin() ); }\x0a"
"            char_t  \x26value() const { return *_value; }\x0a"
"\x0a"
"            void set_char( char_t ch ) { *_value = ch; }\x0a"
"\x0a"
"            char_t \x26operator*() \x26 { return *_value; }\x0a"
"            char_t \x26operator*() \x26\x26 = delete;\x0a"
"            char_t *operator->() const { return _value; }\x0a"
"\x0a"
"            friend bool operator==( const segment_t \x26lhs, const segment_t \x26rhs )\x0a"
"            {\x0a"
"                return std\x3a\x3atie( lhs._from, lhs._value ) == std\x3a\x3atie( rhs._from, rhs._value );\x0a"
"            }\x0a"
"\x0a"
"            friend bool operator\x21=( const segment_t \x26lhs, const segment_t \x26rhs )\x0a"
"            {\x0a"
"                return \x21(lhs == rhs );\x0a"
"            }\x0a"
"\x0a"
"            inline segment_t\x26 operator+=( const int\x26 rhs )\x0a"
"            {\x0a"
"                _from += rhs;\x0a"
"                _value += rhs;\x0a"
"                return *this;\x0a"
"            }\x0a"
"\x0a"
"            inline segment_t\x26 operator-=( const int\x26 rhs )\x0a"
"            {\x0a"
"                _from -= rhs;\x0a"
"                _value -= rhs;\x0a"
"                return *this;\x0a"
"            }\x0a"
"\x0a"
"            segment_t\x26 operator++()\x0a"
"            {\x0a"
"                ++_from;\x0a"
"                ++_value;\x0a"
"                return *this;\x0a"
"            }\x0a"
"\x0a"
"            segment_t operator++(int)\x0a"
"            {\x0a"
"                segment_t tmp(*this);\x0a"
"                operator++();\x0a"
"                return tmp;\x0a"
"            }\x0a"
"\x0a"
"            segment_t\x26 operator--()\x0a"
"            {\x0a"
"                --_from; --_value;\x0a"
"                return *this;\x0a"
"            }\x0a"
"\x0a"
"            segment_t operator--(int)\x0a"
"            {\x0a"
"                segment_t tmp(*this);\x0a"
"                operator++();\x0a"
"                return tmp;\x0a"
"            }\x0a"
"\x0a"
"            bool empty() const { return static_cast< bool >( from() == to() ); }\x0a"
"            bool has_value( char ch ) const { return has_value( char_t\x3a\x3alift( ch ) ); }\x0a"
"\x0a"
"            bool has_value( char_t ch ) const\x0a"
"            {\x0a"
"                if ( empty() )\x0a"
"                    return false;\x0a"
"                return static_cast< bool >( value() == ch );\x0a"
"            }\x0a"
"\x0a"
"            bool singleton() const\x0a"
"            {\x0a"
"                return static_cast< bool >( from() + index_t\x3a\x3alift( uint64_t( 1 ) ) == to() );\x0a"
"            }\x0a"
"        };\x0a"
"\x0a"
"        struct segments_range\x0a"
"        {\x0a"
"            template< typename iterator_t >\x0a"
"            struct range_t\x0a"
"            {\x0a"
"                iterator_t _begin;\x0a"
"                iterator_t _end;\x0a"
"\x0a"
"                auto begin() { return _begin; }\x0a"
"                auto begin() const { return _begin; }\x0a"
"                auto end() { return _end; }\x0a"
"                auto end() const { return _end; }\x0a"
"            };\x0a"
"\x0a"
"            segment_t begin() { return { bounds.begin(), values.begin() }; }\x0a"
"            segment_t end() { return { bounds.end(), values.end() }; }\x0a"
"\x0a"
"            segment_t next_segment( segment_t seg )\x0a"
"            {\x0a"
"                do { ++seg; } while ( seg.begin() \x21= bounds.end() \x26\x26 seg.empty() );\x0a"
"                return seg;\x0a"
"            }\x0a"
"\x0a"
"            segment_t terminal() const\x0a"
"            {\x0a"
"                return { std\x3a\x3aprev( bounds.end() ), std\x3a\x3aprev( values.end() ) };\x0a"
"            }\x0a"
"\x0a"
"            range_t< bounds_iterator > bounds;\x0a"
"            range_t< values_iterator > values;\x0a"
"        };\x0a"
"\x0a"
"        segments_range range( segment_t f, segment_t t ) const\x0a"
"        {\x0a"
"            return { { f.begin(), std\x3a\x3anext( t.begin() ) }, { f._value, std\x3a\x3anext( t._value ) } };\x0a"
"        }\x0a"
"\x0a"
"        segments_range range( index_t from, index_t to ) const\x0a"
"        {\x0a"
"            auto f = segment_at_index( from );\x0a"
"            auto t = segment_at_index( to );\x0a"
"            return range( f, t );\x0a"
"        }\x0a"
"\x0a"
"        segments_range interest() const\x0a"
"        {\x0a"
"            return range( segment_at_current_offset(), terminal_segment() );\x0a"
"        }\x0a"
"\x0a"
"        static char_dom op_load( mref array, bitwidth_t bw )\x0a"
"        {\x0a"
"            if ( bw \x21= 8 )\x0a"
"                fault( \x22unexpected load bitwidth\x22 );\x0a"
"\x0a"
"            return array.segment_at_current_offset().value();\x0a"
"        }\x0a"
"\x0a"
"        void store( const char_t \x26""ch, const index_t \x26idx )\x0a"
"        {\x0a"
"            auto one = index_t\x3a\x3alift( uint64_t( 1 ) );\x0a"
"            auto seg = segment_at_index( idx );\x0a"
"\x0a"
"            if ( seg.value() == ch )\x0a"
"                ; // do nothing\x0a"
"            else if ( seg.singleton() )\x0a"
"                // rewrite single character segment\x0a"
"                seg.set_char( ch );\x0a"
"            else if ( seg.from() == idx )\x0a"
"            {\x0a"
"                // rewrite first character of segment\x0a"
"                if ( seg.begin() \x21= bounds().begin() )\x0a"
"                {\x0a"
"                    auto prev = seg; --prev;\x0a"
"                    if ( prev.value() == ch )\x0a"
"                    {\x0a"
"                        // merge with left neighbour\x0a"
"                        seg.from() = seg.from() + one;\x0a"
"                        return;\x0a"
"                    }\x0a"
"                }\x0a"
"\x0a"
"                bounds().insert( std\x3a\x3anext( seg.begin() ), idx + one );\x0a"
"                values().insert( \x26seg.value(), ch );\x0a"
"            }\x0a"
"            else if ( seg.to() - one == idx )\x0a"
"            {\x0a"
"                // rewrite last character of segment\x0a"
"                if ( seg.end() \x21= bounds().end() )\x0a"
"                {\x0a"
"                    auto next = seg; ++next;\x0a"
"                    if ( next.value() == ch )\x0a"
"                    {\x0a"
"                        // merge with left neighbour\x0a"
"                        seg.to() = seg.to() - one;\x0a"
"                        return;\x0a"
"                    }\x0a"
"                }\x0a"
"                bounds().insert( std\x3a\x3anext( seg.begin() ), idx );\x0a"
"                values().insert( std\x3a\x3anext( \x26seg.value() ), ch );\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                // rewrite segment in the middle (split segment)\x0a"
"                auto seg_v = seg.value();\x0a"
"                auto vit = values().insert( \x26seg.value(), seg_v );\x0a"
"                values().insert( std\x3a\x3anext( vit ), ch );\x0a"
"                auto bit = bounds().insert( std\x3a\x3anext( seg.begin() ), idx );\x0a"
"                bounds().insert( std\x3a\x3anext( bit ), idx + one );\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"        template< typename char_in >\x0a"
"        static mstring op_store( mref array, const char_in \x26value, bitwidth_t bw )\x0a"
"        {\x0a"
"            if constexpr ( std\x3a\x3ais_same_v< char_in, char_dom > )\x0a"
"            {\x0a"
"                if ( bw \x21= 8 )\x0a"
"                    fault( \x22unexpected store bitwidth\x22 );\x0a"
"\x0a"
"                auto \x26str = const_cast< mstring \x26 >( array );\x0a"
"                str.store( char_t( value ).zfit( 8 ), array.checked_offset() );\x0a"
"                return { nullptr, index_t\x3a\x3alift( 0ul ) };\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                __dios_trace_f( \x22""boom \x25s\x22, __PRETTY_FUNCTION__ );\x0a"
"                __builtin_trap();\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"        template< typename index_in >\x0a"
"        static mstring op_gep( mref array, const index_in \x26idx, size_t elem_size )\x0a"
"        {\x0a"
"            ASSERT_EQ( elem_size, 8 ); /* FIXME */\x0a"
"            if constexpr ( std\x3a\x3ais_same_v< index_in, index_dom > )\x0a"
"                return { array.data(), array.offset() + index_t( idx ) };\x0a"
"            else\x0a"
"                __builtin_trap();\x0a"
"        }\x0a"
"\x0a"
"        static index_dom op_sub( mref lhs, mref rhs )\x0a"
"        {\x0a"
"            if ( \x26lhs.content() \x21= \x26rhs.content() )\x0a"
"                fault( \x22""comparing pointers of different objects\x22 );\x0a"
"            return lhs.offset() - rhs.offset();\x0a"
"        }\x0a"
"\x0a"
"        static index_dom op_eq( mref lhs, mref rhs )\x0a"
"        {\x0a"
"            if ( \x21lhs.data() \x7c\x7c \x21rhs.data() \x7c\x7c ( lhs.data() \x21= rhs.data() ) )\x0a"
"                return index_t\x3a\x3alift( false );\x0a"
"            else\x0a"
"                return lhs.offset() == rhs.offset();\x0a"
"        }\x0a"
"\x0a"
"        static mstring op_zfit( mref str, uint8_t ) { return str; }\x0a"
"\x0a"
"        static index_dom fn_strlen( mref str )\x0a"
"        {\x0a"
"            return ( str.terminator() - str.offset() ).zfit( 64 );\x0a"
"        }\x0a"
"\x0a"
"        static scalar_dom fn_strcmp( mref lhs, mref rhs )\x0a"
"        {\x0a"
"            auto lin = lhs.interest();\x0a"
"            auto rin = rhs.interest();\x0a"
"\x0a"
"            auto lseg = lin.begin();\x0a"
"            if ( lseg.empty() )\x0a"
"                lseg = lin.next_segment( lseg );\x0a"
"            auto rseg = rin.begin();\x0a"
"            if ( rseg.empty() )\x0a"
"                rseg = rin.next_segment( rseg );\x0a"
"\x0a"
"            while ( lseg \x21= lin.terminal() \x26\x26 rseg \x21= rin.terminal() )\x0a"
"            {\x0a"
"                if ( lseg.value() \x21= rseg.value() )\x0a"
"                    return ( lseg.value() - rseg.value() ).zfit( 32 );\x0a"
"                else\x0a"
"                {\x0a"
"                    index_t left = lseg.to() - lhs.offset();\x0a"
"                    index_t right = rseg.to() - rhs.offset();\x0a"
"                    if ( left > right )\x0a"
"                        return ( lseg.value() - rin.next_segment( rseg ).value() ).zfit( 32 );\x0a"
"                    else if ( left < right )\x0a"
"                        return ( lin.next_segment( lseg ).value() - rseg.value() ).zfit( 32 );\x0a"
"                }\x0a"
"\x0a"
"                lseg = lin.next_segment( lseg );\x0a"
"                rseg = rin.next_segment( rseg );\x0a"
"            }\x0a"
"\x0a"
"            return ( lseg.value() - rseg.value() ).zfit( 32 );\x0a"
"        }\x0a"
"\x0a"
"        static mstring fn_strcat( mref dst, mref src ) /* TODO optimize */\x0a"
"        {\x0a"
"            auto off = dst.offset();\x0a"
"            auto size = src.terminator() - src.offset();\x0a"
"            const_cast< mstring \x26 >( dst ).get().offset = dst.terminator();\x0a"
"            auto ret = memcpy( dst, src, size );\x0a"
"            ret.get().offset = off;\x0a"
"            return ret;\x0a"
"        }\x0a"
"\x0a"
"        static mstring fn_strcpy( mref dst, mref src ) /* TODO optimize */\x0a"
"        {\x0a"
"            auto size = index_t( fn_strlen( src ) ) + index_t\x3a\x3alift( size_t( 1 ) );\x0a"
"            return memcpy( dst, src, size );\x0a"
"        }\x0a"
"\x0a"
"        static mstring fn_strchr( mref str, const char_dom \x26""ch_ )\x0a"
"        {\x0a"
"            auto ch = char_t( ch_ ).zfit( 8 );\x0a"
"            auto seg = str.segment_at_current_offset();\x0a"
"            int iter = 0;\x0a"
"\x0a"
"            while ( \x21str.is_beyond_last_segment( seg ) )\x0a"
"            {\x0a"
"                if ( seg.has_value( ch ) )\x0a"
"                {\x0a"
"                    auto off = seg.from();\x0a"
"                    if ( seg.begin() == str.bounds().begin() )\x0a"
"                        return str;\x0a"
"                    return { str.data(), off };\x0a"
"                }\x0a"
"                ++seg;\x0a"
"            }\x0a"
"\x0a"
"            return { nullptr, index_t\x3a\x3alift( 0ul ) };\x0a"
"        }\x0a"
"\x0a"
"        template< typename char_in >\x0a"
"        static mstring fn_strchr( mref str, const char_in \x26 )\x0a"
"        {\x0a"
"            __builtin_trap();\x0a"
"        }\x0a"
"\x0a"
"        static mstring memcpy( mref dst, mref src, const index_dom \x26size_ )\x0a"
"        {\x0a"
"            index_t size( size_ );\x0a"
"\x0a"
"            if ( size > dst.size() - dst.offset() )\x0a"
"                fault( \x22""copying to a smaller string\x22 );\x0a"
"\x0a"
"            if ( size == index_t\x3a\x3alift( uint64_t( 0 ) ) )\x0a"
"                return dst;\x0a"
"\x0a"
"            auto dseg = dst.segment_at_current_offset();\x0a"
"            auto sseg = src.segment_at_current_offset();\x0a"
"\x0a"
"            const auto *dseg_begin = dseg.begin();\x0a"
"            const auto *dseg_end = \x26""dseg.value();\x0a"
"\x0a"
"            bounds_t bounds;\x0a"
"            values_t values;\x0a"
"\x0a"
"            std\x3a\x3a""copy( dst.bounds().begin(), dseg_begin, std\x3a\x3a""back_inserter( bounds ) );\x0a"
"            std\x3a\x3a""copy( dst.values().begin(), dseg_end, std\x3a\x3a""back_inserter( values ) );\x0a"
"\x0a"
"            if ( dseg.from() == dst.offset() )\x0a"
"                bounds.push_back( dseg.from() );\x0a"
"            else\x0a"
"            {\x0a"
"                bounds.push_back( dseg.from() );\x0a"
"                if ( dseg.value() \x21= sseg.value() )\x0a"
"                {\x0a"
"                    values.push_back( dseg.value() );\x0a"
"                    bounds.push_back( dst.offset() );\x0a"
"                }\x0a"
"            }\x0a"
"\x0a"
"            if ( values.size() > 0 \x26\x26 static_cast< bool >( values.back() == sseg.value() ) )\x0a"
"            {\x0a"
"                values.pop_back();\x0a"
"                bounds.pop_back();\x0a"
"            }\x0a"
"\x0a"
"            while ( ( sseg.from() - src.offset() ) < size )\x0a"
"            {\x0a"
"                bounds.push_back( dst.offset() + ( sseg.to() - src.offset() ) );\x0a"
"                values.push_back( sseg.value() );\x0a"
"                ++sseg;\x0a"
"            }\x0a"
"\x0a"
"            if ( dst.size() > dst.offset() + size )\x0a"
"            {\x0a"
"                auto seg = dst.segment_at_index( dst.offset() + size );\x0a"
"                if ( dseg.value() == values.back() )\x0a"
"                {\x0a"
"                    // we will take the value from dst suffix\x0a"
"                    bounds.pop_back();\x0a"
"                    values.pop_back();\x0a"
"                }\x0a"
"\x0a"
"                const auto *dseg_begin = dseg.begin();\x0a"
"                const auto *dseg_end = \x26""dseg.value();\x0a"
"\x0a"
"                std\x3a\x3a""copy( std\x3a\x3anext( dseg_begin ), dst.bounds().end(), std\x3a\x3a""back_inserter( bounds ) );\x0a"
"                std\x3a\x3a""copy( dseg_end, dst.values().end(), std\x3a\x3a""back_inserter( values ) );\x0a"
"            }\x0a"
"\x0a"
"            dst.content().bounds = std\x3a\x3amove( bounds );\x0a"
"            dst.content().values = std\x3a\x3amove( values );\x0a"
"            return dst;\x0a"
"        }\x0a"
"\x0a"
"        template< typename index_in >\x0a"
"        static mstring fn_memcpy( mref dst, mref src, const index_in \x26size )\x0a"
"        {\x0a"
"            if constexpr ( std\x3a\x3ais_same_v< index_in, index_dom > )\x0a"
"                return memcpy( dst, src, size );\x0a"
"            else\x0a"
"                __builtin_trap();\x0a"
"        }\x0a"
"\x0a"
"        // returns first nonepmty segment containing '\x5c""0' after offset\x0a"
"        segment_t terminal_segment() const\x0a"
"        {\x0a"
"            auto seg = segment_at_current_offset();\x0a"
"            while ( \x21is_beyond_last_segment( seg ) \x26\x26 \x21seg.has_value( '\x5c""0' ) ) {\x0a"
"                ++seg;\x0a"
"            }\x0a"
"            if ( is_beyond_last_segment( seg ) )\x0a"
"                out_of_bounds_fault();\x0a"
"            return seg;\x0a"
"        }\x0a"
"\x0a"
"        const index_t \x26terminator() const\x0a"
"        {\x0a"
"            // begining of the segment of the first occurence of '\x5c""0' after offset\x0a"
"            return terminal_segment().from();\x0a"
"        }\x0a"
"\x0a"
"        /* detail */\x0a"
"\x0a"
"        bool is_beyond_last_segment( const segment_t\x26 seg ) const\x0a"
"        {\x0a"
"            return seg.begin() == std\x3a\x3aprev( bounds().end() );\x0a"
"        }\x0a"
"\x0a"
"        segment_t segment_at_index( index_t idx ) const\x0a"
"        {\x0a"
"            if ( idx >= size() )\x0a"
"                out_of_bounds_fault();\x0a"
"\x0a"
"            auto *b_begin = const_cast< index_t * >( bounds().begin() );\x0a"
"            auto *v_begin = const_cast< char_t * >( values().begin() );\x0a"
"\x0a"
"            for ( auto it = b_begin; std\x3a\x3anext( it ) \x21= bounds().end(); ++it )\x0a"
"            {\x0a"
"                if ( idx >= *it \x26\x26 idx < *std\x3a\x3anext( it ) )\x0a"
"                {\x0a"
"                    auto nth = std\x3a\x3a""distance( b_begin, it );\x0a"
"                    return segment_t{ it, std\x3a\x3anext( v_begin, nth ) };\x0a"
"                }\x0a"
"            }\x0a"
"\x0a"
"            __builtin_trap();\x0a"
"        }\x0a"
"\x0a"
"        segment_t segment_at_current_offset() const\x0a"
"        {\x0a"
"            return segment_at_index( offset() );\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"}\x0a"
"", 20820 ); }