#include <string_view>
namespace divine::str::dios {
extern const std::string_view lava_scalar_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2019 Henrich Lauko <xlauko\x40mail.muni.cz>\x0a"
" * (c) 2020 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"#include \x22tristate.hpp\x22\x0a"
"#include <sys/trace.h>\x0a"
"\x0a"
"namespace __lava\x0a"
"{\x0a"
"    // c++ wrapper for scalar domains\x0a"
"\x0a"
"    template< typename dom, bool _signed = false, bool floating = false >\x0a"
"    struct scalar\x0a"
"    {\x0a"
"        static_assert( \x21(floating \x26\x26 \x21_signed) \x26\x26 \x22unsigned floats are not permitted\x22 );\x0a"
"\x0a"
"        dom _value;\x0a"
"\x0a"
"        scalar( dom \x26\x26val ) \x3a _value( std\x3a\x3amove( val ) ) {}\x0a"
"        scalar( const dom \x26val ) \x3a _value( val ) {}\x0a"
"        operator dom\x26() { return _value; }\x0a"
"        operator const dom\x26() const { return _value; }\x0a"
"\x0a"
"        explicit operator bool()\x0a"
"        {\x0a"
"            tristate v = dom\x3a\x3ato_tristate( _value );\x0a"
"\x0a"
"            switch ( v.value )\x0a"
"            {\x0a"
"                case tristate\x3a\x3ano\x3a  return false;\x0a"
"                case tristate\x3a\x3ayes\x3a return true;\x0a"
"                case tristate\x3a\x3amaybe\x3a\x0a"
"                    bool rv = __vm_choose( 2 );\x0a"
"                    dom\x3a\x3a""assume( _value, _value, rv );\x0a"
"                    return rv;\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"        template< typename type > static scalar lift( type val ) { return { dom\x3a\x3alift( val ) }; }\x0a"
"        template< typename type > static scalar any() { return { dom\x3a\x3atemplate any< type >() }; }\x0a"
"\x0a"
"#if 0\x0a"
"        template< template< typename, typename > class operation >\x0a"
"        _LART_INLINE static scalar_t binary_op( scalar_t l, scalar_t r ) noexcept\x0a"
"        {\x0a"
"            using Op = operation< constant_t, domain_t >;\x0a"
"\x0a"
"            auto ldom = domain( l );\x0a"
"            auto rdom = domain( r );\x0a"
"\x0a"
"            if ( is_constant( ldom ) ) {\x0a"
"                if ( is_constant( rdom ) )\x0a"
"                    return Op\x3a\x3a""concrete( l, r );\x0a"
"                return Op\x3a\x3a""abstract( domain_t\x3a\x3alift( l ), r );\x0a"
"            } else {\x0a"
"                if ( is_constant( rdom ) )\x0a"
"                    return Op\x3a\x3a""abstract( l, domain_t\x3a\x3alift( r ) );\x0a"
"                return Op\x3a\x3a""abstract( l, r );\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"        template< typename concrete_t >\x0a"
"        _LART_INLINE concrete_t lower() const noexcept\x0a"
"        {\x0a"
"            assert( is_constant( domain( _value ) ) );\x0a"
"            return static_cast< constant_t * >( _value )->template lower< concrete_t >();\x0a"
"        }\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"        static constexpr auto bv_div = _signed \x3f dom\x3a\x3aop_sdiv \x3a dom\x3a\x3aop_udiv;\x0a"
"        static constexpr auto bv_rem = _signed \x3f dom\x3a\x3aop_srem \x3a dom\x3a\x3aop_urem;\x0a"
"\x0a"
"        static constexpr auto ge = _signed \x3f dom\x3a\x3aop_sge \x3a dom\x3a\x3aop_uge;\x0a"
"        static constexpr auto le = _signed \x3f dom\x3a\x3aop_sle \x3a dom\x3a\x3aop_ule;\x0a"
"        static constexpr auto lt = _signed \x3f dom\x3a\x3aop_slt \x3a dom\x3a\x3aop_ult;\x0a"
"        static constexpr auto gt = _signed \x3f dom\x3a\x3aop_sgt \x3a dom\x3a\x3aop_ugt;\x0a"
"\x0a"
"        static constexpr auto add = floating \x3f dom\x3a\x3aop_fadd \x3a dom\x3a\x3aop_add;\x0a"
"        static constexpr auto sub = floating \x3f dom\x3a\x3aop_fsub \x3a dom\x3a\x3aop_sub;\x0a"
"        static constexpr auto div = floating \x3f dom\x3a\x3aop_fdiv \x3a bv_div;\x0a"
"        static constexpr auto rem = floating \x3f dom\x3a\x3aop_frem \x3a bv_rem;\x0a"
"\x0a"
"        using sref = const scalar \x26;\x0a"
"\x0a"
"        scalar operator+( sref o ) const { return add( _value, o._value ); }\x0a"
"        scalar operator-( sref o ) const { return sub( _value, o._value ); }\x0a"
"        scalar operator/( sref o ) const { return div( _value, o._value ); }\x0a"
"        scalar operator\x25( sref o ) const { return rem( _value, o._value ); }\x0a"
"\x0a"
"        scalar operator==( sref o ) const { return dom\x3a\x3aop_eq( _value, o._value ); }\x0a"
"        scalar operator\x21=( sref o ) const { return dom\x3a\x3aop_ne( _value, o._value ); }\x0a"
"        scalar operator>=( sref o ) const { return ge( _value, o._value ); }\x0a"
"        scalar operator<=( sref o ) const { return le( _value, o._value ); }\x0a"
"        scalar operator< ( sref o ) const { return lt( _value, o._value ); }\x0a"
"        scalar operator> ( sref o ) const { return gt( _value, o._value ); }\x0a"
"\x0a"
"        scalar operator\x21() const { return dom\x3a\x3aop_not( _value ); }\x0a"
"        scalar operator\x26\x26( sref o ) const { return dom\x3a\x3aop_and( \x21\x21*this, \x21\x21o ); }\x0a"
"        scalar operator\x7c\x7c( sref o ) const { return dom\x3a\x3aop_or ( \x21\x21*this, \x21\x21o ); }\x0a"
"\x0a"
"        scalar zfit( int w ) const { return dom\x3a\x3aop_zfit( _value, w );; }\x0a"
"#if 0\x0a"
"        template< template< typename > class operation >\x0a"
"        inline static constexpr bool is_in_domain = is_detected_v< operation, domain_t >;\x0a"
"\x0a"
"        #define op_traits( name ) \x5c\x0a"
"            template < typename T > \x5c\x0a"
"            using op_ ## name ## _t = decltype( \x26T\x3a\x3aop_ ## name ); \x5c\x0a"
"            \x5c\x0a"
"            template< typename Concrete, typename Abstract > \x5c\x0a"
"            struct name ## _op \x5c\x0a"
"            { \x5c\x0a"
"                static_assert( is_detected_v< op_ ## name ## _t, Concrete > ); \x5c\x0a"
"                static_assert( is_detected_v< op_ ## name ## _t, Abstract > ); \x5c\x0a"
"                inline static constexpr auto concrete = \x26""Concrete\x3a\x3aop_ ## name; \x5c\x0a"
"                inline static constexpr auto abstract = \x26""Abstract\x3a\x3aop_ ## name; \x5c\x0a"
"            };\x0a"
"\x0a"
"        #define unsigned_operation( name ) \x5c\x0a"
"            \x21_signed \x26\x26 is_in_domain< op_ ## name ## _t >\x0a"
"\x0a"
"        #define unsigned_icmp_operation( name ) \x5c\x0a"
"            \x21_signed \x26\x26 is_in_domain< op_u ## name ## _t >\x0a"
"\x0a"
"        #define signed_operation( name ) \x5c\x0a"
"            _signed \x26\x26 is_in_domain< op_s ## name ## _t >\x0a"
"\x0a"
"        #define floating_operation( name ) \x5c\x0a"
"            floating \x26\x26 is_in_domain< op_f ## name ## _t >\x0a"
"\x0a"
"        #define perform_operation( name ) \x5c\x0a"
"            return binary_op< name ## _op >( l, r );\x0a"
"\x0a"
"        #define perform_unsigned_operation( name ) \x5c\x0a"
"            perform_operation( u ## name )\x0a"
"\x0a"
"        #define perform_signed_operation( name ) \x5c\x0a"
"            perform_operation( s ## name )\x0a"
"\x0a"
"        #define perform_floating_operation( name ) \x5c\x0a"
"            perform_operation( f ## name )\x0a"
"\x0a"
"        #define general_operation( name, op ) \x5c\x0a"
"            op_traits( name ) \x5c\x0a"
"            \x5c\x0a"
"            \x5c\x0a"
"            template< typename first_t, typename second_t > \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            static scalar_t name ## _impl( first_t l, second_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                if constexpr ( is_in_domain< op_ ## name ## _t > ) \x5c\x0a"
"                    return binary_op< name ## _op >( l, r ); \x5c\x0a"
"                else \x5c\x0a"
"                    UNREACHABLE( \x22unsupported operation \x22 # name ); \x5c\x0a"
"            } \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            friend scalar_t operator op ( scalar_t l, scalar_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                return name ## _impl( l, r ); \x5c\x0a"
"            } \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            friend scalar_t operator op ( abstract_value_t l, scalar_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                return name ## _impl( l, r ); \x5c\x0a"
"            } \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            friend scalar_t operator op ( scalar_t l, abstract_value_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                return name ## _impl( l, r ); \x5c\x0a"
"            }\x0a"
"\x0a"
"        #define operation( name, op ) \x5c\x0a"
"            op_traits( name ) \x5c\x0a"
"            op_traits( s ## name ) \x5c\x0a"
"            op_traits( f ## name ) \x5c\x0a"
"            \x5c\x0a"
"            template< typename first_t, typename second_t > \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            static auto name ## _impl( first_t l, second_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                if constexpr ( unsigned_operation( name ) ) \x5c\x0a"
"                    perform_operation( name ) \x5c\x0a"
"                else if constexpr ( signed_operation( name ) ) \x5c\x0a"
"                    perform_signed_operation( name ) \x5c\x0a"
"                else if constexpr ( floating_operation( name ) ) \x5c\x0a"
"                    perform_floating_operation( name ) \x5c\x0a"
"                else \x5c\x0a"
"                    UNREACHABLE( \x22unsupported operation \x22 # name ); \x5c\x0a"
"            } \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            friend scalar_t operator op ( scalar_t l, scalar_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                return name ## _impl( l, r ); \x5c\x0a"
"            } \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            friend scalar_t operator op ( abstract_value_t l, scalar_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                return name ## _impl( l, r ); \x5c\x0a"
"            } \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            friend scalar_t operator op ( scalar_t l, abstract_value_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                return name ## _impl( l, r ); \x5c\x0a"
"            }\x0a"
"\x0a"
"        /* arithmetic operations */\x0a"
"        operation( add, + )\x0a"
"        operation( sub, - )\x0a"
"        operation( mul, * )\x0a"
"        operation( div, / )\x0a"
"        operation( rem, \x25 )\x0a"
"\x0a"
"        /* bitwise operations */\x0a"
"        general_operation( shl, << )\x0a"
"\x0a"
"        op_traits( lshr )\x0a"
"        op_traits( ashr )\x0a"
"\x0a"
"        _LART_INLINE\x0a"
"        friend scalar_t operator>>( scalar_t l, scalar_t r ) noexcept\x0a"
"        {\x0a"
"            if constexpr ( \x21_signed \x26\x26 is_detected_v< op_lshr_t, domain_t > ) \x5c\x0a"
"                return binary_op< lshr_op >( l, r );\x0a"
"            else if constexpr ( _signed \x26\x26 is_detected_v< op_ashr_t, domain_t > ) \x5c\x0a"
"                return binary_op< ashr_op >( l, r );\x0a"
"            else\x0a"
"                UNREACHABLE( \x22unsupported operation lshr/ashr\x22 );\x0a"
"        }\x0a"
"\x0a"
"        general_operation( and, \x26 )\x0a"
"        general_operation( or, \x7c )\x0a"
"        general_operation( xor, ^ )\x0a"
"\x0a"
"        /* comparison operations */\x0a"
"        general_operation( eq, == )\x0a"
"        general_operation( ne, \x21= )\x0a"
"\x0a"
"        #define icmp_operation( name, op ) \x5c\x0a"
"            op_traits( u ## name ) \x5c\x0a"
"            op_traits( s ## name ) \x5c\x0a"
"            \x5c\x0a"
"            template< typename first_t, typename second_t > \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            static scalar_t name ## _impl ( first_t l, second_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                if constexpr ( unsigned_icmp_operation( name ) ) \x5c\x0a"
"                    perform_unsigned_operation( name ) \x5c\x0a"
"                else if constexpr ( signed_operation( name ) ) \x5c\x0a"
"                    perform_signed_operation( name ) \x5c\x0a"
"                else \x5c\x0a"
"                    UNREACHABLE( \x22unsupported operation \x22 # name ); \x5c\x0a"
"            } \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            friend scalar_t operator op ( scalar_t l, scalar_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                return name ## _impl( l, r ); \x5c\x0a"
"            } \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            friend scalar_t operator op ( abstract_value_t l, scalar_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                return name ## _impl( l, r ); \x5c\x0a"
"            } \x5c\x0a"
"            _LART_INLINE \x5c\x0a"
"            friend scalar_t operator op ( scalar_t l, abstract_value_t r ) noexcept \x5c\x0a"
"            { \x5c\x0a"
"                return name ## _impl( l, r ); \x5c\x0a"
"            }\x0a"
"\x0a"
"        icmp_operation( gt, > )\x0a"
"        icmp_operation( ge, >= )\x0a"
"        icmp_operation( lt, < )\x0a"
"        icmp_operation( le, <= )\x0a"
"#endif\x0a"
"    };\x0a"
"}\x0a"
"", 11313 ); }