#include <string_view>
namespace divine::str::dios {
extern const std::string_view lava_term_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2019, 2020 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" * (c) 2019 Henrich Lauko <xlauko\x40mail.muni.cz>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"#include \x22""base.hpp\x22\x0a"
"#include \x22tristate.hpp\x22\x0a"
"#include <util/map.hpp>\x0a"
"\x0a"
"#include <brick-smt>\x0a"
"#include <type_traits>\x0a"
"\x0a"
"namespace __lava\x0a"
"{\x0a"
"    template< typename >\x0a"
"    using tagged_array_adaptor = tagged_array< _VM_PT_Marked >;\x0a"
"\x0a"
"    /* Values in the term_t abstract domain are built out of Constants, Variables and\x0a"
"     * operations defined on them. Integers are represented as bitvectors of fixed\x0a"
"     * bitwidth, operations similarly have a bitwidth specified (of the arguments they\x0a"
"     * take). See \x60""bricks/brick-smt\x60 for details on the types and operations.\x0a"
"     *\x0a"
"     * A term_t is stored/encoded as bytecode in the \x60pointer\x60 data member, which\x0a"
"     * is a pointer to an RPN structure (RPN is also defined in \x60""brick-smt\x60).\x0a"
"     *\x0a"
"     * If method name is in form \x60op_X\x60 then \x60X\x60 should correspond to the llvm\x0a"
"     * instruction names. These methods are used in lart and their lookup is name-based\x0a"
"     * therefore it is mandatory to satisfy this requirement.\x0a"
"     * Otherwise there are no requirements. */\x0a"
"\x0a"
"    struct term \x3a brq\x3a\x3asmt_expr< tagged_array_adaptor >, domain_mixin< term >\x0a"
"    {\x0a"
"        using base = brq\x3a\x3asmt_expr< tagged_array_adaptor >;\x0a"
"\x0a"
"        term() = default;\x0a"
"        term( void *v, __dios\x3a\x3a""construct_shared_t s ) \x3a base( v, s ) {}\x0a"
"\x0a"
"        template< typename imm_t, typename... args_t >\x0a"
"        term( const brq\x3a\x3asmt_atom_t< imm_t > \x26o, const args_t \x26 ... args )\x0a"
"            \x3a brq\x3a\x3asmt_expr< tagged_array_adaptor >()\x0a"
"        {\x0a"
"            apply( o, args... );\x0a"
"        }\x0a"
"\x0a"
"        template< typename... args_t >\x0a"
"        term( const term \x26o, const args_t \x26 ... args ) \x3a brq\x3a\x3asmt_expr< tagged_array_adaptor >()\x0a"
"        {\x0a"
"            apply( o, args... );\x0a"
"        }\x0a"
"\x0a"
"        static int counter()\x0a"
"        {\x0a"
"            static int v = 0;\x0a"
"            return ++v;\x0a"
"        }\x0a"
"\x0a"
"        template< typename T >\x0a"
"        static term any()\x0a"
"        {\x0a"
"            constexpr auto op = brq\x3a\x3asmt_match_op< brq\x3a\x3asmt_op_var, bitwidth_v< T > >;\x0a"
"            return { brq\x3a\x3asmt_atom_t< brq\x3a\x3asmt_varid_t >( op, counter() ) };\x0a"
"        }\x0a"
"\x0a"
"        template< typename T >\x0a"
"        static term lift( T value )\x0a"
"        {\x0a"
"            if constexpr ( std\x3a\x3ais_same_v< T, array_ref > )\x0a"
"                NOT_IMPLEMENTED();\x0a"
"            else\x0a"
"            {\x0a"
"                constexpr auto op = brq\x3a\x3asmt_match_op< brq\x3a\x3asmt_op_const, bitwidth_v< T > >;\x0a"
"                return { brq\x3a\x3asmt_atom_t< T >( op, value ) };\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"        static tristate to_tristate( term ) { return { tristate\x3a\x3amaybe }; }\x0a"
"\x0a"
"        static term div( term a, term b, brq\x3a\x3asmt_op o )\x0a"
"        {\x0a"
"            auto fault = _VM_Fault\x3a\x3a_VM_F_Integer;\x0a"
"            auto divisor = b;\x0a"
"\x0a"
"            if ( o == op\x3a\x3a""fp_div \x7c\x7c o == op\x3a\x3a""fp_rem )\x0a"
"            {\x0a"
"                divisor = op_fptosi( b, 64 );\x0a"
"                fault = _VM_Fault\x3a\x3a_VM_F_Float;\x0a"
"            }\x0a"
"\x0a"
"            auto eq = op_eq( op_zext( divisor, 64 ), lift( 0ul ) );\x0a"
"\x0a"
"            if ( to_tristate( eq ) )\x0a"
"            {\x0a"
"                assume( eq, eq, true );\x0a"
"                __dios_fault( fault, \x22""division by zero\x22 );\x0a"
"                return b;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                assume( eq, eq, false );\x0a"
"                return { a, b, o };\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"        using op = brq\x3a\x3asmt_op;\x0a"
"        using tt = const term \x26;\x0a"
"        using bw = uint8_t;\x0a"
"\x0a"
"        static term cast( term arg, bitwidth_t bw, op o )\x0a"
"        {\x0a"
"            brq\x3a\x3asmt_atom_t< uint8_t > atom( o, bw );\x0a"
"            return { arg, atom };\x0a"
"        }\x0a"
"\x0a"
"        static term assume( tt value, tt constraint, bool expect );\x0a"
"        static term op_thaw( tt term, uint8_t bw )\x0a"
"        {\x0a"
"            /* TODO interval-based peek \x26 poke */\x0a"
"            return cast( term, bw, op\x3a\x3a""bv_zfit );\x0a"
"        }\x0a"
"\x0a"
"        static term op_extract( term t, uint8_t from, uint8_t to )\x0a"
"        {\x0a"
"            std\x3a\x3apair arg{ from, to };\x0a"
"            brq\x3a\x3asmt_atom_t< std\x3a\x3apair< uint8_t, uint8_t > > atom( op\x3a\x3a""bv_extract, arg );\x0a"
"            return { t, atom };\x0a"
"        }\x0a"
"\x0a"
"        static term op_not( tt a ) { return { a, op\x3a\x3a""bv_not }; }\x0a"
"        static term op_neg( tt a ) { return { a, op\x3a\x3a""bv_neg }; }\x0a"
"\x0a"
"        static term op_add ( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_add  }; }\x0a"
"        static term op_sub ( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_sub  }; }\x0a"
"        static term op_mul ( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_mul  }; }\x0a"
"        static term op_sdiv( tt a, tt b ) { return div( a, b, op\x3a\x3a""bv_sdiv ); }\x0a"
"        static term op_udiv( tt a, tt b ) { return div( a, b, op\x3a\x3a""bv_udiv ); }\x0a"
"        static term op_srem( tt a, tt b ) { return div( a, b, op\x3a\x3a""bv_srem ); }\x0a"
"        static term op_urem( tt a, tt b ) { return div( a, b, op\x3a\x3a""bv_urem ); }\x0a"
"\x0a"
"        static term op_fadd( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_add }; }\x0a"
"        static term op_fsub( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_sub }; }\x0a"
"        static term op_fmul( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_mul }; }\x0a"
"        static term op_fdiv( tt a, tt b ) { return div( a, b, op\x3a\x3a""fp_div ); }\x0a"
"        static term op_frem( tt a, tt b ) { return div( a, b, op\x3a\x3a""fp_rem ); }\x0a"
"\x0a"
"        static term op_shl ( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_shl  }; }\x0a"
"        static term op_ashr( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_ashr }; }\x0a"
"        static term op_lshr( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_lshr }; }\x0a"
"        static term op_and ( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_and  }; }\x0a"
"        static term op_or  ( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_or   }; }\x0a"
"        static term op_xor ( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_xor  }; }\x0a"
"\x0a"
"        static term op_eq ( tt a, tt b ) { return { a, b, op\x3a\x3a""eq }; };\x0a"
"        static term op_ne ( tt a, tt b ) { return { a, b, op\x3a\x3aneq }; };\x0a"
"        static term op_ugt( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_ugt }; };\x0a"
"        static term op_uge( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_uge }; };\x0a"
"        static term op_ult( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_ult }; };\x0a"
"        static term op_ule( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_ule }; };\x0a"
"        static term op_sgt( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_sgt }; };\x0a"
"        static term op_sge( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_sge }; };\x0a"
"        static term op_slt( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_slt }; };\x0a"
"        static term op_sle( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_sle }; };\x0a"
"\x0a"
"        static term op_foeq( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_oeq }; }\x0a"
"        static term op_fogt( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_ogt }; }\x0a"
"        static term op_foge( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_oge }; }\x0a"
"        static term op_folt( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_olt }; }\x0a"
"        static term op_fole( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_ole }; }\x0a"
"        static term op_ford( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_ord }; }\x0a"
"        static term op_funo( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_uno }; }\x0a"
"        static term op_fueq( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_ueq }; }\x0a"
"        static term op_fugt( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_ugt }; }\x0a"
"        static term op_fuge( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_uge }; }\x0a"
"        static term op_fult( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_ult }; }\x0a"
"        static term op_fule( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_ule }; }\x0a"
"\x0a"
"        static term op_ffalse( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_false }; }\x0a"
"        static term op_ftrue( tt a, tt b ) { return { a, b, op\x3a\x3a""fp_true }; }\x0a"
"\x0a"
"        static term op_trunc  ( tt a, bw w ) { return cast( a, w, op\x3a\x3a""bv_trunc ); }\x0a"
"        static term op_fptrunc( tt a, bw w ) { return cast( a, w, op\x3a\x3a""fp_trunc ); }\x0a"
"        static term op_sitofp ( tt a, bw w ) { return cast( a, w, op\x3a\x3a""bv_stofp ); }\x0a"
"        static term op_uitofp ( tt a, bw w ) { return cast( a, w, op\x3a\x3a""bv_utofp ); }\x0a"
"        static term op_zext   ( tt a, bw w ) { return cast( a, w, op\x3a\x3a""bv_zext ); }\x0a"
"        static term op_zfit   ( tt a, bw w ) { return cast( a, w, op\x3a\x3a""bv_zfit ); }\x0a"
"        static term op_sext   ( tt a, bw w ) { return cast( a, w, op\x3a\x3a""bv_sext ); }\x0a"
"        static term op_fpext  ( tt a, bw w ) { return cast( a, w, op\x3a\x3a""fp_ext ); }\x0a"
"        static term op_fptosi ( tt a, bw w ) { return cast( a, w, op\x3a\x3a""fp_tosbv ); }\x0a"
"        static term op_fptoui ( tt a, bw w ) { return cast( a, w, op\x3a\x3a""fp_toubv ); }\x0a"
"\x0a"
"        static term op_concat ( tt a, tt b ) { return { a, b, op\x3a\x3a""bv_concat }; }\x0a"
"\x0a"
"        template< typename index >\x0a"
"        static term op_gep( tt a, const index \x26""b, uint64_t w )\x0a"
"        {\x0a"
"            if constexpr ( std\x3a\x3ais_same_v< index, term > )\x0a"
"                if ( w == 8 )\x0a"
"                    return { a, b, op\x3a\x3a""bv_add };\x0a"
"            __builtin_trap();\x0a"
"        }\x0a"
"        // op_inttoptr\x0a"
"        // op_ptrtoint\x0a"
"    };\x0a"
"\x0a"
"    struct term_state_t\x0a"
"    {\x0a"
"        template< typename val >\x0a"
"        using dense_map = brq\x3a\x3a""dense_map< brq\x3a\x3asmt_varid_t, val, __dios\x3a\x3a""Array< val, _VM_PT_Weak > >;\x0a"
"        brq\x3a\x3aunion_find< dense_map< brq\x3a\x3asmt_varid_t > > uf;\x0a"
"        dense_map< term > decomp; /* maps representants to terms */\x0a"
"    };\x0a"
"\x0a"
"    extern term_state_t *__term_state;\x0a"
"    static_assert( sizeof( term ) == 8 );\x0a"
"}\x0a"
"\x0a"
"extern \x22""C\x22 void *__dios_term_init();\x0a"
"", 9861 ); }