#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc__PDCLIB_glue_c( 
"// -*- C -*- (c) 2013 Petr Rockai <me\x40mornfall.net>\x0a"
"#include <limits.h>\x0a"
"#include <unistd.h>\x0a"
"#include <stdint.h>\x0a"
"#include <signal.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <_PDCLIB/cdefs.h>\x0a"
"#include <sys/divm.h>\x0a"
"#include <sys/syscall.h>\x0a"
"#include <sys/start.h>\x0a"
"#include <sys/vmutil.h>\x0a"
"#include <string.h>\x0a"
"#include <dios.h>\x0a"
"#include <errno.h>\x0a"
"#include <sys/syswrap.h>\x0a"
"\x0a"
"/*\x0a"
" * Glue code that ties various bits of C and C++ runtime to the divine runtime\x0a"
" * support. It's not particularly pretty. Other bits of this code are also\x0a"
" * exploded over runtime/ which is even worse.\x0a"
" */\x0a"
"\x0a"
"uint8_t __dios_simfail_flags;\x0a"
"\x0a"
"/* Memory allocation */\x0a"
"__local_invisible void *malloc( size_t size )\x0a"
"{\x0a"
"    int kernel = ( ( ( uint64_t ) __vm_ctl_get( _VM_CR_Flags ) ) \x26 _VM_CF_KernelMode ) \x3f 1 \x3a 0;\x0a"
"    int simfail = __dios_sim_fail( _DiOS_SF_Malloc );\x0a"
"    int ok = ( simfail \x26\x26 \x21kernel ) \x3f __vm_choose( 2 ) \x3a 1;\x0a"
"\x0a"
"    if ( ok \x26\x26 size > 0 )\x0a"
"        return __vm_obj_make( size, _VM_PT_Heap ); // success\x0a"
"    else\x0a"
"    {\x0a"
"        errno = ENOMEM;\x0a"
"        return NULL; // failure\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"void __dios_check_free( void * );\x0a"
"\x0a"
"__local_invisible void free( void * p )\x0a"
"{\x0a"
"    if ( \x21p )\x0a"
"        return;\x0a"
"\x0a"
"    __dios_check_free( p );\x0a"
"    __vm_obj_free( p );\x0a"
"}\x0a"
"\x0a"
"__local_invisible void *aligned_alloc( size_t align, size_t size )\x0a"
"{\x0a"
"    (void) align;\x0a"
"    return malloc( size ); /* we are always aligned */\x0a"
"}\x0a"
"\x0a"
"__local_invisible int posix_memalign( void **ptr, size_t align, size_t size )\x0a"
"{\x0a"
"    (void) align;\x0a"
"    /* TODO EINVAL if align is not a power of two >= sizeof( void* ) */\x0a"
"    *ptr = malloc( size ); /* we are always aligned */\x0a"
"    if ( *ptr )\x0a"
"        return 0;\x0a"
"    else\x0a"
"        return ENOMEM;\x0a"
"}\x0a"
"\x0a"
"#define MIN( a, b )   ((a) < (b) \x3f (a) \x3a (b))\x0a"
"\x0a"
"void *realloc( void *orig, size_t size )\x0a"
"{\x0a"
"    int masked = __dios_mask( 1 );\x0a"
"    int ok = __dios_sim_fail( _DiOS_SF_Malloc ) \x3f __vm_choose( 2 ) \x3a 1;\x0a"
"    void *r;\x0a"
"    if ( \x21size ) {\x0a"
"        __vm_obj_free( orig );\x0a"
"        r = NULL;\x0a"
"    }\x0a"
"    else if ( ok ) {\x0a"
"        void *n = __vm_obj_make( size, _VM_PT_Heap );\x0a"
"        if ( orig ) {\x0a"
"            memcpy( n, orig, MIN( size , (size_t) __vm_obj_size( orig ) ) );\x0a"
"            __vm_obj_free( orig );\x0a"
"        }\x0a"
"        r = n;\x0a"
"    } else {\x0a"
"        errno = ENOMEM;\x0a"
"        r = NULL; // failure\x0a"
"    }\x0a"
"    __dios_mask( masked );\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"void *calloc( size_t n, size_t size )\x0a"
"{\x0a"
"    int masked = __dios_mask( 1 );\x0a"
"    void *r;\x0a"
"    int ok = __dios_sim_fail( _DiOS_SF_Malloc ) \x3f __vm_choose( 2 ) \x3a 1;\x0a"
"    if ( ok \x26\x26 n * size ) {\x0a"
"        void *mem = __vm_obj_make( n * size, _VM_PT_Heap ); // success\x0a"
"        memset( mem, 0, n * size );\x0a"
"        r = mem;\x0a"
"    } else {\x0a"
"        errno = ENOMEM;\x0a"
"        r = NULL; // failure\x0a"
"    }\x0a"
"    __dios_mask( masked );\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"/* IOStream */\x0a"
"\x0a"
"void *__dso_handle; /* this is emitted by clang for calls to __cxa_exit for whatever reason */\x0a"
"\x0a"
"int nanosleep(const struct timespec *req, struct timespec *rem)\x0a"
"{\x0a"
"    (void) req;\x0a"
"    (void) rem;\x0a"
"    // I believe we will do nothing wrong if we verify nanosleep as NOOP,\x0a"
"    // it does not guarantee anything anyway\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"unsigned int sleep( unsigned int seconds )\x0a"
"{\x0a"
"    (void) seconds;\x0a"
"    // same as nanosleep\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int usleep( useconds_t usec )\x0a"
"{\x0a"
"    (void) usec;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* signals */\x0a"
"\x0a"
"int raise( int sig )\x0a"
"{\x0a"
"    switch ( sig )\x0a"
"    {\x0a"
"        case SIGKILL\x3a\x0a"
"            __dios_reschedule();\x0a"
"        default\x3a\x0a"
"            return __libc_kill( __libc_getpid(), sig );\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"typedef void ( *SignalHandler )( int );\x0a"
"\x0a"
"SignalHandler signal( int sig, SignalHandler handler )\x0a"
"{\x0a"
"    struct sigaction sa, res;\x0a"
"    sa.sa_handler = handler;\x0a"
"    sigemptyset(\x26sa.sa_mask);\x0a"
"    sa.sa_flags = SA_RESTART; /* Restart functions if\x0a"
"                                interrupted by handler */\x0a"
"    if ( __libc_sigaction( sig, \x26sa, \x26res ) == -1 )\x0a"
"        return SIG_ERR;\x0a"
"    else\x0a"
"        return res.sa_handler;\x0a"
"}\x0a"
"\x0a"
"int issetugid( void )\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"", 3888 ); }