#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_nl_types_catgets_c( 
"/*\x09\x24OpenBSD\x3a catgets.c,v 1.9 2015/09/05 11\x3a""25\x3a""30 guenther Exp \x24 */\x0a"
"/*-\x0a"
" * Copyright (c) 1996 The NetBSD Foundation, Inc.\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * This code is derived from software contributed to The NetBSD Foundation\x0a"
" * by J.T. Conklin.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS\x0a"
" * \x60\x60""AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED\x0a"
" * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR\x0a"
" * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE\x0a"
" * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR\x0a"
" * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF\x0a"
" * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS\x0a"
" * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN\x0a"
" * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)\x0a"
" * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE\x0a"
" * POSSIBILITY OF SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#define _NLS_PRIVATE\x0a"
"\x0a"
"#include <errno.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"#include <nl_types.h>\x0a"
"#include <endian.h>\x0a"
"\x0a"
"char *\x0a"
"catgets(nl_catd catd, int set_id, int msg_id, const char *s)\x0a"
"{\x0a"
"\x09struct _nls_cat_hdr *cat_hdr;\x0a"
"\x09struct _nls_set_hdr *set_hdr;\x0a"
"\x09struct _nls_msg_hdr *msg_hdr;\x0a"
"\x09int l, u, i, r;\x0a"
"\x0a"
"\x09if (catd == (nl_catd) -1) {\x0a"
"\x09\x09""errno = EBADF;\x0a"
"\x09\x09return (char *) s;\x0a"
"\x09}\x0a"
"\x0a"
"\x09""cat_hdr = (struct _nls_cat_hdr *) catd->__data; \x0a"
"\x09set_hdr = (struct _nls_set_hdr *) ((char *)catd->__data\x0a"
"\x09\x09+ sizeof(struct _nls_cat_hdr));\x0a"
"\x0a"
"\x09/* binary search, see knuth algorithm b */\x0a"
"\x09l = 0;\x0a"
"\x09u = ntohl(cat_hdr->__nsets) - 1;\x0a"
"\x09while (l <= u) {\x0a"
"\x09\x09i = (l + u) / 2;\x0a"
"\x09\x09r = set_id - ntohl(set_hdr\x5bi\x5d.__setno);\x0a"
"\x0a"
"\x09\x09if (r == 0) {\x0a"
"\x09\x09\x09msg_hdr = (struct _nls_msg_hdr *) ((char *)catd->__data\x0a"
"\x09\x09\x09\x09+ sizeof(struct _nls_cat_hdr)\x0a"
"\x09\x09\x09\x09+ ntohl(cat_hdr->__msg_hdr_offset));\x0a"
"\x0a"
"\x09\x09\x09l = ntohl(set_hdr\x5bi\x5d.__index);\x0a"
"\x09\x09\x09u = l + ntohl(set_hdr\x5bi\x5d.__nmsgs) - 1;\x0a"
"\x09\x09\x09while (l <= u) {\x0a"
"\x09\x09\x09\x09i = (l + u) / 2;\x0a"
"\x09\x09\x09\x09r = msg_id - ntohl(msg_hdr\x5bi\x5d.__msgno);\x0a"
"\x09\x09\x09\x09if (r == 0) {\x0a"
"\x09\x09\x09\x09\x09return (char *) catd->__data \x0a"
"\x09\x09\x09\x09\x09    + sizeof(struct _nls_cat_hdr)\x0a"
"\x09\x09\x09\x09\x09    + ntohl(cat_hdr->__msg_txt_offset)\x0a"
"\x09\x09\x09\x09\x09    + ntohl(msg_hdr\x5bi\x5d.__offset);\x0a"
"\x09\x09\x09\x09} else if (r < 0) {\x0a"
"\x09\x09\x09\x09\x09u = i - 1;\x0a"
"\x09\x09\x09\x09} else {\x0a"
"\x09\x09\x09\x09\x09l = i + 1;\x0a"
"\x09\x09\x09\x09}\x0a"
"\x09\x09\x09}\x0a"
"\x0a"
"\x09\x09\x09/* not found */\x0a"
"\x09\x09\x09return (char *) s;\x0a"
"\x0a"
"\x09\x09} else if (r < 0) {\x0a"
"\x09\x09\x09u = i - 1;\x0a"
"\x09\x09} else {\x0a"
"\x09\x09\x09l = i + 1;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x0a"
"\x09/* not found */\x0a"
"\x09return (char *) s;\x0a"
"}\x0a"
"", 2955 ); }