#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_nl_types_catopen_c( 
"/*\x09\x24OpenBSD\x3a catopen.c,v 1.21 2017/04/27 23\x3a""54\x3a""08 millert Exp \x24 */\x0a"
"/*-\x0a"
" * Copyright (c) 1996 The NetBSD Foundation, Inc.\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * This code is derived from software contributed to The NetBSD Foundation\x0a"
" * by J.T. Conklin.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS\x0a"
" * \x60\x60""AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED\x0a"
" * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR\x0a"
" * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE\x0a"
" * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR\x0a"
" * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF\x0a"
" * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS\x0a"
" * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN\x0a"
" * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)\x0a"
" * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE\x0a"
" * POSSIBILITY OF SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#define _NLS_PRIVATE\x0a"
"\x0a"
"#include <sys/types.h>\x0a"
"#include <sys/stat.h>\x0a"
"#include <sys/mman.h>\x0a"
"#include <errno.h>\x0a"
"#include <fcntl.h>\x0a"
"#include <limits.h>\x0a"
"#include <nl_types.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"#include <unistd.h>\x0a"
"\x0a"
"#define MAXIMUM(a, b)\x09(((a) > (b)) \x3f (a) \x3a (b))\x0a"
"\x0a"
"#define NLS_DEFAULT_LANG \x22""C\x22\x0a"
"\x0a"
"static nl_catd\x09load_msgcat(const char *);\x0a"
"static int\x09verify_msgcat(nl_catd);\x0a"
"\x0a"
"nl_catd\x0a"
"catopen(const char *name, int oflag)\x0a"
"{\x0a"
"\x09""char tmppath\x5bPATH_MAX\x5d;\x0a"
"\x09""char *nlspath;\x0a"
"\x09""char *lang;\x0a"
"\x09""char *s, *t, *sep, *dot;\x0a"
"\x09""const char *u;\x0a"
"\x09nl_catd catd;\x0a"
"\x09\x09\x0a"
"\x09if (name == NULL \x7c\x7c *name == '\x5c""0')\x0a"
"\x09\x09return (nl_catd) -1;\x0a"
"\x0a"
"\x09/* absolute or relative path\x3f */\x0a"
"\x09if (strchr(name, '/'))\x0a"
"\x09\x09return load_msgcat(name);\x0a"
"\x0a"
"\x09if (issetugid() \x21= 0 \x7c\x7c (nlspath = getenv(\x22NLSPATH\x22)) == NULL)\x0a"
"\x09\x09return (nl_catd) -1;\x0a"
"\x0a"
"\x09lang = NULL;\x0a"
"\x09if (oflag \x26 NL_CAT_LOCALE) {\x0a"
"\x09\x09lang = getenv(\x22LC_ALL\x22);\x0a"
"\x09\x09if (lang == NULL)\x0a"
"\x09\x09\x09lang = getenv(\x22LC_MESSAGES\x22);\x0a"
"\x09}\x0a"
"\x09if (lang == NULL)\x0a"
"\x09\x09lang = getenv(\x22LANG\x22);\x0a"
"\x09if (lang == NULL)\x0a"
"\x09\x09lang = NLS_DEFAULT_LANG;\x0a"
"\x09if (strcmp(lang, \x22POSIX\x22) == 0)\x0a"
"\x09\x09lang = NLS_DEFAULT_LANG;\x0a"
"\x0a"
"\x09s = nlspath;\x0a"
"\x09t = tmppath;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * Locale names are of the form language\x5b_territory\x5d\x5b.codeset\x5d.\x0a"
"\x09 * See POSIX-1-2008 \x22""8.2 Internationalization Variables\x22\x0a"
"\x09 */\x0a"
"\x09sep = strchr(lang, '_');\x0a"
"\x09""dot = strrchr(lang, '.');\x0a"
"\x09if (dot \x26\x26 sep \x26\x26 dot < sep)\x0a"
"\x09\x09""dot = NULL; /* ignore dots preceeding _ */\x0a"
"\x09if (dot == NULL)\x0a"
"\x09\x09lang = NLS_DEFAULT_LANG; /* no codeset specified */\x0a"
"\x09""do {\x0a"
"\x09\x09while (*s \x26\x26 *s \x21= '\x3a') {\x0a"
"\x09\x09\x09if (*s == '\x25') {\x0a"
"\x09\x09\x09\x09switch (*(++s)) {\x0a"
"\x09\x09\x09\x09""case 'L'\x3a\x09/* LANG or LC_MESSAGES */\x0a"
"\x09\x09\x09\x09\x09u = lang;\x0a"
"\x09\x09\x09\x09\x09while (*u \x26\x26 t < tmppath + PATH_MAX-1)\x0a"
"\x09\x09\x09\x09\x09\x09*t++ = *u++;\x0a"
"\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09""case 'N'\x3a\x09/* value of name parameter */\x0a"
"\x09\x09\x09\x09\x09u = name;\x0a"
"\x09\x09\x09\x09\x09while (*u \x26\x26 t < tmppath + PATH_MAX-1)\x0a"
"\x09\x09\x09\x09\x09\x09*t++ = *u++;\x0a"
"\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09""case 'l'\x3a\x09/* language part */\x0a"
"\x09\x09\x09\x09\x09u = lang;\x0a"
"\x09\x09\x09\x09\x09while (*u \x26\x26 t < tmppath + PATH_MAX-1) {\x0a"
"\x09\x09\x09\x09\x09\x09*t++ = *u++;\x0a"
"\x09\x09\x09\x09\x09\x09if (sep \x26\x26 u >= sep)\x0a"
"\x09\x09\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09\x09\x09if (dot \x26\x26 u >= dot)\x0a"
"\x09\x09\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09\x09}\x0a"
"\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09""case 't'\x3a\x09/* territory part */\x0a"
"\x09\x09\x09\x09\x09if (sep == NULL)\x0a"
"\x09\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09\x09u = sep + 1;\x0a"
"\x09\x09\x09\x09\x09while (*u \x26\x26 t < tmppath + PATH_MAX-1) {\x0a"
"\x09\x09\x09\x09\x09\x09*t++ = *u++;\x0a"
"\x09\x09\x09\x09\x09\x09if (dot \x26\x26 u >= dot)\x0a"
"\x09\x09\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09\x09}\x0a"
"\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09""case 'c'\x3a\x09/* codeset part */\x0a"
"\x09\x09\x09\x09\x09if (dot == NULL)\x0a"
"\x09\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09\x09u = dot + 1;\x0a"
"\x09\x09\x09\x09\x09while (*u \x26\x26 t < tmppath + PATH_MAX-1)\x0a"
"\x09\x09\x09\x09\x09\x09*t++ = *u++;\x0a"
"\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09""default\x3a\x0a"
"\x09\x09\x09\x09\x09if (t < tmppath + PATH_MAX-1)\x0a"
"\x09\x09\x09\x09\x09\x09*t++ = *s;\x0a"
"\x09\x09\x09\x09}\x0a"
"\x09\x09\x09} else {\x0a"
"\x09\x09\x09\x09if (t < tmppath + PATH_MAX-1)\x0a"
"\x09\x09\x09\x09\x09*t++ = *s;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09\x09s++;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09\x09*t = '\x5c""0';\x0a"
"\x09\x09""catd = load_msgcat(tmppath);\x0a"
"\x09\x09if (catd \x21= (nl_catd) -1)\x0a"
"\x09\x09\x09return catd;\x0a"
"\x0a"
"\x09\x09if (*s)\x0a"
"\x09\x09\x09s++;\x0a"
"\x09\x09t = tmppath;\x0a"
"\x09} while (*s);\x0a"
"\x0a"
"\x09return (nl_catd) -1;\x0a"
"}\x0a"
"\x0a"
"static nl_catd\x0a"
"load_msgcat(const char *path)\x0a"
"{\x0a"
"\x09struct stat st;\x0a"
"\x09nl_catd catd;\x0a"
"\x09void *data;\x0a"
"\x09int fd;\x0a"
"\x0a"
"\x09""catd = NULL;\x0a"
"\x0a"
"\x09if ((fd = open(path, O_RDONLY\x7cO_CLOEXEC)) == -1)\x0a"
"\x09\x09return (nl_catd) -1;\x0a"
"\x0a"
"\x09if (fstat(fd, \x26st) \x21= 0) {\x0a"
"\x09\x09""close (fd);\x0a"
"\x09\x09return (nl_catd) -1;\x0a"
"\x09}\x0a"
"\x0a"
"\x09if (st.st_size > INT_MAX \x7c\x7c st.st_size < sizeof (struct _nls_cat_hdr)) {\x0a"
"\x09\x09""errno = EINVAL;\x0a"
"\x09\x09""close (fd);\x0a"
"\x09\x09return (nl_catd) -1;\x0a"
"\x09}\x0a"
"\x0a"
"\x09""data = mmap(0, st.st_size, PROT_READ, MAP_SHARED, fd, 0);\x0a"
"\x09""close (fd);\x0a"
"\x0a"
"\x09if (data == MAP_FAILED)\x0a"
"\x09\x09return (nl_catd) -1;\x0a"
"\x0a"
"\x09if (ntohl(((struct _nls_cat_hdr *) data)->__magic) \x21= _NLS_MAGIC)\x0a"
"\x09\x09goto invalid;\x0a"
"\x0a"
"\x09if ((catd = malloc(sizeof (*catd))) == 0)\x0a"
"\x09\x09goto invalid;\x0a"
"\x0a"
"\x09""catd->__data = data;\x0a"
"\x09""catd->__size = st.st_size;\x0a"
"\x0a"
"\x09if (verify_msgcat(catd))\x0a"
"\x09\x09goto invalid;\x0a"
"\x0a"
"\x09return catd;\x0a"
"\x0a"
"invalid\x3a\x0a"
"\x09""free(catd);\x0a"
"\x09munmap(data, st.st_size);\x0a"
"\x09""errno = EINVAL;\x0a"
"\x09return (nl_catd) -1;\x0a"
"}\x0a"
"\x0a"
"static int\x0a"
"verify_msgcat(nl_catd catd)\x0a"
"{\x0a"
"\x09struct _nls_cat_hdr *cat;\x0a"
"\x09struct _nls_set_hdr *set;\x0a"
"\x09struct _nls_msg_hdr *msg;\x0a"
"\x09ssize_t remain;\x0a"
"\x09int hdr_offset, i, index, j, msgs, nmsgs, nsets, off, txt_offset;\x0a"
"        const ssize_t cat_size = sizeof (*cat), set_size = sizeof (*set), msg_size = sizeof (*msg);\x0a"
"\x0a"
"\x09remain = catd->__size;\x0a"
"\x09""cat = (struct _nls_cat_hdr *) catd->__data;\x0a"
"\x0a"
"\x09hdr_offset = ntohl(cat->__msg_hdr_offset);\x0a"
"\x09nsets = ntohl(cat->__nsets);\x0a"
"\x09txt_offset = ntohl(cat->__msg_txt_offset);\x0a"
"\x0a"
"\x09/* catalog must contain at least one set and no negative offsets */\x0a"
"\x09if (nsets < 1 \x7c\x7c hdr_offset < 0 \x7c\x7c txt_offset < 0)\x0a"
"\x09\x09return (1);\x0a"
"\x0a"
"\x09remain -= cat_size;\x0a"
"\x0a"
"\x09/* check if offsets or set size overflow */\x0a"
"\x09if (remain <= hdr_offset \x7c\x7c remain <= ntohl(cat->__msg_txt_offset) \x7c\x7c\x0a"
"\x09    remain / set_size < nsets)\x0a"
"\x09\x09return (1);\x0a"
"\x0a"
"\x09set = (struct _nls_set_hdr *) ((char *) catd->__data + cat_size);\x0a"
"\x0a"
"\x09/* make sure that msg has space for at least one index */\x0a"
"\x09if (remain - hdr_offset < msg_size)\x0a"
"\x09\x09return (1);\x0a"
"\x0a"
"\x09msg = (struct _nls_msg_hdr *) ((char *) catd->__data + cat_size\x0a"
"\x09    + hdr_offset);\x0a"
"\x0a"
"\x09/* validate and retrieve largest string offset from sets */\x0a"
"\x09off = 0;\x0a"
"\x09""for (i = 0; i < nsets; i++) {\x0a"
"\x09\x09index = ntohl(set\x5bi\x5d.__index);\x0a"
"\x09\x09nmsgs = ntohl(set\x5bi\x5d.__nmsgs);\x0a"
"\x09\x09/* set must contain at least one message */\x0a"
"\x09\x09if (index < 0 \x7c\x7c nmsgs < 1)\x0a"
"\x09\x09\x09return (1);\x0a"
"\x0a"
"\x09\x09if (INT_MAX - nmsgs < index)\x0a"
"\x09\x09\x09return (1);\x0a"
"\x09\x09msgs = index + nmsgs;\x0a"
"\x0a"
"\x09\x09/* avoid msg index overflow */\x0a"
"\x09\x09if ((remain - hdr_offset) / msg_size < msgs)\x0a"
"\x09\x09\x09return (1);\x0a"
"\x0a"
"\x09\x09/* retrieve largest string offset */\x0a"
"\x09\x09""for (j = index; j < nmsgs; j++) {\x0a"
"\x09\x09\x09if (ntohl(msg\x5bj\x5d.__offset) > INT_MAX)\x0a"
"\x09\x09\x09\x09return (1);\x0a"
"\x09\x09\x09off = MAXIMUM(off, (int) ntohl(msg\x5bj\x5d.__offset));\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x0a"
"\x09/* check if largest string offset is nul-terminated */\x0a"
"\x09if (remain - txt_offset < off \x7c\x7c\x0a"
"\x09    memchr((char *) catd->__data + cat_size + txt_offset + off,\x0a"
"\x09    '\x5c""0', remain - txt_offset - off) == NULL)\x0a"
"\x09\x09return (1);\x0a"
"\x0a"
"\x09return (0);\x0a"
"}\x0a"
"\x0a"
"", 7012 ); }