#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_pthread_pthread_cond_cpp( 
"// -*- C++ -*- (c) 2013 Milan Lenco <lencomilan\x40gmail.com>\x0a"
"//             (c) 2014-2018 Vladim\xc3\xadr \xc5\xa0till <xstill\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Henrich Lauko <xlauko\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"/* Includes */\x0a"
"#include <sys/thread.h>\x0a"
"\x0a"
"using namespace __dios;\x0a"
"\x0a"
"/* Conditional variables */\x0a"
"\x0a"
"/*\x0a"
"  pthread_cond_t representation\x3a\x0a"
"\x0a"
"    { .mutex\x3a address of associated mutex\x0a"
"      .counter\x3a number of waiting threads\x3a 16 bits\x0a"
"      .initialized\x3a 1 bit\x0a"
"      ._pad\x3a 15 bits\x0a"
"    }\x0a"
"*/\x0a"
"\x0a"
"int pthread_cond_destroy( pthread_cond_t *cond ) noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    int r = _destroy_cond_or_barrier( cond );\x0a"
"    if ( r == 0 ) {\x0a"
"        pthread_mutex_t *uninit;\x0a"
"        cond->__mutex = uninit;\x0a"
"    }\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"int pthread_cond_init( pthread_cond_t *cond, const pthread_condattr_t * /* TODO */ ) noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( cond == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    *cond = ( pthread_cond_t )PTHREAD_COND_INITIALIZER;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_cond_signal( pthread_cond_t *cond ) noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    int r = _cond_signal< false >( cond );\x0a"
"    if ( r == 0 \x26\x26 cond->__counter == 0 )\x0a"
"        cond->__mutex = NULL; // break binding between cond. variable and mutex\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"int pthread_cond_broadcast( pthread_cond_t *cond ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    int r = _cond_signal< true >( cond );\x0a"
"    if ( r == 0 \x26\x26 cond->__counter == 0 )\x0a"
"        cond->__mutex = NULL; // break binding between cond. variable and mutex\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"int pthread_cond_wait( pthread_cond_t *cond, pthread_mutex_t *mutex ) noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    _PThread \x26thread = getThread();\x0a"
"\x0a"
"    if ( cond == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    if ( mutex == NULL ) {\x0a"
"        return EINVAL;\x0a"
"    }\x0a"
"\x0a"
"    if ( mutex->__owner \x21= pthread_self() ) {\x0a"
"        // mutex is not locked or it is already locked by another thread\x0a"
"        return EPERM;\x0a"
"    }\x0a"
"\x0a"
"    if ( __vm_choose( 2 ) )\x0a"
"        return 0; // simulate spurious wakeup\x0a"
"\x0a"
"    // It is allowed to have one mutex associated with more than one conditional\x0a"
"    // variable. On the other hand, using more than one mutex for one\x0a"
"    // conditional variable results in undefined behaviour.\x0a"
"    if ( cond->__mutex \x21= NULL \x26\x26 cond->__mutex \x21= mutex )\x0a"
"        __dios_fault( _VM_Fault\x3a\x3a_VM_F_Locking, \x22""Attempted to wait on condition variable using other mutex \x22\x0a"
"                                        \x22that already in use by this condition variable\x22 );\x0a"
"    cond->__mutex = mutex;\x0a"
"\x0a"
"    // fall asleep\x0a"
"    thread.setSleeping( cond );\x0a"
"\x0a"
"    _cond_adjust_count( cond, 1 ); // one more thread is waiting for this condition\x0a"
"    pthread_mutex_unlock( mutex ); // unlock associated mutex\x0a"
"\x0a"
"    // sleeping\x0a"
"    waitOrCancel( mask, \x5b\x26\x5d { return thread.sleeping == Condition; } );\x0a"
"\x0a"
"    // try to lock mutex which was associated to the cond. variable by this\x0a"
"    // thread\x0a"
"    // (not the one from current binding, which may have changed)\x0a"
"    _mutex_lock( mask, mutex, 1 );\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_cond_timedwait( pthread_cond_t *cond, pthread_mutex_t *mutex,\x0a"
"                            const struct timespec *abstime ) noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( abstime == NULL \x7c\x7c abstime->tv_sec < 0 \x7c\x7c abstime->tv_nsec < 0 \x7c\x7c abstime->tv_nsec >= MILLIARD )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    // Consider both scenarios, one in which the time specified by abstime has\x0a"
"    // passed\x0a"
"    // before the function could finish, and the other in which\x0a"
"    // pthread_cond_timedwait behaves basically the same as pthread_cond_wait.\x0a"
"    if ( __vm_choose( 2 ) ) {\x0a"
"        return pthread_cond_wait( cond, mutex );\x0a"
"    } else {\x0a"
"        return ETIMEDOUT;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"/* Attributes of conditional variables */\x0a"
"int pthread_condattr_destroy( pthread_condattr_t * ) noexcept\x0a"
"{\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_condattr_getclock( const pthread_condattr_t *, clockid_t * ) noexcept\x0a"
"{\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_condattr_getpshared( const pthread_condattr_t *, int * ) noexcept\x0a"
"{\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_condattr_init( pthread_condattr_t * ) noexcept\x0a"
"{\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_condattr_setclock( pthread_condattr_t *, clockid_t ) noexcept\x0a"
"{\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_condattr_setpshared( pthread_condattr_t *, int ) noexcept\x0a"
"{\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"", 4421 ); }