#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_pthread_pthread_core_cpp( 
"// -*- C++ -*- (c) 2013 Milan Lenco <lencomilan\x40gmail.com>\x0a"
"//             (c) 2014-2018 Vladim\xc3\xadr \xc5\xa0till <xstill\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Henrich Lauko <xlauko\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"/* Includes */\x0a"
"#include <sys/thread.h>\x0a"
"#include <sys/divm.h>\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"static_assert( _HOST_pthr_mutex_t_size >= 16 );\x0a"
"\x0a"
"// this is not run when thread's main returns\x21\x0a"
"static void _run_cleanup_handlers() noexcept\x0a"
"{\x0a"
"    _PThread \x26thread = getThread();\x0a"
"\x0a"
"    CleanupHandler *handler = thread.cleanup_handlers;\x0a"
"    thread.cleanup_handlers = NULL;\x0a"
"    CleanupHandler *next;\x0a"
"\x0a"
"    while ( handler ) {\x0a"
"        next = handler->next;\x0a"
"        handler->routine( handler->arg );\x0a"
"        __vm_obj_free( handler );\x0a"
"        handler = next;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"void _cancel( __dios\x3a\x3a""FencedInterruptMask \x26mask ) noexcept\x0a"
"{\x0a"
"    __dios_task tid = __dios_this_task();\x0a"
"    _PThread \x26thread = getThread( tid );\x0a"
"    thread.sleeping = NotSleeping;\x0a"
"\x0a"
"    // call all cleanup handlers\x0a"
"    _run_cleanup_handlers();\x0a"
"    _clean_and_become_zombie( mask, tid );\x0a"
"}\x0a"
"\x0a"
"/* Function __pthread_entry associates current task with a new thread and\x0a"
" * executes the thread subroutine. In the end it releases thread resources.\x0a"
" *\x0a"
" * After the execution of the thread DiOS terminates current task.\x0a"
" * */\x0a"
"extern \x22""C\x22 void __pthread_entry( void *_args )\x0a"
"{\x0a"
"    __pthread_start( _args );\x0a"
"    __dios_suicide();\x0a"
"}\x0a"
"\x0a"
"static int _pthread_join( __dios\x3a\x3a""FencedInterruptMask \x26mask, __dios_task task, void **result ) noexcept\x0a"
"{\x0a"
"    _PThread \x26thread = getThread( task );\x0a"
"\x0a"
"    if ( task == __dios_this_task() )\x0a"
"        return EDEADLK;\x0a"
"\x0a"
"    if ( thread.detached )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    // wait for the thread to finnish\x0a"
"    waitOrCancel( mask, \x5b\x26\x5d { return thread.running; } );\x0a"
"\x0a"
"    if ( thread.detached )\x0a"
"        // meanwhile detached\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    // copy result\x0a"
"    if ( result ) {\x0a"
"        if ( thread.cancelled )\x0a"
"            *result = PTHREAD_CANCELED;\x0a"
"        else\x0a"
"            *result = thread.result;\x0a"
"    }\x0a"
"\x0a"
"    // kill the thread so that it does not pollute state space by ending\x0a"
"    // nondeterministically\x0a"
"    releaseAndKillThread( task );\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"}\x0a"
"\x0a"
"using namespace __dios;\x0a"
"\x0a"
"\x0a"
"/* The pthread_create() function starts a new thread in the calling\x0a"
" * process. The new thread starts execution by invoking entry();\x0a"
" * arg is passed as the sole argument of entry().\x0a"
" *\x0a"
" * Function creates a new __dios_task which calls __pthread_entry with\x0a"
" * thread entry function and its argument arg.\x0a"
" *\x0a"
" * The newly created thread is in running state.\x0a"
" * */\x0a"
"int pthread_create( __dios_task *ptid, const pthread_attr_t *attr, void *( *entry )( void * ), void *arg ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    // create new thread and pass arguments to the entry wrapper\x0a"
"    Entry *args = static_cast< Entry * >( __vm_obj_make( sizeof( Entry ), _VM_PT_Heap ) );\x0a"
"    args->entry = entry;\x0a"
"    args->arg = arg;\x0a"
"    auto tid = __dios_start_task( __pthread_entry, static_cast< void * >( args ), 0 );\x0a"
"    // init thread here, before it has first chance to run\x0a"
"    __init_thread( tid, attr == nullptr \x3f PTHREAD_CREATE_JOINABLE \x3a *attr );\x0a"
"    getThread( tid ).entry = args;\x0a"
"    *ptid = tid;\x0a"
"\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* DESCRIPTION\x0a"
" * The  pthread_exit() function terminates the calling thread and returns\x0a"
" * a value via result that (if the thread is joinable)  is  available  to\x0a"
" * another thread in the same process that calls pthread_join(3).\x0a"
" *\x0a"
" * Any clean-up handlers established by pthread_cleanup_push(3) that have\x0a"
" * not yet been popped, are popped (in the reverse of the order in  which\x0a"
" * they were pushed) and executed.  If the thread has any thread-specific\x0a"
" * data, then, after the clean-up handlers have been executed, the corre-\x0a"
" * sponding destructor functions are called, in an unspecified order.\x0a"
" *\x0a"
" * When  a  thread  terminates,  process-shared resources (e.g., mutexes,\x0a"
" * condition variables, semaphores, and file  descriptors)  are  not  re\xe2\x80\x90\x0a"
" * leased, and functions registered using atexit(3) are not called.\x0a"
" *\x0a"
" * After  the last thread in a process terminates, the process terminates\x0a"
" * as by calling exit(3) with an exit  status  of  zero;  thus,  process-\x0a"
" * shared resources are released and functions registered using atexit(3)\x0a"
" * are called.\x0a"
" *\x0a"
" * RETURN VALUE\x0a"
" * This function does not return to the caller.\x0a"
" *\x0a"
" * ERRORS\x0a"
" * This function always succeeds.\x0a"
" */\x0a"
"void pthread_exit( void *result ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    auto task = __dios_this_task();\x0a"
"    _PThread \x26thread = getThread( task );\x0a"
"    thread.result = result;\x0a"
"\x0a"
"    // in main wait for all the threads\x0a"
"    if ( thread.is_main )\x0a"
"        iterateThreads( \x5b\x26\x5d( __dios_task task ) {\x0a"
"                _pthread_join( mask, task, nullptr ); // joining self is detected and ignored\x0a"
"            } );\x0a"
"\x0a"
"    _run_cleanup_handlers();\x0a"
"    _clean_and_become_zombie( mask, task );\x0a"
"}\x0a"
"\x0a"
"/* DESCRIPTION\x0a"
" * The  pthread_join()  function waits for the thread specified by thread\x0a"
" * to  terminate.   If  that  thread   has   already   terminated,   then\x0a"
" * pthread_join()  returns  immediately.   The thread specified by thread\x0a"
" * must be joinable.\x0a"
" *\x0a"
" * If retval is not NULL, then pthread_join() copies the exit  status  of\x0a"
" * the  target thread (i.e., the value that the target thread supplied to\x0a"
" * pthread_exit(3)) into the location pointed to by retval.  If the  tar\xe2\x80\x90\x0a"
" * get  thread was canceled, then PTHREAD_CANCELED is placed in the loca\xe2\x80\x90\x0a"
" * tion pointed to by retval.\x0a"
" *\x0a"
" * If multiple threads simultaneously try to join with the  same  thread,\x0a"
" * the  results  are  undefined.  If the thread calling pthread_join() is\x0a"
" * canceled, then the target thread will remain joinable (i.e.,  it  will\x0a"
" * not be detached).\x0a"
" *\x0a"
" * RETURN VALUE\x0a"
" * On success, pthread_join() returns 0; on error, it returns an error\x0a"
" * number.\x0a"
" *\x0a"
" * ERRORS\x0a"
" * EDEADLK\x0a"
" *   A deadlock was detected (e.g., two threads tried to  join  with\x0a"
" *   each other); or thread specifies the calling thread.\x0a"
" * EINVAL thread is not a joinable thread.\x0a"
" *\x0a"
" * EINVAL Another thread is already waiting to join with this thread.\x0a"
" *\x0a"
" * TODO not detecting\x3a\x0a"
" * ESRCH  No thread with the ID thread could be found.\x0a"
" */\x0a"
"int pthread_join( pthread_t tid, void **result ) noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    return _pthread_join( mask, get_task( tid ), result );\x0a"
"}\x0a"
"\x0a"
"/* DESCRIPTION\x0a"
" * The pthread_detach() function marks the thread identified by thread as\x0a"
" * detached.  When a detached thread terminates, its resources are  auto\xe2\x80\x90\x0a"
" * matically  released  back  to  the system without the need for another\x0a"
" * thread to join with the terminated thread.\x0a"
" *\x0a"
" * Attempting to detach an already detached thread results in unspecified\x0a"
" * behavior.\x0a"
" *\x0a"
" * RETURN VALUE\x0a"
" * On success, pthread_detach() returns 0; on error, it returns an error\x0a"
" * number.\x0a"
" *\x0a"
" * ERRORS\x0a"
" * EINVAL thread is not a joinable thread.\x0a"
" *\x0a"
" * TODO not detecting\x3a\x0a"
" * ESRCH  No thread with the ID thread could be found.\x0a"
" */\x0a"
"int pthread_detach( pthread_t gtid ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    _PThread \x26thread = getThread( gtid );\x0a"
"\x0a"
"    if ( thread.detached )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    bool ended = \x21thread.running;\x0a"
"    thread.detached = true;\x0a"
"\x0a"
"    if ( ended ) {\x0a"
"        // kill the thread so that it does not pollute state space by ending\x0a"
"        // nondeterministically\x0a"
"        releaseAndKillThread( get_task( gtid ) );\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* Thread attributes */\x0a"
"\x0a"
"/*\x0a"
"   pthread_attr_t representation\x3a\x0a"
"     ------------------------------\x0a"
"    \x7c *free* \x7c detach state\x3a 1 bit \x7c\x0a"
"     ------------------------------\x0a"
"  */\x0a"
"\x0a"
"int pthread_attr_destroy( pthread_attr_t * ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_init( pthread_attr_t *attr ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    *attr = 0;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_getdetachstate( const pthread_attr_t *attr, int *state ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( attr == NULL \x7c\x7c state == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    *state = *attr \x26 _THREAD_ATTR_DETACH_MASK;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_getguardsize( const pthread_attr_t *, size_t * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_getinheritsched( const pthread_attr_t *, int * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_getschedparam( const pthread_attr_t *, struct sched_param * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_getschedpolicy( const pthread_attr_t *, int * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_getscope( const pthread_attr_t *, int * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_getstack( const pthread_attr_t *, void **, size_t * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_getstackaddr( const pthread_attr_t *, void ** ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_getstacksize( const pthread_attr_t *, size_t * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_setdetachstate( pthread_attr_t *attr, int state ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( attr == NULL \x7c\x7c ( state \x26 \x7e_THREAD_ATTR_DETACH_MASK ) )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    *attr \x26= \x7e_THREAD_ATTR_DETACH_MASK;\x0a"
"    *attr \x7c= state;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_setguardsize( pthread_attr_t *, size_t ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_setinheritsched( pthread_attr_t *, int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_setschedparam( pthread_attr_t *, const struct sched_param * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_setschedpolicy( pthread_attr_t *, int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_setscope( pthread_attr_t *, int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_setstack( pthread_attr_t *, void *, size_t ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_setstackaddr( pthread_attr_t *, void * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_attr_setstacksize( pthread_attr_t *, size_t ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* Thread ID */\x0a"
"\x0a"
"/* pthread is represented by dios task */\x0a"
"pthread_t pthread_self( void ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    return get_tid( __dios_this_task() );\x0a"
"}\x0a"
"\x0a"
"int pthread_equal( pthread_t t1, pthread_t t2 ) noexcept {\x0a"
"    return t1 == t2;\x0a"
"}\x0a"
"\x0a"
"/* Scheduler */\x0a"
"int pthread_getconcurrency( void ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_getcpuclockid( pthread_t, clockid_t * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_getschedparam( pthread_t, int *, struct sched_param * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_setconcurrency( int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_setschedparam( pthread_t, int, const struct sched_param * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_setschedprio( pthread_t, int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* Spin lock */\x0a"
"\x0a"
"int pthread_spin_destroy( pthread_spinlock_t * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_spin_init( pthread_spinlock_t *, int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_spin_lock( pthread_spinlock_t * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_spin_trylock( pthread_spinlock_t * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_spin_unlock( pthread_spinlock_t * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* POSIX Realtime Extension - sched.h */\x0a"
"int sched_get_priority_max( int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int sched_get_priority_min( int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int sched_getparam( pid_t, struct sched_param * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int sched_getscheduler( pid_t ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int sched_rr_get_interval( pid_t, struct timespec * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int sched_setparam( pid_t, const struct sched_param * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int sched_setscheduler( pid_t, int, const struct sched_param * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int sched_yield( void ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_yield( void ) noexcept {\x0a"
"    return 0;\x0a"
"}\x0a"
"", 12157 ); }