#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_pthread_pthread_init_cpp( 
"// -*- C++ -*- (c) 2013 Milan Lenco <lencomilan\x40gmail.com>\x0a"
"//             (c) 2014-2018 Vladim\xc3\xadr \xc5\xa0till <xstill\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Henrich Lauko <xlauko\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"/* Includes */\x0a"
"#include <sys/thread.h>\x0a"
"\x0a"
"using namespace __dios;\x0a"
"\x0a"
"/* Initializes a thread of the main task. This should be executed before we\x0a"
" * run main and call global constructors, because they may depend on thread\x0a"
" * data.\x0a"
" * */\x0a"
"void __pthread_initialize() noexcept\x0a"
"{\x0a"
"    // initialize implicitly created main thread\x0a"
"    __init_thread( __dios_this_task(), PTHREAD_CREATE_DETACHED );\x0a"
"    getThread().is_main = true;\x0a"
"    getThread().started = true;\x0a"
"}\x0a"
"\x0a"
"/* Terminate and cleanup all threads except itself for the current process.\x0a"
" * All threads are killed and their TLS is deallocated without calling cleanup\x0a"
" * handlers.\x0a"
" *\x0a"
" * This function is used at exit() from process.\x0a"
" * */\x0a"
"void __pthread_finalize() noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    auto **threads = __dios_this_process_tasks();\x0a"
"    auto *self = __dios_this_task();\x0a"
"    int cnt = __vm_obj_size( threads ) / sizeof( struct __dios_tls * );\x0a"
"    for ( int i = 0; i < cnt; ++i )\x0a"
"    {\x0a"
"        /* FIXME this conflicts with any non-pthread tasks with non-trivial TLS */\x0a"
"        if ( __vm_obj_size( threads\x5bi\x5d ) > sizeof( struct __dios_tls ) )\x0a"
"            delete \x26getThread( threads\x5bi\x5d );\x0a"
"        if ( threads\x5b i \x5d \x21= self )\x0a"
"            __dios_kill( threads\x5b i \x5d );\x0a"
"    }\x0a"
"    __vm_obj_free( threads );\x0a"
"\x0a"
"    __pthread_atfork_fini();\x0a"
"    __pthread_tls_fini();\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* At start of a thread, DiOS associates the current task with the thread.\x0a"
" * Hence the tid is initialized to be equal to __dios_task handle.\x0a"
" *\x0a"
" * The __pthread_start function executes thread entry function in an unmasked\x0a"
" * environment (with enabled interrupts), and stores the result to thread storage\x0a"
" * (see dios/include/sys/thread.h).\x0a"
" *\x0a"
" * After successful execution, thread storage is released and the thread\x0a"
" * becomes zombie (see _clean_and_become_zombie).\x0a"
" */\x0a"
"__noinline void __pthread_start( void *_args )\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    Entry *args = static_cast< Entry * >( _args );\x0a"
"    auto tid = __dios_this_task();\x0a"
"    _PThread \x26thread = getThread( tid );\x0a"
"\x0a"
"    // copy arguments\x0a"
"    void *arg = args->arg;\x0a"
"    auto entry = args->entry;\x0a"
"    __vm_obj_free( _args );\x0a"
"\x0a"
"    thread.entry = nullptr;\x0a"
"    thread.started = true;\x0a"
"\x0a"
"    // call entry function\x0a"
"    mask.without( \x5b\x26\x5d {\x0a"
"        thread.result = entry( arg );\x0a"
"    } );\x0a"
"\x0a"
"    assert( thread.sleeping == false );\x0a"
"\x0a"
"    _clean_and_become_zombie( mask, tid );\x0a"
"}\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"/* Creates a thread for task \x60gtid\x60. Constructs its thread local storage\x0a"
" * and sets its metadata. The resulting thread is in running state.\x0a"
" *\x0a"
" * Each thread, either main thread or threads created by\x0a"
" * pthread_create, is initialized by this method.\x0a"
" * */\x0a"
"void __init_thread( const __dios_task gtid, const pthread_attr_t attr ) noexcept\x0a"
"{\x0a"
"    __dios_assert( gtid );\x0a"
"\x0a"
"    if ( __vm_obj_size( gtid ) < _PthreadTLS\x3a\x3araw_size( 0 ) )\x0a"
"        __vm_obj_resize( gtid, _PthreadTLS\x3a\x3araw_size( 0 ) );\x0a"
"    auto *thread = new _PThread;\x0a"
"    tls( gtid ).thread = thread;\x0a"
"\x0a"
"    // initialize thread metadata\x0a"
"    thread->started = false;\x0a"
"    thread->running = true;\x0a"
"    thread->detached = ( ( attr \x26 _THREAD_ATTR_DETACH_MASK ) == PTHREAD_CREATE_DETACHED );\x0a"
"    thread->condition = nullptr;\x0a"
"    thread->cancel_state = PTHREAD_CANCEL_ENABLE;\x0a"
"    thread->cancel_type = PTHREAD_CANCEL_DEFERRED;\x0a"
"}\x0a"
"\x0a"
"/* Cleanup TLS associated with thread \x60tid\x60. For every tls key calls associated\x0a"
" * cleanup handler until any such handler exists.\x0a"
" *\x0a"
" * If the terminating thread is main, the function exits the process. Otherwise,\x0a"
" * the thread is either is in the detached state than it can be freely killed and\x0a"
" * release its storage, else the thread needs to wait to be detached or joined.\x0a"
" */\x0a"
"_Noreturn void _clean_and_become_zombie( __dios\x3a\x3a""FencedInterruptMask \x26mask,\x0a"
"                                         __dios_task tid ) noexcept\x0a"
"{\x0a"
"    _PThread \x26thread = getThread( tid );\x0a"
"    // An  optional  destructor  function may be associated with each key\x0a"
"    // value.  At thread exit, if a key value has a non-NULL destructor\x0a"
"    // pointer, and the thread has a non-NULL value associated with that key,\x0a"
"    // the value of the key is set to NULL, and then the function pointed to is\x0a"
"    // called with the previously associated value as its sole argument. The\x0a"
"    // order of destructor calls is unspecified if more than one destructor\x0a"
"    // exists for a thread when it exits.\x0a"
"    //\x0a"
"    // If, after all the destructors have been called for all non-NULL values\x0a"
"    // with associated destructors, there are still some non-NULL values  with\x0a"
"    // associated  destructors, then  the  process  is  repeated.  If,  after\x0a"
"    // at  least {PTHREAD_DESTRUCTOR_ITERATIONS}  iterations  of destructor\x0a"
"    // calls for outstanding non-NULL values, there are still some non-NULL\x0a"
"    // values with associated destructors, implementations may stop calling\x0a"
"    // destructors, or they may continue calling destructors until no\x0a"
"    // non-NULL values with associated destructors exist, even though this\x0a"
"    // might result in an infinite loop.\x0a"
"    int iter = 0;\x0a"
"    bool done;\x0a"
"\x0a"
"    auto \x26tls = __dios\x3a\x3atls( tid );\x0a"
"    do {\x0a"
"        done = true;\x0a"
"        for ( int i = 0; i < tls.keyCount(); ++i )\x0a"
"            if ( tls.getKey( i ) )\x0a"
"            {\x0a"
"                done = false;\x0a"
"                tls.destroy( i );\x0a"
"            }\x0a"
"        ++iter;\x0a"
"    } while ( iter <= PTHREAD_DESTRUCTOR_ITERATIONS \x26\x26 \x21""done );\x0a"
"\x0a"
"    thread.running = false;\x0a"
"\x0a"
"    if ( thread.is_main )\x0a"
"        exit( 0 );\x0a"
"\x0a"
"    if ( thread.detached )\x0a"
"        releaseAndKillThread( tid );\x0a"
"    else // wait until detach / join kills us\x0a"
"        wait( mask, \x5b\x26\x5d { return true; } );\x0a"
"    __builtin_trap();\x0a"
"}\x0a"
"\x0a"
"}\x0a"
"", 5844 ); }