#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_pthread_pthread_mutex_cpp( 
"// -*- C++ -*- (c) 2013 Milan Lenco <lencomilan\x40gmail.com>\x0a"
"//             (c) 2014-2018 Vladim\xc3\xadr \xc5\xa0till <xstill\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Henrich Lauko <xlauko\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"/* Includes */\x0a"
"#include <sys/thread.h>\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"/* Mutex */\x0a"
"\x0a"
"/*\x0a"
"  pthread_mutex_t representation\x3a\x0a"
"  -----------------------------------------------------------------------------------------------\x0a"
" \x7c *free* \x7c initialized\x3f\x3a 1 bit \x7c type\x3a 2 bits \x7c lock counter\x3a 8 bits \x7c\x0a"
" (thread_id + 1)\x3a 16 bits \x7c\x0a"
"  -----------------------------------------------------------------------------------------------\x0a"
"  */\x0a"
"\x0a"
"static int _mutex_adjust_count( pthread_mutex_t *mutex, int adj ) noexcept {\x0a"
"    int count = mutex->__lockCounter;\x0a"
"    count += adj;\x0a"
"    if ( count >= ( 1 << 28 ) \x7c\x7c count < 0 )\x0a"
"        return EAGAIN;\x0a"
"\x0a"
"    mutex->__lockCounter = count;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* The function _check_deadlock tries to find a cycle dependency in waiting\x0a"
" * threads. For this reason, a thread maintains a mutex on which it is waiting,\x0a"
" * and mutex keeps a pointer to a thread which holds it. Hence threads and\x0a"
" * mutexes together form a graph of dependencies in which we can detect a\x0a"
" * cycle.\x0a"
" */\x0a"
"static bool _check_deadlock( pthread_mutex_t *mutex, _PThread \x26tid ) noexcept\x0a"
"{\x0a"
"    // note\x3a the cycle is detected first time it occurs, therefore it must go\x0a"
"    // through this mutex, for this reason, we don't need to keep closed set of\x0a"
"    // visited threads and mutexes.\x0a"
"    // Furthermore, if the cycle is re-detected it is already marked in\x0a"
"    // 'deadlocked' attribute of Thread struct.\x0a"
"\x0a"
"    while ( mutex \x26\x26 mutex->__owner )\x0a"
"    {\x0a"
"        _PThread *owner = \x26getThread( mutex->__owner );\x0a"
"        if ( owner == \x26tid )\x0a"
"        {\x0a"
"            __dios_fault( _VM_Fault\x3a\x3a_VM_F_Locking, \x22""deadlock\x3a circular wait on a mutex\x22 );\x0a"
"            return tid.deadlocked = owner->deadlocked = true;\x0a"
"        }\x0a"
"        if ( owner->deadlocked )\x0a"
"        {\x0a"
"            __dios_fault( _VM_Fault\x3a\x3a_VM_F_Locking, \x22""deadlock\x3a waiting for a deadlocked thread\x22 );\x0a"
"            return tid.deadlocked = true;\x0a"
"        }\x0a"
"        if ( \x21owner->running )\x0a"
"        {\x0a"
"            __dios_fault( _VM_Fault\x3a\x3a_VM_F_Locking, \x22""deadlock\x3a mutex locked by a dead thread\x22 );\x0a"
"            return tid.deadlocked = true;\x0a"
"        }\x0a"
"        mutex = owner->waiting_mutex;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"static bool _mutex_can_lock( pthread_mutex_t *mutex, _PThread \x26thr ) noexcept {\x0a"
"    return \x21mutex->__owner \x7c\x7c ( \x26getThread( mutex->__owner ) == \x26thr );\x0a"
"}\x0a"
"\x0a"
"int _mutex_lock( __dios\x3a\x3a""FencedInterruptMask \x26mask, pthread_mutex_t *mutex, bool wait ) noexcept\x0a"
"{\x0a"
"    __dios_task task = __dios_this_task();\x0a"
"    _PThread \x26thr = getThread( task );\x0a"
"\x0a"
"    if ( mutex == NULL ) {\x0a"
"        return EINVAL; // mutex does not refer to an initialized mutex object\x0a"
"    }\x0a"
"\x0a"
"    if ( mutex->__owner \x26\x26 \x26getThread( mutex->__owner ) == \x26thr ) {\x0a"
"        // already locked by this thread\x0a"
"        assert( mutex->__lockCounter ); // count should be > 0\x0a"
"        if ( mutex->__type \x21= PTHREAD_MUTEX_RECURSIVE ) {\x0a"
"            if ( mutex->__type == PTHREAD_MUTEX_ERRORCHECK )\x0a"
"                return EDEADLK;\x0a"
"            else\x0a"
"                __dios_fault( _VM_Fault\x3a\x3a_VM_F_Locking, \x22""deadlock\x3a double lock on a nonrecursive mutex\x22 );\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    if ( \x21_mutex_can_lock( mutex, thr ) ) {\x0a"
"        assert( mutex->__lockCounter ); // count should be > 0\x0a"
"        if ( \x21wait )\x0a"
"            return EBUSY;\x0a"
"    }\x0a"
"\x0a"
"    // mark waiting now for wait cycle detection\x0a"
"    // note\x3a waiting should not be set in case of unsuccessfull try-lock\x0a"
"    // (cycle in try-lock is not deadlock, although it might be livelock)\x0a"
"    // so it must be here after return EBUSY\x0a"
"    thr.waiting_mutex = mutex;\x0a"
"    bool can_lock = _mutex_can_lock( mutex, thr );\x0a"
"\x0a"
"    if ( \x21""can_lock )\x0a"
"        mask.without( \x5b\x5d { __dios_reschedule(); } );\x0a"
"\x0a"
"    if ( \x21_mutex_can_lock( mutex, thr ) )\x0a"
"    {\x0a"
"        if ( _check_deadlock( mutex, thr ) )\x0a"
"            __dios_suspend();\x0a"
"        else\x0a"
"            __vm_cancel();\x0a"
"    }\x0a"
"\x0a"
"    thr.waiting_mutex = NULL;\x0a"
"\x0a"
"    // try to increment lock counter\x0a"
"    int err = _mutex_adjust_count( mutex, 1 );\x0a"
"    if ( err )\x0a"
"        return err;\x0a"
"\x0a"
"    // lock the mutex\x0a"
"    acquireThread( thr );\x0a"
"    mutex->__owner = get_tid( task );\x0a"
"\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"}\x0a"
"\x0a"
"using namespace __dios;\x0a"
"\x0a"
"int pthread_mutex_destroy( pthread_mutex_t *mutex ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( mutex == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    if ( mutex->__owner ) {\x0a"
"        // mutex is locked\x0a"
"        if ( mutex->__type == PTHREAD_MUTEX_ERRORCHECK )\x0a"
"            return EBUSY;\x0a"
"        else\x0a"
"            __dios_fault( _VM_Fault\x3a\x3a_VM_F_Locking, \x22""destroying a locked mutex\x22 );\x0a"
"    }\x0a"
"    pthread_mutex_t uninit;\x0a"
"    *mutex = uninit;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutex_init( pthread_mutex_t *mutex, const pthread_mutexattr_t *attr ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( mutex == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    /* bitfield initializers can be only used as such, that is, initializers,\x0a"
"     * *not* as a right-hand side of an assignment to uninitialised memory */\x0a"
"    mutex->__owner = NULL;\x0a"
"    mutex->__bitflags = 1;\x0a"
"\x0a"
"    if ( attr )\x0a"
"        mutex->__type = attr->__type;\x0a"
"    else\x0a"
"        mutex->__type = PTHREAD_MUTEX_DEFAULT;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutex_lock( pthread_mutex_t *mutex ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    return _mutex_lock( mask, mutex, 1 );\x0a"
"}\x0a"
"\x0a"
"int pthread_mutex_trylock( pthread_mutex_t *mutex ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    return _mutex_lock( mask, mutex, 0 );\x0a"
"}\x0a"
"\x0a"
"int pthread_mutex_unlock( pthread_mutex_t *mutex ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    _PThread \x26thr = getThread();\x0a"
"\x0a"
"    if ( mutex == NULL ) {\x0a"
"        return EINVAL; // mutex does not refer to an initialized mutex object\x0a"
"    }\x0a"
"\x0a"
"    if ( mutex->__owner == 0 ) {\x0a"
"        if ( mutex->__type == PTHREAD_MUTEX_NORMAL )\x0a"
"            __dios_fault( _VM_Fault\x3a\x3a_VM_F_Locking, \x22mutex already unlocked\x22 );\x0a"
"        else\x0a"
"            return EPERM;\x0a"
"    }\x0a"
"\x0a"
"    if ( mutex->__owner \x21= pthread_self() ) {\x0a"
"        // mutex is not locked or it is already locked by another thread\x0a"
"        assert( mutex->__lockCounter ); // count should be > 0\x0a"
"        if ( mutex->__type == PTHREAD_MUTEX_NORMAL )\x0a"
"            __dios_fault( _VM_Fault\x3a\x3a_VM_F_Locking, \x22mutex locked by another thread\x22 );\x0a"
"        else\x0a"
"            return EPERM; // recursive mutex can also detect\x0a"
"    }\x0a"
"\x0a"
"    int r = _mutex_adjust_count( mutex, -1 );\x0a"
"    assert( r == 0 );\x0a"
"    if ( \x21mutex->__lockCounter ) {\x0a"
"        releaseThread( getThread( mutex->__owner ) );\x0a"
"        mutex->__owner = 0; // unlock if count == 0\x0a"
"\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutex_getprioceiling( const pthread_mutex_t *, int * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutex_setprioceiling( pthread_mutex_t *, int, int * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutex_timedlock( pthread_mutex_t *mutex, const struct timespec *abstime ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( abstime == NULL \x7c\x7c abstime->tv_nsec < 0 \x7c\x7c abstime->tv_nsec >= MILLIARD ) {\x0a"
"        return EINVAL;\x0a"
"    }\x0a"
"\x0a"
"    // Consider both scenarios, one in which the mutex could not be locked\x0a"
"    // before the specified timeout expired, and the other in which\x0a"
"    // pthread_mutex_timedlock behaves basically the same as pthread_mutex_lock.\x0a"
"    if ( __vm_choose( 2 ) ) {\x0a"
"        return pthread_mutex_lock( mutex );\x0a"
"    } else {\x0a"
"        return ETIMEDOUT;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"/* Mutex attributes */\x0a"
"\x0a"
"/*\x0a"
"  pthread_mutexattr_t representation\x3a\x0a"
"  -----------------------------\x0a"
" \x7c *free* \x7c mutex type\x3a 2 bits \x7c\x0a"
"  -----------------------------\x0a"
"*/\x0a"
"\x0a"
"int pthread_mutexattr_destroy( pthread_mutexattr_t *attr ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( attr == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    int uninit;\x0a"
"    attr->__type = uninit;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutexattr_init( pthread_mutexattr_t *attr ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( attr == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    attr->__type = PTHREAD_MUTEX_DEFAULT;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutexattr_gettype( const pthread_mutexattr_t *attr, int *value ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( attr == NULL \x7c\x7c value == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    *value = attr->__type \x26 _MUTEX_ATTR_TYPE_MASK;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutexattr_getprioceiling( const pthread_mutexattr_t *, int * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutexattr_getprotocol( const pthread_mutexattr_t *, int * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutexattr_getpshared( const pthread_mutexattr_t *, int * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutexattr_settype( pthread_mutexattr_t *attr, int value ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( attr == NULL \x7c\x7c ( value \x26 \x7e_MUTEX_ATTR_TYPE_MASK ) )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    attr->__type = value;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutexattr_setprioceiling( pthread_mutexattr_t *, int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutexattr_setprotocol( pthread_mutexattr_t *, int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_mutexattr_setpshared( pthread_mutexattr_t *, int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"", 9250 ); }