#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_pthread_pthread_tls_cpp( 
"// -*- C++ -*- (c) 2013 Milan Lenco <lencomilan\x40gmail.com>\x0a"
"//             (c) 2014-2018 Vladim\xc3\xadr \xc5\xa0till <xstill\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Henrich Lauko <xlauko\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"/* Includes */\x0a"
"#include <sys/thread.h>\x0a"
"\x0a"
"using namespace __dios;\x0a"
"\x0a"
"using _PthreadTLSDestructors = _PthreadHandlers< Destructor >;\x0a"
"static _PthreadTLSDestructors tlsDestructors;\x0a"
"\x0a"
"void __pthread_tls_fini() noexcept { tlsDestructors.fini(); }\x0a"
"\x0a"
"void *_PthreadTLS\x3a\x3araw() noexcept\x0a"
"{\x0a"
"    return reinterpret_cast< char * >( this ) - sizeof( __dios_tls );\x0a"
"}\x0a"
"\x0a"
"int _PthreadTLS\x3a\x3akeyCount() noexcept\x0a"
"{\x0a"
"    return ( __vm_obj_size( raw() ) - raw_size( 0 ) ) / sizeof( void * );\x0a"
"}\x0a"
"\x0a"
"void _PthreadTLS\x3a\x3amakeFit( int count ) noexcept\x0a"
"{\x0a"
"    int now = keyCount();\x0a"
"    if ( count > now )\x0a"
"    {\x0a"
"        __vm_obj_resize( raw(), raw_size( count ) );\x0a"
"        for ( int i = now; i < count; ++i )\x0a"
"            keys\x5b i \x5d = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"void _PthreadTLS\x3a\x3ashrink() noexcept\x0a"
"{\x0a"
"    int count = keyCount();\x0a"
"    int toDrop = 0;\x0a"
"    for ( int i = count - 1; i >= 0; --i )\x0a"
"        if ( keys\x5b i \x5d == nullptr )\x0a"
"            ++toDrop;\x0a"
"        else\x0a"
"            break;\x0a"
"    if ( toDrop )\x0a"
"        __vm_obj_resize( raw(), raw_size( count - toDrop ) );\x0a"
"}\x0a"
"\x0a"
"void *_PthreadTLS\x3a\x3agetKey( int key ) noexcept\x0a"
"{\x0a"
"    assert( key >= 0 \x26\x26 key < tlsDestructors.count() );\x0a"
"    if ( key >= keyCount() )\x0a"
"        return nullptr;\x0a"
"    return keys\x5b key \x5d;\x0a"
"}\x0a"
"\x0a"
"void _PthreadTLS\x3a\x3asetKey( int key, const void *value ) noexcept\x0a"
"{\x0a"
"    assert( key >= 0 \x26\x26 key < tlsDestructors.count() );\x0a"
"    const int c = keyCount();\x0a"
"    if ( value == nullptr \x26\x26 key >= c )\x0a"
"        return;\x0a"
"    if ( key >= c )\x0a"
"        makeFit( key + 1 );\x0a"
"    keys\x5b key \x5d = const_cast< void * >( value );\x0a"
"    if ( value == nullptr )\x0a"
"        shrink();\x0a"
"}\x0a"
"\x0a"
"void _PthreadTLS\x3a\x3a""destroy( int key ) noexcept\x0a"
"{\x0a"
"    auto data = getKey( key );\x0a"
"    setKey( key, nullptr );\x0a"
"    tlsDestructors\x5b key \x5d( data );\x0a"
"}\x0a"
"\x0a"
"/* DESCRIPTION\x0a"
" * The pthread_key_create() function shall create a thread-specific data key\x0a"
" * visible to all threads in the process. Key values provided by\x0a"
" * pthread_key_create() are opaque objects used to locate thread-specific data.\x0a"
" * Although the same key value may be used by different threads, the values\x0a"
" * bound to the key by pthread_setspecific() are maintained on a per-thread\x0a"
" * basis and persist for the life of the calling thread.\x0a"
"\x0a"
" * Upon key creation, the value NULL shall be associated with the new key in all\x0a"
" * active threads. Upon thread creation, the value NULL shall be associated with\x0a"
" * all defined keys in the new thread.\x0a"
"\x0a"
" * An optional destructor function may be associated with each key value. At\x0a"
" * thread exit, if a key value has a non-NULL destructor pointer, and the thread\x0a"
" * has a non-NULL value associated with that key, the value of the key is set to\x0a"
" * NULL, and then the function pointed to is called with the previously associated\x0a"
" * value as its sole argument. The order of destructor calls is unspecified if\x0a"
" * more than one destructor exists for a thread when it exits.\x0a"
" *\x0a"
" * RETURN VALUE\x0a"
" * If successful, the pthread_key_create() function shall store the newly created\x0a"
" * key value at *key and shall return zero. Otherwise, an error number shall be\x0a"
" * returned to indicate the error.\x0a"
" *\x0a"
" * ERRORS\x0a"
" *\x0a"
" * The pthread_key_create() function shall fail if\x3a\x0a"
" *\x0a"
" * \x5b""EAGAIN\x5d The system lacked the necessary resources to create another\x0a"
" * thread-specific data key, or the system-imposed limit on the total number of\x0a"
" * keys per process {PTHREAD_KEYS_MAX} has been exceeded.\x0a"
" *\x0a"
" * \x5b""ENOMEM\x5d Insufficient memory exists to create the key.\x0a"
" *\x0a"
" * The pthread_key_create() function shall not return an error code of \x5b""EINTR\x5d.\x0a"
" * */\x0a"
"int pthread_key_create( pthread_key_t *p_key, void ( *destructor )( void * ) ) noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    tlsDestructors.init();\x0a"
"\x0a"
"    *p_key = tlsDestructors.getFirstAvailable();;\x0a"
"    tlsDestructors\x5b *p_key \x5d = destructor \x3f\x3a \x5b\x5d( void * ) { };\x0a"
"\x0a"
"    // TODO\x3a simulate errors\x3f\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* DESCRIPTION\x0a"
" * The pthread_key_delete() function shall delete a thread-specific data key\x0a"
" * previously returned by pthread_key_create(). The thread-specific data values\x0a"
" * associated with key need not be NULL at the time pthread_key_delete() is\x0a"
" * called. It is the responsibility of the application to free any application\x0a"
" * storage or perform any cleanup actions for data structures related to the\x0a"
" * deleted key or associated thread-specific data in any threads; this cleanup\x0a"
" * can be done either before or after pthread_key_delete() is called. Any\x0a"
" * attempt to use key following the call to pthread_key_delete() results in\x0a"
" * undefined behavior.\x0a"
" *\x0a"
" * The pthread_key_delete() function shall be callable from within destructor\x0a"
" * functions. No destructor functions shall be invoked by pthread_key_delete().\x0a"
" * Any destructor function that may have been associated with key shall no\x0a"
" * longer be called upon thread exit.\x0a"
" *\x0a"
" * RETURN VALUE\x0a"
" * If successful, the pthread_key_delete() function shall return zero;\x0a"
" * otherwise, an error number shall be returned to indicate the error.\x0a"
" *\x0a"
" * ERRORS\x0a"
" * The pthread_key_delete() function may fail if\x3a\x0a"
" *\x0a"
" * \x5b""EINVAL\x5d\x0a"
" * The key value is invalid.\x0a"
" *\x0a"
" * The pthread_key_delete() function shall not return an error code of \x5b""EINTR\x5d.\x0a"
" */\x0a"
"int pthread_key_delete( pthread_key_t key ) noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( key >= tlsDestructors.count() )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    iterateThreads( \x5b\x26\x5d( __dios_task tid ) {\x0a"
"            tls( tid ).setKey( key, nullptr );\x0a"
"            tls( tid ).shrink();\x0a"
"        } );\x0a"
"    tlsDestructors\x5b key \x5d = nullptr;\x0a"
"    tlsDestructors.shrink();\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* DESCRIPTION\x0a"
" * The pthread_setspecific() function shall associate a thread-specific value\x0a"
" * with a key obtained via a previous call to pthread_key_create(). Different\x0a"
" * threads may bind different values to the same key. These values are typically\x0a"
" * pointers to blocks of dynamically allocated memory that have been reserved for\x0a"
" * use by the calling thread.\x0a"
" *\x0a"
" * The effect of calling pthread_setspecific() with a key value not obtained\x0a"
" * from pthread_key_create() or after key has been deleted with\x0a"
" * pthread_key_delete() is undefined.\x0a"
" *\x0a"
" * Function pthread_setspecific() may be called from a thread-specific data\x0a"
" * destructor function. Calling pthread_setspecific() from a thread-specific\x0a"
" * data destructor routine may result either in lost storage (after at least\x0a"
" * PTHREAD_DESTRUCTOR_ITERATIONS attempts at destruction) or in an infinite loop.\x0a"
" *\x0a"
" * RETURN VALUE\x0a"
" * If successful, the pthread_setspecific() function shall return zero; otherwise,\x0a"
" * an error number shall be returned to indicate the error.\x0a"
" *\x0a"
" * ERRORS\x0a"
" * The pthread_setspecific() function shall fail if\x3a\x0a"
" *\x0a"
" * \x5b""ENOMEM\x5d\x0a"
" * Insufficient memory exists to associate the value with the key.\x0a"
" * The pthread_setspecific() function may fail if\x3a\x0a"
" *\x0a"
" * \x5b""EINVAL\x5d\x0a"
" * The key value is invalid.\x0a"
" *\x0a"
" * The pthread_setspecific() functions shall not return an error code of \x5b""EINTR\x5d.\x0a"
" * */\x0a"
"int pthread_setspecific( pthread_key_t key, const void *data ) noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    tls( __dios_this_task() ).setKey( key, data );\x0a"
"    // TODO\x3a simulate errors\x3f\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* DESCRIPTION\x0a"
" * The pthread_getspecific() function shall return the value currently bound to\x0a"
" * the specified key on behalf of the calling thread.\x0a"
" *\x0a"
" * The effect of calling pthread_getspecific() with a key value not obtained\x0a"
" * from pthread_key_create() or after key has been deleted with\x0a"
" * pthread_key_delete() is undefined.\x0a"
" *\x0a"
" * Function pthread_getspecific() may be called from a thread-specific\x0a"
" * data destructor function. A call to pthread_getspecific() for\x0a"
" * the thread-specific data key being destroyed shall return the value NULL,\x0a"
" * unless the value is changed (after the destructor starts) by a call to\x0a"
" * pthread_setspecific().\x0a"
" *\x0a"
" * RETURN VALUE\x0a"
" * The pthread_getspecific() function shall return the thread-specific data value\x0a"
" * associated with the given key. If no thread-specific data value is associated\x0a"
" * with key, then the value NULL shall be returned.\x0a"
" *\x0a"
" * ERRORS\x0a"
" * No errors are returned from pthread_getspecific().\x0a"
" * */\x0a"
"void *pthread_getspecific( pthread_key_t key ) noexcept\x0a"
"{\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    return tls( __dios_this_task() ).getKey( key );\x0a"
"}\x0a"
"", 8349 ); }