#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_regcomp_c( 
"/*\x0a"
"  tre_regcomp.c - TRE POSIX compatible regex compilation functions.\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"\x0a"
"#include <string.h>\x0a"
"#include <errno.h>\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"#include \x22tre.h\x22\x0a"
"#include \x22tre-internal.h\x22\x0a"
"#include \x22xmalloc.h\x22\x0a"
"\x0a"
"int\x0a"
"tre_regncomp(regex_t *preg, const char *regex, size_t n, int cflags)\x0a"
"{\x0a"
"  int ret;\x0a"
"#if TRE_WCHAR\x0a"
"  tre_char_t *wregex;\x0a"
"  size_t wlen;\x0a"
"\x0a"
"  wregex = xmalloc(sizeof(tre_char_t) * (n + 1));\x0a"
"  if (wregex == NULL)\x0a"
"    return REG_ESPACE;\x0a"
"\x0a"
"  /* If the current locale uses the standard single byte encoding of\x0a"
"     characters, we don't do a multibyte string conversion.  If we did,\x0a"
"     many applications which use the default locale would break since\x0a"
"     the default \x22""C\x22 locale uses the 7-bit ASCII character set, and\x0a"
"     all characters with the eighth bit set would be considered invalid. */\x0a"
"#if TRE_MULTIBYTE\x0a"
"  if (TRE_MB_CUR_MAX == 1)\x0a"
"#endif /* TRE_MULTIBYTE */\x0a"
"    {\x0a"
"      unsigned int i;\x0a"
"      const unsigned char *str = (const unsigned char *)regex;\x0a"
"      tre_char_t *wstr = wregex;\x0a"
"\x0a"
"      for (i = 0; i < n; i++)\x0a"
"\x09*(wstr++) = *(str++);\x0a"
"      wlen = n;\x0a"
"    }\x0a"
"#if TRE_MULTIBYTE\x0a"
"  else\x0a"
"    {\x0a"
"      int consumed;\x0a"
"      tre_char_t *wcptr = wregex;\x0a"
"#ifdef HAVE_MBSTATE_T\x0a"
"      mbstate_t state;\x0a"
"      memset(\x26state, '\x5c""0', sizeof(state));\x0a"
"#endif /* HAVE_MBSTATE_T */\x0a"
"      while (n > 0)\x0a"
"\x09{\x0a"
"\x09  consumed = tre_mbrtowc(wcptr, regex, n, \x26state);\x0a"
"\x0a"
"\x09  switch (consumed)\x0a"
"\x09    {\x0a"
"\x09    case 0\x3a\x0a"
"\x09      if (*regex == '\x5c""0')\x0a"
"\x09\x09""consumed = 1;\x0a"
"\x09      else\x0a"
"\x09\x09{\x0a"
"\x09\x09  xfree(wregex);\x0a"
"\x09\x09  return REG_BADPAT;\x0a"
"\x09\x09}\x0a"
"\x09      break;\x0a"
"\x09    case -1\x3a\x0a"
"\x09      DPRINT((\x22mbrtowc\x3a error \x25""d\x3a \x25s.\x5cn\x22, errno, strerror(errno)));\x0a"
"\x09      xfree(wregex);\x0a"
"\x09      return REG_BADPAT;\x0a"
"\x09    case -2\x3a\x0a"
"\x09      /* The last character wasn't complete.  Let's not call it a\x0a"
"\x09\x09 fatal error. */\x0a"
"\x09      consumed = n;\x0a"
"\x09      break;\x0a"
"\x09    }\x0a"
"\x09  regex += consumed;\x0a"
"\x09  n -= consumed;\x0a"
"\x09  wcptr++;\x0a"
"\x09}\x0a"
"      wlen = wcptr - wregex;\x0a"
"    }\x0a"
"#endif /* TRE_MULTIBYTE */\x0a"
"\x0a"
"  wregex\x5bwlen\x5d = L'\x5c""0';\x0a"
"  ret = tre_compile(preg, wregex, wlen, cflags);\x0a"
"  xfree(wregex);\x0a"
"#else /* \x21TRE_WCHAR */\x0a"
"  ret = tre_compile(preg, (const tre_char_t *)regex, n, cflags);\x0a"
"#endif /* \x21TRE_WCHAR */\x0a"
"\x0a"
"  return ret;\x0a"
"}\x0a"
"\x0a"
"/* this version takes bytes literally, to be used with raw vectors */\x0a"
"int\x0a"
"tre_regncompb(regex_t *preg, const char *regex, size_t n, int cflags)\x0a"
"{\x0a"
"  int ret;\x0a"
"#if TRE_WCHAR /* wide chars = we need to convert it all to the wide format */\x0a"
"  tre_char_t *wregex;\x0a"
"  size_t i;\x0a"
"\x0a"
"  wregex = xmalloc(sizeof(tre_char_t) * n);\x0a"
"  if (wregex == NULL)\x0a"
"    return REG_ESPACE;\x0a"
"\x0a"
"  for (i = 0; i < n; i++)\x0a"
"    wregex\x5bi\x5d = (tre_char_t) ((unsigned char) regex\x5bi\x5d);\x0a"
"\x0a"
"  ret = tre_compile(preg, wregex, n, cflags \x7c REG_USEBYTES);\x0a"
"  xfree(wregex);\x0a"
"#else /* \x21TRE_WCHAR */\x0a"
"  ret = tre_compile(preg, (const tre_char_t *)regex, n, cflags \x7c REG_USEBYTES);\x0a"
"#endif /* \x21TRE_WCHAR */\x0a"
"\x0a"
"  return ret;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regcomp(regex_t *preg, const char *regex, int cflags)\x0a"
"{\x0a"
"  return tre_regncomp(preg, regex, regex \x3f strlen(regex) \x3a 0, cflags);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regcompb(regex_t *preg, const char *regex, int cflags)\x0a"
"{\x0a"
"  int ret;\x0a"
"  tre_char_t *wregex;\x0a"
"  size_t wlen, n = strlen(regex);\x0a"
"  unsigned int i;\x0a"
"  const unsigned char *str = (const unsigned char *)regex;\x0a"
"  tre_char_t *wstr;\x0a"
"\x0a"
"  wregex = xmalloc(sizeof(tre_char_t) * (n + 1));\x0a"
"  if (wregex == NULL) return REG_ESPACE;\x0a"
"  wstr = wregex;\x0a"
"\x0a"
"  for (i = 0; i < n; i++) *(wstr++) = *(str++);\x0a"
"  wlen = n;\x0a"
"  wregex\x5bwlen\x5d = L'\x5c""0';\x0a"
"  ret = tre_compile(preg, wregex, wlen, cflags \x7c REG_USEBYTES);\x0a"
"  xfree(wregex);\x0a"
"  return ret;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#ifdef TRE_WCHAR\x0a"
"int\x0a"
"tre_regwncomp(regex_t *preg, const wchar_t *regex, size_t n, int cflags)\x0a"
"{\x0a"
"  return tre_compile(preg, regex, n, cflags);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regwcomp(regex_t *preg, const wchar_t *regex, int cflags)\x0a"
"{\x0a"
"  return tre_compile(preg, regex, regex \x3f wcslen(regex) \x3a 0, cflags);\x0a"
"}\x0a"
"#endif /* TRE_WCHAR */\x0a"
"\x0a"
"void\x0a"
"tre_regfree(regex_t *preg)\x0a"
"{\x0a"
"  tre_free(preg);\x0a"
"}\x0a"
"\x0a"
"/* EOF */\x0a"
"", 3986 ); }