#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_regerror_c( 
"/*\x0a"
"  tre_regerror.c - POSIX tre_regerror() implementation for TRE.\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"\x0a"
"#include <string.h>\x0a"
"#ifdef HAVE_WCHAR_H\x0a"
"#include <wchar.h>\x0a"
"#endif /* HAVE_WCHAR_H */\x0a"
"#ifdef HAVE_WCTYPE_H\x0a"
"#include <wctype.h>\x0a"
"#endif /* HAVE_WCTYPE_H */\x0a"
"\x0a"
"#include \x22tre-internal.h\x22\x0a"
"#include \x22tre.h\x22\x0a"
"\x0a"
"#ifdef HAVE_GETTEXT\x0a"
"#include <libintl.h>\x0a"
"#else\x0a"
"#define dgettext(p, s) s\x0a"
"#define gettext(s) s\x0a"
"#endif\x0a"
"\x0a"
"#define _(String) dgettext(PACKAGE, String)\x0a"
"#define gettext_noop(String) String\x0a"
"\x0a"
"/* Error message strings for error codes listed in \x60tre.h'.  This list\x0a"
"   needs to be in sync with the codes listed there, naturally. */\x0a"
"static const char *tre_error_messages\x5b\x5d =\x0a"
"  { gettext_noop(\x22No error\x22),\x09\x09\x09\x09 /* REG_OK */\x0a"
"    gettext_noop(\x22No match\x22),\x09\x09\x09\x09 /* REG_NOMATCH */\x0a"
"    gettext_noop(\x22Invalid regexp\x22),\x09\x09\x09 /* REG_BADPAT */\x0a"
"    gettext_noop(\x22Unknown collating element\x22),\x09\x09 /* REG_ECOLLATE */\x0a"
"    gettext_noop(\x22Unknown character class name\x22),\x09 /* REG_ECTYPE */\x0a"
"    gettext_noop(\x22Trailing backslash\x22),\x09\x09\x09 /* REG_EESCAPE */\x0a"
"    gettext_noop(\x22Invalid back reference\x22),\x09\x09 /* REG_ESUBREG */\x0a"
"    gettext_noop(\x22Missing '\x5d'\x22),\x09\x09\x09 /* REG_EBRACK */\x0a"
"    gettext_noop(\x22Missing ')'\x22),\x09\x09\x09 /* REG_EPAREN */\x0a"
"    gettext_noop(\x22Missing '}'\x22),\x09\x09\x09 /* REG_EBRACE */\x0a"
"    gettext_noop(\x22Invalid contents of {}\x22),\x09\x09 /* REG_BADBR */\x0a"
"    gettext_noop(\x22Invalid character range\x22),\x09\x09 /* REG_ERANGE */\x0a"
"    gettext_noop(\x22Out of memory\x22),\x09\x09\x09 /* REG_ESPACE */\x0a"
"    gettext_noop(\x22Invalid use of repetition operators\x22)\x09 /* REG_BADRPT */\x0a"
"  };\x0a"
"\x0a"
"size_t\x0a"
"tre_regerror(int errcode, const regex_t *preg, char *errbuf, size_t errbuf_size)\x0a"
"{\x0a"
"  const char *err;\x0a"
"  size_t err_len;\x0a"
"\x0a"
"  /*LINTED*/(void)\x26preg;\x0a"
"  if (errcode >= 0\x0a"
"      \x26\x26 errcode < (int)(sizeof(tre_error_messages)\x0a"
"\x09\x09\x09 / sizeof(*tre_error_messages)))\x0a"
"    err = gettext(tre_error_messages\x5b""errcode\x5d);\x0a"
"  else\x0a"
"    err = gettext(\x22Unknown error\x22);\x0a"
"\x0a"
"  err_len = strlen(err) + 1;\x0a"
"  if (errbuf_size > 0 \x26\x26 errbuf \x21= NULL)\x0a"
"    {\x0a"
"      if (err_len > errbuf_size)\x0a"
"\x09{\x0a"
"\x09  strncpy(errbuf, err, errbuf_size - 1);\x0a"
"\x09  errbuf\x5b""errbuf_size - 1\x5d = '\x5c""0';\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  strcpy(errbuf, err);\x0a"
"\x09}\x0a"
"    }\x0a"
"  return err_len;\x0a"
"}\x0a"
"\x0a"
"/* EOF */\x0a"
"", 2264 ); }