#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_regexec_c( 
"/*\x0a"
"  tre_regexec.c - TRE POSIX compatible matching functions (and more).\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"\x0a"
"#ifdef TRE_USE_ALLOCA\x0a"
"/* AIX requires this to be the first thing in the file.\x09 */\x0a"
"#ifndef __GNUC__\x0a"
"# if HAVE_ALLOCA_H\x0a"
"#  include <alloca.h>\x0a"
"# else\x0a"
"#  ifdef _AIX\x0a"
" #pragma alloca\x0a"
"#  else\x0a"
"#   ifndef alloca /* predefined by HP cc +Olibcalls */\x0a"
"char *alloca ();\x0a"
"#   endif\x0a"
"#  endif\x0a"
"# endif\x0a"
"#endif\x0a"
"#endif /* TRE_USE_ALLOCA */\x0a"
"\x0a"
"#include <assert.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"#ifdef HAVE_WCHAR_H\x0a"
"#include <wchar.h>\x0a"
"#endif /* HAVE_WCHAR_H */\x0a"
"#ifdef HAVE_WCTYPE_H\x0a"
"#include <wctype.h>\x0a"
"#endif /* HAVE_WCTYPE_H */\x0a"
"#ifndef TRE_WCHAR\x0a"
"#include <ctype.h>\x0a"
"#endif /* \x21TRE_WCHAR */\x0a"
"#ifdef HAVE_MALLOC_H\x0a"
"#include <malloc.h>\x0a"
"#endif /* HAVE_MALLOC_H */\x0a"
"#include <limits.h>\x0a"
"\x0a"
"#include \x22tre-internal.h\x22\x0a"
"#include \x22tre.h\x22\x0a"
"#include \x22xmalloc.h\x22\x0a"
"\x0a"
"\x0a"
"/* Fills the POSIX.2 regmatch_t array according to the TNFA tag and match\x0a"
"   endpoint values. */\x0a"
"void\x0a"
"tre_fill_pmatch(size_t nmatch, regmatch_t pmatch\x5b\x5d, int cflags,\x0a"
"\x09\x09""const tre_tnfa_t *tnfa, int *tags, int match_eo)\x0a"
"{\x0a"
"  tre_submatch_data_t *submatch_data;\x0a"
"  unsigned int i, j;\x0a"
"  int *parents;\x0a"
"\x0a"
"  i = 0;\x0a"
"  if (match_eo >= 0 \x26\x26 \x21(cflags \x26 REG_NOSUB))\x0a"
"    {\x0a"
"      /* Construct submatch offsets from the tags. */\x0a"
"      DPRINT((\x22""end tag = t\x25""d = \x25""d\x5cn\x22, tnfa->end_tag, match_eo));\x0a"
"      submatch_data = tnfa->submatch_data;\x0a"
"      while (i < tnfa->num_submatches \x26\x26 i < nmatch)\x0a"
"\x09{\x0a"
"\x09  if (submatch_data\x5bi\x5d.so_tag == tnfa->end_tag)\x0a"
"\x09    pmatch\x5bi\x5d.rm_so = match_eo;\x0a"
"\x09  else\x0a"
"\x09    pmatch\x5bi\x5d.rm_so = tags\x5bsubmatch_data\x5bi\x5d.so_tag\x5d;\x0a"
"\x0a"
"\x09  if (submatch_data\x5bi\x5d.eo_tag == tnfa->end_tag)\x0a"
"\x09    pmatch\x5bi\x5d.rm_eo = match_eo;\x0a"
"\x09  else\x0a"
"\x09    pmatch\x5bi\x5d.rm_eo = tags\x5bsubmatch_data\x5bi\x5d.eo_tag\x5d;\x0a"
"\x0a"
"\x09  /* If either of the endpoints were not used, this submatch\x0a"
"\x09     was not part of the match. */\x0a"
"\x09  if (pmatch\x5bi\x5d.rm_so == -1 \x7c\x7c pmatch\x5bi\x5d.rm_eo == -1)\x0a"
"\x09    pmatch\x5bi\x5d.rm_so = pmatch\x5bi\x5d.rm_eo = -1;\x0a"
"\x0a"
"\x09  DPRINT((\x22pmatch\x5b\x25""d\x5d = {t\x25""d = \x25""d, t\x25""d = \x25""d}\x5cn\x22, i,\x0a"
"\x09\x09  submatch_data\x5bi\x5d.so_tag, pmatch\x5bi\x5d.rm_so,\x0a"
"\x09\x09  submatch_data\x5bi\x5d.eo_tag, pmatch\x5bi\x5d.rm_eo));\x0a"
"\x09  i++;\x0a"
"\x09}\x0a"
"      /* Reset all submatches that are not within all of their parent\x0a"
"\x09 submatches. */\x0a"
"      i = 0;\x0a"
"      while (i < tnfa->num_submatches \x26\x26 i < nmatch)\x0a"
"\x09{\x0a"
"\x09  if (pmatch\x5bi\x5d.rm_eo == -1)\x0a"
"\x09    assert(pmatch\x5bi\x5d.rm_so == -1);\x0a"
"\x09  assert(pmatch\x5bi\x5d.rm_so <= pmatch\x5bi\x5d.rm_eo);\x0a"
"\x0a"
"\x09  parents = submatch_data\x5bi\x5d.parents;\x0a"
"\x09  if (parents \x21= NULL)\x0a"
"\x09    for (j = 0; parents\x5bj\x5d >= 0; j++)\x0a"
"\x09      {\x0a"
"\x09\x09""DPRINT((\x22pmatch\x5b\x25""d\x5d parent \x25""d\x5cn\x22, i, parents\x5bj\x5d));\x0a"
"\x09\x09if (pmatch\x5bi\x5d.rm_so < pmatch\x5bparents\x5bj\x5d\x5d.rm_so\x0a"
"\x09\x09    \x7c\x7c pmatch\x5bi\x5d.rm_eo > pmatch\x5bparents\x5bj\x5d\x5d.rm_eo)\x0a"
"\x09\x09  pmatch\x5bi\x5d.rm_so = pmatch\x5bi\x5d.rm_eo = -1;\x0a"
"\x09      }\x0a"
"\x09  i++;\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  while (i < nmatch)\x0a"
"    {\x0a"
"      pmatch\x5bi\x5d.rm_so = -1;\x0a"
"      pmatch\x5bi\x5d.rm_eo = -1;\x0a"
"      i++;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/*\x0a"
"  Wrapper functions for POSIX compatible regexp matching.\x0a"
"*/\x0a"
"\x0a"
"int\x0a"
"tre_have_backrefs(const regex_t *preg)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"  return tnfa->have_backrefs;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_have_approx(const regex_t *preg)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"  return tnfa->have_approx;\x0a"
"}\x0a"
"\x0a"
"static int\x0a"
"tre_match(const tre_tnfa_t *tnfa, const void *string, size_t len,\x0a"
"\x09  tre_str_type_t type, size_t nmatch, regmatch_t pmatch\x5b\x5d,\x0a"
"\x09  int eflags)\x0a"
"{\x0a"
"  reg_errcode_t status;\x0a"
"  int *tags = NULL, eo;\x0a"
"  if (tnfa->num_tags > 0 \x26\x26 nmatch > 0)\x0a"
"    {\x0a"
"#ifdef TRE_USE_ALLOCA\x0a"
"      tags = alloca(sizeof(*tags) * tnfa->num_tags);\x0a"
"#else /* \x21TRE_USE_ALLOCA */\x0a"
"      tags = xmalloc(sizeof(*tags) * tnfa->num_tags);\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"      if (tags == NULL)\x0a"
"\x09return REG_ESPACE;\x0a"
"    }\x0a"
"\x0a"
"  /* Dispatch to the appropriate matcher. */\x0a"
"  if (tnfa->have_backrefs \x7c\x7c eflags \x26 REG_BACKTRACKING_MATCHER)\x0a"
"    {\x0a"
"      /* The regex has back references, use the backtracking matcher. */\x0a"
"      if (type == STR_USER)\x0a"
"\x09{\x0a"
"\x09  const tre_str_source *source = string;\x0a"
"\x09  if (source->rewind == NULL \x7c\x7c source->compare == NULL)\x0a"
"\x09    /* The backtracking matcher requires rewind and compare\x0a"
"\x09       capabilities from the input stream. */\x0a"
"\x09    return REG_BADPAT;\x0a"
"\x09}\x0a"
"      status = tre_tnfa_run_backtrack(tnfa, string, (int)len, type,\x0a"
"\x09\x09\x09\x09      tags, eflags, \x26""eo);\x0a"
"    }\x0a"
"#ifdef TRE_APPROX\x0a"
"  else if (tnfa->have_approx \x7c\x7c eflags \x26 REG_APPROX_MATCHER)\x0a"
"    {\x0a"
"      /* The regex uses approximate matching, use the approximate matcher. */\x0a"
"      regamatch_t match;\x0a"
"      regaparams_t params;\x0a"
"      tre_regaparams_default(\x26params);\x0a"
"      params.max_err = 0;\x0a"
"      params.max_cost = 0;\x0a"
"      status = tre_tnfa_run_approx(tnfa, string, (int)len, type, tags,\x0a"
"\x09\x09\x09\x09   \x26match, params, eflags, \x26""eo);\x0a"
"    }\x0a"
"#endif /* TRE_APPROX */\x0a"
"  else\x0a"
"    {\x0a"
"      /* Exact matching, no back references, use the parallel matcher. */\x0a"
"      status = tre_tnfa_run_parallel(tnfa, string, (int)len, type,\x0a"
"\x09\x09\x09\x09     tags, eflags, \x26""eo);\x0a"
"    }\x0a"
"\x0a"
"  if (status == REG_OK)\x0a"
"    /* A match was found, so fill the submatch registers. */\x0a"
"    tre_fill_pmatch(nmatch, pmatch, tnfa->cflags, tnfa, tags, eo);\x0a"
"#ifndef TRE_USE_ALLOCA\x0a"
"  if (tags)\x0a"
"    xfree(tags);\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regnexec(const regex_t *preg, const char *str, size_t len,\x0a"
"\x09 size_t nmatch, regmatch_t pmatch\x5b\x5d, int eflags)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"  tre_str_type_t type = (TRE_MB_CUR_MAX == 1) \x3f STR_BYTE \x3a STR_MBS;\x0a"
"\x0a"
"  return tre_match(tnfa, str, len, type, nmatch, pmatch, eflags);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regexec(const regex_t *preg, const char *str,\x0a"
"\x09size_t nmatch, regmatch_t pmatch\x5b\x5d, int eflags)\x0a"
"{\x0a"
"  return tre_regnexec(preg, str, (unsigned)-1, nmatch, pmatch, eflags);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regexecb(const regex_t *preg, const char *str,\x0a"
"        size_t nmatch, regmatch_t pmatch\x5b\x5d, int eflags)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"\x0a"
"  return tre_match(tnfa, str, (unsigned)-1, STR_BYTE, nmatch, pmatch, eflags);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regnexecb(const regex_t *preg, const char *str, size_t len,\x0a"
"        size_t nmatch, regmatch_t pmatch\x5b\x5d, int eflags)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"\x0a"
"  return tre_match(tnfa, str, len, STR_BYTE, nmatch, pmatch, eflags);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#ifdef TRE_WCHAR\x0a"
"\x0a"
"int\x0a"
"tre_regwnexec(const regex_t *preg, const wchar_t *str, size_t len,\x0a"
"\x09  size_t nmatch, regmatch_t pmatch\x5b\x5d, int eflags)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"  return tre_match(tnfa, str, len, STR_WIDE, nmatch, pmatch, eflags);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regwexec(const regex_t *preg, const wchar_t *str,\x0a"
"\x09 size_t nmatch, regmatch_t pmatch\x5b\x5d, int eflags)\x0a"
"{\x0a"
"  return tre_regwnexec(preg, str, (unsigned)-1, nmatch, pmatch, eflags);\x0a"
"}\x0a"
"\x0a"
"#endif /* TRE_WCHAR */\x0a"
"\x0a"
"int\x0a"
"tre_reguexec(const regex_t *preg, const tre_str_source *str,\x0a"
"\x09 size_t nmatch, regmatch_t pmatch\x5b\x5d, int eflags)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"  return tre_match(tnfa, str, (unsigned)-1, STR_USER, nmatch, pmatch, eflags);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#ifdef TRE_APPROX\x0a"
"\x0a"
"/*\x0a"
"  Wrapper functions for approximate regexp matching.\x0a"
"*/\x0a"
"\x0a"
"static int\x0a"
"tre_match_approx(const tre_tnfa_t *tnfa, const void *string, size_t len,\x0a"
"\x09\x09 tre_str_type_t type, regamatch_t *match, regaparams_t params,\x0a"
"\x09\x09 int eflags)\x0a"
"{\x0a"
"  reg_errcode_t status;\x0a"
"  int *tags = NULL, eo;\x0a"
"\x0a"
"  /* If the regexp does not use approximate matching features, the\x0a"
"     maximum cost is zero, and the approximate matcher isn't forced,\x0a"
"     use the exact matcher instead. */\x0a"
"  if (params.max_cost == 0 \x26\x26 \x21tnfa->have_approx\x0a"
"      \x26\x26 \x21(eflags \x26 REG_APPROX_MATCHER))\x0a"
"    return tre_match(tnfa, string, len, type, match->nmatch, match->pmatch,\x0a"
"\x09\x09     eflags);\x0a"
"\x0a"
"  /* Back references are not supported by the approximate matcher. */\x0a"
"  if (tnfa->have_backrefs)\x0a"
"    return REG_BADPAT;\x0a"
"\x0a"
"  if (tnfa->num_tags > 0 \x26\x26 match->nmatch > 0)\x0a"
"    {\x0a"
"#if TRE_USE_ALLOCA\x0a"
"      tags = alloca(sizeof(*tags) * tnfa->num_tags);\x0a"
"#else /* \x21TRE_USE_ALLOCA */\x0a"
"      tags = xmalloc(sizeof(*tags) * tnfa->num_tags);\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"      if (tags == NULL)\x0a"
"\x09return REG_ESPACE;\x0a"
"    }\x0a"
"  status = tre_tnfa_run_approx(tnfa, string, (int)len, type, tags,\x0a"
"\x09\x09\x09       match, params, eflags, \x26""eo);\x0a"
"  if (status == REG_OK)\x0a"
"    tre_fill_pmatch(match->nmatch, match->pmatch, tnfa->cflags, tnfa, tags, eo);\x0a"
"#ifndef TRE_USE_ALLOCA\x0a"
"  if (tags)\x0a"
"    xfree(tags);\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_reganexec(const regex_t *preg, const char *str, size_t len,\x0a"
"\x09  regamatch_t *match, regaparams_t params, int eflags)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"  tre_str_type_t type = (TRE_MB_CUR_MAX == 1) \x3f STR_BYTE \x3a STR_MBS;\x0a"
"\x0a"
"  return tre_match_approx(tnfa, str, len, type, match, params, eflags);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regaexec(const regex_t *preg, const char *str,\x0a"
"\x09 regamatch_t *match, regaparams_t params, int eflags)\x0a"
"{\x0a"
"  return tre_reganexec(preg, str, (unsigned)-1, match, params, eflags);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regaexecb(const regex_t *preg, const char *str,\x0a"
"          regamatch_t *match, regaparams_t params, int eflags)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"\x0a"
"  return tre_match_approx(tnfa, str, (unsigned)-1, STR_BYTE,\x0a"
"                          match, params, eflags);\x0a"
"}\x0a"
"\x0a"
"#ifdef TRE_WCHAR\x0a"
"\x0a"
"int\x0a"
"tre_regawnexec(const regex_t *preg, const wchar_t *str, size_t len,\x0a"
"\x09   regamatch_t *match, regaparams_t params, int eflags)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"  return tre_match_approx(tnfa, str, len, STR_WIDE,\x0a"
"\x09\x09\x09  match, params, eflags);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_regawexec(const regex_t *preg, const wchar_t *str,\x0a"
"\x09  regamatch_t *match, regaparams_t params, int eflags)\x0a"
"{\x0a"
"  return tre_regawnexec(preg, str, (unsigned)-1, match, params, eflags);\x0a"
"}\x0a"
"\x0a"
"#endif /* TRE_WCHAR */\x0a"
"\x0a"
"void\x0a"
"tre_regaparams_default(regaparams_t *params)\x0a"
"{\x0a"
"  memset(params, 0, sizeof(*params));\x0a"
"  params->cost_ins = 1;\x0a"
"  params->cost_del = 1;\x0a"
"  params->cost_subst = 1;\x0a"
"  params->max_cost = INT_MAX;\x0a"
"  params->max_ins = INT_MAX;\x0a"
"  params->max_del = INT_MAX;\x0a"
"  params->max_subst = INT_MAX;\x0a"
"  params->max_err = INT_MAX;\x0a"
"}\x0a"
"\x0a"
"#endif /* TRE_APPROX */\x0a"
"\x0a"
"/* EOF */\x0a"
"", 9925 ); }