#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_tre_ast_c( 
"/*\x0a"
"  tre-ast.c - Abstract syntax tree (AST) routines\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"#include <assert.h>\x0a"
"\x0a"
"#include \x22tre-ast.h\x22\x0a"
"#include \x22tre-mem.h\x22\x0a"
"\x0a"
"tre_ast_node_t *\x0a"
"tre_ast_new_node(tre_mem_t mem, tre_ast_type_t type, size_t size)\x0a"
"{\x0a"
"  tre_ast_node_t *node;\x0a"
"\x0a"
"  node = tre_mem_calloc(mem, sizeof(*node));\x0a"
"  if (\x21node)\x0a"
"    return NULL;\x0a"
"  node->obj = tre_mem_calloc(mem, size);\x0a"
"  if (\x21node->obj)\x0a"
"    return NULL;\x0a"
"  node->type = type;\x0a"
"  node->nullable = -1;\x0a"
"  node->submatch_id = -1;\x0a"
"\x0a"
"  return node;\x0a"
"}\x0a"
"\x0a"
"tre_ast_node_t *\x0a"
"tre_ast_new_literal(tre_mem_t mem, int code_min, int code_max, int position)\x0a"
"{\x0a"
"  tre_ast_node_t *node;\x0a"
"  tre_literal_t *lit;\x0a"
"\x0a"
"  node = tre_ast_new_node(mem, LITERAL, sizeof(tre_literal_t));\x0a"
"  if (\x21node)\x0a"
"    return NULL;\x0a"
"  lit = node->obj;\x0a"
"  lit->code_min = code_min;\x0a"
"  lit->code_max = code_max;\x0a"
"  lit->position = position;\x0a"
"\x0a"
"  return node;\x0a"
"}\x0a"
"\x0a"
"tre_ast_node_t *\x0a"
"tre_ast_new_iter(tre_mem_t mem, tre_ast_node_t *arg, int min, int max,\x0a"
"\x09\x09 int minimal)\x0a"
"{\x0a"
"  tre_ast_node_t *node;\x0a"
"  tre_iteration_t *iter;\x0a"
"\x0a"
"  node = tre_ast_new_node(mem, ITERATION, sizeof(tre_iteration_t));\x0a"
"  if (\x21node)\x0a"
"    return NULL;\x0a"
"  iter = node->obj;\x0a"
"  iter->arg = arg;\x0a"
"  iter->min = min;\x0a"
"  iter->max = max;\x0a"
"  iter->minimal = minimal;\x0a"
"  node->num_submatches = arg->num_submatches;\x0a"
"\x0a"
"  return node;\x0a"
"}\x0a"
"\x0a"
"tre_ast_node_t *\x0a"
"tre_ast_new_union(tre_mem_t mem, tre_ast_node_t *left, tre_ast_node_t *right)\x0a"
"{\x0a"
"  tre_ast_node_t *node;\x0a"
"\x0a"
"  node = tre_ast_new_node(mem, UNION, sizeof(tre_union_t));\x0a"
"  if (node == NULL)\x0a"
"    return NULL;\x0a"
"  ((tre_union_t *)node->obj)->left = left;\x0a"
"  ((tre_union_t *)node->obj)->right = right;\x0a"
"  node->num_submatches = left->num_submatches + right->num_submatches;\x0a"
"\x0a"
"  return node;\x0a"
"}\x0a"
"\x0a"
"tre_ast_node_t *\x0a"
"tre_ast_new_catenation(tre_mem_t mem, tre_ast_node_t *left,\x0a"
"\x09\x09       tre_ast_node_t *right)\x0a"
"{\x0a"
"  tre_ast_node_t *node;\x0a"
"\x0a"
"  node = tre_ast_new_node(mem, CATENATION, sizeof(tre_catenation_t));\x0a"
"  if (node == NULL)\x0a"
"    return NULL;\x0a"
"  ((tre_catenation_t *)node->obj)->left = left;\x0a"
"  ((tre_catenation_t *)node->obj)->right = right;\x0a"
"  node->num_submatches = left->num_submatches + right->num_submatches;\x0a"
"\x0a"
"  return node;\x0a"
"}\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"\x0a"
"static void\x0a"
"tre_findent(FILE *stream, int i)\x0a"
"{\x0a"
"  while (i-- > 0)\x0a"
"    fputc(' ', stream);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"tre_print_params(int *params)\x0a"
"{\x0a"
"  int i;\x0a"
"  if (params)\x0a"
"    {\x0a"
"      DPRINT((\x22params \x5b\x22));\x0a"
"      for (i = 0; i < TRE_PARAM_LAST; i++)\x0a"
"\x09{\x0a"
"\x09  if (params\x5bi\x5d == TRE_PARAM_UNSET)\x0a"
"\x09    DPRINT((\x22unset\x22));\x0a"
"\x09  else if (params\x5bi\x5d == TRE_PARAM_DEFAULT)\x0a"
"\x09    DPRINT((\x22""default\x22));\x0a"
"\x09  else\x0a"
"\x09    DPRINT((\x22\x25""d\x22, params\x5bi\x5d));\x0a"
"\x09  if (i < TRE_PARAM_LAST - 1)\x0a"
"\x09    DPRINT((\x22, \x22));\x0a"
"\x09}\x0a"
"      DPRINT((\x22\x5d\x22));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"static void\x0a"
"tre_do_print(FILE *stream, tre_ast_node_t *ast, int indent)\x0a"
"{\x0a"
"  int code_min, code_max, pos;\x0a"
"  int num_tags = ast->num_tags;\x0a"
"  tre_literal_t *lit;\x0a"
"  tre_iteration_t *iter;\x0a"
"\x0a"
"  tre_findent(stream, indent);\x0a"
"  switch (ast->type)\x0a"
"    {\x0a"
"    case LITERAL\x3a\x0a"
"      lit = ast->obj;\x0a"
"      code_min = lit->code_min;\x0a"
"      code_max = lit->code_max;\x0a"
"      pos = lit->position;\x0a"
"      if (IS_EMPTY(lit))\x0a"
"\x09{\x0a"
"\x09  fprintf(stream, \x22literal empty\x5cn\x22);\x0a"
"\x09}\x0a"
"      else if (IS_ASSERTION(lit))\x0a"
"\x09{\x0a"
"\x09  int i;\x0a"
"\x09  char *assertions\x5b\x5d = { \x22""bol\x22, \x22""eol\x22, \x22""ctype\x22, \x22\x21""ctype\x22,\x0a"
"\x09\x09\x09\x09 \x22""bow\x22, \x22""eow\x22, \x22wb\x22, \x22\x21wb\x22 };\x0a"
"\x09  if (code_max >= ASSERT_LAST << 1)\x0a"
"\x09    assert(0);\x0a"
"\x09  fprintf(stream, \x22""assertions\x3a \x22);\x0a"
"\x09  for (i = 0; (1 << i) <= ASSERT_LAST; i++)\x0a"
"\x09    if (code_max \x26 (1 << i))\x0a"
"\x09      fprintf(stream, \x22\x25s \x22, assertions\x5bi\x5d);\x0a"
"\x09  fprintf(stream, \x22\x5cn\x22);\x0a"
"\x09}\x0a"
"      else if (IS_TAG(lit))\x0a"
"\x09{\x0a"
"\x09  fprintf(stream, \x22tag \x25""d\x5cn\x22, code_max);\x0a"
"\x09}\x0a"
"      else if (IS_BACKREF(lit))\x0a"
"\x09{\x0a"
"\x09  fprintf(stream, \x22""backref \x25""d, pos \x25""d\x5cn\x22, code_max, pos);\x0a"
"\x09}\x0a"
"      else if (IS_PARAMETER(lit))\x0a"
"\x09{\x0a"
"\x09  tre_print_params(lit->u.params);\x0a"
"\x09  fprintf(stream, \x22\x5cn\x22);\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  fprintf(stream, \x22literal (\x25""c, \x25""c) (\x25""d, \x25""d), pos \x25""d, sub \x25""d, \x22\x0a"
"\x09\x09  \x22\x25""d tags\x5cn\x22, code_min, code_max, code_min, code_max, pos,\x0a"
"\x09\x09  ast->submatch_id, num_tags);\x0a"
"\x09}\x0a"
"      break;\x0a"
"    case ITERATION\x3a\x0a"
"      iter = ast->obj;\x0a"
"      fprintf(stream, \x22iteration {\x25""d, \x25""d}, sub \x25""d, \x25""d tags, \x25s\x5cn\x22,\x0a"
"\x09      iter->min, iter->max, ast->submatch_id, num_tags,\x0a"
"\x09      iter->minimal \x3f \x22minimal\x22 \x3a \x22greedy\x22);\x0a"
"      tre_do_print(stream, iter->arg, indent + 2);\x0a"
"      break;\x0a"
"    case UNION\x3a\x0a"
"      fprintf(stream, \x22union, sub \x25""d, \x25""d tags\x5cn\x22, ast->submatch_id, num_tags);\x0a"
"      tre_do_print(stream, ((tre_union_t *)ast->obj)->left, indent + 2);\x0a"
"      tre_do_print(stream, ((tre_union_t *)ast->obj)->right, indent + 2);\x0a"
"      break;\x0a"
"    case CATENATION\x3a\x0a"
"      fprintf(stream, \x22""catenation, sub \x25""d, \x25""d tags\x5cn\x22, ast->submatch_id,\x0a"
"\x09      num_tags);\x0a"
"      tre_do_print(stream, ((tre_catenation_t *)ast->obj)->left, indent + 2);\x0a"
"      tre_do_print(stream, ((tre_catenation_t *)ast->obj)->right, indent + 2);\x0a"
"      break;\x0a"
"    default\x3a\x0a"
"      assert(0);\x0a"
"      break;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"static void\x0a"
"tre_ast_fprint(FILE *stream, tre_ast_node_t *ast)\x0a"
"{\x0a"
"  tre_do_print(stream, ast, 0);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"tre_ast_print(tre_ast_node_t *tree)\x0a"
"{\x0a"
"  printf(\x22""AST\x3a\x5cn\x22);\x0a"
"  tre_ast_fprint(stdout, tree);\x0a"
"}\x0a"
"\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
"/* EOF */\x0a"
"", 5147 ); }