#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_tre_compile_c( 
"/*\x0a"
"  tre-compile.c - TRE regex compiler\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"/*\x0a"
"  TODO\x3a\x0a"
"   - Fix tre_ast_to_tnfa() to recurse using a stack instead of recursive\x0a"
"     function calls.\x0a"
"*/\x0a"
"\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"#include <stdio.h>\x0a"
"#include <assert.h>\x0a"
"#include <string.h>\x0a"
"\x0a"
"#include \x22tre-internal.h\x22\x0a"
"#include \x22tre-mem.h\x22\x0a"
"#include \x22tre-stack.h\x22\x0a"
"#include \x22tre-ast.h\x22\x0a"
"#include \x22tre-parse.h\x22\x0a"
"#include \x22tre-compile.h\x22\x0a"
"#include \x22tre.h\x22\x0a"
"#include \x22xmalloc.h\x22\x0a"
"\x0a"
"/*\x0a"
"  Algorithms to setup tags so that submatch addressing can be done.\x0a"
"*/\x0a"
"\x0a"
"\x0a"
"/* Inserts a catenation node to the root of the tree given in \x60node'.\x0a"
"   As the left child a new tag with number \x60tag_id' to \x60node' is added,\x0a"
"   and the right child is the old root. */\x0a"
"static reg_errcode_t\x0a"
"tre_add_tag_left(tre_mem_t mem, tre_ast_node_t *node, int tag_id)\x0a"
"{\x0a"
"  tre_catenation_t *c;\x0a"
"\x0a"
"  DPRINT((\x22""add_tag_left\x3a tag \x25""d\x5cn\x22, tag_id));\x0a"
"\x0a"
"  c = tre_mem_alloc(mem, sizeof(*c));\x0a"
"  if (c == NULL)\x0a"
"    return REG_ESPACE;\x0a"
"  c->left = tre_ast_new_literal(mem, TAG, tag_id, -1);\x0a"
"  if (c->left == NULL)\x0a"
"    return REG_ESPACE;\x0a"
"  c->right = tre_mem_alloc(mem, sizeof(tre_ast_node_t));\x0a"
"  if (c->right == NULL)\x0a"
"    return REG_ESPACE;\x0a"
"\x0a"
"  c->right->obj = node->obj;\x0a"
"  c->right->type = node->type;\x0a"
"  c->right->nullable = -1;\x0a"
"  c->right->submatch_id = -1;\x0a"
"  c->right->firstpos = NULL;\x0a"
"  c->right->lastpos = NULL;\x0a"
"  c->right->num_tags = 0;\x0a"
"  node->obj = c;\x0a"
"  node->type = CATENATION;\x0a"
"  return REG_OK;\x0a"
"}\x0a"
"\x0a"
"/* Inserts a catenation node to the root of the tree given in \x60node'.\x0a"
"   As the right child a new tag with number \x60tag_id' to \x60node' is added,\x0a"
"   and the left child is the old root. */\x0a"
"static reg_errcode_t\x0a"
"tre_add_tag_right(tre_mem_t mem, tre_ast_node_t *node, int tag_id)\x0a"
"{\x0a"
"  tre_catenation_t *c;\x0a"
"\x0a"
"  DPRINT((\x22tre_add_tag_right\x3a tag \x25""d\x5cn\x22, tag_id));\x0a"
"\x0a"
"  c = tre_mem_alloc(mem, sizeof(*c));\x0a"
"  if (c == NULL)\x0a"
"    return REG_ESPACE;\x0a"
"  c->right = tre_ast_new_literal(mem, TAG, tag_id, -1);\x0a"
"  if (c->right == NULL)\x0a"
"    return REG_ESPACE;\x0a"
"  c->left = tre_mem_alloc(mem, sizeof(tre_ast_node_t));\x0a"
"  if (c->left == NULL)\x0a"
"    return REG_ESPACE;\x0a"
"\x0a"
"  c->left->obj = node->obj;\x0a"
"  c->left->type = node->type;\x0a"
"  c->left->nullable = -1;\x0a"
"  c->left->submatch_id = -1;\x0a"
"  c->left->firstpos = NULL;\x0a"
"  c->left->lastpos = NULL;\x0a"
"  c->left->num_tags = 0;\x0a"
"  node->obj = c;\x0a"
"  node->type = CATENATION;\x0a"
"  return REG_OK;\x0a"
"}\x0a"
"\x0a"
"typedef enum {\x0a"
"  ADDTAGS_RECURSE,\x0a"
"  ADDTAGS_AFTER_ITERATION,\x0a"
"  ADDTAGS_AFTER_UNION_LEFT,\x0a"
"  ADDTAGS_AFTER_UNION_RIGHT,\x0a"
"  ADDTAGS_AFTER_CAT_LEFT,\x0a"
"  ADDTAGS_AFTER_CAT_RIGHT,\x0a"
"  ADDTAGS_SET_SUBMATCH_END\x0a"
"} tre_addtags_symbol_t;\x0a"
"\x0a"
"\x0a"
"typedef struct {\x0a"
"  int tag;\x0a"
"  int next_tag;\x0a"
"} tre_tag_states_t;\x0a"
"\x0a"
"\x0a"
"/* Go through \x60regset' and set submatch data for submatches that are\x0a"
"   using this tag. */\x0a"
"static void\x0a"
"tre_purge_regset(int *regset, tre_tnfa_t *tnfa, int tag)\x0a"
"{\x0a"
"  int i;\x0a"
"\x0a"
"  for (i = 0; regset\x5bi\x5d >= 0; i++)\x0a"
"    {\x0a"
"      int id = regset\x5bi\x5d / 2;\x0a"
"      int start = \x21(regset\x5bi\x5d \x25 2);\x0a"
"      DPRINT((\x22  Using tag \x25""d for \x25s offset of \x22\x0a"
"\x09      \x22submatch \x25""d\x5cn\x22, tag,\x0a"
"\x09      start \x3f \x22start\x22 \x3a \x22""end\x22, id));\x0a"
"      if (start)\x0a"
"\x09tnfa->submatch_data\x5bid\x5d.so_tag = tag;\x0a"
"      else\x0a"
"\x09tnfa->submatch_data\x5bid\x5d.eo_tag = tag;\x0a"
"    }\x0a"
"  regset\x5b""0\x5d = -1;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* Adds tags to appropriate locations in the parse tree in \x60tree', so that\x0a"
"   subexpressions marked for submatch addressing can be traced. */\x0a"
"static reg_errcode_t\x0a"
"tre_add_tags(tre_mem_t mem, tre_stack_t *stack, tre_ast_node_t *tree,\x0a"
"\x09     tre_tnfa_t *tnfa)\x0a"
"{\x0a"
"  reg_errcode_t status = REG_OK;\x0a"
"  tre_addtags_symbol_t symbol;\x0a"
"  tre_ast_node_t *node = tree; /* Tree node we are currently looking at. */\x0a"
"  int bottom = tre_stack_num_objects(stack);\x0a"
"  /* True for first pass (counting number of needed tags) */\x0a"
"  int first_pass = (mem == NULL \x7c\x7c tnfa == NULL);\x0a"
"  int *regset, *orig_regset;\x0a"
"  int num_tags = 0; /* Total number of tags. */\x0a"
"  int num_minimals = 0;\x09 /* Number of special minimal tags. */\x0a"
"  int tag = 0;\x09    /* The tag that is to be added next. */\x0a"
"  int next_tag = 1; /* Next tag to use after this one. */\x0a"
"  int *parents;\x09    /* Stack of submatches the current submatch is\x0a"
"\x09\x09       contained in. */\x0a"
"  int minimal_tag = -1; /* Tag that marks the beginning of a minimal match. */\x0a"
"  tre_tag_states_t *saved_states;\x0a"
"\x0a"
"  tre_tag_direction_t direction = TRE_TAG_MINIMIZE;\x0a"
"  if (\x21""first_pass)\x0a"
"    {\x0a"
"      tnfa->end_tag = 0;\x0a"
"      tnfa->minimal_tags\x5b""0\x5d = -1;\x0a"
"    }\x0a"
"\x0a"
"  regset = xmalloc(sizeof(*regset) * ((tnfa->num_submatches + 1) * 2));\x0a"
"  if (regset == NULL)\x0a"
"    return REG_ESPACE;\x0a"
"  regset\x5b""0\x5d = -1;\x0a"
"  orig_regset = regset;\x0a"
"\x0a"
"  parents = xmalloc(sizeof(*parents) * (tnfa->num_submatches + 1));\x0a"
"  if (parents == NULL)\x0a"
"    {\x0a"
"      xfree(regset);\x0a"
"      return REG_ESPACE;\x0a"
"    }\x0a"
"  parents\x5b""0\x5d = -1;\x0a"
"\x0a"
"  saved_states = xmalloc(sizeof(*saved_states) * (tnfa->num_submatches + 1));\x0a"
"  if (saved_states == NULL)\x0a"
"    {\x0a"
"      xfree(regset);\x0a"
"      xfree(parents);\x0a"
"      return REG_ESPACE;\x0a"
"    }\x0a"
"  else\x0a"
"    {\x0a"
"      unsigned int i;\x0a"
"      for (i = 0; i <= tnfa->num_submatches; i++)\x0a"
"\x09saved_states\x5bi\x5d.tag = -1;\x0a"
"    }\x0a"
"\x0a"
"  STACK_PUSH(stack, voidptr, node);\x0a"
"  STACK_PUSH(stack, int, ADDTAGS_RECURSE);\x0a"
"\x0a"
"  while (tre_stack_num_objects(stack) > bottom)\x0a"
"    {\x0a"
"      if (status \x21= REG_OK)\x0a"
"\x09""break;\x0a"
"\x0a"
"      symbol = (tre_addtags_symbol_t)tre_stack_pop_int(stack);\x0a"
"      switch (symbol)\x0a"
"\x09{\x0a"
"\x0a"
"\x09""case ADDTAGS_SET_SUBMATCH_END\x3a\x0a"
"\x09  {\x0a"
"\x09    int id = tre_stack_pop_int(stack);\x0a"
"\x09    int i;\x0a"
"\x0a"
"\x09    /* Add end of this submatch to regset. */\x0a"
"\x09    for (i = 0; regset\x5bi\x5d >= 0; i++);\x0a"
"\x09    regset\x5bi\x5d = id * 2 + 1;\x0a"
"\x09    regset\x5bi + 1\x5d = -1;\x0a"
"\x0a"
"\x09    /* Pop this submatch from the parents stack. */\x0a"
"\x09    for (i = 0; parents\x5bi\x5d >= 0; i++);\x0a"
"\x09    parents\x5bi - 1\x5d = -1;\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""case ADDTAGS_RECURSE\x3a\x0a"
"\x09  node = tre_stack_pop_voidptr(stack);\x0a"
"\x0a"
"\x09  if (node->submatch_id >= 0)\x0a"
"\x09    {\x0a"
"\x09      int id = node->submatch_id;\x0a"
"\x09      int i;\x0a"
"\x0a"
"\x0a"
"\x09      /* Add start of this submatch to regset. */\x0a"
"\x09      for (i = 0; regset\x5bi\x5d >= 0; i++);\x0a"
"\x09      regset\x5bi\x5d = id * 2;\x0a"
"\x09      regset\x5bi + 1\x5d = -1;\x0a"
"\x0a"
"\x09      if (\x21""first_pass)\x0a"
"\x09\x09{\x0a"
"\x09\x09  for (i = 0; parents\x5bi\x5d >= 0; i++);\x0a"
"\x09\x09  tnfa->submatch_data\x5bid\x5d.parents = NULL;\x0a"
"\x09\x09  if (i > 0)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      int *p = xmalloc(sizeof(*p) * (i + 1));\x0a"
"\x09\x09      if (p == NULL)\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  status = REG_ESPACE;\x0a"
"\x09\x09\x09  break;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09      assert(tnfa->submatch_data\x5bid\x5d.parents == NULL);\x0a"
"\x09\x09      tnfa->submatch_data\x5bid\x5d.parents = p;\x0a"
"\x09\x09      for (i = 0; parents\x5bi\x5d >= 0; i++)\x0a"
"\x09\x09\x09p\x5bi\x5d = parents\x5bi\x5d;\x0a"
"\x09\x09      p\x5bi\x5d = -1;\x0a"
"\x09\x09    }\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      /* Add end of this submatch to regset after processing this\x0a"
"\x09\x09 node. */\x0a"
"\x09      STACK_PUSHX(stack, int, node->submatch_id);\x0a"
"\x09      STACK_PUSHX(stack, int, ADDTAGS_SET_SUBMATCH_END);\x0a"
"\x09    }\x0a"
"\x0a"
"\x09  switch (node->type)\x0a"
"\x09    {\x0a"
"\x09    case LITERAL\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_literal_t *lit = node->obj;\x0a"
"\x0a"
"\x09\x09if (\x21IS_SPECIAL(lit) \x7c\x7c IS_BACKREF(lit))\x0a"
"\x09\x09  {\x0a"
"\x09\x09    int i;\x0a"
"\x09\x09    DPRINT((\x22Literal \x25""d-\x25""d\x5cn\x22,\x0a"
"\x09\x09\x09    (int)lit->code_min, (int)lit->code_max));\x0a"
"\x09\x09    if (regset\x5b""0\x5d >= 0)\x0a"
"\x09\x09      {\x0a"
"\x09\x09\x09/* Regset is not empty, so add a tag before the\x0a"
"\x09\x09\x09   literal or backref. */\x0a"
"\x09\x09\x09if (\x21""first_pass)\x0a"
"\x09\x09\x09  {\x0a"
"\x09\x09\x09    status = tre_add_tag_left(mem, node, tag);\x0a"
"\x09\x09\x09    tnfa->tag_directions\x5btag\x5d = direction;\x0a"
"\x09\x09\x09    if (minimal_tag >= 0)\x0a"
"\x09\x09\x09      {\x0a"
"\x09\x09\x09\x09""DPRINT((\x22Minimal \x25""d, \x25""d\x5cn\x22, minimal_tag, tag));\x0a"
"\x09\x09\x09\x09""for (i = 0; tnfa->minimal_tags\x5bi\x5d >= 0; i++);\x0a"
"\x09\x09\x09\x09tnfa->minimal_tags\x5bi\x5d = tag;\x0a"
"\x09\x09\x09\x09tnfa->minimal_tags\x5bi + 1\x5d = minimal_tag;\x0a"
"\x09\x09\x09\x09tnfa->minimal_tags\x5bi + 2\x5d = -1;\x0a"
"\x09\x09\x09\x09minimal_tag = -1;\x0a"
"\x09\x09\x09\x09num_minimals++;\x0a"
"\x09\x09\x09      }\x0a"
"\x09\x09\x09    tre_purge_regset(regset, tnfa, tag);\x0a"
"\x09\x09\x09  }\x0a"
"\x09\x09\x09""else\x0a"
"\x09\x09\x09  {\x0a"
"\x09\x09\x09    DPRINT((\x22  num_tags = 1\x5cn\x22));\x0a"
"\x09\x09\x09    node->num_tags = 1;\x0a"
"\x09\x09\x09  }\x0a"
"\x0a"
"\x09\x09\x09""DPRINT((\x22  num_tags++\x5cn\x22));\x0a"
"\x09\x09\x09regset\x5b""0\x5d = -1;\x0a"
"\x09\x09\x09tag = next_tag;\x0a"
"\x09\x09\x09num_tags++;\x0a"
"\x09\x09\x09next_tag++;\x0a"
"\x09\x09      }\x0a"
"\x09\x09  }\x0a"
"\x09\x09""else\x0a"
"\x09\x09  {\x0a"
"\x09\x09    assert(\x21IS_TAG(lit));\x0a"
"\x09\x09  }\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09    case CATENATION\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_catenation_t *cat = node->obj;\x0a"
"\x09\x09tre_ast_node_t *left = cat->left;\x0a"
"\x09\x09tre_ast_node_t *right = cat->right;\x0a"
"\x09\x09int reserved_tag = -1;\x0a"
"\x09\x09""DPRINT((\x22""Catenation, next_tag = \x25""d\x5cn\x22, next_tag));\x0a"
"\x0a"
"\x0a"
"\x09\x09/* After processing right child. */\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, node);\x0a"
"\x09\x09STACK_PUSHX(stack, int, ADDTAGS_AFTER_CAT_RIGHT);\x0a"
"\x0a"
"\x09\x09/* Process right child. */\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, right);\x0a"
"\x09\x09STACK_PUSHX(stack, int, ADDTAGS_RECURSE);\x0a"
"\x0a"
"\x09\x09/* After processing left child. */\x0a"
"\x09\x09STACK_PUSHX(stack, int, next_tag + left->num_tags);\x0a"
"\x09\x09""DPRINT((\x22  Pushing \x25""d for after left\x5cn\x22,\x0a"
"\x09\x09\x09next_tag + left->num_tags));\x0a"
"\x09\x09if (left->num_tags > 0 \x26\x26 right->num_tags > 0)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    /* Reserve the next tag to the right child. */\x0a"
"\x09\x09    DPRINT((\x22  Reserving next_tag \x25""d to right child\x5cn\x22,\x0a"
"\x09\x09\x09    next_tag));\x0a"
"\x09\x09    reserved_tag = next_tag;\x0a"
"\x09\x09    next_tag++;\x0a"
"\x09\x09  }\x0a"
"\x09\x09STACK_PUSHX(stack, int, reserved_tag);\x0a"
"\x09\x09STACK_PUSHX(stack, int, ADDTAGS_AFTER_CAT_LEFT);\x0a"
"\x0a"
"\x09\x09/* Process left child. */\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, left);\x0a"
"\x09\x09STACK_PUSHX(stack, int, ADDTAGS_RECURSE);\x0a"
"\x0a"
"\x09\x09}\x0a"
"\x09      break;\x0a"
"\x09    case ITERATION\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_iteration_t *iter = node->obj;\x0a"
"\x09\x09""DPRINT((\x22Iteration\x5cn\x22));\x0a"
"\x0a"
"\x09\x09if (first_pass)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    STACK_PUSHX(stack, int, regset\x5b""0\x5d >= 0 \x7c\x7c iter->minimal);\x0a"
"\x09\x09  }\x0a"
"\x09\x09""else\x0a"
"\x09\x09  {\x0a"
"\x09\x09    STACK_PUSHX(stack, int, tag);\x0a"
"\x09\x09    STACK_PUSHX(stack, int, iter->minimal);\x0a"
"\x09\x09  }\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, node);\x0a"
"\x09\x09STACK_PUSHX(stack, int, ADDTAGS_AFTER_ITERATION);\x0a"
"\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, iter->arg);\x0a"
"\x09\x09STACK_PUSHX(stack, int, ADDTAGS_RECURSE);\x0a"
"\x0a"
"\x09\x09/* Regset is not empty, so add a tag here. */\x0a"
"\x09\x09if (regset\x5b""0\x5d >= 0 \x7c\x7c iter->minimal)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    if (\x21""first_pass)\x0a"
"\x09\x09      {\x0a"
"\x09\x09\x09int i;\x0a"
"\x09\x09\x09status = tre_add_tag_left(mem, node, tag);\x0a"
"\x09\x09\x09if (iter->minimal)\x0a"
"\x09\x09\x09  tnfa->tag_directions\x5btag\x5d = TRE_TAG_MAXIMIZE;\x0a"
"\x09\x09\x09""else\x0a"
"\x09\x09\x09  tnfa->tag_directions\x5btag\x5d = direction;\x0a"
"\x09\x09\x09if (minimal_tag >= 0)\x0a"
"\x09\x09\x09  {\x0a"
"\x09\x09\x09    DPRINT((\x22Minimal \x25""d, \x25""d\x5cn\x22, minimal_tag, tag));\x0a"
"\x09\x09\x09    for (i = 0; tnfa->minimal_tags\x5bi\x5d >= 0; i++);\x0a"
"\x09\x09\x09    tnfa->minimal_tags\x5bi\x5d = tag;\x0a"
"\x09\x09\x09    tnfa->minimal_tags\x5bi + 1\x5d = minimal_tag;\x0a"
"\x09\x09\x09    tnfa->minimal_tags\x5bi + 2\x5d = -1;\x0a"
"\x09\x09\x09    minimal_tag = -1;\x0a"
"\x09\x09\x09    num_minimals++;\x0a"
"\x09\x09\x09  }\x0a"
"\x09\x09\x09tre_purge_regset(regset, tnfa, tag);\x0a"
"\x09\x09      }\x0a"
"\x0a"
"\x09\x09    DPRINT((\x22  num_tags++\x5cn\x22));\x0a"
"\x09\x09    regset\x5b""0\x5d = -1;\x0a"
"\x09\x09    tag = next_tag;\x0a"
"\x09\x09    num_tags++;\x0a"
"\x09\x09    next_tag++;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""direction = TRE_TAG_MINIMIZE;\x0a"
"\x09      }\x0a"
"\x09      break;\x0a"
"\x09    case UNION\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_union_t *uni = node->obj;\x0a"
"\x09\x09tre_ast_node_t *left = uni->left;\x0a"
"\x09\x09tre_ast_node_t *right = uni->right;\x0a"
"\x09\x09int left_tag;\x0a"
"\x09\x09int right_tag;\x0a"
"\x0a"
"\x09\x09if (regset\x5b""0\x5d >= 0)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    left_tag = next_tag;\x0a"
"\x09\x09    right_tag = next_tag + 1;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""else\x0a"
"\x09\x09  {\x0a"
"\x09\x09    left_tag = tag;\x0a"
"\x09\x09    right_tag = next_tag;\x0a"
"\x09\x09  }\x0a"
"\x0a"
"\x09\x09""DPRINT((\x22Union\x5cn\x22));\x0a"
"\x0a"
"\x09\x09/* After processing right child. */\x0a"
"\x09\x09STACK_PUSHX(stack, int, right_tag);\x0a"
"\x09\x09STACK_PUSHX(stack, int, left_tag);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, regset);\x0a"
"\x09\x09STACK_PUSHX(stack, int, regset\x5b""0\x5d >= 0);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, node);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, right);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, left);\x0a"
"\x09\x09STACK_PUSHX(stack, int, ADDTAGS_AFTER_UNION_RIGHT);\x0a"
"\x0a"
"\x09\x09/* Process right child. */\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, right);\x0a"
"\x09\x09STACK_PUSHX(stack, int, ADDTAGS_RECURSE);\x0a"
"\x0a"
"\x09\x09/* After processing left child. */\x0a"
"\x09\x09STACK_PUSHX(stack, int, ADDTAGS_AFTER_UNION_LEFT);\x0a"
"\x0a"
"\x09\x09/* Process left child. */\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, left);\x0a"
"\x09\x09STACK_PUSHX(stack, int, ADDTAGS_RECURSE);\x0a"
"\x0a"
"\x09\x09/* Regset is not empty, so add a tag here. */\x0a"
"\x09\x09if (regset\x5b""0\x5d >= 0)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    if (\x21""first_pass)\x0a"
"\x09\x09      {\x0a"
"\x09\x09\x09int i;\x0a"
"\x09\x09\x09status = tre_add_tag_left(mem, node, tag);\x0a"
"\x09\x09\x09tnfa->tag_directions\x5btag\x5d = direction;\x0a"
"\x09\x09\x09if (minimal_tag >= 0)\x0a"
"\x09\x09\x09  {\x0a"
"\x09\x09\x09    DPRINT((\x22Minimal \x25""d, \x25""d\x5cn\x22, minimal_tag, tag));\x0a"
"\x09\x09\x09    for (i = 0; tnfa->minimal_tags\x5bi\x5d >= 0; i++);\x0a"
"\x09\x09\x09    tnfa->minimal_tags\x5bi\x5d = tag;\x0a"
"\x09\x09\x09    tnfa->minimal_tags\x5bi + 1\x5d = minimal_tag;\x0a"
"\x09\x09\x09    tnfa->minimal_tags\x5bi + 2\x5d = -1;\x0a"
"\x09\x09\x09    minimal_tag = -1;\x0a"
"\x09\x09\x09    num_minimals++;\x0a"
"\x09\x09\x09  }\x0a"
"\x09\x09\x09tre_purge_regset(regset, tnfa, tag);\x0a"
"\x09\x09      }\x0a"
"\x0a"
"\x09\x09    DPRINT((\x22  num_tags++\x5cn\x22));\x0a"
"\x09\x09    regset\x5b""0\x5d = -1;\x0a"
"\x09\x09    tag = next_tag;\x0a"
"\x09\x09    num_tags++;\x0a"
"\x09\x09    next_tag++;\x0a"
"\x09\x09  }\x0a"
"\x0a"
"\x09\x09if (node->num_submatches > 0)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    /* The next two tags are reserved for markers. */\x0a"
"\x09\x09    next_tag++;\x0a"
"\x09\x09    tag = next_tag;\x0a"
"\x09\x09    next_tag++;\x0a"
"\x09\x09  }\x0a"
"\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09    }\x0a"
"\x0a"
"\x09  if (node->submatch_id >= 0)\x0a"
"\x09    {\x0a"
"\x09      int i;\x0a"
"\x09      /* Push this submatch on the parents stack. */\x0a"
"\x09      for (i = 0; parents\x5bi\x5d >= 0; i++);\x0a"
"\x09      parents\x5bi\x5d = node->submatch_id;\x0a"
"\x09      parents\x5bi + 1\x5d = -1;\x0a"
"\x09    }\x0a"
"\x0a"
"\x09  break; /* end case\x3a ADDTAGS_RECURSE */\x0a"
"\x0a"
"\x09""case ADDTAGS_AFTER_ITERATION\x3a\x0a"
"\x09  {\x0a"
"\x09    int minimal = 0;\x0a"
"\x09    int enter_tag;\x0a"
"\x09    node = tre_stack_pop_voidptr(stack);\x0a"
"\x09    if (first_pass)\x0a"
"\x09      {\x0a"
"\x09\x09node->num_tags = ((tre_iteration_t *)node->obj)->arg->num_tags\x0a"
"\x09\x09  + tre_stack_pop_int(stack);\x0a"
"\x09\x09minimal_tag = -1;\x0a"
"\x09      }\x0a"
"\x09    else\x0a"
"\x09      {\x0a"
"\x09\x09minimal = tre_stack_pop_int(stack);\x0a"
"\x09\x09""enter_tag = tre_stack_pop_int(stack);\x0a"
"\x09\x09if (minimal)\x0a"
"\x09\x09  minimal_tag = enter_tag;\x0a"
"\x09      }\x0a"
"\x0a"
"\x09    DPRINT((\x22""After iteration\x5cn\x22));\x0a"
"\x09    if (\x21""first_pass)\x0a"
"\x09      {\x0a"
"\x09\x09""DPRINT((\x22  Setting direction to \x25s\x5cn\x22,\x0a"
"\x09\x09\x09minimal \x3f \x22minimize\x22 \x3a \x22maximize\x22));\x0a"
"\x09\x09if (minimal)\x0a"
"\x09\x09  direction = TRE_TAG_MINIMIZE;\x0a"
"\x09\x09""else\x0a"
"\x09\x09  direction = TRE_TAG_MAXIMIZE;\x0a"
"\x09      }\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""case ADDTAGS_AFTER_CAT_LEFT\x3a\x0a"
"\x09  {\x0a"
"\x09    int new_tag = tre_stack_pop_int(stack);\x0a"
"\x09    next_tag = tre_stack_pop_int(stack);\x0a"
"\x09    DPRINT((\x22""After cat left, tag = \x25""d, next_tag = \x25""d\x5cn\x22,\x0a"
"\x09\x09    tag, next_tag));\x0a"
"\x09    if (new_tag >= 0)\x0a"
"\x09      {\x0a"
"\x09\x09""DPRINT((\x22  Setting tag to \x25""d\x5cn\x22, new_tag));\x0a"
"\x09\x09tag = new_tag;\x0a"
"\x09      }\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""case ADDTAGS_AFTER_CAT_RIGHT\x3a\x0a"
"\x09  DPRINT((\x22""After cat right\x5cn\x22));\x0a"
"\x09  node = tre_stack_pop_voidptr(stack);\x0a"
"\x09  if (first_pass)\x0a"
"\x09    node->num_tags = ((tre_catenation_t *)node->obj)->left->num_tags\x0a"
"\x09      + ((tre_catenation_t *)node->obj)->right->num_tags;\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case ADDTAGS_AFTER_UNION_LEFT\x3a\x0a"
"\x09  DPRINT((\x22""After union left\x5cn\x22));\x0a"
"\x09  /* Lift the bottom of the \x60regset' array so that when processing\x0a"
"\x09     the right operand the items currently in the array are\x0a"
"\x09     invisible.\x09 The original bottom was saved at ADDTAGS_UNION and\x0a"
"\x09     will be restored at ADDTAGS_AFTER_UNION_RIGHT below. */\x0a"
"\x09  while (*regset >= 0)\x0a"
"\x09    regset++;\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case ADDTAGS_AFTER_UNION_RIGHT\x3a\x0a"
"\x09  {\x0a"
"\x09    int added_tags, tag_left, tag_right;\x0a"
"\x09    tre_ast_node_t *left = tre_stack_pop_voidptr(stack);\x0a"
"\x09    tre_ast_node_t *right = tre_stack_pop_voidptr(stack);\x0a"
"\x09    DPRINT((\x22""After union right\x5cn\x22));\x0a"
"\x09    node = tre_stack_pop_voidptr(stack);\x0a"
"\x09    added_tags = tre_stack_pop_int(stack);\x0a"
"\x09    if (first_pass)\x0a"
"\x09      {\x0a"
"\x09\x09node->num_tags = ((tre_union_t *)node->obj)->left->num_tags\x0a"
"\x09\x09  + ((tre_union_t *)node->obj)->right->num_tags + added_tags\x0a"
"\x09\x09  + ((node->num_submatches > 0) \x3f 2 \x3a 0);\x0a"
"\x09      }\x0a"
"\x09    regset = tre_stack_pop_voidptr(stack);\x0a"
"\x09    tag_left = tre_stack_pop_int(stack);\x0a"
"\x09    tag_right = tre_stack_pop_int(stack);\x0a"
"\x0a"
"\x09    /* Add tags after both children, the left child gets a smaller\x0a"
"\x09       tag than the right child.  This guarantees that we prefer\x0a"
"\x09       the left child over the right child. */\x0a"
"\x09    /* XXX - This is not always necessary (if the children have\x0a"
"\x09       tags which must be seen for every match of that child). */\x0a"
"\x09    /* XXX - Check if this is the only place where tre_add_tag_right\x0a"
"\x09       is used.\x09 If so, use tre_add_tag_left (putting the tag before\x0a"
"\x09       the child as opposed after the child) and throw away\x0a"
"\x09       tre_add_tag_right. */\x0a"
"\x09    if (node->num_submatches > 0)\x0a"
"\x09      {\x0a"
"\x09\x09if (\x21""first_pass)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    status = tre_add_tag_right(mem, left, tag_left);\x0a"
"\x09\x09    tnfa->tag_directions\x5btag_left\x5d = TRE_TAG_MAXIMIZE;\x0a"
"\x09\x09    status = tre_add_tag_right(mem, right, tag_right);\x0a"
"\x09\x09    tnfa->tag_directions\x5btag_right\x5d = TRE_TAG_MAXIMIZE;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""DPRINT((\x22  num_tags += 2\x5cn\x22));\x0a"
"\x09\x09num_tags += 2;\x0a"
"\x09      }\x0a"
"\x09    direction = TRE_TAG_MAXIMIZE;\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""default\x3a\x0a"
"\x09  assert(0);\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09} /* end switch(symbol) */\x0a"
"    } /* end while(tre_stack_num_objects(stack) > bottom) */\x0a"
"\x0a"
"  if (\x21""first_pass)\x0a"
"    tre_purge_regset(regset, tnfa, tag);\x0a"
"\x0a"
"  if (\x21""first_pass \x26\x26 minimal_tag >= 0)\x0a"
"    {\x0a"
"      int i;\x0a"
"      DPRINT((\x22Minimal \x25""d, \x25""d\x5cn\x22, minimal_tag, tag));\x0a"
"      for (i = 0; tnfa->minimal_tags\x5bi\x5d >= 0; i++);\x0a"
"      tnfa->minimal_tags\x5bi\x5d = tag;\x0a"
"      tnfa->minimal_tags\x5bi + 1\x5d = minimal_tag;\x0a"
"      tnfa->minimal_tags\x5bi + 2\x5d = -1;\x0a"
"      minimal_tag = -1;\x0a"
"      num_minimals++;\x0a"
"    }\x0a"
"\x0a"
"  DPRINT((\x22tre_add_tags\x3a \x25s complete.  Number of tags \x25""d.\x5cn\x22,\x0a"
"\x09  first_pass\x3f \x22""First pass\x22 \x3a \x22Second pass\x22, num_tags));\x0a"
"\x0a"
"  assert(tree->num_tags == num_tags);\x0a"
"  tnfa->end_tag = num_tags;\x0a"
"  tnfa->num_tags = num_tags;\x0a"
"  tnfa->num_minimals = num_minimals;\x0a"
"  xfree(orig_regset);\x0a"
"  xfree(parents);\x0a"
"  xfree(saved_states);\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"\x0a"
"/*\x0a"
"  AST to TNFA compilation routines.\x0a"
"*/\x0a"
"\x0a"
"typedef enum {\x0a"
"  COPY_RECURSE,\x0a"
"  COPY_SET_RESULT_PTR\x0a"
"} tre_copyast_symbol_t;\x0a"
"\x0a"
"/* Flags for tre_copy_ast(). */\x0a"
"#define COPY_REMOVE_TAGS\x09 1\x0a"
"#define COPY_MAXIMIZE_FIRST_TAG\x09 2\x0a"
"\x0a"
"static reg_errcode_t\x0a"
"tre_copy_ast(tre_mem_t mem, tre_stack_t *stack, tre_ast_node_t *ast,\x0a"
"\x09     int flags, int *pos_add, tre_tag_direction_t *tag_directions,\x0a"
"\x09     tre_ast_node_t **copy, int *max_pos)\x0a"
"{\x0a"
"  reg_errcode_t status = REG_OK;\x0a"
"  int bottom = tre_stack_num_objects(stack);\x0a"
"  int num_copied = 0;\x0a"
"  int first_tag = 1;\x0a"
"  tre_ast_node_t **result = copy;\x0a"
"  tre_copyast_symbol_t symbol;\x0a"
"\x0a"
"  STACK_PUSH(stack, voidptr, ast);\x0a"
"  STACK_PUSH(stack, int, COPY_RECURSE);\x0a"
"\x0a"
"  while (status == REG_OK \x26\x26 tre_stack_num_objects(stack) > bottom)\x0a"
"    {\x0a"
"      tre_ast_node_t *node;\x0a"
"      if (status \x21= REG_OK)\x0a"
"\x09""break;\x0a"
"\x0a"
"      symbol = (tre_copyast_symbol_t)tre_stack_pop_int(stack);\x0a"
"      switch (symbol)\x0a"
"\x09{\x0a"
"\x09""case COPY_SET_RESULT_PTR\x3a\x0a"
"\x09  result = tre_stack_pop_voidptr(stack);\x0a"
"\x09  break;\x0a"
"\x09""case COPY_RECURSE\x3a\x0a"
"\x09  node = tre_stack_pop_voidptr(stack);\x0a"
"\x09  switch (node->type)\x0a"
"\x09    {\x0a"
"\x09    case LITERAL\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_literal_t *lit = node->obj;\x0a"
"\x09\x09int pos = lit->position;\x0a"
"\x09\x09int min = lit->code_min;\x0a"
"\x09\x09int max = lit->code_max;\x0a"
"\x09\x09if (\x21IS_SPECIAL(lit) \x7c\x7c IS_BACKREF(lit))\x0a"
"\x09\x09  {\x0a"
"\x09\x09    /* XXX - e.g. \x5b""ab\x5d has only one position but two\x0a"
"\x09\x09       nodes, so we are creating holes in the state space\x0a"
"\x09\x09       here.  Not fatal, just wastes memory. */\x0a"
"\x09\x09    pos += *pos_add;\x0a"
"\x09\x09    num_copied++;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""else if (IS_TAG(lit) \x26\x26 (flags \x26 COPY_REMOVE_TAGS))\x0a"
"\x09\x09  {\x0a"
"\x09\x09    /* Change this tag to empty. */\x0a"
"\x09\x09    min = EMPTY;\x0a"
"\x09\x09    max = pos = -1;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""else if (IS_TAG(lit) \x26\x26 (flags \x26 COPY_MAXIMIZE_FIRST_TAG)\x0a"
"\x09\x09\x09 \x26\x26 first_tag)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    /* Maximize the first tag. */\x0a"
"\x09\x09    tag_directions\x5bmax\x5d = TRE_TAG_MAXIMIZE;\x0a"
"\x09\x09    first_tag = 0;\x0a"
"\x09\x09  }\x0a"
"\x09\x09*result = tre_ast_new_literal(mem, min, max, pos);\x0a"
"\x09\x09if (*result == NULL)\x0a"
"\x09\x09  status = REG_ESPACE;\x0a"
"\x0a"
"\x09\x09if (pos > *max_pos)\x0a"
"\x09\x09  *max_pos = pos;\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09    case UNION\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_union_t *uni = node->obj;\x0a"
"\x09\x09tre_union_t *tmp;\x0a"
"\x09\x09*result = tre_ast_new_union(mem, uni->left, uni->right);\x0a"
"\x09\x09if (*result == NULL)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    status = REG_ESPACE;\x0a"
"\x09\x09    break;\x0a"
"\x09\x09  }\x0a"
"\x09\x09tmp = (*result)->obj;\x0a"
"\x09\x09result = \x26tmp->left;\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, uni->right);\x0a"
"\x09\x09STACK_PUSHX(stack, int, COPY_RECURSE);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, \x26tmp->right);\x0a"
"\x09\x09STACK_PUSHX(stack, int, COPY_SET_RESULT_PTR);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, uni->left);\x0a"
"\x09\x09STACK_PUSHX(stack, int, COPY_RECURSE);\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09    case CATENATION\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_catenation_t *cat = node->obj;\x0a"
"\x09\x09tre_catenation_t *tmp;\x0a"
"\x09\x09*result = tre_ast_new_catenation(mem, cat->left, cat->right);\x0a"
"\x09\x09if (*result == NULL)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    status = REG_ESPACE;\x0a"
"\x09\x09    break;\x0a"
"\x09\x09  }\x0a"
"\x09\x09tmp = (*result)->obj;\x0a"
"\x09\x09tmp->left = NULL;\x0a"
"\x09\x09tmp->right = NULL;\x0a"
"\x09\x09result = \x26tmp->left;\x0a"
"\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, cat->right);\x0a"
"\x09\x09STACK_PUSHX(stack, int, COPY_RECURSE);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, \x26tmp->right);\x0a"
"\x09\x09STACK_PUSHX(stack, int, COPY_SET_RESULT_PTR);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, cat->left);\x0a"
"\x09\x09STACK_PUSHX(stack, int, COPY_RECURSE);\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09    case ITERATION\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_iteration_t *iter = node->obj;\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, iter->arg);\x0a"
"\x09\x09STACK_PUSHX(stack, int, COPY_RECURSE);\x0a"
"\x09\x09*result = tre_ast_new_iter(mem, iter->arg, iter->min,\x0a"
"\x09\x09\x09\x09\x09   iter->max, iter->minimal);\x0a"
"\x09\x09if (*result == NULL)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    status = REG_ESPACE;\x0a"
"\x09\x09    break;\x0a"
"\x09\x09  }\x0a"
"\x09\x09iter = (*result)->obj;\x0a"
"\x09\x09result = \x26iter->arg;\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09    default\x3a\x0a"
"\x09      assert(0);\x0a"
"\x09      break;\x0a"
"\x09    }\x0a"
"\x09  break;\x0a"
"\x09}\x0a"
"    }\x0a"
"  *pos_add += num_copied;\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"typedef enum {\x0a"
"  EXPAND_RECURSE,\x0a"
"  EXPAND_AFTER_ITER\x0a"
"} tre_expand_ast_symbol_t;\x0a"
"\x0a"
"/* Expands each iteration node that has a finite nonzero minimum or maximum\x0a"
"   iteration count to a catenated sequence of copies of the node. */\x0a"
"static reg_errcode_t\x0a"
"tre_expand_ast(tre_mem_t mem, tre_stack_t *stack, tre_ast_node_t *ast,\x0a"
"\x09       int *position, tre_tag_direction_t *tag_directions,\x0a"
"\x09       int *max_depth)\x0a"
"{\x0a"
"  reg_errcode_t status = REG_OK;\x0a"
"  int bottom = tre_stack_num_objects(stack);\x0a"
"  int pos_add = 0;\x0a"
"  int pos_add_total = 0;\x0a"
"  int max_pos = 0;\x0a"
"  /* Current approximate matching parameters. */\x0a"
"  int params\x5bTRE_PARAM_LAST\x5d;\x0a"
"  /* Approximate parameter nesting level. */\x0a"
"  int params_depth = 0;\x0a"
"  int iter_depth = 0;\x0a"
"  int i;\x0a"
"\x0a"
"  for (i = 0; i < TRE_PARAM_LAST; i++)\x0a"
"    params\x5bi\x5d = TRE_PARAM_DEFAULT;\x0a"
"\x0a"
"  STACK_PUSHR(stack, voidptr, ast);\x0a"
"  STACK_PUSHR(stack, int, EXPAND_RECURSE);\x0a"
"  while (status == REG_OK \x26\x26 tre_stack_num_objects(stack) > bottom)\x0a"
"    {\x0a"
"      tre_ast_node_t *node;\x0a"
"      tre_expand_ast_symbol_t symbol;\x0a"
"\x0a"
"      if (status \x21= REG_OK)\x0a"
"\x09""break;\x0a"
"\x0a"
"      DPRINT((\x22pos_add \x25""d\x5cn\x22, pos_add));\x0a"
"\x0a"
"      symbol = (tre_expand_ast_symbol_t)tre_stack_pop_int(stack);\x0a"
"      node = tre_stack_pop_voidptr(stack);\x0a"
"      switch (symbol)\x0a"
"\x09{\x0a"
"\x09""case EXPAND_RECURSE\x3a\x0a"
"\x09  switch (node->type)\x0a"
"\x09    {\x0a"
"\x09    case LITERAL\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_literal_t *lit= node->obj;\x0a"
"\x09\x09if (\x21IS_SPECIAL(lit) \x7c\x7c IS_BACKREF(lit))\x0a"
"\x09\x09  {\x0a"
"\x09\x09    lit->position += pos_add;\x0a"
"\x09\x09    if (lit->position > max_pos)\x0a"
"\x09\x09      max_pos = lit->position;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09    case UNION\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_union_t *uni = node->obj;\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, uni->right);\x0a"
"\x09\x09STACK_PUSHX(stack, int, EXPAND_RECURSE);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, uni->left);\x0a"
"\x09\x09STACK_PUSHX(stack, int, EXPAND_RECURSE);\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09    case CATENATION\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_catenation_t *cat = node->obj;\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, cat->right);\x0a"
"\x09\x09STACK_PUSHX(stack, int, EXPAND_RECURSE);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, cat->left);\x0a"
"\x09\x09STACK_PUSHX(stack, int, EXPAND_RECURSE);\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09    case ITERATION\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_iteration_t *iter = node->obj;\x0a"
"\x09\x09STACK_PUSHX(stack, int, pos_add);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, node);\x0a"
"\x09\x09STACK_PUSHX(stack, int, EXPAND_AFTER_ITER);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, iter->arg);\x0a"
"\x09\x09STACK_PUSHX(stack, int, EXPAND_RECURSE);\x0a"
"\x09\x09/* If we are going to expand this node at EXPAND_AFTER_ITER\x0a"
"\x09\x09   then don't increase the \x60pos' fields of the nodes now, it\x0a"
"\x09\x09   will get done when expanding. */\x0a"
"\x09\x09if (iter->min > 1 \x7c\x7c iter->max > 1)\x0a"
"\x09\x09  pos_add = 0;\x0a"
"\x09\x09iter_depth++;\x0a"
"\x09\x09""DPRINT((\x22iter\x5cn\x22));\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09    default\x3a\x0a"
"\x09      assert(0);\x0a"
"\x09      break;\x0a"
"\x09    }\x0a"
"\x09  break;\x0a"
"\x09""case EXPAND_AFTER_ITER\x3a\x0a"
"\x09  {\x0a"
"\x09    tre_iteration_t *iter = node->obj;\x0a"
"\x09    int pos_add_last;\x0a"
"\x09    pos_add = tre_stack_pop_int(stack);\x0a"
"\x09    pos_add_last = pos_add;\x0a"
"\x09    if (iter->min > 1 \x7c\x7c iter->max > 1)\x0a"
"\x09      {\x0a"
"\x09\x09tre_ast_node_t *seq1 = NULL, *seq2 = NULL;\x0a"
"\x09\x09int j;\x0a"
"\x09\x09int pos_add_save = pos_add;\x0a"
"\x0a"
"\x09\x09/* Create a catenated sequence of copies of the node. */\x0a"
"\x09\x09""for (j = 0; j < iter->min; j++)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    tre_ast_node_t *copy;\x0a"
"\x09\x09    /* Remove tags from all but the last copy. */\x0a"
"\x09\x09    int flags = ((j + 1 < iter->min)\x0a"
"\x09\x09\x09\x09 \x3f COPY_REMOVE_TAGS\x0a"
"\x09\x09\x09\x09 \x3a COPY_MAXIMIZE_FIRST_TAG);\x0a"
"\x09\x09    DPRINT((\x22  pos_add \x25""d\x5cn\x22, pos_add));\x0a"
"\x09\x09    pos_add_save = pos_add;\x0a"
"\x09\x09    status = tre_copy_ast(mem, stack, iter->arg, flags,\x0a"
"\x09\x09\x09\x09\x09  \x26pos_add, tag_directions, \x26""copy,\x0a"
"\x09\x09\x09\x09\x09  \x26max_pos);\x0a"
"\x09\x09    if (status \x21= REG_OK)\x0a"
"\x09\x09      return status;\x0a"
"\x09\x09    if (seq1 \x21= NULL)\x0a"
"\x09\x09      seq1 = tre_ast_new_catenation(mem, seq1, copy);\x0a"
"\x09\x09    else\x0a"
"\x09\x09      seq1 = copy;\x0a"
"\x09\x09    if (seq1 == NULL)\x0a"
"\x09\x09      return REG_ESPACE;\x0a"
"\x09\x09  }\x0a"
"\x0a"
"\x09\x09if (iter->max == -1)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    /* No upper limit. */\x0a"
"\x09\x09    pos_add_save = pos_add;\x0a"
"\x09\x09    status = tre_copy_ast(mem, stack, iter->arg, 0,\x0a"
"\x09\x09\x09\x09\x09  \x26pos_add, NULL, \x26seq2, \x26max_pos);\x0a"
"\x09\x09    if (status \x21= REG_OK)\x0a"
"\x09\x09      return status;\x0a"
"\x09\x09    seq2 = tre_ast_new_iter(mem, seq2, 0, -1, 0);\x0a"
"\x09\x09    if (seq2 == NULL)\x0a"
"\x09\x09      return REG_ESPACE;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""else\x0a"
"\x09\x09  {\x0a"
"\x09\x09    for (j = iter->min; j < iter->max; j++)\x0a"
"\x09\x09      {\x0a"
"\x09\x09\x09tre_ast_node_t *tmp, *copy;\x0a"
"\x09\x09\x09pos_add_save = pos_add;\x0a"
"\x09\x09\x09status = tre_copy_ast(mem, stack, iter->arg, 0,\x0a"
"\x09\x09\x09\x09\x09      \x26pos_add, NULL, \x26""copy, \x26max_pos);\x0a"
"\x09\x09\x09if (status \x21= REG_OK)\x0a"
"\x09\x09\x09  return status;\x0a"
"\x09\x09\x09if (seq2 \x21= NULL)\x0a"
"\x09\x09\x09  seq2 = tre_ast_new_catenation(mem, copy, seq2);\x0a"
"\x09\x09\x09""else\x0a"
"\x09\x09\x09  seq2 = copy;\x0a"
"\x09\x09\x09if (seq2 == NULL)\x0a"
"\x09\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09\x09tmp = tre_ast_new_literal(mem, EMPTY, -1, -1);\x0a"
"\x09\x09\x09if (tmp == NULL)\x0a"
"\x09\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09\x09seq2 = tre_ast_new_union(mem, tmp, seq2);\x0a"
"\x09\x09\x09if (seq2 == NULL)\x0a"
"\x09\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09      }\x0a"
"\x09\x09  }\x0a"
"\x0a"
"\x09\x09pos_add = pos_add_save;\x0a"
"\x09\x09if (seq1 == NULL)\x0a"
"\x09\x09  seq1 = seq2;\x0a"
"\x09\x09""else if (seq2 \x21= NULL)\x0a"
"\x09\x09  seq1 = tre_ast_new_catenation(mem, seq1, seq2);\x0a"
"\x09\x09if (seq1 == NULL)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09node->obj = seq1->obj;\x0a"
"\x09\x09node->type = seq1->type;\x0a"
"\x09      }\x0a"
"\x0a"
"\x09    iter_depth--;\x0a"
"\x09    pos_add_total += pos_add - pos_add_last;\x0a"
"\x09    if (iter_depth == 0)\x0a"
"\x09      pos_add = pos_add_total;\x0a"
"\x0a"
"\x09    /* If approximate parameters are specified, surround the result\x0a"
"\x09       with two parameter setting nodes.  The one on the left sets\x0a"
"\x09       the specified parameters, and the one on the right restores\x0a"
"\x09       the old parameters. */\x0a"
"\x09    if (iter->params)\x0a"
"\x09      {\x0a"
"\x09\x09tre_ast_node_t *tmp_l, *tmp_r, *tmp_node, *node_copy;\x0a"
"\x09\x09int *old_params;\x0a"
"\x0a"
"\x09\x09tmp_l = tre_ast_new_literal(mem, PARAMETER, 0, -1);\x0a"
"\x09\x09if (\x21tmp_l)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09((tre_literal_t *)tmp_l->obj)->u.params = iter->params;\x0a"
"\x09\x09iter->params\x5bTRE_PARAM_DEPTH\x5d = params_depth + 1;\x0a"
"\x09\x09tmp_r = tre_ast_new_literal(mem, PARAMETER, 0, -1);\x0a"
"\x09\x09if (\x21tmp_r)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09old_params = tre_mem_alloc(mem, sizeof(*old_params)\x0a"
"\x09\x09\x09\x09\x09   * TRE_PARAM_LAST);\x0a"
"\x09\x09if (\x21old_params)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09""for (i = 0; i < TRE_PARAM_LAST; i++)\x0a"
"\x09\x09  old_params\x5bi\x5d = params\x5bi\x5d;\x0a"
"\x09\x09((tre_literal_t *)tmp_r->obj)->u.params = old_params;\x0a"
"\x09\x09old_params\x5bTRE_PARAM_DEPTH\x5d = params_depth;\x0a"
"\x09\x09/* XXX - this is the only place where ast_new_node is\x0a"
"\x09\x09   needed -- should be moved inside AST module. */\x0a"
"\x09\x09node_copy = tre_ast_new_node(mem, ITERATION,\x0a"
"\x09\x09\x09\x09\x09     sizeof(tre_iteration_t));\x0a"
"\x09\x09if (\x21node_copy)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09node_copy->obj = node->obj;\x0a"
"\x09\x09tmp_node = tre_ast_new_catenation(mem, tmp_l, node_copy);\x0a"
"\x09\x09if (\x21tmp_node)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09tmp_node = tre_ast_new_catenation(mem, tmp_node, tmp_r);\x0a"
"\x09\x09if (\x21tmp_node)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09/* Replace the contents of \x60node' with \x60tmp_node'. */\x0a"
"\x09\x09memcpy(node, tmp_node, sizeof(*node));\x0a"
"\x09\x09node->obj = tmp_node->obj;\x0a"
"\x09\x09node->type = tmp_node->type;\x0a"
"\x09\x09params_depth++;\x0a"
"\x09\x09if (params_depth > *max_depth)\x0a"
"\x09\x09  *max_depth = params_depth;\x0a"
"\x09      }\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x09""default\x3a\x0a"
"\x09  assert(0);\x0a"
"\x09  break;\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  *position += pos_add_total;\x0a"
"\x0a"
"  /* \x60max_pos' should never be larger than \x60*position' if the above\x0a"
"     code works, but just an extra safeguard let's make sure\x0a"
"     \x60*position' is set large enough so enough memory will be\x0a"
"     allocated for the transition table. */\x0a"
"  if (max_pos > *position)\x0a"
"    *position = max_pos;\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"  DPRINT((\x22""Expanded AST\x3a\x5cn\x22));\x0a"
"  tre_ast_print(ast);\x0a"
"  DPRINT((\x22*position \x25""d, max_pos \x25""d\x5cn\x22, *position, max_pos));\x0a"
"#endif\x0a"
"\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"static tre_pos_and_tags_t *\x0a"
"tre_set_empty(tre_mem_t mem)\x0a"
"{\x0a"
"  tre_pos_and_tags_t *new_set;\x0a"
"\x0a"
"  new_set = tre_mem_calloc(mem, sizeof(*new_set));\x0a"
"  if (new_set == NULL)\x0a"
"    return NULL;\x0a"
"\x0a"
"  new_set\x5b""0\x5d.position = -1;\x0a"
"  new_set\x5b""0\x5d.code_min = -1;\x0a"
"  new_set\x5b""0\x5d.code_max = -1;\x0a"
"\x0a"
"  return new_set;\x0a"
"}\x0a"
"\x0a"
"static tre_pos_and_tags_t *\x0a"
"tre_set_one(tre_mem_t mem, int position, int code_min, int code_max,\x0a"
"\x09    tre_ctype_t class, tre_ctype_t *neg_classes, int backref)\x0a"
"{\x0a"
"  tre_pos_and_tags_t *new_set;\x0a"
"\x0a"
"  new_set = tre_mem_calloc(mem, sizeof(*new_set) * 2);\x0a"
"  if (new_set == NULL)\x0a"
"    return NULL;\x0a"
"\x0a"
"  new_set\x5b""0\x5d.position = position;\x0a"
"  new_set\x5b""0\x5d.code_min = code_min;\x0a"
"  new_set\x5b""0\x5d.code_max = code_max;\x0a"
"  new_set\x5b""0\x5d.class = class;\x0a"
"  new_set\x5b""0\x5d.neg_classes = neg_classes;\x0a"
"  new_set\x5b""0\x5d.backref = backref;\x0a"
"  new_set\x5b""1\x5d.position = -1;\x0a"
"  new_set\x5b""1\x5d.code_min = -1;\x0a"
"  new_set\x5b""1\x5d.code_max = -1;\x0a"
"\x0a"
"  return new_set;\x0a"
"}\x0a"
"\x0a"
"static tre_pos_and_tags_t *\x0a"
"tre_set_union(tre_mem_t mem, tre_pos_and_tags_t *set1, tre_pos_and_tags_t *set2,\x0a"
"\x09      int *tags, int assertions, int *params)\x0a"
"{\x0a"
"  int s1, s2, i, j;\x0a"
"  tre_pos_and_tags_t *new_set;\x0a"
"  int *new_tags;\x0a"
"  int num_tags;\x0a"
"\x0a"
"  for (num_tags = 0; tags \x21= NULL \x26\x26 tags\x5bnum_tags\x5d >= 0; num_tags++);\x0a"
"  for (s1 = 0; set1\x5bs1\x5d.position >= 0; s1++);\x0a"
"  for (s2 = 0; set2\x5bs2\x5d.position >= 0; s2++);\x0a"
"  new_set = tre_mem_calloc(mem, sizeof(*new_set) * (s1 + s2 + 1));\x0a"
"  if (\x21new_set )\x0a"
"    return NULL;\x0a"
"\x0a"
"  for (s1 = 0; set1\x5bs1\x5d.position >= 0; s1++)\x0a"
"    {\x0a"
"      new_set\x5bs1\x5d.position = set1\x5bs1\x5d.position;\x0a"
"      new_set\x5bs1\x5d.code_min = set1\x5bs1\x5d.code_min;\x0a"
"      new_set\x5bs1\x5d.code_max = set1\x5bs1\x5d.code_max;\x0a"
"      new_set\x5bs1\x5d.assertions = set1\x5bs1\x5d.assertions \x7c assertions;\x0a"
"      new_set\x5bs1\x5d.class = set1\x5bs1\x5d.class;\x0a"
"      new_set\x5bs1\x5d.neg_classes = set1\x5bs1\x5d.neg_classes;\x0a"
"      new_set\x5bs1\x5d.backref = set1\x5bs1\x5d.backref;\x0a"
"      if (set1\x5bs1\x5d.tags == NULL \x26\x26 tags == NULL)\x0a"
"\x09new_set\x5bs1\x5d.tags = NULL;\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  for (i = 0; set1\x5bs1\x5d.tags \x21= NULL \x26\x26 set1\x5bs1\x5d.tags\x5bi\x5d >= 0; i++);\x0a"
"\x09  new_tags = tre_mem_alloc(mem, (sizeof(*new_tags)\x0a"
"\x09\x09\x09\x09\x09 * (i + num_tags + 1)));\x0a"
"\x09  if (new_tags == NULL)\x0a"
"\x09    return NULL;\x0a"
"\x09  for (j = 0; j < i; j++)\x0a"
"\x09    new_tags\x5bj\x5d = set1\x5bs1\x5d.tags\x5bj\x5d;\x0a"
"\x09  for (i = 0; i < num_tags; i++)\x0a"
"\x09    new_tags\x5bj + i\x5d = tags\x5bi\x5d;\x0a"
"\x09  new_tags\x5bj + i\x5d = -1;\x0a"
"\x09  new_set\x5bs1\x5d.tags = new_tags;\x0a"
"\x09}\x0a"
"      if (set1\x5bs1\x5d.params)\x0a"
"\x09new_set\x5bs1\x5d.params = set1\x5bs1\x5d.params;\x0a"
"      if (params)\x0a"
"\x09{\x0a"
"\x09  if (\x21new_set\x5bs1\x5d.params)\x0a"
"\x09    new_set\x5bs1\x5d.params = params;\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      new_set\x5bs1\x5d.params = tre_mem_alloc(mem, sizeof(*params) *\x0a"
"\x09\x09\x09\x09\x09\x09 TRE_PARAM_LAST);\x0a"
"\x09      if (\x21new_set\x5bs1\x5d.params)\x0a"
"\x09\x09return NULL;\x0a"
"\x09      for (i = 0; i < TRE_PARAM_LAST; i++)\x0a"
"\x09\x09if (params\x5bi\x5d \x21= TRE_PARAM_UNSET)\x0a"
"\x09\x09  new_set\x5bs1\x5d.params\x5bi\x5d = params\x5bi\x5d;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  for (s2 = 0; set2\x5bs2\x5d.position >= 0; s2++)\x0a"
"    {\x0a"
"      new_set\x5bs1 + s2\x5d.position = set2\x5bs2\x5d.position;\x0a"
"      new_set\x5bs1 + s2\x5d.code_min = set2\x5bs2\x5d.code_min;\x0a"
"      new_set\x5bs1 + s2\x5d.code_max = set2\x5bs2\x5d.code_max;\x0a"
"      /* XXX - why not \x7c assertions here as well\x3f */\x0a"
"      new_set\x5bs1 + s2\x5d.assertions = set2\x5bs2\x5d.assertions;\x0a"
"      new_set\x5bs1 + s2\x5d.class = set2\x5bs2\x5d.class;\x0a"
"      new_set\x5bs1 + s2\x5d.neg_classes = set2\x5bs2\x5d.neg_classes;\x0a"
"      new_set\x5bs1 + s2\x5d.backref = set2\x5bs2\x5d.backref;\x0a"
"      if (set2\x5bs2\x5d.tags == NULL)\x0a"
"\x09new_set\x5bs1 + s2\x5d.tags = NULL;\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  for (i = 0; set2\x5bs2\x5d.tags\x5bi\x5d >= 0; i++);\x0a"
"\x09  new_tags = tre_mem_alloc(mem, sizeof(*new_tags) * (i + 1));\x0a"
"\x09  if (new_tags == NULL)\x0a"
"\x09    return NULL;\x0a"
"\x09  for (j = 0; j < i; j++)\x0a"
"\x09    new_tags\x5bj\x5d = set2\x5bs2\x5d.tags\x5bj\x5d;\x0a"
"\x09  new_tags\x5bj\x5d = -1;\x0a"
"\x09  new_set\x5bs1 + s2\x5d.tags = new_tags;\x0a"
"\x09}\x0a"
"      if (set2\x5bs2\x5d.params)\x0a"
"\x09new_set\x5bs1 + s2\x5d.params = set2\x5bs2\x5d.params;\x0a"
"      if (params)\x0a"
"\x09{\x0a"
"\x09  if (\x21new_set\x5bs1 + s2\x5d.params)\x0a"
"\x09    new_set\x5bs1 + s2\x5d.params = params;\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      new_set\x5bs1 + s2\x5d.params = tre_mem_alloc(mem, sizeof(*params) *\x0a"
"\x09\x09\x09\x09\x09\x09      TRE_PARAM_LAST);\x0a"
"\x09      if (\x21new_set\x5bs1 + s2\x5d.params)\x0a"
"\x09\x09return NULL;\x0a"
"\x09      for (i = 0; i < TRE_PARAM_LAST; i++)\x0a"
"\x09\x09if (params\x5bi\x5d \x21= TRE_PARAM_UNSET)\x0a"
"\x09\x09  new_set\x5bs1 + s2\x5d.params\x5bi\x5d = params\x5bi\x5d;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    }\x0a"
"  new_set\x5bs1 + s2\x5d.position = -1;\x0a"
"  return new_set;\x0a"
"}\x0a"
"\x0a"
"/* Finds the empty path through \x60node' which is the one that should be\x0a"
"   taken according to POSIX.2 rules, and adds the tags on that path to\x0a"
"   \x60tags'.   \x60tags' may be NULL.  If \x60num_tags_seen' is not NULL, it is\x0a"
"   set to the number of tags seen on the path. */\x0a"
"static reg_errcode_t\x0a"
"tre_match_empty(tre_stack_t *stack, tre_ast_node_t *node, int *tags,\x0a"
"\x09\x09int *assertions, int *params, int *num_tags_seen,\x0a"
"\x09\x09int *params_seen)\x0a"
"{\x0a"
"  tre_literal_t *lit;\x0a"
"  tre_union_t *uni;\x0a"
"  tre_catenation_t *cat;\x0a"
"  tre_iteration_t *iter;\x0a"
"  int i;\x0a"
"  int bottom = tre_stack_num_objects(stack);\x0a"
"  reg_errcode_t status = REG_OK;\x0a"
"  if (num_tags_seen)\x0a"
"    *num_tags_seen = 0;\x0a"
"  if (params_seen)\x0a"
"    *params_seen = 0;\x0a"
"\x0a"
"  status = tre_stack_push_voidptr(stack, node);\x0a"
"\x0a"
"  /* Walk through the tree recursively. */\x0a"
"  while (status == REG_OK \x26\x26 tre_stack_num_objects(stack) > bottom)\x0a"
"    {\x0a"
"      node = tre_stack_pop_voidptr(stack);\x0a"
"\x0a"
"      switch (node->type)\x0a"
"\x09{\x0a"
"\x09""case LITERAL\x3a\x0a"
"\x09  lit = (tre_literal_t *)node->obj;\x0a"
"\x09  switch (lit->code_min)\x0a"
"\x09    {\x0a"
"\x09    case TAG\x3a\x0a"
"\x09      if (lit->code_max >= 0)\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (tags \x21= NULL)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      /* Add the tag to \x60tags'. */\x0a"
"\x09\x09      for (i = 0; tags\x5bi\x5d >= 0; i++)\x0a"
"\x09\x09\x09if (tags\x5bi\x5d == lit->code_max)\x0a"
"\x09\x09\x09  break;\x0a"
"\x09\x09      if (tags\x5bi\x5d < 0)\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  tags\x5bi\x5d = lit->code_max;\x0a"
"\x09\x09\x09  tags\x5bi + 1\x5d = -1;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09    }\x0a"
"\x09\x09  if (num_tags_seen)\x0a"
"\x09\x09    (*num_tags_seen)++;\x0a"
"\x09\x09}\x0a"
"\x09      break;\x0a"
"\x09    case ASSERTION\x3a\x0a"
"\x09      assert(lit->code_max >= 1\x0a"
"\x09\x09     \x7c\x7c lit->code_max <= ASSERT_LAST);\x0a"
"\x09      if (assertions \x21= NULL)\x0a"
"\x09\x09*assertions \x7c= lit->code_max;\x0a"
"\x09      break;\x0a"
"\x09    case PARAMETER\x3a\x0a"
"\x09      if (params \x21= NULL)\x0a"
"\x09\x09""for (i = 0; i < TRE_PARAM_LAST; i++)\x0a"
"\x09\x09  params\x5bi\x5d = lit->u.params\x5bi\x5d;\x0a"
"\x09      if (params_seen \x21= NULL)\x0a"
"\x09\x09*params_seen = 1;\x0a"
"\x09      break;\x0a"
"\x09    case EMPTY\x3a\x0a"
"\x09      break;\x0a"
"\x09    default\x3a\x0a"
"\x09      assert(0);\x0a"
"\x09      break;\x0a"
"\x09    }\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case UNION\x3a\x0a"
"\x09  /* Subexpressions starting earlier take priority over ones\x0a"
"\x09     starting later, so we prefer the left subexpression over the\x0a"
"\x09     right subexpression. */\x0a"
"\x09  uni = (tre_union_t *)node->obj;\x0a"
"\x09  if (uni->left->nullable)\x0a"
"\x09    STACK_PUSHX(stack, voidptr, uni->left)\x0a"
"\x09  else if (uni->right->nullable)\x0a"
"\x09    STACK_PUSHX(stack, voidptr, uni->right)\x0a"
"\x09  else\x0a"
"\x09    assert(0);\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case CATENATION\x3a\x0a"
"\x09  /* The path must go through both children. */\x0a"
"\x09  cat = (tre_catenation_t *)node->obj;\x0a"
"\x09  assert(cat->left->nullable);\x0a"
"\x09  assert(cat->right->nullable);\x0a"
"\x09  STACK_PUSHX(stack, voidptr, cat->left);\x0a"
"\x09  STACK_PUSHX(stack, voidptr, cat->right);\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case ITERATION\x3a\x0a"
"\x09  /* A match with an empty string is preferred over no match at\x0a"
"\x09     all, so we go through the argument if possible. */\x0a"
"\x09  iter = (tre_iteration_t *)node->obj;\x0a"
"\x09  if (iter->arg->nullable)\x0a"
"\x09    STACK_PUSHX(stack, voidptr, iter->arg);\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""default\x3a\x0a"
"\x09  assert(0);\x0a"
"\x09  break;\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"typedef enum {\x0a"
"  NFL_RECURSE,\x0a"
"  NFL_POST_UNION,\x0a"
"  NFL_POST_CATENATION,\x0a"
"  NFL_POST_ITERATION\x0a"
"} tre_nfl_stack_symbol_t;\x0a"
"\x0a"
"\x0a"
"/* Computes and fills in the fields \x60nullable', \x60""firstpos', and \x60lastpos' for\x0a"
"   the nodes of the AST \x60tree'. */\x0a"
"static reg_errcode_t\x0a"
"tre_compute_nfl(tre_mem_t mem, tre_stack_t *stack, tre_ast_node_t *tree)\x0a"
"{\x0a"
"  int bottom = tre_stack_num_objects(stack);\x0a"
"\x0a"
"  STACK_PUSHR(stack, voidptr, tree);\x0a"
"  STACK_PUSHR(stack, int, NFL_RECURSE);\x0a"
"\x0a"
"  while (tre_stack_num_objects(stack) > bottom)\x0a"
"    {\x0a"
"      tre_nfl_stack_symbol_t symbol;\x0a"
"      tre_ast_node_t *node;\x0a"
"\x0a"
"      symbol = (tre_nfl_stack_symbol_t)tre_stack_pop_int(stack);\x0a"
"      node = tre_stack_pop_voidptr(stack);\x0a"
"      switch (symbol)\x0a"
"\x09{\x0a"
"\x09""case NFL_RECURSE\x3a\x0a"
"\x09  switch (node->type)\x0a"
"\x09    {\x0a"
"\x09    case LITERAL\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_literal_t *lit = (tre_literal_t *)node->obj;\x0a"
"\x09\x09if (IS_BACKREF(lit))\x0a"
"\x09\x09  {\x0a"
"\x09\x09    /* Back references\x3a nullable = false, firstpos = {i},\x0a"
"\x09\x09       lastpos = {i}. */\x0a"
"\x09\x09    node->nullable = 0;\x0a"
"\x09\x09    node->firstpos = tre_set_one(mem, lit->position, 0,\x0a"
"\x09\x09\x09\x09\x09     TRE_CHAR_MAX, 0, NULL, -1);\x0a"
"\x09\x09    if (\x21node->firstpos)\x0a"
"\x09\x09      return REG_ESPACE;\x0a"
"\x09\x09    node->lastpos = tre_set_one(mem, lit->position, 0,\x0a"
"\x09\x09\x09\x09\x09\x09TRE_CHAR_MAX, 0, NULL,\x0a"
"\x09\x09\x09\x09\x09\x09(int)lit->code_max);\x0a"
"\x09\x09    if (\x21node->lastpos)\x0a"
"\x09\x09      return REG_ESPACE;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""else if (lit->code_min < 0)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    /* Tags, empty strings, params, and zero width assertions\x3a\x0a"
"\x09\x09       nullable = true, firstpos = {}, and lastpos = {}. */\x0a"
"\x09\x09    node->nullable = 1;\x0a"
"\x09\x09    node->firstpos = tre_set_empty(mem);\x0a"
"\x09\x09    if (\x21node->firstpos)\x0a"
"\x09\x09      return REG_ESPACE;\x0a"
"\x09\x09    node->lastpos = tre_set_empty(mem);\x0a"
"\x09\x09    if (\x21node->lastpos)\x0a"
"\x09\x09      return REG_ESPACE;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""else\x0a"
"\x09\x09  {\x0a"
"\x09\x09    /* Literal at position i\x3a nullable = false, firstpos = {i},\x0a"
"\x09\x09       lastpos = {i}. */\x0a"
"\x09\x09    node->nullable = 0;\x0a"
"\x09\x09    node->firstpos =\x0a"
"\x09\x09      tre_set_one(mem, lit->position, (int)lit->code_min,\x0a"
"\x09\x09\x09\x09  (int)lit->code_max, 0, NULL, -1);\x0a"
"\x09\x09    if (\x21node->firstpos)\x0a"
"\x09\x09      return REG_ESPACE;\x0a"
"\x09\x09    node->lastpos = tre_set_one(mem, lit->position,\x0a"
"\x09\x09\x09\x09\x09\x09(int)lit->code_min,\x0a"
"\x09\x09\x09\x09\x09\x09(int)lit->code_max,\x0a"
"\x09\x09\x09\x09\x09\x09lit->u.class, lit->neg_classes,\x0a"
"\x09\x09\x09\x09\x09\x09-1);\x0a"
"\x09\x09    if (\x21node->lastpos)\x0a"
"\x09\x09      return REG_ESPACE;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x0a"
"\x09    case UNION\x3a\x0a"
"\x09      /* Compute the attributes for the two subtrees, and after that\x0a"
"\x09\x09 for this node. */\x0a"
"\x09      STACK_PUSHR(stack, voidptr, node);\x0a"
"\x09      STACK_PUSHR(stack, int, NFL_POST_UNION);\x0a"
"\x09      STACK_PUSHR(stack, voidptr, ((tre_union_t *)node->obj)->right);\x0a"
"\x09      STACK_PUSHR(stack, int, NFL_RECURSE);\x0a"
"\x09      STACK_PUSHR(stack, voidptr, ((tre_union_t *)node->obj)->left);\x0a"
"\x09      STACK_PUSHR(stack, int, NFL_RECURSE);\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    case CATENATION\x3a\x0a"
"\x09      /* Compute the attributes for the two subtrees, and after that\x0a"
"\x09\x09 for this node. */\x0a"
"\x09      STACK_PUSHR(stack, voidptr, node);\x0a"
"\x09      STACK_PUSHR(stack, int, NFL_POST_CATENATION);\x0a"
"\x09      STACK_PUSHR(stack, voidptr, ((tre_catenation_t *)node->obj)->right);\x0a"
"\x09      STACK_PUSHR(stack, int, NFL_RECURSE);\x0a"
"\x09      STACK_PUSHR(stack, voidptr, ((tre_catenation_t *)node->obj)->left);\x0a"
"\x09      STACK_PUSHR(stack, int, NFL_RECURSE);\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    case ITERATION\x3a\x0a"
"\x09      /* Compute the attributes for the subtree, and after that for\x0a"
"\x09\x09 this node. */\x0a"
"\x09      STACK_PUSHR(stack, voidptr, node);\x0a"
"\x09      STACK_PUSHR(stack, int, NFL_POST_ITERATION);\x0a"
"\x09      STACK_PUSHR(stack, voidptr, ((tre_iteration_t *)node->obj)->arg);\x0a"
"\x09      STACK_PUSHR(stack, int, NFL_RECURSE);\x0a"
"\x09      break;\x0a"
"\x09    }\x0a"
"\x09  break; /* end case\x3a NFL_RECURSE */\x0a"
"\x0a"
"\x09""case NFL_POST_UNION\x3a\x0a"
"\x09  {\x0a"
"\x09    tre_union_t *uni = (tre_union_t *)node->obj;\x0a"
"\x09    node->nullable = uni->left->nullable \x7c\x7c uni->right->nullable;\x0a"
"\x09    node->firstpos = tre_set_union(mem, uni->left->firstpos,\x0a"
"\x09\x09\x09\x09\x09   uni->right->firstpos, NULL, 0, NULL);\x0a"
"\x09    if (\x21node->firstpos)\x0a"
"\x09      return REG_ESPACE;\x0a"
"\x09    node->lastpos = tre_set_union(mem, uni->left->lastpos,\x0a"
"\x09\x09\x09\x09\x09  uni->right->lastpos, NULL, 0, NULL);\x0a"
"\x09    if (\x21node->lastpos)\x0a"
"\x09      return REG_ESPACE;\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""case NFL_POST_ITERATION\x3a\x0a"
"\x09  {\x0a"
"\x09    tre_iteration_t *iter = (tre_iteration_t *)node->obj;\x0a"
"\x0a"
"\x09    if (iter->min == 0 \x7c\x7c iter->arg->nullable)\x0a"
"\x09      node->nullable = 1;\x0a"
"\x09    else\x0a"
"\x09      node->nullable = 0;\x0a"
"\x09    node->firstpos = iter->arg->firstpos;\x0a"
"\x09    node->lastpos = iter->arg->lastpos;\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""case NFL_POST_CATENATION\x3a\x0a"
"\x09  {\x0a"
"\x09    int num_tags, *tags, assertions, params_seen;\x0a"
"\x09    int *params;\x0a"
"\x09    reg_errcode_t status;\x0a"
"\x09    tre_catenation_t *cat = node->obj;\x0a"
"\x09    node->nullable = cat->left->nullable \x26\x26 cat->right->nullable;\x0a"
"\x0a"
"\x09    /* Compute firstpos. */\x0a"
"\x09    if (cat->left->nullable)\x0a"
"\x09      {\x0a"
"\x09\x09/* The left side matches the empty string.  Make a first pass\x0a"
"\x09\x09   with tre_match_empty() to get the number of tags and\x0a"
"\x09\x09   parameters. */\x0a"
"\x09\x09status = tre_match_empty(stack, cat->left,\x0a"
"\x09\x09\x09\x09\x09 NULL, NULL, NULL, \x26num_tags,\x0a"
"\x09\x09\x09\x09\x09 \x26params_seen);\x0a"
"\x09\x09if (status \x21= REG_OK)\x0a"
"\x09\x09  return status;\x0a"
"\x09\x09/* Allocate arrays for the tags and parameters. */\x0a"
"\x09\x09tags = xmalloc(sizeof(*tags) * (num_tags + 1));\x0a"
"\x09\x09if (\x21tags)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09tags\x5b""0\x5d = -1;\x0a"
"\x09\x09""assertions = 0;\x0a"
"\x09\x09params = NULL;\x0a"
"\x09\x09if (params_seen)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    params = tre_mem_alloc(mem, sizeof(*params)\x0a"
"\x09\x09\x09\x09\x09   * TRE_PARAM_LAST);\x0a"
"\x09\x09    if (\x21params)\x0a"
"\x09\x09      {\x0a"
"\x09\x09\x09xfree(tags);\x0a"
"\x09\x09\x09return REG_ESPACE;\x0a"
"\x09\x09      }\x0a"
"\x09\x09  }\x0a"
"\x09\x09/* Second pass with tre_mach_empty() to get the list of\x0a"
"\x09\x09   tags and parameters. */\x0a"
"\x09\x09status = tre_match_empty(stack, cat->left, tags,\x0a"
"\x09\x09\x09\x09\x09 \x26""assertions, params, NULL, NULL);\x0a"
"\x09\x09if (status \x21= REG_OK)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    xfree(tags);\x0a"
"\x09\x09    return status;\x0a"
"\x09\x09  }\x0a"
"\x09\x09node->firstpos =\x0a"
"\x09\x09  tre_set_union(mem, cat->right->firstpos, cat->left->firstpos,\x0a"
"\x09\x09\x09\x09tags, assertions, params);\x0a"
"\x09\x09xfree(tags);\x0a"
"\x09\x09if (\x21node->firstpos)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09      }\x0a"
"\x09    else\x0a"
"\x09      {\x0a"
"\x09\x09node->firstpos = cat->left->firstpos;\x0a"
"\x09      }\x0a"
"\x0a"
"\x09    /* Compute lastpos. */\x0a"
"\x09    if (cat->right->nullable)\x0a"
"\x09      {\x0a"
"\x09\x09/* The right side matches the empty string.  Make a first pass\x0a"
"\x09\x09   with tre_match_empty() to get the number of tags and\x0a"
"\x09\x09   parameters. */\x0a"
"\x09\x09status = tre_match_empty(stack, cat->right,\x0a"
"\x09\x09\x09\x09\x09 NULL, NULL, NULL, \x26num_tags,\x0a"
"\x09\x09\x09\x09\x09 \x26params_seen);\x0a"
"\x09\x09if (status \x21= REG_OK)\x0a"
"\x09\x09  return status;\x0a"
"\x09\x09/* Allocate arrays for the tags and parameters. */\x0a"
"\x09\x09tags = xmalloc(sizeof(int) * (num_tags + 1));\x0a"
"\x09\x09if (\x21tags)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09tags\x5b""0\x5d = -1;\x0a"
"\x09\x09""assertions = 0;\x0a"
"\x09\x09params = NULL;\x0a"
"\x09\x09if (params_seen)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    params = tre_mem_alloc(mem, sizeof(*params)\x0a"
"\x09\x09\x09\x09\x09   * TRE_PARAM_LAST);\x0a"
"\x09\x09    if (\x21params)\x0a"
"\x09\x09      {\x0a"
"\x09\x09\x09xfree(tags);\x0a"
"\x09\x09\x09return REG_ESPACE;\x0a"
"\x09\x09      }\x0a"
"\x09\x09  }\x0a"
"\x09\x09/* Second pass with tre_mach_empty() to get the list of\x0a"
"\x09\x09   tags and parameters. */\x0a"
"\x09\x09status = tre_match_empty(stack, cat->right, tags,\x0a"
"\x09\x09\x09\x09\x09 \x26""assertions, params, NULL, NULL);\x0a"
"\x09\x09if (status \x21= REG_OK)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    xfree(tags);\x0a"
"\x09\x09    return status;\x0a"
"\x09\x09  }\x0a"
"\x09\x09node->lastpos =\x0a"
"\x09\x09  tre_set_union(mem, cat->left->lastpos, cat->right->lastpos,\x0a"
"\x09\x09\x09\x09tags, assertions, params);\x0a"
"\x09\x09xfree(tags);\x0a"
"\x09\x09if (\x21node->lastpos)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09      }\x0a"
"\x09    else\x0a"
"\x09      {\x0a"
"\x09\x09node->lastpos = cat->right->lastpos;\x0a"
"\x09      }\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""default\x3a\x0a"
"\x09  assert(0);\x0a"
"\x09  break;\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  return REG_OK;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* Adds a transition from each position in \x60p1' to each position in \x60p2'. */\x0a"
"static reg_errcode_t\x0a"
"tre_make_trans(tre_pos_and_tags_t *p1, tre_pos_and_tags_t *p2,\x0a"
"\x09       tre_tnfa_transition_t *transitions,\x0a"
"\x09       int *counts, int *offs)\x0a"
"{\x0a"
"  tre_pos_and_tags_t *orig_p2 = p2;\x0a"
"  tre_tnfa_transition_t *trans;\x0a"
"  int i, j, k, l, dup, prev_p2_pos;\x0a"
"\x0a"
"  if (transitions \x21= NULL)\x0a"
"    while (p1->position >= 0)\x0a"
"      {\x0a"
"\x09p2 = orig_p2;\x0a"
"\x09prev_p2_pos = -1;\x0a"
"\x09while (p2->position >= 0)\x0a"
"\x09  {\x0a"
"\x09    /* Optimization\x3a if this position was already handled, skip it. */\x0a"
"\x09    if (p2->position == prev_p2_pos)\x0a"
"\x09      {\x0a"
"\x09\x09p2++;\x0a"
"\x09\x09""continue;\x0a"
"\x09      }\x0a"
"\x09    prev_p2_pos = p2->position;\x0a"
"\x09    /* Set \x60trans' to point to the next unused transition from\x0a"
"\x09       position \x60p1->position'. */\x0a"
"\x09    trans = transitions + offs\x5bp1->position\x5d;\x0a"
"\x09    while (trans->state \x21= NULL)\x0a"
"\x09      {\x0a"
"#if 0\x0a"
"\x09\x09/* If we find a previous transition from \x60p1->position' to\x0a"
"\x09\x09   \x60p2->position', it is overwritten.  This can happen only\x0a"
"\x09\x09   if there are nested loops in the regexp, like in \x22((a)*)*\x22.\x0a"
"\x09\x09   In POSIX.2 repetition using the outer loop is always\x0a"
"\x09\x09   preferred over using the inner loop.\x09 Therefore the\x0a"
"\x09\x09   transition for the inner loop is useless and can be thrown\x0a"
"\x09\x09   away. */\x0a"
"\x09\x09/* XXX - The same position is used for all nodes in a bracket\x0a"
"\x09\x09   expression, so this optimization cannot be used (it will\x0a"
"\x09\x09   break bracket expressions) unless I figure out a way to\x0a"
"\x09\x09   detect it here. */\x0a"
"\x09\x09if (trans->state_id == p2->position)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    DPRINT((\x22*\x22));\x0a"
"\x09\x09    break;\x0a"
"\x09\x09  }\x0a"
"#endif\x0a"
"\x09\x09trans++;\x0a"
"\x09      }\x0a"
"\x0a"
"\x09    if (trans->state == NULL)\x0a"
"\x09      (trans + 1)->state = NULL;\x0a"
"\x09    /* Use the character ranges, assertions, etc. from \x60p1' for\x0a"
"\x09       the transition from \x60p1' to \x60p2'. */\x0a"
"\x09    trans->code_min = (tre_cint_t) p1->code_min;\x0a"
"\x09    trans->code_max = (tre_cint_t) p1->code_max;\x0a"
"\x09    trans->state = transitions + offs\x5bp2->position\x5d;\x0a"
"\x09    trans->state_id = p2->position;\x0a"
"\x09    trans->assertions = p1->assertions \x7c p2->assertions\x0a"
"\x09      \x7c (p1->class \x3f ASSERT_CHAR_CLASS \x3a 0)\x0a"
"\x09      \x7c (p1->neg_classes \x21= NULL \x3f ASSERT_CHAR_CLASS_NEG \x3a 0);\x0a"
"\x09    if (p1->backref >= 0)\x0a"
"\x09      {\x0a"
"\x09\x09""assert((trans->assertions \x26 ASSERT_CHAR_CLASS) == 0);\x0a"
"\x09\x09""assert(p2->backref < 0);\x0a"
"\x09\x09trans->u.backref = p1->backref;\x0a"
"\x09\x09trans->assertions \x7c= ASSERT_BACKREF;\x0a"
"\x09      }\x0a"
"\x09    else\x0a"
"\x09      trans->u.class = p1->class;\x0a"
"\x09    if (p1->neg_classes \x21= NULL)\x0a"
"\x09      {\x0a"
"\x09\x09""for (i = 0; p1->neg_classes\x5bi\x5d \x21= (tre_ctype_t)0; i++);\x0a"
"\x09\x09trans->neg_classes =\x0a"
"\x09\x09  xmalloc(sizeof(*trans->neg_classes) * (i + 1));\x0a"
"\x09\x09if (trans->neg_classes == NULL)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09""for (i = 0; p1->neg_classes\x5bi\x5d \x21= (tre_ctype_t)0; i++)\x0a"
"\x09\x09  trans->neg_classes\x5bi\x5d = p1->neg_classes\x5bi\x5d;\x0a"
"\x09\x09trans->neg_classes\x5bi\x5d = (tre_ctype_t)0;\x0a"
"\x09      }\x0a"
"\x09    else\x0a"
"\x09      trans->neg_classes = NULL;\x0a"
"\x0a"
"\x09    /* Find out how many tags this transition has. */\x0a"
"\x09    i = 0;\x0a"
"\x09    if (p1->tags \x21= NULL)\x0a"
"\x09      while(p1->tags\x5bi\x5d >= 0)\x0a"
"\x09\x09i++;\x0a"
"\x09    j = 0;\x0a"
"\x09    if (p2->tags \x21= NULL)\x0a"
"\x09      while(p2->tags\x5bj\x5d >= 0)\x0a"
"\x09\x09j++;\x0a"
"\x0a"
"\x09    /* If we are overwriting a transition, free the old tag array. */\x0a"
"\x09    if (trans->tags \x21= NULL)\x0a"
"\x09      xfree(trans->tags);\x0a"
"\x09    trans->tags = NULL;\x0a"
"\x0a"
"\x09    /* If there were any tags, allocate an array and fill it. */\x0a"
"\x09    if (i + j > 0)\x0a"
"\x09      {\x0a"
"\x09\x09trans->tags = xmalloc(sizeof(*trans->tags) * (i + j + 1));\x0a"
"\x09\x09if (\x21trans->tags)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09i = 0;\x0a"
"\x09\x09if (p1->tags \x21= NULL)\x0a"
"\x09\x09  while(p1->tags\x5bi\x5d >= 0)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      trans->tags\x5bi\x5d = p1->tags\x5bi\x5d;\x0a"
"\x09\x09      i++;\x0a"
"\x09\x09    }\x0a"
"\x09\x09l = i;\x0a"
"\x09\x09j = 0;\x0a"
"\x09\x09if (p2->tags \x21= NULL)\x0a"
"\x09\x09  while (p2->tags\x5bj\x5d >= 0)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      /* Don't add duplicates. */\x0a"
"\x09\x09      dup = 0;\x0a"
"\x09\x09      for (k = 0; k < i; k++)\x0a"
"\x09\x09\x09if (trans->tags\x5bk\x5d == p2->tags\x5bj\x5d)\x0a"
"\x09\x09\x09  {\x0a"
"\x09\x09\x09    dup = 1;\x0a"
"\x09\x09\x09    break;\x0a"
"\x09\x09\x09  }\x0a"
"\x09\x09      if (\x21""dup)\x0a"
"\x09\x09\x09trans->tags\x5bl++\x5d = p2->tags\x5bj\x5d;\x0a"
"\x09\x09      j++;\x0a"
"\x09\x09    }\x0a"
"\x09\x09trans->tags\x5bl\x5d = -1;\x0a"
"\x09      }\x0a"
"\x0a"
"\x09    /* Set the parameter array.\x09 If both \x60p2' and \x60p1' have same\x0a"
"\x09       parameters, the values in \x60p2' override those in \x60p1'. */\x0a"
"\x09    if (p1->params \x7c\x7c p2->params)\x0a"
"\x09      {\x0a"
"\x09\x09if (\x21trans->params)\x0a"
"\x09\x09  trans->params = xmalloc(sizeof(*trans->params)\x0a"
"\x09\x09\x09\x09\x09  * TRE_PARAM_LAST);\x0a"
"\x09\x09if (\x21trans->params)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09""for (i = 0; i < TRE_PARAM_LAST; i++)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    trans->params\x5bi\x5d = TRE_PARAM_UNSET;\x0a"
"\x09\x09    if (p1->params \x26\x26 p1->params\x5bi\x5d \x21= TRE_PARAM_UNSET)\x0a"
"\x09\x09      trans->params\x5bi\x5d = p1->params\x5bi\x5d;\x0a"
"\x09\x09    if (p2->params \x26\x26 p2->params\x5bi\x5d \x21= TRE_PARAM_UNSET)\x0a"
"\x09\x09      trans->params\x5bi\x5d = p2->params\x5bi\x5d;\x0a"
"\x09\x09  }\x0a"
"\x09      }\x0a"
"\x09    else\x0a"
"\x09      {\x0a"
"\x09\x09if (trans->params)\x0a"
"\x09\x09  xfree(trans->params);\x0a"
"\x09\x09trans->params = NULL;\x0a"
"\x09      }\x0a"
"\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"\x09    {\x0a"
"\x09      int *tags;\x0a"
"\x0a"
"\x09      DPRINT((\x22\x09 \x25""2d -> \x25""2d on \x25""3d\x22, p1->position, p2->position,\x0a"
"\x09\x09      p1->code_min));\x0a"
"\x09      if (p1->code_max \x21= p1->code_min)\x0a"
"\x09\x09""DPRINT((\x22-\x25""3d\x22, p1->code_max));\x0a"
"\x09      tags = trans->tags;\x0a"
"\x09      if (tags)\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22, tags \x5b\x22));\x0a"
"\x09\x09  while (*tags >= 0)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      DPRINT((\x22\x25""d\x22, *tags));\x0a"
"\x09\x09      tags++;\x0a"
"\x09\x09      if (*tags >= 0)\x0a"
"\x09\x09\x09""DPRINT((\x22,\x22));\x0a"
"\x09\x09    }\x0a"
"\x09\x09  DPRINT((\x22\x5d\x22));\x0a"
"\x09\x09}\x0a"
"\x09      if (trans->assertions)\x0a"
"\x09\x09""DPRINT((\x22, assert \x25""d\x22, trans->assertions));\x0a"
"\x09      if (trans->assertions \x26 ASSERT_BACKREF)\x0a"
"\x09\x09""DPRINT((\x22, backref \x25""d\x22, trans->u.backref));\x0a"
"\x09      else if (trans->u.class)\x0a"
"\x09\x09""DPRINT((\x22, class \x25ld\x22, (long)trans->u.class));\x0a"
"\x09      if (trans->neg_classes)\x0a"
"\x09\x09""DPRINT((\x22, neg_classes \x25p\x22, trans->neg_classes));\x0a"
"\x09      if (trans->params)\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22, \x22));\x0a"
"\x09\x09  tre_print_params(trans->params);\x0a"
"\x09\x09}\x0a"
"\x09      DPRINT((\x22\x5cn\x22));\x0a"
"\x09    }\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x09    p2++;\x0a"
"\x09  }\x0a"
"\x09p1++;\x0a"
"      }\x0a"
"  else\x0a"
"    /* Compute a maximum limit for the number of transitions leaving\x0a"
"       from each state. */\x0a"
"    while (p1->position >= 0)\x0a"
"      {\x0a"
"\x09p2 = orig_p2;\x0a"
"\x09while (p2->position >= 0)\x0a"
"\x09  {\x0a"
"\x09    counts\x5bp1->position\x5d++;\x0a"
"\x09    p2++;\x0a"
"\x09  }\x0a"
"\x09p1++;\x0a"
"      }\x0a"
"  return REG_OK;\x0a"
"}\x0a"
"\x0a"
"/* Converts the syntax tree to a TNFA.\x09""All the transitions in the TNFA are\x0a"
"   labelled with one character range (there are no transitions on empty\x0a"
"   strings).  The TNFA takes O(n^2) space in the worst case, \x60n' is size of\x0a"
"   the regexp. */\x0a"
"static reg_errcode_t\x0a"
"tre_ast_to_tnfa(tre_ast_node_t *node, tre_tnfa_transition_t *transitions,\x0a"
"\x09\x09int *counts, int *offs)\x0a"
"{\x0a"
"  tre_union_t *uni;\x0a"
"  tre_catenation_t *cat;\x0a"
"  tre_iteration_t *iter;\x0a"
"  reg_errcode_t errcode = REG_OK;\x0a"
"\x0a"
"  /* XXX - recurse using a stack\x21. */\x0a"
"  switch (node->type)\x0a"
"    {\x0a"
"    case LITERAL\x3a\x0a"
"      break;\x0a"
"    case UNION\x3a\x0a"
"      uni = (tre_union_t *)node->obj;\x0a"
"      errcode = tre_ast_to_tnfa(uni->left, transitions, counts, offs);\x0a"
"      if (errcode \x21= REG_OK)\x0a"
"\x09return errcode;\x0a"
"      errcode = tre_ast_to_tnfa(uni->right, transitions, counts, offs);\x0a"
"      break;\x0a"
"\x0a"
"    case CATENATION\x3a\x0a"
"      cat = (tre_catenation_t *)node->obj;\x0a"
"      /* Add a transition from each position in cat->left->lastpos\x0a"
"\x09 to each position in cat->right->firstpos. */\x0a"
"      errcode = tre_make_trans(cat->left->lastpos, cat->right->firstpos,\x0a"
"\x09\x09\x09       transitions, counts, offs);\x0a"
"      if (errcode \x21= REG_OK)\x0a"
"\x09return errcode;\x0a"
"      errcode = tre_ast_to_tnfa(cat->left, transitions, counts, offs);\x0a"
"      if (errcode \x21= REG_OK)\x0a"
"\x09return errcode;\x0a"
"      errcode = tre_ast_to_tnfa(cat->right, transitions, counts, offs);\x0a"
"      break;\x0a"
"\x0a"
"    case ITERATION\x3a\x0a"
"      iter = (tre_iteration_t *)node->obj;\x0a"
"      assert(iter->max == -1 \x7c\x7c iter->max == 1);\x0a"
"\x0a"
"      if (iter->max == -1)\x0a"
"\x09{\x0a"
"\x09  assert(iter->min == 0 \x7c\x7c iter->min == 1);\x0a"
"\x09  /* Add a transition from each last position in the iterated\x0a"
"\x09     expression to each first position. */\x0a"
"\x09  errcode = tre_make_trans(iter->arg->lastpos, iter->arg->firstpos,\x0a"
"\x09\x09\x09\x09   transitions, counts, offs);\x0a"
"\x09  if (errcode \x21= REG_OK)\x0a"
"\x09    return errcode;\x0a"
"\x09}\x0a"
"      errcode = tre_ast_to_tnfa(iter->arg, transitions, counts, offs);\x0a"
"      break;\x0a"
"    }\x0a"
"  return errcode;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#define ERROR_EXIT(err)\x09\x09  \x5c\x0a"
"  do\x09\x09\x09\x09  \x5c\x0a"
"    {\x09\x09\x09\x09  \x5c\x0a"
"      errcode = err;\x09\x09  \x5c\x0a"
"      if (/*CONSTCOND*/(void)1,1)\x09  \x5c\x0a"
"      \x09goto error_exit;\x09  \x5c\x0a"
"    }\x09\x09\x09\x09  \x5c\x0a"
" while (/*CONSTCOND*/(void)0,0)\x0a"
"\x0a"
"\x0a"
"int\x0a"
"tre_compile(regex_t *preg, const tre_char_t *regex, size_t n, int cflags)\x0a"
"{\x0a"
"  tre_stack_t *stack;\x0a"
"  tre_ast_node_t *tree, *tmp_ast_l, *tmp_ast_r;\x0a"
"  tre_pos_and_tags_t *p;\x0a"
"  int *counts = NULL, *offs = NULL;\x0a"
"  int i, add = 0;\x0a"
"  tre_tnfa_transition_t *transitions, *initial;\x0a"
"  tre_tnfa_t *tnfa = NULL;\x0a"
"  tre_submatch_data_t *submatch_data;\x0a"
"  tre_tag_direction_t *tag_directions = NULL;\x0a"
"  reg_errcode_t errcode;\x0a"
"  tre_mem_t mem;\x0a"
"\x0a"
"  /* Parse context. */\x0a"
"  tre_parse_ctx_t parse_ctx;\x0a"
"\x0a"
"  /* Allocate a stack used throughout the compilation process for various\x0a"
"     purposes. */\x0a"
"  stack = tre_stack_new(512, 10240, 128);\x0a"
"  if (\x21stack)\x0a"
"    return REG_ESPACE;\x0a"
"  /* Allocate a fast memory allocator. */\x0a"
"  mem = tre_mem_new();\x0a"
"  if (\x21mem)\x0a"
"    {\x0a"
"      tre_stack_destroy(stack);\x0a"
"      return REG_ESPACE;\x0a"
"    }\x0a"
"\x0a"
"  /* Parse the regexp. */\x0a"
"  memset(\x26parse_ctx, 0, sizeof(parse_ctx));\x0a"
"  parse_ctx.mem = mem;\x0a"
"  parse_ctx.stack = stack;\x0a"
"  parse_ctx.re = regex;\x0a"
"  parse_ctx.len = n;\x0a"
"  parse_ctx.cflags = cflags;\x0a"
"  parse_ctx.max_backref = -1;\x0a"
"  /* workaround for PR#14408\x3a use 8-bit optimizations in 8-bit mode */\x0a"
"  parse_ctx.cur_max = (cflags \x26 REG_USEBYTES) \x3f 1 \x3a TRE_MB_CUR_MAX;\x0a"
"  DPRINT((\x22tre_compile\x3a parsing '\x25.*\x22 STRF \x22'\x5cn\x22, (int)n, regex));\x0a"
"  errcode = tre_parse(\x26parse_ctx);\x0a"
"  if (errcode \x21= REG_OK)\x0a"
"    ERROR_EXIT(errcode);\x0a"
"  preg->re_nsub = parse_ctx.submatch_id - 1;\x0a"
"  tree = parse_ctx.result;\x0a"
"\x0a"
"  /* Back references and approximate matching cannot currently be used\x0a"
"     in the same regexp. */\x0a"
"  if (parse_ctx.max_backref >= 0 \x26\x26 parse_ctx.have_approx)\x0a"
"    ERROR_EXIT(REG_BADPAT);\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"  tre_ast_print(tree);\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
"  /* Referring to nonexistent subexpressions is illegal. */\x0a"
"  if (parse_ctx.max_backref > (int)preg->re_nsub)\x0a"
"    ERROR_EXIT(REG_ESUBREG);\x0a"
"\x0a"
"  /* Allocate the TNFA struct. */\x0a"
"  tnfa = xcalloc(1, sizeof(tre_tnfa_t));\x0a"
"  if (tnfa == NULL)\x0a"
"    ERROR_EXIT(REG_ESPACE);\x0a"
"  tnfa->have_backrefs = parse_ctx.max_backref >= 0;\x0a"
"  tnfa->have_approx = parse_ctx.have_approx;\x0a"
"  tnfa->num_submatches = parse_ctx.submatch_id;\x0a"
"\x0a"
"  /* Set up tags for submatch addressing.  If REG_NOSUB is set and the\x0a"
"     regexp does not have back references, this can be skipped. */\x0a"
"  if (tnfa->have_backrefs \x7c\x7c \x21(cflags \x26 REG_NOSUB))\x0a"
"    {\x0a"
"      DPRINT((\x22tre_compile\x3a setting up tags\x5cn\x22));\x0a"
"\x0a"
"      /* Figure out how many tags we will need. */\x0a"
"      errcode = tre_add_tags(NULL, stack, tree, tnfa);\x0a"
"      if (errcode \x21= REG_OK)\x0a"
"\x09""ERROR_EXIT(errcode);\x0a"
"#ifdef TRE_DEBUG\x0a"
"      tre_ast_print(tree);\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
"      if (tnfa->num_tags > 0)\x0a"
"\x09{\x0a"
"\x09  tag_directions = xmalloc(sizeof(*tag_directions)\x0a"
"\x09\x09\x09\x09   * (tnfa->num_tags + 1));\x0a"
"\x09  if (tag_directions == NULL)\x0a"
"\x09    ERROR_EXIT(REG_ESPACE);\x0a"
"\x09  tnfa->tag_directions = tag_directions;\x0a"
"\x09  memset(tag_directions, -1,\x0a"
"\x09\x09 sizeof(*tag_directions) * (tnfa->num_tags + 1));\x0a"
"\x09}\x0a"
"      tnfa->minimal_tags = xcalloc((unsigned)tnfa->num_tags * 2 + 1,\x0a"
"\x09\x09\x09\x09   sizeof(tnfa->minimal_tags));\x0a"
"      if (tnfa->minimal_tags == NULL)\x0a"
"\x09""ERROR_EXIT(REG_ESPACE);\x0a"
"\x0a"
"      submatch_data = xcalloc((unsigned)parse_ctx.submatch_id,\x0a"
"\x09\x09\x09      sizeof(*submatch_data));\x0a"
"      if (submatch_data == NULL)\x0a"
"\x09""ERROR_EXIT(REG_ESPACE);\x0a"
"      tnfa->submatch_data = submatch_data;\x0a"
"\x0a"
"      errcode = tre_add_tags(mem, stack, tree, tnfa);\x0a"
"      if (errcode \x21= REG_OK)\x0a"
"\x09""ERROR_EXIT(errcode);\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"      for (i = 0; i < parse_ctx.submatch_id; i++)\x0a"
"\x09""DPRINT((\x22pmatch\x5b\x25""d\x5d = {t\x25""d, t\x25""d}\x5cn\x22,\x0a"
"\x09\x09i, submatch_data\x5bi\x5d.so_tag, submatch_data\x5bi\x5d.eo_tag));\x0a"
"      for (i = 0; i < tnfa->num_tags; i++)\x0a"
"\x09""DPRINT((\x22t\x25""d is \x25s\x5cn\x22, i,\x0a"
"\x09\x09tag_directions\x5bi\x5d == TRE_TAG_MINIMIZE \x3f\x0a"
"\x09\x09\x22minimized\x22 \x3a \x22maximized\x22));\x0a"
"#endif /* TRE_DEBUG */\x0a"
"    }\x0a"
"\x0a"
"  /* Expand iteration nodes. */\x0a"
"  errcode = tre_expand_ast(mem, stack, tree, \x26parse_ctx.position,\x0a"
"\x09\x09\x09   tag_directions, \x26tnfa->params_depth);\x0a"
"  if (errcode \x21= REG_OK)\x0a"
"    ERROR_EXIT(errcode);\x0a"
"\x0a"
"  /* Add a dummy node for the final state.\x0a"
"     XXX - For certain patterns this dummy node can be optimized away,\x0a"
"\x09   for example \x22""a*\x22 or \x22""ab*\x22.\x09""Figure out a simple way to detect\x0a"
"\x09   this possibility. */\x0a"
"  tmp_ast_l = tree;\x0a"
"  tmp_ast_r = tre_ast_new_literal(mem, 0, 0, parse_ctx.position++);\x0a"
"  if (tmp_ast_r == NULL)\x0a"
"    ERROR_EXIT(REG_ESPACE);\x0a"
"\x0a"
"  tree = tre_ast_new_catenation(mem, tmp_ast_l, tmp_ast_r);\x0a"
"  if (tree == NULL)\x0a"
"    ERROR_EXIT(REG_ESPACE);\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"  tre_ast_print(tree);\x0a"
"  DPRINT((\x22Number of states\x3a \x25""d\x5cn\x22, parse_ctx.position));\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
"  errcode = tre_compute_nfl(mem, stack, tree);\x0a"
"  if (errcode \x21= REG_OK)\x0a"
"    ERROR_EXIT(errcode);\x0a"
"\x0a"
"  counts = xmalloc(sizeof(int) * parse_ctx.position);\x0a"
"  if (counts == NULL)\x0a"
"    ERROR_EXIT(REG_ESPACE);\x0a"
"\x0a"
"  offs = xmalloc(sizeof(int) * parse_ctx.position);\x0a"
"  if (offs == NULL)\x0a"
"    ERROR_EXIT(REG_ESPACE);\x0a"
"\x0a"
"  for (i = 0; i < parse_ctx.position; i++)\x0a"
"    counts\x5bi\x5d = 0;\x0a"
"  tre_ast_to_tnfa(tree, NULL, counts, NULL);\x0a"
"\x0a"
"  add = 0;\x0a"
"  for (i = 0; i < parse_ctx.position; i++)\x0a"
"    {\x0a"
"      offs\x5bi\x5d = add;\x0a"
"      add += counts\x5bi\x5d + 1;\x0a"
"      counts\x5bi\x5d = 0;\x0a"
"    }\x0a"
"  transitions = xcalloc((unsigned)add + 1, sizeof(*transitions));\x0a"
"  if (transitions == NULL)\x0a"
"    ERROR_EXIT(REG_ESPACE);\x0a"
"  tnfa->transitions = transitions;\x0a"
"  tnfa->num_transitions = add;\x0a"
"\x0a"
"  DPRINT((\x22""Converting to TNFA\x3a\x5cn\x22));\x0a"
"  errcode = tre_ast_to_tnfa(tree, transitions, counts, offs);\x0a"
"  if (errcode \x21= REG_OK)\x0a"
"    ERROR_EXIT(errcode);\x0a"
"\x0a"
"  /* If in eight bit mode, compute a table of characters that can be the\x0a"
"     first character of a match. */\x0a"
"  tnfa->first_char = -1;\x0a"
"  if (TRE_MB_CUR_MAX == 1 \x26\x26 \x21tmp_ast_l->nullable)\x0a"
"    {\x0a"
"      int count = 0;\x0a"
"      tre_cint_t k;\x0a"
"      DPRINT((\x22""Characters that can start a match\x3a\x22));\x0a"
"      tnfa->firstpos_chars = xcalloc(256, sizeof(char));\x0a"
"      if (tnfa->firstpos_chars == NULL)\x0a"
"\x09""ERROR_EXIT(REG_ESPACE);\x0a"
"      for (p = tree->firstpos; p->position >= 0; p++)\x0a"
"\x09{\x0a"
"\x09  tre_tnfa_transition_t *j = transitions + offs\x5bp->position\x5d;\x0a"
"\x09  while (j->state \x21= NULL)\x0a"
"\x09    {\x0a"
"\x09      for (k = j->code_min; k <= j->code_max \x26\x26 k < 256; k++)\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22 \x25""d\x22, k));\x0a"
"\x09\x09  tnfa->firstpos_chars\x5bk\x5d = 1;\x0a"
"\x09\x09  count++;\x0a"
"\x09\x09}\x0a"
"\x09      j++;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"      DPRINT((\x22\x5cn\x22));\x0a"
"#define TRE_OPTIMIZE_FIRST_CHAR 1\x0a"
"#if TRE_OPTIMIZE_FIRST_CHAR\x0a"
"      if (count == 1)\x0a"
"\x09{\x0a"
"\x09  for (k = 0; k < 256; k++)\x0a"
"\x09    if (tnfa->firstpos_chars\x5bk\x5d)\x0a"
"\x09      {\x0a"
"\x09\x09""DPRINT((\x22""first char must be \x25""d\x5cn\x22, k));\x0a"
"\x09\x09tnfa->first_char = k;\x0a"
"\x09\x09xfree(tnfa->firstpos_chars);\x0a"
"\x09\x09tnfa->firstpos_chars = NULL;\x0a"
"\x09\x09""break;\x0a"
"\x09      }\x0a"
"\x09}\x0a"
"#endif\x0a"
"\x0a"
"    }\x0a"
"  else\x0a"
"    tnfa->firstpos_chars = NULL;\x0a"
"\x0a"
"\x0a"
"  p = tree->firstpos;\x0a"
"  i = 0;\x0a"
"  while (p->position >= 0)\x0a"
"    {\x0a"
"      i++;\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"      {\x0a"
"\x09int *tags;\x0a"
"\x09""DPRINT((\x22initial\x3a \x25""d\x22, p->position));\x0a"
"\x09tags = p->tags;\x0a"
"\x09if (tags \x21= NULL)\x0a"
"\x09  {\x0a"
"\x09    if (*tags >= 0)\x0a"
"\x09      DPRINT((\x22/\x22));\x0a"
"\x09    while (*tags >= 0)\x0a"
"\x09      {\x0a"
"\x09\x09""DPRINT((\x22\x25""d\x22, *tags));\x0a"
"\x09\x09tags++;\x0a"
"\x09\x09if (*tags >= 0)\x0a"
"\x09\x09  DPRINT((\x22,\x22));\x0a"
"\x09      }\x0a"
"\x09  }\x0a"
"\x09""DPRINT((\x22, assert \x25""d\x22, p->assertions));\x0a"
"\x09if (p->params)\x0a"
"\x09  {\x0a"
"\x09    DPRINT((\x22, \x22));\x0a"
"\x09    tre_print_params(p->params);\x0a"
"\x09  }\x0a"
"\x09""DPRINT((\x22\x5cn\x22));\x0a"
"      }\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
"      p++;\x0a"
"    }\x0a"
"\x0a"
"  initial = xcalloc((unsigned)i + 1, sizeof(tre_tnfa_transition_t));\x0a"
"  if (initial == NULL)\x0a"
"    ERROR_EXIT(REG_ESPACE);\x0a"
"  tnfa->initial = initial;\x0a"
"\x0a"
"  i = 0;\x0a"
"  for (p = tree->firstpos; p->position >= 0; p++)\x0a"
"    {\x0a"
"      initial\x5bi\x5d.state = transitions + offs\x5bp->position\x5d;\x0a"
"      initial\x5bi\x5d.state_id = p->position;\x0a"
"      initial\x5bi\x5d.tags = NULL;\x0a"
"      /* Copy the arrays p->tags, and p->params, they are allocated\x0a"
"\x09 from a tre_mem object. */\x0a"
"      if (p->tags)\x0a"
"\x09{\x0a"
"\x09  int j;\x0a"
"\x09  for (j = 0; p->tags\x5bj\x5d >= 0; j++);\x0a"
"\x09  initial\x5bi\x5d.tags = xmalloc(sizeof(*p->tags) * (j + 1));\x0a"
"\x09  if (\x21initial\x5bi\x5d.tags)\x0a"
"\x09    ERROR_EXIT(REG_ESPACE);\x0a"
"\x09  memcpy(initial\x5bi\x5d.tags, p->tags, sizeof(*p->tags) * (j + 1));\x0a"
"\x09}\x0a"
"      initial\x5bi\x5d.params = NULL;\x0a"
"      if (p->params)\x0a"
"\x09{\x0a"
"\x09  initial\x5bi\x5d.params = xmalloc(sizeof(*p->params) * TRE_PARAM_LAST);\x0a"
"\x09  if (\x21initial\x5bi\x5d.params)\x0a"
"\x09    ERROR_EXIT(REG_ESPACE);\x0a"
"\x09  memcpy(initial\x5bi\x5d.params, p->params,\x0a"
"\x09\x09 sizeof(*p->params) * TRE_PARAM_LAST);\x0a"
"\x09}\x0a"
"      initial\x5bi\x5d.assertions = p->assertions;\x0a"
"      i++;\x0a"
"    }\x0a"
"  initial\x5bi\x5d.state = NULL;\x0a"
"\x0a"
"  tnfa->num_transitions = add;\x0a"
"  tnfa->final = transitions + offs\x5btree->lastpos\x5b""0\x5d.position\x5d;\x0a"
"  tnfa->num_states = parse_ctx.position;\x0a"
"  tnfa->cflags = cflags;\x0a"
"\x0a"
"  DPRINT((\x22""final state \x25p\x5cn\x22, (void *)tnfa->final));\x0a"
"\x0a"
"  tre_mem_destroy(mem);\x0a"
"  tre_stack_destroy(stack);\x0a"
"  xfree(counts);\x0a"
"  xfree(offs);\x0a"
"\x0a"
"  preg->TRE_REGEX_T_FIELD = (void *)tnfa;\x0a"
"  return REG_OK;\x0a"
"\x0a"
" error_exit\x3a\x0a"
"  /* Free everything that was allocated and return the error code. */\x0a"
"  tre_mem_destroy(mem);\x0a"
"  if (stack \x21= NULL)\x0a"
"    tre_stack_destroy(stack);\x0a"
"  if (counts \x21= NULL)\x0a"
"    xfree(counts);\x0a"
"  if (offs \x21= NULL)\x0a"
"    xfree(offs);\x0a"
"  preg->TRE_REGEX_T_FIELD = (void *)tnfa;\x0a"
"  tre_free(preg);\x0a"
"  return errcode;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"\x0a"
"\x0a"
"void\x0a"
"tre_free(regex_t *preg)\x0a"
"{\x0a"
"  tre_tnfa_t *tnfa;\x0a"
"  unsigned int i;\x0a"
"  tre_tnfa_transition_t *trans;\x0a"
"\x0a"
"  tnfa = (void *)preg->TRE_REGEX_T_FIELD;\x0a"
"  if (\x21tnfa)\x0a"
"    return;\x0a"
"\x0a"
"  for (i = 0; i < tnfa->num_transitions; i++)\x0a"
"    if (tnfa->transitions\x5bi\x5d.state)\x0a"
"      {\x0a"
"\x09if (tnfa->transitions\x5bi\x5d.tags)\x0a"
"\x09  xfree(tnfa->transitions\x5bi\x5d.tags);\x0a"
"\x09if (tnfa->transitions\x5bi\x5d.neg_classes)\x0a"
"\x09  xfree(tnfa->transitions\x5bi\x5d.neg_classes);\x0a"
"\x09if (tnfa->transitions\x5bi\x5d.params)\x0a"
"\x09  xfree(tnfa->transitions\x5bi\x5d.params);\x0a"
"      }\x0a"
"  if (tnfa->transitions)\x0a"
"    xfree(tnfa->transitions);\x0a"
"\x0a"
"  if (tnfa->initial)\x0a"
"    {\x0a"
"      for (trans = tnfa->initial; trans->state; trans++)\x0a"
"\x09{\x0a"
"\x09  if (trans->tags)\x0a"
"\x09    xfree(trans->tags);\x0a"
"\x09  if (trans->params)\x0a"
"\x09    xfree(trans->params);\x0a"
"\x09}\x0a"
"      xfree(tnfa->initial);\x0a"
"    }\x0a"
"\x0a"
"  if (tnfa->submatch_data)\x0a"
"    {\x0a"
"      for (i = 0; i < tnfa->num_submatches; i++)\x0a"
"\x09if (tnfa->submatch_data\x5bi\x5d.parents)\x0a"
"\x09  xfree(tnfa->submatch_data\x5bi\x5d.parents);\x0a"
"      xfree(tnfa->submatch_data);\x0a"
"    }\x0a"
"\x0a"
"  if (tnfa->tag_directions)\x0a"
"    xfree(tnfa->tag_directions);\x0a"
"  if (tnfa->firstpos_chars)\x0a"
"    xfree(tnfa->firstpos_chars);\x0a"
"  if (tnfa->minimal_tags)\x0a"
"    xfree(tnfa->minimal_tags);\x0a"
"  xfree(tnfa);\x0a"
"}\x0a"
"\x0a"
"char *\x0a"
"tre_version(void)\x0a"
"{\x0a"
"  static char str\x5b""256\x5d;\x0a"
"  char *version;\x0a"
"\x0a"
"  if (str\x5b""0\x5d == 0)\x0a"
"    {\x0a"
"      (void) tre_config(TRE_CONFIG_VERSION, \x26version);\x0a"
"      (void) snprintf(str, sizeof(str), \x22TRE \x25s (BSD)\x22, version);\x0a"
"    }\x0a"
"  return str;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_config(int query, void *result)\x0a"
"{\x0a"
"  int *int_result = result;\x0a"
"  const char **string_result = result;\x0a"
"\x0a"
"  switch (query)\x0a"
"    {\x0a"
"    case TRE_CONFIG_APPROX\x3a\x0a"
"#ifdef TRE_APPROX\x0a"
"      *int_result = 1;\x0a"
"#else /* \x21TRE_APPROX */\x0a"
"      *int_result = 0;\x0a"
"#endif /* \x21TRE_APPROX */\x0a"
"      return REG_OK;\x0a"
"\x0a"
"    case TRE_CONFIG_WCHAR\x3a\x0a"
"#ifdef TRE_WCHAR\x0a"
"      *int_result = 1;\x0a"
"#else /* \x21TRE_WCHAR */\x0a"
"      *int_result = 0;\x0a"
"#endif /* \x21TRE_WCHAR */\x0a"
"      return REG_OK;\x0a"
"\x0a"
"    case TRE_CONFIG_MULTIBYTE\x3a\x0a"
"#ifdef TRE_MULTIBYTE\x0a"
"      *int_result = 1;\x0a"
"#else /* \x21TRE_MULTIBYTE */\x0a"
"      *int_result = 0;\x0a"
"#endif /* \x21TRE_MULTIBYTE */\x0a"
"      return REG_OK;\x0a"
"\x0a"
"    case TRE_CONFIG_SYSTEM_ABI\x3a\x0a"
"#ifdef TRE_CONFIG_SYSTEM_ABI\x0a"
"      *int_result = 1;\x0a"
"#else /* \x21TRE_CONFIG_SYSTEM_ABI */\x0a"
"      *int_result = 0;\x0a"
"#endif /* \x21TRE_CONFIG_SYSTEM_ABI */\x0a"
"      return REG_OK;\x0a"
"\x0a"
"    case TRE_CONFIG_VERSION\x3a\x0a"
"      *string_result = TRE_VERSION;\x0a"
"      return REG_OK;\x0a"
"    }\x0a"
"\x0a"
"  return REG_NOMATCH;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* EOF */\x0a"
"", 60047 ); }