#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_tre_filter_c( 
"/*\x0a"
"  tre-filter.c\x3a Histogram filter to quickly find regexp match candidates\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"/* The idea of this filter is quite simple.  First, let's assume the\x0a"
"   search pattern is a simple string.  In order for a substring of a\x0a"
"   longer string to match the search pattern, it must have the same\x0a"
"   numbers of different characters as the pattern, and those\x0a"
"   characters must occur in the same order as they occur in pattern. */\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"#include <stdio.h>\x0a"
"#include \x22tre-internal.h\x22\x0a"
"#include \x22tre-filter.h\x22\x0a"
"\x0a"
"int\x0a"
"tre_filter_find(const unsigned char *str, size_t len, tre_filter_t *filter)\x0a"
"{\x0a"
"  unsigned short counts\x5b""256\x5d;\x0a"
"  unsigned int i;\x0a"
"  unsigned int window_len = filter->window_len;\x0a"
"  tre_filter_profile_t *profile = filter->profile;\x0a"
"  const unsigned char *str_orig = str;\x0a"
"\x0a"
"  DPRINT((\x22tre_filter_find\x3a \x25.*s\x5cn\x22, len, str));\x0a"
"\x0a"
"  for (i = 0; i < elementsof(counts); i++)\x0a"
"    counts\x5bi\x5d = 0;\x0a"
"\x0a"
"  i = 0;\x0a"
"  while (*str \x26\x26 i < window_len \x26\x26 i < len)\x0a"
"    {\x0a"
"      counts\x5b*str\x5d++;\x0a"
"      i++;\x0a"
"      str++;\x0a"
"      len--;\x0a"
"    }\x0a"
"\x0a"
"  while (len > 0)\x0a"
"    {\x0a"
"      tre_filter_profile_t *p;\x0a"
"      counts\x5b*str\x5d++;\x0a"
"      counts\x5b*(str - window_len)\x5d--;\x0a"
"\x0a"
"      p = profile;\x0a"
"      while (p->ch)\x0a"
"\x09{\x0a"
"\x09  if (counts\x5bp->ch\x5d < p->count)\x0a"
"\x09    break;\x0a"
"\x09  p++;\x0a"
"\x09}\x0a"
"      if (\x21p->ch)\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22""Found possible match at \x25""d\x5cn\x22,\x0a"
"\x09\x09  str - str_orig));\x0a"
"\x09  return str - str_orig;\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22No match so far...\x5cn\x22));\x0a"
"\x09}\x0a"
"      len--;\x0a"
"      str++;\x0a"
"    }\x0a"
"  DPRINT((\x22This string cannot match.\x5cn\x22));\x0a"
"  return -1;\x0a"
"}\x0a"
"", 1644 ); }