#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_tre_match_approx_c( 
"/*\x0a"
"  tre-match-approx.c - TRE approximate regex matching engine\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"\x0a"
"/* AIX requires this to be the first thing in the file.\x09 */\x0a"
"#ifdef TRE_USE_ALLOCA\x0a"
"#ifndef __GNUC__\x0a"
"# if HAVE_ALLOCA_H\x0a"
"#  include <alloca.h>\x0a"
"# else\x0a"
"#  ifdef _AIX\x0a"
" #pragma alloca\x0a"
"#  else\x0a"
"#   ifndef alloca /* predefined by HP cc +Olibcalls */\x0a"
"char *alloca ();\x0a"
"#   endif\x0a"
"#  endif\x0a"
"# endif\x0a"
"#endif\x0a"
"#endif /* TRE_USE_ALLOCA */\x0a"
"\x0a"
"#define __USE_STRING_INLINES\x0a"
"#undef __NO_INLINE__\x0a"
"\x0a"
"#include <assert.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"#include <limits.h>\x0a"
"#ifdef HAVE_WCHAR_H\x0a"
"#include <wchar.h>\x0a"
"#endif /* HAVE_WCHAR_H */\x0a"
"#ifdef HAVE_WCTYPE_H\x0a"
"#include <wctype.h>\x0a"
"#endif /* HAVE_WCTYPE_H */\x0a"
"#ifndef TRE_WCHAR\x0a"
"#include <ctype.h>\x0a"
"#endif /* \x21TRE_WCHAR */\x0a"
"#ifdef HAVE_MALLOC_H\x0a"
"#include <malloc.h>\x0a"
"#endif /* HAVE_MALLOC_H */\x0a"
"\x0a"
"#include \x22tre-internal.h\x22\x0a"
"#include \x22tre-match-utils.h\x22\x0a"
"#include \x22tre.h\x22\x0a"
"#include \x22xmalloc.h\x22\x0a"
"\x0a"
"#define TRE_M_COST\x09""0\x0a"
"#define TRE_M_NUM_INS\x09""1\x0a"
"#define TRE_M_NUM_DEL\x09""2\x0a"
"#define TRE_M_NUM_SUBST 3\x0a"
"#define TRE_M_NUM_ERR\x09""4\x0a"
"#define TRE_M_LAST\x09""5\x0a"
"\x0a"
"#define TRE_M_MAX_DEPTH 3\x0a"
"\x0a"
"typedef struct {\x0a"
"  /* State in the TNFA transition table. */\x0a"
"  tre_tnfa_transition_t *state;\x0a"
"  /* Position in input string. */\x0a"
"  int pos;\x0a"
"  /* Tag values. */\x0a"
"  int *tags;\x0a"
"  /* Matching parameters. */\x0a"
"  regaparams_t params;\x0a"
"  /* Nesting depth of parameters.  This is used as an index in\x0a"
"     the \x60""costs' array. */\x0a"
"  int depth;\x0a"
"  /* Costs and counter values for different parameter nesting depths. */\x0a"
"  int costs\x5bTRE_M_MAX_DEPTH + 1\x5d\x5bTRE_M_LAST\x5d;\x0a"
"} tre_tnfa_approx_reach_t;\x0a"
"\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"/* Prints the \x60reach' array in a readable fashion with DPRINT. */\x0a"
"static void\x0a"
"tre_print_reach(const tre_tnfa_t *tnfa, tre_tnfa_approx_reach_t *reach,\x0a"
"\x09\x09int pos, int num_tags)\x0a"
"{\x0a"
"  int id;\x0a"
"\x0a"
"  /* Print each state on one line. */\x0a"
"  DPRINT((\x22  reach\x3a\x5cn\x22));\x0a"
"  for (id = 0; id < tnfa->num_states; id++)\x0a"
"    {\x0a"
"      int i, j;\x0a"
"      if (reach\x5bid\x5d.pos < pos)\x0a"
"\x09""continue;  /* Not reached. */\x0a"
"      DPRINT((\x22\x09 \x25""03d, costs \x22, id));\x0a"
"      for (i = 0; i <= reach\x5bid\x5d.depth; i++)\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22\x5b\x22));\x0a"
"\x09  for (j = 0; j < TRE_M_LAST; j++)\x0a"
"\x09    {\x0a"
"\x09      DPRINT((\x22\x25""2d\x22, reach\x5bid\x5d.costs\x5bi\x5d\x5bj\x5d));\x0a"
"\x09      if (j + 1 < TRE_M_LAST)\x0a"
"\x09\x09""DPRINT((\x22,\x22));\x0a"
"\x09    }\x0a"
"\x09  DPRINT((\x22\x5d\x22));\x0a"
"\x09  if (i + 1 <= reach\x5bid\x5d.depth)\x0a"
"\x09    DPRINT((\x22, \x22));\x0a"
"\x09}\x0a"
"      DPRINT((\x22\x5cn\x09tags \x22));\x0a"
"      for (i = 0; i < num_tags; i++)\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22\x25""02d\x22, reach\x5bid\x5d.tags\x5bi\x5d));\x0a"
"\x09  if (i + 1 < num_tags)\x0a"
"\x09    DPRINT((\x22,\x22));\x0a"
"\x09}\x0a"
"      DPRINT((\x22\x5cn\x22));\x0a"
"    }\x0a"
"  DPRINT((\x22\x5cn\x22));\x0a"
"}\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
"\x0a"
"/* Sets the matching parameters in \x60reach' to the ones defined in the \x60pa'\x0a"
"   array.  If \x60pa' specifies default values, they are taken from\x0a"
"   \x60""default_params'. */\x0a"
"inline static void\x0a"
"tre_set_params(tre_tnfa_approx_reach_t *reach,\x0a"
"\x09       int *pa, regaparams_t default_params)\x0a"
"{\x0a"
"  int value;\x0a"
"\x0a"
"  /* If depth is increased reset costs and counters to zero for the\x0a"
"     new levels. */\x0a"
"  value = pa\x5bTRE_PARAM_DEPTH\x5d;\x0a"
"  assert(value <= TRE_M_MAX_DEPTH);\x0a"
"  if (value > reach->depth)\x0a"
"    {\x0a"
"      int i, j;\x0a"
"      for (i = reach->depth + 1; i <= value; i++)\x0a"
"\x09""for (j = 0; j < TRE_M_LAST; j++)\x0a"
"\x09  reach->costs\x5bi\x5d\x5bj\x5d = 0;\x0a"
"    }\x0a"
"  reach->depth = value;\x0a"
"\x0a"
"  /* Set insert cost. */\x0a"
"  value = pa\x5bTRE_PARAM_COST_INS\x5d;\x0a"
"  if (value == TRE_PARAM_DEFAULT)\x0a"
"    reach->params.cost_ins = default_params.cost_ins;\x0a"
"  else if (value \x21= TRE_PARAM_UNSET)\x0a"
"    reach->params.cost_ins = value;\x0a"
"\x0a"
"  /* Set delete cost. */\x0a"
"  value = pa\x5bTRE_PARAM_COST_DEL\x5d;\x0a"
"  if (value == TRE_PARAM_DEFAULT)\x0a"
"    reach->params.cost_del = default_params.cost_del;\x0a"
"  else if (value \x21= TRE_PARAM_UNSET)\x0a"
"    reach->params.cost_del = value;\x0a"
"\x0a"
"  /* Set substitute cost. */\x0a"
"  value = pa\x5bTRE_PARAM_COST_SUBST\x5d;\x0a"
"  if (value == TRE_PARAM_DEFAULT)\x0a"
"    reach->params.cost_subst = default_params.cost_subst;\x0a"
"  else\x0a"
"    reach->params.cost_subst = value;\x0a"
"\x0a"
"  /* Set maximum cost. */\x0a"
"  value = pa\x5bTRE_PARAM_COST_MAX\x5d;\x0a"
"  if (value == TRE_PARAM_DEFAULT)\x0a"
"    reach->params.max_cost = default_params.max_cost;\x0a"
"  else if (value \x21= TRE_PARAM_UNSET)\x0a"
"    reach->params.max_cost = value;\x0a"
"\x0a"
"  /* Set maximum inserts. */\x0a"
"  value = pa\x5bTRE_PARAM_MAX_INS\x5d;\x0a"
"  if (value == TRE_PARAM_DEFAULT)\x0a"
"    reach->params.max_ins = default_params.max_ins;\x0a"
"  else if (value \x21= TRE_PARAM_UNSET)\x0a"
"    reach->params.max_ins = value;\x0a"
"\x0a"
"  /* Set maximum deletes. */\x0a"
"  value = pa\x5bTRE_PARAM_MAX_DEL\x5d;\x0a"
"  if (value == TRE_PARAM_DEFAULT)\x0a"
"    reach->params.max_del = default_params.max_del;\x0a"
"  else if (value \x21= TRE_PARAM_UNSET)\x0a"
"    reach->params.max_del = value;\x0a"
"\x0a"
"  /* Set maximum substitutes. */\x0a"
"  value = pa\x5bTRE_PARAM_MAX_SUBST\x5d;\x0a"
"  if (value == TRE_PARAM_DEFAULT)\x0a"
"    reach->params.max_subst = default_params.max_subst;\x0a"
"  else if (value \x21= TRE_PARAM_UNSET)\x0a"
"    reach->params.max_subst = value;\x0a"
"\x0a"
"  /* Set maximum number of errors. */\x0a"
"  value = pa\x5bTRE_PARAM_MAX_ERR\x5d;\x0a"
"  if (value == TRE_PARAM_DEFAULT)\x0a"
"    reach->params.max_err = default_params.max_err;\x0a"
"  else if (value \x21= TRE_PARAM_UNSET)\x0a"
"    reach->params.max_err = value;\x0a"
"}\x0a"
"\x0a"
"reg_errcode_t\x0a"
"tre_tnfa_run_approx(const tre_tnfa_t *tnfa, const void *string, int len,\x0a"
"\x09\x09    tre_str_type_t type, int *match_tags,\x0a"
"\x09\x09    regamatch_t *match, regaparams_t default_params,\x0a"
"\x09\x09    int eflags, int *match_end_ofs)\x0a"
"{\x0a"
"  /* State variables required by GET_NEXT_WCHAR. */\x0a"
"  tre_char_t prev_c = 0, next_c = 0;\x0a"
"  const char *str_byte = string;\x0a"
"  int pos = -1;\x0a"
"  unsigned int pos_add_next = 1;\x0a"
"#ifdef TRE_WCHAR\x0a"
"  const wchar_t *str_wide = string;\x0a"
"#ifdef TRE_MBSTATE\x0a"
"  mbstate_t mbstate;\x0a"
"#endif /* \x21TRE_WCHAR */\x0a"
"#endif /* TRE_WCHAR */\x0a"
"  int reg_notbol = eflags \x26 REG_NOTBOL;\x0a"
"  int reg_noteol = eflags \x26 REG_NOTEOL;\x0a"
"  int reg_newline = tnfa->cflags \x26 REG_NEWLINE;\x0a"
"  int str_user_end = 0;\x0a"
"\x0a"
"  int prev_pos;\x0a"
"\x0a"
"  /* Number of tags. */\x0a"
"  int num_tags;\x0a"
"  /* The reach tables. */\x0a"
"  tre_tnfa_approx_reach_t *reach, *reach_next;\x0a"
"  /* Tag array for temporary use. */\x0a"
"  int *tmp_tags;\x0a"
"\x0a"
"  /* End offset of best match so far, or -1 if no match found yet. */\x0a"
"  int match_eo = -1;\x0a"
"  /* Costs of the match. */\x0a"
"  int match_costs\x5bTRE_M_LAST\x5d;\x0a"
"\x0a"
"  /* Space for temporary data required for matching. */\x0a"
"  unsigned char *buf;\x0a"
"\x0a"
"  int i, id;\x0a"
"\x0a"
"  if (\x21match_tags)\x0a"
"    num_tags = 0;\x0a"
"  else\x0a"
"    num_tags = tnfa->num_tags;\x0a"
"\x0a"
"#ifdef TRE_MBSTATE\x0a"
"  memset(\x26mbstate, '\x5c""0', sizeof(mbstate));\x0a"
"#endif /* TRE_MBSTATE */\x0a"
"\x0a"
"  DPRINT((\x22tre_tnfa_run_approx, input type \x25""d, len \x25""d, eflags \x25""d, \x22\x0a"
"\x09  \x22match_tags \x25p\x5cn\x22,\x0a"
"\x09  type, len, eflags,\x0a"
"\x09  match_tags));\x0a"
"  DPRINT((\x22max cost \x25""d, ins \x25""d, del \x25""d, subst \x25""d\x5cn\x22,\x0a"
"\x09  default_params.max_cost,\x0a"
"\x09  default_params.cost_ins,\x0a"
"\x09  default_params.cost_del,\x0a"
"\x09  default_params.cost_subst));\x0a"
"\x0a"
"  /* Allocate memory for temporary data required for matching.\x09This needs to\x0a"
"     be done for every matching operation to be thread safe.  This allocates\x0a"
"     everything in a single large block from the stack frame using alloca()\x0a"
"     or with malloc() if alloca is unavailable. */\x0a"
"  {\x0a"
"    unsigned char *buf_cursor;\x0a"
"    /* Space needed for one array of tags. */\x0a"
"    int tag_bytes = sizeof(*tmp_tags) * num_tags;\x0a"
"    /* Space needed for one reach table. */\x0a"
"    int reach_bytes = sizeof(*reach_next) * tnfa->num_states;\x0a"
"    /* Total space needed. */\x0a"
"    int total_bytes = reach_bytes * 2 + (tnfa->num_states * 2 + 1 ) * tag_bytes;\x0a"
"    /* Add some extra to make sure we can align the pointers.  The multiplier\x0a"
"       used here must be equal to the number of ALIGN calls below. */\x0a"
"    total_bytes += (sizeof(long) - 1) * 3;\x0a"
"\x0a"
"    /* Allocate the memory. */\x0a"
"#ifdef TRE_USE_ALLOCA\x0a"
"    buf = alloca(total_bytes);\x0a"
"#else /* \x21TRE_USE_ALLOCA */\x0a"
"    buf = xmalloc((unsigned)total_bytes);\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"    if (\x21""buf)\x0a"
"      return REG_ESPACE;\x0a"
"    memset(buf, 0, (size_t)total_bytes);\x0a"
"\x0a"
"    /* Allocate \x60tmp_tags' from \x60""buf'. */\x0a"
"    tmp_tags = (void *)buf;\x0a"
"    buf_cursor = buf + tag_bytes;\x0a"
"    buf_cursor += ALIGN(buf_cursor, long);\x0a"
"\x0a"
"    /* Allocate \x60reach' from \x60""buf'. */\x0a"
"    reach = (void *)buf_cursor;\x0a"
"    buf_cursor += reach_bytes;\x0a"
"    buf_cursor += ALIGN(buf_cursor, long);\x0a"
"\x0a"
"    /* Allocate \x60reach_next' from \x60""buf'. */\x0a"
"    reach_next = (void *)buf_cursor;\x0a"
"    buf_cursor += reach_bytes;\x0a"
"    buf_cursor += ALIGN(buf_cursor, long);\x0a"
"\x0a"
"    /* Allocate tag arrays for \x60reach' and \x60reach_next' from \x60""buf'. */\x0a"
"    for (i = 0; i < tnfa->num_states; i++)\x0a"
"      {\x0a"
"\x09reach\x5bi\x5d.tags = (void *)buf_cursor;\x0a"
"\x09""buf_cursor += tag_bytes;\x0a"
"\x09reach_next\x5bi\x5d.tags = (void *)buf_cursor;\x0a"
"\x09""buf_cursor += tag_bytes;\x0a"
"      }\x0a"
"    assert(buf_cursor <= buf + total_bytes);\x0a"
"  }\x0a"
"\x0a"
"  for (i = 0; i < TRE_M_LAST; i++)\x0a"
"    match_costs\x5bi\x5d = INT_MAX;\x0a"
"\x0a"
"  /* Mark the reach arrays empty. */\x0a"
"  for (i = 0; i < tnfa->num_states; i++)\x0a"
"    reach\x5bi\x5d.pos = reach_next\x5bi\x5d.pos = -2;\x0a"
"\x0a"
"  prev_pos = pos;\x0a"
"  GET_NEXT_WCHAR();\x0a"
"  pos = 0;\x0a"
"\x0a"
"  while (/*CONSTCOND*/(void)1,1)\x0a"
"    {\x0a"
"      DPRINT((\x22\x25""03d\x3a\x25""2lc/\x25""05d\x5cn\x22, pos, (tre_cint_t)next_c, (int)next_c));\x0a"
"\x0a"
"      /* Add initial states to \x60reach_next' if an exact match has not yet\x0a"
"\x09 been found. */\x0a"
"      if (match_costs\x5bTRE_M_COST\x5d > 0)\x0a"
"\x09{\x0a"
"\x09  tre_tnfa_transition_t *trans;\x0a"
"\x09  DPRINT((\x22  init\x22));\x0a"
"\x09  for (trans = tnfa->initial; trans->state; trans++)\x0a"
"\x09    {\x0a"
"\x09      int stateid = trans->state_id;\x0a"
"\x0a"
"\x09      /* If this state is not currently in \x60reach_next', add it\x0a"
"\x09\x09 there. */\x0a"
"\x09      if (reach_next\x5bstateid\x5d.pos < pos)\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (trans->assertions \x26\x26 CHECK_ASSERTIONS(trans->assertions))\x0a"
"\x09\x09    {\x0a"
"\x09\x09      /* Assertions failed, don't add this state. */\x0a"
"\x09\x09      DPRINT((\x22 \x21\x25""d (assert)\x22, stateid));\x0a"
"\x09\x09      continue;\x0a"
"\x09\x09    }\x0a"
"\x09\x09  DPRINT((\x22 \x25""d\x22, stateid));\x0a"
"\x09\x09  reach_next\x5bstateid\x5d.state = trans->state;\x0a"
"\x09\x09  reach_next\x5bstateid\x5d.pos = pos;\x0a"
"\x0a"
"\x09\x09  /* Compute tag values after this transition. */\x0a"
"\x09\x09  for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09    reach_next\x5bstateid\x5d.tags\x5bi\x5d = -1;\x0a"
"\x0a"
"\x09\x09  if (trans->tags)\x0a"
"\x09\x09    for (i = 0; trans->tags\x5bi\x5d >= 0; i++)\x0a"
"\x09\x09      if (trans->tags\x5bi\x5d < num_tags)\x0a"
"\x09\x09\x09reach_next\x5bstateid\x5d.tags\x5btrans->tags\x5bi\x5d\x5d = pos;\x0a"
"\x0a"
"\x09\x09  /* Set the parameters, depth, and costs. */\x0a"
"\x09\x09  reach_next\x5bstateid\x5d.params = default_params;\x0a"
"\x09\x09  reach_next\x5bstateid\x5d.depth = 0;\x0a"
"\x09\x09  for (i = 0; i < TRE_M_LAST; i++)\x0a"
"\x09\x09    reach_next\x5bstateid\x5d.costs\x5b""0\x5d\x5bi\x5d = 0;\x0a"
"\x09\x09  if (trans->params)\x0a"
"\x09\x09    tre_set_params(\x26reach_next\x5bstateid\x5d, trans->params,\x0a"
"\x09\x09\x09\x09   default_params);\x0a"
"\x0a"
"\x09\x09  /* If this is the final state, mark the exact match. */\x0a"
"\x09\x09  if (trans->state == tnfa->final)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      match_eo = pos;\x0a"
"\x09\x09      for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09\x09match_tags\x5bi\x5d = reach_next\x5bstateid\x5d.tags\x5bi\x5d;\x0a"
"\x09\x09      for (i = 0; i < TRE_M_LAST; i++)\x0a"
"\x09\x09\x09match_costs\x5bi\x5d = 0;\x0a"
"\x09\x09    }\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09    DPRINT((\x22\x5cn\x22));\x0a"
"\x09}\x0a"
"\x0a"
"\x0a"
"      /* Handle inserts.  This is done by pretending there's an epsilon\x0a"
"\x09 transition from each state in \x60reach' back to the same state.\x0a"
"\x09 We don't need to worry about the final state here; this will never\x0a"
"\x09 give a better match than what we already have. */\x0a"
"      for (id = 0; id < tnfa->num_states; id++)\x0a"
"\x09{\x0a"
"\x09  int depth;\x0a"
"\x09  int cost, cost0;\x0a"
"\x0a"
"\x09  if (reach\x5bid\x5d.pos \x21= prev_pos)\x0a"
"\x09    {\x0a"
"\x09      DPRINT((\x22\x09 insert\x3a \x25""d not reached\x5cn\x22, id));\x0a"
"\x09      continue;\x09 /* Not reached. */\x0a"
"\x09    }\x0a"
"\x0a"
"\x09  depth = reach\x5bid\x5d.depth;\x0a"
"\x0a"
"\x09  /* Compute and check cost at current depth. */\x0a"
"\x09  cost = reach\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_COST\x5d;\x0a"
"\x09  if (reach\x5bid\x5d.params.cost_ins \x21= TRE_PARAM_UNSET)\x0a"
"\x09    cost += reach\x5bid\x5d.params.cost_ins;\x0a"
"\x09  if (cost > reach\x5bid\x5d.params.max_cost)\x0a"
"\x09    continue;  /* Cost too large. */\x0a"
"\x0a"
"\x09  /* Check number of inserts at current depth. */\x0a"
"\x09  if (reach\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_NUM_INS\x5d + 1\x0a"
"\x09      > reach\x5bid\x5d.params.max_ins)\x0a"
"\x09    continue;  /* Too many inserts. */\x0a"
"\x0a"
"\x09  /* Check total number of errors at current depth. */\x0a"
"\x09  if (reach\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_NUM_ERR\x5d + 1\x0a"
"\x09      > reach\x5bid\x5d.params.max_err)\x0a"
"\x09    continue;  /* Too many errors. */\x0a"
"\x0a"
"\x09  /* Compute overall cost. */\x0a"
"\x09  cost0 = cost;\x0a"
"\x09  if (depth > 0)\x0a"
"\x09    {\x0a"
"\x09      cost0 = reach\x5bid\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d;\x0a"
"\x09      if (reach\x5bid\x5d.params.cost_ins \x21= TRE_PARAM_UNSET)\x0a"
"\x09\x09""cost0 += reach\x5bid\x5d.params.cost_ins;\x0a"
"\x09      else\x0a"
"\x09\x09""cost0 += default_params.cost_ins;\x0a"
"\x09    }\x0a"
"\x0a"
"\x09  DPRINT((\x22  insert\x3a from \x25""d to \x25""d, cost \x25""d\x3a \x22, id, id,\x0a"
"\x09\x09  reach\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_COST\x5d));\x0a"
"\x09  if (reach_next\x5bid\x5d.pos == pos\x0a"
"\x09      \x26\x26 (cost0 >= reach_next\x5bid\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d))\x0a"
"\x09    {\x0a"
"\x09      DPRINT((\x22lose\x5cn\x22));\x0a"
"\x09      continue;\x0a"
"\x09    }\x0a"
"\x09  DPRINT((\x22win\x5cn\x22));\x0a"
"\x0a"
"\x09  /* Copy state, position, tags, parameters, and depth. */\x0a"
"\x09  reach_next\x5bid\x5d.state = reach\x5bid\x5d.state;\x0a"
"\x09  reach_next\x5bid\x5d.pos = pos;\x0a"
"\x09  for (i = 0; i < num_tags; i++)\x0a"
"\x09    reach_next\x5bid\x5d.tags\x5bi\x5d = reach\x5bid\x5d.tags\x5bi\x5d;\x0a"
"\x09  reach_next\x5bid\x5d.params = reach\x5bid\x5d.params;\x0a"
"\x09  reach_next\x5bid\x5d.depth = reach\x5bid\x5d.depth;\x0a"
"\x0a"
"\x09  /* Set the costs after this transition. */\x0a"
"\x09  memcpy(reach_next\x5bid\x5d.costs, reach\x5bid\x5d.costs,\x0a"
"\x09\x09 sizeof(reach_next\x5bid\x5d.costs\x5b""0\x5d\x5b""0\x5d)\x0a"
"\x09\x09 * TRE_M_LAST * (depth + 1));\x0a"
"\x09  reach_next\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_COST\x5d = cost;\x0a"
"\x09  reach_next\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_NUM_INS\x5d++;\x0a"
"\x09  reach_next\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_NUM_ERR\x5d++;\x0a"
"\x09  if (depth > 0)\x0a"
"\x09    {\x0a"
"\x09      reach_next\x5bid\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d = cost0;\x0a"
"\x09      reach_next\x5bid\x5d.costs\x5b""0\x5d\x5bTRE_M_NUM_INS\x5d++;\x0a"
"\x09      reach_next\x5bid\x5d.costs\x5b""0\x5d\x5bTRE_M_NUM_ERR\x5d++;\x0a"
"\x09    }\x0a"
"\x0a"
"\x09}\x0a"
"\x0a"
"\x0a"
"      /* Handle deletes.  This is done by traversing through the whole TNFA\x0a"
"\x09 pretending that all transitions are epsilon transitions, until\x0a"
"\x09 no more states can be reached with better costs. */\x0a"
"      {\x0a"
"\x09/* XXX - dynamic ringbuffer size */\x0a"
"\x09tre_tnfa_approx_reach_t *ringbuffer\x5b""512\x5d;\x0a"
"\x09tre_tnfa_approx_reach_t **deque_start, **deque_end;\x0a"
"\x0a"
"\x09""deque_start = deque_end = ringbuffer;\x0a"
"\x0a"
"\x09/* Add all states in \x60reach_next' to the deque. */\x0a"
"\x09""for (id = 0; id < tnfa->num_states; id++)\x0a"
"\x09  {\x0a"
"\x09    if (reach_next\x5bid\x5d.pos \x21= pos)\x0a"
"\x09      continue;\x0a"
"\x09    *deque_end = \x26reach_next\x5bid\x5d;\x0a"
"\x09    deque_end++;\x0a"
"\x09    assert(deque_end \x21= deque_start);\x0a"
"\x09  }\x0a"
"\x0a"
"\x09/* Repeat until the deque is empty. */\x0a"
"\x09while (deque_end \x21= deque_start)\x0a"
"\x09  {\x0a"
"\x09    tre_tnfa_approx_reach_t *reach_p;\x0a"
"\x09    int depth;\x0a"
"\x09    int cost, cost0;\x0a"
"\x09    tre_tnfa_transition_t *trans;\x0a"
"\x0a"
"\x09    /* Pop the first item off the deque. */\x0a"
"\x09    reach_p = *deque_start;\x0a"
"\x09    id = reach_p - reach_next;\x0a"
"\x09    depth = reach_p->depth;\x0a"
"\x0a"
"\x09    /* Compute cost at current depth. */\x0a"
"\x09    cost = reach_p->costs\x5b""depth\x5d\x5bTRE_M_COST\x5d;\x0a"
"\x09    if (reach_p->params.cost_del \x21= TRE_PARAM_UNSET)\x0a"
"\x09      cost += reach_p->params.cost_del;\x0a"
"\x0a"
"\x09    /* Check cost, number of deletes, and total number of errors\x0a"
"\x09       at current depth. */\x0a"
"\x09    if (cost > reach_p->params.max_cost\x0a"
"\x09\x09\x7c\x7c (reach_p->costs\x5b""depth\x5d\x5bTRE_M_NUM_DEL\x5d + 1\x0a"
"\x09\x09    > reach_p->params.max_del)\x0a"
"\x09\x09\x7c\x7c (reach_p->costs\x5b""depth\x5d\x5bTRE_M_NUM_ERR\x5d + 1\x0a"
"\x09\x09    > reach_p->params.max_err))\x0a"
"\x09      {\x0a"
"\x09\x09/* Too many errors or cost too large. */\x0a"
"\x09\x09""DPRINT((\x22  delete\x3a from \x25""03d\x3a cost too large\x5cn\x22, id));\x0a"
"\x09\x09""deque_start++;\x0a"
"\x09\x09if (deque_start >= (ringbuffer + 512))\x0a"
"\x09\x09  deque_start = ringbuffer;\x0a"
"\x09\x09""continue;\x0a"
"\x09      }\x0a"
"\x0a"
"\x09    /* Compute overall cost. */\x0a"
"\x09    cost0 = cost;\x0a"
"\x09    if (depth > 0)\x0a"
"\x09      {\x0a"
"\x09\x09""cost0 = reach_p->costs\x5b""0\x5d\x5bTRE_M_COST\x5d;\x0a"
"\x09\x09if (reach_p->params.cost_del \x21= TRE_PARAM_UNSET)\x0a"
"\x09\x09  cost0 += reach_p->params.cost_del;\x0a"
"\x09\x09""else\x0a"
"\x09\x09  cost0 += default_params.cost_del;\x0a"
"\x09      }\x0a"
"\x0a"
"\x09    for (trans = reach_p->state; trans->state; trans++)\x0a"
"\x09      {\x0a"
"\x09\x09int dest_id = trans->state_id;\x0a"
"\x09\x09""DPRINT((\x22  delete\x3a from \x25""03d to \x25""03d, cost \x25""d (\x25""d)\x3a \x22,\x0a"
"\x09\x09\x09id, dest_id, cost0, reach_p->params.max_cost));\x0a"
"\x0a"
"\x09\x09if (trans->assertions \x26\x26 CHECK_ASSERTIONS(trans->assertions))\x0a"
"\x09\x09  {\x0a"
"\x09\x09    DPRINT((\x22""assertion failed\x5cn\x22));\x0a"
"\x09\x09    continue;\x0a"
"\x09\x09  }\x0a"
"\x0a"
"\x09\x09/* Compute tag values after this transition. */\x0a"
"\x09\x09""for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09  tmp_tags\x5bi\x5d = reach_p->tags\x5bi\x5d;\x0a"
"\x09\x09if (trans->tags)\x0a"
"\x09\x09  for (i = 0; trans->tags\x5bi\x5d >= 0; i++)\x0a"
"\x09\x09    if (trans->tags\x5bi\x5d < num_tags)\x0a"
"\x09\x09      tmp_tags\x5btrans->tags\x5bi\x5d\x5d = pos;\x0a"
"\x0a"
"\x09\x09/* If another path has also reached this state, choose the one\x0a"
"\x09\x09   with the smallest cost or best tags if costs are equal. */\x0a"
"\x09\x09if (reach_next\x5b""dest_id\x5d.pos == pos\x0a"
"\x09\x09    \x26\x26 (cost0 > reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d\x0a"
"\x09\x09\x09\x7c\x7c (cost0 == reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d\x0a"
"\x09\x09\x09    \x26\x26 (\x21match_tags\x0a"
"\x09\x09\x09\x09\x7c\x7c \x21tre_tag_order(num_tags,\x0a"
"\x09\x09\x09\x09\x09\x09  tnfa->tag_directions,\x0a"
"\x09\x09\x09\x09\x09\x09  tmp_tags,\x0a"
"\x09\x09\x09\x09\x09\x09  reach_next\x5b""dest_id\x5d.tags)))))\x0a"
"\x09\x09  {\x0a"
"\x09\x09    DPRINT((\x22lose, cost0 \x25""d, have \x25""d\x5cn\x22,\x0a"
"\x09\x09\x09    cost0, reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d));\x0a"
"\x09\x09    continue;\x0a"
"\x09\x09  }\x0a"
"\x09\x09""DPRINT((\x22win\x5cn\x22));\x0a"
"\x0a"
"\x09\x09/* Set state, position, tags, parameters, depth, and costs. */\x0a"
"\x09\x09reach_next\x5b""dest_id\x5d.state = trans->state;\x0a"
"\x09\x09reach_next\x5b""dest_id\x5d.pos = pos;\x0a"
"\x09\x09""for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09  reach_next\x5b""dest_id\x5d.tags\x5bi\x5d = tmp_tags\x5bi\x5d;\x0a"
"\x0a"
"\x09\x09reach_next\x5b""dest_id\x5d.params = reach_p->params;\x0a"
"\x09\x09if (trans->params)\x0a"
"\x09\x09  tre_set_params(\x26reach_next\x5b""dest_id\x5d, trans->params,\x0a"
"\x09\x09\x09\x09 default_params);\x0a"
"\x0a"
"\x09\x09reach_next\x5b""dest_id\x5d.depth = reach_p->depth;\x0a"
"\x09\x09memcpy(\x26reach_next\x5b""dest_id\x5d.costs,\x0a"
"\x09\x09       reach_p->costs,\x0a"
"\x09\x09       sizeof(reach_p->costs\x5b""0\x5d\x5b""0\x5d)\x0a"
"\x09\x09       * TRE_M_LAST * (depth + 1));\x0a"
"\x09\x09reach_next\x5b""dest_id\x5d.costs\x5b""depth\x5d\x5bTRE_M_COST\x5d = cost;\x0a"
"\x09\x09reach_next\x5b""dest_id\x5d.costs\x5b""depth\x5d\x5bTRE_M_NUM_DEL\x5d++;\x0a"
"\x09\x09reach_next\x5b""dest_id\x5d.costs\x5b""depth\x5d\x5bTRE_M_NUM_ERR\x5d++;\x0a"
"\x09\x09if (depth > 0)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d = cost0;\x0a"
"\x09\x09    reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_NUM_DEL\x5d++;\x0a"
"\x09\x09    reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_NUM_ERR\x5d++;\x0a"
"\x09\x09  }\x0a"
"\x0a"
"\x09\x09if (trans->state == tnfa->final\x0a"
"\x09\x09    \x26\x26 (match_eo < 0\x0a"
"\x09\x09\x09\x7c\x7c match_costs\x5bTRE_M_COST\x5d > cost0\x0a"
"\x09\x09\x09\x7c\x7c (match_costs\x5bTRE_M_COST\x5d == cost0\x0a"
"\x09\x09\x09    \x26\x26 (num_tags > 0\x0a"
"\x09\x09\x09\x09\x26\x26 tmp_tags\x5b""0\x5d <= match_tags\x5b""0\x5d))))\x0a"
"\x09\x09  {\x0a"
"\x09\x09    DPRINT((\x22\x09 setting new match at \x25""d, cost \x25""d\x5cn\x22,\x0a"
"\x09\x09\x09    pos, cost0));\x0a"
"\x09\x09    match_eo = pos;\x0a"
"\x09\x09    memcpy(match_costs, reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d,\x0a"
"\x09\x09\x09   sizeof(match_costs\x5b""0\x5d) * TRE_M_LAST);\x0a"
"\x09\x09    for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09      match_tags\x5bi\x5d = tmp_tags\x5bi\x5d;\x0a"
"\x09\x09  }\x0a"
"\x0a"
"\x09\x09/* Add to the end of the deque. */\x0a"
"\x09\x09*deque_end = \x26reach_next\x5b""dest_id\x5d;\x0a"
"\x09\x09""deque_end++;\x0a"
"\x09\x09if (deque_end >= (ringbuffer + 512))\x0a"
"\x09\x09  deque_end = ringbuffer;\x0a"
"\x09\x09""assert(deque_end \x21= deque_start);\x0a"
"\x09      }\x0a"
"\x09    deque_start++;\x0a"
"\x09    if (deque_start >= (ringbuffer + 512))\x0a"
"\x09      deque_start = ringbuffer;\x0a"
"\x09  }\x0a"
"\x0a"
"      }\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"      tre_print_reach(tnfa, reach_next, pos, num_tags);\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
"      /* Check for end of string. */\x0a"
"      if (len < 0)\x0a"
"\x09{\x0a"
"\x09  if (type == STR_USER)\x0a"
"\x09    {\x0a"
"\x09      if (str_user_end)\x0a"
"\x09\x09""break;\x0a"
"\x09    }\x0a"
"\x09  else if (next_c == L'\x5c""0')\x0a"
"\x09    break;\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  if (pos >= len)\x0a"
"\x09    break;\x0a"
"\x09}\x0a"
"\x0a"
"      prev_pos = pos;\x0a"
"      GET_NEXT_WCHAR();\x0a"
"\x0a"
"      /* Swap \x60reach' and \x60reach_next'. */\x0a"
"      {\x0a"
"\x09tre_tnfa_approx_reach_t *tmp;\x0a"
"\x09tmp = reach;\x0a"
"\x09reach = reach_next;\x0a"
"\x09reach_next = tmp;\x0a"
"      }\x0a"
"\x0a"
"      /* Handle exact matches and substitutions. */\x0a"
"      for (id = 0; id < tnfa->num_states; id++)\x0a"
"\x09{\x0a"
"\x09  tre_tnfa_transition_t *trans;\x0a"
"\x0a"
"\x09  if (reach\x5bid\x5d.pos < prev_pos)\x0a"
"\x09    continue;  /* Not reached. */\x0a"
"\x09  for (trans = reach\x5bid\x5d.state; trans->state; trans++)\x0a"
"\x09    {\x0a"
"\x09      int dest_id;\x0a"
"\x09      int depth;\x0a"
"\x09      int cost, cost0, err;\x0a"
"\x0a"
"\x09      if (trans->assertions\x0a"
"\x09\x09  \x26\x26 (CHECK_ASSERTIONS(trans->assertions)\x0a"
"\x09\x09      \x7c\x7c CHECK_CHAR_CLASSES(trans, tnfa, eflags)))\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22  exact,  from \x25""d\x3a assert failed\x5cn\x22, id));\x0a"
"\x09\x09  continue;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      depth = reach\x5bid\x5d.depth;\x0a"
"\x09      dest_id = trans->state_id;\x0a"
"\x0a"
"\x09      cost = reach\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_COST\x5d;\x0a"
"\x09      cost0 = reach\x5bid\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d;\x0a"
"\x09      err = 0;\x0a"
"\x0a"
"\x09      if (trans->code_min > (tre_cint_t)prev_c\x0a"
"\x09\x09  \x7c\x7c trans->code_max < (tre_cint_t)prev_c)\x0a"
"\x09\x09{\x0a"
"\x09\x09  /* Handle substitutes.  The required character was not in\x0a"
"\x09\x09     the string, so match it in place of whatever was supposed\x0a"
"\x09\x09     to be there and increase costs accordingly. */\x0a"
"\x09\x09  err = 1;\x0a"
"\x0a"
"\x09\x09  /* Compute and check cost at current depth. */\x0a"
"\x09\x09  cost = reach\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_COST\x5d;\x0a"
"\x09\x09  if (reach\x5bid\x5d.params.cost_subst \x21= TRE_PARAM_UNSET)\x0a"
"\x09\x09    cost += reach\x5bid\x5d.params.cost_subst;\x0a"
"\x09\x09  if (cost > reach\x5bid\x5d.params.max_cost)\x0a"
"\x09\x09    continue; /* Cost too large. */\x0a"
"\x0a"
"\x09\x09  /* Check number of substitutes at current depth. */\x0a"
"\x09\x09  if (reach\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_NUM_SUBST\x5d + 1\x0a"
"\x09\x09      > reach\x5bid\x5d.params.max_subst)\x0a"
"\x09\x09    continue; /* Too many substitutes. */\x0a"
"\x0a"
"\x09\x09  /* Check total number of errors at current depth. */\x0a"
"\x09\x09  if (reach\x5bid\x5d.costs\x5b""depth\x5d\x5bTRE_M_NUM_ERR\x5d + 1\x0a"
"\x09\x09      > reach\x5bid\x5d.params.max_err)\x0a"
"\x09\x09    continue; /* Too many errors. */\x0a"
"\x0a"
"\x09\x09  /* Compute overall cost. */\x0a"
"\x09\x09  cost0 = cost;\x0a"
"\x09\x09  if (depth > 0)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      cost0 = reach\x5bid\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d;\x0a"
"\x09\x09      if (reach\x5bid\x5d.params.cost_subst \x21= TRE_PARAM_UNSET)\x0a"
"\x09\x09\x09""cost0 += reach\x5bid\x5d.params.cost_subst;\x0a"
"\x09\x09      else\x0a"
"\x09\x09\x09""cost0 += default_params.cost_subst;\x0a"
"\x09\x09    }\x0a"
"\x09\x09  DPRINT((\x22  subst,  from \x25""03d to \x25""03d, cost \x25""d\x3a \x22,\x0a"
"\x09\x09\x09  id, dest_id, cost0));\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09""DPRINT((\x22  exact,  from \x25""03d to \x25""03d, cost \x25""d\x3a \x22,\x0a"
"\x09\x09\x09id, dest_id, cost0));\x0a"
"\x0a"
"\x09      /* Compute tag values after this transition. */\x0a"
"\x09      for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09tmp_tags\x5bi\x5d = reach\x5bid\x5d.tags\x5bi\x5d;\x0a"
"\x09      if (trans->tags)\x0a"
"\x09\x09""for (i = 0; trans->tags\x5bi\x5d >= 0; i++)\x0a"
"\x09\x09  if (trans->tags\x5bi\x5d < num_tags)\x0a"
"\x09\x09    tmp_tags\x5btrans->tags\x5bi\x5d\x5d = pos;\x0a"
"\x0a"
"\x09      /* If another path has also reached this state, choose the\x0a"
"\x09\x09 one with the smallest cost or best tags if costs are equal. */\x0a"
"\x09      if (reach_next\x5b""dest_id\x5d.pos == pos\x0a"
"\x09\x09  \x26\x26 (cost0 > reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d\x0a"
"\x09\x09      \x7c\x7c (cost0 == reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d\x0a"
"\x09\x09\x09  \x26\x26 \x21tre_tag_order(num_tags, tnfa->tag_directions,\x0a"
"\x09\x09\x09\x09\x09    tmp_tags,\x0a"
"\x09\x09\x09\x09\x09    reach_next\x5b""dest_id\x5d.tags))))\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22lose\x5cn\x22));\x0a"
"\x09\x09  continue;\x0a"
"\x09\x09}\x0a"
"\x09      DPRINT((\x22win \x25""d \x25""d\x5cn\x22,\x0a"
"\x09\x09      reach_next\x5b""dest_id\x5d.pos,\x0a"
"\x09\x09      reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d));\x0a"
"\x0a"
"\x09      /* Set state, position, tags, and depth. */\x0a"
"\x09      reach_next\x5b""dest_id\x5d.state = trans->state;\x0a"
"\x09      reach_next\x5b""dest_id\x5d.pos = pos;\x0a"
"\x09      for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09reach_next\x5b""dest_id\x5d.tags\x5bi\x5d = tmp_tags\x5bi\x5d;\x0a"
"\x09      reach_next\x5b""dest_id\x5d.depth = reach\x5bid\x5d.depth;\x0a"
"\x0a"
"\x09      /* Set parameters. */\x0a"
"\x09      reach_next\x5b""dest_id\x5d.params = reach\x5bid\x5d.params;\x0a"
"\x09      if (trans->params)\x0a"
"\x09\x09tre_set_params(\x26reach_next\x5b""dest_id\x5d, trans->params,\x0a"
"\x09\x09\x09       default_params);\x0a"
"\x0a"
"\x09      /* Set the costs after this transition. */\x0a"
"\x09\x09memcpy(\x26reach_next\x5b""dest_id\x5d.costs,\x0a"
"\x09\x09       reach\x5bid\x5d.costs,\x0a"
"\x09\x09       sizeof(reach\x5bid\x5d.costs\x5b""0\x5d\x5b""0\x5d)\x0a"
"\x09\x09       * TRE_M_LAST * (depth + 1));\x0a"
"\x09      reach_next\x5b""dest_id\x5d.costs\x5b""depth\x5d\x5bTRE_M_COST\x5d = cost;\x0a"
"\x09      reach_next\x5b""dest_id\x5d.costs\x5b""depth\x5d\x5bTRE_M_NUM_SUBST\x5d += err;\x0a"
"\x09      reach_next\x5b""dest_id\x5d.costs\x5b""depth\x5d\x5bTRE_M_NUM_ERR\x5d += err;\x0a"
"\x09      if (depth > 0)\x0a"
"\x09\x09{\x0a"
"\x09\x09  reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_COST\x5d = cost0;\x0a"
"\x09\x09  reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_NUM_SUBST\x5d += err;\x0a"
"\x09\x09  reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bTRE_M_NUM_ERR\x5d += err;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      if (trans->state == tnfa->final\x0a"
"\x09\x09  \x26\x26 (match_eo < 0\x0a"
"\x09\x09      \x7c\x7c cost0 < match_costs\x5bTRE_M_COST\x5d\x0a"
"\x09\x09      \x7c\x7c (cost0 == match_costs\x5bTRE_M_COST\x5d\x0a"
"\x09\x09\x09  \x26\x26 num_tags > 0 \x26\x26 tmp_tags\x5b""0\x5d <= match_tags\x5b""0\x5d)))\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22    setting new match at \x25""d, cost \x25""d\x5cn\x22,\x0a"
"\x09\x09\x09  pos, cost0));\x0a"
"\x09\x09  match_eo = pos;\x0a"
"\x09\x09  for (i = 0; i < TRE_M_LAST; i++)\x0a"
"\x09\x09    match_costs\x5bi\x5d = reach_next\x5b""dest_id\x5d.costs\x5b""0\x5d\x5bi\x5d;\x0a"
"\x09\x09  for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09    match_tags\x5bi\x5d = tmp_tags\x5bi\x5d;\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  DPRINT((\x22match end offset = \x25""d, match cost = \x25""d\x5cn\x22, match_eo,\x0a"
"\x09  match_costs\x5bTRE_M_COST\x5d));\x0a"
"\x0a"
"#ifndef TRE_USE_ALLOCA\x0a"
"  if (buf)\x0a"
"    xfree(buf);\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"\x0a"
"  match->cost = match_costs\x5bTRE_M_COST\x5d;\x0a"
"  match->num_ins = match_costs\x5bTRE_M_NUM_INS\x5d;\x0a"
"  match->num_del = match_costs\x5bTRE_M_NUM_DEL\x5d;\x0a"
"  match->num_subst = match_costs\x5bTRE_M_NUM_SUBST\x5d;\x0a"
"  *match_end_ofs = match_eo;\x0a"
"\x0a"
"  return match_eo >= 0 \x3f REG_OK \x3a REG_NOMATCH;\x0a"
"}\x0a"
"", 23210 ); }