#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_tre_match_backtrack_c( 
"/*\x0a"
"  tre-match-backtrack.c - TRE backtracking regex matching engine\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"/*\x0a"
"  This matcher is for regexps that use back referencing.  Regexp matching\x0a"
"  with back referencing is an NP-complete problem on the number of back\x0a"
"  references.  The easiest way to match them is to use a backtracking\x0a"
"  routine which basically goes through all possible paths in the TNFA\x0a"
"  and chooses the one which results in the best (leftmost and longest)\x0a"
"  match.  This can be spectacularly expensive and may run out of stack\x0a"
"  space, but there really is no better known generic algorithm.\x09 Quoting\x0a"
"  Henry Spencer from comp.compilers\x3a\x0a"
"  <URL\x3a http\x3a//compilers.iecc.com/comparch/article/93-03-102>\x0a"
"\x0a"
"    POSIX.2 REs require longest match, which is really exciting to\x0a"
"    implement since the obsolete (\x22""basic\x22) variant also includes\x0a"
"    \x5c<digit>.  I haven't found a better way of tackling this than doing\x0a"
"    a preliminary match using a DFA (or simulation) on a modified RE\x0a"
"    that just replicates subREs for \x5c<digit>, and then doing a\x0a"
"    backtracking match to determine whether the subRE matches were\x0a"
"    right.  This can be rather slow, but I console myself with the\x0a"
"    thought that people who use \x5c<digit> deserve very slow execution.\x0a"
"    (Pun unintentional but very appropriate.)\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"\x0a"
"#ifdef TRE_USE_ALLOCA\x0a"
"/* AIX requires this to be the first thing in the file.\x09 */\x0a"
"#ifndef __GNUC__\x0a"
"# if HAVE_ALLOCA_H\x0a"
"#  include <alloca.h>\x0a"
"# else\x0a"
"#  ifdef _AIX\x0a"
" #pragma alloca\x0a"
"#  else\x0a"
"#   ifndef alloca /* predefined by HP cc +Olibcalls */\x0a"
"char *alloca ();\x0a"
"#   endif\x0a"
"#  endif\x0a"
"# endif\x0a"
"#endif\x0a"
"#endif /* TRE_USE_ALLOCA */\x0a"
"\x0a"
"#include <assert.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"#ifdef HAVE_WCHAR_H\x0a"
"#include <wchar.h>\x0a"
"#endif /* HAVE_WCHAR_H */\x0a"
"#ifdef HAVE_WCTYPE_H\x0a"
"#include <wctype.h>\x0a"
"#endif /* HAVE_WCTYPE_H */\x0a"
"#ifndef TRE_WCHAR\x0a"
"#include <ctype.h>\x0a"
"#endif /* \x21TRE_WCHAR */\x0a"
"#ifdef HAVE_MALLOC_H\x0a"
"#include <malloc.h>\x0a"
"#endif /* HAVE_MALLOC_H */\x0a"
"\x0a"
"#include \x22tre-internal.h\x22\x0a"
"#include \x22tre-mem.h\x22\x0a"
"#include \x22tre-match-utils.h\x22\x0a"
"#include \x22tre.h\x22\x0a"
"#include \x22xmalloc.h\x22\x0a"
"\x0a"
"typedef struct {\x0a"
"  int pos;\x0a"
"  const char *str_byte;\x0a"
"#ifdef TRE_WCHAR\x0a"
"  const wchar_t *str_wide;\x0a"
"#endif /* TRE_WCHAR */\x0a"
"  tre_tnfa_transition_t *state;\x0a"
"  int state_id;\x0a"
"  int next_c;\x0a"
"  int *tags;\x0a"
"#ifdef TRE_MBSTATE\x0a"
"  mbstate_t mbstate;\x0a"
"#endif /* TRE_MBSTATE */\x0a"
"} tre_backtrack_item_t;\x0a"
"\x0a"
"typedef struct tre_backtrack_struct {\x0a"
"  tre_backtrack_item_t item;\x0a"
"  struct tre_backtrack_struct *prev;\x0a"
"  struct tre_backtrack_struct *next;\x0a"
"} *tre_backtrack_t;\x0a"
"\x0a"
"#ifdef TRE_WCHAR\x0a"
"#define BT_STACK_WIDE_IN(_str_wide)\x09stack->item.str_wide = (_str_wide)\x0a"
"#define BT_STACK_WIDE_OUT\x09\x09(str_wide) = stack->item.str_wide\x0a"
"#else /* \x21TRE_WCHAR */\x0a"
"#define BT_STACK_WIDE_IN(_str_wide)\x0a"
"#define BT_STACK_WIDE_OUT\x0a"
"#endif /* \x21TRE_WCHAR */\x0a"
"\x0a"
"#ifdef TRE_MBSTATE\x0a"
"#define BT_STACK_MBSTATE_IN  stack->item.mbstate = (mbstate)\x0a"
"#define BT_STACK_MBSTATE_OUT (mbstate) = stack->item.mbstate\x0a"
"#else /* \x21TRE_MBSTATE */\x0a"
"#define BT_STACK_MBSTATE_IN\x0a"
"#define BT_STACK_MBSTATE_OUT\x0a"
"#endif /* \x21TRE_MBSTATE */\x0a"
"\x0a"
"\x0a"
"#ifdef TRE_USE_ALLOCA\x0a"
"#define tre_bt_mem_new\x09\x09  tre_mem_newa\x0a"
"#define tre_bt_mem_alloc\x09  tre_mem_alloca\x0a"
"#define tre_bt_mem_destroy(obj)\x09  do { } while (0,0)\x0a"
"#else /* \x21TRE_USE_ALLOCA */\x0a"
"#define tre_bt_mem_new\x09\x09  tre_mem_new\x0a"
"#define tre_bt_mem_alloc\x09  tre_mem_alloc\x0a"
"#define tre_bt_mem_destroy\x09  tre_mem_destroy\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"\x0a"
"\x0a"
"#define BT_STACK_PUSH(_pos, _str_byte, _str_wide, _state, _state_id, _next_c, _tags, _mbstate) \x5c\x0a"
"  do\x09\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"    {\x09\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      int i;\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      if (\x21stack->next)\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09{\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09  tre_backtrack_t s;\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09  s = tre_bt_mem_alloc(mem, sizeof(*s));\x09\x09\x09      \x5c\x0a"
"\x09  if (\x21s)\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09    {\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09      tre_bt_mem_destroy(mem);\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09      if (tags)\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09\x09xfree(tags);\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09      if (pmatch)\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09\x09xfree(pmatch);\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09      if (states_seen)\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09\x09xfree(states_seen);\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09      return REG_ESPACE;\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09    }\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09  s->prev = stack;\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09  s->next = NULL;\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09  s->item.tags = tre_bt_mem_alloc(mem,\x09\x09\x09\x09      \x5c\x0a"
"\x09\x09\x09\x09\x09  sizeof(*tags) * tnfa->num_tags);    \x5c\x0a"
"\x09  if (\x21s->item.tags)\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09    {\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09      tre_bt_mem_destroy(mem);\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09      if (tags)\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09\x09xfree(tags);\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09      if (pmatch)\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09\x09xfree(pmatch);\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09      if (states_seen)\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09\x09xfree(states_seen);\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09      return REG_ESPACE;\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09    }\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09  stack->next = s;\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09  stack = s;\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09}\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      else\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"\x09stack = stack->next;\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      stack->item.pos = (_pos);\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      stack->item.str_byte = (_str_byte);\x09\x09\x09\x09      \x5c\x0a"
"      BT_STACK_WIDE_IN(_str_wide);\x09\x09\x09\x09\x09      \x5c\x0a"
"      stack->item.state = (_state);\x09\x09\x09\x09\x09      \x5c\x0a"
"      stack->item.state_id = (_state_id);\x09\x09\x09\x09      \x5c\x0a"
"      stack->item.next_c = (_next_c);\x09\x09\x09\x09\x09      \x5c\x0a"
"      for (i = 0; i < tnfa->num_tags; i++)\x09\x09\x09\x09      \x5c\x0a"
"\x09stack->item.tags\x5bi\x5d = (_tags)\x5bi\x5d;\x09\x09\x09\x09      \x5c\x0a"
"      BT_STACK_MBSTATE_IN;\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"    }\x09\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"  while (/*CONSTCOND*/(void)0,0)\x0a"
"\x0a"
"#define BT_STACK_POP()\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"  do\x09\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"    {\x09\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      int i;\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      assert(stack->prev);\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      pos = stack->item.pos;\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      if (type == STR_USER)                                                   \x5c\x0a"
"        str_source->rewind(pos + pos_add_next, str_source->context);          \x5c\x0a"
"      str_byte = stack->item.str_byte;\x09\x09\x09\x09\x09      \x5c\x0a"
"      BT_STACK_WIDE_OUT;\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      state = stack->item.state;\x09\x09\x09\x09\x09      \x5c\x0a"
"      next_c = (tre_char_t) stack->item.next_c;\x09\x09\x09\x09\x09      \x5c\x0a"
"      for (i = 0; i < tnfa->num_tags; i++)\x09\x09\x09\x09      \x5c\x0a"
"\x09tags\x5bi\x5d = stack->item.tags\x5bi\x5d;\x09\x09\x09\x09\x09      \x5c\x0a"
"      BT_STACK_MBSTATE_OUT;\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"      stack = stack->prev;\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"    }\x09\x09\x09\x09\x09\x09\x09\x09\x09      \x5c\x0a"
"  while (/*CONSTCOND*/(void)0,0)\x0a"
"\x0a"
"#undef MIN\x0a"
"#define MIN(a, b) ((a) <= (b) \x3f (a) \x3a (b))\x0a"
"\x0a"
"reg_errcode_t\x0a"
"tre_tnfa_run_backtrack(const tre_tnfa_t *tnfa, const void *string,\x0a"
"\x09\x09       int len, tre_str_type_t type, int *match_tags,\x0a"
"\x09\x09       int eflags, int *match_end_ofs)\x0a"
"{\x0a"
"  /* State variables required by GET_NEXT_WCHAR. */\x0a"
"  tre_char_t prev_c = 0, next_c = 0;\x0a"
"  const char *str_byte = string;\x0a"
"  int pos = 0;\x0a"
"  unsigned int pos_add_next = 1;\x0a"
"#ifdef TRE_WCHAR\x0a"
"  const wchar_t *str_wide = string;\x0a"
"#ifdef TRE_MBSTATE\x0a"
"  mbstate_t mbstate;\x0a"
"#endif /* TRE_MBSTATE */\x0a"
"#endif /* TRE_WCHAR */\x0a"
"  int reg_notbol = eflags \x26 REG_NOTBOL;\x0a"
"  int reg_noteol = eflags \x26 REG_NOTEOL;\x0a"
"  int reg_newline = tnfa->cflags \x26 REG_NEWLINE;\x0a"
"  int str_user_end = 0;\x0a"
"\x0a"
"  /* These are used to remember the necessary values of the above\x0a"
"     variables to return to the position where the current search\x0a"
"     started from. */\x0a"
"  int next_c_start;\x0a"
"  const char *str_byte_start;\x0a"
"  int pos_start = -1;\x0a"
"#ifdef TRE_WCHAR\x0a"
"  const wchar_t *str_wide_start;\x0a"
"#endif /* TRE_WCHAR */\x0a"
"#ifdef TRE_MBSTATE\x0a"
"  mbstate_t mbstate_start;\x0a"
"#endif /* TRE_MBSTATE */\x0a"
"\x0a"
"  /* End offset of best match so far, or -1 if no match found yet. */\x0a"
"  int match_eo = -1;\x0a"
"  /* Tag arrays. */\x0a"
"  int *next_tags, *tags = NULL;\x0a"
"  /* Current TNFA state. */\x0a"
"  tre_tnfa_transition_t *state;\x0a"
"  int *states_seen = NULL;\x0a"
"\x0a"
"  /* Memory allocator to for allocating the backtracking stack. */\x0a"
"  tre_mem_t mem = tre_bt_mem_new();\x0a"
"\x0a"
"  /* The backtracking stack. */\x0a"
"  tre_backtrack_t stack;\x0a"
"\x0a"
"  tre_tnfa_transition_t *trans_i;\x0a"
"  regmatch_t *pmatch = NULL;\x0a"
"  int ret;\x0a"
"\x0a"
"#ifdef TRE_MBSTATE\x0a"
"  memset(\x26mbstate, '\x5c""0', sizeof(mbstate));\x0a"
"#endif /* TRE_MBSTATE */\x0a"
"\x0a"
"  if (\x21mem)\x0a"
"    return REG_ESPACE;\x0a"
"  stack = tre_bt_mem_alloc(mem, sizeof(*stack));\x0a"
"  if (\x21stack)\x0a"
"    {\x0a"
"      ret = REG_ESPACE;\x0a"
"      goto error_exit;\x0a"
"    }\x0a"
"  stack->prev = NULL;\x0a"
"  stack->next = NULL;\x0a"
"\x0a"
"  DPRINT((\x22tnfa_execute_backtrack, input type \x25""d\x5cn\x22, type));\x0a"
"  DPRINT((\x22len = \x25""d\x5cn\x22, len));\x0a"
"\x0a"
"#ifdef TRE_USE_ALLOCA\x0a"
"  tags = alloca(sizeof(*tags) * tnfa->num_tags);\x0a"
"  pmatch = alloca(sizeof(*pmatch) * tnfa->num_submatches);\x0a"
"  states_seen = alloca(sizeof(*states_seen) * tnfa->num_states);\x0a"
"#else /* \x21TRE_USE_ALLOCA */\x0a"
"  if (tnfa->num_tags)\x0a"
"    {\x0a"
"      tags = xmalloc(sizeof(*tags) * tnfa->num_tags);\x0a"
"      if (\x21tags)\x0a"
"\x09{\x0a"
"\x09  ret = REG_ESPACE;\x0a"
"\x09  goto error_exit;\x0a"
"\x09}\x0a"
"    }\x0a"
"  if (tnfa->num_submatches)\x0a"
"    {\x0a"
"      pmatch = xmalloc(sizeof(*pmatch) * tnfa->num_submatches);\x0a"
"      if (\x21pmatch)\x0a"
"\x09{\x0a"
"\x09  ret = REG_ESPACE;\x0a"
"\x09  goto error_exit;\x0a"
"\x09}\x0a"
"    }\x0a"
"  if (tnfa->num_states)\x0a"
"    {\x0a"
"      states_seen = xmalloc(sizeof(*states_seen) * tnfa->num_states);\x0a"
"      if (\x21states_seen)\x0a"
"\x09{\x0a"
"\x09  ret = REG_ESPACE;\x0a"
"\x09  goto error_exit;\x0a"
"\x09}\x0a"
"    }\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"\x0a"
" retry\x3a\x0a"
"  {\x0a"
"    int i;\x0a"
"    for (i = 0; i < tnfa->num_tags; i++)\x0a"
"      {\x0a"
"\x09tags\x5bi\x5d = -1;\x0a"
"\x09if (match_tags)\x0a"
"\x09  match_tags\x5bi\x5d = -1;\x0a"
"      }\x0a"
"    for (i = 0; i < tnfa->num_states; i++)\x0a"
"      states_seen\x5bi\x5d = 0;\x0a"
"  }\x0a"
"\x0a"
"  state = NULL;\x0a"
"  pos = pos_start;\x0a"
"  if (type == STR_USER)\x0a"
"    str_source->rewind(pos + pos_add_next, str_source->context);\x0a"
"  GET_NEXT_WCHAR();\x0a"
"  pos_start = pos;\x0a"
"  next_c_start = next_c;\x0a"
"  str_byte_start = str_byte;\x0a"
"#ifdef TRE_WCHAR\x0a"
"  str_wide_start = str_wide;\x0a"
"#endif /* TRE_WCHAR */\x0a"
"#ifdef TRE_MBSTATE\x0a"
"  mbstate_start = mbstate;\x0a"
"#endif /* TRE_MBSTATE */\x0a"
"\x0a"
"  /* Handle initial states. */\x0a"
"  next_tags = NULL;\x0a"
"  for (trans_i = tnfa->initial; trans_i->state; trans_i++)\x0a"
"    {\x0a"
"      DPRINT((\x22> init \x25p, prev_c \x25lc\x5cn\x22, trans_i->state, (tre_cint_t)prev_c));\x0a"
"      if (trans_i->assertions \x26\x26 CHECK_ASSERTIONS(trans_i->assertions))\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22""assert failed\x5cn\x22));\x0a"
"\x09  continue;\x0a"
"\x09}\x0a"
"      if (state == NULL)\x0a"
"\x09{\x0a"
"\x09  /* Start from this state. */\x0a"
"\x09  state = trans_i->state;\x0a"
"\x09  next_tags = trans_i->tags;\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  /* Backtrack to this state. */\x0a"
"\x09  DPRINT((\x22saving state \x25""d for backtracking\x5cn\x22, trans_i->state_id));\x0a"
"\x09  BT_STACK_PUSH(pos, str_byte, str_wide, trans_i->state,\x0a"
"\x09\x09\x09trans_i->state_id, next_c, tags, mbstate);\x0a"
"\x09  {\x0a"
"\x09    int *tmp = trans_i->tags;\x0a"
"\x09    if (tmp)\x0a"
"\x09      while (*tmp >= 0)\x0a"
"\x09\x09stack->item.tags\x5b*tmp++\x5d = pos;\x0a"
"\x09  }\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  if (next_tags)\x0a"
"    for (; *next_tags >= 0; next_tags++)\x0a"
"      tags\x5b*next_tags\x5d = pos;\x0a"
"\x0a"
"\x0a"
"  DPRINT((\x22""entering match loop, pos \x25""d, str_byte \x25p\x5cn\x22, pos, str_byte));\x0a"
"  DPRINT((\x22pos\x3a""chr/code \x7c state and tags\x5cn\x22));\x0a"
"  DPRINT((\x22-------------+------------------------------------------------\x5cn\x22));\x0a"
"\x0a"
"  if (state == NULL)\x0a"
"    goto backtrack;\x0a"
"\x0a"
"  while (/*CONSTCOND*/(void)1,1)\x0a"
"    {\x0a"
"      tre_tnfa_transition_t *next_state;\x0a"
"      int empty_br_match;\x0a"
"\x0a"
"      DPRINT((\x22start loop\x5cn\x22));\x0a"
"      if (state == tnfa->final)\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22  match found, \x25""d \x25""d\x5cn\x22, match_eo, pos));\x0a"
"\x09  if (match_eo < pos\x0a"
"\x09      \x7c\x7c (match_eo == pos\x0a"
"\x09\x09  \x26\x26 match_tags\x0a"
"\x09\x09  \x26\x26 tre_tag_order(tnfa->num_tags, tnfa->tag_directions,\x0a"
"\x09\x09\x09\x09   tags, match_tags)))\x0a"
"\x09    {\x0a"
"\x09      int i;\x0a"
"\x09      /* This match wins the previous match. */\x0a"
"\x09      DPRINT((\x22\x09 win previous\x5cn\x22));\x0a"
"\x09      match_eo = pos;\x0a"
"\x09      if (match_tags)\x0a"
"\x09\x09""for (i = 0; i < tnfa->num_tags; i++)\x0a"
"\x09\x09  match_tags\x5bi\x5d = tags\x5bi\x5d;\x0a"
"\x09    }\x0a"
"\x09  /* Our TNFAs never have transitions leaving from the final state,\x0a"
"\x09     so we jump right to backtracking. */\x0a"
"\x09  goto backtrack;\x0a"
"\x09}\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"      DPRINT((\x22\x25""3d\x3a\x25""2lc/\x25""05d \x7c \x25p \x22, pos, (tre_cint_t)next_c, (int)next_c,\x0a"
"\x09      state));\x0a"
"      {\x0a"
"\x09int i;\x0a"
"\x09""for (i = 0; i < tnfa->num_tags; i++)\x0a"
"\x09  DPRINT((\x22\x25""d\x25s\x22, tags\x5bi\x5d, i < tnfa->num_tags - 1 \x3f \x22, \x22 \x3a \x22\x22));\x0a"
"\x09""DPRINT((\x22\x5cn\x22));\x0a"
"      }\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
"      /* Go to the next character in the input string. */\x0a"
"      empty_br_match = 0;\x0a"
"      trans_i = state;\x0a"
"      if (trans_i->state \x26\x26 trans_i->assertions \x26 ASSERT_BACKREF)\x0a"
"\x09{\x0a"
"\x09  /* This is a back reference state.  All transitions leaving from\x0a"
"\x09     this state have the same back reference \x22""assertion\x22.  Instead\x0a"
"\x09     of reading the next character, we match the back reference. */\x0a"
"\x09  int so, eo, bt = trans_i->u.backref;\x0a"
"\x09  int bt_len;\x0a"
"\x09  int result;\x0a"
"\x0a"
"\x09  DPRINT((\x22  should match back reference \x25""d\x5cn\x22, bt));\x0a"
"\x09  /* Get the substring we need to match against.  Remember to\x0a"
"\x09     turn off REG_NOSUB temporarily. */\x0a"
"\x09  tre_fill_pmatch(bt + 1, pmatch, tnfa->cflags \x26 /*LINTED*/\x21REG_NOSUB,\x0a"
"\x09\x09\x09  tnfa, tags, pos);\x0a"
"\x09  so = pmatch\x5b""bt\x5d.rm_so;\x0a"
"\x09  eo = pmatch\x5b""bt\x5d.rm_eo;\x0a"
"\x09  bt_len = eo - so;\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"\x09  {\x0a"
"\x09    int slen;\x0a"
"\x09    if (len < 0)\x0a"
"\x09      slen = bt_len;\x0a"
"\x09    else\x0a"
"\x09      slen = MIN(bt_len, len - pos);\x0a"
"\x0a"
"\x09    if (type == STR_BYTE)\x0a"
"\x09      {\x0a"
"\x09\x09""DPRINT((\x22  substring (len \x25""d) is \x5b\x25""d, \x25""d\x5b\x3a '\x25.*s'\x5cn\x22,\x0a"
"\x09\x09\x09""bt_len, so, eo, bt_len, (char*)string + so));\x0a"
"\x09\x09""DPRINT((\x22  current string is '\x25.*s'\x5cn\x22, slen, str_byte - 1));\x0a"
"\x09      }\x0a"
"#ifdef TRE_WCHAR\x0a"
"\x09    else if (type == STR_WIDE)\x0a"
"\x09      {\x0a"
"\x09\x09""DPRINT((\x22  substring (len \x25""d) is \x5b\x25""d, \x25""d\x5b\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09""bt_len, so, eo, bt_len, (wchar_t*)string + so));\x0a"
"\x09\x09""DPRINT((\x22  current string is '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09slen, str_wide - 1));\x0a"
"\x09      }\x0a"
"#endif /* TRE_WCHAR */\x0a"
"\x09  }\x0a"
"#endif\x0a"
"\x0a"
"\x09  if (len < 0)\x0a"
"\x09    {\x0a"
"\x09      if (type == STR_USER)\x0a"
"\x09\x09result = str_source->compare((unsigned)so, (unsigned)pos,\x0a"
"\x09\x09\x09\x09\x09     (unsigned)bt_len,\x0a"
"\x09\x09\x09\x09\x09     str_source->context);\x0a"
"#ifdef TRE_WCHAR\x0a"
"\x09      else if (type == STR_WIDE)\x0a"
"\x09\x09result = wcsncmp((const wchar_t*)string + so, str_wide - 1,\x0a"
"\x09\x09\x09\x09 (size_t)bt_len);\x0a"
"#endif /* TRE_WCHAR */\x0a"
"\x09      else\x0a"
"\x09\x09result = strncmp((const char*)string + so, str_byte - 1,\x0a"
"\x09\x09\x09\x09 (size_t)bt_len);\x0a"
"\x09    }\x0a"
"\x09  else if (len - pos < bt_len)\x0a"
"\x09    result = 1;\x0a"
"#ifdef TRE_WCHAR\x0a"
"\x09  else if (type == STR_WIDE)\x0a"
"\x09    result = wmemcmp((const wchar_t*)string + so, str_wide - 1,\x0a"
"\x09\x09\x09     (size_t)bt_len);\x0a"
"#endif /* TRE_WCHAR */\x0a"
"\x09  else\x0a"
"\x09    result = memcmp((const char*)string + so, str_byte - 1,\x0a"
"\x09\x09\x09    (size_t)bt_len);\x0a"
"\x0a"
"\x09  if (result == 0)\x0a"
"\x09    {\x0a"
"\x09      /* Back reference matched.  Check for infinite loop. */\x0a"
"\x09      if (bt_len == 0)\x0a"
"\x09\x09""empty_br_match = 1;\x0a"
"\x09      if (empty_br_match \x26\x26 states_seen\x5btrans_i->state_id\x5d)\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22  avoid loop\x5cn\x22));\x0a"
"\x09\x09  goto backtrack;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      states_seen\x5btrans_i->state_id\x5d = empty_br_match;\x0a"
"\x0a"
"\x09      /* Advance in input string and resync \x60prev_c', \x60next_c'\x0a"
"\x09\x09 and pos. */\x0a"
"\x09      DPRINT((\x22\x09 back reference matched\x5cn\x22));\x0a"
"\x09      str_byte += bt_len - 1;\x0a"
"#ifdef TRE_WCHAR\x0a"
"\x09      str_wide += bt_len - 1;\x0a"
"#endif /* TRE_WCHAR */\x0a"
"\x09      pos += bt_len - 1;\x0a"
"\x09      GET_NEXT_WCHAR();\x0a"
"\x09      DPRINT((\x22\x09 pos now \x25""d\x5cn\x22, pos));\x0a"
"\x09    }\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      DPRINT((\x22\x09 back reference did not match\x5cn\x22));\x0a"
"\x09      goto backtrack;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  /* Check for end of string. */\x0a"
"\x09  if (len < 0)\x0a"
"\x09    {\x0a"
"\x09      if (type == STR_USER)\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (str_user_end)\x0a"
"\x09\x09    goto backtrack;\x0a"
"\x09\x09}\x0a"
"\x09      else if (next_c == L'\x5c""0')\x0a"
"\x09\x09goto backtrack;\x0a"
"\x09    }\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      if (pos >= len)\x0a"
"\x09\x09goto backtrack;\x0a"
"\x09    }\x0a"
"\x0a"
"\x09  /* Read the next character. */\x0a"
"\x09  GET_NEXT_WCHAR();\x0a"
"\x09}\x0a"
"\x0a"
"      next_state = NULL;\x0a"
"      for (trans_i = state; trans_i->state; trans_i++)\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22  transition \x25""d-\x25""d (\x25""c-\x25""c) \x25""d to \x25""d\x5cn\x22,\x0a"
"\x09\x09  trans_i->code_min, trans_i->code_max,\x0a"
"\x09\x09  trans_i->code_min, trans_i->code_max,\x0a"
"\x09\x09  trans_i->assertions, trans_i->state_id));\x0a"
"\x09  if (trans_i->code_min <= (tre_cint_t)prev_c\x0a"
"\x09      \x26\x26 trans_i->code_max >= (tre_cint_t)prev_c)\x0a"
"\x09    {\x0a"
"\x09      if (trans_i->assertions\x0a"
"\x09\x09  \x26\x26 (CHECK_ASSERTIONS(trans_i->assertions)\x0a"
"\x09\x09      \x7c\x7c CHECK_CHAR_CLASSES(trans_i, tnfa, eflags)))\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22  assertion failed\x5cn\x22));\x0a"
"\x09\x09  continue;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      if (next_state == NULL)\x0a"
"\x09\x09{\x0a"
"\x09\x09  /* First matching transition. */\x0a"
"\x09\x09  DPRINT((\x22  Next state is \x25""d\x5cn\x22, trans_i->state_id));\x0a"
"\x09\x09  next_state = trans_i->state;\x0a"
"\x09\x09  next_tags = trans_i->tags;\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09{\x0a"
"\x09\x09  /* Second matching transition.  We may need to backtrack here\x0a"
"\x09\x09     to take this transition instead of the first one, so we\x0a"
"\x09\x09     push this transition in the backtracking stack so we can\x0a"
"\x09\x09     jump back here if needed. */\x0a"
"\x09\x09  DPRINT((\x22  saving state \x25""d for backtracking\x5cn\x22,\x0a"
"\x09\x09\x09  trans_i->state_id));\x0a"
"\x09\x09  BT_STACK_PUSH(pos, str_byte, str_wide, trans_i->state,\x0a"
"\x09\x09\x09\x09trans_i->state_id, next_c, tags, mbstate);\x0a"
"\x09\x09  {\x0a"
"\x09\x09    int *tmp;\x0a"
"\x09\x09    for (tmp = trans_i->tags; tmp \x26\x26 *tmp >= 0; tmp++)\x0a"
"\x09\x09      stack->item.tags\x5b*tmp\x5d = pos;\x0a"
"\x09\x09  }\x0a"
"#if 0 /* XXX - it's important not to look at all transitions here to keep\x0a"
"\x09 the stack small\x21 */\x0a"
"\x09\x09  break;\x0a"
"#endif\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"      if (next_state \x21= NULL)\x0a"
"\x09{\x0a"
"\x09  /* Matching transitions were found.  Take the first one. */\x0a"
"\x09  state = next_state;\x0a"
"\x0a"
"\x09  /* Update the tag values. */\x0a"
"\x09  if (next_tags)\x0a"
"\x09    while (*next_tags >= 0)\x0a"
"\x09      tags\x5b*next_tags++\x5d = pos;\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09""backtrack\x3a\x0a"
"\x09  /* A matching transition was not found.  Try to backtrack. */\x0a"
"\x09  if (stack->prev)\x0a"
"\x09    {\x0a"
"\x09      DPRINT((\x22\x09 backtracking\x5cn\x22));\x0a"
"\x09      if (stack->item.state->assertions \x26 ASSERT_BACKREF)\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22  states_seen\x5b\x25""d\x5d = 0\x5cn\x22,\x0a"
"\x09\x09\x09  stack->item.state_id));\x0a"
"\x09\x09  states_seen\x5bstack->item.state_id\x5d = 0;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      BT_STACK_POP();\x0a"
"\x09    }\x0a"
"\x09  else if (match_eo < 0)\x0a"
"\x09    {\x0a"
"\x09      /* Try starting from a later position in the input string. */\x0a"
"\x09      /* Check for end of string. */\x0a"
"\x09      if (len < 0)\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (next_c == L'\x5c""0')\x0a"
"\x09\x09    {\x0a"
"\x09\x09      DPRINT((\x22""end of string.\x5cn\x22));\x0a"
"\x09\x09      break;\x0a"
"\x09\x09    }\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (pos >= len)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      DPRINT((\x22""end of string.\x5cn\x22));\x0a"
"\x09\x09      break;\x0a"
"\x09\x09    }\x0a"
"\x09\x09}\x0a"
"\x09      DPRINT((\x22restarting from next start position\x5cn\x22));\x0a"
"\x09      next_c = (tre_char_t) next_c_start;\x0a"
"#ifdef TRE_MBSTATE\x0a"
"\x09      mbstate = mbstate_start;\x0a"
"#endif /* TRE_MBSTATE */\x0a"
"\x09      str_byte = str_byte_start;\x0a"
"#ifdef TRE_WCHAR\x0a"
"\x09      str_wide = str_wide_start;\x0a"
"#endif /* TRE_WCHAR */\x0a"
"\x09      goto retry;\x0a"
"\x09    }\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      DPRINT((\x22""finished\x5cn\x22));\x0a"
"\x09      break;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  ret = match_eo >= 0 \x3f REG_OK \x3a REG_NOMATCH;\x0a"
"  *match_end_ofs = match_eo;\x0a"
"\x0a"
" error_exit\x3a\x0a"
"  tre_bt_mem_destroy(mem);\x0a"
"#ifndef TRE_USE_ALLOCA\x0a"
"  if (tags)\x0a"
"    xfree(tags);\x0a"
"  if (pmatch)\x0a"
"    xfree(pmatch);\x0a"
"  if (states_seen)\x0a"
"    xfree(states_seen);\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"\x0a"
"  return ret;\x0a"
"}\x0a"
"", 17763 ); }