#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_tre_match_parallel_c( 
"/*\x0a"
"  tre-match-parallel.c - TRE parallel regex matching engine\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"/*\x0a"
"  This algorithm searches for matches basically by reading characters\x0a"
"  in the searched string one by one, starting at the beginning.\x09 All\x0a"
"  matching paths in the TNFA are traversed in parallel.\x09 When two or\x0a"
"  more paths reach the same state, exactly one is chosen according to\x0a"
"  tag ordering rules; if returning submatches is not required it does\x0a"
"  not matter which path is chosen.\x0a"
"\x0a"
"  The worst case time required for finding the leftmost and longest\x0a"
"  match, or determining that there is no match, is always linearly\x0a"
"  dependent on the length of the text being searched.\x0a"
"\x0a"
"  This algorithm cannot handle TNFAs with back referencing nodes.\x0a"
"  See \x60tre-match-backtrack.c'.\x0a"
"*/\x0a"
"\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"\x0a"
"#ifdef TRE_USE_ALLOCA\x0a"
"/* AIX requires this to be the first thing in the file.\x09 */\x0a"
"#ifndef __GNUC__\x0a"
"# if HAVE_ALLOCA_H\x0a"
"#  include <alloca.h>\x0a"
"# else\x0a"
"#  ifdef _AIX\x0a"
" #pragma alloca\x0a"
"#  else\x0a"
"#   ifndef alloca /* predefined by HP cc +Olibcalls */\x0a"
"char *alloca ();\x0a"
"#   endif\x0a"
"#  endif\x0a"
"# endif\x0a"
"#endif\x0a"
"#endif /* TRE_USE_ALLOCA */\x0a"
"\x0a"
"#include <assert.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"#ifdef HAVE_WCHAR_H\x0a"
"#include <wchar.h>\x0a"
"#endif /* HAVE_WCHAR_H */\x0a"
"#ifdef HAVE_WCTYPE_H\x0a"
"#include <wctype.h>\x0a"
"#endif /* HAVE_WCTYPE_H */\x0a"
"#ifndef TRE_WCHAR\x0a"
"#include <ctype.h>\x0a"
"#endif /* \x21TRE_WCHAR */\x0a"
"#ifdef HAVE_MALLOC_H\x0a"
"#include <malloc.h>\x0a"
"#endif /* HAVE_MALLOC_H */\x0a"
"\x0a"
"#include \x22tre-internal.h\x22\x0a"
"#include \x22tre-match-utils.h\x22\x0a"
"#include \x22tre.h\x22\x0a"
"#include \x22xmalloc.h\x22\x0a"
"\x0a"
"\x0a"
"\x0a"
"typedef struct {\x0a"
"  tre_tnfa_transition_t *state;\x0a"
"  int *tags;\x0a"
"} tre_tnfa_reach_t;\x0a"
"\x0a"
"typedef struct {\x0a"
"  int pos;\x0a"
"  int **tags;\x0a"
"} tre_reach_pos_t;\x0a"
"\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"static void\x0a"
"tre_print_reach(const tre_tnfa_t *tnfa, tre_tnfa_reach_t *reach, int num_tags)\x0a"
"{\x0a"
"  int i;\x0a"
"\x0a"
"  while (reach->state \x21= NULL)\x0a"
"    {\x0a"
"      DPRINT((\x22 \x25p\x22, (void *)reach->state));\x0a"
"      if (num_tags > 0)\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22/\x22));\x0a"
"\x09  for (i = 0; i < num_tags; i++)\x0a"
"\x09    {\x0a"
"\x09      DPRINT((\x22\x25""d\x3a\x25""d\x22, i, reach->tags\x5bi\x5d));\x0a"
"\x09      if (i < (num_tags-1))\x0a"
"\x09\x09""DPRINT((\x22,\x22));\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"      reach++;\x0a"
"    }\x0a"
"  DPRINT((\x22\x5cn\x22));\x0a"
"\x0a"
"}\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
"reg_errcode_t\x0a"
"tre_tnfa_run_parallel(const tre_tnfa_t *tnfa, const void *string, int len,\x0a"
"\x09\x09      tre_str_type_t type, int *match_tags, int eflags,\x0a"
"\x09\x09      int *match_end_ofs)\x0a"
"{\x0a"
"  /* State variables required by GET_NEXT_WCHAR. */\x0a"
"  tre_char_t prev_c = 0, next_c = 0;\x0a"
"  const char *str_byte = string;\x0a"
"  int pos = -1;\x0a"
"  unsigned int pos_add_next = 1;\x0a"
"#ifdef TRE_WCHAR\x0a"
"  const wchar_t *str_wide = string;\x0a"
"#ifdef TRE_MBSTATE\x0a"
"  mbstate_t mbstate;\x0a"
"#endif /* TRE_MBSTATE */\x0a"
"#endif /* TRE_WCHAR */\x0a"
"  int reg_notbol = eflags \x26 REG_NOTBOL;\x0a"
"  int reg_noteol = eflags \x26 REG_NOTEOL;\x0a"
"  int reg_newline = tnfa->cflags \x26 REG_NEWLINE;\x0a"
"  int str_user_end = 0;\x0a"
"\x0a"
"  char *buf;\x0a"
"  tre_tnfa_transition_t *trans_i;\x0a"
"  tre_tnfa_reach_t *reach, *reach_next, *reach_i, *reach_next_i;\x0a"
"  tre_reach_pos_t *reach_pos;\x0a"
"  int *tag_i;\x0a"
"  int num_tags, i;\x0a"
"\x0a"
"  int match_eo = -1;\x09   /* end offset of match (-1 if no match found yet) */\x0a"
"  int new_match = 0;\x0a"
"  int *tmp_tags = NULL;\x0a"
"  int *tmp_iptr;\x0a"
"\x0a"
"#ifdef TRE_MBSTATE\x0a"
"  memset(\x26mbstate, '\x5c""0', sizeof(mbstate));\x0a"
"#endif /* TRE_MBSTATE */\x0a"
"\x0a"
"  DPRINT((\x22tre_tnfa_run_parallel, input type \x25""d\x5cn\x22, type));\x0a"
"\x0a"
"  if (\x21match_tags)\x0a"
"    num_tags = 0;\x0a"
"  else\x0a"
"    num_tags = tnfa->num_tags;\x0a"
"\x0a"
"  /* Allocate memory for temporary data required for matching.\x09This needs to\x0a"
"     be done for every matching operation to be thread safe.  This allocates\x0a"
"     everything in a single large block from the stack frame using alloca()\x0a"
"     or with malloc() if alloca is unavailable. */\x0a"
"  {\x0a"
"    int tbytes, rbytes, pbytes, xbytes, total_bytes;\x0a"
"    char *tmp_buf;\x0a"
"    /* Compute the length of the block we need. */\x0a"
"    tbytes = sizeof(*tmp_tags) * num_tags;\x0a"
"    rbytes = sizeof(*reach_next) * (tnfa->num_states + 1);\x0a"
"    pbytes = sizeof(*reach_pos) * tnfa->num_states;\x0a"
"    xbytes = sizeof(int) * num_tags;\x0a"
"    total_bytes =\x0a"
"      (sizeof(long) - 1) * 4 /* for alignment paddings */\x0a"
"      + (rbytes + xbytes * tnfa->num_states) * 2 + tbytes + pbytes;\x0a"
"\x0a"
"    /* Allocate the memory. */\x0a"
"#ifdef TRE_USE_ALLOCA\x0a"
"    buf = alloca(total_bytes);\x0a"
"#else /* \x21TRE_USE_ALLOCA */\x0a"
"    buf = xmalloc((unsigned)total_bytes);\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"    if (buf == NULL)\x0a"
"      return REG_ESPACE;\x0a"
"    memset(buf, 0, (size_t)total_bytes);\x0a"
"\x0a"
"    /* Get the various pointers within tmp_buf (properly aligned). */\x0a"
"    tmp_tags = (void *)buf;\x0a"
"    tmp_buf = buf + tbytes;\x0a"
"    tmp_buf += ALIGN(tmp_buf, long);\x0a"
"    reach_next = (void *)tmp_buf;\x0a"
"    tmp_buf += rbytes;\x0a"
"    tmp_buf += ALIGN(tmp_buf, long);\x0a"
"    reach = (void *)tmp_buf;\x0a"
"    tmp_buf += rbytes;\x0a"
"    tmp_buf += ALIGN(tmp_buf, long);\x0a"
"    reach_pos = (void *)tmp_buf;\x0a"
"    tmp_buf += pbytes;\x0a"
"    tmp_buf += ALIGN(tmp_buf, long);\x0a"
"    for (i = 0; i < tnfa->num_states; i++)\x0a"
"      {\x0a"
"\x09reach\x5bi\x5d.tags = (void *)tmp_buf;\x0a"
"\x09tmp_buf += xbytes;\x0a"
"\x09reach_next\x5bi\x5d.tags = (void *)tmp_buf;\x0a"
"\x09tmp_buf += xbytes;\x0a"
"      }\x0a"
"  }\x0a"
"\x0a"
"  for (i = 0; i < tnfa->num_states; i++)\x0a"
"    reach_pos\x5bi\x5d.pos = -1;\x0a"
"\x0a"
"  /* If only one character can start a match, find it first. */\x0a"
"  if (tnfa->first_char >= 0 \x26\x26 type == STR_BYTE \x26\x26 str_byte)\x0a"
"    {\x0a"
"      const char *orig_str = str_byte;\x0a"
"      int first = tnfa->first_char;\x0a"
"\x0a"
"      if (len >= 0)\x0a"
"\x09str_byte = memchr(orig_str, first, (size_t)len);\x0a"
"      else\x0a"
"\x09str_byte = strchr(orig_str, first);\x0a"
"      if (str_byte == NULL)\x0a"
"\x09{\x0a"
"#ifndef TRE_USE_ALLOCA\x0a"
"\x09  if (buf)\x0a"
"\x09    xfree(buf);\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"\x09  return REG_NOMATCH;\x0a"
"\x09}\x0a"
"      DPRINT((\x22skipped \x25lu chars\x5cn\x22, (unsigned long)(str_byte - orig_str)));\x0a"
"      if (str_byte >= orig_str + 1)\x0a"
"\x09prev_c = (unsigned char)*(str_byte - 1);\x0a"
"      next_c = (unsigned char)*str_byte;\x0a"
"      pos = str_byte - orig_str;\x0a"
"      if (len < 0 \x7c\x7c pos < len)\x0a"
"\x09str_byte++;\x0a"
"    }\x0a"
"  else\x0a"
"    {\x0a"
"      GET_NEXT_WCHAR();\x0a"
"      pos = 0;\x0a"
"    }\x0a"
"\x0a"
"#if 0\x0a"
"  /* Skip over characters that cannot possibly be the first character\x0a"
"     of a match. */\x0a"
"  if (tnfa->firstpos_chars \x21= NULL)\x0a"
"    {\x0a"
"      char *chars = tnfa->firstpos_chars;\x0a"
"\x0a"
"      if (len < 0)\x0a"
"\x09{\x0a"
"\x09  const char *orig_str = str_byte;\x0a"
"\x09  /* XXX - use strpbrk() and wcspbrk() because they might be\x0a"
"\x09     optimized for the target architecture.  Try also strcspn()\x0a"
"\x09     and wcscspn() and compare the speeds. */\x0a"
"\x09  while (next_c \x21= L'\x5c""0' \x26\x26 \x21""chars\x5bnext_c\x5d)\x0a"
"\x09    {\x0a"
"\x09      next_c = *str_byte++;\x0a"
"\x09    }\x0a"
"\x09  prev_c = *(str_byte - 2);\x0a"
"\x09  pos += str_byte - orig_str;\x0a"
"\x09  DPRINT((\x22skipped \x25""d chars\x5cn\x22, str_byte - orig_str));\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  while (pos <= len \x26\x26 \x21""chars\x5bnext_c\x5d)\x0a"
"\x09    {\x0a"
"\x09      prev_c = next_c;\x0a"
"\x09      next_c = (unsigned char)(*str_byte++);\x0a"
"\x09      pos++;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"  DPRINT((\x22length\x3a \x25""d\x5cn\x22, len));\x0a"
"  DPRINT((\x22pos\x3a""chr/code \x7c states and tags\x5cn\x22));\x0a"
"  DPRINT((\x22-------------+------------------------------------------------\x5cn\x22));\x0a"
"\x0a"
"  reach_next_i = reach_next;\x0a"
"  while (/*CONSTCOND*/(void)1,1)\x0a"
"    {\x0a"
"      /* If no match found yet, add the initial states to \x60reach_next'. */\x0a"
"      if (match_eo < 0)\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22 init >\x22));\x0a"
"\x09  trans_i = tnfa->initial;\x0a"
"\x09  while (trans_i->state \x21= NULL)\x0a"
"\x09    {\x0a"
"\x09      if (reach_pos\x5btrans_i->state_id\x5d.pos < pos)\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (trans_i->assertions\x0a"
"\x09\x09      \x26\x26 CHECK_ASSERTIONS(trans_i->assertions))\x0a"
"\x09\x09    {\x0a"
"\x09\x09      DPRINT((\x22""assertion failed\x5cn\x22));\x0a"
"\x09\x09      trans_i++;\x0a"
"\x09\x09      continue;\x0a"
"\x09\x09    }\x0a"
"\x0a"
"\x09\x09  DPRINT((\x22 \x25p\x22, (void *)trans_i->state));\x0a"
"\x09\x09  reach_next_i->state = trans_i->state;\x0a"
"\x09\x09  for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09    reach_next_i->tags\x5bi\x5d = -1;\x0a"
"\x09\x09  tag_i = trans_i->tags;\x0a"
"\x09\x09  if (tag_i)\x0a"
"\x09\x09    while (*tag_i >= 0)\x0a"
"\x09\x09      {\x0a"
"\x09\x09\x09if (*tag_i < num_tags)\x0a"
"\x09\x09\x09  reach_next_i->tags\x5b*tag_i\x5d = pos;\x0a"
"\x09\x09\x09tag_i++;\x0a"
"\x09\x09      }\x0a"
"\x09\x09  if (reach_next_i->state == tnfa->final)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      DPRINT((\x22\x09 found empty match\x5cn\x22));\x0a"
"\x09\x09      match_eo = pos;\x0a"
"\x09\x09      new_match = 1;\x0a"
"\x09\x09      for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09\x09match_tags\x5bi\x5d = reach_next_i->tags\x5bi\x5d;\x0a"
"\x09\x09    }\x0a"
"\x09\x09  reach_pos\x5btrans_i->state_id\x5d.pos = pos;\x0a"
"\x09\x09  reach_pos\x5btrans_i->state_id\x5d.tags = \x26reach_next_i->tags;\x0a"
"\x09\x09  reach_next_i++;\x0a"
"\x09\x09}\x0a"
"\x09      trans_i++;\x0a"
"\x09    }\x0a"
"\x09  DPRINT((\x22\x5cn\x22));\x0a"
"\x09  reach_next_i->state = NULL;\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  if (num_tags == 0 \x7c\x7c reach_next_i == reach_next)\x0a"
"\x09    /* We have found a match. */\x0a"
"\x09    break;\x0a"
"\x09}\x0a"
"\x0a"
"      /* Check for end of string. */\x0a"
"      if (len < 0)\x0a"
"\x09{\x0a"
"\x09  if (type == STR_USER)\x0a"
"\x09    {\x0a"
"\x09      if (str_user_end)\x0a"
"\x09\x09""break;\x0a"
"\x09    }\x0a"
"\x09  else if (next_c == L'\x5c""0')\x0a"
"\x09    break;\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  if (pos >= len)\x0a"
"\x09    break;\x0a"
"\x09}\x0a"
"\x0a"
"      GET_NEXT_WCHAR();\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"      DPRINT((\x22\x25""3d\x3a\x25""2lc/\x25""05d \x7c\x22, pos - 1, (tre_cint_t)prev_c, (int)prev_c));\x0a"
"      tre_print_reach(tnfa, reach_next, num_tags);\x0a"
"      DPRINT((\x22\x25""3d\x3a\x25""2lc/\x25""05d \x7c\x22, pos, (tre_cint_t)next_c, (int)next_c));\x0a"
"      tre_print_reach(tnfa, reach_next, num_tags);\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
"      /* Swap \x60reach' and \x60reach_next'. */\x0a"
"      reach_i = reach;\x0a"
"      reach = reach_next;\x0a"
"      reach_next = reach_i;\x0a"
"\x0a"
"      /* For each state in \x60reach', weed out states that don't fulfill the\x0a"
"\x09 minimal matching conditions. */\x0a"
"      if (tnfa->num_minimals \x26\x26 new_match)\x0a"
"\x09{\x0a"
"\x09  new_match = 0;\x0a"
"\x09  reach_next_i = reach_next;\x0a"
"\x09  for (reach_i = reach; reach_i->state; reach_i++)\x0a"
"\x09    {\x0a"
"\x09      int skip = 0;\x0a"
"\x09      for (i = 0; tnfa->minimal_tags\x5bi\x5d >= 0; i += 2)\x0a"
"\x09\x09{\x0a"
"\x09\x09  int end = tnfa->minimal_tags\x5bi\x5d;\x0a"
"\x09\x09  int start = tnfa->minimal_tags\x5bi + 1\x5d;\x0a"
"\x09\x09  DPRINT((\x22  Minimal start \x25""d, end \x25""d\x5cn\x22, start, end));\x0a"
"\x09\x09  if (end >= num_tags)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      DPRINT((\x22\x09 Throwing \x25p out.\x5cn\x22, reach_i->state));\x0a"
"\x09\x09      skip = 1;\x0a"
"\x09\x09      break;\x0a"
"\x09\x09    }\x0a"
"\x09\x09  else if (reach_i->tags\x5bstart\x5d == match_tags\x5bstart\x5d\x0a"
"\x09\x09\x09   \x26\x26 reach_i->tags\x5b""end\x5d < match_tags\x5b""end\x5d)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      DPRINT((\x22\x09 Throwing \x25p out because t\x25""d < \x25""d\x5cn\x22,\x0a"
"\x09\x09\x09      reach_i->state, end, match_tags\x5b""end\x5d));\x0a"
"\x09\x09      skip = 1;\x0a"
"\x09\x09      break;\x0a"
"\x09\x09    }\x0a"
"\x09\x09}\x0a"
"\x09      if (\x21skip)\x0a"
"\x09\x09{\x0a"
"\x09\x09  reach_next_i->state = reach_i->state;\x0a"
"\x09\x09  tmp_iptr = reach_next_i->tags;\x0a"
"\x09\x09  reach_next_i->tags = reach_i->tags;\x0a"
"\x09\x09  reach_i->tags = tmp_iptr;\x0a"
"\x09\x09  reach_next_i++;\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09  reach_next_i->state = NULL;\x0a"
"\x0a"
"\x09  /* Swap \x60reach' and \x60reach_next'. */\x0a"
"\x09  reach_i = reach;\x0a"
"\x09  reach = reach_next;\x0a"
"\x09  reach_next = reach_i;\x0a"
"\x09}\x0a"
"\x0a"
"      /* For each state in \x60reach' see if there is a transition leaving with\x0a"
"\x09 the current input symbol to a state not yet in \x60reach_next', and\x0a"
"\x09 add the destination states to \x60reach_next'. */\x0a"
"      reach_next_i = reach_next;\x0a"
"      for (reach_i = reach; reach_i->state; reach_i++)\x0a"
"\x09{\x0a"
"\x09  for (trans_i = reach_i->state; trans_i->state; trans_i++)\x0a"
"\x09    {\x0a"
"\x09      /* Does this transition match the input symbol\x3f */\x0a"
"\x09      if (trans_i->code_min <= (tre_cint_t)prev_c \x26\x26\x0a"
"\x09\x09  trans_i->code_max >= (tre_cint_t)prev_c)\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (trans_i->assertions\x0a"
"\x09\x09      \x26\x26 (CHECK_ASSERTIONS(trans_i->assertions)\x0a"
"\x09\x09\x09  \x7c\x7c CHECK_CHAR_CLASSES(trans_i, tnfa, eflags)))\x0a"
"\x09\x09    {\x0a"
"\x09\x09      DPRINT((\x22""assertion failed\x5cn\x22));\x0a"
"\x09\x09      continue;\x0a"
"\x09\x09    }\x0a"
"\x0a"
"\x09\x09  /* Compute the tags after this transition. */\x0a"
"\x09\x09  for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09    tmp_tags\x5bi\x5d = reach_i->tags\x5bi\x5d;\x0a"
"\x09\x09  tag_i = trans_i->tags;\x0a"
"\x09\x09  if (tag_i \x21= NULL)\x0a"
"\x09\x09    while (*tag_i >= 0)\x0a"
"\x09\x09      {\x0a"
"\x09\x09\x09if (*tag_i < num_tags)\x0a"
"\x09\x09\x09  tmp_tags\x5b*tag_i\x5d = pos;\x0a"
"\x09\x09\x09tag_i++;\x0a"
"\x09\x09      }\x0a"
"\x0a"
"\x09\x09  if (reach_pos\x5btrans_i->state_id\x5d.pos < pos)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      /* Found an unvisited node. */\x0a"
"\x09\x09      reach_next_i->state = trans_i->state;\x0a"
"\x09\x09      tmp_iptr = reach_next_i->tags;\x0a"
"\x09\x09      reach_next_i->tags = tmp_tags;\x0a"
"\x09\x09      tmp_tags = tmp_iptr;\x0a"
"\x09\x09      reach_pos\x5btrans_i->state_id\x5d.pos = pos;\x0a"
"\x09\x09      reach_pos\x5btrans_i->state_id\x5d.tags = \x26reach_next_i->tags;\x0a"
"\x0a"
"\x09\x09      if (reach_next_i->state == tnfa->final\x0a"
"\x09\x09\x09  \x26\x26 (match_eo == -1\x0a"
"\x09\x09\x09      \x7c\x7c (num_tags > 0\x0a"
"\x09\x09\x09\x09  \x26\x26 reach_next_i->tags\x5b""0\x5d <= match_tags\x5b""0\x5d)))\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  DPRINT((\x22  found match \x25p\x5cn\x22, trans_i->state));\x0a"
"\x09\x09\x09  match_eo = pos;\x0a"
"\x09\x09\x09  new_match = 1;\x0a"
"\x09\x09\x09  for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09\x09    match_tags\x5bi\x5d = reach_next_i->tags\x5bi\x5d;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09      reach_next_i++;\x0a"
"\x0a"
"\x09\x09    }\x0a"
"\x09\x09  else\x0a"
"\x09\x09    {\x0a"
"\x09\x09      assert(reach_pos\x5btrans_i->state_id\x5d.pos == pos);\x0a"
"\x09\x09      /* Another path has also reached this state.  We choose\x0a"
"\x09\x09\x09 the winner by examining the tag values for both\x0a"
"\x09\x09\x09 paths. */\x0a"
"\x09\x09      if (tre_tag_order(num_tags, tnfa->tag_directions,\x0a"
"\x09\x09\x09\x09\x09tmp_tags,\x0a"
"\x09\x09\x09\x09\x09*reach_pos\x5btrans_i->state_id\x5d.tags))\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  /* The new path wins. */\x0a"
"\x09\x09\x09  tmp_iptr = *reach_pos\x5btrans_i->state_id\x5d.tags;\x0a"
"\x09\x09\x09  *reach_pos\x5btrans_i->state_id\x5d.tags = tmp_tags;\x0a"
"\x09\x09\x09  if (trans_i->state == tnfa->final)\x0a"
"\x09\x09\x09    {\x0a"
"\x09\x09\x09      DPRINT((\x22\x09 found better match\x5cn\x22));\x0a"
"\x09\x09\x09      match_eo = pos;\x0a"
"\x09\x09\x09      new_match = 1;\x0a"
"\x09\x09\x09      for (i = 0; i < num_tags; i++)\x0a"
"\x09\x09\x09\x09match_tags\x5bi\x5d = tmp_tags\x5bi\x5d;\x0a"
"\x09\x09\x09    }\x0a"
"\x09\x09\x09  tmp_tags = tmp_iptr;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09    }\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"      reach_next_i->state = NULL;\x0a"
"    }\x0a"
"\x0a"
"  DPRINT((\x22match end offset = \x25""d\x5cn\x22, match_eo));\x0a"
"\x0a"
"#ifndef TRE_USE_ALLOCA\x0a"
"  if (buf)\x0a"
"    xfree(buf);\x0a"
"#endif /* \x21TRE_USE_ALLOCA */\x0a"
"\x0a"
"  *match_end_ofs = match_eo;\x0a"
"  return match_eo >= 0 \x3f REG_OK \x3a REG_NOMATCH;\x0a"
"}\x0a"
"\x0a"
"/* EOF */\x0a"
"", 12873 ); }