#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_tre_parse_c( 
"/*\x0a"
"  tre-parse.c - Regexp parser\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"/*\x0a"
"  This parser is just a simple recursive descent parser for POSIX.2\x0a"
"  regexps.  The parser supports both the obsolete default syntax and\x0a"
"  the \x22""extended\x22 syntax, and some nonstandard extensions.\x0a"
"*/\x0a"
"\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"#include <string.h>\x0a"
"#include <assert.h>\x0a"
"#include <limits.h>\x0a"
"\x0a"
"#include \x22xmalloc.h\x22\x0a"
"#include \x22tre-mem.h\x22\x0a"
"#include \x22tre-ast.h\x22\x0a"
"#include \x22tre-stack.h\x22\x0a"
"#include \x22tre-parse.h\x22\x0a"
"\x0a"
"\x0a"
"/* Characters with special meanings in regexp syntax. */\x0a"
"#define CHAR_PIPE\x09   L'\x7c'\x0a"
"#define CHAR_LPAREN\x09   L'('\x0a"
"#define CHAR_RPAREN\x09   L')'\x0a"
"#define CHAR_LBRACE\x09   L'{'\x0a"
"#define CHAR_RBRACE\x09   L'}'\x0a"
"#define CHAR_LBRACKET\x09   L'\x5b'\x0a"
"#define CHAR_RBRACKET\x09   L'\x5d'\x0a"
"#define CHAR_MINUS\x09   L'-'\x0a"
"#define CHAR_STAR\x09   L'*'\x0a"
"#define CHAR_QUESTIONMARK  L'\x3f'\x0a"
"#define CHAR_PLUS\x09   L'+'\x0a"
"#define CHAR_PERIOD\x09   L'.'\x0a"
"#define CHAR_COLON\x09   L'\x3a'\x0a"
"#define CHAR_EQUAL\x09   L'='\x0a"
"#define CHAR_COMMA\x09   L','\x0a"
"#define CHAR_CARET\x09   L'^'\x0a"
"#define CHAR_DOLLAR\x09   L'\x24'\x0a"
"#define CHAR_BACKSLASH\x09   L'\x5c\x5c'\x0a"
"#define CHAR_HASH\x09   L'#'\x0a"
"#define CHAR_TILDE\x09   L'\x7e'\x0a"
"\x0a"
"\x0a"
"/* Some macros for expanding \x5cw, \x5cs, etc. */\x0a"
"static const struct tre_macro_struct {\x0a"
"  const char c;\x0a"
"  const char *expansion;\x0a"
"} tre_macros\x5b\x5d =\x0a"
"  { {'t', \x22\x5ct\x22},\x09   {'n', \x22\x5cn\x22},\x09\x09   {'r', \x22\x5cr\x22},\x0a"
"    {'f', \x22\x5c""f\x22},\x09   {'a', \x22\x5c""a\x22},\x09\x09   {'e', \x22\x5c""033\x22},\x0a"
"    {'w', \x22\x5b\x5b\x3a""alnum\x3a\x5d_\x5d\x22}, {'W', \x22\x5b^\x5b\x3a""alnum\x3a\x5d_\x5d\x22}, {'s', \x22\x5b\x5b\x3aspace\x3a\x5d\x5d\x22},\x0a"
"    {'S', \x22\x5b^\x5b\x3aspace\x3a\x5d\x5d\x22}, {'d', \x22\x5b\x5b\x3a""digit\x3a\x5d\x5d\x22},   {'D', \x22\x5b^\x5b\x3a""digit\x3a\x5d\x5d\x22},\x0a"
"    { 0, NULL }\x0a"
"  };\x0a"
"\x0a"
"\x0a"
"/* Expands a macro delimited by \x60regex' and \x60regex_end' to \x60""buf', which\x0a"
"   must have at least \x60len' items.  Sets buf\x5b""0\x5d to zero if the there\x0a"
"   is no match in \x60tre_macros'. */\x0a"
"static void\x0a"
"tre_expand_macro(const tre_char_t *regex, const tre_char_t *regex_end,\x0a"
"\x09\x09 tre_char_t *buf, size_t buf_len)\x0a"
"{\x0a"
"  int i;\x0a"
"\x0a"
"  buf\x5b""0\x5d = 0;\x0a"
"  if (regex >= regex_end)\x0a"
"    return;\x0a"
"\x0a"
"  for (i = 0; tre_macros\x5bi\x5d.expansion; i++)\x0a"
"    {\x0a"
"      if (tre_macros\x5bi\x5d.c == *regex)\x0a"
"\x09{\x0a"
"\x09  unsigned int j;\x0a"
"\x09  DPRINT((\x22""Expanding macro '\x25""c' => '\x25s'\x5cn\x22,\x0a"
"\x09\x09  tre_macros\x5bi\x5d.c, tre_macros\x5bi\x5d.expansion));\x0a"
"\x09  for (j = 0; tre_macros\x5bi\x5d.expansion\x5bj\x5d \x26\x26 j < buf_len; j++)\x0a"
"\x09    buf\x5bj\x5d = tre_macros\x5bi\x5d.expansion\x5bj\x5d;\x0a"
"\x09  buf\x5bj\x5d = 0;\x0a"
"\x09  break;\x0a"
"\x09}\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"static reg_errcode_t\x0a"
"tre_new_item(tre_mem_t mem, int min, int max, int *i, int *max_i,\x0a"
"\x09 tre_ast_node_t ***items)\x0a"
"{\x0a"
"  reg_errcode_t status;\x0a"
"  tre_ast_node_t **array = *items;\x0a"
"  /* Allocate more space if necessary. */\x0a"
"  if (*i >= *max_i)\x0a"
"    {\x0a"
"      tre_ast_node_t **new_items;\x0a"
"      DPRINT((\x22out of array space, i = \x25""d\x5cn\x22, *i));\x0a"
"      /* If the array is already 1024 items large, give up -- there's\x0a"
"\x09 probably an error in the regexp (e.g. not a '\x5c""0' terminated\x0a"
"\x09 string and missing '\x5d') */\x0a"
"      if (*max_i > 1024)\x0a"
"\x09return REG_ESPACE;\x0a"
"      *max_i *= 2;\x0a"
"      new_items = xrealloc(array, sizeof(*items) * *max_i);\x0a"
"      if (new_items == NULL)\x0a"
"\x09return REG_ESPACE;\x0a"
"      *items = array = new_items;\x0a"
"    }\x0a"
"  array\x5b*i\x5d = tre_ast_new_literal(mem, min, max, -1);\x0a"
"  status = array\x5b*i\x5d == NULL \x3f REG_ESPACE \x3a REG_OK;\x0a"
"  (*i)++;\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* Expands a character class to character ranges. */\x0a"
"static reg_errcode_t\x0a"
"tre_expand_ctype(tre_mem_t mem, tre_ctype_t class, tre_ast_node_t ***items,\x0a"
"\x09\x09 int *i, int *max_i, int cflags)\x0a"
"{\x0a"
"  reg_errcode_t status = REG_OK;\x0a"
"  tre_cint_t c;\x0a"
"  int j, min = -1, max = 0;\x0a"
"  assert(TRE_MB_CUR_MAX == 1);\x0a"
"\x0a"
"  DPRINT((\x22  expanding class to character ranges\x5cn\x22));\x0a"
"  for (j = 0; (j < 256) \x26\x26 (status == REG_OK); j++)\x0a"
"    {\x0a"
"      c = (tre_cint_t) j;\x0a"
"      if (tre_isctype(c, class)\x0a"
"\x09  \x7c\x7c ((cflags \x26 REG_ICASE)\x0a"
"\x09      \x26\x26 (tre_isctype(tre_tolower(c), class)\x0a"
"\x09\x09  \x7c\x7c tre_isctype(tre_toupper(c), class))))\x0a"
"{\x0a"
"\x09  if (min < 0)\x0a"
"\x09    min = c;\x0a"
"\x09  max = c;\x0a"
"\x09}\x0a"
"      else if (min >= 0)\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22  range \x25""c (\x25""d) to \x25""c (\x25""d)\x5cn\x22, min, min, max, max));\x0a"
"\x09  status = tre_new_item(mem, min, max, i, max_i, items);\x0a"
"\x09  min = -1;\x0a"
"\x09}\x0a"
"    }\x0a"
"  if (min >= 0 \x26\x26 status == REG_OK)\x0a"
"    status = tre_new_item(mem, min, max, i, max_i, items);\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"static int\x0a"
"tre_compare_items(const void *a, const void *b)\x0a"
"{\x0a"
"  const tre_ast_node_t *node_a = *(tre_ast_node_t * const *)a;\x0a"
"  const tre_ast_node_t *node_b = *(tre_ast_node_t * const *)b;\x0a"
"  tre_literal_t *l_a = node_a->obj, *l_b = node_b->obj;\x0a"
"  int a_min = l_a->code_min, b_min = l_b->code_min;\x0a"
"\x0a"
"  if (a_min < b_min)\x0a"
"    return -1;\x0a"
"  else if (a_min > b_min)\x0a"
"    return 1;\x0a"
"  else\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"#ifndef TRE_USE_SYSTEM_WCTYPE\x0a"
"\x0a"
"/* isalnum() and the rest may be macros, so wrap them to functions. */\x0a"
"int tre_isalnum_func(tre_cint_t c) { return tre_isalnum(c); }\x0a"
"int tre_isalpha_func(tre_cint_t c) { return tre_isalpha(c); }\x0a"
"\x0a"
"#ifdef tre_isascii\x0a"
"int tre_isascii_func(tre_cint_t c) { return tre_isascii(c); }\x0a"
"#else /* \x21tre_isascii */\x0a"
"int tre_isascii_func(tre_cint_t c) { return \x21(c >> 7); }\x0a"
"#endif /* \x21tre_isascii */\x0a"
"\x0a"
"#ifdef tre_isblank\x0a"
"int tre_isblank_func(tre_cint_t c) { return tre_isblank(c); }\x0a"
"#else /* \x21tre_isblank */\x0a"
"int tre_isblank_func(tre_cint_t c) { return ((c == ' ') \x7c\x7c (c == '\x5ct')); }\x0a"
"#endif /* \x21tre_isblank */\x0a"
"\x0a"
"int tre_iscntrl_func(tre_cint_t c) { return tre_iscntrl(c); }\x0a"
"int tre_isdigit_func(tre_cint_t c) { return tre_isdigit(c); }\x0a"
"int tre_isgraph_func(tre_cint_t c) { return tre_isgraph(c); }\x0a"
"int tre_islower_func(tre_cint_t c) { return tre_islower(c); }\x0a"
"int tre_isprint_func(tre_cint_t c) { return tre_isprint(c); }\x0a"
"int tre_ispunct_func(tre_cint_t c) { return tre_ispunct(c); }\x0a"
"int tre_isspace_func(tre_cint_t c) { return tre_isspace(c); }\x0a"
"int tre_isupper_func(tre_cint_t c) { return tre_isupper(c); }\x0a"
"int tre_isxdigit_func(tre_cint_t c) { return tre_isxdigit(c); }\x0a"
"\x0a"
"struct {\x0a"
"  char *name;\x0a"
"  int (*func)(tre_cint_t);\x0a"
"} tre_ctype_map\x5b\x5d = {\x0a"
"  { \x22""alnum\x22, \x26tre_isalnum_func },\x0a"
"  { \x22""alpha\x22, \x26tre_isalpha_func },\x0a"
"#ifdef tre_isascii\x0a"
"  { \x22""ascii\x22, \x26tre_isascii_func },\x0a"
"#endif /* tre_isascii */\x0a"
"#ifdef tre_isblank\x0a"
"  { \x22""blank\x22, \x26tre_isblank_func },\x0a"
"#endif /* tre_isblank */\x0a"
"  { \x22""cntrl\x22, \x26tre_iscntrl_func },\x0a"
"  { \x22""digit\x22, \x26tre_isdigit_func },\x0a"
"  { \x22graph\x22, \x26tre_isgraph_func },\x0a"
"  { \x22lower\x22, \x26tre_islower_func },\x0a"
"  { \x22print\x22, \x26tre_isprint_func },\x0a"
"  { \x22punct\x22, \x26tre_ispunct_func },\x0a"
"  { \x22space\x22, \x26tre_isspace_func },\x0a"
"  { \x22upper\x22, \x26tre_isupper_func },\x0a"
"  { \x22xdigit\x22, \x26tre_isxdigit_func },\x0a"
"  { NULL, NULL}\x0a"
"};\x0a"
"\x0a"
"tre_ctype_t tre_ctype(const char *name)\x0a"
"{\x0a"
"  int i;\x0a"
"  for (i = 0; tre_ctype_map\x5bi\x5d.name \x21= NULL; i++)\x0a"
"    {\x0a"
"      if (strcmp(name, tre_ctype_map\x5bi\x5d.name) == 0)\x0a"
"\x09return tre_ctype_map\x5bi\x5d.func;\x0a"
"    }\x0a"
"  return (tre_ctype_t)0;\x0a"
"}\x0a"
"#endif /* \x21TRE_USE_SYSTEM_WCTYPE */\x0a"
"\x0a"
"/* Maximum number of character classes that can occur in a negated bracket\x0a"
"   expression.\x09*/\x0a"
"#define MAX_NEG_CLASSES 64\x0a"
"\x0a"
"/* Maximum length of character class names. */\x0a"
"#define MAX_CLASS_NAME\x0a"
"\x0a"
"#define REST(re) (int)(ctx->re_end - (re)), (re)\x0a"
"\x0a"
"static reg_errcode_t\x0a"
"tre_parse_bracket_items(tre_parse_ctx_t *ctx, int negate,\x0a"
"\x09\x09\x09tre_ctype_t neg_classes\x5b\x5d, int *num_neg_classes,\x0a"
"\x09\x09\x09tre_ast_node_t ***items, int *num_items,\x0a"
"\x09\x09\x09int *items_size)\x0a"
"{\x0a"
"  const tre_char_t *re = ctx->re;\x0a"
"  reg_errcode_t status = REG_OK;\x0a"
"  tre_ctype_t class = (tre_ctype_t)0;\x0a"
"  int i = *num_items;\x0a"
"  int max_i = *items_size;\x0a"
"  int skip;\x0a"
"\x0a"
"  /* Build an array of the items in the bracket expression. */\x0a"
"  while (status == REG_OK)\x0a"
"    {\x0a"
"      skip = 0;\x0a"
"      if (re == ctx->re_end)\x0a"
"\x09{\x0a"
"\x09  status = REG_EBRACK;\x0a"
"\x09}\x0a"
"      else if (*re == CHAR_RBRACKET \x26\x26 re > ctx->re)\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22tre_parse_bracket\x3a\x09""done\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(re)));\x0a"
"\x09  re++;\x0a"
"\x09  break;\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  tre_cint_t min = 0, max = 0;\x0a"
"\x0a"
"\x09  class = (tre_ctype_t)0;\x0a"
"\x09  if (re + 2 < ctx->re_end\x0a"
"\x09      \x26\x26 *(re + 1) == CHAR_MINUS \x26\x26 *(re + 2) \x21= CHAR_RBRACKET)\x0a"
"\x09    {\x0a"
"\x09      DPRINT((\x22tre_parse_bracket\x3a  range\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(re)));\x0a"
"\x09      min = *re;\x0a"
"\x09      max = *(re + 2);\x0a"
"\x09      re += 3;\x0a"
"\x09      /* XXX - Should use collation order instead of encoding values\x0a"
"\x09\x09 in character ranges. */\x0a"
"\x09      if (min > max)\x0a"
"\x09\x09status = REG_ERANGE;\x0a"
"\x09    }\x0a"
"\x09  else if (re + 1 < ctx->re_end\x0a"
"\x09\x09   \x26\x26 *re == CHAR_LBRACKET \x26\x26 *(re + 1) == CHAR_PERIOD)\x0a"
"\x09    status = REG_ECOLLATE;\x0a"
"\x09  else if (re + 1 < ctx->re_end\x0a"
"\x09\x09   \x26\x26 *re == CHAR_LBRACKET \x26\x26 *(re + 1) == CHAR_EQUAL)\x0a"
"\x09    status = REG_ECOLLATE;\x0a"
"\x09  else if (re + 1 < ctx->re_end\x0a"
"\x09\x09   \x26\x26 *re == CHAR_LBRACKET \x26\x26 *(re + 1) == CHAR_COLON)\x0a"
"\x09    {\x0a"
"\x09      char tmp_str\x5b""64\x5d;\x0a"
"\x09      const tre_char_t *endptr = re + 2;\x0a"
"\x09      int len;\x0a"
"\x09      DPRINT((\x22tre_parse_bracket\x3a  class\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(re)));\x0a"
"\x09      while (endptr < ctx->re_end \x26\x26 *endptr \x21= CHAR_COLON)\x0a"
"\x09\x09""endptr++;\x0a"
"\x09      if (endptr \x21= ctx->re_end)\x0a"
"\x09\x09{\x0a"
"\x09\x09  len = MIN(endptr - re - 2, 63);\x0a"
"#ifdef TRE_WCHAR\x0a"
"\x09\x09  {\x0a"
"\x09\x09    tre_char_t tmp_wcs\x5b""64\x5d;\x0a"
"\x09\x09    wcsncpy(tmp_wcs, re + 2, (size_t)len);\x0a"
"\x09\x09    tmp_wcs\x5blen\x5d = L'\x5c""0';\x0a"
"#if defined HAVE_WCSRTOMBS\x0a"
"\x09\x09    {\x0a"
"\x09\x09      mbstate_t state;\x0a"
"\x09\x09      const tre_char_t *src = tmp_wcs;\x0a"
"\x09\x09      memset(\x26state, '\x5c""0', sizeof(state));\x0a"
"\x09\x09      len = wcsrtombs(tmp_str, \x26src, sizeof(tmp_str), \x26state);\x0a"
"\x09\x09    }\x0a"
"#elif defined HAVE_WCSTOMBS\x0a"
"\x09\x09    len = wcstombs(tmp_str, tmp_wcs, 63);\x0a"
"#endif /* defined HAVE_WCSTOMBS */\x0a"
"\x09\x09  }\x0a"
"#else /* \x21TRE_WCHAR */\x0a"
"\x09\x09  strncpy(tmp_str, (const char*)re + 2, len);\x0a"
"#endif /* \x21TRE_WCHAR */\x0a"
"\x09\x09  tmp_str\x5blen\x5d = '\x5c""0';\x0a"
"\x09\x09  DPRINT((\x22  class name\x3a \x25s\x5cn\x22, tmp_str));\x0a"
"\x09\x09  class = tre_ctype(tmp_str);\x0a"
"\x09\x09  if (\x21""class)\x0a"
"\x09\x09    status = REG_ECTYPE;\x0a"
"\x09\x09  /* Optimize character classes for 8 bit character sets. */\x0a"
"\x09\x09  if (status == REG_OK \x26\x26 ctx->cur_max == 1)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      status = tre_expand_ctype(ctx->mem, class, items,\x0a"
"\x09\x09\x09\x09\x09\x09\x26i, \x26max_i, ctx->cflags);\x0a"
"\x09\x09      class = (tre_ctype_t)0;\x0a"
"\x09\x09      skip = 1;\x0a"
"\x09\x09    }\x0a"
"\x09\x09  re = endptr + 2;\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09status = REG_ECTYPE;\x0a"
"\x09      min = 0;\x0a"
"\x09      max = TRE_CHAR_MAX;\x0a"
"\x09    }\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      DPRINT((\x22tre_parse_bracket\x3a   char\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(re)));\x0a"
"\x09      if (*re == CHAR_MINUS \x26\x26 *(re + 1) \x21= CHAR_RBRACKET\x0a"
"\x09\x09  \x26\x26 ctx->re \x21= re)\x0a"
"\x09\x09/* Two ranges are not allowed to share and endpoint. */\x0a"
"\x09\x09status = REG_ERANGE;\x0a"
"\x09      min = max = *re++;\x0a"
"\x09    }\x0a"
"\x0a"
"\x09  if (status \x21= REG_OK)\x0a"
"\x09    break;\x0a"
"\x0a"
"\x09  if (class \x26\x26 negate)\x0a"
"\x09    if (*num_neg_classes >= MAX_NEG_CLASSES)\x0a"
"\x09      status = REG_ESPACE;\x0a"
"\x09    else\x0a"
"\x09      neg_classes\x5b(*num_neg_classes)++\x5d = class;\x0a"
"\x09  else if (\x21skip)\x0a"
"\x09    {\x0a"
"\x09      status = tre_new_item(ctx->mem, min, max, \x26i, \x26max_i, items);\x0a"
"\x09      if (status \x21= REG_OK)\x0a"
"\x09\x09""break;\x0a"
"\x09      ((tre_literal_t*)((*items)\x5bi-1\x5d)->obj)->u.class = class;\x0a"
"\x09    }\x0a"
"\x0a"
"\x09  /* Add opposite-case counterpoints if REG_ICASE is present.\x0a"
"\x09     This is broken if there are more than two \x22same\x22 characters. */\x0a"
"\x09  if (ctx->cflags \x26 REG_ICASE \x26\x26 \x21""class \x26\x26 status == REG_OK \x26\x26 \x21skip)\x0a"
"\x09    {\x0a"
"\x09      tre_cint_t cmin, ccurr;\x0a"
"\x0a"
"\x09      DPRINT((\x22""adding opposite-case counterpoints\x5cn\x22));\x0a"
"\x09      while (min <= max)\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (tre_islower(min))\x0a"
"\x09\x09    {\x0a"
"\x09\x09      cmin = ccurr = tre_toupper(min++);\x0a"
"\x09\x09      while (tre_islower(min) \x26\x26 tre_toupper(min) == ccurr + 1\x0a"
"\x09\x09\x09     \x26\x26 min <= max)\x0a"
"\x09\x09\x09""ccurr = tre_toupper(min++);\x0a"
"\x09\x09      status = tre_new_item(ctx->mem, cmin, ccurr,\x0a"
"\x09\x09\x09\x09\x09    \x26i, \x26max_i, items);\x0a"
"\x09\x09    }\x0a"
"\x09\x09  else if (tre_isupper(min))\x0a"
"\x09\x09    {\x0a"
"\x09\x09      cmin = ccurr = tre_tolower(min++);\x0a"
"\x09\x09      while (tre_isupper(min) \x26\x26 tre_tolower(min) == ccurr + 1\x0a"
"\x09\x09\x09     \x26\x26 min <= max)\x0a"
"\x09\x09\x09""ccurr = tre_tolower(min++);\x0a"
"\x09\x09      status = tre_new_item(ctx->mem, cmin, ccurr,\x0a"
"\x09\x09\x09\x09\x09    \x26i, \x26max_i, items);\x0a"
"\x09\x09    }\x0a"
"\x09\x09  else min++;\x0a"
"\x09\x09  if (status \x21= REG_OK)\x0a"
"\x09\x09    break;\x0a"
"\x09\x09}\x0a"
"\x09      if (status \x21= REG_OK)\x0a"
"\x09\x09""break;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    }\x0a"
"  *num_items = i;\x0a"
"  *items_size = max_i;\x0a"
"  ctx->re = re;\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"static reg_errcode_t\x0a"
"tre_parse_bracket(tre_parse_ctx_t *ctx, tre_ast_node_t **result)\x0a"
"{\x0a"
"  tre_ast_node_t *node = NULL;\x0a"
"  int negate = 0;\x0a"
"  reg_errcode_t status = REG_OK;\x0a"
"  tre_ast_node_t **items, *u, *n;\x0a"
"  int i = 0, j, max_i = 32, curr_max, curr_min;\x0a"
"  tre_ctype_t neg_classes\x5bMAX_NEG_CLASSES\x5d;\x0a"
"  int num_neg_classes = 0;\x0a"
"\x0a"
"  /* Start off with an array of \x60max_i' elements. */\x0a"
"  items = xmalloc(sizeof(*items) * max_i);\x0a"
"  if (items == NULL)\x0a"
"    return REG_ESPACE;\x0a"
"\x0a"
"  if (*ctx->re == CHAR_CARET)\x0a"
"    {\x0a"
"      DPRINT((\x22tre_parse_bracket\x3a negate\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(ctx->re)));\x0a"
"      negate = 1;\x0a"
"      ctx->re++;\x0a"
"    }\x0a"
"\x0a"
"  status = tre_parse_bracket_items(ctx, negate, neg_classes, \x26num_neg_classes,\x0a"
"\x09\x09\x09\x09   \x26items, \x26i, \x26max_i);\x0a"
"\x0a"
"  if (status \x21= REG_OK)\x0a"
"    goto parse_bracket_done;\x0a"
"\x0a"
"  /* Sort the array if we need to negate it. */\x0a"
"  if (negate)\x0a"
"    qsort(items, (unsigned)i, sizeof(*items), tre_compare_items);\x0a"
"\x0a"
"  curr_max = curr_min = 0;\x0a"
"  /* Build a union of the items in the array, negated if necessary. */\x0a"
"  for (j = 0; j < i \x26\x26 status == REG_OK; j++)\x0a"
"    {\x0a"
"      int min, max;\x0a"
"      tre_literal_t *l = items\x5bj\x5d->obj;\x0a"
"      min = l->code_min;\x0a"
"      max = l->code_max;\x0a"
"\x0a"
"      DPRINT((\x22item\x3a \x25""d - \x25""d, class \x25ld, curr_max = \x25""d\x5cn\x22,\x0a"
"\x09      (int)l->code_min, (int)l->code_max, (long)l->u.class, curr_max));\x0a"
"\x0a"
"      if (negate)\x0a"
"\x09{\x0a"
"\x09  if (min < curr_max)\x0a"
"\x09    {\x0a"
"\x09      /* Overlap. */\x0a"
"\x09      curr_max = MAX(max + 1, curr_max);\x0a"
"\x09      DPRINT((\x22overlap, curr_max = \x25""d\x5cn\x22, curr_max));\x0a"
"\x09      l = NULL;\x0a"
"\x09    }\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      /* No overlap. */\x0a"
"\x09      curr_max = min - 1;\x0a"
"\x09      if (curr_max >= curr_min)\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22no overlap\x5cn\x22));\x0a"
"\x09\x09  l->code_min = curr_min;\x0a"
"\x09\x09  l->code_max = curr_max;\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22no overlap, zero room\x5cn\x22));\x0a"
"\x09\x09  l = NULL;\x0a"
"\x09\x09}\x0a"
"\x09      curr_min = curr_max = max + 1;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"      if (l \x21= NULL)\x0a"
"\x09{\x0a"
"\x09  int k;\x0a"
"\x09  DPRINT((\x22""creating \x25""d - \x25""d\x5cn\x22, (int)l->code_min, (int)l->code_max));\x0a"
"\x09  l->position = ctx->position;\x0a"
"\x09  if (num_neg_classes > 0)\x0a"
"\x09    {\x0a"
"\x09      l->neg_classes = tre_mem_alloc(ctx->mem,\x0a"
"\x09\x09\x09\x09\x09     (sizeof(l->neg_classes)\x0a"
"\x09\x09\x09\x09\x09      * (num_neg_classes + 1)));\x0a"
"\x09      if (l->neg_classes == NULL)\x0a"
"\x09\x09{\x0a"
"\x09\x09  status = REG_ESPACE;\x0a"
"\x09\x09  break;\x0a"
"\x09\x09}\x0a"
"\x09      for (k = 0; k < num_neg_classes; k++)\x0a"
"\x09\x09l->neg_classes\x5bk\x5d = neg_classes\x5bk\x5d;\x0a"
"\x09      l->neg_classes\x5bk\x5d = (tre_ctype_t)0;\x0a"
"\x09    }\x0a"
"\x09  else\x0a"
"\x09    l->neg_classes = NULL;\x0a"
"\x09  if (node == NULL)\x0a"
"\x09    node = items\x5bj\x5d;\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      u = tre_ast_new_union(ctx->mem, node, items\x5bj\x5d);\x0a"
"\x09      if (u == NULL)\x0a"
"\x09\x09status = REG_ESPACE;\x0a"
"\x09      node = u;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  if (status \x21= REG_OK)\x0a"
"    goto parse_bracket_done;\x0a"
"\x0a"
"  if (negate)\x0a"
"    {\x0a"
"      int k;\x0a"
"      DPRINT((\x22""final\x3a creating \x25""d - \x25""d\x5cn\x22, curr_min, (int)TRE_CHAR_MAX));\x0a"
"      n = tre_ast_new_literal(ctx->mem, curr_min, TRE_CHAR_MAX, ctx->position);\x0a"
"      if (n == NULL)\x0a"
"\x09status = REG_ESPACE;\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  tre_literal_t *l = n->obj;\x0a"
"\x09  if (num_neg_classes > 0)\x0a"
"\x09    {\x0a"
"\x09      l->neg_classes = tre_mem_alloc(ctx->mem,\x0a"
"\x09\x09\x09\x09\x09     (sizeof(l->neg_classes)\x0a"
"\x09\x09\x09\x09\x09      * (num_neg_classes + 1)));\x0a"
"\x09      if (l->neg_classes == NULL)\x0a"
"\x09\x09{\x0a"
"\x09\x09  status = REG_ESPACE;\x0a"
"\x09\x09  goto parse_bracket_done;\x0a"
"\x09\x09}\x0a"
"\x09      for (k = 0; k < num_neg_classes; k++)\x0a"
"\x09\x09l->neg_classes\x5bk\x5d = neg_classes\x5bk\x5d;\x0a"
"\x09      l->neg_classes\x5bk\x5d = (tre_ctype_t)0;\x0a"
"\x09    }\x0a"
"\x09  else\x0a"
"\x09    l->neg_classes = NULL;\x0a"
"\x09  if (node == NULL)\x0a"
"\x09    node = n;\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      u = tre_ast_new_union(ctx->mem, node, n);\x0a"
"\x09      if (u == NULL)\x0a"
"\x09\x09status = REG_ESPACE;\x0a"
"\x09      node = u;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  if (status \x21= REG_OK)\x0a"
"    goto parse_bracket_done;\x0a"
"\x0a"
"#ifdef TRE_DEBUG\x0a"
"  tre_ast_print(node);\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x0a"
" parse_bracket_done\x3a\x0a"
"  xfree(items);\x0a"
"  ctx->position++;\x0a"
"  *result = node;\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* Parses a positive decimal integer.  Returns -1 if the string does not\x0a"
"   contain a valid number. */\x0a"
"static int\x0a"
"tre_parse_int(const tre_char_t **regex, const tre_char_t *regex_end)\x0a"
"{\x0a"
"  int num = -1;\x0a"
"  const tre_char_t *r = *regex;\x0a"
"  while (r < regex_end \x26\x26 *r >= L'0' \x26\x26 *r <= L'9')\x0a"
"    {\x0a"
"      if (num < 0)\x0a"
"\x09num = 0;\x0a"
"      num = num * 10 + *r - L'0';\x0a"
"      r++;\x0a"
"    }\x0a"
"  *regex = r;\x0a"
"  return num;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"static reg_errcode_t\x0a"
"tre_parse_bound(tre_parse_ctx_t *ctx, tre_ast_node_t **result)\x0a"
"{\x0a"
"  int min, max, i;\x0a"
"  int cost_ins, cost_del, cost_subst, cost_max;\x0a"
"  int limit_ins, limit_del, limit_subst, limit_err;\x0a"
"  const tre_char_t *r = ctx->re;\x0a"
"  const tre_char_t *start;\x0a"
"  int minimal = (ctx->cflags \x26 REG_UNGREEDY) \x3f 1 \x3a 0;\x0a"
"  int approx = 0;\x0a"
"  int costs_set = 0;\x0a"
"  int counts_set = 0;\x0a"
"\x0a"
"  cost_ins = cost_del = cost_subst = cost_max = TRE_PARAM_UNSET;\x0a"
"  limit_ins = limit_del = limit_subst = limit_err = TRE_PARAM_UNSET;\x0a"
"\x0a"
"  /* Parse number (minimum repetition count). */\x0a"
"  min = -1;\x0a"
"  if (r < ctx->re_end \x26\x26 *r >= L'0' \x26\x26 *r <= L'9') {\x0a"
"    DPRINT((\x22tre_parse\x3a\x09  min count\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(r)));\x0a"
"    min = tre_parse_int(\x26r, ctx->re_end);\x0a"
"  }\x0a"
"\x0a"
"  /* Parse comma and second number (maximum repetition count). */\x0a"
"  max = min;\x0a"
"  if (r < ctx->re_end \x26\x26 *r == CHAR_COMMA)\x0a"
"    {\x0a"
"      r++;\x0a"
"      DPRINT((\x22tre_parse\x3a   max count\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(r)));\x0a"
"      max = tre_parse_int(\x26r, ctx->re_end);\x0a"
"    }\x0a"
"\x0a"
"  /* Check that the repeat counts are sane. */\x0a"
"  if ((max >= 0 \x26\x26 min > max) \x7c\x7c max > RE_DUP_MAX)\x0a"
"    return REG_BADBR;\x0a"
"\x0a"
"\x0a"
"  /*\x0a"
"   '{'\x0a"
"     optionally followed immediately by a number == minimum repcount\x0a"
"     optionally followed by , then a number == maximum repcount\x0a"
"      + then a number == maximum insertion count\x0a"
"      - then a number == maximum deletion count\x0a"
"      # then a number == maximum substitution count\x0a"
"      \x7e then a number == maximum number of errors\x0a"
"      Any of +, -, # or \x7e without followed by a number means that\x0a"
"      the maximum count/number of errors is infinite.\x0a"
"\x0a"
"      An equation of the form\x0a"
"\x09Xi + Yd + Zs < C\x0a"
"      can be specified to set costs and the cost limit to a value\x0a"
"      different from the default value\x3a\x0a"
"\x09- X is the cost of an insertion\x0a"
"\x09- Y is the cost of a deletion\x0a"
"\x09- Z is the cost of a substitution\x0a"
"\x09- C is the maximum cost\x0a"
"\x0a"
"      If no count limit or cost is set for an operation, the operation\x0a"
"      is not allowed at all.\x0a"
"  */\x0a"
"\x0a"
"\x0a"
"  do {\x0a"
"    int done;\x0a"
"    start = r;\x0a"
"\x0a"
"    /* Parse count limit settings */\x0a"
"    done = 0;\x0a"
"    if (\x21""counts_set)\x0a"
"      while (r + 1 < ctx->re_end \x26\x26 \x21""done)\x0a"
"\x09{\x0a"
"\x09  switch (*r)\x0a"
"\x09    {\x0a"
"\x09    case CHAR_PLUS\x3a  /* Insert limit */\x0a"
"\x09      DPRINT((\x22tre_parse\x3a   ins limit\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(r)));\x0a"
"\x09      r++;\x0a"
"\x09      limit_ins = tre_parse_int(\x26r, ctx->re_end);\x0a"
"\x09      if (limit_ins < 0)\x0a"
"\x09\x09limit_ins = INT_MAX;\x0a"
"\x09      counts_set = 1;\x0a"
"\x09      break;\x0a"
"\x09    case CHAR_MINUS\x3a /* Delete limit */\x0a"
"\x09      DPRINT((\x22tre_parse\x3a   del limit\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(r)));\x0a"
"\x09      r++;\x0a"
"\x09      limit_del = tre_parse_int(\x26r, ctx->re_end);\x0a"
"\x09      if (limit_del < 0)\x0a"
"\x09\x09limit_del = INT_MAX;\x0a"
"\x09      counts_set = 1;\x0a"
"\x09      break;\x0a"
"\x09    case CHAR_HASH\x3a  /* Substitute limit */\x0a"
"\x09      DPRINT((\x22tre_parse\x3a subst limit\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(r)));\x0a"
"\x09      r++;\x0a"
"\x09      limit_subst = tre_parse_int(\x26r, ctx->re_end);\x0a"
"\x09      if (limit_subst < 0)\x0a"
"\x09\x09limit_subst = INT_MAX;\x0a"
"\x09      counts_set = 1;\x0a"
"\x09      break;\x0a"
"\x09    case CHAR_TILDE\x3a /* Maximum number of changes */\x0a"
"\x09      DPRINT((\x22tre_parse\x3a count limit\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(r)));\x0a"
"\x09      r++;\x0a"
"\x09      limit_err = tre_parse_int(\x26r, ctx->re_end);\x0a"
"\x09      if (limit_err < 0)\x0a"
"\x09\x09limit_err = INT_MAX;\x0a"
"\x09      approx = 1;\x0a"
"\x09      break;\x0a"
"\x09    case CHAR_COMMA\x3a\x0a"
"\x09      r++;\x0a"
"\x09      break;\x0a"
"\x09    case L' '\x3a\x0a"
"\x09      r++;\x0a"
"\x09      break;\x0a"
"\x09    case L'}'\x3a\x0a"
"\x09      done = 1;\x0a"
"\x09      break;\x0a"
"\x09    default\x3a\x0a"
"\x09      done = 1;\x0a"
"\x09      break;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* Parse cost restriction equation. */\x0a"
"    done = 0;\x0a"
"    if (\x21""costs_set)\x0a"
"      while (r + 1 < ctx->re_end \x26\x26 \x21""done)\x0a"
"\x09{\x0a"
"\x09  switch (*r)\x0a"
"\x09    {\x0a"
"\x09    case CHAR_PLUS\x3a\x0a"
"\x09    case L' '\x3a\x0a"
"\x09      r++;\x0a"
"\x09      break;\x0a"
"\x09    case L'<'\x3a\x0a"
"\x09      DPRINT((\x22tre_parse\x3a    max cost\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(r)));\x0a"
"\x09      r++;\x0a"
"\x09      while (*r == L' ')\x0a"
"\x09\x09r++;\x0a"
"\x09      cost_max = tre_parse_int(\x26r, ctx->re_end);\x0a"
"\x09      if (cost_max < 0)\x0a"
"\x09\x09""cost_max = INT_MAX;\x0a"
"\x09      else\x0a"
"\x09\x09""cost_max--;\x0a"
"\x09      approx = 1;\x0a"
"\x09      break;\x0a"
"\x09    case CHAR_COMMA\x3a\x0a"
"\x09      r++;\x0a"
"\x09      done = 1;\x0a"
"\x09      break;\x0a"
"\x09    default\x3a\x0a"
"\x09      if (*r >= L'0' \x26\x26 *r <= L'9')\x0a"
"\x09\x09{\x0a"
"#ifdef TRE_DEBUG\x0a"
"\x09\x09  const tre_char_t *sr = r;\x0a"
"#endif /* TRE_DEBUG */\x0a"
"\x09\x09  int cost = tre_parse_int(\x26r, ctx->re_end);\x0a"
"\x09\x09  /* XXX - make sure r is not past end. */\x0a"
"\x09\x09  switch (*r)\x0a"
"\x09\x09    {\x0a"
"\x09\x09    case L'i'\x3a\x09/* Insert cost */\x0a"
"\x09\x09      DPRINT((\x22tre_parse\x3a    ins cost\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09      REST(sr)));\x0a"
"\x09\x09      r++;\x0a"
"\x09\x09      cost_ins = cost;\x0a"
"\x09\x09      costs_set = 1;\x0a"
"\x09\x09      break;\x0a"
"\x09\x09    case L'd'\x3a\x09/* Delete cost */\x0a"
"\x09\x09      DPRINT((\x22tre_parse\x3a    del cost\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09      REST(sr)));\x0a"
"\x09\x09      r++;\x0a"
"\x09\x09      cost_del = cost;\x0a"
"\x09\x09      costs_set = 1;\x0a"
"\x09\x09      break;\x0a"
"\x09\x09    case L's'\x3a\x09/* Substitute cost */\x0a"
"\x09\x09      DPRINT((\x22tre_parse\x3a  subst cost\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09      REST(sr)));\x0a"
"\x09\x09      r++;\x0a"
"\x09\x09      cost_subst = cost;\x0a"
"\x09\x09      costs_set = 1;\x0a"
"\x09\x09      break;\x0a"
"\x09\x09    default\x3a\x0a"
"\x09\x09      return REG_BADBR;\x0a"
"\x09\x09    }\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09{\x0a"
"\x09\x09  done = 1;\x0a"
"\x09\x09  break;\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"  } while (start \x21= r);\x0a"
"\x0a"
"  /* Missing }. */\x0a"
"  if (r >= ctx->re_end)\x0a"
"    return REG_EBRACE;\x0a"
"\x0a"
"  /* Empty contents of {}. */\x0a"
"  if (r == ctx->re)\x0a"
"    return REG_BADBR;\x0a"
"\x0a"
"  /* Parse the ending '}' or '\x5c}'.*/\x0a"
"  if (ctx->cflags \x26 REG_EXTENDED)\x0a"
"    {\x0a"
"      if (r >= ctx->re_end \x7c\x7c *r \x21= CHAR_RBRACE)\x0a"
"\x09return REG_BADBR;\x0a"
"      r++;\x0a"
"    }\x0a"
"  else\x0a"
"    {\x0a"
"      if (r + 1 >= ctx->re_end\x0a"
"\x09  \x7c\x7c *r \x21= CHAR_BACKSLASH\x0a"
"\x09  \x7c\x7c *(r + 1) \x21= CHAR_RBRACE)\x0a"
"\x09return REG_BADBR;\x0a"
"      r += 2;\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"  /* Parse trailing '\x3f' marking minimal repetition. */\x0a"
"  if (r < ctx->re_end)\x0a"
"    {\x0a"
"      if (*r == CHAR_QUESTIONMARK)\x0a"
"\x09{\x0a"
"\x09  minimal = \x21(ctx->cflags \x26 REG_UNGREEDY);\x0a"
"\x09  r++;\x0a"
"\x09}\x0a"
"      else if (*r == CHAR_STAR \x7c\x7c *r == CHAR_PLUS)\x0a"
"\x09{\x0a"
"\x09  /* These are reserved for future extensions. */\x0a"
"\x09  return REG_BADRPT;\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  /* Create the AST node(s). */\x0a"
"  if (min == 0 \x26\x26 max == 0)\x0a"
"    {\x0a"
"      *result = tre_ast_new_literal(ctx->mem, EMPTY, -1, -1);\x0a"
"      if (*result == NULL)\x0a"
"\x09return REG_ESPACE;\x0a"
"    }\x0a"
"  else\x0a"
"    {\x0a"
"      if (min < 0 \x26\x26 max < 0)\x0a"
"\x09/* Only approximate parameters set, no repetitions. */\x0a"
"\x09min = max = 1;\x0a"
"\x0a"
"      *result = tre_ast_new_iter(ctx->mem, *result, min, max, minimal);\x0a"
"      if (\x21*result)\x0a"
"\x09return REG_ESPACE;\x0a"
"\x0a"
"      /* If approximate matching parameters are set, add them to the\x0a"
"\x09 iteration node. */\x0a"
"      if (approx \x7c\x7c costs_set \x7c\x7c counts_set)\x0a"
"\x09{\x0a"
"\x09  int *params;\x0a"
"\x09  tre_iteration_t *iter = (*result)->obj;\x0a"
"\x0a"
"\x09  if (costs_set \x7c\x7c counts_set)\x0a"
"\x09    {\x0a"
"\x09      if (limit_ins == TRE_PARAM_UNSET)\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (cost_ins == TRE_PARAM_UNSET)\x0a"
"\x09\x09    limit_ins = 0;\x0a"
"\x09\x09  else\x0a"
"\x09\x09    limit_ins = INT_MAX;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      if (limit_del == TRE_PARAM_UNSET)\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (cost_del == TRE_PARAM_UNSET)\x0a"
"\x09\x09    limit_del = 0;\x0a"
"\x09\x09  else\x0a"
"\x09\x09    limit_del = INT_MAX;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      if (limit_subst == TRE_PARAM_UNSET)\x0a"
"\x09\x09{\x0a"
"\x09\x09  if (cost_subst == TRE_PARAM_UNSET)\x0a"
"\x09\x09    limit_subst = 0;\x0a"
"\x09\x09  else\x0a"
"\x09\x09    limit_subst = INT_MAX;\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x0a"
"\x09  if (cost_max == TRE_PARAM_UNSET)\x0a"
"\x09    cost_max = INT_MAX;\x0a"
"\x09  if (limit_err == TRE_PARAM_UNSET)\x0a"
"\x09    limit_err = INT_MAX;\x0a"
"\x0a"
"\x09  ctx->have_approx = 1;\x0a"
"\x09  params = tre_mem_alloc(ctx->mem, sizeof(*params) * TRE_PARAM_LAST);\x0a"
"\x09  if (\x21params)\x0a"
"\x09    return REG_ESPACE;\x0a"
"\x09  for (i = 0; i < TRE_PARAM_LAST; i++)\x0a"
"\x09    params\x5bi\x5d = TRE_PARAM_UNSET;\x0a"
"\x09  params\x5bTRE_PARAM_COST_INS\x5d = cost_ins;\x0a"
"\x09  params\x5bTRE_PARAM_COST_DEL\x5d = cost_del;\x0a"
"\x09  params\x5bTRE_PARAM_COST_SUBST\x5d = cost_subst;\x0a"
"\x09  params\x5bTRE_PARAM_COST_MAX\x5d = cost_max;\x0a"
"\x09  params\x5bTRE_PARAM_MAX_INS\x5d = limit_ins;\x0a"
"\x09  params\x5bTRE_PARAM_MAX_DEL\x5d = limit_del;\x0a"
"\x09  params\x5bTRE_PARAM_MAX_SUBST\x5d = limit_subst;\x0a"
"\x09  params\x5bTRE_PARAM_MAX_ERR\x5d = limit_err;\x0a"
"\x09  iter->params = params;\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  DPRINT((\x22tre_parse_bound\x3a min \x25""d, max \x25""d, costs \x5b\x25""d,\x25""d,\x25""d, total \x25""d\x5d, \x22\x0a"
"\x09  \x22limits \x5b\x25""d,\x25""d,\x25""d, total \x25""d\x5d\x5cn\x22,\x0a"
"\x09  min, max, cost_ins, cost_del, cost_subst, cost_max,\x0a"
"\x09  limit_ins, limit_del, limit_subst, limit_err));\x0a"
"\x0a"
"\x0a"
"  ctx->re = r;\x0a"
"  return REG_OK;\x0a"
"}\x0a"
"\x0a"
"typedef enum {\x0a"
"  PARSE_RE = 0,\x0a"
"  PARSE_ATOM,\x0a"
"  PARSE_MARK_FOR_SUBMATCH,\x0a"
"  PARSE_BRANCH,\x0a"
"  PARSE_PIECE,\x0a"
"  PARSE_CATENATION,\x0a"
"  PARSE_POST_CATENATION,\x0a"
"  PARSE_UNION,\x0a"
"  PARSE_POST_UNION,\x0a"
"  PARSE_POSTFIX,\x0a"
"  PARSE_RESTORE_CFLAGS\x0a"
"} tre_parse_re_stack_symbol_t;\x0a"
"\x0a"
"\x0a"
"reg_errcode_t\x0a"
"tre_parse(tre_parse_ctx_t *ctx)\x0a"
"{\x0a"
"  tre_ast_node_t *result = NULL;\x0a"
"  tre_parse_re_stack_symbol_t symbol;\x0a"
"  reg_errcode_t status = REG_OK;\x0a"
"  tre_stack_t *stack = ctx->stack;\x0a"
"  int bottom = tre_stack_num_objects(stack);\x0a"
"  int depth = 0;\x0a"
"  int temporary_cflags = 0;\x0a"
"\x0a"
"  DPRINT((\x22tre_parse\x3a parsing '\x25.*\x22 STRF \x22', len = \x25""d\x5cn\x22,\x0a"
"\x09  ctx->len, ctx->re, ctx->len));\x0a"
"\x0a"
"  if (\x21""ctx->nofirstsub)\x0a"
"    {\x0a"
"      STACK_PUSH(stack, int, ctx->submatch_id);\x0a"
"      STACK_PUSH(stack, int, PARSE_MARK_FOR_SUBMATCH);\x0a"
"      ctx->submatch_id++;\x0a"
"    }\x0a"
"  STACK_PUSH(stack, int, PARSE_RE);\x0a"
"  ctx->re_start = ctx->re;\x0a"
"  ctx->re_end = ctx->re + ctx->len;\x0a"
"\x0a"
"\x0a"
"  /* The following is basically just a recursive descent parser.  I use\x0a"
"     an explicit stack instead of recursive functions mostly because of\x0a"
"     two reasons\x3a compatibility with systems which have an overflowable\x0a"
"     call stack, and efficiency (both in lines of code and speed).  */\x0a"
"  while (tre_stack_num_objects(stack) > bottom \x26\x26 status == REG_OK)\x0a"
"    {\x0a"
"      if (status \x21= REG_OK)\x0a"
"\x09""break;\x0a"
"      symbol = tre_stack_pop_int(stack);\x0a"
"      switch (symbol)\x0a"
"\x09{\x0a"
"\x09""case PARSE_RE\x3a\x0a"
"\x09  /* Parse a full regexp.  A regexp is one or more branches,\x0a"
"\x09     separated by the union operator \x60\x7c'. */\x0a"
"#ifdef REG_LITERAL\x0a"
"\x09  if (\x21(ctx->cflags \x26 REG_LITERAL)\x0a"
"\x09      \x26\x26 ctx->cflags \x26 REG_EXTENDED)\x0a"
"#endif /* REG_LITERAL */\x0a"
"\x09    STACK_PUSHX(stack, int, PARSE_UNION);\x0a"
"\x09  STACK_PUSHX(stack, int, PARSE_BRANCH);\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case PARSE_BRANCH\x3a\x0a"
"\x09  /* Parse a branch.  A branch is one or more pieces, concatenated.\x0a"
"\x09     A piece is an atom possibly followed by a postfix operator. */\x0a"
"\x09  STACK_PUSHX(stack, int, PARSE_CATENATION);\x0a"
"\x09  STACK_PUSHX(stack, int, PARSE_PIECE);\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case PARSE_PIECE\x3a\x0a"
"\x09  /* Parse a piece.  A piece is an atom possibly followed by one\x0a"
"\x09     or more postfix operators. */\x0a"
"#ifdef REG_LITERAL\x0a"
"\x09  if (\x21(ctx->cflags \x26 REG_LITERAL))\x0a"
"#endif /* REG_LITERAL */\x0a"
"\x09    STACK_PUSHX(stack, int, PARSE_POSTFIX);\x0a"
"\x09  STACK_PUSHX(stack, int, PARSE_ATOM);\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case PARSE_CATENATION\x3a\x0a"
"\x09  /* If the expression has not ended, parse another piece. */\x0a"
"\x09  {\x0a"
"\x09    tre_char_t c;\x0a"
"\x09    if (ctx->re >= ctx->re_end)\x0a"
"\x09      break;\x0a"
"\x09    c = *ctx->re;\x0a"
"#ifdef REG_LITERAL\x0a"
"\x09    if (\x21(ctx->cflags \x26 REG_LITERAL))\x0a"
"\x09      {\x0a"
"#endif /* REG_LITERAL */\x0a"
"\x09\x09if (ctx->cflags \x26 REG_EXTENDED \x26\x26 c == CHAR_PIPE)\x0a"
"\x09\x09  break;\x0a"
"\x09\x09if ((ctx->cflags \x26 REG_EXTENDED\x0a"
"\x09\x09     \x26\x26 c == CHAR_RPAREN \x26\x26 depth > 0)\x0a"
"\x09\x09    \x7c\x7c (\x21(ctx->cflags \x26 REG_EXTENDED)\x0a"
"\x09\x09\x09\x26\x26 (c == CHAR_BACKSLASH\x0a"
"\x09\x09\x09    \x26\x26 *(ctx->re + 1) == CHAR_RPAREN)))\x0a"
"\x09\x09  {\x0a"
"\x09\x09    if (\x21(ctx->cflags \x26 REG_EXTENDED) \x26\x26 depth == 0)\x0a"
"\x09\x09      status = REG_EPAREN;\x0a"
"\x09\x09    DPRINT((\x22tre_parse\x3a\x09  group end\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09    REST(ctx->re)));\x0a"
"\x09\x09    depth--;\x0a"
"\x09\x09    if (\x21(ctx->cflags \x26 REG_EXTENDED))\x0a"
"\x09\x09      ctx->re += 2;\x0a"
"\x09\x09    break;\x0a"
"\x09\x09  }\x0a"
"#ifdef REG_LITERAL\x0a"
"\x09      }\x0a"
"#endif /* REG_LITERAL */\x0a"
"\x0a"
"#ifdef REG_RIGHT_ASSOC\x0a"
"\x09    if (ctx->cflags \x26 REG_RIGHT_ASSOC)\x0a"
"\x09      {\x0a"
"\x09\x09/* Right associative concatenation. */\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, result);\x0a"
"\x09\x09STACK_PUSHX(stack, int, PARSE_POST_CATENATION);\x0a"
"\x09\x09STACK_PUSHX(stack, int, PARSE_CATENATION);\x0a"
"\x09\x09STACK_PUSHX(stack, int, PARSE_PIECE);\x0a"
"\x09      }\x0a"
"\x09    else\x0a"
"#endif /* REG_RIGHT_ASSOC */\x0a"
"\x09      {\x0a"
"\x09\x09/* Default case, left associative concatenation. */\x0a"
"\x09\x09STACK_PUSHX(stack, int, PARSE_CATENATION);\x0a"
"\x09\x09STACK_PUSHX(stack, voidptr, result);\x0a"
"\x09\x09STACK_PUSHX(stack, int, PARSE_POST_CATENATION);\x0a"
"\x09\x09STACK_PUSHX(stack, int, PARSE_PIECE);\x0a"
"\x09      }\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""case PARSE_POST_CATENATION\x3a\x0a"
"\x09  {\x0a"
"\x09    tre_ast_node_t *tree = tre_stack_pop_voidptr(stack);\x0a"
"\x09    tre_ast_node_t *tmp_node;\x0a"
"\x09    tmp_node = tre_ast_new_catenation(ctx->mem, tree, result);\x0a"
"\x09    if (\x21tmp_node)\x0a"
"\x09      return REG_ESPACE;\x0a"
"\x09    result = tmp_node;\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""case PARSE_UNION\x3a\x0a"
"\x09  if (ctx->re >= ctx->re_end)\x0a"
"\x09    break;\x0a"
"#ifdef REG_LITERAL\x0a"
"\x09  if (ctx->cflags \x26 REG_LITERAL)\x0a"
"\x09    break;\x0a"
"#endif /* REG_LITERAL */\x0a"
"\x09  switch (*ctx->re)\x0a"
"\x09    {\x0a"
"\x09    case CHAR_PIPE\x3a\x0a"
"\x09      DPRINT((\x22tre_parse\x3a\x09union\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09      REST(ctx->re)));\x0a"
"\x09      STACK_PUSHX(stack, int, PARSE_UNION);\x0a"
"\x09      STACK_PUSHX(stack, voidptr, result);\x0a"
"\x09      STACK_PUSHX(stack, int, PARSE_POST_UNION);\x0a"
"\x09      STACK_PUSHX(stack, int, PARSE_BRANCH);\x0a"
"\x09      ctx->re++;\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    case CHAR_RPAREN\x3a\x0a"
"\x09      ctx->re++;\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    default\x3a\x0a"
"\x09      break;\x0a"
"\x09    }\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case PARSE_POST_UNION\x3a\x0a"
"\x09  {\x0a"
"\x09    tre_ast_node_t *tmp_node;\x0a"
"\x09    tre_ast_node_t *tree = tre_stack_pop_voidptr(stack);\x0a"
"\x09    tmp_node = tre_ast_new_union(ctx->mem, tree, result);\x0a"
"\x09    if (\x21tmp_node)\x0a"
"\x09      return REG_ESPACE;\x0a"
"\x09    result = tmp_node;\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""case PARSE_POSTFIX\x3a\x0a"
"\x09  /* Parse postfix operators. */\x0a"
"\x09  if (ctx->re >= ctx->re_end)\x0a"
"\x09    break;\x0a"
"#ifdef REG_LITERAL\x0a"
"\x09  if (ctx->cflags \x26 REG_LITERAL)\x0a"
"\x09    break;\x0a"
"#endif /* REG_LITERAL */\x0a"
"\x09  switch (*ctx->re)\x0a"
"\x09    {\x0a"
"\x09    case CHAR_PLUS\x3a\x0a"
"\x09    case CHAR_QUESTIONMARK\x3a\x0a"
"\x09      if (\x21(ctx->cflags \x26 REG_EXTENDED))\x0a"
"\x09\x09""break;\x0a"
"\x09\x09/*FALLTHROUGH*/\x0a"
"\x09    case CHAR_STAR\x3a\x0a"
"\x09      {\x0a"
"\x09\x09tre_ast_node_t *tmp_node;\x0a"
"\x09\x09int minimal = (ctx->cflags \x26 REG_UNGREEDY) \x3f 1 \x3a 0;\x0a"
"\x09\x09int rep_min = 0;\x0a"
"\x09\x09int rep_max = -1;\x0a"
"#ifdef TRE_DEBUG\x0a"
"\x09\x09""const tre_char_t *tmp_re;\x0a"
"#endif\x0a"
"\x0a"
"\x09\x09if (*ctx->re == CHAR_PLUS)\x0a"
"\x09\x09  rep_min = 1;\x0a"
"\x09\x09if (*ctx->re == CHAR_QUESTIONMARK)\x0a"
"\x09\x09  rep_max = 1;\x0a"
"#ifdef TRE_DEBUG\x0a"
"\x09\x09tmp_re = ctx->re;\x0a"
"#endif\x0a"
"\x0a"
"\x09\x09if (ctx->re + 1 < ctx->re_end)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    if (*(ctx->re + 1) == CHAR_QUESTIONMARK)\x0a"
"\x09\x09      {\x0a"
"\x09\x09\x09minimal = \x21(ctx->cflags \x26 REG_UNGREEDY);\x0a"
"\x09\x09\x09""ctx->re++;\x0a"
"\x09\x09      }\x0a"
"\x09\x09    else if (*(ctx->re + 1) == CHAR_STAR\x0a"
"\x09\x09\x09     \x7c\x7c *(ctx->re + 1) == CHAR_PLUS)\x0a"
"\x09\x09      {\x0a"
"\x09\x09\x09/* These are reserved for future extensions. */\x0a"
"\x09\x09\x09return REG_BADRPT;\x0a"
"\x09\x09      }\x0a"
"\x09\x09  }\x0a"
"\x0a"
"\x09\x09""DPRINT((\x22tre_parse\x3a \x25s star\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09minimal \x3f \x22  minimal\x22 \x3a \x22greedy\x22, REST(tmp_re)));\x0a"
"\x09\x09""ctx->re++;\x0a"
"\x09\x09tmp_node = tre_ast_new_iter(ctx->mem, result, rep_min, rep_max,\x0a"
"\x09\x09\x09\x09\x09    minimal);\x0a"
"\x09\x09if (tmp_node == NULL)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09result = tmp_node;\x0a"
"\x09\x09STACK_PUSHX(stack, int, PARSE_POSTFIX);\x0a"
"\x09      }\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    case CHAR_BACKSLASH\x3a\x0a"
"\x09      /* \x22\x5c{\x22 is special without REG_EXTENDED */\x0a"
"\x09      if (\x21(ctx->cflags \x26 REG_EXTENDED)\x0a"
"\x09\x09  \x26\x26 ctx->re + 1 < ctx->re_end\x0a"
"\x09\x09  \x26\x26 *(ctx->re + 1) == CHAR_LBRACE)\x0a"
"\x09\x09{\x0a"
"\x09\x09  ctx->re++;\x0a"
"\x09\x09  goto parse_brace;\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09""break;\x0a"
"\x0a"
"\x09    case CHAR_LBRACE\x3a\x0a"
"\x09      /* \x22{\x22 is literal without REG_EXTENDED */\x0a"
"\x09      if (\x21(ctx->cflags \x26 REG_EXTENDED))\x0a"
"\x09\x09""break;\x0a"
"\x0a"
"\x09    parse_brace\x3a\x0a"
"\x09      DPRINT((\x22tre_parse\x3a\x09""bound\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09      REST(ctx->re)));\x0a"
"\x09      ctx->re++;\x0a"
"\x0a"
"\x09      status = tre_parse_bound(ctx, \x26result);\x0a"
"\x09      if (status \x21= REG_OK)\x0a"
"\x09\x09return status;\x0a"
"\x09      STACK_PUSHX(stack, int, PARSE_POSTFIX);\x0a"
"\x09      break;\x0a"
"\x09    }\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case PARSE_ATOM\x3a\x0a"
"\x09  /* Parse an atom.  An atom is a regular expression enclosed in \x60()',\x0a"
"\x09     an empty set of \x60()', a bracket expression, \x60.', \x60^', \x60\x24',\x0a"
"\x09     a \x60\x5c' followed by a character, or a single character. */\x0a"
"\x0a"
"\x09  /* End of regexp\x3f (empty string). */\x0a"
"\x09  if (ctx->re >= ctx->re_end)\x0a"
"\x09    goto parse_literal;\x0a"
"\x0a"
"#ifdef REG_LITERAL\x0a"
"\x09  if (ctx->cflags \x26 REG_LITERAL)\x0a"
"\x09    goto parse_literal;\x0a"
"#endif /* REG_LITERAL */\x0a"
"\x0a"
"\x09  switch (*ctx->re)\x0a"
"\x09    {\x0a"
"\x09    case CHAR_LPAREN\x3a  /* parenthesized subexpression */\x0a"
"\x0a"
"\x09      /* Handle \x22(\x3f...)\x22 extensions.  They work in a way similar\x0a"
"\x09\x09 to Perls corresponding extensions. */\x0a"
"\x09      if (ctx->cflags \x26 REG_EXTENDED\x0a"
"\x09\x09  \x26\x26 *(ctx->re + 1) == CHAR_QUESTIONMARK)\x0a"
"\x09\x09{\x0a"
"\x09\x09  int new_cflags = ctx->cflags;\x0a"
"\x09\x09  int bit = 1;\x0a"
"\x09\x09  DPRINT((\x22tre_parse\x3a\x09""extension\x3a '\x25.*\x22 STRF \x22\x5cn\x22,\x0a"
"\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09  ctx->re += 2;\x0a"
"\x09\x09  while (/*CONSTCOND*/(void)1,1)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      if (*ctx->re == L'i')\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  DPRINT((\x22tre_parse\x3a\x09    icase\x3a '\x25.*\x22 STRF \x22\x5cn\x22,\x0a"
"\x09\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09\x09  if (bit)\x0a"
"\x09\x09\x09    new_cflags \x7c= REG_ICASE;\x0a"
"\x09\x09\x09  else\x0a"
"\x09\x09\x09    new_cflags \x26= \x7eREG_ICASE;\x0a"
"\x09\x09\x09  ctx->re++;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09      else if (*ctx->re == L'n')\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  DPRINT((\x22tre_parse\x3a\x09  newline\x3a '\x25.*\x22 STRF \x22\x5cn\x22,\x0a"
"\x09\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09\x09  if (bit)\x0a"
"\x09\x09\x09    new_cflags \x7c= REG_NEWLINE;\x0a"
"\x09\x09\x09  else\x0a"
"\x09\x09\x09    new_cflags \x26= \x7eREG_NEWLINE;\x0a"
"\x09\x09\x09  ctx->re++;\x0a"
"\x09\x09\x09}\x0a"
"#ifdef REG_RIGHT_ASSOC\x0a"
"\x09\x09      else if (*ctx->re == L'r')\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  DPRINT((\x22tre_parse\x3a right assoc\x3a '\x25.*\x22 STRF \x22\x5cn\x22,\x0a"
"\x09\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09\x09  if (bit)\x0a"
"\x09\x09\x09    new_cflags \x7c= REG_RIGHT_ASSOC;\x0a"
"\x09\x09\x09  else\x0a"
"\x09\x09\x09    new_cflags \x26= \x7eREG_RIGHT_ASSOC;\x0a"
"\x09\x09\x09  ctx->re++;\x0a"
"\x09\x09\x09}\x0a"
"#endif /* REG_RIGHT_ASSOC */\x0a"
"#ifdef REG_UNGREEDY\x0a"
"\x09\x09      else if (*ctx->re == L'U')\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  DPRINT((\x22tre_parse\x3a    ungreedy\x3a '\x25.*\x22 STRF \x22\x5cn\x22,\x0a"
"\x09\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09\x09  if (bit)\x0a"
"\x09\x09\x09    new_cflags \x7c= REG_UNGREEDY;\x0a"
"\x09\x09\x09  else\x0a"
"\x09\x09\x09    new_cflags \x26= \x7eREG_UNGREEDY;\x0a"
"\x09\x09\x09  ctx->re++;\x0a"
"\x09\x09\x09}\x0a"
"#endif /* REG_UNGREEDY */\x0a"
"\x09\x09      else if (*ctx->re == CHAR_MINUS)\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  DPRINT((\x22tre_parse\x3a\x09 turn off\x3a '\x25.*\x22 STRF \x22\x5cn\x22,\x0a"
"\x09\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09\x09  ctx->re++;\x0a"
"\x09\x09\x09  bit = 0;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09      else if (*ctx->re == CHAR_COLON)\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  DPRINT((\x22tre_parse\x3a\x09 no group\x3a '\x25.*\x22 STRF \x22\x5cn\x22,\x0a"
"\x09\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09\x09  ctx->re++;\x0a"
"\x09\x09\x09  depth++;\x0a"
"\x09\x09\x09  break;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09      else if (*ctx->re == CHAR_HASH)\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  DPRINT((\x22tre_parse\x3a    comment\x3a '\x25.*\x22 STRF \x22\x5cn\x22,\x0a"
"\x09\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09\x09  /* A comment can contain any character except a\x0a"
"\x09\x09\x09     right parenthesis */\x0a"
"\x09\x09\x09  while (*ctx->re \x21= CHAR_RPAREN\x0a"
"\x09\x09\x09\x09 \x26\x26 ctx->re < ctx->re_end)\x0a"
"\x09\x09\x09    ctx->re++;\x0a"
"\x09\x09\x09  if (*ctx->re == CHAR_RPAREN \x26\x26 ctx->re < ctx->re_end)\x0a"
"\x09\x09\x09    {\x0a"
"\x09\x09\x09      ctx->re++;\x0a"
"\x09\x09\x09      break;\x0a"
"\x09\x09\x09    }\x0a"
"\x09\x09\x09  else\x0a"
"\x09\x09\x09    return REG_BADPAT;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09      else if (*ctx->re == CHAR_RPAREN)\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  ctx->re++;\x0a"
"\x09\x09\x09  break;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09      else\x0a"
"\x09\x09\x09return REG_BADPAT;\x0a"
"\x09\x09    }\x0a"
"\x0a"
"\x09\x09  /* Turn on the cflags changes for the rest of the\x0a"
"\x09\x09     enclosing group. */\x0a"
"\x09\x09  STACK_PUSHX(stack, int, ctx->cflags);\x0a"
"\x09\x09  STACK_PUSHX(stack, int, PARSE_RESTORE_CFLAGS);\x0a"
"\x09\x09  STACK_PUSHX(stack, int, PARSE_RE);\x0a"
"\x09\x09  ctx->cflags = new_cflags;\x0a"
"\x09\x09  break;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      if (ctx->cflags \x26 REG_EXTENDED\x0a"
"\x09\x09  \x7c\x7c (ctx->re > ctx->re_start\x0a"
"\x09\x09      \x26\x26 *(ctx->re - 1) == CHAR_BACKSLASH))\x0a"
"\x09\x09{\x0a"
"\x09\x09  depth++;\x0a"
"\x09\x09  if (ctx->re + 2 < ctx->re_end\x0a"
"\x09\x09      \x26\x26 *(ctx->re + 1) == CHAR_QUESTIONMARK\x0a"
"\x09\x09      \x26\x26 *(ctx->re + 2) == CHAR_COLON)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      DPRINT((\x22tre_parse\x3a group begin\x3a '\x25.*\x22 STRF\x0a"
"\x09\x09\x09      \x22', no submatch\x5cn\x22, REST(ctx->re)));\x0a"
"\x09\x09      /* Don't mark for submatching. */\x0a"
"\x09\x09      ctx->re += 3;\x0a"
"\x09\x09      STACK_PUSHX(stack, int, PARSE_RE);\x0a"
"\x09\x09    }\x0a"
"\x09\x09  else\x0a"
"\x09\x09    {\x0a"
"\x09\x09      DPRINT((\x22tre_parse\x3a group begin\x3a '\x25.*\x22 STRF\x0a"
"\x09\x09\x09      \x22', submatch \x25""d\x5cn\x22, REST(ctx->re),\x0a"
"\x09\x09\x09      ctx->submatch_id));\x0a"
"\x09\x09      ctx->re++;\x0a"
"\x09\x09      /* First parse a whole RE, then mark the resulting tree\x0a"
"\x09\x09\x09 for submatching. */\x0a"
"\x09\x09      STACK_PUSHX(stack, int, ctx->submatch_id);\x0a"
"\x09\x09      STACK_PUSHX(stack, int, PARSE_MARK_FOR_SUBMATCH);\x0a"
"\x09\x09      STACK_PUSHX(stack, int, PARSE_RE);\x0a"
"\x09\x09      ctx->submatch_id++;\x0a"
"\x09\x09    }\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09goto parse_literal;\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    case CHAR_RPAREN\x3a  /* end of current subexpression */\x0a"
"\x09      if ((ctx->cflags \x26 REG_EXTENDED \x26\x26 depth > 0)\x0a"
"\x09\x09  \x7c\x7c (ctx->re > ctx->re_start\x0a"
"\x09\x09      \x26\x26 *(ctx->re - 1) == CHAR_BACKSLASH))\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22tre_parse\x3a\x09    empty\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09  /* We were expecting an atom, but instead the current\x0a"
"\x09\x09     subexpression was closed.\x09POSIX leaves the meaning of\x0a"
"\x09\x09     this to be implementation-defined.\x09 We interpret this as\x0a"
"\x09\x09     an empty expression (which matches an empty string).  */\x0a"
"\x09\x09  result = tre_ast_new_literal(ctx->mem, EMPTY, -1, -1);\x0a"
"\x09\x09  if (result == NULL)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09  if (\x21(ctx->cflags \x26 REG_EXTENDED))\x0a"
"\x09\x09    ctx->re--;\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09goto parse_literal;\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    case CHAR_LBRACKET\x3a /* bracket expression */\x0a"
"\x09      DPRINT((\x22tre_parse\x3a     bracket\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09      REST(ctx->re)));\x0a"
"\x09      ctx->re++;\x0a"
"\x09      status = tre_parse_bracket(ctx, \x26result);\x0a"
"\x09      if (status \x21= REG_OK)\x0a"
"\x09\x09return status;\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    case CHAR_BACKSLASH\x3a\x0a"
"\x09      /* If this is \x22\x5c(\x22 or \x22\x5c)\x22 chew off the backslash and\x0a"
"\x09\x09 try again. */\x0a"
"\x09      if (\x21(ctx->cflags \x26 REG_EXTENDED)\x0a"
"\x09\x09  \x26\x26 ctx->re + 1 < ctx->re_end\x0a"
"\x09\x09  \x26\x26 (*(ctx->re + 1) == CHAR_LPAREN\x0a"
"\x09\x09      \x7c\x7c *(ctx->re + 1) == CHAR_RPAREN))\x0a"
"\x09\x09{\x0a"
"\x09\x09  ctx->re++;\x0a"
"\x09\x09  STACK_PUSHX(stack, int, PARSE_ATOM);\x0a"
"\x09\x09  break;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      /* If a macro is used, parse the expanded macro recursively. */\x0a"
"\x09      {\x0a"
"\x09\x09tre_char_t buf\x5b""64\x5d;\x0a"
"\x09\x09tre_expand_macro(ctx->re + 1, ctx->re_end,\x0a"
"\x09\x09\x09\x09 buf, elementsof(buf));\x0a"
"\x09\x09if (buf\x5b""0\x5d \x21= 0)\x0a"
"\x09\x09  {\x0a"
"\x09\x09    tre_parse_ctx_t subctx;\x0a"
"\x09\x09    memcpy(\x26subctx, ctx, sizeof(subctx));\x0a"
"\x09\x09    subctx.re = buf;\x0a"
"\x09\x09    subctx.len = tre_strlen(buf);\x0a"
"\x09\x09    subctx.nofirstsub = 1;\x0a"
"\x09\x09    status = tre_parse(\x26subctx);\x0a"
"\x09\x09    if (status \x21= REG_OK)\x0a"
"\x09\x09      return status;\x0a"
"\x09\x09    ctx->re += 2;\x0a"
"\x09\x09    ctx->position = subctx.position;\x0a"
"\x09\x09    result = subctx.result;\x0a"
"\x09\x09    break;\x0a"
"\x09\x09  }\x0a"
"\x09      }\x0a"
"\x0a"
"\x09      if (ctx->re + 1 >= ctx->re_end)\x0a"
"\x09\x09/* Trailing backslash. */\x0a"
"\x09\x09return REG_EESCAPE;\x0a"
"\x0a"
"#ifdef REG_LITERAL\x0a"
"\x09      if (*(ctx->re + 1) == L'Q')\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22tre_parse\x3a tmp literal\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09  ctx->cflags \x7c= REG_LITERAL;\x0a"
"\x09\x09  temporary_cflags \x7c= REG_LITERAL;\x0a"
"\x09\x09  ctx->re += 2;\x0a"
"\x09\x09  STACK_PUSHX(stack, int, PARSE_ATOM);\x0a"
"\x09\x09  break;\x0a"
"\x09\x09}\x0a"
"#endif /* REG_LITERAL */\x0a"
"\x0a"
"\x09      DPRINT((\x22tre_parse\x3a  bleep\x3a '\x25.*\x22 STRF \x22'\x5cn\x22, REST(ctx->re)));\x0a"
"\x09      ctx->re++;\x0a"
"\x09      switch (*ctx->re)\x0a"
"\x09\x09{\x0a"
"\x09\x09""case L'b'\x3a\x0a"
"\x09\x09  result = tre_ast_new_literal(ctx->mem, ASSERTION,\x0a"
"\x09\x09\x09\x09\x09       ASSERT_AT_WB, -1);\x0a"
"\x09\x09  ctx->re++;\x0a"
"\x09\x09  break;\x0a"
"\x09\x09""case L'B'\x3a\x0a"
"\x09\x09  result = tre_ast_new_literal(ctx->mem, ASSERTION,\x0a"
"\x09\x09\x09\x09\x09       ASSERT_AT_WB_NEG, -1);\x0a"
"\x09\x09  ctx->re++;\x0a"
"\x09\x09  break;\x0a"
"\x09\x09""case L'<'\x3a\x0a"
"\x09\x09  result = tre_ast_new_literal(ctx->mem, ASSERTION,\x0a"
"\x09\x09\x09\x09\x09       ASSERT_AT_BOW, -1);\x0a"
"\x09\x09  ctx->re++;\x0a"
"\x09\x09  break;\x0a"
"\x09\x09""case L'>'\x3a\x0a"
"\x09\x09  result = tre_ast_new_literal(ctx->mem, ASSERTION,\x0a"
"\x09\x09\x09\x09\x09       ASSERT_AT_EOW, -1);\x0a"
"\x09\x09  ctx->re++;\x0a"
"\x09\x09  break;\x0a"
"\x09\x09""case L'x'\x3a\x0a"
"\x09\x09  ctx->re++;\x0a"
"\x09\x09  if (ctx->re\x5b""0\x5d \x21= CHAR_LBRACE \x26\x26 ctx->re < ctx->re_end)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      /* 8 bit hex char. */\x0a"
"\x09\x09      char tmp\x5b""3\x5d = {0, 0, 0};\x0a"
"\x09\x09      long val;\x0a"
"\x09\x09      DPRINT((\x22tre_parse\x3a  8 bit hex\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09      REST(ctx->re - 2)));\x0a"
"\x0a"
"\x09\x09      if (tre_isxdigit(ctx->re\x5b""0\x5d) \x26\x26 ctx->re < ctx->re_end)\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  tmp\x5b""0\x5d = (char)ctx->re\x5b""0\x5d;\x0a"
"\x09\x09\x09  ctx->re++;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09      if (tre_isxdigit(ctx->re\x5b""0\x5d) \x26\x26 ctx->re < ctx->re_end)\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  tmp\x5b""1\x5d = (char)ctx->re\x5b""0\x5d;\x0a"
"\x09\x09\x09  ctx->re++;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09      val = strtol(tmp, NULL, 16);\x0a"
"\x09\x09      result = tre_ast_new_literal(ctx->mem, (int)val,\x0a"
"\x09\x09\x09\x09\x09\x09   (int)val, ctx->position);\x0a"
"\x09\x09      ctx->position++;\x0a"
"\x09\x09      break;\x0a"
"\x09\x09    }\x0a"
"\x09\x09  else if (ctx->re < ctx->re_end)\x0a"
"\x09\x09    {\x0a"
"\x09\x09      /* Wide char. */\x0a"
"\x09\x09      char tmp\x5b""32\x5d;\x0a"
"\x09\x09      long val;\x0a"
"\x09\x09      int i = 0;\x0a"
"\x09\x09      ctx->re++;\x0a"
"\x09\x09      while (ctx->re_end - ctx->re >= 0)\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09  if (ctx->re\x5b""0\x5d == CHAR_RBRACE)\x0a"
"\x09\x09\x09    break;\x0a"
"\x09\x09\x09  if (tre_isxdigit(ctx->re\x5b""0\x5d))\x0a"
"\x09\x09\x09    {\x0a"
"\x09\x09\x09      tmp\x5bi\x5d = (char)ctx->re\x5b""0\x5d;\x0a"
"\x09\x09\x09      i++;\x0a"
"\x09\x09\x09      ctx->re++;\x0a"
"\x09\x09\x09      continue;\x0a"
"\x09\x09\x09    }\x0a"
"\x09\x09\x09  return REG_EBRACE;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09      ctx->re++;\x0a"
"\x09\x09      tmp\x5bi\x5d = 0;\x0a"
"\x09\x09      val = strtol(tmp, NULL, 16);\x0a"
"\x09\x09      result = tre_ast_new_literal(ctx->mem, (int)val, (int)val,\x0a"
"\x09\x09\x09\x09\x09\x09   ctx->position);\x0a"
"\x09\x09      ctx->position++;\x0a"
"\x09\x09      break;\x0a"
"\x09\x09    }\x0a"
"\x09\x09  /*FALLTHROUGH*/\x0a"
"\x0a"
"\x09\x09""default\x3a\x0a"
"\x09\x09  if (tre_isdigit(*ctx->re))\x0a"
"\x09\x09    {\x0a"
"\x09\x09      /* Back reference. */\x0a"
"\x09\x09      int val = *ctx->re - L'0';\x0a"
"\x09\x09      DPRINT((\x22tre_parse\x3a     backref\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09      REST(ctx->re - 1)));\x0a"
"\x09\x09      result = tre_ast_new_literal(ctx->mem, BACKREF, val,\x0a"
"\x09\x09\x09\x09\x09\x09   ctx->position);\x0a"
"\x09\x09      if (result == NULL)\x0a"
"\x09\x09\x09return REG_ESPACE;\x0a"
"\x09\x09      ctx->position++;\x0a"
"\x09\x09      ctx->max_backref = MAX(val, ctx->max_backref);\x0a"
"\x09\x09      ctx->re++;\x0a"
"\x09\x09    }\x0a"
"\x09\x09  else\x0a"
"\x09\x09    {\x0a"
"\x09\x09      /* Escaped character. */\x0a"
"\x09\x09      DPRINT((\x22tre_parse\x3a     escaped\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09      REST(ctx->re - 1)));\x0a"
"\x09\x09      result = tre_ast_new_literal(ctx->mem, *ctx->re, *ctx->re,\x0a"
"\x09\x09\x09\x09\x09\x09   ctx->position);\x0a"
"\x09\x09      ctx->position++;\x0a"
"\x09\x09      ctx->re++;\x0a"
"\x09\x09    }\x0a"
"\x09\x09  break;\x0a"
"\x09\x09}\x0a"
"\x09      if (result == NULL)\x0a"
"\x09\x09return REG_ESPACE;\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    case CHAR_PERIOD\x3a\x09 /* the any-symbol */\x0a"
"\x09      DPRINT((\x22tre_parse\x3a\x09  any\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09      REST(ctx->re)));\x0a"
"\x09      if (ctx->cflags \x26 REG_NEWLINE)\x0a"
"\x09\x09{\x0a"
"\x09\x09  tre_ast_node_t *tmp1;\x0a"
"\x09\x09  tre_ast_node_t *tmp2;\x0a"
"\x09\x09  tmp1 = tre_ast_new_literal(ctx->mem, 0, L'\x5cn' - 1,\x0a"
"\x09\x09\x09\x09\x09     ctx->position);\x0a"
"\x09\x09  if (\x21tmp1)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09  tmp2 = tre_ast_new_literal(ctx->mem, L'\x5cn' + 1, TRE_CHAR_MAX,\x0a"
"\x09\x09\x09\x09\x09     ctx->position + 1);\x0a"
"\x09\x09  if (\x21tmp2)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09  result = tre_ast_new_union(ctx->mem, tmp1, tmp2);\x0a"
"\x09\x09  if (\x21result)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09  ctx->position += 2;\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09{\x0a"
"\x09\x09  result = tre_ast_new_literal(ctx->mem, 0, TRE_CHAR_MAX,\x0a"
"\x09\x09\x09\x09\x09       ctx->position);\x0a"
"\x09\x09  if (\x21result)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09  ctx->position++;\x0a"
"\x09\x09}\x0a"
"\x09      ctx->re++;\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    case CHAR_CARET\x3a\x09 /* beginning of line assertion */\x0a"
"\x09      /* '^' has a special meaning everywhere in EREs, and in the\x0a"
"\x09\x09 beginning of the RE and after \x5c( is BREs. */\x0a"
"\x09      if (ctx->cflags \x26 REG_EXTENDED\x0a"
"\x09\x09  \x7c\x7c (ctx->re - 2 >= ctx->re_start\x0a"
"\x09\x09      \x26\x26 *(ctx->re - 2) == CHAR_BACKSLASH\x0a"
"\x09\x09      \x26\x26 *(ctx->re - 1) == CHAR_LPAREN)\x0a"
"\x09\x09  \x7c\x7c ctx->re == ctx->re_start)\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22tre_parse\x3a\x09      BOL\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09  result = tre_ast_new_literal(ctx->mem, ASSERTION,\x0a"
"\x09\x09\x09\x09\x09       ASSERT_AT_BOL, -1);\x0a"
"\x09\x09  if (result == NULL)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09  ctx->re++;\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09goto parse_literal;\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    case CHAR_DOLLAR\x3a\x09 /* end of line assertion. */\x0a"
"\x09      /* '\x24' is special everywhere in EREs, and in the end of the\x0a"
"\x09\x09 string and before \x5c) is BREs. */\x0a"
"\x09      if (ctx->cflags \x26 REG_EXTENDED\x0a"
"\x09\x09  \x7c\x7c (ctx->re + 2 < ctx->re_end\x0a"
"\x09\x09      \x26\x26 *(ctx->re + 1) == CHAR_BACKSLASH\x0a"
"\x09\x09      \x26\x26 *(ctx->re + 2) == CHAR_RPAREN)\x0a"
"\x09\x09  \x7c\x7c ctx->re + 1 == ctx->re_end)\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22tre_parse\x3a\x09      EOL\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09  result = tre_ast_new_literal(ctx->mem, ASSERTION,\x0a"
"\x09\x09\x09\x09\x09       ASSERT_AT_EOL, -1);\x0a"
"\x09\x09  if (result == NULL)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09  ctx->re++;\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09goto parse_literal;\x0a"
"\x09      break;\x0a"
"\x0a"
"\x09    default\x3a\x0a"
"\x09    parse_literal\x3a\x0a"
"\x0a"
"\x09      if (temporary_cflags \x26\x26 ctx->re + 1 < ctx->re_end\x0a"
"\x09\x09  \x26\x26 *ctx->re == CHAR_BACKSLASH \x26\x26 *(ctx->re + 1) == L'E')\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22tre_parse\x3a\x09 end tmps\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09  ctx->cflags \x26= \x7etemporary_cflags;\x0a"
"\x09\x09  temporary_cflags = 0;\x0a"
"\x09\x09  ctx->re += 2;\x0a"
"\x09\x09  STACK_PUSHX(stack, int, PARSE_PIECE);\x0a"
"\x09\x09  break;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x0a"
"\x09      /* We are expecting an atom.  If the subexpression (or the whole\x0a"
"\x09\x09 regexp ends here, we interpret it as an empty expression\x0a"
"\x09\x09 (which matches an empty string).  */\x0a"
"\x09      if (\x0a"
"#ifdef REG_LITERAL\x0a"
"\x09\x09  \x21(ctx->cflags \x26 REG_LITERAL) \x26\x26\x0a"
"#endif /* REG_LITERAL */\x0a"
"\x09\x09  (ctx->re >= ctx->re_end\x0a"
"\x09\x09   \x7c\x7c *ctx->re == CHAR_STAR\x0a"
"\x09\x09   \x7c\x7c (ctx->cflags \x26 REG_EXTENDED\x0a"
"\x09\x09       \x26\x26 (*ctx->re == CHAR_PIPE\x0a"
"\x09\x09\x09   \x7c\x7c *ctx->re == CHAR_LBRACE\x0a"
"\x09\x09\x09   \x7c\x7c *ctx->re == CHAR_PLUS\x0a"
"\x09\x09\x09   \x7c\x7c *ctx->re == CHAR_QUESTIONMARK))\x0a"
"\x09\x09   /* Test for \x22\x5c)\x22 in BRE mode. */\x0a"
"\x09\x09   \x7c\x7c (\x21(ctx->cflags \x26 REG_EXTENDED)\x0a"
"\x09\x09       \x26\x26 ctx->re + 1 < ctx->re_end\x0a"
"\x09\x09       \x26\x26 *ctx->re == CHAR_BACKSLASH\x0a"
"\x09\x09       \x26\x26 *(ctx->re + 1) == CHAR_LBRACE)))\x0a"
"\x09\x09{\x0a"
"\x09\x09  DPRINT((\x22tre_parse\x3a\x09    empty\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09\x09  REST(ctx->re)));\x0a"
"\x09\x09  result = tre_ast_new_literal(ctx->mem, EMPTY, -1, -1);\x0a"
"\x09\x09  if (\x21result)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09  break;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09      DPRINT((\x22tre_parse\x3a     literal\x3a '\x25.*\x22 STRF \x22'\x5cn\x22,\x0a"
"\x09\x09      REST(ctx->re)));\x0a"
"\x09      /* Note that we can't use an tre_isalpha() test here, since there\x0a"
"\x09\x09 may be characters which are alphabetic but neither upper or\x0a"
"\x09\x09 lower case. */\x0a"
"\x09      if (ctx->cflags \x26 REG_ICASE\x0a"
"\x09\x09  \x26\x26 (tre_isupper(*ctx->re) \x7c\x7c tre_islower(*ctx->re)))\x0a"
"\x09\x09{\x0a"
"\x09\x09  tre_ast_node_t *tmp1;\x0a"
"\x09\x09  tre_ast_node_t *tmp2;\x0a"
"\x0a"
"\x09\x09  /* XXX - Can there be more than one opposite-case\x0a"
"\x09\x09     counterpoints for some character in some locale\x3f  Or\x0a"
"\x09\x09     more than two characters which all should be regarded\x0a"
"\x09\x09     the same character if case is ignored\x3f  If yes, there\x0a"
"\x09\x09     does not seem to be a portable way to detect it.  I guess\x0a"
"\x09\x09     that at least for multi-character collating elements there\x0a"
"\x09\x09     could be several opposite-case counterpoints, but they\x0a"
"\x09\x09     cannot be supported portably anyway. */\x0a"
"\x09\x09  tmp1 = tre_ast_new_literal(ctx->mem, tre_toupper(*ctx->re),\x0a"
"\x09\x09\x09\x09\x09     tre_toupper(*ctx->re),\x0a"
"\x09\x09\x09\x09\x09     ctx->position);\x0a"
"\x09\x09  if (\x21tmp1)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09  tmp2 = tre_ast_new_literal(ctx->mem, tre_tolower(*ctx->re),\x0a"
"\x09\x09\x09\x09\x09     tre_tolower(*ctx->re),\x0a"
"\x09\x09\x09\x09\x09     ctx->position);\x0a"
"\x09\x09  if (\x21tmp2)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09  result = tre_ast_new_union(ctx->mem, tmp1, tmp2);\x0a"
"\x09\x09  if (\x21result)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09}\x0a"
"\x09      else\x0a"
"\x09\x09{\x0a"
"\x09\x09  result = tre_ast_new_literal(ctx->mem, *ctx->re, *ctx->re,\x0a"
"\x09\x09\x09\x09\x09       ctx->position);\x0a"
"\x09\x09  if (\x21result)\x0a"
"\x09\x09    return REG_ESPACE;\x0a"
"\x09\x09}\x0a"
"\x09      ctx->position++;\x0a"
"\x09      ctx->re++;\x0a"
"\x09      break;\x0a"
"\x09    }\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""case PARSE_MARK_FOR_SUBMATCH\x3a\x0a"
"\x09  {\x0a"
"\x09    int submatch_id = tre_stack_pop_int(stack);\x0a"
"\x0a"
"\x09    if (result->submatch_id >= 0)\x0a"
"\x09      {\x0a"
"\x09\x09tre_ast_node_t *n, *tmp_node;\x0a"
"\x09\x09n = tre_ast_new_literal(ctx->mem, EMPTY, -1, -1);\x0a"
"\x09\x09if (n == NULL)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09tmp_node = tre_ast_new_catenation(ctx->mem, n, result);\x0a"
"\x09\x09if (tmp_node == NULL)\x0a"
"\x09\x09  return REG_ESPACE;\x0a"
"\x09\x09tmp_node->num_submatches = result->num_submatches;\x0a"
"\x09\x09result = tmp_node;\x0a"
"\x09      }\x0a"
"\x09    result->submatch_id = submatch_id;\x0a"
"\x09    result->num_submatches++;\x0a"
"\x09    break;\x0a"
"\x09  }\x0a"
"\x0a"
"\x09""case PARSE_RESTORE_CFLAGS\x3a\x0a"
"\x09  ctx->cflags = tre_stack_pop_int(stack);\x0a"
"\x09  break;\x0a"
"\x0a"
"\x09""default\x3a\x0a"
"\x09  assert(0);\x0a"
"\x09  break;\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  /* Check for missing closing parentheses. */\x0a"
"  if (depth > 0)\x0a"
"    return REG_EPAREN;\x0a"
"\x0a"
"  if (status == REG_OK)\x0a"
"    ctx->result = result;\x0a"
"\x0a"
"  return status;\x0a"
"}\x0a"
"\x0a"
"/* EOF */\x0a"
"", 44867 ); }