#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_tre_stack_c( 
"/*\x0a"
"  tre-stack.c - Simple stack implementation\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"#include <stdlib.h>\x0a"
"#include <assert.h>\x0a"
"\x0a"
"#include \x22tre-internal.h\x22\x0a"
"#include \x22tre-stack.h\x22\x0a"
"#include \x22xmalloc.h\x22\x0a"
"\x0a"
"union tre_stack_item {\x0a"
"  void *voidptr_value;\x0a"
"  int int_value;\x0a"
"};\x0a"
"\x0a"
"struct tre_stack_rec {\x0a"
"  int size;\x0a"
"  int max_size;\x0a"
"  int increment;\x0a"
"  int ptr;\x0a"
"  union tre_stack_item *stack;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"tre_stack_t *\x0a"
"tre_stack_new(int size, int max_size, int increment)\x0a"
"{\x0a"
"  tre_stack_t *s;\x0a"
"\x0a"
"  s = xmalloc(sizeof(*s));\x0a"
"  if (s \x21= NULL)\x0a"
"    {\x0a"
"      s->stack = xmalloc(sizeof(*s->stack) * size);\x0a"
"      if (s->stack == NULL)\x0a"
"\x09{\x0a"
"\x09  xfree(s);\x0a"
"\x09  return NULL;\x0a"
"\x09}\x0a"
"      s->size = size;\x0a"
"      s->max_size = max_size;\x0a"
"      s->increment = increment;\x0a"
"      s->ptr = 0;\x0a"
"    }\x0a"
"  return s;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"tre_stack_destroy(tre_stack_t *s)\x0a"
"{\x0a"
"  xfree(s->stack);\x0a"
"  xfree(s);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"tre_stack_num_objects(tre_stack_t *s)\x0a"
"{\x0a"
"  return s->ptr;\x0a"
"}\x0a"
"\x0a"
"static reg_errcode_t\x0a"
"tre_stack_push(tre_stack_t *s, union tre_stack_item value)\x0a"
"{\x0a"
"  if (s->ptr < s->size)\x0a"
"    {\x0a"
"      s->stack\x5bs->ptr\x5d = value;\x0a"
"      s->ptr++;\x0a"
"    }\x0a"
"  else\x0a"
"    {\x0a"
"      if (s->size >= s->max_size)\x0a"
"\x09{\x0a"
"\x09  DPRINT((\x22tre_stack_push\x3a stack full\x5cn\x22));\x0a"
"\x09  return REG_ESPACE;\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  union tre_stack_item *new_buffer;\x0a"
"\x09  int new_size;\x0a"
"\x09  DPRINT((\x22tre_stack_push\x3a trying to realloc more space\x5cn\x22));\x0a"
"\x09  new_size = s->size + s->increment;\x0a"
"\x09  if (new_size > s->max_size)\x0a"
"\x09    new_size = s->max_size;\x0a"
"\x09  new_buffer = xrealloc(s->stack, sizeof(*new_buffer) * new_size);\x0a"
"\x09  if (new_buffer == NULL)\x0a"
"\x09    {\x0a"
"\x09      DPRINT((\x22tre_stack_push\x3a realloc failed.\x5cn\x22));\x0a"
"\x09      return REG_ESPACE;\x0a"
"\x09    }\x0a"
"\x09  DPRINT((\x22tre_stack_push\x3a realloc succeeded.\x5cn\x22));\x0a"
"\x09  assert(new_size > s->size);\x0a"
"\x09  s->size = new_size;\x0a"
"\x09  s->stack = new_buffer;\x0a"
"\x09  tre_stack_push(s, value);\x0a"
"\x09}\x0a"
"    }\x0a"
"  return REG_OK;\x0a"
"}\x0a"
"\x0a"
"#define define_pushf(typetag, type)  \x5c\x0a"
"  declare_pushf(typetag, type) {     \x5c\x0a"
"    union tre_stack_item item;\x09     \x5c\x0a"
"    item.typetag ## _value = value;  \x5c\x0a"
"    return tre_stack_push(s, item);  \x5c\x0a"
"}\x0a"
"\x0a"
"define_pushf(int, int)\x0a"
"define_pushf(voidptr, void *)\x0a"
"\x0a"
"#define define_popf(typetag, type)\x09\x09    \x5c\x0a"
"  declare_popf(typetag, type) {\x09\x09\x09    \x5c\x0a"
"    return s->stack\x5b--s->ptr\x5d.typetag ## _value;    \x5c\x0a"
"  }\x0a"
"\x0a"
"define_popf(int, int)\x0a"
"define_popf(voidptr, void *)\x0a"
"\x0a"
"/* EOF */\x0a"
"", 2384 ); }