#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_regex_xmalloc_c( 
"/*\x0a"
"  xmalloc.c - Simple malloc debugging library implementation\x0a"
"\x0a"
"  This software is released under a BSD-style license.\x0a"
"  See the file LICENSE for details and copyright.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"/*\x0a"
"  TODO\x3a\x0a"
"   - red zones\x0a"
"   - group dumps by source location\x0a"
"*/\x0a"
"\x0a"
"#ifdef HAVE_CONFIG_H\x0a"
"#include <config.h>\x0a"
"#endif /* HAVE_CONFIG_H */\x0a"
"\x0a"
"#include <stdlib.h>\x0a"
"#include <assert.h>\x0a"
"#include <stdio.h>\x0a"
"#define XMALLOC_INTERNAL 1\x0a"
"#include \x22xmalloc.h\x22\x0a"
"\x0a"
"\x0c\x0a"
"/*\x0a"
"  Internal stuff.\x0a"
"*/\x0a"
"\x0a"
"typedef struct hashTableItemRec {\x0a"
"  void *ptr;\x0a"
"  int bytes;\x0a"
"  const char *file;\x0a"
"  int line;\x0a"
"  const char *func;\x0a"
"  struct hashTableItemRec *next;\x0a"
"} hashTableItem;\x0a"
"\x0a"
"typedef struct {\x0a"
"  hashTableItem **table;\x0a"
"} hashTable;\x0a"
"\x0a"
"static int xmalloc_peak;\x0a"
"int xmalloc_current;\x0a"
"static int xmalloc_peak_blocks;\x0a"
"int xmalloc_current_blocks;\x0a"
"static int xmalloc_fail_after;\x0a"
"\x0a"
"#define TABLE_BITS 8\x0a"
"#define TABLE_MASK ((1 << TABLE_BITS) - 1)\x0a"
"#define TABLE_SIZE (1 << TABLE_BITS)\x0a"
"\x0a"
"static hashTable *\x0a"
"hash_table_new(void)\x0a"
"{\x0a"
"  hashTable *tbl;\x0a"
"\x0a"
"  tbl = malloc(sizeof(*tbl));\x0a"
"\x0a"
"  if (tbl \x21= NULL)\x0a"
"    {\x0a"
"      tbl->table = calloc(TABLE_SIZE, sizeof(*tbl->table));\x0a"
"\x0a"
"      if (tbl->table == NULL)\x0a"
"\x09{\x0a"
"\x09  free(tbl);\x0a"
"\x09  return NULL;\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"  return tbl;\x0a"
"}\x0a"
"\x0a"
"static int\x0a"
"hash_void_ptr(void *ptr)\x0a"
"{\x0a"
"  int hash;\x0a"
"  int i;\x0a"
"\x0a"
"  /* I took this hash function just off the top of my head, I have\x0a"
"     no idea whether it is bad or very bad. */\x0a"
"  hash = 0;\x0a"
"  for (i = 0; i < (int)sizeof(ptr)*8 / TABLE_BITS; i++)\x0a"
"    {\x0a"
"      hash ^= (unsigned long)ptr >> i*8;\x0a"
"      hash += i * 17;\x0a"
"      hash \x26= TABLE_MASK;\x0a"
"    }\x0a"
"  return hash;\x0a"
"}\x0a"
"\x0a"
"static void\x0a"
"hash_table_add(hashTable *tbl, void *ptr, int bytes,\x0a"
"\x09       const char *file, int line, const char *func)\x0a"
"{\x0a"
"  int i;\x0a"
"  hashTableItem *item, *new;\x0a"
"\x0a"
"  i = hash_void_ptr(ptr);\x0a"
"\x0a"
"  item = tbl->table\x5bi\x5d;\x0a"
"  if (item \x21= NULL)\x0a"
"    while (item->next \x21= NULL)\x0a"
"      item = item->next;\x0a"
"\x0a"
"  new = malloc(sizeof(*new));\x0a"
"  assert(new \x21= NULL);\x0a"
"  new->ptr = ptr;\x0a"
"  new->bytes = bytes;\x0a"
"  new->file = file;\x0a"
"  new->line = line;\x0a"
"  new->func = func;\x0a"
"  new->next = NULL;\x0a"
"  if (item \x21= NULL)\x0a"
"    item->next = new;\x0a"
"  else\x0a"
"    tbl->table\x5bi\x5d = new;\x0a"
"\x0a"
"  xmalloc_current += bytes;\x0a"
"  if (xmalloc_current > xmalloc_peak)\x0a"
"    xmalloc_peak = xmalloc_current;\x0a"
"  xmalloc_current_blocks++;\x0a"
"  if (xmalloc_current_blocks > xmalloc_peak_blocks)\x0a"
"    xmalloc_peak_blocks = xmalloc_current_blocks;\x0a"
"}\x0a"
"\x0a"
"static void\x0a"
"hash_table_del(hashTable *tbl, void *ptr)\x0a"
"{\x0a"
"  int i;\x0a"
"  hashTableItem *item, *prev;\x0a"
"\x0a"
"  i = hash_void_ptr(ptr);\x0a"
"\x0a"
"  item = tbl->table\x5bi\x5d;\x0a"
"  if (item == NULL)\x0a"
"    {\x0a"
"      printf(\x22xfree\x3a invalid ptr \x25p\x5cn\x22, ptr);\x0a"
"      abort();\x0a"
"    }\x0a"
"  prev = NULL;\x0a"
"  while (item->ptr \x21= ptr)\x0a"
"    {\x0a"
"      prev = item;\x0a"
"      item = item->next;\x0a"
"    }\x0a"
"  if (item->ptr \x21= ptr)\x0a"
"    {\x0a"
"      printf(\x22xfree\x3a invalid ptr \x25p\x5cn\x22, ptr);\x0a"
"      abort();\x0a"
"    }\x0a"
"\x0a"
"  xmalloc_current -= item->bytes;\x0a"
"  xmalloc_current_blocks--;\x0a"
"\x0a"
"  if (prev \x21= NULL)\x0a"
"    {\x0a"
"      prev->next = item->next;\x0a"
"      free(item);\x0a"
"    }\x0a"
"  else\x0a"
"    {\x0a"
"      tbl->table\x5bi\x5d = item->next;\x0a"
"      free(item);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"static hashTable *xmalloc_table = NULL;\x0a"
"\x0a"
"static void\x0a"
"xmalloc_init(void)\x0a"
"{\x0a"
"  if (xmalloc_table == NULL)\x0a"
"    {\x0a"
"      xmalloc_table = hash_table_new();\x0a"
"      xmalloc_peak = 0;\x0a"
"      xmalloc_peak_blocks = 0;\x0a"
"      xmalloc_current = 0;\x0a"
"      xmalloc_current_blocks = 0;\x0a"
"      xmalloc_fail_after = -1;\x0a"
"    }\x0a"
"  assert(xmalloc_table \x21= NULL);\x0a"
"  assert(xmalloc_table->table \x21= NULL);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"\x0c\x0a"
"/*\x0a"
"  Public API.\x0a"
"*/\x0a"
"\x0a"
"void\x0a"
"xmalloc_configure(int fail_after)\x0a"
"{\x0a"
"  xmalloc_init();\x0a"
"  xmalloc_fail_after = fail_after;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"xmalloc_dump_leaks(void)\x0a"
"{\x0a"
"  int i;\x0a"
"  int num_leaks = 0;\x0a"
"  int leaked_bytes = 0;\x0a"
"  hashTableItem *item;\x0a"
"\x0a"
"  xmalloc_init();\x0a"
"\x0a"
"  for (i = 0; i < TABLE_SIZE; i++)\x0a"
"    {\x0a"
"      item = xmalloc_table->table\x5bi\x5d;\x0a"
"      while (item \x21= NULL)\x0a"
"\x09{\x0a"
"\x09  printf(\x22\x25s\x3a\x25""d\x3a \x25s\x3a \x25""d bytes at \x25p not freed\x5cn\x22,\x0a"
"\x09\x09 item->file, item->line, item->func, item->bytes, item->ptr);\x0a"
"\x09  num_leaks++;\x0a"
"\x09  leaked_bytes += item->bytes;\x0a"
"\x09  item = item->next;\x0a"
"\x09}\x0a"
"    }\x0a"
"  if (num_leaks == 0)\x0a"
"    printf(\x22No memory leaks.\x5cn\x22);\x0a"
"  else\x0a"
"    printf(\x22\x25""d unfreed memory chuncks, total \x25""d unfreed bytes.\x5cn\x22,\x0a"
"\x09   num_leaks, leaked_bytes);\x0a"
"  printf(\x22Peak memory consumption \x25""d bytes (\x25.1f kB, \x25.1f MB) in \x25""d blocks \x22,\x0a"
"\x09 xmalloc_peak, (double)xmalloc_peak / 1024,\x0a"
"\x09 (double)xmalloc_peak / (1024*1024), xmalloc_peak_blocks);\x0a"
"  printf(\x22(average \x22);\x0a"
"  if (xmalloc_peak_blocks)\x0a"
"    printf(\x22\x25""d\x22, ((xmalloc_peak + xmalloc_peak_blocks / 2)\x0a"
"\x09\x09  / xmalloc_peak_blocks));\x0a"
"  else\x0a"
"    printf(\x22N/A\x22);\x0a"
"  printf(\x22 bytes per block).\x5cn\x22);\x0a"
"\x0a"
"  return num_leaks;\x0a"
"}\x0a"
"\x0a"
"void *\x0a"
"xmalloc_impl(size_t size, const char *file, int line, const char *func)\x0a"
"{\x0a"
"  void *ptr;\x0a"
"\x0a"
"  xmalloc_init();\x0a"
"  assert(size > 0);\x0a"
"\x0a"
"  if (xmalloc_fail_after == 0)\x0a"
"    {\x0a"
"      xmalloc_fail_after = -2;\x0a"
"#if 0\x0a"
"      printf(\x22xmalloc\x3a forced failure \x25s\x3a\x25""d\x3a \x25s\x5cn\x22, file, line, func);\x0a"
"#endif\x0a"
"      return NULL;\x0a"
"    }\x0a"
"  else if (xmalloc_fail_after == -2)\x0a"
"    {\x0a"
"      printf(\x22xmalloc\x3a called after failure from \x25s\x3a\x25""d\x3a \x25s\x5cn\x22,\x0a"
"\x09     file, line, func);\x0a"
"      assert(0);\x0a"
"    }\x0a"
"  else if (xmalloc_fail_after > 0)\x0a"
"    xmalloc_fail_after--;\x0a"
"\x0a"
"  ptr = malloc(size);\x0a"
"  if (ptr \x21= NULL)\x0a"
"    hash_table_add(xmalloc_table, ptr, (int)size, file, line, func);\x0a"
"  return ptr;\x0a"
"}\x0a"
"\x0a"
"void *\x0a"
"xcalloc_impl(size_t nmemb, size_t size, const char *file, int line,\x0a"
"\x09     const char *func)\x0a"
"{\x0a"
"  void *ptr;\x0a"
"\x0a"
"  xmalloc_init();\x0a"
"  assert(size > 0);\x0a"
"\x0a"
"  if (xmalloc_fail_after == 0)\x0a"
"    {\x0a"
"      xmalloc_fail_after = -2;\x0a"
"#if 0\x0a"
"      printf(\x22xcalloc\x3a forced failure \x25s\x3a\x25""d\x3a \x25s\x5cn\x22, file, line, func);\x0a"
"#endif\x0a"
"      return NULL;\x0a"
"    }\x0a"
"  else if (xmalloc_fail_after == -2)\x0a"
"    {\x0a"
"      printf(\x22xcalloc\x3a called after failure from \x25s\x3a\x25""d\x3a \x25s\x5cn\x22,\x0a"
"\x09     file, line, func);\x0a"
"      assert(0);\x0a"
"    }\x0a"
"  else if (xmalloc_fail_after > 0)\x0a"
"    xmalloc_fail_after--;\x0a"
"\x0a"
"  ptr = calloc(nmemb, size);\x0a"
"  if (ptr \x21= NULL)\x0a"
"    hash_table_add(xmalloc_table, ptr, (int)(nmemb * size), file, line, func);\x0a"
"  return ptr;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"xfree_impl(void *ptr, const char *file, int line, const char *func)\x0a"
"{\x0a"
"  /*LINTED*/(void)\x26""file;\x0a"
"  /*LINTED*/(void)\x26line;\x0a"
"  /*LINTED*/(void)\x26""func;\x0a"
"  xmalloc_init();\x0a"
"\x0a"
"  if (ptr \x21= NULL)\x0a"
"    hash_table_del(xmalloc_table, ptr);\x0a"
"  free(ptr);\x0a"
"}\x0a"
"\x0a"
"void *\x0a"
"xrealloc_impl(void *ptr, size_t new_size, const char *file, int line,\x0a"
"\x09      const char *func)\x0a"
"{\x0a"
"  void *new_ptr;\x0a"
"\x0a"
"  xmalloc_init();\x0a"
"  assert(ptr \x21= NULL);\x0a"
"  assert(new_size > 0);\x0a"
"\x0a"
"  if (xmalloc_fail_after == 0)\x0a"
"    {\x0a"
"      xmalloc_fail_after = -2;\x0a"
"      return NULL;\x0a"
"    }\x0a"
"  else if (xmalloc_fail_after == -2)\x0a"
"    {\x0a"
"      printf(\x22xrealloc\x3a called after failure from \x25s\x3a\x25""d\x3a \x25s\x5cn\x22,\x0a"
"\x09     file, line, func);\x0a"
"      assert(0);\x0a"
"    }\x0a"
"  else if (xmalloc_fail_after > 0)\x0a"
"    xmalloc_fail_after--;\x0a"
"\x0a"
"  new_ptr = realloc(ptr, new_size);\x0a"
"  if (new_ptr \x21= NULL)\x0a"
"    {\x0a"
"      hash_table_del(xmalloc_table, ptr);\x0a"
"      hash_table_add(xmalloc_table, new_ptr, (int)new_size, file, line, func);\x0a"
"    }\x0a"
"  return new_ptr;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"\x0a"
"/* EOF */\x0a"
"", 6765 ); }