#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_signal_raise_c( 
"/* raise( int )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <signal.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"extern void (*_PDCLIB_sigabrt)( int );\x0a"
"extern void (*_PDCLIB_sigfpe)( int );\x0a"
"extern void (*_PDCLIB_sigill)( int );\x0a"
"extern void (*_PDCLIB_sigint)( int );\x0a"
"extern void (*_PDCLIB_sigsegv)( int );\x0a"
"extern void (*_PDCLIB_sigterm)( int );\x0a"
"\x0a"
"int raise( int sig )\x0a"
"{\x0a"
"    void (*sighandler)( int );\x0a"
"    char const * message;\x0a"
"    switch ( sig )\x0a"
"    {\x0a"
"        case SIGABRT\x3a\x0a"
"            sighandler = _PDCLIB_sigabrt;\x0a"
"            message = \x22""Abnormal termination (SIGABRT)\x22;\x0a"
"            break;\x0a"
"        case SIGFPE\x3a\x0a"
"            sighandler = _PDCLIB_sigfpe;\x0a"
"            message = \x22""Arithmetic exception (SIGFPE)\x22;\x0a"
"            break;\x0a"
"        case SIGILL\x3a\x0a"
"            sighandler = _PDCLIB_sigill;\x0a"
"            message = \x22Illegal instruction (SIGILL)\x22;\x0a"
"            break;\x0a"
"        case SIGINT\x3a\x0a"
"            sighandler = _PDCLIB_sigint;\x0a"
"            message = \x22Interactive attention signal (SIGINT)\x22;\x0a"
"            break;\x0a"
"        case SIGSEGV\x3a\x0a"
"            sighandler = _PDCLIB_sigsegv;\x0a"
"            message = \x22Invalid memory access (SIGSEGV)\x22;\x0a"
"            break;\x0a"
"        case SIGTERM\x3a\x0a"
"            sighandler = _PDCLIB_sigterm;\x0a"
"            message = \x22Termination request (SIGTERM)\x22;\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            fprintf( stderr, \x22Unknown signal #\x25""d\x5cn\x22, sig );\x0a"
"            _Exit( EXIT_FAILURE );\x0a"
"    }\x0a"
"    if ( sighandler == SIG_DFL )\x0a"
"    {\x0a"
"        fputs( message, stderr );\x0a"
"        _Exit( EXIT_FAILURE );\x0a"
"    }\x0a"
"    else if ( sighandler \x21= SIG_IGN )\x0a"
"    {\x0a"
"        sighandler = signal( sig, SIG_DFL );\x0a"
"        sighandler( sig );\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"static volatile sig_atomic_t flag = 0;\x0a"
"\x0a"
"static int expected_signal = 0;\x0a"
"\x0a"
"static void test_handler( int sig )\x0a"
"{\x0a"
"    TESTCASE( sig == expected_signal );\x0a"
"    flag = 1;\x0a"
"}\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    /* Could be other than SIG_DFL if you changed the implementation. */\x0a"
"    TESTCASE( signal( SIGABRT, SIG_IGN ) == SIG_DFL );\x0a"
"    /* Should be ignored. */\x0a"
"    TESTCASE( raise( SIGABRT ) == 0 );\x0a"
"    /* Installing test handler, old handler should be returned */\x0a"
"    TESTCASE( signal( SIGABRT, test_handler ) == SIG_IGN );\x0a"
"    /* Raising and checking SIGABRT */\x0a"
"    expected_signal = SIGABRT;\x0a"
"    TESTCASE( raise( SIGABRT ) == 0 );\x0a"
"    TESTCASE( flag == 1 );\x0a"
"    /* Re-installing test handler, should have been reset to default */\x0a"
"    /* Could be other than SIG_DFL if you changed the implementation. */\x0a"
"    TESTCASE( signal( SIGABRT, test_handler ) == SIG_DFL );\x0a"
"    /* Raising and checking SIGABRT */\x0a"
"    flag = 0;\x0a"
"    TESTCASE( raise( SIGABRT ) == 0 );\x0a"
"    TESTCASE( flag == 1 );\x0a"
"    /* Installing test handler for different signal... */\x0a"
"    TESTCASE( signal( SIGTERM, test_handler ) == SIG_DFL );\x0a"
"    /* Raising and checking SIGTERM */\x0a"
"    expected_signal = SIGTERM;\x0a"
"    TESTCASE( raise( SIGTERM ) == 0 );\x0a"
"    TESTCASE( flag == 1 );\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"#endif\x0a"
"", 3094 ); }