#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio__PDCLIB_filemode_c( 
"/* _PDCLIB_filemode( const char * )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stddef.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"#include \x22_PDCLIB/io.h\x22\x0a"
"/* Helper function that parses the C-style mode string passed to fopen() into\x0a"
"   the PDCLib flags FREAD, FWRITE, FAPPEND, FRW (read-write) and FBIN (binary\x0a"
"   mode).\x0a"
"*/\x0a"
"unsigned int _PDCLIB_filemode( char const * const mode )\x0a"
"{\x0a"
"    if(\x21mode) return 0;\x0a"
"\x0a"
"    unsigned rc = 0;\x0a"
"    switch ( mode\x5b""0\x5d )\x0a"
"    {\x0a"
"        case 'r'\x3a\x0a"
"            rc \x7c= _PDCLIB_FREAD;\x0a"
"            break;\x0a"
"        case 'w'\x3a\x0a"
"            rc \x7c= _PDCLIB_FWRITE;\x0a"
"            break;\x0a"
"        case 'a'\x3a\x0a"
"            rc \x7c= _PDCLIB_FAPPEND \x7c _PDCLIB_FWRITE;\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            /* Other than read, write, or append - invalid */\x0a"
"            return 0;\x0a"
"    }\x0a"
"    for ( size_t i = 1; i < 4; ++i )\x0a"
"    {\x0a"
"        switch ( mode\x5bi\x5d )\x0a"
"        {\x0a"
"            case '+'\x3a\x0a"
"                if ( rc \x26 _PDCLIB_FRW ) return 0; /* Duplicates are invalid */\x0a"
"                rc \x7c= _PDCLIB_FRW;\x0a"
"                break;\x0a"
"            case 'b'\x3a\x0a"
"                if ( rc \x26 _PDCLIB_FBIN ) return 0; /* Duplicates are invalid */\x0a"
"                rc \x7c= _PDCLIB_FBIN;\x0a"
"                break;\x0a"
"            case '\x5c""0'\x3a\x0a"
"                /* End of mode */\x0a"
"                return rc;\x0a"
"            default\x3a\x0a"
"                /* Other than read/write or binary - invalid. */\x0a"
"                return 0;\x0a"
"        }\x0a"
"    }\x0a"
"    /* Longer than three chars - invalid. */\x0a"
"    return 0;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"#ifndef REGTEST\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22r\x22 ) == _PDCLIB_FREAD );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22w\x22 ) == _PDCLIB_FWRITE );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22""a\x22 ) == ( _PDCLIB_FAPPEND \x7c _PDCLIB_FWRITE ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22r+\x22 ) == ( _PDCLIB_FREAD \x7c _PDCLIB_FRW ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22w+\x22 ) == ( _PDCLIB_FWRITE \x7c _PDCLIB_FRW ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22""a+\x22 ) == ( _PDCLIB_FAPPEND \x7c _PDCLIB_FWRITE \x7c _PDCLIB_FRW ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22rb\x22 ) == ( _PDCLIB_FREAD \x7c _PDCLIB_FBIN ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22wb\x22 ) == ( _PDCLIB_FWRITE \x7c _PDCLIB_FBIN ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22""ab\x22 ) == ( _PDCLIB_FAPPEND \x7c _PDCLIB_FWRITE \x7c _PDCLIB_FBIN ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22r+b\x22 ) == ( _PDCLIB_FREAD \x7c _PDCLIB_FRW \x7c _PDCLIB_FBIN ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22w+b\x22 ) == ( _PDCLIB_FWRITE \x7c _PDCLIB_FRW \x7c _PDCLIB_FBIN ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22""a+b\x22 ) == ( _PDCLIB_FAPPEND \x7c _PDCLIB_FWRITE \x7c _PDCLIB_FRW \x7c _PDCLIB_FBIN ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22rb+\x22 ) == ( _PDCLIB_FREAD \x7c _PDCLIB_FRW \x7c _PDCLIB_FBIN ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22wb+\x22 ) == ( _PDCLIB_FWRITE \x7c _PDCLIB_FRW \x7c _PDCLIB_FBIN ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22""ab+\x22 ) == ( _PDCLIB_FAPPEND \x7c _PDCLIB_FWRITE \x7c _PDCLIB_FRW \x7c _PDCLIB_FBIN ) );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22x\x22 ) == 0 );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22r++\x22 ) == 0 );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22wbb\x22 ) == 0 );\x0a"
"    TESTCASE( _PDCLIB_filemode( \x22""a+bx\x22 ) == 0 );\x0a"
"#endif\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"", 3166 ); }