#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio__PDCLIB_fvopen_c( 
"/* _PDCLIB_fvopen( _PDCLIB_fd_t, _PDCLIB_fileops_t * )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"#include \x22_PDCLIB/glue.h\x22\x0a"
"#include \x22_PDCLIB/io.h\x22\x0a"
"#include <string.h>\x0a"
"#include <threads.h>\x0a"
"\x0a"
"extern FILE * _PDCLIB_filelist;\x0a"
"extern mtx_t _PDCLIB_filelist_lock;\x0a"
"\x0a"
"FILE * _PDCLIB_fvopen(\x0a"
"    _PDCLIB_fd_t                                    fd,\x0a"
"    const _PDCLIB_fileops_t    *_PDCLIB_restrict    ops,\x0a"
"    int                                             mode,\x0a"
"    const char                  *_PDCLIB_restrict   filename\x0a"
")\x0a"
"{\x0a"
"    size_t filename_len;\x0a"
"    FILE * rc;\x0a"
"    if ( mode == NULL )\x0a"
"    {\x0a"
"        /* Mode invalid */\x0a"
"        return NULL;\x0a"
"    }\x0a"
"    /* To reduce the number of malloc calls, all data fields are concatenated\x3a\x0a"
"       * the FILE structure itself,\x0a"
"       * ungetc buffer,\x0a"
"       * filename buffer,\x0a"
"       * data buffer.\x0a"
"       Data buffer comes last because it might change in size ( setvbuf() ).\x0a"
"    */\x0a"
"    filename_len = filename \x3f strlen( filename ) + 1 \x3a 1;\x0a"
"    if ( ( rc = calloc( 1, sizeof( FILE ) + _PDCLIB_UNGETCBUFSIZE + filename_len + BUFSIZ ) ) == NULL )\x0a"
"    {\x0a"
"        /* no memory */\x0a"
"        return NULL;\x0a"
"    }\x0a"
"\x0a"
"    if(mtx_init(\x26rc->lock, mtx_recursive) \x21= thrd_success) {\x0a"
"        free(rc);\x0a"
"        return NULL;\x0a"
"    }\x0a"
"\x0a"
"    rc->status = mode;\x0a"
"    rc->ops    = ops;\x0a"
"    rc->handle = fd;\x0a"
"    /* Setting pointers into the memory block allocated above */\x0a"
"    rc->ungetbuf = (unsigned char *)rc + sizeof( FILE );\x0a"
"    rc->filename = (char *)rc->ungetbuf + _PDCLIB_UNGETCBUFSIZE;\x0a"
"    rc->buffer   = rc->filename + filename_len;\x0a"
"    /* Copying filename to FILE structure */\x0a"
"    if(filename) strcpy( rc->filename, filename );\x0a"
"    /* Initializing the rest of the structure */\x0a"
"    rc->bufsize = BUFSIZ;\x0a"
"    rc->bufidx = 0;\x0a"
"#ifdef _PDCLIB_NEED_EOL_TRANSLATION\x0a"
"    rc->bufnlexp = 0;\x0a"
"#endif\x0a"
"    rc->ungetidx = 0;\x0a"
"    /* Setting buffer to _IOLBF because \x22when opened, a stream is fully\x0a"
"       buffered if and only if it can be determined not to refer to an\x0a"
"       interactive device.\x22\x0a"
"    */\x0a"
"    rc->status \x7c= _IOLBF;\x0a"
"    /* TODO\x3a Setting mbstate */\x0a"
"    /* Adding to list of open files */\x0a"
"#ifdef __divine__\x0a"
"    if (\x21_PDCLIB_filelist)\x0a"
"        atexit(_PDCLIB_closeall);\x0a"
"#endif\x0a"
"    mtx_lock( \x26_PDCLIB_filelist_lock );\x0a"
"    rc->next = _PDCLIB_filelist;\x0a"
"    _PDCLIB_filelist = rc;\x0a"
"    mtx_unlock( \x26_PDCLIB_filelist_lock );\x0a"
"    return rc;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    /* Some of the tests are not executed for regression tests, as the libc on\x0a"
"       my system is at once less forgiving (segfaults on mode NULL) and more\x0a"
"       forgiving (accepts undefined modes).\x0a"
"    */\x0a"
"    FILE * fh;\x0a"
"    remove( testfile );\x0a"
"    TESTCASE_NOREG( fopen( NULL, NULL ) == NULL );\x0a"
"    TESTCASE( fopen( NULL, \x22w\x22 ) == NULL );\x0a"
"    TESTCASE_NOREG( fopen( \x22\x22, NULL ) == NULL );\x0a"
"    TESTCASE( fopen( \x22\x22, \x22w\x22 ) == NULL );\x0a"
"    TESTCASE( fopen( \x22""foo\x22, \x22\x22 ) == NULL );\x0a"
"    TESTCASE_NOREG( fopen( testfile, \x22wq\x22 ) == NULL ); /* Undefined mode */\x0a"
"    TESTCASE_NOREG( fopen( testfile, \x22wr\x22 ) == NULL ); /* Undefined mode */\x0a"
"    TESTCASE( ( fh = fopen( testfile, \x22w\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE( fclose( fh ) == 0 );\x0a"
"    TESTCASE( remove( testfile ) == 0 );\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"", 3354 ); }