#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio__PDCLIB_print_c( 
"/* _PDCLIB_print( const char *, struct _PDCLIB_status_t * )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"#include <stdint.h>\x0a"
"#include <stdarg.h>\x0a"
"#include <string.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <stddef.h>\x0a"
"#include <stdbool.h>\x0a"
"#include <limits.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"#include \x22_PDCLIB/io.h\x22\x0a"
"\x0a"
"/* Using an integer's bits as flags for both the conversion flags and length\x0a"
"   modifiers.\x0a"
"*/\x0a"
"/* FIXME\x3a one too many flags to work on a 16-bit machine, join some (e.g. the\x0a"
"          width flags) into a combined field.\x0a"
"*/\x0a"
"#define E_minus    (1<<0)\x0a"
"#define E_plus     (1<<1)\x0a"
"#define E_alt      (1<<2)\x0a"
"#define E_space    (1<<3)\x0a"
"#define E_zero     (1<<4)\x0a"
"#define E_done     (1<<5)\x0a"
"\x0a"
"#define E_char     (1<<6)\x0a"
"#define E_short    (1<<7)\x0a"
"#define E_long     (1<<8)\x0a"
"#define E_llong    (1<<9)\x0a"
"#define E_intmax   (1<<10)\x0a"
"#define E_size     (1<<11)\x0a"
"#define E_ptrdiff  (1<<12)\x0a"
"#define E_intptr   (1<<13)\x0a"
"\x0a"
"#define E_ldouble  (1<<14)\x0a"
"\x0a"
"#define E_lower    (1<<15)\x0a"
"#define E_unsigned (1<<16)\x0a"
"\x0a"
"#define E_TYPES (E_char \x7c E_short \x7c E_long \x7c E_llong \x7c E_intmax \x5c\x0a"
"                \x7c E_size \x7c E_ptrdiff \x7c E_intptr)\x0a"
"\x0a"
"/* returns true if callback-based output succeeded; else false */\x0a"
"static inline bool cbout(\x0a"
"    struct _PDCLIB_status_t * status,\x0a"
"    const void * buf,\x0a"
"    size_t size )\x0a"
"{\x0a"
"    size_t rv = status->write( status->ctx, buf, size );\x0a"
"    status->i       += rv;\x0a"
"    status->current += rv;\x0a"
"    return rv == size;\x0a"
"}\x0a"
"\x0a"
"/* repeated output of a single character */\x0a"
"static inline bool cbrept(\x0a"
"    struct _PDCLIB_status_t * status,\x0a"
"    char c,\x0a"
"    size_t times )\x0a"
"{\x0a"
"    if ( sizeof(size_t) == 8 \x26\x26 CHAR_BIT == 8)\x0a"
"    {\x0a"
"        uint64_t spread = UINT64_C(0x0101010101010101) * c;\x0a"
"        while ( times )\x0a"
"        {\x0a"
"            size_t n = times > 8 \x3f 8 \x3a times;\x0a"
"            if ( \x21""cbout( status, \x26spread, n ) )\x0a"
"                return false;\x0a"
"            times -= n;\x0a"
"        }\x0a"
"        return true;\x0a"
"    }\x0a"
"    else if ( sizeof(size_t) == 4  \x26\x26 CHAR_BIT == 8)\x0a"
"    {\x0a"
"        uint32_t spread = UINT32_C(0x01010101) * c;\x0a"
"        while ( times )\x0a"
"        {\x0a"
"            size_t n = times > 4 \x3f 4 \x3a times;\x0a"
"            if ( \x21""cbout( status, \x26spread, n ) )\x0a"
"                return false;\x0a"
"            times -= n;\x0a"
"        }\x0a"
"        return true;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        while ( times )\x0a"
"        {\x0a"
"            if ( \x21""cbout( status, \x26""c, 1) )\x0a"
"                return false;\x0a"
"            times--;\x0a"
"        }\x0a"
"        return true;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* Maximum number of output characters =\x0a"
" *   number of bits in (u)intmax_t / number of bits per character in smallest\x0a"
" *   base. Smallest base is octal, 3 bits/char.\x0a"
" *\x0a"
" * Additionally require 2 extra characters for prefixes\x0a"
" *\x0a"
" * Returns false if an I/O error occured.\x0a"
" */\x0a"
"static const size_t maxIntLen = sizeof(intmax_t) * CHAR_BIT / 3 + 1;\x0a"
"\x0a"
"static bool int2base( uintmax_t value, struct _PDCLIB_status_t * status )\x0a"
"{\x0a"
"    char sign = 0;\x0a"
"    if ( \x21 ( status->flags \x26 E_unsigned ) )\x0a"
"    {\x0a"
"        intmax_t signval = (intmax_t) value;\x0a"
"        bool negative = signval < 0;\x0a"
"        value = signval < 0 \x3f -signval \x3a signval;\x0a"
"\x0a"
"        if ( negative )\x0a"
"        {\x0a"
"            sign = '-';\x0a"
"        }\x0a"
"        else if ( status->flags \x26 E_plus )\x0a"
"        {\x0a"
"            sign = '+';\x0a"
"        }\x0a"
"        else if (status->flags \x26 E_space )\x0a"
"        {\x0a"
"            sign = ' ';\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    // The user could theoretically ask for a silly buffer length here.\x0a"
"    // Perhaps after a certain size we should malloc\x3f Or do we refuse to protect\x0a"
"    // them from their own stupidity\x3f\x0a"
"    size_t bufLen = (status->width > maxIntLen \x3f status->width \x3a maxIntLen) + 2;\x0a"
"    char outbuf\x5b""bufLen\x5d;\x0a"
"    char * outend = outbuf + bufLen;\x0a"
"    int written = 0;\x0a"
"\x0a"
"    if ( status->prec == EOF )\x0a"
"        status->prec = 1;\x0a"
"\x0a"
"    // Build up our output string - backwards\x0a"
"    {\x0a"
"        const char * digits = (status->flags \x26 E_lower) \x3f\x0a"
"                                _PDCLIB_digits \x3a _PDCLIB_Xdigits;\x0a"
"        uintmax_t remaining = value;\x0a"
"        if(status->prec \x21= 0 \x7c\x7c remaining \x21= 0) do {\x0a"
"            uintmax_t digit = remaining \x25 status->base;\x0a"
"            remaining /= status->base;\x0a"
"\x0a"
"            outend\x5b-++written\x5d = digits\x5b""digit\x5d;\x0a"
"        } while(remaining \x21= 0);\x0a"
"    }\x0a"
"\x0a"
"    // Pad field out to the precision specification\x0a"
"    while( (long) written < status->prec ) outend\x5b-++written\x5d = '0';\x0a"
"\x0a"
"    // If a field width specified, and zero padding was requested, then pad to\x0a"
"    // the field width\x0a"
"    unsigned padding = 0;\x0a"
"    if ( ( \x21 ( status->flags \x26 E_minus ) ) \x26\x26 ( status->flags \x26 E_zero ) )\x0a"
"    {\x0a"
"        while( written < (int) status->width )\x0a"
"        {\x0a"
"            outend\x5b-++written\x5d = '0';\x0a"
"            padding++;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    // Prefixes\x0a"
"    if ( sign \x21= 0 )\x0a"
"    {\x0a"
"        if ( padding == 0 ) written++;\x0a"
"        outend\x5b-written\x5d = sign;\x0a"
"    }\x0a"
"    else if ( status->flags \x26 E_alt )\x0a"
"    {\x0a"
"        switch ( status->base )\x0a"
"        {\x0a"
"            case 8\x3a\x0a"
"                if ( outend\x5b-written\x5d \x21= '0' ) outend\x5b-++written\x5d = '0';\x0a"
"                break;\x0a"
"            case 16\x3a\x0a"
"                // No prefix if zero\x0a"
"                if ( value == 0 ) break;\x0a"
"\x0a"
"                written += padding < 2 \x3f 2 - padding \x3a 0;\x0a"
"                outend\x5b-written    \x5d = '0';\x0a"
"                outend\x5b-written + 1\x5d = (status->flags \x26 E_lower) \x3f 'x' \x3a 'X';\x0a"
"                break;\x0a"
"            default\x3a\x0a"
"                break;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    // Space padding to field width\x0a"
"    if ( \x21 ( status->flags \x26 ( E_minus \x7c E_zero ) ) )\x0a"
"    {\x0a"
"        while( written < (int) status->width ) outend\x5b-++written\x5d = ' ';\x0a"
"    }\x0a"
"\x0a"
"    // Write output\x0a"
"    return cbout( status, outend - written, written );\x0a"
"}\x0a"
"\x0a"
"/* print a string. returns false if an I/O error occured */\x0a"
"static bool printstr( const char * str, struct _PDCLIB_status_t * status )\x0a"
"{\x0a"
"    size_t len = status->prec >= 0 \x3f strnlen( str, status-> prec)\x0a"
"                                   \x3a strlen(str);\x0a"
"\x0a"
"    if ( status->width == 0 \x7c\x7c status->flags \x26 E_minus )\x0a"
"    {\x0a"
"        // Simple case or left justification\x0a"
"        if ( status->prec > 0 )\x0a"
"        {\x0a"
"            len = (unsigned) status->prec < len \x3f (unsigned)  status->prec \x3a len;\x0a"
"        }\x0a"
"\x0a"
"        if ( \x21""cbout( status, str, len ) )\x0a"
"            return false;\x0a"
"\x0a"
"        /* right padding */\x0a"
"        if ( status->width > status->current ) {\x0a"
"            len = status->width - status->current;\x0a"
"\x0a"
"            if ( \x21""cbrept( status, ' ', len ) )\x0a"
"                return false;\x0a"
"        }\x0a"
"    } else {\x0a"
"        // Right justification\x0a"
"\x0a"
"        if ( status->width > len ) {\x0a"
"            size_t padding = status->width - len;\x0a"
"\x0a"
"            if ( \x21""cbrept( status, ' ', padding ))\x0a"
"                return false;\x0a"
"        }\x0a"
"\x0a"
"        if ( \x21""cbout( status, str, len ) )\x0a"
"            return false;\x0a"
"    }\x0a"
"\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"static bool printchar( char chr, struct _PDCLIB_status_t * status )\x0a"
"{\x0a"
"    if( \x21 ( status->flags \x26 E_minus ) )\x0a"
"    {\x0a"
"        // Right justification\x0a"
"        if ( status-> width ) {\x0a"
"            size_t justification = status->width - status->current - 1;\x0a"
"            if ( \x21""cbrept( status, ' ', justification ))\x0a"
"                return false;\x0a"
"        }\x0a"
"\x0a"
"        if ( \x21""cbout( status, \x26""chr, 1 ))\x0a"
"            return false;\x0a"
"    } else {\x0a"
"        // Left justification\x0a"
"\x0a"
"        if ( \x21""cbout( status, \x26""chr, 1 ))\x0a"
"            return false;\x0a"
"\x0a"
"        if ( status->width > status->current ) {\x0a"
"            if ( \x21""cbrept( status, ' ', status->width - status->current ) )\x0a"
"                return false;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"int _PDCLIB_print( const char * spec, struct _PDCLIB_status_t * status )\x0a"
"{\x0a"
"    const char * orig_spec = spec;\x0a"
"    if ( *(++spec) == '\x25' )\x0a"
"    {\x0a"
"        /* \x25\x25 -> print single '\x25' */\x0a"
"        if ( \x21""cbout(status, spec, 1) )\x0a"
"            return -1;\x0a"
"        ++spec;\x0a"
"        return (spec - orig_spec);\x0a"
"    }\x0a"
"    /* Initializing status structure */\x0a"
"    status->flags = 0;\x0a"
"    status->base  = 0;\x0a"
"    status->current  = 0;\x0a"
"    status->width = 0;\x0a"
"    status->prec  = EOF;\x0a"
"\x0a"
"    /* First come 0..n flags */\x0a"
"    do\x0a"
"    {\x0a"
"        switch ( *spec )\x0a"
"        {\x0a"
"            case '-'\x3a\x0a"
"                /* left-aligned output */\x0a"
"                status->flags \x7c= E_minus;\x0a"
"                ++spec;\x0a"
"                break;\x0a"
"            case '+'\x3a\x0a"
"                /* positive numbers prefixed with '+' */\x0a"
"                status->flags \x7c= E_plus;\x0a"
"                ++spec;\x0a"
"                break;\x0a"
"            case '#'\x3a\x0a"
"                /* alternative format (leading 0x for hex, 0 for octal) */\x0a"
"                status->flags \x7c= E_alt;\x0a"
"                ++spec;\x0a"
"                break;\x0a"
"            case ' '\x3a\x0a"
"                /* positive numbers prefixed with ' ' */\x0a"
"                status->flags \x7c= E_space;\x0a"
"                ++spec;\x0a"
"                break;\x0a"
"            case '0'\x3a\x0a"
"                /* right-aligned padding done with '0' instead of ' ' */\x0a"
"                status->flags \x7c= E_zero;\x0a"
"                ++spec;\x0a"
"                break;\x0a"
"            default\x3a\x0a"
"                /* not a flag, exit flag parsing */\x0a"
"                status->flags \x7c= E_done;\x0a"
"                break;\x0a"
"        }\x0a"
"    } while ( \x21 ( status->flags \x26 E_done ) );\x0a"
"\x0a"
"    /* Optional field width */\x0a"
"    if ( *spec == '*' )\x0a"
"    {\x0a"
"        /* Retrieve width value from argument stack */\x0a"
"        int width = va_arg( status->arg, int );\x0a"
"        if ( width < 0 )\x0a"
"        {\x0a"
"            status->flags \x7c= E_minus;\x0a"
"            status->width = abs( width );\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            status->width = width;\x0a"
"        }\x0a"
"        ++spec;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        /* If a width is given, strtol() will return its value. If not given,\x0a"
"           strtol() will return zero. In both cases, endptr will point to the\x0a"
"           rest of the conversion specifier - just what we need.\x0a"
"        */\x0a"
"        // Original\x3a status->width = (int)strtol( spec, (char**)\x26spec, 10 );\x0a"
"        // See _PDCLIB_io.h\x0a"
"        status->width = ( int ) _DIVINE_strtol( spec, INT_MAX, ( char ** )\x26spec );\x0a"
"    }\x0a"
"\x0a"
"    /* Optional precision */\x0a"
"    if ( *spec == '.' )\x0a"
"    {\x0a"
"        ++spec;\x0a"
"        if ( *spec == '*' )\x0a"
"        {\x0a"
"            /* Retrieve precision value from argument stack. A negative value\x0a"
"               is as if no precision is given - as precision is initalized to\x0a"
"               EOF (negative), there is no need for testing for negative here.\x0a"
"            */\x0a"
"            status->prec = va_arg( status->arg, int );\x0a"
"            ++spec;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            // Original\x3a status->prec = (int)strtol( spec, (char**) \x26spec, 10 );\x0a"
"            // See _PDCLIB_io.h\x0a"
"            status->prec = ( int ) _DIVINE_strtol( spec, INT_MAX, ( char ** ) \x26spec );\x0a"
"        }\x0a"
"        /* Having a precision cancels out any zero flag. */\x0a"
"        status->flags \x26= \x7e""E_zero;\x0a"
"    }\x0a"
"\x0a"
"    /* Optional length modifier\x0a"
"       We step one character ahead in any case, and step back only if we find\x0a"
"       there has been no length modifier (or step ahead another character if it\x0a"
"       has been \x22hh\x22 or \x22ll\x22).\x0a"
"    */\x0a"
"    switch ( *(spec++) )\x0a"
"    {\x0a"
"        case 'h'\x3a\x0a"
"            if ( *spec == 'h' )\x0a"
"            {\x0a"
"                /* hh -> char */\x0a"
"                status->flags \x7c= E_char;\x0a"
"                ++spec;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                /* h -> short */\x0a"
"                status->flags \x7c= E_short;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 'l'\x3a\x0a"
"            if ( *spec == 'l' )\x0a"
"            {\x0a"
"                /* ll -> long long */\x0a"
"                status->flags \x7c= E_llong;\x0a"
"                ++spec;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                /* k -> long */\x0a"
"                status->flags \x7c= E_long;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 'j'\x3a\x0a"
"            /* j -> intmax_t, which might or might not be long long */\x0a"
"            status->flags \x7c= E_intmax;\x0a"
"            break;\x0a"
"        case 'z'\x3a\x0a"
"            /* z -> size_t, which might or might not be unsigned int */\x0a"
"            status->flags \x7c= E_size;\x0a"
"            break;\x0a"
"        case 't'\x3a\x0a"
"            /* t -> ptrdiff_t, which might or might not be long */\x0a"
"            status->flags \x7c= E_ptrdiff;\x0a"
"            break;\x0a"
"        case 'L'\x3a\x0a"
"            /* L -> long double */\x0a"
"            status->flags \x7c= E_ldouble;\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            --spec;\x0a"
"            break;\x0a"
"    }\x0a"
"\x0a"
"    /* Conversion specifier */\x0a"
"    switch ( *spec )\x0a"
"    {\x0a"
"        case 'd'\x3a\x0a"
"            /* FALLTHROUGH */\x0a"
"        case 'i'\x3a\x0a"
"            status->base = 10;\x0a"
"            break;\x0a"
"        case 'o'\x3a\x0a"
"            status->base = 8;\x0a"
"            status->flags \x7c= E_unsigned;\x0a"
"            break;\x0a"
"        case 'u'\x3a\x0a"
"            status->base = 10;\x0a"
"            status->flags \x7c= E_unsigned;\x0a"
"            break;\x0a"
"        case 'x'\x3a\x0a"
"            status->base = 16;\x0a"
"            status->flags \x7c= ( E_lower \x7c E_unsigned );\x0a"
"            break;\x0a"
"        case 'X'\x3a\x0a"
"            status->base = 16;\x0a"
"            status->flags \x7c= E_unsigned;\x0a"
"            break;\x0a"
"        case 'f'\x3a\x0a"
"        case 'F'\x3a\x0a"
"        case 'e'\x3a\x0a"
"        case 'E'\x3a\x0a"
"        case 'g'\x3a\x0a"
"        case 'G'\x3a\x0a"
"            break;\x0a"
"        case 'a'\x3a\x0a"
"        case 'A'\x3a\x0a"
"            break;\x0a"
"        case 'c'\x3a\x0a"
"            /* TODO\x3a wide chars. */\x0a"
"            if ( \x21printchar( va_arg( status->arg, int ), status ) )\x0a"
"                return -1;\x0a"
"            ++spec;\x0a"
"            return (spec - orig_spec);\x0a"
"        case 's'\x3a\x0a"
"            /* TODO\x3a wide chars. */\x0a"
"            {\x0a"
"                char * s = va_arg( status->arg, char * );\x0a"
"                if ( \x21printstr( s, status ) )\x0a"
"                    return -1;\x0a"
"                ++spec;\x0a"
"                return (spec - orig_spec);\x0a"
"            }\x0a"
"        case 'p'\x3a\x0a"
"            status->base = 16;\x0a"
"            status->flags \x7c= ( E_lower \x7c E_unsigned \x7c E_alt \x7c E_intptr );\x0a"
"            break;\x0a"
"        case 'n'\x3a\x0a"
"           {\x0a"
"               int * val = va_arg( status->arg, int * );\x0a"
"               *val = status->i;\x0a"
"               ++spec;\x0a"
"               return (spec - orig_spec);\x0a"
"           }\x0a"
"        default\x3a\x0a"
"            /* No conversion specifier. Bad conversion. */\x0a"
"            return 0;\x0a"
"    }\x0a"
"    /* Do the actual output based on our findings */\x0a"
"    if ( status->base \x21= 0 )\x0a"
"    {\x0a"
"        /* Integer conversions */\x0a"
"        /* TODO\x3a Check for invalid flag combinations. */\x0a"
"        if ( status->flags \x26 E_unsigned )\x0a"
"        {\x0a"
"            /* TODO\x3a Marking the default case _PDCLIB_UNREACHABLE breaks \x25ju test driver\x3f */\x0a"
"            uintmax_t value = 0;\x0a"
"            switch ( status->flags \x26 E_TYPES )\x0a"
"            {\x0a"
"                case E_char\x3a\x0a"
"                    value = (uintmax_t)(unsigned char)va_arg( status->arg, int );\x0a"
"                    break;\x0a"
"                case E_short\x3a\x0a"
"                    value = (uintmax_t)(unsigned short)va_arg( status->arg, int );\x0a"
"                    break;\x0a"
"                case 0\x3a\x0a"
"                    value = (uintmax_t)va_arg( status->arg, unsigned int );\x0a"
"                    break;\x0a"
"                case E_long\x3a\x0a"
"                    value = (uintmax_t)va_arg( status->arg, unsigned long );\x0a"
"                    break;\x0a"
"                case E_llong\x3a\x0a"
"                    value = (uintmax_t)va_arg( status->arg, unsigned long long );\x0a"
"                    break;\x0a"
"                case E_size\x3a\x0a"
"                    value = (uintmax_t)va_arg( status->arg, size_t );\x0a"
"                    break;\x0a"
"                case E_intptr\x3a\x0a"
"                    value = (uintmax_t)va_arg( status->arg, uintptr_t );\x0a"
"                    break;\x0a"
"                case E_ptrdiff\x3a\x0a"
"                    value = (uintmax_t)va_arg( status->arg, ptrdiff_t );\x0a"
"                    break;\x0a"
"                case E_intmax\x3a\x0a"
"                    value = va_arg( status->arg, uintmax_t );\x0a"
"            }\x0a"
"            if ( \x21int2base( value, status ) )\x0a"
"                return -1;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            intmax_t value = 0;\x0a"
"            switch ( status->flags \x26 E_TYPES )\x0a"
"            {\x0a"
"                case E_char\x3a\x0a"
"                    value = (intmax_t)(char)va_arg( status->arg, int );\x0a"
"                    break;\x0a"
"                case E_short\x3a\x0a"
"                    value = (intmax_t)(short)va_arg( status->arg, int );\x0a"
"                    break;\x0a"
"                case 0\x3a\x0a"
"                    value = (intmax_t)va_arg( status->arg, int );\x0a"
"                    break;\x0a"
"                case E_long\x3a\x0a"
"                    value = (intmax_t)va_arg( status->arg, long );\x0a"
"                    break;\x0a"
"                case E_llong\x3a\x0a"
"                    value = (intmax_t)va_arg( status->arg, long long );\x0a"
"                    break;\x0a"
"                case E_size\x3a\x0a"
"                    value = (intmax_t)va_arg( status->arg, size_t );\x0a"
"                    break;\x0a"
"                case E_intptr\x3a\x0a"
"                    value = (intmax_t)va_arg( status->arg, intptr_t );\x0a"
"                    break;\x0a"
"                case E_ptrdiff\x3a\x0a"
"                    value = (intmax_t)va_arg( status->arg, ptrdiff_t );\x0a"
"                    break;\x0a"
"                case E_intmax\x3a\x0a"
"                    value = va_arg( status->arg, intmax_t );\x0a"
"                    break;\x0a"
"                default\x3a\x0a"
"                    _PDCLIB_UNREACHABLE;\x0a"
"            }\x0a"
"\x0a"
"            if (\x21int2base( value, status ) )\x0a"
"                return -1;\x0a"
"        }\x0a"
"\x0a"
"        if ( status->flags \x26 E_minus \x26\x26 status->current < status->width )\x0a"
"        {\x0a"
"            if (\x21""cbrept( status, ' ', status->width - status->current ))\x0a"
"                return -1;\x0a"
"        }\x0a"
"    }\x0a"
"    ++spec;\x0a"
"    return spec - orig_spec;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#define _PDCLIB_FILEID \x22_PDCLIB/print.c\x22\x0a"
"#define _PDCLIB_STRINGIO\x0a"
"\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"static size_t testcb( void *p, const char *buf, size_t size )\x0a"
"{\x0a"
"    char **destbuf = p;\x0a"
"    memcpy(*destbuf, buf, size);\x0a"
"    *destbuf += size;\x0a"
"    return size;\x0a"
"}\x0a"
"\x0a"
"static int testprintf( char * buffer, const char * format, ... )\x0a"
"{\x0a"
"    /* Members\x3a base, flags, n, i, current, width, prec, ctx, cb, arg      */\x0a"
"    struct _PDCLIB_status_t status;\x0a"
"    status.base = 0;\x0a"
"    status.flags = 0;\x0a"
"    status.n = 100;\x0a"
"    status.i = 0;\x0a"
"    status.current = 0;\x0a"
"    status.width = 0;\x0a"
"    status.prec = 0;\x0a"
"    status.ctx = \x26""buffer;\x0a"
"    status.write = testcb;\x0a"
"    va_start( status.arg, format );\x0a"
"    memset( buffer, '\x5c""0', 100 );\x0a"
"    if ( _PDCLIB_print( format, \x26status ) \x21= (int)strlen( format ) )\x0a"
"    {\x0a"
"        printf( \x22_PDCLIB_print() did not return end-of-specifier on '\x25s'.\x5cn\x22, format );\x0a"
"        ++TEST_RESULTS;\x0a"
"    }\x0a"
"    va_end( status.arg );\x0a"
"    return status.i;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#define TEST_CONVERSION_ONLY\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"#ifndef REGTEST\x0a"
"    char target\x5b""100\x5d;\x0a"
"#include \x22printf_testcases.h\x22\x0a"
"#endif\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"", 18369 ); }