#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio__PDCLIB_scan_c( 
"/* _PDCLIB_scan( const char *, struct _PDCLIB_status_t * )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"#include <stdbool.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <stdarg.h>\x0a"
"#include <stdint.h>\x0a"
"#include <ctype.h>\x0a"
"#include <string.h>\x0a"
"#include <stddef.h>\x0a"
"#include <limits.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"\x0a"
"#include \x22_PDCLIB/io.h\x22\x0a"
"\x0a"
"/* Using an integer's bits as flags for both the conversion flags and length\x0a"
"   modifiers.\x0a"
"*/\x0a"
"#define E_suppressed 1<<0\x0a"
"#define E_char       1<<6\x0a"
"#define E_short      1<<7\x0a"
"#define E_long       1<<8\x0a"
"#define E_llong      1<<9\x0a"
"#define E_intmax     1<<10\x0a"
"#define E_size       1<<11\x0a"
"#define E_ptrdiff    1<<12\x0a"
"#define E_intptr     1<<13\x0a"
"#define E_ldouble    1<<14\x0a"
"#define E_unsigned   1<<16\x0a"
"\x0a"
"\x0a"
"/* Helper function to get a character from the string or stream, whatever is\x0a"
"   used for input. When reading from a string, returns EOF on end-of-string\x0a"
"   so that handling of the return value can be uniform for both streams and\x0a"
"   strings.\x0a"
"*/\x0a"
"static int GET( struct _PDCLIB_status_t * status )\x0a"
"{\x0a"
"    int rc = EOF;\x0a"
"    if ( status->stream \x21= NULL )\x0a"
"    {\x0a"
"        rc = getc_unlocked( status->stream );\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        rc = ( *status->s == '\x5c""0' ) \x3f EOF \x3a (unsigned char)*((status->s)++);\x0a"
"    }\x0a"
"    if ( rc \x21= EOF )\x0a"
"    {\x0a"
"        ++(status->i);\x0a"
"        ++(status->current);\x0a"
"    }\x0a"
"    return rc;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* Helper function to put a read character back into the string or stream,\x0a"
"   whatever is used for input.\x0a"
"*/\x0a"
"static void UNGET( int c, struct _PDCLIB_status_t * status )\x0a"
"{\x0a"
"    if ( status->stream \x21= NULL )\x0a"
"    {\x0a"
"        _PDCLIB_ungetc_unlocked( c, status->stream ); /* TODO\x3a Error\x3f */\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        --(status->s);\x0a"
"    }\x0a"
"    --(status->i);\x0a"
"    --(status->current);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* Helper function to check if a character is part of a given scanset */\x0a"
"static bool IN_SCANSET( const char * scanlist, const char * end_scanlist, int rc )\x0a"
"{\x0a"
"    // SOLAR\x0a"
"    int previous = -1;\x0a"
"    while ( scanlist \x21= end_scanlist )\x0a"
"    {\x0a"
"        if ( ( *scanlist == '-' ) \x26\x26 ( previous \x21= -1 ) )\x0a"
"        {\x0a"
"            /* possible scangroup (\x22""a-z\x22) */\x0a"
"            if ( ++scanlist == end_scanlist )\x0a"
"            {\x0a"
"                /* '-' at end of scanlist does not describe a scangroup */\x0a"
"                return rc == '-';\x0a"
"            }\x0a"
"            while ( ++previous <= (unsigned char)*scanlist )\x0a"
"            {\x0a"
"                if ( previous == rc )\x0a"
"                {\x0a"
"                    return true;\x0a"
"                }\x0a"
"            }\x0a"
"            previous = -1;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            /* not a scangroup, check verbatim */\x0a"
"            if ( rc == (unsigned char)*scanlist )\x0a"
"            {\x0a"
"                return true;\x0a"
"            }\x0a"
"            previous = (unsigned char)(*scanlist++);\x0a"
"        }\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"const char * _PDCLIB_scan( const char * spec, struct _PDCLIB_status_t * status )\x0a"
"{\x0a"
"    /* generic input character */\x0a"
"    int rc = EOF;\x0a"
"    const char * orig_spec = spec;\x0a"
"    if ( *(++spec) == '\x25' )\x0a"
"    {\x0a"
"        /* \x25\x25 -> match single '\x25' */\x0a"
"        rc = GET( status );\x0a"
"        switch ( rc )\x0a"
"        {\x0a"
"            case EOF\x3a\x0a"
"                /* input error */\x0a"
"                if ( status->n == 0 )\x0a"
"                {\x0a"
"                    status->n = -1;\x0a"
"                }\x0a"
"                return NULL;\x0a"
"            case '\x25'\x3a\x0a"
"                return ++spec;\x0a"
"            default\x3a\x0a"
"                UNGET( rc, status );\x0a"
"                break;\x0a"
"        }\x0a"
"    }\x0a"
"    /* Initializing status structure */\x0a"
"    status->flags = 0;\x0a"
"    status->base = -1;\x0a"
"    status->current = 0;\x0a"
"    status->width = 0;\x0a"
"    status->prec = 0;\x0a"
"\x0a"
"    /* '*' suppresses assigning parsed value to variable */\x0a"
"    if ( *spec == '*' )\x0a"
"    {\x0a"
"        status->flags \x7c= E_suppressed;\x0a"
"        ++spec;\x0a"
"    }\x0a"
"\x0a"
"    /* If a width is given, strtol() will return its value. If not given,\x0a"
"       strtol() will return zero. In both cases, endptr will point to the\x0a"
"       rest of the conversion specifier - just what we need.\x0a"
"    */\x0a"
"    char const * prev_spec = spec;\x0a"
"    status->width = (int)strtol( spec, (char**)\x26spec, 10 );\x0a"
"    if ( spec == prev_spec )\x0a"
"    {\x0a"
"        status->width = UINT_MAX;\x0a"
"    }\x0a"
"\x0a"
"    /* Optional length modifier\x0a"
"       We step one character ahead in any case, and step back only if we find\x0a"
"       there has been no length modifier (or step ahead another character if it\x0a"
"       has been \x22hh\x22 or \x22ll\x22).\x0a"
"    */\x0a"
"    switch ( *(spec++) )\x0a"
"    {\x0a"
"        case 'h'\x3a\x0a"
"            if ( *spec == 'h' )\x0a"
"            {\x0a"
"                /* hh -> char */\x0a"
"                status->flags \x7c= E_char;\x0a"
"                ++spec;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                /* h -> short */\x0a"
"                status->flags \x7c= E_short;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 'l'\x3a\x0a"
"            if ( *spec == 'l' )\x0a"
"            {\x0a"
"                /* ll -> long long */\x0a"
"                status->flags \x7c= E_llong;\x0a"
"                ++spec;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                /* l -> long */\x0a"
"                status->flags \x7c= E_long;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 'j'\x3a\x0a"
"            /* j -> intmax_t, which might or might not be long long */\x0a"
"            status->flags \x7c= E_intmax;\x0a"
"            break;\x0a"
"        case 'z'\x3a\x0a"
"            /* z -> size_t, which might or might not be unsigned int */\x0a"
"            status->flags \x7c= E_size;\x0a"
"            break;\x0a"
"        case 't'\x3a\x0a"
"            /* t -> ptrdiff_t, which might or might not be long */\x0a"
"            status->flags \x7c= E_ptrdiff;\x0a"
"            break;\x0a"
"        case 'L'\x3a\x0a"
"            /* L -> long double */\x0a"
"            status->flags \x7c= E_ldouble;\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            --spec;\x0a"
"            break;\x0a"
"    }\x0a"
"\x0a"
"    /* Conversion specifier */\x0a"
"\x0a"
"    /* whether valid input had been parsed */\x0a"
"    bool value_parsed = false;\x0a"
"\x0a"
"    switch ( *spec )\x0a"
"    {\x0a"
"        case 'd'\x3a\x0a"
"            status->base = 10;\x0a"
"            break;\x0a"
"        case 'i'\x3a\x0a"
"            status->base = 0;\x0a"
"            break;\x0a"
"        case 'o'\x3a\x0a"
"            status->base = 8;\x0a"
"            status->flags \x7c= E_unsigned;\x0a"
"            break;\x0a"
"        case 'u'\x3a\x0a"
"            status->base = 10;\x0a"
"            status->flags \x7c= E_unsigned;\x0a"
"            break;\x0a"
"        case 'x'\x3a\x0a"
"            status->base = 16;\x0a"
"            status->flags \x7c= E_unsigned;\x0a"
"            break;\x0a"
"        case 'f'\x3a\x0a"
"        case 'F'\x3a\x0a"
"        case 'e'\x3a\x0a"
"        case 'E'\x3a\x0a"
"        case 'g'\x3a\x0a"
"        case 'G'\x3a\x0a"
"        case 'a'\x3a\x0a"
"        case 'A'\x3a\x0a"
"            break;\x0a"
"        case 'c'\x3a\x0a"
"        {\x0a"
"            char * c = va_arg( status->arg, char * );\x0a"
"            /* for \x25""c, default width is one */\x0a"
"            if ( status->width == UINT_MAX )\x0a"
"            {\x0a"
"                status->width = 1;\x0a"
"            }\x0a"
"            /* reading until width reached or input exhausted */\x0a"
"            while ( ( status->current < status->width ) \x26\x26\x0a"
"                    ( ( rc = GET( status ) ) \x21= EOF ) )\x0a"
"            {\x0a"
"                *(c++) = rc;\x0a"
"                value_parsed = true;\x0a"
"            }\x0a"
"            /* width or input exhausted */\x0a"
"            if ( value_parsed )\x0a"
"            {\x0a"
"                ++status->n;\x0a"
"                return ++spec;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                /* input error, no character read */\x0a"
"                if ( status->n == 0 )\x0a"
"                {\x0a"
"                    status->n = -1;\x0a"
"                }\x0a"
"                return NULL;\x0a"
"            }\x0a"
"        }\x0a"
"        case 's'\x3a\x0a"
"        {\x0a"
"            char * c = va_arg( status->arg, char * );\x0a"
"            while ( ( status->current < status->width ) \x26\x26\x0a"
"                    ( ( rc = GET( status ) ) \x21= EOF ) )\x0a"
"            {\x0a"
"                if ( isspace( rc ) )\x0a"
"                {\x0a"
"                    UNGET( rc, status );\x0a"
"                    if ( value_parsed )\x0a"
"                    {\x0a"
"                        /* matching sequence terminated by whitespace */\x0a"
"                        *c = '\x5c""0';\x0a"
"                        ++status->n;\x0a"
"                        return ++spec;\x0a"
"                    }\x0a"
"                    else\x0a"
"                    {\x0a"
"                        /* matching error */\x0a"
"                        return NULL;\x0a"
"                    }\x0a"
"                }\x0a"
"                else\x0a"
"                {\x0a"
"                    /* match */\x0a"
"                    value_parsed = true;\x0a"
"                    *(c++) = rc;\x0a"
"                }\x0a"
"            }\x0a"
"            /* width or input exhausted */\x0a"
"            if ( value_parsed )\x0a"
"            {\x0a"
"                *c = '\x5c""0';\x0a"
"                ++status->n;\x0a"
"                return ++spec;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                /* input error, no character read */\x0a"
"                if ( status->n == 0 )\x0a"
"                {\x0a"
"                    status->n = -1;\x0a"
"                }\x0a"
"                return NULL;\x0a"
"            }\x0a"
"        }\x0a"
"        case '\x5b'\x3a\x0a"
"        {\x0a"
"            const char * endspec = spec;\x0a"
"            bool negative_scanlist = false;\x0a"
"            if ( *(++endspec) == '^' )\x0a"
"            {\x0a"
"                negative_scanlist = true;\x0a"
"                ++endspec;\x0a"
"            }\x0a"
"            spec = endspec;\x0a"
"            do\x0a"
"            {\x0a"
"                // TODO\x3a This can run beyond a malformed format string\x0a"
"                ++endspec;\x0a"
"            } while ( *endspec \x21= '\x5d' );\x0a"
"            // read according to scanlist, equiv. to \x25s above\x0a"
"            char * c = va_arg( status->arg, char * );\x0a"
"            while ( ( status->current < status->width ) \x26\x26\x0a"
"                    ( ( rc = GET( status ) ) \x21= EOF ) )\x0a"
"            {\x0a"
"                if ( negative_scanlist )\x0a"
"                {\x0a"
"                    if ( IN_SCANSET( spec, endspec, rc ) )\x0a"
"                    {\x0a"
"                        UNGET( rc, status );\x0a"
"                        break;\x0a"
"                    }\x0a"
"                }\x0a"
"                else\x0a"
"                {\x0a"
"                    if ( \x21 IN_SCANSET( spec, endspec, rc ) )\x0a"
"                    {\x0a"
"                        UNGET( rc, status );\x0a"
"                        break;\x0a"
"                    }\x0a"
"                }\x0a"
"                value_parsed = true;\x0a"
"                *(c++) = rc;\x0a"
"            }\x0a"
"            if ( value_parsed )\x0a"
"            {\x0a"
"                *c = '\x5c""0';\x0a"
"                ++status->n;\x0a"
"                return ++endspec;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                if ( rc == EOF )\x0a"
"                {\x0a"
"                    status->n = -1;\x0a"
"                }\x0a"
"                return NULL;\x0a"
"            }\x0a"
"        }\x0a"
"        case 'p'\x3a\x0a"
"            status->base = 16;\x0a"
"            // TODO\x3a Like _PDCLIB_print, E_pointer(\x3f)\x0a"
"            status->flags \x7c= E_unsigned \x7c E_long;\x0a"
"            break;\x0a"
"        case 'n'\x3a\x0a"
"        {\x0a"
"            int * val = va_arg( status->arg, int * );\x0a"
"            *val = status->i;\x0a"
"            return ++spec;\x0a"
"        }\x0a"
"        default\x3a\x0a"
"            /* No conversion specifier. Bad conversion. */\x0a"
"            return orig_spec;\x0a"
"    }\x0a"
"\x0a"
"    if ( status->base \x21= -1 )\x0a"
"    {\x0a"
"        /* integer conversion */\x0a"
"        uintmax_t value = 0;         /* absolute value read */\x0a"
"        bool prefix_parsed = false;\x0a"
"        int sign = 0;\x0a"
"        while ( ( status->current < status->width ) \x26\x26\x0a"
"                ( ( rc = GET( status ) ) \x21= EOF ) )\x0a"
"        {\x0a"
"            if ( isspace( rc ) )\x0a"
"            {\x0a"
"                if ( sign )\x0a"
"                {\x0a"
"                    /* matching sequence terminated by whitespace */\x0a"
"                    UNGET( rc, status );\x0a"
"                    break;\x0a"
"                }\x0a"
"                else\x0a"
"                {\x0a"
"                    /* leading whitespace not counted against width */\x0a"
"                    status->current--;\x0a"
"                }\x0a"
"            }\x0a"
"            else if ( \x21 sign )\x0a"
"            {\x0a"
"                /* no sign parsed yet */\x0a"
"                switch ( rc )\x0a"
"                {\x0a"
"                    case '-'\x3a\x0a"
"                        sign = -1;\x0a"
"                        break;\x0a"
"                    case '+'\x3a\x0a"
"                        sign = 1;\x0a"
"                        break;\x0a"
"                    default\x3a\x0a"
"                        /* not a sign; put back character */\x0a"
"                        sign = 1;\x0a"
"                        UNGET( rc, status );\x0a"
"                        break;\x0a"
"                }\x0a"
"            }\x0a"
"            else if ( \x21 prefix_parsed )\x0a"
"            {\x0a"
"                /* no prefix (0x... for hex, 0... for octal) parsed yet */\x0a"
"                prefix_parsed = true;\x0a"
"                if ( rc \x21= '0' )\x0a"
"                {\x0a"
"                    /* not a prefix; if base not yet set, set to decimal */\x0a"
"                    if ( status->base == 0 )\x0a"
"                    {\x0a"
"                        status->base = 10;\x0a"
"                    }\x0a"
"                    UNGET( rc, status );\x0a"
"                }\x0a"
"                else\x0a"
"                {\x0a"
"                    /* starts with zero, so it might be a prefix. */\x0a"
"                    /* check what follows next (might be 0x...) */\x0a"
"                    if ( ( status->current < status->width ) \x26\x26\x0a"
"                         ( ( rc = GET( status ) ) \x21= EOF ) )\x0a"
"                    {\x0a"
"                        if ( tolower( rc ) == 'x' )\x0a"
"                        {\x0a"
"                            /* 0x... would be prefix for hex base... */\x0a"
"                            if ( ( status->base == 0 ) \x7c\x7c\x0a"
"                                 ( status->base == 16 ) )\x0a"
"                            {\x0a"
"                                status->base = 16;\x0a"
"                            }\x0a"
"                            else\x0a"
"                            {\x0a"
"                                /* ...unless already set to other value */\x0a"
"                                UNGET( rc, status );\x0a"
"                                value_parsed = true;\x0a"
"                            }\x0a"
"                        }\x0a"
"                        else\x0a"
"                        {\x0a"
"                            /* 0... but not 0x.... would be octal prefix */\x0a"
"                            UNGET( rc, status );\x0a"
"                            if ( status->base == 0 )\x0a"
"                            {\x0a"
"                                status->base = 8;\x0a"
"                            }\x0a"
"                            /* in any case we have read a zero */\x0a"
"                            value_parsed = true;\x0a"
"                        }\x0a"
"                    }\x0a"
"                    else\x0a"
"                    {\x0a"
"                        /* failed to read beyond the initial zero */\x0a"
"                        value_parsed = true;\x0a"
"                        break;\x0a"
"                    }\x0a"
"                }\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                char * digitptr = memchr( _PDCLIB_digits, tolower( rc ), status->base );\x0a"
"                if ( digitptr == NULL )\x0a"
"                {\x0a"
"                    /* end of input item */\x0a"
"                    UNGET( rc, status );\x0a"
"                    break;\x0a"
"                }\x0a"
"                value *= status->base;\x0a"
"                value += digitptr - _PDCLIB_digits;\x0a"
"                value_parsed = true;\x0a"
"            }\x0a"
"        }\x0a"
"        /* width or input exhausted, or non-matching character */\x0a"
"        if ( \x21 value_parsed )\x0a"
"        {\x0a"
"            /* out of input before anything could be parsed - input error */\x0a"
"            /* FIXME\x3a if first character does not match, value_parsed is not set - but it is NOT an input error */\x0a"
"            if ( ( status->n == 0 ) \x26\x26 ( rc == EOF ) )\x0a"
"            {\x0a"
"                status->n = -1;\x0a"
"            }\x0a"
"            return NULL;\x0a"
"        }\x0a"
"        /* convert value to target type and assign to parameter */\x0a"
"        if ( \x21 ( status->flags \x26 E_suppressed ) )\x0a"
"        {\x0a"
"            switch ( status->flags \x26 ( E_char \x7c E_short \x7c E_long \x7c E_llong \x7c\x0a"
"                                       E_intmax \x7c E_size \x7c E_ptrdiff \x7c\x0a"
"                                       E_unsigned ) )\x0a"
"            {\x0a"
"                case E_char\x3a\x0a"
"                    *( va_arg( status->arg,               char * ) ) =               (char)( value * sign );\x0a"
"                    break;\x0a"
"                case E_char \x7c E_unsigned\x3a\x0a"
"                    *( va_arg( status->arg,      unsigned char * ) ) =      (unsigned char)( value * sign );\x0a"
"                    break;\x0a"
"\x0a"
"                case E_short\x3a\x0a"
"                    *( va_arg( status->arg,              short * ) ) =              (short)( value * sign );\x0a"
"                    break;\x0a"
"                case E_short \x7c E_unsigned\x3a\x0a"
"                    *( va_arg( status->arg,     unsigned short * ) ) =     (unsigned short)( value * sign );\x0a"
"                    break;\x0a"
"\x0a"
"                case 0\x3a\x0a"
"                    *( va_arg( status->arg,                int * ) ) =                (int)( value * sign );\x0a"
"                    break;\x0a"
"                case E_unsigned\x3a\x0a"
"                    *( va_arg( status->arg,       unsigned int * ) ) =       (unsigned int)( value * sign );\x0a"
"                    break;\x0a"
"\x0a"
"                case E_long\x3a\x0a"
"                    *( va_arg( status->arg,               long * ) ) =               (long)( value * sign );\x0a"
"                    break;\x0a"
"                case E_long \x7c E_unsigned\x3a\x0a"
"                    *( va_arg( status->arg,      unsigned long * ) ) =      (unsigned long)( value * sign );\x0a"
"                    break;\x0a"
"\x0a"
"                case E_llong\x3a\x0a"
"                    *( va_arg( status->arg,          long long * ) ) =          (long long)( value * sign );\x0a"
"                    break;\x0a"
"                case E_llong \x7c E_unsigned\x3a\x0a"
"                    *( va_arg( status->arg, unsigned long long * ) ) = (unsigned long long)( value * sign );\x0a"
"                    break;\x0a"
"\x0a"
"                case E_intmax\x3a\x0a"
"                    *( va_arg( status->arg,           intmax_t * ) ) =           (intmax_t)( value * sign );\x0a"
"                    break;\x0a"
"                case E_intmax \x7c E_unsigned\x3a\x0a"
"                    *( va_arg( status->arg,          uintmax_t * ) ) =          (uintmax_t)( value * sign );\x0a"
"                    break;\x0a"
"\x0a"
"                case E_size\x3a\x0a"
"                    /* E_size always implies unsigned */\x0a"
"                    *( va_arg( status->arg,             size_t * ) ) =             (size_t)( value * sign );\x0a"
"                    break;\x0a"
"\x0a"
"                case E_ptrdiff\x3a\x0a"
"                    /* E_ptrdiff always implies signed */\x0a"
"                    *( va_arg( status->arg,          ptrdiff_t * ) ) =          (ptrdiff_t)( value * sign );\x0a"
"                    break;\x0a"
"\x0a"
"                default\x3a\x0a"
"                    puts( \x22UNSUPPORTED SCANF FLAG COMBINATION\x22 );\x0a"
"                    return NULL; /* behaviour unspecified */\x0a"
"            }\x0a"
"            ++(status->n);\x0a"
"        }\x0a"
"        return ++spec;\x0a"
"    }\x0a"
"    /* TODO\x3a Floats. */\x0a"
"    return NULL;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#define _PDCLIB_FILEID \x22_PDCLIB/scan.c\x22\x0a"
"#define _PDCLIB_STRINGIO\x0a"
"\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"static int testscanf( char const * s, char const * format, ... )\x0a"
"{\x0a"
"    struct _PDCLIB_status_t status;\x0a"
"    status.n = 0;\x0a"
"    status.i = 0;\x0a"
"    status.s = (char *)s;\x0a"
"    status.stream = NULL;\x0a"
"    va_start( status.arg, format );\x0a"
"    if ( *(_PDCLIB_scan( format, \x26status )) \x21= '\x5c""0' )\x0a"
"    {\x0a"
"        printf( \x22_PDCLIB_scan() did not return end-of-specifier on '\x25s'.\x5cn\x22, format );\x0a"
"        ++TEST_RESULTS;\x0a"
"    }\x0a"
"    va_end( status.arg );\x0a"
"    return status.n;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#define TEST_CONVERSION_ONLY\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"#ifndef REGTEST\x0a"
"    char source\x5b""100\x5d;\x0a"
"#include \x22scanf_testcases.h\x22\x0a"
"#endif\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"", 19074 ); }