#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio_fclose_c( 
"/* fclose( FILE * )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <errno.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"#include \x22_PDCLIB/io.h\x22\x0a"
"#include <threads.h>\x0a"
"\x0a"
"extern FILE * _PDCLIB_filelist;\x0a"
"extern mtx_t _PDCLIB_filelist_lock;\x0a"
"\x0a"
"\x0a"
"int fclose( FILE * stream )\x0a"
"{\x0a"
"    mtx_lock( \x26_PDCLIB_filelist_lock );\x0a"
"    FILE * current = _PDCLIB_filelist;\x0a"
"    FILE * previous = NULL;\x0a"
"    /* Checking that the FILE handle is actually one we had opened before. */\x0a"
"    while ( current \x21= NULL )\x0a"
"    {\x0a"
"        if ( stream == current )\x0a"
"        {\x0a"
"            /* Flush buffer */\x0a"
"            if ( stream->status \x26 _PDCLIB_FWRITE )\x0a"
"            {\x0a"
"                if ( _PDCLIB_flushbuffer( stream ) == EOF )\x0a"
"                {\x0a"
"                    /* Flush failed, errno already set */\x0a"
"                    mtx_unlock( \x26_PDCLIB_filelist_lock );\x0a"
"                    return EOF;\x0a"
"                }\x0a"
"            }\x0a"
"\x0a"
"            /* Release mutex*/\x0a"
"            mtx_destroy( \x26stream->lock );\x0a"
"\x0a"
"            /* Close handle */\x0a"
"            stream->ops->close(stream->handle);\x0a"
"\x0a"
"            /* Remove stream from list */\x0a"
"            if ( previous \x21= NULL )\x0a"
"            {\x0a"
"                previous->next = stream->next;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                _PDCLIB_filelist = stream->next;\x0a"
"            }\x0a"
"            mtx_unlock( \x26_PDCLIB_filelist_lock );\x0a"
"\x0a"
"            /* Delete tmpfile() */\x0a"
"            if ( stream->status \x26 _PDCLIB_DELONCLOSE )\x0a"
"            {\x0a"
"                remove( stream->filename );\x0a"
"            }\x0a"
"            /* Free user buffer (SetVBuf allocated) */\x0a"
"            if ( stream->status \x26 _PDCLIB_FREEBUFFER )\x0a"
"            {\x0a"
"                free( stream->buffer );\x0a"
"            }\x0a"
"            /* Free stream */\x0a"
"            if ( \x21 ( stream->status \x26 _PDCLIB_STATIC ) )\x0a"
"            {\x0a"
"                free( stream );\x0a"
"            }\x0a"
"            return 0;\x0a"
"        }\x0a"
"        previous = current;\x0a"
"        current = current->next;\x0a"
"    }\x0a"
"\x0a"
"    mtx_unlock( \x26_PDCLIB_filelist_lock );\x0a"
"    errno = EINVAL;\x0a"
"    return -1;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"#ifndef REGTEST\x0a"
"    FILE * file1;\x0a"
"    FILE * file2;\x0a"
"    remove( testfile1 );\x0a"
"    remove( testfile2 );\x0a"
"    TESTCASE( _PDCLIB_filelist == stdin );\x0a"
"    TESTCASE( ( file1 = fopen( testfile1, \x22w\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE( _PDCLIB_filelist == file1 );\x0a"
"    TESTCASE( ( file2 = fopen( testfile2, \x22w\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE( _PDCLIB_filelist == file2 );\x0a"
"    TESTCASE( fclose( file2 ) == 0 );\x0a"
"    TESTCASE( _PDCLIB_filelist == file1 );\x0a"
"    TESTCASE( ( file2 = fopen( testfile2, \x22w\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE( _PDCLIB_filelist == file2 );\x0a"
"    TESTCASE( fclose( file1 ) == 0 );\x0a"
"    TESTCASE( _PDCLIB_filelist == file2 );\x0a"
"    TESTCASE( fclose( file2 ) == 0 );\x0a"
"    TESTCASE( _PDCLIB_filelist == stdin );\x0a"
"    TESTCASE( remove( testfile1 ) == 0 );\x0a"
"    TESTCASE( remove( testfile2 ) == 0 );\x0a"
"#else\x0a"
"    puts( \x22 NOTEST fclose() test driver is PDCLib-specific.\x22 );\x0a"
"#endif\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"", 3081 ); }