#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio_fputs_c( 
"/* fputs( const char *, FILE * )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"#include <stdbool.h>\x0a"
"#include <string.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"#include \x22_PDCLIB/io.h\x22\x0a"
"\x0a"
"int fputs_unlocked( const char * _PDCLIB_restrict s, \x0a"
"                    FILE * _PDCLIB_restrict stream )\x0a"
"{\x0a"
"    if ( _PDCLIB_prepwrite( stream ) == EOF )\x0a"
"    {\x0a"
"        return EOF;\x0a"
"    }\x0a"
"\x0a"
"    if ( stream->status \x26 _IONBF )\x0a"
"    {\x0a"
"        size_t justWrote;\x0a"
"        size_t slen = strlen(s);\x0a"
"\x0a"
"        bool res = stream->ops->write( stream->handle, s, slen, \x26justWrote );\x0a"
"        stream->pos.offset += slen;\x0a"
"\x0a"
"        if (\x21res)\x0a"
"        {\x0a"
"            stream->status \x7c= _PDCLIB_ERRORFLAG;\x0a"
"            return EOF;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        while ( *s \x21= '\x5c""0' )\x0a"
"        {\x0a"
"            /* Unbuffered and line buffered streams get flushed when fputs() does\x0a"
"            write the terminating end-of-line. All streams get flushed if the\x0a"
"            buffer runs full.\x0a"
"            */\x0a"
"            stream->buffer\x5b stream->bufidx++ \x5d = *s;\x0a"
"            if ( ( stream->bufidx == stream->bufsize ) \x7c\x7c\x0a"
"                ( ( stream->status \x26 _IOLBF ) \x26\x26 *s == '\x5cn' )\x0a"
"            )\x0a"
"            {\x0a"
"                if ( _PDCLIB_flushbuffer( stream ) == EOF )\x0a"
"                {\x0a"
"                    return EOF;\x0a"
"                }\x0a"
"            }\x0a"
"            ++s;\x0a"
"        }\x0a"
"    }\x0a"
"    if ( stream->status \x26 _IONBF )\x0a"
"    {\x0a"
"        if ( _PDCLIB_flushbuffer( stream ) == EOF )\x0a"
"        {\x0a"
"            return EOF;\x0a"
"        }\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int fputs( const char * _PDCLIB_restrict s,\x0a"
"           FILE * _PDCLIB_restrict stream )\x0a"
"{\x0a"
"    _PDCLIB_flockfile( stream );\x0a"
"    int r = fputs_unlocked( s, stream );\x0a"
"    _PDCLIB_funlockfile( stream );\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    char const * const message = \x22SUCCESS testing fputs()\x22;\x0a"
"    FILE * fh;\x0a"
"    TESTCASE( ( fh = tmpfile() ) \x21= NULL );\x0a"
"    TESTCASE( fputs( message, fh ) >= 0 );\x0a"
"    rewind( fh );\x0a"
"    for ( size_t i = 0; i < 23; ++i )\x0a"
"    {\x0a"
"        TESTCASE( fgetc( fh ) == message\x5bi\x5d );\x0a"
"    }\x0a"
"    TESTCASE( fclose( fh ) == 0 );\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"", 2219 ); }