#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio_freopen_c( 
"/* freopen( const char *, const char *, FILE * )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"#include \x22_PDCLIB/io.h\x22\x0a"
"#include \x22_PDCLIB/glue.h\x22\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"\x0a"
"FILE * freopen( \x0a"
"    const char * _PDCLIB_restrict filename, \x0a"
"    const char * _PDCLIB_restrict mode, \x0a"
"    FILE * _PDCLIB_restrict stream \x0a"
")\x0a"
"{\x0a"
"    _PDCLIB_flockfile( stream );\x0a"
"\x0a"
"    unsigned int status = stream->status \x26 \x0a"
"        ( _IONBF \x7c _IOLBF \x7c _IOFBF \x7c _PDCLIB_FREEBUFFER \x0a"
"        \x7c _PDCLIB_DELONCLOSE \x7c _PDCLIB_STATIC );\x0a"
"\x0a"
"    /* TODO\x3a This function can change wide orientation of a stream */\x0a"
"    if ( stream->status \x26 _PDCLIB_FWRITE )\x0a"
"    {\x0a"
"        _PDCLIB_flushbuffer( stream );\x0a"
"    }\x0a"
"    if ( ( filename == NULL ) \x26\x26 ( stream->filename == NULL ) )\x0a"
"    {\x0a"
"        /* TODO\x3a Special handling for mode changes on std-streams */\x0a"
"        _PDCLIB_funlockfile( stream );\x0a"
"        return NULL;\x0a"
"    }\x0a"
"    stream->ops->close(stream->handle);\x0a"
"    \x0a"
"    /* TODO\x3a It is not nice to do this on a stream we just closed.\x0a"
"       It does not matter with the current implementation of clearerr(),\x0a"
"       but it might start to matter if someone replaced that implementation.\x0a"
"    */\x0a"
"    clearerr_unlocked( stream );\x0a"
"    /* The new filename might not fit the old buffer */\x0a"
"    if ( filename == NULL )\x0a"
"    {\x0a"
"        /* Use previous filename */\x0a"
"        filename = stream->filename;\x0a"
"    }\x0a"
"    else if ( ( stream->filename \x21= NULL ) \x26\x26 ( strlen( stream->filename ) >= strlen( filename ) ) )\x0a"
"    {\x0a"
"        /* Copy new filename into existing buffer */\x0a"
"        strcpy( stream->filename, filename );\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        /* Allocate new buffer */\x0a"
"        if ( ( stream->filename = (char *)malloc( strlen( filename ) + 1 ) ) == NULL )\x0a"
"        {\x0a"
"            _PDCLIB_funlockfile( stream );\x0a"
"            return NULL;\x0a"
"        }\x0a"
"        strcpy( stream->filename, filename );\x0a"
"    }\x0a"
"    if ( ( mode == NULL ) \x7c\x7c ( filename\x5b""0\x5d == '\x5c""0' ) )\x0a"
"    {\x0a"
"        _PDCLIB_funlockfile( stream );\x0a"
"        return NULL;\x0a"
"    }\x0a"
"    if ( ( stream->status = _PDCLIB_filemode( mode ) ) == 0 )\x0a"
"    {\x0a"
"        _PDCLIB_funlockfile( stream );\x0a"
"        return NULL;\x0a"
"    }\x0a"
"    /* Re-add the flags we saved above */\x0a"
"    stream->status \x7c= status;\x0a"
"    stream->bufidx = 0;\x0a"
"    stream->bufend = 0;\x0a"
"    stream->ungetidx = 0;\x0a"
"    /* TODO\x3a Setting mbstate */\x0a"
"    if ( \x21 _PDCLIB_open( \x26stream->handle, \x26stream->ops, filename, \x0a"
"                         stream->status ) )\x0a"
"    {\x0a"
"        _PDCLIB_funlockfile( stream );\x0a"
"        return NULL;\x0a"
"    }\x0a"
"    _PDCLIB_funlockfile( stream );\x0a"
"    return stream;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    FILE * fin;\x0a"
"    FILE * fout;\x0a"
"    TESTCASE( ( fin = fopen( testfile1, \x22wb+\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE( fputc( 'x', fin ) == 'x' );\x0a"
"    TESTCASE( fclose( fin ) == 0 );\x0a"
"    TESTCASE( ( fin = freopen( testfile1, \x22rb\x22, stdin ) ) \x21= NULL );\x0a"
"    TESTCASE( getchar() == 'x' );\x0a"
"\x0a"
"    TESTCASE( ( fout = freopen( testfile2, \x22wb+\x22, stdout ) ) \x21= NULL );\x0a"
"    TESTCASE( putchar( 'x' ) == 'x' );\x0a"
"    rewind( fout );\x0a"
"    TESTCASE( fgetc( fout ) == 'x' );\x0a"
"\x0a"
"    TESTCASE( fclose( fin ) == 0 );\x0a"
"    TESTCASE( fclose( fout ) == 0 );\x0a"
"    TESTCASE( remove( testfile1 ) == 0 );\x0a"
"    TESTCASE( remove( testfile2 ) == 0 );\x0a"
"\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"", 3355 ); }