#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio_fseek_c( 
"/* fseek( FILE *, long, int )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"#include \x22_PDCLIB/io.h\x22\x0a"
"\x0a"
"int _PDCLIB_fseek_unlocked( FILE * stream, long loffset, int whence )\x0a"
"{\x0a"
"    _PDCLIB_int64_t offset = loffset;\x0a"
"    if ( stream->status \x26 _PDCLIB_FWRITE )\x0a"
"    {\x0a"
"        if ( _PDCLIB_flushbuffer( stream ) == EOF )\x0a"
"        {\x0a"
"            return EOF;\x0a"
"        }\x0a"
"    }\x0a"
"    stream->status \x26= \x7e _PDCLIB_EOFFLAG;\x0a"
"    if ( stream->status \x26 _PDCLIB_FRW )\x0a"
"    {\x0a"
"        stream->status \x26= \x7e ( _PDCLIB_FREAD \x7c _PDCLIB_FWRITE );\x0a"
"    }\x0a"
"\x0a"
"    if ( whence == SEEK_CUR )\x0a"
"    {\x0a"
"        whence  = SEEK_SET;\x0a"
"        offset += _PDCLIB_ftell64_unlocked( stream );\x0a"
"    }\x0a"
"\x0a"
"    return ( _PDCLIB_seek( stream, offset, whence ) \x21= EOF ) \x3f 0 \x3a EOF;\x0a"
"}\x0a"
"\x0a"
"int fseek( FILE * stream, long loffset, int whence )\x0a"
"{\x0a"
"    _PDCLIB_flockfile( stream );\x0a"
"    int r = _PDCLIB_fseek_unlocked( stream, loffset, whence );\x0a"
"    _PDCLIB_funlockfile( stream );\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"int fseeko( FILE * stream, long loffset, int whence )\x0a"
"{\x0a"
"    return fseek( stream, loffset, whence );\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"#include <string.h>\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    FILE * fh;\x0a"
"    TESTCASE( ( fh = tmpfile() ) \x21= NULL );\x0a"
"    TESTCASE( fwrite( teststring, 1, strlen( teststring ), fh ) == strlen( teststring ) );\x0a"
"    /* General functionality */\x0a"
"    TESTCASE( fseek( fh, -1, SEEK_END ) == 0  );\x0a"
"    TESTCASE( (size_t)ftell( fh ) == strlen( teststring ) - 1 );\x0a"
"    TESTCASE( fseek( fh, 0, SEEK_END ) == 0 );\x0a"
"    TESTCASE( (size_t)ftell( fh ) == strlen( teststring ) );\x0a"
"    TESTCASE( fseek( fh, 0, SEEK_SET ) == 0 );\x0a"
"    TESTCASE( ftell( fh ) == 0 );\x0a"
"    TESTCASE( fseek( fh, 5, SEEK_CUR ) == 0 );\x0a"
"    TESTCASE( ftell( fh ) == 5 );\x0a"
"    TESTCASE( fseek( fh, -3, SEEK_CUR ) == 0 );\x0a"
"    TESTCASE( ftell( fh ) == 2 );\x0a"
"    /* Checking behaviour around EOF */\x0a"
"    TESTCASE( fseek( fh, 0, SEEK_END ) == 0 );\x0a"
"    TESTCASE( \x21 feof( fh ) );\x0a"
"    TESTCASE( fgetc( fh ) == EOF );\x0a"
"    TESTCASE( feof( fh ) );\x0a"
"    TESTCASE( fseek( fh, 0, SEEK_END ) == 0 );\x0a"
"    TESTCASE( \x21 feof( fh ) );\x0a"
"    /* Checking undo of ungetc() */\x0a"
"    TESTCASE( fseek( fh, 0, SEEK_SET ) == 0 );\x0a"
"    TESTCASE( fgetc( fh ) == teststring\x5b""0\x5d );\x0a"
"    TESTCASE( fgetc( fh ) == teststring\x5b""1\x5d );\x0a"
"    TESTCASE( fgetc( fh ) == teststring\x5b""2\x5d );\x0a"
"    TESTCASE( ftell( fh ) == 3 );\x0a"
"    TESTCASE( ungetc( teststring\x5b""2\x5d, fh ) == teststring\x5b""2\x5d );\x0a"
"    TESTCASE( ftell( fh ) == 2 );\x0a"
"    TESTCASE( fgetc( fh ) == teststring\x5b""2\x5d );\x0a"
"    TESTCASE( ftell( fh ) == 3 );\x0a"
"    TESTCASE( ungetc( 'x', fh ) == 'x' );\x0a"
"    TESTCASE( ftell( fh ) == 2 );\x0a"
"    TESTCASE( fgetc( fh ) == 'x' );\x0a"
"    TESTCASE( ungetc( 'x', fh ) == 'x' );\x0a"
"    TESTCASE( ftell( fh ) == 2 );\x0a"
"    TESTCASE( fseek( fh, 2, SEEK_SET ) == 0 );\x0a"
"    TESTCASE( fgetc( fh ) == teststring\x5b""2\x5d );\x0a"
"    /* PDCLIB-7\x3a Check that we handle the underlying file descriptor correctly\x0a"
"     *           in the SEEK_CUR case */\x0a"
"    TESTCASE( fseek( fh, 10, SEEK_SET ) == 0 );\x0a"
"    TESTCASE( ftell( fh ) == 10l );\x0a"
"    TESTCASE( fseek( fh, 0, SEEK_CUR ) == 0 );\x0a"
"    TESTCASE( ftell( fh ) == 10l );\x0a"
"    TESTCASE( fseek( fh, 2, SEEK_CUR ) == 0 );\x0a"
"    TESTCASE( ftell( fh ) == 12l );\x0a"
"    TESTCASE( fseek( fh, -1, SEEK_CUR ) == 0 );\x0a"
"    TESTCASE( ftell( fh ) == 11l );\x0a"
"    /* Checking error handling */\x0a"
"    TESTCASE( fseek( fh, -5, SEEK_SET ) == -1 );\x0a"
"    TESTCASE( fseek( fh, 0, SEEK_END ) == 0 );\x0a"
"    TESTCASE( fclose( fh ) == 0 );\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"", 3515 ); }