#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio_rename_c( 
"/* rename( const char *, const char * )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"#if \x21""defined(__divine__) // rename is syscall in DIVINE (as well as Linux)\x0a"
"#include \x22_PDCLIB/glue.h\x22\x0a"
"#include <threads.h>\x0a"
"\x0a"
"#include <string.h>\x0a"
"\x0a"
"extern _PDCLIB_file_t * _PDCLIB_filelist;\x0a"
"extern mtx_t _PDCLIB_filelist_lock;\x0a"
"\x0a"
"int rename( const char * old, const char * new )\x0a"
"{\x0a"
"    mtx_lock( \x26_PDCLIB_filelist_lock );\x0a"
"    FILE * current = _PDCLIB_filelist;\x0a"
"    while ( current \x21= NULL )\x0a"
"    {\x0a"
"        if ( ( current->filename \x21= NULL ) \x26\x26 ( strcmp( current->filename, old ) == 0 ) )\x0a"
"        {\x0a"
"            // File of that name currently open. Do not rename.\x0a"
"            mtx_unlock( \x26_PDCLIB_filelist_lock );\x0a"
"            return EOF;\x0a"
"        }\x0a"
"        current = current->next;\x0a"
"    }\x0a"
"    mtx_unlock( \x26_PDCLIB_filelist_lock );\x0a"
"    return _PDCLIB_rename( old, new );\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    FILE * file;\x0a"
"    remove( testfile1 );\x0a"
"    remove( testfile2 );\x0a"
"    /* make sure that neither file exists */\x0a"
"    TESTCASE( fopen( testfile1, \x22r\x22 ) == NULL );\x0a"
"    TESTCASE( fopen( testfile2, \x22r\x22 ) == NULL );\x0a"
"    /* rename file 1 to file 2 - expected to fail */\x0a"
"    TESTCASE( rename( testfile1, testfile2 ) \x21= 0 );\x0a"
"    /* create file 1 */\x0a"
"    TESTCASE( ( file = fopen( testfile1, \x22w\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE( fputs( \x22x\x22, file ) \x21= EOF );\x0a"
"    TESTCASE( fclose( file ) == 0 );\x0a"
"    /* check that file 1 exists */\x0a"
"    TESTCASE( ( file = fopen( testfile1, \x22r\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE( fclose( file ) == 0 );\x0a"
"    /* rename file 1 to file 2 */\x0a"
"    TESTCASE( rename( testfile1, testfile2 ) == 0 );\x0a"
"    /* check that file 2 exists, file 1 does not */\x0a"
"    TESTCASE( fopen( testfile1, \x22r\x22 ) == NULL );\x0a"
"    TESTCASE( ( file = fopen( testfile2, \x22r\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE( fclose( file ) == 0 );\x0a"
"    /* create another file 1 */\x0a"
"    TESTCASE( ( file = fopen( testfile1, \x22w\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE( fputs( \x22x\x22, file ) \x21= EOF );\x0a"
"    TESTCASE( fclose( file ) == 0 );\x0a"
"    /* check that file 1 exists */\x0a"
"    TESTCASE( ( file = fopen( testfile1, \x22r\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE( fclose( file ) == 0 );\x0a"
"    /* rename file 1 to file 2 - expected to fail, see comment in\x0a"
"       _PDCLIB_rename() itself.\x0a"
"    */\x0a"
"#if \x21""defined(__divine__)\x0a"
"    /* NOREG as glibc overwrites existing destination file. */\x0a"
"    TESTCASE_NOREG( rename( testfile1, testfile2 ) \x21= 0 );\x0a"
"    /* remove both files */\x0a"
"    TESTCASE( remove( testfile1 ) == 0 );\x0a"
"    TESTCASE( remove( testfile2 ) == 0 );\x0a"
"#else\x0a"
"    TESTCASE_NOREG( rename( testfile1, testfile2 ) == 0 );\x0a"
"    /* remove both files */\x0a"
"    TESTCASE( remove( testfile1 ) \x21= 0 );\x0a"
"    TESTCASE( remove( testfile2 ) == 0 );\x0a"
"#endif\x0a"
"    /* check that they're gone */\x0a"
"    TESTCASE( fopen( testfile1, \x22r\x22 ) == NULL );\x0a"
"    TESTCASE( fopen( testfile2, \x22r\x22 ) == NULL );\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"", 2986 ); }