#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio_setvbuf_c( 
"/* setvbuf( FILE *, char *, int, size_t )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <limits.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"#include \x22_PDCLIB/io.h\x22\x0a"
"\x0a"
"int setvbuf( FILE * _PDCLIB_restrict stream, char * _PDCLIB_restrict buf, int mode, size_t size )\x0a"
"{\x0a"
"    _PDCLIB_flockfile( stream );\x0a"
"    switch ( mode )\x0a"
"    {\x0a"
"        case _IONBF\x3a\x0a"
"            /* When unbuffered I/O is requested, we keep the buffer anyway, as\x0a"
"               we don't want to e.g. flush the stream for every character of a\x0a"
"               stream being printed.\x0a"
"            */\x0a"
"            break;\x0a"
"        case _IOFBF\x3a\x0a"
"        case _IOLBF\x3a\x0a"
"            if ( size > INT_MAX \x7c\x7c size == 0 )\x0a"
"            {\x0a"
"                /* PDCLib only supports buffers up to INT_MAX in size. A size\x0a"
"                   of zero doesn't make sense.\x0a"
"                */\x0a"
"                _PDCLIB_funlockfile( stream );\x0a"
"                return -1;\x0a"
"            }\x0a"
"            if ( buf == NULL )\x0a"
"            {\x0a"
"                /* User requested buffer size, but leaves it to library to\x0a"
"                   allocate the buffer.\x0a"
"                */\x0a"
"                /* If current buffer is big enough for requested size, but not\x0a"
"                   over twice as big (and wasting memory space), we use the\x0a"
"                   current buffer (i.e., do nothing), to save the malloc() / \x0a"
"                   free() overhead.\x0a"
"                */\x0a"
"                if ( ( stream->bufsize < size ) \x7c\x7c ( stream->bufsize > ( size << 1 ) ) )\x0a"
"                {\x0a"
"                    /* Buffer too small, or much too large - allocate. */\x0a"
"                    if ( ( buf = (char *) malloc( size ) ) == NULL )\x0a"
"                    {\x0a"
"                        /* Out of memory error. */\x0a"
"                        _PDCLIB_funlockfile( stream );\x0a"
"                        return -1;\x0a"
"                    }\x0a"
"                    /* This buffer must be free()d on fclose() */\x0a"
"                    stream->status \x7c= _PDCLIB_FREEBUFFER;\x0a"
"                }\x0a"
"            }\x0a"
"            stream->buffer = buf;\x0a"
"            stream->bufsize = size;\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            /* If mode is something else than _IOFBF, _IOLBF or _IONBF -> exit */\x0a"
"            _PDCLIB_funlockfile( stream );\x0a"
"            return -1;\x0a"
"    }\x0a"
"    /* Deleting current buffer mode */\x0a"
"    stream->status \x26= \x7e( _IOFBF \x7c _IOLBF \x7c _IONBF );\x0a"
"    /* Set user-defined mode */\x0a"
"    stream->status \x7c= mode;\x0a"
"    _PDCLIB_funlockfile( stream );\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"#include <errno.h>\x0a"
"#ifndef REGTEST\x0a"
"#include \x22_PDCLIB/io.h\x22\x0a"
"#endif\x0a"
"#define BUFFERSIZE 500\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"#ifndef REGTEST\x0a"
"    char buffer\x5b BUFFERSIZE \x5d;\x0a"
"    FILE * fh;\x0a"
"    /* full buffered, user-supplied buffer */\x0a"
"    TESTCASE( ( fh = tmpfile() ) \x21= NULL );\x0a"
"    TESTCASE( setvbuf( fh, buffer, _IOFBF, BUFFERSIZE ) == 0 );\x0a"
"    TESTCASE( fh->buffer == buffer );\x0a"
"    TESTCASE( fh->bufsize == BUFFERSIZE );\x0a"
"    TESTCASE( ( fh->status \x26 ( _IOFBF \x7c _IONBF \x7c _IOLBF ) ) == _IOFBF );\x0a"
"    TESTCASE( fclose( fh ) == 0 );\x0a"
"    /* line buffered, lib-supplied buffer */\x0a"
"    TESTCASE( ( fh = tmpfile() ) \x21= NULL );\x0a"
"    TESTCASE( setvbuf( fh, NULL, _IOLBF, BUFFERSIZE ) == 0 );\x0a"
"    TESTCASE( fh->buffer \x21= NULL );\x0a"
"    TESTCASE( fh->bufsize == BUFFERSIZE );\x0a"
"    TESTCASE( ( fh->status \x26 ( _IOFBF \x7c _IONBF \x7c _IOLBF ) ) == _IOLBF );\x0a"
"    TESTCASE( fclose( fh ) == 0 );\x0a"
"    /* not buffered, user-supplied buffer */\x0a"
"    TESTCASE( ( fh = tmpfile() ) \x21= NULL );\x0a"
"    TESTCASE( setvbuf( fh, buffer, _IONBF, BUFFERSIZE ) == 0 );\x0a"
"    TESTCASE( ( fh->status \x26 ( _IOFBF \x7c _IONBF \x7c _IOLBF ) ) == _IONBF );\x0a"
"    TESTCASE( fclose( fh ) == 0 );\x0a"
"#else\x0a"
"    puts( \x22 NOTEST setvbuf() test driver is PDCLib-specific.\x22 );\x0a"
"#endif\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"", 3821 ); }