#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdio_tmpfile_c( 
"/* tmpfile( void )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"\x0a"
"#include <inttypes.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"#include \x22_PDCLIB/glue.h\x22\x0a"
"#include <unistd.h>\x0a"
"#ifdef __linux__\x0a"
"/* get O_CLOEXEC without sys/types.h being awful */\x0a"
"#include <asm/fcntl.h>\x0a"
"int open(const char *fname, int flags, ...);\x0a"
"#else\x0a"
"#include <fcntl.h>\x0a"
"#endif\x0a"
"#include <errno.h>\x0a"
"#include <sys/syswrap.h>\x0a"
"\x0a"
"extern const _PDCLIB_fileops_t _PDCLIB_fileops;\x0a"
"\x0a"
"FILE* _PDCLIB_nothrow tmpfile( void )\x0a"
"{\x0a"
"\x0a"
"    /* Good quality random source */\x0a"
"    int urandom = open( \x22/dev/urandom\x22, O_RDONLY \x7c O_CLOEXEC );\x0a"
"\x0a"
"    int fd;\x0a"
"    char filename\x5b L_tmpnam \x5d;\x0a"
"    for ( ;; )\x0a"
"    {\x0a"
"        long long randnum;\x0a"
"        if( urandom == -1 \x7c\x7c __libc_read(urandom, \x26randnum, sizeof randnum ) \x21= sizeof randnum )\x0a"
"            randnum = rand();\x0a"
"\x0a"
"        sprintf( filename, \x22/tmp/\x25llx.tmp\x22, randnum );\x0a"
"        /* Check if file of this name exists. Note that fopen() is a very weak\x0a"
"           check, which does not take e.g. access permissions into account\x0a"
"           (file might exist but not readable). Replace with something more\x0a"
"           appropriate.\x0a"
"        */\x0a"
"        fd = open( filename, O_CREAT \x7c O_EXCL \x7c O_RDWR, 0600 );\x0a"
"        /* if it fails for other reason then existence of the file (such as\x0a"
"           nonexistence of /tmp/) fail immediatelly.\x0a"
"        */\x0a"
"        if ( fd == -1 \x26\x26 errno \x21= EEXIST )\x0a"
"        {\x0a"
"            if ( urandom \x21= -1 )\x0a"
"                __libc_close( urandom );\x0a"
"            return NULL;\x0a"
"        }\x0a"
"        if ( fd \x21= -1 )\x0a"
"        {\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    if ( urandom \x21= -1 )\x0a"
"        __libc_close( urandom );\x0a"
"\x0a"
"    FILE* rc = _PDCLIB_fvopen(((_PDCLIB_fd_t){ .sval = fd}), \x26_PDCLIB_fileops,\x0a"
"                                _PDCLIB_FWRITE \x7c _PDCLIB_FRW \x7c\x0a"
"                                _PDCLIB_DELONCLOSE, filename);\x0a"
"    if( rc == NULL )\x0a"
"    {\x0a"
"        __libc_close( fd );\x0a"
"        return NULL;\x0a"
"    }\x0a"
"\x0a"
"    return rc;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"#include <string.h>\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    FILE * fh;\x0a"
"#ifndef REGTEST\x0a"
"    char filename\x5b L_tmpnam \x5d;\x0a"
"    FILE * fhtest;\x0a"
"#endif\x0a"
"    TESTCASE( ( fh = tmpfile() ) \x21= NULL );\x0a"
"    TESTCASE( fputc( 'x', fh ) == 'x' );\x0a"
"    /* Checking that file is actually there */\x0a"
"    TESTCASE_NOREG( strcpy( filename, fh->filename ) == filename );\x0a"
"    TESTCASE_NOREG( ( fhtest = fopen( filename, \x22r\x22 ) ) \x21= NULL );\x0a"
"    TESTCASE_NOREG( fclose( fhtest ) == 0 );\x0a"
"    /* Closing tmpfile */\x0a"
"    TESTCASE( fclose( fh ) == 0 );\x0a"
"    /* Checking that file was deleted */\x0a"
"    TESTCASE_NOREG( fopen( filename, \x22r\x22 ) == NULL );\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"", 2726 ); }