#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdlib_atexit_c( 
"/* atexit( void (*)( void ) )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdlib.h>\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"\x0a"
"#ifndef __divine__\x0a"
"\x0a"
"extern void (*_PDCLIB_exitstack\x5b\x5d)( void );\x0a"
"extern size_t _PDCLIB_exitptr;\x0a"
"\x0a"
"int atexit( void (*func)( void ) )\x0a"
"{\x0a"
"    if ( _PDCLIB_exitptr == 0 )\x0a"
"    {\x0a"
"        return -1;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        _PDCLIB_exitstack\x5b --_PDCLIB_exitptr \x5d = func;\x0a"
"        return 0;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"#include <sys/divm.h>\x0a"
"\x0a"
"struct AtexitEntry {\x0a"
"    void ( *func )( void * );\x0a"
"    void *arg;\x0a"
"    void *dso_handle;\x0a"
"};\x0a"
"\x0a"
"static struct AtexitEntry *atexit_entries;\x0a"
"\x0a"
"static void call(void *p) {\x0a"
"    ((void (*)(void))(uintptr_t)p)();\x0a"
"}\x0a"
"\x0a"
"int __cxa_atexit( void ( *func ) ( void * ), void *arg, void *dso_handle ) {\x0a"
"    typedef struct AtexitEntry Ent;\x0a"
"    if ( \x21""atexit_entries )\x0a"
"        atexit_entries = ( Ent* ) __vm_obj_make( sizeof( Ent ), _VM_PT_Heap );\x0a"
"    else\x0a"
"        __vm_obj_resize( atexit_entries, __vm_obj_size( atexit_entries ) + sizeof( Ent ) );\x0a"
"\x0a"
"    size_t idx = __vm_obj_size( atexit_entries ) / sizeof( Ent ) - 1;\x0a"
"    Ent tmp = { func, arg, dso_handle };\x0a"
"    atexit_entries\x5b idx \x5d = tmp;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int __cxa_finalize( void *dso_handle )\x0a"
"{\x0a"
"    typedef struct AtexitEntry Ent;\x0a"
"    size_t i = atexit_entries \x3f __vm_obj_size( atexit_entries ) / sizeof( Ent ) \x3a 0;\x0a"
"    for ( ; i \x21= 0; i-- )\x0a"
"    {\x0a"
"        Ent *entry = \x26""atexit_entries\x5b i - 1 \x5d;\x0a"
"        if ( entry->func \x26\x26 ( \x21""dso_handle \x7c\x7c entry->dso_handle == dso_handle ) )\x0a"
"        {\x0a"
"            ( *entry->func )( entry->arg );\x0a"
"            entry->func = NULL;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    if ( atexit_entries )\x0a"
"        __vm_obj_free( atexit_entries );\x0a"
"\x0a"
"    // ToDo\x3a Remove invalid entries\x3f\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int atexit( void ( *func )( void ) ) {\x0a"
"    return __cxa_atexit( call, ( void * )( uintptr_t )func, 0);\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"#include <assert.h>\x0a"
"\x0a"
"static int flags\x5b 32 \x5d;\x0a"
"\x0a"
"static void counthandler( void )\x0a"
"{\x0a"
"    static int count = 0;\x0a"
"    flags\x5b count \x5d = count;\x0a"
"    ++count;\x0a"
"}\x0a"
"\x0a"
"static void checkhandler( void )\x0a"
"{\x0a"
"    for ( int i = 0; i < 31; ++i )\x0a"
"    {\x0a"
"        assert( flags\x5b i \x5d == i );\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    TESTCASE( atexit( \x26""checkhandler ) == 0 );\x0a"
"    for ( int i = 0; i < 31; ++i )\x0a"
"    {\x0a"
"        TESTCASE( atexit( \x26""counthandler ) == 0 );\x0a"
"    }\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"", 2412 ); }