#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdlib_bsearch_c( 
"/* bsearch( const void *, const void *, size_t, size_t, int(*)( const void *, const void * ) )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"\x0a"
"void * bsearch( const void * key, const void * base, size_t nmemb, size_t size, int (*compar)( const void *, const void * ) )\x0a"
"{\x0a"
"    const void * pivot;\x0a"
"    int rc;\x0a"
"    size_t corr;\x0a"
"    while ( nmemb )\x0a"
"    {\x0a"
"        /* algorithm needs -1 correction if remaining elements are an even number. */\x0a"
"        corr = nmemb \x25 2;\x0a"
"        nmemb /= 2;\x0a"
"        pivot = (const char *)base + (nmemb * size);\x0a"
"        rc = compar( key, pivot );\x0a"
"        if ( rc > 0 )\x0a"
"        {\x0a"
"            base = (const char *)pivot + size;\x0a"
"            /* applying correction */\x0a"
"            nmemb -= ( 1 - corr );\x0a"
"        }\x0a"
"        else if ( rc == 0 )\x0a"
"        {\x0a"
"            return (void *)pivot;\x0a"
"        }\x0a"
"    }\x0a"
"    return NULL;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"static int compare( const void * left, const void * right )\x0a"
"{\x0a"
"    return *( (unsigned char *)left ) - *( (unsigned char *)right );\x0a"
"}\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    TESTCASE( bsearch( \x22""e\x22, abcde, 4, 1, compare ) == NULL );\x0a"
"    TESTCASE( bsearch( \x22""e\x22, abcde, 5, 1, compare ) == \x26""abcde\x5b""4\x5d );\x0a"
"    TESTCASE( bsearch( \x22""a\x22, abcde + 1, 4, 1, compare ) == NULL );\x0a"
"    TESTCASE( bsearch( \x22""0\x22, abcde, 1, 1, compare ) == NULL );\x0a"
"    TESTCASE( bsearch( \x22""a\x22, abcde, 1, 1, compare ) == \x26""abcde\x5b""0\x5d );\x0a"
"    TESTCASE( bsearch( \x22""a\x22, abcde, 0, 1, compare ) == NULL );\x0a"
"    TESTCASE( bsearch( \x22""e\x22, abcde, 3, 2, compare ) == \x26""abcde\x5b""4\x5d );\x0a"
"    TESTCASE( bsearch( \x22""b\x22, abcde, 3, 2, compare ) == NULL );\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"", 1719 ); }