#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdlib_qsort_c( 
"/* qsort( void *, size_t, size_t, int(*)( const void *, const void * ) )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"\x0a"
"/* This implementation is taken from Paul Edward's PDPCLIB.\x0a"
"\x0a"
"   Original code is credited to Raymond Gardner, Englewood CO.\x0a"
"   Minor mods are credited to Paul Edwards.\x0a"
"   Some reformatting and simplification done by Martin Baute.\x0a"
"   All code is still Public Domain.\x0a"
"*/\x0a"
"\x0a"
"/* Wrapper for _PDCLIB_memswp protects against multiple argument evaluation. */\x0a"
"static inline void memswp( char * i, char * j, size_t size )\x0a"
"{\x0a"
"    _PDCLIB_memswp( i, j, size );\x0a"
"}\x0a"
"\x0a"
"/* For small sets, insertion sort is faster than quicksort.\x0a"
"   T is the threshold below which insertion sort will be used.\x0a"
"   Must be 3 or larger.\x0a"
"*/\x0a"
"#define T 7\x0a"
"\x0a"
"/* Macros for handling the QSort stack */\x0a"
"#define PREPARE_STACK char * stack\x5bSTACKSIZE\x5d; char * * stackptr = stack\x0a"
"#define PUSH( base, limit ) stackptr\x5b""0\x5d = base; stackptr\x5b""1\x5d = limit; stackptr += 2\x0a"
"#define POP( base, limit ) stackptr -= 2; base = stackptr\x5b""0\x5d; limit = stackptr\x5b""1\x5d\x0a"
"/* TODO\x3a Stack usage is log2( nmemb ) (minus what T shaves off the worst case).\x0a"
"         Worst-case nmemb is platform dependent and should probably be \x0a"
"         configured through _PDCLIB_config.h.\x0a"
"*/\x0a"
"#define STACKSIZE 64\x0a"
"\x0a"
"void qsort( void * base, size_t nmemb, size_t size, int (*compar)( const void *, const void * ) )\x0a"
"{\x0a"
"    char * i;\x0a"
"    char * j;\x0a"
"    _PDCLIB_size_t thresh = T * size;\x0a"
"    char * base_          = (char *)base;\x0a"
"    char * limit          = base_ + nmemb * size;\x0a"
"    PREPARE_STACK;\x0a"
"\x0a"
"    for ( ;; )\x0a"
"    {\x0a"
"        if ( (size_t)( limit - base_ ) > thresh ) /* QSort for more than T elements. */\x0a"
"        {\x0a"
"            /* We work from second to last - first will be pivot element. */\x0a"
"            i = base_ + size;\x0a"
"            j = limit - size;\x0a"
"            /* We swap first with middle element, then sort that with second\x0a"
"               and last element so that eventually first element is the median\x0a"
"               of the three - avoiding pathological pivots.\x0a"
"               TODO\x3a Instead of middle element, chose one randomly.\x0a"
"            */\x0a"
"            memswp( ( ( ( (size_t)( limit - base_ ) ) / size ) / 2 ) * size + base_, base_, size );\x0a"
"            if ( compar( i, j ) > 0 ) memswp( i, j, size );\x0a"
"            if ( compar( base_, j ) > 0 ) memswp( base_, j, size );\x0a"
"            if ( compar( i, base_ ) > 0 ) memswp( i, base_, size );\x0a"
"            /* Now we have the median for pivot element, entering main Quicksort. */\x0a"
"            for ( ;; )\x0a"
"            {\x0a"
"                do\x0a"
"                {\x0a"
"                    /* move i right until *i >= pivot */\x0a"
"                    i += size;\x0a"
"                } while ( compar( i, base_ ) < 0 );\x0a"
"                do\x0a"
"                {\x0a"
"                    /* move j left until *j <= pivot */\x0a"
"                    j -= size;\x0a"
"                } while ( compar( j, base_ ) > 0 );\x0a"
"                if ( i > j )\x0a"
"                {\x0a"
"                    /* break loop if pointers crossed */\x0a"
"                    break;\x0a"
"                }\x0a"
"                /* else swap elements, keep scanning */\x0a"
"                memswp( i, j, size );\x0a"
"            }\x0a"
"            /* move pivot into correct place */\x0a"
"            memswp( base_, j, size );\x0a"
"            /* larger subfile base / limit to stack, sort smaller */\x0a"
"            if ( j - base_ > limit - i )\x0a"
"            {\x0a"
"                /* left is larger */\x0a"
"                PUSH( base_, j );\x0a"
"                base_ = i;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                /* right is larger */\x0a"
"                PUSH( i, limit );\x0a"
"                limit = j;\x0a"
"            }\x0a"
"        }\x0a"
"        else /* insertion sort for less than T elements              */\x0a"
"        {\x0a"
"            for ( j = base_, i = j + size; i < limit; j = i, i += size )\x0a"
"            {\x0a"
"                for ( ; compar( j, j + size ) > 0; j -= size )\x0a"
"                {\x0a"
"                    memswp( j, j + size, size );\x0a"
"                    if ( j == base_ )\x0a"
"                    {\x0a"
"                        break;\x0a"
"                    }\x0a"
"                }\x0a"
"            }\x0a"
"            if ( stackptr \x21= stack )           /* if any entries on stack  */\x0a"
"            {\x0a"
"                POP( base_, limit );\x0a"
"            }\x0a"
"            else                       /* else stack empty, done   */\x0a"
"            {\x0a"
"                break;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"#include <string.h>\x0a"
"#include <limits.h>\x0a"
"\x0a"
"static int compare( const void * left, const void * right )\x0a"
"{\x0a"
"    return *( (unsigned char *)left ) - *( (unsigned char *)right );\x0a"
"}\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    char presort\x5b\x5d = { \x22shreicnyjqpvozxmbt\x22 };\x0a"
"    char sorted1\x5b\x5d = { \x22""bcehijmnopqrstvxyz\x22 };\x0a"
"    char sorted2\x5b\x5d = { \x22""bticjqnyozpvreshxm\x22 };\x0a"
"    char s\x5b""19\x5d;\x0a"
"    strcpy( s, presort );\x0a"
"    qsort( s, 18, 1, compare );\x0a"
"    TESTCASE( strcmp( s, sorted1 ) == 0 );\x0a"
"    strcpy( s, presort );\x0a"
"    qsort( s, 9, 2, compare );\x0a"
"    TESTCASE( strcmp( s, sorted2 ) == 0 );\x0a"
"    strcpy( s, presort );\x0a"
"    qsort( s, 1, 1, compare );\x0a"
"    TESTCASE( strcmp( s, presort ) == 0 );\x0a"
"#if defined(REGTEST) \x26\x26 (__BSD_VISIBLE \x7c\x7c __APPLE__)\x0a"
"    puts( \x22qsort.c\x3a Skipping test #4 for BSD as it goes into endless loop here.\x22 );\x0a"
"#else\x0a"
"    qsort( s, 100, 0, compare );\x0a"
"    TESTCASE( strcmp( s, presort ) == 0 );\x0a"
"#endif\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"", 5389 ); }