#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdlib_setenv_c( 
"/*\x09\x24OpenBSD\x3a setenv.c,v 1.19 2016/09/21 04\x3a""38\x3a""56 guenther Exp \x24 */\x0a"
"/*\x0a"
" * Copyright (c) 1987 Regents of the University of California.\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" * 3. Neither the name of the University nor the names of its contributors\x0a"
" *    may be used to endorse or promote products derived from this software\x0a"
" *    without specific prior written permission.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#include <errno.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"\x0a"
"static char **lastenv;\x09\x09\x09\x09/* last value of environ */\x0a"
"extern char **environ;\x0a"
"\x0a"
"char *__findenv( const char *, int, int * );\x0a"
"\x0a"
"/*\x0a"
" * putenv --\x0a"
" *\x09""Add a name=value string directly to the environmental, replacing\x0a"
" *\x09""any current value.\x0a"
" */\x0a"
"int\x0a"
"putenv(char *str)\x0a"
"{\x0a"
"\x09""char **P, *cp;\x0a"
"\x09size_t cnt = 0;\x0a"
"\x09int offset = 0;\x0a"
"\x0a"
"\x09""for (cp = str; *cp \x26\x26 *cp \x21= '='; ++cp)\x0a"
"\x09\x09;\x0a"
"\x09if (*cp \x21= '=') {\x0a"
"\x09\x09""errno = EINVAL;\x0a"
"\x09\x09return (-1);\x09\x09\x09/* missing \x60=' in string */\x0a"
"\x09}\x0a"
"\x0a"
"\x09if (__findenv(str, (int)(cp - str), \x26offset) \x21= NULL) {\x0a"
"\x09\x09""environ\x5boffset++\x5d = str;\x0a"
"\x09\x09/* could be set multiple times */\x0a"
"\x09\x09while (__findenv(str, (int)(cp - str), \x26offset)) {\x0a"
"\x09\x09\x09""for (P = \x26""environ\x5boffset\x5d;; ++P)\x0a"
"\x09\x09\x09\x09if (\x21(*P = *(P + 1)))\x0a"
"\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09}\x0a"
"\x09\x09return (0);\x0a"
"\x09}\x0a"
"\x0a"
"\x09/* create new slot for string */\x0a"
"\x09if (environ \x21= NULL) {\x0a"
"\x09\x09""for (P = environ; *P \x21= NULL; P++)\x0a"
"\x09\x09\x09;\x0a"
"\x09\x09""cnt = P - environ;\x0a"
"\x09}\x0a"
"\x09P = reallocarray(lastenv, cnt + 2, sizeof(char *));\x0a"
"\x09if (\x21P)\x0a"
"\x09\x09return (-1);\x0a"
"\x09if (lastenv \x21= environ \x26\x26 environ \x21= NULL)\x0a"
"\x09\x09memcpy(P, environ, cnt * sizeof(char *));\x0a"
"\x09lastenv = environ = P;\x0a"
"\x09""environ\x5b""cnt\x5d = str;\x0a"
"\x09""environ\x5b""cnt + 1\x5d = NULL;\x0a"
"\x09return (0);\x0a"
"}\x0a"
"//DEF_WEAK(putenv);\x0a"
"\x0a"
"/*\x0a"
" * setenv --\x0a"
" *\x09Set the value of the environmental variable \x22name\x22 to be\x0a"
" *\x09\x22value\x22.  If rewrite is set, replace any current value.\x0a"
" */\x0a"
"int\x0a"
"setenv(const char *name, const char *value, int rewrite)\x0a"
"{\x0a"
"\x09""char *C, **P;\x0a"
"\x09""const char *np;\x0a"
"\x09int l_value, offset = 0;\x0a"
"\x0a"
"\x09if (\x21name \x7c\x7c \x21*name) {\x0a"
"\x09\x09""errno = EINVAL;\x0a"
"\x09\x09return (-1);\x0a"
"\x09}\x0a"
"\x09""for (np = name; *np \x26\x26 *np \x21= '='; ++np)\x0a"
"\x09\x09;\x0a"
"\x09if (*np) {\x0a"
"\x09\x09""errno = EINVAL;\x0a"
"\x09\x09return (-1);\x09\x09\x09/* has \x60=' in name */\x0a"
"\x09}\x0a"
"\x0a"
"\x09l_value = strlen(value);\x0a"
"\x09if ((C = __findenv(name, (int)(np - name), \x26offset)) \x21= NULL) {\x0a"
"\x09\x09int tmpoff = offset + 1;\x0a"
"\x09\x09if (\x21rewrite)\x0a"
"\x09\x09\x09return (0);\x0a"
"#if 0 /* XXX - existing entry may not be writable */\x0a"
"\x09\x09if (strlen(C) >= l_value) {\x09/* old larger; copy over */\x0a"
"\x09\x09\x09while ((*C++ = *value++))\x0a"
"\x09\x09\x09\x09;\x0a"
"\x09\x09\x09return (0);\x0a"
"\x09\x09}\x0a"
"#endif\x0a"
"\x09\x09/* could be set multiple times */\x0a"
"\x09\x09while (__findenv(name, (int)(np - name), \x26tmpoff)) {\x0a"
"\x09\x09\x09""for (P = \x26""environ\x5btmpoff\x5d;; ++P)\x0a"
"\x09\x09\x09\x09if (\x21(*P = *(P + 1)))\x0a"
"\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09}\x0a"
"\x09} else {\x09\x09\x09\x09\x09/* create new slot */\x0a"
"\x09\x09size_t cnt = 0;\x0a"
"\x0a"
"\x09\x09if (environ \x21= NULL) {\x0a"
"\x09\x09\x09""for (P = environ; *P \x21= NULL; P++)\x0a"
"\x09\x09\x09\x09;\x0a"
"\x09\x09\x09""cnt = P - environ;\x0a"
"\x09\x09}\x0a"
"\x09\x09P = reallocarray(lastenv, cnt + 2, sizeof(char *));\x0a"
"\x09\x09if (\x21P)\x0a"
"\x09\x09\x09return (-1);\x0a"
"\x09\x09if (lastenv \x21= environ \x26\x26 environ \x21= NULL)\x0a"
"\x09\x09\x09memcpy(P, environ, cnt * sizeof(char *));\x0a"
"\x09\x09lastenv = environ = P;\x0a"
"\x09\x09offset = cnt;\x0a"
"\x09\x09""environ\x5b""cnt + 1\x5d = NULL;\x0a"
"\x09}\x0a"
"\x09if (\x21(environ\x5boffset\x5d =\x09\x09\x09/* name + \x60=' + value */\x0a"
"\x09    malloc((int)(np - name) + l_value + 2)))\x0a"
"\x09\x09return (-1);\x0a"
"\x09""for (C = environ\x5boffset\x5d; (*C = *name++) \x26\x26 *C \x21= '='; ++C)\x0a"
"\x09\x09;\x0a"
"\x09""for (*C++ = '='; (*C++ = *value++); )\x0a"
"\x09\x09;\x0a"
"\x09return (0);\x0a"
"}\x0a"
"//DEF_WEAK(setenv);\x0a"
"\x0a"
"/*\x0a"
" * unsetenv(name) --\x0a"
" *\x09""Delete environmental variable \x22name\x22.\x0a"
" */\x0a"
"int\x0a"
"unsetenv(const char *name)\x0a"
"{\x0a"
"\x09""char **P;\x0a"
"\x09""const char *np;\x0a"
"\x09int offset = 0;\x0a"
"\x0a"
"\x09if (\x21name \x7c\x7c \x21*name) {\x0a"
"\x09\x09""errno = EINVAL;\x0a"
"\x09\x09return (-1);\x0a"
"\x09}\x0a"
"\x09""for (np = name; *np \x26\x26 *np \x21= '='; ++np)\x0a"
"\x09\x09;\x0a"
"\x09if (*np) {\x0a"
"\x09\x09""errno = EINVAL;\x0a"
"\x09\x09return (-1);\x09\x09\x09/* has \x60=' in name */\x0a"
"\x09}\x0a"
"\x0a"
"\x09/* could be set multiple times */\x0a"
"\x09while (__findenv(name, (int)(np - name), \x26offset)) {\x0a"
"\x09\x09""for (P = \x26""environ\x5boffset\x5d;; ++P)\x0a"
"\x09\x09\x09if (\x21(*P = *(P + 1)))\x0a"
"\x09\x09\x09\x09""break;\x0a"
"\x09}\x0a"
"\x09return (0);\x0a"
"}\x0a"
"//DEF_WEAK(unsetenv);\x0a"
"", 4921 ); }