#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_stdlib_strtoull_c( 
"/* strtoull( const char *, char * *, int )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <limits.h>\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"unsigned long long int strtoull( const char * s, char ** endptr, int base )\x0a"
"{\x0a"
"    unsigned long long int rc;\x0a"
"    char sign = '+';\x0a"
"    const char * p = _PDCLIB_strtox_prelim( s, \x26sign, \x26""base );\x0a"
"    if ( base < 2 \x7c\x7c base > 36 ) return 0;\x0a"
"    rc = _PDCLIB_strtox_main( \x26p, (unsigned)base, (uintmax_t)ULLONG_MAX, (uintmax_t)( ULLONG_MAX / base ), (int)( ULLONG_MAX \x25 base ), \x26sign );\x0a"
"    if ( endptr \x21= NULL ) *endptr = ( p \x21= NULL ) \x3f (char *) p \x3a (char *) s;\x0a"
"    return ( sign == '+' ) \x3f rc \x3a -rc;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"#include <errno.h>\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    char * endptr;\x0a"
"    /* this, to base 36, overflows even a 256 bit integer */\x0a"
"    char overflow\x5b\x5d = \x22-ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ_\x22;\x0a"
"    /* tricky border case */\x0a"
"    char tricky\x5b\x5d = \x22+0xz\x22;\x0a"
"    errno = 0;\x0a"
"    /* basic functionality */\x0a"
"    TESTCASE( strtoull( \x22""123\x22, NULL, 10 ) == 123 );\x0a"
"    /* proper detecting of default base 10 */\x0a"
"    TESTCASE( strtoull( \x22""456\x22, NULL, 0 ) == 456 );\x0a"
"    /* proper functioning to smaller base */\x0a"
"    TESTCASE( strtoull( \x22""14\x22, NULL, 8 ) == 12 );\x0a"
"    /* proper autodetecting of octal */\x0a"
"    TESTCASE( strtoull( \x22""016\x22, NULL, 0 ) == 14 );\x0a"
"    /* proper autodetecting of hexadecimal, lowercase 'x' */\x0a"
"    TESTCASE( strtoull( \x22""0xFF\x22, NULL, 0 ) == 255 );\x0a"
"    /* proper autodetecting of hexadecimal, uppercase 'X' */\x0a"
"    TESTCASE( strtoull( \x22""0Xa1\x22, NULL, 0 ) == 161 );\x0a"
"    /* proper handling of border case\x3a 0x followed by non-hexdigit */\x0a"
"    TESTCASE( strtoull( tricky, \x26""endptr, 0 ) == 0 );\x0a"
"    TESTCASE( endptr == tricky + 2 );\x0a"
"    /* proper handling of border case\x3a 0 followed by non-octdigit */\x0a"
"    TESTCASE( strtoull( tricky, \x26""endptr, 8 ) == 0 );\x0a"
"    TESTCASE( endptr == tricky + 2 );\x0a"
"    /* errno should still be 0 */\x0a"
"    TESTCASE( errno == 0 );\x0a"
"    /* overflowing subject sequence must still return proper endptr */\x0a"
"    TESTCASE( strtoull( overflow, \x26""endptr, 36 ) == ULLONG_MAX );\x0a"
"    TESTCASE( errno == ERANGE );\x0a"
"    TESTCASE( ( endptr - overflow ) == 53 );\x0a"
"    /* same for positive */\x0a"
"    errno = 0;\x0a"
"    TESTCASE( strtoull( overflow + 1, \x26""endptr, 36 ) == ULLONG_MAX );\x0a"
"    TESTCASE( errno == ERANGE );\x0a"
"    TESTCASE( ( endptr - overflow ) == 53 );\x0a"
"    /* testing skipping of leading whitespace */\x0a"
"    TESTCASE( strtoull( \x22 \x5cn\x5cv\x5ct\x5c""f789\x22, NULL, 0 ) == 789 );\x0a"
"    /* testing conversion failure */\x0a"
"    TESTCASE( strtoull( overflow, \x26""endptr, 10 ) == 0 );\x0a"
"    TESTCASE( endptr == overflow );\x0a"
"    endptr = NULL;\x0a"
"    TESTCASE( strtoull( overflow, \x26""endptr, 0 ) == 0 );\x0a"
"    TESTCASE( endptr == overflow );\x0a"
"    errno = 0;\x0a"
"/* long long -> 64 bit */\x0a"
"#if ULLONG_MAX >> 63 == 1\x0a"
"    /* testing \x22""even\x22 overflow, i.e. base is power of two */\x0a"
"    TESTCASE( strtoull( \x22""18446744073709551615\x22, NULL, 0 ) == ULLONG_MAX );\x0a"
"    TESTCASE( errno == 0 );\x0a"
"    TESTCASE( strtoull( \x22""18446744073709551616\x22, NULL, 0 ) == ULLONG_MAX );\x0a"
"    TESTCASE( errno == ERANGE );\x0a"
"    /* TODO\x3a test \x22odd\x22 overflow, i.e. base is not power of two */\x0a"
"/* long long -> 128 bit */\x0a"
"#elif ULLONG_MAX >> 127 == 1\x0a"
"    /* testing \x22""even\x22 overflow, i.e. base is power of two */\x0a"
"    TESTCASE( strtoull( \x22""340282366920938463463374607431768211455\x22, NULL, 0 ) == ULLONG_MAX );\x0a"
"    TESTCASE( errno == 0 );\x0a"
"    TESTCASE( strtoull( \x22""340282366920938463463374607431768211456\x22, NULL, 0 ) == ULLONG_MAX );\x0a"
"    TESTCASE( errno == ERANGE );\x0a"
"    /* TODO\x3a test \x22odd\x22 overflow, i.e. base is not power of two */\x0a"
"#else\x0a"
"#error Unsupported width of 'long long' (neither 64 nor 128 bit).\x0a"
"#endif\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"", 3754 ); }