#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_string_memcpy_c( 
"/* memcpy( void *, const void *, size_t )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <string.h>\x0a"
"#include <assert.h>\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"\x0a"
"__link_always __local_skipcfl\x0a"
"void * memcpy( void * _PDCLIB_restrict s1, const void * _PDCLIB_restrict s2, size_t n )\x0a"
"{\x0a"
"    assert( s1 < s2 \x3f s1 + n <= s2 \x3a s2 + n <= s1 );\x0a"
"\x0a"
"    char *dst = ( char * ) s1;\x0a"
"    const char *src = ( const char * ) s2;\x0a"
"\x0a"
"    switch ( n )\x0a"
"    {\x0a"
"        case 1\x3a *dst = *src; return s1;\x0a"
"        case 2\x3a *( uint16_t * ) dst = *( uint16_t * ) src; return s1;\x0a"
"        case 4\x3a *( uint32_t * ) dst = *( uint32_t * ) src; return s1;\x0a"
"        case 8\x3a *( uint64_t * ) dst = *( uint64_t * ) src; return s1;\x0a"
"        default\x3a\x0a"
"        {\x0a"
"            while ( ( uint64_t ) dst \x25 8 \x26\x26 ( uint64_t ) src \x25 8 \x26\x26 n )\x0a"
"                *dst++ = *src++, n --;\x0a"
"\x0a"
"            uint64_t *src_l = ( uint64_t * ) src;\x0a"
"            uint64_t *dst_l = ( uint64_t * ) dst;\x0a"
"\x0a"
"            while ( n >= 8 )\x0a"
"            {\x0a"
"                *dst_l++ = *src_l++;\x0a"
"                n -= 8;\x0a"
"            }\x0a"
"\x0a"
"            src = ( const char * ) src_l;\x0a"
"            dst = ( char *) dst_l;\x0a"
"            while ( n-- )\x0a"
"                *dst++ = *src++;\x0a"
"        }\x0a"
"        return s1;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    char s\x5b\x5d = \x22xxxxxxxxxxx\x22;\x0a"
"    TESTCASE( memcpy( s, abcde, 6 ) == s );\x0a"
"    TESTCASE( s\x5b""4\x5d == 'e' );\x0a"
"    TESTCASE( s\x5b""5\x5d == '\x5c""0' );\x0a"
"    TESTCASE( memcpy( s + 5, abcde, 5 ) == s + 5 );\x0a"
"    TESTCASE( s\x5b""9\x5d == 'e' );\x0a"
"    TESTCASE( s\x5b""10\x5d == 'x' );\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"#endif\x0a"
"", 1658 ); }