#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_string_strerror_r_c( 
"/* \x24Id\x24 */\x0a"
"\x0a"
"/* strerror_r( int, char * , size_t )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#include <string.h>\x0a"
"#include <errno.h>\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"\x0a"
"#include <_PDCLIB/locale.h>\x0a"
"\x0a"
"#define MIN( a, b ) ( (a) < (b) \x3f (a) \x3a (b) )\x0a"
"\x0a"
"/* The GNU-specific strerror_r() returns a pointer to a string\x0a"
"   containing the error message. This may be either a pointer to\x0a"
"   a string that the function stores in buf, or a pointer to some\x0a"
"   (immutable) static string (in which case buf is unused).\x0a"
"   If the function stores a string in buf, then at most buflen bytes\x0a"
"   are stored (the string may be truncated if buflen is too small\x0a"
"   and errnum is unknown). The string always includes a terminating\x0a"
"   null byte.\x0a"
"*/\x0a"
"#if _HOST_is_glibc\x0a"
"        int __xpg_strerror_r( int errnum, char *buf, size_t buflen )\x0a"
"#else\x0a"
"        int strerror_r( int errnum, char *buf, size_t buflen )\x0a"
"#endif\x0a"
"    {\x0a"
"        const char *err;\x0a"
"        if ( errnum == 0 \x7c\x7c errnum >= _PDCLIB_ERRNO_MAX\x0a"
"             \x7c\x7c _PDCLIB_threadlocale()->_ErrnoStr\x5b""errnum\x5d == NULL )\x0a"
"            err = \x22Unknown error\x22;\x0a"
"        else\x0a"
"            err = _PDCLIB_threadlocale()->_ErrnoStr\x5b""errnum\x5d;\x0a"
"\x0a"
"        size_t errlen = strlen( err );\x0a"
"        int len = MIN( buflen - 1, errlen );\x0a"
"        memcpy( buf, err, len );\x0a"
"        buf\x5b len \x5d = '\x5c""0';\x0a"
"\x0a"
"        if ( errnum == 0 \x7c\x7c errnum >= _PDCLIB_ERRNO_MAX )\x0a"
"            return EINVAL;\x0a"
"        return buflen <= errlen\x3f ERANGE \x3a 0;\x0a"
"    }\x0a"
"\x0a"
"#if _HOST_is_glibc // _GNU_SOURCE\x0a"
"    char * strerror_r( int errnum, char *buf, size_t buflen )\x0a"
"    {\x0a"
"        if ( errnum == 0 \x7c\x7c errnum >= _PDCLIB_ERRNO_MAX )\x0a"
"            return (char *)\x22Unknown error\x22;\x0a"
"        else\x0a"
"        {\x0a"
"            const char *src = _PDCLIB_threadlocale()->_ErrnoStr\x5b""errnum\x5d;\x0a"
"            int len = MIN( buflen - 1, strlen( src ) );\x0a"
"            memcpy( buf, src, len );\x0a"
"            buf\x5b len \x5d = '\x5c""0';\x0a"
"            return buf;\x0a"
"        }\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"#endif // REGTEST\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include <_PDCLIB_test.h>\x0a"
"\x0a"
"#include <stdio.h>\x0a"
"#include <errno.h>\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    char buf1\x5b""128\x5d, buf2\x5b""128\x5d;\x0a"
"    TESTCASE( strcmp( strerror_r( ERANGE, buf1, 128 ), strerror_r( EDOM, buf2, 128 ) ) );\x0a"
"    TESTCASE( strcmp( strerror_r( ERANGE, buf1 + 125, 3 ), strerror_r( EDOM, buf2 + 125, 3 ) ) );\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"#endif\x0a"
"", 2348 ); }