#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_sys_start_cpp( 
"#include <stdlib.h>\x0a"
"#include <pthread.h>\x0a"
"#include <sys/start.h>\x0a"
"#include <sys/metadata.h>\x0a"
"\x0a"
"char** environ;\x0a"
"static char **__argv;\x0a"
"char* __progname;\x0a"
"\x0a"
"extern char* program_invocation_short_name __attribute__((alias (\x22__progname\x22)));\x0a"
"\x0a"
"extern \x22""C\x22 /* generated by lart */\x0a"
"{\x0a"
"    void __dios_call_global_ctors();\x0a"
"    void __dios_call_global_dtors();\x0a"
"    void __dios_term_fini();\x0a"
"}\x0a"
"\x0a"
"namespace\x0a"
"{\x0a"
"\x0a"
"struct CtorDtorEntry\x0a"
"{\x0a"
"    int32_t prio;\x0a"
"    void (*fn)();\x0a"
"    void *ignored; // should be used only by linker to discard entries\x0a"
"};\x0a"
"\x0a"
"void freeMainArgs( char** argv ) noexcept\x0a"
"{\x0a"
"    char **orig = argv;\x0a"
"    while( *argv )\x0a"
"    {\x0a"
"        __vm_obj_free( *argv );\x0a"
"        ++argv;\x0a"
"    }\x0a"
"    __vm_obj_free( orig );\x0a"
"}\x0a"
"\x0a"
"} // namespace\x0a"
"\x0a"
"extern \x22""C\x22\x0a"
"{\x0a"
"    __attribute__((noinline,weak)) void __lart_globals_initialize() {}\x0a"
"}\x0a"
"\x0a"
"void __dios_run_ctors()\x0a"
"{\x0a"
"    __dios_call_global_ctors();\x0a"
"}\x0a"
"\x0a"
"void __dios_run_dtors()\x0a"
"{\x0a"
"    __dios_call_global_dtors();\x0a"
"}\x0a"
"\x0a"
"extern \x22""C\x22 void _exit( int rv )\x0a"
"{\x0a"
"    if ( rv )\x0a"
"    {\x0a"
"        __dios_trace_f( \x22Non-zero exit code\x3a \x25""d\x22, rv );\x0a"
"        __dios_fault( _DiOS_F_Exit, \x22""exit called with non-zero value\x22 );\x0a"
"    }\x0a"
"    __dios_reschedule();\x0a"
"    __dios_run_dtors();\x0a"
"    __cxa_finalize( 0 );\x0a"
"    __pthread_finalize();\x0a"
"    __dios_term_fini();\x0a"
"    freeMainArgs( environ );\x0a"
"    freeMainArgs( __argv );\x0a"
"    __dios_exit_process( rv );\x0a"
"    __builtin_unreachable();\x0a"
"}\x0a"
"\x0a"
"__attribute__(( __always_inline__ )) int __execute_main( int l, int argc, char **argv, char **envp )\x0a"
"{\x0a"
"    __lart_globals_initialize();\x0a"
"\x0a"
"    environ = envp;\x0a"
"    __progname = argv\x3f argv\x5b""0\x5d \x3a NULL;\x0a"
"    __argv = argv;\x0a"
"\x0a"
"    __pthread_initialize(); // must run before constructors, constructors can\x0a"
"                            // use pthreads (such as pthread_once or thread\x0a"
"                            // local storage)\x0a"
"    __dios_run_ctors();\x0a"
"    int res;\x0a"
"    switch (l)\x0a"
"    {\x0a"
"        case 0\x3a\x0a"
"            res = main();\x0a"
"            break;\x0a"
"        case 2\x3a\x0a"
"            res = main( argc, argv );\x0a"
"            break;\x0a"
"        case 3\x3a\x0a"
"            res = main( argc, argv, envp );\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            __dios_assert_v( false, \x22Unexpected prototype of main\x22 );\x0a"
"            res = 256;\x0a"
"    }\x0a"
"\x0a"
"    return res;\x0a"
"}\x0a"
"\x0a"
"void __dios_start( int l, int argc, char **argv, char **envp )\x0a"
"{\x0a"
"    int res = __execute_main( l, argc, argv, envp );\x0a"
"    exit( res );\x0a"
"}\x0a"
"\x0a"
"void __dios_start_synchronous( int l, int argc, char **argv, char **envp )\x0a"
"{\x0a"
"    int res = __execute_main( l, argc, argv, envp );\x0a"
"    if ( res )\x0a"
"    {\x0a"
"        __dios_trace_f( \x22Non-zero return from setup\x3a \x25""d\x22, res );\x0a"
"        __dios_fault( _DiOS_F_Exit, \x22setup ended with non-zero value\x22 );\x0a"
"    }\x0a"
"    __dios_yield();\x0a"
"}\x0a"
"", 2634 ); }