#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_time_asctime_c( 
"/*\x09\x24OpenBSD\x3a asctime.c,v 1.23 2015/10/24 18\x3a""13\x3a""18 guenther Exp \x24 */\x0a"
"/*\x0a"
"** This file is in the public domain, so clarified as of\x0a"
"** 1996-06-05 by Arthur David Olson.\x0a"
"*/\x0a"
"\x0a"
"/*\x0a"
"** Avoid the temptation to punt entirely to strftime;\x0a"
"** the output of strftime is supposed to be locale specific\x0a"
"** whereas the output of asctime is supposed to be constant.\x0a"
"*/\x0a"
"\x0a"
"#include <errno.h>\x0a"
"#include <stdio.h>\x0a"
"#include <string.h>\x0a"
"#include \x22private.h\x22\x0a"
"#include \x22tzfile.h\x22\x0a"
"#include \x22thread_private.h\x22\x0a"
"\x0a"
"/*\x0a"
"** Some systems only handle \x22\x25.2d\x22; others only handle \x22\x25""02d\x22;\x0a"
"** \x22\x25""02.2d\x22 makes (most) everybody happy.\x0a"
"** At least some versions of gcc warn about the \x25""02.2d;\x0a"
"** we conditionalize below to avoid the warning.\x0a"
"*/\x0a"
"/*\x0a"
"** All years associated with 32-bit time_t values are exactly four digits long;\x0a"
"** some years associated with 64-bit time_t values are not.\x0a"
"** Vintage programs are coded for years that are always four digits long\x0a"
"** and may assume that the newline always lands in the same place.\x0a"
"** For years that are less than four digits, we pad the output with\x0a"
"** leading zeroes to get the newline in the traditional place.\x0a"
"** The -4 ensures that we get four characters of output even if\x0a"
"** we call a strftime variant that produces fewer characters for some years.\x0a"
"** The ISO C 1999 and POSIX 1003.1-2004 standards prohibit padding the year,\x0a"
"** but many implementations pad anyway; most likely the standards are buggy.\x0a"
"*/\x0a"
"#define ASCTIME_FMT\x09\x22\x25.3s \x25.3s\x25""3d \x25""2.2d\x3a\x25""2.2d\x3a\x25""2.2d \x25-4s\x5cn\x22\x0a"
"\x0a"
"/*\x0a"
"** For years that are more than four digits we put extra spaces before the year\x0a"
"** so that code trying to overwrite the newline won't end up overwriting\x0a"
"** a digit within a year and truncating the year (operating on the assumption\x0a"
"** that no output is better than wrong output).\x0a"
"*/\x0a"
"#define ASCTIME_FMT_B\x09\x22\x25.3s \x25.3s\x25""3d \x25""2.2d\x3a\x25""2.2d\x3a\x25""2.2d     \x25s\x5cn\x22\x0a"
"\x0a"
"#define STD_ASCTIME_BUF_SIZE\x09""26\x0a"
"/*\x0a"
"** Big enough for something such as\x0a"
"** \x3f\x3f\x3f \x3f\x3f\x3f-2147483648 -2147483648\x3a-2147483648\x3a-2147483648     -2147483648\x5cn\x0a"
"** (two three-character abbreviations, five strings denoting integers,\x0a"
"** seven explicit spaces, two explicit colons, a newline,\x0a"
"** and a trailing ASCII nul).\x0a"
"** The values above are for systems where an int is 32 bits and are provided\x0a"
"** as an example; the define below calculates the maximum for the system at\x0a"
"** hand.\x0a"
"*/\x0a"
"#define MAX_ASCTIME_BUF_SIZE\x09(2*3+5*INT_STRLEN_MAXIMUM(int)+7+2+1+1)\x0a"
"\x0a"
"static char *\x0a"
"asctime3(const struct tm *timeptr, char *buf, int bufsize)\x0a"
"{\x0a"
"\x09static const char\x09wday_name\x5b\x5d\x5b""4\x5d = {\x0a"
"\x09\x09\x22Sun\x22, \x22Mon\x22, \x22Tue\x22, \x22Wed\x22, \x22Thu\x22, \x22""Fri\x22, \x22Sat\x22\x0a"
"\x09};\x0a"
"\x09static const char\x09mon_name\x5b\x5d\x5b""4\x5d = {\x0a"
"\x09\x09\x22Jan\x22, \x22""Feb\x22, \x22Mar\x22, \x22""Apr\x22, \x22May\x22, \x22Jun\x22,\x0a"
"\x09\x09\x22Jul\x22, \x22""Aug\x22, \x22Sep\x22, \x22Oct\x22, \x22Nov\x22, \x22""Dec\x22\x0a"
"\x09};\x0a"
"\x09""const char *\x09wn;\x0a"
"\x09""const char *\x09mn;\x0a"
"\x09""char\x09\x09year\x5bINT_STRLEN_MAXIMUM(int) + 2\x5d;\x0a"
"\x09int\x09\x09len;\x0a"
"\x0a"
"\x09if (timeptr == NULL) {\x0a"
"\x09\x09""errno = EINVAL;\x0a"
"\x09\x09strlcpy(buf, \x22\x3f\x3f\x3f \x3f\x3f\x3f \x3f\x3f \x3f\x3f\x3a\x3f\x3f\x3a\x3f\x3f \x3f\x3f\x3f\x3f\x5cn\x22, bufsize);\x0a"
"\x09\x09return buf;\x0a"
"\x09}\x0a"
"\x09if (timeptr->tm_wday < 0 \x7c\x7c timeptr->tm_wday >= DAYSPERWEEK)\x0a"
"\x09\x09wn = \x22\x3f\x3f\x3f\x22;\x0a"
"\x09""else\x0a"
"\x09\x09wn = wday_name\x5btimeptr->tm_wday\x5d;\x0a"
"\x09if (timeptr->tm_mon < 0 \x7c\x7c timeptr->tm_mon >= MONSPERYEAR)\x0a"
"\x09\x09mn = \x22\x3f\x3f\x3f\x22;\x0a"
"\x09""else\x0a"
"\x09\x09mn = mon_name\x5btimeptr->tm_mon\x5d;\x0a"
"\x09/*\x0a"
"\x09** Use strftime's \x25Y to generate the year, to avoid overflow problems\x0a"
"\x09** when computing timeptr->tm_year + TM_YEAR_BASE.\x0a"
"\x09** Assume that strftime is unaffected by other out-of-range members\x0a"
"\x09** (e.g., timeptr->tm_mday) when processing \x22\x25Y\x22.\x0a"
"\x09*/\x0a"
"\x09(void) strftime(year, sizeof year, \x22\x25Y\x22, timeptr);\x0a"
"\x09len = snprintf(buf, bufsize,\x0a"
"\x09    ((strlen(year) <= 4) \x3f ASCTIME_FMT \x3a ASCTIME_FMT_B),\x0a"
"\x09    wn, mn,\x0a"
"\x09    timeptr->tm_mday, timeptr->tm_hour,\x0a"
"\x09    timeptr->tm_min, timeptr->tm_sec,\x0a"
"\x09    year);\x0a"
"\x09if (len \x21= -1 \x26\x26 len < bufsize) {\x0a"
"\x09\x09return buf;\x0a"
"\x09} else {\x0a"
"\x09\x09""errno = EOVERFLOW;\x0a"
"\x09\x09return NULL;\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** A la ISO/IEC 9945-1, ANSI/IEEE Std 1003.1, 2004 Edition.\x0a"
"*/\x0a"
"\x0a"
"char *\x0a"
"asctime_r(const struct tm *timeptr, char *buf)\x0a"
"{\x0a"
"\x09/*\x0a"
"\x09** P1003 8.3.5.2 says that asctime_r() can only assume at most\x0a"
"\x09** a 26 byte buffer.\x0a"
"\x09*/\x0a"
"\x09return asctime3(timeptr, buf, STD_ASCTIME_BUF_SIZE);\x0a"
"}\x0a"
"//DEF_WEAK(asctime_r);\x0a"
"\x0a"
"/*\x0a"
"** A la ISO/IEC 9945-1, ANSI/IEEE Std 1003.1, 2004 Edition.\x0a"
"*/\x0a"
"\x0a"
"char *\x0a"
"asctime(const struct tm *timeptr)\x0a"
"{\x0a"
"\x09static char result\x5bMAX_ASCTIME_BUF_SIZE\x5d;\x0a"
"\x09_THREAD_PRIVATE_KEY(asctime);\x0a"
"\x09""char *resultp = (char *)_THREAD_PRIVATE(asctime, result, NULL);\x0a"
"\x0a"
"\x09if (resultp == NULL)\x0a"
"\x09\x09return NULL;\x0a"
"\x09""else\x0a"
"\x09\x09return asctime3(timeptr, resultp, sizeof(result));\x0a"
"}\x0a"
"//DEF_STRONG(asctime);\x0a"
"", 4355 ); }