#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_time_localtime_c( 
"/*\x09\x24OpenBSD\x3a localtime.c,v 1.58 2016/03/14 15\x3a""26\x3a""52 mestre Exp \x24 */\x0a"
"/*\x0a"
"** This file is in the public domain, so clarified as of\x0a"
"** 1996-06-05 by Arthur David Olson.\x0a"
"*/\x0a"
"\x0a"
"/*\x0a"
"** Leap second handling from Bradley White.\x0a"
"** POSIX-style TZ environment variable handling from Guy Harris.\x0a"
"*/\x0a"
"\x0a"
"#include <ctype.h>\x0a"
"#include <errno.h>\x0a"
"#include <fcntl.h>\x0a"
"#include <float.h>\x09/* for FLT_MAX and DBL_MAX */\x0a"
"#include <stdint.h>\x0a"
"#include <stdlib.h>\x0a"
"#include <string.h>\x0a"
"#include <unistd.h>\x0a"
"\x0a"
"#include <sys/syswrap.h>\x0a"
"\x0a"
"#include \x22private.h\x22\x0a"
"#include \x22tzfile.h\x22\x0a"
"#include \x22thread_private.h\x22\x0a"
"\x0a"
"#ifndef TZ_ABBR_MAX_LEN\x0a"
"#define TZ_ABBR_MAX_LEN\x09""16\x0a"
"#endif /* \x21""defined TZ_ABBR_MAX_LEN */\x0a"
"\x0a"
"#ifndef TZ_ABBR_CHAR_SET\x0a"
"#define TZ_ABBR_CHAR_SET \x5c\x0a"
"\x09\x22""abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 \x3a+-._\x22\x0a"
"#endif /* \x21""defined TZ_ABBR_CHAR_SET */\x0a"
"\x0a"
"#ifndef TZ_ABBR_ERR_CHAR\x0a"
"#define TZ_ABBR_ERR_CHAR\x09'_'\x0a"
"#endif /* \x21""defined TZ_ABBR_ERR_CHAR */\x0a"
"\x0a"
"#ifndef WILDABBR\x0a"
"/*\x0a"
"** Someone might make incorrect use of a time zone abbreviation\x3a\x0a"
"**\x09""1.\x09They might reference tzname\x5b""0\x5d before calling tzset (explicitly\x0a"
"**\x09\x09or implicitly).\x0a"
"**\x09""2.\x09They might reference tzname\x5b""1\x5d before calling tzset (explicitly\x0a"
"**\x09\x09or implicitly).\x0a"
"**\x09""3.\x09They might reference tzname\x5b""1\x5d after setting to a time zone\x0a"
"**\x09\x09in which Daylight Saving Time is never observed.\x0a"
"**\x09""4.\x09They might reference tzname\x5b""0\x5d after setting to a time zone\x0a"
"**\x09\x09in which Standard Time is never observed.\x0a"
"**\x09""5.\x09They might reference tm.TM_ZONE after calling offtime.\x0a"
"** What's best to do in the above cases is open to debate;\x0a"
"** for now, we just set things up so that in any of the five cases\x0a"
"** WILDABBR is used. Another possibility\x3a initialize tzname\x5b""0\x5d to the\x0a"
"** string \x22tzname\x5b""0\x5d used before set\x22, and similarly for the other cases.\x0a"
"** And another\x3a initialize tzname\x5b""0\x5d to \x22""ERA\x22, with an explanation in the\x0a"
"** manual page of what this \x22time zone abbreviation\x22 means (doing this so\x0a"
"** that tzname\x5b""0\x5d has the \x22normal\x22 length of three characters).\x0a"
"*/\x0a"
"#define WILDABBR\x09\x22   \x22\x0a"
"#endif /* \x21""defined WILDABBR */\x0a"
"\x0a"
"static char\x09\x09wildabbr\x5b\x5d = WILDABBR;\x0a"
"\x0a"
"static const char\x09gmt\x5b\x5d = \x22GMT\x22;\x0a"
"\x0a"
"/*\x0a"
"** The DST rules to use if TZ has no rules and we can't load TZDEFRULES.\x0a"
"** We default to US rules as of 1999-08-17.\x0a"
"** POSIX 1003.1 section 8.1.1 says that the default DST rules are\x0a"
"** implementation dependent; for historical reasons, US rules are a\x0a"
"** common default.\x0a"
"*/\x0a"
"#ifndef TZDEFRULESTRING\x0a"
"#define TZDEFRULESTRING \x22,M4.1.0,M10.5.0\x22\x0a"
"#endif /* \x21""defined TZDEFDST */\x0a"
"\x0a"
"struct ttinfo {\x09\x09\x09\x09/* time type information */\x0a"
"\x09long\x09\x09tt_gmtoff;\x09/* UTC offset in seconds */\x0a"
"\x09int\x09\x09tt_isdst;\x09/* used to set tm_isdst */\x0a"
"\x09int\x09\x09tt_abbrind;\x09/* abbreviation list index */\x0a"
"\x09int\x09\x09tt_ttisstd;\x09/* TRUE if transition is std time */\x0a"
"\x09int\x09\x09tt_ttisgmt;\x09/* TRUE if transition is UTC */\x0a"
"};\x0a"
"\x0a"
"struct lsinfo {\x09\x09\x09\x09/* leap second information */\x0a"
"\x09time_t\x09\x09ls_trans;\x09/* transition time */\x0a"
"\x09long\x09\x09ls_corr;\x09/* correction to apply */\x0a"
"};\x0a"
"\x0a"
"#define BIGGEST(a, b)\x09(((a) > (b)) \x3f (a) \x3a (b))\x0a"
"\x0a"
"#ifdef TZNAME_MAX\x0a"
"#define MY_TZNAME_MAX\x09TZNAME_MAX\x0a"
"#endif /* defined TZNAME_MAX */\x0a"
"#ifndef TZNAME_MAX\x0a"
"#define MY_TZNAME_MAX\x09""255\x0a"
"#endif /* \x21""defined TZNAME_MAX */\x0a"
"\x0a"
"struct state {\x0a"
"\x09int\x09\x09leapcnt;\x0a"
"\x09int\x09\x09timecnt;\x0a"
"\x09int\x09\x09typecnt;\x0a"
"\x09int\x09\x09""charcnt;\x0a"
"\x09int\x09\x09goback;\x0a"
"\x09int\x09\x09goahead;\x0a"
"\x09time_t\x09\x09""ats\x5bTZ_MAX_TIMES\x5d;\x0a"
"\x09unsigned char\x09types\x5bTZ_MAX_TIMES\x5d;\x0a"
"\x09struct ttinfo\x09ttis\x5bTZ_MAX_TYPES\x5d;\x0a"
"\x09""char\x09\x09""chars\x5b""BIGGEST(BIGGEST(TZ_MAX_CHARS + 1, sizeof gmt),\x0a"
"\x09\x09\x09    (2 * (MY_TZNAME_MAX + 1)))\x5d;\x0a"
"\x09struct lsinfo\x09lsis\x5bTZ_MAX_LEAPS\x5d;\x0a"
"};\x0a"
"\x0a"
"struct rule {\x0a"
"\x09int\x09\x09r_type;\x09\x09/* type of rule--see below */\x0a"
"\x09int\x09\x09r_day;\x09\x09/* day number of rule */\x0a"
"\x09int\x09\x09r_week;\x09\x09/* week number of rule */\x0a"
"\x09int\x09\x09r_mon;\x09\x09/* month number of rule */\x0a"
"\x09long\x09\x09r_time;\x09\x09/* transition time of rule */\x0a"
"};\x0a"
"\x0a"
"#define JULIAN_DAY\x09\x09""0\x09/* Jn - Julian day */\x0a"
"#define DAY_OF_YEAR\x09\x09""1\x09/* n - day of year */\x0a"
"#define MONTH_NTH_DAY_OF_WEEK\x09""2\x09/* Mm.n.d - month, week, day of week */\x0a"
"\x0a"
"/*\x0a"
"** Prototypes for static functions.\x0a"
"*/\x0a"
"\x0a"
"static long\x09\x09""detzcode(const char * codep);\x0a"
"static time_t\x09\x09""detzcode64(const char * codep);\x0a"
"static int\x09\x09""differ_by_repeat(time_t t1, time_t t0);\x0a"
"static const char *\x09getzname(const char * strp);\x0a"
"static const char *\x09getqzname(const char * strp, const int delim);\x0a"
"static const char *\x09getnum(const char * strp, int * nump, int min,\x0a"
"\x09\x09\x09\x09int max);\x0a"
"static const char *\x09getsecs(const char * strp, long * secsp);\x0a"
"static const char *\x09getoffset(const char * strp, long * offsetp);\x0a"
"static const char *\x09getrule(const char * strp, struct rule * rulep);\x0a"
"static void\x09\x09gmtload(struct state * sp);\x0a"
"static struct tm *\x09gmtsub(const time_t * timep, long offset,\x0a"
"\x09\x09\x09\x09struct tm * tmp);\x0a"
"static struct tm *\x09localsub(const time_t * timep, long offset,\x0a"
"\x09\x09\x09\x09struct tm * tmp);\x0a"
"static int\x09\x09increment_overflow(int * number, int delta);\x0a"
"static int\x09\x09leaps_thru_end_of(int y);\x0a"
"static int\x09\x09long_increment_overflow(long * number, int delta);\x0a"
"static int\x09\x09long_normalize_overflow(long * tensptr,\x0a"
"\x09\x09\x09\x09int * unitsptr, int base);\x0a"
"static int\x09\x09normalize_overflow(int * tensptr, int * unitsptr,\x0a"
"\x09\x09\x09\x09int base);\x0a"
"static void\x09\x09settzname(void);\x0a"
"static time_t\x09\x09time1(struct tm * tmp,\x0a"
"\x09\x09\x09\x09struct tm * (*funcp)(const time_t *,\x0a"
"\x09\x09\x09\x09long, struct tm *),\x0a"
"\x09\x09\x09\x09long offset);\x0a"
"static time_t\x09\x09time2(struct tm *tmp,\x0a"
"\x09\x09\x09\x09struct tm * (*funcp)(const time_t *,\x0a"
"\x09\x09\x09\x09long, struct tm*),\x0a"
"\x09\x09\x09\x09long offset, int * okayp);\x0a"
"static time_t\x09\x09time2sub(struct tm *tmp,\x0a"
"\x09\x09\x09\x09struct tm * (*funcp)(const time_t *,\x0a"
"\x09\x09\x09\x09long, struct tm*),\x0a"
"\x09\x09\x09\x09long offset, int * okayp, int do_norm_secs);\x0a"
"static struct tm *\x09timesub(const time_t * timep, long offset,\x0a"
"\x09\x09\x09\x09""const struct state * sp, struct tm * tmp);\x0a"
"static int\x09\x09tmcomp(const struct tm * atmp,\x0a"
"\x09\x09\x09\x09""const struct tm * btmp);\x0a"
"static time_t\x09\x09transtime(time_t janfirst, int year,\x0a"
"\x09\x09\x09\x09""const struct rule * rulep, long offset);\x0a"
"static int\x09\x09typesequiv(const struct state * sp, int a, int b);\x0a"
"static int\x09\x09tzload(const char * name, struct state * sp,\x0a"
"\x09\x09\x09\x09int doextend);\x0a"
"static int\x09\x09tzparse(const char * name, struct state * sp,\x0a"
"\x09\x09\x09\x09int lastditch);\x0a"
"\x0a"
"#ifdef STD_INSPIRED\x0a"
"struct tm\x09*offtime(const time_t *, long);\x0a"
"time_t\x09\x09time2posix(time_t);\x0a"
"time_t\x09\x09posix2time(time_t);\x0a"
"//PROTO_DEPRECATED(offtime);\x0a"
"//PROTO_DEPRECATED(time2posix);\x0a"
"//PROTO_DEPRECATED(posix2time);\x0a"
"#endif\x0a"
"\x0a"
"static struct state *\x09lclptr;\x0a"
"static struct state *\x09gmtptr;\x0a"
"\x0a"
"\x0a"
"#ifndef TZ_STRLEN_MAX\x0a"
"#define TZ_STRLEN_MAX 255\x0a"
"#endif /* \x21""defined TZ_STRLEN_MAX */\x0a"
"\x0a"
"static char\x09\x09lcl_TZname\x5bTZ_STRLEN_MAX + 1\x5d;\x0a"
"static int\x09\x09lcl_is_set;\x0a"
"static int\x09\x09gmt_is_set;\x0a"
"_THREAD_PRIVATE_MUTEX(lcl);\x0a"
"_THREAD_PRIVATE_MUTEX(gmt);\x0a"
"\x0a"
"char *\x09\x09\x09tzname\x5b""2\x5d = {\x0a"
"\x09wildabbr,\x0a"
"\x09wildabbr\x0a"
"};\x0a"
"#if 0\x0a"
"DEF_WEAK(tzname);\x0a"
"#endif\x0a"
"\x0a"
"/*\x0a"
"** Section 4.12.3 of X3.159-1989 requires that\x0a"
"**\x09""Except for the strftime function, these functions \x5b""asctime,\x0a"
"**\x09""ctime, gmtime, localtime\x5d return values in one of two static\x0a"
"**\x09objects\x3a a broken-down time structure and an array of char.\x0a"
"** Thanks to Paul Eggert for noting this.\x0a"
"*/\x0a"
"\x0a"
"static struct tm\x09tm;\x0a"
"\x0a"
"#ifdef USG_COMPAT\x0a"
"long\x09\x09\x09timezone = 0;\x0a"
"int\x09\x09\x09""daylight = 0;\x0a"
"#endif /* defined USG_COMPAT */\x0a"
"\x0a"
"#ifdef ALTZONE\x0a"
"time_t\x09\x09\x09""altzone = 0;\x0a"
"#endif /* defined ALTZONE */\x0a"
"\x0a"
"static long\x0a"
"detzcode(const char *codep)\x0a"
"{\x0a"
"\x09long\x09result;\x0a"
"\x09int\x09i;\x0a"
"\x0a"
"\x09result = (codep\x5b""0\x5d \x26 0x80) \x3f \x7e""0L \x3a 0;\x0a"
"\x09""for (i = 0; i < 4; ++i)\x0a"
"\x09\x09result = (result << 8) \x7c (codep\x5bi\x5d \x26 0xff);\x0a"
"\x09return result;\x0a"
"}\x0a"
"\x0a"
"static time_t\x0a"
"detzcode64(const char *codep)\x0a"
"{\x0a"
"\x09time_t\x09result;\x0a"
"\x09int\x09i;\x0a"
"\x0a"
"\x09result = (codep\x5b""0\x5d \x26 0x80) \x3f  (\x7e(int_fast64_t) 0) \x3a 0;\x0a"
"\x09""for (i = 0; i < 8; ++i)\x0a"
"\x09\x09result = result * 256 + (codep\x5bi\x5d \x26 0xff);\x0a"
"\x09return result;\x0a"
"}\x0a"
"\x0a"
"static void\x0a"
"settzname(void)\x0a"
"{\x0a"
"\x09struct state * const\x09sp = lclptr;\x0a"
"\x09int\x09\x09\x09i;\x0a"
"\x0a"
"\x09tzname\x5b""0\x5d = wildabbr;\x0a"
"\x09tzname\x5b""1\x5d = wildabbr;\x0a"
"#ifdef USG_COMPAT\x0a"
"\x09""daylight = 0;\x0a"
"\x09timezone = 0;\x0a"
"#endif /* defined USG_COMPAT */\x0a"
"#ifdef ALTZONE\x0a"
"\x09""altzone = 0;\x0a"
"#endif /* defined ALTZONE */\x0a"
"\x09if (sp == NULL) {\x0a"
"\x09\x09tzname\x5b""0\x5d = tzname\x5b""1\x5d = (char *)gmt;\x0a"
"\x09\x09return;\x0a"
"\x09}\x0a"
"\x09/*\x0a"
"\x09** And to get the latest zone names into tzname. . .\x0a"
"\x09*/\x0a"
"\x09""for (i = 0; i < sp->timecnt; ++i) {\x0a"
"\x09\x09""const struct ttinfo *ttisp = \x26sp->ttis\x5bsp->types\x5bi\x5d\x5d;\x0a"
"\x0a"
"\x09\x09tzname\x5bttisp->tt_isdst\x5d = \x26sp->chars\x5bttisp->tt_abbrind\x5d;\x0a"
"#ifdef USG_COMPAT\x0a"
"\x09\x09if (ttisp->tt_isdst)\x0a"
"\x09\x09\x09""daylight = 1;\x0a"
"\x09\x09if (\x21ttisp->tt_isdst)\x0a"
"\x09\x09\x09timezone = -(ttisp->tt_gmtoff);\x0a"
"#endif /* defined USG_COMPAT */\x0a"
"#ifdef ALTZONE\x0a"
"\x09\x09if (ttisp->tt_isdst)\x0a"
"\x09\x09\x09""altzone = -(ttisp->tt_gmtoff);\x0a"
"#endif /* defined ALTZONE */\x0a"
"\x09}\x0a"
"\x09/*\x0a"
"\x09** Finally, scrub the abbreviations.\x0a"
"\x09** First, replace bogus characters.\x0a"
"\x09*/\x0a"
"\x09""for (i = 0; i < sp->charcnt; ++i) {\x0a"
"\x09\x09if (strchr(TZ_ABBR_CHAR_SET, sp->chars\x5bi\x5d) == NULL)\x0a"
"\x09\x09\x09sp->chars\x5bi\x5d = TZ_ABBR_ERR_CHAR;\x0a"
"\x09}\x0a"
"\x09/*\x0a"
"\x09** Second, truncate long abbreviations.\x0a"
"\x09*/\x0a"
"\x09""for (i = 0; i < sp->typecnt; ++i) {\x0a"
"\x09\x09""const struct ttinfo *ttisp = \x26sp->ttis\x5bi\x5d;\x0a"
"\x09\x09""char *cp = \x26sp->chars\x5bttisp->tt_abbrind\x5d;\x0a"
"\x0a"
"\x09\x09if (strlen(cp) > TZ_ABBR_MAX_LEN \x26\x26\x0a"
"\x09\x09    strcmp(cp, GRANDPARENTED) \x21= 0)\x0a"
"\x09\x09\x09*(cp + TZ_ABBR_MAX_LEN) = '\x5c""0';\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"static int\x0a"
"differ_by_repeat(time_t t1, time_t t0)\x0a"
"{\x0a"
"\x09if (TYPE_BIT(time_t) - 1 < SECSPERREPEAT_BITS)\x0a"
"\x09\x09return 0;\x0a"
"\x09return (int64_t)t1 - t0 == SECSPERREPEAT;\x0a"
"}\x0a"
"\x0a"
"static int\x0a"
"tzload(const char *name, struct state *sp, int doextend)\x0a"
"{\x0a"
"\x09""const char *\x09\x09p;\x0a"
"\x09int\x09\x09\x09i;\x0a"
"\x09int\x09\x09\x09""fid;\x0a"
"\x09int\x09\x09\x09stored;\x0a"
"\x09int\x09\x09\x09nread;\x0a"
"\x09typedef union {\x0a"
"\x09\x09struct tzhead\x09tzhead;\x0a"
"\x09\x09""char\x09\x09""buf\x5b""2 * sizeof(struct tzhead) +\x0a"
"\x09\x09\x09\x09    2 * sizeof *sp +\x0a"
"\x09\x09\x09\x09    4 * TZ_MAX_TIMES\x5d;\x0a"
"\x09} u_t;\x0a"
"\x09u_t *\x09\x09\x09up;\x0a"
"\x09""char\x09\x09\x09""fullname\x5bPATH_MAX\x5d;\x0a"
"\x0a"
"\x09up = calloc(1, sizeof *up);\x0a"
"\x09if (up == NULL)\x0a"
"\x09\x09return -1;\x0a"
"\x0a"
"\x09sp->goback = sp->goahead = FALSE;\x0a"
"\x09if (name \x21= NULL \x26\x26 issetugid() \x21= 0) {\x0a"
"\x09\x09if ((name\x5b""0\x5d == '\x3a' \x26\x26 (strchr(name, '/') \x7c\x7c strstr(name, \x22..\x22))) \x7c\x7c\x0a"
"\x09\x09    name\x5b""0\x5d == '/' \x7c\x7c strchr(name, '.'))\x0a"
"\x09\x09\x09name = NULL;\x0a"
"\x09}\x0a"
"\x09if (name == NULL \x26\x26 (name = TZDEFAULT) == NULL)\x0a"
"\x09\x09goto oops;\x0a"
"\x0a"
"\x09if (name\x5b""0\x5d == '\x3a')\x0a"
"\x09\x09++name;\x0a"
"\x09if (name\x5b""0\x5d \x21= '/') {\x0a"
"\x09\x09if ((p = TZDIR) == NULL)\x0a"
"\x09\x09\x09goto oops;\x0a"
"\x09\x09if ((strlen(p) + strlen(name) + 1) >= sizeof fullname)\x0a"
"\x09\x09\x09goto oops;\x0a"
"\x09\x09strlcpy(fullname, p, sizeof fullname);\x0a"
"\x09\x09strlcat(fullname, \x22/\x22, sizeof fullname);\x0a"
"\x09\x09strlcat(fullname, name, sizeof fullname);\x0a"
"\x09\x09name = fullname;\x0a"
"\x09}\x0a"
"\x09if ((fid = open(name, O_RDONLY)) == -1)\x0a"
"\x09\x09goto oops;\x0a"
"\x0a"
"\x09nread = __libc_read(fid, up->buf, sizeof up->buf);\x0a"
"\x09if (__libc_close(fid) < 0 \x7c\x7c nread <= 0)\x0a"
"\x09\x09goto oops;\x0a"
"\x09""for (stored = 4; stored <= 8; stored *= 2) {\x0a"
"\x09\x09int\x09\x09ttisstdcnt;\x0a"
"\x09\x09int\x09\x09ttisgmtcnt;\x0a"
"\x0a"
"\x09\x09ttisstdcnt = (int) detzcode(up->tzhead.tzh_ttisstdcnt);\x0a"
"\x09\x09ttisgmtcnt = (int) detzcode(up->tzhead.tzh_ttisgmtcnt);\x0a"
"\x09\x09sp->leapcnt = (int) detzcode(up->tzhead.tzh_leapcnt);\x0a"
"\x09\x09sp->timecnt = (int) detzcode(up->tzhead.tzh_timecnt);\x0a"
"\x09\x09sp->typecnt = (int) detzcode(up->tzhead.tzh_typecnt);\x0a"
"\x09\x09sp->charcnt = (int) detzcode(up->tzhead.tzh_charcnt);\x0a"
"\x09\x09p = up->tzhead.tzh_charcnt + sizeof up->tzhead.tzh_charcnt;\x0a"
"\x09\x09if (sp->leapcnt < 0 \x7c\x7c sp->leapcnt > TZ_MAX_LEAPS \x7c\x7c\x0a"
"\x09\x09    sp->typecnt <= 0 \x7c\x7c sp->typecnt > TZ_MAX_TYPES \x7c\x7c\x0a"
"\x09\x09    sp->timecnt < 0 \x7c\x7c sp->timecnt > TZ_MAX_TIMES \x7c\x7c\x0a"
"\x09\x09    sp->charcnt < 0 \x7c\x7c sp->charcnt > TZ_MAX_CHARS \x7c\x7c\x0a"
"\x09\x09    (ttisstdcnt \x21= sp->typecnt \x26\x26 ttisstdcnt \x21= 0) \x7c\x7c\x0a"
"\x09\x09    (ttisgmtcnt \x21= sp->typecnt \x26\x26 ttisgmtcnt \x21= 0))\x0a"
"\x09\x09\x09goto oops;\x0a"
"\x09\x09if (nread - (p - up->buf) <\x0a"
"\x09\x09    sp->timecnt * stored +\x09\x09/* ats */\x0a"
"\x09\x09    sp->timecnt +\x09\x09\x09/* types */\x0a"
"\x09\x09    sp->typecnt * 6 +\x09\x09/* ttinfos */\x0a"
"\x09\x09    sp->charcnt +\x09\x09\x09/* chars */\x0a"
"\x09\x09    sp->leapcnt * (stored + 4) +\x09/* lsinfos */\x0a"
"\x09\x09    ttisstdcnt +\x09\x09\x09/* ttisstds */\x0a"
"\x09\x09    ttisgmtcnt)\x09\x09\x09/* ttisgmts */\x0a"
"\x09\x09\x09goto oops;\x0a"
"\x09\x09""for (i = 0; i < sp->timecnt; ++i) {\x0a"
"\x09\x09\x09sp->ats\x5bi\x5d = (stored == 4) \x3f\x0a"
"\x09\x09\x09    detzcode(p) \x3a detzcode64(p);\x0a"
"\x09\x09\x09p += stored;\x0a"
"\x09\x09}\x0a"
"\x09\x09""for (i = 0; i < sp->timecnt; ++i) {\x0a"
"\x09\x09\x09sp->types\x5bi\x5d = (unsigned char) *p++;\x0a"
"\x09\x09\x09if (sp->types\x5bi\x5d >= sp->typecnt)\x0a"
"\x09\x09\x09\x09goto oops;\x0a"
"\x09\x09}\x0a"
"\x09\x09""for (i = 0; i < sp->typecnt; ++i) {\x0a"
"\x09\x09\x09struct ttinfo *\x09ttisp;\x0a"
"\x0a"
"\x09\x09\x09ttisp = \x26sp->ttis\x5bi\x5d;\x0a"
"\x09\x09\x09ttisp->tt_gmtoff = detzcode(p);\x0a"
"\x09\x09\x09p += 4;\x0a"
"\x09\x09\x09ttisp->tt_isdst = (unsigned char) *p++;\x0a"
"\x09\x09\x09if (ttisp->tt_isdst \x21= 0 \x26\x26 ttisp->tt_isdst \x21= 1)\x0a"
"\x09\x09\x09\x09goto oops;\x0a"
"\x09\x09\x09ttisp->tt_abbrind = (unsigned char) *p++;\x0a"
"\x09\x09\x09if (ttisp->tt_abbrind < 0 \x7c\x7c\x0a"
"\x09\x09\x09    ttisp->tt_abbrind > sp->charcnt)\x0a"
"\x09\x09\x09\x09goto oops;\x0a"
"\x09\x09}\x0a"
"\x09\x09""for (i = 0; i < sp->charcnt; ++i)\x0a"
"\x09\x09\x09sp->chars\x5bi\x5d = *p++;\x0a"
"\x09\x09sp->chars\x5bi\x5d = '\x5c""0';\x09/* ensure '\x5c""0' at end */\x0a"
"\x09\x09""for (i = 0; i < sp->leapcnt; ++i) {\x0a"
"\x09\x09\x09struct lsinfo *\x09lsisp;\x0a"
"\x0a"
"\x09\x09\x09lsisp = \x26sp->lsis\x5bi\x5d;\x0a"
"\x09\x09\x09lsisp->ls_trans = (stored == 4) \x3f\x0a"
"\x09\x09\x09    detzcode(p) \x3a detzcode64(p);\x0a"
"\x09\x09\x09p += stored;\x0a"
"\x09\x09\x09lsisp->ls_corr = detzcode(p);\x0a"
"\x09\x09\x09p += 4;\x0a"
"\x09\x09}\x0a"
"\x09\x09""for (i = 0; i < sp->typecnt; ++i) {\x0a"
"\x09\x09\x09struct ttinfo *\x09ttisp;\x0a"
"\x0a"
"\x09\x09\x09ttisp = \x26sp->ttis\x5bi\x5d;\x0a"
"\x09\x09\x09if (ttisstdcnt == 0)\x0a"
"\x09\x09\x09\x09ttisp->tt_ttisstd = FALSE;\x0a"
"\x09\x09\x09""else {\x0a"
"\x09\x09\x09\x09ttisp->tt_ttisstd = *p++;\x0a"
"\x09\x09\x09\x09if (ttisp->tt_ttisstd \x21= TRUE \x26\x26\x0a"
"\x09\x09\x09\x09    ttisp->tt_ttisstd \x21= FALSE)\x0a"
"\x09\x09\x09\x09\x09goto oops;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09}\x0a"
"\x09\x09""for (i = 0; i < sp->typecnt; ++i) {\x0a"
"\x09\x09\x09struct ttinfo *\x09ttisp;\x0a"
"\x0a"
"\x09\x09\x09ttisp = \x26sp->ttis\x5bi\x5d;\x0a"
"\x09\x09\x09if (ttisgmtcnt == 0)\x0a"
"\x09\x09\x09\x09ttisp->tt_ttisgmt = FALSE;\x0a"
"\x09\x09\x09""else {\x0a"
"\x09\x09\x09\x09ttisp->tt_ttisgmt = *p++;\x0a"
"\x09\x09\x09\x09if (ttisp->tt_ttisgmt \x21= TRUE \x26\x26\x0a"
"\x09\x09\x09\x09    ttisp->tt_ttisgmt \x21= FALSE)\x0a"
"\x09\x09\x09\x09\x09goto oops;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09}\x0a"
"\x09\x09/*\x0a"
"\x09\x09** Out-of-sort ats should mean we're running on a\x0a"
"\x09\x09** signed time_t system but using a data file with\x0a"
"\x09\x09** unsigned values (or vice versa).\x0a"
"\x09\x09*/\x0a"
"\x09\x09""for (i = 0; i < sp->timecnt - 2; ++i)\x0a"
"\x09\x09\x09if (sp->ats\x5bi\x5d > sp->ats\x5bi + 1\x5d) {\x0a"
"\x09\x09\x09\x09++i;\x0a"
"\x09\x09\x09\x09/*\x0a"
"\x09\x09\x09\x09** Ignore the end (easy).\x0a"
"\x09\x09\x09\x09*/\x0a"
"\x09\x09\x09\x09sp->timecnt = i;\x0a"
"\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09/*\x0a"
"\x09\x09** If this is an old file, we're done.\x0a"
"\x09\x09*/\x0a"
"\x09\x09if (up->tzhead.tzh_version\x5b""0\x5d == '\x5c""0')\x0a"
"\x09\x09\x09""break;\x0a"
"\x09\x09nread -= p - up->buf;\x0a"
"\x09\x09""for (i = 0; i < nread; ++i)\x0a"
"\x09\x09\x09up->buf\x5bi\x5d = p\x5bi\x5d;\x0a"
"\x09\x09/*\x0a"
"\x09\x09** If this is a narrow integer time_t system, we're done.\x0a"
"\x09\x09*/\x0a"
"\x09\x09if (stored >= sizeof(time_t))\x0a"
"\x09\x09\x09""break;\x0a"
"\x09}\x0a"
"\x09if (doextend \x26\x26 nread > 2 \x26\x26\x0a"
"\x09    up->buf\x5b""0\x5d == '\x5cn' \x26\x26 up->buf\x5bnread - 1\x5d == '\x5cn' \x26\x26\x0a"
"\x09    sp->typecnt + 2 <= TZ_MAX_TYPES) {\x0a"
"\x09\x09struct state\x09ts;\x0a"
"\x09\x09int\x09result;\x0a"
"\x0a"
"\x09\x09up->buf\x5bnread - 1\x5d = '\x5c""0';\x0a"
"\x09\x09result = tzparse(\x26up->buf\x5b""1\x5d, \x26ts, FALSE);\x0a"
"\x09\x09if (result == 0 \x26\x26 ts.typecnt == 2 \x26\x26\x0a"
"\x09\x09    sp->charcnt + ts.charcnt <= TZ_MAX_CHARS) {\x0a"
"\x09\x09\x09""for (i = 0; i < 2; ++i)\x0a"
"\x09\x09\x09\x09ts.ttis\x5bi\x5d.tt_abbrind +=\x0a"
"\x09\x09\x09\x09    sp->charcnt;\x0a"
"\x09\x09\x09""for (i = 0; i < ts.charcnt; ++i)\x0a"
"\x09\x09\x09\x09sp->chars\x5bsp->charcnt++\x5d =\x0a"
"\x09\x09\x09\x09    ts.chars\x5bi\x5d;\x0a"
"\x09\x09\x09i = 0;\x0a"
"\x09\x09\x09while (i < ts.timecnt \x26\x26\x0a"
"\x09\x09\x09    ts.ats\x5bi\x5d <=\x0a"
"\x09\x09\x09    sp->ats\x5bsp->timecnt - 1\x5d)\x0a"
"\x09\x09\x09\x09++i;\x0a"
"\x09\x09\x09while (i < ts.timecnt \x26\x26\x0a"
"\x09\x09\x09    sp->timecnt < TZ_MAX_TIMES) {\x0a"
"\x09\x09\x09\x09sp->ats\x5bsp->timecnt\x5d =\x0a"
"\x09\x09\x09\x09    ts.ats\x5bi\x5d;\x0a"
"\x09\x09\x09\x09sp->types\x5bsp->timecnt\x5d =\x0a"
"\x09\x09\x09\x09    sp->typecnt +\x0a"
"\x09\x09\x09\x09    ts.types\x5bi\x5d;\x0a"
"\x09\x09\x09\x09++sp->timecnt;\x0a"
"\x09\x09\x09\x09++i;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09\x09sp->ttis\x5bsp->typecnt++\x5d = ts.ttis\x5b""0\x5d;\x0a"
"\x09\x09\x09sp->ttis\x5bsp->typecnt++\x5d = ts.ttis\x5b""1\x5d;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09if (sp->timecnt > 1) {\x0a"
"\x09\x09""for (i = 1; i < sp->timecnt; ++i) {\x0a"
"\x09\x09\x09if (typesequiv(sp, sp->types\x5bi\x5d, sp->types\x5b""0\x5d) \x26\x26\x0a"
"\x09\x09\x09    differ_by_repeat(sp->ats\x5bi\x5d, sp->ats\x5b""0\x5d)) {\x0a"
"\x09\x09\x09\x09sp->goback = TRUE;\x0a"
"\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09}\x0a"
"\x09\x09""for (i = sp->timecnt - 2; i >= 0; --i) {\x0a"
"\x09\x09\x09if (typesequiv(sp, sp->types\x5bsp->timecnt - 1\x5d,\x0a"
"\x09\x09\x09    sp->types\x5bi\x5d) \x26\x26\x0a"
"\x09\x09\x09    differ_by_repeat(sp->ats\x5bsp->timecnt - 1\x5d,\x0a"
"\x09\x09\x09    sp->ats\x5bi\x5d)) {\x0a"
"\x09\x09\x09\x09sp->goahead = TRUE;\x0a"
"\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09""free(up);\x0a"
"\x09return 0;\x0a"
"oops\x3a\x0a"
"\x09""free(up);\x0a"
"\x09return -1;\x0a"
"}\x0a"
"\x0a"
"static int\x0a"
"typesequiv(const struct state *sp, int a, int b)\x0a"
"{\x0a"
"\x09int\x09result;\x0a"
"\x0a"
"\x09if (sp == NULL \x7c\x7c\x0a"
"\x09    a < 0 \x7c\x7c a >= sp->typecnt \x7c\x7c\x0a"
"\x09    b < 0 \x7c\x7c b >= sp->typecnt)\x0a"
"\x09\x09result = FALSE;\x0a"
"\x09""else {\x0a"
"\x09\x09""const struct ttinfo *\x09""ap = \x26sp->ttis\x5b""a\x5d;\x0a"
"\x09\x09""const struct ttinfo *\x09""bp = \x26sp->ttis\x5b""b\x5d;\x0a"
"\x09\x09result = ap->tt_gmtoff == bp->tt_gmtoff \x26\x26\x0a"
"\x09\x09    ap->tt_isdst == bp->tt_isdst \x26\x26\x0a"
"\x09\x09    ap->tt_ttisstd == bp->tt_ttisstd \x26\x26\x0a"
"\x09\x09    ap->tt_ttisgmt == bp->tt_ttisgmt \x26\x26\x0a"
"\x09\x09    strcmp(\x26sp->chars\x5b""ap->tt_abbrind\x5d,\x0a"
"\x09\x09    \x26sp->chars\x5b""bp->tt_abbrind\x5d) == 0;\x0a"
"\x09}\x0a"
"\x09return result;\x0a"
"}\x0a"
"\x0a"
"static const int\x09mon_lengths\x5b""2\x5d\x5bMONSPERYEAR\x5d = {\x0a"
"\x09{ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 },\x0a"
"\x09{ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 }\x0a"
"};\x0a"
"\x0a"
"static const int\x09year_lengths\x5b""2\x5d = {\x0a"
"\x09""DAYSPERNYEAR, DAYSPERLYEAR\x0a"
"};\x0a"
"\x0a"
"/*\x0a"
"** Given a pointer into a time zone string, scan until a character that is not\x0a"
"** a valid character in a zone name is found. Return a pointer to that\x0a"
"** character.\x0a"
"*/\x0a"
"\x0a"
"static const char *\x0a"
"getzname(const char *strp)\x0a"
"{\x0a"
"\x09""char\x09""c;\x0a"
"\x0a"
"\x09while ((c = *strp) \x21= '\x5c""0' \x26\x26 \x21isdigit((unsigned char)c) \x26\x26 c \x21= ',' \x26\x26 c \x21= '-' \x26\x26\x0a"
"\x09    c \x21= '+')\x0a"
"\x09\x09++strp;\x0a"
"\x09return strp;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** Given a pointer into an extended time zone string, scan until the ending\x0a"
"** delimiter of the zone name is located. Return a pointer to the delimiter.\x0a"
"**\x0a"
"** As with getzname above, the legal character set is actually quite\x0a"
"** restricted, with other characters producing undefined results.\x0a"
"** We don't do any checking here; checking is done later in common-case code.\x0a"
"*/\x0a"
"\x0a"
"static const char *\x0a"
"getqzname(const char *strp, const int delim)\x0a"
"{\x0a"
"\x09int\x09""c;\x0a"
"\x0a"
"\x09while ((c = *strp) \x21= '\x5c""0' \x26\x26 c \x21= delim)\x0a"
"\x09\x09++strp;\x0a"
"\x09return strp;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** Given a pointer into a time zone string, extract a number from that string.\x0a"
"** Check that the number is within a specified range; if it is not, return\x0a"
"** NULL.\x0a"
"** Otherwise, return a pointer to the first character not part of the number.\x0a"
"*/\x0a"
"\x0a"
"static const char *\x0a"
"getnum(const char *strp, int *nump, int min, int max)\x0a"
"{\x0a"
"\x09""char\x09""c;\x0a"
"\x09int\x09num;\x0a"
"\x0a"
"\x09if (strp == NULL \x7c\x7c \x21isdigit((unsigned char)(c = *strp)))\x0a"
"\x09\x09return NULL;\x0a"
"\x09num = 0;\x0a"
"\x09""do {\x0a"
"\x09\x09num = num * 10 + (c - '0');\x0a"
"\x09\x09if (num > max)\x0a"
"\x09\x09\x09return NULL;\x09/* illegal value */\x0a"
"\x09\x09""c = *++strp;\x0a"
"\x09} while (isdigit((unsigned char)c));\x0a"
"\x09if (num < min)\x0a"
"\x09\x09return NULL;\x09\x09/* illegal value */\x0a"
"\x09*nump = num;\x0a"
"\x09return strp;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** Given a pointer into a time zone string, extract a number of seconds,\x0a"
"** in hh\x5b\x3amm\x5b\x3ass\x5d\x5d form, from the string.\x0a"
"** If any error occurs, return NULL.\x0a"
"** Otherwise, return a pointer to the first character not part of the number\x0a"
"** of seconds.\x0a"
"*/\x0a"
"\x0a"
"static const char *\x0a"
"getsecs(const char *strp, long *secsp)\x0a"
"{\x0a"
"\x09int\x09num;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09** \x60HOURSPERDAY * DAYSPERWEEK - 1' allows quasi-Posix rules like\x0a"
"\x09** \x22M10.4.6/26\x22, which does not conform to Posix,\x0a"
"\x09** but which specifies the equivalent of\x0a"
"\x09** \x60\x60""02\x3a""00 on the first Sunday on or after 23 Oct''.\x0a"
"\x09*/\x0a"
"\x09strp = getnum(strp, \x26num, 0, HOURSPERDAY * DAYSPERWEEK - 1);\x0a"
"\x09if (strp == NULL)\x0a"
"\x09\x09return NULL;\x0a"
"\x09*secsp = num * (long) SECSPERHOUR;\x0a"
"\x09if (*strp == '\x3a') {\x0a"
"\x09\x09++strp;\x0a"
"\x09\x09strp = getnum(strp, \x26num, 0, MINSPERHOUR - 1);\x0a"
"\x09\x09if (strp == NULL)\x0a"
"\x09\x09\x09return NULL;\x0a"
"\x09\x09*secsp += num * SECSPERMIN;\x0a"
"\x09\x09if (*strp == '\x3a') {\x0a"
"\x09\x09\x09++strp;\x0a"
"\x09\x09\x09/* \x60SECSPERMIN' allows for leap seconds. */\x0a"
"\x09\x09\x09strp = getnum(strp, \x26num, 0, SECSPERMIN);\x0a"
"\x09\x09\x09if (strp == NULL)\x0a"
"\x09\x09\x09\x09return NULL;\x0a"
"\x09\x09\x09*secsp += num;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09return strp;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** Given a pointer into a time zone string, extract an offset, in\x0a"
"** \x5b+-\x5dhh\x5b\x3amm\x5b\x3ass\x5d\x5d form, from the string.\x0a"
"** If any error occurs, return NULL.\x0a"
"** Otherwise, return a pointer to the first character not part of the time.\x0a"
"*/\x0a"
"\x0a"
"static const char *\x0a"
"getoffset(const char *strp, long *offsetp)\x0a"
"{\x0a"
"\x09int\x09neg = 0;\x0a"
"\x0a"
"\x09if (*strp == '-') {\x0a"
"\x09\x09neg = 1;\x0a"
"\x09\x09++strp;\x0a"
"\x09} else if (*strp == '+')\x0a"
"\x09\x09++strp;\x0a"
"\x09strp = getsecs(strp, offsetp);\x0a"
"\x09if (strp == NULL)\x0a"
"\x09\x09return NULL;\x09\x09/* illegal time */\x0a"
"\x09if (neg)\x0a"
"\x09\x09*offsetp = -*offsetp;\x0a"
"\x09return strp;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** Given a pointer into a time zone string, extract a rule in the form\x0a"
"** date\x5b/time\x5d. See POSIX section 8 for the format of \x22""date\x22 and \x22time\x22.\x0a"
"** If a valid rule is not found, return NULL.\x0a"
"** Otherwise, return a pointer to the first character not part of the rule.\x0a"
"*/\x0a"
"\x0a"
"static const char *\x0a"
"getrule(const char *strp, struct rule *rulep)\x0a"
"{\x0a"
"\x09if (*strp == 'J') {\x0a"
"\x09\x09/*\x0a"
"\x09\x09** Julian day.\x0a"
"\x09\x09*/\x0a"
"\x09\x09rulep->r_type = JULIAN_DAY;\x0a"
"\x09\x09++strp;\x0a"
"\x09\x09strp = getnum(strp, \x26rulep->r_day, 1, DAYSPERNYEAR);\x0a"
"\x09} else if (*strp == 'M') {\x0a"
"\x09\x09/*\x0a"
"\x09\x09** Month, week, day.\x0a"
"\x09\x09*/\x0a"
"\x09\x09rulep->r_type = MONTH_NTH_DAY_OF_WEEK;\x0a"
"\x09\x09++strp;\x0a"
"\x09\x09strp = getnum(strp, \x26rulep->r_mon, 1, MONSPERYEAR);\x0a"
"\x09\x09if (strp == NULL)\x0a"
"\x09\x09\x09return NULL;\x0a"
"\x09\x09if (*strp++ \x21= '.')\x0a"
"\x09\x09\x09return NULL;\x0a"
"\x09\x09strp = getnum(strp, \x26rulep->r_week, 1, 5);\x0a"
"\x09\x09if (strp == NULL)\x0a"
"\x09\x09\x09return NULL;\x0a"
"\x09\x09if (*strp++ \x21= '.')\x0a"
"\x09\x09\x09return NULL;\x0a"
"\x09\x09strp = getnum(strp, \x26rulep->r_day, 0, DAYSPERWEEK - 1);\x0a"
"\x09} else if (isdigit((unsigned char)*strp)) {\x0a"
"\x09\x09/*\x0a"
"\x09\x09** Day of year.\x0a"
"\x09\x09*/\x0a"
"\x09\x09rulep->r_type = DAY_OF_YEAR;\x0a"
"\x09\x09strp = getnum(strp, \x26rulep->r_day, 0, DAYSPERLYEAR - 1);\x0a"
"\x09} else\x0a"
"\x09\x09return NULL;\x09\x09/* invalid format */\x0a"
"\x09if (strp == NULL)\x0a"
"\x09\x09return NULL;\x0a"
"\x09if (*strp == '/') {\x0a"
"\x09\x09/*\x0a"
"\x09\x09** Time specified.\x0a"
"\x09\x09*/\x0a"
"\x09\x09++strp;\x0a"
"\x09\x09strp = getsecs(strp, \x26rulep->r_time);\x0a"
"\x09} else\x0a"
"\x09\x09rulep->r_time = 2 * SECSPERHOUR;\x09/* default = 2\x3a""00\x3a""00 */\x0a"
"\x09return strp;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** Given the Epoch-relative time of January 1, 00\x3a""00\x3a""00 UTC, in a year, the\x0a"
"** year, a rule, and the offset from UTC at the time that rule takes effect,\x0a"
"** calculate the Epoch-relative time that rule takes effect.\x0a"
"*/\x0a"
"\x0a"
"static time_t\x0a"
"transtime(time_t janfirst, int year, const struct rule *rulep, long offset)\x0a"
"{\x0a"
"\x09int\x09leapyear;\x0a"
"\x09time_t\x09value;\x0a"
"\x09int\x09i;\x0a"
"\x09int\x09\x09""d, m1, yy0, yy1, yy2, dow;\x0a"
"\x0a"
"\x09value = 0;\x0a"
"\x09leapyear = isleap(year);\x0a"
"\x09switch (rulep->r_type) {\x0a"
"\x0a"
"\x09""case JULIAN_DAY\x3a\x0a"
"\x09\x09/*\x0a"
"\x09\x09** Jn - Julian day, 1 == January 1, 60 == March 1 even in leap\x0a"
"\x09\x09** years.\x0a"
"\x09\x09** In non-leap years, or if the day number is 59 or less, just\x0a"
"\x09\x09** add SECSPERDAY times the day number-1 to the time of\x0a"
"\x09\x09** January 1, midnight, to get the day.\x0a"
"\x09\x09*/\x0a"
"\x09\x09value = janfirst + (rulep->r_day - 1) * SECSPERDAY;\x0a"
"\x09\x09if (leapyear \x26\x26 rulep->r_day >= 60)\x0a"
"\x09\x09\x09value += SECSPERDAY;\x0a"
"\x09\x09""break;\x0a"
"\x0a"
"\x09""case DAY_OF_YEAR\x3a\x0a"
"\x09\x09/*\x0a"
"\x09\x09** n - day of year.\x0a"
"\x09\x09** Just add SECSPERDAY times the day number to the time of\x0a"
"\x09\x09** January 1, midnight, to get the day.\x0a"
"\x09\x09*/\x0a"
"\x09\x09value = janfirst + rulep->r_day * SECSPERDAY;\x0a"
"\x09\x09""break;\x0a"
"\x0a"
"\x09""case MONTH_NTH_DAY_OF_WEEK\x3a\x0a"
"\x09\x09/*\x0a"
"\x09\x09** Mm.n.d - nth \x22""dth day\x22 of month m.\x0a"
"\x09\x09*/\x0a"
"\x09\x09value = janfirst;\x0a"
"\x09\x09""for (i = 0; i < rulep->r_mon - 1; ++i)\x0a"
"\x09\x09\x09value += mon_lengths\x5bleapyear\x5d\x5bi\x5d * SECSPERDAY;\x0a"
"\x0a"
"\x09\x09/*\x0a"
"\x09\x09** Use Zeller's Congruence to get day-of-week of first day of\x0a"
"\x09\x09** month.\x0a"
"\x09\x09*/\x0a"
"\x09\x09m1 = (rulep->r_mon + 9) \x25 12 + 1;\x0a"
"\x09\x09yy0 = (rulep->r_mon <= 2) \x3f (year - 1) \x3a year;\x0a"
"\x09\x09yy1 = yy0 / 100;\x0a"
"\x09\x09yy2 = yy0 \x25 100;\x0a"
"\x09\x09""dow = ((26 * m1 - 2) / 10 +\x0a"
"\x09\x09    1 + yy2 + yy2 / 4 + yy1 / 4 - 2 * yy1) \x25 7;\x0a"
"\x09\x09if (dow < 0)\x0a"
"\x09\x09\x09""dow += DAYSPERWEEK;\x0a"
"\x0a"
"\x09\x09/*\x0a"
"\x09\x09** \x22""dow\x22 is the day-of-week of the first day of the month. Get\x0a"
"\x09\x09** the day-of-month (zero-origin) of the first \x22""dow\x22 day of the\x0a"
"\x09\x09** month.\x0a"
"\x09\x09*/\x0a"
"\x09\x09""d = rulep->r_day - dow;\x0a"
"\x09\x09if (d < 0)\x0a"
"\x09\x09\x09""d += DAYSPERWEEK;\x0a"
"\x09\x09""for (i = 1; i < rulep->r_week; ++i) {\x0a"
"\x09\x09\x09if (d + DAYSPERWEEK >=\x0a"
"\x09\x09\x09    mon_lengths\x5bleapyear\x5d\x5brulep->r_mon - 1\x5d)\x0a"
"\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09""d += DAYSPERWEEK;\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09\x09/*\x0a"
"\x09\x09** \x22""d\x22 is the day-of-month (zero-origin) of the day we want.\x0a"
"\x09\x09*/\x0a"
"\x09\x09value += d * SECSPERDAY;\x0a"
"\x09\x09""break;\x0a"
"\x09}\x0a"
"\x0a"
"\x09/*\x0a"
"\x09** \x22value\x22 is the Epoch-relative time of 00\x3a""00\x3a""00 UTC on the day in\x0a"
"\x09** question. To get the Epoch-relative time of the specified local\x0a"
"\x09** time on that day, add the transition time and the current offset\x0a"
"\x09** from UTC.\x0a"
"\x09*/\x0a"
"\x09return value + rulep->r_time + offset;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** Given a POSIX section 8-style TZ string, fill in the rule tables as\x0a"
"** appropriate.\x0a"
"*/\x0a"
"\x0a"
"static int\x0a"
"tzparse(const char *name, struct state *sp, int lastditch)\x0a"
"{\x0a"
"\x09""const char *\x09\x09\x09stdname;\x0a"
"\x09""const char *\x09\x09\x09""dstname;\x0a"
"\x09size_t\x09\x09\x09\x09stdlen;\x0a"
"\x09size_t\x09\x09\x09\x09""dstlen;\x0a"
"\x09long\x09\x09\x09\x09stdoffset;\x0a"
"\x09long\x09\x09\x09\x09""dstoffset;\x0a"
"\x09time_t *\x09\x09""atp;\x0a"
"\x09unsigned char *\x09typep;\x0a"
"\x09""char *\x09\x09\x09""cp;\x0a"
"\x09int\x09\x09\x09load_result;\x0a"
"\x09static struct ttinfo\x09\x09zttinfo;\x0a"
"\x0a"
"\x09""dstname = NULL;\x0a"
"\x09stdname = name;\x0a"
"\x09if (lastditch) {\x0a"
"\x09\x09stdlen = strlen(name);\x09/* length of standard zone name */\x0a"
"\x09\x09name += stdlen;\x0a"
"\x09\x09if (stdlen >= sizeof sp->chars)\x0a"
"\x09\x09\x09stdlen = (sizeof sp->chars) - 1;\x0a"
"\x09\x09stdoffset = 0;\x0a"
"\x09} else {\x0a"
"\x09\x09if (*name == '<') {\x0a"
"\x09\x09\x09name++;\x0a"
"\x09\x09\x09stdname = name;\x0a"
"\x09\x09\x09name = getqzname(name, '>');\x0a"
"\x09\x09\x09if (*name \x21= '>')\x0a"
"\x09\x09\x09\x09return (-1);\x0a"
"\x09\x09\x09stdlen = name - stdname;\x0a"
"\x09\x09\x09name++;\x0a"
"\x09\x09} else {\x0a"
"\x09\x09\x09name = getzname(name);\x0a"
"\x09\x09\x09stdlen = name - stdname;\x0a"
"\x09\x09}\x0a"
"\x09\x09if (*name == '\x5c""0')\x0a"
"\x09\x09\x09return -1;\x0a"
"\x09\x09name = getoffset(name, \x26stdoffset);\x0a"
"\x09\x09if (name == NULL)\x0a"
"\x09\x09\x09return -1;\x0a"
"\x09}\x0a"
"\x09load_result = tzload(TZDEFRULES, sp, FALSE);\x0a"
"\x09if (load_result \x21= 0)\x0a"
"\x09\x09sp->leapcnt = 0;\x09\x09/* so, we're off a little */\x0a"
"\x09if (*name \x21= '\x5c""0') {\x0a"
"\x09\x09if (*name == '<') {\x0a"
"\x09\x09\x09""dstname = ++name;\x0a"
"\x09\x09\x09name = getqzname(name, '>');\x0a"
"\x09\x09\x09if (*name \x21= '>')\x0a"
"\x09\x09\x09\x09return -1;\x0a"
"\x09\x09\x09""dstlen = name - dstname;\x0a"
"\x09\x09\x09name++;\x0a"
"\x09\x09} else {\x0a"
"\x09\x09\x09""dstname = name;\x0a"
"\x09\x09\x09name = getzname(name);\x0a"
"\x09\x09\x09""dstlen = name - dstname; /* length of DST zone name */\x0a"
"\x09\x09}\x0a"
"\x09\x09if (*name \x21= '\x5c""0' \x26\x26 *name \x21= ',' \x26\x26 *name \x21= ';') {\x0a"
"\x09\x09\x09name = getoffset(name, \x26""dstoffset);\x0a"
"\x09\x09\x09if (name == NULL)\x0a"
"\x09\x09\x09\x09return -1;\x0a"
"\x09\x09} else\x0a"
"\x09\x09\x09""dstoffset = stdoffset - SECSPERHOUR;\x0a"
"\x09\x09if (*name == '\x5c""0' \x26\x26 load_result \x21= 0)\x0a"
"\x09\x09\x09name = TZDEFRULESTRING;\x0a"
"\x09\x09if (*name == ',' \x7c\x7c *name == ';') {\x0a"
"\x09\x09\x09struct rule\x09start;\x0a"
"\x09\x09\x09struct rule\x09""end;\x0a"
"\x09\x09\x09int\x09\x09year;\x0a"
"\x09\x09\x09time_t\x09\x09janfirst;\x0a"
"\x09\x09\x09time_t\x09\x09starttime;\x0a"
"\x09\x09\x09time_t\x09\x09""endtime;\x0a"
"\x0a"
"\x09\x09\x09++name;\x0a"
"\x09\x09\x09if ((name = getrule(name, \x26start)) == NULL)\x0a"
"\x09\x09\x09\x09return -1;\x0a"
"\x09\x09\x09if (*name++ \x21= ',')\x0a"
"\x09\x09\x09\x09return -1;\x0a"
"\x09\x09\x09if ((name = getrule(name, \x26""end)) == NULL)\x0a"
"\x09\x09\x09\x09return -1;\x0a"
"\x09\x09\x09if (*name \x21= '\x5c""0')\x0a"
"\x09\x09\x09\x09return -1;\x0a"
"\x09\x09\x09sp->typecnt = 2;\x09/* standard time and DST */\x0a"
"\x09\x09\x09/*\x0a"
"\x09\x09\x09** Two transitions per year, from EPOCH_YEAR forward.\x0a"
"\x09\x09\x09*/\x0a"
"\x09\x09\x09sp->ttis\x5b""0\x5d = sp->ttis\x5b""1\x5d = zttinfo;\x0a"
"\x09\x09\x09sp->ttis\x5b""0\x5d.tt_gmtoff = -dstoffset;\x0a"
"\x09\x09\x09sp->ttis\x5b""0\x5d.tt_isdst = 1;\x0a"
"\x09\x09\x09sp->ttis\x5b""0\x5d.tt_abbrind = stdlen + 1;\x0a"
"\x09\x09\x09sp->ttis\x5b""1\x5d.tt_gmtoff = -stdoffset;\x0a"
"\x09\x09\x09sp->ttis\x5b""1\x5d.tt_isdst = 0;\x0a"
"\x09\x09\x09sp->ttis\x5b""1\x5d.tt_abbrind = 0;\x0a"
"\x09\x09\x09""atp = sp->ats;\x0a"
"\x09\x09\x09typep = sp->types;\x0a"
"\x09\x09\x09janfirst = 0;\x0a"
"\x09\x09\x09sp->timecnt = 0;\x0a"
"\x09\x09\x09""for (year = EPOCH_YEAR;\x0a"
"\x09\x09\x09    sp->timecnt + 2 <= TZ_MAX_TIMES;\x0a"
"\x09\x09\x09    ++year) {\x0a"
"\x09\x09\x09    \x09time_t\x09newfirst;\x0a"
"\x0a"
"\x09\x09\x09\x09starttime = transtime(janfirst, year, \x26start,\x0a"
"\x09\x09\x09\x09    stdoffset);\x0a"
"\x09\x09\x09\x09""endtime = transtime(janfirst, year, \x26""end,\x0a"
"\x09\x09\x09\x09    dstoffset);\x0a"
"\x09\x09\x09\x09if (starttime > endtime) {\x0a"
"\x09\x09\x09\x09\x09*atp++ = endtime;\x0a"
"\x09\x09\x09\x09\x09*typep++ = 1;\x09/* DST ends */\x0a"
"\x09\x09\x09\x09\x09*atp++ = starttime;\x0a"
"\x09\x09\x09\x09\x09*typep++ = 0;\x09/* DST begins */\x0a"
"\x09\x09\x09\x09} else {\x0a"
"\x09\x09\x09\x09\x09*atp++ = starttime;\x0a"
"\x09\x09\x09\x09\x09*typep++ = 0;\x09/* DST begins */\x0a"
"\x09\x09\x09\x09\x09*atp++ = endtime;\x0a"
"\x09\x09\x09\x09\x09*typep++ = 1;\x09/* DST ends */\x0a"
"\x09\x09\x09\x09}\x0a"
"\x09\x09\x09\x09sp->timecnt += 2;\x0a"
"\x09\x09\x09\x09newfirst = janfirst;\x0a"
"\x09\x09\x09\x09newfirst += year_lengths\x5bisleap(year)\x5d *\x0a"
"\x09\x09\x09\x09    SECSPERDAY;\x0a"
"\x09\x09\x09\x09if (newfirst <= janfirst)\x0a"
"\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09janfirst = newfirst;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09} else {\x0a"
"\x09\x09\x09long\x09theirstdoffset;\x0a"
"\x09\x09\x09long\x09theirdstoffset;\x0a"
"\x09\x09\x09long\x09theiroffset;\x0a"
"\x09\x09\x09int\x09isdst;\x0a"
"\x09\x09\x09int\x09i;\x0a"
"\x09\x09\x09int\x09j;\x0a"
"\x0a"
"\x09\x09\x09if (*name \x21= '\x5c""0')\x0a"
"\x09\x09\x09\x09return -1;\x0a"
"\x09\x09\x09/*\x0a"
"\x09\x09\x09** Initial values of theirstdoffset and theirdstoffset.\x0a"
"\x09\x09\x09*/\x0a"
"\x09\x09\x09theirstdoffset = 0;\x0a"
"\x09\x09\x09""for (i = 0; i < sp->timecnt; ++i) {\x0a"
"\x09\x09\x09\x09j = sp->types\x5bi\x5d;\x0a"
"\x09\x09\x09\x09if (\x21sp->ttis\x5bj\x5d.tt_isdst) {\x0a"
"\x09\x09\x09\x09\x09theirstdoffset =\x0a"
"\x09\x09\x09\x09\x09\x09-sp->ttis\x5bj\x5d.tt_gmtoff;\x0a"
"\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09}\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09\x09theirdstoffset = 0;\x0a"
"\x09\x09\x09""for (i = 0; i < sp->timecnt; ++i) {\x0a"
"\x09\x09\x09\x09j = sp->types\x5bi\x5d;\x0a"
"\x09\x09\x09\x09if (sp->ttis\x5bj\x5d.tt_isdst) {\x0a"
"\x09\x09\x09\x09\x09theirdstoffset =\x0a"
"\x09\x09\x09\x09\x09\x09-sp->ttis\x5bj\x5d.tt_gmtoff;\x0a"
"\x09\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09\x09}\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09\x09/*\x0a"
"\x09\x09\x09** Initially we're assumed to be in standard time.\x0a"
"\x09\x09\x09*/\x0a"
"\x09\x09\x09isdst = FALSE;\x0a"
"\x09\x09\x09theiroffset = theirstdoffset;\x0a"
"\x09\x09\x09/*\x0a"
"\x09\x09\x09** Now juggle transition times and types\x0a"
"\x09\x09\x09** tracking offsets as you do.\x0a"
"\x09\x09\x09*/\x0a"
"\x09\x09\x09""for (i = 0; i < sp->timecnt; ++i) {\x0a"
"\x09\x09\x09\x09j = sp->types\x5bi\x5d;\x0a"
"\x09\x09\x09\x09sp->types\x5bi\x5d = sp->ttis\x5bj\x5d.tt_isdst;\x0a"
"\x09\x09\x09\x09if (sp->ttis\x5bj\x5d.tt_ttisgmt) {\x0a"
"\x09\x09\x09\x09\x09/* No adjustment to transition time */\x0a"
"\x09\x09\x09\x09} else {\x0a"
"\x09\x09\x09\x09\x09/*\x0a"
"\x09\x09\x09\x09\x09** If summer time is in effect, and the\x0a"
"\x09\x09\x09\x09\x09** transition time was not specified as\x0a"
"\x09\x09\x09\x09\x09** standard time, add the summer time\x0a"
"\x09\x09\x09\x09\x09** offset to the transition time;\x0a"
"\x09\x09\x09\x09\x09** otherwise, add the standard time\x0a"
"\x09\x09\x09\x09\x09** offset to the transition time.\x0a"
"\x09\x09\x09\x09\x09*/\x0a"
"\x09\x09\x09\x09\x09/*\x0a"
"\x09\x09\x09\x09\x09** Transitions from DST to DDST\x0a"
"\x09\x09\x09\x09\x09** will effectively disappear since\x0a"
"\x09\x09\x09\x09\x09** POSIX provides for only one DST\x0a"
"\x09\x09\x09\x09\x09** offset.\x0a"
"\x09\x09\x09\x09\x09*/\x0a"
"\x09\x09\x09\x09\x09if (isdst \x26\x26 \x21sp->ttis\x5bj\x5d.tt_ttisstd) {\x0a"
"\x09\x09\x09\x09\x09\x09sp->ats\x5bi\x5d += dstoffset -\x0a"
"\x09\x09\x09\x09\x09\x09    theirdstoffset;\x0a"
"\x09\x09\x09\x09\x09} else {\x0a"
"\x09\x09\x09\x09\x09\x09sp->ats\x5bi\x5d += stdoffset -\x0a"
"\x09\x09\x09\x09\x09\x09    theirstdoffset;\x0a"
"\x09\x09\x09\x09\x09}\x0a"
"\x09\x09\x09\x09}\x0a"
"\x09\x09\x09\x09theiroffset = -sp->ttis\x5bj\x5d.tt_gmtoff;\x0a"
"\x09\x09\x09\x09if (sp->ttis\x5bj\x5d.tt_isdst)\x0a"
"\x09\x09\x09\x09\x09theirdstoffset = theiroffset;\x0a"
"\x09\x09\x09\x09""else\x0a"
"\x09\x09\x09\x09\x09theirstdoffset = theiroffset;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09\x09/*\x0a"
"\x09\x09\x09** Finally, fill in ttis.\x0a"
"\x09\x09\x09*/\x0a"
"\x09\x09\x09sp->ttis\x5b""0\x5d = sp->ttis\x5b""1\x5d = zttinfo;\x0a"
"\x09\x09\x09sp->ttis\x5b""0\x5d.tt_gmtoff = -stdoffset;\x0a"
"\x09\x09\x09sp->ttis\x5b""0\x5d.tt_isdst = FALSE;\x0a"
"\x09\x09\x09sp->ttis\x5b""0\x5d.tt_abbrind = 0;\x0a"
"\x09\x09\x09sp->ttis\x5b""1\x5d.tt_gmtoff = -dstoffset;\x0a"
"\x09\x09\x09sp->ttis\x5b""1\x5d.tt_isdst = TRUE;\x0a"
"\x09\x09\x09sp->ttis\x5b""1\x5d.tt_abbrind = stdlen + 1;\x0a"
"\x09\x09\x09sp->typecnt = 2;\x0a"
"\x09\x09}\x0a"
"\x09} else {\x0a"
"\x09\x09""dstlen = 0;\x0a"
"\x09\x09sp->typecnt = 1;\x09\x09/* only standard time */\x0a"
"\x09\x09sp->timecnt = 0;\x0a"
"\x09\x09sp->ttis\x5b""0\x5d = zttinfo;\x0a"
"\x09\x09sp->ttis\x5b""0\x5d.tt_gmtoff = -stdoffset;\x0a"
"\x09\x09sp->ttis\x5b""0\x5d.tt_isdst = 0;\x0a"
"\x09\x09sp->ttis\x5b""0\x5d.tt_abbrind = 0;\x0a"
"\x09}\x0a"
"\x09sp->charcnt = stdlen + 1;\x0a"
"\x09if (dstlen \x21= 0)\x0a"
"\x09\x09sp->charcnt += dstlen + 1;\x0a"
"\x09if ((size_t) sp->charcnt > sizeof sp->chars)\x0a"
"\x09\x09return -1;\x0a"
"\x09""cp = sp->chars;\x0a"
"\x09strlcpy(cp, stdname, stdlen + 1);\x0a"
"\x09""cp += stdlen + 1;\x0a"
"\x09if (dstlen \x21= 0) {\x0a"
"\x09\x09strlcpy(cp, dstname, dstlen + 1);\x0a"
"\x09}\x0a"
"\x09return 0;\x0a"
"}\x0a"
"\x0a"
"static void\x0a"
"gmtload(struct state *sp)\x0a"
"{\x0a"
"\x09if (tzload(gmt, sp, TRUE) \x21= 0)\x0a"
"\x09\x09(void) tzparse(gmt, sp, TRUE);\x0a"
"}\x0a"
"\x0a"
"static void\x0a"
"tzsetwall_basic(void)\x0a"
"{\x0a"
"\x09if (lcl_is_set < 0)\x0a"
"\x09\x09return;\x0a"
"\x09lcl_is_set = -1;\x0a"
"\x0a"
"\x09if (lclptr == NULL) {\x0a"
"\x09\x09lclptr = calloc(1, sizeof *lclptr);\x0a"
"\x09\x09if (lclptr == NULL) {\x0a"
"\x09\x09\x09settzname();\x09/* all we can do */\x0a"
"\x09\x09\x09return;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09if (tzload(NULL, lclptr, TRUE) \x21= 0)\x0a"
"\x09\x09gmtload(lclptr);\x0a"
"\x09settzname();\x0a"
"}\x0a"
"\x0a"
"#ifndef STD_INSPIRED\x0a"
"/*\x0a"
"** A non-static declaration of tzsetwall in a system header file\x0a"
"** may cause a warning about this upcoming static declaration...\x0a"
"*/\x0a"
"static\x0a"
"#endif /* \x21""defined STD_INSPIRED */\x0a"
"void\x0a"
"tzsetwall(void)\x0a"
"{\x0a"
"\x09_THREAD_PRIVATE_MUTEX_LOCK(lcl);\x0a"
"\x09tzsetwall_basic();\x0a"
"\x09_THREAD_PRIVATE_MUTEX_UNLOCK(lcl);\x0a"
"}\x0a"
"\x0a"
"static void\x0a"
"tzset_basic(void)\x0a"
"{\x0a"
"\x09""const char *\x09name;\x0a"
"\x0a"
"\x09name = getenv(\x22TZ\x22);\x0a"
"\x09if (name == NULL) {\x0a"
"\x09\x09tzsetwall_basic();\x0a"
"\x09\x09return;\x0a"
"\x09}\x0a"
"\x0a"
"\x09if (lcl_is_set > 0 \x26\x26 strcmp(lcl_TZname, name) == 0)\x0a"
"\x09\x09return;\x0a"
"\x09lcl_is_set = strlen(name) < sizeof lcl_TZname;\x0a"
"\x09if (lcl_is_set)\x0a"
"\x09\x09strlcpy(lcl_TZname, name, sizeof lcl_TZname);\x0a"
"\x0a"
"\x09if (lclptr == NULL) {\x0a"
"\x09\x09lclptr = calloc(1, sizeof *lclptr);\x0a"
"\x09\x09if (lclptr == NULL) {\x0a"
"\x09\x09\x09settzname();\x09/* all we can do */\x0a"
"\x09\x09\x09return;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09if (*name == '\x5c""0') {\x0a"
"\x09\x09/*\x0a"
"\x09\x09** User wants it fast rather than right.\x0a"
"\x09\x09*/\x0a"
"\x09\x09lclptr->leapcnt = 0;\x09\x09/* so, we're off a little */\x0a"
"\x09\x09lclptr->timecnt = 0;\x0a"
"\x09\x09lclptr->typecnt = 0;\x0a"
"\x09\x09lclptr->ttis\x5b""0\x5d.tt_isdst = 0;\x0a"
"\x09\x09lclptr->ttis\x5b""0\x5d.tt_gmtoff = 0;\x0a"
"\x09\x09lclptr->ttis\x5b""0\x5d.tt_abbrind = 0;\x0a"
"\x09\x09strlcpy(lclptr->chars, gmt, sizeof lclptr->chars);\x0a"
"\x09} else if (tzload(name, lclptr, TRUE) \x21= 0) {\x0a"
"\x09\x09if (name\x5b""0\x5d == '\x3a' \x7c\x7c tzparse(name, lclptr, FALSE) \x21= 0)\x0a"
"\x09\x09\x09gmtload(lclptr);\x0a"
"\x09}\x0a"
"\x09settzname();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"tzset(void)\x0a"
"{\x0a"
"\x09_THREAD_PRIVATE_MUTEX_LOCK(lcl);\x0a"
"\x09tzset_basic();\x0a"
"\x09_THREAD_PRIVATE_MUTEX_UNLOCK(lcl);\x0a"
"}\x0a"
"//DEF_WEAK(tzset);\x0a"
"\x0a"
"/*\x0a"
"** The easy way to behave \x22""as if no library function calls\x22 localtime\x0a"
"** is to not call it--so we drop its guts into \x22localsub\x22, which can be\x0a"
"** freely called. (And no, the PANS doesn't require the above behavior--\x0a"
"** but it *is* desirable.)\x0a"
"**\x0a"
"** The unused offset argument is for the benefit of mktime variants.\x0a"
"*/\x0a"
"\x0a"
"static struct tm *\x0a"
"localsub(const time_t *timep, long offset, struct tm *tmp)\x0a"
"{\x0a"
"\x09struct state *\x09\x09sp;\x0a"
"\x09""const struct ttinfo *\x09ttisp;\x0a"
"\x09int\x09\x09\x09i;\x0a"
"\x09struct tm *\x09\x09result;\x0a"
"\x09""const time_t\x09\x09\x09t = *timep;\x0a"
"\x0a"
"\x09sp = lclptr;\x0a"
"\x09if (sp == NULL)\x0a"
"\x09\x09return gmtsub(timep, offset, tmp);\x0a"
"\x09if ((sp->goback \x26\x26 t < sp->ats\x5b""0\x5d) \x7c\x7c\x0a"
"\x09    (sp->goahead \x26\x26 t > sp->ats\x5bsp->timecnt - 1\x5d)) {\x0a"
"\x09\x09time_t\x09\x09\x09newt = t;\x0a"
"\x09\x09time_t\x09\x09seconds;\x0a"
"\x09\x09time_t\x09\x09tcycles;\x0a"
"\x09\x09int_fast64_t\x09icycles;\x0a"
"\x0a"
"\x09\x09if (t < sp->ats\x5b""0\x5d)\x0a"
"\x09\x09\x09seconds = sp->ats\x5b""0\x5d - t;\x0a"
"\x09\x09""else\x0a"
"\x09\x09\x09seconds = t - sp->ats\x5bsp->timecnt - 1\x5d;\x0a"
"\x09\x09--seconds;\x0a"
"\x09\x09tcycles = seconds / YEARSPERREPEAT / AVGSECSPERYEAR;\x0a"
"\x09\x09++tcycles;\x0a"
"\x09\x09icycles = tcycles;\x0a"
"\x09\x09if (tcycles - icycles >= 1 \x7c\x7c icycles - tcycles >= 1)\x0a"
"\x09\x09\x09return NULL;\x0a"
"\x09\x09seconds = icycles;\x0a"
"\x09\x09seconds *= YEARSPERREPEAT;\x0a"
"\x09\x09seconds *= AVGSECSPERYEAR;\x0a"
"\x09\x09if (t < sp->ats\x5b""0\x5d)\x0a"
"\x09\x09\x09newt += seconds;\x0a"
"\x09\x09""else\x0a"
"\x09\x09\x09newt -= seconds;\x0a"
"\x09\x09if (newt < sp->ats\x5b""0\x5d \x7c\x7c\x0a"
"\x09\x09    newt > sp->ats\x5bsp->timecnt - 1\x5d)\x0a"
"\x09\x09\x09return NULL;\x09/* \x22""cannot happen\x22 */\x0a"
"\x09\x09result = localsub(\x26newt, offset, tmp);\x0a"
"\x09\x09if (result == tmp) {\x0a"
"\x09\x09\x09time_t\x09newy;\x0a"
"\x0a"
"\x09\x09\x09newy = tmp->tm_year;\x0a"
"\x09\x09\x09if (t < sp->ats\x5b""0\x5d)\x0a"
"\x09\x09\x09\x09newy -= icycles * YEARSPERREPEAT;\x0a"
"\x09\x09\x09""else\x0a"
"\x09\x09\x09\x09newy += icycles * YEARSPERREPEAT;\x0a"
"\x09\x09\x09tmp->tm_year = newy;\x0a"
"\x09\x09\x09if (tmp->tm_year \x21= newy)\x0a"
"\x09\x09\x09\x09return NULL;\x0a"
"\x09\x09}\x0a"
"\x09\x09return result;\x0a"
"\x09}\x0a"
"\x09if (sp->timecnt == 0 \x7c\x7c t < sp->ats\x5b""0\x5d) {\x0a"
"\x09\x09i = 0;\x0a"
"\x09\x09while (sp->ttis\x5bi\x5d.tt_isdst) {\x0a"
"\x09\x09\x09if (++i >= sp->typecnt) {\x0a"
"\x09\x09\x09\x09i = 0;\x0a"
"\x09\x09\x09\x09""break;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09}\x0a"
"\x09} else {\x0a"
"\x09\x09int\x09lo = 1;\x0a"
"\x09\x09int\x09hi = sp->timecnt;\x0a"
"\x0a"
"\x09\x09while (lo < hi) {\x0a"
"\x09\x09\x09int\x09mid = (lo + hi) >> 1;\x0a"
"\x0a"
"\x09\x09\x09if (t < sp->ats\x5bmid\x5d)\x0a"
"\x09\x09\x09\x09hi = mid;\x0a"
"\x09\x09\x09""else\x0a"
"\x09\x09\x09\x09lo = mid + 1;\x0a"
"\x09\x09}\x0a"
"\x09\x09i = (int) sp->types\x5blo - 1\x5d;\x0a"
"\x09}\x0a"
"\x09ttisp = \x26sp->ttis\x5bi\x5d;\x0a"
"\x09/*\x0a"
"\x09** To get (wrong) behavior that's compatible with System V Release 2.0\x0a"
"\x09** you'd replace the statement below with\x0a"
"\x09**\x09t += ttisp->tt_gmtoff;\x0a"
"\x09**\x09timesub(\x26t, 0L, sp, tmp);\x0a"
"\x09*/\x0a"
"\x09result = timesub(\x26t, ttisp->tt_gmtoff, sp, tmp);\x0a"
"\x09tmp->tm_isdst = ttisp->tt_isdst;\x0a"
"\x09tzname\x5btmp->tm_isdst\x5d = \x26sp->chars\x5bttisp->tt_abbrind\x5d;\x0a"
"#ifdef TM_ZONE\x0a"
"\x09tmp->TM_ZONE = \x26sp->chars\x5bttisp->tt_abbrind\x5d;\x0a"
"#endif /* defined TM_ZONE */\x0a"
"\x09return result;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** Re-entrant version of localtime.\x0a"
"*/\x0a"
"\x0a"
"struct tm *\x0a"
"localtime_r(const time_t *timep, struct tm *p_tm)\x0a"
"{\x0a"
"\x09_THREAD_PRIVATE_MUTEX_LOCK(lcl);\x0a"
"\x09tzset_basic();\x0a"
"\x09p_tm = localsub(timep, 0L, p_tm);\x0a"
"\x09_THREAD_PRIVATE_MUTEX_UNLOCK(lcl);\x0a"
"\x09return p_tm;\x0a"
"}\x0a"
"//DEF_WEAK(localtime_r);\x0a"
"\x0a"
"struct tm *\x0a"
"localtime(const time_t *timep)\x0a"
"{\x0a"
"\x09_THREAD_PRIVATE_KEY(localtime);\x0a"
"\x09struct tm * p_tm = (struct tm*)_THREAD_PRIVATE(localtime, tm, NULL);\x0a"
"\x0a"
"\x09if (p_tm == NULL)\x0a"
"\x09\x09return NULL;\x0a"
"\x09return localtime_r(timep, p_tm);\x0a"
"}\x0a"
"//DEF_STRONG(localtime);\x0a"
"\x0a"
"/*\x0a"
"** gmtsub is to gmtime as localsub is to localtime.\x0a"
"*/\x0a"
"\x0a"
"static struct tm *\x0a"
"gmtsub(const time_t *timep, long offset, struct tm *tmp)\x0a"
"{\x0a"
"\x09struct tm *\x09result;\x0a"
"\x0a"
"\x09_THREAD_PRIVATE_MUTEX_LOCK(gmt);\x0a"
"\x09if (\x21gmt_is_set) {\x0a"
"\x09\x09gmt_is_set = TRUE;\x0a"
"\x09\x09gmtptr = calloc(1, sizeof(*gmtptr));\x0a"
"\x09\x09if (gmtptr \x21= NULL)\x0a"
"\x09\x09\x09gmtload(gmtptr);\x0a"
"\x09}\x0a"
"\x09_THREAD_PRIVATE_MUTEX_UNLOCK(gmt);\x0a"
"\x09result = timesub(timep, offset, gmtptr, tmp);\x0a"
"#ifdef TM_ZONE\x0a"
"\x09/*\x0a"
"\x09** Could get fancy here and deliver something such as\x0a"
"\x09** \x22UTC+xxxx\x22 or \x22UTC-xxxx\x22 if offset is non-zero,\x0a"
"\x09** but this is no time for a treasure hunt.\x0a"
"\x09*/\x0a"
"\x09if (offset \x21= 0)\x0a"
"\x09\x09tmp->TM_ZONE = wildabbr;\x0a"
"\x09""else {\x0a"
"\x09\x09if (gmtptr == NULL)\x0a"
"\x09\x09\x09tmp->TM_ZONE = (char *)gmt;\x0a"
"\x09\x09""else\x0a"
"\x09\x09\x09tmp->TM_ZONE = gmtptr->chars;\x0a"
"\x09}\x0a"
"#endif /* defined TM_ZONE */\x0a"
"\x09return result;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** Re-entrant version of gmtime.\x0a"
"*/\x0a"
"\x0a"
"struct tm *\x0a"
"gmtime_r(const time_t *timep, struct tm *p_tm)\x0a"
"{\x0a"
"\x09return gmtsub(timep, 0L, p_tm);\x0a"
"}\x0a"
"//DEF_WEAK(gmtime_r);\x0a"
"\x0a"
"struct tm *\x0a"
"gmtime(const time_t *timep)\x0a"
"{\x0a"
"\x09_THREAD_PRIVATE_KEY(gmtime);\x0a"
"\x09struct tm * p_tm = (struct tm*) _THREAD_PRIVATE(gmtime, tm, NULL);\x0a"
"\x0a"
"\x09if (p_tm == NULL)\x0a"
"\x09\x09return NULL;\x0a"
"\x09return gmtime_r(timep, p_tm);\x0a"
"\x0a"
"}\x0a"
"//DEF_WEAK(gmtime);\x0a"
"\x0a"
"#ifdef STD_INSPIRED\x0a"
"\x0a"
"struct tm *\x0a"
"offtime(const time_t *timep, long offset)\x0a"
"{\x0a"
"\x09return gmtsub(timep, offset, \x26tm);\x0a"
"}\x0a"
"\x0a"
"#endif /* defined STD_INSPIRED */\x0a"
"\x0a"
"/*\x0a"
"** Return the number of leap years through the end of the given year\x0a"
"** where, to make the math easy, the answer for year zero is defined as zero.\x0a"
"*/\x0a"
"\x0a"
"static int\x0a"
"leaps_thru_end_of(int y)\x0a"
"{\x0a"
"\x09return (y >= 0) \x3f (y / 4 - y / 100 + y / 400) \x3a\x0a"
"\x09\x09-(leaps_thru_end_of(-(y + 1)) + 1);\x0a"
"}\x0a"
"\x0a"
"static struct tm *\x0a"
"timesub(const time_t *timep, long offset, const struct state *sp, struct tm *tmp)\x0a"
"{\x0a"
"\x09""const struct lsinfo *\x09lp;\x0a"
"\x09time_t\x09\x09\x09tdays;\x0a"
"\x09int\x09\x09\x09idays;\x09/* unsigned would be so 2003 */\x0a"
"\x09long\x09\x09\x09rem;\x0a"
"\x09int\x09\x09\x09y;\x0a"
"\x09""const int *\x09\x09ip;\x0a"
"\x09long\x09\x09\x09""corr;\x0a"
"\x09int\x09\x09\x09hit;\x0a"
"\x09int\x09\x09\x09i;\x0a"
"\x09long\x09\x09\x09seconds;\x0a"
"\x0a"
"\x09""corr = 0;\x0a"
"\x09hit = 0;\x0a"
"\x09i = (sp == NULL) \x3f 0 \x3a sp->leapcnt;\x0a"
"\x09while (--i >= 0) {\x0a"
"\x09\x09lp = \x26sp->lsis\x5bi\x5d;\x0a"
"\x09\x09if (*timep >= lp->ls_trans) {\x0a"
"\x09\x09\x09if (*timep == lp->ls_trans) {\x0a"
"\x09\x09\x09\x09hit = ((i == 0 \x26\x26 lp->ls_corr > 0) \x7c\x7c\x0a"
"\x09\x09\x09\x09    lp->ls_corr > sp->lsis\x5bi - 1\x5d.ls_corr);\x0a"
"\x09\x09\x09\x09if (hit) {\x0a"
"\x09\x09\x09\x09\x09while (i > 0 \x26\x26\x0a"
"\x09\x09\x09\x09\x09    sp->lsis\x5bi\x5d.ls_trans ==\x0a"
"\x09\x09\x09\x09\x09    sp->lsis\x5bi - 1\x5d.ls_trans + 1 \x26\x26\x0a"
"\x09\x09\x09\x09\x09    sp->lsis\x5bi\x5d.ls_corr ==\x0a"
"\x09\x09\x09\x09\x09    sp->lsis\x5bi - 1\x5d.ls_corr + 1) {\x0a"
"\x09\x09\x09\x09\x09\x09++hit;\x0a"
"\x09\x09\x09\x09\x09\x09--i;\x0a"
"\x09\x09\x09\x09\x09}\x0a"
"\x09\x09\x09\x09}\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09\x09""corr = lp->ls_corr;\x0a"
"\x09\x09\x09""break;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09y = EPOCH_YEAR;\x0a"
"\x09tdays = *timep / SECSPERDAY;\x0a"
"\x09rem = *timep - tdays * SECSPERDAY;\x0a"
"\x09while (tdays < 0 \x7c\x7c tdays >= year_lengths\x5bisleap(y)\x5d) {\x0a"
"\x09\x09int\x09\x09newy;\x0a"
"\x09\x09time_t\x09tdelta;\x0a"
"\x09\x09int\x09idelta;\x0a"
"\x09\x09int\x09leapdays;\x0a"
"\x0a"
"\x09\x09tdelta = tdays / DAYSPERLYEAR;\x0a"
"\x09\x09idelta = tdelta;\x0a"
"\x09\x09if (tdelta - idelta >= 1 \x7c\x7c idelta - tdelta >= 1)\x0a"
"\x09\x09\x09return NULL;\x0a"
"\x09\x09if (idelta == 0)\x0a"
"\x09\x09\x09idelta = (tdays < 0) \x3f -1 \x3a 1;\x0a"
"\x09\x09newy = y;\x0a"
"\x09\x09if (increment_overflow(\x26newy, idelta))\x0a"
"\x09\x09\x09return NULL;\x0a"
"\x09\x09leapdays = leaps_thru_end_of(newy - 1) -\x0a"
"\x09\x09\x09leaps_thru_end_of(y - 1);\x0a"
"\x09\x09tdays -= ((time_t) newy - y) * DAYSPERNYEAR;\x0a"
"\x09\x09tdays -= leapdays;\x0a"
"\x09\x09y = newy;\x0a"
"\x09}\x0a"
"\x0a"
"\x09seconds = tdays * SECSPERDAY + 0.5;\x0a"
"\x09tdays = seconds / SECSPERDAY;\x0a"
"\x09rem += seconds - tdays * SECSPERDAY;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09** Given the range, we can now fearlessly cast...\x0a"
"\x09*/\x0a"
"\x09idays = tdays;\x0a"
"\x09rem += offset - corr;\x0a"
"\x09while (rem < 0) {\x0a"
"\x09\x09rem += SECSPERDAY;\x0a"
"\x09\x09--idays;\x0a"
"\x09}\x0a"
"\x09while (rem >= SECSPERDAY) {\x0a"
"\x09\x09rem -= SECSPERDAY;\x0a"
"\x09\x09++idays;\x0a"
"\x09}\x0a"
"\x09while (idays < 0) {\x0a"
"\x09\x09if (increment_overflow(\x26y, -1))\x0a"
"\x09\x09\x09return NULL;\x0a"
"\x09\x09idays += year_lengths\x5bisleap(y)\x5d;\x0a"
"\x09}\x0a"
"\x09while (idays >= year_lengths\x5bisleap(y)\x5d) {\x0a"
"\x09\x09idays -= year_lengths\x5bisleap(y)\x5d;\x0a"
"\x09\x09if (increment_overflow(\x26y, 1))\x0a"
"\x09\x09\x09return NULL;\x0a"
"\x09}\x0a"
"\x09tmp->tm_year = y;\x0a"
"\x09if (increment_overflow(\x26tmp->tm_year, -TM_YEAR_BASE))\x0a"
"\x09\x09return NULL;\x0a"
"\x09tmp->tm_yday = idays;\x0a"
"\x09/*\x0a"
"\x09** The \x22""extra\x22 mods below avoid overflow problems.\x0a"
"\x09*/\x0a"
"\x09tmp->tm_wday = EPOCH_WDAY +\x0a"
"\x09    ((y - EPOCH_YEAR) \x25 DAYSPERWEEK) *\x0a"
"\x09    (DAYSPERNYEAR \x25 DAYSPERWEEK) +\x0a"
"\x09    leaps_thru_end_of(y - 1) -\x0a"
"\x09    leaps_thru_end_of(EPOCH_YEAR - 1) +\x0a"
"\x09    idays;\x0a"
"\x09tmp->tm_wday \x25= DAYSPERWEEK;\x0a"
"\x09if (tmp->tm_wday < 0)\x0a"
"\x09\x09tmp->tm_wday += DAYSPERWEEK;\x0a"
"\x09tmp->tm_hour = (int) (rem / SECSPERHOUR);\x0a"
"\x09rem \x25= SECSPERHOUR;\x0a"
"\x09tmp->tm_min = (int) (rem / SECSPERMIN);\x0a"
"\x09/*\x0a"
"\x09** A positive leap second requires a special\x0a"
"\x09** representation. This uses \x22... \x3f\x3f\x3a""59\x3a""60\x22 et seq.\x0a"
"\x09*/\x0a"
"\x09tmp->tm_sec = (int) (rem \x25 SECSPERMIN) + hit;\x0a"
"\x09ip = mon_lengths\x5bisleap(y)\x5d;\x0a"
"\x09""for (tmp->tm_mon = 0; idays >= ip\x5btmp->tm_mon\x5d; ++(tmp->tm_mon))\x0a"
"\x09\x09idays -= ip\x5btmp->tm_mon\x5d;\x0a"
"\x09tmp->tm_mday = (int) (idays + 1);\x0a"
"\x09tmp->tm_isdst = 0;\x0a"
"#ifdef TM_GMTOFF\x0a"
"\x09tmp->TM_GMTOFF = offset;\x0a"
"#endif /* defined TM_GMTOFF */\x0a"
"\x09return tmp;\x0a"
"}\x0a"
"\x0a"
"char *\x0a"
"ctime(const time_t *timep)\x0a"
"{\x0a"
"/*\x0a"
"** Section 4.12.3.2 of X3.159-1989 requires that\x0a"
"**\x09The ctime function converts the calendar time pointed to by timer\x0a"
"**\x09to local time in the form of a string. It is equivalent to\x0a"
"**\x09\x09""asctime(localtime(timer))\x0a"
"*/\x0a"
"\x09return asctime(localtime(timep));\x0a"
"}\x0a"
"\x0a"
"char *\x0a"
"ctime_r(const time_t *timep, char *buf)\x0a"
"{\x0a"
"\x09struct tm\x09mytm;\x0a"
"\x0a"
"\x09return asctime_r(localtime_r(timep, \x26mytm), buf);\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"** Adapted from code provided by Robert Elz, who writes\x3a\x0a"
"**\x09The \x22""best\x22 way to do mktime I think is based on an idea of Bob\x0a"
"**\x09Kridle's (so its said...) from a long time ago.\x0a"
"**\x09It does a binary search of the time_t space. Since time_t's are\x0a"
"**\x09just 32 bits, its a max of 32 iterations (even at 64 bits it\x0a"
"**\x09would still be very reasonable).\x0a"
"*/\x0a"
"\x0a"
"#ifndef WRONG\x0a"
"#define WRONG\x09(-1)\x0a"
"#endif /* \x21""defined WRONG */\x0a"
"\x0a"
"/*\x0a"
"** Normalize logic courtesy Paul Eggert.\x0a"
"*/\x0a"
"\x0a"
"static int\x0a"
"increment_overflow(int *ip, int j)\x0a"
"{\x0a"
"\x09int const\x09i = *ip;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09** If i >= 0 there can only be overflow if i + j > INT_MAX\x0a"
"\x09** or if j > INT_MAX - i; given i >= 0, INT_MAX - i cannot overflow.\x0a"
"\x09** If i < 0 there can only be overflow if i + j < INT_MIN\x0a"
"\x09** or if j < INT_MIN - i; given i < 0, INT_MIN - i cannot overflow.\x0a"
"\x09*/\x0a"
"\x09if ((i >= 0) \x3f (j > INT_MAX - i) \x3a (j < INT_MIN - i))\x0a"
"\x09\x09return TRUE;\x0a"
"\x09*ip += j;\x0a"
"\x09return FALSE;\x0a"
"}\x0a"
"\x0a"
"static int\x0a"
"long_increment_overflow(long *lp, int m)\x0a"
"{\x0a"
"\x09long const\x09l = *lp;\x0a"
"\x0a"
"\x09if ((l >= 0) \x3f (m > LONG_MAX - l) \x3a (m < LONG_MIN - l))\x0a"
"\x09\x09return TRUE;\x0a"
"\x09*lp += m;\x0a"
"\x09return FALSE;\x0a"
"}\x0a"
"\x0a"
"static int\x0a"
"normalize_overflow(int *tensptr, int *unitsptr, int base)\x0a"
"{\x0a"
"\x09int\x09tensdelta;\x0a"
"\x0a"
"\x09tensdelta = (*unitsptr >= 0) \x3f\x0a"
"\x09    (*unitsptr / base) \x3a\x0a"
"\x09    (-1 - (-1 - *unitsptr) / base);\x0a"
"\x09*unitsptr -= tensdelta * base;\x0a"
"\x09return increment_overflow(tensptr, tensdelta);\x0a"
"}\x0a"
"\x0a"
"static int\x0a"
"long_normalize_overflow(long *tensptr, int *unitsptr, int base)\x0a"
"{\x0a"
"\x09int\x09tensdelta;\x0a"
"\x0a"
"\x09tensdelta = (*unitsptr >= 0) \x3f\x0a"
"\x09    (*unitsptr / base) \x3a\x0a"
"\x09    (-1 - (-1 - *unitsptr) / base);\x0a"
"\x09*unitsptr -= tensdelta * base;\x0a"
"\x09return long_increment_overflow(tensptr, tensdelta);\x0a"
"}\x0a"
"\x0a"
"static int\x0a"
"tmcomp(const struct tm *atmp, const struct tm *btmp)\x0a"
"{\x0a"
"\x09int\x09result;\x0a"
"\x0a"
"\x09if ((result = (atmp->tm_year - btmp->tm_year)) == 0 \x26\x26\x0a"
"\x09    (result = (atmp->tm_mon - btmp->tm_mon)) == 0 \x26\x26\x0a"
"\x09    (result = (atmp->tm_mday - btmp->tm_mday)) == 0 \x26\x26\x0a"
"\x09    (result = (atmp->tm_hour - btmp->tm_hour)) == 0 \x26\x26\x0a"
"\x09    (result = (atmp->tm_min - btmp->tm_min)) == 0)\x0a"
"\x09\x09result = atmp->tm_sec - btmp->tm_sec;\x0a"
"\x09return result;\x0a"
"}\x0a"
"\x0a"
"static time_t\x0a"
"time2sub(struct tm *tmp, struct tm *(*funcp)(const time_t *, long, struct tm *),\x0a"
"    long offset, int *okayp, int do_norm_secs)\x0a"
"{\x0a"
"\x09""const struct state *\x09sp;\x0a"
"\x09int\x09\x09\x09""dir;\x0a"
"\x09int\x09\x09\x09i, j;\x0a"
"\x09int\x09\x09\x09saved_seconds;\x0a"
"\x09long\x09\x09\x09li;\x0a"
"\x09time_t\x09\x09\x09lo;\x0a"
"\x09time_t\x09\x09\x09hi;\x0a"
"\x09long\x09\x09\x09y;\x0a"
"\x09time_t\x09\x09\x09newt;\x0a"
"\x09time_t\x09\x09\x09t;\x0a"
"\x09struct tm\x09\x09yourtm, mytm;\x0a"
"\x0a"
"\x09*okayp = FALSE;\x0a"
"\x09yourtm = *tmp;\x0a"
"\x09if (do_norm_secs) {\x0a"
"\x09\x09if (normalize_overflow(\x26yourtm.tm_min, \x26yourtm.tm_sec,\x0a"
"\x09\x09\x09SECSPERMIN))\x0a"
"\x09\x09\x09\x09return WRONG;\x0a"
"\x09}\x0a"
"\x09if (normalize_overflow(\x26yourtm.tm_hour, \x26yourtm.tm_min, MINSPERHOUR))\x0a"
"\x09\x09return WRONG;\x0a"
"\x09if (normalize_overflow(\x26yourtm.tm_mday, \x26yourtm.tm_hour, HOURSPERDAY))\x0a"
"\x09\x09return WRONG;\x0a"
"\x09y = yourtm.tm_year;\x0a"
"\x09if (long_normalize_overflow(\x26y, \x26yourtm.tm_mon, MONSPERYEAR))\x0a"
"\x09\x09return WRONG;\x0a"
"\x09/*\x0a"
"\x09** Turn y into an actual year number for now.\x0a"
"\x09** It is converted back to an offset from TM_YEAR_BASE later.\x0a"
"\x09*/\x0a"
"\x09if (long_increment_overflow(\x26y, TM_YEAR_BASE))\x0a"
"\x09\x09return WRONG;\x0a"
"\x09while (yourtm.tm_mday <= 0) {\x0a"
"\x09\x09if (long_increment_overflow(\x26y, -1))\x0a"
"\x09\x09\x09return WRONG;\x0a"
"\x09\x09li = y + (1 < yourtm.tm_mon);\x0a"
"\x09\x09yourtm.tm_mday += year_lengths\x5bisleap(li)\x5d;\x0a"
"\x09}\x0a"
"\x09while (yourtm.tm_mday > DAYSPERLYEAR) {\x0a"
"\x09\x09li = y + (1 < yourtm.tm_mon);\x0a"
"\x09\x09yourtm.tm_mday -= year_lengths\x5bisleap(li)\x5d;\x0a"
"\x09\x09if (long_increment_overflow(\x26y, 1))\x0a"
"\x09\x09\x09return WRONG;\x0a"
"\x09}\x0a"
"\x09""for ( ; ; ) {\x0a"
"\x09\x09i = mon_lengths\x5bisleap(y)\x5d\x5byourtm.tm_mon\x5d;\x0a"
"\x09\x09if (yourtm.tm_mday <= i)\x0a"
"\x09\x09\x09""break;\x0a"
"\x09\x09yourtm.tm_mday -= i;\x0a"
"\x09\x09if (++yourtm.tm_mon >= MONSPERYEAR) {\x0a"
"\x09\x09\x09yourtm.tm_mon = 0;\x0a"
"\x09\x09\x09if (long_increment_overflow(\x26y, 1))\x0a"
"\x09\x09\x09\x09return WRONG;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09if (long_increment_overflow(\x26y, -TM_YEAR_BASE))\x0a"
"\x09\x09return WRONG;\x0a"
"\x09yourtm.tm_year = y;\x0a"
"\x09if (yourtm.tm_year \x21= y)\x0a"
"\x09\x09return WRONG;\x0a"
"\x09if (yourtm.tm_sec >= 0 \x26\x26 yourtm.tm_sec < SECSPERMIN)\x0a"
"\x09\x09saved_seconds = 0;\x0a"
"\x09""else if (y + TM_YEAR_BASE < EPOCH_YEAR) {\x0a"
"\x09\x09/*\x0a"
"\x09\x09** We can't set tm_sec to 0, because that might push the\x0a"
"\x09\x09** time below the minimum representable time.\x0a"
"\x09\x09** Set tm_sec to 59 instead.\x0a"
"\x09\x09** This assumes that the minimum representable time is\x0a"
"\x09\x09** not in the same minute that a leap second was deleted from,\x0a"
"\x09\x09** which is a safer assumption than using 58 would be.\x0a"
"\x09\x09*/\x0a"
"\x09\x09if (increment_overflow(\x26yourtm.tm_sec, 1 - SECSPERMIN))\x0a"
"\x09\x09\x09return WRONG;\x0a"
"\x09\x09saved_seconds = yourtm.tm_sec;\x0a"
"\x09\x09yourtm.tm_sec = SECSPERMIN - 1;\x0a"
"\x09} else {\x0a"
"\x09\x09saved_seconds = yourtm.tm_sec;\x0a"
"\x09\x09yourtm.tm_sec = 0;\x0a"
"\x09}\x0a"
"\x09/*\x0a"
"\x09** Do a binary search (this works whatever time_t's type is).\x0a"
"\x09*/\x0a"
"\x09lo = 1;\x0a"
"\x09""for (i = 0; i < (int) TYPE_BIT(time_t) - 1; ++i)\x0a"
"\x09\x09lo *= 2;\x0a"
"\x09hi = -(lo + 1);\x0a"
"\x09""for ( ; ; ) {\x0a"
"\x09\x09t = lo / 2 + hi / 2;\x0a"
"\x09\x09if (t < lo)\x0a"
"\x09\x09\x09t = lo;\x0a"
"\x09\x09""else if (t > hi)\x0a"
"\x09\x09\x09t = hi;\x0a"
"\x09\x09if ((*funcp)(\x26t, offset, \x26mytm) == NULL) {\x0a"
"\x09\x09\x09/*\x0a"
"\x09\x09\x09** Assume that t is too extreme to be represented in\x0a"
"\x09\x09\x09** a struct tm; arrange things so that it is less\x0a"
"\x09\x09\x09** extreme on the next pass.\x0a"
"\x09\x09\x09*/\x0a"
"\x09\x09\x09""dir = (t > 0) \x3f 1 \x3a -1;\x0a"
"\x09\x09} else\x0a"
"\x09\x09\x09""dir = tmcomp(\x26mytm, \x26yourtm);\x0a"
"\x09\x09if (dir \x21= 0) {\x0a"
"\x09\x09\x09if (t == lo) {\x0a"
"\x09\x09\x09\x09++t;\x0a"
"\x09\x09\x09\x09if (t <= lo)\x0a"
"\x09\x09\x09\x09\x09return WRONG;\x0a"
"\x09\x09\x09\x09++lo;\x0a"
"\x09\x09\x09} else if (t == hi) {\x0a"
"\x09\x09\x09\x09--t;\x0a"
"\x09\x09\x09\x09if (t >= hi)\x0a"
"\x09\x09\x09\x09\x09return WRONG;\x0a"
"\x09\x09\x09\x09--hi;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09\x09if (lo > hi)\x0a"
"\x09\x09\x09\x09return WRONG;\x0a"
"\x09\x09\x09if (dir > 0)\x0a"
"\x09\x09\x09\x09hi = t;\x0a"
"\x09\x09\x09""else\x0a"
"\x09\x09\x09\x09lo = t;\x0a"
"\x09\x09\x09""continue;\x0a"
"\x09\x09}\x0a"
"\x09\x09if (yourtm.tm_isdst < 0 \x7c\x7c mytm.tm_isdst == yourtm.tm_isdst)\x0a"
"\x09\x09\x09""break;\x0a"
"\x09\x09/*\x0a"
"\x09\x09** Right time, wrong type.\x0a"
"\x09\x09** Hunt for right time, right type.\x0a"
"\x09\x09** It's okay to guess wrong since the guess\x0a"
"\x09\x09** gets checked.\x0a"
"\x09\x09*/\x0a"
"\x09\x09sp = (const struct state *)\x0a"
"\x09\x09    ((funcp == localsub) \x3f lclptr \x3a gmtptr);\x0a"
"\x09\x09if (sp == NULL)\x0a"
"\x09\x09\x09return WRONG;\x0a"
"\x09\x09""for (i = sp->typecnt - 1; i >= 0; --i) {\x0a"
"\x09\x09\x09if (sp->ttis\x5bi\x5d.tt_isdst \x21= yourtm.tm_isdst)\x0a"
"\x09\x09\x09\x09""continue;\x0a"
"\x09\x09\x09""for (j = sp->typecnt - 1; j >= 0; --j) {\x0a"
"\x09\x09\x09\x09if (sp->ttis\x5bj\x5d.tt_isdst == yourtm.tm_isdst)\x0a"
"\x09\x09\x09\x09\x09""continue;\x0a"
"\x09\x09\x09\x09newt = t + sp->ttis\x5bj\x5d.tt_gmtoff -\x0a"
"\x09\x09\x09\x09\x09sp->ttis\x5bi\x5d.tt_gmtoff;\x0a"
"\x09\x09\x09\x09if ((*funcp)(\x26newt, offset, \x26mytm) == NULL)\x0a"
"\x09\x09\x09\x09\x09""continue;\x0a"
"\x09\x09\x09\x09if (tmcomp(\x26mytm, \x26yourtm) \x21= 0)\x0a"
"\x09\x09\x09\x09\x09""continue;\x0a"
"\x09\x09\x09\x09if (mytm.tm_isdst \x21= yourtm.tm_isdst)\x0a"
"\x09\x09\x09\x09\x09""continue;\x0a"
"\x09\x09\x09\x09/*\x0a"
"\x09\x09\x09\x09** We have a match.\x0a"
"\x09\x09\x09\x09*/\x0a"
"\x09\x09\x09\x09t = newt;\x0a"
"\x09\x09\x09\x09goto label;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09}\x0a"
"\x09\x09return WRONG;\x0a"
"\x09}\x0a"
"label\x3a\x0a"
"\x09newt = t + saved_seconds;\x0a"
"\x09if ((newt < t) \x21= (saved_seconds < 0))\x0a"
"\x09\x09return WRONG;\x0a"
"\x09t = newt;\x0a"
"\x09if ((*funcp)(\x26t, offset, tmp))\x0a"
"\x09\x09*okayp = TRUE;\x0a"
"\x09return t;\x0a"
"}\x0a"
"\x0a"
"static time_t\x0a"
"time2(struct tm *tmp, struct tm * (*funcp)(const time_t *, long, struct tm *),\x0a"
"    long offset, int *okayp)\x0a"
"{\x0a"
"\x09time_t\x09t;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09** First try without normalization of seconds\x0a"
"\x09** (in case tm_sec contains a value associated with a leap second).\x0a"
"\x09** If that fails, try with normalization of seconds.\x0a"
"\x09*/\x0a"
"\x09t = time2sub(tmp, funcp, offset, okayp, FALSE);\x0a"
"\x09return *okayp \x3f t \x3a time2sub(tmp, funcp, offset, okayp, TRUE);\x0a"
"}\x0a"
"\x0a"
"static time_t\x0a"
"time1(struct tm *tmp, struct tm * (*funcp)(const time_t *, long, struct tm *),\x0a"
"    long offset)\x0a"
"{\x0a"
"\x09time_t\x09\x09\x09t;\x0a"
"\x09""const struct state *\x09sp;\x0a"
"\x09int\x09\x09\x09samei, otheri;\x0a"
"\x09int\x09\x09\x09sameind, otherind;\x0a"
"\x09int\x09\x09\x09i;\x0a"
"\x09int\x09\x09\x09nseen;\x0a"
"\x09int\x09\x09\x09seen\x5bTZ_MAX_TYPES\x5d;\x0a"
"\x09int\x09\x09\x09types\x5bTZ_MAX_TYPES\x5d;\x0a"
"\x09int\x09\x09\x09okay;\x0a"
"\x0a"
"\x09if (tmp == NULL) {\x0a"
"\x09\x09""errno = EINVAL;\x0a"
"\x09\x09return WRONG;\x0a"
"\x09}\x0a"
"\x09if (tmp->tm_isdst > 1)\x0a"
"\x09\x09tmp->tm_isdst = 1;\x0a"
"\x09t = time2(tmp, funcp, offset, \x26okay);\x0a"
"#ifdef PCTS\x0a"
"\x09/*\x0a"
"\x09** PCTS code courtesy Grant Sullivan.\x0a"
"\x09*/\x0a"
"\x09if (okay)\x0a"
"\x09\x09return t;\x0a"
"\x09if (tmp->tm_isdst < 0)\x0a"
"\x09\x09tmp->tm_isdst = 0;\x09/* reset to std and try again */\x0a"
"#endif /* defined PCTS */\x0a"
"#ifndef PCTS\x0a"
"\x09if (okay \x7c\x7c tmp->tm_isdst < 0)\x0a"
"\x09\x09return t;\x0a"
"#endif /* \x21""defined PCTS */\x0a"
"\x09/*\x0a"
"\x09** We're supposed to assume that somebody took a time of one type\x0a"
"\x09** and did some math on it that yielded a \x22struct tm\x22 that's bad.\x0a"
"\x09** We try to divine the type they started from and adjust to the\x0a"
"\x09** type they need.\x0a"
"\x09*/\x0a"
"\x09sp = (const struct state *) ((funcp == localsub) \x3f  lclptr \x3a gmtptr);\x0a"
"\x09if (sp == NULL)\x0a"
"\x09\x09return WRONG;\x0a"
"\x09""for (i = 0; i < sp->typecnt; ++i)\x0a"
"\x09\x09seen\x5bi\x5d = FALSE;\x0a"
"\x09nseen = 0;\x0a"
"\x09""for (i = sp->timecnt - 1; i >= 0; --i) {\x0a"
"\x09\x09if (\x21seen\x5bsp->types\x5bi\x5d\x5d) {\x0a"
"\x09\x09\x09seen\x5bsp->types\x5bi\x5d\x5d = TRUE;\x0a"
"\x09\x09\x09types\x5bnseen++\x5d = sp->types\x5bi\x5d;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09""for (sameind = 0; sameind < nseen; ++sameind) {\x0a"
"\x09\x09samei = types\x5bsameind\x5d;\x0a"
"\x09\x09if (sp->ttis\x5bsamei\x5d.tt_isdst \x21= tmp->tm_isdst)\x0a"
"\x09\x09\x09""continue;\x0a"
"\x09\x09""for (otherind = 0; otherind < nseen; ++otherind) {\x0a"
"\x09\x09\x09otheri = types\x5botherind\x5d;\x0a"
"\x09\x09\x09if (sp->ttis\x5botheri\x5d.tt_isdst == tmp->tm_isdst)\x0a"
"\x09\x09\x09\x09""continue;\x0a"
"\x09\x09\x09tmp->tm_sec += sp->ttis\x5botheri\x5d.tt_gmtoff -\x0a"
"\x09\x09\x09    sp->ttis\x5bsamei\x5d.tt_gmtoff;\x0a"
"\x09\x09\x09tmp->tm_isdst = \x21tmp->tm_isdst;\x0a"
"\x09\x09\x09t = time2(tmp, funcp, offset, \x26okay);\x0a"
"\x09\x09\x09if (okay)\x0a"
"\x09\x09\x09\x09return t;\x0a"
"\x09\x09\x09tmp->tm_sec -= sp->ttis\x5botheri\x5d.tt_gmtoff -\x0a"
"\x09\x09\x09    sp->ttis\x5bsamei\x5d.tt_gmtoff;\x0a"
"\x09\x09\x09tmp->tm_isdst = \x21tmp->tm_isdst;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09return WRONG;\x0a"
"}\x0a"
"\x0a"
"time_t\x0a"
"mktime(struct tm *tmp)\x0a"
"{\x0a"
"\x09time_t ret;\x0a"
"\x0a"
"\x09_THREAD_PRIVATE_MUTEX_LOCK(lcl);\x0a"
"\x09tzset_basic();\x0a"
"\x09ret = time1(tmp, localsub, 0L);\x0a"
"\x09_THREAD_PRIVATE_MUTEX_UNLOCK(lcl);\x0a"
"\x09return ret;\x0a"
"}\x0a"
"//DEF_STRONG(mktime);\x0a"
"\x0a"
"#ifdef STD_INSPIRED\x0a"
"\x0a"
"time_t\x0a"
"timelocal(struct tm *tmp)\x0a"
"{\x0a"
"\x09if (tmp \x21= NULL)\x0a"
"\x09\x09tmp->tm_isdst = -1;\x09/* in case it wasn't initialized */\x0a"
"\x09return mktime(tmp);\x0a"
"}\x0a"
"\x0a"
"time_t\x0a"
"timegm(struct tm *tmp)\x0a"
"{\x0a"
"\x09if (tmp \x21= NULL)\x0a"
"\x09\x09tmp->tm_isdst = 0;\x0a"
"\x09return time1(tmp, gmtsub, 0L);\x0a"
"}\x0a"
"\x0a"
"time_t\x0a"
"timeoff(struct tm *tmp, long offset)\x0a"
"{\x0a"
"\x09if (tmp \x21= NULL)\x0a"
"\x09\x09tmp->tm_isdst = 0;\x0a"
"\x09return time1(tmp, gmtsub, offset);\x0a"
"}\x0a"
"\x0a"
"#endif /* defined STD_INSPIRED */\x0a"
"\x0a"
"/*\x0a"
"** XXX--is the below the right way to conditionalize\x3f\x3f\x0a"
"*/\x0a"
"\x0a"
"#ifdef STD_INSPIRED\x0a"
"\x0a"
"/*\x0a"
"** IEEE Std 1003.1-1988 (POSIX) legislates that 536457599\x0a"
"** shall correspond to \x22Wed Dec 31 23\x3a""59\x3a""59 UTC 1986\x22, which\x0a"
"** is not the case if we are accounting for leap seconds.\x0a"
"** So, we provide the following conversion routines for use\x0a"
"** when exchanging timestamps with POSIX conforming systems.\x0a"
"*/\x0a"
"\x0a"
"static long\x0a"
"leapcorr(time_t *timep)\x0a"
"{\x0a"
"\x09struct state *\x09\x09sp;\x0a"
"\x09struct lsinfo *\x09lp;\x0a"
"\x09int\x09\x09\x09i;\x0a"
"\x0a"
"\x09sp = lclptr;\x0a"
"\x09i = sp->leapcnt;\x0a"
"\x09while (--i >= 0) {\x0a"
"\x09\x09lp = \x26sp->lsis\x5bi\x5d;\x0a"
"\x09\x09if (*timep >= lp->ls_trans)\x0a"
"\x09\x09\x09return lp->ls_corr;\x0a"
"\x09}\x0a"
"\x09return 0;\x0a"
"}\x0a"
"\x0a"
"time_t\x0a"
"time2posix(time_t t)\x0a"
"{\x0a"
"\x09tzset();\x0a"
"\x09return t - leapcorr(\x26t);\x0a"
"}\x0a"
"\x0a"
"time_t\x0a"
"posix2time(time_t t)\x0a"
"{\x0a"
"\x09time_t\x09x;\x0a"
"\x09time_t\x09y;\x0a"
"\x0a"
"\x09tzset();\x0a"
"\x09/*\x0a"
"\x09** For a positive leap second hit, the result\x0a"
"\x09** is not unique. For a negative leap second\x0a"
"\x09** hit, the corresponding time doesn't exist,\x0a"
"\x09** so we return an adjacent second.\x0a"
"\x09*/\x0a"
"\x09x = t + leapcorr(\x26t);\x0a"
"\x09y = x - leapcorr(\x26x);\x0a"
"\x09if (y < t) {\x0a"
"\x09\x09""do {\x0a"
"\x09\x09\x09x++;\x0a"
"\x09\x09\x09y = x - leapcorr(\x26x);\x0a"
"\x09\x09} while (y < t);\x0a"
"\x09\x09if (t \x21= y)\x0a"
"\x09\x09\x09return x - 1;\x0a"
"\x09} else if (y > t) {\x0a"
"\x09\x09""do {\x0a"
"\x09\x09\x09--x;\x0a"
"\x09\x09\x09y = x - leapcorr(\x26x);\x0a"
"\x09\x09} while (y > t);\x0a"
"\x09\x09if (t \x21= y)\x0a"
"\x09\x09\x09return x + 1;\x0a"
"\x09}\x0a"
"\x09return x;\x0a"
"}\x0a"
"\x0a"
"#endif /* defined STD_INSPIRED */\x0a"
"", 47799 ); }