#include <string_view>
namespace divine::str::dios {
extern const std::string_view libc_uchar_c16rtomb_c( 
"/* c16rtomb( char *, char16_t, mbstate_t * )\x0a"
"\x0a"
"   This file is part of the Public Domain C Library (PDCLib).\x0a"
"   Permission is granted to use, modify, and / or redistribute at will.\x0a"
"*/\x0a"
"\x0a"
"#ifndef REGTEST\x0a"
"#include <uchar.h>\x0a"
"#include <errno.h>\x0a"
"#include <stdint.h>\x0a"
"#include <assert.h>\x0a"
"#include <stdlib.h>\x0a"
"#include \x22_PDCLIB/encoding.h\x22\x0a"
"#include \x22_PDCLIB/locale.h\x22\x0a"
"\x0a"
"size_t c16rtomb_l(\x0a"
"    char        *restrict   s, \x0a"
"    char16_t                c16,\x0a"
"    mbstate_t   *restrict   ps,\x0a"
"    locale_t     restrict   l\x0a"
")\x0a"
"{\x0a"
"    const char16_t *restrict psrc = \x26""c16;\x0a"
"    char buf\x5bs \x3f 0 \x3a MB_CUR_MAX\x5d;\x0a"
"    s =      s \x3f s \x3a buf;\x0a"
"\x0a"
"    if(\x21l->_Codec->__c16stombs) {\x0a"
"        // Codec doesn't support direct conversion - translate via UCS-4\x0a"
"        if(ps->_Surrogate == 0) {\x0a"
"            // No pending surrogate\x0a"
"            if((c16 \x26 0xF800) == 0xD800) {\x0a"
"                // Surrogate range\x0a"
"                if((c16 \x26 0x0400) == 0) {\x0a"
"                    // 0xD800 -> 0xDBFF leading surrogate\x0a"
"                    ps->_Surrogate = c16;\x0a"
"\x0a"
"                    // Need more data\x0a"
"                    // Return 0 - we haven't output anything yet\x0a"
"\x0a"
"                    /* STD\x3a ISO/IEC 9899\x3a""2011 is very implcifit about this being\x0a"
"                     *      the correct return value. N1040, from which the \x0a"
"                     *      function was adopted, is explicit about 0 being a \x0a"
"                     *      valid return.\x0a"
"                     */\x0a"
"                    return (size_t) 0;\x0a"
"                } else {\x0a"
"                    // 0xDC00 -> 0xDFFF trailing surrogate\x0a"
"                    errno = EILSEQ;\x0a"
"                    return (size_t) -1;\x0a"
"                }\x0a"
"            } else {\x0a"
"                // BMP range - UTF16 == UCS-4, pass through to c32rtomb_l\x0a"
"                return c32rtomb_l(s, c16, ps, l);\x0a"
"            }\x0a"
"        } else {\x0a"
"            // We have a stored surrogate\x0a"
"            if((c16 \x26 0xFC00) == 0xDC00) {\x0a"
"                // Trailing surrogate\x0a"
"                char32_t c32 = (ps->_Surrogate \x26 0x3FF) << 10 \x7c (c16 \x26 0x3FF);\x0a"
"                ps->_Surrogate = 0;\x0a"
"                return c32rtomb_l(s, c32, ps, l);\x0a"
"            } else {\x0a"
"                // Not a trailing surrogate - encoding error\x0a"
"                errno = EILSEQ;\x0a"
"                return (size_t) -1;\x0a"
"            }\x0a"
"\x0a"
"        }\x0a"
"    } else {\x0a"
"        // Codec supports direct conversion\x0a"
"        size_t srcsz  = 1;\x0a"
"        size_t dstsz  = MB_CUR_MAX;\x0a"
"        size_t dstrem = dstsz;\x0a"
"\x0a"
"        if(l->_Codec->__c16stombs(\x26s, \x26""dstrem, \x26psrc, \x26srcsz, ps)) {\x0a"
"            // Successful conversion\x0a"
"            return dstsz - dstrem;\x0a"
"        } else {\x0a"
"            errno = EILSEQ;\x0a"
"            return (size_t) -1;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"size_t c16rtomb(\x0a"
"    char        *restrict   s, \x0a"
"    char16_t                c16,\x0a"
"    mbstate_t   *restrict   ps\x0a"
")\x0a"
"{\x0a"
"    return c16rtomb_l(s, c16, ps, _PDCLIB_threadlocale());\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef TEST\x0a"
"#include \x22_PDCLIB_test.h\x22\x0a"
"\x0a"
"int main( void )\x0a"
"{\x0a"
"    TESTCASE( NO_TESTDRIVER );\x0a"
"    return TEST_RESULTS;\x0a"
"}\x0a"
"#endif\x0a"
"", 2970 ); }