#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include___bsd_locale_fallbacks_h( 
"// -*- C++ -*-\x0a"
"//===---------------------- __bsd_locale_fallbacks.h ----------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"// The BSDs have lots of *_l functions.  This file provides reimplementations\x0a"
"// of those functions for non-BSD platforms.\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_BSD_LOCALE_FALLBACKS_DEFAULTS_H\x0a"
"#define _LIBCPP_BSD_LOCALE_FALLBACKS_DEFAULTS_H\x0a"
"\x0a"
"#include <stdlib.h>\x0a"
"#include <stdarg.h>\x0a"
"#include <memory>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"decltype(MB_CUR_MAX) __libcpp_mb_cur_max_l(locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return MB_CUR_MAX;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"wint_t __libcpp_btowc_l(int __c, locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return btowc(__c);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"int __libcpp_wctob_l(wint_t __c, locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return wctob(__c);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"size_t __libcpp_wcsnrtombs_l(char *__dest, const wchar_t **__src, size_t __nwc,\x0a"
"                         size_t __len, mbstate_t *__ps, locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return wcsnrtombs(__dest, __src, __nwc, __len, __ps);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"size_t __libcpp_wcrtomb_l(char *__s, wchar_t __wc, mbstate_t *__ps, locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return wcrtomb(__s, __wc, __ps);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"size_t __libcpp_mbsnrtowcs_l(wchar_t * __dest, const char **__src, size_t __nms,\x0a"
"                      size_t __len, mbstate_t *__ps, locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return mbsnrtowcs(__dest, __src, __nms, __len, __ps);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"size_t __libcpp_mbrtowc_l(wchar_t *__pwc, const char *__s, size_t __n,\x0a"
"                   mbstate_t *__ps, locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return mbrtowc(__pwc, __s, __n, __ps);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"int __libcpp_mbtowc_l(wchar_t *__pwc, const char *__pmb, size_t __max, locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return mbtowc(__pwc, __pmb, __max);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"size_t __libcpp_mbrlen_l(const char *__s, size_t __n, mbstate_t *__ps, locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return mbrlen(__s, __n, __ps);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"lconv *__libcpp_localeconv_l(locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return localeconv();\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"size_t __libcpp_mbsrtowcs_l(wchar_t *__dest, const char **__src, size_t __len,\x0a"
"                     mbstate_t *__ps, locale_t __l)\x0a"
"{\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    return mbsrtowcs(__dest, __src, __len, __ps);\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"int __libcpp_snprintf_l(char *__s, size_t __n, locale_t __l, const char *__format, ...) {\x0a"
"    va_list __va;\x0a"
"    va_start(__va, __format);\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    int __res = vsnprintf(__s, __n, __format, __va);\x0a"
"    va_end(__va);\x0a"
"    return __res;\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"int __libcpp_asprintf_l(char **__s, locale_t __l, const char *__format, ...) {\x0a"
"    va_list __va;\x0a"
"    va_start(__va, __format);\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    int __res = vasprintf(__s, __format, __va);\x0a"
"    va_end(__va);\x0a"
"    return __res;\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"int __libcpp_sscanf_l(const char *__s, locale_t __l, const char *__format, ...) {\x0a"
"    va_list __va;\x0a"
"    va_start(__va, __format);\x0a"
"    __libcpp_locale_guard __current(__l);\x0a"
"    int __res = vsscanf(__s, __format, __va);\x0a"
"    va_end(__va);\x0a"
"    return __res;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // _LIBCPP_BSD_LOCALE_FALLBACKS_DEFAULTS_H\x0a"
"", 4032 ); }