#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include___errc( 
"// -*- C++ -*-\x0a"
"//===---------------------------- __errc ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP___ERRC\x0a"
"#define _LIBCPP___ERRC\x0a"
"\x0a"
"/*\x0a"
"    system_error synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"enum class errc\x0a"
"{\x0a"
"    address_family_not_supported,       // EAFNOSUPPORT\x0a"
"    address_in_use,                     // EADDRINUSE\x0a"
"    address_not_available,              // EADDRNOTAVAIL\x0a"
"    already_connected,                  // EISCONN\x0a"
"    argument_list_too_long,             // E2BIG\x0a"
"    argument_out_of_domain,             // EDOM\x0a"
"    bad_address,                        // EFAULT\x0a"
"    bad_file_descriptor,                // EBADF\x0a"
"    bad_message,                        // EBADMSG\x0a"
"    broken_pipe,                        // EPIPE\x0a"
"    connection_aborted,                 // ECONNABORTED\x0a"
"    connection_already_in_progress,     // EALREADY\x0a"
"    connection_refused,                 // ECONNREFUSED\x0a"
"    connection_reset,                   // ECONNRESET\x0a"
"    cross_device_link,                  // EXDEV\x0a"
"    destination_address_required,       // EDESTADDRREQ\x0a"
"    device_or_resource_busy,            // EBUSY\x0a"
"    directory_not_empty,                // ENOTEMPTY\x0a"
"    executable_format_error,            // ENOEXEC\x0a"
"    file_exists,                        // EEXIST\x0a"
"    file_too_large,                     // EFBIG\x0a"
"    filename_too_long,                  // ENAMETOOLONG\x0a"
"    function_not_supported,             // ENOSYS\x0a"
"    host_unreachable,                   // EHOSTUNREACH\x0a"
"    identifier_removed,                 // EIDRM\x0a"
"    illegal_byte_sequence,              // EILSEQ\x0a"
"    inappropriate_io_control_operation, // ENOTTY\x0a"
"    interrupted,                        // EINTR\x0a"
"    invalid_argument,                   // EINVAL\x0a"
"    invalid_seek,                       // ESPIPE\x0a"
"    io_error,                           // EIO\x0a"
"    is_a_directory,                     // EISDIR\x0a"
"    message_size,                       // EMSGSIZE\x0a"
"    network_down,                       // ENETDOWN\x0a"
"    network_reset,                      // ENETRESET\x0a"
"    network_unreachable,                // ENETUNREACH\x0a"
"    no_buffer_space,                    // ENOBUFS\x0a"
"    no_child_process,                   // ECHILD\x0a"
"    no_link,                            // ENOLINK\x0a"
"    no_lock_available,                  // ENOLCK\x0a"
"    no_message_available,               // ENODATA\x0a"
"    no_message,                         // ENOMSG\x0a"
"    no_protocol_option,                 // ENOPROTOOPT\x0a"
"    no_space_on_device,                 // ENOSPC\x0a"
"    no_stream_resources,                // ENOSR\x0a"
"    no_such_device_or_address,          // ENXIO\x0a"
"    no_such_device,                     // ENODEV\x0a"
"    no_such_file_or_directory,          // ENOENT\x0a"
"    no_such_process,                    // ESRCH\x0a"
"    not_a_directory,                    // ENOTDIR\x0a"
"    not_a_socket,                       // ENOTSOCK\x0a"
"    not_a_stream,                       // ENOSTR\x0a"
"    not_connected,                      // ENOTCONN\x0a"
"    not_enough_memory,                  // ENOMEM\x0a"
"    not_supported,                      // ENOTSUP\x0a"
"    operation_canceled,                 // ECANCELED\x0a"
"    operation_in_progress,              // EINPROGRESS\x0a"
"    operation_not_permitted,            // EPERM\x0a"
"    operation_not_supported,            // EOPNOTSUPP\x0a"
"    operation_would_block,              // EWOULDBLOCK\x0a"
"    owner_dead,                         // EOWNERDEAD\x0a"
"    permission_denied,                  // EACCES\x0a"
"    protocol_error,                     // EPROTO\x0a"
"    protocol_not_supported,             // EPROTONOSUPPORT\x0a"
"    read_only_file_system,              // EROFS\x0a"
"    resource_deadlock_would_occur,      // EDEADLK\x0a"
"    resource_unavailable_try_again,     // EAGAIN\x0a"
"    result_out_of_range,                // ERANGE\x0a"
"    state_not_recoverable,              // ENOTRECOVERABLE\x0a"
"    stream_timeout,                     // ETIME\x0a"
"    text_file_busy,                     // ETXTBSY\x0a"
"    timed_out,                          // ETIMEDOUT\x0a"
"    too_many_files_open_in_system,      // ENFILE\x0a"
"    too_many_files_open,                // EMFILE\x0a"
"    too_many_links,                     // EMLINK\x0a"
"    too_many_symbolic_link_levels,      // ELOOP\x0a"
"    value_too_large,                    // EOVERFLOW\x0a"
"    wrong_protocol_type                 // EPROTOTYPE\x0a"
"};\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <cerrno>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// Some error codes are not present on all platforms, so we provide equivalents\x0a"
"// for them\x3a\x0a"
"\x0a"
"//enum class errc\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM(errc)\x0a"
"{\x0a"
"    address_family_not_supported        = EAFNOSUPPORT,\x0a"
"    address_in_use                      = EADDRINUSE,\x0a"
"    address_not_available               = EADDRNOTAVAIL,\x0a"
"    already_connected                   = EISCONN,\x0a"
"    argument_list_too_long              = E2BIG,\x0a"
"    argument_out_of_domain              = EDOM,\x0a"
"    bad_address                         = EFAULT,\x0a"
"    bad_file_descriptor                 = EBADF,\x0a"
"    bad_message                         = EBADMSG,\x0a"
"    broken_pipe                         = EPIPE,\x0a"
"    connection_aborted                  = ECONNABORTED,\x0a"
"    connection_already_in_progress      = EALREADY,\x0a"
"    connection_refused                  = ECONNREFUSED,\x0a"
"    connection_reset                    = ECONNRESET,\x0a"
"    cross_device_link                   = EXDEV,\x0a"
"    destination_address_required        = EDESTADDRREQ,\x0a"
"    device_or_resource_busy             = EBUSY,\x0a"
"    directory_not_empty                 = ENOTEMPTY,\x0a"
"    executable_format_error             = ENOEXEC,\x0a"
"    file_exists                         = EEXIST,\x0a"
"    file_too_large                      = EFBIG,\x0a"
"    filename_too_long                   = ENAMETOOLONG,\x0a"
"    function_not_supported              = ENOSYS,\x0a"
"    host_unreachable                    = EHOSTUNREACH,\x0a"
"    identifier_removed                  = EIDRM,\x0a"
"    illegal_byte_sequence               = EILSEQ,\x0a"
"    inappropriate_io_control_operation  = ENOTTY,\x0a"
"    interrupted                         = EINTR,\x0a"
"    invalid_argument                    = EINVAL,\x0a"
"    invalid_seek                        = ESPIPE,\x0a"
"    io_error                            = EIO,\x0a"
"    is_a_directory                      = EISDIR,\x0a"
"    message_size                        = EMSGSIZE,\x0a"
"    network_down                        = ENETDOWN,\x0a"
"    network_reset                       = ENETRESET,\x0a"
"    network_unreachable                 = ENETUNREACH,\x0a"
"    no_buffer_space                     = ENOBUFS,\x0a"
"    no_child_process                    = ECHILD,\x0a"
"    no_link                             = ENOLINK,\x0a"
"    no_lock_available                   = ENOLCK,\x0a"
"#ifdef ENODATA\x0a"
"    no_message_available                = ENODATA,\x0a"
"#else\x0a"
"    no_message_available                = ENOMSG,\x0a"
"#endif\x0a"
"    no_message                          = ENOMSG,\x0a"
"    no_protocol_option                  = ENOPROTOOPT,\x0a"
"    no_space_on_device                  = ENOSPC,\x0a"
"#ifdef ENOSR\x0a"
"    no_stream_resources                 = ENOSR,\x0a"
"#else\x0a"
"    no_stream_resources                 = ENOMEM,\x0a"
"#endif\x0a"
"    no_such_device_or_address           = ENXIO,\x0a"
"    no_such_device                      = ENODEV,\x0a"
"    no_such_file_or_directory           = ENOENT,\x0a"
"    no_such_process                     = ESRCH,\x0a"
"    not_a_directory                     = ENOTDIR,\x0a"
"    not_a_socket                        = ENOTSOCK,\x0a"
"#ifdef ENOSTR\x0a"
"    not_a_stream                        = ENOSTR,\x0a"
"#else\x0a"
"    not_a_stream                        = EINVAL,\x0a"
"#endif\x0a"
"    not_connected                       = ENOTCONN,\x0a"
"    not_enough_memory                   = ENOMEM,\x0a"
"    not_supported                       = ENOTSUP,\x0a"
"    operation_canceled                  = ECANCELED,\x0a"
"    operation_in_progress               = EINPROGRESS,\x0a"
"    operation_not_permitted             = EPERM,\x0a"
"    operation_not_supported             = EOPNOTSUPP,\x0a"
"    operation_would_block               = EWOULDBLOCK,\x0a"
"    owner_dead                          = EOWNERDEAD,\x0a"
"    permission_denied                   = EACCES,\x0a"
"    protocol_error                      = EPROTO,\x0a"
"    protocol_not_supported              = EPROTONOSUPPORT,\x0a"
"    read_only_file_system               = EROFS,\x0a"
"    resource_deadlock_would_occur       = EDEADLK,\x0a"
"    resource_unavailable_try_again      = EAGAIN,\x0a"
"    result_out_of_range                 = ERANGE,\x0a"
"    state_not_recoverable               = ENOTRECOVERABLE,\x0a"
"#ifdef ETIME\x0a"
"    stream_timeout                      = ETIME,\x0a"
"#else\x0a"
"    stream_timeout                      = ETIMEDOUT,\x0a"
"#endif\x0a"
"    text_file_busy                      = ETXTBSY,\x0a"
"    timed_out                           = ETIMEDOUT,\x0a"
"    too_many_files_open_in_system       = ENFILE,\x0a"
"    too_many_files_open                 = EMFILE,\x0a"
"    too_many_links                      = EMLINK,\x0a"
"    too_many_symbolic_link_levels       = ELOOP,\x0a"
"    value_too_large                     = EOVERFLOW,\x0a"
"    wrong_protocol_type                 = EPROTOTYPE\x0a"
"};\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM_EPILOG(errc)\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP___ERRC\x0a"
"", 9244 ); }