#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include___mutex_base( 
"// -*- C++ -*-\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP___MUTEX_BASE\x0a"
"#define _LIBCPP___MUTEX_BASE\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <chrono>\x0a"
"#include <system_error>\x0a"
"#include <__threading_support>\x0a"
"\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"#ifndef _LIBCPP_THREAD_SAFETY_ANNOTATION\x0a"
"#  ifdef _LIBCPP_HAS_THREAD_SAFETY_ANNOTATIONS\x0a"
"#    define _LIBCPP_THREAD_SAFETY_ANNOTATION(x) __attribute__((x))\x0a"
"#  else\x0a"
"#    define _LIBCPP_THREAD_SAFETY_ANNOTATION(x)\x0a"
"#  endif\x0a"
"#endif  // _LIBCPP_THREAD_SAFETY_ANNOTATION\x0a"
"\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS _LIBCPP_THREAD_SAFETY_ANNOTATION(capability(\x22mutex\x22)) mutex\x0a"
"{\x0a"
"    __libcpp_mutex_t __m_ = _LIBCPP_MUTEX_INITIALIZER;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR mutex() = default;\x0a"
"\x0a"
"    mutex(const mutex\x26) = delete;\x0a"
"    mutex\x26 operator=(const mutex\x26) = delete;\x0a"
"\x0a"
"#if defined(_LIBCPP_HAS_TRIVIAL_MUTEX_DESTRUCTION)\x0a"
"    \x7emutex() = default;\x0a"
"#else\x0a"
"    \x7emutex() _NOEXCEPT;\x0a"
"#endif\x0a"
"\x0a"
"    void lock() _LIBCPP_THREAD_SAFETY_ANNOTATION(acquire_capability());\x0a"
"    bool try_lock() _NOEXCEPT _LIBCPP_THREAD_SAFETY_ANNOTATION(try_acquire_capability(true));\x0a"
"    void unlock() _NOEXCEPT _LIBCPP_THREAD_SAFETY_ANNOTATION(release_capability());\x0a"
"\x0a"
"    typedef __libcpp_mutex_t* native_handle_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY native_handle_type native_handle() {return \x26__m_;}\x0a"
"};\x0a"
"\x0a"
"static_assert(is_nothrow_default_constructible<mutex>\x3a\x3avalue,\x0a"
"              \x22the default constructor for std\x3a\x3amutex must be nothrow\x22);\x0a"
"\x0a"
"struct _LIBCPP_TYPE_VIS defer_lock_t {};\x0a"
"struct _LIBCPP_TYPE_VIS try_to_lock_t {};\x0a"
"struct _LIBCPP_TYPE_VIS adopt_lock_t {};\x0a"
"\x0a"
"#if defined(_LIBCPP_CXX03_LANG) \x7c\x7c defined(_LIBCPP_BUILDING_LIBRARY)\x0a"
"\x0a"
"extern _LIBCPP_EXPORTED_FROM_ABI const defer_lock_t  defer_lock;\x0a"
"extern _LIBCPP_EXPORTED_FROM_ABI const try_to_lock_t try_to_lock;\x0a"
"extern _LIBCPP_EXPORTED_FROM_ABI const adopt_lock_t  adopt_lock;\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr defer_lock_t  defer_lock  = defer_lock_t();\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr try_to_lock_t try_to_lock = try_to_lock_t();\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr adopt_lock_t  adopt_lock  = adopt_lock_t();\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_THREAD_SAFETY_ANNOTATION(scoped_lockable)\x0a"
"lock_guard\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Mutex mutex_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    mutex_type\x26 __m_;\x0a"
"public\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit lock_guard(mutex_type\x26 __m) _LIBCPP_THREAD_SAFETY_ANNOTATION(acquire_capability(__m))\x0a"
"        \x3a __m_(__m) {__m_.lock();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    lock_guard(mutex_type\x26 __m, adopt_lock_t) _LIBCPP_THREAD_SAFETY_ANNOTATION(requires_capability(__m))\x0a"
"        \x3a __m_(__m) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7elock_guard() _LIBCPP_THREAD_SAFETY_ANNOTATION(release_capability()) {__m_.unlock();}\x0a"
"\x0a"
"private\x3a\x0a"
"    lock_guard(lock_guard const\x26) _LIBCPP_EQUAL_DELETE;\x0a"
"    lock_guard\x26 operator=(lock_guard const\x26) _LIBCPP_EQUAL_DELETE;\x0a"
"};\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"class _LIBCPP_TEMPLATE_VIS unique_lock\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Mutex mutex_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    mutex_type* __m_;\x0a"
"    bool __owns_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unique_lock() _NOEXCEPT \x3a __m_(nullptr), __owns_(false) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit unique_lock(mutex_type\x26 __m)\x0a"
"        \x3a __m_(_VSTD\x3a\x3a""addressof(__m)), __owns_(true) {__m_->lock();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unique_lock(mutex_type\x26 __m, defer_lock_t) _NOEXCEPT\x0a"
"        \x3a __m_(_VSTD\x3a\x3a""addressof(__m)), __owns_(false) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unique_lock(mutex_type\x26 __m, try_to_lock_t)\x0a"
"        \x3a __m_(_VSTD\x3a\x3a""addressof(__m)), __owns_(__m.try_lock()) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unique_lock(mutex_type\x26 __m, adopt_lock_t)\x0a"
"        \x3a __m_(_VSTD\x3a\x3a""addressof(__m)), __owns_(true) {}\x0a"
"    template <class _Clock, class _Duration>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        unique_lock(mutex_type\x26 __m, const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t)\x0a"
"            \x3a __m_(_VSTD\x3a\x3a""addressof(__m)), __owns_(__m.try_lock_until(__t)) {}\x0a"
"    template <class _Rep, class _Period>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        unique_lock(mutex_type\x26 __m, const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d)\x0a"
"            \x3a __m_(_VSTD\x3a\x3a""addressof(__m)), __owns_(__m.try_lock_for(__d)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7eunique_lock()\x0a"
"    {\x0a"
"        if (__owns_)\x0a"
"            __m_->unlock();\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    unique_lock(unique_lock const\x26); // = delete;\x0a"
"    unique_lock\x26 operator=(unique_lock const\x26); // = delete;\x0a"
"\x0a"
"public\x3a\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unique_lock(unique_lock\x26\x26 __u) _NOEXCEPT\x0a"
"        \x3a __m_(__u.__m_), __owns_(__u.__owns_)\x0a"
"        {__u.__m_ = nullptr; __u.__owns_ = false;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unique_lock\x26 operator=(unique_lock\x26\x26 __u) _NOEXCEPT\x0a"
"        {\x0a"
"            if (__owns_)\x0a"
"                __m_->unlock();\x0a"
"            __m_ = __u.__m_;\x0a"
"            __owns_ = __u.__owns_;\x0a"
"            __u.__m_ = nullptr;\x0a"
"            __u.__owns_ = false;\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    void lock();\x0a"
"    bool try_lock();\x0a"
"\x0a"
"    template <class _Rep, class _Period>\x0a"
"        bool try_lock_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d);\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        bool try_lock_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t);\x0a"
"\x0a"
"    void unlock();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(unique_lock\x26 __u) _NOEXCEPT\x0a"
"    {\x0a"
"        _VSTD\x3a\x3aswap(__m_, __u.__m_);\x0a"
"        _VSTD\x3a\x3aswap(__owns_, __u.__owns_);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    mutex_type* release() _NOEXCEPT\x0a"
"    {\x0a"
"        mutex_type* __m = __m_;\x0a"
"        __m_ = nullptr;\x0a"
"        __owns_ = false;\x0a"
"        return __m;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool owns_lock() const _NOEXCEPT {return __owns_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_EXPLICIT\x0a"
"        operator bool () const _NOEXCEPT {return __owns_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    mutex_type* mutex() const _NOEXCEPT {return __m_;}\x0a"
"};\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"void\x0a"
"unique_lock<_Mutex>\x3a\x3alock()\x0a"
"{\x0a"
"    if (__m_ == nullptr)\x0a"
"        __throw_system_error(EPERM, \x22unique_lock\x3a\x3alock\x3a references null mutex\x22);\x0a"
"    if (__owns_)\x0a"
"        __throw_system_error(EDEADLK, \x22unique_lock\x3a\x3alock\x3a already locked\x22);\x0a"
"    __m_->lock();\x0a"
"    __owns_ = true;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"bool\x0a"
"unique_lock<_Mutex>\x3a\x3atry_lock()\x0a"
"{\x0a"
"    if (__m_ == nullptr)\x0a"
"        __throw_system_error(EPERM, \x22unique_lock\x3a\x3atry_lock\x3a references null mutex\x22);\x0a"
"    if (__owns_)\x0a"
"        __throw_system_error(EDEADLK, \x22unique_lock\x3a\x3atry_lock\x3a already locked\x22);\x0a"
"    __owns_ = __m_->try_lock();\x0a"
"    return __owns_;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"template <class _Rep, class _Period>\x0a"
"bool\x0a"
"unique_lock<_Mutex>\x3a\x3atry_lock_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d)\x0a"
"{\x0a"
"    if (__m_ == nullptr)\x0a"
"        __throw_system_error(EPERM, \x22unique_lock\x3a\x3atry_lock_for\x3a references null mutex\x22);\x0a"
"    if (__owns_)\x0a"
"        __throw_system_error(EDEADLK, \x22unique_lock\x3a\x3atry_lock_for\x3a already locked\x22);\x0a"
"    __owns_ = __m_->try_lock_for(__d);\x0a"
"    return __owns_;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"template <class _Clock, class _Duration>\x0a"
"bool\x0a"
"unique_lock<_Mutex>\x3a\x3atry_lock_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    if (__m_ == nullptr)\x0a"
"        __throw_system_error(EPERM, \x22unique_lock\x3a\x3atry_lock_until\x3a references null mutex\x22);\x0a"
"    if (__owns_)\x0a"
"        __throw_system_error(EDEADLK, \x22unique_lock\x3a\x3atry_lock_until\x3a already locked\x22);\x0a"
"    __owns_ = __m_->try_lock_until(__t);\x0a"
"    return __owns_;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"void\x0a"
"unique_lock<_Mutex>\x3a\x3aunlock()\x0a"
"{\x0a"
"    if (\x21__owns_)\x0a"
"        __throw_system_error(EPERM, \x22unique_lock\x3a\x3aunlock\x3a not locked\x22);\x0a"
"    __m_->unlock();\x0a"
"    __owns_ = false;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(unique_lock<_Mutex>\x26 __x, unique_lock<_Mutex>\x26 __y) _NOEXCEPT\x0a"
"    {__x.swap(__y);}\x0a"
"\x0a"
"//enum class cv_status\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM(cv_status)\x0a"
"{\x0a"
"    no_timeout,\x0a"
"    timeout\x0a"
"};\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM_EPILOG(cv_status)\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS condition_variable\x0a"
"{\x0a"
"    __libcpp_condvar_t __cv_ = _LIBCPP_CONDVAR_INITIALIZER;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR condition_variable() _NOEXCEPT = default;\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_TRIVIAL_CONDVAR_DESTRUCTION\x0a"
"    \x7e""condition_variable() = default;\x0a"
"#else\x0a"
"    \x7e""condition_variable();\x0a"
"#endif\x0a"
"\x0a"
"    condition_variable(const condition_variable\x26) = delete;\x0a"
"    condition_variable\x26 operator=(const condition_variable\x26) = delete;\x0a"
"\x0a"
"    void notify_one() _NOEXCEPT;\x0a"
"    void notify_all() _NOEXCEPT;\x0a"
"\x0a"
"    void wait(unique_lock<mutex>\x26 __lk) _NOEXCEPT;\x0a"
"    template <class _Predicate>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        void wait(unique_lock<mutex>\x26 __lk, _Predicate __pred);\x0a"
"\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        cv_status\x0a"
"        wait_until(unique_lock<mutex>\x26 __lk,\x0a"
"                   const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t);\x0a"
"\x0a"
"    template <class _Clock, class _Duration, class _Predicate>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        bool\x0a"
"        wait_until(unique_lock<mutex>\x26 __lk,\x0a"
"                   const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t,\x0a"
"                   _Predicate __pred);\x0a"
"\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        cv_status\x0a"
"        wait_for(unique_lock<mutex>\x26 __lk,\x0a"
"                 const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d);\x0a"
"\x0a"
"    template <class _Rep, class _Period, class _Predicate>\x0a"
"        bool\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        wait_for(unique_lock<mutex>\x26 __lk,\x0a"
"                 const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d,\x0a"
"                 _Predicate __pred);\x0a"
"\x0a"
"    typedef __libcpp_condvar_t* native_handle_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY native_handle_type native_handle() {return \x26__cv_;}\x0a"
"\x0a"
"private\x3a\x0a"
"    void __do_timed_wait(unique_lock<mutex>\x26 __lk,\x0a"
"       chrono\x3a\x3atime_point<chrono\x3a\x3asystem_clock, chrono\x3a\x3ananoseconds>) _NOEXCEPT;\x0a"
"};\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"template <class _To, class _Rep, class _Period>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    chrono\x3a\x3a__is_duration<_To>\x3a\x3avalue,\x0a"
"    _To\x0a"
">\x3a\x3atype\x0a"
"__ceil(chrono\x3a\x3a""duration<_Rep, _Period> __d)\x0a"
"{\x0a"
"    using namespace chrono;\x0a"
"    _To __r = duration_cast<_To>(__d);\x0a"
"    if (__r < __d)\x0a"
"        ++__r;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"template <class _Predicate>\x0a"
"void\x0a"
"condition_variable\x3a\x3await(unique_lock<mutex>\x26 __lk, _Predicate __pred)\x0a"
"{\x0a"
"    while (\x21__pred())\x0a"
"        wait(__lk);\x0a"
"}\x0a"
"\x0a"
"template <class _Clock, class _Duration>\x0a"
"cv_status\x0a"
"condition_variable\x3a\x3await_until(unique_lock<mutex>\x26 __lk,\x0a"
"                               const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    using namespace chrono;\x0a"
"    wait_for(__lk, __t - _Clock\x3a\x3anow());\x0a"
"    return _Clock\x3a\x3anow() < __t \x3f cv_status\x3a\x3ano_timeout \x3a cv_status\x3a\x3atimeout;\x0a"
"}\x0a"
"\x0a"
"template <class _Clock, class _Duration, class _Predicate>\x0a"
"bool\x0a"
"condition_variable\x3a\x3await_until(unique_lock<mutex>\x26 __lk,\x0a"
"                   const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t,\x0a"
"                   _Predicate __pred)\x0a"
"{\x0a"
"    while (\x21__pred())\x0a"
"    {\x0a"
"        if (wait_until(__lk, __t) == cv_status\x3a\x3atimeout)\x0a"
"            return __pred();\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Rep, class _Period>\x0a"
"cv_status\x0a"
"condition_variable\x3a\x3await_for(unique_lock<mutex>\x26 __lk,\x0a"
"                             const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d)\x0a"
"{\x0a"
"    using namespace chrono;\x0a"
"    if (__d <= __d.zero())\x0a"
"        return cv_status\x3a\x3atimeout;\x0a"
"    typedef time_point<system_clock, duration<long double, nano> > __sys_tpf;\x0a"
"    typedef time_point<system_clock, nanoseconds> __sys_tpi;\x0a"
"    __sys_tpf _Max = __sys_tpi\x3a\x3amax();\x0a"
"    steady_clock\x3a\x3atime_point __c_now = steady_clock\x3a\x3anow();\x0a"
"    system_clock\x3a\x3atime_point __s_now = system_clock\x3a\x3anow();\x0a"
"    if (_Max - __d > __s_now)\x0a"
"        __do_timed_wait(__lk, __s_now + __ceil<nanoseconds>(__d));\x0a"
"    else\x0a"
"        __do_timed_wait(__lk, __sys_tpi\x3a\x3amax());\x0a"
"    return steady_clock\x3a\x3anow() - __c_now < __d \x3f cv_status\x3a\x3ano_timeout \x3a\x0a"
"                                                 cv_status\x3a\x3atimeout;\x0a"
"}\x0a"
"\x0a"
"template <class _Rep, class _Period, class _Predicate>\x0a"
"inline\x0a"
"bool\x0a"
"condition_variable\x3a\x3await_for(unique_lock<mutex>\x26 __lk,\x0a"
"                             const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d,\x0a"
"                             _Predicate __pred)\x0a"
"{\x0a"
"    return wait_until(__lk, chrono\x3a\x3asteady_clock\x3a\x3anow() + __d,\x0a"
"                      _VSTD\x3a\x3amove(__pred));\x0a"
"}\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP___MUTEX_BASE\x0a"
"", 12930 ); }