#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include___node_handle( 
"// -*- C++ -*-\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP___NODE_HANDLE\x0a"
"#define _LIBCPP___NODE_HANDLE\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <memory>\x0a"
"#include <optional>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"// Specialized in __tree \x26 __hash_table for their _NodeType.\x0a"
"template <class _NodeType, class _Alloc>\x0a"
"struct __generic_container_node_destructor;\x0a"
"\x0a"
"template <class _NodeType, class _Alloc,\x0a"
"          template <class, class> class _MapOrSetSpecifics>\x0a"
"class _LIBCPP_TEMPLATE_VIS __basic_node_handle\x0a"
"    \x3a public _MapOrSetSpecifics<\x0a"
"          _NodeType,\x0a"
"          __basic_node_handle<_NodeType, _Alloc, _MapOrSetSpecifics>>\x0a"
"{\x0a"
"    template <class _Tp, class _Compare, class _Allocator>\x0a"
"        friend class __tree;\x0a"
"    template <class _Tp, class _Hash, class _Equal, class _Allocator>\x0a"
"        friend class __hash_table;\x0a"
"    friend struct _MapOrSetSpecifics<\x0a"
"        _NodeType, __basic_node_handle<_NodeType, _Alloc, _MapOrSetSpecifics>>;\x0a"
"\x0a"
"    typedef allocator_traits<_Alloc> __alloc_traits;\x0a"
"    typedef typename __rebind_pointer<typename __alloc_traits\x3a\x3avoid_pointer,\x0a"
"                                      _NodeType>\x3a\x3atype\x0a"
"        __node_pointer_type;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _Alloc allocator_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    __node_pointer_type __ptr_ = nullptr;\x0a"
"    optional<allocator_type> __alloc_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __release_ptr()\x0a"
"    {\x0a"
"        __ptr_ = nullptr;\x0a"
"        __alloc_ = _VSTD\x3a\x3anullopt;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __destroy_node_pointer()\x0a"
"    {\x0a"
"        if (__ptr_ \x21= nullptr)\x0a"
"        {\x0a"
"            typedef typename __allocator_traits_rebind<\x0a"
"                allocator_type, _NodeType>\x3a\x3atype __node_alloc_type;\x0a"
"            __node_alloc_type __alloc(*__alloc_);\x0a"
"            __generic_container_node_destructor<_NodeType, __node_alloc_type>(\x0a"
"                __alloc, true)(__ptr_);\x0a"
"            __ptr_ = nullptr;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __basic_node_handle(__node_pointer_type __ptr,\x0a"
"                        allocator_type const\x26 __alloc)\x0a"
"            \x3a __ptr_(__ptr), __alloc_(__alloc)\x0a"
"    {\x0a"
"    }\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __basic_node_handle() = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __basic_node_handle(__basic_node_handle\x26\x26 __other) noexcept\x0a"
"            \x3a __ptr_(__other.__ptr_),\x0a"
"              __alloc_(_VSTD\x3a\x3amove(__other.__alloc_))\x0a"
"    {\x0a"
"        __other.__ptr_ = nullptr;\x0a"
"        __other.__alloc_ = _VSTD\x3a\x3anullopt;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __basic_node_handle\x26 operator=(__basic_node_handle\x26\x26 __other)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x0a"
"            __alloc_ == _VSTD\x3a\x3anullopt \x7c\x7c\x0a"
"            __alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"            __alloc_ == __other.__alloc_,\x0a"
"            \x22node_type with incompatible allocator passed to \x22\x0a"
"            \x22node_type\x3a\x3aoperator=(node_type\x26\x26)\x22);\x0a"
"\x0a"
"        __destroy_node_pointer();\x0a"
"        __ptr_ = __other.__ptr_;\x0a"
"\x0a"
"        if (__alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"            __alloc_ == _VSTD\x3a\x3anullopt)\x0a"
"            __alloc_ = _VSTD\x3a\x3amove(__other.__alloc_);\x0a"
"\x0a"
"        __other.__ptr_ = nullptr;\x0a"
"        __other.__alloc_ = _VSTD\x3a\x3anullopt;\x0a"
"\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const { return *__alloc_; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit operator bool() const { return __ptr_ \x21= nullptr; }\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const { return __ptr_ == nullptr; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(__basic_node_handle\x26 __other) noexcept(\x0a"
"        __alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"        __alloc_traits\x3a\x3ais_always_equal\x3a\x3avalue)\x0a"
"    {\x0a"
"        using _VSTD\x3a\x3aswap;\x0a"
"        swap(__ptr_, __other.__ptr_);\x0a"
"        if (__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"            __alloc_ == _VSTD\x3a\x3anullopt \x7c\x7c __other.__alloc_ == _VSTD\x3a\x3anullopt)\x0a"
"            swap(__alloc_, __other.__alloc_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    friend void swap(__basic_node_handle\x26 __a, __basic_node_handle\x26 __b)\x0a"
"        noexcept(noexcept(__a.swap(__b))) { __a.swap(__b); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e__basic_node_handle()\x0a"
"    {\x0a"
"        __destroy_node_pointer();\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _NodeType, class _Derived>\x0a"
"struct __set_node_handle_specifics\x0a"
"{\x0a"
"    typedef typename _NodeType\x3a\x3a__node_value_type value_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type\x26 value() const\x0a"
"    {\x0a"
"        return static_cast<_Derived const*>(this)->__ptr_->__value_;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _NodeType, class _Derived>\x0a"
"struct __map_node_handle_specifics\x0a"
"{\x0a"
"    typedef typename _NodeType\x3a\x3a__node_value_type\x3a\x3akey_type key_type;\x0a"
"    typedef typename _NodeType\x3a\x3a__node_value_type\x3a\x3amapped_type mapped_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_type\x26 key() const\x0a"
"    {\x0a"
"        return static_cast<_Derived const*>(this)->\x0a"
"            __ptr_->__value_.__ref().first;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    mapped_type\x26 mapped() const\x0a"
"    {\x0a"
"        return static_cast<_Derived const*>(this)->\x0a"
"            __ptr_->__value_.__ref().second;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _NodeType, class _Alloc>\x0a"
"using __set_node_handle =\x0a"
"    __basic_node_handle< _NodeType, _Alloc, __set_node_handle_specifics>;\x0a"
"\x0a"
"template <class _NodeType, class _Alloc>\x0a"
"using __map_node_handle =\x0a"
"    __basic_node_handle< _NodeType, _Alloc, __map_node_handle_specifics>;\x0a"
"\x0a"
"template <class _Iterator, class _NodeType>\x0a"
"struct _LIBCPP_TEMPLATE_VIS __insert_return_type\x0a"
"{\x0a"
"    _Iterator position;\x0a"
"    bool inserted;\x0a"
"    _NodeType node;\x0a"
"};\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif\x0a"
"", 6074 ); }