#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include___string( 
"// -*- C++ -*-\x0a"
"//===-------------------------- __string ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP___STRING\x0a"
"#define _LIBCPP___STRING\x0a"
"\x0a"
"/*\x0a"
"    string synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class charT>\x0a"
"struct char_traits\x0a"
"{\x0a"
"    typedef charT     char_type;\x0a"
"    typedef ...       int_type;\x0a"
"    typedef streamoff off_type;\x0a"
"    typedef streampos pos_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    static constexpr void assign(char_type\x26 c1, const char_type\x26 c2) noexcept;\x0a"
"    static constexpr bool eq(char_type c1, char_type c2) noexcept;\x0a"
"    static constexpr bool lt(char_type c1, char_type c2) noexcept;\x0a"
"\x0a"
"    static constexpr int    compare(const char_type* s1, const char_type* s2, size_t n);\x0a"
"    static constexpr size_t length(const char_type* s);\x0a"
"    static constexpr const char_type* \x0a"
"                            find(const char_type* s, size_t n, const char_type\x26 a);\x0a"
"    static char_type*       move(char_type* s1, const char_type* s2, size_t n);\x0a"
"    static char_type*       copy(char_type* s1, const char_type* s2, size_t n);\x0a"
"    static char_type*       assign(char_type* s, size_t n, char_type a);\x0a"
"\x0a"
"    static constexpr int_type  not_eof(int_type c) noexcept;\x0a"
"    static constexpr char_type to_char_type(int_type c) noexcept;\x0a"
"    static constexpr int_type  to_int_type(char_type c) noexcept;\x0a"
"    static constexpr bool      eq_int_type(int_type c1, int_type c2) noexcept;\x0a"
"    static constexpr int_type  eof() noexcept;\x0a"
"};\x0a"
"\x0a"
"template <> struct char_traits<char>;\x0a"
"template <> struct char_traits<wchar_t>;\x0a"
"template <> struct char_traits<char8_t>;  // c++20\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <algorithm>  // for search and min\x0a"
"#include <cstdio>     // For EOF.\x0a"
"#include <memory>     // for __murmur2_or_cityhash\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// char_traits\x0a"
"\x0a"
"template <class _CharT>\x0a"
"struct _LIBCPP_TEMPLATE_VIS char_traits\x0a"
"{\x0a"
"    typedef _CharT    char_type;\x0a"
"    typedef int       int_type;\x0a"
"    typedef streamoff off_type;\x0a"
"    typedef streampos pos_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    static inline void _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"        assign(char_type\x26 __c1, const char_type\x26 __c2) _NOEXCEPT {__c1 = __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool eq(char_type __c1, char_type __c2) _NOEXCEPT\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool lt(char_type __c1, char_type __c2) _NOEXCEPT\x0a"
"        {return __c1 < __c2;}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    int compare(const char_type* __s1, const char_type* __s2, size_t __n);\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    size_t length(const char_type* __s);\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const char_type* find(const char_type* __s, size_t __n, const char_type\x26 __a);\x0a"
"    static char_type*       move(char_type* __s1, const char_type* __s2, size_t __n);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static char_type*       copy(char_type* __s1, const char_type* __s2, size_t __n);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static char_type*       assign(char_type* __s, size_t __n, char_type __a);\x0a"
"\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type  not_eof(int_type __c) _NOEXCEPT\x0a"
"        {return eq_int_type(__c, eof()) \x3f \x7e""eof() \x3a __c;}\x0a"
"    static inline _LIBCPP_CONSTEXPR char_type to_char_type(int_type __c) _NOEXCEPT\x0a"
"        {return char_type(__c);}\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type  to_int_type(char_type __c) _NOEXCEPT\x0a"
"        {return int_type(__c);}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool      eq_int_type(int_type __c1, int_type __c2) _NOEXCEPT\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type  eof() _NOEXCEPT\x0a"
"        {return int_type(EOF);}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX14 int\x0a"
"char_traits<_CharT>\x3a\x3a""compare(const char_type* __s1, const char_type* __s2, size_t __n)\x0a"
"{\x0a"
"    for (; __n; --__n, ++__s1, ++__s2)\x0a"
"    {\x0a"
"        if (lt(*__s1, *__s2))\x0a"
"            return -1;\x0a"
"        if (lt(*__s2, *__s1))\x0a"
"            return 1;\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX14 size_t\x0a"
"char_traits<_CharT>\x3a\x3alength(const char_type* __s)\x0a"
"{\x0a"
"    size_t __len = 0;\x0a"
"    for (; \x21""eq(*__s, char_type(0)); ++__s)\x0a"
"        ++__len;\x0a"
"    return __len;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX14 const _CharT*\x0a"
"char_traits<_CharT>\x3a\x3a""find(const char_type* __s, size_t __n, const char_type\x26 __a)\x0a"
"{\x0a"
"    for (; __n; --__n)\x0a"
"    {\x0a"
"        if (eq(*__s, __a))\x0a"
"            return __s;\x0a"
"        ++__s;\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"_CharT*\x0a"
"char_traits<_CharT>\x3a\x3amove(char_type* __s1, const char_type* __s2, size_t __n)\x0a"
"{\x0a"
"    char_type* __r = __s1;\x0a"
"    if (__s1 < __s2)\x0a"
"    {\x0a"
"        for (; __n; --__n, ++__s1, ++__s2)\x0a"
"            assign(*__s1, *__s2);\x0a"
"    }\x0a"
"    else if (__s2 < __s1)\x0a"
"    {\x0a"
"        __s1 += __n;\x0a"
"        __s2 += __n;\x0a"
"        for (; __n; --__n)\x0a"
"            assign(*--__s1, *--__s2);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"inline\x0a"
"_CharT*\x0a"
"char_traits<_CharT>\x3a\x3a""copy(char_type* __s1, const char_type* __s2, size_t __n)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s2 < __s1 \x7c\x7c __s2 >= __s1+__n, \x22""char_traits\x3a\x3a""copy overlapped range\x22);\x0a"
"    char_type* __r = __s1;\x0a"
"    for (; __n; --__n, ++__s1, ++__s2)\x0a"
"        assign(*__s1, *__s2);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"inline\x0a"
"_CharT*\x0a"
"char_traits<_CharT>\x3a\x3a""assign(char_type* __s, size_t __n, char_type __a)\x0a"
"{\x0a"
"    char_type* __r = __s;\x0a"
"    for (; __n; --__n, ++__s)\x0a"
"        assign(*__s, __a);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// char_traits<char>\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS char_traits<char>\x0a"
"{\x0a"
"    typedef char      char_type;\x0a"
"    typedef int       int_type;\x0a"
"    typedef streamoff off_type;\x0a"
"    typedef streampos pos_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    static inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    void assign(char_type\x26 __c1, const char_type\x26 __c2) _NOEXCEPT {__c1 = __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool eq(char_type __c1, char_type __c2) _NOEXCEPT\x0a"
"            {return __c1 == __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool lt(char_type __c1, char_type __c2) _NOEXCEPT\x0a"
"        {return (unsigned char)__c1 < (unsigned char)__c2;}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    int compare(const char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT;\x0a"
"    static inline size_t _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    length(const char_type* __s)  _NOEXCEPT {return __builtin_strlen(__s);}\x0a"
"    static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const char_type* find(const char_type* __s, size_t __n, const char_type\x26 __a) _NOEXCEPT;\x0a"
"    static inline char_type* move(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"        {return __n == 0 \x3f __s1 \x3a (char_type*) memmove(__s1, __s2, __n);}\x0a"
"    static inline char_type* copy(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"        {\x0a"
"            _LIBCPP_ASSERT(__s2 < __s1 \x7c\x7c __s2 >= __s1+__n, \x22""char_traits\x3a\x3a""copy overlapped range\x22);\x0a"
"            return __n == 0 \x3f __s1 \x3a (char_type*)memcpy(__s1, __s2, __n);\x0a"
"        }\x0a"
"    static inline char_type* assign(char_type* __s, size_t __n, char_type __a) _NOEXCEPT\x0a"
"        {return __n == 0 \x3f __s \x3a (char_type*)memset(__s, to_int_type(__a), __n);}\x0a"
"\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type  not_eof(int_type __c) _NOEXCEPT\x0a"
"        {return eq_int_type(__c, eof()) \x3f \x7e""eof() \x3a __c;}\x0a"
"    static inline _LIBCPP_CONSTEXPR char_type to_char_type(int_type __c) _NOEXCEPT\x0a"
"        {return char_type(__c);}\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type to_int_type(char_type __c) _NOEXCEPT\x0a"
"        {return int_type((unsigned char)__c);}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool eq_int_type(int_type __c1, int_type __c2) _NOEXCEPT\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type  eof() _NOEXCEPT\x0a"
"        {return int_type(EOF);}\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"int\x0a"
"char_traits<char>\x3a\x3a""compare(const char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"{\x0a"
"    if (__n == 0)\x0a"
"        return 0;\x0a"
"#if __has_feature(cxx_constexpr_string_builtins)\x0a"
"    return __builtin_memcmp(__s1, __s2, __n);\x0a"
"#elif _LIBCPP_STD_VER <= 14\x0a"
"    return memcmp(__s1, __s2, __n);\x0a"
"#else\x0a"
"    for (; __n; --__n, ++__s1, ++__s2)\x0a"
"    {\x0a"
"        if (lt(*__s1, *__s2))\x0a"
"            return -1;\x0a"
"        if (lt(*__s2, *__s1))\x0a"
"            return 1;\x0a"
"    }\x0a"
"    return 0;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"const char*\x0a"
"char_traits<char>\x3a\x3a""find(const char_type* __s, size_t __n, const char_type\x26 __a) _NOEXCEPT\x0a"
"{\x0a"
"    if (__n == 0)\x0a"
"        return nullptr;\x0a"
"#if __has_feature(cxx_constexpr_string_builtins)\x0a"
"    return __builtin_char_memchr(__s, to_int_type(__a), __n);\x0a"
"#elif _LIBCPP_STD_VER <= 14\x0a"
"    return (const char_type*) memchr(__s, to_int_type(__a), __n);\x0a"
"#else\x0a"
"    for (; __n; --__n)\x0a"
"    {\x0a"
"        if (eq(*__s, __a))\x0a"
"            return __s;\x0a"
"        ++__s;\x0a"
"    }\x0a"
"    return nullptr;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// char_traits<wchar_t>\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS char_traits<wchar_t>\x0a"
"{\x0a"
"    typedef wchar_t   char_type;\x0a"
"    typedef wint_t    int_type;\x0a"
"    typedef streamoff off_type;\x0a"
"    typedef streampos pos_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    static inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    void assign(char_type\x26 __c1, const char_type\x26 __c2) _NOEXCEPT {__c1 = __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool eq(char_type __c1, char_type __c2) _NOEXCEPT\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool lt(char_type __c1, char_type __c2) _NOEXCEPT\x0a"
"        {return __c1 < __c2;}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    int compare(const char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT;\x0a"
"    static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    size_t length(const char_type* __s) _NOEXCEPT;\x0a"
"    static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const char_type* find(const char_type* __s, size_t __n, const char_type\x26 __a) _NOEXCEPT;\x0a"
"    static inline char_type* move(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"        {return __n == 0 \x3f __s1 \x3a (char_type*)wmemmove(__s1, __s2, __n);}\x0a"
"    static inline char_type* copy(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"        {\x0a"
"            _LIBCPP_ASSERT(__s2 < __s1 \x7c\x7c __s2 >= __s1+__n, \x22""char_traits\x3a\x3a""copy overlapped range\x22);\x0a"
"            return __n == 0 \x3f __s1 \x3a (char_type*)wmemcpy(__s1, __s2, __n);\x0a"
"        }\x0a"
"    static inline char_type* assign(char_type* __s, size_t __n, char_type __a) _NOEXCEPT\x0a"
"        {return __n == 0 \x3f __s \x3a (char_type*)wmemset(__s, __a, __n);}\x0a"
"\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type  not_eof(int_type __c) _NOEXCEPT\x0a"
"        {return eq_int_type(__c, eof()) \x3f \x7e""eof() \x3a __c;}\x0a"
"    static inline _LIBCPP_CONSTEXPR char_type to_char_type(int_type __c) _NOEXCEPT\x0a"
"        {return char_type(__c);}\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type to_int_type(char_type __c) _NOEXCEPT\x0a"
"        {return int_type(__c);}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool eq_int_type(int_type __c1, int_type __c2) _NOEXCEPT\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type eof() _NOEXCEPT\x0a"
"        {return int_type(WEOF);}\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"int\x0a"
"char_traits<wchar_t>\x3a\x3a""compare(const char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"{\x0a"
"    if (__n == 0)\x0a"
"        return 0;\x0a"
"#if __has_feature(cxx_constexpr_string_builtins)\x0a"
"    return __builtin_wmemcmp(__s1, __s2, __n);\x0a"
"#elif _LIBCPP_STD_VER <= 14\x0a"
"    return wmemcmp(__s1, __s2, __n);\x0a"
"#else\x0a"
"    for (; __n; --__n, ++__s1, ++__s2)\x0a"
"    {\x0a"
"        if (lt(*__s1, *__s2))\x0a"
"            return -1;\x0a"
"        if (lt(*__s2, *__s1))\x0a"
"            return 1;\x0a"
"    }\x0a"
"    return 0;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"size_t\x0a"
"char_traits<wchar_t>\x3a\x3alength(const char_type* __s) _NOEXCEPT\x0a"
"{\x0a"
"#if __has_feature(cxx_constexpr_string_builtins)\x0a"
"    return __builtin_wcslen(__s);\x0a"
"#elif _LIBCPP_STD_VER <= 14\x0a"
"    return wcslen(__s);\x0a"
"#else\x0a"
"    size_t __len = 0;\x0a"
"    for (; \x21""eq(*__s, char_type(0)); ++__s)\x0a"
"        ++__len;\x0a"
"    return __len;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"const wchar_t*\x0a"
"char_traits<wchar_t>\x3a\x3a""find(const char_type* __s, size_t __n, const char_type\x26 __a) _NOEXCEPT\x0a"
"{\x0a"
"    if (__n == 0)\x0a"
"        return nullptr;\x0a"
"#if __has_feature(cxx_constexpr_string_builtins)\x0a"
"    return __builtin_wmemchr(__s, __a, __n);\x0a"
"#elif _LIBCPP_STD_VER <= 14\x0a"
"    return wmemchr(__s, __a, __n);\x0a"
"#else\x0a"
"    for (; __n; --__n)\x0a"
"    {\x0a"
"        if (eq(*__s, __a))\x0a"
"            return __s;\x0a"
"        ++__s;\x0a"
"    }\x0a"
"    return nullptr;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_HAS_CHAR8_T\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS char_traits<char8_t>\x0a"
"{\x0a"
"    typedef char8_t        char_type;\x0a"
"    typedef unsigned int   int_type;\x0a"
"    typedef streamoff      off_type;\x0a"
"    typedef u8streampos    pos_type;\x0a"
"    typedef mbstate_t      state_type;\x0a"
"\x0a"
"    static inline constexpr void assign(char_type\x26 __c1, const char_type\x26 __c2) noexcept\x0a"
"        {__c1 = __c2;}\x0a"
"    static inline constexpr bool eq(char_type __c1, char_type __c2) noexcept\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline constexpr bool lt(char_type __c1, char_type __c2) noexcept\x0a"
"        {return __c1 < __c2;}\x0a"
"\x0a"
"    static constexpr\x0a"
"    int              compare(const char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT;\x0a"
"\x0a"
"    static constexpr\x0a"
"    size_t           length(const char_type* __s) _NOEXCEPT;\x0a"
" \x0a"
"    _LIBCPP_INLINE_VISIBILITY static constexpr\x0a"
"    const char_type* find(const char_type* __s, size_t __n, const char_type\x26 __a) _NOEXCEPT;\x0a"
" \x0a"
"    static char_type*       move(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"        {return __n == 0 \x3f __s1 \x3a (char_type*) memmove(__s1, __s2, __n);}\x0a"
" \x0a"
"    static char_type*       copy(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"       {\x0a"
"            _LIBCPP_ASSERT(__s2 < __s1 \x7c\x7c __s2 >= __s1+__n, \x22""char_traits\x3a\x3a""copy overlapped range\x22);\x0a"
"            return __n == 0 \x3f __s1 \x3a (char_type*)memcpy(__s1, __s2, __n);\x0a"
"       }\x0a"
" \x0a"
"    static char_type*       assign(char_type* __s, size_t __n, char_type __a) _NOEXCEPT\x0a"
"        {return __n == 0 \x3f __s \x3a (char_type*)memset(__s, to_int_type(__a), __n);}\x0a"
"\x0a"
"    static inline constexpr int_type  not_eof(int_type __c) noexcept\x0a"
"        {return eq_int_type(__c, eof()) \x3f \x7e""eof() \x3a __c;}\x0a"
"    static inline constexpr char_type to_char_type(int_type __c) noexcept\x0a"
"        {return char_type(__c);}\x0a"
"    static inline constexpr int_type to_int_type(char_type __c) noexcept\x0a"
"        {return int_type(__c);}\x0a"
"    static inline constexpr bool eq_int_type(int_type __c1, int_type __c2) noexcept\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline constexpr int_type eof() noexcept\x0a"
"        {return int_type(EOF);}\x0a"
"};\x0a"
"\x0a"
"// TODO use '__builtin_strlen' if it ever supports char8_t \x3f\x3f\x0a"
"inline constexpr\x0a"
"size_t\x0a"
"char_traits<char8_t>\x3a\x3alength(const char_type* __s) _NOEXCEPT\x0a"
"{\x0a"
"    size_t __len = 0;\x0a"
"    for (; \x21""eq(*__s, char_type(0)); ++__s)\x0a"
"        ++__len;\x0a"
"    return __len;\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"int\x0a"
"char_traits<char8_t>\x3a\x3a""compare(const char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"{\x0a"
"#if __has_feature(cxx_constexpr_string_builtins)\x0a"
"    return __builtin_memcmp(__s1, __s2, __n);\x0a"
"#else\x0a"
"    for (; __n; --__n, ++__s1, ++__s2)\x0a"
"    {\x0a"
"        if (lt(*__s1, *__s2))\x0a"
"            return -1;\x0a"
"        if (lt(*__s2, *__s1))\x0a"
"            return 1;\x0a"
"    }\x0a"
"    return 0;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"// TODO use '__builtin_char_memchr' if it ever supports char8_t \x3f\x3f\x0a"
"inline constexpr\x0a"
"const char8_t*\x0a"
"char_traits<char8_t>\x3a\x3a""find(const char_type* __s, size_t __n, const char_type\x26 __a) _NOEXCEPT\x0a"
"{\x0a"
"    for (; __n; --__n)\x0a"
"    {\x0a"
"        if (eq(*__s, __a))\x0a"
"            return __s;\x0a"
"        ++__s;\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"#endif // #_LIBCPP_NO_HAS_CHAR8_T\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS char_traits<char16_t>\x0a"
"{\x0a"
"    typedef char16_t       char_type;\x0a"
"    typedef uint_least16_t int_type;\x0a"
"    typedef streamoff      off_type;\x0a"
"    typedef u16streampos   pos_type;\x0a"
"    typedef mbstate_t      state_type;\x0a"
"\x0a"
"    static inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    void assign(char_type\x26 __c1, const char_type\x26 __c2) _NOEXCEPT {__c1 = __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool eq(char_type __c1, char_type __c2) _NOEXCEPT\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool lt(char_type __c1, char_type __c2) _NOEXCEPT\x0a"
"        {return __c1 < __c2;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    int              compare(const char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    size_t           length(const char_type* __s) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const char_type* find(const char_type* __s, size_t __n, const char_type\x26 __a) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static char_type*       move(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static char_type*       copy(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static char_type*       assign(char_type* __s, size_t __n, char_type __a) _NOEXCEPT;\x0a"
"\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type  not_eof(int_type __c) _NOEXCEPT\x0a"
"        {return eq_int_type(__c, eof()) \x3f \x7e""eof() \x3a __c;}\x0a"
"    static inline _LIBCPP_CONSTEXPR char_type to_char_type(int_type __c) _NOEXCEPT\x0a"
"        {return char_type(__c);}\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type to_int_type(char_type __c) _NOEXCEPT\x0a"
"        {return int_type(__c);}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool eq_int_type(int_type __c1, int_type __c2) _NOEXCEPT\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type eof() _NOEXCEPT\x0a"
"        {return int_type(0xFFFF);}\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"int\x0a"
"char_traits<char16_t>\x3a\x3a""compare(const char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"{\x0a"
"    for (; __n; --__n, ++__s1, ++__s2)\x0a"
"    {\x0a"
"        if (lt(*__s1, *__s2))\x0a"
"            return -1;\x0a"
"        if (lt(*__s2, *__s1))\x0a"
"            return 1;\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"size_t\x0a"
"char_traits<char16_t>\x3a\x3alength(const char_type* __s) _NOEXCEPT\x0a"
"{\x0a"
"    size_t __len = 0;\x0a"
"    for (; \x21""eq(*__s, char_type(0)); ++__s)\x0a"
"        ++__len;\x0a"
"    return __len;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"const char16_t*\x0a"
"char_traits<char16_t>\x3a\x3a""find(const char_type* __s, size_t __n, const char_type\x26 __a) _NOEXCEPT\x0a"
"{\x0a"
"    for (; __n; --__n)\x0a"
"    {\x0a"
"        if (eq(*__s, __a))\x0a"
"            return __s;\x0a"
"        ++__s;\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"char16_t*\x0a"
"char_traits<char16_t>\x3a\x3amove(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"{\x0a"
"    char_type* __r = __s1;\x0a"
"    if (__s1 < __s2)\x0a"
"    {\x0a"
"        for (; __n; --__n, ++__s1, ++__s2)\x0a"
"            assign(*__s1, *__s2);\x0a"
"    }\x0a"
"    else if (__s2 < __s1)\x0a"
"    {\x0a"
"        __s1 += __n;\x0a"
"        __s2 += __n;\x0a"
"        for (; __n; --__n)\x0a"
"            assign(*--__s1, *--__s2);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"char16_t*\x0a"
"char_traits<char16_t>\x3a\x3a""copy(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s2 < __s1 \x7c\x7c __s2 >= __s1+__n, \x22""char_traits\x3a\x3a""copy overlapped range\x22);\x0a"
"    char_type* __r = __s1;\x0a"
"    for (; __n; --__n, ++__s1, ++__s2)\x0a"
"        assign(*__s1, *__s2);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"char16_t*\x0a"
"char_traits<char16_t>\x3a\x3a""assign(char_type* __s, size_t __n, char_type __a) _NOEXCEPT\x0a"
"{\x0a"
"    char_type* __r = __s;\x0a"
"    for (; __n; --__n, ++__s)\x0a"
"        assign(*__s, __a);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS char_traits<char32_t>\x0a"
"{\x0a"
"    typedef char32_t       char_type;\x0a"
"    typedef uint_least32_t int_type;\x0a"
"    typedef streamoff      off_type;\x0a"
"    typedef u32streampos   pos_type;\x0a"
"    typedef mbstate_t      state_type;\x0a"
"\x0a"
"    static inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    void assign(char_type\x26 __c1, const char_type\x26 __c2) _NOEXCEPT {__c1 = __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool eq(char_type __c1, char_type __c2) _NOEXCEPT\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool lt(char_type __c1, char_type __c2) _NOEXCEPT\x0a"
"        {return __c1 < __c2;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    int              compare(const char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    size_t           length(const char_type* __s) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const char_type* find(const char_type* __s, size_t __n, const char_type\x26 __a) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static char_type*       move(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static char_type*       copy(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static char_type*       assign(char_type* __s, size_t __n, char_type __a) _NOEXCEPT;\x0a"
"\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type  not_eof(int_type __c) _NOEXCEPT\x0a"
"        {return eq_int_type(__c, eof()) \x3f \x7e""eof() \x3a __c;}\x0a"
"    static inline _LIBCPP_CONSTEXPR char_type to_char_type(int_type __c) _NOEXCEPT\x0a"
"        {return char_type(__c);}\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type to_int_type(char_type __c) _NOEXCEPT\x0a"
"        {return int_type(__c);}\x0a"
"    static inline _LIBCPP_CONSTEXPR bool eq_int_type(int_type __c1, int_type __c2) _NOEXCEPT\x0a"
"        {return __c1 == __c2;}\x0a"
"    static inline _LIBCPP_CONSTEXPR int_type eof() _NOEXCEPT\x0a"
"        {return int_type(0xFFFFFFFF);}\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"int\x0a"
"char_traits<char32_t>\x3a\x3a""compare(const char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"{\x0a"
"    for (; __n; --__n, ++__s1, ++__s2)\x0a"
"    {\x0a"
"        if (lt(*__s1, *__s2))\x0a"
"            return -1;\x0a"
"        if (lt(*__s2, *__s1))\x0a"
"            return 1;\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"size_t\x0a"
"char_traits<char32_t>\x3a\x3alength(const char_type* __s) _NOEXCEPT\x0a"
"{\x0a"
"    size_t __len = 0;\x0a"
"    for (; \x21""eq(*__s, char_type(0)); ++__s)\x0a"
"        ++__len;\x0a"
"    return __len;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"const char32_t*\x0a"
"char_traits<char32_t>\x3a\x3a""find(const char_type* __s, size_t __n, const char_type\x26 __a) _NOEXCEPT\x0a"
"{\x0a"
"    for (; __n; --__n)\x0a"
"    {\x0a"
"        if (eq(*__s, __a))\x0a"
"            return __s;\x0a"
"        ++__s;\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"char32_t*\x0a"
"char_traits<char32_t>\x3a\x3amove(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"{\x0a"
"    char_type* __r = __s1;\x0a"
"    if (__s1 < __s2)\x0a"
"    {\x0a"
"        for (; __n; --__n, ++__s1, ++__s2)\x0a"
"            assign(*__s1, *__s2);\x0a"
"    }\x0a"
"    else if (__s2 < __s1)\x0a"
"    {\x0a"
"        __s1 += __n;\x0a"
"        __s2 += __n;\x0a"
"        for (; __n; --__n)\x0a"
"            assign(*--__s1, *--__s2);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"char32_t*\x0a"
"char_traits<char32_t>\x3a\x3a""copy(char_type* __s1, const char_type* __s2, size_t __n) _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s2 < __s1 \x7c\x7c __s2 >= __s1+__n, \x22""char_traits\x3a\x3a""copy overlapped range\x22);\x0a"
"    char_type* __r = __s1;\x0a"
"    for (; __n; --__n, ++__s1, ++__s2)\x0a"
"        assign(*__s1, *__s2);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"char32_t*\x0a"
"char_traits<char32_t>\x3a\x3a""assign(char_type* __s, size_t __n, char_type __a) _NOEXCEPT\x0a"
"{\x0a"
"    char_type* __r = __s;\x0a"
"    for (; __n; --__n, ++__s)\x0a"
"        assign(*__s, __a);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"\x0a"
"// helper fns for basic_string and string_view\x0a"
"\x0a"
"// __str_find\x0a"
"template<class _CharT, class _SizeT, class _Traits, _SizeT __npos>\x0a"
"inline _SizeT _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"__str_find(const _CharT *__p, _SizeT __sz, \x0a"
"             _CharT __c, _SizeT __pos) _NOEXCEPT\x0a"
"{\x0a"
"    if (__pos >= __sz)\x0a"
"        return __npos;\x0a"
"    const _CharT* __r = _Traits\x3a\x3a""find(__p + __pos, __sz - __pos, __c);\x0a"
"    if (__r == 0)\x0a"
"        return __npos;\x0a"
"    return static_cast<_SizeT>(__r - __p);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX11 const _CharT *\x0a"
"__search_substring(const _CharT *__first1, const _CharT *__last1,\x0a"
"                   const _CharT *__first2, const _CharT *__last2) {\x0a"
"  // Take advantage of knowing source and pattern lengths.\x0a"
"  // Stop short when source is smaller than pattern.\x0a"
"  const ptrdiff_t __len2 = __last2 - __first2;\x0a"
"  if (__len2 == 0)\x0a"
"    return __first1;\x0a"
"\x0a"
"  ptrdiff_t __len1 = __last1 - __first1;\x0a"
"  if (__len1 < __len2)\x0a"
"    return __last1;\x0a"
"\x0a"
"  // First element of __first2 is loop invariant.\x0a"
"  _CharT __f2 = *__first2;\x0a"
"  while (true) {\x0a"
"    __len1 = __last1 - __first1;\x0a"
"    // Check whether __first1 still has at least __len2 bytes.\x0a"
"    if (__len1 < __len2)\x0a"
"      return __last1;\x0a"
"\x0a"
"    // Find __f2 the first byte matching in __first1.\x0a"
"    __first1 = _Traits\x3a\x3a""find(__first1, __len1 - __len2 + 1, __f2);\x0a"
"    if (__first1 == 0)\x0a"
"      return __last1;\x0a"
"\x0a"
"    // It is faster to compare from the first byte of __first1 even if we\x0a"
"    // already know that it matches the first byte of __first2\x3a this is because\x0a"
"    // __first2 is most likely aligned, as it is user's \x22pattern\x22 string, and\x0a"
"    // __first1 + 1 is most likely not aligned, as the match is in the middle of\x0a"
"    // the string.\x0a"
"    if (_Traits\x3a\x3a""compare(__first1, __first2, __len2) == 0)\x0a"
"      return __first1;\x0a"
"\x0a"
"    ++__first1;\x0a"
"  }\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _SizeT, class _Traits, _SizeT __npos>\x0a"
"inline _SizeT _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"__str_find(const _CharT *__p, _SizeT __sz, \x0a"
"       const _CharT* __s, _SizeT __pos, _SizeT __n) _NOEXCEPT\x0a"
"{\x0a"
"    if (__pos > __sz)\x0a"
"        return __npos;\x0a"
"\x0a"
"    if (__n == 0) // There is nothing to search, just return __pos.\x0a"
"        return __pos;\x0a"
"\x0a"
"    const _CharT *__r = __search_substring<_CharT, _Traits>(\x0a"
"        __p + __pos, __p + __sz, __s, __s + __n);\x0a"
"\x0a"
"    if (__r == __p + __sz)\x0a"
"        return __npos;\x0a"
"    return static_cast<_SizeT>(__r - __p);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// __str_rfind\x0a"
"\x0a"
"template<class _CharT, class _SizeT, class _Traits, _SizeT __npos>\x0a"
"inline _SizeT _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"__str_rfind(const _CharT *__p, _SizeT __sz, \x0a"
"              _CharT __c, _SizeT __pos) _NOEXCEPT\x0a"
"{\x0a"
"    if (__sz < 1)\x0a"
"        return __npos;\x0a"
"    if (__pos < __sz)\x0a"
"        ++__pos;\x0a"
"    else\x0a"
"        __pos = __sz;\x0a"
"    for (const _CharT* __ps = __p + __pos; __ps \x21= __p;)\x0a"
"    {\x0a"
"        if (_Traits\x3a\x3a""eq(*--__ps, __c))\x0a"
"            return static_cast<_SizeT>(__ps - __p);\x0a"
"    }\x0a"
"    return __npos;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _SizeT, class _Traits, _SizeT __npos>\x0a"
"inline _SizeT _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"__str_rfind(const _CharT *__p, _SizeT __sz, \x0a"
"        const _CharT* __s, _SizeT __pos, _SizeT __n) _NOEXCEPT\x0a"
"{\x0a"
"    __pos = _VSTD\x3a\x3amin(__pos, __sz);\x0a"
"    if (__n < __sz - __pos)\x0a"
"        __pos += __n;\x0a"
"    else\x0a"
"        __pos = __sz;\x0a"
"    const _CharT* __r = _VSTD\x3a\x3a__find_end(\x0a"
"                  __p, __p + __pos, __s, __s + __n, _Traits\x3a\x3a""eq, \x0a"
"                        random_access_iterator_tag(), random_access_iterator_tag());\x0a"
"    if (__n > 0 \x26\x26 __r == __p + __pos)\x0a"
"        return __npos;\x0a"
"    return static_cast<_SizeT>(__r - __p);\x0a"
"}\x0a"
"\x0a"
"// __str_find_first_of\x0a"
"template<class _CharT, class _SizeT, class _Traits, _SizeT __npos>\x0a"
"inline _SizeT _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"__str_find_first_of(const _CharT *__p, _SizeT __sz,\x0a"
"                const _CharT* __s, _SizeT __pos, _SizeT __n) _NOEXCEPT\x0a"
"{\x0a"
"    if (__pos >= __sz \x7c\x7c __n == 0)\x0a"
"        return __npos;\x0a"
"    const _CharT* __r = _VSTD\x3a\x3a__find_first_of_ce\x0a"
"        (__p + __pos, __p + __sz, __s, __s + __n, _Traits\x3a\x3a""eq );\x0a"
"    if (__r == __p + __sz)\x0a"
"        return __npos;\x0a"
"    return static_cast<_SizeT>(__r - __p);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// __str_find_last_of\x0a"
"template<class _CharT, class _SizeT, class _Traits, _SizeT __npos>\x0a"
"inline _SizeT _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"__str_find_last_of(const _CharT *__p, _SizeT __sz,\x0a"
"               const _CharT* __s, _SizeT __pos, _SizeT __n) _NOEXCEPT\x0a"
"    {\x0a"
"    if (__n \x21= 0)\x0a"
"    {\x0a"
"        if (__pos < __sz)\x0a"
"            ++__pos;\x0a"
"        else\x0a"
"            __pos = __sz;\x0a"
"        for (const _CharT* __ps = __p + __pos; __ps \x21= __p;)\x0a"
"        {\x0a"
"            const _CharT* __r = _Traits\x3a\x3a""find(__s, __n, *--__ps);\x0a"
"            if (__r)\x0a"
"                return static_cast<_SizeT>(__ps - __p);\x0a"
"        }\x0a"
"    }\x0a"
"    return __npos;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// __str_find_first_not_of\x0a"
"template<class _CharT, class _SizeT, class _Traits, _SizeT __npos>\x0a"
"inline _SizeT _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"__str_find_first_not_of(const _CharT *__p, _SizeT __sz,\x0a"
"                    const _CharT* __s, _SizeT __pos, _SizeT __n) _NOEXCEPT\x0a"
"{\x0a"
"    if (__pos < __sz)\x0a"
"    {\x0a"
"        const _CharT* __pe = __p + __sz;\x0a"
"        for (const _CharT* __ps = __p + __pos; __ps \x21= __pe; ++__ps)\x0a"
"            if (_Traits\x3a\x3a""find(__s, __n, *__ps) == 0)\x0a"
"                return static_cast<_SizeT>(__ps - __p);\x0a"
"    }\x0a"
"    return __npos;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _CharT, class _SizeT, class _Traits, _SizeT __npos>\x0a"
"inline _SizeT _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"__str_find_first_not_of(const _CharT *__p, _SizeT __sz,\x0a"
"                          _CharT __c, _SizeT __pos) _NOEXCEPT\x0a"
"{\x0a"
"    if (__pos < __sz)\x0a"
"    {\x0a"
"        const _CharT* __pe = __p + __sz;\x0a"
"        for (const _CharT* __ps = __p + __pos; __ps \x21= __pe; ++__ps)\x0a"
"            if (\x21_Traits\x3a\x3a""eq(*__ps, __c))\x0a"
"                return static_cast<_SizeT>(__ps - __p);\x0a"
"    }\x0a"
"    return __npos;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// __str_find_last_not_of\x0a"
"template<class _CharT, class _SizeT, class _Traits, _SizeT __npos>\x0a"
"inline _SizeT _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"__str_find_last_not_of(const _CharT *__p, _SizeT __sz,\x0a"
"                   const _CharT* __s, _SizeT __pos, _SizeT __n) _NOEXCEPT\x0a"
"{\x0a"
"    if (__pos < __sz)\x0a"
"        ++__pos;\x0a"
"    else\x0a"
"        __pos = __sz;\x0a"
"    for (const _CharT* __ps = __p + __pos; __ps \x21= __p;)\x0a"
"        if (_Traits\x3a\x3a""find(__s, __n, *--__ps) == 0)\x0a"
"            return static_cast<_SizeT>(__ps - __p);\x0a"
"    return __npos;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _CharT, class _SizeT, class _Traits, _SizeT __npos>\x0a"
"inline _SizeT _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"__str_find_last_not_of(const _CharT *__p, _SizeT __sz,\x0a"
"                         _CharT __c, _SizeT __pos) _NOEXCEPT\x0a"
"{\x0a"
"    if (__pos < __sz)\x0a"
"        ++__pos;\x0a"
"    else\x0a"
"        __pos = __sz;\x0a"
"    for (const _CharT* __ps = __p + __pos; __ps \x21= __p;)\x0a"
"        if (\x21_Traits\x3a\x3a""eq(*--__ps, __c))\x0a"
"            return static_cast<_SizeT>(__ps - __p);\x0a"
"    return __npos;\x0a"
"}\x0a"
"\x0a"
"template<class _Ptr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"size_t __do_string_hash(_Ptr __p, _Ptr __e)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_Ptr>\x3a\x3avalue_type value_type;\x0a"
"    return __murmur2_or_cityhash<size_t>()(__p, (__e-__p)*sizeof(value_type));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Iter, class _Traits=char_traits<_CharT> >\x0a"
"struct __quoted_output_proxy\x0a"
"{\x0a"
"    _Iter  __first;\x0a"
"    _Iter  __last;\x0a"
"    _CharT  __delim;\x0a"
"    _CharT  __escape;\x0a"
"\x0a"
"    __quoted_output_proxy(_Iter __f, _Iter __l, _CharT __d, _CharT __e)\x0a"
"    \x3a __first(__f), __last(__l), __delim(__d), __escape(__e) {}\x0a"
"    //  This would be a nice place for a string_ref \x0a"
"};\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP___STRING\x0a"
"", 31132 ); }