#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include___tree( 
"// -*- C++ -*-\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP___TREE\x0a"
"#define _LIBCPP___TREE\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <iterator>\x0a"
"#include <memory>\x0a"
"#include <stdexcept>\x0a"
"#include <algorithm>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#if defined(__GNUC__) \x26\x26 \x21""defined(__clang__) // gcc.gnu.org/PR37804\x0a"
"template <class, class, class, class> class _LIBCPP_TEMPLATE_VIS map;\x0a"
"template <class, class, class, class> class _LIBCPP_TEMPLATE_VIS multimap;\x0a"
"template <class, class, class> class _LIBCPP_TEMPLATE_VIS set;\x0a"
"template <class, class, class> class _LIBCPP_TEMPLATE_VIS multiset;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator> class __tree;\x0a"
"template <class _Tp, class _NodePtr, class _DiffType>\x0a"
"    class _LIBCPP_TEMPLATE_VIS __tree_iterator;\x0a"
"template <class _Tp, class _ConstNodePtr, class _DiffType>\x0a"
"    class _LIBCPP_TEMPLATE_VIS __tree_const_iterator;\x0a"
"\x0a"
"template <class _Pointer> class __tree_end_node;\x0a"
"template <class _VoidPtr> class __tree_node_base;\x0a"
"template <class _Tp, class _VoidPtr> class __tree_node;\x0a"
"\x0a"
"template <class _Key, class _Value>\x0a"
"struct __value_type;\x0a"
"\x0a"
"template <class _Allocator> class __map_node_destructor;\x0a"
"template <class _TreeIterator> class _LIBCPP_TEMPLATE_VIS __map_iterator;\x0a"
"template <class _TreeIterator> class _LIBCPP_TEMPLATE_VIS __map_const_iterator;\x0a"
"\x0a"
"/*\x0a"
"\x0a"
"_NodePtr algorithms\x0a"
"\x0a"
"The algorithms taking _NodePtr are red black tree algorithms.  Those\x0a"
"algorithms taking a parameter named __root should assume that __root\x0a"
"points to a proper red black tree (unless otherwise specified).\x0a"
"\x0a"
"Each algorithm herein assumes that __root->__parent_ points to a non-null\x0a"
"structure which has a member __left_ which points back to __root.  No other\x0a"
"member is read or written to at __root->__parent_.\x0a"
"\x0a"
"__root->__parent_ will be referred to below (in comments only) as end_node.\x0a"
"end_node->__left_ is an externably accessible lvalue for __root, and can be\x0a"
"changed by node insertion and removal (without explicit reference to end_node).\x0a"
"\x0a"
"All nodes (with the exception of end_node), even the node referred to as\x0a"
"__root, have a non-null __parent_ field.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"// Returns\x3a  true if __x is a left child of its parent, else false\x0a"
"// Precondition\x3a  __x \x21= nullptr.\x0a"
"template <class _NodePtr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__tree_is_left_child(_NodePtr __x) _NOEXCEPT\x0a"
"{\x0a"
"    return __x == __x->__parent_->__left_;\x0a"
"}\x0a"
"\x0a"
"// Determines if the subtree rooted at __x is a proper red black subtree.  If\x0a"
"//    __x is a proper subtree, returns the black height (null counts as 1).  If\x0a"
"//    __x is an improper subtree, returns 0.\x0a"
"template <class _NodePtr>\x0a"
"unsigned\x0a"
"__tree_sub_invariant(_NodePtr __x)\x0a"
"{\x0a"
"    if (__x == nullptr)\x0a"
"        return 1;\x0a"
"    // parent consistency checked by caller\x0a"
"    // check __x->__left_ consistency\x0a"
"    if (__x->__left_ \x21= nullptr \x26\x26 __x->__left_->__parent_ \x21= __x)\x0a"
"        return 0;\x0a"
"    // check __x->__right_ consistency\x0a"
"    if (__x->__right_ \x21= nullptr \x26\x26 __x->__right_->__parent_ \x21= __x)\x0a"
"        return 0;\x0a"
"    // check __x->__left_ \x21= __x->__right_ unless both are nullptr\x0a"
"    if (__x->__left_ == __x->__right_ \x26\x26 __x->__left_ \x21= nullptr)\x0a"
"        return 0;\x0a"
"    // If this is red, neither child can be red\x0a"
"    if (\x21__x->__is_black_)\x0a"
"    {\x0a"
"        if (__x->__left_ \x26\x26 \x21__x->__left_->__is_black_)\x0a"
"            return 0;\x0a"
"        if (__x->__right_ \x26\x26 \x21__x->__right_->__is_black_)\x0a"
"            return 0;\x0a"
"    }\x0a"
"    unsigned __h = __tree_sub_invariant(__x->__left_);\x0a"
"    if (__h == 0)\x0a"
"        return 0;  // invalid left subtree\x0a"
"    if (__h \x21= __tree_sub_invariant(__x->__right_))\x0a"
"        return 0;  // invalid or different height right subtree\x0a"
"    return __h + __x->__is_black_;  // return black height of this node\x0a"
"}\x0a"
"\x0a"
"// Determines if the red black tree rooted at __root is a proper red black tree.\x0a"
"//    __root == nullptr is a proper tree.  Returns true is __root is a proper\x0a"
"//    red black tree, else returns false.\x0a"
"template <class _NodePtr>\x0a"
"bool\x0a"
"__tree_invariant(_NodePtr __root)\x0a"
"{\x0a"
"    if (__root == nullptr)\x0a"
"        return true;\x0a"
"    // check __x->__parent_ consistency\x0a"
"    if (__root->__parent_ == nullptr)\x0a"
"        return false;\x0a"
"    if (\x21__tree_is_left_child(__root))\x0a"
"        return false;\x0a"
"    // root must be black\x0a"
"    if (\x21__root->__is_black_)\x0a"
"        return false;\x0a"
"    // do normal node checks\x0a"
"    return __tree_sub_invariant(__root) \x21= 0;\x0a"
"}\x0a"
"\x0a"
"// Returns\x3a  pointer to the left-most node under __x.\x0a"
"// Precondition\x3a  __x \x21= nullptr.\x0a"
"template <class _NodePtr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_NodePtr\x0a"
"__tree_min(_NodePtr __x) _NOEXCEPT\x0a"
"{\x0a"
"    while (__x->__left_ \x21= nullptr)\x0a"
"        __x = __x->__left_;\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"// Returns\x3a  pointer to the right-most node under __x.\x0a"
"// Precondition\x3a  __x \x21= nullptr.\x0a"
"template <class _NodePtr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_NodePtr\x0a"
"__tree_max(_NodePtr __x) _NOEXCEPT\x0a"
"{\x0a"
"    while (__x->__right_ \x21= nullptr)\x0a"
"        __x = __x->__right_;\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"// Returns\x3a  pointer to the next in-order node after __x.\x0a"
"// Precondition\x3a  __x \x21= nullptr.\x0a"
"template <class _NodePtr>\x0a"
"_NodePtr\x0a"
"__tree_next(_NodePtr __x) _NOEXCEPT\x0a"
"{\x0a"
"    if (__x->__right_ \x21= nullptr)\x0a"
"        return __tree_min(__x->__right_);\x0a"
"    while (\x21__tree_is_left_child(__x))\x0a"
"        __x = __x->__parent_unsafe();\x0a"
"    return __x->__parent_unsafe();\x0a"
"}\x0a"
"\x0a"
"template <class _EndNodePtr, class _NodePtr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_EndNodePtr\x0a"
"__tree_next_iter(_NodePtr __x) _NOEXCEPT\x0a"
"{\x0a"
"    if (__x->__right_ \x21= nullptr)\x0a"
"        return static_cast<_EndNodePtr>(__tree_min(__x->__right_));\x0a"
"    while (\x21__tree_is_left_child(__x))\x0a"
"        __x = __x->__parent_unsafe();\x0a"
"    return static_cast<_EndNodePtr>(__x->__parent_);\x0a"
"}\x0a"
"\x0a"
"// Returns\x3a  pointer to the previous in-order node before __x.\x0a"
"// Precondition\x3a  __x \x21= nullptr.\x0a"
"// Note\x3a __x may be the end node.\x0a"
"template <class _NodePtr, class _EndNodePtr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_NodePtr\x0a"
"__tree_prev_iter(_EndNodePtr __x) _NOEXCEPT\x0a"
"{\x0a"
"    if (__x->__left_ \x21= nullptr)\x0a"
"        return __tree_max(__x->__left_);\x0a"
"    _NodePtr __xx = static_cast<_NodePtr>(__x);\x0a"
"    while (__tree_is_left_child(__xx))\x0a"
"        __xx = __xx->__parent_unsafe();\x0a"
"    return __xx->__parent_unsafe();\x0a"
"}\x0a"
"\x0a"
"// Returns\x3a  pointer to a node which has no children\x0a"
"// Precondition\x3a  __x \x21= nullptr.\x0a"
"template <class _NodePtr>\x0a"
"_NodePtr\x0a"
"__tree_leaf(_NodePtr __x) _NOEXCEPT\x0a"
"{\x0a"
"    while (true)\x0a"
"    {\x0a"
"        if (__x->__left_ \x21= nullptr)\x0a"
"        {\x0a"
"            __x = __x->__left_;\x0a"
"            continue;\x0a"
"        }\x0a"
"        if (__x->__right_ \x21= nullptr)\x0a"
"        {\x0a"
"            __x = __x->__right_;\x0a"
"            continue;\x0a"
"        }\x0a"
"        break;\x0a"
"    }\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"// Effects\x3a  Makes __x->__right_ the subtree root with __x as its left child\x0a"
"//           while preserving in-order order.\x0a"
"// Precondition\x3a  __x->__right_ \x21= nullptr\x0a"
"template <class _NodePtr>\x0a"
"void\x0a"
"__tree_left_rotate(_NodePtr __x) _NOEXCEPT\x0a"
"{\x0a"
"    _NodePtr __y = __x->__right_;\x0a"
"    __x->__right_ = __y->__left_;\x0a"
"    if (__x->__right_ \x21= nullptr)\x0a"
"        __x->__right_->__set_parent(__x);\x0a"
"    __y->__parent_ = __x->__parent_;\x0a"
"    if (__tree_is_left_child(__x))\x0a"
"        __x->__parent_->__left_ = __y;\x0a"
"    else\x0a"
"        __x->__parent_unsafe()->__right_ = __y;\x0a"
"    __y->__left_ = __x;\x0a"
"    __x->__set_parent(__y);\x0a"
"}\x0a"
"\x0a"
"// Effects\x3a  Makes __x->__left_ the subtree root with __x as its right child\x0a"
"//           while preserving in-order order.\x0a"
"// Precondition\x3a  __x->__left_ \x21= nullptr\x0a"
"template <class _NodePtr>\x0a"
"void\x0a"
"__tree_right_rotate(_NodePtr __x) _NOEXCEPT\x0a"
"{\x0a"
"    _NodePtr __y = __x->__left_;\x0a"
"    __x->__left_ = __y->__right_;\x0a"
"    if (__x->__left_ \x21= nullptr)\x0a"
"        __x->__left_->__set_parent(__x);\x0a"
"    __y->__parent_ = __x->__parent_;\x0a"
"    if (__tree_is_left_child(__x))\x0a"
"        __x->__parent_->__left_ = __y;\x0a"
"    else\x0a"
"        __x->__parent_unsafe()->__right_ = __y;\x0a"
"    __y->__right_ = __x;\x0a"
"    __x->__set_parent(__y);\x0a"
"}\x0a"
"\x0a"
"// Effects\x3a  Rebalances __root after attaching __x to a leaf.\x0a"
"// Precondition\x3a  __root \x21= nulptr \x26\x26 __x \x21= nullptr.\x0a"
"//                __x has no children.\x0a"
"//                __x == __root or == a direct or indirect child of __root.\x0a"
"//                If __x were to be unlinked from __root (setting __root to\x0a"
"//                  nullptr if __root == __x), __tree_invariant(__root) == true.\x0a"
"// Postcondition\x3a __tree_invariant(end_node->__left_) == true.  end_node->__left_\x0a"
"//                may be different than the value passed in as __root.\x0a"
"template <class _NodePtr>\x0a"
"void\x0a"
"__tree_balance_after_insert(_NodePtr __root, _NodePtr __x) _NOEXCEPT\x0a"
"{\x0a"
"    __x->__is_black_ = __x == __root;\x0a"
"    while (__x \x21= __root \x26\x26 \x21__x->__parent_unsafe()->__is_black_)\x0a"
"    {\x0a"
"        // __x->__parent_ \x21= __root because __x->__parent_->__is_black == false\x0a"
"        if (__tree_is_left_child(__x->__parent_unsafe()))\x0a"
"        {\x0a"
"            _NodePtr __y = __x->__parent_unsafe()->__parent_unsafe()->__right_;\x0a"
"            if (__y \x21= nullptr \x26\x26 \x21__y->__is_black_)\x0a"
"            {\x0a"
"                __x = __x->__parent_unsafe();\x0a"
"                __x->__is_black_ = true;\x0a"
"                __x = __x->__parent_unsafe();\x0a"
"                __x->__is_black_ = __x == __root;\x0a"
"                __y->__is_black_ = true;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                if (\x21__tree_is_left_child(__x))\x0a"
"                {\x0a"
"                    __x = __x->__parent_unsafe();\x0a"
"                    __tree_left_rotate(__x);\x0a"
"                }\x0a"
"                __x = __x->__parent_unsafe();\x0a"
"                __x->__is_black_ = true;\x0a"
"                __x = __x->__parent_unsafe();\x0a"
"                __x->__is_black_ = false;\x0a"
"                __tree_right_rotate(__x);\x0a"
"                break;\x0a"
"            }\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            _NodePtr __y = __x->__parent_unsafe()->__parent_->__left_;\x0a"
"            if (__y \x21= nullptr \x26\x26 \x21__y->__is_black_)\x0a"
"            {\x0a"
"                __x = __x->__parent_unsafe();\x0a"
"                __x->__is_black_ = true;\x0a"
"                __x = __x->__parent_unsafe();\x0a"
"                __x->__is_black_ = __x == __root;\x0a"
"                __y->__is_black_ = true;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                if (__tree_is_left_child(__x))\x0a"
"                {\x0a"
"                    __x = __x->__parent_unsafe();\x0a"
"                    __tree_right_rotate(__x);\x0a"
"                }\x0a"
"                __x = __x->__parent_unsafe();\x0a"
"                __x->__is_black_ = true;\x0a"
"                __x = __x->__parent_unsafe();\x0a"
"                __x->__is_black_ = false;\x0a"
"                __tree_left_rotate(__x);\x0a"
"                break;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Precondition\x3a  __root \x21= nullptr \x26\x26 __z \x21= nullptr.\x0a"
"//                __tree_invariant(__root) == true.\x0a"
"//                __z == __root or == a direct or indirect child of __root.\x0a"
"// Effects\x3a  unlinks __z from the tree rooted at __root, rebalancing as needed.\x0a"
"// Postcondition\x3a __tree_invariant(end_node->__left_) == true \x26\x26 end_node->__left_\x0a"
"//                nor any of its children refer to __z.  end_node->__left_\x0a"
"//                may be different than the value passed in as __root.\x0a"
"template <class _NodePtr>\x0a"
"void\x0a"
"__tree_remove(_NodePtr __root, _NodePtr __z) _NOEXCEPT\x0a"
"{\x0a"
"    // __z will be removed from the tree.  Client still needs to destruct/deallocate it\x0a"
"    // __y is either __z, or if __z has two children, __tree_next(__z).\x0a"
"    // __y will have at most one child.\x0a"
"    // __y will be the initial hole in the tree (make the hole at a leaf)\x0a"
"    _NodePtr __y = (__z->__left_ == nullptr \x7c\x7c __z->__right_ == nullptr) \x3f\x0a"
"                    __z \x3a __tree_next(__z);\x0a"
"    // __x is __y's possibly null single child\x0a"
"    _NodePtr __x = __y->__left_ \x21= nullptr \x3f __y->__left_ \x3a __y->__right_;\x0a"
"    // __w is __x's possibly null uncle (will become __x's sibling)\x0a"
"    _NodePtr __w = nullptr;\x0a"
"    // link __x to __y's parent, and find __w\x0a"
"    if (__x \x21= nullptr)\x0a"
"        __x->__parent_ = __y->__parent_;\x0a"
"    if (__tree_is_left_child(__y))\x0a"
"    {\x0a"
"        __y->__parent_->__left_ = __x;\x0a"
"        if (__y \x21= __root)\x0a"
"            __w = __y->__parent_unsafe()->__right_;\x0a"
"        else\x0a"
"            __root = __x;  // __w == nullptr\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __y->__parent_unsafe()->__right_ = __x;\x0a"
"        // __y can't be root if it is a right child\x0a"
"        __w = __y->__parent_->__left_;\x0a"
"    }\x0a"
"    bool __removed_black = __y->__is_black_;\x0a"
"    // If we didn't remove __z, do so now by splicing in __y for __z,\x0a"
"    //    but copy __z's color.  This does not impact __x or __w.\x0a"
"    if (__y \x21= __z)\x0a"
"    {\x0a"
"        // __z->__left_ \x21= nulptr but __z->__right_ might == __x == nullptr\x0a"
"        __y->__parent_ = __z->__parent_;\x0a"
"        if (__tree_is_left_child(__z))\x0a"
"            __y->__parent_->__left_ = __y;\x0a"
"        else\x0a"
"            __y->__parent_unsafe()->__right_ = __y;\x0a"
"        __y->__left_ = __z->__left_;\x0a"
"        __y->__left_->__set_parent(__y);\x0a"
"        __y->__right_ = __z->__right_;\x0a"
"        if (__y->__right_ \x21= nullptr)\x0a"
"            __y->__right_->__set_parent(__y);\x0a"
"        __y->__is_black_ = __z->__is_black_;\x0a"
"        if (__root == __z)\x0a"
"            __root = __y;\x0a"
"    }\x0a"
"    // There is no need to rebalance if we removed a red, or if we removed\x0a"
"    //     the last node.\x0a"
"    if (__removed_black \x26\x26 __root \x21= nullptr)\x0a"
"    {\x0a"
"        // Rebalance\x3a\x0a"
"        // __x has an implicit black color (transferred from the removed __y)\x0a"
"        //    associated with it, no matter what its color is.\x0a"
"        // If __x is __root (in which case it can't be null), it is supposed\x0a"
"        //    to be black anyway, and if it is doubly black, then the double\x0a"
"        //    can just be ignored.\x0a"
"        // If __x is red (in which case it can't be null), then it can absorb\x0a"
"        //    the implicit black just by setting its color to black.\x0a"
"        // Since __y was black and only had one child (which __x points to), __x\x0a"
"        //   is either red with no children, else null, otherwise __y would have\x0a"
"        //   different black heights under left and right pointers.\x0a"
"        // if (__x == __root \x7c\x7c __x \x21= nullptr \x26\x26 \x21__x->__is_black_)\x0a"
"        if (__x \x21= nullptr)\x0a"
"            __x->__is_black_ = true;\x0a"
"        else\x0a"
"        {\x0a"
"            //  Else __x isn't root, and is \x22""doubly black\x22, even though it may\x0a"
"            //     be null.  __w can not be null here, else the parent would\x0a"
"            //     see a black height >= 2 on the __x side and a black height\x0a"
"            //     of 1 on the __w side (__w must be a non-null black or a red\x0a"
"            //     with a non-null black child).\x0a"
"            while (true)\x0a"
"            {\x0a"
"                if (\x21__tree_is_left_child(__w))  // if x is left child\x0a"
"                {\x0a"
"                    if (\x21__w->__is_black_)\x0a"
"                    {\x0a"
"                        __w->__is_black_ = true;\x0a"
"                        __w->__parent_unsafe()->__is_black_ = false;\x0a"
"                        __tree_left_rotate(__w->__parent_unsafe());\x0a"
"                        // __x is still valid\x0a"
"                        // reset __root only if necessary\x0a"
"                        if (__root == __w->__left_)\x0a"
"                            __root = __w;\x0a"
"                        // reset sibling, and it still can't be null\x0a"
"                        __w = __w->__left_->__right_;\x0a"
"                    }\x0a"
"                    // __w->__is_black_ is now true, __w may have null children\x0a"
"                    if ((__w->__left_  == nullptr \x7c\x7c __w->__left_->__is_black_) \x26\x26\x0a"
"                        (__w->__right_ == nullptr \x7c\x7c __w->__right_->__is_black_))\x0a"
"                    {\x0a"
"                        __w->__is_black_ = false;\x0a"
"                        __x = __w->__parent_unsafe();\x0a"
"                        // __x can no longer be null\x0a"
"                        if (__x == __root \x7c\x7c \x21__x->__is_black_)\x0a"
"                        {\x0a"
"                            __x->__is_black_ = true;\x0a"
"                            break;\x0a"
"                        }\x0a"
"                        // reset sibling, and it still can't be null\x0a"
"                        __w = __tree_is_left_child(__x) \x3f\x0a"
"                                    __x->__parent_unsafe()->__right_ \x3a\x0a"
"                                    __x->__parent_->__left_;\x0a"
"                        // continue;\x0a"
"                    }\x0a"
"                    else  // __w has a red child\x0a"
"                    {\x0a"
"                        if (__w->__right_ == nullptr \x7c\x7c __w->__right_->__is_black_)\x0a"
"                        {\x0a"
"                            // __w left child is non-null and red\x0a"
"                            __w->__left_->__is_black_ = true;\x0a"
"                            __w->__is_black_ = false;\x0a"
"                            __tree_right_rotate(__w);\x0a"
"                            // __w is known not to be root, so root hasn't changed\x0a"
"                            // reset sibling, and it still can't be null\x0a"
"                            __w = __w->__parent_unsafe();\x0a"
"                        }\x0a"
"                        // __w has a right red child, left child may be null\x0a"
"                        __w->__is_black_ = __w->__parent_unsafe()->__is_black_;\x0a"
"                        __w->__parent_unsafe()->__is_black_ = true;\x0a"
"                        __w->__right_->__is_black_ = true;\x0a"
"                        __tree_left_rotate(__w->__parent_unsafe());\x0a"
"                        break;\x0a"
"                    }\x0a"
"                }\x0a"
"                else\x0a"
"                {\x0a"
"                    if (\x21__w->__is_black_)\x0a"
"                    {\x0a"
"                        __w->__is_black_ = true;\x0a"
"                        __w->__parent_unsafe()->__is_black_ = false;\x0a"
"                        __tree_right_rotate(__w->__parent_unsafe());\x0a"
"                        // __x is still valid\x0a"
"                        // reset __root only if necessary\x0a"
"                        if (__root == __w->__right_)\x0a"
"                            __root = __w;\x0a"
"                        // reset sibling, and it still can't be null\x0a"
"                        __w = __w->__right_->__left_;\x0a"
"                    }\x0a"
"                    // __w->__is_black_ is now true, __w may have null children\x0a"
"                    if ((__w->__left_  == nullptr \x7c\x7c __w->__left_->__is_black_) \x26\x26\x0a"
"                        (__w->__right_ == nullptr \x7c\x7c __w->__right_->__is_black_))\x0a"
"                    {\x0a"
"                        __w->__is_black_ = false;\x0a"
"                        __x = __w->__parent_unsafe();\x0a"
"                        // __x can no longer be null\x0a"
"                        if (\x21__x->__is_black_ \x7c\x7c __x == __root)\x0a"
"                        {\x0a"
"                            __x->__is_black_ = true;\x0a"
"                            break;\x0a"
"                        }\x0a"
"                        // reset sibling, and it still can't be null\x0a"
"                        __w = __tree_is_left_child(__x) \x3f\x0a"
"                                    __x->__parent_unsafe()->__right_ \x3a\x0a"
"                                    __x->__parent_->__left_;\x0a"
"                        // continue;\x0a"
"                    }\x0a"
"                    else  // __w has a red child\x0a"
"                    {\x0a"
"                        if (__w->__left_ == nullptr \x7c\x7c __w->__left_->__is_black_)\x0a"
"                        {\x0a"
"                            // __w right child is non-null and red\x0a"
"                            __w->__right_->__is_black_ = true;\x0a"
"                            __w->__is_black_ = false;\x0a"
"                            __tree_left_rotate(__w);\x0a"
"                            // __w is known not to be root, so root hasn't changed\x0a"
"                            // reset sibling, and it still can't be null\x0a"
"                            __w = __w->__parent_unsafe();\x0a"
"                        }\x0a"
"                        // __w has a left red child, right child may be null\x0a"
"                        __w->__is_black_ = __w->__parent_unsafe()->__is_black_;\x0a"
"                        __w->__parent_unsafe()->__is_black_ = true;\x0a"
"                        __w->__left_->__is_black_ = true;\x0a"
"                        __tree_right_rotate(__w->__parent_unsafe());\x0a"
"                        break;\x0a"
"                    }\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// node traits\x0a"
"\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Tp>\x0a"
"struct __is_tree_value_type_imp \x3a false_type {};\x0a"
"\x0a"
"template <class _Key, class _Value>\x0a"
"struct __is_tree_value_type_imp<__value_type<_Key, _Value>> \x3a true_type {};\x0a"
"\x0a"
"template <class ..._Args>\x0a"
"struct __is_tree_value_type \x3a false_type {};\x0a"
"\x0a"
"template <class _One>\x0a"
"struct __is_tree_value_type<_One> \x3a __is_tree_value_type_imp<typename __uncvref<_One>\x3a\x3atype> {};\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __tree_key_value_types {\x0a"
"  typedef _Tp key_type;\x0a"
"  typedef _Tp __node_value_type;\x0a"
"  typedef _Tp __container_value_type;\x0a"
"  static const bool __is_map = false;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static key_type const\x26 __get_key(_Tp const\x26 __v) {\x0a"
"    return __v;\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static __container_value_type const\x26 __get_value(__node_value_type const\x26 __v) {\x0a"
"    return __v;\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static __container_value_type* __get_ptr(__node_value_type\x26 __n) {\x0a"
"    return _VSTD\x3a\x3a""addressof(__n);\x0a"
"  }\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static __container_value_type\x26\x26 __move(__node_value_type\x26 __v) {\x0a"
"    return _VSTD\x3a\x3amove(__v);\x0a"
"  }\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Tp>\x0a"
"struct __tree_key_value_types<__value_type<_Key, _Tp> > {\x0a"
"  typedef _Key                                         key_type;\x0a"
"  typedef _Tp                                          mapped_type;\x0a"
"  typedef __value_type<_Key, _Tp>                      __node_value_type;\x0a"
"  typedef pair<const _Key, _Tp>                        __container_value_type;\x0a"
"  typedef __container_value_type                       __map_value_type;\x0a"
"  static const bool __is_map = true;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static key_type const\x26\x0a"
"  __get_key(__node_value_type const\x26 __t) {\x0a"
"    return __t.__get_value().first;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static typename enable_if<__is_same_uncvref<_Up, __container_value_type>\x3a\x3avalue,\x0a"
"      key_type const\x26>\x3a\x3atype\x0a"
"  __get_key(_Up\x26 __t) {\x0a"
"    return __t.first;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static __container_value_type const\x26\x0a"
"  __get_value(__node_value_type const\x26 __t) {\x0a"
"    return __t.__get_value();\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static typename enable_if<__is_same_uncvref<_Up, __container_value_type>\x3a\x3avalue,\x0a"
"      __container_value_type const\x26>\x3a\x3atype\x0a"
"  __get_value(_Up\x26 __t) {\x0a"
"    return __t;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static __container_value_type* __get_ptr(__node_value_type\x26 __n) {\x0a"
"    return _VSTD\x3a\x3a""addressof(__n.__get_value());\x0a"
"  }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static pair<key_type\x26\x26, mapped_type\x26\x26> __move(__node_value_type\x26 __v) {\x0a"
"    return __v.__move();\x0a"
"  }\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _VoidPtr>\x0a"
"struct __tree_node_base_types {\x0a"
"  typedef _VoidPtr                                               __void_pointer;\x0a"
"\x0a"
"  typedef __tree_node_base<__void_pointer>                      __node_base_type;\x0a"
"  typedef typename __rebind_pointer<_VoidPtr, __node_base_type>\x3a\x3atype\x0a"
"                                                             __node_base_pointer;\x0a"
"\x0a"
"  typedef __tree_end_node<__node_base_pointer>                  __end_node_type;\x0a"
"  typedef typename __rebind_pointer<_VoidPtr, __end_node_type>\x3a\x3atype\x0a"
"                                                             __end_node_pointer;\x0a"
"#if defined(_LIBCPP_ABI_TREE_REMOVE_NODE_POINTER_UB)\x0a"
"  typedef __end_node_pointer __parent_pointer;\x0a"
"#else\x0a"
"  typedef typename conditional<\x0a"
"      is_pointer<__end_node_pointer>\x3a\x3avalue,\x0a"
"        __end_node_pointer,\x0a"
"        __node_base_pointer>\x3a\x3atype __parent_pointer;\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"  static_assert((is_same<typename pointer_traits<_VoidPtr>\x3a\x3a""element_type, void>\x3a\x3avalue),\x0a"
"                  \x22_VoidPtr does not point to unqualified void type\x22);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _AllocPtr, class _KVTypes = __tree_key_value_types<_Tp>,\x0a"
"         bool = _KVTypes\x3a\x3a__is_map>\x0a"
"struct __tree_map_pointer_types {};\x0a"
"\x0a"
"template <class _Tp, class _AllocPtr, class _KVTypes>\x0a"
"struct __tree_map_pointer_types<_Tp, _AllocPtr, _KVTypes, true> {\x0a"
"  typedef typename _KVTypes\x3a\x3a__map_value_type   _Mv;\x0a"
"  typedef typename __rebind_pointer<_AllocPtr, _Mv>\x3a\x3atype\x0a"
"                                                       __map_value_type_pointer;\x0a"
"  typedef typename __rebind_pointer<_AllocPtr, const _Mv>\x3a\x3atype\x0a"
"                                                 __const_map_value_type_pointer;\x0a"
"};\x0a"
"\x0a"
"template <class _NodePtr, class _NodeT = typename pointer_traits<_NodePtr>\x3a\x3a""element_type>\x0a"
"struct __tree_node_types;\x0a"
"\x0a"
"template <class _NodePtr, class _Tp, class _VoidPtr>\x0a"
"struct __tree_node_types<_NodePtr, __tree_node<_Tp, _VoidPtr> >\x0a"
"    \x3a public __tree_node_base_types<_VoidPtr>,\x0a"
"             __tree_key_value_types<_Tp>,\x0a"
"             __tree_map_pointer_types<_Tp, _VoidPtr>\x0a"
"{\x0a"
"  typedef __tree_node_base_types<_VoidPtr> __base;\x0a"
"  typedef __tree_key_value_types<_Tp>      __key_base;\x0a"
"  typedef __tree_map_pointer_types<_Tp, _VoidPtr> __map_pointer_base;\x0a"
"public\x3a\x0a"
"\x0a"
"  typedef typename pointer_traits<_NodePtr>\x3a\x3a""element_type       __node_type;\x0a"
"  typedef _NodePtr                                              __node_pointer;\x0a"
"\x0a"
"  typedef _Tp                                                 __node_value_type;\x0a"
"  typedef typename __rebind_pointer<_VoidPtr, __node_value_type>\x3a\x3atype\x0a"
"                                                      __node_value_type_pointer;\x0a"
"  typedef typename __rebind_pointer<_VoidPtr, const __node_value_type>\x3a\x3atype\x0a"
"                                                __const_node_value_type_pointer;\x0a"
"#if defined(_LIBCPP_ABI_TREE_REMOVE_NODE_POINTER_UB)\x0a"
"  typedef typename __base\x3a\x3a__end_node_pointer __iter_pointer;\x0a"
"#else\x0a"
"  typedef typename conditional<\x0a"
"      is_pointer<__node_pointer>\x3a\x3avalue,\x0a"
"        typename __base\x3a\x3a__end_node_pointer,\x0a"
"        __node_pointer>\x3a\x3atype __iter_pointer;\x0a"
"#endif\x0a"
"private\x3a\x0a"
"    static_assert(\x21is_const<__node_type>\x3a\x3avalue,\x0a"
"                \x22_NodePtr should never be a pointer to const\x22);\x0a"
"    static_assert((is_same<typename __rebind_pointer<_VoidPtr, __node_type>\x3a\x3atype,\x0a"
"                          _NodePtr>\x3a\x3avalue), \x22_VoidPtr does not rebind to _NodePtr.\x22);\x0a"
"};\x0a"
"\x0a"
"template <class _ValueTp, class _VoidPtr>\x0a"
"struct __make_tree_node_types {\x0a"
"  typedef typename __rebind_pointer<_VoidPtr, __tree_node<_ValueTp, _VoidPtr> >\x3a\x3atype\x0a"
"                                                                        _NodePtr;\x0a"
"  typedef __tree_node_types<_NodePtr> type;\x0a"
"};\x0a"
"\x0a"
"// node\x0a"
"\x0a"
"template <class _Pointer>\x0a"
"class __tree_end_node\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Pointer pointer;\x0a"
"    pointer __left_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tree_end_node() _NOEXCEPT \x3a __left_() {}\x0a"
"};\x0a"
"\x0a"
"template <class _VoidPtr>\x0a"
"class __tree_node_base\x0a"
"    \x3a public __tree_node_base_types<_VoidPtr>\x3a\x3a__end_node_type\x0a"
"{\x0a"
"    typedef __tree_node_base_types<_VoidPtr> _NodeBaseTypes;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename _NodeBaseTypes\x3a\x3a__node_base_pointer pointer;\x0a"
"    typedef typename _NodeBaseTypes\x3a\x3a__parent_pointer __parent_pointer;\x0a"
"\x0a"
"    pointer          __right_;\x0a"
"    __parent_pointer __parent_;\x0a"
"    bool __is_black_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer __parent_unsafe() const { return static_cast<pointer>(__parent_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __set_parent(pointer __p) {\x0a"
"        __parent_ = static_cast<__parent_pointer>(__p);\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"  \x7e__tree_node_base() _LIBCPP_EQUAL_DELETE;\x0a"
"  __tree_node_base(__tree_node_base const\x26) _LIBCPP_EQUAL_DELETE;\x0a"
"  __tree_node_base\x26 operator=(__tree_node_base const\x26) _LIBCPP_EQUAL_DELETE;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr>\x0a"
"class __tree_node\x0a"
"    \x3a public __tree_node_base<_VoidPtr>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp __node_value_type;\x0a"
"\x0a"
"    __node_value_type __value_;\x0a"
"\x0a"
"private\x3a\x0a"
"  \x7e__tree_node() _LIBCPP_EQUAL_DELETE;\x0a"
"  __tree_node(__tree_node const\x26) _LIBCPP_EQUAL_DELETE;\x0a"
"  __tree_node\x26 operator=(__tree_node const\x26) _LIBCPP_EQUAL_DELETE;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"class __tree_node_destructor\x0a"
"{\x0a"
"    typedef _Allocator                                      allocator_type;\x0a"
"    typedef allocator_traits<allocator_type>                __alloc_traits;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer                pointer;\x0a"
"private\x3a\x0a"
"    typedef __tree_node_types<pointer> _NodeTypes;\x0a"
"    allocator_type\x26 __na_;\x0a"
"\x0a"
"    __tree_node_destructor\x26 operator=(const __tree_node_destructor\x26);\x0a"
"\x0a"
"public\x3a\x0a"
"    bool __value_constructed;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __tree_node_destructor(allocator_type\x26 __na, bool __val = false) _NOEXCEPT\x0a"
"        \x3a __na_(__na),\x0a"
"          __value_constructed(__val)\x0a"
"        {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator()(pointer __p) _NOEXCEPT\x0a"
"    {\x0a"
"        if (__value_constructed)\x0a"
"            __alloc_traits\x3a\x3a""destroy(__na_, _NodeTypes\x3a\x3a__get_ptr(__p->__value_));\x0a"
"        if (__p)\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__na_, __p, 1);\x0a"
"    }\x0a"
"\x0a"
"    template <class> friend class __map_node_destructor;\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _NodeType, class _Alloc>\x0a"
"struct __generic_container_node_destructor;\x0a"
"template <class _Tp, class _VoidPtr, class _Alloc>\x0a"
"struct __generic_container_node_destructor<__tree_node<_Tp, _VoidPtr>, _Alloc>\x0a"
"    \x3a __tree_node_destructor<_Alloc>\x0a"
"{\x0a"
"    using __tree_node_destructor<_Alloc>\x3a\x3a__tree_node_destructor;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _NodePtr, class _DiffType>\x0a"
"class _LIBCPP_TEMPLATE_VIS __tree_iterator\x0a"
"{\x0a"
"    typedef __tree_node_types<_NodePtr>                     _NodeTypes;\x0a"
"    typedef _NodePtr                                        __node_pointer;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__node_base_pointer        __node_base_pointer;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__end_node_pointer         __end_node_pointer;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__iter_pointer             __iter_pointer;\x0a"
"    typedef pointer_traits<__node_pointer> __pointer_traits;\x0a"
"\x0a"
"    __iter_pointer __ptr_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef bidirectional_iterator_tag                     iterator_category;\x0a"
"    typedef _Tp                                            value_type;\x0a"
"    typedef _DiffType                                      difference_type;\x0a"
"    typedef value_type\x26                                    reference;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__node_value_type_pointer pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __tree_iterator() _NOEXCEPT\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    \x3a __ptr_(nullptr)\x0a"
"#endif\x0a"
"    {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference operator*() const\x0a"
"        {return __get_np()->__value_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY pointer operator->() const\x0a"
"        {return pointer_traits<pointer>\x3a\x3apointer_to(__get_np()->__value_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tree_iterator\x26 operator++() {\x0a"
"      __ptr_ = static_cast<__iter_pointer>(\x0a"
"          __tree_next_iter<__end_node_pointer>(static_cast<__node_base_pointer>(__ptr_)));\x0a"
"      return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tree_iterator operator++(int)\x0a"
"        {__tree_iterator __t(*this); ++(*this); return __t;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tree_iterator\x26 operator--() {\x0a"
"      __ptr_ = static_cast<__iter_pointer>(__tree_prev_iter<__node_base_pointer>(\x0a"
"          static_cast<__end_node_pointer>(__ptr_)));\x0a"
"      return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tree_iterator operator--(int)\x0a"
"        {__tree_iterator __t(*this); --(*this); return __t;}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const __tree_iterator\x26 __x, const __tree_iterator\x26 __y)\x0a"
"        {return __x.__ptr_ == __y.__ptr_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const __tree_iterator\x26 __x, const __tree_iterator\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __tree_iterator(__node_pointer __p) _NOEXCEPT \x3a __ptr_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __tree_iterator(__end_node_pointer __p) _NOEXCEPT \x3a __ptr_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __node_pointer __get_np() const { return static_cast<__node_pointer>(__ptr_); }\x0a"
"    template <class, class, class> friend class __tree;\x0a"
"    template <class, class, class> friend class _LIBCPP_TEMPLATE_VIS __tree_const_iterator;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __map_iterator;\x0a"
"    template <class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS map;\x0a"
"    template <class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS multimap;\x0a"
"    template <class, class, class> friend class _LIBCPP_TEMPLATE_VIS set;\x0a"
"    template <class, class, class> friend class _LIBCPP_TEMPLATE_VIS multiset;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _NodePtr, class _DiffType>\x0a"
"class _LIBCPP_TEMPLATE_VIS __tree_const_iterator\x0a"
"{\x0a"
"    typedef __tree_node_types<_NodePtr>                     _NodeTypes;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__node_pointer             __node_pointer;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__node_base_pointer        __node_base_pointer;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__end_node_pointer         __end_node_pointer;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__iter_pointer             __iter_pointer;\x0a"
"    typedef pointer_traits<__node_pointer> __pointer_traits;\x0a"
"\x0a"
"    __iter_pointer __ptr_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef bidirectional_iterator_tag                           iterator_category;\x0a"
"    typedef _Tp                                                  value_type;\x0a"
"    typedef _DiffType                                            difference_type;\x0a"
"    typedef const value_type\x26                                    reference;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__const_node_value_type_pointer pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __tree_const_iterator() _NOEXCEPT\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    \x3a __ptr_(nullptr)\x0a"
"#endif\x0a"
"    {}\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef __tree_iterator<value_type, __node_pointer, difference_type>\x0a"
"                                                           __non_const_iterator;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tree_const_iterator(__non_const_iterator __p) _NOEXCEPT\x0a"
"        \x3a __ptr_(__p.__ptr_) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference operator*() const\x0a"
"        {return __get_np()->__value_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY pointer operator->() const\x0a"
"        {return pointer_traits<pointer>\x3a\x3apointer_to(__get_np()->__value_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tree_const_iterator\x26 operator++() {\x0a"
"      __ptr_ = static_cast<__iter_pointer>(\x0a"
"          __tree_next_iter<__end_node_pointer>(static_cast<__node_base_pointer>(__ptr_)));\x0a"
"      return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tree_const_iterator operator++(int)\x0a"
"        {__tree_const_iterator __t(*this); ++(*this); return __t;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tree_const_iterator\x26 operator--() {\x0a"
"      __ptr_ = static_cast<__iter_pointer>(__tree_prev_iter<__node_base_pointer>(\x0a"
"          static_cast<__end_node_pointer>(__ptr_)));\x0a"
"      return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tree_const_iterator operator--(int)\x0a"
"        {__tree_const_iterator __t(*this); --(*this); return __t;}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const __tree_const_iterator\x26 __x, const __tree_const_iterator\x26 __y)\x0a"
"        {return __x.__ptr_ == __y.__ptr_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const __tree_const_iterator\x26 __x, const __tree_const_iterator\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __tree_const_iterator(__node_pointer __p) _NOEXCEPT\x0a"
"        \x3a __ptr_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __tree_const_iterator(__end_node_pointer __p) _NOEXCEPT\x0a"
"        \x3a __ptr_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __node_pointer __get_np() const { return static_cast<__node_pointer>(__ptr_); }\x0a"
"\x0a"
"    template <class, class, class> friend class __tree;\x0a"
"    template <class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS map;\x0a"
"    template <class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS multimap;\x0a"
"    template <class, class, class> friend class _LIBCPP_TEMPLATE_VIS set;\x0a"
"    template <class, class, class> friend class _LIBCPP_TEMPLATE_VIS multiset;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __map_const_iterator;\x0a"
"\x0a"
"};\x0a"
"\x0a"
"template<class _Tp, class _Compare>\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_DIAGNOSE_WARNING(\x21std\x3a\x3a__invokable<_Compare const\x26, _Tp const\x26, _Tp const\x26>\x3a\x3avalue,\x0a"
"        \x22the specified comparator type does not provide a viable const call operator\x22)\x0a"
"#endif\x0a"
"int __diagnose_non_const_comparator();\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"class __tree\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp                                      value_type;\x0a"
"    typedef _Compare                                 value_compare;\x0a"
"    typedef _Allocator                               allocator_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef allocator_traits<allocator_type>         __alloc_traits;\x0a"
"    typedef typename __make_tree_node_types<value_type,\x0a"
"        typename __alloc_traits\x3a\x3avoid_pointer>\x3a\x3atype\x0a"
"                                                    _NodeTypes;\x0a"
"    typedef typename _NodeTypes\x3a\x3akey_type           key_type;\x0a"
"public\x3a\x0a"
"    typedef typename _NodeTypes\x3a\x3a__node_value_type      __node_value_type;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__container_value_type __container_value_type;\x0a"
"\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer         pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3asize_type       size_type;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename _NodeTypes\x3a\x3a__void_pointer        __void_pointer;\x0a"
"\x0a"
"    typedef typename _NodeTypes\x3a\x3a__node_type           __node;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__node_pointer        __node_pointer;\x0a"
"\x0a"
"    typedef typename _NodeTypes\x3a\x3a__node_base_type      __node_base;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__node_base_pointer   __node_base_pointer;\x0a"
"\x0a"
"    typedef typename _NodeTypes\x3a\x3a__end_node_type       __end_node_t;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__end_node_pointer    __end_node_ptr;\x0a"
"\x0a"
"    typedef typename _NodeTypes\x3a\x3a__parent_pointer      __parent_pointer;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__iter_pointer        __iter_pointer;\x0a"
"\x0a"
"    typedef typename __rebind_alloc_helper<__alloc_traits, __node>\x3a\x3atype __node_allocator;\x0a"
"    typedef allocator_traits<__node_allocator>         __node_traits;\x0a"
"\x0a"
"private\x3a\x0a"
"    // check for sane allocator pointer rebinding semantics. Rebinding the\x0a"
"    // allocator for a new pointer type should be exactly the same as rebinding\x0a"
"    // the pointer using 'pointer_traits'.\x0a"
"    static_assert((is_same<__node_pointer, typename __node_traits\x3a\x3apointer>\x3a\x3avalue),\x0a"
"                  \x22""Allocator does not rebind pointers in a sane manner.\x22);\x0a"
"    typedef typename __rebind_alloc_helper<__node_traits, __node_base>\x3a\x3atype\x0a"
"        __node_base_allocator;\x0a"
"    typedef allocator_traits<__node_base_allocator> __node_base_traits;\x0a"
"    static_assert((is_same<__node_base_pointer, typename __node_base_traits\x3a\x3apointer>\x3a\x3avalue),\x0a"
"                 \x22""Allocator does not rebind pointers in a sane manner.\x22);\x0a"
"\x0a"
"private\x3a\x0a"
"    __iter_pointer                                     __begin_node_;\x0a"
"    __compressed_pair<__end_node_t, __node_allocator>  __pair1_;\x0a"
"    __compressed_pair<size_type, value_compare>        __pair3_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __iter_pointer __end_node() _NOEXCEPT\x0a"
"    {\x0a"
"        return static_cast<__iter_pointer>(\x0a"
"                pointer_traits<__end_node_ptr>\x3a\x3apointer_to(__pair1_.first())\x0a"
"        );\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __iter_pointer __end_node() const _NOEXCEPT\x0a"
"    {\x0a"
"        return static_cast<__iter_pointer>(\x0a"
"            pointer_traits<__end_node_ptr>\x3a\x3apointer_to(\x0a"
"                const_cast<__end_node_t\x26>(__pair1_.first())\x0a"
"            )\x0a"
"        );\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          __node_allocator\x26 __node_alloc() _NOEXCEPT {return __pair1_.second();}\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const __node_allocator\x26 __node_alloc() const _NOEXCEPT\x0a"
"        {return __pair1_.second();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          __iter_pointer\x26 __begin_node() _NOEXCEPT {return __begin_node_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const __iter_pointer\x26 __begin_node() const _NOEXCEPT {return __begin_node_;}\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type __alloc() const _NOEXCEPT\x0a"
"        {return allocator_type(__node_alloc());}\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          size_type\x26 size() _NOEXCEPT {return __pair3_.first();}\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const size_type\x26 size() const _NOEXCEPT {return __pair3_.first();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          value_compare\x26 value_comp() _NOEXCEPT {return __pair3_.second();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_compare\x26 value_comp() const _NOEXCEPT\x0a"
"        {return __pair3_.second();}\x0a"
"public\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __node_pointer __root() const _NOEXCEPT\x0a"
"        {return static_cast<__node_pointer>(__end_node()->__left_);}\x0a"
"\x0a"
"    __node_base_pointer* __root_ptr() const _NOEXCEPT {\x0a"
"        return _VSTD\x3a\x3a""addressof(__end_node()->__left_);\x0a"
"    }\x0a"
"\x0a"
"    typedef __tree_iterator<value_type, __node_pointer, difference_type>             iterator;\x0a"
"    typedef __tree_const_iterator<value_type, __node_pointer, difference_type> const_iterator;\x0a"
"\x0a"
"    explicit __tree(const value_compare\x26 __comp)\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_default_constructible<__node_allocator>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<value_compare>\x3a\x3avalue);\x0a"
"    explicit __tree(const allocator_type\x26 __a);\x0a"
"    __tree(const value_compare\x26 __comp, const allocator_type\x26 __a);\x0a"
"    __tree(const __tree\x26 __t);\x0a"
"    __tree\x26 operator=(const __tree\x26 __t);\x0a"
"    template <class _ForwardIterator>\x0a"
"        void __assign_unique(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _InputIterator>\x0a"
"        void __assign_multi(_InputIterator __first, _InputIterator __last);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    __tree(__tree\x26\x26 __t)\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_move_constructible<__node_allocator>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<value_compare>\x3a\x3avalue);\x0a"
"    __tree(__tree\x26\x26 __t, const allocator_type\x26 __a);\x0a"
"    __tree\x26 operator=(__tree\x26\x26 __t)\x0a"
"        _NOEXCEPT_(\x0a"
"            __node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<value_compare>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue);\x0a"
"#endif // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    \x7e__tree();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator begin()  _NOEXCEPT {return       iterator(__begin_node());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT {return const_iterator(__begin_node());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator end() _NOEXCEPT {return       iterator(__end_node());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end() const _NOEXCEPT {return const_iterator(__end_node());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT\x0a"
"        {return std\x3a\x3amin<size_type>(\x0a"
"                __node_traits\x3a\x3amax_size(__node_alloc()),\x0a"
"                numeric_limits<difference_type >\x3a\x3amax());}\x0a"
"\x0a"
"    void clear() _NOEXCEPT;\x0a"
"\x0a"
"    void swap(__tree\x26 __t)\x0a"
"#if _LIBCPP_STD_VER <= 11\x0a"
"        _NOEXCEPT_(\x0a"
"            __is_nothrow_swappable<value_compare>\x3a\x3avalue\x0a"
"            \x26\x26 (\x21__node_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                 __is_nothrow_swappable<__node_allocator>\x3a\x3avalue)\x0a"
"            );\x0a"
"#else\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<value_compare>\x3a\x3avalue);\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Key, class ..._Args>\x0a"
"    pair<iterator, bool>\x0a"
"    __emplace_unique_key_args(_Key const\x26, _Args\x26\x26... __args);\x0a"
"    template <class _Key, class ..._Args>\x0a"
"    iterator\x0a"
"    __emplace_hint_unique_key_args(const_iterator, _Key const\x26, _Args\x26\x26...);\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    pair<iterator, bool> __emplace_unique_impl(_Args\x26\x26... __args);\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    iterator __emplace_hint_unique_impl(const_iterator __p, _Args\x26\x26... __args);\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    iterator __emplace_multi(_Args\x26\x26... __args);\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    iterator __emplace_hint_multi(const_iterator __p, _Args\x26\x26... __args);\x0a"
"\x0a"
"    template <class _Pp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> __emplace_unique(_Pp\x26\x26 __x) {\x0a"
"        return __emplace_unique_extract_key(_VSTD\x3a\x3a""forward<_Pp>(__x),\x0a"
"                                            __can_extract_key<_Pp, key_type>());\x0a"
"    }\x0a"
"\x0a"
"    template <class _First, class _Second>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<\x0a"
"        __can_extract_map_key<_First, key_type, __container_value_type>\x3a\x3avalue,\x0a"
"        pair<iterator, bool>\x0a"
"    >\x3a\x3atype __emplace_unique(_First\x26\x26 __f, _Second\x26\x26 __s) {\x0a"
"        return __emplace_unique_key_args(__f, _VSTD\x3a\x3a""forward<_First>(__f),\x0a"
"                                              _VSTD\x3a\x3a""forward<_Second>(__s));\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> __emplace_unique(_Args\x26\x26... __args) {\x0a"
"        return __emplace_unique_impl(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    template <class _Pp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool>\x0a"
"    __emplace_unique_extract_key(_Pp\x26\x26 __x, __extract_key_fail_tag) {\x0a"
"      return __emplace_unique_impl(_VSTD\x3a\x3a""forward<_Pp>(__x));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Pp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool>\x0a"
"    __emplace_unique_extract_key(_Pp\x26\x26 __x, __extract_key_self_tag) {\x0a"
"      return __emplace_unique_key_args(__x, _VSTD\x3a\x3a""forward<_Pp>(__x));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Pp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool>\x0a"
"    __emplace_unique_extract_key(_Pp\x26\x26 __x, __extract_key_first_tag) {\x0a"
"      return __emplace_unique_key_args(__x.first, _VSTD\x3a\x3a""forward<_Pp>(__x));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Pp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __emplace_hint_unique(const_iterator __p, _Pp\x26\x26 __x) {\x0a"
"        return __emplace_hint_unique_extract_key(__p, _VSTD\x3a\x3a""forward<_Pp>(__x),\x0a"
"                                            __can_extract_key<_Pp, key_type>());\x0a"
"    }\x0a"
"\x0a"
"    template <class _First, class _Second>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<\x0a"
"        __can_extract_map_key<_First, key_type, __container_value_type>\x3a\x3avalue,\x0a"
"        iterator\x0a"
"    >\x3a\x3atype __emplace_hint_unique(const_iterator __p, _First\x26\x26 __f, _Second\x26\x26 __s) {\x0a"
"        return __emplace_hint_unique_key_args(__p, __f,\x0a"
"                                              _VSTD\x3a\x3a""forward<_First>(__f),\x0a"
"                                              _VSTD\x3a\x3a""forward<_Second>(__s));\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __emplace_hint_unique(const_iterator __p, _Args\x26\x26... __args) {\x0a"
"        return __emplace_hint_unique_impl(__p, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    template <class _Pp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator\x0a"
"    __emplace_hint_unique_extract_key(const_iterator __p, _Pp\x26\x26 __x, __extract_key_fail_tag) {\x0a"
"      return __emplace_hint_unique_impl(__p, _VSTD\x3a\x3a""forward<_Pp>(__x));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Pp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator\x0a"
"    __emplace_hint_unique_extract_key(const_iterator __p, _Pp\x26\x26 __x, __extract_key_self_tag) {\x0a"
"      return __emplace_hint_unique_key_args(__p, __x, _VSTD\x3a\x3a""forward<_Pp>(__x));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Pp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator\x0a"
"    __emplace_hint_unique_extract_key(const_iterator __p, _Pp\x26\x26 __x, __extract_key_first_tag) {\x0a"
"      return __emplace_hint_unique_key_args(__p, __x.first, _VSTD\x3a\x3a""forward<_Pp>(__x));\x0a"
"    }\x0a"
"\x0a"
"#else\x0a"
"    template <class _Key, class _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> __emplace_unique_key_args(_Key const\x26, _Args\x26 __args);\x0a"
"    template <class _Key, class _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __emplace_hint_unique_key_args(const_iterator, _Key const\x26, _Args\x26);\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> __insert_unique(const __container_value_type\x26 __v) {\x0a"
"        return __emplace_unique_key_args(_NodeTypes\x3a\x3a__get_key(__v), __v);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __insert_unique(const_iterator __p, const __container_value_type\x26 __v) {\x0a"
"        return __emplace_hint_unique_key_args(__p, _NodeTypes\x3a\x3a__get_key(__v), __v);\x0a"
"    }\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __insert_multi(const __container_value_type\x26 __v);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __insert_multi(const_iterator __p, const __container_value_type\x26 __v);\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> __insert_unique(__container_value_type\x26\x26 __v) {\x0a"
"        return __emplace_unique_key_args(_NodeTypes\x3a\x3a__get_key(__v), _VSTD\x3a\x3amove(__v));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __insert_unique(const_iterator __p, __container_value_type\x26\x26 __v) {\x0a"
"        return __emplace_hint_unique_key_args(__p, _NodeTypes\x3a\x3a__get_key(__v), _VSTD\x3a\x3amove(__v));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Vp, class = typename enable_if<\x0a"
"            \x21is_same<typename __unconstref<_Vp>\x3a\x3atype,\x0a"
"                     __container_value_type\x0a"
"            >\x3a\x3avalue\x0a"
"        >\x3a\x3atype>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> __insert_unique(_Vp\x26\x26 __v) {\x0a"
"        return __emplace_unique(_VSTD\x3a\x3a""forward<_Vp>(__v));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Vp, class = typename enable_if<\x0a"
"            \x21is_same<typename __unconstref<_Vp>\x3a\x3atype,\x0a"
"                     __container_value_type\x0a"
"            >\x3a\x3avalue\x0a"
"        >\x3a\x3atype>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __insert_unique(const_iterator __p, _Vp\x26\x26 __v) {\x0a"
"        return __emplace_hint_unique(__p, _VSTD\x3a\x3a""forward<_Vp>(__v));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __insert_multi(__container_value_type\x26\x26 __v) {\x0a"
"        return __emplace_multi(_VSTD\x3a\x3amove(__v));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __insert_multi(const_iterator __p, __container_value_type\x26\x26 __v) {\x0a"
"        return __emplace_hint_multi(__p, _VSTD\x3a\x3amove(__v));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Vp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __insert_multi(_Vp\x26\x26 __v) {\x0a"
"        return __emplace_multi(_VSTD\x3a\x3a""forward<_Vp>(__v));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Vp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __insert_multi(const_iterator __p, _Vp\x26\x26 __v) {\x0a"
"        return __emplace_hint_multi(__p, _VSTD\x3a\x3a""forward<_Vp>(__v));\x0a"
"    }\x0a"
"\x0a"
"#endif // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> __node_assign_unique(const __container_value_type\x26 __v, __node_pointer __dest);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __node_insert_multi(__node_pointer __nd);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __node_insert_multi(const_iterator __p, __node_pointer __nd);\x0a"
"\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY iterator\x0a"
"    __remove_node_pointer(__node_pointer) _NOEXCEPT;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    template <class _NodeHandle, class _InsertReturnType>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _InsertReturnType __node_handle_insert_unique(_NodeHandle\x26\x26);\x0a"
"    template <class _NodeHandle>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __node_handle_insert_unique(const_iterator, _NodeHandle\x26\x26);\x0a"
"    template <class _Tree>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __node_handle_merge_unique(_Tree\x26 __source);\x0a"
"\x0a"
"    template <class _NodeHandle>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __node_handle_insert_multi(_NodeHandle\x26\x26);\x0a"
"    template <class _NodeHandle>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __node_handle_insert_multi(const_iterator, _NodeHandle\x26\x26);\x0a"
"    template <class _Tree>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __node_handle_merge_multi(_Tree\x26 __source);\x0a"
"\x0a"
"\x0a"
"    template <class _NodeHandle>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _NodeHandle __node_handle_extract(key_type const\x26);\x0a"
"    template <class _NodeHandle>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _NodeHandle __node_handle_extract(const_iterator);\x0a"
"#endif\x0a"
"\x0a"
"    iterator erase(const_iterator __p);\x0a"
"    iterator erase(const_iterator __f, const_iterator __l);\x0a"
"    template <class _Key>\x0a"
"        size_type __erase_unique(const _Key\x26 __k);\x0a"
"    template <class _Key>\x0a"
"        size_type __erase_multi(const _Key\x26 __k);\x0a"
"\x0a"
"    void __insert_node_at(__parent_pointer     __parent,\x0a"
"                          __node_base_pointer\x26 __child,\x0a"
"                          __node_base_pointer __new_node) _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Key>\x0a"
"        iterator find(const _Key\x26 __v);\x0a"
"    template <class _Key>\x0a"
"        const_iterator find(const _Key\x26 __v) const;\x0a"
"\x0a"
"    template <class _Key>\x0a"
"        size_type __count_unique(const _Key\x26 __k) const;\x0a"
"    template <class _Key>\x0a"
"        size_type __count_multi(const _Key\x26 __k) const;\x0a"
"\x0a"
"    template <class _Key>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator lower_bound(const _Key\x26 __v)\x0a"
"            {return __lower_bound(__v, __root(), __end_node());}\x0a"
"    template <class _Key>\x0a"
"        iterator __lower_bound(const _Key\x26 __v,\x0a"
"                               __node_pointer __root,\x0a"
"                               __iter_pointer __result);\x0a"
"    template <class _Key>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        const_iterator lower_bound(const _Key\x26 __v) const\x0a"
"            {return __lower_bound(__v, __root(), __end_node());}\x0a"
"    template <class _Key>\x0a"
"        const_iterator __lower_bound(const _Key\x26 __v,\x0a"
"                                     __node_pointer __root,\x0a"
"                                     __iter_pointer __result) const;\x0a"
"    template <class _Key>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator upper_bound(const _Key\x26 __v)\x0a"
"            {return __upper_bound(__v, __root(), __end_node());}\x0a"
"    template <class _Key>\x0a"
"        iterator __upper_bound(const _Key\x26 __v,\x0a"
"                               __node_pointer __root,\x0a"
"                               __iter_pointer __result);\x0a"
"    template <class _Key>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        const_iterator upper_bound(const _Key\x26 __v) const\x0a"
"            {return __upper_bound(__v, __root(), __end_node());}\x0a"
"    template <class _Key>\x0a"
"        const_iterator __upper_bound(const _Key\x26 __v,\x0a"
"                                     __node_pointer __root,\x0a"
"                                     __iter_pointer __result) const;\x0a"
"    template <class _Key>\x0a"
"        pair<iterator, iterator>\x0a"
"        __equal_range_unique(const _Key\x26 __k);\x0a"
"    template <class _Key>\x0a"
"        pair<const_iterator, const_iterator>\x0a"
"        __equal_range_unique(const _Key\x26 __k) const;\x0a"
"\x0a"
"    template <class _Key>\x0a"
"        pair<iterator, iterator>\x0a"
"        __equal_range_multi(const _Key\x26 __k);\x0a"
"    template <class _Key>\x0a"
"        pair<const_iterator, const_iterator>\x0a"
"        __equal_range_multi(const _Key\x26 __k) const;\x0a"
"\x0a"
"    typedef __tree_node_destructor<__node_allocator> _Dp;\x0a"
"    typedef unique_ptr<__node, _Dp> __node_holder;\x0a"
"\x0a"
"    __node_holder remove(const_iterator __p) _NOEXCEPT;\x0a"
"private\x3a\x0a"
"    __node_base_pointer\x26\x0a"
"        __find_leaf_low(__parent_pointer\x26 __parent, const key_type\x26 __v);\x0a"
"    __node_base_pointer\x26\x0a"
"        __find_leaf_high(__parent_pointer\x26 __parent, const key_type\x26 __v);\x0a"
"    __node_base_pointer\x26\x0a"
"        __find_leaf(const_iterator __hint,\x0a"
"                    __parent_pointer\x26 __parent, const key_type\x26 __v);\x0a"
"    // FIXME\x3a Make this function const qualified. Unfortunetly doing so\x0a"
"    // breaks existing code which uses non-const callable comparators.\x0a"
"    template <class _Key>\x0a"
"    __node_base_pointer\x26\x0a"
"        __find_equal(__parent_pointer\x26 __parent, const _Key\x26 __v);\x0a"
"    template <class _Key>\x0a"
"    _LIBCPP_INLINE_VISIBILITY __node_base_pointer\x26\x0a"
"    __find_equal(__parent_pointer\x26 __parent, const _Key\x26 __v) const {\x0a"
"      return const_cast<__tree*>(this)->__find_equal(__parent, __v);\x0a"
"    }\x0a"
"    template <class _Key>\x0a"
"    __node_base_pointer\x26\x0a"
"        __find_equal(const_iterator __hint, __parent_pointer\x26 __parent,\x0a"
"                     __node_base_pointer\x26 __dummy,\x0a"
"                     const _Key\x26 __v);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class ..._Args>\x0a"
"    __node_holder __construct_node(_Args\x26\x26 ...__args);\x0a"
"#else\x0a"
"    __node_holder __construct_node(const __container_value_type\x26 __v);\x0a"
"#endif\x0a"
"\x0a"
"    void destroy(__node_pointer __nd) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __tree\x26 __t)\x0a"
"        {__copy_assign_alloc(__t, integral_constant<bool,\x0a"
"             __node_traits\x3a\x3apropagate_on_container_copy_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __tree\x26 __t, true_type)\x0a"
"        {\x0a"
"        if (__node_alloc() \x21= __t.__node_alloc())\x0a"
"            clear();\x0a"
"        __node_alloc() = __t.__node_alloc();\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __tree\x26, false_type) {}\x0a"
"\x0a"
"    void __move_assign(__tree\x26 __t, false_type);\x0a"
"    void __move_assign(__tree\x26 __t, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<value_compare>\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__tree\x26 __t)\x0a"
"        _NOEXCEPT_(\x0a"
"            \x21__node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"            is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue)\x0a"
"        {__move_assign_alloc(__t, integral_constant<bool,\x0a"
"             __node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__tree\x26 __t, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue)\x0a"
"        {__node_alloc() = _VSTD\x3a\x3amove(__t.__node_alloc());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__tree\x26, false_type) _NOEXCEPT {}\x0a"
"\x0a"
"    struct _DetachedTreeCache {\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      explicit _DetachedTreeCache(__tree *__t) _NOEXCEPT \x3a __t_(__t),\x0a"
"        __cache_root_(__detach_from_tree(__t)) {\x0a"
"          __advance();\x0a"
"        }\x0a"
"\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      __node_pointer __get() const _NOEXCEPT {\x0a"
"        return __cache_elem_;\x0a"
"      }\x0a"
"\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      void __advance() _NOEXCEPT {\x0a"
"        __cache_elem_ = __cache_root_;\x0a"
"        if (__cache_root_) {\x0a"
"          __cache_root_ = __detach_next(__cache_root_);\x0a"
"        }\x0a"
"      }\x0a"
"\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      \x7e_DetachedTreeCache() {\x0a"
"        __t_->destroy(__cache_elem_);\x0a"
"        if (__cache_root_) {\x0a"
"          while (__cache_root_->__parent_ \x21= nullptr)\x0a"
"            __cache_root_ = static_cast<__node_pointer>(__cache_root_->__parent_);\x0a"
"          __t_->destroy(__cache_root_);\x0a"
"        }\x0a"
"      }\x0a"
"\x0a"
"       _DetachedTreeCache(_DetachedTreeCache const\x26) = delete;\x0a"
"       _DetachedTreeCache\x26 operator=(_DetachedTreeCache const\x26) = delete;\x0a"
"\x0a"
"    private\x3a\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      static __node_pointer __detach_from_tree(__tree *__t) _NOEXCEPT;\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      static __node_pointer __detach_next(__node_pointer) _NOEXCEPT;\x0a"
"\x0a"
"      __tree *__t_;\x0a"
"      __node_pointer __cache_root_;\x0a"
"      __node_pointer __cache_elem_;\x0a"
"    };\x0a"
"\x0a"
"\x0a"
"    template <class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS map;\x0a"
"    template <class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS multimap;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__tree(const value_compare\x26 __comp)\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_default_constructible<__node_allocator>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<value_compare>\x3a\x3avalue)\x0a"
"    \x3a __pair3_(0, __comp)\x0a"
"{\x0a"
"    __begin_node() = __end_node();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__tree(const allocator_type\x26 __a)\x0a"
"    \x3a __begin_node_(__iter_pointer()),\x0a"
"      __pair1_(__second_tag(), __node_allocator(__a)),\x0a"
"      __pair3_(0)\x0a"
"{\x0a"
"    __begin_node() = __end_node();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__tree(const value_compare\x26 __comp,\x0a"
"                                           const allocator_type\x26 __a)\x0a"
"    \x3a __begin_node_(__iter_pointer()),\x0a"
"      __pair1_(__second_tag(), __node_allocator(__a)),\x0a"
"      __pair3_(0, __comp)\x0a"
"{\x0a"
"    __begin_node() = __end_node();\x0a"
"}\x0a"
"\x0a"
"// Precondition\x3a  size() \x21= 0\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_pointer\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a_DetachedTreeCache\x3a\x3a__detach_from_tree(__tree *__t) _NOEXCEPT\x0a"
"{\x0a"
"    __node_pointer __cache = static_cast<__node_pointer>(__t->__begin_node());\x0a"
"    __t->__begin_node() = __t->__end_node();\x0a"
"    __t->__end_node()->__left_->__parent_ = nullptr;\x0a"
"    __t->__end_node()->__left_ = nullptr;\x0a"
"    __t->size() = 0;\x0a"
"    // __cache->__left_ == nullptr\x0a"
"    if (__cache->__right_ \x21= nullptr)\x0a"
"        __cache = static_cast<__node_pointer>(__cache->__right_);\x0a"
"    // __cache->__left_ == nullptr\x0a"
"    // __cache->__right_ == nullptr\x0a"
"    return __cache;\x0a"
"}\x0a"
"\x0a"
"// Precondition\x3a  __cache \x21= nullptr\x0a"
"//    __cache->left_ == nullptr\x0a"
"//    __cache->right_ == nullptr\x0a"
"//    This is no longer a red-black tree\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_pointer\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a_DetachedTreeCache\x3a\x3a__detach_next(__node_pointer __cache) _NOEXCEPT\x0a"
"{\x0a"
"    if (__cache->__parent_ == nullptr)\x0a"
"        return nullptr;\x0a"
"    if (__tree_is_left_child(static_cast<__node_base_pointer>(__cache)))\x0a"
"    {\x0a"
"        __cache->__parent_->__left_ = nullptr;\x0a"
"        __cache = static_cast<__node_pointer>(__cache->__parent_);\x0a"
"        if (__cache->__right_ == nullptr)\x0a"
"            return __cache;\x0a"
"        return static_cast<__node_pointer>(__tree_leaf(__cache->__right_));\x0a"
"    }\x0a"
"    // __cache is right child\x0a"
"    __cache->__parent_unsafe()->__right_ = nullptr;\x0a"
"    __cache = static_cast<__node_pointer>(__cache->__parent_);\x0a"
"    if (__cache->__left_ == nullptr)\x0a"
"        return __cache;\x0a"
"    return static_cast<__node_pointer>(__tree_leaf(__cache->__left_));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x26\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3aoperator=(const __tree\x26 __t)\x0a"
"{\x0a"
"    if (this \x21= \x26__t)\x0a"
"    {\x0a"
"        value_comp() = __t.value_comp();\x0a"
"        __copy_assign_alloc(__t);\x0a"
"        __assign_multi(__t.begin(), __t.end());\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"void\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__assign_unique(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    typedef iterator_traits<_ForwardIterator> _ITraits;\x0a"
"    typedef typename _ITraits\x3a\x3avalue_type _ItValueType;\x0a"
"    static_assert((is_same<_ItValueType, __container_value_type>\x3a\x3avalue),\x0a"
"                  \x22__assign_unique may only be called with the containers value type\x22);\x0a"
"    static_assert(__is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"                  \x22__assign_unique requires a forward iterator\x22);\x0a"
"    if (size() \x21= 0)\x0a"
"    {\x0a"
"        _DetachedTreeCache __cache(this);\x0a"
"          for (; __cache.__get() \x21= nullptr \x26\x26 __first \x21= __last; ++__first) {\x0a"
"              if (__node_assign_unique(*__first, __cache.__get()).second)\x0a"
"                  __cache.__advance();\x0a"
"            }\x0a"
"    }\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __insert_unique(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _InputIterator>\x0a"
"void\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__assign_multi(_InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    typedef iterator_traits<_InputIterator> _ITraits;\x0a"
"    typedef typename _ITraits\x3a\x3avalue_type _ItValueType;\x0a"
"    static_assert((is_same<_ItValueType, __container_value_type>\x3a\x3avalue \x7c\x7c\x0a"
"                  is_same<_ItValueType, __node_value_type>\x3a\x3avalue),\x0a"
"                  \x22__assign_multi may only be called with the containers value type\x22\x0a"
"                  \x22 or the nodes value type\x22);\x0a"
"    if (size() \x21= 0)\x0a"
"    {\x0a"
"        _DetachedTreeCache __cache(this);\x0a"
"        for (; __cache.__get() \x26\x26 __first \x21= __last; ++__first) {\x0a"
"            __cache.__get()->__value_ = *__first;\x0a"
"            __node_insert_multi(__cache.__get());\x0a"
"            __cache.__advance();\x0a"
"        }\x0a"
"    }\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __insert_multi(_NodeTypes\x3a\x3a__get_value(*__first));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__tree(const __tree\x26 __t)\x0a"
"    \x3a __begin_node_(__iter_pointer()),\x0a"
"      __pair1_(__second_tag(), __node_traits\x3a\x3aselect_on_container_copy_construction(__t.__node_alloc())),\x0a"
"      __pair3_(0, __t.value_comp())\x0a"
"{\x0a"
"    __begin_node() = __end_node();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__tree(__tree\x26\x26 __t)\x0a"
"    _NOEXCEPT_(\x0a"
"        is_nothrow_move_constructible<__node_allocator>\x3a\x3avalue \x26\x26\x0a"
"        is_nothrow_move_constructible<value_compare>\x3a\x3avalue)\x0a"
"    \x3a __begin_node_(_VSTD\x3a\x3amove(__t.__begin_node_)),\x0a"
"      __pair1_(_VSTD\x3a\x3amove(__t.__pair1_)),\x0a"
"      __pair3_(_VSTD\x3a\x3amove(__t.__pair3_))\x0a"
"{\x0a"
"    if (size() == 0)\x0a"
"        __begin_node() = __end_node();\x0a"
"    else\x0a"
"    {\x0a"
"        __end_node()->__left_->__parent_ = static_cast<__parent_pointer>(__end_node());\x0a"
"        __t.__begin_node() = __t.__end_node();\x0a"
"        __t.__end_node()->__left_ = nullptr;\x0a"
"        __t.size() = 0;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__tree(__tree\x26\x26 __t, const allocator_type\x26 __a)\x0a"
"    \x3a __pair1_(__second_tag(), __node_allocator(__a)),\x0a"
"      __pair3_(0, _VSTD\x3a\x3amove(__t.value_comp()))\x0a"
"{\x0a"
"    if (__a == __t.__alloc())\x0a"
"    {\x0a"
"        if (__t.size() == 0)\x0a"
"            __begin_node() = __end_node();\x0a"
"        else\x0a"
"        {\x0a"
"            __begin_node() = __t.__begin_node();\x0a"
"            __end_node()->__left_ = __t.__end_node()->__left_;\x0a"
"            __end_node()->__left_->__parent_ = static_cast<__parent_pointer>(__end_node());\x0a"
"            size() = __t.size();\x0a"
"            __t.__begin_node() = __t.__end_node();\x0a"
"            __t.__end_node()->__left_ = nullptr;\x0a"
"            __t.size() = 0;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __begin_node() = __end_node();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"void\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__move_assign(__tree\x26 __t, true_type)\x0a"
"    _NOEXCEPT_(is_nothrow_move_assignable<value_compare>\x3a\x3avalue \x26\x26\x0a"
"               is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue)\x0a"
"{\x0a"
"    destroy(static_cast<__node_pointer>(__end_node()->__left_));\x0a"
"    __begin_node_ = __t.__begin_node_;\x0a"
"    __pair1_.first() = __t.__pair1_.first();\x0a"
"    __move_assign_alloc(__t);\x0a"
"    __pair3_ = _VSTD\x3a\x3amove(__t.__pair3_);\x0a"
"    if (size() == 0)\x0a"
"        __begin_node() = __end_node();\x0a"
"    else\x0a"
"    {\x0a"
"        __end_node()->__left_->__parent_ = static_cast<__parent_pointer>(__end_node());\x0a"
"        __t.__begin_node() = __t.__end_node();\x0a"
"        __t.__end_node()->__left_ = nullptr;\x0a"
"        __t.size() = 0;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"void\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__move_assign(__tree\x26 __t, false_type)\x0a"
"{\x0a"
"    if (__node_alloc() == __t.__node_alloc())\x0a"
"        __move_assign(__t, true_type());\x0a"
"    else\x0a"
"    {\x0a"
"        value_comp() = _VSTD\x3a\x3amove(__t.value_comp());\x0a"
"        const_iterator __e = end();\x0a"
"        if (size() \x21= 0)\x0a"
"        {\x0a"
"            _DetachedTreeCache __cache(this);\x0a"
"            while (__cache.__get() \x21= nullptr \x26\x26 __t.size() \x21= 0) {\x0a"
"              __cache.__get()->__value_ = _VSTD\x3a\x3amove(__t.remove(__t.begin())->__value_);\x0a"
"              __node_insert_multi(__cache.__get());\x0a"
"              __cache.__advance();\x0a"
"            }\x0a"
"        }\x0a"
"        while (__t.size() \x21= 0)\x0a"
"            __insert_multi(__e, _NodeTypes\x3a\x3a__move(__t.remove(__t.begin())->__value_));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x26\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3aoperator=(__tree\x26\x26 __t)\x0a"
"    _NOEXCEPT_(\x0a"
"        __node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"        is_nothrow_move_assignable<value_compare>\x3a\x3avalue \x26\x26\x0a"
"        is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue)\x0a"
"\x0a"
"{\x0a"
"    __move_assign(__t, integral_constant<bool,\x0a"
"                  __node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a\x7e__tree()\x0a"
"{\x0a"
"    static_assert((is_copy_constructible<value_compare>\x3a\x3avalue),\x0a"
"                 \x22""Comparator must be copy-constructible.\x22);\x0a"
"  destroy(__root());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"void\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a""destroy(__node_pointer __nd) _NOEXCEPT\x0a"
"{\x0a"
"    if (__nd \x21= nullptr)\x0a"
"    {\x0a"
"        destroy(static_cast<__node_pointer>(__nd->__left_));\x0a"
"        destroy(static_cast<__node_pointer>(__nd->__right_));\x0a"
"        __node_allocator\x26 __na = __node_alloc();\x0a"
"        __node_traits\x3a\x3a""destroy(__na, _NodeTypes\x3a\x3a__get_ptr(__nd->__value_));\x0a"
"        __node_traits\x3a\x3a""deallocate(__na, __nd, 1);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"void\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3aswap(__tree\x26 __t)\x0a"
"#if _LIBCPP_STD_VER <= 11\x0a"
"        _NOEXCEPT_(\x0a"
"            __is_nothrow_swappable<value_compare>\x3a\x3avalue\x0a"
"            \x26\x26 (\x21__node_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                 __is_nothrow_swappable<__node_allocator>\x3a\x3avalue)\x0a"
"            )\x0a"
"#else\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<value_compare>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"    using _VSTD\x3a\x3aswap;\x0a"
"    swap(__begin_node_, __t.__begin_node_);\x0a"
"    swap(__pair1_.first(), __t.__pair1_.first());\x0a"
"    __swap_allocator(__node_alloc(), __t.__node_alloc());\x0a"
"    __pair3_.swap(__t.__pair3_);\x0a"
"    if (size() == 0)\x0a"
"        __begin_node() = __end_node();\x0a"
"    else\x0a"
"        __end_node()->__left_->__parent_ = static_cast<__parent_pointer>(__end_node());\x0a"
"    if (__t.size() == 0)\x0a"
"        __t.__begin_node() = __t.__end_node();\x0a"
"    else\x0a"
"        __t.__end_node()->__left_->__parent_ = static_cast<__parent_pointer>(__t.__end_node());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"void\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a""clear() _NOEXCEPT\x0a"
"{\x0a"
"    destroy(__root());\x0a"
"    size() = 0;\x0a"
"    __begin_node() = __end_node();\x0a"
"    __end_node()->__left_ = nullptr;\x0a"
"}\x0a"
"\x0a"
"// Find lower_bound place to insert\x0a"
"// Set __parent to parent of null leaf\x0a"
"// Return reference to null leaf\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_base_pointer\x26\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__find_leaf_low(__parent_pointer\x26 __parent,\x0a"
"                                                   const key_type\x26 __v)\x0a"
"{\x0a"
"    __node_pointer __nd = __root();\x0a"
"    if (__nd \x21= nullptr)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (value_comp()(__nd->__value_, __v))\x0a"
"            {\x0a"
"                if (__nd->__right_ \x21= nullptr)\x0a"
"                    __nd = static_cast<__node_pointer>(__nd->__right_);\x0a"
"                else\x0a"
"                {\x0a"
"                    __parent = static_cast<__parent_pointer>(__nd);\x0a"
"                    return __nd->__right_;\x0a"
"                }\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                if (__nd->__left_ \x21= nullptr)\x0a"
"                    __nd = static_cast<__node_pointer>(__nd->__left_);\x0a"
"                else\x0a"
"                {\x0a"
"                    __parent = static_cast<__parent_pointer>(__nd);\x0a"
"                    return __parent->__left_;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    __parent = static_cast<__parent_pointer>(__end_node());\x0a"
"    return __parent->__left_;\x0a"
"}\x0a"
"\x0a"
"// Find upper_bound place to insert\x0a"
"// Set __parent to parent of null leaf\x0a"
"// Return reference to null leaf\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_base_pointer\x26\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__find_leaf_high(__parent_pointer\x26 __parent,\x0a"
"                                                    const key_type\x26 __v)\x0a"
"{\x0a"
"    __node_pointer __nd = __root();\x0a"
"    if (__nd \x21= nullptr)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (value_comp()(__v, __nd->__value_))\x0a"
"            {\x0a"
"                if (__nd->__left_ \x21= nullptr)\x0a"
"                    __nd = static_cast<__node_pointer>(__nd->__left_);\x0a"
"                else\x0a"
"                {\x0a"
"                    __parent = static_cast<__parent_pointer>(__nd);\x0a"
"                    return __parent->__left_;\x0a"
"                }\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                if (__nd->__right_ \x21= nullptr)\x0a"
"                    __nd = static_cast<__node_pointer>(__nd->__right_);\x0a"
"                else\x0a"
"                {\x0a"
"                    __parent = static_cast<__parent_pointer>(__nd);\x0a"
"                    return __nd->__right_;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    __parent = static_cast<__parent_pointer>(__end_node());\x0a"
"    return __parent->__left_;\x0a"
"}\x0a"
"\x0a"
"// Find leaf place to insert closest to __hint\x0a"
"// First check prior to __hint.\x0a"
"// Next check after __hint.\x0a"
"// Next do O(log N) search.\x0a"
"// Set __parent to parent of null leaf\x0a"
"// Return reference to null leaf\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_base_pointer\x26\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__find_leaf(const_iterator __hint,\x0a"
"                                               __parent_pointer\x26 __parent,\x0a"
"                                               const key_type\x26 __v)\x0a"
"{\x0a"
"    if (__hint == end() \x7c\x7c \x21value_comp()(*__hint, __v))  // check before\x0a"
"    {\x0a"
"        // __v <= *__hint\x0a"
"        const_iterator __prior = __hint;\x0a"
"        if (__prior == begin() \x7c\x7c \x21value_comp()(__v, *--__prior))\x0a"
"        {\x0a"
"            // *prev(__hint) <= __v <= *__hint\x0a"
"            if (__hint.__ptr_->__left_ == nullptr)\x0a"
"            {\x0a"
"                __parent = static_cast<__parent_pointer>(__hint.__ptr_);\x0a"
"                return __parent->__left_;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                __parent = static_cast<__parent_pointer>(__prior.__ptr_);\x0a"
"                return static_cast<__node_base_pointer>(__prior.__ptr_)->__right_;\x0a"
"            }\x0a"
"        }\x0a"
"        // __v < *prev(__hint)\x0a"
"        return __find_leaf_high(__parent, __v);\x0a"
"    }\x0a"
"    // else __v > *__hint\x0a"
"    return __find_leaf_low(__parent, __v);\x0a"
"}\x0a"
"\x0a"
"// Find place to insert if __v doesn't exist\x0a"
"// Set __parent to parent of null leaf\x0a"
"// Return reference to null leaf\x0a"
"// If __v exists, set parent to node of __v and return reference to node of __v\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_base_pointer\x26\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__find_equal(__parent_pointer\x26 __parent,\x0a"
"                                                const _Key\x26 __v)\x0a"
"{\x0a"
"    __node_pointer __nd = __root();\x0a"
"    __node_base_pointer* __nd_ptr = __root_ptr();\x0a"
"    if (__nd \x21= nullptr)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (value_comp()(__v, __nd->__value_))\x0a"
"            {\x0a"
"                if (__nd->__left_ \x21= nullptr) {\x0a"
"                    __nd_ptr = _VSTD\x3a\x3a""addressof(__nd->__left_);\x0a"
"                    __nd = static_cast<__node_pointer>(__nd->__left_);\x0a"
"                } else {\x0a"
"                    __parent = static_cast<__parent_pointer>(__nd);\x0a"
"                    return __parent->__left_;\x0a"
"                }\x0a"
"            }\x0a"
"            else if (value_comp()(__nd->__value_, __v))\x0a"
"            {\x0a"
"                if (__nd->__right_ \x21= nullptr) {\x0a"
"                    __nd_ptr = _VSTD\x3a\x3a""addressof(__nd->__right_);\x0a"
"                    __nd = static_cast<__node_pointer>(__nd->__right_);\x0a"
"                } else {\x0a"
"                    __parent = static_cast<__parent_pointer>(__nd);\x0a"
"                    return __nd->__right_;\x0a"
"                }\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                __parent = static_cast<__parent_pointer>(__nd);\x0a"
"                return *__nd_ptr;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    __parent = static_cast<__parent_pointer>(__end_node());\x0a"
"    return __parent->__left_;\x0a"
"}\x0a"
"\x0a"
"// Find place to insert if __v doesn't exist\x0a"
"// First check prior to __hint.\x0a"
"// Next check after __hint.\x0a"
"// Next do O(log N) search.\x0a"
"// Set __parent to parent of null leaf\x0a"
"// Return reference to null leaf\x0a"
"// If __v exists, set parent to node of __v and return reference to node of __v\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_base_pointer\x26\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__find_equal(const_iterator __hint,\x0a"
"                                                __parent_pointer\x26 __parent,\x0a"
"                                                __node_base_pointer\x26 __dummy,\x0a"
"                                                const _Key\x26 __v)\x0a"
"{\x0a"
"    if (__hint == end() \x7c\x7c value_comp()(__v, *__hint))  // check before\x0a"
"    {\x0a"
"        // __v < *__hint\x0a"
"        const_iterator __prior = __hint;\x0a"
"        if (__prior == begin() \x7c\x7c value_comp()(*--__prior, __v))\x0a"
"        {\x0a"
"            // *prev(__hint) < __v < *__hint\x0a"
"            if (__hint.__ptr_->__left_ == nullptr)\x0a"
"            {\x0a"
"                __parent = static_cast<__parent_pointer>(__hint.__ptr_);\x0a"
"                return __parent->__left_;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                __parent = static_cast<__parent_pointer>(__prior.__ptr_);\x0a"
"                return static_cast<__node_base_pointer>(__prior.__ptr_)->__right_;\x0a"
"            }\x0a"
"        }\x0a"
"        // __v <= *prev(__hint)\x0a"
"        return __find_equal(__parent, __v);\x0a"
"    }\x0a"
"    else if (value_comp()(*__hint, __v))  // check after\x0a"
"    {\x0a"
"        // *__hint < __v\x0a"
"        const_iterator __next = _VSTD\x3a\x3anext(__hint);\x0a"
"        if (__next == end() \x7c\x7c value_comp()(__v, *__next))\x0a"
"        {\x0a"
"            // *__hint < __v < *_VSTD\x3a\x3anext(__hint)\x0a"
"            if (__hint.__get_np()->__right_ == nullptr)\x0a"
"            {\x0a"
"                __parent = static_cast<__parent_pointer>(__hint.__ptr_);\x0a"
"                return static_cast<__node_base_pointer>(__hint.__ptr_)->__right_;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                __parent = static_cast<__parent_pointer>(__next.__ptr_);\x0a"
"                return __parent->__left_;\x0a"
"            }\x0a"
"        }\x0a"
"        // *next(__hint) <= __v\x0a"
"        return __find_equal(__parent, __v);\x0a"
"    }\x0a"
"    // else __v == *__hint\x0a"
"    __parent = static_cast<__parent_pointer>(__hint.__ptr_);\x0a"
"    __dummy = static_cast<__node_base_pointer>(__hint.__ptr_);\x0a"
"    return __dummy;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"void __tree<_Tp, _Compare, _Allocator>\x3a\x3a__insert_node_at(\x0a"
"    __parent_pointer __parent, __node_base_pointer\x26 __child,\x0a"
"    __node_base_pointer __new_node) _NOEXCEPT\x0a"
"{\x0a"
"    __new_node->__left_   = nullptr;\x0a"
"    __new_node->__right_  = nullptr;\x0a"
"    __new_node->__parent_ = __parent;\x0a"
"    // __new_node->__is_black_ is initialized in __tree_balance_after_insert\x0a"
"    __child = __new_node;\x0a"
"    if (__begin_node()->__left_ \x21= nullptr)\x0a"
"        __begin_node() = static_cast<__iter_pointer>(__begin_node()->__left_);\x0a"
"    __tree_balance_after_insert(__end_node()->__left_, __child);\x0a"
"    ++size();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key, class... _Args>\x0a"
"pair<typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator, bool>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__emplace_unique_key_args(_Key const\x26 __k, _Args\x26\x26... __args)\x0a"
"#else\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key, class _Args>\x0a"
"pair<typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator, bool>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__emplace_unique_key_args(_Key const\x26 __k, _Args\x26 __args)\x0a"
"#endif\x0a"
"{\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_equal(__parent, __k);\x0a"
"    __node_pointer __r = static_cast<__node_pointer>(__child);\x0a"
"    bool __inserted = false;\x0a"
"    if (__child == nullptr)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"        __node_holder __h = __construct_node(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"#else\x0a"
"        __node_holder __h = __construct_node(__args);\x0a"
"#endif\x0a"
"        __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__h.get()));\x0a"
"        __r = __h.release();\x0a"
"        __inserted = true;\x0a"
"    }\x0a"
"    return pair<iterator, bool>(iterator(__r), __inserted);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key, class... _Args>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__emplace_hint_unique_key_args(\x0a"
"    const_iterator __p, _Key const\x26 __k, _Args\x26\x26... __args)\x0a"
"#else\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key, class _Args>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__emplace_hint_unique_key_args(\x0a"
"    const_iterator __p, _Key const\x26 __k, _Args\x26 __args)\x0a"
"#endif\x0a"
"{\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer __dummy;\x0a"
"    __node_base_pointer\x26 __child = __find_equal(__p, __parent, __dummy, __k);\x0a"
"    __node_pointer __r = static_cast<__node_pointer>(__child);\x0a"
"    if (__child == nullptr)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"        __node_holder __h = __construct_node(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"#else\x0a"
"        __node_holder __h = __construct_node(__args);\x0a"
"#endif\x0a"
"        __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__h.get()));\x0a"
"        __r = __h.release();\x0a"
"    }\x0a"
"    return iterator(__r);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class ..._Args>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_holder\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__construct_node(_Args\x26\x26 ...__args)\x0a"
"{\x0a"
"    static_assert(\x21__is_tree_value_type<_Args...>\x3a\x3avalue,\x0a"
"                  \x22""Cannot construct from __value_type\x22);\x0a"
"    __node_allocator\x26 __na = __node_alloc();\x0a"
"    __node_holder __h(__node_traits\x3a\x3a""allocate(__na, 1), _Dp(__na));\x0a"
"    __node_traits\x3a\x3a""construct(__na, _NodeTypes\x3a\x3a__get_ptr(__h->__value_), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __h.get_deleter().__value_constructed = true;\x0a"
"    return __h;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class... _Args>\x0a"
"pair<typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator, bool>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__emplace_unique_impl(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    __node_holder __h = __construct_node(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_equal(__parent, __h->__value_);\x0a"
"    __node_pointer __r = static_cast<__node_pointer>(__child);\x0a"
"    bool __inserted = false;\x0a"
"    if (__child == nullptr)\x0a"
"    {\x0a"
"        __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__h.get()));\x0a"
"        __r = __h.release();\x0a"
"        __inserted = true;\x0a"
"    }\x0a"
"    return pair<iterator, bool>(iterator(__r), __inserted);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class... _Args>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__emplace_hint_unique_impl(const_iterator __p, _Args\x26\x26... __args)\x0a"
"{\x0a"
"    __node_holder __h = __construct_node(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer __dummy;\x0a"
"    __node_base_pointer\x26 __child = __find_equal(__p, __parent, __dummy, __h->__value_);\x0a"
"    __node_pointer __r = static_cast<__node_pointer>(__child);\x0a"
"    if (__child == nullptr)\x0a"
"    {\x0a"
"        __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__h.get()));\x0a"
"        __r = __h.release();\x0a"
"    }\x0a"
"    return iterator(__r);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class... _Args>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__emplace_multi(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    __node_holder __h = __construct_node(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_leaf_high(__parent, _NodeTypes\x3a\x3a__get_key(__h->__value_));\x0a"
"    __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__h.get()));\x0a"
"    return iterator(static_cast<__node_pointer>(__h.release()));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class... _Args>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__emplace_hint_multi(const_iterator __p,\x0a"
"                                                        _Args\x26\x26... __args)\x0a"
"{\x0a"
"    __node_holder __h = __construct_node(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_leaf(__p, __parent, _NodeTypes\x3a\x3a__get_key(__h->__value_));\x0a"
"    __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__h.get()));\x0a"
"    return iterator(static_cast<__node_pointer>(__h.release()));\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_holder\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__construct_node(const __container_value_type\x26 __v)\x0a"
"{\x0a"
"    __node_allocator\x26 __na = __node_alloc();\x0a"
"    __node_holder __h(__node_traits\x3a\x3a""allocate(__na, 1), _Dp(__na));\x0a"
"    __node_traits\x3a\x3a""construct(__na, _NodeTypes\x3a\x3a__get_ptr(__h->__value_), __v);\x0a"
"    __h.get_deleter().__value_constructed = true;\x0a"
"    return _LIBCPP_EXPLICIT_MOVE(__h);  // explicitly moved for C++03\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__insert_multi(const __container_value_type\x26 __v)\x0a"
"{\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_leaf_high(__parent, _NodeTypes\x3a\x3a__get_key(__v));\x0a"
"    __node_holder __h = __construct_node(__v);\x0a"
"    __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__h.get()));\x0a"
"    return iterator(__h.release());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__insert_multi(const_iterator __p, const __container_value_type\x26 __v)\x0a"
"{\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_leaf(__p, __parent, _NodeTypes\x3a\x3a__get_key(__v));\x0a"
"    __node_holder __h = __construct_node(__v);\x0a"
"    __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__h.get()));\x0a"
"    return iterator(__h.release());\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"pair<typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator, bool>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_assign_unique(const __container_value_type\x26 __v, __node_pointer __nd)\x0a"
"{\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_equal(__parent, _NodeTypes\x3a\x3a__get_key(__v));\x0a"
"    __node_pointer __r = static_cast<__node_pointer>(__child);\x0a"
"    bool __inserted = false;\x0a"
"    if (__child == nullptr)\x0a"
"    {\x0a"
"        __nd->__value_ = __v;\x0a"
"        __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__nd));\x0a"
"        __r = __nd;\x0a"
"        __inserted = true;\x0a"
"    }\x0a"
"    return pair<iterator, bool>(iterator(__r), __inserted);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_insert_multi(__node_pointer __nd)\x0a"
"{\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_leaf_high(__parent, _NodeTypes\x3a\x3a__get_key(__nd->__value_));\x0a"
"    __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__nd));\x0a"
"    return iterator(__nd);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_insert_multi(const_iterator __p,\x0a"
"                                                       __node_pointer __nd)\x0a"
"{\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_leaf(__p, __parent, _NodeTypes\x3a\x3a__get_key(__nd->__value_));\x0a"
"    __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__nd));\x0a"
"    return iterator(__nd);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__remove_node_pointer(__node_pointer __ptr) _NOEXCEPT\x0a"
"{\x0a"
"    iterator __r(__ptr);\x0a"
"    ++__r;\x0a"
"    if (__begin_node() == __ptr)\x0a"
"        __begin_node() = __r.__ptr_;\x0a"
"    --size();\x0a"
"    __tree_remove(__end_node()->__left_,\x0a"
"                  static_cast<__node_base_pointer>(__ptr));\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _NodeHandle, class _InsertReturnType>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_InsertReturnType\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_handle_insert_unique(\x0a"
"    _NodeHandle\x26\x26 __nh)\x0a"
"{\x0a"
"    if (__nh.empty())\x0a"
"        return _InsertReturnType{end(), false, _NodeHandle()};\x0a"
"\x0a"
"    __node_pointer __ptr = __nh.__ptr_;\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_equal(__parent,\x0a"
"                                                __ptr->__value_);\x0a"
"    if (__child \x21= nullptr)\x0a"
"        return _InsertReturnType{\x0a"
"            iterator(static_cast<__node_pointer>(__child)),\x0a"
"            false, _VSTD\x3a\x3amove(__nh)};\x0a"
"\x0a"
"    __insert_node_at(__parent, __child,\x0a"
"                     static_cast<__node_base_pointer>(__ptr));\x0a"
"    __nh.__release_ptr();\x0a"
"    return _InsertReturnType{iterator(__ptr), true, _NodeHandle()};\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _NodeHandle>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_handle_insert_unique(\x0a"
"    const_iterator __hint, _NodeHandle\x26\x26 __nh)\x0a"
"{\x0a"
"    if (__nh.empty())\x0a"
"        return end();\x0a"
"\x0a"
"    __node_pointer __ptr = __nh.__ptr_;\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer __dummy;\x0a"
"    __node_base_pointer\x26 __child = __find_equal(__hint, __parent, __dummy,\x0a"
"                                                __ptr->__value_);\x0a"
"    __node_pointer __r = static_cast<__node_pointer>(__child);\x0a"
"    if (__child == nullptr)\x0a"
"    {\x0a"
"        __insert_node_at(__parent, __child,\x0a"
"                         static_cast<__node_base_pointer>(__ptr));\x0a"
"        __r = __ptr;\x0a"
"        __nh.__release_ptr();\x0a"
"    }\x0a"
"    return iterator(__r);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _NodeHandle>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_NodeHandle\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_handle_extract(key_type const\x26 __key)\x0a"
"{\x0a"
"    iterator __it = find(__key);\x0a"
"    if (__it == end())\x0a"
"        return _NodeHandle();\x0a"
"    return __node_handle_extract<_NodeHandle>(__it);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _NodeHandle>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_NodeHandle\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_handle_extract(const_iterator __p)\x0a"
"{\x0a"
"    __node_pointer __np = __p.__get_np();\x0a"
"    __remove_node_pointer(__np);\x0a"
"    return _NodeHandle(__np, __alloc());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Tree>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_handle_merge_unique(_Tree\x26 __source)\x0a"
"{\x0a"
"    static_assert(is_same<typename _Tree\x3a\x3a__node_pointer, __node_pointer>\x3a\x3avalue, \x22\x22);\x0a"
"\x0a"
"    for (typename _Tree\x3a\x3aiterator __i = __source.begin();\x0a"
"         __i \x21= __source.end();)\x0a"
"    {\x0a"
"        __node_pointer __src_ptr = __i.__get_np();\x0a"
"        __parent_pointer __parent;\x0a"
"        __node_base_pointer\x26 __child =\x0a"
"            __find_equal(__parent, _NodeTypes\x3a\x3a__get_key(__src_ptr->__value_));\x0a"
"        ++__i;\x0a"
"        if (__child \x21= nullptr)\x0a"
"            continue;\x0a"
"        __source.__remove_node_pointer(__src_ptr);\x0a"
"        __insert_node_at(__parent, __child,\x0a"
"                         static_cast<__node_base_pointer>(__src_ptr));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _NodeHandle>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_handle_insert_multi(_NodeHandle\x26\x26 __nh)\x0a"
"{\x0a"
"    if (__nh.empty())\x0a"
"        return end();\x0a"
"    __node_pointer __ptr = __nh.__ptr_;\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_leaf_high(\x0a"
"        __parent, _NodeTypes\x3a\x3a__get_key(__ptr->__value_));\x0a"
"    __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__ptr));\x0a"
"    __nh.__release_ptr();\x0a"
"    return iterator(__ptr);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _NodeHandle>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_handle_insert_multi(\x0a"
"    const_iterator __hint, _NodeHandle\x26\x26 __nh)\x0a"
"{\x0a"
"    if (__nh.empty())\x0a"
"        return end();\x0a"
"\x0a"
"    __node_pointer __ptr = __nh.__ptr_;\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __find_leaf(__hint, __parent,\x0a"
"                                               _NodeTypes\x3a\x3a__get_key(__ptr->__value_));\x0a"
"    __insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__ptr));\x0a"
"    __nh.__release_ptr();\x0a"
"    return iterator(__ptr);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Tree>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_handle_merge_multi(_Tree\x26 __source)\x0a"
"{\x0a"
"    static_assert(is_same<typename _Tree\x3a\x3a__node_pointer, __node_pointer>\x3a\x3avalue, \x22\x22);\x0a"
"\x0a"
"    for (typename _Tree\x3a\x3aiterator __i = __source.begin();\x0a"
"         __i \x21= __source.end();)\x0a"
"    {\x0a"
"        __node_pointer __src_ptr = __i.__get_np();\x0a"
"        __parent_pointer __parent;\x0a"
"        __node_base_pointer\x26 __child = __find_leaf_high(\x0a"
"            __parent, _NodeTypes\x3a\x3a__get_key(__src_ptr->__value_));\x0a"
"        ++__i;\x0a"
"        __source.__remove_node_pointer(__src_ptr);\x0a"
"        __insert_node_at(__parent, __child,\x0a"
"                         static_cast<__node_base_pointer>(__src_ptr));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a""erase(const_iterator __p)\x0a"
"{\x0a"
"    __node_pointer __np = __p.__get_np();\x0a"
"    iterator __r = __remove_node_pointer(__np);\x0a"
"    __node_allocator\x26 __na = __node_alloc();\x0a"
"    __node_traits\x3a\x3a""destroy(__na, _NodeTypes\x3a\x3a__get_ptr(\x0a"
"        const_cast<__node_value_type\x26>(*__p)));\x0a"
"    __node_traits\x3a\x3a""deallocate(__na, __np, 1);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a""erase(const_iterator __f, const_iterator __l)\x0a"
"{\x0a"
"    while (__f \x21= __l)\x0a"
"        __f = erase(__f);\x0a"
"    return iterator(__l.__ptr_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3asize_type\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__erase_unique(const _Key\x26 __k)\x0a"
"{\x0a"
"    iterator __i = find(__k);\x0a"
"    if (__i == end())\x0a"
"        return 0;\x0a"
"    erase(__i);\x0a"
"    return 1;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3asize_type\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__erase_multi(const _Key\x26 __k)\x0a"
"{\x0a"
"    pair<iterator, iterator> __p = __equal_range_multi(__k);\x0a"
"    size_type __r = 0;\x0a"
"    for (; __p.first \x21= __p.second; ++__r)\x0a"
"        __p.first = erase(__p.first);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a""find(const _Key\x26 __v)\x0a"
"{\x0a"
"    iterator __p = __lower_bound(__v, __root(), __end_node());\x0a"
"    if (__p \x21= end() \x26\x26 \x21value_comp()(__v, *__p))\x0a"
"        return __p;\x0a"
"    return end();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a""const_iterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a""find(const _Key\x26 __v) const\x0a"
"{\x0a"
"    const_iterator __p = __lower_bound(__v, __root(), __end_node());\x0a"
"    if (__p \x21= end() \x26\x26 \x21value_comp()(__v, *__p))\x0a"
"        return __p;\x0a"
"    return end();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3asize_type\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__count_unique(const _Key\x26 __k) const\x0a"
"{\x0a"
"    __node_pointer __rt = __root();\x0a"
"    while (__rt \x21= nullptr)\x0a"
"    {\x0a"
"        if (value_comp()(__k, __rt->__value_))\x0a"
"        {\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__left_);\x0a"
"        }\x0a"
"        else if (value_comp()(__rt->__value_, __k))\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__right_);\x0a"
"        else\x0a"
"            return 1;\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3asize_type\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__count_multi(const _Key\x26 __k) const\x0a"
"{\x0a"
"    __iter_pointer __result = __end_node();\x0a"
"    __node_pointer __rt = __root();\x0a"
"    while (__rt \x21= nullptr)\x0a"
"    {\x0a"
"        if (value_comp()(__k, __rt->__value_))\x0a"
"        {\x0a"
"            __result = static_cast<__iter_pointer>(__rt);\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__left_);\x0a"
"        }\x0a"
"        else if (value_comp()(__rt->__value_, __k))\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__right_);\x0a"
"        else\x0a"
"            return _VSTD\x3a\x3a""distance(\x0a"
"                __lower_bound(__k, static_cast<__node_pointer>(__rt->__left_), static_cast<__iter_pointer>(__rt)),\x0a"
"                __upper_bound(__k, static_cast<__node_pointer>(__rt->__right_), __result)\x0a"
"            );\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__lower_bound(const _Key\x26 __v,\x0a"
"                                                 __node_pointer __root,\x0a"
"                                                 __iter_pointer __result)\x0a"
"{\x0a"
"    while (__root \x21= nullptr)\x0a"
"    {\x0a"
"        if (\x21value_comp()(__root->__value_, __v))\x0a"
"        {\x0a"
"            __result = static_cast<__iter_pointer>(__root);\x0a"
"            __root = static_cast<__node_pointer>(__root->__left_);\x0a"
"        }\x0a"
"        else\x0a"
"            __root = static_cast<__node_pointer>(__root->__right_);\x0a"
"    }\x0a"
"    return iterator(__result);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a""const_iterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__lower_bound(const _Key\x26 __v,\x0a"
"                                                 __node_pointer __root,\x0a"
"                                                 __iter_pointer __result) const\x0a"
"{\x0a"
"    while (__root \x21= nullptr)\x0a"
"    {\x0a"
"        if (\x21value_comp()(__root->__value_, __v))\x0a"
"        {\x0a"
"            __result = static_cast<__iter_pointer>(__root);\x0a"
"            __root = static_cast<__node_pointer>(__root->__left_);\x0a"
"        }\x0a"
"        else\x0a"
"            __root = static_cast<__node_pointer>(__root->__right_);\x0a"
"    }\x0a"
"    return const_iterator(__result);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__upper_bound(const _Key\x26 __v,\x0a"
"                                                 __node_pointer __root,\x0a"
"                                                 __iter_pointer __result)\x0a"
"{\x0a"
"    while (__root \x21= nullptr)\x0a"
"    {\x0a"
"        if (value_comp()(__v, __root->__value_))\x0a"
"        {\x0a"
"            __result = static_cast<__iter_pointer>(__root);\x0a"
"            __root = static_cast<__node_pointer>(__root->__left_);\x0a"
"        }\x0a"
"        else\x0a"
"            __root = static_cast<__node_pointer>(__root->__right_);\x0a"
"    }\x0a"
"    return iterator(__result);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a""const_iterator\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__upper_bound(const _Key\x26 __v,\x0a"
"                                                 __node_pointer __root,\x0a"
"                                                 __iter_pointer __result) const\x0a"
"{\x0a"
"    while (__root \x21= nullptr)\x0a"
"    {\x0a"
"        if (value_comp()(__v, __root->__value_))\x0a"
"        {\x0a"
"            __result = static_cast<__iter_pointer>(__root);\x0a"
"            __root = static_cast<__node_pointer>(__root->__left_);\x0a"
"        }\x0a"
"        else\x0a"
"            __root = static_cast<__node_pointer>(__root->__right_);\x0a"
"    }\x0a"
"    return const_iterator(__result);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"pair<typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator,\x0a"
"     typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__equal_range_unique(const _Key\x26 __k)\x0a"
"{\x0a"
"    typedef pair<iterator, iterator> _Pp;\x0a"
"    __iter_pointer __result = __end_node();\x0a"
"    __node_pointer __rt = __root();\x0a"
"    while (__rt \x21= nullptr)\x0a"
"    {\x0a"
"        if (value_comp()(__k, __rt->__value_))\x0a"
"        {\x0a"
"            __result = static_cast<__iter_pointer>(__rt);\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__left_);\x0a"
"        }\x0a"
"        else if (value_comp()(__rt->__value_, __k))\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__right_);\x0a"
"        else\x0a"
"            return _Pp(iterator(__rt),\x0a"
"                      iterator(\x0a"
"                          __rt->__right_ \x21= nullptr \x3f\x0a"
"                              static_cast<__iter_pointer>(__tree_min(__rt->__right_))\x0a"
"                            \x3a __result));\x0a"
"    }\x0a"
"    return _Pp(iterator(__result), iterator(__result));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"pair<typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a""const_iterator,\x0a"
"     typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a""const_iterator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__equal_range_unique(const _Key\x26 __k) const\x0a"
"{\x0a"
"    typedef pair<const_iterator, const_iterator> _Pp;\x0a"
"    __iter_pointer __result = __end_node();\x0a"
"    __node_pointer __rt = __root();\x0a"
"    while (__rt \x21= nullptr)\x0a"
"    {\x0a"
"        if (value_comp()(__k, __rt->__value_))\x0a"
"        {\x0a"
"            __result = static_cast<__iter_pointer>(__rt);\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__left_);\x0a"
"        }\x0a"
"        else if (value_comp()(__rt->__value_, __k))\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__right_);\x0a"
"        else\x0a"
"            return _Pp(const_iterator(__rt),\x0a"
"                      const_iterator(\x0a"
"                          __rt->__right_ \x21= nullptr \x3f\x0a"
"                              static_cast<__iter_pointer>(__tree_min(__rt->__right_))\x0a"
"                            \x3a __result));\x0a"
"    }\x0a"
"    return _Pp(const_iterator(__result), const_iterator(__result));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"pair<typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator,\x0a"
"     typename __tree<_Tp, _Compare, _Allocator>\x3a\x3aiterator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__equal_range_multi(const _Key\x26 __k)\x0a"
"{\x0a"
"    typedef pair<iterator, iterator> _Pp;\x0a"
"    __iter_pointer __result = __end_node();\x0a"
"    __node_pointer __rt = __root();\x0a"
"    while (__rt \x21= nullptr)\x0a"
"    {\x0a"
"        if (value_comp()(__k, __rt->__value_))\x0a"
"        {\x0a"
"            __result = static_cast<__iter_pointer>(__rt);\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__left_);\x0a"
"        }\x0a"
"        else if (value_comp()(__rt->__value_, __k))\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__right_);\x0a"
"        else\x0a"
"            return _Pp(__lower_bound(__k, static_cast<__node_pointer>(__rt->__left_), static_cast<__iter_pointer>(__rt)),\x0a"
"                      __upper_bound(__k, static_cast<__node_pointer>(__rt->__right_), __result));\x0a"
"    }\x0a"
"    return _Pp(iterator(__result), iterator(__result));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"template <class _Key>\x0a"
"pair<typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a""const_iterator,\x0a"
"     typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a""const_iterator>\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3a__equal_range_multi(const _Key\x26 __k) const\x0a"
"{\x0a"
"    typedef pair<const_iterator, const_iterator> _Pp;\x0a"
"    __iter_pointer __result = __end_node();\x0a"
"    __node_pointer __rt = __root();\x0a"
"    while (__rt \x21= nullptr)\x0a"
"    {\x0a"
"        if (value_comp()(__k, __rt->__value_))\x0a"
"        {\x0a"
"            __result = static_cast<__iter_pointer>(__rt);\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__left_);\x0a"
"        }\x0a"
"        else if (value_comp()(__rt->__value_, __k))\x0a"
"            __rt = static_cast<__node_pointer>(__rt->__right_);\x0a"
"        else\x0a"
"            return _Pp(__lower_bound(__k, static_cast<__node_pointer>(__rt->__left_), static_cast<__iter_pointer>(__rt)),\x0a"
"                      __upper_bound(__k, static_cast<__node_pointer>(__rt->__right_), __result));\x0a"
"    }\x0a"
"    return _Pp(const_iterator(__result), const_iterator(__result));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"typename __tree<_Tp, _Compare, _Allocator>\x3a\x3a__node_holder\x0a"
"__tree<_Tp, _Compare, _Allocator>\x3a\x3aremove(const_iterator __p) _NOEXCEPT\x0a"
"{\x0a"
"    __node_pointer __np = __p.__get_np();\x0a"
"    if (__begin_node() == __p.__ptr_)\x0a"
"    {\x0a"
"        if (__np->__right_ \x21= nullptr)\x0a"
"            __begin_node() = static_cast<__iter_pointer>(__np->__right_);\x0a"
"        else\x0a"
"            __begin_node() = static_cast<__iter_pointer>(__np->__parent_);\x0a"
"    }\x0a"
"    --size();\x0a"
"    __tree_remove(__end_node()->__left_,\x0a"
"                  static_cast<__node_base_pointer>(__np));\x0a"
"    return __node_holder(__np, _Dp(__node_alloc(), true));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(__tree<_Tp, _Compare, _Allocator>\x26 __x,\x0a"
"     __tree<_Tp, _Compare, _Allocator>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP___TREE\x0a"
"", 104704 ); }