#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_any( 
"// -*- C++ -*-\x0a"
"//===------------------------------ any -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_ANY\x0a"
"#define _LIBCPP_ANY\x0a"
"\x0a"
"/*\x0a"
"   any synopsis\x0a"
"\x0a"
"namespace std {\x0a"
"\x0a"
"  class bad_any_cast \x3a public bad_cast\x0a"
"  {\x0a"
"  public\x3a\x0a"
"    virtual const char* what() const noexcept;\x0a"
"  };\x0a"
"\x0a"
"  class any\x0a"
"  {\x0a"
"  public\x3a\x0a"
"\x0a"
"    // 6.3.1 any construct/destruct\x0a"
"    any() noexcept;\x0a"
"\x0a"
"    any(const any\x26 other);\x0a"
"    any(any\x26\x26 other) noexcept;\x0a"
"\x0a"
"    template <class ValueType>\x0a"
"      any(ValueType\x26\x26 value);\x0a"
"\x0a"
"    \x7e""any();\x0a"
"\x0a"
"    // 6.3.2 any assignments\x0a"
"    any\x26 operator=(const any\x26 rhs);\x0a"
"    any\x26 operator=(any\x26\x26 rhs) noexcept;\x0a"
"\x0a"
"    template <class ValueType>\x0a"
"      any\x26 operator=(ValueType\x26\x26 rhs);\x0a"
"\x0a"
"    // 6.3.3 any modifiers\x0a"
"    template <class ValueType, class... Args>\x0a"
"      decay_t<ValueType>\x26 emplace(Args\x26\x26... args);\x0a"
"    template <class ValueType, class U, class... Args>\x0a"
"      decay_t<ValueType>\x26 emplace(initializer_list<U>, Args\x26\x26...);\x0a"
"    void reset() noexcept;\x0a"
"    void swap(any\x26 rhs) noexcept;\x0a"
"\x0a"
"    // 6.3.4 any observers\x0a"
"    bool has_value() const noexcept;\x0a"
"    const type_info\x26 type() const noexcept;\x0a"
"  };\x0a"
"\x0a"
"   // 6.4 Non-member functions\x0a"
"  void swap(any\x26 x, any\x26 y) noexcept;\x0a"
"\x0a"
"  template <class T, class ...Args>\x0a"
"    any make_any(Args\x26\x26 ...args);\x0a"
"  template <class T, class U, class ...Args>\x0a"
"    any make_any(initializer_list<U>, Args\x26\x26 ...args);\x0a"
"\x0a"
"  template<class ValueType>\x0a"
"    ValueType any_cast(const any\x26 operand);\x0a"
"  template<class ValueType>\x0a"
"    ValueType any_cast(any\x26 operand);\x0a"
"  template<class ValueType>\x0a"
"    ValueType any_cast(any\x26\x26 operand);\x0a"
"\x0a"
"  template<class ValueType>\x0a"
"    const ValueType* any_cast(const any* operand) noexcept;\x0a"
"  template<class ValueType>\x0a"
"    ValueType* any_cast(any* operand) noexcept;\x0a"
"\x0a"
"} // namespace std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <experimental/__config>\x0a"
"#include <memory>\x0a"
"#include <new>\x0a"
"#include <typeinfo>\x0a"
"#include <type_traits>\x0a"
"#include <cstdlib>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"namespace std {\x0a"
"class _LIBCPP_EXCEPTION_ABI _LIBCPP_AVAILABILITY_BAD_ANY_CAST bad_any_cast \x3a public bad_cast\x0a"
"{\x0a"
"public\x3a\x0a"
"    virtual const char* what() const _NOEXCEPT;\x0a"
"};\x0a"
"} // namespace std\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_ANY_CAST\x0a"
"void __throw_bad_any_cast()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw bad_any_cast();\x0a"
"#else\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"// Forward declarations\x0a"
"class _LIBCPP_TEMPLATE_VIS any;\x0a"
"\x0a"
"template <class _ValueType>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"add_pointer_t<add_const_t<_ValueType>>\x0a"
"any_cast(any const *) _NOEXCEPT;\x0a"
"\x0a"
"template <class _ValueType>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"add_pointer_t<_ValueType> any_cast(any *) _NOEXCEPT;\x0a"
"\x0a"
"namespace __any_imp\x0a"
"{\x0a"
"  using _Buffer = aligned_storage_t<3*sizeof(void*), alignment_of<void*>\x3a\x3avalue>;\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  using _IsSmallObject = integral_constant<bool\x0a"
"        , sizeof(_Tp) <= sizeof(_Buffer)\x0a"
"          \x26\x26 alignment_of<_Buffer>\x3a\x3avalue\x0a"
"             \x25 alignment_of<_Tp>\x3a\x3avalue == 0\x0a"
"          \x26\x26 is_nothrow_move_constructible<_Tp>\x3a\x3avalue\x0a"
"        >;\x0a"
"\x0a"
"  enum class _Action {\x0a"
"    _Destroy,\x0a"
"    _Copy,\x0a"
"    _Move,\x0a"
"    _Get,\x0a"
"    _TypeInfo\x0a"
"  };\x0a"
"\x0a"
"  template <class _Tp> struct _SmallHandler;\x0a"
"  template <class _Tp> struct _LargeHandler;\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  struct  _LIBCPP_TEMPLATE_VIS __unique_typeinfo { static constexpr int __id = 0; };\x0a"
"  template <class _Tp> constexpr int __unique_typeinfo<_Tp>\x3a\x3a__id;\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr const void* __get_fallback_typeid() {\x0a"
"      return \x26__unique_typeinfo<decay_t<_Tp>>\x3a\x3a__id;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool __compare_typeid(type_info const* __id, const void* __fallback_id)\x0a"
"  {\x0a"
"#if \x21""defined(_LIBCPP_NO_RTTI)\x0a"
"      if (__id \x26\x26 *__id == typeid(_Tp))\x0a"
"          return true;\x0a"
"#endif\x0a"
"      if (\x21__id \x26\x26 __fallback_id == __any_imp\x3a\x3a__get_fallback_typeid<_Tp>())\x0a"
"          return true;\x0a"
"      return false;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  using _Handler = conditional_t<\x0a"
"    _IsSmallObject<_Tp>\x3a\x3avalue, _SmallHandler<_Tp>, _LargeHandler<_Tp>>;\x0a"
"\x0a"
"} // namespace __any_imp\x0a"
"\x0a"
"class _LIBCPP_TEMPLATE_VIS any\x0a"
"{\x0a"
"public\x3a\x0a"
"  // construct/destruct\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr any() _NOEXCEPT \x3a __h(nullptr) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  any(any const \x26 __other) \x3a __h(nullptr)\x0a"
"  {\x0a"
"    if (__other.__h) __other.__call(_Action\x3a\x3a_Copy, this);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  any(any \x26\x26 __other) _NOEXCEPT \x3a __h(nullptr)\x0a"
"  {\x0a"
"    if (__other.__h) __other.__call(_Action\x3a\x3a_Move, this);\x0a"
"  }\x0a"
"\x0a"
"  template <\x0a"
"      class _ValueType\x0a"
"    , class _Tp = decay_t<_ValueType>\x0a"
"    , class = enable_if_t<\x0a"
"        \x21is_same<_Tp, any>\x3a\x3avalue \x26\x26\x0a"
"        \x21__is_inplace_type<_ValueType>\x3a\x3avalue \x26\x26\x0a"
"        is_copy_constructible<_Tp>\x3a\x3avalue>\x0a"
"    >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  any(_ValueType \x26\x26 __value);\x0a"
"\x0a"
"  template <class _ValueType, class ..._Args,\x0a"
"    class _Tp = decay_t<_ValueType>,\x0a"
"    class = enable_if_t<\x0a"
"        is_constructible<_Tp, _Args...>\x3a\x3avalue \x26\x26\x0a"
"        is_copy_constructible<_Tp>\x3a\x3avalue\x0a"
"    >\x0a"
"  >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit any(in_place_type_t<_ValueType>, _Args\x26\x26... __args);\x0a"
"\x0a"
"  template <class _ValueType, class _Up, class ..._Args,\x0a"
"    class _Tp = decay_t<_ValueType>,\x0a"
"    class = enable_if_t<\x0a"
"        is_constructible<_Tp, initializer_list<_Up>\x26, _Args...>\x3a\x3avalue \x26\x26\x0a"
"        is_copy_constructible<_Tp>\x3a\x3avalue>\x0a"
"  >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit any(in_place_type_t<_ValueType>, initializer_list<_Up>, _Args\x26\x26... __args);\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  \x7e""any() { this->reset(); }\x0a"
"\x0a"
"  // assignments\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  any \x26 operator=(any const \x26 __rhs) {\x0a"
"    any(__rhs).swap(*this);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  any \x26 operator=(any \x26\x26 __rhs) _NOEXCEPT {\x0a"
"    any(_VSTD\x3a\x3amove(__rhs)).swap(*this);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <\x0a"
"      class _ValueType\x0a"
"    , class _Tp = decay_t<_ValueType>\x0a"
"    , class = enable_if_t<\x0a"
"          \x21is_same<_Tp, any>\x3a\x3avalue\x0a"
"          \x26\x26 is_copy_constructible<_Tp>\x3a\x3avalue>\x0a"
"    >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  any \x26 operator=(_ValueType \x26\x26 __rhs);\x0a"
"\x0a"
"  template <class _ValueType, class ..._Args,\x0a"
"    class _Tp = decay_t<_ValueType>,\x0a"
"    class = enable_if_t<\x0a"
"        is_constructible<_Tp, _Args...>\x3a\x3avalue \x26\x26\x0a"
"        is_copy_constructible<_Tp>\x3a\x3avalue>\x0a"
"    >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _Tp\x26 emplace(_Args\x26\x26... args);\x0a"
"\x0a"
"  template <class _ValueType, class _Up, class ..._Args,\x0a"
"    class _Tp = decay_t<_ValueType>,\x0a"
"    class = enable_if_t<\x0a"
"        is_constructible<_Tp, initializer_list<_Up>\x26, _Args...>\x3a\x3avalue \x26\x26\x0a"
"        is_copy_constructible<_Tp>\x3a\x3avalue>\x0a"
"  >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _Tp\x26 emplace(initializer_list<_Up>, _Args\x26\x26...);\x0a"
"\x0a"
"  // 6.3.3 any modifiers\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void reset() _NOEXCEPT { if (__h) this->__call(_Action\x3a\x3a_Destroy); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void swap(any \x26 __rhs) _NOEXCEPT;\x0a"
"\x0a"
"  // 6.3.4 any observers\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool has_value() const _NOEXCEPT { return __h \x21= nullptr; }\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_NO_RTTI)\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const type_info \x26 type() const _NOEXCEPT {\x0a"
"    if (__h) {\x0a"
"        return *static_cast<type_info const *>(this->__call(_Action\x3a\x3a_TypeInfo));\x0a"
"    } else {\x0a"
"        return typeid(void);\x0a"
"    }\x0a"
"  }\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef __any_imp\x3a\x3a_Action _Action;\x0a"
"    using _HandleFuncPtr =  void* (*)(_Action, any const *, any *, const type_info *,\x0a"
"      const void* __fallback_info);\x0a"
"\x0a"
"    union _Storage {\x0a"
"        constexpr _Storage() \x3a __ptr(nullptr) {}\x0a"
"        void *  __ptr;\x0a"
"        __any_imp\x3a\x3a_Buffer __buf;\x0a"
"    };\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void * __call(_Action __a, any * __other = nullptr,\x0a"
"                  type_info const * __info = nullptr,\x0a"
"                   const void* __fallback_info = nullptr) const\x0a"
"    {\x0a"
"        return __h(__a, this, __other, __info, __fallback_info);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void * __call(_Action __a, any * __other = nullptr,\x0a"
"                  type_info const * __info = nullptr,\x0a"
"                  const void* __fallback_info = nullptr)\x0a"
"    {\x0a"
"        return __h(__a, this, __other, __info, __fallback_info);\x0a"
"    }\x0a"
"\x0a"
"    template <class>\x0a"
"    friend struct __any_imp\x3a\x3a_SmallHandler;\x0a"
"    template <class>\x0a"
"    friend struct __any_imp\x3a\x3a_LargeHandler;\x0a"
"\x0a"
"    template <class _ValueType>\x0a"
"    friend add_pointer_t<add_const_t<_ValueType>>\x0a"
"    any_cast(any const *) _NOEXCEPT;\x0a"
"\x0a"
"    template <class _ValueType>\x0a"
"    friend add_pointer_t<_ValueType>\x0a"
"    any_cast(any *) _NOEXCEPT;\x0a"
"\x0a"
"    _HandleFuncPtr __h = nullptr;\x0a"
"    _Storage __s;\x0a"
"};\x0a"
"\x0a"
"namespace __any_imp\x0a"
"{\x0a"
"  template <class _Tp>\x0a"
"  struct _LIBCPP_TEMPLATE_VIS _SmallHandler\x0a"
"  {\x0a"
"     _LIBCPP_INLINE_VISIBILITY\x0a"
"     static void* __handle(_Action __act, any const * __this, any * __other,\x0a"
"                           type_info const * __info, const void* __fallback_info)\x0a"
"     {\x0a"
"        switch (__act)\x0a"
"        {\x0a"
"        case _Action\x3a\x3a_Destroy\x3a\x0a"
"          __destroy(const_cast<any \x26>(*__this));\x0a"
"          return nullptr;\x0a"
"        case _Action\x3a\x3a_Copy\x3a\x0a"
"            __copy(*__this, *__other);\x0a"
"            return nullptr;\x0a"
"        case _Action\x3a\x3a_Move\x3a\x0a"
"          __move(const_cast<any \x26>(*__this), *__other);\x0a"
"          return nullptr;\x0a"
"        case _Action\x3a\x3a_Get\x3a\x0a"
"            return __get(const_cast<any \x26>(*__this), __info, __fallback_info);\x0a"
"        case _Action\x3a\x3a_TypeInfo\x3a\x0a"
"          return __type_info();\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _Tp\x26 __create(any \x26 __dest, _Args\x26\x26... __args) {\x0a"
"        _Tp* __ret = \x3a\x3anew (static_cast<void*>(\x26__dest.__s.__buf)) _Tp(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        __dest.__h = \x26_SmallHandler\x3a\x3a__handle;\x0a"
"        return *__ret;\x0a"
"    }\x0a"
"\x0a"
"  private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void __destroy(any \x26 __this) {\x0a"
"        _Tp \x26 __value = *static_cast<_Tp *>(static_cast<void*>(\x26__this.__s.__buf));\x0a"
"        __value.\x7e_Tp();\x0a"
"        __this.__h = nullptr;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void __copy(any const \x26 __this, any \x26 __dest) {\x0a"
"        _SmallHandler\x3a\x3a__create(__dest, *static_cast<_Tp const *>(\x0a"
"            static_cast<void const *>(\x26__this.__s.__buf)));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void __move(any \x26 __this, any \x26 __dest) {\x0a"
"        _SmallHandler\x3a\x3a__create(__dest, _VSTD\x3a\x3amove(\x0a"
"            *static_cast<_Tp*>(static_cast<void*>(\x26__this.__s.__buf))));\x0a"
"        __destroy(__this);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void* __get(any \x26 __this,\x0a"
"                       type_info const * __info,\x0a"
"                       const void* __fallback_id)\x0a"
"    {\x0a"
"        if (__any_imp\x3a\x3a__compare_typeid<_Tp>(__info, __fallback_id))\x0a"
"            return static_cast<void*>(\x26__this.__s.__buf);\x0a"
"        return nullptr;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void* __type_info()\x0a"
"    {\x0a"
"#if \x21""defined(_LIBCPP_NO_RTTI)\x0a"
"        return const_cast<void*>(static_cast<void const *>(\x26typeid(_Tp)));\x0a"
"#else\x0a"
"        return nullptr;\x0a"
"#endif\x0a"
"    }\x0a"
"  };\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  struct _LIBCPP_TEMPLATE_VIS _LargeHandler\x0a"
"  {\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void* __handle(_Action __act, any const * __this,\x0a"
"                          any * __other, type_info const * __info,\x0a"
"                          void const* __fallback_info)\x0a"
"    {\x0a"
"        switch (__act)\x0a"
"        {\x0a"
"        case _Action\x3a\x3a_Destroy\x3a\x0a"
"          __destroy(const_cast<any \x26>(*__this));\x0a"
"          return nullptr;\x0a"
"        case _Action\x3a\x3a_Copy\x3a\x0a"
"          __copy(*__this, *__other);\x0a"
"          return nullptr;\x0a"
"        case _Action\x3a\x3a_Move\x3a\x0a"
"          __move(const_cast<any \x26>(*__this), *__other);\x0a"
"          return nullptr;\x0a"
"        case _Action\x3a\x3a_Get\x3a\x0a"
"            return __get(const_cast<any \x26>(*__this), __info, __fallback_info);\x0a"
"        case _Action\x3a\x3a_TypeInfo\x3a\x0a"
"          return __type_info();\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _Tp\x26 __create(any \x26 __dest, _Args\x26\x26... __args) {\x0a"
"        typedef allocator<_Tp> _Alloc;\x0a"
"        typedef __allocator_destructor<_Alloc> _Dp;\x0a"
"        _Alloc __a;\x0a"
"        unique_ptr<_Tp, _Dp> __hold(__a.allocate(1), _Dp(__a, 1));\x0a"
"        _Tp* __ret = \x3a\x3anew ((void*)__hold.get()) _Tp(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        __dest.__s.__ptr = __hold.release();\x0a"
"        __dest.__h = \x26_LargeHandler\x3a\x3a__handle;\x0a"
"        return *__ret;\x0a"
"    }\x0a"
"\x0a"
"  private\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void __destroy(any \x26 __this){\x0a"
"        delete static_cast<_Tp*>(__this.__s.__ptr);\x0a"
"        __this.__h = nullptr;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void __copy(any const \x26 __this, any \x26 __dest) {\x0a"
"        _LargeHandler\x3a\x3a__create(__dest, *static_cast<_Tp const *>(__this.__s.__ptr));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void __move(any \x26 __this, any \x26 __dest) {\x0a"
"      __dest.__s.__ptr = __this.__s.__ptr;\x0a"
"      __dest.__h = \x26_LargeHandler\x3a\x3a__handle;\x0a"
"      __this.__h = nullptr;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void* __get(any \x26 __this, type_info const * __info,\x0a"
"                       void const* __fallback_info)\x0a"
"    {\x0a"
"        if (__any_imp\x3a\x3a__compare_typeid<_Tp>(__info, __fallback_info))\x0a"
"            return static_cast<void*>(__this.__s.__ptr);\x0a"
"        return nullptr;\x0a"
"\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void* __type_info()\x0a"
"    {\x0a"
"#if \x21""defined(_LIBCPP_NO_RTTI)\x0a"
"        return const_cast<void*>(static_cast<void const *>(\x26typeid(_Tp)));\x0a"
"#else\x0a"
"        return nullptr;\x0a"
"#endif\x0a"
"    }\x0a"
"  };\x0a"
"\x0a"
"} // namespace __any_imp\x0a"
"\x0a"
"\x0a"
"template <class _ValueType, class _Tp, class>\x0a"
"any\x3a\x3a""any(_ValueType \x26\x26 __v) \x3a __h(nullptr)\x0a"
"{\x0a"
"  __any_imp\x3a\x3a_Handler<_Tp>\x3a\x3a__create(*this, _VSTD\x3a\x3a""forward<_ValueType>(__v));\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType, class ..._Args, class _Tp, class>\x0a"
"any\x3a\x3a""any(in_place_type_t<_ValueType>, _Args\x26\x26... __args) {\x0a"
"  __any_imp\x3a\x3a_Handler<_Tp>\x3a\x3a__create(*this, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType, class _Up, class ..._Args, class _Tp, class>\x0a"
"any\x3a\x3a""any(in_place_type_t<_ValueType>, initializer_list<_Up> __il, _Args\x26\x26... __args) {\x0a"
"  __any_imp\x3a\x3a_Handler<_Tp>\x3a\x3a__create(*this, __il, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType, class, class>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"any \x26 any\x3a\x3aoperator=(_ValueType \x26\x26 __v)\x0a"
"{\x0a"
"  any(_VSTD\x3a\x3a""forward<_ValueType>(__v)).swap(*this);\x0a"
"  return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType, class ..._Args, class _Tp, class>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x26 any\x3a\x3a""emplace(_Args\x26\x26... __args) {\x0a"
"  reset();\x0a"
"  return __any_imp\x3a\x3a_Handler<_Tp>\x3a\x3a__create(*this, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType, class _Up, class ..._Args, class _Tp, class>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x26 any\x3a\x3a""emplace(initializer_list<_Up> __il, _Args\x26\x26... __args) {\x0a"
"  reset();\x0a"
"  return __any_imp\x3a\x3a_Handler<_Tp>\x3a\x3a__create(*this, __il, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void any\x3a\x3aswap(any \x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    if (this == \x26__rhs)\x0a"
"      return;\x0a"
"    if (__h \x26\x26 __rhs.__h) {\x0a"
"        any __tmp;\x0a"
"        __rhs.__call(_Action\x3a\x3a_Move, \x26__tmp);\x0a"
"        this->__call(_Action\x3a\x3a_Move, \x26__rhs);\x0a"
"        __tmp.__call(_Action\x3a\x3a_Move, this);\x0a"
"    }\x0a"
"    else if (__h) {\x0a"
"        this->__call(_Action\x3a\x3a_Move, \x26__rhs);\x0a"
"    }\x0a"
"    else if (__rhs.__h) {\x0a"
"        __rhs.__call(_Action\x3a\x3a_Move, this);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// 6.4 Non-member functions\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void swap(any \x26 __lhs, any \x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    __lhs.swap(__rhs);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class ..._Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"any make_any(_Args\x26\x26... __args) {\x0a"
"    return any(in_place_type<_Tp>, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up, class ..._Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"any make_any(initializer_list<_Up> __il, _Args\x26\x26... __args) {\x0a"
"    return any(in_place_type<_Tp>, __il, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_ANY_CAST\x0a"
"_ValueType any_cast(any const \x26 __v)\x0a"
"{\x0a"
"    using _RawValueType = __uncvref_t<_ValueType>;\x0a"
"    static_assert(is_constructible<_ValueType, _RawValueType const \x26>\x3a\x3avalue,\x0a"
"                  \x22ValueType is required to be a const lvalue reference \x22\x0a"
"                  \x22or a CopyConstructible type\x22);\x0a"
"    auto __tmp = _VSTD\x3a\x3a""any_cast<add_const_t<_RawValueType>>(\x26__v);\x0a"
"    if (__tmp == nullptr)\x0a"
"        __throw_bad_any_cast();\x0a"
"    return static_cast<_ValueType>(*__tmp);\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_ANY_CAST\x0a"
"_ValueType any_cast(any \x26 __v)\x0a"
"{\x0a"
"    using _RawValueType = __uncvref_t<_ValueType>;\x0a"
"    static_assert(is_constructible<_ValueType, _RawValueType \x26>\x3a\x3avalue,\x0a"
"                  \x22ValueType is required to be an lvalue reference \x22\x0a"
"                  \x22or a CopyConstructible type\x22);\x0a"
"    auto __tmp = _VSTD\x3a\x3a""any_cast<_RawValueType>(\x26__v);\x0a"
"    if (__tmp == nullptr)\x0a"
"        __throw_bad_any_cast();\x0a"
"    return static_cast<_ValueType>(*__tmp);\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_ANY_CAST\x0a"
"_ValueType any_cast(any \x26\x26 __v)\x0a"
"{\x0a"
"    using _RawValueType = __uncvref_t<_ValueType>;\x0a"
"    static_assert(is_constructible<_ValueType, _RawValueType>\x3a\x3avalue,\x0a"
"                  \x22ValueType is required to be an rvalue reference \x22\x0a"
"                  \x22or a CopyConstructible type\x22);\x0a"
"    auto __tmp = _VSTD\x3a\x3a""any_cast<_RawValueType>(\x26__v);\x0a"
"    if (__tmp == nullptr)\x0a"
"        __throw_bad_any_cast();\x0a"
"    return static_cast<_ValueType>(_VSTD\x3a\x3amove(*__tmp));\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"add_pointer_t<add_const_t<_ValueType>>\x0a"
"any_cast(any const * __any) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(\x21is_reference<_ValueType>\x3a\x3avalue,\x0a"
"                  \x22_ValueType may not be a reference.\x22);\x0a"
"    return _VSTD\x3a\x3a""any_cast<_ValueType>(const_cast<any *>(__any));\x0a"
"}\x0a"
"\x0a"
"template <class _RetType>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_RetType __pointer_or_func_cast(void* __p, /*IsFunction*/false_type) noexcept {\x0a"
"  return static_cast<_RetType>(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _RetType>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_RetType __pointer_or_func_cast(void*, /*IsFunction*/true_type) noexcept {\x0a"
"  return nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType>\x0a"
"add_pointer_t<_ValueType>\x0a"
"any_cast(any * __any) _NOEXCEPT\x0a"
"{\x0a"
"    using __any_imp\x3a\x3a_Action;\x0a"
"    static_assert(\x21is_reference<_ValueType>\x3a\x3avalue,\x0a"
"                  \x22_ValueType may not be a reference.\x22);\x0a"
"    typedef typename add_pointer<_ValueType>\x3a\x3atype _ReturnType;\x0a"
"    if (__any \x26\x26 __any->__h) {\x0a"
"      void *__p = __any->__call(_Action\x3a\x3a_Get, nullptr,\x0a"
"#if \x21""defined(_LIBCPP_NO_RTTI)\x0a"
"                          \x26typeid(_ValueType),\x0a"
"#else\x0a"
"                          nullptr,\x0a"
"#endif\x0a"
"                          __any_imp\x3a\x3a__get_fallback_typeid<_ValueType>());\x0a"
"        return _VSTD\x3a\x3a__pointer_or_func_cast<_ReturnType>(\x0a"
"            __p, is_function<_ValueType>{});\x0a"
"    }\x0a"
"    return nullptr;\x0a"
"}\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // _LIBCPP_ANY\x0a"
"", 19031 ); }