#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_array( 
"// -*- C++ -*-\x0a"
"//===---------------------------- array -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_ARRAY\x0a"
"#define _LIBCPP_ARRAY\x0a"
"\x0a"
"/*\x0a"
"    array synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"template <class T, size_t N >\x0a"
"struct array\x0a"
"{\x0a"
"    // types\x3a\x0a"
"    typedef T \x26 reference;\x0a"
"    typedef const T \x26 const_reference;\x0a"
"    typedef implementation defined iterator;\x0a"
"    typedef implementation defined const_iterator;\x0a"
"    typedef size_t size_type;\x0a"
"    typedef ptrdiff_t difference_type;\x0a"
"    typedef T value_type;\x0a"
"    typedef T* pointer;\x0a"
"    typedef const T* const_pointer;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator> reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator> const_reverse_iterator;\x0a"
"\x0a"
"    // No explicit construct/copy/destroy for aggregate type\x0a"
"    void fill(const T\x26 u);\x0a"
"    void swap(array\x26 a) noexcept(is_nothrow_swappable_v<T>);\x0a"
"\x0a"
"    // iterators\x3a\x0a"
"    iterator begin() noexcept;\x0a"
"    const_iterator begin() const noexcept;\x0a"
"    iterator end() noexcept;\x0a"
"    const_iterator end() const noexcept;\x0a"
"\x0a"
"    reverse_iterator rbegin() noexcept;\x0a"
"    const_reverse_iterator rbegin() const noexcept;\x0a"
"    reverse_iterator rend() noexcept;\x0a"
"    const_reverse_iterator rend() const noexcept;\x0a"
"\x0a"
"    const_iterator cbegin() const noexcept;\x0a"
"    const_iterator cend() const noexcept;\x0a"
"    const_reverse_iterator crbegin() const noexcept;\x0a"
"    const_reverse_iterator crend() const noexcept;\x0a"
"\x0a"
"    // capacity\x3a\x0a"
"    constexpr size_type size() const noexcept;\x0a"
"    constexpr size_type max_size() const noexcept;\x0a"
"    constexpr bool empty() const noexcept;\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    reference operator\x5b\x5d(size_type n);\x0a"
"    const_reference operator\x5b\x5d(size_type n) const; // constexpr in C++14\x0a"
"    const_reference at(size_type n) const; // constexpr in C++14\x0a"
"    reference at(size_type n);\x0a"
"\x0a"
"    reference front();\x0a"
"    const_reference front() const; // constexpr in C++14\x0a"
"    reference back();\x0a"
"    const_reference back() const; // constexpr in C++14\x0a"
"\x0a"
"    T* data() noexcept;\x0a"
"    const T* data() const noexcept;\x0a"
"};\x0a"
"\x0a"
"  template <class T, class... U>\x0a"
"    array(T, U...) -> array<T, 1 + sizeof...(U)>;\x0a"
"\x0a"
"template <class T, size_t N>\x0a"
"  bool operator==(const array<T,N>\x26 x, const array<T,N>\x26 y);\x0a"
"template <class T, size_t N>\x0a"
"  bool operator\x21=(const array<T,N>\x26 x, const array<T,N>\x26 y);\x0a"
"template <class T, size_t N>\x0a"
"  bool operator<(const array<T,N>\x26 x, const array<T,N>\x26 y);\x0a"
"template <class T, size_t N>\x0a"
"  bool operator>(const array<T,N>\x26 x, const array<T,N>\x26 y);\x0a"
"template <class T, size_t N>\x0a"
"  bool operator<=(const array<T,N>\x26 x, const array<T,N>\x26 y);\x0a"
"template <class T, size_t N>\x0a"
"  bool operator>=(const array<T,N>\x26 x, const array<T,N>\x26 y);\x0a"
"\x0a"
"template <class T, size_t N >\x0a"
"  void swap(array<T,N>\x26 x, array<T,N>\x26 y) noexcept(noexcept(x.swap(y))); // C++17\x0a"
"\x0a"
"template <class T> struct tuple_size;\x0a"
"template <size_t I, class T> struct tuple_element;\x0a"
"template <class T, size_t N> struct tuple_size<array<T, N>>;\x0a"
"template <size_t I, class T, size_t N> struct tuple_element<I, array<T, N>>;\x0a"
"template <size_t I, class T, size_t N> T\x26 get(array<T, N>\x26) noexcept; // constexpr in C++14\x0a"
"template <size_t I, class T, size_t N> const T\x26 get(const array<T, N>\x26) noexcept; // constexpr in C++14\x0a"
"template <size_t I, class T, size_t N> T\x26\x26 get(array<T, N>\x26\x26) noexcept; // constexpr in C++14\x0a"
"template <size_t I, class T, size_t N> const T\x26\x26 get(const array<T, N>\x26\x26) noexcept; // constexpr in C++14\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__tuple>\x0a"
"#include <type_traits>\x0a"
"#include <utility>\x0a"
"#include <iterator>\x0a"
"#include <algorithm>\x0a"
"#include <stdexcept>\x0a"
"#include <cstdlib> // for _LIBCPP_UNREACHABLE\x0a"
"#include <version>\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"struct _LIBCPP_TEMPLATE_VIS array\x0a"
"{\x0a"
"    // types\x3a\x0a"
"    typedef array __self;\x0a"
"    typedef _Tp                                   value_type;\x0a"
"    typedef value_type\x26                           reference;\x0a"
"    typedef const value_type\x26                     const_reference;\x0a"
"    typedef value_type*                           iterator;\x0a"
"    typedef const value_type*                     const_iterator;\x0a"
"    typedef value_type*                           pointer;\x0a"
"    typedef const value_type*                     const_pointer;\x0a"
"    typedef size_t                                size_type;\x0a"
"    typedef ptrdiff_t                             difference_type;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator>       reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator> const_reverse_iterator;\x0a"
"\x0a"
"    _Tp __elems_\x5b_Size\x5d;\x0a"
"\x0a"
"    // No explicit construct/copy/destroy for aggregate type\x0a"
"    _LIBCPP_INLINE_VISIBILITY void fill(const value_type\x26 __u) {\x0a"
"      _VSTD\x3a\x3a""fill_n(__elems_, _Size, __u);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(array\x26 __a) _NOEXCEPT_(__is_nothrow_swappable<_Tp>\x3a\x3avalue) {\x0a"
"      std\x3a\x3aswap_ranges(__elems_, __elems_ + _Size, __a.__elems_);\x0a"
"    }\x0a"
"\x0a"
"    // iterators\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    iterator begin() _NOEXCEPT {return iterator(data());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const_iterator begin() const _NOEXCEPT {return const_iterator(data());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    iterator end() _NOEXCEPT {return iterator(data() + _Size);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const_iterator end() const _NOEXCEPT {return const_iterator(data() + _Size);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator rbegin() _NOEXCEPT {return reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const_reverse_iterator rbegin() const _NOEXCEPT {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator rend() _NOEXCEPT {return reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const_reverse_iterator rend() const _NOEXCEPT {return const_reverse_iterator(begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const_iterator cbegin() const _NOEXCEPT {return begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const_iterator cend() const _NOEXCEPT {return end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT {return rbegin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const_reverse_iterator crend() const _NOEXCEPT {return rend();}\x0a"
"\x0a"
"    // capacity\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR size_type size() const _NOEXCEPT {return _Size;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR size_type max_size() const _NOEXCEPT {return _Size;}\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR bool empty() const _NOEXCEPT {return false; }\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reference operator\x5b\x5d(size_type __n)             _NOEXCEPT {return __elems_\x5b__n\x5d;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    const_reference operator\x5b\x5d(size_type __n) const _NOEXCEPT {return __elems_\x5b__n\x5d;}\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX14       reference at(size_type __n);\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 const_reference at(size_type __n) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 reference front()             _NOEXCEPT {return __elems_\x5b""0\x5d;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 const_reference front() const _NOEXCEPT {return __elems_\x5b""0\x5d;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 reference back()              _NOEXCEPT {return __elems_\x5b_Size - 1\x5d;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 const_reference back() const  _NOEXCEPT {return __elems_\x5b_Size - 1\x5d;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    value_type* data() _NOEXCEPT {return __elems_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    const value_type* data() const _NOEXCEPT {return __elems_;}\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"typename array<_Tp, _Size>\x3a\x3areference\x0a"
"array<_Tp, _Size>\x3a\x3a""at(size_type __n)\x0a"
"{\x0a"
"    if (__n >= _Size)\x0a"
"        __throw_out_of_range(\x22""array\x3a\x3a""at\x22);\x0a"
"\x0a"
"    return __elems_\x5b__n\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"typename array<_Tp, _Size>\x3a\x3a""const_reference\x0a"
"array<_Tp, _Size>\x3a\x3a""at(size_type __n) const\x0a"
"{\x0a"
"    if (__n >= _Size)\x0a"
"        __throw_out_of_range(\x22""array\x3a\x3a""at\x22);\x0a"
"    return __elems_\x5b__n\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS array<_Tp, 0>\x0a"
"{\x0a"
"    // types\x3a\x0a"
"    typedef array __self;\x0a"
"    typedef _Tp                                   value_type;\x0a"
"    typedef value_type\x26                           reference;\x0a"
"    typedef const value_type\x26                     const_reference;\x0a"
"    typedef value_type*                           iterator;\x0a"
"    typedef const value_type*                     const_iterator;\x0a"
"    typedef value_type*                           pointer;\x0a"
"    typedef const value_type*                     const_pointer;\x0a"
"    typedef size_t                                size_type;\x0a"
"    typedef ptrdiff_t                             difference_type;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator>       reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator> const_reverse_iterator;\x0a"
"\x0a"
"    typedef typename conditional<is_const<_Tp>\x3a\x3avalue, const char,\x0a"
"                                char>\x3a\x3atype _CharType;\x0a"
"\x0a"
"    struct  _ArrayInStructT { _Tp __data_\x5b""1\x5d; };\x0a"
"    _ALIGNAS_TYPE(_ArrayInStructT) _CharType __elems_\x5bsizeof(_ArrayInStructT)\x5d;\x0a"
"\x0a"
"    // No explicit construct/copy/destroy for aggregate type\x0a"
"    _LIBCPP_INLINE_VISIBILITY void fill(const value_type\x26) {\x0a"
"      static_assert(\x21is_const<_Tp>\x3a\x3avalue,\x0a"
"                    \x22""cannot fill zero-sized array of type 'const T'\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(array\x26) _NOEXCEPT {\x0a"
"      static_assert(\x21is_const<_Tp>\x3a\x3avalue,\x0a"
"                    \x22""cannot swap zero-sized array of type 'const T'\x22);\x0a"
"    }\x0a"
"\x0a"
"    // iterators\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator begin() _NOEXCEPT {return iterator(data());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT {return const_iterator(data());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator end() _NOEXCEPT {return iterator(data());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end() const _NOEXCEPT {return const_iterator(data());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reverse_iterator rbegin() _NOEXCEPT {return reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin() const _NOEXCEPT {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reverse_iterator rend() _NOEXCEPT {return reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend() const _NOEXCEPT {return const_reverse_iterator(begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const _NOEXCEPT {return begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend() const _NOEXCEPT {return end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT {return rbegin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend() const _NOEXCEPT {return rend();}\x0a"
"\x0a"
"    // capacity\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR size_type size() const _NOEXCEPT {return 0; }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR size_type max_size() const _NOEXCEPT {return 0;}\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR bool empty() const _NOEXCEPT {return true;}\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator\x5b\x5d(size_type) _NOEXCEPT {\x0a"
"      _LIBCPP_ASSERT(false, \x22""cannot call array<T, 0>\x3a\x3aoperator\x5b\x5d on a zero-sized array\x22);\x0a"
"      _LIBCPP_UNREACHABLE();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    const_reference operator\x5b\x5d(size_type) const _NOEXCEPT {\x0a"
"      _LIBCPP_ASSERT(false, \x22""cannot call array<T, 0>\x3a\x3aoperator\x5b\x5d on a zero-sized array\x22);\x0a"
"      _LIBCPP_UNREACHABLE();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference at(size_type) {\x0a"
"      __throw_out_of_range(\x22""array<T, 0>\x3a\x3a""at\x22);\x0a"
"      _LIBCPP_UNREACHABLE();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference at(size_type) const {\x0a"
"      __throw_out_of_range(\x22""array<T, 0>\x3a\x3a""at\x22);\x0a"
"      _LIBCPP_UNREACHABLE();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference front() _NOEXCEPT {\x0a"
"      _LIBCPP_ASSERT(false, \x22""cannot call array<T, 0>\x3a\x3a""front() on a zero-sized array\x22);\x0a"
"      _LIBCPP_UNREACHABLE();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference front() const _NOEXCEPT {\x0a"
"      _LIBCPP_ASSERT(false, \x22""cannot call array<T, 0>\x3a\x3a""front() on a zero-sized array\x22);\x0a"
"      _LIBCPP_UNREACHABLE();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference back() _NOEXCEPT {\x0a"
"      _LIBCPP_ASSERT(false, \x22""cannot call array<T, 0>\x3a\x3a""back() on a zero-sized array\x22);\x0a"
"      _LIBCPP_UNREACHABLE();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference back() const _NOEXCEPT {\x0a"
"      _LIBCPP_ASSERT(false, \x22""cannot call array<T, 0>\x3a\x3a""back() on a zero-sized array\x22);\x0a"
"      _LIBCPP_UNREACHABLE();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type* data() _NOEXCEPT {return reinterpret_cast<value_type*>(__elems_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type* data() const _NOEXCEPT {return reinterpret_cast<const value_type*>(__elems_);}\x0a"
"};\x0a"
"\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _Tp, class... _Args,\x0a"
"         class = typename enable_if<(is_same_v<_Tp, _Args> \x26\x26 ...), void>\x3a\x3atype\x0a"
"         >\x0a"
"array(_Tp, _Args...)\x0a"
"  -> array<_Tp, 1 + sizeof...(_Args)>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"operator==(const array<_Tp, _Size>\x26 __x, const array<_Tp, _Size>\x26 __y)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""equal(__x.begin(), __x.end(), __y.begin());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"operator\x21=(const array<_Tp, _Size>\x26 __x, const array<_Tp, _Size>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"operator<(const array<_Tp, _Size>\x26 __x, const array<_Tp, _Size>\x26 __y)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alexicographical_compare(__x.begin(), __x.end(),\x0a"
"                                          __y.begin(), __y.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"operator>(const array<_Tp, _Size>\x26 __x, const array<_Tp, _Size>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"operator<=(const array<_Tp, _Size>\x26 __x, const array<_Tp, _Size>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"operator>=(const array<_Tp, _Size>\x26 __x, const array<_Tp, _Size>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    _Size == 0 \x7c\x7c\x0a"
"    __is_swappable<_Tp>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"swap(array<_Tp, _Size>\x26 __x, array<_Tp, _Size>\x26 __y)\x0a"
"                                  _NOEXCEPT_(noexcept(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t _Size>\x0a"
"struct _LIBCPP_TEMPLATE_VIS tuple_size<array<_Tp, _Size> >\x0a"
"    \x3a public integral_constant<size_t, _Size> {};\x0a"
"\x0a"
"template <size_t _Ip, class _Tp, size_t _Size>\x0a"
"struct _LIBCPP_TEMPLATE_VIS tuple_element<_Ip, array<_Tp, _Size> >\x0a"
"{\x0a"
"    static_assert(_Ip < _Size, \x22Index out of bounds in std\x3a\x3atuple_element<> (std\x3a\x3a""array)\x22);\x0a"
"    typedef _Tp type;\x0a"
"};\x0a"
"\x0a"
"template <size_t _Ip, class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp\x26\x0a"
"get(array<_Tp, _Size>\x26 __a) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(_Ip < _Size, \x22Index out of bounds in std\x3a\x3aget<> (std\x3a\x3a""array)\x22);\x0a"
"    return __a.__elems_\x5b_Ip\x5d;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const _Tp\x26\x0a"
"get(const array<_Tp, _Size>\x26 __a) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(_Ip < _Size, \x22Index out of bounds in std\x3a\x3aget<> (const std\x3a\x3a""array)\x22);\x0a"
"    return __a.__elems_\x5b_Ip\x5d;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <size_t _Ip, class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp\x26\x26\x0a"
"get(array<_Tp, _Size>\x26\x26 __a) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(_Ip < _Size, \x22Index out of bounds in std\x3a\x3aget<> (std\x3a\x3a""array \x26\x26)\x22);\x0a"
"    return _VSTD\x3a\x3amove(__a.__elems_\x5b_Ip\x5d);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class _Tp, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const _Tp\x26\x26\x0a"
"get(const array<_Tp, _Size>\x26\x26 __a) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(_Ip < _Size, \x22Index out of bounds in std\x3a\x3aget<> (const std\x3a\x3a""array \x26\x26)\x22);\x0a"
"    return _VSTD\x3a\x3amove(__a.__elems_\x5b_Ip\x5d);\x0a"
"}\x0a"
"\x0a"
"#endif  // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_ARRAY\x0a"
"", 17270 ); }