#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_atomic( 
"// -*- C++ -*-\x0a"
"//===--------------------------- atomic -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_ATOMIC\x0a"
"#define _LIBCPP_ATOMIC\x0a"
"\x0a"
"/*\x0a"
"    atomic synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"// feature test macro\x0a"
"\x0a"
"#define __cpp_lib_atomic_is_always_lock_free // as specified by SG10\x0a"
"\x0a"
" // order and consistency\x0a"
"\x0a"
" enum memory_order\x3a unspecified // enum class in C++20\x0a"
" {\x0a"
"    relaxed,\x0a"
"    consume, // load-consume\x0a"
"    acquire, // load-acquire\x0a"
"    release, // store-release\x0a"
"    acq_rel, // store-release load-acquire\x0a"
"    seq_cst // store-release load-acquire\x0a"
" };\x0a"
"\x0a"
" inline constexpr auto memory_order_relaxed = memory_order\x3a\x3arelaxed;\x0a"
" inline constexpr auto memory_order_consume = memory_order\x3a\x3a""consume;\x0a"
" inline constexpr auto memory_order_acquire = memory_order\x3a\x3a""acquire;\x0a"
" inline constexpr auto memory_order_release = memory_order\x3a\x3arelease;\x0a"
" inline constexpr auto memory_order_acq_rel = memory_order\x3a\x3a""acq_rel;\x0a"
" inline constexpr auto memory_order_seq_cst = memory_order\x3a\x3aseq_cst;\x0a"
"\x0a"
"template <class T> T kill_dependency(T y) noexcept;\x0a"
"\x0a"
"// lock-free property\x0a"
"\x0a"
"#define ATOMIC_BOOL_LOCK_FREE unspecified\x0a"
"#define ATOMIC_CHAR_LOCK_FREE unspecified\x0a"
"#define ATOMIC_CHAR16_T_LOCK_FREE unspecified\x0a"
"#define ATOMIC_CHAR32_T_LOCK_FREE unspecified\x0a"
"#define ATOMIC_WCHAR_T_LOCK_FREE unspecified\x0a"
"#define ATOMIC_SHORT_LOCK_FREE unspecified\x0a"
"#define ATOMIC_INT_LOCK_FREE unspecified\x0a"
"#define ATOMIC_LONG_LOCK_FREE unspecified\x0a"
"#define ATOMIC_LLONG_LOCK_FREE unspecified\x0a"
"#define ATOMIC_POINTER_LOCK_FREE unspecified\x0a"
"\x0a"
"// flag type and operations\x0a"
"\x0a"
"typedef struct atomic_flag\x0a"
"{\x0a"
"    bool test_and_set(memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    bool test_and_set(memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    void clear(memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    void clear(memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    atomic_flag()  noexcept = default;\x0a"
"    atomic_flag(const atomic_flag\x26) = delete;\x0a"
"    atomic_flag\x26 operator=(const atomic_flag\x26) = delete;\x0a"
"    atomic_flag\x26 operator=(const atomic_flag\x26) volatile = delete;\x0a"
"} atomic_flag;\x0a"
"\x0a"
"bool\x0a"
"    atomic_flag_test_and_set(volatile atomic_flag* obj) noexcept;\x0a"
"\x0a"
"bool\x0a"
"    atomic_flag_test_and_set(atomic_flag* obj) noexcept;\x0a"
"\x0a"
"bool\x0a"
"    atomic_flag_test_and_set_explicit(volatile atomic_flag* obj,\x0a"
"                                      memory_order m) noexcept;\x0a"
"\x0a"
"bool\x0a"
"    atomic_flag_test_and_set_explicit(atomic_flag* obj, memory_order m) noexcept;\x0a"
"\x0a"
"void\x0a"
"    atomic_flag_clear(volatile atomic_flag* obj) noexcept;\x0a"
"\x0a"
"void\x0a"
"    atomic_flag_clear(atomic_flag* obj) noexcept;\x0a"
"\x0a"
"void\x0a"
"    atomic_flag_clear_explicit(volatile atomic_flag* obj, memory_order m) noexcept;\x0a"
"\x0a"
"void\x0a"
"    atomic_flag_clear_explicit(atomic_flag* obj, memory_order m) noexcept;\x0a"
"\x0a"
"#define ATOMIC_FLAG_INIT see below\x0a"
"#define ATOMIC_VAR_INIT(value) see below\x0a"
"\x0a"
"template <class T>\x0a"
"struct atomic\x0a"
"{\x0a"
"    static constexpr bool is_always_lock_free;\x0a"
"    bool is_lock_free() const volatile noexcept;\x0a"
"    bool is_lock_free() const noexcept;\x0a"
"    void store(T desr, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    void store(T desr, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    T load(memory_order m = memory_order_seq_cst) const volatile noexcept;\x0a"
"    T load(memory_order m = memory_order_seq_cst) const noexcept;\x0a"
"    operator T() const volatile noexcept;\x0a"
"    operator T() const noexcept;\x0a"
"    T exchange(T desr, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    T exchange(T desr, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    bool compare_exchange_weak(T\x26 expc, T desr,\x0a"
"                               memory_order s, memory_order f) volatile noexcept;\x0a"
"    bool compare_exchange_weak(T\x26 expc, T desr, memory_order s, memory_order f) noexcept;\x0a"
"    bool compare_exchange_strong(T\x26 expc, T desr,\x0a"
"                                 memory_order s, memory_order f) volatile noexcept;\x0a"
"    bool compare_exchange_strong(T\x26 expc, T desr,\x0a"
"                                 memory_order s, memory_order f) noexcept;\x0a"
"    bool compare_exchange_weak(T\x26 expc, T desr,\x0a"
"                               memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    bool compare_exchange_weak(T\x26 expc, T desr,\x0a"
"                               memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    bool compare_exchange_strong(T\x26 expc, T desr,\x0a"
"                                memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    bool compare_exchange_strong(T\x26 expc, T desr,\x0a"
"                                 memory_order m = memory_order_seq_cst) noexcept;\x0a"
"\x0a"
"    atomic() noexcept = default;\x0a"
"    constexpr atomic(T desr) noexcept;\x0a"
"    atomic(const atomic\x26) = delete;\x0a"
"    atomic\x26 operator=(const atomic\x26) = delete;\x0a"
"    atomic\x26 operator=(const atomic\x26) volatile = delete;\x0a"
"    T operator=(T) volatile noexcept;\x0a"
"    T operator=(T) noexcept;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct atomic<integral>\x0a"
"{\x0a"
"    static constexpr bool is_always_lock_free;\x0a"
"    bool is_lock_free() const volatile noexcept;\x0a"
"    bool is_lock_free() const noexcept;\x0a"
"    void store(integral desr, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    void store(integral desr, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    integral load(memory_order m = memory_order_seq_cst) const volatile noexcept;\x0a"
"    integral load(memory_order m = memory_order_seq_cst) const noexcept;\x0a"
"    operator integral() const volatile noexcept;\x0a"
"    operator integral() const noexcept;\x0a"
"    integral exchange(integral desr,\x0a"
"                      memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    integral exchange(integral desr, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    bool compare_exchange_weak(integral\x26 expc, integral desr,\x0a"
"                               memory_order s, memory_order f) volatile noexcept;\x0a"
"    bool compare_exchange_weak(integral\x26 expc, integral desr,\x0a"
"                               memory_order s, memory_order f) noexcept;\x0a"
"    bool compare_exchange_strong(integral\x26 expc, integral desr,\x0a"
"                                 memory_order s, memory_order f) volatile noexcept;\x0a"
"    bool compare_exchange_strong(integral\x26 expc, integral desr,\x0a"
"                                 memory_order s, memory_order f) noexcept;\x0a"
"    bool compare_exchange_weak(integral\x26 expc, integral desr,\x0a"
"                               memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    bool compare_exchange_weak(integral\x26 expc, integral desr,\x0a"
"                               memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    bool compare_exchange_strong(integral\x26 expc, integral desr,\x0a"
"                                memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    bool compare_exchange_strong(integral\x26 expc, integral desr,\x0a"
"                                 memory_order m = memory_order_seq_cst) noexcept;\x0a"
"\x0a"
"    integral\x0a"
"        fetch_add(integral op, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    integral fetch_add(integral op, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    integral\x0a"
"        fetch_sub(integral op, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    integral fetch_sub(integral op, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    integral\x0a"
"        fetch_and(integral op, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    integral fetch_and(integral op, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    integral\x0a"
"        fetch_or(integral op, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    integral fetch_or(integral op, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    integral\x0a"
"        fetch_xor(integral op, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    integral fetch_xor(integral op, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"\x0a"
"    atomic() noexcept = default;\x0a"
"    constexpr atomic(integral desr) noexcept;\x0a"
"    atomic(const atomic\x26) = delete;\x0a"
"    atomic\x26 operator=(const atomic\x26) = delete;\x0a"
"    atomic\x26 operator=(const atomic\x26) volatile = delete;\x0a"
"    integral operator=(integral desr) volatile noexcept;\x0a"
"    integral operator=(integral desr) noexcept;\x0a"
"\x0a"
"    integral operator++(int) volatile noexcept;\x0a"
"    integral operator++(int) noexcept;\x0a"
"    integral operator--(int) volatile noexcept;\x0a"
"    integral operator--(int) noexcept;\x0a"
"    integral operator++() volatile noexcept;\x0a"
"    integral operator++() noexcept;\x0a"
"    integral operator--() volatile noexcept;\x0a"
"    integral operator--() noexcept;\x0a"
"    integral operator+=(integral op) volatile noexcept;\x0a"
"    integral operator+=(integral op) noexcept;\x0a"
"    integral operator-=(integral op) volatile noexcept;\x0a"
"    integral operator-=(integral op) noexcept;\x0a"
"    integral operator\x26=(integral op) volatile noexcept;\x0a"
"    integral operator\x26=(integral op) noexcept;\x0a"
"    integral operator\x7c=(integral op) volatile noexcept;\x0a"
"    integral operator\x7c=(integral op) noexcept;\x0a"
"    integral operator^=(integral op) volatile noexcept;\x0a"
"    integral operator^=(integral op) noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class T>\x0a"
"struct atomic<T*>\x0a"
"{\x0a"
"    static constexpr bool is_always_lock_free;\x0a"
"    bool is_lock_free() const volatile noexcept;\x0a"
"    bool is_lock_free() const noexcept;\x0a"
"    void store(T* desr, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    void store(T* desr, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    T* load(memory_order m = memory_order_seq_cst) const volatile noexcept;\x0a"
"    T* load(memory_order m = memory_order_seq_cst) const noexcept;\x0a"
"    operator T*() const volatile noexcept;\x0a"
"    operator T*() const noexcept;\x0a"
"    T* exchange(T* desr, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    T* exchange(T* desr, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    bool compare_exchange_weak(T*\x26 expc, T* desr,\x0a"
"                               memory_order s, memory_order f) volatile noexcept;\x0a"
"    bool compare_exchange_weak(T*\x26 expc, T* desr,\x0a"
"                               memory_order s, memory_order f) noexcept;\x0a"
"    bool compare_exchange_strong(T*\x26 expc, T* desr,\x0a"
"                                 memory_order s, memory_order f) volatile noexcept;\x0a"
"    bool compare_exchange_strong(T*\x26 expc, T* desr,\x0a"
"                                 memory_order s, memory_order f) noexcept;\x0a"
"    bool compare_exchange_weak(T*\x26 expc, T* desr,\x0a"
"                               memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    bool compare_exchange_weak(T*\x26 expc, T* desr,\x0a"
"                               memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    bool compare_exchange_strong(T*\x26 expc, T* desr,\x0a"
"                                memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    bool compare_exchange_strong(T*\x26 expc, T* desr,\x0a"
"                                 memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    T* fetch_add(ptrdiff_t op, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    T* fetch_add(ptrdiff_t op, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"    T* fetch_sub(ptrdiff_t op, memory_order m = memory_order_seq_cst) volatile noexcept;\x0a"
"    T* fetch_sub(ptrdiff_t op, memory_order m = memory_order_seq_cst) noexcept;\x0a"
"\x0a"
"    atomic() noexcept = default;\x0a"
"    constexpr atomic(T* desr) noexcept;\x0a"
"    atomic(const atomic\x26) = delete;\x0a"
"    atomic\x26 operator=(const atomic\x26) = delete;\x0a"
"    atomic\x26 operator=(const atomic\x26) volatile = delete;\x0a"
"\x0a"
"    T* operator=(T*) volatile noexcept;\x0a"
"    T* operator=(T*) noexcept;\x0a"
"    T* operator++(int) volatile noexcept;\x0a"
"    T* operator++(int) noexcept;\x0a"
"    T* operator--(int) volatile noexcept;\x0a"
"    T* operator--(int) noexcept;\x0a"
"    T* operator++() volatile noexcept;\x0a"
"    T* operator++() noexcept;\x0a"
"    T* operator--() volatile noexcept;\x0a"
"    T* operator--() noexcept;\x0a"
"    T* operator+=(ptrdiff_t op) volatile noexcept;\x0a"
"    T* operator+=(ptrdiff_t op) noexcept;\x0a"
"    T* operator-=(ptrdiff_t op) volatile noexcept;\x0a"
"    T* operator-=(ptrdiff_t op) noexcept;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class T>\x0a"
"    bool\x0a"
"    atomic_is_lock_free(const volatile atomic<T>* obj) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    bool\x0a"
"    atomic_is_lock_free(const atomic<T>* obj) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    void\x0a"
"    atomic_init(volatile atomic<T>* obj, T desr) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    void\x0a"
"    atomic_init(atomic<T>* obj, T desr) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    void\x0a"
"    atomic_store(volatile atomic<T>* obj, T desr) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    void\x0a"
"    atomic_store(atomic<T>* obj, T desr) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    void\x0a"
"    atomic_store_explicit(volatile atomic<T>* obj, T desr, memory_order m) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    void\x0a"
"    atomic_store_explicit(atomic<T>* obj, T desr, memory_order m) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T\x0a"
"    atomic_load(const volatile atomic<T>* obj) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T\x0a"
"    atomic_load(const atomic<T>* obj) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T\x0a"
"    atomic_load_explicit(const volatile atomic<T>* obj, memory_order m) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T\x0a"
"    atomic_load_explicit(const atomic<T>* obj, memory_order m) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T\x0a"
"    atomic_exchange(volatile atomic<T>* obj, T desr) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T\x0a"
"    atomic_exchange(atomic<T>* obj, T desr) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T\x0a"
"    atomic_exchange_explicit(volatile atomic<T>* obj, T desr, memory_order m) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T\x0a"
"    atomic_exchange_explicit(atomic<T>* obj, T desr, memory_order m) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_weak(volatile atomic<T>* obj, T* expc, T desr) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_weak(atomic<T>* obj, T* expc, T desr) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_strong(volatile atomic<T>* obj, T* expc, T desr) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_strong(atomic<T>* obj, T* expc, T desr) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_weak_explicit(volatile atomic<T>* obj, T* expc,\x0a"
"                                          T desr,\x0a"
"                                          memory_order s, memory_order f) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_weak_explicit(atomic<T>* obj, T* expc, T desr,\x0a"
"                                          memory_order s, memory_order f) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_strong_explicit(volatile atomic<T>* obj,\x0a"
"                                            T* expc, T desr,\x0a"
"                                            memory_order s, memory_order f) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_strong_explicit(atomic<T>* obj, T* expc,\x0a"
"                                            T desr,\x0a"
"                                            memory_order s, memory_order f) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_add(volatile atomic<Integral>* obj, Integral op) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_add(atomic<Integral>* obj, Integral op) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_add_explicit(volatile atomic<Integral>* obj, Integral op,\x0a"
"                              memory_order m) noexcept;\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_add_explicit(atomic<Integral>* obj, Integral op,\x0a"
"                              memory_order m) noexcept;\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_sub(volatile atomic<Integral>* obj, Integral op) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_sub(atomic<Integral>* obj, Integral op) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_sub_explicit(volatile atomic<Integral>* obj, Integral op,\x0a"
"                              memory_order m) noexcept;\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_sub_explicit(atomic<Integral>* obj, Integral op,\x0a"
"                              memory_order m) noexcept;\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_and(volatile atomic<Integral>* obj, Integral op) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_and(atomic<Integral>* obj, Integral op) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_and_explicit(volatile atomic<Integral>* obj, Integral op,\x0a"
"                              memory_order m) noexcept;\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_and_explicit(atomic<Integral>* obj, Integral op,\x0a"
"                              memory_order m) noexcept;\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_or(volatile atomic<Integral>* obj, Integral op) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_or(atomic<Integral>* obj, Integral op) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_or_explicit(volatile atomic<Integral>* obj, Integral op,\x0a"
"                             memory_order m) noexcept;\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_or_explicit(atomic<Integral>* obj, Integral op,\x0a"
"                             memory_order m) noexcept;\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_xor(volatile atomic<Integral>* obj, Integral op) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_xor(atomic<Integral>* obj, Integral op) noexcept;\x0a"
"\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_xor_explicit(volatile atomic<Integral>* obj, Integral op,\x0a"
"                              memory_order m) noexcept;\x0a"
"template <class Integral>\x0a"
"    Integral\x0a"
"    atomic_fetch_xor_explicit(atomic<Integral>* obj, Integral op,\x0a"
"                              memory_order m) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T*\x0a"
"    atomic_fetch_add(volatile atomic<T*>* obj, ptrdiff_t op) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T*\x0a"
"    atomic_fetch_add(atomic<T*>* obj, ptrdiff_t op) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T*\x0a"
"    atomic_fetch_add_explicit(volatile atomic<T*>* obj, ptrdiff_t op,\x0a"
"                              memory_order m) noexcept;\x0a"
"template <class T>\x0a"
"    T*\x0a"
"    atomic_fetch_add_explicit(atomic<T*>* obj, ptrdiff_t op, memory_order m) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T*\x0a"
"    atomic_fetch_sub(volatile atomic<T*>* obj, ptrdiff_t op) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T*\x0a"
"    atomic_fetch_sub(atomic<T*>* obj, ptrdiff_t op) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    T*\x0a"
"    atomic_fetch_sub_explicit(volatile atomic<T*>* obj, ptrdiff_t op,\x0a"
"                              memory_order m) noexcept;\x0a"
"template <class T>\x0a"
"    T*\x0a"
"    atomic_fetch_sub_explicit(atomic<T*>* obj, ptrdiff_t op, memory_order m) noexcept;\x0a"
"\x0a"
"// Atomics for standard typedef types\x0a"
"\x0a"
"typedef atomic<bool>               atomic_bool;\x0a"
"typedef atomic<char>               atomic_char;\x0a"
"typedef atomic<signed char>        atomic_schar;\x0a"
"typedef atomic<unsigned char>      atomic_uchar;\x0a"
"typedef atomic<short>              atomic_short;\x0a"
"typedef atomic<unsigned short>     atomic_ushort;\x0a"
"typedef atomic<int>                atomic_int;\x0a"
"typedef atomic<unsigned int>       atomic_uint;\x0a"
"typedef atomic<long>               atomic_long;\x0a"
"typedef atomic<unsigned long>      atomic_ulong;\x0a"
"typedef atomic<long long>          atomic_llong;\x0a"
"typedef atomic<unsigned long long> atomic_ullong;\x0a"
"typedef atomic<char16_t>           atomic_char16_t;\x0a"
"typedef atomic<char32_t>           atomic_char32_t;\x0a"
"typedef atomic<wchar_t>            atomic_wchar_t;\x0a"
"\x0a"
"typedef atomic<int_least8_t>   atomic_int_least8_t;\x0a"
"typedef atomic<uint_least8_t>  atomic_uint_least8_t;\x0a"
"typedef atomic<int_least16_t>  atomic_int_least16_t;\x0a"
"typedef atomic<uint_least16_t> atomic_uint_least16_t;\x0a"
"typedef atomic<int_least32_t>  atomic_int_least32_t;\x0a"
"typedef atomic<uint_least32_t> atomic_uint_least32_t;\x0a"
"typedef atomic<int_least64_t>  atomic_int_least64_t;\x0a"
"typedef atomic<uint_least64_t> atomic_uint_least64_t;\x0a"
"\x0a"
"typedef atomic<int_fast8_t>   atomic_int_fast8_t;\x0a"
"typedef atomic<uint_fast8_t>  atomic_uint_fast8_t;\x0a"
"typedef atomic<int_fast16_t>  atomic_int_fast16_t;\x0a"
"typedef atomic<uint_fast16_t> atomic_uint_fast16_t;\x0a"
"typedef atomic<int_fast32_t>  atomic_int_fast32_t;\x0a"
"typedef atomic<uint_fast32_t> atomic_uint_fast32_t;\x0a"
"typedef atomic<int_fast64_t>  atomic_int_fast64_t;\x0a"
"typedef atomic<uint_fast64_t> atomic_uint_fast64_t;\x0a"
"\x0a"
"typedef atomic<int8_t>   atomic_int8_t;\x0a"
"typedef atomic<uint8_t>  atomic_uint8_t;\x0a"
"typedef atomic<int16_t>  atomic_int16_t;\x0a"
"typedef atomic<uint16_t> atomic_uint16_t;\x0a"
"typedef atomic<int32_t>  atomic_int32_t;\x0a"
"typedef atomic<uint32_t> atomic_uint32_t;\x0a"
"typedef atomic<int64_t>  atomic_int64_t;\x0a"
"typedef atomic<uint64_t> atomic_uint64_t;\x0a"
"\x0a"
"typedef atomic<intptr_t>  atomic_intptr_t;\x0a"
"typedef atomic<uintptr_t> atomic_uintptr_t;\x0a"
"typedef atomic<size_t>    atomic_size_t;\x0a"
"typedef atomic<ptrdiff_t> atomic_ptrdiff_t;\x0a"
"typedef atomic<intmax_t>  atomic_intmax_t;\x0a"
"typedef atomic<uintmax_t> atomic_uintmax_t;\x0a"
"\x0a"
"// fences\x0a"
"\x0a"
"void atomic_thread_fence(memory_order m) noexcept;\x0a"
"void atomic_signal_fence(memory_order m) noexcept;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <cstddef>\x0a"
"#include <cstdint>\x0a"
"#include <type_traits>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_NO_THREADS\x0a"
"# error <atomic> is not supported on this single threaded system\x0a"
"#endif\x0a"
"#ifdef _LIBCPP_HAS_NO_ATOMIC_HEADER\x0a"
"# error <atomic> is not implemented\x0a"
"#endif\x0a"
"#ifdef kill_dependency\x0a"
"# error C++ standard library is incompatible with <stdatomic.h>\x0a"
"#endif\x0a"
"\x0a"
"#define _LIBCPP_CHECK_STORE_MEMORY_ORDER(__m) \x5c\x0a"
"  _LIBCPP_DIAGNOSE_WARNING(__m == memory_order_consume \x7c\x7c \x5c\x0a"
"                           __m == memory_order_acquire \x7c\x7c \x5c\x0a"
"                           __m == memory_order_acq_rel,   \x5c\x0a"
"                        \x22memory order argument to atomic operation is invalid\x22)\x0a"
"\x0a"
"#define _LIBCPP_CHECK_LOAD_MEMORY_ORDER(__m) \x5c\x0a"
"  _LIBCPP_DIAGNOSE_WARNING(__m == memory_order_release \x7c\x7c \x5c\x0a"
"                           __m == memory_order_acq_rel,   \x5c\x0a"
"                        \x22memory order argument to atomic operation is invalid\x22)\x0a"
"\x0a"
"#define _LIBCPP_CHECK_EXCHANGE_MEMORY_ORDER(__m, __f) \x5c\x0a"
"  _LIBCPP_DIAGNOSE_WARNING(__f == memory_order_release \x7c\x7c \x5c\x0a"
"                           __f == memory_order_acq_rel,   \x5c\x0a"
"                        \x22memory order argument to atomic operation is invalid\x22)\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// Figure out what the underlying type for \x60memory_order\x60 would be if it were\x0a"
"// declared as an unscoped enum (accounting for -fshort-enums). Use this result\x0a"
"// to pin the underlying type in C++20.\x0a"
"enum __legacy_memory_order {\x0a"
"    __mo_relaxed,\x0a"
"    __mo_consume,\x0a"
"    __mo_acquire,\x0a"
"    __mo_release,\x0a"
"    __mo_acq_rel,\x0a"
"    __mo_seq_cst\x0a"
"};\x0a"
"\x0a"
"typedef underlying_type<__legacy_memory_order>\x3a\x3atype __memory_order_underlying_t;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"enum class memory_order \x3a __memory_order_underlying_t {\x0a"
"  relaxed = __mo_relaxed,\x0a"
"  consume = __mo_consume,\x0a"
"  acquire = __mo_acquire,\x0a"
"  release = __mo_release,\x0a"
"  acq_rel = __mo_acq_rel,\x0a"
"  seq_cst = __mo_seq_cst\x0a"
"};\x0a"
"\x0a"
"inline constexpr auto memory_order_relaxed = memory_order\x3a\x3arelaxed;\x0a"
"inline constexpr auto memory_order_consume = memory_order\x3a\x3a""consume;\x0a"
"inline constexpr auto memory_order_acquire = memory_order\x3a\x3a""acquire;\x0a"
"inline constexpr auto memory_order_release = memory_order\x3a\x3arelease;\x0a"
"inline constexpr auto memory_order_acq_rel = memory_order\x3a\x3a""acq_rel;\x0a"
"inline constexpr auto memory_order_seq_cst = memory_order\x3a\x3aseq_cst;\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"typedef enum memory_order {\x0a"
"  memory_order_relaxed = __mo_relaxed,\x0a"
"  memory_order_consume = __mo_consume,\x0a"
"  memory_order_acquire = __mo_acquire,\x0a"
"  memory_order_release = __mo_release,\x0a"
"  memory_order_acq_rel = __mo_acq_rel,\x0a"
"  memory_order_seq_cst = __mo_seq_cst,\x0a"
"} memory_order;\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"static_assert((is_same<underlying_type<memory_order>\x3a\x3atype, __memory_order_underlying_t>\x3a\x3avalue),\x0a"
"  \x22unexpected underlying type for std\x3a\x3amemory_order\x22);\x0a"
"\x0a"
"#if defined(_LIBCPP_HAS_GCC_ATOMIC_IMP) \x7c\x7c \x5c\x0a"
"\x09""defined(_LIBCPP_ATOMIC_ONLY_USE_BUILTINS)\x0a"
"\x0a"
"// \x5b""atomics.types.generic\x5dp1 guarantees _Tp is trivially copyable. Because\x0a"
"// the default operator= in an object is not volatile, a byte-by-byte copy\x0a"
"// is required.\x0a"
"template <typename _Tp, typename _Tv> _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if<is_assignable<_Tp\x26, _Tv>\x3a\x3avalue>\x3a\x3atype\x0a"
"__cxx_atomic_assign_volatile(_Tp\x26 __a_value, _Tv const\x26 __val) {\x0a"
"  __a_value = __val;\x0a"
"}\x0a"
"template <typename _Tp, typename _Tv> _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if<is_assignable<_Tp\x26, _Tv>\x3a\x3avalue>\x3a\x3atype\x0a"
"__cxx_atomic_assign_volatile(_Tp volatile\x26 __a_value, _Tv volatile const\x26 __val) {\x0a"
"  volatile char* __to = reinterpret_cast<volatile char*>(\x26__a_value);\x0a"
"  volatile char* __end = __to + sizeof(_Tp);\x0a"
"  volatile const char* __from = reinterpret_cast<volatile const char*>(\x26__val);\x0a"
"  while (__to \x21= __end)\x0a"
"    *__to++ = *__from++;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if defined(_LIBCPP_HAS_GCC_ATOMIC_IMP)\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"struct __cxx_atomic_base_impl {\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    __cxx_atomic_base_impl() _NOEXCEPT = default;\x0a"
"#else\x0a"
"    __cxx_atomic_base_impl() _NOEXCEPT \x3a __a_value() {}\x0a"
"#endif // _LIBCPP_CXX03_LANG\x0a"
"  _LIBCPP_CONSTEXPR explicit __cxx_atomic_base_impl(_Tp value) _NOEXCEPT\x0a"
"    \x3a __a_value(value) {}\x0a"
"  _Tp __a_value;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY inline _LIBCPP_CONSTEXPR int __to_gcc_order(memory_order __order) {\x0a"
"  // Avoid switch statement to make this a constexpr.\x0a"
"  return __order == memory_order_relaxed \x3f __ATOMIC_RELAXED\x3a\x0a"
"         (__order == memory_order_acquire \x3f __ATOMIC_ACQUIRE\x3a\x0a"
"          (__order == memory_order_release \x3f __ATOMIC_RELEASE\x3a\x0a"
"           (__order == memory_order_seq_cst \x3f __ATOMIC_SEQ_CST\x3a\x0a"
"            (__order == memory_order_acq_rel \x3f __ATOMIC_ACQ_REL\x3a\x0a"
"              __ATOMIC_CONSUME))));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY inline _LIBCPP_CONSTEXPR int __to_gcc_failure_order(memory_order __order) {\x0a"
"  // Avoid switch statement to make this a constexpr.\x0a"
"  return __order == memory_order_relaxed \x3f __ATOMIC_RELAXED\x3a\x0a"
"         (__order == memory_order_acquire \x3f __ATOMIC_ACQUIRE\x3a\x0a"
"          (__order == memory_order_release \x3f __ATOMIC_RELAXED\x3a\x0a"
"           (__order == memory_order_seq_cst \x3f __ATOMIC_SEQ_CST\x3a\x0a"
"            (__order == memory_order_acq_rel \x3f __ATOMIC_ACQUIRE\x3a\x0a"
"              __ATOMIC_CONSUME))));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_init(volatile __cxx_atomic_base_impl<_Tp>* __a,  _Tp __val) {\x0a"
"  __cxx_atomic_assign_volatile(__a->__a_value, __val);\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_init(__cxx_atomic_base_impl<_Tp>* __a,  _Tp __val) {\x0a"
"  __a->__a_value = __val;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY inline\x0a"
"void __cxx_atomic_thread_fence(memory_order __order) {\x0a"
"  __atomic_thread_fence(__to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY inline\x0a"
"void __cxx_atomic_signal_fence(memory_order __order) {\x0a"
"  __atomic_signal_fence(__to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_store(volatile __cxx_atomic_base_impl<_Tp>* __a,  _Tp __val,\x0a"
"                        memory_order __order) {\x0a"
"  __atomic_store(\x26__a->__a_value, \x26__val,\x0a"
"                 __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_store(__cxx_atomic_base_impl<_Tp>* __a,  _Tp __val,\x0a"
"                        memory_order __order) {\x0a"
"  __atomic_store(\x26__a->__a_value, \x26__val,\x0a"
"                 __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_load(const volatile __cxx_atomic_base_impl<_Tp>* __a,\x0a"
"                      memory_order __order) {\x0a"
"  _Tp __ret;\x0a"
"  __atomic_load(\x26__a->__a_value, \x26__ret,\x0a"
"                __to_gcc_order(__order));\x0a"
"  return __ret;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_load(const __cxx_atomic_base_impl<_Tp>* __a, memory_order __order) {\x0a"
"  _Tp __ret;\x0a"
"  __atomic_load(\x26__a->__a_value, \x26__ret,\x0a"
"                __to_gcc_order(__order));\x0a"
"  return __ret;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_exchange(volatile __cxx_atomic_base_impl<_Tp>* __a,\x0a"
"                          _Tp __value, memory_order __order) {\x0a"
"  _Tp __ret;\x0a"
"  __atomic_exchange(\x26__a->__a_value, \x26__value, \x26__ret,\x0a"
"                    __to_gcc_order(__order));\x0a"
"  return __ret;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_exchange(__cxx_atomic_base_impl<_Tp>* __a, _Tp __value,\x0a"
"                          memory_order __order) {\x0a"
"  _Tp __ret;\x0a"
"  __atomic_exchange(\x26__a->__a_value, \x26__value, \x26__ret,\x0a"
"                    __to_gcc_order(__order));\x0a"
"  return __ret;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_strong(\x0a"
"    volatile __cxx_atomic_base_impl<_Tp>* __a, _Tp* __expected, _Tp __value,\x0a"
"    memory_order __success, memory_order __failure) {\x0a"
"  return __atomic_compare_exchange(\x26__a->__a_value, __expected, \x26__value,\x0a"
"                                   false,\x0a"
"                                   __to_gcc_order(__success),\x0a"
"                                   __to_gcc_failure_order(__failure));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_strong(\x0a"
"    __cxx_atomic_base_impl<_Tp>* __a, _Tp* __expected, _Tp __value, memory_order __success,\x0a"
"    memory_order __failure) {\x0a"
"  return __atomic_compare_exchange(\x26__a->__a_value, __expected, \x26__value,\x0a"
"                                   false,\x0a"
"                                   __to_gcc_order(__success),\x0a"
"                                   __to_gcc_failure_order(__failure));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_weak(\x0a"
"    volatile __cxx_atomic_base_impl<_Tp>* __a, _Tp* __expected, _Tp __value,\x0a"
"    memory_order __success, memory_order __failure) {\x0a"
"  return __atomic_compare_exchange(\x26__a->__a_value, __expected, \x26__value,\x0a"
"                                   true,\x0a"
"                                   __to_gcc_order(__success),\x0a"
"                                   __to_gcc_failure_order(__failure));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_weak(\x0a"
"    __cxx_atomic_base_impl<_Tp>* __a, _Tp* __expected, _Tp __value, memory_order __success,\x0a"
"    memory_order __failure) {\x0a"
"  return __atomic_compare_exchange(\x26__a->__a_value, __expected, \x26__value,\x0a"
"                                   true,\x0a"
"                                   __to_gcc_order(__success),\x0a"
"                                   __to_gcc_failure_order(__failure));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"struct __skip_amt { enum {value = 1}; };\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"struct __skip_amt<_Tp*> { enum {value = sizeof(_Tp)}; };\x0a"
"\x0a"
"// FIXME\x3a Haven't figured out what the spec says about using arrays with\x0a"
"// atomic_fetch_add. Force a failure rather than creating bad behavior.\x0a"
"template <typename _Tp>\x0a"
"struct __skip_amt<_Tp\x5b\x5d> { };\x0a"
"template <typename _Tp, int n>\x0a"
"struct __skip_amt<_Tp\x5bn\x5d> { };\x0a"
"\x0a"
"template <typename _Tp, typename _Td>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_add(volatile __cxx_atomic_base_impl<_Tp>* __a,\x0a"
"                           _Td __delta, memory_order __order) {\x0a"
"  return __atomic_fetch_add(\x26__a->__a_value, __delta * __skip_amt<_Tp>\x3a\x3avalue,\x0a"
"                            __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename _Td>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_add(__cxx_atomic_base_impl<_Tp>* __a, _Td __delta,\x0a"
"                           memory_order __order) {\x0a"
"  return __atomic_fetch_add(\x26__a->__a_value, __delta * __skip_amt<_Tp>\x3a\x3avalue,\x0a"
"                            __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename _Td>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_sub(volatile __cxx_atomic_base_impl<_Tp>* __a,\x0a"
"                           _Td __delta, memory_order __order) {\x0a"
"  return __atomic_fetch_sub(\x26__a->__a_value, __delta * __skip_amt<_Tp>\x3a\x3avalue,\x0a"
"                            __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename _Td>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_sub(__cxx_atomic_base_impl<_Tp>* __a, _Td __delta,\x0a"
"                           memory_order __order) {\x0a"
"  return __atomic_fetch_sub(\x26__a->__a_value, __delta * __skip_amt<_Tp>\x3a\x3avalue,\x0a"
"                            __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_and(volatile __cxx_atomic_base_impl<_Tp>* __a,\x0a"
"                           _Tp __pattern, memory_order __order) {\x0a"
"  return __atomic_fetch_and(\x26__a->__a_value, __pattern,\x0a"
"                            __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_and(__cxx_atomic_base_impl<_Tp>* __a,\x0a"
"                           _Tp __pattern, memory_order __order) {\x0a"
"  return __atomic_fetch_and(\x26__a->__a_value, __pattern,\x0a"
"                            __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_or(volatile __cxx_atomic_base_impl<_Tp>* __a,\x0a"
"                          _Tp __pattern, memory_order __order) {\x0a"
"  return __atomic_fetch_or(\x26__a->__a_value, __pattern,\x0a"
"                           __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_or(__cxx_atomic_base_impl<_Tp>* __a, _Tp __pattern,\x0a"
"                          memory_order __order) {\x0a"
"  return __atomic_fetch_or(\x26__a->__a_value, __pattern,\x0a"
"                           __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_xor(volatile __cxx_atomic_base_impl<_Tp>* __a,\x0a"
"                           _Tp __pattern, memory_order __order) {\x0a"
"  return __atomic_fetch_xor(\x26__a->__a_value, __pattern,\x0a"
"                            __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_xor(__cxx_atomic_base_impl<_Tp>* __a, _Tp __pattern,\x0a"
"                           memory_order __order) {\x0a"
"  return __atomic_fetch_xor(\x26__a->__a_value, __pattern,\x0a"
"                            __to_gcc_order(__order));\x0a"
"}\x0a"
"\x0a"
"#define __cxx_atomic_is_lock_free(__s) __atomic_is_lock_free(__s, 0)\x0a"
"\x0a"
"#elif defined(_LIBCPP_HAS_C_ATOMIC_IMP)\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"struct __cxx_atomic_base_impl {\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    __cxx_atomic_base_impl() _NOEXCEPT = default;\x0a"
"#else\x0a"
"    __cxx_atomic_base_impl() _NOEXCEPT \x3a __a_value() {}\x0a"
"#endif // _LIBCPP_CXX03_LANG\x0a"
"  _LIBCPP_CONSTEXPR explicit __cxx_atomic_base_impl(_Tp value) _NOEXCEPT\x0a"
"    \x3a __a_value(value) {}\x0a"
"  _Atomic(_Tp) __a_value;\x0a"
"};\x0a"
"\x0a"
"#define __cxx_atomic_is_lock_free(__s) __c11_atomic_is_lock_free(__s)\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY inline\x0a"
"void __cxx_atomic_thread_fence(memory_order __order) _NOEXCEPT {\x0a"
"    __c11_atomic_thread_fence(static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY inline\x0a"
"void __cxx_atomic_signal_fence(memory_order __order) _NOEXCEPT {\x0a"
"    __c11_atomic_signal_fence(static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_init(__cxx_atomic_base_impl<_Tp> volatile* __a, _Tp __val) _NOEXCEPT {\x0a"
"    __c11_atomic_init(\x26__a->__a_value, __val);\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_init(__cxx_atomic_base_impl<_Tp> * __a, _Tp __val) _NOEXCEPT {\x0a"
"    __c11_atomic_init(\x26__a->__a_value, __val);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_store(__cxx_atomic_base_impl<_Tp> volatile* __a, _Tp __val, memory_order __order) _NOEXCEPT {\x0a"
"    __c11_atomic_store(\x26__a->__a_value, __val, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_store(__cxx_atomic_base_impl<_Tp> * __a, _Tp __val, memory_order __order) _NOEXCEPT {\x0a"
"    __c11_atomic_store(\x26__a->__a_value, __val, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_load(__cxx_atomic_base_impl<_Tp> const volatile* __a, memory_order __order) _NOEXCEPT {\x0a"
"    using __ptr_type = typename remove_const<decltype(__a->__a_value)>\x3a\x3atype*;\x0a"
"    return __c11_atomic_load(const_cast<__ptr_type>(\x26__a->__a_value), static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_load(__cxx_atomic_base_impl<_Tp> const* __a, memory_order __order) _NOEXCEPT {\x0a"
"    using __ptr_type = typename remove_const<decltype(__a->__a_value)>\x3a\x3atype*;\x0a"
"    return __c11_atomic_load(const_cast<__ptr_type>(\x26__a->__a_value), static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_exchange(__cxx_atomic_base_impl<_Tp> volatile* __a, _Tp __value, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_exchange(\x26__a->__a_value, __value, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_exchange(__cxx_atomic_base_impl<_Tp> * __a, _Tp __value, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_exchange(\x26__a->__a_value, __value, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_strong(__cxx_atomic_base_impl<_Tp> volatile* __a, _Tp* __expected, _Tp __value, memory_order __success, memory_order __failure) _NOEXCEPT {\x0a"
"    return __c11_atomic_compare_exchange_strong(\x26__a->__a_value, __expected, __value, static_cast<__memory_order_underlying_t>(__success), static_cast<__memory_order_underlying_t>(__failure));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_strong(__cxx_atomic_base_impl<_Tp> * __a, _Tp* __expected, _Tp __value, memory_order __success, memory_order __failure) _NOEXCEPT {\x0a"
"    return __c11_atomic_compare_exchange_strong(\x26__a->__a_value, __expected, __value, static_cast<__memory_order_underlying_t>(__success), static_cast<__memory_order_underlying_t>(__failure));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_weak(__cxx_atomic_base_impl<_Tp> volatile* __a, _Tp* __expected, _Tp __value, memory_order __success, memory_order __failure) _NOEXCEPT {\x0a"
"    return __c11_atomic_compare_exchange_weak(\x26__a->__a_value, __expected, __value, static_cast<__memory_order_underlying_t>(__success), static_cast<__memory_order_underlying_t>(__failure));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_weak(__cxx_atomic_base_impl<_Tp> * __a, _Tp* __expected, _Tp __value, memory_order __success, memory_order __failure) _NOEXCEPT {\x0a"
"    return __c11_atomic_compare_exchange_weak(\x26__a->__a_value, __expected, __value,  static_cast<__memory_order_underlying_t>(__success), static_cast<__memory_order_underlying_t>(__failure));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_add(__cxx_atomic_base_impl<_Tp> volatile* __a, _Tp __delta, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_add(\x26__a->__a_value, __delta, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_add(__cxx_atomic_base_impl<_Tp> * __a, _Tp __delta, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_add(\x26__a->__a_value, __delta, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp* __cxx_atomic_fetch_add(__cxx_atomic_base_impl<_Tp*> volatile* __a, ptrdiff_t __delta, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_add(\x26__a->__a_value, __delta, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp* __cxx_atomic_fetch_add(__cxx_atomic_base_impl<_Tp*> * __a, ptrdiff_t __delta, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_add(\x26__a->__a_value, __delta, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_sub(__cxx_atomic_base_impl<_Tp> volatile* __a, _Tp __delta, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_sub(\x26__a->__a_value, __delta, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_sub(__cxx_atomic_base_impl<_Tp> * __a, _Tp __delta, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_sub(\x26__a->__a_value, __delta, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp* __cxx_atomic_fetch_sub(__cxx_atomic_base_impl<_Tp*> volatile* __a, ptrdiff_t __delta, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_sub(\x26__a->__a_value, __delta, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp* __cxx_atomic_fetch_sub(__cxx_atomic_base_impl<_Tp*> * __a, ptrdiff_t __delta, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_sub(\x26__a->__a_value, __delta, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_and(__cxx_atomic_base_impl<_Tp> volatile* __a, _Tp __pattern, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_and(\x26__a->__a_value, __pattern, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_and(__cxx_atomic_base_impl<_Tp> * __a, _Tp __pattern, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_and(\x26__a->__a_value, __pattern, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_or(__cxx_atomic_base_impl<_Tp> volatile* __a, _Tp __pattern, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_or(\x26__a->__a_value, __pattern, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_or(__cxx_atomic_base_impl<_Tp> * __a, _Tp __pattern, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_or(\x26__a->__a_value, __pattern, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_xor(__cxx_atomic_base_impl<_Tp> volatile* __a, _Tp __pattern, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_xor(\x26__a->__a_value, __pattern, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_xor(__cxx_atomic_base_impl<_Tp> * __a, _Tp __pattern, memory_order __order) _NOEXCEPT {\x0a"
"    return __c11_atomic_fetch_xor(\x26__a->__a_value, __pattern, static_cast<__memory_order_underlying_t>(__order));\x0a"
"}\x0a"
"\x0a"
"#endif // _LIBCPP_HAS_GCC_ATOMIC_IMP, _LIBCPP_HAS_C_ATOMIC_IMP\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp kill_dependency(_Tp __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __y;\x0a"
"}\x0a"
"\x0a"
"#if defined(__CLANG_ATOMIC_BOOL_LOCK_FREE)\x0a"
"# define ATOMIC_BOOL_LOCK_FREE      __CLANG_ATOMIC_BOOL_LOCK_FREE\x0a"
"# define ATOMIC_CHAR_LOCK_FREE      __CLANG_ATOMIC_CHAR_LOCK_FREE\x0a"
"# define ATOMIC_CHAR16_T_LOCK_FREE  __CLANG_ATOMIC_CHAR16_T_LOCK_FREE\x0a"
"# define ATOMIC_CHAR32_T_LOCK_FREE  __CLANG_ATOMIC_CHAR32_T_LOCK_FREE\x0a"
"# define ATOMIC_WCHAR_T_LOCK_FREE   __CLANG_ATOMIC_WCHAR_T_LOCK_FREE\x0a"
"# define ATOMIC_SHORT_LOCK_FREE     __CLANG_ATOMIC_SHORT_LOCK_FREE\x0a"
"# define ATOMIC_INT_LOCK_FREE       __CLANG_ATOMIC_INT_LOCK_FREE\x0a"
"# define ATOMIC_LONG_LOCK_FREE      __CLANG_ATOMIC_LONG_LOCK_FREE\x0a"
"# define ATOMIC_LLONG_LOCK_FREE     __CLANG_ATOMIC_LLONG_LOCK_FREE\x0a"
"# define ATOMIC_POINTER_LOCK_FREE   __CLANG_ATOMIC_POINTER_LOCK_FREE\x0a"
"#elif defined(__GCC_ATOMIC_BOOL_LOCK_FREE)\x0a"
"# define ATOMIC_BOOL_LOCK_FREE      __GCC_ATOMIC_BOOL_LOCK_FREE\x0a"
"# define ATOMIC_CHAR_LOCK_FREE      __GCC_ATOMIC_CHAR_LOCK_FREE\x0a"
"# define ATOMIC_CHAR16_T_LOCK_FREE  __GCC_ATOMIC_CHAR16_T_LOCK_FREE\x0a"
"# define ATOMIC_CHAR32_T_LOCK_FREE  __GCC_ATOMIC_CHAR32_T_LOCK_FREE\x0a"
"# define ATOMIC_WCHAR_T_LOCK_FREE   __GCC_ATOMIC_WCHAR_T_LOCK_FREE\x0a"
"# define ATOMIC_SHORT_LOCK_FREE     __GCC_ATOMIC_SHORT_LOCK_FREE\x0a"
"# define ATOMIC_INT_LOCK_FREE       __GCC_ATOMIC_INT_LOCK_FREE\x0a"
"# define ATOMIC_LONG_LOCK_FREE      __GCC_ATOMIC_LONG_LOCK_FREE\x0a"
"# define ATOMIC_LLONG_LOCK_FREE     __GCC_ATOMIC_LLONG_LOCK_FREE\x0a"
"# define ATOMIC_POINTER_LOCK_FREE   __GCC_ATOMIC_POINTER_LOCK_FREE\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _LIBCPP_ATOMIC_ONLY_USE_BUILTINS\x0a"
"\x0a"
"template<typename _Tp>\x0a"
"struct __cxx_atomic_lock_impl {\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  __cxx_atomic_lock_impl() _NOEXCEPT\x0a"
"    \x3a __a_value(), __a_lock(0) {}\x0a"
"  _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR explicit\x0a"
"  __cxx_atomic_lock_impl(_Tp value) _NOEXCEPT\x0a"
"    \x3a __a_value(value), __a_lock(0) {}\x0a"
"\x0a"
"  _Tp __a_value;\x0a"
"  mutable __cxx_atomic_base_impl<_LIBCPP_ATOMIC_FLAG_TYPE> __a_lock;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY void __lock() const volatile {\x0a"
"    while(1 == __cxx_atomic_exchange(\x26__a_lock, _LIBCPP_ATOMIC_FLAG_TYPE(true), memory_order_acquire))\x0a"
"        /*spin*/;\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY void __lock() const {\x0a"
"    while(1 == __cxx_atomic_exchange(\x26__a_lock, _LIBCPP_ATOMIC_FLAG_TYPE(true), memory_order_acquire))\x0a"
"        /*spin*/;\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY void __unlock() const volatile {\x0a"
"    __cxx_atomic_store(\x26__a_lock, _LIBCPP_ATOMIC_FLAG_TYPE(false), memory_order_release);\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY void __unlock() const {\x0a"
"    __cxx_atomic_store(\x26__a_lock, _LIBCPP_ATOMIC_FLAG_TYPE(false), memory_order_release);\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY _Tp __read() const volatile {\x0a"
"    __lock();\x0a"
"    _Tp __old;\x0a"
"    __cxx_atomic_assign_volatile(__old, __a_value);\x0a"
"    __unlock();\x0a"
"    return __old;\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY _Tp __read() const {\x0a"
"    __lock();\x0a"
"    _Tp __old = __a_value;\x0a"
"    __unlock();\x0a"
"    return __old;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_init(volatile __cxx_atomic_lock_impl<_Tp>* __a,  _Tp __val) {\x0a"
"  __cxx_atomic_assign_volatile(__a->__a_value, __val);\x0a"
"}\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_init(__cxx_atomic_lock_impl<_Tp>* __a,  _Tp __val) {\x0a"
"  __a->__a_value = __val;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_store(volatile __cxx_atomic_lock_impl<_Tp>* __a,  _Tp __val, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  __cxx_atomic_assign_volatile(__a->__a_value, __val);\x0a"
"  __a->__unlock();\x0a"
"}\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __cxx_atomic_store(__cxx_atomic_lock_impl<_Tp>* __a,  _Tp __val, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  __a->__a_value = __val;\x0a"
"  __a->__unlock();\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_load(const volatile __cxx_atomic_lock_impl<_Tp>* __a, memory_order) {\x0a"
"  return __a->__read();\x0a"
"}\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_load(const __cxx_atomic_lock_impl<_Tp>* __a, memory_order) {\x0a"
"  return __a->__read();\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_exchange(volatile __cxx_atomic_lock_impl<_Tp>* __a, _Tp __value, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old;\x0a"
"  __cxx_atomic_assign_volatile(__old, __a->__a_value);\x0a"
"  __cxx_atomic_assign_volatile(__a->__a_value, __value);\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_exchange(__cxx_atomic_lock_impl<_Tp>* __a, _Tp __value, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old = __a->__a_value;\x0a"
"  __a->__a_value = __value;\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_strong(volatile __cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                                          _Tp* __expected, _Tp __value, memory_order, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp temp;\x0a"
"  __cxx_atomic_assign_volatile(temp, __a->__a_value);\x0a"
"  bool __ret = temp == *__expected;\x0a"
"  if(__ret)\x0a"
"    __cxx_atomic_assign_volatile(__a->__a_value, __value);\x0a"
"  else\x0a"
"    __cxx_atomic_assign_volatile(*__expected, __a->__a_value);\x0a"
"  __a->__unlock();\x0a"
"  return __ret;\x0a"
"}\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_strong(__cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                                          _Tp* __expected, _Tp __value, memory_order, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  bool __ret = __a->__a_value == *__expected;\x0a"
"  if(__ret)\x0a"
"    __a->__a_value = __value;\x0a"
"  else\x0a"
"    *__expected = __a->__a_value;\x0a"
"  __a->__unlock();\x0a"
"  return __ret;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_weak(volatile __cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                                        _Tp* __expected, _Tp __value, memory_order, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp temp;\x0a"
"  __cxx_atomic_assign_volatile(temp, __a->__a_value);\x0a"
"  bool __ret = temp == *__expected;\x0a"
"  if(__ret)\x0a"
"    __cxx_atomic_assign_volatile(__a->__a_value, __value);\x0a"
"  else\x0a"
"    __cxx_atomic_assign_volatile(*__expected, __a->__a_value);\x0a"
"  __a->__unlock();\x0a"
"  return __ret;\x0a"
"}\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __cxx_atomic_compare_exchange_weak(__cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                                        _Tp* __expected, _Tp __value, memory_order, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  bool __ret = __a->__a_value == *__expected;\x0a"
"  if(__ret)\x0a"
"    __a->__a_value = __value;\x0a"
"  else\x0a"
"    *__expected = __a->__a_value;\x0a"
"  __a->__unlock();\x0a"
"  return __ret;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename _Td>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_add(volatile __cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                           _Td __delta, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old;\x0a"
"  __cxx_atomic_assign_volatile(__old, __a->__a_value);\x0a"
"  __cxx_atomic_assign_volatile(__a->__a_value, _Tp(__old + __delta));\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"template <typename _Tp, typename _Td>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_add(__cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                           _Td __delta, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old = __a->__a_value;\x0a"
"  __a->__a_value += __delta;\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename _Td>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp* __cxx_atomic_fetch_add(volatile __cxx_atomic_lock_impl<_Tp*>* __a,\x0a"
"                           ptrdiff_t __delta, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp* __old;\x0a"
"  __cxx_atomic_assign_volatile(__old, __a->__a_value);\x0a"
"  __cxx_atomic_assign_volatile(__a->__a_value, __old + __delta);\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"template <typename _Tp, typename _Td>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp* __cxx_atomic_fetch_add(__cxx_atomic_lock_impl<_Tp*>* __a,\x0a"
"                           ptrdiff_t __delta, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp* __old = __a->__a_value;\x0a"
"  __a->__a_value += __delta;\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename _Td>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_sub(volatile __cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                           _Td __delta, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old;\x0a"
"  __cxx_atomic_assign_volatile(__old, __a->__a_value);\x0a"
"  __cxx_atomic_assign_volatile(__a->__a_value, _Tp(__old - __delta));\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"template <typename _Tp, typename _Td>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_sub(__cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                           _Td __delta, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old = __a->__a_value;\x0a"
"  __a->__a_value -= __delta;\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_and(volatile __cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                           _Tp __pattern, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old;\x0a"
"  __cxx_atomic_assign_volatile(__old, __a->__a_value);\x0a"
"  __cxx_atomic_assign_volatile(__a->__a_value, _Tp(__old \x26 __pattern));\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_and(__cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                           _Tp __pattern, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old = __a->__a_value;\x0a"
"  __a->__a_value \x26= __pattern;\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_or(volatile __cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                          _Tp __pattern, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old;\x0a"
"  __cxx_atomic_assign_volatile(__old, __a->__a_value);\x0a"
"  __cxx_atomic_assign_volatile(__a->__a_value, _Tp(__old \x7c __pattern));\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_or(__cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                          _Tp __pattern, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old = __a->__a_value;\x0a"
"  __a->__a_value \x7c= __pattern;\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_xor(volatile __cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                           _Tp __pattern, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old;\x0a"
"  __cxx_atomic_assign_volatile(__old, __a->__a_value);\x0a"
"  __cxx_atomic_assign_volatile(__a->__a_value, _Tp(__old ^ __pattern));\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp __cxx_atomic_fetch_xor(__cxx_atomic_lock_impl<_Tp>* __a,\x0a"
"                           _Tp __pattern, memory_order) {\x0a"
"  __a->__lock();\x0a"
"  _Tp __old = __a->__a_value;\x0a"
"  __a->__a_value ^= __pattern;\x0a"
"  __a->__unlock();\x0a"
"  return __old;\x0a"
"}\x0a"
"\x0a"
"#ifdef __cpp_lib_atomic_is_always_lock_free\x0a"
"\x0a"
"template<typename _Tp> struct __cxx_is_always_lock_free {\x0a"
"    enum { __value = __atomic_always_lock_free(sizeof(_Tp), 0) }; };\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template<typename _Tp> struct __cxx_is_always_lock_free { enum { __value = false }; };\x0a"
"// Implementations must match the C ATOMIC_*_LOCK_FREE macro values.\x0a"
"template<> struct __cxx_is_always_lock_free<bool> { enum { __value = 2 == ATOMIC_BOOL_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<char> { enum { __value = 2 == ATOMIC_CHAR_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<signed char> { enum { __value = 2 == ATOMIC_CHAR_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<unsigned char> { enum { __value = 2 == ATOMIC_CHAR_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<char16_t> { enum { __value = 2 == ATOMIC_CHAR16_T_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<char32_t> { enum { __value = 2 == ATOMIC_CHAR32_T_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<wchar_t> { enum { __value = 2 == ATOMIC_WCHAR_T_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<short> { enum { __value = 2 == ATOMIC_SHORT_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<unsigned short> { enum { __value = 2 == ATOMIC_SHORT_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<int> { enum { __value = 2 == ATOMIC_INT_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<unsigned int> { enum { __value = 2 == ATOMIC_INT_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<long> { enum { __value = 2 == ATOMIC_LONG_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<unsigned long> { enum { __value = 2 == ATOMIC_LONG_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<long long> { enum { __value = 2 == ATOMIC_LLONG_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<unsigned long long> { enum { __value = 2 == ATOMIC_LLONG_LOCK_FREE }; };\x0a"
"template<typename _Tp> struct __cxx_is_always_lock_free<_Tp*> { enum { __value = 2 == ATOMIC_POINTER_LOCK_FREE }; };\x0a"
"template<> struct __cxx_is_always_lock_free<std\x3a\x3anullptr_t> { enum { __value = 2 == ATOMIC_POINTER_LOCK_FREE }; };\x0a"
"\x0a"
"#endif //__cpp_lib_atomic_is_always_lock_free\x0a"
"\x0a"
"template <typename _Tp,\x0a"
"          typename _Base = typename conditional<__cxx_is_always_lock_free<_Tp>\x3a\x3a__value,\x0a"
"                                                __cxx_atomic_base_impl<_Tp>,\x0a"
"                                                __cxx_atomic_lock_impl<_Tp> >\x3a\x3atype>\x0a"
"#else\x0a"
"template <typename _Tp,\x0a"
"          typename _Base = __cxx_atomic_base_impl<_Tp> >\x0a"
"#endif //_LIBCPP_ATOMIC_ONLY_USE_BUILTINS\x0a"
"struct __cxx_atomic_impl \x3a public _Base {\x0a"
"\x0a"
"#if _GNUC_VER >= 501\x0a"
"    static_assert(is_trivially_copyable<_Tp>\x3a\x3avalue,\x0a"
"      \x22std\x3a\x3a""atomic<Tp> requires that 'Tp' be a trivially copyable type\x22);\x0a"
"#endif\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY __cxx_atomic_impl() _NOEXCEPT _LIBCPP_DEFAULT\x0a"
"  _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR explicit __cxx_atomic_impl(_Tp value) _NOEXCEPT\x0a"
"    \x3a _Base(value) {}\x0a"
"};\x0a"
"\x0a"
"// general atomic<T>\x0a"
"\x0a"
"template <class _Tp, bool = is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue>\x0a"
"struct __atomic_base  // false\x0a"
"{\x0a"
"    mutable __cxx_atomic_impl<_Tp> __a_;\x0a"
"\x0a"
"#if defined(__cpp_lib_atomic_is_always_lock_free)\x0a"
"  static _LIBCPP_CONSTEXPR bool is_always_lock_free = __atomic_always_lock_free(sizeof(__a_), 0);\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool is_lock_free() const volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_is_lock_free(sizeof(_Tp));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool is_lock_free() const _NOEXCEPT\x0a"
"        {return static_cast<__atomic_base const volatile*>(this)->is_lock_free();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void store(_Tp __d, memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"      _LIBCPP_CHECK_STORE_MEMORY_ORDER(__m)\x0a"
"        {__cxx_atomic_store(\x26__a_, __d, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void store(_Tp __d, memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"      _LIBCPP_CHECK_STORE_MEMORY_ORDER(__m)\x0a"
"        {__cxx_atomic_store(\x26__a_, __d, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp load(memory_order __m = memory_order_seq_cst) const volatile _NOEXCEPT\x0a"
"      _LIBCPP_CHECK_LOAD_MEMORY_ORDER(__m)\x0a"
"        {return __cxx_atomic_load(\x26__a_, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp load(memory_order __m = memory_order_seq_cst) const _NOEXCEPT\x0a"
"      _LIBCPP_CHECK_LOAD_MEMORY_ORDER(__m)\x0a"
"        {return __cxx_atomic_load(\x26__a_, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator _Tp() const volatile _NOEXCEPT {return load();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator _Tp() const _NOEXCEPT          {return load();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp exchange(_Tp __d, memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_exchange(\x26__a_, __d, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp exchange(_Tp __d, memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_exchange(\x26__a_, __d, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool compare_exchange_weak(_Tp\x26 __e, _Tp __d,\x0a"
"                               memory_order __s, memory_order __f) volatile _NOEXCEPT\x0a"
"      _LIBCPP_CHECK_EXCHANGE_MEMORY_ORDER(__s, __f)\x0a"
"        {return __cxx_atomic_compare_exchange_weak(\x26__a_, \x26__e, __d, __s, __f);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool compare_exchange_weak(_Tp\x26 __e, _Tp __d,\x0a"
"                               memory_order __s, memory_order __f) _NOEXCEPT\x0a"
"      _LIBCPP_CHECK_EXCHANGE_MEMORY_ORDER(__s, __f)\x0a"
"        {return __cxx_atomic_compare_exchange_weak(\x26__a_, \x26__e, __d, __s, __f);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool compare_exchange_strong(_Tp\x26 __e, _Tp __d,\x0a"
"                                 memory_order __s, memory_order __f) volatile _NOEXCEPT\x0a"
"      _LIBCPP_CHECK_EXCHANGE_MEMORY_ORDER(__s, __f)\x0a"
"        {return __cxx_atomic_compare_exchange_strong(\x26__a_, \x26__e, __d, __s, __f);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool compare_exchange_strong(_Tp\x26 __e, _Tp __d,\x0a"
"                                 memory_order __s, memory_order __f) _NOEXCEPT\x0a"
"      _LIBCPP_CHECK_EXCHANGE_MEMORY_ORDER(__s, __f)\x0a"
"        {return __cxx_atomic_compare_exchange_strong(\x26__a_, \x26__e, __d, __s, __f);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool compare_exchange_weak(_Tp\x26 __e, _Tp __d,\x0a"
"                              memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_compare_exchange_weak(\x26__a_, \x26__e, __d, __m, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool compare_exchange_weak(_Tp\x26 __e, _Tp __d,\x0a"
"                               memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_compare_exchange_weak(\x26__a_, \x26__e, __d, __m, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool compare_exchange_strong(_Tp\x26 __e, _Tp __d,\x0a"
"                              memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_compare_exchange_strong(\x26__a_, \x26__e, __d, __m, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool compare_exchange_strong(_Tp\x26 __e, _Tp __d,\x0a"
"                                 memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_compare_exchange_strong(\x26__a_, \x26__e, __d, __m, __m);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __atomic_base() _NOEXCEPT _LIBCPP_DEFAULT\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    __atomic_base(_Tp __d) _NOEXCEPT \x3a __a_(__d) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    __atomic_base(const __atomic_base\x26) = delete;\x0a"
"    __atomic_base\x26 operator=(const __atomic_base\x26) = delete;\x0a"
"    __atomic_base\x26 operator=(const __atomic_base\x26) volatile = delete;\x0a"
"#else\x0a"
"private\x3a\x0a"
"    __atomic_base(const __atomic_base\x26);\x0a"
"    __atomic_base\x26 operator=(const __atomic_base\x26);\x0a"
"    __atomic_base\x26 operator=(const __atomic_base\x26) volatile;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"#if defined(__cpp_lib_atomic_is_always_lock_free)\x0a"
"template <class _Tp, bool __b>\x0a"
"_LIBCPP_CONSTEXPR bool __atomic_base<_Tp, __b>\x3a\x3ais_always_lock_free;\x0a"
"#endif\x0a"
"\x0a"
"// atomic<Integral>\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __atomic_base<_Tp, true>\x0a"
"    \x3a public __atomic_base<_Tp, false>\x0a"
"{\x0a"
"    typedef __atomic_base<_Tp, false> __base;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __atomic_base() _NOEXCEPT _LIBCPP_DEFAULT\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR __atomic_base(_Tp __d) _NOEXCEPT \x3a __base(__d) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp fetch_add(_Tp __op, memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_add(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp fetch_add(_Tp __op, memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_add(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp fetch_sub(_Tp __op, memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_sub(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp fetch_sub(_Tp __op, memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_sub(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp fetch_and(_Tp __op, memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_and(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp fetch_and(_Tp __op, memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_and(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp fetch_or(_Tp __op, memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_or(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp fetch_or(_Tp __op, memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_or(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp fetch_xor(_Tp __op, memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_xor(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp fetch_xor(_Tp __op, memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_xor(\x26this->__a_, __op, __m);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator++(int) volatile _NOEXCEPT      {return fetch_add(_Tp(1));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator++(int) _NOEXCEPT               {return fetch_add(_Tp(1));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator--(int) volatile _NOEXCEPT      {return fetch_sub(_Tp(1));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator--(int) _NOEXCEPT               {return fetch_sub(_Tp(1));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator++() volatile _NOEXCEPT         {return fetch_add(_Tp(1)) + _Tp(1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator++() _NOEXCEPT                  {return fetch_add(_Tp(1)) + _Tp(1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator--() volatile _NOEXCEPT         {return fetch_sub(_Tp(1)) - _Tp(1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator--() _NOEXCEPT                  {return fetch_sub(_Tp(1)) - _Tp(1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator+=(_Tp __op) volatile _NOEXCEPT {return fetch_add(__op) + __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator+=(_Tp __op) _NOEXCEPT          {return fetch_add(__op) + __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator-=(_Tp __op) volatile _NOEXCEPT {return fetch_sub(__op) - __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator-=(_Tp __op) _NOEXCEPT          {return fetch_sub(__op) - __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator\x26=(_Tp __op) volatile _NOEXCEPT {return fetch_and(__op) \x26 __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator\x26=(_Tp __op) _NOEXCEPT          {return fetch_and(__op) \x26 __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator\x7c=(_Tp __op) volatile _NOEXCEPT {return fetch_or(__op) \x7c __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator\x7c=(_Tp __op) _NOEXCEPT          {return fetch_or(__op) \x7c __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator^=(_Tp __op) volatile _NOEXCEPT {return fetch_xor(__op) ^ __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator^=(_Tp __op) _NOEXCEPT          {return fetch_xor(__op) ^ __op;}\x0a"
"};\x0a"
"\x0a"
"// atomic<T>\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct atomic\x0a"
"    \x3a public __atomic_base<_Tp>\x0a"
"{\x0a"
"    typedef __atomic_base<_Tp> __base;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    atomic() _NOEXCEPT _LIBCPP_DEFAULT\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR atomic(_Tp __d) _NOEXCEPT \x3a __base(__d) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator=(_Tp __d) volatile _NOEXCEPT\x0a"
"        {__base\x3a\x3astore(__d); return __d;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator=(_Tp __d) _NOEXCEPT\x0a"
"        {__base\x3a\x3astore(__d); return __d;}\x0a"
"};\x0a"
"\x0a"
"// atomic<T*>\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct atomic<_Tp*>\x0a"
"    \x3a public __atomic_base<_Tp*>\x0a"
"{\x0a"
"    typedef __atomic_base<_Tp*> __base;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    atomic() _NOEXCEPT _LIBCPP_DEFAULT\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR atomic(_Tp* __d) _NOEXCEPT \x3a __base(__d) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator=(_Tp* __d) volatile _NOEXCEPT\x0a"
"        {__base\x3a\x3astore(__d); return __d;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator=(_Tp* __d) _NOEXCEPT\x0a"
"        {__base\x3a\x3astore(__d); return __d;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* fetch_add(ptrdiff_t __op, memory_order __m = memory_order_seq_cst)\x0a"
"                                                                        volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_add(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* fetch_add(ptrdiff_t __op, memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_add(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* fetch_sub(ptrdiff_t __op, memory_order __m = memory_order_seq_cst)\x0a"
"                                                                        volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_sub(\x26this->__a_, __op, __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* fetch_sub(ptrdiff_t __op, memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_fetch_sub(\x26this->__a_, __op, __m);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator++(int) volatile _NOEXCEPT            {return fetch_add(1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator++(int) _NOEXCEPT                     {return fetch_add(1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator--(int) volatile _NOEXCEPT            {return fetch_sub(1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator--(int) _NOEXCEPT                     {return fetch_sub(1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator++() volatile _NOEXCEPT               {return fetch_add(1) + 1;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator++() _NOEXCEPT                        {return fetch_add(1) + 1;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator--() volatile _NOEXCEPT               {return fetch_sub(1) - 1;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator--() _NOEXCEPT                        {return fetch_sub(1) - 1;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator+=(ptrdiff_t __op) volatile _NOEXCEPT {return fetch_add(__op) + __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator+=(ptrdiff_t __op) _NOEXCEPT          {return fetch_add(__op) + __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator-=(ptrdiff_t __op) volatile _NOEXCEPT {return fetch_sub(__op) - __op;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* operator-=(ptrdiff_t __op) _NOEXCEPT          {return fetch_sub(__op) - __op;}\x0a"
"};\x0a"
"\x0a"
"// atomic_is_lock_free\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_is_lock_free(const volatile atomic<_Tp>* __o) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->is_lock_free();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_is_lock_free(const atomic<_Tp>* __o) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->is_lock_free();\x0a"
"}\x0a"
"\x0a"
"// atomic_init\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_init(volatile atomic<_Tp>* __o, _Tp __d) _NOEXCEPT\x0a"
"{\x0a"
"    __cxx_atomic_init(\x26__o->__a_, __d);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_init(atomic<_Tp>* __o, _Tp __d) _NOEXCEPT\x0a"
"{\x0a"
"    __cxx_atomic_init(\x26__o->__a_, __d);\x0a"
"}\x0a"
"\x0a"
"// atomic_store\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_store(volatile atomic<_Tp>* __o, _Tp __d) _NOEXCEPT\x0a"
"{\x0a"
"    __o->store(__d);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_store(atomic<_Tp>* __o, _Tp __d) _NOEXCEPT\x0a"
"{\x0a"
"    __o->store(__d);\x0a"
"}\x0a"
"\x0a"
"// atomic_store_explicit\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_store_explicit(volatile atomic<_Tp>* __o, _Tp __d, memory_order __m) _NOEXCEPT\x0a"
"  _LIBCPP_CHECK_STORE_MEMORY_ORDER(__m)\x0a"
"{\x0a"
"    __o->store(__d, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_store_explicit(atomic<_Tp>* __o, _Tp __d, memory_order __m) _NOEXCEPT\x0a"
"  _LIBCPP_CHECK_STORE_MEMORY_ORDER(__m)\x0a"
"{\x0a"
"    __o->store(__d, __m);\x0a"
"}\x0a"
"\x0a"
"// atomic_load\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"atomic_load(const volatile atomic<_Tp>* __o) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->load();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"atomic_load(const atomic<_Tp>* __o) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->load();\x0a"
"}\x0a"
"\x0a"
"// atomic_load_explicit\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"atomic_load_explicit(const volatile atomic<_Tp>* __o, memory_order __m) _NOEXCEPT\x0a"
"  _LIBCPP_CHECK_LOAD_MEMORY_ORDER(__m)\x0a"
"{\x0a"
"    return __o->load(__m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"atomic_load_explicit(const atomic<_Tp>* __o, memory_order __m) _NOEXCEPT\x0a"
"  _LIBCPP_CHECK_LOAD_MEMORY_ORDER(__m)\x0a"
"{\x0a"
"    return __o->load(__m);\x0a"
"}\x0a"
"\x0a"
"// atomic_exchange\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"atomic_exchange(volatile atomic<_Tp>* __o, _Tp __d) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->exchange(__d);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"atomic_exchange(atomic<_Tp>* __o, _Tp __d) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->exchange(__d);\x0a"
"}\x0a"
"\x0a"
"// atomic_exchange_explicit\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"atomic_exchange_explicit(volatile atomic<_Tp>* __o, _Tp __d, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->exchange(__d, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"atomic_exchange_explicit(atomic<_Tp>* __o, _Tp __d, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->exchange(__d, __m);\x0a"
"}\x0a"
"\x0a"
"// atomic_compare_exchange_weak\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_compare_exchange_weak(volatile atomic<_Tp>* __o, _Tp* __e, _Tp __d) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->compare_exchange_weak(*__e, __d);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_compare_exchange_weak(atomic<_Tp>* __o, _Tp* __e, _Tp __d) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->compare_exchange_weak(*__e, __d);\x0a"
"}\x0a"
"\x0a"
"// atomic_compare_exchange_strong\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_compare_exchange_strong(volatile atomic<_Tp>* __o, _Tp* __e, _Tp __d) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->compare_exchange_strong(*__e, __d);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_compare_exchange_strong(atomic<_Tp>* __o, _Tp* __e, _Tp __d) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->compare_exchange_strong(*__e, __d);\x0a"
"}\x0a"
"\x0a"
"// atomic_compare_exchange_weak_explicit\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_compare_exchange_weak_explicit(volatile atomic<_Tp>* __o, _Tp* __e,\x0a"
"                                      _Tp __d,\x0a"
"                                      memory_order __s, memory_order __f) _NOEXCEPT\x0a"
"  _LIBCPP_CHECK_EXCHANGE_MEMORY_ORDER(__s, __f)\x0a"
"{\x0a"
"    return __o->compare_exchange_weak(*__e, __d, __s, __f);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_compare_exchange_weak_explicit(atomic<_Tp>* __o, _Tp* __e, _Tp __d,\x0a"
"                                      memory_order __s, memory_order __f) _NOEXCEPT\x0a"
"  _LIBCPP_CHECK_EXCHANGE_MEMORY_ORDER(__s, __f)\x0a"
"{\x0a"
"    return __o->compare_exchange_weak(*__e, __d, __s, __f);\x0a"
"}\x0a"
"\x0a"
"// atomic_compare_exchange_strong_explicit\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_compare_exchange_strong_explicit(volatile atomic<_Tp>* __o,\x0a"
"                                        _Tp* __e, _Tp __d,\x0a"
"                                        memory_order __s, memory_order __f) _NOEXCEPT\x0a"
"  _LIBCPP_CHECK_EXCHANGE_MEMORY_ORDER(__s, __f)\x0a"
"{\x0a"
"    return __o->compare_exchange_strong(*__e, __d, __s, __f);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_compare_exchange_strong_explicit(atomic<_Tp>* __o, _Tp* __e,\x0a"
"                                        _Tp __d,\x0a"
"                                        memory_order __s, memory_order __f) _NOEXCEPT\x0a"
"  _LIBCPP_CHECK_EXCHANGE_MEMORY_ORDER(__s, __f)\x0a"
"{\x0a"
"    return __o->compare_exchange_strong(*__e, __d, __s, __f);\x0a"
"}\x0a"
"\x0a"
"// atomic_fetch_add\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_add(volatile atomic<_Tp>* __o, _Tp __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_add(__op);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_add(atomic<_Tp>* __o, _Tp __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_add(__op);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"atomic_fetch_add(volatile atomic<_Tp*>* __o, ptrdiff_t __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_add(__op);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"atomic_fetch_add(atomic<_Tp*>* __o, ptrdiff_t __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_add(__op);\x0a"
"}\x0a"
"\x0a"
"// atomic_fetch_add_explicit\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_add_explicit(volatile atomic<_Tp>* __o, _Tp __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_add(__op, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_add_explicit(atomic<_Tp>* __o, _Tp __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_add(__op, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"atomic_fetch_add_explicit(volatile atomic<_Tp*>* __o, ptrdiff_t __op,\x0a"
"                          memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_add(__op, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"atomic_fetch_add_explicit(atomic<_Tp*>* __o, ptrdiff_t __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_add(__op, __m);\x0a"
"}\x0a"
"\x0a"
"// atomic_fetch_sub\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_sub(volatile atomic<_Tp>* __o, _Tp __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_sub(__op);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_sub(atomic<_Tp>* __o, _Tp __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_sub(__op);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"atomic_fetch_sub(volatile atomic<_Tp*>* __o, ptrdiff_t __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_sub(__op);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"atomic_fetch_sub(atomic<_Tp*>* __o, ptrdiff_t __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_sub(__op);\x0a"
"}\x0a"
"\x0a"
"// atomic_fetch_sub_explicit\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_sub_explicit(volatile atomic<_Tp>* __o, _Tp __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_sub(__op, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_sub_explicit(atomic<_Tp>* __o, _Tp __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_sub(__op, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"atomic_fetch_sub_explicit(volatile atomic<_Tp*>* __o, ptrdiff_t __op,\x0a"
"                          memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_sub(__op, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"atomic_fetch_sub_explicit(atomic<_Tp*>* __o, ptrdiff_t __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_sub(__op, __m);\x0a"
"}\x0a"
"\x0a"
"// atomic_fetch_and\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_and(volatile atomic<_Tp>* __o, _Tp __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_and(__op);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_and(atomic<_Tp>* __o, _Tp __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_and(__op);\x0a"
"}\x0a"
"\x0a"
"// atomic_fetch_and_explicit\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_and_explicit(volatile atomic<_Tp>* __o, _Tp __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_and(__op, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_and_explicit(atomic<_Tp>* __o, _Tp __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_and(__op, __m);\x0a"
"}\x0a"
"\x0a"
"// atomic_fetch_or\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_or(volatile atomic<_Tp>* __o, _Tp __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_or(__op);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_or(atomic<_Tp>* __o, _Tp __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_or(__op);\x0a"
"}\x0a"
"\x0a"
"// atomic_fetch_or_explicit\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_or_explicit(volatile atomic<_Tp>* __o, _Tp __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_or(__op, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_or_explicit(atomic<_Tp>* __o, _Tp __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_or(__op, __m);\x0a"
"}\x0a"
"\x0a"
"// atomic_fetch_xor\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_xor(volatile atomic<_Tp>* __o, _Tp __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_xor(__op);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_xor(atomic<_Tp>* __o, _Tp __op) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_xor(__op);\x0a"
"}\x0a"
"\x0a"
"// atomic_fetch_xor_explicit\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_xor_explicit(volatile atomic<_Tp>* __o, _Tp __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_xor(__op, __m);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x26\x26 \x21is_same<_Tp, bool>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"atomic_fetch_xor_explicit(atomic<_Tp>* __o, _Tp __op, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->fetch_xor(__op, __m);\x0a"
"}\x0a"
"\x0a"
"// flag type and operations\x0a"
"\x0a"
"typedef struct atomic_flag\x0a"
"{\x0a"
"    __cxx_atomic_impl<_LIBCPP_ATOMIC_FLAG_TYPE> __a_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool test_and_set(memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"        {return __cxx_atomic_exchange(\x26__a_, _LIBCPP_ATOMIC_FLAG_TYPE(true), __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool test_and_set(memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {return __cxx_atomic_exchange(\x26__a_, _LIBCPP_ATOMIC_FLAG_TYPE(true), __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear(memory_order __m = memory_order_seq_cst) volatile _NOEXCEPT\x0a"
"        {__cxx_atomic_store(\x26__a_, _LIBCPP_ATOMIC_FLAG_TYPE(false), __m);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear(memory_order __m = memory_order_seq_cst) _NOEXCEPT\x0a"
"        {__cxx_atomic_store(\x26__a_, _LIBCPP_ATOMIC_FLAG_TYPE(false), __m);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    atomic_flag() _NOEXCEPT _LIBCPP_DEFAULT\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    atomic_flag(bool __b) _NOEXCEPT \x3a __a_(__b) {} // EXTENSION\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    atomic_flag(const atomic_flag\x26) = delete;\x0a"
"    atomic_flag\x26 operator=(const atomic_flag\x26) = delete;\x0a"
"    atomic_flag\x26 operator=(const atomic_flag\x26) volatile = delete;\x0a"
"#else\x0a"
"private\x3a\x0a"
"    atomic_flag(const atomic_flag\x26);\x0a"
"    atomic_flag\x26 operator=(const atomic_flag\x26);\x0a"
"    atomic_flag\x26 operator=(const atomic_flag\x26) volatile;\x0a"
"#endif\x0a"
"} atomic_flag;\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_flag_test_and_set(volatile atomic_flag* __o) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->test_and_set();\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_flag_test_and_set(atomic_flag* __o) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->test_and_set();\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_flag_test_and_set_explicit(volatile atomic_flag* __o, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->test_and_set(__m);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_flag_test_and_set_explicit(atomic_flag* __o, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    return __o->test_and_set(__m);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_flag_clear(volatile atomic_flag* __o) _NOEXCEPT\x0a"
"{\x0a"
"    __o->clear();\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_flag_clear(atomic_flag* __o) _NOEXCEPT\x0a"
"{\x0a"
"    __o->clear();\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_flag_clear_explicit(volatile atomic_flag* __o, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    __o->clear(__m);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_flag_clear_explicit(atomic_flag* __o, memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    __o->clear(__m);\x0a"
"}\x0a"
"\x0a"
"// fences\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_thread_fence(memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    __cxx_atomic_thread_fence(__m);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"atomic_signal_fence(memory_order __m) _NOEXCEPT\x0a"
"{\x0a"
"    __cxx_atomic_signal_fence(__m);\x0a"
"}\x0a"
"\x0a"
"// Atomics for standard typedef types\x0a"
"\x0a"
"typedef atomic<bool>               atomic_bool;\x0a"
"typedef atomic<char>               atomic_char;\x0a"
"typedef atomic<signed char>        atomic_schar;\x0a"
"typedef atomic<unsigned char>      atomic_uchar;\x0a"
"typedef atomic<short>              atomic_short;\x0a"
"typedef atomic<unsigned short>     atomic_ushort;\x0a"
"typedef atomic<int>                atomic_int;\x0a"
"typedef atomic<unsigned int>       atomic_uint;\x0a"
"typedef atomic<long>               atomic_long;\x0a"
"typedef atomic<unsigned long>      atomic_ulong;\x0a"
"typedef atomic<long long>          atomic_llong;\x0a"
"typedef atomic<unsigned long long> atomic_ullong;\x0a"
"typedef atomic<char16_t>           atomic_char16_t;\x0a"
"typedef atomic<char32_t>           atomic_char32_t;\x0a"
"typedef atomic<wchar_t>            atomic_wchar_t;\x0a"
"\x0a"
"typedef atomic<int_least8_t>   atomic_int_least8_t;\x0a"
"typedef atomic<uint_least8_t>  atomic_uint_least8_t;\x0a"
"typedef atomic<int_least16_t>  atomic_int_least16_t;\x0a"
"typedef atomic<uint_least16_t> atomic_uint_least16_t;\x0a"
"typedef atomic<int_least32_t>  atomic_int_least32_t;\x0a"
"typedef atomic<uint_least32_t> atomic_uint_least32_t;\x0a"
"typedef atomic<int_least64_t>  atomic_int_least64_t;\x0a"
"typedef atomic<uint_least64_t> atomic_uint_least64_t;\x0a"
"\x0a"
"typedef atomic<int_fast8_t>   atomic_int_fast8_t;\x0a"
"typedef atomic<uint_fast8_t>  atomic_uint_fast8_t;\x0a"
"typedef atomic<int_fast16_t>  atomic_int_fast16_t;\x0a"
"typedef atomic<uint_fast16_t> atomic_uint_fast16_t;\x0a"
"typedef atomic<int_fast32_t>  atomic_int_fast32_t;\x0a"
"typedef atomic<uint_fast32_t> atomic_uint_fast32_t;\x0a"
"typedef atomic<int_fast64_t>  atomic_int_fast64_t;\x0a"
"typedef atomic<uint_fast64_t> atomic_uint_fast64_t;\x0a"
"\x0a"
"typedef atomic< int8_t>  atomic_int8_t;\x0a"
"typedef atomic<uint8_t>  atomic_uint8_t;\x0a"
"typedef atomic< int16_t> atomic_int16_t;\x0a"
"typedef atomic<uint16_t> atomic_uint16_t;\x0a"
"typedef atomic< int32_t> atomic_int32_t;\x0a"
"typedef atomic<uint32_t> atomic_uint32_t;\x0a"
"typedef atomic< int64_t> atomic_int64_t;\x0a"
"typedef atomic<uint64_t> atomic_uint64_t;\x0a"
"\x0a"
"typedef atomic<intptr_t>  atomic_intptr_t;\x0a"
"typedef atomic<uintptr_t> atomic_uintptr_t;\x0a"
"typedef atomic<size_t>    atomic_size_t;\x0a"
"typedef atomic<ptrdiff_t> atomic_ptrdiff_t;\x0a"
"typedef atomic<intmax_t>  atomic_intmax_t;\x0a"
"typedef atomic<uintmax_t> atomic_uintmax_t;\x0a"
"\x0a"
"#define ATOMIC_FLAG_INIT {false}\x0a"
"#define ATOMIC_VAR_INIT(__v) {__v}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_ATOMIC\x0a"
"", 85116 ); }