#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_bit( 
"// -*- C++ -*-\x0a"
"//===------------------------------ bit ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===---------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_BIT\x0a"
"#define _LIBCPP_BIT\x0a"
"\x0a"
"/*\x0a"
"    bit synopsis\x0a"
"\x0a"
"namespace std {\x0a"
"\x0a"
"  template <class T>\x0a"
"    constexpr bool ispow2(T x) noexcept; // C++20\x0a"
"  template <class T>\x0a"
"    constexpr T ceil2(T x);              // C++20\x0a"
"  template <class T>\x0a"
"    constexpr T floor2(T x) noexcept;    // C++20\x0a"
"  template <class T>\x0a"
"    constexpr T log2p1(T x) noexcept;    // C++20\x0a"
"\x0a"
"  // 23.20.2, rotating\x0a"
"  template<class T>\x0a"
"    constexpr T rotl(T x, unsigned int s) noexcept; // C++20\x0a"
"  template<class T>\x0a"
"    constexpr T rotr(T x, unsigned int s) noexcept; // C++20\x0a"
"\x0a"
"  // 23.20.3, counting\x0a"
"  template<class T>\x0a"
"    constexpr int countl_zero(T x) noexcept;  // C++20\x0a"
"  template<class T>\x0a"
"    constexpr int countl_one(T x) noexcept;   // C++20\x0a"
"  template<class T>\x0a"
"    constexpr int countr_zero(T x) noexcept;  // C++20\x0a"
"  template<class T>\x0a"
"    constexpr int countr_one(T x) noexcept;   // C++20\x0a"
"  template<class T>\x0a"
"    constexpr int popcount(T x) noexcept;     // C++20\x0a"
"\x0a"
"} // namespace std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <limits>\x0a"
"#include <type_traits>\x0a"
"#include <version>\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if defined(__IBMCPP__)\x0a"
"#include \x22support/ibm/support.h\x22\x0a"
"#endif\x0a"
"#if defined(_LIBCPP_COMPILER_MSVC)\x0a"
"#include <intrin.h>\x0a"
"#endif\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#ifndef _LIBCPP_COMPILER_MSVC\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"int __libcpp_ctz(unsigned __x)           _NOEXCEPT { return __builtin_ctz(__x); }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"int __libcpp_ctz(unsigned long __x)      _NOEXCEPT { return __builtin_ctzl(__x); }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"int __libcpp_ctz(unsigned long long __x) _NOEXCEPT { return __builtin_ctzll(__x); }\x0a"
"\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"int __libcpp_clz(unsigned __x)           _NOEXCEPT { return __builtin_clz(__x); }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"int __libcpp_clz(unsigned long __x)      _NOEXCEPT { return __builtin_clzl(__x); }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"int __libcpp_clz(unsigned long long __x) _NOEXCEPT { return __builtin_clzll(__x); }\x0a"
"\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"int __libcpp_popcount(unsigned __x)           _NOEXCEPT { return __builtin_popcount(__x); }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"int __libcpp_popcount(unsigned long __x)      _NOEXCEPT { return __builtin_popcountl(__x); }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"int __libcpp_popcount(unsigned long long __x) _NOEXCEPT { return __builtin_popcountll(__x); }\x0a"
"\x0a"
"#else  // _LIBCPP_COMPILER_MSVC\x0a"
"\x0a"
"// Precondition\x3a  __x \x21= 0\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"int __libcpp_ctz(unsigned __x) {\x0a"
"  static_assert(sizeof(unsigned) == sizeof(unsigned long), \x22\x22);\x0a"
"  static_assert(sizeof(unsigned long) == 4, \x22\x22);\x0a"
"  unsigned long __where;\x0a"
"  if (_BitScanForward(\x26__where, __x))\x0a"
"    return static_cast<int>(__where);\x0a"
"  return 32;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"int __libcpp_ctz(unsigned long __x) {\x0a"
"    static_assert(sizeof(unsigned long) == sizeof(unsigned), \x22\x22);\x0a"
"    return __ctz(static_cast<unsigned>(__x));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"int __libcpp_ctz(unsigned long long __x) {\x0a"
"    unsigned long __where;\x0a"
"#if defined(_LIBCPP_HAS_BITSCAN64)\x0a"
"    (defined(_M_AMD64) \x7c\x7c defined(__x86_64__))\x0a"
"  if (_BitScanForward64(\x26__where, __x))\x0a"
"    return static_cast<int>(__where);\x0a"
"#else\x0a"
"  // Win32 doesn't have _BitScanForward64 so emulate it with two 32 bit calls.\x0a"
"  if (_BitScanForward(\x26__where, static_cast<unsigned long>(__x)))\x0a"
"    return static_cast<int>(__where);\x0a"
"  if (_BitScanForward(\x26__where, static_cast<unsigned long>(__x >> 32)))\x0a"
"    return static_cast<int>(__where + 32);\x0a"
"#endif\x0a"
"  return 64;\x0a"
"}\x0a"
"\x0a"
"// Precondition\x3a  __x \x21= 0\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"int __libcpp_clz(unsigned __x) {\x0a"
"  static_assert(sizeof(unsigned) == sizeof(unsigned long), \x22\x22);\x0a"
"  static_assert(sizeof(unsigned long) == 4, \x22\x22);\x0a"
"  unsigned long __where;\x0a"
"  if (_BitScanReverse(\x26__where, __x))\x0a"
"    return static_cast<int>(31 - __where);\x0a"
"  return 32; // Undefined Behavior.\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"int __libcpp_clz(unsigned long __x) {\x0a"
"    static_assert(sizeof(unsigned) == sizeof(unsigned long), \x22\x22);\x0a"
"    return __libcpp_clz(static_cast<unsigned>(__x));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"int __libcpp_clz(unsigned long long __x) {\x0a"
"  unsigned long __where;\x0a"
"#if defined(_LIBCPP_HAS_BITSCAN64)\x0a"
"  if (_BitScanReverse64(\x26__where, __x))\x0a"
"    return static_cast<int>(63 - __where);\x0a"
"#else\x0a"
"  // Win32 doesn't have _BitScanReverse64 so emulate it with two 32 bit calls.\x0a"
"  if (_BitScanReverse(\x26__where, static_cast<unsigned long>(__x >> 32)))\x0a"
"    return static_cast<int>(63 - (__where + 32));\x0a"
"  if (_BitScanReverse(\x26__where, static_cast<unsigned long>(__x)))\x0a"
"    return static_cast<int>(63 - __where);\x0a"
"#endif\x0a"
"  return 64; // Undefined Behavior.\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY int __libcpp_popcount(unsigned __x) {\x0a"
"  static_assert(sizeof(unsigned) == 4, \x22\x22);\x0a"
"  return __popcnt(__x);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY int __libcpp_popcount(unsigned long __x) {\x0a"
"  static_assert(sizeof(unsigned long) == 4, \x22\x22);\x0a"
"  return __popcnt(__x);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY int __libcpp_popcount(unsigned long long __x) {\x0a"
"  static_assert(sizeof(unsigned long long) == 8, \x22\x22);\x0a"
"  return __popcnt64(__x);\x0a"
"}\x0a"
"\x0a"
"#endif // _LIBCPP_COMPILER_MSVC\x0a"
"\x0a"
"template <class _Tp>\x0a"
"using __bitop_unsigned_integer _LIBCPP_NODEBUG_TYPE = integral_constant<bool,\x0a"
"         is_integral<_Tp>\x3a\x3avalue \x26\x26\x0a"
"         is_unsigned<_Tp>\x3a\x3avalue \x26\x26\x0a"
"        _IsNotSame<typename remove_cv<_Tp>\x3a\x3atype, bool>\x3a\x3avalue \x26\x26\x0a"
"        _IsNotSame<typename remove_cv<_Tp>\x3a\x3atype, signed char>\x3a\x3avalue \x26\x26\x0a"
"        _IsNotSame<typename remove_cv<_Tp>\x3a\x3atype, wchar_t>\x3a\x3avalue \x26\x26\x0a"
"        _IsNotSame<typename remove_cv<_Tp>\x3a\x3atype, char16_t>\x3a\x3avalue \x26\x26\x0a"
"        _IsNotSame<typename remove_cv<_Tp>\x3a\x3atype, char32_t>\x3a\x3avalue\x0a"
"    >;\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp __rotl(_Tp __t, unsigned int __cnt) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(__bitop_unsigned_integer<_Tp>\x3a\x3avalue, \x22__rotl requires unsigned\x22);\x0a"
"    const unsigned int __dig = numeric_limits<_Tp>\x3a\x3a""digits;\x0a"
"    if ((__cnt \x25 __dig) == 0)\x0a"
"        return __t;\x0a"
"    return (__t << (__cnt \x25 __dig)) \x7c (__t >> (__dig - (__cnt \x25 __dig)));\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp __rotr(_Tp __t, unsigned int __cnt) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(__bitop_unsigned_integer<_Tp>\x3a\x3avalue, \x22__rotr requires unsigned\x22);\x0a"
"    const unsigned int __dig = numeric_limits<_Tp>\x3a\x3a""digits;\x0a"
"    if ((__cnt \x25 __dig) == 0)\x0a"
"        return __t;\x0a"
"    return (__t >> (__cnt \x25 __dig)) \x7c (__t << (__dig - (__cnt \x25 __dig)));\x0a"
"}\x0a"
"\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"int __countr_zero(_Tp __t) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(__bitop_unsigned_integer<_Tp>\x3a\x3avalue, \x22__countr_zero requires unsigned\x22);\x0a"
"    if (__t == 0)\x0a"
"        return numeric_limits<_Tp>\x3a\x3a""digits;\x0a"
"\x0a"
"    if      (sizeof(_Tp) <= sizeof(unsigned int))\x0a"
"        return __libcpp_ctz(static_cast<unsigned int>(__t));\x0a"
"    else if (sizeof(_Tp) <= sizeof(unsigned long))\x0a"
"        return __libcpp_ctz(static_cast<unsigned long>(__t));\x0a"
"    else if (sizeof(_Tp) <= sizeof(unsigned long long))\x0a"
"        return __libcpp_ctz(static_cast<unsigned long long>(__t));\x0a"
"    else\x0a"
"    {\x0a"
"        int __ret = 0;\x0a"
"        int __iter = 0;\x0a"
"        const unsigned int __ulldigits = numeric_limits<unsigned long long>\x3a\x3a""digits;\x0a"
"        while ((__iter = __libcpp_ctz(static_cast<unsigned long long>(__t))) == __ulldigits)\x0a"
"        {\x0a"
"            __ret += __iter;\x0a"
"            __t >>= __ulldigits;\x0a"
"        }\x0a"
"        return __ret + __iter;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"int __countl_zero(_Tp __t) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(__bitop_unsigned_integer<_Tp>\x3a\x3avalue, \x22__countl_zero requires unsigned\x22);\x0a"
"    if (__t == 0)\x0a"
"        return numeric_limits<_Tp>\x3a\x3a""digits;\x0a"
"\x0a"
"    if      (sizeof(_Tp) <= sizeof(unsigned int))\x0a"
"        return __libcpp_clz(static_cast<unsigned int>(__t))\x0a"
"              - (numeric_limits<unsigned int>\x3a\x3a""digits - numeric_limits<_Tp>\x3a\x3a""digits);\x0a"
"    else if (sizeof(_Tp) <= sizeof(unsigned long))\x0a"
"        return __libcpp_clz(static_cast<unsigned long>(__t))\x0a"
"              - (numeric_limits<unsigned long>\x3a\x3a""digits - numeric_limits<_Tp>\x3a\x3a""digits);\x0a"
"    else if (sizeof(_Tp) <= sizeof(unsigned long long))\x0a"
"        return __libcpp_clz(static_cast<unsigned long long>(__t))\x0a"
"              - (numeric_limits<unsigned long long>\x3a\x3a""digits - numeric_limits<_Tp>\x3a\x3a""digits);\x0a"
"    else\x0a"
"    {\x0a"
"        int __ret = 0;\x0a"
"        int __iter = 0;\x0a"
"        const unsigned int __ulldigits = numeric_limits<unsigned long long>\x3a\x3a""digits;\x0a"
"        while (true) {\x0a"
"            __t = __rotr(__t, __ulldigits);\x0a"
"            if ((__iter = __countl_zero(static_cast<unsigned long long>(__t))) \x21= __ulldigits)\x0a"
"                break;\x0a"
"            __ret += __iter;\x0a"
"            }\x0a"
"        return __ret + __iter;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"int __countl_one(_Tp __t) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(__bitop_unsigned_integer<_Tp>\x3a\x3avalue, \x22__countl_one requires unsigned\x22);\x0a"
"    return __t \x21= numeric_limits<_Tp>\x3a\x3amax()\x0a"
"        \x3f __countl_zero(static_cast<_Tp>(\x7e__t))\x0a"
"        \x3a numeric_limits<_Tp>\x3a\x3a""digits;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"int __countr_one(_Tp __t) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(__bitop_unsigned_integer<_Tp>\x3a\x3avalue, \x22__countr_one requires unsigned\x22);\x0a"
"    return __t \x21= numeric_limits<_Tp>\x3a\x3amax()\x0a"
"        \x3f __countr_zero(static_cast<_Tp>(\x7e__t))\x0a"
"        \x3a numeric_limits<_Tp>\x3a\x3a""digits;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"int\x0a"
"__popcount(_Tp __t) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(__bitop_unsigned_integer<_Tp>\x3a\x3avalue, \x22__libcpp_popcount requires unsigned\x22);\x0a"
"    if      (sizeof(_Tp) <= sizeof(unsigned int))\x0a"
"        return __libcpp_popcount(static_cast<unsigned int>(__t));\x0a"
"    else if (sizeof(_Tp) <= sizeof(unsigned long))\x0a"
"        return __libcpp_popcount(static_cast<unsigned long>(__t));\x0a"
"    else if (sizeof(_Tp) <= sizeof(unsigned long long))\x0a"
"        return __libcpp_popcount(static_cast<unsigned long long>(__t));\x0a"
"    else\x0a"
"    {\x0a"
"        int __ret = 0;\x0a"
"        while (__t \x21= 0)\x0a"
"        {\x0a"
"            __ret += __libcpp_popcount(static_cast<unsigned long long>(__t));\x0a"
"            __t >>= numeric_limits<unsigned long long>\x3a\x3a""digits;\x0a"
"        }\x0a"
"        return __ret;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// integral log base 2\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"unsigned __bit_log2(_Tp __t) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(__bitop_unsigned_integer<_Tp>\x3a\x3avalue, \x22__bit_log2 requires unsigned\x22);\x0a"
"    return std\x3a\x3anumeric_limits<_Tp>\x3a\x3a""digits - 1 - __countl_zero(__t);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"bool __ispow2(_Tp __t) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(__bitop_unsigned_integer<_Tp>\x3a\x3avalue, \x22__ispow2 requires unsigned\x22);\x0a"
"\x09return __t \x21= 0 \x26\x26 (((__t \x26 (__t - 1)) == 0)); \x0a"
"}\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, _Tp>\x0a"
"rotl(_Tp __t, unsigned int __cnt) noexcept\x0a"
"{\x0a"
"    return __rotl(__t, __cnt);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// rotr\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, _Tp>\x0a"
"rotr(_Tp __t, unsigned int __cnt) noexcept\x0a"
"{\x0a"
"    return __rotr(__t, __cnt);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, int>\x0a"
"countl_zero(_Tp __t) noexcept\x0a"
"{\x0a"
"    return __countl_zero(__t);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, int>\x0a"
"countl_one(_Tp __t) noexcept\x0a"
"{\x0a"
"    return __countl_one(__t);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, int>\x0a"
"countr_zero(_Tp __t) noexcept\x0a"
"{\x0a"
"\x09return __countr_zero(__t);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, int>\x0a"
"countr_one(_Tp __t) noexcept\x0a"
"{\x0a"
"    return __countr_one(__t);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, int>\x0a"
"popcount(_Tp __t) noexcept\x0a"
"{\x0a"
"    return __popcount(__t);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, bool>\x0a"
"ispow2(_Tp __t) noexcept\x0a"
"{\x0a"
"    return __ispow2(__t);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, _Tp>\x0a"
"floor2(_Tp __t) noexcept\x0a"
"{\x0a"
"    return __t == 0 \x3f 0 \x3a _Tp{1} << __bit_log2(__t);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, _Tp>\x0a"
"ceil2(_Tp __t) noexcept\x0a"
"{\x0a"
"    if (__t < 2) return 1;\x0a"
"    const unsigned __n = numeric_limits<_Tp>\x3a\x3a""digits - countl_zero((_Tp)(__t - 1u));\x0a"
"    _LIBCPP_DEBUG_ASSERT(__libcpp_is_constant_evaluated() \x7c\x7c __n \x21= numeric_limits<_Tp>\x3a\x3a""digits, \x22""Bad input to ceil2\x22);\x0a"
"\x0a"
"    if constexpr (sizeof(_Tp) >= sizeof(unsigned))\x0a"
"        return _Tp{1} << __n;\x0a"
"    else\x0a"
"    {\x0a"
"        const unsigned __extra = numeric_limits<unsigned>\x3a\x3a""digits  - numeric_limits<_Tp>\x3a\x3a""digits;\x0a"
"        const unsigned __retVal = 1u << (__n + __extra);\x0a"
"        return (_Tp) (__retVal >> __extra);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<__bitop_unsigned_integer<_Tp>\x3a\x3avalue, _Tp>\x0a"
"log2p1(_Tp __t) noexcept\x0a"
"{\x0a"
"    return __t == 0 \x3f 0 \x3a __bit_log2(__t) + 1;\x0a"
"}\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif // _LIBCPP_BIT\x0a"
"", 14043 ); }