#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_bitset( 
"// -*- C++ -*-\x0a"
"//===---------------------------- bitset ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_BITSET\x0a"
"#define _LIBCPP_BITSET\x0a"
"\x0a"
"/*\x0a"
"    bitset synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"namespace std {\x0a"
"\x0a"
"template <size_t N>\x0a"
"class bitset\x0a"
"{\x0a"
"public\x3a\x0a"
"    // bit reference\x3a\x0a"
"    class reference\x0a"
"    {\x0a"
"        friend class bitset;\x0a"
"        reference() noexcept;\x0a"
"    public\x3a\x0a"
"        \x7ereference() noexcept;\x0a"
"        reference\x26 operator=(bool x) noexcept;           // for b\x5bi\x5d = x;\x0a"
"        reference\x26 operator=(const reference\x26) noexcept; // for b\x5bi\x5d = b\x5bj\x5d;\x0a"
"        bool operator\x7e() const noexcept;                 // flips the bit\x0a"
"        operator bool() const noexcept;                  // for x = b\x5bi\x5d;\x0a"
"        reference\x26 flip() noexcept;                      // for b\x5bi\x5d.flip();\x0a"
"    };\x0a"
"\x0a"
"    // 23.3.5.1 constructors\x3a\x0a"
"    constexpr bitset() noexcept;\x0a"
"    constexpr bitset(unsigned long long val) noexcept;\x0a"
"    template <class charT>\x0a"
"        explicit bitset(const charT* str,\x0a"
"                        typename basic_string<charT>\x3a\x3asize_type n = basic_string<charT>\x3a\x3anpos,\x0a"
"                        charT zero = charT('0'), charT one = charT('1'));\x0a"
"    template<class charT, class traits, class Allocator>\x0a"
"        explicit bitset(const basic_string<charT,traits,Allocator>\x26 str,\x0a"
"                        typename basic_string<charT,traits,Allocator>\x3a\x3asize_type pos = 0,\x0a"
"                        typename basic_string<charT,traits,Allocator>\x3a\x3asize_type n =\x0a"
"                                 basic_string<charT,traits,Allocator>\x3a\x3anpos,\x0a"
"                        charT zero = charT('0'), charT one = charT('1'));\x0a"
"\x0a"
"    // 23.3.5.2 bitset operations\x3a\x0a"
"    bitset\x26 operator\x26=(const bitset\x26 rhs) noexcept;\x0a"
"    bitset\x26 operator\x7c=(const bitset\x26 rhs) noexcept;\x0a"
"    bitset\x26 operator^=(const bitset\x26 rhs) noexcept;\x0a"
"    bitset\x26 operator<<=(size_t pos) noexcept;\x0a"
"    bitset\x26 operator>>=(size_t pos) noexcept;\x0a"
"    bitset\x26 set() noexcept;\x0a"
"    bitset\x26 set(size_t pos, bool val = true);\x0a"
"    bitset\x26 reset() noexcept;\x0a"
"    bitset\x26 reset(size_t pos);\x0a"
"    bitset operator\x7e() const noexcept;\x0a"
"    bitset\x26 flip() noexcept;\x0a"
"    bitset\x26 flip(size_t pos);\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    constexpr bool operator\x5b\x5d(size_t pos) const; // for b\x5bi\x5d;\x0a"
"    reference operator\x5b\x5d(size_t pos);            // for b\x5bi\x5d;\x0a"
"    unsigned long to_ulong() const;\x0a"
"    unsigned long long to_ullong() const;\x0a"
"    template <class charT, class traits, class Allocator>\x0a"
"        basic_string<charT, traits, Allocator> to_string(charT zero = charT('0'), charT one = charT('1')) const;\x0a"
"    template <class charT, class traits>\x0a"
"        basic_string<charT, traits, allocator<charT> > to_string(charT zero = charT('0'), charT one = charT('1')) const;\x0a"
"    template <class charT>\x0a"
"        basic_string<charT, char_traits<charT>, allocator<charT> > to_string(charT zero = charT('0'), charT one = charT('1')) const;\x0a"
"    basic_string<char, char_traits<char>, allocator<char> > to_string(char zero = '0', char one = '1') const;\x0a"
"    size_t count() const noexcept;\x0a"
"    constexpr size_t size() const noexcept;\x0a"
"    bool operator==(const bitset\x26 rhs) const noexcept;\x0a"
"    bool operator\x21=(const bitset\x26 rhs) const noexcept;\x0a"
"    bool test(size_t pos) const;\x0a"
"    bool all() const noexcept;\x0a"
"    bool any() const noexcept;\x0a"
"    bool none() const noexcept;\x0a"
"    bitset operator<<(size_t pos) const noexcept;\x0a"
"    bitset operator>>(size_t pos) const noexcept;\x0a"
"};\x0a"
"\x0a"
"// 23.3.5.3 bitset operators\x3a\x0a"
"template <size_t N>\x0a"
"bitset<N> operator\x26(const bitset<N>\x26, const bitset<N>\x26) noexcept;\x0a"
"\x0a"
"template <size_t N>\x0a"
"bitset<N> operator\x7c(const bitset<N>\x26, const bitset<N>\x26) noexcept;\x0a"
"\x0a"
"template <size_t N>\x0a"
"bitset<N> operator^(const bitset<N>\x26, const bitset<N>\x26) noexcept;\x0a"
"\x0a"
"template <class charT, class traits, size_t N>\x0a"
"basic_istream<charT, traits>\x26\x0a"
"operator>>(basic_istream<charT, traits>\x26 is, bitset<N>\x26 x);\x0a"
"\x0a"
"template <class charT, class traits, size_t N>\x0a"
"basic_ostream<charT, traits>\x26\x0a"
"operator<<(basic_ostream<charT, traits>\x26 os, const bitset<N>\x26 x);\x0a"
"\x0a"
"template <size_t N> struct hash<std\x3a\x3a""bitset<N>>;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__bit_reference>\x0a"
"#include <cstddef>\x0a"
"#include <climits>\x0a"
"#include <string>\x0a"
"#include <stdexcept>\x0a"
"#include <iosfwd>\x0a"
"#include <__functional_base>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"class __bitset;\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"struct __has_storage_type<__bitset<_N_words, _Size> >\x0a"
"{\x0a"
"    static const bool value = true;\x0a"
"};\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"class __bitset\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef ptrdiff_t              difference_type;\x0a"
"    typedef size_t                 size_type;\x0a"
"    typedef size_type              __storage_type;\x0a"
"protected\x3a\x0a"
"    typedef __bitset __self;\x0a"
"    typedef       __storage_type*  __storage_pointer;\x0a"
"    typedef const __storage_type*  __const_storage_pointer;\x0a"
"    static const unsigned __bits_per_word = static_cast<unsigned>(sizeof(__storage_type) * CHAR_BIT);\x0a"
"\x0a"
"    friend class __bit_reference<__bitset>;\x0a"
"    friend class __bit_const_reference<__bitset>;\x0a"
"    friend class __bit_iterator<__bitset, false>;\x0a"
"    friend class __bit_iterator<__bitset, true>;\x0a"
"    friend struct __bit_array<__bitset>;\x0a"
"\x0a"
"    __storage_type __first_\x5b_N_words\x5d;\x0a"
"\x0a"
"    typedef __bit_reference<__bitset>                  reference;\x0a"
"    typedef __bit_const_reference<__bitset>            const_reference;\x0a"
"    typedef __bit_iterator<__bitset, false>            iterator;\x0a"
"    typedef __bit_iterator<__bitset, true>             const_iterator;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR __bitset() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit _LIBCPP_CONSTEXPR __bitset(unsigned long long __v) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference __make_ref(size_t __pos) _NOEXCEPT\x0a"
"        {return reference(__first_ + __pos / __bits_per_word, __storage_type(1) << __pos \x25 __bits_per_word);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR const_reference __make_ref(size_t __pos) const _NOEXCEPT\x0a"
"        {return const_reference(__first_ + __pos / __bits_per_word, __storage_type(1) << __pos \x25 __bits_per_word);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY iterator __make_iter(size_t __pos) _NOEXCEPT\x0a"
"        {return iterator(__first_ + __pos / __bits_per_word, __pos \x25 __bits_per_word);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_iterator __make_iter(size_t __pos) const _NOEXCEPT\x0a"
"        {return const_iterator(__first_ + __pos / __bits_per_word, __pos \x25 __bits_per_word);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator\x26=(const __bitset\x26 __v) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator\x7c=(const __bitset\x26 __v) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator^=(const __bitset\x26 __v) _NOEXCEPT;\x0a"
"\x0a"
"    void flip() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY unsigned long to_ulong() const\x0a"
"        {return to_ulong(integral_constant<bool, _Size < sizeof(unsigned long) * CHAR_BIT>());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY unsigned long long to_ullong() const\x0a"
"        {return to_ullong(integral_constant<bool, _Size < sizeof(unsigned long long) * CHAR_BIT>());}\x0a"
"\x0a"
"    bool all() const _NOEXCEPT;\x0a"
"    bool any() const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t __hash_code() const _NOEXCEPT;\x0a"
"private\x3a\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    void __init(unsigned long long __v, false_type) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __init(unsigned long long __v, true_type) _NOEXCEPT;\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    unsigned long to_ulong(false_type) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unsigned long to_ulong(true_type) const;\x0a"
"    unsigned long long to_ullong(false_type) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unsigned long long to_ullong(true_type) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unsigned long long to_ullong(true_type, false_type) const;\x0a"
"    unsigned long long to_ullong(true_type, true_type) const;\x0a"
"};\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"__bitset<_N_words, _Size>\x3a\x3a__bitset() _NOEXCEPT\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    \x3a __first_{0}\x0a"
"#endif\x0a"
"{\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    _VSTD\x3a\x3a""fill_n(__first_, _N_words, __storage_type(0));\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"void\x0a"
"__bitset<_N_words, _Size>\x3a\x3a__init(unsigned long long __v, false_type) _NOEXCEPT\x0a"
"{\x0a"
"    __storage_type __t\x5bsizeof(unsigned long long) / sizeof(__storage_type)\x5d;\x0a"
"    size_t __sz = _Size;\x0a"
"    for (size_t __i = 0; __i < sizeof(__t)/sizeof(__t\x5b""0\x5d); ++__i, __v >>= __bits_per_word, __sz -= __bits_per_word )\x0a"
"        if ( __sz < __bits_per_word)\x0a"
"            __t\x5b__i\x5d = static_cast<__storage_type>(__v) \x26 ( 1ULL << __sz ) - 1;\x0a"
"        else\x0a"
"            __t\x5b__i\x5d = static_cast<__storage_type>(__v);\x0a"
"\x0a"
"    _VSTD\x3a\x3a""copy(__t, __t + sizeof(__t)/sizeof(__t\x5b""0\x5d), __first_);\x0a"
"    _VSTD\x3a\x3a""fill(__first_ + sizeof(__t)/sizeof(__t\x5b""0\x5d), __first_ + sizeof(__first_)/sizeof(__first_\x5b""0\x5d),\x0a"
"               __storage_type(0));\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"__bitset<_N_words, _Size>\x3a\x3a__init(unsigned long long __v, true_type) _NOEXCEPT\x0a"
"{\x0a"
"    __first_\x5b""0\x5d = __v;\x0a"
"    if (_Size < __bits_per_word)\x0a"
"        __first_\x5b""0\x5d \x26= ( 1ULL << _Size ) - 1;\x0a"
"\x0a"
"    _VSTD\x3a\x3a""fill(__first_ + 1, __first_ + sizeof(__first_)/sizeof(__first_\x5b""0\x5d), __storage_type(0));\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"__bitset<_N_words, _Size>\x3a\x3a__bitset(unsigned long long __v) _NOEXCEPT\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"#if __SIZEOF_SIZE_T__ == 8\x0a"
"    \x3a __first_{__v}\x0a"
"#elif __SIZEOF_SIZE_T__ == 4\x0a"
"    \x3a __first_{static_cast<__storage_type>(__v),\x0a"
"                _Size >= 2 * __bits_per_word \x3f static_cast<__storage_type>(__v >> __bits_per_word)\x0a"
"                \x3a static_cast<__storage_type>((__v >> __bits_per_word) \x26 (__storage_type(1) << (_Size - __bits_per_word)) - 1)}\x0a"
"#else\x0a"
"#error This constructor has not been ported to this platform\x0a"
"#endif\x0a"
"#endif\x0a"
"{\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    __init(__v, integral_constant<bool, sizeof(unsigned long long) == sizeof(__storage_type)>());\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"inline\x0a"
"void\x0a"
"__bitset<_N_words, _Size>\x3a\x3aoperator\x26=(const __bitset\x26 __v) _NOEXCEPT\x0a"
"{\x0a"
"    for (size_type __i = 0; __i < _N_words; ++__i)\x0a"
"        __first_\x5b__i\x5d \x26= __v.__first_\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"inline\x0a"
"void\x0a"
"__bitset<_N_words, _Size>\x3a\x3aoperator\x7c=(const __bitset\x26 __v) _NOEXCEPT\x0a"
"{\x0a"
"    for (size_type __i = 0; __i < _N_words; ++__i)\x0a"
"        __first_\x5b__i\x5d \x7c= __v.__first_\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"inline\x0a"
"void\x0a"
"__bitset<_N_words, _Size>\x3a\x3aoperator^=(const __bitset\x26 __v) _NOEXCEPT\x0a"
"{\x0a"
"    for (size_type __i = 0; __i < _N_words; ++__i)\x0a"
"        __first_\x5b__i\x5d ^= __v.__first_\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"void\x0a"
"__bitset<_N_words, _Size>\x3a\x3a""flip() _NOEXCEPT\x0a"
"{\x0a"
"    // do middle whole words\x0a"
"    size_type __n = _Size;\x0a"
"    __storage_pointer __p = __first_;\x0a"
"    for (; __n >= __bits_per_word; ++__p, __n -= __bits_per_word)\x0a"
"        *__p = \x7e*__p;\x0a"
"    // do last partial word\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __storage_type __m = \x7e__storage_type(0) >> (__bits_per_word - __n);\x0a"
"        __storage_type __b = *__p \x26 __m;\x0a"
"        *__p \x26= \x7e__m;\x0a"
"        *__p \x7c= \x7e__b \x26 __m;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"unsigned long\x0a"
"__bitset<_N_words, _Size>\x3a\x3ato_ulong(false_type) const\x0a"
"{\x0a"
"    const_iterator __e = __make_iter(_Size);\x0a"
"    const_iterator __i = _VSTD\x3a\x3a""find(__make_iter(sizeof(unsigned long) * CHAR_BIT), __e, true);\x0a"
"    if (__i \x21= __e)\x0a"
"        __throw_overflow_error(\x22""bitset to_ulong overflow error\x22);\x0a"
"\x0a"
"    return __first_\x5b""0\x5d;\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"inline\x0a"
"unsigned long\x0a"
"__bitset<_N_words, _Size>\x3a\x3ato_ulong(true_type) const\x0a"
"{\x0a"
"    return __first_\x5b""0\x5d;\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"unsigned long long\x0a"
"__bitset<_N_words, _Size>\x3a\x3ato_ullong(false_type) const\x0a"
"{\x0a"
"    const_iterator __e = __make_iter(_Size);\x0a"
"    const_iterator __i = _VSTD\x3a\x3a""find(__make_iter(sizeof(unsigned long long) * CHAR_BIT), __e, true);\x0a"
"    if (__i \x21= __e)\x0a"
"        __throw_overflow_error(\x22""bitset to_ullong overflow error\x22);\x0a"
"\x0a"
"    return to_ullong(true_type());\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"inline\x0a"
"unsigned long long\x0a"
"__bitset<_N_words, _Size>\x3a\x3ato_ullong(true_type) const\x0a"
"{\x0a"
"    return to_ullong(true_type(), integral_constant<bool, sizeof(__storage_type) < sizeof(unsigned long long)>());\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"inline\x0a"
"unsigned long long\x0a"
"__bitset<_N_words, _Size>\x3a\x3ato_ullong(true_type, false_type) const\x0a"
"{\x0a"
"    return __first_\x5b""0\x5d;\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"unsigned long long\x0a"
"__bitset<_N_words, _Size>\x3a\x3ato_ullong(true_type, true_type) const\x0a"
"{\x0a"
"    unsigned long long __r = __first_\x5b""0\x5d;\x0a"
"    for (std\x3a\x3asize_t __i = 1; __i < sizeof(unsigned long long) / sizeof(__storage_type); ++__i)\x0a"
"        __r \x7c= static_cast<unsigned long long>(__first_\x5b__i\x5d) << (sizeof(__storage_type) * CHAR_BIT);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"bool\x0a"
"__bitset<_N_words, _Size>\x3a\x3a""all() const _NOEXCEPT\x0a"
"{\x0a"
"    // do middle whole words\x0a"
"    size_type __n = _Size;\x0a"
"    __const_storage_pointer __p = __first_;\x0a"
"    for (; __n >= __bits_per_word; ++__p, __n -= __bits_per_word)\x0a"
"        if (\x7e*__p)\x0a"
"            return false;\x0a"
"    // do last partial word\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __storage_type __m = \x7e__storage_type(0) >> (__bits_per_word - __n);\x0a"
"        if (\x7e*__p \x26 __m)\x0a"
"            return false;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"bool\x0a"
"__bitset<_N_words, _Size>\x3a\x3a""any() const _NOEXCEPT\x0a"
"{\x0a"
"    // do middle whole words\x0a"
"    size_type __n = _Size;\x0a"
"    __const_storage_pointer __p = __first_;\x0a"
"    for (; __n >= __bits_per_word; ++__p, __n -= __bits_per_word)\x0a"
"        if (*__p)\x0a"
"            return true;\x0a"
"    // do last partial word\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __storage_type __m = \x7e__storage_type(0) >> (__bits_per_word - __n);\x0a"
"        if (*__p \x26 __m)\x0a"
"            return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <size_t _N_words, size_t _Size>\x0a"
"inline\x0a"
"size_t\x0a"
"__bitset<_N_words, _Size>\x3a\x3a__hash_code() const _NOEXCEPT\x0a"
"{\x0a"
"    size_t __h = 0;\x0a"
"    for (size_type __i = 0; __i < _N_words; ++__i)\x0a"
"        __h ^= __first_\x5b__i\x5d;\x0a"
"    return __h;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"class __bitset<1, _Size>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef ptrdiff_t              difference_type;\x0a"
"    typedef size_t                 size_type;\x0a"
"    typedef size_type              __storage_type;\x0a"
"protected\x3a\x0a"
"    typedef __bitset __self;\x0a"
"    typedef       __storage_type*  __storage_pointer;\x0a"
"    typedef const __storage_type*  __const_storage_pointer;\x0a"
"    static const unsigned __bits_per_word = static_cast<unsigned>(sizeof(__storage_type) * CHAR_BIT);\x0a"
"\x0a"
"    friend class __bit_reference<__bitset>;\x0a"
"    friend class __bit_const_reference<__bitset>;\x0a"
"    friend class __bit_iterator<__bitset, false>;\x0a"
"    friend class __bit_iterator<__bitset, true>;\x0a"
"    friend struct __bit_array<__bitset>;\x0a"
"\x0a"
"    __storage_type __first_;\x0a"
"\x0a"
"    typedef __bit_reference<__bitset>                  reference;\x0a"
"    typedef __bit_const_reference<__bitset>            const_reference;\x0a"
"    typedef __bit_iterator<__bitset, false>            iterator;\x0a"
"    typedef __bit_iterator<__bitset, true>             const_iterator;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR __bitset() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit _LIBCPP_CONSTEXPR __bitset(unsigned long long __v) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference __make_ref(size_t __pos) _NOEXCEPT\x0a"
"        {return reference(\x26__first_, __storage_type(1) << __pos);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR const_reference __make_ref(size_t __pos) const _NOEXCEPT\x0a"
"        {return const_reference(\x26__first_, __storage_type(1) << __pos);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY iterator __make_iter(size_t __pos) _NOEXCEPT\x0a"
"        {return iterator(\x26__first_ + __pos / __bits_per_word, __pos \x25 __bits_per_word);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_iterator __make_iter(size_t __pos) const _NOEXCEPT\x0a"
"        {return const_iterator(\x26__first_ + __pos / __bits_per_word, __pos \x25 __bits_per_word);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator\x26=(const __bitset\x26 __v) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator\x7c=(const __bitset\x26 __v) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator^=(const __bitset\x26 __v) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void flip() _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unsigned long to_ulong() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unsigned long long to_ullong() const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool all() const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool any() const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t __hash_code() const _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"__bitset<1, _Size>\x3a\x3a__bitset() _NOEXCEPT\x0a"
"    \x3a __first_(0)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"__bitset<1, _Size>\x3a\x3a__bitset(unsigned long long __v) _NOEXCEPT\x0a"
"    \x3a __first_(\x0a"
"        _Size == __bits_per_word \x3f static_cast<__storage_type>(__v)\x0a"
"                                 \x3a static_cast<__storage_type>(__v) \x26 ((__storage_type(1) << _Size) - 1)\x0a"
"    )\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"void\x0a"
"__bitset<1, _Size>\x3a\x3aoperator\x26=(const __bitset\x26 __v) _NOEXCEPT\x0a"
"{\x0a"
"    __first_ \x26= __v.__first_;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"void\x0a"
"__bitset<1, _Size>\x3a\x3aoperator\x7c=(const __bitset\x26 __v) _NOEXCEPT\x0a"
"{\x0a"
"    __first_ \x7c= __v.__first_;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"void\x0a"
"__bitset<1, _Size>\x3a\x3aoperator^=(const __bitset\x26 __v) _NOEXCEPT\x0a"
"{\x0a"
"    __first_ ^= __v.__first_;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"void\x0a"
"__bitset<1, _Size>\x3a\x3a""flip() _NOEXCEPT\x0a"
"{\x0a"
"    __storage_type __m = \x7e__storage_type(0) >> (__bits_per_word - _Size);\x0a"
"    __first_ = \x7e__first_;\x0a"
"    __first_ \x26= __m;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"unsigned long\x0a"
"__bitset<1, _Size>\x3a\x3ato_ulong() const\x0a"
"{\x0a"
"    return __first_;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"unsigned long long\x0a"
"__bitset<1, _Size>\x3a\x3ato_ullong() const\x0a"
"{\x0a"
"    return __first_;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bool\x0a"
"__bitset<1, _Size>\x3a\x3a""all() const _NOEXCEPT\x0a"
"{\x0a"
"    __storage_type __m = \x7e__storage_type(0) >> (__bits_per_word - _Size);\x0a"
"    return \x21(\x7e__first_ \x26 __m);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bool\x0a"
"__bitset<1, _Size>\x3a\x3a""any() const _NOEXCEPT\x0a"
"{\x0a"
"    __storage_type __m = \x7e__storage_type(0) >> (__bits_per_word - _Size);\x0a"
"    return __first_ \x26 __m;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"size_t\x0a"
"__bitset<1, _Size>\x3a\x3a__hash_code() const _NOEXCEPT\x0a"
"{\x0a"
"    return __first_;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"class __bitset<0, 0>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef ptrdiff_t              difference_type;\x0a"
"    typedef size_t                 size_type;\x0a"
"    typedef size_type              __storage_type;\x0a"
"protected\x3a\x0a"
"    typedef __bitset __self;\x0a"
"    typedef       __storage_type*  __storage_pointer;\x0a"
"    typedef const __storage_type*  __const_storage_pointer;\x0a"
"    static const unsigned __bits_per_word = static_cast<unsigned>(sizeof(__storage_type) * CHAR_BIT);\x0a"
"\x0a"
"    friend class __bit_reference<__bitset>;\x0a"
"    friend class __bit_const_reference<__bitset>;\x0a"
"    friend class __bit_iterator<__bitset, false>;\x0a"
"    friend class __bit_iterator<__bitset, true>;\x0a"
"    friend struct __bit_array<__bitset>;\x0a"
"\x0a"
"    typedef __bit_reference<__bitset>                  reference;\x0a"
"    typedef __bit_const_reference<__bitset>            const_reference;\x0a"
"    typedef __bit_iterator<__bitset, false>            iterator;\x0a"
"    typedef __bit_iterator<__bitset, true>             const_iterator;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR __bitset() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit _LIBCPP_CONSTEXPR __bitset(unsigned long long) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference __make_ref(size_t) _NOEXCEPT\x0a"
"        {return reference(0, 1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR const_reference __make_ref(size_t) const _NOEXCEPT\x0a"
"        {return const_reference(0, 1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY iterator __make_iter(size_t) _NOEXCEPT\x0a"
"        {return iterator(0, 0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_iterator __make_iter(size_t) const _NOEXCEPT\x0a"
"        {return const_iterator(0, 0);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void operator\x26=(const __bitset\x26) _NOEXCEPT {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void operator\x7c=(const __bitset\x26) _NOEXCEPT {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void operator^=(const __bitset\x26) _NOEXCEPT {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void flip() _NOEXCEPT {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY unsigned long to_ulong() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY unsigned long long to_ullong() const {return 0;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool all() const _NOEXCEPT {return true;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool any() const _NOEXCEPT {return false;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_t __hash_code() const _NOEXCEPT {return 0;}\x0a"
"};\x0a"
"\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"__bitset<0, 0>\x3a\x3a__bitset() _NOEXCEPT\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"__bitset<0, 0>\x3a\x3a__bitset(unsigned long long) _NOEXCEPT\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size> class _LIBCPP_TEMPLATE_VIS bitset;\x0a"
"template <size_t _Size> struct hash<bitset<_Size> >;\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"class _LIBCPP_TEMPLATE_VIS bitset\x0a"
"    \x3a private __bitset<_Size == 0 \x3f 0 \x3a (_Size - 1) / (sizeof(size_t) * CHAR_BIT) + 1, _Size>\x0a"
"{\x0a"
"public\x3a\x0a"
"    static const unsigned __n_words = _Size == 0 \x3f 0 \x3a (_Size - 1) / (sizeof(size_t) * CHAR_BIT) + 1;\x0a"
"    typedef __bitset<__n_words, _Size> base;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename base\x3a\x3areference       reference;\x0a"
"    typedef typename base\x3a\x3a""const_reference const_reference;\x0a"
"\x0a"
"    // 23.3.5.1 constructors\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR bitset() _NOEXCEPT {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"        bitset(unsigned long long __v) _NOEXCEPT \x3a base(__v) {}\x0a"
"    template<class _CharT, class = _EnableIf<_IsCharLikeType<_CharT>\x3a\x3avalue> >\x0a"
"        explicit bitset(const _CharT* __str,\x0a"
"                        typename basic_string<_CharT>\x3a\x3asize_type __n = basic_string<_CharT>\x3a\x3anpos,\x0a"
"                        _CharT __zero = _CharT('0'), _CharT __one = _CharT('1'));\x0a"
"    template<class _CharT, class _Traits, class _Allocator>\x0a"
"        explicit bitset(const basic_string<_CharT,_Traits,_Allocator>\x26 __str,\x0a"
"                        typename basic_string<_CharT,_Traits,_Allocator>\x3a\x3asize_type __pos = 0,\x0a"
"                        typename basic_string<_CharT,_Traits,_Allocator>\x3a\x3asize_type __n =\x0a"
"                                (basic_string<_CharT,_Traits,_Allocator>\x3a\x3anpos),\x0a"
"                        _CharT __zero = _CharT('0'), _CharT __one = _CharT('1'));\x0a"
"\x0a"
"    // 23.3.5.2 bitset operations\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bitset\x26 operator\x26=(const bitset\x26 __rhs) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bitset\x26 operator\x7c=(const bitset\x26 __rhs) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bitset\x26 operator^=(const bitset\x26 __rhs) _NOEXCEPT;\x0a"
"    bitset\x26 operator<<=(size_t __pos) _NOEXCEPT;\x0a"
"    bitset\x26 operator>>=(size_t __pos) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bitset\x26 set() _NOEXCEPT;\x0a"
"    bitset\x26 set(size_t __pos, bool __val = true);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bitset\x26 reset() _NOEXCEPT;\x0a"
"    bitset\x26 reset(size_t __pos);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bitset  operator\x7e() const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bitset\x26 flip() _NOEXCEPT;\x0a"
"    bitset\x26 flip(size_t __pos);\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"                              const_reference operator\x5b\x5d(size_t __p) const {return base\x3a\x3a__make_ref(__p);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY       reference operator\x5b\x5d(size_t __p)       {return base\x3a\x3a__make_ref(__p);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unsigned long to_ulong() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unsigned long long to_ullong() const;\x0a"
"    template <class _CharT, class _Traits, class _Allocator>\x0a"
"        basic_string<_CharT, _Traits, _Allocator> to_string(_CharT __zero = _CharT('0'),\x0a"
"                                                            _CharT __one = _CharT('1')) const;\x0a"
"    template <class _CharT, class _Traits>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        basic_string<_CharT, _Traits, allocator<_CharT> > to_string(_CharT __zero = _CharT('0'),\x0a"
"                                                                    _CharT __one = _CharT('1')) const;\x0a"
"    template <class _CharT>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        basic_string<_CharT, char_traits<_CharT>, allocator<_CharT> > to_string(_CharT __zero = _CharT('0'),\x0a"
"                                                                                _CharT __one = _CharT('1')) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string<char, char_traits<char>, allocator<char> > to_string(char __zero = '0',\x0a"
"                                                                      char __one = '1') const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t count() const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR size_t size() const _NOEXCEPT {return _Size;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const bitset\x26 __rhs) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const bitset\x26 __rhs) const _NOEXCEPT;\x0a"
"    bool test(size_t __pos) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool all() const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool any() const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool none() const _NOEXCEPT {return \x21""any();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bitset operator<<(size_t __pos) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bitset operator>>(size_t __pos) const _NOEXCEPT;\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t __hash_code() const _NOEXCEPT {return base\x3a\x3a__hash_code();}\x0a"
"\x0a"
"    friend struct hash<bitset>;\x0a"
"};\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"template<class _CharT, class>\x0a"
"bitset<_Size>\x3a\x3a""bitset(const _CharT* __str,\x0a"
"                      typename basic_string<_CharT>\x3a\x3asize_type __n,\x0a"
"                      _CharT __zero, _CharT __one)\x0a"
"{\x0a"
"    size_t __rlen = _VSTD\x3a\x3amin(__n, char_traits<_CharT>\x3a\x3alength(__str));\x0a"
"    for (size_t __i = 0; __i < __rlen; ++__i)\x0a"
"        if (__str\x5b__i\x5d \x21= __zero \x26\x26 __str\x5b__i\x5d \x21= __one)\x0a"
"            __throw_invalid_argument(\x22""bitset string ctor has invalid argument\x22);\x0a"
"\x0a"
"    size_t _Mp = _VSTD\x3a\x3amin(__rlen, _Size);\x0a"
"    size_t __i = 0;\x0a"
"    for (; __i < _Mp; ++__i)\x0a"
"    {\x0a"
"        _CharT __c = __str\x5b_Mp - 1 - __i\x5d;\x0a"
"        if (__c == __zero)\x0a"
"            (*this)\x5b__i\x5d = false;\x0a"
"        else\x0a"
"            (*this)\x5b__i\x5d = true;\x0a"
"    }\x0a"
"    _VSTD\x3a\x3a""fill(base\x3a\x3a__make_iter(__i), base\x3a\x3a__make_iter(_Size), false);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"bitset<_Size>\x3a\x3a""bitset(const basic_string<_CharT,_Traits,_Allocator>\x26 __str,\x0a"
"       typename basic_string<_CharT,_Traits,_Allocator>\x3a\x3asize_type __pos,\x0a"
"       typename basic_string<_CharT,_Traits,_Allocator>\x3a\x3asize_type __n,\x0a"
"       _CharT __zero, _CharT __one)\x0a"
"{\x0a"
"    if (__pos > __str.size())\x0a"
"        __throw_out_of_range(\x22""bitset string pos out of range\x22);\x0a"
"\x0a"
"    size_t __rlen = _VSTD\x3a\x3amin(__n, __str.size() - __pos);\x0a"
"    for (size_t __i = __pos; __i < __pos + __rlen; ++__i)\x0a"
"        if (\x21_Traits\x3a\x3a""eq(__str\x5b__i\x5d, __zero) \x26\x26 \x21_Traits\x3a\x3a""eq(__str\x5b__i\x5d, __one))\x0a"
"            __throw_invalid_argument(\x22""bitset string ctor has invalid argument\x22);\x0a"
"\x0a"
"    size_t _Mp = _VSTD\x3a\x3amin(__rlen, _Size);\x0a"
"    size_t __i = 0;\x0a"
"    for (; __i < _Mp; ++__i)\x0a"
"    {\x0a"
"        _CharT __c = __str\x5b__pos + _Mp - 1 - __i\x5d;\x0a"
"        if (_Traits\x3a\x3a""eq(__c, __zero))\x0a"
"            (*this)\x5b__i\x5d = false;\x0a"
"        else\x0a"
"            (*this)\x5b__i\x5d = true;\x0a"
"    }\x0a"
"    _VSTD\x3a\x3a""fill(base\x3a\x3a__make_iter(__i), base\x3a\x3a__make_iter(_Size), false);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3aoperator\x26=(const bitset\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    base\x3a\x3aoperator\x26=(__rhs);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3aoperator\x7c=(const bitset\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    base\x3a\x3aoperator\x7c=(__rhs);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3aoperator^=(const bitset\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    base\x3a\x3aoperator^=(__rhs);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3aoperator<<=(size_t __pos) _NOEXCEPT\x0a"
"{\x0a"
"    __pos = _VSTD\x3a\x3amin(__pos, _Size);\x0a"
"    _VSTD\x3a\x3a""copy_backward(base\x3a\x3a__make_iter(0), base\x3a\x3a__make_iter(_Size - __pos), base\x3a\x3a__make_iter(_Size));\x0a"
"    _VSTD\x3a\x3a""fill_n(base\x3a\x3a__make_iter(0), __pos, false);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3aoperator>>=(size_t __pos) _NOEXCEPT\x0a"
"{\x0a"
"    __pos = _VSTD\x3a\x3amin(__pos, _Size);\x0a"
"    _VSTD\x3a\x3a""copy(base\x3a\x3a__make_iter(__pos), base\x3a\x3a__make_iter(_Size), base\x3a\x3a__make_iter(0));\x0a"
"    _VSTD\x3a\x3a""fill_n(base\x3a\x3a__make_iter(_Size - __pos), __pos, false);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3aset() _NOEXCEPT\x0a"
"{\x0a"
"    _VSTD\x3a\x3a""fill_n(base\x3a\x3a__make_iter(0), _Size, true);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3aset(size_t __pos, bool __val)\x0a"
"{\x0a"
"    if (__pos >= _Size)\x0a"
"        __throw_out_of_range(\x22""bitset set argument out of range\x22);\x0a"
"\x0a"
"    (*this)\x5b__pos\x5d = __val;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3areset() _NOEXCEPT\x0a"
"{\x0a"
"    _VSTD\x3a\x3a""fill_n(base\x3a\x3a__make_iter(0), _Size, false);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3areset(size_t __pos)\x0a"
"{\x0a"
"    if (__pos >= _Size)\x0a"
"        __throw_out_of_range(\x22""bitset reset argument out of range\x22);\x0a"
"\x0a"
"    (*this)\x5b__pos\x5d = false;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bitset<_Size>\x0a"
"bitset<_Size>\x3a\x3aoperator\x7e() const _NOEXCEPT\x0a"
"{\x0a"
"    bitset __x(*this);\x0a"
"    __x.flip();\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3a""flip() _NOEXCEPT\x0a"
"{\x0a"
"    base\x3a\x3a""flip();\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"bitset<_Size>\x26\x0a"
"bitset<_Size>\x3a\x3a""flip(size_t __pos)\x0a"
"{\x0a"
"    if (__pos >= _Size)\x0a"
"        __throw_out_of_range(\x22""bitset flip argument out of range\x22);\x0a"
"\x0a"
"    reference r = base\x3a\x3a__make_ref(__pos);\x0a"
"    r = \x7er;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"unsigned long\x0a"
"bitset<_Size>\x3a\x3ato_ulong() const\x0a"
"{\x0a"
"    return base\x3a\x3ato_ulong();\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"unsigned long long\x0a"
"bitset<_Size>\x3a\x3ato_ullong() const\x0a"
"{\x0a"
"    return base\x3a\x3ato_ullong();\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"bitset<_Size>\x3a\x3ato_string(_CharT __zero, _CharT __one) const\x0a"
"{\x0a"
"    basic_string<_CharT, _Traits, _Allocator> __r(_Size, __zero);\x0a"
"    for (size_t __i = 0; __i < _Size; ++__i)\x0a"
"    {\x0a"
"        if ((*this)\x5b__i\x5d)\x0a"
"            __r\x5b_Size - 1 - __i\x5d = __one;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, allocator<_CharT> >\x0a"
"bitset<_Size>\x3a\x3ato_string(_CharT __zero, _CharT __one) const\x0a"
"{\x0a"
"    return to_string<_CharT, _Traits, allocator<_CharT> >(__zero, __one);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"template <class _CharT>\x0a"
"inline\x0a"
"basic_string<_CharT, char_traits<_CharT>, allocator<_CharT> >\x0a"
"bitset<_Size>\x3a\x3ato_string(_CharT __zero, _CharT __one) const\x0a"
"{\x0a"
"    return to_string<_CharT, char_traits<_CharT>, allocator<_CharT> >(__zero, __one);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"basic_string<char, char_traits<char>, allocator<char> >\x0a"
"bitset<_Size>\x3a\x3ato_string(char __zero, char __one) const\x0a"
"{\x0a"
"    return to_string<char, char_traits<char>, allocator<char> >(__zero, __one);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"size_t\x0a"
"bitset<_Size>\x3a\x3a""count() const _NOEXCEPT\x0a"
"{\x0a"
"    return static_cast<size_t>(__count_bool_true(base\x3a\x3a__make_iter(0), _Size));\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bool\x0a"
"bitset<_Size>\x3a\x3aoperator==(const bitset\x26 __rhs) const _NOEXCEPT\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""equal(base\x3a\x3a__make_iter(0), base\x3a\x3a__make_iter(_Size), __rhs.__make_iter(0));\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bool\x0a"
"bitset<_Size>\x3a\x3aoperator\x21=(const bitset\x26 __rhs) const _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(*this == __rhs);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"bool\x0a"
"bitset<_Size>\x3a\x3atest(size_t __pos) const\x0a"
"{\x0a"
"    if (__pos >= _Size)\x0a"
"        __throw_out_of_range(\x22""bitset test argument out of range\x22);\x0a"
"\x0a"
"    return (*this)\x5b__pos\x5d;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bool\x0a"
"bitset<_Size>\x3a\x3a""all() const _NOEXCEPT\x0a"
"{\x0a"
"    return base\x3a\x3a""all();\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bool\x0a"
"bitset<_Size>\x3a\x3a""any() const _NOEXCEPT\x0a"
"{\x0a"
"    return base\x3a\x3a""any();\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bitset<_Size>\x0a"
"bitset<_Size>\x3a\x3aoperator<<(size_t __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    bitset __r = *this;\x0a"
"    __r <<= __pos;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline\x0a"
"bitset<_Size>\x0a"
"bitset<_Size>\x3a\x3aoperator>>(size_t __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    bitset __r = *this;\x0a"
"    __r >>= __pos;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bitset<_Size>\x0a"
"operator\x26(const bitset<_Size>\x26 __x, const bitset<_Size>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    bitset<_Size> __r = __x;\x0a"
"    __r \x26= __y;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bitset<_Size>\x0a"
"operator\x7c(const bitset<_Size>\x26 __x, const bitset<_Size>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    bitset<_Size> __r = __x;\x0a"
"    __r \x7c= __y;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bitset<_Size>\x0a"
"operator^(const bitset<_Size>\x26 __x, const bitset<_Size>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    bitset<_Size> __r = __x;\x0a"
"    __r ^= __y;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<bitset<_Size> >\x0a"
"    \x3a public unary_function<bitset<_Size>, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const bitset<_Size>\x26 __bs) const _NOEXCEPT\x0a"
"        {return __bs.__hash_code();}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, size_t _Size>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, bitset<_Size>\x26 __x);\x0a"
"\x0a"
"template <class _CharT, class _Traits, size_t _Size>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const bitset<_Size>\x26 __x);\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_BITSET\x0a"
"", 33794 ); }