#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_charconv( 
"// -*- C++ -*-\x0a"
"//===------------------------------ charconv ------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_CHARCONV\x0a"
"#define _LIBCPP_CHARCONV\x0a"
"\x0a"
"/*\x0a"
"    charconv synopsis\x0a"
"\x0a"
"namespace std {\x0a"
"\x0a"
"  // floating-point format for primitive numerical conversion\x0a"
"  enum class chars_format {\x0a"
"    scientific = unspecified,\x0a"
"    fixed = unspecified,\x0a"
"    hex = unspecified,\x0a"
"    general = fixed \x7c scientific\x0a"
"  };\x0a"
"\x0a"
"  // 23.20.2, primitive numerical output conversion\x0a"
"  struct to_chars_result {\x0a"
"    char* ptr;\x0a"
"    errc ec;\x0a"
"  };\x0a"
"\x0a"
"  to_chars_result to_chars(char* first, char* last, see below value,\x0a"
"                           int base = 10);\x0a"
"\x0a"
"  to_chars_result to_chars(char* first, char* last, float value);\x0a"
"  to_chars_result to_chars(char* first, char* last, double value);\x0a"
"  to_chars_result to_chars(char* first, char* last, long double value);\x0a"
"\x0a"
"  to_chars_result to_chars(char* first, char* last, float value,\x0a"
"                           chars_format fmt);\x0a"
"  to_chars_result to_chars(char* first, char* last, double value,\x0a"
"                           chars_format fmt);\x0a"
"  to_chars_result to_chars(char* first, char* last, long double value,\x0a"
"                           chars_format fmt);\x0a"
"\x0a"
"  to_chars_result to_chars(char* first, char* last, float value,\x0a"
"                           chars_format fmt, int precision);\x0a"
"  to_chars_result to_chars(char* first, char* last, double value,\x0a"
"                           chars_format fmt, int precision);\x0a"
"  to_chars_result to_chars(char* first, char* last, long double value,\x0a"
"                           chars_format fmt, int precision);\x0a"
"\x0a"
"  // 23.20.3, primitive numerical input conversion\x0a"
"  struct from_chars_result {\x0a"
"    const char* ptr;\x0a"
"    errc ec;\x0a"
"  };\x0a"
"\x0a"
"  from_chars_result from_chars(const char* first, const char* last,\x0a"
"                               see below\x26 value, int base = 10);\x0a"
"\x0a"
"  from_chars_result from_chars(const char* first, const char* last,\x0a"
"                               float\x26 value,\x0a"
"                               chars_format fmt = chars_format\x3a\x3ageneral);\x0a"
"  from_chars_result from_chars(const char* first, const char* last,\x0a"
"                               double\x26 value,\x0a"
"                               chars_format fmt = chars_format\x3a\x3ageneral);\x0a"
"  from_chars_result from_chars(const char* first, const char* last,\x0a"
"                               long double\x26 value,\x0a"
"                               chars_format fmt = chars_format\x3a\x3ageneral);\x0a"
"\x0a"
"} // namespace std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__errc>\x0a"
"#include <type_traits>\x0a"
"#include <limits>\x0a"
"#include <stdint.h>\x0a"
"#include <string.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"namespace __itoa {\x0a"
"_LIBCPP_FUNC_VIS char* __u64toa(uint64_t __value, char* __buffer);\x0a"
"_LIBCPP_FUNC_VIS char* __u32toa(uint32_t __value, char* __buffer);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"enum class _LIBCPP_ENUM_VIS chars_format\x0a"
"{\x0a"
"    scientific = 0x1,\x0a"
"    fixed = 0x2,\x0a"
"    hex = 0x4,\x0a"
"    general = fixed \x7c scientific\x0a"
"};\x0a"
"\x0a"
"struct _LIBCPP_TYPE_VIS to_chars_result\x0a"
"{\x0a"
"    char* ptr;\x0a"
"    errc ec;\x0a"
"};\x0a"
"\x0a"
"struct _LIBCPP_TYPE_VIS from_chars_result\x0a"
"{\x0a"
"    const char* ptr;\x0a"
"    errc ec;\x0a"
"};\x0a"
"\x0a"
"void to_chars(char*, char*, bool, int = 10) = delete;\x0a"
"void from_chars(const char*, const char*, bool, int = 10) = delete;\x0a"
"\x0a"
"namespace __itoa\x0a"
"{\x0a"
"\x0a"
"static _LIBCPP_CONSTEXPR uint64_t __pow10_64\x5b\x5d = {\x0a"
"    UINT64_C(0),\x0a"
"    UINT64_C(10),\x0a"
"    UINT64_C(100),\x0a"
"    UINT64_C(1000),\x0a"
"    UINT64_C(10000),\x0a"
"    UINT64_C(100000),\x0a"
"    UINT64_C(1000000),\x0a"
"    UINT64_C(10000000),\x0a"
"    UINT64_C(100000000),\x0a"
"    UINT64_C(1000000000),\x0a"
"    UINT64_C(10000000000),\x0a"
"    UINT64_C(100000000000),\x0a"
"    UINT64_C(1000000000000),\x0a"
"    UINT64_C(10000000000000),\x0a"
"    UINT64_C(100000000000000),\x0a"
"    UINT64_C(1000000000000000),\x0a"
"    UINT64_C(10000000000000000),\x0a"
"    UINT64_C(100000000000000000),\x0a"
"    UINT64_C(1000000000000000000),\x0a"
"    UINT64_C(10000000000000000000),\x0a"
"};\x0a"
"\x0a"
"static _LIBCPP_CONSTEXPR uint32_t __pow10_32\x5b\x5d = {\x0a"
"    UINT32_C(0),          UINT32_C(10),       UINT32_C(100),\x0a"
"    UINT32_C(1000),       UINT32_C(10000),    UINT32_C(100000),\x0a"
"    UINT32_C(1000000),    UINT32_C(10000000), UINT32_C(100000000),\x0a"
"    UINT32_C(1000000000),\x0a"
"};\x0a"
"\x0a"
"template <typename _Tp, typename = void>\x0a"
"struct _LIBCPP_HIDDEN __traits_base\x0a"
"{\x0a"
"    using type = uint64_t;\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_COMPILER_MSVC)\x0a"
"    static _LIBCPP_INLINE_VISIBILITY int __width(_Tp __v)\x0a"
"    {\x0a"
"        auto __t = (64 - __builtin_clzll(__v \x7c 1)) * 1233 >> 12;\x0a"
"        return __t - (__v < __pow10_64\x5b__t\x5d) + 1;\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    static _LIBCPP_INLINE_VISIBILITY char* __convert(_Tp __v, char* __p)\x0a"
"    {\x0a"
"        return __u64toa(__v, __p);\x0a"
"    }\x0a"
"\x0a"
"    static _LIBCPP_INLINE_VISIBILITY decltype(__pow10_64)\x26 __pow() { return __pow10_64; }\x0a"
"};\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"struct _LIBCPP_HIDDEN\x0a"
"    __traits_base<_Tp, decltype(void(uint32_t{declval<_Tp>()}))>\x0a"
"{\x0a"
"    using type = uint32_t;\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_COMPILER_MSVC)\x0a"
"    static _LIBCPP_INLINE_VISIBILITY int __width(_Tp __v)\x0a"
"    {\x0a"
"        auto __t = (32 - __builtin_clz(__v \x7c 1)) * 1233 >> 12;\x0a"
"        return __t - (__v < __pow10_32\x5b__t\x5d) + 1;\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    static _LIBCPP_INLINE_VISIBILITY char* __convert(_Tp __v, char* __p)\x0a"
"    {\x0a"
"        return __u32toa(__v, __p);\x0a"
"    }\x0a"
"\x0a"
"    static _LIBCPP_INLINE_VISIBILITY decltype(__pow10_32)\x26 __pow() { return __pow10_32; }\x0a"
"};\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"__mul_overflowed(unsigned char __a, _Tp __b, unsigned char\x26 __r)\x0a"
"{\x0a"
"    auto __c = __a * __b;\x0a"
"    __r = __c;\x0a"
"    return __c > (numeric_limits<unsigned char>\x3a\x3amax)();\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"__mul_overflowed(unsigned short __a, _Tp __b, unsigned short\x26 __r)\x0a"
"{\x0a"
"    auto __c = __a * __b;\x0a"
"    __r = __c;\x0a"
"    return __c > (numeric_limits<unsigned short>\x3a\x3amax)();\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"__mul_overflowed(_Tp __a, _Tp __b, _Tp\x26 __r)\x0a"
"{\x0a"
"    static_assert(is_unsigned<_Tp>\x3a\x3avalue, \x22\x22);\x0a"
"#if \x21""defined(_LIBCPP_COMPILER_MSVC)\x0a"
"    return __builtin_mul_overflow(__a, __b, \x26__r);\x0a"
"#else\x0a"
"    bool __did = __b \x26\x26 ((numeric_limits<_Tp>\x3a\x3amax)() / __b) < __a;\x0a"
"    __r = __a * __b;\x0a"
"    return __did;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"__mul_overflowed(_Tp __a, _Up __b, _Tp\x26 __r)\x0a"
"{\x0a"
"    return __mul_overflowed(__a, static_cast<_Tp>(__b), __r);\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"struct _LIBCPP_HIDDEN __traits \x3a __traits_base<_Tp>\x0a"
"{\x0a"
"    static _LIBCPP_CONSTEXPR int digits = numeric_limits<_Tp>\x3a\x3a""digits10 + 1;\x0a"
"    using __traits_base<_Tp>\x3a\x3a__pow;\x0a"
"    using typename __traits_base<_Tp>\x3a\x3atype;\x0a"
"\x0a"
"    // precondition\x3a at least one non-zero character available\x0a"
"    static _LIBCPP_INLINE_VISIBILITY char const*\x0a"
"    __read(char const* __p, char const* __ep, type\x26 __a, type\x26 __b)\x0a"
"    {\x0a"
"        type __cprod\x5b""digits\x5d;\x0a"
"        int __j = digits - 1;\x0a"
"        int __i = digits;\x0a"
"        do\x0a"
"        {\x0a"
"            if (\x21('0' <= *__p \x26\x26 *__p <= '9'))\x0a"
"                break;\x0a"
"            __cprod\x5b--__i\x5d = *__p++ - '0';\x0a"
"        } while (__p \x21= __ep \x26\x26 __i \x21= 0);\x0a"
"\x0a"
"        __a = __inner_product(__cprod + __i + 1, __cprod + __j, __pow() + 1,\x0a"
"                              __cprod\x5b__i\x5d);\x0a"
"        if (__mul_overflowed(__cprod\x5b__j\x5d, __pow()\x5b__j - __i\x5d, __b))\x0a"
"            --__p;\x0a"
"        return __p;\x0a"
"    }\x0a"
"\x0a"
"    template <typename _It1, typename _It2, class _Up>\x0a"
"    static _LIBCPP_INLINE_VISIBILITY _Up\x0a"
"    __inner_product(_It1 __first1, _It1 __last1, _It2 __first2, _Up __init)\x0a"
"    {\x0a"
"        for (; __first1 < __last1; ++__first1, ++__first2)\x0a"
"            __init = __init + *__first1 * *__first2;\x0a"
"        return __init;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"}  // namespace __itoa\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _Tp\x0a"
"__complement(_Tp __x)\x0a"
"{\x0a"
"    static_assert(is_unsigned<_Tp>\x3a\x3avalue, \x22""cast to unsigned first\x22);\x0a"
"    return _Tp(\x7e__x + 1);\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY typename make_unsigned<_Tp>\x3a\x3atype\x0a"
"__to_unsigned(_Tp __x)\x0a"
"{\x0a"
"    return static_cast<typename make_unsigned<_Tp>\x3a\x3atype>(__x);\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY to_chars_result\x0a"
"__to_chars_itoa(char* __first, char* __last, _Tp __value, true_type)\x0a"
"{\x0a"
"    auto __x = __to_unsigned(__value);\x0a"
"    if (__value < 0 \x26\x26 __first \x21= __last)\x0a"
"    {\x0a"
"        *__first++ = '-';\x0a"
"        __x = __complement(__x);\x0a"
"    }\x0a"
"\x0a"
"    return __to_chars_itoa(__first, __last, __x, false_type());\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY to_chars_result\x0a"
"__to_chars_itoa(char* __first, char* __last, _Tp __value, false_type)\x0a"
"{\x0a"
"    using __tx = __itoa\x3a\x3a__traits<_Tp>;\x0a"
"    auto __diff = __last - __first;\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_COMPILER_MSVC)\x0a"
"    if (__tx\x3a\x3a""digits <= __diff \x7c\x7c __tx\x3a\x3a__width(__value) <= __diff)\x0a"
"        return {__tx\x3a\x3a__convert(__value, __first), errc(0)};\x0a"
"    else\x0a"
"        return {__last, errc\x3a\x3avalue_too_large};\x0a"
"#else\x0a"
"    if (__tx\x3a\x3a""digits <= __diff)\x0a"
"        return {__tx\x3a\x3a__convert(__value, __first), {}};\x0a"
"    else\x0a"
"    {\x0a"
"        char __buf\x5b__tx\x3a\x3a""digits\x5d;\x0a"
"        auto __p = __tx\x3a\x3a__convert(__value, __buf);\x0a"
"        auto __len = __p - __buf;\x0a"
"        if (__len <= __diff)\x0a"
"        {\x0a"
"            memcpy(__first, __buf, __len);\x0a"
"            return {__first + __len, {}};\x0a"
"        }\x0a"
"        else\x0a"
"            return {__last, errc\x3a\x3avalue_too_large};\x0a"
"    }\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY to_chars_result\x0a"
"__to_chars_integral(char* __first, char* __last, _Tp __value, int __base,\x0a"
"                    true_type)\x0a"
"{\x0a"
"    auto __x = __to_unsigned(__value);\x0a"
"    if (__value < 0 \x26\x26 __first \x21= __last)\x0a"
"    {\x0a"
"        *__first++ = '-';\x0a"
"        __x = __complement(__x);\x0a"
"    }\x0a"
"\x0a"
"    return __to_chars_integral(__first, __last, __x, __base, false_type());\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY to_chars_result\x0a"
"__to_chars_integral(char* __first, char* __last, _Tp __value, int __base,\x0a"
"                    false_type)\x0a"
"{\x0a"
"    if (__base == 10)\x0a"
"        return __to_chars_itoa(__first, __last, __value, false_type());\x0a"
"\x0a"
"    auto __p = __last;\x0a"
"    while (__p \x21= __first)\x0a"
"    {\x0a"
"        auto __c = __value \x25 __base;\x0a"
"        __value /= __base;\x0a"
"        *--__p = \x22""0123456789abcdefghijklmnopqrstuvwxyz\x22\x5b__c\x5d;\x0a"
"        if (__value == 0)\x0a"
"            break;\x0a"
"    }\x0a"
"\x0a"
"    auto __len = __last - __p;\x0a"
"    if (__value \x21= 0 \x7c\x7c \x21__len)\x0a"
"        return {__last, errc\x3a\x3avalue_too_large};\x0a"
"    else\x0a"
"    {\x0a"
"        memmove(__first, __p, __len);\x0a"
"        return {__first + __len, {}};\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename enable_if<is_integral<_Tp>\x3a\x3avalue, int>\x3a\x3atype = 0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY to_chars_result\x0a"
"to_chars(char* __first, char* __last, _Tp __value)\x0a"
"{\x0a"
"    return __to_chars_itoa(__first, __last, __value, is_signed<_Tp>());\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename enable_if<is_integral<_Tp>\x3a\x3avalue, int>\x3a\x3atype = 0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY to_chars_result\x0a"
"to_chars(char* __first, char* __last, _Tp __value, int __base)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(2 <= __base \x26\x26 __base <= 36, \x22""base not in \x5b""2, 36\x5d\x22);\x0a"
"    return __to_chars_integral(__first, __last, __value, __base,\x0a"
"                               is_signed<_Tp>());\x0a"
"}\x0a"
"\x0a"
"template <typename _It, typename _Tp, typename _Fn, typename... _Ts>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY from_chars_result\x0a"
"__sign_combinator(_It __first, _It __last, _Tp\x26 __value, _Fn __f, _Ts... __args)\x0a"
"{\x0a"
"    using __tl = numeric_limits<_Tp>;\x0a"
"    decltype(__to_unsigned(__value)) __x;\x0a"
"\x0a"
"    bool __neg = (__first \x21= __last \x26\x26 *__first == '-');\x0a"
"    auto __r = __f(__neg \x3f __first + 1 \x3a __first, __last, __x, __args...);\x0a"
"    switch (__r.ec)\x0a"
"    {\x0a"
"    case errc\x3a\x3ainvalid_argument\x3a\x0a"
"        return {__first, __r.ec};\x0a"
"    case errc\x3a\x3aresult_out_of_range\x3a\x0a"
"        return __r;\x0a"
"    default\x3a\x0a"
"        break;\x0a"
"    }\x0a"
"\x0a"
"    if (__neg)\x0a"
"    {\x0a"
"        if (__x <= __complement(__to_unsigned(__tl\x3a\x3amin())))\x0a"
"        {\x0a"
"            __x = __complement(__x);\x0a"
"            memcpy(\x26__value, \x26__x, sizeof(__x));\x0a"
"            return __r;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        if (__x <= (__tl\x3a\x3amax)())\x0a"
"        {\x0a"
"            __value = __x;\x0a"
"            return __r;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    return {__r.ptr, errc\x3a\x3aresult_out_of_range};\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"__in_pattern(_Tp __c)\x0a"
"{\x0a"
"    return '0' <= __c \x26\x26 __c <= '9';\x0a"
"}\x0a"
"\x0a"
"struct _LIBCPP_HIDDEN __in_pattern_result\x0a"
"{\x0a"
"    bool __ok;\x0a"
"    int __val;\x0a"
"\x0a"
"    explicit _LIBCPP_INLINE_VISIBILITY operator bool() const { return __ok; }\x0a"
"};\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY __in_pattern_result\x0a"
"__in_pattern(_Tp __c, int __base)\x0a"
"{\x0a"
"    if (__base <= 10)\x0a"
"        return {'0' <= __c \x26\x26 __c < '0' + __base, __c - '0'};\x0a"
"    else if (__in_pattern(__c))\x0a"
"        return {true, __c - '0'};\x0a"
"    else if ('a' <= __c \x26\x26 __c < 'a' + __base - 10)\x0a"
"        return {true, __c - 'a' + 10};\x0a"
"    else\x0a"
"        return {'A' <= __c \x26\x26 __c < 'A' + __base - 10, __c - 'A' + 10};\x0a"
"}\x0a"
"\x0a"
"template <typename _It, typename _Tp, typename _Fn, typename... _Ts>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY from_chars_result\x0a"
"__subject_seq_combinator(_It __first, _It __last, _Tp\x26 __value, _Fn __f,\x0a"
"                         _Ts... __args)\x0a"
"{\x0a"
"    auto __find_non_zero = \x5b\x5d(_It __first, _It __last) {\x0a"
"        for (; __first \x21= __last; ++__first)\x0a"
"            if (*__first \x21= '0')\x0a"
"                break;\x0a"
"        return __first;\x0a"
"    };\x0a"
"\x0a"
"    auto __p = __find_non_zero(__first, __last);\x0a"
"    if (__p == __last \x7c\x7c \x21__in_pattern(*__p, __args...))\x0a"
"    {\x0a"
"        if (__p == __first)\x0a"
"            return {__first, errc\x3a\x3ainvalid_argument};\x0a"
"        else\x0a"
"        {\x0a"
"            __value = 0;\x0a"
"            return {__p, {}};\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    auto __r = __f(__p, __last, __value, __args...);\x0a"
"    if (__r.ec == errc\x3a\x3aresult_out_of_range)\x0a"
"    {\x0a"
"        for (; __r.ptr \x21= __last; ++__r.ptr)\x0a"
"        {\x0a"
"            if (\x21__in_pattern(*__r.ptr, __args...))\x0a"
"                break;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename enable_if<is_unsigned<_Tp>\x3a\x3avalue, int>\x3a\x3atype = 0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY from_chars_result\x0a"
"__from_chars_atoi(const char* __first, const char* __last, _Tp\x26 __value)\x0a"
"{\x0a"
"    using __tx = __itoa\x3a\x3a__traits<_Tp>;\x0a"
"    using __output_type = typename __tx\x3a\x3atype;\x0a"
"\x0a"
"    return __subject_seq_combinator(\x0a"
"        __first, __last, __value,\x0a"
"        \x5b\x5d(const char* __first, const char* __last,\x0a"
"           _Tp\x26 __value) -> from_chars_result {\x0a"
"            __output_type __a, __b;\x0a"
"            auto __p = __tx\x3a\x3a__read(__first, __last, __a, __b);\x0a"
"            if (__p == __last \x7c\x7c \x21__in_pattern(*__p))\x0a"
"            {\x0a"
"                __output_type __m = (numeric_limits<_Tp>\x3a\x3amax)();\x0a"
"                if (__m >= __a \x26\x26 __m - __a >= __b)\x0a"
"                {\x0a"
"                    __value = __a + __b;\x0a"
"                    return {__p, {}};\x0a"
"                }\x0a"
"            }\x0a"
"            return {__p, errc\x3a\x3aresult_out_of_range};\x0a"
"        });\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename enable_if<is_signed<_Tp>\x3a\x3avalue, int>\x3a\x3atype = 0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY from_chars_result\x0a"
"__from_chars_atoi(const char* __first, const char* __last, _Tp\x26 __value)\x0a"
"{\x0a"
"    using __t = decltype(__to_unsigned(__value));\x0a"
"    return __sign_combinator(__first, __last, __value, __from_chars_atoi<__t>);\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename enable_if<is_unsigned<_Tp>\x3a\x3avalue, int>\x3a\x3atype = 0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY from_chars_result\x0a"
"__from_chars_integral(const char* __first, const char* __last, _Tp\x26 __value,\x0a"
"                      int __base)\x0a"
"{\x0a"
"    if (__base == 10)\x0a"
"        return __from_chars_atoi(__first, __last, __value);\x0a"
"\x0a"
"    return __subject_seq_combinator(\x0a"
"        __first, __last, __value,\x0a"
"        \x5b\x5d(const char* __p, const char* __last, _Tp\x26 __value,\x0a"
"           int __base) -> from_chars_result {\x0a"
"            using __tl = numeric_limits<_Tp>;\x0a"
"            auto __digits = __tl\x3a\x3a""digits / log2f(float(__base));\x0a"
"            _Tp __a = __in_pattern(*__p++, __base).__val, __b = 0;\x0a"
"\x0a"
"            for (int __i = 1; __p \x21= __last; ++__i, ++__p)\x0a"
"            {\x0a"
"                if (auto __c = __in_pattern(*__p, __base))\x0a"
"                {\x0a"
"                    if (__i < __digits - 1)\x0a"
"                        __a = __a * __base + __c.__val;\x0a"
"                    else\x0a"
"                    {\x0a"
"                        if (\x21__itoa\x3a\x3a__mul_overflowed(__a, __base, __a))\x0a"
"                            ++__p;\x0a"
"                        __b = __c.__val;\x0a"
"                        break;\x0a"
"                    }\x0a"
"                }\x0a"
"                else\x0a"
"                    break;\x0a"
"            }\x0a"
"\x0a"
"            if (__p == __last \x7c\x7c \x21__in_pattern(*__p, __base))\x0a"
"            {\x0a"
"                if ((__tl\x3a\x3amax)() - __a >= __b)\x0a"
"                {\x0a"
"                    __value = __a + __b;\x0a"
"                    return {__p, {}};\x0a"
"                }\x0a"
"            }\x0a"
"            return {__p, errc\x3a\x3aresult_out_of_range};\x0a"
"        },\x0a"
"        __base);\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename enable_if<is_signed<_Tp>\x3a\x3avalue, int>\x3a\x3atype = 0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY from_chars_result\x0a"
"__from_chars_integral(const char* __first, const char* __last, _Tp\x26 __value,\x0a"
"                      int __base)\x0a"
"{\x0a"
"    using __t = decltype(__to_unsigned(__value));\x0a"
"    return __sign_combinator(__first, __last, __value,\x0a"
"                             __from_chars_integral<__t>, __base);\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename enable_if<is_integral<_Tp>\x3a\x3avalue, int>\x3a\x3atype = 0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY from_chars_result\x0a"
"from_chars(const char* __first, const char* __last, _Tp\x26 __value)\x0a"
"{\x0a"
"    return __from_chars_atoi(__first, __last, __value);\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp, typename enable_if<is_integral<_Tp>\x3a\x3avalue, int>\x3a\x3atype = 0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY from_chars_result\x0a"
"from_chars(const char* __first, const char* __last, _Tp\x26 __value, int __base)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(2 <= __base \x26\x26 __base <= 36, \x22""base not in \x5b""2, 36\x5d\x22);\x0a"
"    return __from_chars_integral(__first, __last, __value, __base);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_CHARCONV\x0a"
"", 18037 ); }