#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_chrono( 
"// -*- C++ -*-\x0a"
"//===---------------------------- chrono ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_CHRONO\x0a"
"#define _LIBCPP_CHRONO\x0a"
"\x0a"
"/*\x0a"
"    chrono synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"namespace chrono\x0a"
"{\x0a"
"\x0a"
"template <class ToDuration, class Rep, class Period>\x0a"
"constexpr\x0a"
"ToDuration\x0a"
"duration_cast(const duration<Rep, Period>\x26 fd);\x0a"
"\x0a"
"template <class Rep> struct treat_as_floating_point \x3a is_floating_point<Rep> {};\x0a"
"\x0a"
"template <class Rep> inline constexpr bool treat_as_floating_point_v\x0a"
"    = treat_as_floating_point<Rep>\x3a\x3avalue;                       // C++17\x0a"
"\x0a"
"template <class Rep>\x0a"
"struct duration_values\x0a"
"{\x0a"
"public\x3a\x0a"
"    static constexpr Rep zero(); // noexcept in C++20\x0a"
"    static constexpr Rep max();  // noexcept in C++20\x0a"
"    static constexpr Rep min();  // noexcept in C++20\x0a"
"};\x0a"
"\x0a"
"// duration\x0a"
"\x0a"
"template <class Rep, class Period = ratio<1>>\x0a"
"class duration\x0a"
"{\x0a"
"    static_assert(\x21__is_duration<Rep>\x3a\x3avalue, \x22""A duration representation can not be a duration\x22);\x0a"
"    static_assert(__is_ratio<Period>\x3a\x3avalue, \x22Second template parameter of duration must be a std\x3a\x3aratio\x22);\x0a"
"    static_assert(Period\x3a\x3anum > 0, \x22""duration period must be positive\x22);\x0a"
"public\x3a\x0a"
"    typedef Rep rep;\x0a"
"    typedef typename _Period\x3a\x3atype period;\x0a"
"\x0a"
"    constexpr duration() = default;\x0a"
"    template <class Rep2>\x0a"
"        constexpr explicit duration(const Rep2\x26 r,\x0a"
"            typename enable_if\x0a"
"            <\x0a"
"               is_convertible<Rep2, rep>\x3a\x3avalue \x26\x26\x0a"
"               (treat_as_floating_point<rep>\x3a\x3avalue \x7c\x7c\x0a"
"               \x21treat_as_floating_point<rep>\x3a\x3avalue \x26\x26 \x21treat_as_floating_point<Rep2>\x3a\x3avalue)\x0a"
"            >\x3a\x3atype* = 0);\x0a"
"\x0a"
"    // conversions\x0a"
"    template <class Rep2, class Period2>\x0a"
"        constexpr duration(const duration<Rep2, Period2>\x26 d,\x0a"
"            typename enable_if\x0a"
"            <\x0a"
"                treat_as_floating_point<rep>\x3a\x3avalue \x7c\x7c\x0a"
"                ratio_divide<Period2, period>\x3a\x3atype\x3a\x3a""den == 1\x0a"
"            >\x3a\x3atype* = 0);\x0a"
"\x0a"
"    // observer\x0a"
"\x0a"
"    constexpr rep count() const;\x0a"
"\x0a"
"    // arithmetic\x0a"
"\x0a"
"    constexpr common_type<duration>\x3a\x3atype  operator+() const;\x0a"
"    constexpr common_type<duration>\x3a\x3atype  operator-() const;\x0a"
"    constexpr duration\x26 operator++();    // constexpr in C++17\x0a"
"    constexpr duration  operator++(int); // constexpr in C++17\x0a"
"    constexpr duration\x26 operator--();    // constexpr in C++17\x0a"
"    constexpr duration  operator--(int); // constexpr in C++17\x0a"
"\x0a"
"    constexpr duration\x26 operator+=(const duration\x26 d);  // constexpr in C++17\x0a"
"    constexpr duration\x26 operator-=(const duration\x26 d);  // constexpr in C++17\x0a"
"\x0a"
"    duration\x26 operator*=(const rep\x26 rhs);       // constexpr in C++17\x0a"
"    duration\x26 operator/=(const rep\x26 rhs);       // constexpr in C++17\x0a"
"    duration\x26 operator\x25=(const rep\x26 rhs);       // constexpr in C++17\x0a"
"    duration\x26 operator\x25=(const duration\x26 rhs);  // constexpr in C++17\x0a"
"\x0a"
"    // special values\x0a"
"\x0a"
"    static constexpr duration zero(); // noexcept in C++20\x0a"
"    static constexpr duration min();  // noexcept in C++20\x0a"
"    static constexpr duration max();  // noexcept in C++20\x0a"
"};\x0a"
"\x0a"
"typedef duration<long long,         nano> nanoseconds;\x0a"
"typedef duration<long long,        micro> microseconds;\x0a"
"typedef duration<long long,        milli> milliseconds;\x0a"
"typedef duration<long long              > seconds;\x0a"
"typedef duration<     long, ratio<  60> > minutes;\x0a"
"typedef duration<     long, ratio<3600> > hours;\x0a"
"\x0a"
"template <class Clock, class Duration = typename Clock\x3a\x3a""duration>\x0a"
"class time_point\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef Clock                     clock;\x0a"
"    typedef Duration                  duration;\x0a"
"    typedef typename duration\x3a\x3arep    rep;\x0a"
"    typedef typename duration\x3a\x3aperiod period;\x0a"
"private\x3a\x0a"
"    duration d_;  // exposition only\x0a"
"\x0a"
"public\x3a\x0a"
"    time_point();  // has value \x22""epoch\x22 // constexpr in C++14\x0a"
"    explicit time_point(const duration\x26 d);  // same as time_point() + d // constexpr in C++14\x0a"
"\x0a"
"    // conversions\x0a"
"    template <class Duration2>\x0a"
"       time_point(const time_point<clock, Duration2>\x26 t); // constexpr in C++14\x0a"
"\x0a"
"    // observer\x0a"
"\x0a"
"    duration time_since_epoch() const; // constexpr in C++14\x0a"
"\x0a"
"    // arithmetic\x0a"
"\x0a"
"    time_point\x26 operator+=(const duration\x26 d); // constexpr in C++17\x0a"
"    time_point\x26 operator-=(const duration\x26 d); // constexpr in C++17\x0a"
"\x0a"
"    // special values\x0a"
"\x0a"
"    static constexpr time_point min();  // noexcept in C++20\x0a"
"    static constexpr time_point max();  // noexcept in C++20\x0a"
"};\x0a"
"\x0a"
"} // chrono\x0a"
"\x0a"
"// common_type traits\x0a"
"template <class Rep1, class Period1, class Rep2, class Period2>\x0a"
"  struct common_type<chrono\x3a\x3a""duration<Rep1, Period1>, chrono\x3a\x3a""duration<Rep2, Period2>>;\x0a"
"\x0a"
"template <class Clock, class Duration1, class Duration2>\x0a"
"  struct common_type<chrono\x3a\x3atime_point<Clock, Duration1>, chrono\x3a\x3atime_point<Clock, Duration2>>;\x0a"
"\x0a"
"namespace chrono {\x0a"
"\x0a"
"\x0a"
"template<class T> struct is_clock;  // C++20\x0a"
"template<class T> inline constexpr bool is_clock_v = is_clock<T>\x3a\x3avalue;   // C++20\x0a"
"\x0a"
"\x0a"
"// duration arithmetic\x0a"
"template <class Rep1, class Period1, class Rep2, class Period2>\x0a"
"  constexpr\x0a"
"  typename common_type<duration<Rep1, Period1>, duration<Rep2, Period2>>\x3a\x3atype\x0a"
"  operator+(const duration<Rep1, Period1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"template <class Rep1, class Period1, class Rep2, class Period2>\x0a"
"  constexpr\x0a"
"  typename common_type<duration<Rep1, Period1>, duration<Rep2, Period2>>\x3a\x3atype\x0a"
"  operator-(const duration<Rep1, Period1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"template <class Rep1, class Period, class Rep2>\x0a"
"  constexpr\x0a"
"  duration<typename common_type<Rep1, Rep2>\x3a\x3atype, Period>\x0a"
"  operator*(const duration<Rep1, Period>\x26 d, const Rep2\x26 s);\x0a"
"template <class Rep1, class Period, class Rep2>\x0a"
"  constexpr\x0a"
"  duration<typename common_type<Rep1, Rep2>\x3a\x3atype, Period>\x0a"
"  operator*(const Rep1\x26 s, const duration<Rep2, Period>\x26 d);\x0a"
"template <class Rep1, class Period, class Rep2>\x0a"
"  constexpr\x0a"
"  duration<typename common_type<Rep1, Rep2>\x3a\x3atype, Period>\x0a"
"  operator/(const duration<Rep1, Period>\x26 d, const Rep2\x26 s);\x0a"
"template <class Rep1, class Period1, class Rep2, class Period2>\x0a"
"  constexpr\x0a"
"  typename common_type<Rep1, Rep2>\x3a\x3atype\x0a"
"  operator/(const duration<Rep1, Period1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"\x0a"
"// duration comparisons\x0a"
"template <class Rep1, class Period1, class Rep2, class Period2>\x0a"
"   constexpr\x0a"
"   bool operator==(const duration<Rep1, Period1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"template <class Rep1, class Period1, class Rep2, class Period2>\x0a"
"   constexpr\x0a"
"   bool operator\x21=(const duration<Rep1, Period1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"template <class Rep1, class Period1, class Rep2, class Period2>\x0a"
"   constexpr\x0a"
"   bool operator< (const duration<Rep1, Period1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"template <class Rep1, class Period1, class Rep2, class Period2>\x0a"
"   constexpr\x0a"
"   bool operator<=(const duration<Rep1, Period1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"template <class Rep1, class Period1, class Rep2, class Period2>\x0a"
"   constexpr\x0a"
"   bool operator> (const duration<Rep1, Period1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"template <class Rep1, class Period1, class Rep2, class Period2>\x0a"
"   constexpr\x0a"
"   bool operator>=(const duration<Rep1, Period1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"\x0a"
"// duration_cast\x0a"
"template <class ToDuration, class Rep, class Period>\x0a"
"  ToDuration duration_cast(const duration<Rep, Period>\x26 d);\x0a"
"\x0a"
"template <class ToDuration, class Rep, class Period>\x0a"
"    constexpr ToDuration floor(const duration<Rep, Period>\x26 d);    // C++17\x0a"
"template <class ToDuration, class Rep, class Period>\x0a"
"    constexpr ToDuration ceil(const duration<Rep, Period>\x26 d);     // C++17\x0a"
"template <class ToDuration, class Rep, class Period>\x0a"
"    constexpr ToDuration round(const duration<Rep, Period>\x26 d);    // C++17\x0a"
"\x0a"
"// duration I/O is elsewhere\x0a"
"\x0a"
"// time_point arithmetic (all constexpr in C++14)\x0a"
"template <class Clock, class Duration1, class Rep2, class Period2>\x0a"
"  time_point<Clock, typename common_type<Duration1, duration<Rep2, Period2>>\x3a\x3atype>\x0a"
"  operator+(const time_point<Clock, Duration1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"template <class Rep1, class Period1, class Clock, class Duration2>\x0a"
"  time_point<Clock, typename common_type<duration<Rep1, Period1>, Duration2>\x3a\x3atype>\x0a"
"  operator+(const duration<Rep1, Period1>\x26 lhs, const time_point<Clock, Duration2>\x26 rhs);\x0a"
"template <class Clock, class Duration1, class Rep2, class Period2>\x0a"
"  time_point<Clock, typename common_type<Duration1, duration<Rep2, Period2>>\x3a\x3atype>\x0a"
"  operator-(const time_point<Clock, Duration1>\x26 lhs, const duration<Rep2, Period2>\x26 rhs);\x0a"
"template <class Clock, class Duration1, class Duration2>\x0a"
"  typename common_type<Duration1, Duration2>\x3a\x3atype\x0a"
"  operator-(const time_point<Clock, Duration1>\x26 lhs, const time_point<Clock, Duration2>\x26 rhs);\x0a"
"\x0a"
"// time_point comparisons (all constexpr in C++14)\x0a"
"template <class Clock, class Duration1, class Duration2>\x0a"
"   bool operator==(const time_point<Clock, Duration1>\x26 lhs, const time_point<Clock, Duration2>\x26 rhs);\x0a"
"template <class Clock, class Duration1, class Duration2>\x0a"
"   bool operator\x21=(const time_point<Clock, Duration1>\x26 lhs, const time_point<Clock, Duration2>\x26 rhs);\x0a"
"template <class Clock, class Duration1, class Duration2>\x0a"
"   bool operator< (const time_point<Clock, Duration1>\x26 lhs, const time_point<Clock, Duration2>\x26 rhs);\x0a"
"template <class Clock, class Duration1, class Duration2>\x0a"
"   bool operator<=(const time_point<Clock, Duration1>\x26 lhs, const time_point<Clock, Duration2>\x26 rhs);\x0a"
"template <class Clock, class Duration1, class Duration2>\x0a"
"   bool operator> (const time_point<Clock, Duration1>\x26 lhs, const time_point<Clock, Duration2>\x26 rhs);\x0a"
"template <class Clock, class Duration1, class Duration2>\x0a"
"   bool operator>=(const time_point<Clock, Duration1>\x26 lhs, const time_point<Clock, Duration2>\x26 rhs);\x0a"
"\x0a"
"// time_point_cast (constexpr in C++14)\x0a"
"\x0a"
"template <class ToDuration, class Clock, class Duration>\x0a"
"  time_point<Clock, ToDuration> time_point_cast(const time_point<Clock, Duration>\x26 t);\x0a"
"\x0a"
"template <class ToDuration, class Clock, class Duration>\x0a"
"    constexpr time_point<Clock, ToDuration>\x0a"
"    floor(const time_point<Clock, Duration>\x26 tp);                  // C++17\x0a"
"\x0a"
"template <class ToDuration, class Clock, class Duration>\x0a"
"    constexpr time_point<Clock, ToDuration>\x0a"
"    ceil(const time_point<Clock, Duration>\x26 tp);                   // C++17\x0a"
"\x0a"
"template <class ToDuration, class Clock, class Duration>\x0a"
"    constexpr time_point<Clock, ToDuration>\x0a"
"    round(const time_point<Clock, Duration>\x26 tp);                  // C++17\x0a"
"\x0a"
"template <class Rep, class Period>\x0a"
"    constexpr duration<Rep, Period> abs(duration<Rep, Period> d);  // C++17\x0a"
"\x0a"
"// Clocks\x0a"
"\x0a"
"class system_clock\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef microseconds                     duration;\x0a"
"    typedef duration\x3a\x3arep                    rep;\x0a"
"    typedef duration\x3a\x3aperiod                 period;\x0a"
"    typedef chrono\x3a\x3atime_point<system_clock> time_point;\x0a"
"    static const bool is_steady =            false; // constexpr in C++14\x0a"
"\x0a"
"    static time_point now() noexcept;\x0a"
"    static time_t     to_time_t  (const time_point\x26 __t) noexcept;\x0a"
"    static time_point from_time_t(time_t __t) noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class Duration>\x0a"
"  using sys_time  = time_point<system_clock, Duration>; // C++20\x0a"
"using sys_seconds = sys_time<seconds>;                  // C++20\x0a"
"using sys_days    = sys_time<days>;                     // C++20\x0a"
"\x0a"
"class utc_clock;                                        // C++20\x0a"
"\x0a"
"template <class Duration>\x0a"
"  using utc_time  = time_point<utc_clock, Duration>;    // C++20\x0a"
"using utc_seconds = utc_time<seconds>;                  // C++20\x0a"
"\x0a"
"class tai_clock;                                        // C++20\x0a"
"\x0a"
"template <class Duration>\x0a"
"  using tai_time  = time_point<tai_clock, Duration>;    // C++20\x0a"
"using tai_seconds = tai_time<seconds>;                  // C++20\x0a"
"\x0a"
"class file_clock;                                       // C++20\x0a"
"\x0a"
"template<class Duration>\x0a"
"  using file_time = time_point<file_clock, Duration>;   // C++20\x0a"
"\x0a"
"class steady_clock\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef nanoseconds                                   duration;\x0a"
"    typedef duration\x3a\x3arep                                 rep;\x0a"
"    typedef duration\x3a\x3aperiod                              period;\x0a"
"    typedef chrono\x3a\x3atime_point<steady_clock, duration>    time_point;\x0a"
"    static const bool is_steady =                         true; // constexpr in C++14\x0a"
"\x0a"
"    static time_point now() noexcept;\x0a"
"};\x0a"
"\x0a"
"typedef steady_clock high_resolution_clock;\x0a"
"\x0a"
"// 25.7.8, local time           // C++20\x0a"
"struct local_t {};\x0a"
"template<class Duration>\x0a"
"  using local_time  = time_point<local_t, Duration>;\x0a"
"using local_seconds = local_time<seconds>;\x0a"
"using local_days    = local_time<days>;\x0a"
"\x0a"
"// 25.7.9, time_point conversions template<class DestClock, class SourceClock>    // C++20\x0a"
"struct clock_time_conversion;\x0a"
"\x0a"
"template<class DestClock, class SourceClock, class Duration>\x0a"
"  auto clock_cast(const time_point<SourceClock, Duration>\x26 t);\x0a"
"\x0a"
"// 25.8.2, class last_spec    // C++20\x0a"
"struct last_spec;\x0a"
"\x0a"
"// 25.8.3, class day          // C++20\x0a"
"\x0a"
"class day;\x0a"
"constexpr bool operator==(const day\x26 x, const day\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const day\x26 x, const day\x26 y) noexcept;\x0a"
"constexpr bool operator< (const day\x26 x, const day\x26 y) noexcept;\x0a"
"constexpr bool operator> (const day\x26 x, const day\x26 y) noexcept;\x0a"
"constexpr bool operator<=(const day\x26 x, const day\x26 y) noexcept;\x0a"
"constexpr bool operator>=(const day\x26 x, const day\x26 y) noexcept;\x0a"
"constexpr day  operator+(const day\x26  x, const days\x26 y) noexcept;\x0a"
"constexpr day  operator+(const days\x26 x, const day\x26  y) noexcept;\x0a"
"constexpr day  operator-(const day\x26  x, const days\x26 y) noexcept;\x0a"
"constexpr days operator-(const day\x26  x, const day\x26  y) noexcept;\x0a"
"\x0a"
"// 25.8.4, class month    // C++20\x0a"
"class month;\x0a"
"constexpr bool operator==(const month\x26 x, const month\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const month\x26 x, const month\x26 y) noexcept;\x0a"
"constexpr bool operator< (const month\x26 x, const month\x26 y) noexcept;\x0a"
"constexpr bool operator> (const month\x26 x, const month\x26 y) noexcept;\x0a"
"constexpr bool operator<=(const month\x26 x, const month\x26 y) noexcept;\x0a"
"constexpr bool operator>=(const month\x26 x, const month\x26 y) noexcept;\x0a"
"constexpr month  operator+(const month\x26  x, const months\x26 y) noexcept;\x0a"
"constexpr month  operator+(const months\x26 x,  const month\x26 y) noexcept;\x0a"
"constexpr month  operator-(const month\x26  x, const months\x26 y) noexcept;\x0a"
"constexpr months operator-(const month\x26  x,  const month\x26 y) noexcept;\x0a"
"\x0a"
"// 25.8.5, class year    // C++20\x0a"
"class year;\x0a"
"constexpr bool operator==(const year\x26 x, const year\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const year\x26 x, const year\x26 y) noexcept;\x0a"
"constexpr bool operator< (const year\x26 x, const year\x26 y) noexcept;\x0a"
"constexpr bool operator> (const year\x26 x, const year\x26 y) noexcept;\x0a"
"constexpr bool operator<=(const year\x26 x, const year\x26 y) noexcept;\x0a"
"constexpr bool operator>=(const year\x26 x, const year\x26 y) noexcept;\x0a"
"constexpr year  operator+(const year\x26  x, const years\x26 y) noexcept;\x0a"
"constexpr year  operator+(const years\x26 x, const year\x26  y) noexcept;\x0a"
"constexpr year  operator-(const year\x26  x, const years\x26 y) noexcept;\x0a"
"constexpr years operator-(const year\x26  x, const year\x26  y) noexcept;\x0a"
"\x0a"
"// 25.8.6, class weekday    // C++20\x0a"
"class weekday;\x0a"
"\x0a"
"constexpr bool operator==(const weekday\x26 x, const weekday\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const weekday\x26 x, const weekday\x26 y) noexcept;\x0a"
"constexpr weekday operator+(const weekday\x26 x, const days\x26    y) noexcept;\x0a"
"constexpr weekday operator+(const days\x26    x, const weekday\x26 y) noexcept;\x0a"
"constexpr weekday operator-(const weekday\x26 x, const days\x26    y) noexcept;\x0a"
"constexpr days    operator-(const weekday\x26 x, const weekday\x26 y) noexcept;\x0a"
"\x0a"
"// 25.8.7, class weekday_indexed    // C++20\x0a"
"\x0a"
"class weekday_indexed;\x0a"
"constexpr bool operator==(const weekday_indexed\x26 x, const weekday_indexed\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const weekday_indexed\x26 x, const weekday_indexed\x26 y) noexcept;\x0a"
"\x0a"
"// 25.8.8, class weekday_last    // C++20\x0a"
"class weekday_last;\x0a"
"\x0a"
"constexpr bool operator==(const weekday_last\x26 x, const weekday_last\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const weekday_last\x26 x, const weekday_last\x26 y) noexcept;\x0a"
"\x0a"
"// 25.8.9, class month_day    // C++20\x0a"
"class month_day;\x0a"
"\x0a"
"constexpr bool operator==(const month_day\x26 x, const month_day\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const month_day\x26 x, const month_day\x26 y) noexcept;\x0a"
"constexpr bool operator< (const month_day\x26 x, const month_day\x26 y) noexcept;\x0a"
"constexpr bool operator> (const month_day\x26 x, const month_day\x26 y) noexcept;\x0a"
"constexpr bool operator<=(const month_day\x26 x, const month_day\x26 y) noexcept;\x0a"
"constexpr bool operator>=(const month_day\x26 x, const month_day\x26 y) noexcept;\x0a"
"\x0a"
"\x0a"
"// 25.8.10, class month_day_last    // C++20\x0a"
"class month_day_last;\x0a"
"\x0a"
"constexpr bool operator==(const month_day_last\x26 x, const month_day_last\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const month_day_last\x26 x, const month_day_last\x26 y) noexcept;\x0a"
"constexpr bool operator< (const month_day_last\x26 x, const month_day_last\x26 y) noexcept;\x0a"
"constexpr bool operator> (const month_day_last\x26 x, const month_day_last\x26 y) noexcept;\x0a"
"constexpr bool operator<=(const month_day_last\x26 x, const month_day_last\x26 y) noexcept;\x0a"
"constexpr bool operator>=(const month_day_last\x26 x, const month_day_last\x26 y) noexcept;\x0a"
"\x0a"
"// 25.8.11, class month_weekday    // C++20\x0a"
"class month_weekday;\x0a"
"\x0a"
"constexpr bool operator==(const month_weekday\x26 x, const month_weekday\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const month_weekday\x26 x, const month_weekday\x26 y) noexcept;\x0a"
"\x0a"
"// 25.8.12, class month_weekday_last    // C++20\x0a"
"class month_weekday_last;\x0a"
"\x0a"
"constexpr bool operator==(const month_weekday_last\x26 x, const month_weekday_last\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const month_weekday_last\x26 x, const month_weekday_last\x26 y) noexcept;\x0a"
"\x0a"
"\x0a"
"// 25.8.13, class year_month    // C++20\x0a"
"class year_month;\x0a"
"\x0a"
"constexpr bool operator==(const year_month\x26 x, const year_month\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const year_month\x26 x, const year_month\x26 y) noexcept;\x0a"
"constexpr bool operator< (const year_month\x26 x, const year_month\x26 y) noexcept;\x0a"
"constexpr bool operator> (const year_month\x26 x, const year_month\x26 y) noexcept;\x0a"
"constexpr bool operator<=(const year_month\x26 x, const year_month\x26 y) noexcept;\x0a"
"constexpr bool operator>=(const year_month\x26 x, const year_month\x26 y) noexcept;\x0a"
"\x0a"
"constexpr year_month operator+(const year_month\x26 ym, const months\x26 dm) noexcept;\x0a"
"constexpr year_month operator+(const months\x26 dm, const year_month\x26 ym) noexcept;\x0a"
"constexpr year_month operator-(const year_month\x26 ym, const months\x26 dm) noexcept;\x0a"
"constexpr months operator-(const year_month\x26 x, const year_month\x26 y) noexcept;\x0a"
"constexpr year_month operator+(const year_month\x26 ym, const years\x26 dy) noexcept;\x0a"
"constexpr year_month operator+(const years\x26 dy, const year_month\x26 ym) noexcept;\x0a"
"constexpr year_month operator-(const year_month\x26 ym, const years\x26 dy) noexcept;\x0a"
"\x0a"
"// 25.8.14, class year_month_day class    // C++20\x0a"
"year_month_day;\x0a"
"\x0a"
"constexpr bool operator==(const year_month_day\x26 x, const year_month_day\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const year_month_day\x26 x, const year_month_day\x26 y) noexcept;\x0a"
"constexpr bool operator< (const year_month_day\x26 x, const year_month_day\x26 y) noexcept;\x0a"
"constexpr bool operator> (const year_month_day\x26 x, const year_month_day\x26 y) noexcept;\x0a"
"constexpr bool operator<=(const year_month_day\x26 x, const year_month_day\x26 y) noexcept;\x0a"
"constexpr bool operator>=(const year_month_day\x26 x, const year_month_day\x26 y) noexcept;\x0a"
"\x0a"
"constexpr year_month_day operator+(const year_month_day\x26 ymd, const months\x26 dm) noexcept;\x0a"
"constexpr year_month_day operator+(const months\x26 dm, const year_month_day\x26 ymd) noexcept;\x0a"
"constexpr year_month_day operator+(const year_month_day\x26 ymd, const years\x26 dy) noexcept;\x0a"
"constexpr year_month_day operator+(const years\x26 dy, const year_month_day\x26 ymd) noexcept;\x0a"
"constexpr year_month_day operator-(const year_month_day\x26 ymd, const months\x26 dm) noexcept;\x0a"
"constexpr year_month_day operator-(const year_month_day\x26 ymd, const years\x26 dy) noexcept;\x0a"
"\x0a"
"\x0a"
"// 25.8.15, class year_month_day_last    // C++20\x0a"
"class year_month_day_last;\x0a"
"\x0a"
"constexpr bool operator==(const year_month_day_last\x26 x,\x0a"
"                          const year_month_day_last\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const year_month_day_last\x26 x,\x0a"
"                          const year_month_day_last\x26 y) noexcept;\x0a"
"constexpr bool operator< (const year_month_day_last\x26 x,\x0a"
"                          const year_month_day_last\x26 y) noexcept;\x0a"
"constexpr bool operator> (const year_month_day_last\x26 x,\x0a"
"                          const year_month_day_last\x26 y) noexcept;\x0a"
"constexpr bool operator<=(const year_month_day_last\x26 x,\x0a"
"                          const year_month_day_last\x26 y) noexcept;\x0a"
"constexpr bool operator>=(const year_month_day_last\x26 x,\x0a"
"                          const year_month_day_last\x26 y) noexcept;\x0a"
"\x0a"
"constexpr year_month_day_last\x0a"
"  operator+(const year_month_day_last\x26 ymdl, const months\x26 dm) noexcept;\x0a"
"constexpr year_month_day_last\x0a"
"  operator+(const months\x26 dm, const year_month_day_last\x26 ymdl) noexcept;\x0a"
"constexpr year_month_day_last\x0a"
"  operator+(const year_month_day_last\x26 ymdl, const years\x26 dy) noexcept;\x0a"
"constexpr year_month_day_last\x0a"
"  operator+(const years\x26 dy, const year_month_day_last\x26 ymdl) noexcept;\x0a"
"constexpr year_month_day_last\x0a"
"  operator-(const year_month_day_last\x26 ymdl, const months\x26 dm) noexcept;\x0a"
"constexpr year_month_day_last\x0a"
"  operator-(const year_month_day_last\x26 ymdl, const years\x26 dy) noexcept;\x0a"
"\x0a"
"// 25.8.16, class year_month_weekday    // C++20\x0a"
"class year_month_weekday;\x0a"
"\x0a"
"constexpr bool operator==(const year_month_weekday\x26 x,\x0a"
"                          const year_month_weekday\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const year_month_weekday\x26 x,\x0a"
"                          const year_month_weekday\x26 y) noexcept;\x0a"
"\x0a"
"constexpr year_month_weekday\x0a"
"  operator+(const year_month_weekday\x26 ymwd, const months\x26 dm) noexcept;\x0a"
"constexpr year_month_weekday\x0a"
"  operator+(const months\x26 dm, const year_month_weekday\x26 ymwd) noexcept;\x0a"
"constexpr year_month_weekday\x0a"
"  operator+(const year_month_weekday\x26 ymwd, const years\x26 dy) noexcept;\x0a"
"constexpr year_month_weekday\x0a"
"  operator+(const years\x26 dy, const year_month_weekday\x26 ymwd) noexcept;\x0a"
"constexpr year_month_weekday\x0a"
"  operator-(const year_month_weekday\x26 ymwd, const months\x26 dm) noexcept;\x0a"
"constexpr year_month_weekday\x0a"
"  operator-(const year_month_weekday\x26 ymwd, const years\x26 dy) noexcept;\x0a"
"\x0a"
"// 25.8.17, class year_month_weekday_last    // C++20\x0a"
"class year_month_weekday_last;\x0a"
"\x0a"
"constexpr bool operator==(const year_month_weekday_last\x26 x,\x0a"
"                          const year_month_weekday_last\x26 y) noexcept;\x0a"
"constexpr bool operator\x21=(const year_month_weekday_last\x26 x,\x0a"
"                          const year_month_weekday_last\x26 y) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator+(const year_month_weekday_last\x26 ymwdl, const months\x26 dm) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator+(const months\x26 dm, const year_month_weekday_last\x26 ymwdl) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator+(const year_month_weekday_last\x26 ymwdl, const years\x26 dy) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator+(const years\x26 dy, const year_month_weekday_last\x26 ymwdl) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator-(const year_month_weekday_last\x26 ymwdl, const months\x26 dm) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator-(const year_month_weekday_last\x26 ymwdl, const years\x26 dy) noexcept;\x0a"
"\x0a"
"// 25.8.18, civil calendar conventional syntax operators    // C++20\x0a"
"constexpr year_month\x0a"
"  operator/(const year\x26 y, const month\x26 m) noexcept;\x0a"
"constexpr year_month\x0a"
"  operator/(const year\x26 y, int m) noexcept;\x0a"
"constexpr month_day\x0a"
"  operator/(const month\x26 m, const day\x26 d) noexcept;\x0a"
"constexpr month_day\x0a"
"  operator/(const month\x26 m, int d) noexcept;\x0a"
"constexpr month_day\x0a"
"  operator/(int m, const day\x26 d) noexcept;\x0a"
"constexpr month_day\x0a"
"  operator/(const day\x26 d, const month\x26 m) noexcept;\x0a"
"constexpr month_day\x0a"
"  operator/(const day\x26 d, int m) noexcept;\x0a"
"constexpr month_day_last\x0a"
"  operator/(const month\x26 m, last_spec) noexcept;\x0a"
"constexpr month_day_last\x0a"
"  operator/(int m, last_spec) noexcept;\x0a"
"constexpr month_day_last\x0a"
"  operator/(last_spec, const month\x26 m) noexcept;\x0a"
"constexpr month_day_last\x0a"
"  operator/(last_spec, int m) noexcept;\x0a"
"constexpr month_weekday\x0a"
"  operator/(const month\x26 m, const weekday_indexed\x26 wdi) noexcept;\x0a"
"constexpr month_weekday\x0a"
"  operator/(int m, const weekday_indexed\x26 wdi) noexcept;\x0a"
"constexpr month_weekday\x0a"
"  operator/(const weekday_indexed\x26 wdi, const month\x26 m) noexcept;\x0a"
"constexpr month_weekday\x0a"
"  operator/(const weekday_indexed\x26 wdi, int m) noexcept;\x0a"
"constexpr month_weekday_last\x0a"
"  operator/(const month\x26 m, const weekday_last\x26 wdl) noexcept;\x0a"
"constexpr month_weekday_last\x0a"
"  operator/(int m, const weekday_last\x26 wdl) noexcept;\x0a"
"constexpr month_weekday_last\x0a"
"  operator/(const weekday_last\x26 wdl, const month\x26 m) noexcept;\x0a"
"constexpr month_weekday_last\x0a"
"  operator/(const weekday_last\x26 wdl, int m) noexcept;\x0a"
"constexpr year_month_day\x0a"
"  operator/(const year_month\x26 ym, const day\x26 d) noexcept;\x0a"
"constexpr year_month_day\x0a"
"  operator/(const year_month\x26 ym, int d) noexcept;\x0a"
"constexpr year_month_day\x0a"
"  operator/(const year\x26 y, const month_day\x26 md) noexcept;\x0a"
"constexpr year_month_day\x0a"
"  operator/(int y, const month_day\x26 md) noexcept;\x0a"
"constexpr year_month_day\x0a"
"  operator/(const month_day\x26 md, const year\x26 y) noexcept;\x0a"
"constexpr year_month_day\x0a"
"  operator/(const month_day\x26 md, int y) noexcept;\x0a"
"constexpr year_month_day_last\x0a"
"  operator/(const year_month\x26 ym, last_spec) noexcept;\x0a"
"constexpr year_month_day_last\x0a"
"  operator/(const year\x26 y, const month_day_last\x26 mdl) noexcept;\x0a"
"constexpr year_month_day_last\x0a"
"  operator/(int y, const month_day_last\x26 mdl) noexcept;\x0a"
"constexpr year_month_day_last\x0a"
"  operator/(const month_day_last\x26 mdl, const year\x26 y) noexcept;\x0a"
"constexpr year_month_day_last\x0a"
"  operator/(const month_day_last\x26 mdl, int y) noexcept;\x0a"
"constexpr year_month_weekday\x0a"
"  operator/(const year_month\x26 ym, const weekday_indexed\x26 wdi) noexcept;\x0a"
"constexpr year_month_weekday\x0a"
"  operator/(const year\x26 y, const month_weekday\x26 mwd) noexcept;\x0a"
"constexpr year_month_weekday\x0a"
"  operator/(int y, const month_weekday\x26 mwd) noexcept;\x0a"
"constexpr year_month_weekday\x0a"
"  operator/(const month_weekday\x26 mwd, const year\x26 y) noexcept;\x0a"
"constexpr year_month_weekday\x0a"
"  operator/(const month_weekday\x26 mwd, int y) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator/(const year_month\x26 ym, const weekday_last\x26 wdl) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator/(const year\x26 y, const month_weekday_last\x26 mwdl) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator/(int y, const month_weekday_last\x26 mwdl) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator/(const month_weekday_last\x26 mwdl, const year\x26 y) noexcept;\x0a"
"constexpr year_month_weekday_last\x0a"
"  operator/(const month_weekday_last\x26 mwdl, int y) noexcept;\x0a"
"\x0a"
"// 25.9, class template time_of_day    // C++20\x0a"
"template<class Duration> class time_of_day;\x0a"
"\x0a"
"template<> class time_of_day<hours>;\x0a"
"template<> class time_of_day<minutes>;\x0a"
"template<> class time_of_day<seconds>;\x0a"
"template<class Rep, class Period> class time_of_day<duration<Rep, Period>>;\x0a"
"\x0a"
"// 25.10.2, time zone database     // C++20\x0a"
"struct tzdb;\x0a"
"class tzdb_list;\x0a"
"\x0a"
"// 25.10.2.3, time zone database access    // C++20\x0a"
"const tzdb\x26 get_tzdb();\x0a"
"tzdb_list\x26 get_tzdb_list();\x0a"
"const time_zone* locate_zone(string_view tz_name);\x0a"
"const time_zone* current_zone();\x0a"
"\x0a"
"// 25.10.2.4, remote time zone database support    // C++20\x0a"
"const tzdb\x26 reload_tzdb();\x0a"
"string remote_version();\x0a"
"\x0a"
"// 25.10.3, exception classes    // C++20\x0a"
"class nonexistent_local_time;\x0a"
"class ambiguous_local_time;\x0a"
"\x0a"
"// 25.10.4, information classes    // C++20\x0a"
"struct sys_info;\x0a"
"struct local_info;\x0a"
"\x0a"
"// 25.10.5, class time_zone    // C++20\x0a"
"enum class choose {earliest, latest};\x0a"
"class time_zone;\x0a"
"bool operator==(const time_zone\x26 x, const time_zone\x26 y) noexcept;\x0a"
"bool operator\x21=(const time_zone\x26 x, const time_zone\x26 y) noexcept;\x0a"
"bool operator<(const time_zone\x26 x, const time_zone\x26 y) noexcept;\x0a"
"bool operator>(const time_zone\x26 x, const time_zone\x26 y) noexcept;\x0a"
"bool operator<=(const time_zone\x26 x, const time_zone\x26 y) noexcept;\x0a"
"bool operator>=(const time_zone\x26 x, const time_zone\x26 y) noexcept;\x0a"
"\x0a"
"// 25.10.6, class template zoned_traits    // C++20\x0a"
"template<class T> struct zoned_traits;\x0a"
"\x0a"
"// 25.10.7, class template zoned_time    // C++20\x0a"
"template<class Duration, class TimeZonePtr = const time_zone*> class zoned_time;\x0a"
"using zoned_seconds = zoned_time<seconds>;\x0a"
"\x0a"
"template<class Duration1, class Duration2, class TimeZonePtr>\x0a"
"  bool operator==(const zoned_time<Duration1, TimeZonePtr>\x26 x,\x0a"
"                  const zoned_time<Duration2, TimeZonePtr>\x26 y);\x0a"
"template<class Duration1, class Duration2, class TimeZonePtr>\x0a"
"  bool operator\x21=(const zoned_time<Duration1, TimeZonePtr>\x26 x,\x0a"
"                  const zoned_time<Duration2, TimeZonePtr>\x26 y);\x0a"
"\x0a"
"// 25.10.8, leap second support    // C++20\x0a"
"class leap;\x0a"
"\x0a"
"bool operator==(const leap\x26 x, const leap\x26 y);\x0a"
"bool operator\x21=(const leap\x26 x, const leap\x26 y);\x0a"
"bool operator< (const leap\x26 x, const leap\x26 y);\x0a"
"bool operator> (const leap\x26 x, const leap\x26 y);\x0a"
"bool operator<=(const leap\x26 x, const leap\x26 y);\x0a"
"bool operator>=(const leap\x26 x, const leap\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator==(const leap\x26 x, const sys_time<Duration>\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator==(const sys_time<Duration>\x26 x, const leap\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator\x21=(const leap\x26 x, const sys_time<Duration>\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator\x21=(const sys_time<Duration>\x26 x, const leap\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator< (const leap\x26 x, const sys_time<Duration>\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator< (const sys_time<Duration>\x26 x, const leap\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator> (const leap\x26 x, const sys_time<Duration>\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator> (const sys_time<Duration>\x26 x, const leap\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator<=(const leap\x26 x, const sys_time<Duration>\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator<=(const sys_time<Duration>\x26 x, const leap\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator>=(const leap\x26 x, const sys_time<Duration>\x26 y);\x0a"
"template<class Duration>\x0a"
"  bool operator>=(const sys_time<Duration>\x26 x, const leap\x26 y);\x0a"
"\x0a"
"// 25.10.9, class link    // C++20\x0a"
"class link;\x0a"
"bool operator==(const link\x26 x, const link\x26 y);\x0a"
"bool operator\x21=(const link\x26 x, const link\x26 y);\x0a"
"bool operator< (const link\x26 x, const link\x26 y);\x0a"
"bool operator> (const link\x26 x, const link\x26 y);\x0a"
"bool operator<=(const link\x26 x, const link\x26 y);\x0a"
"bool operator>=(const link\x26 x, const link\x26 y);\x0a"
"\x0a"
"// 25.11, formatting    // C++20\x0a"
"template<class charT, class Streamable>\x0a"
"  basic_string<charT>\x0a"
"    format(const charT* fmt, const Streamable\x26 s);\x0a"
"\x0a"
"template<class charT, class Streamable>\x0a"
"  basic_string<charT>\x0a"
"    format(const locale\x26 loc, const charT* fmt, const Streamable\x26 s);\x0a"
"\x0a"
"template<class charT, class traits, class Alloc, class Streamable>\x0a"
"  basic_string<charT, traits, Alloc>\x0a"
"    format(const basic_string<charT, traits, Alloc>\x26 fmt, const Streamable\x26 s);\x0a"
"\x0a"
"template<class charT, class traits, class Alloc, class Streamable>\x0a"
"  basic_string<charT, traits, Alloc>\x0a"
"    format(const locale\x26 loc, const basic_string<charT, traits, Alloc>\x26 fmt,\x0a"
"           const Streamable\x26 s);\x0a"
"\x0a"
"// 25.12, parsing    // C++20\x0a"
"template<class charT, class traits, class Alloc, class Parsable>\x0a"
"unspecified\x0a"
"    parse(const basic_string<charT, traits, Alloc>\x26 format, Parsable\x26 tp);\x0a"
"\x0a"
"template<class charT, class traits, class Alloc, class Parsable>\x0a"
"unspecified\x0a"
"    parse(const basic_string<charT, traits, Alloc>\x26 format, Parsable\x26 tp,\x0a"
"          basic_string<charT, traits, Alloc>\x26 abbrev);\x0a"
"\x0a"
"template<class charT, class traits, class Alloc, class Parsable>\x0a"
"unspecified\x0a"
"    parse(const basic_string<charT, traits, Alloc>\x26 format, Parsable\x26 tp,\x0a"
"          minutes\x26 offset);\x0a"
"\x0a"
"template<class charT, class traits, class Alloc, class Parsable>\x0a"
"unspecified\x0a"
"    parse(const basic_string<charT, traits, Alloc>\x26 format, Parsable\x26 tp,\x0a"
"          basic_string<charT, traits, Alloc>\x26 abbrev, minutes\x26 offset);\x0a"
"\x0a"
"// calendrical constants\x0a"
"inline constexpr last_spec                              last{};       // C++20\x0a"
"inline constexpr chrono\x3a\x3aweekday                        Sunday{0};    // C++20\x0a"
"inline constexpr chrono\x3a\x3aweekday                        Monday{1};    // C++20\x0a"
"inline constexpr chrono\x3a\x3aweekday                        Tuesday{2};   // C++20\x0a"
"inline constexpr chrono\x3a\x3aweekday                        Wednesday{3}; // C++20\x0a"
"inline constexpr chrono\x3a\x3aweekday                        Thursday{4};  // C++20\x0a"
"inline constexpr chrono\x3a\x3aweekday                        Friday{5};    // C++20\x0a"
"inline constexpr chrono\x3a\x3aweekday                        Saturday{6};  // C++20\x0a"
"\x0a"
"inline constexpr chrono\x3a\x3amonth                          January{1};   // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          February{2};  // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          March{3};     // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          April{4};     // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          May{5};       // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          June{6};      // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          July{7};      // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          August{8};    // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          September{9}; // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          October{10};  // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          November{11}; // C++20\x0a"
"inline constexpr chrono\x3a\x3amonth                          December{12}; // C++20\x0a"
"}  // chrono\x0a"
"\x0a"
"inline namespace literals {\x0a"
"  inline namespace chrono_literals {\x0a"
"constexpr chrono\x3a\x3ahours                                 operator \x22\x22h(unsigned long long); // C++14\x0a"
"constexpr chrono\x3a\x3a""duration<unspecified , ratio<3600,1>> operator \x22\x22h(long double); // C++14\x0a"
"constexpr chrono\x3a\x3aminutes                               operator \x22\x22min(unsigned long long); // C++14\x0a"
"constexpr chrono\x3a\x3a""duration<unspecified , ratio<60,1>>   operator \x22\x22min(long double); // C++14\x0a"
"constexpr chrono\x3a\x3aseconds                               operator \x22\x22s(unsigned long long); // C++14\x0a"
"constexpr chrono\x3a\x3a""duration<unspecified >                operator \x22\x22s(long double); // C++14\x0a"
"constexpr chrono\x3a\x3amilliseconds                          operator \x22\x22ms(unsigned long long); // C++14\x0a"
"constexpr chrono\x3a\x3a""duration<unspecified , milli>         operator \x22\x22ms(long double); // C++14\x0a"
"constexpr chrono\x3a\x3amicroseconds                          operator \x22\x22us(unsigned long long); // C++14\x0a"
"constexpr chrono\x3a\x3a""duration<unspecified , micro>         operator \x22\x22us(long double); // C++14\x0a"
"constexpr chrono\x3a\x3ananoseconds                           operator \x22\x22ns(unsigned long long); // C++14\x0a"
"constexpr chrono\x3a\x3a""duration<unspecified , nano>          operator \x22\x22ns(long double); // C++14\x0a"
"constexpr chrono\x3a\x3a""day                                   operator \x22\x22""d(unsigned long long d) noexcept; // C++20\x0a"
"constexpr chrono\x3a\x3ayear                                  operator \x22\x22y(unsigned long long y) noexcept; // C++20\x0a"
"}  // chrono_literals\x0a"
"}  // literals\x0a"
"\x0a"
"}  // std\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <ctime>\x0a"
"#include <type_traits>\x0a"
"#include <ratio>\x0a"
"#include <limits>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"_LIBCPP_BEGIN_NAMESPACE_FILESYSTEM\x0a"
"struct _FilesystemClock;\x0a"
"_LIBCPP_END_NAMESPACE_FILESYSTEM\x0a"
"#endif // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"namespace chrono\x0a"
"{\x0a"
"\x0a"
"template <class _Rep, class _Period = ratio<1> > class _LIBCPP_TEMPLATE_VIS duration;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_duration \x3a false_type {};\x0a"
"\x0a"
"template <class _Rep, class _Period>\x0a"
"struct __is_duration<duration<_Rep, _Period> > \x3a true_type  {};\x0a"
"\x0a"
"template <class _Rep, class _Period>\x0a"
"struct __is_duration<const duration<_Rep, _Period> > \x3a true_type  {};\x0a"
"\x0a"
"template <class _Rep, class _Period>\x0a"
"struct __is_duration<volatile duration<_Rep, _Period> > \x3a true_type  {};\x0a"
"\x0a"
"template <class _Rep, class _Period>\x0a"
"struct __is_duration<const volatile duration<_Rep, _Period> > \x3a true_type  {};\x0a"
"\x0a"
"} // chrono\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS common_type<chrono\x3a\x3a""duration<_Rep1, _Period1>,\x0a"
"                                         chrono\x3a\x3a""duration<_Rep2, _Period2> >\x0a"
"{\x0a"
"    typedef chrono\x3a\x3a""duration<typename common_type<_Rep1, _Rep2>\x3a\x3atype,\x0a"
"                             typename __ratio_gcd<_Period1, _Period2>\x3a\x3atype> type;\x0a"
"};\x0a"
"\x0a"
"namespace chrono {\x0a"
"\x0a"
"// duration_cast\x0a"
"\x0a"
"template <class _FromDuration, class _ToDuration,\x0a"
"          class _Period = typename ratio_divide<typename _FromDuration\x3a\x3aperiod, typename _ToDuration\x3a\x3aperiod>\x3a\x3atype,\x0a"
"          bool = _Period\x3a\x3anum == 1,\x0a"
"          bool = _Period\x3a\x3a""den == 1>\x0a"
"struct __duration_cast;\x0a"
"\x0a"
"template <class _FromDuration, class _ToDuration, class _Period>\x0a"
"struct __duration_cast<_FromDuration, _ToDuration, _Period, true, true>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    _ToDuration operator()(const _FromDuration\x26 __fd) const\x0a"
"    {\x0a"
"        return _ToDuration(static_cast<typename _ToDuration\x3a\x3arep>(__fd.count()));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _FromDuration, class _ToDuration, class _Period>\x0a"
"struct __duration_cast<_FromDuration, _ToDuration, _Period, true, false>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    _ToDuration operator()(const _FromDuration\x26 __fd) const\x0a"
"    {\x0a"
"        typedef typename common_type<typename _ToDuration\x3a\x3arep, typename _FromDuration\x3a\x3arep, intmax_t>\x3a\x3atype _Ct;\x0a"
"        return _ToDuration(static_cast<typename _ToDuration\x3a\x3arep>(\x0a"
"                           static_cast<_Ct>(__fd.count()) / static_cast<_Ct>(_Period\x3a\x3a""den)));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _FromDuration, class _ToDuration, class _Period>\x0a"
"struct __duration_cast<_FromDuration, _ToDuration, _Period, false, true>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    _ToDuration operator()(const _FromDuration\x26 __fd) const\x0a"
"    {\x0a"
"        typedef typename common_type<typename _ToDuration\x3a\x3arep, typename _FromDuration\x3a\x3arep, intmax_t>\x3a\x3atype _Ct;\x0a"
"        return _ToDuration(static_cast<typename _ToDuration\x3a\x3arep>(\x0a"
"                           static_cast<_Ct>(__fd.count()) * static_cast<_Ct>(_Period\x3a\x3anum)));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _FromDuration, class _ToDuration, class _Period>\x0a"
"struct __duration_cast<_FromDuration, _ToDuration, _Period, false, false>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    _ToDuration operator()(const _FromDuration\x26 __fd) const\x0a"
"    {\x0a"
"        typedef typename common_type<typename _ToDuration\x3a\x3arep, typename _FromDuration\x3a\x3arep, intmax_t>\x3a\x3atype _Ct;\x0a"
"        return _ToDuration(static_cast<typename _ToDuration\x3a\x3arep>(\x0a"
"                           static_cast<_Ct>(__fd.count()) * static_cast<_Ct>(_Period\x3a\x3anum)\x0a"
"                                                          / static_cast<_Ct>(_Period\x3a\x3a""den)));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _ToDuration, class _Rep, class _Period>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_duration<_ToDuration>\x3a\x3avalue,\x0a"
"    _ToDuration\x0a"
">\x3a\x3atype\x0a"
"duration_cast(const duration<_Rep, _Period>\x26 __fd)\x0a"
"{\x0a"
"    return __duration_cast<duration<_Rep, _Period>, _ToDuration>()(__fd);\x0a"
"}\x0a"
"\x0a"
"template <class _Rep>\x0a"
"struct _LIBCPP_TEMPLATE_VIS treat_as_floating_point \x3a is_floating_point<_Rep> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Rep>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool treat_as_floating_point_v\x0a"
"    = treat_as_floating_point<_Rep>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Rep>\x0a"
"struct _LIBCPP_TEMPLATE_VIS duration_values\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR _Rep zero() _NOEXCEPT {return _Rep(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR _Rep max()  _NOEXCEPT {return numeric_limits<_Rep>\x3a\x3amax();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR _Rep min()  _NOEXCEPT {return numeric_limits<_Rep>\x3a\x3alowest();}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _ToDuration, class _Rep, class _Period>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_duration<_ToDuration>\x3a\x3avalue,\x0a"
"    _ToDuration\x0a"
">\x3a\x3atype\x0a"
"floor(const duration<_Rep, _Period>\x26 __d)\x0a"
"{\x0a"
"    _ToDuration __t = duration_cast<_ToDuration>(__d);\x0a"
"    if (__t > __d)\x0a"
"        __t = __t - _ToDuration{1};\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template <class _ToDuration, class _Rep, class _Period>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_duration<_ToDuration>\x3a\x3avalue,\x0a"
"    _ToDuration\x0a"
">\x3a\x3atype\x0a"
"ceil(const duration<_Rep, _Period>\x26 __d)\x0a"
"{\x0a"
"    _ToDuration __t = duration_cast<_ToDuration>(__d);\x0a"
"    if (__t < __d)\x0a"
"        __t = __t + _ToDuration{1};\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template <class _ToDuration, class _Rep, class _Period>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_duration<_ToDuration>\x3a\x3avalue,\x0a"
"    _ToDuration\x0a"
">\x3a\x3atype\x0a"
"round(const duration<_Rep, _Period>\x26 __d)\x0a"
"{\x0a"
"    _ToDuration __lower = floor<_ToDuration>(__d);\x0a"
"    _ToDuration __upper = __lower + _ToDuration{1};\x0a"
"    auto __lowerDiff = __d - __lower;\x0a"
"    auto __upperDiff = __upper - __d;\x0a"
"    if (__lowerDiff < __upperDiff)\x0a"
"        return __lower;\x0a"
"    if (__lowerDiff > __upperDiff)\x0a"
"        return __upper;\x0a"
"    return __lower.count() \x26 1 \x3f __upper \x3a __lower;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"// duration\x0a"
"\x0a"
"template <class _Rep, class _Period>\x0a"
"class _LIBCPP_TEMPLATE_VIS duration\x0a"
"{\x0a"
"    static_assert(\x21__is_duration<_Rep>\x3a\x3avalue, \x22""A duration representation can not be a duration\x22);\x0a"
"    static_assert(__is_ratio<_Period>\x3a\x3avalue, \x22Second template parameter of duration must be a std\x3a\x3aratio\x22);\x0a"
"    static_assert(_Period\x3a\x3anum > 0, \x22""duration period must be positive\x22);\x0a"
"\x0a"
"    template <class _R1, class _R2>\x0a"
"    struct __no_overflow\x0a"
"    {\x0a"
"    private\x3a\x0a"
"        static const intmax_t __gcd_n1_n2 = __static_gcd<_R1\x3a\x3anum, _R2\x3a\x3anum>\x3a\x3avalue;\x0a"
"        static const intmax_t __gcd_d1_d2 = __static_gcd<_R1\x3a\x3a""den, _R2\x3a\x3a""den>\x3a\x3avalue;\x0a"
"        static const intmax_t __n1 = _R1\x3a\x3anum / __gcd_n1_n2;\x0a"
"        static const intmax_t __d1 = _R1\x3a\x3a""den / __gcd_d1_d2;\x0a"
"        static const intmax_t __n2 = _R2\x3a\x3anum / __gcd_n1_n2;\x0a"
"        static const intmax_t __d2 = _R2\x3a\x3a""den / __gcd_d1_d2;\x0a"
"        static const intmax_t max = -((intmax_t(1) << (sizeof(intmax_t) * CHAR_BIT - 1)) + 1);\x0a"
"\x0a"
"        template <intmax_t _Xp, intmax_t _Yp, bool __overflow>\x0a"
"        struct __mul    // __overflow == false\x0a"
"        {\x0a"
"            static const intmax_t value = _Xp * _Yp;\x0a"
"        };\x0a"
"\x0a"
"        template <intmax_t _Xp, intmax_t _Yp>\x0a"
"        struct __mul<_Xp, _Yp, true>\x0a"
"        {\x0a"
"            static const intmax_t value = 1;\x0a"
"        };\x0a"
"\x0a"
"    public\x3a\x0a"
"        static const bool value = (__n1 <= max / __d2) \x26\x26 (__n2 <= max / __d1);\x0a"
"        typedef ratio<__mul<__n1, __d2, \x21value>\x3a\x3avalue,\x0a"
"                      __mul<__n2, __d1, \x21value>\x3a\x3avalue> type;\x0a"
"    };\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _Rep rep;\x0a"
"    typedef typename _Period\x3a\x3atype period;\x0a"
"private\x3a\x0a"
"    rep __rep_;\x0a"
"public\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"        duration() = default;\x0a"
"#else\x0a"
"        duration() {}\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Rep2>\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"        explicit duration(const _Rep2\x26 __r,\x0a"
"            typename enable_if\x0a"
"            <\x0a"
"               is_convertible<_Rep2, rep>\x3a\x3avalue \x26\x26\x0a"
"               (treat_as_floating_point<rep>\x3a\x3avalue \x7c\x7c\x0a"
"               \x21treat_as_floating_point<_Rep2>\x3a\x3avalue)\x0a"
"            >\x3a\x3atype* = 0)\x0a"
"                \x3a __rep_(__r) {}\x0a"
"\x0a"
"    // conversions\x0a"
"    template <class _Rep2, class _Period2>\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"        duration(const duration<_Rep2, _Period2>\x26 __d,\x0a"
"            typename enable_if\x0a"
"            <\x0a"
"                __no_overflow<_Period2, period>\x3a\x3avalue \x26\x26 (\x0a"
"                treat_as_floating_point<rep>\x3a\x3avalue \x7c\x7c\x0a"
"                (__no_overflow<_Period2, period>\x3a\x3atype\x3a\x3a""den == 1 \x26\x26\x0a"
"                 \x21treat_as_floating_point<_Rep2>\x3a\x3avalue))\x0a"
"            >\x3a\x3atype* = 0)\x0a"
"                \x3a __rep_(_VSTD\x3a\x3a""chrono\x3a\x3a""duration_cast<duration>(__d).count()) {}\x0a"
"\x0a"
"    // observer\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR rep count() const {return __rep_;}\x0a"
"\x0a"
"    // arithmetic\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR typename common_type<duration>\x3a\x3atype operator+() const {return typename common_type<duration>\x3a\x3atype(*this);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR typename common_type<duration>\x3a\x3atype operator-() const {return typename common_type<duration>\x3a\x3atype(-__rep_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 duration\x26 operator++()      {++__rep_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 duration  operator++(int)   {return duration(__rep_++);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 duration\x26 operator--()      {--__rep_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 duration  operator--(int)   {return duration(__rep_--);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 duration\x26 operator+=(const duration\x26 __d) {__rep_ += __d.count(); return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 duration\x26 operator-=(const duration\x26 __d) {__rep_ -= __d.count(); return *this;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 duration\x26 operator*=(const rep\x26 rhs) {__rep_ *= rhs; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 duration\x26 operator/=(const rep\x26 rhs) {__rep_ /= rhs; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 duration\x26 operator\x25=(const rep\x26 rhs) {__rep_ \x25= rhs; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 duration\x26 operator\x25=(const duration\x26 rhs) {__rep_ \x25= rhs.count(); return *this;}\x0a"
"\x0a"
"    // special values\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR duration zero() _NOEXCEPT {return duration(duration_values<rep>\x3a\x3azero());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR duration min()  _NOEXCEPT {return duration(duration_values<rep>\x3a\x3amin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR duration max()  _NOEXCEPT {return duration(duration_values<rep>\x3a\x3amax());}\x0a"
"};\x0a"
"\x0a"
"typedef duration<long long,         nano> nanoseconds;\x0a"
"typedef duration<long long,        micro> microseconds;\x0a"
"typedef duration<long long,        milli> milliseconds;\x0a"
"typedef duration<long long              > seconds;\x0a"
"typedef duration<     long, ratio<  60> > minutes;\x0a"
"typedef duration<     long, ratio<3600> > hours;\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"typedef duration<     int, ratio_multiply<ratio<24>, hours\x3a\x3aperiod>>         days;\x0a"
"typedef duration<     int, ratio_multiply<ratio<7>,   days\x3a\x3aperiod>>         weeks;\x0a"
"typedef duration<     int, ratio_multiply<ratio<146097, 400>, days\x3a\x3aperiod>> years;\x0a"
"typedef duration<     int, ratio_divide<years\x3a\x3aperiod, ratio<12>>>           months;\x0a"
"#endif\x0a"
"// Duration ==\x0a"
"\x0a"
"template <class _LhsDuration, class _RhsDuration>\x0a"
"struct __duration_eq\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    bool operator()(const _LhsDuration\x26 __lhs, const _RhsDuration\x26 __rhs) const\x0a"
"        {\x0a"
"            typedef typename common_type<_LhsDuration, _RhsDuration>\x3a\x3atype _Ct;\x0a"
"            return _Ct(__lhs).count() == _Ct(__rhs).count();\x0a"
"        }\x0a"
"};\x0a"
"\x0a"
"template <class _LhsDuration>\x0a"
"struct __duration_eq<_LhsDuration, _LhsDuration>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    bool operator()(const _LhsDuration\x26 __lhs, const _LhsDuration\x26 __rhs) const\x0a"
"        {return __lhs.count() == __rhs.count();}\x0a"
"};\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"bool\x0a"
"operator==(const duration<_Rep1, _Period1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    return __duration_eq<duration<_Rep1, _Period1>, duration<_Rep2, _Period2> >()(__lhs, __rhs);\x0a"
"}\x0a"
"\x0a"
"// Duration \x21=\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"bool\x0a"
"operator\x21=(const duration<_Rep1, _Period1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    return \x21(__lhs == __rhs);\x0a"
"}\x0a"
"\x0a"
"// Duration <\x0a"
"\x0a"
"template <class _LhsDuration, class _RhsDuration>\x0a"
"struct __duration_lt\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    bool operator()(const _LhsDuration\x26 __lhs, const _RhsDuration\x26 __rhs) const\x0a"
"        {\x0a"
"            typedef typename common_type<_LhsDuration, _RhsDuration>\x3a\x3atype _Ct;\x0a"
"            return _Ct(__lhs).count() < _Ct(__rhs).count();\x0a"
"        }\x0a"
"};\x0a"
"\x0a"
"template <class _LhsDuration>\x0a"
"struct __duration_lt<_LhsDuration, _LhsDuration>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    bool operator()(const _LhsDuration\x26 __lhs, const _LhsDuration\x26 __rhs) const\x0a"
"        {return __lhs.count() < __rhs.count();}\x0a"
"};\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"bool\x0a"
"operator< (const duration<_Rep1, _Period1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    return __duration_lt<duration<_Rep1, _Period1>, duration<_Rep2, _Period2> >()(__lhs, __rhs);\x0a"
"}\x0a"
"\x0a"
"// Duration >\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"bool\x0a"
"operator> (const duration<_Rep1, _Period1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    return __rhs < __lhs;\x0a"
"}\x0a"
"\x0a"
"// Duration <=\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"bool\x0a"
"operator<=(const duration<_Rep1, _Period1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    return \x21(__rhs < __lhs);\x0a"
"}\x0a"
"\x0a"
"// Duration >=\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"bool\x0a"
"operator>=(const duration<_Rep1, _Period1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    return \x21(__lhs < __rhs);\x0a"
"}\x0a"
"\x0a"
"// Duration +\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"typename common_type<duration<_Rep1, _Period1>, duration<_Rep2, _Period2> >\x3a\x3atype\x0a"
"operator+(const duration<_Rep1, _Period1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    typedef typename common_type<duration<_Rep1, _Period1>, duration<_Rep2, _Period2> >\x3a\x3atype _Cd;\x0a"
"    return _Cd(_Cd(__lhs).count() + _Cd(__rhs).count());\x0a"
"}\x0a"
"\x0a"
"// Duration -\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"typename common_type<duration<_Rep1, _Period1>, duration<_Rep2, _Period2> >\x3a\x3atype\x0a"
"operator-(const duration<_Rep1, _Period1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    typedef typename common_type<duration<_Rep1, _Period1>, duration<_Rep2, _Period2> >\x3a\x3atype _Cd;\x0a"
"    return _Cd(_Cd(__lhs).count() - _Cd(__rhs).count());\x0a"
"}\x0a"
"\x0a"
"// Duration *\x0a"
"\x0a"
"template <class _Rep1, class _Period, class _Rep2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_convertible<_Rep2, typename common_type<_Rep1, _Rep2>\x3a\x3atype>\x3a\x3avalue,\x0a"
"    duration<typename common_type<_Rep1, _Rep2>\x3a\x3atype, _Period>\x0a"
">\x3a\x3atype\x0a"
"operator*(const duration<_Rep1, _Period>\x26 __d, const _Rep2\x26 __s)\x0a"
"{\x0a"
"    typedef typename common_type<_Rep1, _Rep2>\x3a\x3atype _Cr;\x0a"
"    typedef duration<_Cr, _Period> _Cd;\x0a"
"    return _Cd(_Cd(__d).count() * static_cast<_Cr>(__s));\x0a"
"}\x0a"
"\x0a"
"template <class _Rep1, class _Period, class _Rep2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_convertible<_Rep1, typename common_type<_Rep1, _Rep2>\x3a\x3atype>\x3a\x3avalue,\x0a"
"    duration<typename common_type<_Rep1, _Rep2>\x3a\x3atype, _Period>\x0a"
">\x3a\x3atype\x0a"
"operator*(const _Rep1\x26 __s, const duration<_Rep2, _Period>\x26 __d)\x0a"
"{\x0a"
"    return __d * __s;\x0a"
"}\x0a"
"\x0a"
"// Duration /\x0a"
"\x0a"
"template <class _Rep1, class _Period, class _Rep2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21__is_duration<_Rep2>\x3a\x3avalue \x26\x26\x0a"
"      is_convertible<_Rep2, typename common_type<_Rep1, _Rep2>\x3a\x3atype>\x3a\x3avalue,\x0a"
"    duration<typename common_type<_Rep1, _Rep2>\x3a\x3atype, _Period>\x0a"
">\x3a\x3atype\x0a"
"operator/(const duration<_Rep1, _Period>\x26 __d, const _Rep2\x26 __s)\x0a"
"{\x0a"
"    typedef typename common_type<_Rep1, _Rep2>\x3a\x3atype _Cr;\x0a"
"    typedef duration<_Cr, _Period> _Cd;\x0a"
"    return _Cd(_Cd(__d).count() / static_cast<_Cr>(__s));\x0a"
"}\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"typename common_type<_Rep1, _Rep2>\x3a\x3atype\x0a"
"operator/(const duration<_Rep1, _Period1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    typedef typename common_type<duration<_Rep1, _Period1>, duration<_Rep2, _Period2> >\x3a\x3atype _Ct;\x0a"
"    return _Ct(__lhs).count() / _Ct(__rhs).count();\x0a"
"}\x0a"
"\x0a"
"// Duration \x25\x0a"
"\x0a"
"template <class _Rep1, class _Period, class _Rep2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21__is_duration<_Rep2>\x3a\x3avalue \x26\x26\x0a"
"      is_convertible<_Rep2, typename common_type<_Rep1, _Rep2>\x3a\x3atype>\x3a\x3avalue,\x0a"
"    duration<typename common_type<_Rep1, _Rep2>\x3a\x3atype, _Period>\x0a"
">\x3a\x3atype\x0a"
"operator\x25(const duration<_Rep1, _Period>\x26 __d, const _Rep2\x26 __s)\x0a"
"{\x0a"
"    typedef typename common_type<_Rep1, _Rep2>\x3a\x3atype _Cr;\x0a"
"    typedef duration<_Cr, _Period> _Cd;\x0a"
"    return _Cd(_Cd(__d).count() \x25 static_cast<_Cr>(__s));\x0a"
"}\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"typename common_type<duration<_Rep1, _Period1>, duration<_Rep2, _Period2> >\x3a\x3atype\x0a"
"operator\x25(const duration<_Rep1, _Period1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    typedef typename common_type<_Rep1, _Rep2>\x3a\x3atype _Cr;\x0a"
"    typedef typename common_type<duration<_Rep1, _Period1>, duration<_Rep2, _Period2> >\x3a\x3atype _Cd;\x0a"
"    return _Cd(static_cast<_Cr>(_Cd(__lhs).count()) \x25 static_cast<_Cr>(_Cd(__rhs).count()));\x0a"
"}\x0a"
"\x0a"
"//////////////////////////////////////////////////////////\x0a"
"///////////////////// time_point /////////////////////////\x0a"
"//////////////////////////////////////////////////////////\x0a"
"\x0a"
"template <class _Clock, class _Duration = typename _Clock\x3a\x3a""duration>\x0a"
"class _LIBCPP_TEMPLATE_VIS time_point\x0a"
"{\x0a"
"    static_assert(__is_duration<_Duration>\x3a\x3avalue,\x0a"
"                  \x22Second template parameter of time_point must be a std\x3a\x3a""chrono\x3a\x3a""duration\x22);\x0a"
"public\x3a\x0a"
"    typedef _Clock                    clock;\x0a"
"    typedef _Duration                 duration;\x0a"
"    typedef typename duration\x3a\x3arep    rep;\x0a"
"    typedef typename duration\x3a\x3aperiod period;\x0a"
"private\x3a\x0a"
"    duration __d_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 time_point() \x3a __d_(duration\x3a\x3azero()) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 explicit time_point(const duration\x26 __d) \x3a __d_(__d) {}\x0a"
"\x0a"
"    // conversions\x0a"
"    template <class _Duration2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    time_point(const time_point<clock, _Duration2>\x26 t,\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<_Duration2, duration>\x3a\x3avalue\x0a"
"        >\x3a\x3atype* = 0)\x0a"
"            \x3a __d_(t.time_since_epoch()) {}\x0a"
"\x0a"
"    // observer\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 duration time_since_epoch() const {return __d_;}\x0a"
"\x0a"
"    // arithmetic\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 time_point\x26 operator+=(const duration\x26 __d) {__d_ += __d; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 time_point\x26 operator-=(const duration\x26 __d) {__d_ -= __d; return *this;}\x0a"
"\x0a"
"    // special values\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR time_point min() _NOEXCEPT {return time_point(duration\x3a\x3amin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR time_point max() _NOEXCEPT {return time_point(duration\x3a\x3amax());}\x0a"
"};\x0a"
"\x0a"
"} // chrono\x0a"
"\x0a"
"template <class _Clock, class _Duration1, class _Duration2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS common_type<chrono\x3a\x3atime_point<_Clock, _Duration1>,\x0a"
"                                         chrono\x3a\x3atime_point<_Clock, _Duration2> >\x0a"
"{\x0a"
"    typedef chrono\x3a\x3atime_point<_Clock, typename common_type<_Duration1, _Duration2>\x3a\x3atype> type;\x0a"
"};\x0a"
"\x0a"
"namespace chrono {\x0a"
"\x0a"
"template <class _ToDuration, class _Clock, class _Duration>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"time_point<_Clock, _ToDuration>\x0a"
"time_point_cast(const time_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    return time_point<_Clock, _ToDuration>(_VSTD\x3a\x3a""chrono\x3a\x3a""duration_cast<_ToDuration>(__t.time_since_epoch()));\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _ToDuration, class _Clock, class _Duration>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_duration<_ToDuration>\x3a\x3avalue,\x0a"
"    time_point<_Clock, _ToDuration>\x0a"
">\x3a\x3atype\x0a"
"floor(const time_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    return time_point<_Clock, _ToDuration>{floor<_ToDuration>(__t.time_since_epoch())};\x0a"
"}\x0a"
"\x0a"
"template <class _ToDuration, class _Clock, class _Duration>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_duration<_ToDuration>\x3a\x3avalue,\x0a"
"    time_point<_Clock, _ToDuration>\x0a"
">\x3a\x3atype\x0a"
"ceil(const time_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    return time_point<_Clock, _ToDuration>{ceil<_ToDuration>(__t.time_since_epoch())};\x0a"
"}\x0a"
"\x0a"
"template <class _ToDuration, class _Clock, class _Duration>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_duration<_ToDuration>\x3a\x3avalue,\x0a"
"    time_point<_Clock, _ToDuration>\x0a"
">\x3a\x3atype\x0a"
"round(const time_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    return time_point<_Clock, _ToDuration>{round<_ToDuration>(__t.time_since_epoch())};\x0a"
"}\x0a"
"\x0a"
"template <class _Rep, class _Period>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    numeric_limits<_Rep>\x3a\x3ais_signed,\x0a"
"    duration<_Rep, _Period>\x0a"
">\x3a\x3atype\x0a"
"abs(duration<_Rep, _Period> __d)\x0a"
"{\x0a"
"    return __d >= __d.zero() \x3f __d \x3a -__d;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"// time_point ==\x0a"
"\x0a"
"template <class _Clock, class _Duration1, class _Duration2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator==(const time_point<_Clock, _Duration1>\x26 __lhs, const time_point<_Clock, _Duration2>\x26 __rhs)\x0a"
"{\x0a"
"    return __lhs.time_since_epoch() == __rhs.time_since_epoch();\x0a"
"}\x0a"
"\x0a"
"// time_point \x21=\x0a"
"\x0a"
"template <class _Clock, class _Duration1, class _Duration2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator\x21=(const time_point<_Clock, _Duration1>\x26 __lhs, const time_point<_Clock, _Duration2>\x26 __rhs)\x0a"
"{\x0a"
"    return \x21(__lhs == __rhs);\x0a"
"}\x0a"
"\x0a"
"// time_point <\x0a"
"\x0a"
"template <class _Clock, class _Duration1, class _Duration2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator<(const time_point<_Clock, _Duration1>\x26 __lhs, const time_point<_Clock, _Duration2>\x26 __rhs)\x0a"
"{\x0a"
"    return __lhs.time_since_epoch() < __rhs.time_since_epoch();\x0a"
"}\x0a"
"\x0a"
"// time_point >\x0a"
"\x0a"
"template <class _Clock, class _Duration1, class _Duration2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator>(const time_point<_Clock, _Duration1>\x26 __lhs, const time_point<_Clock, _Duration2>\x26 __rhs)\x0a"
"{\x0a"
"    return __rhs < __lhs;\x0a"
"}\x0a"
"\x0a"
"// time_point <=\x0a"
"\x0a"
"template <class _Clock, class _Duration1, class _Duration2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator<=(const time_point<_Clock, _Duration1>\x26 __lhs, const time_point<_Clock, _Duration2>\x26 __rhs)\x0a"
"{\x0a"
"    return \x21(__rhs < __lhs);\x0a"
"}\x0a"
"\x0a"
"// time_point >=\x0a"
"\x0a"
"template <class _Clock, class _Duration1, class _Duration2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator>=(const time_point<_Clock, _Duration1>\x26 __lhs, const time_point<_Clock, _Duration2>\x26 __rhs)\x0a"
"{\x0a"
"    return \x21(__lhs < __rhs);\x0a"
"}\x0a"
"\x0a"
"// time_point operator+(time_point x, duration y);\x0a"
"\x0a"
"template <class _Clock, class _Duration1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"time_point<_Clock, typename common_type<_Duration1, duration<_Rep2, _Period2> >\x3a\x3atype>\x0a"
"operator+(const time_point<_Clock, _Duration1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    typedef time_point<_Clock, typename common_type<_Duration1, duration<_Rep2, _Period2> >\x3a\x3atype> _Tr;\x0a"
"    return _Tr (__lhs.time_since_epoch() + __rhs);\x0a"
"}\x0a"
"\x0a"
"// time_point operator+(duration x, time_point y);\x0a"
"\x0a"
"template <class _Rep1, class _Period1, class _Clock, class _Duration2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"time_point<_Clock, typename common_type<duration<_Rep1, _Period1>, _Duration2>\x3a\x3atype>\x0a"
"operator+(const duration<_Rep1, _Period1>\x26 __lhs, const time_point<_Clock, _Duration2>\x26 __rhs)\x0a"
"{\x0a"
"    return __rhs + __lhs;\x0a"
"}\x0a"
"\x0a"
"// time_point operator-(time_point x, duration y);\x0a"
"\x0a"
"template <class _Clock, class _Duration1, class _Rep2, class _Period2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"time_point<_Clock, typename common_type<_Duration1, duration<_Rep2, _Period2> >\x3a\x3atype>\x0a"
"operator-(const time_point<_Clock, _Duration1>\x26 __lhs, const duration<_Rep2, _Period2>\x26 __rhs)\x0a"
"{\x0a"
"    typedef time_point<_Clock, typename common_type<_Duration1, duration<_Rep2, _Period2> >\x3a\x3atype> _Ret;\x0a"
"    return _Ret(__lhs.time_since_epoch() -__rhs);\x0a"
"}\x0a"
"\x0a"
"// duration operator-(time_point x, time_point y);\x0a"
"\x0a"
"template <class _Clock, class _Duration1, class _Duration2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"typename common_type<_Duration1, _Duration2>\x3a\x3atype\x0a"
"operator-(const time_point<_Clock, _Duration1>\x26 __lhs, const time_point<_Clock, _Duration2>\x26 __rhs)\x0a"
"{\x0a"
"    return __lhs.time_since_epoch() - __rhs.time_since_epoch();\x0a"
"}\x0a"
"\x0a"
"//////////////////////////////////////////////////////////\x0a"
"/////////////////////// clocks ///////////////////////////\x0a"
"//////////////////////////////////////////////////////////\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS system_clock\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef microseconds                     duration;\x0a"
"    typedef duration\x3a\x3arep                    rep;\x0a"
"    typedef duration\x3a\x3aperiod                 period;\x0a"
"    typedef chrono\x3a\x3atime_point<system_clock> time_point;\x0a"
"    static _LIBCPP_CONSTEXPR_AFTER_CXX11 const bool is_steady = false;\x0a"
"\x0a"
"    static time_point now() _NOEXCEPT;\x0a"
"    static time_t     to_time_t  (const time_point\x26 __t) _NOEXCEPT;\x0a"
"    static time_point from_time_t(time_t __t) _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_MONOTONIC_CLOCK\x0a"
"class _LIBCPP_TYPE_VIS steady_clock\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef nanoseconds                                   duration;\x0a"
"    typedef duration\x3a\x3arep                                 rep;\x0a"
"    typedef duration\x3a\x3aperiod                              period;\x0a"
"    typedef chrono\x3a\x3atime_point<steady_clock, duration>    time_point;\x0a"
"    static _LIBCPP_CONSTEXPR_AFTER_CXX11 const bool is_steady = true;\x0a"
"\x0a"
"    static time_point now() _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"typedef steady_clock high_resolution_clock;\x0a"
"#else\x0a"
"typedef system_clock high_resolution_clock;\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"// \x5btime.clock.file\x5d, type file_clock\x0a"
"using file_clock = _VSTD_FS\x3a\x3a_FilesystemClock;\x0a"
"\x0a"
"template<class _Duration>\x0a"
"using file_time = time_point<file_clock, _Duration>;\x0a"
"\x0a"
"\x0a"
"template <class _Duration>\x0a"
"using sys_time    = time_point<system_clock, _Duration>;\x0a"
"using sys_seconds = sys_time<seconds>;\x0a"
"using sys_days    = sys_time<days>;\x0a"
"\x0a"
"struct local_t {};\x0a"
"template<class Duration>\x0a"
"using local_time  = time_point<local_t, Duration>;\x0a"
"using local_seconds = local_time<seconds>;\x0a"
"using local_days    = local_time<days>;\x0a"
"\x0a"
"\x0a"
"struct last_spec { explicit last_spec() = default; };\x0a"
"\x0a"
"class day {\x0a"
"private\x3a\x0a"
"    unsigned char __d;\x0a"
"public\x3a\x0a"
"    day() = default;\x0a"
"    explicit inline constexpr day(unsigned __val) noexcept \x3a __d(static_cast<unsigned char>(__val)) {}\x0a"
"    inline constexpr day\x26 operator++()    noexcept { ++__d; return *this; }\x0a"
"    inline constexpr day  operator++(int) noexcept { day __tmp = *this; ++(*this); return __tmp; }\x0a"
"    inline constexpr day\x26 operator--()    noexcept { --__d; return *this; }\x0a"
"    inline constexpr day  operator--(int) noexcept { day __tmp = *this; --(*this); return __tmp; }\x0a"
"           constexpr day\x26 operator+=(const days\x26 __dd) noexcept;\x0a"
"           constexpr day\x26 operator-=(const days\x26 __dd) noexcept;\x0a"
"    explicit inline constexpr operator unsigned() const noexcept { return __d; }\x0a"
"    inline constexpr bool ok() const noexcept { return __d >= 1 \x26\x26 __d <= 31; }\x0a"
"  };\x0a"
"\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const day\x26 __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return static_cast<unsigned>(__lhs) == static_cast<unsigned>(__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const day\x26 __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator< (const day\x26 __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return static_cast<unsigned>(__lhs) <  static_cast<unsigned>(__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator> (const day\x26 __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return __rhs < __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator<=(const day\x26 __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return \x21(__rhs < __lhs);}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator>=(const day\x26 __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs < __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"day operator+ (const day\x26 __lhs, const days\x26 __rhs) noexcept\x0a"
"{ return day(static_cast<unsigned>(__lhs) + __rhs.count()); }\x0a"
"\x0a"
"inline constexpr\x0a"
"day operator+ (const days\x26 __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"day operator- (const day\x26 __lhs, const days\x26 __rhs) noexcept\x0a"
"{ return __lhs + -__rhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"days operator-(const day\x26 __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return days(static_cast<int>(static_cast<unsigned>(__lhs)) -\x0a"
"              static_cast<int>(static_cast<unsigned>(__rhs))); }\x0a"
"\x0a"
"inline constexpr day\x26 day\x3a\x3aoperator+=(const days\x26 __dd) noexcept\x0a"
"{ *this = *this + __dd; return *this; }\x0a"
"\x0a"
"inline constexpr day\x26 day\x3a\x3aoperator-=(const days\x26 __dd) noexcept\x0a"
"{ *this = *this - __dd; return *this; }\x0a"
"\x0a"
"\x0a"
"class month {\x0a"
"private\x3a\x0a"
"    unsigned char __m;\x0a"
"public\x3a\x0a"
"    month() = default;\x0a"
"    explicit inline constexpr month(unsigned __val) noexcept \x3a __m(static_cast<unsigned char>(__val)) {}\x0a"
"    inline constexpr month\x26 operator++()    noexcept { ++__m; return *this; }\x0a"
"    inline constexpr month  operator++(int) noexcept { month __tmp = *this; ++(*this); return __tmp; }\x0a"
"    inline constexpr month\x26 operator--()    noexcept { --__m; return *this; }\x0a"
"    inline constexpr month  operator--(int) noexcept { month __tmp = *this; --(*this); return __tmp; }\x0a"
"           constexpr month\x26 operator+=(const months\x26 __m1) noexcept;\x0a"
"           constexpr month\x26 operator-=(const months\x26 __m1) noexcept;\x0a"
"    explicit inline constexpr operator unsigned() const noexcept { return __m; }\x0a"
"    inline constexpr bool ok() const noexcept { return __m >= 1 \x26\x26 __m <= 12; }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const month\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{ return static_cast<unsigned>(__lhs) == static_cast<unsigned>(__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const month\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator< (const month\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{ return static_cast<unsigned>(__lhs)  < static_cast<unsigned>(__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator> (const month\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{ return __rhs < __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator<=(const month\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{ return \x21(__rhs < __lhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator>=(const month\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs < __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"month operator+ (const month\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{\x0a"
"    auto const __mu = static_cast<long long>(static_cast<unsigned>(__lhs)) + (__rhs.count() - 1);\x0a"
"    auto const __yr = (__mu >= 0 \x3f __mu \x3a __mu - 11) / 12;\x0a"
"    return month{static_cast<unsigned>(__mu - __yr * 12 + 1)};\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"month operator+ (const months\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month operator- (const month\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{ return __lhs + -__rhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"months operator-(const month\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{\x0a"
"    auto const __dm = static_cast<unsigned>(__lhs) - static_cast<unsigned>(__rhs);\x0a"
"    return months(__dm <= 11 \x3f __dm \x3a __dm + 12);\x0a"
"}\x0a"
"\x0a"
"inline constexpr month\x26 month\x3a\x3aoperator+=(const months\x26 __dm) noexcept\x0a"
"{ *this = *this + __dm; return *this; }\x0a"
"\x0a"
"inline constexpr month\x26 month\x3a\x3aoperator-=(const months\x26 __dm) noexcept\x0a"
"{ *this = *this - __dm; return *this; }\x0a"
"\x0a"
"\x0a"
"class year {\x0a"
"private\x3a\x0a"
"    short __y;\x0a"
"public\x3a\x0a"
"    year() = default;\x0a"
"    explicit inline constexpr year(int __val) noexcept \x3a __y(static_cast<short>(__val)) {}\x0a"
"\x0a"
"    inline constexpr year\x26 operator++()    noexcept { ++__y; return *this; }\x0a"
"    inline constexpr year  operator++(int) noexcept { year __tmp = *this; ++(*this); return __tmp; }\x0a"
"    inline constexpr year\x26 operator--()    noexcept { --__y; return *this; }\x0a"
"    inline constexpr year  operator--(int) noexcept { year __tmp = *this; --(*this); return __tmp; }\x0a"
"           constexpr year\x26 operator+=(const years\x26 __dy) noexcept;\x0a"
"           constexpr year\x26 operator-=(const years\x26 __dy) noexcept;\x0a"
"    inline constexpr year operator+() const noexcept { return *this; }\x0a"
"    inline constexpr year operator-() const noexcept { return year{-__y}; }\x0a"
"\x0a"
"    inline constexpr bool is_leap() const noexcept { return __y \x25 4 == 0 \x26\x26 (__y \x25 100 \x21= 0 \x7c\x7c __y \x25 400 == 0); }\x0a"
"    explicit inline constexpr operator int() const noexcept { return __y; }\x0a"
"           constexpr bool ok() const noexcept;\x0a"
"    static inline constexpr year min() noexcept { return year{-32767}; }\x0a"
"    static inline constexpr year max() noexcept { return year{ 32767}; }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const year\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return static_cast<int>(__lhs) == static_cast<int>(__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const year\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator< (const year\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return static_cast<int>(__lhs)  < static_cast<int>(__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator> (const year\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return __rhs < __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator<=(const year\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return \x21(__rhs < __lhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator>=(const year\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs < __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year operator+ (const year\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return year(static_cast<int>(__lhs) + __rhs.count()); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year operator+ (const years\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year operator- (const year\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return __lhs + -__rhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"years operator-(const year\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return years{static_cast<int>(__lhs) - static_cast<int>(__rhs)}; }\x0a"
"\x0a"
"\x0a"
"inline constexpr year\x26 year\x3a\x3aoperator+=(const years\x26 __dy) noexcept\x0a"
"{ *this = *this + __dy; return *this; }\x0a"
"\x0a"
"inline constexpr year\x26 year\x3a\x3aoperator-=(const years\x26 __dy) noexcept\x0a"
"{ *this = *this - __dy; return *this; }\x0a"
"\x0a"
"inline constexpr bool year\x3a\x3aok() const noexcept\x0a"
"{ return static_cast<int>(min()) <= __y \x26\x26 __y <= static_cast<int>(max()); }\x0a"
"\x0a"
"class weekday_indexed;\x0a"
"class weekday_last;\x0a"
"\x0a"
"class weekday {\x0a"
"private\x3a\x0a"
"    unsigned char __wd;\x0a"
"public\x3a\x0a"
"  weekday() = default;\x0a"
"  inline explicit constexpr weekday(unsigned __val) noexcept \x3a __wd(static_cast<unsigned char>(__val)) {}\x0a"
"  inline constexpr          weekday(const sys_days\x26 __sysd) noexcept\x0a"
"          \x3a __wd(__weekday_from_days(__sysd.time_since_epoch().count())) {}\x0a"
"  inline explicit constexpr weekday(const local_days\x26 __locd) noexcept\x0a"
"          \x3a __wd(__weekday_from_days(__locd.time_since_epoch().count())) {}\x0a"
"\x0a"
"  inline constexpr weekday\x26 operator++()    noexcept { __wd = (__wd == 6 \x3f 0 \x3a __wd + 1); return *this; }\x0a"
"  inline constexpr weekday  operator++(int) noexcept { weekday __tmp = *this; ++(*this); return __tmp; }\x0a"
"  inline constexpr weekday\x26 operator--()    noexcept { __wd = (__wd == 0 \x3f 6 \x3a __wd - 1); return *this; }\x0a"
"  inline constexpr weekday  operator--(int) noexcept { weekday __tmp = *this; --(*this); return __tmp; }\x0a"
"         constexpr weekday\x26 operator+=(const days\x26 __dd) noexcept;\x0a"
"         constexpr weekday\x26 operator-=(const days\x26 __dd) noexcept;\x0a"
"  inline explicit constexpr operator unsigned() const noexcept { return __wd; }\x0a"
"  inline constexpr bool ok() const noexcept { return __wd <= 6; }\x0a"
"         constexpr weekday_indexed operator\x5b\x5d(unsigned __index) const noexcept;\x0a"
"         constexpr weekday_last    operator\x5b\x5d(last_spec) const noexcept;\x0a"
"\x0a"
"  static constexpr unsigned char __weekday_from_days(int __days) noexcept;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"// https\x3a//howardhinnant.github.io/date_algorithms.html#weekday_from_days\x0a"
"inline constexpr\x0a"
"unsigned char weekday\x3a\x3a__weekday_from_days(int __days) noexcept\x0a"
"{\x0a"
"    return static_cast<unsigned char>(\x0a"
"              static_cast<unsigned>(__days >= -4 \x3f (__days+4) \x25 7 \x3a (__days+5) \x25 7 + 6)\x0a"
"           );\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const weekday\x26 __lhs, const weekday\x26 __rhs) noexcept\x0a"
"{ return static_cast<unsigned>(__lhs) == static_cast<unsigned>(__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const weekday\x26 __lhs, const weekday\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator< (const weekday\x26 __lhs, const weekday\x26 __rhs) noexcept\x0a"
"{ return static_cast<unsigned>(__lhs) <  static_cast<unsigned>(__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator> (const weekday\x26 __lhs, const weekday\x26 __rhs) noexcept\x0a"
"{ return __rhs < __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator<=(const weekday\x26 __lhs, const weekday\x26 __rhs) noexcept\x0a"
"{ return \x21(__rhs < __lhs);}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator>=(const weekday\x26 __lhs, const weekday\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs < __rhs); }\x0a"
"\x0a"
"constexpr weekday operator+(const weekday\x26 __lhs, const days\x26 __rhs) noexcept\x0a"
"{\x0a"
"    auto const __mu = static_cast<long long>(static_cast<unsigned>(__lhs)) + __rhs.count();\x0a"
"    auto const __yr = (__mu >= 0 \x3f __mu \x3a __mu - 6) / 7;\x0a"
"    return weekday{static_cast<unsigned>(__mu - __yr * 7)};\x0a"
"}\x0a"
"\x0a"
"constexpr weekday operator+(const days\x26 __lhs, const weekday\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"constexpr weekday operator-(const weekday\x26 __lhs, const days\x26 __rhs) noexcept\x0a"
"{ return __lhs + -__rhs; }\x0a"
"\x0a"
"constexpr days operator-(const weekday\x26 __lhs, const weekday\x26 __rhs) noexcept\x0a"
"{\x0a"
"    const int __wdu = static_cast<unsigned>(__lhs) - static_cast<unsigned>(__rhs);\x0a"
"    const int __wk = (__wdu >= 0 \x3f __wdu \x3a __wdu-6) / 7;\x0a"
"    return days{__wdu - __wk * 7};\x0a"
"}\x0a"
"\x0a"
"inline constexpr weekday\x26 weekday\x3a\x3aoperator+=(const days\x26 __dd) noexcept\x0a"
"{ *this = *this + __dd; return *this; }\x0a"
"\x0a"
"inline constexpr weekday\x26 weekday\x3a\x3aoperator-=(const days\x26 __dd) noexcept\x0a"
"{ *this = *this - __dd; return *this; }\x0a"
"\x0a"
"\x0a"
"class weekday_indexed {\x0a"
"private\x3a\x0a"
"    _VSTD\x3a\x3a""chrono\x3a\x3aweekday __wd;\x0a"
"    unsigned char          __idx;\x0a"
"public\x3a\x0a"
"    weekday_indexed() = default;\x0a"
"    inline constexpr weekday_indexed(const _VSTD\x3a\x3a""chrono\x3a\x3aweekday\x26 __wdval, unsigned __idxval) noexcept\x0a"
"        \x3a __wd{__wdval}, __idx(__idxval) {}\x0a"
"    inline constexpr _VSTD\x3a\x3a""chrono\x3a\x3aweekday weekday() const noexcept { return __wd; }\x0a"
"    inline constexpr unsigned                 index() const noexcept { return __idx; }\x0a"
"    inline constexpr bool ok() const noexcept { return __wd.ok() \x26\x26 __idx >= 1 \x26\x26 __idx <= 5; }\x0a"
"};\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const weekday_indexed\x26 __lhs, const weekday_indexed\x26 __rhs) noexcept\x0a"
"{ return __lhs.weekday() == __rhs.weekday() \x26\x26 __lhs.index() == __rhs.index(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const weekday_indexed\x26 __lhs, const weekday_indexed\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"\x0a"
"class weekday_last {\x0a"
"private\x3a\x0a"
"    _VSTD\x3a\x3a""chrono\x3a\x3aweekday __wd;\x0a"
"public\x3a\x0a"
"    explicit constexpr weekday_last(const _VSTD\x3a\x3a""chrono\x3a\x3aweekday\x26 __val) noexcept\x0a"
"        \x3a __wd{__val} {}\x0a"
"    constexpr _VSTD\x3a\x3a""chrono\x3a\x3aweekday weekday() const noexcept { return __wd; }\x0a"
"    constexpr bool ok() const noexcept { return __wd.ok(); }\x0a"
"};\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const weekday_last\x26 __lhs, const weekday_last\x26 __rhs) noexcept\x0a"
"{ return __lhs.weekday() == __rhs.weekday(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const weekday_last\x26 __lhs, const weekday_last\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"weekday_indexed weekday\x3a\x3aoperator\x5b\x5d(unsigned __index) const noexcept { return weekday_indexed{*this, __index}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"weekday_last    weekday\x3a\x3aoperator\x5b\x5d(last_spec) const noexcept { return weekday_last{*this}; }\x0a"
"\x0a"
"\x0a"
"inline constexpr last_spec last{};\x0a"
"inline constexpr weekday   Sunday{0};\x0a"
"inline constexpr weekday   Monday{1};\x0a"
"inline constexpr weekday   Tuesday{2};\x0a"
"inline constexpr weekday   Wednesday{3};\x0a"
"inline constexpr weekday   Thursday{4};\x0a"
"inline constexpr weekday   Friday{5};\x0a"
"inline constexpr weekday   Saturday{6};\x0a"
"\x0a"
"inline constexpr month January{1};\x0a"
"inline constexpr month February{2};\x0a"
"inline constexpr month March{3};\x0a"
"inline constexpr month April{4};\x0a"
"inline constexpr month May{5};\x0a"
"inline constexpr month June{6};\x0a"
"inline constexpr month July{7};\x0a"
"inline constexpr month August{8};\x0a"
"inline constexpr month September{9};\x0a"
"inline constexpr month October{10};\x0a"
"inline constexpr month November{11};\x0a"
"inline constexpr month December{12};\x0a"
"\x0a"
"\x0a"
"class month_day {\x0a"
"private\x3a\x0a"
"   chrono\x3a\x3amonth __m;\x0a"
"   chrono\x3a\x3a""day   __d;\x0a"
"public\x3a\x0a"
"    month_day() = default;\x0a"
"    constexpr month_day(const chrono\x3a\x3amonth\x26 __mval, const chrono\x3a\x3a""day\x26 __dval) noexcept\x0a"
"        \x3a __m{__mval}, __d{__dval} {}\x0a"
"    inline constexpr chrono\x3a\x3amonth month() const noexcept { return __m; }\x0a"
"    inline constexpr chrono\x3a\x3a""day   day()   const noexcept { return __d; }\x0a"
"    constexpr bool ok() const noexcept;\x0a"
"};\x0a"
"\x0a"
"inline constexpr\x0a"
"bool month_day\x3a\x3aok() const noexcept\x0a"
"{\x0a"
"    if (\x21__m.ok()) return false;\x0a"
"    const unsigned __dval = static_cast<unsigned>(__d);\x0a"
"    if (__dval < 1 \x7c\x7c __dval > 31) return false;\x0a"
"    if (__dval <= 29) return true;\x0a"
"//  Now we've got either 30 or 31\x0a"
"    const unsigned __mval = static_cast<unsigned>(__m);\x0a"
"    if (__mval == 2) return false;\x0a"
"    if (__mval == 4 \x7c\x7c __mval == 6 \x7c\x7c __mval == 9 \x7c\x7c __mval == 11)\x0a"
"        return __dval == 30;\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const month_day\x26 __lhs, const month_day\x26 __rhs) noexcept\x0a"
"{ return __lhs.month() == __rhs.month() \x26\x26 __lhs.day() == __rhs.day(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const month_day\x26 __lhs, const month_day\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_day operator/(const month\x26 __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return month_day{__lhs, __rhs}; }\x0a"
"\x0a"
"constexpr\x0a"
"month_day operator/(const day\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{ return __rhs / __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_day operator/(const month\x26 __lhs, int __rhs) noexcept\x0a"
"{ return __lhs / day(__rhs); }\x0a"
"\x0a"
"constexpr\x0a"
"month_day operator/(int __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return month(__lhs) / __rhs; }\x0a"
"\x0a"
"constexpr\x0a"
"month_day operator/(const day\x26 __lhs, int __rhs) noexcept\x0a"
"{ return month(__rhs) / __lhs; }\x0a"
"\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator< (const month_day\x26 __lhs, const month_day\x26 __rhs) noexcept\x0a"
"{ return __lhs.month() \x21= __rhs.month() \x3f __lhs.month() < __rhs.month() \x3a __lhs.day() < __rhs.day(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator> (const month_day\x26 __lhs, const month_day\x26 __rhs) noexcept\x0a"
"{ return __rhs < __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator<=(const month_day\x26 __lhs, const month_day\x26 __rhs) noexcept\x0a"
"{ return \x21(__rhs < __lhs);}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator>=(const month_day\x26 __lhs, const month_day\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs < __rhs); }\x0a"
"\x0a"
"\x0a"
"\x0a"
"class month_day_last {\x0a"
"private\x3a\x0a"
"    chrono\x3a\x3amonth __m;\x0a"
"public\x3a\x0a"
"    explicit constexpr month_day_last(const chrono\x3a\x3amonth\x26 __val) noexcept\x0a"
"        \x3a __m{__val} {}\x0a"
"    inline constexpr chrono\x3a\x3amonth month() const noexcept { return __m; }\x0a"
"    inline constexpr bool ok() const noexcept { return __m.ok(); }\x0a"
"};\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const month_day_last\x26 __lhs, const month_day_last\x26 __rhs) noexcept\x0a"
"{ return __lhs.month() == __rhs.month(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const month_day_last\x26 __lhs, const month_day_last\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator< (const month_day_last\x26 __lhs, const month_day_last\x26 __rhs) noexcept\x0a"
"{ return __lhs.month() < __rhs.month(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator> (const month_day_last\x26 __lhs, const month_day_last\x26 __rhs) noexcept\x0a"
"{ return __rhs < __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator<=(const month_day_last\x26 __lhs, const month_day_last\x26 __rhs) noexcept\x0a"
"{ return \x21(__rhs < __lhs);}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator>=(const month_day_last\x26 __lhs, const month_day_last\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs < __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_day_last operator/(const month\x26 __lhs, last_spec) noexcept\x0a"
"{ return month_day_last{__lhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_day_last operator/(last_spec, const month\x26 __rhs) noexcept\x0a"
"{ return month_day_last{__rhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_day_last operator/(int __lhs, last_spec) noexcept\x0a"
"{ return month_day_last{month(__lhs)}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_day_last operator/(last_spec, int __rhs) noexcept\x0a"
"{ return month_day_last{month(__rhs)}; }\x0a"
"\x0a"
"\x0a"
"class month_weekday {\x0a"
"private\x3a\x0a"
"    chrono\x3a\x3amonth __m;\x0a"
"    chrono\x3a\x3aweekday_indexed __wdi;\x0a"
"public\x3a\x0a"
"    month_weekday() = default;\x0a"
"    constexpr month_weekday(const chrono\x3a\x3amonth\x26 __mval, const chrono\x3a\x3aweekday_indexed\x26 __wdival) noexcept\x0a"
"        \x3a __m{__mval}, __wdi{__wdival} {}\x0a"
"    inline constexpr chrono\x3a\x3amonth                     month() const noexcept { return __m; }\x0a"
"    inline constexpr chrono\x3a\x3aweekday_indexed weekday_indexed() const noexcept { return __wdi; }\x0a"
"    inline constexpr bool                                 ok() const noexcept { return __m.ok() \x26\x26 __wdi.ok(); }\x0a"
"};\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const month_weekday\x26 __lhs, const month_weekday\x26 __rhs) noexcept\x0a"
"{ return __lhs.month() == __rhs.month() \x26\x26 __lhs.weekday_indexed() == __rhs.weekday_indexed(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const month_weekday\x26 __lhs, const month_weekday\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_weekday operator/(const month\x26 __lhs, const weekday_indexed\x26 __rhs) noexcept\x0a"
"{ return month_weekday{__lhs, __rhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_weekday operator/(int __lhs, const weekday_indexed\x26 __rhs) noexcept\x0a"
"{ return month_weekday{month(__lhs), __rhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_weekday operator/(const weekday_indexed\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{ return month_weekday{__rhs, __lhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_weekday operator/(const weekday_indexed\x26 __lhs, int __rhs) noexcept\x0a"
"{ return month_weekday{month(__rhs), __lhs}; }\x0a"
"\x0a"
"\x0a"
"class month_weekday_last {\x0a"
"    chrono\x3a\x3amonth        __m;\x0a"
"    chrono\x3a\x3aweekday_last __wdl;\x0a"
"  public\x3a\x0a"
"    constexpr month_weekday_last(const chrono\x3a\x3amonth\x26 __mval, const chrono\x3a\x3aweekday_last\x26 __wdlval) noexcept\x0a"
"        \x3a __m{__mval}, __wdl{__wdlval} {}\x0a"
"    inline constexpr chrono\x3a\x3amonth               month() const noexcept { return __m; }\x0a"
"    inline constexpr chrono\x3a\x3aweekday_last weekday_last() const noexcept { return __wdl; }\x0a"
"    inline constexpr bool                           ok() const noexcept { return __m.ok() \x26\x26 __wdl.ok(); }\x0a"
"};\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const month_weekday_last\x26 __lhs, const month_weekday_last\x26 __rhs) noexcept\x0a"
"{ return __lhs.month() == __rhs.month() \x26\x26 __lhs.weekday_last() == __rhs.weekday_last(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const month_weekday_last\x26 __lhs, const month_weekday_last\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"\x0a"
"inline constexpr\x0a"
"month_weekday_last operator/(const month\x26 __lhs, const weekday_last\x26 __rhs) noexcept\x0a"
"{ return month_weekday_last{__lhs, __rhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_weekday_last operator/(int __lhs, const weekday_last\x26 __rhs) noexcept\x0a"
"{ return month_weekday_last{month(__lhs), __rhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_weekday_last operator/(const weekday_last\x26 __lhs, const month\x26 __rhs) noexcept\x0a"
"{ return month_weekday_last{__rhs, __lhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"month_weekday_last operator/(const weekday_last\x26 __lhs, int __rhs) noexcept\x0a"
"{ return month_weekday_last{month(__rhs), __lhs}; }\x0a"
"\x0a"
"\x0a"
"class year_month {\x0a"
"    chrono\x3a\x3ayear  __y;\x0a"
"    chrono\x3a\x3amonth __m;\x0a"
"public\x3a\x0a"
"    year_month() = default;\x0a"
"    constexpr year_month(const chrono\x3a\x3ayear\x26 __yval, const chrono\x3a\x3amonth\x26 __mval) noexcept\x0a"
"        \x3a __y{__yval}, __m{__mval} {}\x0a"
"    inline constexpr chrono\x3a\x3ayear  year()  const noexcept { return __y; }\x0a"
"    inline constexpr chrono\x3a\x3amonth month() const noexcept { return __m; }\x0a"
"    inline constexpr year_month\x26 operator+=(const months\x26 __dm) noexcept { this->__m += __dm; return *this; }\x0a"
"    inline constexpr year_month\x26 operator-=(const months\x26 __dm) noexcept { this->__m -= __dm; return *this; }\x0a"
"    inline constexpr year_month\x26 operator+=(const years\x26 __dy)  noexcept { this->__y += __dy; return *this; }\x0a"
"    inline constexpr year_month\x26 operator-=(const years\x26 __dy)  noexcept { this->__y -= __dy; return *this; }\x0a"
"    inline constexpr bool ok() const noexcept { return __y.ok() \x26\x26 __m.ok(); }\x0a"
"};\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month operator/(const year\x26 __y, const month\x26 __m) noexcept { return year_month{__y, __m}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month operator/(const year\x26 __y, int __m) noexcept { return year_month{__y, month(__m)}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const year_month\x26 __lhs, const year_month\x26 __rhs) noexcept\x0a"
"{ return __lhs.year() == __rhs.year() \x26\x26 __lhs.month() == __rhs.month(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const year_month\x26 __lhs, const year_month\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator< (const year_month\x26 __lhs, const year_month\x26 __rhs) noexcept\x0a"
"{ return __lhs.year() \x21= __rhs.year() \x3f __lhs.year() < __rhs.year() \x3a __lhs.month() < __rhs.month(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator> (const year_month\x26 __lhs, const year_month\x26 __rhs) noexcept\x0a"
"{ return __rhs < __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator<=(const year_month\x26 __lhs, const year_month\x26 __rhs) noexcept\x0a"
"{ return \x21(__rhs < __lhs);}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator>=(const year_month\x26 __lhs, const year_month\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs < __rhs); }\x0a"
"\x0a"
"constexpr year_month operator+(const year_month\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{\x0a"
"    int __dmi = static_cast<int>(static_cast<unsigned>(__lhs.month())) - 1 + __rhs.count();\x0a"
"    const int __dy = (__dmi >= 0 \x3f __dmi \x3a __dmi-11) / 12;\x0a"
"    __dmi = __dmi - __dy * 12 + 1;\x0a"
"    return (__lhs.year() + years(__dy)) / month(static_cast<unsigned>(__dmi));\x0a"
"}\x0a"
"\x0a"
"constexpr year_month operator+(const months\x26 __lhs, const year_month\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"constexpr year_month operator+(const year_month\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return (__lhs.year() + __rhs) / __lhs.month(); }\x0a"
"\x0a"
"constexpr year_month operator+(const years\x26 __lhs, const year_month\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"constexpr months     operator-(const year_month\x26 __lhs, const year_month\x26 __rhs) noexcept\x0a"
"{ return (__lhs.year() - __rhs.year()) + months(static_cast<unsigned>(__lhs.month()) - static_cast<unsigned>(__rhs.month())); }\x0a"
"\x0a"
"constexpr year_month operator-(const year_month\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{ return __lhs + -__rhs; }\x0a"
"\x0a"
"constexpr year_month operator-(const year_month\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return __lhs + -__rhs; }\x0a"
"\x0a"
"class year_month_day_last;\x0a"
"\x0a"
"class year_month_day {\x0a"
"private\x3a\x0a"
"    chrono\x3a\x3ayear  __y;\x0a"
"    chrono\x3a\x3amonth __m;\x0a"
"    chrono\x3a\x3a""day   __d;\x0a"
"public\x3a\x0a"
"     year_month_day() = default;\x0a"
"     inline constexpr year_month_day(\x0a"
"            const chrono\x3a\x3ayear\x26 __yval, const chrono\x3a\x3amonth\x26 __mval, const chrono\x3a\x3a""day\x26 __dval) noexcept\x0a"
"            \x3a __y{__yval}, __m{__mval}, __d{__dval} {}\x0a"
"            constexpr year_month_day(const year_month_day_last\x26 __ymdl) noexcept;\x0a"
"     inline constexpr year_month_day(const sys_days\x26 __sysd) noexcept\x0a"
"            \x3a year_month_day(__from_days(__sysd.time_since_epoch())) {}\x0a"
"     inline explicit constexpr year_month_day(const local_days\x26 __locd) noexcept\x0a"
"            \x3a year_month_day(__from_days(__locd.time_since_epoch())) {}\x0a"
"\x0a"
"            constexpr year_month_day\x26 operator+=(const months\x26 __dm) noexcept;\x0a"
"            constexpr year_month_day\x26 operator-=(const months\x26 __dm) noexcept;\x0a"
"            constexpr year_month_day\x26 operator+=(const years\x26 __dy)  noexcept;\x0a"
"            constexpr year_month_day\x26 operator-=(const years\x26 __dy)  noexcept;\x0a"
"\x0a"
"     inline constexpr chrono\x3a\x3ayear   year() const noexcept { return __y; }\x0a"
"     inline constexpr chrono\x3a\x3amonth month() const noexcept { return __m; }\x0a"
"     inline constexpr chrono\x3a\x3a""day     day() const noexcept { return __d; }\x0a"
"     inline constexpr operator   sys_days() const noexcept          { return   sys_days{__to_days()}; }\x0a"
"     inline explicit constexpr operator local_days() const noexcept { return local_days{__to_days()}; }\x0a"
"\x0a"
"            constexpr bool             ok() const noexcept;\x0a"
"\x0a"
"     static constexpr year_month_day __from_days(days __d) noexcept;\x0a"
"     constexpr days __to_days() const noexcept;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"// https\x3a//howardhinnant.github.io/date_algorithms.html#civil_from_days\x0a"
"inline constexpr\x0a"
"year_month_day\x0a"
"year_month_day\x3a\x3a__from_days(days __d) noexcept\x0a"
"{\x0a"
"    static_assert(std\x3a\x3anumeric_limits<unsigned>\x3a\x3a""digits >= 18, \x22\x22);\x0a"
"    static_assert(std\x3a\x3anumeric_limits<int>\x3a\x3a""digits >= 20     , \x22\x22);\x0a"
"    const int      __z = __d.count() + 719468;\x0a"
"    const int      __era = (__z >= 0 \x3f __z \x3a __z - 146096) / 146097;\x0a"
"    const unsigned __doe = static_cast<unsigned>(__z - __era * 146097);              // \x5b""0, 146096\x5d\x0a"
"    const unsigned __yoe = (__doe - __doe/1460 + __doe/36524 - __doe/146096) / 365;  // \x5b""0, 399\x5d\x0a"
"    const int      __yr = static_cast<int>(__yoe) + __era * 400;\x0a"
"    const unsigned __doy = __doe - (365 * __yoe + __yoe/4 - __yoe/100);              // \x5b""0, 365\x5d\x0a"
"    const unsigned __mp = (5 * __doy + 2)/153;                                       // \x5b""0, 11\x5d\x0a"
"    const unsigned __dy = __doy - (153 * __mp + 2)/5 + 1;                            // \x5b""1, 31\x5d\x0a"
"    const unsigned __mth = __mp + (__mp < 10 \x3f 3 \x3a -9);                              // \x5b""1, 12\x5d\x0a"
"    return year_month_day{chrono\x3a\x3ayear{__yr + (__mth <= 2)}, chrono\x3a\x3amonth{__mth}, chrono\x3a\x3a""day{__dy}};\x0a"
"}\x0a"
"\x0a"
"// https\x3a//howardhinnant.github.io/date_algorithms.html#days_from_civil\x0a"
"inline constexpr days year_month_day\x3a\x3a__to_days() const noexcept\x0a"
"{\x0a"
"    static_assert(std\x3a\x3anumeric_limits<unsigned>\x3a\x3a""digits >= 18, \x22\x22);\x0a"
"    static_assert(std\x3a\x3anumeric_limits<int>\x3a\x3a""digits >= 20     , \x22\x22);\x0a"
"\x0a"
"    const int      __yr  = static_cast<int>(__y) - (__m <= February);\x0a"
"    const unsigned __mth = static_cast<unsigned>(__m);\x0a"
"    const unsigned __dy  = static_cast<unsigned>(__d);\x0a"
"\x0a"
"    const int      __era = (__yr >= 0 \x3f __yr \x3a __yr - 399) / 400;\x0a"
"    const unsigned __yoe = static_cast<unsigned>(__yr - __era * 400);                // \x5b""0, 399\x5d\x0a"
"    const unsigned __doy = (153 * (__mth + (__mth > 2 \x3f -3 \x3a 9)) + 2) / 5 + __dy-1;  // \x5b""0, 365\x5d\x0a"
"    const unsigned __doe = __yoe * 365 + __yoe/4 - __yoe/100 + __doy;                // \x5b""0, 146096\x5d\x0a"
"    return days{__era * 146097 + static_cast<int>(__doe) - 719468};\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const year_month_day\x26 __lhs, const year_month_day\x26 __rhs) noexcept\x0a"
"{ return __lhs.year() == __rhs.year() \x26\x26 __lhs.month() == __rhs.month() \x26\x26 __lhs.day() == __rhs.day(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const year_month_day\x26 __lhs, const year_month_day\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator< (const year_month_day\x26 __lhs, const year_month_day\x26 __rhs) noexcept\x0a"
"{\x0a"
"    if (__lhs.year() < __rhs.year()) return true;\x0a"
"    if (__lhs.year() > __rhs.year()) return false;\x0a"
"    if (__lhs.month() < __rhs.month()) return true;\x0a"
"    if (__lhs.month() > __rhs.month()) return false;\x0a"
"    return __lhs.day() < __rhs.day();\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator> (const year_month_day\x26 __lhs, const year_month_day\x26 __rhs) noexcept\x0a"
"{ return __rhs < __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator<=(const year_month_day\x26 __lhs, const year_month_day\x26 __rhs) noexcept\x0a"
"{ return \x21(__rhs < __lhs);}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator>=(const year_month_day\x26 __lhs, const year_month_day\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs < __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator/(const year_month\x26 __lhs, const day\x26 __rhs) noexcept\x0a"
"{ return year_month_day{__lhs.year(), __lhs.month(), __rhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator/(const year_month\x26 __lhs, int __rhs) noexcept\x0a"
"{ return __lhs / day(__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator/(const year\x26 __lhs, const month_day\x26 __rhs) noexcept\x0a"
"{ return __lhs / __rhs.month() / __rhs.day(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator/(int __lhs, const month_day\x26 __rhs) noexcept\x0a"
"{ return year(__lhs) / __rhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator/(const month_day\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return __rhs / __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator/(const month_day\x26 __lhs, int __rhs) noexcept\x0a"
"{ return year(__rhs) / __lhs; }\x0a"
"\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator+(const year_month_day\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{ return (__lhs.year()/__lhs.month() + __rhs)/__lhs.day(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator+(const months\x26 __lhs, const year_month_day\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator-(const year_month_day\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{ return __lhs + -__rhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator+(const year_month_day\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return (__lhs.year() + __rhs) / __lhs.month() / __lhs.day(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator+(const years\x26 __lhs, const year_month_day\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day operator-(const year_month_day\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return __lhs + -__rhs; }\x0a"
"\x0a"
"inline constexpr year_month_day\x26 year_month_day\x3a\x3aoperator+=(const months\x26 __dm) noexcept { *this = *this + __dm; return *this; }\x0a"
"inline constexpr year_month_day\x26 year_month_day\x3a\x3aoperator-=(const months\x26 __dm) noexcept { *this = *this - __dm; return *this; }\x0a"
"inline constexpr year_month_day\x26 year_month_day\x3a\x3aoperator+=(const years\x26 __dy)  noexcept { *this = *this + __dy; return *this; }\x0a"
"inline constexpr year_month_day\x26 year_month_day\x3a\x3aoperator-=(const years\x26 __dy)  noexcept { *this = *this - __dy; return *this; }\x0a"
"\x0a"
"class year_month_day_last {\x0a"
"private\x3a\x0a"
"    chrono\x3a\x3ayear           __y;\x0a"
"    chrono\x3a\x3amonth_day_last __mdl;\x0a"
"public\x3a\x0a"
"     constexpr year_month_day_last(const year\x26 __yval, const month_day_last\x26 __mdlval) noexcept\x0a"
"        \x3a __y{__yval}, __mdl{__mdlval} {}\x0a"
"\x0a"
"     constexpr year_month_day_last\x26 operator+=(const months\x26 __m) noexcept;\x0a"
"     constexpr year_month_day_last\x26 operator-=(const months\x26 __m) noexcept;\x0a"
"     constexpr year_month_day_last\x26 operator+=(const years\x26 __y)  noexcept;\x0a"
"     constexpr year_month_day_last\x26 operator-=(const years\x26 __y)  noexcept;\x0a"
"\x0a"
"     inline constexpr chrono\x3a\x3ayear                     year() const noexcept { return __y; }\x0a"
"     inline constexpr chrono\x3a\x3amonth                   month() const noexcept { return __mdl.month(); }\x0a"
"     inline constexpr chrono\x3a\x3amonth_day_last month_day_last() const noexcept { return __mdl; }\x0a"
"            constexpr chrono\x3a\x3a""day                       day() const noexcept;\x0a"
"     inline constexpr operator                     sys_days() const noexcept { return   sys_days{year()/month()/day()}; }\x0a"
"     inline explicit constexpr operator          local_days() const noexcept { return local_days{year()/month()/day()}; }\x0a"
"     inline constexpr bool                               ok() const noexcept { return __y.ok() \x26\x26 __mdl.ok(); }\x0a"
"};\x0a"
"\x0a"
"inline constexpr\x0a"
"chrono\x3a\x3a""day year_month_day_last\x3a\x3a""day() const noexcept\x0a"
"{\x0a"
"    constexpr chrono\x3a\x3a""day __d\x5b\x5d =\x0a"
"    {\x0a"
"        chrono\x3a\x3a""day(31), chrono\x3a\x3a""day(28), chrono\x3a\x3a""day(31),\x0a"
"        chrono\x3a\x3a""day(30), chrono\x3a\x3a""day(31), chrono\x3a\x3a""day(30),\x0a"
"        chrono\x3a\x3a""day(31), chrono\x3a\x3a""day(31), chrono\x3a\x3a""day(30),\x0a"
"        chrono\x3a\x3a""day(31), chrono\x3a\x3a""day(30), chrono\x3a\x3a""day(31)\x0a"
"    };\x0a"
"    return month() \x21= February \x7c\x7c \x21__y.is_leap() \x3f\x0a"
"        __d\x5bstatic_cast<unsigned>(month()) - 1\x5d \x3a chrono\x3a\x3a""day{29};\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const year_month_day_last\x26 __lhs, const year_month_day_last\x26 __rhs) noexcept\x0a"
"{ return __lhs.year() == __rhs.year() \x26\x26 __lhs.month_day_last() == __rhs.month_day_last(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const year_month_day_last\x26 __lhs, const year_month_day_last\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator< (const year_month_day_last\x26 __lhs, const year_month_day_last\x26 __rhs) noexcept\x0a"
"{\x0a"
"    if (__lhs.year() < __rhs.year()) return true;\x0a"
"    if (__lhs.year() > __rhs.year()) return false;\x0a"
"    return __lhs.month_day_last() < __rhs.month_day_last();\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator> (const year_month_day_last\x26 __lhs, const year_month_day_last\x26 __rhs) noexcept\x0a"
"{ return __rhs < __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator<=(const year_month_day_last\x26 __lhs, const year_month_day_last\x26 __rhs) noexcept\x0a"
"{ return \x21(__rhs < __lhs);}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator>=(const year_month_day_last\x26 __lhs, const year_month_day_last\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs < __rhs); }\x0a"
"\x0a"
"inline constexpr year_month_day_last operator/(const year_month\x26 __lhs, last_spec) noexcept\x0a"
"{ return year_month_day_last{__lhs.year(), month_day_last{__lhs.month()}}; }\x0a"
"\x0a"
"inline constexpr year_month_day_last operator/(const year\x26 __lhs, const month_day_last\x26 __rhs) noexcept\x0a"
"{ return year_month_day_last{__lhs, __rhs}; }\x0a"
"\x0a"
"inline constexpr year_month_day_last operator/(int __lhs, const month_day_last\x26 __rhs) noexcept\x0a"
"{ return year_month_day_last{year{__lhs}, __rhs}; }\x0a"
"\x0a"
"inline constexpr year_month_day_last operator/(const month_day_last\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return __rhs / __lhs; }\x0a"
"\x0a"
"inline constexpr year_month_day_last operator/(const month_day_last\x26 __lhs, int __rhs) noexcept\x0a"
"{ return year{__rhs} / __lhs; }\x0a"
"\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day_last operator+(const year_month_day_last\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{ return (__lhs.year() / __lhs.month() + __rhs) / last; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day_last operator+(const months\x26 __lhs, const year_month_day_last\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day_last operator-(const year_month_day_last\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{ return __lhs + (-__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day_last operator+(const year_month_day_last\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return year_month_day_last{__lhs.year() + __rhs, __lhs.month_day_last()}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day_last operator+(const years\x26 __lhs, const year_month_day_last\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_day_last operator-(const year_month_day_last\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return __lhs + (-__rhs); }\x0a"
"\x0a"
"inline constexpr year_month_day_last\x26 year_month_day_last\x3a\x3aoperator+=(const months\x26 __dm) noexcept { *this = *this + __dm; return *this; }\x0a"
"inline constexpr year_month_day_last\x26 year_month_day_last\x3a\x3aoperator-=(const months\x26 __dm) noexcept { *this = *this - __dm; return *this; }\x0a"
"inline constexpr year_month_day_last\x26 year_month_day_last\x3a\x3aoperator+=(const years\x26 __dy)  noexcept { *this = *this + __dy; return *this; }\x0a"
"inline constexpr year_month_day_last\x26 year_month_day_last\x3a\x3aoperator-=(const years\x26 __dy)  noexcept { *this = *this - __dy; return *this; }\x0a"
"\x0a"
"inline constexpr year_month_day\x3a\x3ayear_month_day(const year_month_day_last\x26 __ymdl) noexcept\x0a"
"    \x3a __y{__ymdl.year()}, __m{__ymdl.month()}, __d{__ymdl.day()} {}\x0a"
"\x0a"
"inline constexpr bool year_month_day\x3a\x3aok() const noexcept\x0a"
"{\x0a"
"    if (\x21__y.ok() \x7c\x7c \x21__m.ok()) return false;\x0a"
"    return chrono\x3a\x3a""day{1} <= __d \x26\x26 __d <= (__y / __m / last).day();\x0a"
"}\x0a"
"\x0a"
"class year_month_weekday {\x0a"
"    chrono\x3a\x3ayear            __y;\x0a"
"    chrono\x3a\x3amonth           __m;\x0a"
"    chrono\x3a\x3aweekday_indexed __wdi;\x0a"
"public\x3a\x0a"
"    year_month_weekday() = default;\x0a"
"    constexpr year_month_weekday(const chrono\x3a\x3ayear\x26 __yval, const chrono\x3a\x3amonth\x26 __mval,\x0a"
"                               const chrono\x3a\x3aweekday_indexed\x26 __wdival) noexcept\x0a"
"        \x3a __y{__yval}, __m{__mval}, __wdi{__wdival} {}\x0a"
"    constexpr year_month_weekday(const sys_days\x26 __sysd) noexcept\x0a"
"            \x3a year_month_weekday(__from_days(__sysd.time_since_epoch())) {}\x0a"
"    inline explicit constexpr year_month_weekday(const local_days\x26 __locd) noexcept\x0a"
"            \x3a year_month_weekday(__from_days(__locd.time_since_epoch())) {}\x0a"
"    constexpr year_month_weekday\x26 operator+=(const months\x26 m) noexcept;\x0a"
"    constexpr year_month_weekday\x26 operator-=(const months\x26 m) noexcept;\x0a"
"    constexpr year_month_weekday\x26 operator+=(const years\x26 y)  noexcept;\x0a"
"    constexpr year_month_weekday\x26 operator-=(const years\x26 y)  noexcept;\x0a"
"\x0a"
"    inline constexpr chrono\x3a\x3ayear                       year() const noexcept { return __y; }\x0a"
"    inline constexpr chrono\x3a\x3amonth                     month() const noexcept { return __m; }\x0a"
"    inline constexpr chrono\x3a\x3aweekday                 weekday() const noexcept { return __wdi.weekday(); }\x0a"
"    inline constexpr unsigned                          index() const noexcept { return __wdi.index(); }\x0a"
"    inline constexpr chrono\x3a\x3aweekday_indexed weekday_indexed() const noexcept { return __wdi; }\x0a"
"\x0a"
"    inline constexpr                       operator sys_days() const noexcept { return   sys_days{__to_days()}; }\x0a"
"    inline explicit constexpr operator            local_days() const noexcept { return local_days{__to_days()}; }\x0a"
"    inline constexpr bool ok() const noexcept\x0a"
"    {\x0a"
"        if (\x21__y.ok() \x7c\x7c \x21__m.ok() \x7c\x7c \x21__wdi.ok()) return false;\x0a"
"    //  TODO\x3a make sure it's a valid date\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    static constexpr year_month_weekday __from_days(days __d) noexcept;\x0a"
"    constexpr days __to_days() const noexcept;\x0a"
"};\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday year_month_weekday\x3a\x3a__from_days(days __d) noexcept\x0a"
"{\x0a"
"    const sys_days      __sysd{__d};\x0a"
"    const chrono\x3a\x3aweekday __wd = chrono\x3a\x3aweekday(__sysd);\x0a"
"    const year_month_day __ymd = year_month_day(__sysd);\x0a"
"    return year_month_weekday{__ymd.year(), __ymd.month(),\x0a"
"                              __wd\x5b(static_cast<unsigned>(__ymd.day())-1)/7+1\x5d};\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"days year_month_weekday\x3a\x3a__to_days() const noexcept\x0a"
"{\x0a"
"    const sys_days __sysd = sys_days(__y/__m/1);\x0a"
"    return (__sysd + (__wdi.weekday() - chrono\x3a\x3aweekday(__sysd) + days{(__wdi.index()-1)*7}))\x0a"
"                .time_since_epoch();\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const year_month_weekday\x26 __lhs, const year_month_weekday\x26 __rhs) noexcept\x0a"
"{ return __lhs.year() == __rhs.year() \x26\x26 __lhs.month() == __rhs.month() \x26\x26 __lhs.weekday_indexed() == __rhs.weekday_indexed(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const year_month_weekday\x26 __lhs, const year_month_weekday\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator/(const year_month\x26 __lhs, const weekday_indexed\x26 __rhs) noexcept\x0a"
"{ return year_month_weekday{__lhs.year(), __lhs.month(), __rhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator/(const year\x26 __lhs, const month_weekday\x26 __rhs) noexcept\x0a"
"{ return year_month_weekday{__lhs, __rhs.month(), __rhs.weekday_indexed()}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator/(int __lhs, const month_weekday\x26 __rhs) noexcept\x0a"
"{ return year(__lhs) / __rhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator/(const month_weekday\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return __rhs / __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator/(const month_weekday\x26 __lhs, int __rhs) noexcept\x0a"
"{ return year(__rhs) / __lhs; }\x0a"
"\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator+(const year_month_weekday\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{ return (__lhs.year() / __lhs.month() + __rhs) / __lhs.weekday_indexed(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator+(const months\x26 __lhs, const year_month_weekday\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator-(const year_month_weekday\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{ return __lhs + (-__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator+(const year_month_weekday\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return year_month_weekday{__lhs.year() + __rhs, __lhs.month(), __lhs.weekday_indexed()}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator+(const years\x26 __lhs, const year_month_weekday\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday operator-(const year_month_weekday\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return __lhs + (-__rhs); }\x0a"
"\x0a"
"\x0a"
"inline constexpr year_month_weekday\x26 year_month_weekday\x3a\x3aoperator+=(const months\x26 __dm) noexcept { *this = *this + __dm; return *this; }\x0a"
"inline constexpr year_month_weekday\x26 year_month_weekday\x3a\x3aoperator-=(const months\x26 __dm) noexcept { *this = *this - __dm; return *this; }\x0a"
"inline constexpr year_month_weekday\x26 year_month_weekday\x3a\x3aoperator+=(const years\x26 __dy)  noexcept { *this = *this + __dy; return *this; }\x0a"
"inline constexpr year_month_weekday\x26 year_month_weekday\x3a\x3aoperator-=(const years\x26 __dy)  noexcept { *this = *this - __dy; return *this; }\x0a"
"\x0a"
"class year_month_weekday_last {\x0a"
"private\x3a\x0a"
"    chrono\x3a\x3ayear         __y;\x0a"
"    chrono\x3a\x3amonth        __m;\x0a"
"    chrono\x3a\x3aweekday_last __wdl;\x0a"
"public\x3a\x0a"
"    constexpr year_month_weekday_last(const chrono\x3a\x3ayear\x26 __yval, const chrono\x3a\x3amonth\x26 __mval,\x0a"
"                                      const chrono\x3a\x3aweekday_last\x26 __wdlval) noexcept\x0a"
"                \x3a __y{__yval}, __m{__mval}, __wdl{__wdlval} {}\x0a"
"    constexpr year_month_weekday_last\x26 operator+=(const months\x26 __dm) noexcept;\x0a"
"    constexpr year_month_weekday_last\x26 operator-=(const months\x26 __dm) noexcept;\x0a"
"    constexpr year_month_weekday_last\x26 operator+=(const years\x26 __dy)  noexcept;\x0a"
"    constexpr year_month_weekday_last\x26 operator-=(const years\x26 __dy)  noexcept;\x0a"
"\x0a"
"    inline constexpr chrono\x3a\x3ayear                 year() const noexcept { return __y; }\x0a"
"    inline constexpr chrono\x3a\x3amonth               month() const noexcept { return __m; }\x0a"
"    inline constexpr chrono\x3a\x3aweekday           weekday() const noexcept { return __wdl.weekday(); }\x0a"
"    inline constexpr chrono\x3a\x3aweekday_last weekday_last() const noexcept { return __wdl; }\x0a"
"    inline constexpr operator                 sys_days() const noexcept { return   sys_days{__to_days()}; }\x0a"
"    inline explicit constexpr operator      local_days() const noexcept { return local_days{__to_days()}; }\x0a"
"    inline constexpr bool ok() const noexcept { return __y.ok() \x26\x26 __m.ok() \x26\x26 __wdl.ok(); }\x0a"
"\x0a"
"    constexpr days __to_days() const noexcept;\x0a"
"\x0a"
"};\x0a"
"\x0a"
"inline constexpr\x0a"
"days year_month_weekday_last\x3a\x3a__to_days() const noexcept\x0a"
"{\x0a"
"    const sys_days __last = sys_days{__y/__m/last};\x0a"
"    return (__last - (chrono\x3a\x3aweekday{__last} - __wdl.weekday())).time_since_epoch();\x0a"
"\x0a"
"}\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator==(const year_month_weekday_last\x26 __lhs, const year_month_weekday_last\x26 __rhs) noexcept\x0a"
"{ return __lhs.year() == __rhs.year() \x26\x26 __lhs.month() == __rhs.month() \x26\x26 __lhs.weekday_last() == __rhs.weekday_last(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"bool operator\x21=(const year_month_weekday_last\x26 __lhs, const year_month_weekday_last\x26 __rhs) noexcept\x0a"
"{ return \x21(__lhs == __rhs); }\x0a"
"\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator/(const year_month\x26 __lhs, const weekday_last\x26 __rhs) noexcept\x0a"
"{ return year_month_weekday_last{__lhs.year(), __lhs.month(), __rhs}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator/(const year\x26 __lhs, const month_weekday_last\x26 __rhs) noexcept\x0a"
"{ return year_month_weekday_last{__lhs, __rhs.month(), __rhs.weekday_last()}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator/(int __lhs, const month_weekday_last\x26 __rhs) noexcept\x0a"
"{ return year(__lhs) / __rhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator/(const month_weekday_last\x26 __lhs, const year\x26 __rhs) noexcept\x0a"
"{ return __rhs / __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator/(const month_weekday_last\x26 __lhs, int __rhs) noexcept\x0a"
"{ return year(__rhs) / __lhs; }\x0a"
"\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator+(const year_month_weekday_last\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{ return (__lhs.year() / __lhs.month() + __rhs) / __lhs.weekday_last(); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator+(const months\x26 __lhs, const year_month_weekday_last\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator-(const year_month_weekday_last\x26 __lhs, const months\x26 __rhs) noexcept\x0a"
"{ return __lhs + (-__rhs); }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator+(const year_month_weekday_last\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return year_month_weekday_last{__lhs.year() + __rhs, __lhs.month(), __lhs.weekday_last()}; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator+(const years\x26 __lhs, const year_month_weekday_last\x26 __rhs) noexcept\x0a"
"{ return __rhs + __lhs; }\x0a"
"\x0a"
"inline constexpr\x0a"
"year_month_weekday_last operator-(const year_month_weekday_last\x26 __lhs, const years\x26 __rhs) noexcept\x0a"
"{ return __lhs + (-__rhs); }\x0a"
"\x0a"
"inline constexpr year_month_weekday_last\x26 year_month_weekday_last\x3a\x3aoperator+=(const months\x26 __dm) noexcept { *this = *this + __dm; return *this; }\x0a"
"inline constexpr year_month_weekday_last\x26 year_month_weekday_last\x3a\x3aoperator-=(const months\x26 __dm) noexcept { *this = *this - __dm; return *this; }\x0a"
"inline constexpr year_month_weekday_last\x26 year_month_weekday_last\x3a\x3aoperator+=(const years\x26 __dy)  noexcept { *this = *this + __dy; return *this; }\x0a"
"inline constexpr year_month_weekday_last\x26 year_month_weekday_last\x3a\x3aoperator-=(const years\x26 __dy)  noexcept { *this = *this - __dy; return *this; }\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"} // chrono\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"// Suffixes for duration literals \x5btime.duration.literals\x5d\x0a"
"inline namespace literals\x0a"
"{\x0a"
"  inline namespace chrono_literals\x0a"
"  {\x0a"
"\x0a"
"    constexpr chrono\x3a\x3ahours operator\x22\x22h(unsigned long long __h)\x0a"
"    {\x0a"
"        return chrono\x3a\x3ahours(static_cast<chrono\x3a\x3ahours\x3a\x3arep>(__h));\x0a"
"    }\x0a"
"\x0a"
"    constexpr chrono\x3a\x3a""duration<long double, ratio<3600,1>> operator\x22\x22h(long double __h)\x0a"
"    {\x0a"
"        return chrono\x3a\x3a""duration<long double, ratio<3600,1>>(__h);\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    constexpr chrono\x3a\x3aminutes operator\x22\x22min(unsigned long long __m)\x0a"
"    {\x0a"
"        return chrono\x3a\x3aminutes(static_cast<chrono\x3a\x3aminutes\x3a\x3arep>(__m));\x0a"
"    }\x0a"
"\x0a"
"    constexpr chrono\x3a\x3a""duration<long double, ratio<60,1>> operator\x22\x22min(long double __m)\x0a"
"    {\x0a"
"        return chrono\x3a\x3a""duration<long double, ratio<60,1>> (__m);\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    constexpr chrono\x3a\x3aseconds operator\x22\x22s(unsigned long long __s)\x0a"
"    {\x0a"
"        return chrono\x3a\x3aseconds(static_cast<chrono\x3a\x3aseconds\x3a\x3arep>(__s));\x0a"
"    }\x0a"
"\x0a"
"    constexpr chrono\x3a\x3a""duration<long double> operator\x22\x22s(long double __s)\x0a"
"    {\x0a"
"        return chrono\x3a\x3a""duration<long double> (__s);\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    constexpr chrono\x3a\x3amilliseconds operator\x22\x22ms(unsigned long long __ms)\x0a"
"    {\x0a"
"        return chrono\x3a\x3amilliseconds(static_cast<chrono\x3a\x3amilliseconds\x3a\x3arep>(__ms));\x0a"
"    }\x0a"
"\x0a"
"    constexpr chrono\x3a\x3a""duration<long double, milli> operator\x22\x22ms(long double __ms)\x0a"
"    {\x0a"
"        return chrono\x3a\x3a""duration<long double, milli>(__ms);\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    constexpr chrono\x3a\x3amicroseconds operator\x22\x22us(unsigned long long __us)\x0a"
"    {\x0a"
"        return chrono\x3a\x3amicroseconds(static_cast<chrono\x3a\x3amicroseconds\x3a\x3arep>(__us));\x0a"
"    }\x0a"
"\x0a"
"    constexpr chrono\x3a\x3a""duration<long double, micro> operator\x22\x22us(long double __us)\x0a"
"    {\x0a"
"        return chrono\x3a\x3a""duration<long double, micro> (__us);\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    constexpr chrono\x3a\x3ananoseconds operator\x22\x22ns(unsigned long long __ns)\x0a"
"    {\x0a"
"        return chrono\x3a\x3ananoseconds(static_cast<chrono\x3a\x3ananoseconds\x3a\x3arep>(__ns));\x0a"
"    }\x0a"
"\x0a"
"    constexpr chrono\x3a\x3a""duration<long double, nano> operator\x22\x22ns(long double __ns)\x0a"
"    {\x0a"
"        return chrono\x3a\x3a""duration<long double, nano> (__ns);\x0a"
"    }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_CXX20_CHRONO_LITERALS)\x0a"
"    constexpr chrono\x3a\x3a""day operator \x22\x22""d(unsigned long long __d) noexcept\x0a"
"    {\x0a"
"        return chrono\x3a\x3a""day(static_cast<unsigned>(__d));\x0a"
"    }\x0a"
"\x0a"
"    constexpr chrono\x3a\x3ayear operator \x22\x22y(unsigned long long __y) noexcept\x0a"
"    {\x0a"
"        return chrono\x3a\x3ayear(static_cast<int>(__y));\x0a"
"    }\x0a"
"#endif\x0a"
"}}\x0a"
"\x0a"
"namespace chrono { // hoist the literals into namespace std\x3a\x3a""chrono\x0a"
"   using namespace literals\x3a\x3a""chrono_literals;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"_LIBCPP_BEGIN_NAMESPACE_FILESYSTEM\x0a"
"struct _FilesystemClock {\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_INT128)\x0a"
"  typedef __int128_t rep;\x0a"
"  typedef nano period;\x0a"
"#else\x0a"
"  typedef long long rep;\x0a"
"  typedef nano period;\x0a"
"#endif\x0a"
"\x0a"
"  typedef chrono\x3a\x3a""duration<rep, period> duration;\x0a"
"  typedef chrono\x3a\x3atime_point<_FilesystemClock> time_point;\x0a"
"\x0a"
"  static _LIBCPP_CONSTEXPR_AFTER_CXX11 const bool is_steady = false;\x0a"
"\x0a"
"  _LIBCPP_AVAILABILITY_FILESYSTEM _LIBCPP_FUNC_VIS static time_point now() noexcept;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static time_t to_time_t(const time_point\x26 __t) noexcept {\x0a"
"      typedef chrono\x3a\x3a""duration<rep> __secs;\x0a"
"      return time_t(\x0a"
"          chrono\x3a\x3a""duration_cast<__secs>(__t.time_since_epoch()).count());\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static time_point from_time_t(time_t __t) noexcept {\x0a"
"      typedef chrono\x3a\x3a""duration<rep> __secs;\x0a"
"      return time_point(__secs(__t));\x0a"
"  }\x0a"
"};\x0a"
"_LIBCPP_END_NAMESPACE_FILESYSTEM\x0a"
"#endif // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_CHRONO\x0a"
"", 112095 ); }