#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_cmath( 
"// -*- C++ -*-\x0a"
"//===---------------------------- cmath -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_CMATH\x0a"
"#define _LIBCPP_CMATH\x0a"
"\x0a"
"/*\x0a"
"    cmath synopsis\x0a"
"\x0a"
"Macros\x3a\x0a"
"\x0a"
"    HUGE_VAL\x0a"
"    HUGE_VALF               // C99\x0a"
"    HUGE_VALL               // C99\x0a"
"    INFINITY                // C99\x0a"
"    NAN                     // C99\x0a"
"    FP_INFINITE             // C99\x0a"
"    FP_NAN                  // C99\x0a"
"    FP_NORMAL               // C99\x0a"
"    FP_SUBNORMAL            // C99\x0a"
"    FP_ZERO                 // C99\x0a"
"    FP_FAST_FMA             // C99\x0a"
"    FP_FAST_FMAF            // C99\x0a"
"    FP_FAST_FMAL            // C99\x0a"
"    FP_ILOGB0               // C99\x0a"
"    FP_ILOGBNAN             // C99\x0a"
"    MATH_ERRNO              // C99\x0a"
"    MATH_ERREXCEPT          // C99\x0a"
"    math_errhandling        // C99\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"Types\x3a\x0a"
"\x0a"
"    float_t                 // C99\x0a"
"    double_t                // C99\x0a"
"\x0a"
"// C90\x0a"
"\x0a"
"floating_point abs(floating_point x);\x0a"
"\x0a"
"floating_point acos (arithmetic x);\x0a"
"float          acosf(float x);\x0a"
"long double    acosl(long double x);\x0a"
"\x0a"
"floating_point asin (arithmetic x);\x0a"
"float          asinf(float x);\x0a"
"long double    asinl(long double x);\x0a"
"\x0a"
"floating_point atan (arithmetic x);\x0a"
"float          atanf(float x);\x0a"
"long double    atanl(long double x);\x0a"
"\x0a"
"floating_point atan2 (arithmetic y, arithmetic x);\x0a"
"float          atan2f(float y, float x);\x0a"
"long double    atan2l(long double y, long double x);\x0a"
"\x0a"
"floating_point ceil (arithmetic x);\x0a"
"float          ceilf(float x);\x0a"
"long double    ceill(long double x);\x0a"
"\x0a"
"floating_point cos (arithmetic x);\x0a"
"float          cosf(float x);\x0a"
"long double    cosl(long double x);\x0a"
"\x0a"
"floating_point cosh (arithmetic x);\x0a"
"float          coshf(float x);\x0a"
"long double    coshl(long double x);\x0a"
"\x0a"
"floating_point exp (arithmetic x);\x0a"
"float          expf(float x);\x0a"
"long double    expl(long double x);\x0a"
"\x0a"
"floating_point fabs (arithmetic x);\x0a"
"float          fabsf(float x);\x0a"
"long double    fabsl(long double x);\x0a"
"\x0a"
"floating_point floor (arithmetic x);\x0a"
"float          floorf(float x);\x0a"
"long double    floorl(long double x);\x0a"
"\x0a"
"floating_point fmod (arithmetic x, arithmetic y);\x0a"
"float          fmodf(float x, float y);\x0a"
"long double    fmodl(long double x, long double y);\x0a"
"\x0a"
"floating_point frexp (arithmetic value, int* exp);\x0a"
"float          frexpf(float value, int* exp);\x0a"
"long double    frexpl(long double value, int* exp);\x0a"
"\x0a"
"floating_point ldexp (arithmetic value, int exp);\x0a"
"float          ldexpf(float value, int exp);\x0a"
"long double    ldexpl(long double value, int exp);\x0a"
"\x0a"
"floating_point log (arithmetic x);\x0a"
"float          logf(float x);\x0a"
"long double    logl(long double x);\x0a"
"\x0a"
"floating_point log10 (arithmetic x);\x0a"
"float          log10f(float x);\x0a"
"long double    log10l(long double x);\x0a"
"\x0a"
"floating_point modf (floating_point value, floating_point* iptr);\x0a"
"float          modff(float value, float* iptr);\x0a"
"long double    modfl(long double value, long double* iptr);\x0a"
"\x0a"
"floating_point pow (arithmetic x, arithmetic y);\x0a"
"float          powf(float x, float y);\x0a"
"long double    powl(long double x, long double y);\x0a"
"\x0a"
"floating_point sin (arithmetic x);\x0a"
"float          sinf(float x);\x0a"
"long double    sinl(long double x);\x0a"
"\x0a"
"floating_point sinh (arithmetic x);\x0a"
"float          sinhf(float x);\x0a"
"long double    sinhl(long double x);\x0a"
"\x0a"
"floating_point sqrt (arithmetic x);\x0a"
"float          sqrtf(float x);\x0a"
"long double    sqrtl(long double x);\x0a"
"\x0a"
"floating_point tan (arithmetic x);\x0a"
"float          tanf(float x);\x0a"
"long double    tanl(long double x);\x0a"
"\x0a"
"floating_point tanh (arithmetic x);\x0a"
"float          tanhf(float x);\x0a"
"long double    tanhl(long double x);\x0a"
"\x0a"
"//  C99\x0a"
"\x0a"
"bool signbit(arithmetic x);\x0a"
"\x0a"
"int fpclassify(arithmetic x);\x0a"
"\x0a"
"bool isfinite(arithmetic x);\x0a"
"bool isinf(arithmetic x);\x0a"
"bool isnan(arithmetic x);\x0a"
"bool isnormal(arithmetic x);\x0a"
"\x0a"
"bool isgreater(arithmetic x, arithmetic y);\x0a"
"bool isgreaterequal(arithmetic x, arithmetic y);\x0a"
"bool isless(arithmetic x, arithmetic y);\x0a"
"bool islessequal(arithmetic x, arithmetic y);\x0a"
"bool islessgreater(arithmetic x, arithmetic y);\x0a"
"bool isunordered(arithmetic x, arithmetic y);\x0a"
"\x0a"
"floating_point acosh (arithmetic x);\x0a"
"float          acoshf(float x);\x0a"
"long double    acoshl(long double x);\x0a"
"\x0a"
"floating_point asinh (arithmetic x);\x0a"
"float          asinhf(float x);\x0a"
"long double    asinhl(long double x);\x0a"
"\x0a"
"floating_point atanh (arithmetic x);\x0a"
"float          atanhf(float x);\x0a"
"long double    atanhl(long double x);\x0a"
"\x0a"
"floating_point cbrt (arithmetic x);\x0a"
"float          cbrtf(float x);\x0a"
"long double    cbrtl(long double x);\x0a"
"\x0a"
"floating_point copysign (arithmetic x, arithmetic y);\x0a"
"float          copysignf(float x, float y);\x0a"
"long double    copysignl(long double x, long double y);\x0a"
"\x0a"
"floating_point erf (arithmetic x);\x0a"
"float          erff(float x);\x0a"
"long double    erfl(long double x);\x0a"
"\x0a"
"floating_point erfc (arithmetic x);\x0a"
"float          erfcf(float x);\x0a"
"long double    erfcl(long double x);\x0a"
"\x0a"
"floating_point exp2 (arithmetic x);\x0a"
"float          exp2f(float x);\x0a"
"long double    exp2l(long double x);\x0a"
"\x0a"
"floating_point expm1 (arithmetic x);\x0a"
"float          expm1f(float x);\x0a"
"long double    expm1l(long double x);\x0a"
"\x0a"
"floating_point fdim (arithmetic x, arithmetic y);\x0a"
"float          fdimf(float x, float y);\x0a"
"long double    fdiml(long double x, long double y);\x0a"
"\x0a"
"floating_point fma (arithmetic x, arithmetic y, arithmetic z);\x0a"
"float          fmaf(float x, float y, float z);\x0a"
"long double    fmal(long double x, long double y, long double z);\x0a"
"\x0a"
"floating_point fmax (arithmetic x, arithmetic y);\x0a"
"float          fmaxf(float x, float y);\x0a"
"long double    fmaxl(long double x, long double y);\x0a"
"\x0a"
"floating_point fmin (arithmetic x, arithmetic y);\x0a"
"float          fminf(float x, float y);\x0a"
"long double    fminl(long double x, long double y);\x0a"
"\x0a"
"floating_point hypot (arithmetic x, arithmetic y);\x0a"
"float          hypotf(float x, float y);\x0a"
"long double    hypotl(long double x, long double y);\x0a"
"\x0a"
"double       hypot(double x, double y, double z);                // C++17\x0a"
"float        hypot(float x, float y, float z);                   // C++17\x0a"
"long double  hypot(long double x, long double y, long double z); // C++17\x0a"
"\x0a"
"int ilogb (arithmetic x);\x0a"
"int ilogbf(float x);\x0a"
"int ilogbl(long double x);\x0a"
"\x0a"
"floating_point lgamma (arithmetic x);\x0a"
"float          lgammaf(float x);\x0a"
"long double    lgammal(long double x);\x0a"
"\x0a"
"long long llrint (arithmetic x);\x0a"
"long long llrintf(float x);\x0a"
"long long llrintl(long double x);\x0a"
"\x0a"
"long long llround (arithmetic x);\x0a"
"long long llroundf(float x);\x0a"
"long long llroundl(long double x);\x0a"
"\x0a"
"floating_point log1p (arithmetic x);\x0a"
"float          log1pf(float x);\x0a"
"long double    log1pl(long double x);\x0a"
"\x0a"
"floating_point log2 (arithmetic x);\x0a"
"float          log2f(float x);\x0a"
"long double    log2l(long double x);\x0a"
"\x0a"
"floating_point logb (arithmetic x);\x0a"
"float          logbf(float x);\x0a"
"long double    logbl(long double x);\x0a"
"\x0a"
"long lrint (arithmetic x);\x0a"
"long lrintf(float x);\x0a"
"long lrintl(long double x);\x0a"
"\x0a"
"long lround (arithmetic x);\x0a"
"long lroundf(float x);\x0a"
"long lroundl(long double x);\x0a"
"\x0a"
"double      nan (const char* str);\x0a"
"float       nanf(const char* str);\x0a"
"long double nanl(const char* str);\x0a"
"\x0a"
"floating_point nearbyint (arithmetic x);\x0a"
"float          nearbyintf(float x);\x0a"
"long double    nearbyintl(long double x);\x0a"
"\x0a"
"floating_point nextafter (arithmetic x, arithmetic y);\x0a"
"float          nextafterf(float x, float y);\x0a"
"long double    nextafterl(long double x, long double y);\x0a"
"\x0a"
"floating_point nexttoward (arithmetic x, long double y);\x0a"
"float          nexttowardf(float x, long double y);\x0a"
"long double    nexttowardl(long double x, long double y);\x0a"
"\x0a"
"floating_point remainder (arithmetic x, arithmetic y);\x0a"
"float          remainderf(float x, float y);\x0a"
"long double    remainderl(long double x, long double y);\x0a"
"\x0a"
"floating_point remquo (arithmetic x, arithmetic y, int* pquo);\x0a"
"float          remquof(float x, float y, int* pquo);\x0a"
"long double    remquol(long double x, long double y, int* pquo);\x0a"
"\x0a"
"floating_point rint (arithmetic x);\x0a"
"float          rintf(float x);\x0a"
"long double    rintl(long double x);\x0a"
"\x0a"
"floating_point round (arithmetic x);\x0a"
"float          roundf(float x);\x0a"
"long double    roundl(long double x);\x0a"
"\x0a"
"floating_point scalbln (arithmetic x, long ex);\x0a"
"float          scalblnf(float x, long ex);\x0a"
"long double    scalblnl(long double x, long ex);\x0a"
"\x0a"
"floating_point scalbn (arithmetic x, int ex);\x0a"
"float          scalbnf(float x, int ex);\x0a"
"long double    scalbnl(long double x, int ex);\x0a"
"\x0a"
"floating_point tgamma (arithmetic x);\x0a"
"float          tgammaf(float x);\x0a"
"long double    tgammal(long double x);\x0a"
"\x0a"
"floating_point trunc (arithmetic x);\x0a"
"float          truncf(float x);\x0a"
"long double    truncl(long double x);\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <math.h>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"using \x3a\x3asignbit;\x0a"
"using \x3a\x3a""fpclassify;\x0a"
"using \x3a\x3aisfinite;\x0a"
"using \x3a\x3aisinf;\x0a"
"using \x3a\x3aisnan;\x0a"
"using \x3a\x3aisnormal;\x0a"
"using \x3a\x3aisgreater;\x0a"
"using \x3a\x3aisgreaterequal;\x0a"
"using \x3a\x3aisless;\x0a"
"using \x3a\x3aislessequal;\x0a"
"using \x3a\x3aislessgreater;\x0a"
"using \x3a\x3aisunordered;\x0a"
"using \x3a\x3aisunordered;\x0a"
"\x0a"
"using \x3a\x3a""float_t;\x0a"
"using \x3a\x3a""double_t;\x0a"
"\x0a"
"#ifndef _AIX\x0a"
"using \x3a\x3a""abs;\x0a"
"#endif\x0a"
"\x0a"
"using \x3a\x3a""acos;\x0a"
"using \x3a\x3a""acosf;\x0a"
"using \x3a\x3a""asin;\x0a"
"using \x3a\x3a""asinf;\x0a"
"using \x3a\x3a""atan;\x0a"
"using \x3a\x3a""atanf;\x0a"
"using \x3a\x3a""atan2;\x0a"
"using \x3a\x3a""atan2f;\x0a"
"using \x3a\x3a""ceil;\x0a"
"using \x3a\x3a""ceilf;\x0a"
"using \x3a\x3a""cos;\x0a"
"using \x3a\x3a""cosf;\x0a"
"using \x3a\x3a""cosh;\x0a"
"using \x3a\x3a""coshf;\x0a"
"\x0a"
"using \x3a\x3a""exp;\x0a"
"using \x3a\x3a""expf;\x0a"
"\x0a"
"using \x3a\x3a""fabs;\x0a"
"using \x3a\x3a""fabsf;\x0a"
"using \x3a\x3a""floor;\x0a"
"using \x3a\x3a""floorf;\x0a"
"\x0a"
"using \x3a\x3a""fmod;\x0a"
"using \x3a\x3a""fmodf;\x0a"
"\x0a"
"using \x3a\x3a""frexp;\x0a"
"using \x3a\x3a""frexpf;\x0a"
"using \x3a\x3aldexp;\x0a"
"using \x3a\x3aldexpf;\x0a"
"\x0a"
"using \x3a\x3alog;\x0a"
"using \x3a\x3alogf;\x0a"
"\x0a"
"using \x3a\x3alog10;\x0a"
"using \x3a\x3alog10f;\x0a"
"using \x3a\x3amodf;\x0a"
"using \x3a\x3amodff;\x0a"
"\x0a"
"using \x3a\x3apow;\x0a"
"using \x3a\x3apowf;\x0a"
"\x0a"
"using \x3a\x3asin;\x0a"
"using \x3a\x3asinf;\x0a"
"using \x3a\x3asinh;\x0a"
"using \x3a\x3asinhf;\x0a"
"\x0a"
"using \x3a\x3asqrt;\x0a"
"using \x3a\x3asqrtf;\x0a"
"using \x3a\x3atan;\x0a"
"using \x3a\x3atanf;\x0a"
"\x0a"
"using \x3a\x3atanh;\x0a"
"using \x3a\x3atanhf;\x0a"
"\x0a"
"using \x3a\x3a""acosh;\x0a"
"using \x3a\x3a""acoshf;\x0a"
"using \x3a\x3a""asinh;\x0a"
"using \x3a\x3a""asinhf;\x0a"
"using \x3a\x3a""atanh;\x0a"
"using \x3a\x3a""atanhf;\x0a"
"using \x3a\x3a""cbrt;\x0a"
"using \x3a\x3a""cbrtf;\x0a"
"\x0a"
"using \x3a\x3a""copysign;\x0a"
"using \x3a\x3a""copysignf;\x0a"
"\x0a"
"using \x3a\x3a""erf;\x0a"
"using \x3a\x3a""erff;\x0a"
"using \x3a\x3a""erfc;\x0a"
"using \x3a\x3a""erfcf;\x0a"
"using \x3a\x3a""exp2;\x0a"
"using \x3a\x3a""exp2f;\x0a"
"using \x3a\x3a""expm1;\x0a"
"using \x3a\x3a""expm1f;\x0a"
"using \x3a\x3a""fdim;\x0a"
"using \x3a\x3a""fdimf;\x0a"
"using \x3a\x3a""fmaf;\x0a"
"using \x3a\x3a""fma;\x0a"
"using \x3a\x3a""fmax;\x0a"
"using \x3a\x3a""fmaxf;\x0a"
"using \x3a\x3a""fmin;\x0a"
"using \x3a\x3a""fminf;\x0a"
"using \x3a\x3ahypot;\x0a"
"using \x3a\x3ahypotf;\x0a"
"using \x3a\x3ailogb;\x0a"
"using \x3a\x3ailogbf;\x0a"
"using \x3a\x3algamma;\x0a"
"using \x3a\x3algammaf;\x0a"
"using \x3a\x3allrint;\x0a"
"using \x3a\x3allrintf;\x0a"
"using \x3a\x3allround;\x0a"
"using \x3a\x3allroundf;\x0a"
"using \x3a\x3alog1p;\x0a"
"using \x3a\x3alog1pf;\x0a"
"using \x3a\x3alog2;\x0a"
"using \x3a\x3alog2f;\x0a"
"using \x3a\x3alogb;\x0a"
"using \x3a\x3alogbf;\x0a"
"using \x3a\x3alrint;\x0a"
"using \x3a\x3alrintf;\x0a"
"using \x3a\x3alround;\x0a"
"using \x3a\x3alroundf;\x0a"
"\x0a"
"using \x3a\x3anan;\x0a"
"using \x3a\x3ananf;\x0a"
"\x0a"
"using \x3a\x3anearbyint;\x0a"
"using \x3a\x3anearbyintf;\x0a"
"using \x3a\x3anextafter;\x0a"
"using \x3a\x3anextafterf;\x0a"
"using \x3a\x3anexttoward;\x0a"
"using \x3a\x3anexttowardf;\x0a"
"using \x3a\x3aremainder;\x0a"
"using \x3a\x3aremainderf;\x0a"
"using \x3a\x3aremquo;\x0a"
"using \x3a\x3aremquof;\x0a"
"using \x3a\x3arint;\x0a"
"using \x3a\x3arintf;\x0a"
"using \x3a\x3around;\x0a"
"using \x3a\x3aroundf;\x0a"
"using \x3a\x3ascalbln;\x0a"
"using \x3a\x3ascalblnf;\x0a"
"using \x3a\x3ascalbn;\x0a"
"using \x3a\x3ascalbnf;\x0a"
"using \x3a\x3atgamma;\x0a"
"using \x3a\x3atgammaf;\x0a"
"using \x3a\x3atrunc;\x0a"
"using \x3a\x3atruncf;\x0a"
"\x0a"
"using \x3a\x3a""acosl;\x0a"
"using \x3a\x3a""asinl;\x0a"
"using \x3a\x3a""atanl;\x0a"
"using \x3a\x3a""atan2l;\x0a"
"using \x3a\x3a""ceill;\x0a"
"using \x3a\x3a""cosl;\x0a"
"using \x3a\x3a""coshl;\x0a"
"using \x3a\x3a""expl;\x0a"
"using \x3a\x3a""fabsl;\x0a"
"using \x3a\x3a""floorl;\x0a"
"using \x3a\x3a""fmodl;\x0a"
"using \x3a\x3a""frexpl;\x0a"
"using \x3a\x3aldexpl;\x0a"
"using \x3a\x3alogl;\x0a"
"using \x3a\x3alog10l;\x0a"
"using \x3a\x3amodfl;\x0a"
"using \x3a\x3apowl;\x0a"
"using \x3a\x3asinl;\x0a"
"using \x3a\x3asinhl;\x0a"
"using \x3a\x3asqrtl;\x0a"
"using \x3a\x3atanl;\x0a"
"\x0a"
"using \x3a\x3atanhl;\x0a"
"using \x3a\x3a""acoshl;\x0a"
"using \x3a\x3a""asinhl;\x0a"
"using \x3a\x3a""atanhl;\x0a"
"using \x3a\x3a""cbrtl;\x0a"
"\x0a"
"using \x3a\x3a""copysignl;\x0a"
"\x0a"
"using \x3a\x3a""erfl;\x0a"
"using \x3a\x3a""erfcl;\x0a"
"using \x3a\x3a""exp2l;\x0a"
"using \x3a\x3a""expm1l;\x0a"
"using \x3a\x3a""fdiml;\x0a"
"using \x3a\x3a""fmal;\x0a"
"using \x3a\x3a""fmaxl;\x0a"
"using \x3a\x3a""fminl;\x0a"
"using \x3a\x3ahypotl;\x0a"
"using \x3a\x3ailogbl;\x0a"
"using \x3a\x3algammal;\x0a"
"using \x3a\x3allrintl;\x0a"
"using \x3a\x3allroundl;\x0a"
"using \x3a\x3alog1pl;\x0a"
"using \x3a\x3alog2l;\x0a"
"using \x3a\x3alogbl;\x0a"
"using \x3a\x3alrintl;\x0a"
"using \x3a\x3alroundl;\x0a"
"using \x3a\x3ananl;\x0a"
"using \x3a\x3anearbyintl;\x0a"
"using \x3a\x3anextafterl;\x0a"
"using \x3a\x3anexttowardl;\x0a"
"using \x3a\x3aremainderl;\x0a"
"using \x3a\x3aremquol;\x0a"
"using \x3a\x3arintl;\x0a"
"using \x3a\x3aroundl;\x0a"
"using \x3a\x3ascalblnl;\x0a"
"using \x3a\x3ascalbnl;\x0a"
"using \x3a\x3atgammal;\x0a"
"using \x3a\x3atruncl;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       hypot(       float x,       float y,       float z ) { return sqrt(x*x + y*y + z*z); }\x0a"
"inline _LIBCPP_INLINE_VISIBILITY double      hypot(      double x,      double y,      double z ) { return sqrt(x*x + y*y + z*z); }\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double hypot( long double x, long double y, long double z ) { return sqrt(x*x + y*y + z*z); }\x0a"
"\x0a"
"template <class _A1, class _A2, class _A3>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename _EnableIf\x0a"
"<\x0a"
"    is_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    is_arithmetic<_A2>\x3a\x3avalue \x26\x26\x0a"
"    is_arithmetic<_A3>\x3a\x3avalue,\x0a"
"    __promote<_A1, _A2, _A3>\x0a"
">\x3a\x3atype\x0a"
"hypot(_A1 __lcpp_x, _A2 __lcpp_y, _A3 __lcpp_z) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename __promote<_A1, _A2, _A3>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(is_same<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     is_same<_A2, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     is_same<_A3, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return hypot((__result_type)__lcpp_x, (__result_type)__lcpp_y, (__result_type)__lcpp_z);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR typename enable_if<is_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"__libcpp_isnan_or_builtin(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"#if __has_builtin(__builtin_isnan)\x0a"
"    return __builtin_isnan(__lcpp_x);\x0a"
"#else\x0a"
"    return isnan(__lcpp_x);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR typename enable_if<\x21is_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"__libcpp_isnan_or_builtin(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return isnan(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR typename enable_if<is_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"__libcpp_isinf_or_builtin(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"#if __has_builtin(__builtin_isinf)\x0a"
"    return __builtin_isinf(__lcpp_x);\x0a"
"#else\x0a"
"    return isinf(__lcpp_x);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR typename enable_if<\x21is_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"__libcpp_isinf_or_builtin(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return isinf(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR typename enable_if<is_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"__libcpp_isfinite_or_builtin(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"#if __has_builtin(__builtin_isfinite)\x0a"
"    return __builtin_isfinite(__lcpp_x);\x0a"
"#else\x0a"
"    return isfinite(__lcpp_x);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR typename enable_if<\x21is_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"__libcpp_isfinite_or_builtin(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return isfinite(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <typename _Fp>\x0a"
"constexpr\x0a"
"_Fp __lerp(_Fp __a, _Fp __b, _Fp __t) noexcept {\x0a"
"    if ((__a <= 0 \x26\x26 __b >= 0) \x7c\x7c (__a >= 0 \x26\x26 __b <= 0))\x0a"
"        return __t * __b + (1 - __t) * __a;\x0a"
"\x0a"
"    if (__t == 1) return __b;\x0a"
"    const _Fp __x = __a + __t * (__b - __a);\x0a"
"    if (__t > 1 == __b > __a)\x0a"
"    \x09return __b < __x \x3f __x \x3a __b;\x0a"
"    else\x0a"
"    \x09return __x < __b \x3f __x \x3a __b;\x0a"
"}\x0a"
"\x0a"
"constexpr float\x0a"
"lerp(float __a, float __b, float __t)                   _NOEXCEPT { return __lerp(__a, __b, __t); }\x0a"
"\x0a"
"constexpr double\x0a"
"lerp(double __a, double __b, double __t)                _NOEXCEPT { return __lerp(__a, __b, __t); }\x0a"
"\x0a"
"constexpr long double\x0a"
"lerp(long double __a, long double __b, long double __t) _NOEXCEPT { return __lerp(__a, __b, __t); }\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_CMATH\x0a"
"", 15303 ); }