#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_codecvt( 
"// -*- C++ -*-\x0a"
"//===-------------------------- codecvt -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_CODECVT\x0a"
"#define _LIBCPP_CODECVT\x0a"
"\x0a"
"/*\x0a"
"    codecvt synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"enum codecvt_mode\x0a"
"{\x0a"
"    consume_header = 4,\x0a"
"    generate_header = 2,\x0a"
"    little_endian = 1\x0a"
"};\x0a"
"\x0a"
"template <class Elem, unsigned long Maxcode = 0x10ffff,\x0a"
"          codecvt_mode Mode = (codecvt_mode)0>\x0a"
"class codecvt_utf8\x0a"
"    \x3a public codecvt<Elem, char, mbstate_t>\x0a"
"{\x0a"
"    explicit codecvt_utf8(size_t refs = 0);\x0a"
"    \x7e""codecvt_utf8();\x0a"
"};\x0a"
"\x0a"
"template <class Elem, unsigned long Maxcode = 0x10ffff,\x0a"
"          codecvt_mode Mode = (codecvt_mode)0>\x0a"
"class codecvt_utf16\x0a"
"    \x3a public codecvt<Elem, char, mbstate_t>\x0a"
"{\x0a"
"    explicit codecvt_utf16(size_t refs = 0);\x0a"
"    \x7e""codecvt_utf16();\x0a"
"};\x0a"
"\x0a"
"template <class Elem, unsigned long Maxcode = 0x10ffff,\x0a"
"          codecvt_mode Mode = (codecvt_mode)0>\x0a"
"class codecvt_utf8_utf16\x0a"
"    \x3a public codecvt<Elem, char, mbstate_t>\x0a"
"{\x0a"
"    explicit codecvt_utf8_utf16(size_t refs = 0);\x0a"
"    \x7e""codecvt_utf8_utf16();\x0a"
"};\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__locale>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"enum codecvt_mode\x0a"
"{\x0a"
"    consume_header = 4,\x0a"
"    generate_header = 2,\x0a"
"    little_endian = 1\x0a"
"};\x0a"
"\x0a"
"// codecvt_utf8\x0a"
"\x0a"
"template <class _Elem> class __codecvt_utf8;\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf8<wchar_t>\x0a"
"    \x3a public codecvt<wchar_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef wchar_t   intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf8(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<wchar_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf8<char16_t>\x0a"
"    \x3a public codecvt<char16_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef char16_t  intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf8(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<char16_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf8<char32_t>\x0a"
"    \x3a public codecvt<char32_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef char32_t  intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf8(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<char32_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <class _Elem, unsigned long _Maxcode = 0x10ffff,\x0a"
"          codecvt_mode _Mode = (codecvt_mode)0>\x0a"
"class _LIBCPP_TEMPLATE_VIS codecvt_utf8\x0a"
"    \x3a public __codecvt_utf8<_Elem>\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit codecvt_utf8(size_t __refs = 0)\x0a"
"        \x3a __codecvt_utf8<_Elem>(__refs, _Maxcode, _Mode) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e""codecvt_utf8() {}\x0a"
"};\x0a"
"\x0a"
"// codecvt_utf16\x0a"
"\x0a"
"template <class _Elem, bool _LittleEndian> class __codecvt_utf16;\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf16<wchar_t, false>\x0a"
"    \x3a public codecvt<wchar_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef wchar_t   intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf16(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<wchar_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf16<wchar_t, true>\x0a"
"    \x3a public codecvt<wchar_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef wchar_t   intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf16(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<wchar_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf16<char16_t, false>\x0a"
"    \x3a public codecvt<char16_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef char16_t  intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf16(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<char16_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf16<char16_t, true>\x0a"
"    \x3a public codecvt<char16_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef char16_t  intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf16(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<char16_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf16<char32_t, false>\x0a"
"    \x3a public codecvt<char32_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef char32_t  intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf16(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<char32_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf16<char32_t, true>\x0a"
"    \x3a public codecvt<char32_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef char32_t  intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf16(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<char32_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <class _Elem, unsigned long _Maxcode = 0x10ffff,\x0a"
"          codecvt_mode _Mode = (codecvt_mode)0>\x0a"
"class _LIBCPP_TEMPLATE_VIS codecvt_utf16\x0a"
"    \x3a public __codecvt_utf16<_Elem, _Mode \x26 little_endian>\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit codecvt_utf16(size_t __refs = 0)\x0a"
"        \x3a __codecvt_utf16<_Elem, _Mode \x26 little_endian>(__refs, _Maxcode, _Mode) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e""codecvt_utf16() {}\x0a"
"};\x0a"
"\x0a"
"// codecvt_utf8_utf16\x0a"
"\x0a"
"template <class _Elem> class __codecvt_utf8_utf16;\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf8_utf16<wchar_t>\x0a"
"    \x3a public codecvt<wchar_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef wchar_t   intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf8_utf16(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<wchar_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf8_utf16<char32_t>\x0a"
"    \x3a public codecvt<char32_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef char32_t  intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf8_utf16(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<char32_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS __codecvt_utf8_utf16<char16_t>\x0a"
"    \x3a public codecvt<char16_t, char, mbstate_t>\x0a"
"{\x0a"
"    unsigned long _Maxcode_;\x0a"
"    codecvt_mode _Mode_;\x0a"
"public\x3a\x0a"
"    typedef char16_t  intern_type;\x0a"
"    typedef char      extern_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __codecvt_utf8_utf16(size_t __refs, unsigned long _Maxcode,\x0a"
"                            codecvt_mode _Mode)\x0a"
"        \x3a codecvt<char16_t, char, mbstate_t>(__refs), _Maxcode_(_Maxcode),\x0a"
"          _Mode_(_Mode) {}\x0a"
"protected\x3a\x0a"
"    virtual result\x0a"
"        do_out(state_type\x26 __st,\x0a"
"               const intern_type* __frm, const intern_type* __frm_end, const intern_type*\x26 __frm_nxt,\x0a"
"               extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_in(state_type\x26 __st,\x0a"
"              const extern_type* __frm, const extern_type* __frm_end, const extern_type*\x26 __frm_nxt,\x0a"
"              intern_type* __to, intern_type* __to_end, intern_type*\x26 __to_nxt) const;\x0a"
"    virtual result\x0a"
"        do_unshift(state_type\x26 __st,\x0a"
"                   extern_type* __to, extern_type* __to_end, extern_type*\x26 __to_nxt) const;\x0a"
"    virtual int do_encoding() const throw();\x0a"
"    virtual bool do_always_noconv() const throw();\x0a"
"    virtual int do_length(state_type\x26, const extern_type* __frm, const extern_type* __end,\x0a"
"                          size_t __mx) const;\x0a"
"    virtual int do_max_length() const throw();\x0a"
"};\x0a"
"\x0a"
"template <class _Elem, unsigned long _Maxcode = 0x10ffff,\x0a"
"          codecvt_mode _Mode = (codecvt_mode)0>\x0a"
"class _LIBCPP_TEMPLATE_VIS codecvt_utf8_utf16\x0a"
"    \x3a public __codecvt_utf8_utf16<_Elem>\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit codecvt_utf8_utf16(size_t __refs = 0)\x0a"
"        \x3a __codecvt_utf8_utf16<_Elem>(__refs, _Maxcode, _Mode) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e""codecvt_utf8_utf16() {}\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_CODECVT\x0a"
"", 20528 ); }