#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_compare( 
"// -*- C++ -*-\x0a"
"//===-------------------------- compare -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_COMPARE\x0a"
"#define _LIBCPP_COMPARE\x0a"
"\x0a"
"/*\x0a"
"    compare synopsis\x0a"
"\x0a"
"namespace std {\x0a"
"  // \x5b""cmp.categories\x5d, comparison category types\x0a"
"  class weak_equality;\x0a"
"  class strong_equality;\x0a"
"  class partial_ordering;\x0a"
"  class weak_ordering;\x0a"
"  class strong_ordering;\x0a"
"\x0a"
"  // named comparison functions\x0a"
"  constexpr bool is_eq  (weak_equality cmp) noexcept    { return cmp == 0; }\x0a"
"  constexpr bool is_neq (weak_equality cmp) noexcept    { return cmp \x21= 0; }\x0a"
"  constexpr bool is_lt  (partial_ordering cmp) noexcept { return cmp < 0; }\x0a"
"  constexpr bool is_lteq(partial_ordering cmp) noexcept { return cmp <= 0; }\x0a"
"  constexpr bool is_gt  (partial_ordering cmp) noexcept { return cmp > 0; }\x0a"
"  constexpr bool is_gteq(partial_ordering cmp) noexcept { return cmp >= 0; }\x0a"
"\x0a"
"  // \x5b""cmp.common\x5d, common comparison category type\x0a"
"  template<class... Ts>\x0a"
"  struct common_comparison_category {\x0a"
"    using type = see below;\x0a"
"  };\x0a"
"  template<class... Ts>\x0a"
"    using common_comparison_category_t = typename common_comparison_category<Ts...>\x3a\x3atype;\x0a"
"\x0a"
"  // \x5b""cmp.alg\x5d, comparison algorithms\x0a"
"  template<class T> constexpr strong_ordering strong_order(const T\x26 a, const T\x26 b);\x0a"
"  template<class T> constexpr weak_ordering weak_order(const T\x26 a, const T\x26 b);\x0a"
"  template<class T> constexpr partial_ordering partial_order(const T\x26 a, const T\x26 b);\x0a"
"  template<class T> constexpr strong_equality strong_equal(const T\x26 a, const T\x26 b);\x0a"
"  template<class T> constexpr weak_equality weak_equal(const T\x26 a, const T\x26 b);\x0a"
"}\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <type_traits>\x0a"
"#include <array>\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"// exposition only\x0a"
"enum class _LIBCPP_ENUM_VIS _EqResult \x3a unsigned char {\x0a"
"  __zero = 0,\x0a"
"  __equal = __zero,\x0a"
"  __equiv = __equal,\x0a"
"  __nonequal = 1,\x0a"
"  __nonequiv = __nonequal\x0a"
"};\x0a"
"\x0a"
"enum class _LIBCPP_ENUM_VIS _OrdResult \x3a signed char {\x0a"
"  __less = -1,\x0a"
"  __greater = 1\x0a"
"};\x0a"
"\x0a"
"enum class _LIBCPP_ENUM_VIS _NCmpResult \x3a signed char {\x0a"
"  __unordered = -127\x0a"
"};\x0a"
"\x0a"
"struct _CmpUnspecifiedType;\x0a"
"using _CmpUnspecifiedParam = void (_CmpUnspecifiedType\x3a\x3a*)();\x0a"
"\x0a"
"class  weak_equality {\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr explicit weak_equality(_EqResult __val) noexcept \x3a __value_(__val) {}\x0a"
"\x0a"
"public\x3a\x0a"
"  static const weak_equality equivalent;\x0a"
"  static const weak_equality nonequivalent;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator==(weak_equality __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator==(_CmpUnspecifiedParam, weak_equality __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator\x21=(weak_equality __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator\x21=(_CmpUnspecifiedParam, weak_equality __v) noexcept;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr weak_equality operator<=>(weak_equality __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr weak_equality operator<=>(_CmpUnspecifiedParam, weak_equality __v) noexcept;\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"  _EqResult __value_;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VAR constexpr weak_equality weak_equality\x3a\x3a""equivalent(_EqResult\x3a\x3a__equiv);\x0a"
"_LIBCPP_INLINE_VAR constexpr weak_equality weak_equality\x3a\x3anonequivalent(_EqResult\x3a\x3a__nonequiv);\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr bool operator==(weak_equality __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ == _EqResult\x3a\x3a__zero;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr bool operator==(_CmpUnspecifiedParam, weak_equality __v) noexcept {\x0a"
"  return __v.__value_ == _EqResult\x3a\x3a__zero;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr bool operator\x21=(weak_equality __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ \x21= _EqResult\x3a\x3a__zero;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr bool operator\x21=(_CmpUnspecifiedParam, weak_equality __v) noexcept {\x0a"
"  return __v.__value_ \x21= _EqResult\x3a\x3a__zero;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr weak_equality operator<=>(weak_equality __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr weak_equality operator<=>(_CmpUnspecifiedParam, weak_equality __v) noexcept {\x0a"
"  return __v;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"class strong_equality {\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr strong_equality(_EqResult __val) noexcept \x3a __value_(__val) {}\x0a"
"\x0a"
"public\x3a\x0a"
"  static const strong_equality equal;\x0a"
"  static const strong_equality nonequal;\x0a"
"  static const strong_equality equivalent;\x0a"
"  static const strong_equality nonequivalent;\x0a"
"\x0a"
"  // conversion\x0a"
"  _LIBCPP_INLINE_VISIBILITY constexpr operator weak_equality() const noexcept {\x0a"
"    return __value_ == _EqResult\x3a\x3a__zero \x3f weak_equality\x3a\x3a""equivalent\x0a"
"          \x3a weak_equality\x3a\x3anonequivalent;\x0a"
"  }\x0a"
"\x0a"
"  // comparisons\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator==(strong_equality __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator\x21=(strong_equality __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator==(_CmpUnspecifiedParam, strong_equality __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator\x21=(_CmpUnspecifiedParam, strong_equality __v) noexcept;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr strong_equality operator<=>(strong_equality __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr strong_equality operator<=>(_CmpUnspecifiedParam, strong_equality __v) noexcept;\x0a"
"#endif\x0a"
"private\x3a\x0a"
"  _EqResult __value_;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VAR constexpr strong_equality strong_equality\x3a\x3a""equal(_EqResult\x3a\x3a__equal);\x0a"
"_LIBCPP_INLINE_VAR constexpr strong_equality strong_equality\x3a\x3anonequal(_EqResult\x3a\x3a__nonequal);\x0a"
"_LIBCPP_INLINE_VAR constexpr strong_equality strong_equality\x3a\x3a""equivalent(_EqResult\x3a\x3a__equiv);\x0a"
"_LIBCPP_INLINE_VAR constexpr strong_equality strong_equality\x3a\x3anonequivalent(_EqResult\x3a\x3a__nonequiv);\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator==(strong_equality __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ == _EqResult\x3a\x3a__zero;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator==(_CmpUnspecifiedParam, strong_equality __v) noexcept {\x0a"
"  return __v.__value_ == _EqResult\x3a\x3a__zero;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator\x21=(strong_equality __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ \x21= _EqResult\x3a\x3a__zero;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator\x21=(_CmpUnspecifiedParam, strong_equality __v) noexcept {\x0a"
"  return __v.__value_ \x21= _EqResult\x3a\x3a__zero;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr strong_equality operator<=>(strong_equality __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr strong_equality operator<=>(_CmpUnspecifiedParam, strong_equality __v) noexcept {\x0a"
"  return __v;\x0a"
"}\x0a"
"#endif // _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"\x0a"
"class partial_ordering {\x0a"
"  using _ValueT = signed char;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr partial_ordering(_EqResult __v) noexcept\x0a"
"      \x3a __value_(_ValueT(__v)) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr partial_ordering(_OrdResult __v) noexcept\x0a"
"      \x3a __value_(_ValueT(__v)) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr partial_ordering(_NCmpResult __v) noexcept\x0a"
"      \x3a __value_(_ValueT(__v)) {}\x0a"
"\x0a"
"  constexpr bool __is_ordered() const noexcept {\x0a"
"    return __value_ \x21= _ValueT(_NCmpResult\x3a\x3a__unordered);\x0a"
"  }\x0a"
"public\x3a\x0a"
"  // valid values\x0a"
"  static const partial_ordering less;\x0a"
"  static const partial_ordering equivalent;\x0a"
"  static const partial_ordering greater;\x0a"
"  static const partial_ordering unordered;\x0a"
"\x0a"
"  // conversion\x0a"
"  constexpr operator weak_equality() const noexcept {\x0a"
"    return __value_ == 0 \x3f weak_equality\x3a\x3a""equivalent \x3a weak_equality\x3a\x3anonequivalent;\x0a"
"  }\x0a"
"\x0a"
"  // comparisons\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator==(partial_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator\x21=(partial_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator< (partial_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator<=(partial_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator> (partial_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator>=(partial_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator==(_CmpUnspecifiedParam, partial_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator\x21=(_CmpUnspecifiedParam, partial_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator< (_CmpUnspecifiedParam, partial_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator<=(_CmpUnspecifiedParam, partial_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator> (_CmpUnspecifiedParam, partial_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator>=(_CmpUnspecifiedParam, partial_ordering __v) noexcept;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr partial_ordering operator<=>(partial_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr partial_ordering operator<=>(_CmpUnspecifiedParam, partial_ordering __v) noexcept;\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"  _ValueT __value_;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VAR constexpr partial_ordering partial_ordering\x3a\x3aless(_OrdResult\x3a\x3a__less);\x0a"
"_LIBCPP_INLINE_VAR constexpr partial_ordering partial_ordering\x3a\x3a""equivalent(_EqResult\x3a\x3a__equiv);\x0a"
"_LIBCPP_INLINE_VAR constexpr partial_ordering partial_ordering\x3a\x3agreater(_OrdResult\x3a\x3a__greater);\x0a"
"_LIBCPP_INLINE_VAR constexpr partial_ordering partial_ordering\x3a\x3aunordered(_NCmpResult \x3a\x3a__unordered);\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator==(partial_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__is_ordered() \x26\x26 __v.__value_ == 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator< (partial_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__is_ordered() \x26\x26 __v.__value_ < 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator<=(partial_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__is_ordered() \x26\x26 __v.__value_ <= 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator> (partial_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__is_ordered() \x26\x26 __v.__value_ > 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator>=(partial_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__is_ordered() \x26\x26 __v.__value_ >= 0;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator==(_CmpUnspecifiedParam, partial_ordering __v) noexcept {\x0a"
"  return __v.__is_ordered() \x26\x26 0 == __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator< (_CmpUnspecifiedParam, partial_ordering __v) noexcept {\x0a"
"  return __v.__is_ordered() \x26\x26 0 < __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator<=(_CmpUnspecifiedParam, partial_ordering __v) noexcept {\x0a"
"  return __v.__is_ordered() \x26\x26 0 <= __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator> (_CmpUnspecifiedParam, partial_ordering __v) noexcept {\x0a"
"  return __v.__is_ordered() \x26\x26 0 > __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator>=(_CmpUnspecifiedParam, partial_ordering __v) noexcept {\x0a"
"  return __v.__is_ordered() \x26\x26 0 >= __v.__value_;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator\x21=(partial_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return \x21__v.__is_ordered() \x7c\x7c __v.__value_ \x21= 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator\x21=(_CmpUnspecifiedParam, partial_ordering __v) noexcept {\x0a"
"  return \x21__v.__is_ordered() \x7c\x7c __v.__value_ \x21= 0;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr partial_ordering operator<=>(partial_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr partial_ordering operator<=>(_CmpUnspecifiedParam, partial_ordering __v) noexcept {\x0a"
"  return __v < 0 \x3f partial_ordering\x3a\x3agreater \x3a (__v > 0 \x3f partial_ordering\x3a\x3aless \x3a __v);\x0a"
"}\x0a"
"#endif // _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"\x0a"
"class weak_ordering {\x0a"
"  using _ValueT = signed char;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr weak_ordering(_EqResult __v) noexcept \x3a __value_(_ValueT(__v)) {}\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr weak_ordering(_OrdResult __v) noexcept \x3a __value_(_ValueT(__v)) {}\x0a"
"\x0a"
"public\x3a\x0a"
"  static const weak_ordering less;\x0a"
"  static const weak_ordering equivalent;\x0a"
"  static const weak_ordering greater;\x0a"
"\x0a"
"  // conversions\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr operator weak_equality() const noexcept {\x0a"
"    return __value_ == 0 \x3f weak_equality\x3a\x3a""equivalent\x0a"
"                         \x3a weak_equality\x3a\x3anonequivalent;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr operator partial_ordering() const noexcept {\x0a"
"    return __value_ == 0 \x3f partial_ordering\x3a\x3a""equivalent\x0a"
"        \x3a (__value_ < 0 \x3f partial_ordering\x3a\x3aless \x3a partial_ordering\x3a\x3agreater);\x0a"
"  }\x0a"
"\x0a"
"  // comparisons\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator==(weak_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator\x21=(weak_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator< (weak_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator<=(weak_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator> (weak_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator>=(weak_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator==(_CmpUnspecifiedParam, weak_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator\x21=(_CmpUnspecifiedParam, weak_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator< (_CmpUnspecifiedParam, weak_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator<=(_CmpUnspecifiedParam, weak_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator> (_CmpUnspecifiedParam, weak_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator>=(_CmpUnspecifiedParam, weak_ordering __v) noexcept;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr weak_ordering operator<=>(weak_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr weak_ordering operator<=>(_CmpUnspecifiedParam, weak_ordering __v) noexcept;\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"  _ValueT __value_;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VAR constexpr weak_ordering weak_ordering\x3a\x3aless(_OrdResult\x3a\x3a__less);\x0a"
"_LIBCPP_INLINE_VAR constexpr weak_ordering weak_ordering\x3a\x3a""equivalent(_EqResult\x3a\x3a__equiv);\x0a"
"_LIBCPP_INLINE_VAR constexpr weak_ordering weak_ordering\x3a\x3agreater(_OrdResult\x3a\x3a__greater);\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator==(weak_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ == 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator\x21=(weak_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ \x21= 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator< (weak_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ < 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator<=(weak_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ <= 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator> (weak_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ > 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator>=(weak_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ >= 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator==(_CmpUnspecifiedParam, weak_ordering __v) noexcept {\x0a"
"  return 0 == __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator\x21=(_CmpUnspecifiedParam, weak_ordering __v) noexcept {\x0a"
"  return 0 \x21= __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator< (_CmpUnspecifiedParam, weak_ordering __v) noexcept {\x0a"
"  return 0 < __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator<=(_CmpUnspecifiedParam, weak_ordering __v) noexcept {\x0a"
"  return 0 <= __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator> (_CmpUnspecifiedParam, weak_ordering __v) noexcept {\x0a"
"  return 0 > __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator>=(_CmpUnspecifiedParam, weak_ordering __v) noexcept {\x0a"
"  return 0 >= __v.__value_;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr weak_ordering operator<=>(weak_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr weak_ordering operator<=>(_CmpUnspecifiedParam, weak_ordering __v) noexcept {\x0a"
"  return __v < 0 \x3f weak_ordering\x3a\x3agreater \x3a (__v > 0 \x3f weak_ordering\x3a\x3aless \x3a __v);\x0a"
"}\x0a"
"#endif // _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"\x0a"
"class strong_ordering {\x0a"
"  using _ValueT = signed char;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr strong_ordering(_EqResult __v) noexcept \x3a __value_(_ValueT(__v)) {}\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr strong_ordering(_OrdResult __v) noexcept \x3a __value_(_ValueT(__v)) {}\x0a"
"\x0a"
"public\x3a\x0a"
"  static const strong_ordering less;\x0a"
"  static const strong_ordering equal;\x0a"
"  static const strong_ordering equivalent;\x0a"
"  static const strong_ordering greater;\x0a"
"\x0a"
"  // conversions\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr operator weak_equality() const noexcept {\x0a"
"    return __value_ == 0 \x3f weak_equality\x3a\x3a""equivalent\x0a"
"                         \x3a weak_equality\x3a\x3anonequivalent;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr operator strong_equality() const noexcept {\x0a"
"    return __value_ == 0 \x3f strong_equality\x3a\x3a""equal\x0a"
"                         \x3a strong_equality\x3a\x3anonequal;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr operator partial_ordering() const noexcept {\x0a"
"    return __value_ == 0 \x3f partial_ordering\x3a\x3a""equivalent\x0a"
"        \x3a (__value_ < 0 \x3f partial_ordering\x3a\x3aless \x3a partial_ordering\x3a\x3agreater);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr operator weak_ordering() const noexcept {\x0a"
"    return __value_ == 0 \x3f weak_ordering\x3a\x3a""equivalent\x0a"
"        \x3a (__value_ < 0 \x3f weak_ordering\x3a\x3aless \x3a weak_ordering\x3a\x3agreater);\x0a"
"  }\x0a"
"\x0a"
"  // comparisons\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator==(strong_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator\x21=(strong_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator< (strong_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator<=(strong_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator> (strong_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator>=(strong_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator==(_CmpUnspecifiedParam, strong_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator\x21=(_CmpUnspecifiedParam, strong_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator< (_CmpUnspecifiedParam, strong_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator<=(_CmpUnspecifiedParam, strong_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator> (_CmpUnspecifiedParam, strong_ordering __v) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr bool operator>=(_CmpUnspecifiedParam, strong_ordering __v) noexcept;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr strong_ordering operator<=>(strong_ordering __v, _CmpUnspecifiedParam) noexcept;\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend constexpr strong_ordering operator<=>(_CmpUnspecifiedParam, strong_ordering __v) noexcept;\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"  _ValueT __value_;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VAR constexpr strong_ordering strong_ordering\x3a\x3aless(_OrdResult\x3a\x3a__less);\x0a"
"_LIBCPP_INLINE_VAR constexpr strong_ordering strong_ordering\x3a\x3a""equal(_EqResult\x3a\x3a__equal);\x0a"
"_LIBCPP_INLINE_VAR constexpr strong_ordering strong_ordering\x3a\x3a""equivalent(_EqResult\x3a\x3a__equiv);\x0a"
"_LIBCPP_INLINE_VAR constexpr strong_ordering strong_ordering\x3a\x3agreater(_OrdResult\x3a\x3a__greater);\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator==(strong_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ == 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator\x21=(strong_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ \x21= 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator< (strong_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ < 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator<=(strong_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ <= 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator> (strong_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ > 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator>=(strong_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v.__value_ >= 0;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator==(_CmpUnspecifiedParam, strong_ordering __v) noexcept {\x0a"
"  return 0 == __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator\x21=(_CmpUnspecifiedParam, strong_ordering __v) noexcept {\x0a"
"  return 0 \x21= __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator< (_CmpUnspecifiedParam, strong_ordering __v) noexcept {\x0a"
"  return 0 < __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator<=(_CmpUnspecifiedParam, strong_ordering __v) noexcept {\x0a"
"  return 0 <= __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator> (_CmpUnspecifiedParam, strong_ordering __v) noexcept {\x0a"
"  return 0 > __v.__value_;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator>=(_CmpUnspecifiedParam, strong_ordering __v) noexcept {\x0a"
"  return 0 >= __v.__value_;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr strong_ordering operator<=>(strong_ordering __v, _CmpUnspecifiedParam) noexcept {\x0a"
"  return __v;\x0a"
"}\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr strong_ordering operator<=>(_CmpUnspecifiedParam, strong_ordering __v) noexcept {\x0a"
"  return __v < 0 \x3f strong_ordering\x3a\x3agreater \x3a (__v > 0 \x3f strong_ordering\x3a\x3aless \x3a __v);\x0a"
"}\x0a"
"#endif // _LIBCPP_HAS_NO_SPACESHIP_OPERATOR\x0a"
"\x0a"
"// named comparison functions\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool is_eq(weak_equality __cmp) noexcept    { return __cmp == 0; }\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool is_neq(weak_equality __cmp) noexcept    { return __cmp \x21= 0; }\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool is_lt(partial_ordering __cmp) noexcept { return __cmp < 0; }\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool is_lteq(partial_ordering __cmp) noexcept { return __cmp <= 0; }\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool is_gt(partial_ordering __cmp) noexcept { return __cmp > 0; }\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool is_gteq(partial_ordering __cmp) noexcept { return __cmp >= 0; }\x0a"
"\x0a"
"namespace __comp_detail {\x0a"
"\x0a"
"enum _ClassifyCompCategory \x3a unsigned{\x0a"
"  _None,\x0a"
"  _WeakEq,\x0a"
"  _StrongEq,\x0a"
"  _PartialOrd,\x0a"
"  _WeakOrd,\x0a"
"  _StrongOrd,\x0a"
"  _CCC_Size\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _ClassifyCompCategory __type_to_enum() noexcept {\x0a"
"  if (is_same_v<_Tp, weak_equality>)\x0a"
"    return _WeakEq;\x0a"
"  if (is_same_v<_Tp, strong_equality>)\x0a"
"    return _StrongEq;\x0a"
"  if (is_same_v<_Tp, partial_ordering>)\x0a"
"    return _PartialOrd;\x0a"
"  if (is_same_v<_Tp, weak_ordering>)\x0a"
"    return _WeakOrd;\x0a"
"  if (is_same_v<_Tp, strong_ordering>)\x0a"
"    return _StrongOrd;\x0a"
"  return _None;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Size>\x0a"
"constexpr _ClassifyCompCategory\x0a"
"__compute_comp_type(std\x3a\x3a""array<_ClassifyCompCategory, _Size> __types) {\x0a"
"  std\x3a\x3a""array<int, _CCC_Size> __seen = {};\x0a"
"  for (auto __type \x3a __types)\x0a"
"    ++__seen\x5b__type\x5d;\x0a"
"  if (__seen\x5b_None\x5d)\x0a"
"    return _None;\x0a"
"  if (__seen\x5b_WeakEq\x5d)\x0a"
"    return _WeakEq;\x0a"
"  if (__seen\x5b_StrongEq\x5d \x26\x26 (__seen\x5b_PartialOrd\x5d \x7c\x7c __seen\x5b_WeakOrd\x5d))\x0a"
"    return _WeakEq;\x0a"
"  if (__seen\x5b_StrongEq\x5d)\x0a"
"    return _StrongEq;\x0a"
"  if (__seen\x5b_PartialOrd\x5d)\x0a"
"    return _PartialOrd;\x0a"
"  if (__seen\x5b_WeakOrd\x5d)\x0a"
"    return _WeakOrd;\x0a"
"  return _StrongOrd;\x0a"
"}\x0a"
"\x0a"
"template <class ..._Ts>\x0a"
"constexpr auto __get_comp_type() {\x0a"
"  using _CCC = _ClassifyCompCategory;\x0a"
"  constexpr array<_CCC, sizeof...(_Ts)> __type_kinds{{__comp_detail\x3a\x3a__type_to_enum<_Ts>()...}};\x0a"
"  constexpr _CCC _Cat = sizeof...(_Ts) == 0 \x3f _StrongOrd\x0a"
"      \x3a __compute_comp_type(__type_kinds);\x0a"
"  if constexpr (_Cat == _None)\x0a"
"    return void();\x0a"
"  else if constexpr (_Cat == _WeakEq)\x0a"
"    return weak_equality\x3a\x3a""equivalent;\x0a"
"  else if constexpr (_Cat == _StrongEq)\x0a"
"    return strong_equality\x3a\x3a""equivalent;\x0a"
"  else if constexpr (_Cat == _PartialOrd)\x0a"
"    return partial_ordering\x3a\x3a""equivalent;\x0a"
"  else if constexpr (_Cat == _WeakOrd)\x0a"
"    return weak_ordering\x3a\x3a""equivalent;\x0a"
"  else if constexpr (_Cat == _StrongOrd)\x0a"
"    return strong_ordering\x3a\x3a""equivalent;\x0a"
"  else\x0a"
"    static_assert(_Cat \x21= _Cat, \x22unhandled case\x22);\x0a"
"}\x0a"
"} // namespace __comp_detail\x0a"
"\x0a"
"// \x5b""cmp.common\x5d, common comparison category type\x0a"
"template<class... _Ts>\x0a"
"struct _LIBCPP_TEMPLATE_VIS common_comparison_category {\x0a"
"  using type = decltype(__comp_detail\x3a\x3a__get_comp_type<_Ts...>());\x0a"
"};\x0a"
"\x0a"
"template<class... _Ts>\x0a"
"using common_comparison_category_t = typename common_comparison_category<_Ts...>\x3a\x3atype;\x0a"
"\x0a"
"// \x5b""cmp.alg\x5d, comparison algorithms\x0a"
"// TODO\x3a unimplemented\x0a"
"template<class _Tp> constexpr strong_ordering strong_order(const _Tp\x26 __lhs, const _Tp\x26 __rhs);\x0a"
"template<class _Tp> constexpr weak_ordering weak_order(const _Tp\x26 __lhs, const _Tp\x26 __rhs);\x0a"
"template<class _Tp> constexpr partial_ordering partial_order(const _Tp\x26 __lhs, const _Tp\x26 __rhs);\x0a"
"template<class _Tp> constexpr strong_equality strong_equal(const _Tp\x26 __lhs, const _Tp\x26 __rhs);\x0a"
"template<class _Tp> constexpr weak_equality weak_equal(const _Tp\x26 __lhs, const _Tp\x26 __rhs);\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // _LIBCPP_COMPARE\x0a"
"", 26526 ); }