#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_complex( 
"// -*- C++ -*-\x0a"
"//===--------------------------- complex ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_COMPLEX\x0a"
"#define _LIBCPP_COMPLEX\x0a"
"\x0a"
"/*\x0a"
"    complex synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template<class T>\x0a"
"class complex\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T value_type;\x0a"
"\x0a"
"    complex(const T\x26 re = T(), const T\x26 im = T()); // constexpr in C++14\x0a"
"    complex(const complex\x26);  // constexpr in C++14\x0a"
"    template<class X> complex(const complex<X>\x26);  // constexpr in C++14\x0a"
"\x0a"
"    T real() const; // constexpr in C++14\x0a"
"    T imag() const; // constexpr in C++14\x0a"
"\x0a"
"    void real(T);\x0a"
"    void imag(T);\x0a"
"\x0a"
"    complex<T>\x26 operator= (const T\x26);\x0a"
"    complex<T>\x26 operator+=(const T\x26);\x0a"
"    complex<T>\x26 operator-=(const T\x26);\x0a"
"    complex<T>\x26 operator*=(const T\x26);\x0a"
"    complex<T>\x26 operator/=(const T\x26);\x0a"
"\x0a"
"    complex\x26 operator=(const complex\x26);\x0a"
"    template<class X> complex<T>\x26 operator= (const complex<X>\x26);\x0a"
"    template<class X> complex<T>\x26 operator+=(const complex<X>\x26);\x0a"
"    template<class X> complex<T>\x26 operator-=(const complex<X>\x26);\x0a"
"    template<class X> complex<T>\x26 operator*=(const complex<X>\x26);\x0a"
"    template<class X> complex<T>\x26 operator/=(const complex<X>\x26);\x0a"
"};\x0a"
"\x0a"
"template<>\x0a"
"class complex<float>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef float value_type;\x0a"
"\x0a"
"    constexpr complex(float re = 0.0f, float im = 0.0f);\x0a"
"    explicit constexpr complex(const complex<double>\x26);\x0a"
"    explicit constexpr complex(const complex<long double>\x26);\x0a"
"\x0a"
"    constexpr float real() const;\x0a"
"    void real(float);\x0a"
"    constexpr float imag() const;\x0a"
"    void imag(float);\x0a"
"\x0a"
"    complex<float>\x26 operator= (float);\x0a"
"    complex<float>\x26 operator+=(float);\x0a"
"    complex<float>\x26 operator-=(float);\x0a"
"    complex<float>\x26 operator*=(float);\x0a"
"    complex<float>\x26 operator/=(float);\x0a"
"\x0a"
"    complex<float>\x26 operator=(const complex<float>\x26);\x0a"
"    template<class X> complex<float>\x26 operator= (const complex<X>\x26);\x0a"
"    template<class X> complex<float>\x26 operator+=(const complex<X>\x26);\x0a"
"    template<class X> complex<float>\x26 operator-=(const complex<X>\x26);\x0a"
"    template<class X> complex<float>\x26 operator*=(const complex<X>\x26);\x0a"
"    template<class X> complex<float>\x26 operator/=(const complex<X>\x26);\x0a"
"};\x0a"
"\x0a"
"template<>\x0a"
"class complex<double>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef double value_type;\x0a"
"\x0a"
"    constexpr complex(double re = 0.0, double im = 0.0);\x0a"
"    constexpr complex(const complex<float>\x26);\x0a"
"    explicit constexpr complex(const complex<long double>\x26);\x0a"
"\x0a"
"    constexpr double real() const;\x0a"
"    void real(double);\x0a"
"    constexpr double imag() const;\x0a"
"    void imag(double);\x0a"
"\x0a"
"    complex<double>\x26 operator= (double);\x0a"
"    complex<double>\x26 operator+=(double);\x0a"
"    complex<double>\x26 operator-=(double);\x0a"
"    complex<double>\x26 operator*=(double);\x0a"
"    complex<double>\x26 operator/=(double);\x0a"
"    complex<double>\x26 operator=(const complex<double>\x26);\x0a"
"\x0a"
"    template<class X> complex<double>\x26 operator= (const complex<X>\x26);\x0a"
"    template<class X> complex<double>\x26 operator+=(const complex<X>\x26);\x0a"
"    template<class X> complex<double>\x26 operator-=(const complex<X>\x26);\x0a"
"    template<class X> complex<double>\x26 operator*=(const complex<X>\x26);\x0a"
"    template<class X> complex<double>\x26 operator/=(const complex<X>\x26);\x0a"
"};\x0a"
"\x0a"
"template<>\x0a"
"class complex<long double>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef long double value_type;\x0a"
"\x0a"
"    constexpr complex(long double re = 0.0L, long double im = 0.0L);\x0a"
"    constexpr complex(const complex<float>\x26);\x0a"
"    constexpr complex(const complex<double>\x26);\x0a"
"\x0a"
"    constexpr long double real() const;\x0a"
"    void real(long double);\x0a"
"    constexpr long double imag() const;\x0a"
"    void imag(long double);\x0a"
"\x0a"
"    complex<long double>\x26 operator=(const complex<long double>\x26);\x0a"
"    complex<long double>\x26 operator= (long double);\x0a"
"    complex<long double>\x26 operator+=(long double);\x0a"
"    complex<long double>\x26 operator-=(long double);\x0a"
"    complex<long double>\x26 operator*=(long double);\x0a"
"    complex<long double>\x26 operator/=(long double);\x0a"
"\x0a"
"    template<class X> complex<long double>\x26 operator= (const complex<X>\x26);\x0a"
"    template<class X> complex<long double>\x26 operator+=(const complex<X>\x26);\x0a"
"    template<class X> complex<long double>\x26 operator-=(const complex<X>\x26);\x0a"
"    template<class X> complex<long double>\x26 operator*=(const complex<X>\x26);\x0a"
"    template<class X> complex<long double>\x26 operator/=(const complex<X>\x26);\x0a"
"};\x0a"
"\x0a"
"// 26.3.6 operators\x3a\x0a"
"template<class T> complex<T> operator+(const complex<T>\x26, const complex<T>\x26);\x0a"
"template<class T> complex<T> operator+(const complex<T>\x26, const T\x26);\x0a"
"template<class T> complex<T> operator+(const T\x26, const complex<T>\x26);\x0a"
"template<class T> complex<T> operator-(const complex<T>\x26, const complex<T>\x26);\x0a"
"template<class T> complex<T> operator-(const complex<T>\x26, const T\x26);\x0a"
"template<class T> complex<T> operator-(const T\x26, const complex<T>\x26);\x0a"
"template<class T> complex<T> operator*(const complex<T>\x26, const complex<T>\x26);\x0a"
"template<class T> complex<T> operator*(const complex<T>\x26, const T\x26);\x0a"
"template<class T> complex<T> operator*(const T\x26, const complex<T>\x26);\x0a"
"template<class T> complex<T> operator/(const complex<T>\x26, const complex<T>\x26);\x0a"
"template<class T> complex<T> operator/(const complex<T>\x26, const T\x26);\x0a"
"template<class T> complex<T> operator/(const T\x26, const complex<T>\x26);\x0a"
"template<class T> complex<T> operator+(const complex<T>\x26);\x0a"
"template<class T> complex<T> operator-(const complex<T>\x26);\x0a"
"template<class T> bool operator==(const complex<T>\x26, const complex<T>\x26); // constexpr in C++14\x0a"
"template<class T> bool operator==(const complex<T>\x26, const T\x26); // constexpr in C++14\x0a"
"template<class T> bool operator==(const T\x26, const complex<T>\x26); // constexpr in C++14\x0a"
"template<class T> bool operator\x21=(const complex<T>\x26, const complex<T>\x26); // constexpr in C++14\x0a"
"template<class T> bool operator\x21=(const complex<T>\x26, const T\x26); // constexpr in C++14\x0a"
"template<class T> bool operator\x21=(const T\x26, const complex<T>\x26); // constexpr in C++14\x0a"
"\x0a"
"template<class T, class charT, class traits>\x0a"
"  basic_istream<charT, traits>\x26\x0a"
"  operator>>(basic_istream<charT, traits>\x26, complex<T>\x26);\x0a"
"template<class T, class charT, class traits>\x0a"
"  basic_ostream<charT, traits>\x26\x0a"
"  operator<<(basic_ostream<charT, traits>\x26, const complex<T>\x26);\x0a"
"\x0a"
"// 26.3.7 values\x3a\x0a"
"\x0a"
"template<class T>              T real(const complex<T>\x26); // constexpr in C++14\x0a"
"                     long double real(long double);       // constexpr in C++14\x0a"
"                          double real(double);            // constexpr in C++14\x0a"
"template<Integral T>      double real(T);                 // constexpr in C++14\x0a"
"                          float  real(float);             // constexpr in C++14\x0a"
"\x0a"
"template<class T>              T imag(const complex<T>\x26); // constexpr in C++14\x0a"
"                     long double imag(long double);       // constexpr in C++14\x0a"
"                          double imag(double);            // constexpr in C++14\x0a"
"template<Integral T>      double imag(T);                 // constexpr in C++14\x0a"
"                          float  imag(float);             // constexpr in C++14\x0a"
"\x0a"
"template<class T> T abs(const complex<T>\x26);\x0a"
"\x0a"
"template<class T>              T arg(const complex<T>\x26);\x0a"
"                     long double arg(long double);\x0a"
"                          double arg(double);\x0a"
"template<Integral T>      double arg(T);\x0a"
"                          float  arg(float);\x0a"
"\x0a"
"template<class T>              T norm(const complex<T>\x26);\x0a"
"                     long double norm(long double);\x0a"
"                          double norm(double);\x0a"
"template<Integral T>      double norm(T);\x0a"
"                          float  norm(float);\x0a"
"\x0a"
"template<class T>      complex<T>           conj(const complex<T>\x26);\x0a"
"                       complex<long double> conj(long double);\x0a"
"                       complex<double>      conj(double);\x0a"
"template<Integral T>   complex<double>      conj(T);\x0a"
"                       complex<float>       conj(float);\x0a"
"\x0a"
"template<class T>    complex<T>           proj(const complex<T>\x26);\x0a"
"                     complex<long double> proj(long double);\x0a"
"                     complex<double>      proj(double);\x0a"
"template<Integral T> complex<double>      proj(T);\x0a"
"                     complex<float>       proj(float);\x0a"
"\x0a"
"template<class T> complex<T> polar(const T\x26, const T\x26 = T());\x0a"
"\x0a"
"// 26.3.8 transcendentals\x3a\x0a"
"template<class T> complex<T> acos(const complex<T>\x26);\x0a"
"template<class T> complex<T> asin(const complex<T>\x26);\x0a"
"template<class T> complex<T> atan(const complex<T>\x26);\x0a"
"template<class T> complex<T> acosh(const complex<T>\x26);\x0a"
"template<class T> complex<T> asinh(const complex<T>\x26);\x0a"
"template<class T> complex<T> atanh(const complex<T>\x26);\x0a"
"template<class T> complex<T> cos (const complex<T>\x26);\x0a"
"template<class T> complex<T> cosh (const complex<T>\x26);\x0a"
"template<class T> complex<T> exp (const complex<T>\x26);\x0a"
"template<class T> complex<T> log (const complex<T>\x26);\x0a"
"template<class T> complex<T> log10(const complex<T>\x26);\x0a"
"\x0a"
"template<class T> complex<T> pow(const complex<T>\x26, const T\x26);\x0a"
"template<class T> complex<T> pow(const complex<T>\x26, const complex<T>\x26);\x0a"
"template<class T> complex<T> pow(const T\x26, const complex<T>\x26);\x0a"
"\x0a"
"template<class T> complex<T> sin (const complex<T>\x26);\x0a"
"template<class T> complex<T> sinh (const complex<T>\x26);\x0a"
"template<class T> complex<T> sqrt (const complex<T>\x26);\x0a"
"template<class T> complex<T> tan (const complex<T>\x26);\x0a"
"template<class T> complex<T> tanh (const complex<T>\x26);\x0a"
"\x0a"
"template<class T, class charT, class traits>\x0a"
"  basic_istream<charT, traits>\x26\x0a"
"  operator>>(basic_istream<charT, traits>\x26 is, complex<T>\x26 x);\x0a"
"\x0a"
"template<class T, class charT, class traits>\x0a"
"  basic_ostream<charT, traits>\x26\x0a"
"  operator<<(basic_ostream<charT, traits>\x26 o, const complex<T>\x26 x);\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <type_traits>\x0a"
"#include <stdexcept>\x0a"
"#include <cmath>\x0a"
"#include <sstream>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template<class _Tp> class _LIBCPP_TEMPLATE_VIS complex;\x0a"
"\x0a"
"template<class _Tp> complex<_Tp> operator*(const complex<_Tp>\x26 __z, const complex<_Tp>\x26 __w);\x0a"
"template<class _Tp> complex<_Tp> operator/(const complex<_Tp>\x26 __x, const complex<_Tp>\x26 __y);\x0a"
"\x0a"
"template<class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS complex\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp value_type;\x0a"
"private\x3a\x0a"
"    value_type __re_;\x0a"
"    value_type __im_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    complex(const value_type\x26 __re = value_type(), const value_type\x26 __im = value_type())\x0a"
"        \x3a __re_(__re), __im_(__im) {}\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    complex(const complex<_Xp>\x26 __c)\x0a"
"        \x3a __re_(__c.real()), __im_(__c.imag()) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 value_type real() const {return __re_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 value_type imag() const {return __im_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void real(value_type __re) {__re_ = __re;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void imag(value_type __im) {__im_ = __im;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator= (const value_type\x26 __re)\x0a"
"        {__re_ = __re; __im_ = value_type(); return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator+=(const value_type\x26 __re) {__re_ += __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator-=(const value_type\x26 __re) {__re_ -= __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator*=(const value_type\x26 __re) {__re_ *= __re; __im_ *= __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator/=(const value_type\x26 __re) {__re_ /= __re; __im_ /= __re; return *this;}\x0a"
"\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator= (const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ = __c.real();\x0a"
"            __im_ = __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator+=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ += __c.real();\x0a"
"            __im_ += __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator-=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ -= __c.real();\x0a"
"            __im_ -= __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator*=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            *this = *this * complex(__c.real(), __c.imag());\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator/=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            *this = *this / complex(__c.real(), __c.imag());\x0a"
"            return *this;\x0a"
"        }\x0a"
"};\x0a"
"\x0a"
"template<> class _LIBCPP_TEMPLATE_VIS complex<double>;\x0a"
"template<> class _LIBCPP_TEMPLATE_VIS complex<long double>;\x0a"
"\x0a"
"template<>\x0a"
"class _LIBCPP_TEMPLATE_VIS complex<float>\x0a"
"{\x0a"
"    float __re_;\x0a"
"    float __im_;\x0a"
"public\x3a\x0a"
"    typedef float value_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR complex(float __re = 0.0f, float __im = 0.0f)\x0a"
"        \x3a __re_(__re), __im_(__im) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit _LIBCPP_CONSTEXPR complex(const complex<double>\x26 __c);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit _LIBCPP_CONSTEXPR complex(const complex<long double>\x26 __c);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR float real() const {return __re_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR float imag() const {return __im_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void real(value_type __re) {__re_ = __re;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void imag(value_type __im) {__im_ = __im;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator= (float __re)\x0a"
"        {__re_ = __re; __im_ = value_type(); return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator+=(float __re) {__re_ += __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator-=(float __re) {__re_ -= __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator*=(float __re) {__re_ *= __re; __im_ *= __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator/=(float __re) {__re_ /= __re; __im_ /= __re; return *this;}\x0a"
"\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator= (const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ = __c.real();\x0a"
"            __im_ = __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator+=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ += __c.real();\x0a"
"            __im_ += __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator-=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ -= __c.real();\x0a"
"            __im_ -= __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator*=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            *this = *this * complex(__c.real(), __c.imag());\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator/=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            *this = *this / complex(__c.real(), __c.imag());\x0a"
"            return *this;\x0a"
"        }\x0a"
"};\x0a"
"\x0a"
"template<>\x0a"
"class _LIBCPP_TEMPLATE_VIS complex<double>\x0a"
"{\x0a"
"    double __re_;\x0a"
"    double __im_;\x0a"
"public\x3a\x0a"
"    typedef double value_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR complex(double __re = 0.0, double __im = 0.0)\x0a"
"        \x3a __re_(__re), __im_(__im) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR complex(const complex<float>\x26 __c);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit _LIBCPP_CONSTEXPR complex(const complex<long double>\x26 __c);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR double real() const {return __re_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR double imag() const {return __im_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void real(value_type __re) {__re_ = __re;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void imag(value_type __im) {__im_ = __im;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator= (double __re)\x0a"
"        {__re_ = __re; __im_ = value_type(); return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator+=(double __re) {__re_ += __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator-=(double __re) {__re_ -= __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator*=(double __re) {__re_ *= __re; __im_ *= __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator/=(double __re) {__re_ /= __re; __im_ /= __re; return *this;}\x0a"
"\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator= (const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ = __c.real();\x0a"
"            __im_ = __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator+=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ += __c.real();\x0a"
"            __im_ += __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator-=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ -= __c.real();\x0a"
"            __im_ -= __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator*=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            *this = *this * complex(__c.real(), __c.imag());\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator/=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            *this = *this / complex(__c.real(), __c.imag());\x0a"
"            return *this;\x0a"
"        }\x0a"
"};\x0a"
"\x0a"
"template<>\x0a"
"class _LIBCPP_TEMPLATE_VIS complex<long double>\x0a"
"{\x0a"
"    long double __re_;\x0a"
"    long double __im_;\x0a"
"public\x3a\x0a"
"    typedef long double value_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR complex(long double __re = 0.0L, long double __im = 0.0L)\x0a"
"        \x3a __re_(__re), __im_(__im) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR complex(const complex<float>\x26 __c);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR complex(const complex<double>\x26 __c);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR long double real() const {return __re_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR long double imag() const {return __im_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void real(value_type __re) {__re_ = __re;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void imag(value_type __im) {__im_ = __im;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator= (long double __re)\x0a"
"        {__re_ = __re; __im_ = value_type(); return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator+=(long double __re) {__re_ += __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator-=(long double __re) {__re_ -= __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator*=(long double __re) {__re_ *= __re; __im_ *= __re; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY complex\x26 operator/=(long double __re) {__re_ /= __re; __im_ /= __re; return *this;}\x0a"
"\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator= (const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ = __c.real();\x0a"
"            __im_ = __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator+=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ += __c.real();\x0a"
"            __im_ += __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator-=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            __re_ -= __c.real();\x0a"
"            __im_ -= __c.imag();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator*=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            *this = *this * complex(__c.real(), __c.imag());\x0a"
"            return *this;\x0a"
"        }\x0a"
"    template<class _Xp> _LIBCPP_INLINE_VISIBILITY complex\x26 operator/=(const complex<_Xp>\x26 __c)\x0a"
"        {\x0a"
"            *this = *this / complex(__c.real(), __c.imag());\x0a"
"            return *this;\x0a"
"        }\x0a"
"};\x0a"
"\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"complex<float>\x3a\x3a""complex(const complex<double>\x26 __c)\x0a"
"    \x3a __re_(__c.real()), __im_(__c.imag()) {}\x0a"
"\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"complex<float>\x3a\x3a""complex(const complex<long double>\x26 __c)\x0a"
"    \x3a __re_(__c.real()), __im_(__c.imag()) {}\x0a"
"\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"complex<double>\x3a\x3a""complex(const complex<float>\x26 __c)\x0a"
"    \x3a __re_(__c.real()), __im_(__c.imag()) {}\x0a"
"\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"complex<double>\x3a\x3a""complex(const complex<long double>\x26 __c)\x0a"
"    \x3a __re_(__c.real()), __im_(__c.imag()) {}\x0a"
"\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"complex<long double>\x3a\x3a""complex(const complex<float>\x26 __c)\x0a"
"    \x3a __re_(__c.real()), __im_(__c.imag()) {}\x0a"
"\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"complex<long double>\x3a\x3a""complex(const complex<double>\x26 __c)\x0a"
"    \x3a __re_(__c.real()), __im_(__c.imag()) {}\x0a"
"\x0a"
"// 26.3.6 operators\x3a\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator+(const complex<_Tp>\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    complex<_Tp> __t(__x);\x0a"
"    __t += __y;\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator+(const complex<_Tp>\x26 __x, const _Tp\x26 __y)\x0a"
"{\x0a"
"    complex<_Tp> __t(__x);\x0a"
"    __t += __y;\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator+(const _Tp\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    complex<_Tp> __t(__y);\x0a"
"    __t += __x;\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator-(const complex<_Tp>\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    complex<_Tp> __t(__x);\x0a"
"    __t -= __y;\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator-(const complex<_Tp>\x26 __x, const _Tp\x26 __y)\x0a"
"{\x0a"
"    complex<_Tp> __t(__x);\x0a"
"    __t -= __y;\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator-(const _Tp\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    complex<_Tp> __t(-__y);\x0a"
"    __t += __x;\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"operator*(const complex<_Tp>\x26 __z, const complex<_Tp>\x26 __w)\x0a"
"{\x0a"
"    _Tp __a = __z.real();\x0a"
"    _Tp __b = __z.imag();\x0a"
"    _Tp __c = __w.real();\x0a"
"    _Tp __d = __w.imag();\x0a"
"    _Tp __ac = __a * __c;\x0a"
"    _Tp __bd = __b * __d;\x0a"
"    _Tp __ad = __a * __d;\x0a"
"    _Tp __bc = __b * __c;\x0a"
"    _Tp __x = __ac - __bd;\x0a"
"    _Tp __y = __ad + __bc;\x0a"
"    if (__libcpp_isnan_or_builtin(__x) \x26\x26 __libcpp_isnan_or_builtin(__y))\x0a"
"    {\x0a"
"        bool __recalc = false;\x0a"
"        if (__libcpp_isinf_or_builtin(__a) \x7c\x7c __libcpp_isinf_or_builtin(__b))\x0a"
"        {\x0a"
"            __a = copysign(__libcpp_isinf_or_builtin(__a) \x3f _Tp(1) \x3a _Tp(0), __a);\x0a"
"            __b = copysign(__libcpp_isinf_or_builtin(__b) \x3f _Tp(1) \x3a _Tp(0), __b);\x0a"
"            if (__libcpp_isnan_or_builtin(__c))\x0a"
"                __c = copysign(_Tp(0), __c);\x0a"
"            if (__libcpp_isnan_or_builtin(__d))\x0a"
"                __d = copysign(_Tp(0), __d);\x0a"
"            __recalc = true;\x0a"
"        }\x0a"
"        if (__libcpp_isinf_or_builtin(__c) \x7c\x7c __libcpp_isinf_or_builtin(__d))\x0a"
"        {\x0a"
"            __c = copysign(__libcpp_isinf_or_builtin(__c) \x3f _Tp(1) \x3a _Tp(0), __c);\x0a"
"            __d = copysign(__libcpp_isinf_or_builtin(__d) \x3f _Tp(1) \x3a _Tp(0), __d);\x0a"
"            if (__libcpp_isnan_or_builtin(__a))\x0a"
"                __a = copysign(_Tp(0), __a);\x0a"
"            if (__libcpp_isnan_or_builtin(__b))\x0a"
"                __b = copysign(_Tp(0), __b);\x0a"
"            __recalc = true;\x0a"
"        }\x0a"
"        if (\x21__recalc \x26\x26 (__libcpp_isinf_or_builtin(__ac) \x7c\x7c __libcpp_isinf_or_builtin(__bd) \x7c\x7c\x0a"
"                          __libcpp_isinf_or_builtin(__ad) \x7c\x7c __libcpp_isinf_or_builtin(__bc)))\x0a"
"        {\x0a"
"            if (__libcpp_isnan_or_builtin(__a))\x0a"
"                __a = copysign(_Tp(0), __a);\x0a"
"            if (__libcpp_isnan_or_builtin(__b))\x0a"
"                __b = copysign(_Tp(0), __b);\x0a"
"            if (__libcpp_isnan_or_builtin(__c))\x0a"
"                __c = copysign(_Tp(0), __c);\x0a"
"            if (__libcpp_isnan_or_builtin(__d))\x0a"
"                __d = copysign(_Tp(0), __d);\x0a"
"            __recalc = true;\x0a"
"        }\x0a"
"        if (__recalc)\x0a"
"        {\x0a"
"            __x = _Tp(INFINITY) * (__a * __c - __b * __d);\x0a"
"            __y = _Tp(INFINITY) * (__a * __d + __b * __c);\x0a"
"        }\x0a"
"    }\x0a"
"    return complex<_Tp>(__x, __y);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator*(const complex<_Tp>\x26 __x, const _Tp\x26 __y)\x0a"
"{\x0a"
"    complex<_Tp> __t(__x);\x0a"
"    __t *= __y;\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator*(const _Tp\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    complex<_Tp> __t(__y);\x0a"
"    __t *= __x;\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"operator/(const complex<_Tp>\x26 __z, const complex<_Tp>\x26 __w)\x0a"
"{\x0a"
"    int __ilogbw = 0;\x0a"
"    _Tp __a = __z.real();\x0a"
"    _Tp __b = __z.imag();\x0a"
"    _Tp __c = __w.real();\x0a"
"    _Tp __d = __w.imag();\x0a"
"    _Tp __logbw = logb(fmax(fabs(__c), fabs(__d)));\x0a"
"    if (__libcpp_isfinite_or_builtin(__logbw))\x0a"
"    {\x0a"
"        __ilogbw = static_cast<int>(__logbw);\x0a"
"        __c = scalbn(__c, -__ilogbw);\x0a"
"        __d = scalbn(__d, -__ilogbw);\x0a"
"    }\x0a"
"    _Tp __denom = __c * __c + __d * __d;\x0a"
"    _Tp __x = scalbn((__a * __c + __b * __d) / __denom, -__ilogbw);\x0a"
"    _Tp __y = scalbn((__b * __c - __a * __d) / __denom, -__ilogbw);\x0a"
"    if (__libcpp_isnan_or_builtin(__x) \x26\x26 __libcpp_isnan_or_builtin(__y))\x0a"
"    {\x0a"
"        if ((__denom == _Tp(0)) \x26\x26 (\x21__libcpp_isnan_or_builtin(__a) \x7c\x7c \x21__libcpp_isnan_or_builtin(__b)))\x0a"
"        {\x0a"
"            __x = copysign(_Tp(INFINITY), __c) * __a;\x0a"
"            __y = copysign(_Tp(INFINITY), __c) * __b;\x0a"
"        }\x0a"
"        else if ((__libcpp_isinf_or_builtin(__a) \x7c\x7c __libcpp_isinf_or_builtin(__b)) \x26\x26 __libcpp_isfinite_or_builtin(__c) \x26\x26 __libcpp_isfinite_or_builtin(__d))\x0a"
"        {\x0a"
"            __a = copysign(__libcpp_isinf_or_builtin(__a) \x3f _Tp(1) \x3a _Tp(0), __a);\x0a"
"            __b = copysign(__libcpp_isinf_or_builtin(__b) \x3f _Tp(1) \x3a _Tp(0), __b);\x0a"
"            __x = _Tp(INFINITY) * (__a * __c + __b * __d);\x0a"
"            __y = _Tp(INFINITY) * (__b * __c - __a * __d);\x0a"
"        }\x0a"
"        else if (__libcpp_isinf_or_builtin(__logbw) \x26\x26 __logbw > _Tp(0) \x26\x26 __libcpp_isfinite_or_builtin(__a) \x26\x26 __libcpp_isfinite_or_builtin(__b))\x0a"
"        {\x0a"
"            __c = copysign(__libcpp_isinf_or_builtin(__c) \x3f _Tp(1) \x3a _Tp(0), __c);\x0a"
"            __d = copysign(__libcpp_isinf_or_builtin(__d) \x3f _Tp(1) \x3a _Tp(0), __d);\x0a"
"            __x = _Tp(0) * (__a * __c + __b * __d);\x0a"
"            __y = _Tp(0) * (__b * __c - __a * __d);\x0a"
"        }\x0a"
"    }\x0a"
"    return complex<_Tp>(__x, __y);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator/(const complex<_Tp>\x26 __x, const _Tp\x26 __y)\x0a"
"{\x0a"
"    return complex<_Tp>(__x.real() / __y, __x.imag() / __y);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator/(const _Tp\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    complex<_Tp> __t(__x);\x0a"
"    __t /= __y;\x0a"
"    return __t;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator+(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"operator-(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    return complex<_Tp>(-__x.real(), -__x.imag());\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator==(const complex<_Tp>\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    return __x.real() == __y.real() \x26\x26 __x.imag() == __y.imag();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator==(const complex<_Tp>\x26 __x, const _Tp\x26 __y)\x0a"
"{\x0a"
"    return __x.real() == __y \x26\x26 __x.imag() == 0;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator==(const _Tp\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    return __x == __y.real() \x26\x26 0 == __y.imag();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator\x21=(const complex<_Tp>\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator\x21=(const complex<_Tp>\x26 __x, const _Tp\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator\x21=(const _Tp\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"// 26.3.7 values\x3a\x0a"
"\x0a"
"template <class _Tp, bool = is_integral<_Tp>\x3a\x3avalue,\x0a"
"                     bool = is_floating_point<_Tp>\x3a\x3avalue\x0a"
"                     >\x0a"
"struct __libcpp_complex_overload_traits {};\x0a"
"\x0a"
"// Integral Types\x0a"
"template <class _Tp>\x0a"
"struct __libcpp_complex_overload_traits<_Tp, true, false>\x0a"
"{\x0a"
"    typedef double _ValueType;\x0a"
"    typedef complex<double> _ComplexType;\x0a"
"};\x0a"
"\x0a"
"// Floating point types\x0a"
"template <class _Tp>\x0a"
"struct __libcpp_complex_overload_traits<_Tp, false, true>\x0a"
"{\x0a"
"    typedef _Tp _ValueType;\x0a"
"    typedef complex<_Tp> _ComplexType;\x0a"
"};\x0a"
"\x0a"
"// real\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp\x0a"
"real(const complex<_Tp>\x26 __c)\x0a"
"{\x0a"
"    return __c.real();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"typename __libcpp_complex_overload_traits<_Tp>\x3a\x3a_ValueType\x0a"
"real(_Tp __re)\x0a"
"{\x0a"
"    return __re;\x0a"
"}\x0a"
"\x0a"
"// imag\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp\x0a"
"imag(const complex<_Tp>\x26 __c)\x0a"
"{\x0a"
"    return __c.imag();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"typename __libcpp_complex_overload_traits<_Tp>\x3a\x3a_ValueType\x0a"
"imag(_Tp)\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"// abs\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"abs(const complex<_Tp>\x26 __c)\x0a"
"{\x0a"
"    return hypot(__c.real(), __c.imag());\x0a"
"}\x0a"
"\x0a"
"// arg\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"arg(const complex<_Tp>\x26 __c)\x0a"
"{\x0a"
"    return atan2(__c.imag(), __c.real());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if<\x0a"
"    is_same<_Tp, long double>\x3a\x3avalue,\x0a"
"    long double\x0a"
">\x3a\x3atype\x0a"
"arg(_Tp __re)\x0a"
"{\x0a"
"    return atan2l(0.L, __re);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue \x7c\x7c is_same<_Tp, double>\x3a\x3avalue,\x0a"
"    double\x0a"
">\x3a\x3atype\x0a"
"arg(_Tp __re)\x0a"
"{\x0a"
"    return atan2(0., __re);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if<\x0a"
"    is_same<_Tp, float>\x3a\x3avalue,\x0a"
"    float\x0a"
">\x3a\x3atype\x0a"
"arg(_Tp __re)\x0a"
"{\x0a"
"    return atan2f(0.F, __re);\x0a"
"}\x0a"
"\x0a"
"// norm\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"norm(const complex<_Tp>\x26 __c)\x0a"
"{\x0a"
"    if (__libcpp_isinf_or_builtin(__c.real()))\x0a"
"        return abs(__c.real());\x0a"
"    if (__libcpp_isinf_or_builtin(__c.imag()))\x0a"
"        return abs(__c.imag());\x0a"
"    return __c.real() * __c.real() + __c.imag() * __c.imag();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename __libcpp_complex_overload_traits<_Tp>\x3a\x3a_ValueType\x0a"
"norm(_Tp __re)\x0a"
"{\x0a"
"    typedef typename __libcpp_complex_overload_traits<_Tp>\x3a\x3a_ValueType _ValueType;\x0a"
"    return static_cast<_ValueType>(__re) * __re;\x0a"
"}\x0a"
"\x0a"
"// conj\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"conj(const complex<_Tp>\x26 __c)\x0a"
"{\x0a"
"    return complex<_Tp>(__c.real(), -__c.imag());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename __libcpp_complex_overload_traits<_Tp>\x3a\x3a_ComplexType\x0a"
"conj(_Tp __re)\x0a"
"{\x0a"
"    typedef typename __libcpp_complex_overload_traits<_Tp>\x3a\x3a_ComplexType _ComplexType;\x0a"
"    return _ComplexType(__re);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"\x0a"
"// proj\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"proj(const complex<_Tp>\x26 __c)\x0a"
"{\x0a"
"    std\x3a\x3a""complex<_Tp> __r = __c;\x0a"
"    if (__libcpp_isinf_or_builtin(__c.real()) \x7c\x7c __libcpp_isinf_or_builtin(__c.imag()))\x0a"
"        __r = complex<_Tp>(INFINITY, copysign(_Tp(0), __c.imag()));\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_floating_point<_Tp>\x3a\x3avalue,\x0a"
"    typename __libcpp_complex_overload_traits<_Tp>\x3a\x3a_ComplexType\x0a"
">\x3a\x3atype\x0a"
"proj(_Tp __re)\x0a"
"{\x0a"
"    if (__libcpp_isinf_or_builtin(__re))\x0a"
"        __re = abs(__re);\x0a"
"    return complex<_Tp>(__re);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Tp>\x3a\x3avalue,\x0a"
"    typename __libcpp_complex_overload_traits<_Tp>\x3a\x3a_ComplexType\x0a"
">\x3a\x3atype\x0a"
"proj(_Tp __re)\x0a"
"{\x0a"
"    typedef typename __libcpp_complex_overload_traits<_Tp>\x3a\x3a_ComplexType _ComplexType;\x0a"
"    return _ComplexType(__re);\x0a"
"}\x0a"
"\x0a"
"// polar\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"polar(const _Tp\x26 __rho, const _Tp\x26 __theta = _Tp())\x0a"
"{\x0a"
"    if (__libcpp_isnan_or_builtin(__rho) \x7c\x7c signbit(__rho))\x0a"
"        return complex<_Tp>(_Tp(NAN), _Tp(NAN));\x0a"
"    if (__libcpp_isnan_or_builtin(__theta))\x0a"
"    {\x0a"
"        if (__libcpp_isinf_or_builtin(__rho))\x0a"
"            return complex<_Tp>(__rho, __theta);\x0a"
"        return complex<_Tp>(__theta, __theta);\x0a"
"    }\x0a"
"    if (__libcpp_isinf_or_builtin(__theta))\x0a"
"    {\x0a"
"        if (__libcpp_isinf_or_builtin(__rho))\x0a"
"            return complex<_Tp>(__rho, _Tp(NAN));\x0a"
"        return complex<_Tp>(_Tp(NAN), _Tp(NAN));\x0a"
"    }\x0a"
"    _Tp __x = __rho * cos(__theta);\x0a"
"    if (__libcpp_isnan_or_builtin(__x))\x0a"
"        __x = 0;\x0a"
"    _Tp __y = __rho * sin(__theta);\x0a"
"    if (__libcpp_isnan_or_builtin(__y))\x0a"
"        __y = 0;\x0a"
"    return complex<_Tp>(__x, __y);\x0a"
"}\x0a"
"\x0a"
"// log\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"log(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    return complex<_Tp>(log(abs(__x)), arg(__x));\x0a"
"}\x0a"
"\x0a"
"// log10\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"log10(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    return log(__x) / log(_Tp(10));\x0a"
"}\x0a"
"\x0a"
"// sqrt\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"sqrt(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"        return complex<_Tp>(_Tp(INFINITY), __x.imag());\x0a"
"    if (__libcpp_isinf_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        if (__x.real() > _Tp(0))\x0a"
"            return complex<_Tp>(__x.real(), __libcpp_isnan_or_builtin(__x.imag()) \x3f __x.imag() \x3a copysign(_Tp(0), __x.imag()));\x0a"
"        return complex<_Tp>(__libcpp_isnan_or_builtin(__x.imag()) \x3f __x.imag() \x3a _Tp(0), copysign(__x.real(), __x.imag()));\x0a"
"    }\x0a"
"    return polar(sqrt(abs(__x)), arg(__x) / _Tp(2));\x0a"
"}\x0a"
"\x0a"
"// exp\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"exp(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    _Tp __i = __x.imag();\x0a"
"    if (__libcpp_isinf_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        if (__x.real() < _Tp(0))\x0a"
"        {\x0a"
"            if (\x21__libcpp_isfinite_or_builtin(__i))\x0a"
"                __i = _Tp(1);\x0a"
"        }\x0a"
"        else if (__i == 0 \x7c\x7c \x21__libcpp_isfinite_or_builtin(__i))\x0a"
"        {\x0a"
"            if (__libcpp_isinf_or_builtin(__i))\x0a"
"                __i = _Tp(NAN);\x0a"
"            return complex<_Tp>(__x.real(), __i);\x0a"
"        }\x0a"
"    }\x0a"
"    else if (__libcpp_isnan_or_builtin(__x.real()) \x26\x26 __x.imag() == 0)\x0a"
"        return __x;\x0a"
"    _Tp __e = exp(__x.real());\x0a"
"    return complex<_Tp>(__e * cos(__i), __e * sin(__i));\x0a"
"}\x0a"
"\x0a"
"// pow\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"pow(const complex<_Tp>\x26 __x, const complex<_Tp>\x26 __y)\x0a"
"{\x0a"
"    return exp(__y * log(__x));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<typename __promote<_Tp, _Up>\x3a\x3atype>\x0a"
"pow(const complex<_Tp>\x26 __x, const complex<_Up>\x26 __y)\x0a"
"{\x0a"
"    typedef complex<typename __promote<_Tp, _Up>\x3a\x3atype> result_type;\x0a"
"    return _VSTD\x3a\x3apow(result_type(__x), result_type(__y));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_arithmetic<_Up>\x3a\x3avalue,\x0a"
"    complex<typename __promote<_Tp, _Up>\x3a\x3atype>\x0a"
">\x3a\x3atype\x0a"
"pow(const complex<_Tp>\x26 __x, const _Up\x26 __y)\x0a"
"{\x0a"
"    typedef complex<typename __promote<_Tp, _Up>\x3a\x3atype> result_type;\x0a"
"    return _VSTD\x3a\x3apow(result_type(__x), result_type(__y));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_arithmetic<_Tp>\x3a\x3avalue,\x0a"
"    complex<typename __promote<_Tp, _Up>\x3a\x3atype>\x0a"
">\x3a\x3atype\x0a"
"pow(const _Tp\x26 __x, const complex<_Up>\x26 __y)\x0a"
"{\x0a"
"    typedef complex<typename __promote<_Tp, _Up>\x3a\x3atype> result_type;\x0a"
"    return _VSTD\x3a\x3apow(result_type(__x), result_type(__y));\x0a"
"}\x0a"
"\x0a"
"// __sqr, computes pow(x, 2)\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"__sqr(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    return complex<_Tp>((__x.real() - __x.imag()) * (__x.real() + __x.imag()),\x0a"
"                        _Tp(2) * __x.real() * __x.imag());\x0a"
"}\x0a"
"\x0a"
"// asinh\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"asinh(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    const _Tp __pi(atan2(+0., -0.));\x0a"
"    if (__libcpp_isinf_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        if (__libcpp_isnan_or_builtin(__x.imag()))\x0a"
"            return __x;\x0a"
"        if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"            return complex<_Tp>(__x.real(), copysign(__pi * _Tp(0.25), __x.imag()));\x0a"
"        return complex<_Tp>(__x.real(), copysign(_Tp(0), __x.imag()));\x0a"
"    }\x0a"
"    if (__libcpp_isnan_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"            return complex<_Tp>(__x.imag(), __x.real());\x0a"
"        if (__x.imag() == 0)\x0a"
"            return __x;\x0a"
"        return complex<_Tp>(__x.real(), __x.real());\x0a"
"    }\x0a"
"    if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"        return complex<_Tp>(copysign(__x.imag(), __x.real()), copysign(__pi/_Tp(2), __x.imag()));\x0a"
"    complex<_Tp> __z = log(__x + sqrt(__sqr(__x) + _Tp(1)));\x0a"
"    return complex<_Tp>(copysign(__z.real(), __x.real()), copysign(__z.imag(), __x.imag()));\x0a"
"}\x0a"
"\x0a"
"// acosh\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"acosh(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    const _Tp __pi(atan2(+0., -0.));\x0a"
"    if (__libcpp_isinf_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        if (__libcpp_isnan_or_builtin(__x.imag()))\x0a"
"            return complex<_Tp>(abs(__x.real()), __x.imag());\x0a"
"        if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"        {\x0a"
"            if (__x.real() > 0)\x0a"
"                return complex<_Tp>(__x.real(), copysign(__pi * _Tp(0.25), __x.imag()));\x0a"
"            else\x0a"
"                return complex<_Tp>(-__x.real(), copysign(__pi * _Tp(0.75), __x.imag()));\x0a"
"        }\x0a"
"        if (__x.real() < 0)\x0a"
"            return complex<_Tp>(-__x.real(), copysign(__pi, __x.imag()));\x0a"
"        return complex<_Tp>(__x.real(), copysign(_Tp(0), __x.imag()));\x0a"
"    }\x0a"
"    if (__libcpp_isnan_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"            return complex<_Tp>(abs(__x.imag()), __x.real());\x0a"
"        return complex<_Tp>(__x.real(), __x.real());\x0a"
"    }\x0a"
"    if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"        return complex<_Tp>(abs(__x.imag()), copysign(__pi/_Tp(2), __x.imag()));\x0a"
"    complex<_Tp> __z = log(__x + sqrt(__sqr(__x) - _Tp(1)));\x0a"
"    return complex<_Tp>(copysign(__z.real(), _Tp(0)), copysign(__z.imag(), __x.imag()));\x0a"
"}\x0a"
"\x0a"
"// atanh\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"atanh(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    const _Tp __pi(atan2(+0., -0.));\x0a"
"    if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"    {\x0a"
"        return complex<_Tp>(copysign(_Tp(0), __x.real()), copysign(__pi/_Tp(2), __x.imag()));\x0a"
"    }\x0a"
"    if (__libcpp_isnan_or_builtin(__x.imag()))\x0a"
"    {\x0a"
"        if (__libcpp_isinf_or_builtin(__x.real()) \x7c\x7c __x.real() == 0)\x0a"
"            return complex<_Tp>(copysign(_Tp(0), __x.real()), __x.imag());\x0a"
"        return complex<_Tp>(__x.imag(), __x.imag());\x0a"
"    }\x0a"
"    if (__libcpp_isnan_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        return complex<_Tp>(__x.real(), __x.real());\x0a"
"    }\x0a"
"    if (__libcpp_isinf_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        return complex<_Tp>(copysign(_Tp(0), __x.real()), copysign(__pi/_Tp(2), __x.imag()));\x0a"
"    }\x0a"
"    if (abs(__x.real()) == _Tp(1) \x26\x26 __x.imag() == _Tp(0))\x0a"
"    {\x0a"
"        return complex<_Tp>(copysign(_Tp(INFINITY), __x.real()), copysign(_Tp(0), __x.imag()));\x0a"
"    }\x0a"
"    complex<_Tp> __z = log((_Tp(1) + __x) / (_Tp(1) - __x)) / _Tp(2);\x0a"
"    return complex<_Tp>(copysign(__z.real(), __x.real()), copysign(__z.imag(), __x.imag()));\x0a"
"}\x0a"
"\x0a"
"// sinh\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"sinh(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    if (__libcpp_isinf_or_builtin(__x.real()) \x26\x26 \x21__libcpp_isfinite_or_builtin(__x.imag()))\x0a"
"        return complex<_Tp>(__x.real(), _Tp(NAN));\x0a"
"    if (__x.real() == 0 \x26\x26 \x21__libcpp_isfinite_or_builtin(__x.imag()))\x0a"
"        return complex<_Tp>(__x.real(), _Tp(NAN));\x0a"
"    if (__x.imag() == 0 \x26\x26 \x21__libcpp_isfinite_or_builtin(__x.real()))\x0a"
"        return __x;\x0a"
"    return complex<_Tp>(sinh(__x.real()) * cos(__x.imag()), cosh(__x.real()) * sin(__x.imag()));\x0a"
"}\x0a"
"\x0a"
"// cosh\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"cosh(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    if (__libcpp_isinf_or_builtin(__x.real()) \x26\x26 \x21__libcpp_isfinite_or_builtin(__x.imag()))\x0a"
"        return complex<_Tp>(abs(__x.real()), _Tp(NAN));\x0a"
"    if (__x.real() == 0 \x26\x26 \x21__libcpp_isfinite_or_builtin(__x.imag()))\x0a"
"        return complex<_Tp>(_Tp(NAN), __x.real());\x0a"
"    if (__x.real() == 0 \x26\x26 __x.imag() == 0)\x0a"
"        return complex<_Tp>(_Tp(1), __x.imag());\x0a"
"    if (__x.imag() == 0 \x26\x26 \x21__libcpp_isfinite_or_builtin(__x.real()))\x0a"
"        return complex<_Tp>(abs(__x.real()), __x.imag());\x0a"
"    return complex<_Tp>(cosh(__x.real()) * cos(__x.imag()), sinh(__x.real()) * sin(__x.imag()));\x0a"
"}\x0a"
"\x0a"
"// tanh\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"tanh(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    if (__libcpp_isinf_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        if (\x21__libcpp_isfinite_or_builtin(__x.imag()))\x0a"
"            return complex<_Tp>(_Tp(1), _Tp(0));\x0a"
"        return complex<_Tp>(_Tp(1), copysign(_Tp(0), sin(_Tp(2) * __x.imag())));\x0a"
"    }\x0a"
"    if (__libcpp_isnan_or_builtin(__x.real()) \x26\x26 __x.imag() == 0)\x0a"
"        return __x;\x0a"
"    _Tp __2r(_Tp(2) * __x.real());\x0a"
"    _Tp __2i(_Tp(2) * __x.imag());\x0a"
"    _Tp __d(cosh(__2r) + cos(__2i));\x0a"
"    _Tp __2rsh(sinh(__2r));\x0a"
"    if (__libcpp_isinf_or_builtin(__2rsh) \x26\x26 __libcpp_isinf_or_builtin(__d))\x0a"
"        return complex<_Tp>(__2rsh > _Tp(0) \x3f _Tp(1) \x3a _Tp(-1),\x0a"
"                            __2i > _Tp(0) \x3f _Tp(0) \x3a _Tp(-0.));\x0a"
"    return  complex<_Tp>(__2rsh/__d, sin(__2i)/__d);\x0a"
"}\x0a"
"\x0a"
"// asin\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"asin(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    complex<_Tp> __z = asinh(complex<_Tp>(-__x.imag(), __x.real()));\x0a"
"    return complex<_Tp>(__z.imag(), -__z.real());\x0a"
"}\x0a"
"\x0a"
"// acos\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"acos(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    const _Tp __pi(atan2(+0., -0.));\x0a"
"    if (__libcpp_isinf_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        if (__libcpp_isnan_or_builtin(__x.imag()))\x0a"
"            return complex<_Tp>(__x.imag(), __x.real());\x0a"
"        if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"        {\x0a"
"            if (__x.real() < _Tp(0))\x0a"
"                return complex<_Tp>(_Tp(0.75) * __pi, -__x.imag());\x0a"
"            return complex<_Tp>(_Tp(0.25) * __pi, -__x.imag());\x0a"
"        }\x0a"
"        if (__x.real() < _Tp(0))\x0a"
"            return complex<_Tp>(__pi, signbit(__x.imag()) \x3f -__x.real() \x3a __x.real());\x0a"
"        return complex<_Tp>(_Tp(0), signbit(__x.imag()) \x3f __x.real() \x3a -__x.real());\x0a"
"    }\x0a"
"    if (__libcpp_isnan_or_builtin(__x.real()))\x0a"
"    {\x0a"
"        if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"            return complex<_Tp>(__x.real(), -__x.imag());\x0a"
"        return complex<_Tp>(__x.real(), __x.real());\x0a"
"    }\x0a"
"    if (__libcpp_isinf_or_builtin(__x.imag()))\x0a"
"        return complex<_Tp>(__pi/_Tp(2), -__x.imag());\x0a"
"    if (__x.real() == 0 \x26\x26 (__x.imag() == 0 \x7c\x7c isnan(__x.imag())))\x0a"
"        return complex<_Tp>(__pi/_Tp(2), -__x.imag());\x0a"
"    complex<_Tp> __z = log(__x + sqrt(__sqr(__x) - _Tp(1)));\x0a"
"    if (signbit(__x.imag()))\x0a"
"        return complex<_Tp>(abs(__z.imag()), abs(__z.real()));\x0a"
"    return complex<_Tp>(abs(__z.imag()), -abs(__z.real()));\x0a"
"}\x0a"
"\x0a"
"// atan\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"atan(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    complex<_Tp> __z = atanh(complex<_Tp>(-__x.imag(), __x.real()));\x0a"
"    return complex<_Tp>(__z.imag(), -__z.real());\x0a"
"}\x0a"
"\x0a"
"// sin\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"sin(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    complex<_Tp> __z = sinh(complex<_Tp>(-__x.imag(), __x.real()));\x0a"
"    return complex<_Tp>(__z.imag(), -__z.real());\x0a"
"}\x0a"
"\x0a"
"// cos\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"complex<_Tp>\x0a"
"cos(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    return cosh(complex<_Tp>(-__x.imag(), __x.real()));\x0a"
"}\x0a"
"\x0a"
"// tan\x0a"
"\x0a"
"template<class _Tp>\x0a"
"complex<_Tp>\x0a"
"tan(const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    complex<_Tp> __z = tanh(complex<_Tp>(-__x.imag(), __x.real()));\x0a"
"    return complex<_Tp>(__z.imag(), -__z.real());\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    if (__is.good())\x0a"
"    {\x0a"
"        ws(__is);\x0a"
"        if (__is.peek() == _CharT('('))\x0a"
"        {\x0a"
"            __is.get();\x0a"
"            _Tp __r;\x0a"
"            __is >> __r;\x0a"
"            if (\x21__is.fail())\x0a"
"            {\x0a"
"                ws(__is);\x0a"
"                _CharT __c = __is.peek();\x0a"
"                if (__c == _CharT(','))\x0a"
"                {\x0a"
"                    __is.get();\x0a"
"                    _Tp __i;\x0a"
"                    __is >> __i;\x0a"
"                    if (\x21__is.fail())\x0a"
"                    {\x0a"
"                        ws(__is);\x0a"
"                        __c = __is.peek();\x0a"
"                        if (__c == _CharT(')'))\x0a"
"                        {\x0a"
"                            __is.get();\x0a"
"                            __x = complex<_Tp>(__r, __i);\x0a"
"                        }\x0a"
"                        else\x0a"
"                            __is.setstate(ios_base\x3a\x3a""failbit);\x0a"
"                    }\x0a"
"                    else\x0a"
"                        __is.setstate(ios_base\x3a\x3a""failbit);\x0a"
"                }\x0a"
"                else if (__c == _CharT(')'))\x0a"
"                {\x0a"
"                    __is.get();\x0a"
"                    __x = complex<_Tp>(__r, _Tp(0));\x0a"
"                }\x0a"
"                else\x0a"
"                    __is.setstate(ios_base\x3a\x3a""failbit);\x0a"
"            }\x0a"
"            else\x0a"
"                __is.setstate(ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            _Tp __r;\x0a"
"            __is >> __r;\x0a"
"            if (\x21__is.fail())\x0a"
"                __x = complex<_Tp>(__r, _Tp(0));\x0a"
"            else\x0a"
"                __is.setstate(ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"        __is.setstate(ios_base\x3a\x3a""failbit);\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const complex<_Tp>\x26 __x)\x0a"
"{\x0a"
"    basic_ostringstream<_CharT, _Traits> __s;\x0a"
"    __s.flags(__os.flags());\x0a"
"    __s.imbue(__os.getloc());\x0a"
"    __s.precision(__os.precision());\x0a"
"    __s << '(' << __x.real() << ',' << __x.imag() << ')';\x0a"
"    return __os << __s.str();\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"// Literal suffix for complex number literals \x5b""complex.literals\x5d\x0a"
"inline namespace literals\x0a"
"{\x0a"
"  inline namespace complex_literals\x0a"
"  {\x0a"
"    constexpr complex<long double> operator\x22\x22il(long double __im)\x0a"
"    {\x0a"
"        return { 0.0l, __im };\x0a"
"    }\x0a"
"\x0a"
"    constexpr complex<long double> operator\x22\x22il(unsigned long long __im)\x0a"
"    {\x0a"
"        return { 0.0l, static_cast<long double>(__im) };\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    constexpr complex<double> operator\x22\x22i(long double __im)\x0a"
"    {\x0a"
"        return { 0.0, static_cast<double>(__im) };\x0a"
"    }\x0a"
"\x0a"
"    constexpr complex<double> operator\x22\x22i(unsigned long long __im)\x0a"
"    {\x0a"
"        return { 0.0, static_cast<double>(__im) };\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    constexpr complex<float> operator\x22\x22if(long double __im)\x0a"
"    {\x0a"
"        return { 0.0f, static_cast<float>(__im) };\x0a"
"    }\x0a"
"\x0a"
"    constexpr complex<float> operator\x22\x22if(unsigned long long __im)\x0a"
"    {\x0a"
"        return { 0.0f, static_cast<float>(__im) };\x0a"
"    }\x0a"
"  }\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_COMPLEX\x0a"
"", 46618 ); }