#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_condition_variable( 
"// -*- C++ -*-\x0a"
"//===---------------------- condition_variable ----------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_CONDITION_VARIABLE\x0a"
"#define _LIBCPP_CONDITION_VARIABLE\x0a"
"\x0a"
"/*\x0a"
"    condition_variable synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"enum class cv_status { no_timeout, timeout };\x0a"
"\x0a"
"class condition_variable\x0a"
"{\x0a"
"public\x3a\x0a"
"    condition_variable();\x0a"
"    \x7e""condition_variable();\x0a"
"\x0a"
"    condition_variable(const condition_variable\x26) = delete;\x0a"
"    condition_variable\x26 operator=(const condition_variable\x26) = delete;\x0a"
"\x0a"
"    void notify_one() noexcept;\x0a"
"    void notify_all() noexcept;\x0a"
"\x0a"
"    void wait(unique_lock<mutex>\x26 lock);\x0a"
"    template <class Predicate>\x0a"
"        void wait(unique_lock<mutex>\x26 lock, Predicate pred);\x0a"
"\x0a"
"    template <class Clock, class Duration>\x0a"
"        cv_status\x0a"
"        wait_until(unique_lock<mutex>\x26 lock,\x0a"
"                   const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"\x0a"
"    template <class Clock, class Duration, class Predicate>\x0a"
"        bool\x0a"
"        wait_until(unique_lock<mutex>\x26 lock,\x0a"
"                   const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time,\x0a"
"                   Predicate pred);\x0a"
"\x0a"
"    template <class Rep, class Period>\x0a"
"        cv_status\x0a"
"        wait_for(unique_lock<mutex>\x26 lock,\x0a"
"                 const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"\x0a"
"    template <class Rep, class Period, class Predicate>\x0a"
"        bool\x0a"
"        wait_for(unique_lock<mutex>\x26 lock,\x0a"
"                 const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time,\x0a"
"                 Predicate pred);\x0a"
"\x0a"
"    typedef pthread_cond_t* native_handle_type;\x0a"
"    native_handle_type native_handle();\x0a"
"};\x0a"
"\x0a"
"void notify_all_at_thread_exit(condition_variable\x26 cond, unique_lock<mutex> lk);\x0a"
"\x0a"
"class condition_variable_any\x0a"
"{\x0a"
"public\x3a\x0a"
"    condition_variable_any();\x0a"
"    \x7e""condition_variable_any();\x0a"
"\x0a"
"    condition_variable_any(const condition_variable_any\x26) = delete;\x0a"
"    condition_variable_any\x26 operator=(const condition_variable_any\x26) = delete;\x0a"
"\x0a"
"    void notify_one() noexcept;\x0a"
"    void notify_all() noexcept;\x0a"
"\x0a"
"    template <class Lock>\x0a"
"        void wait(Lock\x26 lock);\x0a"
"    template <class Lock, class Predicate>\x0a"
"        void wait(Lock\x26 lock, Predicate pred);\x0a"
"\x0a"
"    template <class Lock, class Clock, class Duration>\x0a"
"        cv_status\x0a"
"        wait_until(Lock\x26 lock,\x0a"
"                   const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"\x0a"
"    template <class Lock, class Clock, class Duration, class Predicate>\x0a"
"        bool\x0a"
"        wait_until(Lock\x26 lock,\x0a"
"                   const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time,\x0a"
"                   Predicate pred);\x0a"
"\x0a"
"    template <class Lock, class Rep, class Period>\x0a"
"        cv_status\x0a"
"        wait_for(Lock\x26 lock,\x0a"
"                 const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"\x0a"
"    template <class Lock, class Rep, class Period, class Predicate>\x0a"
"        bool\x0a"
"        wait_for(Lock\x26 lock,\x0a"
"                 const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time,\x0a"
"                 Predicate pred);\x0a"
"};\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__mutex_base>\x0a"
"#include <memory>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS condition_variable_any\x0a"
"{\x0a"
"    condition_variable __cv_;\x0a"
"    shared_ptr<mutex>  __mut_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    condition_variable_any();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void notify_one() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void notify_all() _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Lock>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        void wait(_Lock\x26 __lock);\x0a"
"    template <class _Lock, class _Predicate>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void wait(_Lock\x26 __lock, _Predicate __pred);\x0a"
"\x0a"
"    template <class _Lock, class _Clock, class _Duration>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        cv_status\x0a"
"        wait_until(_Lock\x26 __lock,\x0a"
"                   const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t);\x0a"
"\x0a"
"    template <class _Lock, class _Clock, class _Duration, class _Predicate>\x0a"
"        bool\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        wait_until(_Lock\x26 __lock,\x0a"
"                   const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t,\x0a"
"                   _Predicate __pred);\x0a"
"\x0a"
"    template <class _Lock, class _Rep, class _Period>\x0a"
"        cv_status\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        wait_for(_Lock\x26 __lock,\x0a"
"                 const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d);\x0a"
"\x0a"
"    template <class _Lock, class _Rep, class _Period, class _Predicate>\x0a"
"        bool\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        wait_for(_Lock\x26 __lock,\x0a"
"                 const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d,\x0a"
"                 _Predicate __pred);\x0a"
"};\x0a"
"\x0a"
"inline\x0a"
"condition_variable_any\x3a\x3a""condition_variable_any()\x0a"
"    \x3a __mut_(make_shared<mutex>()) {}\x0a"
"\x0a"
"inline\x0a"
"void\x0a"
"condition_variable_any\x3a\x3anotify_one() _NOEXCEPT\x0a"
"{\x0a"
"    {lock_guard<mutex> __lx(*__mut_);}\x0a"
"    __cv_.notify_one();\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"void\x0a"
"condition_variable_any\x3a\x3anotify_all() _NOEXCEPT\x0a"
"{\x0a"
"    {lock_guard<mutex> __lx(*__mut_);}\x0a"
"    __cv_.notify_all();\x0a"
"}\x0a"
"\x0a"
"struct __lock_external\x0a"
"{\x0a"
"    template <class _Lock>\x0a"
"    void operator()(_Lock* __m) {__m->lock();}\x0a"
"};\x0a"
"\x0a"
"template <class _Lock>\x0a"
"void\x0a"
"condition_variable_any\x3a\x3await(_Lock\x26 __lock)\x0a"
"{\x0a"
"    shared_ptr<mutex> __mut = __mut_;\x0a"
"    unique_lock<mutex> __lk(*__mut);\x0a"
"    __lock.unlock();\x0a"
"    unique_ptr<_Lock, __lock_external> __lxx(\x26__lock);\x0a"
"    lock_guard<unique_lock<mutex> > __lx(__lk, adopt_lock);\x0a"
"    __cv_.wait(__lk);\x0a"
"}  // __mut_.unlock(), __lock.lock()\x0a"
"\x0a"
"template <class _Lock, class _Predicate>\x0a"
"inline\x0a"
"void\x0a"
"condition_variable_any\x3a\x3await(_Lock\x26 __lock, _Predicate __pred)\x0a"
"{\x0a"
"    while (\x21__pred())\x0a"
"        wait(__lock);\x0a"
"}\x0a"
"\x0a"
"template <class _Lock, class _Clock, class _Duration>\x0a"
"cv_status\x0a"
"condition_variable_any\x3a\x3await_until(_Lock\x26 __lock,\x0a"
"                                   const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    shared_ptr<mutex> __mut = __mut_;\x0a"
"    unique_lock<mutex> __lk(*__mut);\x0a"
"    __lock.unlock();\x0a"
"    unique_ptr<_Lock, __lock_external> __lxx(\x26__lock);\x0a"
"    lock_guard<unique_lock<mutex> > __lx(__lk, adopt_lock);\x0a"
"    return __cv_.wait_until(__lk, __t);\x0a"
"}  // __mut_.unlock(), __lock.lock()\x0a"
"\x0a"
"template <class _Lock, class _Clock, class _Duration, class _Predicate>\x0a"
"inline\x0a"
"bool\x0a"
"condition_variable_any\x3a\x3await_until(_Lock\x26 __lock,\x0a"
"                                   const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t,\x0a"
"                                   _Predicate __pred)\x0a"
"{\x0a"
"    while (\x21__pred())\x0a"
"        if (wait_until(__lock, __t) == cv_status\x3a\x3atimeout)\x0a"
"            return __pred();\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Lock, class _Rep, class _Period>\x0a"
"inline\x0a"
"cv_status\x0a"
"condition_variable_any\x3a\x3await_for(_Lock\x26 __lock,\x0a"
"                                 const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d)\x0a"
"{\x0a"
"    return wait_until(__lock, chrono\x3a\x3asteady_clock\x3a\x3anow() + __d);\x0a"
"}\x0a"
"\x0a"
"template <class _Lock, class _Rep, class _Period, class _Predicate>\x0a"
"inline\x0a"
"bool\x0a"
"condition_variable_any\x3a\x3await_for(_Lock\x26 __lock,\x0a"
"                                 const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d,\x0a"
"                                 _Predicate __pred)\x0a"
"{\x0a"
"    return wait_until(__lock, chrono\x3a\x3asteady_clock\x3a\x3anow() + __d,\x0a"
"                      _VSTD\x3a\x3amove(__pred));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void notify_all_at_thread_exit(condition_variable\x26 cond, unique_lock<mutex> lk);\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"#endif  // _LIBCPP_CONDITION_VARIABLE\x0a"
"", 7606 ); }