#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_cstddef( 
"// -*- C++ -*-\x0a"
"//===--------------------------- cstddef ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_CSTDDEF\x0a"
"#define _LIBCPP_CSTDDEF\x0a"
"\x0a"
"/*\x0a"
"    cstddef synopsis\x0a"
"\x0a"
"Macros\x3a\x0a"
"\x0a"
"    offsetof(type,member-designator)\x0a"
"    NULL\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"Types\x3a\x0a"
"\x0a"
"    ptrdiff_t\x0a"
"    size_t\x0a"
"    max_align_t\x0a"
"    nullptr_t\x0a"
"    byte // C++17\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"// Don't include our own <stddef.h>; we don't want to declare \x3a\x3anullptr_t.\x0a"
"#include_next <stddef.h>\x0a"
"#include <__nullptr>\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"using \x3a\x3aptrdiff_t;\x0a"
"using \x3a\x3asize_t;\x0a"
"\x0a"
"#if defined(__CLANG_MAX_ALIGN_T_DEFINED) \x7c\x7c defined(_GCC_MAX_ALIGN_T) \x7c\x7c \x5c\x0a"
"    defined(__DEFINED_max_align_t) \x7c\x7c defined(__NetBSD__)\x0a"
"// Re-use the compiler's <stddef.h> max_align_t where possible.\x0a"
"using \x3a\x3amax_align_t;\x0a"
"#else\x0a"
"typedef long double max_align_t;\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"namespace std  // purposefully not versioned\x0a"
"{\x0a"
"enum class byte \x3a unsigned char {};\x0a"
"\x0a"
"constexpr byte  operator\x7c (byte  __lhs, byte __rhs) noexcept\x0a"
"{\x0a"
"    return static_cast<byte>(\x0a"
"      static_cast<unsigned char>(\x0a"
"         static_cast<unsigned int>(__lhs) \x7c static_cast<unsigned int>(__rhs)\x0a"
"    ));\x0a"
"}\x0a"
"\x0a"
"constexpr byte\x26 operator\x7c=(byte\x26 __lhs, byte __rhs) noexcept\x0a"
"{ return __lhs = __lhs \x7c __rhs; }\x0a"
"\x0a"
"constexpr byte  operator\x26 (byte  __lhs, byte __rhs) noexcept\x0a"
"{\x0a"
"    return static_cast<byte>(\x0a"
"      static_cast<unsigned char>(\x0a"
"         static_cast<unsigned int>(__lhs) \x26 static_cast<unsigned int>(__rhs)\x0a"
"    ));\x0a"
"}\x0a"
"\x0a"
"constexpr byte\x26 operator\x26=(byte\x26 __lhs, byte __rhs) noexcept\x0a"
"{ return __lhs = __lhs \x26 __rhs; }\x0a"
"\x0a"
"constexpr byte  operator^ (byte  __lhs, byte __rhs) noexcept\x0a"
"{\x0a"
"    return static_cast<byte>(\x0a"
"      static_cast<unsigned char>(\x0a"
"         static_cast<unsigned int>(__lhs) ^ static_cast<unsigned int>(__rhs)\x0a"
"    ));\x0a"
"}\x0a"
"\x0a"
"constexpr byte\x26 operator^=(byte\x26 __lhs, byte __rhs) noexcept\x0a"
"{ return __lhs = __lhs ^ __rhs; }\x0a"
"\x0a"
"constexpr byte  operator\x7e (byte __b) noexcept\x0a"
"{\x0a"
"    return static_cast<byte>(\x0a"
"      static_cast<unsigned char>(\x0a"
"        \x7estatic_cast<unsigned int>(__b)\x0a"
"    ));\x0a"
"}\x0a"
"\x0a"
"}\x0a"
"\x0a"
"#include <type_traits>  // rest of byte\x0a"
"#endif\x0a"
"\x0a"
"#endif  // _LIBCPP_CSTDDEF\x0a"
"", 2515 ); }