#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_cstdint( 
"// -*- C++ -*-\x0a"
"//===--------------------------- cstdint ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_CSTDINT\x0a"
"#define _LIBCPP_CSTDINT\x0a"
"\x0a"
"/*\x0a"
"    cstdint synopsis\x0a"
"\x0a"
"Macros\x3a\x0a"
"\x0a"
"    INT8_MIN\x0a"
"    INT16_MIN\x0a"
"    INT32_MIN\x0a"
"    INT64_MIN\x0a"
"\x0a"
"    INT8_MAX\x0a"
"    INT16_MAX\x0a"
"    INT32_MAX\x0a"
"    INT64_MAX\x0a"
"\x0a"
"    UINT8_MAX\x0a"
"    UINT16_MAX\x0a"
"    UINT32_MAX\x0a"
"    UINT64_MAX\x0a"
"\x0a"
"    INT_LEAST8_MIN\x0a"
"    INT_LEAST16_MIN\x0a"
"    INT_LEAST32_MIN\x0a"
"    INT_LEAST64_MIN\x0a"
"\x0a"
"    INT_LEAST8_MAX\x0a"
"    INT_LEAST16_MAX\x0a"
"    INT_LEAST32_MAX\x0a"
"    INT_LEAST64_MAX\x0a"
"\x0a"
"    UINT_LEAST8_MAX\x0a"
"    UINT_LEAST16_MAX\x0a"
"    UINT_LEAST32_MAX\x0a"
"    UINT_LEAST64_MAX\x0a"
"\x0a"
"    INT_FAST8_MIN\x0a"
"    INT_FAST16_MIN\x0a"
"    INT_FAST32_MIN\x0a"
"    INT_FAST64_MIN\x0a"
"\x0a"
"    INT_FAST8_MAX\x0a"
"    INT_FAST16_MAX\x0a"
"    INT_FAST32_MAX\x0a"
"    INT_FAST64_MAX\x0a"
"\x0a"
"    UINT_FAST8_MAX\x0a"
"    UINT_FAST16_MAX\x0a"
"    UINT_FAST32_MAX\x0a"
"    UINT_FAST64_MAX\x0a"
"\x0a"
"    INTPTR_MIN\x0a"
"    INTPTR_MAX\x0a"
"    UINTPTR_MAX\x0a"
"\x0a"
"    INTMAX_MIN\x0a"
"    INTMAX_MAX\x0a"
"\x0a"
"    UINTMAX_MAX\x0a"
"\x0a"
"    PTRDIFF_MIN\x0a"
"    PTRDIFF_MAX\x0a"
"\x0a"
"    SIG_ATOMIC_MIN\x0a"
"    SIG_ATOMIC_MAX\x0a"
"\x0a"
"    SIZE_MAX\x0a"
"\x0a"
"    WCHAR_MIN\x0a"
"    WCHAR_MAX\x0a"
"\x0a"
"    WINT_MIN\x0a"
"    WINT_MAX\x0a"
"\x0a"
"    INT8_C(value)\x0a"
"    INT16_C(value)\x0a"
"    INT32_C(value)\x0a"
"    INT64_C(value)\x0a"
"\x0a"
"    UINT8_C(value)\x0a"
"    UINT16_C(value)\x0a"
"    UINT32_C(value)\x0a"
"    UINT64_C(value)\x0a"
"\x0a"
"    INTMAX_C(value)\x0a"
"    UINTMAX_C(value)\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"Types\x3a\x0a"
"\x0a"
"    int8_t\x0a"
"    int16_t\x0a"
"    int32_t\x0a"
"    int64_t\x0a"
"\x0a"
"    uint8_t\x0a"
"    uint16_t\x0a"
"    uint32_t\x0a"
"    uint64_t\x0a"
"\x0a"
"    int_least8_t\x0a"
"    int_least16_t\x0a"
"    int_least32_t\x0a"
"    int_least64_t\x0a"
"\x0a"
"    uint_least8_t\x0a"
"    uint_least16_t\x0a"
"    uint_least32_t\x0a"
"    uint_least64_t\x0a"
"\x0a"
"    int_fast8_t\x0a"
"    int_fast16_t\x0a"
"    int_fast32_t\x0a"
"    int_fast64_t\x0a"
"\x0a"
"    uint_fast8_t\x0a"
"    uint_fast16_t\x0a"
"    uint_fast32_t\x0a"
"    uint_fast64_t\x0a"
"\x0a"
"    intptr_t\x0a"
"    uintptr_t\x0a"
"\x0a"
"    intmax_t\x0a"
"    uintmax_t\x0a"
"\x0a"
"}  // std\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"using\x3a\x3aint8_t;\x0a"
"using\x3a\x3aint16_t;\x0a"
"using\x3a\x3aint32_t;\x0a"
"using\x3a\x3aint64_t;\x0a"
"\x0a"
"using\x3a\x3auint8_t;\x0a"
"using\x3a\x3auint16_t;\x0a"
"using\x3a\x3auint32_t;\x0a"
"using\x3a\x3auint64_t;\x0a"
"\x0a"
"using\x3a\x3aint_least8_t;\x0a"
"using\x3a\x3aint_least16_t;\x0a"
"using\x3a\x3aint_least32_t;\x0a"
"using\x3a\x3aint_least64_t;\x0a"
"\x0a"
"using\x3a\x3auint_least8_t;\x0a"
"using\x3a\x3auint_least16_t;\x0a"
"using\x3a\x3auint_least32_t;\x0a"
"using\x3a\x3auint_least64_t;\x0a"
"\x0a"
"using\x3a\x3aint_fast8_t;\x0a"
"using\x3a\x3aint_fast16_t;\x0a"
"using\x3a\x3aint_fast32_t;\x0a"
"using\x3a\x3aint_fast64_t;\x0a"
"\x0a"
"using\x3a\x3auint_fast8_t;\x0a"
"using\x3a\x3auint_fast16_t;\x0a"
"using\x3a\x3auint_fast32_t;\x0a"
"using\x3a\x3auint_fast64_t;\x0a"
"\x0a"
"using\x3a\x3aintptr_t;\x0a"
"using\x3a\x3auintptr_t;\x0a"
"\x0a"
"using\x3a\x3aintmax_t;\x0a"
"using\x3a\x3auintmax_t;\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_CSTDINT\x0a"
"", 2798 ); }