#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_cstdio( 
"// -*- C++ -*-\x0a"
"//===---------------------------- cstdio ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_CSTDIO\x0a"
"#define _LIBCPP_CSTDIO\x0a"
"\x0a"
"/*\x0a"
"    cstdio synopsis\x0a"
"\x0a"
"Macros\x3a\x0a"
"\x0a"
"    BUFSIZ\x0a"
"    EOF\x0a"
"    FILENAME_MAX\x0a"
"    FOPEN_MAX\x0a"
"    L_tmpnam\x0a"
"    NULL\x0a"
"    SEEK_CUR\x0a"
"    SEEK_END\x0a"
"    SEEK_SET\x0a"
"    TMP_MAX\x0a"
"    _IOFBF\x0a"
"    _IOLBF\x0a"
"    _IONBF\x0a"
"    stderr\x0a"
"    stdin\x0a"
"    stdout\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"Types\x3a\x0a"
"\x0a"
"FILE\x0a"
"fpos_t\x0a"
"size_t\x0a"
"\x0a"
"int remove(const char* filename);\x0a"
"int rename(const char* old, const char* new);\x0a"
"FILE* tmpfile(void);\x0a"
"char* tmpnam(char* s);\x0a"
"int fclose(FILE* stream);\x0a"
"int fflush(FILE* stream);\x0a"
"FILE* fopen(const char* restrict filename, const char* restrict mode);\x0a"
"FILE* freopen(const char* restrict filename, const char * restrict mode,\x0a"
"              FILE * restrict stream);\x0a"
"void setbuf(FILE* restrict stream, char* restrict buf);\x0a"
"int setvbuf(FILE* restrict stream, char* restrict buf, int mode, size_t size);\x0a"
"int fprintf(FILE* restrict stream, const char* restrict format, ...);\x0a"
"int fscanf(FILE* restrict stream, const char * restrict format, ...);\x0a"
"int printf(const char* restrict format, ...);\x0a"
"int scanf(const char* restrict format, ...);\x0a"
"int snprintf(char* restrict s, size_t n, const char* restrict format, ...);    // C99\x0a"
"int sprintf(char* restrict s, const char* restrict format, ...);\x0a"
"int sscanf(const char* restrict s, const char* restrict format, ...);\x0a"
"int vfprintf(FILE* restrict stream, const char* restrict format, va_list arg);\x0a"
"int vfscanf(FILE* restrict stream, const char* restrict format, va_list arg);  // C99\x0a"
"int vprintf(const char* restrict format, va_list arg);\x0a"
"int vscanf(const char* restrict format, va_list arg);                          // C99\x0a"
"int vsnprintf(char* restrict s, size_t n, const char* restrict format,         // C99\x0a"
"              va_list arg);\x0a"
"int vsprintf(char* restrict s, const char* restrict format, va_list arg);\x0a"
"int vsscanf(const char* restrict s, const char* restrict format, va_list arg); // C99\x0a"
"int fgetc(FILE* stream);\x0a"
"char* fgets(char* restrict s, int n, FILE* restrict stream);\x0a"
"int fputc(int c, FILE* stream);\x0a"
"int fputs(const char* restrict s, FILE* restrict stream);\x0a"
"int getc(FILE* stream);\x0a"
"int getchar(void);\x0a"
"char* gets(char* s);  // removed in C++14\x0a"
"int putc(int c, FILE* stream);\x0a"
"int putchar(int c);\x0a"
"int puts(const char* s);\x0a"
"int ungetc(int c, FILE* stream);\x0a"
"size_t fread(void* restrict ptr, size_t size, size_t nmemb,\x0a"
"             FILE* restrict stream);\x0a"
"size_t fwrite(const void* restrict ptr, size_t size, size_t nmemb,\x0a"
"              FILE* restrict stream);\x0a"
"int fgetpos(FILE* restrict stream, fpos_t* restrict pos);\x0a"
"int fseek(FILE* stream, long offset, int whence);\x0a"
"int fsetpos(FILE*stream, const fpos_t* pos);\x0a"
"long ftell(FILE* stream);\x0a"
"void rewind(FILE* stream);\x0a"
"void clearerr(FILE* stream);\x0a"
"int feof(FILE* stream);\x0a"
"int ferror(FILE* stream);\x0a"
"void perror(const char* s);\x0a"
"\x0a"
"}  // std\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <stdio.h>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"using \x3a\x3a""FILE;\x0a"
"using \x3a\x3a""fpos_t;\x0a"
"using \x3a\x3asize_t;\x0a"
"\x0a"
"using \x3a\x3a""fclose;\x0a"
"using \x3a\x3a""fflush;\x0a"
"using \x3a\x3asetbuf;\x0a"
"using \x3a\x3asetvbuf;\x0a"
"using \x3a\x3a""fprintf;\x0a"
"using \x3a\x3a""fscanf;\x0a"
"using \x3a\x3asnprintf;\x0a"
"using \x3a\x3asprintf;\x0a"
"using \x3a\x3asscanf;\x0a"
"using \x3a\x3avfprintf;\x0a"
"using \x3a\x3avfscanf;\x0a"
"using \x3a\x3avsscanf;\x0a"
"using \x3a\x3avsnprintf;\x0a"
"using \x3a\x3avsprintf;\x0a"
"using \x3a\x3a""fgetc;\x0a"
"using \x3a\x3a""fgets;\x0a"
"using \x3a\x3a""fputc;\x0a"
"using \x3a\x3a""fputs;\x0a"
"using \x3a\x3agetc;\x0a"
"using \x3a\x3aputc;\x0a"
"using \x3a\x3aungetc;\x0a"
"using \x3a\x3a""fread;\x0a"
"using \x3a\x3a""fwrite;\x0a"
"using \x3a\x3a""fgetpos;\x0a"
"using \x3a\x3a""fseek;\x0a"
"using \x3a\x3a""fsetpos;\x0a"
"using \x3a\x3a""ftell;\x0a"
"using \x3a\x3arewind;\x0a"
"using \x3a\x3a""clearerr;\x0a"
"using \x3a\x3a""feof;\x0a"
"using \x3a\x3a""ferror;\x0a"
"using \x3a\x3aperror;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"using \x3a\x3a""fopen;\x0a"
"using \x3a\x3a""freopen;\x0a"
"using \x3a\x3aremove;\x0a"
"using \x3a\x3arename;\x0a"
"using \x3a\x3atmpfile;\x0a"
"using \x3a\x3atmpnam;\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_STDIN\x0a"
"using \x3a\x3agetchar;\x0a"
"#if _LIBCPP_STD_VER <= 11 \x26\x26 \x21""defined(_LIBCPP_MSVCRT) \x26\x26 \x21""defined(__OpenBSD__)\x0a"
"using \x3a\x3agets;\x0a"
"#endif\x0a"
"using \x3a\x3ascanf;\x0a"
"using \x3a\x3avscanf;\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_STDOUT\x0a"
"using \x3a\x3aprintf;\x0a"
"using \x3a\x3aputchar;\x0a"
"using \x3a\x3aputs;\x0a"
"using \x3a\x3avprintf;\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_CSTDIO\x0a"
"", 4339 ); }