#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_errno_h( 
"// -*- C++ -*-\x0a"
"//===-------------------------- errno.h -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_ERRNO_H\x0a"
"#define _LIBCPP_ERRNO_H\x0a"
"\x0a"
"/*\x0a"
"    errno.h synopsis\x0a"
"\x0a"
"Macros\x3a\x0a"
"\x0a"
"    EDOM\x0a"
"    EILSEQ  // C99\x0a"
"    ERANGE\x0a"
"    errno\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#include_next <errno.h>\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"\x0a"
"#if \x21""defined(EOWNERDEAD) \x7c\x7c \x21""defined(ENOTRECOVERABLE)\x0a"
"\x0a"
"#ifdef ELAST\x0a"
"\x0a"
"static const int __elast1 = ELAST+1;\x0a"
"static const int __elast2 = ELAST+2;\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"static const int __elast1 = 104;\x0a"
"static const int __elast2 = 105;\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#ifdef ENOTRECOVERABLE\x0a"
"\x0a"
"#define EOWNERDEAD __elast1\x0a"
"\x0a"
"#ifdef ELAST\x0a"
"#undef ELAST\x0a"
"#define ELAST EOWNERDEAD\x0a"
"#endif\x0a"
"\x0a"
"#elif defined(EOWNERDEAD)\x0a"
"\x0a"
"#define ENOTRECOVERABLE __elast1\x0a"
"#ifdef ELAST\x0a"
"#undef ELAST\x0a"
"#define ELAST ENOTRECOVERABLE\x0a"
"#endif\x0a"
"\x0a"
"#else  // defined(EOWNERDEAD)\x0a"
"\x0a"
"#define EOWNERDEAD __elast1\x0a"
"#define ENOTRECOVERABLE __elast2\x0a"
"#ifdef ELAST\x0a"
"#undef ELAST\x0a"
"#define ELAST ENOTRECOVERABLE\x0a"
"#endif\x0a"
"\x0a"
"#endif  // defined(EOWNERDEAD)\x0a"
"\x0a"
"#endif  // \x21""defined(EOWNERDEAD) \x7c\x7c \x21""defined(ENOTRECOVERABLE)\x0a"
"\x0a"
"//  supply errno values likely to be missing, particularly on Windows\x0a"
"\x0a"
"#ifndef EAFNOSUPPORT\x0a"
"#define EAFNOSUPPORT 9901\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EADDRINUSE\x0a"
"#define EADDRINUSE 9902\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EADDRNOTAVAIL\x0a"
"#define EADDRNOTAVAIL 9903\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EISCONN\x0a"
"#define EISCONN 9904\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EBADMSG\x0a"
"#define EBADMSG 9905\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ECONNABORTED\x0a"
"#define ECONNABORTED 9906\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EALREADY\x0a"
"#define EALREADY 9907\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ECONNREFUSED\x0a"
"#define ECONNREFUSED 9908\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ECONNRESET\x0a"
"#define ECONNRESET 9909\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EDESTADDRREQ\x0a"
"#define EDESTADDRREQ 9910\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EHOSTUNREACH\x0a"
"#define EHOSTUNREACH 9911\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EIDRM\x0a"
"#define EIDRM 9912\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EMSGSIZE\x0a"
"#define EMSGSIZE 9913\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENETDOWN\x0a"
"#define ENETDOWN 9914\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENETRESET\x0a"
"#define ENETRESET 9915\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENETUNREACH\x0a"
"#define ENETUNREACH 9916\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOBUFS\x0a"
"#define ENOBUFS 9917\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOLINK\x0a"
"#define ENOLINK 9918\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENODATA\x0a"
"#define ENODATA 9919\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOMSG\x0a"
"#define ENOMSG 9920\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOPROTOOPT\x0a"
"#define ENOPROTOOPT 9921\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOSR\x0a"
"#define ENOSR 9922\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOTSOCK\x0a"
"#define ENOTSOCK 9923\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOSTR\x0a"
"#define ENOSTR 9924\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOTCONN\x0a"
"#define ENOTCONN 9925\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOTSUP\x0a"
"#define ENOTSUP 9926\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ECANCELED\x0a"
"#define ECANCELED 9927\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EINPROGRESS\x0a"
"#define EINPROGRESS 9928\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EOPNOTSUPP\x0a"
"#define EOPNOTSUPP 9929\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EWOULDBLOCK\x0a"
"#define EWOULDBLOCK 9930\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EOWNERDEAD\x0a"
"#define EOWNERDEAD  9931\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EPROTO\x0a"
"#define EPROTO 9932\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EPROTONOSUPPORT\x0a"
"#define EPROTONOSUPPORT 9933\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOTRECOVERABLE\x0a"
"#define ENOTRECOVERABLE 9934\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ETIME\x0a"
"#define ETIME 9935\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ETXTBSY\x0a"
"#define ETXTBSY 9936\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ETIMEDOUT\x0a"
"#define ETIMEDOUT 9938\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ELOOP\x0a"
"#define ELOOP 9939\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EOVERFLOW\x0a"
"#define EOVERFLOW 9940\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EPROTOTYPE\x0a"
"#define EPROTOTYPE 9941\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOSYS\x0a"
"#define ENOSYS 9942\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EINVAL\x0a"
"#define EINVAL 9943\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ERANGE\x0a"
"#define ERANGE 9944\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EILSEQ\x0a"
"#define EILSEQ 9945\x0a"
"#endif\x0a"
"\x0a"
"//  Windows Mobile doesn't appear to define these\x3a\x0a"
"\x0a"
"#ifndef E2BIG\x0a"
"#define E2BIG 9946\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EDOM\x0a"
"#define EDOM 9947\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EFAULT\x0a"
"#define EFAULT 9948\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EBADF\x0a"
"#define EBADF 9949\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EPIPE\x0a"
"#define EPIPE 9950\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EXDEV\x0a"
"#define EXDEV 9951\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EBUSY\x0a"
"#define EBUSY 9952\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOTEMPTY\x0a"
"#define ENOTEMPTY 9953\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOEXEC\x0a"
"#define ENOEXEC 9954\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EEXIST\x0a"
"#define EEXIST 9955\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EFBIG\x0a"
"#define EFBIG 9956\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENAMETOOLONG\x0a"
"#define ENAMETOOLONG 9957\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOTTY\x0a"
"#define ENOTTY 9958\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EINTR\x0a"
"#define EINTR 9959\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ESPIPE\x0a"
"#define ESPIPE 9960\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EIO\x0a"
"#define EIO 9961\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EISDIR\x0a"
"#define EISDIR 9962\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ECHILD\x0a"
"#define ECHILD 9963\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOLCK\x0a"
"#define ENOLCK 9964\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOSPC\x0a"
"#define ENOSPC 9965\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENXIO\x0a"
"#define ENXIO 9966\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENODEV\x0a"
"#define ENODEV 9967\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOENT\x0a"
"#define ENOENT 9968\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ESRCH\x0a"
"#define ESRCH 9969\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOTDIR\x0a"
"#define ENOTDIR 9970\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENOMEM\x0a"
"#define ENOMEM 9971\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EPERM\x0a"
"#define EPERM 9972\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EACCES\x0a"
"#define EACCES 9973\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EROFS\x0a"
"#define EROFS 9974\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EDEADLK\x0a"
"#define EDEADLK 9975\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EAGAIN\x0a"
"#define EAGAIN 9976\x0a"
"#endif\x0a"
"\x0a"
"#ifndef ENFILE\x0a"
"#define ENFILE 9977\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EMFILE\x0a"
"#define EMFILE 9978\x0a"
"#endif\x0a"
"\x0a"
"#ifndef EMLINK\x0a"
"#define EMLINK 9979\x0a"
"#endif\x0a"
"\x0a"
"#endif // __cplusplus\x0a"
"\x0a"
"#endif  // _LIBCPP_ERRNO_H\x0a"
"", 5144 ); }