#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_exception( 
"// -*- C++ -*-\x0a"
"//===-------------------------- exception ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_EXCEPTION\x0a"
"#define _LIBCPP_EXCEPTION\x0a"
"\x0a"
"/*\x0a"
"    exception synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"class exception\x0a"
"{\x0a"
"public\x3a\x0a"
"    exception() noexcept;\x0a"
"    exception(const exception\x26) noexcept;\x0a"
"    exception\x26 operator=(const exception\x26) noexcept;\x0a"
"    virtual \x7e""exception() noexcept;\x0a"
"    virtual const char* what() const noexcept;\x0a"
"};\x0a"
"\x0a"
"class bad_exception\x0a"
"    \x3a public exception\x0a"
"{\x0a"
"public\x3a\x0a"
"    bad_exception() noexcept;\x0a"
"    bad_exception(const bad_exception\x26) noexcept;\x0a"
"    bad_exception\x26 operator=(const bad_exception\x26) noexcept;\x0a"
"    virtual \x7e""bad_exception() noexcept;\x0a"
"    virtual const char* what() const noexcept;\x0a"
"};\x0a"
"\x0a"
"typedef void (*unexpected_handler)();\x0a"
"unexpected_handler set_unexpected(unexpected_handler  f ) noexcept;\x0a"
"unexpected_handler get_unexpected() noexcept;\x0a"
"\x5b\x5bnoreturn\x5d\x5d void unexpected();\x0a"
"\x0a"
"typedef void (*terminate_handler)();\x0a"
"terminate_handler set_terminate(terminate_handler  f ) noexcept;\x0a"
"terminate_handler get_terminate() noexcept;\x0a"
"\x5b\x5bnoreturn\x5d\x5d void terminate() noexcept;\x0a"
"\x0a"
"bool uncaught_exception()  noexcept;\x0a"
"int  uncaught_exceptions() noexcept;  // C++17\x0a"
"\x0a"
"typedef unspecified exception_ptr;\x0a"
"\x0a"
"exception_ptr current_exception() noexcept;\x0a"
"void rethrow_exception \x5b\x5bnoreturn\x5d\x5d (exception_ptr p);\x0a"
"template<class E> exception_ptr make_exception_ptr(E e) noexcept;\x0a"
"\x0a"
"class nested_exception\x0a"
"{\x0a"
"public\x3a\x0a"
"    nested_exception() noexcept;\x0a"
"    nested_exception(const nested_exception\x26) noexcept = default;\x0a"
"    nested_exception\x26 operator=(const nested_exception\x26) noexcept = default;\x0a"
"    virtual \x7enested_exception() = default;\x0a"
"\x0a"
"    // access functions\x0a"
"    \x5b\x5bnoreturn\x5d\x5d void rethrow_nested() const;\x0a"
"    exception_ptr nested_ptr() const noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class T> \x5b\x5bnoreturn\x5d\x5d void throw_with_nested(T\x26\x26 t);\x0a"
"template <class E> void rethrow_if_nested(const E\x26 e);\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <cstddef>\x0a"
"#include <cstdlib>\x0a"
"#include <type_traits>\x0a"
"#include <version>\x0a"
"\x0a"
"#if defined(_LIBCPP_ABI_VCRUNTIME)\x0a"
"#include <vcruntime_exception.h>\x0a"
"#endif\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"namespace std  // purposefully not using versioning namespace\x0a"
"{\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_ABI_VCRUNTIME)\x0a"
"class _LIBCPP_EXCEPTION_ABI exception\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY exception() _NOEXCEPT {}\x0a"
"    virtual \x7e""exception() _NOEXCEPT;\x0a"
"    virtual const char* what() const _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI bad_exception\x0a"
"    \x3a public exception\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY bad_exception() _NOEXCEPT {}\x0a"
"    virtual \x7e""bad_exception() _NOEXCEPT;\x0a"
"    virtual const char* what() const _NOEXCEPT;\x0a"
"};\x0a"
"#endif // \x21_LIBCPP_ABI_VCRUNTIME\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14 \x5c\x0a"
"    \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_UNEXPECTED_FUNCTIONS) \x5c\x0a"
"    \x7c\x7c defined(_LIBCPP_BUILDING_LIBRARY)\x0a"
"typedef void (*unexpected_handler)();\x0a"
"_LIBCPP_FUNC_VIS unexpected_handler set_unexpected(unexpected_handler) _NOEXCEPT;\x0a"
"_LIBCPP_FUNC_VIS unexpected_handler get_unexpected() _NOEXCEPT;\x0a"
"_LIBCPP_NORETURN _LIBCPP_FUNC_VIS void unexpected();\x0a"
"#endif\x0a"
"\x0a"
"typedef void (*terminate_handler)();\x0a"
"_LIBCPP_FUNC_VIS terminate_handler set_terminate(terminate_handler) _NOEXCEPT;\x0a"
"_LIBCPP_FUNC_VIS terminate_handler get_terminate() _NOEXCEPT;\x0a"
"_LIBCPP_NORETURN _LIBCPP_FUNC_VIS void terminate() _NOEXCEPT;\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS bool uncaught_exception() _NOEXCEPT;\x0a"
"_LIBCPP_FUNC_VIS _LIBCPP_AVAILABILITY_UNCAUGHT_EXCEPTIONS int uncaught_exceptions() _NOEXCEPT;\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS exception_ptr;\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS exception_ptr current_exception() _NOEXCEPT;\x0a"
"_LIBCPP_NORETURN _LIBCPP_FUNC_VIS void rethrow_exception(exception_ptr);\x0a"
"\x0a"
"#ifndef _LIBCPP_ABI_MICROSOFT\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS exception_ptr\x0a"
"{\x0a"
"    void* __ptr_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY exception_ptr() _NOEXCEPT \x3a __ptr_() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY exception_ptr(nullptr_t) _NOEXCEPT \x3a __ptr_() {}\x0a"
"\x0a"
"    exception_ptr(const exception_ptr\x26) _NOEXCEPT;\x0a"
"    exception_ptr\x26 operator=(const exception_ptr\x26) _NOEXCEPT;\x0a"
"    \x7e""exception_ptr() _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_EXPLICIT operator bool() const _NOEXCEPT\x0a"
"    {return __ptr_ \x21= nullptr;}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const exception_ptr\x26 __x, const exception_ptr\x26 __y) _NOEXCEPT\x0a"
"        {return __x.__ptr_ == __y.__ptr_;}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const exception_ptr\x26 __x, const exception_ptr\x26 __y) _NOEXCEPT\x0a"
"        {return \x21(__x == __y);}\x0a"
"\x0a"
"    friend _LIBCPP_FUNC_VIS exception_ptr current_exception() _NOEXCEPT;\x0a"
"    friend _LIBCPP_FUNC_VIS void rethrow_exception(exception_ptr);\x0a"
"};\x0a"
"\x0a"
"template<class _Ep>\x0a"
"_LIBCPP_INLINE_VISIBILITY exception_ptr\x0a"
"make_exception_ptr(_Ep __e) _NOEXCEPT\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"        throw __e;\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        return current_exception();\x0a"
"    }\x0a"
"#else\x0a"
"    ((void)__e);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#else // _LIBCPP_ABI_MICROSOFT\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS exception_ptr\x0a"
"{\x0a"
"#if defined(__clang__)\x0a"
"#pragma clang diagnostic push\x0a"
"#pragma clang diagnostic ignored \x22-Wunused-private-field\x22\x0a"
"#endif\x0a"
"    void* __ptr1_;\x0a"
"    void* __ptr2_;\x0a"
"#if defined(__clang__)\x0a"
"#pragma clang diagnostic pop\x0a"
"#endif\x0a"
"public\x3a\x0a"
"    exception_ptr() _NOEXCEPT;\x0a"
"    exception_ptr(nullptr_t) _NOEXCEPT;\x0a"
"    exception_ptr(const exception_ptr\x26 __other) _NOEXCEPT;\x0a"
"    exception_ptr\x26 operator=(const exception_ptr\x26 __other) _NOEXCEPT;\x0a"
"    exception_ptr\x26 operator=(nullptr_t) _NOEXCEPT;\x0a"
"    \x7e""exception_ptr() _NOEXCEPT;\x0a"
"    _LIBCPP_EXPLICIT operator bool() const _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"bool operator==(const exception_ptr\x26 __x, const exception_ptr\x26 __y) _NOEXCEPT;\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(const exception_ptr\x26 __x, const exception_ptr\x26 __y) _NOEXCEPT\x0a"
"    {return \x21(__x == __y);}\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS void swap(exception_ptr\x26, exception_ptr\x26) _NOEXCEPT;\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS exception_ptr __copy_exception_ptr(void *__except, const void* __ptr);\x0a"
"_LIBCPP_FUNC_VIS exception_ptr current_exception() _NOEXCEPT;\x0a"
"_LIBCPP_NORETURN _LIBCPP_FUNC_VIS void rethrow_exception(exception_ptr p);\x0a"
"\x0a"
"// This is a built-in template function which automagically extracts the required\x0a"
"// information.\x0a"
"template <class _E> void *__GetExceptionInfo(_E);\x0a"
"\x0a"
"template<class _Ep>\x0a"
"_LIBCPP_INLINE_VISIBILITY exception_ptr\x0a"
"make_exception_ptr(_Ep __e) _NOEXCEPT\x0a"
"{\x0a"
"  return __copy_exception_ptr(_VSTD\x3a\x3a""addressof(__e), __GetExceptionInfo(__e));\x0a"
"}\x0a"
"\x0a"
"#endif // _LIBCPP_ABI_MICROSOFT\x0a"
"// nested_exception\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI nested_exception\x0a"
"{\x0a"
"    exception_ptr __ptr_;\x0a"
"public\x3a\x0a"
"    nested_exception() _NOEXCEPT;\x0a"
"//     nested_exception(const nested_exception\x26) noexcept = default;\x0a"
"//     nested_exception\x26 operator=(const nested_exception\x26) noexcept = default;\x0a"
"    virtual \x7enested_exception() _NOEXCEPT;\x0a"
"\x0a"
"    // access functions\x0a"
"    _LIBCPP_NORETURN void rethrow_nested() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY exception_ptr nested_ptr() const _NOEXCEPT {return __ptr_;}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __nested\x0a"
"    \x3a public _Tp,\x0a"
"      public nested_exception\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit __nested(const _Tp\x26 __t) \x3a _Tp(__t) {}\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"template <class _Tp, class _Up, bool>\x0a"
"struct __throw_with_nested;\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __throw_with_nested<_Tp, _Up, true> {\x0a"
"    _LIBCPP_NORETURN static inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"    __do_throw(_Tp\x26\x26 __t)\x0a"
"    {\x0a"
"        throw __nested<_Up>(_VSTD\x3a\x3a""forward<_Tp>(__t));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __throw_with_nested<_Tp, _Up, false> {\x0a"
"    _LIBCPP_NORETURN static inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    __do_throw(_Tp\x26\x26 __t)\x0a"
"#else\x0a"
"    __do_throw (_Tp\x26 __t)\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    {\x0a"
"        throw _VSTD\x3a\x3a""forward<_Tp>(__t);\x0a"
"    }\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_NORETURN\x0a"
"void\x0a"
"throw_with_nested(_Tp\x26\x26 __t)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    typedef typename decay<_Tp>\x3a\x3atype _Up;\x0a"
"    static_assert( is_copy_constructible<_Up>\x3a\x3avalue, \x22type thrown must be CopyConstructible\x22);\x0a"
"    __throw_with_nested<_Tp, _Up,\x0a"
"        is_class<_Up>\x3a\x3avalue \x26\x26\x0a"
"        \x21is_base_of<nested_exception, _Up>\x3a\x3avalue \x26\x26\x0a"
"        \x21__libcpp_is_final<_Up>\x3a\x3avalue>\x3a\x3a\x0a"
"            __do_throw(_VSTD\x3a\x3a""forward<_Tp>(__t));\x0a"
"#else\x0a"
"    ((void)__t);\x0a"
"    // FIXME\x3a Make this abort\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _From, class _To>\x0a"
"struct __can_dynamic_cast \x3a public _LIBCPP_BOOL_CONSTANT(\x0a"
"              is_polymorphic<_From>\x3a\x3avalue \x26\x26\x0a"
"                 (\x21is_base_of<_To, _From>\x3a\x3avalue \x7c\x7c\x0a"
"                   is_convertible<const _From*, const _To*>\x3a\x3avalue)) {};\x0a"
"\x0a"
"template <class _Ep>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"rethrow_if_nested(const _Ep\x26 __e,\x0a"
"                  typename enable_if< __can_dynamic_cast<_Ep, nested_exception>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"{\x0a"
"    const nested_exception* __nep = dynamic_cast<const nested_exception*>(_VSTD\x3a\x3a""addressof(__e));\x0a"
"    if (__nep)\x0a"
"        __nep->rethrow_nested();\x0a"
"}\x0a"
"\x0a"
"template <class _Ep>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"rethrow_if_nested(const _Ep\x26,\x0a"
"                  typename enable_if<\x21__can_dynamic_cast<_Ep, nested_exception>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"#endif  // _LIBCPP_EXCEPTION\x0a"
"", 9391 ); }