#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_experimental_coroutine( 
"// -*- C++ -*-\x0a"
"//===----------------------------- coroutine -----------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_EXPERIMENTAL_COROUTINE\x0a"
"#define _LIBCPP_EXPERIMENTAL_COROUTINE\x0a"
"\x0a"
"/**\x0a"
"    experimental/coroutine synopsis\x0a"
"\x0a"
"// C++next\x0a"
"\x0a"
"namespace std {\x0a"
"namespace experimental {\x0a"
"inline namespace coroutines_v1 {\x0a"
"\x0a"
"  // 18.11.1 coroutine traits\x0a"
"template <typename R, typename... ArgTypes>\x0a"
"class coroutine_traits;\x0a"
"// 18.11.2 coroutine handle\x0a"
"template <typename Promise = void>\x0a"
"class coroutine_handle;\x0a"
"// 18.11.2.7 comparison operators\x3a\x0a"
"bool operator==(coroutine_handle<> x, coroutine_handle<> y) _NOEXCEPT;\x0a"
"bool operator\x21=(coroutine_handle<> x, coroutine_handle<> y) _NOEXCEPT;\x0a"
"bool operator<(coroutine_handle<> x, coroutine_handle<> y) _NOEXCEPT;\x0a"
"bool operator<=(coroutine_handle<> x, coroutine_handle<> y) _NOEXCEPT;\x0a"
"bool operator>=(coroutine_handle<> x, coroutine_handle<> y) _NOEXCEPT;\x0a"
"bool operator>(coroutine_handle<> x, coroutine_handle<> y) _NOEXCEPT;\x0a"
"// 18.11.3 trivial awaitables\x0a"
"struct suspend_never;\x0a"
"struct suspend_always;\x0a"
"// 18.11.2.8 hash support\x3a\x0a"
"template <class T> struct hash;\x0a"
"template <class P> struct hash<coroutine_handle<P>>;\x0a"
"\x0a"
"} // namespace coroutines_v1\x0a"
"} // namespace experimental\x0a"
"} // namespace std\x0a"
"\x0a"
" */\x0a"
"\x0a"
"#include <experimental/__config>\x0a"
"#include <new>\x0a"
"#include <type_traits>\x0a"
"#include <functional>\x0a"
"#include <memory> // for hash<T*>\x0a"
"#include <cstddef>\x0a"
"#include <cassert>\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_NO_COROUTINES\x0a"
"# if defined(_LIBCPP_WARNING)\x0a"
"    _LIBCPP_WARNING(\x22<experimental/coroutine> cannot be used with this compiler\x22)\x0a"
"# else\x0a"
"#   warning <experimental/coroutine> cannot be used with this compiler\x0a"
"# endif\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_COROUTINES\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_EXPERIMENTAL_COROUTINES\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __coroutine_traits_sfinae {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __coroutine_traits_sfinae<\x0a"
"    _Tp, typename __void_t<typename _Tp\x3a\x3apromise_type>\x3a\x3atype>\x0a"
"{\x0a"
"  using promise_type = typename _Tp\x3a\x3apromise_type;\x0a"
"};\x0a"
"\x0a"
"template <typename _Ret, typename... _Args>\x0a"
"struct coroutine_traits\x0a"
"    \x3a public __coroutine_traits_sfinae<_Ret>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <typename _Promise = void>\x0a"
"class _LIBCPP_TEMPLATE_VIS coroutine_handle;\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TEMPLATE_VIS coroutine_handle<void> {\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR coroutine_handle() _NOEXCEPT \x3a __handle_(nullptr) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR coroutine_handle(nullptr_t) _NOEXCEPT \x3a __handle_(nullptr) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    coroutine_handle\x26 operator=(nullptr_t) _NOEXCEPT {\x0a"
"        __handle_ = nullptr;\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR void* address() const _NOEXCEPT { return __handle_; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR explicit operator bool() const _NOEXCEPT { return __handle_; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator()() { resume(); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void resume() {\x0a"
"      _LIBCPP_ASSERT(__is_suspended(),\x0a"
"                     \x22resume() can only be called on suspended coroutines\x22);\x0a"
"      _LIBCPP_ASSERT(\x21""done(),\x0a"
"                \x22resume() has undefined behavior when the coroutine is done\x22);\x0a"
"      __builtin_coro_resume(__handle_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void destroy() {\x0a"
"      _LIBCPP_ASSERT(__is_suspended(),\x0a"
"                     \x22""destroy() can only be called on suspended coroutines\x22);\x0a"
"      __builtin_coro_destroy(__handle_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool done() const {\x0a"
"      _LIBCPP_ASSERT(__is_suspended(),\x0a"
"                     \x22""done() can only be called on suspended coroutines\x22);\x0a"
"      return __builtin_coro_done(__handle_);\x0a"
"    }\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static coroutine_handle from_address(void* __addr) _NOEXCEPT {\x0a"
"        coroutine_handle __tmp;\x0a"
"        __tmp.__handle_ = __addr;\x0a"
"        return __tmp;\x0a"
"    }\x0a"
"\x0a"
"    // FIXME\x3a Should from_address(nullptr) be allowed\x3f\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static coroutine_handle from_address(nullptr_t) _NOEXCEPT {\x0a"
"      return coroutine_handle(nullptr);\x0a"
"    }\x0a"
"\x0a"
"    template <class _Tp, bool _CallIsValid = false>\x0a"
"    static coroutine_handle from_address(_Tp*) {\x0a"
"      static_assert(_CallIsValid,\x0a"
"       \x22""coroutine_handle<void>\x3a\x3a""from_address cannot be called with \x22\x0a"
"        \x22non-void pointers\x22);\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"  bool __is_suspended() const _NOEXCEPT  {\x0a"
"    // FIXME actually implement a check for if the coro is suspended.\x0a"
"    return __handle_;\x0a"
"  }\x0a"
"\x0a"
"  template <class _PromiseT> friend class coroutine_handle;\x0a"
"  void* __handle_;\x0a"
"};\x0a"
"\x0a"
"// 18.11.2.7 comparison operators\x3a\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator==(coroutine_handle<> __x, coroutine_handle<> __y) _NOEXCEPT {\x0a"
"    return __x.address() == __y.address();\x0a"
"}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(coroutine_handle<> __x, coroutine_handle<> __y) _NOEXCEPT {\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator<(coroutine_handle<> __x, coroutine_handle<> __y) _NOEXCEPT {\x0a"
"    return less<void*>()(__x.address(), __y.address());\x0a"
"}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator>(coroutine_handle<> __x, coroutine_handle<> __y) _NOEXCEPT {\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator<=(coroutine_handle<> __x, coroutine_handle<> __y) _NOEXCEPT {\x0a"
"    return \x21(__x > __y);\x0a"
"}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator>=(coroutine_handle<> __x, coroutine_handle<> __y) _NOEXCEPT {\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <typename _Promise>\x0a"
"class _LIBCPP_TEMPLATE_VIS coroutine_handle \x3a public coroutine_handle<> {\x0a"
"    using _Base = coroutine_handle<>;\x0a"
"public\x3a\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    // 18.11.2.1 construct/reset\x0a"
"    using coroutine_handle<>\x3a\x3a""coroutine_handle;\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY coroutine_handle() _NOEXCEPT \x3a _Base() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY coroutine_handle(nullptr_t) _NOEXCEPT \x3a _Base(nullptr) {}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    coroutine_handle\x26 operator=(nullptr_t) _NOEXCEPT {\x0a"
"        _Base\x3a\x3aoperator=(nullptr);\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Promise\x26 promise() const {\x0a"
"        return *static_cast<_Promise*>(\x0a"
"            __builtin_coro_promise(this->__handle_, _LIBCPP_ALIGNOF(_Promise), false));\x0a"
"    }\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static coroutine_handle from_address(void* __addr) _NOEXCEPT {\x0a"
"        coroutine_handle __tmp;\x0a"
"        __tmp.__handle_ = __addr;\x0a"
"        return __tmp;\x0a"
"    }\x0a"
"\x0a"
"    // NOTE\x3a this overload isn't required by the standard but is needed so\x0a"
"    // the deleted _Promise* overload doesn't make from_address(nullptr)\x0a"
"    // ambiguous.\x0a"
"    // FIXME\x3a should from_address work with nullptr\x3f\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static coroutine_handle from_address(nullptr_t) _NOEXCEPT {\x0a"
"      return coroutine_handle(nullptr);\x0a"
"    }\x0a"
"\x0a"
"    template <class _Tp, bool _CallIsValid = false>\x0a"
"    static coroutine_handle from_address(_Tp*) {\x0a"
"      static_assert(_CallIsValid,\x0a"
"       \x22""coroutine_handle<promise_type>\x3a\x3a""from_address cannot be called with \x22\x0a"
"        \x22non-void pointers\x22);\x0a"
"    }\x0a"
"\x0a"
"    template <bool _CallIsValid = false>\x0a"
"    static coroutine_handle from_address(_Promise*) {\x0a"
"      static_assert(_CallIsValid,\x0a"
"       \x22""coroutine_handle<promise_type>\x3a\x3a""from_address cannot be used with \x22\x0a"
"        \x22pointers to the coroutine's promise type; use 'from_promise' instead\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static coroutine_handle from_promise(_Promise\x26 __promise) _NOEXCEPT {\x0a"
"        typedef typename remove_cv<_Promise>\x3a\x3atype _RawPromise;\x0a"
"        coroutine_handle __tmp;\x0a"
"        __tmp.__handle_ = __builtin_coro_promise(\x0a"
"            _VSTD\x3a\x3a""addressof(const_cast<_RawPromise\x26>(__promise)),\x0a"
"             _LIBCPP_ALIGNOF(_Promise), true);\x0a"
"        return __tmp;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"#if __has_builtin(__builtin_coro_noop)\x0a"
"struct noop_coroutine_promise {};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TEMPLATE_VIS coroutine_handle<noop_coroutine_promise>\x0a"
"    \x3a public coroutine_handle<> {\x0a"
"  using _Base = coroutine_handle<>;\x0a"
"  using _Promise = noop_coroutine_promise;\x0a"
"public\x3a\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _Promise\x26 promise() const {\x0a"
"    return *static_cast<_Promise*>(\x0a"
"      __builtin_coro_promise(this->__handle_, _LIBCPP_ALIGNOF(_Promise), false));\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR explicit operator bool() const _NOEXCEPT { return true; }\x0a"
"  _LIBCPP_CONSTEXPR bool done() const _NOEXCEPT { return false; }\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR_AFTER_CXX17 void operator()() const _NOEXCEPT {}\x0a"
"  _LIBCPP_CONSTEXPR_AFTER_CXX17 void resume() const _NOEXCEPT {}\x0a"
"  _LIBCPP_CONSTEXPR_AFTER_CXX17 void destroy() const _NOEXCEPT {}\x0a"
"\x0a"
"private\x3a\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  friend coroutine_handle<noop_coroutine_promise> noop_coroutine() _NOEXCEPT;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY coroutine_handle() _NOEXCEPT {\x0a"
"    this->__handle_ = __builtin_coro_noop();\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"using noop_coroutine_handle = coroutine_handle<noop_coroutine_promise>;\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"noop_coroutine_handle noop_coroutine() _NOEXCEPT {\x0a"
"  return noop_coroutine_handle();\x0a"
"}\x0a"
"#endif // __has_builtin(__builtin_coro_noop)\x0a"
"\x0a"
"struct suspend_never {\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool await_ready() const _NOEXCEPT { return true; }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void await_suspend(coroutine_handle<>) const _NOEXCEPT {}\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void await_resume() const _NOEXCEPT {}\x0a"
"};\x0a"
"\x0a"
"struct suspend_always {\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool await_ready() const _NOEXCEPT { return false; }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void await_suspend(coroutine_handle<>) const _NOEXCEPT {}\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void await_resume() const _NOEXCEPT {}\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_EXPERIMENTAL_COROUTINES\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct hash<_VSTD_CORO\x3a\x3a""coroutine_handle<_Tp> > {\x0a"
"    using __arg_type = _VSTD_CORO\x3a\x3a""coroutine_handle<_Tp>;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(__arg_type const\x26 __v) const _NOEXCEPT\x0a"
"    {return hash<void*>()(__v.address());}\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // \x21""defined(_LIBCPP_HAS_NO_COROUTINES)\x0a"
"\x0a"
"#endif /* _LIBCPP_EXPERIMENTAL_COROUTINE */\x0a"
"", 10333 ); }