#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_experimental_filesystem( 
"// -*- C++ -*-\x0a"
"//===--------------------------- filesystem -------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"#ifndef _LIBCPP_EXPERIMENTAL_FILESYSTEM\x0a"
"#define _LIBCPP_EXPERIMENTAL_FILESYSTEM\x0a"
"/*\x0a"
"    filesystem synopsis\x0a"
"\x0a"
"    namespace std { namespace experimental { namespace filesystem { inline namespace v1 {\x0a"
"\x0a"
"    class path;\x0a"
"\x0a"
"    void swap(path\x26 lhs, path\x26 rhs) noexcept;\x0a"
"    size_t hash_value(const path\x26 p) noexcept;\x0a"
"\x0a"
"    bool operator==(const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"    bool operator\x21=(const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"    bool operator< (const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"    bool operator<=(const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"    bool operator> (const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"    bool operator>=(const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"\x0a"
"    path operator/ (const path\x26 lhs, const path\x26 rhs);\x0a"
"\x0a"
"    // fs.path.io operators are friends of path.\x0a"
"    template <class charT, class traits>\x0a"
"    friend basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os, const path\x26 p);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is, path\x26 p);\x0a"
"\x0a"
"    template <class Source>\x0a"
"      path u8path(const Source\x26 source);\x0a"
"    template <class InputIterator>\x0a"
"      path u8path(InputIterator first, InputIterator last);\x0a"
"\x0a"
"    class filesystem_error;\x0a"
"    class directory_entry;\x0a"
"\x0a"
"    class directory_iterator;\x0a"
"\x0a"
"    // enable directory_iterator range-based for statements\x0a"
"    directory_iterator begin(directory_iterator iter) noexcept;\x0a"
"    directory_iterator end(const directory_iterator\x26) noexcept;\x0a"
"\x0a"
"    class recursive_directory_iterator;\x0a"
"\x0a"
"    // enable recursive_directory_iterator range-based for statements\x0a"
"    recursive_directory_iterator begin(recursive_directory_iterator iter) noexcept;\x0a"
"    recursive_directory_iterator end(const recursive_directory_iterator\x26) noexcept;\x0a"
"\x0a"
"    class file_status;\x0a"
"\x0a"
"    struct space_info\x0a"
"    {\x0a"
"      uintmax_t capacity;\x0a"
"      uintmax_t free;\x0a"
"      uintmax_t available;\x0a"
"    };\x0a"
"\x0a"
"    enum class file_type;\x0a"
"    enum class perms;\x0a"
"    enum class perm_options;\x0a"
"    enum class copy_options;\x0a"
"    enum class directory_options;\x0a"
"\x0a"
"    typedef chrono\x3a\x3atime_point<trivial-clock>  file_time_type;\x0a"
"\x0a"
"    // operational functions\x0a"
"\x0a"
"    path absolute(const path\x26 p);\x0a"
"    path absolute(const path\x26 p, error_code \x26""ec);\x0a"
"\x0a"
"    path canonical(const path\x26 p);\x0a"
"    path canonical(const path\x26 p, error_code\x26 ec);\x0a"
"\x0a"
"    void copy(const path\x26 from, const path\x26 to);\x0a"
"    void copy(const path\x26 from, const path\x26 to, error_code\x26 ec);\x0a"
"    void copy(const path\x26 from, const path\x26 to, copy_options options);\x0a"
"    void copy(const path\x26 from, const path\x26 to, copy_options options,\x0a"
"                   error_code\x26 ec);\x0a"
"\x0a"
"    bool copy_file(const path\x26 from, const path\x26 to);\x0a"
"    bool copy_file(const path\x26 from, const path\x26 to, error_code\x26 ec);\x0a"
"    bool copy_file(const path\x26 from, const path\x26 to, copy_options option);\x0a"
"    bool copy_file(const path\x26 from, const path\x26 to, copy_options option,\x0a"
"                           error_code\x26 ec);\x0a"
"\x0a"
"    void copy_symlink(const path\x26 existing_symlink, const path\x26 new_symlink);\x0a"
"    void copy_symlink(const path\x26 existing_symlink, const path\x26 new_symlink,\x0a"
"                              error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool create_directories(const path\x26 p);\x0a"
"    bool create_directories(const path\x26 p, error_code\x26 ec);\x0a"
"\x0a"
"    bool create_directory(const path\x26 p);\x0a"
"    bool create_directory(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool create_directory(const path\x26 p, const path\x26 attributes);\x0a"
"    bool create_directory(const path\x26 p, const path\x26 attributes,\x0a"
"                                  error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    void create_directory_symlink(const path\x26 to, const path\x26 new_symlink);\x0a"
"    void create_directory_symlink(const path\x26 to, const path\x26 new_symlink,\x0a"
"                                          error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    void create_hard_link(const path\x26 to, const path\x26 new_hard_link);\x0a"
"    void create_hard_link(const path\x26 to, const path\x26 new_hard_link,\x0a"
"                                  error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    void create_symlink(const path\x26 to, const path\x26 new_symlink);\x0a"
"    void create_symlink(const path\x26 to, const path\x26 new_symlink,\x0a"
"                                error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    path current_path();\x0a"
"    path current_path(error_code\x26 ec);\x0a"
"    void current_path(const path\x26 p);\x0a"
"    void current_path(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool exists(file_status s) noexcept;\x0a"
"    bool exists(const path\x26 p);\x0a"
"    bool exists(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool equivalent(const path\x26 p1, const path\x26 p2);\x0a"
"    bool equivalent(const path\x26 p1, const path\x26 p2, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    uintmax_t    file_size(const path\x26 p);\x0a"
"    uintmax_t    file_size(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    uintmax_t    hard_link_count(const path\x26 p);\x0a"
"    uintmax_t    hard_link_count(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_block_file(file_status s) noexcept;\x0a"
"    bool is_block_file(const path\x26 p);\x0a"
"    bool is_block_file(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_character_file(file_status s) noexcept;\x0a"
"    bool is_character_file(const path\x26 p);\x0a"
"    bool is_character_file(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_directory(file_status s) noexcept;\x0a"
"    bool is_directory(const path\x26 p);\x0a"
"    bool is_directory(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_empty(const path\x26 p);\x0a"
"    bool is_empty(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_fifo(file_status s) noexcept;\x0a"
"    bool is_fifo(const path\x26 p);\x0a"
"    bool is_fifo(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_other(file_status s) noexcept;\x0a"
"    bool is_other(const path\x26 p);\x0a"
"    bool is_other(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_regular_file(file_status s) noexcept;\x0a"
"    bool is_regular_file(const path\x26 p);\x0a"
"    bool is_regular_file(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_socket(file_status s) noexcept;\x0a"
"    bool is_socket(const path\x26 p);\x0a"
"    bool is_socket(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_symlink(file_status s) noexcept;\x0a"
"    bool is_symlink(const path\x26 p);\x0a"
"    bool is_symlink(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    file_time_type  last_write_time(const path\x26 p);\x0a"
"    file_time_type  last_write_time(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"    void last_write_time(const path\x26 p, file_time_type new_time);\x0a"
"    void last_write_time(const path\x26 p, file_time_type new_time,\x0a"
"                                 error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    void permissions(const path\x26 p, perms prms,\x0a"
"                     perm_options opts=perm_options\x3a\x3areplace);\x0a"
"    void permissions(const path\x26 p, perms prms, error_code\x26 ec) noexcept;\x0a"
"    void permissions(const path\x26 p, perms prms, perm_options opts,\x0a"
"                     error_code\x26 ec);\x0a"
"\x0a"
"    path proximate(const path\x26 p, error_code\x26 ec);\x0a"
"    path proximate(const path\x26 p, const path\x26 base = current_path());\x0a"
"    path proximate(const path\x26 p, const path\x26 base, error_code \x26""ec);\x0a"
"\x0a"
"    path read_symlink(const path\x26 p);\x0a"
"    path read_symlink(const path\x26 p, error_code\x26 ec);\x0a"
"\x0a"
"    path relative(const path\x26 p, error_code\x26 ec);\x0a"
"    path relative(const path\x26 p, const path\x26 base=current_path());\x0a"
"    path relative(const path\x26 p, const path\x26 base, error_code\x26 ec);\x0a"
"\x0a"
"    bool remove(const path\x26 p);\x0a"
"    bool remove(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    uintmax_t    remove_all(const path\x26 p);\x0a"
"    uintmax_t    remove_all(const path\x26 p, error_code\x26 ec);\x0a"
"\x0a"
"    void rename(const path\x26 from, const path\x26 to);\x0a"
"    void rename(const path\x26 from, const path\x26 to, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    void resize_file(const path\x26 p, uintmax_t size);\x0a"
"    void resize_file(const path\x26 p, uintmax_t size, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    space_info   space(const path\x26 p);\x0a"
"    space_info   space(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    file_status  status(const path\x26 p);\x0a"
"    file_status  status(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool status_known(file_status s) noexcept;\x0a"
"\x0a"
"    file_status  symlink_status(const path\x26 p);\x0a"
"    file_status  symlink_status(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    path temp_directory_path();\x0a"
"    path temp_directory_path(error_code\x26 ec);\x0a"
"\x0a"
"    path weakly_canonical(path const\x26 p);\x0a"
"    path weakly_canonical(path const\x26 p, error_code\x26 ec);\x0a"
"\x0a"
"\x0a"
"} } } }  // namespaces std\x3a\x3a""experimental\x3a\x3a""filesystem\x3a\x3av1\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <experimental/__config>\x0a"
"#include <filesystem>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#define __cpp_lib_experimental_filesystem 201406\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_EXPERIMENTAL_FILESYSTEM\x0a"
"\x0a"
"using namespace _VSTD_FS;\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_EXPERIMENTAL_FILESYSTEM\x0a"
"\x0a"
"#endif // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif // _LIBCPP_EXPERIMENTAL_FILESYSTEM\x0a"
"", 9152 ); }