#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_experimental_functional( 
"// -*- C++ -*-\x0a"
"//===-------------------------- functional --------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_EXPERIMENTAL_FUNCTIONAL\x0a"
"#define _LIBCPP_EXPERIMENTAL_FUNCTIONAL\x0a"
"\x0a"
"/*\x0a"
"   experimental/functional synopsis\x0a"
"\x0a"
"#include <algorithm>\x0a"
"\x0a"
"namespace std {\x0a"
"namespace experimental {\x0a"
"inline namespace fundamentals_v1 {\x0a"
"\x0a"
"    // See C++14 20.9.9, Function object binders\x0a"
"    template <class T> constexpr bool is_bind_expression_v\x0a"
"      = is_bind_expression<T>\x3a\x3avalue;\x0a"
"    template <class T> constexpr int is_placeholder_v\x0a"
"      = is_placeholder<T>\x3a\x3avalue;\x0a"
"\x0a"
"    // 4.2, Class template function\x0a"
"    template<class> class function; // undefined\x0a"
"    template<class R, class... ArgTypes> class function<R(ArgTypes...)>;\x0a"
"\x0a"
"    template<class R, class... ArgTypes>\x0a"
"    void swap(function<R(ArgTypes...)>\x26, function<R(ArgTypes...)>\x26);\x0a"
"\x0a"
"    template<class R, class... ArgTypes>\x0a"
"    bool operator==(const function<R(ArgTypes...)>\x26, nullptr_t) noexcept;\x0a"
"    template<class R, class... ArgTypes>\x0a"
"    bool operator==(nullptr_t, const function<R(ArgTypes...)>\x26) noexcept;\x0a"
"    template<class R, class... ArgTypes>\x0a"
"    bool operator\x21=(const function<R(ArgTypes...)>\x26, nullptr_t) noexcept;\x0a"
"    template<class R, class... ArgTypes>\x0a"
"    bool operator\x21=(nullptr_t, const function<R(ArgTypes...)>\x26) noexcept;\x0a"
"\x0a"
"    // 4.3, Searchers\x0a"
"    template<class ForwardIterator, class BinaryPredicate = equal_to<>>\x0a"
"      class default_searcher;\x0a"
"\x0a"
"    template<class RandomAccessIterator,\x0a"
"             class Hash = hash<typename iterator_traits<RandomAccessIterator>\x3a\x3avalue_type>,\x0a"
"             class BinaryPredicate = equal_to<>>\x0a"
"      class boyer_moore_searcher;\x0a"
"\x0a"
"    template<class RandomAccessIterator,\x0a"
"             class Hash = hash<typename iterator_traits<RandomAccessIterator>\x3a\x3avalue_type>,\x0a"
"             class BinaryPredicate = equal_to<>>\x0a"
"      class boyer_moore_horspool_searcher;\x0a"
"\x0a"
"    template<class ForwardIterator, class BinaryPredicate = equal_to<>>\x0a"
"    default_searcher<ForwardIterator, BinaryPredicate>\x0a"
"    make_default_searcher(ForwardIterator pat_first, ForwardIterator pat_last,\x0a"
"                          BinaryPredicate pred = BinaryPredicate());\x0a"
"\x0a"
"    template<class RandomAccessIterator,\x0a"
"             class Hash = hash<typename iterator_traits<RandomAccessIterator>\x3a\x3avalue_type>,\x0a"
"             class BinaryPredicate = equal_to<>>\x0a"
"    boyer_moore_searcher<RandomAccessIterator, Hash, BinaryPredicate>\x0a"
"    make_boyer_moore_searcher(\x0a"
"        RandomAccessIterator pat_first, RandomAccessIterator pat_last,\x0a"
"        Hash hf = Hash(), BinaryPredicate pred = BinaryPredicate());\x0a"
"\x0a"
"    template<class RandomAccessIterator,\x0a"
"             class Hash = hash<typename iterator_traits<RandomAccessIterator>\x3a\x3avalue_type>,\x0a"
"             class BinaryPredicate = equal_to<>>\x0a"
"    boyer_moore_horspool_searcher<RandomAccessIterator, Hash, BinaryPredicate>\x0a"
"    make_boyer_moore_horspool_searcher(\x0a"
"        RandomAccessIterator pat_first, RandomAccessIterator pat_last,\x0a"
"        Hash hf = Hash(), BinaryPredicate pred = BinaryPredicate());\x0a"
"\x0a"
"  } // namespace fundamentals_v1\x0a"
"  } // namespace experimental\x0a"
"\x0a"
"  template<class R, class... ArgTypes, class Alloc>\x0a"
"  struct uses_allocator<experimental\x3a\x3a""function<R(ArgTypes...)>, Alloc>;\x0a"
"\x0a"
"} // namespace std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <experimental/__config>\x0a"
"#include <functional>\x0a"
"#include <algorithm>\x0a"
"#include <type_traits>\x0a"
"#include <vector>\x0a"
"#include <array>\x0a"
"#include <unordered_map>\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_LFTS\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"// default searcher\x0a"
"template<class _ForwardIterator, class _BinaryPredicate = equal_to<>>\x0a"
"class _LIBCPP_TYPE_VIS default_searcher {\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    default_searcher(_ForwardIterator __f, _ForwardIterator __l, \x0a"
"                       _BinaryPredicate __p = _BinaryPredicate())\x0a"
"        \x3a __first_(__f), __last_(__l), __pred_(__p) {}\x0a"
"\x0a"
"    template <typename _ForwardIterator2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<_ForwardIterator2, _ForwardIterator2>\x0a"
"    operator () (_ForwardIterator2 __f, _ForwardIterator2 __l) const\x0a"
"    {\x0a"
"        return _VSTD\x3a\x3a__search(__f, __l, __first_, __last_, __pred_,\x0a"
"            typename _VSTD\x3a\x3aiterator_traits<_ForwardIterator>\x3a\x3aiterator_category(),\x0a"
"            typename _VSTD\x3a\x3aiterator_traits<_ForwardIterator2>\x3a\x3aiterator_category());\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    _ForwardIterator __first_;\x0a"
"    _ForwardIterator __last_;\x0a"
"    _BinaryPredicate __pred_;\x0a"
"    };\x0a"
"\x0a"
"template<class _ForwardIterator, class _BinaryPredicate = equal_to<>>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"default_searcher<_ForwardIterator, _BinaryPredicate>\x0a"
"make_default_searcher( _ForwardIterator __f, _ForwardIterator __l, _BinaryPredicate __p = _BinaryPredicate ())\x0a"
"{\x0a"
"    return default_searcher<_ForwardIterator, _BinaryPredicate>(__f, __l, __p);\x0a"
"}\x0a"
"\x0a"
"template<class _Key, class _Value, class _Hash, class _BinaryPredicate, bool /*useArray*/> class _BMSkipTable;\x0a"
"\x0a"
"//  General case for BM data searching; use a map\x0a"
"template<class _Key, typename _Value, class _Hash, class _BinaryPredicate>\x0a"
"class _BMSkipTable<_Key, _Value, _Hash, _BinaryPredicate, false> {\x0a"
"public\x3a // TODO private\x3a\x0a"
"    typedef _Value value_type;\x0a"
"    typedef _Key   key_type;\x0a"
"\x0a"
"    const _Value __default_value_;\x0a"
"    std\x3a\x3aunordered_map<_Key, _Value, _Hash, _BinaryPredicate> __table;\x0a"
"    \x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _BMSkipTable(std\x3a\x3asize_t __sz, _Value __default, _Hash __hf, _BinaryPredicate __pred)\x0a"
"        \x3a __default_value_(__default), __table(__sz, __hf, __pred) {}\x0a"
"    \x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(const key_type \x26__key, value_type __val)\x0a"
"    {\x0a"
"        __table \x5b__key\x5d = __val;    // Would skip_.insert (val) be better here\x3f\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type operator \x5b\x5d(const key_type \x26 __key) const\x0a"
"    {\x0a"
"        auto __it = __table.find (__key);\x0a"
"        return __it == __table.end() \x3f __default_value_ \x3a __it->second;\x0a"
"    }\x0a"
"};\x0a"
"    \x0a"
"\x0a"
"//  Special case small numeric values; use an array\x0a"
"template<class _Key, typename _Value, class _Hash, class _BinaryPredicate>\x0a"
"class _BMSkipTable<_Key, _Value, _Hash, _BinaryPredicate, true> {\x0a"
"private\x3a\x0a"
"    typedef _Value value_type;\x0a"
"    typedef _Key   key_type;\x0a"
"\x0a"
"    typedef typename std\x3a\x3amake_unsigned<key_type>\x3a\x3atype unsigned_key_type;\x0a"
"    typedef std\x3a\x3a""array<value_type, _VSTD\x3a\x3anumeric_limits<unsigned_key_type>\x3a\x3amax()> skip_map;\x0a"
"    skip_map __table;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _BMSkipTable(std\x3a\x3asize_t /*__sz*/, _Value __default, _Hash /*__hf*/, _BinaryPredicate /*__pred*/)\x0a"
"    {\x0a"
"        std\x3a\x3a""fill_n(__table.begin(), __table.size(), __default);\x0a"
"    }\x0a"
"    \x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(key_type __key, value_type __val)\x0a"
"    {\x0a"
"        __table\x5bstatic_cast<unsigned_key_type>(__key)\x5d = __val;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type operator \x5b\x5d(key_type __key) const\x0a"
"    {\x0a"
"        return __table\x5bstatic_cast<unsigned_key_type>(__key)\x5d;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class _RandomAccessIterator1, \x0a"
"          class _Hash = hash<typename iterator_traits<_RandomAccessIterator1>\x3a\x3avalue_type>, \x0a"
"          class _BinaryPredicate = equal_to<>>\x0a"
"class _LIBCPP_TYPE_VIS boyer_moore_searcher {\x0a"
"private\x3a\x0a"
"    typedef typename std\x3a\x3aiterator_traits<_RandomAccessIterator1>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename std\x3a\x3aiterator_traits<_RandomAccessIterator1>\x3a\x3avalue_type      value_type;\x0a"
"    typedef _BMSkipTable<value_type, difference_type, _Hash, _BinaryPredicate,\x0a"
"                    _VSTD\x3a\x3ais_integral<value_type>\x3a\x3avalue \x26\x26 // what about enums\x3f\x0a"
"                    sizeof(value_type) == 1 \x26\x26\x0a"
"                    is_same<_Hash, hash<value_type>>\x3a\x3avalue \x26\x26\x0a"
"                    is_same<_BinaryPredicate, equal_to<>>\x3a\x3avalue\x0a"
"            > skip_table_type;\x0a"
"    \x0a"
"public\x3a\x0a"
"    boyer_moore_searcher(_RandomAccessIterator1 __f, _RandomAccessIterator1 __l, \x0a"
"                _Hash __hf = _Hash(), _BinaryPredicate __pred = _BinaryPredicate())\x0a"
"            \x3a __first_(__f), __last_(__l), __pred_(__pred),\x0a"
"              __pattern_length_(_VSTD\x3a\x3a""distance(__first_, __last_)),\x0a"
"              __skip_{make_shared<skip_table_type>(__pattern_length_, -1, __hf, __pred_)},\x0a"
"              __suffix_{make_shared<vector<difference_type>>(__pattern_length_ + 1)}\x0a"
"        {\x0a"
"    //  build the skip table\x0a"
"        for ( difference_type __i = 0; __f \x21= __l; ++__f, (void) ++__i )\x0a"
"            __skip_->insert(*__f, __i);\x0a"
"\x0a"
"        this->__build_suffix_table ( __first_, __last_, __pred_ );\x0a"
"        }\x0a"
"        \x0a"
"    template <typename _RandomAccessIterator2>\x0a"
"    pair<_RandomAccessIterator2, _RandomAccessIterator2>\x0a"
"    operator ()(_RandomAccessIterator2 __f, _RandomAccessIterator2 __l) const\x0a"
"    {\x0a"
"        static_assert ( std\x3a\x3ais_same<\x0a"
"                typename std\x3a\x3a__uncvref<typename std\x3a\x3aiterator_traits<_RandomAccessIterator1>\x3a\x3avalue_type>\x3a\x3atype, \x0a"
"                typename std\x3a\x3a__uncvref<typename std\x3a\x3aiterator_traits<_RandomAccessIterator2>\x3a\x3avalue_type>\x3a\x3atype\x0a"
"                    >\x3a\x3avalue,\x0a"
"                \x22""Corpus and Pattern iterators must point to the same type\x22 );\x0a"
"\x0a"
"        if (__f      == __l )    return make_pair(__l, __l); // empty corpus\x0a"
"        if (__first_ == __last_) return make_pair(__f, __f); // empty pattern\x0a"
"\x0a"
"    //  If the pattern is larger than the corpus, we can't find it\x21\x0a"
"        if ( __pattern_length_ > _VSTD\x3a\x3a""distance (__f, __l)) \x0a"
"            return make_pair(__l, __l);\x0a"
"\x0a"
"    //  Do the search \x0a"
"        return this->__search(__f, __l);\x0a"
"    }\x0a"
"        \x0a"
"public\x3a // TODO private\x3a\x0a"
"    _RandomAccessIterator1               __first_;\x0a"
"    _RandomAccessIterator1               __last_;\x0a"
"    _BinaryPredicate                     __pred_;\x0a"
"    difference_type                      __pattern_length_;\x0a"
"    shared_ptr<skip_table_type>          __skip_;\x0a"
"    shared_ptr<vector<difference_type>>  __suffix_;\x0a"
"\x0a"
"    template <typename _RandomAccessIterator2>\x0a"
"    pair<_RandomAccessIterator2, _RandomAccessIterator2>\x0a"
"    __search(_RandomAccessIterator2 __f, _RandomAccessIterator2 __l) const\x0a"
"    {\x0a"
"        _RandomAccessIterator2 __cur = __f;\x0a"
"        const _RandomAccessIterator2 __last = __l - __pattern_length_;\x0a"
"        const skip_table_type \x26         __skip   = *__skip_.get();\x0a"
"        const vector<difference_type> \x26 __suffix = *__suffix_.get();\x0a"
"        \x0a"
"        while (__cur <= __last)\x0a"
"        {\x0a"
"\x0a"
"        //  Do we match right where we are\x3f\x0a"
"            difference_type __j = __pattern_length_;\x0a"
"            while (__pred_(__first_ \x5b__j-1\x5d, __cur \x5b__j-1\x5d)) {\x0a"
"                __j--;\x0a"
"            //  We matched - we're done\x21\x0a"
"                if ( __j == 0 )\x0a"
"                    return make_pair(__cur, __cur + __pattern_length_);\x0a"
"                }\x0a"
"            \x0a"
"        //  Since we didn't match, figure out how far to skip forward\x0a"
"            difference_type __k = __skip\x5b__cur \x5b __j - 1 \x5d\x5d;\x0a"
"            difference_type __m = __j - __k - 1;\x0a"
"            if (__k < __j \x26\x26 __m > __suffix\x5b __j \x5d)\x0a"
"                __cur += __m;\x0a"
"            else\x0a"
"                __cur += __suffix\x5b __j \x5d;\x0a"
"        }\x0a"
"    \x0a"
"        return make_pair(__l, __l);     // We didn't find anything\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    template<typename _Iterator, typename _Container>\x0a"
"    void __compute_bm_prefix ( _Iterator __f, _Iterator __l, _BinaryPredicate __pred, _Container \x26__prefix )\x0a"
"    {\x0a"
"        const std\x3a\x3asize_t __count = _VSTD\x3a\x3a""distance(__f, __l);\x0a"
"                        \x0a"
"        __prefix\x5b""0\x5d = 0;\x0a"
"        std\x3a\x3asize_t __k = 0;\x0a"
"        for ( std\x3a\x3asize_t __i = 1; __i < __count; ++__i )\x0a"
"        {\x0a"
"            while ( __k > 0 \x26\x26 \x21__pred ( __f\x5b__k\x5d, __f\x5b__i\x5d ))\x0a"
"                __k = __prefix \x5b __k - 1 \x5d;\x0a"
"                \x0a"
"            if ( __pred ( __f\x5b__k\x5d, __f\x5b__i\x5d ))\x0a"
"                __k++;\x0a"
"            __prefix \x5b __i \x5d = __k;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    void __build_suffix_table(_RandomAccessIterator1 __f, _RandomAccessIterator1 __l, \x0a"
"                                                    _BinaryPredicate __pred)\x0a"
"    {\x0a"
"        const std\x3a\x3asize_t __count = _VSTD\x3a\x3a""distance(__f, __l);\x0a"
"        vector<difference_type> \x26 __suffix = *__suffix_.get();\x0a"
"        if (__count > 0)\x0a"
"        {\x0a"
"            _VSTD\x3a\x3avector<value_type> __scratch(__count);\x0a"
"            \x0a"
"            __compute_bm_prefix(__f, __l, __pred, __scratch);\x0a"
"            for ( std\x3a\x3asize_t __i = 0; __i <= __count; __i++ )\x0a"
"                __suffix\x5b__i\x5d = __count - __scratch\x5b__count-1\x5d;\x0a"
"    \x0a"
"            typedef _VSTD\x3a\x3areverse_iterator<_RandomAccessIterator1> _RevIter;\x0a"
"            __compute_bm_prefix(_RevIter(__l), _RevIter(__f), __pred, __scratch);\x0a"
"     \x0a"
"            for ( std\x3a\x3asize_t __i = 0; __i < __count; __i++ )\x0a"
"            {\x0a"
"                const std\x3a\x3asize_t     __j = __count - __scratch\x5b__i\x5d;\x0a"
"                const difference_type __k = __i     - __scratch\x5b__i\x5d + 1;\x0a"
"     \x0a"
"                if (__suffix\x5b__j\x5d > __k)\x0a"
"                    __suffix\x5b__j\x5d = __k;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"};\x0a"
"\x0a"
"template<class _RandomAccessIterator, \x0a"
"         class _Hash = hash<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>, \x0a"
"         class _BinaryPredicate = equal_to<>>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"boyer_moore_searcher<_RandomAccessIterator, _Hash, _BinaryPredicate>\x0a"
"make_boyer_moore_searcher( _RandomAccessIterator __f, _RandomAccessIterator __l, \x0a"
"                    _Hash __hf = _Hash(), _BinaryPredicate __p = _BinaryPredicate ())\x0a"
"{\x0a"
"    return boyer_moore_searcher<_RandomAccessIterator, _Hash, _BinaryPredicate>(__f, __l, __hf, __p);\x0a"
"}\x0a"
"\x0a"
"// boyer-moore-horspool\x0a"
"template <class _RandomAccessIterator1, \x0a"
"          class _Hash = hash<typename iterator_traits<_RandomAccessIterator1>\x3a\x3avalue_type>, \x0a"
"          class _BinaryPredicate = equal_to<>>\x0a"
"class _LIBCPP_TYPE_VIS boyer_moore_horspool_searcher {\x0a"
"private\x3a\x0a"
"    typedef typename std\x3a\x3aiterator_traits<_RandomAccessIterator1>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename std\x3a\x3aiterator_traits<_RandomAccessIterator1>\x3a\x3avalue_type      value_type;\x0a"
"    typedef _BMSkipTable<value_type, difference_type, _Hash, _BinaryPredicate,\x0a"
"                    _VSTD\x3a\x3ais_integral<value_type>\x3a\x3avalue \x26\x26 // what about enums\x3f\x0a"
"                    sizeof(value_type) == 1 \x26\x26\x0a"
"                    is_same<_Hash, hash<value_type>>\x3a\x3avalue \x26\x26\x0a"
"                    is_same<_BinaryPredicate, equal_to<>>\x3a\x3avalue\x0a"
"            > skip_table_type;\x0a"
"\x0a"
"public\x3a\x0a"
"    boyer_moore_horspool_searcher(_RandomAccessIterator1 __f, _RandomAccessIterator1 __l, \x0a"
"                _Hash __hf = _Hash(), _BinaryPredicate __pred = _BinaryPredicate())\x0a"
"            \x3a __first_(__f), __last_(__l), __pred_(__pred),\x0a"
"              __pattern_length_(_VSTD\x3a\x3a""distance(__first_, __last_)),\x0a"
"              __skip_{_VSTD\x3a\x3amake_shared<skip_table_type>(__pattern_length_, __pattern_length_, __hf, __pred_)}\x0a"
"        {\x0a"
"    //  build the skip table\x0a"
"            if ( __f \x21= __l )\x0a"
"            {\x0a"
"                __l = __l - 1;\x0a"
"                for ( difference_type __i = 0; __f \x21= __l; ++__f, (void) ++__i )\x0a"
"                    __skip_->insert(*__f, __pattern_length_ - 1 - __i);\x0a"
"            }\x0a"
"        }\x0a"
"            \x0a"
"    template <typename _RandomAccessIterator2>\x0a"
"    pair<_RandomAccessIterator2, _RandomAccessIterator2>\x0a"
"    operator ()(_RandomAccessIterator2 __f, _RandomAccessIterator2 __l) const\x0a"
"    {\x0a"
"        static_assert ( std\x3a\x3ais_same<\x0a"
"                typename std\x3a\x3a__uncvref<typename std\x3a\x3aiterator_traits<_RandomAccessIterator1>\x3a\x3avalue_type>\x3a\x3atype, \x0a"
"                typename std\x3a\x3a__uncvref<typename std\x3a\x3aiterator_traits<_RandomAccessIterator2>\x3a\x3avalue_type>\x3a\x3atype\x0a"
"                    >\x3a\x3avalue,\x0a"
"                \x22""Corpus and Pattern iterators must point to the same type\x22 );\x0a"
"\x0a"
"        if (__f      == __l )    return make_pair(__l, __l); // empty corpus\x0a"
"        if (__first_ == __last_) return make_pair(__f, __f); // empty pattern\x0a"
"\x0a"
"    //  If the pattern is larger than the corpus, we can't find it\x21\x0a"
"        if ( __pattern_length_ > _VSTD\x3a\x3a""distance (__f, __l)) \x0a"
"            return make_pair(__l, __l);\x0a"
"\x0a"
"    //  Do the search \x0a"
"        return this->__search(__f, __l);\x0a"
"    }\x0a"
"        \x0a"
"private\x3a\x0a"
"    _RandomAccessIterator1      __first_;\x0a"
"    _RandomAccessIterator1      __last_;\x0a"
"    _BinaryPredicate            __pred_;\x0a"
"    difference_type             __pattern_length_;\x0a"
"    shared_ptr<skip_table_type> __skip_;\x0a"
"\x0a"
"    template <typename _RandomAccessIterator2>\x0a"
"    pair<_RandomAccessIterator2, _RandomAccessIterator2>\x0a"
"    __search ( _RandomAccessIterator2 __f, _RandomAccessIterator2 __l ) const {\x0a"
"        _RandomAccessIterator2 __cur = __f;\x0a"
"        const _RandomAccessIterator2 __last = __l - __pattern_length_;\x0a"
"        const skip_table_type \x26 __skip = *__skip_.get();\x0a"
"\x0a"
"        while (__cur <= __last)\x0a"
"        {\x0a"
"        //  Do we match right where we are\x3f\x0a"
"            difference_type __j = __pattern_length_;\x0a"
"            while (__pred_(__first_\x5b__j-1\x5d, __cur\x5b__j-1\x5d))\x0a"
"            {\x0a"
"                __j--;\x0a"
"            //  We matched - we're done\x21\x0a"
"                if ( __j == 0 )\x0a"
"                    return make_pair(__cur, __cur + __pattern_length_);\x0a"
"            }\x0a"
"            __cur += __skip\x5b__cur\x5b__pattern_length_-1\x5d\x5d;\x0a"
"        }\x0a"
"        \x0a"
"        return make_pair(__l, __l);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template<class _RandomAccessIterator, \x0a"
"         class _Hash = hash<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>, \x0a"
"         class _BinaryPredicate = equal_to<>>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"boyer_moore_horspool_searcher<_RandomAccessIterator, _Hash, _BinaryPredicate>\x0a"
"make_boyer_moore_horspool_searcher( _RandomAccessIterator __f, _RandomAccessIterator __l, \x0a"
"                    _Hash __hf = _Hash(), _BinaryPredicate __p = _BinaryPredicate ())\x0a"
"{\x0a"
"    return boyer_moore_horspool_searcher<_RandomAccessIterator, _Hash, _BinaryPredicate>(__f, __l, __hf, __p);\x0a"
"}\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_LFTS\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif /* _LIBCPP_EXPERIMENTAL_FUNCTIONAL */\x0a"
"", 17902 ); }