#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_experimental_iterator( 
"// -*- C++ -*-\x0a"
"//===----------------------------- iterator -------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_EXPERIMENTAL_ITERATOR\x0a"
"#define _LIBCPP_EXPERIMENTAL_ITERATOR\x0a"
"\x0a"
"/*\x0a"
"namespace std {\x0a"
"  namespace experimental {\x0a"
"    inline namespace fundamentals_v2 {\x0a"
"\x0a"
"    template <class DelimT, class charT = char, class traits = char_traits<charT>>\x0a"
"        class ostream_joiner {\x0a"
"        public\x3a\x0a"
"         typedef charT                        char_type;\x0a"
"         typedef traits                       traits_type;\x0a"
"         typedef basic_ostream<charT, traits> ostream_type;\x0a"
"         typedef output_iterator_tag          iterator_category;\x0a"
"         typedef void                         value_type;\x0a"
"         typedef void                         difference_type;\x0a"
"         typedef void                         pointer;\x0a"
"         typedef void                         reference;\x0a"
"      \x0a"
"         ostream_joiner(ostream_type\x26 s, const DelimT\x26 delimiter);\x0a"
"         ostream_joiner(ostream_type\x26 s, DelimT\x26\x26 delimiter);\x0a"
"\x0a"
"         template<typename T>  \x0a"
"         ostream_joiner\x26 operator=(const T\x26 value);\x0a"
"\x0a"
"         ostream_joiner\x26 operator*() noexcept;\x0a"
"         ostream_joiner\x26 operator++() noexcept;\x0a"
"         ostream_joiner\x26 operator++(int) noexcept;\x0a"
"   private\x3a\x0a"
"      ostream_type* out_stream;   // exposition only \x0a"
"      DelimT delim;               // exposition only \x0a"
"      bool first_element;         // exposition only\x0a"
"   };\x0a"
"\x0a"
"  template <class charT, class traits, class DelimT>\x0a"
"    ostream_joiner<decay_t<DelimT>, charT, traits>\x0a"
"    make_ostream_joiner(basic_ostream<charT, traits>\x26 os, DelimT\x26\x26 delimiter);\x0a"
"\x0a"
"    } // inline namespace fundamentals_v2\x0a"
"  } // namespace experimental\x0a"
"} // namespace std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <experimental/__config>\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"#include <iterator>\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_LFTS\x0a"
"\x0a"
"template <class _Delim, class _CharT = char, class _Traits = char_traits<_CharT>>\x0a"
"class ostream_joiner {\x0a"
"public\x3a\x0a"
"\x0a"
"    typedef _CharT                               char_type;\x0a"
"    typedef _Traits                              traits_type;\x0a"
"    typedef basic_ostream<char_type,traits_type> ostream_type;\x0a"
"    typedef output_iterator_tag                  iterator_category;\x0a"
"    typedef void                                 value_type;\x0a"
"    typedef void                                 difference_type;\x0a"
"    typedef void                                 pointer;\x0a"
"    typedef void                                 reference;\x0a"
"\x0a"
"    ostream_joiner(ostream_type\x26 __os, _Delim\x26\x26 __d)\x0a"
"        \x3a __output_iter(_VSTD\x3a\x3a""addressof(__os)), __delim(_VSTD\x3a\x3amove(__d)), __first(true) {}\x0a"
"        \x0a"
"    ostream_joiner(ostream_type\x26 __os, const _Delim\x26 __d)\x0a"
"        \x3a __output_iter(_VSTD\x3a\x3a""addressof(__os)), __delim(__d), __first(true) {}\x0a"
"    \x0a"
"\x0a"
"    template<typename _Tp>\x0a"
"    ostream_joiner\x26 operator=(const _Tp\x26 __v)\x0a"
"    {\x0a"
"        if (\x21__first)\x0a"
"            *__output_iter << __delim;\x0a"
"        __first = false;\x0a"
"        *__output_iter << __v;\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    ostream_joiner\x26 operator*()     _NOEXCEPT { return *this; }\x0a"
"    ostream_joiner\x26 operator++()    _NOEXCEPT { return *this; }\x0a"
"    ostream_joiner\x26 operator++(int) _NOEXCEPT { return *this; }\x0a"
"\x0a"
"private\x3a\x0a"
"    ostream_type*   __output_iter;\x0a"
"    _Delim          __delim;\x0a"
"    bool            __first;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Delim>\x0a"
"ostream_joiner<typename decay<_Delim>\x3a\x3atype, _CharT, _Traits>\x0a"
"make_ostream_joiner(basic_ostream<_CharT, _Traits>\x26 __os, _Delim \x26\x26 __d)\x0a"
"{ return ostream_joiner<typename decay<_Delim>\x3a\x3atype, _CharT, _Traits>(__os, _VSTD\x3a\x3a""forward<_Delim>(__d)); }\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_LFTS\x0a"
"\x0a"
"#endif /* _LIBCPP_STD_VER > 11 */\x0a"
"\x0a"
"#endif // _LIBCPP_EXPERIMENTAL_ITERATOR\x0a"
"", 3929 ); }