#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_experimental_memory_resource( 
"// -*- C++ -*-\x0a"
"//===------------------------ memory_resource -----------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_EXPERIMENTAL_MEMORY_RESOURCE\x0a"
"#define _LIBCPP_EXPERIMENTAL_MEMORY_RESOURCE\x0a"
"\x0a"
"/**\x0a"
"    experimental/memory_resource synopsis\x0a"
"\x0a"
"// C++1y\x0a"
"\x0a"
"namespace std {\x0a"
"namespace experimental {\x0a"
"inline namespace fundamentals_v1 {\x0a"
"namespace pmr {\x0a"
"\x0a"
"  class memory_resource;\x0a"
"\x0a"
"  bool operator==(const memory_resource\x26 a,\x0a"
"                  const memory_resource\x26 b) noexcept;\x0a"
"  bool operator\x21=(const memory_resource\x26 a,\x0a"
"                  const memory_resource\x26 b) noexcept;\x0a"
"\x0a"
"  template <class Tp> class polymorphic_allocator;\x0a"
"\x0a"
"  template <class T1, class T2>\x0a"
"  bool operator==(const polymorphic_allocator<T1>\x26 a,\x0a"
"                  const polymorphic_allocator<T2>\x26 b) noexcept;\x0a"
"  template <class T1, class T2>\x0a"
"  bool operator\x21=(const polymorphic_allocator<T1>\x26 a,\x0a"
"                  const polymorphic_allocator<T2>\x26 b) noexcept;\x0a"
"\x0a"
"  // The name resource_adaptor_imp is for exposition only.\x0a"
"  template <class Allocator> class resource_adaptor_imp;\x0a"
"\x0a"
"  template <class Allocator>\x0a"
"    using resource_adaptor = resource_adaptor_imp<\x0a"
"      allocator_traits<Allocator>\x3a\x3arebind_alloc<char>>;\x0a"
"\x0a"
"  // Global memory resources\x0a"
"  memory_resource* new_delete_resource() noexcept;\x0a"
"  memory_resource* null_memory_resource() noexcept;\x0a"
"\x0a"
"  // The default memory resource\x0a"
"  memory_resource* set_default_resource(memory_resource* r) noexcept;\x0a"
"  memory_resource* get_default_resource() noexcept;\x0a"
"\x0a"
"  // Standard memory resources\x0a"
"  struct pool_options;\x0a"
"  class synchronized_pool_resource;\x0a"
"  class unsynchronized_pool_resource;\x0a"
"  class monotonic_buffer_resource;\x0a"
"\x0a"
"} // namespace pmr\x0a"
"} // namespace fundamentals_v1\x0a"
"} // namespace experimental\x0a"
"} // namespace std\x0a"
"\x0a"
" */\x0a"
"\x0a"
"#include <experimental/__config>\x0a"
"#include <experimental/__memory>\x0a"
"#include <limits>\x0a"
"#include <memory>\x0a"
"#include <new>\x0a"
"#include <stdexcept>\x0a"
"#include <__tuple>\x0a"
"#include <type_traits>\x0a"
"#include <utility>\x0a"
"#include <cstddef>\x0a"
"#include <cstdlib>\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_LFTS_PMR\x0a"
"\x0a"
"// Round __s up to next multiple of __a.\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"size_t __aligned_allocation_size(size_t __s, size_t __a) _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s + __a > __s, \x22""aligned allocation size overflows\x22);\x0a"
"    return (__s + __a - 1) \x26 \x7e(__a - 1);\x0a"
"}\x0a"
"\x0a"
"// 8.5, memory.resource\x0a"
"class _LIBCPP_TYPE_VIS memory_resource\x0a"
"{\x0a"
"    static const size_t __max_align = _LIBCPP_ALIGNOF(max_align_t);\x0a"
"\x0a"
"// 8.5.2, memory.resource.public\x0a"
"public\x3a\x0a"
"    virtual \x7ememory_resource() = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void* allocate(size_t __bytes, size_t __align = __max_align)\x0a"
"        { return do_allocate(__bytes, __align); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void deallocate(void * __p, size_t __bytes, size_t __align = __max_align)\x0a"
"        { do_deallocate(__p, __bytes, __align); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool is_equal(memory_resource const \x26 __other) const _NOEXCEPT\x0a"
"        { return do_is_equal(__other); }\x0a"
"\x0a"
"// 8.5.3, memory.resource.priv\x0a"
"protected\x3a\x0a"
"    virtual void* do_allocate(size_t, size_t) = 0;\x0a"
"    virtual void do_deallocate(void*, size_t, size_t) = 0;\x0a"
"    virtual bool do_is_equal(memory_resource const \x26) const _NOEXCEPT = 0;\x0a"
"};\x0a"
"\x0a"
"// 8.5.4, memory.resource.eq\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator==(memory_resource const \x26 __lhs,\x0a"
"                memory_resource const \x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x26__lhs == \x26__rhs \x7c\x7c __lhs.is_equal(__rhs);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(memory_resource const \x26 __lhs,\x0a"
"                memory_resource const \x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__lhs == __rhs);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"memory_resource * new_delete_resource() _NOEXCEPT;\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"memory_resource * null_memory_resource() _NOEXCEPT;\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"memory_resource * get_default_resource() _NOEXCEPT;\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"memory_resource * set_default_resource(memory_resource * __new_res) _NOEXCEPT;\x0a"
"\x0a"
"// 8.6, memory.polymorphic.allocator.class\x0a"
"\x0a"
"// 8.6.1, memory.polymorphic.allocator.overview\x0a"
"template <class _ValueType>\x0a"
"class _LIBCPP_TEMPLATE_VIS polymorphic_allocator\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _ValueType value_type;\x0a"
"\x0a"
"    // 8.6.2, memory.polymorphic.allocator.ctor\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    polymorphic_allocator() _NOEXCEPT\x0a"
"      \x3a __res_(_VSTD_LFTS_PMR\x3a\x3aget_default_resource())\x0a"
"    {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    polymorphic_allocator(memory_resource * __r) _NOEXCEPT\x0a"
"      \x3a __res_(__r)\x0a"
"    {}\x0a"
"\x0a"
"    polymorphic_allocator(polymorphic_allocator const \x26) = default;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    polymorphic_allocator(polymorphic_allocator<_Tp> const \x26 __other) _NOEXCEPT\x0a"
"      \x3a __res_(__other.resource())\x0a"
"    {}\x0a"
"\x0a"
"    polymorphic_allocator \x26\x0a"
"    operator=(polymorphic_allocator const \x26) = delete;\x0a"
"\x0a"
"    // 8.6.3, memory.polymorphic.allocator.mem\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _ValueType* allocate(size_t __n) {\x0a"
"        if (__n > __max_size()) {\x0a"
"            __throw_length_error(\x0a"
"                \x22std\x3a\x3a""experimental\x3a\x3apmr\x3a\x3apolymorphic_allocator<T>\x3a\x3a""allocate(size_t n)\x22\x0a"
"                \x22 'n' exceeds maximum supported size\x22);\x0a"
"        }\x0a"
"        return static_cast<_ValueType*>(\x0a"
"            __res_->allocate(__n * sizeof(_ValueType), _LIBCPP_ALIGNOF(_ValueType))\x0a"
"        );\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void deallocate(_ValueType * __p, size_t __n) _NOEXCEPT {\x0a"
"        _LIBCPP_ASSERT(__n <= __max_size(),\x0a"
"                       \x22""deallocate called for size which exceeds max_size()\x22);\x0a"
"        __res_->deallocate(__p, __n * sizeof(_ValueType), _LIBCPP_ALIGNOF(_ValueType));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Tp, class ..._Ts>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void construct(_Tp* __p, _Ts \x26\x26... __args)\x0a"
"    {\x0a"
"        _VSTD_LFTS\x3a\x3a__lfts_user_alloc_construct(\x0a"
"            __p, *this, _VSTD\x3a\x3a""forward<_Ts>(__args)...\x0a"
"          );\x0a"
"    }\x0a"
"\x0a"
"    template <class _T1, class _T2, class ..._Args1, class ..._Args2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void construct(pair<_T1, _T2>* __p, piecewise_construct_t,\x0a"
"                   tuple<_Args1...> __x, tuple<_Args2...> __y)\x0a"
"    {\x0a"
"        \x3a\x3anew ((void*)__p) pair<_T1, _T2>(piecewise_construct\x0a"
"          , __transform_tuple(\x0a"
"              typename __lfts_uses_alloc_ctor<\x0a"
"                  _T1, polymorphic_allocator\x26, _Args1...\x0a"
"              >\x3a\x3atype()\x0a"
"            , _VSTD\x3a\x3amove(__x)\x0a"
"            , typename __make_tuple_indices<sizeof...(_Args1)>\x3a\x3atype{}\x0a"
"          )\x0a"
"          , __transform_tuple(\x0a"
"              typename __lfts_uses_alloc_ctor<\x0a"
"                  _T2, polymorphic_allocator\x26, _Args2...\x0a"
"              >\x3a\x3atype()\x0a"
"            , _VSTD\x3a\x3amove(__y)\x0a"
"            , typename __make_tuple_indices<sizeof...(_Args2)>\x3a\x3atype{}\x0a"
"          )\x0a"
"        );\x0a"
"    }\x0a"
"\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void construct(pair<_T1, _T2>* __p) {\x0a"
"        construct(__p, piecewise_construct, tuple<>(), tuple<>());\x0a"
"    }\x0a"
"\x0a"
"    template <class _T1, class _T2, class _Up, class _Vp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void construct(pair<_T1, _T2> * __p, _Up \x26\x26 __u, _Vp \x26\x26 __v) {\x0a"
"        construct(__p, piecewise_construct\x0a"
"          , _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Up>(__u))\x0a"
"          , _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Vp>(__v)));\x0a"
"    }\x0a"
"\x0a"
"    template <class _T1, class _T2, class _U1, class _U2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void construct(pair<_T1, _T2> * __p, pair<_U1, _U2> const \x26 __pr) {\x0a"
"        construct(__p, piecewise_construct\x0a"
"            , _VSTD\x3a\x3a""forward_as_tuple(__pr.first)\x0a"
"            , _VSTD\x3a\x3a""forward_as_tuple(__pr.second));\x0a"
"    }\x0a"
"\x0a"
"    template <class _T1, class _T2, class _U1, class _U2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void construct(pair<_T1, _T2> * __p, pair<_U1, _U2> \x26\x26 __pr){\x0a"
"        construct(__p, piecewise_construct\x0a"
"            , _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_U1>(__pr.first))\x0a"
"            , _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_U2>(__pr.second)));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void destroy(_Tp * __p) _NOEXCEPT\x0a"
"        { __p->\x7e_Tp(); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    polymorphic_allocator\x0a"
"    select_on_container_copy_construction() const _NOEXCEPT\x0a"
"        { return polymorphic_allocator(); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    memory_resource * resource() const _NOEXCEPT\x0a"
"        { return __res_; }\x0a"
"\x0a"
"private\x3a\x0a"
"    template <class ..._Args, size_t ..._Idx>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    tuple<_Args\x26\x26...>\x0a"
"    __transform_tuple(integral_constant<int, 0>, tuple<_Args...>\x26\x26 __t,\x0a"
"                      __tuple_indices<_Idx...>) const\x0a"
"    {\x0a"
"        return _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3aget<_Idx>(_VSTD\x3a\x3amove(__t))...);\x0a"
"    }\x0a"
"\x0a"
"    template <class ..._Args, size_t ..._Idx>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    tuple<allocator_arg_t const\x26, polymorphic_allocator\x26, _Args\x26\x26...>\x0a"
"    __transform_tuple(integral_constant<int, 1>, tuple<_Args...> \x26\x26 __t,\x0a"
"                      __tuple_indices<_Idx...>)\x0a"
"    {\x0a"
"        using _Tup = tuple<allocator_arg_t const\x26, polymorphic_allocator\x26, _Args\x26\x26...>;\x0a"
"        return _Tup(allocator_arg, *this,\x0a"
"                    _VSTD\x3a\x3aget<_Idx>(_VSTD\x3a\x3amove(__t))...);\x0a"
"    }\x0a"
"\x0a"
"    template <class ..._Args, size_t ..._Idx>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    tuple<_Args\x26\x26..., polymorphic_allocator\x26>\x0a"
"    __transform_tuple(integral_constant<int, 2>, tuple<_Args...> \x26\x26 __t,\x0a"
"                      __tuple_indices<_Idx...>)\x0a"
"    {\x0a"
"        using _Tup = tuple<_Args\x26\x26..., polymorphic_allocator\x26>;\x0a"
"        return _Tup(_VSTD\x3a\x3aget<_Idx>(_VSTD\x3a\x3amove(__t))..., *this);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t __max_size() const _NOEXCEPT\x0a"
"        { return numeric_limits<size_t>\x3a\x3amax() / sizeof(value_type); }\x0a"
"\x0a"
"    memory_resource * __res_;\x0a"
"};\x0a"
"\x0a"
"// 8.6.4, memory.polymorphic.allocator.eq\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator==(polymorphic_allocator<_Tp> const \x26 __lhs,\x0a"
"                polymorphic_allocator<_Up> const \x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return *__lhs.resource() == *__rhs.resource();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(polymorphic_allocator<_Tp> const \x26 __lhs,\x0a"
"                polymorphic_allocator<_Up> const \x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__lhs == __rhs);\x0a"
"}\x0a"
"\x0a"
"// 8.7, memory.resource.adaptor\x0a"
"\x0a"
"// 8.7.1, memory.resource.adaptor.overview\x0a"
"template <class _CharAlloc>\x0a"
"class _LIBCPP_TEMPLATE_VIS __resource_adaptor_imp\x0a"
"  \x3a public memory_resource\x0a"
"{\x0a"
"    using _CTraits = allocator_traits<_CharAlloc>;\x0a"
"    static_assert(is_same<typename _CTraits\x3a\x3avalue_type, char>\x3a\x3avalue\x0a"
"               \x26\x26 is_same<typename _CTraits\x3a\x3apointer, char*>\x3a\x3avalue\x0a"
"               \x26\x26 is_same<typename _CTraits\x3a\x3avoid_pointer, void*>\x3a\x3avalue, \x22\x22);\x0a"
"\x0a"
"    static const size_t _MaxAlign = _LIBCPP_ALIGNOF(max_align_t);\x0a"
"\x0a"
"    using _Alloc = typename _CTraits\x3a\x3atemplate rebind_alloc<\x0a"
"            typename aligned_storage<_MaxAlign, _MaxAlign>\x3a\x3atype\x0a"
"        >;\x0a"
"\x0a"
"    using _ValueType = typename _Alloc\x3a\x3avalue_type;\x0a"
"\x0a"
"    _Alloc __alloc_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _CharAlloc allocator_type;\x0a"
"\x0a"
"    __resource_adaptor_imp() = default;\x0a"
"    __resource_adaptor_imp(__resource_adaptor_imp const \x26) = default;\x0a"
"    __resource_adaptor_imp(__resource_adaptor_imp \x26\x26) = default;\x0a"
"\x0a"
"    // 8.7.2, memory.resource.adaptor.ctor\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __resource_adaptor_imp(allocator_type const \x26 __a)\x0a"
"      \x3a __alloc_(__a)\x0a"
"    {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __resource_adaptor_imp(allocator_type \x26\x26 __a)\x0a"
"      \x3a __alloc_(_VSTD\x3a\x3amove(__a))\x0a"
"    {}\x0a"
"\x0a"
"    __resource_adaptor_imp \x26\x0a"
"    operator=(__resource_adaptor_imp const \x26) = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const\x0a"
"    { return __alloc_; }\x0a"
"\x0a"
"// 8.7.3, memory.resource.adaptor.mem\x0a"
"protected\x3a\x0a"
"    virtual void * do_allocate(size_t __bytes, size_t)\x0a"
"    {\x0a"
"        if (__bytes > __max_size()) {\x0a"
"            __throw_length_error(\x0a"
"                \x22std\x3a\x3a""experimental\x3a\x3apmr\x3a\x3aresource_adaptor<T>\x3a\x3a""do_allocate(size_t bytes, size_t align)\x22\x0a"
"                \x22 'bytes' exceeds maximum supported size\x22);\x0a"
"        }\x0a"
"        size_t __s = __aligned_allocation_size(__bytes, _MaxAlign) / _MaxAlign;\x0a"
"        return __alloc_.allocate(__s);\x0a"
"    }\x0a"
"\x0a"
"    virtual void do_deallocate(void * __p, size_t __bytes, size_t)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__bytes <= __max_size(),\x0a"
"            \x22""do_deallocate called for size which exceeds the maximum allocation size\x22);\x0a"
"        size_t __s = __aligned_allocation_size(__bytes, _MaxAlign) / _MaxAlign;\x0a"
"        __alloc_.deallocate((_ValueType*)__p, __s);\x0a"
"    }\x0a"
"\x0a"
"    virtual bool do_is_equal(memory_resource const \x26 __other) const _NOEXCEPT {\x0a"
"        __resource_adaptor_imp const * __p\x0a"
"          = dynamic_cast<__resource_adaptor_imp const *>(\x26__other);\x0a"
"        return __p  \x3f __alloc_ == __p->__alloc_ \x3a false;\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t __max_size() const _NOEXCEPT {\x0a"
"        return numeric_limits<size_t>\x3a\x3amax() - _MaxAlign;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"using resource_adaptor = __resource_adaptor_imp<\x0a"
"    typename allocator_traits<_Alloc>\x3a\x3atemplate rebind_alloc<char>\x0a"
"  >;\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_LFTS_PMR\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif /* _LIBCPP_EXPERIMENTAL_MEMORY_RESOURCE */\x0a"
"", 13384 ); }