#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_experimental_propagate_const( 
"// -*- C++ -*-\x0a"
"//===------------------------ propagate_const -----------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_EXPERIMENTAL_PROPAGATE_CONST\x0a"
"#define _LIBCPP_EXPERIMENTAL_PROPAGATE_CONST\x0a"
"/*\x0a"
"    propagate_const synopsis\x0a"
"\x0a"
"    namespace std { namespace experimental { inline namespace fundamentals_v2 {\x0a"
"\x0a"
"    // \x5bpropagate_const\x5d\x0a"
"    template <class T> class propagate_const;\x0a"
"\x0a"
"    // \x5bpropagate_const.underlying\x5d, underlying pointer access\x0a"
"    constexpr const _Tp\x26 _VSTD_LFTS_V2\x3a\x3aget_underlying(const propagate_const<T>\x26 pt) noexcept;\x0a"
"    constexpr T\x26 _VSTD_LFTS_V2\x3a\x3aget_underlying(propagate_const<T>\x26 pt) noexcept;\x0a"
"\x0a"
"    // \x5bpropagate_const.relational\x5d, relational operators\x0a"
"    template <class T> constexpr bool operator==(const propagate_const<T>\x26 pt, nullptr_t);\x0a"
"    template <class T> constexpr bool operator==(nullptr_t, const propagate_const<T>\x26 pu);\x0a"
"    template <class T> constexpr bool operator\x21=(const propagate_const<T>\x26 pt, nullptr_t);\x0a"
"    template <class T> constexpr bool operator\x21=(nullptr_t, const propagate_const<T>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator==(const propagate_const<T>\x26 pt, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator\x21=(const propagate_const<T>\x26 pt, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator<(const propagate_const<T>\x26 pt, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator>(const propagate_const<T>\x26 pt, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator<=(const propagate_const<T>\x26 pt, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator>=(const propagate_const<T>\x26 pt, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator==(const propagate_const<T>\x26 pt, const _Up\x26 u);\x0a"
"    template <class T, class U> constexpr bool operator\x21=(const propagate_const<T>\x26 pt, const _Up\x26 u);\x0a"
"    template <class T, class U> constexpr bool operator<(const propagate_const<T>\x26 pt, const _Up\x26 u);\x0a"
"    template <class T, class U> constexpr bool operator>(const propagate_const<T>\x26 pt, const _Up\x26 u);\x0a"
"    template <class T, class U> constexpr bool operator<=(const propagate_const<T>\x26 pt, const _Up\x26 u);\x0a"
"    template <class T, class U> constexpr bool operator>=(const propagate_const<T>\x26 pt, const _Up\x26 u);\x0a"
"    template <class T, class U> constexpr bool operator==(const _Tp\x26 t, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator\x21=(const _Tp\x26 t, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator<(const _Tp\x26 t, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator>(const _Tp\x26 t, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator<=(const _Tp\x26 t, const propagate_const<_Up>\x26 pu);\x0a"
"    template <class T, class U> constexpr bool operator>=(const _Tp\x26 t, const propagate_const<_Up>\x26 pu);\x0a"
"\x0a"
"    // \x5bpropagate_const.algorithms\x5d, specialized algorithms\x0a"
"    template <class T> constexpr void swap(propagate_const<T>\x26 pt, propagate_const<T>\x26 pu) noexcept(see below);\x0a"
"\x0a"
"    template <class T>\x0a"
"    class propagate_const\x0a"
"    {\x0a"
"\x0a"
"    public\x3a\x0a"
"      typedef remove_reference_t<decltype(*declval<T\x26>())> element_type;\x0a"
"\x0a"
"      // \x5bpropagate_const.ctor\x5d, constructors\x0a"
"      constexpr propagate_const() = default;\x0a"
"      propagate_const(const propagate_const\x26 p) = delete;\x0a"
"      constexpr propagate_const(propagate_const\x26\x26 p) = default;\x0a"
"      template <class U> EXPLICIT constexpr propagate_const(propagate_const<_Up>\x26\x26 pu); // see below\x0a"
"      template <class U> EXPLICIT constexpr propagate_const(U\x26\x26 u); // see below\x0a"
"\x0a"
"      // \x5bpropagate_const.assignment\x5d, assignment\x0a"
"      propagate_const\x26 operator=(const propagate_const\x26 p) = delete;\x0a"
"      constexpr propagate_const\x26 operator=(propagate_const\x26\x26 p) = default;\x0a"
"      template <class U> constexpr propagate_const\x26 operator=(propagate_const<_Up>\x26\x26 pu);\x0a"
"      template <class U> constexpr propagate_const\x26 operator=(U\x26\x26 u); // see below\x0a"
"\x0a"
"      // \x5bpropagate_const.const_observers\x5d, const observers\x0a"
"      explicit constexpr operator bool() const;\x0a"
"      constexpr const element_type* operator->() const;\x0a"
"      constexpr operator const element_type*() const; // Not always defined\x0a"
"      constexpr const element_type\x26 operator*() const;\x0a"
"      constexpr const element_type* get() const;\x0a"
"\x0a"
"      // \x5bpropagate_const.non_const_observers\x5d, non-const observers\x0a"
"      constexpr element_type* operator->();\x0a"
"      constexpr operator element_type*(); // Not always defined\x0a"
"      constexpr element_type\x26 operator*();\x0a"
"      constexpr element_type* get();\x0a"
"\x0a"
"      // \x5bpropagate_const.modifiers\x5d, modifiers\x0a"
"      constexpr void swap(propagate_const\x26 pt) noexcept(see below)\x0a"
"\x0a"
"    private\x3a\x0a"
"      T t_; // exposition only\x0a"
"    };\x0a"
"\x0a"
"  } // namespace fundamentals_v2\x0a"
"  } // namespace experimental\x0a"
"\x0a"
"  // \x5bpropagate_const.hash\x5d, hash support\x0a"
"  template <class T> struct hash<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<T>>;\x0a"
"\x0a"
"  // \x5bpropagate_const.comparison_function_objects\x5d, comparison function objects\x0a"
"  template <class T> struct equal_to<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<T>>;\x0a"
"  template <class T> struct not_equal_to<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<T>>;\x0a"
"  template <class T> struct less<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<T>>;\x0a"
"  template <class T> struct greater<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<T>>;\x0a"
"  template <class T> struct less_equal<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<T>>;\x0a"
"  template <class T> struct greater_equal<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<T>>;\x0a"
"\x0a"
"} // namespace std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <experimental/__config>\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"#include <type_traits>\x0a"
"#include <utility>\x0a"
"#include <functional>\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_LFTS_V2\x0a"
"\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class propagate_const;\x0a"
"\x0a"
"template <class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"const _Up\x26 get_underlying(const propagate_const<_Up>\x26 __pu) _NOEXCEPT;\x0a"
"\x0a"
"template <class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"_Up\x26 get_underlying(propagate_const<_Up>\x26 __pu) _NOEXCEPT;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class propagate_const\x0a"
"{\x0a"
"public\x3a\x0a"
"  typedef remove_reference_t<decltype(*_VSTD\x3a\x3a""declval<_Tp\x26>())> element_type;\x0a"
"\x0a"
"  static_assert(\x21is_array<_Tp>\x3a\x3avalue,\x0a"
"      \x22Instantiation of propagate_const with an array type is ill-formed.\x22);\x0a"
"  static_assert(\x21is_reference<_Tp>\x3a\x3avalue,\x0a"
"      \x22Instantiation of propagate_const with a reference type is ill-formed.\x22);\x0a"
"  static_assert(\x21(is_pointer<_Tp>\x3a\x3avalue \x26\x26 is_function<typename remove_pointer<_Tp>\x3a\x3atype>\x3a\x3avalue),\x0a"
"      \x22Instantiation of propagate_const with a function-pointer type is ill-formed.\x22);\x0a"
"  static_assert(\x21(is_pointer<_Tp>\x3a\x3avalue \x26\x26 is_same<typename remove_cv<typename remove_pointer<_Tp>\x3a\x3atype>\x3a\x3atype, void>\x3a\x3avalue),\x0a"
"      \x22Instantiation of propagate_const with a pointer to (possibly cv-qualified) void is ill-formed.\x22);\x0a"
"\x0a"
"private\x3a\x0a"
"  template <class _Up>\x0a"
"  static _LIBCPP_CONSTEXPR element_type* __get_pointer(_Up* __u)\x0a"
"  {\x0a"
"    return __u;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  static _LIBCPP_CONSTEXPR element_type* __get_pointer(_Up\x26 __u)\x0a"
"  {\x0a"
"    return __get_pointer(__u.get());\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  static _LIBCPP_CONSTEXPR const element_type* __get_pointer(const _Up* __u)\x0a"
"  {\x0a"
"    return __u;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  static _LIBCPP_CONSTEXPR const element_type* __get_pointer(const _Up\x26 __u)\x0a"
"  {\x0a"
"    return __get_pointer(__u.get());\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  struct __is_propagate_const \x3a false_type\x0a"
"  {\x0a"
"  };\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  struct __is_propagate_const<propagate_const<_Up>> \x3a true_type\x0a"
"  {\x0a"
"  };\x0a"
"\x0a"
"  _Tp __t_;\x0a"
"\x0a"
"public\x3a\x0a"
"\x0a"
"  template <class _Up> friend _LIBCPP_CONSTEXPR const _Up\x26 \x3a\x3a_VSTD_LFTS_V2\x3a\x3aget_underlying(const propagate_const<_Up>\x26 __pu) _NOEXCEPT;\x0a"
"  template <class _Up> friend _LIBCPP_CONSTEXPR _Up\x26 \x3a\x3a_VSTD_LFTS_V2\x3a\x3aget_underlying(propagate_const<_Up>\x26 __pu) _NOEXCEPT;\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR propagate_const() = default;\x0a"
"\x0a"
"  propagate_const(const propagate_const\x26) = delete;\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR propagate_const(propagate_const\x26\x26) = default;\x0a"
"\x0a"
"  template <class _Up, enable_if_t<\x21is_convertible<_Up, _Tp>\x3a\x3avalue \x26\x26\x0a"
"                                 is_constructible<_Tp, _Up\x26\x26>\x3a\x3avalue,bool> = true>\x0a"
"  explicit _LIBCPP_CONSTEXPR propagate_const(propagate_const<_Up>\x26\x26 __pu)\x0a"
"      \x3a __t_(std\x3a\x3amove(_VSTD_LFTS_V2\x3a\x3aget_underlying(__pu)))\x0a"
"  {\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up, enable_if_t<is_convertible<_Up\x26\x26, _Tp>\x3a\x3avalue \x26\x26\x0a"
"                                 is_constructible<_Tp, _Up\x26\x26>\x3a\x3avalue,bool> = false>\x0a"
"  _LIBCPP_CONSTEXPR propagate_const(propagate_const<_Up>\x26\x26 __pu)\x0a"
"      \x3a __t_(std\x3a\x3amove(_VSTD_LFTS_V2\x3a\x3aget_underlying(__pu)))\x0a"
"  {\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up, enable_if_t<\x21is_convertible<_Up\x26\x26, _Tp>\x3a\x3avalue \x26\x26\x0a"
"                                 is_constructible<_Tp, _Up\x26\x26>\x3a\x3avalue \x26\x26\x0a"
"                                 \x21__is_propagate_const<decay_t<_Up>>\x3a\x3avalue,bool> = true>\x0a"
"  explicit _LIBCPP_CONSTEXPR propagate_const(_Up\x26\x26 __u)\x0a"
"      \x3a __t_(std\x3a\x3a""forward<_Up>(__u))\x0a"
"  {\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up, enable_if_t<is_convertible<_Up\x26\x26, _Tp>\x3a\x3avalue \x26\x26\x0a"
"                                 is_constructible<_Tp, _Up\x26\x26>\x3a\x3avalue \x26\x26\x0a"
"                                 \x21__is_propagate_const<decay_t<_Up>>\x3a\x3avalue,bool> = false>\x0a"
"  _LIBCPP_CONSTEXPR propagate_const(_Up\x26\x26 __u)\x0a"
"      \x3a __t_(std\x3a\x3a""forward<_Up>(__u))\x0a"
"  {\x0a"
"  }\x0a"
"\x0a"
"  propagate_const\x26 operator=(const propagate_const\x26) = delete;\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR propagate_const\x26 operator=(propagate_const\x26\x26) = default;\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  _LIBCPP_CONSTEXPR propagate_const\x26 operator=(propagate_const<_Up>\x26\x26 __pu)\x0a"
"  {\x0a"
"    __t_ = std\x3a\x3amove(_VSTD_LFTS_V2\x3a\x3aget_underlying(__pu));\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up, class _Vp = enable_if_t<\x21__is_propagate_const<decay_t<_Up>>\x3a\x3avalue>>\x0a"
"  _LIBCPP_CONSTEXPR propagate_const\x26 operator=(_Up\x26\x26 __u)\x0a"
"  {\x0a"
"    __t_ = std\x3a\x3a""forward<_Up>(__u);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR const element_type* get() const\x0a"
"  {\x0a"
"    return __get_pointer(__t_);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR element_type* get()\x0a"
"  {\x0a"
"    return __get_pointer(__t_);\x0a"
"  }\x0a"
"\x0a"
"  explicit _LIBCPP_CONSTEXPR operator bool() const\x0a"
"  {\x0a"
"    return get() \x21= nullptr;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR const element_type* operator->() const\x0a"
"  {\x0a"
"    return get();\x0a"
"  }\x0a"
"\x0a"
"  template <class _Tp_ = _Tp, class _Up = enable_if_t<is_convertible<\x0a"
"                                  const _Tp_, const element_type *>\x3a\x3avalue>>\x0a"
"  _LIBCPP_CONSTEXPR operator const element_type *() const {\x0a"
"    return get();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR const element_type\x26 operator*() const\x0a"
"  {\x0a"
"    return *get();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR element_type* operator->()\x0a"
"  {\x0a"
"    return get();\x0a"
"  }\x0a"
"\x0a"
"  template <class _Tp_ = _Tp, class _Up = enable_if_t<\x0a"
"                                  is_convertible<_Tp_, element_type *>\x3a\x3avalue>>\x0a"
"  _LIBCPP_CONSTEXPR operator element_type *() {\x0a"
"    return get();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR element_type\x26 operator*()\x0a"
"  {\x0a"
"    return *get();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_CONSTEXPR void swap(propagate_const\x26 __pt) _NOEXCEPT_(__is_nothrow_swappable<_Tp>\x3a\x3avalue)\x0a"
"  {\x0a"
"    using _VSTD\x3a\x3aswap;\x0a"
"    swap(__t_, __pt.__t_);\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator==(const propagate_const<_Tp>\x26 __pt, nullptr_t)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) == nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator==(nullptr_t, const propagate_const<_Tp>\x26 __pt)\x0a"
"{\x0a"
"  return nullptr == _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator\x21=(const propagate_const<_Tp>\x26 __pt, nullptr_t)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) \x21= nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator\x21=(nullptr_t, const propagate_const<_Tp>\x26 __pt)\x0a"
"{\x0a"
"  return nullptr \x21= _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator==(const propagate_const<_Tp>\x26 __pt,\x0a"
"                          const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) == _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator\x21=(const propagate_const<_Tp>\x26 __pt,\x0a"
"                          const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) \x21= _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator<(const propagate_const<_Tp>\x26 __pt,\x0a"
"                         const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) < _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator>(const propagate_const<_Tp>\x26 __pt,\x0a"
"                         const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) > _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator<=(const propagate_const<_Tp>\x26 __pt,\x0a"
"                          const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) <= _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator>=(const propagate_const<_Tp>\x26 __pt,\x0a"
"                          const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) >= _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator==(const propagate_const<_Tp>\x26 __pt, const _Up\x26 __u)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) == __u;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator\x21=(const propagate_const<_Tp>\x26 __pt, const _Up\x26 __u)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) \x21= __u;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator<(const propagate_const<_Tp>\x26 __pt, const _Up\x26 __u)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) < __u;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator>(const propagate_const<_Tp>\x26 __pt, const _Up\x26 __u)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) > __u;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator<=(const propagate_const<_Tp>\x26 __pt, const _Up\x26 __u)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) <= __u;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator>=(const propagate_const<_Tp>\x26 __pt, const _Up\x26 __u)\x0a"
"{\x0a"
"  return _VSTD_LFTS_V2\x3a\x3aget_underlying(__pt) >= __u;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator==(const _Tp\x26 __t, const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return __t == _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator\x21=(const _Tp\x26 __t, const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return __t \x21= _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator<(const _Tp\x26 __t, const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return __t < _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator>(const _Tp\x26 __t, const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return __t > _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator<=(const _Tp\x26 __t, const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return __t <= _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR bool operator>=(const _Tp\x26 __t, const propagate_const<_Up>\x26 __pu)\x0a"
"{\x0a"
"  return __t >= _VSTD_LFTS_V2\x3a\x3aget_underlying(__pu);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR void swap(propagate_const<_Tp>\x26 __pc1, propagate_const<_Tp>\x26 __pc2) _NOEXCEPT_(__is_nothrow_swappable<_Tp>\x3a\x3avalue)\x0a"
"{\x0a"
"  __pc1.swap(__pc2);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_CONSTEXPR const _Tp\x26 get_underlying(const propagate_const<_Tp>\x26 __pt) _NOEXCEPT\x0a"
"{\x0a"
"  return __pt.__t_;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_CONSTEXPR _Tp\x26 get_underlying(propagate_const<_Tp>\x26 __pt) _NOEXCEPT\x0a"
"{\x0a"
"  return __pt.__t_;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_LFTS_V2\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct hash<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>>\x0a"
"{\x0a"
"  typedef size_t result_type;\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> argument_type;\x0a"
"\x0a"
"  size_t operator()(const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc1) const\x0a"
"  {\x0a"
"    return std\x3a\x3ahash<_Tp>()(_VSTD_LFTS_V2\x3a\x3aget_underlying(__pc1));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct equal_to<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>>\x0a"
"{\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> first_argument_type;\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> second_argument_type;\x0a"
"\x0a"
"  bool operator()(const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc1,\x0a"
"      const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc2) const\x0a"
"  {\x0a"
"    return std\x3a\x3a""equal_to<_Tp>()(_VSTD_LFTS_V2\x3a\x3aget_underlying(__pc1), _VSTD_LFTS_V2\x3a\x3aget_underlying(__pc2));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct not_equal_to<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>>\x0a"
"{\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> first_argument_type;\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> second_argument_type;\x0a"
"\x0a"
"  bool operator()(const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc1,\x0a"
"      const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc2) const\x0a"
"  {\x0a"
"    return std\x3a\x3anot_equal_to<_Tp>()(_VSTD_LFTS_V2\x3a\x3aget_underlying(__pc1), _VSTD_LFTS_V2\x3a\x3aget_underlying(__pc2));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct less<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>>\x0a"
"{\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> first_argument_type;\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> second_argument_type;\x0a"
"\x0a"
"  bool operator()(const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc1,\x0a"
"      const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc2) const\x0a"
"  {\x0a"
"    return std\x3a\x3aless<_Tp>()(_VSTD_LFTS_V2\x3a\x3aget_underlying(__pc1), _VSTD_LFTS_V2\x3a\x3aget_underlying(__pc2));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct greater<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>>\x0a"
"{\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> first_argument_type;\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> second_argument_type;\x0a"
"\x0a"
"  bool operator()(const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc1,\x0a"
"      const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc2) const\x0a"
"  {\x0a"
"    return std\x3a\x3agreater<_Tp>()(_VSTD_LFTS_V2\x3a\x3aget_underlying(__pc1), _VSTD_LFTS_V2\x3a\x3aget_underlying(__pc2));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct less_equal<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>>\x0a"
"{\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> first_argument_type;\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> second_argument_type;\x0a"
"\x0a"
"  bool operator()(const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc1,\x0a"
"      const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc2) const\x0a"
"  {\x0a"
"    return std\x3a\x3aless_equal<_Tp>()(_VSTD_LFTS_V2\x3a\x3aget_underlying(__pc1), _VSTD_LFTS_V2\x3a\x3aget_underlying(__pc2));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct greater_equal<experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>>\x0a"
"{\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> first_argument_type;\x0a"
"  typedef experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp> second_argument_type;\x0a"
"\x0a"
"  bool operator()(const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc1,\x0a"
"      const experimental\x3a\x3a""fundamentals_v2\x3a\x3apropagate_const<_Tp>\x26 __pc2) const\x0a"
"  {\x0a"
"    return std\x3a\x3agreater_equal<_Tp>()(_VSTD_LFTS_V2\x3a\x3aget_underlying(__pc1), _VSTD_LFTS_V2\x3a\x3aget_underlying(__pc2));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 11\x0a"
"#endif // _LIBCPP_EXPERIMENTAL_PROPAGATE_CONST\x0a"
"\x0a"
"", 20523 ); }