#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_experimental_simd( 
"// -*- C++ -*-\x0a"
"//===------------------------------- simd ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"#ifndef _LIBCPP_EXPERIMENTAL_SIMD\x0a"
"#define _LIBCPP_EXPERIMENTAL_SIMD\x0a"
"\x0a"
"/*\x0a"
"    experimental/simd synopsis\x0a"
"\x0a"
"namespace std\x3a\x3a""experimental {\x0a"
"\x0a"
"inline namespace parallelism_v2 {\x0a"
"\x0a"
"namespace simd_abi {\x0a"
"\x0a"
"struct scalar {};\x0a"
"template <int N> struct fixed_size {};\x0a"
"template <typename T> inline constexpr int max_fixed_size = implementation-defined;\x0a"
"template <typename T> using compatible = implementation-defined;\x0a"
"template <typename T> using native = implementation-defined;\x0a"
"\x0a"
"} // simd_abi\x0a"
"\x0a"
"struct element_aligned_tag {};\x0a"
"struct vector_aligned_tag {};\x0a"
"template <size_t> struct overaligned_tag {};\x0a"
"inline constexpr element_aligned_tag element_aligned{};\x0a"
"inline constexpr vector_aligned_tag vector_aligned{};\x0a"
"template <size_t N> inline constexpr overaligned_tag<N> overaligned{};\x0a"
"\x0a"
"// traits \x5bsimd.traits\x5d\x0a"
"template <class T> struct is_abi_tag;\x0a"
"template <class T> inline constexpr bool is_abi_tag_v = is_abi_tag<T>\x3a\x3avalue;\x0a"
"\x0a"
"template <class T> struct is_simd;\x0a"
"template <class T> inline constexpr bool is_simd_v = is_simd<T>\x3a\x3avalue;\x0a"
"\x0a"
"template <class T> struct is_simd_mask;\x0a"
"template <class T> inline constexpr bool is_simd_mask_v = is_simd_mask<T>\x3a\x3avalue;\x0a"
"\x0a"
"template <class T> struct is_simd_flag_type;\x0a"
"template <class T> inline constexpr bool is_simd_flag_type_v = is_simd_flag_type<T>\x3a\x3avalue;\x0a"
"\x0a"
"template <class T, size_t N> struct abi_for_size { using type = see below; };\x0a"
"template <class T, size_t N> using abi_for_size_t = typename abi_for_size<T, N>\x3a\x3atype;\x0a"
"\x0a"
"template <class T, class Abi = simd_abi\x3a\x3a""compatible<T>> struct simd_size;\x0a"
"template <class T, class Abi = simd_abi\x3a\x3a""compatible<T>>\x0a"
"inline constexpr size_t simd_size_v = simd_size<T, Abi>\x3a\x3avalue;\x0a"
"\x0a"
"template <class T, class U = typename T\x3a\x3avalue_type> struct memory_alignment;\x0a"
"template <class T, class U = typename T\x3a\x3avalue_type>\x0a"
"inline constexpr size_t memory_alignment_v = memory_alignment<T, U>\x3a\x3avalue;\x0a"
"\x0a"
"// class template simd \x5bsimd.class\x5d\x0a"
"template <class T, class Abi = simd_abi\x3a\x3a""compatible<T>> class simd;\x0a"
"template <class T> using native_simd = simd<T, simd_abi\x3a\x3anative<T>>;\x0a"
"template <class T, int N> using fixed_size_simd = simd<T, simd_abi\x3a\x3a""fixed_size<N>>;\x0a"
"\x0a"
"// class template simd_mask \x5bsimd.mask.class\x5d\x0a"
"template <class T, class Abi = simd_abi\x3a\x3a""compatible<T>> class simd_mask;\x0a"
"template <class T> using native_simd_mask = simd_mask<T, simd_abi\x3a\x3anative<T>>;\x0a"
"template <class T, int N> using fixed_size_simd_mask = simd_mask<T, simd_abi\x3a\x3a""fixed_size<N>>;\x0a"
"\x0a"
"// casts \x5bsimd.casts\x5d\x0a"
"template <class T, class U, class Abi> see below simd_cast(const simd<U, Abi>\x26);\x0a"
"template <class T, class U, class Abi> see below static_simd_cast(const simd<U, Abi>\x26);\x0a"
"\x0a"
"template <class T, class Abi>\x0a"
"fixed_size_simd<T, simd_size_v<T, Abi>> to_fixed_size(const simd<T, Abi>\x26) noexcept;\x0a"
"template <class T, class Abi>\x0a"
"fixed_size_simd_mask<T, simd_size_v<T, Abi>> to_fixed_size(const simd_mask<T, Abi>\x26) noexcept;\x0a"
"template <class T, size_t N> native_simd<T> to_native(const fixed_size_simd<T, N>\x26) noexcept;\x0a"
"template <class T, size_t N>\x0a"
"native_simd_mask<T> to_native(const fixed_size_simd_mask<T, N>> \x26) noexcept;\x0a"
"template <class T, size_t N> simd<T> to_compatible(const fixed_size_simd<T, N>\x26) noexcept;\x0a"
"template <class T, size_t N> simd_mask<T> to_compatible(const fixed_size_simd_mask<T, N>\x26) noexcept;\x0a"
"\x0a"
"template <size_t... Sizes, class T, class Abi>\x0a"
"tuple<simd<T, abi_for_size_t<Sizes>>...> split(const simd<T, Abi>\x26);\x0a"
"template <size_t... Sizes, class T, class Abi>\x0a"
"tuple<simd_mask<T, abi_for_size_t<Sizes>>...> split(const simd_mask<T, Abi>\x26);\x0a"
"template <class V, class Abi>\x0a"
"array<V, simd_size_v<typename V\x3a\x3avalue_type, Abi> / V\x3a\x3asize()> split(\x0a"
"const simd<typename V\x3a\x3avalue_type, Abi>\x26);\x0a"
"template <class V, class Abi>\x0a"
"array<V, simd_size_v<typename V\x3a\x3avalue_type, Abi> / V\x3a\x3asize()> split(\x0a"
"const simd_mask<typename V\x3a\x3avalue_type, Abi>\x26);\x0a"
"\x0a"
"template <class T, class... Abis>\x0a"
"simd<T, abi_for_size_t<T, (simd_size_v<T, Abis> + ...)>> concat(const simd<T, Abis>\x26...);\x0a"
"template <class T, class... Abis>\x0a"
"simd_mask<T, abi_for_size_t<T, (simd_size_v<T, Abis> + ...)>> concat(const simd_mask<T, Abis>\x26...);\x0a"
"\x0a"
"// reductions \x5bsimd.mask.reductions\x5d\x0a"
"template <class T, class Abi> bool all_of(const simd_mask<T, Abi>\x26) noexcept;\x0a"
"template <class T, class Abi> bool any_of(const simd_mask<T, Abi>\x26) noexcept;\x0a"
"template <class T, class Abi> bool none_of(const simd_mask<T, Abi>\x26) noexcept;\x0a"
"template <class T, class Abi> bool some_of(const simd_mask<T, Abi>\x26) noexcept;\x0a"
"template <class T, class Abi> int popcount(const simd_mask<T, Abi>\x26) noexcept;\x0a"
"template <class T, class Abi> int find_first_set(const simd_mask<T, Abi>\x26);\x0a"
"template <class T, class Abi> int find_last_set(const simd_mask<T, Abi>\x26);\x0a"
"\x0a"
"bool all_of(see below) noexcept;\x0a"
"bool any_of(see below) noexcept;\x0a"
"bool none_of(see below) noexcept;\x0a"
"bool some_of(see below) noexcept;\x0a"
"int popcount(see below) noexcept;\x0a"
"int find_first_set(see below) noexcept;\x0a"
"int find_last_set(see below) noexcept;\x0a"
"\x0a"
"// masked assignment \x5bsimd.whereexpr\x5d\x0a"
"template <class M, class T> class const_where_expression;\x0a"
"template <class M, class T> class where_expression;\x0a"
"\x0a"
"// masked assignment \x5bsimd.mask.where\x5d\x0a"
"template <class T> struct nodeduce { using type = T; }; // exposition only\x0a"
"\x0a"
"template <class T> using nodeduce_t = typename nodeduce<T>\x3a\x3atype; // exposition only\x0a"
"\x0a"
"template <class T, class Abi>\x0a"
"where_expression<simd_mask<T, Abi>, simd<T, Abi>>\x0a"
"where(const typename simd<T, Abi>\x3a\x3amask_type\x26, simd<T, Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class T, class Abi>\x0a"
"const_where_expression<simd_mask<T, Abi>, const simd<T, Abi>>\x0a"
"where(const typename simd<T, Abi>\x3a\x3amask_type\x26, const simd<T, Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class T, class Abi>\x0a"
"where_expression<simd_mask<T, Abi>, simd_mask<T, Abi>>\x0a"
"where(const nodeduce_t<simd_mask<T, Abi>>\x26, simd_mask<T, Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class T, class Abi>\x0a"
"const_where_expression<simd_mask<T, Abi>, const simd_mask<T, Abi>>\x0a"
"where(const nodeduce_t<simd_mask<T, Abi>>\x26, const simd_mask<T, Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class T> where_expression<bool, T> where(see below k, T\x26 d) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"const_where_expression<bool, const T> where(see below k, const T\x26 d) noexcept;\x0a"
"\x0a"
"// reductions \x5bsimd.reductions\x5d\x0a"
"template <class T, class Abi, class BinaryOperation = std\x3a\x3aplus<>>\x0a"
"T reduce(const simd<T, Abi>\x26, BinaryOperation = BinaryOperation());\x0a"
"\x0a"
"template <class M, class V, class BinaryOperation>\x0a"
"typename V\x3a\x3avalue_type reduce(const const_where_expression<M, V>\x26 x,\x0a"
"typename V\x3a\x3avalue_type neutral_element, BinaryOperation binary_op);\x0a"
"\x0a"
"template <class M, class V>\x0a"
"typename V\x3a\x3avalue_type reduce(const const_where_expression<M, V>\x26 x, plus<> binary_op = plus<>());\x0a"
"\x0a"
"template <class M, class V>\x0a"
"typename V\x3a\x3avalue_type reduce(const const_where_expression<M, V>\x26 x, multiplies<> binary_op);\x0a"
"\x0a"
"template <class M, class V>\x0a"
"typename V\x3a\x3avalue_type reduce(const const_where_expression<M, V>\x26 x, bit_and<> binary_op);\x0a"
"\x0a"
"template <class M, class V>\x0a"
"typename V\x3a\x3avalue_type reduce(const const_where_expression<M, V>\x26 x, bit_or<> binary_op);\x0a"
"\x0a"
"template <class M, class V>\x0a"
"typename V\x3a\x3avalue_type reduce(const const_where_expression<M, V>\x26 x, bit_xor<> binary_op);\x0a"
"\x0a"
"template <class T, class Abi> T hmin(const simd<T, Abi>\x26);\x0a"
"template <class M, class V> T hmin(const const_where_expression<M, V>\x26);\x0a"
"template <class T, class Abi> T hmax(const simd<T, Abi>\x26);\x0a"
"template <class M, class V> T hmax(const const_where_expression<M, V>\x26);\x0a"
"\x0a"
"// algorithms \x5bsimd.alg\x5d\x0a"
"template <class T, class Abi> simd<T, Abi> min(const simd<T, Abi>\x26, const simd<T, Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class T, class Abi> simd<T, Abi> max(const simd<T, Abi>\x26, const simd<T, Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class T, class Abi>\x0a"
"std\x3a\x3apair<simd<T, Abi>, simd<T, Abi>> minmax(const simd<T, Abi>\x26, const simd<T, Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class T, class Abi>\x0a"
"simd<T, Abi> clamp(const simd<T, Abi>\x26 v, const simd<T, Abi>\x26 lo, const simd<T, Abi>\x26 hi);\x0a"
"\x0a"
"// \x5bsimd.whereexpr\x5d\x0a"
"template <class M, class T>\x0a"
"class const_where_expression {\x0a"
"  const M\x26 mask; // exposition only\x0a"
"  T\x26 data; // exposition only\x0a"
"public\x3a\x0a"
"  const_where_expression(const const_where_expression\x26) = delete;\x0a"
"  const_where_expression\x26 operator=(const const_where_expression\x26) = delete;\x0a"
"  remove_const_t<T> operator-() const \x26\x26;\x0a"
"  template <class U, class Flags> void copy_to(U* mem, Flags f) const \x26\x26;\x0a"
"};\x0a"
"\x0a"
"template <class M, class T>\x0a"
"class where_expression \x3a public const_where_expression<M, T> {\x0a"
"public\x3a\x0a"
"  where_expression(const where_expression\x26) = delete;\x0a"
"  where_expression\x26 operator=(const where_expression\x26) = delete;\x0a"
"  template <class U> void operator=(U\x26\x26 x);\x0a"
"  template <class U> void operator+=(U\x26\x26 x);\x0a"
"  template <class U> void operator-=(U\x26\x26 x);\x0a"
"  template <class U> void operator*=(U\x26\x26 x);\x0a"
"  template <class U> void operator/=(U\x26\x26 x);\x0a"
"  template <class U> void operator\x25=(U\x26\x26 x);\x0a"
"  template <class U> void operator\x26=(U\x26\x26 x);\x0a"
"  template <class U> void operator\x7c=(U\x26\x26 x);\x0a"
"  template <class U> void operator^=(U\x26\x26 x);\x0a"
"  template <class U> void operator<<=(U\x26\x26 x);\x0a"
"  template <class U> void operator>>=(U\x26\x26 x);\x0a"
"  void operator++();\x0a"
"  void operator++(int);\x0a"
"  void operator--();\x0a"
"  void operator--(int);\x0a"
"  template <class U, class Flags> void copy_from(const U* mem, Flags);\x0a"
"};\x0a"
"\x0a"
"// \x5bsimd.class\x5d\x0a"
"template <class T, class Abi> class simd {\x0a"
"public\x3a\x0a"
"  using value_type = T;\x0a"
"  using reference = see below;\x0a"
"  using mask_type = simd_mask<T, Abi>;\x0a"
"\x0a"
"  using abi_type = Abi;\x0a"
"  static constexpr size_t size() noexcept;\x0a"
"  simd() = default;\x0a"
"\x0a"
"  // implicit type conversion constructor\x0a"
"  template <class U> simd(const simd<U, simd_abi\x3a\x3a""fixed_size<size()>>\x26);\x0a"
"\x0a"
"  // implicit broadcast constructor (see below for constraints)\x0a"
"  template <class U> simd(U\x26\x26 value);\x0a"
"\x0a"
"  // generator constructor (see below for constraints)\x0a"
"  template <class G> explicit simd(G\x26\x26 gen);\x0a"
"\x0a"
"  // load constructor\x0a"
"  template <class U, class Flags> simd(const U* mem, Flags f);\x0a"
"\x0a"
"  // loads \x5bsimd.load\x5d\x0a"
"  template <class U, class Flags> void copy_from(const U* mem, Flags f);\x0a"
"\x0a"
"  // stores \x5bsimd.store\x5d\x0a"
"  template <class U, class Flags> void copy_to(U* mem, Flags f) const;\x0a"
"\x0a"
"  // scalar access \x5bsimd.subscr\x5d\x0a"
"  reference operator\x5b\x5d(size_t);\x0a"
"  value_type operator\x5b\x5d(size_t) const;\x0a"
"\x0a"
"  // unary operators \x5bsimd.unary\x5d\x0a"
"  simd\x26 operator++();\x0a"
"  simd operator++(int);\x0a"
"  simd\x26 operator--();\x0a"
"  simd operator--(int);\x0a"
"  mask_type operator\x21() const;\x0a"
"  simd operator\x7e() const; // see below\x0a"
"  simd operator+() const;\x0a"
"  simd operator-() const;\x0a"
"\x0a"
"  // binary operators \x5bsimd.binary\x5d\x0a"
"  friend simd operator+ (const simd\x26, const simd\x26);\x0a"
"  friend simd operator- (const simd\x26, const simd\x26);\x0a"
"  friend simd operator* (const simd\x26, const simd\x26);\x0a"
"  friend simd operator/ (const simd\x26, const simd\x26);\x0a"
"  friend simd operator\x25 (const simd\x26, const simd\x26);\x0a"
"  friend simd operator\x26 (const simd\x26, const simd\x26);\x0a"
"  friend simd operator\x7c (const simd\x26, const simd\x26);\x0a"
"  friend simd operator^ (const simd\x26, const simd\x26);\x0a"
"  friend simd operator<<(const simd\x26, const simd\x26);\x0a"
"  friend simd operator>>(const simd\x26, const simd\x26);\x0a"
"  friend simd operator<<(const simd\x26, int);\x0a"
"  friend simd operator>>(const simd\x26, int);\x0a"
"\x0a"
"  // compound assignment \x5bsimd.cassign\x5d\x0a"
"  friend simd\x26 operator+= (simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator-= (simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator*= (simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator/= (simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator\x25= (simd\x26, const simd\x26);\x0a"
"\x0a"
"  friend simd\x26 operator\x26= (simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator\x7c= (simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator^= (simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator<<=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator>>=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator<<=(simd\x26, int);\x0a"
"  friend simd\x26 operator>>=(simd\x26, int);\x0a"
"\x0a"
"  // compares \x5bsimd.comparison\x5d\x0a"
"  friend mask_type operator==(const simd\x26, const simd\x26);\x0a"
"  friend mask_type operator\x21=(const simd\x26, const simd\x26);\x0a"
"  friend mask_type operator>=(const simd\x26, const simd\x26);\x0a"
"  friend mask_type operator<=(const simd\x26, const simd\x26);\x0a"
"  friend mask_type operator> (const simd\x26, const simd\x26);\x0a"
"  friend mask_type operator< (const simd\x26, const simd\x26);\x0a"
"};\x0a"
"\x0a"
"// \x5bsimd.math\x5d\x0a"
"template <class Abi> using scharv = simd<signed char, Abi>; // exposition only\x0a"
"template <class Abi> using shortv = simd<short, Abi>; // exposition only\x0a"
"template <class Abi> using intv = simd<int, Abi>; // exposition only\x0a"
"template <class Abi> using longv = simd<long int, Abi>; // exposition only\x0a"
"template <class Abi> using llongv = simd<long long int, Abi>; // exposition only\x0a"
"template <class Abi> using floatv = simd<float, Abi>; // exposition only\x0a"
"template <class Abi> using doublev = simd<double, Abi>; // exposition only\x0a"
"template <class Abi> using ldoublev = simd<long double, Abi>; // exposition only\x0a"
"template <class T, class V> using samesize = fixed_size_simd<T, V\x3a\x3asize()>; // exposition only\x0a"
"\x0a"
"template <class Abi> floatv<Abi> acos(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> acos(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> acos(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> asin(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> asin(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> asin(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> atan(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> atan(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> atan(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> atan2(floatv<Abi> y, floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> atan2(doublev<Abi> y, doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> atan2(ldoublev<Abi> y, ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> cos(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> cos(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> cos(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> sin(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> sin(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> sin(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> tan(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> tan(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> tan(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> acosh(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> acosh(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> acosh(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> asinh(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> asinh(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> asinh(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> atanh(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> atanh(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> atanh(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> cosh(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> cosh(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> cosh(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> sinh(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> sinh(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> sinh(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> tanh(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> tanh(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> tanh(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> exp(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> exp(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> exp(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> exp2(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> exp2(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> exp2(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> expm1(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> expm1(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> expm1(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> frexp(floatv<Abi> value, samesize<int, floatv<Abi>>* exp);\x0a"
"template <class Abi> doublev<Abi> frexp(doublev<Abi> value, samesize<int, doublev<Abi>>* exp);\x0a"
"template <class Abi> ldoublev<Abi> frexp(ldoublev<Abi> value, samesize<int, ldoublev<Abi>>* exp);\x0a"
"\x0a"
"template <class Abi> samesize<int, floatv<Abi>> ilogb(floatv<Abi> x);\x0a"
"template <class Abi> samesize<int, doublev<Abi>> ilogb(doublev<Abi> x);\x0a"
"template <class Abi> samesize<int, ldoublev<Abi>> ilogb(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> ldexp(floatv<Abi> x, samesize<int, floatv<Abi>> exp);\x0a"
"template <class Abi> doublev<Abi> ldexp(doublev<Abi> x, samesize<int, doublev<Abi>> exp);\x0a"
"template <class Abi> ldoublev<Abi> ldexp(ldoublev<Abi> x, samesize<int, ldoublev<Abi>> exp);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> log(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> log(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> log(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> log10(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> log10(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> log10(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> log1p(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> log1p(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> log1p(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> log2(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> log2(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> log2(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> logb(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> logb(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> logb(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> modf(floatv<Abi> value, floatv<Abi>* iptr);\x0a"
"template <class Abi> doublev<Abi> modf(doublev<Abi> value, doublev<Abi>* iptr);\x0a"
"template <class Abi> ldoublev<Abi> modf(ldoublev<Abi> value, ldoublev<Abi>* iptr);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> scalbn(floatv<Abi> x, samesize<int, floatv<Abi>> n);\x0a"
"template <class Abi> doublev<Abi> scalbn(doublev<Abi> x, samesize<int, doublev<Abi>> n);\x0a"
"template <class Abi> ldoublev<Abi> scalbn(ldoublev<Abi> x, samesize<int, ldoublev<Abi>> n);\x0a"
"template <class Abi> floatv<Abi> scalbln(floatv<Abi> x, samesize<long int, floatv<Abi>> n);\x0a"
"template <class Abi> doublev<Abi> scalbln(doublev<Abi> x, samesize<long int, doublev<Abi>> n);\x0a"
"template <class Abi> ldoublev<Abi> scalbln(ldoublev<Abi> x, samesize<long int, ldoublev<Abi>> n);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> cbrt(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> cbrt(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> cbrt(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> scharv<Abi> abs(scharv<Abi> j);\x0a"
"template <class Abi> shortv<Abi> abs(shortv<Abi> j);\x0a"
"template <class Abi> intv<Abi> abs(intv<Abi> j);\x0a"
"template <class Abi> longv<Abi> abs(longv<Abi> j);\x0a"
"template <class Abi> llongv<Abi> abs(llongv<Abi> j);\x0a"
"template <class Abi> floatv<Abi> abs(floatv<Abi> j);\x0a"
"template <class Abi> doublev<Abi> abs(doublev<Abi> j);\x0a"
"template <class Abi> ldoublev<Abi> abs(ldoublev<Abi> j);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> hypot(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> doublev<Abi> hypot(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> ldoublev<Abi> hypot(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> floatv<Abi> hypot(floatv<Abi> x, floatv<Abi> y, floatv<Abi> z);\x0a"
"template <class Abi> doublev<Abi> hypot(doublev<Abi> x, doublev<Abi> y, doublev<Abi> z);\x0a"
"template <class Abi> ldoublev<Abi> hypot(ldoublev<Abi> x, ldoublev<Abi> y, ldoublev<Abi> z);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> pow(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> doublev<Abi> pow(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> ldoublev<Abi> pow(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> sqrt(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> sqrt(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> sqrt(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> erf(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> erf(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> erf(ldoublev<Abi> x);\x0a"
"template <class Abi> floatv<Abi> erfc(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> erfc(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> erfc(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> lgamma(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> lgamma(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> lgamma(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> tgamma(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> tgamma(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> tgamma(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> ceil(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> ceil(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> ceil(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> floor(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> floor(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> floor(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> nearbyint(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> nearbyint(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> nearbyint(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> rint(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> rint(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> rint(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> samesize<long int, floatv<Abi>> lrint(floatv<Abi> x);\x0a"
"template <class Abi> samesize<long int, doublev<Abi>> lrint(doublev<Abi> x);\x0a"
"template <class Abi> samesize<long int, ldoublev<Abi>> lrint(ldoublev<Abi> x);\x0a"
"template <class Abi> samesize<long long int, floatv<Abi>> llrint(floatv<Abi> x);\x0a"
"template <class Abi> samesize<long long int, doublev<Abi>> llrint(doublev<Abi> x);\x0a"
"template <class Abi> samesize<long long int, ldoublev<Abi>> llrint(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> round(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> round(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> round(ldoublev<Abi> x);\x0a"
"template <class Abi> samesize<long int, floatv<Abi>> lround(floatv<Abi> x);\x0a"
"template <class Abi> samesize<long int, doublev<Abi>> lround(doublev<Abi> x);\x0a"
"template <class Abi> samesize<long int, ldoublev<Abi>> lround(ldoublev<Abi> x);\x0a"
"template <class Abi> samesize<long long int, floatv<Abi>> llround(floatv<Abi> x);\x0a"
"template <class Abi> samesize<long long int, doublev<Abi>> llround(doublev<Abi> x);\x0a"
"template <class Abi> samesize<long long int, ldoublev<Abi>> llround(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> trunc(floatv<Abi> x);\x0a"
"template <class Abi> doublev<Abi> trunc(doublev<Abi> x);\x0a"
"template <class Abi> ldoublev<Abi> trunc(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> fmod(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> doublev<Abi> fmod(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> ldoublev<Abi> fmod(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> remainder(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> doublev<Abi> remainder(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> ldoublev<Abi> remainder(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> remquo(floatv<Abi> x, floatv<Abi> y, samesize<int, floatv<Abi>>* quo);\x0a"
"template <class Abi> doublev<Abi> remquo(doublev<Abi> x, doublev<Abi> y, samesize<int, doublev<Abi>>* quo);\x0a"
"template <class Abi> ldoublev<Abi> remquo(ldoublev<Abi> x, ldoublev<Abi> y, samesize<int, ldoublev<Abi>>* quo);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> copysign(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> doublev<Abi> copysign(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> ldoublev<Abi> copysign(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> doublev<Abi> nan(const char* tagp);\x0a"
"template <class Abi> floatv<Abi> nanf(const char* tagp);\x0a"
"template <class Abi> ldoublev<Abi> nanl(const char* tagp);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> nextafter(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> doublev<Abi> nextafter(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> ldoublev<Abi> nextafter(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> nexttoward(floatv<Abi> x, ldoublev<Abi> y);\x0a"
"template <class Abi> doublev<Abi> nexttoward(doublev<Abi> x, ldoublev<Abi> y);\x0a"
"template <class Abi> ldoublev<Abi> nexttoward(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> fdim(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> doublev<Abi> fdim(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> ldoublev<Abi> fdim(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> fmax(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> doublev<Abi> fmax(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> ldoublev<Abi> fmax(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> fmin(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> doublev<Abi> fmin(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> ldoublev<Abi> fmin(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> floatv<Abi> fma(floatv<Abi> x, floatv<Abi> y, floatv<Abi> z);\x0a"
"template <class Abi> doublev<Abi> fma(doublev<Abi> x, doublev<Abi> y, doublev<Abi> z);\x0a"
"template <class Abi> ldoublev<Abi> fma(ldoublev<Abi> x, ldoublev<Abi> y, ldoublev<Abi> z);\x0a"
"\x0a"
"template <class Abi> samesize<int, floatv<Abi>> fpclassify(floatv<Abi> x);\x0a"
"template <class Abi> samesize<int, doublev<Abi>> fpclassify(doublev<Abi> x);\x0a"
"template <class Abi> samesize<int, ldoublev<Abi>> fpclassify(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> isfinite(floatv<Abi> x);\x0a"
"template <class Abi> simd_mask<double, Abi> isfinite(doublev<Abi> x);\x0a"
"template <class Abi> simd_mask<long double, Abi> isfinite(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> isinf(floatv<Abi> x);\x0a"
"template <class Abi> simd_mask<double, Abi> isinf(doublev<Abi> x);\x0a"
"template <class Abi> simd_mask<long double, Abi> isinf(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> isnan(floatv<Abi> x);\x0a"
"template <class Abi> simd_mask<double, Abi> isnan(doublev<Abi> x);\x0a"
"template <class Abi> simd_mask<long double, Abi> isnan(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> isnormal(floatv<Abi> x);\x0a"
"template <class Abi> simd_mask<double, Abi> isnormal(doublev<Abi> x);\x0a"
"template <class Abi> simd_mask<long double, Abi> isnormal(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> signbit(floatv<Abi> x);\x0a"
"template <class Abi> simd_mask<double, Abi> signbit(doublev<Abi> x);\x0a"
"template <class Abi> simd_mask<long double, Abi> signbit(ldoublev<Abi> x);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> isgreater(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> simd_mask<double, Abi> isgreater(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> simd_mask<long double, Abi> isgreater(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> isgreaterequal(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> simd_mask<double, Abi> isgreaterequal(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> simd_mask<long double, Abi> isgreaterequal(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> isless(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> simd_mask<double, Abi> isless(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> simd_mask<long double, Abi> isless(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> islessequal(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> simd_mask<double, Abi> islessequal(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> simd_mask<long double, Abi> islessequal(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> islessgreater(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> simd_mask<double, Abi> islessgreater(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> simd_mask<long double, Abi> islessgreater(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class Abi> simd_mask<float, Abi> isunordered(floatv<Abi> x, floatv<Abi> y);\x0a"
"template <class Abi> simd_mask<double, Abi> isunordered(doublev<Abi> x, doublev<Abi> y);\x0a"
"template <class Abi> simd_mask<long double, Abi> isunordered(ldoublev<Abi> x, ldoublev<Abi> y);\x0a"
"\x0a"
"template <class V> struct simd_div_t { V quot, rem; };\x0a"
"template <class Abi> simd_div_t<scharv<Abi>> div(scharv<Abi> numer, scharv<Abi> denom);\x0a"
"template <class Abi> simd_div_t<shortv<Abi>> div(shortv<Abi> numer, shortv<Abi> denom);\x0a"
"template <class Abi> simd_div_t<intv<Abi>> div(intv<Abi> numer, intv<Abi> denom);\x0a"
"template <class Abi> simd_div_t<longv<Abi>> div(longv<Abi> numer, longv<Abi> denom);\x0a"
"template <class Abi> simd_div_t<llongv<Abi>> div(llongv<Abi> numer, llongv<Abi> denom);\x0a"
"\x0a"
"// \x5bsimd.mask.class\x5d\x0a"
"template <class T, class Abi>\x0a"
"class simd_mask {\x0a"
"public\x3a\x0a"
"  using value_type = bool;\x0a"
"  using reference = see below;\x0a"
"  using simd_type = simd<T, Abi>;\x0a"
"  using abi_type = Abi;\x0a"
"  static constexpr size_t size() noexcept;\x0a"
"  simd_mask() = default;\x0a"
"\x0a"
"  // broadcast constructor\x0a"
"  explicit simd_mask(value_type) noexcept;\x0a"
"\x0a"
"  // implicit type conversion constructor\x0a"
"  template <class U> simd_mask(const simd_mask<U, simd_abi\x3a\x3a""fixed_size<size()>>\x26) noexcept;\x0a"
"\x0a"
"  // load constructor\x0a"
"  template <class Flags> simd_mask(const value_type* mem, Flags);\x0a"
"\x0a"
"  // loads \x5bsimd.mask.copy\x5d\x0a"
"  template <class Flags> void copy_from(const value_type* mem, Flags);\x0a"
"  template <class Flags> void copy_to(value_type* mem, Flags) const;\x0a"
"\x0a"
"  // scalar access \x5bsimd.mask.subscr\x5d\x0a"
"  reference operator\x5b\x5d(size_t);\x0a"
"  value_type operator\x5b\x5d(size_t) const;\x0a"
"\x0a"
"  // unary operators \x5bsimd.mask.unary\x5d\x0a"
"  simd_mask operator\x21() const noexcept;\x0a"
"\x0a"
"  // simd_mask binary operators \x5bsimd.mask.binary\x5d\x0a"
"  friend simd_mask operator\x26\x26(const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask operator\x7c\x7c(const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask operator\x26 (const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask operator\x7c (const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask operator^ (const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"\x0a"
"  // simd_mask compound assignment \x5bsimd.mask.cassign\x5d\x0a"
"  friend simd_mask\x26 operator\x26=(simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask\x26 operator\x7c=(simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask\x26 operator^=(simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"\x0a"
"  // simd_mask compares \x5bsimd.mask.comparison\x5d\x0a"
"  friend simd_mask operator==(const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask operator\x21=(const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"};\x0a"
"\x0a"
"} // parallelism_v2\x0a"
"} // std\x3a\x3a""experimental\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <experimental/__config>\x0a"
"#include <algorithm>\x0a"
"#include <array>\x0a"
"#include <cstddef>\x0a"
"#include <functional>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_EXPERIMENTAL_SIMD\x0a"
"\x0a"
"#if _LIBCPP_STD_VER >= 17\x0a"
"\x0a"
"enum class _StorageKind {\x0a"
"  _Scalar,\x0a"
"  _Array,\x0a"
"  _VecExt,\x0a"
"};\x0a"
"\x0a"
"template <_StorageKind __kind, int _Np>\x0a"
"struct __simd_abi {};\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"class __simd_storage {};\x0a"
"\x0a"
"template <class _Tp, int __num_element>\x0a"
"class __simd_storage<_Tp, __simd_abi<_StorageKind\x3a\x3a_Array, __num_element>> {\x0a"
"  std\x3a\x3a""array<_Tp, __num_element> __storage_;\x0a"
"\x0a"
"  template <class, class>\x0a"
"  friend struct simd;\x0a"
"\x0a"
"  template <class, class>\x0a"
"  friend struct simd_mask;\x0a"
"\x0a"
"public\x3a\x0a"
"  _Tp __get(size_t __index) const noexcept { return __storage_\x5b__index\x5d; };\x0a"
"  void __set(size_t __index, _Tp __val) noexcept {\x0a"
"    __storage_\x5b__index\x5d = __val;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class __simd_storage<_Tp, __simd_abi<_StorageKind\x3a\x3a_Scalar, 1>> {\x0a"
"  _Tp __storage_;\x0a"
"\x0a"
"  template <class, class>\x0a"
"  friend struct simd;\x0a"
"\x0a"
"  template <class, class>\x0a"
"  friend struct simd_mask;\x0a"
"\x0a"
"public\x3a\x0a"
"  _Tp __get(size_t __index) const noexcept { return (\x26__storage_)\x5b__index\x5d; };\x0a"
"  void __set(size_t __index, _Tp __val) noexcept {\x0a"
"    (\x26__storage_)\x5b__index\x5d = __val;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VECTOR_EXTENSION\x0a"
"\x0a"
"constexpr size_t __floor_pow_of_2(size_t __val) {\x0a"
"  return ((__val - 1) \x26 __val) == 0 \x3f __val\x0a"
"                                    \x3a __floor_pow_of_2((__val - 1) \x26 __val);\x0a"
"}\x0a"
"\x0a"
"constexpr size_t __ceil_pow_of_2(size_t __val) {\x0a"
"  return __val == 1 \x3f 1 \x3a __floor_pow_of_2(__val - 1) << 1;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t __bytes>\x0a"
"struct __vec_ext_traits {\x0a"
"#if \x21""defined(_LIBCPP_COMPILER_CLANG)\x0a"
"  typedef _Tp type __attribute__((vector_size(__ceil_pow_of_2(__bytes))));\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"#if defined(_LIBCPP_COMPILER_CLANG)\x0a"
"#define _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, _NUM_ELEMENT)                        \x5c\x0a"
"  template <>                                                                  \x5c\x0a"
"  struct __vec_ext_traits<_TYPE, sizeof(_TYPE) * _NUM_ELEMENT> {               \x5c\x0a"
"    using type =                                                               \x5c\x0a"
"        _TYPE __attribute__((vector_size(sizeof(_TYPE) * _NUM_ELEMENT)));      \x5c\x0a"
"  }\x0a"
"\x0a"
"#define _LIBCPP_SPECIALIZE_VEC_EXT_32(_TYPE)                                   \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 1);                                        \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 2);                                        \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 3);                                        \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 4);                                        \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 5);                                        \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 6);                                        \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 7);                                        \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 8);                                        \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 9);                                        \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 10);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 11);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 12);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 13);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 14);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 15);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 16);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 17);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 18);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 19);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 20);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 21);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 22);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 23);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 24);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 25);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 26);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 27);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 28);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 29);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 30);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 31);                                       \x5c\x0a"
"  _LIBCPP_SPECIALIZE_VEC_EXT(_TYPE, 32);\x0a"
"\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(char);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(char16_t);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(char32_t);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(wchar_t);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(signed char);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(signed short);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(signed int);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(signed long);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(signed long long);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(unsigned char);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(unsigned short);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(unsigned int);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(unsigned long);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(unsigned long long);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(float);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(double);\x0a"
"_LIBCPP_SPECIALIZE_VEC_EXT_32(long double);\x0a"
"\x0a"
"#undef _LIBCPP_SPECIALIZE_VEC_EXT_32\x0a"
"#undef _LIBCPP_SPECIALIZE_VEC_EXT\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, int __num_element>\x0a"
"class __simd_storage<_Tp, __simd_abi<_StorageKind\x3a\x3a_VecExt, __num_element>> {\x0a"
"  using _StorageType =\x0a"
"      typename __vec_ext_traits<_Tp, sizeof(_Tp) * __num_element>\x3a\x3atype;\x0a"
"\x0a"
"  _StorageType __storage_;\x0a"
"\x0a"
"  template <class, class>\x0a"
"  friend struct simd;\x0a"
"\x0a"
"  template <class, class>\x0a"
"  friend struct simd_mask;\x0a"
"\x0a"
"public\x3a\x0a"
"  _Tp __get(size_t __index) const noexcept { return __storage_\x5b__index\x5d; };\x0a"
"  void __set(size_t __index, _Tp __val) noexcept {\x0a"
"    __storage_\x5b__index\x5d = __val;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"#endif // _LIBCPP_HAS_NO_VECTOR_EXTENSION\x0a"
"\x0a"
"template <class _Vp, class _Tp, class _Abi>\x0a"
"class __simd_reference {\x0a"
"  static_assert(std\x3a\x3ais_same<_Vp, _Tp>\x3a\x3avalue, \x22\x22);\x0a"
"\x0a"
"  template <class, class>\x0a"
"  friend struct simd;\x0a"
"\x0a"
"  template <class, class>\x0a"
"  friend struct simd_mask;\x0a"
"\x0a"
"  __simd_storage<_Tp, _Abi>* __ptr_;\x0a"
"  size_t __index_;\x0a"
"\x0a"
"  __simd_reference(__simd_storage<_Tp, _Abi>* __ptr, size_t __index)\x0a"
"      \x3a __ptr_(__ptr), __index_(__index) {}\x0a"
"\x0a"
"  __simd_reference(const __simd_reference\x26) = default;\x0a"
"\x0a"
"public\x3a\x0a"
"  __simd_reference() = delete;\x0a"
"  __simd_reference\x26 operator=(const __simd_reference\x26) = delete;\x0a"
"\x0a"
"  operator _Vp() const { return __ptr_->__get(__index_); }\x0a"
"\x0a"
"  __simd_reference operator=(_Vp __value) \x26\x26 {\x0a"
"    __ptr_->__set(__index_, __value);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator++() \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) + 1;\x0a"
"  }\x0a"
"\x0a"
"  _Vp operator++(int) \x26\x26 {\x0a"
"    auto __val = __ptr_->__get(__index_);\x0a"
"    __ptr_->__set(__index_, __val + 1);\x0a"
"    return __val;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator--() \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) - 1;\x0a"
"  }\x0a"
"\x0a"
"  _Vp operator--(int) \x26\x26 {\x0a"
"    auto __val = __ptr_->__get(__index_);\x0a"
"    __ptr_->__set(__index_, __val - 1);\x0a"
"    return __val;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator+=(_Vp __value) \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) + __value;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator-=(_Vp __value) \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) - __value;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator*=(_Vp __value) \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) * __value;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator/=(_Vp __value) \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) / __value;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator\x25=(_Vp __value) \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) \x25 __value;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator>>=(_Vp __value) \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) >> __value;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator<<=(_Vp __value) \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) << __value;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator\x26=(_Vp __value) \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) \x26 __value;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator\x7c=(_Vp __value) \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) \x7c __value;\x0a"
"  }\x0a"
"\x0a"
"  __simd_reference operator^=(_Vp __value) \x26\x26 {\x0a"
"    return std\x3a\x3amove(*this) = __ptr_->__get(__index_) ^ __value;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _To, class _From>\x0a"
"constexpr decltype(_To{std\x3a\x3a""declval<_From>()}, true)\x0a"
"__is_non_narrowing_convertible_impl(_From) {\x0a"
"  return true;\x0a"
"}\x0a"
"\x0a"
"template <class _To>\x0a"
"constexpr bool __is_non_narrowing_convertible_impl(...) {\x0a"
"  return false;\x0a"
"}\x0a"
"\x0a"
"template <class _From, class _To>\x0a"
"constexpr typename std\x3a\x3a""enable_if<std\x3a\x3ais_arithmetic<_To>\x3a\x3avalue \x26\x26\x0a"
"                                      std\x3a\x3ais_arithmetic<_From>\x3a\x3avalue,\x0a"
"                                  bool>\x3a\x3atype\x0a"
"__is_non_narrowing_arithmetic_convertible() {\x0a"
"  return __is_non_narrowing_convertible_impl<_To>(_From{});\x0a"
"}\x0a"
"\x0a"
"template <class _From, class _To>\x0a"
"constexpr typename std\x3a\x3a""enable_if<\x21(std\x3a\x3ais_arithmetic<_To>\x3a\x3avalue \x26\x26\x0a"
"                                    std\x3a\x3ais_arithmetic<_From>\x3a\x3avalue),\x0a"
"                                  bool>\x3a\x3atype\x0a"
"__is_non_narrowing_arithmetic_convertible() {\x0a"
"  return false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"constexpr _Tp __variadic_sum() {\x0a"
"  return _Tp{};\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up, class... _Args>\x0a"
"constexpr _Tp __variadic_sum(_Up __first, _Args... __rest) {\x0a"
"  return static_cast<_Tp>(__first) + __variadic_sum<_Tp>(__rest...);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __nodeduce {\x0a"
"  using type = _Tp;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"constexpr bool __vectorizable() {\x0a"
"  return std\x3a\x3ais_arithmetic<_Tp>\x3a\x3avalue \x26\x26 \x21std\x3a\x3ais_const<_Tp>\x3a\x3avalue \x26\x26\x0a"
"         \x21std\x3a\x3ais_volatile<_Tp>\x3a\x3avalue \x26\x26 \x21std\x3a\x3ais_same<_Tp, bool>\x3a\x3avalue;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_EXPERIMENTAL_SIMD\x0a"
"_LIBCPP_BEGIN_NAMESPACE_EXPERIMENTAL_SIMD_ABI\x0a"
"\x0a"
"using scalar = __simd_abi<_StorageKind\x3a\x3a_Scalar, 1>;\x0a"
"\x0a"
"template <int _Np>\x0a"
"using fixed_size = __simd_abi<_StorageKind\x3a\x3a_Array, _Np>;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr size_t max_fixed_size = 32;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"using compatible = fixed_size<16 / sizeof(_Tp)>;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VECTOR_EXTENSION\x0a"
"template <class _Tp>\x0a"
"using native = __simd_abi<_StorageKind\x3a\x3a_VecExt,\x0a"
"                          _LIBCPP_NATIVE_SIMD_WIDTH_IN_BYTES / sizeof(_Tp)>;\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"using native =\x0a"
"    fixed_size<_Tp, _LIBCPP_NATIVE_SIMD_WIDTH_IN_BYTES / sizeof(_Tp)>;\x0a"
"#endif // _LIBCPP_HAS_NO_VECTOR_EXTENSION\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_EXPERIMENTAL_SIMD_ABI\x0a"
"_LIBCPP_BEGIN_NAMESPACE_EXPERIMENTAL_SIMD\x0a"
"\x0a"
"template <class _Tp, class _Abi = simd_abi\x3a\x3a""compatible<_Tp>>\x0a"
"class simd;\x0a"
"template <class _Tp, class _Abi = simd_abi\x3a\x3a""compatible<_Tp>>\x0a"
"class simd_mask;\x0a"
"\x0a"
"struct element_aligned_tag {};\x0a"
"struct vector_aligned_tag {};\x0a"
"template <size_t>\x0a"
"struct overaligned_tag {};\x0a"
"_LIBCPP_INLINE_VAR constexpr element_aligned_tag element_aligned{};\x0a"
"_LIBCPP_INLINE_VAR constexpr vector_aligned_tag vector_aligned{};\x0a"
"template <size_t _Np>\x0a"
"_LIBCPP_INLINE_VAR constexpr overaligned_tag<_Np> overaligned{};\x0a"
"\x0a"
"// traits \x5bsimd.traits\x5d\x0a"
"template <class _Tp>\x0a"
"struct is_abi_tag \x3a std\x3a\x3aintegral_constant<bool, false> {};\x0a"
"\x0a"
"template <_StorageKind __kind, int _Np>\x0a"
"struct is_abi_tag<__simd_abi<__kind, _Np>>\x0a"
"    \x3a std\x3a\x3aintegral_constant<bool, true> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct is_simd \x3a std\x3a\x3aintegral_constant<bool, false> {};\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"struct is_simd<simd<_Tp, _Abi>> \x3a std\x3a\x3aintegral_constant<bool, true> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct is_simd_mask \x3a std\x3a\x3aintegral_constant<bool, false> {};\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"struct is_simd_mask<simd_mask<_Tp, _Abi>> \x3a std\x3a\x3aintegral_constant<bool, true> {\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct is_simd_flag_type \x3a std\x3a\x3aintegral_constant<bool, false> {};\x0a"
"\x0a"
"template <>\x0a"
"struct is_simd_flag_type<element_aligned_tag>\x0a"
"    \x3a std\x3a\x3aintegral_constant<bool, true> {};\x0a"
"\x0a"
"template <>\x0a"
"struct is_simd_flag_type<vector_aligned_tag>\x0a"
"    \x3a std\x3a\x3aintegral_constant<bool, true> {};\x0a"
"\x0a"
"template <size_t _Align>\x0a"
"struct is_simd_flag_type<overaligned_tag<_Align>>\x0a"
"    \x3a std\x3a\x3aintegral_constant<bool, true> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_abi_tag_v = is_abi_tag<_Tp>\x3a\x3avalue;\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_simd_v = is_simd<_Tp>\x3a\x3avalue;\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_simd_mask_v = is_simd_mask<_Tp>\x3a\x3avalue;\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_simd_flag_type_v =\x0a"
"    is_simd_flag_type<_Tp>\x3a\x3avalue;\x0a"
"template <class _Tp, size_t _Np>\x0a"
"struct abi_for_size {\x0a"
"  using type = simd_abi\x3a\x3a""fixed_size<_Np>;\x0a"
"};\x0a"
"template <class _Tp, size_t _Np>\x0a"
"using abi_for_size_t = typename abi_for_size<_Tp, _Np>\x3a\x3atype;\x0a"
"\x0a"
"template <class _Tp, class _Abi = simd_abi\x3a\x3a""compatible<_Tp>>\x0a"
"struct simd_size;\x0a"
"\x0a"
"template <class _Tp, _StorageKind __kind, int _Np>\x0a"
"struct simd_size<_Tp, __simd_abi<__kind, _Np>>\x0a"
"    \x3a std\x3a\x3aintegral_constant<size_t, _Np> {\x0a"
"  static_assert(\x0a"
"      std\x3a\x3ais_arithmetic<_Tp>\x3a\x3avalue \x26\x26\x0a"
"          \x21std\x3a\x3ais_same<typename std\x3a\x3aremove_const<_Tp>\x3a\x3atype, bool>\x3a\x3avalue,\x0a"
"      \x22""Element type should be vectorizable\x22);\x0a"
"};\x0a"
"\x0a"
"// TODO\x3a implement it.\x0a"
"template <class _Tp, class _Up = typename _Tp\x3a\x3avalue_type>\x0a"
"struct memory_alignment;\x0a"
"\x0a"
"template <class _Tp, class _Abi = simd_abi\x3a\x3a""compatible<_Tp>>\x0a"
"_LIBCPP_INLINE_VAR constexpr size_t simd_size_v = simd_size<_Tp, _Abi>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Tp, class _Up = typename _Tp\x3a\x3avalue_type>\x0a"
"_LIBCPP_INLINE_VAR constexpr size_t memory_alignment_v =\x0a"
"    memory_alignment<_Tp, _Up>\x3a\x3avalue;\x0a"
"\x0a"
"// class template simd \x5bsimd.class\x5d\x0a"
"template <class _Tp>\x0a"
"using native_simd = simd<_Tp, simd_abi\x3a\x3anative<_Tp>>;\x0a"
"template <class _Tp, int _Np>\x0a"
"using fixed_size_simd = simd<_Tp, simd_abi\x3a\x3a""fixed_size<_Np>>;\x0a"
"\x0a"
"// class template simd_mask \x5bsimd.mask.class\x5d\x0a"
"template <class _Tp>\x0a"
"using native_simd_mask = simd_mask<_Tp, simd_abi\x3a\x3anative<_Tp>>;\x0a"
"\x0a"
"template <class _Tp, int _Np>\x0a"
"using fixed_size_simd_mask = simd_mask<_Tp, simd_abi\x3a\x3a""fixed_size<_Np>>;\x0a"
"\x0a"
"// casts \x5bsimd.casts\x5d\x0a"
"template <class _Tp>\x0a"
"struct __static_simd_cast_traits {\x0a"
"  template <class _Up, class _Abi>\x0a"
"  static simd<_Tp, _Abi> __apply(const simd<_Up, _Abi>\x26 __v);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _NewAbi>\x0a"
"struct __static_simd_cast_traits<simd<_Tp, _NewAbi>> {\x0a"
"  template <class _Up, class _Abi>\x0a"
"  static typename std\x3a\x3a""enable_if<simd<_Up, _Abi>\x3a\x3asize() ==\x0a"
"                                     simd<_Tp, _NewAbi>\x3a\x3asize(),\x0a"
"                                 simd<_Tp, _NewAbi>>\x3a\x3atype\x0a"
"  __apply(const simd<_Up, _Abi>\x26 __v);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __simd_cast_traits {\x0a"
"  template <class _Up, class _Abi>\x0a"
"  static typename std\x3a\x3a""enable_if<\x0a"
"      __is_non_narrowing_arithmetic_convertible<_Up, _Tp>(),\x0a"
"      simd<_Tp, _Abi>>\x3a\x3atype\x0a"
"  __apply(const simd<_Up, _Abi>\x26 __v);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _NewAbi>\x0a"
"struct __simd_cast_traits<simd<_Tp, _NewAbi>> {\x0a"
"  template <class _Up, class _Abi>\x0a"
"  static typename std\x3a\x3a""enable_if<\x0a"
"      __is_non_narrowing_arithmetic_convertible<_Up, _Tp>() \x26\x26\x0a"
"          simd<_Up, _Abi>\x3a\x3asize() == simd<_Tp, _NewAbi>\x3a\x3asize(),\x0a"
"      simd<_Tp, _NewAbi>>\x3a\x3atype\x0a"
"  __apply(const simd<_Up, _Abi>\x26 __v);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up, class _Abi>\x0a"
"auto simd_cast(const simd<_Up, _Abi>\x26 __v)\x0a"
"    -> decltype(__simd_cast_traits<_Tp>\x3a\x3a__apply(__v)) {\x0a"
"  return __simd_cast_traits<_Tp>\x3a\x3a__apply(__v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up, class _Abi>\x0a"
"auto static_simd_cast(const simd<_Up, _Abi>\x26 __v)\x0a"
"    -> decltype(__static_simd_cast_traits<_Tp>\x3a\x3a__apply(__v)) {\x0a"
"  return __static_simd_cast_traits<_Tp>\x3a\x3a__apply(__v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"fixed_size_simd<_Tp, simd_size<_Tp, _Abi>\x3a\x3avalue>\x0a"
"to_fixed_size(const simd<_Tp, _Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"fixed_size_simd_mask<_Tp, simd_size<_Tp, _Abi>\x3a\x3avalue>\x0a"
"to_fixed_size(const simd_mask<_Tp, _Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, size_t _Np>\x0a"
"native_simd<_Tp> to_native(const fixed_size_simd<_Tp, _Np>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, size_t _Np>\x0a"
"native_simd_mask<_Tp> to_native(const fixed_size_simd_mask<_Tp, _Np>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, size_t _Np>\x0a"
"simd<_Tp> to_compatible(const fixed_size_simd<_Tp, _Np>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, size_t _Np>\x0a"
"simd_mask<_Tp> to_compatible(const fixed_size_simd_mask<_Tp, _Np>\x26) noexcept;\x0a"
"\x0a"
"template <size_t... __sizes, class _Tp, class _Abi>\x0a"
"tuple<simd<_Tp, abi_for_size_t<_Tp, __sizes>>...> split(const simd<_Tp, _Abi>\x26);\x0a"
"\x0a"
"template <size_t... __sizes, class _Tp, class _Abi>\x0a"
"tuple<simd_mask<_Tp, abi_for_size_t<_Tp, __sizes>>...>\x0a"
"split(const simd_mask<_Tp, _Abi>\x26);\x0a"
"\x0a"
"template <class _SimdType, class _Abi>\x0a"
"array<_SimdType, simd_size<typename _SimdType\x3a\x3avalue_type, _Abi>\x3a\x3avalue /\x0a"
"                     _SimdType\x3a\x3asize()>\x0a"
"split(const simd<typename _SimdType\x3a\x3avalue_type, _Abi>\x26);\x0a"
"\x0a"
"template <class _SimdType, class _Abi>\x0a"
"array<_SimdType, simd_size<typename _SimdType\x3a\x3avalue_type, _Abi>\x3a\x3avalue /\x0a"
"                     _SimdType\x3a\x3asize()>\x0a"
"split(const simd_mask<typename _SimdType\x3a\x3avalue_type, _Abi>\x26);\x0a"
"\x0a"
"template <class _Tp, class... _Abis>\x0a"
"simd<_Tp, abi_for_size_t<_Tp, __variadic_sum(simd_size<_Tp, _Abis>\x3a\x3avalue...)>>\x0a"
"concat(const simd<_Tp, _Abis>\x26...);\x0a"
"\x0a"
"template <class _Tp, class... _Abis>\x0a"
"simd_mask<_Tp,\x0a"
"          abi_for_size_t<_Tp, __variadic_sum(simd_size<_Tp, _Abis>\x3a\x3avalue...)>>\x0a"
"concat(const simd_mask<_Tp, _Abis>\x26...);\x0a"
"\x0a"
"// reductions \x5bsimd.mask.reductions\x5d\x0a"
"template <class _Tp, class _Abi>\x0a"
"bool all_of(const simd_mask<_Tp, _Abi>\x26) noexcept;\x0a"
"template <class _Tp, class _Abi>\x0a"
"bool any_of(const simd_mask<_Tp, _Abi>\x26) noexcept;\x0a"
"template <class _Tp, class _Abi>\x0a"
"bool none_of(const simd_mask<_Tp, _Abi>\x26) noexcept;\x0a"
"template <class _Tp, class _Abi>\x0a"
"bool some_of(const simd_mask<_Tp, _Abi>\x26) noexcept;\x0a"
"template <class _Tp, class _Abi>\x0a"
"int popcount(const simd_mask<_Tp, _Abi>\x26) noexcept;\x0a"
"template <class _Tp, class _Abi>\x0a"
"int find_first_set(const simd_mask<_Tp, _Abi>\x26);\x0a"
"template <class _Tp, class _Abi>\x0a"
"int find_last_set(const simd_mask<_Tp, _Abi>\x26);\x0a"
"bool all_of(bool) noexcept;\x0a"
"bool any_of(bool) noexcept;\x0a"
"bool none_of(bool) noexcept;\x0a"
"bool some_of(bool) noexcept;\x0a"
"int popcount(bool) noexcept;\x0a"
"int find_first_set(bool) noexcept;\x0a"
"int find_last_set(bool) noexcept;\x0a"
"\x0a"
"// masked assignment \x5bsimd.whereexpr\x5d\x0a"
"template <class _MaskType, class _Tp>\x0a"
"class const_where_expression;\x0a"
"template <class _MaskType, class _Tp>\x0a"
"class where_expression;\x0a"
"\x0a"
"// masked assignment \x5bsimd.mask.where\x5d\x0a"
"template <class _Tp, class _Abi>\x0a"
"where_expression<simd_mask<_Tp, _Abi>, simd<_Tp, _Abi>>\x0a"
"where(const typename simd<_Tp, _Abi>\x3a\x3amask_type\x26, simd<_Tp, _Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"const_where_expression<simd_mask<_Tp, _Abi>, const simd<_Tp, _Abi>>\x0a"
"where(const typename simd<_Tp, _Abi>\x3a\x3amask_type\x26,\x0a"
"      const simd<_Tp, _Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"where_expression<simd_mask<_Tp, _Abi>, simd_mask<_Tp, _Abi>>\x0a"
"where(const typename __nodeduce<simd_mask<_Tp, _Abi>>\x3a\x3atype\x26,\x0a"
"      simd_mask<_Tp, _Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"const_where_expression<simd_mask<_Tp, _Abi>, const simd_mask<_Tp, _Abi>>\x0a"
"where(const typename __nodeduce<simd_mask<_Tp, _Abi>>\x3a\x3atype\x26,\x0a"
"      const simd_mask<_Tp, _Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"where_expression<bool, _Tp> where(bool, _Tp\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"const_where_expression<bool, const _Tp> where(bool, const _Tp\x26) noexcept;\x0a"
"\x0a"
"// reductions \x5bsimd.reductions\x5d\x0a"
"template <class _Tp, class _Abi, class _BinaryOp = std\x3a\x3aplus<_Tp>>\x0a"
"_Tp reduce(const simd<_Tp, _Abi>\x26, _BinaryOp = _BinaryOp());\x0a"
"\x0a"
"template <class _MaskType, class _SimdType, class _BinaryOp>\x0a"
"typename _SimdType\x3a\x3avalue_type\x0a"
"reduce(const const_where_expression<_MaskType, _SimdType>\x26,\x0a"
"       typename _SimdType\x3a\x3avalue_type neutral_element, _BinaryOp binary_op);\x0a"
"\x0a"
"template <class _MaskType, class _SimdType>\x0a"
"typename _SimdType\x3a\x3avalue_type\x0a"
"reduce(const const_where_expression<_MaskType, _SimdType>\x26,\x0a"
"       plus<typename _SimdType\x3a\x3avalue_type> binary_op = {});\x0a"
"\x0a"
"template <class _MaskType, class _SimdType>\x0a"
"typename _SimdType\x3a\x3avalue_type\x0a"
"reduce(const const_where_expression<_MaskType, _SimdType>\x26,\x0a"
"       multiplies<typename _SimdType\x3a\x3avalue_type> binary_op);\x0a"
"\x0a"
"template <class _MaskType, class _SimdType>\x0a"
"typename _SimdType\x3a\x3avalue_type\x0a"
"reduce(const const_where_expression<_MaskType, _SimdType>\x26,\x0a"
"       bit_and<typename _SimdType\x3a\x3avalue_type> binary_op);\x0a"
"\x0a"
"template <class _MaskType, class _SimdType>\x0a"
"typename _SimdType\x3a\x3avalue_type\x0a"
"reduce(const const_where_expression<_MaskType, _SimdType>\x26,\x0a"
"       bit_or<typename _SimdType\x3a\x3avalue_type> binary_op);\x0a"
"\x0a"
"template <class _MaskType, class _SimdType>\x0a"
"typename _SimdType\x3a\x3avalue_type\x0a"
"reduce(const const_where_expression<_MaskType, _SimdType>\x26,\x0a"
"       bit_xor<typename _SimdType\x3a\x3avalue_type> binary_op);\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"_Tp hmin(const simd<_Tp, _Abi>\x26);\x0a"
"template <class _MaskType, class _SimdType>\x0a"
"typename _SimdType\x3a\x3avalue_type\x0a"
"hmin(const const_where_expression<_MaskType, _SimdType>\x26);\x0a"
"template <class _Tp, class _Abi>\x0a"
"_Tp hmax(const simd<_Tp, _Abi>\x26);\x0a"
"template <class _MaskType, class _SimdType>\x0a"
"typename _SimdType\x3a\x3avalue_type\x0a"
"hmax(const const_where_expression<_MaskType, _SimdType>\x26);\x0a"
"\x0a"
"// algorithms \x5bsimd.alg\x5d\x0a"
"template <class _Tp, class _Abi>\x0a"
"simd<_Tp, _Abi> min(const simd<_Tp, _Abi>\x26, const simd<_Tp, _Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"simd<_Tp, _Abi> max(const simd<_Tp, _Abi>\x26, const simd<_Tp, _Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"std\x3a\x3apair<simd<_Tp, _Abi>, simd<_Tp, _Abi>>\x0a"
"minmax(const simd<_Tp, _Abi>\x26, const simd<_Tp, _Abi>\x26) noexcept;\x0a"
"\x0a"
"template <class _Tp, class _Abi>\x0a"
"simd<_Tp, _Abi> clamp(const simd<_Tp, _Abi>\x26, const simd<_Tp, _Abi>\x26,\x0a"
"                      const simd<_Tp, _Abi>\x26);\x0a"
"\x0a"
"// \x5bsimd.whereexpr\x5d\x0a"
"// TODO implement where expressions.\x0a"
"template <class _MaskType, class _Tp>\x0a"
"class const_where_expression {\x0a"
"public\x3a\x0a"
"  const_where_expression(const const_where_expression\x26) = delete;\x0a"
"  const_where_expression\x26 operator=(const const_where_expression\x26) = delete;\x0a"
"  typename remove_const<_Tp>\x3a\x3atype operator-() const\x26\x26;\x0a"
"  template <class _Up, class _Flags>\x0a"
"  void copy_to(_Up*, _Flags) const\x26\x26;\x0a"
"};\x0a"
"\x0a"
"template <class _MaskType, class _Tp>\x0a"
"class where_expression \x3a public const_where_expression<_MaskType, _Tp> {\x0a"
"public\x3a\x0a"
"  where_expression(const where_expression\x26) = delete;\x0a"
"  where_expression\x26 operator=(const where_expression\x26) = delete;\x0a"
"  template <class _Up>\x0a"
"  void operator=(_Up\x26\x26);\x0a"
"  template <class _Up>\x0a"
"  void operator+=(_Up\x26\x26);\x0a"
"  template <class _Up>\x0a"
"  void operator-=(_Up\x26\x26);\x0a"
"  template <class _Up>\x0a"
"  void operator*=(_Up\x26\x26);\x0a"
"  template <class _Up>\x0a"
"  void operator/=(_Up\x26\x26);\x0a"
"  template <class _Up>\x0a"
"  void operator\x25=(_Up\x26\x26);\x0a"
"  template <class _Up>\x0a"
"  void operator\x26=(_Up\x26\x26);\x0a"
"  template <class _Up>\x0a"
"  void operator\x7c=(_Up\x26\x26);\x0a"
"  template <class _Up>\x0a"
"  void operator^=(_Up\x26\x26);\x0a"
"  template <class _Up>\x0a"
"  void operator<<=(_Up\x26\x26);\x0a"
"  template <class _Up>\x0a"
"  void operator>>=(_Up\x26\x26);\x0a"
"  void operator++();\x0a"
"  void operator++(int);\x0a"
"  void operator--();\x0a"
"  void operator--(int);\x0a"
"  template <class _Up, class _Flags>\x0a"
"  void copy_from(const _Up*, _Flags);\x0a"
"};\x0a"
"\x0a"
"// \x5bsimd.class\x5d\x0a"
"// TODO\x3a implement simd\x0a"
"template <class _Tp, class _Abi>\x0a"
"class simd {\x0a"
"public\x3a\x0a"
"  using value_type = _Tp;\x0a"
"  using reference = __simd_reference<_Tp, _Tp, _Abi>;\x0a"
"  using mask_type = simd_mask<_Tp, _Abi>;\x0a"
"  using abi_type = _Abi;\x0a"
"\x0a"
"  simd() = default;\x0a"
"  simd(const simd\x26) = default;\x0a"
"  simd\x26 operator=(const simd\x26) = default;\x0a"
"\x0a"
"  static constexpr size_t size() noexcept {\x0a"
"    return simd_size<_Tp, _Abi>\x3a\x3avalue;\x0a"
"  }\x0a"
"\x0a"
"private\x3a\x0a"
"  __simd_storage<_Tp, _Abi> __s_;\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  static constexpr bool __can_broadcast() {\x0a"
"    return (std\x3a\x3ais_arithmetic<_Up>\x3a\x3avalue \x26\x26\x0a"
"            __is_non_narrowing_arithmetic_convertible<_Up, _Tp>()) \x7c\x7c\x0a"
"           (\x21std\x3a\x3ais_arithmetic<_Up>\x3a\x3avalue \x26\x26\x0a"
"            std\x3a\x3ais_convertible<_Up, _Tp>\x3a\x3avalue) \x7c\x7c\x0a"
"           std\x3a\x3ais_same<typename std\x3a\x3aremove_const<_Up>\x3a\x3atype, int>\x3a\x3avalue \x7c\x7c\x0a"
"           (std\x3a\x3ais_same<typename std\x3a\x3aremove_const<_Up>\x3a\x3atype,\x0a"
"                         unsigned int>\x3a\x3avalue \x26\x26\x0a"
"            std\x3a\x3ais_unsigned<_Tp>\x3a\x3avalue);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Generator, size_t... __indicies>\x0a"
"  static constexpr decltype(\x0a"
"      std\x3a\x3a""forward_as_tuple(std\x3a\x3a""declval<_Generator>()(\x0a"
"          std\x3a\x3aintegral_constant<size_t, __indicies>())...),\x0a"
"      bool())\x0a"
"  __can_generate(std\x3a\x3aindex_sequence<__indicies...>) {\x0a"
"    return \x21__variadic_sum<bool>(\x0a"
"        \x21__can_broadcast<decltype(std\x3a\x3a""declval<_Generator>()(\x0a"
"            std\x3a\x3aintegral_constant<size_t, __indicies>()))>()...);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Generator>\x0a"
"  static bool __can_generate(...) {\x0a"
"    return false;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Generator, size_t... __indicies>\x0a"
"  void __generator_init(_Generator\x26\x26 __g, std\x3a\x3aindex_sequence<__indicies...>) {\x0a"
"    int __not_used\x5b\x5d{((*this)\x5b__indicies\x5d =\x0a"
"                          __g(std\x3a\x3aintegral_constant<size_t, __indicies>()),\x0a"
"                      0)...};\x0a"
"    (void)__not_used;\x0a"
"  }\x0a"
"\x0a"
"public\x3a\x0a"
"  // implicit type conversion constructor\x0a"
"  template <class _Up,\x0a"
"            class = typename std\x3a\x3a""enable_if<\x0a"
"                std\x3a\x3ais_same<_Abi, simd_abi\x3a\x3a""fixed_size<size()>>\x3a\x3avalue \x26\x26\x0a"
"                __is_non_narrowing_arithmetic_convertible<_Up, _Tp>()>\x3a\x3atype>\x0a"
"  simd(const simd<_Up, simd_abi\x3a\x3a""fixed_size<size()>>\x26 __v) {\x0a"
"    for (size_t __i = 0; __i < size(); __i++) {\x0a"
"      (*this)\x5b__i\x5d = static_cast<_Tp>(__v\x5b__i\x5d);\x0a"
"    }\x0a"
"  }\x0a"
"\x0a"
"  // implicit broadcast constructor\x0a"
"  template <class _Up,\x0a"
"            class = typename std\x3a\x3a""enable_if<__can_broadcast<_Up>()>\x3a\x3atype>\x0a"
"  simd(_Up\x26\x26 __rv) {\x0a"
"    auto __v = static_cast<_Tp>(__rv);\x0a"
"    for (size_t __i = 0; __i < size(); __i++) {\x0a"
"      (*this)\x5b__i\x5d = __v;\x0a"
"    }\x0a"
"  }\x0a"
"\x0a"
"  // generator constructor\x0a"
"  template <class _Generator,\x0a"
"            int = typename std\x3a\x3a""enable_if<\x0a"
"                __can_generate<_Generator>(std\x3a\x3amake_index_sequence<size()>()),\x0a"
"                int>\x3a\x3atype()>\x0a"
"  explicit simd(_Generator\x26\x26 __g) {\x0a"
"    __generator_init(std\x3a\x3a""forward<_Generator>(__g),\x0a"
"                     std\x3a\x3amake_index_sequence<size()>());\x0a"
"  }\x0a"
"\x0a"
"  // load constructor\x0a"
"  template <\x0a"
"      class _Up, class _Flags,\x0a"
"      class = typename std\x3a\x3a""enable_if<__vectorizable<_Up>()>\x3a\x3atype,\x0a"
"      class = typename std\x3a\x3a""enable_if<is_simd_flag_type<_Flags>\x3a\x3avalue>\x3a\x3atype>\x0a"
"  simd(const _Up* __buffer, _Flags) {\x0a"
"    // TODO\x3a optimize for overaligned flags\x0a"
"    for (size_t __i = 0; __i < size(); __i++) {\x0a"
"      (*this)\x5b__i\x5d = static_cast<_Tp>(__buffer\x5b__i\x5d);\x0a"
"    }\x0a"
"  }\x0a"
"\x0a"
"  // loads \x5bsimd.load\x5d\x0a"
"  template <class _Up, class _Flags>\x0a"
"  typename std\x3a\x3a""enable_if<__vectorizable<_Up>() \x26\x26\x0a"
"                          is_simd_flag_type<_Flags>\x3a\x3avalue>\x3a\x3atype\x0a"
"  copy_from(const _Up* __buffer, _Flags) {\x0a"
"    *this = simd(__buffer, _Flags());\x0a"
"  }\x0a"
"\x0a"
"  // stores \x5bsimd.store\x5d\x0a"
"  template <class _Up, class _Flags>\x0a"
"  typename std\x3a\x3a""enable_if<__vectorizable<_Up>() \x26\x26\x0a"
"                          is_simd_flag_type<_Flags>\x3a\x3avalue>\x3a\x3atype\x0a"
"  copy_to(_Up* __buffer, _Flags) const {\x0a"
"    // TODO\x3a optimize for overaligned flags\x0a"
"    for (size_t __i = 0; __i < size(); __i++) {\x0a"
"      __buffer\x5b__i\x5d = static_cast<_Up>((*this)\x5b__i\x5d);\x0a"
"    }\x0a"
"  }\x0a"
"\x0a"
"  // scalar access \x5bsimd.subscr\x5d\x0a"
"  reference operator\x5b\x5d(size_t __i) { return reference(\x26__s_, __i); }\x0a"
"\x0a"
"  value_type operator\x5b\x5d(size_t __i) const { return __s_.__get(__i); }\x0a"
"\x0a"
"  // unary operators \x5bsimd.unary\x5d\x0a"
"  simd\x26 operator++();\x0a"
"  simd operator++(int);\x0a"
"  simd\x26 operator--();\x0a"
"  simd operator--(int);\x0a"
"  mask_type operator\x21() const;\x0a"
"  simd operator\x7e() const;\x0a"
"  simd operator+() const;\x0a"
"  simd operator-() const;\x0a"
"\x0a"
"  // binary operators \x5bsimd.binary\x5d\x0a"
"  friend simd operator+(const simd\x26, const simd\x26);\x0a"
"  friend simd operator-(const simd\x26, const simd\x26);\x0a"
"  friend simd operator*(const simd\x26, const simd\x26);\x0a"
"  friend simd operator/(const simd\x26, const simd\x26);\x0a"
"  friend simd operator\x25(const simd\x26, const simd\x26);\x0a"
"  friend simd operator\x26(const simd\x26, const simd\x26);\x0a"
"  friend simd operator\x7c(const simd\x26, const simd\x26);\x0a"
"  friend simd operator^(const simd\x26, const simd\x26);\x0a"
"  friend simd operator<<(const simd\x26, const simd\x26);\x0a"
"  friend simd operator>>(const simd\x26, const simd\x26);\x0a"
"  friend simd operator<<(const simd\x26, int);\x0a"
"  friend simd operator>>(const simd\x26, int);\x0a"
"\x0a"
"  // compound assignment \x5bsimd.cassign\x5d\x0a"
"  friend simd\x26 operator+=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator-=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator*=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator/=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator\x25=(simd\x26, const simd\x26);\x0a"
"\x0a"
"  friend simd\x26 operator\x26=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator\x7c=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator^=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator<<=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator>>=(simd\x26, const simd\x26);\x0a"
"  friend simd\x26 operator<<=(simd\x26, int);\x0a"
"  friend simd\x26 operator>>=(simd\x26, int);\x0a"
"\x0a"
"  // compares \x5bsimd.comparison\x5d\x0a"
"  friend mask_type operator==(const simd\x26, const simd\x26);\x0a"
"  friend mask_type operator\x21=(const simd\x26, const simd\x26);\x0a"
"  friend mask_type operator>=(const simd\x26, const simd\x26);\x0a"
"  friend mask_type operator<=(const simd\x26, const simd\x26);\x0a"
"  friend mask_type operator>(const simd\x26, const simd\x26);\x0a"
"  friend mask_type operator<(const simd\x26, const simd\x26);\x0a"
"};\x0a"
"\x0a"
"// \x5bsimd.mask.class\x5d\x0a"
"template <class _Tp, class _Abi>\x0a"
"// TODO\x3a implement simd_mask\x0a"
"class simd_mask {\x0a"
"public\x3a\x0a"
"  using value_type = bool;\x0a"
"  // TODO\x3a this is strawman implementation. Turn it into a proxy type.\x0a"
"  using reference = bool\x26;\x0a"
"  using simd_type = simd<_Tp, _Abi>;\x0a"
"  using abi_type = _Abi;\x0a"
"  static constexpr size_t size() noexcept;\x0a"
"  simd_mask() = default;\x0a"
"\x0a"
"  // broadcast constructor\x0a"
"  explicit simd_mask(value_type) noexcept;\x0a"
"\x0a"
"  // implicit type conversion constructor\x0a"
"  template <class _Up>\x0a"
"  simd_mask(const simd_mask<_Up, simd_abi\x3a\x3a""fixed_size<size()>>\x26) noexcept;\x0a"
"\x0a"
"  // load constructor\x0a"
"  template <class _Flags>\x0a"
"  simd_mask(const value_type*, _Flags);\x0a"
"\x0a"
"  // loads \x5bsimd.mask.copy\x5d\x0a"
"  template <class _Flags>\x0a"
"  void copy_from(const value_type*, _Flags);\x0a"
"  template <class _Flags>\x0a"
"  void copy_to(value_type*, _Flags) const;\x0a"
"\x0a"
"  // scalar access \x5bsimd.mask.subscr\x5d\x0a"
"  reference operator\x5b\x5d(size_t);\x0a"
"  value_type operator\x5b\x5d(size_t) const;\x0a"
"\x0a"
"  // unary operators \x5bsimd.mask.unary\x5d\x0a"
"  simd_mask operator\x21() const noexcept;\x0a"
"\x0a"
"  // simd_mask binary operators \x5bsimd.mask.binary\x5d\x0a"
"  friend simd_mask operator\x26\x26(const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask operator\x7c\x7c(const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask operator\x26(const simd_mask\x26, const simd_mask\x26)noexcept;\x0a"
"  friend simd_mask operator\x7c(const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask operator^(const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"\x0a"
"  // simd_mask compound assignment \x5bsimd.mask.cassign\x5d\x0a"
"  friend simd_mask\x26 operator\x26=(simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask\x26 operator\x7c=(simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask\x26 operator^=(simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"\x0a"
"  // simd_mask compares \x5bsimd.mask.comparison\x5d\x0a"
"  friend simd_mask operator==(const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"  friend simd_mask operator\x21=(const simd_mask\x26, const simd_mask\x26) noexcept;\x0a"
"};\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER >= 17\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_EXPERIMENTAL_SIMD\x0a"
"\x0a"
"#endif /* _LIBCPP_EXPERIMENTAL_SIMD */\x0a"
"", 61263 ); }