#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_experimental_type_traits( 
"// -*- C++ -*-\x0a"
"//===-------------------------- type_traits -------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_EXPERIMENTAL_TYPE_TRAITS\x0a"
"#define _LIBCPP_EXPERIMENTAL_TYPE_TRAITS\x0a"
"\x0a"
"/**\x0a"
"    experimental/type_traits synopsis\x0a"
"\x0a"
"// C++1y\x0a"
"#include <type_traits>\x0a"
"\x0a"
"namespace std {\x0a"
"namespace experimental {\x0a"
"inline namespace fundamentals_v1 {\x0a"
"\x0a"
"  // 3.3.2, Other type transformations\x0a"
"  template <class> class invocation_type; // not defined\x0a"
"  template <class F, class... ArgTypes> class invocation_type<F(ArgTypes...)>;\x0a"
"  template <class> class raw_invocation_type; // not defined\x0a"
"  template <class F, class... ArgTypes> class raw_invocation_type<F(ArgTypes...)>;\x0a"
"\x0a"
"  template <class T>\x0a"
"    using invocation_type_t = typename invocation_type<T>\x3a\x3atype;\x0a"
"  template <class T>\x0a"
"    using raw_invocation_type_t = typename raw_invocation_type<T>\x3a\x3atype;\x0a"
"\x0a"
"  // 3.3.4, Detection idiom\x0a"
"  template <class...> using void_t = void;\x0a"
"\x0a"
"  struct nonesuch {\x0a"
"    nonesuch() = delete;\x0a"
"    \x7enonesuch() = delete;\x0a"
"    nonesuch(nonesuch const\x26) = delete;\x0a"
"    void operator=(nonesuch const\x26) = delete;\x0a"
"  };\x0a"
"\x0a"
"  template <template<class...> class Op, class... Args>\x0a"
"    using is_detected = see below;\x0a"
"  template <template<class...> class Op, class... Args>\x0a"
"    constexpr bool is_detected_v = is_detected<Op, Args...>\x3a\x3avalue;\x0a"
"  template <template<class...> class Op, class... Args>\x0a"
"    using detected_t = see below;\x0a"
"  template <class Default, template<class...> class Op, class... Args>\x0a"
"    using detected_or = see below;\x0a"
"  template <class Default, template<class...> class Op, class... Args>\x0a"
"    using detected_or_t = typename detected_or<Default, Op, Args...>\x3a\x3atype;\x0a"
"  template <class Expected, template<class...> class Op, class... Args>\x0a"
"    using is_detected_exact = is_same<Expected, detected_t<Op, Args...>>;\x0a"
"  template <class Expected, template<class...> class Op, class... Args>\x0a"
"    constexpr bool is_detected_exact_v\x0a"
"      = is_detected_exact<Expected, Op, Args...>\x3a\x3avalue;\x0a"
"  template <class To, template<class...> class Op, class... Args>\x0a"
"     using is_detected_convertible = is_convertible<detected_t<Op, Args...>, To>;\x0a"
"  template <class To, template<class...> class Op, class... Args>\x0a"
"     constexpr bool is_detected_convertible_v\x0a"
"       = is_detected_convertible<To, Op, Args...>\x3a\x3avalue;  \x0a"
"\x0a"
"} // namespace fundamentals_v1\x0a"
"} // namespace experimental\x0a"
"} // namespace std\x0a"
"\x0a"
" */\x0a"
"\x0a"
"#include <experimental/__config>\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"#include <initializer_list>\x0a"
"#include <type_traits>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_LFTS\x0a"
"\x0a"
"// 3.3.2, Other type transformations\x0a"
"/*\x0a"
"template <class>\x0a"
"class _LIBCPP_TEMPLATE_VIS raw_invocation_type;\x0a"
"\x0a"
"template <class _Fn, class ..._Args>\x0a"
"class _LIBCPP_TEMPLATE_VIS raw_invocation_type<_Fn(_Args...)>;\x0a"
"\x0a"
"template <class>\x0a"
"class _LIBCPP_TEMPLATE_VIS invokation_type;\x0a"
"\x0a"
"template <class _Fn, class ..._Args>\x0a"
"class _LIBCPP_TEMPLATE_VIS invokation_type<_Fn(_Args...)>;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"using invokation_type_t = typename invokation_type<_Tp>\x3a\x3atype;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"using raw_invocation_type_t = typename raw_invocation_type<_Tp>\x3a\x3atype;\x0a"
"*/\x0a"
"\x0a"
"// 3.3.4, Detection idiom\x0a"
"template <class...> using void_t = void;\x0a"
"\x0a"
"struct nonesuch \x3a private _VSTD\x3a\x3a__nat { // make nonesuch \x22not an aggregate\x22\x0a"
"  \x7enonesuch() = delete;\x0a"
"  nonesuch      (nonesuch const\x26) = delete;\x0a"
"  void operator=(nonesuch const\x26) = delete;\x0a"
"  };\x0a"
"\x0a"
"template <class _Default, class _AlwaysVoid, template <class...> class _Op, class... _Args>\x0a"
"struct _DETECTOR {\x0a"
"   using value_t = false_type;\x0a"
"   using type = _Default;\x0a"
"   };\x0a"
"\x0a"
"template <class _Default, template <class...> class _Op, class... _Args>\x0a"
"struct _DETECTOR<_Default, void_t<_Op<_Args...>>, _Op, _Args...> {\x0a"
"   using value_t = true_type;\x0a"
"   using type = _Op<_Args...>;\x0a"
"   };\x0a"
"     \x0a"
"\x0a"
"template <template<class...> class _Op, class... _Args>\x0a"
"  using is_detected = typename _DETECTOR<nonesuch, void, _Op, _Args...>\x3a\x3avalue_t;\x0a"
"template <template<class...> class _Op, class... _Args>\x0a"
"  using detected_t = typename _DETECTOR<nonesuch, void, _Op, _Args...>\x3a\x3atype;\x0a"
"template <template<class...> class _Op, class... _Args>\x0a"
"  _LIBCPP_CONSTEXPR bool is_detected_v = is_detected<_Op, _Args...>\x3a\x3avalue;\x0a"
"\x0a"
"template <class Default, template<class...> class _Op, class... _Args>\x0a"
"  using detected_or = _DETECTOR<Default, void, _Op, _Args...>;\x0a"
"template <class Default, template<class...> class _Op, class... _Args>\x0a"
"  using detected_or_t = typename detected_or<Default, _Op, _Args...>\x3a\x3atype;\x0a"
"\x0a"
"template <class Expected, template<class...> class _Op, class... _Args>\x0a"
"  using is_detected_exact = is_same<Expected, detected_t<_Op, _Args...>>;\x0a"
"template <class Expected, template<class...> class _Op, class... _Args>\x0a"
"  _LIBCPP_CONSTEXPR bool is_detected_exact_v = is_detected_exact<Expected, _Op, _Args...>\x3a\x3avalue;\x0a"
"\x0a"
"template <class To, template<class...> class _Op, class... _Args>\x0a"
"  using is_detected_convertible = is_convertible<detected_t<_Op, _Args...>, To>;\x0a"
"template <class To, template<class...> class _Op, class... _Args>\x0a"
"  _LIBCPP_CONSTEXPR bool is_detected_convertible_v = is_detected_convertible<To, _Op, _Args...>\x3a\x3avalue;  \x0a"
"\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_LFTS\x0a"
"\x0a"
"#endif /* _LIBCPP_STD_VER > 11 */\x0a"
"\x0a"
"#endif /* _LIBCPP_EXPERIMENTAL_TYPE_TRAITS */\x0a"
"", 5493 ); }