#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_ext_hash_map( 
"// -*- C++ -*-\x0a"
"//===-------------------------- hash_map ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_HASH_MAP\x0a"
"#define _LIBCPP_HASH_MAP\x0a"
"\x0a"
"/*\x0a"
"\x0a"
"    hash_map synopsis\x0a"
"\x0a"
"namespace __gnu_cxx\x0a"
"{\x0a"
"\x0a"
"template <class Key, class T, class Hash = hash<Key>, class Pred = equal_to<Key>,\x0a"
"          class Alloc = allocator<pair<const Key, T>>>\x0a"
"class hash_map\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef Key                                                        key_type;\x0a"
"    typedef T                                                          mapped_type;\x0a"
"    typedef Hash                                                       hasher;\x0a"
"    typedef Pred                                                       key_equal;\x0a"
"    typedef Alloc                                                      allocator_type;\x0a"
"    typedef pair<const key_type, mapped_type>                          value_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef /unspecified/ iterator;\x0a"
"    typedef /unspecified/ const_iterator;\x0a"
"\x0a"
"    explicit hash_map(size_type n = 193, const hasher\x26 hf = hasher(),\x0a"
"                           const key_equal\x26 eql = key_equal(),\x0a"
"                           const allocator_type\x26 a = allocator_type());\x0a"
"    template <class InputIterator>\x0a"
"        hash_map(InputIterator f, InputIterator l,\x0a"
"                      size_type n = 193, const hasher\x26 hf = hasher(),\x0a"
"                      const key_equal\x26 eql = key_equal(),\x0a"
"                      const allocator_type\x26 a = allocator_type());\x0a"
"    hash_map(const hash_map\x26);\x0a"
"    \x7ehash_map();\x0a"
"    hash_map\x26 operator=(const hash_map\x26);\x0a"
"\x0a"
"    allocator_type get_allocator() const;\x0a"
"\x0a"
"    bool      empty() const;\x0a"
"    size_type size() const;\x0a"
"    size_type max_size() const;\x0a"
"\x0a"
"    iterator       begin();\x0a"
"    iterator       end();\x0a"
"    const_iterator begin()  const;\x0a"
"    const_iterator end()    const;\x0a"
"\x0a"
"    pair<iterator, bool> insert(const value_type\x26 obj);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"\x0a"
"    void erase(const_iterator position);\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    void erase(const_iterator first, const_iterator last);\x0a"
"    void clear();\x0a"
"\x0a"
"    void swap(hash_map\x26);\x0a"
"\x0a"
"    hasher hash_funct() const;\x0a"
"    key_equal key_eq() const;\x0a"
"\x0a"
"    iterator       find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    size_type count(const key_type\x26 k) const;\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"\x0a"
"    mapped_type\x26 operator\x5b\x5d(const key_type\x26 k);\x0a"
"\x0a"
"    size_type bucket_count() const;\x0a"
"    size_type max_bucket_count() const;\x0a"
"\x0a"
"    size_type elems_in_bucket(size_type n) const;\x0a"
"\x0a"
"    void resize(size_type n);\x0a"
"};\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    void swap(hash_map<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"              hash_map<Key, T, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator==(const hash_map<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"               const hash_map<Key, T, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator\x21=(const hash_map<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"               const hash_map<Key, T, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Hash = hash<Key>, class Pred = equal_to<Key>,\x0a"
"          class Alloc = allocator<pair<const Key, T>>>\x0a"
"class hash_multimap\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef Key                                                        key_type;\x0a"
"    typedef T                                                          mapped_type;\x0a"
"    typedef Hash                                                       hasher;\x0a"
"    typedef Pred                                                       key_equal;\x0a"
"    typedef Alloc                                                      allocator_type;\x0a"
"    typedef pair<const key_type, mapped_type>                          value_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef /unspecified/ iterator;\x0a"
"    typedef /unspecified/ const_iterator;\x0a"
"\x0a"
"    explicit hash_multimap(size_type n = 193, const hasher\x26 hf = hasher(),\x0a"
"                           const key_equal\x26 eql = key_equal(),\x0a"
"                           const allocator_type\x26 a = allocator_type());\x0a"
"    template <class InputIterator>\x0a"
"        hash_multimap(InputIterator f, InputIterator l,\x0a"
"                      size_type n = 193, const hasher\x26 hf = hasher(),\x0a"
"                      const key_equal\x26 eql = key_equal(),\x0a"
"                      const allocator_type\x26 a = allocator_type());\x0a"
"    explicit hash_multimap(const allocator_type\x26);\x0a"
"    hash_multimap(const hash_multimap\x26);\x0a"
"    \x7ehash_multimap();\x0a"
"    hash_multimap\x26 operator=(const hash_multimap\x26);\x0a"
"\x0a"
"    allocator_type get_allocator() const;\x0a"
"\x0a"
"    bool      empty() const;\x0a"
"    size_type size() const;\x0a"
"    size_type max_size() const;\x0a"
"\x0a"
"    iterator       begin();\x0a"
"    iterator       end();\x0a"
"    const_iterator begin()  const;\x0a"
"    const_iterator end()    const;\x0a"
"\x0a"
"    iterator insert(const value_type\x26 obj);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"\x0a"
"    void erase(const_iterator position);\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    void erase(const_iterator first, const_iterator last);\x0a"
"    void clear();\x0a"
"\x0a"
"    void swap(hash_multimap\x26);\x0a"
"\x0a"
"    hasher hash_funct() const;\x0a"
"    key_equal key_eq() const;\x0a"
"\x0a"
"    iterator       find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    size_type count(const key_type\x26 k) const;\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"\x0a"
"    size_type bucket_count() const;\x0a"
"    size_type max_bucket_count() const;\x0a"
"\x0a"
"    size_type elems_in_bucket(size_type n) const;\x0a"
"\x0a"
"    void resize(size_type n);\x0a"
"};\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    void swap(hash_multimap<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"              hash_multimap<Key, T, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator==(const hash_multimap<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"               const hash_multimap<Key, T, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator\x21=(const hash_multimap<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"               const hash_multimap<Key, T, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"}  // __gnu_cxx\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__hash_table>\x0a"
"#include <functional>\x0a"
"#include <stdexcept>\x0a"
"#include <type_traits>\x0a"
"#include <ext/__hash>\x0a"
"\x0a"
"#if __DEPRECATED\x0a"
"#if defined(_LIBCPP_WARNING)\x0a"
"    _LIBCPP_WARNING(\x22Use of the header <ext/hash_map> is deprecated.  Migrate to <unordered_map>\x22)\x0a"
"#else\x0a"
"#   warning Use of the header <ext/hash_map> is deprecated.  Migrate to <unordered_map>\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"namespace __gnu_cxx {\x0a"
"\x0a"
"template <class _Tp, class _Hash,\x0a"
"          bool = std\x3a\x3ais_empty<_Hash>\x3a\x3avalue \x26\x26 \x21std\x3a\x3a__libcpp_is_final<_Hash>\x3a\x3avalue\x0a"
"        >\x0a"
"class __hash_map_hasher\x0a"
"    \x3a private _Hash\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_hasher() \x3a _Hash() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_hasher(const _Hash\x26 __h) \x3a _Hash(__h) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const _Hash\x26 hash_function() const {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const _Tp\x26 __x) const\x0a"
"        {return static_cast<const _Hash\x26>(*this)(__x.first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const typename _Tp\x3a\x3a""first_type\x26 __x) const\x0a"
"        {return static_cast<const _Hash\x26>(*this)(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Hash>\x0a"
"class __hash_map_hasher<_Tp, _Hash, false>\x0a"
"{\x0a"
"    _Hash __hash_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_hasher() \x3a __hash_() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_hasher(const _Hash\x26 __h) \x3a __hash_(__h) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const _Hash\x26 hash_function() const {return __hash_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const _Tp\x26 __x) const\x0a"
"        {return __hash_(__x.first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const typename _Tp\x3a\x3a""first_type\x26 __x) const\x0a"
"        {return __hash_(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Pred,\x0a"
"          bool = std\x3a\x3ais_empty<_Pred>\x3a\x3avalue \x26\x26 \x21std\x3a\x3a__libcpp_is_final<_Pred>\x3a\x3avalue\x0a"
"         >\x0a"
"class __hash_map_equal\x0a"
"    \x3a private _Pred\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_equal() \x3a _Pred() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_equal(const _Pred\x26 __p) \x3a _Pred(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const _Pred\x26 key_eq() const {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return static_cast<const _Pred\x26>(*this)(__x.first, __y.first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const typename _Tp\x3a\x3a""first_type\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return static_cast<const _Pred\x26>(*this)(__x, __y.first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const typename _Tp\x3a\x3a""first_type\x26 __y) const\x0a"
"        {return static_cast<const _Pred\x26>(*this)(__x.first, __y);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const typename _Tp\x3a\x3a""first_type\x26 __x,\x0a"
"                    const typename _Tp\x3a\x3a""first_type\x26 __y) const\x0a"
"        {return static_cast<const _Pred\x26>(*this)(__x, __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Pred>\x0a"
"class __hash_map_equal<_Tp, _Pred, false>\x0a"
"{\x0a"
"    _Pred __pred_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_equal() \x3a __pred_() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_equal(const _Pred\x26 __p) \x3a __pred_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const _Pred\x26 key_eq() const {return __pred_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __pred_(__x.first, __y.first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const typename _Tp\x3a\x3a""first_type\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __pred_(__x, __y.first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const typename _Tp\x3a\x3a""first_type\x26 __y) const\x0a"
"        {return __pred_(__x.first, __y);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const typename _Tp\x3a\x3a""first_type\x26 __x,\x0a"
"                    const typename _Tp\x3a\x3a""first_type\x26 __y) const\x0a"
"        {return __pred_(__x, __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"class __hash_map_node_destructor\x0a"
"{\x0a"
"    typedef _Alloc                              allocator_type;\x0a"
"    typedef std\x3a\x3a""allocator_traits<allocator_type>    __alloc_traits;\x0a"
"    typedef typename __alloc_traits\x3a\x3avalue_type\x3a\x3a__node_value_type value_type;\x0a"
"public\x3a\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer    pointer;\x0a"
"private\x3a\x0a"
"    typedef typename value_type\x3a\x3a""first_type     first_type;\x0a"
"    typedef typename value_type\x3a\x3asecond_type    second_type;\x0a"
"\x0a"
"    allocator_type\x26 __na_;\x0a"
"\x0a"
"    __hash_map_node_destructor\x26 operator=(const __hash_map_node_destructor\x26);\x0a"
"\x0a"
"public\x3a\x0a"
"    bool __first_constructed;\x0a"
"    bool __second_constructed;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __hash_map_node_destructor(allocator_type\x26 __na)\x0a"
"        \x3a __na_(__na),\x0a"
"          __first_constructed(false),\x0a"
"          __second_constructed(false)\x0a"
"        {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_node_destructor(std\x3a\x3a__hash_node_destructor<allocator_type>\x26\x26 __x)\x0a"
"        \x3a __na_(__x.__na_),\x0a"
"          __first_constructed(__x.__value_constructed),\x0a"
"          __second_constructed(__x.__value_constructed)\x0a"
"        {\x0a"
"            __x.__value_constructed = false;\x0a"
"        }\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_node_destructor(const std\x3a\x3a__hash_node_destructor<allocator_type>\x26 __x)\x0a"
"        \x3a __na_(__x.__na_),\x0a"
"          __first_constructed(__x.__value_constructed),\x0a"
"          __second_constructed(__x.__value_constructed)\x0a"
"        {\x0a"
"            const_cast<bool\x26>(__x.__value_constructed) = false;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator()(pointer __p)\x0a"
"    {\x0a"
"        if (__second_constructed)\x0a"
"            __alloc_traits\x3a\x3a""destroy(__na_, _VSTD\x3a\x3a""addressof(__p->__value_.second));\x0a"
"        if (__first_constructed)\x0a"
"            __alloc_traits\x3a\x3a""destroy(__na_, _VSTD\x3a\x3a""addressof(__p->__value_.first));\x0a"
"        if (__p)\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__na_, __p, 1);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _HashIterator>\x0a"
"class _LIBCPP_TEMPLATE_VIS __hash_map_iterator\x0a"
"{\x0a"
"    _HashIterator __i_;\x0a"
"\x0a"
"    typedef const typename _HashIterator\x3a\x3avalue_type\x3a\x3a""first_type key_type;\x0a"
"    typedef typename _HashIterator\x3a\x3avalue_type\x3a\x3asecond_type      mapped_type;\x0a"
"public\x3a\x0a"
"    typedef std\x3a\x3a""forward_iterator_tag                            iterator_category;\x0a"
"    typedef std\x3a\x3apair<key_type, mapped_type>                     value_type;\x0a"
"    typedef typename _HashIterator\x3a\x3a""difference_type              difference_type;\x0a"
"    typedef value_type\x26                                          reference;\x0a"
"    typedef typename std\x3a\x3a__rebind_pointer<typename _HashIterator\x3a\x3apointer, value_type>\x3a\x3atype\x0a"
"        pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_iterator() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_iterator(_HashIterator __i) \x3a __i_(__i) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference operator*() const {return *operator->();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY pointer operator->() const {return (pointer)__i_.operator->();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_iterator\x26 operator++() {++__i_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_iterator operator++(int)\x0a"
"    {\x0a"
"        __hash_map_iterator __t(*this);\x0a"
"        ++(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY \x0a"
"    bool operator==(const __hash_map_iterator\x26 __x, const __hash_map_iterator\x26 __y)\x0a"
"        {return __x.__i_ == __y.__i_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY \x0a"
"    bool operator\x21=(const __hash_map_iterator\x26 __x, const __hash_map_iterator\x26 __y)\x0a"
"        {return __x.__i_ \x21= __y.__i_;}\x0a"
"\x0a"
"    template <class, class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS hash_map;\x0a"
"    template <class, class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS hash_multimap;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __hash_const_iterator;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __hash_const_local_iterator;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __hash_map_const_iterator;\x0a"
"};\x0a"
"\x0a"
"template <class _HashIterator>\x0a"
"class _LIBCPP_TEMPLATE_VIS __hash_map_const_iterator\x0a"
"{\x0a"
"    _HashIterator __i_;\x0a"
"\x0a"
"    typedef const typename _HashIterator\x3a\x3avalue_type\x3a\x3a""first_type key_type;\x0a"
"    typedef typename _HashIterator\x3a\x3avalue_type\x3a\x3asecond_type      mapped_type;\x0a"
"public\x3a\x0a"
"    typedef std\x3a\x3a""forward_iterator_tag                            iterator_category;\x0a"
"    typedef std\x3a\x3apair<key_type, mapped_type>                     value_type;\x0a"
"    typedef typename _HashIterator\x3a\x3a""difference_type              difference_type;\x0a"
"    typedef const value_type\x26                                    reference;\x0a"
"    typedef typename std\x3a\x3a__rebind_pointer<typename _HashIterator\x3a\x3apointer, const value_type>\x3a\x3atype\x0a"
"        pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __hash_map_const_iterator() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_const_iterator(_HashIterator __i) \x3a __i_(__i) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_const_iterator(\x0a"
"            __hash_map_iterator<typename _HashIterator\x3a\x3a__non_const_iterator> __i)\x0a"
"                \x3a __i_(__i.__i_) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator*() const {return *operator->();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const {return (pointer)__i_.operator->();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_const_iterator\x26 operator++() {++__i_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_const_iterator operator++(int)\x0a"
"    {\x0a"
"        __hash_map_const_iterator __t(*this);\x0a"
"        ++(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const __hash_map_const_iterator\x26 __x, const __hash_map_const_iterator\x26 __y)\x0a"
"        {return __x.__i_ == __y.__i_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const __hash_map_const_iterator\x26 __x, const __hash_map_const_iterator\x26 __y)\x0a"
"        {return __x.__i_ \x21= __y.__i_;}\x0a"
"\x0a"
"    template <class, class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS hash_map;\x0a"
"    template <class, class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS hash_multimap;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __hash_const_iterator;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __hash_const_local_iterator;\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std\x3a\x3a""equal_to<_Key>,\x0a"
"          class _Alloc = std\x3a\x3a""allocator<std\x3a\x3apair<const _Key, _Tp> > >\x0a"
"class _LIBCPP_TEMPLATE_VIS hash_map\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _Key                                           key_type;\x0a"
"    typedef _Tp                                            mapped_type;\x0a"
"    typedef _Tp                                            data_type;\x0a"
"    typedef _Hash                                          hasher;\x0a"
"    typedef _Pred                                          key_equal;\x0a"
"    typedef _Alloc                                         allocator_type;\x0a"
"    typedef std\x3a\x3apair<const key_type, mapped_type>         value_type;\x0a"
"    typedef value_type\x26                                    reference;\x0a"
"    typedef const value_type\x26                              const_reference;\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef std\x3a\x3apair<key_type, mapped_type>                    __value_type;\x0a"
"    typedef __hash_map_hasher<__value_type, hasher>   __hasher;\x0a"
"    typedef __hash_map_equal<__value_type, key_equal> __key_equal;\x0a"
"    typedef typename std\x3a\x3a__rebind_alloc_helper<\x0a"
"        std\x3a\x3a""allocator_traits<allocator_type>, __value_type>\x3a\x3atype __allocator_type;\x0a"
"\x0a"
"    typedef std\x3a\x3a__hash_table<__value_type, __hasher,\x0a"
"                         __key_equal,  __allocator_type>   __table;\x0a"
"\x0a"
"    __table __table_;\x0a"
"\x0a"
"    typedef typename __table\x3a\x3a__node_pointer               __node_pointer;\x0a"
"    typedef typename __table\x3a\x3a__node_const_pointer         __node_const_pointer;\x0a"
"    typedef typename __table\x3a\x3a__node_traits                __node_traits;\x0a"
"    typedef typename __table\x3a\x3a__node_allocator             __node_allocator;\x0a"
"    typedef typename __table\x3a\x3a__node                       __node;\x0a"
"    typedef __hash_map_node_destructor<__node_allocator>   _Dp;\x0a"
"    typedef std\x3a\x3aunique_ptr<__node, _Dp>                   __node_holder;\x0a"
"    typedef std\x3a\x3a""allocator_traits<allocator_type>          __alloc_traits;\x0a"
"public\x3a\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer         pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3asize_type       size_type;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef __hash_map_iterator<typename __table\x3a\x3aiterator>       iterator;\x0a"
"    typedef __hash_map_const_iterator<typename __table\x3a\x3a""const_iterator> const_iterator;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY hash_map() {__table_.rehash(193);}\x0a"
"    explicit hash_map(size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                           const key_equal\x26 __eql = key_equal());\x0a"
"    hash_map(size_type __n, const hasher\x26 __hf,\x0a"
"                  const key_equal\x26 __eql,\x0a"
"                  const allocator_type\x26 __a);\x0a"
"    template <class _InputIterator>\x0a"
"        hash_map(_InputIterator __first, _InputIterator __last);\x0a"
"    template <class _InputIterator>\x0a"
"        hash_map(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                      const key_equal\x26 __eql = key_equal());\x0a"
"    template <class _InputIterator>\x0a"
"        hash_map(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf,\x0a"
"                      const key_equal\x26 __eql,\x0a"
"                      const allocator_type\x26 __a);\x0a"
"    hash_map(const hash_map\x26 __u);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const\x0a"
"        {return allocator_type(__table_.__node_alloc());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool      empty() const {return __table_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const  {return __table_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const {return __table_.max_size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       begin()        {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       end()          {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin()  const {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()    const {return __table_.end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    std\x3a\x3apair<iterator, bool> insert(const value_type\x26 __x)\x0a"
"        {return __table_.__insert_unique(__x);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator, const value_type\x26 __x) {return insert(__x).first;}\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __first, _InputIterator __last);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void erase(const_iterator __p) {__table_.erase(__p.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k) {return __table_.__erase_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void erase(const_iterator __first, const_iterator __last)\x0a"
"        {__table_.erase(__first.__i_, __last.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() {__table_.clear();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(hash_map\x26 __u) {__table_.swap(__u.__table_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hasher hash_funct() const\x0a"
"        {return __table_.hash_function().hash_function();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_equal key_eq() const\x0a"
"        {return __table_.key_eq().key_eq();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       find(const key_type\x26 __k)       {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type count(const key_type\x26 __k) const {return __table_.__count_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    std\x3a\x3apair<iterator, iterator>             equal_range(const key_type\x26 __k)\x0a"
"        {return __table_.__equal_range_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    std\x3a\x3apair<const_iterator, const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"        {return __table_.__equal_range_unique(__k);}\x0a"
"\x0a"
"    mapped_type\x26 operator\x5b\x5d(const key_type\x26 __k);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_count() const {return __table_.bucket_count();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_bucket_count() const {return __table_.max_bucket_count();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type elems_in_bucket(size_type __n) const\x0a"
"        {return __table_.bucket_size(__n);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void resize(size_type __n) {__table_.rehash(__n);}\x0a"
"\x0a"
"private\x3a\x0a"
"    __node_holder __construct_node(const key_type\x26 __k);\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_map(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_map(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_map(\x0a"
"        _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    __table_.rehash(193);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_map(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_map(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_map(\x0a"
"        const hash_map\x26 __u)\x0a"
"    \x3a __table_(__u.__table_)\x0a"
"{\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"typename hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3a__node_holder\x0a"
"hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3a__construct_node(const key_type\x26 __k)\x0a"
"{\x0a"
"    __node_allocator\x26 __na = __table_.__node_alloc();\x0a"
"    __node_holder __h(__node_traits\x3a\x3a""allocate(__na, 1), _Dp(__na));\x0a"
"    __node_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__h->__value_.first), __k);\x0a"
"    __h.get_deleter().__first_constructed = true;\x0a"
"    __node_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__h->__value_.second));\x0a"
"    __h.get_deleter().__second_constructed = true;\x0a"
"    return _LIBCPP_EXPLICIT_MOVE(__h);  // explicitly moved for C++03\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"inline\x0a"
"void\x0a"
"hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ainsert(_InputIterator __first,\x0a"
"                                                       _InputIterator __last)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __table_.__insert_unique(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"_Tp\x26\x0a"
"hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aoperator\x5b\x5d(const key_type\x26 __k)\x0a"
"{\x0a"
"    iterator __i = find(__k);\x0a"
"    if (__i \x21= end())\x0a"
"        return __i->second;\x0a"
"    __node_holder __h = __construct_node(__k);\x0a"
"    std\x3a\x3apair<iterator, bool> __r = __table_.__node_insert_unique(__h.get());\x0a"
"    __h.release();\x0a"
"    return __r.first->second;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"     hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"bool\x0a"
"operator==(const hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    if (__x.size() \x21= __y.size())\x0a"
"        return false;\x0a"
"    typedef typename hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3a""const_iterator\x0a"
"                                                                 const_iterator;\x0a"
"    for (const_iterator __i = __x.begin(), __ex = __x.end(), __ey = __y.end();\x0a"
"            __i \x21= __ex; ++__i)\x0a"
"    {\x0a"
"        const_iterator __j = __y.find(__i->first);\x0a"
"        if (__j == __ey \x7c\x7c \x21(*__i == *__j))\x0a"
"            return false;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const hash_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = std\x3a\x3a""equal_to<_Key>,\x0a"
"          class _Alloc = std\x3a\x3a""allocator<std\x3a\x3apair<const _Key, _Tp> > >\x0a"
"class _LIBCPP_TEMPLATE_VIS hash_multimap\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _Key                                           key_type;\x0a"
"    typedef _Tp                                            mapped_type;\x0a"
"    typedef _Tp                                            data_type;\x0a"
"    typedef _Hash                                          hasher;\x0a"
"    typedef _Pred                                          key_equal;\x0a"
"    typedef _Alloc                                         allocator_type;\x0a"
"    typedef std\x3a\x3apair<const key_type, mapped_type>         value_type;\x0a"
"    typedef value_type\x26                                    reference;\x0a"
"    typedef const value_type\x26                              const_reference;\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef std\x3a\x3apair<key_type, mapped_type>               __value_type;\x0a"
"    typedef __hash_map_hasher<__value_type, hasher>   __hasher;\x0a"
"    typedef __hash_map_equal<__value_type, key_equal> __key_equal;\x0a"
"    typedef typename std\x3a\x3a__rebind_alloc_helper<std\x3a\x3a""allocator_traits<allocator_type>, __value_type>\x3a\x3atype __allocator_type;\x0a"
"\x0a"
"    typedef std\x3a\x3a__hash_table<__value_type, __hasher,\x0a"
"                         __key_equal,  __allocator_type>   __table;\x0a"
"\x0a"
"    __table __table_;\x0a"
"\x0a"
"    typedef typename __table\x3a\x3a__node_traits                __node_traits;\x0a"
"    typedef typename __table\x3a\x3a__node_allocator             __node_allocator;\x0a"
"    typedef typename __table\x3a\x3a__node                       __node;\x0a"
"    typedef __hash_map_node_destructor<__node_allocator>   _Dp;\x0a"
"    typedef std\x3a\x3aunique_ptr<__node, _Dp>                         __node_holder;\x0a"
"    typedef std\x3a\x3a""allocator_traits<allocator_type>               __alloc_traits;\x0a"
"public\x3a\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer         pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3asize_type       size_type;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef __hash_map_iterator<typename __table\x3a\x3aiterator>       iterator;\x0a"
"    typedef __hash_map_const_iterator<typename __table\x3a\x3a""const_iterator> const_iterator;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hash_multimap() {__table_.rehash(193);}\x0a"
"    explicit hash_multimap(size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                                const key_equal\x26 __eql = key_equal());\x0a"
"    hash_multimap(size_type __n, const hasher\x26 __hf,\x0a"
"                                const key_equal\x26 __eql,\x0a"
"                                const allocator_type\x26 __a);\x0a"
"    template <class _InputIterator>\x0a"
"        hash_multimap(_InputIterator __first, _InputIterator __last);\x0a"
"    template <class _InputIterator>\x0a"
"        hash_multimap(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                      const key_equal\x26 __eql = key_equal());\x0a"
"    template <class _InputIterator>\x0a"
"        hash_multimap(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf,\x0a"
"                      const key_equal\x26 __eql,\x0a"
"                      const allocator_type\x26 __a);\x0a"
"    hash_multimap(const hash_multimap\x26 __u);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const\x0a"
"        {return allocator_type(__table_.__node_alloc());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool      empty() const {return __table_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const  {return __table_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const {return __table_.max_size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       begin()        {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       end()          {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin()  const {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()    const {return __table_.end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const value_type\x26 __x) {return __table_.__insert_multi(__x);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator, const value_type\x26 __x) {return insert(__x);}\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __first, _InputIterator __last);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void erase(const_iterator __p) {__table_.erase(__p.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k) {return __table_.__erase_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void erase(const_iterator __first, const_iterator __last)\x0a"
"        {__table_.erase(__first.__i_, __last.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() {__table_.clear();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(hash_multimap\x26 __u) {__table_.swap(__u.__table_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hasher hash_funct() const\x0a"
"        {return __table_.hash_function().hash_function();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_equal key_eq() const\x0a"
"        {return __table_.key_eq().key_eq();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       find(const key_type\x26 __k)       {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type count(const key_type\x26 __k) const {return __table_.__count_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    std\x3a\x3apair<iterator, iterator>             equal_range(const key_type\x26 __k)\x0a"
"        {return __table_.__equal_range_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    std\x3a\x3apair<const_iterator, const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"        {return __table_.__equal_range_multi(__k);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_count() const {return __table_.bucket_count();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_bucket_count() const {return __table_.max_bucket_count();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type elems_in_bucket(size_type __n) const\x0a"
"        {return __table_.bucket_size(__n);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void resize(size_type __n) {__table_.rehash(__n);}\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_multimap(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_multimap(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_multimap(\x0a"
"        _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    __table_.rehash(193);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_multimap(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_multimap(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ahash_multimap(\x0a"
"        const hash_multimap\x26 __u)\x0a"
"    \x3a __table_(__u.__table_)\x0a"
"{\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"inline\x0a"
"void\x0a"
"hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ainsert(_InputIterator __first,\x0a"
"                                                            _InputIterator __last)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __table_.__insert_multi(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"     hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"bool\x0a"
"operator==(const hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    if (__x.size() \x21= __y.size())\x0a"
"        return false;\x0a"
"    typedef typename hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3a""const_iterator\x0a"
"                                                                 const_iterator;\x0a"
"    typedef std\x3a\x3apair<const_iterator, const_iterator> _EqRng;\x0a"
"    for (const_iterator __i = __x.begin(), __ex = __x.end(); __i \x21= __ex;)\x0a"
"    {\x0a"
"        _EqRng __xeq = __x.equal_range(__i->first);\x0a"
"        _EqRng __yeq = __y.equal_range(__i->first);\x0a"
"        if (_VSTD\x3a\x3a""distance(__xeq.first, __xeq.second) \x21=\x0a"
"            _VSTD\x3a\x3a""distance(__yeq.first, __yeq.second) \x7c\x7c\x0a"
"                  \x21_VSTD\x3a\x3ais_permutation(__xeq.first, __xeq.second, __yeq.first))\x0a"
"            return false;\x0a"
"        __i = __xeq.second;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const hash_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"} // __gnu_cxx\x0a"
"\x0a"
"#endif  // _LIBCPP_HASH_MAP\x0a"
"", 38752 ); }