#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_ext_hash_set( 
"// -*- C++ -*-\x0a"
"//===------------------------- hash_set ------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_HASH_SET\x0a"
"#define _LIBCPP_HASH_SET\x0a"
"\x0a"
"/*\x0a"
"\x0a"
"    hash_set synopsis\x0a"
"\x0a"
"namespace __gnu_cxx\x0a"
"{\x0a"
"\x0a"
"template <class Value, class Hash = hash<Value>, class Pred = equal_to<Value>,\x0a"
"          class Alloc = allocator<Value>>\x0a"
"class hash_set\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef Value                                                      key_type;\x0a"
"    typedef key_type                                                   value_type;\x0a"
"    typedef Hash                                                       hasher;\x0a"
"    typedef Pred                                                       key_equal;\x0a"
"    typedef Alloc                                                      allocator_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef /unspecified/ iterator;\x0a"
"    typedef /unspecified/ const_iterator;\x0a"
"\x0a"
"    explicit hash_set(size_type n = 193, const hasher\x26 hf = hasher(),\x0a"
"                           const key_equal\x26 eql = key_equal(),\x0a"
"                           const allocator_type\x26 a = allocator_type());\x0a"
"    template <class InputIterator>\x0a"
"        hash_set(InputIterator f, InputIterator l,\x0a"
"                      size_type n = 193, const hasher\x26 hf = hasher(),\x0a"
"                      const key_equal\x26 eql = key_equal(),\x0a"
"                      const allocator_type\x26 a = allocator_type());\x0a"
"    hash_set(const hash_set\x26);\x0a"
"    \x7ehash_set();\x0a"
"    hash_set\x26 operator=(const hash_set\x26);\x0a"
"\x0a"
"    allocator_type get_allocator() const;\x0a"
"\x0a"
"    bool      empty() const;\x0a"
"    size_type size() const;\x0a"
"    size_type max_size() const;\x0a"
"\x0a"
"    iterator       begin();\x0a"
"    iterator       end();\x0a"
"    const_iterator begin()  const;\x0a"
"    const_iterator end()    const;\x0a"
"\x0a"
"    pair<iterator, bool> insert(const value_type\x26 obj);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"\x0a"
"    void erase(const_iterator position);\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    void erase(const_iterator first, const_iterator last);\x0a"
"    void clear();\x0a"
"\x0a"
"    void swap(hash_set\x26);\x0a"
"\x0a"
"    hasher hash_funct() const;\x0a"
"    key_equal key_eq() const;\x0a"
"\x0a"
"    iterator       find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    size_type count(const key_type\x26 k) const;\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"\x0a"
"    size_type bucket_count() const;\x0a"
"    size_type max_bucket_count() const;\x0a"
"\x0a"
"    size_type elems_in_bucket(size_type n) const;\x0a"
"\x0a"
"    void resize(size_type n);\x0a"
"};\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    void swap(hash_set<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"              hash_set<Value, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator==(const hash_set<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"               const hash_set<Value, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator\x21=(const hash_set<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"               const hash_set<Value, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Value, class Hash = hash<Value>, class Pred = equal_to<Value>,\x0a"
"          class Alloc = allocator<Value>>\x0a"
"class hash_multiset\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef Value                                                      key_type;\x0a"
"    typedef key_type                                                   value_type;\x0a"
"    typedef Hash                                                       hasher;\x0a"
"    typedef Pred                                                       key_equal;\x0a"
"    typedef Alloc                                                      allocator_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef /unspecified/ iterator;\x0a"
"    typedef /unspecified/ const_iterator;\x0a"
"\x0a"
"    explicit hash_multiset(size_type n = 193, const hasher\x26 hf = hasher(),\x0a"
"                           const key_equal\x26 eql = key_equal(),\x0a"
"                           const allocator_type\x26 a = allocator_type());\x0a"
"    template <class InputIterator>\x0a"
"        hash_multiset(InputIterator f, InputIterator l,\x0a"
"                      size_type n = 193, const hasher\x26 hf = hasher(),\x0a"
"                      const key_equal\x26 eql = key_equal(),\x0a"
"                      const allocator_type\x26 a = allocator_type());\x0a"
"    hash_multiset(const hash_multiset\x26);\x0a"
"    \x7ehash_multiset();\x0a"
"    hash_multiset\x26 operator=(const hash_multiset\x26);\x0a"
"\x0a"
"    allocator_type get_allocator() const;\x0a"
"\x0a"
"    bool      empty() const;\x0a"
"    size_type size() const;\x0a"
"    size_type max_size() const;\x0a"
"\x0a"
"    iterator       begin();\x0a"
"    iterator       end();\x0a"
"    const_iterator begin()  const;\x0a"
"    const_iterator end()    const;\x0a"
"\x0a"
"    iterator insert(const value_type\x26 obj);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"\x0a"
"    void erase(const_iterator position);\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    void erase(const_iterator first, const_iterator last);\x0a"
"    void clear();\x0a"
"\x0a"
"    void swap(hash_multiset\x26);\x0a"
"\x0a"
"    hasher hash_funct() const;\x0a"
"    key_equal key_eq() const;\x0a"
"\x0a"
"    iterator       find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    size_type count(const key_type\x26 k) const;\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"\x0a"
"    size_type bucket_count() const;\x0a"
"    size_type max_bucket_count() const;\x0a"
"\x0a"
"    size_type elems_in_bucket(size_type n) const;\x0a"
"\x0a"
"    void resize(size_type n);\x0a"
"};\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    void swap(hash_multiset<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"              hash_multiset<Value, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator==(const hash_multiset<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"               const hash_multiset<Value, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator\x21=(const hash_multiset<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"               const hash_multiset<Value, Hash, Pred, Alloc>\x26 y);\x0a"
"}  // __gnu_cxx\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__hash_table>\x0a"
"#include <functional>\x0a"
"#include <ext/__hash>\x0a"
"\x0a"
"#if __DEPRECATED\x0a"
"#if defined(_LIBCPP_WARNING)\x0a"
"    _LIBCPP_WARNING(\x22Use of the header <ext/hash_set> is deprecated.  Migrate to <unordered_set>\x22)\x0a"
"#else\x0a"
"#   warning Use of the header <ext/hash_set> is deprecated.  Migrate to <unordered_set>\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"namespace __gnu_cxx {\x0a"
"\x0a"
"\x0a"
"template <class _Value, class _Hash = hash<_Value>, class _Pred = std\x3a\x3a""equal_to<_Value>,\x0a"
"          class _Alloc = std\x3a\x3a""allocator<_Value> >\x0a"
"class _LIBCPP_TEMPLATE_VIS hash_set\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _Value                                                     key_type;\x0a"
"    typedef key_type                                                   value_type;\x0a"
"    typedef _Hash                                                      hasher;\x0a"
"    typedef _Pred                                                      key_equal;\x0a"
"    typedef _Alloc                                                     allocator_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef std\x3a\x3a__hash_table<value_type, hasher, key_equal, allocator_type> __table;\x0a"
"\x0a"
"    __table __table_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __table\x3a\x3apointer         pointer;\x0a"
"    typedef typename __table\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename __table\x3a\x3asize_type       size_type;\x0a"
"    typedef typename __table\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef typename __table\x3a\x3a""const_iterator       iterator;\x0a"
"    typedef typename __table\x3a\x3a""const_iterator       const_iterator;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hash_set() {__table_.rehash(193);}\x0a"
"    explicit hash_set(size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                           const key_equal\x26 __eql = key_equal());\x0a"
"    hash_set(size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"                  const allocator_type\x26 __a);\x0a"
"    template <class _InputIterator>\x0a"
"        hash_set(_InputIterator __first, _InputIterator __last);\x0a"
"    template <class _InputIterator>\x0a"
"        hash_set(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                      const key_equal\x26 __eql = key_equal());\x0a"
"    template <class _InputIterator>\x0a"
"        hash_set(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"                      const allocator_type\x26 __a);\x0a"
"    hash_set(const hash_set\x26 __u);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const\x0a"
"        {return allocator_type(__table_.__node_alloc());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool      empty() const {return __table_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const  {return __table_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const {return __table_.max_size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       begin()        {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       end()          {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin()  const {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()    const {return __table_.end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    std\x3a\x3apair<iterator, bool> insert(const value_type\x26 __x)\x0a"
"        {return __table_.__insert_unique(__x);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator, const value_type\x26 __x) {return insert(__x).first;}\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __first, _InputIterator __last);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void erase(const_iterator __p) {__table_.erase(__p);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k) {return __table_.__erase_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void erase(const_iterator __first, const_iterator __last)\x0a"
"        {__table_.erase(__first, __last);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() {__table_.clear();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(hash_set\x26 __u) {__table_.swap(__u.__table_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hasher hash_funct() const {return __table_.hash_function();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_equal key_eq() const {return __table_.key_eq();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       find(const key_type\x26 __k)       {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type count(const key_type\x26 __k) const {return __table_.__count_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    std\x3a\x3apair<iterator, iterator>             equal_range(const key_type\x26 __k)\x0a"
"        {return __table_.__equal_range_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    std\x3a\x3apair<const_iterator, const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"        {return __table_.__equal_range_unique(__k);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_count() const {return __table_.bucket_count();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_bucket_count() const {return __table_.max_bucket_count();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type elems_in_bucket(size_type __n) const {return __table_.bucket_size(__n);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void resize(size_type __n) {__table_.rehash(__n);}\x0a"
"};\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_set(size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_set(size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_set(\x0a"
"        _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    __table_.rehash(193);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_set(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_set(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_set(\x0a"
"        const hash_set\x26 __u)\x0a"
"    \x3a __table_(__u.__table_)\x0a"
"{\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"inline\x0a"
"void\x0a"
"hash_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3ainsert(_InputIterator __first,\x0a"
"                                                    _InputIterator __last)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __table_.__insert_unique(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(hash_set<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"     hash_set<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"bool\x0a"
"operator==(const hash_set<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const hash_set<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    if (__x.size() \x21= __y.size())\x0a"
"        return false;\x0a"
"    typedef typename hash_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3a""const_iterator\x0a"
"                                                                 const_iterator;\x0a"
"    for (const_iterator __i = __x.begin(), __ex = __x.end(), __ey = __y.end();\x0a"
"            __i \x21= __ex; ++__i)\x0a"
"    {\x0a"
"        const_iterator __j = __y.find(*__i);\x0a"
"        if (__j == __ey \x7c\x7c \x21(*__i == *__j))\x0a"
"            return false;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const hash_set<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const hash_set<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash = hash<_Value>, class _Pred = std\x3a\x3a""equal_to<_Value>,\x0a"
"          class _Alloc = std\x3a\x3a""allocator<_Value> >\x0a"
"class _LIBCPP_TEMPLATE_VIS hash_multiset\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _Value                                                     key_type;\x0a"
"    typedef key_type                                                   value_type;\x0a"
"    typedef _Hash                                                      hasher;\x0a"
"    typedef _Pred                                                      key_equal;\x0a"
"    typedef _Alloc                                                     allocator_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef std\x3a\x3a__hash_table<value_type, hasher, key_equal, allocator_type> __table;\x0a"
"\x0a"
"    __table __table_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __table\x3a\x3apointer         pointer;\x0a"
"    typedef typename __table\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename __table\x3a\x3asize_type       size_type;\x0a"
"    typedef typename __table\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef typename __table\x3a\x3a""const_iterator       iterator;\x0a"
"    typedef typename __table\x3a\x3a""const_iterator       const_iterator;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hash_multiset() {__table_.rehash(193);}\x0a"
"    explicit hash_multiset(size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                                const key_equal\x26 __eql = key_equal());\x0a"
"    hash_multiset(size_type __n, const hasher\x26 __hf,\x0a"
"                       const key_equal\x26 __eql, const allocator_type\x26 __a);\x0a"
"    template <class _InputIterator>\x0a"
"        hash_multiset(_InputIterator __first, _InputIterator __last);\x0a"
"    template <class _InputIterator>\x0a"
"        hash_multiset(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                      const key_equal\x26 __eql = key_equal());\x0a"
"    template <class _InputIterator>\x0a"
"        hash_multiset(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n , const hasher\x26 __hf,\x0a"
"                      const key_equal\x26 __eql, const allocator_type\x26 __a);\x0a"
"    hash_multiset(const hash_multiset\x26 __u);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const\x0a"
"        {return allocator_type(__table_.__node_alloc());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool      empty() const {return __table_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const  {return __table_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const {return __table_.max_size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       begin()        {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       end()          {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin()  const {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()    const {return __table_.end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const value_type\x26 __x) {return __table_.__insert_multi(__x);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator, const value_type\x26 __x) {return insert(__x);}\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __first, _InputIterator __last);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void erase(const_iterator __p) {__table_.erase(__p);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k) {return __table_.__erase_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void erase(const_iterator __first, const_iterator __last)\x0a"
"        {__table_.erase(__first, __last);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() {__table_.clear();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(hash_multiset\x26 __u) {__table_.swap(__u.__table_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hasher hash_funct() const {return __table_.hash_function();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_equal key_eq() const {return __table_.key_eq();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       find(const key_type\x26 __k)       {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type count(const key_type\x26 __k) const {return __table_.__count_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    std\x3a\x3apair<iterator, iterator>             equal_range(const key_type\x26 __k)\x0a"
"        {return __table_.__equal_range_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    std\x3a\x3apair<const_iterator, const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"        {return __table_.__equal_range_multi(__k);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_count() const {return __table_.bucket_count();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_bucket_count() const {return __table_.max_bucket_count();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type elems_in_bucket(size_type __n) const {return __table_.bucket_size(__n);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void resize(size_type __n) {__table_.rehash(__n);}\x0a"
"};\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_multiset(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_multiset(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_multiset(\x0a"
"        _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    __table_.rehash(193);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_multiset(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"hash_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_multiset(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"hash_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3ahash_multiset(\x0a"
"        const hash_multiset\x26 __u)\x0a"
"    \x3a __table_(__u.__table_)\x0a"
"{\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"inline\x0a"
"void\x0a"
"hash_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3ainsert(_InputIterator __first,\x0a"
"                                                    _InputIterator __last)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __table_.__insert_multi(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(hash_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"     hash_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"bool\x0a"
"operator==(const hash_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const hash_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    if (__x.size() \x21= __y.size())\x0a"
"        return false;\x0a"
"    typedef typename hash_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3a""const_iterator\x0a"
"                                                                 const_iterator;\x0a"
"    typedef std\x3a\x3apair<const_iterator, const_iterator> _EqRng;\x0a"
"    for (const_iterator __i = __x.begin(), __ex = __x.end(); __i \x21= __ex;)\x0a"
"    {\x0a"
"        _EqRng __xeq = __x.equal_range(*__i);\x0a"
"        _EqRng __yeq = __y.equal_range(*__i);\x0a"
"        if (_VSTD\x3a\x3a""distance(__xeq.first, __xeq.second) \x21=\x0a"
"            _VSTD\x3a\x3a""distance(__yeq.first, __yeq.second) \x7c\x7c\x0a"
"                  \x21_VSTD\x3a\x3ais_permutation(__xeq.first, __xeq.second, __yeq.first))\x0a"
"            return false;\x0a"
"        __i = __xeq.second;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const hash_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const hash_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"} // __gnu_cxx\x0a"
"\x0a"
"#endif  // _LIBCPP_HASH_SET\x0a"
"", 24893 ); }