#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_fenv_h( 
"// -*- C++ -*-\x0a"
"//===---------------------------- math.h ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_FENV_H\x0a"
"#define _LIBCPP_FENV_H\x0a"
"\x0a"
"\x0a"
"/*\x0a"
"    fenv.h synopsis\x0a"
"\x0a"
"This entire header is C99 / C++0X\x0a"
"\x0a"
"Macros\x3a\x0a"
"\x0a"
"    FE_DIVBYZERO\x0a"
"    FE_INEXACT\x0a"
"    FE_INVALID\x0a"
"    FE_OVERFLOW\x0a"
"    FE_UNDERFLOW\x0a"
"    FE_ALL_EXCEPT\x0a"
"    FE_DOWNWARD\x0a"
"    FE_TONEAREST\x0a"
"    FE_TOWARDZERO\x0a"
"    FE_UPWARD\x0a"
"    FE_DFL_ENV\x0a"
"\x0a"
"Types\x3a\x0a"
"\x0a"
"    fenv_t\x0a"
"    fexcept_t\x0a"
"\x0a"
"int feclearexcept(int excepts);\x0a"
"int fegetexceptflag(fexcept_t* flagp, int excepts);\x0a"
"int feraiseexcept(int excepts);\x0a"
"int fesetexceptflag(const fexcept_t* flagp, int excepts);\x0a"
"int fetestexcept(int excepts);\x0a"
"int fegetround();\x0a"
"int fesetround(int round);\x0a"
"int fegetenv(fenv_t* envp);\x0a"
"int feholdexcept(fenv_t* envp);\x0a"
"int fesetenv(const fenv_t* envp);\x0a"
"int feupdateenv(const fenv_t* envp);\x0a"
"\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#include_next <fenv.h>\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"\x0a"
"extern \x22""C++\x22 {\x0a"
"\x0a"
"#ifdef feclearexcept\x0a"
"#undef feclearexcept\x0a"
"#endif\x0a"
"\x0a"
"#ifdef fegetexceptflag\x0a"
"#undef fegetexceptflag\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#ifdef feraiseexcept\x0a"
"#undef feraiseexcept\x0a"
"#endif\x0a"
"\x0a"
"#ifdef fesetexceptflag\x0a"
"#undef fesetexceptflag\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#ifdef fetestexcept\x0a"
"#undef fetestexcept\x0a"
"#endif\x0a"
"\x0a"
"#ifdef fegetround\x0a"
"#undef fegetround\x0a"
"#endif\x0a"
"\x0a"
"#ifdef fesetround\x0a"
"#undef fesetround\x0a"
"#endif\x0a"
"\x0a"
"#ifdef fegetenv\x0a"
"#undef fegetenv\x0a"
"#endif\x0a"
"\x0a"
"#ifdef feholdexcept\x0a"
"#undef feholdexcept\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#ifdef fesetenv\x0a"
"#undef fesetenv\x0a"
"#endif\x0a"
"\x0a"
"#ifdef feupdateenv\x0a"
"#undef feupdateenv\x0a"
"#endif\x0a"
"\x0a"
"} // extern \x22""C++\x22\x0a"
"\x0a"
"#endif // defined(__cplusplus)\x0a"
"\x0a"
"#endif // _LIBCPP_FENV_H\x0a"
"", 1863 ); }