#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_filesystem( 
"// -*- C++ -*-\x0a"
"//===--------------------------- filesystem -------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"#ifndef _LIBCPP_FILESYSTEM\x0a"
"#define _LIBCPP_FILESYSTEM\x0a"
"/*\x0a"
"    filesystem synopsis\x0a"
"\x0a"
"    namespace std { namespace filesystem {\x0a"
"\x0a"
"    class path;\x0a"
"\x0a"
"    void swap(path\x26 lhs, path\x26 rhs) noexcept;\x0a"
"    size_t hash_value(const path\x26 p) noexcept;\x0a"
"\x0a"
"    bool operator==(const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"    bool operator\x21=(const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"    bool operator< (const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"    bool operator<=(const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"    bool operator> (const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"    bool operator>=(const path\x26 lhs, const path\x26 rhs) noexcept;\x0a"
"\x0a"
"    path operator/ (const path\x26 lhs, const path\x26 rhs);\x0a"
"\x0a"
"    // fs.path.io operators are friends of path.\x0a"
"    template <class charT, class traits>\x0a"
"    friend basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os, const path\x26 p);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is, path\x26 p);\x0a"
"\x0a"
"    template <class Source>\x0a"
"      path u8path(const Source\x26 source);\x0a"
"    template <class InputIterator>\x0a"
"      path u8path(InputIterator first, InputIterator last);\x0a"
"\x0a"
"    class filesystem_error;\x0a"
"    class directory_entry;\x0a"
"\x0a"
"    class directory_iterator;\x0a"
"\x0a"
"    // enable directory_iterator range-based for statements\x0a"
"    directory_iterator begin(directory_iterator iter) noexcept;\x0a"
"    directory_iterator end(const directory_iterator\x26) noexcept;\x0a"
"\x0a"
"    class recursive_directory_iterator;\x0a"
"\x0a"
"    // enable recursive_directory_iterator range-based for statements\x0a"
"    recursive_directory_iterator begin(recursive_directory_iterator iter) noexcept;\x0a"
"    recursive_directory_iterator end(const recursive_directory_iterator\x26) noexcept;\x0a"
"\x0a"
"    class file_status;\x0a"
"\x0a"
"    struct space_info\x0a"
"    {\x0a"
"      uintmax_t capacity;\x0a"
"      uintmax_t free;\x0a"
"      uintmax_t available;\x0a"
"    };\x0a"
"\x0a"
"    enum class file_type;\x0a"
"    enum class perms;\x0a"
"    enum class perm_options;\x0a"
"    enum class copy_options;\x0a"
"    enum class directory_options;\x0a"
"\x0a"
"    typedef chrono\x3a\x3atime_point<trivial-clock>  file_time_type;\x0a"
"\x0a"
"    // operational functions\x0a"
"\x0a"
"    path absolute(const path\x26 p);\x0a"
"    path absolute(const path\x26 p, error_code \x26""ec);\x0a"
"\x0a"
"    path canonical(const path\x26 p);\x0a"
"    path canonical(const path\x26 p, error_code\x26 ec);\x0a"
"\x0a"
"    void copy(const path\x26 from, const path\x26 to);\x0a"
"    void copy(const path\x26 from, const path\x26 to, error_code\x26 ec);\x0a"
"    void copy(const path\x26 from, const path\x26 to, copy_options options);\x0a"
"    void copy(const path\x26 from, const path\x26 to, copy_options options,\x0a"
"                   error_code\x26 ec);\x0a"
"\x0a"
"    bool copy_file(const path\x26 from, const path\x26 to);\x0a"
"    bool copy_file(const path\x26 from, const path\x26 to, error_code\x26 ec);\x0a"
"    bool copy_file(const path\x26 from, const path\x26 to, copy_options option);\x0a"
"    bool copy_file(const path\x26 from, const path\x26 to, copy_options option,\x0a"
"                           error_code\x26 ec);\x0a"
"\x0a"
"    void copy_symlink(const path\x26 existing_symlink, const path\x26 new_symlink);\x0a"
"    void copy_symlink(const path\x26 existing_symlink, const path\x26 new_symlink,\x0a"
"                              error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool create_directories(const path\x26 p);\x0a"
"    bool create_directories(const path\x26 p, error_code\x26 ec);\x0a"
"\x0a"
"    bool create_directory(const path\x26 p);\x0a"
"    bool create_directory(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool create_directory(const path\x26 p, const path\x26 attributes);\x0a"
"    bool create_directory(const path\x26 p, const path\x26 attributes,\x0a"
"                                  error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    void create_directory_symlink(const path\x26 to, const path\x26 new_symlink);\x0a"
"    void create_directory_symlink(const path\x26 to, const path\x26 new_symlink,\x0a"
"                                          error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    void create_hard_link(const path\x26 to, const path\x26 new_hard_link);\x0a"
"    void create_hard_link(const path\x26 to, const path\x26 new_hard_link,\x0a"
"                                  error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    void create_symlink(const path\x26 to, const path\x26 new_symlink);\x0a"
"    void create_symlink(const path\x26 to, const path\x26 new_symlink,\x0a"
"                                error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    path current_path();\x0a"
"    path current_path(error_code\x26 ec);\x0a"
"    void current_path(const path\x26 p);\x0a"
"    void current_path(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool exists(file_status s) noexcept;\x0a"
"    bool exists(const path\x26 p);\x0a"
"    bool exists(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool equivalent(const path\x26 p1, const path\x26 p2);\x0a"
"    bool equivalent(const path\x26 p1, const path\x26 p2, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    uintmax_t    file_size(const path\x26 p);\x0a"
"    uintmax_t    file_size(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    uintmax_t    hard_link_count(const path\x26 p);\x0a"
"    uintmax_t    hard_link_count(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_block_file(file_status s) noexcept;\x0a"
"    bool is_block_file(const path\x26 p);\x0a"
"    bool is_block_file(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_character_file(file_status s) noexcept;\x0a"
"    bool is_character_file(const path\x26 p);\x0a"
"    bool is_character_file(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_directory(file_status s) noexcept;\x0a"
"    bool is_directory(const path\x26 p);\x0a"
"    bool is_directory(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_empty(const path\x26 p);\x0a"
"    bool is_empty(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_fifo(file_status s) noexcept;\x0a"
"    bool is_fifo(const path\x26 p);\x0a"
"    bool is_fifo(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_other(file_status s) noexcept;\x0a"
"    bool is_other(const path\x26 p);\x0a"
"    bool is_other(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_regular_file(file_status s) noexcept;\x0a"
"    bool is_regular_file(const path\x26 p);\x0a"
"    bool is_regular_file(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_socket(file_status s) noexcept;\x0a"
"    bool is_socket(const path\x26 p);\x0a"
"    bool is_socket(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool is_symlink(file_status s) noexcept;\x0a"
"    bool is_symlink(const path\x26 p);\x0a"
"    bool is_symlink(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    file_time_type  last_write_time(const path\x26 p);\x0a"
"    file_time_type  last_write_time(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"    void last_write_time(const path\x26 p, file_time_type new_time);\x0a"
"    void last_write_time(const path\x26 p, file_time_type new_time,\x0a"
"                                 error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    void permissions(const path\x26 p, perms prms,\x0a"
"                     perm_options opts=perm_options\x3a\x3areplace);\x0a"
"    void permissions(const path\x26 p, perms prms, error_code\x26 ec) noexcept;\x0a"
"    void permissions(const path\x26 p, perms prms, perm_options opts,\x0a"
"                     error_code\x26 ec);\x0a"
"\x0a"
"    path proximate(const path\x26 p, error_code\x26 ec);\x0a"
"    path proximate(const path\x26 p, const path\x26 base = current_path());\x0a"
"    path proximate(const path\x26 p, const path\x26 base, error_code \x26""ec);\x0a"
"\x0a"
"    path read_symlink(const path\x26 p);\x0a"
"    path read_symlink(const path\x26 p, error_code\x26 ec);\x0a"
"\x0a"
"    path relative(const path\x26 p, error_code\x26 ec);\x0a"
"    path relative(const path\x26 p, const path\x26 base=current_path());\x0a"
"    path relative(const path\x26 p, const path\x26 base, error_code\x26 ec);\x0a"
"\x0a"
"    bool remove(const path\x26 p);\x0a"
"    bool remove(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    uintmax_t    remove_all(const path\x26 p);\x0a"
"    uintmax_t    remove_all(const path\x26 p, error_code\x26 ec);\x0a"
"\x0a"
"    void rename(const path\x26 from, const path\x26 to);\x0a"
"    void rename(const path\x26 from, const path\x26 to, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    void resize_file(const path\x26 p, uintmax_t size);\x0a"
"    void resize_file(const path\x26 p, uintmax_t size, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    space_info   space(const path\x26 p);\x0a"
"    space_info   space(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    file_status  status(const path\x26 p);\x0a"
"    file_status  status(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    bool status_known(file_status s) noexcept;\x0a"
"\x0a"
"    file_status  symlink_status(const path\x26 p);\x0a"
"    file_status  symlink_status(const path\x26 p, error_code\x26 ec) noexcept;\x0a"
"\x0a"
"    path temp_directory_path();\x0a"
"    path temp_directory_path(error_code\x26 ec);\x0a"
"\x0a"
"    path weakly_canonical(path const\x26 p);\x0a"
"    path weakly_canonical(path const\x26 p, error_code\x26 ec);\x0a"
"\x0a"
"\x0a"
"} }  // namespaces std\x3a\x3a""filesystem\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <cstddef>\x0a"
"#include <cstdlib>\x0a"
"#include <chrono>\x0a"
"#include <iterator>\x0a"
"#include <iosfwd>\x0a"
"#include <locale>\x0a"
"#include <memory>\x0a"
"#include <stack>\x0a"
"#include <string>\x0a"
"#include <system_error>\x0a"
"#include <utility>\x0a"
"#include <iomanip> // for quoted\x0a"
"#include <string_view>\x0a"
"#include <version>\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_FILESYSTEM\x0a"
"\x0a"
"_LIBCPP_AVAILABILITY_FILESYSTEM_PUSH\x0a"
"\x0a"
"typedef chrono\x3a\x3atime_point<_FilesystemClock> file_time_type;\x0a"
"\x0a"
"struct _LIBCPP_TYPE_VIS space_info {\x0a"
"  uintmax_t capacity;\x0a"
"  uintmax_t free;\x0a"
"  uintmax_t available;\x0a"
"};\x0a"
"\x0a"
"enum class _LIBCPP_ENUM_VIS file_type \x3a signed char {\x0a"
"  none = 0,\x0a"
"  not_found = -1,\x0a"
"  regular = 1,\x0a"
"  directory = 2,\x0a"
"  symlink = 3,\x0a"
"  block = 4,\x0a"
"  character = 5,\x0a"
"  fifo = 6,\x0a"
"  socket = 7,\x0a"
"  unknown = 8\x0a"
"};\x0a"
"\x0a"
"enum class _LIBCPP_ENUM_VIS perms \x3a unsigned {\x0a"
"  none = 0,\x0a"
"\x0a"
"  owner_read = 0400,\x0a"
"  owner_write = 0200,\x0a"
"  owner_exec = 0100,\x0a"
"  owner_all = 0700,\x0a"
"\x0a"
"  group_read = 040,\x0a"
"  group_write = 020,\x0a"
"  group_exec = 010,\x0a"
"  group_all = 070,\x0a"
"\x0a"
"  others_read = 04,\x0a"
"  others_write = 02,\x0a"
"  others_exec = 01,\x0a"
"  others_all = 07,\x0a"
"\x0a"
"  all = 0777,\x0a"
"\x0a"
"  set_uid = 04000,\x0a"
"  set_gid = 02000,\x0a"
"  sticky_bit = 01000,\x0a"
"  mask = 07777,\x0a"
"  unknown = 0xFFFF,\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr perms operator\x26(perms _LHS, perms _RHS) {\x0a"
"  return static_cast<perms>(static_cast<unsigned>(_LHS) \x26\x0a"
"                            static_cast<unsigned>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr perms operator\x7c(perms _LHS, perms _RHS) {\x0a"
"  return static_cast<perms>(static_cast<unsigned>(_LHS) \x7c\x0a"
"                            static_cast<unsigned>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr perms operator^(perms _LHS, perms _RHS) {\x0a"
"  return static_cast<perms>(static_cast<unsigned>(_LHS) ^\x0a"
"                            static_cast<unsigned>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr perms operator\x7e(perms _LHS) {\x0a"
"  return static_cast<perms>(\x7estatic_cast<unsigned>(_LHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline perms\x26 operator\x26=(perms\x26 _LHS, perms _RHS) { return _LHS = _LHS \x26 _RHS; }\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline perms\x26 operator\x7c=(perms\x26 _LHS, perms _RHS) { return _LHS = _LHS \x7c _RHS; }\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline perms\x26 operator^=(perms\x26 _LHS, perms _RHS) { return _LHS = _LHS ^ _RHS; }\x0a"
"\x0a"
"enum class _LIBCPP_ENUM_VIS perm_options \x3a unsigned char {\x0a"
"  replace = 1,\x0a"
"  add = 2,\x0a"
"  remove = 4,\x0a"
"  nofollow = 8\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr perm_options operator\x26(perm_options _LHS, perm_options _RHS) {\x0a"
"  return static_cast<perm_options>(static_cast<unsigned>(_LHS) \x26\x0a"
"                                   static_cast<unsigned>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr perm_options operator\x7c(perm_options _LHS, perm_options _RHS) {\x0a"
"  return static_cast<perm_options>(static_cast<unsigned>(_LHS) \x7c\x0a"
"                                   static_cast<unsigned>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr perm_options operator^(perm_options _LHS, perm_options _RHS) {\x0a"
"  return static_cast<perm_options>(static_cast<unsigned>(_LHS) ^\x0a"
"                                   static_cast<unsigned>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr perm_options operator\x7e(perm_options _LHS) {\x0a"
"  return static_cast<perm_options>(\x7estatic_cast<unsigned>(_LHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline perm_options\x26 operator\x26=(perm_options\x26 _LHS, perm_options _RHS) {\x0a"
"  return _LHS = _LHS \x26 _RHS;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline perm_options\x26 operator\x7c=(perm_options\x26 _LHS, perm_options _RHS) {\x0a"
"  return _LHS = _LHS \x7c _RHS;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline perm_options\x26 operator^=(perm_options\x26 _LHS, perm_options _RHS) {\x0a"
"  return _LHS = _LHS ^ _RHS;\x0a"
"}\x0a"
"\x0a"
"enum class _LIBCPP_ENUM_VIS copy_options \x3a unsigned short {\x0a"
"  none = 0,\x0a"
"  skip_existing = 1,\x0a"
"  overwrite_existing = 2,\x0a"
"  update_existing = 4,\x0a"
"  recursive = 8,\x0a"
"  copy_symlinks = 16,\x0a"
"  skip_symlinks = 32,\x0a"
"  directories_only = 64,\x0a"
"  create_symlinks = 128,\x0a"
"  create_hard_links = 256,\x0a"
"  __in_recursive_copy = 512,\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr copy_options operator\x26(copy_options _LHS, copy_options _RHS) {\x0a"
"  return static_cast<copy_options>(static_cast<unsigned short>(_LHS) \x26\x0a"
"                                   static_cast<unsigned short>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr copy_options operator\x7c(copy_options _LHS, copy_options _RHS) {\x0a"
"  return static_cast<copy_options>(static_cast<unsigned short>(_LHS) \x7c\x0a"
"                                   static_cast<unsigned short>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr copy_options operator^(copy_options _LHS, copy_options _RHS) {\x0a"
"  return static_cast<copy_options>(static_cast<unsigned short>(_LHS) ^\x0a"
"                                   static_cast<unsigned short>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr copy_options operator\x7e(copy_options _LHS) {\x0a"
"  return static_cast<copy_options>(\x7estatic_cast<unsigned short>(_LHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline copy_options\x26 operator\x26=(copy_options\x26 _LHS, copy_options _RHS) {\x0a"
"  return _LHS = _LHS \x26 _RHS;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline copy_options\x26 operator\x7c=(copy_options\x26 _LHS, copy_options _RHS) {\x0a"
"  return _LHS = _LHS \x7c _RHS;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline copy_options\x26 operator^=(copy_options\x26 _LHS, copy_options _RHS) {\x0a"
"  return _LHS = _LHS ^ _RHS;\x0a"
"}\x0a"
"\x0a"
"enum class _LIBCPP_ENUM_VIS directory_options \x3a unsigned char {\x0a"
"  none = 0,\x0a"
"  follow_directory_symlink = 1,\x0a"
"  skip_permission_denied = 2\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr directory_options operator\x26(directory_options _LHS,\x0a"
"                                             directory_options _RHS) {\x0a"
"  return static_cast<directory_options>(static_cast<unsigned char>(_LHS) \x26\x0a"
"                                        static_cast<unsigned char>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr directory_options operator\x7c(directory_options _LHS,\x0a"
"                                             directory_options _RHS) {\x0a"
"  return static_cast<directory_options>(static_cast<unsigned char>(_LHS) \x7c\x0a"
"                                        static_cast<unsigned char>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr directory_options operator^(directory_options _LHS,\x0a"
"                                             directory_options _RHS) {\x0a"
"  return static_cast<directory_options>(static_cast<unsigned char>(_LHS) ^\x0a"
"                                        static_cast<unsigned char>(_RHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr directory_options operator\x7e(directory_options _LHS) {\x0a"
"  return static_cast<directory_options>(\x7estatic_cast<unsigned char>(_LHS));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline directory_options\x26 operator\x26=(directory_options\x26 _LHS,\x0a"
"                                     directory_options _RHS) {\x0a"
"  return _LHS = _LHS \x26 _RHS;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline directory_options\x26 operator\x7c=(directory_options\x26 _LHS,\x0a"
"                                     directory_options _RHS) {\x0a"
"  return _LHS = _LHS \x7c _RHS;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline directory_options\x26 operator^=(directory_options\x26 _LHS,\x0a"
"                                     directory_options _RHS) {\x0a"
"  return _LHS = _LHS ^ _RHS;\x0a"
"}\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS file_status {\x0a"
"public\x3a\x0a"
"  // constructors\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_status() noexcept \x3a file_status(file_type\x3a\x3anone) {}\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit file_status(file_type __ft, perms __prms = perms\x3a\x3aunknown) noexcept\x0a"
"      \x3a __ft_(__ft),\x0a"
"        __prms_(__prms) {}\x0a"
"\x0a"
"  file_status(const file_status\x26) noexcept = default;\x0a"
"  file_status(file_status\x26\x26) noexcept = default;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  \x7e""file_status() {}\x0a"
"\x0a"
"  file_status\x26 operator=(const file_status\x26) noexcept = default;\x0a"
"  file_status\x26 operator=(file_status\x26\x26) noexcept = default;\x0a"
"\x0a"
"  // observers\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_type type() const noexcept { return __ft_; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  perms permissions() const noexcept { return __prms_; }\x0a"
"\x0a"
"  // modifiers\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void type(file_type __ft) noexcept { __ft_ = __ft; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void permissions(perms __p) noexcept { __prms_ = __p; }\x0a"
"\x0a"
"private\x3a\x0a"
"  file_type __ft_;\x0a"
"  perms __prms_;\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS directory_entry;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __can_convert_char {\x0a"
"  static const bool value = false;\x0a"
"};\x0a"
"template <class _Tp>\x0a"
"struct __can_convert_char<const _Tp> \x3a public __can_convert_char<_Tp> {};\x0a"
"template <>\x0a"
"struct __can_convert_char<char> {\x0a"
"  static const bool value = true;\x0a"
"  using __char_type = char;\x0a"
"};\x0a"
"template <>\x0a"
"struct __can_convert_char<wchar_t> {\x0a"
"  static const bool value = true;\x0a"
"  using __char_type = wchar_t;\x0a"
"};\x0a"
"template <>\x0a"
"struct __can_convert_char<char16_t> {\x0a"
"  static const bool value = true;\x0a"
"  using __char_type = char16_t;\x0a"
"};\x0a"
"template <>\x0a"
"struct __can_convert_char<char32_t> {\x0a"
"  static const bool value = true;\x0a"
"  using __char_type = char32_t;\x0a"
"};\x0a"
"\x0a"
"template <class _ECharT>\x0a"
"typename enable_if<__can_convert_char<_ECharT>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"__is_separator(_ECharT __e) {\x0a"
"  return __e == _ECharT('/');\x0a"
"}\x0a"
"\x0a"
"struct _NullSentinal {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"using _Void = void;\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __is_pathable_string \x3a public false_type {};\x0a"
"\x0a"
"template <class _ECharT, class _Traits, class _Alloc>\x0a"
"struct __is_pathable_string<\x0a"
"    basic_string<_ECharT, _Traits, _Alloc>,\x0a"
"    _Void<typename __can_convert_char<_ECharT>\x3a\x3a__char_type> >\x0a"
"    \x3a public __can_convert_char<_ECharT> {\x0a"
"  using _Str = basic_string<_ECharT, _Traits, _Alloc>;\x0a"
"  using _Base = __can_convert_char<_ECharT>;\x0a"
"  static _ECharT const* __range_begin(_Str const\x26 __s) { return __s.data(); }\x0a"
"  static _ECharT const* __range_end(_Str const\x26 __s) {\x0a"
"    return __s.data() + __s.length();\x0a"
"  }\x0a"
"  static _ECharT __first_or_null(_Str const\x26 __s) {\x0a"
"    return __s.empty() \x3f _ECharT{} \x3a __s\x5b""0\x5d;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _ECharT, class _Traits>\x0a"
"struct __is_pathable_string<\x0a"
"    basic_string_view<_ECharT, _Traits>,\x0a"
"    _Void<typename __can_convert_char<_ECharT>\x3a\x3a__char_type> >\x0a"
"    \x3a public __can_convert_char<_ECharT> {\x0a"
"  using _Str = basic_string_view<_ECharT, _Traits>;\x0a"
"  using _Base = __can_convert_char<_ECharT>;\x0a"
"  static _ECharT const* __range_begin(_Str const\x26 __s) { return __s.data(); }\x0a"
"  static _ECharT const* __range_end(_Str const\x26 __s) {\x0a"
"    return __s.data() + __s.length();\x0a"
"  }\x0a"
"  static _ECharT __first_or_null(_Str const\x26 __s) {\x0a"
"    return __s.empty() \x3f _ECharT{} \x3a __s\x5b""0\x5d;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Source, class _DS = typename decay<_Source>\x3a\x3atype,\x0a"
"          class _UnqualPtrType =\x0a"
"              typename remove_const<typename remove_pointer<_DS>\x3a\x3atype>\x3a\x3atype,\x0a"
"          bool _IsCharPtr = is_pointer<_DS>\x3a\x3avalue\x26\x26\x0a"
"              __can_convert_char<_UnqualPtrType>\x3a\x3avalue>\x0a"
"struct __is_pathable_char_array \x3a false_type {};\x0a"
"\x0a"
"template <class _Source, class _ECharT, class _UPtr>\x0a"
"struct __is_pathable_char_array<_Source, _ECharT*, _UPtr, true>\x0a"
"    \x3a __can_convert_char<typename remove_const<_ECharT>\x3a\x3atype> {\x0a"
"  using _Base = __can_convert_char<typename remove_const<_ECharT>\x3a\x3atype>;\x0a"
"\x0a"
"  static _ECharT const* __range_begin(const _ECharT* __b) { return __b; }\x0a"
"  static _ECharT const* __range_end(const _ECharT* __b) {\x0a"
"    using _Iter = const _ECharT*;\x0a"
"    const _ECharT __sentinal = _ECharT{};\x0a"
"    _Iter __e = __b;\x0a"
"    for (; *__e \x21= __sentinal; ++__e)\x0a"
"      ;\x0a"
"    return __e;\x0a"
"  }\x0a"
"\x0a"
"  static _ECharT __first_or_null(const _ECharT* __b) { return *__b; }\x0a"
"};\x0a"
"\x0a"
"template <class _Iter, bool _IsIt = __is_input_iterator<_Iter>\x3a\x3avalue,\x0a"
"          class = void>\x0a"
"struct __is_pathable_iter \x3a false_type {};\x0a"
"\x0a"
"template <class _Iter>\x0a"
"struct __is_pathable_iter<\x0a"
"    _Iter, true,\x0a"
"    _Void<typename __can_convert_char<\x0a"
"        typename iterator_traits<_Iter>\x3a\x3avalue_type>\x3a\x3a__char_type> >\x0a"
"    \x3a __can_convert_char<typename iterator_traits<_Iter>\x3a\x3avalue_type> {\x0a"
"  using _ECharT = typename iterator_traits<_Iter>\x3a\x3avalue_type;\x0a"
"  using _Base = __can_convert_char<_ECharT>;\x0a"
"\x0a"
"  static _Iter __range_begin(_Iter __b) { return __b; }\x0a"
"  static _NullSentinal __range_end(_Iter) { return _NullSentinal{}; }\x0a"
"\x0a"
"  static _ECharT __first_or_null(_Iter __b) { return *__b; }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool _IsStringT = __is_pathable_string<_Tp>\x3a\x3avalue,\x0a"
"          bool _IsCharIterT = __is_pathable_char_array<_Tp>\x3a\x3avalue,\x0a"
"          bool _IsIterT = \x21_IsCharIterT \x26\x26 __is_pathable_iter<_Tp>\x3a\x3avalue>\x0a"
"struct __is_pathable \x3a false_type {\x0a"
"  static_assert(\x21_IsStringT \x26\x26 \x21_IsCharIterT \x26\x26 \x21_IsIterT, \x22Must all be false\x22);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_pathable<_Tp, true, false, false> \x3a __is_pathable_string<_Tp> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_pathable<_Tp, false, true, false> \x3a __is_pathable_char_array<_Tp> {\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_pathable<_Tp, false, false, true> \x3a __is_pathable_iter<_Tp> {};\x0a"
"\x0a"
"template <class _ECharT>\x0a"
"struct _PathCVT {\x0a"
"  static_assert(__can_convert_char<_ECharT>\x3a\x3avalue,\x0a"
"                \x22""Char type not convertible\x22);\x0a"
"\x0a"
"  typedef __narrow_to_utf8<sizeof(_ECharT) * __CHAR_BIT__> _Narrower;\x0a"
"\x0a"
"  static void __append_range(string\x26 __dest, _ECharT const* __b,\x0a"
"                             _ECharT const* __e) {\x0a"
"    _Narrower()(back_inserter(__dest), __b, __e);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Iter>\x0a"
"  static void __append_range(string\x26 __dest, _Iter __b, _Iter __e) {\x0a"
"    static_assert(\x21is_same<_Iter, _ECharT*>\x3a\x3avalue, \x22""Call const overload\x22);\x0a"
"    if (__b == __e)\x0a"
"      return;\x0a"
"    basic_string<_ECharT> __tmp(__b, __e);\x0a"
"    _Narrower()(back_inserter(__dest), __tmp.data(),\x0a"
"                __tmp.data() + __tmp.length());\x0a"
"  }\x0a"
"\x0a"
"  template <class _Iter>\x0a"
"  static void __append_range(string\x26 __dest, _Iter __b, _NullSentinal) {\x0a"
"    static_assert(\x21is_same<_Iter, _ECharT*>\x3a\x3avalue, \x22""Call const overload\x22);\x0a"
"    const _ECharT __sentinal = _ECharT{};\x0a"
"    if (*__b == __sentinal)\x0a"
"      return;\x0a"
"    basic_string<_ECharT> __tmp;\x0a"
"    for (; *__b \x21= __sentinal; ++__b)\x0a"
"      __tmp.push_back(*__b);\x0a"
"    _Narrower()(back_inserter(__dest), __tmp.data(),\x0a"
"                __tmp.data() + __tmp.length());\x0a"
"  }\x0a"
"\x0a"
"  template <class _Source>\x0a"
"  static void __append_source(string\x26 __dest, _Source const\x26 __s) {\x0a"
"    using _Traits = __is_pathable<_Source>;\x0a"
"    __append_range(__dest, _Traits\x3a\x3a__range_begin(__s),\x0a"
"                   _Traits\x3a\x3a__range_end(__s));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _PathCVT<char> {\x0a"
"\x0a"
"  template <class _Iter>\x0a"
"  static typename enable_if<__is_exactly_input_iterator<_Iter>\x3a\x3avalue>\x3a\x3atype\x0a"
"  __append_range(string\x26 __dest, _Iter __b, _Iter __e) {\x0a"
"    for (; __b \x21= __e; ++__b)\x0a"
"      __dest.push_back(*__b);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Iter>\x0a"
"  static typename enable_if<__is_forward_iterator<_Iter>\x3a\x3avalue>\x3a\x3atype\x0a"
"  __append_range(string\x26 __dest, _Iter __b, _Iter __e) {\x0a"
"    __dest.__append_forward_unsafe(__b, __e);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Iter>\x0a"
"  static void __append_range(string\x26 __dest, _Iter __b, _NullSentinal) {\x0a"
"    const char __sentinal = char{};\x0a"
"    for (; *__b \x21= __sentinal; ++__b)\x0a"
"      __dest.push_back(*__b);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Source>\x0a"
"  static void __append_source(string\x26 __dest, _Source const\x26 __s) {\x0a"
"    using _Traits = __is_pathable<_Source>;\x0a"
"    __append_range(__dest, _Traits\x3a\x3a__range_begin(__s),\x0a"
"                   _Traits\x3a\x3a__range_end(__s));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS path {\x0a"
"  template <class _SourceOrIter, class _Tp = path\x26>\x0a"
"  using _EnableIfPathable =\x0a"
"      typename enable_if<__is_pathable<_SourceOrIter>\x3a\x3avalue, _Tp>\x3a\x3atype;\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  using _SourceChar = typename __is_pathable<_Tp>\x3a\x3a__char_type;\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  using _SourceCVT = _PathCVT<_SourceChar<_Tp> >;\x0a"
"\x0a"
"public\x3a\x0a"
"  typedef char value_type;\x0a"
"  typedef basic_string<value_type> string_type;\x0a"
"  typedef _VSTD\x3a\x3astring_view __string_view;\x0a"
"  static constexpr value_type preferred_separator = '/';\x0a"
"\x0a"
"  enum class _LIBCPP_ENUM_VIS format \x3a unsigned char {\x0a"
"    auto_format,\x0a"
"    native_format,\x0a"
"    generic_format\x0a"
"  };\x0a"
"\x0a"
"  // constructors and destructor\x0a"
"  _LIBCPP_INLINE_VISIBILITY path() noexcept {}\x0a"
"  _LIBCPP_INLINE_VISIBILITY path(const path\x26 __p) \x3a __pn_(__p.__pn_) {}\x0a"
"  _LIBCPP_INLINE_VISIBILITY path(path\x26\x26 __p) noexcept\x0a"
"      \x3a __pn_(_VSTD\x3a\x3amove(__p.__pn_)) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  path(string_type\x26\x26 __s, format = format\x3a\x3a""auto_format) noexcept\x0a"
"      \x3a __pn_(_VSTD\x3a\x3amove(__s)) {}\x0a"
"\x0a"
"  template <class _Source, class = _EnableIfPathable<_Source, void> >\x0a"
"  path(const _Source\x26 __src, format = format\x3a\x3a""auto_format) {\x0a"
"    _SourceCVT<_Source>\x3a\x3a__append_source(__pn_, __src);\x0a"
"  }\x0a"
"\x0a"
"  template <class _InputIt>\x0a"
"  path(_InputIt __first, _InputIt __last, format = format\x3a\x3a""auto_format) {\x0a"
"    typedef typename iterator_traits<_InputIt>\x3a\x3avalue_type _ItVal;\x0a"
"    _PathCVT<_ItVal>\x3a\x3a__append_range(__pn_, __first, __last);\x0a"
"  }\x0a"
"\x0a"
"  // TODO Implement locale conversions.\x0a"
"  template <class _Source, class = _EnableIfPathable<_Source, void> >\x0a"
"  path(const _Source\x26 __src, const locale\x26 __loc, format = format\x3a\x3a""auto_format);\x0a"
"  template <class _InputIt>\x0a"
"  path(_InputIt __first, _InputIt _last, const locale\x26 __loc,\x0a"
"       format = format\x3a\x3a""auto_format);\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  \x7epath() = default;\x0a"
"\x0a"
"  // assignments\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  path\x26 operator=(const path\x26 __p) {\x0a"
"    __pn_ = __p.__pn_;\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  path\x26 operator=(path\x26\x26 __p) noexcept {\x0a"
"    __pn_ = _VSTD\x3a\x3amove(__p.__pn_);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <class = void>\x0a"
"  _LIBCPP_INLINE_VISIBILITY path\x26 operator=(string_type\x26\x26 __s) noexcept {\x0a"
"    __pn_ = _VSTD\x3a\x3amove(__s);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  path\x26 assign(string_type\x26\x26 __s) noexcept {\x0a"
"    __pn_ = _VSTD\x3a\x3amove(__s);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Source>\x0a"
"  _LIBCPP_INLINE_VISIBILITY _EnableIfPathable<_Source>\x0a"
"  operator=(const _Source\x26 __src) {\x0a"
"    return this->assign(__src);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Source>\x0a"
"  _EnableIfPathable<_Source> assign(const _Source\x26 __src) {\x0a"
"    __pn_.clear();\x0a"
"    _SourceCVT<_Source>\x3a\x3a__append_source(__pn_, __src);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <class _InputIt>\x0a"
"  path\x26 assign(_InputIt __first, _InputIt __last) {\x0a"
"    typedef typename iterator_traits<_InputIt>\x3a\x3avalue_type _ItVal;\x0a"
"    __pn_.clear();\x0a"
"    _PathCVT<_ItVal>\x3a\x3a__append_range(__pn_, __first, __last);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"private\x3a\x0a"
"  template <class _ECharT>\x0a"
"  static bool __source_is_absolute(_ECharT __first_or_null) {\x0a"
"    return __is_separator(__first_or_null);\x0a"
"  }\x0a"
"\x0a"
"public\x3a\x0a"
"  // appends\x0a"
"  path\x26 operator/=(const path\x26 __p) {\x0a"
"    if (__p.is_absolute()) {\x0a"
"      __pn_ = __p.__pn_;\x0a"
"      return *this;\x0a"
"    }\x0a"
"    if (has_filename())\x0a"
"      __pn_ += preferred_separator;\x0a"
"    __pn_ += __p.native();\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  // FIXME\x3a Use _LIBCPP_DIAGNOSE_WARNING to produce a diagnostic when __src\x0a"
"  // is known at compile time to be \x22/' since the user almost certainly intended\x0a"
"  // to append a separator instead of overwriting the path with \x22/\x22\x0a"
"  template <class _Source>\x0a"
"  _LIBCPP_INLINE_VISIBILITY _EnableIfPathable<_Source>\x0a"
"  operator/=(const _Source\x26 __src) {\x0a"
"    return this->append(__src);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Source>\x0a"
"  _EnableIfPathable<_Source> append(const _Source\x26 __src) {\x0a"
"    using _Traits = __is_pathable<_Source>;\x0a"
"    using _CVT = _PathCVT<_SourceChar<_Source> >;\x0a"
"    if (__source_is_absolute(_Traits\x3a\x3a__first_or_null(__src)))\x0a"
"      __pn_.clear();\x0a"
"    else if (has_filename())\x0a"
"      __pn_ += preferred_separator;\x0a"
"    _CVT\x3a\x3a__append_source(__pn_, __src);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <class _InputIt>\x0a"
"  path\x26 append(_InputIt __first, _InputIt __last) {\x0a"
"    typedef typename iterator_traits<_InputIt>\x3a\x3avalue_type _ItVal;\x0a"
"    static_assert(__can_convert_char<_ItVal>\x3a\x3avalue, \x22Must convertible\x22);\x0a"
"    using _CVT = _PathCVT<_ItVal>;\x0a"
"    if (__first \x21= __last \x26\x26 __source_is_absolute(*__first))\x0a"
"      __pn_.clear();\x0a"
"    else if (has_filename())\x0a"
"      __pn_ += preferred_separator;\x0a"
"    _CVT\x3a\x3a__append_range(__pn_, __first, __last);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  // concatenation\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  path\x26 operator+=(const path\x26 __x) {\x0a"
"    __pn_ += __x.__pn_;\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  path\x26 operator+=(const string_type\x26 __x) {\x0a"
"    __pn_ += __x;\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  path\x26 operator+=(__string_view __x) {\x0a"
"    __pn_ += __x;\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  path\x26 operator+=(const value_type* __x) {\x0a"
"    __pn_ += __x;\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  path\x26 operator+=(value_type __x) {\x0a"
"    __pn_ += __x;\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <class _ECharT>\x0a"
"  typename enable_if<__can_convert_char<_ECharT>\x3a\x3avalue, path\x26>\x3a\x3atype\x0a"
"  operator+=(_ECharT __x) {\x0a"
"    basic_string<_ECharT> __tmp;\x0a"
"    __tmp += __x;\x0a"
"    _PathCVT<_ECharT>\x3a\x3a__append_source(__pn_, __tmp);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Source>\x0a"
"  _EnableIfPathable<_Source> operator+=(const _Source\x26 __x) {\x0a"
"    return this->concat(__x);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Source>\x0a"
"  _EnableIfPathable<_Source> concat(const _Source\x26 __x) {\x0a"
"    _SourceCVT<_Source>\x3a\x3a__append_source(__pn_, __x);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <class _InputIt>\x0a"
"  path\x26 concat(_InputIt __first, _InputIt __last) {\x0a"
"    typedef typename iterator_traits<_InputIt>\x3a\x3avalue_type _ItVal;\x0a"
"    _PathCVT<_ItVal>\x3a\x3a__append_range(__pn_, __first, __last);\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  // modifiers\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void clear() noexcept { __pn_.clear(); }\x0a"
"\x0a"
"  path\x26 make_preferred() { return *this; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  path\x26 remove_filename() {\x0a"
"    auto __fname = __filename();\x0a"
"    if (\x21__fname.empty())\x0a"
"      __pn_.erase(__fname.data() - __pn_.data());\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  path\x26 replace_filename(const path\x26 __replacement) {\x0a"
"    remove_filename();\x0a"
"    return (*this /= __replacement);\x0a"
"  }\x0a"
"\x0a"
"  path\x26 replace_extension(const path\x26 __replacement = path());\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void swap(path\x26 __rhs) noexcept { __pn_.swap(__rhs.__pn_); }\x0a"
"\x0a"
"  // private helper to allow reserving memory in the path\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void __reserve(size_t __s) { __pn_.reserve(__s); }\x0a"
"\x0a"
"  // native format observers\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const string_type\x26 native() const noexcept { return __pn_; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const value_type* c_str() const noexcept { return __pn_.c_str(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY operator string_type() const { return __pn_; }\x0a"
"\x0a"
"  template <class _ECharT, class _Traits = char_traits<_ECharT>,\x0a"
"            class _Allocator = allocator<_ECharT> >\x0a"
"  basic_string<_ECharT, _Traits, _Allocator>\x0a"
"  string(const _Allocator\x26 __a = _Allocator()) const {\x0a"
"    using _CVT = __widen_from_utf8<sizeof(_ECharT) * __CHAR_BIT__>;\x0a"
"    using _Str = basic_string<_ECharT, _Traits, _Allocator>;\x0a"
"    _Str __s(__a);\x0a"
"    __s.reserve(__pn_.size());\x0a"
"    _CVT()(back_inserter(__s), __pn_.data(), __pn_.data() + __pn_.size());\x0a"
"    return __s;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY std\x3a\x3astring string() const { return __pn_; }\x0a"
"  _LIBCPP_INLINE_VISIBILITY std\x3a\x3awstring wstring() const {\x0a"
"    return string<wchar_t>();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY std\x3a\x3astring u8string() const { return __pn_; }\x0a"
"  _LIBCPP_INLINE_VISIBILITY std\x3a\x3au16string u16string() const {\x0a"
"    return string<char16_t>();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY std\x3a\x3au32string u32string() const {\x0a"
"    return string<char32_t>();\x0a"
"  }\x0a"
"\x0a"
"  // generic format observers\x0a"
"  template <class _ECharT, class _Traits = char_traits<_ECharT>,\x0a"
"            class _Allocator = allocator<_ECharT> >\x0a"
"  basic_string<_ECharT, _Traits, _Allocator>\x0a"
"  generic_string(const _Allocator\x26 __a = _Allocator()) const {\x0a"
"    return string<_ECharT, _Traits, _Allocator>(__a);\x0a"
"  }\x0a"
"\x0a"
"  std\x3a\x3astring generic_string() const { return __pn_; }\x0a"
"  std\x3a\x3awstring generic_wstring() const { return string<wchar_t>(); }\x0a"
"  std\x3a\x3astring generic_u8string() const { return __pn_; }\x0a"
"  std\x3a\x3au16string generic_u16string() const { return string<char16_t>(); }\x0a"
"  std\x3a\x3au32string generic_u32string() const { return string<char32_t>(); }\x0a"
"\x0a"
"private\x3a\x0a"
"  int __compare(__string_view) const;\x0a"
"  __string_view __root_name() const;\x0a"
"  __string_view __root_directory() const;\x0a"
"  __string_view __root_path_raw() const;\x0a"
"  __string_view __relative_path() const;\x0a"
"  __string_view __parent_path() const;\x0a"
"  __string_view __filename() const;\x0a"
"  __string_view __stem() const;\x0a"
"  __string_view __extension() const;\x0a"
"\x0a"
"public\x3a\x0a"
"  // compare\x0a"
"  _LIBCPP_INLINE_VISIBILITY int compare(const path\x26 __p) const noexcept {\x0a"
"    return __compare(__p.__pn_);\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY int compare(const string_type\x26 __s) const {\x0a"
"    return __compare(__s);\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY int compare(__string_view __s) const {\x0a"
"    return __compare(__s);\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY int compare(const value_type* __s) const {\x0a"
"    return __compare(__s);\x0a"
"  }\x0a"
"\x0a"
"  // decomposition\x0a"
"  _LIBCPP_INLINE_VISIBILITY path root_name() const {\x0a"
"    return string_type(__root_name());\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY path root_directory() const {\x0a"
"    return string_type(__root_directory());\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY path root_path() const {\x0a"
"    return root_name().append(string_type(__root_directory()));\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY path relative_path() const {\x0a"
"    return string_type(__relative_path());\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY path parent_path() const {\x0a"
"    return string_type(__parent_path());\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY path filename() const {\x0a"
"    return string_type(__filename());\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY path stem() const { return string_type(__stem()); }\x0a"
"  _LIBCPP_INLINE_VISIBILITY path extension() const {\x0a"
"    return string_type(__extension());\x0a"
"  }\x0a"
"\x0a"
"  // query\x0a"
"  _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY bool\x0a"
"  empty() const noexcept {\x0a"
"    return __pn_.empty();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY bool has_root_name() const {\x0a"
"    return \x21__root_name().empty();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY bool has_root_directory() const {\x0a"
"    return \x21__root_directory().empty();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY bool has_root_path() const {\x0a"
"    return \x21__root_path_raw().empty();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY bool has_relative_path() const {\x0a"
"    return \x21__relative_path().empty();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY bool has_parent_path() const {\x0a"
"    return \x21__parent_path().empty();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY bool has_filename() const {\x0a"
"    return \x21__filename().empty();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY bool has_stem() const { return \x21__stem().empty(); }\x0a"
"  _LIBCPP_INLINE_VISIBILITY bool has_extension() const {\x0a"
"    return \x21__extension().empty();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY bool is_absolute() const {\x0a"
"    return has_root_directory();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY bool is_relative() const { return \x21is_absolute(); }\x0a"
"\x0a"
"  // relative paths\x0a"
"  path lexically_normal() const;\x0a"
"  path lexically_relative(const path\x26 __base) const;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY path lexically_proximate(const path\x26 __base) const {\x0a"
"    path __result = this->lexically_relative(__base);\x0a"
"    if (__result.native().empty())\x0a"
"      return *this;\x0a"
"    return __result;\x0a"
"  }\x0a"
"\x0a"
"  // iterators\x0a"
"  class _LIBCPP_TYPE_VIS iterator;\x0a"
"  typedef iterator const_iterator;\x0a"
"\x0a"
"  iterator begin() const;\x0a"
"  iterator end() const;\x0a"
"\x0a"
"  template <class _CharT, class _Traits>\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend\x0a"
"      typename enable_if<is_same<_CharT, char>\x3a\x3avalue \x26\x26\x0a"
"                             is_same<_Traits, char_traits<char> >\x3a\x3avalue,\x0a"
"                         basic_ostream<_CharT, _Traits>\x26>\x3a\x3atype\x0a"
"      operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const path\x26 __p) {\x0a"
"    __os << std\x3a\x3a__quoted(__p.native());\x0a"
"    return __os;\x0a"
"  }\x0a"
"\x0a"
"  template <class _CharT, class _Traits>\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend\x0a"
"      typename enable_if<\x21is_same<_CharT, char>\x3a\x3avalue \x7c\x7c\x0a"
"                             \x21is_same<_Traits, char_traits<char> >\x3a\x3avalue,\x0a"
"                         basic_ostream<_CharT, _Traits>\x26>\x3a\x3atype\x0a"
"      operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const path\x26 __p) {\x0a"
"    __os << std\x3a\x3a__quoted(__p.string<_CharT, _Traits>());\x0a"
"    return __os;\x0a"
"  }\x0a"
"\x0a"
"  template <class _CharT, class _Traits>\x0a"
"  _LIBCPP_INLINE_VISIBILITY friend basic_istream<_CharT, _Traits>\x26\x0a"
"  operator>>(basic_istream<_CharT, _Traits>\x26 __is, path\x26 __p) {\x0a"
"    basic_string<_CharT, _Traits> __tmp;\x0a"
"    __is >> __quoted(__tmp);\x0a"
"    __p = __tmp;\x0a"
"    return __is;\x0a"
"  }\x0a"
"\x0a"
"  friend _LIBCPP_INLINE_VISIBILITY bool operator==(const path\x26 __lhs, const path\x26 __rhs) noexcept {\x0a"
"    return __lhs.compare(__rhs) == 0;\x0a"
"  }\x0a"
"  friend _LIBCPP_INLINE_VISIBILITY bool operator\x21=(const path\x26 __lhs, const path\x26 __rhs) noexcept {\x0a"
"    return __lhs.compare(__rhs) \x21= 0;\x0a"
"  }\x0a"
"  friend _LIBCPP_INLINE_VISIBILITY bool operator<(const path\x26 __lhs, const path\x26 __rhs) noexcept {\x0a"
"    return __lhs.compare(__rhs) < 0;\x0a"
"  }\x0a"
"  friend _LIBCPP_INLINE_VISIBILITY bool operator<=(const path\x26 __lhs, const path\x26 __rhs) noexcept {\x0a"
"    return __lhs.compare(__rhs) <= 0;\x0a"
"  }\x0a"
"  friend _LIBCPP_INLINE_VISIBILITY bool operator>(const path\x26 __lhs, const path\x26 __rhs) noexcept {\x0a"
"    return __lhs.compare(__rhs) > 0;\x0a"
"  }\x0a"
"  friend _LIBCPP_INLINE_VISIBILITY bool operator>=(const path\x26 __lhs, const path\x26 __rhs) noexcept {\x0a"
"    return __lhs.compare(__rhs) >= 0;\x0a"
"  }\x0a"
"\x0a"
"  friend _LIBCPP_INLINE_VISIBILITY path operator/(const path\x26 __lhs,\x0a"
"                                                  const path\x26 __rhs) {\x0a"
"    path __result(__lhs);\x0a"
"    __result /= __rhs;\x0a"
"    return __result;\x0a"
"  }\x0a"
"private\x3a\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY path\x26\x0a"
"  __assign_view(__string_view const\x26 __s) noexcept {\x0a"
"    __pn_ = string_type(__s);\x0a"
"    return *this;\x0a"
"  }\x0a"
"  string_type __pn_;\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void swap(path\x26 __lhs, path\x26 __rhs) noexcept {\x0a"
"  __lhs.swap(__rhs);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"size_t hash_value(const path\x26 __p) noexcept;\x0a"
"\x0a"
"template <class _Source>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_pathable<_Source>\x3a\x3avalue, path>\x3a\x3atype\x0a"
"    u8path(const _Source\x26 __s) {\x0a"
"  static_assert(\x0a"
"      is_same<typename __is_pathable<_Source>\x3a\x3a__char_type, char>\x3a\x3avalue,\x0a"
"      \x22u8path(Source const\x26) requires Source have a character type of type \x22\x0a"
"      \x22'char'\x22);\x0a"
"  return path(__s);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIt>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_pathable<_InputIt>\x3a\x3avalue, path>\x3a\x3atype\x0a"
"    u8path(_InputIt __f, _InputIt __l) {\x0a"
"  static_assert(\x0a"
"      is_same<typename __is_pathable<_InputIt>\x3a\x3a__char_type, char>\x3a\x3avalue,\x0a"
"      \x22u8path(Iter, Iter) requires Iter have a value_type of type 'char'\x22);\x0a"
"  return path(__f, __l);\x0a"
"}\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS path\x3a\x3aiterator {\x0a"
"public\x3a\x0a"
"  enum _ParserState \x3a unsigned char {\x0a"
"    _Singular,\x0a"
"    _BeforeBegin,\x0a"
"    _InRootName,\x0a"
"    _InRootDir,\x0a"
"    _InFilenames,\x0a"
"    _InTrailingSep,\x0a"
"    _AtEnd\x0a"
"  };\x0a"
"\x0a"
"public\x3a\x0a"
"  typedef bidirectional_iterator_tag iterator_category;\x0a"
"\x0a"
"  typedef path value_type;\x0a"
"  typedef std\x3a\x3aptrdiff_t difference_type;\x0a"
"  typedef const path* pointer;\x0a"
"  typedef const path\x26 reference;\x0a"
"\x0a"
"  typedef void\x0a"
"      __stashing_iterator_tag; // See reverse_iterator and __is_stashing_iterator\x0a"
"\x0a"
"public\x3a\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  iterator()\x0a"
"      \x3a __stashed_elem_(), __path_ptr_(nullptr), __entry_(),\x0a"
"        __state_(_Singular) {}\x0a"
"\x0a"
"  iterator(const iterator\x26) = default;\x0a"
"  \x7eiterator() = default;\x0a"
"\x0a"
"  iterator\x26 operator=(const iterator\x26) = default;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  reference operator*() const { return __stashed_elem_; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  pointer operator->() const { return \x26__stashed_elem_; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  iterator\x26 operator++() {\x0a"
"    _LIBCPP_ASSERT(__state_ \x21= _Singular,\x0a"
"                   \x22""attempting to increment a singular iterator\x22);\x0a"
"    _LIBCPP_ASSERT(__state_ \x21= _AtEnd,\x0a"
"                   \x22""attempting to increment the end iterator\x22);\x0a"
"    return __increment();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  iterator operator++(int) {\x0a"
"    iterator __it(*this);\x0a"
"    this->operator++();\x0a"
"    return __it;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  iterator\x26 operator--() {\x0a"
"    _LIBCPP_ASSERT(__state_ \x21= _Singular,\x0a"
"                   \x22""attempting to decrement a singular iterator\x22);\x0a"
"    _LIBCPP_ASSERT(__entry_.data() \x21= __path_ptr_->native().data(),\x0a"
"                   \x22""attempting to decrement the begin iterator\x22);\x0a"
"    return __decrement();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  iterator operator--(int) {\x0a"
"    iterator __it(*this);\x0a"
"    this->operator--();\x0a"
"    return __it;\x0a"
"  }\x0a"
"\x0a"
"private\x3a\x0a"
"  friend class path;\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY friend bool operator==(const iterator\x26,\x0a"
"                                                          const iterator\x26);\x0a"
"\x0a"
"  iterator\x26 __increment();\x0a"
"  iterator\x26 __decrement();\x0a"
"\x0a"
"  path __stashed_elem_;\x0a"
"  const path* __path_ptr_;\x0a"
"  path\x3a\x3a__string_view __entry_;\x0a"
"  _ParserState __state_;\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool operator==(const path\x3a\x3aiterator\x26 __lhs,\x0a"
"                                                 const path\x3a\x3aiterator\x26 __rhs) {\x0a"
"  return __lhs.__path_ptr_ == __rhs.__path_ptr_ \x26\x26\x0a"
"         __lhs.__entry_.data() == __rhs.__entry_.data();\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool operator\x21=(const path\x3a\x3aiterator\x26 __lhs,\x0a"
"                                                 const path\x3a\x3aiterator\x26 __rhs) {\x0a"
"  return \x21(__lhs == __rhs);\x0a"
"}\x0a"
"\x0a"
"// TODO(ldionne)\x3a We need to pop the pragma and push it again after\x0a"
"//                filesystem_error to work around PR41078.\x0a"
"_LIBCPP_AVAILABILITY_FILESYSTEM_POP\x0a"
"\x0a"
"class _LIBCPP_AVAILABILITY_FILESYSTEM _LIBCPP_EXCEPTION_ABI filesystem_error \x3a public system_error {\x0a"
"public\x3a\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  filesystem_error(const string\x26 __what, error_code __ec)\x0a"
"      \x3a system_error(__ec, __what),\x0a"
"        __storage_(make_shared<_Storage>(path(), path())) {\x0a"
"    __create_what(0);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  filesystem_error(const string\x26 __what, const path\x26 __p1, error_code __ec)\x0a"
"      \x3a system_error(__ec, __what),\x0a"
"        __storage_(make_shared<_Storage>(__p1, path())) {\x0a"
"    __create_what(1);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  filesystem_error(const string\x26 __what, const path\x26 __p1, const path\x26 __p2,\x0a"
"                   error_code __ec)\x0a"
"      \x3a system_error(__ec, __what),\x0a"
"        __storage_(make_shared<_Storage>(__p1, __p2)) {\x0a"
"    __create_what(2);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const path\x26 path1() const noexcept { return __storage_->__p1_; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const path\x26 path2() const noexcept { return __storage_->__p2_; }\x0a"
"\x0a"
"  \x7e""filesystem_error() override; // key function\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const char* what() const noexcept override {\x0a"
"    return __storage_->__what_.c_str();\x0a"
"  }\x0a"
"\x0a"
"  void __create_what(int __num_paths);\x0a"
"\x0a"
"private\x3a\x0a"
"  struct _LIBCPP_HIDDEN _Storage {\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Storage(const path\x26 __p1, const path\x26 __p2) \x3a __p1_(__p1), __p2_(__p2) {}\x0a"
"\x0a"
"    path __p1_;\x0a"
"    path __p2_;\x0a"
"    string __what_;\x0a"
"  };\x0a"
"  shared_ptr<_Storage> __storage_;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_AVAILABILITY_FILESYSTEM_PUSH\x0a"
"\x0a"
"template <class... _Args>\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"void __throw_filesystem_error(_Args\x26\x26... __args) {\x0a"
"  throw filesystem_error(std\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"#else\x0a"
"void __throw_filesystem_error(_Args\x26\x26...) {\x0a"
"  _VSTD\x3a\x3a""abort();\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"// operational functions\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"path __absolute(const path\x26, error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"path __canonical(const path\x26, error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void __copy(const path\x26 __from, const path\x26 __to, copy_options __opt,\x0a"
"            error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"bool __copy_file(const path\x26 __from, const path\x26 __to, copy_options __opt,\x0a"
"                 error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void __copy_symlink(const path\x26 __existing_symlink, const path\x26 __new_symlink,\x0a"
"                    error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"bool __create_directories(const path\x26 p, error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"bool __create_directory(const path\x26 p, error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"bool __create_directory(const path\x26 p, const path\x26 attributes,\x0a"
"                        error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void __create_directory_symlink(const path\x26 __to, const path\x26 __new_symlink,\x0a"
"                                error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void __create_hard_link(const path\x26 __to, const path\x26 __new_hard_link,\x0a"
"                        error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void __create_symlink(const path\x26 __to, const path\x26 __new_symlink,\x0a"
"                      error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"path __current_path(error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void __current_path(const path\x26, error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"bool __equivalent(const path\x26, const path\x26, error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"uintmax_t __file_size(const path\x26, error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"uintmax_t __hard_link_count(const path\x26, error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"bool __fs_is_empty(const path\x26 p, error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"file_time_type __last_write_time(const path\x26 p, error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void __last_write_time(const path\x26 p, file_time_type new_time,\x0a"
"                       error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void __permissions(const path\x26, perms, perm_options, error_code* = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"path __read_symlink(const path\x26 p, error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"bool __remove(const path\x26 p, error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"uintmax_t __remove_all(const path\x26 p, error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void __rename(const path\x26 from, const path\x26 to, error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"void __resize_file(const path\x26 p, uintmax_t size, error_code* ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"space_info __space(const path\x26, error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"file_status __status(const path\x26, error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"file_status __symlink_status(const path\x26, error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"path __system_complete(const path\x26, error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"path __temp_directory_path(error_code* __ec = nullptr);\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"path __weakly_canonical(path const\x26 __p, error_code* __ec = nullptr);\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path current_path() {\x0a"
"  return __current_path();\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path current_path(error_code\x26 __ec) {\x0a"
"  return __current_path(\x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void current_path(const path\x26 __p) {\x0a"
"  __current_path(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void current_path(const path\x26 __p,\x0a"
"                                                   error_code\x26 __ec) noexcept {\x0a"
"  __current_path(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path absolute(const path\x26 __p) {\x0a"
"  return __absolute(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path absolute(const path\x26 __p,\x0a"
"                                               error_code\x26 __ec) {\x0a"
"  return __absolute(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path canonical(const path\x26 __p) {\x0a"
"  return __canonical(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path canonical(const path\x26 __p,\x0a"
"                                                error_code\x26 __ec) {\x0a"
"  return __canonical(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void copy(const path\x26 __from,\x0a"
"                                           const path\x26 __to) {\x0a"
"  __copy(__from, __to, copy_options\x3a\x3anone);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void copy(const path\x26 __from, const path\x26 __to,\x0a"
"                                           error_code\x26 __ec) {\x0a"
"  __copy(__from, __to, copy_options\x3a\x3anone, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void copy(const path\x26 __from, const path\x26 __to,\x0a"
"                                           copy_options __opt) {\x0a"
"  __copy(__from, __to, __opt);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void copy(const path\x26 __from, const path\x26 __to,\x0a"
"                                           copy_options __opt,\x0a"
"                                           error_code\x26 __ec) {\x0a"
"  __copy(__from, __to, __opt, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool copy_file(const path\x26 __from,\x0a"
"                                                const path\x26 __to) {\x0a"
"  return __copy_file(__from, __to, copy_options\x3a\x3anone);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"copy_file(const path\x26 __from, const path\x26 __to, error_code\x26 __ec) {\x0a"
"  return __copy_file(__from, __to, copy_options\x3a\x3anone, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"copy_file(const path\x26 __from, const path\x26 __to, copy_options __opt) {\x0a"
"  return __copy_file(__from, __to, __opt);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool copy_file(const path\x26 __from,\x0a"
"                                                const path\x26 __to,\x0a"
"                                                copy_options __opt,\x0a"
"                                                error_code\x26 __ec) {\x0a"
"  return __copy_file(__from, __to, __opt, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void copy_symlink(const path\x26 __existing,\x0a"
"                                                   const path\x26 __new) {\x0a"
"  __copy_symlink(__existing, __new);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"copy_symlink(const path\x26 __ext, const path\x26 __new, error_code\x26 __ec) noexcept {\x0a"
"  __copy_symlink(__ext, __new, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool create_directories(const path\x26 __p) {\x0a"
"  return __create_directories(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool create_directories(const path\x26 __p,\x0a"
"                                                         error_code\x26 __ec) {\x0a"
"  return __create_directories(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool create_directory(const path\x26 __p) {\x0a"
"  return __create_directory(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"create_directory(const path\x26 __p, error_code\x26 __ec) noexcept {\x0a"
"  return __create_directory(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool create_directory(const path\x26 __p,\x0a"
"                                                       const path\x26 __attrs) {\x0a"
"  return __create_directory(__p, __attrs);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"create_directory(const path\x26 __p, const path\x26 __attrs,\x0a"
"                 error_code\x26 __ec) noexcept {\x0a"
"  return __create_directory(__p, __attrs, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"create_directory_symlink(const path\x26 __to, const path\x26 __new) {\x0a"
"  __create_directory_symlink(__to, __new);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"create_directory_symlink(const path\x26 __to, const path\x26 __new,\x0a"
"                         error_code\x26 __ec) noexcept {\x0a"
"  __create_directory_symlink(__to, __new, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void create_hard_link(const path\x26 __to,\x0a"
"                                                       const path\x26 __new) {\x0a"
"  __create_hard_link(__to, __new);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"create_hard_link(const path\x26 __to, const path\x26 __new,\x0a"
"                 error_code\x26 __ec) noexcept {\x0a"
"  __create_hard_link(__to, __new, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void create_symlink(const path\x26 __to,\x0a"
"                                                     const path\x26 __new) {\x0a"
"  __create_symlink(__to, __new);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"create_symlink(const path\x26 __to, const path\x26 __new, error_code\x26 __ec) noexcept {\x0a"
"  return __create_symlink(__to, __new, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool status_known(file_status __s) noexcept {\x0a"
"  return __s.type() \x21= file_type\x3a\x3anone;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool exists(file_status __s) noexcept {\x0a"
"  return status_known(__s) \x26\x26 __s.type() \x21= file_type\x3a\x3anot_found;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool exists(const path\x26 __p) {\x0a"
"  return exists(__status(__p));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool exists(const path\x26 __p,\x0a"
"                                             error_code\x26 __ec) noexcept {\x0a"
"  auto __s = __status(__p, \x26__ec);\x0a"
"  if (status_known(__s))\x0a"
"    __ec.clear();\x0a"
"  return exists(__s);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool equivalent(const path\x26 __p1,\x0a"
"                                                 const path\x26 __p2) {\x0a"
"  return __equivalent(__p1, __p2);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"equivalent(const path\x26 __p1, const path\x26 __p2, error_code\x26 __ec) noexcept {\x0a"
"  return __equivalent(__p1, __p2, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY uintmax_t file_size(const path\x26 __p) {\x0a"
"  return __file_size(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY uintmax_t\x0a"
"file_size(const path\x26 __p, error_code\x26 __ec) noexcept {\x0a"
"  return __file_size(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY uintmax_t hard_link_count(const path\x26 __p) {\x0a"
"  return __hard_link_count(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY uintmax_t\x0a"
"hard_link_count(const path\x26 __p, error_code\x26 __ec) noexcept {\x0a"
"  return __hard_link_count(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_block_file(file_status __s) noexcept {\x0a"
"  return __s.type() == file_type\x3a\x3a""block;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_block_file(const path\x26 __p) {\x0a"
"  return is_block_file(__status(__p));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_block_file(const path\x26 __p,\x0a"
"                                                    error_code\x26 __ec) noexcept {\x0a"
"  return is_block_file(__status(__p, \x26__ec));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"is_character_file(file_status __s) noexcept {\x0a"
"  return __s.type() == file_type\x3a\x3a""character;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_character_file(const path\x26 __p) {\x0a"
"  return is_character_file(__status(__p));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"is_character_file(const path\x26 __p, error_code\x26 __ec) noexcept {\x0a"
"  return is_character_file(__status(__p, \x26__ec));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_directory(file_status __s) noexcept {\x0a"
"  return __s.type() == file_type\x3a\x3a""directory;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_directory(const path\x26 __p) {\x0a"
"  return is_directory(__status(__p));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_directory(const path\x26 __p,\x0a"
"                                                   error_code\x26 __ec) noexcept {\x0a"
"  return is_directory(__status(__p, \x26__ec));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_empty(const path\x26 __p) {\x0a"
"  return __fs_is_empty(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_empty(const path\x26 __p,\x0a"
"                                               error_code\x26 __ec) {\x0a"
"  return __fs_is_empty(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_fifo(file_status __s) noexcept {\x0a"
"  return __s.type() == file_type\x3a\x3a""fifo;\x0a"
"}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_fifo(const path\x26 __p) {\x0a"
"  return is_fifo(__status(__p));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_fifo(const path\x26 __p,\x0a"
"                                              error_code\x26 __ec) noexcept {\x0a"
"  return is_fifo(__status(__p, \x26__ec));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"is_regular_file(file_status __s) noexcept {\x0a"
"  return __s.type() == file_type\x3a\x3aregular;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_regular_file(const path\x26 __p) {\x0a"
"  return is_regular_file(__status(__p));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"is_regular_file(const path\x26 __p, error_code\x26 __ec) noexcept {\x0a"
"  return is_regular_file(__status(__p, \x26__ec));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_socket(file_status __s) noexcept {\x0a"
"  return __s.type() == file_type\x3a\x3asocket;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_socket(const path\x26 __p) {\x0a"
"  return is_socket(__status(__p));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_socket(const path\x26 __p,\x0a"
"                                                error_code\x26 __ec) noexcept {\x0a"
"  return is_socket(__status(__p, \x26__ec));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_symlink(file_status __s) noexcept {\x0a"
"  return __s.type() == file_type\x3a\x3asymlink;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_symlink(const path\x26 __p) {\x0a"
"  return is_symlink(__symlink_status(__p));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_symlink(const path\x26 __p,\x0a"
"                                                 error_code\x26 __ec) noexcept {\x0a"
"  return is_symlink(__symlink_status(__p, \x26__ec));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_other(file_status __s) noexcept {\x0a"
"  return exists(__s) \x26\x26 \x21is_regular_file(__s) \x26\x26 \x21is_directory(__s) \x26\x26\x0a"
"         \x21is_symlink(__s);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_other(const path\x26 __p) {\x0a"
"  return is_other(__status(__p));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool is_other(const path\x26 __p,\x0a"
"                                               error_code\x26 __ec) noexcept {\x0a"
"  return is_other(__status(__p, \x26__ec));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY file_time_type\x0a"
"last_write_time(const path\x26 __p) {\x0a"
"  return __last_write_time(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY file_time_type\x0a"
"last_write_time(const path\x26 __p, error_code\x26 __ec) noexcept {\x0a"
"  return __last_write_time(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void last_write_time(const path\x26 __p,\x0a"
"                                                      file_time_type __t) {\x0a"
"  __last_write_time(__p, __t);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"last_write_time(const path\x26 __p, file_time_type __t,\x0a"
"                error_code\x26 __ec) noexcept {\x0a"
"  __last_write_time(__p, __t, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"permissions(const path\x26 __p, perms __prms,\x0a"
"            perm_options __opts = perm_options\x3a\x3areplace) {\x0a"
"  __permissions(__p, __prms, __opts);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void permissions(const path\x26 __p, perms __prms,\x0a"
"                                                  error_code\x26 __ec) noexcept {\x0a"
"  __permissions(__p, __prms, perm_options\x3a\x3areplace, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void permissions(const path\x26 __p, perms __prms,\x0a"
"                                                  perm_options __opts,\x0a"
"                                                  error_code\x26 __ec) {\x0a"
"  __permissions(__p, __prms, __opts, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path proximate(const path\x26 __p,\x0a"
"                                                const path\x26 __base,\x0a"
"                                                error_code\x26 __ec) {\x0a"
"  path __tmp = __weakly_canonical(__p, \x26__ec);\x0a"
"  if (__ec)\x0a"
"    return {};\x0a"
"  path __tmp_base = __weakly_canonical(__base, \x26__ec);\x0a"
"  if (__ec)\x0a"
"    return {};\x0a"
"  return __tmp.lexically_proximate(__tmp_base);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path proximate(const path\x26 __p,\x0a"
"                                                error_code\x26 __ec) {\x0a"
"  return proximate(__p, current_path(), __ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path\x0a"
"proximate(const path\x26 __p, const path\x26 __base = current_path()) {\x0a"
"  return __weakly_canonical(__p).lexically_proximate(\x0a"
"      __weakly_canonical(__base));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path read_symlink(const path\x26 __p) {\x0a"
"  return __read_symlink(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path read_symlink(const path\x26 __p,\x0a"
"                                                   error_code\x26 __ec) {\x0a"
"  return __read_symlink(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path relative(const path\x26 __p,\x0a"
"                                               const path\x26 __base,\x0a"
"                                               error_code\x26 __ec) {\x0a"
"  path __tmp = __weakly_canonical(__p, \x26__ec);\x0a"
"  if (__ec)\x0a"
"    return path();\x0a"
"  path __tmpbase = __weakly_canonical(__base, \x26__ec);\x0a"
"  if (__ec)\x0a"
"    return path();\x0a"
"  return __tmp.lexically_relative(__tmpbase);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path relative(const path\x26 __p,\x0a"
"                                               error_code\x26 __ec) {\x0a"
"  return relative(__p, current_path(), __ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path\x0a"
"relative(const path\x26 __p, const path\x26 __base = current_path()) {\x0a"
"  return __weakly_canonical(__p).lexically_relative(__weakly_canonical(__base));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool remove(const path\x26 __p) {\x0a"
"  return __remove(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool remove(const path\x26 __p,\x0a"
"                                             error_code\x26 __ec) noexcept {\x0a"
"  return __remove(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY uintmax_t remove_all(const path\x26 __p) {\x0a"
"  return __remove_all(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY uintmax_t remove_all(const path\x26 __p,\x0a"
"                                                      error_code\x26 __ec) {\x0a"
"  return __remove_all(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void rename(const path\x26 __from,\x0a"
"                                             const path\x26 __to) {\x0a"
"  return __rename(__from, __to);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"rename(const path\x26 __from, const path\x26 __to, error_code\x26 __ec) noexcept {\x0a"
"  return __rename(__from, __to, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void resize_file(const path\x26 __p,\x0a"
"                                                  uintmax_t __ns) {\x0a"
"  return __resize_file(__p, __ns);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY void\x0a"
"resize_file(const path\x26 __p, uintmax_t __ns, error_code\x26 __ec) noexcept {\x0a"
"  return __resize_file(__p, __ns, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY space_info space(const path\x26 __p) {\x0a"
"  return __space(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY space_info space(const path\x26 __p,\x0a"
"                                                  error_code\x26 __ec) noexcept {\x0a"
"  return __space(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY file_status status(const path\x26 __p) {\x0a"
"  return __status(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY file_status status(const path\x26 __p,\x0a"
"                                                    error_code\x26 __ec) noexcept {\x0a"
"  return __status(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY file_status symlink_status(const path\x26 __p) {\x0a"
"  return __symlink_status(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY file_status\x0a"
"symlink_status(const path\x26 __p, error_code\x26 __ec) noexcept {\x0a"
"  return __symlink_status(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path temp_directory_path() {\x0a"
"  return __temp_directory_path();\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path temp_directory_path(error_code\x26 __ec) {\x0a"
"  return __temp_directory_path(\x26__ec);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path weakly_canonical(path const\x26 __p) {\x0a"
"  return __weakly_canonical(__p);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY path weakly_canonical(path const\x26 __p,\x0a"
"                                                       error_code\x26 __ec) {\x0a"
"  return __weakly_canonical(__p, \x26__ec);\x0a"
"}\x0a"
"\x0a"
"class directory_iterator;\x0a"
"class recursive_directory_iterator;\x0a"
"class _LIBCPP_HIDDEN __dir_stream;\x0a"
"\x0a"
"class directory_entry {\x0a"
"  typedef _VSTD_FS\x3a\x3apath _Path;\x0a"
"\x0a"
"public\x3a\x0a"
"  // constructors and destructors\x0a"
"  directory_entry() noexcept = default;\x0a"
"  directory_entry(directory_entry const\x26) = default;\x0a"
"  directory_entry(directory_entry\x26\x26) noexcept = default;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit directory_entry(_Path const\x26 __p) \x3a __p_(__p) {\x0a"
"    error_code __ec;\x0a"
"    __refresh(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  directory_entry(_Path const\x26 __p, error_code\x26 __ec) \x3a __p_(__p) {\x0a"
"    __refresh(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  \x7e""directory_entry() {}\x0a"
"\x0a"
"  directory_entry\x26 operator=(directory_entry const\x26) = default;\x0a"
"  directory_entry\x26 operator=(directory_entry\x26\x26) noexcept = default;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void assign(_Path const\x26 __p) {\x0a"
"    __p_ = __p;\x0a"
"    error_code __ec;\x0a"
"    __refresh(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void assign(_Path const\x26 __p, error_code\x26 __ec) {\x0a"
"    __p_ = __p;\x0a"
"    __refresh(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void replace_filename(_Path const\x26 __p) {\x0a"
"    __p_.replace_filename(__p);\x0a"
"    error_code __ec;\x0a"
"    __refresh(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void replace_filename(_Path const\x26 __p, error_code\x26 __ec) {\x0a"
"    __p_ = __p_.parent_path() / __p;\x0a"
"    __refresh(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void refresh() { __refresh(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void refresh(error_code\x26 __ec) noexcept { __refresh(\x26__ec); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _Path const\x26 path() const noexcept { return __p_; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  operator const _Path\x26() const noexcept { return __p_; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool exists() const { return _VSTD_FS\x3a\x3a""exists(file_status{__get_ft()}); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool exists(error_code\x26 __ec) const noexcept {\x0a"
"    return _VSTD_FS\x3a\x3a""exists(file_status{__get_ft(\x26__ec)});\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_block_file() const { return __get_ft() == file_type\x3a\x3a""block; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_block_file(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_ft(\x26__ec) == file_type\x3a\x3a""block;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_character_file() const { return __get_ft() == file_type\x3a\x3a""character; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_character_file(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_ft(\x26__ec) == file_type\x3a\x3a""character;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_directory() const { return __get_ft() == file_type\x3a\x3a""directory; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_directory(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_ft(\x26__ec) == file_type\x3a\x3a""directory;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_fifo() const { return __get_ft() == file_type\x3a\x3a""fifo; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_fifo(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_ft(\x26__ec) == file_type\x3a\x3a""fifo;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_other() const { return _VSTD_FS\x3a\x3ais_other(file_status{__get_ft()}); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_other(error_code\x26 __ec) const noexcept {\x0a"
"    return _VSTD_FS\x3a\x3ais_other(file_status{__get_ft(\x26__ec)});\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_regular_file() const { return __get_ft() == file_type\x3a\x3aregular; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_regular_file(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_ft(\x26__ec) == file_type\x3a\x3aregular;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_socket() const { return __get_ft() == file_type\x3a\x3asocket; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_socket(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_ft(\x26__ec) == file_type\x3a\x3asocket;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_symlink() const { return __get_sym_ft() == file_type\x3a\x3asymlink; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool is_symlink(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_sym_ft(\x26__ec) == file_type\x3a\x3asymlink;\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  uintmax_t file_size() const { return __get_size(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  uintmax_t file_size(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_size(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  uintmax_t hard_link_count() const { return __get_nlink(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  uintmax_t hard_link_count(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_nlink(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_time_type last_write_time() const { return __get_write_time(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_time_type last_write_time(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_write_time(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_status status() const { return __get_status(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_status status(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_status(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_status symlink_status() const { return __get_symlink_status(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_status symlink_status(error_code\x26 __ec) const noexcept {\x0a"
"    return __get_symlink_status(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool operator<(directory_entry const\x26 __rhs) const noexcept {\x0a"
"    return __p_ < __rhs.__p_;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool operator==(directory_entry const\x26 __rhs) const noexcept {\x0a"
"    return __p_ == __rhs.__p_;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool operator\x21=(directory_entry const\x26 __rhs) const noexcept {\x0a"
"    return __p_ \x21= __rhs.__p_;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool operator<=(directory_entry const\x26 __rhs) const noexcept {\x0a"
"    return __p_ <= __rhs.__p_;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool operator>(directory_entry const\x26 __rhs) const noexcept {\x0a"
"    return __p_ > __rhs.__p_;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool operator>=(directory_entry const\x26 __rhs) const noexcept {\x0a"
"    return __p_ >= __rhs.__p_;\x0a"
"  }\x0a"
"\x0a"
"private\x3a\x0a"
"  friend class directory_iterator;\x0a"
"  friend class recursive_directory_iterator;\x0a"
"  friend class __dir_stream;\x0a"
"\x0a"
"  enum _CacheType \x3a unsigned char {\x0a"
"    _Empty,\x0a"
"    _IterSymlink,\x0a"
"    _IterNonSymlink,\x0a"
"    _RefreshSymlink,\x0a"
"    _RefreshSymlinkUnresolved,\x0a"
"    _RefreshNonSymlink\x0a"
"  };\x0a"
"\x0a"
"  struct __cached_data {\x0a"
"    uintmax_t __size_;\x0a"
"    uintmax_t __nlink_;\x0a"
"    file_time_type __write_time_;\x0a"
"    perms __sym_perms_;\x0a"
"    perms __non_sym_perms_;\x0a"
"    file_type __type_;\x0a"
"    _CacheType __cache_type_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __cached_data() noexcept { __reset(); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __reset() {\x0a"
"      __cache_type_ = _Empty;\x0a"
"      __type_ = file_type\x3a\x3anone;\x0a"
"      __sym_perms_ = __non_sym_perms_ = perms\x3a\x3aunknown;\x0a"
"      __size_ = __nlink_ = uintmax_t(-1);\x0a"
"      __write_time_ = file_time_type\x3a\x3amin();\x0a"
"    }\x0a"
"  };\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static __cached_data __create_iter_result(file_type __ft) {\x0a"
"    __cached_data __data;\x0a"
"    __data.__type_ = __ft;\x0a"
"    __data.__cache_type_ = \x5b\x26\x5d() {\x0a"
"      switch (__ft) {\x0a"
"      case file_type\x3a\x3anone\x3a\x0a"
"        return _Empty;\x0a"
"      case file_type\x3a\x3asymlink\x3a\x0a"
"        return _IterSymlink;\x0a"
"      default\x3a\x0a"
"        return _IterNonSymlink;\x0a"
"      }\x0a"
"    }();\x0a"
"    return __data;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void __assign_iter_entry(_Path\x26\x26 __p, __cached_data __dt) {\x0a"
"    __p_ = std\x3a\x3amove(__p);\x0a"
"    __data_ = __dt;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_FUNC_VIS\x0a"
"  error_code __do_refresh() noexcept;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static bool __is_dne_error(error_code const\x26 __ec) {\x0a"
"    if (\x21__ec)\x0a"
"      return true;\x0a"
"    switch (static_cast<errc>(__ec.value())) {\x0a"
"    case errc\x3a\x3ano_such_file_or_directory\x3a\x0a"
"    case errc\x3a\x3anot_a_directory\x3a\x0a"
"      return true;\x0a"
"    default\x3a\x0a"
"      return false;\x0a"
"    }\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void __handle_error(const char* __msg, error_code* __dest_ec,\x0a"
"                      error_code const\x26 __ec, bool __allow_dne = false) const {\x0a"
"    if (__dest_ec) {\x0a"
"      *__dest_ec = __ec;\x0a"
"      return;\x0a"
"    }\x0a"
"    if (__ec \x26\x26 (\x21__allow_dne \x7c\x7c \x21__is_dne_error(__ec)))\x0a"
"      __throw_filesystem_error(__msg, __p_, __ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void __refresh(error_code* __ec = nullptr) {\x0a"
"    __handle_error(\x22in directory_entry\x3a\x3arefresh\x22, __ec, __do_refresh(),\x0a"
"                   /*allow_dne*/ true);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_type __get_sym_ft(error_code* __ec = nullptr) const {\x0a"
"    switch (__data_.__cache_type_) {\x0a"
"    case _Empty\x3a\x0a"
"      return __symlink_status(__p_, __ec).type();\x0a"
"    case _IterSymlink\x3a\x0a"
"    case _RefreshSymlink\x3a\x0a"
"    case _RefreshSymlinkUnresolved\x3a\x0a"
"      if (__ec)\x0a"
"        __ec->clear();\x0a"
"      return file_type\x3a\x3asymlink;\x0a"
"    case _IterNonSymlink\x3a\x0a"
"    case _RefreshNonSymlink\x3a\x0a"
"      file_status __st(__data_.__type_);\x0a"
"      if (__ec \x26\x26 \x21_VSTD_FS\x3a\x3a""exists(__st))\x0a"
"        *__ec = make_error_code(errc\x3a\x3ano_such_file_or_directory);\x0a"
"      else if (__ec)\x0a"
"        __ec->clear();\x0a"
"      return __data_.__type_;\x0a"
"    }\x0a"
"    _LIBCPP_UNREACHABLE();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_type __get_ft(error_code* __ec = nullptr) const {\x0a"
"    switch (__data_.__cache_type_) {\x0a"
"    case _Empty\x3a\x0a"
"    case _IterSymlink\x3a\x0a"
"    case _RefreshSymlinkUnresolved\x3a\x0a"
"      return __status(__p_, __ec).type();\x0a"
"    case _IterNonSymlink\x3a\x0a"
"    case _RefreshNonSymlink\x3a\x0a"
"    case _RefreshSymlink\x3a {\x0a"
"      file_status __st(__data_.__type_);\x0a"
"      if (__ec \x26\x26 \x21_VSTD_FS\x3a\x3a""exists(__st))\x0a"
"        *__ec = make_error_code(errc\x3a\x3ano_such_file_or_directory);\x0a"
"      else if (__ec)\x0a"
"        __ec->clear();\x0a"
"      return __data_.__type_;\x0a"
"    }\x0a"
"    }\x0a"
"    _LIBCPP_UNREACHABLE();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_status __get_status(error_code* __ec = nullptr) const {\x0a"
"    switch (__data_.__cache_type_) {\x0a"
"    case _Empty\x3a\x0a"
"    case _IterNonSymlink\x3a\x0a"
"    case _IterSymlink\x3a\x0a"
"    case _RefreshSymlinkUnresolved\x3a\x0a"
"      return __status(__p_, __ec);\x0a"
"    case _RefreshNonSymlink\x3a\x0a"
"    case _RefreshSymlink\x3a\x0a"
"      return file_status(__get_ft(__ec), __data_.__non_sym_perms_);\x0a"
"    }\x0a"
"    _LIBCPP_UNREACHABLE();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_status __get_symlink_status(error_code* __ec = nullptr) const {\x0a"
"    switch (__data_.__cache_type_) {\x0a"
"    case _Empty\x3a\x0a"
"    case _IterNonSymlink\x3a\x0a"
"    case _IterSymlink\x3a\x0a"
"      return __symlink_status(__p_, __ec);\x0a"
"    case _RefreshNonSymlink\x3a\x0a"
"      return file_status(__get_sym_ft(__ec), __data_.__non_sym_perms_);\x0a"
"    case _RefreshSymlink\x3a\x0a"
"    case _RefreshSymlinkUnresolved\x3a\x0a"
"      return file_status(__get_sym_ft(__ec), __data_.__sym_perms_);\x0a"
"    }\x0a"
"    _LIBCPP_UNREACHABLE();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  uintmax_t __get_size(error_code* __ec = nullptr) const {\x0a"
"    switch (__data_.__cache_type_) {\x0a"
"    case _Empty\x3a\x0a"
"    case _IterNonSymlink\x3a\x0a"
"    case _IterSymlink\x3a\x0a"
"    case _RefreshSymlinkUnresolved\x3a\x0a"
"      return _VSTD_FS\x3a\x3a__file_size(__p_, __ec);\x0a"
"    case _RefreshSymlink\x3a\x0a"
"    case _RefreshNonSymlink\x3a {\x0a"
"      error_code __m_ec;\x0a"
"      file_status __st(__get_ft(\x26__m_ec));\x0a"
"      __handle_error(\x22in directory_entry\x3a\x3a""file_size\x22, __ec, __m_ec);\x0a"
"      if (_VSTD_FS\x3a\x3a""exists(__st) \x26\x26 \x21_VSTD_FS\x3a\x3ais_regular_file(__st)) {\x0a"
"        errc __err_kind = _VSTD_FS\x3a\x3ais_directory(__st) \x3f errc\x3a\x3ais_a_directory\x0a"
"                                                       \x3a errc\x3a\x3anot_supported;\x0a"
"        __handle_error(\x22in directory_entry\x3a\x3a""file_size\x22, __ec,\x0a"
"                       make_error_code(__err_kind));\x0a"
"      }\x0a"
"      return __data_.__size_;\x0a"
"    }\x0a"
"    }\x0a"
"    _LIBCPP_UNREACHABLE();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  uintmax_t __get_nlink(error_code* __ec = nullptr) const {\x0a"
"    switch (__data_.__cache_type_) {\x0a"
"    case _Empty\x3a\x0a"
"    case _IterNonSymlink\x3a\x0a"
"    case _IterSymlink\x3a\x0a"
"    case _RefreshSymlinkUnresolved\x3a\x0a"
"      return _VSTD_FS\x3a\x3a__hard_link_count(__p_, __ec);\x0a"
"    case _RefreshSymlink\x3a\x0a"
"    case _RefreshNonSymlink\x3a {\x0a"
"      error_code __m_ec;\x0a"
"      (void)__get_ft(\x26__m_ec);\x0a"
"      __handle_error(\x22in directory_entry\x3a\x3ahard_link_count\x22, __ec, __m_ec);\x0a"
"      return __data_.__nlink_;\x0a"
"    }\x0a"
"    }\x0a"
"    _LIBCPP_UNREACHABLE();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  file_time_type __get_write_time(error_code* __ec = nullptr) const {\x0a"
"    switch (__data_.__cache_type_) {\x0a"
"    case _Empty\x3a\x0a"
"    case _IterNonSymlink\x3a\x0a"
"    case _IterSymlink\x3a\x0a"
"    case _RefreshSymlinkUnresolved\x3a\x0a"
"      return _VSTD_FS\x3a\x3a__last_write_time(__p_, __ec);\x0a"
"    case _RefreshSymlink\x3a\x0a"
"    case _RefreshNonSymlink\x3a {\x0a"
"      error_code __m_ec;\x0a"
"      file_status __st(__get_ft(\x26__m_ec));\x0a"
"      __handle_error(\x22in directory_entry\x3a\x3alast_write_time\x22, __ec, __m_ec);\x0a"
"      if (_VSTD_FS\x3a\x3a""exists(__st) \x26\x26\x0a"
"          __data_.__write_time_ == file_time_type\x3a\x3amin())\x0a"
"        __handle_error(\x22in directory_entry\x3a\x3alast_write_time\x22, __ec,\x0a"
"                       make_error_code(errc\x3a\x3avalue_too_large));\x0a"
"      return __data_.__write_time_;\x0a"
"    }\x0a"
"    }\x0a"
"    _LIBCPP_UNREACHABLE();\x0a"
"  }\x0a"
"\x0a"
"private\x3a\x0a"
"  _Path __p_;\x0a"
"  __cached_data __data_;\x0a"
"};\x0a"
"\x0a"
"class __dir_element_proxy {\x0a"
"public\x3a\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY directory_entry operator*() {\x0a"
"    return _VSTD\x3a\x3amove(__elem_);\x0a"
"  }\x0a"
"\x0a"
"private\x3a\x0a"
"  friend class directory_iterator;\x0a"
"  friend class recursive_directory_iterator;\x0a"
"  explicit __dir_element_proxy(directory_entry const\x26 __e) \x3a __elem_(__e) {}\x0a"
"  __dir_element_proxy(__dir_element_proxy\x26\x26 __o)\x0a"
"      \x3a __elem_(_VSTD\x3a\x3amove(__o.__elem_)) {}\x0a"
"  directory_entry __elem_;\x0a"
"};\x0a"
"\x0a"
"class directory_iterator {\x0a"
"public\x3a\x0a"
"  typedef directory_entry value_type;\x0a"
"  typedef ptrdiff_t difference_type;\x0a"
"  typedef value_type const* pointer;\x0a"
"  typedef value_type const\x26 reference;\x0a"
"  typedef input_iterator_tag iterator_category;\x0a"
"\x0a"
"public\x3a\x0a"
"  //ctor \x26 dtor\x0a"
"  directory_iterator() noexcept {}\x0a"
"\x0a"
"  explicit directory_iterator(const path\x26 __p)\x0a"
"      \x3a directory_iterator(__p, nullptr) {}\x0a"
"\x0a"
"  directory_iterator(const path\x26 __p, directory_options __opts)\x0a"
"      \x3a directory_iterator(__p, nullptr, __opts) {}\x0a"
"\x0a"
"  directory_iterator(const path\x26 __p, error_code\x26 __ec)\x0a"
"      \x3a directory_iterator(__p, \x26__ec) {}\x0a"
"\x0a"
"  directory_iterator(const path\x26 __p, directory_options __opts,\x0a"
"                     error_code\x26 __ec)\x0a"
"      \x3a directory_iterator(__p, \x26__ec, __opts) {}\x0a"
"\x0a"
"  directory_iterator(const directory_iterator\x26) = default;\x0a"
"  directory_iterator(directory_iterator\x26\x26) = default;\x0a"
"  directory_iterator\x26 operator=(const directory_iterator\x26) = default;\x0a"
"\x0a"
"  directory_iterator\x26 operator=(directory_iterator\x26\x26 __o) noexcept {\x0a"
"    // non-default implementation provided to support self-move assign.\x0a"
"    if (this \x21= \x26__o) {\x0a"
"      __imp_ = _VSTD\x3a\x3amove(__o.__imp_);\x0a"
"    }\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  \x7e""directory_iterator() = default;\x0a"
"\x0a"
"  const directory_entry\x26 operator*() const {\x0a"
"    _LIBCPP_ASSERT(__imp_, \x22The end iterator cannot be dereferenced\x22);\x0a"
"    return __dereference();\x0a"
"  }\x0a"
"\x0a"
"  const directory_entry* operator->() const { return \x26**this; }\x0a"
"\x0a"
"  directory_iterator\x26 operator++() { return __increment(); }\x0a"
"\x0a"
"  __dir_element_proxy operator++(int) {\x0a"
"    __dir_element_proxy __p(**this);\x0a"
"    __increment();\x0a"
"    return __p;\x0a"
"  }\x0a"
"\x0a"
"  directory_iterator\x26 increment(error_code\x26 __ec) { return __increment(\x26__ec); }\x0a"
"\x0a"
"private\x3a\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY friend bool\x0a"
"  operator==(const directory_iterator\x26 __lhs,\x0a"
"             const directory_iterator\x26 __rhs) noexcept;\x0a"
"\x0a"
"  // construct the dir_stream\x0a"
"  _LIBCPP_FUNC_VIS\x0a"
"  directory_iterator(const path\x26, error_code*,\x0a"
"                     directory_options = directory_options\x3a\x3anone);\x0a"
"\x0a"
"  _LIBCPP_FUNC_VIS\x0a"
"  directory_iterator\x26 __increment(error_code* __ec = nullptr);\x0a"
"\x0a"
"  _LIBCPP_FUNC_VIS\x0a"
"  const directory_entry\x26 __dereference() const;\x0a"
"\x0a"
"private\x3a\x0a"
"  shared_ptr<__dir_stream> __imp_;\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"operator==(const directory_iterator\x26 __lhs,\x0a"
"           const directory_iterator\x26 __rhs) noexcept {\x0a"
"  return __lhs.__imp_ == __rhs.__imp_;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"operator\x21=(const directory_iterator\x26 __lhs,\x0a"
"           const directory_iterator\x26 __rhs) noexcept {\x0a"
"  return \x21(__lhs == __rhs);\x0a"
"}\x0a"
"\x0a"
"// enable directory_iterator range-based for statements\x0a"
"inline _LIBCPP_INLINE_VISIBILITY directory_iterator\x0a"
"begin(directory_iterator __iter) noexcept {\x0a"
"  return __iter;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY directory_iterator\x0a"
"end(const directory_iterator\x26) noexcept {\x0a"
"  return directory_iterator();\x0a"
"}\x0a"
"\x0a"
"class recursive_directory_iterator {\x0a"
"public\x3a\x0a"
"  using value_type = directory_entry;\x0a"
"  using difference_type = std\x3a\x3aptrdiff_t;\x0a"
"  using pointer = directory_entry const*;\x0a"
"  using reference = directory_entry const\x26;\x0a"
"  using iterator_category = std\x3a\x3ainput_iterator_tag;\x0a"
"\x0a"
"public\x3a\x0a"
"  // constructors and destructor\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  recursive_directory_iterator() noexcept \x3a __rec_(false) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit recursive_directory_iterator(\x0a"
"      const path\x26 __p, directory_options __xoptions = directory_options\x3a\x3anone)\x0a"
"      \x3a recursive_directory_iterator(__p, __xoptions, nullptr) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  recursive_directory_iterator(const path\x26 __p, directory_options __xoptions,\x0a"
"                               error_code\x26 __ec)\x0a"
"      \x3a recursive_directory_iterator(__p, __xoptions, \x26__ec) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  recursive_directory_iterator(const path\x26 __p, error_code\x26 __ec)\x0a"
"      \x3a recursive_directory_iterator(__p, directory_options\x3a\x3anone, \x26__ec) {}\x0a"
"\x0a"
"  recursive_directory_iterator(const recursive_directory_iterator\x26) = default;\x0a"
"  recursive_directory_iterator(recursive_directory_iterator\x26\x26) = default;\x0a"
"\x0a"
"  recursive_directory_iterator\x26\x0a"
"  operator=(const recursive_directory_iterator\x26) = default;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  recursive_directory_iterator\x26\x0a"
"  operator=(recursive_directory_iterator\x26\x26 __o) noexcept {\x0a"
"    // non-default implementation provided to support self-move assign.\x0a"
"    if (this \x21= \x26__o) {\x0a"
"      __imp_ = _VSTD\x3a\x3amove(__o.__imp_);\x0a"
"      __rec_ = __o.__rec_;\x0a"
"    }\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  \x7erecursive_directory_iterator() = default;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const directory_entry\x26 operator*() const { return __dereference(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const directory_entry* operator->() const { return \x26__dereference(); }\x0a"
"\x0a"
"  recursive_directory_iterator\x26 operator++() { return __increment(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  __dir_element_proxy operator++(int) {\x0a"
"    __dir_element_proxy __p(**this);\x0a"
"    __increment();\x0a"
"    return __p;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  recursive_directory_iterator\x26 increment(error_code\x26 __ec) {\x0a"
"    return __increment(\x26__ec);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_FUNC_VIS directory_options options() const;\x0a"
"  _LIBCPP_FUNC_VIS int depth() const;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void pop() { __pop(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void pop(error_code\x26 __ec) { __pop(\x26__ec); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool recursion_pending() const { return __rec_; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void disable_recursion_pending() { __rec_ = false; }\x0a"
"\x0a"
"private\x3a\x0a"
"  recursive_directory_iterator(const path\x26 __p, directory_options __opt,\x0a"
"                               error_code* __ec);\x0a"
"\x0a"
"  _LIBCPP_FUNC_VIS\x0a"
"  const directory_entry\x26 __dereference() const;\x0a"
"\x0a"
"  _LIBCPP_FUNC_VIS\x0a"
"  bool __try_recursion(error_code* __ec);\x0a"
"\x0a"
"  _LIBCPP_FUNC_VIS\x0a"
"  void __advance(error_code* __ec = nullptr);\x0a"
"\x0a"
"  _LIBCPP_FUNC_VIS\x0a"
"  recursive_directory_iterator\x26 __increment(error_code* __ec = nullptr);\x0a"
"\x0a"
"  _LIBCPP_FUNC_VIS\x0a"
"  void __pop(error_code* __ec = nullptr);\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY friend bool\x0a"
"  operator==(const recursive_directory_iterator\x26,\x0a"
"             const recursive_directory_iterator\x26) noexcept;\x0a"
"\x0a"
"  struct _LIBCPP_HIDDEN __shared_imp;\x0a"
"  shared_ptr<__shared_imp> __imp_;\x0a"
"  bool __rec_;\x0a"
"}; // class recursive_directory_iterator\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool\x0a"
"operator==(const recursive_directory_iterator\x26 __lhs,\x0a"
"           const recursive_directory_iterator\x26 __rhs) noexcept {\x0a"
"  return __lhs.__imp_ == __rhs.__imp_;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline bool operator\x21=(const recursive_directory_iterator\x26 __lhs,\x0a"
"                       const recursive_directory_iterator\x26 __rhs) noexcept {\x0a"
"  return \x21(__lhs == __rhs);\x0a"
"}\x0a"
"// enable recursive_directory_iterator range-based for statements\x0a"
"inline _LIBCPP_INLINE_VISIBILITY recursive_directory_iterator\x0a"
"begin(recursive_directory_iterator __iter) noexcept {\x0a"
"  return __iter;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY recursive_directory_iterator\x0a"
"end(const recursive_directory_iterator\x26) noexcept {\x0a"
"  return recursive_directory_iterator();\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_AVAILABILITY_FILESYSTEM_POP\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_FILESYSTEM\x0a"
"\x0a"
"#endif // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif // _LIBCPP_FILESYSTEM\x0a"
"", 82007 ); }