#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_forward_list( 
"// -*- C++ -*-\x0a"
"//===----------------------- forward_list ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_FORWARD_LIST\x0a"
"#define _LIBCPP_FORWARD_LIST\x0a"
"\x0a"
"/*\x0a"
"    forward_list synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class T, class Allocator = allocator<T>>\x0a"
"class forward_list\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T         value_type;\x0a"
"    typedef Allocator allocator_type;\x0a"
"\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef <details> iterator;\x0a"
"    typedef <details> const_iterator;\x0a"
"\x0a"
"    forward_list()\x0a"
"        noexcept(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    explicit forward_list(const allocator_type\x26 a);\x0a"
"    explicit forward_list(size_type n);\x0a"
"    explicit forward_list(size_type n, const allocator_type\x26 a); // C++14\x0a"
"    forward_list(size_type n, const value_type\x26 v);\x0a"
"    forward_list(size_type n, const value_type\x26 v, const allocator_type\x26 a);\x0a"
"    template <class InputIterator>\x0a"
"        forward_list(InputIterator first, InputIterator last);\x0a"
"    template <class InputIterator>\x0a"
"        forward_list(InputIterator first, InputIterator last, const allocator_type\x26 a);\x0a"
"    forward_list(const forward_list\x26 x);\x0a"
"    forward_list(const forward_list\x26 x, const allocator_type\x26 a);\x0a"
"    forward_list(forward_list\x26\x26 x)\x0a"
"        noexcept(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    forward_list(forward_list\x26\x26 x, const allocator_type\x26 a);\x0a"
"    forward_list(initializer_list<value_type> il);\x0a"
"    forward_list(initializer_list<value_type> il, const allocator_type\x26 a);\x0a"
"\x0a"
"    \x7e""forward_list();\x0a"
"\x0a"
"    forward_list\x26 operator=(const forward_list\x26 x);\x0a"
"    forward_list\x26 operator=(forward_list\x26\x26 x)\x0a"
"        noexcept(\x0a"
"             allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"             is_nothrow_move_assignable<allocator_type>\x3a\x3avalue);\x0a"
"    forward_list\x26 operator=(initializer_list<value_type> il);\x0a"
"\x0a"
"    template <class InputIterator>\x0a"
"        void assign(InputIterator first, InputIterator last);\x0a"
"    void assign(size_type n, const value_type\x26 v);\x0a"
"    void assign(initializer_list<value_type> il);\x0a"
"\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"\x0a"
"    iterator       begin() noexcept;\x0a"
"    const_iterator begin() const noexcept;\x0a"
"    iterator       end() noexcept;\x0a"
"    const_iterator end() const noexcept;\x0a"
"\x0a"
"    const_iterator cbegin() const noexcept;\x0a"
"    const_iterator cend() const noexcept;\x0a"
"\x0a"
"    iterator       before_begin() noexcept;\x0a"
"    const_iterator before_begin() const noexcept;\x0a"
"    const_iterator cbefore_begin() const noexcept;\x0a"
"\x0a"
"    bool empty() const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"\x0a"
"    reference       front();\x0a"
"    const_reference front() const;\x0a"
"\x0a"
"    template <class... Args> reference emplace_front(Args\x26\x26... args);  // reference in C++17\x0a"
"    void push_front(const value_type\x26 v);\x0a"
"    void push_front(value_type\x26\x26 v);\x0a"
"\x0a"
"    void pop_front();\x0a"
"\x0a"
"    template <class... Args>\x0a"
"        iterator emplace_after(const_iterator p, Args\x26\x26... args);\x0a"
"    iterator insert_after(const_iterator p, const value_type\x26 v);\x0a"
"    iterator insert_after(const_iterator p, value_type\x26\x26 v);\x0a"
"    iterator insert_after(const_iterator p, size_type n, const value_type\x26 v);\x0a"
"    template <class InputIterator>\x0a"
"        iterator insert_after(const_iterator p,\x0a"
"                              InputIterator first, InputIterator last);\x0a"
"    iterator insert_after(const_iterator p, initializer_list<value_type> il);\x0a"
"\x0a"
"    iterator erase_after(const_iterator p);\x0a"
"    iterator erase_after(const_iterator first, const_iterator last);\x0a"
"\x0a"
"    void swap(forward_list\x26 x)\x0a"
"        noexcept(allocator_traits<allocator_type>\x3a\x3ais_always_equal\x3a\x3avalue);  // C++17\x0a"
"\x0a"
"    void resize(size_type n);\x0a"
"    void resize(size_type n, const value_type\x26 v);\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    void splice_after(const_iterator p, forward_list\x26 x);\x0a"
"    void splice_after(const_iterator p, forward_list\x26\x26 x);\x0a"
"    void splice_after(const_iterator p, forward_list\x26 x, const_iterator i);\x0a"
"    void splice_after(const_iterator p, forward_list\x26\x26 x, const_iterator i);\x0a"
"    void splice_after(const_iterator p, forward_list\x26 x,\x0a"
"                      const_iterator first, const_iterator last);\x0a"
"    void splice_after(const_iterator p, forward_list\x26\x26 x,\x0a"
"                      const_iterator first, const_iterator last);\x0a"
"    size_type remove(const value_type\x26 v);           // void before C++20\x0a"
"    template <class Predicate>\x0a"
"      size_type remove_if(Predicate pred);           // void before C++20\x0a"
"    size_type unique();                              // void before C++20\x0a"
"    template <class BinaryPredicate>\x0a"
"      size_type unique(BinaryPredicate binary_pred); // void before C++20\x0a"
"    void merge(forward_list\x26 x);\x0a"
"    void merge(forward_list\x26\x26 x);\x0a"
"    template <class Compare> void merge(forward_list\x26 x, Compare comp);\x0a"
"    template <class Compare> void merge(forward_list\x26\x26 x, Compare comp);\x0a"
"    void sort();\x0a"
"    template <class Compare> void sort(Compare comp);\x0a"
"    void reverse() noexcept;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class InputIterator, class Allocator = allocator<typename iterator_traits<InputIterator>\x3a\x3avalue_type>>\x0a"
"    forward_list(InputIterator, InputIterator, Allocator = Allocator())\x0a"
"    -> forward_list<typename iterator_traits<InputIterator>\x3a\x3avalue_type, Allocator>;  // C++17\x0a"
"\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator==(const forward_list<T, Allocator>\x26 x,\x0a"
"                    const forward_list<T, Allocator>\x26 y);\x0a"
"\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator< (const forward_list<T, Allocator>\x26 x,\x0a"
"                    const forward_list<T, Allocator>\x26 y);\x0a"
"\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator\x21=(const forward_list<T, Allocator>\x26 x,\x0a"
"                    const forward_list<T, Allocator>\x26 y);\x0a"
"\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator> (const forward_list<T, Allocator>\x26 x,\x0a"
"                    const forward_list<T, Allocator>\x26 y);\x0a"
"\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator>=(const forward_list<T, Allocator>\x26 x,\x0a"
"                    const forward_list<T, Allocator>\x26 y);\x0a"
"\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator<=(const forward_list<T, Allocator>\x26 x,\x0a"
"                    const forward_list<T, Allocator>\x26 y);\x0a"
"\x0a"
"template <class T, class Allocator>\x0a"
"    void swap(forward_list<T, Allocator>\x26 x, forward_list<T, Allocator>\x26 y)\x0a"
"         noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class T, class Allocator, class U>\x0a"
"    void erase(forward_list<T, Allocator>\x26 c, const U\x26 value);       // C++20\x0a"
"template <class T, class Allocator, class Predicate>\x0a"
"    void erase_if(forward_list<T, Allocator>\x26 c, Predicate pred);    // C++20\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <initializer_list>\x0a"
"#include <memory>\x0a"
"#include <limits>\x0a"
"#include <iterator>\x0a"
"#include <algorithm>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr> struct __forward_list_node;\x0a"
"template <class _NodePtr> struct __forward_begin_node;\x0a"
"\x0a"
"\x0a"
"template <class>\x0a"
"struct __forward_list_node_value_type;\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr>\x0a"
"struct __forward_list_node_value_type<__forward_list_node<_Tp, _VoidPtr> > {\x0a"
"  typedef _Tp type;\x0a"
"};\x0a"
"\x0a"
"template <class _NodePtr>\x0a"
"struct __forward_node_traits {\x0a"
"\x0a"
"  typedef typename remove_cv<\x0a"
"        typename pointer_traits<_NodePtr>\x3a\x3a""element_type>\x3a\x3atype  __node;\x0a"
"  typedef typename __forward_list_node_value_type<__node>\x3a\x3atype __node_value_type;\x0a"
"  typedef _NodePtr                                              __node_pointer;\x0a"
"  typedef __forward_begin_node<_NodePtr>                        __begin_node;\x0a"
"  typedef typename __rebind_pointer<_NodePtr, __begin_node>\x3a\x3atype\x0a"
"                                                                __begin_node_pointer;\x0a"
"  typedef typename __rebind_pointer<_NodePtr, void>\x3a\x3atype       __void_pointer;\x0a"
"\x0a"
"#if defined(_LIBCPP_ABI_FORWARD_LIST_REMOVE_NODE_POINTER_UB)\x0a"
"  typedef __begin_node_pointer __iter_node_pointer;\x0a"
"#else\x0a"
"  typedef typename conditional<\x0a"
"          is_pointer<__void_pointer>\x3a\x3avalue,\x0a"
"          __begin_node_pointer,\x0a"
"          __node_pointer\x0a"
"    >\x3a\x3atype __iter_node_pointer;\x0a"
"#endif\x0a"
"\x0a"
"  typedef typename conditional<\x0a"
"          is_same<__iter_node_pointer, __node_pointer>\x3a\x3avalue,\x0a"
"          __begin_node_pointer,\x0a"
"          __node_pointer\x0a"
"    >\x3a\x3atype __non_iter_node_pointer;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static __iter_node_pointer __as_iter_node(__iter_node_pointer __p) {\x0a"
"      return __p;\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  static __iter_node_pointer __as_iter_node(__non_iter_node_pointer __p) {\x0a"
"      return static_cast<__iter_node_pointer>(static_cast<__void_pointer>(__p));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _NodePtr>\x0a"
"struct __forward_begin_node\x0a"
"{\x0a"
"    typedef _NodePtr pointer;\x0a"
"    typedef typename __rebind_pointer<_NodePtr, __forward_begin_node>\x3a\x3atype __begin_node_pointer;\x0a"
"\x0a"
"    pointer __next_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __forward_begin_node() \x3a __next_(nullptr) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __begin_node_pointer __next_as_begin() const {\x0a"
"        return static_cast<__begin_node_pointer>(__next_);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr>\x0a"
"struct _LIBCPP_HIDDEN __begin_node_of\x0a"
"{\x0a"
"    typedef __forward_begin_node<\x0a"
"        typename __rebind_pointer<_VoidPtr, __forward_list_node<_Tp, _VoidPtr> >\x3a\x3atype\x0a"
"    > type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr>\x0a"
"struct __forward_list_node\x0a"
"    \x3a public __begin_node_of<_Tp, _VoidPtr>\x3a\x3atype\x0a"
"{\x0a"
"    typedef _Tp value_type;\x0a"
"\x0a"
"    value_type __value_;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Alloc = allocator<_Tp> > class _LIBCPP_TEMPLATE_VIS forward_list;\x0a"
"template<class _NodeConstPtr> class _LIBCPP_TEMPLATE_VIS __forward_list_const_iterator;\x0a"
"\x0a"
"template <class _NodePtr>\x0a"
"class _LIBCPP_TEMPLATE_VIS __forward_list_iterator\x0a"
"{\x0a"
"    typedef __forward_node_traits<_NodePtr>         __traits;\x0a"
"    typedef typename __traits\x3a\x3a__node_pointer       __node_pointer;\x0a"
"    typedef typename __traits\x3a\x3a__begin_node_pointer __begin_node_pointer;\x0a"
"    typedef typename __traits\x3a\x3a__iter_node_pointer  __iter_node_pointer;\x0a"
"    typedef typename __traits\x3a\x3a__void_pointer       __void_pointer;\x0a"
"\x0a"
"    __iter_node_pointer __ptr_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __begin_node_pointer __get_begin() const {\x0a"
"        return static_cast<__begin_node_pointer>(\x0a"
"                static_cast<__void_pointer>(__ptr_));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __node_pointer __get_unsafe_node_pointer() const {\x0a"
"        return static_cast<__node_pointer>(\x0a"
"                static_cast<__void_pointer>(__ptr_));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __forward_list_iterator(nullptr_t) _NOEXCEPT \x3a __ptr_(nullptr) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __forward_list_iterator(__begin_node_pointer __p) _NOEXCEPT\x0a"
"        \x3a __ptr_(__traits\x3a\x3a__as_iter_node(__p)) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __forward_list_iterator(__node_pointer __p) _NOEXCEPT\x0a"
"        \x3a __ptr_(__traits\x3a\x3a__as_iter_node(__p)) {}\x0a"
"\x0a"
"    template<class, class> friend class _LIBCPP_TEMPLATE_VIS forward_list;\x0a"
"    template<class> friend class _LIBCPP_TEMPLATE_VIS __forward_list_const_iterator;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef forward_iterator_tag                              iterator_category;\x0a"
"    typedef typename __traits\x3a\x3a__node_value_type              value_type;\x0a"
"    typedef value_type\x26                                       reference;\x0a"
"    typedef typename pointer_traits<__node_pointer>\x3a\x3a""difference_type\x0a"
"                                                              difference_type;\x0a"
"    typedef typename __rebind_pointer<__node_pointer, value_type>\x3a\x3atype pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __forward_list_iterator() _NOEXCEPT \x3a __ptr_(nullptr) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator*() const {return __get_unsafe_node_pointer()->__value_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const {\x0a"
"        return pointer_traits<pointer>\x3a\x3apointer_to(__get_unsafe_node_pointer()->__value_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __forward_list_iterator\x26 operator++()\x0a"
"    {\x0a"
"        __ptr_ = __traits\x3a\x3a__as_iter_node(__ptr_->__next_);\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __forward_list_iterator operator++(int)\x0a"
"    {\x0a"
"        __forward_list_iterator __t(*this);\x0a"
"        ++(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const __forward_list_iterator\x26 __x,\x0a"
"                    const __forward_list_iterator\x26 __y)\x0a"
"        {return __x.__ptr_ == __y.__ptr_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const __forward_list_iterator\x26 __x,\x0a"
"                    const __forward_list_iterator\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _NodeConstPtr>\x0a"
"class _LIBCPP_TEMPLATE_VIS __forward_list_const_iterator\x0a"
"{\x0a"
"    static_assert((\x21is_const<typename pointer_traits<_NodeConstPtr>\x3a\x3a""element_type>\x3a\x3avalue), \x22\x22);\x0a"
"    typedef _NodeConstPtr _NodePtr;\x0a"
"\x0a"
"    typedef __forward_node_traits<_NodePtr>         __traits;\x0a"
"    typedef typename __traits\x3a\x3a__node               __node;\x0a"
"    typedef typename __traits\x3a\x3a__node_pointer       __node_pointer;\x0a"
"    typedef typename __traits\x3a\x3a__begin_node_pointer __begin_node_pointer;\x0a"
"    typedef typename __traits\x3a\x3a__iter_node_pointer  __iter_node_pointer;\x0a"
"    typedef typename __traits\x3a\x3a__void_pointer       __void_pointer;\x0a"
"\x0a"
"    __iter_node_pointer __ptr_;\x0a"
"\x0a"
"    __begin_node_pointer __get_begin() const {\x0a"
"        return static_cast<__begin_node_pointer>(\x0a"
"                static_cast<__void_pointer>(__ptr_));\x0a"
"    }\x0a"
"    __node_pointer __get_unsafe_node_pointer() const {\x0a"
"        return static_cast<__node_pointer>(\x0a"
"                static_cast<__void_pointer>(__ptr_));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __forward_list_const_iterator(nullptr_t) _NOEXCEPT\x0a"
"        \x3a __ptr_(nullptr) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __forward_list_const_iterator(__begin_node_pointer __p) _NOEXCEPT\x0a"
"        \x3a __ptr_(__traits\x3a\x3a__as_iter_node(__p)) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __forward_list_const_iterator(__node_pointer __p) _NOEXCEPT\x0a"
"        \x3a __ptr_(__traits\x3a\x3a__as_iter_node(__p)) {}\x0a"
"\x0a"
"\x0a"
"    template<class, class> friend class forward_list;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef forward_iterator_tag                              iterator_category;\x0a"
"    typedef typename __traits\x3a\x3a__node_value_type              value_type;\x0a"
"    typedef const value_type\x26                                 reference;\x0a"
"    typedef typename pointer_traits<__node_pointer>\x3a\x3a""difference_type\x0a"
"                                                              difference_type;\x0a"
"    typedef typename __rebind_pointer<__node_pointer, const value_type>\x3a\x3atype\x0a"
"                                                              pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __forward_list_const_iterator() _NOEXCEPT \x3a __ptr_(nullptr) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __forward_list_const_iterator(__forward_list_iterator<__node_pointer> __p) _NOEXCEPT\x0a"
"        \x3a __ptr_(__p.__ptr_) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator*() const {return __get_unsafe_node_pointer()->__value_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const {return pointer_traits<pointer>\x3a\x3apointer_to(\x0a"
"                __get_unsafe_node_pointer()->__value_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __forward_list_const_iterator\x26 operator++()\x0a"
"    {\x0a"
"        __ptr_ = __traits\x3a\x3a__as_iter_node(__ptr_->__next_);\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __forward_list_const_iterator operator++(int)\x0a"
"    {\x0a"
"        __forward_list_const_iterator __t(*this);\x0a"
"        ++(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const __forward_list_const_iterator\x26 __x,\x0a"
"                    const __forward_list_const_iterator\x26 __y)\x0a"
"        {return __x.__ptr_ == __y.__ptr_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const __forward_list_const_iterator\x26 __x,\x0a"
"                           const __forward_list_const_iterator\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"class __forward_list_base\x0a"
"{\x0a"
"protected\x3a\x0a"
"    typedef _Tp    value_type;\x0a"
"    typedef _Alloc allocator_type;\x0a"
"\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3avoid_pointer  void_pointer;\x0a"
"    typedef __forward_list_node<value_type, void_pointer>            __node;\x0a"
"    typedef typename __begin_node_of<value_type, void_pointer>\x3a\x3atype __begin_node;\x0a"
"    typedef typename __rebind_alloc_helper<allocator_traits<allocator_type>, __node>\x3a\x3atype __node_allocator;\x0a"
"    typedef allocator_traits<__node_allocator>        __node_traits;\x0a"
"    typedef typename __node_traits\x3a\x3apointer           __node_pointer;\x0a"
"\x0a"
"    typedef typename __rebind_alloc_helper<\x0a"
"        allocator_traits<allocator_type>, __begin_node\x0a"
"    >\x3a\x3atype                                           __begin_node_allocator;\x0a"
"    typedef typename allocator_traits<__begin_node_allocator>\x3a\x3apointer\x0a"
"                                                      __begin_node_pointer;\x0a"
"\x0a"
"    static_assert((\x21is_same<allocator_type, __node_allocator>\x3a\x3avalue),\x0a"
"                  \x22internal allocator type must differ from user-specified \x22\x0a"
"                  \x22type; otherwise overload resolution breaks\x22);\x0a"
"\x0a"
"    __compressed_pair<__begin_node, __node_allocator> __before_begin_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __begin_node_pointer        __before_begin() _NOEXCEPT\x0a"
"        {return pointer_traits<__begin_node_pointer>\x3a\x3apointer_to(__before_begin_.first());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __begin_node_pointer __before_begin() const _NOEXCEPT\x0a"
"        {return pointer_traits<__begin_node_pointer>\x3a\x3apointer_to(const_cast<__begin_node\x26>(__before_begin_.first()));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          __node_allocator\x26 __alloc() _NOEXCEPT\x0a"
"            {return __before_begin_.second();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const __node_allocator\x26 __alloc() const _NOEXCEPT\x0a"
"        {return __before_begin_.second();}\x0a"
"\x0a"
"    typedef __forward_list_iterator<__node_pointer>             iterator;\x0a"
"    typedef __forward_list_const_iterator<__node_pointer>       const_iterator;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __forward_list_base()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<__node_allocator>\x3a\x3avalue)\x0a"
"        \x3a __before_begin_(__begin_node()) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __forward_list_base(const allocator_type\x26 __a)\x0a"
"        \x3a __before_begin_(__begin_node(), __node_allocator(__a)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __forward_list_base(const __node_allocator\x26 __a)\x0a"
"        \x3a __before_begin_(__begin_node(), __a) {}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __forward_list_base(__forward_list_base\x26\x26 __x)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__node_allocator>\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __forward_list_base(__forward_list_base\x26\x26 __x, const allocator_type\x26 __a);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"private\x3a\x0a"
"    __forward_list_base(const __forward_list_base\x26);\x0a"
"    __forward_list_base\x26 operator=(const __forward_list_base\x26);\x0a"
"\x0a"
"public\x3a\x0a"
"    \x7e__forward_list_base();\x0a"
"\x0a"
"protected\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __forward_list_base\x26 __x)\x0a"
"        {__copy_assign_alloc(__x, integral_constant<bool,\x0a"
"              __node_traits\x3a\x3apropagate_on_container_copy_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__forward_list_base\x26 __x)\x0a"
"        _NOEXCEPT_(\x21__node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"                   is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue)\x0a"
"        {__move_assign_alloc(__x, integral_constant<bool,\x0a"
"              __node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(__forward_list_base\x26 __x)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT;\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<__node_allocator>\x3a\x3avalue);\x0a"
"#endif\x0a"
"protected\x3a\x0a"
"    void clear() _NOEXCEPT;\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __forward_list_base\x26, false_type) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __forward_list_base\x26 __x, true_type)\x0a"
"    {\x0a"
"        if (__alloc() \x21= __x.__alloc())\x0a"
"            clear();\x0a"
"        __alloc() = __x.__alloc();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__forward_list_base\x26, false_type) _NOEXCEPT\x0a"
"        {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__forward_list_base\x26 __x, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue)\x0a"
"        {__alloc() = _VSTD\x3a\x3amove(__x.__alloc());}\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"__forward_list_base<_Tp, _Alloc>\x3a\x3a__forward_list_base(__forward_list_base\x26\x26 __x)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__node_allocator>\x3a\x3avalue)\x0a"
"    \x3a __before_begin_(_VSTD\x3a\x3amove(__x.__before_begin_))\x0a"
"{\x0a"
"    __x.__before_begin()->__next_ = nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"__forward_list_base<_Tp, _Alloc>\x3a\x3a__forward_list_base(__forward_list_base\x26\x26 __x,\x0a"
"                                                      const allocator_type\x26 __a)\x0a"
"    \x3a __before_begin_(__begin_node(), __node_allocator(__a))\x0a"
"{\x0a"
"    if (__alloc() == __x.__alloc())\x0a"
"    {\x0a"
"        __before_begin()->__next_ = __x.__before_begin()->__next_;\x0a"
"        __x.__before_begin()->__next_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"__forward_list_base<_Tp, _Alloc>\x3a\x3a\x7e__forward_list_base()\x0a"
"{\x0a"
"    clear();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"void\x0a"
"__forward_list_base<_Tp, _Alloc>\x3a\x3aswap(__forward_list_base\x26 __x)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<__node_allocator>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"    __swap_allocator(__alloc(), __x.__alloc(),\x0a"
"            integral_constant<bool, __node_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue>());\x0a"
"    using _VSTD\x3a\x3aswap;\x0a"
"    swap(__before_begin()->__next_, __x.__before_begin()->__next_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"__forward_list_base<_Tp, _Alloc>\x3a\x3a""clear() _NOEXCEPT\x0a"
"{\x0a"
"    __node_allocator\x26 __a = __alloc();\x0a"
"    for (__node_pointer __p = __before_begin()->__next_; __p \x21= nullptr;)\x0a"
"    {\x0a"
"        __node_pointer __next = __p->__next_;\x0a"
"        __node_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(__p->__value_));\x0a"
"        __node_traits\x3a\x3a""deallocate(__a, __p, 1);\x0a"
"        __p = __next;\x0a"
"    }\x0a"
"    __before_begin()->__next_ = nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc /*= allocator<_Tp>*/>\x0a"
"class _LIBCPP_TEMPLATE_VIS forward_list\x0a"
"    \x3a private __forward_list_base<_Tp, _Alloc>\x0a"
"{\x0a"
"    typedef __forward_list_base<_Tp, _Alloc> base;\x0a"
"    typedef typename base\x3a\x3a__node_allocator  __node_allocator;\x0a"
"    typedef typename base\x3a\x3a__node               __node;\x0a"
"    typedef typename base\x3a\x3a__node_traits        __node_traits;\x0a"
"    typedef typename base\x3a\x3a__node_pointer       __node_pointer;\x0a"
"    typedef typename base\x3a\x3a__begin_node_pointer __begin_node_pointer;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _Tp    value_type;\x0a"
"    typedef _Alloc allocator_type;\x0a"
"\x0a"
"    static_assert((is_same<typename allocator_type\x3a\x3avalue_type, value_type>\x3a\x3avalue),\x0a"
"                  \x22""Allocator\x3a\x3avalue_type must be same type as value_type\x22);\x0a"
"\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef typename base\x3a\x3aiterator       iterator;\x0a"
"    typedef typename base\x3a\x3a""const_iterator const_iterator;\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"    typedef size_type                                __remove_return_type;\x0a"
"#else\x0a"
"    typedef void                                     __remove_return_type;\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    forward_list()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<__node_allocator>\x3a\x3avalue)\x0a"
"        {} // = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit forward_list(const allocator_type\x26 __a);\x0a"
"    explicit forward_list(size_type __n);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    explicit forward_list(size_type __n, const allocator_type\x26 __a);\x0a"
"#endif\x0a"
"    forward_list(size_type __n, const value_type\x26 __v);\x0a"
"    forward_list(size_type __n, const value_type\x26 __v, const allocator_type\x26 __a);\x0a"
"    template <class _InputIterator>\x0a"
"        forward_list(_InputIterator __f, _InputIterator __l,\x0a"
"                     typename enable_if<\x0a"
"                       __is_input_iterator<_InputIterator>\x3a\x3avalue\x0a"
"                     >\x3a\x3atype* = nullptr);\x0a"
"    template <class _InputIterator>\x0a"
"        forward_list(_InputIterator __f, _InputIterator __l,\x0a"
"                     const allocator_type\x26 __a,\x0a"
"                     typename enable_if<\x0a"
"                       __is_input_iterator<_InputIterator>\x3a\x3avalue\x0a"
"                     >\x3a\x3atype* = nullptr);\x0a"
"    forward_list(const forward_list\x26 __x);\x0a"
"    forward_list(const forward_list\x26 __x, const allocator_type\x26 __a);\x0a"
"\x0a"
"    forward_list\x26 operator=(const forward_list\x26 __x);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    forward_list(forward_list\x26\x26 __x)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<base>\x3a\x3avalue)\x0a"
"        \x3a base(_VSTD\x3a\x3amove(__x)) {}\x0a"
"    forward_list(forward_list\x26\x26 __x, const allocator_type\x26 __a);\x0a"
"\x0a"
"    forward_list(initializer_list<value_type> __il);\x0a"
"    forward_list(initializer_list<value_type> __il, const allocator_type\x26 __a);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    forward_list\x26 operator=(forward_list\x26\x26 __x)\x0a"
"        _NOEXCEPT_(\x0a"
"             __node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"             is_nothrow_move_assignable<allocator_type>\x3a\x3avalue);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    forward_list\x26 operator=(initializer_list<value_type> __il);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void assign(initializer_list<value_type> __il);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    // \x7e""forward_list() = default;\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_input_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        assign(_InputIterator __f, _InputIterator __l);\x0a"
"    void assign(size_type __n, const value_type\x26 __v);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT\x0a"
"        {return allocator_type(base\x3a\x3a__alloc());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       begin() _NOEXCEPT\x0a"
"        {return       iterator(base\x3a\x3a__before_begin()->__next_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT\x0a"
"        {return const_iterator(base\x3a\x3a__before_begin()->__next_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       end() _NOEXCEPT\x0a"
"        {return       iterator(nullptr);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end() const _NOEXCEPT\x0a"
"        {return const_iterator(nullptr);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const _NOEXCEPT\x0a"
"        {return const_iterator(base\x3a\x3a__before_begin()->__next_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend() const _NOEXCEPT\x0a"
"        {return const_iterator(nullptr);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       before_begin() _NOEXCEPT\x0a"
"        {return       iterator(base\x3a\x3a__before_begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator before_begin() const _NOEXCEPT\x0a"
"        {return const_iterator(base\x3a\x3a__before_begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbefore_begin() const _NOEXCEPT\x0a"
"        {return const_iterator(base\x3a\x3a__before_begin());}\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT\x0a"
"        {return base\x3a\x3a__before_begin()->__next_ == nullptr;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT {\x0a"
"        return std\x3a\x3amin<size_type>(\x0a"
"            __node_traits\x3a\x3amax_size(base\x3a\x3a__alloc()),\x0a"
"            numeric_limits<difference_type>\x3a\x3amax());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference       front()       {return base\x3a\x3a__before_begin()->__next_->__value_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference front() const {return base\x3a\x3a__before_begin()->__next_->__value_;}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    template <class... _Args> reference emplace_front(_Args\x26\x26... __args);\x0a"
"#else\x0a"
"    template <class... _Args> void      emplace_front(_Args\x26\x26... __args);\x0a"
"#endif\x0a"
"    void push_front(value_type\x26\x26 __v);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    void push_front(const value_type\x26 __v);\x0a"
"\x0a"
"    void pop_front();\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class... _Args>\x0a"
"        iterator emplace_after(const_iterator __p, _Args\x26\x26... __args);\x0a"
"\x0a"
"    iterator insert_after(const_iterator __p, value_type\x26\x26 __v);\x0a"
"    iterator insert_after(const_iterator __p, initializer_list<value_type> __il)\x0a"
"        {return insert_after(__p, __il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    iterator insert_after(const_iterator __p, const value_type\x26 __v);\x0a"
"    iterator insert_after(const_iterator __p, size_type __n, const value_type\x26 __v);\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_input_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"            iterator\x0a"
"        >\x3a\x3atype\x0a"
"        insert_after(const_iterator __p, _InputIterator __f, _InputIterator __l);\x0a"
"\x0a"
"    iterator erase_after(const_iterator __p);\x0a"
"    iterator erase_after(const_iterator __f, const_iterator __l);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(forward_list\x26 __x)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__node_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                   __is_nothrow_swappable<__node_allocator>\x3a\x3avalue)\x0a"
"#endif\x0a"
"        {base\x3a\x3aswap(__x);}\x0a"
"\x0a"
"    void resize(size_type __n);\x0a"
"    void resize(size_type __n, const value_type\x26 __v);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {base\x3a\x3a""clear();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void splice_after(const_iterator __p, forward_list\x26\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void splice_after(const_iterator __p, forward_list\x26\x26 __x, const_iterator __i);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void splice_after(const_iterator __p, forward_list\x26\x26 __x,\x0a"
"                      const_iterator __f, const_iterator __l);\x0a"
"    void splice_after(const_iterator __p, forward_list\x26 __x);\x0a"
"    void splice_after(const_iterator __p, forward_list\x26 __x, const_iterator __i);\x0a"
"    void splice_after(const_iterator __p, forward_list\x26 __x,\x0a"
"                      const_iterator __f, const_iterator __l);\x0a"
"    __remove_return_type remove(const value_type\x26 __v);\x0a"
"    template <class _Predicate> __remove_return_type remove_if(_Predicate __pred);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __remove_return_type unique() {return unique(__equal_to<value_type>());}\x0a"
"    template <class _BinaryPredicate> __remove_return_type unique(_BinaryPredicate __binary_pred);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(forward_list\x26\x26 __x) {merge(__x, __less<value_type>());}\x0a"
"    template <class _Compare>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void merge(forward_list\x26\x26 __x, _Compare __comp)\x0a"
"        {merge(__x, _VSTD\x3a\x3amove(__comp));}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(forward_list\x26 __x) {merge(__x, __less<value_type>());}\x0a"
"    template <class _Compare> void merge(forward_list\x26 __x, _Compare __comp);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void sort() {sort(__less<value_type>());}\x0a"
"    template <class _Compare> _LIBCPP_INLINE_VISIBILITY void sort(_Compare __comp);\x0a"
"    void reverse() _NOEXCEPT;\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    void __move_assign(forward_list\x26 __x, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue);\x0a"
"    void __move_assign(forward_list\x26 __x, false_type);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template <class _Compare>\x0a"
"        static\x0a"
"        __node_pointer\x0a"
"        __merge(__node_pointer __f1, __node_pointer __f2, _Compare\x26 __comp);\x0a"
"\x0a"
"    template <class _Compare>\x0a"
"        static\x0a"
"        __node_pointer\x0a"
"        __sort(__node_pointer __f, difference_type __sz, _Compare\x26 __comp);\x0a"
"};\x0a"
"\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _Alloc = typename std\x3a\x3a""allocator<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>,\x0a"
"         class = typename enable_if<__is_allocator<_Alloc>\x3a\x3avalue, void>\x3a\x3atype\x0a"
"         >\x0a"
"forward_list(_InputIterator, _InputIterator)\x0a"
"  -> forward_list<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Alloc>;\x0a"
"\x0a"
"template<class _InputIterator,\x0a"
"         class _Alloc,\x0a"
"         class = typename enable_if<__is_allocator<_Alloc>\x3a\x3avalue, void>\x3a\x3atype\x0a"
"         >\x0a"
"forward_list(_InputIterator, _InputIterator, _Alloc)\x0a"
"  -> forward_list<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Alloc>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(const allocator_type\x26 __a)\x0a"
"    \x3a base(__a)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(size_type __n)\x0a"
"{\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"        typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"        unique_ptr<__node, _Dp> __h(nullptr, _Dp(__a, 1));\x0a"
"        for (__begin_node_pointer __p = base\x3a\x3a__before_begin(); __n > 0; --__n,\x0a"
"                                                             __p = __p->__next_as_begin())\x0a"
"        {\x0a"
"            __h.reset(__node_traits\x3a\x3a""allocate(__a, 1));\x0a"
"            __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_));\x0a"
"            __h->__next_ = nullptr;\x0a"
"            __p->__next_ = __h.release();\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp, class _Alloc>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(size_type __n,\x0a"
"                                        const allocator_type\x26 __base_alloc)\x0a"
"    \x3a base ( __base_alloc )\x0a"
"{\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"        typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"        unique_ptr<__node, _Dp> __h(nullptr, _Dp(__a, 1));\x0a"
"        for (__begin_node_pointer __p = base\x3a\x3a__before_begin(); __n > 0; --__n,\x0a"
"                                                             __p = __p->__next_as_begin())\x0a"
"        {\x0a"
"            __h.reset(__node_traits\x3a\x3a""allocate(__a, 1));\x0a"
"            __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_));\x0a"
"            __h->__next_ = nullptr;\x0a"
"            __p->__next_ = __h.release();\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(size_type __n, const value_type\x26 __v)\x0a"
"{\x0a"
"    insert_after(cbefore_begin(), __n, __v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(size_type __n, const value_type\x26 __v,\x0a"
"                                        const allocator_type\x26 __a)\x0a"
"    \x3a base(__a)\x0a"
"{\x0a"
"    insert_after(cbefore_begin(), __n, __v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(_InputIterator __f, _InputIterator __l,\x0a"
"                                        typename enable_if<\x0a"
"                                          __is_input_iterator<_InputIterator>\x3a\x3avalue\x0a"
"                                        >\x3a\x3atype*)\x0a"
"{\x0a"
"    insert_after(cbefore_begin(), __f, __l);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(_InputIterator __f, _InputIterator __l,\x0a"
"                                        const allocator_type\x26 __a,\x0a"
"                                        typename enable_if<\x0a"
"                                          __is_input_iterator<_InputIterator>\x3a\x3avalue\x0a"
"                                        >\x3a\x3atype*)\x0a"
"    \x3a base(__a)\x0a"
"{\x0a"
"    insert_after(cbefore_begin(), __f, __l);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(const forward_list\x26 __x)\x0a"
"    \x3a base(\x0a"
"          __node_traits\x3a\x3aselect_on_container_copy_construction(__x.__alloc())) {\x0a"
"  insert_after(cbefore_begin(), __x.begin(), __x.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(const forward_list\x26 __x,\x0a"
"                                        const allocator_type\x26 __a)\x0a"
"    \x3a base(__a)\x0a"
"{\x0a"
"    insert_after(cbefore_begin(), __x.begin(), __x.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"forward_list<_Tp, _Alloc>\x26\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3aoperator=(const forward_list\x26 __x)\x0a"
"{\x0a"
"    if (this \x21= \x26__x)\x0a"
"    {\x0a"
"        base\x3a\x3a__copy_assign_alloc(__x);\x0a"
"        assign(__x.begin(), __x.end());\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Tp, class _Alloc>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(forward_list\x26\x26 __x,\x0a"
"                                        const allocator_type\x26 __a)\x0a"
"    \x3a base(_VSTD\x3a\x3amove(__x), __a)\x0a"
"{\x0a"
"    if (base\x3a\x3a__alloc() \x21= __x.__alloc())\x0a"
"    {\x0a"
"        typedef move_iterator<iterator> _Ip;\x0a"
"        insert_after(cbefore_begin(), _Ip(__x.begin()), _Ip(__x.end()));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(initializer_list<value_type> __il)\x0a"
"{\x0a"
"    insert_after(cbefore_begin(), __il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""forward_list(initializer_list<value_type> __il,\x0a"
"                                        const allocator_type\x26 __a)\x0a"
"    \x3a base(__a)\x0a"
"{\x0a"
"    insert_after(cbefore_begin(), __il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a__move_assign(forward_list\x26 __x, true_type)\x0a"
"    _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"{\x0a"
"    clear();\x0a"
"    base\x3a\x3a__move_assign_alloc(__x);\x0a"
"    base\x3a\x3a__before_begin()->__next_ = __x.__before_begin()->__next_;\x0a"
"    __x.__before_begin()->__next_ = nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a__move_assign(forward_list\x26 __x, false_type)\x0a"
"{\x0a"
"    if (base\x3a\x3a__alloc() == __x.__alloc())\x0a"
"        __move_assign(__x, true_type());\x0a"
"    else\x0a"
"    {\x0a"
"        typedef move_iterator<iterator> _Ip;\x0a"
"        assign(_Ip(__x.begin()), _Ip(__x.end()));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"forward_list<_Tp, _Alloc>\x26\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3aoperator=(forward_list\x26\x26 __x)\x0a"
"    _NOEXCEPT_(\x0a"
"             __node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"             is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"{\x0a"
"    __move_assign(__x, integral_constant<bool,\x0a"
"          __node_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"forward_list<_Tp, _Alloc>\x26\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3aoperator=(initializer_list<value_type> __il)\x0a"
"{\x0a"
"    assign(__il.begin(), __il.end());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_input_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""assign(_InputIterator __f, _InputIterator __l)\x0a"
"{\x0a"
"    iterator __i = before_begin();\x0a"
"    iterator __j = _VSTD\x3a\x3anext(__i);\x0a"
"    iterator __e = end();\x0a"
"    for (; __j \x21= __e \x26\x26 __f \x21= __l; ++__i, (void) ++__j, ++__f)\x0a"
"        *__j = *__f;\x0a"
"    if (__j == __e)\x0a"
"        insert_after(__i, __f, __l);\x0a"
"    else\x0a"
"        erase_after(__i, __e);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""assign(size_type __n, const value_type\x26 __v)\x0a"
"{\x0a"
"    iterator __i = before_begin();\x0a"
"    iterator __j = _VSTD\x3a\x3anext(__i);\x0a"
"    iterator __e = end();\x0a"
"    for (; __j \x21= __e \x26\x26 __n > 0; --__n, ++__i, ++__j)\x0a"
"        *__j = __v;\x0a"
"    if (__j == __e)\x0a"
"        insert_after(__i, __n, __v);\x0a"
"    else\x0a"
"        erase_after(__i, __e);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""assign(initializer_list<value_type> __il)\x0a"
"{\x0a"
"    assign(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class... _Args>\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3areference\x0a"
"#else\x0a"
"void\x0a"
"#endif\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""emplace_front(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"    typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"    unique_ptr<__node, _Dp> __h(__node_traits\x3a\x3a""allocate(__a, 1), _Dp(__a, 1));\x0a"
"    __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_),\x0a"
"                                  _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __h->__next_ = base\x3a\x3a__before_begin()->__next_;\x0a"
"    base\x3a\x3a__before_begin()->__next_ = __h.release();\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    return base\x3a\x3a__before_begin()->__next_->__value_;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3apush_front(value_type\x26\x26 __v)\x0a"
"{\x0a"
"    __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"    typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"    unique_ptr<__node, _Dp> __h(__node_traits\x3a\x3a""allocate(__a, 1), _Dp(__a, 1));\x0a"
"    __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_), _VSTD\x3a\x3amove(__v));\x0a"
"    __h->__next_ = base\x3a\x3a__before_begin()->__next_;\x0a"
"    base\x3a\x3a__before_begin()->__next_ = __h.release();\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3apush_front(const value_type\x26 __v)\x0a"
"{\x0a"
"    __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"    typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"    unique_ptr<__node, _Dp> __h(__node_traits\x3a\x3a""allocate(__a, 1), _Dp(__a, 1));\x0a"
"    __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_), __v);\x0a"
"    __h->__next_ = base\x3a\x3a__before_begin()->__next_;\x0a"
"    base\x3a\x3a__before_begin()->__next_ = __h.release();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3apop_front()\x0a"
"{\x0a"
"    __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"    __node_pointer __p = base\x3a\x3a__before_begin()->__next_;\x0a"
"    base\x3a\x3a__before_begin()->__next_ = __p->__next_;\x0a"
"    __node_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(__p->__value_));\x0a"
"    __node_traits\x3a\x3a""deallocate(__a, __p, 1);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class... _Args>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""emplace_after(const_iterator __p, _Args\x26\x26... __args)\x0a"
"{\x0a"
"    __begin_node_pointer const __r = __p.__get_begin();\x0a"
"    __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"    typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"    unique_ptr<__node, _Dp> __h(__node_traits\x3a\x3a""allocate(__a, 1), _Dp(__a, 1));\x0a"
"    __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_),\x0a"
"                                  _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __h->__next_ = __r->__next_;\x0a"
"    __r->__next_ = __h.release();\x0a"
"    return iterator(__r->__next_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3ainsert_after(const_iterator __p, value_type\x26\x26 __v)\x0a"
"{\x0a"
"    __begin_node_pointer const __r = __p.__get_begin();\x0a"
"    __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"    typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"    unique_ptr<__node, _Dp> __h(__node_traits\x3a\x3a""allocate(__a, 1), _Dp(__a, 1));\x0a"
"    __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_), _VSTD\x3a\x3amove(__v));\x0a"
"    __h->__next_ = __r->__next_;\x0a"
"    __r->__next_ = __h.release();\x0a"
"    return iterator(__r->__next_);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3ainsert_after(const_iterator __p, const value_type\x26 __v)\x0a"
"{\x0a"
"    __begin_node_pointer const __r = __p.__get_begin();\x0a"
"    __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"    typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"    unique_ptr<__node, _Dp> __h(__node_traits\x3a\x3a""allocate(__a, 1), _Dp(__a, 1));\x0a"
"    __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_), __v);\x0a"
"    __h->__next_ = __r->__next_;\x0a"
"    __r->__next_ = __h.release();\x0a"
"    return iterator(__r->__next_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3ainsert_after(const_iterator __p, size_type __n,\x0a"
"                                        const value_type\x26 __v)\x0a"
"{\x0a"
"    __begin_node_pointer __r = __p.__get_begin();\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"        typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"        unique_ptr<__node, _Dp> __h(__node_traits\x3a\x3a""allocate(__a, 1), _Dp(__a, 1));\x0a"
"        __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_), __v);\x0a"
"        __node_pointer __first = __h.release();\x0a"
"        __node_pointer __last = __first;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (--__n; __n \x21= 0; --__n, __last = __last->__next_)\x0a"
"            {\x0a"
"                __h.reset(__node_traits\x3a\x3a""allocate(__a, 1));\x0a"
"                __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_), __v);\x0a"
"                __last->__next_ = __h.release();\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            while (__first \x21= nullptr)\x0a"
"            {\x0a"
"                __node_pointer __next = __first->__next_;\x0a"
"                __node_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(__first->__value_));\x0a"
"                __node_traits\x3a\x3a""deallocate(__a, __first, 1);\x0a"
"                __first = __next;\x0a"
"            }\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __last->__next_ = __r->__next_;\x0a"
"        __r->__next_ = __first;\x0a"
"        __r = static_cast<__begin_node_pointer>(__last);\x0a"
"    }\x0a"
"    return iterator(__r);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_input_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"    typename forward_list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
">\x3a\x3atype\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3ainsert_after(const_iterator __p,\x0a"
"                                        _InputIterator __f, _InputIterator __l)\x0a"
"{\x0a"
"    __begin_node_pointer __r = __p.__get_begin();\x0a"
"    if (__f \x21= __l)\x0a"
"    {\x0a"
"        __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"        typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"        unique_ptr<__node, _Dp> __h(__node_traits\x3a\x3a""allocate(__a, 1), _Dp(__a, 1));\x0a"
"        __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_), *__f);\x0a"
"        __node_pointer __first = __h.release();\x0a"
"        __node_pointer __last = __first;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (++__f; __f \x21= __l; ++__f, ((void)(__last = __last->__next_)))\x0a"
"            {\x0a"
"                __h.reset(__node_traits\x3a\x3a""allocate(__a, 1));\x0a"
"                __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_), *__f);\x0a"
"                __last->__next_ = __h.release();\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            while (__first \x21= nullptr)\x0a"
"            {\x0a"
"                __node_pointer __next = __first->__next_;\x0a"
"                __node_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(__first->__value_));\x0a"
"                __node_traits\x3a\x3a""deallocate(__a, __first, 1);\x0a"
"                __first = __next;\x0a"
"            }\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __last->__next_ = __r->__next_;\x0a"
"        __r->__next_ = __first;\x0a"
"        __r = static_cast<__begin_node_pointer>(__last);\x0a"
"    }\x0a"
"    return iterator(__r);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""erase_after(const_iterator __f)\x0a"
"{\x0a"
"    __begin_node_pointer __p = __f.__get_begin();\x0a"
"    __node_pointer __n = __p->__next_;\x0a"
"    __p->__next_ = __n->__next_;\x0a"
"    __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"    __node_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(__n->__value_));\x0a"
"    __node_traits\x3a\x3a""deallocate(__a, __n, 1);\x0a"
"    return iterator(__p->__next_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a""erase_after(const_iterator __f, const_iterator __l)\x0a"
"{\x0a"
"    __node_pointer __e = __l.__get_unsafe_node_pointer();\x0a"
"    if (__f \x21= __l)\x0a"
"    {\x0a"
"        __begin_node_pointer __bp = __f.__get_begin();\x0a"
"\x0a"
"        __node_pointer __n = __bp->__next_;\x0a"
"        if (__n \x21= __e)\x0a"
"        {\x0a"
"            __bp->__next_ = __e;\x0a"
"            __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"            do\x0a"
"            {\x0a"
"                __node_pointer __tmp = __n->__next_;\x0a"
"                __node_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(__n->__value_));\x0a"
"                __node_traits\x3a\x3a""deallocate(__a, __n, 1);\x0a"
"                __n = __tmp;\x0a"
"            } while (__n \x21= __e);\x0a"
"        }\x0a"
"    }\x0a"
"    return iterator(__e);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3aresize(size_type __n)\x0a"
"{\x0a"
"    size_type __sz = 0;\x0a"
"    iterator __p = before_begin();\x0a"
"    iterator __i = begin();\x0a"
"    iterator __e = end();\x0a"
"    for (; __i \x21= __e \x26\x26 __sz < __n; ++__p, ++__i, ++__sz)\x0a"
"        ;\x0a"
"    if (__i \x21= __e)\x0a"
"        erase_after(__p, __e);\x0a"
"    else\x0a"
"    {\x0a"
"        __n -= __sz;\x0a"
"        if (__n > 0)\x0a"
"        {\x0a"
"            __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"            typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"            unique_ptr<__node, _Dp> __h(nullptr, _Dp(__a, 1));\x0a"
"            for (__begin_node_pointer __ptr = __p.__get_begin(); __n > 0; --__n,\x0a"
"                                                         __ptr = __ptr->__next_as_begin())\x0a"
"            {\x0a"
"                __h.reset(__node_traits\x3a\x3a""allocate(__a, 1));\x0a"
"                __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_));\x0a"
"                __h->__next_ = nullptr;\x0a"
"                __ptr->__next_ = __h.release();\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3aresize(size_type __n, const value_type\x26 __v)\x0a"
"{\x0a"
"    size_type __sz = 0;\x0a"
"    iterator __p = before_begin();\x0a"
"    iterator __i = begin();\x0a"
"    iterator __e = end();\x0a"
"    for (; __i \x21= __e \x26\x26 __sz < __n; ++__p, ++__i, ++__sz)\x0a"
"        ;\x0a"
"    if (__i \x21= __e)\x0a"
"        erase_after(__p, __e);\x0a"
"    else\x0a"
"    {\x0a"
"        __n -= __sz;\x0a"
"        if (__n > 0)\x0a"
"        {\x0a"
"            __node_allocator\x26 __a = base\x3a\x3a__alloc();\x0a"
"            typedef __allocator_destructor<__node_allocator> _Dp;\x0a"
"            unique_ptr<__node, _Dp> __h(nullptr, _Dp(__a, 1));\x0a"
"            for (__begin_node_pointer __ptr = __p.__get_begin(); __n > 0; --__n,\x0a"
"                                                         __ptr = __ptr->__next_as_begin())\x0a"
"            {\x0a"
"                __h.reset(__node_traits\x3a\x3a""allocate(__a, 1));\x0a"
"                __node_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(__h->__value_), __v);\x0a"
"                __h->__next_ = nullptr;\x0a"
"                __ptr->__next_ = __h.release();\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3asplice_after(const_iterator __p,\x0a"
"                                        forward_list\x26 __x)\x0a"
"{\x0a"
"    if (\x21__x.empty())\x0a"
"    {\x0a"
"        if (__p.__get_begin()->__next_ \x21= nullptr)\x0a"
"        {\x0a"
"            const_iterator __lm1 = __x.before_begin();\x0a"
"            while (__lm1.__get_begin()->__next_ \x21= nullptr)\x0a"
"                ++__lm1;\x0a"
"            __lm1.__get_begin()->__next_ = __p.__get_begin()->__next_;\x0a"
"        }\x0a"
"        __p.__get_begin()->__next_ = __x.__before_begin()->__next_;\x0a"
"        __x.__before_begin()->__next_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3asplice_after(const_iterator __p,\x0a"
"                                        forward_list\x26 /*__other*/,\x0a"
"                                        const_iterator __i)\x0a"
"{\x0a"
"    const_iterator __lm1 = _VSTD\x3a\x3anext(__i);\x0a"
"    if (__p \x21= __i \x26\x26 __p \x21= __lm1)\x0a"
"    {\x0a"
"        __i.__get_begin()->__next_ = __lm1.__get_begin()->__next_;\x0a"
"        __lm1.__get_begin()->__next_ = __p.__get_begin()->__next_;\x0a"
"        __p.__get_begin()->__next_ = __lm1.__get_unsafe_node_pointer();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3asplice_after(const_iterator __p,\x0a"
"                                        forward_list\x26 /*__other*/,\x0a"
"                                        const_iterator __f, const_iterator __l)\x0a"
"{\x0a"
"    if (__f \x21= __l \x26\x26 __p \x21= __f)\x0a"
"    {\x0a"
"        const_iterator __lm1 = __f;\x0a"
"        while (__lm1.__get_begin()->__next_ \x21= __l.__get_begin())\x0a"
"            ++__lm1;\x0a"
"        if (__f \x21= __lm1)\x0a"
"        {\x0a"
"            __lm1.__get_begin()->__next_ = __p.__get_begin()->__next_;\x0a"
"            __p.__get_begin()->__next_ = __f.__get_begin()->__next_;\x0a"
"            __f.__get_begin()->__next_ = __l.__get_unsafe_node_pointer();\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3asplice_after(const_iterator __p,\x0a"
"                                        forward_list\x26\x26 __x)\x0a"
"{\x0a"
"    splice_after(__p, __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3asplice_after(const_iterator __p,\x0a"
"                                        forward_list\x26\x26 __x,\x0a"
"                                        const_iterator __i)\x0a"
"{\x0a"
"    splice_after(__p, __x, __i);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3asplice_after(const_iterator __p,\x0a"
"                                        forward_list\x26\x26 __x,\x0a"
"                                        const_iterator __f, const_iterator __l)\x0a"
"{\x0a"
"    splice_after(__p, __x, __f, __l);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3a__remove_return_type\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3aremove(const value_type\x26 __v)\x0a"
"{\x0a"
"    forward_list<_Tp, _Alloc> __deleted_nodes(get_allocator()); // collect the nodes we're removing\x0a"
"    typename forward_list<_Tp, _Alloc>\x3a\x3asize_type __count_removed = 0;\x0a"
"    const iterator __e = end();\x0a"
"    for (iterator __i = before_begin(); __i.__get_begin()->__next_ \x21= nullptr;)\x0a"
"    {\x0a"
"        if (__i.__get_begin()->__next_->__value_ == __v)\x0a"
"        {\x0a"
"            ++__count_removed;\x0a"
"            iterator __j = _VSTD\x3a\x3anext(__i, 2);\x0a"
"            for (; __j \x21= __e \x26\x26 *__j == __v; ++__j)\x0a"
"                ++__count_removed;\x0a"
"            __deleted_nodes.splice_after(__deleted_nodes.before_begin(), *this, __i, __j);\x0a"
"            if (__j == __e)\x0a"
"                break;\x0a"
"            __i = __j;\x0a"
"        }\x0a"
"        else\x0a"
"            ++__i;\x0a"
"    }\x0a"
"    \x0a"
"    return (__remove_return_type) __count_removed;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _Predicate>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3a__remove_return_type\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3aremove_if(_Predicate __pred)\x0a"
"{\x0a"
"    forward_list<_Tp, _Alloc> __deleted_nodes(get_allocator()); // collect the nodes we're removing\x0a"
"    typename forward_list<_Tp, _Alloc>\x3a\x3asize_type __count_removed = 0;\x0a"
"    const iterator __e = end();\x0a"
"    for (iterator __i = before_begin(); __i.__get_begin()->__next_ \x21= nullptr;)\x0a"
"    {\x0a"
"        if (__pred(__i.__get_begin()->__next_->__value_))\x0a"
"        {\x0a"
"            ++__count_removed;\x0a"
"            iterator __j = _VSTD\x3a\x3anext(__i, 2);\x0a"
"            for (; __j \x21= __e \x26\x26 __pred(*__j); ++__j)\x0a"
"                ++__count_removed;\x0a"
"            __deleted_nodes.splice_after(__deleted_nodes.before_begin(), *this, __i, __j);\x0a"
"            if (__j == __e)\x0a"
"                break;\x0a"
"            __i = __j;\x0a"
"        }\x0a"
"        else\x0a"
"            ++__i;\x0a"
"    }\x0a"
"    \x0a"
"    return (__remove_return_type) __count_removed;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _BinaryPredicate>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3a__remove_return_type\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3aunique(_BinaryPredicate __binary_pred)\x0a"
"{\x0a"
"    forward_list<_Tp, _Alloc> __deleted_nodes(get_allocator()); // collect the nodes we're removing\x0a"
"    typename forward_list<_Tp, _Alloc>\x3a\x3asize_type __count_removed = 0;\x0a"
"    for (iterator __i = begin(), __e = end(); __i \x21= __e;)\x0a"
"    {\x0a"
"        iterator __j = _VSTD\x3a\x3anext(__i);\x0a"
"        for (; __j \x21= __e \x26\x26 __binary_pred(*__i, *__j); ++__j)\x0a"
"            ++__count_removed;\x0a"
"        if (__i.__get_begin()->__next_ \x21= __j.__get_unsafe_node_pointer())\x0a"
"            __deleted_nodes.splice_after(__deleted_nodes.before_begin(), *this, __i, __j);\x0a"
"        __i = __j;\x0a"
"    }\x0a"
"    \x0a"
"    return (__remove_return_type) __count_removed;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _Compare>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3amerge(forward_list\x26 __x, _Compare __comp)\x0a"
"{\x0a"
"    if (this \x21= \x26__x)\x0a"
"    {\x0a"
"        base\x3a\x3a__before_begin()->__next_ = __merge(base\x3a\x3a__before_begin()->__next_,\x0a"
"                                                    __x.__before_begin()->__next_,\x0a"
"                                                    __comp);\x0a"
"        __x.__before_begin()->__next_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _Compare>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3a__node_pointer\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a__merge(__node_pointer __f1, __node_pointer __f2,\x0a"
"                                   _Compare\x26 __comp)\x0a"
"{\x0a"
"    if (__f1 == nullptr)\x0a"
"        return __f2;\x0a"
"    if (__f2 == nullptr)\x0a"
"        return __f1;\x0a"
"    __node_pointer __r;\x0a"
"    if (__comp(__f2->__value_, __f1->__value_))\x0a"
"    {\x0a"
"        __node_pointer __t = __f2;\x0a"
"        while (__t->__next_ \x21= nullptr \x26\x26\x0a"
"                             __comp(__t->__next_->__value_, __f1->__value_))\x0a"
"            __t = __t->__next_;\x0a"
"        __r = __f2;\x0a"
"        __f2 = __t->__next_;\x0a"
"        __t->__next_ = __f1;\x0a"
"    }\x0a"
"    else\x0a"
"        __r = __f1;\x0a"
"    __node_pointer __p = __f1;\x0a"
"    __f1 = __f1->__next_;\x0a"
"    while (__f1 \x21= nullptr \x26\x26 __f2 \x21= nullptr)\x0a"
"    {\x0a"
"        if (__comp(__f2->__value_, __f1->__value_))\x0a"
"        {\x0a"
"            __node_pointer __t = __f2;\x0a"
"            while (__t->__next_ \x21= nullptr \x26\x26\x0a"
"                                 __comp(__t->__next_->__value_, __f1->__value_))\x0a"
"                __t = __t->__next_;\x0a"
"            __p->__next_ = __f2;\x0a"
"            __f2 = __t->__next_;\x0a"
"            __t->__next_ = __f1;\x0a"
"        }\x0a"
"        __p = __f1;\x0a"
"        __f1 = __f1->__next_;\x0a"
"    }\x0a"
"    if (__f2 \x21= nullptr)\x0a"
"        __p->__next_ = __f2;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _Compare>\x0a"
"inline\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3asort(_Compare __comp)\x0a"
"{\x0a"
"    base\x3a\x3a__before_begin()->__next_ = __sort(base\x3a\x3a__before_begin()->__next_,\x0a"
"                                       _VSTD\x3a\x3a""distance(begin(), end()), __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _Compare>\x0a"
"typename forward_list<_Tp, _Alloc>\x3a\x3a__node_pointer\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3a__sort(__node_pointer __f1, difference_type __sz,\x0a"
"                                  _Compare\x26 __comp)\x0a"
"{\x0a"
"    switch (__sz)\x0a"
"    {\x0a"
"    case 0\x3a\x0a"
"    case 1\x3a\x0a"
"        return __f1;\x0a"
"    case 2\x3a\x0a"
"        if (__comp(__f1->__next_->__value_, __f1->__value_))\x0a"
"        {\x0a"
"            __node_pointer __t = __f1->__next_;\x0a"
"            __t->__next_ = __f1;\x0a"
"            __f1->__next_ = nullptr;\x0a"
"            __f1 = __t;\x0a"
"        }\x0a"
"        return __f1;\x0a"
"    }\x0a"
"    difference_type __sz1 = __sz / 2;\x0a"
"    difference_type __sz2 = __sz - __sz1;\x0a"
"    __node_pointer __t = _VSTD\x3a\x3anext(iterator(__f1), __sz1 - 1).__get_unsafe_node_pointer();\x0a"
"    __node_pointer __f2 = __t->__next_;\x0a"
"    __t->__next_ = nullptr;\x0a"
"    return __merge(__sort(__f1, __sz1, __comp),\x0a"
"                   __sort(__f2, __sz2, __comp), __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"forward_list<_Tp, _Alloc>\x3a\x3areverse() _NOEXCEPT\x0a"
"{\x0a"
"    __node_pointer __p = base\x3a\x3a__before_begin()->__next_;\x0a"
"    if (__p \x21= nullptr)\x0a"
"    {\x0a"
"        __node_pointer __f = __p->__next_;\x0a"
"        __p->__next_ = nullptr;\x0a"
"        while (__f \x21= nullptr)\x0a"
"        {\x0a"
"            __node_pointer __t = __f->__next_;\x0a"
"            __f->__next_ = __p;\x0a"
"            __p = __f;\x0a"
"            __f = __t;\x0a"
"        }\x0a"
"        base\x3a\x3a__before_begin()->__next_ = __p;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"bool operator==(const forward_list<_Tp, _Alloc>\x26 __x,\x0a"
"                const forward_list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    typedef forward_list<_Tp, _Alloc> _Cp;\x0a"
"    typedef typename _Cp\x3a\x3a""const_iterator _Ip;\x0a"
"    _Ip __ix = __x.begin();\x0a"
"    _Ip __ex = __x.end();\x0a"
"    _Ip __iy = __y.begin();\x0a"
"    _Ip __ey = __y.end();\x0a"
"    for (; __ix \x21= __ex \x26\x26 __iy \x21= __ey; ++__ix, ++__iy)\x0a"
"        if (\x21(*__ix == *__iy))\x0a"
"            return false;\x0a"
"    return (__ix == __ex) == (__iy == __ey);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(const forward_list<_Tp, _Alloc>\x26 __x,\x0a"
"                const forward_list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator< (const forward_list<_Tp, _Alloc>\x26 __x,\x0a"
"                const forward_list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alexicographical_compare(__x.begin(), __x.end(),\x0a"
"                                         __y.begin(), __y.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator> (const forward_list<_Tp, _Alloc>\x26 __x,\x0a"
"                const forward_list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator>=(const forward_list<_Tp, _Alloc>\x26 __x,\x0a"
"                const forward_list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator<=(const forward_list<_Tp, _Alloc>\x26 __x,\x0a"
"                const forward_list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(forward_list<_Tp, _Alloc>\x26 __x, forward_list<_Tp, _Alloc>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Tp, class _Allocator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(forward_list<_Tp, _Allocator>\x26 __c, _Predicate __pred)\x0a"
"{ __c.remove_if(__pred); }\x0a"
"\x0a"
"template <class _Tp, class _Allocator, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase(forward_list<_Tp, _Allocator>\x26 __c, const _Up\x26 __v)\x0a"
"{ _VSTD\x3a\x3a""erase_if(__c, \x5b\x26\x5d(auto\x26 __elem) { return __elem == __v; }); }\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_FORWARD_LIST\x0a"
"", 62304 ); }