#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_fstream( 
"// -*- C++ -*-\x0a"
"//===------------------------- fstream ------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_FSTREAM\x0a"
"#define _LIBCPP_FSTREAM\x0a"
"\x0a"
"/*\x0a"
"    fstream synopsis\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> >\x0a"
"class basic_filebuf\x0a"
"    \x3a public basic_streambuf<charT, traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    // 27.9.1.2 Constructors/destructor\x3a\x0a"
"    basic_filebuf();\x0a"
"    basic_filebuf(basic_filebuf\x26\x26 rhs);\x0a"
"    virtual \x7e""basic_filebuf();\x0a"
"\x0a"
"    // 27.9.1.3 Assign/swap\x3a\x0a"
"    basic_filebuf\x26 operator=(basic_filebuf\x26\x26 rhs);\x0a"
"    void swap(basic_filebuf\x26 rhs);\x0a"
"\x0a"
"    // 27.9.1.4 Members\x3a\x0a"
"    bool is_open() const;\x0a"
"    basic_filebuf* open(const char* s, ios_base\x3a\x3aopenmode mode);\x0a"
"    basic_filebuf* open(const string\x26 s, ios_base\x3a\x3aopenmode mode);\x0a"
"    basic_filebuf* open(const filesystem\x3a\x3apath\x26 p, ios_base\x3a\x3aopenmode mode); // C++17\x0a"
"    basic_filebuf* close();\x0a"
"\x0a"
"protected\x3a\x0a"
"    // 27.9.1.5 Overridden virtual functions\x3a\x0a"
"    virtual streamsize showmanyc();\x0a"
"    virtual int_type underflow();\x0a"
"    virtual int_type uflow();\x0a"
"    virtual int_type pbackfail(int_type c = traits_type\x3a\x3a""eof());\x0a"
"    virtual int_type overflow (int_type c = traits_type\x3a\x3a""eof());\x0a"
"    virtual basic_streambuf<char_type, traits_type>* setbuf(char_type* s, streamsize n);\x0a"
"    virtual pos_type seekoff(off_type off, ios_base\x3a\x3aseekdir way,\x0a"
"                             ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual pos_type seekpos(pos_type sp,\x0a"
"                             ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual int sync();\x0a"
"    virtual void imbue(const locale\x26 loc);\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"  void\x0a"
"  swap(basic_filebuf<charT, traits>\x26 x, basic_filebuf<charT, traits>\x26 y);\x0a"
"\x0a"
"typedef basic_filebuf<char>    filebuf;\x0a"
"typedef basic_filebuf<wchar_t> wfilebuf;\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> >\x0a"
"class basic_ifstream\x0a"
"    \x3a public basic_istream<charT,traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    basic_ifstream();\x0a"
"    explicit basic_ifstream(const char* s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain);\x0a"
"    explicit basic_ifstream(const string\x26 s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain);\x0a"
"    explicit basic_ifstream(const filesystem\x3a\x3apath\x26 p,\x0a"
"                            ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain); // C++17\x0a"
"    basic_ifstream(basic_ifstream\x26\x26 rhs);\x0a"
"\x0a"
"    basic_ifstream\x26 operator=(basic_ifstream\x26\x26 rhs);\x0a"
"    void swap(basic_ifstream\x26 rhs);\x0a"
"\x0a"
"    basic_filebuf<char_type, traits_type>* rdbuf() const;\x0a"
"    bool is_open() const;\x0a"
"    void open(const char* s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain);\x0a"
"    void open(const string\x26 s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain);\x0a"
"    void open(const filesystem\x3a\x3apath\x26 s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain); // C++17\x0a"
"\x0a"
"    void close();\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"  void\x0a"
"  swap(basic_ifstream<charT, traits>\x26 x, basic_ifstream<charT, traits>\x26 y);\x0a"
"\x0a"
"typedef basic_ifstream<char>    ifstream;\x0a"
"typedef basic_ifstream<wchar_t> wifstream;\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> >\x0a"
"class basic_ofstream\x0a"
"    \x3a public basic_ostream<charT,traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    basic_ofstream();\x0a"
"    explicit basic_ofstream(const char* s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3aout);\x0a"
"    explicit basic_ofstream(const string\x26 s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3aout);\x0a"
"    explicit basic_ofstream(const filesystem\x3a\x3apath\x26 p,\x0a"
"                            ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3aout); // C++17\x0a"
"    basic_ofstream(basic_ofstream\x26\x26 rhs);\x0a"
"\x0a"
"    basic_ofstream\x26 operator=(basic_ofstream\x26\x26 rhs);\x0a"
"    void swap(basic_ofstream\x26 rhs);\x0a"
"\x0a"
"    basic_filebuf<char_type, traits_type>* rdbuf() const;\x0a"
"    bool is_open() const;\x0a"
"    void open(const char* s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3aout);\x0a"
"    void open(const string\x26 s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3aout);\x0a"
"    void open(const filesystem\x3a\x3apath\x26 p,\x0a"
"              ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3aout); // C++17\x0a"
"\x0a"
"    void close();\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"  void\x0a"
"  swap(basic_ofstream<charT, traits>\x26 x, basic_ofstream<charT, traits>\x26 y);\x0a"
"\x0a"
"typedef basic_ofstream<char>    ofstream;\x0a"
"typedef basic_ofstream<wchar_t> wofstream;\x0a"
"\x0a"
"template <class charT, class traits=char_traits<charT> >\x0a"
"class basic_fstream\x0a"
"    \x3a public basic_iostream<charT,traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    basic_fstream();\x0a"
"    explicit basic_fstream(const char* s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain\x7cios_base\x3a\x3aout);\x0a"
"    explicit basic_fstream(const string\x26 s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain\x7cios_base\x3a\x3aout);\x0a"
"    explicit basic_fstream(const filesystem\x3a\x3apath\x26 p,\x0a"
"                           ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain\x7cios_base\x3a\x3aout); C++17\x0a"
"    basic_fstream(basic_fstream\x26\x26 rhs);\x0a"
"\x0a"
"    basic_fstream\x26 operator=(basic_fstream\x26\x26 rhs);\x0a"
"    void swap(basic_fstream\x26 rhs);\x0a"
"\x0a"
"    basic_filebuf<char_type, traits_type>* rdbuf() const;\x0a"
"    bool is_open() const;\x0a"
"    void open(const char* s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain\x7cios_base\x3a\x3aout);\x0a"
"    void open(const string\x26 s, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain\x7cios_base\x3a\x3aout);\x0a"
"    void open(const filesystem\x3a\x3apath\x26 s,\x0a"
"              ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain\x7cios_base\x3a\x3aout); // C++17\x0a"
"\x0a"
"    void close();\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"  void swap(basic_fstream<charT, traits>\x26 x, basic_fstream<charT, traits>\x26 y);\x0a"
"\x0a"
"typedef basic_fstream<char>    fstream;\x0a"
"typedef basic_fstream<wchar_t> wfstream;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <ostream>\x0a"
"#include <istream>\x0a"
"#include <__locale>\x0a"
"#include <cstdio>\x0a"
"#include <cstdlib>\x0a"
"#include <filesystem>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_filebuf\x0a"
"    \x3a public basic_streambuf<_CharT, _Traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                           char_type;\x0a"
"    typedef _Traits                          traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type   int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type   pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type   off_type;\x0a"
"    typedef typename traits_type\x3a\x3astate_type state_type;\x0a"
"\x0a"
"    // 27.9.1.2 Constructors/destructor\x3a\x0a"
"    basic_filebuf();\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    basic_filebuf(basic_filebuf\x26\x26 __rhs);\x0a"
"#endif\x0a"
"    virtual \x7e""basic_filebuf();\x0a"
"\x0a"
"    // 27.9.1.3 Assign/swap\x3a\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_filebuf\x26 operator=(basic_filebuf\x26\x26 __rhs);\x0a"
"#endif\x0a"
"    void swap(basic_filebuf\x26 __rhs);\x0a"
"\x0a"
"    // 27.9.1.4 Members\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool is_open() const;\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"    basic_filebuf* open(const char* __s, ios_base\x3a\x3aopenmode __mode);\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"    basic_filebuf* open(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode);\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_filebuf* open(const string\x26 __s, ios_base\x3a\x3aopenmode __mode);\x0a"
"\x0a"
"#if _LIBCPP_STD_VER >= 17\x0a"
"    _LIBCPP_AVAILABILITY_FILESYSTEM _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_filebuf* open(const _VSTD_FS\x3a\x3apath\x26 __p, ios_base\x3a\x3aopenmode __mode) {\x0a"
"      return open(__p.c_str(), __mode);\x0a"
"    }\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_filebuf* __open(int __fd, ios_base\x3a\x3aopenmode __mode);\x0a"
"#endif\x0a"
"    basic_filebuf* close();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    inline static const char*\x0a"
"    __make_mdstring(ios_base\x3a\x3aopenmode __mode) _NOEXCEPT;\x0a"
"\x0a"
"  protected\x3a\x0a"
"    // 27.9.1.5 Overridden virtual functions\x3a\x0a"
"    virtual int_type underflow();\x0a"
"    virtual int_type pbackfail(int_type __c = traits_type\x3a\x3a""eof());\x0a"
"    virtual int_type overflow (int_type __c = traits_type\x3a\x3a""eof());\x0a"
"    virtual basic_streambuf<char_type, traits_type>* setbuf(char_type* __s, streamsize __n);\x0a"
"    virtual pos_type seekoff(off_type __off, ios_base\x3a\x3aseekdir __way,\x0a"
"                             ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual pos_type seekpos(pos_type __sp,\x0a"
"                             ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual int sync();\x0a"
"    virtual void imbue(const locale\x26 __loc);\x0a"
"\x0a"
"private\x3a\x0a"
"  char* __extbuf_;\x0a"
"  const char* __extbufnext_;\x0a"
"  const char* __extbufend_;\x0a"
"  char __extbuf_min_\x5b""8\x5d;\x0a"
"  size_t __ebs_;\x0a"
"  char_type* __intbuf_;\x0a"
"  size_t __ibs_;\x0a"
"  FILE* __file_;\x0a"
"  const codecvt<char_type, char, state_type>* __cv_;\x0a"
"  state_type __st_;\x0a"
"  state_type __st_last_;\x0a"
"  ios_base\x3a\x3aopenmode __om_;\x0a"
"  ios_base\x3a\x3aopenmode __cm_;\x0a"
"  bool __owns_eb_;\x0a"
"  bool __owns_ib_;\x0a"
"  bool __always_noconv_;\x0a"
"\x0a"
"  bool __read_mode();\x0a"
"  void __write_mode();\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3a""basic_filebuf()\x0a"
"    \x3a __extbuf_(0),\x0a"
"      __extbufnext_(0),\x0a"
"      __extbufend_(0),\x0a"
"      __ebs_(0),\x0a"
"      __intbuf_(0),\x0a"
"      __ibs_(0),\x0a"
"      __file_(0),\x0a"
"      __cv_(nullptr),\x0a"
"      __st_(),\x0a"
"      __st_last_(),\x0a"
"      __om_(0),\x0a"
"      __cm_(0),\x0a"
"      __owns_eb_(false),\x0a"
"      __owns_ib_(false),\x0a"
"      __always_noconv_(false)\x0a"
"{\x0a"
"    if (has_facet<codecvt<char_type, char, state_type> >(this->getloc()))\x0a"
"    {\x0a"
"        __cv_ = \x26use_facet<codecvt<char_type, char, state_type> >(this->getloc());\x0a"
"        __always_noconv_ = __cv_->always_noconv();\x0a"
"    }\x0a"
"    setbuf(0, 4096);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3a""basic_filebuf(basic_filebuf\x26\x26 __rhs)\x0a"
"    \x3a basic_streambuf<_CharT, _Traits>(__rhs)\x0a"
"{\x0a"
"    if (__rhs.__extbuf_ == __rhs.__extbuf_min_)\x0a"
"    {\x0a"
"        __extbuf_ = __extbuf_min_;\x0a"
"        __extbufnext_ = __extbuf_ + (__rhs.__extbufnext_ - __rhs.__extbuf_);\x0a"
"        __extbufend_ = __extbuf_ + (__rhs.__extbufend_ - __rhs.__extbuf_);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __extbuf_ = __rhs.__extbuf_;\x0a"
"        __extbufnext_ = __rhs.__extbufnext_;\x0a"
"        __extbufend_ = __rhs.__extbufend_;\x0a"
"    }\x0a"
"    __ebs_ = __rhs.__ebs_;\x0a"
"    __intbuf_ = __rhs.__intbuf_;\x0a"
"    __ibs_ = __rhs.__ibs_;\x0a"
"    __file_ = __rhs.__file_;\x0a"
"    __cv_ = __rhs.__cv_;\x0a"
"    __st_ = __rhs.__st_;\x0a"
"    __st_last_ = __rhs.__st_last_;\x0a"
"    __om_ = __rhs.__om_;\x0a"
"    __cm_ = __rhs.__cm_;\x0a"
"    __owns_eb_ = __rhs.__owns_eb_;\x0a"
"    __owns_ib_ = __rhs.__owns_ib_;\x0a"
"    __always_noconv_ = __rhs.__always_noconv_;\x0a"
"    if (__rhs.pbase())\x0a"
"    {\x0a"
"        if (__rhs.pbase() == __rhs.__intbuf_)\x0a"
"            this->setp(__intbuf_, __intbuf_ + (__rhs. epptr() - __rhs.pbase()));\x0a"
"        else\x0a"
"            this->setp((char_type*)__extbuf_,\x0a"
"                       (char_type*)__extbuf_ + (__rhs. epptr() - __rhs.pbase()));\x0a"
"        this->__pbump(__rhs. pptr() - __rhs.pbase());\x0a"
"    }\x0a"
"    else if (__rhs.eback())\x0a"
"    {\x0a"
"        if (__rhs.eback() == __rhs.__intbuf_)\x0a"
"            this->setg(__intbuf_, __intbuf_ + (__rhs.gptr() - __rhs.eback()),\x0a"
"                                  __intbuf_ + (__rhs.egptr() - __rhs.eback()));\x0a"
"        else\x0a"
"            this->setg((char_type*)__extbuf_,\x0a"
"                       (char_type*)__extbuf_ + (__rhs.gptr() - __rhs.eback()),\x0a"
"                       (char_type*)__extbuf_ + (__rhs.egptr() - __rhs.eback()));\x0a"
"    }\x0a"
"    __rhs.__extbuf_ = 0;\x0a"
"    __rhs.__extbufnext_ = 0;\x0a"
"    __rhs.__extbufend_ = 0;\x0a"
"    __rhs.__ebs_ = 0;\x0a"
"    __rhs.__intbuf_ = 0;\x0a"
"    __rhs.__ibs_ = 0;\x0a"
"    __rhs.__file_ = 0;\x0a"
"    __rhs.__st_ = state_type();\x0a"
"    __rhs.__st_last_ = state_type();\x0a"
"    __rhs.__om_ = 0;\x0a"
"    __rhs.__cm_ = 0;\x0a"
"    __rhs.__owns_eb_ = false;\x0a"
"    __rhs.__owns_ib_ = false;\x0a"
"    __rhs.setg(0, 0, 0);\x0a"
"    __rhs.setp(0, 0);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_filebuf<_CharT, _Traits>\x26\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3aoperator=(basic_filebuf\x26\x26 __rhs)\x0a"
"{\x0a"
"    close();\x0a"
"    swap(__rhs);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3a\x7e""basic_filebuf()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        close();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    if (__owns_eb_)\x0a"
"        delete \x5b\x5d __extbuf_;\x0a"
"    if (__owns_ib_)\x0a"
"        delete \x5b\x5d __intbuf_;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3aswap(basic_filebuf\x26 __rhs)\x0a"
"{\x0a"
"    basic_streambuf<char_type, traits_type>\x3a\x3aswap(__rhs);\x0a"
"    if (__extbuf_ \x21= __extbuf_min_ \x26\x26 __rhs.__extbuf_ \x21= __rhs.__extbuf_min_)\x0a"
"    {\x0a"
"        _VSTD\x3a\x3aswap(__extbuf_, __rhs.__extbuf_);\x0a"
"        _VSTD\x3a\x3aswap(__extbufnext_, __rhs.__extbufnext_);\x0a"
"        _VSTD\x3a\x3aswap(__extbufend_, __rhs.__extbufend_);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        ptrdiff_t __ln = __extbufnext_ - __extbuf_;\x0a"
"        ptrdiff_t __le = __extbufend_ - __extbuf_;\x0a"
"        ptrdiff_t __rn = __rhs.__extbufnext_ - __rhs.__extbuf_;\x0a"
"        ptrdiff_t __re = __rhs.__extbufend_ - __rhs.__extbuf_;\x0a"
"        if (__extbuf_ == __extbuf_min_ \x26\x26 __rhs.__extbuf_ \x21= __rhs.__extbuf_min_)\x0a"
"        {\x0a"
"            __extbuf_ = __rhs.__extbuf_;\x0a"
"            __rhs.__extbuf_ = __rhs.__extbuf_min_;\x0a"
"        }\x0a"
"        else if (__extbuf_ \x21= __extbuf_min_ \x26\x26 __rhs.__extbuf_ == __rhs.__extbuf_min_)\x0a"
"        {\x0a"
"            __rhs.__extbuf_ = __extbuf_;\x0a"
"            __extbuf_ = __extbuf_min_;\x0a"
"        }\x0a"
"        __extbufnext_ = __extbuf_ + __rn;\x0a"
"        __extbufend_ = __extbuf_ + __re;\x0a"
"        __rhs.__extbufnext_ = __rhs.__extbuf_ + __ln;\x0a"
"        __rhs.__extbufend_ = __rhs.__extbuf_ + __le;\x0a"
"    }\x0a"
"    _VSTD\x3a\x3aswap(__ebs_, __rhs.__ebs_);\x0a"
"    _VSTD\x3a\x3aswap(__intbuf_, __rhs.__intbuf_);\x0a"
"    _VSTD\x3a\x3aswap(__ibs_, __rhs.__ibs_);\x0a"
"    _VSTD\x3a\x3aswap(__file_, __rhs.__file_);\x0a"
"    _VSTD\x3a\x3aswap(__cv_, __rhs.__cv_);\x0a"
"    _VSTD\x3a\x3aswap(__st_, __rhs.__st_);\x0a"
"    _VSTD\x3a\x3aswap(__st_last_, __rhs.__st_last_);\x0a"
"    _VSTD\x3a\x3aswap(__om_, __rhs.__om_);\x0a"
"    _VSTD\x3a\x3aswap(__cm_, __rhs.__cm_);\x0a"
"    _VSTD\x3a\x3aswap(__owns_eb_, __rhs.__owns_eb_);\x0a"
"    _VSTD\x3a\x3aswap(__owns_ib_, __rhs.__owns_ib_);\x0a"
"    _VSTD\x3a\x3aswap(__always_noconv_, __rhs.__always_noconv_);\x0a"
"    if (this->eback() == (char_type*)__rhs.__extbuf_min_)\x0a"
"    {\x0a"
"        ptrdiff_t __n = this->gptr() - this->eback();\x0a"
"        ptrdiff_t __e = this->egptr() - this->eback();\x0a"
"        this->setg((char_type*)__extbuf_min_,\x0a"
"                   (char_type*)__extbuf_min_ + __n,\x0a"
"                   (char_type*)__extbuf_min_ + __e);\x0a"
"    }\x0a"
"    else if (this->pbase() == (char_type*)__rhs.__extbuf_min_)\x0a"
"    {\x0a"
"        ptrdiff_t __n = this->pptr() - this->pbase();\x0a"
"        ptrdiff_t __e = this->epptr() - this->pbase();\x0a"
"        this->setp((char_type*)__extbuf_min_,\x0a"
"                   (char_type*)__extbuf_min_ + __e);\x0a"
"        this->__pbump(__n);\x0a"
"    }\x0a"
"    if (__rhs.eback() == (char_type*)__extbuf_min_)\x0a"
"    {\x0a"
"        ptrdiff_t __n = __rhs.gptr() - __rhs.eback();\x0a"
"        ptrdiff_t __e = __rhs.egptr() - __rhs.eback();\x0a"
"        __rhs.setg((char_type*)__rhs.__extbuf_min_,\x0a"
"                   (char_type*)__rhs.__extbuf_min_ + __n,\x0a"
"                   (char_type*)__rhs.__extbuf_min_ + __e);\x0a"
"    }\x0a"
"    else if (__rhs.pbase() == (char_type*)__extbuf_min_)\x0a"
"    {\x0a"
"        ptrdiff_t __n = __rhs.pptr() - __rhs.pbase();\x0a"
"        ptrdiff_t __e = __rhs.epptr() - __rhs.pbase();\x0a"
"        __rhs.setp((char_type*)__rhs.__extbuf_min_,\x0a"
"                   (char_type*)__rhs.__extbuf_min_ + __e);\x0a"
"        __rhs.__pbump(__n);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(basic_filebuf<_CharT, _Traits>\x26 __x, basic_filebuf<_CharT, _Traits>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"bool\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3ais_open() const\x0a"
"{\x0a"
"    return __file_ \x21= 0;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"const char* basic_filebuf<_CharT, _Traits>\x3a\x3a__make_mdstring(\x0a"
"    ios_base\x3a\x3aopenmode __mode) _NOEXCEPT {\x0a"
"  switch (__mode \x26 \x7eios_base\x3a\x3a""ate) {\x0a"
"  case ios_base\x3a\x3aout\x3a\x0a"
"  case ios_base\x3a\x3aout \x7c ios_base\x3a\x3atrunc\x3a\x0a"
"    return \x22w\x22;\x0a"
"  case ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""app\x3a\x0a"
"  case ios_base\x3a\x3a""app\x3a\x0a"
"    return \x22""a\x22;\x0a"
"  case ios_base\x3a\x3ain\x3a\x0a"
"    return \x22r\x22;\x0a"
"  case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout\x3a\x0a"
"    return \x22r+\x22;\x0a"
"  case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout \x7c ios_base\x3a\x3atrunc\x3a\x0a"
"    return \x22w+\x22;\x0a"
"  case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""app\x3a\x0a"
"  case ios_base\x3a\x3ain \x7c ios_base\x3a\x3a""app\x3a\x0a"
"    return \x22""a+\x22;\x0a"
"  case ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"  case ios_base\x3a\x3aout \x7c ios_base\x3a\x3atrunc \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"    return \x22wb\x22;\x0a"
"  case ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""app \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"  case ios_base\x3a\x3a""app \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"    return \x22""ab\x22;\x0a"
"  case ios_base\x3a\x3ain \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"    return \x22rb\x22;\x0a"
"  case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"    return \x22r+b\x22;\x0a"
"  case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout \x7c ios_base\x3a\x3atrunc \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"    return \x22w+b\x22;\x0a"
"  case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""app \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"  case ios_base\x3a\x3ain \x7c ios_base\x3a\x3a""app \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"    return \x22""a+b\x22;\x0a"
"  default\x3a\x0a"
"    return nullptr;\x0a"
"  }\x0a"
"  _LIBCPP_UNREACHABLE();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_filebuf<_CharT, _Traits>*\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3aopen(const char* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    basic_filebuf<_CharT, _Traits>* __rt = 0;\x0a"
"    if (__file_ == 0)\x0a"
"    {\x0a"
"      if (const char* __mdstr = __make_mdstring(__mode)) {\x0a"
"        __rt = this;\x0a"
"        __file_ = fopen(__s, __mdstr);\x0a"
"        if (__file_) {\x0a"
"          __om_ = __mode;\x0a"
"          if (__mode \x26 ios_base\x3a\x3a""ate) {\x0a"
"            if (fseek(__file_, 0, SEEK_END)) {\x0a"
"              fclose(__file_);\x0a"
"              __file_ = 0;\x0a"
"              __rt = 0;\x0a"
"            }\x0a"
"          }\x0a"
"        } else\x0a"
"          __rt = 0;\x0a"
"      }\x0a"
"    }\x0a"
"    return __rt;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"_LIBCPP_INLINE_VISIBILITY basic_filebuf<_CharT, _Traits>*\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3a__open(int __fd, ios_base\x3a\x3aopenmode __mode) {\x0a"
"  basic_filebuf<_CharT, _Traits>* __rt = 0;\x0a"
"  if (__file_ == 0) {\x0a"
"    if (const char* __mdstr = __make_mdstring(__mode)) {\x0a"
"      __rt = this;\x0a"
"      __file_ = fdopen(__fd, __mdstr);\x0a"
"      if (__file_) {\x0a"
"        __om_ = __mode;\x0a"
"        if (__mode \x26 ios_base\x3a\x3a""ate) {\x0a"
"          if (fseek(__file_, 0, SEEK_END)) {\x0a"
"            fclose(__file_);\x0a"
"            __file_ = 0;\x0a"
"            __rt = 0;\x0a"
"          }\x0a"
"        }\x0a"
"      } else\x0a"
"        __rt = 0;\x0a"
"    }\x0a"
"  }\x0a"
"  return __rt;\x0a"
"}\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"// This is basically the same as the char* overload except that it uses _wfopen\x0a"
"// and long mode strings.\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_filebuf<_CharT, _Traits>*\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3aopen(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    basic_filebuf<_CharT, _Traits>* __rt = 0;\x0a"
"    if (__file_ == 0)\x0a"
"    {\x0a"
"        __rt = this;\x0a"
"        const wchar_t* __mdstr;\x0a"
"        switch (__mode \x26 \x7eios_base\x3a\x3a""ate)\x0a"
"        {\x0a"
"        case ios_base\x3a\x3aout\x3a\x0a"
"        case ios_base\x3a\x3aout \x7c ios_base\x3a\x3atrunc\x3a\x0a"
"            __mdstr = L\x22w\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""app\x3a\x0a"
"        case ios_base\x3a\x3a""app\x3a\x0a"
"            __mdstr = L\x22""a\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3ain\x3a\x0a"
"            __mdstr = L\x22r\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout\x3a\x0a"
"            __mdstr = L\x22r+\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout \x7c ios_base\x3a\x3atrunc\x3a\x0a"
"            __mdstr = L\x22w+\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""app\x3a\x0a"
"        case ios_base\x3a\x3ain \x7c ios_base\x3a\x3a""app\x3a\x0a"
"            __mdstr = L\x22""a+\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"        case ios_base\x3a\x3aout \x7c ios_base\x3a\x3atrunc \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"            __mdstr = L\x22wb\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""app \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"        case ios_base\x3a\x3a""app \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"            __mdstr = L\x22""ab\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3ain \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"            __mdstr = L\x22rb\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"            __mdstr = L\x22r+b\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout \x7c ios_base\x3a\x3atrunc \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"            __mdstr = L\x22w+b\x22;\x0a"
"            break;\x0a"
"        case ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout \x7c ios_base\x3a\x3a""app \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"        case ios_base\x3a\x3ain \x7c ios_base\x3a\x3a""app \x7c ios_base\x3a\x3a""binary\x3a\x0a"
"            __mdstr = L\x22""a+b\x22;\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            __rt = 0;\x0a"
"            break;\x0a"
"        }\x0a"
"        if (__rt)\x0a"
"        {\x0a"
"            __file_ = _wfopen(__s, __mdstr);\x0a"
"            if (__file_)\x0a"
"            {\x0a"
"                __om_ = __mode;\x0a"
"                if (__mode \x26 ios_base\x3a\x3a""ate)\x0a"
"                {\x0a"
"                    if (fseek(__file_, 0, SEEK_END))\x0a"
"                    {\x0a"
"                        fclose(__file_);\x0a"
"                        __file_ = 0;\x0a"
"                        __rt = 0;\x0a"
"                    }\x0a"
"                }\x0a"
"            }\x0a"
"            else\x0a"
"                __rt = 0;\x0a"
"        }\x0a"
"    }\x0a"
"    return __rt;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_filebuf<_CharT, _Traits>*\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3aopen(const string\x26 __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    return open(__s.c_str(), __mode);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_filebuf<_CharT, _Traits>*\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3a""close()\x0a"
"{\x0a"
"    basic_filebuf<_CharT, _Traits>* __rt = 0;\x0a"
"    if (__file_)\x0a"
"    {\x0a"
"        __rt = this;\x0a"
"        unique_ptr<FILE, int(*)(FILE*)> __h(__file_, fclose);\x0a"
"        if (sync())\x0a"
"            __rt = 0;\x0a"
"        if (fclose(__h.release()) == 0)\x0a"
"            __file_ = 0;\x0a"
"        else\x0a"
"            __rt = 0;\x0a"
"        setbuf(0, 0);\x0a"
"    }\x0a"
"    return __rt;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_filebuf<_CharT, _Traits>\x3a\x3aint_type\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3aunderflow()\x0a"
"{\x0a"
"    if (__file_ == 0)\x0a"
"        return traits_type\x3a\x3a""eof();\x0a"
"    bool __initial = __read_mode();\x0a"
"    char_type __1buf;\x0a"
"    if (this->gptr() == 0)\x0a"
"        this->setg(\x26__1buf, \x26__1buf+1, \x26__1buf+1);\x0a"
"    const size_t __unget_sz = __initial \x3f 0 \x3a min<size_t>((this->egptr() - this->eback()) / 2, 4);\x0a"
"    int_type __c = traits_type\x3a\x3a""eof();\x0a"
"    if (this->gptr() == this->egptr())\x0a"
"    {\x0a"
"        memmove(this->eback(), this->egptr() - __unget_sz, __unget_sz * sizeof(char_type));\x0a"
"        if (__always_noconv_)\x0a"
"        {\x0a"
"            size_t __nmemb = static_cast<size_t>(this->egptr() - this->eback() - __unget_sz);\x0a"
"            __nmemb = fread(this->eback() + __unget_sz, 1, __nmemb, __file_);\x0a"
"            if (__nmemb \x21= 0)\x0a"
"            {\x0a"
"                this->setg(this->eback(),\x0a"
"                           this->eback() + __unget_sz,\x0a"
"                           this->eback() + __unget_sz + __nmemb);\x0a"
"                __c = traits_type\x3a\x3ato_int_type(*this->gptr());\x0a"
"            }\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            _LIBCPP_ASSERT ( \x21(__extbufnext_ == NULL \x26\x26 (__extbufend_ \x21= __extbufnext_)), \x22underflow moving from NULL\x22 );\x0a"
"            if (__extbufend_ \x21= __extbufnext_)\x0a"
"                memmove(__extbuf_, __extbufnext_, __extbufend_ - __extbufnext_);\x0a"
"            __extbufnext_ = __extbuf_ + (__extbufend_ - __extbufnext_);\x0a"
"            __extbufend_ = __extbuf_ + (__extbuf_ == __extbuf_min_ \x3f sizeof(__extbuf_min_) \x3a __ebs_);\x0a"
"            size_t __nmemb = _VSTD\x3a\x3amin(static_cast<size_t>(__ibs_ - __unget_sz),\x0a"
"                                 static_cast<size_t>(__extbufend_ - __extbufnext_));\x0a"
"            codecvt_base\x3a\x3aresult __r;\x0a"
"            __st_last_ = __st_;\x0a"
"            size_t __nr = fread((void*) const_cast<char *>(__extbufnext_), 1, __nmemb, __file_);\x0a"
"            if (__nr \x21= 0)\x0a"
"            {\x0a"
"                if (\x21__cv_)\x0a"
"                    __throw_bad_cast();\x0a"
"\x0a"
"                __extbufend_ = __extbufnext_ + __nr;\x0a"
"                char_type*  __inext;\x0a"
"                __r = __cv_->in(__st_, __extbuf_, __extbufend_, __extbufnext_,\x0a"
"                                       this->eback() + __unget_sz,\x0a"
"                                       this->eback() + __ibs_, __inext);\x0a"
"                if (__r == codecvt_base\x3a\x3anoconv)\x0a"
"                {\x0a"
"                    this->setg((char_type*)__extbuf_, (char_type*)__extbuf_,\x0a"
"                                          (char_type*)const_cast<char *>(__extbufend_));\x0a"
"                    __c = traits_type\x3a\x3ato_int_type(*this->gptr());\x0a"
"                }\x0a"
"                else if (__inext \x21= this->eback() + __unget_sz)\x0a"
"                {\x0a"
"                    this->setg(this->eback(), this->eback() + __unget_sz, __inext);\x0a"
"                    __c = traits_type\x3a\x3ato_int_type(*this->gptr());\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"        __c = traits_type\x3a\x3ato_int_type(*this->gptr());\x0a"
"    if (this->eback() == \x26__1buf)\x0a"
"        this->setg(0, 0, 0);\x0a"
"    return __c;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_filebuf<_CharT, _Traits>\x3a\x3aint_type\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3apbackfail(int_type __c)\x0a"
"{\x0a"
"    if (__file_ \x26\x26 this->eback() < this->gptr())\x0a"
"    {\x0a"
"        if (traits_type\x3a\x3a""eq_int_type(__c, traits_type\x3a\x3a""eof()))\x0a"
"        {\x0a"
"            this->gbump(-1);\x0a"
"            return traits_type\x3a\x3anot_eof(__c);\x0a"
"        }\x0a"
"        if ((__om_ \x26 ios_base\x3a\x3aout) \x7c\x7c\x0a"
"            traits_type\x3a\x3a""eq(traits_type\x3a\x3ato_char_type(__c), this->gptr()\x5b-1\x5d))\x0a"
"        {\x0a"
"            this->gbump(-1);\x0a"
"            *this->gptr() = traits_type\x3a\x3ato_char_type(__c);\x0a"
"            return __c;\x0a"
"        }\x0a"
"    }\x0a"
"    return traits_type\x3a\x3a""eof();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_filebuf<_CharT, _Traits>\x3a\x3aint_type\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3aoverflow(int_type __c)\x0a"
"{\x0a"
"    if (__file_ == 0)\x0a"
"        return traits_type\x3a\x3a""eof();\x0a"
"    __write_mode();\x0a"
"    char_type __1buf;\x0a"
"    char_type* __pb_save = this->pbase();\x0a"
"    char_type* __epb_save = this->epptr();\x0a"
"    if (\x21traits_type\x3a\x3a""eq_int_type(__c, traits_type\x3a\x3a""eof()))\x0a"
"    {\x0a"
"        if (this->pptr() == 0)\x0a"
"            this->setp(\x26__1buf, \x26__1buf+1);\x0a"
"        *this->pptr() = traits_type\x3a\x3ato_char_type(__c);\x0a"
"        this->pbump(1);\x0a"
"    }\x0a"
"    if (this->pptr() \x21= this->pbase())\x0a"
"    {\x0a"
"        if (__always_noconv_)\x0a"
"        {\x0a"
"            size_t __nmemb = static_cast<size_t>(this->pptr() - this->pbase());\x0a"
"            if (fwrite(this->pbase(), sizeof(char_type), __nmemb, __file_) \x21= __nmemb)\x0a"
"                return traits_type\x3a\x3a""eof();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            char* __extbe = __extbuf_;\x0a"
"            codecvt_base\x3a\x3aresult __r;\x0a"
"            do\x0a"
"            {\x0a"
"                if (\x21__cv_)\x0a"
"                    __throw_bad_cast();\x0a"
"\x0a"
"                const char_type* __e;\x0a"
"                __r = __cv_->out(__st_, this->pbase(), this->pptr(), __e,\x0a"
"                                        __extbuf_, __extbuf_ + __ebs_, __extbe);\x0a"
"                if (__e == this->pbase())\x0a"
"                    return traits_type\x3a\x3a""eof();\x0a"
"                if (__r == codecvt_base\x3a\x3anoconv)\x0a"
"                {\x0a"
"                    size_t __nmemb = static_cast<size_t>(this->pptr() - this->pbase());\x0a"
"                    if (fwrite(this->pbase(), 1, __nmemb, __file_) \x21= __nmemb)\x0a"
"                        return traits_type\x3a\x3a""eof();\x0a"
"                }\x0a"
"                else if (__r == codecvt_base\x3a\x3aok \x7c\x7c __r == codecvt_base\x3a\x3apartial)\x0a"
"                {\x0a"
"                    size_t __nmemb = static_cast<size_t>(__extbe - __extbuf_);\x0a"
"                    if (fwrite(__extbuf_, 1, __nmemb, __file_) \x21= __nmemb)\x0a"
"                        return traits_type\x3a\x3a""eof();\x0a"
"                    if (__r == codecvt_base\x3a\x3apartial)\x0a"
"                    {\x0a"
"                        this->setp(const_cast<char_type*>(__e), this->pptr());\x0a"
"                        this->__pbump(this->epptr() - this->pbase());\x0a"
"                    }\x0a"
"                }\x0a"
"                else\x0a"
"                    return traits_type\x3a\x3a""eof();\x0a"
"            } while (__r == codecvt_base\x3a\x3apartial);\x0a"
"        }\x0a"
"        this->setp(__pb_save, __epb_save);\x0a"
"    }\x0a"
"    return traits_type\x3a\x3anot_eof(__c);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_streambuf<_CharT, _Traits>*\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3asetbuf(char_type* __s, streamsize __n)\x0a"
"{\x0a"
"    this->setg(0, 0, 0);\x0a"
"    this->setp(0, 0);\x0a"
"    if (__owns_eb_)\x0a"
"        delete \x5b\x5d __extbuf_;\x0a"
"    if (__owns_ib_)\x0a"
"        delete \x5b\x5d __intbuf_;\x0a"
"    __ebs_ = __n;\x0a"
"    if (__ebs_ > sizeof(__extbuf_min_))\x0a"
"    {\x0a"
"        if (__always_noconv_ \x26\x26 __s)\x0a"
"        {\x0a"
"            __extbuf_ = (char*)__s;\x0a"
"            __owns_eb_ = false;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __extbuf_ = new char\x5b__ebs_\x5d;\x0a"
"            __owns_eb_ = true;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __extbuf_ = __extbuf_min_;\x0a"
"        __ebs_ = sizeof(__extbuf_min_);\x0a"
"        __owns_eb_ = false;\x0a"
"    }\x0a"
"    if (\x21__always_noconv_)\x0a"
"    {\x0a"
"        __ibs_ = max<streamsize>(__n, sizeof(__extbuf_min_));\x0a"
"        if (__s \x26\x26 __ibs_ >= sizeof(__extbuf_min_))\x0a"
"        {\x0a"
"            __intbuf_ = __s;\x0a"
"            __owns_ib_ = false;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __intbuf_ = new char_type\x5b__ibs_\x5d;\x0a"
"            __owns_ib_ = true;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __ibs_ = 0;\x0a"
"        __intbuf_ = 0;\x0a"
"        __owns_ib_ = false;\x0a"
"    }\x0a"
"    return this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_filebuf<_CharT, _Traits>\x3a\x3apos_type\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3aseekoff(off_type __off, ios_base\x3a\x3aseekdir __way,\x0a"
"                                        ios_base\x3a\x3aopenmode)\x0a"
"{\x0a"
"    if (\x21__cv_)\x0a"
"        __throw_bad_cast();\x0a"
"\x0a"
"    int __width = __cv_->encoding();\x0a"
"    if (__file_ == 0 \x7c\x7c (__width <= 0 \x26\x26 __off \x21= 0) \x7c\x7c sync())\x0a"
"        return pos_type(off_type(-1));\x0a"
"    // __width > 0 \x7c\x7c __off == 0\x0a"
"    int __whence;\x0a"
"    switch (__way)\x0a"
"    {\x0a"
"    case ios_base\x3a\x3a""beg\x3a\x0a"
"        __whence = SEEK_SET;\x0a"
"        break;\x0a"
"    case ios_base\x3a\x3a""cur\x3a\x0a"
"        __whence = SEEK_CUR;\x0a"
"        break;\x0a"
"    case ios_base\x3a\x3a""end\x3a\x0a"
"        __whence = SEEK_END;\x0a"
"        break;\x0a"
"    default\x3a\x0a"
"        return pos_type(off_type(-1));\x0a"
"    }\x0a"
"#if defined(_LIBCPP_HAS_NO_OFF_T_FUNCTIONS)\x0a"
"    if (fseek(__file_, __width > 0 \x3f __width * __off \x3a 0, __whence))\x0a"
"        return pos_type(off_type(-1));\x0a"
"    pos_type __r = ftell(__file_);\x0a"
"#else\x0a"
"    if (fseeko(__file_, __width > 0 \x3f __width * __off \x3a 0, __whence))\x0a"
"        return pos_type(off_type(-1));\x0a"
"    pos_type __r = ftello(__file_);\x0a"
"#endif\x0a"
"    __r.state(__st_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_filebuf<_CharT, _Traits>\x3a\x3apos_type\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3aseekpos(pos_type __sp, ios_base\x3a\x3aopenmode)\x0a"
"{\x0a"
"    if (__file_ == 0 \x7c\x7c sync())\x0a"
"        return pos_type(off_type(-1));\x0a"
"#if defined(_LIBCPP_HAS_NO_OFF_T_FUNCTIONS)\x0a"
"    if (fseek(__file_, __sp, SEEK_SET))\x0a"
"        return pos_type(off_type(-1));\x0a"
"#else\x0a"
"    if (fseeko(__file_, __sp, SEEK_SET))\x0a"
"        return pos_type(off_type(-1));\x0a"
"#endif\x0a"
"    __st_ = __sp.state();\x0a"
"    return __sp;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"int\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3async()\x0a"
"{\x0a"
"    if (__file_ == 0)\x0a"
"        return 0;\x0a"
"    if (\x21__cv_)\x0a"
"        __throw_bad_cast();\x0a"
"\x0a"
"    if (__cm_ \x26 ios_base\x3a\x3aout)\x0a"
"    {\x0a"
"        if (this->pptr() \x21= this->pbase())\x0a"
"            if (overflow() == traits_type\x3a\x3a""eof())\x0a"
"                return -1;\x0a"
"        codecvt_base\x3a\x3aresult __r;\x0a"
"        do\x0a"
"        {\x0a"
"            char* __extbe;\x0a"
"            __r = __cv_->unshift(__st_, __extbuf_, __extbuf_ + __ebs_, __extbe);\x0a"
"            size_t __nmemb = static_cast<size_t>(__extbe - __extbuf_);\x0a"
"            if (fwrite(__extbuf_, 1, __nmemb, __file_) \x21= __nmemb)\x0a"
"                return -1;\x0a"
"        } while (__r == codecvt_base\x3a\x3apartial);\x0a"
"        if (__r == codecvt_base\x3a\x3a""error)\x0a"
"            return -1;\x0a"
"        if (fflush(__file_))\x0a"
"            return -1;\x0a"
"    }\x0a"
"    else if (__cm_ \x26 ios_base\x3a\x3ain)\x0a"
"    {\x0a"
"        off_type __c;\x0a"
"        state_type __state = __st_last_;\x0a"
"        bool __update_st = false;\x0a"
"        if (__always_noconv_)\x0a"
"            __c = this->egptr() - this->gptr();\x0a"
"        else\x0a"
"        {\x0a"
"            int __width = __cv_->encoding();\x0a"
"            __c = __extbufend_ - __extbufnext_;\x0a"
"            if (__width > 0)\x0a"
"                __c += __width * (this->egptr() - this->gptr());\x0a"
"            else\x0a"
"            {\x0a"
"                if (this->gptr() \x21= this->egptr())\x0a"
"                {\x0a"
"                    const int __off =  __cv_->length(__state, __extbuf_,\x0a"
"                                                     __extbufnext_,\x0a"
"                                                     this->gptr() - this->eback());\x0a"
"                    __c += __extbufnext_ - __extbuf_ - __off;\x0a"
"                    __update_st = true;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"#if defined(_LIBCPP_HAS_NO_OFF_T_FUNCTIONS)\x0a"
"        if (fseek(__file_, -__c, SEEK_CUR))\x0a"
"            return -1;\x0a"
"#else\x0a"
"        if (fseeko(__file_, -__c, SEEK_CUR))\x0a"
"            return -1;\x0a"
"#endif\x0a"
"        if (__update_st)\x0a"
"            __st_ = __state;\x0a"
"        __extbufnext_ = __extbufend_ = __extbuf_;\x0a"
"        this->setg(0, 0, 0);\x0a"
"        __cm_ = 0;\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3aimbue(const locale\x26 __loc)\x0a"
"{\x0a"
"    sync();\x0a"
"    __cv_ = \x26use_facet<codecvt<char_type, char, state_type> >(__loc);\x0a"
"    bool __old_anc = __always_noconv_;\x0a"
"    __always_noconv_ = __cv_->always_noconv();\x0a"
"    if (__old_anc \x21= __always_noconv_)\x0a"
"    {\x0a"
"        this->setg(0, 0, 0);\x0a"
"        this->setp(0, 0);\x0a"
"        // invariant, char_type is char, else we couldn't get here\x0a"
"        if (__always_noconv_)  // need to dump __intbuf_\x0a"
"        {\x0a"
"            if (__owns_eb_)\x0a"
"                delete \x5b\x5d __extbuf_;\x0a"
"            __owns_eb_ = __owns_ib_;\x0a"
"            __ebs_ = __ibs_;\x0a"
"            __extbuf_ = (char*)__intbuf_;\x0a"
"            __ibs_ = 0;\x0a"
"            __intbuf_ = 0;\x0a"
"            __owns_ib_ = false;\x0a"
"        }\x0a"
"        else  // need to obtain an __intbuf_.\x0a"
"        {     // If __extbuf_ is user-supplied, use it, else new __intbuf_\x0a"
"            if (\x21__owns_eb_ \x26\x26 __extbuf_ \x21= __extbuf_min_)\x0a"
"            {\x0a"
"                __ibs_ = __ebs_;\x0a"
"                __intbuf_ = (char_type*)__extbuf_;\x0a"
"                __owns_ib_ = false;\x0a"
"                __extbuf_ = new char\x5b__ebs_\x5d;\x0a"
"                __owns_eb_ = true;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                __ibs_ = __ebs_;\x0a"
"                __intbuf_ = new char_type\x5b__ibs_\x5d;\x0a"
"                __owns_ib_ = true;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"bool\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3a__read_mode()\x0a"
"{\x0a"
"    if (\x21(__cm_ \x26 ios_base\x3a\x3ain))\x0a"
"    {\x0a"
"        this->setp(0, 0);\x0a"
"        if (__always_noconv_)\x0a"
"            this->setg((char_type*)__extbuf_,\x0a"
"                       (char_type*)__extbuf_ + __ebs_,\x0a"
"                       (char_type*)__extbuf_ + __ebs_);\x0a"
"        else\x0a"
"            this->setg(__intbuf_, __intbuf_ + __ibs_, __intbuf_ + __ibs_);\x0a"
"        __cm_ = ios_base\x3a\x3ain;\x0a"
"        return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_filebuf<_CharT, _Traits>\x3a\x3a__write_mode()\x0a"
"{\x0a"
"    if (\x21(__cm_ \x26 ios_base\x3a\x3aout))\x0a"
"    {\x0a"
"        this->setg(0, 0, 0);\x0a"
"        if (__ebs_ > sizeof(__extbuf_min_))\x0a"
"        {\x0a"
"            if (__always_noconv_)\x0a"
"                this->setp((char_type*)__extbuf_,\x0a"
"                           (char_type*)__extbuf_ + (__ebs_ - 1));\x0a"
"            else\x0a"
"                this->setp(__intbuf_, __intbuf_ + (__ibs_ - 1));\x0a"
"        }\x0a"
"        else\x0a"
"            this->setp(0, 0);\x0a"
"        __cm_ = ios_base\x3a\x3aout;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// basic_ifstream\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_ifstream\x0a"
"    \x3a public basic_istream<_CharT, _Traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ifstream();\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ifstream(const char* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain);\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ifstream(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain);\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ifstream(const string\x26 __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain);\x0a"
"#if _LIBCPP_STD_VER >= 17\x0a"
"    _LIBCPP_AVAILABILITY_FILESYSTEM _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ifstream(const filesystem\x3a\x3apath\x26 __p, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain)\x0a"
"      \x3a basic_ifstream(__p.c_str(), __mode) {}\x0a"
"#endif // _LIBCPP_STD_VER >= 17\x0a"
"#endif\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ifstream(basic_ifstream\x26\x26 __rhs);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ifstream\x26 operator=(basic_ifstream\x26\x26 __rhs);\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(basic_ifstream\x26 __rhs);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_filebuf<char_type, traits_type>* rdbuf() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool is_open() const;\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"    void open(const char* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain);\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"    void open(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain);\x0a"
"#endif\x0a"
"    void open(const string\x26 __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain);\x0a"
"#if _LIBCPP_STD_VER >= 17\x0a"
"    _LIBCPP_AVAILABILITY_FILESYSTEM _LIBCPP_INLINE_VISIBILITY\x0a"
"    void open(const filesystem\x3a\x3apath\x26 __p,\x0a"
"              ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain) {\x0a"
"      return open(__p.c_str(), __mode);\x0a"
"    }\x0a"
"#endif // _LIBCPP_STD_VER >= 17\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __open(int __fd, ios_base\x3a\x3aopenmode __mode);\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void close();\x0a"
"\x0a"
"private\x3a\x0a"
"    basic_filebuf<char_type, traits_type> __sb_;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3a""basic_ifstream()\x0a"
"    \x3a basic_istream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3a""basic_ifstream(const char* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"    \x3a basic_istream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3ain) == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3a""basic_ifstream(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"    \x3a basic_istream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3ain) == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3a""basic_ifstream(const string\x26 __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"    \x3a basic_istream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3ain) == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3a""basic_ifstream(basic_ifstream\x26\x26 __rhs)\x0a"
"    \x3a basic_istream<char_type, traits_type>(_VSTD\x3a\x3amove(__rhs)),\x0a"
"      __sb_(_VSTD\x3a\x3amove(__rhs.__sb_))\x0a"
"{\x0a"
"    this->set_rdbuf(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ifstream<_CharT, _Traits>\x26\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3aoperator=(basic_ifstream\x26\x26 __rhs)\x0a"
"{\x0a"
"    basic_istream<char_type, traits_type>\x3a\x3aoperator=(_VSTD\x3a\x3amove(__rhs));\x0a"
"    __sb_ = _VSTD\x3a\x3amove(__rhs.__sb_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"void\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3aswap(basic_ifstream\x26 __rhs)\x0a"
"{\x0a"
"    basic_istream<char_type, traits_type>\x3a\x3aswap(__rhs);\x0a"
"    __sb_.swap(__rhs.__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(basic_ifstream<_CharT, _Traits>\x26 __x, basic_ifstream<_CharT, _Traits>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_filebuf<_CharT, _Traits>*\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3ardbuf() const\x0a"
"{\x0a"
"    return const_cast<basic_filebuf<char_type, traits_type>*>(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"bool\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3ais_open() const\x0a"
"{\x0a"
"    return __sb_.is_open();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3aopen(const char* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3ain))\x0a"
"        this->clear();\x0a"
"    else\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3aopen(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3ain))\x0a"
"        this->clear();\x0a"
"    else\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3aopen(const string\x26 __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3ain))\x0a"
"        this->clear();\x0a"
"    else\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void basic_ifstream<_CharT, _Traits>\x3a\x3a__open(int __fd,\x0a"
"                                             ios_base\x3a\x3aopenmode __mode) {\x0a"
"  if (__sb_.__open(__fd, __mode \x7c ios_base\x3a\x3ain))\x0a"
"    this->clear();\x0a"
"  else\x0a"
"    this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"void\x0a"
"basic_ifstream<_CharT, _Traits>\x3a\x3a""close()\x0a"
"{\x0a"
"    if (__sb_.close() == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"// basic_ofstream\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_ofstream\x0a"
"    \x3a public basic_ostream<_CharT, _Traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ofstream();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ofstream(const char* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3aout);\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ofstream(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3aout);\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ofstream(const string\x26 __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3aout);\x0a"
"\x0a"
"#if _LIBCPP_STD_VER >= 17\x0a"
"    _LIBCPP_AVAILABILITY_FILESYSTEM _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ofstream(const filesystem\x3a\x3apath\x26 __p, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3aout)\x0a"
"      \x3a basic_ofstream(__p.c_str(), __mode) {}\x0a"
"#endif // _LIBCPP_STD_VER >= 17\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ofstream(basic_ofstream\x26\x26 __rhs);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ofstream\x26 operator=(basic_ofstream\x26\x26 __rhs);\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(basic_ofstream\x26 __rhs);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_filebuf<char_type, traits_type>* rdbuf() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool is_open() const;\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"    void open(const char* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3aout);\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"    void open(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3aout);\x0a"
"#endif\x0a"
"    void open(const string\x26 __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3aout);\x0a"
"\x0a"
"#if _LIBCPP_STD_VER >= 17\x0a"
"    _LIBCPP_AVAILABILITY_FILESYSTEM _LIBCPP_INLINE_VISIBILITY\x0a"
"    void open(const filesystem\x3a\x3apath\x26 __p, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3aout)\x0a"
"    { return open(__p.c_str(), __mode); }\x0a"
"#endif // _LIBCPP_STD_VER >= 17\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __open(int __fd, ios_base\x3a\x3aopenmode __mode);\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void close();\x0a"
"\x0a"
"private\x3a\x0a"
"    basic_filebuf<char_type, traits_type> __sb_;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3a""basic_ofstream()\x0a"
"    \x3a basic_ostream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3a""basic_ofstream(const char* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"    \x3a basic_ostream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3aout) == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3a""basic_ofstream(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"    \x3a basic_ostream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3aout) == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3a""basic_ofstream(const string\x26 __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"    \x3a basic_ostream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3aout) == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3a""basic_ofstream(basic_ofstream\x26\x26 __rhs)\x0a"
"    \x3a basic_ostream<char_type, traits_type>(_VSTD\x3a\x3amove(__rhs)),\x0a"
"      __sb_(_VSTD\x3a\x3amove(__rhs.__sb_))\x0a"
"{\x0a"
"    this->set_rdbuf(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_ofstream<_CharT, _Traits>\x26\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3aoperator=(basic_ofstream\x26\x26 __rhs)\x0a"
"{\x0a"
"    basic_ostream<char_type, traits_type>\x3a\x3aoperator=(_VSTD\x3a\x3amove(__rhs));\x0a"
"    __sb_ = _VSTD\x3a\x3amove(__rhs.__sb_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"void\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3aswap(basic_ofstream\x26 __rhs)\x0a"
"{\x0a"
"    basic_ostream<char_type, traits_type>\x3a\x3aswap(__rhs);\x0a"
"    __sb_.swap(__rhs.__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(basic_ofstream<_CharT, _Traits>\x26 __x, basic_ofstream<_CharT, _Traits>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_filebuf<_CharT, _Traits>*\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3ardbuf() const\x0a"
"{\x0a"
"    return const_cast<basic_filebuf<char_type, traits_type>*>(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"bool\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3ais_open() const\x0a"
"{\x0a"
"    return __sb_.is_open();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3aopen(const char* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3aout))\x0a"
"        this->clear();\x0a"
"    else\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3aopen(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3aout))\x0a"
"        this->clear();\x0a"
"    else\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3aopen(const string\x26 __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode \x7c ios_base\x3a\x3aout))\x0a"
"        this->clear();\x0a"
"    else\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void basic_ofstream<_CharT, _Traits>\x3a\x3a__open(int __fd,\x0a"
"                                             ios_base\x3a\x3aopenmode __mode) {\x0a"
"  if (__sb_.__open(__fd, __mode \x7c ios_base\x3a\x3aout))\x0a"
"    this->clear();\x0a"
"  else\x0a"
"    this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"void\x0a"
"basic_ofstream<_CharT, _Traits>\x3a\x3a""close()\x0a"
"{\x0a"
"    if (__sb_.close() == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"// basic_fstream\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_fstream\x0a"
"    \x3a public basic_iostream<_CharT, _Traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_fstream();\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_fstream(const char* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_fstream(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_fstream(const string\x26 __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"\x0a"
"#if _LIBCPP_STD_VER >= 17\x0a"
"    _LIBCPP_AVAILABILITY_FILESYSTEM _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_fstream(const filesystem\x3a\x3apath\x26 __p, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout)\x0a"
"      \x3a basic_fstream(__p.c_str(), __mode) {}\x0a"
"#endif // _LIBCPP_STD_VER >= 17\x0a"
"\x0a"
"#endif\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_fstream(basic_fstream\x26\x26 __rhs);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_fstream\x26 operator=(basic_fstream\x26\x26 __rhs);\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(basic_fstream\x26 __rhs);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_filebuf<char_type, traits_type>* rdbuf() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool is_open() const;\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"    void open(const char* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"    void open(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"#endif\x0a"
"    void open(const string\x26 __s, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"\x0a"
"#if _LIBCPP_STD_VER >= 17\x0a"
"    _LIBCPP_AVAILABILITY_FILESYSTEM _LIBCPP_INLINE_VISIBILITY\x0a"
"    void open(const filesystem\x3a\x3apath\x26 __p, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain\x7cios_base\x3a\x3aout)\x0a"
"    { return open(__p.c_str(), __mode); }\x0a"
"#endif // _LIBCPP_STD_VER >= 17\x0a"
"\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void close();\x0a"
"\x0a"
"private\x3a\x0a"
"    basic_filebuf<char_type, traits_type> __sb_;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3a""basic_fstream()\x0a"
"    \x3a basic_iostream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3a""basic_fstream(const char* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"    \x3a basic_iostream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode) == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3a""basic_fstream(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"    \x3a basic_iostream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode) == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3a""basic_fstream(const string\x26 __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"    \x3a basic_iostream<char_type, traits_type>(\x26__sb_)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode) == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3a""basic_fstream(basic_fstream\x26\x26 __rhs)\x0a"
"    \x3a basic_iostream<char_type, traits_type>(_VSTD\x3a\x3amove(__rhs)),\x0a"
"      __sb_(_VSTD\x3a\x3amove(__rhs.__sb_))\x0a"
"{\x0a"
"    this->set_rdbuf(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_fstream<_CharT, _Traits>\x26\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3aoperator=(basic_fstream\x26\x26 __rhs)\x0a"
"{\x0a"
"    basic_iostream<char_type, traits_type>\x3a\x3aoperator=(_VSTD\x3a\x3amove(__rhs));\x0a"
"    __sb_ = _VSTD\x3a\x3amove(__rhs.__sb_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"void\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3aswap(basic_fstream\x26 __rhs)\x0a"
"{\x0a"
"    basic_iostream<char_type, traits_type>\x3a\x3aswap(__rhs);\x0a"
"    __sb_.swap(__rhs.__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(basic_fstream<_CharT, _Traits>\x26 __x, basic_fstream<_CharT, _Traits>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"basic_filebuf<_CharT, _Traits>*\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3ardbuf() const\x0a"
"{\x0a"
"    return const_cast<basic_filebuf<char_type, traits_type>*>(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"bool\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3ais_open() const\x0a"
"{\x0a"
"    return __sb_.is_open();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_GLOBAL_FILESYSTEM_NAMESPACE\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3aopen(const char* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode))\x0a"
"        this->clear();\x0a"
"    else\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_OPEN_WITH_WCHAR\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3aopen(const wchar_t* __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode))\x0a"
"        this->clear();\x0a"
"    else\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3aopen(const string\x26 __s, ios_base\x3a\x3aopenmode __mode)\x0a"
"{\x0a"
"    if (__sb_.open(__s, __mode))\x0a"
"        this->clear();\x0a"
"    else\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline\x0a"
"void\x0a"
"basic_fstream<_CharT, _Traits>\x3a\x3a""close()\x0a"
"{\x0a"
"    if (__sb_.close() == 0)\x0a"
"        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_FSTREAM\x0a"
"", 54022 ); }