#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_functional( 
"// -*- C++ -*-\x0a"
"//===------------------------ functional ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_FUNCTIONAL\x0a"
"#define _LIBCPP_FUNCTIONAL\x0a"
"\x0a"
"/*\x0a"
"    functional synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class Arg, class Result>\x0a"
"struct unary_function\x0a"
"{\x0a"
"    typedef Arg    argument_type;\x0a"
"    typedef Result result_type;\x0a"
"};\x0a"
"\x0a"
"template <class Arg1, class Arg2, class Result>\x0a"
"struct binary_function\x0a"
"{\x0a"
"    typedef Arg1   first_argument_type;\x0a"
"    typedef Arg2   second_argument_type;\x0a"
"    typedef Result result_type;\x0a"
"};\x0a"
"\x0a"
"template <class T>\x0a"
"class reference_wrapper\x0a"
"    \x3a public unary_function<T1, R> // if wrapping a unary functor\x0a"
"    \x3a public binary_function<T1, T2, R> // if wraping a binary functor\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef T type;\x0a"
"    typedef see below result_type; // Not always defined\x0a"
"\x0a"
"    // construct/copy/destroy\x0a"
"    reference_wrapper(T\x26) noexcept;\x0a"
"    reference_wrapper(T\x26\x26) = delete; // do not bind to temps\x0a"
"    reference_wrapper(const reference_wrapper<T>\x26 x) noexcept;\x0a"
"\x0a"
"    // assignment\x0a"
"    reference_wrapper\x26 operator=(const reference_wrapper<T>\x26 x) noexcept;\x0a"
"\x0a"
"    // access\x0a"
"    operator T\x26 () const noexcept;\x0a"
"    T\x26 get() const noexcept;\x0a"
"\x0a"
"    // invoke\x0a"
"    template <class... ArgTypes>\x0a"
"      typename result_of<T\x26(ArgTypes\x26\x26...)>\x3a\x3atype\x0a"
"          operator() (ArgTypes\x26\x26...) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> reference_wrapper<T> ref(T\x26 t) noexcept;\x0a"
"template <class T> void ref(const T\x26\x26 t) = delete;\x0a"
"template <class T> reference_wrapper<T> ref(reference_wrapper<T>t) noexcept;\x0a"
"\x0a"
"template <class T> reference_wrapper<const T> cref(const T\x26 t) noexcept;\x0a"
"template <class T> void cref(const T\x26\x26 t) = delete;\x0a"
"template <class T> reference_wrapper<const T> cref(reference_wrapper<T> t) noexcept;\x0a"
"\x0a"
"template <class T> struct unwrap_reference;                                       // since C++20\x0a"
"template <class T> struct unwrap_ref_decay \x3a unwrap_reference<decay_t<T>> { };    // since C++20\x0a"
"template <class T> using unwrap_reference_t = typename unwrap_reference<T>\x3a\x3atype; // since C++20\x0a"
"template <class T> using unwrap_ref_decay_t = typename unwrap_ref_decay<T>\x3a\x3atype; // since C++20\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct plus \x3a binary_function<T, T, T>\x0a"
"{\x0a"
"    T operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct minus \x3a binary_function<T, T, T>\x0a"
"{\x0a"
"    T operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct multiplies \x3a binary_function<T, T, T>\x0a"
"{\x0a"
"    T operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct divides \x3a binary_function<T, T, T>\x0a"
"{\x0a"
"    T operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct modulus \x3a binary_function<T, T, T>\x0a"
"{\x0a"
"    T operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct negate \x3a unary_function<T, T>\x0a"
"{\x0a"
"    T operator()(const T\x26 x) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct equal_to \x3a binary_function<T, T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct not_equal_to \x3a binary_function<T, T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct greater \x3a binary_function<T, T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct less \x3a binary_function<T, T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct greater_equal \x3a binary_function<T, T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct less_equal \x3a binary_function<T, T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct logical_and \x3a binary_function<T, T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct logical_or \x3a binary_function<T, T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct logical_not \x3a unary_function<T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct bit_and \x3a unary_function<T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct bit_or \x3a unary_function<T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T> // <class T=void> in C++14\x0a"
"struct bit_xor \x3a unary_function<T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x, const T\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class T=void> // C++14\x0a"
"struct bit_xor \x3a unary_function<T, bool>\x0a"
"{\x0a"
"    bool operator()(const T\x26 x) const;\x0a"
"};\x0a"
"\x0a"
"template <class Predicate>\x0a"
"class unary_negate // deprecated in C++17\x0a"
"    \x3a public unary_function<typename Predicate\x3a\x3a""argument_type, bool>\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit unary_negate(const Predicate\x26 pred);\x0a"
"    bool operator()(const typename Predicate\x3a\x3a""argument_type\x26 x) const;\x0a"
"};\x0a"
"\x0a"
"template <class Predicate> // deprecated in C++17\x0a"
"unary_negate<Predicate> not1(const Predicate\x26 pred);\x0a"
"\x0a"
"template <class Predicate>\x0a"
"class binary_negate // deprecated in C++17\x0a"
"    \x3a public binary_function<typename Predicate\x3a\x3a""first_argument_type,\x0a"
"                             typename Predicate\x3a\x3asecond_argument_type,\x0a"
"                             bool>\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit binary_negate(const Predicate\x26 pred);\x0a"
"    bool operator()(const typename Predicate\x3a\x3a""first_argument_type\x26 x,\x0a"
"                    const typename Predicate\x3a\x3asecond_argument_type\x26 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class Predicate> // deprecated in C++17\x0a"
"binary_negate<Predicate> not2(const Predicate\x26 pred);\x0a"
"\x0a"
"template <class F> unspecified not_fn(F\x26\x26 f); // C++17\x0a"
"\x0a"
"template<class T> struct is_bind_expression;\x0a"
"template<class T> struct is_placeholder;\x0a"
"\x0a"
"    // See C++14 20.9.9, Function object binders\x0a"
"template <class T> inline constexpr bool is_bind_expression_v\x0a"
"  = is_bind_expression<T>\x3a\x3avalue; // C++17\x0a"
"template <class T> inline constexpr int is_placeholder_v\x0a"
"  = is_placeholder<T>\x3a\x3avalue; // C++17\x0a"
"\x0a"
"\x0a"
"template<class Fn, class... BoundArgs>\x0a"
"  unspecified bind(Fn\x26\x26, BoundArgs\x26\x26...);\x0a"
"template<class R, class Fn, class... BoundArgs>\x0a"
"  unspecified bind(Fn\x26\x26, BoundArgs\x26\x26...);\x0a"
"\x0a"
"template<class F, class... Args>\x0a"
" invoke_result_t<F, Args...> invoke(F\x26\x26 f, Args\x26\x26... args) // C++17\x0a"
"    noexcept(is_nothrow_invocable_v<F, Args...>);\x0a"
"\x0a"
"namespace placeholders {\x0a"
"  // M is the implementation-defined number of placeholders\x0a"
"  extern unspecified _1;\x0a"
"  extern unspecified _2;\x0a"
"  .\x0a"
"  .\x0a"
"  .\x0a"
"  extern unspecified _Mp;\x0a"
"}\x0a"
"\x0a"
"template <class Operation>\x0a"
"class binder1st     // deprecated in C++11, removed in C++17\x0a"
"    \x3a public unary_function<typename Operation\x3a\x3asecond_argument_type,\x0a"
"                            typename Operation\x3a\x3aresult_type>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    Operation                               op;\x0a"
"    typename Operation\x3a\x3a""first_argument_type value;\x0a"
"public\x3a\x0a"
"    binder1st(const Operation\x26 x, const typename Operation\x3a\x3a""first_argument_type y);\x0a"
"    typename Operation\x3a\x3aresult_type operator()(      typename Operation\x3a\x3asecond_argument_type\x26 x) const;\x0a"
"    typename Operation\x3a\x3aresult_type operator()(const typename Operation\x3a\x3asecond_argument_type\x26 x) const;\x0a"
"};\x0a"
"\x0a"
"template <class Operation, class T>\x0a"
"binder1st<Operation> bind1st(const Operation\x26 op, const T\x26 x);  // deprecated in C++11, removed in C++17\x0a"
"\x0a"
"template <class Operation>\x0a"
"class binder2nd     // deprecated in C++11, removed in C++17\x0a"
"    \x3a public unary_function<typename Operation\x3a\x3a""first_argument_type,\x0a"
"                            typename Operation\x3a\x3aresult_type>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    Operation                                op;\x0a"
"    typename Operation\x3a\x3asecond_argument_type value;\x0a"
"public\x3a\x0a"
"    binder2nd(const Operation\x26 x, const typename Operation\x3a\x3asecond_argument_type y);\x0a"
"    typename Operation\x3a\x3aresult_type operator()(      typename Operation\x3a\x3a""first_argument_type\x26 x) const;\x0a"
"    typename Operation\x3a\x3aresult_type operator()(const typename Operation\x3a\x3a""first_argument_type\x26 x) const;\x0a"
"};\x0a"
"\x0a"
"template <class Operation, class T>\x0a"
"binder2nd<Operation> bind2nd(const Operation\x26 op, const T\x26 x);  // deprecated in C++11, removed in C++17\x0a"
"\x0a"
"template <class Arg, class Result>      // deprecated in C++11, removed in C++17\x0a"
"class pointer_to_unary_function \x3a public unary_function<Arg, Result>\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit pointer_to_unary_function(Result (*f)(Arg));\x0a"
"    Result operator()(Arg x) const;\x0a"
"};\x0a"
"\x0a"
"template <class Arg, class Result>\x0a"
"pointer_to_unary_function<Arg,Result> ptr_fun(Result (*f)(Arg));      // deprecated in C++11, removed in C++17\x0a"
"\x0a"
"template <class Arg1, class Arg2, class Result>      // deprecated in C++11, removed in C++17\x0a"
"class pointer_to_binary_function \x3a public binary_function<Arg1, Arg2, Result>\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit pointer_to_binary_function(Result (*f)(Arg1, Arg2));\x0a"
"    Result operator()(Arg1 x, Arg2 y) const;\x0a"
"};\x0a"
"\x0a"
"template <class Arg1, class Arg2, class Result>\x0a"
"pointer_to_binary_function<Arg1,Arg2,Result> ptr_fun(Result (*f)(Arg1,Arg2));      // deprecated in C++11, removed in C++17\x0a"
"\x0a"
"template<class S, class T>      // deprecated in C++11, removed in C++17\x0a"
"class mem_fun_t \x3a public unary_function<T*, S>\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit mem_fun_t(S (T\x3a\x3a*p)());\x0a"
"    S operator()(T* p) const;\x0a"
"};\x0a"
"\x0a"
"template<class S, class T, class A>\x0a"
"class mem_fun1_t \x3a public binary_function<T*, A, S>      // deprecated in C++11, removed in C++17\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit mem_fun1_t(S (T\x3a\x3a*p)(A));\x0a"
"    S operator()(T* p, A x) const;\x0a"
"};\x0a"
"\x0a"
"template<class S, class T>          mem_fun_t<S,T>    mem_fun(S (T\x3a\x3a*f)());      // deprecated in C++11, removed in C++17\x0a"
"template<class S, class T, class A> mem_fun1_t<S,T,A> mem_fun(S (T\x3a\x3a*f)(A));     // deprecated in C++11, removed in C++17\x0a"
"\x0a"
"template<class S, class T>\x0a"
"class mem_fun_ref_t \x3a public unary_function<T, S>      // deprecated in C++11, removed in C++17\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit mem_fun_ref_t(S (T\x3a\x3a*p)());\x0a"
"    S operator()(T\x26 p) const;\x0a"
"};\x0a"
"\x0a"
"template<class S, class T, class A>\x0a"
"class mem_fun1_ref_t \x3a public binary_function<T, A, S>      // deprecated in C++11, removed in C++17\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit mem_fun1_ref_t(S (T\x3a\x3a*p)(A));\x0a"
"    S operator()(T\x26 p, A x) const;\x0a"
"};\x0a"
"\x0a"
"template<class S, class T>          mem_fun_ref_t<S,T>    mem_fun_ref(S (T\x3a\x3a*f)());      // deprecated in C++11, removed in C++17\x0a"
"template<class S, class T, class A> mem_fun1_ref_t<S,T,A> mem_fun_ref(S (T\x3a\x3a*f)(A));     // deprecated in C++11, removed in C++17\x0a"
"\x0a"
"template <class S, class T>\x0a"
"class const_mem_fun_t \x3a public unary_function<const T*, S>      // deprecated in C++11, removed in C++17\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit const_mem_fun_t(S (T\x3a\x3a*p)() const);\x0a"
"    S operator()(const T* p) const;\x0a"
"};\x0a"
"\x0a"
"template <class S, class T, class A>\x0a"
"class const_mem_fun1_t \x3a public binary_function<const T*, A, S>      // deprecated in C++11, removed in C++17\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit const_mem_fun1_t(S (T\x3a\x3a*p)(A) const);\x0a"
"    S operator()(const T* p, A x) const;\x0a"
"};\x0a"
"\x0a"
"template <class S, class T>          const_mem_fun_t<S,T>    mem_fun(S (T\x3a\x3a*f)() const);      // deprecated in C++11, removed in C++17\x0a"
"template <class S, class T, class A> const_mem_fun1_t<S,T,A> mem_fun(S (T\x3a\x3a*f)(A) const);     // deprecated in C++11, removed in C++17\x0a"
"\x0a"
"template <class S, class T>\x0a"
"class const_mem_fun_ref_t \x3a public unary_function<T, S>      // deprecated in C++11, removed in C++17\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit const_mem_fun_ref_t(S (T\x3a\x3a*p)() const);\x0a"
"    S operator()(const T\x26 p) const;\x0a"
"};\x0a"
"\x0a"
"template <class S, class T, class A>\x0a"
"class const_mem_fun1_ref_t \x3a public binary_function<T, A, S>      // deprecated in C++11, removed in C++17\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit const_mem_fun1_ref_t(S (T\x3a\x3a*p)(A) const);\x0a"
"    S operator()(const T\x26 p, A x) const;\x0a"
"};\x0a"
"\x0a"
"template <class S, class T>          const_mem_fun_ref_t<S,T>    mem_fun_ref(S (T\x3a\x3a*f)() const);   // deprecated in C++11, removed in C++17\x0a"
"template <class S, class T, class A> const_mem_fun1_ref_t<S,T,A> mem_fun_ref(S (T\x3a\x3a*f)(A) const);  // deprecated in C++11, removed in C++17\x0a"
"\x0a"
"template<class R, class T> unspecified mem_fn(R T\x3a\x3a*);\x0a"
"\x0a"
"class bad_function_call\x0a"
"    \x3a public exception\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template<class> class function; // undefined\x0a"
"\x0a"
"template<class R, class... ArgTypes>\x0a"
"class function<R(ArgTypes...)>\x0a"
"  \x3a public unary_function<T1, R>      // iff sizeof...(ArgTypes) == 1 and\x0a"
"                                      // ArgTypes contains T1\x0a"
"  \x3a public binary_function<T1, T2, R> // iff sizeof...(ArgTypes) == 2 and\x0a"
"                                      // ArgTypes contains T1 and T2\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef R result_type;\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    function() noexcept;\x0a"
"    function(nullptr_t) noexcept;\x0a"
"    function(const function\x26);\x0a"
"    function(function\x26\x26) noexcept;\x0a"
"    template<class F>\x0a"
"      function(F);\x0a"
"    template<Allocator Alloc>\x0a"
"      function(allocator_arg_t, const Alloc\x26) noexcept;            // removed in C++17\x0a"
"    template<Allocator Alloc>\x0a"
"      function(allocator_arg_t, const Alloc\x26, nullptr_t) noexcept; // removed in C++17\x0a"
"    template<Allocator Alloc>\x0a"
"      function(allocator_arg_t, const Alloc\x26, const function\x26);    // removed in C++17\x0a"
"    template<Allocator Alloc>\x0a"
"      function(allocator_arg_t, const Alloc\x26, function\x26\x26);         // removed in C++17\x0a"
"    template<class F, Allocator Alloc>\x0a"
"      function(allocator_arg_t, const Alloc\x26, F);                  // removed in C++17\x0a"
"\x0a"
"    function\x26 operator=(const function\x26);\x0a"
"    function\x26 operator=(function\x26\x26) noexcept;\x0a"
"    function\x26 operator=(nullptr_t) noexcept;\x0a"
"    template<class F>\x0a"
"      function\x26 operator=(F\x26\x26);\x0a"
"    template<class F>\x0a"
"      function\x26 operator=(reference_wrapper<F>) noexcept;\x0a"
"\x0a"
"    \x7e""function();\x0a"
"\x0a"
"    // function modifiers\x3a\x0a"
"    void swap(function\x26) noexcept;\x0a"
"    template<class F, class Alloc>\x0a"
"      void assign(F\x26\x26, const Alloc\x26);                 // Removed in C++17\x0a"
"\x0a"
"    // function capacity\x3a\x0a"
"    explicit operator bool() const noexcept;\x0a"
"\x0a"
"    // function invocation\x3a\x0a"
"    R operator()(ArgTypes...) const;\x0a"
"\x0a"
"    // function target access\x3a\x0a"
"    const std\x3a\x3atype_info\x26 target_type() const noexcept;\x0a"
"    template <typename T>       T* target() noexcept;\x0a"
"    template <typename T> const T* target() const noexcept;\x0a"
"};\x0a"
"\x0a"
"// Null pointer comparisons\x3a\x0a"
"template <class R, class ... ArgTypes>\x0a"
"  bool operator==(const function<R(ArgTypes...)>\x26, nullptr_t) noexcept;\x0a"
"\x0a"
"template <class R, class ... ArgTypes>\x0a"
"  bool operator==(nullptr_t, const function<R(ArgTypes...)>\x26) noexcept;\x0a"
"\x0a"
"template <class R, class ... ArgTypes>\x0a"
"  bool operator\x21=(const function<R(ArgTypes...)>\x26, nullptr_t) noexcept;\x0a"
"\x0a"
"template <class  R, class ... ArgTypes>\x0a"
"  bool operator\x21=(nullptr_t, const function<R(ArgTypes...)>\x26) noexcept;\x0a"
"\x0a"
"// specialized algorithms\x3a\x0a"
"template <class  R, class ... ArgTypes>\x0a"
"  void swap(function<R(ArgTypes...)>\x26, function<R(ArgTypes...)>\x26) noexcept;\x0a"
"\x0a"
"template <class T> struct hash;\x0a"
"\x0a"
"template <> struct hash<bool>;\x0a"
"template <> struct hash<char>;\x0a"
"template <> struct hash<signed char>;\x0a"
"template <> struct hash<unsigned char>;\x0a"
"template <> struct hash<char16_t>;\x0a"
"template <> struct hash<char32_t>;\x0a"
"template <> struct hash<wchar_t>;\x0a"
"template <> struct hash<short>;\x0a"
"template <> struct hash<unsigned short>;\x0a"
"template <> struct hash<int>;\x0a"
"template <> struct hash<unsigned int>;\x0a"
"template <> struct hash<long>;\x0a"
"template <> struct hash<long long>;\x0a"
"template <> struct hash<unsigned long>;\x0a"
"template <> struct hash<unsigned long long>;\x0a"
"\x0a"
"template <> struct hash<float>;\x0a"
"template <> struct hash<double>;\x0a"
"template <> struct hash<long double>;\x0a"
"\x0a"
"template<class T> struct hash<T*>;\x0a"
"template <> struct hash<nullptr_t>;  // C++17\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"POLICY\x3a  For non-variadic implementations, the number of arguments is limited\x0a"
"         to 3.  It is hoped that the need for non-variadic implementations\x0a"
"         will be minimal.\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <type_traits>\x0a"
"#include <typeinfo>\x0a"
"#include <exception>\x0a"
"#include <memory>\x0a"
"#include <tuple>\x0a"
"#include <utility>\x0a"
"#include <version>\x0a"
"\x0a"
"#include <__functional_base>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS plus \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x + __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS plus<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) + _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) + _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) + _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS minus \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x - __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS minus<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) - _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) - _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) - _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS multiplies \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x * __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS multiplies<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) * _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) * _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) * _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS divides \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x / __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS divides<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) / _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) / _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) / _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS modulus \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x \x25 __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS modulus<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) \x25 _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) \x25 _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) \x25 _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS negate \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return -__x;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS negate<void>\x0a"
"{\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_Tp\x26\x26 __x) const\x0a"
"    _NOEXCEPT_(noexcept(- _VSTD\x3a\x3a""forward<_Tp>(__x)))\x0a"
"    -> decltype        (- _VSTD\x3a\x3a""forward<_Tp>(__x))\x0a"
"        { return        - _VSTD\x3a\x3a""forward<_Tp>(__x); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS equal_to \x3a binary_function<_Tp, _Tp, bool>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x == __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS equal_to<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) == _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) == _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) == _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS not_equal_to \x3a binary_function<_Tp, _Tp, bool>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x \x21= __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS not_equal_to<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) \x21= _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) \x21= _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) \x21= _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS greater \x3a binary_function<_Tp, _Tp, bool>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x > __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS greater<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) > _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) > _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) > _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"// less in <__functional_base>\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS greater_equal \x3a binary_function<_Tp, _Tp, bool>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x >= __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS greater_equal<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) >= _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) >= _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) >= _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS less_equal \x3a binary_function<_Tp, _Tp, bool>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x <= __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS less_equal<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) <= _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) <= _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) <= _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS logical_and \x3a binary_function<_Tp, _Tp, bool>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x \x26\x26 __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS logical_and<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) \x26\x26 _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) \x26\x26 _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) \x26\x26 _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS logical_or \x3a binary_function<_Tp, _Tp, bool>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x \x7c\x7c __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS logical_or<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) \x7c\x7c _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) \x7c\x7c _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) \x7c\x7c _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS logical_not \x3a unary_function<_Tp, bool>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Tp\x26 __x) const\x0a"
"        {return \x21__x;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS logical_not<void>\x0a"
"{\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_Tp\x26\x26 __x) const\x0a"
"    _NOEXCEPT_(noexcept(\x21_VSTD\x3a\x3a""forward<_Tp>(__x)))\x0a"
"    -> decltype        (\x21_VSTD\x3a\x3a""forward<_Tp>(__x))\x0a"
"        { return        \x21_VSTD\x3a\x3a""forward<_Tp>(__x); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS bit_and \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x \x26 __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS bit_and<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) \x26 _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) \x26 _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) \x26 _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS bit_or \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x \x7c __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS bit_or<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) \x7c _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) \x7c _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) \x7c _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"#else\x0a"
"template <class _Tp>\x0a"
"#endif\x0a"
"struct _LIBCPP_TEMPLATE_VIS bit_xor \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x ^ __y;}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS bit_xor<void>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"    _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) ^ _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"    -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) ^ _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"        { return        _VSTD\x3a\x3a""forward<_T1>(__t) ^ _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp = void>\x0a"
"struct _LIBCPP_TEMPLATE_VIS bit_not \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return \x7e__x;}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS bit_not<void>\x0a"
"{\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_Tp\x26\x26 __x) const\x0a"
"    _NOEXCEPT_(noexcept(\x7e_VSTD\x3a\x3a""forward<_Tp>(__x)))\x0a"
"    -> decltype        (\x7e_VSTD\x3a\x3a""forward<_Tp>(__x))\x0a"
"        { return        \x7e_VSTD\x3a\x3a""forward<_Tp>(__x); }\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"template <class _Predicate>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX17 unary_negate\x0a"
"    \x3a public unary_function<typename _Predicate\x3a\x3a""argument_type, bool>\x0a"
"{\x0a"
"    _Predicate __pred_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit unary_negate(const _Predicate\x26 __pred)\x0a"
"        \x3a __pred_(__pred) {}\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const typename _Predicate\x3a\x3a""argument_type\x26 __x) const\x0a"
"        {return \x21__pred_(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Predicate>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX17 inline _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"unary_negate<_Predicate>\x0a"
"not1(const _Predicate\x26 __pred) {return unary_negate<_Predicate>(__pred);}\x0a"
"\x0a"
"template <class _Predicate>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX17 binary_negate\x0a"
"    \x3a public binary_function<typename _Predicate\x3a\x3a""first_argument_type,\x0a"
"                             typename _Predicate\x3a\x3asecond_argument_type,\x0a"
"                             bool>\x0a"
"{\x0a"
"    _Predicate __pred_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    binary_negate(const _Predicate\x26 __pred) \x3a __pred_(__pred) {}\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const typename _Predicate\x3a\x3a""first_argument_type\x26 __x,\x0a"
"                    const typename _Predicate\x3a\x3asecond_argument_type\x26 __y) const\x0a"
"        {return \x21__pred_(__x, __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _Predicate>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX17 inline _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"binary_negate<_Predicate>\x0a"
"not2(const _Predicate\x26 __pred) {return binary_negate<_Predicate>(__pred);}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_BINDERS)\x0a"
"template <class __Operation>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 binder1st\x0a"
"    \x3a public unary_function<typename __Operation\x3a\x3asecond_argument_type,\x0a"
"                            typename __Operation\x3a\x3aresult_type>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    __Operation                               op;\x0a"
"    typename __Operation\x3a\x3a""first_argument_type value;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY binder1st(const __Operation\x26 __x,\x0a"
"                               const typename __Operation\x3a\x3a""first_argument_type __y)\x0a"
"        \x3a op(__x), value(__y) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY typename __Operation\x3a\x3aresult_type operator()\x0a"
"        (typename __Operation\x3a\x3asecond_argument_type\x26 __x) const\x0a"
"            {return op(value, __x);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY typename __Operation\x3a\x3aresult_type operator()\x0a"
"        (const typename __Operation\x3a\x3asecond_argument_type\x26 __x) const\x0a"
"            {return op(value, __x);}\x0a"
"};\x0a"
"\x0a"
"template <class __Operation, class _Tp>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"binder1st<__Operation>\x0a"
"bind1st(const __Operation\x26 __op, const _Tp\x26 __x)\x0a"
"    {return binder1st<__Operation>(__op, __x);}\x0a"
"\x0a"
"template <class __Operation>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 binder2nd\x0a"
"    \x3a public unary_function<typename __Operation\x3a\x3a""first_argument_type,\x0a"
"                            typename __Operation\x3a\x3aresult_type>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    __Operation                                op;\x0a"
"    typename __Operation\x3a\x3asecond_argument_type value;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    binder2nd(const __Operation\x26 __x, const typename __Operation\x3a\x3asecond_argument_type __y)\x0a"
"        \x3a op(__x), value(__y) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY typename __Operation\x3a\x3aresult_type operator()\x0a"
"        (      typename __Operation\x3a\x3a""first_argument_type\x26 __x) const\x0a"
"            {return op(__x, value);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY typename __Operation\x3a\x3aresult_type operator()\x0a"
"        (const typename __Operation\x3a\x3a""first_argument_type\x26 __x) const\x0a"
"            {return op(__x, value);}\x0a"
"};\x0a"
"\x0a"
"template <class __Operation, class _Tp>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"binder2nd<__Operation>\x0a"
"bind2nd(const __Operation\x26 __op, const _Tp\x26 __x)\x0a"
"    {return binder2nd<__Operation>(__op, __x);}\x0a"
"\x0a"
"template <class _Arg, class _Result>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 pointer_to_unary_function\x0a"
"    \x3a public unary_function<_Arg, _Result>\x0a"
"{\x0a"
"    _Result (*__f_)(_Arg);\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit pointer_to_unary_function(_Result (*__f)(_Arg))\x0a"
"        \x3a __f_(__f) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Result operator()(_Arg __x) const\x0a"
"        {return __f_(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Arg, class _Result>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"pointer_to_unary_function<_Arg,_Result>\x0a"
"ptr_fun(_Result (*__f)(_Arg))\x0a"
"    {return pointer_to_unary_function<_Arg,_Result>(__f);}\x0a"
"\x0a"
"template <class _Arg1, class _Arg2, class _Result>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 pointer_to_binary_function\x0a"
"    \x3a public binary_function<_Arg1, _Arg2, _Result>\x0a"
"{\x0a"
"    _Result (*__f_)(_Arg1, _Arg2);\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit pointer_to_binary_function(_Result (*__f)(_Arg1, _Arg2))\x0a"
"        \x3a __f_(__f) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Result operator()(_Arg1 __x, _Arg2 __y) const\x0a"
"        {return __f_(__x, __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _Arg1, class _Arg2, class _Result>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"pointer_to_binary_function<_Arg1,_Arg2,_Result>\x0a"
"ptr_fun(_Result (*__f)(_Arg1,_Arg2))\x0a"
"    {return pointer_to_binary_function<_Arg1,_Arg2,_Result>(__f);}\x0a"
"\x0a"
"template<class _Sp, class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 mem_fun_t\x0a"
"    \x3a public unary_function<_Tp*, _Sp>\x0a"
"{\x0a"
"    _Sp (_Tp\x3a\x3a*__p_)();\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit mem_fun_t(_Sp (_Tp\x3a\x3a*__p)())\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Sp operator()(_Tp* __p) const\x0a"
"        {return (__p->*__p_)();}\x0a"
"};\x0a"
"\x0a"
"template<class _Sp, class _Tp, class _Ap>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 mem_fun1_t\x0a"
"    \x3a public binary_function<_Tp*, _Ap, _Sp>\x0a"
"{\x0a"
"    _Sp (_Tp\x3a\x3a*__p_)(_Ap);\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit mem_fun1_t(_Sp (_Tp\x3a\x3a*__p)(_Ap))\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Sp operator()(_Tp* __p, _Ap __x) const\x0a"
"        {return (__p->*__p_)(__x);}\x0a"
"};\x0a"
"\x0a"
"template<class _Sp, class _Tp>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"mem_fun_t<_Sp,_Tp>\x0a"
"mem_fun(_Sp (_Tp\x3a\x3a*__f)())\x0a"
"    {return mem_fun_t<_Sp,_Tp>(__f);}\x0a"
"\x0a"
"template<class _Sp, class _Tp, class _Ap>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"mem_fun1_t<_Sp,_Tp,_Ap>\x0a"
"mem_fun(_Sp (_Tp\x3a\x3a*__f)(_Ap))\x0a"
"    {return mem_fun1_t<_Sp,_Tp,_Ap>(__f);}\x0a"
"\x0a"
"template<class _Sp, class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 mem_fun_ref_t\x0a"
"    \x3a public unary_function<_Tp, _Sp>\x0a"
"{\x0a"
"    _Sp (_Tp\x3a\x3a*__p_)();\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit mem_fun_ref_t(_Sp (_Tp\x3a\x3a*__p)())\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Sp operator()(_Tp\x26 __p) const\x0a"
"        {return (__p.*__p_)();}\x0a"
"};\x0a"
"\x0a"
"template<class _Sp, class _Tp, class _Ap>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 mem_fun1_ref_t\x0a"
"    \x3a public binary_function<_Tp, _Ap, _Sp>\x0a"
"{\x0a"
"    _Sp (_Tp\x3a\x3a*__p_)(_Ap);\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit mem_fun1_ref_t(_Sp (_Tp\x3a\x3a*__p)(_Ap))\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Sp operator()(_Tp\x26 __p, _Ap __x) const\x0a"
"        {return (__p.*__p_)(__x);}\x0a"
"};\x0a"
"\x0a"
"template<class _Sp, class _Tp>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"mem_fun_ref_t<_Sp,_Tp>\x0a"
"mem_fun_ref(_Sp (_Tp\x3a\x3a*__f)())\x0a"
"    {return mem_fun_ref_t<_Sp,_Tp>(__f);}\x0a"
"\x0a"
"template<class _Sp, class _Tp, class _Ap>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"mem_fun1_ref_t<_Sp,_Tp,_Ap>\x0a"
"mem_fun_ref(_Sp (_Tp\x3a\x3a*__f)(_Ap))\x0a"
"    {return mem_fun1_ref_t<_Sp,_Tp,_Ap>(__f);}\x0a"
"\x0a"
"template <class _Sp, class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 const_mem_fun_t\x0a"
"    \x3a public unary_function<const _Tp*, _Sp>\x0a"
"{\x0a"
"    _Sp (_Tp\x3a\x3a*__p_)() const;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit const_mem_fun_t(_Sp (_Tp\x3a\x3a*__p)() const)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Sp operator()(const _Tp* __p) const\x0a"
"        {return (__p->*__p_)();}\x0a"
"};\x0a"
"\x0a"
"template <class _Sp, class _Tp, class _Ap>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 const_mem_fun1_t\x0a"
"    \x3a public binary_function<const _Tp*, _Ap, _Sp>\x0a"
"{\x0a"
"    _Sp (_Tp\x3a\x3a*__p_)(_Ap) const;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit const_mem_fun1_t(_Sp (_Tp\x3a\x3a*__p)(_Ap) const)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Sp operator()(const _Tp* __p, _Ap __x) const\x0a"
"        {return (__p->*__p_)(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Sp, class _Tp>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"const_mem_fun_t<_Sp,_Tp>\x0a"
"mem_fun(_Sp (_Tp\x3a\x3a*__f)() const)\x0a"
"    {return const_mem_fun_t<_Sp,_Tp>(__f);}\x0a"
"\x0a"
"template <class _Sp, class _Tp, class _Ap>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"const_mem_fun1_t<_Sp,_Tp,_Ap>\x0a"
"mem_fun(_Sp (_Tp\x3a\x3a*__f)(_Ap) const)\x0a"
"    {return const_mem_fun1_t<_Sp,_Tp,_Ap>(__f);}\x0a"
"\x0a"
"template <class _Sp, class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 const_mem_fun_ref_t\x0a"
"    \x3a public unary_function<_Tp, _Sp>\x0a"
"{\x0a"
"    _Sp (_Tp\x3a\x3a*__p_)() const;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit const_mem_fun_ref_t(_Sp (_Tp\x3a\x3a*__p)() const)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Sp operator()(const _Tp\x26 __p) const\x0a"
"        {return (__p.*__p_)();}\x0a"
"};\x0a"
"\x0a"
"template <class _Sp, class _Tp, class _Ap>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 const_mem_fun1_ref_t\x0a"
"    \x3a public binary_function<_Tp, _Ap, _Sp>\x0a"
"{\x0a"
"    _Sp (_Tp\x3a\x3a*__p_)(_Ap) const;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit const_mem_fun1_ref_t(_Sp (_Tp\x3a\x3a*__p)(_Ap) const)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Sp operator()(const _Tp\x26 __p, _Ap __x) const\x0a"
"        {return (__p.*__p_)(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Sp, class _Tp>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"const_mem_fun_ref_t<_Sp,_Tp>\x0a"
"mem_fun_ref(_Sp (_Tp\x3a\x3a*__f)() const)\x0a"
"    {return const_mem_fun_ref_t<_Sp,_Tp>(__f);}\x0a"
"\x0a"
"template <class _Sp, class _Tp, class _Ap>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX11 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"const_mem_fun1_ref_t<_Sp,_Tp,_Ap>\x0a"
"mem_fun_ref(_Sp (_Tp\x3a\x3a*__f)(_Ap) const)\x0a"
"    {return const_mem_fun1_ref_t<_Sp,_Tp,_Ap>(__f);}\x0a"
"#endif\x0a"
"\x0a"
"////////////////////////////////////////////////////////////////////////////////\x0a"
"//                                MEMFUN\x0a"
"//==============================================================================\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class __mem_fn\x0a"
"    \x3a public __weak_result_type<_Tp>\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _Tp type;\x0a"
"private\x3a\x0a"
"    type __f_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY __mem_fn(type __f) _NOEXCEPT \x3a __f_(__f) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    // invoke\x0a"
"    template <class... _ArgTypes>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return<type, _ArgTypes...>\x3a\x3atype\x0a"
"    operator() (_ArgTypes\x26\x26... __args) const {\x0a"
"        return __invoke(__f_, _VSTD\x3a\x3a""forward<_ArgTypes>(__args)...);\x0a"
"    }\x0a"
"#else\x0a"
"\x0a"
"    template <class _A0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return0<type, _A0>\x3a\x3atype\x0a"
"    operator() (_A0\x26 __a0) const {\x0a"
"        return __invoke(__f_, __a0);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return0<type, _A0 const>\x3a\x3atype\x0a"
"    operator() (_A0 const\x26 __a0) const {\x0a"
"        return __invoke(__f_, __a0);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return1<type, _A0, _A1>\x3a\x3atype\x0a"
"    operator() (_A0\x26 __a0, _A1\x26 __a1) const {\x0a"
"        return __invoke(__f_, __a0, __a1);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return1<type, _A0 const, _A1>\x3a\x3atype\x0a"
"    operator() (_A0 const\x26 __a0, _A1\x26 __a1) const {\x0a"
"        return __invoke(__f_, __a0, __a1);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return1<type, _A0, _A1 const>\x3a\x3atype\x0a"
"    operator() (_A0\x26 __a0, _A1 const\x26 __a1) const {\x0a"
"        return __invoke(__f_, __a0, __a1);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return1<type, _A0 const, _A1 const>\x3a\x3atype\x0a"
"    operator() (_A0 const\x26 __a0, _A1 const\x26 __a1) const {\x0a"
"        return __invoke(__f_, __a0, __a1);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1, class _A2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return2<type, _A0, _A1, _A2>\x3a\x3atype\x0a"
"    operator() (_A0\x26 __a0, _A1\x26 __a1, _A2\x26 __a2) const {\x0a"
"        return __invoke(__f_, __a0, __a1, __a2);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1, class _A2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return2<type, _A0 const, _A1, _A2>\x3a\x3atype\x0a"
"    operator() (_A0 const\x26 __a0, _A1\x26 __a1, _A2\x26 __a2) const {\x0a"
"        return __invoke(__f_, __a0, __a1, __a2);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1, class _A2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return2<type, _A0, _A1 const, _A2>\x3a\x3atype\x0a"
"    operator() (_A0\x26 __a0, _A1 const\x26 __a1, _A2\x26 __a2) const {\x0a"
"        return __invoke(__f_, __a0, __a1, __a2);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1, class _A2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return2<type, _A0, _A1, _A2 const>\x3a\x3atype\x0a"
"    operator() (_A0\x26 __a0, _A1\x26 __a1, _A2 const\x26 __a2) const {\x0a"
"        return __invoke(__f_, __a0, __a1, __a2);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1, class _A2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return2<type, _A0 const, _A1 const, _A2>\x3a\x3atype\x0a"
"    operator() (_A0 const\x26 __a0, _A1 const\x26 __a1, _A2\x26 __a2) const {\x0a"
"        return __invoke(__f_, __a0, __a1, __a2);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1, class _A2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return2<type, _A0 const, _A1, _A2 const>\x3a\x3atype\x0a"
"    operator() (_A0 const\x26 __a0, _A1\x26 __a1, _A2 const\x26 __a2) const {\x0a"
"        return __invoke(__f_, __a0, __a1, __a2);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1, class _A2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return2<type, _A0, _A1 const, _A2 const>\x3a\x3atype\x0a"
"    operator() (_A0\x26 __a0, _A1 const\x26 __a1, _A2 const\x26 __a2) const {\x0a"
"        return __invoke(__f_, __a0, __a1, __a2);\x0a"
"    }\x0a"
"\x0a"
"    template <class _A0, class _A1, class _A2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename __invoke_return2<type, _A0 const, _A1 const, _A2 const>\x3a\x3atype\x0a"
"    operator() (_A0 const\x26 __a0, _A1 const\x26 __a1, _A2 const\x26 __a2) const {\x0a"
"        return __invoke(__f_, __a0, __a1, __a2);\x0a"
"    }\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template<class _Rp, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__mem_fn<_Rp _Tp\x3a\x3a*>\x0a"
"mem_fn(_Rp _Tp\x3a\x3a* __pm) _NOEXCEPT\x0a"
"{\x0a"
"    return __mem_fn<_Rp _Tp\x3a\x3a*>(__pm);\x0a"
"}\x0a"
"\x0a"
"////////////////////////////////////////////////////////////////////////////////\x0a"
"//                                FUNCTION\x0a"
"//==============================================================================\x0a"
"\x0a"
"// bad_function_call\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI bad_function_call\x0a"
"    \x3a public exception\x0a"
"{\x0a"
"#ifdef _LIBCPP_ABI_BAD_FUNCTION_CALL_KEY_FUNCTION\x0a"
"public\x3a\x0a"
"    virtual \x7e""bad_function_call() _NOEXCEPT;\x0a"
"\x0a"
"    virtual const char* what() const _NOEXCEPT;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_bad_function_call()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw bad_function_call();\x0a"
"#else\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template<class _Fp> class _LIBCPP_TEMPLATE_VIS function; // undefined\x0a"
"\x0a"
"namespace __function\x0a"
"{\x0a"
"\x0a"
"template<class _Rp>\x0a"
"struct __maybe_derive_from_unary_function\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template<class _Rp, class _A1>\x0a"
"struct __maybe_derive_from_unary_function<_Rp(_A1)>\x0a"
"    \x3a public unary_function<_A1, _Rp>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template<class _Rp>\x0a"
"struct __maybe_derive_from_binary_function\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template<class _Rp, class _A1, class _A2>\x0a"
"struct __maybe_derive_from_binary_function<_Rp(_A1, _A2)>\x0a"
"    \x3a public binary_function<_A1, _A2, _Rp>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Fp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __not_null(_Fp const\x26) { return true; }\x0a"
"\x0a"
"template <class _Fp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __not_null(_Fp* __ptr) { return __ptr; }\x0a"
"\x0a"
"template <class _Ret, class _Class>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __not_null(_Ret _Class\x3a\x3a*__ptr) { return __ptr; }\x0a"
"\x0a"
"template <class _Fp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool __not_null(function<_Fp> const\x26 __f) { return \x21\x21__f; }\x0a"
"\x0a"
"} // namespace __function\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"namespace __function {\x0a"
"\x0a"
"// __alloc_func holds a functor and an allocator.\x0a"
"\x0a"
"template <class _Fp, class _Ap, class _FB> class __alloc_func;\x0a"
"template <class _Fp, class _FB>\x0a"
"class __default_alloc_func;\x0a"
"\x0a"
"template <class _Fp, class _Ap, class _Rp, class... _ArgTypes>\x0a"
"class __alloc_func<_Fp, _Ap, _Rp(_ArgTypes...)>\x0a"
"{\x0a"
"    __compressed_pair<_Fp, _Ap> __f_;\x0a"
"\x0a"
"  public\x3a\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE _Fp _Target;\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE _Ap _Alloc;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Target\x26 __target() const { return __f_.first(); }\x0a"
"\x0a"
"    // WIN32 APIs may define __allocator, so use __get_allocator instead.\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Alloc\x26 __get_allocator() const { return __f_.second(); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __alloc_func(_Target\x26\x26 __f)\x0a"
"        \x3a __f_(piecewise_construct, _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3amove(__f)),\x0a"
"               _VSTD\x3a\x3a""forward_as_tuple())\x0a"
"    {\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __alloc_func(const _Target\x26 __f, const _Alloc\x26 __a)\x0a"
"        \x3a __f_(piecewise_construct, _VSTD\x3a\x3a""forward_as_tuple(__f),\x0a"
"               _VSTD\x3a\x3a""forward_as_tuple(__a))\x0a"
"    {\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __alloc_func(const _Target\x26 __f, _Alloc\x26\x26 __a)\x0a"
"        \x3a __f_(piecewise_construct, _VSTD\x3a\x3a""forward_as_tuple(__f),\x0a"
"               _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3amove(__a)))\x0a"
"    {\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __alloc_func(_Target\x26\x26 __f, _Alloc\x26\x26 __a)\x0a"
"        \x3a __f_(piecewise_construct, _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3amove(__f)),\x0a"
"               _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3amove(__a)))\x0a"
"    {\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Rp operator()(_ArgTypes\x26\x26... __arg)\x0a"
"    {\x0a"
"        typedef __invoke_void_return_wrapper<_Rp> _Invoker;\x0a"
"        return _Invoker\x3a\x3a__call(__f_.first(),\x0a"
"                                _VSTD\x3a\x3a""forward<_ArgTypes>(__arg)...);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __alloc_func* __clone() const\x0a"
"    {\x0a"
"        typedef allocator_traits<_Alloc> __alloc_traits;\x0a"
"        typedef\x0a"
"            typename __rebind_alloc_helper<__alloc_traits, __alloc_func>\x3a\x3atype\x0a"
"                _AA;\x0a"
"        _AA __a(__f_.second());\x0a"
"        typedef __allocator_destructor<_AA> _Dp;\x0a"
"        unique_ptr<__alloc_func, _Dp> __hold(__a.allocate(1), _Dp(__a, 1));\x0a"
"        \x3a\x3anew ((void*)__hold.get()) __alloc_func(__f_.first(), _Alloc(__a));\x0a"
"        return __hold.release();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void destroy() _NOEXCEPT { __f_.\x7e__compressed_pair<_Target, _Alloc>(); }\x0a"
"\x0a"
"    static void __destroy_and_delete(__alloc_func* __f) {\x0a"
"      typedef allocator_traits<_Alloc> __alloc_traits;\x0a"
"      typedef typename __rebind_alloc_helper<__alloc_traits, __alloc_func>\x3a\x3atype\x0a"
"          _FunAlloc;\x0a"
"      _FunAlloc __a(__f->__get_allocator());\x0a"
"      __f->destroy();\x0a"
"      __a.deallocate(__f, 1);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Fp, class _Rp, class... _ArgTypes>\x0a"
"class __default_alloc_func<_Fp, _Rp(_ArgTypes...)> {\x0a"
"  _Fp __f_;\x0a"
"\x0a"
"public\x3a\x0a"
"  typedef _LIBCPP_NODEBUG_TYPE _Fp _Target;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const _Target\x26 __target() const { return __f_; }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit __default_alloc_func(_Target\x26\x26 __f) \x3a __f_(std\x3a\x3amove(__f)) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit __default_alloc_func(const _Target\x26 __f) \x3a __f_(__f) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _Rp operator()(_ArgTypes\x26\x26... __arg) {\x0a"
"    typedef __invoke_void_return_wrapper<_Rp> _Invoker;\x0a"
"    return _Invoker\x3a\x3a__call(__f_, _VSTD\x3a\x3a""forward<_ArgTypes>(__arg)...);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  __default_alloc_func* __clone() const {\x0a"
"      __builtin_new_allocator\x3a\x3a__holder_t __hold =\x0a"
"        __builtin_new_allocator\x3a\x3a__allocate_type<__default_alloc_func>(1);\x0a"
"    __default_alloc_func* __res =\x0a"
"        \x3a\x3anew (__hold.get()) __default_alloc_func(__f_);\x0a"
"    (void)__hold.release();\x0a"
"    return __res;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void destroy() _NOEXCEPT { __f_.\x7e_Target(); }\x0a"
"\x0a"
"  static void __destroy_and_delete(__default_alloc_func* __f) {\x0a"
"    __f->destroy();\x0a"
"      __builtin_new_allocator\x3a\x3a__deallocate_type<__default_alloc_func>(__f, 1);\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"// __base provides an abstract interface for copyable functors.\x0a"
"\x0a"
"template<class _Fp> class __base;\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"class __base<_Rp(_ArgTypes...)>\x0a"
"{\x0a"
"    __base(const __base\x26);\x0a"
"    __base\x26 operator=(const __base\x26);\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY __base() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY virtual \x7e__base() {}\x0a"
"    virtual __base* __clone() const = 0;\x0a"
"    virtual void __clone(__base*) const = 0;\x0a"
"    virtual void destroy() _NOEXCEPT = 0;\x0a"
"    virtual void destroy_deallocate() _NOEXCEPT = 0;\x0a"
"    virtual _Rp operator()(_ArgTypes\x26\x26 ...) = 0;\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"    virtual const void* target(const type_info\x26) const _NOEXCEPT = 0;\x0a"
"    virtual const std\x3a\x3atype_info\x26 target_type() const _NOEXCEPT = 0;\x0a"
"#endif  // _LIBCPP_NO_RTTI\x0a"
"};\x0a"
"\x0a"
"// __func implements __base for a given functor type.\x0a"
"\x0a"
"template<class _FD, class _Alloc, class _FB> class __func;\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"class __func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x0a"
"    \x3a public  __base<_Rp(_ArgTypes...)>\x0a"
"{\x0a"
"    __alloc_func<_Fp, _Alloc, _Rp(_ArgTypes...)> __f_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __func(_Fp\x26\x26 __f)\x0a"
"        \x3a __f_(_VSTD\x3a\x3amove(__f)) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __func(const _Fp\x26 __f, const _Alloc\x26 __a)\x0a"
"        \x3a __f_(__f, __a) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __func(const _Fp\x26 __f, _Alloc\x26\x26 __a)\x0a"
"        \x3a __f_(__f, _VSTD\x3a\x3amove(__a)) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __func(_Fp\x26\x26 __f, _Alloc\x26\x26 __a)\x0a"
"        \x3a __f_(_VSTD\x3a\x3amove(__f), _VSTD\x3a\x3amove(__a)) {}\x0a"
"\x0a"
"    virtual __base<_Rp(_ArgTypes...)>* __clone() const;\x0a"
"    virtual void __clone(__base<_Rp(_ArgTypes...)>*) const;\x0a"
"    virtual void destroy() _NOEXCEPT;\x0a"
"    virtual void destroy_deallocate() _NOEXCEPT;\x0a"
"    virtual _Rp operator()(_ArgTypes\x26\x26... __arg);\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"    virtual const void* target(const type_info\x26) const _NOEXCEPT;\x0a"
"    virtual const std\x3a\x3atype_info\x26 target_type() const _NOEXCEPT;\x0a"
"#endif  // _LIBCPP_NO_RTTI\x0a"
"};\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"__base<_Rp(_ArgTypes...)>*\x0a"
"__func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3a__clone() const\x0a"
"{\x0a"
"    typedef allocator_traits<_Alloc> __alloc_traits;\x0a"
"    typedef typename __rebind_alloc_helper<__alloc_traits, __func>\x3a\x3atype _Ap;\x0a"
"    _Ap __a(__f_.__get_allocator());\x0a"
"    typedef __allocator_destructor<_Ap> _Dp;\x0a"
"    unique_ptr<__func, _Dp> __hold(__a.allocate(1), _Dp(__a, 1));\x0a"
"    \x3a\x3anew ((void*)__hold.get()) __func(__f_.__target(), _Alloc(__a));\x0a"
"    return __hold.release();\x0a"
"}\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"__func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3a__clone(__base<_Rp(_ArgTypes...)>* __p) const\x0a"
"{\x0a"
"    \x3a\x3anew (__p) __func(__f_.__target(), __f_.__get_allocator());\x0a"
"}\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"__func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3a""destroy() _NOEXCEPT\x0a"
"{\x0a"
"    __f_.destroy();\x0a"
"}\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"__func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3a""destroy_deallocate() _NOEXCEPT\x0a"
"{\x0a"
"    typedef allocator_traits<_Alloc> __alloc_traits;\x0a"
"    typedef typename __rebind_alloc_helper<__alloc_traits, __func>\x3a\x3atype _Ap;\x0a"
"    _Ap __a(__f_.__get_allocator());\x0a"
"    __f_.destroy();\x0a"
"    __a.deallocate(this, 1);\x0a"
"}\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"_Rp\x0a"
"__func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3aoperator()(_ArgTypes\x26\x26 ... __arg)\x0a"
"{\x0a"
"    return __f_(_VSTD\x3a\x3a""forward<_ArgTypes>(__arg)...);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"const void*\x0a"
"__func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3atarget(const type_info\x26 __ti) const _NOEXCEPT\x0a"
"{\x0a"
"    if (__ti == typeid(_Fp))\x0a"
"        return \x26__f_.__target();\x0a"
"    return (const void*)0;\x0a"
"}\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"const std\x3a\x3atype_info\x26\x0a"
"__func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3atarget_type() const _NOEXCEPT\x0a"
"{\x0a"
"    return typeid(_Fp);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_NO_RTTI\x0a"
"\x0a"
"// __value_func creates a value-type from a __func.\x0a"
"\x0a"
"template <class _Fp> class __value_func;\x0a"
"\x0a"
"template <class _Rp, class... _ArgTypes> class __value_func<_Rp(_ArgTypes...)>\x0a"
"{\x0a"
"    typename aligned_storage<3 * sizeof(void*)>\x3a\x3atype __buf_;\x0a"
"\x0a"
"    typedef __base<_Rp(_ArgTypes...)> __func;\x0a"
"    __func* __f_;\x0a"
"\x0a"
"    _LIBCPP_NO_CFI static __func* __as_base(void* p)\x0a"
"    {\x0a"
"        return reinterpret_cast<__func*>(p);\x0a"
"    }\x0a"
"\x0a"
"  public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __value_func() _NOEXCEPT \x3a __f_(0) {}\x0a"
"\x0a"
"    template <class _Fp, class _Alloc>\x0a"
"    _LIBCPP_INLINE_VISIBILITY __value_func(_Fp\x26\x26 __f, const _Alloc\x26 __a)\x0a"
"        \x3a __f_(0)\x0a"
"    {\x0a"
"        typedef allocator_traits<_Alloc> __alloc_traits;\x0a"
"        typedef __function\x3a\x3a__func<_Fp, _Alloc, _Rp(_ArgTypes...)> _Fun;\x0a"
"        typedef typename __rebind_alloc_helper<__alloc_traits, _Fun>\x3a\x3atype\x0a"
"            _FunAlloc;\x0a"
"\x0a"
"        if (__function\x3a\x3a__not_null(__f))\x0a"
"        {\x0a"
"            _FunAlloc __af(__a);\x0a"
"            if (sizeof(_Fun) <= sizeof(__buf_) \x26\x26\x0a"
"                is_nothrow_copy_constructible<_Fp>\x3a\x3avalue \x26\x26\x0a"
"                is_nothrow_copy_constructible<_FunAlloc>\x3a\x3avalue)\x0a"
"            {\x0a"
"                __f_ =\x0a"
"                    \x3a\x3anew ((void*)\x26__buf_) _Fun(_VSTD\x3a\x3amove(__f), _Alloc(__af));\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                typedef __allocator_destructor<_FunAlloc> _Dp;\x0a"
"                unique_ptr<__func, _Dp> __hold(__af.allocate(1), _Dp(__af, 1));\x0a"
"                \x3a\x3anew ((void*)__hold.get()) _Fun(_VSTD\x3a\x3amove(__f), _Alloc(__a));\x0a"
"                __f_ = __hold.release();\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    template <class _Fp,\x0a"
"        class = typename enable_if<\x21is_same<typename decay<_Fp>\x3a\x3atype, __value_func>\x3a\x3avalue>\x3a\x3atype>\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit __value_func(_Fp\x26\x26 __f)\x0a"
"        \x3a __value_func(std\x3a\x3a""forward<_Fp>(__f), allocator<_Fp>()) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __value_func(const __value_func\x26 __f)\x0a"
"    {\x0a"
"        if (__f.__f_ == 0)\x0a"
"            __f_ = 0;\x0a"
"        else if ((void*)__f.__f_ == \x26__f.__buf_)\x0a"
"        {\x0a"
"            __f_ = __as_base(\x26__buf_);\x0a"
"            __f.__f_->__clone(__f_);\x0a"
"        }\x0a"
"        else\x0a"
"            __f_ = __f.__f_->__clone();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __value_func(__value_func\x26\x26 __f) _NOEXCEPT\x0a"
"    {\x0a"
"        if (__f.__f_ == 0)\x0a"
"            __f_ = 0;\x0a"
"        else if ((void*)__f.__f_ == \x26__f.__buf_)\x0a"
"        {\x0a"
"            __f_ = __as_base(\x26__buf_);\x0a"
"            __f.__f_->__clone(__f_);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __f_ = __f.__f_;\x0a"
"            __f.__f_ = 0;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e__value_func()\x0a"
"    {\x0a"
"        if ((void*)__f_ == \x26__buf_)\x0a"
"            __f_->destroy();\x0a"
"        else if (__f_)\x0a"
"            __f_->destroy_deallocate();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __value_func\x26 operator=(__value_func\x26\x26 __f)\x0a"
"    {\x0a"
"        *this = nullptr;\x0a"
"        if (__f.__f_ == 0)\x0a"
"            __f_ = 0;\x0a"
"        else if ((void*)__f.__f_ == \x26__f.__buf_)\x0a"
"        {\x0a"
"            __f_ = __as_base(\x26__buf_);\x0a"
"            __f.__f_->__clone(__f_);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __f_ = __f.__f_;\x0a"
"            __f.__f_ = 0;\x0a"
"        }\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __value_func\x26 operator=(nullptr_t)\x0a"
"    {\x0a"
"        __func* __f = __f_;\x0a"
"        __f_ = 0;\x0a"
"        if ((void*)__f == \x26__buf_)\x0a"
"            __f->destroy();\x0a"
"        else if (__f)\x0a"
"            __f->destroy_deallocate();\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Rp operator()(_ArgTypes\x26\x26... __args) const\x0a"
"    {\x0a"
"        if (__f_ == 0)\x0a"
"            __throw_bad_function_call();\x0a"
"        return (*__f_)(_VSTD\x3a\x3a""forward<_ArgTypes>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(__value_func\x26 __f) _NOEXCEPT\x0a"
"    {\x0a"
"        if (\x26__f == this)\x0a"
"            return;\x0a"
"        if ((void*)__f_ == \x26__buf_ \x26\x26 (void*)__f.__f_ == \x26__f.__buf_)\x0a"
"        {\x0a"
"            typename aligned_storage<sizeof(__buf_)>\x3a\x3atype __tempbuf;\x0a"
"            __func* __t = __as_base(\x26__tempbuf);\x0a"
"            __f_->__clone(__t);\x0a"
"            __f_->destroy();\x0a"
"            __f_ = 0;\x0a"
"            __f.__f_->__clone(__as_base(\x26__buf_));\x0a"
"            __f.__f_->destroy();\x0a"
"            __f.__f_ = 0;\x0a"
"            __f_ = __as_base(\x26__buf_);\x0a"
"            __t->__clone(__as_base(\x26__f.__buf_));\x0a"
"            __t->destroy();\x0a"
"            __f.__f_ = __as_base(\x26__f.__buf_);\x0a"
"        }\x0a"
"        else if ((void*)__f_ == \x26__buf_)\x0a"
"        {\x0a"
"            __f_->__clone(__as_base(\x26__f.__buf_));\x0a"
"            __f_->destroy();\x0a"
"            __f_ = __f.__f_;\x0a"
"            __f.__f_ = __as_base(\x26__f.__buf_);\x0a"
"        }\x0a"
"        else if ((void*)__f.__f_ == \x26__f.__buf_)\x0a"
"        {\x0a"
"            __f.__f_->__clone(__as_base(\x26__buf_));\x0a"
"            __f.__f_->destroy();\x0a"
"            __f.__f_ = __f_;\x0a"
"            __f_ = __as_base(\x26__buf_);\x0a"
"        }\x0a"
"        else\x0a"
"            _VSTD\x3a\x3aswap(__f_, __f.__f_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_EXPLICIT operator bool() const _NOEXCEPT { return __f_ \x21= 0; }\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const std\x3a\x3atype_info\x26 target_type() const _NOEXCEPT\x0a"
"    {\x0a"
"        if (__f_ == 0)\x0a"
"            return typeid(void);\x0a"
"        return __f_->target_type();\x0a"
"    }\x0a"
"\x0a"
"    template <typename _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY const _Tp* target() const _NOEXCEPT\x0a"
"    {\x0a"
"        if (__f_ == 0)\x0a"
"            return 0;\x0a"
"        return (const _Tp*)__f_->target(typeid(_Tp));\x0a"
"    }\x0a"
"#endif // _LIBCPP_NO_RTTI\x0a"
"};\x0a"
"\x0a"
"// Storage for a functor object, to be used with __policy to manage copy and\x0a"
"// destruction.\x0a"
"union __policy_storage\x0a"
"{\x0a"
"    mutable char __small\x5bsizeof(void*) * 2\x5d;\x0a"
"    void* __large;\x0a"
"};\x0a"
"\x0a"
"// True if _Fun can safely be held in __policy_storage.__small.\x0a"
"template <typename _Fun>\x0a"
"struct __use_small_storage\x0a"
"    \x3a public _VSTD\x3a\x3aintegral_constant<\x0a"
"          bool, sizeof(_Fun) <= sizeof(__policy_storage) \x26\x26\x0a"
"                    _LIBCPP_ALIGNOF(_Fun) <= _LIBCPP_ALIGNOF(__policy_storage) \x26\x26\x0a"
"                    _VSTD\x3a\x3ais_trivially_copy_constructible<_Fun>\x3a\x3avalue \x26\x26\x0a"
"                    _VSTD\x3a\x3ais_trivially_destructible<_Fun>\x3a\x3avalue> {};\x0a"
"\x0a"
"// Policy contains information about how to copy, destroy, and move the\x0a"
"// underlying functor. You can think of it as a vtable of sorts.\x0a"
"struct __policy\x0a"
"{\x0a"
"    // Used to copy or destroy __large values. null for trivial objects.\x0a"
"    void* (*const __clone)(const void*);\x0a"
"    void (*const __destroy)(void*);\x0a"
"\x0a"
"    // True if this is the null policy (no value).\x0a"
"    const bool __is_null;\x0a"
"\x0a"
"    // The target type. May be null if RTTI is disabled.\x0a"
"    const std\x3a\x3atype_info* const __type_info;\x0a"
"\x0a"
"    // Returns a pointer to a static policy object suitable for the functor\x0a"
"    // type.\x0a"
"    template <typename _Fun>\x0a"
"    _LIBCPP_INLINE_VISIBILITY static const __policy* __create()\x0a"
"    {\x0a"
"        return __choose_policy<_Fun>(__use_small_storage<_Fun>());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static const __policy* __create_empty()\x0a"
"    {\x0a"
"        static const _LIBCPP_CONSTEXPR __policy __policy_ = {nullptr, nullptr,\x0a"
"                                                             true,\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"                                                             \x26typeid(void)\x0a"
"#else\x0a"
"                                                             nullptr\x0a"
"#endif\x0a"
"        };\x0a"
"        return \x26__policy_;\x0a"
"    }\x0a"
"\x0a"
"  private\x3a\x0a"
"    template <typename _Fun> static void* __large_clone(const void* __s)\x0a"
"    {\x0a"
"        const _Fun* __f = static_cast<const _Fun*>(__s);\x0a"
"        return __f->__clone();\x0a"
"    }\x0a"
"\x0a"
"    template <typename _Fun>\x0a"
"    static void __large_destroy(void* __s) {\x0a"
"      _Fun\x3a\x3a__destroy_and_delete(static_cast<_Fun*>(__s));\x0a"
"    }\x0a"
"\x0a"
"    template <typename _Fun>\x0a"
"    _LIBCPP_INLINE_VISIBILITY static const __policy*\x0a"
"    __choose_policy(/* is_small = */ false_type) {\x0a"
"      static const _LIBCPP_CONSTEXPR __policy __policy_ = {\x0a"
"          \x26__large_clone<_Fun>, \x26__large_destroy<_Fun>, false,\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"          \x26typeid(typename _Fun\x3a\x3a_Target)\x0a"
"#else\x0a"
"          nullptr\x0a"
"#endif\x0a"
"      };\x0a"
"        return \x26__policy_;\x0a"
"    }\x0a"
"\x0a"
"    template <typename _Fun>\x0a"
"    _LIBCPP_INLINE_VISIBILITY static const __policy*\x0a"
"        __choose_policy(/* is_small = */ true_type)\x0a"
"    {\x0a"
"        static const _LIBCPP_CONSTEXPR __policy __policy_ = {\x0a"
"            nullptr, nullptr, false,\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"            \x26typeid(typename _Fun\x3a\x3a_Target)\x0a"
"#else\x0a"
"            nullptr\x0a"
"#endif\x0a"
"        };\x0a"
"        return \x26__policy_;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"// Used to choose between perfect forwarding or pass-by-value. Pass-by-value is\x0a"
"// faster for types that can be passed in registers.\x0a"
"template <typename _Tp>\x0a"
"using __fast_forward =\x0a"
"    typename _VSTD\x3a\x3a""conditional<_VSTD\x3a\x3ais_scalar<_Tp>\x3a\x3avalue, _Tp, _Tp\x26\x26>\x3a\x3atype;\x0a"
"\x0a"
"// __policy_invoker calls an instance of __alloc_func held in __policy_storage.\x0a"
"\x0a"
"template <class _Fp> struct __policy_invoker;\x0a"
"\x0a"
"template <class _Rp, class... _ArgTypes>\x0a"
"struct __policy_invoker<_Rp(_ArgTypes...)>\x0a"
"{\x0a"
"    typedef _Rp (*__Call)(const __policy_storage*,\x0a"
"                          __fast_forward<_ArgTypes>...);\x0a"
"\x0a"
"    __Call __call_;\x0a"
"\x0a"
"    // Creates an invoker that throws bad_function_call.\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __policy_invoker() \x3a __call_(\x26__call_empty) {}\x0a"
"\x0a"
"    // Creates an invoker that calls the given instance of __func.\x0a"
"    template <typename _Fun>\x0a"
"    _LIBCPP_INLINE_VISIBILITY static __policy_invoker __create()\x0a"
"    {\x0a"
"        return __policy_invoker(\x26__call_impl<_Fun>);\x0a"
"    }\x0a"
"\x0a"
"  private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __policy_invoker(__Call __c) \x3a __call_(__c) {}\x0a"
"\x0a"
"    static _Rp __call_empty(const __policy_storage*,\x0a"
"                            __fast_forward<_ArgTypes>...)\x0a"
"    {\x0a"
"        __throw_bad_function_call();\x0a"
"    }\x0a"
"\x0a"
"    template <typename _Fun>\x0a"
"    static _Rp __call_impl(const __policy_storage* __buf,\x0a"
"                           __fast_forward<_ArgTypes>... __args)\x0a"
"    {\x0a"
"        _Fun* __f = reinterpret_cast<_Fun*>(__use_small_storage<_Fun>\x3a\x3avalue\x0a"
"                                                \x3f \x26__buf->__small\x0a"
"                                                \x3a __buf->__large);\x0a"
"        return (*__f)(_VSTD\x3a\x3a""forward<_ArgTypes>(__args)...);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"// __policy_func uses a __policy and __policy_invoker to create a type-erased,\x0a"
"// copyable functor.\x0a"
"\x0a"
"template <class _Fp> class __policy_func;\x0a"
"\x0a"
"template <class _Rp, class... _ArgTypes> class __policy_func<_Rp(_ArgTypes...)>\x0a"
"{\x0a"
"    // Inline storage for small objects.\x0a"
"    __policy_storage __buf_;\x0a"
"\x0a"
"    // Calls the value stored in __buf_. This could technically be part of\x0a"
"    // policy, but storing it here eliminates a level of indirection inside\x0a"
"    // operator().\x0a"
"    typedef __function\x3a\x3a__policy_invoker<_Rp(_ArgTypes...)> __invoker;\x0a"
"    __invoker __invoker_;\x0a"
"\x0a"
"    // The policy that describes how to move / copy / destroy __buf_. Never\x0a"
"    // null, even if the function is empty.\x0a"
"    const __policy* __policy_;\x0a"
"\x0a"
"  public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __policy_func() \x3a __policy_(__policy\x3a\x3a__create_empty()) {}\x0a"
"\x0a"
"    template <class _Fp, class _Alloc>\x0a"
"    _LIBCPP_INLINE_VISIBILITY __policy_func(_Fp\x26\x26 __f, const _Alloc\x26 __a)\x0a"
"        \x3a __policy_(__policy\x3a\x3a__create_empty())\x0a"
"    {\x0a"
"        typedef __alloc_func<_Fp, _Alloc, _Rp(_ArgTypes...)> _Fun;\x0a"
"        typedef allocator_traits<_Alloc> __alloc_traits;\x0a"
"        typedef typename __rebind_alloc_helper<__alloc_traits, _Fun>\x3a\x3atype\x0a"
"            _FunAlloc;\x0a"
"\x0a"
"        if (__function\x3a\x3a__not_null(__f))\x0a"
"        {\x0a"
"            __invoker_ = __invoker\x3a\x3atemplate __create<_Fun>();\x0a"
"            __policy_ = __policy\x3a\x3a__create<_Fun>();\x0a"
"\x0a"
"            _FunAlloc __af(__a);\x0a"
"            if (__use_small_storage<_Fun>())\x0a"
"            {\x0a"
"                \x3a\x3anew ((void*)\x26__buf_.__small)\x0a"
"                    _Fun(_VSTD\x3a\x3amove(__f), _Alloc(__af));\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                typedef __allocator_destructor<_FunAlloc> _Dp;\x0a"
"                unique_ptr<_Fun, _Dp> __hold(__af.allocate(1), _Dp(__af, 1));\x0a"
"                \x3a\x3anew ((void*)__hold.get())\x0a"
"                    _Fun(_VSTD\x3a\x3amove(__f), _Alloc(__af));\x0a"
"                __buf_.__large = __hold.release();\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    template <class _Fp, class = typename enable_if<\x21is_same<typename decay<_Fp>\x3a\x3atype, __policy_func>\x3a\x3avalue>\x3a\x3atype>\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit __policy_func(_Fp\x26\x26 __f)\x0a"
"        \x3a __policy_(__policy\x3a\x3a__create_empty()) {\x0a"
"      typedef __default_alloc_func<_Fp, _Rp(_ArgTypes...)> _Fun;\x0a"
"\x0a"
"      if (__function\x3a\x3a__not_null(__f)) {\x0a"
"        __invoker_ = __invoker\x3a\x3atemplate __create<_Fun>();\x0a"
"        __policy_ = __policy\x3a\x3a__create<_Fun>();\x0a"
"        if (__use_small_storage<_Fun>()) {\x0a"
"          \x3a\x3anew ((void*)\x26__buf_.__small) _Fun(_VSTD\x3a\x3amove(__f));\x0a"
"        } else {\x0a"
"          __builtin_new_allocator\x3a\x3a__holder_t __hold =\x0a"
"              __builtin_new_allocator\x3a\x3a__allocate_type<_Fun>(1);\x0a"
"          __buf_.__large = \x3a\x3anew (__hold.get()) _Fun(_VSTD\x3a\x3amove(__f));\x0a"
"          (void)__hold.release();\x0a"
"        }\x0a"
"      }\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __policy_func(const __policy_func\x26 __f)\x0a"
"        \x3a __buf_(__f.__buf_), __invoker_(__f.__invoker_),\x0a"
"          __policy_(__f.__policy_)\x0a"
"    {\x0a"
"        if (__policy_->__clone)\x0a"
"            __buf_.__large = __policy_->__clone(__f.__buf_.__large);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __policy_func(__policy_func\x26\x26 __f)\x0a"
"        \x3a __buf_(__f.__buf_), __invoker_(__f.__invoker_),\x0a"
"          __policy_(__f.__policy_)\x0a"
"    {\x0a"
"        if (__policy_->__destroy)\x0a"
"        {\x0a"
"            __f.__policy_ = __policy\x3a\x3a__create_empty();\x0a"
"            __f.__invoker_ = __invoker();\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e__policy_func()\x0a"
"    {\x0a"
"        if (__policy_->__destroy)\x0a"
"            __policy_->__destroy(__buf_.__large);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __policy_func\x26 operator=(__policy_func\x26\x26 __f)\x0a"
"    {\x0a"
"        *this = nullptr;\x0a"
"        __buf_ = __f.__buf_;\x0a"
"        __invoker_ = __f.__invoker_;\x0a"
"        __policy_ = __f.__policy_;\x0a"
"        __f.__policy_ = __policy\x3a\x3a__create_empty();\x0a"
"        __f.__invoker_ = __invoker();\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __policy_func\x26 operator=(nullptr_t)\x0a"
"    {\x0a"
"        const __policy* __p = __policy_;\x0a"
"        __policy_ = __policy\x3a\x3a__create_empty();\x0a"
"        __invoker_ = __invoker();\x0a"
"        if (__p->__destroy)\x0a"
"            __p->__destroy(__buf_.__large);\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Rp operator()(_ArgTypes\x26\x26... __args) const\x0a"
"    {\x0a"
"        return __invoker_.__call_(_VSTD\x3a\x3a""addressof(__buf_),\x0a"
"                                  _VSTD\x3a\x3a""forward<_ArgTypes>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(__policy_func\x26 __f)\x0a"
"    {\x0a"
"        _VSTD\x3a\x3aswap(__invoker_, __f.__invoker_);\x0a"
"        _VSTD\x3a\x3aswap(__policy_, __f.__policy_);\x0a"
"        _VSTD\x3a\x3aswap(__buf_, __f.__buf_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit operator bool() const _NOEXCEPT\x0a"
"    {\x0a"
"        return \x21__policy_->__is_null;\x0a"
"    }\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const std\x3a\x3atype_info\x26 target_type() const _NOEXCEPT\x0a"
"    {\x0a"
"        return *__policy_->__type_info;\x0a"
"    }\x0a"
"\x0a"
"    template <typename _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY const _Tp* target() const _NOEXCEPT\x0a"
"    {\x0a"
"        if (__policy_->__is_null \x7c\x7c typeid(_Tp) \x21= *__policy_->__type_info)\x0a"
"            return nullptr;\x0a"
"        if (__policy_->__clone) // Out of line storage.\x0a"
"            return reinterpret_cast<const _Tp*>(__buf_.__large);\x0a"
"        else\x0a"
"            return reinterpret_cast<const _Tp*>(\x26__buf_.__small);\x0a"
"    }\x0a"
"#endif // _LIBCPP_NO_RTTI\x0a"
"};\x0a"
"\x0a"
"}  // __function\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"class _LIBCPP_TEMPLATE_VIS function<_Rp(_ArgTypes...)>\x0a"
"    \x3a public __function\x3a\x3a__maybe_derive_from_unary_function<_Rp(_ArgTypes...)>,\x0a"
"      public __function\x3a\x3a__maybe_derive_from_binary_function<_Rp(_ArgTypes...)>\x0a"
"{\x0a"
"#ifndef _LIBCPP_ABI_OPTIMIZED_FUNCTION\x0a"
"    typedef __function\x3a\x3a__value_func<_Rp(_ArgTypes...)> __func;\x0a"
"#else\x0a"
"    typedef __function\x3a\x3a__policy_func<_Rp(_ArgTypes...)> __func;\x0a"
"#endif\x0a"
"\x0a"
"    __func __f_;\x0a"
"\x0a"
"    template <class _Fp, bool = _And<\x0a"
"        _IsNotSame<__uncvref_t<_Fp>, function>,\x0a"
"        __invokable<_Fp\x26, _ArgTypes...>\x0a"
"    >\x3a\x3avalue>\x0a"
"    struct __callable;\x0a"
"    template <class _Fp>\x0a"
"        struct __callable<_Fp, true>\x0a"
"        {\x0a"
"            static const bool value = is_same<void, _Rp>\x3a\x3avalue \x7c\x7c\x0a"
"                is_convertible<typename __invoke_of<_Fp\x26, _ArgTypes...>\x3a\x3atype,\x0a"
"                               _Rp>\x3a\x3avalue;\x0a"
"        };\x0a"
"    template <class _Fp>\x0a"
"        struct __callable<_Fp, false>\x0a"
"        {\x0a"
"            static const bool value = false;\x0a"
"        };\x0a"
"\x0a"
"  template <class _Fp>\x0a"
"  using _EnableIfCallable = typename enable_if<__callable<_Fp>\x3a\x3avalue>\x3a\x3atype;\x0a"
"public\x3a\x0a"
"    typedef _Rp result_type;\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    function() _NOEXCEPT { }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    function(nullptr_t) _NOEXCEPT {}\x0a"
"    function(const function\x26);\x0a"
"    function(function\x26\x26) _NOEXCEPT;\x0a"
"    template<class _Fp, class = _EnableIfCallable<_Fp>>\x0a"
"    function(_Fp);\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"    template<class _Alloc>\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      function(allocator_arg_t, const _Alloc\x26) _NOEXCEPT {}\x0a"
"    template<class _Alloc>\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      function(allocator_arg_t, const _Alloc\x26, nullptr_t) _NOEXCEPT {}\x0a"
"    template<class _Alloc>\x0a"
"      function(allocator_arg_t, const _Alloc\x26, const function\x26);\x0a"
"    template<class _Alloc>\x0a"
"      function(allocator_arg_t, const _Alloc\x26, function\x26\x26);\x0a"
"    template<class _Fp, class _Alloc, class = _EnableIfCallable<_Fp>>\x0a"
"      function(allocator_arg_t, const _Alloc\x26 __a, _Fp __f);\x0a"
"#endif\x0a"
"\x0a"
"    function\x26 operator=(const function\x26);\x0a"
"    function\x26 operator=(function\x26\x26) _NOEXCEPT;\x0a"
"    function\x26 operator=(nullptr_t) _NOEXCEPT;\x0a"
"    template<class _Fp, class = _EnableIfCallable<_Fp>>\x0a"
"    function\x26 operator=(_Fp\x26\x26);\x0a"
"\x0a"
"    \x7e""function();\x0a"
"\x0a"
"    // function modifiers\x3a\x0a"
"    void swap(function\x26) _NOEXCEPT;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"    template<class _Fp, class _Alloc>\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      void assign(_Fp\x26\x26 __f, const _Alloc\x26 __a)\x0a"
"        {function(allocator_arg, __a, _VSTD\x3a\x3a""forward<_Fp>(__f)).swap(*this);}\x0a"
"#endif\x0a"
"\x0a"
"    // function capacity\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_EXPLICIT operator bool() const _NOEXCEPT {\x0a"
"      return static_cast<bool>(__f_);\x0a"
"    }\x0a"
"\x0a"
"    // deleted overloads close possible hole in the type system\x0a"
"    template<class _R2, class... _ArgTypes2>\x0a"
"      bool operator==(const function<_R2(_ArgTypes2...)>\x26) const = delete;\x0a"
"    template<class _R2, class... _ArgTypes2>\x0a"
"      bool operator\x21=(const function<_R2(_ArgTypes2...)>\x26) const = delete;\x0a"
"public\x3a\x0a"
"    // function invocation\x3a\x0a"
"    _Rp operator()(_ArgTypes...) const;\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"    // function target access\x3a\x0a"
"    const std\x3a\x3atype_info\x26 target_type() const _NOEXCEPT;\x0a"
"    template <typename _Tp> _Tp* target() _NOEXCEPT;\x0a"
"    template <typename _Tp> const _Tp* target() const _NOEXCEPT;\x0a"
"#endif  // _LIBCPP_NO_RTTI\x0a"
"};\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3a""function(const function\x26 __f) \x3a __f_(__f.__f_) {}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"template <class _Alloc>\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3a""function(allocator_arg_t, const _Alloc\x26,\x0a"
"                                     const function\x26 __f) \x3a __f_(__f.__f_) {}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Rp, class... _ArgTypes>\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3a""function(function\x26\x26 __f) _NOEXCEPT\x0a"
"    \x3a __f_(_VSTD\x3a\x3amove(__f.__f_)) {}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"template <class _Alloc>\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3a""function(allocator_arg_t, const _Alloc\x26,\x0a"
"                                      function\x26\x26 __f)\x0a"
"    \x3a __f_(_VSTD\x3a\x3amove(__f.__f_)) {}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Rp, class... _ArgTypes>\x0a"
"template <class _Fp, class>\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3a""function(_Fp __f) \x3a __f_(_VSTD\x3a\x3amove(__f)) {}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"template <class _Rp, class... _ArgTypes>\x0a"
"template <class _Fp, class _Alloc, class>\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3a""function(allocator_arg_t, const _Alloc\x26 __a,\x0a"
"                                      _Fp __f)\x0a"
"    \x3a __f_(_VSTD\x3a\x3amove(__f), __a) {}\x0a"
"#endif\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"function<_Rp(_ArgTypes...)>\x26\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3aoperator=(const function\x26 __f)\x0a"
"{\x0a"
"    function(__f).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"function<_Rp(_ArgTypes...)>\x26\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3aoperator=(function\x26\x26 __f) _NOEXCEPT\x0a"
"{\x0a"
"    __f_ = std\x3a\x3amove(__f.__f_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"function<_Rp(_ArgTypes...)>\x26\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3aoperator=(nullptr_t) _NOEXCEPT\x0a"
"{\x0a"
"    __f_ = nullptr;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"template <class _Fp, class>\x0a"
"function<_Rp(_ArgTypes...)>\x26\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3aoperator=(_Fp\x26\x26 __f)\x0a"
"{\x0a"
"    function(_VSTD\x3a\x3a""forward<_Fp>(__f)).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3a\x7e""function() {}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3aswap(function\x26 __f) _NOEXCEPT\x0a"
"{\x0a"
"    __f_.swap(__f.__f_);\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"_Rp\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3aoperator()(_ArgTypes... __arg) const\x0a"
"{\x0a"
"    return __f_(_VSTD\x3a\x3a""forward<_ArgTypes>(__arg)...);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"const std\x3a\x3atype_info\x26\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3atarget_type() const _NOEXCEPT\x0a"
"{\x0a"
"    return __f_.target_type();\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"template <typename _Tp>\x0a"
"_Tp*\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3atarget() _NOEXCEPT\x0a"
"{\x0a"
"    return (_Tp*)(__f_.template target<_Tp>());\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"template <typename _Tp>\x0a"
"const _Tp*\x0a"
"function<_Rp(_ArgTypes...)>\x3a\x3atarget() const _NOEXCEPT\x0a"
"{\x0a"
"    return __f_.template target<_Tp>();\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_NO_RTTI\x0a"
"\x0a"
"template <class _Rp, class... _ArgTypes>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const function<_Rp(_ArgTypes...)>\x26 __f, nullptr_t) _NOEXCEPT {return \x21__f;}\x0a"
"\x0a"
"template <class _Rp, class... _ArgTypes>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(nullptr_t, const function<_Rp(_ArgTypes...)>\x26 __f) _NOEXCEPT {return \x21__f;}\x0a"
"\x0a"
"template <class _Rp, class... _ArgTypes>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const function<_Rp(_ArgTypes...)>\x26 __f, nullptr_t) _NOEXCEPT {return (bool)__f;}\x0a"
"\x0a"
"template <class _Rp, class... _ArgTypes>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(nullptr_t, const function<_Rp(_ArgTypes...)>\x26 __f) _NOEXCEPT {return (bool)__f;}\x0a"
"\x0a"
"template <class _Rp, class... _ArgTypes>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(function<_Rp(_ArgTypes...)>\x26 __x, function<_Rp(_ArgTypes...)>\x26 __y) _NOEXCEPT\x0a"
"{return __x.swap(__y);}\x0a"
"\x0a"
"#else // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#include <__functional_03>\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"////////////////////////////////////////////////////////////////////////////////\x0a"
"//                                  BIND\x0a"
"//==============================================================================\x0a"
"\x0a"
"template<class _Tp> struct __is_bind_expression \x3a public false_type {};\x0a"
"template<class _Tp> struct _LIBCPP_TEMPLATE_VIS is_bind_expression\x0a"
"    \x3a public __is_bind_expression<typename remove_cv<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr size_t is_bind_expression_v = is_bind_expression<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"template<class _Tp> struct __is_placeholder \x3a public integral_constant<int, 0> {};\x0a"
"template<class _Tp> struct _LIBCPP_TEMPLATE_VIS is_placeholder\x0a"
"    \x3a public __is_placeholder<typename remove_cv<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr size_t is_placeholder_v = is_placeholder<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"namespace placeholders\x0a"
"{\x0a"
"\x0a"
"template <int _Np> struct __ph {};\x0a"
"\x0a"
"#if defined(_LIBCPP_CXX03_LANG) \x7c\x7c defined(_LIBCPP_BUILDING_LIBRARY)\x0a"
"_LIBCPP_FUNC_VIS extern const __ph<1>   _1;\x0a"
"_LIBCPP_FUNC_VIS extern const __ph<2>   _2;\x0a"
"_LIBCPP_FUNC_VIS extern const __ph<3>   _3;\x0a"
"_LIBCPP_FUNC_VIS extern const __ph<4>   _4;\x0a"
"_LIBCPP_FUNC_VIS extern const __ph<5>   _5;\x0a"
"_LIBCPP_FUNC_VIS extern const __ph<6>   _6;\x0a"
"_LIBCPP_FUNC_VIS extern const __ph<7>   _7;\x0a"
"_LIBCPP_FUNC_VIS extern const __ph<8>   _8;\x0a"
"_LIBCPP_FUNC_VIS extern const __ph<9>   _9;\x0a"
"_LIBCPP_FUNC_VIS extern const __ph<10> _10;\x0a"
"#else\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr __ph<1>   _1{};\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr __ph<2>   _2{};\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr __ph<3>   _3{};\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr __ph<4>   _4{};\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr __ph<5>   _5{};\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr __ph<6>   _6{};\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr __ph<7>   _7{};\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr __ph<8>   _8{};\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr __ph<9>   _9{};\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr __ph<10> _10{};\x0a"
"#endif // defined(_LIBCPP_CXX03_LANG) \x7c\x7c defined(_LIBCPP_BUILDING_LIBRARY)\x0a"
"\x0a"
"}  // placeholders\x0a"
"\x0a"
"template<int _Np>\x0a"
"struct __is_placeholder<placeholders\x3a\x3a__ph<_Np> >\x0a"
"    \x3a public integral_constant<int, _Np> {};\x0a"
"\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Uj>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x26\x0a"
"__mu(reference_wrapper<_Tp> __t, _Uj\x26)\x0a"
"{\x0a"
"    return __t.get();\x0a"
"}\x0a"
"\x0a"
"template <class _Ti, class ..._Uj, size_t ..._Indx>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename __invoke_of<_Ti\x26, _Uj...>\x3a\x3atype\x0a"
"__mu_expand(_Ti\x26 __ti, tuple<_Uj...>\x26 __uj, __tuple_indices<_Indx...>)\x0a"
"{\x0a"
"    return __ti(_VSTD\x3a\x3a""forward<_Uj>(_VSTD\x3a\x3aget<_Indx>(__uj))...);\x0a"
"}\x0a"
"\x0a"
"template <class _Ti, class ..._Uj>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename _EnableIf\x0a"
"<\x0a"
"    is_bind_expression<_Ti>\x3a\x3avalue,\x0a"
"    __invoke_of<_Ti\x26, _Uj...>\x0a"
">\x3a\x3atype\x0a"
"__mu(_Ti\x26 __ti, tuple<_Uj...>\x26 __uj)\x0a"
"{\x0a"
"    typedef typename __make_tuple_indices<sizeof...(_Uj)>\x3a\x3atype __indices;\x0a"
"    return  __mu_expand(__ti, __uj, __indices());\x0a"
"}\x0a"
"\x0a"
"template <bool IsPh, class _Ti, class _Uj>\x0a"
"struct __mu_return2 {};\x0a"
"\x0a"
"template <class _Ti, class _Uj>\x0a"
"struct __mu_return2<true, _Ti, _Uj>\x0a"
"{\x0a"
"    typedef typename tuple_element<is_placeholder<_Ti>\x3a\x3avalue - 1, _Uj>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Ti, class _Uj>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    0 < is_placeholder<_Ti>\x3a\x3avalue,\x0a"
"    typename __mu_return2<0 < is_placeholder<_Ti>\x3a\x3avalue, _Ti, _Uj>\x3a\x3atype\x0a"
">\x3a\x3atype\x0a"
"__mu(_Ti\x26, _Uj\x26 __uj)\x0a"
"{\x0a"
"    const size_t _Indx = is_placeholder<_Ti>\x3a\x3avalue - 1;\x0a"
"    return _VSTD\x3a\x3a""forward<typename tuple_element<_Indx, _Uj>\x3a\x3atype>(_VSTD\x3a\x3aget<_Indx>(__uj));\x0a"
"}\x0a"
"\x0a"
"template <class _Ti, class _Uj>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_bind_expression<_Ti>\x3a\x3avalue \x26\x26\x0a"
"    is_placeholder<_Ti>\x3a\x3avalue == 0 \x26\x26\x0a"
"    \x21__is_reference_wrapper<_Ti>\x3a\x3avalue,\x0a"
"    _Ti\x26\x0a"
">\x3a\x3atype\x0a"
"__mu(_Ti\x26 __ti, _Uj\x26)\x0a"
"{\x0a"
"    return __ti;\x0a"
"}\x0a"
"\x0a"
"template <class _Ti, bool IsReferenceWrapper, bool IsBindEx, bool IsPh,\x0a"
"          class _TupleUj>\x0a"
"struct __mu_return_impl;\x0a"
"\x0a"
"template <bool _Invokable, class _Ti, class ..._Uj>\x0a"
"struct __mu_return_invokable  // false\x0a"
"{\x0a"
"    typedef __nat type;\x0a"
"};\x0a"
"\x0a"
"template <class _Ti, class ..._Uj>\x0a"
"struct __mu_return_invokable<true, _Ti, _Uj...>\x0a"
"{\x0a"
"    typedef typename __invoke_of<_Ti\x26, _Uj...>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Ti, class ..._Uj>\x0a"
"struct __mu_return_impl<_Ti, false, true, false, tuple<_Uj...> >\x0a"
"    \x3a public __mu_return_invokable<__invokable<_Ti\x26, _Uj...>\x3a\x3avalue, _Ti, _Uj...>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Ti, class _TupleUj>\x0a"
"struct __mu_return_impl<_Ti, false, false, true, _TupleUj>\x0a"
"{\x0a"
"    typedef typename tuple_element<is_placeholder<_Ti>\x3a\x3avalue - 1,\x0a"
"                                   _TupleUj>\x3a\x3atype\x26\x26 type;\x0a"
"};\x0a"
"\x0a"
"template <class _Ti, class _TupleUj>\x0a"
"struct __mu_return_impl<_Ti, true, false, false, _TupleUj>\x0a"
"{\x0a"
"    typedef typename _Ti\x3a\x3atype\x26 type;\x0a"
"};\x0a"
"\x0a"
"template <class _Ti, class _TupleUj>\x0a"
"struct __mu_return_impl<_Ti, false, false, false, _TupleUj>\x0a"
"{\x0a"
"    typedef _Ti\x26 type;\x0a"
"};\x0a"
"\x0a"
"template <class _Ti, class _TupleUj>\x0a"
"struct __mu_return\x0a"
"    \x3a public __mu_return_impl<_Ti,\x0a"
"                              __is_reference_wrapper<_Ti>\x3a\x3avalue,\x0a"
"                              is_bind_expression<_Ti>\x3a\x3avalue,\x0a"
"                              0 < is_placeholder<_Ti>\x3a\x3avalue \x26\x26\x0a"
"                              is_placeholder<_Ti>\x3a\x3avalue <= tuple_size<_TupleUj>\x3a\x3avalue,\x0a"
"                              _TupleUj>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Fp, class _BoundArgs, class _TupleUj>\x0a"
"struct __is_valid_bind_return\x0a"
"{\x0a"
"    static const bool value = false;\x0a"
"};\x0a"
"\x0a"
"template <class _Fp, class ..._BoundArgs, class _TupleUj>\x0a"
"struct __is_valid_bind_return<_Fp, tuple<_BoundArgs...>, _TupleUj>\x0a"
"{\x0a"
"    static const bool value = __invokable<_Fp,\x0a"
"                    typename __mu_return<_BoundArgs, _TupleUj>\x3a\x3atype...>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _Fp, class ..._BoundArgs, class _TupleUj>\x0a"
"struct __is_valid_bind_return<_Fp, const tuple<_BoundArgs...>, _TupleUj>\x0a"
"{\x0a"
"    static const bool value = __invokable<_Fp,\x0a"
"                    typename __mu_return<const _BoundArgs, _TupleUj>\x3a\x3atype...>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _Fp, class _BoundArgs, class _TupleUj,\x0a"
"          bool = __is_valid_bind_return<_Fp, _BoundArgs, _TupleUj>\x3a\x3avalue>\x0a"
"struct __bind_return;\x0a"
"\x0a"
"template <class _Fp, class ..._BoundArgs, class _TupleUj>\x0a"
"struct __bind_return<_Fp, tuple<_BoundArgs...>, _TupleUj, true>\x0a"
"{\x0a"
"    typedef typename __invoke_of\x0a"
"    <\x0a"
"        _Fp\x26,\x0a"
"        typename __mu_return\x0a"
"        <\x0a"
"            _BoundArgs,\x0a"
"            _TupleUj\x0a"
"        >\x3a\x3atype...\x0a"
"    >\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Fp, class ..._BoundArgs, class _TupleUj>\x0a"
"struct __bind_return<_Fp, const tuple<_BoundArgs...>, _TupleUj, true>\x0a"
"{\x0a"
"    typedef typename __invoke_of\x0a"
"    <\x0a"
"        _Fp\x26,\x0a"
"        typename __mu_return\x0a"
"        <\x0a"
"            const _BoundArgs,\x0a"
"            _TupleUj\x0a"
"        >\x3a\x3atype...\x0a"
"    >\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Fp, class _BoundArgs, size_t ..._Indx, class _Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename __bind_return<_Fp, _BoundArgs, _Args>\x3a\x3atype\x0a"
"__apply_functor(_Fp\x26 __f, _BoundArgs\x26 __bound_args, __tuple_indices<_Indx...>,\x0a"
"                _Args\x26\x26 __args)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__invoke(__f, _VSTD\x3a\x3a__mu(_VSTD\x3a\x3aget<_Indx>(__bound_args), __args)...);\x0a"
"}\x0a"
"\x0a"
"template<class _Fp, class ..._BoundArgs>\x0a"
"class __bind\x0a"
"    \x3a public __weak_result_type<typename decay<_Fp>\x3a\x3atype>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    typedef typename decay<_Fp>\x3a\x3atype _Fd;\x0a"
"    typedef tuple<typename decay<_BoundArgs>\x3a\x3atype...> _Td;\x0a"
"private\x3a\x0a"
"    _Fd __f_;\x0a"
"    _Td __bound_args_;\x0a"
"\x0a"
"    typedef typename __make_tuple_indices<sizeof...(_BoundArgs)>\x3a\x3atype __indices;\x0a"
"public\x3a\x0a"
"    template <class _Gp, class ..._BA,\x0a"
"              class = typename enable_if\x0a"
"                               <\x0a"
"                                  is_constructible<_Fd, _Gp>\x3a\x3avalue \x26\x26\x0a"
"                                  \x21is_same<typename remove_reference<_Gp>\x3a\x3atype,\x0a"
"                                           __bind>\x3a\x3avalue\x0a"
"                               >\x3a\x3atype>\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      explicit __bind(_Gp\x26\x26 __f, _BA\x26\x26 ...__bound_args)\x0a"
"        \x3a __f_(_VSTD\x3a\x3a""forward<_Gp>(__f)),\x0a"
"          __bound_args_(_VSTD\x3a\x3a""forward<_BA>(__bound_args)...) {}\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename __bind_return<_Fd, _Td, tuple<_Args\x26\x26...> >\x3a\x3atype\x0a"
"        operator()(_Args\x26\x26 ...__args)\x0a"
"        {\x0a"
"            return _VSTD\x3a\x3a__apply_functor(__f_, __bound_args_, __indices(),\x0a"
"                                  tuple<_Args\x26\x26...>(_VSTD\x3a\x3a""forward<_Args>(__args)...));\x0a"
"        }\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename __bind_return<const _Fd, const _Td, tuple<_Args\x26\x26...> >\x3a\x3atype\x0a"
"        operator()(_Args\x26\x26 ...__args) const\x0a"
"        {\x0a"
"            return _VSTD\x3a\x3a__apply_functor(__f_, __bound_args_, __indices(),\x0a"
"                                   tuple<_Args\x26\x26...>(_VSTD\x3a\x3a""forward<_Args>(__args)...));\x0a"
"        }\x0a"
"};\x0a"
"\x0a"
"template<class _Fp, class ..._BoundArgs>\x0a"
"struct __is_bind_expression<__bind<_Fp, _BoundArgs...> > \x3a public true_type {};\x0a"
"\x0a"
"template<class _Rp, class _Fp, class ..._BoundArgs>\x0a"
"class __bind_r\x0a"
"    \x3a public __bind<_Fp, _BoundArgs...>\x0a"
"{\x0a"
"    typedef __bind<_Fp, _BoundArgs...> base;\x0a"
"    typedef typename base\x3a\x3a_Fd _Fd;\x0a"
"    typedef typename base\x3a\x3a_Td _Td;\x0a"
"public\x3a\x0a"
"    typedef _Rp result_type;\x0a"
"\x0a"
"\x0a"
"    template <class _Gp, class ..._BA,\x0a"
"              class = typename enable_if\x0a"
"                               <\x0a"
"                                  is_constructible<_Fd, _Gp>\x3a\x3avalue \x26\x26\x0a"
"                                  \x21is_same<typename remove_reference<_Gp>\x3a\x3atype,\x0a"
"                                           __bind_r>\x3a\x3avalue\x0a"
"                               >\x3a\x3atype>\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      explicit __bind_r(_Gp\x26\x26 __f, _BA\x26\x26 ...__bound_args)\x0a"
"        \x3a base(_VSTD\x3a\x3a""forward<_Gp>(__f),\x0a"
"               _VSTD\x3a\x3a""forward<_BA>(__bound_args)...) {}\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<typename __bind_return<_Fd, _Td, tuple<_Args\x26\x26...> >\x3a\x3atype,\x0a"
"                           result_type>\x3a\x3avalue \x7c\x7c is_void<_Rp>\x3a\x3avalue,\x0a"
"            result_type\x0a"
"        >\x3a\x3atype\x0a"
"        operator()(_Args\x26\x26 ...__args)\x0a"
"        {\x0a"
"            typedef __invoke_void_return_wrapper<_Rp> _Invoker;\x0a"
"            return _Invoker\x3a\x3a__call(static_cast<base\x26>(*this), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        }\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<typename __bind_return<const _Fd, const _Td, tuple<_Args\x26\x26...> >\x3a\x3atype,\x0a"
"                           result_type>\x3a\x3avalue \x7c\x7c is_void<_Rp>\x3a\x3avalue,\x0a"
"            result_type\x0a"
"        >\x3a\x3atype\x0a"
"        operator()(_Args\x26\x26 ...__args) const\x0a"
"        {\x0a"
"            typedef __invoke_void_return_wrapper<_Rp> _Invoker;\x0a"
"            return _Invoker\x3a\x3a__call(static_cast<base const\x26>(*this), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        }\x0a"
"};\x0a"
"\x0a"
"template<class _Rp, class _Fp, class ..._BoundArgs>\x0a"
"struct __is_bind_expression<__bind_r<_Rp, _Fp, _BoundArgs...> > \x3a public true_type {};\x0a"
"\x0a"
"template<class _Fp, class ..._BoundArgs>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__bind<_Fp, _BoundArgs...>\x0a"
"bind(_Fp\x26\x26 __f, _BoundArgs\x26\x26... __bound_args)\x0a"
"{\x0a"
"    typedef __bind<_Fp, _BoundArgs...> type;\x0a"
"    return type(_VSTD\x3a\x3a""forward<_Fp>(__f), _VSTD\x3a\x3a""forward<_BoundArgs>(__bound_args)...);\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class _Fp, class ..._BoundArgs>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__bind_r<_Rp, _Fp, _BoundArgs...>\x0a"
"bind(_Fp\x26\x26 __f, _BoundArgs\x26\x26... __bound_args)\x0a"
"{\x0a"
"    typedef __bind_r<_Rp, _Fp, _BoundArgs...> type;\x0a"
"    return type(_VSTD\x3a\x3a""forward<_Fp>(__f), _VSTD\x3a\x3a""forward<_BoundArgs>(__bound_args)...);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"template <class _Fn, class ..._Args>\x0a"
"invoke_result_t<_Fn, _Args...>\x0a"
"invoke(_Fn\x26\x26 __f, _Args\x26\x26... __args)\x0a"
"    noexcept(is_nothrow_invocable_v<_Fn, _Args...>)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__invoke(_VSTD\x3a\x3a""forward<_Fn>(__f), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"template <class _DecayFunc>\x0a"
"class _LIBCPP_TEMPLATE_VIS __not_fn_imp {\x0a"
"  _DecayFunc __fd;\x0a"
"\x0a"
"public\x3a\x0a"
"    __not_fn_imp() = delete;\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_Args\x26\x26 ...__args) \x26\x0a"
"            noexcept(noexcept(\x21_VSTD\x3a\x3ainvoke(__fd, _VSTD\x3a\x3a""forward<_Args>(__args)...)))\x0a"
"        -> decltype(          \x21_VSTD\x3a\x3ainvoke(__fd, _VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"        { return              \x21_VSTD\x3a\x3ainvoke(__fd, _VSTD\x3a\x3a""forward<_Args>(__args)...); }\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_Args\x26\x26 ...__args) \x26\x26\x0a"
"            noexcept(noexcept(\x21_VSTD\x3a\x3ainvoke(_VSTD\x3a\x3amove(__fd), _VSTD\x3a\x3a""forward<_Args>(__args)...)))\x0a"
"        -> decltype(          \x21_VSTD\x3a\x3ainvoke(_VSTD\x3a\x3amove(__fd), _VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"        { return              \x21_VSTD\x3a\x3ainvoke(_VSTD\x3a\x3amove(__fd), _VSTD\x3a\x3a""forward<_Args>(__args)...); }\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_Args\x26\x26 ...__args) const\x26\x0a"
"            noexcept(noexcept(\x21_VSTD\x3a\x3ainvoke(__fd, _VSTD\x3a\x3a""forward<_Args>(__args)...)))\x0a"
"        -> decltype(          \x21_VSTD\x3a\x3ainvoke(__fd, _VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"        { return              \x21_VSTD\x3a\x3ainvoke(__fd, _VSTD\x3a\x3a""forward<_Args>(__args)...); }\x0a"
"\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    auto operator()(_Args\x26\x26 ...__args) const\x26\x26\x0a"
"            noexcept(noexcept(\x21_VSTD\x3a\x3ainvoke(_VSTD\x3a\x3amove(__fd), _VSTD\x3a\x3a""forward<_Args>(__args)...)))\x0a"
"        -> decltype(          \x21_VSTD\x3a\x3ainvoke(_VSTD\x3a\x3amove(__fd), _VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"        { return              \x21_VSTD\x3a\x3ainvoke(_VSTD\x3a\x3amove(__fd), _VSTD\x3a\x3a""forward<_Args>(__args)...); }\x0a"
"\x0a"
"private\x3a\x0a"
"    template <class _RawFunc,\x0a"
"              class = enable_if_t<\x21is_same<decay_t<_RawFunc>, __not_fn_imp>\x3a\x3avalue>>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __not_fn_imp(_RawFunc\x26\x26 __rf)\x0a"
"        \x3a __fd(_VSTD\x3a\x3a""forward<_RawFunc>(__rf)) {}\x0a"
"\x0a"
"    template <class _RawFunc>\x0a"
"    friend inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    __not_fn_imp<decay_t<_RawFunc>> not_fn(_RawFunc\x26\x26);\x0a"
"};\x0a"
"\x0a"
"template <class _RawFunc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__not_fn_imp<decay_t<_RawFunc>> not_fn(_RawFunc\x26\x26 __fn) {\x0a"
"    return __not_fn_imp<decay_t<_RawFunc>>(_VSTD\x3a\x3a""forward<_RawFunc>(__fn));\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"// struct hash<T*> in <memory>\x0a"
"\x0a"
"template <class _BinaryPredicate, class _ForwardIterator1, class _ForwardIterator2>\x0a"
"pair<_ForwardIterator1, _ForwardIterator1> _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"__search(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"         _ForwardIterator2 __first2, _ForwardIterator2 __last2, _BinaryPredicate __pred,\x0a"
"         forward_iterator_tag, forward_iterator_tag)\x0a"
"{\x0a"
"    if (__first2 == __last2)\x0a"
"        return make_pair(__first1, __first1);  // Everything matches an empty sequence\x0a"
"    while (true)\x0a"
"    {\x0a"
"        // Find first element in sequence 1 that matchs *__first2, with a mininum of loop checks\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (__first1 == __last1)  // return __last1 if no element matches *__first2\x0a"
"                return make_pair(__last1, __last1);\x0a"
"            if (__pred(*__first1, *__first2))\x0a"
"                break;\x0a"
"            ++__first1;\x0a"
"        }\x0a"
"        // *__first1 matches *__first2, now match elements after here\x0a"
"        _ForwardIterator1 __m1 = __first1;\x0a"
"        _ForwardIterator2 __m2 = __first2;\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (++__m2 == __last2)  // If pattern exhausted, __first1 is the answer (works for 1 element pattern)\x0a"
"                return make_pair(__first1, __m1);\x0a"
"            if (++__m1 == __last1)  // Otherwise if source exhaused, pattern not found\x0a"
"                return make_pair(__last1, __last1);\x0a"
"            if (\x21__pred(*__m1, *__m2))  // if there is a mismatch, restart with a new __first1\x0a"
"            {\x0a"
"                ++__first1;\x0a"
"                break;\x0a"
"            }  // else there is a match, check next elements\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _BinaryPredicate, class _RandomAccessIterator1, class _RandomAccessIterator2>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"pair<_RandomAccessIterator1, _RandomAccessIterator1>\x0a"
"__search(_RandomAccessIterator1 __first1, _RandomAccessIterator1 __last1,\x0a"
"         _RandomAccessIterator2 __first2, _RandomAccessIterator2 __last2, _BinaryPredicate __pred,\x0a"
"           random_access_iterator_tag, random_access_iterator_tag)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator1>\x3a\x3a""difference_type _D1;\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator2>\x3a\x3a""difference_type _D2;\x0a"
"    // Take advantage of knowing source and pattern lengths.  Stop short when source is smaller than pattern\x0a"
"    const _D2 __len2 = __last2 - __first2;\x0a"
"    if (__len2 == 0)\x0a"
"        return make_pair(__first1, __first1);\x0a"
"    const _D1 __len1 = __last1 - __first1;\x0a"
"    if (__len1 < __len2)\x0a"
"        return make_pair(__last1, __last1);\x0a"
"    const _RandomAccessIterator1 __s = __last1 - (__len2 - 1);  // Start of pattern match can't go beyond here\x0a"
"\x0a"
"    while (true)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (__first1 == __s)\x0a"
"                return make_pair(__last1, __last1);\x0a"
"            if (__pred(*__first1, *__first2))\x0a"
"                break;\x0a"
"            ++__first1;\x0a"
"        }\x0a"
"\x0a"
"        _RandomAccessIterator1 __m1 = __first1;\x0a"
"        _RandomAccessIterator2 __m2 = __first2;\x0a"
"         while (true)\x0a"
"         {\x0a"
"             if (++__m2 == __last2)\x0a"
"                 return make_pair(__first1, __first1 + __len2);\x0a"
"             ++__m1;          // no need to check range on __m1 because __s guarantees we have enough source\x0a"
"             if (\x21__pred(*__m1, *__m2))\x0a"
"             {\x0a"
"                 ++__first1;\x0a"
"                 break;\x0a"
"             }\x0a"
"         }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"// default searcher\x0a"
"template<class _ForwardIterator, class _BinaryPredicate = equal_to<>>\x0a"
"class _LIBCPP_TYPE_VIS default_searcher {\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    default_searcher(_ForwardIterator __f, _ForwardIterator __l,\x0a"
"                       _BinaryPredicate __p = _BinaryPredicate())\x0a"
"        \x3a __first_(__f), __last_(__l), __pred_(__p) {}\x0a"
"\x0a"
"    template <typename _ForwardIterator2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<_ForwardIterator2, _ForwardIterator2>\x0a"
"    operator () (_ForwardIterator2 __f, _ForwardIterator2 __l) const\x0a"
"    {\x0a"
"        return _VSTD\x3a\x3a__search(__f, __l, __first_, __last_, __pred_,\x0a"
"            typename _VSTD\x3a\x3aiterator_traits<_ForwardIterator>\x3a\x3aiterator_category(),\x0a"
"            typename _VSTD\x3a\x3aiterator_traits<_ForwardIterator2>\x3a\x3aiterator_category());\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    _ForwardIterator __first_;\x0a"
"    _ForwardIterator __last_;\x0a"
"    _BinaryPredicate __pred_;\x0a"
"    };\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Tp>\x0a"
"using unwrap_reference_t = typename unwrap_reference<_Tp>\x3a\x3atype;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"using unwrap_ref_decay_t = typename unwrap_ref_decay<_Tp>\x3a\x3atype;\x0a"
"#endif // > C++17\x0a"
"\x0a"
"template <class _Container, class _Predicate>\x0a"
"inline void __libcpp_erase_if_container( _Container\x26 __c, _Predicate __pred)\x0a"
"{\x0a"
"\x09""for (typename _Container\x3a\x3aiterator __iter = __c.begin(), __last = __c.end(); __iter \x21= __last;)\x0a"
"\x09{\x0a"
"\x09\x09if (__pred(*__iter))\x0a"
"\x09\x09\x09__iter = __c.erase(__iter);\x0a"
"\x09\x09""else\x0a"
"\x09\x09\x09++__iter;\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_FUNCTIONAL\x0a"
"", 96163 ); }