#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_future( 
"// -*- C++ -*-\x0a"
"//===--------------------------- future -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_FUTURE\x0a"
"#define _LIBCPP_FUTURE\x0a"
"\x0a"
"/*\x0a"
"    future synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"enum class future_errc\x0a"
"{\x0a"
"    future_already_retrieved = 1,\x0a"
"    promise_already_satisfied,\x0a"
"    no_state,\x0a"
"    broken_promise\x0a"
"};\x0a"
"\x0a"
"enum class launch\x0a"
"{\x0a"
"    async = 1,\x0a"
"    deferred = 2,\x0a"
"    any = async \x7c deferred\x0a"
"};\x0a"
"\x0a"
"enum class future_status\x0a"
"{\x0a"
"    ready,\x0a"
"    timeout,\x0a"
"    deferred\x0a"
"};\x0a"
"\x0a"
"template <> struct is_error_code_enum<future_errc> \x3a public true_type { };\x0a"
"error_code make_error_code(future_errc e) noexcept;\x0a"
"error_condition make_error_condition(future_errc e) noexcept;\x0a"
"\x0a"
"const error_category\x26 future_category() noexcept;\x0a"
"\x0a"
"class future_error\x0a"
"    \x3a public logic_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    future_error(error_code ec);  // exposition only\x0a"
"    explicit future_error(future_errc); // C++17\x0a"
"    const error_code\x26 code() const noexcept;\x0a"
"    const char*       what() const noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class R>\x0a"
"class promise\x0a"
"{\x0a"
"public\x3a\x0a"
"    promise();\x0a"
"    template <class Allocator>\x0a"
"        promise(allocator_arg_t, const Allocator\x26 a);\x0a"
"    promise(promise\x26\x26 rhs) noexcept;\x0a"
"    promise(const promise\x26 rhs) = delete;\x0a"
"    \x7epromise();\x0a"
"\x0a"
"    // assignment\x0a"
"    promise\x26 operator=(promise\x26\x26 rhs) noexcept;\x0a"
"    promise\x26 operator=(const promise\x26 rhs) = delete;\x0a"
"    void swap(promise\x26 other) noexcept;\x0a"
"\x0a"
"    // retrieving the result\x0a"
"    future<R> get_future();\x0a"
"\x0a"
"    // setting the result\x0a"
"    void set_value(const R\x26 r);\x0a"
"    void set_value(R\x26\x26 r);\x0a"
"    void set_exception(exception_ptr p);\x0a"
"\x0a"
"    // setting the result with deferred notification\x0a"
"    void set_value_at_thread_exit(const R\x26 r);\x0a"
"    void set_value_at_thread_exit(R\x26\x26 r);\x0a"
"    void set_exception_at_thread_exit(exception_ptr p);\x0a"
"};\x0a"
"\x0a"
"template <class R>\x0a"
"class promise<R\x26>\x0a"
"{\x0a"
"public\x3a\x0a"
"    promise();\x0a"
"    template <class Allocator>\x0a"
"        promise(allocator_arg_t, const Allocator\x26 a);\x0a"
"    promise(promise\x26\x26 rhs) noexcept;\x0a"
"    promise(const promise\x26 rhs) = delete;\x0a"
"    \x7epromise();\x0a"
"\x0a"
"    // assignment\x0a"
"    promise\x26 operator=(promise\x26\x26 rhs) noexcept;\x0a"
"    promise\x26 operator=(const promise\x26 rhs) = delete;\x0a"
"    void swap(promise\x26 other) noexcept;\x0a"
"\x0a"
"    // retrieving the result\x0a"
"    future<R\x26> get_future();\x0a"
"\x0a"
"    // setting the result\x0a"
"    void set_value(R\x26 r);\x0a"
"    void set_exception(exception_ptr p);\x0a"
"\x0a"
"    // setting the result with deferred notification\x0a"
"    void set_value_at_thread_exit(R\x26);\x0a"
"    void set_exception_at_thread_exit(exception_ptr p);\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class promise<void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    promise();\x0a"
"    template <class Allocator>\x0a"
"        promise(allocator_arg_t, const Allocator\x26 a);\x0a"
"    promise(promise\x26\x26 rhs) noexcept;\x0a"
"    promise(const promise\x26 rhs) = delete;\x0a"
"    \x7epromise();\x0a"
"\x0a"
"    // assignment\x0a"
"    promise\x26 operator=(promise\x26\x26 rhs) noexcept;\x0a"
"    promise\x26 operator=(const promise\x26 rhs) = delete;\x0a"
"    void swap(promise\x26 other) noexcept;\x0a"
"\x0a"
"    // retrieving the result\x0a"
"    future<void> get_future();\x0a"
"\x0a"
"    // setting the result\x0a"
"    void set_value();\x0a"
"    void set_exception(exception_ptr p);\x0a"
"\x0a"
"    // setting the result with deferred notification\x0a"
"    void set_value_at_thread_exit();\x0a"
"    void set_exception_at_thread_exit(exception_ptr p);\x0a"
"};\x0a"
"\x0a"
"template <class R> void swap(promise<R>\x26 x, promise<R>\x26 y) noexcept;\x0a"
"\x0a"
"template <class R, class Alloc>\x0a"
"    struct uses_allocator<promise<R>, Alloc> \x3a public true_type {};\x0a"
"\x0a"
"template <class R>\x0a"
"class future\x0a"
"{\x0a"
"public\x3a\x0a"
"    future() noexcept;\x0a"
"    future(future\x26\x26) noexcept;\x0a"
"    future(const future\x26 rhs) = delete;\x0a"
"    \x7e""future();\x0a"
"    future\x26 operator=(const future\x26 rhs) = delete;\x0a"
"    future\x26 operator=(future\x26\x26) noexcept;\x0a"
"    shared_future<R> share() noexcept;\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    R get();\x0a"
"\x0a"
"    // functions to check state\x0a"
"    bool valid() const noexcept;\x0a"
"\x0a"
"    void wait() const;\x0a"
"    template <class Rep, class Period>\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time) const;\x0a"
"    template <class Clock, class Duration>\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time) const;\x0a"
"};\x0a"
"\x0a"
"template <class R>\x0a"
"class future<R\x26>\x0a"
"{\x0a"
"public\x3a\x0a"
"    future() noexcept;\x0a"
"    future(future\x26\x26) noexcept;\x0a"
"    future(const future\x26 rhs) = delete;\x0a"
"    \x7e""future();\x0a"
"    future\x26 operator=(const future\x26 rhs) = delete;\x0a"
"    future\x26 operator=(future\x26\x26) noexcept;\x0a"
"    shared_future<R\x26> share() noexcept;\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    R\x26 get();\x0a"
"\x0a"
"    // functions to check state\x0a"
"    bool valid() const noexcept;\x0a"
"\x0a"
"    void wait() const;\x0a"
"    template <class Rep, class Period>\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time) const;\x0a"
"    template <class Clock, class Duration>\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time) const;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class future<void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    future() noexcept;\x0a"
"    future(future\x26\x26) noexcept;\x0a"
"    future(const future\x26 rhs) = delete;\x0a"
"    \x7e""future();\x0a"
"    future\x26 operator=(const future\x26 rhs) = delete;\x0a"
"    future\x26 operator=(future\x26\x26) noexcept;\x0a"
"    shared_future<void> share() noexcept;\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    void get();\x0a"
"\x0a"
"    // functions to check state\x0a"
"    bool valid() const noexcept;\x0a"
"\x0a"
"    void wait() const;\x0a"
"    template <class Rep, class Period>\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time) const;\x0a"
"    template <class Clock, class Duration>\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time) const;\x0a"
"};\x0a"
"\x0a"
"template <class R>\x0a"
"class shared_future\x0a"
"{\x0a"
"public\x3a\x0a"
"    shared_future() noexcept;\x0a"
"    shared_future(const shared_future\x26 rhs);\x0a"
"    shared_future(future<R>\x26\x26) noexcept;\x0a"
"    shared_future(shared_future\x26\x26 rhs) noexcept;\x0a"
"    \x7eshared_future();\x0a"
"    shared_future\x26 operator=(const shared_future\x26 rhs);\x0a"
"    shared_future\x26 operator=(shared_future\x26\x26 rhs) noexcept;\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    const R\x26 get() const;\x0a"
"\x0a"
"    // functions to check state\x0a"
"    bool valid() const noexcept;\x0a"
"\x0a"
"    void wait() const;\x0a"
"    template <class Rep, class Period>\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time) const;\x0a"
"    template <class Clock, class Duration>\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time) const;\x0a"
"};\x0a"
"\x0a"
"template <class R>\x0a"
"class shared_future<R\x26>\x0a"
"{\x0a"
"public\x3a\x0a"
"    shared_future() noexcept;\x0a"
"    shared_future(const shared_future\x26 rhs);\x0a"
"    shared_future(future<R\x26>\x26\x26) noexcept;\x0a"
"    shared_future(shared_future\x26\x26 rhs) noexcept;\x0a"
"    \x7eshared_future();\x0a"
"    shared_future\x26 operator=(const shared_future\x26 rhs);\x0a"
"    shared_future\x26 operator=(shared_future\x26\x26 rhs) noexcept;\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    R\x26 get() const;\x0a"
"\x0a"
"    // functions to check state\x0a"
"    bool valid() const noexcept;\x0a"
"\x0a"
"    void wait() const;\x0a"
"    template <class Rep, class Period>\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time) const;\x0a"
"    template <class Clock, class Duration>\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time) const;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class shared_future<void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    shared_future() noexcept;\x0a"
"    shared_future(const shared_future\x26 rhs);\x0a"
"    shared_future(future<void>\x26\x26) noexcept;\x0a"
"    shared_future(shared_future\x26\x26 rhs) noexcept;\x0a"
"    \x7eshared_future();\x0a"
"    shared_future\x26 operator=(const shared_future\x26 rhs);\x0a"
"    shared_future\x26 operator=(shared_future\x26\x26 rhs) noexcept;\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    void get() const;\x0a"
"\x0a"
"    // functions to check state\x0a"
"    bool valid() const noexcept;\x0a"
"\x0a"
"    void wait() const;\x0a"
"    template <class Rep, class Period>\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time) const;\x0a"
"    template <class Clock, class Duration>\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time) const;\x0a"
"};\x0a"
"\x0a"
"template <class F, class... Args>\x0a"
"  future<typename result_of<typename decay<F>\x3a\x3atype(typename decay<Args>\x3a\x3atype...)>\x3a\x3atype>\x0a"
"  async(F\x26\x26 f, Args\x26\x26... args);\x0a"
"\x0a"
"template <class F, class... Args>\x0a"
"  future<typename result_of<typename decay<F>\x3a\x3atype(typename decay<Args>\x3a\x3atype...)>\x3a\x3atype>\x0a"
"  async(launch policy, F\x26\x26 f, Args\x26\x26... args);\x0a"
"\x0a"
"template <class> class packaged_task; // undefined\x0a"
"\x0a"
"template <class R, class... ArgTypes>\x0a"
"class packaged_task<R(ArgTypes...)>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef R result_type; // extension\x0a"
"\x0a"
"    // construction and destruction\x0a"
"    packaged_task() noexcept;\x0a"
"    template <class F>\x0a"
"        explicit packaged_task(F\x26\x26 f);\x0a"
"    template <class F, class Allocator>\x0a"
"        packaged_task(allocator_arg_t, const Allocator\x26 a, F\x26\x26 f);\x0a"
"    \x7epackaged_task();\x0a"
"\x0a"
"    // no copy\x0a"
"    packaged_task(const packaged_task\x26) = delete;\x0a"
"    packaged_task\x26 operator=(const packaged_task\x26) = delete;\x0a"
"\x0a"
"    // move support\x0a"
"    packaged_task(packaged_task\x26\x26 other) noexcept;\x0a"
"    packaged_task\x26 operator=(packaged_task\x26\x26 other) noexcept;\x0a"
"    void swap(packaged_task\x26 other) noexcept;\x0a"
"\x0a"
"    bool valid() const noexcept;\x0a"
"\x0a"
"    // result retrieval\x0a"
"    future<R> get_future();\x0a"
"\x0a"
"    // execution\x0a"
"    void operator()(ArgTypes... );\x0a"
"    void make_ready_at_thread_exit(ArgTypes...);\x0a"
"\x0a"
"    void reset();\x0a"
"};\x0a"
"\x0a"
"template <class R>\x0a"
"  void swap(packaged_task<R(ArgTypes...)\x26, packaged_task<R(ArgTypes...)>\x26) noexcept;\x0a"
"\x0a"
"template <class R, class Alloc> struct uses_allocator<packaged_task<R>, Alloc>;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <system_error>\x0a"
"#include <memory>\x0a"
"#include <chrono>\x0a"
"#include <exception>\x0a"
"#include <mutex>\x0a"
"#include <thread>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_NO_THREADS\x0a"
"#error <future> is not supported on this single threaded system\x0a"
"#else // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"//enum class future_errc\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM(future_errc)\x0a"
"{\x0a"
"    future_already_retrieved = 1,\x0a"
"    promise_already_satisfied,\x0a"
"    no_state,\x0a"
"    broken_promise\x0a"
"};\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM_EPILOG(future_errc)\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_error_code_enum<future_errc> \x3a public true_type {};\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_NO_STRONG_ENUMS\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_error_code_enum<future_errc\x3a\x3a__lx> \x3a public true_type { };\x0a"
"#endif\x0a"
"\x0a"
"//enum class launch\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM(launch)\x0a"
"{\x0a"
"    async = 1,\x0a"
"    deferred = 2,\x0a"
"    any = async \x7c deferred\x0a"
"};\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM_EPILOG(launch)\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_STRONG_ENUMS\x0a"
"\x0a"
"typedef underlying_type<launch>\x3a\x3atype __launch_underlying_type;\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"launch\x0a"
"operator\x26(launch __x, launch __y)\x0a"
"{\x0a"
"    return static_cast<launch>(static_cast<__launch_underlying_type>(__x) \x26\x0a"
"                               static_cast<__launch_underlying_type>(__y));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"launch\x0a"
"operator\x7c(launch __x, launch __y)\x0a"
"{\x0a"
"    return static_cast<launch>(static_cast<__launch_underlying_type>(__x) \x7c\x0a"
"                               static_cast<__launch_underlying_type>(__y));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"launch\x0a"
"operator^(launch __x, launch __y)\x0a"
"{\x0a"
"    return static_cast<launch>(static_cast<__launch_underlying_type>(__x) ^\x0a"
"                               static_cast<__launch_underlying_type>(__y));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"launch\x0a"
"operator\x7e(launch __x)\x0a"
"{\x0a"
"    return static_cast<launch>(\x7estatic_cast<__launch_underlying_type>(__x) \x26 3);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"launch\x26\x0a"
"operator\x26=(launch\x26 __x, launch __y)\x0a"
"{\x0a"
"    __x = __x \x26 __y; return __x;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"launch\x26\x0a"
"operator\x7c=(launch\x26 __x, launch __y)\x0a"
"{\x0a"
"    __x = __x \x7c __y; return __x;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"launch\x26\x0a"
"operator^=(launch\x26 __x, launch __y)\x0a"
"{\x0a"
"    __x = __x ^ __y; return __x;\x0a"
"}\x0a"
"\x0a"
"#endif  // \x21_LIBCPP_HAS_NO_STRONG_ENUMS\x0a"
"\x0a"
"//enum class future_status\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM(future_status)\x0a"
"{\x0a"
"    ready,\x0a"
"    timeout,\x0a"
"    deferred\x0a"
"};\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM_EPILOG(future_status)\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"const error_category\x26 future_category() _NOEXCEPT;\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"error_code\x0a"
"make_error_code(future_errc __e) _NOEXCEPT\x0a"
"{\x0a"
"    return error_code(static_cast<int>(__e), future_category());\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"error_condition\x0a"
"make_error_condition(future_errc __e) _NOEXCEPT\x0a"
"{\x0a"
"    return error_condition(static_cast<int>(__e), future_category());\x0a"
"}\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI _LIBCPP_AVAILABILITY_FUTURE_ERROR future_error\x0a"
"    \x3a public logic_error\x0a"
"{\x0a"
"    error_code __ec_;\x0a"
"public\x3a\x0a"
"    future_error(error_code __ec);\x0a"
"#if _LIBCPP_STD_VERS > 14\x0a"
"    explicit future_error(future_errc _Ev) \x3a logic_error(), __ec_(make_error_code(_Ev)) {}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const error_code\x26 code() const _NOEXCEPT {return __ec_;}\x0a"
"\x0a"
"    virtual \x7e""future_error() _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"_LIBCPP_AVAILABILITY_FUTURE_ERROR\x0a"
"#endif\x0a"
"void __throw_future_error(future_errc _Ev)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw future_error(make_error_code(_Ev));\x0a"
"#else\x0a"
"    ((void)_Ev);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS _LIBCPP_AVAILABILITY_FUTURE __assoc_sub_state\x0a"
"    \x3a public __shared_count\x0a"
"{\x0a"
"protected\x3a\x0a"
"    exception_ptr __exception_;\x0a"
"    mutable mutex __mut_;\x0a"
"    mutable condition_variable __cv_;\x0a"
"    unsigned __state_;\x0a"
"\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT;\x0a"
"    void __sub_wait(unique_lock<mutex>\x26 __lk);\x0a"
"public\x3a\x0a"
"    enum\x0a"
"    {\x0a"
"        __constructed = 1,\x0a"
"        __future_attached = 2,\x0a"
"        ready = 4,\x0a"
"        deferred = 8\x0a"
"    };\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __assoc_sub_state() \x3a __state_(0) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool __has_value() const\x0a"
"        {return (__state_ \x26 __constructed) \x7c\x7c (__exception_ \x21= nullptr);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __attach_future() {\x0a"
"        lock_guard<mutex> __lk(__mut_);\x0a"
"        bool __has_future_attached = (__state_ \x26 __future_attached) \x21= 0;\x0a"
"        if (__has_future_attached)\x0a"
"            __throw_future_error(future_errc\x3a\x3a""future_already_retrieved);\x0a"
"        this->__add_shared();\x0a"
"        __state_ \x7c= __future_attached;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __set_deferred() {__state_ \x7c= deferred;}\x0a"
"\x0a"
"    void __make_ready();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool __is_ready() const {return (__state_ \x26 ready) \x21= 0;}\x0a"
"\x0a"
"    void set_value();\x0a"
"    void set_value_at_thread_exit();\x0a"
"\x0a"
"    void set_exception(exception_ptr __p);\x0a"
"    void set_exception_at_thread_exit(exception_ptr __p);\x0a"
"\x0a"
"    void copy();\x0a"
"\x0a"
"    void wait();\x0a"
"    template <class _Rep, class _Period>\x0a"
"        future_status\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        wait_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time) const;\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time) const;\x0a"
"\x0a"
"    virtual void __execute();\x0a"
"};\x0a"
"\x0a"
"template <class _Clock, class _Duration>\x0a"
"future_status\x0a"
"__assoc_sub_state\x3a\x3await_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time) const\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(__mut_);\x0a"
"    if (__state_ \x26 deferred)\x0a"
"        return future_status\x3a\x3a""deferred;\x0a"
"    while (\x21(__state_ \x26 ready) \x26\x26 _Clock\x3a\x3anow() < __abs_time)\x0a"
"        __cv_.wait_until(__lk, __abs_time);\x0a"
"    if (__state_ \x26 ready)\x0a"
"        return future_status\x3a\x3aready;\x0a"
"    return future_status\x3a\x3atimeout;\x0a"
"}\x0a"
"\x0a"
"template <class _Rep, class _Period>\x0a"
"inline\x0a"
"future_status\x0a"
"__assoc_sub_state\x3a\x3await_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time) const\x0a"
"{\x0a"
"    return wait_until(chrono\x3a\x3asteady_clock\x3a\x3anow() + __rel_time);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __assoc_state\x0a"
"    \x3a public __assoc_sub_state\x0a"
"{\x0a"
"    typedef __assoc_sub_state base;\x0a"
"    typedef typename aligned_storage<sizeof(_Rp), alignment_of<_Rp>\x3a\x3avalue>\x3a\x3atype _Up;\x0a"
"protected\x3a\x0a"
"    _Up __value_;\x0a"
"\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT;\x0a"
"public\x3a\x0a"
"\x0a"
"    template <class _Arg>\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"        void set_value(_Arg\x26\x26 __arg);\x0a"
"#else\x0a"
"        void set_value(_Arg\x26 __arg);\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Arg>\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"        void set_value_at_thread_exit(_Arg\x26\x26 __arg);\x0a"
"#else\x0a"
"        void set_value_at_thread_exit(_Arg\x26 __arg);\x0a"
"#endif\x0a"
"\x0a"
"    _Rp move();\x0a"
"    typename add_lvalue_reference<_Rp>\x3a\x3atype copy();\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"__assoc_state<_Rp>\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    if (this->__state_ \x26 base\x3a\x3a__constructed)\x0a"
"        reinterpret_cast<_Rp*>(\x26__value_)->\x7e_Rp();\x0a"
"    delete this;\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"template <class _Arg>\x0a"
"_LIBCPP_AVAILABILITY_FUTURE\x0a"
"void\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"__assoc_state<_Rp>\x3a\x3aset_value(_Arg\x26\x26 __arg)\x0a"
"#else\x0a"
"__assoc_state<_Rp>\x3a\x3aset_value(_Arg\x26 __arg)\x0a"
"#endif\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(this->__mut_);\x0a"
"    if (this->__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"    \x3a\x3anew(\x26__value_) _Rp(_VSTD\x3a\x3a""forward<_Arg>(__arg));\x0a"
"    this->__state_ \x7c= base\x3a\x3a__constructed \x7c base\x3a\x3aready;\x0a"
"    __cv_.notify_all();\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"template <class _Arg>\x0a"
"void\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"__assoc_state<_Rp>\x3a\x3aset_value_at_thread_exit(_Arg\x26\x26 __arg)\x0a"
"#else\x0a"
"__assoc_state<_Rp>\x3a\x3aset_value_at_thread_exit(_Arg\x26 __arg)\x0a"
"#endif\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(this->__mut_);\x0a"
"    if (this->__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"    \x3a\x3anew(\x26__value_) _Rp(_VSTD\x3a\x3a""forward<_Arg>(__arg));\x0a"
"    this->__state_ \x7c= base\x3a\x3a__constructed;\x0a"
"    __thread_local_data()->__make_ready_at_thread_exit(this);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"_Rp\x0a"
"__assoc_state<_Rp>\x3a\x3amove()\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(this->__mut_);\x0a"
"    this->__sub_wait(__lk);\x0a"
"    if (this->__exception_ \x21= nullptr)\x0a"
"        rethrow_exception(this->__exception_);\x0a"
"    return _VSTD\x3a\x3amove(*reinterpret_cast<_Rp*>(\x26__value_));\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"typename add_lvalue_reference<_Rp>\x3a\x3atype\x0a"
"__assoc_state<_Rp>\x3a\x3a""copy()\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(this->__mut_);\x0a"
"    this->__sub_wait(__lk);\x0a"
"    if (this->__exception_ \x21= nullptr)\x0a"
"        rethrow_exception(this->__exception_);\x0a"
"    return *reinterpret_cast<_Rp*>(\x26__value_);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __assoc_state<_Rp\x26>\x0a"
"    \x3a public __assoc_sub_state\x0a"
"{\x0a"
"    typedef __assoc_sub_state base;\x0a"
"    typedef _Rp* _Up;\x0a"
"protected\x3a\x0a"
"    _Up __value_;\x0a"
"\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT;\x0a"
"public\x3a\x0a"
"\x0a"
"    void set_value(_Rp\x26 __arg);\x0a"
"    void set_value_at_thread_exit(_Rp\x26 __arg);\x0a"
"\x0a"
"    _Rp\x26 copy();\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"__assoc_state<_Rp\x26>\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    delete this;\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"__assoc_state<_Rp\x26>\x3a\x3aset_value(_Rp\x26 __arg)\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(this->__mut_);\x0a"
"    if (this->__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"    __value_ = _VSTD\x3a\x3a""addressof(__arg);\x0a"
"    this->__state_ \x7c= base\x3a\x3a__constructed \x7c base\x3a\x3aready;\x0a"
"    __cv_.notify_all();\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"__assoc_state<_Rp\x26>\x3a\x3aset_value_at_thread_exit(_Rp\x26 __arg)\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(this->__mut_);\x0a"
"    if (this->__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"    __value_ = _VSTD\x3a\x3a""addressof(__arg);\x0a"
"    this->__state_ \x7c= base\x3a\x3a__constructed;\x0a"
"    __thread_local_data()->__make_ready_at_thread_exit(this);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"_Rp\x26\x0a"
"__assoc_state<_Rp\x26>\x3a\x3a""copy()\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(this->__mut_);\x0a"
"    this->__sub_wait(__lk);\x0a"
"    if (this->__exception_ \x21= nullptr)\x0a"
"        rethrow_exception(this->__exception_);\x0a"
"    return *__value_;\x0a"
"}\x0a"
"\x0a"
"template <class _Rp, class _Alloc>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __assoc_state_alloc\x0a"
"    \x3a public __assoc_state<_Rp>\x0a"
"{\x0a"
"    typedef __assoc_state<_Rp> base;\x0a"
"    _Alloc __alloc_;\x0a"
"\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __assoc_state_alloc(const _Alloc\x26 __a)\x0a"
"        \x3a __alloc_(__a) {}\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Alloc>\x0a"
"void\x0a"
"__assoc_state_alloc<_Rp, _Alloc>\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    if (this->__state_ \x26 base\x3a\x3a__constructed)\x0a"
"        reinterpret_cast<_Rp*>(_VSTD\x3a\x3a""addressof(this->__value_))->\x7e_Rp();\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, __assoc_state_alloc>\x3a\x3atype _Al;\x0a"
"    typedef allocator_traits<_Al> _ATraits;\x0a"
"    typedef pointer_traits<typename _ATraits\x3a\x3apointer> _PTraits;\x0a"
"    _Al __a(__alloc_);\x0a"
"    this->\x7e__assoc_state_alloc();\x0a"
"    __a.deallocate(_PTraits\x3a\x3apointer_to(*this), 1);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp, class _Alloc>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __assoc_state_alloc<_Rp\x26, _Alloc>\x0a"
"    \x3a public __assoc_state<_Rp\x26>\x0a"
"{\x0a"
"    typedef __assoc_state<_Rp\x26> base;\x0a"
"    _Alloc __alloc_;\x0a"
"\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __assoc_state_alloc(const _Alloc\x26 __a)\x0a"
"        \x3a __alloc_(__a) {}\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Alloc>\x0a"
"void\x0a"
"__assoc_state_alloc<_Rp\x26, _Alloc>\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, __assoc_state_alloc>\x3a\x3atype _Al;\x0a"
"    typedef allocator_traits<_Al> _ATraits;\x0a"
"    typedef pointer_traits<typename _ATraits\x3a\x3apointer> _PTraits;\x0a"
"    _Al __a(__alloc_);\x0a"
"    this->\x7e__assoc_state_alloc();\x0a"
"    __a.deallocate(_PTraits\x3a\x3apointer_to(*this), 1);\x0a"
"}\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __assoc_sub_state_alloc\x0a"
"    \x3a public __assoc_sub_state\x0a"
"{\x0a"
"    typedef __assoc_sub_state base;\x0a"
"    _Alloc __alloc_;\x0a"
"\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __assoc_sub_state_alloc(const _Alloc\x26 __a)\x0a"
"        \x3a __alloc_(__a) {}\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"void\x0a"
"__assoc_sub_state_alloc<_Alloc>\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, __assoc_sub_state_alloc>\x3a\x3atype _Al;\x0a"
"    typedef allocator_traits<_Al> _ATraits;\x0a"
"    typedef pointer_traits<typename _ATraits\x3a\x3apointer> _PTraits;\x0a"
"    _Al __a(__alloc_);\x0a"
"    this->\x7e__assoc_sub_state_alloc();\x0a"
"    __a.deallocate(_PTraits\x3a\x3apointer_to(*this), 1);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __deferred_assoc_state\x0a"
"    \x3a public __assoc_state<_Rp>\x0a"
"{\x0a"
"    typedef __assoc_state<_Rp> base;\x0a"
"\x0a"
"    _Fp __func_;\x0a"
"\x0a"
"public\x3a\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __deferred_assoc_state(_Fp\x26\x26 __f);\x0a"
"#endif\x0a"
"\x0a"
"    virtual void __execute();\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"inline\x0a"
"__deferred_assoc_state<_Rp, _Fp>\x3a\x3a__deferred_assoc_state(_Fp\x26\x26 __f)\x0a"
"    \x3a __func_(_VSTD\x3a\x3a""forward<_Fp>(__f))\x0a"
"{\x0a"
"    this->__set_deferred();\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"void\x0a"
"__deferred_assoc_state<_Rp, _Fp>\x3a\x3a__execute()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        this->set_value(__func_());\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->set_exception(current_exception());\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template <class _Fp>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __deferred_assoc_state<void, _Fp>\x0a"
"    \x3a public __assoc_sub_state\x0a"
"{\x0a"
"    typedef __assoc_sub_state base;\x0a"
"\x0a"
"    _Fp __func_;\x0a"
"\x0a"
"public\x3a\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __deferred_assoc_state(_Fp\x26\x26 __f);\x0a"
"#endif\x0a"
"\x0a"
"    virtual void __execute();\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Fp>\x0a"
"inline\x0a"
"__deferred_assoc_state<void, _Fp>\x3a\x3a__deferred_assoc_state(_Fp\x26\x26 __f)\x0a"
"    \x3a __func_(_VSTD\x3a\x3a""forward<_Fp>(__f))\x0a"
"{\x0a"
"    this->__set_deferred();\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Fp>\x0a"
"void\x0a"
"__deferred_assoc_state<void, _Fp>\x3a\x3a__execute()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __func_();\x0a"
"        this->set_value();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->set_exception(current_exception());\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __async_assoc_state\x0a"
"    \x3a public __assoc_state<_Rp>\x0a"
"{\x0a"
"    typedef __assoc_state<_Rp> base;\x0a"
"\x0a"
"    _Fp __func_;\x0a"
"\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT;\x0a"
"public\x3a\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __async_assoc_state(_Fp\x26\x26 __f);\x0a"
"#endif\x0a"
"\x0a"
"    virtual void __execute();\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"inline\x0a"
"__async_assoc_state<_Rp, _Fp>\x3a\x3a__async_assoc_state(_Fp\x26\x26 __f)\x0a"
"    \x3a __func_(_VSTD\x3a\x3a""forward<_Fp>(__f))\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"void\x0a"
"__async_assoc_state<_Rp, _Fp>\x3a\x3a__execute()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        this->set_value(__func_());\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->set_exception(current_exception());\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"void\x0a"
"__async_assoc_state<_Rp, _Fp>\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    this->wait();\x0a"
"    base\x3a\x3a__on_zero_shared();\x0a"
"}\x0a"
"\x0a"
"template <class _Fp>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __async_assoc_state<void, _Fp>\x0a"
"    \x3a public __assoc_sub_state\x0a"
"{\x0a"
"    typedef __assoc_sub_state base;\x0a"
"\x0a"
"    _Fp __func_;\x0a"
"\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT;\x0a"
"public\x3a\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __async_assoc_state(_Fp\x26\x26 __f);\x0a"
"#endif\x0a"
"\x0a"
"    virtual void __execute();\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Fp>\x0a"
"inline\x0a"
"__async_assoc_state<void, _Fp>\x3a\x3a__async_assoc_state(_Fp\x26\x26 __f)\x0a"
"    \x3a __func_(_VSTD\x3a\x3a""forward<_Fp>(__f))\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Fp>\x0a"
"void\x0a"
"__async_assoc_state<void, _Fp>\x3a\x3a__execute()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __func_();\x0a"
"        this->set_value();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->set_exception(current_exception());\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template <class _Fp>\x0a"
"void\x0a"
"__async_assoc_state<void, _Fp>\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    this->wait();\x0a"
"    base\x3a\x3a__on_zero_shared();\x0a"
"}\x0a"
"\x0a"
"template <class _Rp> class _LIBCPP_TEMPLATE_VIS promise;\x0a"
"template <class _Rp> class _LIBCPP_TEMPLATE_VIS shared_future;\x0a"
"\x0a"
"// future\x0a"
"\x0a"
"template <class _Rp> class _LIBCPP_TEMPLATE_VIS future;\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"future<_Rp>\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"__make_deferred_assoc_state(_Fp\x26\x26 __f);\x0a"
"#else\x0a"
"__make_deferred_assoc_state(_Fp __f);\x0a"
"#endif\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"future<_Rp>\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"__make_async_assoc_state(_Fp\x26\x26 __f);\x0a"
"#else\x0a"
"__make_async_assoc_state(_Fp __f);\x0a"
"#endif\x0a"
"\x0a"
"template <class _Rp>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_AVAILABILITY_FUTURE future\x0a"
"{\x0a"
"    __assoc_state<_Rp>* __state_;\x0a"
"\x0a"
"    explicit future(__assoc_state<_Rp>* __state);\x0a"
"\x0a"
"    template <class> friend class promise;\x0a"
"    template <class> friend class shared_future;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_deferred_assoc_state(_Fp\x26\x26 __f);\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_async_assoc_state(_Fp\x26\x26 __f);\x0a"
"#else\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_deferred_assoc_state(_Fp __f);\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_async_assoc_state(_Fp __f);\x0a"
"#endif\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future() _NOEXCEPT \x3a __state_(nullptr) {}\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future(future\x26\x26 __rhs) _NOEXCEPT\x0a"
"        \x3a __state_(__rhs.__state_) {__rhs.__state_ = nullptr;}\x0a"
"    future(const future\x26) = delete;\x0a"
"    future\x26 operator=(const future\x26) = delete;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future\x26 operator=(future\x26\x26 __rhs) _NOEXCEPT\x0a"
"        {\x0a"
"            future(std\x3a\x3amove(__rhs)).swap(*this);\x0a"
"            return *this;\x0a"
"        }\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"private\x3a\x0a"
"    future(const future\x26);\x0a"
"    future\x26 operator=(const future\x26);\x0a"
"public\x3a\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    \x7e""future();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future<_Rp> share() _NOEXCEPT;\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    _Rp get();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(future\x26 __rhs) _NOEXCEPT {_VSTD\x3a\x3aswap(__state_, __rhs.__state_);}\x0a"
"\x0a"
"    // functions to check state\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool valid() const _NOEXCEPT {return __state_ \x21= nullptr;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void wait() const {__state_->wait();}\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time) const\x0a"
"            {return __state_->wait_for(__rel_time);}\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time) const\x0a"
"            {return __state_->wait_until(__abs_time);}\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"future<_Rp>\x3a\x3a""future(__assoc_state<_Rp>* __state)\x0a"
"    \x3a __state_(__state)\x0a"
"{\x0a"
"    __state_->__attach_future();\x0a"
"}\x0a"
"\x0a"
"struct __release_shared_count\x0a"
"{\x0a"
"    void operator()(__shared_count* p) {p->__release_shared();}\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"future<_Rp>\x3a\x3a\x7e""future()\x0a"
"{\x0a"
"    if (__state_)\x0a"
"        __state_->__release_shared();\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"_Rp\x0a"
"future<_Rp>\x3a\x3aget()\x0a"
"{\x0a"
"    unique_ptr<__shared_count, __release_shared_count> __(__state_);\x0a"
"    __assoc_state<_Rp>* __s = __state_;\x0a"
"    __state_ = nullptr;\x0a"
"    return __s->move();\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_AVAILABILITY_FUTURE future<_Rp\x26>\x0a"
"{\x0a"
"    __assoc_state<_Rp\x26>* __state_;\x0a"
"\x0a"
"    explicit future(__assoc_state<_Rp\x26>* __state);\x0a"
"\x0a"
"    template <class> friend class promise;\x0a"
"    template <class> friend class shared_future;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_deferred_assoc_state(_Fp\x26\x26 __f);\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_async_assoc_state(_Fp\x26\x26 __f);\x0a"
"#else\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_deferred_assoc_state(_Fp __f);\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_async_assoc_state(_Fp __f);\x0a"
"#endif\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future() _NOEXCEPT \x3a __state_(nullptr) {}\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future(future\x26\x26 __rhs) _NOEXCEPT\x0a"
"        \x3a __state_(__rhs.__state_) {__rhs.__state_ = nullptr;}\x0a"
"    future(const future\x26) = delete;\x0a"
"    future\x26 operator=(const future\x26) = delete;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future\x26 operator=(future\x26\x26 __rhs) _NOEXCEPT\x0a"
"        {\x0a"
"            future(std\x3a\x3amove(__rhs)).swap(*this);\x0a"
"            return *this;\x0a"
"        }\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"private\x3a\x0a"
"    future(const future\x26);\x0a"
"    future\x26 operator=(const future\x26);\x0a"
"public\x3a\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    \x7e""future();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future<_Rp\x26> share() _NOEXCEPT;\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    _Rp\x26 get();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(future\x26 __rhs) _NOEXCEPT {_VSTD\x3a\x3aswap(__state_, __rhs.__state_);}\x0a"
"\x0a"
"    // functions to check state\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool valid() const _NOEXCEPT {return __state_ \x21= nullptr;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void wait() const {__state_->wait();}\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time) const\x0a"
"            {return __state_->wait_for(__rel_time);}\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time) const\x0a"
"            {return __state_->wait_until(__abs_time);}\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"future<_Rp\x26>\x3a\x3a""future(__assoc_state<_Rp\x26>* __state)\x0a"
"    \x3a __state_(__state)\x0a"
"{\x0a"
"    __state_->__attach_future();\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"future<_Rp\x26>\x3a\x3a\x7e""future()\x0a"
"{\x0a"
"    if (__state_)\x0a"
"        __state_->__release_shared();\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"_Rp\x26\x0a"
"future<_Rp\x26>\x3a\x3aget()\x0a"
"{\x0a"
"    unique_ptr<__shared_count, __release_shared_count> __(__state_);\x0a"
"    __assoc_state<_Rp\x26>* __s = __state_;\x0a"
"    __state_ = nullptr;\x0a"
"    return __s->copy();\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS _LIBCPP_AVAILABILITY_FUTURE future<void>\x0a"
"{\x0a"
"    __assoc_sub_state* __state_;\x0a"
"\x0a"
"    explicit future(__assoc_sub_state* __state);\x0a"
"\x0a"
"    template <class> friend class promise;\x0a"
"    template <class> friend class shared_future;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_deferred_assoc_state(_Fp\x26\x26 __f);\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_async_assoc_state(_Fp\x26\x26 __f);\x0a"
"#else\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_deferred_assoc_state(_Fp __f);\x0a"
"    template <class _R1, class _Fp>\x0a"
"        friend future<_R1> __make_async_assoc_state(_Fp __f);\x0a"
"#endif\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future() _NOEXCEPT \x3a __state_(nullptr) {}\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future(future\x26\x26 __rhs) _NOEXCEPT\x0a"
"        \x3a __state_(__rhs.__state_) {__rhs.__state_ = nullptr;}\x0a"
"    future(const future\x26) = delete;\x0a"
"    future\x26 operator=(const future\x26) = delete;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future\x26 operator=(future\x26\x26 __rhs) _NOEXCEPT\x0a"
"        {\x0a"
"            future(std\x3a\x3amove(__rhs)).swap(*this);\x0a"
"            return *this;\x0a"
"        }\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"private\x3a\x0a"
"    future(const future\x26);\x0a"
"    future\x26 operator=(const future\x26);\x0a"
"public\x3a\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    \x7e""future();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future<void> share() _NOEXCEPT;\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    void get();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(future\x26 __rhs) _NOEXCEPT {_VSTD\x3a\x3aswap(__state_, __rhs.__state_);}\x0a"
"\x0a"
"    // functions to check state\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool valid() const _NOEXCEPT {return __state_ \x21= nullptr;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void wait() const {__state_->wait();}\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time) const\x0a"
"            {return __state_->wait_for(__rel_time);}\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time) const\x0a"
"            {return __state_->wait_until(__abs_time);}\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(future<_Rp>\x26 __x, future<_Rp>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"// promise<R>\x0a"
"\x0a"
"template <class _Callable> class packaged_task;\x0a"
"\x0a"
"template <class _Rp>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_AVAILABILITY_FUTURE promise\x0a"
"{\x0a"
"    __assoc_state<_Rp>* __state_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit promise(nullptr_t) _NOEXCEPT \x3a __state_(nullptr) {}\x0a"
"\x0a"
"    template <class> friend class packaged_task;\x0a"
"public\x3a\x0a"
"    promise();\x0a"
"    template <class _Alloc>\x0a"
"        promise(allocator_arg_t, const _Alloc\x26 __a);\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    promise(promise\x26\x26 __rhs) _NOEXCEPT\x0a"
"        \x3a __state_(__rhs.__state_) {__rhs.__state_ = nullptr;}\x0a"
"    promise(const promise\x26 __rhs) = delete;\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"private\x3a\x0a"
"    promise(const promise\x26 __rhs);\x0a"
"public\x3a\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    \x7epromise();\x0a"
"\x0a"
"    // assignment\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    promise\x26 operator=(promise\x26\x26 __rhs) _NOEXCEPT\x0a"
"        {\x0a"
"            promise(std\x3a\x3amove(__rhs)).swap(*this);\x0a"
"            return *this;\x0a"
"        }\x0a"
"    promise\x26 operator=(const promise\x26 __rhs) = delete;\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"private\x3a\x0a"
"    promise\x26 operator=(const promise\x26 __rhs);\x0a"
"public\x3a\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(promise\x26 __rhs) _NOEXCEPT {_VSTD\x3a\x3aswap(__state_, __rhs.__state_);}\x0a"
"\x0a"
"    // retrieving the result\x0a"
"    future<_Rp> get_future();\x0a"
"\x0a"
"    // setting the result\x0a"
"    void set_value(const _Rp\x26 __r);\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    void set_value(_Rp\x26\x26 __r);\x0a"
"#endif\x0a"
"    void set_exception(exception_ptr __p);\x0a"
"\x0a"
"    // setting the result with deferred notification\x0a"
"    void set_value_at_thread_exit(const _Rp\x26 __r);\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    void set_value_at_thread_exit(_Rp\x26\x26 __r);\x0a"
"#endif\x0a"
"    void set_exception_at_thread_exit(exception_ptr __p);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"promise<_Rp>\x3a\x3apromise()\x0a"
"    \x3a __state_(new __assoc_state<_Rp>)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"template <class _Alloc>\x0a"
"promise<_Rp>\x3a\x3apromise(allocator_arg_t, const _Alloc\x26 __a0)\x0a"
"{\x0a"
"    typedef __assoc_state_alloc<_Rp, _Alloc> _State;\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, _State>\x3a\x3atype _A2;\x0a"
"    typedef __allocator_destructor<_A2> _D2;\x0a"
"    _A2 __a(__a0);\x0a"
"    unique_ptr<_State, _D2> __hold(__a.allocate(1), _D2(__a, 1));\x0a"
"    \x3a\x3anew(static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold.get()))) _State(__a0);\x0a"
"    __state_ = _VSTD\x3a\x3a""addressof(*__hold.release());\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"promise<_Rp>\x3a\x3a\x7epromise()\x0a"
"{\x0a"
"    if (__state_)\x0a"
"    {\x0a"
"        if (\x21__state_->__has_value() \x26\x26 __state_->use_count() > 1)\x0a"
"            __state_->set_exception(make_exception_ptr(\x0a"
"                      future_error(make_error_code(future_errc\x3a\x3a""broken_promise))\x0a"
"                                                      ));\x0a"
"        __state_->__release_shared();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"future<_Rp>\x0a"
"promise<_Rp>\x3a\x3aget_future()\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    return future<_Rp>(__state_);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"promise<_Rp>\x3a\x3aset_value(const _Rp\x26 __r)\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_value(__r);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"promise<_Rp>\x3a\x3aset_value(_Rp\x26\x26 __r)\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_value(_VSTD\x3a\x3amove(__r));\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"promise<_Rp>\x3a\x3aset_exception(exception_ptr __p)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT( __p \x21= nullptr, \x22promise\x3a\x3aset_exception\x3a received nullptr\x22 );\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_exception(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"promise<_Rp>\x3a\x3aset_value_at_thread_exit(const _Rp\x26 __r)\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_value_at_thread_exit(__r);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"promise<_Rp>\x3a\x3aset_value_at_thread_exit(_Rp\x26\x26 __r)\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_value_at_thread_exit(_VSTD\x3a\x3amove(__r));\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"promise<_Rp>\x3a\x3aset_exception_at_thread_exit(exception_ptr __p)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT( __p \x21= nullptr, \x22promise\x3a\x3aset_exception_at_thread_exit\x3a received nullptr\x22 );\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_exception_at_thread_exit(__p);\x0a"
"}\x0a"
"\x0a"
"// promise<R\x26>\x0a"
"\x0a"
"template <class _Rp>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_AVAILABILITY_FUTURE promise<_Rp\x26>\x0a"
"{\x0a"
"    __assoc_state<_Rp\x26>* __state_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit promise(nullptr_t) _NOEXCEPT \x3a __state_(nullptr) {}\x0a"
"\x0a"
"    template <class> friend class packaged_task;\x0a"
"\x0a"
"public\x3a\x0a"
"    promise();\x0a"
"    template <class _Allocator>\x0a"
"        promise(allocator_arg_t, const _Allocator\x26 __a);\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    promise(promise\x26\x26 __rhs) _NOEXCEPT\x0a"
"        \x3a __state_(__rhs.__state_) {__rhs.__state_ = nullptr;}\x0a"
"    promise(const promise\x26 __rhs) = delete;\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"private\x3a\x0a"
"    promise(const promise\x26 __rhs);\x0a"
"public\x3a\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    \x7epromise();\x0a"
"\x0a"
"    // assignment\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    promise\x26 operator=(promise\x26\x26 __rhs) _NOEXCEPT\x0a"
"        {\x0a"
"            promise(std\x3a\x3amove(__rhs)).swap(*this);\x0a"
"            return *this;\x0a"
"        }\x0a"
"    promise\x26 operator=(const promise\x26 __rhs) = delete;\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"private\x3a\x0a"
"    promise\x26 operator=(const promise\x26 __rhs);\x0a"
"public\x3a\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(promise\x26 __rhs) _NOEXCEPT {_VSTD\x3a\x3aswap(__state_, __rhs.__state_);}\x0a"
"\x0a"
"    // retrieving the result\x0a"
"    future<_Rp\x26> get_future();\x0a"
"\x0a"
"    // setting the result\x0a"
"    void set_value(_Rp\x26 __r);\x0a"
"    void set_exception(exception_ptr __p);\x0a"
"\x0a"
"    // setting the result with deferred notification\x0a"
"    void set_value_at_thread_exit(_Rp\x26);\x0a"
"    void set_exception_at_thread_exit(exception_ptr __p);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"promise<_Rp\x26>\x3a\x3apromise()\x0a"
"    \x3a __state_(new __assoc_state<_Rp\x26>)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"template <class _Alloc>\x0a"
"promise<_Rp\x26>\x3a\x3apromise(allocator_arg_t, const _Alloc\x26 __a0)\x0a"
"{\x0a"
"    typedef __assoc_state_alloc<_Rp\x26, _Alloc> _State;\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, _State>\x3a\x3atype _A2;\x0a"
"    typedef __allocator_destructor<_A2> _D2;\x0a"
"    _A2 __a(__a0);\x0a"
"    unique_ptr<_State, _D2> __hold(__a.allocate(1), _D2(__a, 1));\x0a"
"    \x3a\x3anew(static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold.get()))) _State(__a0);\x0a"
"    __state_ = _VSTD\x3a\x3a""addressof(*__hold.release());\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"promise<_Rp\x26>\x3a\x3a\x7epromise()\x0a"
"{\x0a"
"    if (__state_)\x0a"
"    {\x0a"
"        if (\x21__state_->__has_value() \x26\x26 __state_->use_count() > 1)\x0a"
"            __state_->set_exception(make_exception_ptr(\x0a"
"                      future_error(make_error_code(future_errc\x3a\x3a""broken_promise))\x0a"
"                                                      ));\x0a"
"        __state_->__release_shared();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"future<_Rp\x26>\x0a"
"promise<_Rp\x26>\x3a\x3aget_future()\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    return future<_Rp\x26>(__state_);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"promise<_Rp\x26>\x3a\x3aset_value(_Rp\x26 __r)\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_value(__r);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"promise<_Rp\x26>\x3a\x3aset_exception(exception_ptr __p)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT( __p \x21= nullptr, \x22promise\x3a\x3aset_exception\x3a received nullptr\x22 );\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_exception(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"promise<_Rp\x26>\x3a\x3aset_value_at_thread_exit(_Rp\x26 __r)\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_value_at_thread_exit(__r);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"void\x0a"
"promise<_Rp\x26>\x3a\x3aset_exception_at_thread_exit(exception_ptr __p)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT( __p \x21= nullptr, \x22promise\x3a\x3aset_exception_at_thread_exit\x3a received nullptr\x22 );\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_exception_at_thread_exit(__p);\x0a"
"}\x0a"
"\x0a"
"// promise<void>\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS _LIBCPP_AVAILABILITY_FUTURE promise<void>\x0a"
"{\x0a"
"    __assoc_sub_state* __state_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit promise(nullptr_t) _NOEXCEPT \x3a __state_(nullptr) {}\x0a"
"\x0a"
"    template <class> friend class packaged_task;\x0a"
"\x0a"
"public\x3a\x0a"
"    promise();\x0a"
"    template <class _Allocator>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        promise(allocator_arg_t, const _Allocator\x26 __a);\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    promise(promise\x26\x26 __rhs) _NOEXCEPT\x0a"
"        \x3a __state_(__rhs.__state_) {__rhs.__state_ = nullptr;}\x0a"
"    promise(const promise\x26 __rhs) = delete;\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"private\x3a\x0a"
"    promise(const promise\x26 __rhs);\x0a"
"public\x3a\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    \x7epromise();\x0a"
"\x0a"
"    // assignment\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    promise\x26 operator=(promise\x26\x26 __rhs) _NOEXCEPT\x0a"
"        {\x0a"
"            promise(std\x3a\x3amove(__rhs)).swap(*this);\x0a"
"            return *this;\x0a"
"        }\x0a"
"    promise\x26 operator=(const promise\x26 __rhs) = delete;\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"private\x3a\x0a"
"    promise\x26 operator=(const promise\x26 __rhs);\x0a"
"public\x3a\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(promise\x26 __rhs) _NOEXCEPT {_VSTD\x3a\x3aswap(__state_, __rhs.__state_);}\x0a"
"\x0a"
"    // retrieving the result\x0a"
"    future<void> get_future();\x0a"
"\x0a"
"    // setting the result\x0a"
"    void set_value();\x0a"
"    void set_exception(exception_ptr __p);\x0a"
"\x0a"
"    // setting the result with deferred notification\x0a"
"    void set_value_at_thread_exit();\x0a"
"    void set_exception_at_thread_exit(exception_ptr __p);\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"promise<void>\x3a\x3apromise(allocator_arg_t, const _Alloc\x26 __a0)\x0a"
"{\x0a"
"    typedef __assoc_sub_state_alloc<_Alloc> _State;\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, _State>\x3a\x3atype _A2;\x0a"
"    typedef __allocator_destructor<_A2> _D2;\x0a"
"    _A2 __a(__a0);\x0a"
"    unique_ptr<_State, _D2> __hold(__a.allocate(1), _D2(__a, 1));\x0a"
"    \x3a\x3anew(static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold.get()))) _State(__a0);\x0a"
"    __state_ = _VSTD\x3a\x3a""addressof(*__hold.release());\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(promise<_Rp>\x26 __x, promise<_Rp>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp, class _Alloc>\x0a"
"    struct _LIBCPP_TEMPLATE_VIS uses_allocator<promise<_Rp>, _Alloc>\x0a"
"        \x3a public true_type {};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"// packaged_task\x0a"
"\x0a"
"template<class _Fp> class __packaged_task_base;\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __packaged_task_base<_Rp(_ArgTypes...)>\x0a"
"{\x0a"
"    __packaged_task_base(const __packaged_task_base\x26);\x0a"
"    __packaged_task_base\x26 operator=(const __packaged_task_base\x26);\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __packaged_task_base() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    virtual \x7e__packaged_task_base() {}\x0a"
"    virtual void __move_to(__packaged_task_base*) _NOEXCEPT = 0;\x0a"
"    virtual void destroy() = 0;\x0a"
"    virtual void destroy_deallocate() = 0;\x0a"
"    virtual _Rp operator()(_ArgTypes\x26\x26 ...) = 0;\x0a"
"};\x0a"
"\x0a"
"template<class _FD, class _Alloc, class _FB> class __packaged_task_func;\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __packaged_task_func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x0a"
"    \x3a public  __packaged_task_base<_Rp(_ArgTypes...)>\x0a"
"{\x0a"
"    __compressed_pair<_Fp, _Alloc> __f_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __packaged_task_func(const _Fp\x26 __f) \x3a __f_(__f) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __packaged_task_func(_Fp\x26\x26 __f) \x3a __f_(_VSTD\x3a\x3amove(__f)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __packaged_task_func(const _Fp\x26 __f, const _Alloc\x26 __a)\x0a"
"        \x3a __f_(__f, __a) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __packaged_task_func(_Fp\x26\x26 __f, const _Alloc\x26 __a)\x0a"
"        \x3a __f_(_VSTD\x3a\x3amove(__f), __a) {}\x0a"
"    virtual void __move_to(__packaged_task_base<_Rp(_ArgTypes...)>*) _NOEXCEPT;\x0a"
"    virtual void destroy();\x0a"
"    virtual void destroy_deallocate();\x0a"
"    virtual _Rp operator()(_ArgTypes\x26\x26 ... __args);\x0a"
"};\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"__packaged_task_func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3a__move_to(\x0a"
"                              __packaged_task_base<_Rp(_ArgTypes...)>* __p) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3anew (__p) __packaged_task_func(_VSTD\x3a\x3amove(__f_.first()), _VSTD\x3a\x3amove(__f_.second()));\x0a"
"}\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"__packaged_task_func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3a""destroy()\x0a"
"{\x0a"
"    __f_.\x7e__compressed_pair<_Fp, _Alloc>();\x0a"
"}\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"__packaged_task_func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3a""destroy_deallocate()\x0a"
"{\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, __packaged_task_func>\x3a\x3atype _Ap;\x0a"
"    typedef allocator_traits<_Ap> _ATraits;\x0a"
"    typedef pointer_traits<typename _ATraits\x3a\x3apointer> _PTraits;\x0a"
"    _Ap __a(__f_.second());\x0a"
"    __f_.\x7e__compressed_pair<_Fp, _Alloc>();\x0a"
"    __a.deallocate(_PTraits\x3a\x3apointer_to(*this), 1);\x0a"
"}\x0a"
"\x0a"
"template<class _Fp, class _Alloc, class _Rp, class ..._ArgTypes>\x0a"
"_Rp\x0a"
"__packaged_task_func<_Fp, _Alloc, _Rp(_ArgTypes...)>\x3a\x3aoperator()(_ArgTypes\x26\x26 ... __arg)\x0a"
"{\x0a"
"    return __invoke(__f_.first(), _VSTD\x3a\x3a""forward<_ArgTypes>(__arg)...);\x0a"
"}\x0a"
"\x0a"
"template <class _Callable> class __packaged_task_function;\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"class _LIBCPP_AVAILABILITY_FUTURE __packaged_task_function<_Rp(_ArgTypes...)>\x0a"
"{\x0a"
"    typedef __packaged_task_base<_Rp(_ArgTypes...)> __base;\x0a"
"    typename aligned_storage<3*sizeof(void*)>\x3a\x3atype __buf_;\x0a"
"    __base* __f_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _Rp result_type;\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __packaged_task_function() _NOEXCEPT \x3a __f_(nullptr) {}\x0a"
"    template<class _Fp>\x0a"
"      __packaged_task_function(_Fp\x26\x26 __f);\x0a"
"    template<class _Fp, class _Alloc>\x0a"
"      __packaged_task_function(allocator_arg_t, const _Alloc\x26 __a, _Fp\x26\x26 __f);\x0a"
"\x0a"
"    __packaged_task_function(__packaged_task_function\x26\x26) _NOEXCEPT;\x0a"
"    __packaged_task_function\x26 operator=(__packaged_task_function\x26\x26) _NOEXCEPT;\x0a"
"\x0a"
"    __packaged_task_function(const __packaged_task_function\x26) =  delete;\x0a"
"    __packaged_task_function\x26 operator=(const __packaged_task_function\x26) =  delete;\x0a"
"\x0a"
"    \x7e__packaged_task_function();\x0a"
"\x0a"
"    void swap(__packaged_task_function\x26) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Rp operator()(_ArgTypes...) const;\x0a"
"};\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"__packaged_task_function<_Rp(_ArgTypes...)>\x3a\x3a__packaged_task_function(__packaged_task_function\x26\x26 __f) _NOEXCEPT\x0a"
"{\x0a"
"    if (__f.__f_ == nullptr)\x0a"
"        __f_ = nullptr;\x0a"
"    else if (__f.__f_ == (__base*)\x26__f.__buf_)\x0a"
"    {\x0a"
"        __f_ = (__base*)\x26__buf_;\x0a"
"        __f.__f_->__move_to(__f_);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __f_ = __f.__f_;\x0a"
"        __f.__f_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"template <class _Fp>\x0a"
"__packaged_task_function<_Rp(_ArgTypes...)>\x3a\x3a__packaged_task_function(_Fp\x26\x26 __f)\x0a"
"    \x3a __f_(nullptr)\x0a"
"{\x0a"
"    typedef typename remove_reference<typename decay<_Fp>\x3a\x3atype>\x3a\x3atype _FR;\x0a"
"    typedef __packaged_task_func<_FR, allocator<_FR>, _Rp(_ArgTypes...)> _FF;\x0a"
"    if (sizeof(_FF) <= sizeof(__buf_))\x0a"
"    {\x0a"
"        __f_ = (__base*)\x26__buf_;\x0a"
"        \x3a\x3anew (__f_) _FF(_VSTD\x3a\x3a""forward<_Fp>(__f));\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        typedef allocator<_FF> _Ap;\x0a"
"        _Ap __a;\x0a"
"        typedef __allocator_destructor<_Ap> _Dp;\x0a"
"        unique_ptr<__base, _Dp> __hold(__a.allocate(1), _Dp(__a, 1));\x0a"
"        \x3a\x3anew (__hold.get()) _FF(_VSTD\x3a\x3a""forward<_Fp>(__f), allocator<_FR>(__a));\x0a"
"        __f_ = __hold.release();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"template <class _Fp, class _Alloc>\x0a"
"__packaged_task_function<_Rp(_ArgTypes...)>\x3a\x3a__packaged_task_function(\x0a"
"                                  allocator_arg_t, const _Alloc\x26 __a0, _Fp\x26\x26 __f)\x0a"
"    \x3a __f_(nullptr)\x0a"
"{\x0a"
"    typedef typename remove_reference<typename decay<_Fp>\x3a\x3atype>\x3a\x3atype _FR;\x0a"
"    typedef __packaged_task_func<_FR, _Alloc, _Rp(_ArgTypes...)> _FF;\x0a"
"    if (sizeof(_FF) <= sizeof(__buf_))\x0a"
"    {\x0a"
"        __f_ = (__base*)\x26__buf_;\x0a"
"        \x3a\x3anew (__f_) _FF(_VSTD\x3a\x3a""forward<_Fp>(__f));\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        typedef typename __allocator_traits_rebind<_Alloc, _FF>\x3a\x3atype _Ap;\x0a"
"        _Ap __a(__a0);\x0a"
"        typedef __allocator_destructor<_Ap> _Dp;\x0a"
"        unique_ptr<__base, _Dp> __hold(__a.allocate(1), _Dp(__a, 1));\x0a"
"        \x3a\x3anew (static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold.get())))\x0a"
"            _FF(_VSTD\x3a\x3a""forward<_Fp>(__f), _Alloc(__a));\x0a"
"        __f_ = _VSTD\x3a\x3a""addressof(*__hold.release());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"__packaged_task_function<_Rp(_ArgTypes...)>\x26\x0a"
"__packaged_task_function<_Rp(_ArgTypes...)>\x3a\x3aoperator=(__packaged_task_function\x26\x26 __f) _NOEXCEPT\x0a"
"{\x0a"
"    if (__f_ == (__base*)\x26__buf_)\x0a"
"        __f_->destroy();\x0a"
"    else if (__f_)\x0a"
"        __f_->destroy_deallocate();\x0a"
"    __f_ = nullptr;\x0a"
"    if (__f.__f_ == nullptr)\x0a"
"        __f_ = nullptr;\x0a"
"    else if (__f.__f_ == (__base*)\x26__f.__buf_)\x0a"
"    {\x0a"
"        __f_ = (__base*)\x26__buf_;\x0a"
"        __f.__f_->__move_to(__f_);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __f_ = __f.__f_;\x0a"
"        __f.__f_ = nullptr;\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"__packaged_task_function<_Rp(_ArgTypes...)>\x3a\x3a\x7e__packaged_task_function()\x0a"
"{\x0a"
"    if (__f_ == (__base*)\x26__buf_)\x0a"
"        __f_->destroy();\x0a"
"    else if (__f_)\x0a"
"        __f_->destroy_deallocate();\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"__packaged_task_function<_Rp(_ArgTypes...)>\x3a\x3aswap(__packaged_task_function\x26 __f) _NOEXCEPT\x0a"
"{\x0a"
"    if (__f_ == (__base*)\x26__buf_ \x26\x26 __f.__f_ == (__base*)\x26__f.__buf_)\x0a"
"    {\x0a"
"        typename aligned_storage<sizeof(__buf_)>\x3a\x3atype __tempbuf;\x0a"
"        __base* __t = (__base*)\x26__tempbuf;\x0a"
"        __f_->__move_to(__t);\x0a"
"        __f_->destroy();\x0a"
"        __f_ = nullptr;\x0a"
"        __f.__f_->__move_to((__base*)\x26__buf_);\x0a"
"        __f.__f_->destroy();\x0a"
"        __f.__f_ = nullptr;\x0a"
"        __f_ = (__base*)\x26__buf_;\x0a"
"        __t->__move_to((__base*)\x26__f.__buf_);\x0a"
"        __t->destroy();\x0a"
"        __f.__f_ = (__base*)\x26__f.__buf_;\x0a"
"    }\x0a"
"    else if (__f_ == (__base*)\x26__buf_)\x0a"
"    {\x0a"
"        __f_->__move_to((__base*)\x26__f.__buf_);\x0a"
"        __f_->destroy();\x0a"
"        __f_ = __f.__f_;\x0a"
"        __f.__f_ = (__base*)\x26__f.__buf_;\x0a"
"    }\x0a"
"    else if (__f.__f_ == (__base*)\x26__f.__buf_)\x0a"
"    {\x0a"
"        __f.__f_->__move_to((__base*)\x26__buf_);\x0a"
"        __f.__f_->destroy();\x0a"
"        __f.__f_ = __f_;\x0a"
"        __f_ = (__base*)\x26__buf_;\x0a"
"    }\x0a"
"    else\x0a"
"        _VSTD\x3a\x3aswap(__f_, __f.__f_);\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"inline\x0a"
"_Rp\x0a"
"__packaged_task_function<_Rp(_ArgTypes...)>\x3a\x3aoperator()(_ArgTypes... __arg) const\x0a"
"{\x0a"
"    return (*__f_)(_VSTD\x3a\x3a""forward<_ArgTypes>(__arg)...);\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_AVAILABILITY_FUTURE packaged_task<_Rp(_ArgTypes...)>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Rp result_type; // extension\x0a"
"\x0a"
"private\x3a\x0a"
"    __packaged_task_function<result_type(_ArgTypes...)> __f_;\x0a"
"    promise<result_type>                                __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // construction and destruction\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    packaged_task() _NOEXCEPT \x3a __p_(nullptr) {}\x0a"
"    template <class _Fp,\x0a"
"              class = typename enable_if\x0a"
"              <\x0a"
"                  \x21is_same<\x0a"
"                      typename __uncvref<_Fp>\x3a\x3atype,\x0a"
"                      packaged_task\x0a"
"                      >\x3a\x3avalue\x0a"
"                  >\x3a\x3atype\x0a"
"             >\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit packaged_task(_Fp\x26\x26 __f) \x3a __f_(_VSTD\x3a\x3a""forward<_Fp>(__f)) {}\x0a"
"    template <class _Fp, class _Allocator,\x0a"
"              class = typename enable_if\x0a"
"              <\x0a"
"                  \x21is_same<\x0a"
"                      typename __uncvref<_Fp>\x3a\x3atype,\x0a"
"                      packaged_task\x0a"
"                      >\x3a\x3avalue\x0a"
"                  >\x3a\x3atype\x0a"
"              >\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        packaged_task(allocator_arg_t, const _Allocator\x26 __a, _Fp\x26\x26 __f)\x0a"
"             \x3a __f_(allocator_arg, __a, _VSTD\x3a\x3a""forward<_Fp>(__f)),\x0a"
"               __p_(allocator_arg, __a) {}\x0a"
"    // \x7epackaged_task() = default;\x0a"
"\x0a"
"    // no copy\x0a"
"    packaged_task(const packaged_task\x26) = delete;\x0a"
"    packaged_task\x26 operator=(const packaged_task\x26) = delete;\x0a"
"\x0a"
"    // move support\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    packaged_task(packaged_task\x26\x26 __other) _NOEXCEPT\x0a"
"        \x3a __f_(_VSTD\x3a\x3amove(__other.__f_)), __p_(_VSTD\x3a\x3amove(__other.__p_)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    packaged_task\x26 operator=(packaged_task\x26\x26 __other) _NOEXCEPT\x0a"
"    {\x0a"
"        __f_ = _VSTD\x3a\x3amove(__other.__f_);\x0a"
"        __p_ = _VSTD\x3a\x3amove(__other.__p_);\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(packaged_task\x26 __other) _NOEXCEPT\x0a"
"    {\x0a"
"        __f_.swap(__other.__f_);\x0a"
"        __p_.swap(__other.__p_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool valid() const _NOEXCEPT {return __p_.__state_ \x21= nullptr;}\x0a"
"\x0a"
"    // result retrieval\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future<result_type> get_future() {return __p_.get_future();}\x0a"
"\x0a"
"    // execution\x0a"
"    void operator()(_ArgTypes... __args);\x0a"
"    void make_ready_at_thread_exit(_ArgTypes... __args);\x0a"
"\x0a"
"    void reset();\x0a"
"};\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"packaged_task<_Rp(_ArgTypes...)>\x3a\x3aoperator()(_ArgTypes... __args)\x0a"
"{\x0a"
"    if (__p_.__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    if (__p_.__state_->__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __p_.set_value(__f_(_VSTD\x3a\x3a""forward<_ArgTypes>(__args)...));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __p_.set_exception(current_exception());\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"packaged_task<_Rp(_ArgTypes...)>\x3a\x3amake_ready_at_thread_exit(_ArgTypes... __args)\x0a"
"{\x0a"
"    if (__p_.__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    if (__p_.__state_->__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __p_.set_value_at_thread_exit(__f_(_VSTD\x3a\x3a""forward<_ArgTypes>(__args)...));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __p_.set_exception_at_thread_exit(current_exception());\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template<class _Rp, class ..._ArgTypes>\x0a"
"void\x0a"
"packaged_task<_Rp(_ArgTypes...)>\x3a\x3areset()\x0a"
"{\x0a"
"    if (\x21valid())\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __p_ = promise<result_type>();\x0a"
"}\x0a"
"\x0a"
"template<class ..._ArgTypes>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_AVAILABILITY_FUTURE packaged_task<void(_ArgTypes...)>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef void result_type; // extension\x0a"
"\x0a"
"private\x3a\x0a"
"    __packaged_task_function<result_type(_ArgTypes...)> __f_;\x0a"
"    promise<result_type>                                __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // construction and destruction\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    packaged_task() _NOEXCEPT \x3a __p_(nullptr) {}\x0a"
"    template <class _Fp,\x0a"
"              class = typename enable_if\x0a"
"              <\x0a"
"                  \x21is_same<\x0a"
"                      typename __uncvref<_Fp>\x3a\x3atype,\x0a"
"                      packaged_task\x0a"
"                      >\x3a\x3avalue\x0a"
"                  >\x3a\x3atype\x0a"
"              >\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit packaged_task(_Fp\x26\x26 __f) \x3a __f_(_VSTD\x3a\x3a""forward<_Fp>(__f)) {}\x0a"
"    template <class _Fp, class _Allocator,\x0a"
"              class = typename enable_if\x0a"
"              <\x0a"
"                  \x21is_same<\x0a"
"                      typename __uncvref<_Fp>\x3a\x3atype,\x0a"
"                      packaged_task\x0a"
"                      >\x3a\x3avalue\x0a"
"                  >\x3a\x3atype\x0a"
"              >\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        packaged_task(allocator_arg_t, const _Allocator\x26 __a, _Fp\x26\x26 __f)\x0a"
"             \x3a __f_(allocator_arg, __a, _VSTD\x3a\x3a""forward<_Fp>(__f)),\x0a"
"               __p_(allocator_arg, __a) {}\x0a"
"    // \x7epackaged_task() = default;\x0a"
"\x0a"
"    // no copy\x0a"
"    packaged_task(const packaged_task\x26) = delete;\x0a"
"    packaged_task\x26 operator=(const packaged_task\x26) = delete;\x0a"
"\x0a"
"    // move support\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    packaged_task(packaged_task\x26\x26 __other) _NOEXCEPT\x0a"
"        \x3a __f_(_VSTD\x3a\x3amove(__other.__f_)), __p_(_VSTD\x3a\x3amove(__other.__p_)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    packaged_task\x26 operator=(packaged_task\x26\x26 __other) _NOEXCEPT\x0a"
"    {\x0a"
"        __f_ = _VSTD\x3a\x3amove(__other.__f_);\x0a"
"        __p_ = _VSTD\x3a\x3amove(__other.__p_);\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(packaged_task\x26 __other) _NOEXCEPT\x0a"
"    {\x0a"
"        __f_.swap(__other.__f_);\x0a"
"        __p_.swap(__other.__p_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool valid() const _NOEXCEPT {return __p_.__state_ \x21= nullptr;}\x0a"
"\x0a"
"    // result retrieval\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    future<result_type> get_future() {return __p_.get_future();}\x0a"
"\x0a"
"    // execution\x0a"
"    void operator()(_ArgTypes... __args);\x0a"
"    void make_ready_at_thread_exit(_ArgTypes... __args);\x0a"
"\x0a"
"    void reset();\x0a"
"};\x0a"
"\x0a"
"template<class ..._ArgTypes>\x0a"
"void\x0a"
"packaged_task<void(_ArgTypes...)>\x3a\x3aoperator()(_ArgTypes... __args)\x0a"
"{\x0a"
"    if (__p_.__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    if (__p_.__state_->__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __f_(_VSTD\x3a\x3a""forward<_ArgTypes>(__args)...);\x0a"
"        __p_.set_value();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __p_.set_exception(current_exception());\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template<class ..._ArgTypes>\x0a"
"void\x0a"
"packaged_task<void(_ArgTypes...)>\x3a\x3amake_ready_at_thread_exit(_ArgTypes... __args)\x0a"
"{\x0a"
"    if (__p_.__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    if (__p_.__state_->__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __f_(_VSTD\x3a\x3a""forward<_ArgTypes>(__args)...);\x0a"
"        __p_.set_value_at_thread_exit();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __p_.set_exception_at_thread_exit(current_exception());\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template<class ..._ArgTypes>\x0a"
"void\x0a"
"packaged_task<void(_ArgTypes...)>\x3a\x3areset()\x0a"
"{\x0a"
"    if (\x21valid())\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __p_ = promise<result_type>();\x0a"
"}\x0a"
"\x0a"
"template <class _Callable>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(packaged_task<_Callable>\x26 __x, packaged_task<_Callable>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Callable, class _Alloc>\x0a"
"struct _LIBCPP_TEMPLATE_VIS uses_allocator<packaged_task<_Callable>, _Alloc>\x0a"
"    \x3a public true_type {};\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"future<_Rp>\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"__make_deferred_assoc_state(_Fp\x26\x26 __f)\x0a"
"#else\x0a"
"__make_deferred_assoc_state(_Fp __f)\x0a"
"#endif\x0a"
"{\x0a"
"    unique_ptr<__deferred_assoc_state<_Rp, _Fp>, __release_shared_count>\x0a"
"        __h(new __deferred_assoc_state<_Rp, _Fp>(_VSTD\x3a\x3a""forward<_Fp>(__f)));\x0a"
"    return future<_Rp>(__h.get());\x0a"
"}\x0a"
"\x0a"
"template <class _Rp, class _Fp>\x0a"
"future<_Rp>\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"__make_async_assoc_state(_Fp\x26\x26 __f)\x0a"
"#else\x0a"
"__make_async_assoc_state(_Fp __f)\x0a"
"#endif\x0a"
"{\x0a"
"    unique_ptr<__async_assoc_state<_Rp, _Fp>, __release_shared_count>\x0a"
"        __h(new __async_assoc_state<_Rp, _Fp>(_VSTD\x3a\x3a""forward<_Fp>(__f)));\x0a"
"    _VSTD\x3a\x3athread(\x26__async_assoc_state<_Rp, _Fp>\x3a\x3a__execute, __h.get()).detach();\x0a"
"    return future<_Rp>(__h.get());\x0a"
"}\x0a"
"\x0a"
"template <class _Fp, class... _Args>\x0a"
"class __async_func\x0a"
"{\x0a"
"    tuple<_Fp, _Args...> __f_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __invoke_of<_Fp, _Args...>\x3a\x3atype _Rp;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __async_func(_Fp\x26\x26 __f, _Args\x26\x26... __args)\x0a"
"        \x3a __f_(_VSTD\x3a\x3amove(__f), _VSTD\x3a\x3amove(__args)...) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __async_func(__async_func\x26\x26 __f) \x3a __f_(_VSTD\x3a\x3amove(__f.__f_)) {}\x0a"
"\x0a"
"    _Rp operator()()\x0a"
"    {\x0a"
"        typedef typename __make_tuple_indices<1+sizeof...(_Args), 1>\x3a\x3atype _Index;\x0a"
"        return __execute(_Index());\x0a"
"    }\x0a"
"private\x3a\x0a"
"    template <size_t ..._Indices>\x0a"
"    _Rp\x0a"
"    __execute(__tuple_indices<_Indices...>)\x0a"
"    {\x0a"
"        return __invoke(_VSTD\x3a\x3amove(_VSTD\x3a\x3aget<0>(__f_)), _VSTD\x3a\x3amove(_VSTD\x3a\x3aget<_Indices>(__f_))...);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY bool __does_policy_contain(launch __policy, launch __value )\x0a"
"{ return (int(__policy) \x26 int(__value)) \x21= 0; }\x0a"
"\x0a"
"template <class _Fp, class... _Args>\x0a"
"_LIBCPP_NODISCARD_AFTER_CXX17\x0a"
"future<typename __invoke_of<typename decay<_Fp>\x3a\x3atype, typename decay<_Args>\x3a\x3atype...>\x3a\x3atype>\x0a"
"async(launch __policy, _Fp\x26\x26 __f, _Args\x26\x26... __args)\x0a"
"{\x0a"
"    typedef __async_func<typename decay<_Fp>\x3a\x3atype, typename decay<_Args>\x3a\x3atype...> _BF;\x0a"
"    typedef typename _BF\x3a\x3a_Rp _Rp;\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif\x0a"
"        if (__does_policy_contain(__policy, launch\x3a\x3a""async))\x0a"
"        return _VSTD\x3a\x3a__make_async_assoc_state<_Rp>(_BF(__decay_copy(_VSTD\x3a\x3a""forward<_Fp>(__f)),\x0a"
"                                                     __decay_copy(_VSTD\x3a\x3a""forward<_Args>(__args))...));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch ( ... ) { if (__policy == launch\x3a\x3a""async) throw ; }\x0a"
"#endif\x0a"
"\x0a"
"    if (__does_policy_contain(__policy, launch\x3a\x3a""deferred))\x0a"
"        return _VSTD\x3a\x3a__make_deferred_assoc_state<_Rp>(_BF(__decay_copy(_VSTD\x3a\x3a""forward<_Fp>(__f)),\x0a"
"                                                        __decay_copy(_VSTD\x3a\x3a""forward<_Args>(__args))...));\x0a"
"    return future<_Rp>{};\x0a"
"}\x0a"
"\x0a"
"template <class _Fp, class... _Args>\x0a"
"_LIBCPP_NODISCARD_AFTER_CXX17 inline _LIBCPP_INLINE_VISIBILITY\x0a"
"future<typename __invoke_of<typename decay<_Fp>\x3a\x3atype, typename decay<_Args>\x3a\x3atype...>\x3a\x3atype>\x0a"
"async(_Fp\x26\x26 __f, _Args\x26\x26... __args)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""async(launch\x3a\x3a""any, _VSTD\x3a\x3a""forward<_Fp>(__f),\x0a"
"                                    _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"// shared_future\x0a"
"\x0a"
"template <class _Rp>\x0a"
"class _LIBCPP_TEMPLATE_VIS shared_future\x0a"
"{\x0a"
"    __assoc_state<_Rp>* __state_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future() _NOEXCEPT \x3a __state_(nullptr) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future(const shared_future\x26 __rhs)  _NOEXCEPT \x3a __state_(__rhs.__state_)\x0a"
"        {if (__state_) __state_->__add_shared();}\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future(future<_Rp>\x26\x26 __f) _NOEXCEPT \x3a __state_(__f.__state_)\x0a"
"        {__f.__state_ = nullptr;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future(shared_future\x26\x26 __rhs) _NOEXCEPT \x3a __state_(__rhs.__state_)\x0a"
"        {__rhs.__state_ = nullptr;}\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    \x7eshared_future();\x0a"
"    shared_future\x26 operator=(const shared_future\x26 __rhs) _NOEXCEPT;\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future\x26 operator=(shared_future\x26\x26 __rhs) _NOEXCEPT\x0a"
"        {\x0a"
"            shared_future(std\x3a\x3amove(__rhs)).swap(*this);\x0a"
"            return *this;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Rp\x26 get() const {return __state_->copy();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(shared_future\x26 __rhs) _NOEXCEPT {_VSTD\x3a\x3aswap(__state_, __rhs.__state_);}\x0a"
"\x0a"
"    // functions to check state\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool valid() const _NOEXCEPT {return __state_ \x21= nullptr;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void wait() const {__state_->wait();}\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time) const\x0a"
"            {return __state_->wait_for(__rel_time);}\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time) const\x0a"
"            {return __state_->wait_until(__abs_time);}\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"shared_future<_Rp>\x3a\x3a\x7eshared_future()\x0a"
"{\x0a"
"    if (__state_)\x0a"
"        __state_->__release_shared();\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"shared_future<_Rp>\x26\x0a"
"shared_future<_Rp>\x3a\x3aoperator=(const shared_future\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    if (__rhs.__state_)\x0a"
"        __rhs.__state_->__add_shared();\x0a"
"    if (__state_)\x0a"
"        __state_->__release_shared();\x0a"
"    __state_ = __rhs.__state_;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"class _LIBCPP_TEMPLATE_VIS shared_future<_Rp\x26>\x0a"
"{\x0a"
"    __assoc_state<_Rp\x26>* __state_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future() _NOEXCEPT \x3a __state_(nullptr) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future(const shared_future\x26 __rhs) \x3a __state_(__rhs.__state_)\x0a"
"        {if (__state_) __state_->__add_shared();}\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future(future<_Rp\x26>\x26\x26 __f) _NOEXCEPT \x3a __state_(__f.__state_)\x0a"
"        {__f.__state_ = nullptr;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future(shared_future\x26\x26 __rhs) _NOEXCEPT \x3a __state_(__rhs.__state_)\x0a"
"        {__rhs.__state_ = nullptr;}\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    \x7eshared_future();\x0a"
"    shared_future\x26 operator=(const shared_future\x26 __rhs);\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future\x26 operator=(shared_future\x26\x26 __rhs) _NOEXCEPT\x0a"
"        {\x0a"
"            shared_future(std\x3a\x3amove(__rhs)).swap(*this);\x0a"
"            return *this;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Rp\x26 get() const {return __state_->copy();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(shared_future\x26 __rhs) _NOEXCEPT {_VSTD\x3a\x3aswap(__state_, __rhs.__state_);}\x0a"
"\x0a"
"    // functions to check state\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool valid() const _NOEXCEPT {return __state_ \x21= nullptr;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void wait() const {__state_->wait();}\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time) const\x0a"
"            {return __state_->wait_for(__rel_time);}\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time) const\x0a"
"            {return __state_->wait_until(__abs_time);}\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"shared_future<_Rp\x26>\x3a\x3a\x7eshared_future()\x0a"
"{\x0a"
"    if (__state_)\x0a"
"        __state_->__release_shared();\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"shared_future<_Rp\x26>\x26\x0a"
"shared_future<_Rp\x26>\x3a\x3aoperator=(const shared_future\x26 __rhs)\x0a"
"{\x0a"
"    if (__rhs.__state_)\x0a"
"        __rhs.__state_->__add_shared();\x0a"
"    if (__state_)\x0a"
"        __state_->__release_shared();\x0a"
"    __state_ = __rhs.__state_;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TYPE_VIS _LIBCPP_AVAILABILITY_FUTURE shared_future<void>\x0a"
"{\x0a"
"    __assoc_sub_state* __state_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future() _NOEXCEPT \x3a __state_(nullptr) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future(const shared_future\x26 __rhs) \x3a __state_(__rhs.__state_)\x0a"
"        {if (__state_) __state_->__add_shared();}\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future(future<void>\x26\x26 __f) _NOEXCEPT \x3a __state_(__f.__state_)\x0a"
"        {__f.__state_ = nullptr;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future(shared_future\x26\x26 __rhs) _NOEXCEPT \x3a __state_(__rhs.__state_)\x0a"
"        {__rhs.__state_ = nullptr;}\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    \x7eshared_future();\x0a"
"    shared_future\x26 operator=(const shared_future\x26 __rhs);\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_future\x26 operator=(shared_future\x26\x26 __rhs) _NOEXCEPT\x0a"
"        {\x0a"
"            shared_future(std\x3a\x3amove(__rhs)).swap(*this);\x0a"
"            return *this;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"    // retrieving the value\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void get() const {__state_->copy();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(shared_future\x26 __rhs) _NOEXCEPT {_VSTD\x3a\x3aswap(__state_, __rhs.__state_);}\x0a"
"\x0a"
"    // functions to check state\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool valid() const _NOEXCEPT {return __state_ \x21= nullptr;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void wait() const {__state_->wait();}\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time) const\x0a"
"            {return __state_->wait_for(__rel_time);}\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        future_status\x0a"
"        wait_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time) const\x0a"
"            {return __state_->wait_until(__abs_time);}\x0a"
"};\x0a"
"\x0a"
"template <class _Rp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(shared_future<_Rp>\x26 __x, shared_future<_Rp>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"inline\x0a"
"shared_future<_Rp>\x0a"
"future<_Rp>\x3a\x3ashare() _NOEXCEPT\x0a"
"{\x0a"
"    return shared_future<_Rp>(_VSTD\x3a\x3amove(*this));\x0a"
"}\x0a"
"\x0a"
"template <class _Rp>\x0a"
"inline\x0a"
"shared_future<_Rp\x26>\x0a"
"future<_Rp\x26>\x3a\x3ashare() _NOEXCEPT\x0a"
"{\x0a"
"    return shared_future<_Rp\x26>(_VSTD\x3a\x3amove(*this));\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"inline\x0a"
"shared_future<void>\x0a"
"future<void>\x3a\x3ashare() _NOEXCEPT\x0a"
"{\x0a"
"    return shared_future<void>(_VSTD\x3a\x3amove(*this));\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"#endif  // _LIBCPP_FUTURE\x0a"
"", 72374 ); }