#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_initializer_list( 
"// -*- C++ -*-\x0a"
"//===----------------------- initializer_list -----------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_INITIALIZER_LIST\x0a"
"#define _LIBCPP_INITIALIZER_LIST\x0a"
"\x0a"
"/*\x0a"
"    initializer_list synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template<class E>\x0a"
"class initializer_list\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef E        value_type;\x0a"
"    typedef const E\x26 reference;\x0a"
"    typedef const E\x26 const_reference;\x0a"
"    typedef size_t   size_type;\x0a"
"\x0a"
"    typedef const E* iterator;\x0a"
"    typedef const E* const_iterator;\x0a"
"\x0a"
"    initializer_list() noexcept; // constexpr in C++14\x0a"
"\x0a"
"    size_t   size()  const noexcept; // constexpr in C++14\x0a"
"    const E* begin() const noexcept; // constexpr in C++14\x0a"
"    const E* end()   const noexcept; // constexpr in C++14\x0a"
"};\x0a"
"\x0a"
"template<class E> const E* begin(initializer_list<E> il) noexcept; // constexpr in C++14\x0a"
"template<class E> const E* end(initializer_list<E> il) noexcept; // constexpr in C++14\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <cstddef>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"namespace std  // purposefully not versioned\x0a"
"{\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _Ep>\x0a"
"class _LIBCPP_TEMPLATE_VIS initializer_list\x0a"
"{\x0a"
"    const _Ep* __begin_;\x0a"
"    size_t    __size_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    initializer_list(const _Ep* __b, size_t __s) _NOEXCEPT\x0a"
"        \x3a __begin_(__b),\x0a"
"          __size_(__s)\x0a"
"        {}\x0a"
"public\x3a\x0a"
"    typedef _Ep        value_type;\x0a"
"    typedef const _Ep\x26 reference;\x0a"
"    typedef const _Ep\x26 const_reference;\x0a"
"    typedef size_t    size_type;\x0a"
"\x0a"
"    typedef const _Ep* iterator;\x0a"
"    typedef const _Ep* const_iterator;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    initializer_list() _NOEXCEPT \x3a __begin_(nullptr), __size_(0) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    size_t    size()  const _NOEXCEPT {return __size_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    const _Ep* begin() const _NOEXCEPT {return __begin_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    const _Ep* end()   const _NOEXCEPT {return __begin_ + __size_;}\x0a"
"};\x0a"
"\x0a"
"template<class _Ep>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const _Ep*\x0a"
"begin(initializer_list<_Ep> __il) _NOEXCEPT\x0a"
"{\x0a"
"    return __il.begin();\x0a"
"}\x0a"
"\x0a"
"template<class _Ep>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const _Ep*\x0a"
"end(initializer_list<_Ep> __il) _NOEXCEPT\x0a"
"{\x0a"
"    return __il.end();\x0a"
"}\x0a"
"\x0a"
"#endif  // \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"#endif  // _LIBCPP_INITIALIZER_LIST\x0a"
"", 2842 ); }