#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_iomanip( 
"// -*- C++ -*-\x0a"
"//===--------------------------- iomanip ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_IOMANIP\x0a"
"#define _LIBCPP_IOMANIP\x0a"
"\x0a"
"/*\x0a"
"    iomanip synopsis\x0a"
"\x0a"
"namespace std {\x0a"
"\x0a"
"// types T1, T2, ... are unspecified implementation types\x0a"
"T1 resetiosflags(ios_base\x3a\x3a""fmtflags mask);\x0a"
"T2 setiosflags (ios_base\x3a\x3a""fmtflags mask);\x0a"
"T3 setbase(int base);\x0a"
"template<charT> T4 setfill(charT c);\x0a"
"T5 setprecision(int n);\x0a"
"T6 setw(int n);\x0a"
"template <class moneyT> T7 get_money(moneyT\x26 mon, bool intl = false);\x0a"
"template <class charT, class moneyT> T8 put_money(const moneyT\x26 mon, bool intl = false);\x0a"
"template <class charT> T9 get_time(struct tm* tmb, const charT* fmt);\x0a"
"template <class charT> T10 put_time(const struct tm* tmb, const charT* fmt);\x0a"
"\x0a"
"template <class charT>\x0a"
"  T11 quoted(const charT* s, charT delim=charT('\x22'), charT escape=charT('\x5c\x5c')); // C++14\x0a"
"\x0a"
"template <class charT, class traits, class Allocator>\x0a"
"  T12 quoted(const basic_string<charT, traits, Allocator>\x26 s,\x0a"
"             charT delim=charT('\x22'), charT escape=charT('\x5c\x5c')); // C++14\x0a"
"\x0a"
"template <class charT, class traits, class Allocator>\x0a"
"  T13 quoted(basic_string<charT, traits, Allocator>\x26 s,\x0a"
"             charT delim=charT('\x22'), charT escape=charT('\x5c\x5c')); // C++14\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__string>\x0a"
"#include <istream>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// resetiosflags\x0a"
"\x0a"
"class __iom_t1\x0a"
"{\x0a"
"    ios_base\x3a\x3a""fmtflags __mask_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __iom_t1(ios_base\x3a\x3a""fmtflags __m) \x3a __mask_(__m) {}\x0a"
"\x0a"
"    template <class _CharT, class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is, const __iom_t1\x26 __x)\x0a"
"    {\x0a"
"        __is.unsetf(__x.__mask_);\x0a"
"        return __is;\x0a"
"    }\x0a"
"\x0a"
"    template <class _CharT, class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t1\x26 __x)\x0a"
"    {\x0a"
"        __os.unsetf(__x.__mask_);\x0a"
"        return __os;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__iom_t1\x0a"
"resetiosflags(ios_base\x3a\x3a""fmtflags __mask)\x0a"
"{\x0a"
"    return __iom_t1(__mask);\x0a"
"}\x0a"
"\x0a"
"// setiosflags\x0a"
"\x0a"
"class __iom_t2\x0a"
"{\x0a"
"    ios_base\x3a\x3a""fmtflags __mask_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __iom_t2(ios_base\x3a\x3a""fmtflags __m) \x3a __mask_(__m) {}\x0a"
"\x0a"
"    template <class _CharT, class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is, const __iom_t2\x26 __x)\x0a"
"    {\x0a"
"        __is.setf(__x.__mask_);\x0a"
"        return __is;\x0a"
"    }\x0a"
"\x0a"
"    template <class _CharT, class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t2\x26 __x)\x0a"
"    {\x0a"
"        __os.setf(__x.__mask_);\x0a"
"        return __os;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__iom_t2\x0a"
"setiosflags(ios_base\x3a\x3a""fmtflags __mask)\x0a"
"{\x0a"
"    return __iom_t2(__mask);\x0a"
"}\x0a"
"\x0a"
"// setbase\x0a"
"\x0a"
"class __iom_t3\x0a"
"{\x0a"
"    int __base_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __iom_t3(int __b) \x3a __base_(__b) {}\x0a"
"\x0a"
"    template <class _CharT, class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is, const __iom_t3\x26 __x)\x0a"
"    {\x0a"
"        __is.setf(__x.__base_ == 8  \x3f ios_base\x3a\x3aoct \x3a\x0a"
"                  __x.__base_ == 10 \x3f ios_base\x3a\x3a""dec \x3a\x0a"
"                  __x.__base_ == 16 \x3f ios_base\x3a\x3ahex \x3a\x0a"
"                  ios_base\x3a\x3a""fmtflags(0), ios_base\x3a\x3a""basefield);\x0a"
"        return __is;\x0a"
"    }\x0a"
"\x0a"
"    template <class _CharT, class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t3\x26 __x)\x0a"
"    {\x0a"
"        __os.setf(__x.__base_ == 8  \x3f ios_base\x3a\x3aoct \x3a\x0a"
"                  __x.__base_ == 10 \x3f ios_base\x3a\x3a""dec \x3a\x0a"
"                  __x.__base_ == 16 \x3f ios_base\x3a\x3ahex \x3a\x0a"
"                  ios_base\x3a\x3a""fmtflags(0), ios_base\x3a\x3a""basefield);\x0a"
"        return __os;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__iom_t3\x0a"
"setbase(int __base)\x0a"
"{\x0a"
"    return __iom_t3(__base);\x0a"
"}\x0a"
"\x0a"
"// setfill\x0a"
"\x0a"
"template<class _CharT>\x0a"
"class __iom_t4\x0a"
"{\x0a"
"    _CharT __fill_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __iom_t4(_CharT __c) \x3a __fill_(__c) {}\x0a"
"\x0a"
"    template <class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t4\x26 __x)\x0a"
"    {\x0a"
"        __os.fill(__x.__fill_);\x0a"
"        return __os;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template<class _CharT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__iom_t4<_CharT>\x0a"
"setfill(_CharT __c)\x0a"
"{\x0a"
"    return __iom_t4<_CharT>(__c);\x0a"
"}\x0a"
"\x0a"
"// setprecision\x0a"
"\x0a"
"class __iom_t5\x0a"
"{\x0a"
"    int __n_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __iom_t5(int __n) \x3a __n_(__n) {}\x0a"
"\x0a"
"    template <class _CharT, class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is, const __iom_t5\x26 __x)\x0a"
"    {\x0a"
"        __is.precision(__x.__n_);\x0a"
"        return __is;\x0a"
"    }\x0a"
"\x0a"
"    template <class _CharT, class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t5\x26 __x)\x0a"
"    {\x0a"
"        __os.precision(__x.__n_);\x0a"
"        return __os;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__iom_t5\x0a"
"setprecision(int __n)\x0a"
"{\x0a"
"    return __iom_t5(__n);\x0a"
"}\x0a"
"\x0a"
"// setw\x0a"
"\x0a"
"class __iom_t6\x0a"
"{\x0a"
"    int __n_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __iom_t6(int __n) \x3a __n_(__n) {}\x0a"
"\x0a"
"    template <class _CharT, class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is, const __iom_t6\x26 __x)\x0a"
"    {\x0a"
"        __is.width(__x.__n_);\x0a"
"        return __is;\x0a"
"    }\x0a"
"\x0a"
"    template <class _CharT, class _Traits>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t6\x26 __x)\x0a"
"    {\x0a"
"        __os.width(__x.__n_);\x0a"
"        return __os;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__iom_t6\x0a"
"setw(int __n)\x0a"
"{\x0a"
"    return __iom_t6(__n);\x0a"
"}\x0a"
"\x0a"
"// get_money\x0a"
"\x0a"
"template <class _MoneyT> class __iom_t7;\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _MoneyT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, const __iom_t7<_MoneyT>\x26 __x);\x0a"
"\x0a"
"template <class _MoneyT>\x0a"
"class __iom_t7\x0a"
"{\x0a"
"    _MoneyT\x26 __mon_;\x0a"
"    bool __intl_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __iom_t7(_MoneyT\x26 __mon, bool __intl)\x0a"
"        \x3a __mon_(__mon), __intl_(__intl) {}\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _Mp>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is, const __iom_t7<_Mp>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _MoneyT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, const __iom_t7<_MoneyT>\x26 __x)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typename basic_istream<_CharT, _Traits>\x3a\x3asentry __s(__is);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef istreambuf_iterator<_CharT, _Traits> _Ip;\x0a"
"            typedef money_get<_CharT, _Ip> _Fp;\x0a"
"            ios_base\x3a\x3aiostate __err = ios_base\x3a\x3agoodbit;\x0a"
"            const _Fp\x26 __mf = use_facet<_Fp>(__is.getloc());\x0a"
"            __mf.get(_Ip(__is), _Ip(), __x.__intl_, __is, __err, __x.__mon_);\x0a"
"            __is.setstate(__err);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __is.__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"template <class _MoneyT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__iom_t7<_MoneyT>\x0a"
"get_money(_MoneyT\x26 __mon, bool __intl = false)\x0a"
"{\x0a"
"    return __iom_t7<_MoneyT>(__mon, __intl);\x0a"
"}\x0a"
"\x0a"
"// put_money\x0a"
"\x0a"
"template <class _MoneyT> class __iom_t8;\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _MoneyT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t8<_MoneyT>\x26 __x);\x0a"
"\x0a"
"template <class _MoneyT>\x0a"
"class __iom_t8\x0a"
"{\x0a"
"    const _MoneyT\x26 __mon_;\x0a"
"    bool __intl_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __iom_t8(const _MoneyT\x26 __mon, bool __intl)\x0a"
"        \x3a __mon_(__mon), __intl_(__intl) {}\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _Mp>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t8<_Mp>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _MoneyT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t8<_MoneyT>\x26 __x)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typename basic_ostream<_CharT, _Traits>\x3a\x3asentry __s(__os);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef ostreambuf_iterator<_CharT, _Traits> _Op;\x0a"
"            typedef money_put<_CharT, _Op> _Fp;\x0a"
"            const _Fp\x26 __mf = use_facet<_Fp>(__os.getloc());\x0a"
"            if (__mf.put(_Op(__os), __x.__intl_, __os, __os.fill(), __x.__mon_).failed())\x0a"
"                __os.setstate(ios_base\x3a\x3a""badbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __os.__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _MoneyT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__iom_t8<_MoneyT>\x0a"
"put_money(const _MoneyT\x26 __mon, bool __intl = false)\x0a"
"{\x0a"
"    return __iom_t8<_MoneyT>(__mon, __intl);\x0a"
"}\x0a"
"\x0a"
"// get_time\x0a"
"\x0a"
"template <class _CharT> class __iom_t9;\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, const __iom_t9<_CharT>\x26 __x);\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __iom_t9\x0a"
"{\x0a"
"    tm* __tm_;\x0a"
"    const _CharT* __fmt_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __iom_t9(tm* __tm, const _CharT* __fmt)\x0a"
"        \x3a __tm_(__tm), __fmt_(__fmt) {}\x0a"
"\x0a"
"    template <class _Cp, class _Traits>\x0a"
"    friend\x0a"
"    basic_istream<_Cp, _Traits>\x26\x0a"
"    operator>>(basic_istream<_Cp, _Traits>\x26 __is, const __iom_t9<_Cp>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, const __iom_t9<_CharT>\x26 __x)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typename basic_istream<_CharT, _Traits>\x3a\x3asentry __s(__is);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef istreambuf_iterator<_CharT, _Traits> _Ip;\x0a"
"            typedef time_get<_CharT, _Ip> _Fp;\x0a"
"            ios_base\x3a\x3aiostate __err = ios_base\x3a\x3agoodbit;\x0a"
"            const _Fp\x26 __tf = use_facet<_Fp>(__is.getloc());\x0a"
"            __tf.get(_Ip(__is), _Ip(), __is, __err, __x.__tm_,\x0a"
"                     __x.__fmt_, __x.__fmt_ + _Traits\x3a\x3alength(__x.__fmt_));\x0a"
"            __is.setstate(__err);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __is.__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__iom_t9<_CharT>\x0a"
"get_time(tm* __tm, const _CharT* __fmt)\x0a"
"{\x0a"
"    return __iom_t9<_CharT>(__tm, __fmt);\x0a"
"}\x0a"
"\x0a"
"// put_time\x0a"
"\x0a"
"template <class _CharT> class __iom_t10;\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t10<_CharT>\x26 __x);\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __iom_t10\x0a"
"{\x0a"
"    const tm* __tm_;\x0a"
"    const _CharT* __fmt_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __iom_t10(const tm* __tm, const _CharT* __fmt)\x0a"
"        \x3a __tm_(__tm), __fmt_(__fmt) {}\x0a"
"\x0a"
"    template <class _Cp, class _Traits>\x0a"
"    friend\x0a"
"    basic_ostream<_Cp, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_Cp, _Traits>\x26 __os, const __iom_t10<_Cp>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const __iom_t10<_CharT>\x26 __x)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typename basic_ostream<_CharT, _Traits>\x3a\x3asentry __s(__os);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef ostreambuf_iterator<_CharT, _Traits> _Op;\x0a"
"            typedef time_put<_CharT, _Op> _Fp;\x0a"
"            const _Fp\x26 __tf = use_facet<_Fp>(__os.getloc());\x0a"
"            if (__tf.put(_Op(__os), __os, __os.fill(), __x.__tm_,\x0a"
"                         __x.__fmt_, __x.__fmt_ + _Traits\x3a\x3alength(__x.__fmt_)).failed())\x0a"
"                __os.setstate(ios_base\x3a\x3a""badbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __os.__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__iom_t10<_CharT>\x0a"
"put_time(const tm* __tm, const _CharT* __fmt)\x0a"
"{\x0a"
"    return __iom_t10<_CharT>(__tm, __fmt);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _ForwardIterator>\x0a"
"std\x3a\x3a""basic_ostream<_CharT, _Traits> \x26\x0a"
"__quoted_output ( basic_ostream<_CharT, _Traits> \x26__os,\x0a"
"        _ForwardIterator __first, _ForwardIterator __last, _CharT __delim, _CharT __escape )\x0a"
"{\x0a"
"    _VSTD\x3a\x3a""basic_string<_CharT, _Traits> __str;\x0a"
"    __str.push_back(__delim);\x0a"
"    for ( ; __first \x21= __last; ++ __first )\x0a"
"    {\x0a"
"        if (_Traits\x3a\x3a""eq (*__first, __escape) \x7c\x7c _Traits\x3a\x3a""eq (*__first, __delim))\x0a"
"            __str.push_back(__escape);\x0a"
"        __str.push_back(*__first);\x0a"
"    }\x0a"
"    __str.push_back(__delim);\x0a"
"    return __put_character_sequence(__os, __str.data(), __str.size());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _String>\x0a"
"basic_istream<_CharT, _Traits> \x26\x0a"
"__quoted_input ( basic_istream<_CharT, _Traits> \x26__is, _String \x26 __string, _CharT __delim, _CharT __escape )\x0a"
"{\x0a"
"    __string.clear ();\x0a"
"    _CharT __c;\x0a"
"    __is >> __c;\x0a"
"    if ( __is.fail ())\x0a"
"        return __is;\x0a"
"\x0a"
"    if (\x21_Traits\x3a\x3a""eq (__c, __delim))    // no delimiter, read the whole string\x0a"
"    {\x0a"
"        __is.unget ();\x0a"
"        __is >> __string;\x0a"
"        return __is;\x0a"
"    }\x0a"
"\x0a"
"    __save_flags<_CharT, _Traits> sf(__is);\x0a"
"    noskipws (__is);\x0a"
"    while (true)\x0a"
"        {\x0a"
"        __is >> __c;\x0a"
"        if ( __is.fail ())\x0a"
"            break;\x0a"
"        if (_Traits\x3a\x3a""eq (__c, __escape))\x0a"
"        {\x0a"
"            __is >> __c;\x0a"
"            if ( __is.fail ())\x0a"
"                break;\x0a"
"        }\x0a"
"        else if (_Traits\x3a\x3a""eq (__c, __delim))\x0a"
"            break;\x0a"
"        __string.push_back ( __c );\x0a"
"        }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Iter>\x0a"
"basic_ostream<_CharT, _Traits>\x26 operator<<(\x0a"
"         basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"         const __quoted_output_proxy<_CharT, _Iter, _Traits> \x26 __proxy)\x0a"
"{\x0a"
"    return __quoted_output (__os, __proxy.__first, __proxy.__last, __proxy.__delim, __proxy.__escape);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"struct __quoted_proxy\x0a"
"{\x0a"
"    basic_string<_CharT, _Traits, _Allocator> \x26__string;\x0a"
"    _CharT  __delim;\x0a"
"    _CharT  __escape;\x0a"
"\x0a"
"    __quoted_proxy(basic_string<_CharT, _Traits, _Allocator> \x26__s, _CharT __d, _CharT __e)\x0a"
"    \x3a __string(__s), __delim(__d), __escape(__e) {}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26 operator<<(\x0a"
"        basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"        const __quoted_proxy<_CharT, _Traits, _Allocator> \x26 __proxy)\x0a"
"{\x0a"
"    return __quoted_output (__os, __proxy.__string.cbegin (), __proxy.__string.cend (), __proxy.__delim, __proxy.__escape);\x0a"
"}\x0a"
"\x0a"
"//  extractor for non-const basic_string\x26 proxies\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26 operator>>(\x0a"
"        basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"        const __quoted_proxy<_CharT, _Traits, _Allocator> \x26 __proxy)\x0a"
"{\x0a"
"    return __quoted_input ( __is, __proxy.__string, __proxy.__delim, __proxy.__escape );\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _CharT>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"__quoted_output_proxy<_CharT, const _CharT *>\x0a"
"quoted ( const _CharT *__s, _CharT __delim = _CharT('\x22'), _CharT __escape =_CharT('\x5c\x5c'))\x0a"
"{\x0a"
"    const _CharT *__end = __s;\x0a"
"    while ( *__end ) ++__end;\x0a"
"    return __quoted_output_proxy<_CharT, const _CharT *> ( __s, __end, __delim, __escape );\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"__quoted_output_proxy<_CharT, typename basic_string <_CharT, _Traits, _Allocator>\x3a\x3a""const_iterator>\x0a"
"__quoted ( const basic_string <_CharT, _Traits, _Allocator> \x26__s, _CharT __delim = _CharT('\x22'), _CharT __escape=_CharT('\x5c\x5c'))\x0a"
"{\x0a"
"    return __quoted_output_proxy<_CharT,\x0a"
"            typename basic_string <_CharT, _Traits, _Allocator>\x3a\x3a""const_iterator>\x0a"
"                    ( __s.cbegin(), __s.cend (), __delim, __escape );\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"__quoted_proxy<_CharT, _Traits, _Allocator>\x0a"
"__quoted ( basic_string <_CharT, _Traits, _Allocator> \x26__s, _CharT __delim = _CharT('\x22'), _CharT __escape=_CharT('\x5c\x5c'))\x0a"
"{\x0a"
"    return __quoted_proxy<_CharT, _Traits, _Allocator>( __s, __delim, __escape );\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"__quoted_output_proxy<_CharT, typename basic_string <_CharT, _Traits, _Allocator>\x3a\x3a""const_iterator>\x0a"
"quoted ( const basic_string <_CharT, _Traits, _Allocator> \x26__s, _CharT __delim = _CharT('\x22'), _CharT __escape=_CharT('\x5c\x5c'))\x0a"
"{\x0a"
"    return __quoted(__s, __delim, __escape);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"__quoted_proxy<_CharT, _Traits, _Allocator>\x0a"
"quoted ( basic_string <_CharT, _Traits, _Allocator> \x26__s, _CharT __delim = _CharT('\x22'), _CharT __escape=_CharT('\x5c\x5c'))\x0a"
"{\x0a"
"    return __quoted(__s, __delim, __escape);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"__quoted_output_proxy<_CharT, const _CharT *, _Traits>\x0a"
"quoted (basic_string_view <_CharT, _Traits> __sv,\x0a"
"             _CharT __delim = _CharT('\x22'), _CharT __escape=_CharT('\x5c\x5c'))\x0a"
"{\x0a"
"    return __quoted_output_proxy<_CharT, const _CharT *, _Traits>\x0a"
"         ( __sv.data(), __sv.data() + __sv.size(), __delim, __escape );\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_IOMANIP\x0a"
"", 18278 ); }