#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_ios( 
"// -*- C++ -*-\x0a"
"//===---------------------------- ios -------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_IOS\x0a"
"#define _LIBCPP_IOS\x0a"
"\x0a"
"/*\x0a"
"    ios synopsis\x0a"
"\x0a"
"#include <iosfwd>\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"typedef OFF_T streamoff;\x0a"
"typedef SZ_T streamsize;\x0a"
"template <class stateT> class fpos;\x0a"
"\x0a"
"class ios_base\x0a"
"{\x0a"
"public\x3a\x0a"
"    class failure;\x0a"
"\x0a"
"    typedef T1 fmtflags;\x0a"
"    static constexpr fmtflags boolalpha;\x0a"
"    static constexpr fmtflags dec;\x0a"
"    static constexpr fmtflags fixed;\x0a"
"    static constexpr fmtflags hex;\x0a"
"    static constexpr fmtflags internal;\x0a"
"    static constexpr fmtflags left;\x0a"
"    static constexpr fmtflags oct;\x0a"
"    static constexpr fmtflags right;\x0a"
"    static constexpr fmtflags scientific;\x0a"
"    static constexpr fmtflags showbase;\x0a"
"    static constexpr fmtflags showpoint;\x0a"
"    static constexpr fmtflags showpos;\x0a"
"    static constexpr fmtflags skipws;\x0a"
"    static constexpr fmtflags unitbuf;\x0a"
"    static constexpr fmtflags uppercase;\x0a"
"    static constexpr fmtflags adjustfield;\x0a"
"    static constexpr fmtflags basefield;\x0a"
"    static constexpr fmtflags floatfield;\x0a"
"\x0a"
"    typedef T2 iostate;\x0a"
"    static constexpr iostate badbit;\x0a"
"    static constexpr iostate eofbit;\x0a"
"    static constexpr iostate failbit;\x0a"
"    static constexpr iostate goodbit;\x0a"
"\x0a"
"    typedef T3 openmode;\x0a"
"    static constexpr openmode app;\x0a"
"    static constexpr openmode ate;\x0a"
"    static constexpr openmode binary;\x0a"
"    static constexpr openmode in;\x0a"
"    static constexpr openmode out;\x0a"
"    static constexpr openmode trunc;\x0a"
"\x0a"
"    typedef T4 seekdir;\x0a"
"    static constexpr seekdir beg;\x0a"
"    static constexpr seekdir cur;\x0a"
"    static constexpr seekdir end;\x0a"
"\x0a"
"    class Init;\x0a"
"\x0a"
"    // 27.5.2.2 fmtflags state\x3a\x0a"
"    fmtflags flags() const;\x0a"
"    fmtflags flags(fmtflags fmtfl);\x0a"
"    fmtflags setf(fmtflags fmtfl);\x0a"
"    fmtflags setf(fmtflags fmtfl, fmtflags mask);\x0a"
"    void unsetf(fmtflags mask);\x0a"
"\x0a"
"    streamsize precision() const;\x0a"
"    streamsize precision(streamsize prec);\x0a"
"    streamsize width() const;\x0a"
"    streamsize width(streamsize wide);\x0a"
"\x0a"
"    // 27.5.2.3 locales\x3a\x0a"
"    locale imbue(const locale\x26 loc);\x0a"
"    locale getloc() const;\x0a"
"\x0a"
"    // 27.5.2.5 storage\x3a\x0a"
"    static int xalloc();\x0a"
"    long\x26 iword(int index);\x0a"
"    void*\x26 pword(int index);\x0a"
"\x0a"
"    // destructor\x0a"
"    virtual \x7eios_base();\x0a"
"\x0a"
"    // 27.5.2.6 callbacks;\x0a"
"    enum event { erase_event, imbue_event, copyfmt_event };\x0a"
"    typedef void (*event_callback)(event, ios_base\x26, int index);\x0a"
"    void register_callback(event_callback fn, int index);\x0a"
"\x0a"
"    ios_base(const ios_base\x26) = delete;\x0a"
"    ios_base\x26 operator=(const ios_base\x26) = delete;\x0a"
"\x0a"
"    static bool sync_with_stdio(bool sync = true);\x0a"
"\x0a"
"protected\x3a\x0a"
"    ios_base();\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> >\x0a"
"class basic_ios\x0a"
"    \x3a public ios_base\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef charT char_type;\x0a"
"    typedef typename traits\x3a\x3aint_type int_type;  // removed in C++17\x0a"
"    typedef typename traits\x3a\x3apos_type pos_type;  // removed in C++17\x0a"
"    typedef typename traits\x3a\x3aoff_type off_type;  // removed in C++17\x0a"
"    typedef traits traits_type;\x0a"
"\x0a"
"    operator unspecified-bool-type() const;\x0a"
"    bool operator\x21() const;\x0a"
"    iostate rdstate() const;\x0a"
"    void clear(iostate state = goodbit);\x0a"
"    void setstate(iostate state);\x0a"
"    bool good() const;\x0a"
"    bool eof() const;\x0a"
"    bool fail() const;\x0a"
"    bool bad() const;\x0a"
"\x0a"
"    iostate exceptions() const;\x0a"
"    void exceptions(iostate except);\x0a"
"\x0a"
"    // 27.5.4.1 Constructor/destructor\x3a\x0a"
"    explicit basic_ios(basic_streambuf<charT,traits>* sb);\x0a"
"    virtual \x7e""basic_ios();\x0a"
"\x0a"
"    // 27.5.4.2 Members\x3a\x0a"
"    basic_ostream<charT,traits>* tie() const;\x0a"
"    basic_ostream<charT,traits>* tie(basic_ostream<charT,traits>* tiestr);\x0a"
"\x0a"
"    basic_streambuf<charT,traits>* rdbuf() const;\x0a"
"    basic_streambuf<charT,traits>* rdbuf(basic_streambuf<charT,traits>* sb);\x0a"
"\x0a"
"    basic_ios\x26 copyfmt(const basic_ios\x26 rhs);\x0a"
"\x0a"
"    char_type fill() const;\x0a"
"    char_type fill(char_type ch);\x0a"
"\x0a"
"    locale imbue(const locale\x26 loc);\x0a"
"\x0a"
"    char narrow(char_type c, char dfault) const;\x0a"
"    char_type widen(char c) const;\x0a"
"\x0a"
"    basic_ios(const basic_ios\x26 ) = delete;\x0a"
"    basic_ios\x26 operator=(const basic_ios\x26) = delete;\x0a"
"\x0a"
"protected\x3a\x0a"
"    basic_ios();\x0a"
"    void init(basic_streambuf<charT,traits>* sb);\x0a"
"    void move(basic_ios\x26 rhs);\x0a"
"    void swap(basic_ios\x26 rhs) noexcept;\x0a"
"    void set_rdbuf(basic_streambuf<charT, traits>* sb);\x0a"
"};\x0a"
"\x0a"
"// 27.5.5, manipulators\x3a\x0a"
"ios_base\x26 boolalpha (ios_base\x26 str);\x0a"
"ios_base\x26 noboolalpha(ios_base\x26 str);\x0a"
"ios_base\x26 showbase (ios_base\x26 str);\x0a"
"ios_base\x26 noshowbase (ios_base\x26 str);\x0a"
"ios_base\x26 showpoint (ios_base\x26 str);\x0a"
"ios_base\x26 noshowpoint(ios_base\x26 str);\x0a"
"ios_base\x26 showpos (ios_base\x26 str);\x0a"
"ios_base\x26 noshowpos (ios_base\x26 str);\x0a"
"ios_base\x26 skipws (ios_base\x26 str);\x0a"
"ios_base\x26 noskipws (ios_base\x26 str);\x0a"
"ios_base\x26 uppercase (ios_base\x26 str);\x0a"
"ios_base\x26 nouppercase(ios_base\x26 str);\x0a"
"ios_base\x26 unitbuf (ios_base\x26 str);\x0a"
"ios_base\x26 nounitbuf (ios_base\x26 str);\x0a"
"\x0a"
"// 27.5.5.2 adjustfield\x3a\x0a"
"ios_base\x26 internal (ios_base\x26 str);\x0a"
"ios_base\x26 left (ios_base\x26 str);\x0a"
"ios_base\x26 right (ios_base\x26 str);\x0a"
"\x0a"
"// 27.5.5.3 basefield\x3a\x0a"
"ios_base\x26 dec (ios_base\x26 str);\x0a"
"ios_base\x26 hex (ios_base\x26 str);\x0a"
"ios_base\x26 oct (ios_base\x26 str);\x0a"
"\x0a"
"// 27.5.5.4 floatfield\x3a\x0a"
"ios_base\x26 fixed (ios_base\x26 str);\x0a"
"ios_base\x26 scientific (ios_base\x26 str);\x0a"
"ios_base\x26 hexfloat (ios_base\x26 str);\x0a"
"ios_base\x26 defaultfloat(ios_base\x26 str);\x0a"
"\x0a"
"// 27.5.5.5 error reporting\x3a\x0a"
"enum class io_errc\x0a"
"{\x0a"
"    stream = 1\x0a"
"};\x0a"
"\x0a"
"concept_map ErrorCodeEnum<io_errc> { };\x0a"
"error_code make_error_code(io_errc e) noexcept;\x0a"
"error_condition make_error_condition(io_errc e) noexcept;\x0a"
"storage-class-specifier const error_category\x26 iostream_category() noexcept;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <iosfwd>\x0a"
"#include <__locale>\x0a"
"#include <system_error>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_ATOMIC_HEADER)\x0a"
"#include <atomic>     // for __xindex_\x0a"
"#endif\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"typedef ptrdiff_t streamsize;\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS ios_base\x0a"
"{\x0a"
"public\x3a\x0a"
"    class _LIBCPP_EXCEPTION_ABI failure;\x0a"
"\x0a"
"    typedef unsigned int fmtflags;\x0a"
"    static const fmtflags boolalpha   = 0x0001;\x0a"
"    static const fmtflags dec         = 0x0002;\x0a"
"    static const fmtflags fixed       = 0x0004;\x0a"
"    static const fmtflags hex         = 0x0008;\x0a"
"    static const fmtflags internal    = 0x0010;\x0a"
"    static const fmtflags left        = 0x0020;\x0a"
"    static const fmtflags oct         = 0x0040;\x0a"
"    static const fmtflags right       = 0x0080;\x0a"
"    static const fmtflags scientific  = 0x0100;\x0a"
"    static const fmtflags showbase    = 0x0200;\x0a"
"    static const fmtflags showpoint   = 0x0400;\x0a"
"    static const fmtflags showpos     = 0x0800;\x0a"
"    static const fmtflags skipws      = 0x1000;\x0a"
"    static const fmtflags unitbuf     = 0x2000;\x0a"
"    static const fmtflags uppercase   = 0x4000;\x0a"
"    static const fmtflags adjustfield = left \x7c right \x7c internal;\x0a"
"    static const fmtflags basefield   = dec \x7c oct \x7c hex;\x0a"
"    static const fmtflags floatfield  = scientific \x7c fixed;\x0a"
"\x0a"
"    typedef unsigned int iostate;\x0a"
"    static const iostate badbit  = 0x1;\x0a"
"    static const iostate eofbit  = 0x2;\x0a"
"    static const iostate failbit = 0x4;\x0a"
"    static const iostate goodbit = 0x0;\x0a"
"\x0a"
"    typedef unsigned int openmode;\x0a"
"    static const openmode app    = 0x01;\x0a"
"    static const openmode ate    = 0x02;\x0a"
"    static const openmode binary = 0x04;\x0a"
"    static const openmode in     = 0x08;\x0a"
"    static const openmode out    = 0x10;\x0a"
"    static const openmode trunc  = 0x20;\x0a"
"\x0a"
"    enum seekdir {beg, cur, end};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"    typedef iostate      io_state;\x0a"
"    typedef openmode     open_mode;\x0a"
"    typedef seekdir      seek_dir;\x0a"
"\x0a"
"    typedef _VSTD\x3a\x3astreamoff streamoff;\x0a"
"    typedef _VSTD\x3a\x3astreampos streampos;\x0a"
"#endif\x0a"
"\x0a"
"    class _LIBCPP_TYPE_VIS Init;\x0a"
"\x0a"
"    // 27.5.2.2 fmtflags state\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY fmtflags flags() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY fmtflags flags(fmtflags __fmtfl);\x0a"
"    _LIBCPP_INLINE_VISIBILITY fmtflags setf(fmtflags __fmtfl);\x0a"
"    _LIBCPP_INLINE_VISIBILITY fmtflags setf(fmtflags __fmtfl, fmtflags __mask);\x0a"
"    _LIBCPP_INLINE_VISIBILITY void unsetf(fmtflags __mask);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY streamsize precision() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY streamsize precision(streamsize __prec);\x0a"
"    _LIBCPP_INLINE_VISIBILITY streamsize width() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY streamsize width(streamsize __wide);\x0a"
"\x0a"
"    // 27.5.2.3 locales\x3a\x0a"
"    locale imbue(const locale\x26 __loc);\x0a"
"    locale getloc() const;\x0a"
"\x0a"
"    // 27.5.2.5 storage\x3a\x0a"
"    static int xalloc();\x0a"
"    long\x26 iword(int __index);\x0a"
"    void*\x26 pword(int __index);\x0a"
"\x0a"
"    // destructor\x0a"
"    virtual \x7eios_base();\x0a"
"\x0a"
"    // 27.5.2.6 callbacks;\x0a"
"    enum event { erase_event, imbue_event, copyfmt_event };\x0a"
"    typedef void (*event_callback)(event, ios_base\x26, int __index);\x0a"
"    void register_callback(event_callback __fn, int __index);\x0a"
"\x0a"
"private\x3a\x0a"
"    ios_base(const ios_base\x26); // = delete;\x0a"
"    ios_base\x26 operator=(const ios_base\x26); // = delete;\x0a"
"\x0a"
"public\x3a\x0a"
"    static bool sync_with_stdio(bool __sync = true);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY iostate rdstate() const;\x0a"
"    void clear(iostate __state = goodbit);\x0a"
"    _LIBCPP_INLINE_VISIBILITY void setstate(iostate __state);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool good() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool eof() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool fail() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool bad() const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY iostate exceptions() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY void exceptions(iostate __iostate);\x0a"
"\x0a"
"    void __set_badbit_and_consider_rethrow();\x0a"
"    void __set_failbit_and_consider_rethrow();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __setstate_nothrow(iostate __state)\x0a"
"    {\x0a"
"        if (__rdbuf_)\x0a"
"            __rdstate_ \x7c= __state;\x0a"
"        else\x0a"
"            __rdstate_ \x7c= __state \x7c ios_base\x3a\x3a""badbit;\x0a"
"    }\x0a"
"\x0a"
"protected\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    ios_base() {// purposefully does no initialization\x0a"
"               }\x0a"
"\x0a"
"    void init(void* __sb);\x0a"
"    _LIBCPP_INLINE_VISIBILITY void* rdbuf() const {return __rdbuf_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void rdbuf(void* __sb)\x0a"
"    {\x0a"
"        __rdbuf_ = __sb;\x0a"
"        clear();\x0a"
"    }\x0a"
"\x0a"
"    void __call_callbacks(event);\x0a"
"    void copyfmt(const ios_base\x26);\x0a"
"    void move(ios_base\x26);\x0a"
"    void swap(ios_base\x26) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void set_rdbuf(void* __sb)\x0a"
"    {\x0a"
"        __rdbuf_ = __sb;\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    // All data members must be scalars\x0a"
"    fmtflags        __fmtflags_;\x0a"
"    streamsize      __precision_;\x0a"
"    streamsize      __width_;\x0a"
"    iostate         __rdstate_;\x0a"
"    iostate         __exceptions_;\x0a"
"    void*           __rdbuf_;\x0a"
"    void*           __loc_;\x0a"
"    event_callback* __fn_;\x0a"
"    int*            __index_;\x0a"
"    size_t          __event_size_;\x0a"
"    size_t          __event_cap_;\x0a"
"// TODO(EricWF)\x3a Enable this for both Clang and GCC. Currently it is only\x0a"
"// enabled with clang.\x0a"
"#if defined(_LIBCPP_HAS_C_ATOMIC_IMP) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_THREADS)\x0a"
"    static atomic<int> __xindex_;\x0a"
"#else\x0a"
"    static int      __xindex_;\x0a"
"#endif\x0a"
"    long*           __iarray_;\x0a"
"    size_t          __iarray_size_;\x0a"
"    size_t          __iarray_cap_;\x0a"
"    void**          __parray_;\x0a"
"    size_t          __parray_size_;\x0a"
"    size_t          __parray_cap_;\x0a"
"};\x0a"
"\x0a"
"//enum class io_errc\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM(io_errc)\x0a"
"{\x0a"
"    stream = 1\x0a"
"};\x0a"
"_LIBCPP_DECLARE_STRONG_ENUM_EPILOG(io_errc)\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_error_code_enum<io_errc> \x3a public true_type { };\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_NO_STRONG_ENUMS\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_error_code_enum<io_errc\x3a\x3a__lx> \x3a public true_type { };\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS\x0a"
"const error_category\x26 iostream_category() _NOEXCEPT;\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"error_code\x0a"
"make_error_code(io_errc __e) _NOEXCEPT\x0a"
"{\x0a"
"    return error_code(static_cast<int>(__e), iostream_category());\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"error_condition\x0a"
"make_error_condition(io_errc __e) _NOEXCEPT\x0a"
"{\x0a"
"    return error_condition(static_cast<int>(__e), iostream_category());\x0a"
"}\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI ios_base\x3a\x3a""failure\x0a"
"    \x3a public system_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit failure(const string\x26 __msg, const error_code\x26 __ec = io_errc\x3a\x3astream);\x0a"
"    explicit failure(const char* __msg, const error_code\x26 __ec = io_errc\x3a\x3astream);\x0a"
"    virtual \x7e""failure() throw();\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_failure(char const* __msg) {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw ios_base\x3a\x3a""failure(__msg);\x0a"
"#else\x0a"
"    ((void)__msg);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS ios_base\x3a\x3aInit\x0a"
"{\x0a"
"public\x3a\x0a"
"    Init();\x0a"
"    \x7eInit();\x0a"
"};\x0a"
"\x0a"
"// fmtflags\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x3a\x3a""fmtflags\x0a"
"ios_base\x3a\x3a""flags() const\x0a"
"{\x0a"
"    return __fmtflags_;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x3a\x3a""fmtflags\x0a"
"ios_base\x3a\x3a""flags(fmtflags __fmtfl)\x0a"
"{\x0a"
"    fmtflags __r = __fmtflags_;\x0a"
"    __fmtflags_ = __fmtfl;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x3a\x3a""fmtflags\x0a"
"ios_base\x3a\x3asetf(fmtflags __fmtfl)\x0a"
"{\x0a"
"    fmtflags __r = __fmtflags_;\x0a"
"    __fmtflags_ \x7c= __fmtfl;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"ios_base\x3a\x3aunsetf(fmtflags __mask)\x0a"
"{\x0a"
"    __fmtflags_ \x26= \x7e__mask;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x3a\x3a""fmtflags\x0a"
"ios_base\x3a\x3asetf(fmtflags __fmtfl, fmtflags __mask)\x0a"
"{\x0a"
"    fmtflags __r = __fmtflags_;\x0a"
"    unsetf(__mask);\x0a"
"    __fmtflags_ \x7c= __fmtfl \x26 __mask;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// precision\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"streamsize\x0a"
"ios_base\x3a\x3aprecision() const\x0a"
"{\x0a"
"    return __precision_;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"streamsize\x0a"
"ios_base\x3a\x3aprecision(streamsize __prec)\x0a"
"{\x0a"
"    streamsize __r = __precision_;\x0a"
"    __precision_ = __prec;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// width\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"streamsize\x0a"
"ios_base\x3a\x3awidth() const\x0a"
"{\x0a"
"    return __width_;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"streamsize\x0a"
"ios_base\x3a\x3awidth(streamsize __wide)\x0a"
"{\x0a"
"    streamsize __r = __width_;\x0a"
"    __width_ = __wide;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// iostate\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x3a\x3aiostate\x0a"
"ios_base\x3a\x3ardstate() const\x0a"
"{\x0a"
"    return __rdstate_;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"ios_base\x3a\x3asetstate(iostate __state)\x0a"
"{\x0a"
"    clear(__rdstate_ \x7c __state);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"ios_base\x3a\x3agood() const\x0a"
"{\x0a"
"    return __rdstate_ == 0;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"ios_base\x3a\x3a""eof() const\x0a"
"{\x0a"
"    return (__rdstate_ \x26 eofbit) \x21= 0;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"ios_base\x3a\x3a""fail() const\x0a"
"{\x0a"
"    return (__rdstate_ \x26 (failbit \x7c badbit)) \x21= 0;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"ios_base\x3a\x3a""bad() const\x0a"
"{\x0a"
"    return (__rdstate_ \x26 badbit) \x21= 0;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x3a\x3aiostate\x0a"
"ios_base\x3a\x3a""exceptions() const\x0a"
"{\x0a"
"    return __exceptions_;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"ios_base\x3a\x3a""exceptions(iostate __iostate)\x0a"
"{\x0a"
"    __exceptions_ = __iostate;\x0a"
"    clear(__rdstate_);\x0a"
"}\x0a"
"\x0a"
"#if defined(_LIBCPP_CXX03_LANG)\x0a"
"struct _LIBCPP_TYPE_VIS __cxx03_bool {\x0a"
"  typedef void (__cxx03_bool\x3a\x3a*__bool_type)();\x0a"
"  void __true_value() {}\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_ios\x0a"
"    \x3a public ios_base\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef _CharT char_type;\x0a"
"    typedef _Traits traits_type;\x0a"
"\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    static_assert((is_same<_CharT, typename traits_type\x3a\x3a""char_type>\x3a\x3avalue),\x0a"
"                  \x22traits_type\x3a\x3a""char_type must be the same type as CharT\x22);\x0a"
"\x0a"
"  // __true_value will generate undefined references when linking unless\x0a"
"  // we give it internal linkage.\x0a"
"\x0a"
"#if defined(_LIBCPP_CXX03_LANG)\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator __cxx03_bool\x3a\x3a__bool_type() const {\x0a"
"        return \x21""fail() \x3f \x26__cxx03_bool\x3a\x3a__true_value \x3a nullptr;\x0a"
"    }\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_EXPLICIT operator bool() const {return \x21""fail();}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool operator\x21() const    {return  fail();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY iostate rdstate() const   {return ios_base\x3a\x3ardstate();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void clear(iostate __state = goodbit) {ios_base\x3a\x3a""clear(__state);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void setstate(iostate __state) {ios_base\x3a\x3asetstate(__state);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool good() const {return ios_base\x3a\x3agood();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool eof() const  {return ios_base\x3a\x3a""eof();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool fail() const {return ios_base\x3a\x3a""fail();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool bad() const  {return ios_base\x3a\x3a""bad();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY iostate exceptions() const {return ios_base\x3a\x3a""exceptions();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void exceptions(iostate __iostate) {ios_base\x3a\x3a""exceptions(__iostate);}\x0a"
"\x0a"
"    // 27.5.4.1 Constructor/destructor\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ios(basic_streambuf<char_type,traits_type>* __sb);\x0a"
"    virtual \x7e""basic_ios();\x0a"
"\x0a"
"    // 27.5.4.2 Members\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream<char_type, traits_type>* tie() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream<char_type, traits_type>* tie(basic_ostream<char_type, traits_type>* __tiestr);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_streambuf<char_type, traits_type>* rdbuf() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_streambuf<char_type, traits_type>* rdbuf(basic_streambuf<char_type, traits_type>* __sb);\x0a"
"\x0a"
"    basic_ios\x26 copyfmt(const basic_ios\x26 __rhs);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    char_type fill() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    char_type fill(char_type __ch);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    locale imbue(const locale\x26 __loc);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    char narrow(char_type __c, char __dfault) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    char_type widen(char __c) const;\x0a"
"\x0a"
"protected\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ios() {// purposefully does no initialization\x0a"
"                }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void init(basic_streambuf<char_type, traits_type>* __sb);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void move(basic_ios\x26 __rhs);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void move(basic_ios\x26\x26 __rhs) {move(__rhs);}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(basic_ios\x26 __rhs) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void set_rdbuf(basic_streambuf<char_type, traits_type>* __sb);\x0a"
"private\x3a\x0a"
"    basic_ostream<char_type, traits_type>* __tie_;\x0a"
"    mutable int_type __fill_;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3a""basic_ios(basic_streambuf<char_type,traits_type>* __sb)\x0a"
"{\x0a"
"    init(__sb);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3a\x7e""basic_ios()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3ainit(basic_streambuf<char_type, traits_type>* __sb)\x0a"
"{\x0a"
"    ios_base\x3a\x3ainit(__sb);\x0a"
"    __tie_ = 0;\x0a"
"    __fill_ = traits_type\x3a\x3a""eof();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>*\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3atie() const\x0a"
"{\x0a"
"    return __tie_;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>*\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3atie(basic_ostream<char_type, traits_type>* __tiestr)\x0a"
"{\x0a"
"    basic_ostream<char_type, traits_type>* __r = __tie_;\x0a"
"    __tie_ = __tiestr;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_streambuf<_CharT, _Traits>*\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3ardbuf() const\x0a"
"{\x0a"
"    return static_cast<basic_streambuf<char_type, traits_type>*>(ios_base\x3a\x3ardbuf());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_streambuf<_CharT, _Traits>*\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3ardbuf(basic_streambuf<char_type, traits_type>* __sb)\x0a"
"{\x0a"
"    basic_streambuf<char_type, traits_type>* __r = rdbuf();\x0a"
"    ios_base\x3a\x3ardbuf(__sb);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"locale\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3aimbue(const locale\x26 __loc)\x0a"
"{\x0a"
"    locale __r = getloc();\x0a"
"    ios_base\x3a\x3aimbue(__loc);\x0a"
"    if (rdbuf())\x0a"
"        rdbuf()->pubimbue(__loc);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"char\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3anarrow(char_type __c, char __dfault) const\x0a"
"{\x0a"
"    return use_facet<ctype<char_type> >(getloc()).narrow(__c, __dfault);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_CharT\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3awiden(char __c) const\x0a"
"{\x0a"
"    return use_facet<ctype<char_type> >(getloc()).widen(__c);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_CharT\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3a""fill() const\x0a"
"{\x0a"
"    if (traits_type\x3a\x3a""eq_int_type(traits_type\x3a\x3a""eof(), __fill_))\x0a"
"        __fill_ = widen(' ');\x0a"
"    return __fill_;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_CharT\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3a""fill(char_type __ch)\x0a"
"{\x0a"
"    char_type __r = __fill_;\x0a"
"    __fill_ = __ch;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ios<_CharT, _Traits>\x26\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3a""copyfmt(const basic_ios\x26 __rhs)\x0a"
"{\x0a"
"    if (this \x21= \x26__rhs)\x0a"
"    {\x0a"
"        __call_callbacks(erase_event);\x0a"
"        ios_base\x3a\x3a""copyfmt(__rhs);\x0a"
"        __tie_ = __rhs.__tie_;\x0a"
"        __fill_ = __rhs.__fill_;\x0a"
"        __call_callbacks(copyfmt_event);\x0a"
"        exceptions(__rhs.exceptions());\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3amove(basic_ios\x26 __rhs)\x0a"
"{\x0a"
"    ios_base\x3a\x3amove(__rhs);\x0a"
"    __tie_ = __rhs.__tie_;\x0a"
"    __rhs.__tie_ = 0;\x0a"
"    __fill_ = __rhs.__fill_;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3aswap(basic_ios\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    ios_base\x3a\x3aswap(__rhs);\x0a"
"    _VSTD\x3a\x3aswap(__tie_, __rhs.__tie_);\x0a"
"    _VSTD\x3a\x3aswap(__fill_, __rhs.__fill_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"basic_ios<_CharT, _Traits>\x3a\x3aset_rdbuf(basic_streambuf<char_type, traits_type>* __sb)\x0a"
"{\x0a"
"    ios_base\x3a\x3aset_rdbuf(__sb);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"boolalpha(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3a""boolalpha);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"noboolalpha(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.unsetf(ios_base\x3a\x3a""boolalpha);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"showbase(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3ashowbase);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"noshowbase(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.unsetf(ios_base\x3a\x3ashowbase);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"showpoint(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3ashowpoint);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"noshowpoint(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.unsetf(ios_base\x3a\x3ashowpoint);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"showpos(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3ashowpos);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"noshowpos(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.unsetf(ios_base\x3a\x3ashowpos);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"skipws(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3askipws);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"noskipws(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.unsetf(ios_base\x3a\x3askipws);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"uppercase(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3auppercase);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"nouppercase(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.unsetf(ios_base\x3a\x3auppercase);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"unitbuf(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3aunitbuf);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"nounitbuf(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.unsetf(ios_base\x3a\x3aunitbuf);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"internal(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3ainternal, ios_base\x3a\x3a""adjustfield);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"left(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3aleft, ios_base\x3a\x3a""adjustfield);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"right(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3aright, ios_base\x3a\x3a""adjustfield);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"dec(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3a""dec, ios_base\x3a\x3a""basefield);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"hex(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3ahex, ios_base\x3a\x3a""basefield);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"oct(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3aoct, ios_base\x3a\x3a""basefield);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"fixed(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3a""fixed, ios_base\x3a\x3a""floatfield);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"scientific(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3ascientific, ios_base\x3a\x3a""floatfield);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"hexfloat(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.setf(ios_base\x3a\x3a""fixed \x7c ios_base\x3a\x3ascientific, ios_base\x3a\x3a""floatfield);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"ios_base\x26\x0a"
"defaultfloat(ios_base\x26 __str)\x0a"
"{\x0a"
"    __str.unsetf(ios_base\x3a\x3a""floatfield);\x0a"
"    return __str;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class __save_flags\x0a"
"{\x0a"
"    typedef basic_ios<_CharT, _Traits> __stream_type;\x0a"
"    typedef typename __stream_type\x3a\x3a""fmtflags fmtflags;\x0a"
"\x0a"
"    __stream_type\x26 __stream_;\x0a"
"    fmtflags       __fmtflags_;\x0a"
"    _CharT         __fill_;\x0a"
"\x0a"
"    __save_flags(const __save_flags\x26);\x0a"
"    __save_flags\x26 operator=(const __save_flags\x26);\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __save_flags(__stream_type\x26 __stream)\x0a"
"        \x3a __stream_(__stream),\x0a"
"          __fmtflags_(__stream.flags()),\x0a"
"          __fill_(__stream.fill())\x0a"
"        {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e__save_flags()\x0a"
"    {\x0a"
"        __stream_.flags(__fmtflags_);\x0a"
"        __stream_.fill(__fill_);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_IOS\x0a"
"", 26167 ); }