#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_iosfwd( 
"// -*- C++ -*-\x0a"
"//===--------------------------- iosfwd -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_IOSFWD\x0a"
"#define _LIBCPP_IOSFWD\x0a"
"\x0a"
"/*\x0a"
"    iosfwd synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template<class charT> struct char_traits;\x0a"
"template<>            struct char_traits<char>;\x0a"
"template<>            struct char_traits<char8_t>;  // C++20\x0a"
"template<>            struct char_traits<char16_t>;\x0a"
"template<>            struct char_traits<char32_t>;\x0a"
"template<>            struct char_traits<wchar_t>;\x0a"
"\x0a"
"template<class T>     class allocator;\x0a"
"\x0a"
"class ios_base;\x0a"
"template <class charT, class traits = char_traits<charT> > class basic_ios;\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> > class basic_streambuf;\x0a"
"template <class charT, class traits = char_traits<charT> > class basic_istream;\x0a"
"template <class charT, class traits = char_traits<charT> > class basic_ostream;\x0a"
"template <class charT, class traits = char_traits<charT> > class basic_iostream;\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT>, class Allocator = allocator<charT> >\x0a"
"    class basic_stringbuf;\x0a"
"template <class charT, class traits = char_traits<charT>, class Allocator = allocator<charT> >\x0a"
"    class basic_istringstream;\x0a"
"template <class charT, class traits = char_traits<charT>, class Allocator = allocator<charT> >\x0a"
"    class basic_ostringstream;\x0a"
"template <class charT, class traits = char_traits<charT>, class Allocator = allocator<charT> >\x0a"
"    class basic_stringstream;\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> > class basic_filebuf;\x0a"
"template <class charT, class traits = char_traits<charT> > class basic_ifstream;\x0a"
"template <class charT, class traits = char_traits<charT> > class basic_ofstream;\x0a"
"template <class charT, class traits = char_traits<charT> > class basic_fstream;\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> > class istreambuf_iterator;\x0a"
"template <class charT, class traits = char_traits<charT> > class ostreambuf_iterator;\x0a"
"\x0a"
"typedef basic_ios<char>              ios;\x0a"
"typedef basic_ios<wchar_t>           wios;\x0a"
"\x0a"
"typedef basic_streambuf<char>        streambuf;\x0a"
"typedef basic_istream<char>          istream;\x0a"
"typedef basic_ostream<char>          ostream;\x0a"
"typedef basic_iostream<char>         iostream;\x0a"
"\x0a"
"typedef basic_stringbuf<char>        stringbuf;\x0a"
"typedef basic_istringstream<char>    istringstream;\x0a"
"typedef basic_ostringstream<char>    ostringstream;\x0a"
"typedef basic_stringstream<char>     stringstream;\x0a"
"\x0a"
"typedef basic_filebuf<char>          filebuf;\x0a"
"typedef basic_ifstream<char>         ifstream;\x0a"
"typedef basic_ofstream<char>         ofstream;\x0a"
"typedef basic_fstream<char>          fstream;\x0a"
"\x0a"
"typedef basic_streambuf<wchar_t>     wstreambuf;\x0a"
"typedef basic_istream<wchar_t>       wistream;\x0a"
"typedef basic_ostream<wchar_t>       wostream;\x0a"
"typedef basic_iostream<wchar_t>      wiostream;\x0a"
"\x0a"
"typedef basic_stringbuf<wchar_t>     wstringbuf;\x0a"
"typedef basic_istringstream<wchar_t> wistringstream;\x0a"
"typedef basic_ostringstream<wchar_t> wostringstream;\x0a"
"typedef basic_stringstream<wchar_t>  wstringstream;\x0a"
"\x0a"
"typedef basic_filebuf<wchar_t>       wfilebuf;\x0a"
"typedef basic_ifstream<wchar_t>      wifstream;\x0a"
"typedef basic_ofstream<wchar_t>      wofstream;\x0a"
"typedef basic_fstream<wchar_t>       wfstream;\x0a"
"\x0a"
"template <class state> class fpos;\x0a"
"typedef fpos<char_traits<char>\x3a\x3astate_type>    streampos;\x0a"
"typedef fpos<char_traits<wchar_t>\x3a\x3astate_type> wstreampos;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <wchar.h>  // for mbstate_t\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS ios_base;\x0a"
"\x0a"
"template<class _CharT>  struct _LIBCPP_TEMPLATE_VIS char_traits;\x0a"
"template<> struct char_traits<char>;\x0a"
"#ifndef _LIBCPP_NO_HAS_CHAR8_T\x0a"
"template<> struct char_traits<char8_t>;\x0a"
"#endif\x0a"
"template<> struct char_traits<char16_t>;\x0a"
"template<> struct char_traits<char32_t>;\x0a"
"template<> struct char_traits<wchar_t>;\x0a"
"\x0a"
"template<class _Tp>     class _LIBCPP_TEMPLATE_VIS allocator;\x0a"
"\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_ios;\x0a"
"\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_streambuf;\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_istream;\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_ostream;\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_iostream;\x0a"
"\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT>,\x0a"
"          class _Allocator = allocator<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_stringbuf;\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT>,\x0a"
"          class _Allocator = allocator<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_istringstream;\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT>,\x0a"
"          class _Allocator = allocator<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_ostringstream;\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT>,\x0a"
"          class _Allocator = allocator<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_stringstream;\x0a"
"\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_filebuf;\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_ifstream;\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_ofstream;\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_fstream;\x0a"
"\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS istreambuf_iterator;\x0a"
"template <class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS ostreambuf_iterator;\x0a"
"\x0a"
"typedef basic_ios<char>              ios;\x0a"
"typedef basic_ios<wchar_t>           wios;\x0a"
"\x0a"
"typedef basic_streambuf<char>        streambuf;\x0a"
"typedef basic_istream<char>          istream;\x0a"
"typedef basic_ostream<char>          ostream;\x0a"
"typedef basic_iostream<char>         iostream;\x0a"
"\x0a"
"typedef basic_stringbuf<char>        stringbuf;\x0a"
"typedef basic_istringstream<char>    istringstream;\x0a"
"typedef basic_ostringstream<char>    ostringstream;\x0a"
"typedef basic_stringstream<char>     stringstream;\x0a"
"\x0a"
"typedef basic_filebuf<char>          filebuf;\x0a"
"typedef basic_ifstream<char>         ifstream;\x0a"
"typedef basic_ofstream<char>         ofstream;\x0a"
"typedef basic_fstream<char>          fstream;\x0a"
"\x0a"
"typedef basic_streambuf<wchar_t>     wstreambuf;\x0a"
"typedef basic_istream<wchar_t>       wistream;\x0a"
"typedef basic_ostream<wchar_t>       wostream;\x0a"
"typedef basic_iostream<wchar_t>      wiostream;\x0a"
"\x0a"
"typedef basic_stringbuf<wchar_t>     wstringbuf;\x0a"
"typedef basic_istringstream<wchar_t> wistringstream;\x0a"
"typedef basic_ostringstream<wchar_t> wostringstream;\x0a"
"typedef basic_stringstream<wchar_t>  wstringstream;\x0a"
"\x0a"
"typedef basic_filebuf<wchar_t>       wfilebuf;\x0a"
"typedef basic_ifstream<wchar_t>      wifstream;\x0a"
"typedef basic_ofstream<wchar_t>      wofstream;\x0a"
"typedef basic_fstream<wchar_t>       wfstream;\x0a"
"\x0a"
"template <class _State>             class _LIBCPP_TEMPLATE_VIS fpos;\x0a"
"typedef fpos<mbstate_t>    streampos;\x0a"
"typedef fpos<mbstate_t>    wstreampos;\x0a"
"#ifndef _LIBCPP_NO_HAS_CHAR8_T\x0a"
"typedef fpos<mbstate_t>    u8streampos;\x0a"
"#endif\x0a"
"#ifndef _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"typedef fpos<mbstate_t>    u16streampos;\x0a"
"typedef fpos<mbstate_t>    u32streampos;\x0a"
"#endif  // _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"\x0a"
"#if defined(_NEWLIB_VERSION)\x0a"
"// On newlib, off_t is 'long int'\x0a"
"typedef long int streamoff;         // for char_traits in <string>\x0a"
"#else\x0a"
"typedef long long streamoff;        // for char_traits in <string>\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT,             // for <stdexcept>\x0a"
"          class _Traits = char_traits<_CharT>,\x0a"
"          class _Allocator = allocator<_CharT> >\x0a"
"    class _LIBCPP_TEMPLATE_VIS basic_string;\x0a"
"typedef basic_string<char, char_traits<char>, allocator<char> > string;\x0a"
"typedef basic_string<wchar_t, char_traits<wchar_t>, allocator<wchar_t> > wstring;\x0a"
"\x0a"
"\x0a"
"// Include other forward declarations here\x0a"
"template <class _Tp, class _Alloc = allocator<_Tp> >\x0a"
"class _LIBCPP_TEMPLATE_VIS vector;\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_IOSFWD\x0a"
"", 8465 ); }