#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_istream( 
"// -*- C++ -*-\x0a"
"//===--------------------------- istream ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_ISTREAM\x0a"
"#define _LIBCPP_ISTREAM\x0a"
"\x0a"
"/*\x0a"
"    istream synopsis\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> >\x0a"
"class basic_istream\x0a"
"    \x3a virtual public basic_ios<charT,traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types (inherited from basic_ios (27.5.4))\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    // 27.7.1.1.1 Constructor/destructor\x3a\x0a"
"    explicit basic_istream(basic_streambuf<char_type, traits_type>* sb);\x0a"
"    basic_istream(basic_istream\x26\x26 rhs);\x0a"
"    virtual \x7e""basic_istream();\x0a"
"\x0a"
"    // 27.7.1.1.2 Assign/swap\x3a\x0a"
"    basic_istream\x26 operator=(basic_istream\x26\x26 rhs);\x0a"
"    void swap(basic_istream\x26 rhs);\x0a"
"\x0a"
"    // 27.7.1.1.3 Prefix/suffix\x3a\x0a"
"    class sentry;\x0a"
"\x0a"
"    // 27.7.1.2 Formatted input\x3a\x0a"
"    basic_istream\x26 operator>>(basic_istream\x26 (*pf)(basic_istream\x26));\x0a"
"    basic_istream\x26 operator>>(basic_ios<char_type, traits_type>\x26\x0a"
"                              (*pf)(basic_ios<char_type, traits_type>\x26));\x0a"
"    basic_istream\x26 operator>>(ios_base\x26 (*pf)(ios_base\x26));\x0a"
"    basic_istream\x26 operator>>(basic_streambuf<char_type, traits_type>* sb);\x0a"
"    basic_istream\x26 operator>>(bool\x26 n);\x0a"
"    basic_istream\x26 operator>>(short\x26 n);\x0a"
"    basic_istream\x26 operator>>(unsigned short\x26 n);\x0a"
"    basic_istream\x26 operator>>(int\x26 n);\x0a"
"    basic_istream\x26 operator>>(unsigned int\x26 n);\x0a"
"    basic_istream\x26 operator>>(long\x26 n);\x0a"
"    basic_istream\x26 operator>>(unsigned long\x26 n);\x0a"
"    basic_istream\x26 operator>>(long long\x26 n);\x0a"
"    basic_istream\x26 operator>>(unsigned long long\x26 n);\x0a"
"    basic_istream\x26 operator>>(float\x26 f);\x0a"
"    basic_istream\x26 operator>>(double\x26 f);\x0a"
"    basic_istream\x26 operator>>(long double\x26 f);\x0a"
"    basic_istream\x26 operator>>(void*\x26 p);\x0a"
"\x0a"
"    // 27.7.1.3 Unformatted input\x3a\x0a"
"    streamsize gcount() const;\x0a"
"    int_type get();\x0a"
"    basic_istream\x26 get(char_type\x26 c);\x0a"
"    basic_istream\x26 get(char_type* s, streamsize n);\x0a"
"    basic_istream\x26 get(char_type* s, streamsize n, char_type delim);\x0a"
"    basic_istream\x26 get(basic_streambuf<char_type,traits_type>\x26 sb);\x0a"
"    basic_istream\x26 get(basic_streambuf<char_type,traits_type>\x26 sb, char_type delim);\x0a"
"\x0a"
"    basic_istream\x26 getline(char_type* s, streamsize n);\x0a"
"    basic_istream\x26 getline(char_type* s, streamsize n, char_type delim);\x0a"
"\x0a"
"    basic_istream\x26 ignore(streamsize n = 1, int_type delim = traits_type\x3a\x3a""eof());\x0a"
"    int_type peek();\x0a"
"    basic_istream\x26 read (char_type* s, streamsize n);\x0a"
"    streamsize readsome(char_type* s, streamsize n);\x0a"
"\x0a"
"    basic_istream\x26 putback(char_type c);\x0a"
"    basic_istream\x26 unget();\x0a"
"    int sync();\x0a"
"\x0a"
"    pos_type tellg();\x0a"
"    basic_istream\x26 seekg(pos_type);\x0a"
"    basic_istream\x26 seekg(off_type, ios_base\x3a\x3aseekdir);\x0a"
"protected\x3a\x0a"
"    basic_istream(const basic_istream\x26 rhs) = delete;\x0a"
"    basic_istream(basic_istream\x26\x26 rhs);\x0a"
"    // 27.7.2.1.2 Assign/swap\x3a\x0a"
"    basic_istream\x26 operator=(const basic_istream\x26 rhs) = delete;\x0a"
"    basic_istream\x26 operator=(basic_istream\x26\x26 rhs);\x0a"
"    void swap(basic_istream\x26 rhs);\x0a"
"};\x0a"
"\x0a"
"// 27.7.1.2.3 character extraction templates\x3a\x0a"
"template<class charT, class traits>\x0a"
"  basic_istream<charT,traits>\x26 operator>>(basic_istream<charT,traits>\x26, charT\x26);\x0a"
"\x0a"
"template<class traits>\x0a"
"  basic_istream<char,traits>\x26 operator>>(basic_istream<char,traits>\x26, unsigned char\x26);\x0a"
"\x0a"
"template<class traits>\x0a"
"  basic_istream<char,traits>\x26 operator>>(basic_istream<char,traits>\x26, signed char\x26);\x0a"
"\x0a"
"template<class charT, class traits>\x0a"
"  basic_istream<charT,traits>\x26 operator>>(basic_istream<charT,traits>\x26, charT*);\x0a"
"\x0a"
"template<class traits>\x0a"
"  basic_istream<char,traits>\x26 operator>>(basic_istream<char,traits>\x26, unsigned char*);\x0a"
"\x0a"
"template<class traits>\x0a"
"  basic_istream<char,traits>\x26 operator>>(basic_istream<char,traits>\x26, signed char*);\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"  void\x0a"
"  swap(basic_istream<charT, traits>\x26 x, basic_istream<charT, traits>\x26 y);\x0a"
"\x0a"
"typedef basic_istream<char> istream;\x0a"
"typedef basic_istream<wchar_t> wistream;\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> >\x0a"
"class basic_iostream \x3a\x0a"
"    public basic_istream<charT,traits>,\x0a"
"    public basic_ostream<charT,traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    // constructor/destructor\x0a"
"    explicit basic_iostream(basic_streambuf<char_type, traits_type>* sb);\x0a"
"    basic_iostream(basic_iostream\x26\x26 rhs);\x0a"
"    virtual \x7e""basic_iostream();\x0a"
"\x0a"
"    // assign/swap\x0a"
"    basic_iostream\x26 operator=(basic_iostream\x26\x26 rhs);\x0a"
"    void swap(basic_iostream\x26 rhs);\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"  void\x0a"
"  swap(basic_iostream<charT, traits>\x26 x, basic_iostream<charT, traits>\x26 y);\x0a"
"\x0a"
"typedef basic_iostream<char> iostream;\x0a"
"typedef basic_iostream<wchar_t> wiostream;\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"  basic_istream<charT,traits>\x26\x0a"
"  ws(basic_istream<charT,traits>\x26 is);\x0a"
"\x0a"
"template <class charT, class traits, class T>\x0a"
"  basic_istream<charT, traits>\x26\x0a"
"  operator>>(basic_istream<charT, traits>\x26\x26 is, T\x26 x);\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <version>\x0a"
"#include <ostream>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_istream\x0a"
"    \x3a virtual public basic_ios<_CharT, _Traits>\x0a"
"{\x0a"
"    streamsize __gc_;\x0a"
"public\x3a\x0a"
"    // types (inherited from basic_ios (27.5.4))\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    // 27.7.1.1.1 Constructor/destructor\x3a\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    explicit basic_istream(basic_streambuf<char_type, traits_type>* __sb) \x3a __gc_(0)\x0a"
"    { this->init(__sb); }\x0a"
"    virtual \x7e""basic_istream();\x0a"
"protected\x3a\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_istream(basic_istream\x26\x26 __rhs);\x0a"
"\x0a"
"    // 27.7.1.1.2 Assign/swap\x3a\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_istream\x26 operator=(basic_istream\x26\x26 __rhs);\x0a"
"#endif\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    void swap(basic_istream\x26 __rhs) {\x0a"
"      _VSTD\x3a\x3aswap(__gc_, __rhs.__gc_);\x0a"
"      basic_ios<char_type, traits_type>\x3a\x3aswap(__rhs);\x0a"
"    }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    basic_istream           (const basic_istream\x26 __rhs) = delete;\x0a"
"    basic_istream\x26 operator=(const basic_istream\x26 __rhs) = delete;\x0a"
"#endif\x0a"
"public\x3a\x0a"
"\x0a"
"    // 27.7.1.1.3 Prefix/suffix\x3a\x0a"
"    class _LIBCPP_TEMPLATE_VIS sentry;\x0a"
"\x0a"
"    // 27.7.1.2 Formatted input\x3a\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_istream\x26 operator>>(basic_istream\x26 (*__pf)(basic_istream\x26))\x0a"
"    { return __pf(*this); }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_istream\x26 operator>>(basic_ios<char_type, traits_type>\x26\x0a"
"                              (*__pf)(basic_ios<char_type, traits_type>\x26))\x0a"
"    { __pf(*this); return *this; }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_istream\x26 operator>>(ios_base\x26 (*__pf)(ios_base\x26))\x0a"
"    { __pf(*this); return *this; }\x0a"
"\x0a"
"    basic_istream\x26 operator>>(basic_streambuf<char_type, traits_type>* __sb);\x0a"
"    basic_istream\x26 operator>>(bool\x26 __n);\x0a"
"    basic_istream\x26 operator>>(short\x26 __n);\x0a"
"    basic_istream\x26 operator>>(unsigned short\x26 __n);\x0a"
"    basic_istream\x26 operator>>(int\x26 __n);\x0a"
"    basic_istream\x26 operator>>(unsigned int\x26 __n);\x0a"
"    basic_istream\x26 operator>>(long\x26 __n);\x0a"
"    basic_istream\x26 operator>>(unsigned long\x26 __n);\x0a"
"    basic_istream\x26 operator>>(long long\x26 __n);\x0a"
"    basic_istream\x26 operator>>(unsigned long long\x26 __n);\x0a"
"    basic_istream\x26 operator>>(float\x26 __f);\x0a"
"    basic_istream\x26 operator>>(double\x26 __f);\x0a"
"    basic_istream\x26 operator>>(long double\x26 __f);\x0a"
"    basic_istream\x26 operator>>(void*\x26 __p);\x0a"
"\x0a"
"    // 27.7.1.3 Unformatted input\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    streamsize gcount() const {return __gc_;}\x0a"
"    int_type get();\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_istream\x26 get(char_type\x26 __c) {\x0a"
"      int_type __ch = get();\x0a"
"      if (__ch \x21= traits_type\x3a\x3a""eof())\x0a"
"        __c = traits_type\x3a\x3ato_char_type(__ch);\x0a"
"      return *this;\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_istream\x26 get(char_type* __s, streamsize __n)\x0a"
"    { return get(__s, __n, this->widen('\x5cn')); }\x0a"
"\x0a"
"    basic_istream\x26 get(char_type* __s, streamsize __n, char_type __dlm);\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_istream\x26 get(basic_streambuf<char_type, traits_type>\x26 __sb)\x0a"
"    { return get(__sb, this->widen('\x5cn')); }\x0a"
"\x0a"
"    basic_istream\x26 get(basic_streambuf<char_type, traits_type>\x26 __sb, char_type __dlm);\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_istream\x26 getline(char_type* __s, streamsize __n)\x0a"
"    { return getline(__s, __n, this->widen('\x5cn')); }\x0a"
"\x0a"
"    basic_istream\x26 getline(char_type* __s, streamsize __n, char_type __dlm);\x0a"
"\x0a"
"    basic_istream\x26 ignore(streamsize __n = 1, int_type __dlm = traits_type\x3a\x3a""eof());\x0a"
"    int_type peek();\x0a"
"    basic_istream\x26 read (char_type* __s, streamsize __n);\x0a"
"    streamsize readsome(char_type* __s, streamsize __n);\x0a"
"\x0a"
"    basic_istream\x26 putback(char_type __c);\x0a"
"    basic_istream\x26 unget();\x0a"
"    int sync();\x0a"
"\x0a"
"    pos_type tellg();\x0a"
"    basic_istream\x26 seekg(pos_type __pos);\x0a"
"    basic_istream\x26 seekg(off_type __off, ios_base\x3a\x3aseekdir __dir);\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_istream<_CharT, _Traits>\x3a\x3asentry\x0a"
"{\x0a"
"    bool __ok_;\x0a"
"\x0a"
"    sentry(const sentry\x26); // = delete;\x0a"
"    sentry\x26 operator=(const sentry\x26); // = delete;\x0a"
"\x0a"
"public\x3a\x0a"
"    explicit sentry(basic_istream<_CharT, _Traits>\x26 __is, bool __noskipws = false);\x0a"
"//    \x7esentry() = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        _LIBCPP_EXPLICIT\x0a"
"        operator bool() const {return __ok_;}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3asentry\x3a\x3asentry(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"                                               bool __noskipws)\x0a"
"    \x3a __ok_(false)\x0a"
"{\x0a"
"    if (__is.good())\x0a"
"    {\x0a"
"        if (__is.tie())\x0a"
"            __is.tie()->flush();\x0a"
"        if (\x21__noskipws \x26\x26 (__is.flags() \x26 ios_base\x3a\x3askipws))\x0a"
"        {\x0a"
"            typedef istreambuf_iterator<_CharT, _Traits> _Ip;\x0a"
"            const ctype<_CharT>\x26 __ct = use_facet<ctype<_CharT> >(__is.getloc());\x0a"
"            _Ip __i(__is);\x0a"
"            _Ip __eof;\x0a"
"            for (; __i \x21= __eof; ++__i)\x0a"
"                if (\x21__ct.is(__ct.space, *__i))\x0a"
"                    break;\x0a"
"            if (__i == __eof)\x0a"
"                __is.setstate(ios_base\x3a\x3a""failbit \x7c ios_base\x3a\x3a""eofbit);\x0a"
"        }\x0a"
"        __ok_ = __is.good();\x0a"
"    }\x0a"
"    else\x0a"
"        __is.setstate(ios_base\x3a\x3a""failbit);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3a""basic_istream(basic_istream\x26\x26 __rhs)\x0a"
"    \x3a __gc_(__rhs.__gc_)\x0a"
"{\x0a"
"    __rhs.__gc_ = 0;\x0a"
"    this->move(__rhs);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator=(basic_istream\x26\x26 __rhs)\x0a"
"{\x0a"
"    swap(__rhs);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3a\x7e""basic_istream()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _CharT, class _Traits>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"__input_arithmetic(basic_istream<_CharT, _Traits>\x26 __is, _Tp\x26 __n) {\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    typename basic_istream<_CharT, _Traits>\x3a\x3asentry __s(__is);\x0a"
"    if (__s)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            typedef istreambuf_iterator<_CharT, _Traits> _Ip;\x0a"
"            typedef num_get<_CharT, _Ip> _Fp;\x0a"
"            use_facet<_Fp>(__is.getloc()).get(_Ip(__is), _Ip(), __is, __state, __n);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            __is.__setstate_nothrow(__state);\x0a"
"            if (__is.exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif\x0a"
"        __is.setstate(__state);\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(unsigned short\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<unsigned short>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(unsigned int\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<unsigned int>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(long\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<long>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(unsigned long\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<unsigned long>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(long long\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<long long>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(unsigned long long\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<unsigned long long>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(float\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<float>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(double\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<double>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(long double\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<long double>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(bool\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<bool>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(void*\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic<void*>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _CharT, class _Traits>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"__input_arithmetic_with_numeric_limits(basic_istream<_CharT, _Traits>\x26 __is, _Tp\x26 __n) {\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    typename basic_istream<_CharT, _Traits>\x3a\x3asentry __s(__is);\x0a"
"    if (__s)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            typedef istreambuf_iterator<_CharT, _Traits> _Ip;\x0a"
"            typedef num_get<_CharT, _Ip> _Fp;\x0a"
"            long __temp;\x0a"
"            use_facet<_Fp>(__is.getloc()).get(_Ip(__is), _Ip(), __is, __state, __temp);\x0a"
"            if (__temp < numeric_limits<_Tp>\x3a\x3amin())\x0a"
"            {\x0a"
"                __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"                __n = numeric_limits<_Tp>\x3a\x3amin();\x0a"
"            }\x0a"
"            else if (__temp > numeric_limits<_Tp>\x3a\x3amax())\x0a"
"            {\x0a"
"                __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"                __n = numeric_limits<_Tp>\x3a\x3amax();\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                __n = static_cast<_Tp>(__temp);\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            __is.__setstate_nothrow(__state);\x0a"
"            if (__is.exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __is.setstate(__state);\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(short\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic_with_numeric_limits<short>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(int\x26 __n)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__input_arithmetic_with_numeric_limits<int>(*this, __n);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"__input_c_string(basic_istream<_CharT, _Traits>\x26 __is, _CharT* __p, size_t __n)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    typename basic_istream<_CharT, _Traits>\x3a\x3asentry __sen(__is);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif\x0a"
"            _CharT* __s = __p;\x0a"
"            const ctype<_CharT>\x26 __ct = use_facet<ctype<_CharT> >(__is.getloc());\x0a"
"            while (__s \x21= __p + (__n-1))\x0a"
"            {\x0a"
"                typename _Traits\x3a\x3aint_type __i = __is.rdbuf()->sgetc();\x0a"
"                if (_Traits\x3a\x3a""eq_int_type(__i, _Traits\x3a\x3a""eof()))\x0a"
"                {\x0a"
"                   __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                   break;\x0a"
"                }\x0a"
"                _CharT __ch = _Traits\x3a\x3ato_char_type(__i);\x0a"
"                if (__ct.is(__ct.space, __ch))\x0a"
"                    break;\x0a"
"                *__s++ = __ch;\x0a"
"                 __is.rdbuf()->sbumpc();\x0a"
"            }\x0a"
"            *__s = _CharT();\x0a"
"            __is.width(0);\x0a"
"            if (__s == __p)\x0a"
"               __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            __is.__setstate_nothrow(__state);\x0a"
"            if (__is.exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif\x0a"
"        __is.setstate(__state);\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"template<class _CharT, class _Traits, size_t _Np>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, _CharT (\x26__buf)\x5b_Np\x5d)\x0a"
"{\x0a"
"    size_t __n = _Np;\x0a"
"    if (__is.width() > 0)\x0a"
"        __n = _VSTD\x3a\x3amin(size_t(__is.width()), _Np);\x0a"
"    return _VSTD\x3a\x3a__input_c_string(__is, __buf, __n);\x0a"
"}\x0a"
"\x0a"
"template<class _Traits, size_t _Np>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<char, _Traits>\x26\x0a"
"operator>>(basic_istream<char, _Traits>\x26 __is, unsigned char (\x26__buf)\x5b_Np\x5d)\x0a"
"{\x0a"
"    return __is >> (char(\x26)\x5b_Np\x5d)__buf;\x0a"
"}\x0a"
"\x0a"
"template<class _Traits, size_t _Np>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<char, _Traits>\x26\x0a"
"operator>>(basic_istream<char, _Traits>\x26 __is, signed char (\x26__buf)\x5b_Np\x5d)\x0a"
"{\x0a"
"    return __is >> (char(\x26)\x5b_Np\x5d)__buf;\x0a"
"}\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, _CharT* __s)\x0a"
"{\x0a"
"    streamsize __n = __is.width();\x0a"
"    if (__n <= 0)\x0a"
"        __n = numeric_limits<streamsize>\x3a\x3amax() / sizeof(_CharT) - 1;\x0a"
"    return _VSTD\x3a\x3a__input_c_string(__is, __s, size_t(__n));\x0a"
"}\x0a"
"\x0a"
"template<class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<char, _Traits>\x26\x0a"
"operator>>(basic_istream<char, _Traits>\x26 __is, unsigned char* __s)\x0a"
"{\x0a"
"    return __is >> (char*)__s;\x0a"
"}\x0a"
"\x0a"
"template<class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<char, _Traits>\x26\x0a"
"operator>>(basic_istream<char, _Traits>\x26 __is, signed char* __s)\x0a"
"{\x0a"
"    return __is >> (char*)__s;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, _CharT\x26 __c)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    typename basic_istream<_CharT, _Traits>\x3a\x3asentry __sen(__is);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif\x0a"
"            typename _Traits\x3a\x3aint_type __i = __is.rdbuf()->sbumpc();\x0a"
"            if (_Traits\x3a\x3a""eq_int_type(__i, _Traits\x3a\x3a""eof()))\x0a"
"                __state \x7c= ios_base\x3a\x3a""eofbit \x7c ios_base\x3a\x3a""failbit;\x0a"
"            else\x0a"
"                __c = _Traits\x3a\x3ato_char_type(__i);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            __is.__setstate_nothrow(__state);\x0a"
"            if (__is.exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif\x0a"
"        __is.setstate(__state);\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"template<class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<char, _Traits>\x26\x0a"
"operator>>(basic_istream<char, _Traits>\x26 __is, unsigned char\x26 __c)\x0a"
"{\x0a"
"    return __is >> (char\x26)__c;\x0a"
"}\x0a"
"\x0a"
"template<class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<char, _Traits>\x26\x0a"
"operator>>(basic_istream<char, _Traits>\x26 __is, signed char\x26 __c)\x0a"
"{\x0a"
"    return __is >> (char\x26)__c;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aoperator>>(basic_streambuf<char_type, traits_type>* __sb)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    __gc_ = 0;\x0a"
"    sentry __s(*this, true);\x0a"
"    if (__s)\x0a"
"    {\x0a"
"        if (__sb)\x0a"
"        {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"            try\x0a"
"            {\x0a"
"#endif // _LIBCPP_NO_EXCEPTIONS\x0a"
"                while (true)\x0a"
"                {\x0a"
"                    typename traits_type\x3a\x3aint_type __i = this->rdbuf()->sgetc();\x0a"
"                    if (traits_type\x3a\x3a""eq_int_type(__i, _Traits\x3a\x3a""eof()))\x0a"
"                    {\x0a"
"                       __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                       break;\x0a"
"                    }\x0a"
"                    if (traits_type\x3a\x3a""eq_int_type(\x0a"
"                            __sb->sputc(traits_type\x3a\x3ato_char_type(__i)),\x0a"
"                            traits_type\x3a\x3a""eof()))\x0a"
"                        break;\x0a"
"                    ++__gc_;\x0a"
"                    this->rdbuf()->sbumpc();\x0a"
"                }\x0a"
"                if (__gc_ == 0)\x0a"
"                   __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"            }\x0a"
"            catch (...)\x0a"
"            {\x0a"
"                __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"                if (__gc_ == 0)\x0a"
"                    __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"\x0a"
"                this->__setstate_nothrow(__state);\x0a"
"                if (this->exceptions() \x26 ios_base\x3a\x3a""failbit \x7c\x7c this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"                {\x0a"
"                    throw;\x0a"
"                }\x0a"
"            }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"        }\x0a"
"        this->setstate(__state);\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"typename basic_istream<_CharT, _Traits>\x3a\x3aint_type\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aget()\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    __gc_ = 0;\x0a"
"    int_type __r = traits_type\x3a\x3a""eof();\x0a"
"    sentry __s(*this, true);\x0a"
"    if (__s)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif\x0a"
"            __r = this->rdbuf()->sbumpc();\x0a"
"            if (traits_type\x3a\x3a""eq_int_type(__r, traits_type\x3a\x3a""eof()))\x0a"
"               __state \x7c= ios_base\x3a\x3a""failbit \x7c ios_base\x3a\x3a""eofbit;\x0a"
"            else\x0a"
"                __gc_ = 1;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            this->__setstate_nothrow(this->rdstate() \x7c ios_base\x3a\x3a""badbit);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif\x0a"
"        this->setstate(__state);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aget(char_type* __s, streamsize __n, char_type __dlm)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    __gc_ = 0;\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"        if (__n > 0)\x0a"
"        {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"            try\x0a"
"            {\x0a"
"#endif\x0a"
"                while (__gc_ < __n-1)\x0a"
"                {\x0a"
"                    int_type __i = this->rdbuf()->sgetc();\x0a"
"                    if (traits_type\x3a\x3a""eq_int_type(__i, traits_type\x3a\x3a""eof()))\x0a"
"                    {\x0a"
"                       __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                       break;\x0a"
"                    }\x0a"
"                    char_type __ch = traits_type\x3a\x3ato_char_type(__i);\x0a"
"                    if (traits_type\x3a\x3a""eq(__ch, __dlm))\x0a"
"                        break;\x0a"
"                    *__s++ = __ch;\x0a"
"                    ++__gc_;\x0a"
"                     this->rdbuf()->sbumpc();\x0a"
"                }\x0a"
"                if (__gc_ == 0)\x0a"
"                   __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"            }\x0a"
"            catch (...)\x0a"
"            {\x0a"
"                __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"                this->__setstate_nothrow(__state);\x0a"
"                if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"                {\x0a"
"                    if (__n > 0)\x0a"
"                        *__s = char_type();\x0a"
"                    throw;\x0a"
"                }\x0a"
"            }\x0a"
"#endif\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"        }\x0a"
"\x0a"
"        if (__n > 0)\x0a"
"            *__s = char_type();\x0a"
"        this->setstate(__state);\x0a"
"    }\x0a"
"    if (__n > 0)\x0a"
"        *__s = char_type();\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aget(basic_streambuf<char_type, traits_type>\x26 __sb,\x0a"
"                                    char_type __dlm)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    __gc_ = 0;\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            while (true)\x0a"
"            {\x0a"
"                typename traits_type\x3a\x3aint_type __i = this->rdbuf()->sgetc();\x0a"
"                if (traits_type\x3a\x3a""eq_int_type(__i, traits_type\x3a\x3a""eof()))\x0a"
"                {\x0a"
"                   __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                   break;\x0a"
"                }\x0a"
"                char_type __ch = traits_type\x3a\x3ato_char_type(__i);\x0a"
"                if (traits_type\x3a\x3a""eq(__ch, __dlm))\x0a"
"                    break;\x0a"
"                if (traits_type\x3a\x3a""eq_int_type(__sb.sputc(__ch), traits_type\x3a\x3a""eof()))\x0a"
"                    break;\x0a"
"                ++__gc_;\x0a"
"                this->rdbuf()->sbumpc();\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            // according to the spec, exceptions here are caught but not rethrown\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        if (__gc_ == 0)\x0a"
"           __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"        this->setstate(__state);\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3agetline(char_type* __s, streamsize __n, char_type __dlm)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    __gc_ = 0;\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            while (true)\x0a"
"            {\x0a"
"                typename traits_type\x3a\x3aint_type __i = this->rdbuf()->sgetc();\x0a"
"                if (traits_type\x3a\x3a""eq_int_type(__i, traits_type\x3a\x3a""eof()))\x0a"
"                {\x0a"
"                   __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                   break;\x0a"
"                }\x0a"
"                char_type __ch = traits_type\x3a\x3ato_char_type(__i);\x0a"
"                if (traits_type\x3a\x3a""eq(__ch, __dlm))\x0a"
"                {\x0a"
"                    this->rdbuf()->sbumpc();\x0a"
"                    ++__gc_;\x0a"
"                    break;\x0a"
"                }\x0a"
"                if (__gc_ >= __n-1)\x0a"
"                {\x0a"
"                    __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"                    break;\x0a"
"                }\x0a"
"                *__s++ = __ch;\x0a"
"                this->rdbuf()->sbumpc();\x0a"
"                ++__gc_;\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                if (__n > 0)\x0a"
"                    *__s = char_type();\x0a"
"                if (__gc_ == 0)\x0a"
"                    __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    if (__n > 0)\x0a"
"        *__s = char_type();\x0a"
"    if (__gc_ == 0)\x0a"
"        __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"    this->setstate(__state);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aignore(streamsize __n, int_type __dlm)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    __gc_ = 0;\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            if (__n == numeric_limits<streamsize>\x3a\x3amax())\x0a"
"            {\x0a"
"                while (true)\x0a"
"                {\x0a"
"                    typename traits_type\x3a\x3aint_type __i = this->rdbuf()->sbumpc();\x0a"
"                    if (traits_type\x3a\x3a""eq_int_type(__i, traits_type\x3a\x3a""eof()))\x0a"
"                    {\x0a"
"                       __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                       break;\x0a"
"                    }\x0a"
"                    ++__gc_;\x0a"
"                    if (traits_type\x3a\x3a""eq_int_type(__i, __dlm))\x0a"
"                        break;\x0a"
"                }\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                while (__gc_ < __n)\x0a"
"                {\x0a"
"                    typename traits_type\x3a\x3aint_type __i = this->rdbuf()->sbumpc();\x0a"
"                    if (traits_type\x3a\x3a""eq_int_type(__i, traits_type\x3a\x3a""eof()))\x0a"
"                    {\x0a"
"                       __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                       break;\x0a"
"                    }\x0a"
"                    ++__gc_;\x0a"
"                    if (traits_type\x3a\x3a""eq_int_type(__i, __dlm))\x0a"
"                        break;\x0a"
"                }\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        this->setstate(__state);\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"typename basic_istream<_CharT, _Traits>\x3a\x3aint_type\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3apeek()\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    __gc_ = 0;\x0a"
"    int_type __r = traits_type\x3a\x3a""eof();\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            __r = this->rdbuf()->sgetc();\x0a"
"            if (traits_type\x3a\x3a""eq_int_type(__r, traits_type\x3a\x3a""eof()))\x0a"
"                __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        this->setstate(__state);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aread(char_type* __s, streamsize __n)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    __gc_ = 0;\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            __gc_ = this->rdbuf()->sgetn(__s, __n);\x0a"
"            if (__gc_ \x21= __n)\x0a"
"                __state \x7c= ios_base\x3a\x3a""failbit \x7c ios_base\x3a\x3a""eofbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"    }\x0a"
"    this->setstate(__state);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"streamsize\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3areadsome(char_type* __s, streamsize __n)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    __gc_ = 0;\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            streamsize __c = this->rdbuf()->in_avail();\x0a"
"            switch (__c)\x0a"
"            {\x0a"
"            case -1\x3a\x0a"
"                __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                break;\x0a"
"            case 0\x3a\x0a"
"                break;\x0a"
"            default\x3a\x0a"
"                __n = _VSTD\x3a\x3amin(__c, __n);\x0a"
"                __gc_ = this->rdbuf()->sgetn(__s, __n);\x0a"
"                if (__gc_ \x21= __n)\x0a"
"                    __state \x7c= ios_base\x3a\x3a""failbit \x7c ios_base\x3a\x3a""eofbit;\x0a"
"                break;\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"    }\x0a"
"    this->setstate(__state);\x0a"
"    return __gc_;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aputback(char_type __c)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = this->rdstate() \x26 \x7eios_base\x3a\x3a""eofbit;\x0a"
"    __gc_ = 0;\x0a"
"    this->clear(__state);\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            if (this->rdbuf() == 0 \x7c\x7c this->rdbuf()->sputbackc(__c) == traits_type\x3a\x3a""eof())\x0a"
"                __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"    }\x0a"
"    this->setstate(__state);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aunget()\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = this->rdstate() \x26 \x7eios_base\x3a\x3a""eofbit;\x0a"
"    __gc_ = 0;\x0a"
"    this->clear(__state);\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            if (this->rdbuf() == 0 \x7c\x7c this->rdbuf()->sungetc() == traits_type\x3a\x3a""eof())\x0a"
"                __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"    }\x0a"
"    this->setstate(__state);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"int\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3async()\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    int __r = 0;\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            if (this->rdbuf() == 0)\x0a"
"                return -1;\x0a"
"            if (this->rdbuf()->pubsync() == -1)\x0a"
"            {\x0a"
"                __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"                return -1;\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        this->setstate(__state);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"typename basic_istream<_CharT, _Traits>\x3a\x3apos_type\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3atellg()\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    pos_type __r(-1);\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __r = this->rdbuf()->pubseekoff(0, ios_base\x3a\x3a""cur, ios_base\x3a\x3ain);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        this->setstate(__state);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aseekg(pos_type __pos)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = this->rdstate() \x26 \x7eios_base\x3a\x3a""eofbit;\x0a"
"    this->clear(__state);\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            if (this->rdbuf()->pubseekpos(__pos, ios_base\x3a\x3ain) == pos_type(-1))\x0a"
"                __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        this->setstate(__state);\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"basic_istream<_CharT, _Traits>\x3a\x3aseekg(off_type __off, ios_base\x3a\x3aseekdir __dir)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = this->rdstate() \x26 \x7eios_base\x3a\x3a""eofbit;\x0a"
"    this->clear(__state);\x0a"
"    sentry __sen(*this, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            if (this->rdbuf()->pubseekoff(__off, __dir, ios_base\x3a\x3ain) == pos_type(-1))\x0a"
"                __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            this->__setstate_nothrow(__state);\x0a"
"            if (this->exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        this->setstate(__state);\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"ws(basic_istream<_CharT, _Traits>\x26 __is)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    typename basic_istream<_CharT, _Traits>\x3a\x3asentry __sen(__is, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            const ctype<_CharT>\x26 __ct = use_facet<ctype<_CharT> >(__is.getloc());\x0a"
"            while (true)\x0a"
"            {\x0a"
"                typename _Traits\x3a\x3aint_type __i = __is.rdbuf()->sgetc();\x0a"
"                if (_Traits\x3a\x3a""eq_int_type(__i, _Traits\x3a\x3a""eof()))\x0a"
"                {\x0a"
"                   __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                   break;\x0a"
"                }\x0a"
"                if (\x21__ct.is(__ct.space, _Traits\x3a\x3ato_char_type(__i)))\x0a"
"                    break;\x0a"
"                __is.rdbuf()->sbumpc();\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            __is.__setstate_nothrow(__state);\x0a"
"            if (__is.exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __is.setstate(__state);\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26\x26 __is, _Tp\x26\x26 __x)\x0a"
"{\x0a"
"    __is >> _VSTD\x3a\x3a""forward<_Tp>(__x);\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_iostream\x0a"
"    \x3a public basic_istream<_CharT, _Traits>,\x0a"
"      public basic_ostream<_CharT, _Traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    // constructor/destructor\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    explicit basic_iostream(basic_streambuf<char_type, traits_type>* __sb)\x0a"
"      \x3a basic_istream<_CharT, _Traits>(__sb)\x0a"
"    {}\x0a"
"\x0a"
"    virtual \x7e""basic_iostream();\x0a"
"protected\x3a\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_iostream(basic_iostream\x26\x26 __rhs);\x0a"
"\x0a"
"    // assign/swap\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_iostream\x26 operator=(basic_iostream\x26\x26 __rhs);\x0a"
"#endif\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    void swap(basic_iostream\x26 __rhs)\x0a"
"    { basic_istream<char_type, traits_type>\x3a\x3aswap(__rhs); }\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_iostream<_CharT, _Traits>\x3a\x3a""basic_iostream(basic_iostream\x26\x26 __rhs)\x0a"
"    \x3a basic_istream<_CharT, _Traits>(_VSTD\x3a\x3amove(__rhs))\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_iostream<_CharT, _Traits>\x26\x0a"
"basic_iostream<_CharT, _Traits>\x3a\x3aoperator=(basic_iostream\x26\x26 __rhs)\x0a"
"{\x0a"
"    swap(__rhs);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_iostream<_CharT, _Traits>\x3a\x3a\x7e""basic_iostream()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           basic_string<_CharT, _Traits, _Allocator>\x26 __str)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    typename basic_istream<_CharT, _Traits>\x3a\x3asentry __sen(__is);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif\x0a"
"            __str.clear();\x0a"
"            streamsize __n = __is.width();\x0a"
"            if (__n <= 0)\x0a"
"                __n = __str.max_size();\x0a"
"            if (__n <= 0)\x0a"
"                __n = numeric_limits<streamsize>\x3a\x3amax();\x0a"
"            streamsize __c = 0;\x0a"
"            const ctype<_CharT>\x26 __ct = use_facet<ctype<_CharT> >(__is.getloc());\x0a"
"            while (__c < __n)\x0a"
"            {\x0a"
"                typename _Traits\x3a\x3aint_type __i = __is.rdbuf()->sgetc();\x0a"
"                if (_Traits\x3a\x3a""eq_int_type(__i, _Traits\x3a\x3a""eof()))\x0a"
"                {\x0a"
"                   __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                   break;\x0a"
"                }\x0a"
"                _CharT __ch = _Traits\x3a\x3ato_char_type(__i);\x0a"
"                if (__ct.is(__ct.space, __ch))\x0a"
"                    break;\x0a"
"                __str.push_back(__ch);\x0a"
"                ++__c;\x0a"
"                 __is.rdbuf()->sbumpc();\x0a"
"            }\x0a"
"            __is.width(0);\x0a"
"            if (__c == 0)\x0a"
"               __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            __is.__setstate_nothrow(__state);\x0a"
"            if (__is.exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif\x0a"
"        __is.setstate(__state);\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"getline(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"        basic_string<_CharT, _Traits, _Allocator>\x26 __str, _CharT __dlm)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    typename basic_istream<_CharT, _Traits>\x3a\x3asentry __sen(__is, true);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif\x0a"
"            __str.clear();\x0a"
"            streamsize __extr = 0;\x0a"
"            while (true)\x0a"
"            {\x0a"
"                typename _Traits\x3a\x3aint_type __i = __is.rdbuf()->sbumpc();\x0a"
"                if (_Traits\x3a\x3a""eq_int_type(__i, _Traits\x3a\x3a""eof()))\x0a"
"                {\x0a"
"                   __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                   break;\x0a"
"                }\x0a"
"                ++__extr;\x0a"
"                _CharT __ch = _Traits\x3a\x3ato_char_type(__i);\x0a"
"                if (_Traits\x3a\x3a""eq(__ch, __dlm))\x0a"
"                    break;\x0a"
"                __str.push_back(__ch);\x0a"
"                if (__str.size() == __str.max_size())\x0a"
"                {\x0a"
"                    __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"                    break;\x0a"
"                }\x0a"
"            }\x0a"
"            if (__extr == 0)\x0a"
"               __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            __is.__setstate_nothrow(__state);\x0a"
"            if (__is.exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif\x0a"
"        __is.setstate(__state);\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"getline(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"        basic_string<_CharT, _Traits, _Allocator>\x26 __str)\x0a"
"{\x0a"
"    return getline(__is, __str, __is.widen('\x5cn'));\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"getline(basic_istream<_CharT, _Traits>\x26\x26 __is,\x0a"
"        basic_string<_CharT, _Traits, _Allocator>\x26 __str, _CharT __dlm)\x0a"
"{\x0a"
"    return getline(__is, __str, __dlm);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"getline(basic_istream<_CharT, _Traits>\x26\x26 __is,\x0a"
"        basic_string<_CharT, _Traits, _Allocator>\x26 __str)\x0a"
"{\x0a"
"    return getline(__is, __str, __is.widen('\x5cn'));\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, size_t _Size>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, bitset<_Size>\x26 __x)\x0a"
"{\x0a"
"    ios_base\x3a\x3aiostate __state = ios_base\x3a\x3agoodbit;\x0a"
"    typename basic_istream<_CharT, _Traits>\x3a\x3asentry __sen(__is);\x0a"
"    if (__sen)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif\x0a"
"            basic_string<_CharT, _Traits> __str;\x0a"
"            const ctype<_CharT>\x26 __ct = use_facet<ctype<_CharT> >(__is.getloc());\x0a"
"            size_t __c = 0;\x0a"
"            _CharT __zero = __ct.widen('0');\x0a"
"            _CharT __one = __ct.widen('1');\x0a"
"            while (__c < _Size)\x0a"
"            {\x0a"
"                typename _Traits\x3a\x3aint_type __i = __is.rdbuf()->sgetc();\x0a"
"                if (_Traits\x3a\x3a""eq_int_type(__i, _Traits\x3a\x3a""eof()))\x0a"
"                {\x0a"
"                   __state \x7c= ios_base\x3a\x3a""eofbit;\x0a"
"                   break;\x0a"
"                }\x0a"
"                _CharT __ch = _Traits\x3a\x3ato_char_type(__i);\x0a"
"                if (\x21_Traits\x3a\x3a""eq(__ch, __zero) \x26\x26 \x21_Traits\x3a\x3a""eq(__ch, __one))\x0a"
"                    break;\x0a"
"                __str.push_back(__ch);\x0a"
"                ++__c;\x0a"
"                 __is.rdbuf()->sbumpc();\x0a"
"            }\x0a"
"            __x = bitset<_Size>(__str);\x0a"
"            if (__c == 0)\x0a"
"               __state \x7c= ios_base\x3a\x3a""failbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __state \x7c= ios_base\x3a\x3a""badbit;\x0a"
"            __is.__setstate_nothrow(__state);\x0a"
"            if (__is.exceptions() \x26 ios_base\x3a\x3a""badbit)\x0a"
"            {\x0a"
"                throw;\x0a"
"            }\x0a"
"        }\x0a"
"#endif\x0a"
"        __is.setstate(__state);\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_DO_NOT_ASSUME_STREAMS_EXPLICIT_INSTANTIATION_IN_DYLIB\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_istream<char>)\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_istream<wchar_t>)\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_iostream<char>)\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_ISTREAM\x0a"
"", 47835 ); }