#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_iterator( 
"// -*- C++ -*-\x0a"
"//===-------------------------- iterator ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_ITERATOR\x0a"
"#define _LIBCPP_ITERATOR\x0a"
"\x0a"
"/*\x0a"
"    iterator synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template<class Iterator>\x0a"
"struct iterator_traits\x0a"
"{\x0a"
"    typedef typename Iterator\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename Iterator\x3a\x3avalue_type value_type;\x0a"
"    typedef typename Iterator\x3a\x3apointer pointer;\x0a"
"    typedef typename Iterator\x3a\x3areference reference;\x0a"
"    typedef typename Iterator\x3a\x3aiterator_category iterator_category;\x0a"
"};\x0a"
"\x0a"
"template<class T>\x0a"
"struct iterator_traits<T*>\x0a"
"{\x0a"
"    typedef ptrdiff_t difference_type;\x0a"
"    typedef T value_type;\x0a"
"    typedef T* pointer;\x0a"
"    typedef T\x26 reference;\x0a"
"    typedef random_access_iterator_tag iterator_category;\x0a"
"};\x0a"
"\x0a"
"template<class Category, class T, class Distance = ptrdiff_t,\x0a"
"         class Pointer = T*, class Reference = T\x26>\x0a"
"struct iterator\x0a"
"{\x0a"
"    typedef T         value_type;\x0a"
"    typedef Distance  difference_type;\x0a"
"    typedef Pointer   pointer;\x0a"
"    typedef Reference reference;\x0a"
"    typedef Category  iterator_category;\x0a"
"};\x0a"
"\x0a"
"struct input_iterator_tag  {};\x0a"
"struct output_iterator_tag {};\x0a"
"struct forward_iterator_tag       \x3a public input_iterator_tag         {};\x0a"
"struct bidirectional_iterator_tag \x3a public forward_iterator_tag       {};\x0a"
"struct random_access_iterator_tag \x3a public bidirectional_iterator_tag {};\x0a"
"\x0a"
"// 27.4.3, iterator operations\x0a"
"// extension\x3a second argument not conforming to C++03\x0a"
"template <class InputIterator>  // constexpr in C++17\x0a"
"  constexpr void advance(InputIterator\x26 i,\x0a"
"             typename iterator_traits<InputIterator>\x3a\x3a""difference_type n);\x0a"
"\x0a"
"template <class InputIterator>  // constexpr in C++17\x0a"
"  constexpr typename iterator_traits<InputIterator>\x3a\x3a""difference_type\x0a"
"    distance(InputIterator first, InputIterator last);\x0a"
"\x0a"
"template <class InputIterator>  // constexpr in C++17\x0a"
"  constexpr InputIterator next(InputIterator x,\x0a"
"typename iterator_traits<InputIterator>\x3a\x3a""difference_type n = 1);\x0a"
"\x0a"
"template <class BidirectionalIterator>  // constexpr in C++17\x0a"
"  constexpr BidirectionalIterator prev(BidirectionalIterator x,\x0a"
"    typename iterator_traits<BidirectionalIterator>\x3a\x3a""difference_type n = 1);\x0a"
"\x0a"
"template <class Iterator>\x0a"
"class reverse_iterator\x0a"
"    \x3a public iterator<typename iterator_traits<Iterator>\x3a\x3aiterator_category,\x0a"
"                      typename iterator_traits<Iterator>\x3a\x3avalue_type,\x0a"
"                      typename iterator_traits<Iterator>\x3a\x3a""difference_type,\x0a"
"                      typename iterator_traits<Iterator>\x3a\x3apointer,\x0a"
"                      typename iterator_traits<Iterator>\x3a\x3areference>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    Iterator current;\x0a"
"public\x3a\x0a"
"    typedef Iterator                                            iterator_type;\x0a"
"    typedef typename iterator_traits<Iterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename iterator_traits<Iterator>\x3a\x3areference       reference;\x0a"
"    typedef typename iterator_traits<Iterator>\x3a\x3apointer         pointer;\x0a"
"\x0a"
"    constexpr reverse_iterator();\x0a"
"    constexpr explicit reverse_iterator(Iterator x);\x0a"
"    template <class U> constexpr reverse_iterator(const reverse_iterator<U>\x26 u);\x0a"
"    template <class U> constexpr reverse_iterator\x26 operator=(const reverse_iterator<U>\x26 u);\x0a"
"    constexpr Iterator base() const;\x0a"
"    constexpr reference operator*() const;\x0a"
"    constexpr pointer   operator->() const;\x0a"
"    constexpr reverse_iterator\x26 operator++();\x0a"
"    constexpr reverse_iterator  operator++(int);\x0a"
"    constexpr reverse_iterator\x26 operator--();\x0a"
"    constexpr reverse_iterator  operator--(int);\x0a"
"    constexpr reverse_iterator  operator+ (difference_type n) const;\x0a"
"    constexpr reverse_iterator\x26 operator+=(difference_type n);\x0a"
"    constexpr reverse_iterator  operator- (difference_type n) const;\x0a"
"    constexpr reverse_iterator\x26 operator-=(difference_type n);\x0a"
"    constexpr reference         operator\x5b\x5d(difference_type n) const;\x0a"
"};\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool                          // constexpr in C++17\x0a"
"operator==(const reverse_iterator<Iterator1>\x26 x, const reverse_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool                          // constexpr in C++17\x0a"
"operator<(const reverse_iterator<Iterator1>\x26 x, const reverse_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool                          // constexpr in C++17\x0a"
"operator\x21=(const reverse_iterator<Iterator1>\x26 x, const reverse_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool                          // constexpr in C++17\x0a"
"operator>(const reverse_iterator<Iterator1>\x26 x, const reverse_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool                          // constexpr in C++17\x0a"
"operator>=(const reverse_iterator<Iterator1>\x26 x, const reverse_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool                          // constexpr in C++17\x0a"
"operator<=(const reverse_iterator<Iterator1>\x26 x, const reverse_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr auto\x0a"
"operator-(const reverse_iterator<Iterator1>\x26 x, const reverse_iterator<Iterator2>\x26 y)\x0a"
"-> decltype(__y.base() - __x.base());   // constexpr in C++17\x0a"
"\x0a"
"template <class Iterator>\x0a"
"constexpr reverse_iterator<Iterator>\x0a"
"operator+(typename reverse_iterator<Iterator>\x3a\x3a""difference_type n,\x0a"
"          const reverse_iterator<Iterator>\x26 x);   // constexpr in C++17\x0a"
"\x0a"
"template <class Iterator>\x0a"
"constexpr reverse_iterator<Iterator> make_reverse_iterator(Iterator i); // C++14, constexpr in C++17\x0a"
"\x0a"
"template <class Container>\x0a"
"class back_insert_iterator\x0a"
"{\x0a"
"protected\x3a\x0a"
"    Container* container;\x0a"
"public\x3a\x0a"
"    typedef Container                   container_type;\x0a"
"    typedef void                        value_type;\x0a"
"    typedef void                        difference_type;\x0a"
"    typedef void                        reference;\x0a"
"    typedef void                        pointer;\x0a"
"\x0a"
"    explicit back_insert_iterator(Container\x26 x);\x0a"
"    back_insert_iterator\x26 operator=(const typename Container\x3a\x3avalue_type\x26 value);\x0a"
"    back_insert_iterator\x26 operator*();\x0a"
"    back_insert_iterator\x26 operator++();\x0a"
"    back_insert_iterator  operator++(int);\x0a"
"};\x0a"
"\x0a"
"template <class Container> back_insert_iterator<Container> back_inserter(Container\x26 x);\x0a"
"\x0a"
"template <class Container>\x0a"
"class front_insert_iterator\x0a"
"{\x0a"
"protected\x3a\x0a"
"    Container* container;\x0a"
"public\x3a\x0a"
"    typedef Container                    container_type;\x0a"
"    typedef void                         value_type;\x0a"
"    typedef void                         difference_type;\x0a"
"    typedef void                         reference;\x0a"
"    typedef void                         pointer;\x0a"
"\x0a"
"    explicit front_insert_iterator(Container\x26 x);\x0a"
"    front_insert_iterator\x26 operator=(const typename Container\x3a\x3avalue_type\x26 value);\x0a"
"    front_insert_iterator\x26 operator*();\x0a"
"    front_insert_iterator\x26 operator++();\x0a"
"    front_insert_iterator  operator++(int);\x0a"
"};\x0a"
"\x0a"
"template <class Container> front_insert_iterator<Container> front_inserter(Container\x26 x);\x0a"
"\x0a"
"template <class Container>\x0a"
"class insert_iterator\x0a"
"{\x0a"
"protected\x3a\x0a"
"    Container* container;\x0a"
"    typename Container\x3a\x3aiterator iter;\x0a"
"public\x3a\x0a"
"    typedef Container              container_type;\x0a"
"    typedef void                   value_type;\x0a"
"    typedef void                   difference_type;\x0a"
"    typedef void                   reference;\x0a"
"    typedef void                   pointer;\x0a"
"\x0a"
"    insert_iterator(Container\x26 x, typename Container\x3a\x3aiterator i);\x0a"
"    insert_iterator\x26 operator=(const typename Container\x3a\x3avalue_type\x26 value);\x0a"
"    insert_iterator\x26 operator*();\x0a"
"    insert_iterator\x26 operator++();\x0a"
"    insert_iterator\x26 operator++(int);\x0a"
"};\x0a"
"\x0a"
"template <class Container, class Iterator>\x0a"
"insert_iterator<Container> inserter(Container\x26 x, Iterator i);\x0a"
"\x0a"
"template <class Iterator>\x0a"
"class move_iterator {\x0a"
"public\x3a\x0a"
"    typedef Iterator                                              iterator_type;\x0a"
"    typedef typename iterator_traits<Iterator>\x3a\x3a""difference_type   difference_type;\x0a"
"    typedef Iterator                                              pointer;\x0a"
"    typedef typename iterator_traits<Iterator>\x3a\x3avalue_type        value_type;\x0a"
"    typedef typename iterator_traits<Iterator>\x3a\x3aiterator_category iterator_category;\x0a"
"    typedef value_type\x26\x26                                          reference;\x0a"
"\x0a"
"    constexpr move_iterator();  // all the constexprs are in C++17\x0a"
"    constexpr explicit move_iterator(Iterator i);\x0a"
"    template <class U>\x0a"
"      constexpr move_iterator(const move_iterator<U>\x26 u);\x0a"
"    template <class U>\x0a"
"      constexpr move_iterator\x26 operator=(const move_iterator<U>\x26 u);\x0a"
"    constexpr iterator_type base() const;\x0a"
"    constexpr reference operator*() const;\x0a"
"    constexpr pointer operator->() const;\x0a"
"    constexpr move_iterator\x26 operator++();\x0a"
"    constexpr move_iterator operator++(int);\x0a"
"    constexpr move_iterator\x26 operator--();\x0a"
"    constexpr move_iterator operator--(int);\x0a"
"    constexpr move_iterator operator+(difference_type n) const;\x0a"
"    constexpr move_iterator\x26 operator+=(difference_type n);\x0a"
"    constexpr move_iterator operator-(difference_type n) const;\x0a"
"    constexpr move_iterator\x26 operator-=(difference_type n);\x0a"
"    constexpr unspecified operator\x5b\x5d(difference_type n) const;\x0a"
"private\x3a\x0a"
"    Iterator current; // exposition only\x0a"
"};\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool   // constexpr in C++17\x0a"
"operator==(const move_iterator<Iterator1>\x26 x, const move_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool   // constexpr in C++17\x0a"
"operator\x21=(const move_iterator<Iterator1>\x26 x, const move_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool   // constexpr in C++17\x0a"
"operator<(const move_iterator<Iterator1>\x26 x, const move_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool   // constexpr in C++17\x0a"
"operator<=(const move_iterator<Iterator1>\x26 x, const move_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool   // constexpr in C++17\x0a"
"operator>(const move_iterator<Iterator1>\x26 x, const move_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr bool   // constexpr in C++17\x0a"
"operator>=(const move_iterator<Iterator1>\x26 x, const move_iterator<Iterator2>\x26 y);\x0a"
"\x0a"
"template <class Iterator1, class Iterator2>\x0a"
"constexpr auto   // constexpr in C++17\x0a"
"operator-(const move_iterator<Iterator1>\x26 x,\x0a"
"          const move_iterator<Iterator2>\x26 y) -> decltype(x.base() - y.base());\x0a"
"\x0a"
"template <class Iterator>\x0a"
"constexpr move_iterator<Iterator> operator+(   // constexpr in C++17\x0a"
"            typename move_iterator<Iterator>\x3a\x3a""difference_type n,\x0a"
"            const move_iterator<Iterator>\x26 x);\x0a"
"\x0a"
"template <class Iterator>   // constexpr in C++17\x0a"
"constexpr  move_iterator<Iterator> make_move_iterator(const Iterator\x26 i);\x0a"
"\x0a"
"\x0a"
"template <class T, class charT = char, class traits = char_traits<charT>, class Distance = ptrdiff_t>\x0a"
"class istream_iterator\x0a"
"    \x3a public iterator<input_iterator_tag, T, Distance, const T*, const T\x26>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT char_type;\x0a"
"    typedef traits traits_type;\x0a"
"    typedef basic_istream<charT,traits> istream_type;\x0a"
"\x0a"
"    constexpr istream_iterator();\x0a"
"    istream_iterator(istream_type\x26 s);\x0a"
"    istream_iterator(const istream_iterator\x26 x);\x0a"
"    \x7eistream_iterator();\x0a"
"\x0a"
"    const T\x26 operator*() const;\x0a"
"    const T* operator->() const;\x0a"
"    istream_iterator\x26 operator++();\x0a"
"    istream_iterator  operator++(int);\x0a"
"};\x0a"
"\x0a"
"template <class T, class charT, class traits, class Distance>\x0a"
"bool operator==(const istream_iterator<T,charT,traits,Distance>\x26 x,\x0a"
"                const istream_iterator<T,charT,traits,Distance>\x26 y);\x0a"
"template <class T, class charT, class traits, class Distance>\x0a"
"bool operator\x21=(const istream_iterator<T,charT,traits,Distance>\x26 x,\x0a"
"                const istream_iterator<T,charT,traits,Distance>\x26 y);\x0a"
"\x0a"
"template <class T, class charT = char, class traits = char_traits<charT> >\x0a"
"class ostream_iterator\x0a"
"    \x3a public iterator<output_iterator_tag, void, void, void ,void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT char_type;\x0a"
"    typedef traits traits_type;\x0a"
"    typedef basic_ostream<charT,traits> ostream_type;\x0a"
"\x0a"
"    ostream_iterator(ostream_type\x26 s);\x0a"
"    ostream_iterator(ostream_type\x26 s, const charT* delimiter);\x0a"
"    ostream_iterator(const ostream_iterator\x26 x);\x0a"
"    \x7eostream_iterator();\x0a"
"    ostream_iterator\x26 operator=(const T\x26 value);\x0a"
"\x0a"
"    ostream_iterator\x26 operator*();\x0a"
"    ostream_iterator\x26 operator++();\x0a"
"    ostream_iterator\x26 operator++(int);\x0a"
"};\x0a"
"\x0a"
"template<class charT, class traits = char_traits<charT> >\x0a"
"class istreambuf_iterator\x0a"
"    \x3a public iterator<input_iterator_tag, charT,\x0a"
"                      typename traits\x3a\x3aoff_type, unspecified,\x0a"
"                      charT>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT                         char_type;\x0a"
"    typedef traits                        traits_type;\x0a"
"    typedef typename traits\x3a\x3aint_type     int_type;\x0a"
"    typedef basic_streambuf<charT,traits> streambuf_type;\x0a"
"    typedef basic_istream<charT,traits>   istream_type;\x0a"
"\x0a"
"    istreambuf_iterator() noexcept;\x0a"
"    istreambuf_iterator(istream_type\x26 s) noexcept;\x0a"
"    istreambuf_iterator(streambuf_type* s) noexcept;\x0a"
"    istreambuf_iterator(a-private-type) noexcept;\x0a"
"\x0a"
"    charT                operator*() const;\x0a"
"    pointer operator->() const;\x0a"
"    istreambuf_iterator\x26 operator++();\x0a"
"    a-private-type       operator++(int);\x0a"
"\x0a"
"    bool equal(const istreambuf_iterator\x26 b) const;\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"bool operator==(const istreambuf_iterator<charT,traits>\x26 a,\x0a"
"                const istreambuf_iterator<charT,traits>\x26 b);\x0a"
"template <class charT, class traits>\x0a"
"bool operator\x21=(const istreambuf_iterator<charT,traits>\x26 a,\x0a"
"                const istreambuf_iterator<charT,traits>\x26 b);\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> >\x0a"
"class ostreambuf_iterator\x0a"
"    \x3a public iterator<output_iterator_tag, void, void, void, void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT                         char_type;\x0a"
"    typedef traits                        traits_type;\x0a"
"    typedef basic_streambuf<charT,traits> streambuf_type;\x0a"
"    typedef basic_ostream<charT,traits>   ostream_type;\x0a"
"\x0a"
"    ostreambuf_iterator(ostream_type\x26 s) noexcept;\x0a"
"    ostreambuf_iterator(streambuf_type* s) noexcept;\x0a"
"    ostreambuf_iterator\x26 operator=(charT c);\x0a"
"    ostreambuf_iterator\x26 operator*();\x0a"
"    ostreambuf_iterator\x26 operator++();\x0a"
"    ostreambuf_iterator\x26 operator++(int);\x0a"
"    bool failed() const noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class C> constexpr auto begin(C\x26 c) -> decltype(c.begin());\x0a"
"template <class C> constexpr auto begin(const C\x26 c) -> decltype(c.begin());\x0a"
"template <class C> constexpr auto end(C\x26 c) -> decltype(c.end());\x0a"
"template <class C> constexpr auto end(const C\x26 c) -> decltype(c.end());\x0a"
"template <class T, size_t N> constexpr T* begin(T (\x26""array)\x5bN\x5d);\x0a"
"template <class T, size_t N> constexpr T* end(T (\x26""array)\x5bN\x5d);\x0a"
"\x0a"
"template <class C> auto constexpr cbegin(const C\x26 c) -> decltype(std\x3a\x3a""begin(c));        // C++14\x0a"
"template <class C> auto constexpr cend(const C\x26 c) -> decltype(std\x3a\x3a""end(c));            // C++14\x0a"
"template <class C> auto constexpr rbegin(C\x26 c) -> decltype(c.rbegin());                 // C++14\x0a"
"template <class C> auto constexpr rbegin(const C\x26 c) -> decltype(c.rbegin());           // C++14\x0a"
"template <class C> auto constexpr rend(C\x26 c) -> decltype(c.rend());                     // C++14\x0a"
"template <class C> constexpr auto rend(const C\x26 c) -> decltype(c.rend());               // C++14\x0a"
"template <class E> reverse_iterator<const E*> constexpr rbegin(initializer_list<E> il); // C++14\x0a"
"template <class E> reverse_iterator<const E*> constexpr rend(initializer_list<E> il);   // C++14\x0a"
"template <class T, size_t N> reverse_iterator<T*> constexpr rbegin(T (\x26""array)\x5bN\x5d);      // C++14\x0a"
"template <class T, size_t N> reverse_iterator<T*> constexpr rend(T (\x26""array)\x5bN\x5d);        // C++14\x0a"
"template <class C> constexpr auto crbegin(const C\x26 c) -> decltype(std\x3a\x3arbegin(c));      // C++14\x0a"
"template <class C> constexpr auto crend(const C\x26 c) -> decltype(std\x3a\x3arend(c));          // C++14\x0a"
"\x0a"
"// 24.8, container access\x3a\x0a"
"template <class C> constexpr auto size(const C\x26 c) -> decltype(c.size());         // C++17\x0a"
"template <class T, size_t N> constexpr size_t size(const T (\x26""array)\x5bN\x5d) noexcept; // C++17\x0a"
"\x0a"
"template <class C> constexpr auto ssize(const C\x26 c)\x0a"
"    -> common_type_t<ptrdiff_t, make_signed_t<decltype(c.size())>>;\x09\x09\x09\x09       // C++20\x0a"
"template <class T, ptrdiff_t> constexpr ptrdiff_t ssize(const T (\x26""array)\x5bN\x5d) noexcept; // C++20\x0a"
"\x0a"
"template <class C> constexpr auto empty(const C\x26 c) -> decltype(c.empty());       // C++17\x0a"
"template <class T, size_t N> constexpr bool empty(const T (\x26""array)\x5bN\x5d) noexcept;  // C++17\x0a"
"template <class E> constexpr bool empty(initializer_list<E> il) noexcept;         // C++17\x0a"
"template <class C> constexpr auto data(C\x26 c) -> decltype(c.data());               // C++17\x0a"
"template <class C> constexpr auto data(const C\x26 c) -> decltype(c.data());         // C++17\x0a"
"template <class T, size_t N> constexpr T* data(T (\x26""array)\x5bN\x5d) noexcept;           // C++17\x0a"
"template <class E> constexpr const E* data(initializer_list<E> il) noexcept;      // C++17\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <iosfwd> // for forward declarations of vector and string.\x0a"
"#include <__functional_base>\x0a"
"#include <type_traits>\x0a"
"#include <cstddef>\x0a"
"#include <initializer_list>\x0a"
"#include <version>\x0a"
"#ifdef __APPLE__\x0a"
"#include <Availability.h>\x0a"
"#endif\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"struct _LIBCPP_TEMPLATE_VIS input_iterator_tag {};\x0a"
"struct _LIBCPP_TEMPLATE_VIS output_iterator_tag {};\x0a"
"struct _LIBCPP_TEMPLATE_VIS forward_iterator_tag       \x3a public input_iterator_tag {};\x0a"
"struct _LIBCPP_TEMPLATE_VIS bidirectional_iterator_tag \x3a public forward_iterator_tag {};\x0a"
"struct _LIBCPP_TEMPLATE_VIS random_access_iterator_tag \x3a public bidirectional_iterator_tag {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_iterator_typedefs\x0a"
"{\x0a"
"private\x3a\x0a"
"    struct __two {char __lx; char __lxx;};\x0a"
"    template <class _Up> static __two __test(...);\x0a"
"    template <class _Up> static char __test(typename std\x3a\x3a__void_t<typename _Up\x3a\x3aiterator_category>\x3a\x3atype* = 0,\x0a"
"    \x09\x09\x09\x09\x09\x09\x09\x09\x09\x09typename std\x3a\x3a__void_t<typename _Up\x3a\x3a""difference_type>\x3a\x3atype* = 0,\x0a"
"    \x09\x09\x09\x09\x09\x09\x09\x09\x09\x09typename std\x3a\x3a__void_t<typename _Up\x3a\x3avalue_type>\x3a\x3atype* = 0,\x0a"
"    \x09\x09\x09\x09\x09\x09\x09\x09\x09\x09typename std\x3a\x3a__void_t<typename _Up\x3a\x3areference>\x3a\x3atype* = 0,\x0a"
"    \x09\x09\x09\x09\x09\x09\x09\x09\x09\x09typename std\x3a\x3a__void_t<typename _Up\x3a\x3apointer>\x3a\x3atype* = 0\x0a"
"    \x09\x09\x09\x09\x09\x09\x09\x09\x09\x09);\x0a"
"public\x3a\x0a"
"    static const bool value = sizeof(__test<_Tp>(0,0,0,0,0)) == 1;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_iterator_category\x0a"
"{\x0a"
"private\x3a\x0a"
"    struct __two {char __lx; char __lxx;};\x0a"
"    template <class _Up> static __two __test(...);\x0a"
"    template <class _Up> static char __test(typename _Up\x3a\x3aiterator_category* = 0);\x0a"
"public\x3a\x0a"
"    static const bool value = sizeof(__test<_Tp>(0)) == 1;\x0a"
"};\x0a"
"\x0a"
"template <class _Iter, bool> struct __iterator_traits_impl {};\x0a"
"\x0a"
"template <class _Iter>\x0a"
"struct __iterator_traits_impl<_Iter, true>\x0a"
"{\x0a"
"    typedef typename _Iter\x3a\x3a""difference_type   difference_type;\x0a"
"    typedef typename _Iter\x3a\x3avalue_type        value_type;\x0a"
"    typedef typename _Iter\x3a\x3apointer           pointer;\x0a"
"    typedef typename _Iter\x3a\x3areference         reference;\x0a"
"    typedef typename _Iter\x3a\x3aiterator_category iterator_category;\x0a"
"};\x0a"
"\x0a"
"template <class _Iter, bool> struct __iterator_traits {};\x0a"
"\x0a"
"template <class _Iter>\x0a"
"struct __iterator_traits<_Iter, true>\x0a"
"    \x3a  __iterator_traits_impl\x0a"
"      <\x0a"
"        _Iter,\x0a"
"        is_convertible<typename _Iter\x3a\x3aiterator_category, input_iterator_tag>\x3a\x3avalue \x7c\x7c\x0a"
"        is_convertible<typename _Iter\x3a\x3aiterator_category, output_iterator_tag>\x3a\x3avalue\x0a"
"      >\x0a"
"{};\x0a"
"\x0a"
"// iterator_traits<Iterator> will only have the nested types if Iterator\x3a\x3aiterator_category\x0a"
"//    exists.  Else iterator_traits<Iterator> will be an empty class.  This is a\x0a"
"//    conforming extension which allows some programs to compile and behave as\x0a"
"//    the client expects instead of failing at compile time.\x0a"
"\x0a"
"template <class _Iter>\x0a"
"struct _LIBCPP_TEMPLATE_VIS iterator_traits\x0a"
"    \x3a __iterator_traits<_Iter, __has_iterator_typedefs<_Iter>\x3a\x3avalue> {};\x0a"
"\x0a"
"template<class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS iterator_traits<_Tp*>\x0a"
"{\x0a"
"    typedef ptrdiff_t difference_type;\x0a"
"    typedef typename remove_cv<_Tp>\x3a\x3atype value_type;\x0a"
"    typedef _Tp* pointer;\x0a"
"    typedef _Tp\x26 reference;\x0a"
"    typedef random_access_iterator_tag iterator_category;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up, bool = __has_iterator_category<iterator_traits<_Tp> >\x3a\x3avalue>\x0a"
"struct __has_iterator_category_convertible_to\x0a"
"    \x3a public integral_constant<bool, is_convertible<typename iterator_traits<_Tp>\x3a\x3aiterator_category, _Up>\x3a\x3avalue>\x0a"
"{};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __has_iterator_category_convertible_to<_Tp, _Up, false> \x3a public false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_input_iterator \x3a public __has_iterator_category_convertible_to<_Tp, input_iterator_tag> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_forward_iterator \x3a public __has_iterator_category_convertible_to<_Tp, forward_iterator_tag> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_bidirectional_iterator \x3a public __has_iterator_category_convertible_to<_Tp, bidirectional_iterator_tag> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_random_access_iterator \x3a public __has_iterator_category_convertible_to<_Tp, random_access_iterator_tag> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_exactly_input_iterator\x0a"
"    \x3a public integral_constant<bool,\x0a"
"         __has_iterator_category_convertible_to<_Tp, input_iterator_tag>\x3a\x3avalue \x26\x26\x0a"
"        \x21__has_iterator_category_convertible_to<_Tp, forward_iterator_tag>\x3a\x3avalue> {};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator>\x0a"
"using __iter_value_type = typename iterator_traits<_InputIterator>\x3a\x3avalue_type;\x0a"
"\x0a"
"template<class _InputIterator>\x0a"
"using __iter_key_type = remove_const_t<typename iterator_traits<_InputIterator>\x3a\x3avalue_type\x3a\x3a""first_type>;\x0a"
"\x0a"
"template<class _InputIterator>\x0a"
"using __iter_mapped_type = typename iterator_traits<_InputIterator>\x3a\x3avalue_type\x3a\x3asecond_type;\x0a"
"\x0a"
"template<class _InputIterator>\x0a"
"using __iter_to_alloc_type = pair<\x0a"
"    add_const_t<typename iterator_traits<_InputIterator>\x3a\x3avalue_type\x3a\x3a""first_type>,\x0a"
"    typename iterator_traits<_InputIterator>\x3a\x3avalue_type\x3a\x3asecond_type>;\x0a"
"#endif\x0a"
"\x0a"
"template<class _Category, class _Tp, class _Distance = ptrdiff_t,\x0a"
"         class _Pointer = _Tp*, class _Reference = _Tp\x26>\x0a"
"struct _LIBCPP_TEMPLATE_VIS iterator\x0a"
"{\x0a"
"    typedef _Tp        value_type;\x0a"
"    typedef _Distance  difference_type;\x0a"
"    typedef _Pointer   pointer;\x0a"
"    typedef _Reference reference;\x0a"
"    typedef _Category  iterator_category;\x0a"
"};\x0a"
"\x0a"
"template <class _InputIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"void __advance(_InputIter\x26 __i,\x0a"
"             typename iterator_traits<_InputIter>\x3a\x3a""difference_type __n, input_iterator_tag)\x0a"
"{\x0a"
"    for (; __n > 0; --__n)\x0a"
"        ++__i;\x0a"
"}\x0a"
"\x0a"
"template <class _BiDirIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"void __advance(_BiDirIter\x26 __i,\x0a"
"             typename iterator_traits<_BiDirIter>\x3a\x3a""difference_type __n, bidirectional_iterator_tag)\x0a"
"{\x0a"
"    if (__n >= 0)\x0a"
"        for (; __n > 0; --__n)\x0a"
"            ++__i;\x0a"
"    else\x0a"
"        for (; __n < 0; ++__n)\x0a"
"            --__i;\x0a"
"}\x0a"
"\x0a"
"template <class _RandIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"void __advance(_RandIter\x26 __i,\x0a"
"             typename iterator_traits<_RandIter>\x3a\x3a""difference_type __n, random_access_iterator_tag)\x0a"
"{\x0a"
"   __i += __n;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"void advance(_InputIter\x26 __i,\x0a"
"             typename iterator_traits<_InputIter>\x3a\x3a""difference_type __n)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n >= 0 \x7c\x7c __is_bidirectional_iterator<_InputIter>\x3a\x3avalue,\x0a"
"                       \x22""Attempt to advance(it, -n) on a non-bidi iterator\x22);\x0a"
"    __advance(__i, __n, typename iterator_traits<_InputIter>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"template <class _InputIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"typename iterator_traits<_InputIter>\x3a\x3a""difference_type\x0a"
"__distance(_InputIter __first, _InputIter __last, input_iterator_tag)\x0a"
"{\x0a"
"    typename iterator_traits<_InputIter>\x3a\x3a""difference_type __r(0);\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        ++__r;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _RandIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"typename iterator_traits<_RandIter>\x3a\x3a""difference_type\x0a"
"__distance(_RandIter __first, _RandIter __last, random_access_iterator_tag)\x0a"
"{\x0a"
"    return __last - __first;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"typename iterator_traits<_InputIter>\x3a\x3a""difference_type\x0a"
"distance(_InputIter __first, _InputIter __last)\x0a"
"{\x0a"
"    return __distance(__first, __last, typename iterator_traits<_InputIter>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"template <class _InputIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_input_iterator<_InputIter>\x3a\x3avalue,\x0a"
"    _InputIter\x0a"
">\x3a\x3atype\x0a"
"next(_InputIter __x,\x0a"
"     typename iterator_traits<_InputIter>\x3a\x3a""difference_type __n = 1)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n >= 0 \x7c\x7c __is_bidirectional_iterator<_InputIter>\x3a\x3avalue,\x0a"
"                       \x22""Attempt to next(it, -n) on a non-bidi iterator\x22);\x0a"
"\x0a"
"    _VSTD\x3a\x3a""advance(__x, __n);\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_input_iterator<_InputIter>\x3a\x3avalue,\x0a"
"    _InputIter\x0a"
">\x3a\x3atype\x0a"
"prev(_InputIter __x,\x0a"
"     typename iterator_traits<_InputIter>\x3a\x3a""difference_type __n = 1)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n <= 0 \x7c\x7c __is_bidirectional_iterator<_InputIter>\x3a\x3avalue,\x0a"
"                       \x22""Attempt to prev(it, +n) on a non-bidi iterator\x22);\x0a"
"    _VSTD\x3a\x3a""advance(__x, -__n);\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __is_stashing_iterator \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_stashing_iterator<_Tp, typename __void_t<typename _Tp\x3a\x3a__stashing_iterator_tag>\x3a\x3atype>\x0a"
"  \x3a true_type {};\x0a"
"\x0a"
"template <class _Iter>\x0a"
"class _LIBCPP_TEMPLATE_VIS reverse_iterator\x0a"
"    \x3a public iterator<typename iterator_traits<_Iter>\x3a\x3aiterator_category,\x0a"
"                      typename iterator_traits<_Iter>\x3a\x3avalue_type,\x0a"
"                      typename iterator_traits<_Iter>\x3a\x3a""difference_type,\x0a"
"                      typename iterator_traits<_Iter>\x3a\x3apointer,\x0a"
"                      typename iterator_traits<_Iter>\x3a\x3areference>\x0a"
"{\x0a"
"private\x3a\x0a"
"    /*mutable*/ _Iter __t;  // no longer used as of LWG #2360, not removed due to ABI break\x0a"
"\x0a"
"    static_assert(\x21__is_stashing_iterator<_Iter>\x3a\x3avalue,\x0a"
"      \x22The specified iterator type cannot be used with reverse_iterator; \x22\x0a"
"      \x22Using stashing iterators with reverse_iterator causes undefined behavior\x22);\x0a"
"\x0a"
"protected\x3a\x0a"
"    _Iter current;\x0a"
"public\x3a\x0a"
"    typedef _Iter                                            iterator_type;\x0a"
"    typedef typename iterator_traits<_Iter>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename iterator_traits<_Iter>\x3a\x3areference       reference;\x0a"
"    typedef typename iterator_traits<_Iter>\x3a\x3apointer         pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator() \x3a __t(), current() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    explicit reverse_iterator(_Iter __x) \x3a __t(__x), current(__x) {}\x0a"
"    template <class _Up>\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"        reverse_iterator(const reverse_iterator<_Up>\x26 __u) \x3a __t(__u.base()), current(__u.base()) {}\x0a"
"    template <class _Up>\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"        reverse_iterator\x26 operator=(const reverse_iterator<_Up>\x26 __u)\x0a"
"            { __t = current = __u.base(); return *this; }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    _Iter base() const {return current;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reference operator*() const {_Iter __tmp = current; return *--__tmp;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    pointer  operator->() const {return _VSTD\x3a\x3a""addressof(operator*());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator\x26 operator++() {--current; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator  operator++(int) {reverse_iterator __tmp(*this); --current; return __tmp;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator\x26 operator--() {++current; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator  operator--(int) {reverse_iterator __tmp(*this); ++current; return __tmp;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator  operator+ (difference_type __n) const {return reverse_iterator(current - __n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator\x26 operator+=(difference_type __n) {current -= __n; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator  operator- (difference_type __n) const {return reverse_iterator(current + __n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reverse_iterator\x26 operator-=(difference_type __n) {current += __n; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reference         operator\x5b\x5d(difference_type __n) const {return *(*this + __n);}\x0a"
"};\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator==(const reverse_iterator<_Iter1>\x26 __x, const reverse_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() == __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator<(const reverse_iterator<_Iter1>\x26 __x, const reverse_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() > __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator\x21=(const reverse_iterator<_Iter1>\x26 __x, const reverse_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() \x21= __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator>(const reverse_iterator<_Iter1>\x26 __x, const reverse_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() < __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator>=(const reverse_iterator<_Iter1>\x26 __x, const reverse_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() <= __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator<=(const reverse_iterator<_Iter1>\x26 __x, const reverse_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() >= __y.base();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto\x0a"
"operator-(const reverse_iterator<_Iter1>\x26 __x, const reverse_iterator<_Iter2>\x26 __y)\x0a"
"-> decltype(__y.base() - __x.base())\x0a"
"{\x0a"
"    return __y.base() - __x.base();\x0a"
"}\x0a"
"#else\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename reverse_iterator<_Iter1>\x3a\x3a""difference_type\x0a"
"operator-(const reverse_iterator<_Iter1>\x26 __x, const reverse_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __y.base() - __x.base();\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Iter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"reverse_iterator<_Iter>\x0a"
"operator+(typename reverse_iterator<_Iter>\x3a\x3a""difference_type __n, const reverse_iterator<_Iter>\x26 __x)\x0a"
"{\x0a"
"    return reverse_iterator<_Iter>(__x.base() - __n);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Iter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"reverse_iterator<_Iter> make_reverse_iterator(_Iter __i)\x0a"
"{\x0a"
"    return reverse_iterator<_Iter>(__i);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Container>\x0a"
"class _LIBCPP_TEMPLATE_VIS back_insert_iterator\x0a"
"    \x3a public iterator<output_iterator_tag,\x0a"
"                      void,\x0a"
"                      void,\x0a"
"                      void,\x0a"
"                      void>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    _Container* container;\x0a"
"public\x3a\x0a"
"    typedef _Container container_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit back_insert_iterator(_Container\x26 __x) \x3a container(_VSTD\x3a\x3a""addressof(__x)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY back_insert_iterator\x26 operator=(const typename _Container\x3a\x3avalue_type\x26 __value_)\x0a"
"        {container->push_back(__value_); return *this;}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY back_insert_iterator\x26 operator=(typename _Container\x3a\x3avalue_type\x26\x26 __value_)\x0a"
"        {container->push_back(_VSTD\x3a\x3amove(__value_)); return *this;}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY back_insert_iterator\x26 operator*()     {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY back_insert_iterator\x26 operator++()    {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY back_insert_iterator  operator++(int) {return *this;}\x0a"
"};\x0a"
"\x0a"
"template <class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"back_insert_iterator<_Container>\x0a"
"back_inserter(_Container\x26 __x)\x0a"
"{\x0a"
"    return back_insert_iterator<_Container>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Container>\x0a"
"class _LIBCPP_TEMPLATE_VIS front_insert_iterator\x0a"
"    \x3a public iterator<output_iterator_tag,\x0a"
"                      void,\x0a"
"                      void,\x0a"
"                      void,\x0a"
"                      void>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    _Container* container;\x0a"
"public\x3a\x0a"
"    typedef _Container container_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit front_insert_iterator(_Container\x26 __x) \x3a container(_VSTD\x3a\x3a""addressof(__x)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY front_insert_iterator\x26 operator=(const typename _Container\x3a\x3avalue_type\x26 __value_)\x0a"
"        {container->push_front(__value_); return *this;}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY front_insert_iterator\x26 operator=(typename _Container\x3a\x3avalue_type\x26\x26 __value_)\x0a"
"        {container->push_front(_VSTD\x3a\x3amove(__value_)); return *this;}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY front_insert_iterator\x26 operator*()     {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY front_insert_iterator\x26 operator++()    {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY front_insert_iterator  operator++(int) {return *this;}\x0a"
"};\x0a"
"\x0a"
"template <class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"front_insert_iterator<_Container>\x0a"
"front_inserter(_Container\x26 __x)\x0a"
"{\x0a"
"    return front_insert_iterator<_Container>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Container>\x0a"
"class _LIBCPP_TEMPLATE_VIS insert_iterator\x0a"
"    \x3a public iterator<output_iterator_tag,\x0a"
"                      void,\x0a"
"                      void,\x0a"
"                      void,\x0a"
"                      void>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    _Container* container;\x0a"
"    typename _Container\x3a\x3aiterator iter;\x0a"
"public\x3a\x0a"
"    typedef _Container container_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY insert_iterator(_Container\x26 __x, typename _Container\x3a\x3aiterator __i)\x0a"
"        \x3a container(_VSTD\x3a\x3a""addressof(__x)), iter(__i) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY insert_iterator\x26 operator=(const typename _Container\x3a\x3avalue_type\x26 __value_)\x0a"
"        {iter = container->insert(iter, __value_); ++iter; return *this;}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY insert_iterator\x26 operator=(typename _Container\x3a\x3avalue_type\x26\x26 __value_)\x0a"
"        {iter = container->insert(iter, _VSTD\x3a\x3amove(__value_)); ++iter; return *this;}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY insert_iterator\x26 operator*()        {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY insert_iterator\x26 operator++()       {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY insert_iterator\x26 operator++(int)    {return *this;}\x0a"
"};\x0a"
"\x0a"
"template <class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"insert_iterator<_Container>\x0a"
"inserter(_Container\x26 __x, typename _Container\x3a\x3aiterator __i)\x0a"
"{\x0a"
"    return insert_iterator<_Container>(__x, __i);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _CharT = char,\x0a"
"          class _Traits = char_traits<_CharT>, class _Distance = ptrdiff_t>\x0a"
"class _LIBCPP_TEMPLATE_VIS istream_iterator\x0a"
"    \x3a public iterator<input_iterator_tag, _Tp, _Distance, const _Tp*, const _Tp\x26>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT char_type;\x0a"
"    typedef _Traits traits_type;\x0a"
"    typedef basic_istream<_CharT,_Traits> istream_type;\x0a"
"private\x3a\x0a"
"    istream_type* __in_stream_;\x0a"
"    _Tp __value_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR istream_iterator() \x3a __in_stream_(0), __value_() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY istream_iterator(istream_type\x26 __s) \x3a __in_stream_(_VSTD\x3a\x3a""addressof(__s))\x0a"
"        {\x0a"
"            if (\x21(*__in_stream_ >> __value_))\x0a"
"                __in_stream_ = 0;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY const _Tp\x26 operator*() const {return __value_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const _Tp* operator->() const {return _VSTD\x3a\x3a""addressof((operator*()));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY istream_iterator\x26 operator++()\x0a"
"        {\x0a"
"            if (\x21(*__in_stream_ >> __value_))\x0a"
"                __in_stream_ = 0;\x0a"
"            return *this;\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY istream_iterator  operator++(int)\x0a"
"        {istream_iterator __t(*this); ++(*this); return __t;}\x0a"
"\x0a"
"    template <class _Up, class _CharU, class _TraitsU, class _DistanceU>\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool\x0a"
"    operator==(const istream_iterator<_Up, _CharU, _TraitsU, _DistanceU>\x26 __x,\x0a"
"               const istream_iterator<_Up, _CharU, _TraitsU, _DistanceU>\x26 __y);\x0a"
"\x0a"
"    template <class _Up, class _CharU, class _TraitsU, class _DistanceU>\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool\x0a"
"    operator==(const istream_iterator<_Up, _CharU, _TraitsU, _DistanceU>\x26 __x,\x0a"
"               const istream_iterator<_Up, _CharU, _TraitsU, _DistanceU>\x26 __y);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _CharT, class _Traits, class _Distance>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const istream_iterator<_Tp, _CharT, _Traits, _Distance>\x26 __x,\x0a"
"           const istream_iterator<_Tp, _CharT, _Traits, _Distance>\x26 __y)\x0a"
"{\x0a"
"    return __x.__in_stream_ == __y.__in_stream_;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _CharT, class _Traits, class _Distance>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const istream_iterator<_Tp, _CharT, _Traits, _Distance>\x26 __x,\x0a"
"           const istream_iterator<_Tp, _CharT, _Traits, _Distance>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _CharT = char, class _Traits = char_traits<_CharT> >\x0a"
"class _LIBCPP_TEMPLATE_VIS ostream_iterator\x0a"
"    \x3a public iterator<output_iterator_tag, void, void, void, void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT char_type;\x0a"
"    typedef _Traits traits_type;\x0a"
"    typedef basic_ostream<_CharT,_Traits> ostream_type;\x0a"
"private\x3a\x0a"
"    ostream_type* __out_stream_;\x0a"
"    const char_type* __delim_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostream_iterator(ostream_type\x26 __s) _NOEXCEPT\x0a"
"        \x3a __out_stream_(_VSTD\x3a\x3a""addressof(__s)), __delim_(0) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostream_iterator(ostream_type\x26 __s, const _CharT* __delimiter) _NOEXCEPT\x0a"
"        \x3a __out_stream_(_VSTD\x3a\x3a""addressof(__s)), __delim_(__delimiter) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostream_iterator\x26 operator=(const _Tp\x26 __value_)\x0a"
"        {\x0a"
"            *__out_stream_ << __value_;\x0a"
"            if (__delim_)\x0a"
"                *__out_stream_ << __delim_;\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostream_iterator\x26 operator*()     {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostream_iterator\x26 operator++()    {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostream_iterator\x26 operator++(int) {return *this;}\x0a"
"};\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS istreambuf_iterator\x0a"
"    \x3a public iterator<input_iterator_tag, _CharT,\x0a"
"                      typename _Traits\x3a\x3aoff_type, _CharT*,\x0a"
"                      _CharT>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                          char_type;\x0a"
"    typedef _Traits                         traits_type;\x0a"
"    typedef typename _Traits\x3a\x3aint_type      int_type;\x0a"
"    typedef basic_streambuf<_CharT,_Traits> streambuf_type;\x0a"
"    typedef basic_istream<_CharT,_Traits>   istream_type;\x0a"
"private\x3a\x0a"
"    mutable streambuf_type* __sbuf_;\x0a"
"\x0a"
"    class __proxy\x0a"
"    {\x0a"
"        char_type __keep_;\x0a"
"        streambuf_type* __sbuf_;\x0a"
"        _LIBCPP_INLINE_VISIBILITY __proxy(char_type __c, streambuf_type* __s)\x0a"
"            \x3a __keep_(__c), __sbuf_(__s) {}\x0a"
"        friend class istreambuf_iterator;\x0a"
"    public\x3a\x0a"
"        _LIBCPP_INLINE_VISIBILITY char_type operator*() const {return __keep_;}\x0a"
"    };\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool __test_for_eof() const\x0a"
"    {\x0a"
"        if (__sbuf_ \x26\x26 traits_type\x3a\x3a""eq_int_type(__sbuf_->sgetc(), traits_type\x3a\x3a""eof()))\x0a"
"            __sbuf_ = 0;\x0a"
"        return __sbuf_ == 0;\x0a"
"    }\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR istreambuf_iterator() _NOEXCEPT \x3a __sbuf_(0) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY istreambuf_iterator(istream_type\x26 __s) _NOEXCEPT\x0a"
"        \x3a __sbuf_(__s.rdbuf()) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY istreambuf_iterator(streambuf_type* __s) _NOEXCEPT\x0a"
"        \x3a __sbuf_(__s) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY istreambuf_iterator(const __proxy\x26 __p) _NOEXCEPT\x0a"
"        \x3a __sbuf_(__p.__sbuf_) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY char_type  operator*() const\x0a"
"        {return static_cast<char_type>(__sbuf_->sgetc());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY istreambuf_iterator\x26 operator++()\x0a"
"        {\x0a"
"            __sbuf_->sbumpc();\x0a"
"            return *this;\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY __proxy              operator++(int)\x0a"
"        {\x0a"
"            return __proxy(__sbuf_->sbumpc(), __sbuf_);\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool equal(const istreambuf_iterator\x26 __b) const\x0a"
"        {return __test_for_eof() == __b.__test_for_eof();}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator==(const istreambuf_iterator<_CharT,_Traits>\x26 __a,\x0a"
"                const istreambuf_iterator<_CharT,_Traits>\x26 __b)\x0a"
"                {return __a.equal(__b);}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(const istreambuf_iterator<_CharT,_Traits>\x26 __a,\x0a"
"                const istreambuf_iterator<_CharT,_Traits>\x26 __b)\x0a"
"                {return \x21__a.equal(__b);}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS ostreambuf_iterator\x0a"
"    \x3a public iterator<output_iterator_tag, void, void, void, void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                          char_type;\x0a"
"    typedef _Traits                         traits_type;\x0a"
"    typedef basic_streambuf<_CharT,_Traits> streambuf_type;\x0a"
"    typedef basic_ostream<_CharT,_Traits>   ostream_type;\x0a"
"private\x3a\x0a"
"    streambuf_type* __sbuf_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostreambuf_iterator(ostream_type\x26 __s) _NOEXCEPT\x0a"
"        \x3a __sbuf_(__s.rdbuf()) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostreambuf_iterator(streambuf_type* __s) _NOEXCEPT\x0a"
"        \x3a __sbuf_(__s) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostreambuf_iterator\x26 operator=(_CharT __c)\x0a"
"        {\x0a"
"            if (__sbuf_ \x26\x26 traits_type\x3a\x3a""eq_int_type(__sbuf_->sputc(__c), traits_type\x3a\x3a""eof()))\x0a"
"                __sbuf_ = 0;\x0a"
"            return *this;\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostreambuf_iterator\x26 operator*()     {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostreambuf_iterator\x26 operator++()    {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY ostreambuf_iterator\x26 operator++(int) {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool failed() const _NOEXCEPT {return __sbuf_ == 0;}\x0a"
"\x0a"
"    template <class _Ch, class _Tr>\x0a"
"    friend\x0a"
"    _LIBCPP_HIDDEN\x0a"
"    ostreambuf_iterator<_Ch, _Tr>\x0a"
"    __pad_and_output(ostreambuf_iterator<_Ch, _Tr> __s,\x0a"
"                     const _Ch* __ob, const _Ch* __op, const _Ch* __oe,\x0a"
"                     ios_base\x26 __iob, _Ch __fl);\x0a"
"};\x0a"
"\x0a"
"template <class _Iter>\x0a"
"class _LIBCPP_TEMPLATE_VIS move_iterator\x0a"
"{\x0a"
"private\x3a\x0a"
"    _Iter __i;\x0a"
"public\x3a\x0a"
"    typedef _Iter                                            iterator_type;\x0a"
"    typedef typename iterator_traits<iterator_type>\x3a\x3aiterator_category iterator_category;\x0a"
"    typedef typename iterator_traits<iterator_type>\x3a\x3avalue_type value_type;\x0a"
"    typedef typename iterator_traits<iterator_type>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef iterator_type pointer;\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef typename iterator_traits<iterator_type>\x3a\x3areference __reference;\x0a"
"    typedef typename conditional<\x0a"
"            is_reference<__reference>\x3a\x3avalue,\x0a"
"            typename remove_reference<__reference>\x3a\x3atype\x26\x26,\x0a"
"            __reference\x0a"
"        >\x3a\x3atype reference;\x0a"
"#else\x0a"
"    typedef typename iterator_traits<iterator_type>\x3a\x3areference reference;\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    move_iterator() \x3a __i() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    explicit move_iterator(_Iter __x) \x3a __i(__x) {}\x0a"
"    template <class _Up>\x0a"
"      _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"      move_iterator(const move_iterator<_Up>\x26 __u) \x3a __i(__u.base()) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14 _Iter base() const {return __i;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reference operator*() const { return static_cast<reference>(*__i); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    pointer  operator->() const { return __i;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    move_iterator\x26 operator++() {++__i; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    move_iterator  operator++(int) {move_iterator __tmp(*this); ++__i; return __tmp;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    move_iterator\x26 operator--() {--__i; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    move_iterator  operator--(int) {move_iterator __tmp(*this); --__i; return __tmp;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    move_iterator  operator+ (difference_type __n) const {return move_iterator(__i + __n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    move_iterator\x26 operator+=(difference_type __n) {__i += __n; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    move_iterator  operator- (difference_type __n) const {return move_iterator(__i - __n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    move_iterator\x26 operator-=(difference_type __n) {__i -= __n; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"    reference operator\x5b\x5d(difference_type __n) const { return static_cast<reference>(__i\x5b__n\x5d); }\x0a"
"};\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator==(const move_iterator<_Iter1>\x26 __x, const move_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() == __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator<(const move_iterator<_Iter1>\x26 __x, const move_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() < __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator\x21=(const move_iterator<_Iter1>\x26 __x, const move_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() \x21= __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator>(const move_iterator<_Iter1>\x26 __x, const move_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() > __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator>=(const move_iterator<_Iter1>\x26 __x, const move_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() >= __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"bool\x0a"
"operator<=(const move_iterator<_Iter1>\x26 __x, const move_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() <= __y.base();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto\x0a"
"operator-(const move_iterator<_Iter1>\x26 __x, const move_iterator<_Iter2>\x26 __y)\x0a"
"-> decltype(__x.base() - __y.base())\x0a"
"{\x0a"
"    return __x.base() - __y.base();\x0a"
"}\x0a"
"#else\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename move_iterator<_Iter1>\x3a\x3a""difference_type\x0a"
"operator-(const move_iterator<_Iter1>\x26 __x, const move_iterator<_Iter2>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() - __y.base();\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Iter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"move_iterator<_Iter>\x0a"
"operator+(typename move_iterator<_Iter>\x3a\x3a""difference_type __n, const move_iterator<_Iter>\x26 __x)\x0a"
"{\x0a"
"    return move_iterator<_Iter>(__x.base() + __n);\x0a"
"}\x0a"
"\x0a"
"template <class _Iter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"move_iterator<_Iter>\x0a"
"make_move_iterator(_Iter __i)\x0a"
"{\x0a"
"    return move_iterator<_Iter>(__i);\x0a"
"}\x0a"
"\x0a"
"// __wrap_iter\x0a"
"\x0a"
"template <class _Iter> class __wrap_iter;\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator==(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator<(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator\x21=(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator>(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator>=(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator<=(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"auto\x0a"
"operator-(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter2>\x26 __y) _NOEXCEPT\x0a"
"-> decltype(__x.base() - __y.base());\x0a"
"#else\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename __wrap_iter<_Iter1>\x3a\x3a""difference_type\x0a"
"operator-(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Iter>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"__wrap_iter<_Iter>\x0a"
"operator+(typename __wrap_iter<_Iter>\x3a\x3a""difference_type, __wrap_iter<_Iter>) _NOEXCEPT;\x0a"
"\x0a"
"template <class _Ip, class _Op> _Op _LIBCPP_INLINE_VISIBILITY copy(_Ip, _Ip, _Op);\x0a"
"template <class _B1, class _B2> _B2 _LIBCPP_INLINE_VISIBILITY copy_backward(_B1, _B1, _B2);\x0a"
"template <class _Ip, class _Op> _Op _LIBCPP_INLINE_VISIBILITY move(_Ip, _Ip, _Op);\x0a"
"template <class _B1, class _B2> _B2 _LIBCPP_INLINE_VISIBILITY move_backward(_B1, _B1, _B2);\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL < 2\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_trivially_copy_assignable<_Tp>\x3a\x3avalue,\x0a"
"    _Tp*\x0a"
">\x3a\x3atype\x0a"
"__unwrap_iter(__wrap_iter<_Tp*>);\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_trivially_copy_assignable<_Tp>\x3a\x3avalue,\x0a"
"    __wrap_iter<_Tp*>\x0a"
">\x3a\x3atype\x0a"
"__unwrap_iter(__wrap_iter<_Tp*> __i);\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"template <class _Iter>\x0a"
"class __wrap_iter\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Iter                                                      iterator_type;\x0a"
"    typedef typename iterator_traits<iterator_type>\x3a\x3aiterator_category iterator_category;\x0a"
"    typedef typename iterator_traits<iterator_type>\x3a\x3avalue_type        value_type;\x0a"
"    typedef typename iterator_traits<iterator_type>\x3a\x3a""difference_type   difference_type;\x0a"
"    typedef typename iterator_traits<iterator_type>\x3a\x3apointer           pointer;\x0a"
"    typedef typename iterator_traits<iterator_type>\x3a\x3areference         reference;\x0a"
"private\x3a\x0a"
"    iterator_type __i;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter() _NOEXCEPT\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"                \x3a __i{}\x0a"
"#endif\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __get_db()->__insert_i(this);\x0a"
"#endif\x0a"
"    }\x0a"
"    template <class _Up> _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"        __wrap_iter(const __wrap_iter<_Up>\x26 __u,\x0a"
"            typename enable_if<is_convertible<_Up, iterator_type>\x3a\x3avalue>\x3a\x3atype* = 0) _NOEXCEPT\x0a"
"            \x3a __i(__u.base())\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __get_db()->__iterator_copy(this, \x26__u);\x0a"
"#endif\x0a"
"    }\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"    __wrap_iter(const __wrap_iter\x26 __x)\x0a"
"        \x3a __i(__x.base())\x0a"
"    {\x0a"
"        __get_db()->__iterator_copy(this, \x26__x);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"    __wrap_iter\x26 operator=(const __wrap_iter\x26 __x)\x0a"
"    {\x0a"
"        if (this \x21= \x26__x)\x0a"
"        {\x0a"
"            __get_db()->__iterator_copy(this, \x26__x);\x0a"
"            __i = __x.__i;\x0a"
"        }\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"    \x7e__wrap_iter()\x0a"
"    {\x0a"
"        __get_db()->__erase_i(this);\x0a"
"    }\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG reference operator*() const _NOEXCEPT\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__dereferenceable(this),\x0a"
"                       \x22""Attempted to dereference a non-dereferenceable iterator\x22);\x0a"
"#endif\x0a"
"        return *__i;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG pointer  operator->() const _NOEXCEPT\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__dereferenceable(this),\x0a"
"                       \x22""Attempted to dereference a non-dereferenceable iterator\x22);\x0a"
"#endif\x0a"
"        return (pointer)_VSTD\x3a\x3a""addressof(*__i);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter\x26 operator++() _NOEXCEPT\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__dereferenceable(this),\x0a"
"                       \x22""Attempted to increment non-incrementable iterator\x22);\x0a"
"#endif\x0a"
"        ++__i;\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter  operator++(int) _NOEXCEPT\x0a"
"        {__wrap_iter __tmp(*this); ++(*this); return __tmp;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter\x26 operator--() _NOEXCEPT\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__decrementable(this),\x0a"
"                       \x22""Attempted to decrement non-decrementable iterator\x22);\x0a"
"#endif\x0a"
"        --__i;\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter  operator--(int) _NOEXCEPT\x0a"
"        {__wrap_iter __tmp(*this); --(*this); return __tmp;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter  operator+ (difference_type __n) const _NOEXCEPT\x0a"
"        {__wrap_iter __w(*this); __w += __n; return __w;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter\x26 operator+=(difference_type __n) _NOEXCEPT\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__addable(this, __n),\x0a"
"                   \x22""Attempted to add/subtract iterator outside of valid range\x22);\x0a"
"#endif\x0a"
"        __i += __n;\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter  operator- (difference_type __n) const _NOEXCEPT\x0a"
"        {return *this + (-__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter\x26 operator-=(difference_type __n) _NOEXCEPT\x0a"
"        {*this += -__n; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG reference    operator\x5b\x5d(difference_type __n) const _NOEXCEPT\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__subscriptable(this, __n),\x0a"
"                   \x22""Attempted to subscript iterator outside of valid range\x22);\x0a"
"#endif\x0a"
"        return __i\x5b__n\x5d;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG iterator_type base() const _NOEXCEPT {return __i;}\x0a"
"\x0a"
"private\x3a\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter(const void* __p, iterator_type __x) \x3a __i(__x)\x0a"
"    {\x0a"
"        __get_db()->__insert_ic(this, __p);\x0a"
"    }\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG __wrap_iter(iterator_type __x) _NOEXCEPT \x3a __i(__x) {}\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Up> friend class __wrap_iter;\x0a"
"    template <class _CharT, class _Traits, class _Alloc> friend class basic_string;\x0a"
"    template <class _Tp, class _Alloc> friend class _LIBCPP_TEMPLATE_VIS vector;\x0a"
"    template <class _Tp, size_t> friend class _LIBCPP_TEMPLATE_VIS span;\x0a"
"\x0a"
"    template <class _Iter1, class _Iter2>\x0a"
"    _LIBCPP_CONSTEXPR_IF_NODEBUG friend\x0a"
"    bool\x0a"
"    operator==(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Iter1, class _Iter2>\x0a"
"    _LIBCPP_CONSTEXPR_IF_NODEBUG friend\x0a"
"    bool\x0a"
"    operator<(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Iter1, class _Iter2>\x0a"
"    _LIBCPP_CONSTEXPR_IF_NODEBUG friend\x0a"
"    bool\x0a"
"    operator\x21=(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Iter1, class _Iter2>\x0a"
"    _LIBCPP_CONSTEXPR_IF_NODEBUG friend\x0a"
"    bool\x0a"
"    operator>(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Iter1, class _Iter2>\x0a"
"    _LIBCPP_CONSTEXPR_IF_NODEBUG friend\x0a"
"    bool\x0a"
"    operator>=(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Iter1, class _Iter2>\x0a"
"    _LIBCPP_CONSTEXPR_IF_NODEBUG friend\x0a"
"    bool\x0a"
"    operator<=(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Iter1, class _Iter2>\x0a"
"    _LIBCPP_CONSTEXPR_IF_NODEBUG friend\x0a"
"    auto\x0a"
"    operator-(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter2>\x26 __y) _NOEXCEPT\x0a"
"    -> decltype(__x.base() - __y.base());\x0a"
"#else\x0a"
"    template <class _Iter1, class _Iter2>\x0a"
"    _LIBCPP_CONSTEXPR_IF_NODEBUG friend\x0a"
"    typename __wrap_iter<_Iter1>\x3a\x3a""difference_type\x0a"
"    operator-(const __wrap_iter<_Iter1>\x26, const __wrap_iter<_Iter2>\x26) _NOEXCEPT;\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Iter1>\x0a"
"    _LIBCPP_CONSTEXPR_IF_NODEBUG friend\x0a"
"    __wrap_iter<_Iter1>\x0a"
"    operator+(typename __wrap_iter<_Iter1>\x3a\x3a""difference_type, __wrap_iter<_Iter1>) _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Ip, class _Op> friend _Op copy(_Ip, _Ip, _Op);\x0a"
"    template <class _B1, class _B2> friend _B2 copy_backward(_B1, _B1, _B2);\x0a"
"    template <class _Ip, class _Op> friend _Op move(_Ip, _Ip, _Op);\x0a"
"    template <class _B1, class _B2> friend _B2 move_backward(_B1, _B1, _B2);\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL < 2\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR_IF_NODEBUG friend\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        is_trivially_copy_assignable<_Tp>\x3a\x3avalue,\x0a"
"        _Tp*\x0a"
"    >\x3a\x3atype\x0a"
"    __unwrap_iter(__wrap_iter<_Tp*>);\x0a"
"#else\x0a"
"  template <class _Tp>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"  typename enable_if\x0a"
"  <\x0a"
"      is_trivially_copy_assignable<_Tp>\x3a\x3avalue,\x0a"
"      __wrap_iter<_Tp*>\x0a"
"  >\x3a\x3atype\x0a"
"  __unwrap_iter(__wrap_iter<_Tp*> __i);\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator==(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter2>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __x.base() == __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator<(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter2>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__less_than_comparable(\x26__x, \x26__y),\x0a"
"                   \x22""Attempted to compare incomparable iterators\x22);\x0a"
"#endif\x0a"
"    return __x.base() < __y.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator\x21=(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter2>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator>(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter2>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator>=(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter2>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator<=(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter2>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator\x21=(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter1>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator>(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter1>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator>=(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter1>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Iter1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"bool\x0a"
"operator<=(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter1>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"auto\x0a"
"operator-(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter2>\x26 __y) _NOEXCEPT\x0a"
"-> decltype(__x.base() - __y.base())\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__less_than_comparable(\x26__x, \x26__y),\x0a"
"                   \x22""Attempted to subtract incompatible iterators\x22);\x0a"
"#endif\x0a"
"    return __x.base() - __y.base();\x0a"
"}\x0a"
"#else\x0a"
"template <class _Iter1, class _Iter2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"typename __wrap_iter<_Iter1>\x3a\x3a""difference_type\x0a"
"operator-(const __wrap_iter<_Iter1>\x26 __x, const __wrap_iter<_Iter2>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__less_than_comparable(\x26__x, \x26__y),\x0a"
"                   \x22""Attempted to subtract incompatible iterators\x22);\x0a"
"#endif\x0a"
"    return __x.base() - __y.base();\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Iter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"__wrap_iter<_Iter>\x0a"
"operator+(typename __wrap_iter<_Iter>\x3a\x3a""difference_type __n,\x0a"
"          __wrap_iter<_Iter> __x) _NOEXCEPT\x0a"
"{\x0a"
"    __x += __n;\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Iter>\x0a"
"struct __libcpp_is_trivial_iterator\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT(is_pointer<_Iter>\x3a\x3avalue) {};\x0a"
"\x0a"
"template <class _Iter>\x0a"
"struct __libcpp_is_trivial_iterator<move_iterator<_Iter> >\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT(__libcpp_is_trivial_iterator<_Iter>\x3a\x3avalue) {};\x0a"
"\x0a"
"template <class _Iter>\x0a"
"struct __libcpp_is_trivial_iterator<reverse_iterator<_Iter> >\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT(__libcpp_is_trivial_iterator<_Iter>\x3a\x3avalue) {};\x0a"
"\x0a"
"template <class _Iter>\x0a"
"struct __libcpp_is_trivial_iterator<__wrap_iter<_Iter> >\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT(__libcpp_is_trivial_iterator<_Iter>\x3a\x3avalue) {};\x0a"
"\x0a"
"\x0a"
"template <class _Tp, size_t _Np>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp*\x0a"
"begin(_Tp (\x26__array)\x5b_Np\x5d)\x0a"
"{\x0a"
"    return __array;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t _Np>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp*\x0a"
"end(_Tp (\x26__array)\x5b_Np\x5d)\x0a"
"{\x0a"
"    return __array + _Np;\x0a"
"}\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto\x0a"
"begin(_Cp\x26 __c) -> decltype(__c.begin())\x0a"
"{\x0a"
"    return __c.begin();\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto\x0a"
"begin(const _Cp\x26 __c) -> decltype(__c.begin())\x0a"
"{\x0a"
"    return __c.begin();\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto\x0a"
"end(_Cp\x26 __c) -> decltype(__c.end())\x0a"
"{\x0a"
"    return __c.end();\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto\x0a"
"end(const _Cp\x26 __c) -> decltype(__c.end())\x0a"
"{\x0a"
"    return __c.end();\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"template <class _Tp, size_t _Np>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"reverse_iterator<_Tp*> rbegin(_Tp (\x26__array)\x5b_Np\x5d)\x0a"
"{\x0a"
"    return reverse_iterator<_Tp*>(__array + _Np);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t _Np>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"reverse_iterator<_Tp*> rend(_Tp (\x26__array)\x5b_Np\x5d)\x0a"
"{\x0a"
"    return reverse_iterator<_Tp*>(__array);\x0a"
"}\x0a"
"\x0a"
"template <class _Ep>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"reverse_iterator<const _Ep*> rbegin(initializer_list<_Ep> __il)\x0a"
"{\x0a"
"    return reverse_iterator<const _Ep*>(__il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Ep>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"reverse_iterator<const _Ep*> rend(initializer_list<_Ep> __il)\x0a"
"{\x0a"
"    return reverse_iterator<const _Ep*>(__il.begin());\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"auto cbegin(const _Cp\x26 __c) -> decltype(_VSTD\x3a\x3a""begin(__c))\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""begin(__c);\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"auto cend(const _Cp\x26 __c) -> decltype(_VSTD\x3a\x3a""end(__c))\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""end(__c);\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto rbegin(_Cp\x26 __c) -> decltype(__c.rbegin())\x0a"
"{\x0a"
"    return __c.rbegin();\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto rbegin(const _Cp\x26 __c) -> decltype(__c.rbegin())\x0a"
"{\x0a"
"    return __c.rbegin();\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto rend(_Cp\x26 __c) -> decltype(__c.rend())\x0a"
"{\x0a"
"    return __c.rend();\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto rend(const _Cp\x26 __c) -> decltype(__c.rend())\x0a"
"{\x0a"
"    return __c.rend();\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto crbegin(const _Cp\x26 __c) -> decltype(_VSTD\x3a\x3arbegin(__c))\x0a"
"{\x0a"
"    return _VSTD\x3a\x3arbegin(__c);\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"auto crend(const _Cp\x26 __c) -> decltype(_VSTD\x3a\x3arend(__c))\x0a"
"{\x0a"
"    return _VSTD\x3a\x3arend(__c);\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"#else  // defined(_LIBCPP_CXX03_LANG)\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename _Cp\x3a\x3aiterator\x0a"
"begin(_Cp\x26 __c)\x0a"
"{\x0a"
"    return __c.begin();\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename _Cp\x3a\x3a""const_iterator\x0a"
"begin(const _Cp\x26 __c)\x0a"
"{\x0a"
"    return __c.begin();\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename _Cp\x3a\x3aiterator\x0a"
"end(_Cp\x26 __c)\x0a"
"{\x0a"
"    return __c.end();\x0a"
"}\x0a"
"\x0a"
"template <class _Cp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"typename _Cp\x3a\x3a""const_iterator\x0a"
"end(const _Cp\x26 __c)\x0a"
"{\x0a"
"    return __c.end();\x0a"
"}\x0a"
"\x0a"
"#endif  // \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"// #if _LIBCPP_STD_VER > 11\x0a"
"// template <>\x0a"
"// struct _LIBCPP_TEMPLATE_VIS plus<void>\x0a"
"// {\x0a"
"//     template <class _T1, class _T2>\x0a"
"//     _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"//     auto operator()(_T1\x26\x26 __t, _T2\x26\x26 __u) const\x0a"
"//     _NOEXCEPT_(noexcept(_VSTD\x3a\x3a""forward<_T1>(__t) + _VSTD\x3a\x3a""forward<_T2>(__u)))\x0a"
"//     -> decltype        (_VSTD\x3a\x3a""forward<_T1>(__t) + _VSTD\x3a\x3a""forward<_T2>(__u))\x0a"
"//         { return        _VSTD\x3a\x3a""forward<_T1>(__t) + _VSTD\x3a\x3a""forward<_T2>(__u); }\x0a"
"//     typedef void is_transparent;\x0a"
"// };\x0a"
"// #endif\x0a"
"\x0a"
"template <class _Cont>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr auto size(const _Cont\x26 __c)\x0a"
"_NOEXCEPT_(noexcept(__c.size()))\x0a"
"-> decltype        (__c.size())\x0a"
"{ return            __c.size(); }\x0a"
"\x0a"
"template <class _Tp, size_t _Sz>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr size_t size(const _Tp (\x26)\x5b_Sz\x5d) noexcept { return _Sz; }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Cont>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr auto ssize(const _Cont\x26 __c)\x0a"
"_NOEXCEPT_(noexcept(static_cast<common_type_t<ptrdiff_t, make_signed_t<decltype(__c.size())>>>(__c.size())))\x0a"
"->                              common_type_t<ptrdiff_t, make_signed_t<decltype(__c.size())>>\x0a"
"{ return            static_cast<common_type_t<ptrdiff_t, make_signed_t<decltype(__c.size())>>>(__c.size()); }\x0a"
"\x0a"
"template <class _Tp, ptrdiff_t _Sz>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr ptrdiff_t ssize(const _Tp (\x26)\x5b_Sz\x5d) noexcept { return _Sz; }\x0a"
"#endif\x0a"
"\x0a"
"template <class _Cont>\x0a"
"_LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr auto empty(const _Cont\x26 __c)\x0a"
"_NOEXCEPT_(noexcept(__c.empty()))\x0a"
"-> decltype        (__c.empty())\x0a"
"{ return            __c.empty(); }\x0a"
"\x0a"
"template <class _Tp, size_t _Sz>\x0a"
"_LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool empty(const _Tp (\x26)\x5b_Sz\x5d) noexcept { return false; }\x0a"
"\x0a"
"template <class _Ep>\x0a"
"_LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool empty(initializer_list<_Ep> __il) noexcept { return __il.size() == 0; }\x0a"
"\x0a"
"template <class _Cont> constexpr\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"auto data(_Cont\x26 __c)\x0a"
"_NOEXCEPT_(noexcept(__c.data()))\x0a"
"-> decltype        (__c.data())\x0a"
"{ return            __c.data(); }\x0a"
"\x0a"
"template <class _Cont> constexpr\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"auto data(const _Cont\x26 __c)\x0a"
"_NOEXCEPT_(noexcept(__c.data()))\x0a"
"-> decltype        (__c.data())\x0a"
"{ return            __c.data(); }\x0a"
"\x0a"
"template <class _Tp, size_t _Sz>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _Tp* data(_Tp (\x26__array)\x5b_Sz\x5d) noexcept { return __array; }\x0a"
"\x0a"
"template <class _Ep>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr const _Ep* data(initializer_list<_Ep> __il) noexcept { return __il.begin(); }\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_ITERATOR\x0a"
"", 69508 ); }