#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_limits( 
"// -*- C++ -*-\x0a"
"//===---------------------------- limits ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_LIMITS\x0a"
"#define _LIBCPP_LIMITS\x0a"
"\x0a"
"/*\x0a"
"    limits synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template<class T>\x0a"
"class numeric_limits\x0a"
"{\x0a"
"public\x3a\x0a"
"    static constexpr bool is_specialized = false;\x0a"
"    static constexpr T min() noexcept;\x0a"
"    static constexpr T max() noexcept;\x0a"
"    static constexpr T lowest() noexcept;\x0a"
"\x0a"
"    static constexpr int  digits = 0;\x0a"
"    static constexpr int  digits10 = 0;\x0a"
"    static constexpr int  max_digits10 = 0;\x0a"
"    static constexpr bool is_signed = false;\x0a"
"    static constexpr bool is_integer = false;\x0a"
"    static constexpr bool is_exact = false;\x0a"
"    static constexpr int  radix = 0;\x0a"
"    static constexpr T epsilon() noexcept;\x0a"
"    static constexpr T round_error() noexcept;\x0a"
"\x0a"
"    static constexpr int  min_exponent = 0;\x0a"
"    static constexpr int  min_exponent10 = 0;\x0a"
"    static constexpr int  max_exponent = 0;\x0a"
"    static constexpr int  max_exponent10 = 0;\x0a"
"\x0a"
"    static constexpr bool has_infinity = false;\x0a"
"    static constexpr bool has_quiet_NaN = false;\x0a"
"    static constexpr bool has_signaling_NaN = false;\x0a"
"    static constexpr float_denorm_style has_denorm = denorm_absent;\x0a"
"    static constexpr bool has_denorm_loss = false;\x0a"
"    static constexpr T infinity() noexcept;\x0a"
"    static constexpr T quiet_NaN() noexcept;\x0a"
"    static constexpr T signaling_NaN() noexcept;\x0a"
"    static constexpr T denorm_min() noexcept;\x0a"
"\x0a"
"    static constexpr bool is_iec559 = false;\x0a"
"    static constexpr bool is_bounded = false;\x0a"
"    static constexpr bool is_modulo = false;\x0a"
"\x0a"
"    static constexpr bool traps = false;\x0a"
"    static constexpr bool tinyness_before = false;\x0a"
"    static constexpr float_round_style round_style = round_toward_zero;\x0a"
"};\x0a"
"\x0a"
"enum float_round_style\x0a"
"{\x0a"
"    round_indeterminate       = -1,\x0a"
"    round_toward_zero         =  0,\x0a"
"    round_to_nearest          =  1,\x0a"
"    round_toward_infinity     =  2,\x0a"
"    round_toward_neg_infinity =  3\x0a"
"};\x0a"
"\x0a"
"enum float_denorm_style\x0a"
"{\x0a"
"    denorm_indeterminate = -1,\x0a"
"    denorm_absent = 0,\x0a"
"    denorm_present = 1\x0a"
"};\x0a"
"\x0a"
"template<> class numeric_limits<cv bool>;\x0a"
"\x0a"
"template<> class numeric_limits<cv char>;\x0a"
"template<> class numeric_limits<cv signed char>;\x0a"
"template<> class numeric_limits<cv unsigned char>;\x0a"
"template<> class numeric_limits<cv wchar_t>;\x0a"
"template<> class numeric_limits<cv char8_t>; // C++20\x0a"
"template<> class numeric_limits<cv char16_t>;\x0a"
"template<> class numeric_limits<cv char32_t>;\x0a"
"\x0a"
"template<> class numeric_limits<cv short>;\x0a"
"template<> class numeric_limits<cv int>;\x0a"
"template<> class numeric_limits<cv long>;\x0a"
"template<> class numeric_limits<cv long long>;\x0a"
"template<> class numeric_limits<cv unsigned short>;\x0a"
"template<> class numeric_limits<cv unsigned int>;\x0a"
"template<> class numeric_limits<cv unsigned long>;\x0a"
"template<> class numeric_limits<cv unsigned long long>;\x0a"
"\x0a"
"template<> class numeric_limits<cv float>;\x0a"
"template<> class numeric_limits<cv double>;\x0a"
"template<> class numeric_limits<cv long double>;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"#include <__config>\x0a"
"#include <type_traits>\x0a"
"\x0a"
"#if defined(_LIBCPP_COMPILER_MSVC)\x0a"
"#include \x22support/win32/limits_msvc_win32.h\x22\x0a"
"#endif // _LIBCPP_MSVCRT\x0a"
"\x0a"
"#if defined(__IBMCPP__)\x0a"
"#include \x22support/ibm/limits.h\x22\x0a"
"#endif // __IBMCPP__\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"#include <version>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"enum float_round_style\x0a"
"{\x0a"
"    round_indeterminate       = -1,\x0a"
"    round_toward_zero         =  0,\x0a"
"    round_to_nearest          =  1,\x0a"
"    round_toward_infinity     =  2,\x0a"
"    round_toward_neg_infinity =  3\x0a"
"};\x0a"
"\x0a"
"enum float_denorm_style\x0a"
"{\x0a"
"    denorm_indeterminate = -1,\x0a"
"    denorm_absent = 0,\x0a"
"    denorm_present = 1\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool = is_arithmetic<_Tp>\x3a\x3avalue>\x0a"
"class __libcpp_numeric_limits\x0a"
"{\x0a"
"protected\x3a\x0a"
"    typedef _Tp type;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const  bool is_specialized = false;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type min() _NOEXCEPT {return type();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type max() _NOEXCEPT {return type();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type lowest() _NOEXCEPT {return type();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits10 = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_digits10 = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_signed = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_integer = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_exact = false;\x0a"
"    static _LIBCPP_CONSTEXPR const int  radix = 0;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type epsilon() _NOEXCEPT {return type();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type round_error() _NOEXCEPT {return type();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent10 = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent10 = 0;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_infinity = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_quiet_NaN = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_signaling_NaN = false;\x0a"
"    static _LIBCPP_CONSTEXPR const float_denorm_style has_denorm = denorm_absent;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_denorm_loss = false;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type infinity() _NOEXCEPT {return type();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type quiet_NaN() _NOEXCEPT {return type();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type signaling_NaN() _NOEXCEPT {return type();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type denorm_min() _NOEXCEPT {return type();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_bounded = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_modulo = false;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool tinyness_before = false;\x0a"
"    static _LIBCPP_CONSTEXPR const float_round_style round_style = round_toward_zero;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, int __digits, bool _IsSigned>\x0a"
"struct __libcpp_compute_min\x0a"
"{\x0a"
"    static _LIBCPP_CONSTEXPR const _Tp value = _Tp(_Tp(1) << __digits);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, int __digits>\x0a"
"struct __libcpp_compute_min<_Tp, __digits, false>\x0a"
"{\x0a"
"    static _LIBCPP_CONSTEXPR const _Tp value = _Tp(0);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class __libcpp_numeric_limits<_Tp, true>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    typedef _Tp type;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_specialized = true;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_signed = type(-1) < type(0);\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits = static_cast<int>(sizeof(type) * __CHAR_BIT__ - is_signed);\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits10 = digits * 3 / 10;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_digits10 = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const type __min = __libcpp_compute_min<type, digits, is_signed>\x3a\x3avalue;\x0a"
"    static _LIBCPP_CONSTEXPR const type __max = is_signed \x3f type(type(\x7e""0) ^ __min) \x3a type(\x7e""0);\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type min() _NOEXCEPT {return __min;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type max() _NOEXCEPT {return __max;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type lowest() _NOEXCEPT {return min();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_integer = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_exact = true;\x0a"
"    static _LIBCPP_CONSTEXPR const int  radix = 2;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type epsilon() _NOEXCEPT {return type(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type round_error() _NOEXCEPT {return type(0);}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent10 = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent10 = 0;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_infinity = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_quiet_NaN = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_signaling_NaN = false;\x0a"
"    static _LIBCPP_CONSTEXPR const float_denorm_style has_denorm = denorm_absent;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_denorm_loss = false;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type infinity() _NOEXCEPT {return type(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type quiet_NaN() _NOEXCEPT {return type(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type signaling_NaN() _NOEXCEPT {return type(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type denorm_min() _NOEXCEPT {return type(0);}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_bounded = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_modulo = \x21_VSTD\x3a\x3ais_signed<_Tp>\x3a\x3avalue;\x0a"
"\x0a"
"#if defined(__i386__) \x7c\x7c defined(__x86_64__) \x7c\x7c defined(__pnacl__) \x7c\x7c \x5c\x0a"
"    defined(__wasm__)\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = true;\x0a"
"#else\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = false;\x0a"
"#endif\x0a"
"    static _LIBCPP_CONSTEXPR const bool tinyness_before = false;\x0a"
"    static _LIBCPP_CONSTEXPR const float_round_style round_style = round_toward_zero;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class __libcpp_numeric_limits<bool, true>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    typedef bool type;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_specialized = true;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_signed = false;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits = 1;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits10 = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_digits10 = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const type __min = false;\x0a"
"    static _LIBCPP_CONSTEXPR const type __max = true;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type min() _NOEXCEPT {return __min;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type max() _NOEXCEPT {return __max;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type lowest() _NOEXCEPT {return min();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_integer = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_exact = true;\x0a"
"    static _LIBCPP_CONSTEXPR const int  radix = 2;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type epsilon() _NOEXCEPT {return type(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type round_error() _NOEXCEPT {return type(0);}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent10 = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent10 = 0;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_infinity = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_quiet_NaN = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_signaling_NaN = false;\x0a"
"    static _LIBCPP_CONSTEXPR const float_denorm_style has_denorm = denorm_absent;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_denorm_loss = false;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type infinity() _NOEXCEPT {return type(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type quiet_NaN() _NOEXCEPT {return type(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type signaling_NaN() _NOEXCEPT {return type(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type denorm_min() _NOEXCEPT {return type(0);}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_bounded = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_modulo = false;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool tinyness_before = false;\x0a"
"    static _LIBCPP_CONSTEXPR const float_round_style round_style = round_toward_zero;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class __libcpp_numeric_limits<float, true>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    typedef float type;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_specialized = true;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_signed = true;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits = __FLT_MANT_DIG__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits10 = __FLT_DIG__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_digits10 = 2+(digits * 30103l)/100000l;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type min() _NOEXCEPT {return __FLT_MIN__;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type max() _NOEXCEPT {return __FLT_MAX__;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type lowest() _NOEXCEPT {return -max();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_integer = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_exact = false;\x0a"
"    static _LIBCPP_CONSTEXPR const int  radix = __FLT_RADIX__;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type epsilon() _NOEXCEPT {return __FLT_EPSILON__;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type round_error() _NOEXCEPT {return 0.5F;}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent = __FLT_MIN_EXP__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent10 = __FLT_MIN_10_EXP__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent = __FLT_MAX_EXP__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent10 = __FLT_MAX_10_EXP__;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_infinity = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_quiet_NaN = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_signaling_NaN = true;\x0a"
"    static _LIBCPP_CONSTEXPR const float_denorm_style has_denorm = denorm_present;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_denorm_loss = false;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type infinity() _NOEXCEPT {return __builtin_huge_valf();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type quiet_NaN() _NOEXCEPT {return __builtin_nanf(\x22\x22);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type signaling_NaN() _NOEXCEPT {return __builtin_nansf(\x22\x22);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type denorm_min() _NOEXCEPT {return __FLT_DENORM_MIN__;}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_bounded = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_modulo = false;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool tinyness_before = false;\x0a"
"    static _LIBCPP_CONSTEXPR const float_round_style round_style = round_to_nearest;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class __libcpp_numeric_limits<double, true>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    typedef double type;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_specialized = true;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_signed = true;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits = __DBL_MANT_DIG__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits10 = __DBL_DIG__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_digits10 = 2+(digits * 30103l)/100000l;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type min() _NOEXCEPT {return __DBL_MIN__;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type max() _NOEXCEPT {return __DBL_MAX__;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type lowest() _NOEXCEPT {return -max();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_integer = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_exact = false;\x0a"
"    static _LIBCPP_CONSTEXPR const int  radix = __FLT_RADIX__;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type epsilon() _NOEXCEPT {return __DBL_EPSILON__;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type round_error() _NOEXCEPT {return 0.5;}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent = __DBL_MIN_EXP__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent10 = __DBL_MIN_10_EXP__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent = __DBL_MAX_EXP__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent10 = __DBL_MAX_10_EXP__;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_infinity = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_quiet_NaN = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_signaling_NaN = true;\x0a"
"    static _LIBCPP_CONSTEXPR const float_denorm_style has_denorm = denorm_present;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_denorm_loss = false;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type infinity() _NOEXCEPT {return __builtin_huge_val();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type quiet_NaN() _NOEXCEPT {return __builtin_nan(\x22\x22);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type signaling_NaN() _NOEXCEPT {return __builtin_nans(\x22\x22);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type denorm_min() _NOEXCEPT {return __DBL_DENORM_MIN__;}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_bounded = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_modulo = false;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool tinyness_before = false;\x0a"
"    static _LIBCPP_CONSTEXPR const float_round_style round_style = round_to_nearest;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class __libcpp_numeric_limits<long double, true>\x0a"
"{\x0a"
"protected\x3a\x0a"
"    typedef long double type;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_specialized = true;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_signed = true;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits = __LDBL_MANT_DIG__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits10 = __LDBL_DIG__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_digits10 = 2+(digits * 30103l)/100000l;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type min() _NOEXCEPT {return __LDBL_MIN__;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type max() _NOEXCEPT {return __LDBL_MAX__;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type lowest() _NOEXCEPT {return -max();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_integer = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_exact = false;\x0a"
"    static _LIBCPP_CONSTEXPR const int  radix = __FLT_RADIX__;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type epsilon() _NOEXCEPT {return __LDBL_EPSILON__;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type round_error() _NOEXCEPT {return 0.5L;}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent = __LDBL_MIN_EXP__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent10 = __LDBL_MIN_10_EXP__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent = __LDBL_MAX_EXP__;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent10 = __LDBL_MAX_10_EXP__;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_infinity = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_quiet_NaN = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_signaling_NaN = true;\x0a"
"    static _LIBCPP_CONSTEXPR const float_denorm_style has_denorm = denorm_present;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_denorm_loss = false;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type infinity() _NOEXCEPT {return __builtin_huge_vall();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type quiet_NaN() _NOEXCEPT {return __builtin_nanl(\x22\x22);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type signaling_NaN() _NOEXCEPT {return __builtin_nansl(\x22\x22);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type denorm_min() _NOEXCEPT {return __LDBL_DENORM_MIN__;}\x0a"
"\x0a"
"#if (defined(__ppc__) \x7c\x7c defined(__ppc64__))\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = false;\x0a"
"#else\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = true;\x0a"
"#endif\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_bounded = true;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_modulo = false;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = false;\x0a"
"    static _LIBCPP_CONSTEXPR const bool tinyness_before = false;\x0a"
"    static _LIBCPP_CONSTEXPR const float_round_style round_style = round_to_nearest;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS numeric_limits\x0a"
"    \x3a private __libcpp_numeric_limits<typename remove_cv<_Tp>\x3a\x3atype>\x0a"
"{\x0a"
"    typedef __libcpp_numeric_limits<typename remove_cv<_Tp>\x3a\x3atype> __base;\x0a"
"    typedef typename __base\x3a\x3atype type;\x0a"
"public\x3a\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_specialized = __base\x3a\x3ais_specialized;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type min() _NOEXCEPT {return __base\x3a\x3amin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type max() _NOEXCEPT {return __base\x3a\x3amax();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type lowest() _NOEXCEPT {return __base\x3a\x3alowest();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits = __base\x3a\x3a""digits;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits10 = __base\x3a\x3a""digits10;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_digits10 = __base\x3a\x3amax_digits10;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_signed = __base\x3a\x3ais_signed;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_integer = __base\x3a\x3ais_integer;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_exact = __base\x3a\x3ais_exact;\x0a"
"    static _LIBCPP_CONSTEXPR const int  radix = __base\x3a\x3aradix;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type epsilon() _NOEXCEPT {return __base\x3a\x3a""epsilon();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type round_error() _NOEXCEPT {return __base\x3a\x3around_error();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent = __base\x3a\x3amin_exponent;\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent10 = __base\x3a\x3amin_exponent10;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent = __base\x3a\x3amax_exponent;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent10 = __base\x3a\x3amax_exponent10;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_infinity = __base\x3a\x3ahas_infinity;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_quiet_NaN = __base\x3a\x3ahas_quiet_NaN;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_signaling_NaN = __base\x3a\x3ahas_signaling_NaN;\x0a"
"    static _LIBCPP_CONSTEXPR const float_denorm_style has_denorm = __base\x3a\x3ahas_denorm;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_denorm_loss = __base\x3a\x3ahas_denorm_loss;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type infinity() _NOEXCEPT {return __base\x3a\x3ainfinity();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type quiet_NaN() _NOEXCEPT {return __base\x3a\x3aquiet_NaN();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type signaling_NaN() _NOEXCEPT {return __base\x3a\x3asignaling_NaN();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type denorm_min() _NOEXCEPT {return __base\x3a\x3a""denorm_min();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = __base\x3a\x3ais_iec559;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_bounded = __base\x3a\x3ais_bounded;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_modulo = __base\x3a\x3ais_modulo;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = __base\x3a\x3atraps;\x0a"
"    static _LIBCPP_CONSTEXPR const bool tinyness_before = __base\x3a\x3atinyness_before;\x0a"
"    static _LIBCPP_CONSTEXPR const float_round_style round_style = __base\x3a\x3around_style;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ais_specialized;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<_Tp>\x3a\x3a""digits;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<_Tp>\x3a\x3a""digits10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<_Tp>\x3a\x3amax_digits10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ais_signed;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ais_integer;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ais_exact;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<_Tp>\x3a\x3aradix;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<_Tp>\x3a\x3amin_exponent;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<_Tp>\x3a\x3amin_exponent10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<_Tp>\x3a\x3amax_exponent;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<_Tp>\x3a\x3amax_exponent10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ahas_infinity;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ahas_quiet_NaN;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ahas_signaling_NaN;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const float_denorm_style numeric_limits<_Tp>\x3a\x3ahas_denorm;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ahas_denorm_loss;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ais_iec559;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ais_bounded;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3ais_modulo;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3atraps;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<_Tp>\x3a\x3atinyness_before;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const float_round_style numeric_limits<_Tp>\x3a\x3around_style;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS numeric_limits<const _Tp>\x0a"
"    \x3a private numeric_limits<_Tp>\x0a"
"{\x0a"
"    typedef numeric_limits<_Tp> __base;\x0a"
"    typedef _Tp type;\x0a"
"public\x3a\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_specialized = __base\x3a\x3ais_specialized;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type min() _NOEXCEPT {return __base\x3a\x3amin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type max() _NOEXCEPT {return __base\x3a\x3amax();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type lowest() _NOEXCEPT {return __base\x3a\x3alowest();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits = __base\x3a\x3a""digits;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits10 = __base\x3a\x3a""digits10;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_digits10 = __base\x3a\x3amax_digits10;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_signed = __base\x3a\x3ais_signed;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_integer = __base\x3a\x3ais_integer;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_exact = __base\x3a\x3ais_exact;\x0a"
"    static _LIBCPP_CONSTEXPR const int  radix = __base\x3a\x3aradix;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type epsilon() _NOEXCEPT {return __base\x3a\x3a""epsilon();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type round_error() _NOEXCEPT {return __base\x3a\x3around_error();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent = __base\x3a\x3amin_exponent;\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent10 = __base\x3a\x3amin_exponent10;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent = __base\x3a\x3amax_exponent;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent10 = __base\x3a\x3amax_exponent10;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_infinity = __base\x3a\x3ahas_infinity;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_quiet_NaN = __base\x3a\x3ahas_quiet_NaN;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_signaling_NaN = __base\x3a\x3ahas_signaling_NaN;\x0a"
"    static _LIBCPP_CONSTEXPR const float_denorm_style has_denorm = __base\x3a\x3ahas_denorm;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_denorm_loss = __base\x3a\x3ahas_denorm_loss;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type infinity() _NOEXCEPT {return __base\x3a\x3ainfinity();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type quiet_NaN() _NOEXCEPT {return __base\x3a\x3aquiet_NaN();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type signaling_NaN() _NOEXCEPT {return __base\x3a\x3asignaling_NaN();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type denorm_min() _NOEXCEPT {return __base\x3a\x3a""denorm_min();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = __base\x3a\x3ais_iec559;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_bounded = __base\x3a\x3ais_bounded;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_modulo = __base\x3a\x3ais_modulo;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = __base\x3a\x3atraps;\x0a"
"    static _LIBCPP_CONSTEXPR const bool tinyness_before = __base\x3a\x3atinyness_before;\x0a"
"    static _LIBCPP_CONSTEXPR const float_round_style round_style = __base\x3a\x3around_style;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ais_specialized;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const _Tp>\x3a\x3a""digits;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const _Tp>\x3a\x3a""digits10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const _Tp>\x3a\x3amax_digits10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ais_signed;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ais_integer;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ais_exact;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const _Tp>\x3a\x3aradix;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const _Tp>\x3a\x3amin_exponent;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const _Tp>\x3a\x3amin_exponent10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const _Tp>\x3a\x3amax_exponent;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const _Tp>\x3a\x3amax_exponent10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ahas_infinity;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ahas_quiet_NaN;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ahas_signaling_NaN;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const float_denorm_style numeric_limits<const _Tp>\x3a\x3ahas_denorm;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ahas_denorm_loss;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ais_iec559;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ais_bounded;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3ais_modulo;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3atraps;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const _Tp>\x3a\x3atinyness_before;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const float_round_style numeric_limits<const _Tp>\x3a\x3around_style;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS numeric_limits<volatile _Tp>\x0a"
"    \x3a private numeric_limits<_Tp>\x0a"
"{\x0a"
"    typedef numeric_limits<_Tp> __base;\x0a"
"    typedef _Tp type;\x0a"
"public\x3a\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_specialized = __base\x3a\x3ais_specialized;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type min() _NOEXCEPT {return __base\x3a\x3amin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type max() _NOEXCEPT {return __base\x3a\x3amax();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type lowest() _NOEXCEPT {return __base\x3a\x3alowest();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits = __base\x3a\x3a""digits;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits10 = __base\x3a\x3a""digits10;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_digits10 = __base\x3a\x3amax_digits10;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_signed = __base\x3a\x3ais_signed;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_integer = __base\x3a\x3ais_integer;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_exact = __base\x3a\x3ais_exact;\x0a"
"    static _LIBCPP_CONSTEXPR const int  radix = __base\x3a\x3aradix;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type epsilon() _NOEXCEPT {return __base\x3a\x3a""epsilon();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type round_error() _NOEXCEPT {return __base\x3a\x3around_error();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent = __base\x3a\x3amin_exponent;\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent10 = __base\x3a\x3amin_exponent10;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent = __base\x3a\x3amax_exponent;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent10 = __base\x3a\x3amax_exponent10;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_infinity = __base\x3a\x3ahas_infinity;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_quiet_NaN = __base\x3a\x3ahas_quiet_NaN;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_signaling_NaN = __base\x3a\x3ahas_signaling_NaN;\x0a"
"    static _LIBCPP_CONSTEXPR const float_denorm_style has_denorm = __base\x3a\x3ahas_denorm;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_denorm_loss = __base\x3a\x3ahas_denorm_loss;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type infinity() _NOEXCEPT {return __base\x3a\x3ainfinity();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type quiet_NaN() _NOEXCEPT {return __base\x3a\x3aquiet_NaN();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type signaling_NaN() _NOEXCEPT {return __base\x3a\x3asignaling_NaN();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type denorm_min() _NOEXCEPT {return __base\x3a\x3a""denorm_min();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = __base\x3a\x3ais_iec559;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_bounded = __base\x3a\x3ais_bounded;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_modulo = __base\x3a\x3ais_modulo;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = __base\x3a\x3atraps;\x0a"
"    static _LIBCPP_CONSTEXPR const bool tinyness_before = __base\x3a\x3atinyness_before;\x0a"
"    static _LIBCPP_CONSTEXPR const float_round_style round_style = __base\x3a\x3around_style;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ais_specialized;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<volatile _Tp>\x3a\x3a""digits;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<volatile _Tp>\x3a\x3a""digits10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<volatile _Tp>\x3a\x3amax_digits10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ais_signed;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ais_integer;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ais_exact;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<volatile _Tp>\x3a\x3aradix;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<volatile _Tp>\x3a\x3amin_exponent;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<volatile _Tp>\x3a\x3amin_exponent10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<volatile _Tp>\x3a\x3amax_exponent;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<volatile _Tp>\x3a\x3amax_exponent10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ahas_infinity;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ahas_quiet_NaN;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ahas_signaling_NaN;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const float_denorm_style numeric_limits<volatile _Tp>\x3a\x3ahas_denorm;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ahas_denorm_loss;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ais_iec559;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ais_bounded;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3ais_modulo;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3atraps;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<volatile _Tp>\x3a\x3atinyness_before;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const float_round_style numeric_limits<volatile _Tp>\x3a\x3around_style;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS numeric_limits<const volatile _Tp>\x0a"
"    \x3a private numeric_limits<_Tp>\x0a"
"{\x0a"
"    typedef numeric_limits<_Tp> __base;\x0a"
"    typedef _Tp type;\x0a"
"public\x3a\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_specialized = __base\x3a\x3ais_specialized;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type min() _NOEXCEPT {return __base\x3a\x3amin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type max() _NOEXCEPT {return __base\x3a\x3amax();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type lowest() _NOEXCEPT {return __base\x3a\x3alowest();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits = __base\x3a\x3a""digits;\x0a"
"    static _LIBCPP_CONSTEXPR const int  digits10 = __base\x3a\x3a""digits10;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_digits10 = __base\x3a\x3amax_digits10;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_signed = __base\x3a\x3ais_signed;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_integer = __base\x3a\x3ais_integer;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_exact = __base\x3a\x3ais_exact;\x0a"
"    static _LIBCPP_CONSTEXPR const int  radix = __base\x3a\x3aradix;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type epsilon() _NOEXCEPT {return __base\x3a\x3a""epsilon();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type round_error() _NOEXCEPT {return __base\x3a\x3around_error();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent = __base\x3a\x3amin_exponent;\x0a"
"    static _LIBCPP_CONSTEXPR const int  min_exponent10 = __base\x3a\x3amin_exponent10;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent = __base\x3a\x3amax_exponent;\x0a"
"    static _LIBCPP_CONSTEXPR const int  max_exponent10 = __base\x3a\x3amax_exponent10;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_infinity = __base\x3a\x3ahas_infinity;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_quiet_NaN = __base\x3a\x3ahas_quiet_NaN;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_signaling_NaN = __base\x3a\x3ahas_signaling_NaN;\x0a"
"    static _LIBCPP_CONSTEXPR const float_denorm_style has_denorm = __base\x3a\x3ahas_denorm;\x0a"
"    static _LIBCPP_CONSTEXPR const bool has_denorm_loss = __base\x3a\x3ahas_denorm_loss;\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type infinity() _NOEXCEPT {return __base\x3a\x3ainfinity();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type quiet_NaN() _NOEXCEPT {return __base\x3a\x3aquiet_NaN();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type signaling_NaN() _NOEXCEPT {return __base\x3a\x3asignaling_NaN();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY static _LIBCPP_CONSTEXPR type denorm_min() _NOEXCEPT {return __base\x3a\x3a""denorm_min();}\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_iec559 = __base\x3a\x3ais_iec559;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_bounded = __base\x3a\x3ais_bounded;\x0a"
"    static _LIBCPP_CONSTEXPR const bool is_modulo = __base\x3a\x3ais_modulo;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const bool traps = __base\x3a\x3atraps;\x0a"
"    static _LIBCPP_CONSTEXPR const bool tinyness_before = __base\x3a\x3atinyness_before;\x0a"
"    static _LIBCPP_CONSTEXPR const float_round_style round_style = __base\x3a\x3around_style;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ais_specialized;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const volatile _Tp>\x3a\x3a""digits;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const volatile _Tp>\x3a\x3a""digits10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const volatile _Tp>\x3a\x3amax_digits10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ais_signed;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ais_integer;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ais_exact;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const volatile _Tp>\x3a\x3aradix;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const volatile _Tp>\x3a\x3amin_exponent;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const volatile _Tp>\x3a\x3amin_exponent10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const volatile _Tp>\x3a\x3amax_exponent;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const int numeric_limits<const volatile _Tp>\x3a\x3amax_exponent10;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ahas_infinity;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ahas_quiet_NaN;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ahas_signaling_NaN;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const float_denorm_style numeric_limits<const volatile _Tp>\x3a\x3ahas_denorm;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ahas_denorm_loss;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ais_iec559;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ais_bounded;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3ais_modulo;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3atraps;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const bool numeric_limits<const volatile _Tp>\x3a\x3atinyness_before;\x0a"
"template <class _Tp>\x0a"
"    _LIBCPP_CONSTEXPR const float_round_style numeric_limits<const volatile _Tp>\x3a\x3around_style;\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_LIMITS\x0a"
"", 40659 ); }