#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_list( 
"// -*- C++ -*-\x0a"
"//===---------------------------- list ------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_LIST\x0a"
"#define _LIBCPP_LIST\x0a"
"\x0a"
"/*\x0a"
"    list synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class T, class Alloc = allocator<T> >\x0a"
"class list\x0a"
"{\x0a"
"public\x3a\x0a"
"\x0a"
"    // types\x3a\x0a"
"    typedef T value_type;\x0a"
"    typedef Alloc allocator_type;\x0a"
"    typedef typename allocator_type\x3a\x3areference reference;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename allocator_type\x3a\x3apointer pointer;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_pointer const_pointer;\x0a"
"    typedef implementation-defined iterator;\x0a"
"    typedef implementation-defined const_iterator;\x0a"
"    typedef implementation-defined size_type;\x0a"
"    typedef implementation-defined difference_type;\x0a"
"    typedef reverse_iterator<iterator> reverse_iterator;\x0a"
"    typedef reverse_iterator<const_iterator> const_reverse_iterator;\x0a"
"\x0a"
"    list()\x0a"
"        noexcept(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    explicit list(const allocator_type\x26 a);\x0a"
"    explicit list(size_type n);\x0a"
"    explicit list(size_type n, const allocator_type\x26 a); // C++14\x0a"
"    list(size_type n, const value_type\x26 value);\x0a"
"    list(size_type n, const value_type\x26 value, const allocator_type\x26 a);\x0a"
"    template <class Iter>\x0a"
"        list(Iter first, Iter last);\x0a"
"    template <class Iter>\x0a"
"        list(Iter first, Iter last, const allocator_type\x26 a);\x0a"
"    list(const list\x26 x);\x0a"
"    list(const list\x26, const allocator_type\x26 a);\x0a"
"    list(list\x26\x26 x)\x0a"
"        noexcept(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    list(list\x26\x26, const allocator_type\x26 a);\x0a"
"    list(initializer_list<value_type>);\x0a"
"    list(initializer_list<value_type>, const allocator_type\x26 a);\x0a"
"\x0a"
"    \x7elist();\x0a"
"\x0a"
"    list\x26 operator=(const list\x26 x);\x0a"
"    list\x26 operator=(list\x26\x26 x)\x0a"
"        noexcept(\x0a"
"             allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"             is_nothrow_move_assignable<allocator_type>\x3a\x3avalue);\x0a"
"    list\x26 operator=(initializer_list<value_type>);\x0a"
"    template <class Iter>\x0a"
"        void assign(Iter first, Iter last);\x0a"
"    void assign(size_type n, const value_type\x26 t);\x0a"
"    void assign(initializer_list<value_type>);\x0a"
"\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"\x0a"
"    iterator begin() noexcept;\x0a"
"    const_iterator begin() const noexcept;\x0a"
"    iterator end() noexcept;\x0a"
"    const_iterator end() const noexcept;\x0a"
"    reverse_iterator rbegin() noexcept;\x0a"
"    const_reverse_iterator rbegin() const noexcept;\x0a"
"    reverse_iterator rend() noexcept;\x0a"
"    const_reverse_iterator rend() const noexcept;\x0a"
"    const_iterator cbegin() const noexcept;\x0a"
"    const_iterator cend() const noexcept;\x0a"
"    const_reverse_iterator crbegin() const noexcept;\x0a"
"    const_reverse_iterator crend() const noexcept;\x0a"
"\x0a"
"    reference front();\x0a"
"    const_reference front() const;\x0a"
"    reference back();\x0a"
"    const_reference back() const;\x0a"
"\x0a"
"    bool empty() const noexcept;\x0a"
"    size_type size() const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"\x0a"
"    template <class... Args>\x0a"
"        reference emplace_front(Args\x26\x26... args); // reference in C++17\x0a"
"    void pop_front();\x0a"
"    template <class... Args>\x0a"
"        reference emplace_back(Args\x26\x26... args);  // reference in C++17\x0a"
"    void pop_back();\x0a"
"    void push_front(const value_type\x26 x);\x0a"
"    void push_front(value_type\x26\x26 x);\x0a"
"    void push_back(const value_type\x26 x);\x0a"
"    void push_back(value_type\x26\x26 x);\x0a"
"    template <class... Args>\x0a"
"        iterator emplace(const_iterator position, Args\x26\x26... args);\x0a"
"    iterator insert(const_iterator position, const value_type\x26 x);\x0a"
"    iterator insert(const_iterator position, value_type\x26\x26 x);\x0a"
"    iterator insert(const_iterator position, size_type n, const value_type\x26 x);\x0a"
"    template <class Iter>\x0a"
"        iterator insert(const_iterator position, Iter first, Iter last);\x0a"
"    iterator insert(const_iterator position, initializer_list<value_type> il);\x0a"
"\x0a"
"    iterator erase(const_iterator position);\x0a"
"    iterator erase(const_iterator position, const_iterator last);\x0a"
"\x0a"
"    void resize(size_type sz);\x0a"
"    void resize(size_type sz, const value_type\x26 c);\x0a"
"\x0a"
"    void swap(list\x26)\x0a"
"        noexcept(allocator_traits<allocator_type>\x3a\x3ais_always_equal\x3a\x3avalue);  // C++17\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    void splice(const_iterator position, list\x26 x);\x0a"
"    void splice(const_iterator position, list\x26\x26 x);\x0a"
"    void splice(const_iterator position, list\x26 x, const_iterator i);\x0a"
"    void splice(const_iterator position, list\x26\x26 x, const_iterator i);\x0a"
"    void splice(const_iterator position, list\x26 x, const_iterator first,\x0a"
"                                                  const_iterator last);\x0a"
"    void splice(const_iterator position, list\x26\x26 x, const_iterator first,\x0a"
"                                                  const_iterator last);\x0a"
"\x0a"
"    size_type remove(const value_type\x26 value);       // void before C++20\x0a"
"    template <class Pred>\x0a"
"      size_type remove_if(Pred pred);                // void before C++20\x0a"
"    size_type unique();                              // void before C++20\x0a"
"    template <class BinaryPredicate>\x0a"
"      size_type unique(BinaryPredicate binary_pred); // void before C++20\x0a"
"    void merge(list\x26 x);\x0a"
"    void merge(list\x26\x26 x);\x0a"
"    template <class Compare>\x0a"
"        void merge(list\x26 x, Compare comp);\x0a"
"    template <class Compare>\x0a"
"        void merge(list\x26\x26 x, Compare comp);\x0a"
"    void sort();\x0a"
"    template <class Compare>\x0a"
"        void sort(Compare comp);\x0a"
"    void reverse() noexcept;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class InputIterator, class Allocator = allocator<typename iterator_traits<InputIterator>\x3a\x3avalue_type>>\x0a"
"    list(InputIterator, InputIterator, Allocator = Allocator())\x0a"
"    -> list<typename iterator_traits<InputIterator>\x3a\x3avalue_type, Allocator>;  // C++17\x0a"
"\x0a"
"template <class T, class Alloc>\x0a"
"    bool operator==(const list<T,Alloc>\x26 x, const list<T,Alloc>\x26 y);\x0a"
"template <class T, class Alloc>\x0a"
"    bool operator< (const list<T,Alloc>\x26 x, const list<T,Alloc>\x26 y);\x0a"
"template <class T, class Alloc>\x0a"
"    bool operator\x21=(const list<T,Alloc>\x26 x, const list<T,Alloc>\x26 y);\x0a"
"template <class T, class Alloc>\x0a"
"    bool operator> (const list<T,Alloc>\x26 x, const list<T,Alloc>\x26 y);\x0a"
"template <class T, class Alloc>\x0a"
"    bool operator>=(const list<T,Alloc>\x26 x, const list<T,Alloc>\x26 y);\x0a"
"template <class T, class Alloc>\x0a"
"    bool operator<=(const list<T,Alloc>\x26 x, const list<T,Alloc>\x26 y);\x0a"
"\x0a"
"template <class T, class Alloc>\x0a"
"    void swap(list<T,Alloc>\x26 x, list<T,Alloc>\x26 y)\x0a"
"         noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class T, class Allocator, class U>\x0a"
"    void erase(list<T, Allocator>\x26 c, const U\x26 value);       // C++20\x0a"
"template <class T, class Allocator, class Predicate>\x0a"
"    void erase_if(list<T, Allocator>\x26 c, Predicate pred);    // C++20\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"\x0a"
"#include <memory>\x0a"
"#include <limits>\x0a"
"#include <initializer_list>\x0a"
"#include <iterator>\x0a"
"#include <algorithm>\x0a"
"#include <type_traits>\x0a"
"#include <version>\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr> struct __list_node;\x0a"
"template <class _Tp, class _VoidPtr> struct __list_node_base;\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr>\x0a"
"struct __list_node_pointer_traits {\x0a"
"  typedef typename __rebind_pointer<_VoidPtr, __list_node<_Tp, _VoidPtr> >\x3a\x3atype\x0a"
"        __node_pointer;\x0a"
"  typedef typename __rebind_pointer<_VoidPtr, __list_node_base<_Tp, _VoidPtr> >\x3a\x3atype\x0a"
"        __base_pointer;\x0a"
"\x0a"
"#if defined(_LIBCPP_ABI_LIST_REMOVE_NODE_POINTER_UB)\x0a"
"  typedef __base_pointer __link_pointer;\x0a"
"#else\x0a"
"  typedef typename conditional<\x0a"
"          is_pointer<_VoidPtr>\x3a\x3avalue,\x0a"
"          __base_pointer,\x0a"
"          __node_pointer\x0a"
"  >\x3a\x3atype __link_pointer;\x0a"
"#endif\x0a"
"\x0a"
"  typedef typename conditional<\x0a"
"          is_same<__link_pointer, __node_pointer>\x3a\x3avalue,\x0a"
"          __base_pointer,\x0a"
"          __node_pointer\x0a"
"  >\x3a\x3atype __non_link_pointer;\x0a"
"\x0a"
"  static _LIBCPP_INLINE_VISIBILITY\x0a"
"  __link_pointer __unsafe_link_pointer_cast(__link_pointer __p) {\x0a"
"      return __p;\x0a"
"  }\x0a"
"\x0a"
"  static _LIBCPP_INLINE_VISIBILITY\x0a"
"  __link_pointer __unsafe_link_pointer_cast(__non_link_pointer __p) {\x0a"
"      return static_cast<__link_pointer>(static_cast<_VoidPtr>(__p));\x0a"
"  }\x0a"
"\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr>\x0a"
"struct __list_node_base\x0a"
"{\x0a"
"    typedef __list_node_pointer_traits<_Tp, _VoidPtr> _NodeTraits;\x0a"
"    typedef typename _NodeTraits\x3a\x3a__node_pointer __node_pointer;\x0a"
"    typedef typename _NodeTraits\x3a\x3a__base_pointer __base_pointer;\x0a"
"    typedef typename _NodeTraits\x3a\x3a__link_pointer __link_pointer;\x0a"
"\x0a"
"    __link_pointer __prev_;\x0a"
"    __link_pointer __next_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_node_base() \x3a __prev_(_NodeTraits\x3a\x3a__unsafe_link_pointer_cast(__self())),\x0a"
"                         __next_(_NodeTraits\x3a\x3a__unsafe_link_pointer_cast(__self())) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __base_pointer __self() {\x0a"
"        return pointer_traits<__base_pointer>\x3a\x3apointer_to(*this);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __node_pointer __as_node() {\x0a"
"        return static_cast<__node_pointer>(__self());\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr>\x0a"
"struct __list_node\x0a"
"    \x3a public __list_node_base<_Tp, _VoidPtr>\x0a"
"{\x0a"
"    _Tp __value_;\x0a"
"\x0a"
"    typedef __list_node_base<_Tp, _VoidPtr> __base;\x0a"
"    typedef typename __base\x3a\x3a__link_pointer __link_pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __link_pointer __as_link() {\x0a"
"        return static_cast<__link_pointer>(__base\x3a\x3a__self());\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Alloc = allocator<_Tp> > class _LIBCPP_TEMPLATE_VIS list;\x0a"
"template <class _Tp, class _Alloc> class __list_imp;\x0a"
"template <class _Tp, class _VoidPtr> class _LIBCPP_TEMPLATE_VIS __list_const_iterator;\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr>\x0a"
"class _LIBCPP_TEMPLATE_VIS __list_iterator\x0a"
"{\x0a"
"    typedef __list_node_pointer_traits<_Tp, _VoidPtr> _NodeTraits;\x0a"
"    typedef typename _NodeTraits\x3a\x3a__link_pointer __link_pointer;\x0a"
"\x0a"
"    __link_pointer __ptr_;\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __list_iterator(__link_pointer __p, const void* __c) _NOEXCEPT\x0a"
"        \x3a __ptr_(__p)\x0a"
"    {\x0a"
"        __get_db()->__insert_ic(this, __c);\x0a"
"    }\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __list_iterator(__link_pointer __p) _NOEXCEPT \x3a __ptr_(__p) {}\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"\x0a"
"    template<class, class> friend class list;\x0a"
"    template<class, class> friend class __list_imp;\x0a"
"    template<class, class> friend class __list_const_iterator;\x0a"
"public\x3a\x0a"
"    typedef bidirectional_iterator_tag       iterator_category;\x0a"
"    typedef _Tp                              value_type;\x0a"
"    typedef value_type\x26                      reference;\x0a"
"    typedef typename __rebind_pointer<_VoidPtr, value_type>\x3a\x3atype pointer;\x0a"
"    typedef typename pointer_traits<pointer>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_iterator() _NOEXCEPT \x3a __ptr_(nullptr)\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __get_db()->__insert_i(this);\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_iterator(const __list_iterator\x26 __p)\x0a"
"        \x3a __ptr_(__p.__ptr_)\x0a"
"    {\x0a"
"        __get_db()->__iterator_copy(this, \x26__p);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e__list_iterator()\x0a"
"    {\x0a"
"        __get_db()->__erase_i(this);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_iterator\x26 operator=(const __list_iterator\x26 __p)\x0a"
"    {\x0a"
"        if (this \x21= \x26__p)\x0a"
"        {\x0a"
"            __get_db()->__iterator_copy(this, \x26__p);\x0a"
"            __ptr_ = __p.__ptr_;\x0a"
"        }\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator*() const\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__dereferenceable(this),\x0a"
"                       \x22""Attempted to dereference a non-dereferenceable list\x3a\x3aiterator\x22);\x0a"
"#endif\x0a"
"        return __ptr_->__as_node()->__value_;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__dereferenceable(this),\x0a"
"                       \x22""Attempted to dereference a non-dereferenceable list\x3a\x3aiterator\x22);\x0a"
"#endif\x0a"
"        return pointer_traits<pointer>\x3a\x3apointer_to(__ptr_->__as_node()->__value_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_iterator\x26 operator++()\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__dereferenceable(this),\x0a"
"                       \x22""Attempted to increment non-incrementable list\x3a\x3aiterator\x22);\x0a"
"#endif\x0a"
"        __ptr_ = __ptr_->__next_;\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_iterator operator++(int) {__list_iterator __t(*this); ++(*this); return __t;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_iterator\x26 operator--()\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__decrementable(this),\x0a"
"                       \x22""Attempted to decrement non-decrementable list\x3a\x3aiterator\x22);\x0a"
"#endif\x0a"
"        __ptr_ = __ptr_->__prev_;\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_iterator operator--(int) {__list_iterator __t(*this); --(*this); return __t;}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const __list_iterator\x26 __x, const __list_iterator\x26 __y)\x0a"
"    {\x0a"
"        return __x.__ptr_ == __y.__ptr_;\x0a"
"    }\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"     bool operator\x21=(const __list_iterator\x26 __x, const __list_iterator\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _VoidPtr>\x0a"
"class _LIBCPP_TEMPLATE_VIS __list_const_iterator\x0a"
"{\x0a"
"    typedef __list_node_pointer_traits<_Tp, _VoidPtr> _NodeTraits;\x0a"
"    typedef typename _NodeTraits\x3a\x3a__link_pointer __link_pointer;\x0a"
"\x0a"
"    __link_pointer __ptr_;\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __list_const_iterator(__link_pointer __p, const void* __c) _NOEXCEPT\x0a"
"        \x3a __ptr_(__p)\x0a"
"    {\x0a"
"        __get_db()->__insert_ic(this, __c);\x0a"
"    }\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __list_const_iterator(__link_pointer __p) _NOEXCEPT \x3a __ptr_(__p) {}\x0a"
"#endif\x0a"
"\x0a"
"    template<class, class> friend class list;\x0a"
"    template<class, class> friend class __list_imp;\x0a"
"public\x3a\x0a"
"    typedef bidirectional_iterator_tag       iterator_category;\x0a"
"    typedef _Tp                              value_type;\x0a"
"    typedef const value_type\x26                reference;\x0a"
"    typedef typename __rebind_pointer<_VoidPtr, const value_type>\x3a\x3atype pointer;\x0a"
"    typedef typename pointer_traits<pointer>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_const_iterator() _NOEXCEPT \x3a __ptr_(nullptr)\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __get_db()->__insert_i(this);\x0a"
"#endif\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_const_iterator(const __list_iterator<_Tp, _VoidPtr>\x26 __p) _NOEXCEPT\x0a"
"        \x3a __ptr_(__p.__ptr_)\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __get_db()->__iterator_copy(this, \x26__p);\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_const_iterator(const __list_const_iterator\x26 __p)\x0a"
"        \x3a __ptr_(__p.__ptr_)\x0a"
"    {\x0a"
"        __get_db()->__iterator_copy(this, \x26__p);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e__list_const_iterator()\x0a"
"    {\x0a"
"        __get_db()->__erase_i(this);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_const_iterator\x26 operator=(const __list_const_iterator\x26 __p)\x0a"
"    {\x0a"
"        if (this \x21= \x26__p)\x0a"
"        {\x0a"
"            __get_db()->__iterator_copy(this, \x26__p);\x0a"
"            __ptr_ = __p.__ptr_;\x0a"
"        }\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator*() const\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__dereferenceable(this),\x0a"
"                       \x22""Attempted to dereference a non-dereferenceable list\x3a\x3a""const_iterator\x22);\x0a"
"#endif\x0a"
"        return __ptr_->__as_node()->__value_;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__dereferenceable(this),\x0a"
"                       \x22""Attempted to dereference a non-dereferenceable list\x3a\x3a""const_iterator\x22);\x0a"
"#endif\x0a"
"        return pointer_traits<pointer>\x3a\x3apointer_to(__ptr_->__as_node()->__value_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_const_iterator\x26 operator++()\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__dereferenceable(this),\x0a"
"                       \x22""Attempted to increment non-incrementable list\x3a\x3a""const_iterator\x22);\x0a"
"#endif\x0a"
"        __ptr_ = __ptr_->__next_;\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_const_iterator operator++(int) {__list_const_iterator __t(*this); ++(*this); return __t;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_const_iterator\x26 operator--()\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__decrementable(this),\x0a"
"                       \x22""Attempted to decrement non-decrementable list\x3a\x3a""const_iterator\x22);\x0a"
"#endif\x0a"
"        __ptr_ = __ptr_->__prev_;\x0a"
"        return *this;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_const_iterator operator--(int) {__list_const_iterator __t(*this); --(*this); return __t;}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const __list_const_iterator\x26 __x, const __list_const_iterator\x26 __y)\x0a"
"    {\x0a"
"        return __x.__ptr_ == __y.__ptr_;\x0a"
"    }\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const __list_const_iterator\x26 __x, const __list_const_iterator\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"class __list_imp\x0a"
"{\x0a"
"    __list_imp(const __list_imp\x26);\x0a"
"    __list_imp\x26 operator=(const __list_imp\x26);\x0a"
"public\x3a\x0a"
"    typedef _Alloc                                                  allocator_type;\x0a"
"    typedef allocator_traits<allocator_type>                        __alloc_traits;\x0a"
"    typedef typename __alloc_traits\x3a\x3asize_type                      size_type;\x0a"
"protected\x3a\x0a"
"    typedef _Tp                                                     value_type;\x0a"
"    typedef typename __alloc_traits\x3a\x3avoid_pointer                   __void_pointer;\x0a"
"    typedef __list_iterator<value_type, __void_pointer>             iterator;\x0a"
"    typedef __list_const_iterator<value_type, __void_pointer>       const_iterator;\x0a"
"    typedef __list_node_base<value_type, __void_pointer>            __node_base;\x0a"
"    typedef __list_node<value_type, __void_pointer>                 __node;\x0a"
"    typedef typename __rebind_alloc_helper<__alloc_traits, __node>\x3a\x3atype __node_allocator;\x0a"
"    typedef allocator_traits<__node_allocator>                       __node_alloc_traits;\x0a"
"    typedef typename __node_alloc_traits\x3a\x3apointer                    __node_pointer;\x0a"
"    typedef typename __node_alloc_traits\x3a\x3apointer                    __node_const_pointer;\x0a"
"    typedef __list_node_pointer_traits<value_type, __void_pointer> __node_pointer_traits;\x0a"
"    typedef typename __node_pointer_traits\x3a\x3a__link_pointer __link_pointer;\x0a"
"    typedef __link_pointer __link_const_pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer                         pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer                   const_pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""difference_type                 difference_type;\x0a"
"\x0a"
"    typedef typename __rebind_alloc_helper<__alloc_traits, __node_base>\x3a\x3atype __node_base_allocator;\x0a"
"    typedef typename allocator_traits<__node_base_allocator>\x3a\x3apointer __node_base_pointer;\x0a"
"    static_assert((\x21is_same<allocator_type, __node_allocator>\x3a\x3avalue),\x0a"
"                  \x22internal allocator type must differ from user-specified \x22\x0a"
"                  \x22type; otherwise overload resolution breaks\x22);\x0a"
"\x0a"
"    __node_base __end_;\x0a"
"    __compressed_pair<size_type, __node_allocator> __size_alloc_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __link_pointer __end_as_link() const _NOEXCEPT {\x0a"
"        return __node_pointer_traits\x3a\x3a__unsafe_link_pointer_cast(\x0a"
"                const_cast<__node_base\x26>(__end_).__self());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          size_type\x26 __sz() _NOEXCEPT {return __size_alloc_.first();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const size_type\x26 __sz() const _NOEXCEPT\x0a"
"        {return __size_alloc_.first();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          __node_allocator\x26 __node_alloc() _NOEXCEPT\x0a"
"          {return __size_alloc_.second();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const __node_allocator\x26 __node_alloc() const _NOEXCEPT\x0a"
"        {return __size_alloc_.second();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type __node_alloc_max_size() const _NOEXCEPT {\x0a"
"        return __node_alloc_traits\x3a\x3amax_size(__node_alloc());\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void __unlink_nodes(__link_pointer __f, __link_pointer __l) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_imp()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<__node_allocator>\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_imp(const allocator_type\x26 __a);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __list_imp(const __node_allocator\x26 __a);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    __list_imp(__node_allocator\x26\x26 __a) _NOEXCEPT;\x0a"
"#endif\x0a"
"    \x7e__list_imp();\x0a"
"    void clear() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT {return __sz() == 0;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator begin() _NOEXCEPT\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        return iterator(__end_.__next_, this);\x0a"
"#else\x0a"
"        return iterator(__end_.__next_);\x0a"
"#endif\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const  _NOEXCEPT\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        return const_iterator(__end_.__next_, this);\x0a"
"#else\x0a"
"        return const_iterator(__end_.__next_);\x0a"
"#endif\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator end() _NOEXCEPT\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        return iterator(__end_as_link(), this);\x0a"
"#else\x0a"
"        return iterator(__end_as_link());\x0a"
"#endif\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end() const _NOEXCEPT\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        return const_iterator(__end_as_link(), this);\x0a"
"#else\x0a"
"        return const_iterator(__end_as_link());\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    void swap(__list_imp\x26 __c)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT;\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<allocator_type>\x3a\x3avalue);\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __list_imp\x26 __c)\x0a"
"        {__copy_assign_alloc(__c, integral_constant<bool,\x0a"
"                      __node_alloc_traits\x3a\x3apropagate_on_container_copy_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__list_imp\x26 __c)\x0a"
"        _NOEXCEPT_(\x0a"
"            \x21__node_alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"            is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue)\x0a"
"        {__move_assign_alloc(__c, integral_constant<bool,\x0a"
"                      __node_alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __list_imp\x26 __c, true_type)\x0a"
"        {\x0a"
"            if (__node_alloc() \x21= __c.__node_alloc())\x0a"
"                clear();\x0a"
"            __node_alloc() = __c.__node_alloc();\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __list_imp\x26, false_type)\x0a"
"        {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__list_imp\x26 __c, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue)\x0a"
"        {\x0a"
"            __node_alloc() = _VSTD\x3a\x3amove(__c.__node_alloc());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__list_imp\x26, false_type)\x0a"
"        _NOEXCEPT\x0a"
"        {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __invalidate_all_iterators() {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"      __get_db()->__invalidate_all(this);\x0a"
"#endif\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"// Unlink nodes \x5b__f, __l\x5d\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"void\x0a"
"__list_imp<_Tp, _Alloc>\x3a\x3a__unlink_nodes(__link_pointer __f, __link_pointer __l)\x0a"
"    _NOEXCEPT\x0a"
"{\x0a"
"    __f->__prev_->__next_ = __l->__next_;\x0a"
"    __l->__next_->__prev_ = __f->__prev_;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"__list_imp<_Tp, _Alloc>\x3a\x3a__list_imp()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<__node_allocator>\x3a\x3avalue)\x0a"
"    \x3a __size_alloc_(0)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"__list_imp<_Tp, _Alloc>\x3a\x3a__list_imp(const allocator_type\x26 __a)\x0a"
"    \x3a __size_alloc_(0, __node_allocator(__a))\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline __list_imp<_Tp, _Alloc>\x3a\x3a__list_imp(const __node_allocator\x26 __a)\x0a"
"    \x3a __size_alloc_(0, __a) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline __list_imp<_Tp, _Alloc>\x3a\x3a__list_imp(__node_allocator\x26\x26 __a) _NOEXCEPT\x0a"
"    \x3a __size_alloc_(0, std\x3a\x3amove(__a)) {}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"__list_imp<_Tp, _Alloc>\x3a\x3a\x7e__list_imp() {\x0a"
"  clear();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__erase_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"__list_imp<_Tp, _Alloc>\x3a\x3a""clear() _NOEXCEPT\x0a"
"{\x0a"
"    if (\x21""empty())\x0a"
"    {\x0a"
"        __node_allocator\x26 __na = __node_alloc();\x0a"
"        __link_pointer __f = __end_.__next_;\x0a"
"        __link_pointer __l = __end_as_link();\x0a"
"        __unlink_nodes(__f, __l->__prev_);\x0a"
"        __sz() = 0;\x0a"
"        while (__f \x21= __l)\x0a"
"        {\x0a"
"            __node_pointer __np = __f->__as_node();\x0a"
"            __f = __f->__next_;\x0a"
"            __node_alloc_traits\x3a\x3a""destroy(__na, _VSTD\x3a\x3a""addressof(__np->__value_));\x0a"
"            __node_alloc_traits\x3a\x3a""deallocate(__na, __np, 1);\x0a"
"        }\x0a"
"        __invalidate_all_iterators();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"__list_imp<_Tp, _Alloc>\x3a\x3aswap(__list_imp\x26 __c)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<allocator_type>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                   this->__node_alloc() == __c.__node_alloc(),\x0a"
"                   \x22list\x3a\x3aswap\x3a Either propagate_on_container_swap must be true\x22\x0a"
"                   \x22 or the allocators must compare equal\x22);\x0a"
"    using _VSTD\x3a\x3aswap;\x0a"
"    __swap_allocator(__node_alloc(), __c.__node_alloc());\x0a"
"    swap(__sz(), __c.__sz());\x0a"
"    swap(__end_, __c.__end_);\x0a"
"    if (__sz() == 0)\x0a"
"        __end_.__next_ = __end_.__prev_ = __end_as_link();\x0a"
"    else\x0a"
"        __end_.__prev_->__next_ = __end_.__next_->__prev_ = __end_as_link();\x0a"
"    if (__c.__sz() == 0)\x0a"
"        __c.__end_.__next_ = __c.__end_.__prev_ = __c.__end_as_link();\x0a"
"    else\x0a"
"        __c.__end_.__prev_->__next_ = __c.__end_.__next_->__prev_ = __c.__end_as_link();\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __libcpp_db* __db = __get_db();\x0a"
"    __c_node* __cn1 = __db->__find_c_and_lock(this);\x0a"
"    __c_node* __cn2 = __db->__find_c(\x26__c);\x0a"
"    std\x3a\x3aswap(__cn1->beg_, __cn2->beg_);\x0a"
"    std\x3a\x3aswap(__cn1->end_, __cn2->end_);\x0a"
"    std\x3a\x3aswap(__cn1->cap_, __cn2->cap_);\x0a"
"    for (__i_node** __p = __cn1->end_; __p \x21= __cn1->beg_;)\x0a"
"    {\x0a"
"        --__p;\x0a"
"        const_iterator* __i = static_cast<const_iterator*>((*__p)->__i_);\x0a"
"        if (__i->__ptr_ == __c.__end_as_link())\x0a"
"        {\x0a"
"            __cn2->__add(*__p);\x0a"
"            if (--__cn1->end_ \x21= __p)\x0a"
"                memmove(__p, __p+1, (__cn1->end_ - __p)*sizeof(__i_node*));\x0a"
"        }\x0a"
"        else\x0a"
"            (*__p)->__c_ = __cn1;\x0a"
"    }\x0a"
"    for (__i_node** __p = __cn2->end_; __p \x21= __cn2->beg_;)\x0a"
"    {\x0a"
"        --__p;\x0a"
"        const_iterator* __i = static_cast<const_iterator*>((*__p)->__i_);\x0a"
"        if (__i->__ptr_ == __end_as_link())\x0a"
"        {\x0a"
"            __cn1->__add(*__p);\x0a"
"            if (--__cn2->end_ \x21= __p)\x0a"
"                memmove(__p, __p+1, (__cn2->end_ - __p)*sizeof(__i_node*));\x0a"
"        }\x0a"
"        else\x0a"
"            (*__p)->__c_ = __cn2;\x0a"
"    }\x0a"
"    __db->unlock();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc /*= allocator<_Tp>*/>\x0a"
"class _LIBCPP_TEMPLATE_VIS list\x0a"
"    \x3a private __list_imp<_Tp, _Alloc>\x0a"
"{\x0a"
"    typedef __list_imp<_Tp, _Alloc> base;\x0a"
"    typedef typename base\x3a\x3a__node              __node;\x0a"
"    typedef typename base\x3a\x3a__node_allocator    __node_allocator;\x0a"
"    typedef typename base\x3a\x3a__node_pointer      __node_pointer;\x0a"
"    typedef typename base\x3a\x3a__node_alloc_traits __node_alloc_traits;\x0a"
"    typedef typename base\x3a\x3a__node_base         __node_base;\x0a"
"    typedef typename base\x3a\x3a__node_base_pointer __node_base_pointer;\x0a"
"    typedef typename base\x3a\x3a__link_pointer __link_pointer;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _Tp                                      value_type;\x0a"
"    typedef _Alloc                                   allocator_type;\x0a"
"    static_assert((is_same<value_type, typename allocator_type\x3a\x3avalue_type>\x3a\x3avalue),\x0a"
"                  \x22Invalid allocator\x3a\x3avalue_type\x22);\x0a"
"    typedef value_type\x26                              reference;\x0a"
"    typedef const value_type\x26                        const_reference;\x0a"
"    typedef typename base\x3a\x3apointer                   pointer;\x0a"
"    typedef typename base\x3a\x3a""const_pointer             const_pointer;\x0a"
"    typedef typename base\x3a\x3asize_type                 size_type;\x0a"
"    typedef typename base\x3a\x3a""difference_type           difference_type;\x0a"
"    typedef typename base\x3a\x3aiterator                  iterator;\x0a"
"    typedef typename base\x3a\x3a""const_iterator            const_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<iterator>         reverse_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<const_iterator>   const_reverse_iterator;\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"    typedef size_type                                __remove_return_type;\x0a"
"#else\x0a"
"    typedef void                                     __remove_return_type;\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    list()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<__node_allocator>\x3a\x3avalue)\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit list(const allocator_type\x26 __a) \x3a base(__a)\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    }\x0a"
"    explicit list(size_type __n);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    explicit list(size_type __n, const allocator_type\x26 __a);\x0a"
"#endif\x0a"
"    list(size_type __n, const value_type\x26 __x);\x0a"
"    list(size_type __n, const value_type\x26 __x, const allocator_type\x26 __a);\x0a"
"    template <class _InpIter>\x0a"
"        list(_InpIter __f, _InpIter __l,\x0a"
"             typename enable_if<__is_input_iterator<_InpIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _InpIter>\x0a"
"        list(_InpIter __f, _InpIter __l, const allocator_type\x26 __a,\x0a"
"             typename enable_if<__is_input_iterator<_InpIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"\x0a"
"    list(const list\x26 __c);\x0a"
"    list(const list\x26 __c, const allocator_type\x26 __a);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    list\x26 operator=(const list\x26 __c);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    list(initializer_list<value_type> __il);\x0a"
"    list(initializer_list<value_type> __il, const allocator_type\x26 __a);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    list(list\x26\x26 __c)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__node_allocator>\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    list(list\x26\x26 __c, const allocator_type\x26 __a);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    list\x26 operator=(list\x26\x26 __c)\x0a"
"        _NOEXCEPT_(\x0a"
"            __node_alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    list\x26 operator=(initializer_list<value_type> __il)\x0a"
"        {assign(__il.begin(), __il.end()); return *this;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void assign(initializer_list<value_type> __il)\x0a"
"        {assign(__il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template <class _InpIter>\x0a"
"        void assign(_InpIter __f, _InpIter __l,\x0a"
"             typename enable_if<__is_input_iterator<_InpIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    void assign(size_type __n, const value_type\x26 __x);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT     {return base\x3a\x3a__sz();}\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT         {return base\x3a\x3a""empty();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT\x0a"
"        {\x0a"
"            return std\x3a\x3amin<size_type>(\x0a"
"                base\x3a\x3a__node_alloc_max_size(),\x0a"
"                numeric_limits<difference_type >\x3a\x3amax());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator begin() _NOEXCEPT        {return base\x3a\x3a""begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin()  const _NOEXCEPT {return base\x3a\x3a""begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator end() _NOEXCEPT          {return base\x3a\x3a""end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()    const _NOEXCEPT {return base\x3a\x3a""end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const _NOEXCEPT {return base\x3a\x3a""begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend()   const _NOEXCEPT {return base\x3a\x3a""end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          reverse_iterator rbegin() _NOEXCEPT\x0a"
"            {return       reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin()  const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          reverse_iterator rend() _NOEXCEPT\x0a"
"            {return       reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend()    const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend()   const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference front()\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21""empty(), \x22list\x3a\x3a""front called on empty list\x22);\x0a"
"        return base\x3a\x3a__end_.__next_->__as_node()->__value_;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference front() const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21""empty(), \x22list\x3a\x3a""front called on empty list\x22);\x0a"
"        return base\x3a\x3a__end_.__next_->__as_node()->__value_;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference back()\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21""empty(), \x22list\x3a\x3a""back called on empty list\x22);\x0a"
"        return base\x3a\x3a__end_.__prev_->__as_node()->__value_;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference back() const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21""empty(), \x22list\x3a\x3a""back called on empty list\x22);\x0a"
"        return base\x3a\x3a__end_.__prev_->__as_node()->__value_;\x0a"
"    }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    void push_front(value_type\x26\x26 __x);\x0a"
"    void push_back(value_type\x26\x26 __x);\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"       reference emplace_front(_Args\x26\x26... __args);\x0a"
"#else\x0a"
"       void      emplace_front(_Args\x26\x26... __args);\x0a"
"#endif\x0a"
"    template <class... _Args>\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        reference emplace_back(_Args\x26\x26... __args);\x0a"
"#else\x0a"
"       void       emplace_back(_Args\x26\x26... __args);\x0a"
"#endif\x0a"
"    template <class... _Args>\x0a"
"        iterator emplace(const_iterator __p, _Args\x26\x26... __args);\x0a"
"\x0a"
"    iterator insert(const_iterator __p, value_type\x26\x26 __x);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, initializer_list<value_type> __il)\x0a"
"        {return insert(__p, __il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    void push_front(const value_type\x26 __x);\x0a"
"    void push_back(const value_type\x26 __x);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Arg>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __emplace_back(_Arg\x26\x26 __arg) { emplace_back(_VSTD\x3a\x3a""forward<_Arg>(__arg)); }\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __emplace_back(value_type const\x26 __arg) { push_back(__arg); }\x0a"
"#endif\x0a"
"\x0a"
"    iterator insert(const_iterator __p, const value_type\x26 __x);\x0a"
"    iterator insert(const_iterator __p, size_type __n, const value_type\x26 __x);\x0a"
"    template <class _InpIter>\x0a"
"        iterator insert(const_iterator __p, _InpIter __f, _InpIter __l,\x0a"
"             typename enable_if<__is_input_iterator<_InpIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(list\x26 __c)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__node_alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                   __is_nothrow_swappable<__node_allocator>\x3a\x3avalue)\x0a"
"#endif\x0a"
"        {base\x3a\x3aswap(__c);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {base\x3a\x3a""clear();}\x0a"
"\x0a"
"    void pop_front();\x0a"
"    void pop_back();\x0a"
"\x0a"
"    iterator erase(const_iterator __p);\x0a"
"    iterator erase(const_iterator __f, const_iterator __l);\x0a"
"\x0a"
"    void resize(size_type __n);\x0a"
"    void resize(size_type __n, const value_type\x26 __x);\x0a"
"\x0a"
"    void splice(const_iterator __p, list\x26 __c);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void splice(const_iterator __p, list\x26\x26 __c) {splice(__p, __c);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void splice(const_iterator __p, list\x26\x26 __c, const_iterator __i)\x0a"
"        {splice(__p, __c, __i);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void splice(const_iterator __p, list\x26\x26 __c, const_iterator __f, const_iterator __l)\x0a"
"        {splice(__p, __c, __f, __l);}\x0a"
"#endif\x0a"
"    void splice(const_iterator __p, list\x26 __c, const_iterator __i);\x0a"
"    void splice(const_iterator __p, list\x26 __c, const_iterator __f, const_iterator __l);\x0a"
"\x0a"
"    __remove_return_type remove(const value_type\x26 __x);\x0a"
"    template <class _Pred> __remove_return_type remove_if(_Pred __pred);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __remove_return_type unique() { return unique(__equal_to<value_type>()); }\x0a"
"    template <class _BinaryPred>\x0a"
"        __remove_return_type unique(_BinaryPred __binary_pred);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(list\x26 __c);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(list\x26\x26 __c) {merge(__c);}\x0a"
"\x0a"
"    template <class _Comp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        void merge(list\x26\x26 __c, _Comp __comp) {merge(__c, __comp);}\x0a"
"#endif\x0a"
"    template <class _Comp>\x0a"
"        void merge(list\x26 __c, _Comp __comp);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void sort();\x0a"
"    template <class _Comp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void sort(_Comp __comp);\x0a"
"\x0a"
"    void reverse() _NOEXCEPT;\x0a"
"\x0a"
"    bool __invariants() const;\x0a"
"\x0a"
"    typedef __allocator_destructor<__node_allocator> __node_destructor;\x0a"
"    typedef unique_ptr<__node, __node_destructor> __hold_pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hold_pointer __allocate_node(__node_allocator\x26 __na) {\x0a"
"      __node_pointer __p = __node_alloc_traits\x3a\x3a""allocate(__na, 1);\x0a"
"      __p->__prev_ = nullptr;\x0a"
"      return __hold_pointer(__p, __node_destructor(__na, 1));\x0a"
"    }\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"    bool __dereferenceable(const const_iterator* __i) const;\x0a"
"    bool __decrementable(const const_iterator* __i) const;\x0a"
"    bool __addable(const const_iterator* __i, ptrdiff_t __n) const;\x0a"
"    bool __subscriptable(const const_iterator* __i, ptrdiff_t __n) const;\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void __link_nodes  (__link_pointer __p, __link_pointer __f, __link_pointer __l);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __link_nodes_at_front(__link_pointer __f, __link_pointer __l);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __link_nodes_at_back (__link_pointer __f, __link_pointer __l);\x0a"
"    iterator __iterator(size_type __n);\x0a"
"    template <class _Comp>\x0a"
"        static iterator __sort(iterator __f1, iterator __e2, size_type __n, _Comp\x26 __comp);\x0a"
"\x0a"
"    void __move_assign(list\x26 __c, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue);\x0a"
"    void __move_assign(list\x26 __c, false_type);\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _Alloc = typename std\x3a\x3a""allocator<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>,\x0a"
"         class = typename enable_if<__is_allocator<_Alloc>\x3a\x3avalue, void>\x3a\x3atype\x0a"
"         >\x0a"
"list(_InputIterator, _InputIterator)\x0a"
"  -> list<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Alloc>;\x0a"
"\x0a"
"template<class _InputIterator,\x0a"
"         class _Alloc,\x0a"
"         class = typename enable_if<__is_allocator<_Alloc>\x3a\x3avalue, void>\x3a\x3atype\x0a"
"         >\x0a"
"list(_InputIterator, _InputIterator, _Alloc)\x0a"
"  -> list<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Alloc>;\x0a"
"#endif\x0a"
"\x0a"
"// Link in nodes \x5b__f, __l\x5d just prior to __p\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3a__link_nodes(__link_pointer __p, __link_pointer __f, __link_pointer __l)\x0a"
"{\x0a"
"    __p->__prev_->__next_ = __f;\x0a"
"    __f->__prev_ = __p->__prev_;\x0a"
"    __p->__prev_ = __l;\x0a"
"    __l->__next_ = __p;\x0a"
"}\x0a"
"\x0a"
"// Link in nodes \x5b__f, __l\x5d at the front of the list\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3a__link_nodes_at_front(__link_pointer __f, __link_pointer __l)\x0a"
"{\x0a"
"    __f->__prev_ = base\x3a\x3a__end_as_link();\x0a"
"    __l->__next_ = base\x3a\x3a__end_.__next_;\x0a"
"    __l->__next_->__prev_ = __l;\x0a"
"    base\x3a\x3a__end_.__next_ = __f;\x0a"
"}\x0a"
"\x0a"
"// Link in nodes \x5b__f, __l\x5d at the back of the list\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3a__link_nodes_at_back(__link_pointer __f, __link_pointer __l)\x0a"
"{\x0a"
"    __l->__next_ = base\x3a\x3a__end_as_link();\x0a"
"    __f->__prev_ = base\x3a\x3a__end_.__prev_;\x0a"
"    __f->__prev_->__next_ = __f;\x0a"
"    base\x3a\x3a__end_.__prev_ = __l;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"typename list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"list<_Tp, _Alloc>\x3a\x3a__iterator(size_type __n)\x0a"
"{\x0a"
"    return __n <= base\x3a\x3a__sz() / 2 \x3f _VSTD\x3a\x3anext(begin(), __n)\x0a"
"                                   \x3a _VSTD\x3a\x3aprev(end(), base\x3a\x3a__sz() - __n);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(size_type __n)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (; __n > 0; --__n)\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"        emplace_back();\x0a"
"#else\x0a"
"        push_back(value_type());\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp, class _Alloc>\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(size_type __n, const allocator_type\x26 __a) \x3a base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (; __n > 0; --__n)\x0a"
"        emplace_back();\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(size_type __n, const value_type\x26 __x)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (; __n > 0; --__n)\x0a"
"        push_back(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(size_type __n, const value_type\x26 __x, const allocator_type\x26 __a)\x0a"
"    \x3a base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (; __n > 0; --__n)\x0a"
"        push_back(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _InpIter>\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(_InpIter __f, _InpIter __l,\x0a"
"                        typename enable_if<__is_input_iterator<_InpIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (; __f \x21= __l; ++__f)\x0a"
"        __emplace_back(*__f);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _InpIter>\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(_InpIter __f, _InpIter __l, const allocator_type\x26 __a,\x0a"
"                        typename enable_if<__is_input_iterator<_InpIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (; __f \x21= __l; ++__f)\x0a"
"        __emplace_back(*__f);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(const list\x26 __c)\x0a"
"    \x3a base(__node_alloc_traits\x3a\x3aselect_on_container_copy_construction(\x0a"
"          __c.__node_alloc())) {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (const_iterator __i = __c.begin(), __e = __c.end(); __i \x21= __e; ++__i)\x0a"
"        push_back(*__i);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(const list\x26 __c, const allocator_type\x26 __a)\x0a"
"    \x3a base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (const_iterator __i = __c.begin(), __e = __c.end(); __i \x21= __e; ++__i)\x0a"
"        push_back(*__i);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(initializer_list<value_type> __il, const allocator_type\x26 __a)\x0a"
"    \x3a base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (typename initializer_list<value_type>\x3a\x3a""const_iterator __i = __il.begin(),\x0a"
"            __e = __il.end(); __i \x21= __e; ++__i)\x0a"
"        push_back(*__i);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(initializer_list<value_type> __il)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (typename initializer_list<value_type>\x3a\x3a""const_iterator __i = __il.begin(),\x0a"
"            __e = __il.end(); __i \x21= __e; ++__i)\x0a"
"        push_back(*__i);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline list<_Tp, _Alloc>\x3a\x3alist(list\x26\x26 __c)\x0a"
"    _NOEXCEPT_(is_nothrow_move_constructible<__node_allocator>\x3a\x3avalue)\x0a"
"    \x3a base(_VSTD\x3a\x3amove(__c.__node_alloc())) {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    splice(end(), __c);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"list<_Tp, _Alloc>\x3a\x3alist(list\x26\x26 __c, const allocator_type\x26 __a)\x0a"
"    \x3a base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__a == __c.get_allocator())\x0a"
"        splice(end(), __c);\x0a"
"    else\x0a"
"    {\x0a"
"        typedef move_iterator<iterator> _Ip;\x0a"
"        assign(_Ip(__c.begin()), _Ip(__c.end()));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"list<_Tp, _Alloc>\x26\x0a"
"list<_Tp, _Alloc>\x3a\x3aoperator=(list\x26\x26 __c)\x0a"
"        _NOEXCEPT_(\x0a"
"            __node_alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue)\x0a"
"{\x0a"
"    __move_assign(__c, integral_constant<bool,\x0a"
"          __node_alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3a__move_assign(list\x26 __c, false_type)\x0a"
"{\x0a"
"    if (base\x3a\x3a__node_alloc() \x21= __c.__node_alloc())\x0a"
"    {\x0a"
"        typedef move_iterator<iterator> _Ip;\x0a"
"        assign(_Ip(__c.begin()), _Ip(__c.end()));\x0a"
"    }\x0a"
"    else\x0a"
"        __move_assign(__c, true_type());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3a__move_assign(list\x26 __c, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__node_allocator>\x3a\x3avalue)\x0a"
"{\x0a"
"    clear();\x0a"
"    base\x3a\x3a__move_assign_alloc(__c);\x0a"
"    splice(end(), __c);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"list<_Tp, _Alloc>\x26\x0a"
"list<_Tp, _Alloc>\x3a\x3aoperator=(const list\x26 __c)\x0a"
"{\x0a"
"    if (this \x21= \x26__c)\x0a"
"    {\x0a"
"        base\x3a\x3a__copy_assign_alloc(__c);\x0a"
"        assign(__c.begin(), __c.end());\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _InpIter>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3a""assign(_InpIter __f, _InpIter __l,\x0a"
"                          typename enable_if<__is_input_iterator<_InpIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    iterator __i = begin();\x0a"
"    iterator __e = end();\x0a"
"    for (; __f \x21= __l \x26\x26 __i \x21= __e; ++__f, ++__i)\x0a"
"        *__i = *__f;\x0a"
"    if (__i == __e)\x0a"
"        insert(__e, __f, __l);\x0a"
"    else\x0a"
"        erase(__i, __e);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"      __get_db()->__invalidate_all(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3a""assign(size_type __n, const value_type\x26 __x)\x0a"
"{\x0a"
"    iterator __i = begin();\x0a"
"    iterator __e = end();\x0a"
"    for (; __n > 0 \x26\x26 __i \x21= __e; --__n, ++__i)\x0a"
"        *__i = __x;\x0a"
"    if (__i == __e)\x0a"
"        insert(__e, __n, __x);\x0a"
"    else\x0a"
"        erase(__i, __e);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"      __get_db()->__invalidate_all(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"_Alloc\x0a"
"list<_Tp, _Alloc>\x3a\x3aget_allocator() const _NOEXCEPT\x0a"
"{\x0a"
"    return allocator_type(base\x3a\x3a__node_alloc());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"list<_Tp, _Alloc>\x3a\x3ainsert(const_iterator __p, const value_type\x26 __x)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"        \x22list\x3a\x3ainsert(iterator, x) called with an iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"#endif\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __hold_pointer __hold = __allocate_node(__na);\x0a"
"    __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), __x);\x0a"
"    __link_nodes(__p.__ptr_, __hold->__as_link(), __hold->__as_link());\x0a"
"    ++base\x3a\x3a__sz();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    return iterator(__hold.release()->__as_link(), this);\x0a"
"#else\x0a"
"    return iterator(__hold.release()->__as_link());\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"list<_Tp, _Alloc>\x3a\x3ainsert(const_iterator __p, size_type __n, const value_type\x26 __x)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"        \x22list\x3a\x3ainsert(iterator, n, x) called with an iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"    iterator __r(__p.__ptr_, this);\x0a"
"#else\x0a"
"    iterator __r(__p.__ptr_);\x0a"
"#endif\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        size_type __ds = 0;\x0a"
"        __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"        __hold_pointer __hold = __allocate_node(__na);\x0a"
"        __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), __x);\x0a"
"        ++__ds;\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __r = iterator(__hold->__as_link(), this);\x0a"
"#else\x0a"
"        __r = iterator(__hold->__as_link());\x0a"
"#endif\x0a"
"        __hold.release();\x0a"
"        iterator __e = __r;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (--__n; __n \x21= 0; --__n, ++__e, ++__ds)\x0a"
"            {\x0a"
"                __hold.reset(__node_alloc_traits\x3a\x3a""allocate(__na, 1));\x0a"
"                __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), __x);\x0a"
"                __e.__ptr_->__next_ = __hold->__as_link();\x0a"
"                __hold->__prev_ = __e.__ptr_;\x0a"
"                __hold.release();\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            while (true)\x0a"
"            {\x0a"
"                __node_alloc_traits\x3a\x3a""destroy(__na, _VSTD\x3a\x3a""addressof(*__e));\x0a"
"                __link_pointer __prev = __e.__ptr_->__prev_;\x0a"
"                __node_alloc_traits\x3a\x3a""deallocate(__na, __e.__ptr_->__as_node(), 1);\x0a"
"                if (__prev == 0)\x0a"
"                    break;\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"                __e = iterator(__prev, this);\x0a"
"#else\x0a"
"                __e = iterator(__prev);\x0a"
"#endif\x0a"
"            }\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __link_nodes(__p.__ptr_, __r.__ptr_, __e.__ptr_);\x0a"
"        base\x3a\x3a__sz() += __ds;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _InpIter>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"list<_Tp, _Alloc>\x3a\x3ainsert(const_iterator __p, _InpIter __f, _InpIter __l,\x0a"
"             typename enable_if<__is_input_iterator<_InpIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"        \x22list\x3a\x3ainsert(iterator, range) called with an iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"    iterator __r(__p.__ptr_, this);\x0a"
"#else\x0a"
"    iterator __r(__p.__ptr_);\x0a"
"#endif\x0a"
"    if (__f \x21= __l)\x0a"
"    {\x0a"
"        size_type __ds = 0;\x0a"
"        __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"        __hold_pointer __hold = __allocate_node(__na);\x0a"
"        __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), *__f);\x0a"
"        ++__ds;\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __r = iterator(__hold.get()->__as_link(), this);\x0a"
"#else\x0a"
"        __r = iterator(__hold.get()->__as_link());\x0a"
"#endif\x0a"
"        __hold.release();\x0a"
"        iterator __e = __r;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (++__f; __f \x21= __l; ++__f, (void) ++__e, (void) ++__ds)\x0a"
"            {\x0a"
"                __hold.reset(__node_alloc_traits\x3a\x3a""allocate(__na, 1));\x0a"
"                __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), *__f);\x0a"
"                __e.__ptr_->__next_ = __hold.get()->__as_link();\x0a"
"                __hold->__prev_ = __e.__ptr_;\x0a"
"                __hold.release();\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            while (true)\x0a"
"            {\x0a"
"                __node_alloc_traits\x3a\x3a""destroy(__na, _VSTD\x3a\x3a""addressof(*__e));\x0a"
"                __link_pointer __prev = __e.__ptr_->__prev_;\x0a"
"                __node_alloc_traits\x3a\x3a""deallocate(__na, __e.__ptr_->__as_node(), 1);\x0a"
"                if (__prev == 0)\x0a"
"                    break;\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"                __e = iterator(__prev, this);\x0a"
"#else\x0a"
"                __e = iterator(__prev);\x0a"
"#endif\x0a"
"            }\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __link_nodes(__p.__ptr_, __r.__ptr_, __e.__ptr_);\x0a"
"        base\x3a\x3a__sz() += __ds;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3apush_front(const value_type\x26 __x)\x0a"
"{\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __hold_pointer __hold = __allocate_node(__na);\x0a"
"    __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), __x);\x0a"
"    __link_pointer __nl = __hold->__as_link();\x0a"
"    __link_nodes_at_front(__nl, __nl);\x0a"
"    ++base\x3a\x3a__sz();\x0a"
"    __hold.release();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3apush_back(const value_type\x26 __x)\x0a"
"{\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __hold_pointer __hold = __allocate_node(__na);\x0a"
"    __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), __x);\x0a"
"    __link_nodes_at_back(__hold.get()->__as_link(), __hold.get()->__as_link());\x0a"
"    ++base\x3a\x3a__sz();\x0a"
"    __hold.release();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3apush_front(value_type\x26\x26 __x)\x0a"
"{\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __hold_pointer __hold = __allocate_node(__na);\x0a"
"    __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), _VSTD\x3a\x3amove(__x));\x0a"
"    __link_nodes_at_front(__hold.get()->__as_link(), __hold.get()->__as_link());\x0a"
"    ++base\x3a\x3a__sz();\x0a"
"    __hold.release();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3apush_back(value_type\x26\x26 __x)\x0a"
"{\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __hold_pointer __hold = __allocate_node(__na);\x0a"
"    __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), _VSTD\x3a\x3amove(__x));\x0a"
"    __link_nodes_at_back(__hold.get()->__as_link(), __hold.get()->__as_link());\x0a"
"    ++base\x3a\x3a__sz();\x0a"
"    __hold.release();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class... _Args>\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"typename list<_Tp, _Alloc>\x3a\x3areference\x0a"
"#else\x0a"
"void\x0a"
"#endif\x0a"
"list<_Tp, _Alloc>\x3a\x3a""emplace_front(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __hold_pointer __hold = __allocate_node(__na);\x0a"
"    __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __link_nodes_at_front(__hold.get()->__as_link(), __hold.get()->__as_link());\x0a"
"    ++base\x3a\x3a__sz();\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    return __hold.release()->__value_;\x0a"
"#else\x0a"
"    __hold.release();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class... _Args>\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"typename list<_Tp, _Alloc>\x3a\x3areference\x0a"
"#else\x0a"
"void\x0a"
"#endif\x0a"
"list<_Tp, _Alloc>\x3a\x3a""emplace_back(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __hold_pointer __hold = __allocate_node(__na);\x0a"
"    __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __link_pointer __nl = __hold->__as_link();\x0a"
"    __link_nodes_at_back(__nl, __nl);\x0a"
"    ++base\x3a\x3a__sz();\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    return __hold.release()->__value_;\x0a"
"#else\x0a"
"    __hold.release();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class... _Args>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"list<_Tp, _Alloc>\x3a\x3a""emplace(const_iterator __p, _Args\x26\x26... __args)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"        \x22list\x3a\x3a""emplace(iterator, args...) called with an iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"#endif\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __hold_pointer __hold = __allocate_node(__na);\x0a"
"    __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __link_pointer __nl = __hold.get()->__as_link();\x0a"
"    __link_nodes(__p.__ptr_, __nl, __nl);\x0a"
"    ++base\x3a\x3a__sz();\x0a"
"    __hold.release();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    return iterator(__nl, this);\x0a"
"#else\x0a"
"    return iterator(__nl);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"list<_Tp, _Alloc>\x3a\x3ainsert(const_iterator __p, value_type\x26\x26 __x)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"        \x22list\x3a\x3ainsert(iterator, x) called with an iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"#endif\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __hold_pointer __hold = __allocate_node(__na);\x0a"
"    __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), _VSTD\x3a\x3amove(__x));\x0a"
"    __link_pointer __nl = __hold->__as_link();\x0a"
"    __link_nodes(__p.__ptr_, __nl, __nl);\x0a"
"    ++base\x3a\x3a__sz();\x0a"
"    __hold.release();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    return iterator(__nl, this);\x0a"
"#else\x0a"
"    return iterator(__nl);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3apop_front()\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(\x21""empty(), \x22list\x3a\x3apop_front() called with empty list\x22);\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __link_pointer __n = base\x3a\x3a__end_.__next_;\x0a"
"    base\x3a\x3a__unlink_nodes(__n, __n);\x0a"
"    --base\x3a\x3a__sz();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __c_node* __c = __get_db()->__find_c_and_lock(this);\x0a"
"    for (__i_node** __p = __c->end_; __p \x21= __c->beg_; )\x0a"
"    {\x0a"
"        --__p;\x0a"
"        iterator* __i = static_cast<iterator*>((*__p)->__i_);\x0a"
"        if (__i->__ptr_ == __n)\x0a"
"        {\x0a"
"            (*__p)->__c_ = nullptr;\x0a"
"            if (--__c->end_ \x21= __p)\x0a"
"                memmove(__p, __p+1, (__c->end_ - __p)*sizeof(__i_node*));\x0a"
"        }\x0a"
"    }\x0a"
"    __get_db()->unlock();\x0a"
"#endif\x0a"
"    __node_pointer __np = __n->__as_node();\x0a"
"    __node_alloc_traits\x3a\x3a""destroy(__na, _VSTD\x3a\x3a""addressof(__np->__value_));\x0a"
"    __node_alloc_traits\x3a\x3a""deallocate(__na, __np, 1);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3apop_back()\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(\x21""empty(), \x22list\x3a\x3apop_back() called with empty list\x22);\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __link_pointer __n = base\x3a\x3a__end_.__prev_;\x0a"
"    base\x3a\x3a__unlink_nodes(__n, __n);\x0a"
"    --base\x3a\x3a__sz();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __c_node* __c = __get_db()->__find_c_and_lock(this);\x0a"
"    for (__i_node** __p = __c->end_; __p \x21= __c->beg_; )\x0a"
"    {\x0a"
"        --__p;\x0a"
"        iterator* __i = static_cast<iterator*>((*__p)->__i_);\x0a"
"        if (__i->__ptr_ == __n)\x0a"
"        {\x0a"
"            (*__p)->__c_ = nullptr;\x0a"
"            if (--__c->end_ \x21= __p)\x0a"
"                memmove(__p, __p+1, (__c->end_ - __p)*sizeof(__i_node*));\x0a"
"        }\x0a"
"    }\x0a"
"    __get_db()->unlock();\x0a"
"#endif\x0a"
"    __node_pointer __np = __n->__as_node();\x0a"
"    __node_alloc_traits\x3a\x3a""destroy(__na, _VSTD\x3a\x3a""addressof(__np->__value_));\x0a"
"    __node_alloc_traits\x3a\x3a""deallocate(__na, __np, 1);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"list<_Tp, _Alloc>\x3a\x3a""erase(const_iterator __p)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"        \x22list\x3a\x3a""erase(iterator) called with an iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"#endif\x0a"
"    _LIBCPP_ASSERT(__p \x21= end(),\x0a"
"        \x22list\x3a\x3a""erase(iterator) called with a non-dereferenceable iterator\x22);\x0a"
"    __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"    __link_pointer __n = __p.__ptr_;\x0a"
"    __link_pointer __r = __n->__next_;\x0a"
"    base\x3a\x3a__unlink_nodes(__n, __n);\x0a"
"    --base\x3a\x3a__sz();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __c_node* __c = __get_db()->__find_c_and_lock(this);\x0a"
"    for (__i_node** __ip = __c->end_; __ip \x21= __c->beg_; )\x0a"
"    {\x0a"
"        --__ip;\x0a"
"        iterator* __i = static_cast<iterator*>((*__ip)->__i_);\x0a"
"        if (__i->__ptr_ == __n)\x0a"
"        {\x0a"
"            (*__ip)->__c_ = nullptr;\x0a"
"            if (--__c->end_ \x21= __ip)\x0a"
"                memmove(__ip, __ip+1, (__c->end_ - __ip)*sizeof(__i_node*));\x0a"
"        }\x0a"
"    }\x0a"
"    __get_db()->unlock();\x0a"
"#endif\x0a"
"    __node_pointer __np = __n->__as_node();\x0a"
"    __node_alloc_traits\x3a\x3a""destroy(__na, _VSTD\x3a\x3a""addressof(__np->__value_));\x0a"
"    __node_alloc_traits\x3a\x3a""deallocate(__na, __np, 1);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    return iterator(__r, this);\x0a"
"#else\x0a"
"    return iterator(__r);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"list<_Tp, _Alloc>\x3a\x3a""erase(const_iterator __f, const_iterator __l)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__f) == this,\x0a"
"        \x22list\x3a\x3a""erase(iterator, iterator) called with an iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"   _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__l) == this,\x0a"
"        \x22list\x3a\x3a""erase(iterator, iterator) called with an iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"#endif\x0a"
"    if (__f \x21= __l)\x0a"
"    {\x0a"
"        __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"        base\x3a\x3a__unlink_nodes(__f.__ptr_, __l.__ptr_->__prev_);\x0a"
"        while (__f \x21= __l)\x0a"
"        {\x0a"
"            __link_pointer __n = __f.__ptr_;\x0a"
"            ++__f;\x0a"
"            --base\x3a\x3a__sz();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"            __c_node* __c = __get_db()->__find_c_and_lock(this);\x0a"
"            for (__i_node** __p = __c->end_; __p \x21= __c->beg_; )\x0a"
"            {\x0a"
"                --__p;\x0a"
"                iterator* __i = static_cast<iterator*>((*__p)->__i_);\x0a"
"                if (__i->__ptr_ == __n)\x0a"
"                {\x0a"
"                    (*__p)->__c_ = nullptr;\x0a"
"                    if (--__c->end_ \x21= __p)\x0a"
"                        memmove(__p, __p+1, (__c->end_ - __p)*sizeof(__i_node*));\x0a"
"                }\x0a"
"            }\x0a"
"            __get_db()->unlock();\x0a"
"#endif\x0a"
"            __node_pointer __np = __n->__as_node();\x0a"
"            __node_alloc_traits\x3a\x3a""destroy(__na, _VSTD\x3a\x3a""addressof(__np->__value_));\x0a"
"            __node_alloc_traits\x3a\x3a""deallocate(__na, __np, 1);\x0a"
"        }\x0a"
"    }\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    return iterator(__l.__ptr_, this);\x0a"
"#else\x0a"
"    return iterator(__l.__ptr_);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3aresize(size_type __n)\x0a"
"{\x0a"
"    if (__n < base\x3a\x3a__sz())\x0a"
"        erase(__iterator(__n), end());\x0a"
"    else if (__n > base\x3a\x3a__sz())\x0a"
"    {\x0a"
"        __n -= base\x3a\x3a__sz();\x0a"
"        size_type __ds = 0;\x0a"
"        __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"        __hold_pointer __hold = __allocate_node(__na);\x0a"
"        __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_));\x0a"
"        ++__ds;\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        iterator __r = iterator(__hold.release()->__as_link(), this);\x0a"
"#else\x0a"
"        iterator __r = iterator(__hold.release()->__as_link());\x0a"
"#endif\x0a"
"        iterator __e = __r;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (--__n; __n \x21= 0; --__n, ++__e, ++__ds)\x0a"
"            {\x0a"
"                __hold.reset(__node_alloc_traits\x3a\x3a""allocate(__na, 1));\x0a"
"                __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_));\x0a"
"                __e.__ptr_->__next_ = __hold.get()->__as_link();\x0a"
"                __hold->__prev_ = __e.__ptr_;\x0a"
"                __hold.release();\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            while (true)\x0a"
"            {\x0a"
"                __node_alloc_traits\x3a\x3a""destroy(__na, _VSTD\x3a\x3a""addressof(*__e));\x0a"
"                __link_pointer __prev = __e.__ptr_->__prev_;\x0a"
"                __node_alloc_traits\x3a\x3a""deallocate(__na, __e.__ptr_->__as_node(), 1);\x0a"
"                if (__prev == 0)\x0a"
"                    break;\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"                __e = iterator(__prev, this);\x0a"
"#else\x0a"
"                __e = iterator(__prev);\x0a"
"#endif\x0a"
"            }\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __link_nodes_at_back(__r.__ptr_, __e.__ptr_);\x0a"
"        base\x3a\x3a__sz() += __ds;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3aresize(size_type __n, const value_type\x26 __x)\x0a"
"{\x0a"
"    if (__n < base\x3a\x3a__sz())\x0a"
"        erase(__iterator(__n), end());\x0a"
"    else if (__n > base\x3a\x3a__sz())\x0a"
"    {\x0a"
"        __n -= base\x3a\x3a__sz();\x0a"
"        size_type __ds = 0;\x0a"
"        __node_allocator\x26 __na = base\x3a\x3a__node_alloc();\x0a"
"        __hold_pointer __hold = __allocate_node(__na);\x0a"
"        __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), __x);\x0a"
"        ++__ds;\x0a"
"        __link_pointer __nl = __hold.release()->__as_link();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        iterator __r = iterator(__nl, this);\x0a"
"#else\x0a"
"        iterator __r = iterator(__nl);\x0a"
"#endif\x0a"
"        iterator __e = __r;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (--__n; __n \x21= 0; --__n, ++__e, ++__ds)\x0a"
"            {\x0a"
"                __hold.reset(__node_alloc_traits\x3a\x3a""allocate(__na, 1));\x0a"
"                __node_alloc_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__hold->__value_), __x);\x0a"
"                __e.__ptr_->__next_ = __hold.get()->__as_link();\x0a"
"                __hold->__prev_ = __e.__ptr_;\x0a"
"                __hold.release();\x0a"
"            }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            while (true)\x0a"
"            {\x0a"
"                __node_alloc_traits\x3a\x3a""destroy(__na, _VSTD\x3a\x3a""addressof(*__e));\x0a"
"                __link_pointer __prev = __e.__ptr_->__prev_;\x0a"
"                __node_alloc_traits\x3a\x3a""deallocate(__na, __e.__ptr_->__as_node(), 1);\x0a"
"                if (__prev == 0)\x0a"
"                    break;\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"                __e = iterator(__prev, this);\x0a"
"#else\x0a"
"                __e = iterator(__prev);\x0a"
"#endif\x0a"
"            }\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __link_nodes(base\x3a\x3a__end_as_link(), __r.__ptr_, __e.__ptr_);\x0a"
"        base\x3a\x3a__sz() += __ds;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3asplice(const_iterator __p, list\x26 __c)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(this \x21= \x26__c,\x0a"
"                   \x22list\x3a\x3asplice(iterator, list) called with this == \x26list\x22);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"        \x22list\x3a\x3asplice(iterator, list) called with an iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"#endif\x0a"
"    if (\x21__c.empty())\x0a"
"    {\x0a"
"        __link_pointer __f = __c.__end_.__next_;\x0a"
"        __link_pointer __l = __c.__end_.__prev_;\x0a"
"        base\x3a\x3a__unlink_nodes(__f, __l);\x0a"
"        __link_nodes(__p.__ptr_, __f, __l);\x0a"
"        base\x3a\x3a__sz() += __c.__sz();\x0a"
"        __c.__sz() = 0;\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        if (\x26__c \x21= this) {\x0a"
"            __libcpp_db* __db = __get_db();\x0a"
"            __c_node* __cn1 = __db->__find_c_and_lock(this);\x0a"
"            __c_node* __cn2 = __db->__find_c(\x26__c);\x0a"
"            for (__i_node** __ip = __cn2->end_; __ip \x21= __cn2->beg_;)\x0a"
"            {\x0a"
"                --__ip;\x0a"
"                iterator* __i = static_cast<iterator*>((*__ip)->__i_);\x0a"
"                if (__i->__ptr_ \x21= __c.__end_as_link())\x0a"
"                {\x0a"
"                    __cn1->__add(*__ip);\x0a"
"                    (*__ip)->__c_ = __cn1;\x0a"
"                    if (--__cn2->end_ \x21= __ip)\x0a"
"                        memmove(__ip, __ip+1, (__cn2->end_ - __ip)*sizeof(__i_node*));\x0a"
"                }\x0a"
"            }\x0a"
"            __db->unlock();\x0a"
"        }\x0a"
"#endif\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3asplice(const_iterator __p, list\x26 __c, const_iterator __i)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"        \x22list\x3a\x3asplice(iterator, list, iterator) called with first iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__i) == \x26__c,\x0a"
"        \x22list\x3a\x3asplice(iterator, list, iterator) called with second iterator not\x22\x0a"
"        \x22 referring to list argument\x22);\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__dereferenceable(\x26__i),\x0a"
"        \x22list\x3a\x3asplice(iterator, list, iterator) called with second iterator not\x22\x0a"
"        \x22 derefereceable\x22);\x0a"
"#endif\x0a"
"    if (__p.__ptr_ \x21= __i.__ptr_ \x26\x26 __p.__ptr_ \x21= __i.__ptr_->__next_)\x0a"
"    {\x0a"
"        __link_pointer __f = __i.__ptr_;\x0a"
"        base\x3a\x3a__unlink_nodes(__f, __f);\x0a"
"        __link_nodes(__p.__ptr_, __f, __f);\x0a"
"        --__c.__sz();\x0a"
"        ++base\x3a\x3a__sz();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        if (\x26__c \x21= this) {\x0a"
"            __libcpp_db* __db = __get_db();\x0a"
"            __c_node* __cn1 = __db->__find_c_and_lock(this);\x0a"
"            __c_node* __cn2 = __db->__find_c(\x26__c);\x0a"
"            for (__i_node** __ip = __cn2->end_; __ip \x21= __cn2->beg_;)\x0a"
"            {\x0a"
"                --__ip;\x0a"
"                iterator* __j = static_cast<iterator*>((*__ip)->__i_);\x0a"
"                if (__j->__ptr_ == __f)\x0a"
"                {\x0a"
"                    __cn1->__add(*__ip);\x0a"
"                    (*__ip)->__c_ = __cn1;\x0a"
"                    if (--__cn2->end_ \x21= __ip)\x0a"
"                        memmove(__ip, __ip+1, (__cn2->end_ - __ip)*sizeof(__i_node*));\x0a"
"                }\x0a"
"            }\x0a"
"            __db->unlock();\x0a"
"        }\x0a"
"#endif\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3asplice(const_iterator __p, list\x26 __c, const_iterator __f, const_iterator __l)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"        \x22list\x3a\x3asplice(iterator, list, iterator, iterator) called with first iterator not\x22\x0a"
"        \x22 referring to this list\x22);\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__f) == \x26__c,\x0a"
"        \x22list\x3a\x3asplice(iterator, list, iterator, iterator) called with second iterator not\x22\x0a"
"        \x22 referring to list argument\x22);\x0a"
"    if (this == \x26__c)\x0a"
"    {\x0a"
"        for (const_iterator __i = __f; __i \x21= __l; ++__i)\x0a"
"            _LIBCPP_ASSERT(__i \x21= __p,\x0a"
"                           \x22list\x3a\x3asplice(iterator, list, iterator, iterator)\x22\x0a"
"                           \x22 called with the first iterator within the range\x22\x0a"
"                           \x22 of the second and third iterators\x22);\x0a"
"    }\x0a"
"#endif\x0a"
"    if (__f \x21= __l)\x0a"
"    {\x0a"
"        __link_pointer __first = __f.__ptr_;\x0a"
"        --__l;\x0a"
"        __link_pointer __last = __l.__ptr_;\x0a"
"        if (this \x21= \x26__c)\x0a"
"        {\x0a"
"            size_type __s = _VSTD\x3a\x3a""distance(__f, __l) + 1;\x0a"
"            __c.__sz() -= __s;\x0a"
"            base\x3a\x3a__sz() += __s;\x0a"
"        }\x0a"
"        base\x3a\x3a__unlink_nodes(__first, __last);\x0a"
"        __link_nodes(__p.__ptr_, __first, __last);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        if (\x26__c \x21= this) {\x0a"
"            __libcpp_db* __db = __get_db();\x0a"
"            __c_node* __cn1 = __db->__find_c_and_lock(this);\x0a"
"            __c_node* __cn2 = __db->__find_c(\x26__c);\x0a"
"            for (__i_node** __ip = __cn2->end_; __ip \x21= __cn2->beg_;)\x0a"
"            {\x0a"
"                --__ip;\x0a"
"                iterator* __j = static_cast<iterator*>((*__ip)->__i_);\x0a"
"                for (__link_pointer __k = __f.__ptr_;\x0a"
"                                              __k \x21= __l.__ptr_; __k = __k->__next_)\x0a"
"                {\x0a"
"                    if (__j->__ptr_ == __k)\x0a"
"                    {\x0a"
"                        __cn1->__add(*__ip);\x0a"
"                        (*__ip)->__c_ = __cn1;\x0a"
"                        if (--__cn2->end_ \x21= __ip)\x0a"
"                            memmove(__ip, __ip+1, (__cn2->end_ - __ip)*sizeof(__i_node*));\x0a"
"                    }\x0a"
"                }\x0a"
"            }\x0a"
"            __db->unlock();\x0a"
"        }\x0a"
"#endif\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3a__remove_return_type\x0a"
"list<_Tp, _Alloc>\x3a\x3aremove(const value_type\x26 __x)\x0a"
"{\x0a"
"    list<_Tp, _Alloc> __deleted_nodes(get_allocator()); // collect the nodes we're removing\x0a"
"    for (const_iterator __i = begin(), __e = end(); __i \x21= __e;)\x0a"
"    {\x0a"
"        if (*__i == __x)\x0a"
"        {\x0a"
"            const_iterator __j = _VSTD\x3a\x3anext(__i);\x0a"
"            for (; __j \x21= __e \x26\x26 *__j == __x; ++__j)\x0a"
"                ;\x0a"
"            __deleted_nodes.splice(__deleted_nodes.end(), *this, __i, __j);\x0a"
"            __i = __j;\x0a"
"            if (__i \x21= __e)\x0a"
"                ++__i;\x0a"
"        }\x0a"
"        else\x0a"
"            ++__i;\x0a"
"    }\x0a"
"\x0a"
"    return (__remove_return_type) __deleted_nodes.size();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _Pred>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3a__remove_return_type\x0a"
"list<_Tp, _Alloc>\x3a\x3aremove_if(_Pred __pred)\x0a"
"{\x0a"
"    list<_Tp, _Alloc> __deleted_nodes(get_allocator()); // collect the nodes we're removing\x0a"
"    for (iterator __i = begin(), __e = end(); __i \x21= __e;)\x0a"
"    {\x0a"
"        if (__pred(*__i))\x0a"
"        {\x0a"
"            iterator __j = _VSTD\x3a\x3anext(__i);\x0a"
"            for (; __j \x21= __e \x26\x26 __pred(*__j); ++__j)\x0a"
"                ;\x0a"
"            __deleted_nodes.splice(__deleted_nodes.end(), *this, __i, __j);\x0a"
"            __i = __j;\x0a"
"            if (__i \x21= __e)\x0a"
"                ++__i;\x0a"
"        }\x0a"
"        else\x0a"
"            ++__i;\x0a"
"    }\x0a"
"\x0a"
"    return (__remove_return_type) __deleted_nodes.size();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _BinaryPred>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3a__remove_return_type\x0a"
"list<_Tp, _Alloc>\x3a\x3aunique(_BinaryPred __binary_pred)\x0a"
"{\x0a"
"    list<_Tp, _Alloc> __deleted_nodes(get_allocator()); // collect the nodes we're removing\x0a"
"    for (iterator __i = begin(), __e = end(); __i \x21= __e;)\x0a"
"    {\x0a"
"        iterator __j = _VSTD\x3a\x3anext(__i);\x0a"
"        for (; __j \x21= __e \x26\x26 __binary_pred(*__i, *__j); ++__j)\x0a"
"            ;\x0a"
"        if (++__i \x21= __j) {\x0a"
"            __deleted_nodes.splice(__deleted_nodes.end(), *this, __i, __j);\x0a"
"            __i = __j;\x0a"
"            }\x0a"
"    }\x0a"
"    \x0a"
"    return (__remove_return_type) __deleted_nodes.size();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3amerge(list\x26 __c)\x0a"
"{\x0a"
"    merge(__c, __less<value_type>());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _Comp>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3amerge(list\x26 __c, _Comp __comp)\x0a"
"{\x0a"
"    if (this \x21= _VSTD\x3a\x3a""addressof(__c))\x0a"
"    {\x0a"
"        iterator __f1 = begin();\x0a"
"        iterator __e1 = end();\x0a"
"        iterator __f2 = __c.begin();\x0a"
"        iterator __e2 = __c.end();\x0a"
"        while (__f1 \x21= __e1 \x26\x26 __f2 \x21= __e2)\x0a"
"        {\x0a"
"            if (__comp(*__f2, *__f1))\x0a"
"            {\x0a"
"                size_type __ds = 1;\x0a"
"                iterator __m2 = _VSTD\x3a\x3anext(__f2);\x0a"
"                for (; __m2 \x21= __e2 \x26\x26 __comp(*__m2, *__f1); ++__m2, ++__ds)\x0a"
"                    ;\x0a"
"                base\x3a\x3a__sz() += __ds;\x0a"
"                __c.__sz() -= __ds;\x0a"
"                __link_pointer __f = __f2.__ptr_;\x0a"
"                __link_pointer __l = __m2.__ptr_->__prev_;\x0a"
"                __f2 = __m2;\x0a"
"                base\x3a\x3a__unlink_nodes(__f, __l);\x0a"
"                __m2 = _VSTD\x3a\x3anext(__f1);\x0a"
"                __link_nodes(__f1.__ptr_, __f, __l);\x0a"
"                __f1 = __m2;\x0a"
"            }\x0a"
"            else\x0a"
"                ++__f1;\x0a"
"        }\x0a"
"        splice(__e1, __c);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __libcpp_db* __db = __get_db();\x0a"
"        __c_node* __cn1 = __db->__find_c_and_lock(this);\x0a"
"        __c_node* __cn2 = __db->__find_c(\x26__c);\x0a"
"        for (__i_node** __p = __cn2->end_; __p \x21= __cn2->beg_;)\x0a"
"        {\x0a"
"            --__p;\x0a"
"            iterator* __i = static_cast<iterator*>((*__p)->__i_);\x0a"
"            if (__i->__ptr_ \x21= __c.__end_as_link())\x0a"
"            {\x0a"
"                __cn1->__add(*__p);\x0a"
"                (*__p)->__c_ = __cn1;\x0a"
"                if (--__cn2->end_ \x21= __p)\x0a"
"                    memmove(__p, __p+1, (__cn2->end_ - __p)*sizeof(__i_node*));\x0a"
"            }\x0a"
"        }\x0a"
"        __db->unlock();\x0a"
"#endif\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3asort()\x0a"
"{\x0a"
"    sort(__less<value_type>());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _Comp>\x0a"
"inline\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3asort(_Comp __comp)\x0a"
"{\x0a"
"    __sort(begin(), end(), base\x3a\x3a__sz(), __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"template <class _Comp>\x0a"
"typename list<_Tp, _Alloc>\x3a\x3aiterator\x0a"
"list<_Tp, _Alloc>\x3a\x3a__sort(iterator __f1, iterator __e2, size_type __n, _Comp\x26 __comp)\x0a"
"{\x0a"
"    switch (__n)\x0a"
"    {\x0a"
"    case 0\x3a\x0a"
"    case 1\x3a\x0a"
"        return __f1;\x0a"
"    case 2\x3a\x0a"
"        if (__comp(*--__e2, *__f1))\x0a"
"        {\x0a"
"            __link_pointer __f = __e2.__ptr_;\x0a"
"            base\x3a\x3a__unlink_nodes(__f, __f);\x0a"
"            __link_nodes(__f1.__ptr_, __f, __f);\x0a"
"            return __e2;\x0a"
"        }\x0a"
"        return __f1;\x0a"
"    }\x0a"
"    size_type __n2 = __n / 2;\x0a"
"    iterator __e1 = _VSTD\x3a\x3anext(__f1, __n2);\x0a"
"    iterator  __r = __f1 = __sort(__f1, __e1, __n2, __comp);\x0a"
"    iterator __f2 = __e1 = __sort(__e1, __e2, __n - __n2, __comp);\x0a"
"    if (__comp(*__f2, *__f1))\x0a"
"    {\x0a"
"        iterator __m2 = _VSTD\x3a\x3anext(__f2);\x0a"
"        for (; __m2 \x21= __e2 \x26\x26 __comp(*__m2, *__f1); ++__m2)\x0a"
"            ;\x0a"
"        __link_pointer __f = __f2.__ptr_;\x0a"
"        __link_pointer __l = __m2.__ptr_->__prev_;\x0a"
"        __r = __f2;\x0a"
"        __e1 = __f2 = __m2;\x0a"
"        base\x3a\x3a__unlink_nodes(__f, __l);\x0a"
"        __m2 = _VSTD\x3a\x3anext(__f1);\x0a"
"        __link_nodes(__f1.__ptr_, __f, __l);\x0a"
"        __f1 = __m2;\x0a"
"    }\x0a"
"    else\x0a"
"        ++__f1;\x0a"
"    while (__f1 \x21= __e1 \x26\x26 __f2 \x21= __e2)\x0a"
"    {\x0a"
"        if (__comp(*__f2, *__f1))\x0a"
"        {\x0a"
"            iterator __m2 = _VSTD\x3a\x3anext(__f2);\x0a"
"            for (; __m2 \x21= __e2 \x26\x26 __comp(*__m2, *__f1); ++__m2)\x0a"
"                ;\x0a"
"            __link_pointer __f = __f2.__ptr_;\x0a"
"            __link_pointer __l = __m2.__ptr_->__prev_;\x0a"
"            if (__e1 == __f2)\x0a"
"                __e1 = __m2;\x0a"
"            __f2 = __m2;\x0a"
"            base\x3a\x3a__unlink_nodes(__f, __l);\x0a"
"            __m2 = _VSTD\x3a\x3anext(__f1);\x0a"
"            __link_nodes(__f1.__ptr_, __f, __l);\x0a"
"            __f1 = __m2;\x0a"
"        }\x0a"
"        else\x0a"
"            ++__f1;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"list<_Tp, _Alloc>\x3a\x3areverse() _NOEXCEPT\x0a"
"{\x0a"
"    if (base\x3a\x3a__sz() > 1)\x0a"
"    {\x0a"
"        iterator __e = end();\x0a"
"        for (iterator __i = begin(); __i.__ptr_ \x21= __e.__ptr_;)\x0a"
"        {\x0a"
"            _VSTD\x3a\x3aswap(__i.__ptr_->__prev_, __i.__ptr_->__next_);\x0a"
"            __i.__ptr_ = __i.__ptr_->__prev_;\x0a"
"        }\x0a"
"        _VSTD\x3a\x3aswap(__e.__ptr_->__prev_, __e.__ptr_->__next_);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"bool\x0a"
"list<_Tp, _Alloc>\x3a\x3a__invariants() const\x0a"
"{\x0a"
"    return size() == _VSTD\x3a\x3a""distance(begin(), end());\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"bool\x0a"
"list<_Tp, _Alloc>\x3a\x3a__dereferenceable(const const_iterator* __i) const\x0a"
"{\x0a"
"    return __i->__ptr_ \x21= this->__end_as_link();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"bool\x0a"
"list<_Tp, _Alloc>\x3a\x3a__decrementable(const const_iterator* __i) const\x0a"
"{\x0a"
"    return \x21""empty() \x26\x26  __i->__ptr_ \x21= base\x3a\x3a__end_.__next_;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"bool\x0a"
"list<_Tp, _Alloc>\x3a\x3a__addable(const const_iterator*, ptrdiff_t) const\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"bool\x0a"
"list<_Tp, _Alloc>\x3a\x3a__subscriptable(const const_iterator*, ptrdiff_t) const\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const list<_Tp, _Alloc>\x26 __x, const list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return __x.size() == __y.size() \x26\x26 _VSTD\x3a\x3a""equal(__x.begin(), __x.end(), __y.begin());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const list<_Tp, _Alloc>\x26 __x, const list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alexicographical_compare(__x.begin(), __x.end(), __y.begin(), __y.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const list<_Tp, _Alloc>\x26 __x, const list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const list<_Tp, _Alloc>\x26 __x, const list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const list<_Tp, _Alloc>\x26 __x, const list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const list<_Tp, _Alloc>\x26 __x, const list<_Tp, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(list<_Tp, _Alloc>\x26 __x, list<_Tp, _Alloc>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Tp, class _Allocator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(list<_Tp, _Allocator>\x26 __c, _Predicate __pred)\x0a"
"{ __c.remove_if(__pred); }\x0a"
"\x0a"
"template <class _Tp, class _Allocator, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase(list<_Tp, _Allocator>\x26 __c, const _Up\x26 __v)\x0a"
"{ _VSTD\x3a\x3a""erase_if(__c, \x5b\x26\x5d(auto\x26 __elem) { return __elem == __v; }); }\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_LIST\x0a"
"", 80128 ); }