#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_map( 
"// -*- C++ -*-\x0a"
"//===----------------------------- map ------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_MAP\x0a"
"#define _LIBCPP_MAP\x0a"
"\x0a"
"/*\x0a"
"\x0a"
"    map synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class Key, class T, class Compare = less<Key>,\x0a"
"          class Allocator = allocator<pair<const Key, T>>>\x0a"
"class map\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef Key                                      key_type;\x0a"
"    typedef T                                        mapped_type;\x0a"
"    typedef pair<const key_type, mapped_type>        value_type;\x0a"
"    typedef Compare                                  key_compare;\x0a"
"    typedef Allocator                                allocator_type;\x0a"
"    typedef typename allocator_type\x3a\x3areference       reference;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename allocator_type\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_type\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_type\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef implementation-defined                   iterator;\x0a"
"    typedef implementation-defined                   const_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator>          reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator>    const_reverse_iterator;\x0a"
"    typedef unspecified                              node_type;              // C++17\x0a"
"    typedef INSERT_RETURN_TYPE<iterator, node_type>  insert_return_type;     // C++17\x0a"
"\x0a"
"    class value_compare\x0a"
"        \x3a public binary_function<value_type, value_type, bool>\x0a"
"    {\x0a"
"        friend class map;\x0a"
"    protected\x3a\x0a"
"        key_compare comp;\x0a"
"\x0a"
"        value_compare(key_compare c);\x0a"
"    public\x3a\x0a"
"        bool operator()(const value_type\x26 x, const value_type\x26 y) const;\x0a"
"    };\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    map()\x0a"
"        noexcept(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_compare>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue);\x0a"
"    explicit map(const key_compare\x26 comp);\x0a"
"    map(const key_compare\x26 comp, const allocator_type\x26 a);\x0a"
"    template <class InputIterator>\x0a"
"        map(InputIterator first, InputIterator last,\x0a"
"            const key_compare\x26 comp = key_compare());\x0a"
"    template <class InputIterator>\x0a"
"        map(InputIterator first, InputIterator last,\x0a"
"            const key_compare\x26 comp, const allocator_type\x26 a);\x0a"
"    map(const map\x26 m);\x0a"
"    map(map\x26\x26 m)\x0a"
"        noexcept(\x0a"
"            is_nothrow_move_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<key_compare>\x3a\x3avalue);\x0a"
"    explicit map(const allocator_type\x26 a);\x0a"
"    map(const map\x26 m, const allocator_type\x26 a);\x0a"
"    map(map\x26\x26 m, const allocator_type\x26 a);\x0a"
"    map(initializer_list<value_type> il, const key_compare\x26 comp = key_compare());\x0a"
"    map(initializer_list<value_type> il, const key_compare\x26 comp, const allocator_type\x26 a);\x0a"
"    template <class InputIterator>\x0a"
"        map(InputIterator first, InputIterator last, const allocator_type\x26 a)\x0a"
"            \x3a map(first, last, Compare(), a) {}  // C++14\x0a"
"    map(initializer_list<value_type> il, const allocator_type\x26 a)\x0a"
"        \x3a map(il, Compare(), a) {}  // C++14\x0a"
"   \x7emap();\x0a"
"\x0a"
"    map\x26 operator=(const map\x26 m);\x0a"
"    map\x26 operator=(map\x26\x26 m)\x0a"
"        noexcept(\x0a"
"            allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<key_compare>\x3a\x3avalue);\x0a"
"    map\x26 operator=(initializer_list<value_type> il);\x0a"
"\x0a"
"    // iterators\x3a\x0a"
"          iterator begin() noexcept;\x0a"
"    const_iterator begin() const noexcept;\x0a"
"          iterator end() noexcept;\x0a"
"    const_iterator end()   const noexcept;\x0a"
"\x0a"
"          reverse_iterator rbegin() noexcept;\x0a"
"    const_reverse_iterator rbegin() const noexcept;\x0a"
"          reverse_iterator rend() noexcept;\x0a"
"    const_reverse_iterator rend()   const noexcept;\x0a"
"\x0a"
"    const_iterator         cbegin()  const noexcept;\x0a"
"    const_iterator         cend()    const noexcept;\x0a"
"    const_reverse_iterator crbegin() const noexcept;\x0a"
"    const_reverse_iterator crend()   const noexcept;\x0a"
"\x0a"
"    // capacity\x3a\x0a"
"    bool      empty()    const noexcept;\x0a"
"    size_type size()     const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    mapped_type\x26 operator\x5b\x5d(const key_type\x26 k);\x0a"
"    mapped_type\x26 operator\x5b\x5d(key_type\x26\x26 k);\x0a"
"\x0a"
"          mapped_type\x26 at(const key_type\x26 k);\x0a"
"    const mapped_type\x26 at(const key_type\x26 k) const;\x0a"
"\x0a"
"    // modifiers\x3a\x0a"
"    template <class... Args>\x0a"
"        pair<iterator, bool> emplace(Args\x26\x26... args);\x0a"
"    template <class... Args>\x0a"
"        iterator emplace_hint(const_iterator position, Args\x26\x26... args);\x0a"
"    pair<iterator, bool> insert(const value_type\x26 v);\x0a"
"    pair<iterator, bool> insert(      value_type\x26\x26 v);                                // C++17\x0a"
"    template <class P>\x0a"
"        pair<iterator, bool> insert(P\x26\x26 p);\x0a"
"    iterator insert(const_iterator position, const value_type\x26 v);\x0a"
"    iterator insert(const_iterator position,       value_type\x26\x26 v);                   // C++17\x0a"
"    template <class P>\x0a"
"        iterator insert(const_iterator position, P\x26\x26 p);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"    void insert(initializer_list<value_type> il);\x0a"
"\x0a"
"    node_type extract(const_iterator position);                                       // C++17\x0a"
"    node_type extract(const key_type\x26 x);                                             // C++17\x0a"
"    insert_return_type insert(node_type\x26\x26 nh);                                        // C++17\x0a"
"    iterator insert(const_iterator hint, node_type\x26\x26 nh);                             // C++17\x0a"
"\x0a"
"    template <class... Args>\x0a"
"        pair<iterator, bool> try_emplace(const key_type\x26 k, Args\x26\x26... args);          // C++17\x0a"
"    template <class... Args>\x0a"
"        pair<iterator, bool> try_emplace(key_type\x26\x26 k, Args\x26\x26... args);               // C++17\x0a"
"    template <class... Args>\x0a"
"        iterator try_emplace(const_iterator hint, const key_type\x26 k, Args\x26\x26... args); // C++17\x0a"
"    template <class... Args>\x0a"
"        iterator try_emplace(const_iterator hint, key_type\x26\x26 k, Args\x26\x26... args);      // C++17\x0a"
"    template <class M>\x0a"
"        pair<iterator, bool> insert_or_assign(const key_type\x26 k, M\x26\x26 obj);            // C++17\x0a"
"    template <class M>\x0a"
"        pair<iterator, bool> insert_or_assign(key_type\x26\x26 k, M\x26\x26 obj);                 // C++17\x0a"
"    template <class M>\x0a"
"        iterator insert_or_assign(const_iterator hint, const key_type\x26 k, M\x26\x26 obj);   // C++17\x0a"
"    template <class M>\x0a"
"        iterator insert_or_assign(const_iterator hint, key_type\x26\x26 k, M\x26\x26 obj);        // C++17\x0a"
"\x0a"
"    iterator  erase(const_iterator position);\x0a"
"    iterator  erase(iterator position); // C++14\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    iterator  erase(const_iterator first, const_iterator last);\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    template<class C2>\x0a"
"      void merge(map<Key, T, C2, Allocator>\x26 source);         // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(map<Key, T, C2, Allocator>\x26\x26 source);        // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(multimap<Key, T, C2, Allocator>\x26 source);    // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(multimap<Key, T, C2, Allocator>\x26\x26 source);   // C++17\x0a"
"\x0a"
"    void swap(map\x26 m)\x0a"
"        noexcept(allocator_traits<allocator_type>\x3a\x3ais_always_equal\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_swappable<key_compare>\x3a\x3avalue); // C++17\x0a"
"\x0a"
"    // observers\x3a\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"    key_compare    key_comp()      const;\x0a"
"    value_compare  value_comp()    const;\x0a"
"\x0a"
"    // map operations\x3a\x0a"
"          iterator find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator find(const K\x26 x);              // C++14\x0a"
"    template<typename K>\x0a"
"        const_iterator find(const K\x26 x) const;  // C++14\x0a"
"    template<typename K>\x0a"
"      size_type count(const K\x26 x) const;        // C++14\x0a"
"    size_type      count(const key_type\x26 k) const;\x0a"
"        bool contains(const key_type\x26 x) const; // C++20\x0a"
"          iterator lower_bound(const key_type\x26 k);\x0a"
"    const_iterator lower_bound(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator lower_bound(const K\x26 x);              // C++14\x0a"
"    template<typename K>\x0a"
"        const_iterator lower_bound(const K\x26 x) const;  // C++14\x0a"
"\x0a"
"          iterator upper_bound(const key_type\x26 k);\x0a"
"    const_iterator upper_bound(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator upper_bound(const K\x26 x);              // C++14\x0a"
"    template<typename K>\x0a"
"        const_iterator upper_bound(const K\x26 x) const;  // C++14\x0a"
"\x0a"
"    pair<iterator,iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator,const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        pair<iterator,iterator>             equal_range(const K\x26 x);        // C++14\x0a"
"    template<typename K>\x0a"
"        pair<const_iterator,const_iterator> equal_range(const K\x26 x) const;  // C++14\x0a"
"};\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator==(const map<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const map<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator< (const map<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const map<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator\x21=(const map<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const map<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator> (const map<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const map<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator>=(const map<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const map<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator<=(const map<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const map<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"// specialized algorithms\x3a\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"void\x0a"
"swap(map<Key, T, Compare, Allocator>\x26 x, map<Key, T, Compare, Allocator>\x26 y)\x0a"
"    noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator, class Predicate>\x0a"
"  void erase_if(map<Key, T, Compare, Allocator>\x26 c, Predicate pred);  // C++20\x0a"
"\x0a"
"\x0a"
"template <class Key, class T, class Compare = less<Key>,\x0a"
"          class Allocator = allocator<pair<const Key, T>>>\x0a"
"class multimap\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef Key                                      key_type;\x0a"
"    typedef T                                        mapped_type;\x0a"
"    typedef pair<const key_type,mapped_type>         value_type;\x0a"
"    typedef Compare                                  key_compare;\x0a"
"    typedef Allocator                                allocator_type;\x0a"
"    typedef typename allocator_type\x3a\x3areference       reference;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename allocator_type\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_type\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename allocator_type\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_pointer   const_pointer;\x0a"
"\x0a"
"    typedef implementation-defined                   iterator;\x0a"
"    typedef implementation-defined                   const_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator>          reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator>    const_reverse_iterator;\x0a"
"    typedef unspecified                              node_type;              // C++17\x0a"
"\x0a"
"    class value_compare\x0a"
"        \x3a public binary_function<value_type,value_type,bool>\x0a"
"    {\x0a"
"        friend class multimap;\x0a"
"    protected\x3a\x0a"
"        key_compare comp;\x0a"
"        value_compare(key_compare c);\x0a"
"    public\x3a\x0a"
"        bool operator()(const value_type\x26 x, const value_type\x26 y) const;\x0a"
"    };\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    multimap()\x0a"
"        noexcept(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_compare>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue);\x0a"
"    explicit multimap(const key_compare\x26 comp);\x0a"
"    multimap(const key_compare\x26 comp, const allocator_type\x26 a);\x0a"
"    template <class InputIterator>\x0a"
"        multimap(InputIterator first, InputIterator last, const key_compare\x26 comp);\x0a"
"    template <class InputIterator>\x0a"
"        multimap(InputIterator first, InputIterator last, const key_compare\x26 comp,\x0a"
"                 const allocator_type\x26 a);\x0a"
"    multimap(const multimap\x26 m);\x0a"
"    multimap(multimap\x26\x26 m)\x0a"
"        noexcept(\x0a"
"            is_nothrow_move_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<key_compare>\x3a\x3avalue);\x0a"
"    explicit multimap(const allocator_type\x26 a);\x0a"
"    multimap(const multimap\x26 m, const allocator_type\x26 a);\x0a"
"    multimap(multimap\x26\x26 m, const allocator_type\x26 a);\x0a"
"    multimap(initializer_list<value_type> il, const key_compare\x26 comp = key_compare());\x0a"
"    multimap(initializer_list<value_type> il, const key_compare\x26 comp,\x0a"
"             const allocator_type\x26 a);\x0a"
"    template <class InputIterator>\x0a"
"        multimap(InputIterator first, InputIterator last, const allocator_type\x26 a)\x0a"
"            \x3a multimap(first, last, Compare(), a) {} // C++14\x0a"
"    multimap(initializer_list<value_type> il, const allocator_type\x26 a)\x0a"
"        \x3a multimap(il, Compare(), a) {} // C++14\x0a"
"    \x7emultimap();\x0a"
"\x0a"
"    multimap\x26 operator=(const multimap\x26 m);\x0a"
"    multimap\x26 operator=(multimap\x26\x26 m)\x0a"
"        noexcept(\x0a"
"            allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<key_compare>\x3a\x3avalue);\x0a"
"    multimap\x26 operator=(initializer_list<value_type> il);\x0a"
"\x0a"
"    // iterators\x3a\x0a"
"          iterator begin() noexcept;\x0a"
"    const_iterator begin() const noexcept;\x0a"
"          iterator end() noexcept;\x0a"
"    const_iterator end()   const noexcept;\x0a"
"\x0a"
"          reverse_iterator rbegin() noexcept;\x0a"
"    const_reverse_iterator rbegin() const noexcept;\x0a"
"          reverse_iterator rend() noexcept;\x0a"
"    const_reverse_iterator rend()   const noexcept;\x0a"
"\x0a"
"    const_iterator         cbegin()  const noexcept;\x0a"
"    const_iterator         cend()    const noexcept;\x0a"
"    const_reverse_iterator crbegin() const noexcept;\x0a"
"    const_reverse_iterator crend()   const noexcept;\x0a"
"\x0a"
"    // capacity\x3a\x0a"
"    bool      empty()    const noexcept;\x0a"
"    size_type size()     const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"\x0a"
"    // modifiers\x3a\x0a"
"    template <class... Args>\x0a"
"        iterator emplace(Args\x26\x26... args);\x0a"
"    template <class... Args>\x0a"
"        iterator emplace_hint(const_iterator position, Args\x26\x26... args);\x0a"
"    iterator insert(const value_type\x26 v);\x0a"
"    iterator insert(      value_type\x26\x26 v);                                            // C++17\x0a"
"    template <class P>\x0a"
"        iterator insert(P\x26\x26 p);\x0a"
"    iterator insert(const_iterator position, const value_type\x26 v);\x0a"
"    iterator insert(const_iterator position,       value_type\x26\x26 v);                   // C++17\x0a"
"    template <class P>\x0a"
"        iterator insert(const_iterator position, P\x26\x26 p);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"    void insert(initializer_list<value_type> il);\x0a"
"\x0a"
"    node_type extract(const_iterator position);                                       // C++17\x0a"
"    node_type extract(const key_type\x26 x);                                             // C++17\x0a"
"    iterator insert(node_type\x26\x26 nh);                                                  // C++17\x0a"
"    iterator insert(const_iterator hint, node_type\x26\x26 nh);                             // C++17\x0a"
"\x0a"
"    iterator  erase(const_iterator position);\x0a"
"    iterator  erase(iterator position); // C++14\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    iterator  erase(const_iterator first, const_iterator last);\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    template<class C2>\x0a"
"      void merge(multimap<Key, T, C2, Allocator>\x26 source);    // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(multimap<Key, T, C2, Allocator>\x26\x26 source);   // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(map<Key, T, C2, Allocator>\x26 source);         // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(map<Key, T, C2, Allocator>\x26\x26 source);        // C++17\x0a"
"\x0a"
"    void swap(multimap\x26 m)\x0a"
"        noexcept(allocator_traits<allocator_type>\x3a\x3ais_always_equal\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_swappable<key_compare>\x3a\x3avalue); // C++17\x0a"
"\x0a"
"    // observers\x3a\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"    key_compare    key_comp()      const;\x0a"
"    value_compare  value_comp()    const;\x0a"
"\x0a"
"    // map operations\x3a\x0a"
"          iterator find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator find(const K\x26 x);              // C++14\x0a"
"    template<typename K>\x0a"
"        const_iterator find(const K\x26 x) const;  // C++14\x0a"
"    template<typename K>\x0a"
"      size_type count(const K\x26 x) const;        // C++14\x0a"
"    size_type      count(const key_type\x26 k) const;\x0a"
"        bool contains(const key_type\x26 x) const; // C++20\x0a"
"          iterator lower_bound(const key_type\x26 k);\x0a"
"    const_iterator lower_bound(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator lower_bound(const K\x26 x);              // C++14\x0a"
"    template<typename K>\x0a"
"        const_iterator lower_bound(const K\x26 x) const;  // C++14\x0a"
"\x0a"
"          iterator upper_bound(const key_type\x26 k);\x0a"
"    const_iterator upper_bound(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator upper_bound(const K\x26 x);              // C++14\x0a"
"    template<typename K>\x0a"
"        const_iterator upper_bound(const K\x26 x) const;  // C++14\x0a"
"\x0a"
"    pair<iterator,iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator,const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        pair<iterator,iterator>             equal_range(const K\x26 x);        // C++14\x0a"
"    template<typename K>\x0a"
"        pair<const_iterator,const_iterator> equal_range(const K\x26 x) const;  // C++14\x0a"
"};\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator==(const multimap<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const multimap<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator< (const multimap<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const multimap<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator\x21=(const multimap<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const multimap<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator> (const multimap<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const multimap<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator>=(const multimap<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const multimap<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator<=(const multimap<Key, T, Compare, Allocator>\x26 x,\x0a"
"           const multimap<Key, T, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"// specialized algorithms\x3a\x0a"
"template <class Key, class T, class Compare, class Allocator>\x0a"
"void\x0a"
"swap(multimap<Key, T, Compare, Allocator>\x26 x,\x0a"
"     multimap<Key, T, Compare, Allocator>\x26 y)\x0a"
"    noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class Key, class T, class Compare, class Allocator, class Predicate>\x0a"
"  void erase_if(multimap<Key, T, Compare, Allocator>\x26 c, Predicate pred);  // C++20\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__tree>\x0a"
"#include <__node_handle>\x0a"
"#include <iterator>\x0a"
"#include <memory>\x0a"
"#include <utility>\x0a"
"#include <functional>\x0a"
"#include <initializer_list>\x0a"
"#include <type_traits>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Key, class _CP, class _Compare,\x0a"
"          bool = is_empty<_Compare>\x3a\x3avalue \x26\x26 \x21__libcpp_is_final<_Compare>\x3a\x3avalue>\x0a"
"class __map_value_compare\x0a"
"    \x3a private _Compare\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_value_compare()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<_Compare>\x3a\x3avalue)\x0a"
"        \x3a _Compare() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_value_compare(_Compare c)\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<_Compare>\x3a\x3avalue)\x0a"
"        \x3a _Compare(c) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Compare\x26 key_comp() const _NOEXCEPT {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _CP\x26 __x, const _CP\x26 __y) const\x0a"
"        {return static_cast<const _Compare\x26>(*this)(__x.__get_value().first, __y.__get_value().first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _CP\x26 __x, const _Key\x26 __y) const\x0a"
"        {return static_cast<const _Compare\x26>(*this)(__x.__get_value().first, __y);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Key\x26 __x, const _CP\x26 __y) const\x0a"
"        {return static_cast<const _Compare\x26>(*this)(__x, __y.__get_value().first);}\x0a"
"    void swap(__map_value_compare\x26__y)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<_Compare>\x3a\x3avalue)\x0a"
"    {\x0a"
"      using _VSTD\x3a\x3aswap;\x0a"
"      swap(static_cast<_Compare\x26>(*this), static_cast<_Compare\x26>(__y));\x0a"
"    }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"    operator () ( const _K2\x26 __x, const _CP\x26 __y ) const\x0a"
"        {return static_cast<const _Compare\x26>(*this) (__x, __y.__get_value().first);}\x0a"
"\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"    operator () (const _CP\x26 __x, const _K2\x26 __y) const\x0a"
"        {return static_cast<const _Compare\x26>(*this) (__x.__get_value().first, __y);}\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _CP, class _Compare>\x0a"
"class __map_value_compare<_Key, _CP, _Compare, false>\x0a"
"{\x0a"
"    _Compare comp;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_value_compare()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<_Compare>\x3a\x3avalue)\x0a"
"        \x3a comp() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_value_compare(_Compare c)\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<_Compare>\x3a\x3avalue)\x0a"
"        \x3a comp(c) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Compare\x26 key_comp() const _NOEXCEPT {return comp;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _CP\x26 __x, const _CP\x26 __y) const\x0a"
"        {return comp(__x.__get_value().first, __y.__get_value().first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _CP\x26 __x, const _Key\x26 __y) const\x0a"
"        {return comp(__x.__get_value().first, __y);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Key\x26 __x, const _CP\x26 __y) const\x0a"
"        {return comp(__x, __y.__get_value().first);}\x0a"
"    void swap(__map_value_compare\x26__y)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<_Compare>\x3a\x3avalue)\x0a"
"    {\x0a"
"        using _VSTD\x3a\x3aswap;\x0a"
"        swap(comp, __y.comp);\x0a"
"    }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"    operator () ( const _K2\x26 __x, const _CP\x26 __y ) const\x0a"
"        {return comp (__x, __y.__get_value().first);}\x0a"
"\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"    operator () (const _CP\x26 __x, const _K2\x26 __y) const\x0a"
"        {return comp (__x.__get_value().first, __y);}\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _CP, class _Compare, bool __b>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(__map_value_compare<_Key, _CP, _Compare, __b>\x26 __x,\x0a"
"     __map_value_compare<_Key, _CP, _Compare, __b>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"class __map_node_destructor\x0a"
"{\x0a"
"    typedef _Allocator                          allocator_type;\x0a"
"    typedef allocator_traits<allocator_type>    __alloc_traits;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer    pointer;\x0a"
"\x0a"
"private\x3a\x0a"
"    allocator_type\x26 __na_;\x0a"
"\x0a"
"    __map_node_destructor\x26 operator=(const __map_node_destructor\x26);\x0a"
"\x0a"
"public\x3a\x0a"
"    bool __first_constructed;\x0a"
"    bool __second_constructed;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __map_node_destructor(allocator_type\x26 __na) _NOEXCEPT\x0a"
"        \x3a __na_(__na),\x0a"
"          __first_constructed(false),\x0a"
"          __second_constructed(false)\x0a"
"        {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_node_destructor(__tree_node_destructor<allocator_type>\x26\x26 __x) _NOEXCEPT\x0a"
"        \x3a __na_(__x.__na_),\x0a"
"          __first_constructed(__x.__value_constructed),\x0a"
"          __second_constructed(__x.__value_constructed)\x0a"
"        {\x0a"
"            __x.__value_constructed = false;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator()(pointer __p) _NOEXCEPT\x0a"
"    {\x0a"
"        if (__second_constructed)\x0a"
"            __alloc_traits\x3a\x3a""destroy(__na_, _VSTD\x3a\x3a""addressof(__p->__value_.__get_value().second));\x0a"
"        if (__first_constructed)\x0a"
"            __alloc_traits\x3a\x3a""destroy(__na_, _VSTD\x3a\x3a""addressof(__p->__value_.__get_value().first));\x0a"
"        if (__p)\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__na_, __p, 1);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"    class map;\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"    class multimap;\x0a"
"template <class _TreeIterator> class __map_const_iterator;\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Tp>\x0a"
"struct __value_type\x0a"
"{\x0a"
"    typedef _Key                                     key_type;\x0a"
"    typedef _Tp                                      mapped_type;\x0a"
"    typedef pair<const key_type, mapped_type>        value_type;\x0a"
"    typedef pair<key_type\x26, mapped_type\x26>            __nc_ref_pair_type;\x0a"
"    typedef pair<key_type\x26\x26, mapped_type\x26\x26>          __nc_rref_pair_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    value_type __cc;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type\x26 __get_value()\x0a"
"    {\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        return *_VSTD\x3a\x3alaunder(_VSTD\x3a\x3a""addressof(__cc));\x0a"
"#else\x0a"
"        return __cc;\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type\x26 __get_value() const\x0a"
"    {\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        return *_VSTD\x3a\x3alaunder(_VSTD\x3a\x3a""addressof(__cc));\x0a"
"#else\x0a"
"        return __cc;\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __nc_ref_pair_type __ref()\x0a"
"    {\x0a"
"        value_type\x26 __v = __get_value();\x0a"
"        return __nc_ref_pair_type(const_cast<key_type\x26>(__v.first), __v.second);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __nc_rref_pair_type __move()\x0a"
"    {\x0a"
"        value_type\x26 __v = __get_value();\x0a"
"        return __nc_rref_pair_type(\x0a"
"            _VSTD\x3a\x3amove(const_cast<key_type\x26>(__v.first)),\x0a"
"            _VSTD\x3a\x3amove(__v.second));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __value_type\x26 operator=(const __value_type\x26 __v)\x0a"
"    {\x0a"
"        __ref() = __v.__get_value();\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __value_type\x26 operator=(__value_type\x26\x26 __v)\x0a"
"    {\x0a"
"        __ref() = __v.__move();\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    template <class _ValueTp,\x0a"
"              class = typename enable_if<\x0a"
"                    __is_same_uncvref<_ValueTp, value_type>\x3a\x3avalue\x0a"
"                 >\x3a\x3atype\x0a"
"             >\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __value_type\x26 operator=(_ValueTp\x26\x26 __v)\x0a"
"    {\x0a"
"        __ref() = _VSTD\x3a\x3a""forward<_ValueTp>(__v);\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    __value_type() _LIBCPP_EQUAL_DELETE;\x0a"
"    \x7e__value_type() _LIBCPP_EQUAL_DELETE;\x0a"
"    __value_type(const __value_type\x26 __v) _LIBCPP_EQUAL_DELETE;\x0a"
"    __value_type(__value_type\x26\x26 __v) _LIBCPP_EQUAL_DELETE;\x0a"
"};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Key, class _Tp>\x0a"
"struct __value_type\x0a"
"{\x0a"
"    typedef _Key                                     key_type;\x0a"
"    typedef _Tp                                      mapped_type;\x0a"
"    typedef pair<const key_type, mapped_type>        value_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    value_type __cc;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type\x26 __get_value() { return __cc; }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type\x26 __get_value() const { return __cc; }\x0a"
"\x0a"
"private\x3a\x0a"
"   __value_type();\x0a"
"   __value_type(__value_type const\x26);\x0a"
"   __value_type\x26 operator=(__value_type const\x26);\x0a"
"   \x7e__value_type();\x0a"
"};\x0a"
"\x0a"
"#endif // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __extract_key_value_types;\x0a"
"\x0a"
"template <class _Key, class _Tp>\x0a"
"struct __extract_key_value_types<__value_type<_Key, _Tp> >\x0a"
"{\x0a"
"  typedef _Key const __key_type;\x0a"
"  typedef _Tp        __mapped_type;\x0a"
"};\x0a"
"\x0a"
"template <class _TreeIterator>\x0a"
"class _LIBCPP_TEMPLATE_VIS __map_iterator\x0a"
"{\x0a"
"    typedef typename _TreeIterator\x3a\x3a_NodeTypes                   _NodeTypes;\x0a"
"    typedef typename _TreeIterator\x3a\x3a__pointer_traits             __pointer_traits;\x0a"
"\x0a"
"    _TreeIterator __i_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef bidirectional_iterator_tag                           iterator_category;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__map_value_type                value_type;\x0a"
"    typedef typename _TreeIterator\x3a\x3a""difference_type              difference_type;\x0a"
"    typedef value_type\x26                                          reference;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__map_value_type_pointer        pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_iterator() _NOEXCEPT {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_iterator(_TreeIterator __i) _NOEXCEPT \x3a __i_(__i) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator*() const {return __i_->__get_value();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const {return pointer_traits<pointer>\x3a\x3apointer_to(__i_->__get_value());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_iterator\x26 operator++() {++__i_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_iterator operator++(int)\x0a"
"    {\x0a"
"        __map_iterator __t(*this);\x0a"
"        ++(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_iterator\x26 operator--() {--__i_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_iterator operator--(int)\x0a"
"    {\x0a"
"        __map_iterator __t(*this);\x0a"
"        --(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const __map_iterator\x26 __x, const __map_iterator\x26 __y)\x0a"
"        {return __x.__i_ == __y.__i_;}\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const __map_iterator\x26 __x, const __map_iterator\x26 __y)\x0a"
"        {return __x.__i_ \x21= __y.__i_;}\x0a"
"\x0a"
"    template <class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS map;\x0a"
"    template <class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS multimap;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __map_const_iterator;\x0a"
"};\x0a"
"\x0a"
"template <class _TreeIterator>\x0a"
"class _LIBCPP_TEMPLATE_VIS __map_const_iterator\x0a"
"{\x0a"
"    typedef typename _TreeIterator\x3a\x3a_NodeTypes                   _NodeTypes;\x0a"
"    typedef typename _TreeIterator\x3a\x3a__pointer_traits             __pointer_traits;\x0a"
"\x0a"
"    _TreeIterator __i_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef bidirectional_iterator_tag                           iterator_category;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__map_value_type                value_type;\x0a"
"    typedef typename _TreeIterator\x3a\x3a""difference_type              difference_type;\x0a"
"    typedef const value_type\x26                                    reference;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__const_map_value_type_pointer  pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_const_iterator() _NOEXCEPT {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_const_iterator(_TreeIterator __i) _NOEXCEPT \x3a __i_(__i) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_const_iterator(__map_iterator<\x0a"
"        typename _TreeIterator\x3a\x3a__non_const_iterator> __i) _NOEXCEPT\x0a"
"        \x3a __i_(__i.__i_) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator*() const {return __i_->__get_value();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const {return pointer_traits<pointer>\x3a\x3apointer_to(__i_->__get_value());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_const_iterator\x26 operator++() {++__i_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_const_iterator operator++(int)\x0a"
"    {\x0a"
"        __map_const_iterator __t(*this);\x0a"
"        ++(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_const_iterator\x26 operator--() {--__i_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __map_const_iterator operator--(int)\x0a"
"    {\x0a"
"        __map_const_iterator __t(*this);\x0a"
"        --(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const __map_const_iterator\x26 __x, const __map_const_iterator\x26 __y)\x0a"
"        {return __x.__i_ == __y.__i_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const __map_const_iterator\x26 __x, const __map_const_iterator\x26 __y)\x0a"
"        {return __x.__i_ \x21= __y.__i_;}\x0a"
"\x0a"
"    template <class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS map;\x0a"
"    template <class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS multimap;\x0a"
"    template <class, class, class> friend class _LIBCPP_TEMPLATE_VIS __tree_const_iterator;\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare = less<_Key>,\x0a"
"          class _Allocator = allocator<pair<const _Key, _Tp> > >\x0a"
"class _LIBCPP_TEMPLATE_VIS map\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef _Key                                     key_type;\x0a"
"    typedef _Tp                                      mapped_type;\x0a"
"    typedef pair<const key_type, mapped_type>        value_type;\x0a"
"    typedef typename __identity<_Compare>\x3a\x3atype      key_compare;\x0a"
"    typedef typename __identity<_Allocator>\x3a\x3atype    allocator_type;\x0a"
"    typedef value_type\x26                              reference;\x0a"
"    typedef const value_type\x26                        const_reference;\x0a"
"\x0a"
"    static_assert((is_same<typename allocator_type\x3a\x3avalue_type, value_type>\x3a\x3avalue),\x0a"
"                  \x22""Allocator\x3a\x3avalue_type must be same type as value_type\x22);\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS value_compare\x0a"
"        \x3a public binary_function<value_type, value_type, bool>\x0a"
"    {\x0a"
"        friend class map;\x0a"
"    protected\x3a\x0a"
"        key_compare comp;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY value_compare(key_compare c) \x3a comp(c) {}\x0a"
"    public\x3a\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator()(const value_type\x26 __x, const value_type\x26 __y) const\x0a"
"            {return comp(__x.first, __y.first);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"    typedef _VSTD\x3a\x3a__value_type<key_type, mapped_type>             __value_type;\x0a"
"    typedef __map_value_compare<key_type, __value_type, key_compare> __vc;\x0a"
"    typedef typename __rebind_alloc_helper<allocator_traits<allocator_type>,\x0a"
"                                                 __value_type>\x3a\x3atype __allocator_type;\x0a"
"    typedef __tree<__value_type, __vc, __allocator_type>   __base;\x0a"
"    typedef typename __base\x3a\x3a__node_traits                 __node_traits;\x0a"
"    typedef allocator_traits<allocator_type>               __alloc_traits;\x0a"
"\x0a"
"    __base __tree_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer               pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer         const_pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3asize_type             size_type;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""difference_type       difference_type;\x0a"
"    typedef __map_iterator<typename __base\x3a\x3aiterator>             iterator;\x0a"
"    typedef __map_const_iterator<typename __base\x3a\x3a""const_iterator> const_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<iterator>               reverse_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<const_iterator>         const_reverse_iterator;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    typedef __map_node_handle<typename __base\x3a\x3a__node, allocator_type> node_type;\x0a"
"    typedef __insert_return_type<iterator, node_type> insert_return_type;\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Key2, class _Value2, class _Comp2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS map;\x0a"
"    template <class _Key2, class _Value2, class _Comp2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS multimap;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map()\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_compare>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue)\x0a"
"        \x3a __tree_(__vc(key_compare())) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit map(const key_compare\x26 __comp)\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue)\x0a"
"        \x3a __tree_(__vc(__comp)) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit map(const key_compare\x26 __comp, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__vc(__comp), typename __base\x3a\x3a""allocator_type(__a)) {}\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        map(_InputIterator __f, _InputIterator __l,\x0a"
"            const key_compare\x26 __comp = key_compare())\x0a"
"        \x3a __tree_(__vc(__comp))\x0a"
"        {\x0a"
"            insert(__f, __l);\x0a"
"        }\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        map(_InputIterator __f, _InputIterator __l,\x0a"
"            const key_compare\x26 __comp, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__vc(__comp), typename __base\x3a\x3a""allocator_type(__a))\x0a"
"        {\x0a"
"            insert(__f, __l);\x0a"
"        }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <class _InputIterator>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map(_InputIterator __f, _InputIterator __l, const allocator_type\x26 __a)\x0a"
"        \x3a map(__f, __l, key_compare(), __a) {}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map(const map\x26 __m)\x0a"
"        \x3a __tree_(__m.__tree_)\x0a"
"        {\x0a"
"            insert(__m.begin(), __m.end());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map\x26 operator=(const map\x26 __m)\x0a"
"        {\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"            __tree_ = __m.__tree_;\x0a"
"#else\x0a"
"            if (this \x21= \x26__m) {\x0a"
"                __tree_.clear();\x0a"
"                __tree_.value_comp() = __m.__tree_.value_comp();\x0a"
"                __tree_.__copy_assign_alloc(__m.__tree_);\x0a"
"                insert(__m.begin(), __m.end());\x0a"
"            }\x0a"
"#endif\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map(map\x26\x26 __m)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__base>\x3a\x3avalue)\x0a"
"        \x3a __tree_(_VSTD\x3a\x3amove(__m.__tree_))\x0a"
"        {\x0a"
"        }\x0a"
"\x0a"
"    map(map\x26\x26 __m, const allocator_type\x26 __a);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map\x26 operator=(map\x26\x26 __m)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__base>\x3a\x3avalue)\x0a"
"        {\x0a"
"            __tree_ = _VSTD\x3a\x3amove(__m.__tree_);\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map(initializer_list<value_type> __il, const key_compare\x26 __comp = key_compare())\x0a"
"        \x3a __tree_(__vc(__comp))\x0a"
"        {\x0a"
"            insert(__il.begin(), __il.end());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map(initializer_list<value_type> __il, const key_compare\x26 __comp, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__vc(__comp), typename __base\x3a\x3a""allocator_type(__a))\x0a"
"        {\x0a"
"            insert(__il.begin(), __il.end());\x0a"
"        }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map(initializer_list<value_type> __il, const allocator_type\x26 __a)\x0a"
"        \x3a map(__il, key_compare(), __a) {}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map\x26 operator=(initializer_list<value_type> __il)\x0a"
"        {\x0a"
"            __tree_.__assign_unique(__il.begin(), __il.end());\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit map(const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(typename __base\x3a\x3a""allocator_type(__a))\x0a"
"        {\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    map(const map\x26 __m, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__m.__tree_.value_comp(), typename __base\x3a\x3a""allocator_type(__a))\x0a"
"        {\x0a"
"            insert(__m.begin(), __m.end());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7emap() {\x0a"
"        static_assert(sizeof(__diagnose_non_const_comparator<_Key, _Compare>()), \x22\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator begin() _NOEXCEPT {return __tree_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT {return __tree_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator end() _NOEXCEPT {return __tree_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end() const _NOEXCEPT {return __tree_.end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          reverse_iterator rbegin() _NOEXCEPT {return reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          reverse_iterator rend() _NOEXCEPT\x0a"
"            {return       reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const _NOEXCEPT {return begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend() const _NOEXCEPT {return end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT {return rbegin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend() const _NOEXCEPT {return rend();}\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool      empty() const _NOEXCEPT {return __tree_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT {return __tree_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT {return __tree_.max_size();}\x0a"
"\x0a"
"    mapped_type\x26 operator\x5b\x5d(const key_type\x26 __k);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    mapped_type\x26 operator\x5b\x5d(key_type\x26\x26 __k);\x0a"
"#endif\x0a"
"\x0a"
"          mapped_type\x26 at(const key_type\x26 __k);\x0a"
"    const mapped_type\x26 at(const key_type\x26 __k) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT {return allocator_type(__tree_.__alloc());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_compare    key_comp()      const {return __tree_.value_comp().key_comp();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_compare  value_comp()    const {return value_compare(__tree_.value_comp().key_comp());}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class ..._Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> emplace(_Args\x26\x26 ...__args) {\x0a"
"        return __tree_.__emplace_unique(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator emplace_hint(const_iterator __p, _Args\x26\x26 ...__args) {\x0a"
"        return __tree_.__emplace_hint_unique(__p.__i_, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    template <class _Pp,\x0a"
"              class = typename enable_if<is_constructible<value_type, _Pp>\x3a\x3avalue>\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> insert(_Pp\x26\x26 __p)\x0a"
"            {return __tree_.__insert_unique(_VSTD\x3a\x3a""forward<_Pp>(__p));}\x0a"
"\x0a"
"    template <class _Pp,\x0a"
"              class = typename enable_if<is_constructible<value_type, _Pp>\x3a\x3avalue>\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator insert(const_iterator __pos, _Pp\x26\x26 __p)\x0a"
"            {return __tree_.__insert_unique(__pos.__i_, _VSTD\x3a\x3a""forward<_Pp>(__p));}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool>\x0a"
"        insert(const value_type\x26 __v) {return __tree_.__insert_unique(__v);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator\x0a"
"        insert(const_iterator __p, const value_type\x26 __v)\x0a"
"            {return __tree_.__insert_unique(__p.__i_, __v);}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool>\x0a"
"    insert(value_type\x26\x26 __v) {return __tree_.__insert_unique(_VSTD\x3a\x3amove(__v));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p,  value_type\x26\x26 __v)\x0a"
"    {return __tree_.__insert_unique(__p.__i_, _VSTD\x3a\x3amove(__v));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(initializer_list<value_type> __il)\x0a"
"        {insert(__il.begin(), __il.end());}\x0a"
"#endif\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __f, _InputIterator __l)\x0a"
"        {\x0a"
"            for (const_iterator __e = cend(); __f \x21= __l; ++__f)\x0a"
"                insert(__e.__i_, *__f);\x0a"
"        }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> try_emplace(const key_type\x26 __k, _Args\x26\x26... __args)\x0a"
"    {\x0a"
"        return __tree_.__emplace_unique_key_args(__k,\x0a"
"            _VSTD\x3a\x3apiecewise_construct,\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(__k),\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Args>(__args)...));\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> try_emplace(key_type\x26\x26 __k, _Args\x26\x26... __args)\x0a"
"    {\x0a"
"        return __tree_.__emplace_unique_key_args(__k,\x0a"
"            _VSTD\x3a\x3apiecewise_construct,\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3amove(__k)),\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Args>(__args)...));\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator try_emplace(const_iterator __h, const key_type\x26 __k, _Args\x26\x26... __args)\x0a"
"    {\x0a"
"        return __tree_.__emplace_hint_unique_key_args(__h.__i_, __k,\x0a"
"            _VSTD\x3a\x3apiecewise_construct,\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(__k),\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Args>(__args)...));\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator try_emplace(const_iterator __h, key_type\x26\x26 __k, _Args\x26\x26... __args)\x0a"
"    {\x0a"
"        return __tree_.__emplace_hint_unique_key_args(__h.__i_, __k,\x0a"
"            _VSTD\x3a\x3apiecewise_construct,\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3amove(__k)),\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Args>(__args)...));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Vp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> insert_or_assign(const key_type\x26 __k, _Vp\x26\x26 __v)\x0a"
"    {\x0a"
"        iterator __p = lower_bound(__k);\x0a"
"        if ( __p \x21= end() \x26\x26 \x21key_comp()(__k, __p->first))\x0a"
"        {\x0a"
"            __p->second = _VSTD\x3a\x3a""forward<_Vp>(__v);\x0a"
"            return _VSTD\x3a\x3amake_pair(__p, false);\x0a"
"        }\x0a"
"        return _VSTD\x3a\x3amake_pair(emplace_hint(__p, __k, _VSTD\x3a\x3a""forward<_Vp>(__v)), true);\x0a"
"    }\x0a"
"\x0a"
"    template <class _Vp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> insert_or_assign(key_type\x26\x26 __k, _Vp\x26\x26 __v)\x0a"
"    {\x0a"
"        iterator __p = lower_bound(__k);\x0a"
"        if ( __p \x21= end() \x26\x26 \x21key_comp()(__k, __p->first))\x0a"
"        {\x0a"
"            __p->second = _VSTD\x3a\x3a""forward<_Vp>(__v);\x0a"
"            return _VSTD\x3a\x3amake_pair(__p, false);\x0a"
"        }\x0a"
"        return _VSTD\x3a\x3amake_pair(emplace_hint(__p, _VSTD\x3a\x3amove(__k), _VSTD\x3a\x3a""forward<_Vp>(__v)), true);\x0a"
"    }\x0a"
"\x0a"
"    template <class _Vp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator insert_or_assign(const_iterator __h, const key_type\x26 __k, _Vp\x26\x26 __v)\x0a"
"     {\x0a"
"        iterator __p = lower_bound(__k);\x0a"
"        if ( __p \x21= end() \x26\x26 \x21key_comp()(__k, __p->first))\x0a"
"        {\x0a"
"            __p->second = _VSTD\x3a\x3a""forward<_Vp>(__v);\x0a"
"            return __p;\x0a"
"        }\x0a"
"        return emplace_hint(__h, __k, _VSTD\x3a\x3a""forward<_Vp>(__v));\x0a"
"     }\x0a"
"\x0a"
"    template <class _Vp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator insert_or_assign(const_iterator __h, key_type\x26\x26 __k, _Vp\x26\x26 __v)\x0a"
"     {\x0a"
"        iterator __p = lower_bound(__k);\x0a"
"        if ( __p \x21= end() \x26\x26 \x21key_comp()(__k, __p->first))\x0a"
"        {\x0a"
"            __p->second = _VSTD\x3a\x3a""forward<_Vp>(__v);\x0a"
"            return __p;\x0a"
"        }\x0a"
"        return emplace_hint(__h, _VSTD\x3a\x3amove(__k), _VSTD\x3a\x3a""forward<_Vp>(__v));\x0a"
"     }\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(const_iterator __p) {return __tree_.erase(__p.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(iterator __p)       {return __tree_.erase(__p.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k)\x0a"
"        {return __tree_.__erase_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator  erase(const_iterator __f, const_iterator __l)\x0a"
"        {return __tree_.erase(__f.__i_, __l.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {__tree_.clear();}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    insert_return_type insert(node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to map\x3a\x3ainsert()\x22);\x0a"
"        return __tree_.template __node_handle_insert_unique<\x0a"
"            node_type, insert_return_type>(_VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __hint, node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to map\x3a\x3ainsert()\x22);\x0a"
"        return __tree_.template __node_handle_insert_unique<node_type>(\x0a"
"            __hint.__i_, _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(key_type const\x26 __key)\x0a"
"    {\x0a"
"        return __tree_.template __node_handle_extract<node_type>(__key);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(const_iterator __it)\x0a"
"    {\x0a"
"        return __tree_.template __node_handle_extract<node_type>(__it.__i_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(map<key_type, mapped_type, _Compare2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_unique(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(map<key_type, mapped_type, _Compare2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_unique(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(multimap<key_type, mapped_type, _Compare2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_unique(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(multimap<key_type, mapped_type, _Compare2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_unique(__source.__tree_);\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(map\x26 __m)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<__base>\x3a\x3avalue)\x0a"
"        {__tree_.swap(__m.__tree_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator find(const key_type\x26 __k)             {return __tree_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __tree_.find(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    find(const _K2\x26 __k)                           {return __tree_.find(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    find(const _K2\x26 __k) const                     {return __tree_.find(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type      count(const key_type\x26 __k) const\x0a"
"        {return __tree_.__count_unique(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,size_type>\x3a\x3atype\x0a"
"    count(const _K2\x26 __k) const {return __tree_.__count_multi(__k);}\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool contains(const key_type\x26 __k) const {return find(__k) \x21= end();}\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator lower_bound(const key_type\x26 __k)\x0a"
"        {return __tree_.lower_bound(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator lower_bound(const key_type\x26 __k) const\x0a"
"        {return __tree_.lower_bound(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    lower_bound(const _K2\x26 __k)       {return __tree_.lower_bound(__k);}\x0a"
"\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    lower_bound(const _K2\x26 __k) const {return __tree_.lower_bound(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator upper_bound(const key_type\x26 __k)\x0a"
"        {return __tree_.upper_bound(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator upper_bound(const key_type\x26 __k) const\x0a"
"        {return __tree_.upper_bound(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    upper_bound(const _K2\x26 __k)       {return __tree_.upper_bound(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    upper_bound(const _K2\x26 __k) const {return __tree_.upper_bound(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator,iterator> equal_range(const key_type\x26 __k)\x0a"
"        {return __tree_.__equal_range_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<const_iterator,const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"        {return __tree_.__equal_range_unique(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,pair<iterator,iterator>>\x3a\x3atype\x0a"
"    equal_range(const _K2\x26 __k)       {return __tree_.__equal_range_multi(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,pair<const_iterator,const_iterator>>\x3a\x3atype\x0a"
"    equal_range(const _K2\x26 __k) const {return __tree_.__equal_range_multi(__k);}\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef typename __base\x3a\x3a__node                    __node;\x0a"
"    typedef typename __base\x3a\x3a__node_allocator          __node_allocator;\x0a"
"    typedef typename __base\x3a\x3a__node_pointer            __node_pointer;\x0a"
"    typedef typename __base\x3a\x3a__node_base_pointer       __node_base_pointer;\x0a"
"    typedef typename __base\x3a\x3a__parent_pointer          __parent_pointer;\x0a"
"\x0a"
"    typedef __map_node_destructor<__node_allocator> _Dp;\x0a"
"    typedef unique_ptr<__node, _Dp> __node_holder;\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    __node_holder __construct_node_with_key(const key_type\x26 __k);\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator, class _Compare = less<__iter_key_type<_InputIterator>>,\x0a"
"         class _Allocator = allocator<__iter_to_alloc_type<_InputIterator>>,\x0a"
"         class = enable_if_t<\x21__is_allocator<_Compare>\x3a\x3avalue, void>,\x0a"
"         class = enable_if_t<__is_allocator<_Allocator>\x3a\x3avalue, void>>\x0a"
"map(_InputIterator, _InputIterator, _Compare = _Compare(), _Allocator = _Allocator())\x0a"
"  -> map<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>, _Compare, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Compare = less<remove_const_t<_Key>>,\x0a"
"         class _Allocator = allocator<pair<const _Key, _Tp>>,\x0a"
"         class = enable_if_t<\x21__is_allocator<_Compare>\x3a\x3avalue, void>,\x0a"
"         class = enable_if_t<__is_allocator<_Allocator>\x3a\x3avalue, void>>\x0a"
"map(initializer_list<pair<_Key, _Tp>>, _Compare = _Compare(), _Allocator = _Allocator())\x0a"
"  -> map<remove_const_t<_Key>, _Tp, _Compare, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Allocator,\x0a"
"         class = enable_if_t<__is_allocator<_Allocator>\x3a\x3avalue, void>>\x0a"
"map(_InputIterator, _InputIterator, _Allocator)\x0a"
"  -> map<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>,\x0a"
"         less<__iter_key_type<_InputIterator>>, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Allocator,\x0a"
"         class = enable_if_t<__is_allocator<_Allocator>\x3a\x3avalue, void>>\x0a"
"map(initializer_list<pair<_Key, _Tp>>, _Allocator)\x0a"
"  -> map<remove_const_t<_Key>, _Tp, less<remove_const_t<_Key>>, _Allocator>;\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"map<_Key, _Tp, _Compare, _Allocator>\x3a\x3amap(map\x26\x26 __m, const allocator_type\x26 __a)\x0a"
"    \x3a __tree_(_VSTD\x3a\x3amove(__m.__tree_), typename __base\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"    if (__a \x21= __m.get_allocator())\x0a"
"    {\x0a"
"        const_iterator __e = cend();\x0a"
"        while (\x21__m.empty())\x0a"
"            __tree_.__insert_unique(__e.__i_,\x0a"
"                    __m.__tree_.remove(__m.begin().__i_)->__value_.__move());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"_Tp\x26\x0a"
"map<_Key, _Tp, _Compare, _Allocator>\x3a\x3aoperator\x5b\x5d(const key_type\x26 __k)\x0a"
"{\x0a"
"    return __tree_.__emplace_unique_key_args(__k,\x0a"
"        _VSTD\x3a\x3apiecewise_construct,\x0a"
"        _VSTD\x3a\x3a""forward_as_tuple(__k),\x0a"
"        _VSTD\x3a\x3a""forward_as_tuple()).first->__get_value().second;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"_Tp\x26\x0a"
"map<_Key, _Tp, _Compare, _Allocator>\x3a\x3aoperator\x5b\x5d(key_type\x26\x26 __k)\x0a"
"{\x0a"
"    return __tree_.__emplace_unique_key_args(__k,\x0a"
"        _VSTD\x3a\x3apiecewise_construct,\x0a"
"        _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3amove(__k)),\x0a"
"        _VSTD\x3a\x3a""forward_as_tuple()).first->__get_value().second;\x0a"
"}\x0a"
"\x0a"
"#else // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"typename map<_Key, _Tp, _Compare, _Allocator>\x3a\x3a__node_holder\x0a"
"map<_Key, _Tp, _Compare, _Allocator>\x3a\x3a__construct_node_with_key(const key_type\x26 __k)\x0a"
"{\x0a"
"    __node_allocator\x26 __na = __tree_.__node_alloc();\x0a"
"    __node_holder __h(__node_traits\x3a\x3a""allocate(__na, 1), _Dp(__na));\x0a"
"    __node_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__h->__value_.__get_value().first), __k);\x0a"
"    __h.get_deleter().__first_constructed = true;\x0a"
"    __node_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__h->__value_.__get_value().second));\x0a"
"    __h.get_deleter().__second_constructed = true;\x0a"
"    return _LIBCPP_EXPLICIT_MOVE(__h);  // explicitly moved for C++03\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"_Tp\x26\x0a"
"map<_Key, _Tp, _Compare, _Allocator>\x3a\x3aoperator\x5b\x5d(const key_type\x26 __k)\x0a"
"{\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __tree_.__find_equal(__parent, __k);\x0a"
"    __node_pointer __r = static_cast<__node_pointer>(__child);\x0a"
"    if (__child == nullptr)\x0a"
"    {\x0a"
"        __node_holder __h = __construct_node_with_key(__k);\x0a"
"        __tree_.__insert_node_at(__parent, __child, static_cast<__node_base_pointer>(__h.get()));\x0a"
"        __r = __h.release();\x0a"
"    }\x0a"
"    return __r->__value_.__get_value().second;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"_Tp\x26\x0a"
"map<_Key, _Tp, _Compare, _Allocator>\x3a\x3a""at(const key_type\x26 __k)\x0a"
"{\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer\x26 __child = __tree_.__find_equal(__parent, __k);\x0a"
"    if (__child == nullptr)\x0a"
"        __throw_out_of_range(\x22map\x3a\x3a""at\x3a  key not found\x22);\x0a"
"    return static_cast<__node_pointer>(__child)->__value_.__get_value().second;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"const _Tp\x26\x0a"
"map<_Key, _Tp, _Compare, _Allocator>\x3a\x3a""at(const key_type\x26 __k) const\x0a"
"{\x0a"
"    __parent_pointer __parent;\x0a"
"    __node_base_pointer __child = __tree_.__find_equal(__parent, __k);\x0a"
"    if (__child == nullptr)\x0a"
"        __throw_out_of_range(\x22map\x3a\x3a""at\x3a  key not found\x22);\x0a"
"    return static_cast<__node_pointer>(__child)->__value_.__get_value().second;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const map<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const map<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return __x.size() == __y.size() \x26\x26 _VSTD\x3a\x3a""equal(__x.begin(), __x.end(), __y.begin());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const map<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const map<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alexicographical_compare(__x.begin(), __x.end(), __y.begin(), __y.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const map<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const map<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const map<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const map<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const map<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const map<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const map<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const map<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(map<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"     map<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(map<_Key, _Tp, _Compare, _Allocator>\x26 __c, _Predicate __pred)\x0a"
"{ __libcpp_erase_if_container(__c, __pred); }\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare = less<_Key>,\x0a"
"          class _Allocator = allocator<pair<const _Key, _Tp> > >\x0a"
"class _LIBCPP_TEMPLATE_VIS multimap\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef _Key                                     key_type;\x0a"
"    typedef _Tp                                      mapped_type;\x0a"
"    typedef pair<const key_type, mapped_type>        value_type;\x0a"
"    typedef typename __identity<_Compare>\x3a\x3atype      key_compare;\x0a"
"    typedef typename __identity<_Allocator>\x3a\x3atype    allocator_type;\x0a"
"    typedef value_type\x26                              reference;\x0a"
"    typedef const value_type\x26                        const_reference;\x0a"
"\x0a"
"    static_assert((is_same<typename allocator_type\x3a\x3avalue_type, value_type>\x3a\x3avalue),\x0a"
"                  \x22""Allocator\x3a\x3avalue_type must be same type as value_type\x22);\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS value_compare\x0a"
"        \x3a public binary_function<value_type, value_type, bool>\x0a"
"    {\x0a"
"        friend class multimap;\x0a"
"    protected\x3a\x0a"
"        key_compare comp;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        value_compare(key_compare c) \x3a comp(c) {}\x0a"
"    public\x3a\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator()(const value_type\x26 __x, const value_type\x26 __y) const\x0a"
"            {return comp(__x.first, __y.first);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"    typedef _VSTD\x3a\x3a__value_type<key_type, mapped_type>             __value_type;\x0a"
"    typedef __map_value_compare<key_type, __value_type, key_compare> __vc;\x0a"
"    typedef typename __rebind_alloc_helper<allocator_traits<allocator_type>,\x0a"
"                                                 __value_type>\x3a\x3atype __allocator_type;\x0a"
"    typedef __tree<__value_type, __vc, __allocator_type>            __base;\x0a"
"    typedef typename __base\x3a\x3a__node_traits                          __node_traits;\x0a"
"    typedef allocator_traits<allocator_type>                        __alloc_traits;\x0a"
"\x0a"
"    __base __tree_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer               pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer         const_pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3asize_type             size_type;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""difference_type       difference_type;\x0a"
"    typedef __map_iterator<typename __base\x3a\x3aiterator>      iterator;\x0a"
"    typedef __map_const_iterator<typename __base\x3a\x3a""const_iterator> const_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<iterator>               reverse_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<const_iterator>         const_reverse_iterator;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    typedef __map_node_handle<typename __base\x3a\x3a__node, allocator_type> node_type;\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Key2, class _Value2, class _Comp2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS map;\x0a"
"    template <class _Key2, class _Value2, class _Comp2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS multimap;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap()\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_compare>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue)\x0a"
"        \x3a __tree_(__vc(key_compare())) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit multimap(const key_compare\x26 __comp)\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue)\x0a"
"        \x3a __tree_(__vc(__comp)) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit multimap(const key_compare\x26 __comp, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__vc(__comp), typename __base\x3a\x3a""allocator_type(__a)) {}\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        multimap(_InputIterator __f, _InputIterator __l,\x0a"
"            const key_compare\x26 __comp = key_compare())\x0a"
"        \x3a __tree_(__vc(__comp))\x0a"
"        {\x0a"
"            insert(__f, __l);\x0a"
"        }\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        multimap(_InputIterator __f, _InputIterator __l,\x0a"
"            const key_compare\x26 __comp, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__vc(__comp), typename __base\x3a\x3a""allocator_type(__a))\x0a"
"        {\x0a"
"            insert(__f, __l);\x0a"
"        }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <class _InputIterator>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap(_InputIterator __f, _InputIterator __l, const allocator_type\x26 __a)\x0a"
"        \x3a multimap(__f, __l, key_compare(), __a) {}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap(const multimap\x26 __m)\x0a"
"        \x3a __tree_(__m.__tree_.value_comp(),\x0a"
"          __alloc_traits\x3a\x3aselect_on_container_copy_construction(__m.__tree_.__alloc()))\x0a"
"        {\x0a"
"            insert(__m.begin(), __m.end());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap\x26 operator=(const multimap\x26 __m)\x0a"
"        {\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"            __tree_ = __m.__tree_;\x0a"
"#else\x0a"
"            if (this \x21= \x26__m) {\x0a"
"                __tree_.clear();\x0a"
"                __tree_.value_comp() = __m.__tree_.value_comp();\x0a"
"                __tree_.__copy_assign_alloc(__m.__tree_);\x0a"
"                insert(__m.begin(), __m.end());\x0a"
"            }\x0a"
"#endif\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap(multimap\x26\x26 __m)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__base>\x3a\x3avalue)\x0a"
"        \x3a __tree_(_VSTD\x3a\x3amove(__m.__tree_))\x0a"
"        {\x0a"
"        }\x0a"
"\x0a"
"    multimap(multimap\x26\x26 __m, const allocator_type\x26 __a);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap\x26 operator=(multimap\x26\x26 __m)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__base>\x3a\x3avalue)\x0a"
"        {\x0a"
"            __tree_ = _VSTD\x3a\x3amove(__m.__tree_);\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap(initializer_list<value_type> __il, const key_compare\x26 __comp = key_compare())\x0a"
"        \x3a __tree_(__vc(__comp))\x0a"
"        {\x0a"
"            insert(__il.begin(), __il.end());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap(initializer_list<value_type> __il, const key_compare\x26 __comp, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__vc(__comp), typename __base\x3a\x3a""allocator_type(__a))\x0a"
"        {\x0a"
"            insert(__il.begin(), __il.end());\x0a"
"        }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap(initializer_list<value_type> __il, const allocator_type\x26 __a)\x0a"
"        \x3a multimap(__il, key_compare(), __a) {}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap\x26 operator=(initializer_list<value_type> __il)\x0a"
"        {\x0a"
"            __tree_.__assign_multi(__il.begin(), __il.end());\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit multimap(const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(typename __base\x3a\x3a""allocator_type(__a))\x0a"
"        {\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multimap(const multimap\x26 __m, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__m.__tree_.value_comp(), typename __base\x3a\x3a""allocator_type(__a))\x0a"
"        {\x0a"
"            insert(__m.begin(), __m.end());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7emultimap() {\x0a"
"        static_assert(sizeof(__diagnose_non_const_comparator<_Key, _Compare>()), \x22\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator begin() _NOEXCEPT {return __tree_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT {return __tree_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator end() _NOEXCEPT {return __tree_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end() const _NOEXCEPT {return __tree_.end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          reverse_iterator rbegin() _NOEXCEPT {return reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          reverse_iterator rend() _NOEXCEPT {return reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin()  const _NOEXCEPT {return begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend() const _NOEXCEPT {return end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT {return rbegin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend() const _NOEXCEPT {return rend();}\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT {return __tree_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT {return __tree_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT {return __tree_.max_size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT {return allocator_type(__tree_.__alloc());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_compare    key_comp() const {return __tree_.value_comp().key_comp();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_compare  value_comp() const\x0a"
"        {return value_compare(__tree_.value_comp().key_comp());}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator emplace(_Args\x26\x26 ...__args) {\x0a"
"        return __tree_.__emplace_multi(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator emplace_hint(const_iterator __p, _Args\x26\x26 ...__args) {\x0a"
"        return __tree_.__emplace_hint_multi(__p.__i_, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    template <class _Pp,\x0a"
"              class = typename enable_if<is_constructible<value_type, _Pp>\x3a\x3avalue>\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator insert(_Pp\x26\x26 __p)\x0a"
"            {return __tree_.__insert_multi(_VSTD\x3a\x3a""forward<_Pp>(__p));}\x0a"
"\x0a"
"    template <class _Pp,\x0a"
"              class = typename enable_if<is_constructible<value_type, _Pp>\x3a\x3avalue>\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator insert(const_iterator __pos, _Pp\x26\x26 __p)\x0a"
"            {return __tree_.__insert_multi(__pos.__i_, _VSTD\x3a\x3a""forward<_Pp>(__p));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(value_type\x26\x26 __v)\x0a"
"        {return __tree_.__insert_multi(_VSTD\x3a\x3amove(__v));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, value_type\x26\x26 __v)\x0a"
"        {return __tree_.__insert_multi(__p.__i_, _VSTD\x3a\x3amove(__v));}\x0a"
"\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(initializer_list<value_type> __il)\x0a"
"        {insert(__il.begin(), __il.end());}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const value_type\x26 __v) {return __tree_.__insert_multi(__v);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, const value_type\x26 __v)\x0a"
"            {return __tree_.__insert_multi(__p.__i_, __v);}\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __f, _InputIterator __l)\x0a"
"        {\x0a"
"            for (const_iterator __e = cend(); __f \x21= __l; ++__f)\x0a"
"                __tree_.__insert_multi(__e.__i_, *__f);\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(const_iterator __p) {return __tree_.erase(__p.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(iterator __p)       {return __tree_.erase(__p.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k) {return __tree_.__erase_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator  erase(const_iterator __f, const_iterator __l)\x0a"
"        {return __tree_.erase(__f.__i_, __l.__i_);}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to multimap\x3a\x3ainsert()\x22);\x0a"
"        return __tree_.template __node_handle_insert_multi<node_type>(\x0a"
"            _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __hint, node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to multimap\x3a\x3ainsert()\x22);\x0a"
"        return __tree_.template __node_handle_insert_multi<node_type>(\x0a"
"            __hint.__i_, _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(key_type const\x26 __key)\x0a"
"    {\x0a"
"        return __tree_.template __node_handle_extract<node_type>(__key);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(const_iterator __it)\x0a"
"    {\x0a"
"        return __tree_.template __node_handle_extract<node_type>(\x0a"
"            __it.__i_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(multimap<key_type, mapped_type, _Compare2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __tree_.__node_handle_merge_multi(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(multimap<key_type, mapped_type, _Compare2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __tree_.__node_handle_merge_multi(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(map<key_type, mapped_type, _Compare2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __tree_.__node_handle_merge_multi(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(map<key_type, mapped_type, _Compare2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __tree_.__node_handle_merge_multi(__source.__tree_);\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {__tree_.clear();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(multimap\x26 __m)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<__base>\x3a\x3avalue)\x0a"
"        {__tree_.swap(__m.__tree_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator find(const key_type\x26 __k)             {return __tree_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __tree_.find(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    find(const _K2\x26 __k)                           {return __tree_.find(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    find(const _K2\x26 __k) const                     {return __tree_.find(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type      count(const key_type\x26 __k) const\x0a"
"        {return __tree_.__count_multi(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,size_type>\x3a\x3atype\x0a"
"    count(const _K2\x26 __k) const {return __tree_.__count_multi(__k);}\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool contains(const key_type\x26 __k) const {return find(__k) \x21= end();}\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator lower_bound(const key_type\x26 __k)\x0a"
"        {return __tree_.lower_bound(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator lower_bound(const key_type\x26 __k) const\x0a"
"            {return __tree_.lower_bound(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    lower_bound(const _K2\x26 __k)       {return __tree_.lower_bound(__k);}\x0a"
"\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    lower_bound(const _K2\x26 __k) const {return __tree_.lower_bound(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator upper_bound(const key_type\x26 __k)\x0a"
"            {return __tree_.upper_bound(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator upper_bound(const key_type\x26 __k) const\x0a"
"            {return __tree_.upper_bound(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    upper_bound(const _K2\x26 __k)       {return __tree_.upper_bound(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    upper_bound(const _K2\x26 __k) const {return __tree_.upper_bound(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator,iterator>             equal_range(const key_type\x26 __k)\x0a"
"            {return __tree_.__equal_range_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<const_iterator,const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"            {return __tree_.__equal_range_multi(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,pair<iterator,iterator>>\x3a\x3atype\x0a"
"    equal_range(const _K2\x26 __k)       {return __tree_.__equal_range_multi(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,pair<const_iterator,const_iterator>>\x3a\x3atype\x0a"
"    equal_range(const _K2\x26 __k) const {return __tree_.__equal_range_multi(__k);}\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef typename __base\x3a\x3a__node                    __node;\x0a"
"    typedef typename __base\x3a\x3a__node_allocator          __node_allocator;\x0a"
"    typedef typename __base\x3a\x3a__node_pointer            __node_pointer;\x0a"
"\x0a"
"    typedef __map_node_destructor<__node_allocator> _Dp;\x0a"
"    typedef unique_ptr<__node, _Dp> __node_holder;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator, class _Compare = less<__iter_key_type<_InputIterator>>,\x0a"
"         class _Allocator = allocator<__iter_to_alloc_type<_InputIterator>>,\x0a"
"         class = enable_if_t<\x21__is_allocator<_Compare>\x3a\x3avalue, void>,\x0a"
"         class = enable_if_t<__is_allocator<_Allocator>\x3a\x3avalue, void>>\x0a"
"multimap(_InputIterator, _InputIterator, _Compare = _Compare(), _Allocator = _Allocator())\x0a"
"  -> multimap<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>, _Compare, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Compare = less<remove_const_t<_Key>>,\x0a"
"         class _Allocator = allocator<pair<const _Key, _Tp>>,\x0a"
"         class = enable_if_t<\x21__is_allocator<_Compare>\x3a\x3avalue, void>,\x0a"
"         class = enable_if_t<__is_allocator<_Allocator>\x3a\x3avalue, void>>\x0a"
"multimap(initializer_list<pair<_Key, _Tp>>, _Compare = _Compare(), _Allocator = _Allocator())\x0a"
"  -> multimap<remove_const_t<_Key>, _Tp, _Compare, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Allocator,\x0a"
"         class = enable_if_t<__is_allocator<_Allocator>\x3a\x3avalue, void>>\x0a"
"multimap(_InputIterator, _InputIterator, _Allocator)\x0a"
"  -> multimap<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>,\x0a"
"         less<__iter_key_type<_InputIterator>>, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Allocator,\x0a"
"         class = enable_if_t<__is_allocator<_Allocator>\x3a\x3avalue, void>>\x0a"
"multimap(initializer_list<pair<_Key, _Tp>>, _Allocator)\x0a"
"  -> multimap<remove_const_t<_Key>, _Tp, less<remove_const_t<_Key>>, _Allocator>;\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"multimap<_Key, _Tp, _Compare, _Allocator>\x3a\x3amultimap(multimap\x26\x26 __m, const allocator_type\x26 __a)\x0a"
"    \x3a __tree_(_VSTD\x3a\x3amove(__m.__tree_), typename __base\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"    if (__a \x21= __m.get_allocator())\x0a"
"    {\x0a"
"        const_iterator __e = cend();\x0a"
"        while (\x21__m.empty())\x0a"
"            __tree_.__insert_multi(__e.__i_,\x0a"
"                    _VSTD\x3a\x3amove(__m.__tree_.remove(__m.begin().__i_)->__value_.__move()));\x0a"
"    }\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return __x.size() == __y.size() \x26\x26 _VSTD\x3a\x3a""equal(__x.begin(), __x.end(), __y.begin());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alexicographical_compare(__x.begin(), __x.end(), __y.begin(), __y.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"           const multimap<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(multimap<_Key, _Tp, _Compare, _Allocator>\x26 __x,\x0a"
"     multimap<_Key, _Tp, _Compare, _Allocator>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Key, class _Tp, class _Compare, class _Allocator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(multimap<_Key, _Tp, _Compare, _Allocator>\x26 __c, _Predicate __pred)\x0a"
"{ __libcpp_erase_if_container(__c, __pred); }\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_MAP\x0a"
"", 84324 ); }