#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_math_h( 
"// -*- C++ -*-\x0a"
"//===---------------------------- math.h ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_MATH_H\x0a"
"#define _LIBCPP_MATH_H\x0a"
"\x0a"
"/*\x0a"
"    math.h synopsis\x0a"
"\x0a"
"Macros\x3a\x0a"
"\x0a"
"    HUGE_VAL\x0a"
"    HUGE_VALF               // C99\x0a"
"    HUGE_VALL               // C99\x0a"
"    INFINITY                // C99\x0a"
"    NAN                     // C99\x0a"
"    FP_INFINITE             // C99\x0a"
"    FP_NAN                  // C99\x0a"
"    FP_NORMAL               // C99\x0a"
"    FP_SUBNORMAL            // C99\x0a"
"    FP_ZERO                 // C99\x0a"
"    FP_FAST_FMA             // C99\x0a"
"    FP_FAST_FMAF            // C99\x0a"
"    FP_FAST_FMAL            // C99\x0a"
"    FP_ILOGB0               // C99\x0a"
"    FP_ILOGBNAN             // C99\x0a"
"    MATH_ERRNO              // C99\x0a"
"    MATH_ERREXCEPT          // C99\x0a"
"    math_errhandling        // C99\x0a"
"\x0a"
"Types\x3a\x0a"
"\x0a"
"    float_t                 // C99\x0a"
"    double_t                // C99\x0a"
"\x0a"
"// C90\x0a"
"\x0a"
"floating_point abs(floating_point x);\x0a"
"\x0a"
"floating_point acos (arithmetic x);\x0a"
"float          acosf(float x);\x0a"
"long double    acosl(long double x);\x0a"
"\x0a"
"floating_point asin (arithmetic x);\x0a"
"float          asinf(float x);\x0a"
"long double    asinl(long double x);\x0a"
"\x0a"
"floating_point atan (arithmetic x);\x0a"
"float          atanf(float x);\x0a"
"long double    atanl(long double x);\x0a"
"\x0a"
"floating_point atan2 (arithmetic y, arithmetic x);\x0a"
"float          atan2f(float y, float x);\x0a"
"long double    atan2l(long double y, long double x);\x0a"
"\x0a"
"floating_point ceil (arithmetic x);\x0a"
"float          ceilf(float x);\x0a"
"long double    ceill(long double x);\x0a"
"\x0a"
"floating_point cos (arithmetic x);\x0a"
"float          cosf(float x);\x0a"
"long double    cosl(long double x);\x0a"
"\x0a"
"floating_point cosh (arithmetic x);\x0a"
"float          coshf(float x);\x0a"
"long double    coshl(long double x);\x0a"
"\x0a"
"floating_point exp (arithmetic x);\x0a"
"float          expf(float x);\x0a"
"long double    expl(long double x);\x0a"
"\x0a"
"floating_point fabs (arithmetic x);\x0a"
"float          fabsf(float x);\x0a"
"long double    fabsl(long double x);\x0a"
"\x0a"
"floating_point floor (arithmetic x);\x0a"
"float          floorf(float x);\x0a"
"long double    floorl(long double x);\x0a"
"\x0a"
"floating_point fmod (arithmetic x, arithmetic y);\x0a"
"float          fmodf(float x, float y);\x0a"
"long double    fmodl(long double x, long double y);\x0a"
"\x0a"
"floating_point frexp (arithmetic value, int* exp);\x0a"
"float          frexpf(float value, int* exp);\x0a"
"long double    frexpl(long double value, int* exp);\x0a"
"\x0a"
"floating_point ldexp (arithmetic value, int exp);\x0a"
"float          ldexpf(float value, int exp);\x0a"
"long double    ldexpl(long double value, int exp);\x0a"
"\x0a"
"floating_point log (arithmetic x);\x0a"
"float          logf(float x);\x0a"
"long double    logl(long double x);\x0a"
"\x0a"
"floating_point log10 (arithmetic x);\x0a"
"float          log10f(float x);\x0a"
"long double    log10l(long double x);\x0a"
"\x0a"
"floating_point modf (floating_point value, floating_point* iptr);\x0a"
"float          modff(float value, float* iptr);\x0a"
"long double    modfl(long double value, long double* iptr);\x0a"
"\x0a"
"floating_point pow (arithmetic x, arithmetic y);\x0a"
"float          powf(float x, float y);\x0a"
"long double    powl(long double x, long double y);\x0a"
"\x0a"
"floating_point sin (arithmetic x);\x0a"
"float          sinf(float x);\x0a"
"long double    sinl(long double x);\x0a"
"\x0a"
"floating_point sinh (arithmetic x);\x0a"
"float          sinhf(float x);\x0a"
"long double    sinhl(long double x);\x0a"
"\x0a"
"floating_point sqrt (arithmetic x);\x0a"
"float          sqrtf(float x);\x0a"
"long double    sqrtl(long double x);\x0a"
"\x0a"
"floating_point tan (arithmetic x);\x0a"
"float          tanf(float x);\x0a"
"long double    tanl(long double x);\x0a"
"\x0a"
"floating_point tanh (arithmetic x);\x0a"
"float          tanhf(float x);\x0a"
"long double    tanhl(long double x);\x0a"
"\x0a"
"//  C99\x0a"
"\x0a"
"bool signbit(arithmetic x);\x0a"
"\x0a"
"int fpclassify(arithmetic x);\x0a"
"\x0a"
"bool isfinite(arithmetic x);\x0a"
"bool isinf(arithmetic x);\x0a"
"bool isnan(arithmetic x);\x0a"
"bool isnormal(arithmetic x);\x0a"
"\x0a"
"bool isgreater(arithmetic x, arithmetic y);\x0a"
"bool isgreaterequal(arithmetic x, arithmetic y);\x0a"
"bool isless(arithmetic x, arithmetic y);\x0a"
"bool islessequal(arithmetic x, arithmetic y);\x0a"
"bool islessgreater(arithmetic x, arithmetic y);\x0a"
"bool isunordered(arithmetic x, arithmetic y);\x0a"
"\x0a"
"floating_point acosh (arithmetic x);\x0a"
"float          acoshf(float x);\x0a"
"long double    acoshl(long double x);\x0a"
"\x0a"
"floating_point asinh (arithmetic x);\x0a"
"float          asinhf(float x);\x0a"
"long double    asinhl(long double x);\x0a"
"\x0a"
"floating_point atanh (arithmetic x);\x0a"
"float          atanhf(float x);\x0a"
"long double    atanhl(long double x);\x0a"
"\x0a"
"floating_point cbrt (arithmetic x);\x0a"
"float          cbrtf(float x);\x0a"
"long double    cbrtl(long double x);\x0a"
"\x0a"
"floating_point copysign (arithmetic x, arithmetic y);\x0a"
"float          copysignf(float x, float y);\x0a"
"long double    copysignl(long double x, long double y);\x0a"
"\x0a"
"floating_point erf (arithmetic x);\x0a"
"float          erff(float x);\x0a"
"long double    erfl(long double x);\x0a"
"\x0a"
"floating_point erfc (arithmetic x);\x0a"
"float          erfcf(float x);\x0a"
"long double    erfcl(long double x);\x0a"
"\x0a"
"floating_point exp2 (arithmetic x);\x0a"
"float          exp2f(float x);\x0a"
"long double    exp2l(long double x);\x0a"
"\x0a"
"floating_point expm1 (arithmetic x);\x0a"
"float          expm1f(float x);\x0a"
"long double    expm1l(long double x);\x0a"
"\x0a"
"floating_point fdim (arithmetic x, arithmetic y);\x0a"
"float          fdimf(float x, float y);\x0a"
"long double    fdiml(long double x, long double y);\x0a"
"\x0a"
"floating_point fma (arithmetic x, arithmetic y, arithmetic z);\x0a"
"float          fmaf(float x, float y, float z);\x0a"
"long double    fmal(long double x, long double y, long double z);\x0a"
"\x0a"
"floating_point fmax (arithmetic x, arithmetic y);\x0a"
"float          fmaxf(float x, float y);\x0a"
"long double    fmaxl(long double x, long double y);\x0a"
"\x0a"
"floating_point fmin (arithmetic x, arithmetic y);\x0a"
"float          fminf(float x, float y);\x0a"
"long double    fminl(long double x, long double y);\x0a"
"\x0a"
"floating_point hypot (arithmetic x, arithmetic y);\x0a"
"float          hypotf(float x, float y);\x0a"
"long double    hypotl(long double x, long double y);\x0a"
"\x0a"
"int ilogb (arithmetic x);\x0a"
"int ilogbf(float x);\x0a"
"int ilogbl(long double x);\x0a"
"\x0a"
"floating_point lgamma (arithmetic x);\x0a"
"float          lgammaf(float x);\x0a"
"long double    lgammal(long double x);\x0a"
"\x0a"
"long long llrint (arithmetic x);\x0a"
"long long llrintf(float x);\x0a"
"long long llrintl(long double x);\x0a"
"\x0a"
"long long llround (arithmetic x);\x0a"
"long long llroundf(float x);\x0a"
"long long llroundl(long double x);\x0a"
"\x0a"
"floating_point log1p (arithmetic x);\x0a"
"float          log1pf(float x);\x0a"
"long double    log1pl(long double x);\x0a"
"\x0a"
"floating_point log2 (arithmetic x);\x0a"
"float          log2f(float x);\x0a"
"long double    log2l(long double x);\x0a"
"\x0a"
"floating_point logb (arithmetic x);\x0a"
"float          logbf(float x);\x0a"
"long double    logbl(long double x);\x0a"
"\x0a"
"long lrint (arithmetic x);\x0a"
"long lrintf(float x);\x0a"
"long lrintl(long double x);\x0a"
"\x0a"
"long lround (arithmetic x);\x0a"
"long lroundf(float x);\x0a"
"long lroundl(long double x);\x0a"
"\x0a"
"double      nan (const char* str);\x0a"
"float       nanf(const char* str);\x0a"
"long double nanl(const char* str);\x0a"
"\x0a"
"floating_point nearbyint (arithmetic x);\x0a"
"float          nearbyintf(float x);\x0a"
"long double    nearbyintl(long double x);\x0a"
"\x0a"
"floating_point nextafter (arithmetic x, arithmetic y);\x0a"
"float          nextafterf(float x, float y);\x0a"
"long double    nextafterl(long double x, long double y);\x0a"
"\x0a"
"floating_point nexttoward (arithmetic x, long double y);\x0a"
"float          nexttowardf(float x, long double y);\x0a"
"long double    nexttowardl(long double x, long double y);\x0a"
"\x0a"
"floating_point remainder (arithmetic x, arithmetic y);\x0a"
"float          remainderf(float x, float y);\x0a"
"long double    remainderl(long double x, long double y);\x0a"
"\x0a"
"floating_point remquo (arithmetic x, arithmetic y, int* pquo);\x0a"
"float          remquof(float x, float y, int* pquo);\x0a"
"long double    remquol(long double x, long double y, int* pquo);\x0a"
"\x0a"
"floating_point rint (arithmetic x);\x0a"
"float          rintf(float x);\x0a"
"long double    rintl(long double x);\x0a"
"\x0a"
"floating_point round (arithmetic x);\x0a"
"float          roundf(float x);\x0a"
"long double    roundl(long double x);\x0a"
"\x0a"
"floating_point scalbln (arithmetic x, long ex);\x0a"
"float          scalblnf(float x, long ex);\x0a"
"long double    scalblnl(long double x, long ex);\x0a"
"\x0a"
"floating_point scalbn (arithmetic x, int ex);\x0a"
"float          scalbnf(float x, int ex);\x0a"
"long double    scalbnl(long double x, int ex);\x0a"
"\x0a"
"floating_point tgamma (arithmetic x);\x0a"
"float          tgammaf(float x);\x0a"
"long double    tgammal(long double x);\x0a"
"\x0a"
"floating_point trunc (arithmetic x);\x0a"
"float          truncf(float x);\x0a"
"long double    truncl(long double x);\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#define _LIBCPP_STDLIB_INCLUDE_NEXT\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"#include_next <math.h>\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"\x0a"
"// We support including .h headers inside 'extern \x22""C\x22' contexts, so switch\x0a"
"// back to C++ linkage before including these C++ headers.\x0a"
"extern \x22""C++\x22 {\x0a"
"\x0a"
"#include <type_traits>\x0a"
"#include <limits>\x0a"
"\x0a"
"// signbit\x0a"
"\x0a"
"#ifdef signbit\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_signbit(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return signbit(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"#undef signbit\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"signbit(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_signbit((typename std\x3a\x3a__promote<_A1>\x3a\x3atype)__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<\x0a"
"    std\x3a\x3ais_integral<_A1>\x3a\x3avalue \x26\x26 std\x3a\x3ais_signed<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"signbit(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{ return __lcpp_x < 0; }\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<\x0a"
"    std\x3a\x3ais_integral<_A1>\x3a\x3avalue \x26\x26 \x21std\x3a\x3ais_signed<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"signbit(_A1) _NOEXCEPT\x0a"
"{ return false; }\x0a"
"\x0a"
"#elif defined(_LIBCPP_MSVCRT)\x0a"
"\x0a"
"template <typename _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"signbit(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"  return \x3a\x3asignbit(static_cast<typename std\x3a\x3a__promote<_A1>\x3a\x3atype>(__lcpp_x));\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<\x0a"
"    std\x3a\x3ais_integral<_A1>\x3a\x3avalue \x26\x26 std\x3a\x3ais_signed<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"signbit(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{ return __lcpp_x < 0; }\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<\x0a"
"    std\x3a\x3ais_integral<_A1>\x3a\x3avalue \x26\x26 \x21std\x3a\x3ais_signed<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"signbit(_A1) _NOEXCEPT\x0a"
"{ return false; }\x0a"
"\x0a"
"#endif  // signbit\x0a"
"\x0a"
"// fpclassify\x0a"
"\x0a"
"#ifdef fpclassify\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"int\x0a"
"__libcpp_fpclassify(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return fpclassify(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"#undef fpclassify\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_floating_point<_A1>\x3a\x3avalue, int>\x3a\x3atype\x0a"
"fpclassify(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_fpclassify((typename std\x3a\x3a__promote<_A1>\x3a\x3atype)__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, int>\x3a\x3atype\x0a"
"fpclassify(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{ return __lcpp_x == 0 \x3f FP_ZERO \x3a FP_NORMAL; }\x0a"
"\x0a"
"#elif defined(_LIBCPP_MSVCRT)\x0a"
"\x0a"
"template <typename _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"fpclassify(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"  return \x3a\x3a""fpclassify(static_cast<typename std\x3a\x3a__promote<_A1>\x3a\x3atype>(__lcpp_x));\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, int>\x3a\x3atype\x0a"
"fpclassify(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{ return __lcpp_x == 0 \x3f FP_ZERO \x3a FP_NORMAL; }\x0a"
"\x0a"
"#endif  // fpclassify\x0a"
"\x0a"
"// isfinite\x0a"
"\x0a"
"#ifdef isfinite\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_isfinite(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return isfinite(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"#undef isfinite\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26 std\x3a\x3anumeric_limits<_A1>\x3a\x3ahas_infinity,\x0a"
"    bool>\x3a\x3atype\x0a"
"isfinite(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_isfinite((typename std\x3a\x3a__promote<_A1>\x3a\x3atype)__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26 \x21std\x3a\x3anumeric_limits<_A1>\x3a\x3ahas_infinity,\x0a"
"    bool>\x3a\x3atype\x0a"
"isfinite(_A1) _NOEXCEPT\x0a"
"{ return true; }\x0a"
"\x0a"
"#endif  // isfinite\x0a"
"\x0a"
"// isinf\x0a"
"\x0a"
"#ifdef isinf\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_isinf(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return isinf(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"#undef isinf\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26 std\x3a\x3anumeric_limits<_A1>\x3a\x3ahas_infinity,\x0a"
"    bool>\x3a\x3atype\x0a"
"isinf(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_isinf((typename std\x3a\x3a__promote<_A1>\x3a\x3atype)__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26 \x21std\x3a\x3anumeric_limits<_A1>\x3a\x3ahas_infinity,\x0a"
"    bool>\x3a\x3atype\x0a"
"isinf(_A1) _NOEXCEPT\x0a"
"{ return false; }\x0a"
"\x0a"
"#ifdef _LIBCPP_PREFERRED_OVERLOAD\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"isinf(float __lcpp_x) _NOEXCEPT { return __libcpp_isinf(__lcpp_x); }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"bool\x0a"
"isinf(double __lcpp_x) _NOEXCEPT { return __libcpp_isinf(__lcpp_x); }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"isinf(long double __lcpp_x) _NOEXCEPT { return __libcpp_isinf(__lcpp_x); }\x0a"
"#endif\x0a"
"\x0a"
"#endif  // isinf\x0a"
"\x0a"
"// isnan\x0a"
"\x0a"
"#ifdef isnan\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_isnan(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return isnan(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"#undef isnan\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"isnan(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_isnan((typename std\x3a\x3a__promote<_A1>\x3a\x3atype)__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"isnan(_A1) _NOEXCEPT\x0a"
"{ return false; }\x0a"
"\x0a"
"#ifdef _LIBCPP_PREFERRED_OVERLOAD\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"isnan(float __lcpp_x) _NOEXCEPT { return __libcpp_isnan(__lcpp_x); }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"bool\x0a"
"isnan(double __lcpp_x) _NOEXCEPT { return __libcpp_isnan(__lcpp_x); }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"isnan(long double __lcpp_x) _NOEXCEPT { return __libcpp_isnan(__lcpp_x); }\x0a"
"#endif\x0a"
"\x0a"
"#endif  // isnan\x0a"
"\x0a"
"// isnormal\x0a"
"\x0a"
"#ifdef isnormal\x0a"
"\x0a"
"template <class _A1>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_isnormal(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return isnormal(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"#undef isnormal\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_floating_point<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"isnormal(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_isnormal((typename std\x3a\x3a__promote<_A1>\x3a\x3atype)__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, bool>\x3a\x3atype\x0a"
"isnormal(_A1 __lcpp_x) _NOEXCEPT\x0a"
"{ return __lcpp_x \x21= 0; }\x0a"
"\x0a"
"#endif  // isnormal\x0a"
"\x0a"
"// isgreater\x0a"
"\x0a"
"#ifdef isgreater\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_isgreater(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    return isgreater(__lcpp_x, __lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#undef isgreater\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    bool\x0a"
">\x3a\x3atype\x0a"
"isgreater(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype type;\x0a"
"    return __libcpp_isgreater((type)__lcpp_x, (type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#endif  // isgreater\x0a"
"\x0a"
"// isgreaterequal\x0a"
"\x0a"
"#ifdef isgreaterequal\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_isgreaterequal(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    return isgreaterequal(__lcpp_x, __lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#undef isgreaterequal\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    bool\x0a"
">\x3a\x3atype\x0a"
"isgreaterequal(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype type;\x0a"
"    return __libcpp_isgreaterequal((type)__lcpp_x, (type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#endif  // isgreaterequal\x0a"
"\x0a"
"// isless\x0a"
"\x0a"
"#ifdef isless\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_isless(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    return isless(__lcpp_x, __lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#undef isless\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    bool\x0a"
">\x3a\x3atype\x0a"
"isless(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype type;\x0a"
"    return __libcpp_isless((type)__lcpp_x, (type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#endif  // isless\x0a"
"\x0a"
"// islessequal\x0a"
"\x0a"
"#ifdef islessequal\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_islessequal(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    return islessequal(__lcpp_x, __lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#undef islessequal\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    bool\x0a"
">\x3a\x3atype\x0a"
"islessequal(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype type;\x0a"
"    return __libcpp_islessequal((type)__lcpp_x, (type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#endif  // islessequal\x0a"
"\x0a"
"// islessgreater\x0a"
"\x0a"
"#ifdef islessgreater\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_islessgreater(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    return islessgreater(__lcpp_x, __lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#undef islessgreater\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    bool\x0a"
">\x3a\x3atype\x0a"
"islessgreater(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype type;\x0a"
"    return __libcpp_islessgreater((type)__lcpp_x, (type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#endif  // islessgreater\x0a"
"\x0a"
"// isunordered\x0a"
"\x0a"
"#ifdef isunordered\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"__libcpp_isunordered(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    return isunordered(__lcpp_x, __lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#undef isunordered\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    bool\x0a"
">\x3a\x3atype\x0a"
"isunordered(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype type;\x0a"
"    return __libcpp_isunordered((type)__lcpp_x, (type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"#endif  // isunordered\x0a"
"\x0a"
"// abs\x0a"
"\x0a"
"#undef abs\x0a"
"#undef labs\x0a"
"#ifndef _LIBCPP_HAS_NO_LONG_LONG\x0a"
"#undef llabs\x0a"
"#endif\x0a"
"\x0a"
"// MSVCRT already has the correct prototype in <stdlib.h> if __cplusplus is defined\x0a"
"#if \x21""defined(_LIBCPP_MSVCRT) \x26\x26 \x21""defined(__sun__) \x26\x26 \x21""defined(_AIX)\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long abs(long __x) _NOEXCEPT {\x0a"
"  return \x3a\x3alabs(__x);\x0a"
"}\x0a"
"#ifndef _LIBCPP_HAS_NO_LONG_LONG\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long long abs(long long __x) _NOEXCEPT {\x0a"
"  return \x3a\x3allabs(__x);\x0a"
"}\x0a"
"#endif // _LIBCPP_HAS_NO_LONG_LONG\x0a"
"#endif // \x21""defined(_LIBCPP_MSVCRT) \x26\x26 \x21""defined(__sun__) \x26\x26 \x21""defined(_AIX)\x0a"
"\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float abs(float __lcpp_x) _NOEXCEPT {\x0a"
"  return \x3a\x3a""fabsf(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY double abs(double __lcpp_x) _NOEXCEPT {\x0a"
"  return \x3a\x3a""fabs(__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double\x0a"
"abs(long double __lcpp_x) _NOEXCEPT {\x0a"
"  return \x3a\x3a""fabsl(__lcpp_x);\x0a"
"}\x0a"
"#endif // \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"\x0a"
"// div\x0a"
"\x0a"
"#undef div\x0a"
"#undef ldiv\x0a"
"#ifndef _LIBCPP_HAS_NO_LONG_LONG\x0a"
"#undef lldiv\x0a"
"#endif\x0a"
"\x0a"
"// MSVCRT already has the correct prototype in <stdlib.h> if __cplusplus is defined\x0a"
"#if \x21""defined(_LIBCPP_MSVCRT) \x26\x26 \x21""defined(__sun__) \x26\x26 \x21""defined(_AIX)\x0a"
"inline _LIBCPP_INLINE_VISIBILITY ldiv_t div(long __x, long __y) _NOEXCEPT {\x0a"
"  return \x3a\x3aldiv(__x, __y);\x0a"
"}\x0a"
"#ifndef _LIBCPP_HAS_NO_LONG_LONG\x0a"
"inline _LIBCPP_INLINE_VISIBILITY lldiv_t div(long long __x,\x0a"
"                                             long long __y) _NOEXCEPT {\x0a"
"  return \x3a\x3alldiv(__x, __y);\x0a"
"}\x0a"
"#endif // _LIBCPP_HAS_NO_LONG_LONG\x0a"
"#endif // _LIBCPP_MSVCRT / __sun__ / _AIX\x0a"
"\x0a"
"// acos\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       acos(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""acosf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double acos(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""acosl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"acos(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""acos((double)__lcpp_x);}\x0a"
"\x0a"
"// asin\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       asin(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""asinf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double asin(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""asinl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"asin(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""asin((double)__lcpp_x);}\x0a"
"\x0a"
"// atan\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       atan(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""atanf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double atan(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""atanl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"atan(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""atan((double)__lcpp_x);}\x0a"
"\x0a"
"// atan2\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       atan2(float __lcpp_y, float __lcpp_x) _NOEXCEPT             {return \x3a\x3a""atan2f(__lcpp_y, __lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double atan2(long double __lcpp_y, long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""atan2l(__lcpp_y, __lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"atan2(_A1 __lcpp_y, _A2 __lcpp_x) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3a""atan2((__result_type)__lcpp_y, (__result_type)__lcpp_x);\x0a"
"}\x0a"
"\x0a"
"// ceil\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       ceil(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""ceilf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double ceil(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""ceill(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"ceil(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""ceil((double)__lcpp_x);}\x0a"
"\x0a"
"// cos\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       cos(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""cosf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double cos(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""cosl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"cos(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""cos((double)__lcpp_x);}\x0a"
"\x0a"
"// cosh\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       cosh(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""coshf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double cosh(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""coshl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"cosh(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""cosh((double)__lcpp_x);}\x0a"
"\x0a"
"// exp\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       exp(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""expf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double exp(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""expl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"exp(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""exp((double)__lcpp_x);}\x0a"
"\x0a"
"// fabs\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       fabs(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""fabsf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double fabs(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""fabsl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"fabs(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""fabs((double)__lcpp_x);}\x0a"
"\x0a"
"// floor\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       floor(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""floorf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double floor(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""floorl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"floor(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""floor((double)__lcpp_x);}\x0a"
"\x0a"
"// fmod\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       fmod(float __lcpp_x, float __lcpp_y) _NOEXCEPT             {return \x3a\x3a""fmodf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double fmod(long double __lcpp_x, long double __lcpp_y) _NOEXCEPT {return \x3a\x3a""fmodl(__lcpp_x, __lcpp_y);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"fmod(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3a""fmod((__result_type)__lcpp_x, (__result_type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"// frexp\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       frexp(float __lcpp_x, int* __lcpp_e) _NOEXCEPT       {return \x3a\x3a""frexpf(__lcpp_x, __lcpp_e);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double frexp(long double __lcpp_x, int* __lcpp_e) _NOEXCEPT {return \x3a\x3a""frexpl(__lcpp_x, __lcpp_e);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"frexp(_A1 __lcpp_x, int* __lcpp_e) _NOEXCEPT {return \x3a\x3a""frexp((double)__lcpp_x, __lcpp_e);}\x0a"
"\x0a"
"// ldexp\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       ldexp(float __lcpp_x, int __lcpp_e) _NOEXCEPT       {return \x3a\x3aldexpf(__lcpp_x, __lcpp_e);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double ldexp(long double __lcpp_x, int __lcpp_e) _NOEXCEPT {return \x3a\x3aldexpl(__lcpp_x, __lcpp_e);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"ldexp(_A1 __lcpp_x, int __lcpp_e) _NOEXCEPT {return \x3a\x3aldexp((double)__lcpp_x, __lcpp_e);}\x0a"
"\x0a"
"// log\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       log(float __lcpp_x) _NOEXCEPT       {return \x3a\x3alogf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double log(long double __lcpp_x) _NOEXCEPT {return \x3a\x3alogl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"log(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3alog((double)__lcpp_x);}\x0a"
"\x0a"
"// log10\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       log10(float __lcpp_x) _NOEXCEPT       {return \x3a\x3alog10f(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double log10(long double __lcpp_x) _NOEXCEPT {return \x3a\x3alog10l(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"log10(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3alog10((double)__lcpp_x);}\x0a"
"\x0a"
"// modf\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       modf(float __lcpp_x, float* __lcpp_y) _NOEXCEPT             {return \x3a\x3amodff(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double modf(long double __lcpp_x, long double* __lcpp_y) _NOEXCEPT {return \x3a\x3amodfl(__lcpp_x, __lcpp_y);}\x0a"
"#endif\x0a"
"\x0a"
"// pow\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       pow(float __lcpp_x, float __lcpp_y) _NOEXCEPT             {return \x3a\x3apowf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double pow(long double __lcpp_x, long double __lcpp_y) _NOEXCEPT {return \x3a\x3apowl(__lcpp_x, __lcpp_y);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"pow(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3apow((__result_type)__lcpp_x, (__result_type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"// sin\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       sin(float __lcpp_x) _NOEXCEPT       {return \x3a\x3asinf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double sin(long double __lcpp_x) _NOEXCEPT {return \x3a\x3asinl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"sin(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3asin((double)__lcpp_x);}\x0a"
"\x0a"
"// sinh\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       sinh(float __lcpp_x) _NOEXCEPT       {return \x3a\x3asinhf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double sinh(long double __lcpp_x) _NOEXCEPT {return \x3a\x3asinhl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"sinh(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3asinh((double)__lcpp_x);}\x0a"
"\x0a"
"// sqrt\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       sqrt(float __lcpp_x) _NOEXCEPT       {return \x3a\x3asqrtf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double sqrt(long double __lcpp_x) _NOEXCEPT {return \x3a\x3asqrtl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"sqrt(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3asqrt((double)__lcpp_x);}\x0a"
"\x0a"
"// tan\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       tan(float __lcpp_x) _NOEXCEPT       {return \x3a\x3atanf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double tan(long double __lcpp_x) _NOEXCEPT {return \x3a\x3atanl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"tan(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3atan((double)__lcpp_x);}\x0a"
"\x0a"
"// tanh\x0a"
"\x0a"
"#if \x21(defined(_AIX) \x7c\x7c defined(__sun__))\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       tanh(float __lcpp_x) _NOEXCEPT       {return \x3a\x3atanhf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double tanh(long double __lcpp_x) _NOEXCEPT {return \x3a\x3atanhl(__lcpp_x);}\x0a"
"#endif\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"tanh(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3atanh((double)__lcpp_x);}\x0a"
"\x0a"
"// acosh\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       acosh(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""acoshf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double acosh(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""acoshl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"acosh(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""acosh((double)__lcpp_x);}\x0a"
"\x0a"
"// asinh\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       asinh(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""asinhf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double asinh(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""asinhl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"asinh(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""asinh((double)__lcpp_x);}\x0a"
"\x0a"
"// atanh\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       atanh(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""atanhf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double atanh(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""atanhl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"atanh(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""atanh((double)__lcpp_x);}\x0a"
"\x0a"
"// cbrt\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       cbrt(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""cbrtf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double cbrt(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""cbrtl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"cbrt(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""cbrt((double)__lcpp_x);}\x0a"
"\x0a"
"// copysign\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float copysign(float __lcpp_x,\x0a"
"                                                float __lcpp_y) _NOEXCEPT {\x0a"
"  return \x3a\x3a""copysignf(__lcpp_x, __lcpp_y);\x0a"
"}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double\x0a"
"copysign(long double __lcpp_x, long double __lcpp_y) _NOEXCEPT {\x0a"
"  return \x3a\x3a""copysignl(__lcpp_x, __lcpp_y);\x0a"
"}\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"copysign(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3a""copysign((__result_type)__lcpp_x, (__result_type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"// erf\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       erf(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""erff(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double erf(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""erfl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"erf(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""erf((double)__lcpp_x);}\x0a"
"\x0a"
"// erfc\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       erfc(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""erfcf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double erfc(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""erfcl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"erfc(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""erfc((double)__lcpp_x);}\x0a"
"\x0a"
"// exp2\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       exp2(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""exp2f(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double exp2(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""exp2l(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"exp2(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""exp2((double)__lcpp_x);}\x0a"
"\x0a"
"// expm1\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       expm1(float __lcpp_x) _NOEXCEPT       {return \x3a\x3a""expm1f(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double expm1(long double __lcpp_x) _NOEXCEPT {return \x3a\x3a""expm1l(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"expm1(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3a""expm1((double)__lcpp_x);}\x0a"
"\x0a"
"// fdim\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       fdim(float __lcpp_x, float __lcpp_y) _NOEXCEPT             {return \x3a\x3a""fdimf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double fdim(long double __lcpp_x, long double __lcpp_y) _NOEXCEPT {return \x3a\x3a""fdiml(__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"fdim(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3a""fdim((__result_type)__lcpp_x, (__result_type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"// fma\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       fma(float __lcpp_x, float __lcpp_y, float __lcpp_z) _NOEXCEPT                   {return \x3a\x3a""fmaf(__lcpp_x, __lcpp_y, __lcpp_z);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double fma(long double __lcpp_x, long double __lcpp_y, long double __lcpp_z) _NOEXCEPT {return \x3a\x3a""fmal(__lcpp_x, __lcpp_y, __lcpp_z);}\x0a"
"\x0a"
"template <class _A1, class _A2, class _A3>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A3>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2, _A3>\x0a"
">\x3a\x3atype\x0a"
"fma(_A1 __lcpp_x, _A2 __lcpp_y, _A3 __lcpp_z) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2, _A3>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A3, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3a""fma((__result_type)__lcpp_x, (__result_type)__lcpp_y, (__result_type)__lcpp_z);\x0a"
"}\x0a"
"\x0a"
"// fmax\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       fmax(float __lcpp_x, float __lcpp_y) _NOEXCEPT             {return \x3a\x3a""fmaxf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double fmax(long double __lcpp_x, long double __lcpp_y) _NOEXCEPT {return \x3a\x3a""fmaxl(__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"fmax(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3a""fmax((__result_type)__lcpp_x, (__result_type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"// fmin\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       fmin(float __lcpp_x, float __lcpp_y) _NOEXCEPT             {return \x3a\x3a""fminf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double fmin(long double __lcpp_x, long double __lcpp_y) _NOEXCEPT {return \x3a\x3a""fminl(__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"fmin(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3a""fmin((__result_type)__lcpp_x, (__result_type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"// hypot\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       hypot(float __lcpp_x, float __lcpp_y) _NOEXCEPT             {return \x3a\x3ahypotf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double hypot(long double __lcpp_x, long double __lcpp_y) _NOEXCEPT {return \x3a\x3ahypotl(__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"hypot(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3ahypot((__result_type)__lcpp_x, (__result_type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"// ilogb\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY int ilogb(float __lcpp_x) _NOEXCEPT       {return \x3a\x3ailogbf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY int ilogb(long double __lcpp_x) _NOEXCEPT {return \x3a\x3ailogbl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, int>\x3a\x3atype\x0a"
"ilogb(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3ailogb((double)__lcpp_x);}\x0a"
"\x0a"
"// lgamma\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       lgamma(float __lcpp_x) _NOEXCEPT       {return \x3a\x3algammaf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double lgamma(long double __lcpp_x) _NOEXCEPT {return \x3a\x3algammal(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"lgamma(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3algamma((double)__lcpp_x);}\x0a"
"\x0a"
"// llrint\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long long llrint(float __lcpp_x) _NOEXCEPT       {return \x3a\x3allrintf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long long llrint(long double __lcpp_x) _NOEXCEPT {return \x3a\x3allrintl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, long long>\x3a\x3atype\x0a"
"llrint(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3allrint((double)__lcpp_x);}\x0a"
"\x0a"
"// llround\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long long llround(float __lcpp_x) _NOEXCEPT       {return \x3a\x3allroundf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long long llround(long double __lcpp_x) _NOEXCEPT {return \x3a\x3allroundl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, long long>\x3a\x3atype\x0a"
"llround(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3allround((double)__lcpp_x);}\x0a"
"\x0a"
"// log1p\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       log1p(float __lcpp_x) _NOEXCEPT       {return \x3a\x3alog1pf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double log1p(long double __lcpp_x) _NOEXCEPT {return \x3a\x3alog1pl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"log1p(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3alog1p((double)__lcpp_x);}\x0a"
"\x0a"
"// log2\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       log2(float __lcpp_x) _NOEXCEPT       {return \x3a\x3alog2f(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double log2(long double __lcpp_x) _NOEXCEPT {return \x3a\x3alog2l(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"log2(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3alog2((double)__lcpp_x);}\x0a"
"\x0a"
"// logb\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       logb(float __lcpp_x) _NOEXCEPT       {return \x3a\x3alogbf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double logb(long double __lcpp_x) _NOEXCEPT {return \x3a\x3alogbl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"logb(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3alogb((double)__lcpp_x);}\x0a"
"\x0a"
"// lrint\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long lrint(float __lcpp_x) _NOEXCEPT       {return \x3a\x3alrintf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long lrint(long double __lcpp_x) _NOEXCEPT {return \x3a\x3alrintl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, long>\x3a\x3atype\x0a"
"lrint(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3alrint((double)__lcpp_x);}\x0a"
"\x0a"
"// lround\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long lround(float __lcpp_x) _NOEXCEPT       {return \x3a\x3alroundf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long lround(long double __lcpp_x) _NOEXCEPT {return \x3a\x3alroundl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, long>\x3a\x3atype\x0a"
"lround(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3alround((double)__lcpp_x);}\x0a"
"\x0a"
"// nan\x0a"
"\x0a"
"// nearbyint\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       nearbyint(float __lcpp_x) _NOEXCEPT       {return \x3a\x3anearbyintf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double nearbyint(long double __lcpp_x) _NOEXCEPT {return \x3a\x3anearbyintl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"nearbyint(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3anearbyint((double)__lcpp_x);}\x0a"
"\x0a"
"// nextafter\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       nextafter(float __lcpp_x, float __lcpp_y) _NOEXCEPT             {return \x3a\x3anextafterf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double nextafter(long double __lcpp_x, long double __lcpp_y) _NOEXCEPT {return \x3a\x3anextafterl(__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"nextafter(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3anextafter((__result_type)__lcpp_x, (__result_type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"// nexttoward\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       nexttoward(float __lcpp_x, long double __lcpp_y) _NOEXCEPT       {return \x3a\x3anexttowardf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double nexttoward(long double __lcpp_x, long double __lcpp_y) _NOEXCEPT {return \x3a\x3anexttowardl(__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"nexttoward(_A1 __lcpp_x, long double __lcpp_y) _NOEXCEPT {return \x3a\x3anexttoward((double)__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"// remainder\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       remainder(float __lcpp_x, float __lcpp_y) _NOEXCEPT             {return \x3a\x3aremainderf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double remainder(long double __lcpp_x, long double __lcpp_y) _NOEXCEPT {return \x3a\x3aremainderl(__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"remainder(_A1 __lcpp_x, _A2 __lcpp_y) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3aremainder((__result_type)__lcpp_x, (__result_type)__lcpp_y);\x0a"
"}\x0a"
"\x0a"
"// remquo\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       remquo(float __lcpp_x, float __lcpp_y, int* __lcpp_z) _NOEXCEPT             {return \x3a\x3aremquof(__lcpp_x, __lcpp_y, __lcpp_z);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double remquo(long double __lcpp_x, long double __lcpp_y, int* __lcpp_z) _NOEXCEPT {return \x3a\x3aremquol(__lcpp_x, __lcpp_y, __lcpp_z);}\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a_EnableIf\x0a"
"<\x0a"
"    std\x3a\x3ais_arithmetic<_A1>\x3a\x3avalue \x26\x26\x0a"
"    std\x3a\x3ais_arithmetic<_A2>\x3a\x3avalue,\x0a"
"    std\x3a\x3a__promote<_A1, _A2>\x0a"
">\x3a\x3atype\x0a"
"remquo(_A1 __lcpp_x, _A2 __lcpp_y, int* __lcpp_z) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename std\x3a\x3a__promote<_A1, _A2>\x3a\x3atype __result_type;\x0a"
"    static_assert((\x21(std\x3a\x3a_IsSame<_A1, __result_type>\x3a\x3avalue \x26\x26\x0a"
"                     std\x3a\x3a_IsSame<_A2, __result_type>\x3a\x3avalue)), \x22\x22);\x0a"
"    return \x3a\x3aremquo((__result_type)__lcpp_x, (__result_type)__lcpp_y, __lcpp_z);\x0a"
"}\x0a"
"\x0a"
"// rint\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       rint(float __lcpp_x) _NOEXCEPT       {return \x3a\x3arintf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double rint(long double __lcpp_x) _NOEXCEPT {return \x3a\x3arintl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"rint(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3arint((double)__lcpp_x);}\x0a"
"\x0a"
"// round\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       round(float __lcpp_x) _NOEXCEPT       {return \x3a\x3aroundf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double round(long double __lcpp_x) _NOEXCEPT {return \x3a\x3aroundl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"round(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3around((double)__lcpp_x);}\x0a"
"\x0a"
"// scalbln\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       scalbln(float __lcpp_x, long __lcpp_y) _NOEXCEPT       {return \x3a\x3ascalblnf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double scalbln(long double __lcpp_x, long __lcpp_y) _NOEXCEPT {return \x3a\x3ascalblnl(__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"scalbln(_A1 __lcpp_x, long __lcpp_y) _NOEXCEPT {return \x3a\x3ascalbln((double)__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"// scalbn\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       scalbn(float __lcpp_x, int __lcpp_y) _NOEXCEPT       {return \x3a\x3ascalbnf(__lcpp_x, __lcpp_y);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double scalbn(long double __lcpp_x, int __lcpp_y) _NOEXCEPT {return \x3a\x3ascalbnl(__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"scalbn(_A1 __lcpp_x, int __lcpp_y) _NOEXCEPT {return \x3a\x3ascalbn((double)__lcpp_x, __lcpp_y);}\x0a"
"\x0a"
"// tgamma\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       tgamma(float __lcpp_x) _NOEXCEPT       {return \x3a\x3atgammaf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double tgamma(long double __lcpp_x) _NOEXCEPT {return \x3a\x3atgammal(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"tgamma(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3atgamma((double)__lcpp_x);}\x0a"
"\x0a"
"// trunc\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY float       trunc(float __lcpp_x) _NOEXCEPT       {return \x3a\x3atruncf(__lcpp_x);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY long double trunc(long double __lcpp_x) _NOEXCEPT {return \x3a\x3atruncl(__lcpp_x);}\x0a"
"\x0a"
"template <class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename std\x3a\x3a""enable_if<std\x3a\x3ais_integral<_A1>\x3a\x3avalue, double>\x3a\x3atype\x0a"
"trunc(_A1 __lcpp_x) _NOEXCEPT {return \x3a\x3atrunc((double)__lcpp_x);}\x0a"
"\x0a"
"} // extern \x22""C++\x22\x0a"
"\x0a"
"#endif // __cplusplus\x0a"
"\x0a"
"#else // _LIBCPP_MATH_H\x0a"
"\x0a"
"// This include lives outside the header guard in order to support an MSVC\x0a"
"// extension which allows users to do\x3a\x0a"
"//\x0a"
"// #define _USE_MATH_DEFINES\x0a"
"// #include <math.h>\x0a"
"//\x0a"
"// and receive the definitions of mathematical constants, even if <math.h>\x0a"
"// has previously been included.\x0a"
"#if defined(_LIBCPP_MSVCRT) \x26\x26 defined(_USE_MATH_DEFINES)\x0a"
"#include_next <math.h>\x0a"
"#endif\x0a"
"\x0a"
"#endif  // _LIBCPP_MATH_H\x0a"
"", 50651 ); }