#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_mutex( 
"// -*- C++ -*-\x0a"
"//===--------------------------- mutex ------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_MUTEX\x0a"
"#define _LIBCPP_MUTEX\x0a"
"\x0a"
"/*\x0a"
"    mutex synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"class mutex\x0a"
"{\x0a"
"public\x3a\x0a"
"     constexpr mutex() noexcept;\x0a"
"     \x7emutex();\x0a"
"\x0a"
"    mutex(const mutex\x26) = delete;\x0a"
"    mutex\x26 operator=(const mutex\x26) = delete;\x0a"
"\x0a"
"    void lock();\x0a"
"    bool try_lock();\x0a"
"    void unlock();\x0a"
"\x0a"
"    typedef pthread_mutex_t* native_handle_type;\x0a"
"    native_handle_type native_handle();\x0a"
"};\x0a"
"\x0a"
"class recursive_mutex\x0a"
"{\x0a"
"public\x3a\x0a"
"     recursive_mutex();\x0a"
"     \x7erecursive_mutex();\x0a"
"\x0a"
"    recursive_mutex(const recursive_mutex\x26) = delete;\x0a"
"    recursive_mutex\x26 operator=(const recursive_mutex\x26) = delete;\x0a"
"\x0a"
"    void lock();\x0a"
"    bool try_lock() noexcept;\x0a"
"    void unlock();\x0a"
"\x0a"
"    typedef pthread_mutex_t* native_handle_type;\x0a"
"    native_handle_type native_handle();\x0a"
"};\x0a"
"\x0a"
"class timed_mutex\x0a"
"{\x0a"
"public\x3a\x0a"
"     timed_mutex();\x0a"
"     \x7etimed_mutex();\x0a"
"\x0a"
"    timed_mutex(const timed_mutex\x26) = delete;\x0a"
"    timed_mutex\x26 operator=(const timed_mutex\x26) = delete;\x0a"
"\x0a"
"    void lock();\x0a"
"    bool try_lock();\x0a"
"    template <class Rep, class Period>\x0a"
"        bool try_lock_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"    template <class Clock, class Duration>\x0a"
"        bool try_lock_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"    void unlock();\x0a"
"};\x0a"
"\x0a"
"class recursive_timed_mutex\x0a"
"{\x0a"
"public\x3a\x0a"
"     recursive_timed_mutex();\x0a"
"     \x7erecursive_timed_mutex();\x0a"
"\x0a"
"    recursive_timed_mutex(const recursive_timed_mutex\x26) = delete;\x0a"
"    recursive_timed_mutex\x26 operator=(const recursive_timed_mutex\x26) = delete;\x0a"
"\x0a"
"    void lock();\x0a"
"    bool try_lock() noexcept;\x0a"
"    template <class Rep, class Period>\x0a"
"        bool try_lock_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"    template <class Clock, class Duration>\x0a"
"        bool try_lock_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"    void unlock();\x0a"
"};\x0a"
"\x0a"
"struct defer_lock_t {};\x0a"
"struct try_to_lock_t {};\x0a"
"struct adopt_lock_t {};\x0a"
"\x0a"
"inline constexpr defer_lock_t  defer_lock{};\x0a"
"inline constexpr try_to_lock_t try_to_lock{};\x0a"
"inline constexpr adopt_lock_t  adopt_lock{};\x0a"
"\x0a"
"template <class Mutex>\x0a"
"class lock_guard\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef Mutex mutex_type;\x0a"
"\x0a"
"    explicit lock_guard(mutex_type\x26 m);\x0a"
"    lock_guard(mutex_type\x26 m, adopt_lock_t);\x0a"
"    \x7elock_guard();\x0a"
"\x0a"
"    lock_guard(lock_guard const\x26) = delete;\x0a"
"    lock_guard\x26 operator=(lock_guard const\x26) = delete;\x0a"
"};\x0a"
"\x0a"
"template <class... MutexTypes>\x0a"
"class scoped_lock // C++17\x0a"
"{\x0a"
"public\x3a\x0a"
"    using mutex_type = Mutex;  // If MutexTypes... consists of the single type Mutex\x0a"
"\x0a"
"    explicit scoped_lock(MutexTypes\x26... m);\x0a"
"    scoped_lock(adopt_lock_t, MutexTypes\x26... m);\x0a"
"    \x7escoped_lock();\x0a"
"    scoped_lock(scoped_lock const\x26) = delete;\x0a"
"    scoped_lock\x26 operator=(scoped_lock const\x26) = delete;\x0a"
"private\x3a\x0a"
"    tuple<MutexTypes\x26...> pm; // exposition only\x0a"
"};\x0a"
"\x0a"
"template <class Mutex>\x0a"
"class unique_lock\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef Mutex mutex_type;\x0a"
"    unique_lock() noexcept;\x0a"
"    explicit unique_lock(mutex_type\x26 m);\x0a"
"    unique_lock(mutex_type\x26 m, defer_lock_t) noexcept;\x0a"
"    unique_lock(mutex_type\x26 m, try_to_lock_t);\x0a"
"    unique_lock(mutex_type\x26 m, adopt_lock_t);\x0a"
"    template <class Clock, class Duration>\x0a"
"        unique_lock(mutex_type\x26 m, const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"    template <class Rep, class Period>\x0a"
"        unique_lock(mutex_type\x26 m, const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"    \x7eunique_lock();\x0a"
"\x0a"
"    unique_lock(unique_lock const\x26) = delete;\x0a"
"    unique_lock\x26 operator=(unique_lock const\x26) = delete;\x0a"
"\x0a"
"    unique_lock(unique_lock\x26\x26 u) noexcept;\x0a"
"    unique_lock\x26 operator=(unique_lock\x26\x26 u) noexcept;\x0a"
"\x0a"
"    void lock();\x0a"
"    bool try_lock();\x0a"
"\x0a"
"    template <class Rep, class Period>\x0a"
"        bool try_lock_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"    template <class Clock, class Duration>\x0a"
"        bool try_lock_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"\x0a"
"    void unlock();\x0a"
"\x0a"
"    void swap(unique_lock\x26 u) noexcept;\x0a"
"    mutex_type* release() noexcept;\x0a"
"\x0a"
"    bool owns_lock() const noexcept;\x0a"
"    explicit operator bool () const noexcept;\x0a"
"    mutex_type* mutex() const noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class Mutex>\x0a"
"  void swap(unique_lock<Mutex>\x26 x, unique_lock<Mutex>\x26 y) noexcept;\x0a"
"\x0a"
"template <class L1, class L2, class... L3>\x0a"
"  int try_lock(L1\x26, L2\x26, L3\x26...);\x0a"
"template <class L1, class L2, class... L3>\x0a"
"  void lock(L1\x26, L2\x26, L3\x26...);\x0a"
"\x0a"
"struct once_flag\x0a"
"{\x0a"
"    constexpr once_flag() noexcept;\x0a"
"\x0a"
"    once_flag(const once_flag\x26) = delete;\x0a"
"    once_flag\x26 operator=(const once_flag\x26) = delete;\x0a"
"};\x0a"
"\x0a"
"template<class Callable, class ...Args>\x0a"
"  void call_once(once_flag\x26 flag, Callable\x26\x26 func, Args\x26\x26... args);\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__mutex_base>\x0a"
"#include <cstdint>\x0a"
"#include <functional>\x0a"
"#include <memory>\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"#include <tuple>\x0a"
"#endif\x0a"
"#include <version>\x0a"
"#include <__threading_support>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS recursive_mutex\x0a"
"{\x0a"
"    __libcpp_recursive_mutex_t __m_;\x0a"
"\x0a"
"public\x3a\x0a"
"     recursive_mutex();\x0a"
"     \x7erecursive_mutex();\x0a"
"\x0a"
"private\x3a\x0a"
"    recursive_mutex(const recursive_mutex\x26); // = delete;\x0a"
"    recursive_mutex\x26 operator=(const recursive_mutex\x26); // = delete;\x0a"
"\x0a"
"public\x3a\x0a"
"    void lock();\x0a"
"    bool try_lock() _NOEXCEPT;\x0a"
"    void unlock()  _NOEXCEPT;\x0a"
"\x0a"
"    typedef __libcpp_recursive_mutex_t* native_handle_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    native_handle_type native_handle() {return \x26__m_;}\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS timed_mutex\x0a"
"{\x0a"
"    mutex              __m_;\x0a"
"    condition_variable __cv_;\x0a"
"    bool               __locked_;\x0a"
"public\x3a\x0a"
"     timed_mutex();\x0a"
"     \x7etimed_mutex();\x0a"
"\x0a"
"private\x3a\x0a"
"    timed_mutex(const timed_mutex\x26); // = delete;\x0a"
"    timed_mutex\x26 operator=(const timed_mutex\x26); // = delete;\x0a"
"\x0a"
"public\x3a\x0a"
"    void lock();\x0a"
"    bool try_lock() _NOEXCEPT;\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool try_lock_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d)\x0a"
"            {return try_lock_until(chrono\x3a\x3asteady_clock\x3a\x3anow() + __d);}\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        bool try_lock_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t);\x0a"
"    void unlock() _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"template <class _Clock, class _Duration>\x0a"
"bool\x0a"
"timed_mutex\x3a\x3atry_lock_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    using namespace chrono;\x0a"
"    unique_lock<mutex> __lk(__m_);\x0a"
"    bool no_timeout = _Clock\x3a\x3anow() < __t;\x0a"
"    while (no_timeout \x26\x26 __locked_)\x0a"
"        no_timeout = __cv_.wait_until(__lk, __t) == cv_status\x3a\x3ano_timeout;\x0a"
"    if (\x21__locked_)\x0a"
"    {\x0a"
"        __locked_ = true;\x0a"
"        return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS recursive_timed_mutex\x0a"
"{\x0a"
"    mutex              __m_;\x0a"
"    condition_variable __cv_;\x0a"
"    size_t             __count_;\x0a"
"    __thread_id        __id_;\x0a"
"public\x3a\x0a"
"     recursive_timed_mutex();\x0a"
"     \x7erecursive_timed_mutex();\x0a"
"\x0a"
"private\x3a\x0a"
"    recursive_timed_mutex(const recursive_timed_mutex\x26); // = delete;\x0a"
"    recursive_timed_mutex\x26 operator=(const recursive_timed_mutex\x26); // = delete;\x0a"
"\x0a"
"public\x3a\x0a"
"    void lock();\x0a"
"    bool try_lock() _NOEXCEPT;\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool try_lock_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d)\x0a"
"            {return try_lock_until(chrono\x3a\x3asteady_clock\x3a\x3anow() + __d);}\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        bool try_lock_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t);\x0a"
"    void unlock() _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"template <class _Clock, class _Duration>\x0a"
"bool\x0a"
"recursive_timed_mutex\x3a\x3atry_lock_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    using namespace chrono;\x0a"
"    __thread_id __id = this_thread\x3a\x3aget_id();\x0a"
"    unique_lock<mutex> lk(__m_);\x0a"
"    if (__id == __id_)\x0a"
"    {\x0a"
"        if (__count_ == numeric_limits<size_t>\x3a\x3amax())\x0a"
"            return false;\x0a"
"        ++__count_;\x0a"
"        return true;\x0a"
"    }\x0a"
"    bool no_timeout = _Clock\x3a\x3anow() < __t;\x0a"
"    while (no_timeout \x26\x26 __count_ \x21= 0)\x0a"
"        no_timeout = __cv_.wait_until(lk, __t) == cv_status\x3a\x3ano_timeout;\x0a"
"    if (__count_ == 0)\x0a"
"    {\x0a"
"        __count_ = 1;\x0a"
"        __id_ = __id;\x0a"
"        return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _L0, class _L1>\x0a"
"int\x0a"
"try_lock(_L0\x26 __l0, _L1\x26 __l1)\x0a"
"{\x0a"
"    unique_lock<_L0> __u0(__l0, try_to_lock);\x0a"
"    if (__u0.owns_lock())\x0a"
"    {\x0a"
"        if (__l1.try_lock())\x0a"
"        {\x0a"
"            __u0.release();\x0a"
"            return -1;\x0a"
"        }\x0a"
"        else\x0a"
"            return 1;\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _L0, class _L1, class _L2, class... _L3>\x0a"
"int\x0a"
"try_lock(_L0\x26 __l0, _L1\x26 __l1, _L2\x26 __l2, _L3\x26... __l3)\x0a"
"{\x0a"
"    int __r = 0;\x0a"
"    unique_lock<_L0> __u0(__l0, try_to_lock);\x0a"
"    if (__u0.owns_lock())\x0a"
"    {\x0a"
"        __r = try_lock(__l1, __l2, __l3...);\x0a"
"        if (__r == -1)\x0a"
"            __u0.release();\x0a"
"        else\x0a"
"            ++__r;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _L0, class _L1>\x0a"
"void\x0a"
"lock(_L0\x26 __l0, _L1\x26 __l1)\x0a"
"{\x0a"
"    while (true)\x0a"
"    {\x0a"
"        {\x0a"
"            unique_lock<_L0> __u0(__l0);\x0a"
"            if (__l1.try_lock())\x0a"
"            {\x0a"
"                __u0.release();\x0a"
"                break;\x0a"
"            }\x0a"
"        }\x0a"
"        __libcpp_thread_yield();\x0a"
"        {\x0a"
"            unique_lock<_L1> __u1(__l1);\x0a"
"            if (__l0.try_lock())\x0a"
"            {\x0a"
"                __u1.release();\x0a"
"                break;\x0a"
"            }\x0a"
"        }\x0a"
"        __libcpp_thread_yield();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _L0, class _L1, class _L2, class ..._L3>\x0a"
"void\x0a"
"__lock_first(int __i, _L0\x26 __l0, _L1\x26 __l1, _L2\x26 __l2, _L3\x26 ...__l3)\x0a"
"{\x0a"
"    while (true)\x0a"
"    {\x0a"
"        switch (__i)\x0a"
"        {\x0a"
"        case 0\x3a\x0a"
"            {\x0a"
"                unique_lock<_L0> __u0(__l0);\x0a"
"                __i = try_lock(__l1, __l2, __l3...);\x0a"
"                if (__i == -1)\x0a"
"                {\x0a"
"                    __u0.release();\x0a"
"                    return;\x0a"
"                }\x0a"
"            }\x0a"
"            ++__i;\x0a"
"            __libcpp_thread_yield();\x0a"
"            break;\x0a"
"        case 1\x3a\x0a"
"            {\x0a"
"                unique_lock<_L1> __u1(__l1);\x0a"
"                __i = try_lock(__l2, __l3..., __l0);\x0a"
"                if (__i == -1)\x0a"
"                {\x0a"
"                    __u1.release();\x0a"
"                    return;\x0a"
"                }\x0a"
"            }\x0a"
"            if (__i == sizeof...(_L3) + 1)\x0a"
"                __i = 0;\x0a"
"            else\x0a"
"                __i += 2;\x0a"
"            __libcpp_thread_yield();\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            __lock_first(__i - 2, __l2, __l3..., __l0, __l1);\x0a"
"            return;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _L0, class _L1, class _L2, class ..._L3>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"lock(_L0\x26 __l0, _L1\x26 __l1, _L2\x26 __l2, _L3\x26 ...__l3)\x0a"
"{\x0a"
"    __lock_first(0, __l0, __l1, __l2, __l3...);\x0a"
"}\x0a"
"\x0a"
"template <class _L0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __unlock(_L0\x26 __l0) {\x0a"
"    __l0.unlock();\x0a"
"}\x0a"
"\x0a"
"template <class _L0, class _L1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __unlock(_L0\x26 __l0, _L1\x26 __l1) {\x0a"
"    __l0.unlock();\x0a"
"    __l1.unlock();\x0a"
"}\x0a"
"\x0a"
"template <class _L0, class _L1, class _L2, class ..._L3>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __unlock(_L0\x26 __l0, _L1\x26 __l1, _L2\x26 __l2, _L3\x26... __l3) {\x0a"
"    __l0.unlock();\x0a"
"    __l1.unlock();\x0a"
"    _VSTD\x3a\x3a__unlock(__l2, __l3...);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class ..._Mutexes>\x0a"
"class _LIBCPP_TEMPLATE_VIS scoped_lock;\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TEMPLATE_VIS scoped_lock<> {\x0a"
"public\x3a\x0a"
"    explicit scoped_lock() {}\x0a"
"    \x7escoped_lock() = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit scoped_lock(adopt_lock_t) {}\x0a"
"\x0a"
"    scoped_lock(scoped_lock const\x26) = delete;\x0a"
"    scoped_lock\x26 operator=(scoped_lock const\x26) = delete;\x0a"
"};\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_THREAD_SAFETY_ANNOTATION(scoped_lockable) scoped_lock<_Mutex> {\x0a"
"public\x3a\x0a"
"    typedef _Mutex  mutex_type;\x0a"
"private\x3a\x0a"
"    mutex_type\x26 __m_;\x0a"
"public\x3a\x0a"
"    explicit scoped_lock(mutex_type \x26 __m) _LIBCPP_THREAD_SAFETY_ANNOTATION(acquire_capability(__m))\x0a"
"        \x3a __m_(__m) {__m_.lock();}\x0a"
"\x0a"
"    \x7escoped_lock() _LIBCPP_THREAD_SAFETY_ANNOTATION(release_capability()) {__m_.unlock();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit scoped_lock(adopt_lock_t, mutex_type\x26 __m) _LIBCPP_THREAD_SAFETY_ANNOTATION(requires_capability(__m))\x0a"
"        \x3a __m_(__m) {}\x0a"
"\x0a"
"    scoped_lock(scoped_lock const\x26) = delete;\x0a"
"    scoped_lock\x26 operator=(scoped_lock const\x26) = delete;\x0a"
"};\x0a"
"\x0a"
"template <class ..._MArgs>\x0a"
"class _LIBCPP_TEMPLATE_VIS scoped_lock\x0a"
"{\x0a"
"    static_assert(sizeof...(_MArgs) > 1, \x22""At least 2 lock types required\x22);\x0a"
"    typedef tuple<_MArgs\x26...> _MutexTuple;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit scoped_lock(_MArgs\x26... __margs)\x0a"
"      \x3a __t_(__margs...)\x0a"
"    {\x0a"
"        _VSTD\x3a\x3alock(__margs...);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    scoped_lock(adopt_lock_t, _MArgs\x26... __margs)\x0a"
"        \x3a __t_(__margs...)\x0a"
"    {\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7escoped_lock() {\x0a"
"        typedef typename __make_tuple_indices<sizeof...(_MArgs)>\x3a\x3atype _Indices;\x0a"
"        __unlock_unpack(_Indices{}, __t_);\x0a"
"    }\x0a"
"\x0a"
"    scoped_lock(scoped_lock const\x26) = delete;\x0a"
"    scoped_lock\x26 operator=(scoped_lock const\x26) = delete;\x0a"
"\x0a"
"private\x3a\x0a"
"    template <size_t ..._Indx>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void __unlock_unpack(__tuple_indices<_Indx...>, _MutexTuple\x26 __mt) {\x0a"
"        _VSTD\x3a\x3a__unlock(_VSTD\x3a\x3aget<_Indx>(__mt)...);\x0a"
"    }\x0a"
"\x0a"
"    _MutexTuple __t_;\x0a"
"};\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"struct _LIBCPP_TEMPLATE_VIS once_flag;\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _Callable, class... _Args>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void call_once(once_flag\x26, _Callable\x26\x26, _Args\x26\x26...);\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _Callable>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void call_once(once_flag\x26, _Callable\x26);\x0a"
"\x0a"
"template<class _Callable>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void call_once(once_flag\x26, const _Callable\x26);\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"struct _LIBCPP_TEMPLATE_VIS once_flag\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR\x0a"
"        once_flag() _NOEXCEPT \x3a __state_(0) {}\x0a"
"\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT)\x0a"
"   typedef uintptr_t _State_type;\x0a"
"#else\x0a"
"   typedef unsigned long _State_type;\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"private\x3a\x0a"
"    once_flag(const once_flag\x26); // = delete;\x0a"
"    once_flag\x26 operator=(const once_flag\x26); // = delete;\x0a"
"\x0a"
"    _State_type __state_;\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template<class _Callable, class... _Args>\x0a"
"    friend\x0a"
"    void call_once(once_flag\x26, _Callable\x26\x26, _Args\x26\x26...);\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"    template<class _Callable>\x0a"
"    friend\x0a"
"    void call_once(once_flag\x26, _Callable\x26);\x0a"
"\x0a"
"    template<class _Callable>\x0a"
"    friend\x0a"
"    void call_once(once_flag\x26, const _Callable\x26);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Fp>\x0a"
"class __call_once_param\x0a"
"{\x0a"
"    _Fp\x26 __f_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __call_once_param(_Fp\x26 __f) \x3a __f_(__f) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator()()\x0a"
"    {\x0a"
"        typedef typename __make_tuple_indices<tuple_size<_Fp>\x3a\x3avalue, 1>\x3a\x3atype _Index;\x0a"
"        __execute(_Index());\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    template <size_t ..._Indices>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __execute(__tuple_indices<_Indices...>)\x0a"
"    {\x0a"
"        __invoke(_VSTD\x3a\x3aget<0>(_VSTD\x3a\x3amove(__f_)), _VSTD\x3a\x3aget<_Indices>(_VSTD\x3a\x3amove(__f_))...);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Fp>\x0a"
"class __call_once_param\x0a"
"{\x0a"
"    _Fp\x26 __f_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __call_once_param(_Fp\x26 __f) \x3a __f_(__f) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator()()\x0a"
"    {\x0a"
"        __f_();\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"template <class _Fp>\x0a"
"void\x0a"
"__call_once_proxy(void* __vp)\x0a"
"{\x0a"
"    __call_once_param<_Fp>* __p = static_cast<__call_once_param<_Fp>*>(__vp);\x0a"
"    (*__p)();\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS void __call_once(volatile once_flag\x3a\x3a_State_type\x26, void*,\x0a"
"                                  void (*)(void*));\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _Callable, class... _Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"call_once(once_flag\x26 __flag, _Callable\x26\x26 __func, _Args\x26\x26... __args)\x0a"
"{\x0a"
"    if (__libcpp_acquire_load(\x26__flag.__state_) \x21= \x7eonce_flag\x3a\x3a_State_type(0))\x0a"
"    {\x0a"
"        typedef tuple<_Callable\x26\x26, _Args\x26\x26...> _Gp;\x0a"
"        _Gp __f(_VSTD\x3a\x3a""forward<_Callable>(__func), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        __call_once_param<_Gp> __p(__f);\x0a"
"        __call_once(__flag.__state_, \x26__p, \x26__call_once_proxy<_Gp>);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _Callable>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"call_once(once_flag\x26 __flag, _Callable\x26 __func)\x0a"
"{\x0a"
"    if (__libcpp_acquire_load(\x26__flag.__state_) \x21= \x7eonce_flag\x3a\x3a_State_type(0))\x0a"
"    {\x0a"
"        __call_once_param<_Callable> __p(__func);\x0a"
"        __call_once(__flag.__state_, \x26__p, \x26__call_once_proxy<_Callable>);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template<class _Callable>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"call_once(once_flag\x26 __flag, const _Callable\x26 __func)\x0a"
"{\x0a"
"    if (__libcpp_acquire_load(\x26__flag.__state_) \x21= \x7eonce_flag\x3a\x3a_State_type(0))\x0a"
"    {\x0a"
"        __call_once_param<const _Callable> __p(__func);\x0a"
"        __call_once(__flag.__state_, \x26__p, \x26__call_once_proxy<const _Callable>);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_MUTEX\x0a"
"", 17533 ); }