#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_numeric( 
"// -*- C++ -*-\x0a"
"//===---------------------------- numeric ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_NUMERIC\x0a"
"#define _LIBCPP_NUMERIC\x0a"
"\x0a"
"/*\x0a"
"    numeric synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class InputIterator, class T>\x0a"
"    T\x0a"
"    accumulate(InputIterator first, InputIterator last, T init);\x0a"
"\x0a"
"template <class InputIterator, class T, class BinaryOperation>\x0a"
"    T\x0a"
"    accumulate(InputIterator first, InputIterator last, T init, BinaryOperation binary_op);\x0a"
"\x0a"
"template<class InputIterator>\x0a"
"    typename iterator_traits<InputIterator>\x3a\x3avalue_type\x0a"
"    reduce(InputIterator first, InputIterator last);  // C++17\x0a"
"\x0a"
"template<class InputIterator, class T>\x0a"
"    T\x0a"
"    reduce(InputIterator first, InputIterator last, T init);  // C++17\x0a"
"\x0a"
"template<class InputIterator, class T, class BinaryOperation>\x0a"
"    T\x0a"
"    reduce(InputIterator first, InputIterator last, T init, BinaryOperation binary_op);  // C++17\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class T>\x0a"
"    T\x0a"
"    inner_product(InputIterator1 first1, InputIterator1 last1, InputIterator2 first2, T init);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class T, class BinaryOperation1, class BinaryOperation2>\x0a"
"    T\x0a"
"    inner_product(InputIterator1 first1, InputIterator1 last1, InputIterator2 first2,\x0a"
"                  T init, BinaryOperation1 binary_op1, BinaryOperation2 binary_op2);\x0a"
"\x0a"
"\x0a"
"template<class InputIterator1, class InputIterator2, class T>\x0a"
"    T\x0a"
"    transform_reduce(InputIterator1 first1, InputIterator1 last1,\x0a"
"                     InputIterator2 first2, T init);  // C++17\x0a"
"\x0a"
"template<class InputIterator1, class InputIterator2, class T, class BinaryOperation1, class BinaryOperation2>\x0a"
"    T\x0a"
"    transform_reduce(InputIterator1 first1, InputIterator1 last1,\x0a"
"                     InputIterator2 first2, T init,\x0a"
"                     BinaryOperation1 binary_op1, BinaryOperation2 binary_op2);  // C++17\x0a"
"\x0a"
"template<class InputIterator, class T, class BinaryOperation, class UnaryOperation>\x0a"
"    T\x0a"
"    transform_reduce(InputIterator first, InputIterator last, T init,\x0a"
"                     BinaryOperation binary_op, UnaryOperation unary_op);  // C++17\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    partial_sum(InputIterator first, InputIterator last, OutputIterator result);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator, class BinaryOperation>\x0a"
"    OutputIterator\x0a"
"    partial_sum(InputIterator first, InputIterator last, OutputIterator result, BinaryOperation binary_op);\x0a"
"\x0a"
"template<class InputIterator, class OutputIterator, class T>\x0a"
"    OutputIterator\x0a"
"    exclusive_scan(InputIterator first, InputIterator last,\x0a"
"                   OutputIterator result, T init); // C++17\x0a"
"\x0a"
"template<class InputIterator, class OutputIterator, class T, class BinaryOperation>\x0a"
"    OutputIterator\x0a"
"    exclusive_scan(InputIterator first, InputIterator last,\x0a"
"                   OutputIterator result, T init, BinaryOperation binary_op); // C++17\x0a"
"\x0a"
"template<class InputIterator, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    inclusive_scan(InputIterator first, InputIterator last, OutputIterator result);  // C++17\x0a"
"\x0a"
"template<class InputIterator, class OutputIterator, class BinaryOperation>\x0a"
"    OutputIterator\x0a"
"    inclusive_scan(InputIterator first, InputIterator last,\x0a"
"                   OutputIterator result, BinaryOperation binary_op);  // C++17\x0a"
"\x0a"
"template<class InputIterator, class OutputIterator, class BinaryOperation, class T>\x0a"
"    OutputIterator\x0a"
"    inclusive_scan(InputIterator first, InputIterator last,\x0a"
"                   OutputIterator result, BinaryOperation binary_op, T init);  // C++17\x0a"
"\x0a"
"template<class InputIterator, class OutputIterator, class T,\x0a"
"         class BinaryOperation, class UnaryOperation>\x0a"
"    OutputIterator\x0a"
"    transform_exclusive_scan(InputIterator first, InputIterator last,\x0a"
"                             OutputIterator result, T init,\x0a"
"                             BinaryOperation binary_op, UnaryOperation unary_op);  // C++17\x0a"
"\x0a"
"template<class InputIterator, class OutputIterator,\x0a"
"         class BinaryOperation, class UnaryOperation>\x0a"
"    OutputIterator\x0a"
"    transform_inclusive_scan(InputIterator first, InputIterator last,\x0a"
"                             OutputIterator result,\x0a"
"                             BinaryOperation binary_op, UnaryOperation unary_op);  // C++17\x0a"
"\x0a"
"template<class InputIterator, class OutputIterator,\x0a"
"         class BinaryOperation, class UnaryOperation, class T>\x0a"
"    OutputIterator\x0a"
"    transform_inclusive_scan(InputIterator first, InputIterator last,\x0a"
"                             OutputIterator result,\x0a"
"                             BinaryOperation binary_op, UnaryOperation unary_op,\x0a"
"                             T init);  // C++17\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    adjacent_difference(InputIterator first, InputIterator last, OutputIterator result);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator, class BinaryOperation>\x0a"
"    OutputIterator\x0a"
"    adjacent_difference(InputIterator first, InputIterator last, OutputIterator result, BinaryOperation binary_op);\x0a"
"\x0a"
"template <class ForwardIterator, class T>\x0a"
"    void iota(ForwardIterator first, ForwardIterator last, T value);\x0a"
"\x0a"
"template <class M, class N>\x0a"
"    constexpr common_type_t<M,N> gcd(M m, N n);    // C++17\x0a"
"\x0a"
"template <class M, class N>\x0a"
"    constexpr common_type_t<M,N> lcm(M m, N n);    // C++17\x0a"
"\x0a"
"integer         midpoint(integer a, integer b);                  // C++20\x0a"
"pointer         midpoint(pointer a, pointer b);                  // C++20\x0a"
"floating_point  midpoint(floating_point a, floating_point b);    // C++20\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <iterator>\x0a"
"#include <limits> // for numeric_limits\x0a"
"#include <functional>\x0a"
"#include <cmath> // for isnormal\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _InputIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"accumulate(_InputIterator __first, _InputIterator __last, _Tp __init)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __init = __init + *__first;\x0a"
"    return __init;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _Tp, class _BinaryOperation>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"accumulate(_InputIterator __first, _InputIterator __last, _Tp __init, _BinaryOperation __binary_op)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __init = __binary_op(__init, *__first);\x0a"
"    return __init;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _InputIterator, class _Tp, class _BinaryOp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"reduce(_InputIterator __first, _InputIterator __last, _Tp __init, _BinaryOp __b)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __init = __b(__init, *__first);\x0a"
"    return __init;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"reduce(_InputIterator __first, _InputIterator __last, _Tp __init)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3areduce(__first, __last, __init, _VSTD\x3a\x3aplus<>());\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename iterator_traits<_InputIterator>\x3a\x3avalue_type\x0a"
"reduce(_InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3areduce(__first, __last,\x0a"
"       typename iterator_traits<_InputIterator>\x3a\x3avalue_type{});\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"inner_product(_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _Tp __init)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__first1, (void) ++__first2)\x0a"
"        __init = __init + *__first1 * *__first2;\x0a"
"    return __init;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _Tp, class _BinaryOperation1, class _BinaryOperation2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"inner_product(_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2,\x0a"
"              _Tp __init, _BinaryOperation1 __binary_op1, _BinaryOperation2 __binary_op2)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__first1, (void) ++__first2)\x0a"
"        __init = __binary_op1(__init, __binary_op2(*__first1, *__first2));\x0a"
"    return __init;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _InputIterator, class _Tp, class _BinaryOp, class _UnaryOp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"transform_reduce(_InputIterator __first, _InputIterator __last,\x0a"
"           _Tp __init,  _BinaryOp __b, _UnaryOp __u)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __init = __b(__init, __u(*__first));\x0a"
"    return __init;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2,\x0a"
"          class _Tp, class _BinaryOp1, class _BinaryOp2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"transform_reduce(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                 _InputIterator2 __first2, _Tp __init,  _BinaryOp1 __b1, _BinaryOp2 __b2)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__first1, (void) ++__first2)\x0a"
"        __init = __b1(__init, __b2(*__first1, *__first2));\x0a"
"    return __init;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp\x0a"
"transform_reduce(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                 _InputIterator2 __first2, _Tp __init)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3atransform_reduce(__first1, __last1, __first2, _VSTD\x3a\x3amove(__init),\x0a"
"                                   _VSTD\x3a\x3aplus<>(), _VSTD\x3a\x3amultiplies<>());\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"partial_sum(_InputIterator __first, _InputIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        typename iterator_traits<_InputIterator>\x3a\x3avalue_type __t(*__first);\x0a"
"        *__result = __t;\x0a"
"        for (++__first, (void) ++__result; __first \x21= __last; ++__first, (void) ++__result)\x0a"
"        {\x0a"
"            __t = __t + *__first;\x0a"
"            *__result = __t;\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _BinaryOperation>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"partial_sum(_InputIterator __first, _InputIterator __last, _OutputIterator __result,\x0a"
"              _BinaryOperation __binary_op)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        typename iterator_traits<_InputIterator>\x3a\x3avalue_type __t(*__first);\x0a"
"        *__result = __t;\x0a"
"        for (++__first, (void) ++__result; __first \x21= __last; ++__first, (void) ++__result)\x0a"
"        {\x0a"
"            __t = __binary_op(__t, *__first);\x0a"
"            *__result = __t;\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _InputIterator, class _OutputIterator, class _Tp, class _BinaryOp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"exclusive_scan(_InputIterator __first, _InputIterator __last,\x0a"
"               _OutputIterator __result, _Tp __init, _BinaryOp __b)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _Tp __saved = __init;\x0a"
"        do\x0a"
"        {\x0a"
"            __init = __b(__init, *__first);\x0a"
"            *__result = __saved;\x0a"
"            __saved = __init;\x0a"
"            ++__result;\x0a"
"        } while (++__first \x21= __last);\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"exclusive_scan(_InputIterator __first, _InputIterator __last,\x0a"
"               _OutputIterator __result, _Tp __init)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""exclusive_scan(__first, __last, __result, __init, _VSTD\x3a\x3aplus<>());\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _Tp, class _BinaryOp>\x0a"
"_OutputIterator inclusive_scan(_InputIterator __first, _InputIterator __last,\x0a"
"                               _OutputIterator __result, _BinaryOp __b,  _Tp __init)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first, (void) ++__result) {\x0a"
"        __init = __b(__init, *__first);\x0a"
"        *__result = __init;\x0a"
"        }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _BinaryOp>\x0a"
"_OutputIterator inclusive_scan(_InputIterator __first, _InputIterator __last,\x0a"
"                               _OutputIterator __result, _BinaryOp __b)\x0a"
"{\x0a"
"    if (__first \x21= __last) {\x0a"
"        typename std\x3a\x3aiterator_traits<_InputIterator>\x3a\x3avalue_type __init = *__first;\x0a"
"        *__result++ = __init;\x0a"
"        if (++__first \x21= __last)\x0a"
"            return _VSTD\x3a\x3ainclusive_scan(__first, __last, __result, __b, __init);\x0a"
"        }\x0a"
"\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator>\x0a"
"_OutputIterator inclusive_scan(_InputIterator __first, _InputIterator __last,\x0a"
"                               _OutputIterator __result)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3ainclusive_scan(__first, __last, __result, std\x3a\x3aplus<>());\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _Tp,\x0a"
"          class _BinaryOp, class _UnaryOp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"transform_exclusive_scan(_InputIterator __first, _InputIterator __last,\x0a"
"                           _OutputIterator __result, _Tp __init,\x0a"
"                           _BinaryOp __b, _UnaryOp __u)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _Tp __saved = __init;\x0a"
"        do\x0a"
"        {\x0a"
"            __init = __b(__init, __u(*__first));\x0a"
"            *__result = __saved;\x0a"
"            __saved = __init;\x0a"
"            ++__result;\x0a"
"        } while (++__first \x21= __last);\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _Tp, class _BinaryOp, class _UnaryOp>\x0a"
"_OutputIterator transform_inclusive_scan(_InputIterator __first, _InputIterator __last,\x0a"
"                           _OutputIterator __result, _BinaryOp __b, _UnaryOp __u, _Tp __init)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first, (void) ++__result) {\x0a"
"        __init = __b(__init, __u(*__first));\x0a"
"        *__result = __init;\x0a"
"        }\x0a"
"\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _BinaryOp, class _UnaryOp>\x0a"
"_OutputIterator transform_inclusive_scan(_InputIterator __first, _InputIterator __last,\x0a"
"                               _OutputIterator __result, _BinaryOp __b, _UnaryOp __u)\x0a"
"{\x0a"
"    if (__first \x21= __last) {\x0a"
"        typename std\x3a\x3aiterator_traits<_InputIterator>\x3a\x3avalue_type __init = __u(*__first);\x0a"
"        *__result++ = __init;\x0a"
"        if (++__first \x21= __last)\x0a"
"            return _VSTD\x3a\x3atransform_inclusive_scan(__first, __last, __result, __b, __u, __init);\x0a"
"        }\x0a"
"\x0a"
"    return __result;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"adjacent_difference(_InputIterator __first, _InputIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        typename iterator_traits<_InputIterator>\x3a\x3avalue_type __t1(*__first);\x0a"
"        *__result = __t1;\x0a"
"        for (++__first, (void) ++__result; __first \x21= __last; ++__first, (void) ++__result)\x0a"
"        {\x0a"
"            typename iterator_traits<_InputIterator>\x3a\x3avalue_type __t2(*__first);\x0a"
"            *__result = __t2 - __t1;\x0a"
"            __t1 = _VSTD\x3a\x3amove(__t2);\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _BinaryOperation>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"adjacent_difference(_InputIterator __first, _InputIterator __last, _OutputIterator __result,\x0a"
"                      _BinaryOperation __binary_op)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        typename iterator_traits<_InputIterator>\x3a\x3avalue_type __t1(*__first);\x0a"
"        *__result = __t1;\x0a"
"        for (++__first, (void) ++__result; __first \x21= __last; ++__first, (void) ++__result)\x0a"
"        {\x0a"
"            typename iterator_traits<_InputIterator>\x3a\x3avalue_type __t2(*__first);\x0a"
"            *__result = __binary_op(__t2, __t1);\x0a"
"            __t1 = _VSTD\x3a\x3amove(__t2);\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"iota(_ForwardIterator __first, _ForwardIterator __last, _Tp __value_)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first, (void) ++__value_)\x0a"
"        *__first = __value_;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <typename _Result, typename _Source, bool _IsSigned = is_signed<_Source>\x3a\x3avalue> struct __ct_abs;\x0a"
"\x0a"
"template <typename _Result, typename _Source>\x0a"
"struct __ct_abs<_Result, _Source, true> {\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Result operator()(_Source __t) const noexcept\x0a"
"    {\x0a"
"    if (__t >= 0) return __t;\x0a"
"    if (__t == numeric_limits<_Source>\x3a\x3amin()) return -static_cast<_Result>(__t);\x0a"
"    return -__t;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <typename _Result, typename _Source>\x0a"
"struct __ct_abs<_Result, _Source, false> {\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Result operator()(_Source __t) const noexcept { return __t; }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_CONSTEXPR _LIBCPP_HIDDEN\x0a"
"_Tp __gcd(_Tp __m, _Tp __n)\x0a"
"{\x0a"
"    static_assert((\x21is_signed<_Tp>\x3a\x3avalue), \x22\x22);\x0a"
"    return __n == 0 \x3f __m \x3a _VSTD\x3a\x3a__gcd<_Tp>(__n, __m \x25 __n);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"_LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"common_type_t<_Tp,_Up>\x0a"
"gcd(_Tp __m, _Up __n)\x0a"
"{\x0a"
"    static_assert((is_integral<_Tp>\x3a\x3avalue \x26\x26 is_integral<_Up>\x3a\x3avalue), \x22""Arguments to gcd must be integer types\x22);\x0a"
"    static_assert((\x21is_same<typename remove_cv<_Tp>\x3a\x3atype, bool>\x3a\x3avalue), \x22""First argument to gcd cannot be bool\x22 );\x0a"
"    static_assert((\x21is_same<typename remove_cv<_Up>\x3a\x3atype, bool>\x3a\x3avalue), \x22Second argument to gcd cannot be bool\x22 );\x0a"
"    using _Rp = common_type_t<_Tp,_Up>;\x0a"
"    using _Wp = make_unsigned_t<_Rp>;\x0a"
"    return static_cast<_Rp>(_VSTD\x3a\x3a__gcd(\x0a"
"        static_cast<_Wp>(__ct_abs<_Rp, _Tp>()(__m)),\x0a"
"        static_cast<_Wp>(__ct_abs<_Rp, _Up>()(__n))));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"_LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"common_type_t<_Tp,_Up>\x0a"
"lcm(_Tp __m, _Up __n)\x0a"
"{\x0a"
"    static_assert((is_integral<_Tp>\x3a\x3avalue \x26\x26 is_integral<_Up>\x3a\x3avalue), \x22""Arguments to lcm must be integer types\x22);\x0a"
"    static_assert((\x21is_same<typename remove_cv<_Tp>\x3a\x3atype, bool>\x3a\x3avalue), \x22""First argument to lcm cannot be bool\x22 );\x0a"
"    static_assert((\x21is_same<typename remove_cv<_Up>\x3a\x3atype, bool>\x3a\x3avalue), \x22Second argument to lcm cannot be bool\x22 );\x0a"
"    if (__m == 0 \x7c\x7c __n == 0)\x0a"
"        return 0;\x0a"
"\x0a"
"    using _Rp = common_type_t<_Tp,_Up>;\x0a"
"    _Rp __val1 = __ct_abs<_Rp, _Tp>()(__m) / _VSTD\x3a\x3agcd(__m, __n);\x0a"
"    _Rp __val2 = __ct_abs<_Rp, _Up>()(__n);\x0a"
"    _LIBCPP_ASSERT((numeric_limits<_Rp>\x3a\x3amax() / __val1 > __val2), \x22Overflow in lcm\x22);\x0a"
"    return __val1 * __val2;\x0a"
"}\x0a"
"\x0a"
"#endif /* _LIBCPP_STD_VER > 14 */\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<is_integral_v<_Tp> \x26\x26 \x21is_same_v<bool, _Tp> \x26\x26 \x21is_null_pointer_v<_Tp>, _Tp>\x0a"
"midpoint(_Tp __a, _Tp __b) noexcept\x0a"
"_LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"{\x0a"
"    using _Up = std\x3a\x3amake_unsigned_t<_Tp>;\x0a"
"\x0a"
"    int __sign = 1;\x0a"
"    _Up __m = __a;\x0a"
"    _Up __M = __b;\x0a"
"    if (__a > __b)\x0a"
"    {\x0a"
"        __sign = -1;\x0a"
"        __m = __b;\x0a"
"        __M = __a;\x0a"
"    }\x0a"
"     return __a + __sign * _Tp(_Up(__M-__m) >> 1);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _TPtr>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<is_pointer_v<_TPtr>\x0a"
"             \x26\x26 is_object_v<remove_pointer_t<_TPtr>>\x0a"
"             \x26\x26 \x21 is_void_v<remove_pointer_t<_TPtr>>\x0a"
"             \x26\x26 (sizeof(remove_pointer_t<_TPtr>) > 0), _TPtr>\x0a"
"midpoint(_TPtr __a, _TPtr __b) noexcept\x0a"
"{\x0a"
"    return __a + _VSTD\x3a\x3amidpoint(ptrdiff_t(0), __b - __a);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"constexpr int __sign(_Tp __val) {\x0a"
"    return (_Tp(0) < __val) - (__val < _Tp(0));\x0a"
"}\x0a"
"\x0a"
"template <typename _Fp>\x0a"
"constexpr _Fp __fp_abs(_Fp __f) { return __f >= 0 \x3f __f \x3a -__f; }\x0a"
"\x0a"
"template <class _Fp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"enable_if_t<is_floating_point_v<_Fp>, _Fp>\x0a"
"midpoint(_Fp __a, _Fp __b) noexcept\x0a"
"{\x0a"
"\x09""constexpr _Fp __lo = numeric_limits<_Fp>\x3a\x3amin()*2;\x0a"
"\x09""constexpr _Fp __hi = numeric_limits<_Fp>\x3a\x3amax()/2;\x0a"
"    return __fp_abs(__a) <= __hi \x26\x26 __fp_abs(__b) <= __hi \x3f  // typical case\x3a overflow is impossible\x0a"
"      (__a + __b)/2 \x3a                                        // always correctly rounded\x0a"
"      __fp_abs(__a) < __lo \x3f __a + __b/2 \x3a                   // not safe to halve a\x0a"
"      __fp_abs(__a) < __lo \x3f __a/2 + __b \x3a                   // not safe to halve b\x0a"
"      __a/2 + __b/2;                                         // otherwise correctly rounded\x0a"
"}\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_NUMERIC\x0a"
"", 20394 ); }