#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_optional( 
"// -*- C++ -*-\x0a"
"//===-------------------------- optional ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_OPTIONAL\x0a"
"#define _LIBCPP_OPTIONAL\x0a"
"\x0a"
"/*\x0a"
"    optional synopsis\x0a"
"\x0a"
"// C++1z\x0a"
"\x0a"
"namespace std {\x0a"
"  // 23.6.3, optional for object types\x0a"
"  template <class T> class optional;\x0a"
"\x0a"
"  // 23.6.4, no-value state indicator\x0a"
"  struct nullopt_t{see below };\x0a"
"  inline constexpr nullopt_t nullopt(unspecified );\x0a"
"\x0a"
"  // 23.6.5, class bad_optional_access\x0a"
"  class bad_optional_access;\x0a"
"\x0a"
"  // 23.6.6, relational operators\x0a"
"  template <class T, class U>\x0a"
"  constexpr bool operator==(const optional<T>\x26, const optional<U>\x26);\x0a"
"  template <class T, class U>\x0a"
"  constexpr bool operator\x21=(const optional<T>\x26, const optional<U>\x26);\x0a"
"  template <class T, class U>\x0a"
"  constexpr bool operator<(const optional<T>\x26, const optional<U>\x26);\x0a"
"  template <class T, class U>\x0a"
"  constexpr bool operator>(const optional<T>\x26, const optional<U>\x26);\x0a"
"  template <class T, class U>\x0a"
"  constexpr bool operator<=(const optional<T>\x26, const optional<U>\x26);\x0a"
"  template <class T, class U>\x0a"
"  constexpr bool operator>=(const optional<T>\x26, const optional<U>\x26);\x0a"
"\x0a"
"  // 23.6.7 comparison with nullopt\x0a"
"  template <class T> constexpr bool operator==(const optional<T>\x26, nullopt_t) noexcept;\x0a"
"  template <class T> constexpr bool operator==(nullopt_t, const optional<T>\x26) noexcept;\x0a"
"  template <class T> constexpr bool operator\x21=(const optional<T>\x26, nullopt_t) noexcept;\x0a"
"  template <class T> constexpr bool operator\x21=(nullopt_t, const optional<T>\x26) noexcept;\x0a"
"  template <class T> constexpr bool operator<(const optional<T>\x26, nullopt_t) noexcept;\x0a"
"  template <class T> constexpr bool operator<(nullopt_t, const optional<T>\x26) noexcept;\x0a"
"  template <class T> constexpr bool operator<=(const optional<T>\x26, nullopt_t) noexcept;\x0a"
"  template <class T> constexpr bool operator<=(nullopt_t, const optional<T>\x26) noexcept;\x0a"
"  template <class T> constexpr bool operator>(const optional<T>\x26, nullopt_t) noexcept;\x0a"
"  template <class T> constexpr bool operator>(nullopt_t, const optional<T>\x26) noexcept;\x0a"
"  template <class T> constexpr bool operator>=(const optional<T>\x26, nullopt_t) noexcept;\x0a"
"  template <class T> constexpr bool operator>=(nullopt_t, const optional<T>\x26) noexcept;\x0a"
"\x0a"
"  // 23.6.8, comparison with T\x0a"
"  template <class T, class U> constexpr bool operator==(const optional<T>\x26, const U\x26);\x0a"
"  template <class T, class U> constexpr bool operator==(const T\x26, const optional<U>\x26);\x0a"
"  template <class T, class U> constexpr bool operator\x21=(const optional<T>\x26, const U\x26);\x0a"
"  template <class T, class U> constexpr bool operator\x21=(const T\x26, const optional<U>\x26);\x0a"
"  template <class T, class U> constexpr bool operator<(const optional<T>\x26, const U\x26);\x0a"
"  template <class T, class U> constexpr bool operator<(const T\x26, const optional<U>\x26);\x0a"
"  template <class T, class U> constexpr bool operator<=(const optional<T>\x26, const U\x26);\x0a"
"  template <class T, class U> constexpr bool operator<=(const T\x26, const optional<U>\x26);\x0a"
"  template <class T, class U> constexpr bool operator>(const optional<T>\x26, const U\x26);\x0a"
"  template <class T, class U> constexpr bool operator>(const T\x26, const optional<U>\x26);\x0a"
"  template <class T, class U> constexpr bool operator>=(const optional<T>\x26, const U\x26);\x0a"
"  template <class T, class U> constexpr bool operator>=(const T\x26, const optional<U>\x26);\x0a"
"\x0a"
"  // 23.6.9, specialized algorithms\x0a"
"  template <class T> void swap(optional<T>\x26, optional<T>\x26) noexcept(see below );\x0a"
"  template <class T> constexpr optional<see below > make_optional(T\x26\x26);\x0a"
"  template <class T, class... Args>\x0a"
"    constexpr optional<T> make_optional(Args\x26\x26... args);\x0a"
"  template <class T, class U, class... Args>\x0a"
"    constexpr optional<T> make_optional(initializer_list<U> il, Args\x26\x26... args);\x0a"
"\x0a"
"  // 23.6.10, hash support\x0a"
"  template <class T> struct hash;\x0a"
"  template <class T> struct hash<optional<T>>;\x0a"
"\x0a"
"  template <class T> class optional {\x0a"
"  public\x3a\x0a"
"    using value_type = T;\x0a"
"\x0a"
"    // 23.6.3.1, constructors\x0a"
"    constexpr optional() noexcept;\x0a"
"    constexpr optional(nullopt_t) noexcept;\x0a"
"    optional(const optional \x26);\x0a"
"    optional(optional \x26\x26) noexcept(see below);\x0a"
"    template <class... Args> constexpr explicit optional(in_place_t, Args \x26\x26...);\x0a"
"    template <class U, class... Args>\x0a"
"      constexpr explicit optional(in_place_t, initializer_list<U>, Args \x26\x26...);\x0a"
"    template <class U = T>\x0a"
"      constexpr EXPLICIT optional(U \x26\x26);\x0a"
"    template <class U>\x0a"
"      constexpr EXPLICIT optional(const optional<U> \x26);\x0a"
"    template <class U>\x0a"
"      constexpr EXPLICIT optional(optional<U> \x26\x26);\x0a"
"\x0a"
"    // 23.6.3.2, destructor\x0a"
"    \x7eoptional();\x0a"
"\x0a"
"    // 23.6.3.3, assignment\x0a"
"    optional \x26operator=(nullopt_t) noexcept;\x0a"
"    optional \x26operator=(const optional \x26);                // constexpr in C++20\x0a"
"    optional \x26operator=(optional \x26\x26) noexcept(see below); // constexpr in C++20\x0a"
"    template <class U = T> optional \x26operator=(U \x26\x26);\x0a"
"    template <class U> optional \x26operator=(const optional<U> \x26);\x0a"
"    template <class U> optional \x26operator=(optional<U> \x26\x26);\x0a"
"    template <class... Args> T\x26 emplace(Args \x26\x26...);\x0a"
"    template <class U, class... Args>\x0a"
"      T\x26 emplace(initializer_list<U>, Args \x26\x26...);\x0a"
"\x0a"
"    // 23.6.3.4, swap\x0a"
"    void swap(optional \x26) noexcept(see below );\x0a"
"\x0a"
"    // 23.6.3.5, observers\x0a"
"    constexpr T const *operator->() const;\x0a"
"    constexpr T *operator->();\x0a"
"    constexpr T const \x26operator*() const \x26;\x0a"
"    constexpr T \x26operator*() \x26;\x0a"
"    constexpr T \x26\x26operator*() \x26\x26;\x0a"
"    constexpr const T \x26\x26operator*() const \x26\x26;\x0a"
"    constexpr explicit operator bool() const noexcept;\x0a"
"    constexpr bool has_value() const noexcept;\x0a"
"    constexpr T const \x26value() const \x26;\x0a"
"    constexpr T \x26value() \x26;\x0a"
"    constexpr T \x26\x26value() \x26\x26;\x0a"
"    constexpr const T \x26\x26value() const \x26\x26;\x0a"
"    template <class U> constexpr T value_or(U \x26\x26) const \x26;\x0a"
"    template <class U> constexpr T value_or(U \x26\x26) \x26\x26;\x0a"
"\x0a"
"    // 23.6.3.6, modifiers\x0a"
"    void reset() noexcept;\x0a"
"\x0a"
"  private\x3a\x0a"
"    T *val; // exposition only\x0a"
"  };\x0a"
"\x0a"
"template<class T>\x0a"
"  optional(T) -> optional<T>;\x0a"
"\x0a"
"} // namespace std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__debug>\x0a"
"#include <__functional_base>\x0a"
"#include <functional>\x0a"
"#include <initializer_list>\x0a"
"#include <new>\x0a"
"#include <stdexcept>\x0a"
"#include <type_traits>\x0a"
"#include <utility>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"namespace std  // purposefully not using versioning namespace\x0a"
"{\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI _LIBCPP_AVAILABILITY_BAD_OPTIONAL_ACCESS bad_optional_access\x0a"
"    \x3a public exception\x0a"
"{\x0a"
"public\x3a\x0a"
"    // Get the key function \x7e""bad_optional_access() into the dylib\x0a"
"    virtual \x7e""bad_optional_access() _NOEXCEPT;\x0a"
"    virtual const char* what() const _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_NORETURN\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_OPTIONAL_ACCESS\x0a"
"void __throw_bad_optional_access() {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        throw bad_optional_access();\x0a"
"#else\x0a"
"        _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"struct nullopt_t\x0a"
"{\x0a"
"    struct __secret_tag { _LIBCPP_INLINE_VISIBILITY explicit __secret_tag() = default; };\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr explicit nullopt_t(__secret_tag, __secret_tag) noexcept {}\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VAR constexpr nullopt_t nullopt{nullopt_t\x3a\x3a__secret_tag{}, nullopt_t\x3a\x3a__secret_tag{}};\x0a"
"\x0a"
"template <class _Tp, bool = is_trivially_destructible<_Tp>\x3a\x3avalue>\x0a"
"struct __optional_destruct_base;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __optional_destruct_base<_Tp, false>\x0a"
"{\x0a"
"    typedef _Tp value_type;\x0a"
"    static_assert(is_object_v<value_type>,\x0a"
"        \x22instantiation of optional with a non-object type is undefined behavior\x22);\x0a"
"    union\x0a"
"    {\x0a"
"        char __null_state_;\x0a"
"        value_type __val_;\x0a"
"    };\x0a"
"    bool __engaged_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e__optional_destruct_base()\x0a"
"    {\x0a"
"        if (__engaged_)\x0a"
"            __val_.\x7evalue_type();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr __optional_destruct_base() noexcept\x0a"
"        \x3a  __null_state_(),\x0a"
"           __engaged_(false) {}\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr explicit __optional_destruct_base(in_place_t, _Args\x26\x26... __args)\x0a"
"        \x3a  __val_(_VSTD\x3a\x3a""forward<_Args>(__args)...),\x0a"
"           __engaged_(true) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() noexcept\x0a"
"    {\x0a"
"        if (__engaged_)\x0a"
"        {\x0a"
"            __val_.\x7evalue_type();\x0a"
"            __engaged_ = false;\x0a"
"        }\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __optional_destruct_base<_Tp, true>\x0a"
"{\x0a"
"    typedef _Tp value_type;\x0a"
"    static_assert(is_object_v<value_type>,\x0a"
"        \x22instantiation of optional with a non-object type is undefined behavior\x22);\x0a"
"    union\x0a"
"    {\x0a"
"        char __null_state_;\x0a"
"        value_type __val_;\x0a"
"    };\x0a"
"    bool __engaged_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr __optional_destruct_base() noexcept\x0a"
"        \x3a  __null_state_(),\x0a"
"           __engaged_(false) {}\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr explicit __optional_destruct_base(in_place_t, _Args\x26\x26... __args)\x0a"
"        \x3a  __val_(_VSTD\x3a\x3a""forward<_Args>(__args)...),\x0a"
"           __engaged_(true) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() noexcept\x0a"
"    {\x0a"
"        if (__engaged_)\x0a"
"        {\x0a"
"            __engaged_ = false;\x0a"
"        }\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool = is_reference<_Tp>\x3a\x3avalue>\x0a"
"struct __optional_storage_base \x3a __optional_destruct_base<_Tp>\x0a"
"{\x0a"
"    using __base = __optional_destruct_base<_Tp>;\x0a"
"    using value_type = _Tp;\x0a"
"    using __base\x3a\x3a__base;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr bool has_value() const noexcept\x0a"
"    {\x0a"
"        return this->__engaged_;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr value_type\x26 __get() \x26 noexcept\x0a"
"    {\x0a"
"        return this->__val_;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr const value_type\x26 __get() const\x26 noexcept\x0a"
"    {\x0a"
"        return this->__val_;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr value_type\x26\x26 __get() \x26\x26 noexcept\x0a"
"    {\x0a"
"        return _VSTD\x3a\x3amove(this->__val_);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr const value_type\x26\x26 __get() const\x26\x26 noexcept\x0a"
"    {\x0a"
"        return _VSTD\x3a\x3amove(this->__val_);\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __construct(_Args\x26\x26... __args)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21has_value(), \x22__construct called for engaged __optional_storage\x22);\x0a"
"        \x3a\x3anew((void*)_VSTD\x3a\x3a""addressof(this->__val_)) value_type(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        this->__engaged_ = true;\x0a"
"    }\x0a"
"\x0a"
"    template <class _That>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __construct_from(_That\x26\x26 __opt)\x0a"
"    {\x0a"
"        if (__opt.has_value())\x0a"
"            __construct(_VSTD\x3a\x3a""forward<_That>(__opt).__get());\x0a"
"    }\x0a"
"\x0a"
"    template <class _That>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __assign_from(_That\x26\x26 __opt)\x0a"
"    {\x0a"
"        if (this->__engaged_ == __opt.has_value())\x0a"
"        {\x0a"
"            if (this->__engaged_)\x0a"
"                this->__val_ = _VSTD\x3a\x3a""forward<_That>(__opt).__get();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (this->__engaged_)\x0a"
"                this->reset();\x0a"
"            else\x0a"
"                __construct(_VSTD\x3a\x3a""forward<_That>(__opt).__get());\x0a"
"        }\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"// optional<T\x26> is currently required ill-formed, however it may to be in the\x0a"
"// future. For this reason it has already been implemented to ensure we can\x0a"
"// make the change in an ABI compatible manner.\x0a"
"template <class _Tp>\x0a"
"struct __optional_storage_base<_Tp, true>\x0a"
"{\x0a"
"    using value_type = _Tp;\x0a"
"    using __raw_type = remove_reference_t<_Tp>;\x0a"
"    __raw_type* __value_;\x0a"
"\x0a"
"    template <class _Up>\x0a"
"    static constexpr bool __can_bind_reference() {\x0a"
"        using _RawUp = typename remove_reference<_Up>\x3a\x3atype;\x0a"
"        using _UpPtr = _RawUp*;\x0a"
"        using _RawTp = typename remove_reference<_Tp>\x3a\x3atype;\x0a"
"        using _TpPtr = _RawTp*;\x0a"
"        using _CheckLValueArg = integral_constant<bool,\x0a"
"            (is_lvalue_reference<_Up>\x3a\x3avalue \x26\x26 is_convertible<_UpPtr, _TpPtr>\x3a\x3avalue)\x0a"
"        \x7c\x7c  is_same<_RawUp, reference_wrapper<_RawTp>>\x3a\x3avalue\x0a"
"        \x7c\x7c  is_same<_RawUp, reference_wrapper<typename remove_const<_RawTp>\x3a\x3atype>>\x3a\x3avalue\x0a"
"        >;\x0a"
"        return (is_lvalue_reference<_Tp>\x3a\x3avalue \x26\x26 _CheckLValueArg\x3a\x3avalue)\x0a"
"            \x7c\x7c (is_rvalue_reference<_Tp>\x3a\x3avalue \x26\x26 \x21is_lvalue_reference<_Up>\x3a\x3avalue \x26\x26\x0a"
"                is_convertible<_UpPtr, _TpPtr>\x3a\x3avalue);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr __optional_storage_base() noexcept\x0a"
"        \x3a  __value_(nullptr) {}\x0a"
"\x0a"
"    template <class _UArg>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr explicit __optional_storage_base(in_place_t, _UArg\x26\x26 __uarg)\x0a"
"        \x3a  __value_(_VSTD\x3a\x3a""addressof(__uarg))\x0a"
"    {\x0a"
"      static_assert(__can_bind_reference<_UArg>(),\x0a"
"        \x22""Attempted to construct a reference element in tuple from a \x22\x0a"
"        \x22possible temporary\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() noexcept { __value_ = nullptr; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr bool has_value() const noexcept\x0a"
"      { return __value_ \x21= nullptr; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr value_type\x26 __get() const\x26 noexcept\x0a"
"      { return *__value_; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr value_type\x26\x26 __get() const\x26\x26 noexcept\x0a"
"      { return _VSTD\x3a\x3a""forward<value_type>(*__value_); }\x0a"
"\x0a"
"    template <class _UArg>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __construct(_UArg\x26\x26 __val)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21has_value(), \x22__construct called for engaged __optional_storage\x22);\x0a"
"        static_assert(__can_bind_reference<_UArg>(),\x0a"
"            \x22""Attempted to construct a reference element in tuple from a \x22\x0a"
"            \x22possible temporary\x22);\x0a"
"        __value_ = _VSTD\x3a\x3a""addressof(__val);\x0a"
"    }\x0a"
"\x0a"
"    template <class _That>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __construct_from(_That\x26\x26 __opt)\x0a"
"    {\x0a"
"        if (__opt.has_value())\x0a"
"            __construct(_VSTD\x3a\x3a""forward<_That>(__opt).__get());\x0a"
"    }\x0a"
"\x0a"
"    template <class _That>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __assign_from(_That\x26\x26 __opt)\x0a"
"    {\x0a"
"        if (has_value() == __opt.has_value())\x0a"
"        {\x0a"
"            if (has_value())\x0a"
"                *__value_ = _VSTD\x3a\x3a""forward<_That>(__opt).__get();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (has_value())\x0a"
"                reset();\x0a"
"            else\x0a"
"                __construct(_VSTD\x3a\x3a""forward<_That>(__opt).__get());\x0a"
"        }\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool = is_trivially_copy_constructible<_Tp>\x3a\x3avalue>\x0a"
"struct __optional_copy_base \x3a __optional_storage_base<_Tp>\x0a"
"{\x0a"
"    using __optional_storage_base<_Tp>\x3a\x3a__optional_storage_base;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __optional_copy_base<_Tp, false> \x3a __optional_storage_base<_Tp>\x0a"
"{\x0a"
"    using __optional_storage_base<_Tp>\x3a\x3a__optional_storage_base;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_copy_base() = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_copy_base(const __optional_copy_base\x26 __opt)\x0a"
"    {\x0a"
"        this->__construct_from(__opt);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_copy_base(__optional_copy_base\x26\x26) = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_copy_base\x26 operator=(const __optional_copy_base\x26) = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_copy_base\x26 operator=(__optional_copy_base\x26\x26) = default;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool = is_trivially_move_constructible<_Tp>\x3a\x3avalue>\x0a"
"struct __optional_move_base \x3a __optional_copy_base<_Tp>\x0a"
"{\x0a"
"    using __optional_copy_base<_Tp>\x3a\x3a__optional_copy_base;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __optional_move_base<_Tp, false> \x3a __optional_copy_base<_Tp>\x0a"
"{\x0a"
"    using value_type = _Tp;\x0a"
"    using __optional_copy_base<_Tp>\x3a\x3a__optional_copy_base;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_move_base() = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_move_base(const __optional_move_base\x26) = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_move_base(__optional_move_base\x26\x26 __opt)\x0a"
"        noexcept(is_nothrow_move_constructible_v<value_type>)\x0a"
"    {\x0a"
"        this->__construct_from(_VSTD\x3a\x3amove(__opt));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_move_base\x26 operator=(const __optional_move_base\x26) = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_move_base\x26 operator=(__optional_move_base\x26\x26) = default;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool =\x0a"
"    is_trivially_destructible<_Tp>\x3a\x3avalue \x26\x26\x0a"
"    is_trivially_copy_constructible<_Tp>\x3a\x3avalue \x26\x26\x0a"
"    is_trivially_copy_assignable<_Tp>\x3a\x3avalue>\x0a"
"struct __optional_copy_assign_base \x3a __optional_move_base<_Tp>\x0a"
"{\x0a"
"    using __optional_move_base<_Tp>\x3a\x3a__optional_move_base;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __optional_copy_assign_base<_Tp, false> \x3a __optional_move_base<_Tp>\x0a"
"{\x0a"
"    using __optional_move_base<_Tp>\x3a\x3a__optional_move_base;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_copy_assign_base() = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_copy_assign_base(const __optional_copy_assign_base\x26) = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_copy_assign_base(__optional_copy_assign_base\x26\x26) = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_copy_assign_base\x26 operator=(const __optional_copy_assign_base\x26 __opt)\x0a"
"    {\x0a"
"        this->__assign_from(__opt);\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_copy_assign_base\x26 operator=(__optional_copy_assign_base\x26\x26) = default;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool =\x0a"
"    is_trivially_destructible<_Tp>\x3a\x3avalue \x26\x26\x0a"
"    is_trivially_move_constructible<_Tp>\x3a\x3avalue \x26\x26\x0a"
"    is_trivially_move_assignable<_Tp>\x3a\x3avalue>\x0a"
"struct __optional_move_assign_base \x3a __optional_copy_assign_base<_Tp>\x0a"
"{\x0a"
"    using __optional_copy_assign_base<_Tp>\x3a\x3a__optional_copy_assign_base;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __optional_move_assign_base<_Tp, false> \x3a __optional_copy_assign_base<_Tp>\x0a"
"{\x0a"
"    using value_type = _Tp;\x0a"
"    using __optional_copy_assign_base<_Tp>\x3a\x3a__optional_copy_assign_base;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_move_assign_base() = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_move_assign_base(const __optional_move_assign_base\x26 __opt) = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_move_assign_base(__optional_move_assign_base\x26\x26) = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_move_assign_base\x26 operator=(const __optional_move_assign_base\x26) = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __optional_move_assign_base\x26 operator=(__optional_move_assign_base\x26\x26 __opt)\x0a"
"        noexcept(is_nothrow_move_assignable_v<value_type> \x26\x26\x0a"
"                 is_nothrow_move_constructible_v<value_type>)\x0a"
"    {\x0a"
"        this->__assign_from(_VSTD\x3a\x3amove(__opt));\x0a"
"        return *this;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"using __optional_sfinae_ctor_base_t = __sfinae_ctor_base<\x0a"
"    is_copy_constructible<_Tp>\x3a\x3avalue,\x0a"
"    is_move_constructible<_Tp>\x3a\x3avalue\x0a"
">;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"using __optional_sfinae_assign_base_t = __sfinae_assign_base<\x0a"
"    (is_copy_constructible<_Tp>\x3a\x3avalue \x26\x26 is_copy_assignable<_Tp>\x3a\x3avalue),\x0a"
"    (is_move_constructible<_Tp>\x3a\x3avalue \x26\x26 is_move_assignable<_Tp>\x3a\x3avalue)\x0a"
">;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class optional\x0a"
"    \x3a private __optional_move_assign_base<_Tp>\x0a"
"    , private __optional_sfinae_ctor_base_t<_Tp>\x0a"
"    , private __optional_sfinae_assign_base_t<_Tp>\x0a"
"{\x0a"
"    using __base = __optional_move_assign_base<_Tp>;\x0a"
"public\x3a\x0a"
"    using value_type = _Tp;\x0a"
"\x0a"
"private\x3a\x0a"
"     // Disable the reference extension using this static assert.\x0a"
"    static_assert(\x21is_same_v<__uncvref_t<value_type>, in_place_t>,\x0a"
"        \x22instantiation of optional with in_place_t is ill-formed\x22);\x0a"
"    static_assert(\x21is_same_v<__uncvref_t<value_type>, nullopt_t>,\x0a"
"        \x22instantiation of optional with nullopt_t is ill-formed\x22);\x0a"
"    static_assert(\x21is_reference_v<value_type>,\x0a"
"        \x22instantiation of optional with a reference type is ill-formed\x22);\x0a"
"    static_assert(is_destructible_v<value_type>,\x0a"
"        \x22instantiation of optional with a non-destructible type is ill-formed\x22);\x0a"
"    static_assert(\x21is_array_v<value_type>,\x0a"
"        \x22instantiation of optional with an array type is ill-formed\x22);\x0a"
"\x0a"
"    // LWG2756\x3a conditionally explicit conversion from _Up\x0a"
"    struct _CheckOptionalArgsConstructor {\x0a"
"      template <class _Up>\x0a"
"      static constexpr bool __enable_implicit() {\x0a"
"          return is_constructible_v<_Tp, _Up\x26\x26> \x26\x26\x0a"
"                 is_convertible_v<_Up\x26\x26, _Tp>;\x0a"
"      }\x0a"
"\x0a"
"      template <class _Up>\x0a"
"      static constexpr bool __enable_explicit() {\x0a"
"          return is_constructible_v<_Tp, _Up\x26\x26> \x26\x26\x0a"
"                 \x21is_convertible_v<_Up\x26\x26, _Tp>;\x0a"
"      }\x0a"
"    };\x0a"
"    template <class _Up>\x0a"
"    using _CheckOptionalArgsCtor = _If<\x0a"
"        _IsNotSame<__uncvref_t<_Up>, in_place_t>\x3a\x3avalue \x26\x26\x0a"
"        _IsNotSame<__uncvref_t<_Up>, optional>\x3a\x3avalue,\x0a"
"        _CheckOptionalArgsConstructor,\x0a"
"        __check_tuple_constructor_fail\x0a"
"    >;\x0a"
"    template <class _QualUp>\x0a"
"    struct _CheckOptionalLikeConstructor {\x0a"
"      template <class _Up, class _Opt = optional<_Up>>\x0a"
"      using __check_constructible_from_opt = _Or<\x0a"
"          is_constructible<_Tp, _Opt\x26>,\x0a"
"          is_constructible<_Tp, _Opt const\x26>,\x0a"
"          is_constructible<_Tp, _Opt\x26\x26>,\x0a"
"          is_constructible<_Tp, _Opt const\x26\x26>,\x0a"
"          is_convertible<_Opt\x26, _Tp>,\x0a"
"          is_convertible<_Opt const\x26, _Tp>,\x0a"
"          is_convertible<_Opt\x26\x26, _Tp>,\x0a"
"          is_convertible<_Opt const\x26\x26, _Tp>\x0a"
"      >;\x0a"
"      template <class _Up, class _Opt = optional<_Up>>\x0a"
"      using __check_assignable_from_opt = _Or<\x0a"
"          is_assignable<_Tp\x26, _Opt\x26>,\x0a"
"          is_assignable<_Tp\x26, _Opt const\x26>,\x0a"
"          is_assignable<_Tp\x26, _Opt\x26\x26>,\x0a"
"          is_assignable<_Tp\x26, _Opt const\x26\x26>\x0a"
"      >;\x0a"
"      template <class _Up, class _QUp = _QualUp>\x0a"
"      static constexpr bool __enable_implicit() {\x0a"
"          return is_convertible<_QUp, _Tp>\x3a\x3avalue \x26\x26\x0a"
"              \x21__check_constructible_from_opt<_Up>\x3a\x3avalue;\x0a"
"      }\x0a"
"      template <class _Up, class _QUp = _QualUp>\x0a"
"      static constexpr bool __enable_explicit() {\x0a"
"          return \x21is_convertible<_QUp, _Tp>\x3a\x3avalue \x26\x26\x0a"
"              \x21__check_constructible_from_opt<_Up>\x3a\x3avalue;\x0a"
"      }\x0a"
"      template <class _Up, class _QUp = _QualUp>\x0a"
"      static constexpr bool __enable_assign() {\x0a"
"          // Construction and assignability of _Qup to _Tp has already been\x0a"
"          // checked.\x0a"
"          return \x21__check_constructible_from_opt<_Up>\x3a\x3avalue \x26\x26\x0a"
"              \x21__check_assignable_from_opt<_Up>\x3a\x3avalue;\x0a"
"      }\x0a"
"    };\x0a"
"\x0a"
"    template <class _Up, class _QualUp>\x0a"
"    using _CheckOptionalLikeCtor = _If<\x0a"
"      _And<\x0a"
"         _IsNotSame<_Up, _Tp>,\x0a"
"          is_constructible<_Tp, _QualUp>\x0a"
"      >\x3a\x3avalue,\x0a"
"      _CheckOptionalLikeConstructor<_QualUp>,\x0a"
"      __check_tuple_constructor_fail\x0a"
"    >;\x0a"
"    template <class _Up, class _QualUp>\x0a"
"    using _CheckOptionalLikeAssign = _If<\x0a"
"      _And<\x0a"
"          _IsNotSame<_Up, _Tp>,\x0a"
"          is_constructible<_Tp, _QualUp>,\x0a"
"          is_assignable<_Tp\x26, _QualUp>\x0a"
"      >\x3a\x3avalue,\x0a"
"      _CheckOptionalLikeConstructor<_QualUp>,\x0a"
"      __check_tuple_constructor_fail\x0a"
"    >;\x0a"
"public\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr optional() noexcept {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr optional(const optional\x26) = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr optional(optional\x26\x26) = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr optional(nullopt_t) noexcept {}\x0a"
"\x0a"
"    template <class _InPlaceT, class... _Args, class = _EnableIf<\x0a"
"          _And<\x0a"
"              _IsSame<_InPlaceT, in_place_t>,\x0a"
"              is_constructible<value_type, _Args...>\x0a"
"            >\x3a\x3avalue\x0a"
"        >\x0a"
"    >\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr explicit optional(_InPlaceT, _Args\x26\x26... __args)\x0a"
"        \x3a __base(in_place, _VSTD\x3a\x3a""forward<_Args>(__args)...) {}\x0a"
"\x0a"
"    template <class _Up, class... _Args, class = _EnableIf<\x0a"
"        is_constructible_v<value_type, initializer_list<_Up>\x26, _Args...>>\x0a"
"    >\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr explicit optional(in_place_t, initializer_list<_Up> __il, _Args\x26\x26... __args)\x0a"
"        \x3a __base(in_place, __il, _VSTD\x3a\x3a""forward<_Args>(__args)...) {}\x0a"
"\x0a"
"    template <class _Up = value_type, _EnableIf<\x0a"
"        _CheckOptionalArgsCtor<_Up>\x3a\x3atemplate __enable_implicit<_Up>()\x0a"
"    , int> = 0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr optional(_Up\x26\x26 __v)\x0a"
"        \x3a __base(in_place, _VSTD\x3a\x3a""forward<_Up>(__v)) {}\x0a"
"\x0a"
"    template <class _Up, _EnableIf<\x0a"
"        _CheckOptionalArgsCtor<_Up>\x3a\x3atemplate __enable_explicit<_Up>()\x0a"
"    , int> = 0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr explicit optional(_Up\x26\x26 __v)\x0a"
"        \x3a __base(in_place, _VSTD\x3a\x3a""forward<_Up>(__v)) {}\x0a"
"\x0a"
"    // LWG2756\x3a conditionally explicit conversion from const optional<_Up>\x26\x0a"
"    template <class _Up, _EnableIf<\x0a"
"        _CheckOptionalLikeCtor<_Up, _Up const\x26>\x3a\x3atemplate __enable_implicit<_Up>()\x0a"
"    , int> = 0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    optional(const optional<_Up>\x26 __v)\x0a"
"    {\x0a"
"        this->__construct_from(__v);\x0a"
"    }\x0a"
"    template <class _Up, _EnableIf<\x0a"
"        _CheckOptionalLikeCtor<_Up, _Up const\x26>\x3a\x3atemplate __enable_explicit<_Up>()\x0a"
"    , int> = 0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit optional(const optional<_Up>\x26 __v)\x0a"
"    {\x0a"
"        this->__construct_from(__v);\x0a"
"    }\x0a"
"\x0a"
"    // LWG2756\x3a conditionally explicit conversion from optional<_Up>\x26\x26\x0a"
"    template <class _Up, _EnableIf<\x0a"
"        _CheckOptionalLikeCtor<_Up, _Up \x26\x26>\x3a\x3atemplate __enable_implicit<_Up>()\x0a"
"    , int> = 0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    optional(optional<_Up>\x26\x26 __v)\x0a"
"    {\x0a"
"        this->__construct_from(_VSTD\x3a\x3amove(__v));\x0a"
"    }\x0a"
"    template <class _Up, _EnableIf<\x0a"
"        _CheckOptionalLikeCtor<_Up, _Up \x26\x26>\x3a\x3atemplate __enable_explicit<_Up>()\x0a"
"    , int> = 0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit optional(optional<_Up>\x26\x26 __v)\x0a"
"    {\x0a"
"        this->__construct_from(_VSTD\x3a\x3amove(__v));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    optional\x26 operator=(nullopt_t) noexcept\x0a"
"    {\x0a"
"        reset();\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY optional\x26 operator=(const optional\x26) = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY optional\x26 operator=(optional\x26\x26) = default;\x0a"
"\x0a"
"    // LWG2756\x0a"
"    template <class _Up = value_type,\x0a"
"              class = _EnableIf<\x0a"
"                      _And<\x0a"
"                          _IsNotSame<__uncvref_t<_Up>, optional>,\x0a"
"                          _Or<\x0a"
"                              _IsNotSame<__uncvref_t<_Up>, value_type>,\x0a"
"                              _Not<is_scalar<value_type>>\x0a"
"                          >,\x0a"
"                          is_constructible<value_type, _Up>,\x0a"
"                          is_assignable<value_type\x26, _Up>\x0a"
"                      >\x3a\x3avalue>\x0a"
"             >\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    optional\x26\x0a"
"    operator=(_Up\x26\x26 __v)\x0a"
"    {\x0a"
"        if (this->has_value())\x0a"
"            this->__get() = _VSTD\x3a\x3a""forward<_Up>(__v);\x0a"
"        else\x0a"
"            this->__construct(_VSTD\x3a\x3a""forward<_Up>(__v));\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    // LWG2756\x0a"
"    template <class _Up, _EnableIf<\x0a"
"        _CheckOptionalLikeAssign<_Up, _Up const\x26>\x3a\x3atemplate __enable_assign<_Up>()\x0a"
"    , int> = 0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    optional\x26\x0a"
"    operator=(const optional<_Up>\x26 __v)\x0a"
"    {\x0a"
"        this->__assign_from(__v);\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    // LWG2756\x0a"
"    template <class _Up, _EnableIf<\x0a"
"        _CheckOptionalLikeCtor<_Up, _Up \x26\x26>\x3a\x3atemplate __enable_assign<_Up>()\x0a"
"    , int> = 0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    optional\x26\x0a"
"    operator=(optional<_Up>\x26\x26 __v)\x0a"
"    {\x0a"
"        this->__assign_from(_VSTD\x3a\x3amove(__v));\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args,\x0a"
"              class = _EnableIf\x0a"
"                      <\x0a"
"                          is_constructible_v<value_type, _Args...>\x0a"
"                      >\x0a"
"             >\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp \x26\x0a"
"    emplace(_Args\x26\x26... __args)\x0a"
"    {\x0a"
"        reset();\x0a"
"        this->__construct(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        return this->__get();\x0a"
"    }\x0a"
"\x0a"
"    template <class _Up, class... _Args,\x0a"
"              class = _EnableIf\x0a"
"                      <\x0a"
"                          is_constructible_v<value_type, initializer_list<_Up>\x26, _Args...>\x0a"
"                      >\x0a"
"             >\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp \x26\x0a"
"    emplace(initializer_list<_Up> __il, _Args\x26\x26... __args)\x0a"
"    {\x0a"
"        reset();\x0a"
"        this->__construct(__il, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        return this->__get();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(optional\x26 __opt)\x0a"
"        noexcept(is_nothrow_move_constructible_v<value_type> \x26\x26\x0a"
"                 is_nothrow_swappable_v<value_type>)\x0a"
"    {\x0a"
"        if (this->has_value() == __opt.has_value())\x0a"
"        {\x0a"
"            using _VSTD\x3a\x3aswap;\x0a"
"            if (this->has_value())\x0a"
"                swap(this->__get(), __opt.__get());\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (this->has_value())\x0a"
"            {\x0a"
"                __opt.__construct(_VSTD\x3a\x3amove(this->__get()));\x0a"
"                reset();\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                this->__construct(_VSTD\x3a\x3amove(__opt.__get()));\x0a"
"                __opt.reset();\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr\x0a"
"    add_pointer_t<value_type const>\x0a"
"    operator->() const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(this->has_value(), \x22optional operator-> called for disengaged value\x22);\x0a"
"#ifndef _LIBCPP_HAS_NO_BUILTIN_ADDRESSOF\x0a"
"        return _VSTD\x3a\x3a""addressof(this->__get());\x0a"
"#else\x0a"
"        return __operator_arrow(__has_operator_addressof<value_type>{}, this->__get());\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr\x0a"
"    add_pointer_t<value_type>\x0a"
"    operator->()\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(this->has_value(), \x22optional operator-> called for disengaged value\x22);\x0a"
"#ifndef _LIBCPP_HAS_NO_BUILTIN_ADDRESSOF\x0a"
"        return _VSTD\x3a\x3a""addressof(this->__get());\x0a"
"#else\x0a"
"        return __operator_arrow(__has_operator_addressof<value_type>{}, this->__get());\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr\x0a"
"    const value_type\x26\x0a"
"    operator*() const\x26\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(this->has_value(), \x22optional operator* called for disengaged value\x22);\x0a"
"        return this->__get();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr\x0a"
"    value_type\x26\x0a"
"    operator*() \x26\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(this->has_value(), \x22optional operator* called for disengaged value\x22);\x0a"
"        return this->__get();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr\x0a"
"    value_type\x26\x26\x0a"
"    operator*() \x26\x26\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(this->has_value(), \x22optional operator* called for disengaged value\x22);\x0a"
"        return _VSTD\x3a\x3amove(this->__get());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr\x0a"
"    const value_type\x26\x26\x0a"
"    operator*() const\x26\x26\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(this->has_value(), \x22optional operator* called for disengaged value\x22);\x0a"
"        return _VSTD\x3a\x3amove(this->__get());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr explicit operator bool() const noexcept { return has_value(); }\x0a"
"\x0a"
"    using __base\x3a\x3ahas_value;\x0a"
"    using __base\x3a\x3a__get;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_AVAILABILITY_THROW_BAD_OPTIONAL_ACCESS\x0a"
"    constexpr value_type const\x26 value() const\x26\x0a"
"    {\x0a"
"        if (\x21this->has_value())\x0a"
"            __throw_bad_optional_access();\x0a"
"        return this->__get();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_AVAILABILITY_THROW_BAD_OPTIONAL_ACCESS\x0a"
"    constexpr value_type\x26 value() \x26\x0a"
"    {\x0a"
"        if (\x21this->has_value())\x0a"
"            __throw_bad_optional_access();\x0a"
"        return this->__get();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_AVAILABILITY_THROW_BAD_OPTIONAL_ACCESS\x0a"
"    constexpr value_type\x26\x26 value() \x26\x26\x0a"
"    {\x0a"
"        if (\x21this->has_value())\x0a"
"            __throw_bad_optional_access();\x0a"
"        return _VSTD\x3a\x3amove(this->__get());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_AVAILABILITY_THROW_BAD_OPTIONAL_ACCESS\x0a"
"    constexpr value_type const\x26\x26 value() const\x26\x26\x0a"
"    {\x0a"
"        if (\x21this->has_value())\x0a"
"            __throw_bad_optional_access();\x0a"
"        return _VSTD\x3a\x3amove(this->__get());\x0a"
"    }\x0a"
"\x0a"
"    template <class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr value_type value_or(_Up\x26\x26 __v) const\x26\x0a"
"    {\x0a"
"        static_assert(is_copy_constructible_v<value_type>,\x0a"
"                      \x22optional<T>\x3a\x3avalue_or\x3a T must be copy constructible\x22);\x0a"
"        static_assert(is_convertible_v<_Up, value_type>,\x0a"
"                      \x22optional<T>\x3a\x3avalue_or\x3a U must be convertible to T\x22);\x0a"
"        return this->has_value() \x3f this->__get() \x3a\x0a"
"                                  static_cast<value_type>(_VSTD\x3a\x3a""forward<_Up>(__v));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr value_type value_or(_Up\x26\x26 __v) \x26\x26\x0a"
"    {\x0a"
"        static_assert(is_move_constructible_v<value_type>,\x0a"
"                      \x22optional<T>\x3a\x3avalue_or\x3a T must be move constructible\x22);\x0a"
"        static_assert(is_convertible_v<_Up, value_type>,\x0a"
"                      \x22optional<T>\x3a\x3avalue_or\x3a U must be convertible to T\x22);\x0a"
"        return this->has_value() \x3f _VSTD\x3a\x3amove(this->__get()) \x3a\x0a"
"                                  static_cast<value_type>(_VSTD\x3a\x3a""forward<_Up>(__v));\x0a"
"    }\x0a"
"\x0a"
"    using __base\x3a\x3areset;\x0a"
"\x0a"
"private\x3a\x0a"
"    template <class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _Up*\x0a"
"    __operator_arrow(true_type, _Up\x26 __x)\x0a"
"    {\x0a"
"        return _VSTD\x3a\x3a""addressof(__x);\x0a"
"    }\x0a"
"\x0a"
"    template <class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static constexpr _Up*\x0a"
"    __operator_arrow(false_type, _Up\x26 __x)\x0a"
"    {\x0a"
"        return \x26__x;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class T>\x0a"
"    optional(T) -> optional<T>;\x0a"
"#endif\x0a"
"\x0a"
"// Comparisons between optionals\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() ==\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator==(const optional<_Tp>\x26 __x, const optional<_Up>\x26 __y)\x0a"
"{\x0a"
"    if (static_cast<bool>(__x) \x21= static_cast<bool>(__y))\x0a"
"        return false;\x0a"
"    if (\x21static_cast<bool>(__x))\x0a"
"        return true;\x0a"
"    return *__x == *__y;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() \x21=\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator\x21=(const optional<_Tp>\x26 __x, const optional<_Up>\x26 __y)\x0a"
"{\x0a"
"    if (static_cast<bool>(__x) \x21= static_cast<bool>(__y))\x0a"
"        return true;\x0a"
"    if (\x21static_cast<bool>(__x))\x0a"
"        return false;\x0a"
"    return *__x \x21= *__y;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() <\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator<(const optional<_Tp>\x26 __x, const optional<_Up>\x26 __y)\x0a"
"{\x0a"
"    if (\x21static_cast<bool>(__y))\x0a"
"        return false;\x0a"
"    if (\x21static_cast<bool>(__x))\x0a"
"        return true;\x0a"
"    return *__x < *__y;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() >\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator>(const optional<_Tp>\x26 __x, const optional<_Up>\x26 __y)\x0a"
"{\x0a"
"    if (\x21static_cast<bool>(__x))\x0a"
"        return false;\x0a"
"    if (\x21static_cast<bool>(__y))\x0a"
"        return true;\x0a"
"    return *__x > *__y;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() <=\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator<=(const optional<_Tp>\x26 __x, const optional<_Up>\x26 __y)\x0a"
"{\x0a"
"    if (\x21static_cast<bool>(__x))\x0a"
"        return true;\x0a"
"    if (\x21static_cast<bool>(__y))\x0a"
"        return false;\x0a"
"    return *__x <= *__y;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() >=\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator>=(const optional<_Tp>\x26 __x, const optional<_Up>\x26 __y)\x0a"
"{\x0a"
"    if (\x21static_cast<bool>(__y))\x0a"
"        return true;\x0a"
"    if (\x21static_cast<bool>(__x))\x0a"
"        return false;\x0a"
"    return *__x >= *__y;\x0a"
"}\x0a"
"\x0a"
"// Comparisons with nullopt\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator==(const optional<_Tp>\x26 __x, nullopt_t) noexcept\x0a"
"{\x0a"
"    return \x21static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator==(nullopt_t, const optional<_Tp>\x26 __x) noexcept\x0a"
"{\x0a"
"    return \x21static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator\x21=(const optional<_Tp>\x26 __x, nullopt_t) noexcept\x0a"
"{\x0a"
"    return static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator\x21=(nullopt_t, const optional<_Tp>\x26 __x) noexcept\x0a"
"{\x0a"
"    return static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator<(const optional<_Tp>\x26, nullopt_t) noexcept\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator<(nullopt_t, const optional<_Tp>\x26 __x) noexcept\x0a"
"{\x0a"
"    return static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator<=(const optional<_Tp>\x26 __x, nullopt_t) noexcept\x0a"
"{\x0a"
"    return \x21static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator<=(nullopt_t, const optional<_Tp>\x26) noexcept\x0a"
"{\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator>(const optional<_Tp>\x26 __x, nullopt_t) noexcept\x0a"
"{\x0a"
"    return static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator>(nullopt_t, const optional<_Tp>\x26) noexcept\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator>=(const optional<_Tp>\x26, nullopt_t) noexcept\x0a"
"{\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"bool\x0a"
"operator>=(nullopt_t, const optional<_Tp>\x26 __x) noexcept\x0a"
"{\x0a"
"    return \x21static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"// Comparisons with T\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() ==\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator==(const optional<_Tp>\x26 __x, const _Up\x26 __v)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f *__x == __v \x3a false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() ==\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator==(const _Tp\x26 __v, const optional<_Up>\x26 __x)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f __v == *__x \x3a false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() \x21=\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator\x21=(const optional<_Tp>\x26 __x, const _Up\x26 __v)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f *__x \x21= __v \x3a true;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() \x21=\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator\x21=(const _Tp\x26 __v, const optional<_Up>\x26 __x)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f __v \x21= *__x \x3a true;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() <\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator<(const optional<_Tp>\x26 __x, const _Up\x26 __v)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f *__x < __v \x3a true;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() <\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator<(const _Tp\x26 __v, const optional<_Up>\x26 __x)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f __v < *__x \x3a false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() <=\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator<=(const optional<_Tp>\x26 __x, const _Up\x26 __v)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f *__x <= __v \x3a true;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() <=\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator<=(const _Tp\x26 __v, const optional<_Up>\x26 __x)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f __v <= *__x \x3a false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() >\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator>(const optional<_Tp>\x26 __x, const _Up\x26 __v)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f *__x > __v \x3a false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() >\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator>(const _Tp\x26 __v, const optional<_Up>\x26 __x)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f __v > *__x \x3a true;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() >=\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator>=(const optional<_Tp>\x26 __x, const _Up\x26 __v)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f *__x >= __v \x3a false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_EnableIf<\x0a"
"    is_convertible_v<decltype(_VSTD\x3a\x3a""declval<const _Tp\x26>() >=\x0a"
"        _VSTD\x3a\x3a""declval<const _Up\x26>()), bool>,\x0a"
"    bool\x0a"
">\x0a"
"operator>=(const _Tp\x26 __v, const optional<_Up>\x26 __x)\x0a"
"{\x0a"
"    return static_cast<bool>(__x) \x3f __v >= *__x \x3a true;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_EnableIf<\x0a"
"    is_move_constructible_v<_Tp> \x26\x26 is_swappable_v<_Tp>,\x0a"
"    void\x0a"
">\x0a"
"swap(optional<_Tp>\x26 __x, optional<_Tp>\x26 __y) noexcept(noexcept(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"optional<decay_t<_Tp>> make_optional(_Tp\x26\x26 __v)\x0a"
"{\x0a"
"    return optional<decay_t<_Tp>>(_VSTD\x3a\x3a""forward<_Tp>(__v));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class... _Args>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"optional<_Tp> make_optional(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    return optional<_Tp>(in_place, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up, class... _Args>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"optional<_Tp> make_optional(initializer_list<_Up> __il,  _Args\x26\x26... __args)\x0a"
"{\x0a"
"    return optional<_Tp>(in_place, __il, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<\x0a"
"    __enable_hash_helper<optional<_Tp>, remove_const_t<_Tp>>\x0a"
">\x0a"
"{\x0a"
"    typedef optional<_Tp> argument_type;\x0a"
"    typedef size_t        result_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator()(const argument_type\x26 __opt) const\x0a"
"    {\x0a"
"        return static_cast<bool>(__opt) \x3f hash<remove_const_t<_Tp>>()(*__opt) \x3a 0;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_OPTIONAL\x0a"
"", 42592 ); }