#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_ostream( 
"// -*- C++ -*-\x0a"
"//===-------------------------- ostream -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_OSTREAM\x0a"
"#define _LIBCPP_OSTREAM\x0a"
"\x0a"
"/*\x0a"
"    ostream synopsis\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> >\x0a"
"class basic_ostream\x0a"
"    \x3a virtual public basic_ios<charT,traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types (inherited from basic_ios (27.5.4))\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    // 27.7.2.2 Constructor/destructor\x3a\x0a"
"    explicit basic_ostream(basic_streambuf<char_type,traits>* sb);\x0a"
"    basic_ostream(basic_ostream\x26\x26 rhs);\x0a"
"    virtual \x7e""basic_ostream();\x0a"
"\x0a"
"    // 27.7.2.3 Assign/swap\x0a"
"    basic_ostream\x26 operator=(const basic_ostream\x26 rhs) = delete; // C++14\x0a"
"    basic_ostream\x26 operator=(basic_ostream\x26\x26 rhs);\x0a"
"    void swap(basic_ostream\x26 rhs);\x0a"
"\x0a"
"    // 27.7.2.4 Prefix/suffix\x3a\x0a"
"    class sentry;\x0a"
"\x0a"
"    // 27.7.2.6 Formatted output\x3a\x0a"
"    basic_ostream\x26 operator<<(basic_ostream\x26 (*pf)(basic_ostream\x26));\x0a"
"    basic_ostream\x26 operator<<(basic_ios<charT, traits>\x26 (*pf)(basic_ios<charT,traits>\x26));\x0a"
"    basic_ostream\x26 operator<<(ios_base\x26 (*pf)(ios_base\x26));\x0a"
"    basic_ostream\x26 operator<<(bool n);\x0a"
"    basic_ostream\x26 operator<<(short n);\x0a"
"    basic_ostream\x26 operator<<(unsigned short n);\x0a"
"    basic_ostream\x26 operator<<(int n);\x0a"
"    basic_ostream\x26 operator<<(unsigned int n);\x0a"
"    basic_ostream\x26 operator<<(long n);\x0a"
"    basic_ostream\x26 operator<<(unsigned long n);\x0a"
"    basic_ostream\x26 operator<<(long long n);\x0a"
"    basic_ostream\x26 operator<<(unsigned long long n);\x0a"
"    basic_ostream\x26 operator<<(float f);\x0a"
"    basic_ostream\x26 operator<<(double f);\x0a"
"    basic_ostream\x26 operator<<(long double f);\x0a"
"    basic_ostream\x26 operator<<(const void* p);\x0a"
"    basic_ostream\x26 operator<<(basic_streambuf<char_type,traits>* sb);\x0a"
"    basic_ostream\x26 operator<<(nullptr_t);\x0a"
"\x0a"
"    // 27.7.2.7 Unformatted output\x3a\x0a"
"    basic_ostream\x26 put(char_type c);\x0a"
"    basic_ostream\x26 write(const char_type* s, streamsize n);\x0a"
"    basic_ostream\x26 flush();\x0a"
"\x0a"
"    // 27.7.2.5 seeks\x3a\x0a"
"    pos_type tellp();\x0a"
"    basic_ostream\x26 seekp(pos_type);\x0a"
"    basic_ostream\x26 seekp(off_type, ios_base\x3a\x3aseekdir);\x0a"
"protected\x3a\x0a"
"    basic_ostream(const basic_ostream\x26 rhs) = delete;\x0a"
"    basic_ostream(basic_ostream\x26\x26 rhs);\x0a"
"    // 27.7.3.3 Assign/swap\x0a"
"    basic_ostream\x26 operator=(basic_ostream\x26 rhs) = delete;\x0a"
"    basic_ostream\x26 operator=(const basic_ostream\x26\x26 rhs);\x0a"
"    void swap(basic_ostream\x26 rhs);\x0a"
"};\x0a"
"\x0a"
"// 27.7.2.6.4 character inserters\x0a"
"\x0a"
"template<class charT, class traits>\x0a"
"  basic_ostream<charT,traits>\x26 operator<<(basic_ostream<charT,traits>\x26, charT);\x0a"
"\x0a"
"template<class charT, class traits>\x0a"
"  basic_ostream<charT,traits>\x26 operator<<(basic_ostream<charT,traits>\x26, char);\x0a"
"\x0a"
"template<class traits>\x0a"
"  basic_ostream<char,traits>\x26 operator<<(basic_ostream<char,traits>\x26, char);\x0a"
"\x0a"
"// signed and unsigned\x0a"
"\x0a"
"template<class traits>\x0a"
"  basic_ostream<char,traits>\x26 operator<<(basic_ostream<char,traits>\x26, signed char);\x0a"
"\x0a"
"template<class traits>\x0a"
"  basic_ostream<char,traits>\x26 operator<<(basic_ostream<char,traits>\x26, unsigned char);\x0a"
"\x0a"
"// NTBS\x0a"
"template<class charT, class traits>\x0a"
"  basic_ostream<charT,traits>\x26 operator<<(basic_ostream<charT,traits>\x26, const charT*);\x0a"
"\x0a"
"template<class charT, class traits>\x0a"
"  basic_ostream<charT,traits>\x26 operator<<(basic_ostream<charT,traits>\x26, const char*);\x0a"
"\x0a"
"template<class traits>\x0a"
"  basic_ostream<char,traits>\x26 operator<<(basic_ostream<char,traits>\x26, const char*);\x0a"
"\x0a"
"// signed and unsigned\x0a"
"template<class traits>\x0a"
"basic_ostream<char,traits>\x26 operator<<(basic_ostream<char,traits>\x26, const signed char*);\x0a"
"\x0a"
"template<class traits>\x0a"
"  basic_ostream<char,traits>\x26 operator<<(basic_ostream<char,traits>\x26, const unsigned char*);\x0a"
"\x0a"
"// swap\x3a\x0a"
"template <class charT, class traits>\x0a"
"  void swap(basic_ostream<charT, traits>\x26 x, basic_ostream<charT, traits>\x26 y);\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"  basic_ostream<charT,traits>\x26 endl(basic_ostream<charT,traits>\x26 os);\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"  basic_ostream<charT,traits>\x26 ends(basic_ostream<charT,traits>\x26 os);\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"  basic_ostream<charT,traits>\x26 flush(basic_ostream<charT,traits>\x26 os);\x0a"
"\x0a"
"// rvalue stream insertion\x0a"
"template <class charT, class traits, class T>\x0a"
"  basic_ostream<charT, traits>\x26\x0a"
"  operator<<(basic_ostream<charT, traits>\x26\x26 os, const T\x26 x);\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <ios>\x0a"
"#include <streambuf>\x0a"
"#include <locale>\x0a"
"#include <iterator>\x0a"
"#include <bitset>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_ostream\x0a"
"    \x3a virtual public basic_ios<_CharT, _Traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types (inherited from basic_ios (27.5.4))\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    // 27.7.2.2 Constructor/destructor\x3a\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    explicit basic_ostream(basic_streambuf<char_type, traits_type>* __sb)\x0a"
"    { this->init(__sb); }\x0a"
"    virtual \x7e""basic_ostream();\x0a"
"protected\x3a\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream(basic_ostream\x26\x26 __rhs);\x0a"
"\x0a"
"    // 27.7.2.3 Assign/swap\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream\x26 operator=(basic_ostream\x26\x26 __rhs);\x0a"
"#endif\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    void swap(basic_ostream\x26 __rhs)\x0a"
"    { basic_ios<char_type, traits_type>\x3a\x3aswap(__rhs); }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    basic_ostream           (const basic_ostream\x26 __rhs) = delete;\x0a"
"    basic_ostream\x26 operator=(const basic_ostream\x26 __rhs) = delete;\x0a"
"#else\x0a"
"    basic_ostream           (const basic_ostream\x26 __rhs); // not defined\x0a"
"    basic_ostream\x26 operator=(const basic_ostream\x26 __rhs); // not defined\x0a"
"#endif\x0a"
"public\x3a\x0a"
"\x0a"
"    // 27.7.2.4 Prefix/suffix\x3a\x0a"
"    class _LIBCPP_TEMPLATE_VIS sentry;\x0a"
"\x0a"
"    // 27.7.2.6 Formatted output\x3a\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_ostream\x26 operator<<(basic_ostream\x26 (*__pf)(basic_ostream\x26))\x0a"
"    { return __pf(*this); }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_ostream\x26 operator<<(basic_ios<char_type, traits_type>\x26\x0a"
"                              (*__pf)(basic_ios<char_type,traits_type>\x26))\x0a"
"    { __pf(*this); return *this; }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_ostream\x26 operator<<(ios_base\x26 (*__pf)(ios_base\x26))\x0a"
"    { __pf(*this); return *this; }\x0a"
"\x0a"
"    basic_ostream\x26 operator<<(bool __n);\x0a"
"    basic_ostream\x26 operator<<(short __n);\x0a"
"    basic_ostream\x26 operator<<(unsigned short __n);\x0a"
"    basic_ostream\x26 operator<<(int __n);\x0a"
"    basic_ostream\x26 operator<<(unsigned int __n);\x0a"
"    basic_ostream\x26 operator<<(long __n);\x0a"
"    basic_ostream\x26 operator<<(unsigned long __n);\x0a"
"    basic_ostream\x26 operator<<(long long __n);\x0a"
"    basic_ostream\x26 operator<<(unsigned long long __n);\x0a"
"    basic_ostream\x26 operator<<(float __f);\x0a"
"    basic_ostream\x26 operator<<(double __f);\x0a"
"    basic_ostream\x26 operator<<(long double __f);\x0a"
"    basic_ostream\x26 operator<<(const void* __p);\x0a"
"    basic_ostream\x26 operator<<(basic_streambuf<char_type, traits_type>* __sb);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream\x26 operator<<(nullptr_t)\x0a"
"    { return *this << \x22nullptr\x22; }\x0a"
"\x0a"
"    // 27.7.2.7 Unformatted output\x3a\x0a"
"    basic_ostream\x26 put(char_type __c);\x0a"
"    basic_ostream\x26 write(const char_type* __s, streamsize __n);\x0a"
"    basic_ostream\x26 flush();\x0a"
"\x0a"
"    // 27.7.2.5 seeks\x3a\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    pos_type tellp();\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_ostream\x26 seekp(pos_type __pos);\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_ostream\x26 seekp(off_type __off, ios_base\x3a\x3aseekdir __dir);\x0a"
"\x0a"
"protected\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostream() {}  // extension, intentially does not initialize\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_ostream<_CharT, _Traits>\x3a\x3asentry\x0a"
"{\x0a"
"    bool __ok_;\x0a"
"    basic_ostream<_CharT, _Traits>\x26 __os_;\x0a"
"\x0a"
"    sentry(const sentry\x26); // = delete;\x0a"
"    sentry\x26 operator=(const sentry\x26); // = delete;\x0a"
"\x0a"
"public\x3a\x0a"
"    explicit sentry(basic_ostream<_CharT, _Traits>\x26 __os);\x0a"
"    \x7esentry();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        _LIBCPP_EXPLICIT\x0a"
"        operator bool() const {return __ok_;}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3asentry\x3a\x3asentry(basic_ostream<_CharT, _Traits>\x26 __os)\x0a"
"    \x3a __ok_(false),\x0a"
"      __os_(__os)\x0a"
"{\x0a"
"    if (__os.good())\x0a"
"    {\x0a"
"        if (__os.tie())\x0a"
"            __os.tie()->flush();\x0a"
"        __ok_ = true;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3asentry\x3a\x3a\x7esentry()\x0a"
"{\x0a"
"    if (__os_.rdbuf() \x26\x26 __os_.good() \x26\x26 (__os_.flags() \x26 ios_base\x3a\x3aunitbuf)\x0a"
"                      \x26\x26 \x21uncaught_exception())\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            if (__os_.rdbuf()->pubsync() == -1)\x0a"
"                __os_.setstate(ios_base\x3a\x3a""badbit);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3a""basic_ostream(basic_ostream\x26\x26 __rhs)\x0a"
"{\x0a"
"    this->move(__rhs);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator=(basic_ostream\x26\x26 __rhs)\x0a"
"{\x0a"
"    swap(__rhs);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3a\x7e""basic_ostream()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(basic_streambuf<char_type, traits_type>* __sb)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            if (__sb)\x0a"
"            {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"                try\x0a"
"                {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"                    typedef istreambuf_iterator<_CharT, _Traits> _Ip;\x0a"
"                    typedef ostreambuf_iterator<_CharT, _Traits> _Op;\x0a"
"                    _Ip __i(__sb);\x0a"
"                    _Ip __eof;\x0a"
"                    _Op __o(*this);\x0a"
"                    size_t __c = 0;\x0a"
"                    for (; __i \x21= __eof; ++__i, ++__o, ++__c)\x0a"
"                    {\x0a"
"                        *__o = *__i;\x0a"
"                        if (__o.failed())\x0a"
"                            break;\x0a"
"                    }\x0a"
"                    if (__c == 0)\x0a"
"                        this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"                }\x0a"
"                catch (...)\x0a"
"                {\x0a"
"                    this->__set_failbit_and_consider_rethrow();\x0a"
"                }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            }\x0a"
"            else\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(bool __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), __n).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(short __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            ios_base\x3a\x3a""fmtflags __flags = ios_base\x3a\x3a""flags() \x26 ios_base\x3a\x3a""basefield;\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(),\x0a"
"                        __flags == ios_base\x3a\x3aoct \x7c\x7c __flags == ios_base\x3a\x3ahex \x3f\x0a"
"                        static_cast<long>(static_cast<unsigned short>(__n))  \x3a\x0a"
"                        static_cast<long>(__n)).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(unsigned short __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), static_cast<unsigned long>(__n)).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(int __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            ios_base\x3a\x3a""fmtflags __flags = ios_base\x3a\x3a""flags() \x26 ios_base\x3a\x3a""basefield;\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(),\x0a"
"                        __flags == ios_base\x3a\x3aoct \x7c\x7c __flags == ios_base\x3a\x3ahex \x3f\x0a"
"                        static_cast<long>(static_cast<unsigned int>(__n))  \x3a\x0a"
"                        static_cast<long>(__n)).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(unsigned int __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), static_cast<unsigned long>(__n)).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(long __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), __n).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(unsigned long __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), __n).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(long long __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), __n).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(unsigned long long __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), __n).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(float __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), static_cast<double>(__n)).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(double __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), __n).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(long double __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), __n).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aoperator<<(const void* __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef num_put<char_type, ostreambuf_iterator<char_type, traits_type> > _Fp;\x0a"
"            const _Fp\x26 __f = use_facet<_Fp>(this->getloc());\x0a"
"            if (__f.put(*this, *this, this->fill(), __n).failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"__put_character_sequence(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"                          const _CharT* __str, size_t __len)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typename basic_ostream<_CharT, _Traits>\x3a\x3asentry __s(__os);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef ostreambuf_iterator<_CharT, _Traits> _Ip;\x0a"
"            if (__pad_and_output(_Ip(__os),\x0a"
"                                 __str,\x0a"
"                                 (__os.flags() \x26 ios_base\x3a\x3a""adjustfield) == ios_base\x3a\x3aleft \x3f\x0a"
"                                     __str + __len \x3a\x0a"
"                                     __str,\x0a"
"                                 __str + __len,\x0a"
"                                 __os,\x0a"
"                                 __os.fill()).failed())\x0a"
"                __os.setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __os.__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, _CharT __c)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__put_character_sequence(__os, \x26__c, 1);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, char __cn)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typename basic_ostream<_CharT, _Traits>\x3a\x3asentry __s(__os);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            _CharT __c = __os.widen(__cn);\x0a"
"            typedef ostreambuf_iterator<_CharT, _Traits> _Ip;\x0a"
"            if (__pad_and_output(_Ip(__os),\x0a"
"                                 \x26__c,\x0a"
"                                 (__os.flags() \x26 ios_base\x3a\x3a""adjustfield) == ios_base\x3a\x3aleft \x3f\x0a"
"                                     \x26__c + 1 \x3a\x0a"
"                                     \x26__c,\x0a"
"                                 \x26__c + 1,\x0a"
"                                 __os,\x0a"
"                                 __os.fill()).failed())\x0a"
"                __os.setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __os.__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template<class _Traits>\x0a"
"basic_ostream<char, _Traits>\x26\x0a"
"operator<<(basic_ostream<char, _Traits>\x26 __os, char __c)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__put_character_sequence(__os, \x26__c, 1);\x0a"
"}\x0a"
"\x0a"
"template<class _Traits>\x0a"
"basic_ostream<char, _Traits>\x26\x0a"
"operator<<(basic_ostream<char, _Traits>\x26 __os, signed char __c)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__put_character_sequence(__os, (char *) \x26__c, 1);\x0a"
"}\x0a"
"\x0a"
"template<class _Traits>\x0a"
"basic_ostream<char, _Traits>\x26\x0a"
"operator<<(basic_ostream<char, _Traits>\x26 __os, unsigned char __c)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__put_character_sequence(__os, (char *) \x26__c, 1);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const _CharT* __str)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__put_character_sequence(__os, __str, _Traits\x3a\x3alength(__str));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const char* __strn)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typename basic_ostream<_CharT, _Traits>\x3a\x3asentry __s(__os);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef ostreambuf_iterator<_CharT, _Traits> _Ip;\x0a"
"            size_t __len = char_traits<char>\x3a\x3alength(__strn);\x0a"
"            const int __bs = 100;\x0a"
"            _CharT __wbb\x5b__bs\x5d;\x0a"
"            _CharT* __wb = __wbb;\x0a"
"            unique_ptr<_CharT, void(*)(void*)> __h(0, free);\x0a"
"            if (__len > __bs)\x0a"
"            {\x0a"
"                __wb = (_CharT*)malloc(__len*sizeof(_CharT));\x0a"
"                if (__wb == 0)\x0a"
"                    __throw_bad_alloc();\x0a"
"                __h.reset(__wb);\x0a"
"            }\x0a"
"            for (_CharT* __p = __wb; *__strn \x21= '\x5c""0'; ++__strn, ++__p)\x0a"
"                *__p = __os.widen(*__strn);\x0a"
"            if (__pad_and_output(_Ip(__os),\x0a"
"                                 __wb,\x0a"
"                                 (__os.flags() \x26 ios_base\x3a\x3a""adjustfield) == ios_base\x3a\x3aleft \x3f\x0a"
"                                     __wb + __len \x3a\x0a"
"                                     __wb,\x0a"
"                                 __wb + __len,\x0a"
"                                 __os,\x0a"
"                                 __os.fill()).failed())\x0a"
"                __os.setstate(ios_base\x3a\x3a""badbit \x7c ios_base\x3a\x3a""failbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __os.__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template<class _Traits>\x0a"
"basic_ostream<char, _Traits>\x26\x0a"
"operator<<(basic_ostream<char, _Traits>\x26 __os, const char* __str)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__put_character_sequence(__os, __str, _Traits\x3a\x3alength(__str));\x0a"
"}\x0a"
"\x0a"
"template<class _Traits>\x0a"
"basic_ostream<char, _Traits>\x26\x0a"
"operator<<(basic_ostream<char, _Traits>\x26 __os, const signed char* __str)\x0a"
"{\x0a"
"    const char *__s = (const char *) __str;\x0a"
"    return _VSTD\x3a\x3a__put_character_sequence(__os, __s, _Traits\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template<class _Traits>\x0a"
"basic_ostream<char, _Traits>\x26\x0a"
"operator<<(basic_ostream<char, _Traits>\x26 __os, const unsigned char* __str)\x0a"
"{\x0a"
"    const char *__s = (const char *) __str;\x0a"
"    return _VSTD\x3a\x3a__put_character_sequence(__os, __s, _Traits\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aput(char_type __c)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __s(*this);\x0a"
"        if (__s)\x0a"
"        {\x0a"
"            typedef ostreambuf_iterator<_CharT, _Traits> _Op;\x0a"
"            _Op __o(*this);\x0a"
"            *__o = __c;\x0a"
"            if (__o.failed())\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3awrite(const char_type* __s, streamsize __n)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        sentry __sen(*this);\x0a"
"        if (__sen \x26\x26 __n)\x0a"
"        {\x0a"
"            if (this->rdbuf()->sputn(__s, __n) \x21= __n)\x0a"
"                this->setstate(ios_base\x3a\x3a""badbit);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3a""flush()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        if (this->rdbuf())\x0a"
"        {\x0a"
"            sentry __s(*this);\x0a"
"            if (__s)\x0a"
"            {\x0a"
"                if (this->rdbuf()->pubsync() == -1)\x0a"
"                    this->setstate(ios_base\x3a\x3a""badbit);\x0a"
"            }\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        this->__set_badbit_and_consider_rethrow();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_ostream<_CharT, _Traits>\x3a\x3apos_type\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3atellp()\x0a"
"{\x0a"
"    if (this->fail())\x0a"
"        return pos_type(-1);\x0a"
"    return this->rdbuf()->pubseekoff(0, ios_base\x3a\x3a""cur, ios_base\x3a\x3aout);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aseekp(pos_type __pos)\x0a"
"{\x0a"
"    sentry __s(*this);\x0a"
"    if (\x21this->fail())\x0a"
"    {\x0a"
"        if (this->rdbuf()->pubseekpos(__pos, ios_base\x3a\x3aout) == pos_type(-1))\x0a"
"            this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"basic_ostream<_CharT, _Traits>\x3a\x3aseekp(off_type __off, ios_base\x3a\x3aseekdir __dir)\x0a"
"{\x0a"
"    sentry __s(*this);\x0a"
"    if (\x21this->fail())\x0a"
"    {\x0a"
"        if (this->rdbuf()->pubseekoff(__off, __dir, ios_base\x3a\x3aout) == pos_type(-1))\x0a"
"            this->setstate(ios_base\x3a\x3a""failbit);\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"endl(basic_ostream<_CharT, _Traits>\x26 __os)\x0a"
"{\x0a"
"    __os.put(__os.widen('\x5cn'));\x0a"
"    __os.flush();\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"ends(basic_ostream<_CharT, _Traits>\x26 __os)\x0a"
"{\x0a"
"    __os.put(_CharT());\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"flush(basic_ostream<_CharT, _Traits>\x26 __os)\x0a"
"{\x0a"
"    __os.flush();\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Stream, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_lvalue_reference<_Stream>\x3a\x3avalue \x26\x26\x0a"
"    is_base_of<ios_base, _Stream>\x3a\x3avalue,\x0a"
"    _Stream\x26\x26\x0a"
">\x3a\x3atype\x0a"
"operator<<(_Stream\x26\x26 __os, const _Tp\x26 __x)\x0a"
"{\x0a"
"    __os << __x;\x0a"
"    return _VSTD\x3a\x3amove(__os);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __str)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__put_character_sequence(__os, __str.data(), __str.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const basic_string_view<_CharT, _Traits> __sv)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__put_character_sequence(__os, __sv.data(), __sv.size());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const error_code\x26 __ec)\x0a"
"{\x0a"
"    return __os << __ec.category().name() << '\x3a' << __ec.value();\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Yp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, shared_ptr<_Yp> const\x26 __p)\x0a"
"{\x0a"
"    return __os << __p.get();\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Yp, class _Dp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_same<void, typename __void_t<decltype((declval<basic_ostream<_CharT, _Traits>\x26>() << declval<typename unique_ptr<_Yp, _Dp>\x3a\x3apointer>()))>\x3a\x3atype>\x3a\x3avalue,\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
">\x3a\x3atype\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, unique_ptr<_Yp, _Dp> const\x26 __p)\x0a"
"{\x0a"
"    return __os << __p.get();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, size_t _Size>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const bitset<_Size>\x26 __x)\x0a"
"{\x0a"
"    return __os << __x.template to_string<_CharT, _Traits>\x0a"
"                        (use_facet<ctype<_CharT> >(__os.getloc()).widen('0'),\x0a"
"                         use_facet<ctype<_CharT> >(__os.getloc()).widen('1'));\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_DO_NOT_ASSUME_STREAMS_EXPLICIT_INSTANTIATION_IN_DYLIB\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_ostream<char>)\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_ostream<wchar_t>)\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_OSTREAM\x0a"
"", 32876 ); }