#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_queue( 
"// -*- C++ -*-\x0a"
"//===--------------------------- queue ------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_QUEUE\x0a"
"#define _LIBCPP_QUEUE\x0a"
"\x0a"
"/*\x0a"
"    queue synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class T, class Container = deque<T>>\x0a"
"class queue\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef Container                                container_type;\x0a"
"    typedef typename container_type\x3a\x3avalue_type      value_type;\x0a"
"    typedef typename container_type\x3a\x3areference       reference;\x0a"
"    typedef typename container_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename container_type\x3a\x3asize_type       size_type;\x0a"
"\x0a"
"protected\x3a\x0a"
"    container_type c;\x0a"
"\x0a"
"public\x3a\x0a"
"    queue() = default;\x0a"
"    \x7equeue() = default;\x0a"
"\x0a"
"    queue(const queue\x26 q) = default;\x0a"
"    queue(queue\x26\x26 q) = default;\x0a"
"\x0a"
"    queue\x26 operator=(const queue\x26 q) = default;\x0a"
"    queue\x26 operator=(queue\x26\x26 q) = default;\x0a"
"\x0a"
"    explicit queue(const container_type\x26 c);\x0a"
"    explicit queue(container_type\x26\x26 c)\x0a"
"    template <class Alloc>\x0a"
"        explicit queue(const Alloc\x26 a);\x0a"
"    template <class Alloc>\x0a"
"        queue(const container_type\x26 c, const Alloc\x26 a);\x0a"
"    template <class Alloc>\x0a"
"        queue(container_type\x26\x26 c, const Alloc\x26 a);\x0a"
"    template <class Alloc>\x0a"
"        queue(const queue\x26 q, const Alloc\x26 a);\x0a"
"    template <class Alloc>\x0a"
"        queue(queue\x26\x26 q, const Alloc\x26 a);\x0a"
"\x0a"
"    bool      empty() const;\x0a"
"    size_type size() const;\x0a"
"\x0a"
"    reference       front();\x0a"
"    const_reference front() const;\x0a"
"    reference       back();\x0a"
"    const_reference back() const;\x0a"
"\x0a"
"    void push(const value_type\x26 v);\x0a"
"    void push(value_type\x26\x26 v);\x0a"
"    template <class... Args> reference emplace(Args\x26\x26... args); // reference in C++17\x0a"
"    void pop();\x0a"
"\x0a"
"    void swap(queue\x26 q) noexcept(is_nothrow_swappable_v<Container>)\x0a"
"};\x0a"
"\x0a"
"template<class Container>\x0a"
"  queue(Container) -> queue<typename Container\x3a\x3avalue_type, Container>; // C++17\x0a"
"\x0a"
"template<class Container, class Allocator>\x0a"
"  queue(Container, Allocator) -> queue<typename Container\x3a\x3avalue_type, Container>; // C++17\x0a"
"\x0a"
"template <class T, class Container>\x0a"
"  bool operator==(const queue<T, Container>\x26 x,const queue<T, Container>\x26 y);\x0a"
"\x0a"
"template <class T, class Container>\x0a"
"  bool operator< (const queue<T, Container>\x26 x,const queue<T, Container>\x26 y);\x0a"
"\x0a"
"template <class T, class Container>\x0a"
"  bool operator\x21=(const queue<T, Container>\x26 x,const queue<T, Container>\x26 y);\x0a"
"\x0a"
"template <class T, class Container>\x0a"
"  bool operator> (const queue<T, Container>\x26 x,const queue<T, Container>\x26 y);\x0a"
"\x0a"
"template <class T, class Container>\x0a"
"  bool operator>=(const queue<T, Container>\x26 x,const queue<T, Container>\x26 y);\x0a"
"\x0a"
"template <class T, class Container>\x0a"
"  bool operator<=(const queue<T, Container>\x26 x,const queue<T, Container>\x26 y);\x0a"
"\x0a"
"template <class T, class Container>\x0a"
"  void swap(queue<T, Container>\x26 x, queue<T, Container>\x26 y)\x0a"
"  noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class T, class Container = vector<T>,\x0a"
"          class Compare = less<typename Container\x3a\x3avalue_type>>\x0a"
"class priority_queue\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef Container                                container_type;\x0a"
"    typedef typename container_type\x3a\x3avalue_type      value_type;\x0a"
"    typedef typename container_type\x3a\x3areference       reference;\x0a"
"    typedef typename container_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename container_type\x3a\x3asize_type       size_type;\x0a"
"\x0a"
"protected\x3a\x0a"
"    container_type c;\x0a"
"    Compare comp;\x0a"
"\x0a"
"public\x3a\x0a"
"    priority_queue() = default;\x0a"
"    \x7epriority_queue() = default;\x0a"
"\x0a"
"    priority_queue(const priority_queue\x26 q) = default;\x0a"
"    priority_queue(priority_queue\x26\x26 q) = default;\x0a"
"\x0a"
"    priority_queue\x26 operator=(const priority_queue\x26 q) = default;\x0a"
"    priority_queue\x26 operator=(priority_queue\x26\x26 q) = default;\x0a"
"\x0a"
"    explicit priority_queue(const Compare\x26 comp);\x0a"
"    priority_queue(const Compare\x26 comp, const container_type\x26 c);\x0a"
"    explicit priority_queue(const Compare\x26 comp, container_type\x26\x26 c);\x0a"
"    template <class InputIterator>\x0a"
"        priority_queue(InputIterator first, InputIterator last,\x0a"
"                       const Compare\x26 comp = Compare());\x0a"
"    template <class InputIterator>\x0a"
"        priority_queue(InputIterator first, InputIterator last,\x0a"
"                       const Compare\x26 comp, const container_type\x26 c);\x0a"
"    template <class InputIterator>\x0a"
"        priority_queue(InputIterator first, InputIterator last,\x0a"
"                       const Compare\x26 comp, container_type\x26\x26 c);\x0a"
"    template <class Alloc>\x0a"
"        explicit priority_queue(const Alloc\x26 a);\x0a"
"    template <class Alloc>\x0a"
"        priority_queue(const Compare\x26 comp, const Alloc\x26 a);\x0a"
"    template <class Alloc>\x0a"
"        priority_queue(const Compare\x26 comp, const container_type\x26 c,\x0a"
"                       const Alloc\x26 a);\x0a"
"    template <class Alloc>\x0a"
"        priority_queue(const Compare\x26 comp, container_type\x26\x26 c,\x0a"
"                       const Alloc\x26 a);\x0a"
"    template <class Alloc>\x0a"
"        priority_queue(const priority_queue\x26 q, const Alloc\x26 a);\x0a"
"    template <class Alloc>\x0a"
"        priority_queue(priority_queue\x26\x26 q, const Alloc\x26 a);\x0a"
"\x0a"
"    bool            empty() const;\x0a"
"    size_type       size() const;\x0a"
"    const_reference top() const;\x0a"
"\x0a"
"    void push(const value_type\x26 v);\x0a"
"    void push(value_type\x26\x26 v);\x0a"
"    template <class... Args> void emplace(Args\x26\x26... args);\x0a"
"    void pop();\x0a"
"\x0a"
"    void swap(priority_queue\x26 q)\x0a"
"        noexcept(is_nothrow_swappable_v<Container> \x26\x26\x0a"
"                 is_nothrow_swappable_v<Comp>)\x0a"
"};\x0a"
"\x0a"
"template <class Compare, class Container>\x0a"
"priority_queue(Compare, Container)\x0a"
"    -> priority_queue<typename Container\x3a\x3avalue_type, Container, Compare>; // C++17\x0a"
"\x0a"
"template<class InputIterator,\x0a"
"         class Compare = less<typename iterator_traits<InputIterator>\x3a\x3avalue_type>,\x0a"
"         class Container = vector<typename iterator_traits<InputIterator>\x3a\x3avalue_type>>\x0a"
"priority_queue(InputIterator, InputIterator, Compare = Compare(), Container = Container())\x0a"
"    -> priority_queue<typename iterator_traits<InputIterator>\x3a\x3avalue_type, Container, Compare>; // C++17\x0a"
"\x0a"
"template<class Compare, class Container, class Allocator>\x0a"
"priority_queue(Compare, Container, Allocator)\x0a"
"    -> priority_queue<typename Container\x3a\x3avalue_type, Container, Compare>; // C++17\x0a"
"\x0a"
"template <class T, class Container, class Compare>\x0a"
"  void swap(priority_queue<T, Container, Compare>\x26 x,\x0a"
"            priority_queue<T, Container, Compare>\x26 y)\x0a"
"            noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <deque>\x0a"
"#include <vector>\x0a"
"#include <functional>\x0a"
"#include <algorithm>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Tp, class _Container = deque<_Tp> > class _LIBCPP_TEMPLATE_VIS queue;\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const queue<_Tp, _Container>\x26 __x,const queue<_Tp, _Container>\x26 __y);\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const queue<_Tp, _Container>\x26 __x,const queue<_Tp, _Container>\x26 __y);\x0a"
"\x0a"
"template <class _Tp, class _Container /*= deque<_Tp>*/>\x0a"
"class _LIBCPP_TEMPLATE_VIS queue\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Container                               container_type;\x0a"
"    typedef typename container_type\x3a\x3avalue_type      value_type;\x0a"
"    typedef typename container_type\x3a\x3areference       reference;\x0a"
"    typedef typename container_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename container_type\x3a\x3asize_type       size_type;\x0a"
"    static_assert((is_same<_Tp, value_type>\x3a\x3avalue), \x22\x22 );\x0a"
"\x0a"
"protected\x3a\x0a"
"    container_type c;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    queue()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<container_type>\x3a\x3avalue)\x0a"
"        \x3a c() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    queue(const queue\x26 __q) \x3a c(__q.c) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    queue\x26 operator=(const queue\x26 __q) {c = __q.c; return *this;}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    queue(queue\x26\x26 __q)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<container_type>\x3a\x3avalue)\x0a"
"        \x3a c(_VSTD\x3a\x3amove(__q.c)) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    queue\x26 operator=(queue\x26\x26 __q)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<container_type>\x3a\x3avalue)\x0a"
"        {c = _VSTD\x3a\x3amove(__q.c); return *this;}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit queue(const container_type\x26 __c)  \x3a c(__c) {}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit queue(container_type\x26\x26 __c) \x3a c(_VSTD\x3a\x3amove(__c)) {}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit queue(const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"            \x3a c(__a) {}\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        queue(const queue\x26 __q, const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"            \x3a c(__q.c, __a) {}\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        queue(const container_type\x26 __c, const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"            \x3a c(__c, __a) {}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        queue(container_type\x26\x26 __c, const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"            \x3a c(_VSTD\x3a\x3amove(__c), __a) {}\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        queue(queue\x26\x26 __q, const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"            \x3a c(_VSTD\x3a\x3amove(__q.c), __a) {}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool      empty() const {return c.empty();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const  {return c.size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference       front()       {return c.front();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference front() const {return c.front();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference       back()        {return c.back();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference back() const  {return c.back();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void push(const value_type\x26 __v) {c.push_back(__v);}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void push(value_type\x26\x26 __v)      {c.push_back(_VSTD\x3a\x3amove(__v));}\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        decltype(auto) emplace(_Args\x26\x26... __args)\x0a"
"            { return c.emplace_back(_VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"#else\x0a"
"        void     emplace(_Args\x26\x26... __args)\x0a"
"            {        c.emplace_back(_VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"#endif\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void pop() {c.pop_front();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(queue\x26 __q)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<container_type>\x3a\x3avalue)\x0a"
"    {\x0a"
"        using _VSTD\x3a\x3aswap;\x0a"
"        swap(c, __q.c);\x0a"
"    }\x0a"
"\x0a"
"    template <class _T1, class _C1>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool\x0a"
"    operator==(const queue<_T1, _C1>\x26 __x,const queue<_T1, _C1>\x26 __y);\x0a"
"\x0a"
"    template <class _T1, class _C1>\x0a"
"    friend\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool\x0a"
"    operator< (const queue<_T1, _C1>\x26 __x,const queue<_T1, _C1>\x26 __y);\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _Container,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Container>\x3a\x3avalue, nullptr_t>\x3a\x3atype\x0a"
">\x0a"
"queue(_Container)\x0a"
"    -> queue<typename _Container\x3a\x3avalue_type, _Container>;\x0a"
"\x0a"
"template<class _Container,\x0a"
"         class _Alloc,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Container>\x3a\x3avalue, nullptr_t>\x3a\x3atype,\x0a"
"         class = typename enable_if< __is_allocator<_Alloc>\x3a\x3avalue, nullptr_t>\x3a\x3atype\x0a"
">\x0a"
"queue(_Container, _Alloc)\x0a"
"    -> queue<typename _Container\x3a\x3avalue_type, _Container>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const queue<_Tp, _Container>\x26 __x,const queue<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return __x.c == __y.c;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const queue<_Tp, _Container>\x26 __x,const queue<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return __x.c < __y.c;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const queue<_Tp, _Container>\x26 __x,const queue<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const queue<_Tp, _Container>\x26 __x,const queue<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const queue<_Tp, _Container>\x26 __x,const queue<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const queue<_Tp, _Container>\x26 __x,const queue<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if<\x0a"
"    __is_swappable<_Container>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"swap(queue<_Tp, _Container>\x26 __x, queue<_Tp, _Container>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Alloc>\x0a"
"struct _LIBCPP_TEMPLATE_VIS uses_allocator<queue<_Tp, _Container>, _Alloc>\x0a"
"    \x3a public uses_allocator<_Container, _Alloc>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Container = vector<_Tp>,\x0a"
"          class _Compare = less<typename _Container\x3a\x3avalue_type> >\x0a"
"class _LIBCPP_TEMPLATE_VIS priority_queue\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Container                               container_type;\x0a"
"    typedef _Compare                                 value_compare;\x0a"
"    typedef typename container_type\x3a\x3avalue_type      value_type;\x0a"
"    typedef typename container_type\x3a\x3areference       reference;\x0a"
"    typedef typename container_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename container_type\x3a\x3asize_type       size_type;\x0a"
"    static_assert((is_same<_Tp, value_type>\x3a\x3avalue), \x22\x22 );\x0a"
"\x0a"
"protected\x3a\x0a"
"    container_type c;\x0a"
"    value_compare comp;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    priority_queue()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<container_type>\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_default_constructible<value_compare>\x3a\x3avalue)\x0a"
"        \x3a c(), comp() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    priority_queue(const priority_queue\x26 __q) \x3a c(__q.c), comp(__q.comp) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    priority_queue\x26 operator=(const priority_queue\x26 __q)\x0a"
"        {c = __q.c; comp = __q.comp; return *this;}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    priority_queue(priority_queue\x26\x26 __q)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<container_type>\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_move_constructible<value_compare>\x3a\x3avalue)\x0a"
"        \x3a c(_VSTD\x3a\x3amove(__q.c)), comp(_VSTD\x3a\x3amove(__q.comp)) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    priority_queue\x26 operator=(priority_queue\x26\x26 __q)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<container_type>\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_move_assignable<value_compare>\x3a\x3avalue)\x0a"
"        {c = _VSTD\x3a\x3amove(__q.c); comp = _VSTD\x3a\x3amove(__q.comp); return *this;}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit priority_queue(const value_compare\x26 __comp)\x0a"
"        \x3a c(), comp(__comp) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    priority_queue(const value_compare\x26 __comp, const container_type\x26 __c);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit priority_queue(const value_compare\x26 __comp, container_type\x26\x26 __c);\x0a"
"#endif\x0a"
"    template <class _InputIter>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        priority_queue(_InputIter __f, _InputIter __l,\x0a"
"                       const value_compare\x26 __comp = value_compare());\x0a"
"    template <class _InputIter>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        priority_queue(_InputIter __f, _InputIter __l,\x0a"
"                       const value_compare\x26 __comp, const container_type\x26 __c);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _InputIter>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        priority_queue(_InputIter __f, _InputIter __l,\x0a"
"                       const value_compare\x26 __comp, container_type\x26\x26 __c);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit priority_queue(const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        priority_queue(const value_compare\x26 __comp, const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        priority_queue(const value_compare\x26 __comp, const container_type\x26 __c,\x0a"
"                       const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        priority_queue(const priority_queue\x26 __q, const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        priority_queue(const value_compare\x26 __comp, container_type\x26\x26 __c,\x0a"
"                       const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        priority_queue(priority_queue\x26\x26 __q, const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool            empty() const {return c.empty();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type       size() const  {return c.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference top() const   {return c.front();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void push(const value_type\x26 __v);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void push(value_type\x26\x26 __v);\x0a"
"    template <class... _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void emplace(_Args\x26\x26... __args);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void pop();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(priority_queue\x26 __q)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<container_type>\x3a\x3avalue \x26\x26\x0a"
"                   __is_nothrow_swappable<value_compare>\x3a\x3avalue);\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template <class _Compare,\x0a"
"          class _Container,\x0a"
"          class = typename enable_if<\x21__is_allocator<_Compare>\x3a\x3avalue, nullptr_t>\x3a\x3atype,\x0a"
"          class = typename enable_if<\x21__is_allocator<_Container>\x3a\x3avalue, nullptr_t>\x3a\x3atype\x0a"
">\x0a"
"priority_queue(_Compare, _Container)\x0a"
"    -> priority_queue<typename _Container\x3a\x3avalue_type, _Container, _Compare>;\x0a"
"\x0a"
"template<class _InputIterator,\x0a"
"         class _Compare   = less<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>,\x0a"
"         class _Container = vector<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>,\x0a"
"         class = typename enable_if< __is_input_iterator<_InputIterator>\x3a\x3avalue, nullptr_t>\x3a\x3atype,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Compare>\x3a\x3avalue, nullptr_t>\x3a\x3atype,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Container>\x3a\x3avalue, nullptr_t>\x3a\x3atype\x0a"
">\x0a"
"priority_queue(_InputIterator, _InputIterator, _Compare = _Compare(), _Container = _Container())\x0a"
"    -> priority_queue<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Container, _Compare>;\x0a"
"\x0a"
"template<class _Compare,\x0a"
"         class _Container,\x0a"
"         class _Alloc,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Compare>\x3a\x3avalue, nullptr_t>\x3a\x3atype,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Container>\x3a\x3avalue, nullptr_t>\x3a\x3atype,\x0a"
"         class = typename enable_if< __is_allocator<_Alloc>\x3a\x3avalue, nullptr_t>\x3a\x3atype\x0a"
">\x0a"
"priority_queue(_Compare, _Container, _Alloc)\x0a"
"    -> priority_queue<typename _Container\x3a\x3avalue_type, _Container, _Compare>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(const _Compare\x26 __comp,\x0a"
"                                                          const container_type\x26 __c)\x0a"
"    \x3a c(__c),\x0a"
"      comp(__comp)\x0a"
"{\x0a"
"    _VSTD\x3a\x3amake_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(const value_compare\x26 __comp,\x0a"
"                                                          container_type\x26\x26 __c)\x0a"
"    \x3a c(_VSTD\x3a\x3amove(__c)),\x0a"
"      comp(__comp)\x0a"
"{\x0a"
"    _VSTD\x3a\x3amake_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"template <class _InputIter>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(_InputIter __f, _InputIter __l,\x0a"
"                                                          const value_compare\x26 __comp)\x0a"
"    \x3a c(__f, __l),\x0a"
"      comp(__comp)\x0a"
"{\x0a"
"    _VSTD\x3a\x3amake_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"template <class _InputIter>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(_InputIter __f, _InputIter __l,\x0a"
"                                                          const value_compare\x26 __comp,\x0a"
"                                                          const container_type\x26 __c)\x0a"
"    \x3a c(__c),\x0a"
"      comp(__comp)\x0a"
"{\x0a"
"    c.insert(c.end(), __f, __l);\x0a"
"    _VSTD\x3a\x3amake_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"template <class _InputIter>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(_InputIter __f, _InputIter __l,\x0a"
"                                                          const value_compare\x26 __comp,\x0a"
"                                                          container_type\x26\x26 __c)\x0a"
"    \x3a c(_VSTD\x3a\x3amove(__c)),\x0a"
"      comp(__comp)\x0a"
"{\x0a"
"    c.insert(c.end(), __f, __l);\x0a"
"    _VSTD\x3a\x3amake_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"template <class _Alloc>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a c(__a)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"template <class _Alloc>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(const value_compare\x26 __comp,\x0a"
"                                                          const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a c(__a),\x0a"
"      comp(__comp)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"template <class _Alloc>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(const value_compare\x26 __comp,\x0a"
"                                                          const container_type\x26 __c,\x0a"
"                                                          const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a c(__c, __a),\x0a"
"      comp(__comp)\x0a"
"{\x0a"
"    _VSTD\x3a\x3amake_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"template <class _Alloc>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(const priority_queue\x26 __q,\x0a"
"                                                          const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a c(__q.c, __a),\x0a"
"      comp(__q.comp)\x0a"
"{\x0a"
"    _VSTD\x3a\x3amake_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"template <class _Alloc>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(const value_compare\x26 __comp,\x0a"
"                                                          container_type\x26\x26 __c,\x0a"
"                                                          const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a c(_VSTD\x3a\x3amove(__c), __a),\x0a"
"      comp(__comp)\x0a"
"{\x0a"
"    _VSTD\x3a\x3amake_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"template <class _Alloc>\x0a"
"inline\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apriority_queue(priority_queue\x26\x26 __q,\x0a"
"                                                          const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a c(_VSTD\x3a\x3amove(__q.c), __a),\x0a"
"      comp(_VSTD\x3a\x3amove(__q.comp))\x0a"
"{\x0a"
"    _VSTD\x3a\x3amake_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"inline\x0a"
"void\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apush(const value_type\x26 __v)\x0a"
"{\x0a"
"    c.push_back(__v);\x0a"
"    _VSTD\x3a\x3apush_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"inline\x0a"
"void\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apush(value_type\x26\x26 __v)\x0a"
"{\x0a"
"    c.push_back(_VSTD\x3a\x3amove(__v));\x0a"
"    _VSTD\x3a\x3apush_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"template <class... _Args>\x0a"
"inline\x0a"
"void\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3a""emplace(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    c.emplace_back(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    _VSTD\x3a\x3apush_heap(c.begin(), c.end(), comp);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"inline\x0a"
"void\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3apop()\x0a"
"{\x0a"
"    _VSTD\x3a\x3apop_heap(c.begin(), c.end(), comp);\x0a"
"    c.pop_back();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"inline\x0a"
"void\x0a"
"priority_queue<_Tp, _Container, _Compare>\x3a\x3aswap(priority_queue\x26 __q)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<container_type>\x3a\x3avalue \x26\x26\x0a"
"                   __is_nothrow_swappable<value_compare>\x3a\x3avalue)\x0a"
"{\x0a"
"    using _VSTD\x3a\x3aswap;\x0a"
"    swap(c, __q.c);\x0a"
"    swap(comp, __q.comp);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if<\x0a"
"    __is_swappable<_Container>\x3a\x3avalue\x0a"
"    \x26\x26 __is_swappable<_Compare>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"swap(priority_queue<_Tp, _Container, _Compare>\x26 __x,\x0a"
"     priority_queue<_Tp, _Container, _Compare>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Compare, class _Alloc>\x0a"
"struct _LIBCPP_TEMPLATE_VIS uses_allocator<priority_queue<_Tp, _Container, _Compare>, _Alloc>\x0a"
"    \x3a public uses_allocator<_Container, _Alloc>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_QUEUE\x0a"
"", 28120 ); }