#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_ratio( 
"// -*- C++ -*-\x0a"
"//===---------------------------- ratio -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_RATIO\x0a"
"#define _LIBCPP_RATIO\x0a"
"\x0a"
"/*\x0a"
"    ratio synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <intmax_t N, intmax_t D = 1>\x0a"
"class ratio\x0a"
"{\x0a"
"public\x3a\x0a"
"    static constexpr intmax_t num;\x0a"
"    static constexpr intmax_t den;\x0a"
"    typedef ratio<num, den> type;\x0a"
"};\x0a"
"\x0a"
"// ratio arithmetic\x0a"
"template <class R1, class R2> using ratio_add = ...;\x0a"
"template <class R1, class R2> using ratio_subtract = ...;\x0a"
"template <class R1, class R2> using ratio_multiply = ...;\x0a"
"template <class R1, class R2> using ratio_divide = ...;\x0a"
"\x0a"
"// ratio comparison\x0a"
"template <class R1, class R2> struct ratio_equal;\x0a"
"template <class R1, class R2> struct ratio_not_equal;\x0a"
"template <class R1, class R2> struct ratio_less;\x0a"
"template <class R1, class R2> struct ratio_less_equal;\x0a"
"template <class R1, class R2> struct ratio_greater;\x0a"
"template <class R1, class R2> struct ratio_greater_equal;\x0a"
"\x0a"
"// convenience SI typedefs\x0a"
"typedef ratio<1, 1000000000000000000000000> yocto;  // not supported\x0a"
"typedef ratio<1,    1000000000000000000000> zepto;  // not supported\x0a"
"typedef ratio<1,       1000000000000000000> atto;\x0a"
"typedef ratio<1,          1000000000000000> femto;\x0a"
"typedef ratio<1,             1000000000000> pico;\x0a"
"typedef ratio<1,                1000000000> nano;\x0a"
"typedef ratio<1,                   1000000> micro;\x0a"
"typedef ratio<1,                      1000> milli;\x0a"
"typedef ratio<1,                       100> centi;\x0a"
"typedef ratio<1,                        10> deci;\x0a"
"typedef ratio<                       10, 1> deca;\x0a"
"typedef ratio<                      100, 1> hecto;\x0a"
"typedef ratio<                     1000, 1> kilo;\x0a"
"typedef ratio<                  1000000, 1> mega;\x0a"
"typedef ratio<               1000000000, 1> giga;\x0a"
"typedef ratio<            1000000000000, 1> tera;\x0a"
"typedef ratio<         1000000000000000, 1> peta;\x0a"
"typedef ratio<      1000000000000000000, 1> exa;\x0a"
"typedef ratio<   1000000000000000000000, 1> zetta;  // not supported\x0a"
"typedef ratio<1000000000000000000000000, 1> yotta;  // not supported\x0a"
"\x0a"
"  // 20.11.5, ratio comparison\x0a"
"  template <class R1, class R2> inline constexpr bool ratio_equal_v\x0a"
"    = ratio_equal<R1, R2>\x3a\x3avalue;                                       // C++17\x0a"
"  template <class R1, class R2> inline constexpr bool ratio_not_equal_v\x0a"
"    = ratio_not_equal<R1, R2>\x3a\x3avalue;                                   // C++17\x0a"
"  template <class R1, class R2> inline constexpr bool ratio_less_v\x0a"
"    = ratio_less<R1, R2>\x3a\x3avalue;                                        // C++17\x0a"
"  template <class R1, class R2> inline constexpr bool ratio_less_equal_v\x0a"
"    = ratio_less_equal<R1, R2>\x3a\x3avalue;                                  // C++17\x0a"
"  template <class R1, class R2> inline constexpr bool ratio_greater_v\x0a"
"    = ratio_greater<R1, R2>\x3a\x3avalue;                                     // C++17\x0a"
"  template <class R1, class R2> inline constexpr bool ratio_greater_equal_v\x0a"
"    = ratio_greater_equal<R1, R2>\x3a\x3avalue;                               // C++17\x0a"
"}\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <cstdint>\x0a"
"#include <climits>\x0a"
"#include <type_traits>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// __static_gcd\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp>\x0a"
"struct __static_gcd\x0a"
"{\x0a"
"    static const intmax_t value = __static_gcd<_Yp, _Xp \x25 _Yp>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp>\x0a"
"struct __static_gcd<_Xp, 0>\x0a"
"{\x0a"
"    static const intmax_t value = _Xp;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct __static_gcd<0, 0>\x0a"
"{\x0a"
"    static const intmax_t value = 1;\x0a"
"};\x0a"
"\x0a"
"// __static_lcm\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp>\x0a"
"struct __static_lcm\x0a"
"{\x0a"
"    static const intmax_t value = _Xp / __static_gcd<_Xp, _Yp>\x3a\x3avalue * _Yp;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp>\x0a"
"struct __static_abs\x0a"
"{\x0a"
"    static const intmax_t value = _Xp < 0 \x3f -_Xp \x3a _Xp;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp>\x0a"
"struct __static_sign\x0a"
"{\x0a"
"    static const intmax_t value = _Xp == 0 \x3f 0 \x3a (_Xp < 0 \x3f -1 \x3a 1);\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp, intmax_t = __static_sign<_Yp>\x3a\x3avalue>\x0a"
"class __ll_add;\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp>\x0a"
"class __ll_add<_Xp, _Yp, 1>\x0a"
"{\x0a"
"    static const intmax_t min = (1LL << (sizeof(intmax_t) * CHAR_BIT - 1)) + 1;\x0a"
"    static const intmax_t max = -min;\x0a"
"\x0a"
"    static_assert(_Xp <= max - _Yp, \x22overflow in __ll_add\x22);\x0a"
"public\x3a\x0a"
"    static const intmax_t value = _Xp + _Yp;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp>\x0a"
"class __ll_add<_Xp, _Yp, 0>\x0a"
"{\x0a"
"public\x3a\x0a"
"    static const intmax_t value = _Xp;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp>\x0a"
"class __ll_add<_Xp, _Yp, -1>\x0a"
"{\x0a"
"    static const intmax_t min = (1LL << (sizeof(intmax_t) * CHAR_BIT - 1)) + 1;\x0a"
"    static const intmax_t max = -min;\x0a"
"\x0a"
"    static_assert(min - _Yp <= _Xp, \x22overflow in __ll_add\x22);\x0a"
"public\x3a\x0a"
"    static const intmax_t value = _Xp + _Yp;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp, intmax_t = __static_sign<_Yp>\x3a\x3avalue>\x0a"
"class __ll_sub;\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp>\x0a"
"class __ll_sub<_Xp, _Yp, 1>\x0a"
"{\x0a"
"    static const intmax_t min = (1LL << (sizeof(intmax_t) * CHAR_BIT - 1)) + 1;\x0a"
"    static const intmax_t max = -min;\x0a"
"\x0a"
"    static_assert(min + _Yp <= _Xp, \x22overflow in __ll_sub\x22);\x0a"
"public\x3a\x0a"
"    static const intmax_t value = _Xp - _Yp;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp>\x0a"
"class __ll_sub<_Xp, _Yp, 0>\x0a"
"{\x0a"
"public\x3a\x0a"
"    static const intmax_t value = _Xp;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp>\x0a"
"class __ll_sub<_Xp, _Yp, -1>\x0a"
"{\x0a"
"    static const intmax_t min = (1LL << (sizeof(intmax_t) * CHAR_BIT - 1)) + 1;\x0a"
"    static const intmax_t max = -min;\x0a"
"\x0a"
"    static_assert(_Xp <= max + _Yp, \x22overflow in __ll_sub\x22);\x0a"
"public\x3a\x0a"
"    static const intmax_t value = _Xp - _Yp;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp, intmax_t _Yp>\x0a"
"class __ll_mul\x0a"
"{\x0a"
"    static const intmax_t nan = (1LL << (sizeof(intmax_t) * CHAR_BIT - 1));\x0a"
"    static const intmax_t min = nan + 1;\x0a"
"    static const intmax_t max = -min;\x0a"
"    static const intmax_t __a_x = __static_abs<_Xp>\x3a\x3avalue;\x0a"
"    static const intmax_t __a_y = __static_abs<_Yp>\x3a\x3avalue;\x0a"
"\x0a"
"    static_assert(_Xp \x21= nan \x26\x26 _Yp \x21= nan \x26\x26 __a_x <= max / __a_y, \x22overflow in __ll_mul\x22);\x0a"
"public\x3a\x0a"
"    static const intmax_t value = _Xp * _Yp;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Yp>\x0a"
"class __ll_mul<0, _Yp>\x0a"
"{\x0a"
"public\x3a\x0a"
"    static const intmax_t value = 0;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Xp>\x0a"
"class __ll_mul<_Xp, 0>\x0a"
"{\x0a"
"public\x3a\x0a"
"    static const intmax_t value = 0;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class __ll_mul<0, 0>\x0a"
"{\x0a"
"public\x3a\x0a"
"    static const intmax_t value = 0;\x0a"
"};\x0a"
"\x0a"
"// Not actually used but left here in case needed in future maintenance\x0a"
"template <intmax_t _Xp, intmax_t _Yp>\x0a"
"class __ll_div\x0a"
"{\x0a"
"    static const intmax_t nan = (1LL << (sizeof(intmax_t) * CHAR_BIT - 1));\x0a"
"    static const intmax_t min = nan + 1;\x0a"
"    static const intmax_t max = -min;\x0a"
"\x0a"
"    static_assert(_Xp \x21= nan \x26\x26 _Yp \x21= nan \x26\x26 _Yp \x21= 0, \x22overflow in __ll_div\x22);\x0a"
"public\x3a\x0a"
"    static const intmax_t value = _Xp / _Yp;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Num, intmax_t _Den = 1>\x0a"
"class _LIBCPP_TEMPLATE_VIS ratio\x0a"
"{\x0a"
"    static_assert(__static_abs<_Num>\x3a\x3avalue >= 0, \x22ratio numerator is out of range\x22);\x0a"
"    static_assert(_Den \x21= 0, \x22ratio divide by 0\x22);\x0a"
"    static_assert(__static_abs<_Den>\x3a\x3avalue >  0, \x22ratio denominator is out of range\x22);\x0a"
"    static _LIBCPP_CONSTEXPR const intmax_t __na = __static_abs<_Num>\x3a\x3avalue;\x0a"
"    static _LIBCPP_CONSTEXPR const intmax_t __da = __static_abs<_Den>\x3a\x3avalue;\x0a"
"    static _LIBCPP_CONSTEXPR const intmax_t __s = __static_sign<_Num>\x3a\x3avalue * __static_sign<_Den>\x3a\x3avalue;\x0a"
"    static _LIBCPP_CONSTEXPR const intmax_t __gcd = __static_gcd<__na, __da>\x3a\x3avalue;\x0a"
"public\x3a\x0a"
"    static _LIBCPP_CONSTEXPR const intmax_t num = __s * __na / __gcd;\x0a"
"    static _LIBCPP_CONSTEXPR const intmax_t den = __da / __gcd;\x0a"
"\x0a"
"    typedef ratio<num, den> type;\x0a"
"};\x0a"
"\x0a"
"template <intmax_t _Num, intmax_t _Den>\x0a"
"_LIBCPP_CONSTEXPR const intmax_t ratio<_Num, _Den>\x3a\x3anum;\x0a"
"\x0a"
"template <intmax_t _Num, intmax_t _Den>\x0a"
"_LIBCPP_CONSTEXPR const intmax_t ratio<_Num, _Den>\x3a\x3a""den;\x0a"
"\x0a"
"template <class _Tp>                    struct __is_ratio                     \x3a false_type {};\x0a"
"template <intmax_t _Num, intmax_t _Den> struct __is_ratio<ratio<_Num, _Den> > \x3a true_type  {};\x0a"
"\x0a"
"typedef ratio<1LL, 1000000000000000000LL> atto;\x0a"
"typedef ratio<1LL,    1000000000000000LL> femto;\x0a"
"typedef ratio<1LL,       1000000000000LL> pico;\x0a"
"typedef ratio<1LL,          1000000000LL> nano;\x0a"
"typedef ratio<1LL,             1000000LL> micro;\x0a"
"typedef ratio<1LL,                1000LL> milli;\x0a"
"typedef ratio<1LL,                 100LL> centi;\x0a"
"typedef ratio<1LL,                  10LL> deci;\x0a"
"typedef ratio<                 10LL, 1LL> deca;\x0a"
"typedef ratio<                100LL, 1LL> hecto;\x0a"
"typedef ratio<               1000LL, 1LL> kilo;\x0a"
"typedef ratio<            1000000LL, 1LL> mega;\x0a"
"typedef ratio<         1000000000LL, 1LL> giga;\x0a"
"typedef ratio<      1000000000000LL, 1LL> tera;\x0a"
"typedef ratio<   1000000000000000LL, 1LL> peta;\x0a"
"typedef ratio<1000000000000000000LL, 1LL> exa;\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct __ratio_multiply\x0a"
"{\x0a"
"private\x3a\x0a"
"    static const intmax_t __gcd_n1_d2 = __static_gcd<_R1\x3a\x3anum, _R2\x3a\x3a""den>\x3a\x3avalue;\x0a"
"    static const intmax_t __gcd_d1_n2 = __static_gcd<_R1\x3a\x3a""den, _R2\x3a\x3anum>\x3a\x3avalue;\x0a"
"public\x3a\x0a"
"    typedef typename ratio\x0a"
"        <\x0a"
"            __ll_mul<_R1\x3a\x3anum / __gcd_n1_d2, _R2\x3a\x3anum / __gcd_d1_n2>\x3a\x3avalue,\x0a"
"            __ll_mul<_R2\x3a\x3a""den / __gcd_n1_d2, _R1\x3a\x3a""den / __gcd_d1_n2>\x3a\x3avalue\x0a"
"        >\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2> using ratio_multiply\x0a"
"                                    = typename __ratio_multiply<_R1, _R2>\x3a\x3atype;\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS ratio_multiply\x0a"
"    \x3a public __ratio_multiply<_R1, _R2>\x3a\x3atype {};\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct __ratio_divide\x0a"
"{\x0a"
"private\x3a\x0a"
"    static const intmax_t __gcd_n1_n2 = __static_gcd<_R1\x3a\x3anum, _R2\x3a\x3anum>\x3a\x3avalue;\x0a"
"    static const intmax_t __gcd_d1_d2 = __static_gcd<_R1\x3a\x3a""den, _R2\x3a\x3a""den>\x3a\x3avalue;\x0a"
"public\x3a\x0a"
"    typedef typename ratio\x0a"
"        <\x0a"
"            __ll_mul<_R1\x3a\x3anum / __gcd_n1_n2, _R2\x3a\x3a""den / __gcd_d1_d2>\x3a\x3avalue,\x0a"
"            __ll_mul<_R2\x3a\x3anum / __gcd_n1_n2, _R1\x3a\x3a""den / __gcd_d1_d2>\x3a\x3avalue\x0a"
"        >\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2> using ratio_divide\x0a"
"                                      = typename __ratio_divide<_R1, _R2>\x3a\x3atype;\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS ratio_divide\x0a"
"    \x3a public __ratio_divide<_R1, _R2>\x3a\x3atype {};\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct __ratio_add\x0a"
"{\x0a"
"private\x3a\x0a"
"    static const intmax_t __gcd_n1_n2 = __static_gcd<_R1\x3a\x3anum, _R2\x3a\x3anum>\x3a\x3avalue;\x0a"
"    static const intmax_t __gcd_d1_d2 = __static_gcd<_R1\x3a\x3a""den, _R2\x3a\x3a""den>\x3a\x3avalue;\x0a"
"public\x3a\x0a"
"    typedef typename ratio_multiply\x0a"
"        <\x0a"
"            ratio<__gcd_n1_n2, _R1\x3a\x3a""den / __gcd_d1_d2>,\x0a"
"            ratio\x0a"
"            <\x0a"
"                __ll_add\x0a"
"                <\x0a"
"                    __ll_mul<_R1\x3a\x3anum / __gcd_n1_n2, _R2\x3a\x3a""den / __gcd_d1_d2>\x3a\x3avalue,\x0a"
"                    __ll_mul<_R2\x3a\x3anum / __gcd_n1_n2, _R1\x3a\x3a""den / __gcd_d1_d2>\x3a\x3avalue\x0a"
"                >\x3a\x3avalue,\x0a"
"                _R2\x3a\x3a""den\x0a"
"            >\x0a"
"        >\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2> using ratio_add\x0a"
"                                         = typename __ratio_add<_R1, _R2>\x3a\x3atype;\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS ratio_add\x0a"
"    \x3a public __ratio_add<_R1, _R2>\x3a\x3atype {};\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct __ratio_subtract\x0a"
"{\x0a"
"private\x3a\x0a"
"    static const intmax_t __gcd_n1_n2 = __static_gcd<_R1\x3a\x3anum, _R2\x3a\x3anum>\x3a\x3avalue;\x0a"
"    static const intmax_t __gcd_d1_d2 = __static_gcd<_R1\x3a\x3a""den, _R2\x3a\x3a""den>\x3a\x3avalue;\x0a"
"public\x3a\x0a"
"    typedef typename ratio_multiply\x0a"
"        <\x0a"
"            ratio<__gcd_n1_n2, _R1\x3a\x3a""den / __gcd_d1_d2>,\x0a"
"            ratio\x0a"
"            <\x0a"
"                __ll_sub\x0a"
"                <\x0a"
"                    __ll_mul<_R1\x3a\x3anum / __gcd_n1_n2, _R2\x3a\x3a""den / __gcd_d1_d2>\x3a\x3avalue,\x0a"
"                    __ll_mul<_R2\x3a\x3anum / __gcd_n1_n2, _R1\x3a\x3a""den / __gcd_d1_d2>\x3a\x3avalue\x0a"
"                >\x3a\x3avalue,\x0a"
"                _R2\x3a\x3a""den\x0a"
"            >\x0a"
"        >\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2> using ratio_subtract\x0a"
"                                    = typename __ratio_subtract<_R1, _R2>\x3a\x3atype;\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS ratio_subtract\x0a"
"    \x3a public __ratio_subtract<_R1, _R2>\x3a\x3atype {};\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"// ratio_equal\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS ratio_equal\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT((_R1\x3a\x3anum == _R2\x3a\x3anum \x26\x26 _R1\x3a\x3a""den == _R2\x3a\x3a""den)) {};\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS ratio_not_equal\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT((\x21ratio_equal<_R1, _R2>\x3a\x3avalue)) {};\x0a"
"\x0a"
"// ratio_less\x0a"
"\x0a"
"template <class _R1, class _R2, bool _Odd = false,\x0a"
"          intmax_t _Q1 = _R1\x3a\x3anum / _R1\x3a\x3a""den, intmax_t _M1 = _R1\x3a\x3anum \x25 _R1\x3a\x3a""den,\x0a"
"          intmax_t _Q2 = _R2\x3a\x3anum / _R2\x3a\x3a""den, intmax_t _M2 = _R2\x3a\x3anum \x25 _R2\x3a\x3a""den>\x0a"
"struct __ratio_less1\x0a"
"{\x0a"
"    static const bool value = _Odd \x3f _Q2 < _Q1 \x3a _Q1 < _Q2;\x0a"
"};\x0a"
"\x0a"
"template <class _R1, class _R2, bool _Odd, intmax_t _Qp>\x0a"
"struct __ratio_less1<_R1, _R2, _Odd, _Qp, 0, _Qp, 0>\x0a"
"{\x0a"
"    static const bool value = false;\x0a"
"};\x0a"
"\x0a"
"template <class _R1, class _R2, bool _Odd, intmax_t _Qp, intmax_t _M2>\x0a"
"struct __ratio_less1<_R1, _R2, _Odd, _Qp, 0, _Qp, _M2>\x0a"
"{\x0a"
"    static const bool value = \x21_Odd;\x0a"
"};\x0a"
"\x0a"
"template <class _R1, class _R2, bool _Odd, intmax_t _Qp, intmax_t _M1>\x0a"
"struct __ratio_less1<_R1, _R2, _Odd, _Qp, _M1, _Qp, 0>\x0a"
"{\x0a"
"    static const bool value = _Odd;\x0a"
"};\x0a"
"\x0a"
"template <class _R1, class _R2, bool _Odd, intmax_t _Qp, intmax_t _M1,\x0a"
"                                                        intmax_t _M2>\x0a"
"struct __ratio_less1<_R1, _R2, _Odd, _Qp, _M1, _Qp, _M2>\x0a"
"{\x0a"
"    static const bool value = __ratio_less1<ratio<_R1\x3a\x3a""den, _M1>,\x0a"
"                                            ratio<_R2\x3a\x3a""den, _M2>, \x21_Odd>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _R1, class _R2, intmax_t _S1 = __static_sign<_R1\x3a\x3anum>\x3a\x3avalue,\x0a"
"                                intmax_t _S2 = __static_sign<_R2\x3a\x3anum>\x3a\x3avalue>\x0a"
"struct __ratio_less\x0a"
"{\x0a"
"    static const bool value = _S1 < _S2;\x0a"
"};\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct __ratio_less<_R1, _R2, 1LL, 1LL>\x0a"
"{\x0a"
"    static const bool value = __ratio_less1<_R1, _R2>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct __ratio_less<_R1, _R2, -1LL, -1LL>\x0a"
"{\x0a"
"    static const bool value = __ratio_less1<ratio<-_R2\x3a\x3anum, _R2\x3a\x3a""den>, ratio<-_R1\x3a\x3anum, _R1\x3a\x3a""den> >\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS ratio_less\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT((__ratio_less<_R1, _R2>\x3a\x3avalue)) {};\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS ratio_less_equal\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT((\x21ratio_less<_R2, _R1>\x3a\x3avalue)) {};\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS ratio_greater\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT((ratio_less<_R2, _R1>\x3a\x3avalue)) {};\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS ratio_greater_equal\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT((\x21ratio_less<_R1, _R2>\x3a\x3avalue)) {};\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"struct __ratio_gcd\x0a"
"{\x0a"
"    typedef ratio<__static_gcd<_R1\x3a\x3anum, _R2\x3a\x3anum>\x3a\x3avalue,\x0a"
"                  __static_lcm<_R1\x3a\x3a""den, _R2\x3a\x3a""den>\x3a\x3avalue> type;\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _R1, class _R2>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool ratio_equal_v\x0a"
"    = ratio_equal<_R1, _R2>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool ratio_not_equal_v\x0a"
"    = ratio_not_equal<_R1, _R2>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool ratio_less_v\x0a"
"    = ratio_less<_R1, _R2>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool ratio_less_equal_v\x0a"
"    = ratio_less_equal<_R1, _R2>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool ratio_greater_v\x0a"
"    = ratio_greater<_R1, _R2>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _R1, class _R2>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool ratio_greater_equal_v\x0a"
"    = ratio_greater_equal<_R1, _R2>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_RATIO\x0a"
"", 16429 ); }