#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_scoped_allocator( 
"// -*- C++ -*-\x0a"
"//===-------------------------- scoped_allocator --------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_SCOPED_ALLOCATOR\x0a"
"#define _LIBCPP_SCOPED_ALLOCATOR\x0a"
"\x0a"
"/*\x0a"
"    scoped_allocator synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class OuterAlloc, class... InnerAllocs>\x0a"
"class scoped_allocator_adaptor \x3a public OuterAlloc\x0a"
"{\x0a"
"    typedef allocator_traits<OuterAlloc> OuterTraits; // exposition only\x0a"
"    scoped_allocator_adaptor<InnerAllocs...> inner;   // exposition only\x0a"
"public\x3a\x0a"
"\x0a"
"    typedef OuterAlloc outer_allocator_type;\x0a"
"    typedef see below inner_allocator_type;\x0a"
"\x0a"
"    typedef typename OuterTraits\x3a\x3avalue_type value_type;\x0a"
"    typedef typename OuterTraits\x3a\x3asize_type size_type;\x0a"
"    typedef typename OuterTraits\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename OuterTraits\x3a\x3apointer pointer;\x0a"
"    typedef typename OuterTraits\x3a\x3a""const_pointer const_pointer;\x0a"
"    typedef typename OuterTraits\x3a\x3avoid_pointer void_pointer;\x0a"
"    typedef typename OuterTraits\x3a\x3a""const_void_pointer const_void_pointer;\x0a"
"\x0a"
"    typedef see below propagate_on_container_copy_assignment;\x0a"
"    typedef see below propagate_on_container_move_assignment;\x0a"
"    typedef see below propagate_on_container_swap;\x0a"
"    typedef see below is_always_equal;\x0a"
"\x0a"
"    template <class Tp>\x0a"
"        struct rebind\x0a"
"        {\x0a"
"            typedef scoped_allocator_adaptor<\x0a"
"                OuterTraits\x3a\x3atemplate rebind_alloc<Tp>, InnerAllocs...> other;\x0a"
"        };\x0a"
"\x0a"
"    scoped_allocator_adaptor();\x0a"
"    template <class OuterA2>\x0a"
"        scoped_allocator_adaptor(OuterA2\x26\x26 outerAlloc,\x0a"
"                                 const InnerAllocs\x26... innerAllocs) noexcept;\x0a"
"    scoped_allocator_adaptor(const scoped_allocator_adaptor\x26 other) noexcept;\x0a"
"    scoped_allocator_adaptor(scoped_allocator_adaptor\x26\x26 other) noexcept;\x0a"
"    template <class OuterA2>\x0a"
"        scoped_allocator_adaptor(const scoped_allocator_adaptor<OuterA2, InnerAllocs...>\x26 other) noexcept;\x0a"
"    template <class OuterA2>\x0a"
"        scoped_allocator_adaptor(const scoped_allocator_adaptor<OuterA2, InnerAllocs...>\x26\x26 other) noexcept;\x0a"
"\x0a"
"    scoped_allocator_adaptor\x26 operator=(const scoped_allocator_adaptor\x26) = default;\x0a"
"    scoped_allocator_adaptor\x26 operator=(scoped_allocator_adaptor\x26\x26) = default;\x0a"
"    \x7escoped_allocator_adaptor();\x0a"
"\x0a"
"    inner_allocator_type\x26 inner_allocator() noexcept;\x0a"
"    const inner_allocator_type\x26 inner_allocator() const noexcept;\x0a"
"\x0a"
"    outer_allocator_type\x26 outer_allocator() noexcept;\x0a"
"    const outer_allocator_type\x26 outer_allocator() const noexcept;\x0a"
"\x0a"
"    pointer allocate(size_type n);                           // \x5b\x5bnodiscard\x5d\x5d in C++20\x0a"
"    pointer allocate(size_type n, const_void_pointer hint);  // \x5b\x5bnodiscard\x5d\x5d in C++20\x0a"
"    void deallocate(pointer p, size_type n) noexcept;\x0a"
"\x0a"
"    size_type max_size() const;\x0a"
"    template <class T, class... Args> void construct(T* p, Args\x26\x26 args);\x0a"
"    template <class T1, class T2, class... Args1, class... Args2>\x0a"
"        void construct(pair<T1, T2>* p, piecewise_construct t, tuple<Args1...> x,\x0a"
"                       tuple<Args2...> y);\x0a"
"    template <class T1, class T2>\x0a"
"        void construct(pair<T1, T2>* p);\x0a"
"    template <class T1, class T2, class U, class V>\x0a"
"        void construct(pair<T1, T2>* p, U\x26\x26 x, V\x26\x26 y);\x0a"
"    template <class T1, class T2, class U, class V>\x0a"
"        void construct(pair<T1, T2>* p, const pair<U, V>\x26 x);\x0a"
"    template <class T1, class T2, class U, class V>\x0a"
"        void construct(pair<T1, T2>* p, pair<U, V>\x26\x26 x);\x0a"
"    template <class T> void destroy(T* p);\x0a"
"\x0a"
"    template <class T> void destroy(T* p) noexcept;\x0a"
"\x0a"
"    scoped_allocator_adaptor select_on_container_copy_construction() const noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class OuterA1, class OuterA2, class... InnerAllocs>\x0a"
"    bool\x0a"
"    operator==(const scoped_allocator_adaptor<OuterA1, InnerAllocs...>\x26 a,\x0a"
"               const scoped_allocator_adaptor<OuterA2, InnerAllocs...>\x26 b) noexcept;\x0a"
"\x0a"
"template <class OuterA1, class OuterA2, class... InnerAllocs>\x0a"
"    bool\x0a"
"    operator\x21=(const scoped_allocator_adaptor<OuterA1, InnerAllocs...>\x26 a,\x0a"
"               const scoped_allocator_adaptor<OuterA2, InnerAllocs...>\x26 b) noexcept;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <memory>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"\x0a"
"// scoped_allocator_adaptor\x0a"
"\x0a"
"template <class ..._Allocs>\x0a"
"class scoped_allocator_adaptor;\x0a"
"\x0a"
"template <class ..._Allocs> struct __get_poc_copy_assignment;\x0a"
"\x0a"
"template <class _A0>\x0a"
"struct __get_poc_copy_assignment<_A0>\x0a"
"{\x0a"
"    static const bool value = allocator_traits<_A0>\x3a\x3a\x0a"
"                              propagate_on_container_copy_assignment\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _A0, class ..._Allocs>\x0a"
"struct __get_poc_copy_assignment<_A0, _Allocs...>\x0a"
"{\x0a"
"    static const bool value =\x0a"
"        allocator_traits<_A0>\x3a\x3apropagate_on_container_copy_assignment\x3a\x3avalue \x7c\x7c\x0a"
"        __get_poc_copy_assignment<_Allocs...>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class ..._Allocs> struct __get_poc_move_assignment;\x0a"
"\x0a"
"template <class _A0>\x0a"
"struct __get_poc_move_assignment<_A0>\x0a"
"{\x0a"
"    static const bool value = allocator_traits<_A0>\x3a\x3a\x0a"
"                              propagate_on_container_move_assignment\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _A0, class ..._Allocs>\x0a"
"struct __get_poc_move_assignment<_A0, _Allocs...>\x0a"
"{\x0a"
"    static const bool value =\x0a"
"        allocator_traits<_A0>\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"        __get_poc_move_assignment<_Allocs...>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class ..._Allocs> struct __get_poc_swap;\x0a"
"\x0a"
"template <class _A0>\x0a"
"struct __get_poc_swap<_A0>\x0a"
"{\x0a"
"    static const bool value = allocator_traits<_A0>\x3a\x3a\x0a"
"                              propagate_on_container_swap\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _A0, class ..._Allocs>\x0a"
"struct __get_poc_swap<_A0, _Allocs...>\x0a"
"{\x0a"
"    static const bool value =\x0a"
"        allocator_traits<_A0>\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"        __get_poc_swap<_Allocs...>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class ..._Allocs> struct __get_is_always_equal;\x0a"
"\x0a"
"template <class _A0>\x0a"
"struct __get_is_always_equal<_A0>\x0a"
"{\x0a"
"    static const bool value = allocator_traits<_A0>\x3a\x3ais_always_equal\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _A0, class ..._Allocs>\x0a"
"struct __get_is_always_equal<_A0, _Allocs...>\x0a"
"{\x0a"
"    static const bool value =\x0a"
"        allocator_traits<_A0>\x3a\x3ais_always_equal\x3a\x3avalue \x26\x26\x0a"
"        __get_is_always_equal<_Allocs...>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class ..._Allocs>\x0a"
"class __scoped_allocator_storage;\x0a"
"\x0a"
"template <class _OuterAlloc, class... _InnerAllocs>\x0a"
"class __scoped_allocator_storage<_OuterAlloc, _InnerAllocs...>\x0a"
"    \x3a public _OuterAlloc\x0a"
"{\x0a"
"    typedef _OuterAlloc outer_allocator_type;\x0a"
"protected\x3a\x0a"
"    typedef scoped_allocator_adaptor<_InnerAllocs...> inner_allocator_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    inner_allocator_type __inner_;\x0a"
"\x0a"
"protected\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __scoped_allocator_storage() _NOEXCEPT {}\x0a"
"\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, _OuterA2>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __scoped_allocator_storage(_OuterA2\x26\x26 __outerAlloc,\x0a"
"                                   const _InnerAllocs\x26 ...__innerAllocs) _NOEXCEPT\x0a"
"            \x3a outer_allocator_type(_VSTD\x3a\x3a""forward<_OuterA2>(__outerAlloc)),\x0a"
"              __inner_(__innerAllocs...) {}\x0a"
"\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, const _OuterA2\x26>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __scoped_allocator_storage(\x0a"
"            const __scoped_allocator_storage<_OuterA2, _InnerAllocs...>\x26 __other) _NOEXCEPT\x0a"
"            \x3a outer_allocator_type(__other.outer_allocator()),\x0a"
"              __inner_(__other.inner_allocator()) {}\x0a"
"\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, _OuterA2>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __scoped_allocator_storage(\x0a"
"            __scoped_allocator_storage<_OuterA2, _InnerAllocs...>\x26\x26 __other) _NOEXCEPT\x0a"
"            \x3a outer_allocator_type(_VSTD\x3a\x3amove(__other.outer_allocator())),\x0a"
"              __inner_(_VSTD\x3a\x3amove(__other.inner_allocator())) {}\x0a"
"\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, _OuterA2>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __scoped_allocator_storage(_OuterA2\x26\x26 __o,\x0a"
"                                   const inner_allocator_type\x26 __i) _NOEXCEPT\x0a"
"            \x3a outer_allocator_type(_VSTD\x3a\x3a""forward<_OuterA2>(__o)),\x0a"
"              __inner_(__i)\x0a"
"        {\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    inner_allocator_type\x26 inner_allocator() _NOEXCEPT             {return __inner_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const inner_allocator_type\x26 inner_allocator() const _NOEXCEPT {return __inner_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    outer_allocator_type\x26 outer_allocator() _NOEXCEPT\x0a"
"        {return static_cast<outer_allocator_type\x26>(*this);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const outer_allocator_type\x26 outer_allocator() const _NOEXCEPT\x0a"
"        {return static_cast<const outer_allocator_type\x26>(*this);}\x0a"
"\x0a"
"    scoped_allocator_adaptor<outer_allocator_type, _InnerAllocs...>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    select_on_container_copy_construction() const _NOEXCEPT\x0a"
"        {\x0a"
"            return scoped_allocator_adaptor<outer_allocator_type, _InnerAllocs...>\x0a"
"            (\x0a"
"                allocator_traits<outer_allocator_type>\x3a\x3a\x0a"
"                    select_on_container_copy_construction(outer_allocator()),\x0a"
"                allocator_traits<inner_allocator_type>\x3a\x3a\x0a"
"                    select_on_container_copy_construction(inner_allocator())\x0a"
"            );\x0a"
"        }\x0a"
"\x0a"
"    template <class...> friend class __scoped_allocator_storage;\x0a"
"};\x0a"
"\x0a"
"template <class _OuterAlloc>\x0a"
"class __scoped_allocator_storage<_OuterAlloc>\x0a"
"    \x3a public _OuterAlloc\x0a"
"{\x0a"
"    typedef _OuterAlloc outer_allocator_type;\x0a"
"protected\x3a\x0a"
"    typedef scoped_allocator_adaptor<_OuterAlloc> inner_allocator_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __scoped_allocator_storage() _NOEXCEPT {}\x0a"
"\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, _OuterA2>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __scoped_allocator_storage(_OuterA2\x26\x26 __outerAlloc) _NOEXCEPT\x0a"
"            \x3a outer_allocator_type(_VSTD\x3a\x3a""forward<_OuterA2>(__outerAlloc)) {}\x0a"
"\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, const _OuterA2\x26>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __scoped_allocator_storage(\x0a"
"            const __scoped_allocator_storage<_OuterA2>\x26 __other) _NOEXCEPT\x0a"
"            \x3a outer_allocator_type(__other.outer_allocator()) {}\x0a"
"\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, _OuterA2>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __scoped_allocator_storage(\x0a"
"            __scoped_allocator_storage<_OuterA2>\x26\x26 __other) _NOEXCEPT\x0a"
"            \x3a outer_allocator_type(_VSTD\x3a\x3amove(__other.outer_allocator())) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    inner_allocator_type\x26 inner_allocator() _NOEXCEPT\x0a"
"        {return static_cast<inner_allocator_type\x26>(*this);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const inner_allocator_type\x26 inner_allocator() const _NOEXCEPT\x0a"
"        {return static_cast<const inner_allocator_type\x26>(*this);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    outer_allocator_type\x26 outer_allocator() _NOEXCEPT\x0a"
"        {return static_cast<outer_allocator_type\x26>(*this);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const outer_allocator_type\x26 outer_allocator() const _NOEXCEPT\x0a"
"        {return static_cast<const outer_allocator_type\x26>(*this);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    scoped_allocator_adaptor<outer_allocator_type>\x0a"
"    select_on_container_copy_construction() const _NOEXCEPT\x0a"
"        {return scoped_allocator_adaptor<outer_allocator_type>(\x0a"
"            allocator_traits<outer_allocator_type>\x3a\x3a\x0a"
"                select_on_container_copy_construction(outer_allocator())\x0a"
"        );}\x0a"
"\x0a"
"    __scoped_allocator_storage(const outer_allocator_type\x26 __o,\x0a"
"                               const inner_allocator_type\x26 __i) _NOEXCEPT;\x0a"
"\x0a"
"    template <class...> friend class __scoped_allocator_storage;\x0a"
"};\x0a"
"\x0a"
"// __outermost\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"decltype(declval<_Alloc>().outer_allocator(), true_type())\x0a"
"__has_outer_allocator_test(_Alloc\x26\x26 __a);\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"false_type\x0a"
"__has_outer_allocator_test(const volatile _Alloc\x26 __a);\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct __has_outer_allocator\x0a"
"    \x3a public common_type\x0a"
"             <\x0a"
"                 decltype(__has_outer_allocator_test(declval<_Alloc\x26>()))\x0a"
"             >\x3a\x3atype\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc, bool = __has_outer_allocator<_Alloc>\x3a\x3avalue>\x0a"
"struct __outermost\x0a"
"{\x0a"
"    typedef _Alloc type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    type\x26 operator()(type\x26 __a) const _NOEXCEPT {return __a;}\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct __outermost<_Alloc, true>\x0a"
"{\x0a"
"    typedef typename remove_reference\x0a"
"                     <\x0a"
"                        decltype(_VSTD\x3a\x3a""declval<_Alloc>().outer_allocator())\x0a"
"                     >\x3a\x3atype                                    _OuterAlloc;\x0a"
"    typedef typename __outermost<_OuterAlloc>\x3a\x3atype             type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    type\x26 operator()(_Alloc\x26 __a) const _NOEXCEPT\x0a"
"        {return __outermost<_OuterAlloc>()(__a.outer_allocator());}\x0a"
"};\x0a"
"\x0a"
"template <class _OuterAlloc, class... _InnerAllocs>\x0a"
"class _LIBCPP_TEMPLATE_VIS scoped_allocator_adaptor<_OuterAlloc, _InnerAllocs...>\x0a"
"    \x3a public __scoped_allocator_storage<_OuterAlloc, _InnerAllocs...>\x0a"
"{\x0a"
"    typedef __scoped_allocator_storage<_OuterAlloc, _InnerAllocs...> base;\x0a"
"    typedef allocator_traits<_OuterAlloc>             _OuterTraits;\x0a"
"public\x3a\x0a"
"    typedef _OuterAlloc                               outer_allocator_type;\x0a"
"    typedef typename base\x3a\x3ainner_allocator_type       inner_allocator_type;\x0a"
"    typedef typename _OuterTraits\x3a\x3asize_type          size_type;\x0a"
"    typedef typename _OuterTraits\x3a\x3a""difference_type    difference_type;\x0a"
"    typedef typename _OuterTraits\x3a\x3apointer            pointer;\x0a"
"    typedef typename _OuterTraits\x3a\x3a""const_pointer      const_pointer;\x0a"
"    typedef typename _OuterTraits\x3a\x3avoid_pointer       void_pointer;\x0a"
"    typedef typename _OuterTraits\x3a\x3a""const_void_pointer const_void_pointer;\x0a"
"\x0a"
"    typedef integral_constant\x0a"
"            <\x0a"
"                bool,\x0a"
"                __get_poc_copy_assignment<outer_allocator_type,\x0a"
"                                          _InnerAllocs...>\x3a\x3avalue\x0a"
"            > propagate_on_container_copy_assignment;\x0a"
"    typedef integral_constant\x0a"
"            <\x0a"
"                bool,\x0a"
"                __get_poc_move_assignment<outer_allocator_type,\x0a"
"                                          _InnerAllocs...>\x3a\x3avalue\x0a"
"            > propagate_on_container_move_assignment;\x0a"
"    typedef integral_constant\x0a"
"            <\x0a"
"                bool,\x0a"
"                __get_poc_swap<outer_allocator_type, _InnerAllocs...>\x3a\x3avalue\x0a"
"            > propagate_on_container_swap;\x0a"
"    typedef integral_constant\x0a"
"            <\x0a"
"                bool,\x0a"
"                __get_is_always_equal<outer_allocator_type, _InnerAllocs...>\x3a\x3avalue\x0a"
"            > is_always_equal;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    struct rebind\x0a"
"    {\x0a"
"        typedef scoped_allocator_adaptor\x0a"
"        <\x0a"
"            typename _OuterTraits\x3a\x3atemplate rebind_alloc<_Tp>, _InnerAllocs...\x0a"
"        > other;\x0a"
"    };\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    scoped_allocator_adaptor() _NOEXCEPT {}\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, _OuterA2>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        scoped_allocator_adaptor(_OuterA2\x26\x26 __outerAlloc,\x0a"
"                                 const _InnerAllocs\x26 ...__innerAllocs) _NOEXCEPT\x0a"
"            \x3a base(_VSTD\x3a\x3a""forward<_OuterA2>(__outerAlloc), __innerAllocs...) {}\x0a"
"    // scoped_allocator_adaptor(const scoped_allocator_adaptor\x26 __other) = default;\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, const _OuterA2\x26>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        scoped_allocator_adaptor(\x0a"
"            const scoped_allocator_adaptor<_OuterA2, _InnerAllocs...>\x26 __other) _NOEXCEPT\x0a"
"                \x3a base(__other) {}\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, _OuterA2>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        scoped_allocator_adaptor(\x0a"
"            scoped_allocator_adaptor<_OuterA2, _InnerAllocs...>\x26\x26 __other) _NOEXCEPT\x0a"
"                \x3a base(_VSTD\x3a\x3amove(__other)) {}\x0a"
"\x0a"
"    // scoped_allocator_adaptor\x26 operator=(const scoped_allocator_adaptor\x26) = default;\x0a"
"    // scoped_allocator_adaptor\x26 operator=(scoped_allocator_adaptor\x26\x26) = default;\x0a"
"    // \x7escoped_allocator_adaptor() = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    inner_allocator_type\x26 inner_allocator() _NOEXCEPT\x0a"
"        {return base\x3a\x3ainner_allocator();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const inner_allocator_type\x26 inner_allocator() const _NOEXCEPT\x0a"
"        {return base\x3a\x3ainner_allocator();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    outer_allocator_type\x26 outer_allocator() _NOEXCEPT\x0a"
"        {return base\x3a\x3aouter_allocator();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const outer_allocator_type\x26 outer_allocator() const _NOEXCEPT\x0a"
"        {return base\x3a\x3aouter_allocator();}\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer allocate(size_type __n)\x0a"
"        {return allocator_traits<outer_allocator_type>\x3a\x3a\x0a"
"            allocate(outer_allocator(), __n);}\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer allocate(size_type __n, const_void_pointer __hint)\x0a"
"        {return allocator_traits<outer_allocator_type>\x3a\x3a\x0a"
"            allocate(outer_allocator(), __n, __hint);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void deallocate(pointer __p, size_type __n) _NOEXCEPT\x0a"
"        {allocator_traits<outer_allocator_type>\x3a\x3a\x0a"
"            deallocate(outer_allocator(), __p, __n);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const\x0a"
"        {return allocator_traits<outer_allocator_type>\x3a\x3amax_size(outer_allocator());}\x0a"
"\x0a"
"    template <class _Tp, class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void construct(_Tp* __p, _Args\x26\x26 ...__args)\x0a"
"            {__construct(__uses_alloc_ctor<_Tp, inner_allocator_type\x26, _Args...>(),\x0a"
"                         __p, _VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"\x0a"
"    template <class _T1, class _T2, class... _Args1, class... _Args2>\x0a"
"    void construct(pair<_T1, _T2>* __p, piecewise_construct_t,\x0a"
"                       tuple<_Args1...> __x, tuple<_Args2...> __y)\x0a"
"    {\x0a"
"        typedef __outermost<outer_allocator_type> _OM;\x0a"
"        allocator_traits<typename _OM\x3a\x3atype>\x3a\x3a""construct(\x0a"
"            _OM()(outer_allocator()), __p, piecewise_construct\x0a"
"          , __transform_tuple(\x0a"
"              typename __uses_alloc_ctor<\x0a"
"                  _T1, inner_allocator_type\x26, _Args1...\x0a"
"              >\x3a\x3atype()\x0a"
"            , _VSTD\x3a\x3amove(__x)\x0a"
"            , typename __make_tuple_indices<sizeof...(_Args1)>\x3a\x3atype{}\x0a"
"          )\x0a"
"          , __transform_tuple(\x0a"
"              typename __uses_alloc_ctor<\x0a"
"                  _T2, inner_allocator_type\x26, _Args2...\x0a"
"              >\x3a\x3atype()\x0a"
"            , _VSTD\x3a\x3amove(__y)\x0a"
"            , typename __make_tuple_indices<sizeof...(_Args2)>\x3a\x3atype{}\x0a"
"          )\x0a"
"        );\x0a"
"    }\x0a"
"\x0a"
"    template <class _T1, class _T2>\x0a"
"    void construct(pair<_T1, _T2>* __p)\x0a"
"    { construct(__p, piecewise_construct, tuple<>{}, tuple<>{}); }\x0a"
"\x0a"
"    template <class _T1, class _T2, class _Up, class _Vp>\x0a"
"    void construct(pair<_T1, _T2>* __p, _Up\x26\x26 __x, _Vp\x26\x26 __y) {\x0a"
"        construct(__p, piecewise_construct,\x0a"
"                  _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Up>(__x)),\x0a"
"                  _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Vp>(__y)));\x0a"
"    }\x0a"
"\x0a"
"    template <class _T1, class _T2, class _Up, class _Vp>\x0a"
"    void construct(pair<_T1, _T2>* __p, const pair<_Up, _Vp>\x26 __x) {\x0a"
"        construct(__p, piecewise_construct,\x0a"
"                  _VSTD\x3a\x3a""forward_as_tuple(__x.first),\x0a"
"                  _VSTD\x3a\x3a""forward_as_tuple(__x.second));\x0a"
"    }\x0a"
"\x0a"
"    template <class _T1, class _T2, class _Up, class _Vp>\x0a"
"    void construct(pair<_T1, _T2>* __p, pair<_Up, _Vp>\x26\x26 __x) {\x0a"
"        construct(__p, piecewise_construct,\x0a"
"                  _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Up>(__x.first)),\x0a"
"                  _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Vp>(__x.second)));\x0a"
"    }\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void destroy(_Tp* __p)\x0a"
"            {\x0a"
"                typedef __outermost<outer_allocator_type> _OM;\x0a"
"                allocator_traits<typename _OM\x3a\x3atype>\x3a\x3a\x0a"
"                                         destroy(_OM()(outer_allocator()), __p);\x0a"
"            }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    scoped_allocator_adaptor select_on_container_copy_construction() const _NOEXCEPT\x0a"
"        {return base\x3a\x3aselect_on_container_copy_construction();}\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"\x0a"
"    template <class _OuterA2,\x0a"
"              class = typename enable_if<\x0a"
"                        is_constructible<outer_allocator_type, _OuterA2>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    scoped_allocator_adaptor(_OuterA2\x26\x26 __o,\x0a"
"                             const inner_allocator_type\x26 __i) _NOEXCEPT\x0a"
"        \x3a base(_VSTD\x3a\x3a""forward<_OuterA2>(__o), __i) {}\x0a"
"\x0a"
"    template <class _Tp, class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void __construct(integral_constant<int, 0>, _Tp* __p, _Args\x26\x26 ...__args)\x0a"
"            {\x0a"
"                typedef __outermost<outer_allocator_type> _OM;\x0a"
"                allocator_traits<typename _OM\x3a\x3atype>\x3a\x3a""construct\x0a"
"                (\x0a"
"                    _OM()(outer_allocator()),\x0a"
"                    __p,\x0a"
"                    _VSTD\x3a\x3a""forward<_Args>(__args)...\x0a"
"                );\x0a"
"            }\x0a"
"\x0a"
"    template <class _Tp, class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void __construct(integral_constant<int, 1>, _Tp* __p, _Args\x26\x26 ...__args)\x0a"
"            {\x0a"
"                typedef __outermost<outer_allocator_type> _OM;\x0a"
"                allocator_traits<typename _OM\x3a\x3atype>\x3a\x3a""construct\x0a"
"                (\x0a"
"                    _OM()(outer_allocator()),\x0a"
"                    __p, allocator_arg, inner_allocator(),\x0a"
"                    _VSTD\x3a\x3a""forward<_Args>(__args)...\x0a"
"                );\x0a"
"            }\x0a"
"\x0a"
"    template <class _Tp, class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void __construct(integral_constant<int, 2>, _Tp* __p, _Args\x26\x26 ...__args)\x0a"
"            {\x0a"
"                typedef __outermost<outer_allocator_type> _OM;\x0a"
"                allocator_traits<typename _OM\x3a\x3atype>\x3a\x3a""construct\x0a"
"                (\x0a"
"                    _OM()(outer_allocator()),\x0a"
"                    __p,\x0a"
"                    _VSTD\x3a\x3a""forward<_Args>(__args)...,\x0a"
"                    inner_allocator()\x0a"
"                );\x0a"
"            }\x0a"
"\x0a"
"    template <class ..._Args, size_t ..._Idx>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    tuple<_Args\x26\x26...>\x0a"
"    __transform_tuple(integral_constant<int, 0>, tuple<_Args...>\x26\x26 __t,\x0a"
"                      __tuple_indices<_Idx...>)\x0a"
"    {\x0a"
"        return _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3aget<_Idx>(_VSTD\x3a\x3amove(__t))...);\x0a"
"    }\x0a"
"\x0a"
"    template <class ..._Args, size_t ..._Idx>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    tuple<allocator_arg_t, inner_allocator_type\x26, _Args\x26\x26...>\x0a"
"    __transform_tuple(integral_constant<int, 1>, tuple<_Args...> \x26\x26 __t,\x0a"
"                      __tuple_indices<_Idx...>)\x0a"
"    {\x0a"
"        using _Tup = tuple<allocator_arg_t, inner_allocator_type\x26, _Args\x26\x26...>;\x0a"
"        return _Tup(allocator_arg, inner_allocator(),\x0a"
"                    _VSTD\x3a\x3aget<_Idx>(_VSTD\x3a\x3amove(__t))...);\x0a"
"    }\x0a"
"\x0a"
"    template <class ..._Args, size_t ..._Idx>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    tuple<_Args\x26\x26..., inner_allocator_type\x26>\x0a"
"    __transform_tuple(integral_constant<int, 2>, tuple<_Args...> \x26\x26 __t,\x0a"
"                      __tuple_indices<_Idx...>)\x0a"
"    {\x0a"
"        using _Tup = tuple<_Args\x26\x26..., inner_allocator_type\x26>;\x0a"
"        return _Tup(_VSTD\x3a\x3aget<_Idx>(_VSTD\x3a\x3amove(__t))..., inner_allocator());\x0a"
"    }\x0a"
"\x0a"
"    template <class...> friend class __scoped_allocator_storage;\x0a"
"};\x0a"
"\x0a"
"template <class _OuterA1, class _OuterA2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const scoped_allocator_adaptor<_OuterA1>\x26 __a,\x0a"
"           const scoped_allocator_adaptor<_OuterA2>\x26 __b) _NOEXCEPT\x0a"
"{\x0a"
"    return __a.outer_allocator() == __b.outer_allocator();\x0a"
"}\x0a"
"\x0a"
"template <class _OuterA1, class _OuterA2, class _InnerA0, class... _InnerAllocs>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const scoped_allocator_adaptor<_OuterA1, _InnerA0, _InnerAllocs...>\x26 __a,\x0a"
"           const scoped_allocator_adaptor<_OuterA2, _InnerA0, _InnerAllocs...>\x26 __b) _NOEXCEPT\x0a"
"{\x0a"
"    return __a.outer_allocator() == __b.outer_allocator() \x26\x26\x0a"
"           __a.inner_allocator() == __b.inner_allocator();\x0a"
"}\x0a"
"\x0a"
"template <class _OuterA1, class _OuterA2, class... _InnerAllocs>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const scoped_allocator_adaptor<_OuterA1, _InnerAllocs...>\x26 __a,\x0a"
"           const scoped_allocator_adaptor<_OuterA2, _InnerAllocs...>\x26 __b) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__a == __b);\x0a"
"}\x0a"
"\x0a"
"#endif  // \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_SCOPED_ALLOCATOR\x0a"
"", 25740 ); }