#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_set( 
"// -*- C++ -*-\x0a"
"//===---------------------------- set -------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_SET\x0a"
"#define _LIBCPP_SET\x0a"
"\x0a"
"/*\x0a"
"\x0a"
"    set synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class Key, class Compare = less<Key>,\x0a"
"          class Allocator = allocator<Key>>\x0a"
"class set\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef Key                                      key_type;\x0a"
"    typedef key_type                                 value_type;\x0a"
"    typedef Compare                                  key_compare;\x0a"
"    typedef key_compare                              value_compare;\x0a"
"    typedef Allocator                                allocator_type;\x0a"
"    typedef typename allocator_type\x3a\x3areference       reference;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename allocator_type\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_type\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename allocator_type\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_pointer   const_pointer;\x0a"
"\x0a"
"    typedef implementation-defined                   iterator;\x0a"
"    typedef implementation-defined                   const_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator>          reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator>    const_reverse_iterator;\x0a"
"    typedef unspecified                              node_type;               // C++17\x0a"
"    typedef INSERT_RETURN_TYPE<iterator, node_type>  insert_return_type;      // C++17\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    set()\x0a"
"        noexcept(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_compare>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue);\x0a"
"    explicit set(const value_compare\x26 comp);\x0a"
"    set(const value_compare\x26 comp, const allocator_type\x26 a);\x0a"
"    template <class InputIterator>\x0a"
"        set(InputIterator first, InputIterator last,\x0a"
"            const value_compare\x26 comp = value_compare());\x0a"
"    template <class InputIterator>\x0a"
"        set(InputIterator first, InputIterator last, const value_compare\x26 comp,\x0a"
"            const allocator_type\x26 a);\x0a"
"    set(const set\x26 s);\x0a"
"    set(set\x26\x26 s)\x0a"
"        noexcept(\x0a"
"            is_nothrow_move_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<key_compare>\x3a\x3avalue);\x0a"
"    explicit set(const allocator_type\x26 a);\x0a"
"    set(const set\x26 s, const allocator_type\x26 a);\x0a"
"    set(set\x26\x26 s, const allocator_type\x26 a);\x0a"
"    set(initializer_list<value_type> il, const value_compare\x26 comp = value_compare());\x0a"
"    set(initializer_list<value_type> il, const value_compare\x26 comp,\x0a"
"        const allocator_type\x26 a);\x0a"
"    template <class InputIterator>\x0a"
"        set(InputIterator first, InputIterator last, const allocator_type\x26 a)\x0a"
"            \x3a set(first, last, Compare(), a) {}  // C++14\x0a"
"    set(initializer_list<value_type> il, const allocator_type\x26 a)\x0a"
"        \x3a set(il, Compare(), a) {}  // C++14\x0a"
"    \x7eset();\x0a"
"\x0a"
"    set\x26 operator=(const set\x26 s);\x0a"
"    set\x26 operator=(set\x26\x26 s)\x0a"
"        noexcept(\x0a"
"            allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<key_compare>\x3a\x3avalue);\x0a"
"    set\x26 operator=(initializer_list<value_type> il);\x0a"
"\x0a"
"    // iterators\x3a\x0a"
"          iterator begin() noexcept;\x0a"
"    const_iterator begin() const noexcept;\x0a"
"          iterator end() noexcept;\x0a"
"    const_iterator end()   const noexcept;\x0a"
"\x0a"
"          reverse_iterator rbegin() noexcept;\x0a"
"    const_reverse_iterator rbegin() const noexcept;\x0a"
"          reverse_iterator rend() noexcept;\x0a"
"    const_reverse_iterator rend()   const noexcept;\x0a"
"\x0a"
"    const_iterator         cbegin()  const noexcept;\x0a"
"    const_iterator         cend()    const noexcept;\x0a"
"    const_reverse_iterator crbegin() const noexcept;\x0a"
"    const_reverse_iterator crend()   const noexcept;\x0a"
"\x0a"
"    // capacity\x3a\x0a"
"    bool      empty()    const noexcept;\x0a"
"    size_type size()     const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"\x0a"
"    // modifiers\x3a\x0a"
"    template <class... Args>\x0a"
"        pair<iterator, bool> emplace(Args\x26\x26... args);\x0a"
"    template <class... Args>\x0a"
"        iterator emplace_hint(const_iterator position, Args\x26\x26... args);\x0a"
"    pair<iterator,bool> insert(const value_type\x26 v);\x0a"
"    pair<iterator,bool> insert(value_type\x26\x26 v);\x0a"
"    iterator insert(const_iterator position, const value_type\x26 v);\x0a"
"    iterator insert(const_iterator position, value_type\x26\x26 v);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"    void insert(initializer_list<value_type> il);\x0a"
"\x0a"
"    node_type extract(const_iterator position);                                       // C++17\x0a"
"    node_type extract(const key_type\x26 x);                                             // C++17\x0a"
"    insert_return_type insert(node_type\x26\x26 nh);                                        // C++17\x0a"
"    iterator insert(const_iterator hint, node_type\x26\x26 nh);                             // C++17\x0a"
"\x0a"
"    iterator  erase(const_iterator position);\x0a"
"    iterator  erase(iterator position);  // C++14\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    iterator  erase(const_iterator first, const_iterator last);\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    template<class C2>\x0a"
"      void merge(set<Key, C2, Allocator>\x26 source);         // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(set<Key, C2, Allocator>\x26\x26 source);        // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(multiset<Key, C2, Allocator>\x26 source);    // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(multiset<Key, C2, Allocator>\x26\x26 source);   // C++17\x0a"
"\x0a"
"    void swap(set\x26 s)\x0a"
"        noexcept(\x0a"
"            __is_nothrow_swappable<key_compare>\x3a\x3avalue \x26\x26\x0a"
"            (\x21""allocator_type\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"             __is_nothrow_swappable<allocator_type>\x3a\x3avalue));\x0a"
"\x0a"
"    // observers\x3a\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"    key_compare    key_comp()      const;\x0a"
"    value_compare  value_comp()    const;\x0a"
"\x0a"
"    // set operations\x3a\x0a"
"          iterator find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator find(const K\x26 x);\x0a"
"    template<typename K>\x0a"
"        const_iterator find(const K\x26 x) const;  // C++14\x0a"
"    template<typename K>\x0a"
"        size_type count(const K\x26 x) const;        // C++14\x0a"
"    size_type      count(const key_type\x26 k) const;\x0a"
"        bool contains(const key_type\x26 x) const; // C++20\x0a"
"          iterator lower_bound(const key_type\x26 k);\x0a"
"    const_iterator lower_bound(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator lower_bound(const K\x26 x);              // C++14\x0a"
"    template<typename K>\x0a"
"        const_iterator lower_bound(const K\x26 x) const;  // C++14\x0a"
"\x0a"
"          iterator upper_bound(const key_type\x26 k);\x0a"
"    const_iterator upper_bound(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator upper_bound(const K\x26 x);              // C++14\x0a"
"    template<typename K>\x0a"
"        const_iterator upper_bound(const K\x26 x) const;  // C++14\x0a"
"    pair<iterator,iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator,const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        pair<iterator,iterator>             equal_range(const K\x26 x);        // C++14\x0a"
"    template<typename K>\x0a"
"        pair<const_iterator,const_iterator> equal_range(const K\x26 x) const;  // C++14\x0a"
"};\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator==(const set<Key, Compare, Allocator>\x26 x,\x0a"
"           const set<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator< (const set<Key, Compare, Allocator>\x26 x,\x0a"
"           const set<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator\x21=(const set<Key, Compare, Allocator>\x26 x,\x0a"
"           const set<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator> (const set<Key, Compare, Allocator>\x26 x,\x0a"
"           const set<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator>=(const set<Key, Compare, Allocator>\x26 x,\x0a"
"           const set<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator<=(const set<Key, Compare, Allocator>\x26 x,\x0a"
"           const set<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"// specialized algorithms\x3a\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"void\x0a"
"swap(set<Key, Compare, Allocator>\x26 x, set<Key, Compare, Allocator>\x26 y)\x0a"
"    noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator, class Predicate>\x0a"
"  void erase_if(set<Key, Compare, Allocator>\x26 c, Predicate pred);  // C++20\x0a"
"\x0a"
"template <class Key, class Compare = less<Key>,\x0a"
"          class Allocator = allocator<Key>>\x0a"
"class multiset\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef Key                                      key_type;\x0a"
"    typedef key_type                                 value_type;\x0a"
"    typedef Compare                                  key_compare;\x0a"
"    typedef key_compare                              value_compare;\x0a"
"    typedef Allocator                                allocator_type;\x0a"
"    typedef typename allocator_type\x3a\x3areference       reference;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename allocator_type\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_type\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename allocator_type\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_pointer   const_pointer;\x0a"
"\x0a"
"    typedef implementation-defined                   iterator;\x0a"
"    typedef implementation-defined                   const_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator>          reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator>    const_reverse_iterator;\x0a"
"    typedef unspecified                              node_type;               // C++17\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    multiset()\x0a"
"        noexcept(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_compare>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue);\x0a"
"    explicit multiset(const value_compare\x26 comp);\x0a"
"    multiset(const value_compare\x26 comp, const allocator_type\x26 a);\x0a"
"    template <class InputIterator>\x0a"
"        multiset(InputIterator first, InputIterator last,\x0a"
"                 const value_compare\x26 comp = value_compare());\x0a"
"    template <class InputIterator>\x0a"
"        multiset(InputIterator first, InputIterator last,\x0a"
"                 const value_compare\x26 comp, const allocator_type\x26 a);\x0a"
"    multiset(const multiset\x26 s);\x0a"
"    multiset(multiset\x26\x26 s)\x0a"
"        noexcept(\x0a"
"            is_nothrow_move_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<key_compare>\x3a\x3avalue);\x0a"
"    explicit multiset(const allocator_type\x26 a);\x0a"
"    multiset(const multiset\x26 s, const allocator_type\x26 a);\x0a"
"    multiset(multiset\x26\x26 s, const allocator_type\x26 a);\x0a"
"    multiset(initializer_list<value_type> il, const value_compare\x26 comp = value_compare());\x0a"
"    multiset(initializer_list<value_type> il, const value_compare\x26 comp,\x0a"
"             const allocator_type\x26 a);\x0a"
"    template <class InputIterator>\x0a"
"        multiset(InputIterator first, InputIterator last, const allocator_type\x26 a)\x0a"
"            \x3a set(first, last, Compare(), a) {}  // C++14\x0a"
"    multiset(initializer_list<value_type> il, const allocator_type\x26 a)\x0a"
"        \x3a set(il, Compare(), a) {}  // C++14\x0a"
"    \x7emultiset();\x0a"
"\x0a"
"    multiset\x26 operator=(const multiset\x26 s);\x0a"
"    multiset\x26 operator=(multiset\x26\x26 s)\x0a"
"        noexcept(\x0a"
"            allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<key_compare>\x3a\x3avalue);\x0a"
"    multiset\x26 operator=(initializer_list<value_type> il);\x0a"
"\x0a"
"    // iterators\x3a\x0a"
"          iterator begin() noexcept;\x0a"
"    const_iterator begin() const noexcept;\x0a"
"          iterator end() noexcept;\x0a"
"    const_iterator end()   const noexcept;\x0a"
"\x0a"
"          reverse_iterator rbegin() noexcept;\x0a"
"    const_reverse_iterator rbegin() const noexcept;\x0a"
"          reverse_iterator rend() noexcept;\x0a"
"    const_reverse_iterator rend()   const noexcept;\x0a"
"\x0a"
"    const_iterator         cbegin()  const noexcept;\x0a"
"    const_iterator         cend()    const noexcept;\x0a"
"    const_reverse_iterator crbegin() const noexcept;\x0a"
"    const_reverse_iterator crend()   const noexcept;\x0a"
"\x0a"
"    // capacity\x3a\x0a"
"    bool      empty()    const noexcept;\x0a"
"    size_type size()     const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"\x0a"
"    // modifiers\x3a\x0a"
"    template <class... Args>\x0a"
"        iterator emplace(Args\x26\x26... args);\x0a"
"    template <class... Args>\x0a"
"        iterator emplace_hint(const_iterator position, Args\x26\x26... args);\x0a"
"    iterator insert(const value_type\x26 v);\x0a"
"    iterator insert(value_type\x26\x26 v);\x0a"
"    iterator insert(const_iterator position, const value_type\x26 v);\x0a"
"    iterator insert(const_iterator position, value_type\x26\x26 v);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"    void insert(initializer_list<value_type> il);\x0a"
"\x0a"
"    node_type extract(const_iterator position);                                       // C++17\x0a"
"    node_type extract(const key_type\x26 x);                                             // C++17\x0a"
"    iterator insert(node_type\x26\x26 nh);                                                  // C++17\x0a"
"    iterator insert(const_iterator hint, node_type\x26\x26 nh);                             // C++17\x0a"
"\x0a"
"    iterator  erase(const_iterator position);\x0a"
"    iterator  erase(iterator position);  // C++14\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    iterator  erase(const_iterator first, const_iterator last);\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    template<class C2>\x0a"
"      void merge(multiset<Key, C2, Allocator>\x26 source);    // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(multiset<Key, C2, Allocator>\x26\x26 source);   // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(set<Key, C2, Allocator>\x26 source);         // C++17\x0a"
"    template<class C2>\x0a"
"      void merge(set<Key, C2, Allocator>\x26\x26 source);        // C++17\x0a"
"\x0a"
"    void swap(multiset\x26 s)\x0a"
"        noexcept(\x0a"
"            __is_nothrow_swappable<key_compare>\x3a\x3avalue \x26\x26\x0a"
"            (\x21""allocator_type\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"             __is_nothrow_swappable<allocator_type>\x3a\x3avalue));\x0a"
"\x0a"
"    // observers\x3a\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"    key_compare    key_comp()      const;\x0a"
"    value_compare  value_comp()    const;\x0a"
"\x0a"
"    // set operations\x3a\x0a"
"          iterator find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator find(const K\x26 x);\x0a"
"    template<typename K>\x0a"
"        const_iterator find(const K\x26 x) const;  // C++14\x0a"
"    template<typename K>\x0a"
"        size_type count(const K\x26 x) const;      // C++14\x0a"
"    size_type      count(const key_type\x26 k) const;\x0a"
"        bool contains(const key_type\x26 x) const; // C++20\x0a"
"          iterator lower_bound(const key_type\x26 k);\x0a"
"    const_iterator lower_bound(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator lower_bound(const K\x26 x);              // C++14\x0a"
"    template<typename K>\x0a"
"        const_iterator lower_bound(const K\x26 x) const;  // C++14\x0a"
"\x0a"
"          iterator upper_bound(const key_type\x26 k);\x0a"
"    const_iterator upper_bound(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        iterator upper_bound(const K\x26 x);              // C++14\x0a"
"    template<typename K>\x0a"
"        const_iterator upper_bound(const K\x26 x) const;  // C++14\x0a"
"\x0a"
"    pair<iterator,iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator,const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"    template<typename K>\x0a"
"        pair<iterator,iterator>             equal_range(const K\x26 x);        // C++14\x0a"
"    template<typename K>\x0a"
"        pair<const_iterator,const_iterator> equal_range(const K\x26 x) const;  // C++14\x0a"
"};\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator==(const multiset<Key, Compare, Allocator>\x26 x,\x0a"
"           const multiset<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator< (const multiset<Key, Compare, Allocator>\x26 x,\x0a"
"           const multiset<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator\x21=(const multiset<Key, Compare, Allocator>\x26 x,\x0a"
"           const multiset<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator> (const multiset<Key, Compare, Allocator>\x26 x,\x0a"
"           const multiset<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator>=(const multiset<Key, Compare, Allocator>\x26 x,\x0a"
"           const multiset<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"bool\x0a"
"operator<=(const multiset<Key, Compare, Allocator>\x26 x,\x0a"
"           const multiset<Key, Compare, Allocator>\x26 y);\x0a"
"\x0a"
"// specialized algorithms\x3a\x0a"
"template <class Key, class Compare, class Allocator>\x0a"
"void\x0a"
"swap(multiset<Key, Compare, Allocator>\x26 x, multiset<Key, Compare, Allocator>\x26 y)\x0a"
"    noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class Key, class Compare, class Allocator, class Predicate>\x0a"
"  void erase_if(multiset<Key, Compare, Allocator>\x26 c, Predicate pred);  // C++20\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__tree>\x0a"
"#include <__node_handle>\x0a"
"#include <functional>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"class multiset;\x0a"
"\x0a"
"template <class _Key, class _Compare = less<_Key>,\x0a"
"          class _Allocator = allocator<_Key> >\x0a"
"class _LIBCPP_TEMPLATE_VIS set\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef _Key                                     key_type;\x0a"
"    typedef key_type                                 value_type;\x0a"
"    typedef _Compare                                 key_compare;\x0a"
"    typedef key_compare                              value_compare;\x0a"
"    typedef typename __identity<_Allocator>\x3a\x3atype    allocator_type;\x0a"
"    typedef value_type\x26                              reference;\x0a"
"    typedef const value_type\x26                        const_reference;\x0a"
"\x0a"
"    static_assert((is_same<typename allocator_type\x3a\x3avalue_type, value_type>\x3a\x3avalue),\x0a"
"                  \x22""Allocator\x3a\x3avalue_type must be same type as value_type\x22);\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef __tree<value_type, value_compare, allocator_type> __base;\x0a"
"    typedef allocator_traits<allocator_type>                  __alloc_traits;\x0a"
"    typedef typename __base\x3a\x3a__node_holder                    __node_holder;\x0a"
"\x0a"
"    __base __tree_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __base\x3a\x3apointer               pointer;\x0a"
"    typedef typename __base\x3a\x3a""const_pointer         const_pointer;\x0a"
"    typedef typename __base\x3a\x3asize_type             size_type;\x0a"
"    typedef typename __base\x3a\x3a""difference_type       difference_type;\x0a"
"    typedef typename __base\x3a\x3a""const_iterator        iterator;\x0a"
"    typedef typename __base\x3a\x3a""const_iterator        const_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<iterator>       reverse_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<const_iterator> const_reverse_iterator;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    typedef __set_node_handle<typename __base\x3a\x3a__node, allocator_type> node_type;\x0a"
"    typedef __insert_return_type<iterator, node_type> insert_return_type;\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Key2, class _Compare2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS set;\x0a"
"    template <class _Key2, class _Compare2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS multiset;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    set()\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_compare>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue)\x0a"
"        \x3a __tree_(value_compare()) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit set(const value_compare\x26 __comp)\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue)\x0a"
"        \x3a __tree_(__comp) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit set(const value_compare\x26 __comp, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__comp, __a) {}\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        set(_InputIterator __f, _InputIterator __l,\x0a"
"            const value_compare\x26 __comp = value_compare())\x0a"
"        \x3a __tree_(__comp)\x0a"
"        {\x0a"
"            insert(__f, __l);\x0a"
"        }\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        set(_InputIterator __f, _InputIterator __l, const value_compare\x26 __comp,\x0a"
"            const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__comp, __a)\x0a"
"        {\x0a"
"            insert(__f, __l);\x0a"
"        }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"        template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        set(_InputIterator __f, _InputIterator __l, const allocator_type\x26 __a)\x0a"
"            \x3a set(__f, __l, key_compare(), __a) {}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    set(const set\x26 __s)\x0a"
"        \x3a __tree_(__s.__tree_)\x0a"
"        {\x0a"
"            insert(__s.begin(), __s.end());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    set\x26 operator=(const set\x26 __s)\x0a"
"        {\x0a"
"            __tree_ = __s.__tree_;\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    set(set\x26\x26 __s)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__base>\x3a\x3avalue)\x0a"
"        \x3a __tree_(_VSTD\x3a\x3amove(__s.__tree_)) {}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit set(const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__a) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    set(const set\x26 __s, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__s.__tree_.value_comp(), __a)\x0a"
"        {\x0a"
"            insert(__s.begin(), __s.end());\x0a"
"        }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    set(set\x26\x26 __s, const allocator_type\x26 __a);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    set(initializer_list<value_type> __il, const value_compare\x26 __comp = value_compare())\x0a"
"        \x3a __tree_(__comp)\x0a"
"        {\x0a"
"            insert(__il.begin(), __il.end());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    set(initializer_list<value_type> __il, const value_compare\x26 __comp,\x0a"
"        const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__comp, __a)\x0a"
"        {\x0a"
"            insert(__il.begin(), __il.end());\x0a"
"        }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    set(initializer_list<value_type> __il, const allocator_type\x26 __a)\x0a"
"        \x3a set(__il, key_compare(), __a) {}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    set\x26 operator=(initializer_list<value_type> __il)\x0a"
"        {\x0a"
"            __tree_.__assign_unique(__il.begin(), __il.end());\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    set\x26 operator=(set\x26\x26 __s)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__base>\x3a\x3avalue)\x0a"
"        {\x0a"
"            __tree_ = _VSTD\x3a\x3amove(__s.__tree_);\x0a"
"            return *this;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7eset() {\x0a"
"        static_assert(sizeof(__diagnose_non_const_comparator<_Key, _Compare>()), \x22\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator begin() _NOEXCEPT       {return __tree_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT {return __tree_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator end() _NOEXCEPT         {return __tree_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()   const _NOEXCEPT {return __tree_.end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          reverse_iterator rbegin() _NOEXCEPT\x0a"
"            {return reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          reverse_iterator rend() _NOEXCEPT\x0a"
"            {return reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin()  const _NOEXCEPT {return begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend() const _NOEXCEPT {return end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT {return rbegin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend() const _NOEXCEPT {return rend();}\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT {return __tree_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT {return __tree_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT {return __tree_.max_size();}\x0a"
"\x0a"
"    // modifiers\x3a\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> emplace(_Args\x26\x26... __args)\x0a"
"            {return __tree_.__emplace_unique(_VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator emplace_hint(const_iterator __p, _Args\x26\x26... __args)\x0a"
"            {return __tree_.__emplace_hint_unique(__p, _VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator,bool> insert(const value_type\x26 __v)\x0a"
"        {return __tree_.__insert_unique(__v);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, const value_type\x26 __v)\x0a"
"        {return __tree_.__insert_unique(__p, __v);}\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __f, _InputIterator __l)\x0a"
"        {\x0a"
"            for (const_iterator __e = cend(); __f \x21= __l; ++__f)\x0a"
"                __tree_.__insert_unique(__e, *__f);\x0a"
"        }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator,bool> insert(value_type\x26\x26 __v)\x0a"
"        {return __tree_.__insert_unique(_VSTD\x3a\x3amove(__v));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, value_type\x26\x26 __v)\x0a"
"        {return __tree_.__insert_unique(__p, _VSTD\x3a\x3amove(__v));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(initializer_list<value_type> __il)\x0a"
"        {insert(__il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator  erase(const_iterator __p) {return __tree_.erase(__p);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k)\x0a"
"        {return __tree_.__erase_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator  erase(const_iterator __f, const_iterator __l)\x0a"
"        {return __tree_.erase(__f, __l);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {__tree_.clear();}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    insert_return_type insert(node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to set\x3a\x3ainsert()\x22);\x0a"
"        return __tree_.template __node_handle_insert_unique<\x0a"
"            node_type, insert_return_type>(_VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __hint, node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to set\x3a\x3ainsert()\x22);\x0a"
"        return __tree_.template __node_handle_insert_unique<node_type>(\x0a"
"            __hint, _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(key_type const\x26 __key)\x0a"
"    {\x0a"
"        return __tree_.template __node_handle_extract<node_type>(__key);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(const_iterator __it)\x0a"
"    {\x0a"
"        return __tree_.template __node_handle_extract<node_type>(__it);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(set<key_type, _Compare2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_unique(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(set<key_type, _Compare2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_unique(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(multiset<key_type, _Compare2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_unique(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(multiset<key_type, _Compare2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_unique(__source.__tree_);\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(set\x26 __s) _NOEXCEPT_(__is_nothrow_swappable<__base>\x3a\x3avalue)\x0a"
"        {__tree_.swap(__s.__tree_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT {return __tree_.__alloc();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_compare    key_comp()      const {return __tree_.value_comp();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_compare  value_comp()    const {return __tree_.value_comp();}\x0a"
"\x0a"
"    // set operations\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator find(const key_type\x26 __k)             {return __tree_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __tree_.find(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    find(const _K2\x26 __k)                           {return __tree_.find(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    find(const _K2\x26 __k) const                     {return __tree_.find(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type      count(const key_type\x26 __k) const\x0a"
"        {return __tree_.__count_unique(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,size_type>\x3a\x3atype\x0a"
"    count(const _K2\x26 __k) const                    {return __tree_.__count_multi(__k);}\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool contains(const key_type\x26 __k) const {return find(__k) \x21= end();}\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator lower_bound(const key_type\x26 __k)\x0a"
"        {return __tree_.lower_bound(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator lower_bound(const key_type\x26 __k) const\x0a"
"        {return __tree_.lower_bound(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    lower_bound(const _K2\x26 __k)       {return __tree_.lower_bound(__k);}\x0a"
"\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    lower_bound(const _K2\x26 __k) const {return __tree_.lower_bound(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator upper_bound(const key_type\x26 __k)\x0a"
"        {return __tree_.upper_bound(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator upper_bound(const key_type\x26 __k) const\x0a"
"        {return __tree_.upper_bound(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    upper_bound(const _K2\x26 __k)       {return __tree_.upper_bound(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    upper_bound(const _K2\x26 __k) const {return __tree_.upper_bound(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator,iterator> equal_range(const key_type\x26 __k)\x0a"
"        {return __tree_.__equal_range_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<const_iterator,const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"        {return __tree_.__equal_range_unique(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,pair<iterator,iterator>>\x3a\x3atype\x0a"
"    equal_range(const _K2\x26 __k)       {return __tree_.__equal_range_multi(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,pair<const_iterator,const_iterator>>\x3a\x3atype\x0a"
"    equal_range(const _K2\x26 __k) const {return __tree_.__equal_range_multi(__k);}\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _Compare = less<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>,\x0a"
"         class _Allocator = allocator<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Compare>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"set(_InputIterator, _InputIterator, _Compare = _Compare(), _Allocator = _Allocator())\x0a"
"  -> set<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Compare, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Compare = less<_Key>,\x0a"
"         class _Allocator = allocator<_Key>,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Compare>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"set(initializer_list<_Key>, _Compare = _Compare(), _Allocator = _Allocator())\x0a"
"  -> set<_Key, _Compare, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Allocator,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"set(_InputIterator, _InputIterator, _Allocator)\x0a"
"  -> set<typename iterator_traits<_InputIterator>\x3a\x3avalue_type,\x0a"
"         less<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Allocator,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"set(initializer_list<_Key>, _Allocator)\x0a"
"  -> set<_Key, less<_Key>, _Allocator>;\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"set<_Key, _Compare, _Allocator>\x3a\x3aset(set\x26\x26 __s, const allocator_type\x26 __a)\x0a"
"    \x3a __tree_(_VSTD\x3a\x3amove(__s.__tree_), __a)\x0a"
"{\x0a"
"    if (__a \x21= __s.get_allocator())\x0a"
"    {\x0a"
"        const_iterator __e = cend();\x0a"
"        while (\x21__s.empty())\x0a"
"            insert(__e, _VSTD\x3a\x3amove(__s.__tree_.remove(__s.begin())->__value_));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const set<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const set<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return __x.size() == __y.size() \x26\x26 _VSTD\x3a\x3a""equal(__x.begin(), __x.end(), __y.begin());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const set<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const set<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alexicographical_compare(__x.begin(), __x.end(), __y.begin(), __y.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const set<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const set<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const set<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const set<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const set<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const set<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const set<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const set<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"// specialized algorithms\x3a\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(set<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"     set<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Key, class _Compare, class _Allocator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(set<_Key, _Compare, _Allocator>\x26 __c, _Predicate __pred)\x0a"
"{ __libcpp_erase_if_container(__c, __pred); }\x0a"
"#endif\x0a"
"\x0a"
"template <class _Key, class _Compare = less<_Key>,\x0a"
"          class _Allocator = allocator<_Key> >\x0a"
"class _LIBCPP_TEMPLATE_VIS multiset\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef _Key                                      key_type;\x0a"
"    typedef key_type                                 value_type;\x0a"
"    typedef _Compare                                  key_compare;\x0a"
"    typedef key_compare                              value_compare;\x0a"
"    typedef typename __identity<_Allocator>\x3a\x3atype    allocator_type;\x0a"
"    typedef value_type\x26                              reference;\x0a"
"    typedef const value_type\x26                        const_reference;\x0a"
"\x0a"
"    static_assert((is_same<typename allocator_type\x3a\x3avalue_type, value_type>\x3a\x3avalue),\x0a"
"                  \x22""Allocator\x3a\x3avalue_type must be same type as value_type\x22);\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef __tree<value_type, value_compare, allocator_type> __base;\x0a"
"    typedef allocator_traits<allocator_type>                  __alloc_traits;\x0a"
"    typedef typename __base\x3a\x3a__node_holder                    __node_holder;\x0a"
"\x0a"
"    __base __tree_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __base\x3a\x3apointer               pointer;\x0a"
"    typedef typename __base\x3a\x3a""const_pointer         const_pointer;\x0a"
"    typedef typename __base\x3a\x3asize_type             size_type;\x0a"
"    typedef typename __base\x3a\x3a""difference_type       difference_type;\x0a"
"    typedef typename __base\x3a\x3a""const_iterator        iterator;\x0a"
"    typedef typename __base\x3a\x3a""const_iterator        const_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<iterator>       reverse_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<const_iterator> const_reverse_iterator;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    typedef __set_node_handle<typename __base\x3a\x3a__node, allocator_type> node_type;\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Key2, class _Compare2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS set;\x0a"
"    template <class _Key2, class _Compare2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS multiset;\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multiset()\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_compare>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue)\x0a"
"        \x3a __tree_(value_compare()) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit multiset(const value_compare\x26 __comp)\x0a"
"        _NOEXCEPT_(\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_copy_constructible<key_compare>\x3a\x3avalue)\x0a"
"        \x3a __tree_(__comp) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit multiset(const value_compare\x26 __comp, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__comp, __a) {}\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        multiset(_InputIterator __f, _InputIterator __l,\x0a"
"                 const value_compare\x26 __comp = value_compare())\x0a"
"        \x3a __tree_(__comp)\x0a"
"        {\x0a"
"            insert(__f, __l);\x0a"
"        }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"        template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        multiset(_InputIterator __f, _InputIterator __l, const allocator_type\x26 __a)\x0a"
"            \x3a multiset(__f, __l, key_compare(), __a) {}\x0a"
"#endif\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        multiset(_InputIterator __f, _InputIterator __l,\x0a"
"                 const value_compare\x26 __comp, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__comp, __a)\x0a"
"        {\x0a"
"            insert(__f, __l);\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multiset(const multiset\x26 __s)\x0a"
"        \x3a __tree_(__s.__tree_.value_comp(),\x0a"
"          __alloc_traits\x3a\x3aselect_on_container_copy_construction(__s.__tree_.__alloc()))\x0a"
"        {\x0a"
"            insert(__s.begin(), __s.end());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multiset\x26 operator=(const multiset\x26 __s)\x0a"
"        {\x0a"
"            __tree_ = __s.__tree_;\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multiset(multiset\x26\x26 __s)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__base>\x3a\x3avalue)\x0a"
"        \x3a __tree_(_VSTD\x3a\x3amove(__s.__tree_)) {}\x0a"
"\x0a"
"    multiset(multiset\x26\x26 __s, const allocator_type\x26 __a);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit multiset(const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__a) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multiset(const multiset\x26 __s, const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__s.__tree_.value_comp(), __a)\x0a"
"        {\x0a"
"            insert(__s.begin(), __s.end());\x0a"
"        }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multiset(initializer_list<value_type> __il, const value_compare\x26 __comp = value_compare())\x0a"
"        \x3a __tree_(__comp)\x0a"
"        {\x0a"
"            insert(__il.begin(), __il.end());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multiset(initializer_list<value_type> __il, const value_compare\x26 __comp,\x0a"
"        const allocator_type\x26 __a)\x0a"
"        \x3a __tree_(__comp, __a)\x0a"
"        {\x0a"
"            insert(__il.begin(), __il.end());\x0a"
"        }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multiset(initializer_list<value_type> __il, const allocator_type\x26 __a)\x0a"
"        \x3a multiset(__il, key_compare(), __a) {}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multiset\x26 operator=(initializer_list<value_type> __il)\x0a"
"        {\x0a"
"            __tree_.__assign_multi(__il.begin(), __il.end());\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    multiset\x26 operator=(multiset\x26\x26 __s)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__base>\x3a\x3avalue)\x0a"
"        {\x0a"
"            __tree_ = _VSTD\x3a\x3amove(__s.__tree_);\x0a"
"            return *this;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7emultiset() {\x0a"
"        static_assert(sizeof(__diagnose_non_const_comparator<_Key, _Compare>()), \x22\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator begin() _NOEXCEPT       {return __tree_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT {return __tree_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          iterator end() _NOEXCEPT         {return __tree_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()   const _NOEXCEPT {return __tree_.end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          reverse_iterator rbegin() _NOEXCEPT\x0a"
"            {return reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"          reverse_iterator rend() _NOEXCEPT\x0a"
"            {return       reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin()  const _NOEXCEPT {return begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend() const _NOEXCEPT {return end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT {return rbegin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend() const _NOEXCEPT {return rend();}\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT {return __tree_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT {return __tree_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT {return __tree_.max_size();}\x0a"
"\x0a"
"    // modifiers\x3a\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator emplace(_Args\x26\x26... __args)\x0a"
"            {return __tree_.__emplace_multi(_VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator emplace_hint(const_iterator __p, _Args\x26\x26... __args)\x0a"
"            {return __tree_.__emplace_hint_multi(__p, _VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const value_type\x26 __v)\x0a"
"        {return __tree_.__insert_multi(__v);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, const value_type\x26 __v)\x0a"
"        {return __tree_.__insert_multi(__p, __v);}\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __f, _InputIterator __l)\x0a"
"        {\x0a"
"            for (const_iterator __e = cend(); __f \x21= __l; ++__f)\x0a"
"                __tree_.__insert_multi(__e, *__f);\x0a"
"        }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(value_type\x26\x26 __v)\x0a"
"        {return __tree_.__insert_multi(_VSTD\x3a\x3amove(__v));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, value_type\x26\x26 __v)\x0a"
"        {return __tree_.__insert_multi(__p, _VSTD\x3a\x3amove(__v));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(initializer_list<value_type> __il)\x0a"
"        {insert(__il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator  erase(const_iterator __p) {return __tree_.erase(__p);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k) {return __tree_.__erase_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator  erase(const_iterator __f, const_iterator __l)\x0a"
"        {return __tree_.erase(__f, __l);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {__tree_.clear();}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to multiset\x3a\x3ainsert()\x22);\x0a"
"        return __tree_.template __node_handle_insert_multi<node_type>(\x0a"
"            _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __hint, node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to multiset\x3a\x3ainsert()\x22);\x0a"
"        return __tree_.template __node_handle_insert_multi<node_type>(\x0a"
"            __hint, _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(key_type const\x26 __key)\x0a"
"    {\x0a"
"        return __tree_.template __node_handle_extract<node_type>(__key);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(const_iterator __it)\x0a"
"    {\x0a"
"        return __tree_.template __node_handle_extract<node_type>(__it);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(multiset<key_type, _Compare2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_multi(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(multiset<key_type, _Compare2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_multi(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(set<key_type, _Compare2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_multi(__source.__tree_);\x0a"
"    }\x0a"
"    template <class _Compare2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(set<key_type, _Compare2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __tree_.__node_handle_merge_multi(__source.__tree_);\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(multiset\x26 __s)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<__base>\x3a\x3avalue)\x0a"
"        {__tree_.swap(__s.__tree_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT {return __tree_.__alloc();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_compare    key_comp()      const {return __tree_.value_comp();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_compare  value_comp()    const {return __tree_.value_comp();}\x0a"
"\x0a"
"    // set operations\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator find(const key_type\x26 __k)             {return __tree_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __tree_.find(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename _VSTD\x3a\x3a""enable_if<_VSTD\x3a\x3a__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    find(const _K2\x26 __k)                           {return __tree_.find(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename _VSTD\x3a\x3a""enable_if<_VSTD\x3a\x3a__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    find(const _K2\x26 __k) const                     {return __tree_.find(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type      count(const key_type\x26 __k) const\x0a"
"        {return __tree_.__count_multi(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename enable_if<__is_transparent<_Compare, _K2>\x3a\x3avalue,size_type>\x3a\x3atype\x0a"
"    count(const _K2\x26 __k) const            {return __tree_.__count_multi(__k);}\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool contains(const key_type\x26 __k) const {return find(__k) \x21= end();}\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator lower_bound(const key_type\x26 __k)\x0a"
"        {return __tree_.lower_bound(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator lower_bound(const key_type\x26 __k) const\x0a"
"            {return __tree_.lower_bound(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename _VSTD\x3a\x3a""enable_if<_VSTD\x3a\x3a__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    lower_bound(const _K2\x26 __k)       {return __tree_.lower_bound(__k);}\x0a"
"\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename _VSTD\x3a\x3a""enable_if<_VSTD\x3a\x3a__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    lower_bound(const _K2\x26 __k) const {return __tree_.lower_bound(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator upper_bound(const key_type\x26 __k)\x0a"
"            {return __tree_.upper_bound(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator upper_bound(const key_type\x26 __k) const\x0a"
"            {return __tree_.upper_bound(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename _VSTD\x3a\x3a""enable_if<_VSTD\x3a\x3a__is_transparent<_Compare, _K2>\x3a\x3avalue,iterator>\x3a\x3atype\x0a"
"    upper_bound(const _K2\x26 __k)       {return __tree_.upper_bound(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename _VSTD\x3a\x3a""enable_if<_VSTD\x3a\x3a__is_transparent<_Compare, _K2>\x3a\x3avalue,const_iterator>\x3a\x3atype\x0a"
"    upper_bound(const _K2\x26 __k) const {return __tree_.upper_bound(__k);}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator,iterator>             equal_range(const key_type\x26 __k)\x0a"
"            {return __tree_.__equal_range_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<const_iterator,const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"            {return __tree_.__equal_range_multi(__k);}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename _VSTD\x3a\x3a""enable_if<_VSTD\x3a\x3a__is_transparent<_Compare, _K2>\x3a\x3avalue,pair<iterator,iterator>>\x3a\x3atype\x0a"
"    equal_range(const _K2\x26 __k)       {return __tree_.__equal_range_multi(__k);}\x0a"
"    template <typename _K2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename _VSTD\x3a\x3a""enable_if<_VSTD\x3a\x3a__is_transparent<_Compare, _K2>\x3a\x3avalue,pair<const_iterator,const_iterator>>\x3a\x3atype\x0a"
"    equal_range(const _K2\x26 __k) const {return __tree_.__equal_range_multi(__k);}\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _Compare = less<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>,\x0a"
"         class _Allocator = allocator<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Compare>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"multiset(_InputIterator, _InputIterator, _Compare = _Compare(), _Allocator = _Allocator())\x0a"
"  -> multiset<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Compare, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Compare = less<_Key>,\x0a"
"         class _Allocator = allocator<_Key>,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Compare>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"multiset(initializer_list<_Key>, _Compare = _Compare(), _Allocator = _Allocator())\x0a"
"  -> multiset<_Key, _Compare, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Allocator,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"multiset(_InputIterator, _InputIterator, _Allocator)\x0a"
"  -> multiset<typename iterator_traits<_InputIterator>\x3a\x3avalue_type,\x0a"
"         less<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Allocator,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"multiset(initializer_list<_Key>, _Allocator)\x0a"
"  -> multiset<_Key, less<_Key>, _Allocator>;\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"multiset<_Key, _Compare, _Allocator>\x3a\x3amultiset(multiset\x26\x26 __s, const allocator_type\x26 __a)\x0a"
"    \x3a __tree_(_VSTD\x3a\x3amove(__s.__tree_), __a)\x0a"
"{\x0a"
"    if (__a \x21= __s.get_allocator())\x0a"
"    {\x0a"
"        const_iterator __e = cend();\x0a"
"        while (\x21__s.empty())\x0a"
"            insert(__e, _VSTD\x3a\x3amove(__s.__tree_.remove(__s.begin())->__value_));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const multiset<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const multiset<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return __x.size() == __y.size() \x26\x26 _VSTD\x3a\x3a""equal(__x.begin(), __x.end(), __y.begin());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const multiset<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const multiset<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alexicographical_compare(__x.begin(), __x.end(), __y.begin(), __y.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const multiset<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const multiset<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const multiset<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const multiset<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const multiset<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const multiset<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const multiset<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"           const multiset<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Compare, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(multiset<_Key, _Compare, _Allocator>\x26 __x,\x0a"
"     multiset<_Key, _Compare, _Allocator>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Key, class _Compare, class _Allocator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(multiset<_Key, _Compare, _Allocator>\x26 __c, _Predicate __pred)\x0a"
"{ __libcpp_erase_if_container(__c, __pred); }\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_SET\x0a"
"", 57282 ); }