#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_shared_mutex( 
"// -*- C++ -*-\x0a"
"//===------------------------ shared_mutex --------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_SHARED_MUTEX\x0a"
"#define _LIBCPP_SHARED_MUTEX\x0a"
"\x0a"
"/*\x0a"
"    shared_mutex synopsis\x0a"
"\x0a"
"// C++1y\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"class shared_mutex      // C++17\x0a"
"{\x0a"
"public\x3a\x0a"
"    shared_mutex();\x0a"
"    \x7eshared_mutex();\x0a"
"\x0a"
"    shared_mutex(const shared_mutex\x26) = delete;\x0a"
"    shared_mutex\x26 operator=(const shared_mutex\x26) = delete;\x0a"
"\x0a"
"    // Exclusive ownership\x0a"
"    void lock(); // blocking\x0a"
"    bool try_lock();\x0a"
"    void unlock();\x0a"
"\x0a"
"    // Shared ownership\x0a"
"    void lock_shared(); // blocking\x0a"
"    bool try_lock_shared();\x0a"
"    void unlock_shared();\x0a"
"\x0a"
"    typedef implementation-defined native_handle_type; // See 30.2.3\x0a"
"    native_handle_type native_handle(); // See 30.2.3\x0a"
"};\x0a"
"\x0a"
"class shared_timed_mutex\x0a"
"{\x0a"
"public\x3a\x0a"
"    shared_timed_mutex();\x0a"
"    \x7eshared_timed_mutex();\x0a"
"\x0a"
"    shared_timed_mutex(const shared_timed_mutex\x26) = delete;\x0a"
"    shared_timed_mutex\x26 operator=(const shared_timed_mutex\x26) = delete;\x0a"
"\x0a"
"    // Exclusive ownership\x0a"
"    void lock(); // blocking\x0a"
"    bool try_lock();\x0a"
"    template <class Rep, class Period>\x0a"
"        bool try_lock_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"    template <class Clock, class Duration>\x0a"
"        bool try_lock_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"    void unlock();\x0a"
"\x0a"
"    // Shared ownership\x0a"
"    void lock_shared(); // blocking\x0a"
"    bool try_lock_shared();\x0a"
"    template <class Rep, class Period>\x0a"
"        bool\x0a"
"        try_lock_shared_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"    template <class Clock, class Duration>\x0a"
"        bool\x0a"
"        try_lock_shared_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"    void unlock_shared();\x0a"
"};\x0a"
"\x0a"
"template <class Mutex>\x0a"
"class shared_lock\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef Mutex mutex_type;\x0a"
"\x0a"
"    // Shared locking\x0a"
"    shared_lock() noexcept;\x0a"
"    explicit shared_lock(mutex_type\x26 m); // blocking\x0a"
"    shared_lock(mutex_type\x26 m, defer_lock_t) noexcept;\x0a"
"    shared_lock(mutex_type\x26 m, try_to_lock_t);\x0a"
"    shared_lock(mutex_type\x26 m, adopt_lock_t);\x0a"
"    template <class Clock, class Duration>\x0a"
"        shared_lock(mutex_type\x26 m,\x0a"
"                    const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"    template <class Rep, class Period>\x0a"
"        shared_lock(mutex_type\x26 m,\x0a"
"                    const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"    \x7eshared_lock();\x0a"
"\x0a"
"    shared_lock(shared_lock const\x26) = delete;\x0a"
"    shared_lock\x26 operator=(shared_lock const\x26) = delete;\x0a"
"\x0a"
"    shared_lock(shared_lock\x26\x26 u) noexcept;\x0a"
"    shared_lock\x26 operator=(shared_lock\x26\x26 u) noexcept;\x0a"
"\x0a"
"    void lock(); // blocking\x0a"
"    bool try_lock();\x0a"
"    template <class Rep, class Period>\x0a"
"        bool try_lock_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"    template <class Clock, class Duration>\x0a"
"        bool try_lock_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"    void unlock();\x0a"
"\x0a"
"    // Setters\x0a"
"    void swap(shared_lock\x26 u) noexcept;\x0a"
"    mutex_type* release() noexcept;\x0a"
"\x0a"
"    // Getters\x0a"
"    bool owns_lock() const noexcept;\x0a"
"    explicit operator bool () const noexcept;\x0a"
"    mutex_type* mutex() const noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class Mutex>\x0a"
"    void swap(shared_lock<Mutex>\x26 x, shared_lock<Mutex>\x26 y) noexcept;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <version>\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11 \x7c\x7c defined(_LIBCPP_BUILDING_LIBRARY)\x0a"
"\x0a"
"#include <__mutex_base>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_NO_THREADS\x0a"
"#error <shared_mutex> is not supported on this single threaded system\x0a"
"#else // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"struct _LIBCPP_TYPE_VIS _LIBCPP_AVAILABILITY_SHARED_MUTEX _LIBCPP_THREAD_SAFETY_ANNOTATION(capability(\x22shared_mutex\x22))\x0a"
"__shared_mutex_base\x0a"
"{\x0a"
"    mutex               __mut_;\x0a"
"    condition_variable  __gate1_;\x0a"
"    condition_variable  __gate2_;\x0a"
"    unsigned            __state_;\x0a"
"\x0a"
"    static const unsigned __write_entered_ = 1U << (sizeof(unsigned)*__CHAR_BIT__ - 1);\x0a"
"    static const unsigned __n_readers_ = \x7e__write_entered_;\x0a"
"\x0a"
"    __shared_mutex_base();\x0a"
"    _LIBCPP_INLINE_VISIBILITY \x7e__shared_mutex_base() = default;\x0a"
"\x0a"
"    __shared_mutex_base(const __shared_mutex_base\x26) = delete;\x0a"
"    __shared_mutex_base\x26 operator=(const __shared_mutex_base\x26) = delete;\x0a"
"\x0a"
"    // Exclusive ownership\x0a"
"    void lock() _LIBCPP_THREAD_SAFETY_ANNOTATION(acquire_capability()); // blocking\x0a"
"    bool try_lock() _LIBCPP_THREAD_SAFETY_ANNOTATION(try_acquire_capability(true));\x0a"
"    void unlock() _LIBCPP_THREAD_SAFETY_ANNOTATION(release_capability());\x0a"
"\x0a"
"    // Shared ownership\x0a"
"    void lock_shared() _LIBCPP_THREAD_SAFETY_ANNOTATION(acquire_shared_capability()); // blocking\x0a"
"    bool try_lock_shared() _LIBCPP_THREAD_SAFETY_ANNOTATION(try_acquire_shared_capability(true));\x0a"
"    void unlock_shared() _LIBCPP_THREAD_SAFETY_ANNOTATION(release_shared_capability());\x0a"
"\x0a"
"//     typedef implementation-defined native_handle_type; // See 30.2.3\x0a"
"//     native_handle_type native_handle(); // See 30.2.3\x0a"
"};\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"class _LIBCPP_TYPE_VIS _LIBCPP_AVAILABILITY_SHARED_MUTEX shared_mutex\x0a"
"{\x0a"
"    __shared_mutex_base __base;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY shared_mutex() \x3a __base() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY \x7eshared_mutex() = default;\x0a"
"\x0a"
"    shared_mutex(const shared_mutex\x26) = delete;\x0a"
"    shared_mutex\x26 operator=(const shared_mutex\x26) = delete;\x0a"
"\x0a"
"    // Exclusive ownership\x0a"
"    _LIBCPP_INLINE_VISIBILITY void lock()     { return __base.lock(); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool try_lock() { return __base.try_lock(); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY void unlock()   { return __base.unlock(); }\x0a"
"\x0a"
"    // Shared ownership\x0a"
"    _LIBCPP_INLINE_VISIBILITY void lock_shared()     { return __base.lock_shared(); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool try_lock_shared() { return __base.try_lock_shared(); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY void unlock_shared()   { return __base.unlock_shared(); }\x0a"
"\x0a"
"//     typedef __shared_mutex_base\x3a\x3anative_handle_type native_handle_type;\x0a"
"//     _LIBCPP_INLINE_VISIBILITY native_handle_type native_handle() { return __base\x3a\x3aunlock_shared(); }\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS _LIBCPP_AVAILABILITY_SHARED_MUTEX shared_timed_mutex\x0a"
"{\x0a"
"    __shared_mutex_base __base;\x0a"
"public\x3a\x0a"
"    shared_timed_mutex();\x0a"
"    _LIBCPP_INLINE_VISIBILITY \x7eshared_timed_mutex() = default;\x0a"
"\x0a"
"    shared_timed_mutex(const shared_timed_mutex\x26) = delete;\x0a"
"    shared_timed_mutex\x26 operator=(const shared_timed_mutex\x26) = delete;\x0a"
"\x0a"
"    // Exclusive ownership\x0a"
"    void lock();\x0a"
"    bool try_lock();\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool\x0a"
"        try_lock_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time)\x0a"
"        {\x0a"
"            return try_lock_until(chrono\x3a\x3asteady_clock\x3a\x3anow() + __rel_time);\x0a"
"        }\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        bool\x0a"
"        try_lock_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time);\x0a"
"    void unlock();\x0a"
"\x0a"
"    // Shared ownership\x0a"
"    void lock_shared();\x0a"
"    bool try_lock_shared();\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool\x0a"
"        try_lock_shared_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time)\x0a"
"        {\x0a"
"            return try_lock_shared_until(chrono\x3a\x3asteady_clock\x3a\x3anow() + __rel_time);\x0a"
"        }\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        bool\x0a"
"        try_lock_shared_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time);\x0a"
"    void unlock_shared();\x0a"
"};\x0a"
"\x0a"
"template <class _Clock, class _Duration>\x0a"
"bool\x0a"
"shared_timed_mutex\x3a\x3atry_lock_until(\x0a"
"                        const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time)\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(__base.__mut_);\x0a"
"    if (__base.__state_ \x26 __base.__write_entered_)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            cv_status __status = __base.__gate1_.wait_until(__lk, __abs_time);\x0a"
"            if ((__base.__state_ \x26 __base.__write_entered_) == 0)\x0a"
"                break;\x0a"
"            if (__status == cv_status\x3a\x3atimeout)\x0a"
"                return false;\x0a"
"        }\x0a"
"    }\x0a"
"    __base.__state_ \x7c= __base.__write_entered_;\x0a"
"    if (__base.__state_ \x26 __base.__n_readers_)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            cv_status __status = __base.__gate2_.wait_until(__lk, __abs_time);\x0a"
"            if ((__base.__state_ \x26 __base.__n_readers_) == 0)\x0a"
"                break;\x0a"
"            if (__status == cv_status\x3a\x3atimeout)\x0a"
"            {\x0a"
"                __base.__state_ \x26= \x7e__base.__write_entered_;\x0a"
"                __base.__gate1_.notify_all();\x0a"
"                return false;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Clock, class _Duration>\x0a"
"bool\x0a"
"shared_timed_mutex\x3a\x3atry_lock_shared_until(\x0a"
"                        const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time)\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(__base.__mut_);\x0a"
"    if ((__base.__state_ \x26 __base.__write_entered_) \x7c\x7c (__base.__state_ \x26 __base.__n_readers_) == __base.__n_readers_)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            cv_status status = __base.__gate1_.wait_until(__lk, __abs_time);\x0a"
"            if ((__base.__state_ \x26 __base.__write_entered_) == 0 \x26\x26\x0a"
"                                       (__base.__state_ \x26 __base.__n_readers_) < __base.__n_readers_)\x0a"
"                break;\x0a"
"            if (status == cv_status\x3a\x3atimeout)\x0a"
"                return false;\x0a"
"        }\x0a"
"    }\x0a"
"    unsigned __num_readers = (__base.__state_ \x26 __base.__n_readers_) + 1;\x0a"
"    __base.__state_ \x26= \x7e__base.__n_readers_;\x0a"
"    __base.__state_ \x7c= __num_readers;\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"class shared_lock\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Mutex mutex_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    mutex_type* __m_;\x0a"
"    bool __owns_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_lock() _NOEXCEPT\x0a"
"        \x3a __m_(nullptr),\x0a"
"          __owns_(false)\x0a"
"        {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit shared_lock(mutex_type\x26 __m)\x0a"
"        \x3a __m_(_VSTD\x3a\x3a""addressof(__m)),\x0a"
"          __owns_(true)\x0a"
"        {__m_->lock_shared();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_lock(mutex_type\x26 __m, defer_lock_t) _NOEXCEPT\x0a"
"        \x3a __m_(_VSTD\x3a\x3a""addressof(__m)),\x0a"
"          __owns_(false)\x0a"
"        {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_lock(mutex_type\x26 __m, try_to_lock_t)\x0a"
"        \x3a __m_(_VSTD\x3a\x3a""addressof(__m)),\x0a"
"          __owns_(__m.try_lock_shared())\x0a"
"        {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_lock(mutex_type\x26 __m, adopt_lock_t)\x0a"
"        \x3a __m_(_VSTD\x3a\x3a""addressof(__m)),\x0a"
"          __owns_(true)\x0a"
"        {}\x0a"
"\x0a"
"    template <class _Clock, class _Duration>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        shared_lock(mutex_type\x26 __m,\x0a"
"                    const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __abs_time)\x0a"
"            \x3a __m_(_VSTD\x3a\x3a""addressof(__m)),\x0a"
"              __owns_(__m.try_lock_shared_until(__abs_time))\x0a"
"            {}\x0a"
"\x0a"
"    template <class _Rep, class _Period>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        shared_lock(mutex_type\x26 __m,\x0a"
"                    const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __rel_time)\x0a"
"            \x3a __m_(_VSTD\x3a\x3a""addressof(__m)),\x0a"
"              __owns_(__m.try_lock_shared_for(__rel_time))\x0a"
"            {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7eshared_lock()\x0a"
"    {\x0a"
"        if (__owns_)\x0a"
"            __m_->unlock_shared();\x0a"
"    }\x0a"
"\x0a"
"    shared_lock(shared_lock const\x26) = delete;\x0a"
"    shared_lock\x26 operator=(shared_lock const\x26) = delete;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_lock(shared_lock\x26\x26 __u) _NOEXCEPT\x0a"
"        \x3a __m_(__u.__m_),\x0a"
"          __owns_(__u.__owns_)\x0a"
"        {\x0a"
"            __u.__m_ = nullptr;\x0a"
"            __u.__owns_ = false;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_lock\x26 operator=(shared_lock\x26\x26 __u) _NOEXCEPT\x0a"
"    {\x0a"
"        if (__owns_)\x0a"
"            __m_->unlock_shared();\x0a"
"        __m_ = nullptr;\x0a"
"        __owns_ = false;\x0a"
"        __m_ = __u.__m_;\x0a"
"        __owns_ = __u.__owns_;\x0a"
"        __u.__m_ = nullptr;\x0a"
"        __u.__owns_ = false;\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    void lock();\x0a"
"    bool try_lock();\x0a"
"    template <class Rep, class Period>\x0a"
"        bool try_lock_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"    template <class Clock, class Duration>\x0a"
"        bool try_lock_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"    void unlock();\x0a"
"\x0a"
"    // Setters\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(shared_lock\x26 __u) _NOEXCEPT\x0a"
"    {\x0a"
"        _VSTD\x3a\x3aswap(__m_, __u.__m_);\x0a"
"        _VSTD\x3a\x3aswap(__owns_, __u.__owns_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    mutex_type* release() _NOEXCEPT\x0a"
"    {\x0a"
"        mutex_type* __m = __m_;\x0a"
"        __m_ = nullptr;\x0a"
"        __owns_ = false;\x0a"
"        return __m;\x0a"
"    }\x0a"
"\x0a"
"    // Getters\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool owns_lock() const _NOEXCEPT {return __owns_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit operator bool () const _NOEXCEPT {return __owns_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    mutex_type* mutex() const _NOEXCEPT {return __m_;}\x0a"
"};\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"void\x0a"
"shared_lock<_Mutex>\x3a\x3alock()\x0a"
"{\x0a"
"    if (__m_ == nullptr)\x0a"
"        __throw_system_error(EPERM, \x22shared_lock\x3a\x3alock\x3a references null mutex\x22);\x0a"
"    if (__owns_)\x0a"
"        __throw_system_error(EDEADLK, \x22shared_lock\x3a\x3alock\x3a already locked\x22);\x0a"
"    __m_->lock_shared();\x0a"
"    __owns_ = true;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"bool\x0a"
"shared_lock<_Mutex>\x3a\x3atry_lock()\x0a"
"{\x0a"
"    if (__m_ == nullptr)\x0a"
"        __throw_system_error(EPERM, \x22shared_lock\x3a\x3atry_lock\x3a references null mutex\x22);\x0a"
"    if (__owns_)\x0a"
"        __throw_system_error(EDEADLK, \x22shared_lock\x3a\x3atry_lock\x3a already locked\x22);\x0a"
"    __owns_ = __m_->try_lock_shared();\x0a"
"    return __owns_;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"template <class _Rep, class _Period>\x0a"
"bool\x0a"
"shared_lock<_Mutex>\x3a\x3atry_lock_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d)\x0a"
"{\x0a"
"    if (__m_ == nullptr)\x0a"
"        __throw_system_error(EPERM, \x22shared_lock\x3a\x3atry_lock_for\x3a references null mutex\x22);\x0a"
"    if (__owns_)\x0a"
"        __throw_system_error(EDEADLK, \x22shared_lock\x3a\x3atry_lock_for\x3a already locked\x22);\x0a"
"    __owns_ = __m_->try_lock_shared_for(__d);\x0a"
"    return __owns_;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"template <class _Clock, class _Duration>\x0a"
"bool\x0a"
"shared_lock<_Mutex>\x3a\x3atry_lock_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    if (__m_ == nullptr)\x0a"
"        __throw_system_error(EPERM, \x22shared_lock\x3a\x3atry_lock_until\x3a references null mutex\x22);\x0a"
"    if (__owns_)\x0a"
"        __throw_system_error(EDEADLK, \x22shared_lock\x3a\x3atry_lock_until\x3a already locked\x22);\x0a"
"    __owns_ = __m_->try_lock_shared_until(__t);\x0a"
"    return __owns_;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"void\x0a"
"shared_lock<_Mutex>\x3a\x3aunlock()\x0a"
"{\x0a"
"    if (\x21__owns_)\x0a"
"        __throw_system_error(EPERM, \x22shared_lock\x3a\x3aunlock\x3a not locked\x22);\x0a"
"    __m_->unlock_shared();\x0a"
"    __owns_ = false;\x0a"
"}\x0a"
"\x0a"
"template <class _Mutex>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(shared_lock<_Mutex>\x26 __x, shared_lock<_Mutex>\x26 __y) _NOEXCEPT\x0a"
"    {__x.swap(__y);}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"#endif  // _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_SHARED_MUTEX\x0a"
"", 15099 ); }