#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_span( 
"// -*- C++ -*-\x0a"
"//===------------------------------ span ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===---------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_SPAN\x0a"
"#define _LIBCPP_SPAN\x0a"
"\x0a"
"/*\x0a"
"    span synopsis\x0a"
"\x0a"
"namespace std {\x0a"
"\x0a"
"// constants\x0a"
"inline constexpr size_t dynamic_extent = numeric_limits<size_t>\x3a\x3amax();\x0a"
"\x0a"
"// \x5bviews.span\x5d, class template span\x0a"
"template <class ElementType, size_t Extent = dynamic_extent>\x0a"
"    class span;\x0a"
"\x0a"
"// \x5bspan.objectrep\x5d, views of object representation\x0a"
"template <class ElementType, size_t Extent>\x0a"
"    span<const byte, ((Extent == dynamic_extent) \x3f dynamic_extent \x3a\x0a"
"        (sizeof(ElementType) * Extent))> as_bytes(span<ElementType, Extent> s) noexcept;\x0a"
"\x0a"
"template <class ElementType, size_t Extent>\x0a"
"    span<      byte, ((Extent == dynamic_extent) \x3f dynamic_extent \x3a\x0a"
"        (sizeof(ElementType) * Extent))> as_writable_bytes(span<ElementType, Extent> s) noexcept;\x0a"
"\x0a"
"\x0a"
"namespace std {\x0a"
"template <class ElementType, size_t Extent = dynamic_extent>\x0a"
"class span {\x0a"
"public\x3a\x0a"
"    // constants and types\x0a"
"    using element_type = ElementType;\x0a"
"    using value_type = remove_cv_t<ElementType>;\x0a"
"    using index_type = size_t;\x0a"
"    using difference_type = ptrdiff_t;\x0a"
"    using pointer = element_type*;\x0a"
"    using const_pointer = const element_type*;\x0a"
"    using reference = element_type\x26;\x0a"
"    using const_reference = const element_type\x26;\x0a"
"    using iterator = implementation-defined;\x0a"
"    using const_iterator = implementation-defined;\x0a"
"    using reverse_iterator = std\x3a\x3areverse_iterator<iterator>;\x0a"
"    using const_reverse_iterator = std\x3a\x3areverse_iterator<const_iterator>;\x0a"
"    static constexpr index_type extent = Extent;\x0a"
"\x0a"
"    // \x5bspan.cons\x5d, span constructors, copy, assignment, and destructor\x0a"
"    constexpr span() noexcept;\x0a"
"    constexpr span(pointer ptr, index_type count);\x0a"
"    constexpr span(pointer firstElem, pointer lastElem);\x0a"
"    template <size_t N>\x0a"
"        constexpr span(element_type (\x26""arr)\x5bN\x5d) noexcept;\x0a"
"    template <size_t N>\x0a"
"        constexpr span(array<value_type, N>\x26 arr) noexcept;\x0a"
"    template <size_t N>\x0a"
"        constexpr span(const array<value_type, N>\x26 arr) noexcept;\x0a"
"    template <class Container>\x0a"
"        constexpr span(Container\x26 cont);\x0a"
"    template <class Container>\x0a"
"        constexpr span(const Container\x26 cont);\x0a"
"    constexpr span(const span\x26 other) noexcept = default;\x0a"
"    template <class OtherElementType, size_t OtherExtent>\x0a"
"        constexpr span(const span<OtherElementType, OtherExtent>\x26 s) noexcept;\x0a"
"    \x7espan() noexcept = default;\x0a"
"    constexpr span\x26 operator=(const span\x26 other) noexcept = default;\x0a"
"\x0a"
"    // \x5bspan.sub\x5d, span subviews\x0a"
"    template <size_t Count>\x0a"
"        constexpr span<element_type, Count> first() const;\x0a"
"    template <size_t Count>\x0a"
"        constexpr span<element_type, Count> last() const;\x0a"
"    template <size_t Offset, size_t Count = dynamic_extent>\x0a"
"        constexpr span<element_type, see below> subspan() const;\x0a"
"\x0a"
"    constexpr span<element_type, dynamic_extent> first(index_type count) const;\x0a"
"    constexpr span<element_type, dynamic_extent> last(index_type count) const;\x0a"
"    constexpr span<element_type, dynamic_extent> subspan(index_type offset, index_type count = dynamic_extent) const;\x0a"
"\x0a"
"    // \x5bspan.obs\x5d, span observers\x0a"
"    constexpr index_type size() const noexcept;\x0a"
"    constexpr index_type size_bytes() const noexcept;\x0a"
"    constexpr bool empty() const noexcept;\x0a"
"\x0a"
"    // \x5bspan.elem\x5d, span element access\x0a"
"    constexpr reference operator\x5b\x5d(index_type idx) const;\x0a"
"    constexpr reference front() const;\x0a"
"    constexpr reference back() const;\x0a"
"    constexpr pointer data() const noexcept;\x0a"
"\x0a"
"    // \x5bspan.iterators\x5d, span iterator support\x0a"
"    constexpr iterator begin() const noexcept;\x0a"
"    constexpr iterator end() const noexcept;\x0a"
"    constexpr const_iterator cbegin() const noexcept;\x0a"
"    constexpr const_iterator cend() const noexcept;\x0a"
"    constexpr reverse_iterator rbegin() const noexcept;\x0a"
"    constexpr reverse_iterator rend() const noexcept;\x0a"
"    constexpr const_reverse_iterator crbegin() const noexcept;\x0a"
"    constexpr const_reverse_iterator crend() const noexcept;\x0a"
"\x0a"
"private\x3a\x0a"
"    pointer data_;     // exposition only\x0a"
"    index_type size_;  // exposition only\x0a"
"};\x0a"
"\x0a"
"template<class T, size_t N>\x0a"
"    span(T (\x26)\x5bN\x5d) -> span<T, N>;\x0a"
"\x0a"
"template<class T, size_t N>\x0a"
"    span(array<T, N>\x26) -> span<T, N>;\x0a"
"\x0a"
"template<class T, size_t N>\x0a"
"    span(const array<T, N>\x26) -> span<const T, N>;\x0a"
"\x0a"
"template<class Container>\x0a"
"    span(Container\x26) -> span<typename Container\x3a\x3avalue_type>;\x0a"
"\x0a"
"template<class Container>\x0a"
"    span(const Container\x26) -> span<const typename Container\x3a\x3avalue_type>;\x0a"
"\x0a"
"} // namespace std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <cstddef>      // for ptrdiff_t\x0a"
"#include <iterator>     // for iterators\x0a"
"#include <array>        // for array\x0a"
"#include <type_traits>  // for remove_cv, etc\x0a"
"#include <cstddef>      // for byte\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"inline constexpr size_t dynamic_extent = numeric_limits<size_t>\x3a\x3amax();\x0a"
"template <typename _Tp, size_t _Extent = dynamic_extent> class span;\x0a"
"\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_span_impl \x3a public false_type {};\x0a"
"\x0a"
"template <class _Tp, size_t _Extent>\x0a"
"struct __is_span_impl<span<_Tp, _Extent>> \x3a public true_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_span \x3a public __is_span_impl<remove_cv_t<_Tp>> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_std_array_impl \x3a public false_type {};\x0a"
"\x0a"
"template <class _Tp, size_t _Sz>\x0a"
"struct __is_std_array_impl<array<_Tp, _Sz>> \x3a public true_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_std_array \x3a public __is_std_array_impl<remove_cv_t<_Tp>> {};\x0a"
"\x0a"
"template <class _Tp, class _ElementType, class = void>\x0a"
"struct __is_span_compatible_container \x3a public false_type {};\x0a"
"\x0a"
"template <class _Tp, class _ElementType>\x0a"
"struct __is_span_compatible_container<_Tp, _ElementType,\x0a"
"        void_t<\x0a"
"        // is not a specialization of span\x0a"
"            typename enable_if<\x21__is_span<_Tp>\x3a\x3avalue, nullptr_t>\x3a\x3atype,\x0a"
"        // is not a specialization of array\x0a"
"            typename enable_if<\x21__is_std_array<_Tp>\x3a\x3avalue, nullptr_t>\x3a\x3atype,\x0a"
"        // is_array_v<Container> is false,\x0a"
"            typename enable_if<\x21is_array_v<_Tp>, nullptr_t>\x3a\x3atype,\x0a"
"        // data(cont) and size(cont) are well formed\x0a"
"            decltype(data(declval<_Tp>())),\x0a"
"            decltype(size(declval<_Tp>())),\x0a"
"        // remove_pointer_t<decltype(data(cont))>(*)\x5b\x5d is convertible to ElementType(*)\x5b\x5d\x0a"
"            typename enable_if<\x0a"
"                is_convertible_v<remove_pointer_t<decltype(data(declval<_Tp \x26>()))>(*)\x5b\x5d,\x0a"
"                                 _ElementType(*)\x5b\x5d>,\x0a"
"                nullptr_t>\x3a\x3atype\x0a"
"        >>\x0a"
"    \x3a public true_type {};\x0a"
"\x0a"
"\x0a"
"template <typename _Tp, size_t _Extent>\x0a"
"class _LIBCPP_TEMPLATE_VIS span {\x0a"
"public\x3a\x0a"
"//  constants and types\x0a"
"    using element_type           = _Tp;\x0a"
"    using value_type             = remove_cv_t<_Tp>;\x0a"
"    using index_type             = size_t;\x0a"
"    using difference_type        = ptrdiff_t;\x0a"
"    using pointer                = _Tp *;\x0a"
"    using const_pointer          = const _Tp *;\x0a"
"    using reference              = _Tp \x26;\x0a"
"    using const_reference        = const _Tp \x26;\x0a"
"    using iterator               =  __wrap_iter<pointer>;\x0a"
"    using const_iterator         =  __wrap_iter<const_pointer>;\x0a"
"    using reverse_iterator       = _VSTD\x3a\x3areverse_iterator<iterator>;\x0a"
"    using const_reverse_iterator = _VSTD\x3a\x3areverse_iterator<const_iterator>;\x0a"
"\x0a"
"    static constexpr index_type extent = _Extent;\x0a"
"\x0a"
"// \x5bspan.cons\x5d, span constructors, copy, assignment, and destructor\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr span() noexcept \x3a __data{nullptr}\x0a"
"    { static_assert(_Extent == 0, \x22""Can't default construct a statically sized span with size > 0\x22); }\x0a"
"\x0a"
"    constexpr span           (const span\x26) noexcept = default;\x0a"
"    constexpr span\x26 operator=(const span\x26) noexcept = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr span(pointer __ptr, index_type __count) \x3a __data{__ptr}\x0a"
"        { (void)__count; _LIBCPP_ASSERT(_Extent == __count, \x22size mismatch in span's constructor (ptr, len)\x22); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr span(pointer __f, pointer __l) \x3a __data{__f}\x0a"
"        { (void)__l;     _LIBCPP_ASSERT(_Extent == distance(__f, __l), \x22size mismatch in span's constructor (ptr, ptr)\x22); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr span(element_type (\x26__arr)\x5b_Extent\x5d)          noexcept \x3a __data{__arr} {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr span(      array<value_type, _Extent>\x26 __arr) noexcept \x3a __data{__arr.data()} {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr span(const array<value_type, _Extent>\x26 __arr) noexcept \x3a __data{__arr.data()} {}\x0a"
"\x0a"
"    template <class _OtherElementType>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        constexpr span(const span<_OtherElementType, _Extent>\x26 __other,\x0a"
"                       enable_if_t<\x0a"
"                          is_convertible_v<_OtherElementType(*)\x5b\x5d, element_type (*)\x5b\x5d>,\x0a"
"                          nullptr_t> = nullptr)\x0a"
"        \x3a __data{__other.data()} {}\x0a"
"\x0a"
"    template <class _OtherElementType>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        constexpr span(const span<_OtherElementType, dynamic_extent>\x26 __other,\x0a"
"                       enable_if_t<\x0a"
"                          is_convertible_v<_OtherElementType(*)\x5b\x5d, element_type (*)\x5b\x5d>,\x0a"
"                          nullptr_t> = nullptr) noexcept\x0a"
"        \x3a __data{__other.data()} { _LIBCPP_ASSERT(_Extent == __other.size(), \x22size mismatch in span's constructor (other span)\x22); }\x0a"
"\x0a"
"\x0a"
"//  \x7espan() noexcept = default;\x0a"
"\x0a"
"    template <size_t _Count>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span<element_type, _Count> first() const noexcept\x0a"
"    {\x0a"
"        static_assert(_Count <= _Extent, \x22""Count out of range in span\x3a\x3a""first()\x22);\x0a"
"        return {data(), _Count};\x0a"
"    }\x0a"
"\x0a"
"    template <size_t _Count>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span<element_type, _Count> last() const noexcept\x0a"
"    {\x0a"
"        static_assert(_Count <= _Extent, \x22""Count out of range in span\x3a\x3alast()\x22);\x0a"
"        return {data() + size() - _Count, _Count};\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span<element_type, dynamic_extent> first(index_type __count) const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__count <= size(), \x22""Count out of range in span\x3a\x3a""first(count)\x22);\x0a"
"        return {data(), __count};\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span<element_type, dynamic_extent> last(index_type __count) const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__count <= size(), \x22""Count out of range in span\x3a\x3alast(count)\x22);\x0a"
"        return {data() + size() - __count, __count};\x0a"
"    }\x0a"
"\x0a"
"    template <size_t _Offset, size_t _Count = dynamic_extent>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr auto subspan() const noexcept\x0a"
"        -> span<element_type, _Count \x21= dynamic_extent \x3f _Count \x3a _Extent - _Offset>\x0a"
"    {\x0a"
"        static_assert(_Offset <= _Extent, \x22Offset out of range in span\x3a\x3asubspan()\x22);\x0a"
"        return {data() + _Offset, _Count == dynamic_extent \x3f size() - _Offset \x3a _Count};\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span<element_type, dynamic_extent>\x0a"
"       subspan(index_type __offset, index_type __count = dynamic_extent) const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__offset <= size(), \x22Offset out of range in span\x3a\x3asubspan(offset, count)\x22);\x0a"
"        _LIBCPP_ASSERT(__count  <= size() \x7c\x7c __count == dynamic_extent, \x22""Count out of range in span\x3a\x3asubspan(offset, count)\x22);\x0a"
"        if (__count == dynamic_extent)\x0a"
"            return {data() + __offset, size() - __offset};\x0a"
"        _LIBCPP_ASSERT(__offset <= size() - __count, \x22""count + offset out of range in span\x3a\x3asubspan(offset, count)\x22);\x0a"
"        return {data() + __offset, __count};\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr index_type size()       const noexcept { return _Extent; }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr index_type size_bytes() const noexcept { return _Extent * sizeof(element_type); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr bool empty()            const noexcept { return _Extent == 0; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr reference operator\x5b\x5d(index_type __idx) const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__idx >= 0 \x26\x26 __idx < size(), \x22span<T,N>\x5b\x5d index out of bounds\x22);\x0a"
"        return __data\x5b__idx\x5d;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr reference front() const noexcept\x0a"
"    {\x0a"
"        static_assert(_Extent > 0, \x22span<T,N>\x5b\x5d.front() on empty span\x22);\x0a"
"        return __data\x5b""0\x5d;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr reference back() const noexcept\x0a"
"    {\x0a"
"        static_assert(_Extent > 0, \x22span<T,N>\x5b\x5d.back() on empty span\x22);\x0a"
"        return __data\x5bsize()-1\x5d;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr pointer data()                         const noexcept { return __data; }\x0a"
"\x0a"
"// \x5bspan.iter\x5d, span iterator support\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr iterator                 begin() const noexcept { return iterator(data()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr iterator                   end() const noexcept { return iterator(data() + size()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr const_iterator          cbegin() const noexcept { return const_iterator(data()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr const_iterator            cend() const noexcept { return const_iterator(data() + size()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr reverse_iterator        rbegin() const noexcept { return reverse_iterator(end()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr reverse_iterator          rend() const noexcept { return reverse_iterator(begin()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr const_reverse_iterator crbegin() const noexcept { return const_reverse_iterator(cend()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr const_reverse_iterator   crend() const noexcept { return const_reverse_iterator(cbegin()); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr void swap(span \x26__other) noexcept\x0a"
"    {\x0a"
"        pointer __p = __data;\x0a"
"        __data = __other.__data;\x0a"
"        __other.__data = __p;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY span<const byte, _Extent * sizeof(element_type)> __as_bytes() const noexcept\x0a"
"    { return {reinterpret_cast<const byte *>(data()), size_bytes()}; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY span<byte, _Extent * sizeof(element_type)> __as_writable_bytes() const noexcept\x0a"
"    { return {reinterpret_cast<byte *>(data()), size_bytes()}; }\x0a"
"\x0a"
"private\x3a\x0a"
"    pointer    __data;\x0a"
"\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS span<_Tp, dynamic_extent> {\x0a"
"private\x3a\x0a"
"\x0a"
"public\x3a\x0a"
"//  constants and types\x0a"
"    using element_type           = _Tp;\x0a"
"    using value_type             = remove_cv_t<_Tp>;\x0a"
"    using index_type             = size_t;\x0a"
"    using difference_type        = ptrdiff_t;\x0a"
"    using pointer                = _Tp *;\x0a"
"    using const_pointer          = const _Tp *;\x0a"
"    using reference              = _Tp \x26;\x0a"
"    using const_reference        = const _Tp \x26;\x0a"
"    using iterator               =  __wrap_iter<pointer>;\x0a"
"    using const_iterator         =  __wrap_iter<const_pointer>;\x0a"
"    using reverse_iterator       = _VSTD\x3a\x3areverse_iterator<iterator>;\x0a"
"    using const_reverse_iterator = _VSTD\x3a\x3areverse_iterator<const_iterator>;\x0a"
"\x0a"
"    static constexpr index_type extent = dynamic_extent;\x0a"
"\x0a"
"// \x5bspan.cons\x5d, span constructors, copy, assignment, and destructor\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr span() noexcept \x3a __data{nullptr}, __size{0} {}\x0a"
"\x0a"
"    constexpr span           (const span\x26) noexcept = default;\x0a"
"    constexpr span\x26 operator=(const span\x26) noexcept = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr span(pointer __ptr, index_type __count) \x3a __data{__ptr}, __size{__count} {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr span(pointer __f, pointer __l) \x3a __data{__f}, __size{static_cast<size_t>(distance(__f, __l))} {}\x0a"
"\x0a"
"    template <size_t _Sz>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span(element_type (\x26__arr)\x5b_Sz\x5d)          noexcept \x3a __data{__arr}, __size{_Sz} {}\x0a"
"\x0a"
"    template <size_t _Sz>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span(array<value_type, _Sz>\x26 __arr)       noexcept \x3a __data{__arr.data()}, __size{_Sz} {}\x0a"
"\x0a"
"    template <size_t _Sz>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span(const array<value_type, _Sz>\x26 __arr) noexcept \x3a __data{__arr.data()}, __size{_Sz} {}\x0a"
"\x0a"
"    template <class _Container>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        constexpr span(      _Container\x26 __c,\x0a"
"            enable_if_t<__is_span_compatible_container<_Container, _Tp>\x3a\x3avalue, nullptr_t> = nullptr)\x0a"
"        \x3a __data{_VSTD\x3a\x3a""data(__c)}, __size{(index_type) _VSTD\x3a\x3asize(__c)} {}\x0a"
"\x0a"
"    template <class _Container>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        constexpr span(const _Container\x26 __c,\x0a"
"            enable_if_t<__is_span_compatible_container<const _Container, _Tp>\x3a\x3avalue, nullptr_t> = nullptr)\x0a"
"        \x3a __data{_VSTD\x3a\x3a""data(__c)}, __size{(index_type) _VSTD\x3a\x3asize(__c)} {}\x0a"
"\x0a"
"\x0a"
"    template <class _OtherElementType, size_t _OtherExtent>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        constexpr span(const span<_OtherElementType, _OtherExtent>\x26 __other,\x0a"
"                       enable_if_t<\x0a"
"                          is_convertible_v<_OtherElementType(*)\x5b\x5d, element_type (*)\x5b\x5d>,\x0a"
"                          nullptr_t> = nullptr) noexcept\x0a"
"        \x3a __data{__other.data()}, __size{__other.size()} {}\x0a"
"\x0a"
"//    \x7espan() noexcept = default;\x0a"
"\x0a"
"    template <size_t _Count>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span<element_type, _Count> first() const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(_Count <= size(), \x22""Count out of range in span\x3a\x3a""first()\x22);\x0a"
"        return {data(), _Count};\x0a"
"    }\x0a"
"\x0a"
"    template <size_t _Count>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span<element_type, _Count> last() const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(_Count <= size(), \x22""Count out of range in span\x3a\x3alast()\x22);\x0a"
"        return {data() + size() - _Count, _Count};\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span<element_type, dynamic_extent> first(index_type __count) const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__count <= size(), \x22""Count out of range in span\x3a\x3a""first(count)\x22);\x0a"
"        return {data(), __count};\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span<element_type, dynamic_extent> last (index_type __count) const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__count <= size(), \x22""Count out of range in span\x3a\x3alast(count)\x22);\x0a"
"        return {data() + size() - __count, __count};\x0a"
"    }\x0a"
"\x0a"
"    template <size_t _Offset, size_t _Count = dynamic_extent>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr span<_Tp, dynamic_extent> subspan() const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(_Offset <= size(), \x22Offset out of range in span\x3a\x3asubspan()\x22);\x0a"
"        _LIBCPP_ASSERT(_Count == dynamic_extent \x7c\x7c _Offset + _Count <= size(), \x22""Count out of range in span\x3a\x3asubspan()\x22);\x0a"
"        return {data() + _Offset, _Count == dynamic_extent \x3f size() - _Offset \x3a _Count};\x0a"
"    }\x0a"
"\x0a"
"    constexpr span<element_type, dynamic_extent>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    subspan(index_type __offset, index_type __count = dynamic_extent) const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__offset <= size(), \x22Offset out of range in span\x3a\x3asubspan(offset, count)\x22);\x0a"
"        _LIBCPP_ASSERT(__count  <= size() \x7c\x7c __count == dynamic_extent, \x22""count out of range in span\x3a\x3asubspan(offset, count)\x22);\x0a"
"        if (__count == dynamic_extent)\x0a"
"            return {data() + __offset, size() - __offset};\x0a"
"        _LIBCPP_ASSERT(__offset <= size() - __count, \x22Offset + count out of range in span\x3a\x3asubspan(offset, count)\x22);\x0a"
"        return {data() + __offset, __count};\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr index_type size()       const noexcept { return __size; }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr index_type size_bytes() const noexcept { return __size * sizeof(element_type); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr bool empty()            const noexcept { return __size == 0; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr reference operator\x5b\x5d(index_type __idx) const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__idx >= 0 \x26\x26 __idx < size(), \x22span<T>\x5b\x5d index out of bounds\x22);\x0a"
"        return __data\x5b__idx\x5d;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr reference front() const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21""empty(), \x22span<T>\x5b\x5d.front() on empty span\x22);\x0a"
"        return __data\x5b""0\x5d;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr reference back() const noexcept\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21""empty(), \x22span<T>\x5b\x5d.back() on empty span\x22);\x0a"
"        return __data\x5bsize()-1\x5d;\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr pointer data()                         const noexcept { return __data; }\x0a"
"\x0a"
"// \x5bspan.iter\x5d, span iterator support\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr iterator                 begin() const noexcept { return iterator(data()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr iterator                   end() const noexcept { return iterator(data() + size()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr const_iterator          cbegin() const noexcept { return const_iterator(data()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr const_iterator            cend() const noexcept { return const_iterator(data() + size()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr reverse_iterator        rbegin() const noexcept { return reverse_iterator(end()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr reverse_iterator          rend() const noexcept { return reverse_iterator(begin()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr const_reverse_iterator crbegin() const noexcept { return const_reverse_iterator(cend()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr const_reverse_iterator   crend() const noexcept { return const_reverse_iterator(cbegin()); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY constexpr void swap(span \x26__other) noexcept\x0a"
"    {\x0a"
"        pointer __p = __data;\x0a"
"        __data = __other.__data;\x0a"
"        __other.__data = __p;\x0a"
"\x0a"
"        index_type __sz = __size;\x0a"
"        __size = __other.__size;\x0a"
"        __other.__size = __sz;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY span<const byte, dynamic_extent> __as_bytes() const noexcept\x0a"
"    { return {reinterpret_cast<const byte *>(data()), size_bytes()}; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY span<byte, dynamic_extent> __as_writable_bytes() const noexcept\x0a"
"    { return {reinterpret_cast<byte *>(data()), size_bytes()}; }\x0a"
"\x0a"
"private\x3a\x0a"
"    pointer    __data;\x0a"
"    index_type __size;\x0a"
"};\x0a"
"\x0a"
"//  tuple interface\x0a"
"template <class _Tp, size_t _Size>\x0a"
"struct _LIBCPP_TEMPLATE_VIS tuple_size<span<_Tp, _Size>>\x0a"
"    \x3a public integral_constant<size_t, _Size> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS tuple_size<span<_Tp, dynamic_extent>>; // declared but not defined\x0a"
"\x0a"
"\x0a"
"template <size_t _Ip, class _Tp, size_t _Size>\x0a"
"struct _LIBCPP_TEMPLATE_VIS tuple_element<_Ip, span<_Tp, _Size>>\x0a"
"{\x0a"
"    static_assert( dynamic_extent \x21= _Size, \x22std\x3a\x3atuple_element<> not supported for std\x3a\x3aspan<T, dynamic_extent>\x22);\x0a"
"    static_assert(_Ip < _Size, \x22Index out of bounds in std\x3a\x3atuple_element<> (std\x3a\x3aspan)\x22);\x0a"
"    typedef _Tp type;\x0a"
"};\x0a"
"\x0a"
"template <size_t _Ip, class _Tp, size_t _Size>\x0a"
"_LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_Tp\x26\x0a"
"get(span<_Tp, _Size> __s) noexcept\x0a"
"{\x0a"
"    static_assert( dynamic_extent \x21= _Size, \x22std\x3a\x3aget<> not supported for std\x3a\x3aspan<T, dynamic_extent>\x22);\x0a"
"    static_assert(_Ip < _Size, \x22Index out of bounds in std\x3a\x3aget<> (std\x3a\x3aspan)\x22);\x0a"
"    return __s\x5b_Ip\x5d;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"//  as_bytes \x26 as_writable_bytes\x0a"
"template <class _Tp, size_t _Extent>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"auto as_bytes(span<_Tp, _Extent> __s) noexcept\x0a"
"-> decltype(__s.__as_bytes())\x0a"
"{ return    __s.__as_bytes(); }\x0a"
"\x0a"
"template <class _Tp, size_t _Extent>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"auto as_writable_bytes(span<_Tp, _Extent> __s) noexcept\x0a"
"-> enable_if_t<\x21is_const_v<_Tp>, decltype(__s.__as_writable_bytes())>\x0a"
"{ return __s.__as_writable_bytes(); }\x0a"
"\x0a"
"template <class _Tp, size_t _Extent>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr void swap(span<_Tp, _Extent> \x26__lhs, span<_Tp, _Extent> \x26__rhs) noexcept\x0a"
"{ __lhs.swap(__rhs); }\x0a"
"\x0a"
"\x0a"
"//  Deduction guides\x0a"
"template<class _Tp, size_t _Sz>\x0a"
"    span(_Tp (\x26)\x5b_Sz\x5d) -> span<_Tp, _Sz>;\x0a"
"\x0a"
"template<class _Tp, size_t _Sz>\x0a"
"    span(array<_Tp, _Sz>\x26) -> span<_Tp, _Sz>;\x0a"
"\x0a"
"template<class _Tp, size_t _Sz>\x0a"
"    span(const array<_Tp, _Sz>\x26) -> span<const _Tp, _Sz>;\x0a"
"\x0a"
"template<class _Container>\x0a"
"    span(_Container\x26) -> span<typename _Container\x3a\x3avalue_type>;\x0a"
"\x0a"
"template<class _Container>\x0a"
"    span(const _Container\x26) -> span<const typename _Container\x3a\x3avalue_type>;\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // _LIBCPP_SPAN\x0a"
"", 24315 ); }