#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_sstream( 
"// -*- C++ -*-\x0a"
"//===--------------------------- sstream ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_SSTREAM\x0a"
"#define _LIBCPP_SSTREAM\x0a"
"\x0a"
"/*\x0a"
"    sstream synopsis\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT>, class Allocator = allocator<charT> >\x0a"
"class basic_stringbuf\x0a"
"    \x3a public basic_streambuf<charT, traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"    typedef Allocator                      allocator_type;\x0a"
"\x0a"
"    // 27.8.1.1 Constructors\x3a\x0a"
"    explicit basic_stringbuf(ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    explicit basic_stringbuf(const basic_string<char_type, traits_type, allocator_type>\x26 str,\x0a"
"                             ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    basic_stringbuf(basic_stringbuf\x26\x26 rhs);\x0a"
"\x0a"
"    // 27.8.1.2 Assign and swap\x3a\x0a"
"    basic_stringbuf\x26 operator=(basic_stringbuf\x26\x26 rhs);\x0a"
"    void swap(basic_stringbuf\x26 rhs);\x0a"
"\x0a"
"    // 27.8.1.3 Get and set\x3a\x0a"
"    basic_string<char_type, traits_type, allocator_type> str() const;\x0a"
"    void str(const basic_string<char_type, traits_type, allocator_type>\x26 s);\x0a"
"\x0a"
"protected\x3a\x0a"
"    // 27.8.1.4 Overridden virtual functions\x3a\x0a"
"    virtual int_type underflow();\x0a"
"    virtual int_type pbackfail(int_type c = traits_type\x3a\x3a""eof());\x0a"
"    virtual int_type overflow (int_type c = traits_type\x3a\x3a""eof());\x0a"
"    virtual basic_streambuf<char_type, traits_type>* setbuf(char_type*, streamsize);\x0a"
"    virtual pos_type seekoff(off_type off, ios_base\x3a\x3aseekdir way,\x0a"
"                             ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual pos_type seekpos(pos_type sp,\x0a"
"                             ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits, class Allocator>\x0a"
"  void swap(basic_stringbuf<charT, traits, Allocator>\x26 x,\x0a"
"            basic_stringbuf<charT, traits, Allocator>\x26 y);\x0a"
"\x0a"
"typedef basic_stringbuf<char>    stringbuf;\x0a"
"typedef basic_stringbuf<wchar_t> wstringbuf;\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT>, class Allocator = allocator<charT> >\x0a"
"class basic_istringstream\x0a"
"    \x3a public basic_istream<charT, traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"    typedef Allocator                      allocator_type;\x0a"
"\x0a"
"    // 27.8.2.1 Constructors\x3a\x0a"
"    explicit basic_istringstream(ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain);\x0a"
"    explicit basic_istringstream(const basic_string<char_type, traits_type,allocator_type>\x26 str,\x0a"
"                                 ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain);\x0a"
"    basic_istringstream(basic_istringstream\x26\x26 rhs);\x0a"
"\x0a"
"    // 27.8.2.2 Assign and swap\x3a\x0a"
"    basic_istringstream\x26 operator=(basic_istringstream\x26\x26 rhs);\x0a"
"    void swap(basic_istringstream\x26 rhs);\x0a"
"\x0a"
"    // 27.8.2.3 Members\x3a\x0a"
"    basic_stringbuf<char_type, traits_type, allocator_type>* rdbuf() const;\x0a"
"    basic_string<char_type, traits_type, allocator_type> str() const;\x0a"
"    void str(const basic_string<char_type, traits_type, allocator_type>\x26 s);\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits, class Allocator>\x0a"
"  void swap(basic_istringstream<charT, traits, Allocator>\x26 x,\x0a"
"            basic_istringstream<charT, traits, Allocator>\x26 y);\x0a"
"\x0a"
"typedef basic_istringstream<char>    istringstream;\x0a"
"typedef basic_istringstream<wchar_t> wistringstream;\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT>, class Allocator = allocator<charT> >\x0a"
"class basic_ostringstream\x0a"
"    \x3a public basic_ostream<charT, traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"    typedef Allocator                      allocator_type;\x0a"
"\x0a"
"    // 27.8.3.1 Constructors/destructor\x3a\x0a"
"    explicit basic_ostringstream(ios_base\x3a\x3aopenmode which = ios_base\x3a\x3aout);\x0a"
"    explicit basic_ostringstream(const basic_string<char_type, traits_type, allocator_type>\x26 str,\x0a"
"                                 ios_base\x3a\x3aopenmode which = ios_base\x3a\x3aout);\x0a"
"    basic_ostringstream(basic_ostringstream\x26\x26 rhs);\x0a"
"\x0a"
"    // 27.8.3.2 Assign/swap\x3a\x0a"
"    basic_ostringstream\x26 operator=(basic_ostringstream\x26\x26 rhs);\x0a"
"    void swap(basic_ostringstream\x26 rhs);\x0a"
"\x0a"
"    // 27.8.3.3 Members\x3a\x0a"
"    basic_stringbuf<char_type, traits_type, allocator_type>* rdbuf() const;\x0a"
"    basic_string<char_type, traits_type, allocator_type> str() const;\x0a"
"    void str(const basic_string<char_type, traits_type, allocator_type>\x26 s);\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits, class Allocator>\x0a"
"  void swap(basic_ostringstream<charT, traits, Allocator>\x26 x,\x0a"
"            basic_ostringstream<charT, traits, Allocator>\x26 y);\x0a"
"\x0a"
"typedef basic_ostringstream<char>    ostringstream;\x0a"
"typedef basic_ostringstream<wchar_t> wostringstream;\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT>, class Allocator = allocator<charT> >\x0a"
"class basic_stringstream\x0a"
"    \x3a public basic_iostream<charT, traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef charT                          char_type;\x0a"
"    typedef traits                         traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"    typedef Allocator                      allocator_type;\x0a"
"\x0a"
"    // constructors/destructor\x0a"
"    explicit basic_stringstream(ios_base\x3a\x3aopenmode which = ios_base\x3a\x3aout\x7cios_base\x3a\x3ain);\x0a"
"    explicit basic_stringstream(const basic_string<char_type, traits_type, allocator_type>\x26 str,\x0a"
"                                ios_base\x3a\x3aopenmode which = ios_base\x3a\x3aout\x7cios_base\x3a\x3ain);\x0a"
"    basic_stringstream(basic_stringstream\x26\x26 rhs);\x0a"
"\x0a"
"    // 27.8.5.1 Assign/swap\x3a\x0a"
"    basic_stringstream\x26 operator=(basic_stringstream\x26\x26 rhs);\x0a"
"    void swap(basic_stringstream\x26 rhs);\x0a"
"\x0a"
"    // Members\x3a\x0a"
"    basic_stringbuf<char_type, traits_type, allocator_type>* rdbuf() const;\x0a"
"    basic_string<char_type, traits_type, allocator_type> str() const;\x0a"
"    void str(const basic_string<char_type, traits_type, allocator_type>\x26 str);\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits, class Allocator>\x0a"
"  void swap(basic_stringstream<charT, traits, Allocator>\x26 x,\x0a"
"            basic_stringstream<charT, traits, Allocator>\x26 y);\x0a"
"\x0a"
"typedef basic_stringstream<char>    stringstream;\x0a"
"typedef basic_stringstream<wchar_t> wstringstream;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <ostream>\x0a"
"#include <istream>\x0a"
"#include <string>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// basic_stringbuf\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_stringbuf\x0a"
"    \x3a public basic_streambuf<_CharT, _Traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"    typedef _Allocator                     allocator_type;\x0a"
"\x0a"
"    typedef basic_string<char_type, traits_type, allocator_type> string_type;\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"    string_type __str_;\x0a"
"    mutable char_type* __hm_;\x0a"
"    ios_base\x3a\x3aopenmode __mode_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // 27.8.1.1 Constructors\x3a\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_stringbuf(ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_stringbuf(const string_type\x26 __s,\x0a"
"                             ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    basic_stringbuf(basic_stringbuf\x26\x26 __rhs);\x0a"
"\x0a"
"    // 27.8.1.2 Assign and swap\x3a\x0a"
"    basic_stringbuf\x26 operator=(basic_stringbuf\x26\x26 __rhs);\x0a"
"#endif\x0a"
"    void swap(basic_stringbuf\x26 __rhs);\x0a"
"\x0a"
"    // 27.8.1.3 Get and set\x3a\x0a"
"    string_type str() const;\x0a"
"    void str(const string_type\x26 __s);\x0a"
"\x0a"
"protected\x3a\x0a"
"    // 27.8.1.4 Overridden virtual functions\x3a\x0a"
"    virtual int_type underflow();\x0a"
"    virtual int_type pbackfail(int_type __c = traits_type\x3a\x3a""eof());\x0a"
"    virtual int_type overflow (int_type __c = traits_type\x3a\x3a""eof());\x0a"
"    virtual pos_type seekoff(off_type __off, ios_base\x3a\x3aseekdir __way,\x0a"
"                             ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    virtual pos_type seekpos(pos_type __sp,\x0a"
"                             ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3a""basic_stringbuf(ios_base\x3a\x3aopenmode __wch)\x0a"
"    \x3a __hm_(0),\x0a"
"      __mode_(__wch)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3a""basic_stringbuf(const string_type\x26 __s,\x0a"
"                             ios_base\x3a\x3aopenmode __wch)\x0a"
"    \x3a __str_(__s.get_allocator()),\x0a"
"      __hm_(0),\x0a"
"      __mode_(__wch)\x0a"
"{\x0a"
"    str(__s);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3a""basic_stringbuf(basic_stringbuf\x26\x26 __rhs)\x0a"
"    \x3a __mode_(__rhs.__mode_)\x0a"
"{\x0a"
"    char_type* __p = const_cast<char_type*>(__rhs.__str_.data());\x0a"
"    ptrdiff_t __binp = -1;\x0a"
"    ptrdiff_t __ninp = -1;\x0a"
"    ptrdiff_t __einp = -1;\x0a"
"    if (__rhs.eback() \x21= nullptr)\x0a"
"    {\x0a"
"        __binp = __rhs.eback() - __p;\x0a"
"        __ninp = __rhs.gptr() - __p;\x0a"
"        __einp = __rhs.egptr() - __p;\x0a"
"    }\x0a"
"    ptrdiff_t __bout = -1;\x0a"
"    ptrdiff_t __nout = -1;\x0a"
"    ptrdiff_t __eout = -1;\x0a"
"    if (__rhs.pbase() \x21= nullptr)\x0a"
"    {\x0a"
"        __bout = __rhs.pbase() - __p;\x0a"
"        __nout = __rhs.pptr() - __p;\x0a"
"        __eout = __rhs.epptr() - __p;\x0a"
"    }\x0a"
"    ptrdiff_t __hm = __rhs.__hm_ == nullptr \x3f -1 \x3a __rhs.__hm_ - __p;\x0a"
"    __str_ = _VSTD\x3a\x3amove(__rhs.__str_);\x0a"
"    __p = const_cast<char_type*>(__str_.data());\x0a"
"    if (__binp \x21= -1)\x0a"
"        this->setg(__p + __binp, __p + __ninp, __p + __einp);\x0a"
"    if (__bout \x21= -1)\x0a"
"    {\x0a"
"        this->setp(__p + __bout, __p + __eout);\x0a"
"        this->__pbump(__nout);\x0a"
"    }\x0a"
"    __hm_ = __hm == -1 \x3f nullptr \x3a __p + __hm;\x0a"
"    __p = const_cast<char_type*>(__rhs.__str_.data());\x0a"
"    __rhs.setg(__p, __p, __p);\x0a"
"    __rhs.setp(__p, __p);\x0a"
"    __rhs.__hm_ = __p;\x0a"
"    this->pubimbue(__rhs.getloc());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3aoperator=(basic_stringbuf\x26\x26 __rhs)\x0a"
"{\x0a"
"    char_type* __p = const_cast<char_type*>(__rhs.__str_.data());\x0a"
"    ptrdiff_t __binp = -1;\x0a"
"    ptrdiff_t __ninp = -1;\x0a"
"    ptrdiff_t __einp = -1;\x0a"
"    if (__rhs.eback() \x21= nullptr)\x0a"
"    {\x0a"
"        __binp = __rhs.eback() - __p;\x0a"
"        __ninp = __rhs.gptr() - __p;\x0a"
"        __einp = __rhs.egptr() - __p;\x0a"
"    }\x0a"
"    ptrdiff_t __bout = -1;\x0a"
"    ptrdiff_t __nout = -1;\x0a"
"    ptrdiff_t __eout = -1;\x0a"
"    if (__rhs.pbase() \x21= nullptr)\x0a"
"    {\x0a"
"        __bout = __rhs.pbase() - __p;\x0a"
"        __nout = __rhs.pptr() - __p;\x0a"
"        __eout = __rhs.epptr() - __p;\x0a"
"    }\x0a"
"    ptrdiff_t __hm = __rhs.__hm_ == nullptr \x3f -1 \x3a __rhs.__hm_ - __p;\x0a"
"    __str_ = _VSTD\x3a\x3amove(__rhs.__str_);\x0a"
"    __p = const_cast<char_type*>(__str_.data());\x0a"
"    if (__binp \x21= -1)\x0a"
"        this->setg(__p + __binp, __p + __ninp, __p + __einp);\x0a"
"    else\x0a"
"        this->setg(nullptr, nullptr, nullptr);\x0a"
"    if (__bout \x21= -1)\x0a"
"    {\x0a"
"        this->setp(__p + __bout, __p + __eout);\x0a"
"        this->__pbump(__nout);\x0a"
"    }\x0a"
"    else\x0a"
"        this->setp(nullptr, nullptr);\x0a"
"\x0a"
"    __hm_ = __hm == -1 \x3f nullptr \x3a __p + __hm;\x0a"
"    __mode_ = __rhs.__mode_;\x0a"
"    __p = const_cast<char_type*>(__rhs.__str_.data());\x0a"
"    __rhs.setg(__p, __p, __p);\x0a"
"    __rhs.setp(__p, __p);\x0a"
"    __rhs.__hm_ = __p;\x0a"
"    this->pubimbue(__rhs.getloc());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3aswap(basic_stringbuf\x26 __rhs)\x0a"
"{\x0a"
"    char_type* __p = const_cast<char_type*>(__rhs.__str_.data());\x0a"
"    ptrdiff_t __rbinp = -1;\x0a"
"    ptrdiff_t __rninp = -1;\x0a"
"    ptrdiff_t __reinp = -1;\x0a"
"    if (__rhs.eback() \x21= nullptr)\x0a"
"    {\x0a"
"        __rbinp = __rhs.eback() - __p;\x0a"
"        __rninp = __rhs.gptr() - __p;\x0a"
"        __reinp = __rhs.egptr() - __p;\x0a"
"    }\x0a"
"    ptrdiff_t __rbout = -1;\x0a"
"    ptrdiff_t __rnout = -1;\x0a"
"    ptrdiff_t __reout = -1;\x0a"
"    if (__rhs.pbase() \x21= nullptr)\x0a"
"    {\x0a"
"        __rbout = __rhs.pbase() - __p;\x0a"
"        __rnout = __rhs.pptr() - __p;\x0a"
"        __reout = __rhs.epptr() - __p;\x0a"
"    }\x0a"
"    ptrdiff_t __rhm = __rhs.__hm_ == nullptr \x3f -1 \x3a __rhs.__hm_ - __p;\x0a"
"    __p = const_cast<char_type*>(__str_.data());\x0a"
"    ptrdiff_t __lbinp = -1;\x0a"
"    ptrdiff_t __lninp = -1;\x0a"
"    ptrdiff_t __leinp = -1;\x0a"
"    if (this->eback() \x21= nullptr)\x0a"
"    {\x0a"
"        __lbinp = this->eback() - __p;\x0a"
"        __lninp = this->gptr() - __p;\x0a"
"        __leinp = this->egptr() - __p;\x0a"
"    }\x0a"
"    ptrdiff_t __lbout = -1;\x0a"
"    ptrdiff_t __lnout = -1;\x0a"
"    ptrdiff_t __leout = -1;\x0a"
"    if (this->pbase() \x21= nullptr)\x0a"
"    {\x0a"
"        __lbout = this->pbase() - __p;\x0a"
"        __lnout = this->pptr() - __p;\x0a"
"        __leout = this->epptr() - __p;\x0a"
"    }\x0a"
"    ptrdiff_t __lhm = __hm_ == nullptr \x3f -1 \x3a __hm_ - __p;\x0a"
"    _VSTD\x3a\x3aswap(__mode_, __rhs.__mode_);\x0a"
"    __str_.swap(__rhs.__str_);\x0a"
"    __p = const_cast<char_type*>(__str_.data());\x0a"
"    if (__rbinp \x21= -1)\x0a"
"        this->setg(__p + __rbinp, __p + __rninp, __p + __reinp);\x0a"
"    else\x0a"
"        this->setg(nullptr, nullptr, nullptr);\x0a"
"    if (__rbout \x21= -1)\x0a"
"    {\x0a"
"        this->setp(__p + __rbout, __p + __reout);\x0a"
"        this->__pbump(__rnout);\x0a"
"    }\x0a"
"    else\x0a"
"        this->setp(nullptr, nullptr);\x0a"
"    __hm_ = __rhm == -1 \x3f nullptr \x3a __p + __rhm;\x0a"
"    __p = const_cast<char_type*>(__rhs.__str_.data());\x0a"
"    if (__lbinp \x21= -1)\x0a"
"        __rhs.setg(__p + __lbinp, __p + __lninp, __p + __leinp);\x0a"
"    else\x0a"
"        __rhs.setg(nullptr, nullptr, nullptr);\x0a"
"    if (__lbout \x21= -1)\x0a"
"    {\x0a"
"        __rhs.setp(__p + __lbout, __p + __leout);\x0a"
"        __rhs.__pbump(__lnout);\x0a"
"    }\x0a"
"    else\x0a"
"        __rhs.setp(nullptr, nullptr);\x0a"
"    __rhs.__hm_ = __lhm == -1 \x3f nullptr \x3a __p + __lhm;\x0a"
"    locale __tl = __rhs.getloc();\x0a"
"    __rhs.pubimbue(this->getloc());\x0a"
"    this->pubimbue(__tl);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(basic_stringbuf<_CharT, _Traits, _Allocator>\x26 __x,\x0a"
"     basic_stringbuf<_CharT, _Traits, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3astr() const\x0a"
"{\x0a"
"    if (__mode_ \x26 ios_base\x3a\x3aout)\x0a"
"    {\x0a"
"        if (__hm_ < this->pptr())\x0a"
"            __hm_ = this->pptr();\x0a"
"        return string_type(this->pbase(), __hm_, __str_.get_allocator());\x0a"
"    }\x0a"
"    else if (__mode_ \x26 ios_base\x3a\x3ain)\x0a"
"        return string_type(this->eback(), this->egptr(), __str_.get_allocator());\x0a"
"    return string_type(__str_.get_allocator());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3astr(const string_type\x26 __s)\x0a"
"{\x0a"
"    __str_ = __s;\x0a"
"    __hm_ = 0;\x0a"
"    if (__mode_ \x26 ios_base\x3a\x3ain)\x0a"
"    {\x0a"
"        __hm_ = const_cast<char_type*>(__str_.data()) + __str_.size();\x0a"
"        this->setg(const_cast<char_type*>(__str_.data()),\x0a"
"                   const_cast<char_type*>(__str_.data()),\x0a"
"                   __hm_);\x0a"
"    }\x0a"
"    if (__mode_ \x26 ios_base\x3a\x3aout)\x0a"
"    {\x0a"
"        typename string_type\x3a\x3asize_type __sz = __str_.size();\x0a"
"        __hm_ = const_cast<char_type*>(__str_.data()) + __sz;\x0a"
"        __str_.resize(__str_.capacity());\x0a"
"        this->setp(const_cast<char_type*>(__str_.data()),\x0a"
"                   const_cast<char_type*>(__str_.data()) + __str_.size());\x0a"
"        if (__mode_ \x26 (ios_base\x3a\x3a""app \x7c ios_base\x3a\x3a""ate))\x0a"
"        {\x0a"
"            while (__sz > INT_MAX)\x0a"
"            {\x0a"
"                this->pbump(INT_MAX);\x0a"
"                __sz -= INT_MAX;\x0a"
"            }\x0a"
"            if (__sz > 0)\x0a"
"                this->pbump(__sz);\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3aint_type\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3aunderflow()\x0a"
"{\x0a"
"    if (__hm_ < this->pptr())\x0a"
"        __hm_ = this->pptr();\x0a"
"    if (__mode_ \x26 ios_base\x3a\x3ain)\x0a"
"    {\x0a"
"        if (this->egptr() < __hm_)\x0a"
"            this->setg(this->eback(), this->gptr(), __hm_);\x0a"
"        if (this->gptr() < this->egptr())\x0a"
"            return traits_type\x3a\x3ato_int_type(*this->gptr());\x0a"
"    }\x0a"
"    return traits_type\x3a\x3a""eof();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3aint_type\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3apbackfail(int_type __c)\x0a"
"{\x0a"
"    if (__hm_ < this->pptr())\x0a"
"        __hm_ = this->pptr();\x0a"
"    if (this->eback() < this->gptr())\x0a"
"    {\x0a"
"        if (traits_type\x3a\x3a""eq_int_type(__c, traits_type\x3a\x3a""eof()))\x0a"
"        {\x0a"
"            this->setg(this->eback(), this->gptr()-1, __hm_);\x0a"
"            return traits_type\x3a\x3anot_eof(__c);\x0a"
"        }\x0a"
"        if ((__mode_ \x26 ios_base\x3a\x3aout) \x7c\x7c\x0a"
"            traits_type\x3a\x3a""eq(traits_type\x3a\x3ato_char_type(__c), this->gptr()\x5b-1\x5d))\x0a"
"        {\x0a"
"            this->setg(this->eback(), this->gptr()-1, __hm_);\x0a"
"            *this->gptr() = traits_type\x3a\x3ato_char_type(__c);\x0a"
"            return __c;\x0a"
"        }\x0a"
"    }\x0a"
"    return traits_type\x3a\x3a""eof();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3aint_type\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3aoverflow(int_type __c)\x0a"
"{\x0a"
"    if (\x21traits_type\x3a\x3a""eq_int_type(__c, traits_type\x3a\x3a""eof()))\x0a"
"    {\x0a"
"        ptrdiff_t __ninp = this->gptr()  - this->eback();\x0a"
"        if (this->pptr() == this->epptr())\x0a"
"        {\x0a"
"            if (\x21(__mode_ \x26 ios_base\x3a\x3aout))\x0a"
"                return traits_type\x3a\x3a""eof();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"            try\x0a"
"            {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"                ptrdiff_t __nout = this->pptr()  - this->pbase();\x0a"
"                ptrdiff_t __hm = __hm_ - this->pbase();\x0a"
"                __str_.push_back(char_type());\x0a"
"                __str_.resize(__str_.capacity());\x0a"
"                char_type* __p = const_cast<char_type*>(__str_.data());\x0a"
"                this->setp(__p, __p + __str_.size());\x0a"
"                this->__pbump(__nout);\x0a"
"                __hm_ = this->pbase() + __hm;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"            }\x0a"
"            catch (...)\x0a"
"            {\x0a"
"                return traits_type\x3a\x3a""eof();\x0a"
"            }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        __hm_ = _VSTD\x3a\x3amax(this->pptr() + 1, __hm_);\x0a"
"        if (__mode_ \x26 ios_base\x3a\x3ain)\x0a"
"        {\x0a"
"            char_type* __p = const_cast<char_type*>(__str_.data());\x0a"
"            this->setg(__p, __p + __ninp, __hm_);\x0a"
"        }\x0a"
"        return this->sputc(traits_type\x3a\x3ato_char_type(__c));\x0a"
"    }\x0a"
"    return traits_type\x3a\x3anot_eof(__c);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3apos_type\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3aseekoff(off_type __off,\x0a"
"                                                      ios_base\x3a\x3aseekdir __way,\x0a"
"                                                      ios_base\x3a\x3aopenmode __wch)\x0a"
"{\x0a"
"    if (__hm_ < this->pptr())\x0a"
"        __hm_ = this->pptr();\x0a"
"    if ((__wch \x26 (ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout)) == 0)\x0a"
"        return pos_type(-1);\x0a"
"    if ((__wch \x26 (ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout)) == (ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout)\x0a"
"        \x26\x26 __way == ios_base\x3a\x3a""cur)\x0a"
"        return pos_type(-1);\x0a"
"    const ptrdiff_t __hm = __hm_ == nullptr \x3f 0 \x3a __hm_ - __str_.data();\x0a"
"    off_type __noff;\x0a"
"    switch (__way)\x0a"
"    {\x0a"
"    case ios_base\x3a\x3a""beg\x3a\x0a"
"        __noff = 0;\x0a"
"        break;\x0a"
"    case ios_base\x3a\x3a""cur\x3a\x0a"
"        if (__wch \x26 ios_base\x3a\x3ain)\x0a"
"            __noff = this->gptr() - this->eback();\x0a"
"        else\x0a"
"            __noff = this->pptr() - this->pbase();\x0a"
"        break;\x0a"
"    case ios_base\x3a\x3a""end\x3a\x0a"
"        __noff = __hm;\x0a"
"        break;\x0a"
"    default\x3a\x0a"
"        return pos_type(-1);\x0a"
"    }\x0a"
"    __noff += __off;\x0a"
"    if (__noff < 0 \x7c\x7c __hm < __noff)\x0a"
"        return pos_type(-1);\x0a"
"    if (__noff \x21= 0)\x0a"
"    {\x0a"
"        if ((__wch \x26 ios_base\x3a\x3ain) \x26\x26 this->gptr() == 0)\x0a"
"            return pos_type(-1);\x0a"
"        if ((__wch \x26 ios_base\x3a\x3aout) \x26\x26 this->pptr() == 0)\x0a"
"            return pos_type(-1);\x0a"
"    }\x0a"
"    if (__wch \x26 ios_base\x3a\x3ain)\x0a"
"        this->setg(this->eback(), this->eback() + __noff, __hm_);\x0a"
"    if (__wch \x26 ios_base\x3a\x3aout)\x0a"
"    {\x0a"
"        this->setp(this->pbase(), this->epptr());\x0a"
"        this->pbump(__noff);\x0a"
"    }\x0a"
"    return pos_type(__noff);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3apos_type\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>\x3a\x3aseekpos(pos_type __sp,\x0a"
"                                                      ios_base\x3a\x3aopenmode __wch)\x0a"
"{\x0a"
"    return seekoff(__sp, ios_base\x3a\x3a""beg, __wch);\x0a"
"}\x0a"
"\x0a"
"// basic_istringstream\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_istringstream\x0a"
"    \x3a public basic_istream<_CharT, _Traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"    typedef _Allocator                     allocator_type;\x0a"
"\x0a"
"    typedef basic_string<char_type, traits_type, allocator_type> string_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    basic_stringbuf<char_type, traits_type, allocator_type> __sb_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // 27.8.2.1 Constructors\x3a\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_istringstream(ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3ain);\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_istringstream(const string_type\x26 __s,\x0a"
"                                 ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3ain);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_istringstream(basic_istringstream\x26\x26 __rhs);\x0a"
"\x0a"
"    // 27.8.2.2 Assign and swap\x3a\x0a"
"    basic_istringstream\x26 operator=(basic_istringstream\x26\x26 __rhs);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(basic_istringstream\x26 __rhs);\x0a"
"\x0a"
"    // 27.8.2.3 Members\x3a\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_stringbuf<char_type, traits_type, allocator_type>* rdbuf() const;\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    string_type str() const;\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    void str(const string_type\x26 __s);\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_istringstream<_CharT, _Traits, _Allocator>\x3a\x3a""basic_istringstream(ios_base\x3a\x3aopenmode __wch)\x0a"
"    \x3a basic_istream<_CharT, _Traits>(\x26__sb_),\x0a"
"      __sb_(__wch \x7c ios_base\x3a\x3ain)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_istringstream<_CharT, _Traits, _Allocator>\x3a\x3a""basic_istringstream(const string_type\x26 __s,\x0a"
"                                                                      ios_base\x3a\x3aopenmode __wch)\x0a"
"    \x3a basic_istream<_CharT, _Traits>(\x26__sb_),\x0a"
"      __sb_(__s, __wch \x7c ios_base\x3a\x3ain)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_istringstream<_CharT, _Traits, _Allocator>\x3a\x3a""basic_istringstream(basic_istringstream\x26\x26 __rhs)\x0a"
"    \x3a basic_istream<_CharT, _Traits>(_VSTD\x3a\x3amove(__rhs)),\x0a"
"      __sb_(_VSTD\x3a\x3amove(__rhs.__sb_))\x0a"
"{\x0a"
"    basic_istream<_CharT, _Traits>\x3a\x3aset_rdbuf(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_istringstream<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_istringstream<_CharT, _Traits, _Allocator>\x3a\x3aoperator=(basic_istringstream\x26\x26 __rhs)\x0a"
"{\x0a"
"    basic_istream<char_type, traits_type>\x3a\x3aoperator=(_VSTD\x3a\x3amove(__rhs));\x0a"
"    __sb_ = _VSTD\x3a\x3amove(__rhs.__sb_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void basic_istringstream<_CharT, _Traits, _Allocator>\x3a\x3aswap(basic_istringstream\x26 __rhs)\x0a"
"{\x0a"
"    basic_istream<char_type, traits_type>\x3a\x3aswap(__rhs);\x0a"
"    __sb_.swap(__rhs.__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(basic_istringstream<_CharT, _Traits, _Allocator>\x26 __x,\x0a"
"     basic_istringstream<_CharT, _Traits, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>*\x0a"
"basic_istringstream<_CharT, _Traits, _Allocator>\x3a\x3ardbuf() const\x0a"
"{\x0a"
"    return const_cast<basic_stringbuf<char_type, traits_type, allocator_type>*>(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"basic_istringstream<_CharT, _Traits, _Allocator>\x3a\x3astr() const\x0a"
"{\x0a"
"    return __sb_.str();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void basic_istringstream<_CharT, _Traits, _Allocator>\x3a\x3astr(const string_type\x26 __s)\x0a"
"{\x0a"
"    __sb_.str(__s);\x0a"
"}\x0a"
"\x0a"
"// basic_ostringstream\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_ostringstream\x0a"
"    \x3a public basic_ostream<_CharT, _Traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"    typedef _Allocator                     allocator_type;\x0a"
"\x0a"
"    typedef basic_string<char_type, traits_type, allocator_type> string_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    basic_stringbuf<char_type, traits_type, allocator_type> __sb_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // 27.8.2.1 Constructors\x3a\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ostringstream(ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3aout);\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_ostringstream(const string_type\x26 __s,\x0a"
"                                 ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3aout);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_ostringstream(basic_ostringstream\x26\x26 __rhs);\x0a"
"\x0a"
"    // 27.8.2.2 Assign and swap\x3a\x0a"
"    basic_ostringstream\x26 operator=(basic_ostringstream\x26\x26 __rhs);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(basic_ostringstream\x26 __rhs);\x0a"
"\x0a"
"    // 27.8.2.3 Members\x3a\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_stringbuf<char_type, traits_type, allocator_type>* rdbuf() const;\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    string_type str() const;\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    void str(const string_type\x26 __s);\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_ostringstream<_CharT, _Traits, _Allocator>\x3a\x3a""basic_ostringstream(ios_base\x3a\x3aopenmode __wch)\x0a"
"    \x3a basic_ostream<_CharT, _Traits>(\x26__sb_),\x0a"
"      __sb_(__wch \x7c ios_base\x3a\x3aout)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_ostringstream<_CharT, _Traits, _Allocator>\x3a\x3a""basic_ostringstream(const string_type\x26 __s,\x0a"
"                                                                      ios_base\x3a\x3aopenmode __wch)\x0a"
"    \x3a basic_ostream<_CharT, _Traits>(\x26__sb_),\x0a"
"      __sb_(__s, __wch \x7c ios_base\x3a\x3aout)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_ostringstream<_CharT, _Traits, _Allocator>\x3a\x3a""basic_ostringstream(basic_ostringstream\x26\x26 __rhs)\x0a"
"    \x3a basic_ostream<_CharT, _Traits>(_VSTD\x3a\x3amove(__rhs)),\x0a"
"      __sb_(_VSTD\x3a\x3amove(__rhs.__sb_))\x0a"
"{\x0a"
"    basic_ostream<_CharT, _Traits>\x3a\x3aset_rdbuf(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_ostringstream<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_ostringstream<_CharT, _Traits, _Allocator>\x3a\x3aoperator=(basic_ostringstream\x26\x26 __rhs)\x0a"
"{\x0a"
"    basic_ostream<char_type, traits_type>\x3a\x3aoperator=(_VSTD\x3a\x3amove(__rhs));\x0a"
"    __sb_ = _VSTD\x3a\x3amove(__rhs.__sb_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_ostringstream<_CharT, _Traits, _Allocator>\x3a\x3aswap(basic_ostringstream\x26 __rhs)\x0a"
"{\x0a"
"    basic_ostream<char_type, traits_type>\x3a\x3aswap(__rhs);\x0a"
"    __sb_.swap(__rhs.__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(basic_ostringstream<_CharT, _Traits, _Allocator>\x26 __x,\x0a"
"     basic_ostringstream<_CharT, _Traits, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>*\x0a"
"basic_ostringstream<_CharT, _Traits, _Allocator>\x3a\x3ardbuf() const\x0a"
"{\x0a"
"    return const_cast<basic_stringbuf<char_type, traits_type, allocator_type>*>(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"basic_ostringstream<_CharT, _Traits, _Allocator>\x3a\x3astr() const\x0a"
"{\x0a"
"    return __sb_.str();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_ostringstream<_CharT, _Traits, _Allocator>\x3a\x3astr(const string_type\x26 __s)\x0a"
"{\x0a"
"    __sb_.str(__s);\x0a"
"}\x0a"
"\x0a"
"// basic_stringstream\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_stringstream\x0a"
"    \x3a public basic_iostream<_CharT, _Traits>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"    typedef _Allocator                     allocator_type;\x0a"
"\x0a"
"    typedef basic_string<char_type, traits_type, allocator_type> string_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    basic_stringbuf<char_type, traits_type, allocator_type> __sb_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // 27.8.2.1 Constructors\x3a\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_stringstream(ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_stringstream(const string_type\x26 __s,\x0a"
"                                ios_base\x3a\x3aopenmode __wch = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_stringstream(basic_stringstream\x26\x26 __rhs);\x0a"
"\x0a"
"    // 27.8.2.2 Assign and swap\x3a\x0a"
"    basic_stringstream\x26 operator=(basic_stringstream\x26\x26 __rhs);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(basic_stringstream\x26 __rhs);\x0a"
"\x0a"
"    // 27.8.2.3 Members\x3a\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_stringbuf<char_type, traits_type, allocator_type>* rdbuf() const;\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    string_type str() const;\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    void str(const string_type\x26 __s);\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringstream<_CharT, _Traits, _Allocator>\x3a\x3a""basic_stringstream(ios_base\x3a\x3aopenmode __wch)\x0a"
"    \x3a basic_iostream<_CharT, _Traits>(\x26__sb_),\x0a"
"      __sb_(__wch)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringstream<_CharT, _Traits, _Allocator>\x3a\x3a""basic_stringstream(const string_type\x26 __s,\x0a"
"                                                                    ios_base\x3a\x3aopenmode __wch)\x0a"
"    \x3a basic_iostream<_CharT, _Traits>(\x26__sb_),\x0a"
"      __sb_(__s, __wch)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringstream<_CharT, _Traits, _Allocator>\x3a\x3a""basic_stringstream(basic_stringstream\x26\x26 __rhs)\x0a"
"    \x3a basic_iostream<_CharT, _Traits>(_VSTD\x3a\x3amove(__rhs)),\x0a"
"      __sb_(_VSTD\x3a\x3amove(__rhs.__sb_))\x0a"
"{\x0a"
"    basic_istream<_CharT, _Traits>\x3a\x3aset_rdbuf(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringstream<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_stringstream<_CharT, _Traits, _Allocator>\x3a\x3aoperator=(basic_stringstream\x26\x26 __rhs)\x0a"
"{\x0a"
"    basic_iostream<char_type, traits_type>\x3a\x3aoperator=(_VSTD\x3a\x3amove(__rhs));\x0a"
"    __sb_ = _VSTD\x3a\x3amove(__rhs.__sb_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_stringstream<_CharT, _Traits, _Allocator>\x3a\x3aswap(basic_stringstream\x26 __rhs)\x0a"
"{\x0a"
"    basic_iostream<char_type, traits_type>\x3a\x3aswap(__rhs);\x0a"
"    __sb_.swap(__rhs.__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(basic_stringstream<_CharT, _Traits, _Allocator>\x26 __x,\x0a"
"     basic_stringstream<_CharT, _Traits, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_stringbuf<_CharT, _Traits, _Allocator>*\x0a"
"basic_stringstream<_CharT, _Traits, _Allocator>\x3a\x3ardbuf() const\x0a"
"{\x0a"
"    return const_cast<basic_stringbuf<char_type, traits_type, allocator_type>*>(\x26__sb_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"basic_stringstream<_CharT, _Traits, _Allocator>\x3a\x3astr() const\x0a"
"{\x0a"
"    return __sb_.str();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_stringstream<_CharT, _Traits, _Allocator>\x3a\x3astr(const string_type\x26 __s)\x0a"
"{\x0a"
"    __sb_.str(__s);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_SSTREAM\x0a"
"", 33377 ); }