#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_stack( 
"// -*- C++ -*-\x0a"
"//===---------------------------- stack -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_STACK\x0a"
"#define _LIBCPP_STACK\x0a"
"\x0a"
"/*\x0a"
"    stack synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class T, class Container = deque<T>>\x0a"
"class stack\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef Container                                container_type;\x0a"
"    typedef typename container_type\x3a\x3avalue_type      value_type;\x0a"
"    typedef typename container_type\x3a\x3areference       reference;\x0a"
"    typedef typename container_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename container_type\x3a\x3asize_type       size_type;\x0a"
"\x0a"
"protected\x3a\x0a"
"    container_type c;\x0a"
"\x0a"
"public\x3a\x0a"
"    stack() = default;\x0a"
"    \x7estack() = default;\x0a"
"\x0a"
"    stack(const stack\x26 q) = default;\x0a"
"    stack(stack\x26\x26 q) = default;\x0a"
"\x0a"
"    stack\x26 operator=(const stack\x26 q) = default;\x0a"
"    stack\x26 operator=(stack\x26\x26 q) = default;\x0a"
"\x0a"
"    explicit stack(const container_type\x26 c);\x0a"
"    explicit stack(container_type\x26\x26 c);\x0a"
"    template <class Alloc> explicit stack(const Alloc\x26 a);\x0a"
"    template <class Alloc> stack(const container_type\x26 c, const Alloc\x26 a);\x0a"
"    template <class Alloc> stack(container_type\x26\x26 c, const Alloc\x26 a);\x0a"
"    template <class Alloc> stack(const stack\x26 c, const Alloc\x26 a);\x0a"
"    template <class Alloc> stack(stack\x26\x26 c, const Alloc\x26 a);\x0a"
"\x0a"
"    bool empty() const;\x0a"
"    size_type size() const;\x0a"
"    reference top();\x0a"
"    const_reference top() const;\x0a"
"\x0a"
"    void push(const value_type\x26 x);\x0a"
"    void push(value_type\x26\x26 x);\x0a"
"    template <class... Args> reference emplace(Args\x26\x26... args); // reference in C++17\x0a"
"    void pop();\x0a"
"\x0a"
"    void swap(stack\x26 c) noexcept(is_nothrow_swappable_v<Container>)\x0a"
"};\x0a"
"\x0a"
"template<class Container>\x0a"
"  stack(Container) -> stack<typename Container\x3a\x3avalue_type, Container>;  // C++17\x0a"
"\x0a"
"template<class Container, class Allocator>\x0a"
"  stack(Container, Allocator) -> stack<typename Container\x3a\x3avalue_type, Container>; // C++17\x0a"
"\x0a"
"template <class T, class Container>\x0a"
"  bool operator==(const stack<T, Container>\x26 x, const stack<T, Container>\x26 y);\x0a"
"template <class T, class Container>\x0a"
"  bool operator< (const stack<T, Container>\x26 x, const stack<T, Container>\x26 y);\x0a"
"template <class T, class Container>\x0a"
"  bool operator\x21=(const stack<T, Container>\x26 x, const stack<T, Container>\x26 y);\x0a"
"template <class T, class Container>\x0a"
"  bool operator> (const stack<T, Container>\x26 x, const stack<T, Container>\x26 y);\x0a"
"template <class T, class Container>\x0a"
"  bool operator>=(const stack<T, Container>\x26 x, const stack<T, Container>\x26 y);\x0a"
"template <class T, class Container>\x0a"
"  bool operator<=(const stack<T, Container>\x26 x, const stack<T, Container>\x26 y);\x0a"
"\x0a"
"template <class T, class Container>\x0a"
"  void swap(stack<T, Container>\x26 x, stack<T, Container>\x26 y)\x0a"
"  noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <deque>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Tp, class _Container = deque<_Tp> > class _LIBCPP_TEMPLATE_VIS stack;\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const stack<_Tp, _Container>\x26 __x, const stack<_Tp, _Container>\x26 __y);\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const stack<_Tp, _Container>\x26 __x, const stack<_Tp, _Container>\x26 __y);\x0a"
"\x0a"
"template <class _Tp, class _Container /*= deque<_Tp>*/>\x0a"
"class _LIBCPP_TEMPLATE_VIS stack\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Container                               container_type;\x0a"
"    typedef typename container_type\x3a\x3avalue_type      value_type;\x0a"
"    typedef typename container_type\x3a\x3areference       reference;\x0a"
"    typedef typename container_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename container_type\x3a\x3asize_type       size_type;\x0a"
"    static_assert((is_same<_Tp, value_type>\x3a\x3avalue), \x22\x22 );\x0a"
"\x0a"
"protected\x3a\x0a"
"    container_type c;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    stack()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<container_type>\x3a\x3avalue)\x0a"
"        \x3a c() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    stack(const stack\x26 __q) \x3a c(__q.c) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    stack\x26 operator=(const stack\x26 __q) {c = __q.c; return *this;}\x0a"
"\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    stack(stack\x26\x26 __q)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<container_type>\x3a\x3avalue)\x0a"
"        \x3a c(_VSTD\x3a\x3amove(__q.c)) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    stack\x26 operator=(stack\x26\x26 __q)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<container_type>\x3a\x3avalue)\x0a"
"        {c = _VSTD\x3a\x3amove(__q.c); return *this;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit stack(container_type\x26\x26 __c) \x3a c(_VSTD\x3a\x3amove(__c)) {}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit stack(const container_type\x26 __c) \x3a c(__c) {}\x0a"
"\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit stack(const _Alloc\x26 __a,\x0a"
"                       typename enable_if<uses_allocator<container_type,\x0a"
"                                                         _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"            \x3a c(__a) {}\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        stack(const container_type\x26 __c, const _Alloc\x26 __a,\x0a"
"              typename enable_if<uses_allocator<container_type,\x0a"
"                                                _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"            \x3a c(__c, __a) {}\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        stack(const stack\x26 __s, const _Alloc\x26 __a,\x0a"
"              typename enable_if<uses_allocator<container_type,\x0a"
"                                                _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"            \x3a c(__s.c, __a) {}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        stack(container_type\x26\x26 __c, const _Alloc\x26 __a,\x0a"
"              typename enable_if<uses_allocator<container_type,\x0a"
"                                                _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"            \x3a c(_VSTD\x3a\x3amove(__c), __a) {}\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        stack(stack\x26\x26 __s, const _Alloc\x26 __a,\x0a"
"              typename enable_if<uses_allocator<container_type,\x0a"
"                                                _Alloc>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"            \x3a c(_VSTD\x3a\x3amove(__s.c), __a) {}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty()     const      {return c.empty();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const      {return c.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference top()             {return c.back();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference top() const {return c.back();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void push(const value_type\x26 __v) {c.push_back(__v);}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void push(value_type\x26\x26 __v) {c.push_back(_VSTD\x3a\x3amove(__v));}\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        decltype(auto) emplace(_Args\x26\x26... __args)\x0a"
"        { return c.emplace_back(_VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"#else\x0a"
"        void      emplace(_Args\x26\x26... __args)\x0a"
"        {        c.emplace_back(_VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"#endif\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void pop() {c.pop_back();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(stack\x26 __s)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<container_type>\x3a\x3avalue)\x0a"
"    {\x0a"
"        using _VSTD\x3a\x3aswap;\x0a"
"        swap(c, __s.c);\x0a"
"    }\x0a"
"\x0a"
"    template <class T1, class _C1>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator==(const stack<T1, _C1>\x26 __x, const stack<T1, _C1>\x26 __y);\x0a"
"\x0a"
"    template <class T1, class _C1>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator< (const stack<T1, _C1>\x26 __x, const stack<T1, _C1>\x26 __y);\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _Container,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Container>\x3a\x3avalue, nullptr_t>\x3a\x3atype\x0a"
">\x0a"
"stack(_Container)\x0a"
"    -> stack<typename _Container\x3a\x3avalue_type, _Container>;\x0a"
"\x0a"
"template<class _Container,\x0a"
"         class _Alloc,\x0a"
"         class = typename enable_if<\x21__is_allocator<_Container>\x3a\x3avalue, nullptr_t>\x3a\x3atype,\x0a"
"         class = typename enable_if< __is_allocator<_Alloc>\x3a\x3avalue, nullptr_t>\x3a\x3atype\x0a"
"         >\x0a"
"stack(_Container, _Alloc)\x0a"
"    -> stack<typename _Container\x3a\x3avalue_type, _Container>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const stack<_Tp, _Container>\x26 __x, const stack<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return __x.c == __y.c;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const stack<_Tp, _Container>\x26 __x, const stack<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return __x.c < __y.c;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const stack<_Tp, _Container>\x26 __x, const stack<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const stack<_Tp, _Container>\x26 __x, const stack<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const stack<_Tp, _Container>\x26 __x, const stack<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const stack<_Tp, _Container>\x26 __x, const stack<_Tp, _Container>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if<\x0a"
"    __is_swappable<_Container>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"swap(stack<_Tp, _Container>\x26 __x, stack<_Tp, _Container>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Container, class _Alloc>\x0a"
"struct _LIBCPP_TEMPLATE_VIS uses_allocator<stack<_Tp, _Container>, _Alloc>\x0a"
"    \x3a public uses_allocator<_Container, _Alloc>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_STACK\x0a"
"", 10092 ); }