#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_stdexcept( 
"// -*- C++ -*-\x0a"
"//===--------------------------- stdexcept --------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_STDEXCEPT\x0a"
"#define _LIBCPP_STDEXCEPT\x0a"
"\x0a"
"/*\x0a"
"    stdexcept synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"class logic_error;\x0a"
"    class domain_error;\x0a"
"    class invalid_argument;\x0a"
"    class length_error;\x0a"
"    class out_of_range;\x0a"
"class runtime_error;\x0a"
"    class range_error;\x0a"
"    class overflow_error;\x0a"
"    class underflow_error;\x0a"
"\x0a"
"for each class xxx_error\x3a\x0a"
"\x0a"
"class xxx_error \x3a public exception // at least indirectly\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit xxx_error(const string\x26 what_arg);\x0a"
"    explicit xxx_error(const char*   what_arg);\x0a"
"\x0a"
"    virtual const char* what() const noexcept // returns what_arg\x0a"
"};\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <exception>\x0a"
"#include <iosfwd>  // for string forward decl\x0a"
"#ifdef _LIBCPP_NO_EXCEPTIONS\x0a"
"#include <cstdlib>\x0a"
"#endif\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#ifndef _LIBCPP_ABI_VCRUNTIME\x0a"
"class _LIBCPP_HIDDEN __libcpp_refstring\x0a"
"{\x0a"
"    const char* __imp_;\x0a"
"\x0a"
"    bool __uses_refcount() const;\x0a"
"public\x3a\x0a"
"    explicit __libcpp_refstring(const char* __msg);\x0a"
"    __libcpp_refstring(const __libcpp_refstring\x26 __s) _NOEXCEPT;\x0a"
"    __libcpp_refstring\x26 operator=(const __libcpp_refstring\x26 __s) _NOEXCEPT;\x0a"
"    \x7e__libcpp_refstring();\x0a"
"\x0a"
"    const char* c_str() const _NOEXCEPT {return __imp_;}\x0a"
"};\x0a"
"#endif // \x21_LIBCPP_ABI_VCRUNTIME\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"namespace std  // purposefully not using versioning namespace\x0a"
"{\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI logic_error\x0a"
"    \x3a public exception\x0a"
"{\x0a"
"#ifndef _LIBCPP_ABI_VCRUNTIME\x0a"
"private\x3a\x0a"
"    _VSTD\x3a\x3a__libcpp_refstring __imp_;\x0a"
"public\x3a\x0a"
"    explicit logic_error(const string\x26);\x0a"
"    explicit logic_error(const char*);\x0a"
"\x0a"
"    logic_error(const logic_error\x26) _NOEXCEPT;\x0a"
"    logic_error\x26 operator=(const logic_error\x26) _NOEXCEPT;\x0a"
"\x0a"
"    virtual \x7elogic_error() _NOEXCEPT;\x0a"
"\x0a"
"    virtual const char* what() const _NOEXCEPT;\x0a"
"#else\x0a"
"public\x3a\x0a"
"    explicit logic_error(const _VSTD\x3a\x3astring\x26); // Symbol uses versioned std\x3a\x3astring\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit logic_error(const char* __s) \x3a exception(__s) {}\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI runtime_error\x0a"
"    \x3a public exception\x0a"
"{\x0a"
"#ifndef _LIBCPP_ABI_VCRUNTIME\x0a"
"private\x3a\x0a"
"    _VSTD\x3a\x3a__libcpp_refstring __imp_;\x0a"
"public\x3a\x0a"
"    explicit runtime_error(const string\x26);\x0a"
"    explicit runtime_error(const char*);\x0a"
"\x0a"
"    runtime_error(const runtime_error\x26) _NOEXCEPT;\x0a"
"    runtime_error\x26 operator=(const runtime_error\x26) _NOEXCEPT;\x0a"
"\x0a"
"    virtual \x7eruntime_error() _NOEXCEPT;\x0a"
"\x0a"
"    virtual const char* what() const _NOEXCEPT;\x0a"
"#else\x0a"
"public\x3a\x0a"
"   explicit runtime_error(const _VSTD\x3a\x3astring\x26); // Symbol uses versioned std\x3a\x3astring\x0a"
"   _LIBCPP_INLINE_VISIBILITY explicit runtime_error(const char* __s) \x3a exception(__s) {}\x0a"
"#endif // _LIBCPP_ABI_VCRUNTIME\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI domain_error\x0a"
"    \x3a public logic_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit domain_error(const string\x26 __s) \x3a logic_error(__s) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit domain_error(const char* __s)   \x3a logic_error(__s) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_ABI_VCRUNTIME\x0a"
"    virtual \x7e""domain_error() _NOEXCEPT;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI invalid_argument\x0a"
"    \x3a public logic_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit invalid_argument(const string\x26 __s) \x3a logic_error(__s) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit invalid_argument(const char* __s)   \x3a logic_error(__s) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_ABI_VCRUNTIME\x0a"
"    virtual \x7einvalid_argument() _NOEXCEPT;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI length_error\x0a"
"    \x3a public logic_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit length_error(const string\x26 __s) \x3a logic_error(__s) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit length_error(const char* __s)   \x3a logic_error(__s) {}\x0a"
"#ifndef _LIBCPP_ABI_VCRUNTIME\x0a"
"    virtual \x7elength_error() _NOEXCEPT;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI out_of_range\x0a"
"    \x3a public logic_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit out_of_range(const string\x26 __s) \x3a logic_error(__s) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit out_of_range(const char* __s)   \x3a logic_error(__s) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_ABI_VCRUNTIME\x0a"
"    virtual \x7eout_of_range() _NOEXCEPT;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI range_error\x0a"
"    \x3a public runtime_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit range_error(const string\x26 __s) \x3a runtime_error(__s) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit range_error(const char* __s)   \x3a runtime_error(__s) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_ABI_VCRUNTIME\x0a"
"    virtual \x7erange_error() _NOEXCEPT;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI overflow_error\x0a"
"    \x3a public runtime_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit overflow_error(const string\x26 __s) \x3a runtime_error(__s) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit overflow_error(const char* __s)   \x3a runtime_error(__s) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_ABI_VCRUNTIME\x0a"
"    virtual \x7eoverflow_error() _NOEXCEPT;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI underflow_error\x0a"
"    \x3a public runtime_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit underflow_error(const string\x26 __s) \x3a runtime_error(__s) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit underflow_error(const char* __s)   \x3a runtime_error(__s) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_ABI_VCRUNTIME\x0a"
"    virtual \x7eunderflow_error() _NOEXCEPT;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// in the dylib\x0a"
"_LIBCPP_NORETURN _LIBCPP_FUNC_VIS void __throw_runtime_error(const char*);\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_logic_error(const char*__msg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw logic_error(__msg);\x0a"
"#else\x0a"
"    ((void)__msg);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_domain_error(const char*__msg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw domain_error(__msg);\x0a"
"#else\x0a"
"    ((void)__msg);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_invalid_argument(const char*__msg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw invalid_argument(__msg);\x0a"
"#else\x0a"
"    ((void)__msg);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_length_error(const char*__msg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw length_error(__msg);\x0a"
"#else\x0a"
"    ((void)__msg);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_out_of_range(const char*__msg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw out_of_range(__msg);\x0a"
"#else\x0a"
"    ((void)__msg);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_range_error(const char*__msg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw range_error(__msg);\x0a"
"#else\x0a"
"    ((void)__msg);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_overflow_error(const char*__msg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw overflow_error(__msg);\x0a"
"#else\x0a"
"    ((void)__msg);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_underflow_error(const char*__msg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw underflow_error(__msg);\x0a"
"#else\x0a"
"    ((void)__msg);\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_STDEXCEPT\x0a"
"", 7413 ); }