#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_stdint_h( 
"// -*- C++ -*-\x0a"
"//===---------------------------- stdint.h --------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_STDINT_H\x0a"
"// AIX system headers need stdint.h to be re-enterable while _STD_TYPES_T\x0a"
"// is defined until an inclusion of it without _STD_TYPES_T occurs, in which\x0a"
"// case the header guard macro is defined.\x0a"
"#if \x21""defined(_AIX) \x7c\x7c \x21""defined(_STD_TYPES_T)\x0a"
"#define _LIBCPP_STDINT_H\x0a"
"#endif // _STD_TYPES_T\x0a"
"\x0a"
"/*\x0a"
"    stdint.h synopsis\x0a"
"\x0a"
"Macros\x3a\x0a"
"\x0a"
"    INT8_MIN\x0a"
"    INT16_MIN\x0a"
"    INT32_MIN\x0a"
"    INT64_MIN\x0a"
"\x0a"
"    INT8_MAX\x0a"
"    INT16_MAX\x0a"
"    INT32_MAX\x0a"
"    INT64_MAX\x0a"
"\x0a"
"    UINT8_MAX\x0a"
"    UINT16_MAX\x0a"
"    UINT32_MAX\x0a"
"    UINT64_MAX\x0a"
"\x0a"
"    INT_LEAST8_MIN\x0a"
"    INT_LEAST16_MIN\x0a"
"    INT_LEAST32_MIN\x0a"
"    INT_LEAST64_MIN\x0a"
"\x0a"
"    INT_LEAST8_MAX\x0a"
"    INT_LEAST16_MAX\x0a"
"    INT_LEAST32_MAX\x0a"
"    INT_LEAST64_MAX\x0a"
"\x0a"
"    UINT_LEAST8_MAX\x0a"
"    UINT_LEAST16_MAX\x0a"
"    UINT_LEAST32_MAX\x0a"
"    UINT_LEAST64_MAX\x0a"
"\x0a"
"    INT_FAST8_MIN\x0a"
"    INT_FAST16_MIN\x0a"
"    INT_FAST32_MIN\x0a"
"    INT_FAST64_MIN\x0a"
"\x0a"
"    INT_FAST8_MAX\x0a"
"    INT_FAST16_MAX\x0a"
"    INT_FAST32_MAX\x0a"
"    INT_FAST64_MAX\x0a"
"\x0a"
"    UINT_FAST8_MAX\x0a"
"    UINT_FAST16_MAX\x0a"
"    UINT_FAST32_MAX\x0a"
"    UINT_FAST64_MAX\x0a"
"\x0a"
"    INTPTR_MIN\x0a"
"    INTPTR_MAX\x0a"
"    UINTPTR_MAX\x0a"
"\x0a"
"    INTMAX_MIN\x0a"
"    INTMAX_MAX\x0a"
"\x0a"
"    UINTMAX_MAX\x0a"
"\x0a"
"    PTRDIFF_MIN\x0a"
"    PTRDIFF_MAX\x0a"
"\x0a"
"    SIG_ATOMIC_MIN\x0a"
"    SIG_ATOMIC_MAX\x0a"
"\x0a"
"    SIZE_MAX\x0a"
"\x0a"
"    WCHAR_MIN\x0a"
"    WCHAR_MAX\x0a"
"\x0a"
"    WINT_MIN\x0a"
"    WINT_MAX\x0a"
"\x0a"
"    INT8_C(value)\x0a"
"    INT16_C(value)\x0a"
"    INT32_C(value)\x0a"
"    INT64_C(value)\x0a"
"\x0a"
"    UINT8_C(value)\x0a"
"    UINT16_C(value)\x0a"
"    UINT32_C(value)\x0a"
"    UINT64_C(value)\x0a"
"\x0a"
"    INTMAX_C(value)\x0a"
"    UINTMAX_C(value)\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"/* C99 stdlib (e.g. glibc < 2.18) does not provide macros needed\x0a"
"   for C++11 unless __STDC_LIMIT_MACROS and __STDC_CONSTANT_MACROS\x0a"
"   are defined\x0a"
"*/\x0a"
"#if defined(__cplusplus) \x26\x26 \x21""defined(__STDC_LIMIT_MACROS)\x0a"
"#   define __STDC_LIMIT_MACROS\x0a"
"#endif\x0a"
"#if defined(__cplusplus) \x26\x26 \x21""defined(__STDC_CONSTANT_MACROS)\x0a"
"#   define __STDC_CONSTANT_MACROS\x0a"
"#endif\x0a"
"\x0a"
"#include_next <stdint.h>\x0a"
"\x0a"
"#endif  // _LIBCPP_STDINT_H\x0a"
"", 2328 ); }