#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_streambuf( 
"// -*- C++ -*-\x0a"
"//===------------------------- streambuf ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_STEAMBUF\x0a"
"#define _LIBCPP_STEAMBUF\x0a"
"\x0a"
"/*\x0a"
"    streambuf synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class charT, class traits = char_traits<charT> >\x0a"
"class basic_streambuf\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef charT char_type;\x0a"
"    typedef traits traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    virtual \x7e""basic_streambuf();\x0a"
"\x0a"
"    // 27.6.2.2.1 locales\x3a\x0a"
"    locale pubimbue(const locale\x26 loc);\x0a"
"    locale getloc() const;\x0a"
"\x0a"
"    // 27.6.2.2.2 buffer and positioning\x3a\x0a"
"    basic_streambuf* pubsetbuf(char_type* s, streamsize n);\x0a"
"    pos_type pubseekoff(off_type off, ios_base\x3a\x3aseekdir way,\x0a"
"                        ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    pos_type pubseekpos(pos_type sp,\x0a"
"                        ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    int pubsync();\x0a"
"\x0a"
"    // Get and put areas\x3a\x0a"
"    // 27.6.2.2.3 Get area\x3a\x0a"
"    streamsize in_avail();\x0a"
"    int_type snextc();\x0a"
"    int_type sbumpc();\x0a"
"    int_type sgetc();\x0a"
"    streamsize sgetn(char_type* s, streamsize n);\x0a"
"\x0a"
"    // 27.6.2.2.4 Putback\x3a\x0a"
"    int_type sputbackc(char_type c);\x0a"
"    int_type sungetc();\x0a"
"\x0a"
"    // 27.6.2.2.5 Put area\x3a\x0a"
"    int_type sputc(char_type c);\x0a"
"    streamsize sputn(const char_type* s, streamsize n);\x0a"
"\x0a"
"protected\x3a\x0a"
"    basic_streambuf();\x0a"
"    basic_streambuf(const basic_streambuf\x26 rhs);\x0a"
"    basic_streambuf\x26 operator=(const basic_streambuf\x26 rhs);\x0a"
"    void swap(basic_streambuf\x26 rhs);\x0a"
"\x0a"
"    // 27.6.2.3.2 Get area\x3a\x0a"
"    char_type* eback() const;\x0a"
"    char_type* gptr() const;\x0a"
"    char_type* egptr() const;\x0a"
"    void gbump(int n);\x0a"
"    void setg(char_type* gbeg, char_type* gnext, char_type* gend);\x0a"
"\x0a"
"    // 27.6.2.3.3 Put area\x3a\x0a"
"    char_type* pbase() const;\x0a"
"    char_type* pptr() const;\x0a"
"    char_type* epptr() const;\x0a"
"    void pbump(int n);\x0a"
"    void setp(char_type* pbeg, char_type* pend);\x0a"
"\x0a"
"    // 27.6.2.4 virtual functions\x3a\x0a"
"    // 27.6.2.4.1 Locales\x3a\x0a"
"    virtual void imbue(const locale\x26 loc);\x0a"
"\x0a"
"    // 27.6.2.4.2 Buffer management and positioning\x3a\x0a"
"    virtual basic_streambuf* setbuf(char_type* s, streamsize n);\x0a"
"    virtual pos_type seekoff(off_type off, ios_base\x3a\x3aseekdir way,\x0a"
"                             ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual pos_type seekpos(pos_type sp,\x0a"
"                             ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual int sync();\x0a"
"\x0a"
"    // 27.6.2.4.3 Get area\x3a\x0a"
"    virtual streamsize showmanyc();\x0a"
"    virtual streamsize xsgetn(char_type* s, streamsize n);\x0a"
"    virtual int_type underflow();\x0a"
"    virtual int_type uflow();\x0a"
"\x0a"
"    // 27.6.2.4.4 Putback\x3a\x0a"
"    virtual int_type pbackfail(int_type c = traits_type\x3a\x3a""eof());\x0a"
"\x0a"
"    // 27.6.2.4.5 Put area\x3a\x0a"
"    virtual streamsize xsputn(const char_type* s, streamsize n);\x0a"
"    virtual int_type overflow (int_type c = traits_type\x3a\x3a""eof());\x0a"
"};\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <iosfwd>\x0a"
"#include <ios>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_streambuf\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef _CharT                         char_type;\x0a"
"    typedef _Traits                        traits_type;\x0a"
"    typedef typename traits_type\x3a\x3aint_type int_type;\x0a"
"    typedef typename traits_type\x3a\x3apos_type pos_type;\x0a"
"    typedef typename traits_type\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    static_assert((is_same<_CharT, typename traits_type\x3a\x3a""char_type>\x3a\x3avalue),\x0a"
"                  \x22traits_type\x3a\x3a""char_type must be the same type as CharT\x22);\x0a"
"\x0a"
"    virtual \x7e""basic_streambuf();\x0a"
"\x0a"
"    // 27.6.2.2.1 locales\x3a\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    locale pubimbue(const locale\x26 __loc) {\x0a"
"        imbue(__loc);\x0a"
"        locale __r = __loc_;\x0a"
"        __loc_ = __loc;\x0a"
"        return __r;\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    locale getloc() const { return __loc_; }\x0a"
"\x0a"
"    // 27.6.2.2.2 buffer and positioning\x3a\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    basic_streambuf* pubsetbuf(char_type* __s, streamsize __n)\x0a"
"    { return setbuf(__s, __n); }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    pos_type pubseekoff(off_type __off, ios_base\x3a\x3aseekdir __way,\x0a"
"                        ios_base\x3a\x3aopenmode __which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout)\x0a"
"    { return seekoff(__off, __way, __which); }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    pos_type pubseekpos(pos_type __sp,\x0a"
"                        ios_base\x3a\x3aopenmode __which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout)\x0a"
"    { return seekpos(__sp, __which); }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    int pubsync() { return sync(); }\x0a"
"\x0a"
"    // Get and put areas\x3a\x0a"
"    // 27.6.2.2.3 Get area\x3a\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    streamsize in_avail() {\x0a"
"        if (__ninp_ < __einp_)\x0a"
"            return static_cast<streamsize>(__einp_ - __ninp_);\x0a"
"        return showmanyc();\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    int_type snextc() {\x0a"
"        if (sbumpc() == traits_type\x3a\x3a""eof())\x0a"
"            return traits_type\x3a\x3a""eof();\x0a"
"        return sgetc();\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    int_type sbumpc() {\x0a"
"        if (__ninp_ == __einp_)\x0a"
"            return uflow();\x0a"
"        return traits_type\x3a\x3ato_int_type(*__ninp_++);\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    int_type sgetc() {\x0a"
"        if (__ninp_ == __einp_)\x0a"
"            return underflow();\x0a"
"        return traits_type\x3a\x3ato_int_type(*__ninp_);\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    streamsize sgetn(char_type* __s, streamsize __n)\x0a"
"    { return xsgetn(__s, __n); }\x0a"
"\x0a"
"    // 27.6.2.2.4 Putback\x3a\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    int_type sputbackc(char_type __c) {\x0a"
"        if (__binp_ == __ninp_ \x7c\x7c \x21traits_type\x3a\x3a""eq(__c, __ninp_\x5b-1\x5d))\x0a"
"            return pbackfail(traits_type\x3a\x3ato_int_type(__c));\x0a"
"        return traits_type\x3a\x3ato_int_type(*--__ninp_);\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    int_type sungetc() {\x0a"
"        if (__binp_ == __ninp_)\x0a"
"          return pbackfail();\x0a"
"        return traits_type\x3a\x3ato_int_type(*--__ninp_);\x0a"
"    }\x0a"
"\x0a"
"    // 27.6.2.2.5 Put area\x3a\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    int_type sputc(char_type __c) {\x0a"
"        if (__nout_ == __eout_)\x0a"
"            return overflow(traits_type\x3a\x3ato_int_type(__c));\x0a"
"        *__nout_++ = __c;\x0a"
"        return traits_type\x3a\x3ato_int_type(__c);\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    streamsize sputn(const char_type* __s, streamsize __n)\x0a"
"    { return xsputn(__s, __n); }\x0a"
"\x0a"
"protected\x3a\x0a"
"    basic_streambuf();\x0a"
"    basic_streambuf(const basic_streambuf\x26 __rhs);\x0a"
"    basic_streambuf\x26 operator=(const basic_streambuf\x26 __rhs);\x0a"
"    void swap(basic_streambuf\x26 __rhs);\x0a"
"\x0a"
"    // 27.6.2.3.2 Get area\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY char_type* eback() const {return __binp_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY char_type* gptr()  const {return __ninp_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY char_type* egptr() const {return __einp_;}\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    void gbump(int __n) { __ninp_ += __n; }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    void setg(char_type* __gbeg, char_type* __gnext, char_type* __gend) {\x0a"
"        __binp_ = __gbeg;\x0a"
"        __ninp_ = __gnext;\x0a"
"        __einp_ = __gend;\x0a"
"    }\x0a"
"\x0a"
"    // 27.6.2.3.3 Put area\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY char_type* pbase() const {return __bout_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY char_type* pptr()  const {return __nout_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY char_type* epptr() const {return __eout_;}\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    void pbump(int __n) { __nout_ += __n; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __pbump(streamsize __n) { __nout_ += __n; }\x0a"
"\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    void setp(char_type* __pbeg, char_type* __pend) {\x0a"
"        __bout_ = __nout_ = __pbeg;\x0a"
"        __eout_ = __pend;\x0a"
"    }\x0a"
"\x0a"
"    // 27.6.2.4 virtual functions\x3a\x0a"
"    // 27.6.2.4.1 Locales\x3a\x0a"
"    virtual void imbue(const locale\x26 __loc);\x0a"
"\x0a"
"    // 27.6.2.4.2 Buffer management and positioning\x3a\x0a"
"    virtual basic_streambuf* setbuf(char_type* __s, streamsize __n);\x0a"
"    virtual pos_type seekoff(off_type __off, ios_base\x3a\x3aseekdir __way,\x0a"
"                             ios_base\x3a\x3aopenmode __which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual pos_type seekpos(pos_type __sp,\x0a"
"                             ios_base\x3a\x3aopenmode __which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual int sync();\x0a"
"\x0a"
"    // 27.6.2.4.3 Get area\x3a\x0a"
"    virtual streamsize showmanyc();\x0a"
"    virtual streamsize xsgetn(char_type* __s, streamsize __n);\x0a"
"    virtual int_type underflow();\x0a"
"    virtual int_type uflow();\x0a"
"\x0a"
"    // 27.6.2.4.4 Putback\x3a\x0a"
"    virtual int_type pbackfail(int_type __c = traits_type\x3a\x3a""eof());\x0a"
"\x0a"
"    // 27.6.2.4.5 Put area\x3a\x0a"
"    virtual streamsize xsputn(const char_type* __s, streamsize __n);\x0a"
"    virtual int_type overflow(int_type __c = traits_type\x3a\x3a""eof());\x0a"
"\x0a"
"private\x3a\x0a"
"    locale __loc_;\x0a"
"    char_type* __binp_;\x0a"
"    char_type* __ninp_;\x0a"
"    char_type* __einp_;\x0a"
"    char_type* __bout_;\x0a"
"    char_type* __nout_;\x0a"
"    char_type* __eout_;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3a\x7e""basic_streambuf()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3a""basic_streambuf()\x0a"
"    \x3a __binp_(0),\x0a"
"      __ninp_(0),\x0a"
"      __einp_(0),\x0a"
"      __bout_(0),\x0a"
"      __nout_(0),\x0a"
"      __eout_(0)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3a""basic_streambuf(const basic_streambuf\x26 __sb)\x0a"
"    \x3a __loc_(__sb.__loc_),\x0a"
"      __binp_(__sb.__binp_),\x0a"
"      __ninp_(__sb.__ninp_),\x0a"
"      __einp_(__sb.__einp_),\x0a"
"      __bout_(__sb.__bout_),\x0a"
"      __nout_(__sb.__nout_),\x0a"
"      __eout_(__sb.__eout_)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_streambuf<_CharT, _Traits>\x26\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3aoperator=(const basic_streambuf\x26 __sb)\x0a"
"{\x0a"
"    __loc_ = __sb.__loc_;\x0a"
"    __binp_ = __sb.__binp_;\x0a"
"    __ninp_ = __sb.__ninp_;\x0a"
"    __einp_ = __sb.__einp_;\x0a"
"    __bout_ = __sb.__bout_;\x0a"
"    __nout_ = __sb.__nout_;\x0a"
"    __eout_ = __sb.__eout_;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3aswap(basic_streambuf\x26 __sb)\x0a"
"{\x0a"
"    _VSTD\x3a\x3aswap(__loc_, __sb.__loc_);\x0a"
"    _VSTD\x3a\x3aswap(__binp_, __sb.__binp_);\x0a"
"    _VSTD\x3a\x3aswap(__ninp_, __sb.__ninp_);\x0a"
"    _VSTD\x3a\x3aswap(__einp_, __sb.__einp_);\x0a"
"    _VSTD\x3a\x3aswap(__bout_, __sb.__bout_);\x0a"
"    _VSTD\x3a\x3aswap(__nout_, __sb.__nout_);\x0a"
"    _VSTD\x3a\x3aswap(__eout_, __sb.__eout_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3aimbue(const locale\x26)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_streambuf<_CharT, _Traits>*\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3asetbuf(char_type*, streamsize)\x0a"
"{\x0a"
"    return this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_streambuf<_CharT, _Traits>\x3a\x3apos_type\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3aseekoff(off_type, ios_base\x3a\x3aseekdir,\x0a"
"                                          ios_base\x3a\x3aopenmode)\x0a"
"{\x0a"
"    return pos_type(off_type(-1));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_streambuf<_CharT, _Traits>\x3a\x3apos_type\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3aseekpos(pos_type, ios_base\x3a\x3aopenmode)\x0a"
"{\x0a"
"    return pos_type(off_type(-1));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"int\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3async()\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"streamsize\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3ashowmanyc()\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"streamsize\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3axsgetn(char_type* __s, streamsize __n)\x0a"
"{\x0a"
"    const int_type __eof = traits_type\x3a\x3a""eof();\x0a"
"    int_type __c;\x0a"
"    streamsize __i = 0;\x0a"
"    while(__i < __n)\x0a"
"    {\x0a"
"        if (__ninp_ < __einp_)\x0a"
"        {\x0a"
"            const streamsize __len = _VSTD\x3a\x3amin(static_cast<streamsize>(INT_MAX),\x0a"
"                                _VSTD\x3a\x3amin(__einp_ - __ninp_, __n - __i));\x0a"
"            traits_type\x3a\x3a""copy(__s, __ninp_, __len);\x0a"
"            __s +=  __len;\x0a"
"            __i +=  __len;\x0a"
"            this->gbump(__len);\x0a"
"        }\x0a"
"        else if ((__c = uflow()) \x21= __eof)\x0a"
"        {\x0a"
"            *__s = traits_type\x3a\x3ato_char_type(__c);\x0a"
"            ++__s;\x0a"
"            ++__i;\x0a"
"        }\x0a"
"        else\x0a"
"            break;\x0a"
"    }\x0a"
"    return __i;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_streambuf<_CharT, _Traits>\x3a\x3aint_type\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3aunderflow()\x0a"
"{\x0a"
"    return traits_type\x3a\x3a""eof();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_streambuf<_CharT, _Traits>\x3a\x3aint_type\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3auflow()\x0a"
"{\x0a"
"    if (underflow() == traits_type\x3a\x3a""eof())\x0a"
"        return traits_type\x3a\x3a""eof();\x0a"
"    return traits_type\x3a\x3ato_int_type(*__ninp_++);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_streambuf<_CharT, _Traits>\x3a\x3aint_type\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3apbackfail(int_type)\x0a"
"{\x0a"
"    return traits_type\x3a\x3a""eof();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"streamsize\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3axsputn(const char_type* __s, streamsize __n)\x0a"
"{\x0a"
"    streamsize __i = 0;\x0a"
"    int_type __eof = traits_type\x3a\x3a""eof();\x0a"
"    while( __i < __n)\x0a"
"    {\x0a"
"        if (__nout_ >= __eout_)\x0a"
"        {\x0a"
"            if (overflow(traits_type\x3a\x3ato_int_type(*__s)) == __eof)\x0a"
"                break;\x0a"
"            ++__s;\x0a"
"            ++__i;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            streamsize __chunk_size = _VSTD\x3a\x3amin(__eout_ - __nout_, __n - __i);\x0a"
"            traits_type\x3a\x3a""copy(__nout_, __s, __chunk_size);\x0a"
"            __nout_ += __chunk_size;\x0a"
"            __s     += __chunk_size;\x0a"
"            __i     += __chunk_size;\x0a"
"        }\x0a"
"    }\x0a"
"    return __i;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"typename basic_streambuf<_CharT, _Traits>\x3a\x3aint_type\x0a"
"basic_streambuf<_CharT, _Traits>\x3a\x3aoverflow(int_type)\x0a"
"{\x0a"
"    return traits_type\x3a\x3a""eof();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_DO_NOT_ASSUME_STREAMS_EXPLICIT_INSTANTIATION_IN_DYLIB\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_streambuf<char>)\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_streambuf<wchar_t>)\x0a"
"\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_ios<char>)\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_ios<wchar_t>)\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_STEAMBUF\x0a"
"", 14516 ); }