#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_string_h( 
"// -*- C++ -*-\x0a"
"//===--------------------------- string.h ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_STRING_H\x0a"
"#define _LIBCPP_STRING_H\x0a"
"\x0a"
"/*\x0a"
"    string.h synopsis\x0a"
"\x0a"
"Macros\x3a\x0a"
"\x0a"
"    NULL\x0a"
"\x0a"
"Types\x3a\x0a"
"\x0a"
"    size_t\x0a"
"\x0a"
"void* memcpy(void* restrict s1, const void* restrict s2, size_t n);\x0a"
"void* memmove(void* s1, const void* s2, size_t n);\x0a"
"char* strcpy (char* restrict s1, const char* restrict s2);\x0a"
"char* strncpy(char* restrict s1, const char* restrict s2, size_t n);\x0a"
"char* strcat (char* restrict s1, const char* restrict s2);\x0a"
"char* strncat(char* restrict s1, const char* restrict s2, size_t n);\x0a"
"int memcmp(const void* s1, const void* s2, size_t n);\x0a"
"int strcmp (const char* s1, const char* s2);\x0a"
"int strncmp(const char* s1, const char* s2, size_t n);\x0a"
"int strcoll(const char* s1, const char* s2);\x0a"
"size_t strxfrm(char* restrict s1, const char* restrict s2, size_t n);\x0a"
"const void* memchr(const void* s, int c, size_t n);\x0a"
"      void* memchr(      void* s, int c, size_t n);\x0a"
"const char* strchr(const char* s, int c);\x0a"
"      char* strchr(      char* s, int c);\x0a"
"size_t strcspn(const char* s1, const char* s2);\x0a"
"const char* strpbrk(const char* s1, const char* s2);\x0a"
"      char* strpbrk(      char* s1, const char* s2);\x0a"
"const char* strrchr(const char* s, int c);\x0a"
"      char* strrchr(      char* s, int c);\x0a"
"size_t strspn(const char* s1, const char* s2);\x0a"
"const char* strstr(const char* s1, const char* s2);\x0a"
"      char* strstr(      char* s1, const char* s2);\x0a"
"char* strtok(char* restrict s1, const char* restrict s2);\x0a"
"void* memset(void* s, int c, size_t n);\x0a"
"char* strerror(int errnum);\x0a"
"size_t strlen(const char* s);\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#include_next <string.h>\x0a"
"\x0a"
"// MSVCRT, GNU libc and its derivates may already have the correct prototype in\x0a"
"// <string.h>. This macro can be defined by users if their C library provides\x0a"
"// the right signature.\x0a"
"#if defined(__CORRECT_ISO_CPP_STRING_H_PROTO) \x7c\x7c defined(_LIBCPP_MSVCRT) \x7c\x7c \x5c\x0a"
"    defined(__sun__) \x7c\x7c defined(_STRING_H_CPLUSPLUS_98_CONFORMANCE_)\x0a"
"#define _LIBCPP_STRING_H_HAS_CONST_OVERLOADS\x0a"
"#endif\x0a"
"\x0a"
"#if defined(__cplusplus) \x26\x26 \x21""defined(_LIBCPP_STRING_H_HAS_CONST_OVERLOADS) \x26\x26 defined(_LIBCPP_PREFERRED_OVERLOAD)\x0a"
"extern \x22""C++\x22 {\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"char* __libcpp_strchr(const char* __s, int __c) {return (char*)strchr(__s, __c);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"const char* strchr(const char* __s, int __c) {return __libcpp_strchr(__s, __c);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"      char* strchr(      char* __s, int __c) {return __libcpp_strchr(__s, __c);}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"char* __libcpp_strpbrk(const char* __s1, const char* __s2) {return (char*)strpbrk(__s1, __s2);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"const char* strpbrk(const char* __s1, const char* __s2) {return __libcpp_strpbrk(__s1, __s2);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"      char* strpbrk(      char* __s1, const char* __s2) {return __libcpp_strpbrk(__s1, __s2);}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"char* __libcpp_strrchr(const char* __s, int __c) {return (char*)strrchr(__s, __c);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"const char* strrchr(const char* __s, int __c) {return __libcpp_strrchr(__s, __c);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"      char* strrchr(      char* __s, int __c) {return __libcpp_strrchr(__s, __c);}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void* __libcpp_memchr(const void* __s, int __c, size_t __n) {return (void*)memchr(__s, __c, __n);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"const void* memchr(const void* __s, int __c, size_t __n) {return __libcpp_memchr(__s, __c, __n);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"      void* memchr(      void* __s, int __c, size_t __n) {return __libcpp_memchr(__s, __c, __n);}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"char* __libcpp_strstr(const char* __s1, const char* __s2) {return (char*)strstr(__s1, __s2);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"const char* strstr(const char* __s1, const char* __s2) {return __libcpp_strstr(__s1, __s2);}\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_PREFERRED_OVERLOAD\x0a"
"      char* strstr(      char* __s1, const char* __s2) {return __libcpp_strstr(__s1, __s2);}\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#endif  // _LIBCPP_STRING_H\x0a"
"", 4689 ); }