#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_string_view( 
"// -*- C++ -*-\x0a"
"//===------------------------ string_view ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_STRING_VIEW\x0a"
"#define _LIBCPP_STRING_VIEW\x0a"
"\x0a"
"/*\x0a"
"string_view synopsis\x0a"
"\x0a"
"namespace std {\x0a"
"\x0a"
"    // 7.2, Class template basic_string_view\x0a"
"    template<class charT, class traits = char_traits<charT>>\x0a"
"        class basic_string_view;\x0a"
"\x0a"
"    // 7.9, basic_string_view non-member comparison functions\x0a"
"    template<class charT, class traits>\x0a"
"    constexpr bool operator==(basic_string_view<charT, traits> x,\x0a"
"                              basic_string_view<charT, traits> y) noexcept;\x0a"
"    template<class charT, class traits>\x0a"
"    constexpr bool operator\x21=(basic_string_view<charT, traits> x,\x0a"
"                              basic_string_view<charT, traits> y) noexcept;\x0a"
"    template<class charT, class traits>\x0a"
"    constexpr bool operator< (basic_string_view<charT, traits> x,\x0a"
"                                 basic_string_view<charT, traits> y) noexcept;\x0a"
"    template<class charT, class traits>\x0a"
"    constexpr bool operator> (basic_string_view<charT, traits> x,\x0a"
"                              basic_string_view<charT, traits> y) noexcept;\x0a"
"    template<class charT, class traits>\x0a"
"    constexpr bool operator<=(basic_string_view<charT, traits> x,\x0a"
"                                 basic_string_view<charT, traits> y) noexcept;\x0a"
"    template<class charT, class traits>\x0a"
"    constexpr bool operator>=(basic_string_view<charT, traits> x,\x0a"
"                              basic_string_view<charT, traits> y) noexcept;\x0a"
"    // see below, sufficient additional overloads of comparison functions\x0a"
"\x0a"
"    // 7.10, Inserters and extractors\x0a"
"    template<class charT, class traits>\x0a"
"      basic_ostream<charT, traits>\x26\x0a"
"        operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"                   basic_string_view<charT, traits> str);\x0a"
"\x0a"
"    // basic_string_view typedef names\x0a"
"    typedef basic_string_view<char> string_view;\x0a"
"    typedef basic_string_view<char16_t> u16string_view;\x0a"
"    typedef basic_string_view<char32_t> u32string_view;\x0a"
"    typedef basic_string_view<wchar_t> wstring_view;\x0a"
"\x0a"
"    template<class charT, class traits = char_traits<charT>>\x0a"
"    class basic_string_view {\x0a"
"      public\x3a\x0a"
"      // types\x0a"
"      typedef traits traits_type;\x0a"
"      typedef charT value_type;\x0a"
"      typedef charT* pointer;\x0a"
"      typedef const charT* const_pointer;\x0a"
"      typedef charT\x26 reference;\x0a"
"      typedef const charT\x26 const_reference;\x0a"
"      typedef implementation-defined const_iterator;\x0a"
"      typedef const_iterator iterator;\x0a"
"      typedef reverse_iterator<const_iterator> const_reverse_iterator;\x0a"
"      typedef const_reverse_iterator reverse_iterator;\x0a"
"      typedef size_t size_type;\x0a"
"      typedef ptrdiff_t difference_type;\x0a"
"      static constexpr size_type npos = size_type(-1);\x0a"
"\x0a"
"      // 7.3, basic_string_view constructors and assignment operators\x0a"
"      constexpr basic_string_view() noexcept;\x0a"
"      constexpr basic_string_view(const basic_string_view\x26) noexcept = default;\x0a"
"      basic_string_view\x26 operator=(const basic_string_view\x26) noexcept = default;\x0a"
"      template<class Allocator>\x0a"
"      constexpr basic_string_view(const charT* str);\x0a"
"      constexpr basic_string_view(const charT* str, size_type len);\x0a"
"\x0a"
"      // 7.4, basic_string_view iterator support\x0a"
"      constexpr const_iterator begin() const noexcept;\x0a"
"      constexpr const_iterator end() const noexcept;\x0a"
"      constexpr const_iterator cbegin() const noexcept;\x0a"
"      constexpr const_iterator cend() const noexcept;\x0a"
"      const_reverse_iterator rbegin() const noexcept;\x0a"
"      const_reverse_iterator rend() const noexcept;\x0a"
"      const_reverse_iterator crbegin() const noexcept;\x0a"
"      const_reverse_iterator crend() const noexcept;\x0a"
"\x0a"
"      // 7.5, basic_string_view capacity\x0a"
"      constexpr size_type size() const noexcept;\x0a"
"      constexpr size_type length() const noexcept;\x0a"
"      constexpr size_type max_size() const noexcept;\x0a"
"      constexpr bool empty() const noexcept;\x0a"
"\x0a"
"      // 7.6, basic_string_view element access\x0a"
"      constexpr const_reference operator\x5b\x5d(size_type pos) const;\x0a"
"      constexpr const_reference at(size_type pos) const;\x0a"
"      constexpr const_reference front() const;\x0a"
"      constexpr const_reference back() const;\x0a"
"      constexpr const_pointer data() const noexcept;\x0a"
"\x0a"
"      // 7.7, basic_string_view modifiers\x0a"
"      constexpr void remove_prefix(size_type n);\x0a"
"      constexpr void remove_suffix(size_type n);\x0a"
"      constexpr void swap(basic_string_view\x26 s) noexcept;\x0a"
"\x0a"
"      size_type copy(charT* s, size_type n, size_type pos = 0) const;\x0a"
"\x0a"
"      constexpr basic_string_view substr(size_type pos = 0, size_type n = npos) const;\x0a"
"      constexpr int compare(basic_string_view s) const noexcept;\x0a"
"      constexpr int compare(size_type pos1, size_type n1, basic_string_view s) const;\x0a"
"      constexpr int compare(size_type pos1, size_type n1,\x0a"
"                            basic_string_view s, size_type pos2, size_type n2) const;\x0a"
"      constexpr int compare(const charT* s) const;\x0a"
"      constexpr int compare(size_type pos1, size_type n1, const charT* s) const;\x0a"
"      constexpr int compare(size_type pos1, size_type n1,\x0a"
"                            const charT* s, size_type n2) const;\x0a"
"      constexpr size_type find(basic_string_view s, size_type pos = 0) const noexcept;\x0a"
"      constexpr size_type find(charT c, size_type pos = 0) const noexcept;\x0a"
"      constexpr size_type find(const charT* s, size_type pos, size_type n) const;\x0a"
"      constexpr size_type find(const charT* s, size_type pos = 0) const;\x0a"
"      constexpr size_type rfind(basic_string_view s, size_type pos = npos) const noexcept;\x0a"
"      constexpr size_type rfind(charT c, size_type pos = npos) const noexcept;\x0a"
"      constexpr size_type rfind(const charT* s, size_type pos, size_type n) const;\x0a"
"      constexpr size_type rfind(const charT* s, size_type pos = npos) const;\x0a"
"      constexpr size_type find_first_of(basic_string_view s, size_type pos = 0) const noexcept;\x0a"
"      constexpr size_type find_first_of(charT c, size_type pos = 0) const noexcept;\x0a"
"      constexpr size_type find_first_of(const charT* s, size_type pos, size_type n) const;\x0a"
"      constexpr size_type find_first_of(const charT* s, size_type pos = 0) const;\x0a"
"      constexpr size_type find_last_of(basic_string_view s, size_type pos = npos) const noexcept;\x0a"
"      constexpr size_type find_last_of(charT c, size_type pos = npos) const noexcept;\x0a"
"      constexpr size_type find_last_of(const charT* s, size_type pos, size_type n) const;\x0a"
"      constexpr size_type find_last_of(const charT* s, size_type pos = npos) const;\x0a"
"      constexpr size_type find_first_not_of(basic_string_view s, size_type pos = 0) const noexcept;\x0a"
"      constexpr size_type find_first_not_of(charT c, size_type pos = 0) const noexcept;\x0a"
"      constexpr size_type find_first_not_of(const charT* s, size_type pos, size_type n) const;\x0a"
"      constexpr size_type find_first_not_of(const charT* s, size_type pos = 0) const;\x0a"
"      constexpr size_type find_last_not_of(basic_string_view s, size_type pos = npos) const noexcept;\x0a"
"      constexpr size_type find_last_not_of(charT c, size_type pos = npos) const noexcept;\x0a"
"      constexpr size_type find_last_not_of(const charT* s, size_type pos, size_type n) const;\x0a"
"      constexpr size_type find_last_not_of(const charT* s, size_type pos = npos) const;\x0a"
"\x0a"
"      constexpr bool starts_with(basic_string_view s) const noexcept; // C++2a\x0a"
"      constexpr bool starts_with(charT c) const noexcept;             // C++2a\x0a"
"      constexpr bool starts_with(const charT* s) const;               // C++2a\x0a"
"      constexpr bool ends_with(basic_string_view s) const noexcept;   // C++2a\x0a"
"      constexpr bool ends_with(charT c) const noexcept;               // C++2a\x0a"
"      constexpr bool ends_with(const charT* s) const;                 // C++2a\x0a"
"\x0a"
"     private\x3a\x0a"
"      const_pointer data_;  // exposition only\x0a"
"      size_type     size_;  // exposition only\x0a"
"    };\x0a"
"\x0a"
"  // 7.11, Hash support\x0a"
"  template <class T> struct hash;\x0a"
"  template <> struct hash<string_view>;\x0a"
"  template <> struct hash<u16string_view>;\x0a"
"  template <> struct hash<u32string_view>;\x0a"
"  template <> struct hash<wstring_view>;\x0a"
"\x0a"
"  constexpr basic_string_view<char>     operator \x22\x22 sv( const char *str,     size_t len ) noexcept;\x0a"
"  constexpr basic_string_view<wchar_t>  operator \x22\x22 sv( const wchar_t *str,  size_t len ) noexcept;\x0a"
"  constexpr basic_string_view<char16_t> operator \x22\x22 sv( const char16_t *str, size_t len ) noexcept;\x0a"
"  constexpr basic_string_view<char32_t> operator \x22\x22 sv( const char32_t *str, size_t len ) noexcept;\x0a"
"\x0a"
"}  // namespace std\x0a"
"\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__string>\x0a"
"#include <algorithm>\x0a"
"#include <iterator>\x0a"
"#include <limits>\x0a"
"#include <stdexcept>\x0a"
"#include <version>\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template<class _CharT, class _Traits = char_traits<_CharT> >\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_string_view {\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _Traits                                    traits_type;\x0a"
"    typedef _CharT                                     value_type;\x0a"
"    typedef _CharT*                                    pointer;\x0a"
"    typedef const _CharT*                              const_pointer;\x0a"
"    typedef _CharT\x26                                    reference;\x0a"
"    typedef const _CharT\x26                              const_reference;\x0a"
"    typedef const_pointer                              const_iterator; // See \x5bstring.view.iterators\x5d\x0a"
"    typedef const_iterator                             iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<const_iterator>    const_reverse_iterator;\x0a"
"    typedef const_reverse_iterator                     reverse_iterator;\x0a"
"    typedef size_t                                     size_type;\x0a"
"    typedef ptrdiff_t                                  difference_type;\x0a"
"    static _LIBCPP_CONSTEXPR const size_type npos = -1; // size_type(-1);\x0a"
"\x0a"
"    static_assert((\x21is_array<value_type>\x3a\x3avalue), \x22""Character type of basic_string_view must not be an array\x22);\x0a"
"    static_assert(( is_standard_layout<value_type>\x3a\x3avalue), \x22""Character type of basic_string_view must be standard-layout\x22);\x0a"
"    static_assert(( is_trivial<value_type>\x3a\x3avalue), \x22""Character type of basic_string_view must be trivial\x22);\x0a"
"    static_assert((is_same<_CharT, typename traits_type\x3a\x3a""char_type>\x3a\x3avalue),\x0a"
"                  \x22traits_type\x3a\x3a""char_type must be the same type as CharT\x22);\x0a"
"\x0a"
"    // \x5bstring.view.cons\x5d, construct/copy\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string_view() _NOEXCEPT \x3a __data (nullptr), __size(0) {}\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string_view(const basic_string_view\x26) _NOEXCEPT = default;\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string_view\x26 operator=(const basic_string_view\x26) _NOEXCEPT = default;\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string_view(const _CharT* __s, size_type __len) _NOEXCEPT\x0a"
"        \x3a __data(__s), __size(__len)\x0a"
"    {\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    _LIBCPP_ASSERT(__len == 0 \x7c\x7c __s \x21= nullptr, \x22string_view\x3a\x3astring_view(_CharT *, size_t)\x3a received nullptr\x22);\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string_view(const _CharT* __s)\x0a"
"        \x3a __data(__s), __size(_Traits\x3a\x3alength(__s)) {}\x0a"
"\x0a"
"    // \x5bstring.view.iterators\x5d, iterators\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin()  const _NOEXCEPT { return cbegin(); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()    const _NOEXCEPT { return cend(); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const _NOEXCEPT { return __data; }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend()   const _NOEXCEPT { return __data + __size; }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX14 _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin()   const _NOEXCEPT { return const_reverse_iterator(cend()); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX14 _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend()     const _NOEXCEPT { return const_reverse_iterator(cbegin()); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX14 _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin()  const _NOEXCEPT { return const_reverse_iterator(cend()); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX14 _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend()    const _NOEXCEPT { return const_reverse_iterator(cbegin()); }\x0a"
"\x0a"
"    // \x5bstring.view.capacity\x5d, capacity\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size()     const _NOEXCEPT { return __size; }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type length()   const _NOEXCEPT { return __size; }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT { return numeric_limits<size_type>\x3a\x3amax(); }\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    bool empty()         const _NOEXCEPT { return __size == 0; }\x0a"
"\x0a"
"    // \x5bstring.view.access\x5d, element access\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference operator\x5b\x5d(size_type __pos) const _NOEXCEPT { return __data\x5b__pos\x5d; }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference at(size_type __pos) const\x0a"
"    {\x0a"
"        return __pos >= size()\x0a"
"            \x3f (__throw_out_of_range(\x22string_view\x3a\x3a""at\x22), __data\x5b""0\x5d)\x0a"
"            \x3a __data\x5b__pos\x5d;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference front() const _NOEXCEPT\x0a"
"    {\x0a"
"        return _LIBCPP_ASSERT(\x21""empty(), \x22string_view\x3a\x3a""front()\x3a string is empty\x22), __data\x5b""0\x5d;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference back() const _NOEXCEPT\x0a"
"    {\x0a"
"        return _LIBCPP_ASSERT(\x21""empty(), \x22string_view\x3a\x3a""back()\x3a string is empty\x22), __data\x5b__size-1\x5d;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_pointer data() const _NOEXCEPT { return __data; }\x0a"
"\x0a"
"    // \x5bstring.view.modifiers\x5d, modifiers\x3a\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    void remove_prefix(size_type __n) _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__n <= size(), \x22remove_prefix() can't remove more than size()\x22);\x0a"
"        __data += __n;\x0a"
"        __size -= __n;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    void remove_suffix(size_type __n) _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__n <= size(), \x22remove_suffix() can't remove more than size()\x22);\x0a"
"        __size -= __n;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(basic_string_view\x26 __other) _NOEXCEPT\x0a"
"    {\x0a"
"        const value_type *__p = __data;\x0a"
"        __data = __other.__data;\x0a"
"        __other.__data = __p;\x0a"
"\x0a"
"        size_type __sz = __size;\x0a"
"        __size = __other.__size;\x0a"
"        __other.__size = __sz;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type copy(_CharT* __s, size_type __n, size_type __pos = 0) const\x0a"
"    {\x0a"
"        if (__pos > size())\x0a"
"            __throw_out_of_range(\x22string_view\x3a\x3a""copy\x22);\x0a"
"        size_type __rlen = _VSTD\x3a\x3amin(__n, size() - __pos);\x0a"
"        _Traits\x3a\x3a""copy(__s, data() + __pos, __rlen);\x0a"
"        return __rlen;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string_view substr(size_type __pos = 0, size_type __n = npos) const\x0a"
"    {\x0a"
"        return __pos > size()\x0a"
"            \x3f (__throw_out_of_range(\x22string_view\x3a\x3asubstr\x22), basic_string_view())\x0a"
"            \x3a basic_string_view(data() + __pos, _VSTD\x3a\x3amin(__n, size() - __pos));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 int compare(basic_string_view __sv) const _NOEXCEPT\x0a"
"    {\x0a"
"        size_type __rlen = _VSTD\x3a\x3amin( size(), __sv.size());\x0a"
"        int __retval = _Traits\x3a\x3a""compare(data(), __sv.data(), __rlen);\x0a"
"        if ( __retval == 0 ) // first __rlen chars matched\x0a"
"            __retval = size() == __sv.size() \x3f 0 \x3a ( size() < __sv.size() \x3f -1 \x3a 1 );\x0a"
"        return __retval;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    int compare(size_type __pos1, size_type __n1, basic_string_view __sv) const\x0a"
"    {\x0a"
"        return substr(__pos1, __n1).compare(__sv);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    int compare(                       size_type __pos1, size_type __n1,\x0a"
"                basic_string_view __sv, size_type __pos2, size_type __n2) const\x0a"
"    {\x0a"
"        return substr(__pos1, __n1).compare(__sv.substr(__pos2, __n2));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    int compare(const _CharT* __s) const _NOEXCEPT\x0a"
"    {\x0a"
"        return compare(basic_string_view(__s));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    int compare(size_type __pos1, size_type __n1, const _CharT* __s) const\x0a"
"    {\x0a"
"        return substr(__pos1, __n1).compare(basic_string_view(__s));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    int compare(size_type __pos1, size_type __n1, const _CharT* __s, size_type __n2) const\x0a"
"    {\x0a"
"        return substr(__pos1, __n1).compare(basic_string_view(__s, __n2));\x0a"
"    }\x0a"
"\x0a"
"    // find\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find(basic_string_view __s, size_type __pos = 0) const _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s.size() == 0 \x7c\x7c __s.data() \x21= nullptr, \x22string_view\x3a\x3a""find()\x3a received nullptr\x22);\x0a"
"        return __str_find<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s.data(), __pos, __s.size());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find(_CharT __c, size_type __pos = 0) const _NOEXCEPT\x0a"
"    {\x0a"
"        return __str_find<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __c, __pos);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find(const _CharT* __s, size_type __pos, size_type __n) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string_view\x3a\x3a""find()\x3a received nullptr\x22);\x0a"
"        return __str_find<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, __n);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find(const _CharT* __s, size_type __pos = 0) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s \x21= nullptr, \x22string_view\x3a\x3a""find()\x3a received nullptr\x22);\x0a"
"        return __str_find<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"    }\x0a"
"\x0a"
"    // rfind\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type rfind(basic_string_view __s, size_type __pos = npos) const _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s.size() == 0 \x7c\x7c __s.data() \x21= nullptr, \x22string_view\x3a\x3a""find()\x3a received nullptr\x22);\x0a"
"        return __str_rfind<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s.data(), __pos, __s.size());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type rfind(_CharT __c, size_type __pos = npos) const _NOEXCEPT\x0a"
"    {\x0a"
"        return __str_rfind<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __c, __pos);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type rfind(const _CharT* __s, size_type __pos, size_type __n) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string_view\x3a\x3arfind()\x3a received nullptr\x22);\x0a"
"        return __str_rfind<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, __n);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type rfind(const _CharT* __s, size_type __pos=npos) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s \x21= nullptr, \x22string_view\x3a\x3arfind()\x3a received nullptr\x22);\x0a"
"        return __str_rfind<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"    }\x0a"
"\x0a"
"    // find_first_of\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_of(basic_string_view __s, size_type __pos = 0) const _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s.size() == 0 \x7c\x7c __s.data() \x21= nullptr, \x22string_view\x3a\x3a""find_first_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_first_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s.data(), __pos, __s.size());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_of(_CharT __c, size_type __pos = 0) const _NOEXCEPT\x0a"
"    { return find(__c, __pos); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_of(const _CharT* __s, size_type __pos, size_type __n) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string_view\x3a\x3a""find_first_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_first_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, __n);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_of(const _CharT* __s, size_type __pos=0) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s \x21= nullptr, \x22string_view\x3a\x3a""find_first_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_first_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"    }\x0a"
"\x0a"
"    // find_last_of\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_of(basic_string_view __s, size_type __pos=npos) const _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s.size() == 0 \x7c\x7c __s.data() \x21= nullptr, \x22string_view\x3a\x3a""find_last_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_last_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s.data(), __pos, __s.size());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_of(_CharT __c, size_type __pos = npos) const _NOEXCEPT\x0a"
"    { return rfind(__c, __pos); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_of(const _CharT* __s, size_type __pos, size_type __n) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string_view\x3a\x3a""find_last_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_last_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, __n);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_of(const _CharT* __s, size_type __pos=npos) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s \x21= nullptr, \x22string_view\x3a\x3a""find_last_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_last_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"    }\x0a"
"\x0a"
"    // find_first_not_of\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_not_of(basic_string_view __s, size_type __pos=0) const _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s.size() == 0 \x7c\x7c __s.data() \x21= nullptr, \x22string_view\x3a\x3a""find_first_not_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_first_not_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s.data(), __pos, __s.size());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_not_of(_CharT __c, size_type __pos=0) const _NOEXCEPT\x0a"
"    {\x0a"
"        return __str_find_first_not_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __c, __pos);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_not_of(const _CharT* __s, size_type __pos, size_type __n) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string_view\x3a\x3a""find_first_not_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_first_not_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, __n);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_not_of(const _CharT* __s, size_type __pos=0) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s \x21= nullptr, \x22string_view\x3a\x3a""find_first_not_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_first_not_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"    }\x0a"
"\x0a"
"    // find_last_not_of\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_not_of(basic_string_view __s, size_type __pos=npos) const _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s.size() == 0 \x7c\x7c __s.data() \x21= nullptr, \x22string_view\x3a\x3a""find_last_not_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_last_not_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s.data(), __pos, __s.size());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_not_of(_CharT __c, size_type __pos=npos) const _NOEXCEPT\x0a"
"    {\x0a"
"        return __str_find_last_not_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __c, __pos);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_not_of(const _CharT* __s, size_type __pos, size_type __n) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string_view\x3a\x3a""find_last_not_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_last_not_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, __n);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_not_of(const _CharT* __s, size_type __pos=npos) const\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__s \x21= nullptr, \x22string_view\x3a\x3a""find_last_not_of()\x3a received nullptr\x22);\x0a"
"        return __str_find_last_not_of<value_type, size_type, traits_type, npos>\x0a"
"            (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"    }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool starts_with(basic_string_view __s) const _NOEXCEPT\x0a"
"    { return size() >= __s.size() \x26\x26 compare(0, __s.size(), __s) == 0; }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool starts_with(value_type __c) const _NOEXCEPT\x0a"
"    { return \x21""empty() \x26\x26 _Traits\x3a\x3a""eq(front(), __c); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool starts_with(const value_type* __s) const _NOEXCEPT\x0a"
"    { return starts_with(basic_string_view(__s)); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool ends_with(basic_string_view __s) const _NOEXCEPT\x0a"
"    { return size() >= __s.size() \x26\x26 compare(size() - __s.size(), npos, __s) == 0; }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool ends_with(value_type __c) const _NOEXCEPT\x0a"
"    { return \x21""empty() \x26\x26 _Traits\x3a\x3a""eq(back(), __c); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool ends_with(const value_type* __s) const _NOEXCEPT\x0a"
"    { return ends_with(basic_string_view(__s)); }\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"    const   value_type* __data;\x0a"
"    size_type           __size;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"// \x5bstring.view.comparison\x5d\x0a"
"// operator ==\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator==(basic_string_view<_CharT, _Traits> __lhs,\x0a"
"                basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    if ( __lhs.size() \x21= __rhs.size()) return false;\x0a"
"    return __lhs.compare(__rhs) == 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator==(basic_string_view<_CharT, _Traits> __lhs,\x0a"
"                typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    if ( __lhs.size() \x21= __rhs.size()) return false;\x0a"
"    return __lhs.compare(__rhs) == 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator==(typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __lhs,\x0a"
"                basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    if ( __lhs.size() \x21= __rhs.size()) return false;\x0a"
"    return __lhs.compare(__rhs) == 0;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// operator \x21=\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(basic_string_view<_CharT, _Traits> __lhs, basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    if ( __lhs.size() \x21= __rhs.size())\x0a"
"        return true;\x0a"
"    return __lhs.compare(__rhs) \x21= 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(basic_string_view<_CharT, _Traits> __lhs,\x0a"
"                typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    if ( __lhs.size() \x21= __rhs.size())\x0a"
"        return true;\x0a"
"    return __lhs.compare(__rhs) \x21= 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __lhs,\x0a"
"                basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    if ( __lhs.size() \x21= __rhs.size())\x0a"
"        return true;\x0a"
"    return __lhs.compare(__rhs) \x21= 0;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// operator <\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator<(basic_string_view<_CharT, _Traits> __lhs, basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) < 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator<(basic_string_view<_CharT, _Traits> __lhs,\x0a"
"                typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) < 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator<(typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __lhs,\x0a"
"                basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) < 0;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// operator >\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator> (basic_string_view<_CharT, _Traits> __lhs, basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) > 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator>(basic_string_view<_CharT, _Traits> __lhs,\x0a"
"                typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) > 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator>(typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __lhs,\x0a"
"                basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) > 0;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// operator <=\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator<=(basic_string_view<_CharT, _Traits> __lhs, basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) <= 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator<=(basic_string_view<_CharT, _Traits> __lhs,\x0a"
"                typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) <= 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator<=(typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __lhs,\x0a"
"                basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) <= 0;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// operator >=\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator>=(basic_string_view<_CharT, _Traits> __lhs, basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) >= 0;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator>=(basic_string_view<_CharT, _Traits> __lhs,\x0a"
"                typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) >= 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator>=(typename common_type<basic_string_view<_CharT, _Traits> >\x3a\x3atype __lhs,\x0a"
"                basic_string_view<_CharT, _Traits> __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) >= 0;\x0a"
"}\x0a"
"\x0a"
"typedef basic_string_view<char>     string_view;\x0a"
"#ifndef _LIBCPP_NO_HAS_CHAR8_T\x0a"
"typedef basic_string_view<char8_t>  u8string_view;\x0a"
"#endif\x0a"
"typedef basic_string_view<char16_t> u16string_view;\x0a"
"typedef basic_string_view<char32_t> u32string_view;\x0a"
"typedef basic_string_view<wchar_t>  wstring_view;\x0a"
"\x0a"
"// \x5bstring.view.hash\x5d\x0a"
"template<class _CharT>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<basic_string_view<_CharT, char_traits<_CharT> > >\x0a"
"    \x3a public unary_function<basic_string_view<_CharT, char_traits<_CharT> >, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const basic_string_view<_CharT, char_traits<_CharT> > __val) const _NOEXCEPT {\x0a"
"        return __do_string_hash(__val.data(), __val.data() + __val.size());\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"inline namespace literals\x0a"
"{\x0a"
"  inline namespace string_view_literals\x0a"
"  {\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    basic_string_view<char> operator \x22\x22 sv(const char *__str, size_t __len) _NOEXCEPT\x0a"
"    {\x0a"
"        return basic_string_view<char> (__str, __len);\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    basic_string_view<wchar_t> operator \x22\x22 sv(const wchar_t *__str, size_t __len) _NOEXCEPT\x0a"
"    {\x0a"
"        return basic_string_view<wchar_t> (__str, __len);\x0a"
"    }\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_HAS_CHAR8_T\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    basic_string_view<char8_t> operator \x22\x22 sv(const char8_t *__str, size_t __len) _NOEXCEPT\x0a"
"    {\x0a"
"        return basic_string_view<char8_t> (__str, __len);\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    basic_string_view<char16_t> operator \x22\x22 sv(const char16_t *__str, size_t __len) _NOEXCEPT\x0a"
"    {\x0a"
"        return basic_string_view<char16_t> (__str, __len);\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    basic_string_view<char32_t> operator \x22\x22 sv(const char32_t *__str, size_t __len) _NOEXCEPT\x0a"
"    {\x0a"
"        return basic_string_view<char32_t> (__str, __len);\x0a"
"    }\x0a"
"  }\x0a"
"}\x0a"
"#endif\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif // _LIBCPP_STRING_VIEW\x0a"
"", 34333 ); }