#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_strstream( 
"// -*- C++ -*-\x0a"
"//===--------------------------- strstream --------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_STRSTREAM\x0a"
"#define _LIBCPP_STRSTREAM\x0a"
"\x0a"
"/*\x0a"
"    strstream synopsis\x0a"
"\x0a"
"class strstreambuf\x0a"
"    \x3a public basic_streambuf<char>\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit strstreambuf(streamsize alsize_arg = 0);\x0a"
"    strstreambuf(void* (*palloc_arg)(size_t), void (*pfree_arg)(void*));\x0a"
"    strstreambuf(char* gnext_arg, streamsize n, char* pbeg_arg = 0);\x0a"
"    strstreambuf(const char* gnext_arg, streamsize n);\x0a"
"\x0a"
"    strstreambuf(signed char* gnext_arg, streamsize n, signed char* pbeg_arg = 0);\x0a"
"    strstreambuf(const signed char* gnext_arg, streamsize n);\x0a"
"    strstreambuf(unsigned char* gnext_arg, streamsize n, unsigned char* pbeg_arg = 0);\x0a"
"    strstreambuf(const unsigned char* gnext_arg, streamsize n);\x0a"
"\x0a"
"    strstreambuf(strstreambuf\x26\x26 rhs);\x0a"
"    strstreambuf\x26 operator=(strstreambuf\x26\x26 rhs);\x0a"
"\x0a"
"    virtual \x7estrstreambuf();\x0a"
"\x0a"
"    void swap(strstreambuf\x26 rhs);\x0a"
"\x0a"
"    void freeze(bool freezefl = true);\x0a"
"    char* str();\x0a"
"    int pcount() const;\x0a"
"\x0a"
"protected\x3a\x0a"
"    virtual int_type overflow (int_type c = EOF);\x0a"
"    virtual int_type pbackfail(int_type c = EOF);\x0a"
"    virtual int_type underflow();\x0a"
"    virtual pos_type seekoff(off_type off, ios_base\x3a\x3aseekdir way,\x0a"
"                             ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual pos_type seekpos(pos_type sp,\x0a"
"                             ios_base\x3a\x3aopenmode which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual streambuf* setbuf(char* s, streamsize n);\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef T1 strstate;                // exposition only\x0a"
"    static const strstate allocated;    // exposition only\x0a"
"    static const strstate constant;     // exposition only\x0a"
"    static const strstate dynamic;      // exposition only\x0a"
"    static const strstate frozen;       // exposition only\x0a"
"    strstate strmode;                   // exposition only\x0a"
"    streamsize alsize;                  // exposition only\x0a"
"    void* (*palloc)(size_t);            // exposition only\x0a"
"    void (*pfree)(void*);               // exposition only\x0a"
"};\x0a"
"\x0a"
"class istrstream\x0a"
"    \x3a public basic_istream<char>\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit istrstream(const char* s);\x0a"
"    explicit istrstream(char* s);\x0a"
"    istrstream(const char* s, streamsize n);\x0a"
"    istrstream(char* s, streamsize n);\x0a"
"\x0a"
"    virtual \x7eistrstream();\x0a"
"\x0a"
"    strstreambuf* rdbuf() const;\x0a"
"    char *str();\x0a"
"\x0a"
"private\x3a\x0a"
"    strstreambuf sb; // exposition only\x0a"
"};\x0a"
"\x0a"
"class ostrstream\x0a"
"    \x3a public basic_ostream<char>\x0a"
"{\x0a"
"public\x3a\x0a"
"    ostrstream();\x0a"
"    ostrstream(char* s, int n, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3aout);\x0a"
"\x0a"
"    virtual \x7eostrstream();\x0a"
"\x0a"
"    strstreambuf* rdbuf() const;\x0a"
"    void freeze(bool freezefl = true);\x0a"
"    char* str();\x0a"
"    int pcount() const;\x0a"
"\x0a"
"private\x3a\x0a"
"    strstreambuf sb; // exposition only\x0a"
"};\x0a"
"\x0a"
"class strstream\x0a"
"    \x3a public basic_iostream<char>\x0a"
"{\x0a"
"public\x3a\x0a"
"    // Types\x0a"
"    typedef char                        char_type;\x0a"
"    typedef char_traits<char>\x3a\x3aint_type int_type;\x0a"
"    typedef char_traits<char>\x3a\x3apos_type pos_type;\x0a"
"    typedef char_traits<char>\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    // constructors/destructor\x0a"
"    strstream();\x0a"
"    strstream(char* s, int n, ios_base\x3a\x3aopenmode mode = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"\x0a"
"    virtual \x7estrstream();\x0a"
"\x0a"
"    // Members\x3a\x0a"
"    strstreambuf* rdbuf() const;\x0a"
"    void freeze(bool freezefl = true);\x0a"
"    int pcount() const;\x0a"
"    char* str();\x0a"
"\x0a"
"private\x3a\x0a"
"    strstreambuf sb; // exposition only\x0a"
"};\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <ostream>\x0a"
"#include <istream>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS strstreambuf\x0a"
"    \x3a public streambuf\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit strstreambuf(streamsize __alsize = 0);\x0a"
"    strstreambuf(void* (*__palloc)(size_t), void (*__pfree)(void*));\x0a"
"    strstreambuf(char* __gnext, streamsize __n, char* __pbeg = 0);\x0a"
"    strstreambuf(const char* __gnext, streamsize __n);\x0a"
"\x0a"
"    strstreambuf(signed char* __gnext, streamsize __n, signed char* __pbeg = 0);\x0a"
"    strstreambuf(const signed char* __gnext, streamsize __n);\x0a"
"    strstreambuf(unsigned char* __gnext, streamsize __n, unsigned char* __pbeg = 0);\x0a"
"    strstreambuf(const unsigned char* __gnext, streamsize __n);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    strstreambuf(strstreambuf\x26\x26 __rhs);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    strstreambuf\x26 operator=(strstreambuf\x26\x26 __rhs);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    virtual \x7estrstreambuf();\x0a"
"\x0a"
"    void swap(strstreambuf\x26 __rhs);\x0a"
"\x0a"
"    void freeze(bool __freezefl = true);\x0a"
"    char* str();\x0a"
"    int pcount() const;\x0a"
"\x0a"
"protected\x3a\x0a"
"    virtual int_type overflow (int_type __c = EOF);\x0a"
"    virtual int_type pbackfail(int_type __c = EOF);\x0a"
"    virtual int_type underflow();\x0a"
"    virtual pos_type seekoff(off_type __off, ios_base\x3a\x3aseekdir __way,\x0a"
"                             ios_base\x3a\x3aopenmode __which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"    virtual pos_type seekpos(pos_type __sp,\x0a"
"                             ios_base\x3a\x3aopenmode __which = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout);\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef unsigned __mode_type;\x0a"
"    static const __mode_type __allocated = 0x01;\x0a"
"    static const __mode_type __constant  = 0x02;\x0a"
"    static const __mode_type __dynamic   = 0x04;\x0a"
"    static const __mode_type __frozen    = 0x08;\x0a"
"    static const streamsize    __default_alsize = 4096;\x0a"
"\x0a"
"    __mode_type __strmode_;\x0a"
"    streamsize __alsize_;\x0a"
"    void* (*__palloc_)(size_t);\x0a"
"    void (*__pfree_)(void*);\x0a"
"\x0a"
"    void __init(char* __gnext, streamsize __n, char* __pbeg);\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"strstreambuf\x3a\x3astrstreambuf(strstreambuf\x26\x26 __rhs)\x0a"
"    \x3a streambuf(__rhs),\x0a"
"      __strmode_(__rhs.__strmode_),\x0a"
"      __alsize_(__rhs.__alsize_),\x0a"
"      __palloc_(__rhs.__palloc_),\x0a"
"      __pfree_(__rhs.__pfree_)\x0a"
"{\x0a"
"    __rhs.setg(nullptr, nullptr, nullptr);\x0a"
"    __rhs.setp(nullptr, nullptr);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"strstreambuf\x26\x0a"
"strstreambuf\x3a\x3aoperator=(strstreambuf\x26\x26 __rhs)\x0a"
"{\x0a"
"    if (eback() \x26\x26 (__strmode_ \x26 __allocated) \x21= 0 \x26\x26 (__strmode_ \x26 __frozen) == 0)\x0a"
"    {\x0a"
"        if (__pfree_)\x0a"
"            __pfree_(eback());\x0a"
"        else\x0a"
"            delete \x5b\x5d eback();\x0a"
"    }\x0a"
"    streambuf\x3a\x3aoperator=(__rhs);\x0a"
"    __strmode_ = __rhs.__strmode_;\x0a"
"    __alsize_ = __rhs.__alsize_;\x0a"
"    __palloc_ = __rhs.__palloc_;\x0a"
"    __pfree_ = __rhs.__pfree_;\x0a"
"    __rhs.setg(nullptr, nullptr, nullptr);\x0a"
"    __rhs.setp(nullptr, nullptr);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS istrstream\x0a"
"    \x3a public istream\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit istrstream(const char* __s)\x0a"
"        \x3a istream(\x26__sb_), __sb_(__s, 0) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit istrstream(char* __s)\x0a"
"        \x3a istream(\x26__sb_), __sb_(__s, 0) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    istrstream(const char* __s, streamsize __n)\x0a"
"        \x3a istream(\x26__sb_), __sb_(__s, __n) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    istrstream(char* __s, streamsize __n)\x0a"
"        \x3a istream(\x26__sb_), __sb_(__s, __n) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    istrstream(istrstream\x26\x26 __rhs)\x0a"
"        \x3a istream(_VSTD\x3a\x3amove(__rhs)),\x0a"
"          __sb_(_VSTD\x3a\x3amove(__rhs.__sb_))\x0a"
"    {\x0a"
"        istream\x3a\x3aset_rdbuf(\x26__sb_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    istrstream\x26 operator=(istrstream\x26\x26 __rhs)\x0a"
"    {\x0a"
"        istream\x3a\x3aoperator=(_VSTD\x3a\x3amove(__rhs));\x0a"
"        __sb_ = _VSTD\x3a\x3amove(__rhs.__sb_);\x0a"
"        return *this;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    virtual \x7eistrstream();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(istrstream\x26 __rhs)\x0a"
"    {\x0a"
"        istream\x3a\x3aswap(__rhs);\x0a"
"        __sb_.swap(__rhs.__sb_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    strstreambuf* rdbuf() const {return const_cast<strstreambuf*>(\x26__sb_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    char *str() {return __sb_.str();}\x0a"
"\x0a"
"private\x3a\x0a"
"    strstreambuf __sb_;\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS ostrstream\x0a"
"    \x3a public ostream\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    ostrstream()\x0a"
"        \x3a ostream(\x26__sb_) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    ostrstream(char* __s, int __n, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3aout)\x0a"
"        \x3a ostream(\x26__sb_),\x0a"
"          __sb_(__s, __n, __s + (__mode \x26 ios\x3a\x3a""app \x3f strlen(__s) \x3a 0))\x0a"
"        {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    ostrstream(ostrstream\x26\x26 __rhs)\x0a"
"        \x3a ostream(_VSTD\x3a\x3amove(__rhs)),\x0a"
"          __sb_(_VSTD\x3a\x3amove(__rhs.__sb_))\x0a"
"    {\x0a"
"        ostream\x3a\x3aset_rdbuf(\x26__sb_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    ostrstream\x26 operator=(ostrstream\x26\x26 __rhs)\x0a"
"    {\x0a"
"        ostream\x3a\x3aoperator=(_VSTD\x3a\x3amove(__rhs));\x0a"
"        __sb_ = _VSTD\x3a\x3amove(__rhs.__sb_);\x0a"
"        return *this;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    virtual \x7eostrstream();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(ostrstream\x26 __rhs)\x0a"
"    {\x0a"
"        ostream\x3a\x3aswap(__rhs);\x0a"
"        __sb_.swap(__rhs.__sb_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    strstreambuf* rdbuf() const {return const_cast<strstreambuf*>(\x26__sb_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void freeze(bool __freezefl = true) {__sb_.freeze(__freezefl);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    char* str()         {return __sb_.str();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int pcount() const  {return __sb_.pcount();}\x0a"
"\x0a"
"private\x3a\x0a"
"    strstreambuf __sb_; // exposition only\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS strstream\x0a"
"    \x3a public iostream\x0a"
"{\x0a"
"public\x3a\x0a"
"    // Types\x0a"
"    typedef char                        char_type;\x0a"
"    typedef char_traits<char>\x3a\x3aint_type int_type;\x0a"
"    typedef char_traits<char>\x3a\x3apos_type pos_type;\x0a"
"    typedef char_traits<char>\x3a\x3aoff_type off_type;\x0a"
"\x0a"
"    // constructors/destructor\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    strstream()\x0a"
"        \x3a iostream(\x26__sb_) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    strstream(char* __s, int __n, ios_base\x3a\x3aopenmode __mode = ios_base\x3a\x3ain \x7c ios_base\x3a\x3aout)\x0a"
"        \x3a iostream(\x26__sb_),\x0a"
"          __sb_(__s, __n, __s + (__mode \x26 ios\x3a\x3a""app \x3f strlen(__s) \x3a 0))\x0a"
"        {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    strstream(strstream\x26\x26 __rhs)\x0a"
"        \x3a iostream(_VSTD\x3a\x3amove(__rhs)),\x0a"
"          __sb_(_VSTD\x3a\x3amove(__rhs.__sb_))\x0a"
"    {\x0a"
"        iostream\x3a\x3aset_rdbuf(\x26__sb_);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    strstream\x26 operator=(strstream\x26\x26 __rhs)\x0a"
"    {\x0a"
"        iostream\x3a\x3aoperator=(_VSTD\x3a\x3amove(__rhs));\x0a"
"        __sb_ = _VSTD\x3a\x3amove(__rhs.__sb_);\x0a"
"        return *this;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    virtual \x7estrstream();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(strstream\x26 __rhs)\x0a"
"    {\x0a"
"        iostream\x3a\x3aswap(__rhs);\x0a"
"        __sb_.swap(__rhs.__sb_);\x0a"
"    }\x0a"
"\x0a"
"    // Members\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    strstreambuf* rdbuf() const {return const_cast<strstreambuf*>(\x26__sb_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void freeze(bool __freezefl = true) {__sb_.freeze(__freezefl);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int pcount() const {return __sb_.pcount();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    char* str()        {return __sb_.str();}\x0a"
"\x0a"
"private\x3a\x0a"
"    strstreambuf __sb_; // exposition only\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_STRSTREAM\x0a"
"", 11145 ); }