#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_system_error( 
"// -*- C++ -*-\x0a"
"//===---------------------------- system_error ----------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_SYSTEM_ERROR\x0a"
"#define _LIBCPP_SYSTEM_ERROR\x0a"
"\x0a"
"/*\x0a"
"    system_error synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"class error_category\x0a"
"{\x0a"
"public\x3a\x0a"
"    virtual \x7e""error_category() noexcept;\x0a"
"\x0a"
"    constexpr error_category();\x0a"
"    error_category(const error_category\x26) = delete;\x0a"
"    error_category\x26 operator=(const error_category\x26) = delete;\x0a"
"\x0a"
"    virtual const char* name() const noexcept = 0;\x0a"
"    virtual error_condition default_error_condition(int ev) const noexcept;\x0a"
"    virtual bool equivalent(int code, const error_condition\x26 condition) const noexcept;\x0a"
"    virtual bool equivalent(const error_code\x26 code, int condition) const noexcept;\x0a"
"    virtual string message(int ev) const = 0;\x0a"
"\x0a"
"    bool operator==(const error_category\x26 rhs) const noexcept;\x0a"
"    bool operator\x21=(const error_category\x26 rhs) const noexcept;\x0a"
"    bool operator<(const error_category\x26 rhs) const noexcept;\x0a"
"};\x0a"
"\x0a"
"const error_category\x26 generic_category() noexcept;\x0a"
"const error_category\x26 system_category() noexcept;\x0a"
"\x0a"
"template <class T> struct is_error_code_enum\x0a"
"    \x3a public false_type {};\x0a"
"\x0a"
"template <class T> struct is_error_condition_enum\x0a"
"    \x3a public false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline constexpr size_t is_error_condition_enum_v = is_error_condition_enum<_Tp>\x3a\x3avalue; // C++17\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline constexpr size_t is_error_code_enum_v = is_error_code_enum<_Tp>\x3a\x3avalue; // C++17\x0a"
"\x0a"
"class error_code\x0a"
"{\x0a"
"public\x3a\x0a"
"    // constructors\x3a\x0a"
"    error_code() noexcept;\x0a"
"    error_code(int val, const error_category\x26 cat) noexcept;\x0a"
"    template <class ErrorCodeEnum>\x0a"
"        error_code(ErrorCodeEnum e) noexcept;\x0a"
"\x0a"
"    // modifiers\x3a\x0a"
"    void assign(int val, const error_category\x26 cat) noexcept;\x0a"
"    template <class ErrorCodeEnum>\x0a"
"        error_code\x26 operator=(ErrorCodeEnum e) noexcept;\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    // observers\x3a\x0a"
"    int value() const noexcept;\x0a"
"    const error_category\x26 category() const noexcept;\x0a"
"    error_condition default_error_condition() const noexcept;\x0a"
"    string message() const;\x0a"
"    explicit operator bool() const noexcept;\x0a"
"};\x0a"
"\x0a"
"// non-member functions\x3a\x0a"
"bool operator<(const error_code\x26 lhs, const error_code\x26 rhs) noexcept;\x0a"
"template <class charT, class traits>\x0a"
"    basic_ostream<charT,traits>\x26\x0a"
"    operator<<(basic_ostream<charT,traits>\x26 os, const error_code\x26 ec);\x0a"
"\x0a"
"class error_condition\x0a"
"{\x0a"
"public\x3a\x0a"
"    // constructors\x3a\x0a"
"    error_condition() noexcept;\x0a"
"    error_condition(int val, const error_category\x26 cat) noexcept;\x0a"
"    template <class ErrorConditionEnum>\x0a"
"        error_condition(ErrorConditionEnum e) noexcept;\x0a"
"\x0a"
"    // modifiers\x3a\x0a"
"    void assign(int val, const error_category\x26 cat) noexcept;\x0a"
"    template <class ErrorConditionEnum>\x0a"
"        error_condition\x26 operator=(ErrorConditionEnum e) noexcept;\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    // observers\x3a\x0a"
"    int value() const noexcept;\x0a"
"    const error_category\x26 category() const noexcept;\x0a"
"    string message() const noexcept;\x0a"
"    explicit operator bool() const noexcept;\x0a"
"};\x0a"
"\x0a"
"bool operator<(const error_condition\x26 lhs, const error_condition\x26 rhs) noexcept;\x0a"
"\x0a"
"class system_error\x0a"
"    \x3a public runtime_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    system_error(error_code ec, const string\x26 what_arg);\x0a"
"    system_error(error_code ec, const char* what_arg);\x0a"
"    system_error(error_code ec);\x0a"
"    system_error(int ev, const error_category\x26 ecat, const string\x26 what_arg);\x0a"
"    system_error(int ev, const error_category\x26 ecat, const char* what_arg);\x0a"
"    system_error(int ev, const error_category\x26 ecat);\x0a"
"\x0a"
"    const error_code\x26 code() const noexcept;\x0a"
"    const char* what() const noexcept;\x0a"
"};\x0a"
"\x0a"
"template <> struct is_error_condition_enum<errc>\x0a"
"    \x3a true_type { }\x0a"
"\x0a"
"error_code make_error_code(errc e) noexcept;\x0a"
"error_condition make_error_condition(errc e) noexcept;\x0a"
"\x0a"
"// Comparison operators\x3a\x0a"
"bool operator==(const error_code\x26 lhs, const error_code\x26 rhs) noexcept;\x0a"
"bool operator==(const error_code\x26 lhs, const error_condition\x26 rhs) noexcept;\x0a"
"bool operator==(const error_condition\x26 lhs, const error_code\x26 rhs) noexcept;\x0a"
"bool operator==(const error_condition\x26 lhs, const error_condition\x26 rhs) noexcept;\x0a"
"bool operator\x21=(const error_code\x26 lhs, const error_code\x26 rhs) noexcept;\x0a"
"bool operator\x21=(const error_code\x26 lhs, const error_condition\x26 rhs) noexcept;\x0a"
"bool operator\x21=(const error_condition\x26 lhs, const error_code\x26 rhs) noexcept;\x0a"
"bool operator\x21=(const error_condition\x26 lhs, const error_condition\x26 rhs) noexcept;\x0a"
"\x0a"
"template <> struct hash<std\x3a\x3a""error_code>;\x0a"
"template <> struct hash<std\x3a\x3a""error_condition>;\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__errc>\x0a"
"#include <type_traits>\x0a"
"#include <stdexcept>\x0a"
"#include <__functional_base>\x0a"
"#include <string>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// is_error_code_enum\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_error_code_enum\x0a"
"    \x3a public false_type {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr size_t is_error_code_enum_v = is_error_code_enum<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_error_condition_enum\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_error_condition_enum\x0a"
"    \x3a public false_type {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr size_t is_error_condition_enum_v = is_error_condition_enum<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_error_condition_enum<errc>\x0a"
"    \x3a true_type { };\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_NO_STRONG_ENUMS\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_error_condition_enum<errc\x3a\x3a__lx>\x0a"
"    \x3a true_type { };\x0a"
"#endif\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS error_condition;\x0a"
"class _LIBCPP_TYPE_VIS error_code;\x0a"
"\x0a"
"// class error_category\x0a"
"\x0a"
"class _LIBCPP_HIDDEN __do_message;\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS error_category\x0a"
"{\x0a"
"public\x3a\x0a"
"    virtual \x7e""error_category() _NOEXCEPT;\x0a"
"\x0a"
"#if defined(_LIBCPP_BUILDING_LIBRARY) \x26\x26 \x5c\x0a"
"    defined(_LIBCPP_DEPRECATED_ABI_LEGACY_LIBRARY_DEFINITIONS_FOR_INLINE_FUNCTIONS)\x0a"
"    error_category() _NOEXCEPT;\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 error_category() _NOEXCEPT _LIBCPP_DEFAULT\x0a"
"#endif\x0a"
"private\x3a\x0a"
"    error_category(const error_category\x26);// = delete;\x0a"
"    error_category\x26 operator=(const error_category\x26);// = delete;\x0a"
"\x0a"
"public\x3a\x0a"
"    virtual const char* name() const _NOEXCEPT = 0;\x0a"
"    virtual error_condition default_error_condition(int __ev) const _NOEXCEPT;\x0a"
"    virtual bool equivalent(int __code, const error_condition\x26 __condition) const _NOEXCEPT;\x0a"
"    virtual bool equivalent(const error_code\x26 __code, int __condition) const _NOEXCEPT;\x0a"
"    virtual string message(int __ev) const = 0;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const error_category\x26 __rhs) const _NOEXCEPT {return this == \x26__rhs;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const error_category\x26 __rhs) const _NOEXCEPT {return \x21(*this == __rhs);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator< (const error_category\x26 __rhs) const _NOEXCEPT {return this < \x26__rhs;}\x0a"
"\x0a"
"    friend class _LIBCPP_HIDDEN __do_message;\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_HIDDEN __do_message\x0a"
"    \x3a public error_category\x0a"
"{\x0a"
"public\x3a\x0a"
"    virtual string message(int ev) const;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS const error_category\x26 generic_category() _NOEXCEPT;\x0a"
"_LIBCPP_FUNC_VIS const error_category\x26 system_category() _NOEXCEPT;\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS error_condition\x0a"
"{\x0a"
"    int __val_;\x0a"
"    const error_category* __cat_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    error_condition() _NOEXCEPT \x3a __val_(0), __cat_(\x26generic_category()) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    error_condition(int __val, const error_category\x26 __cat) _NOEXCEPT\x0a"
"        \x3a __val_(__val), __cat_(\x26__cat) {}\x0a"
"\x0a"
"    template <class _Ep>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        error_condition(_Ep __e,\x0a"
"              typename enable_if<is_error_condition_enum<_Ep>\x3a\x3avalue>\x3a\x3atype* = 0\x0a"
"                                                                     ) _NOEXCEPT\x0a"
"            {*this = make_error_condition(__e);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void assign(int __val, const error_category\x26 __cat) _NOEXCEPT\x0a"
"    {\x0a"
"        __val_ = __val;\x0a"
"        __cat_ = \x26__cat;\x0a"
"    }\x0a"
"\x0a"
"    template <class _Ep>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_error_condition_enum<_Ep>\x3a\x3avalue,\x0a"
"            error_condition\x26\x0a"
"        >\x3a\x3atype\x0a"
"        operator=(_Ep __e) _NOEXCEPT\x0a"
"            {*this = make_error_condition(__e); return *this;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT\x0a"
"    {\x0a"
"        __val_ = 0;\x0a"
"        __cat_ = \x26generic_category();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int value() const _NOEXCEPT {return __val_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const error_category\x26 category() const _NOEXCEPT {return *__cat_;}\x0a"
"    string message() const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        _LIBCPP_EXPLICIT\x0a"
"        operator bool() const _NOEXCEPT {return __val_ \x21= 0;}\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"error_condition\x0a"
"make_error_condition(errc __e) _NOEXCEPT\x0a"
"{\x0a"
"    return error_condition(static_cast<int>(__e), generic_category());\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(const error_condition\x26 __x, const error_condition\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __x.category() < __y.category()\x0a"
"        \x7c\x7c (__x.category() == __y.category() \x26\x26 __x.value() < __y.value());\x0a"
"}\x0a"
"\x0a"
"// error_code\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS error_code\x0a"
"{\x0a"
"    int __val_;\x0a"
"    const error_category* __cat_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    error_code() _NOEXCEPT \x3a __val_(0), __cat_(\x26system_category()) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    error_code(int __val, const error_category\x26 __cat) _NOEXCEPT\x0a"
"        \x3a __val_(__val), __cat_(\x26__cat) {}\x0a"
"\x0a"
"    template <class _Ep>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        error_code(_Ep __e,\x0a"
"                   typename enable_if<is_error_code_enum<_Ep>\x3a\x3avalue>\x3a\x3atype* = 0\x0a"
"                                                                     ) _NOEXCEPT\x0a"
"            {*this = make_error_code(__e);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void assign(int __val, const error_category\x26 __cat) _NOEXCEPT\x0a"
"    {\x0a"
"        __val_ = __val;\x0a"
"        __cat_ = \x26__cat;\x0a"
"    }\x0a"
"\x0a"
"    template <class _Ep>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_error_code_enum<_Ep>\x3a\x3avalue,\x0a"
"            error_code\x26\x0a"
"        >\x3a\x3atype\x0a"
"        operator=(_Ep __e) _NOEXCEPT\x0a"
"            {*this = make_error_code(__e); return *this;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT\x0a"
"    {\x0a"
"        __val_ = 0;\x0a"
"        __cat_ = \x26system_category();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int value() const _NOEXCEPT {return __val_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const error_category\x26 category() const _NOEXCEPT {return *__cat_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    error_condition default_error_condition() const _NOEXCEPT\x0a"
"        {return __cat_->default_error_condition(__val_);}\x0a"
"\x0a"
"    string message() const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        _LIBCPP_EXPLICIT\x0a"
"        operator bool() const _NOEXCEPT {return __val_ \x21= 0;}\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"error_code\x0a"
"make_error_code(errc __e) _NOEXCEPT\x0a"
"{\x0a"
"    return error_code(static_cast<int>(__e), generic_category());\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(const error_code\x26 __x, const error_code\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __x.category() < __y.category()\x0a"
"        \x7c\x7c (__x.category() == __y.category() \x26\x26 __x.value() < __y.value());\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const error_code\x26 __x, const error_code\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __x.category() == __y.category() \x26\x26 __x.value() == __y.value();\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const error_code\x26 __x, const error_condition\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __x.category().equivalent(__x.value(), __y)\x0a"
"        \x7c\x7c __y.category().equivalent(__x, __y.value());\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const error_condition\x26 __x, const error_code\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __y == __x;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const error_condition\x26 __x, const error_condition\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __x.category() == __y.category() \x26\x26 __x.value() == __y.value();\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const error_code\x26 __x, const error_code\x26 __y) _NOEXCEPT\x0a"
"{return \x21(__x == __y);}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const error_code\x26 __x, const error_condition\x26 __y) _NOEXCEPT\x0a"
"{return \x21(__x == __y);}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const error_condition\x26 __x, const error_code\x26 __y) _NOEXCEPT\x0a"
"{return \x21(__x == __y);}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const error_condition\x26 __x, const error_condition\x26 __y) _NOEXCEPT\x0a"
"{return \x21(__x == __y);}\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<error_code>\x0a"
"    \x3a public unary_function<error_code, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const error_code\x26 __ec) const _NOEXCEPT\x0a"
"    {\x0a"
"        return static_cast<size_t>(__ec.value());\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<error_condition>\x0a"
"    \x3a public unary_function<error_condition, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const error_condition\x26 __ec) const _NOEXCEPT\x0a"
"    {\x0a"
"        return static_cast<size_t>(__ec.value());\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"// system_error\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS system_error\x0a"
"    \x3a public runtime_error\x0a"
"{\x0a"
"    error_code __ec_;\x0a"
"public\x3a\x0a"
"    system_error(error_code __ec, const string\x26 __what_arg);\x0a"
"    system_error(error_code __ec, const char* __what_arg);\x0a"
"    system_error(error_code __ec);\x0a"
"    system_error(int __ev, const error_category\x26 __ecat, const string\x26 __what_arg);\x0a"
"    system_error(int __ev, const error_category\x26 __ecat, const char* __what_arg);\x0a"
"    system_error(int __ev, const error_category\x26 __ecat);\x0a"
"    \x7esystem_error() _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const error_code\x26 code() const _NOEXCEPT {return __ec_;}\x0a"
"\x0a"
"private\x3a\x0a"
"    static string __init(const error_code\x26, string);\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_NORETURN _LIBCPP_FUNC_VIS\x0a"
"void __throw_system_error(int ev, const char* what_arg);\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_SYSTEM_ERROR\x0a"
"", 14156 ); }