#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_thread( 
"// -*- C++ -*-\x0a"
"//===--------------------------- thread -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_THREAD\x0a"
"#define _LIBCPP_THREAD\x0a"
"\x0a"
"/*\x0a"
"\x0a"
"    thread synopsis\x0a"
"\x0a"
"#define __STDCPP_THREADS__ __cplusplus\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"class thread\x0a"
"{\x0a"
"public\x3a\x0a"
"    class id;\x0a"
"    typedef pthread_t native_handle_type;\x0a"
"\x0a"
"    thread() noexcept;\x0a"
"    template <class F, class ...Args> explicit thread(F\x26\x26 f, Args\x26\x26... args);\x0a"
"    \x7ethread();\x0a"
"\x0a"
"    thread(const thread\x26) = delete;\x0a"
"    thread(thread\x26\x26 t) noexcept;\x0a"
"\x0a"
"    thread\x26 operator=(const thread\x26) = delete;\x0a"
"    thread\x26 operator=(thread\x26\x26 t) noexcept;\x0a"
"\x0a"
"    void swap(thread\x26 t) noexcept;\x0a"
"\x0a"
"    bool joinable() const noexcept;\x0a"
"    void join();\x0a"
"    void detach();\x0a"
"    id get_id() const noexcept;\x0a"
"    native_handle_type native_handle();\x0a"
"\x0a"
"    static unsigned hardware_concurrency() noexcept;\x0a"
"};\x0a"
"\x0a"
"void swap(thread\x26 x, thread\x26 y) noexcept;\x0a"
"\x0a"
"class thread\x3a\x3aid\x0a"
"{\x0a"
"public\x3a\x0a"
"    id() noexcept;\x0a"
"};\x0a"
"\x0a"
"bool operator==(thread\x3a\x3aid x, thread\x3a\x3aid y) noexcept;\x0a"
"bool operator\x21=(thread\x3a\x3aid x, thread\x3a\x3aid y) noexcept;\x0a"
"bool operator< (thread\x3a\x3aid x, thread\x3a\x3aid y) noexcept;\x0a"
"bool operator<=(thread\x3a\x3aid x, thread\x3a\x3aid y) noexcept;\x0a"
"bool operator> (thread\x3a\x3aid x, thread\x3a\x3aid y) noexcept;\x0a"
"bool operator>=(thread\x3a\x3aid x, thread\x3a\x3aid y) noexcept;\x0a"
"\x0a"
"template<class charT, class traits>\x0a"
"basic_ostream<charT, traits>\x26\x0a"
"operator<<(basic_ostream<charT, traits>\x26 out, thread\x3a\x3aid id);\x0a"
"\x0a"
"namespace this_thread\x0a"
"{\x0a"
"\x0a"
"thread\x3a\x3aid get_id() noexcept;\x0a"
"\x0a"
"void yield() noexcept;\x0a"
"\x0a"
"template <class Clock, class Duration>\x0a"
"void sleep_until(const chrono\x3a\x3atime_point<Clock, Duration>\x26 abs_time);\x0a"
"\x0a"
"template <class Rep, class Period>\x0a"
"void sleep_for(const chrono\x3a\x3a""duration<Rep, Period>\x26 rel_time);\x0a"
"\x0a"
"}  // this_thread\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <iosfwd>\x0a"
"#include <__functional_base>\x0a"
"#include <type_traits>\x0a"
"#include <cstddef>\x0a"
"#include <functional>\x0a"
"#include <memory>\x0a"
"#include <system_error>\x0a"
"#include <chrono>\x0a"
"#include <__mutex_base>\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"#include <tuple>\x0a"
"#endif\x0a"
"#include <__threading_support>\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"#define __STDCPP_THREADS__ __cplusplus\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_NO_THREADS\x0a"
"#error <thread> is not supported on this single threaded system\x0a"
"#else // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Tp> class __thread_specific_ptr;\x0a"
"class _LIBCPP_TYPE_VIS __thread_struct;\x0a"
"class _LIBCPP_HIDDEN __thread_struct_imp;\x0a"
"class __assoc_sub_state;\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS __thread_specific_ptr<__thread_struct>\x26 __thread_local_data();\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS __thread_struct\x0a"
"{\x0a"
"    __thread_struct_imp* __p_;\x0a"
"\x0a"
"    __thread_struct(const __thread_struct\x26);\x0a"
"    __thread_struct\x26 operator=(const __thread_struct\x26);\x0a"
"public\x3a\x0a"
"    __thread_struct();\x0a"
"    \x7e__thread_struct();\x0a"
"\x0a"
"    void notify_all_at_thread_exit(condition_variable*, mutex*);\x0a"
"    void __make_ready_at_thread_exit(__assoc_sub_state*);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class __thread_specific_ptr\x0a"
"{\x0a"
"    __libcpp_tls_key __key_;\x0a"
"\x0a"
"     // Only __thread_local_data() may construct a __thread_specific_ptr\x0a"
"     // and only with _Tp == __thread_struct.\x0a"
"    static_assert((is_same<_Tp, __thread_struct>\x3a\x3avalue), \x22\x22);\x0a"
"    __thread_specific_ptr();\x0a"
"    friend _LIBCPP_FUNC_VIS __thread_specific_ptr<__thread_struct>\x26 __thread_local_data();\x0a"
"\x0a"
"    __thread_specific_ptr(const __thread_specific_ptr\x26);\x0a"
"    __thread_specific_ptr\x26 operator=(const __thread_specific_ptr\x26);\x0a"
"\x0a"
"    _LIBCPP_HIDDEN static void _LIBCPP_TLS_DESTRUCTOR_CC __at_thread_exit(void*);\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _Tp* pointer;\x0a"
"\x0a"
"    \x7e__thread_specific_ptr();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer get() const {return static_cast<_Tp*>(__libcpp_tls_get(__key_));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator*() const {return *get();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const {return get();}\x0a"
"    void set_pointer(pointer __p);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"void _LIBCPP_TLS_DESTRUCTOR_CC\x0a"
"__thread_specific_ptr<_Tp>\x3a\x3a__at_thread_exit(void* __p)\x0a"
"{\x0a"
"    delete static_cast<pointer>(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"__thread_specific_ptr<_Tp>\x3a\x3a__thread_specific_ptr()\x0a"
"{\x0a"
"  int __ec =\x0a"
"      __libcpp_tls_create(\x26__key_, \x26__thread_specific_ptr\x3a\x3a__at_thread_exit);\x0a"
"  if (__ec)\x0a"
"    __throw_system_error(__ec, \x22__thread_specific_ptr construction failed\x22);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"__thread_specific_ptr<_Tp>\x3a\x3a\x7e__thread_specific_ptr()\x0a"
"{\x0a"
"    // __thread_specific_ptr is only created with a static storage duration\x0a"
"    // so this destructor is only invoked during program termination. Invoking\x0a"
"    // pthread_key_delete(__key_) may prevent other threads from deleting their\x0a"
"    // thread local data. For this reason we leak the key.\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"void\x0a"
"__thread_specific_ptr<_Tp>\x3a\x3aset_pointer(pointer __p)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(get() == nullptr,\x0a"
"                   \x22""Attempting to overwrite thread local data\x22);\x0a"
"    __libcpp_tls_set(__key_, __p);\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<__thread_id>\x0a"
"    \x3a public unary_function<__thread_id, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(__thread_id __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        return hash<__libcpp_thread_id>()(__v.__id_);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template<class _CharT, class _Traits>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, __thread_id __id)\x0a"
"{return __os << __id.__id_;}\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS thread\x0a"
"{\x0a"
"    __libcpp_thread_t __t_;\x0a"
"\x0a"
"    thread(const thread\x26);\x0a"
"    thread\x26 operator=(const thread\x26);\x0a"
"public\x3a\x0a"
"    typedef __thread_id id;\x0a"
"    typedef __libcpp_thread_t native_handle_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    thread() _NOEXCEPT \x3a __t_(_LIBCPP_NULL_THREAD) {}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Fp, class ..._Args,\x0a"
"              class = typename enable_if\x0a"
"              <\x0a"
"                   \x21is_same<typename __uncvref<_Fp>\x3a\x3atype, thread>\x3a\x3avalue\x0a"
"              >\x3a\x3atype\x0a"
"             >\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        explicit thread(_Fp\x26\x26 __f, _Args\x26\x26... __args);\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"    template <class _Fp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    explicit thread(_Fp __f);\x0a"
"#endif\x0a"
"    \x7ethread();\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    thread(thread\x26\x26 __t) _NOEXCEPT \x3a __t_(__t.__t_) {__t.__t_ = _LIBCPP_NULL_THREAD;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    thread\x26 operator=(thread\x26\x26 __t) _NOEXCEPT;\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(thread\x26 __t) _NOEXCEPT {_VSTD\x3a\x3aswap(__t_, __t.__t_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool joinable() const _NOEXCEPT {return \x21__libcpp_thread_isnull(\x26__t_);}\x0a"
"    void join();\x0a"
"    void detach();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    id get_id() const _NOEXCEPT {return __libcpp_thread_get_id(\x26__t_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    native_handle_type native_handle() _NOEXCEPT {return __t_;}\x0a"
"\x0a"
"    static unsigned hardware_concurrency() _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _TSp, class _Fp, class ..._Args, size_t ..._Indices>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"__thread_execute(tuple<_TSp, _Fp, _Args...>\x26 __t, __tuple_indices<_Indices...>)\x0a"
"{\x0a"
"    __invoke(_VSTD\x3a\x3amove(_VSTD\x3a\x3aget<1>(__t)), _VSTD\x3a\x3amove(_VSTD\x3a\x3aget<_Indices>(__t))...);\x0a"
"}\x0a"
"\x0a"
"template <class _Fp>\x0a"
"void* __thread_proxy(void* __vp)\x0a"
"{\x0a"
"    // _Fp = std\x3a\x3atuple< unique_ptr<__thread_struct>, Functor, Args...>\x0a"
"    std\x3a\x3aunique_ptr<_Fp> __p(static_cast<_Fp*>(__vp));\x0a"
"    __thread_local_data().set_pointer(_VSTD\x3a\x3aget<0>(*__p).release());\x0a"
"    typedef typename __make_tuple_indices<tuple_size<_Fp>\x3a\x3avalue, 2>\x3a\x3atype _Index;\x0a"
"    __thread_execute(*__p, _Index());\x0a"
"    return nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _Fp, class ..._Args,\x0a"
"          class\x0a"
"         >\x0a"
"thread\x3a\x3athread(_Fp\x26\x26 __f, _Args\x26\x26... __args)\x0a"
"{\x0a"
"    typedef unique_ptr<__thread_struct> _TSPtr;\x0a"
"    _TSPtr __tsp(new __thread_struct);\x0a"
"    typedef tuple<_TSPtr, typename decay<_Fp>\x3a\x3atype, typename decay<_Args>\x3a\x3atype...> _Gp;\x0a"
"    _VSTD\x3a\x3aunique_ptr<_Gp> __p(\x0a"
"            new _Gp(std\x3a\x3amove(__tsp),\x0a"
"                    __decay_copy(_VSTD\x3a\x3a""forward<_Fp>(__f)),\x0a"
"                    __decay_copy(_VSTD\x3a\x3a""forward<_Args>(__args))...));\x0a"
"    int __ec = __libcpp_thread_create(\x26__t_, \x26__thread_proxy<_Gp>, __p.get());\x0a"
"    if (__ec == 0)\x0a"
"        __p.release();\x0a"
"    else\x0a"
"        __throw_system_error(__ec, \x22thread constructor failed\x22);\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"thread\x26\x0a"
"thread\x3a\x3aoperator=(thread\x26\x26 __t) _NOEXCEPT\x0a"
"{\x0a"
"    if (\x21__libcpp_thread_isnull(\x26__t_))\x0a"
"        terminate();\x0a"
"    __t_ = __t.__t_;\x0a"
"    __t.__t_ = _LIBCPP_NULL_THREAD;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Fp>\x0a"
"struct __thread_invoke_pair {\x0a"
"    // This type is used to pass memory for thread local storage and a functor\x0a"
"    // to a newly created thread because std\x3a\x3apair doesn't work with\x0a"
"    // std\x3a\x3aunique_ptr in C++03.\x0a"
"    __thread_invoke_pair(_Fp\x26 __f) \x3a __tsp_(new __thread_struct), __fn_(__f) {}\x0a"
"    unique_ptr<__thread_struct> __tsp_;\x0a"
"    _Fp __fn_;\x0a"
"};\x0a"
"\x0a"
"template <class _Fp>\x0a"
"void* __thread_proxy_cxx03(void* __vp)\x0a"
"{\x0a"
"    std\x3a\x3aunique_ptr<_Fp> __p(static_cast<_Fp*>(__vp));\x0a"
"    __thread_local_data().set_pointer(__p->__tsp_.release());\x0a"
"    (__p->__fn_)();\x0a"
"    return nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _Fp>\x0a"
"thread\x3a\x3athread(_Fp __f)\x0a"
"{\x0a"
"\x0a"
"    typedef __thread_invoke_pair<_Fp> _InvokePair;\x0a"
"    typedef std\x3a\x3aunique_ptr<_InvokePair> _PairPtr;\x0a"
"    _PairPtr __pp(new _InvokePair(__f));\x0a"
"    int __ec = __libcpp_thread_create(\x26__t_, \x26__thread_proxy_cxx03<_InvokePair>, __pp.get());\x0a"
"    if (__ec == 0)\x0a"
"        __pp.release();\x0a"
"    else\x0a"
"        __throw_system_error(__ec, \x22thread constructor failed\x22);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void swap(thread\x26 __x, thread\x26 __y) _NOEXCEPT {__x.swap(__y);}\x0a"
"\x0a"
"namespace this_thread\x0a"
"{\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS void sleep_for(const chrono\x3a\x3ananoseconds\x26 __ns);\x0a"
"\x0a"
"template <class _Rep, class _Period>\x0a"
"void\x0a"
"sleep_for(const chrono\x3a\x3a""duration<_Rep, _Period>\x26 __d)\x0a"
"{\x0a"
"    using namespace chrono;\x0a"
"    if (__d > duration<_Rep, _Period>\x3a\x3azero())\x0a"
"    {\x0a"
"#if defined(_LIBCPP_COMPILER_GCC) \x26\x26 (__powerpc__ \x7c\x7c __POWERPC__)\x0a"
"    //  GCC's long double const folding is incomplete for IBM128 long doubles.\x0a"
"        _LIBCPP_CONSTEXPR duration<long double> _Max = nanoseconds\x3a\x3amax();\x0a"
"#else\x0a"
"        _LIBCPP_CONSTEXPR duration<long double> _Max = duration<long double>(ULLONG_MAX/1000000000ULL) ;\x0a"
"#endif\x0a"
"        nanoseconds __ns;\x0a"
"        if (__d < _Max)\x0a"
"        {\x0a"
"            __ns = duration_cast<nanoseconds>(__d);\x0a"
"            if (__ns < __d)\x0a"
"                ++__ns;\x0a"
"        }\x0a"
"        else\x0a"
"            __ns = nanoseconds\x3a\x3amax();\x0a"
"        sleep_for(__ns);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Clock, class _Duration>\x0a"
"void\x0a"
"sleep_until(const chrono\x3a\x3atime_point<_Clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    using namespace chrono;\x0a"
"    mutex __mut;\x0a"
"    condition_variable __cv;\x0a"
"    unique_lock<mutex> __lk(__mut);\x0a"
"    while (_Clock\x3a\x3anow() < __t)\x0a"
"        __cv.wait_until(__lk, __t);\x0a"
"}\x0a"
"\x0a"
"template <class _Duration>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"sleep_until(const chrono\x3a\x3atime_point<chrono\x3a\x3asteady_clock, _Duration>\x26 __t)\x0a"
"{\x0a"
"    using namespace chrono;\x0a"
"    sleep_for(__t - steady_clock\x3a\x3anow());\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void yield() _NOEXCEPT {__libcpp_thread_yield();}\x0a"
"\x0a"
"}  // this_thread\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_THREAD\x0a"
"", 11533 ); }