#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_tuple( 
"// -*- C++ -*-\x0a"
"//===--------------------------- tuple ------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_TUPLE\x0a"
"#define _LIBCPP_TUPLE\x0a"
"\x0a"
"/*\x0a"
"    tuple synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class... T>\x0a"
"class tuple {\x0a"
"public\x3a\x0a"
"    constexpr tuple();\x0a"
"    explicit tuple(const T\x26...);  // constexpr in C++14\x0a"
"    template <class... U>\x0a"
"        explicit tuple(U\x26\x26...);  // constexpr in C++14\x0a"
"    tuple(const tuple\x26) = default;\x0a"
"    tuple(tuple\x26\x26) = default;\x0a"
"    template <class... U>\x0a"
"        tuple(const tuple<U...>\x26);  // constexpr in C++14\x0a"
"    template <class... U>\x0a"
"        tuple(tuple<U...>\x26\x26);  // constexpr in C++14\x0a"
"    template <class U1, class U2>\x0a"
"        tuple(const pair<U1, U2>\x26); // iff sizeof...(T) == 2 // constexpr in C++14\x0a"
"    template <class U1, class U2>\x0a"
"        tuple(pair<U1, U2>\x26\x26); // iff sizeof...(T) == 2  // constexpr in C++14\x0a"
"\x0a"
"    // allocator-extended constructors\x0a"
"    template <class Alloc>\x0a"
"        tuple(allocator_arg_t, const Alloc\x26 a);\x0a"
"    template <class Alloc>\x0a"
"        tuple(allocator_arg_t, const Alloc\x26 a, const T\x26...);\x0a"
"    template <class Alloc, class... U>\x0a"
"        tuple(allocator_arg_t, const Alloc\x26 a, U\x26\x26...);\x0a"
"    template <class Alloc>\x0a"
"        tuple(allocator_arg_t, const Alloc\x26 a, const tuple\x26);\x0a"
"    template <class Alloc>\x0a"
"        tuple(allocator_arg_t, const Alloc\x26 a, tuple\x26\x26);\x0a"
"    template <class Alloc, class... U>\x0a"
"        tuple(allocator_arg_t, const Alloc\x26 a, const tuple<U...>\x26);\x0a"
"    template <class Alloc, class... U>\x0a"
"        tuple(allocator_arg_t, const Alloc\x26 a, tuple<U...>\x26\x26);\x0a"
"    template <class Alloc, class U1, class U2>\x0a"
"        tuple(allocator_arg_t, const Alloc\x26 a, const pair<U1, U2>\x26);\x0a"
"    template <class Alloc, class U1, class U2>\x0a"
"        tuple(allocator_arg_t, const Alloc\x26 a, pair<U1, U2>\x26\x26);\x0a"
"\x0a"
"    tuple\x26 operator=(const tuple\x26);\x0a"
"    tuple\x26\x0a"
"        operator=(tuple\x26\x26) noexcept(AND(is_nothrow_move_assignable<T>\x3a\x3avalue ...));\x0a"
"    template <class... U>\x0a"
"        tuple\x26 operator=(const tuple<U...>\x26);\x0a"
"    template <class... U>\x0a"
"        tuple\x26 operator=(tuple<U...>\x26\x26);\x0a"
"    template <class U1, class U2>\x0a"
"        tuple\x26 operator=(const pair<U1, U2>\x26); // iff sizeof...(T) == 2\x0a"
"    template <class U1, class U2>\x0a"
"        tuple\x26 operator=(pair<U1, U2>\x26\x26); // iff sizeof...(T) == 2\x0a"
"\x0a"
"    void swap(tuple\x26) noexcept(AND(swap(declval<T\x26>(), declval<T\x26>())...));\x0a"
"};\x0a"
"\x0a"
"inline constexpr unspecified ignore;\x0a"
"\x0a"
"template <class... T> tuple<V...>  make_tuple(T\x26\x26...); // constexpr in C++14\x0a"
"template <class... T> tuple<ATypes...> forward_as_tuple(T\x26\x26...) noexcept; // constexpr in C++14\x0a"
"template <class... T> tuple<T\x26...> tie(T\x26...) noexcept; // constexpr in C++14\x0a"
"template <class... Tuples> tuple<CTypes...> tuple_cat(Tuples\x26\x26... tpls); // constexpr in C++14\x0a"
"\x0a"
"// \x5btuple.apply\x5d, calling a function with a tuple of arguments\x3a\x0a"
"template <class F, class Tuple>\x0a"
"  constexpr decltype(auto) apply(F\x26\x26 f, Tuple\x26\x26 t); // C++17\x0a"
"template <class T, class Tuple>\x0a"
"  constexpr T make_from_tuple(Tuple\x26\x26 t); // C++17\x0a"
"\x0a"
"// 20.4.1.4, tuple helper classes\x3a\x0a"
"template <class T> struct tuple_size; // undefined\x0a"
"template <class... T> struct tuple_size<tuple<T...>>;\x0a"
"template <class T>\x0a"
" inline constexpr size_t tuple_size_v = tuple_size<T>\x3a\x3avalue; // C++17\x0a"
"template <size_t I, class T> struct tuple_element; // undefined\x0a"
"template <size_t I, class... T> struct tuple_element<I, tuple<T...>>;\x0a"
"template <size_t I, class T>\x0a"
"  using tuple_element_t = typename tuple_element <I, T>\x3a\x3atype; // C++14\x0a"
"\x0a"
"// 20.4.1.5, element access\x3a\x0a"
"template <size_t I, class... T>\x0a"
"    typename tuple_element<I, tuple<T...>>\x3a\x3atype\x26\x0a"
"    get(tuple<T...>\x26) noexcept; // constexpr in C++14\x0a"
"template <size_t I, class... T>\x0a"
"    const typename tuple_element<I, tuple<T...>>\x3a\x3atype\x26\x0a"
"    get(const tuple<T...>\x26) noexcept; // constexpr in C++14\x0a"
"template <size_t I, class... T>\x0a"
"    typename tuple_element<I, tuple<T...>>\x3a\x3atype\x26\x26\x0a"
"    get(tuple<T...>\x26\x26) noexcept; // constexpr in C++14\x0a"
"template <size_t I, class... T>\x0a"
"    const typename tuple_element<I, tuple<T...>>\x3a\x3atype\x26\x26\x0a"
"    get(const tuple<T...>\x26\x26) noexcept; // constexpr in C++14\x0a"
"\x0a"
"template <class T1, class... T>\x0a"
"    constexpr T1\x26 get(tuple<T...>\x26) noexcept;  // C++14\x0a"
"template <class T1, class... T>\x0a"
"    constexpr const T1\x26 get(const tuple<T...>\x26) noexcept;   // C++14\x0a"
"template <class T1, class... T>\x0a"
"    constexpr T1\x26\x26 get(tuple<T...>\x26\x26) noexcept;   // C++14\x0a"
"template <class T1, class... T>\x0a"
"    constexpr const T1\x26\x26 get(const tuple<T...>\x26\x26) noexcept;   // C++14\x0a"
"\x0a"
"// 20.4.1.6, relational operators\x3a\x0a"
"template<class... T, class... U> bool operator==(const tuple<T...>\x26, const tuple<U...>\x26); // constexpr in C++14\x0a"
"template<class... T, class... U> bool operator<(const tuple<T...>\x26, const tuple<U...>\x26);  // constexpr in C++14\x0a"
"template<class... T, class... U> bool operator\x21=(const tuple<T...>\x26, const tuple<U...>\x26); // constexpr in C++14\x0a"
"template<class... T, class... U> bool operator>(const tuple<T...>\x26, const tuple<U...>\x26);  // constexpr in C++14\x0a"
"template<class... T, class... U> bool operator<=(const tuple<T...>\x26, const tuple<U...>\x26); // constexpr in C++14\x0a"
"template<class... T, class... U> bool operator>=(const tuple<T...>\x26, const tuple<U...>\x26); // constexpr in C++14\x0a"
"\x0a"
"template <class... Types, class Alloc>\x0a"
"  struct uses_allocator<tuple<Types...>, Alloc>;\x0a"
"\x0a"
"template <class... Types>\x0a"
"  void\x0a"
"  swap(tuple<Types...>\x26 x, tuple<Types...>\x26 y) noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__tuple>\x0a"
"#include <cstddef>\x0a"
"#include <type_traits>\x0a"
"#include <__functional_base>\x0a"
"#include <utility>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"\x0a"
"// __tuple_leaf\x0a"
"\x0a"
"template <size_t _Ip, class _Hp,\x0a"
"          bool=is_empty<_Hp>\x3a\x3avalue \x26\x26 \x21__libcpp_is_final<_Hp>\x3a\x3avalue\x0a"
"         >\x0a"
"class __tuple_leaf;\x0a"
"\x0a"
"template <size_t _Ip, class _Hp, bool _Ep>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void swap(__tuple_leaf<_Ip, _Hp, _Ep>\x26 __x, __tuple_leaf<_Ip, _Hp, _Ep>\x26 __y)\x0a"
"    _NOEXCEPT_(__is_nothrow_swappable<_Hp>\x3a\x3avalue)\x0a"
"{\x0a"
"    swap(__x.get(), __y.get());\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class _Hp, bool>\x0a"
"class __tuple_leaf\x0a"
"{\x0a"
"    _Hp __value_;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    static constexpr bool __can_bind_reference() {\x0a"
"#if __has_keyword(__reference_binds_to_temporary)\x0a"
"      return \x21__reference_binds_to_temporary(_Hp, _Tp);\x0a"
"#else\x0a"
"      return true;\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    __tuple_leaf\x26 operator=(const __tuple_leaf\x26);\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR __tuple_leaf()\x0a"
"             _NOEXCEPT_(is_nothrow_default_constructible<_Hp>\x3a\x3avalue) \x3a __value_()\x0a"
"       {static_assert(\x21is_reference<_Hp>\x3a\x3avalue,\x0a"
"              \x22""Attempted to default construct a reference element in a tuple\x22);}\x0a"
"\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __tuple_leaf(integral_constant<int, 0>, const _Alloc\x26)\x0a"
"            \x3a __value_()\x0a"
"        {static_assert(\x21is_reference<_Hp>\x3a\x3avalue,\x0a"
"              \x22""Attempted to default construct a reference element in a tuple\x22);}\x0a"
"\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __tuple_leaf(integral_constant<int, 1>, const _Alloc\x26 __a)\x0a"
"            \x3a __value_(allocator_arg_t(), __a)\x0a"
"        {static_assert(\x21is_reference<_Hp>\x3a\x3avalue,\x0a"
"              \x22""Attempted to default construct a reference element in a tuple\x22);}\x0a"
"\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __tuple_leaf(integral_constant<int, 2>, const _Alloc\x26 __a)\x0a"
"            \x3a __value_(__a)\x0a"
"        {static_assert(\x21is_reference<_Hp>\x3a\x3avalue,\x0a"
"              \x22""Attempted to default construct a reference element in a tuple\x22);}\x0a"
"\x0a"
"    template <class _Tp,\x0a"
"              class = _EnableIf<\x0a"
"                  _And<\x0a"
"                      _IsNotSame<__uncvref_t<_Tp>, __tuple_leaf>,\x0a"
"                      is_constructible<_Hp, _Tp>\x0a"
"                    >\x3a\x3avalue\x0a"
"                >\x0a"
"            >\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        explicit __tuple_leaf(_Tp\x26\x26 __t) _NOEXCEPT_((is_nothrow_constructible<_Hp, _Tp>\x3a\x3avalue))\x0a"
"            \x3a __value_(_VSTD\x3a\x3a""forward<_Tp>(__t))\x0a"
"        {static_assert(__can_bind_reference<_Tp\x26\x26>(),\x0a"
"       \x22""Attempted construction of reference element binds to a temporary whose lifetime has ended\x22);}\x0a"
"\x0a"
"    template <class _Tp, class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit __tuple_leaf(integral_constant<int, 0>, const _Alloc\x26, _Tp\x26\x26 __t)\x0a"
"            \x3a __value_(_VSTD\x3a\x3a""forward<_Tp>(__t))\x0a"
"        {static_assert(__can_bind_reference<_Tp\x26\x26>(),\x0a"
"       \x22""Attempted construction of reference element binds to a temporary whose lifetime has ended\x22);}\x0a"
"\x0a"
"    template <class _Tp, class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit __tuple_leaf(integral_constant<int, 1>, const _Alloc\x26 __a, _Tp\x26\x26 __t)\x0a"
"            \x3a __value_(allocator_arg_t(), __a, _VSTD\x3a\x3a""forward<_Tp>(__t))\x0a"
"        {static_assert(\x21is_reference<_Hp>\x3a\x3avalue,\x0a"
"            \x22""Attempted to uses-allocator construct a reference element in a tuple\x22);}\x0a"
"\x0a"
"    template <class _Tp, class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit __tuple_leaf(integral_constant<int, 2>, const _Alloc\x26 __a, _Tp\x26\x26 __t)\x0a"
"            \x3a __value_(_VSTD\x3a\x3a""forward<_Tp>(__t), __a)\x0a"
"        {static_assert(\x21is_reference<_Hp>\x3a\x3avalue,\x0a"
"           \x22""Attempted to uses-allocator construct a reference element in a tuple\x22);}\x0a"
"\x0a"
"    __tuple_leaf(const __tuple_leaf\x26 __t) = default;\x0a"
"    __tuple_leaf(__tuple_leaf\x26\x26 __t) = default;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __tuple_leaf\x26\x0a"
"        operator=(_Tp\x26\x26 __t) _NOEXCEPT_((is_nothrow_assignable<_Hp\x26, _Tp>\x3a\x3avalue))\x0a"
"        {\x0a"
"            __value_ = _VSTD\x3a\x3a""forward<_Tp>(__t);\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int swap(__tuple_leaf\x26 __t) _NOEXCEPT_(__is_nothrow_swappable<__tuple_leaf>\x3a\x3avalue)\x0a"
"    {\x0a"
"        _VSTD\x3a\x3aswap(*this, __t);\x0a"
"        return 0;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11       _Hp\x26 get()       _NOEXCEPT {return __value_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 const _Hp\x26 get() const _NOEXCEPT {return __value_;}\x0a"
"};\x0a"
"\x0a"
"template <size_t _Ip, class _Hp>\x0a"
"class __tuple_leaf<_Ip, _Hp, true>\x0a"
"    \x3a private _Hp\x0a"
"{\x0a"
"\x0a"
"    __tuple_leaf\x26 operator=(const __tuple_leaf\x26);\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR __tuple_leaf()\x0a"
"             _NOEXCEPT_(is_nothrow_default_constructible<_Hp>\x3a\x3avalue) {}\x0a"
"\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __tuple_leaf(integral_constant<int, 0>, const _Alloc\x26) {}\x0a"
"\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __tuple_leaf(integral_constant<int, 1>, const _Alloc\x26 __a)\x0a"
"            \x3a _Hp(allocator_arg_t(), __a) {}\x0a"
"\x0a"
"    template <class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __tuple_leaf(integral_constant<int, 2>, const _Alloc\x26 __a)\x0a"
"            \x3a _Hp(__a) {}\x0a"
"\x0a"
"    template <class _Tp,\x0a"
"              class = _EnableIf<\x0a"
"                  _And<\x0a"
"                    _IsNotSame<__uncvref_t<_Tp>, __tuple_leaf>,\x0a"
"                    is_constructible<_Hp, _Tp>\x0a"
"                  >\x3a\x3avalue\x0a"
"                >\x0a"
"            >\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        explicit __tuple_leaf(_Tp\x26\x26 __t) _NOEXCEPT_((is_nothrow_constructible<_Hp, _Tp>\x3a\x3avalue))\x0a"
"            \x3a _Hp(_VSTD\x3a\x3a""forward<_Tp>(__t)) {}\x0a"
"\x0a"
"    template <class _Tp, class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit __tuple_leaf(integral_constant<int, 0>, const _Alloc\x26, _Tp\x26\x26 __t)\x0a"
"            \x3a _Hp(_VSTD\x3a\x3a""forward<_Tp>(__t)) {}\x0a"
"\x0a"
"    template <class _Tp, class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit __tuple_leaf(integral_constant<int, 1>, const _Alloc\x26 __a, _Tp\x26\x26 __t)\x0a"
"            \x3a _Hp(allocator_arg_t(), __a, _VSTD\x3a\x3a""forward<_Tp>(__t)) {}\x0a"
"\x0a"
"    template <class _Tp, class _Alloc>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit __tuple_leaf(integral_constant<int, 2>, const _Alloc\x26 __a, _Tp\x26\x26 __t)\x0a"
"            \x3a _Hp(_VSTD\x3a\x3a""forward<_Tp>(__t), __a) {}\x0a"
"\x0a"
"    __tuple_leaf(__tuple_leaf const \x26) = default;\x0a"
"    __tuple_leaf(__tuple_leaf \x26\x26) = default;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __tuple_leaf\x26\x0a"
"        operator=(_Tp\x26\x26 __t) _NOEXCEPT_((is_nothrow_assignable<_Hp\x26, _Tp>\x3a\x3avalue))\x0a"
"        {\x0a"
"            _Hp\x3a\x3aoperator=(_VSTD\x3a\x3a""forward<_Tp>(__t));\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int\x0a"
"    swap(__tuple_leaf\x26 __t) _NOEXCEPT_(__is_nothrow_swappable<__tuple_leaf>\x3a\x3avalue)\x0a"
"    {\x0a"
"        _VSTD\x3a\x3aswap(*this, __t);\x0a"
"        return 0;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11       _Hp\x26 get()       _NOEXCEPT {return static_cast<_Hp\x26>(*this);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 const _Hp\x26 get() const _NOEXCEPT {return static_cast<const _Hp\x26>(*this);}\x0a"
"};\x0a"
"\x0a"
"template <class ..._Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __swallow(_Tp\x26\x26...) _NOEXCEPT {}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __all_default_constructible;\x0a"
"\x0a"
"template <class ..._Tp>\x0a"
"struct __all_default_constructible<__tuple_types<_Tp...>>\x0a"
"    \x3a __all<is_default_constructible<_Tp>\x3a\x3avalue...>\x0a"
"{ };\x0a"
"\x0a"
"// __tuple_impl\x0a"
"\x0a"
"template<class _Indx, class ..._Tp> struct __tuple_impl;\x0a"
"\x0a"
"template<size_t ..._Indx, class ..._Tp>\x0a"
"struct _LIBCPP_DECLSPEC_EMPTY_BASES __tuple_impl<__tuple_indices<_Indx...>, _Tp...>\x0a"
"    \x3a public __tuple_leaf<_Indx, _Tp>...\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR __tuple_impl()\x0a"
"        _NOEXCEPT_(__all<is_nothrow_default_constructible<_Tp>\x3a\x3avalue...>\x3a\x3avalue) {}\x0a"
"\x0a"
"    template <size_t ..._Uf, class ..._Tf,\x0a"
"              size_t ..._Ul, class ..._Tl, class ..._Up>\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        explicit\x0a"
"        __tuple_impl(__tuple_indices<_Uf...>, __tuple_types<_Tf...>,\x0a"
"                     __tuple_indices<_Ul...>, __tuple_types<_Tl...>,\x0a"
"                     _Up\x26\x26... __u)\x0a"
"                     _NOEXCEPT_((__all<is_nothrow_constructible<_Tf, _Up>\x3a\x3avalue...>\x3a\x3avalue \x26\x26\x0a"
"                                 __all<is_nothrow_default_constructible<_Tl>\x3a\x3avalue...>\x3a\x3avalue)) \x3a\x0a"
"            __tuple_leaf<_Uf, _Tf>(_VSTD\x3a\x3a""forward<_Up>(__u))...,\x0a"
"            __tuple_leaf<_Ul, _Tl>()...\x0a"
"            {}\x0a"
"\x0a"
"    template <class _Alloc, size_t ..._Uf, class ..._Tf,\x0a"
"              size_t ..._Ul, class ..._Tl, class ..._Up>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit\x0a"
"        __tuple_impl(allocator_arg_t, const _Alloc\x26 __a,\x0a"
"                     __tuple_indices<_Uf...>, __tuple_types<_Tf...>,\x0a"
"                     __tuple_indices<_Ul...>, __tuple_types<_Tl...>,\x0a"
"                     _Up\x26\x26... __u) \x3a\x0a"
"            __tuple_leaf<_Uf, _Tf>(__uses_alloc_ctor<_Tf, _Alloc, _Up>(), __a,\x0a"
"            _VSTD\x3a\x3a""forward<_Up>(__u))...,\x0a"
"            __tuple_leaf<_Ul, _Tl>(__uses_alloc_ctor<_Tl, _Alloc>(), __a)...\x0a"
"            {}\x0a"
"\x0a"
"    template <class _Tuple,\x0a"
"              class = typename enable_if\x0a"
"                      <\x0a"
"                         __tuple_constructible<_Tuple, tuple<_Tp...> >\x3a\x3avalue\x0a"
"                      >\x3a\x3atype\x0a"
"             >\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        __tuple_impl(_Tuple\x26\x26 __t) _NOEXCEPT_((__all<is_nothrow_constructible<_Tp, typename tuple_element<_Indx,\x0a"
"                                       typename __make_tuple_types<_Tuple>\x3a\x3atype>\x3a\x3atype>\x3a\x3avalue...>\x3a\x3avalue))\x0a"
"            \x3a __tuple_leaf<_Indx, _Tp>(_VSTD\x3a\x3a""forward<typename tuple_element<_Indx,\x0a"
"                                       typename __make_tuple_types<_Tuple>\x3a\x3atype>\x3a\x3atype>(_VSTD\x3a\x3aget<_Indx>(__t)))...\x0a"
"            {}\x0a"
"\x0a"
"    template <class _Alloc, class _Tuple,\x0a"
"              class = typename enable_if\x0a"
"                      <\x0a"
"                         __tuple_constructible<_Tuple, tuple<_Tp...> >\x3a\x3avalue\x0a"
"                      >\x3a\x3atype\x0a"
"             >\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __tuple_impl(allocator_arg_t, const _Alloc\x26 __a, _Tuple\x26\x26 __t)\x0a"
"            \x3a __tuple_leaf<_Indx, _Tp>(__uses_alloc_ctor<_Tp, _Alloc, typename tuple_element<_Indx,\x0a"
"                                       typename __make_tuple_types<_Tuple>\x3a\x3atype>\x3a\x3atype>(), __a,\x0a"
"                                       _VSTD\x3a\x3a""forward<typename tuple_element<_Indx,\x0a"
"                                       typename __make_tuple_types<_Tuple>\x3a\x3atype>\x3a\x3atype>(_VSTD\x3a\x3aget<_Indx>(__t)))...\x0a"
"            {}\x0a"
"\x0a"
"    template <class _Tuple>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __tuple_assignable<_Tuple, tuple<_Tp...> >\x3a\x3avalue,\x0a"
"            __tuple_impl\x26\x0a"
"        >\x3a\x3atype\x0a"
"        operator=(_Tuple\x26\x26 __t) _NOEXCEPT_((__all<is_nothrow_assignable<_Tp\x26, typename tuple_element<_Indx,\x0a"
"                                       typename __make_tuple_types<_Tuple>\x3a\x3atype>\x3a\x3atype>\x3a\x3avalue...>\x3a\x3avalue))\x0a"
"        {\x0a"
"            __swallow(__tuple_leaf<_Indx, _Tp>\x3a\x3aoperator=(_VSTD\x3a\x3a""forward<typename tuple_element<_Indx,\x0a"
"                                       typename __make_tuple_types<_Tuple>\x3a\x3atype>\x3a\x3atype>(_VSTD\x3a\x3aget<_Indx>(__t)))...);\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"    __tuple_impl(const __tuple_impl\x26) = default;\x0a"
"    __tuple_impl(__tuple_impl\x26\x26) = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tuple_impl\x26\x0a"
"    operator=(const __tuple_impl\x26 __t) _NOEXCEPT_((__all<is_nothrow_copy_assignable<_Tp>\x3a\x3avalue...>\x3a\x3avalue))\x0a"
"    {\x0a"
"        __swallow(__tuple_leaf<_Indx, _Tp>\x3a\x3aoperator=(static_cast<const __tuple_leaf<_Indx, _Tp>\x26>(__t).get())...);\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __tuple_impl\x26\x0a"
"    operator=(__tuple_impl\x26\x26 __t) _NOEXCEPT_((__all<is_nothrow_move_assignable<_Tp>\x3a\x3avalue...>\x3a\x3avalue))\x0a"
"    {\x0a"
"        __swallow(__tuple_leaf<_Indx, _Tp>\x3a\x3aoperator=(_VSTD\x3a\x3a""forward<_Tp>(static_cast<__tuple_leaf<_Indx, _Tp>\x26>(__t).get()))...);\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(__tuple_impl\x26 __t)\x0a"
"        _NOEXCEPT_(__all<__is_nothrow_swappable<_Tp>\x3a\x3avalue...>\x3a\x3avalue)\x0a"
"    {\x0a"
"        __swallow(__tuple_leaf<_Indx, _Tp>\x3a\x3aswap(static_cast<__tuple_leaf<_Indx, _Tp>\x26>(__t))...);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"\x0a"
"template <class ..._Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS tuple\x0a"
"{\x0a"
"    typedef __tuple_impl<typename __make_tuple_indices<sizeof...(_Tp)>\x3a\x3atype, _Tp...> _BaseT;\x0a"
"\x0a"
"    _BaseT __base_;\x0a"
"\x0a"
"#if defined(_LIBCPP_ENABLE_TUPLE_IMPLICIT_REDUCED_ARITY_EXTENSION)\x0a"
"    static constexpr bool _EnableImplicitReducedArityExtension = true;\x0a"
"#else\x0a"
"    static constexpr bool _EnableImplicitReducedArityExtension = false;\x0a"
"#endif\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"    struct _PackExpandsToThisTuple \x3a false_type {};\x0a"
"\x0a"
"    template <class _Arg>\x0a"
"    struct _PackExpandsToThisTuple<_Arg>\x0a"
"        \x3a is_same<typename __uncvref<_Arg>\x3a\x3atype, tuple> {};\x0a"
"\x0a"
"    template <bool _MaybeEnable, class _Dummy = void>\x0a"
"    struct _CheckArgsConstructor \x3a __check_tuple_constructor_fail {};\x0a"
"\x0a"
"    template <class _Dummy>\x0a"
"    struct _CheckArgsConstructor<true, _Dummy>\x0a"
"    {\x0a"
"        template <class ..._Args>\x0a"
"        static constexpr bool __enable_default() {\x0a"
"            return __all<is_default_constructible<_Args>\x3a\x3avalue...>\x3a\x3avalue;\x0a"
"        }\x0a"
"\x0a"
"        template <class ..._Args>\x0a"
"        static constexpr bool __enable_explicit() {\x0a"
"            return\x0a"
"                __tuple_constructible<\x0a"
"                    tuple<_Args...>,\x0a"
"                    typename __make_tuple_types<tuple,\x0a"
"                             sizeof...(_Args) < sizeof...(_Tp) \x3f\x0a"
"                                 sizeof...(_Args) \x3a\x0a"
"                                 sizeof...(_Tp)>\x3a\x3atype\x0a"
"                >\x3a\x3avalue \x26\x26\x0a"
"                \x21__tuple_convertible<\x0a"
"                    tuple<_Args...>,\x0a"
"                    typename __make_tuple_types<tuple,\x0a"
"                             sizeof...(_Args) < sizeof...(_Tp) \x3f\x0a"
"                                 sizeof...(_Args) \x3a\x0a"
"                                 sizeof...(_Tp)>\x3a\x3atype\x0a"
"                >\x3a\x3avalue \x26\x26\x0a"
"                __all_default_constructible<\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Tp),\x0a"
"                             sizeof...(_Args) < sizeof...(_Tp) \x3f\x0a"
"                                 sizeof...(_Args) \x3a\x0a"
"                                 sizeof...(_Tp)>\x3a\x3atype\x0a"
"                >\x3a\x3avalue;\x0a"
"        }\x0a"
"\x0a"
"        template <class ..._Args>\x0a"
"        static constexpr bool __enable_implicit() {\x0a"
"            return\x0a"
"               __tuple_constructible<\x0a"
"                    tuple<_Args...>,\x0a"
"                    typename __make_tuple_types<tuple,\x0a"
"                             sizeof...(_Args) < sizeof...(_Tp) \x3f\x0a"
"                                 sizeof...(_Args) \x3a\x0a"
"                                 sizeof...(_Tp)>\x3a\x3atype\x0a"
"                >\x3a\x3avalue \x26\x26\x0a"
"                __tuple_convertible<\x0a"
"                    tuple<_Args...>,\x0a"
"                    typename __make_tuple_types<tuple,\x0a"
"                             sizeof...(_Args) < sizeof...(_Tp) \x3f\x0a"
"                                 sizeof...(_Args) \x3a\x0a"
"                                 sizeof...(_Tp)>\x3a\x3atype\x0a"
"                >\x3a\x3avalue \x26\x26\x0a"
"                __all_default_constructible<\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Tp),\x0a"
"                             sizeof...(_Args) < sizeof...(_Tp) \x3f\x0a"
"                                 sizeof...(_Args) \x3a\x0a"
"                                 sizeof...(_Tp)>\x3a\x3atype\x0a"
"                >\x3a\x3avalue;\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"    template <bool _MaybeEnable,\x0a"
"              bool = sizeof...(_Tp) == 1,\x0a"
"              class _Dummy = void>\x0a"
"    struct _CheckTupleLikeConstructor \x3a __check_tuple_constructor_fail {};\x0a"
"\x0a"
"    template <class _Dummy>\x0a"
"    struct _CheckTupleLikeConstructor<true, false, _Dummy>\x0a"
"    {\x0a"
"        template <class _Tuple>\x0a"
"        static constexpr bool __enable_implicit() {\x0a"
"            return __tuple_constructible<_Tuple, tuple>\x3a\x3avalue\x0a"
"                \x26\x26 __tuple_convertible<_Tuple, tuple>\x3a\x3avalue;\x0a"
"        }\x0a"
"\x0a"
"        template <class _Tuple>\x0a"
"        static constexpr bool __enable_explicit() {\x0a"
"            return __tuple_constructible<_Tuple, tuple>\x3a\x3avalue\x0a"
"               \x26\x26 \x21__tuple_convertible<_Tuple, tuple>\x3a\x3avalue;\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"    template <class _Dummy>\x0a"
"    struct _CheckTupleLikeConstructor<true, true, _Dummy>\x0a"
"    {\x0a"
"        // This trait is used to disable the tuple-like constructor when\x0a"
"        // the UTypes... constructor should be selected instead.\x0a"
"        // See LWG issue #2549.\x0a"
"        template <class _Tuple>\x0a"
"        using _PreferTupleLikeConstructor = _Or<\x0a"
"            // Don't attempt the two checks below if the tuple we are given\x0a"
"            // has the same type as this tuple.\x0a"
"            _IsSame<__uncvref_t<_Tuple>, tuple>,\x0a"
"            _Lazy<_And,\x0a"
"                _Not<is_constructible<_Tp..., _Tuple>>,\x0a"
"                _Not<is_convertible<_Tuple, _Tp...>>\x0a"
"            >\x0a"
"        >;\x0a"
"\x0a"
"        template <class _Tuple>\x0a"
"        static constexpr bool __enable_implicit() {\x0a"
"            return _And<\x0a"
"                __tuple_constructible<_Tuple, tuple>,\x0a"
"                __tuple_convertible<_Tuple, tuple>,\x0a"
"                _PreferTupleLikeConstructor<_Tuple>\x0a"
"            >\x3a\x3avalue;\x0a"
"        }\x0a"
"\x0a"
"        template <class _Tuple>\x0a"
"        static constexpr bool __enable_explicit() {\x0a"
"            return _And<\x0a"
"                __tuple_constructible<_Tuple, tuple>,\x0a"
"                _PreferTupleLikeConstructor<_Tuple>,\x0a"
"                _Not<__tuple_convertible<_Tuple, tuple>>\x0a"
"            >\x3a\x3avalue;\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"    template <class _Tuple, bool _DisableIfLValue>\x0a"
"    using _EnableImplicitTupleLikeConstructor = _EnableIf<\x0a"
"                         _CheckTupleLikeConstructor<\x0a"
"                             __tuple_like_with_size<_Tuple, sizeof...(_Tp)>\x3a\x3avalue\x0a"
"                             \x26\x26 \x21_PackExpandsToThisTuple<_Tuple>\x3a\x3avalue\x0a"
"                             \x26\x26 (\x21is_lvalue_reference<_Tuple>\x3a\x3avalue \x7c\x7c \x21_DisableIfLValue)\x0a"
"                         >\x3a\x3atemplate __enable_implicit<_Tuple>(),\x0a"
"                         bool\x0a"
"                      >;\x0a"
"\x0a"
"    template <class _Tuple, bool _DisableIfLValue>\x0a"
"    using _EnableExplicitTupleLikeConstructor = _EnableIf<\x0a"
"                         _CheckTupleLikeConstructor<\x0a"
"                             __tuple_like_with_size<_Tuple, sizeof...(_Tp)>\x3a\x3avalue\x0a"
"                             \x26\x26 \x21_PackExpandsToThisTuple<_Tuple>\x3a\x3avalue\x0a"
"                             \x26\x26 (\x21is_lvalue_reference<_Tuple>\x3a\x3avalue \x7c\x7c \x21_DisableIfLValue)\x0a"
"                         >\x3a\x3atemplate __enable_explicit<_Tuple>(),\x0a"
"                         bool\x0a"
"                      >;\x0a"
"    template <size_t _Jp, class ..._Up> friend _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        typename tuple_element<_Jp, tuple<_Up...> >\x3a\x3atype\x26 get(tuple<_Up...>\x26) _NOEXCEPT;\x0a"
"    template <size_t _Jp, class ..._Up> friend _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        const typename tuple_element<_Jp, tuple<_Up...> >\x3a\x3atype\x26 get(const tuple<_Up...>\x26) _NOEXCEPT;\x0a"
"    template <size_t _Jp, class ..._Up> friend _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        typename tuple_element<_Jp, tuple<_Up...> >\x3a\x3atype\x26\x26 get(tuple<_Up...>\x26\x26) _NOEXCEPT;\x0a"
"    template <size_t _Jp, class ..._Up> friend _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        const typename tuple_element<_Jp, tuple<_Up...> >\x3a\x3atype\x26\x26 get(const tuple<_Up...>\x26\x26) _NOEXCEPT;\x0a"
"public\x3a\x0a"
"\x0a"
"    template <bool _Dummy = true, class = typename enable_if<\x0a"
"        _CheckArgsConstructor<_Dummy>\x3a\x3atemplate __enable_default<_Tp...>()\x0a"
"    >\x3a\x3atype>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR tuple()\x0a"
"        _NOEXCEPT_(__all<is_nothrow_default_constructible<_Tp>\x3a\x3avalue...>\x3a\x3avalue) {}\x0a"
"\x0a"
"    tuple(tuple const\x26) = default;\x0a"
"    tuple(tuple\x26\x26) = default;\x0a"
"\x0a"
"    template <class _AllocArgT, class _Alloc, bool _Dummy = true, class = _EnableIf<\x0a"
"        _And<\x0a"
"            _IsSame<allocator_arg_t, _AllocArgT>,\x0a"
"           __dependent_type<is_default_constructible<_Tp>, _Dummy>...\x0a"
"       >\x3a\x3avalue\x0a"
"      >\x0a"
"    >\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    tuple(_AllocArgT, _Alloc const\x26 __a)\x0a"
"      \x3a __base_(allocator_arg_t(), __a,\x0a"
"                    __tuple_indices<>(), __tuple_types<>(),\x0a"
"                    typename __make_tuple_indices<sizeof...(_Tp), 0>\x3a\x3atype(),\x0a"
"                    __tuple_types<_Tp...>()) {}\x0a"
"\x0a"
"    template <bool _Dummy = true,\x0a"
"              typename enable_if\x0a"
"                      <\x0a"
"                         _CheckArgsConstructor<\x0a"
"                            _Dummy\x0a"
"                         >\x3a\x3atemplate __enable_implicit<_Tp const\x26...>(),\x0a"
"                         bool\x0a"
"                      >\x3a\x3atype = false\x0a"
"        >\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    tuple(const _Tp\x26 ... __t) _NOEXCEPT_((__all<is_nothrow_copy_constructible<_Tp>\x3a\x3avalue...>\x3a\x3avalue))\x0a"
"        \x3a __base_(typename __make_tuple_indices<sizeof...(_Tp)>\x3a\x3atype(),\x0a"
"                typename __make_tuple_types<tuple, sizeof...(_Tp)>\x3a\x3atype(),\x0a"
"                typename __make_tuple_indices<0>\x3a\x3atype(),\x0a"
"                typename __make_tuple_types<tuple, 0>\x3a\x3atype(),\x0a"
"                __t...\x0a"
"               ) {}\x0a"
"\x0a"
"    template <bool _Dummy = true,\x0a"
"              typename enable_if\x0a"
"                      <\x0a"
"                         _CheckArgsConstructor<\x0a"
"                            _Dummy\x0a"
"                         >\x3a\x3atemplate __enable_explicit<_Tp const\x26...>(),\x0a"
"                         bool\x0a"
"                      >\x3a\x3atype = false\x0a"
"        >\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    explicit tuple(const _Tp\x26 ... __t) _NOEXCEPT_((__all<is_nothrow_copy_constructible<_Tp>\x3a\x3avalue...>\x3a\x3avalue))\x0a"
"        \x3a __base_(typename __make_tuple_indices<sizeof...(_Tp)>\x3a\x3atype(),\x0a"
"                typename __make_tuple_types<tuple, sizeof...(_Tp)>\x3a\x3atype(),\x0a"
"                typename __make_tuple_indices<0>\x3a\x3atype(),\x0a"
"                typename __make_tuple_types<tuple, 0>\x3a\x3atype(),\x0a"
"                __t...\x0a"
"               ) {}\x0a"
"\x0a"
"    template <class _Alloc, bool _Dummy = true,\x0a"
"              typename enable_if\x0a"
"                      <\x0a"
"                         _CheckArgsConstructor<\x0a"
"                            _Dummy\x0a"
"                         >\x3a\x3atemplate __enable_implicit<_Tp const\x26...>(),\x0a"
"                         bool\x0a"
"                      >\x3a\x3atype = false\x0a"
"        >\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      tuple(allocator_arg_t, const _Alloc\x26 __a, const _Tp\x26 ... __t)\x0a"
"        \x3a __base_(allocator_arg_t(), __a,\x0a"
"                typename __make_tuple_indices<sizeof...(_Tp)>\x3a\x3atype(),\x0a"
"                typename __make_tuple_types<tuple, sizeof...(_Tp)>\x3a\x3atype(),\x0a"
"                typename __make_tuple_indices<0>\x3a\x3atype(),\x0a"
"                typename __make_tuple_types<tuple, 0>\x3a\x3atype(),\x0a"
"                __t...\x0a"
"               ) {}\x0a"
"\x0a"
"    template <class _Alloc, bool _Dummy = true,\x0a"
"              typename enable_if\x0a"
"                      <\x0a"
"                         _CheckArgsConstructor<\x0a"
"                            _Dummy\x0a"
"                         >\x3a\x3atemplate __enable_explicit<_Tp const\x26...>(),\x0a"
"                         bool\x0a"
"                      >\x3a\x3atype = false\x0a"
"        >\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      explicit\x0a"
"      tuple(allocator_arg_t, const _Alloc\x26 __a, const _Tp\x26 ... __t)\x0a"
"        \x3a __base_(allocator_arg_t(), __a,\x0a"
"                typename __make_tuple_indices<sizeof...(_Tp)>\x3a\x3atype(),\x0a"
"                typename __make_tuple_types<tuple, sizeof...(_Tp)>\x3a\x3atype(),\x0a"
"                typename __make_tuple_indices<0>\x3a\x3atype(),\x0a"
"                typename __make_tuple_types<tuple, 0>\x3a\x3atype(),\x0a"
"                __t...\x0a"
"               ) {}\x0a"
"\x0a"
"    template <class ..._Up,\x0a"
"              bool _PackIsTuple = _PackExpandsToThisTuple<_Up...>\x3a\x3avalue,\x0a"
"              typename enable_if\x0a"
"                      <\x0a"
"                         _CheckArgsConstructor<\x0a"
"                             sizeof...(_Up) == sizeof...(_Tp)\x0a"
"                             \x26\x26 \x21_PackIsTuple\x0a"
"                         >\x3a\x3atemplate __enable_implicit<_Up...>() \x7c\x7c\x0a"
"                        _CheckArgsConstructor<\x0a"
"                            _EnableImplicitReducedArityExtension\x0a"
"                            \x26\x26 sizeof...(_Up) < sizeof...(_Tp)\x0a"
"                            \x26\x26 \x21_PackIsTuple\x0a"
"                         >\x3a\x3atemplate __enable_implicit<_Up...>(),\x0a"
"                         bool\x0a"
"                      >\x3a\x3atype = false\x0a"
"             >\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        tuple(_Up\x26\x26... __u)\x0a"
"            _NOEXCEPT_((\x0a"
"                is_nothrow_constructible<_BaseT,\x0a"
"                    typename __make_tuple_indices<sizeof...(_Up)>\x3a\x3atype,\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Up)>\x3a\x3atype,\x0a"
"                    typename __make_tuple_indices<sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype,\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype,\x0a"
"                    _Up...\x0a"
"                >\x3a\x3avalue\x0a"
"            ))\x0a"
"            \x3a __base_(typename __make_tuple_indices<sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_indices<sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    _VSTD\x3a\x3a""forward<_Up>(__u)...) {}\x0a"
"\x0a"
"    template <class ..._Up,\x0a"
"              typename enable_if\x0a"
"                      <\x0a"
"                         _CheckArgsConstructor<\x0a"
"                             sizeof...(_Up) <= sizeof...(_Tp)\x0a"
"                             \x26\x26 \x21_PackExpandsToThisTuple<_Up...>\x3a\x3avalue\x0a"
"                         >\x3a\x3atemplate __enable_explicit<_Up...>() \x7c\x7c\x0a"
"                         _CheckArgsConstructor<\x0a"
"                            \x21_EnableImplicitReducedArityExtension\x0a"
"                            \x26\x26 sizeof...(_Up) < sizeof...(_Tp)\x0a"
"                            \x26\x26 \x21_PackExpandsToThisTuple<_Up...>\x3a\x3avalue\x0a"
"                         >\x3a\x3atemplate __enable_implicit<_Up...>(),\x0a"
"                         bool\x0a"
"                      >\x3a\x3atype = false\x0a"
"             >\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        explicit\x0a"
"        tuple(_Up\x26\x26... __u)\x0a"
"            _NOEXCEPT_((\x0a"
"                is_nothrow_constructible<_BaseT,\x0a"
"                    typename __make_tuple_indices<sizeof...(_Up)>\x3a\x3atype,\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Up)>\x3a\x3atype,\x0a"
"                    typename __make_tuple_indices<sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype,\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype,\x0a"
"                    _Up...\x0a"
"                >\x3a\x3avalue\x0a"
"            ))\x0a"
"            \x3a __base_(typename __make_tuple_indices<sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_indices<sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    _VSTD\x3a\x3a""forward<_Up>(__u)...) {}\x0a"
"\x0a"
"    template <class _Alloc, class ..._Up,\x0a"
"              typename enable_if\x0a"
"                      <\x0a"
"                         _CheckArgsConstructor<\x0a"
"                             sizeof...(_Up) == sizeof...(_Tp) \x26\x26\x0a"
"                             \x21_PackExpandsToThisTuple<_Up...>\x3a\x3avalue\x0a"
"                         >\x3a\x3atemplate __enable_implicit<_Up...>(),\x0a"
"                         bool\x0a"
"                      >\x3a\x3atype = false\x0a"
"             >\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        tuple(allocator_arg_t, const _Alloc\x26 __a, _Up\x26\x26... __u)\x0a"
"            \x3a __base_(allocator_arg_t(), __a,\x0a"
"                    typename __make_tuple_indices<sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_indices<sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    _VSTD\x3a\x3a""forward<_Up>(__u)...) {}\x0a"
"\x0a"
"    template <class _Alloc, class ..._Up,\x0a"
"              typename enable_if\x0a"
"                      <\x0a"
"                         _CheckArgsConstructor<\x0a"
"                             sizeof...(_Up) == sizeof...(_Tp) \x26\x26\x0a"
"                             \x21_PackExpandsToThisTuple<_Up...>\x3a\x3avalue\x0a"
"                         >\x3a\x3atemplate __enable_explicit<_Up...>(),\x0a"
"                         bool\x0a"
"                      >\x3a\x3atype = false\x0a"
"             >\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit\x0a"
"        tuple(allocator_arg_t, const _Alloc\x26 __a, _Up\x26\x26... __u)\x0a"
"            \x3a __base_(allocator_arg_t(), __a,\x0a"
"                    typename __make_tuple_indices<sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_indices<sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    typename __make_tuple_types<tuple, sizeof...(_Tp), sizeof...(_Up)>\x3a\x3atype(),\x0a"
"                    _VSTD\x3a\x3a""forward<_Up>(__u)...) {}\x0a"
"\x0a"
"    template <class _Tuple, _EnableImplicitTupleLikeConstructor<_Tuple, true> = false>\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        tuple(_Tuple\x26\x26 __t) _NOEXCEPT_((is_nothrow_constructible<_BaseT, _Tuple>\x3a\x3avalue))\x0a"
"            \x3a __base_(_VSTD\x3a\x3a""forward<_Tuple>(__t)) {}\x0a"
"\x0a"
"    template <class _Tuple, _EnableImplicitTupleLikeConstructor<const _Tuple\x26, false> = false>\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        tuple(const _Tuple\x26 __t) _NOEXCEPT_((is_nothrow_constructible<_BaseT, const _Tuple\x26>\x3a\x3avalue))\x0a"
"            \x3a __base_(__t) {}\x0a"
"    template <class _Tuple, _EnableExplicitTupleLikeConstructor<_Tuple, true> = false>\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        explicit\x0a"
"        tuple(_Tuple\x26\x26 __t) _NOEXCEPT_((is_nothrow_constructible<_BaseT, _Tuple>\x3a\x3avalue))\x0a"
"            \x3a __base_(_VSTD\x3a\x3a""forward<_Tuple>(__t)) {}\x0a"
"\x0a"
"    template <class _Tuple, _EnableExplicitTupleLikeConstructor<const _Tuple\x26, false> = false>\x0a"
"        _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"        explicit\x0a"
"        tuple(const _Tuple\x26 __t) _NOEXCEPT_((is_nothrow_constructible<_BaseT, const _Tuple\x26>\x3a\x3avalue))\x0a"
"            \x3a __base_(__t) {}\x0a"
"\x0a"
"    template <class _Alloc, class _Tuple,\x0a"
"              typename enable_if\x0a"
"                      <\x0a"
"                         _CheckTupleLikeConstructor<\x0a"
"                             __tuple_like_with_size<_Tuple, sizeof...(_Tp)>\x3a\x3avalue\x0a"
"                         >\x3a\x3atemplate __enable_implicit<_Tuple>(),\x0a"
"                         bool\x0a"
"                      >\x3a\x3atype = false\x0a"
"             >\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        tuple(allocator_arg_t, const _Alloc\x26 __a, _Tuple\x26\x26 __t)\x0a"
"            \x3a __base_(allocator_arg_t(), __a, _VSTD\x3a\x3a""forward<_Tuple>(__t)) {}\x0a"
"\x0a"
"    template <class _Alloc, class _Tuple,\x0a"
"              typename enable_if\x0a"
"                      <\x0a"
"                         _CheckTupleLikeConstructor<\x0a"
"                             __tuple_like_with_size<_Tuple, sizeof...(_Tp)>\x3a\x3avalue\x0a"
"                         >\x3a\x3atemplate __enable_explicit<_Tuple>(),\x0a"
"                         bool\x0a"
"                      >\x3a\x3atype = false\x0a"
"             >\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit\x0a"
"        tuple(allocator_arg_t, const _Alloc\x26 __a, _Tuple\x26\x26 __t)\x0a"
"            \x3a __base_(allocator_arg_t(), __a, _VSTD\x3a\x3a""forward<_Tuple>(__t)) {}\x0a"
"\x0a"
"    using _CanCopyAssign = __all<is_copy_assignable<_Tp>\x3a\x3avalue...>;\x0a"
"    using _CanMoveAssign = __all<is_move_assignable<_Tp>\x3a\x3avalue...>;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    tuple\x26 operator=(typename conditional<_CanCopyAssign\x3a\x3avalue, tuple, __nat>\x3a\x3atype const\x26 __t)\x0a"
"        _NOEXCEPT_((__all<is_nothrow_copy_assignable<_Tp>\x3a\x3avalue...>\x3a\x3avalue))\x0a"
"    {\x0a"
"        __base_.operator=(__t.__base_);\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    tuple\x26 operator=(typename conditional<_CanMoveAssign\x3a\x3avalue, tuple, __nat>\x3a\x3atype\x26\x26 __t)\x0a"
"        _NOEXCEPT_((__all<is_nothrow_move_assignable<_Tp>\x3a\x3avalue...>\x3a\x3avalue))\x0a"
"    {\x0a"
"        __base_.operator=(static_cast<_BaseT\x26\x26>(__t.__base_));\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    template <class _Tuple,\x0a"
"              class = typename enable_if\x0a"
"                      <\x0a"
"                         __tuple_assignable<_Tuple, tuple>\x3a\x3avalue\x0a"
"                      >\x3a\x3atype\x0a"
"             >\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        tuple\x26\x0a"
"        operator=(_Tuple\x26\x26 __t) _NOEXCEPT_((is_nothrow_assignable<_BaseT\x26, _Tuple>\x3a\x3avalue))\x0a"
"        {\x0a"
"            __base_.operator=(_VSTD\x3a\x3a""forward<_Tuple>(__t));\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(tuple\x26 __t) _NOEXCEPT_(__all<__is_nothrow_swappable<_Tp>\x3a\x3avalue...>\x3a\x3avalue)\x0a"
"        {__base_.swap(__t.__base_);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TEMPLATE_VIS tuple<>\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR tuple() _NOEXCEPT = default;\x0a"
"    template <class _Alloc>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        tuple(allocator_arg_t, const _Alloc\x26) _NOEXCEPT {}\x0a"
"    template <class _Alloc>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        tuple(allocator_arg_t, const _Alloc\x26, const tuple\x26) _NOEXCEPT {}\x0a"
"    template <class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        tuple(array<_Up, 0>) _NOEXCEPT {}\x0a"
"    template <class _Alloc, class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        tuple(allocator_arg_t, const _Alloc\x26, array<_Up, 0>) _NOEXCEPT {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(tuple\x26) _NOEXCEPT {}\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"// NOTE\x3a These are not yet standardized, but are required to simulate the\x0a"
"// implicit deduction guide that should be generated had libc++ declared the\x0a"
"// tuple-like constructors \x22""correctly\x22\x0a"
"template <class _Alloc, class ..._Args>\x0a"
"tuple(allocator_arg_t, const _Alloc\x26, tuple<_Args...> const\x26) -> tuple<_Args...>;\x0a"
"template <class _Alloc, class ..._Args>\x0a"
"tuple(allocator_arg_t, const _Alloc\x26, tuple<_Args...>\x26\x26) -> tuple<_Args...>;\x0a"
"#endif\x0a"
"\x0a"
"template <class ..._Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __all<__is_swappable<_Tp>\x3a\x3avalue...>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"swap(tuple<_Tp...>\x26 __t, tuple<_Tp...>\x26 __u)\x0a"
"                 _NOEXCEPT_(__all<__is_nothrow_swappable<_Tp>\x3a\x3avalue...>\x3a\x3avalue)\x0a"
"    {__t.swap(__u);}\x0a"
"\x0a"
"// get\x0a"
"\x0a"
"template <size_t _Ip, class ..._Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"typename tuple_element<_Ip, tuple<_Tp...> >\x3a\x3atype\x26\x0a"
"get(tuple<_Tp...>\x26 __t) _NOEXCEPT\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename tuple_element<_Ip, tuple<_Tp...> >\x3a\x3atype type;\x0a"
"    return static_cast<__tuple_leaf<_Ip, type>\x26>(__t.__base_).get();\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class ..._Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const typename tuple_element<_Ip, tuple<_Tp...> >\x3a\x3atype\x26\x0a"
"get(const tuple<_Tp...>\x26 __t) _NOEXCEPT\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename tuple_element<_Ip, tuple<_Tp...> >\x3a\x3atype type;\x0a"
"    return static_cast<const __tuple_leaf<_Ip, type>\x26>(__t.__base_).get();\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class ..._Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"typename tuple_element<_Ip, tuple<_Tp...> >\x3a\x3atype\x26\x26\x0a"
"get(tuple<_Tp...>\x26\x26 __t) _NOEXCEPT\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename tuple_element<_Ip, tuple<_Tp...> >\x3a\x3atype type;\x0a"
"    return static_cast<type\x26\x26>(\x0a"
"             static_cast<__tuple_leaf<_Ip, type>\x26\x26>(__t.__base_).get());\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class ..._Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const typename tuple_element<_Ip, tuple<_Tp...> >\x3a\x3atype\x26\x26\x0a"
"get(const tuple<_Tp...>\x26\x26 __t) _NOEXCEPT\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename tuple_element<_Ip, tuple<_Tp...> >\x3a\x3atype type;\x0a"
"    return static_cast<const type\x26\x26>(\x0a"
"             static_cast<const __tuple_leaf<_Ip, type>\x26\x26>(__t.__base_).get());\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"namespace __find_detail {\x0a"
"\x0a"
"static constexpr size_t __not_found = -1;\x0a"
"static constexpr size_t __ambiguous = __not_found - 1;\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr size_t __find_idx_return(size_t __curr_i, size_t __res, bool __matches) {\x0a"
"    return \x21__matches \x3f __res \x3a\x0a"
"        (__res == __not_found \x3f __curr_i \x3a __ambiguous);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Nx>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr size_t __find_idx(size_t __i, const bool (\x26__matches)\x5b_Nx\x5d) {\x0a"
"  return __i == _Nx \x3f __not_found \x3a\x0a"
"      __find_idx_return(__i, __find_idx(__i + 1, __matches), __matches\x5b__i\x5d);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class ..._Args>\x0a"
"struct __find_exactly_one_checked {\x0a"
"    static constexpr bool __matches\x5bsizeof...(_Args)\x5d = {is_same<_T1, _Args>\x3a\x3avalue...};\x0a"
"    static constexpr size_t value = __find_detail\x3a\x3a__find_idx(0, __matches);\x0a"
"    static_assert(value \x21= __not_found, \x22type not found in type list\x22 );\x0a"
"    static_assert(value \x21= __ambiguous, \x22type occurs more than once in type list\x22);\x0a"
"};\x0a"
"\x0a"
"template <class _T1>\x0a"
"struct __find_exactly_one_checked<_T1> {\x0a"
"    static_assert(\x21is_same<_T1, _T1>\x3a\x3avalue, \x22type not in empty type list\x22);\x0a"
"};\x0a"
"\x0a"
"} // namespace __find_detail;\x0a"
"\x0a"
"template <typename _T1, typename... _Args>\x0a"
"struct __find_exactly_one_t\x0a"
"    \x3a public __find_detail\x3a\x3a__find_exactly_one_checked<_T1, _Args...> {\x0a"
"};\x0a"
"\x0a"
"template <class _T1, class... _Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1\x26 get(tuple<_Args...>\x26 __tup) noexcept\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aget<__find_exactly_one_t<_T1, _Args...>\x3a\x3avalue>(__tup);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class... _Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1 const\x26 get(tuple<_Args...> const\x26 __tup) noexcept\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aget<__find_exactly_one_t<_T1, _Args...>\x3a\x3avalue>(__tup);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class... _Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1\x26\x26 get(tuple<_Args...>\x26\x26 __tup) noexcept\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aget<__find_exactly_one_t<_T1, _Args...>\x3a\x3avalue>(_VSTD\x3a\x3amove(__tup));\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class... _Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1 const\x26\x26 get(tuple<_Args...> const\x26\x26 __tup) noexcept\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aget<__find_exactly_one_t<_T1, _Args...>\x3a\x3avalue>(_VSTD\x3a\x3amove(__tup));\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"// tie\x0a"
"\x0a"
"template <class ..._Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"tuple<_Tp\x26...>\x0a"
"tie(_Tp\x26... __t) _NOEXCEPT\x0a"
"{\x0a"
"    return tuple<_Tp\x26...>(__t...);\x0a"
"}\x0a"
"\x0a"
"template <class _Up>\x0a"
"struct __ignore_t\x0a"
"{\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    const __ignore_t\x26 operator=(_Tp\x26\x26) const {return *this;}\x0a"
"};\x0a"
"\x0a"
"namespace {\x0a"
"  _LIBCPP_INLINE_VAR constexpr __ignore_t<unsigned char> ignore = __ignore_t<unsigned char>();\x0a"
"}\x0a"
"\x0a"
"template <class... _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"tuple<typename __unwrap_ref_decay<_Tp>\x3a\x3atype...>\x0a"
"make_tuple(_Tp\x26\x26... __t)\x0a"
"{\x0a"
"    return tuple<typename __unwrap_ref_decay<_Tp>\x3a\x3atype...>(_VSTD\x3a\x3a""forward<_Tp>(__t)...);\x0a"
"}\x0a"
"\x0a"
"template <class... _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"tuple<_Tp\x26\x26...>\x0a"
"forward_as_tuple(_Tp\x26\x26... __t) _NOEXCEPT\x0a"
"{\x0a"
"    return tuple<_Tp\x26\x26...>(_VSTD\x3a\x3a""forward<_Tp>(__t)...);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip>\x0a"
"struct __tuple_equal\x0a"
"{\x0a"
"    template <class _Tp, class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _Tp\x26 __x, const _Up\x26 __y)\x0a"
"    {\x0a"
"        return __tuple_equal<_Ip - 1>()(__x, __y) \x26\x26 _VSTD\x3a\x3aget<_Ip-1>(__x) == _VSTD\x3a\x3aget<_Ip-1>(__y);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct __tuple_equal<0>\x0a"
"{\x0a"
"    template <class _Tp, class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _Tp\x26, const _Up\x26)\x0a"
"    {\x0a"
"        return true;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class ..._Tp, class ..._Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator==(const tuple<_Tp...>\x26 __x, const tuple<_Up...>\x26 __y)\x0a"
"{\x0a"
"    static_assert (sizeof...(_Tp) == sizeof...(_Up), \x22""Can't compare tuples of different sizes\x22);\x0a"
"    return __tuple_equal<sizeof...(_Tp)>()(__x, __y);\x0a"
"}\x0a"
"\x0a"
"template <class ..._Tp, class ..._Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator\x21=(const tuple<_Tp...>\x26 __x, const tuple<_Up...>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip>\x0a"
"struct __tuple_less\x0a"
"{\x0a"
"    template <class _Tp, class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _Tp\x26 __x, const _Up\x26 __y)\x0a"
"    {\x0a"
"        const size_t __idx = tuple_size<_Tp>\x3a\x3avalue - _Ip;\x0a"
"        if (_VSTD\x3a\x3aget<__idx>(__x) < _VSTD\x3a\x3aget<__idx>(__y))\x0a"
"            return true;\x0a"
"        if (_VSTD\x3a\x3aget<__idx>(__y) < _VSTD\x3a\x3aget<__idx>(__x))\x0a"
"            return false;\x0a"
"        return __tuple_less<_Ip-1>()(__x, __y);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct __tuple_less<0>\x0a"
"{\x0a"
"    template <class _Tp, class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _Tp\x26, const _Up\x26)\x0a"
"    {\x0a"
"        return false;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class ..._Tp, class ..._Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator<(const tuple<_Tp...>\x26 __x, const tuple<_Up...>\x26 __y)\x0a"
"{\x0a"
"    static_assert (sizeof...(_Tp) == sizeof...(_Up), \x22""Can't compare tuples of different sizes\x22);\x0a"
"    return __tuple_less<sizeof...(_Tp)>()(__x, __y);\x0a"
"}\x0a"
"\x0a"
"template <class ..._Tp, class ..._Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator>(const tuple<_Tp...>\x26 __x, const tuple<_Up...>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class ..._Tp, class ..._Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator>=(const tuple<_Tp...>\x26 __x, const tuple<_Up...>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class ..._Tp, class ..._Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator<=(const tuple<_Tp...>\x26 __x, const tuple<_Up...>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"// tuple_cat\x0a"
"\x0a"
"template <class _Tp, class _Up> struct __tuple_cat_type;\x0a"
"\x0a"
"template <class ..._Ttypes, class ..._Utypes>\x0a"
"struct __tuple_cat_type<tuple<_Ttypes...>, __tuple_types<_Utypes...> >\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE tuple<_Ttypes..., _Utypes...> type;\x0a"
"};\x0a"
"\x0a"
"template <class _ResultTuple, bool _Is_Tuple0TupleLike, class ..._Tuples>\x0a"
"struct __tuple_cat_return_1\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class ..._Types, class _Tuple0>\x0a"
"struct __tuple_cat_return_1<tuple<_Types...>, true, _Tuple0>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename __tuple_cat_type<tuple<_Types...>,\x0a"
"            typename __make_tuple_types<typename __uncvref<_Tuple0>\x3a\x3atype>\x3a\x3atype>\x3a\x3atype\x0a"
"                                                                           type;\x0a"
"};\x0a"
"\x0a"
"template <class ..._Types, class _Tuple0, class _Tuple1, class ..._Tuples>\x0a"
"struct __tuple_cat_return_1<tuple<_Types...>, true, _Tuple0, _Tuple1, _Tuples...>\x0a"
"    \x3a public __tuple_cat_return_1<\x0a"
"                 typename __tuple_cat_type<\x0a"
"                     tuple<_Types...>,\x0a"
"                     typename __make_tuple_types<typename __uncvref<_Tuple0>\x3a\x3atype>\x3a\x3atype\x0a"
"                 >\x3a\x3atype,\x0a"
"                 __tuple_like<typename remove_reference<_Tuple1>\x3a\x3atype>\x3a\x3avalue,\x0a"
"                 _Tuple1, _Tuples...>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class ..._Tuples> struct __tuple_cat_return;\x0a"
"\x0a"
"template <class _Tuple0, class ..._Tuples>\x0a"
"struct __tuple_cat_return<_Tuple0, _Tuples...>\x0a"
"    \x3a public __tuple_cat_return_1<tuple<>,\x0a"
"         __tuple_like<typename remove_reference<_Tuple0>\x3a\x3atype>\x3a\x3avalue, _Tuple0,\x0a"
"                                                                     _Tuples...>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct __tuple_cat_return<>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE tuple<> type;\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"tuple<>\x0a"
"tuple_cat()\x0a"
"{\x0a"
"    return tuple<>();\x0a"
"}\x0a"
"\x0a"
"template <class _Rp, class _Indices, class _Tuple0, class ..._Tuples>\x0a"
"struct __tuple_cat_return_ref_imp;\x0a"
"\x0a"
"template <class ..._Types, size_t ..._I0, class _Tuple0>\x0a"
"struct __tuple_cat_return_ref_imp<tuple<_Types...>, __tuple_indices<_I0...>, _Tuple0>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename remove_reference<_Tuple0>\x3a\x3atype _T0;\x0a"
"    typedef tuple<_Types..., typename __apply_cv<_Tuple0,\x0a"
"                          typename tuple_element<_I0, _T0>\x3a\x3atype>\x3a\x3atype\x26\x26...> type;\x0a"
"};\x0a"
"\x0a"
"template <class ..._Types, size_t ..._I0, class _Tuple0, class _Tuple1, class ..._Tuples>\x0a"
"struct __tuple_cat_return_ref_imp<tuple<_Types...>, __tuple_indices<_I0...>,\x0a"
"                                  _Tuple0, _Tuple1, _Tuples...>\x0a"
"    \x3a public __tuple_cat_return_ref_imp<\x0a"
"         tuple<_Types..., typename __apply_cv<_Tuple0,\x0a"
"               typename tuple_element<_I0,\x0a"
"                  typename remove_reference<_Tuple0>\x3a\x3atype>\x3a\x3atype>\x3a\x3atype\x26\x26...>,\x0a"
"         typename __make_tuple_indices<tuple_size<typename\x0a"
"                                 remove_reference<_Tuple1>\x3a\x3atype>\x3a\x3avalue>\x3a\x3atype,\x0a"
"         _Tuple1, _Tuples...>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tuple0, class ..._Tuples>\x0a"
"struct __tuple_cat_return_ref\x0a"
"    \x3a public __tuple_cat_return_ref_imp<tuple<>,\x0a"
"               typename __make_tuple_indices<\x0a"
"                        tuple_size<typename remove_reference<_Tuple0>\x3a\x3atype>\x3a\x3avalue\x0a"
"               >\x3a\x3atype, _Tuple0, _Tuples...>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Types, class _I0, class _J0>\x0a"
"struct __tuple_cat;\x0a"
"\x0a"
"template <class ..._Types, size_t ..._I0, size_t ..._J0>\x0a"
"struct __tuple_cat<tuple<_Types...>, __tuple_indices<_I0...>, __tuple_indices<_J0...> >\x0a"
"{\x0a"
"    template <class _Tuple0>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    typename __tuple_cat_return_ref<tuple<_Types...>\x26\x26, _Tuple0\x26\x26>\x3a\x3atype\x0a"
"    operator()(tuple<_Types...> __t, _Tuple0\x26\x26 __t0)\x0a"
"    {\x0a"
"        return forward_as_tuple(_VSTD\x3a\x3a""forward<_Types>(_VSTD\x3a\x3aget<_I0>(__t))...,\x0a"
"                                      _VSTD\x3a\x3aget<_J0>(_VSTD\x3a\x3a""forward<_Tuple0>(__t0))...);\x0a"
"    }\x0a"
"\x0a"
"    template <class _Tuple0, class _Tuple1, class ..._Tuples>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    typename __tuple_cat_return_ref<tuple<_Types...>\x26\x26, _Tuple0\x26\x26, _Tuple1\x26\x26, _Tuples\x26\x26...>\x3a\x3atype\x0a"
"    operator()(tuple<_Types...> __t, _Tuple0\x26\x26 __t0, _Tuple1\x26\x26 __t1, _Tuples\x26\x26 ...__tpls)\x0a"
"    {\x0a"
"        typedef _LIBCPP_NODEBUG_TYPE typename remove_reference<_Tuple0>\x3a\x3atype _T0;\x0a"
"        typedef _LIBCPP_NODEBUG_TYPE typename remove_reference<_Tuple1>\x3a\x3atype _T1;\x0a"
"        return __tuple_cat<\x0a"
"           tuple<_Types..., typename __apply_cv<_Tuple0, typename tuple_element<_J0, _T0>\x3a\x3atype>\x3a\x3atype\x26\x26...>,\x0a"
"           typename __make_tuple_indices<sizeof ...(_Types) + tuple_size<_T0>\x3a\x3avalue>\x3a\x3atype,\x0a"
"           typename __make_tuple_indices<tuple_size<_T1>\x3a\x3avalue>\x3a\x3atype>()\x0a"
"                           (forward_as_tuple(\x0a"
"                              _VSTD\x3a\x3a""forward<_Types>(_VSTD\x3a\x3aget<_I0>(__t))...,\x0a"
"                              _VSTD\x3a\x3aget<_J0>(_VSTD\x3a\x3a""forward<_Tuple0>(__t0))...\x0a"
"                            ),\x0a"
"                            _VSTD\x3a\x3a""forward<_Tuple1>(__t1),\x0a"
"                            _VSTD\x3a\x3a""forward<_Tuples>(__tpls)...);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tuple0, class... _Tuples>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"typename __tuple_cat_return<_Tuple0, _Tuples...>\x3a\x3atype\x0a"
"tuple_cat(_Tuple0\x26\x26 __t0, _Tuples\x26\x26... __tpls)\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename remove_reference<_Tuple0>\x3a\x3atype _T0;\x0a"
"    return __tuple_cat<tuple<>, __tuple_indices<>,\x0a"
"                  typename __make_tuple_indices<tuple_size<_T0>\x3a\x3avalue>\x3a\x3atype>()\x0a"
"                  (tuple<>(), _VSTD\x3a\x3a""forward<_Tuple0>(__t0),\x0a"
"                                            _VSTD\x3a\x3a""forward<_Tuples>(__tpls)...);\x0a"
"}\x0a"
"\x0a"
"template <class ..._Tp, class _Alloc>\x0a"
"struct _LIBCPP_TEMPLATE_VIS uses_allocator<tuple<_Tp...>, _Alloc>\x0a"
"    \x3a true_type {};\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"template <class... _Args1, class... _Args2, size_t ..._I1, size_t ..._I2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"pair<_T1, _T2>\x3a\x3apair(piecewise_construct_t,\x0a"
"                     tuple<_Args1...>\x26 __first_args, tuple<_Args2...>\x26 __second_args,\x0a"
"                     __tuple_indices<_I1...>, __tuple_indices<_I2...>)\x0a"
"    \x3a  first(_VSTD\x3a\x3a""forward<_Args1>(_VSTD\x3a\x3aget<_I1>( __first_args))...),\x0a"
"      second(_VSTD\x3a\x3a""forward<_Args2>(_VSTD\x3a\x3aget<_I2>(__second_args))...)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr size_t tuple_size_v = tuple_size<_Tp>\x3a\x3avalue;\x0a"
"\x0a"
"#define _LIBCPP_NOEXCEPT_RETURN(...) noexcept(noexcept(__VA_ARGS__)) { return __VA_ARGS__; }\x0a"
"\x0a"
"template <class _Fn, class _Tuple, size_t ..._Id>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr decltype(auto) __apply_tuple_impl(_Fn \x26\x26 __f, _Tuple \x26\x26 __t,\x0a"
"                                            __tuple_indices<_Id...>)\x0a"
"_LIBCPP_NOEXCEPT_RETURN(\x0a"
"    _VSTD\x3a\x3a__invoke_constexpr(\x0a"
"        _VSTD\x3a\x3a""forward<_Fn>(__f),\x0a"
"        _VSTD\x3a\x3aget<_Id>(_VSTD\x3a\x3a""forward<_Tuple>(__t))...)\x0a"
")\x0a"
"\x0a"
"template <class _Fn, class _Tuple>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr decltype(auto) apply(_Fn \x26\x26 __f, _Tuple \x26\x26 __t)\x0a"
"_LIBCPP_NOEXCEPT_RETURN(\x0a"
"    _VSTD\x3a\x3a__apply_tuple_impl(\x0a"
"        _VSTD\x3a\x3a""forward<_Fn>(__f), _VSTD\x3a\x3a""forward<_Tuple>(__t),\x0a"
"        typename __make_tuple_indices<tuple_size_v<remove_reference_t<_Tuple>>>\x3a\x3atype{})\x0a"
")\x0a"
"\x0a"
"template <class _Tp, class _Tuple, size_t... _Idx>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _Tp __make_from_tuple_impl(_Tuple\x26\x26 __t, __tuple_indices<_Idx...>)\x0a"
"_LIBCPP_NOEXCEPT_RETURN(\x0a"
"    _Tp(_VSTD\x3a\x3aget<_Idx>(_VSTD\x3a\x3a""forward<_Tuple>(__t))...)\x0a"
")\x0a"
"\x0a"
"template <class _Tp, class _Tuple>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _Tp make_from_tuple(_Tuple\x26\x26 __t)\x0a"
"_LIBCPP_NOEXCEPT_RETURN(\x0a"
"    _VSTD\x3a\x3a__make_from_tuple_impl<_Tp>(_VSTD\x3a\x3a""forward<_Tuple>(__t),\x0a"
"        typename __make_tuple_indices<tuple_size_v<remove_reference_t<_Tuple>>>\x3a\x3atype{})\x0a"
")\x0a"
"\x0a"
"#undef _LIBCPP_NOEXCEPT_RETURN\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"#endif // \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_TUPLE\x0a"
"", 54743 ); }