#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_typeinfo( 
"// -*- C++ -*-\x0a"
"//===-------------------------- typeinfo ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef __LIBCPP_TYPEINFO\x0a"
"#define __LIBCPP_TYPEINFO\x0a"
"\x0a"
"/*\x0a"
"\x0a"
"    typeinfo synopsis\x0a"
"\x0a"
"namespace std {\x0a"
"\x0a"
"class type_info\x0a"
"{\x0a"
"public\x3a\x0a"
"    virtual \x7etype_info();\x0a"
"\x0a"
"    bool operator==(const type_info\x26 rhs) const noexcept;\x0a"
"    bool operator\x21=(const type_info\x26 rhs) const noexcept;\x0a"
"\x0a"
"    bool before(const type_info\x26 rhs) const noexcept;\x0a"
"    size_t hash_code() const noexcept;\x0a"
"    const char* name() const noexcept;\x0a"
"\x0a"
"    type_info(const type_info\x26 rhs) = delete;\x0a"
"    type_info\x26 operator=(const type_info\x26 rhs) = delete;\x0a"
"};\x0a"
"\x0a"
"class bad_cast\x0a"
"    \x3a public exception\x0a"
"{\x0a"
"public\x3a\x0a"
"    bad_cast() noexcept;\x0a"
"    bad_cast(const bad_cast\x26) noexcept;\x0a"
"    bad_cast\x26 operator=(const bad_cast\x26) noexcept;\x0a"
"    virtual const char* what() const noexcept;\x0a"
"};\x0a"
"\x0a"
"class bad_typeid\x0a"
"    \x3a public exception\x0a"
"{\x0a"
"public\x3a\x0a"
"    bad_typeid() noexcept;\x0a"
"    bad_typeid(const bad_typeid\x26) noexcept;\x0a"
"    bad_typeid\x26 operator=(const bad_typeid\x26) noexcept;\x0a"
"    virtual const char* what() const noexcept;\x0a"
"};\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <exception>\x0a"
"#include <cstddef>\x0a"
"#include <cstdint>\x0a"
"#ifdef _LIBCPP_NO_EXCEPTIONS\x0a"
"#include <cstdlib>\x0a"
"#endif\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"#if defined(_LIBCPP_ABI_VCRUNTIME)\x0a"
"#include <vcruntime_typeinfo.h>\x0a"
"#else\x0a"
"\x0a"
"namespace std  // purposefully not using versioning namespace\x0a"
"{\x0a"
"\x0a"
"\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT)\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI type_info\x0a"
"{\x0a"
"    type_info\x26 operator=(const type_info\x26);\x0a"
"    type_info(const type_info\x26);\x0a"
"\x0a"
"    mutable struct {\x0a"
"      const char *__undecorated_name;\x0a"
"      const char __decorated_name\x5b""1\x5d;\x0a"
"    } __data;\x0a"
"\x0a"
"    int __compare(const type_info \x26__rhs) const _NOEXCEPT;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_AVAILABILITY_TYPEINFO_VTABLE\x0a"
"    virtual \x7etype_info();\x0a"
"\x0a"
"    const char *name() const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool before(const type_info\x26 __arg) const _NOEXCEPT {\x0a"
"      return __compare(__arg) < 0;\x0a"
"    }\x0a"
"\x0a"
"    size_t hash_code() const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const type_info\x26 __arg) const _NOEXCEPT {\x0a"
"      return __compare(__arg) == 0;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const type_info\x26 __arg) const _NOEXCEPT\x0a"
"    { return \x21operator==(__arg); }\x0a"
"};\x0a"
"\x0a"
"#else // \x21""defined(_LIBCPP_ABI_MICROSOFT)\x0a"
"\x0a"
"// ========================================================================== //\x0a"
"//                           Implementations\x0a"
"// ========================================================================== //\x0a"
"// ------------------------------------------------------------------------- //\x0a"
"//                               Unique\x0a"
"// ------------------------------------------------------------------------- //\x0a"
"// This implementation of type_info assumes a unique copy of the RTTI for a\x0a"
"// given type inside a program. This is a valid assumption when abiding to\x0a"
"// Itanium ABI (http\x3a//itanium-cxx-abi.github.io/cxx-abi/abi.html#vtable-components).\x0a"
"// Under this assumption, we can always compare the addresses of the type names\x0a"
"// to implement equality-comparison of type_infos instead of having to perform\x0a"
"// a deep string comparison.\x0a"
"// -------------------------------------------------------------------------- //\x0a"
"//                             NonUnique\x0a"
"// -------------------------------------------------------------------------- //\x0a"
"// This implementation of type_info does not assume there is always a unique\x0a"
"// copy of the RTTI for a given type inside a program. For various reasons\x0a"
"// the linker may have failed to merge every copy of a types RTTI\x0a"
"// (For example\x3a -Bsymbolic or llvm.org/PR37398). Under this assumption, two\x0a"
"// type_infos are equal if their addresses are equal or if a deep string\x0a"
"// comparison is equal.\x0a"
"// -------------------------------------------------------------------------- //\x0a"
"//                          NonUniqueARMRTTIBit\x0a"
"// -------------------------------------------------------------------------- //\x0a"
"// This implementation of type_info does not assume always a unique copy of\x0a"
"// the RTTI for a given type inside a program. It packs the pointer to the\x0a"
"// type name into a uintptr_t and reserves the high bit of that pointer (which\x0a"
"// is assumed to be free for use under the ABI in use) to represent whether\x0a"
"// that specific copy of the RTTI can be assumed unique inside the program.\x0a"
"// To implement equality-comparison of type_infos, we check whether BOTH\x0a"
"// type_infos are guaranteed unique, and if so, we simply compare the addresses\x0a"
"// of their type names instead of doing a deep string comparison, which is\x0a"
"// faster. If at least one of the type_infos can't guarantee uniqueness, we\x0a"
"// have no choice but to fall back to a deep string comparison.\x0a"
"//\x0a"
"// This implementation is specific to ARM64 on Apple platforms.\x0a"
"//\x0a"
"// Note that the compiler is the one setting (or unsetting) the high bit of\x0a"
"// the pointer when it constructs the type_info, depending on whether it can\x0a"
"// guarantee uniqueness for that specific type_info.\x0a"
"\x0a"
"struct __type_info_implementations {\x0a"
"  struct __string_impl_base {\x0a"
"    typedef const char* __type_name_t;\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    _LIBCPP_CONSTEXPR static const char* __type_name_to_string(__type_name_t __v) _NOEXCEPT {\x0a"
"      return __v;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    _LIBCPP_CONSTEXPR static __type_name_t __string_to_type_name(const char* __v) _NOEXCEPT {\x0a"
"      return __v;\x0a"
"    }\x0a"
"  };\x0a"
"\x0a"
"  struct __unique_impl \x3a __string_impl_base {\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static size_t __hash(__type_name_t __v) _NOEXCEPT {\x0a"
"      return reinterpret_cast<size_t>(__v);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static bool __eq(__type_name_t __lhs, __type_name_t __rhs) _NOEXCEPT {\x0a"
"      return __lhs == __rhs;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static bool __lt(__type_name_t __lhs, __type_name_t __rhs) _NOEXCEPT {\x0a"
"      return __lhs < __rhs;\x0a"
"    }\x0a"
"  };\x0a"
"\x0a"
"  struct __non_unique_impl \x3a __string_impl_base {\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static size_t __hash(__type_name_t __ptr) _NOEXCEPT {\x0a"
"      size_t __hash = 5381;\x0a"
"      while (unsigned char __c = static_cast<unsigned char>(*__ptr++))\x0a"
"        __hash = (__hash * 33) ^ __c;\x0a"
"      return __hash;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static bool __eq(__type_name_t __lhs, __type_name_t __rhs) _NOEXCEPT {\x0a"
"      return __lhs == __rhs \x7c\x7c __builtin_strcmp(__lhs, __rhs) == 0;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static bool __lt(__type_name_t __lhs, __type_name_t __rhs) _NOEXCEPT {\x0a"
"      return __builtin_strcmp(__lhs, __rhs) < 0;\x0a"
"    }\x0a"
"  };\x0a"
"\x0a"
"  struct __non_unique_arm_rtti_bit_impl {\x0a"
"    typedef uintptr_t __type_name_t;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static const char* __type_name_to_string(__type_name_t __v) _NOEXCEPT {\x0a"
"      return reinterpret_cast<const char*>(__v \x26\x0a"
"          \x7e__non_unique_rtti_bit\x3a\x3avalue);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static __type_name_t __string_to_type_name(const char* __v) _NOEXCEPT {\x0a"
"      return reinterpret_cast<__type_name_t>(__v);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static size_t __hash(__type_name_t __v) _NOEXCEPT {\x0a"
"      if (__is_type_name_unique(__v))\x0a"
"        return reinterpret_cast<size_t>(__v);\x0a"
"      return __non_unique_impl\x3a\x3a__hash(__type_name_to_string(__v));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static bool __eq(__type_name_t __lhs, __type_name_t __rhs) _NOEXCEPT {\x0a"
"      if (__lhs == __rhs)\x0a"
"        return true;\x0a"
"      if (__is_type_name_unique(__lhs, __rhs))\x0a"
"        return false;\x0a"
"      return __builtin_strcmp(__type_name_to_string(__lhs), __type_name_to_string(__rhs)) == 0;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_ALWAYS_INLINE\x0a"
"    static bool __lt(__type_name_t __lhs, __type_name_t __rhs) _NOEXCEPT {\x0a"
"      if (__is_type_name_unique(__lhs, __rhs))\x0a"
"        return __lhs < __rhs;\x0a"
"      return __builtin_strcmp(__type_name_to_string(__lhs), __type_name_to_string(__rhs)) < 0;\x0a"
"    }\x0a"
"\x0a"
"   private\x3a\x0a"
"    // The unique bit is the top bit. It is expected that __type_name_t is 64 bits when\x0a"
"    // this implementation is actually used.\x0a"
"    typedef std\x3a\x3aintegral_constant<__type_name_t,\x0a"
"      (1ULL << ((__CHAR_BIT__ * sizeof(__type_name_t)) - 1))> __non_unique_rtti_bit;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static bool __is_type_name_unique(__type_name_t __lhs) _NOEXCEPT {\x0a"
"      return \x21(__lhs \x26 __non_unique_rtti_bit\x3a\x3avalue);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static bool __is_type_name_unique(__type_name_t __lhs, __type_name_t __rhs) _NOEXCEPT {\x0a"
"      return \x21((__lhs \x26 __rhs) \x26 __non_unique_rtti_bit\x3a\x3avalue);\x0a"
"    }\x0a"
"  };\x0a"
"\x0a"
"  typedef\x0a"
"#if defined(__APPLE__) \x26\x26 defined(__LP64__) \x26\x26 \x21""defined(__x86_64__)\x0a"
"    __non_unique_arm_rtti_bit_impl\x0a"
"#elif _LIBCPP_HAS_MERGED_TYPEINFO_NAMES_DEFAULT == 0\x0a"
"    __non_unique_impl\x0a"
"#elif _LIBCPP_HAS_MERGED_TYPEINFO_NAMES_DEFAULT == 1\x0a"
"    __unique_impl\x0a"
"#else\x0a"
"#   error invalid configuration for _LIBCPP_HAS_MERGED_TYPEINFO_NAMES_DEFAULT\x0a"
"#endif\x0a"
"     __impl;\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI type_info\x0a"
"{\x0a"
"  type_info\x26 operator=(const type_info\x26);\x0a"
"  type_info(const type_info\x26);\x0a"
"\x0a"
" protected\x3a\x0a"
"    typedef __type_info_implementations\x3a\x3a__impl __impl;\x0a"
"\x0a"
"    __impl\x3a\x3a__type_name_t __type_name;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit type_info(const char* __n)\x0a"
"      \x3a __type_name(__impl\x3a\x3a__string_to_type_name(__n)) {}\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_AVAILABILITY_TYPEINFO_VTABLE\x0a"
"    virtual \x7etype_info();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const char* name() const _NOEXCEPT\x0a"
"    {\x0a"
"      return __impl\x3a\x3a__type_name_to_string(__type_name);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool before(const type_info\x26 __arg) const _NOEXCEPT\x0a"
"    {\x0a"
"      return __impl\x3a\x3a__lt(__type_name, __arg.__type_name);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t hash_code() const _NOEXCEPT\x0a"
"    {\x0a"
"      return __impl\x3a\x3a__hash(__type_name);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const type_info\x26 __arg) const _NOEXCEPT\x0a"
"    {\x0a"
"      return __impl\x3a\x3a__eq(__type_name, __arg.__type_name);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const type_info\x26 __arg) const _NOEXCEPT\x0a"
"    { return \x21operator==(__arg); }\x0a"
"};\x0a"
"#endif // defined(_LIBCPP_ABI_MICROSOFT)\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI bad_cast\x0a"
"    \x3a public exception\x0a"
"{\x0a"
" public\x3a\x0a"
"  bad_cast() _NOEXCEPT;\x0a"
"  virtual \x7e""bad_cast() _NOEXCEPT;\x0a"
"  virtual const char* what() const _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI bad_typeid\x0a"
"    \x3a public exception\x0a"
"{\x0a"
" public\x3a\x0a"
"  bad_typeid() _NOEXCEPT;\x0a"
"  virtual \x7e""bad_typeid() _NOEXCEPT;\x0a"
"  virtual const char* what() const _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"#endif // defined(_LIBCPP_ABI_VCRUNTIME)\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_bad_cast()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw bad_cast();\x0a"
"#else\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // __LIBCPP_TYPEINFO\x0a"
"", 11249 ); }