#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_unordered_map( 
"// -*- C++ -*-\x0a"
"//===-------------------------- unordered_map -----------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_UNORDERED_MAP\x0a"
"#define _LIBCPP_UNORDERED_MAP\x0a"
"\x0a"
"/*\x0a"
"\x0a"
"    unordered_map synopsis\x0a"
"\x0a"
"#include <initializer_list>\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class Key, class T, class Hash = hash<Key>, class Pred = equal_to<Key>,\x0a"
"          class Alloc = allocator<pair<const Key, T>>>\x0a"
"class unordered_map\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef Key                                                        key_type;\x0a"
"    typedef T                                                          mapped_type;\x0a"
"    typedef Hash                                                       hasher;\x0a"
"    typedef Pred                                                       key_equal;\x0a"
"    typedef Alloc                                                      allocator_type;\x0a"
"    typedef pair<const key_type, mapped_type>                          value_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef /unspecified/ iterator;\x0a"
"    typedef /unspecified/ const_iterator;\x0a"
"    typedef /unspecified/ local_iterator;\x0a"
"    typedef /unspecified/ const_local_iterator;\x0a"
"\x0a"
"    typedef unspecified                             node_type;            // C++17\x0a"
"    typedef INSERT_RETURN_TYPE<iterator, node_type> insert_return_type;   // C++17\x0a"
"\x0a"
"    unordered_map()\x0a"
"        noexcept(\x0a"
"            is_nothrow_default_constructible<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_equal>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    explicit unordered_map(size_type n, const hasher\x26 hf = hasher(),\x0a"
"                           const key_equal\x26 eql = key_equal(),\x0a"
"                           const allocator_type\x26 a = allocator_type());\x0a"
"    template <class InputIterator>\x0a"
"        unordered_map(InputIterator f, InputIterator l,\x0a"
"                      size_type n = 0, const hasher\x26 hf = hasher(),\x0a"
"                      const key_equal\x26 eql = key_equal(),\x0a"
"                      const allocator_type\x26 a = allocator_type());\x0a"
"    explicit unordered_map(const allocator_type\x26);\x0a"
"    unordered_map(const unordered_map\x26);\x0a"
"    unordered_map(const unordered_map\x26, const Allocator\x26);\x0a"
"    unordered_map(unordered_map\x26\x26)\x0a"
"        noexcept(\x0a"
"            is_nothrow_move_constructible<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<key_equal>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    unordered_map(unordered_map\x26\x26, const Allocator\x26);\x0a"
"    unordered_map(initializer_list<value_type>, size_type n = 0,\x0a"
"                  const hasher\x26 hf = hasher(), const key_equal\x26 eql = key_equal(),\x0a"
"                  const allocator_type\x26 a = allocator_type());\x0a"
"    unordered_map(size_type n, const allocator_type\x26 a)\x0a"
"      \x3a unordered_map(n, hasher(), key_equal(), a) {}  // C++14\x0a"
"    unordered_map(size_type n, const hasher\x26 hf, const allocator_type\x26 a)\x0a"
"      \x3a unordered_map(n, hf, key_equal(), a) {}  // C++14\x0a"
"    template <class InputIterator>\x0a"
"      unordered_map(InputIterator f, InputIterator l, size_type n, const allocator_type\x26 a)\x0a"
"      \x3a unordered_map(f, l, n, hasher(), key_equal(), a) {}  // C++14\x0a"
"    template <class InputIterator>\x0a"
"      unordered_map(InputIterator f, InputIterator l, size_type n, const hasher\x26 hf,\x0a"
"        const allocator_type\x26 a)\x0a"
"      \x3a unordered_map(f, l, n, hf, key_equal(), a) {}  // C++14\x0a"
"    unordered_map(initializer_list<value_type> il, size_type n, const allocator_type\x26 a)\x0a"
"      \x3a unordered_map(il, n, hasher(), key_equal(), a) {}  // C++14\x0a"
"    unordered_map(initializer_list<value_type> il, size_type n, const hasher\x26 hf,\x0a"
"      const allocator_type\x26 a)\x0a"
"      \x3a unordered_map(il, n, hf, key_equal(), a) {}  // C++14\x0a"
"    \x7eunordered_map();\x0a"
"    unordered_map\x26 operator=(const unordered_map\x26);\x0a"
"    unordered_map\x26 operator=(unordered_map\x26\x26)\x0a"
"        noexcept(\x0a"
"            allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<key_equal>\x3a\x3avalue);\x0a"
"    unordered_map\x26 operator=(initializer_list<value_type>);\x0a"
"\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"\x0a"
"    bool      empty() const noexcept;\x0a"
"    size_type size() const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"\x0a"
"    iterator       begin() noexcept;\x0a"
"    iterator       end() noexcept;\x0a"
"    const_iterator begin()  const noexcept;\x0a"
"    const_iterator end()    const noexcept;\x0a"
"    const_iterator cbegin() const noexcept;\x0a"
"    const_iterator cend()   const noexcept;\x0a"
"\x0a"
"    template <class... Args>\x0a"
"        pair<iterator, bool> emplace(Args\x26\x26... args);\x0a"
"    template <class... Args>\x0a"
"        iterator emplace_hint(const_iterator position, Args\x26\x26... args);\x0a"
"    pair<iterator, bool> insert(const value_type\x26 obj);\x0a"
"    template <class P>\x0a"
"        pair<iterator, bool> insert(P\x26\x26 obj);\x0a"
"    iterator insert(const_iterator hint, const value_type\x26 obj);\x0a"
"    template <class P>\x0a"
"        iterator insert(const_iterator hint, P\x26\x26 obj);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"    void insert(initializer_list<value_type>);\x0a"
"\x0a"
"    node_type extract(const_iterator position);                                       // C++17\x0a"
"    node_type extract(const key_type\x26 x);                                             // C++17\x0a"
"    insert_return_type insert(node_type\x26\x26 nh);                                        // C++17\x0a"
"    iterator           insert(const_iterator hint, node_type\x26\x26 nh);                   // C++17\x0a"
"\x0a"
"    template <class... Args>\x0a"
"        pair<iterator, bool> try_emplace(const key_type\x26 k, Args\x26\x26... args);          // C++17\x0a"
"    template <class... Args>\x0a"
"        pair<iterator, bool> try_emplace(key_type\x26\x26 k, Args\x26\x26... args);               // C++17\x0a"
"    template <class... Args>\x0a"
"        iterator try_emplace(const_iterator hint, const key_type\x26 k, Args\x26\x26... args); // C++17\x0a"
"    template <class... Args>\x0a"
"        iterator try_emplace(const_iterator hint, key_type\x26\x26 k, Args\x26\x26... args);      // C++17\x0a"
"    template <class M>\x0a"
"        pair<iterator, bool> insert_or_assign(const key_type\x26 k, M\x26\x26 obj);            // C++17\x0a"
"    template <class M>\x0a"
"        pair<iterator, bool> insert_or_assign(key_type\x26\x26 k, M\x26\x26 obj);                 // C++17\x0a"
"    template <class M>\x0a"
"        iterator insert_or_assign(const_iterator hint, const key_type\x26 k, M\x26\x26 obj);   // C++17\x0a"
"    template <class M>\x0a"
"        iterator insert_or_assign(const_iterator hint, key_type\x26\x26 k, M\x26\x26 obj);        // C++17\x0a"
"\x0a"
"    iterator erase(const_iterator position);\x0a"
"    iterator erase(iterator position);  // C++14\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    iterator erase(const_iterator first, const_iterator last);\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_map<Key, T, H2, P2, Allocator>\x26 source);         // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_map<Key, T, H2, P2, Allocator>\x26\x26 source);        // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_multimap<Key, T, H2, P2, Allocator>\x26 source);    // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_multimap<Key, T, H2, P2, Allocator>\x26\x26 source);   // C++17\x0a"
"\x0a"
"    void swap(unordered_map\x26)\x0a"
"        noexcept(\x0a"
"            (\x21""allocator_type\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"             __is_nothrow_swappable<allocator_type>\x3a\x3avalue) \x26\x26\x0a"
"            __is_nothrow_swappable<hasher>\x3a\x3avalue \x26\x26\x0a"
"            __is_nothrow_swappable<key_equal>\x3a\x3avalue);\x0a"
"\x0a"
"    hasher hash_function() const;\x0a"
"    key_equal key_eq() const;\x0a"
"\x0a"
"    iterator       find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    size_type count(const key_type\x26 k) const;\x0a"
"    bool contains(const key_type\x26 k) const; // C++20\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"\x0a"
"    mapped_type\x26 operator\x5b\x5d(const key_type\x26 k);\x0a"
"    mapped_type\x26 operator\x5b\x5d(key_type\x26\x26 k);\x0a"
"\x0a"
"    mapped_type\x26       at(const key_type\x26 k);\x0a"
"    const mapped_type\x26 at(const key_type\x26 k) const;\x0a"
"\x0a"
"    size_type bucket_count() const noexcept;\x0a"
"    size_type max_bucket_count() const noexcept;\x0a"
"\x0a"
"    size_type bucket_size(size_type n) const;\x0a"
"    size_type bucket(const key_type\x26 k) const;\x0a"
"\x0a"
"    local_iterator       begin(size_type n);\x0a"
"    local_iterator       end(size_type n);\x0a"
"    const_local_iterator begin(size_type n) const;\x0a"
"    const_local_iterator end(size_type n) const;\x0a"
"    const_local_iterator cbegin(size_type n) const;\x0a"
"    const_local_iterator cend(size_type n) const;\x0a"
"\x0a"
"    float load_factor() const noexcept;\x0a"
"    float max_load_factor() const noexcept;\x0a"
"    void max_load_factor(float z);\x0a"
"    void rehash(size_type n);\x0a"
"    void reserve(size_type n);\x0a"
"};\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    void swap(unordered_map<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"              unordered_map<Key, T, Hash, Pred, Alloc>\x26 y)\x0a"
"              noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator==(const unordered_map<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"               const unordered_map<Key, T, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator\x21=(const unordered_map<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"               const unordered_map<Key, T, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Hash = hash<Key>, class Pred = equal_to<Key>,\x0a"
"          class Alloc = allocator<pair<const Key, T>>>\x0a"
"class unordered_multimap\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef Key                                                        key_type;\x0a"
"    typedef T                                                          mapped_type;\x0a"
"    typedef Hash                                                       hasher;\x0a"
"    typedef Pred                                                       key_equal;\x0a"
"    typedef Alloc                                                      allocator_type;\x0a"
"    typedef pair<const key_type, mapped_type>                          value_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef /unspecified/ iterator;\x0a"
"    typedef /unspecified/ const_iterator;\x0a"
"    typedef /unspecified/ local_iterator;\x0a"
"    typedef /unspecified/ const_local_iterator;\x0a"
"\x0a"
"    typedef unspecified node_type;    // C++17\x0a"
"\x0a"
"    unordered_multimap()\x0a"
"        noexcept(\x0a"
"            is_nothrow_default_constructible<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_equal>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    explicit unordered_multimap(size_type n, const hasher\x26 hf = hasher(),\x0a"
"                           const key_equal\x26 eql = key_equal(),\x0a"
"                           const allocator_type\x26 a = allocator_type());\x0a"
"    template <class InputIterator>\x0a"
"        unordered_multimap(InputIterator f, InputIterator l,\x0a"
"                      size_type n = 0, const hasher\x26 hf = hasher(),\x0a"
"                      const key_equal\x26 eql = key_equal(),\x0a"
"                      const allocator_type\x26 a = allocator_type());\x0a"
"    explicit unordered_multimap(const allocator_type\x26);\x0a"
"    unordered_multimap(const unordered_multimap\x26);\x0a"
"    unordered_multimap(const unordered_multimap\x26, const Allocator\x26);\x0a"
"    unordered_multimap(unordered_multimap\x26\x26)\x0a"
"        noexcept(\x0a"
"            is_nothrow_move_constructible<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<key_equal>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    unordered_multimap(unordered_multimap\x26\x26, const Allocator\x26);\x0a"
"    unordered_multimap(initializer_list<value_type>, size_type n = 0,\x0a"
"                  const hasher\x26 hf = hasher(), const key_equal\x26 eql = key_equal(),\x0a"
"                  const allocator_type\x26 a = allocator_type());\x0a"
"    unordered_multimap(size_type n, const allocator_type\x26 a)\x0a"
"      \x3a unordered_multimap(n, hasher(), key_equal(), a) {}  // C++14\x0a"
"    unordered_multimap(size_type n, const hasher\x26 hf, const allocator_type\x26 a)\x0a"
"      \x3a unordered_multimap(n, hf, key_equal(), a) {}  // C++14\x0a"
"    template <class InputIterator>\x0a"
"      unordered_multimap(InputIterator f, InputIterator l, size_type n, const allocator_type\x26 a)\x0a"
"      \x3a unordered_multimap(f, l, n, hasher(), key_equal(), a) {}  // C++14\x0a"
"    template <class InputIterator>\x0a"
"      unordered_multimap(InputIterator f, InputIterator l, size_type n, const hasher\x26 hf,\x0a"
"        const allocator_type\x26 a)\x0a"
"      \x3a unordered_multimap(f, l, n, hf, key_equal(), a) {}  // C++14\x0a"
"    unordered_multimap(initializer_list<value_type> il, size_type n, const allocator_type\x26 a)\x0a"
"      \x3a unordered_multimap(il, n, hasher(), key_equal(), a) {}  // C++14\x0a"
"    unordered_multimap(initializer_list<value_type> il, size_type n, const hasher\x26 hf,\x0a"
"      const allocator_type\x26 a)\x0a"
"      \x3a unordered_multimap(il, n, hf, key_equal(), a) {}  // C++14\x0a"
"    \x7eunordered_multimap();\x0a"
"    unordered_multimap\x26 operator=(const unordered_multimap\x26);\x0a"
"    unordered_multimap\x26 operator=(unordered_multimap\x26\x26)\x0a"
"        noexcept(\x0a"
"            allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<key_equal>\x3a\x3avalue);\x0a"
"    unordered_multimap\x26 operator=(initializer_list<value_type>);\x0a"
"\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"\x0a"
"    bool      empty() const noexcept;\x0a"
"    size_type size() const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"\x0a"
"    iterator       begin() noexcept;\x0a"
"    iterator       end() noexcept;\x0a"
"    const_iterator begin()  const noexcept;\x0a"
"    const_iterator end()    const noexcept;\x0a"
"    const_iterator cbegin() const noexcept;\x0a"
"    const_iterator cend()   const noexcept;\x0a"
"\x0a"
"    template <class... Args>\x0a"
"        iterator emplace(Args\x26\x26... args);\x0a"
"    template <class... Args>\x0a"
"        iterator emplace_hint(const_iterator position, Args\x26\x26... args);\x0a"
"    iterator insert(const value_type\x26 obj);\x0a"
"    template <class P>\x0a"
"        iterator insert(P\x26\x26 obj);\x0a"
"    iterator insert(const_iterator hint, const value_type\x26 obj);\x0a"
"    template <class P>\x0a"
"        iterator insert(const_iterator hint, P\x26\x26 obj);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"    void insert(initializer_list<value_type>);\x0a"
"\x0a"
"    node_type extract(const_iterator position);                // C++17\x0a"
"    node_type extract(const key_type\x26 x);                      // C++17\x0a"
"    iterator insert(node_type\x26\x26 nh);                           // C++17\x0a"
"    iterator insert(const_iterator hint, node_type\x26\x26 nh);      // C++17\x0a"
"\x0a"
"    iterator erase(const_iterator position);\x0a"
"    iterator erase(iterator position);  // C++14\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    iterator erase(const_iterator first, const_iterator last);\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_multimap<Key, T, H2, P2, Allocator>\x26 source);    // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_multimap<Key, T, H2, P2, Allocator>\x26\x26 source);   // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_map<Key, T, H2, P2, Allocator>\x26 source);         // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_map<Key, T, H2, P2, Allocator>\x26\x26 source);        // C++17\x0a"
"\x0a"
"    void swap(unordered_multimap\x26)\x0a"
"        noexcept(\x0a"
"            (\x21""allocator_type\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"             __is_nothrow_swappable<allocator_type>\x3a\x3avalue) \x26\x26\x0a"
"            __is_nothrow_swappable<hasher>\x3a\x3avalue \x26\x26\x0a"
"            __is_nothrow_swappable<key_equal>\x3a\x3avalue);\x0a"
"\x0a"
"    hasher hash_function() const;\x0a"
"    key_equal key_eq() const;\x0a"
"\x0a"
"    iterator       find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    size_type count(const key_type\x26 k) const;\x0a"
"    bool contains(const key_type\x26 k) const; // C++20\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"\x0a"
"    size_type bucket_count() const noexcept;\x0a"
"    size_type max_bucket_count() const noexcept;\x0a"
"\x0a"
"    size_type bucket_size(size_type n) const;\x0a"
"    size_type bucket(const key_type\x26 k) const;\x0a"
"\x0a"
"    local_iterator       begin(size_type n);\x0a"
"    local_iterator       end(size_type n);\x0a"
"    const_local_iterator begin(size_type n) const;\x0a"
"    const_local_iterator end(size_type n) const;\x0a"
"    const_local_iterator cbegin(size_type n) const;\x0a"
"    const_local_iterator cend(size_type n) const;\x0a"
"\x0a"
"    float load_factor() const noexcept;\x0a"
"    float max_load_factor() const noexcept;\x0a"
"    void max_load_factor(float z);\x0a"
"    void rehash(size_type n);\x0a"
"    void reserve(size_type n);\x0a"
"};\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    void swap(unordered_multimap<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"              unordered_multimap<Key, T, Hash, Pred, Alloc>\x26 y)\x0a"
"              noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class K, class T, class H, class P, class A, class Predicate>\x0a"
"    void erase_if(unordered_set<K, T, H, P, A>\x26 c, Predicate pred);       // C++20\x0a"
"\x0a"
"template <class K, class T, class H, class P, class A, class Predicate>\x0a"
"    void erase_if(unordered_multiset<K, T, H, P, A>\x26 c, Predicate pred);  // C++20\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator==(const unordered_multimap<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"               const unordered_multimap<Key, T, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Key, class T, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator\x21=(const unordered_multimap<Key, T, Hash, Pred, Alloc>\x26 x,\x0a"
"               const unordered_multimap<Key, T, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__hash_table>\x0a"
"#include <__node_handle>\x0a"
"#include <functional>\x0a"
"#include <stdexcept>\x0a"
"#include <tuple>\x0a"
"#include <version>\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Key, class _Cp, class _Hash,\x0a"
"          bool = is_empty<_Hash>\x3a\x3avalue \x26\x26 \x21__libcpp_is_final<_Hash>\x3a\x3avalue>\x0a"
"class __unordered_map_hasher\x0a"
"    \x3a private _Hash\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __unordered_map_hasher()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<_Hash>\x3a\x3avalue)\x0a"
"        \x3a _Hash() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __unordered_map_hasher(const _Hash\x26 __h)\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<_Hash>\x3a\x3avalue)\x0a"
"        \x3a _Hash(__h) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Hash\x26 hash_function() const _NOEXCEPT {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const _Cp\x26 __x) const\x0a"
"        {return static_cast<const _Hash\x26>(*this)(__x.__get_value().first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const _Key\x26 __x) const\x0a"
"        {return static_cast<const _Hash\x26>(*this)(__x);}\x0a"
"    void swap(__unordered_map_hasher\x26__y)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<_Hash>\x3a\x3avalue)\x0a"
"    {\x0a"
"        using _VSTD\x3a\x3aswap;\x0a"
"        swap(static_cast<_Hash\x26>(*this), static_cast<_Hash\x26>(__y));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Cp, class _Hash>\x0a"
"class __unordered_map_hasher<_Key, _Cp, _Hash, false>\x0a"
"{\x0a"
"    _Hash __hash_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __unordered_map_hasher()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<_Hash>\x3a\x3avalue)\x0a"
"        \x3a __hash_() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __unordered_map_hasher(const _Hash\x26 __h)\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<_Hash>\x3a\x3avalue)\x0a"
"        \x3a __hash_(__h) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Hash\x26 hash_function() const _NOEXCEPT {return __hash_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const _Cp\x26 __x) const\x0a"
"        {return __hash_(__x.__get_value().first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const _Key\x26 __x) const\x0a"
"        {return __hash_(__x);}\x0a"
"    void swap(__unordered_map_hasher\x26__y)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<_Hash>\x3a\x3avalue)\x0a"
"    {\x0a"
"        using _VSTD\x3a\x3aswap;\x0a"
"        swap(__hash_, __y.__hash_);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Cp, class _Hash, bool __b>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(__unordered_map_hasher<_Key, _Cp, _Hash, __b>\x26 __x,\x0a"
"     __unordered_map_hasher<_Key, _Cp, _Hash, __b>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Cp, class _Pred,\x0a"
"          bool = is_empty<_Pred>\x3a\x3avalue \x26\x26 \x21__libcpp_is_final<_Pred>\x3a\x3avalue>\x0a"
"class __unordered_map_equal\x0a"
"    \x3a private _Pred\x0a"
"{\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __unordered_map_equal()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<_Pred>\x3a\x3avalue)\x0a"
"        \x3a _Pred() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __unordered_map_equal(const _Pred\x26 __p)\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<_Pred>\x3a\x3avalue)\x0a"
"        \x3a _Pred(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Pred\x26 key_eq() const _NOEXCEPT {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Cp\x26 __x, const _Cp\x26 __y) const\x0a"
"        {return static_cast<const _Pred\x26>(*this)(__x.__get_value().first, __y.__get_value().first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Cp\x26 __x, const _Key\x26 __y) const\x0a"
"        {return static_cast<const _Pred\x26>(*this)(__x.__get_value().first, __y);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Key\x26 __x, const _Cp\x26 __y) const\x0a"
"        {return static_cast<const _Pred\x26>(*this)(__x, __y.__get_value().first);}\x0a"
"    void swap(__unordered_map_equal\x26__y)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<_Pred>\x3a\x3avalue)\x0a"
"    {\x0a"
"        using _VSTD\x3a\x3aswap;\x0a"
"        swap(static_cast<_Pred\x26>(*this), static_cast<_Pred\x26>(__y));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Cp, class _Pred>\x0a"
"class __unordered_map_equal<_Key, _Cp, _Pred, false>\x0a"
"{\x0a"
"    _Pred __pred_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __unordered_map_equal()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<_Pred>\x3a\x3avalue)\x0a"
"        \x3a __pred_() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __unordered_map_equal(const _Pred\x26 __p)\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<_Pred>\x3a\x3avalue)\x0a"
"        \x3a __pred_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Pred\x26 key_eq() const _NOEXCEPT {return __pred_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Cp\x26 __x, const _Cp\x26 __y) const\x0a"
"        {return __pred_(__x.__get_value().first, __y.__get_value().first);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Cp\x26 __x, const _Key\x26 __y) const\x0a"
"        {return __pred_(__x.__get_value().first, __y);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _Key\x26 __x, const _Cp\x26 __y) const\x0a"
"        {return __pred_(__x, __y.__get_value().first);}\x0a"
"    void swap(__unordered_map_equal\x26__y)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<_Pred>\x3a\x3avalue)\x0a"
"    {\x0a"
"        using _VSTD\x3a\x3aswap;\x0a"
"        swap(__pred_, __y.__pred_);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Cp, class _Pred, bool __b>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(__unordered_map_equal<_Key, _Cp, _Pred, __b>\x26 __x,\x0a"
"     __unordered_map_equal<_Key, _Cp, _Pred, __b>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"class __hash_map_node_destructor\x0a"
"{\x0a"
"    typedef _Alloc                              allocator_type;\x0a"
"    typedef allocator_traits<allocator_type>    __alloc_traits;\x0a"
"\x0a"
"public\x3a\x0a"
"\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer       pointer;\x0a"
"private\x3a\x0a"
"\x0a"
"    allocator_type\x26 __na_;\x0a"
"\x0a"
"    __hash_map_node_destructor\x26 operator=(const __hash_map_node_destructor\x26);\x0a"
"\x0a"
"public\x3a\x0a"
"    bool __first_constructed;\x0a"
"    bool __second_constructed;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __hash_map_node_destructor(allocator_type\x26 __na) _NOEXCEPT\x0a"
"        \x3a __na_(__na),\x0a"
"          __first_constructed(false),\x0a"
"          __second_constructed(false)\x0a"
"        {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_node_destructor(__hash_node_destructor<allocator_type>\x26\x26 __x)\x0a"
"        _NOEXCEPT\x0a"
"        \x3a __na_(__x.__na_),\x0a"
"          __first_constructed(__x.__value_constructed),\x0a"
"          __second_constructed(__x.__value_constructed)\x0a"
"        {\x0a"
"            __x.__value_constructed = false;\x0a"
"        }\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_node_destructor(const __hash_node_destructor<allocator_type>\x26 __x)\x0a"
"        \x3a __na_(__x.__na_),\x0a"
"          __first_constructed(__x.__value_constructed),\x0a"
"          __second_constructed(__x.__value_constructed)\x0a"
"        {\x0a"
"            const_cast<bool\x26>(__x.__value_constructed) = false;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator()(pointer __p) _NOEXCEPT\x0a"
"    {\x0a"
"        if (__second_constructed)\x0a"
"            __alloc_traits\x3a\x3a""destroy(__na_, _VSTD\x3a\x3a""addressof(__p->__value_.__get_value().second));\x0a"
"        if (__first_constructed)\x0a"
"            __alloc_traits\x3a\x3a""destroy(__na_, _VSTD\x3a\x3a""addressof(__p->__value_.__get_value().first));\x0a"
"        if (__p)\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__na_, __p, 1);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Key, class _Tp>\x0a"
"struct __hash_value_type\x0a"
"{\x0a"
"    typedef _Key                                     key_type;\x0a"
"    typedef _Tp                                      mapped_type;\x0a"
"    typedef pair<const key_type, mapped_type>        value_type;\x0a"
"    typedef pair<key_type\x26, mapped_type\x26>            __nc_ref_pair_type;\x0a"
"    typedef pair<key_type\x26\x26, mapped_type\x26\x26>          __nc_rref_pair_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    value_type __cc;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type\x26 __get_value()\x0a"
"    {\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        return *_VSTD\x3a\x3alaunder(_VSTD\x3a\x3a""addressof(__cc));\x0a"
"#else\x0a"
"        return __cc;\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type\x26 __get_value() const\x0a"
"    {\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        return *_VSTD\x3a\x3alaunder(_VSTD\x3a\x3a""addressof(__cc));\x0a"
"#else\x0a"
"        return __cc;\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __nc_ref_pair_type __ref()\x0a"
"    {\x0a"
"        value_type\x26 __v = __get_value();\x0a"
"        return __nc_ref_pair_type(const_cast<key_type\x26>(__v.first), __v.second);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __nc_rref_pair_type __move()\x0a"
"    {\x0a"
"        value_type\x26 __v = __get_value();\x0a"
"        return __nc_rref_pair_type(\x0a"
"            _VSTD\x3a\x3amove(const_cast<key_type\x26>(__v.first)),\x0a"
"            _VSTD\x3a\x3amove(__v.second));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_value_type\x26 operator=(const __hash_value_type\x26 __v)\x0a"
"    {\x0a"
"        __ref() = __v.__get_value();\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_value_type\x26 operator=(__hash_value_type\x26\x26 __v)\x0a"
"    {\x0a"
"        __ref() = __v.__move();\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    template <class _ValueTp,\x0a"
"              class = typename enable_if<\x0a"
"                    __is_same_uncvref<_ValueTp, value_type>\x3a\x3avalue\x0a"
"                 >\x3a\x3atype\x0a"
"             >\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_value_type\x26 operator=(_ValueTp\x26\x26 __v)\x0a"
"    {\x0a"
"        __ref() = _VSTD\x3a\x3a""forward<_ValueTp>(__v);\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    __hash_value_type(const __hash_value_type\x26 __v) = delete;\x0a"
"    __hash_value_type(__hash_value_type\x26\x26 __v) = delete;\x0a"
"    template <class ..._Args>\x0a"
"    explicit __hash_value_type(_Args\x26\x26 ...__args) = delete;\x0a"
"\x0a"
"    \x7e__hash_value_type() = delete;\x0a"
"};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Key, class _Tp>\x0a"
"struct __hash_value_type\x0a"
"{\x0a"
"    typedef _Key                                     key_type;\x0a"
"    typedef _Tp                                      mapped_type;\x0a"
"    typedef pair<const key_type, mapped_type>        value_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    value_type __cc;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type\x26 __get_value() { return __cc; }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type\x26 __get_value() const { return __cc; }\x0a"
"\x0a"
"private\x3a\x0a"
"   \x7e__hash_value_type();\x0a"
"};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"template <class _HashIterator>\x0a"
"class _LIBCPP_TEMPLATE_VIS __hash_map_iterator\x0a"
"{\x0a"
"    _HashIterator __i_;\x0a"
"\x0a"
"    typedef  __hash_node_types_from_iterator<_HashIterator> _NodeTypes;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef forward_iterator_tag                                 iterator_category;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__map_value_type                value_type;\x0a"
"    typedef typename _NodeTypes\x3a\x3a""difference_type                 difference_type;\x0a"
"    typedef value_type\x26                                          reference;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__map_value_type_pointer       pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_iterator() _NOEXCEPT {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_iterator(_HashIterator __i) _NOEXCEPT \x3a __i_(__i) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator*() const {return __i_->__get_value();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const {return pointer_traits<pointer>\x3a\x3apointer_to(__i_->__get_value());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_iterator\x26 operator++() {++__i_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_iterator operator++(int)\x0a"
"    {\x0a"
"        __hash_map_iterator __t(*this);\x0a"
"        ++(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const __hash_map_iterator\x26 __x, const __hash_map_iterator\x26 __y)\x0a"
"        {return __x.__i_ == __y.__i_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const __hash_map_iterator\x26 __x, const __hash_map_iterator\x26 __y)\x0a"
"        {return __x.__i_ \x21= __y.__i_;}\x0a"
"\x0a"
"    template <class, class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS unordered_map;\x0a"
"    template <class, class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS unordered_multimap;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __hash_const_iterator;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __hash_const_local_iterator;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __hash_map_const_iterator;\x0a"
"};\x0a"
"\x0a"
"template <class _HashIterator>\x0a"
"class _LIBCPP_TEMPLATE_VIS __hash_map_const_iterator\x0a"
"{\x0a"
"    _HashIterator __i_;\x0a"
"\x0a"
"    typedef  __hash_node_types_from_iterator<_HashIterator> _NodeTypes;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef forward_iterator_tag                                 iterator_category;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__map_value_type                value_type;\x0a"
"    typedef typename _NodeTypes\x3a\x3a""difference_type                 difference_type;\x0a"
"    typedef const value_type\x26                                    reference;\x0a"
"    typedef typename _NodeTypes\x3a\x3a__const_map_value_type_pointer  pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_const_iterator() _NOEXCEPT {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_const_iterator(_HashIterator __i) _NOEXCEPT \x3a __i_(__i) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_const_iterator(\x0a"
"            __hash_map_iterator<typename _HashIterator\x3a\x3a__non_const_iterator> __i)\x0a"
"                 _NOEXCEPT\x0a"
"                \x3a __i_(__i.__i_) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator*() const {return __i_->__get_value();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const {return pointer_traits<pointer>\x3a\x3apointer_to(__i_->__get_value());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_const_iterator\x26 operator++() {++__i_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __hash_map_const_iterator operator++(int)\x0a"
"    {\x0a"
"        __hash_map_const_iterator __t(*this);\x0a"
"        ++(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const __hash_map_const_iterator\x26 __x, const __hash_map_const_iterator\x26 __y)\x0a"
"        {return __x.__i_ == __y.__i_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const __hash_map_const_iterator\x26 __x, const __hash_map_const_iterator\x26 __y)\x0a"
"        {return __x.__i_ \x21= __y.__i_;}\x0a"
"\x0a"
"    template <class, class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS unordered_map;\x0a"
"    template <class, class, class, class, class> friend class _LIBCPP_TEMPLATE_VIS unordered_multimap;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __hash_const_iterator;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS __hash_const_local_iterator;\x0a"
"};\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"class unordered_multimap;\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = equal_to<_Key>,\x0a"
"          class _Alloc = allocator<pair<const _Key, _Tp> > >\x0a"
"class _LIBCPP_TEMPLATE_VIS unordered_map\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _Key                                           key_type;\x0a"
"    typedef _Tp                                            mapped_type;\x0a"
"    typedef typename __identity<_Hash>\x3a\x3atype               hasher;\x0a"
"    typedef typename __identity<_Pred>\x3a\x3atype               key_equal;\x0a"
"    typedef typename __identity<_Alloc>\x3a\x3atype              allocator_type;\x0a"
"    typedef pair<const key_type, mapped_type>              value_type;\x0a"
"    typedef value_type\x26                                    reference;\x0a"
"    typedef const value_type\x26                              const_reference;\x0a"
"    static_assert((is_same<value_type, typename allocator_type\x3a\x3avalue_type>\x3a\x3avalue),\x0a"
"                  \x22Invalid allocator\x3a\x3avalue_type\x22);\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef __hash_value_type<key_type, mapped_type>                 __value_type;\x0a"
"    typedef __unordered_map_hasher<key_type, __value_type, hasher>   __hasher;\x0a"
"    typedef __unordered_map_equal<key_type, __value_type, key_equal> __key_equal;\x0a"
"    typedef typename __rebind_alloc_helper<allocator_traits<allocator_type>,\x0a"
"                                                 __value_type>\x3a\x3atype __allocator_type;\x0a"
"\x0a"
"    typedef __hash_table<__value_type, __hasher,\x0a"
"                         __key_equal,  __allocator_type>   __table;\x0a"
"\x0a"
"    __table __table_;\x0a"
"\x0a"
"    typedef typename __table\x3a\x3a_NodeTypes                   _NodeTypes;\x0a"
"    typedef typename __table\x3a\x3a__node_pointer               __node_pointer;\x0a"
"    typedef typename __table\x3a\x3a__node_const_pointer         __node_const_pointer;\x0a"
"    typedef typename __table\x3a\x3a__node_traits                __node_traits;\x0a"
"    typedef typename __table\x3a\x3a__node_allocator             __node_allocator;\x0a"
"    typedef typename __table\x3a\x3a__node                       __node;\x0a"
"    typedef __hash_map_node_destructor<__node_allocator>   _Dp;\x0a"
"    typedef unique_ptr<__node, _Dp>                         __node_holder;\x0a"
"    typedef allocator_traits<allocator_type>               __alloc_traits;\x0a"
"\x0a"
"    static_assert((is_same<typename __table\x3a\x3a__container_value_type, value_type>\x3a\x3avalue), \x22\x22);\x0a"
"    static_assert((is_same<typename __table\x3a\x3a__node_value_type, __value_type>\x3a\x3avalue), \x22\x22);\x0a"
"public\x3a\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer         pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename __table\x3a\x3asize_type              size_type;\x0a"
"    typedef typename __table\x3a\x3a""difference_type        difference_type;\x0a"
"\x0a"
"    typedef __hash_map_iterator<typename __table\x3a\x3aiterator>       iterator;\x0a"
"    typedef __hash_map_const_iterator<typename __table\x3a\x3a""const_iterator> const_iterator;\x0a"
"    typedef __hash_map_iterator<typename __table\x3a\x3alocal_iterator> local_iterator;\x0a"
"    typedef __hash_map_const_iterator<typename __table\x3a\x3a""const_local_iterator> const_local_iterator;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    typedef __map_node_handle<__node, allocator_type> node_type;\x0a"
"    typedef __insert_return_type<iterator, node_type> insert_return_type;\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Key2, class _Tp2, class _Hash2, class _Pred2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS unordered_map;\x0a"
"    template <class _Key2, class _Tp2, class _Hash2, class _Pred2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS unordered_multimap;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_map()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<__table>\x3a\x3avalue)\x0a"
"        {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"            __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"        }\x0a"
"    explicit unordered_map(size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                           const key_equal\x26 __eql = key_equal());\x0a"
"    unordered_map(size_type __n, const hasher\x26 __hf,\x0a"
"                  const key_equal\x26 __eql,\x0a"
"                  const allocator_type\x26 __a);\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_map(_InputIterator __first, _InputIterator __last);\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_map(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                      const key_equal\x26 __eql = key_equal());\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_map(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf,\x0a"
"                      const key_equal\x26 __eql,\x0a"
"                      const allocator_type\x26 __a);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit unordered_map(const allocator_type\x26 __a);\x0a"
"    unordered_map(const unordered_map\x26 __u);\x0a"
"    unordered_map(const unordered_map\x26 __u, const allocator_type\x26 __a);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_map(unordered_map\x26\x26 __u)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__table>\x3a\x3avalue);\x0a"
"    unordered_map(unordered_map\x26\x26 __u, const allocator_type\x26 __a);\x0a"
"    unordered_map(initializer_list<value_type> __il);\x0a"
"    unordered_map(initializer_list<value_type> __il, size_type __n,\x0a"
"                  const hasher\x26 __hf = hasher(), const key_equal\x26 __eql = key_equal());\x0a"
"    unordered_map(initializer_list<value_type> __il, size_type __n,\x0a"
"                  const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"                  const allocator_type\x26 __a);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_map(size_type __n, const allocator_type\x26 __a)\x0a"
"      \x3a unordered_map(__n, hasher(), key_equal(), __a) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_map(size_type __n, const hasher\x26 __hf, const allocator_type\x26 __a)\x0a"
"      \x3a unordered_map(__n, __hf, key_equal(), __a) {}\x0a"
"    template <class _InputIterator>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"      unordered_map(_InputIterator __first, _InputIterator __last, size_type __n, const allocator_type\x26 __a)\x0a"
"      \x3a unordered_map(__first, __last, __n, hasher(), key_equal(), __a) {}\x0a"
"    template <class _InputIterator>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"      unordered_map(_InputIterator __first, _InputIterator __last, size_type __n, const hasher\x26 __hf,\x0a"
"        const allocator_type\x26 __a)\x0a"
"      \x3a unordered_map(__first, __last, __n, __hf, key_equal(), __a) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_map(initializer_list<value_type> __il, size_type __n, const allocator_type\x26 __a)\x0a"
"      \x3a unordered_map(__il, __n, hasher(), key_equal(), __a) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_map(initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf,\x0a"
"      const allocator_type\x26 __a)\x0a"
"      \x3a unordered_map(__il, __n, __hf, key_equal(), __a) {}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7eunordered_map() {\x0a"
"        static_assert(sizeof(__diagnose_unordered_container_requirements<_Key, _Hash, _Pred>(0)), \x22\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_map\x26 operator=(const unordered_map\x26 __u)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"        __table_ = __u.__table_;\x0a"
"#else\x0a"
"        if (this \x21= \x26__u) {\x0a"
"            __table_.clear();\x0a"
"            __table_.hash_function() = __u.__table_.hash_function();\x0a"
"            __table_.key_eq() = __u.__table_.key_eq();\x0a"
"            __table_.max_load_factor() = __u.__table_.max_load_factor();\x0a"
"            __table_.__copy_assign_alloc(__u.__table_);\x0a"
"            insert(__u.begin(), __u.end());\x0a"
"        }\x0a"
"#endif\x0a"
"        return *this;\x0a"
"    }\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_map\x26 operator=(unordered_map\x26\x26 __u)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__table>\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_map\x26 operator=(initializer_list<value_type> __il);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT\x0a"
"        {return allocator_type(__table_.__node_alloc());}\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool      empty() const _NOEXCEPT {return __table_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT  {return __table_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT {return __table_.max_size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       begin() _NOEXCEPT        {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       end() _NOEXCEPT          {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin()  const _NOEXCEPT {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()    const _NOEXCEPT {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const _NOEXCEPT {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend()   const _NOEXCEPT {return __table_.end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> insert(const value_type\x26 __x)\x0a"
"        {return __table_.__insert_unique(__x);}\x0a"
"\x0a"
"    iterator insert(const_iterator __p, const value_type\x26 __x) {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"            \x22unordered_map\x3a\x3ainsert(const_iterator, const value_type\x26) called with an iterator not\x22\x0a"
"            \x22 referring to this unordered_map\x22);\x0a"
"#else\x0a"
"        ((void)__p);\x0a"
"#endif\x0a"
"        return insert(__x).first;\x0a"
"    }\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __first, _InputIterator __last);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(initializer_list<value_type> __il)\x0a"
"        {insert(__il.begin(), __il.end());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> insert(value_type\x26\x26 __x)\x0a"
"        {return __table_.__insert_unique(_VSTD\x3a\x3amove(__x));}\x0a"
"\x0a"
"    iterator insert(const_iterator __p, value_type\x26\x26 __x) {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"            \x22unordered_map\x3a\x3ainsert(const_iterator, const value_type\x26) called with an iterator not\x22\x0a"
"            \x22 referring to this unordered_map\x22);\x0a"
"#else\x0a"
"        ((void)__p);\x0a"
"#endif\x0a"
"        return __table_.__insert_unique(_VSTD\x3a\x3amove(__x)).first;\x0a"
"    }\x0a"
"\x0a"
"    template <class _Pp,\x0a"
"              class = typename enable_if<is_constructible<value_type, _Pp>\x3a\x3avalue>\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> insert(_Pp\x26\x26 __x)\x0a"
"            {return __table_.__insert_unique(_VSTD\x3a\x3a""forward<_Pp>(__x));}\x0a"
"\x0a"
"    template <class _Pp,\x0a"
"              class = typename enable_if<is_constructible<value_type, _Pp>\x3a\x3avalue>\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator insert(const_iterator __p, _Pp\x26\x26 __x)\x0a"
"        {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"            _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"                \x22unordered_map\x3a\x3ainsert(const_iterator, value_type\x26\x26) called with an iterator not\x22\x0a"
"                \x22 referring to this unordered_map\x22);\x0a"
"#else\x0a"
"          ((void)__p);\x0a"
"#endif\x0a"
"            return insert(_VSTD\x3a\x3a""forward<_Pp>(__x)).first;\x0a"
"        }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> emplace(_Args\x26\x26... __args) {\x0a"
"        return __table_.__emplace_unique(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator emplace_hint(const_iterator __p, _Args\x26\x26... __args) {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"            \x22unordered_map\x3a\x3a""emplace_hint(const_iterator, args...) called with an iterator not\x22\x0a"
"            \x22 referring to this unordered_map\x22);\x0a"
"#else\x0a"
"          ((void)__p);\x0a"
"#endif\x0a"
"        return __table_.__emplace_unique(_VSTD\x3a\x3a""forward<_Args>(__args)...).first;\x0a"
"    }\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> try_emplace(const key_type\x26 __k, _Args\x26\x26... __args)\x0a"
"    {\x0a"
"        return __table_.__emplace_unique_key_args(__k, _VSTD\x3a\x3apiecewise_construct,\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(__k),\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Args>(__args)...));\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> try_emplace(key_type\x26\x26 __k, _Args\x26\x26... __args)\x0a"
"    {\x0a"
"        return __table_.__emplace_unique_key_args(__k, _VSTD\x3a\x3apiecewise_construct,\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3amove(__k)),\x0a"
"            _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Args>(__args)...));\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator try_emplace(const_iterator __h, const key_type\x26 __k, _Args\x26\x26... __args)\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__h) == this,\x0a"
"            \x22unordered_map\x3a\x3atry_emplace(const_iterator, key, args...) called with an iterator not\x22\x0a"
"            \x22 referring to this unordered_map\x22);\x0a"
"#else\x0a"
"        ((void)__h);\x0a"
"#endif\x0a"
"        return try_emplace(__k, _VSTD\x3a\x3a""forward<_Args>(__args)...).first;\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator try_emplace(const_iterator __h, key_type\x26\x26 __k, _Args\x26\x26... __args)\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__h) == this,\x0a"
"            \x22unordered_map\x3a\x3atry_emplace(const_iterator, key, args...) called with an iterator not\x22\x0a"
"            \x22 referring to this unordered_map\x22);\x0a"
"#else\x0a"
"        ((void)__h);\x0a"
"#endif\x0a"
"        return try_emplace(_VSTD\x3a\x3amove(__k), _VSTD\x3a\x3a""forward<_Args>(__args)...).first;\x0a"
"    }\x0a"
"\x0a"
"    template <class _Vp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> insert_or_assign(const key_type\x26 __k, _Vp\x26\x26 __v)\x0a"
"    {\x0a"
"        pair<iterator, bool> __res = __table_.__emplace_unique_key_args(__k,\x0a"
"            __k, _VSTD\x3a\x3a""forward<_Vp>(__v));\x0a"
"        if (\x21__res.second) {\x0a"
"            __res.first->second = _VSTD\x3a\x3a""forward<_Vp>(__v);\x0a"
"        }\x0a"
"        return __res;\x0a"
"    }\x0a"
"\x0a"
"    template <class _Vp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> insert_or_assign(key_type\x26\x26 __k, _Vp\x26\x26 __v)\x0a"
"    {\x0a"
"        pair<iterator, bool> __res = __table_.__emplace_unique_key_args(__k,\x0a"
"            _VSTD\x3a\x3amove(__k), _VSTD\x3a\x3a""forward<_Vp>(__v));\x0a"
"        if (\x21__res.second) {\x0a"
"            __res.first->second = _VSTD\x3a\x3a""forward<_Vp>(__v);\x0a"
"        }\x0a"
"        return __res;\x0a"
"    }\x0a"
"\x0a"
"    template <class _Vp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator insert_or_assign(const_iterator, const key_type\x26 __k, _Vp\x26\x26 __v)\x0a"
"     {\x0a"
"          // FIXME\x3a Add debug mode checking for the iterator input\x0a"
"          return insert_or_assign(__k, _VSTD\x3a\x3a""forward<_Vp>(__v)).first;\x0a"
"     }\x0a"
"\x0a"
"    template <class _Vp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator insert_or_assign(const_iterator, key_type\x26\x26 __k, _Vp\x26\x26 __v)\x0a"
"     {\x0a"
"        // FIXME\x3a Add debug mode checking for the iterator input\x0a"
"        return insert_or_assign(_VSTD\x3a\x3amove(__k), _VSTD\x3a\x3a""forward<_Vp>(__v)).first;\x0a"
"     }\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(const_iterator __p) {return __table_.erase(__p.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(iterator __p)       {return __table_.erase(__p.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k) {return __table_.__erase_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(const_iterator __first, const_iterator __last)\x0a"
"        {return __table_.erase(__first.__i_, __last.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"        void clear() _NOEXCEPT {__table_.clear();}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    insert_return_type insert(node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to unordered_map\x3a\x3ainsert()\x22);\x0a"
"        return __table_.template __node_handle_insert_unique<\x0a"
"            node_type, insert_return_type>(_VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __hint, node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to unordered_map\x3a\x3ainsert()\x22);\x0a"
"        return __table_.template __node_handle_insert_unique<node_type>(\x0a"
"            __hint.__i_, _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(key_type const\x26 __key)\x0a"
"    {\x0a"
"        return __table_.template __node_handle_extract<node_type>(__key);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(const_iterator __it)\x0a"
"    {\x0a"
"        return __table_.template __node_handle_extract<node_type>(\x0a"
"            __it.__i_);\x0a"
"    }\x0a"
"\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_map<key_type, mapped_type, _H2, _P2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_unique(__source.__table_);\x0a"
"    }\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_map<key_type, mapped_type, _H2, _P2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_unique(__source.__table_);\x0a"
"    }\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_multimap<key_type, mapped_type, _H2, _P2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_unique(__source.__table_);\x0a"
"    }\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_multimap<key_type, mapped_type, _H2, _P2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_unique(__source.__table_);\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(unordered_map\x26 __u)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<__table>\x3a\x3avalue)\x0a"
"        { __table_.swap(__u.__table_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hasher hash_function() const\x0a"
"        {return __table_.hash_function().hash_function();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_equal key_eq() const\x0a"
"        {return __table_.key_eq().key_eq();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       find(const key_type\x26 __k)       {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type count(const key_type\x26 __k) const {return __table_.__count_unique(__k);}\x0a"
"    #if _LIBCPP_STD_VER > 17\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool contains(const key_type\x26 __k) const {return find(__k) \x21= end();}\x0a"
"    #endif // _LIBCPP_STD_VER > 17\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 __k)\x0a"
"        {return __table_.__equal_range_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"        {return __table_.__equal_range_unique(__k);}\x0a"
"\x0a"
"    mapped_type\x26 operator\x5b\x5d(const key_type\x26 __k);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    mapped_type\x26 operator\x5b\x5d(key_type\x26\x26 __k);\x0a"
"#endif\x0a"
"\x0a"
"    mapped_type\x26       at(const key_type\x26 __k);\x0a"
"    const mapped_type\x26 at(const key_type\x26 __k) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_count() const _NOEXCEPT {return __table_.bucket_count();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_bucket_count() const _NOEXCEPT {return __table_.max_bucket_count();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_size(size_type __n) const\x0a"
"        {return __table_.bucket_size(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket(const key_type\x26 __k) const {return __table_.bucket(__k);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    local_iterator       begin(size_type __n)        {return __table_.begin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    local_iterator       end(size_type __n)          {return __table_.end(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator begin(size_type __n) const  {return __table_.cbegin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator end(size_type __n) const    {return __table_.cend(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator cbegin(size_type __n) const {return __table_.cbegin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator cend(size_type __n) const   {return __table_.cend(__n);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    float load_factor() const _NOEXCEPT {return __table_.load_factor();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    float max_load_factor() const _NOEXCEPT {return __table_.max_load_factor();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void max_load_factor(float __mlf) {__table_.max_load_factor(__mlf);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void rehash(size_type __n) {__table_.rehash(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reserve(size_type __n) {__table_.reserve(__n);}\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"    bool __dereferenceable(const const_iterator* __i) const\x0a"
"        {return __table_.__dereferenceable(\x26__i->__i_);}\x0a"
"    bool __decrementable(const const_iterator* __i) const\x0a"
"        {return __table_.__decrementable(\x26__i->__i_);}\x0a"
"    bool __addable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"        {return __table_.__addable(\x26__i->__i_, __n);}\x0a"
"    bool __subscriptable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"        {return __table_.__addable(\x26__i->__i_, __n);}\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    __node_holder __construct_node_with_key(const key_type\x26 __k);\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _Hash = hash<__iter_key_type<_InputIterator>>,\x0a"
"         class _Pred = equal_to<__iter_key_type<_InputIterator>>,\x0a"
"         class _Allocator = allocator<__iter_to_alloc_type<_InputIterator>>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Pred>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_map(_InputIterator, _InputIterator, typename allocator_traits<_Allocator>\x3a\x3asize_type = 0,\x0a"
"              _Hash = _Hash(), _Pred = _Pred(), _Allocator = _Allocator())\x0a"
"  -> unordered_map<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>, _Hash, _Pred, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Hash = hash<remove_const_t<_Key>>,\x0a"
"         class _Pred = equal_to<remove_const_t<_Key>>,\x0a"
"         class _Allocator = allocator<pair<const _Key, _Tp>>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Pred>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_map(initializer_list<pair<_Key, _Tp>>, typename allocator_traits<_Allocator>\x3a\x3asize_type = 0,\x0a"
"              _Hash = _Hash(), _Pred = _Pred(), _Allocator = _Allocator())\x0a"
"  -> unordered_map<remove_const_t<_Key>, _Tp, _Hash, _Pred, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_map(_InputIterator, _InputIterator, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Allocator)\x0a"
"  -> unordered_map<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>,\x0a"
"                   hash<__iter_key_type<_InputIterator>>, equal_to<__iter_key_type<_InputIterator>>, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_map(_InputIterator, _InputIterator, _Allocator)\x0a"
"  -> unordered_map<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>,\x0a"
"                   hash<__iter_key_type<_InputIterator>>, equal_to<__iter_key_type<_InputIterator>>, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Hash, class _Allocator,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_map(_InputIterator, _InputIterator, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Hash, _Allocator)\x0a"
"  -> unordered_map<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>,\x0a"
"                   _Hash, equal_to<__iter_key_type<_InputIterator>>, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_map(initializer_list<pair<_Key, _Tp>>, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Allocator)\x0a"
"  -> unordered_map<remove_const_t<_Key>, _Tp,\x0a"
"                   hash<remove_const_t<_Key>>,\x0a"
"                   equal_to<remove_const_t<_Key>>, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_map(initializer_list<pair<_Key, _Tp>>, _Allocator)\x0a"
"  -> unordered_map<remove_const_t<_Key>, _Tp,\x0a"
"                   hash<remove_const_t<_Key>>,\x0a"
"                   equal_to<remove_const_t<_Key>>, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Hash, class _Allocator,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_map(initializer_list<pair<_Key, _Tp>>, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Hash, _Allocator)\x0a"
"  -> unordered_map<remove_const_t<_Key>, _Tp, _Hash,\x0a"
"                   equal_to<remove_const_t<_Key>>, _Allocator>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __table_(typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        const unordered_map\x26 __u)\x0a"
"    \x3a __table_(__u.__table_)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        const unordered_map\x26 __u, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__u.__table_, typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        unordered_map\x26\x26 __u)\x0a"
"    _NOEXCEPT_(is_nothrow_move_constructible<__table>\x3a\x3avalue)\x0a"
"    \x3a __table_(_VSTD\x3a\x3amove(__u.__table_))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"    __get_db()->swap(this, \x26__u);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        unordered_map\x26\x26 __u, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(_VSTD\x3a\x3amove(__u.__table_), typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__a \x21= __u.get_allocator())\x0a"
"    {\x0a"
"        iterator __i = __u.begin();\x0a"
"        while (__u.size() \x21= 0) {\x0a"
"            __table_.__emplace_unique(\x0a"
"                __u.__table_.remove((__i++).__i_)->__value_.__move());\x0a"
"        }\x0a"
"    }\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    else\x0a"
"        __get_db()->swap(this, \x26__u);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        initializer_list<value_type> __il)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf,\x0a"
"        const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_map(\x0a"
"        initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf,\x0a"
"        const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aoperator=(unordered_map\x26\x26 __u)\x0a"
"    _NOEXCEPT_(is_nothrow_move_assignable<__table>\x3a\x3avalue)\x0a"
"{\x0a"
"    __table_ = _VSTD\x3a\x3amove(__u.__table_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aoperator=(\x0a"
"        initializer_list<value_type> __il)\x0a"
"{\x0a"
"    __table_.__assign_unique(__il.begin(), __il.end());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"inline\x0a"
"void\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ainsert(_InputIterator __first,\x0a"
"                                                       _InputIterator __last)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __table_.__insert_unique(*__first);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"_Tp\x26\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aoperator\x5b\x5d(const key_type\x26 __k)\x0a"
"{\x0a"
"    return __table_.__emplace_unique_key_args(__k,\x0a"
"        std\x3a\x3apiecewise_construct, std\x3a\x3a""forward_as_tuple(__k),\x0a"
"                                  std\x3a\x3a""forward_as_tuple()).first->__get_value().second;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"_Tp\x26\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aoperator\x5b\x5d(key_type\x26\x26 __k)\x0a"
"{\x0a"
"    return __table_.__emplace_unique_key_args(__k,\x0a"
"        std\x3a\x3apiecewise_construct, std\x3a\x3a""forward_as_tuple(std\x3a\x3amove(__k)),\x0a"
"                                  std\x3a\x3a""forward_as_tuple()).first->__get_value().second;\x0a"
"}\x0a"
"#else // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"typename unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3a__node_holder\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3a__construct_node_with_key(const key_type\x26 __k)\x0a"
"{\x0a"
"    __node_allocator\x26 __na = __table_.__node_alloc();\x0a"
"    __node_holder __h(__node_traits\x3a\x3a""allocate(__na, 1), _Dp(__na));\x0a"
"    __node_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__h->__value_.__get_value().first), __k);\x0a"
"    __h.get_deleter().__first_constructed = true;\x0a"
"    __node_traits\x3a\x3a""construct(__na, _VSTD\x3a\x3a""addressof(__h->__value_.__get_value().second));\x0a"
"    __h.get_deleter().__second_constructed = true;\x0a"
"    return _LIBCPP_EXPLICIT_MOVE(__h);  // explicitly moved for C++03\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"_Tp\x26\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aoperator\x5b\x5d(const key_type\x26 __k)\x0a"
"{\x0a"
"    iterator __i = find(__k);\x0a"
"    if (__i \x21= end())\x0a"
"        return __i->second;\x0a"
"    __node_holder __h = __construct_node_with_key(__k);\x0a"
"    pair<iterator, bool> __r = __table_.__node_insert_unique(__h.get());\x0a"
"    __h.release();\x0a"
"    return __r.first->second;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_MODE\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"_Tp\x26\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3a""at(const key_type\x26 __k)\x0a"
"{\x0a"
"    iterator __i = find(__k);\x0a"
"    if (__i == end())\x0a"
"        __throw_out_of_range(\x22unordered_map\x3a\x3a""at\x3a key not found\x22);\x0a"
"    return __i->second;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"const _Tp\x26\x0a"
"unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3a""at(const key_type\x26 __k) const\x0a"
"{\x0a"
"    const_iterator __i = find(__k);\x0a"
"    if (__i == end())\x0a"
"        __throw_out_of_range(\x22unordered_map\x3a\x3a""at\x3a key not found\x22);\x0a"
"    return __i->second;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"     unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __c, _Predicate __pred)\x0a"
"{ __libcpp_erase_if_container(__c, __pred); }\x0a"
"#endif\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"bool\x0a"
"operator==(const unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    if (__x.size() \x21= __y.size())\x0a"
"        return false;\x0a"
"    typedef typename unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3a""const_iterator\x0a"
"                                                                 const_iterator;\x0a"
"    for (const_iterator __i = __x.begin(), __ex = __x.end(), __ey = __y.end();\x0a"
"            __i \x21= __ex; ++__i)\x0a"
"    {\x0a"
"        const_iterator __j = __y.find(__i->first);\x0a"
"        if (__j == __ey \x7c\x7c \x21(*__i == *__j))\x0a"
"            return false;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash = hash<_Key>, class _Pred = equal_to<_Key>,\x0a"
"          class _Alloc = allocator<pair<const _Key, _Tp> > >\x0a"
"class _LIBCPP_TEMPLATE_VIS unordered_multimap\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _Key                                           key_type;\x0a"
"    typedef _Tp                                            mapped_type;\x0a"
"    typedef typename __identity<_Hash>\x3a\x3atype               hasher;\x0a"
"    typedef typename __identity<_Pred>\x3a\x3atype               key_equal;\x0a"
"    typedef typename __identity<_Alloc>\x3a\x3atype              allocator_type;\x0a"
"    typedef pair<const key_type, mapped_type>              value_type;\x0a"
"    typedef value_type\x26                                    reference;\x0a"
"    typedef const value_type\x26                              const_reference;\x0a"
"    static_assert((is_same<value_type, typename allocator_type\x3a\x3avalue_type>\x3a\x3avalue),\x0a"
"                  \x22Invalid allocator\x3a\x3avalue_type\x22);\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef __hash_value_type<key_type, mapped_type>                 __value_type;\x0a"
"    typedef __unordered_map_hasher<key_type, __value_type, hasher>   __hasher;\x0a"
"    typedef __unordered_map_equal<key_type, __value_type, key_equal> __key_equal;\x0a"
"    typedef typename __rebind_alloc_helper<allocator_traits<allocator_type>,\x0a"
"                                                 __value_type>\x3a\x3atype __allocator_type;\x0a"
"\x0a"
"    typedef __hash_table<__value_type, __hasher,\x0a"
"                         __key_equal,  __allocator_type>   __table;\x0a"
"\x0a"
"    __table __table_;\x0a"
"\x0a"
"    typedef typename __table\x3a\x3a_NodeTypes                   _NodeTypes;\x0a"
"    typedef typename __table\x3a\x3a__node_traits                __node_traits;\x0a"
"    typedef typename __table\x3a\x3a__node_allocator             __node_allocator;\x0a"
"    typedef typename __table\x3a\x3a__node                       __node;\x0a"
"    typedef __hash_map_node_destructor<__node_allocator>   _Dp;\x0a"
"    typedef unique_ptr<__node, _Dp>                         __node_holder;\x0a"
"    typedef allocator_traits<allocator_type>               __alloc_traits;\x0a"
"    static_assert((is_same<typename __node_traits\x3a\x3asize_type,\x0a"
"                          typename __alloc_traits\x3a\x3asize_type>\x3a\x3avalue),\x0a"
"                 \x22""Allocator uses different size_type for different types\x22);\x0a"
"public\x3a\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer         pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename __table\x3a\x3asize_type              size_type;\x0a"
"    typedef typename __table\x3a\x3a""difference_type        difference_type;\x0a"
"\x0a"
"    typedef __hash_map_iterator<typename __table\x3a\x3aiterator>       iterator;\x0a"
"    typedef __hash_map_const_iterator<typename __table\x3a\x3a""const_iterator> const_iterator;\x0a"
"    typedef __hash_map_iterator<typename __table\x3a\x3alocal_iterator> local_iterator;\x0a"
"    typedef __hash_map_const_iterator<typename __table\x3a\x3a""const_local_iterator> const_local_iterator;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    typedef __map_node_handle<__node, allocator_type> node_type;\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Key2, class _Tp2, class _Hash2, class _Pred2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS unordered_map;\x0a"
"    template <class _Key2, class _Tp2, class _Hash2, class _Pred2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS unordered_multimap;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multimap()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<__table>\x3a\x3avalue)\x0a"
"        {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"            __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"        }\x0a"
"    explicit unordered_multimap(size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                                const key_equal\x26 __eql = key_equal());\x0a"
"    unordered_multimap(size_type __n, const hasher\x26 __hf,\x0a"
"                                const key_equal\x26 __eql,\x0a"
"                                const allocator_type\x26 __a);\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_multimap(_InputIterator __first, _InputIterator __last);\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_multimap(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                      const key_equal\x26 __eql = key_equal());\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_multimap(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf,\x0a"
"                      const key_equal\x26 __eql,\x0a"
"                      const allocator_type\x26 __a);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit unordered_multimap(const allocator_type\x26 __a);\x0a"
"    unordered_multimap(const unordered_multimap\x26 __u);\x0a"
"    unordered_multimap(const unordered_multimap\x26 __u, const allocator_type\x26 __a);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multimap(unordered_multimap\x26\x26 __u)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__table>\x3a\x3avalue);\x0a"
"    unordered_multimap(unordered_multimap\x26\x26 __u, const allocator_type\x26 __a);\x0a"
"    unordered_multimap(initializer_list<value_type> __il);\x0a"
"    unordered_multimap(initializer_list<value_type> __il, size_type __n,\x0a"
"                       const hasher\x26 __hf = hasher(),\x0a"
"                       const key_equal\x26 __eql = key_equal());\x0a"
"    unordered_multimap(initializer_list<value_type> __il, size_type __n,\x0a"
"                       const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"                       const allocator_type\x26 __a);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multimap(size_type __n, const allocator_type\x26 __a)\x0a"
"      \x3a unordered_multimap(__n, hasher(), key_equal(), __a) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multimap(size_type __n, const hasher\x26 __hf, const allocator_type\x26 __a)\x0a"
"      \x3a unordered_multimap(__n, __hf, key_equal(), __a) {}\x0a"
"    template <class _InputIterator>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"      unordered_multimap(_InputIterator __first, _InputIterator __last, size_type __n, const allocator_type\x26 __a)\x0a"
"      \x3a unordered_multimap(__first, __last, __n, hasher(), key_equal(), __a) {}\x0a"
"    template <class _InputIterator>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"      unordered_multimap(_InputIterator __first, _InputIterator __last, size_type __n, const hasher\x26 __hf,\x0a"
"        const allocator_type\x26 __a)\x0a"
"      \x3a unordered_multimap(__first, __last, __n, __hf, key_equal(), __a) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multimap(initializer_list<value_type> __il, size_type __n, const allocator_type\x26 __a)\x0a"
"      \x3a unordered_multimap(__il, __n, hasher(), key_equal(), __a) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multimap(initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf,\x0a"
"      const allocator_type\x26 __a)\x0a"
"      \x3a unordered_multimap(__il, __n, __hf, key_equal(), __a) {}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7eunordered_multimap() {\x0a"
"        static_assert(sizeof(__diagnose_unordered_container_requirements<_Key, _Hash, _Pred>(0)), \x22\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multimap\x26 operator=(const unordered_multimap\x26 __u)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"        __table_ = __u.__table_;\x0a"
"#else\x0a"
"        if (this \x21= \x26__u) {\x0a"
"            __table_.clear();\x0a"
"            __table_.hash_function() = __u.__table_.hash_function();\x0a"
"            __table_.key_eq() = __u.__table_.key_eq();\x0a"
"            __table_.max_load_factor() = __u.__table_.max_load_factor();\x0a"
"            __table_.__copy_assign_alloc(__u.__table_);\x0a"
"            insert(__u.begin(), __u.end());\x0a"
"        }\x0a"
"#endif\x0a"
"        return *this;\x0a"
"    }\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multimap\x26 operator=(unordered_multimap\x26\x26 __u)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__table>\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multimap\x26 operator=(initializer_list<value_type> __il);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT\x0a"
"        {return allocator_type(__table_.__node_alloc());}\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool      empty() const _NOEXCEPT {return __table_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT  {return __table_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT {return __table_.max_size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       begin() _NOEXCEPT        {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       end() _NOEXCEPT          {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin()  const _NOEXCEPT {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()    const _NOEXCEPT {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const _NOEXCEPT {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend()   const _NOEXCEPT {return __table_.end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const value_type\x26 __x) {return __table_.__insert_multi(__x);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, const value_type\x26 __x)\x0a"
"        {return __table_.__insert_multi(__p.__i_, __x);}\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(_InputIterator __first, _InputIterator __last);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(initializer_list<value_type> __il)\x0a"
"        {insert(__il.begin(), __il.end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(value_type\x26\x26 __x) {return __table_.__insert_multi(_VSTD\x3a\x3amove(__x));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, value_type\x26\x26 __x)\x0a"
"        {return __table_.__insert_multi(__p.__i_, _VSTD\x3a\x3amove(__x));}\x0a"
"\x0a"
"    template <class _Pp,\x0a"
"              class = typename enable_if<is_constructible<value_type, _Pp>\x3a\x3avalue>\x3a\x3atype>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(_Pp\x26\x26 __x)\x0a"
"        {return __table_.__insert_multi(_VSTD\x3a\x3a""forward<_Pp>(__x));}\x0a"
"\x0a"
"    template <class _Pp,\x0a"
"              class = typename enable_if<is_constructible<value_type, _Pp>\x3a\x3avalue>\x3a\x3atype>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, _Pp\x26\x26 __x)\x0a"
"        {return __table_.__insert_multi(__p.__i_, _VSTD\x3a\x3a""forward<_Pp>(__x));}\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    iterator emplace(_Args\x26\x26... __args) {\x0a"
"        return __table_.__emplace_multi(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    iterator emplace_hint(const_iterator __p, _Args\x26\x26... __args) {\x0a"
"        return __table_.__emplace_hint_multi(__p.__i_, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    }\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(const_iterator __p) {return __table_.erase(__p.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(iterator __p)       {return __table_.erase(__p.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k) {return __table_.__erase_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(const_iterator __first, const_iterator __last)\x0a"
"        {return __table_.erase(__first.__i_, __last.__i_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {__table_.clear();}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to unordered_multimap\x3a\x3ainsert()\x22);\x0a"
"        return __table_.template __node_handle_insert_multi<node_type>(\x0a"
"            _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __hint, node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to unordered_multimap\x3a\x3ainsert()\x22);\x0a"
"        return __table_.template __node_handle_insert_multi<node_type>(\x0a"
"            __hint.__i_, _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(key_type const\x26 __key)\x0a"
"    {\x0a"
"        return __table_.template __node_handle_extract<node_type>(__key);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(const_iterator __it)\x0a"
"    {\x0a"
"        return __table_.template __node_handle_extract<node_type>(\x0a"
"            __it.__i_);\x0a"
"    }\x0a"
"\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_multimap<key_type, mapped_type, _H2, _P2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_multi(__source.__table_);\x0a"
"    }\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_multimap<key_type, mapped_type, _H2, _P2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_multi(__source.__table_);\x0a"
"    }\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_map<key_type, mapped_type, _H2, _P2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_multi(__source.__table_);\x0a"
"    }\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_map<key_type, mapped_type, _H2, _P2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_multi(__source.__table_);\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(unordered_multimap\x26 __u)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<__table>\x3a\x3avalue)\x0a"
"        {__table_.swap(__u.__table_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hasher hash_function() const\x0a"
"        {return __table_.hash_function().hash_function();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_equal key_eq() const\x0a"
"        {return __table_.key_eq().key_eq();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       find(const key_type\x26 __k)       {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type count(const key_type\x26 __k) const {return __table_.__count_multi(__k);}\x0a"
"    #if _LIBCPP_STD_VER > 17\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool contains(const key_type\x26 __k) const {return find(__k) \x21= end();}\x0a"
"    #endif // _LIBCPP_STD_VER > 17\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 __k)\x0a"
"        {return __table_.__equal_range_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"        {return __table_.__equal_range_multi(__k);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_count() const _NOEXCEPT {return __table_.bucket_count();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_bucket_count() const _NOEXCEPT\x0a"
"        {return __table_.max_bucket_count();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_size(size_type __n) const\x0a"
"        {return __table_.bucket_size(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket(const key_type\x26 __k) const {return __table_.bucket(__k);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    local_iterator       begin(size_type __n)        {return __table_.begin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    local_iterator       end(size_type __n)          {return __table_.end(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator begin(size_type __n) const  {return __table_.cbegin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator end(size_type __n) const    {return __table_.cend(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator cbegin(size_type __n) const {return __table_.cbegin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator cend(size_type __n) const   {return __table_.cend(__n);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    float load_factor() const _NOEXCEPT {return __table_.load_factor();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    float max_load_factor() const _NOEXCEPT {return __table_.max_load_factor();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void max_load_factor(float __mlf) {__table_.max_load_factor(__mlf);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void rehash(size_type __n) {__table_.rehash(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reserve(size_type __n) {__table_.reserve(__n);}\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"    bool __dereferenceable(const const_iterator* __i) const\x0a"
"        {return __table_.__dereferenceable(\x26__i->__i_);}\x0a"
"    bool __decrementable(const const_iterator* __i) const\x0a"
"        {return __table_.__decrementable(\x26__i->__i_);}\x0a"
"    bool __addable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"        {return __table_.__addable(\x26__i->__i_, __n);}\x0a"
"    bool __subscriptable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"        {return __table_.__addable(\x26__i->__i_, __n);}\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _Hash = hash<__iter_key_type<_InputIterator>>,\x0a"
"         class _Pred = equal_to<__iter_key_type<_InputIterator>>,\x0a"
"         class _Allocator = allocator<__iter_to_alloc_type<_InputIterator>>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Pred>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multimap(_InputIterator, _InputIterator, typename allocator_traits<_Allocator>\x3a\x3asize_type = 0,\x0a"
"                   _Hash = _Hash(), _Pred = _Pred(), _Allocator = _Allocator())\x0a"
"  -> unordered_multimap<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>, _Hash, _Pred, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Hash = hash<remove_const_t<_Key>>,\x0a"
"         class _Pred = equal_to<remove_const_t<_Key>>,\x0a"
"         class _Allocator = allocator<pair<const _Key, _Tp>>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Pred>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multimap(initializer_list<pair<_Key, _Tp>>, typename allocator_traits<_Allocator>\x3a\x3asize_type = 0,\x0a"
"                   _Hash = _Hash(), _Pred = _Pred(), _Allocator = _Allocator())\x0a"
"  -> unordered_multimap<remove_const_t<_Key>, _Tp, _Hash, _Pred, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multimap(_InputIterator, _InputIterator, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Allocator)\x0a"
"  -> unordered_multimap<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>,\x0a"
"                        hash<__iter_key_type<_InputIterator>>, equal_to<__iter_key_type<_InputIterator>>, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multimap(_InputIterator, _InputIterator, _Allocator)\x0a"
"  -> unordered_multimap<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>,\x0a"
"                        hash<__iter_key_type<_InputIterator>>, equal_to<__iter_key_type<_InputIterator>>, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Hash, class _Allocator,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multimap(_InputIterator, _InputIterator, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Hash, _Allocator)\x0a"
"  -> unordered_multimap<__iter_key_type<_InputIterator>, __iter_mapped_type<_InputIterator>,\x0a"
"                        _Hash, equal_to<__iter_key_type<_InputIterator>>, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multimap(initializer_list<pair<_Key, _Tp>>, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Allocator)\x0a"
"  -> unordered_multimap<remove_const_t<_Key>, _Tp,\x0a"
"                        hash<remove_const_t<_Key>>,\x0a"
"                        equal_to<remove_const_t<_Key>>, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multimap(initializer_list<pair<_Key, _Tp>>, _Allocator)\x0a"
"  -> unordered_multimap<remove_const_t<_Key>, _Tp,\x0a"
"                        hash<remove_const_t<_Key>>,\x0a"
"                        equal_to<remove_const_t<_Key>>, _Allocator>;\x0a"
"\x0a"
"template<class _Key, class _Tp, class _Hash, class _Allocator,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multimap(initializer_list<pair<_Key, _Tp>>, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Hash, _Allocator)\x0a"
"  -> unordered_multimap<remove_const_t<_Key>, _Tp, _Hash,\x0a"
"                        equal_to<remove_const_t<_Key>>, _Allocator>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __table_(typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        const unordered_multimap\x26 __u)\x0a"
"    \x3a __table_(__u.__table_)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        const unordered_multimap\x26 __u, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__u.__table_, typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        unordered_multimap\x26\x26 __u)\x0a"
"    _NOEXCEPT_(is_nothrow_move_constructible<__table>\x3a\x3avalue)\x0a"
"    \x3a __table_(_VSTD\x3a\x3amove(__u.__table_))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"    __get_db()->swap(this, \x26__u);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        unordered_multimap\x26\x26 __u, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(_VSTD\x3a\x3amove(__u.__table_), typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__a \x21= __u.get_allocator())\x0a"
"    {\x0a"
"        iterator __i = __u.begin();\x0a"
"        while (__u.size() \x21= 0)\x0a"
"        {\x0a"
"            __table_.__insert_multi(\x0a"
"                __u.__table_.remove((__i++).__i_)->__value_.__move());\x0a"
"        }\x0a"
"    }\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    else\x0a"
"        __get_db()->swap(this, \x26__u);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        initializer_list<value_type> __il)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf,\x0a"
"        const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multimap(\x0a"
"        initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf,\x0a"
"        const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, typename __table\x3a\x3a""allocator_type(__a))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aoperator=(unordered_multimap\x26\x26 __u)\x0a"
"    _NOEXCEPT_(is_nothrow_move_assignable<__table>\x3a\x3avalue)\x0a"
"{\x0a"
"    __table_ = _VSTD\x3a\x3amove(__u.__table_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3aoperator=(\x0a"
"        initializer_list<value_type> __il)\x0a"
"{\x0a"
"    __table_.__assign_multi(__il.begin(), __il.end());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"inline\x0a"
"void\x0a"
"unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3ainsert(_InputIterator __first,\x0a"
"                                                            _InputIterator __last)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __table_.__insert_multi(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"     unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __c, _Predicate __pred)\x0a"
"{ __libcpp_erase_if_container(__c, __pred); }\x0a"
"#endif\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"bool\x0a"
"operator==(const unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    if (__x.size() \x21= __y.size())\x0a"
"        return false;\x0a"
"    typedef typename unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x3a\x3a""const_iterator\x0a"
"                                                                 const_iterator;\x0a"
"    typedef pair<const_iterator, const_iterator> _EqRng;\x0a"
"    for (const_iterator __i = __x.begin(), __ex = __x.end(); __i \x21= __ex;)\x0a"
"    {\x0a"
"        _EqRng __xeq = __x.equal_range(__i->first);\x0a"
"        _EqRng __yeq = __y.equal_range(__i->first);\x0a"
"        if (_VSTD\x3a\x3a""distance(__xeq.first, __xeq.second) \x21=\x0a"
"            _VSTD\x3a\x3a""distance(__yeq.first, __yeq.second) \x7c\x7c\x0a"
"                  \x21_VSTD\x3a\x3ais_permutation(__xeq.first, __xeq.second, __yeq.first))\x0a"
"            return false;\x0a"
"        __i = __xeq.second;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_UNORDERED_MAP\x0a"
"", 99180 ); }