#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_unordered_set( 
"// -*- C++ -*-\x0a"
"//===-------------------------- unordered_set -----------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_UNORDERED_SET\x0a"
"#define _LIBCPP_UNORDERED_SET\x0a"
"\x0a"
"/*\x0a"
"\x0a"
"    unordered_set synopsis\x0a"
"\x0a"
"#include <initializer_list>\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class Value, class Hash = hash<Value>, class Pred = equal_to<Value>,\x0a"
"          class Alloc = allocator<Value>>\x0a"
"class unordered_set\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef Value                                                      key_type;\x0a"
"    typedef key_type                                                   value_type;\x0a"
"    typedef Hash                                                       hasher;\x0a"
"    typedef Pred                                                       key_equal;\x0a"
"    typedef Alloc                                                      allocator_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef /unspecified/ iterator;\x0a"
"    typedef /unspecified/ const_iterator;\x0a"
"    typedef /unspecified/ local_iterator;\x0a"
"    typedef /unspecified/ const_local_iterator;\x0a"
"\x0a"
"    typedef unspecified node_type unspecified;                            // C++17\x0a"
"    typedef INSERT_RETURN_TYPE<iterator, node_type> insert_return_type;   // C++17\x0a"
"\x0a"
"    unordered_set()\x0a"
"        noexcept(\x0a"
"            is_nothrow_default_constructible<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_equal>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    explicit unordered_set(size_type n, const hasher\x26 hf = hasher(),\x0a"
"                           const key_equal\x26 eql = key_equal(),\x0a"
"                           const allocator_type\x26 a = allocator_type());\x0a"
"    template <class InputIterator>\x0a"
"        unordered_set(InputIterator f, InputIterator l,\x0a"
"                      size_type n = 0, const hasher\x26 hf = hasher(),\x0a"
"                      const key_equal\x26 eql = key_equal(),\x0a"
"                      const allocator_type\x26 a = allocator_type());\x0a"
"    explicit unordered_set(const allocator_type\x26);\x0a"
"    unordered_set(const unordered_set\x26);\x0a"
"    unordered_set(const unordered_set\x26, const Allocator\x26);\x0a"
"    unordered_set(unordered_set\x26\x26)\x0a"
"        noexcept(\x0a"
"            is_nothrow_move_constructible<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<key_equal>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    unordered_set(unordered_set\x26\x26, const Allocator\x26);\x0a"
"    unordered_set(initializer_list<value_type>, size_type n = 0,\x0a"
"                  const hasher\x26 hf = hasher(), const key_equal\x26 eql = key_equal(),\x0a"
"                  const allocator_type\x26 a = allocator_type());\x0a"
"    unordered_set(size_type n, const allocator_type\x26 a); // C++14\x0a"
"    unordered_set(size_type n, const hasher\x26 hf, const allocator_type\x26 a); // C++14\x0a"
"    template <class InputIterator>\x0a"
"      unordered_set(InputIterator f, InputIterator l, size_type n, const allocator_type\x26 a); // C++14\x0a"
"    template <class InputIterator>\x0a"
"      unordered_set(InputIterator f, InputIterator l, size_type n,\x0a"
"                    const hasher\x26 hf,  const allocator_type\x26 a); // C++14\x0a"
"    unordered_set(initializer_list<value_type> il, size_type n, const allocator_type\x26 a); // C++14\x0a"
"    unordered_set(initializer_list<value_type> il, size_type n,\x0a"
"                  const hasher\x26 hf,  const allocator_type\x26 a); // C++14\x0a"
"    \x7eunordered_set();\x0a"
"    unordered_set\x26 operator=(const unordered_set\x26);\x0a"
"    unordered_set\x26 operator=(unordered_set\x26\x26)\x0a"
"        noexcept(\x0a"
"            allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<key_equal>\x3a\x3avalue);\x0a"
"    unordered_set\x26 operator=(initializer_list<value_type>);\x0a"
"\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"\x0a"
"    bool      empty() const noexcept;\x0a"
"    size_type size() const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"\x0a"
"    iterator       begin() noexcept;\x0a"
"    iterator       end() noexcept;\x0a"
"    const_iterator begin()  const noexcept;\x0a"
"    const_iterator end()    const noexcept;\x0a"
"    const_iterator cbegin() const noexcept;\x0a"
"    const_iterator cend()   const noexcept;\x0a"
"\x0a"
"    template <class... Args>\x0a"
"        pair<iterator, bool> emplace(Args\x26\x26... args);\x0a"
"    template <class... Args>\x0a"
"        iterator emplace_hint(const_iterator position, Args\x26\x26... args);\x0a"
"    pair<iterator, bool> insert(const value_type\x26 obj);\x0a"
"    pair<iterator, bool> insert(value_type\x26\x26 obj);\x0a"
"    iterator insert(const_iterator hint, const value_type\x26 obj);\x0a"
"    iterator insert(const_iterator hint, value_type\x26\x26 obj);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"    void insert(initializer_list<value_type>);\x0a"
"\x0a"
"    node_type extract(const_iterator position);                       // C++17\x0a"
"    node_type extract(const key_type\x26 x);                             // C++17\x0a"
"    insert_return_type insert(node_type\x26\x26 nh);                        // C++17\x0a"
"    iterator           insert(const_iterator hint, node_type\x26\x26 nh);   // C++17\x0a"
"\x0a"
"    iterator erase(const_iterator position);\x0a"
"    iterator erase(iterator position);  // C++14\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    iterator erase(const_iterator first, const_iterator last);\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_set<Key, H2, P2, Allocator>\x26 source);         // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_set<Key, H2, P2, Allocator>\x26\x26 source);        // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_multiset<Key, H2, P2, Allocator>\x26 source);    // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_multiset<Key, H2, P2, Allocator>\x26\x26 source);   // C++17\x0a"
"\x0a"
"    void swap(unordered_set\x26)\x0a"
"       noexcept(allocator_traits<Allocator>\x3a\x3ais_always_equal\x3a\x3avalue \x26\x26\x0a"
"                 noexcept(swap(declval<hasher\x26>(), declval<hasher\x26>())) \x26\x26\x0a"
"                 noexcept(swap(declval<key_equal\x26>(), declval<key_equal\x26>()))); // C++17\x0a"
"\x0a"
"    hasher hash_function() const;\x0a"
"    key_equal key_eq() const;\x0a"
"\x0a"
"    iterator       find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    size_type count(const key_type\x26 k) const;\x0a"
"    bool contains(const key_type\x26 k) const; // C++20\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"\x0a"
"    size_type bucket_count() const noexcept;\x0a"
"    size_type max_bucket_count() const noexcept;\x0a"
"\x0a"
"    size_type bucket_size(size_type n) const;\x0a"
"    size_type bucket(const key_type\x26 k) const;\x0a"
"\x0a"
"    local_iterator       begin(size_type n);\x0a"
"    local_iterator       end(size_type n);\x0a"
"    const_local_iterator begin(size_type n) const;\x0a"
"    const_local_iterator end(size_type n) const;\x0a"
"    const_local_iterator cbegin(size_type n) const;\x0a"
"    const_local_iterator cend(size_type n) const;\x0a"
"\x0a"
"    float load_factor() const noexcept;\x0a"
"    float max_load_factor() const noexcept;\x0a"
"    void max_load_factor(float z);\x0a"
"    void rehash(size_type n);\x0a"
"    void reserve(size_type n);\x0a"
"};\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    void swap(unordered_set<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"              unordered_set<Value, Hash, Pred, Alloc>\x26 y)\x0a"
"              noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator==(const unordered_set<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"               const unordered_set<Value, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator\x21=(const unordered_set<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"               const unordered_set<Value, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Value, class Hash = hash<Value>, class Pred = equal_to<Value>,\x0a"
"          class Alloc = allocator<Value>>\x0a"
"class unordered_multiset\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef Value                                                      key_type;\x0a"
"    typedef key_type                                                   value_type;\x0a"
"    typedef Hash                                                       hasher;\x0a"
"    typedef Pred                                                       key_equal;\x0a"
"    typedef Alloc                                                      allocator_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef /unspecified/ iterator;\x0a"
"    typedef /unspecified/ const_iterator;\x0a"
"    typedef /unspecified/ local_iterator;\x0a"
"    typedef /unspecified/ const_local_iterator;\x0a"
"\x0a"
"    typedef unspecified node_type unspecified;   // C++17\x0a"
"\x0a"
"    unordered_multiset()\x0a"
"        noexcept(\x0a"
"            is_nothrow_default_constructible<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<key_equal>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    explicit unordered_multiset(size_type n, const hasher\x26 hf = hasher(),\x0a"
"                           const key_equal\x26 eql = key_equal(),\x0a"
"                           const allocator_type\x26 a = allocator_type());\x0a"
"    template <class InputIterator>\x0a"
"        unordered_multiset(InputIterator f, InputIterator l,\x0a"
"                      size_type n = 0, const hasher\x26 hf = hasher(),\x0a"
"                      const key_equal\x26 eql = key_equal(),\x0a"
"                      const allocator_type\x26 a = allocator_type());\x0a"
"    explicit unordered_multiset(const allocator_type\x26);\x0a"
"    unordered_multiset(const unordered_multiset\x26);\x0a"
"    unordered_multiset(const unordered_multiset\x26, const Allocator\x26);\x0a"
"    unordered_multiset(unordered_multiset\x26\x26)\x0a"
"        noexcept(\x0a"
"            is_nothrow_move_constructible<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<key_equal>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    unordered_multiset(unordered_multiset\x26\x26, const Allocator\x26);\x0a"
"    unordered_multiset(initializer_list<value_type>, size_type n = /see below/,\x0a"
"                  const hasher\x26 hf = hasher(), const key_equal\x26 eql = key_equal(),\x0a"
"                  const allocator_type\x26 a = allocator_type());\x0a"
"    unordered_multiset(size_type n, const allocator_type\x26 a); // C++14\x0a"
"    unordered_multiset(size_type n, const hasher\x26 hf, const allocator_type\x26 a); // C++14\x0a"
"    template <class InputIterator>\x0a"
"      unordered_multiset(InputIterator f, InputIterator l, size_type n, const allocator_type\x26 a); // C++14\x0a"
"    template <class InputIterator>\x0a"
"      unordered_multiset(InputIterator f, InputIterator l, size_type n,\x0a"
"                         const hasher\x26 hf, const allocator_type\x26 a); // C++14\x0a"
"    unordered_multiset(initializer_list<value_type> il, size_type n, const allocator_type\x26 a); // C++14\x0a"
"    unordered_multiset(initializer_list<value_type> il, size_type n,\x0a"
"                       const hasher\x26 hf,  const allocator_type\x26 a); // C++14\x0a"
"    \x7eunordered_multiset();\x0a"
"    unordered_multiset\x26 operator=(const unordered_multiset\x26);\x0a"
"    unordered_multiset\x26 operator=(unordered_multiset\x26\x26)\x0a"
"        noexcept(\x0a"
"            allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<hasher>\x3a\x3avalue \x26\x26\x0a"
"            is_nothrow_move_assignable<key_equal>\x3a\x3avalue);\x0a"
"    unordered_multiset\x26 operator=(initializer_list<value_type>);\x0a"
"\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"\x0a"
"    bool      empty() const noexcept;\x0a"
"    size_type size() const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"\x0a"
"    iterator       begin() noexcept;\x0a"
"    iterator       end() noexcept;\x0a"
"    const_iterator begin()  const noexcept;\x0a"
"    const_iterator end()    const noexcept;\x0a"
"    const_iterator cbegin() const noexcept;\x0a"
"    const_iterator cend()   const noexcept;\x0a"
"\x0a"
"    template <class... Args>\x0a"
"        iterator emplace(Args\x26\x26... args);\x0a"
"    template <class... Args>\x0a"
"        iterator emplace_hint(const_iterator position, Args\x26\x26... args);\x0a"
"    iterator insert(const value_type\x26 obj);\x0a"
"    iterator insert(value_type\x26\x26 obj);\x0a"
"    iterator insert(const_iterator hint, const value_type\x26 obj);\x0a"
"    iterator insert(const_iterator hint, value_type\x26\x26 obj);\x0a"
"    template <class InputIterator>\x0a"
"        void insert(InputIterator first, InputIterator last);\x0a"
"    void insert(initializer_list<value_type>);\x0a"
"\x0a"
"    node_type extract(const_iterator position);             // C++17\x0a"
"    node_type extract(const key_type\x26 x);                   // C++17\x0a"
"    iterator insert(node_type\x26\x26 nh);                        // C++17\x0a"
"    iterator insert(const_iterator hint, node_type\x26\x26 nh);   // C++17\x0a"
"\x0a"
"    iterator erase(const_iterator position);\x0a"
"    iterator erase(iterator position);  // C++14\x0a"
"    size_type erase(const key_type\x26 k);\x0a"
"    iterator erase(const_iterator first, const_iterator last);\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_multiset<Key, H2, P2, Allocator>\x26 source);    // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_multiset<Key, H2, P2, Allocator>\x26\x26 source);   // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_set<Key, H2, P2, Allocator>\x26 source);         // C++17\x0a"
"    template<class H2, class P2>\x0a"
"      void merge(unordered_set<Key, H2, P2, Allocator>\x26\x26 source);        // C++17\x0a"
"\x0a"
"    void swap(unordered_multiset\x26)\x0a"
"       noexcept(allocator_traits<Allocator>\x3a\x3ais_always_equal\x3a\x3avalue \x26\x26\x0a"
"                 noexcept(swap(declval<hasher\x26>(), declval<hasher\x26>())) \x26\x26\x0a"
"                 noexcept(swap(declval<key_equal\x26>(), declval<key_equal\x26>()))); // C++17\x0a"
"\x0a"
"    hasher hash_function() const;\x0a"
"    key_equal key_eq() const;\x0a"
"\x0a"
"    iterator       find(const key_type\x26 k);\x0a"
"    const_iterator find(const key_type\x26 k) const;\x0a"
"    size_type count(const key_type\x26 k) const;\x0a"
"    bool contains(const key_type\x26 k) const; // C++20\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 k);\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 k) const;\x0a"
"\x0a"
"    size_type bucket_count() const noexcept;\x0a"
"    size_type max_bucket_count() const noexcept;\x0a"
"\x0a"
"    size_type bucket_size(size_type n) const;\x0a"
"    size_type bucket(const key_type\x26 k) const;\x0a"
"\x0a"
"    local_iterator       begin(size_type n);\x0a"
"    local_iterator       end(size_type n);\x0a"
"    const_local_iterator begin(size_type n) const;\x0a"
"    const_local_iterator end(size_type n) const;\x0a"
"    const_local_iterator cbegin(size_type n) const;\x0a"
"    const_local_iterator cend(size_type n) const;\x0a"
"\x0a"
"    float load_factor() const noexcept;\x0a"
"    float max_load_factor() const noexcept;\x0a"
"    void max_load_factor(float z);\x0a"
"    void rehash(size_type n);\x0a"
"    void reserve(size_type n);\x0a"
"};\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    void swap(unordered_multiset<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"              unordered_multiset<Value, Hash, Pred, Alloc>\x26 y)\x0a"
"              noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class K, class T, class H, class P, class A, class Predicate>\x0a"
"    void erase_if(unordered_set<K, T, H, P, A>\x26 c, Predicate pred);       // C++20\x0a"
"\x0a"
"template <class K, class T, class H, class P, class A, class Predicate>\x0a"
"    void erase_if(unordered_multiset<K, T, H, P, A>\x26 c, Predicate pred);  // C++20\x0a"
"\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator==(const unordered_multiset<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"               const unordered_multiset<Value, Hash, Pred, Alloc>\x26 y);\x0a"
"\x0a"
"template <class Value, class Hash, class Pred, class Alloc>\x0a"
"    bool\x0a"
"    operator\x21=(const unordered_multiset<Value, Hash, Pred, Alloc>\x26 x,\x0a"
"               const unordered_multiset<Value, Hash, Pred, Alloc>\x26 y);\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__hash_table>\x0a"
"#include <__node_handle>\x0a"
"#include <functional>\x0a"
"#include <version>\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"class unordered_multiset;\x0a"
"\x0a"
"template <class _Value, class _Hash = hash<_Value>, class _Pred = equal_to<_Value>,\x0a"
"          class _Alloc = allocator<_Value> >\x0a"
"class _LIBCPP_TEMPLATE_VIS unordered_set\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _Value                                                     key_type;\x0a"
"    typedef key_type                                                   value_type;\x0a"
"    typedef typename __identity<_Hash>\x3a\x3atype                           hasher;\x0a"
"    typedef typename __identity<_Pred>\x3a\x3atype                           key_equal;\x0a"
"    typedef typename __identity<_Alloc>\x3a\x3atype                          allocator_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    static_assert((is_same<value_type, typename allocator_type\x3a\x3avalue_type>\x3a\x3avalue),\x0a"
"                  \x22Invalid allocator\x3a\x3avalue_type\x22);\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef __hash_table<value_type, hasher, key_equal, allocator_type> __table;\x0a"
"\x0a"
"    __table __table_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __table\x3a\x3apointer         pointer;\x0a"
"    typedef typename __table\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename __table\x3a\x3asize_type       size_type;\x0a"
"    typedef typename __table\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef typename __table\x3a\x3a""const_iterator       iterator;\x0a"
"    typedef typename __table\x3a\x3a""const_iterator       const_iterator;\x0a"
"    typedef typename __table\x3a\x3a""const_local_iterator local_iterator;\x0a"
"    typedef typename __table\x3a\x3a""const_local_iterator const_local_iterator;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    typedef __set_node_handle<typename __table\x3a\x3a__node, allocator_type> node_type;\x0a"
"    typedef __insert_return_type<iterator, node_type> insert_return_type;\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Value2, class _Hash2, class _Pred2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS unordered_set;\x0a"
"    template <class _Value2, class _Hash2, class _Pred2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS unordered_multiset;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_set()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<__table>\x3a\x3avalue)\x0a"
"        {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"            __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"        }\x0a"
"    explicit unordered_set(size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                           const key_equal\x26 __eql = key_equal());\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_set(size_type __n, const allocator_type\x26 __a)\x0a"
"        \x3a unordered_set(__n, hasher(), key_equal(), __a) {}\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_set(size_type __n, const hasher\x26 __hf, const allocator_type\x26 __a)\x0a"
"        \x3a unordered_set(__n, __hf, key_equal(), __a) {}\x0a"
"#endif\x0a"
"    unordered_set(size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"                  const allocator_type\x26 __a);\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_set(_InputIterator __first, _InputIterator __last);\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_set(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                      const key_equal\x26 __eql = key_equal());\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_set(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"                      const allocator_type\x26 __a);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <class _InputIterator>\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"        unordered_set(_InputIterator __first, _InputIterator __last,\x0a"
"                    size_type __n, const allocator_type\x26 __a)\x0a"
"            \x3a unordered_set(__first, __last, __n, hasher(), key_equal(), __a) {}\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_set(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf, const allocator_type\x26 __a)\x0a"
"            \x3a unordered_set(__first, __last, __n, __hf, key_equal(), __a) {}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit unordered_set(const allocator_type\x26 __a);\x0a"
"    unordered_set(const unordered_set\x26 __u);\x0a"
"    unordered_set(const unordered_set\x26 __u, const allocator_type\x26 __a);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_set(unordered_set\x26\x26 __u)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__table>\x3a\x3avalue);\x0a"
"    unordered_set(unordered_set\x26\x26 __u, const allocator_type\x26 __a);\x0a"
"    unordered_set(initializer_list<value_type> __il);\x0a"
"    unordered_set(initializer_list<value_type> __il, size_type __n,\x0a"
"                  const hasher\x26 __hf = hasher(),\x0a"
"                  const key_equal\x26 __eql = key_equal());\x0a"
"    unordered_set(initializer_list<value_type> __il, size_type __n,\x0a"
"                  const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"                  const allocator_type\x26 __a);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_set(initializer_list<value_type> __il, size_type __n,\x0a"
"                                                      const allocator_type\x26 __a)\x0a"
"        \x3a unordered_set(__il, __n, hasher(), key_equal(), __a) {}\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_set(initializer_list<value_type> __il, size_type __n,\x0a"
"                                  const hasher\x26 __hf, const allocator_type\x26 __a)\x0a"
"        \x3a unordered_set(__il, __n, __hf, key_equal(), __a) {}\x0a"
"#endif\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7eunordered_set() {\x0a"
"        static_assert(sizeof(__diagnose_unordered_container_requirements<_Value, _Hash, _Pred>(0)), \x22\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_set\x26 operator=(const unordered_set\x26 __u)\x0a"
"    {\x0a"
"        __table_ = __u.__table_;\x0a"
"        return *this;\x0a"
"    }\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_set\x26 operator=(unordered_set\x26\x26 __u)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__table>\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_set\x26 operator=(initializer_list<value_type> __il);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT\x0a"
"        {return allocator_type(__table_.__node_alloc());}\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool      empty() const _NOEXCEPT {return __table_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT  {return __table_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT {return __table_.max_size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       begin() _NOEXCEPT        {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       end() _NOEXCEPT          {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin()  const _NOEXCEPT {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()    const _NOEXCEPT {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const _NOEXCEPT {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend()   const _NOEXCEPT {return __table_.end();}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair<iterator, bool> emplace(_Args\x26\x26... __args)\x0a"
"            {return __table_.__emplace_unique(_VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        iterator emplace_hint(const_iterator __p, _Args\x26\x26... __args)\x0a"
"        {\x0a"
"            _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"                \x22unordered_set\x3a\x3a""emplace_hint(const_iterator, args...) called with an iterator not\x22\x0a"
"                \x22 referring to this unordered_set\x22);\x0a"
"            return __table_.__emplace_unique(_VSTD\x3a\x3a""forward<_Args>(__args)...).first;\x0a"
"        }\x0a"
"#else\x0a"
"        iterator emplace_hint(const_iterator, _Args\x26\x26... __args)\x0a"
"            {return __table_.__emplace_unique(_VSTD\x3a\x3a""forward<_Args>(__args)...).first;}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> insert(value_type\x26\x26 __x)\x0a"
"        {return __table_.__insert_unique(_VSTD\x3a\x3amove(__x));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    iterator insert(const_iterator __p, value_type\x26\x26 __x)\x0a"
"        {\x0a"
"            _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"                \x22unordered_set\x3a\x3ainsert(const_iterator, value_type\x26\x26) called with an iterator not\x22\x0a"
"                \x22 referring to this unordered_set\x22);\x0a"
"            return insert(_VSTD\x3a\x3amove(__x)).first;\x0a"
"        }\x0a"
"#else\x0a"
"    iterator insert(const_iterator, value_type\x26\x26 __x)\x0a"
"        {return insert(_VSTD\x3a\x3amove(__x)).first;}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(initializer_list<value_type> __il)\x0a"
"        {insert(__il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, bool> insert(const value_type\x26 __x)\x0a"
"        {return __table_.__insert_unique(__x);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    iterator insert(const_iterator __p, const value_type\x26 __x)\x0a"
"        {\x0a"
"            _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__p) == this,\x0a"
"                \x22unordered_set\x3a\x3ainsert(const_iterator, const value_type\x26) called with an iterator not\x22\x0a"
"                \x22 referring to this unordered_set\x22);\x0a"
"            return insert(__x).first;\x0a"
"        }\x0a"
"#else\x0a"
"    iterator insert(const_iterator, const value_type\x26 __x)\x0a"
"        {return insert(__x).first;}\x0a"
"#endif\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __first, _InputIterator __last);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(const_iterator __p) {return __table_.erase(__p);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k) {return __table_.__erase_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(const_iterator __first, const_iterator __last)\x0a"
"        {return __table_.erase(__first, __last);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {__table_.clear();}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    insert_return_type insert(node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to unordered_set\x3a\x3ainsert()\x22);\x0a"
"        return __table_.template __node_handle_insert_unique<\x0a"
"            node_type, insert_return_type>(_VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __h, node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to unordered_set\x3a\x3ainsert()\x22);\x0a"
"        return __table_.template __node_handle_insert_unique<node_type>(\x0a"
"            __h, _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(key_type const\x26 __key)\x0a"
"    {\x0a"
"        return __table_.template __node_handle_extract<node_type>(__key);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(const_iterator __it)\x0a"
"    {\x0a"
"        return __table_.template __node_handle_extract<node_type>(__it);\x0a"
"    }\x0a"
"\x0a"
"    template<class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_set<key_type, _H2, _P2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __table_.__node_handle_merge_unique(__source.__table_);\x0a"
"    }\x0a"
"    template<class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_set<key_type, _H2, _P2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __table_.__node_handle_merge_unique(__source.__table_);\x0a"
"    }\x0a"
"    template<class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_multiset<key_type, _H2, _P2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __table_.__node_handle_merge_unique(__source.__table_);\x0a"
"    }\x0a"
"    template<class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_multiset<key_type, _H2, _P2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        __table_.__node_handle_merge_unique(__source.__table_);\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(unordered_set\x26 __u)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<__table>\x3a\x3avalue)\x0a"
"        {__table_.swap(__u.__table_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hasher hash_function() const {return __table_.hash_function();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_equal key_eq() const {return __table_.key_eq();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       find(const key_type\x26 __k)       {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type count(const key_type\x26 __k) const {return __table_.__count_unique(__k);}\x0a"
"    #if _LIBCPP_STD_VER > 17\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool contains(const key_type\x26 __k) const {return find(__k) \x21= end();}\x0a"
"    #endif // _LIBCPP_STD_VER > 17\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 __k)\x0a"
"        {return __table_.__equal_range_unique(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"        {return __table_.__equal_range_unique(__k);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_count() const _NOEXCEPT {return __table_.bucket_count();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_bucket_count() const _NOEXCEPT {return __table_.max_bucket_count();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_size(size_type __n) const {return __table_.bucket_size(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket(const key_type\x26 __k) const {return __table_.bucket(__k);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    local_iterator       begin(size_type __n)        {return __table_.begin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    local_iterator       end(size_type __n)          {return __table_.end(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator begin(size_type __n) const  {return __table_.cbegin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator end(size_type __n) const    {return __table_.cend(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator cbegin(size_type __n) const {return __table_.cbegin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator cend(size_type __n) const   {return __table_.cend(__n);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    float load_factor() const _NOEXCEPT {return __table_.load_factor();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    float max_load_factor() const _NOEXCEPT {return __table_.max_load_factor();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void max_load_factor(float __mlf) {__table_.max_load_factor(__mlf);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void rehash(size_type __n) {__table_.rehash(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reserve(size_type __n) {__table_.reserve(__n);}\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"    bool __dereferenceable(const const_iterator* __i) const\x0a"
"        {return __table_.__dereferenceable(__i);}\x0a"
"    bool __decrementable(const const_iterator* __i) const\x0a"
"        {return __table_.__decrementable(__i);}\x0a"
"    bool __addable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"        {return __table_.__addable(__i, __n);}\x0a"
"    bool __subscriptable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"        {return __table_.__addable(__i, __n);}\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _Hash = hash<__iter_value_type<_InputIterator>>,\x0a"
"         class _Pred = equal_to<__iter_value_type<_InputIterator>>,\x0a"
"         class _Allocator = allocator<__iter_value_type<_InputIterator>>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Pred>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_set(_InputIterator, _InputIterator, typename allocator_traits<_Allocator>\x3a\x3asize_type = 0,\x0a"
"              _Hash = _Hash(), _Pred = _Pred(), _Allocator = _Allocator())\x0a"
"  -> unordered_set<__iter_value_type<_InputIterator>, _Hash, _Pred, _Allocator>;\x0a"
"\x0a"
"template<class _Tp, class _Hash = hash<_Tp>,\x0a"
"         class _Pred = equal_to<_Tp>,\x0a"
"         class _Allocator = allocator<_Tp>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Pred>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_set(initializer_list<_Tp>, typename allocator_traits<_Allocator>\x3a\x3asize_type = 0,\x0a"
"              _Hash = _Hash(), _Pred = _Pred(), _Allocator = _Allocator())\x0a"
"  -> unordered_set<_Tp, _Hash, _Pred, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_set(_InputIterator, _InputIterator,\x0a"
"              typename allocator_traits<_Allocator>\x3a\x3asize_type, _Allocator)\x0a"
"  -> unordered_set<__iter_value_type<_InputIterator>,\x0a"
"                   hash<__iter_value_type<_InputIterator>>,\x0a"
"                   equal_to<__iter_value_type<_InputIterator>>,\x0a"
"                   _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Hash, class _Allocator,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_set(_InputIterator, _InputIterator,\x0a"
"              typename allocator_traits<_Allocator>\x3a\x3asize_type, _Hash, _Allocator)\x0a"
"  -> unordered_set<__iter_value_type<_InputIterator>, _Hash,\x0a"
"                   equal_to<__iter_value_type<_InputIterator>>,\x0a"
"                   _Allocator>;\x0a"
"\x0a"
"template<class _Tp, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_set(initializer_list<_Tp>, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Allocator)\x0a"
"  -> unordered_set<_Tp, hash<_Tp>, equal_to<_Tp>, _Allocator>;\x0a"
"\x0a"
"template<class _Tp, class _Hash, class _Allocator,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_set(initializer_list<_Tp>, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Hash, _Allocator)\x0a"
"  -> unordered_set<_Tp, _Hash, equal_to<_Tp>, _Allocator>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        const unordered_set\x26 __u)\x0a"
"    \x3a __table_(__u.__table_)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        const unordered_set\x26 __u, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__u.__table_, __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        unordered_set\x26\x26 __u)\x0a"
"    _NOEXCEPT_(is_nothrow_move_constructible<__table>\x3a\x3avalue)\x0a"
"    \x3a __table_(_VSTD\x3a\x3amove(__u.__table_))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"    __get_db()->swap(this, \x26__u);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        unordered_set\x26\x26 __u, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(_VSTD\x3a\x3amove(__u.__table_), __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__a \x21= __u.get_allocator())\x0a"
"    {\x0a"
"        iterator __i = __u.begin();\x0a"
"        while (__u.size() \x21= 0)\x0a"
"            __table_.__insert_unique(_VSTD\x3a\x3amove(__u.__table_.remove(__i++)->__value_));\x0a"
"    }\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    else\x0a"
"        __get_db()->swap(this, \x26__u);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        initializer_list<value_type> __il)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf,\x0a"
"        const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_set(\x0a"
"        initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf,\x0a"
"        const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x26\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aoperator=(unordered_set\x26\x26 __u)\x0a"
"    _NOEXCEPT_(is_nothrow_move_assignable<__table>\x3a\x3avalue)\x0a"
"{\x0a"
"    __table_ = _VSTD\x3a\x3amove(__u.__table_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x26\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3aoperator=(\x0a"
"        initializer_list<value_type> __il)\x0a"
"{\x0a"
"    __table_.__assign_unique(__il.begin(), __il.end());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"inline\x0a"
"void\x0a"
"unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3ainsert(_InputIterator __first,\x0a"
"                                                    _InputIterator __last)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __table_.__insert_unique(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(unordered_set<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"     unordered_set<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(unordered_set<_Value, _Hash, _Pred, _Alloc>\x26 __c, _Predicate __pred)\x0a"
"{ __libcpp_erase_if_container(__c, __pred); }\x0a"
"#endif\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"bool\x0a"
"operator==(const unordered_set<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const unordered_set<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    if (__x.size() \x21= __y.size())\x0a"
"        return false;\x0a"
"    typedef typename unordered_set<_Value, _Hash, _Pred, _Alloc>\x3a\x3a""const_iterator\x0a"
"                                                                 const_iterator;\x0a"
"    for (const_iterator __i = __x.begin(), __ex = __x.end(), __ey = __y.end();\x0a"
"            __i \x21= __ex; ++__i)\x0a"
"    {\x0a"
"        const_iterator __j = __y.find(*__i);\x0a"
"        if (__j == __ey \x7c\x7c \x21(*__i == *__j))\x0a"
"            return false;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const unordered_set<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const unordered_set<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash = hash<_Value>, class _Pred = equal_to<_Value>,\x0a"
"          class _Alloc = allocator<_Value> >\x0a"
"class _LIBCPP_TEMPLATE_VIS unordered_multiset\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _Value                                                     key_type;\x0a"
"    typedef key_type                                                   value_type;\x0a"
"    typedef typename __identity<_Hash>\x3a\x3atype                           hasher;\x0a"
"    typedef typename __identity<_Pred>\x3a\x3atype                           key_equal;\x0a"
"    typedef typename __identity<_Alloc>\x3a\x3atype                          allocator_type;\x0a"
"    typedef value_type\x26                                                reference;\x0a"
"    typedef const value_type\x26                                          const_reference;\x0a"
"    static_assert((is_same<value_type, typename allocator_type\x3a\x3avalue_type>\x3a\x3avalue),\x0a"
"                  \x22Invalid allocator\x3a\x3avalue_type\x22);\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef __hash_table<value_type, hasher, key_equal, allocator_type> __table;\x0a"
"\x0a"
"    __table __table_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef typename __table\x3a\x3apointer         pointer;\x0a"
"    typedef typename __table\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef typename __table\x3a\x3asize_type       size_type;\x0a"
"    typedef typename __table\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef typename __table\x3a\x3a""const_iterator       iterator;\x0a"
"    typedef typename __table\x3a\x3a""const_iterator       const_iterator;\x0a"
"    typedef typename __table\x3a\x3a""const_local_iterator local_iterator;\x0a"
"    typedef typename __table\x3a\x3a""const_local_iterator const_local_iterator;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    typedef __set_node_handle<typename __table\x3a\x3a__node, allocator_type> node_type;\x0a"
"#endif\x0a"
"\x0a"
"    template <class _Value2, class _Hash2, class _Pred2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS unordered_set;\x0a"
"    template <class _Value2, class _Hash2, class _Pred2, class _Alloc2>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS unordered_multiset;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multiset()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<__table>\x3a\x3avalue)\x0a"
"        {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"            __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"        }\x0a"
"    explicit unordered_multiset(size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                                const key_equal\x26 __eql = key_equal());\x0a"
"    unordered_multiset(size_type __n, const hasher\x26 __hf,\x0a"
"                       const key_equal\x26 __eql, const allocator_type\x26 __a);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multiset(size_type __n, const allocator_type\x26 __a)\x0a"
"        \x3a unordered_multiset(__n, hasher(), key_equal(), __a) {}\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multiset(size_type __n, const hasher\x26 __hf, const allocator_type\x26 __a)\x0a"
"        \x3a unordered_multiset(__n, __hf, key_equal(), __a) {}\x0a"
"#endif\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_multiset(_InputIterator __first, _InputIterator __last);\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_multiset(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n, const hasher\x26 __hf = hasher(),\x0a"
"                      const key_equal\x26 __eql = key_equal());\x0a"
"    template <class _InputIterator>\x0a"
"        unordered_multiset(_InputIterator __first, _InputIterator __last,\x0a"
"                      size_type __n , const hasher\x26 __hf,\x0a"
"                      const key_equal\x26 __eql, const allocator_type\x26 __a);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <class _InputIterator>\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multiset(_InputIterator __first, _InputIterator __last,\x0a"
"                       size_type __n, const allocator_type\x26 __a)\x0a"
"        \x3a unordered_multiset(__first, __last, __n, hasher(), key_equal(), __a) {}\x0a"
"    template <class _InputIterator>\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multiset(_InputIterator __first, _InputIterator __last,\x0a"
"                       size_type __n, const hasher\x26 __hf, const allocator_type\x26 __a)\x0a"
"        \x3a unordered_multiset(__first, __last, __n, __hf, key_equal(), __a) {}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit unordered_multiset(const allocator_type\x26 __a);\x0a"
"    unordered_multiset(const unordered_multiset\x26 __u);\x0a"
"    unordered_multiset(const unordered_multiset\x26 __u, const allocator_type\x26 __a);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multiset(unordered_multiset\x26\x26 __u)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<__table>\x3a\x3avalue);\x0a"
"    unordered_multiset(unordered_multiset\x26\x26 __u, const allocator_type\x26 __a);\x0a"
"    unordered_multiset(initializer_list<value_type> __il);\x0a"
"    unordered_multiset(initializer_list<value_type> __il, size_type __n,\x0a"
"                       const hasher\x26 __hf = hasher(),\x0a"
"                       const key_equal\x26 __eql = key_equal());\x0a"
"    unordered_multiset(initializer_list<value_type> __il, size_type __n,\x0a"
"                       const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"                       const allocator_type\x26 __a);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multiset(initializer_list<value_type> __il, size_type __n, const allocator_type\x26 __a)\x0a"
"      \x3a unordered_multiset(__il, __n, hasher(), key_equal(), __a) {}\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multiset(initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf, const allocator_type\x26 __a)\x0a"
"      \x3a unordered_multiset(__il, __n, __hf, key_equal(), __a) {}\x0a"
"#endif\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7eunordered_multiset() {\x0a"
"        static_assert(sizeof(__diagnose_unordered_container_requirements<_Value, _Hash, _Pred>(0)), \x22\x22);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multiset\x26 operator=(const unordered_multiset\x26 __u)\x0a"
"    {\x0a"
"        __table_ = __u.__table_;\x0a"
"        return *this;\x0a"
"    }\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unordered_multiset\x26 operator=(unordered_multiset\x26\x26 __u)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<__table>\x3a\x3avalue);\x0a"
"    unordered_multiset\x26 operator=(initializer_list<value_type> __il);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT\x0a"
"        {return allocator_type(__table_.__node_alloc());}\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool      empty() const _NOEXCEPT {return __table_.size() == 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT  {return __table_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT {return __table_.max_size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       begin() _NOEXCEPT        {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       end() _NOEXCEPT          {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin()  const _NOEXCEPT {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()    const _NOEXCEPT {return __table_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const _NOEXCEPT {return __table_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend()   const _NOEXCEPT {return __table_.end();}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator emplace(_Args\x26\x26... __args)\x0a"
"            {return __table_.__emplace_multi(_VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        iterator emplace_hint(const_iterator __p, _Args\x26\x26... __args)\x0a"
"            {return __table_.__emplace_hint_multi(__p, _VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(value_type\x26\x26 __x) {return __table_.__insert_multi(_VSTD\x3a\x3amove(__x));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, value_type\x26\x26 __x)\x0a"
"        {return __table_.__insert_multi(__p, _VSTD\x3a\x3amove(__x));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void insert(initializer_list<value_type> __il)\x0a"
"        {insert(__il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const value_type\x26 __x) {return __table_.__insert_multi(__x);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, const value_type\x26 __x)\x0a"
"        {return __table_.__insert_multi(__p, __x);}\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void insert(_InputIterator __first, _InputIterator __last);\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to unordered_multiset\x3a\x3ainsert()\x22);\x0a"
"        return __table_.template __node_handle_insert_multi<node_type>(\x0a"
"            _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __hint, node_type\x26\x26 __nh)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__nh.empty() \x7c\x7c __nh.get_allocator() == get_allocator(),\x0a"
"            \x22node_type with incompatible allocator passed to unordered_multiset\x3a\x3ainsert()\x22);\x0a"
"        return __table_.template __node_handle_insert_multi<node_type>(\x0a"
"            __hint, _VSTD\x3a\x3amove(__nh));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(const_iterator __position)\x0a"
"    {\x0a"
"        return __table_.template __node_handle_extract<node_type>(\x0a"
"            __position);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    node_type extract(key_type const\x26 __key)\x0a"
"    {\x0a"
"        return __table_.template __node_handle_extract<node_type>(__key);\x0a"
"    }\x0a"
"\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_multiset<key_type, _H2, _P2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_multi(__source.__table_);\x0a"
"    }\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_multiset<key_type, _H2, _P2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_multi(__source.__table_);\x0a"
"    }\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_set<key_type, _H2, _P2, allocator_type>\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_multi(__source.__table_);\x0a"
"    }\x0a"
"    template <class _H2, class _P2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void merge(unordered_set<key_type, _H2, _P2, allocator_type>\x26\x26 __source)\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(__source.get_allocator() == get_allocator(),\x0a"
"                       \x22merging container with incompatible allocator\x22);\x0a"
"        return __table_.__node_handle_merge_multi(__source.__table_);\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(const_iterator __p) {return __table_.erase(__p);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type erase(const key_type\x26 __k) {return __table_.__erase_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator erase(const_iterator __first, const_iterator __last)\x0a"
"        {return __table_.erase(__first, __last);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {__table_.clear();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(unordered_multiset\x26 __u)\x0a"
"        _NOEXCEPT_(__is_nothrow_swappable<__table>\x3a\x3avalue)\x0a"
"        {__table_.swap(__u.__table_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    hasher hash_function() const {return __table_.hash_function();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    key_equal key_eq() const {return __table_.key_eq();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       find(const key_type\x26 __k)       {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator find(const key_type\x26 __k) const {return __table_.find(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type count(const key_type\x26 __k) const {return __table_.__count_multi(__k);}\x0a"
"    #if _LIBCPP_STD_VER > 17\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool contains(const key_type\x26 __k) const {return find(__k) \x21= end();}\x0a"
"    #endif // _LIBCPP_STD_VER > 17\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<iterator, iterator>             equal_range(const key_type\x26 __k)\x0a"
"        {return __table_.__equal_range_multi(__k);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair<const_iterator, const_iterator> equal_range(const key_type\x26 __k) const\x0a"
"        {return __table_.__equal_range_multi(__k);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_count() const _NOEXCEPT {return __table_.bucket_count();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_bucket_count() const _NOEXCEPT {return __table_.max_bucket_count();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket_size(size_type __n) const {return __table_.bucket_size(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type bucket(const key_type\x26 __k) const {return __table_.bucket(__k);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    local_iterator       begin(size_type __n)        {return __table_.begin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    local_iterator       end(size_type __n)          {return __table_.end(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator begin(size_type __n) const  {return __table_.cbegin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator end(size_type __n) const    {return __table_.cend(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator cbegin(size_type __n) const {return __table_.cbegin(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_local_iterator cend(size_type __n) const   {return __table_.cend(__n);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    float load_factor() const _NOEXCEPT {return __table_.load_factor();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    float max_load_factor() const _NOEXCEPT {return __table_.max_load_factor();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void max_load_factor(float __mlf) {__table_.max_load_factor(__mlf);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void rehash(size_type __n) {__table_.rehash(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reserve(size_type __n) {__table_.reserve(__n);}\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"    bool __dereferenceable(const const_iterator* __i) const\x0a"
"        {return __table_.__dereferenceable(__i);}\x0a"
"    bool __decrementable(const const_iterator* __i) const\x0a"
"        {return __table_.__decrementable(__i);}\x0a"
"    bool __addable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"        {return __table_.__addable(__i, __n);}\x0a"
"    bool __subscriptable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"        {return __table_.__addable(__i, __n);}\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _Hash = hash<__iter_value_type<_InputIterator>>,\x0a"
"         class _Pred = equal_to<__iter_value_type<_InputIterator>>,\x0a"
"         class _Allocator = allocator<__iter_value_type<_InputIterator>>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Pred>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multiset(_InputIterator, _InputIterator, typename allocator_traits<_Allocator>\x3a\x3asize_type = 0,\x0a"
"              _Hash = _Hash(), _Pred = _Pred(), _Allocator = _Allocator())\x0a"
"  -> unordered_multiset<__iter_value_type<_InputIterator>, _Hash, _Pred, _Allocator>;\x0a"
"\x0a"
"template<class _Tp, class _Hash = hash<_Tp>,\x0a"
"         class _Pred = equal_to<_Tp>, class _Allocator = allocator<_Tp>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Pred>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multiset(initializer_list<_Tp>, typename allocator_traits<_Allocator>\x3a\x3asize_type = 0,\x0a"
"              _Hash = _Hash(), _Pred = _Pred(), _Allocator = _Allocator())\x0a"
"  -> unordered_multiset<_Tp, _Hash, _Pred, _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multiset(_InputIterator, _InputIterator, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Allocator)\x0a"
"  -> unordered_multiset<__iter_value_type<_InputIterator>,\x0a"
"                   hash<__iter_value_type<_InputIterator>>,\x0a"
"                   equal_to<__iter_value_type<_InputIterator>>,\x0a"
"                   _Allocator>;\x0a"
"\x0a"
"template<class _InputIterator, class _Hash, class _Allocator,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multiset(_InputIterator, _InputIterator, typename allocator_traits<_Allocator>\x3a\x3asize_type,\x0a"
"              _Hash, _Allocator)\x0a"
"  -> unordered_multiset<__iter_value_type<_InputIterator>, _Hash,\x0a"
"                   equal_to<__iter_value_type<_InputIterator>>,\x0a"
"                   _Allocator>;\x0a"
"\x0a"
"template<class _Tp, class _Allocator,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multiset(initializer_list<_Tp>, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Allocator)\x0a"
"  -> unordered_multiset<_Tp, hash<_Tp>, equal_to<_Tp>, _Allocator>;\x0a"
"\x0a"
"template<class _Tp, class _Hash, class _Allocator,\x0a"
"         class = _EnableIf<\x21__is_allocator<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<\x21is_integral<_Hash>\x3a\x3avalue>,\x0a"
"         class = _EnableIf<__is_allocator<_Allocator>\x3a\x3avalue>>\x0a"
"unordered_multiset(initializer_list<_Tp>, typename allocator_traits<_Allocator>\x3a\x3asize_type, _Hash, _Allocator)\x0a"
"  -> unordered_multiset<_Tp, _Hash, equal_to<_Tp>, _Allocator>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        size_type __n, const hasher\x26 __hf, const key_equal\x26 __eql,\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        _InputIterator __first, _InputIterator __last, size_type __n,\x0a"
"        const hasher\x26 __hf, const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        const unordered_multiset\x26 __u)\x0a"
"    \x3a __table_(__u.__table_)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        const unordered_multiset\x26 __u, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__u.__table_, __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__u.bucket_count());\x0a"
"    insert(__u.begin(), __u.end());\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        unordered_multiset\x26\x26 __u)\x0a"
"    _NOEXCEPT_(is_nothrow_move_constructible<__table>\x3a\x3avalue)\x0a"
"    \x3a __table_(_VSTD\x3a\x3amove(__u.__table_))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"    __get_db()->swap(this, \x26__u);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        unordered_multiset\x26\x26 __u, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(_VSTD\x3a\x3amove(__u.__table_), __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__a \x21= __u.get_allocator())\x0a"
"    {\x0a"
"        iterator __i = __u.begin();\x0a"
"        while (__u.size() \x21= 0)\x0a"
"            __table_.__insert_multi(_VSTD\x3a\x3amove(__u.__table_.remove(__i++)->__value_));\x0a"
"    }\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    else\x0a"
"        __get_db()->swap(this, \x26__u);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        initializer_list<value_type> __il)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf,\x0a"
"        const key_equal\x26 __eql)\x0a"
"    \x3a __table_(__hf, __eql)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aunordered_multiset(\x0a"
"        initializer_list<value_type> __il, size_type __n, const hasher\x26 __hf,\x0a"
"        const key_equal\x26 __eql, const allocator_type\x26 __a)\x0a"
"    \x3a __table_(__hf, __eql, __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __table_.rehash(__n);\x0a"
"    insert(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x26\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aoperator=(\x0a"
"        unordered_multiset\x26\x26 __u)\x0a"
"    _NOEXCEPT_(is_nothrow_move_assignable<__table>\x3a\x3avalue)\x0a"
"{\x0a"
"    __table_ = _VSTD\x3a\x3amove(__u.__table_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x26\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3aoperator=(\x0a"
"        initializer_list<value_type> __il)\x0a"
"{\x0a"
"    __table_.__assign_multi(__il.begin(), __il.end());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"template <class _InputIterator>\x0a"
"inline\x0a"
"void\x0a"
"unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3ainsert(_InputIterator __first,\x0a"
"                                                         _InputIterator __last)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __table_.__insert_multi(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"     unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __c, _Predicate __pred)\x0a"
"{ __libcpp_erase_if_container(__c, __pred); }\x0a"
"#endif\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"bool\x0a"
"operator==(const unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    if (__x.size() \x21= __y.size())\x0a"
"        return false;\x0a"
"    typedef typename unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x3a\x3a""const_iterator\x0a"
"                                                                 const_iterator;\x0a"
"    typedef pair<const_iterator, const_iterator> _EqRng;\x0a"
"    for (const_iterator __i = __x.begin(), __ex = __x.end(); __i \x21= __ex;)\x0a"
"    {\x0a"
"        _EqRng __xeq = __x.equal_range(*__i);\x0a"
"        _EqRng __yeq = __y.equal_range(*__i);\x0a"
"        if (_VSTD\x3a\x3a""distance(__xeq.first, __xeq.second) \x21=\x0a"
"            _VSTD\x3a\x3a""distance(__yeq.first, __yeq.second) \x7c\x7c\x0a"
"                  \x21_VSTD\x3a\x3ais_permutation(__xeq.first, __xeq.second, __yeq.first))\x0a"
"            return false;\x0a"
"        __i = __xeq.second;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Value, class _Hash, class _Pred, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __x,\x0a"
"           const unordered_multiset<_Value, _Hash, _Pred, _Alloc>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_UNORDERED_SET\x0a"
"", 69115 ); }