#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_utility( 
"// -*- C++ -*-\x0a"
"//===-------------------------- utility -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_UTILITY\x0a"
"#define _LIBCPP_UTILITY\x0a"
"\x0a"
"/*\x0a"
"    utility synopsis\x0a"
"\x0a"
"#include <initializer_list>\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class T>\x0a"
"    void\x0a"
"    swap(T\x26 a, T\x26 b);\x0a"
"\x0a"
"namespace rel_ops\x0a"
"{\x0a"
"    template<class T> bool operator\x21=(const T\x26, const T\x26);\x0a"
"    template<class T> bool operator> (const T\x26, const T\x26);\x0a"
"    template<class T> bool operator<=(const T\x26, const T\x26);\x0a"
"    template<class T> bool operator>=(const T\x26, const T\x26);\x0a"
"}\x0a"
"\x0a"
"template<class T>\x0a"
"void\x0a"
"swap(T\x26 a, T\x26 b) noexcept(is_nothrow_move_constructible<T>\x3a\x3avalue \x26\x26\x0a"
"                          is_nothrow_move_assignable<T>\x3a\x3avalue);\x0a"
"\x0a"
"template <class T, size_t N>\x0a"
"void\x0a"
"swap(T (\x26""a)\x5bN\x5d, T (\x26""b)\x5bN\x5d) noexcept(noexcept(swap(*a, *b)));\x0a"
"\x0a"
"template <class T> T\x26\x26 forward(typename remove_reference<T>\x3a\x3atype\x26 t) noexcept;  // constexpr in C++14\x0a"
"template <class T> T\x26\x26 forward(typename remove_reference<T>\x3a\x3atype\x26\x26 t) noexcept; // constexpr in C++14\x0a"
"\x0a"
"template <class T> typename remove_reference<T>\x3a\x3atype\x26\x26 move(T\x26\x26) noexcept;      // constexpr in C++14\x0a"
"\x0a"
"template <class T>\x0a"
"    typename conditional\x0a"
"    <\x0a"
"        \x21is_nothrow_move_constructible<T>\x3a\x3avalue \x26\x26 is_copy_constructible<T>\x3a\x3avalue,\x0a"
"        const T\x26,\x0a"
"        T\x26\x26\x0a"
"    >\x3a\x3atype\x0a"
"    move_if_noexcept(T\x26 x) noexcept; // constexpr in C++14\x0a"
"\x0a"
"template <class T> constexpr add_const_t<T>\x26 as_const(T\x26 t) noexcept;      // C++17\x0a"
"template <class T>                      void as_const(const T\x26\x26) = delete; // C++17\x0a"
"\x0a"
"template <class T> typename add_rvalue_reference<T>\x3a\x3atype declval() noexcept;\x0a"
"\x0a"
"template <class T1, class T2>\x0a"
"struct pair\x0a"
"{\x0a"
"    typedef T1 first_type;\x0a"
"    typedef T2 second_type;\x0a"
"\x0a"
"    T1 first;\x0a"
"    T2 second;\x0a"
"\x0a"
"    pair(const pair\x26) = default;\x0a"
"    pair(pair\x26\x26) = default;\x0a"
"    constexpr pair();\x0a"
"    pair(const T1\x26 x, const T2\x26 y);                          // constexpr in C++14\x0a"
"    template <class U, class V> pair(U\x26\x26 x, V\x26\x26 y);          // constexpr in C++14\x0a"
"    template <class U, class V> pair(const pair<U, V>\x26 p);   // constexpr in C++14\x0a"
"    template <class U, class V> pair(pair<U, V>\x26\x26 p);        // constexpr in C++14\x0a"
"    template <class... Args1, class... Args2>\x0a"
"        pair(piecewise_construct_t, tuple<Args1...> first_args,\x0a"
"             tuple<Args2...> second_args);\x0a"
"\x0a"
"    template <class U, class V> pair\x26 operator=(const pair<U, V>\x26 p);\x0a"
"    pair\x26 operator=(pair\x26\x26 p) noexcept(is_nothrow_move_assignable<T1>\x3a\x3avalue \x26\x26\x0a"
"                                       is_nothrow_move_assignable<T2>\x3a\x3avalue);\x0a"
"    template <class U, class V> pair\x26 operator=(pair<U, V>\x26\x26 p);\x0a"
"\x0a"
"    void swap(pair\x26 p) noexcept(is_nothrow_swappable_v<T1> \x26\x26\x0a"
"                                is_nothrow_swappable_v<T2>);\x0a"
"};\x0a"
"\x0a"
"template <class T1, class T2> bool operator==(const pair<T1,T2>\x26, const pair<T1,T2>\x26); // constexpr in C++14\x0a"
"template <class T1, class T2> bool operator\x21=(const pair<T1,T2>\x26, const pair<T1,T2>\x26); // constexpr in C++14\x0a"
"template <class T1, class T2> bool operator< (const pair<T1,T2>\x26, const pair<T1,T2>\x26); // constexpr in C++14\x0a"
"template <class T1, class T2> bool operator> (const pair<T1,T2>\x26, const pair<T1,T2>\x26); // constexpr in C++14\x0a"
"template <class T1, class T2> bool operator>=(const pair<T1,T2>\x26, const pair<T1,T2>\x26); // constexpr in C++14\x0a"
"template <class T1, class T2> bool operator<=(const pair<T1,T2>\x26, const pair<T1,T2>\x26); // constexpr in C++14\x0a"
"\x0a"
"template <class T1, class T2> pair<V1, V2> make_pair(T1\x26\x26, T2\x26\x26);   // constexpr in C++14\x0a"
"template <class T1, class T2>\x0a"
"void\x0a"
"swap(pair<T1, T2>\x26 x, pair<T1, T2>\x26 y) noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"struct piecewise_construct_t { };\x0a"
"inline constexpr piecewise_construct_t piecewise_construct = piecewise_construct_t();\x0a"
"\x0a"
"template <class T> struct tuple_size;\x0a"
"template <size_t I, class T> struct tuple_element;\x0a"
"\x0a"
"template <class T1, class T2> struct tuple_size<pair<T1, T2> >;\x0a"
"template <class T1, class T2> struct tuple_element<0, pair<T1, T2> >;\x0a"
"template <class T1, class T2> struct tuple_element<1, pair<T1, T2> >;\x0a"
"\x0a"
"template<size_t I, class T1, class T2>\x0a"
"    typename tuple_element<I, pair<T1, T2> >\x3a\x3atype\x26\x0a"
"    get(pair<T1, T2>\x26) noexcept; // constexpr in C++14\x0a"
"\x0a"
"template<size_t I, class T1, class T2>\x0a"
"    const typename tuple_element<I, pair<T1, T2> >\x3a\x3atype\x26\x0a"
"    get(const pair<T1, T2>\x26) noexcept; // constexpr in C++14\x0a"
"\x0a"
"template<size_t I, class T1, class T2>\x0a"
"    typename tuple_element<I, pair<T1, T2> >\x3a\x3atype\x26\x26\x0a"
"    get(pair<T1, T2>\x26\x26) noexcept; // constexpr in C++14\x0a"
"\x0a"
"template<size_t I, class T1, class T2>\x0a"
"    const typename tuple_element<I, pair<T1, T2> >\x3a\x3atype\x26\x26\x0a"
"    get(const pair<T1, T2>\x26\x26) noexcept; // constexpr in C++14\x0a"
"\x0a"
"template<class T1, class T2>\x0a"
"    constexpr T1\x26 get(pair<T1, T2>\x26) noexcept; // C++14\x0a"
"\x0a"
"template<class T1, class T2>\x0a"
"    constexpr const T1\x26 get(const pair<T1, T2>\x26) noexcept; // C++14\x0a"
"\x0a"
"template<class T1, class T2>\x0a"
"    constexpr T1\x26\x26 get(pair<T1, T2>\x26\x26) noexcept; // C++14\x0a"
"\x0a"
"template<class T1, class T2>\x0a"
"    constexpr const T1\x26\x26 get(const pair<T1, T2>\x26\x26) noexcept; // C++14\x0a"
"\x0a"
"template<class T1, class T2>\x0a"
"    constexpr T1\x26 get(pair<T2, T1>\x26) noexcept; // C++14\x0a"
"\x0a"
"template<class T1, class T2>\x0a"
"    constexpr const T1\x26 get(const pair<T2, T1>\x26) noexcept; // C++14\x0a"
"\x0a"
"template<class T1, class T2>\x0a"
"    constexpr T1\x26\x26 get(pair<T2, T1>\x26\x26) noexcept; // C++14\x0a"
"\x0a"
"template<class T1, class T2>\x0a"
"    constexpr const T1\x26\x26 get(const pair<T2, T1>\x26\x26) noexcept; // C++14\x0a"
"\x0a"
"// C++14\x0a"
"\x0a"
"template<class T, T... I>\x0a"
"struct integer_sequence\x0a"
"{\x0a"
"    typedef T value_type;\x0a"
"\x0a"
"    static constexpr size_t size() noexcept;\x0a"
"};\x0a"
"\x0a"
"template<size_t... I>\x0a"
"  using index_sequence = integer_sequence<size_t, I...>;\x0a"
"\x0a"
"template<class T, T N>\x0a"
"  using make_integer_sequence = integer_sequence<T, 0, 1, ..., N-1>;\x0a"
"template<size_t N>\x0a"
"  using make_index_sequence = make_integer_sequence<size_t, N>;\x0a"
"\x0a"
"template<class... T>\x0a"
"  using index_sequence_for = make_index_sequence<sizeof...(T)>;\x0a"
"\x0a"
"template<class T, class U=T>\x0a"
"    T exchange(T\x26 obj, U\x26\x26 new_value);\x0a"
"\x0a"
"// 20.2.7, in-place construction // C++17\x0a"
"struct in_place_t {\x0a"
"  explicit in_place_t() = default;\x0a"
"};\x0a"
"inline constexpr in_place_t in_place{};\x0a"
"template <class T>\x0a"
"  struct in_place_type_t {\x0a"
"    explicit in_place_type_t() = default;\x0a"
"  };\x0a"
"template <class T>\x0a"
"  inline constexpr in_place_type_t<T> in_place_type{};\x0a"
"template <size_t I>\x0a"
"  struct in_place_index_t {\x0a"
"    explicit in_place_index_t() = default;\x0a"
"  };\x0a"
"template <size_t I>\x0a"
"  inline constexpr in_place_index_t<I> in_place_index{};\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__tuple>\x0a"
"#include <type_traits>\x0a"
"#include <initializer_list>\x0a"
"#include <cstddef>\x0a"
"#include <cstring>\x0a"
"#include <cstdint>\x0a"
"#include <version>\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"namespace rel_ops\x0a"
"{\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const _Tp\x26 __x, const _Tp\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const _Tp\x26 __x, const _Tp\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const _Tp\x26 __x, const _Tp\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const _Tp\x26 __x, const _Tp\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"}  // rel_ops\x0a"
"\x0a"
"// swap_ranges\x0a"
"\x0a"
"\x0a"
"template <class _ForwardIterator1, class _ForwardIterator2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator2\x0a"
"swap_ranges(_ForwardIterator1 __first1, _ForwardIterator1 __last1, _ForwardIterator2 __first2)\x0a"
"{\x0a"
"    for(; __first1 \x21= __last1; ++__first1, (void) ++__first2)\x0a"
"        swap(*__first1, *__first2);\x0a"
"    return __first2;\x0a"
"}\x0a"
"\x0a"
"// forward declared in <type_traits>\x0a"
"template<class _Tp, size_t _Np>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"typename enable_if<\x0a"
"    __is_swappable<_Tp>\x3a\x3avalue\x0a"
">\x3a\x3atype\x0a"
"swap(_Tp (\x26__a)\x5b_Np\x5d, _Tp (\x26__b)\x5b_Np\x5d) _NOEXCEPT_(__is_nothrow_swappable<_Tp>\x3a\x3avalue)\x0a"
"{\x0a"
"    _VSTD\x3a\x3aswap_ranges(__a, __a + _Np, __b);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"typename conditional\x0a"
"<\x0a"
"    \x21is_nothrow_move_constructible<_Tp>\x3a\x3avalue \x26\x26 is_copy_constructible<_Tp>\x3a\x3avalue,\x0a"
"    const _Tp\x26,\x0a"
"    _Tp\x26\x26\x0a"
">\x3a\x3atype\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"const _Tp\x26\x0a"
"#endif\x0a"
"move_if_noexcept(_Tp\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amove(__x);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _Tp> constexpr add_const_t<_Tp>\x26 as_const(_Tp\x26 __t) noexcept { return __t; }\x0a"
"template <class _Tp>                        void as_const(const _Tp\x26\x26) = delete;\x0a"
"#endif\x0a"
"\x0a"
"struct _LIBCPP_TEMPLATE_VIS piecewise_construct_t { };\x0a"
"#if defined(_LIBCPP_CXX03_LANG) \x7c\x7c defined(_LIBCPP_BUILDING_LIBRARY)\x0a"
"extern _LIBCPP_EXPORTED_FROM_ABI const piecewise_construct_t piecewise_construct;// = piecewise_construct_t();\x0a"
"#else\x0a"
"/* _LIBCPP_INLINE_VAR */ constexpr piecewise_construct_t piecewise_construct = piecewise_construct_t();\x0a"
"#endif\x0a"
"\x0a"
"#if defined(_LIBCPP_DEPRECATED_ABI_DISABLE_PAIR_TRIVIAL_COPY_CTOR)\x0a"
"template <class, class>\x0a"
"struct __non_trivially_copyable_base {\x0a"
"  _LIBCPP_CONSTEXPR _LIBCPP_INLINE_VISIBILITY\x0a"
"  __non_trivially_copyable_base() _NOEXCEPT {}\x0a"
"  _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"  __non_trivially_copyable_base(__non_trivially_copyable_base const\x26) _NOEXCEPT {}\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS pair\x0a"
"#if defined(_LIBCPP_DEPRECATED_ABI_DISABLE_PAIR_TRIVIAL_COPY_CTOR)\x0a"
"\x3a private __non_trivially_copyable_base<_T1, _T2>\x0a"
"#endif\x0a"
"{\x0a"
"    typedef _T1 first_type;\x0a"
"    typedef _T2 second_type;\x0a"
"\x0a"
"    _T1 first;\x0a"
"    _T2 second;\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"    pair(pair const\x26) = default;\x0a"
"    pair(pair\x26\x26) = default;\x0a"
"#else\x0a"
"  // Use the implicitly declared copy constructor in C++03\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair() \x3a first(), second() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair(_T1 const\x26 __t1, _T2 const\x26 __t2) \x3a first(__t1), second(__t2) {}\x0a"
"\x0a"
"    template <class _U1, class _U2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair(const pair<_U1, _U2>\x26 __p) \x3a first(__p.first), second(__p.second) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair\x26 operator=(pair const\x26 __p) {\x0a"
"        first = __p.first;\x0a"
"        second = __p.second;\x0a"
"        return *this;\x0a"
"    }\x0a"
"#else\x0a"
"    template <bool _Val>\x0a"
"    using _EnableB _LIBCPP_NODEBUG_TYPE = typename enable_if<_Val, bool>\x3a\x3atype;\x0a"
"\x0a"
"    struct _CheckArgs {\x0a"
"      template <class _U1, class _U2>\x0a"
"      static constexpr bool __enable_default() {\x0a"
"          return is_default_constructible<_U1>\x3a\x3avalue\x0a"
"              \x26\x26 is_default_constructible<_U2>\x3a\x3avalue;\x0a"
"      }\x0a"
"\x0a"
"      template <class _U1, class _U2>\x0a"
"      static constexpr bool __enable_explicit() {\x0a"
"          return is_constructible<first_type, _U1>\x3a\x3avalue\x0a"
"              \x26\x26 is_constructible<second_type, _U2>\x3a\x3avalue\x0a"
"              \x26\x26 (\x21is_convertible<_U1, first_type>\x3a\x3avalue\x0a"
"                  \x7c\x7c \x21is_convertible<_U2, second_type>\x3a\x3avalue);\x0a"
"      }\x0a"
"\x0a"
"      template <class _U1, class _U2>\x0a"
"      static constexpr bool __enable_implicit() {\x0a"
"          return is_constructible<first_type, _U1>\x3a\x3avalue\x0a"
"              \x26\x26 is_constructible<second_type, _U2>\x3a\x3avalue\x0a"
"              \x26\x26 is_convertible<_U1, first_type>\x3a\x3avalue\x0a"
"              \x26\x26 is_convertible<_U2, second_type>\x3a\x3avalue;\x0a"
"      }\x0a"
"    };\x0a"
"\x0a"
"    template <bool _MaybeEnable>\x0a"
"    using _CheckArgsDep _LIBCPP_NODEBUG_TYPE = typename conditional<\x0a"
"      _MaybeEnable, _CheckArgs, __check_tuple_constructor_fail>\x3a\x3atype;\x0a"
"\x0a"
"    struct _CheckTupleLikeConstructor {\x0a"
"        template <class _Tuple>\x0a"
"        static constexpr bool __enable_implicit() {\x0a"
"            return __tuple_convertible<_Tuple, pair>\x3a\x3avalue;\x0a"
"        }\x0a"
"\x0a"
"        template <class _Tuple>\x0a"
"        static constexpr bool __enable_explicit() {\x0a"
"            return __tuple_constructible<_Tuple, pair>\x3a\x3avalue\x0a"
"               \x26\x26 \x21__tuple_convertible<_Tuple, pair>\x3a\x3avalue;\x0a"
"        }\x0a"
"\x0a"
"        template <class _Tuple>\x0a"
"        static constexpr bool __enable_assign() {\x0a"
"            return __tuple_assignable<_Tuple, pair>\x3a\x3avalue;\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"    template <class _Tuple>\x0a"
"    using _CheckTLC _LIBCPP_NODEBUG_TYPE = typename conditional<\x0a"
"        __tuple_like_with_size<_Tuple, 2>\x3a\x3avalue\x0a"
"            \x26\x26 \x21is_same<typename decay<_Tuple>\x3a\x3atype, pair>\x3a\x3avalue,\x0a"
"        _CheckTupleLikeConstructor,\x0a"
"        __check_tuple_constructor_fail\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"    template<bool _Dummy = true, _EnableB<\x0a"
"            _CheckArgsDep<_Dummy>\x3a\x3atemplate __enable_default<_T1, _T2>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    pair() _NOEXCEPT_(is_nothrow_default_constructible<first_type>\x3a\x3avalue \x26\x26\x0a"
"                      is_nothrow_default_constructible<second_type>\x3a\x3avalue)\x0a"
"        \x3a first(), second() {}\x0a"
"\x0a"
"    template <bool _Dummy = true, _EnableB<\x0a"
"             _CheckArgsDep<_Dummy>\x3a\x3atemplate __enable_explicit<_T1 const\x26, _T2 const\x26>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    explicit pair(_T1 const\x26 __t1, _T2 const\x26 __t2)\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<first_type>\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_copy_constructible<second_type>\x3a\x3avalue)\x0a"
"        \x3a first(__t1), second(__t2) {}\x0a"
"\x0a"
"    template<bool _Dummy = true, _EnableB<\x0a"
"            _CheckArgsDep<_Dummy>\x3a\x3atemplate __enable_implicit<_T1 const\x26, _T2 const\x26>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    pair(_T1 const\x26 __t1, _T2 const\x26 __t2)\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<first_type>\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_copy_constructible<second_type>\x3a\x3avalue)\x0a"
"        \x3a first(__t1), second(__t2) {}\x0a"
"\x0a"
"    template<class _U1, class _U2, _EnableB<\x0a"
"             _CheckArgs\x3a\x3atemplate __enable_explicit<_U1, _U2>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    explicit pair(_U1\x26\x26 __u1, _U2\x26\x26 __u2)\x0a"
"        _NOEXCEPT_((is_nothrow_constructible<first_type, _U1>\x3a\x3avalue \x26\x26\x0a"
"                    is_nothrow_constructible<second_type, _U2>\x3a\x3avalue))\x0a"
"        \x3a first(_VSTD\x3a\x3a""forward<_U1>(__u1)), second(_VSTD\x3a\x3a""forward<_U2>(__u2)) {}\x0a"
"\x0a"
"    template<class _U1, class _U2, _EnableB<\x0a"
"            _CheckArgs\x3a\x3atemplate __enable_implicit<_U1, _U2>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    pair(_U1\x26\x26 __u1, _U2\x26\x26 __u2)\x0a"
"        _NOEXCEPT_((is_nothrow_constructible<first_type, _U1>\x3a\x3avalue \x26\x26\x0a"
"                    is_nothrow_constructible<second_type, _U2>\x3a\x3avalue))\x0a"
"        \x3a first(_VSTD\x3a\x3a""forward<_U1>(__u1)), second(_VSTD\x3a\x3a""forward<_U2>(__u2)) {}\x0a"
"\x0a"
"    template<class _U1, class _U2, _EnableB<\x0a"
"            _CheckArgs\x3a\x3atemplate __enable_explicit<_U1 const\x26, _U2 const\x26>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    explicit pair(pair<_U1, _U2> const\x26 __p)\x0a"
"        _NOEXCEPT_((is_nothrow_constructible<first_type, _U1 const\x26>\x3a\x3avalue \x26\x26\x0a"
"                    is_nothrow_constructible<second_type, _U2 const\x26>\x3a\x3avalue))\x0a"
"        \x3a first(__p.first), second(__p.second) {}\x0a"
"\x0a"
"    template<class _U1, class _U2, _EnableB<\x0a"
"            _CheckArgs\x3a\x3atemplate __enable_implicit<_U1 const\x26, _U2 const\x26>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    pair(pair<_U1, _U2> const\x26 __p)\x0a"
"        _NOEXCEPT_((is_nothrow_constructible<first_type, _U1 const\x26>\x3a\x3avalue \x26\x26\x0a"
"                    is_nothrow_constructible<second_type, _U2 const\x26>\x3a\x3avalue))\x0a"
"        \x3a first(__p.first), second(__p.second) {}\x0a"
"\x0a"
"    template<class _U1, class _U2, _EnableB<\x0a"
"            _CheckArgs\x3a\x3atemplate __enable_explicit<_U1, _U2>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    explicit pair(pair<_U1, _U2>\x26\x26__p)\x0a"
"        _NOEXCEPT_((is_nothrow_constructible<first_type, _U1\x26\x26>\x3a\x3avalue \x26\x26\x0a"
"                    is_nothrow_constructible<second_type, _U2\x26\x26>\x3a\x3avalue))\x0a"
"        \x3a first(_VSTD\x3a\x3a""forward<_U1>(__p.first)), second(_VSTD\x3a\x3a""forward<_U2>(__p.second)) {}\x0a"
"\x0a"
"    template<class _U1, class _U2, _EnableB<\x0a"
"            _CheckArgs\x3a\x3atemplate __enable_implicit<_U1, _U2>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    pair(pair<_U1, _U2>\x26\x26 __p)\x0a"
"        _NOEXCEPT_((is_nothrow_constructible<first_type, _U1\x26\x26>\x3a\x3avalue \x26\x26\x0a"
"                    is_nothrow_constructible<second_type, _U2\x26\x26>\x3a\x3avalue))\x0a"
"        \x3a first(_VSTD\x3a\x3a""forward<_U1>(__p.first)), second(_VSTD\x3a\x3a""forward<_U2>(__p.second)) {}\x0a"
"\x0a"
"    template<class _Tuple, _EnableB<\x0a"
"            _CheckTLC<_Tuple>\x3a\x3atemplate __enable_explicit<_Tuple>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    explicit pair(_Tuple\x26\x26 __p)\x0a"
"        \x3a first(_VSTD\x3a\x3aget<0>(_VSTD\x3a\x3a""forward<_Tuple>(__p))),\x0a"
"          second(_VSTD\x3a\x3aget<1>(_VSTD\x3a\x3a""forward<_Tuple>(__p))) {}\x0a"
"\x0a"
"    template<class _Tuple, _EnableB<\x0a"
"            _CheckTLC<_Tuple>\x3a\x3atemplate __enable_implicit<_Tuple>()\x0a"
"    > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    pair(_Tuple\x26\x26 __p)\x0a"
"        \x3a first(_VSTD\x3a\x3aget<0>(_VSTD\x3a\x3a""forward<_Tuple>(__p))),\x0a"
"          second(_VSTD\x3a\x3aget<1>(_VSTD\x3a\x3a""forward<_Tuple>(__p))) {}\x0a"
"\x0a"
"    template <class... _Args1, class... _Args2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair(piecewise_construct_t __pc,\x0a"
"         tuple<_Args1...> __first_args, tuple<_Args2...> __second_args)\x0a"
"        _NOEXCEPT_((is_nothrow_constructible<first_type, _Args1...>\x3a\x3avalue \x26\x26\x0a"
"                    is_nothrow_constructible<second_type, _Args2...>\x3a\x3avalue))\x0a"
"        \x3a pair(__pc, __first_args, __second_args,\x0a"
"                typename __make_tuple_indices<sizeof...(_Args1)>\x3a\x3atype(),\x0a"
"                typename __make_tuple_indices<sizeof...(_Args2) >\x3a\x3atype()) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair\x26 operator=(typename conditional<\x0a"
"                        is_copy_assignable<first_type>\x3a\x3avalue \x26\x26\x0a"
"                        is_copy_assignable<second_type>\x3a\x3avalue,\x0a"
"                    pair, __nat>\x3a\x3atype const\x26 __p)\x0a"
"        _NOEXCEPT_(is_nothrow_copy_assignable<first_type>\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_copy_assignable<second_type>\x3a\x3avalue)\x0a"
"    {\x0a"
"        first = __p.first;\x0a"
"        second = __p.second;\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair\x26 operator=(typename conditional<\x0a"
"                        is_move_assignable<first_type>\x3a\x3avalue \x26\x26\x0a"
"                        is_move_assignable<second_type>\x3a\x3avalue,\x0a"
"                    pair, __nat>\x3a\x3atype\x26\x26 __p)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<first_type>\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_move_assignable<second_type>\x3a\x3avalue)\x0a"
"    {\x0a"
"        first = _VSTD\x3a\x3a""forward<first_type>(__p.first);\x0a"
"        second = _VSTD\x3a\x3a""forward<second_type>(__p.second);\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    template <class _Tuple, _EnableB<\x0a"
"            _CheckTLC<_Tuple>\x3a\x3atemplate __enable_assign<_Tuple>()\x0a"
"     > = false>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pair\x26 operator=(_Tuple\x26\x26 __p) {\x0a"
"        first = _VSTD\x3a\x3aget<0>(_VSTD\x3a\x3a""forward<_Tuple>(__p));\x0a"
"        second = _VSTD\x3a\x3aget<1>(_VSTD\x3a\x3a""forward<_Tuple>(__p));\x0a"
"        return *this;\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void\x0a"
"    swap(pair\x26 __p) _NOEXCEPT_(__is_nothrow_swappable<first_type>\x3a\x3avalue \x26\x26\x0a"
"                               __is_nothrow_swappable<second_type>\x3a\x3avalue)\x0a"
"    {\x0a"
"        using _VSTD\x3a\x3aswap;\x0a"
"        swap(first,  __p.first);\x0a"
"        swap(second, __p.second);\x0a"
"    }\x0a"
"private\x3a\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class... _Args1, class... _Args2, size_t... _I1, size_t... _I2>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        pair(piecewise_construct_t,\x0a"
"             tuple<_Args1...>\x26 __first_args, tuple<_Args2...>\x26 __second_args,\x0a"
"             __tuple_indices<_I1...>, __tuple_indices<_I2...>);\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _T1, class _T2>\x0a"
"pair(_T1, _T2) -> pair<_T1, _T2>;\x0a"
"#endif // _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator==(const pair<_T1,_T2>\x26 __x, const pair<_T1,_T2>\x26 __y)\x0a"
"{\x0a"
"    return __x.first == __y.first \x26\x26 __x.second == __y.second;\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator\x21=(const pair<_T1,_T2>\x26 __x, const pair<_T1,_T2>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator< (const pair<_T1,_T2>\x26 __x, const pair<_T1,_T2>\x26 __y)\x0a"
"{\x0a"
"    return __x.first < __y.first \x7c\x7c (\x21(__y.first < __x.first) \x26\x26 __x.second < __y.second);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator> (const pair<_T1,_T2>\x26 __x, const pair<_T1,_T2>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator>=(const pair<_T1,_T2>\x26 __x, const pair<_T1,_T2>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"bool\x0a"
"operator<=(const pair<_T1,_T2>\x26 __x, const pair<_T1,_T2>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_swappable<_T1>\x3a\x3avalue \x26\x26\x0a"
"    __is_swappable<_T2>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"swap(pair<_T1, _T2>\x26 __x, pair<_T1, _T2>\x26 __y)\x0a"
"                     _NOEXCEPT_((__is_nothrow_swappable<_T1>\x3a\x3avalue \x26\x26\x0a"
"                                 __is_nothrow_swappable<_T2>\x3a\x3avalue))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __unwrap_reference { typedef _LIBCPP_NODEBUG_TYPE _Tp type; };\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __unwrap_reference<reference_wrapper<_Tp> > { typedef _LIBCPP_NODEBUG_TYPE _Tp\x26 type; };\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Tp>\x0a"
"struct unwrap_reference \x3a __unwrap_reference<_Tp> { };\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct unwrap_ref_decay \x3a unwrap_reference<typename decay<_Tp>\x3a\x3atype> { };\x0a"
"#endif // > C++17\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __unwrap_ref_decay\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"    \x3a unwrap_ref_decay<_Tp>\x0a"
"#else\x0a"
"    \x3a __unwrap_reference<typename decay<_Tp>\x3a\x3atype>\x0a"
"#endif\x0a"
"{ };\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"pair<typename __unwrap_ref_decay<_T1>\x3a\x3atype, typename __unwrap_ref_decay<_T2>\x3a\x3atype>\x0a"
"make_pair(_T1\x26\x26 __t1, _T2\x26\x26 __t2)\x0a"
"{\x0a"
"    return pair<typename __unwrap_ref_decay<_T1>\x3a\x3atype, typename __unwrap_ref_decay<_T2>\x3a\x3atype>\x0a"
"               (_VSTD\x3a\x3a""forward<_T1>(__t1), _VSTD\x3a\x3a""forward<_T2>(__t2));\x0a"
"}\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"pair<_T1,_T2>\x0a"
"make_pair(_T1 __x, _T2 __y)\x0a"
"{\x0a"
"    return pair<_T1, _T2>(__x, __y);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"  struct _LIBCPP_TEMPLATE_VIS tuple_size<pair<_T1, _T2> >\x0a"
"    \x3a public integral_constant<size_t, 2> {};\x0a"
"\x0a"
"template <size_t _Ip, class _T1, class _T2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS tuple_element<_Ip, pair<_T1, _T2> >\x0a"
"{\x0a"
"    static_assert(_Ip < 2, \x22Index out of bounds in std\x3a\x3atuple_element<std\x3a\x3apair<T1, T2>>\x22);\x0a"
"};\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS tuple_element<0, pair<_T1, _T2> >\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE _T1 type;\x0a"
"};\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"struct _LIBCPP_TEMPLATE_VIS tuple_element<1, pair<_T1, _T2> >\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE _T2 type;\x0a"
"};\x0a"
"\x0a"
"template <size_t _Ip> struct __get_pair;\x0a"
"\x0a"
"template <>\x0a"
"struct __get_pair<0>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    static\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    _T1\x26\x0a"
"    get(pair<_T1, _T2>\x26 __p) _NOEXCEPT {return __p.first;}\x0a"
"\x0a"
"    template <class _T1, class _T2>\x0a"
"    static\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    const _T1\x26\x0a"
"    get(const pair<_T1, _T2>\x26 __p) _NOEXCEPT {return __p.first;}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _T1, class _T2>\x0a"
"    static\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    _T1\x26\x26\x0a"
"    get(pair<_T1, _T2>\x26\x26 __p) _NOEXCEPT {return _VSTD\x3a\x3a""forward<_T1>(__p.first);}\x0a"
"\x0a"
"    template <class _T1, class _T2>\x0a"
"    static\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    const _T1\x26\x26\x0a"
"    get(const pair<_T1, _T2>\x26\x26 __p) _NOEXCEPT {return _VSTD\x3a\x3a""forward<const _T1>(__p.first);}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct __get_pair<1>\x0a"
"{\x0a"
"    template <class _T1, class _T2>\x0a"
"    static\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    _T2\x26\x0a"
"    get(pair<_T1, _T2>\x26 __p) _NOEXCEPT {return __p.second;}\x0a"
"\x0a"
"    template <class _T1, class _T2>\x0a"
"    static\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    const _T2\x26\x0a"
"    get(const pair<_T1, _T2>\x26 __p) _NOEXCEPT {return __p.second;}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _T1, class _T2>\x0a"
"    static\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    _T2\x26\x26\x0a"
"    get(pair<_T1, _T2>\x26\x26 __p) _NOEXCEPT {return _VSTD\x3a\x3a""forward<_T2>(__p.second);}\x0a"
"\x0a"
"    template <class _T1, class _T2>\x0a"
"    static\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    const _T2\x26\x26\x0a"
"    get(const pair<_T1, _T2>\x26\x26 __p) _NOEXCEPT {return _VSTD\x3a\x3a""forward<const _T2>(__p.second);}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"};\x0a"
"\x0a"
"template <size_t _Ip, class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"typename tuple_element<_Ip, pair<_T1, _T2> >\x3a\x3atype\x26\x0a"
"get(pair<_T1, _T2>\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<_Ip>\x3a\x3aget(__p);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const typename tuple_element<_Ip, pair<_T1, _T2> >\x3a\x3atype\x26\x0a"
"get(const pair<_T1, _T2>\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<_Ip>\x3a\x3aget(__p);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <size_t _Ip, class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"typename tuple_element<_Ip, pair<_T1, _T2> >\x3a\x3atype\x26\x26\x0a"
"get(pair<_T1, _T2>\x26\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<_Ip>\x3a\x3aget(_VSTD\x3a\x3amove(__p));\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const typename tuple_element<_Ip, pair<_T1, _T2> >\x3a\x3atype\x26\x26\x0a"
"get(const pair<_T1, _T2>\x26\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<_Ip>\x3a\x3aget(_VSTD\x3a\x3amove(__p));\x0a"
"}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1 \x26 get(pair<_T1, _T2>\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<0>\x3a\x3aget(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1 const \x26 get(pair<_T1, _T2> const\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<0>\x3a\x3aget(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1 \x26\x26 get(pair<_T1, _T2>\x26\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<0>\x3a\x3aget(_VSTD\x3a\x3amove(__p));\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1 const \x26\x26 get(pair<_T1, _T2> const\x26\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<0>\x3a\x3aget(_VSTD\x3a\x3amove(__p));\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1 \x26 get(pair<_T2, _T1>\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<1>\x3a\x3aget(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1 const \x26 get(pair<_T2, _T1> const\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<1>\x3a\x3aget(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1 \x26\x26 get(pair<_T2, _T1>\x26\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<1>\x3a\x3aget(_VSTD\x3a\x3amove(__p));\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _T1 const \x26\x26 get(pair<_T2, _T1> const\x26\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __get_pair<1>\x3a\x3aget(_VSTD\x3a\x3amove(__p));\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"template<class _Tp, _Tp... _Ip>\x0a"
"struct _LIBCPP_TEMPLATE_VIS integer_sequence\x0a"
"{\x0a"
"    typedef _Tp value_type;\x0a"
"    static_assert( is_integral<_Tp>\x3a\x3avalue,\x0a"
"                  \x22std\x3a\x3ainteger_sequence can only be instantiated with an integral type\x22 );\x0a"
"    static\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr\x0a"
"    size_t\x0a"
"    size() noexcept { return sizeof...(_Ip); }\x0a"
"};\x0a"
"\x0a"
"template<size_t... _Ip>\x0a"
"    using index_sequence = integer_sequence<size_t, _Ip...>;\x0a"
"\x0a"
"#if __has_builtin(__make_integer_seq) \x26\x26 \x21""defined(_LIBCPP_TESTING_FALLBACK_MAKE_INTEGER_SEQUENCE)\x0a"
"\x0a"
"template <class _Tp, _Tp _Ep>\x0a"
"using __make_integer_sequence _LIBCPP_NODEBUG_TYPE = __make_integer_seq<integer_sequence, _Tp, _Ep>;\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template<typename _Tp, _Tp _Np> using __make_integer_sequence_unchecked _LIBCPP_NODEBUG_TYPE  =\x0a"
"  typename __detail\x3a\x3a__make<_Np>\x3a\x3atype\x3a\x3atemplate __convert<integer_sequence, _Tp>;\x0a"
"\x0a"
"template <class _Tp, _Tp _Ep>\x0a"
"struct __make_integer_sequence_checked\x0a"
"{\x0a"
"    static_assert(is_integral<_Tp>\x3a\x3avalue,\x0a"
"                  \x22std\x3a\x3amake_integer_sequence can only be instantiated with an integral type\x22 );\x0a"
"    static_assert(0 <= _Ep, \x22std\x3a\x3amake_integer_sequence must have a non-negative sequence length\x22);\x0a"
"    // Workaround GCC bug by preventing bad installations when 0 <= _Ep\x0a"
"    // https\x3a//gcc.gnu.org/bugzilla/show_bug.cgi\x3fid=68929\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE  __make_integer_sequence_unchecked<_Tp, 0 <= _Ep \x3f _Ep \x3a 0> type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, _Tp _Ep>\x0a"
"using __make_integer_sequence _LIBCPP_NODEBUG_TYPE = typename __make_integer_sequence_checked<_Tp, _Ep>\x3a\x3atype;\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"template<class _Tp, _Tp _Np>\x0a"
"    using make_integer_sequence = __make_integer_sequence<_Tp, _Np>;\x0a"
"\x0a"
"template<size_t _Np>\x0a"
"    using make_index_sequence = make_integer_sequence<size_t, _Np>;\x0a"
"\x0a"
"template<class... _Tp>\x0a"
"    using index_sequence_for = make_index_sequence<sizeof...(_Tp)>;\x0a"
"\x0a"
"#endif  // _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template<class _T1, class _T2 = _T1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_T1 exchange(_T1\x26 __obj, _T2 \x26\x26 __new_value)\x0a"
"{\x0a"
"    _T1 __old_value = _VSTD\x3a\x3amove(__obj);\x0a"
"    __obj = _VSTD\x3a\x3a""forward<_T2>(__new_value);\x0a"
"    return __old_value;\x0a"
"}\x0a"
"#endif  // _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"struct _LIBCPP_TYPE_VIS in_place_t {\x0a"
"    explicit in_place_t() = default;\x0a"
"};\x0a"
"_LIBCPP_INLINE_VAR constexpr in_place_t in_place{};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS in_place_type_t {\x0a"
"    explicit in_place_type_t() = default;\x0a"
"};\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr in_place_type_t<_Tp> in_place_type{};\x0a"
"\x0a"
"template <size_t _Idx>\x0a"
"struct _LIBCPP_TYPE_VIS in_place_index_t {\x0a"
"    explicit in_place_index_t() = default;\x0a"
"};\x0a"
"template <size_t _Idx>\x0a"
"_LIBCPP_INLINE_VAR constexpr in_place_index_t<_Idx> in_place_index{};\x0a"
"\x0a"
"template <class _Tp> struct __is_inplace_type_imp \x3a false_type {};\x0a"
"template <class _Tp> struct __is_inplace_type_imp<in_place_type_t<_Tp>> \x3a true_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"using __is_inplace_type = __is_inplace_type_imp<__uncvref_t<_Tp>>;\x0a"
"\x0a"
"template <class _Tp> struct __is_inplace_index_imp \x3a false_type {};\x0a"
"template <size_t _Idx> struct __is_inplace_index_imp<in_place_index_t<_Idx>> \x3a true_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"using __is_inplace_index = __is_inplace_index_imp<__uncvref_t<_Tp>>;\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"template <class _Arg, class _Result>\x0a"
"struct _LIBCPP_TEMPLATE_VIS unary_function\x0a"
"{\x0a"
"    typedef _Arg    argument_type;\x0a"
"    typedef _Result result_type;\x0a"
"};\x0a"
"\x0a"
"template <class _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Size\x0a"
"__loadword(const void* __p)\x0a"
"{\x0a"
"    _Size __r;\x0a"
"    std\x3a\x3amemcpy(\x26__r, __p, sizeof(__r));\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// We use murmur2 when size_t is 32 bits, and cityhash64 when size_t\x0a"
"// is 64 bits.  This is because cityhash64 uses 64bit x 64bit\x0a"
"// multiplication, which can be very slow on 32-bit systems.\x0a"
"template <class _Size, size_t = sizeof(_Size)*__CHAR_BIT__>\x0a"
"struct __murmur2_or_cityhash;\x0a"
"\x0a"
"template <class _Size>\x0a"
"struct __murmur2_or_cityhash<_Size, 32>\x0a"
"{\x0a"
"    inline _Size operator()(const void* __key, _Size __len)\x0a"
"         _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK;\x0a"
"};\x0a"
"\x0a"
"// murmur2\x0a"
"template <class _Size>\x0a"
"_Size\x0a"
"__murmur2_or_cityhash<_Size, 32>\x3a\x3aoperator()(const void* __key, _Size __len)\x0a"
"{\x0a"
"    const _Size __m = 0x5bd1e995;\x0a"
"    const _Size __r = 24;\x0a"
"    _Size __h = __len;\x0a"
"    const unsigned char* __data = static_cast<const unsigned char*>(__key);\x0a"
"    for (; __len >= 4; __data += 4, __len -= 4)\x0a"
"    {\x0a"
"        _Size __k = __loadword<_Size>(__data);\x0a"
"        __k *= __m;\x0a"
"        __k ^= __k >> __r;\x0a"
"        __k *= __m;\x0a"
"        __h *= __m;\x0a"
"        __h ^= __k;\x0a"
"    }\x0a"
"    switch (__len)\x0a"
"    {\x0a"
"    case 3\x3a\x0a"
"        __h ^= __data\x5b""2\x5d << 16;\x0a"
"        _LIBCPP_FALLTHROUGH();\x0a"
"    case 2\x3a\x0a"
"        __h ^= __data\x5b""1\x5d << 8;\x0a"
"        _LIBCPP_FALLTHROUGH();\x0a"
"    case 1\x3a\x0a"
"        __h ^= __data\x5b""0\x5d;\x0a"
"        __h *= __m;\x0a"
"    }\x0a"
"    __h ^= __h >> 13;\x0a"
"    __h *= __m;\x0a"
"    __h ^= __h >> 15;\x0a"
"    return __h;\x0a"
"}\x0a"
"\x0a"
"template <class _Size>\x0a"
"struct __murmur2_or_cityhash<_Size, 64>\x0a"
"{\x0a"
"    inline _Size operator()(const void* __key, _Size __len)  _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK;\x0a"
"\x0a"
" private\x3a\x0a"
"  // Some primes between 2^63 and 2^64.\x0a"
"  static const _Size __k0 = 0xc3a5c85c97cb3127ULL;\x0a"
"  static const _Size __k1 = 0xb492b66fbe98f273ULL;\x0a"
"  static const _Size __k2 = 0x9ae16a3b2f90404fULL;\x0a"
"  static const _Size __k3 = 0xc949d7c7509e6557ULL;\x0a"
"\x0a"
"  static _Size __rotate(_Size __val, int __shift) {\x0a"
"    return __shift == 0 \x3f __val \x3a ((__val >> __shift) \x7c (__val << (64 - __shift)));\x0a"
"  }\x0a"
"\x0a"
"  static _Size __rotate_by_at_least_1(_Size __val, int __shift) {\x0a"
"    return (__val >> __shift) \x7c (__val << (64 - __shift));\x0a"
"  }\x0a"
"\x0a"
"  static _Size __shift_mix(_Size __val) {\x0a"
"    return __val ^ (__val >> 47);\x0a"
"  }\x0a"
"\x0a"
"  static _Size __hash_len_16(_Size __u, _Size __v)\x0a"
"     _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"  {\x0a"
"    const _Size __mul = 0x9ddfea08eb382d69ULL;\x0a"
"    _Size __a = (__u ^ __v) * __mul;\x0a"
"    __a ^= (__a >> 47);\x0a"
"    _Size __b = (__v ^ __a) * __mul;\x0a"
"    __b ^= (__b >> 47);\x0a"
"    __b *= __mul;\x0a"
"    return __b;\x0a"
"  }\x0a"
"\x0a"
"  static _Size __hash_len_0_to_16(const char* __s, _Size __len)\x0a"
"     _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"  {\x0a"
"    if (__len > 8) {\x0a"
"      const _Size __a = __loadword<_Size>(__s);\x0a"
"      const _Size __b = __loadword<_Size>(__s + __len - 8);\x0a"
"      return __hash_len_16(__a, __rotate_by_at_least_1(__b + __len, __len)) ^ __b;\x0a"
"    }\x0a"
"    if (__len >= 4) {\x0a"
"      const uint32_t __a = __loadword<uint32_t>(__s);\x0a"
"      const uint32_t __b = __loadword<uint32_t>(__s + __len - 4);\x0a"
"      return __hash_len_16(__len + (__a << 3), __b);\x0a"
"    }\x0a"
"    if (__len > 0) {\x0a"
"      const unsigned char __a = __s\x5b""0\x5d;\x0a"
"      const unsigned char __b = __s\x5b__len >> 1\x5d;\x0a"
"      const unsigned char __c = __s\x5b__len - 1\x5d;\x0a"
"      const uint32_t __y = static_cast<uint32_t>(__a) +\x0a"
"                           (static_cast<uint32_t>(__b) << 8);\x0a"
"      const uint32_t __z = __len + (static_cast<uint32_t>(__c) << 2);\x0a"
"      return __shift_mix(__y * __k2 ^ __z * __k3) * __k2;\x0a"
"    }\x0a"
"    return __k2;\x0a"
"  }\x0a"
"\x0a"
"  static _Size __hash_len_17_to_32(const char *__s, _Size __len)\x0a"
"     _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"  {\x0a"
"    const _Size __a = __loadword<_Size>(__s) * __k1;\x0a"
"    const _Size __b = __loadword<_Size>(__s + 8);\x0a"
"    const _Size __c = __loadword<_Size>(__s + __len - 8) * __k2;\x0a"
"    const _Size __d = __loadword<_Size>(__s + __len - 16) * __k0;\x0a"
"    return __hash_len_16(__rotate(__a - __b, 43) + __rotate(__c, 30) + __d,\x0a"
"                         __a + __rotate(__b ^ __k3, 20) - __c + __len);\x0a"
"  }\x0a"
"\x0a"
"  // Return a 16-byte hash for 48 bytes.  Quick and dirty.\x0a"
"  // Callers do best to use \x22random-looking\x22 values for a and b.\x0a"
"  static pair<_Size, _Size> __weak_hash_len_32_with_seeds(\x0a"
"      _Size __w, _Size __x, _Size __y, _Size __z, _Size __a, _Size __b)\x0a"
"        _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"  {\x0a"
"    __a += __w;\x0a"
"    __b = __rotate(__b + __a + __z, 21);\x0a"
"    const _Size __c = __a;\x0a"
"    __a += __x;\x0a"
"    __a += __y;\x0a"
"    __b += __rotate(__a, 44);\x0a"
"    return pair<_Size, _Size>(__a + __z, __b + __c);\x0a"
"  }\x0a"
"\x0a"
"  // Return a 16-byte hash for s\x5b""0\x5d ... s\x5b""31\x5d, a, and b.  Quick and dirty.\x0a"
"  static pair<_Size, _Size> __weak_hash_len_32_with_seeds(\x0a"
"      const char* __s, _Size __a, _Size __b)\x0a"
"    _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"  {\x0a"
"    return __weak_hash_len_32_with_seeds(__loadword<_Size>(__s),\x0a"
"                                         __loadword<_Size>(__s + 8),\x0a"
"                                         __loadword<_Size>(__s + 16),\x0a"
"                                         __loadword<_Size>(__s + 24),\x0a"
"                                         __a,\x0a"
"                                         __b);\x0a"
"  }\x0a"
"\x0a"
"  // Return an 8-byte hash for 33 to 64 bytes.\x0a"
"  static _Size __hash_len_33_to_64(const char *__s, size_t __len)\x0a"
"    _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"  {\x0a"
"    _Size __z = __loadword<_Size>(__s + 24);\x0a"
"    _Size __a = __loadword<_Size>(__s) +\x0a"
"                (__len + __loadword<_Size>(__s + __len - 16)) * __k0;\x0a"
"    _Size __b = __rotate(__a + __z, 52);\x0a"
"    _Size __c = __rotate(__a, 37);\x0a"
"    __a += __loadword<_Size>(__s + 8);\x0a"
"    __c += __rotate(__a, 7);\x0a"
"    __a += __loadword<_Size>(__s + 16);\x0a"
"    _Size __vf = __a + __z;\x0a"
"    _Size __vs = __b + __rotate(__a, 31) + __c;\x0a"
"    __a = __loadword<_Size>(__s + 16) + __loadword<_Size>(__s + __len - 32);\x0a"
"    __z += __loadword<_Size>(__s + __len - 8);\x0a"
"    __b = __rotate(__a + __z, 52);\x0a"
"    __c = __rotate(__a, 37);\x0a"
"    __a += __loadword<_Size>(__s + __len - 24);\x0a"
"    __c += __rotate(__a, 7);\x0a"
"    __a += __loadword<_Size>(__s + __len - 16);\x0a"
"    _Size __wf = __a + __z;\x0a"
"    _Size __ws = __b + __rotate(__a, 31) + __c;\x0a"
"    _Size __r = __shift_mix((__vf + __ws) * __k2 + (__wf + __vs) * __k0);\x0a"
"    return __shift_mix(__r * __k0 + __vs) * __k2;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"// cityhash64\x0a"
"template <class _Size>\x0a"
"_Size\x0a"
"__murmur2_or_cityhash<_Size, 64>\x3a\x3aoperator()(const void* __key, _Size __len)\x0a"
"{\x0a"
"  const char* __s = static_cast<const char*>(__key);\x0a"
"  if (__len <= 32) {\x0a"
"    if (__len <= 16) {\x0a"
"      return __hash_len_0_to_16(__s, __len);\x0a"
"    } else {\x0a"
"      return __hash_len_17_to_32(__s, __len);\x0a"
"    }\x0a"
"  } else if (__len <= 64) {\x0a"
"    return __hash_len_33_to_64(__s, __len);\x0a"
"  }\x0a"
"\x0a"
"  // For strings over 64 bytes we hash the end first, and then as we\x0a"
"  // loop we keep 56 bytes of state\x3a v, w, x, y, and z.\x0a"
"  _Size __x = __loadword<_Size>(__s + __len - 40);\x0a"
"  _Size __y = __loadword<_Size>(__s + __len - 16) +\x0a"
"              __loadword<_Size>(__s + __len - 56);\x0a"
"  _Size __z = __hash_len_16(__loadword<_Size>(__s + __len - 48) + __len,\x0a"
"                          __loadword<_Size>(__s + __len - 24));\x0a"
"  pair<_Size, _Size> __v = __weak_hash_len_32_with_seeds(__s + __len - 64, __len, __z);\x0a"
"  pair<_Size, _Size> __w = __weak_hash_len_32_with_seeds(__s + __len - 32, __y + __k1, __x);\x0a"
"  __x = __x * __k1 + __loadword<_Size>(__s);\x0a"
"\x0a"
"  // Decrease len to the nearest multiple of 64, and operate on 64-byte chunks.\x0a"
"  __len = (__len - 1) \x26 \x7estatic_cast<_Size>(63);\x0a"
"  do {\x0a"
"    __x = __rotate(__x + __y + __v.first + __loadword<_Size>(__s + 8), 37) * __k1;\x0a"
"    __y = __rotate(__y + __v.second + __loadword<_Size>(__s + 48), 42) * __k1;\x0a"
"    __x ^= __w.second;\x0a"
"    __y += __v.first + __loadword<_Size>(__s + 40);\x0a"
"    __z = __rotate(__z + __w.first, 33) * __k1;\x0a"
"    __v = __weak_hash_len_32_with_seeds(__s, __v.second * __k1, __x + __w.first);\x0a"
"    __w = __weak_hash_len_32_with_seeds(__s + 32, __z + __w.second,\x0a"
"                                        __y + __loadword<_Size>(__s + 16));\x0a"
"    std\x3a\x3aswap(__z, __x);\x0a"
"    __s += 64;\x0a"
"    __len -= 64;\x0a"
"  } while (__len \x21= 0);\x0a"
"  return __hash_len_16(\x0a"
"      __hash_len_16(__v.first, __w.first) + __shift_mix(__y) * __k1 + __z,\x0a"
"      __hash_len_16(__v.second, __w.second) + __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, size_t = sizeof(_Tp) / sizeof(size_t)>\x0a"
"struct __scalar_hash;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __scalar_hash<_Tp, 0>\x0a"
"    \x3a public unary_function<_Tp, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(_Tp __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        union\x0a"
"        {\x0a"
"            _Tp    __t;\x0a"
"            size_t __a;\x0a"
"        } __u;\x0a"
"        __u.__a = 0;\x0a"
"        __u.__t = __v;\x0a"
"        return __u.__a;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __scalar_hash<_Tp, 1>\x0a"
"    \x3a public unary_function<_Tp, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(_Tp __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        union\x0a"
"        {\x0a"
"            _Tp    __t;\x0a"
"            size_t __a;\x0a"
"        } __u;\x0a"
"        __u.__t = __v;\x0a"
"        return __u.__a;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __scalar_hash<_Tp, 2>\x0a"
"    \x3a public unary_function<_Tp, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(_Tp __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        union\x0a"
"        {\x0a"
"            _Tp __t;\x0a"
"            struct\x0a"
"            {\x0a"
"                size_t __a;\x0a"
"                size_t __b;\x0a"
"            } __s;\x0a"
"        } __u;\x0a"
"        __u.__t = __v;\x0a"
"        return __murmur2_or_cityhash<size_t>()(\x26__u, sizeof(__u));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __scalar_hash<_Tp, 3>\x0a"
"    \x3a public unary_function<_Tp, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(_Tp __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        union\x0a"
"        {\x0a"
"            _Tp __t;\x0a"
"            struct\x0a"
"            {\x0a"
"                size_t __a;\x0a"
"                size_t __b;\x0a"
"                size_t __c;\x0a"
"            } __s;\x0a"
"        } __u;\x0a"
"        __u.__t = __v;\x0a"
"        return __murmur2_or_cityhash<size_t>()(\x26__u, sizeof(__u));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __scalar_hash<_Tp, 4>\x0a"
"    \x3a public unary_function<_Tp, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(_Tp __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        union\x0a"
"        {\x0a"
"            _Tp __t;\x0a"
"            struct\x0a"
"            {\x0a"
"                size_t __a;\x0a"
"                size_t __b;\x0a"
"                size_t __c;\x0a"
"                size_t __d;\x0a"
"            } __s;\x0a"
"        } __u;\x0a"
"        __u.__t = __v;\x0a"
"        return __murmur2_or_cityhash<size_t>()(\x26__u, sizeof(__u));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"struct _PairT {\x0a"
"  size_t first;\x0a"
"  size_t second;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline size_t __hash_combine(size_t __lhs, size_t __rhs) _NOEXCEPT {\x0a"
"    typedef __scalar_hash<_PairT> _HashT;\x0a"
"    const _PairT __p = {__lhs, __rhs};\x0a"
"    return _HashT()(__p);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<_Tp*>\x0a"
"    \x3a public unary_function<_Tp*, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(_Tp* __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        union\x0a"
"        {\x0a"
"            _Tp* __t;\x0a"
"            size_t __a;\x0a"
"        } __u;\x0a"
"        __u.__t = __v;\x0a"
"        return __murmur2_or_cityhash<size_t>()(\x26__u, sizeof(__u));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<bool>\x0a"
"    \x3a public unary_function<bool, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(bool __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<char>\x0a"
"    \x3a public unary_function<char, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(char __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<signed char>\x0a"
"    \x3a public unary_function<signed char, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(signed char __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<unsigned char>\x0a"
"    \x3a public unary_function<unsigned char, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(unsigned char __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<char16_t>\x0a"
"    \x3a public unary_function<char16_t, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(char16_t __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<char32_t>\x0a"
"    \x3a public unary_function<char32_t, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(char32_t __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<wchar_t>\x0a"
"    \x3a public unary_function<wchar_t, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(wchar_t __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<short>\x0a"
"    \x3a public unary_function<short, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(short __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<unsigned short>\x0a"
"    \x3a public unary_function<unsigned short, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(unsigned short __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<int>\x0a"
"    \x3a public unary_function<int, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(int __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<unsigned int>\x0a"
"    \x3a public unary_function<unsigned int, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(unsigned int __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<long>\x0a"
"    \x3a public unary_function<long, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(long __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<unsigned long>\x0a"
"    \x3a public unary_function<unsigned long, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(unsigned long __v) const _NOEXCEPT {return static_cast<size_t>(__v);}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<long long>\x0a"
"    \x3a public __scalar_hash<long long>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<unsigned long long>\x0a"
"    \x3a public __scalar_hash<unsigned long long>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_INT128\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<__int128_t>\x0a"
"    \x3a public __scalar_hash<__int128_t>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<__uint128_t>\x0a"
"    \x3a public __scalar_hash<__uint128_t>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<float>\x0a"
"    \x3a public __scalar_hash<float>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(float __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        // -0.0 and 0.0 should return same hash\x0a"
"       if (__v == 0.0f)\x0a"
"           return 0;\x0a"
"        return __scalar_hash<float>\x3a\x3aoperator()(__v);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<double>\x0a"
"    \x3a public __scalar_hash<double>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(double __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        // -0.0 and 0.0 should return same hash\x0a"
"       if (__v == 0.0)\x0a"
"           return 0;\x0a"
"        return __scalar_hash<double>\x3a\x3aoperator()(__v);\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<long double>\x0a"
"    \x3a public __scalar_hash<long double>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(long double __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        // -0.0 and 0.0 should return same hash\x0a"
"        if (__v == 0.0L)\x0a"
"            return 0;\x0a"
"#if defined(__i386__)\x0a"
"        // Zero out padding bits\x0a"
"        union\x0a"
"        {\x0a"
"            long double __t;\x0a"
"            struct\x0a"
"            {\x0a"
"                size_t __a;\x0a"
"                size_t __b;\x0a"
"                size_t __c;\x0a"
"                size_t __d;\x0a"
"            } __s;\x0a"
"        } __u;\x0a"
"        __u.__s.__a = 0;\x0a"
"        __u.__s.__b = 0;\x0a"
"        __u.__s.__c = 0;\x0a"
"        __u.__s.__d = 0;\x0a"
"        __u.__t = __v;\x0a"
"        return __u.__s.__a ^ __u.__s.__b ^ __u.__s.__c ^ __u.__s.__d;\x0a"
"#elif defined(__x86_64__)\x0a"
"        // Zero out padding bits\x0a"
"        union\x0a"
"        {\x0a"
"            long double __t;\x0a"
"            struct\x0a"
"            {\x0a"
"                size_t __a;\x0a"
"                size_t __b;\x0a"
"            } __s;\x0a"
"        } __u;\x0a"
"        __u.__s.__a = 0;\x0a"
"        __u.__s.__b = 0;\x0a"
"        __u.__t = __v;\x0a"
"        return __u.__s.__a ^ __u.__s.__b;\x0a"
"#else\x0a"
"        return __scalar_hash<long double>\x3a\x3aoperator()(__v);\x0a"
"#endif\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"template <class _Tp, bool = is_enum<_Tp>\x3a\x3avalue>\x0a"
"struct _LIBCPP_TEMPLATE_VIS __enum_hash\x0a"
"    \x3a public unary_function<_Tp, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(_Tp __v) const _NOEXCEPT\x0a"
"    {\x0a"
"        typedef typename underlying_type<_Tp>\x3a\x3atype type;\x0a"
"        return hash<type>{}(static_cast<type>(__v));\x0a"
"    }\x0a"
"};\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS __enum_hash<_Tp, false> {\x0a"
"    __enum_hash() = delete;\x0a"
"    __enum_hash(__enum_hash const\x26) = delete;\x0a"
"    __enum_hash\x26 operator=(__enum_hash const\x26) = delete;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash \x3a public __enum_hash<_Tp>\x0a"
"{\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<nullptr_t>\x0a"
"  \x3a public unary_function<nullptr_t, size_t>\x0a"
"{\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  size_t operator()(nullptr_t) const _NOEXCEPT {\x0a"
"    return 662607004ull;\x0a"
"  }\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Key, class _Hash>\x0a"
"using __check_hash_requirements _LIBCPP_NODEBUG_TYPE  = integral_constant<bool,\x0a"
"    is_copy_constructible<_Hash>\x3a\x3avalue \x26\x26\x0a"
"    is_move_constructible<_Hash>\x3a\x3avalue \x26\x26\x0a"
"    __invokable_r<size_t, _Hash, _Key const\x26>\x3a\x3avalue\x0a"
">;\x0a"
"\x0a"
"template <class _Key, class _Hash = std\x3a\x3ahash<_Key> >\x0a"
"using __has_enabled_hash _LIBCPP_NODEBUG_TYPE = integral_constant<bool,\x0a"
"    __check_hash_requirements<_Key, _Hash>\x3a\x3avalue \x26\x26\x0a"
"    is_default_constructible<_Hash>\x3a\x3avalue\x0a"
">;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _Type, class>\x0a"
"using __enable_hash_helper_imp _LIBCPP_NODEBUG_TYPE  = _Type;\x0a"
"\x0a"
"template <class _Type, class ..._Keys>\x0a"
"using __enable_hash_helper _LIBCPP_NODEBUG_TYPE  = __enable_hash_helper_imp<_Type,\x0a"
"  typename enable_if<__all<__has_enabled_hash<_Keys>\x3a\x3avalue...>\x3a\x3avalue>\x3a\x3atype\x0a"
">;\x0a"
"#else\x0a"
"template <class _Type, class ...>\x0a"
"using __enable_hash_helper _LIBCPP_NODEBUG_TYPE = _Type;\x0a"
"#endif\x0a"
"\x0a"
"#endif // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif  // _LIBCPP_UTILITY\x0a"
"", 49230 ); }