#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_variant( 
"// -*- C++ -*-\x0a"
"//===------------------------------ variant -------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_VARIANT\x0a"
"#define _LIBCPP_VARIANT\x0a"
"\x0a"
"/*\x0a"
"   variant synopsis\x0a"
"\x0a"
"namespace std {\x0a"
"\x0a"
"  // 20.7.2, class template variant\x0a"
"  template <class... Types>\x0a"
"  class variant {\x0a"
"  public\x3a\x0a"
"\x0a"
"    // 20.7.2.1, constructors\x0a"
"    constexpr variant() noexcept(see below);\x0a"
"    variant(const variant\x26);                // constexpr in C++20\x0a"
"    variant(variant\x26\x26) noexcept(see below); // constexpr in C++20\x0a"
"\x0a"
"    template <class T> constexpr variant(T\x26\x26) noexcept(see below);\x0a"
"\x0a"
"    template <class T, class... Args>\x0a"
"    constexpr explicit variant(in_place_type_t<T>, Args\x26\x26...);\x0a"
"\x0a"
"    template <class T, class U, class... Args>\x0a"
"    constexpr explicit variant(\x0a"
"        in_place_type_t<T>, initializer_list<U>, Args\x26\x26...);\x0a"
"\x0a"
"    template <size_t I, class... Args>\x0a"
"    constexpr explicit variant(in_place_index_t<I>, Args\x26\x26...);\x0a"
"\x0a"
"    template <size_t I, class U, class... Args>\x0a"
"    constexpr explicit variant(\x0a"
"        in_place_index_t<I>, initializer_list<U>, Args\x26\x26...);\x0a"
"\x0a"
"    // 20.7.2.2, destructor\x0a"
"    \x7evariant();\x0a"
"\x0a"
"    // 20.7.2.3, assignment\x0a"
"    variant\x26 operator=(const variant\x26);                // constexpr in C++20\x0a"
"    variant\x26 operator=(variant\x26\x26) noexcept(see below); // constexpr in C++20\x0a"
"\x0a"
"    template <class T> variant\x26 operator=(T\x26\x26) noexcept(see below);\x0a"
"\x0a"
"    // 20.7.2.4, modifiers\x0a"
"    template <class T, class... Args>\x0a"
"    T\x26 emplace(Args\x26\x26...);\x0a"
"\x0a"
"    template <class T, class U, class... Args>\x0a"
"    T\x26 emplace(initializer_list<U>, Args\x26\x26...);\x0a"
"\x0a"
"    template <size_t I, class... Args>\x0a"
"    variant_alternative_t<I, variant>\x26 emplace(Args\x26\x26...);\x0a"
"\x0a"
"    template <size_t I, class U, class...  Args>\x0a"
"    variant_alternative_t<I, variant>\x26 emplace(initializer_list<U>, Args\x26\x26...);\x0a"
"\x0a"
"    // 20.7.2.5, value status\x0a"
"    constexpr bool valueless_by_exception() const noexcept;\x0a"
"    constexpr size_t index() const noexcept;\x0a"
"\x0a"
"    // 20.7.2.6, swap\x0a"
"    void swap(variant\x26) noexcept(see below);\x0a"
"  };\x0a"
"\x0a"
"  // 20.7.3, variant helper classes\x0a"
"  template <class T> struct variant_size; // undefined\x0a"
"\x0a"
"  template <class T>\x0a"
"  inline constexpr size_t variant_size_v = variant_size<T>\x3a\x3avalue;\x0a"
"\x0a"
"  template <class T> struct variant_size<const T>;\x0a"
"  template <class T> struct variant_size<volatile T>;\x0a"
"  template <class T> struct variant_size<const volatile T>;\x0a"
"\x0a"
"  template <class... Types>\x0a"
"  struct variant_size<variant<Types...>>;\x0a"
"\x0a"
"  template <size_t I, class T> struct variant_alternative; // undefined\x0a"
"\x0a"
"  template <size_t I, class T>\x0a"
"  using variant_alternative_t = typename variant_alternative<I, T>\x3a\x3atype;\x0a"
"\x0a"
"  template <size_t I, class T> struct variant_alternative<I, const T>;\x0a"
"  template <size_t I, class T> struct variant_alternative<I, volatile T>;\x0a"
"  template <size_t I, class T> struct variant_alternative<I, const volatile T>;\x0a"
"\x0a"
"  template <size_t I, class... Types>\x0a"
"  struct variant_alternative<I, variant<Types...>>;\x0a"
"\x0a"
"  inline constexpr size_t variant_npos = -1;\x0a"
"\x0a"
"  // 20.7.4, value access\x0a"
"  template <class T, class... Types>\x0a"
"  constexpr bool holds_alternative(const variant<Types...>\x26) noexcept;\x0a"
"\x0a"
"  template <size_t I, class... Types>\x0a"
"  constexpr variant_alternative_t<I, variant<Types...>>\x26\x0a"
"  get(variant<Types...>\x26);\x0a"
"\x0a"
"  template <size_t I, class... Types>\x0a"
"  constexpr variant_alternative_t<I, variant<Types...>>\x26\x26\x0a"
"  get(variant<Types...>\x26\x26);\x0a"
"\x0a"
"  template <size_t I, class... Types>\x0a"
"  constexpr variant_alternative_t<I, variant<Types...>> const\x26\x0a"
"  get(const variant<Types...>\x26);\x0a"
"\x0a"
"  template <size_t I, class... Types>\x0a"
"  constexpr variant_alternative_t<I, variant<Types...>> const\x26\x26\x0a"
"  get(const variant<Types...>\x26\x26);\x0a"
"\x0a"
"  template <class T, class...  Types>\x0a"
"  constexpr T\x26 get(variant<Types...>\x26);\x0a"
"\x0a"
"  template <class T, class... Types>\x0a"
"  constexpr T\x26\x26 get(variant<Types...>\x26\x26);\x0a"
"\x0a"
"  template <class T, class... Types>\x0a"
"  constexpr const T\x26 get(const variant<Types...>\x26);\x0a"
"\x0a"
"  template <class T, class... Types>\x0a"
"  constexpr const T\x26\x26 get(const variant<Types...>\x26\x26);\x0a"
"\x0a"
"  template <size_t I, class... Types>\x0a"
"  constexpr add_pointer_t<variant_alternative_t<I, variant<Types...>>>\x0a"
"  get_if(variant<Types...>*) noexcept;\x0a"
"\x0a"
"  template <size_t I, class... Types>\x0a"
"  constexpr add_pointer_t<const variant_alternative_t<I, variant<Types...>>>\x0a"
"  get_if(const variant<Types...>*) noexcept;\x0a"
"\x0a"
"  template <class T, class... Types>\x0a"
"  constexpr add_pointer_t<T>\x0a"
"  get_if(variant<Types...>*) noexcept;\x0a"
"\x0a"
"  template <class T, class... Types>\x0a"
"  constexpr add_pointer_t<const T>\x0a"
"  get_if(const variant<Types...>*) noexcept;\x0a"
"\x0a"
"  // 20.7.5, relational operators\x0a"
"  template <class... Types>\x0a"
"  constexpr bool operator==(const variant<Types...>\x26, const variant<Types...>\x26);\x0a"
"\x0a"
"  template <class... Types>\x0a"
"  constexpr bool operator\x21=(const variant<Types...>\x26, const variant<Types...>\x26);\x0a"
"\x0a"
"  template <class... Types>\x0a"
"  constexpr bool operator<(const variant<Types...>\x26, const variant<Types...>\x26);\x0a"
"\x0a"
"  template <class... Types>\x0a"
"  constexpr bool operator>(const variant<Types...>\x26, const variant<Types...>\x26);\x0a"
"\x0a"
"  template <class... Types>\x0a"
"  constexpr bool operator<=(const variant<Types...>\x26, const variant<Types...>\x26);\x0a"
"\x0a"
"  template <class... Types>\x0a"
"  constexpr bool operator>=(const variant<Types...>\x26, const variant<Types...>\x26);\x0a"
"\x0a"
"  // 20.7.6, visitation\x0a"
"  template <class Visitor, class... Variants>\x0a"
"  constexpr see below visit(Visitor\x26\x26, Variants\x26\x26...);\x0a"
"\x0a"
"  // 20.7.7, class monostate\x0a"
"  struct monostate;\x0a"
"\x0a"
"  // 20.7.8, monostate relational operators\x0a"
"  constexpr bool operator<(monostate, monostate) noexcept;\x0a"
"  constexpr bool operator>(monostate, monostate) noexcept;\x0a"
"  constexpr bool operator<=(monostate, monostate) noexcept;\x0a"
"  constexpr bool operator>=(monostate, monostate) noexcept;\x0a"
"  constexpr bool operator==(monostate, monostate) noexcept;\x0a"
"  constexpr bool operator\x21=(monostate, monostate) noexcept;\x0a"
"\x0a"
"  // 20.7.9, specialized algorithms\x0a"
"  template <class... Types>\x0a"
"  void swap(variant<Types...>\x26, variant<Types...>\x26) noexcept(see below);\x0a"
"\x0a"
"  // 20.7.10, class bad_variant_access\x0a"
"  class bad_variant_access;\x0a"
"\x0a"
"  // 20.7.11, hash support\x0a"
"  template <class T> struct hash;\x0a"
"  template <class... Types> struct hash<variant<Types...>>;\x0a"
"  template <> struct hash<monostate>;\x0a"
"\x0a"
"} // namespace std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__tuple>\x0a"
"#include <array>\x0a"
"#include <exception>\x0a"
"#include <functional>\x0a"
"#include <initializer_list>\x0a"
"#include <new>\x0a"
"#include <tuple>\x0a"
"#include <type_traits>\x0a"
"#include <utility>\x0a"
"#include <limits>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"namespace std { // explicitly not using versioning namespace\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI _LIBCPP_AVAILABILITY_BAD_VARIANT_ACCESS bad_variant_access \x3a public exception {\x0a"
"public\x3a\x0a"
"  virtual const char* what() const _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"} // namespace std\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"_LIBCPP_NORETURN\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"void __throw_bad_variant_access() {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        throw bad_variant_access();\x0a"
"#else\x0a"
"        _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class... _Types>\x0a"
"class _LIBCPP_TEMPLATE_VIS variant;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS variant_size;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr size_t variant_size_v = variant_size<_Tp>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS variant_size<const _Tp> \x3a variant_size<_Tp> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS variant_size<volatile _Tp> \x3a variant_size<_Tp> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS variant_size<const volatile _Tp>\x0a"
"    \x3a variant_size<_Tp> {};\x0a"
"\x0a"
"template <class... _Types>\x0a"
"struct _LIBCPP_TEMPLATE_VIS variant_size<variant<_Types...>>\x0a"
"    \x3a integral_constant<size_t, sizeof...(_Types)> {};\x0a"
"\x0a"
"template <size_t _Ip, class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS variant_alternative;\x0a"
"\x0a"
"template <size_t _Ip, class _Tp>\x0a"
"using variant_alternative_t = typename variant_alternative<_Ip, _Tp>\x3a\x3atype;\x0a"
"\x0a"
"template <size_t _Ip, class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS variant_alternative<_Ip, const _Tp>\x0a"
"    \x3a add_const<variant_alternative_t<_Ip, _Tp>> {};\x0a"
"\x0a"
"template <size_t _Ip, class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS variant_alternative<_Ip, volatile _Tp>\x0a"
"    \x3a add_volatile<variant_alternative_t<_Ip, _Tp>> {};\x0a"
"\x0a"
"template <size_t _Ip, class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS variant_alternative<_Ip, const volatile _Tp>\x0a"
"    \x3a add_cv<variant_alternative_t<_Ip, _Tp>> {};\x0a"
"\x0a"
"template <size_t _Ip, class... _Types>\x0a"
"struct _LIBCPP_TEMPLATE_VIS variant_alternative<_Ip, variant<_Types...>> {\x0a"
"  static_assert(_Ip < sizeof...(_Types), \x22Index out of bounds in std\x3a\x3avariant_alternative<>\x22);\x0a"
"  using type = __type_pack_element<_Ip, _Types...>;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_INLINE_VAR constexpr size_t variant_npos = static_cast<size_t>(-1);\x0a"
"\x0a"
"constexpr int __choose_index_type(unsigned int __num_elem) {\x0a"
"  if (__num_elem < std\x3a\x3anumeric_limits<unsigned char>\x3a\x3amax())\x0a"
"    return 0;\x0a"
"  if (__num_elem < std\x3a\x3anumeric_limits<unsigned short>\x3a\x3amax())\x0a"
"    return 1;\x0a"
"  return 2;\x0a"
"}\x0a"
"\x0a"
"template <size_t _NumAlts>\x0a"
"using __variant_index_t =\x0a"
"#ifndef _LIBCPP_ABI_VARIANT_INDEX_TYPE_OPTIMIZATION\x0a"
"  unsigned int;\x0a"
"#else\x0a"
"  std\x3a\x3atuple_element_t<\x0a"
"      __choose_index_type(_NumAlts),\x0a"
"      std\x3a\x3atuple<unsigned char, unsigned short, unsigned int>\x0a"
"  >;\x0a"
"#endif\x0a"
"\x0a"
"template <class _IndexType>\x0a"
"constexpr _IndexType __variant_npos = static_cast<_IndexType>(-1);\x0a"
"\x0a"
"namespace __find_detail {\x0a"
"\x0a"
"template <class _Tp, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr size_t __find_index() {\x0a"
"  constexpr bool __matches\x5b\x5d = {is_same_v<_Tp, _Types>...};\x0a"
"  size_t __result = __not_found;\x0a"
"  for (size_t __i = 0; __i < sizeof...(_Types); ++__i) {\x0a"
"    if (__matches\x5b__i\x5d) {\x0a"
"      if (__result \x21= __not_found) {\x0a"
"        return __ambiguous;\x0a"
"      }\x0a"
"      __result = __i;\x0a"
"    }\x0a"
"  }\x0a"
"  return __result;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Index>\x0a"
"struct __find_unambiguous_index_sfinae_impl\x0a"
"    \x3a integral_constant<size_t, _Index> {};\x0a"
"\x0a"
"template <>\x0a"
"struct __find_unambiguous_index_sfinae_impl<__not_found> {};\x0a"
"\x0a"
"template <>\x0a"
"struct __find_unambiguous_index_sfinae_impl<__ambiguous> {};\x0a"
"\x0a"
"template <class _Tp, class... _Types>\x0a"
"struct __find_unambiguous_index_sfinae\x0a"
"    \x3a __find_unambiguous_index_sfinae_impl<__find_index<_Tp, _Types...>()> {};\x0a"
"\x0a"
"} // namespace __find_detail\x0a"
"\x0a"
"namespace __variant_detail {\x0a"
"\x0a"
"struct __valueless_t {};\x0a"
"\x0a"
"enum class _Trait { _TriviallyAvailable, _Available, _Unavailable };\x0a"
"\x0a"
"template <typename _Tp,\x0a"
"          template <typename> class _IsTriviallyAvailable,\x0a"
"          template <typename> class _IsAvailable>\x0a"
"constexpr _Trait __trait =\x0a"
"    _IsTriviallyAvailable<_Tp>\x3a\x3avalue\x0a"
"        \x3f _Trait\x3a\x3a_TriviallyAvailable\x0a"
"        \x3a _IsAvailable<_Tp>\x3a\x3avalue \x3f _Trait\x3a\x3a_Available \x3a _Trait\x3a\x3a_Unavailable;\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr _Trait __common_trait(initializer_list<_Trait> __traits) {\x0a"
"  _Trait __result = _Trait\x3a\x3a_TriviallyAvailable;\x0a"
"  for (_Trait __t \x3a __traits) {\x0a"
"    if (static_cast<int>(__t) > static_cast<int>(__result)) {\x0a"
"      __result = __t;\x0a"
"    }\x0a"
"  }\x0a"
"  return __result;\x0a"
"}\x0a"
"\x0a"
"template <typename... _Types>\x0a"
"struct __traits {\x0a"
"  static constexpr _Trait __copy_constructible_trait =\x0a"
"      __common_trait({__trait<_Types,\x0a"
"                              is_trivially_copy_constructible,\x0a"
"                              is_copy_constructible>...});\x0a"
"\x0a"
"  static constexpr _Trait __move_constructible_trait =\x0a"
"      __common_trait({__trait<_Types,\x0a"
"                              is_trivially_move_constructible,\x0a"
"                              is_move_constructible>...});\x0a"
"\x0a"
"  static constexpr _Trait __copy_assignable_trait = __common_trait(\x0a"
"      {__copy_constructible_trait,\x0a"
"       __trait<_Types, is_trivially_copy_assignable, is_copy_assignable>...});\x0a"
"\x0a"
"  static constexpr _Trait __move_assignable_trait = __common_trait(\x0a"
"      {__move_constructible_trait,\x0a"
"       __trait<_Types, is_trivially_move_assignable, is_move_assignable>...});\x0a"
"\x0a"
"  static constexpr _Trait __destructible_trait = __common_trait(\x0a"
"      {__trait<_Types, is_trivially_destructible, is_destructible>...});\x0a"
"};\x0a"
"\x0a"
"namespace __access {\x0a"
"\x0a"
"struct __union {\x0a"
"  template <class _Vp>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto\x26\x26 __get_alt(_Vp\x26\x26 __v, in_place_index_t<0>) {\x0a"
"    return _VSTD\x3a\x3a""forward<_Vp>(__v).__head;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Vp, size_t _Ip>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto\x26\x26 __get_alt(_Vp\x26\x26 __v, in_place_index_t<_Ip>) {\x0a"
"    return __get_alt(_VSTD\x3a\x3a""forward<_Vp>(__v).__tail, in_place_index<_Ip - 1>);\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"struct __base {\x0a"
"  template <size_t _Ip, class _Vp>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto\x26\x26 __get_alt(_Vp\x26\x26 __v) {\x0a"
"    return __union\x3a\x3a__get_alt(_VSTD\x3a\x3a""forward<_Vp>(__v).__data,\x0a"
"                              in_place_index<_Ip>);\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"struct __variant {\x0a"
"  template <size_t _Ip, class _Vp>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto\x26\x26 __get_alt(_Vp\x26\x26 __v) {\x0a"
"    return __base\x3a\x3a__get_alt<_Ip>(_VSTD\x3a\x3a""forward<_Vp>(__v).__impl);\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"} // namespace __access\x0a"
"\x0a"
"namespace __visitation {\x0a"
"\x0a"
"struct __base {\x0a"
"  template <class _Visitor, class... _Vs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr decltype(auto)\x0a"
"  __visit_alt_at(size_t __index, _Visitor\x26\x26 __visitor, _Vs\x26\x26... __vs) {\x0a"
"    constexpr auto __fdiagonal =\x0a"
"        __make_fdiagonal<_Visitor\x26\x26,\x0a"
"                         decltype(_VSTD\x3a\x3a""forward<_Vs>(__vs).__as_base())...>();\x0a"
"    return __fdiagonal\x5b__index\x5d(_VSTD\x3a\x3a""forward<_Visitor>(__visitor),\x0a"
"                                _VSTD\x3a\x3a""forward<_Vs>(__vs).__as_base()...);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Visitor, class... _Vs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr decltype(auto) __visit_alt(_Visitor\x26\x26 __visitor,\x0a"
"                                              _Vs\x26\x26... __vs) {\x0a"
"    constexpr auto __fmatrix =\x0a"
"        __make_fmatrix<_Visitor\x26\x26,\x0a"
"                       decltype(_VSTD\x3a\x3a""forward<_Vs>(__vs).__as_base())...>();\x0a"
"    return __at(__fmatrix, __vs.index()...)(\x0a"
"        _VSTD\x3a\x3a""forward<_Visitor>(__visitor),\x0a"
"        _VSTD\x3a\x3a""forward<_Vs>(__vs).__as_base()...);\x0a"
"  }\x0a"
"\x0a"
"private\x3a\x0a"
"  template <class _Tp>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr const _Tp\x26 __at(const _Tp\x26 __elem) { return __elem; }\x0a"
"\x0a"
"  template <class _Tp, size_t _Np, typename... _Indices>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto\x26\x26 __at(const array<_Tp, _Np>\x26 __elems,\x0a"
"                               size_t __index, _Indices... __indices) {\x0a"
"    return __at(__elems\x5b__index\x5d, __indices...);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Fp, class... _Fs>\x0a"
"  static constexpr void __std_visit_visitor_return_type_check() {\x0a"
"    static_assert(\x0a"
"        __all<is_same_v<_Fp, _Fs>...>\x3a\x3avalue,\x0a"
"        \x22\x60std\x3a\x3avisit\x60 requires the visitor to have a single return type.\x22);\x0a"
"  }\x0a"
"\x0a"
"  template <class... _Fs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto __make_farray(_Fs\x26\x26... __fs) {\x0a"
"    __std_visit_visitor_return_type_check<__uncvref_t<_Fs>...>();\x0a"
"    using __result = array<common_type_t<__uncvref_t<_Fs>...>, sizeof...(_Fs)>;\x0a"
"    return __result{{_VSTD\x3a\x3a""forward<_Fs>(__fs)...}};\x0a"
"  }\x0a"
"\x0a"
"  template <std\x3a\x3asize_t... _Is>\x0a"
"  struct __dispatcher {\x0a"
"    template <class _Fp, class... _Vs>\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    static constexpr decltype(auto) __dispatch(_Fp __f, _Vs... __vs) {\x0a"
"        return __invoke_constexpr(\x0a"
"            static_cast<_Fp>(__f),\x0a"
"            __access\x3a\x3a__base\x3a\x3a__get_alt<_Is>(static_cast<_Vs>(__vs))...);\x0a"
"    }\x0a"
"  };\x0a"
"\x0a"
"  template <class _Fp, class... _Vs, size_t... _Is>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto __make_dispatch(index_sequence<_Is...>) {\x0a"
"    return __dispatcher<_Is...>\x3a\x3atemplate __dispatch<_Fp, _Vs...>;\x0a"
"  }\x0a"
"\x0a"
"  template <size_t _Ip, class _Fp, class... _Vs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto __make_fdiagonal_impl() {\x0a"
"    return __make_dispatch<_Fp, _Vs...>(\x0a"
"        index_sequence<(__identity<_Vs>{}, _Ip)...>{});\x0a"
"  }\x0a"
"\x0a"
"  template <class _Fp, class... _Vs, size_t... _Is>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto __make_fdiagonal_impl(index_sequence<_Is...>) {\x0a"
"    return __base\x3a\x3a__make_farray(__make_fdiagonal_impl<_Is, _Fp, _Vs...>()...);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Fp, class _Vp, class... _Vs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto __make_fdiagonal() {\x0a"
"    constexpr size_t _Np = __uncvref_t<_Vp>\x3a\x3a__size();\x0a"
"    static_assert(__all<(_Np == __uncvref_t<_Vs>\x3a\x3a__size())...>\x3a\x3avalue);\x0a"
"    return __make_fdiagonal_impl<_Fp, _Vp, _Vs...>(make_index_sequence<_Np>{});\x0a"
"  }\x0a"
"\x0a"
"  template <class _Fp, class... _Vs, size_t... _Is>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto __make_fmatrix_impl(index_sequence<_Is...> __is) {\x0a"
"    return __make_dispatch<_Fp, _Vs...>(__is);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Fp, class... _Vs, size_t... _Is, size_t... _Js, class... _Ls>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto __make_fmatrix_impl(index_sequence<_Is...>,\x0a"
"                                            index_sequence<_Js...>,\x0a"
"                                            _Ls... __ls) {\x0a"
"    return __base\x3a\x3a__make_farray(__make_fmatrix_impl<_Fp, _Vs...>(\x0a"
"        index_sequence<_Is..., _Js>{}, __ls...)...);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Fp, class... _Vs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto __make_fmatrix() {\x0a"
"    return __make_fmatrix_impl<_Fp, _Vs...>(\x0a"
"        index_sequence<>{}, make_index_sequence<__uncvref_t<_Vs>\x3a\x3a__size()>{}...);\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"struct __variant {\x0a"
"  template <class _Visitor, class... _Vs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr decltype(auto)\x0a"
"  __visit_alt_at(size_t __index, _Visitor\x26\x26 __visitor, _Vs\x26\x26... __vs) {\x0a"
"    return __base\x3a\x3a__visit_alt_at(__index,\x0a"
"                                  _VSTD\x3a\x3a""forward<_Visitor>(__visitor),\x0a"
"                                  _VSTD\x3a\x3a""forward<_Vs>(__vs).__impl...);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Visitor, class... _Vs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr decltype(auto) __visit_alt(_Visitor\x26\x26 __visitor,\x0a"
"                                              _Vs\x26\x26... __vs) {\x0a"
"    return __base\x3a\x3a__visit_alt(_VSTD\x3a\x3a""forward<_Visitor>(__visitor),\x0a"
"                               _VSTD\x3a\x3a""forward<_Vs>(__vs).__impl...);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Visitor, class... _Vs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr decltype(auto)\x0a"
"  __visit_value_at(size_t __index, _Visitor\x26\x26 __visitor, _Vs\x26\x26... __vs) {\x0a"
"    return __visit_alt_at(\x0a"
"        __index,\x0a"
"        __make_value_visitor(_VSTD\x3a\x3a""forward<_Visitor>(__visitor)),\x0a"
"        _VSTD\x3a\x3a""forward<_Vs>(__vs)...);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Visitor, class... _Vs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr decltype(auto) __visit_value(_Visitor\x26\x26 __visitor,\x0a"
"                                                _Vs\x26\x26... __vs) {\x0a"
"    return __visit_alt(\x0a"
"        __make_value_visitor(_VSTD\x3a\x3a""forward<_Visitor>(__visitor)),\x0a"
"        _VSTD\x3a\x3a""forward<_Vs>(__vs)...);\x0a"
"  }\x0a"
"\x0a"
"private\x3a\x0a"
"  template <class _Visitor, class... _Values>\x0a"
"  static constexpr void __std_visit_exhaustive_visitor_check() {\x0a"
"    static_assert(is_invocable_v<_Visitor, _Values...>,\x0a"
"                  \x22\x60std\x3a\x3avisit\x60 requires the visitor to be exhaustive.\x22);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Visitor>\x0a"
"  struct __value_visitor {\x0a"
"    template <class... _Alts>\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr decltype(auto) operator()(_Alts\x26\x26... __alts) const {\x0a"
"      __std_visit_exhaustive_visitor_check<\x0a"
"          _Visitor,\x0a"
"          decltype((_VSTD\x3a\x3a""forward<_Alts>(__alts).__value))...>();\x0a"
"      return __invoke_constexpr(_VSTD\x3a\x3a""forward<_Visitor>(__visitor),\x0a"
"                                _VSTD\x3a\x3a""forward<_Alts>(__alts).__value...);\x0a"
"    }\x0a"
"    _Visitor\x26\x26 __visitor;\x0a"
"  };\x0a"
"\x0a"
"  template <class _Visitor>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr auto __make_value_visitor(_Visitor\x26\x26 __visitor) {\x0a"
"    return __value_visitor<_Visitor>{_VSTD\x3a\x3a""forward<_Visitor>(__visitor)};\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"} // namespace __visitation\x0a"
"\x0a"
"template <size_t _Index, class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS __alt {\x0a"
"  using __value_type = _Tp;\x0a"
"\x0a"
"  template <class... _Args>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr __alt(in_place_t, _Args\x26\x26... __args)\x0a"
"      \x3a __value(_VSTD\x3a\x3a""forward<_Args>(__args)...) {}\x0a"
"\x0a"
"  __value_type __value;\x0a"
"};\x0a"
"\x0a"
"template <_Trait _DestructibleTrait, size_t _Index, class... _Types>\x0a"
"union _LIBCPP_TEMPLATE_VIS __union;\x0a"
"\x0a"
"template <_Trait _DestructibleTrait, size_t _Index>\x0a"
"union _LIBCPP_TEMPLATE_VIS __union<_DestructibleTrait, _Index> {};\x0a"
"\x0a"
"#define _LIBCPP_VARIANT_UNION(destructible_trait, destructor)                  \x5c\x0a"
"  template <size_t _Index, class _Tp, class... _Types>                         \x5c\x0a"
"  union _LIBCPP_TEMPLATE_VIS __union<destructible_trait,                      \x5c\x0a"
"                                      _Index,                                  \x5c\x0a"
"                                      _Tp,                                     \x5c\x0a"
"                                      _Types...> {                             \x5c\x0a"
"  public\x3a                                                                      \x5c\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY                                           \x5c\x0a"
"    explicit constexpr __union(__valueless_t) noexcept \x3a __dummy{} {}          \x5c\x0a"
"                                                                               \x5c\x0a"
"    template <class... _Args>                                                  \x5c\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY                                           \x5c\x0a"
"    explicit constexpr __union(in_place_index_t<0>, _Args\x26\x26... __args)         \x5c\x0a"
"        \x3a __head(in_place, _VSTD\x3a\x3a""forward<_Args>(__args)...) {}                \x5c\x0a"
"                                                                               \x5c\x0a"
"    template <size_t _Ip, class... _Args>                                      \x5c\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY                                           \x5c\x0a"
"    explicit constexpr __union(in_place_index_t<_Ip>, _Args\x26\x26... __args)       \x5c\x0a"
"        \x3a __tail(in_place_index<_Ip - 1>, _VSTD\x3a\x3a""forward<_Args>(__args)...) {} \x5c\x0a"
"                                                                               \x5c\x0a"
"    __union(const __union\x26) = default;                                         \x5c\x0a"
"    __union(__union\x26\x26) = default;                                              \x5c\x0a"
"                                                                               \x5c\x0a"
"    destructor                                                                 \x5c\x0a"
"                                                                               \x5c\x0a"
"    __union\x26 operator=(const __union\x26) = default;                              \x5c\x0a"
"    __union\x26 operator=(__union\x26\x26) = default;                                   \x5c\x0a"
"                                                                               \x5c\x0a"
"  private\x3a                                                                     \x5c\x0a"
"    char __dummy;                                                              \x5c\x0a"
"    __alt<_Index, _Tp> __head;                                                 \x5c\x0a"
"    __union<destructible_trait, _Index + 1, _Types...> __tail;                 \x5c\x0a"
"                                                                               \x5c\x0a"
"    friend struct __access\x3a\x3a__union;                                           \x5c\x0a"
"  }\x0a"
"\x0a"
"_LIBCPP_VARIANT_UNION(_Trait\x3a\x3a_TriviallyAvailable, \x7e__union() = default;);\x0a"
"_LIBCPP_VARIANT_UNION(_Trait\x3a\x3a_Available, \x7e__union() {});\x0a"
"_LIBCPP_VARIANT_UNION(_Trait\x3a\x3a_Unavailable, \x7e__union() = delete;);\x0a"
"\x0a"
"#undef _LIBCPP_VARIANT_UNION\x0a"
"\x0a"
"template <_Trait _DestructibleTrait, class... _Types>\x0a"
"class _LIBCPP_TEMPLATE_VIS __base {\x0a"
"public\x3a\x0a"
"  using __index_t = __variant_index_t<sizeof...(_Types)>;\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr __base(__valueless_t tag) noexcept\x0a"
"      \x3a __data(tag), __index(__variant_npos<__index_t>) {}\x0a"
"\x0a"
"  template <size_t _Ip, class... _Args>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr __base(in_place_index_t<_Ip>, _Args\x26\x26... __args)\x0a"
"      \x3a\x0a"
"        __data(in_place_index<_Ip>, _VSTD\x3a\x3a""forward<_Args>(__args)...),\x0a"
"        __index(_Ip) {}\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr bool valueless_by_exception() const noexcept {\x0a"
"    return index() == variant_npos;\x0a"
"  }\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr size_t index() const noexcept {\x0a"
"    return __index == __variant_npos<__index_t> \x3f variant_npos \x3a __index;\x0a"
"  }\x0a"
"\x0a"
"protected\x3a\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr auto\x26\x26 __as_base() \x26 { return *this; }\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr auto\x26\x26 __as_base() \x26\x26 { return _VSTD\x3a\x3amove(*this); }\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr auto\x26\x26 __as_base() const \x26 { return *this; }\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr auto\x26\x26 __as_base() const \x26\x26 { return _VSTD\x3a\x3amove(*this); }\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static constexpr size_t __size() { return sizeof...(_Types); }\x0a"
"\x0a"
"  __union<_DestructibleTrait, 0, _Types...> __data;\x0a"
"  __index_t __index;\x0a"
"\x0a"
"  friend struct __access\x3a\x3a__base;\x0a"
"  friend struct __visitation\x3a\x3a__base;\x0a"
"};\x0a"
"\x0a"
"template <class _Traits, _Trait = _Traits\x3a\x3a__destructible_trait>\x0a"
"class _LIBCPP_TEMPLATE_VIS __destructor;\x0a"
"\x0a"
"#define _LIBCPP_VARIANT_DESTRUCTOR(destructible_trait, destructor, destroy)    \x5c\x0a"
"  template <class... _Types>                                                   \x5c\x0a"
"  class _LIBCPP_TEMPLATE_VIS __destructor<__traits<_Types...>,                 \x5c\x0a"
"                                           destructible_trait>                 \x5c\x0a"
"      \x3a public __base<destructible_trait, _Types...> {                         \x5c\x0a"
"    using __base_type = __base<destructible_trait, _Types...>;                 \x5c\x0a"
"    using __index_t = typename __base_type\x3a\x3a__index_t;                         \x5c\x0a"
"                                                                               \x5c\x0a"
"  public\x3a                                                                      \x5c\x0a"
"    using __base_type\x3a\x3a__base_type;                                            \x5c\x0a"
"    using __base_type\x3a\x3aoperator=;                                              \x5c\x0a"
"                                                                               \x5c\x0a"
"    __destructor(const __destructor\x26) = default;                               \x5c\x0a"
"    __destructor(__destructor\x26\x26) = default;                                    \x5c\x0a"
"    destructor                                                                 \x5c\x0a"
"    __destructor\x26 operator=(const __destructor\x26) = default;                    \x5c\x0a"
"    __destructor\x26 operator=(__destructor\x26\x26) = default;                         \x5c\x0a"
"                                                                               \x5c\x0a"
"  protected\x3a                                                                   \x5c\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY                                           \x5c\x0a"
"    destroy                                                                    \x5c\x0a"
"  }\x0a"
"\x0a"
"_LIBCPP_VARIANT_DESTRUCTOR(\x0a"
"    _Trait\x3a\x3a_TriviallyAvailable,\x0a"
"    \x7e__destructor() = default;,\x0a"
"    void __destroy() noexcept { this->__index = __variant_npos<__index_t>; });\x0a"
"\x0a"
"_LIBCPP_VARIANT_DESTRUCTOR(\x0a"
"    _Trait\x3a\x3a_Available,\x0a"
"    \x7e__destructor() { __destroy(); },\x0a"
"    void __destroy() noexcept {\x0a"
"      if (\x21this->valueless_by_exception()) {\x0a"
"        __visitation\x3a\x3a__base\x3a\x3a__visit_alt(\x0a"
"            \x5b\x5d(auto\x26 __alt) noexcept {\x0a"
"              using __alt_type = __uncvref_t<decltype(__alt)>;\x0a"
"              __alt.\x7e__alt_type();\x0a"
"            },\x0a"
"            *this);\x0a"
"      }\x0a"
"      this->__index = __variant_npos<__index_t>;\x0a"
"    });\x0a"
"\x0a"
"_LIBCPP_VARIANT_DESTRUCTOR(\x0a"
"    _Trait\x3a\x3a_Unavailable,\x0a"
"    \x7e__destructor() = delete;,\x0a"
"    void __destroy() noexcept = delete;);\x0a"
"\x0a"
"#undef _LIBCPP_VARIANT_DESTRUCTOR\x0a"
"\x0a"
"template <class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS __constructor \x3a public __destructor<_Traits> {\x0a"
"  using __base_type = __destructor<_Traits>;\x0a"
"\x0a"
"public\x3a\x0a"
"  using __base_type\x3a\x3a__base_type;\x0a"
"  using __base_type\x3a\x3aoperator=;\x0a"
"\x0a"
"protected\x3a\x0a"
"  template <size_t _Ip, class _Tp, class... _Args>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static _Tp\x26 __construct_alt(__alt<_Ip, _Tp>\x26 __a, _Args\x26\x26... __args) {\x0a"
"    \x3a\x3anew ((void*)_VSTD\x3a\x3a""addressof(__a))\x0a"
"        __alt<_Ip, _Tp>(in_place, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    return __a.__value;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Rhs>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  static void __generic_construct(__constructor\x26 __lhs, _Rhs\x26\x26 __rhs) {\x0a"
"    __lhs.__destroy();\x0a"
"    if (\x21__rhs.valueless_by_exception()) {\x0a"
"      __visitation\x3a\x3a__base\x3a\x3a__visit_alt_at(\x0a"
"          __rhs.index(),\x0a"
"          \x5b\x5d(auto\x26 __lhs_alt, auto\x26\x26 __rhs_alt) {\x0a"
"            __construct_alt(\x0a"
"                __lhs_alt,\x0a"
"                _VSTD\x3a\x3a""forward<decltype(__rhs_alt)>(__rhs_alt).__value);\x0a"
"          },\x0a"
"          __lhs, _VSTD\x3a\x3a""forward<_Rhs>(__rhs));\x0a"
"      __lhs.__index = __rhs.index();\x0a"
"    }\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Traits, _Trait = _Traits\x3a\x3a__move_constructible_trait>\x0a"
"class _LIBCPP_TEMPLATE_VIS __move_constructor;\x0a"
"\x0a"
"#define _LIBCPP_VARIANT_MOVE_CONSTRUCTOR(move_constructible_trait,             \x5c\x0a"
"                                         move_constructor)                     \x5c\x0a"
"  template <class... _Types>                                                   \x5c\x0a"
"  class _LIBCPP_TEMPLATE_VIS __move_constructor<__traits<_Types...>,          \x5c\x0a"
"                                                 move_constructible_trait>     \x5c\x0a"
"      \x3a public __constructor<__traits<_Types...>> {                            \x5c\x0a"
"    using __base_type = __constructor<__traits<_Types...>>;                    \x5c\x0a"
"                                                                               \x5c\x0a"
"  public\x3a                                                                      \x5c\x0a"
"    using __base_type\x3a\x3a__base_type;                                            \x5c\x0a"
"    using __base_type\x3a\x3aoperator=;                                              \x5c\x0a"
"                                                                               \x5c\x0a"
"    __move_constructor(const __move_constructor\x26) = default;                   \x5c\x0a"
"    move_constructor                                                           \x5c\x0a"
"    \x7e__move_constructor() = default;                                           \x5c\x0a"
"    __move_constructor\x26 operator=(const __move_constructor\x26) = default;        \x5c\x0a"
"    __move_constructor\x26 operator=(__move_constructor\x26\x26) = default;             \x5c\x0a"
"  }\x0a"
"\x0a"
"_LIBCPP_VARIANT_MOVE_CONSTRUCTOR(\x0a"
"    _Trait\x3a\x3a_TriviallyAvailable,\x0a"
"    __move_constructor(__move_constructor\x26\x26 __that) = default;);\x0a"
"\x0a"
"_LIBCPP_VARIANT_MOVE_CONSTRUCTOR(\x0a"
"    _Trait\x3a\x3a_Available,\x0a"
"    __move_constructor(__move_constructor\x26\x26 __that) noexcept(\x0a"
"        __all<is_nothrow_move_constructible_v<_Types>...>\x3a\x3avalue)\x0a"
"        \x3a __move_constructor(__valueless_t{}) {\x0a"
"      this->__generic_construct(*this, _VSTD\x3a\x3amove(__that));\x0a"
"    });\x0a"
"\x0a"
"_LIBCPP_VARIANT_MOVE_CONSTRUCTOR(\x0a"
"    _Trait\x3a\x3a_Unavailable,\x0a"
"    __move_constructor(__move_constructor\x26\x26) = delete;);\x0a"
"\x0a"
"#undef _LIBCPP_VARIANT_MOVE_CONSTRUCTOR\x0a"
"\x0a"
"template <class _Traits, _Trait = _Traits\x3a\x3a__copy_constructible_trait>\x0a"
"class _LIBCPP_TEMPLATE_VIS __copy_constructor;\x0a"
"\x0a"
"#define _LIBCPP_VARIANT_COPY_CONSTRUCTOR(copy_constructible_trait,             \x5c\x0a"
"                                         copy_constructor)                     \x5c\x0a"
"  template <class... _Types>                                                   \x5c\x0a"
"  class _LIBCPP_TEMPLATE_VIS __copy_constructor<__traits<_Types...>,          \x5c\x0a"
"                                                 copy_constructible_trait>     \x5c\x0a"
"      \x3a public __move_constructor<__traits<_Types...>> {                       \x5c\x0a"
"    using __base_type = __move_constructor<__traits<_Types...>>;               \x5c\x0a"
"                                                                               \x5c\x0a"
"  public\x3a                                                                      \x5c\x0a"
"    using __base_type\x3a\x3a__base_type;                                            \x5c\x0a"
"    using __base_type\x3a\x3aoperator=;                                              \x5c\x0a"
"                                                                               \x5c\x0a"
"    copy_constructor                                                           \x5c\x0a"
"    __copy_constructor(__copy_constructor\x26\x26) = default;                        \x5c\x0a"
"    \x7e__copy_constructor() = default;                                           \x5c\x0a"
"    __copy_constructor\x26 operator=(const __copy_constructor\x26) = default;        \x5c\x0a"
"    __copy_constructor\x26 operator=(__copy_constructor\x26\x26) = default;             \x5c\x0a"
"  }\x0a"
"\x0a"
"_LIBCPP_VARIANT_COPY_CONSTRUCTOR(\x0a"
"    _Trait\x3a\x3a_TriviallyAvailable,\x0a"
"    __copy_constructor(const __copy_constructor\x26 __that) = default;);\x0a"
"\x0a"
"_LIBCPP_VARIANT_COPY_CONSTRUCTOR(\x0a"
"    _Trait\x3a\x3a_Available,\x0a"
"    __copy_constructor(const __copy_constructor\x26 __that)\x0a"
"        \x3a __copy_constructor(__valueless_t{}) {\x0a"
"      this->__generic_construct(*this, __that);\x0a"
"    });\x0a"
"\x0a"
"_LIBCPP_VARIANT_COPY_CONSTRUCTOR(\x0a"
"    _Trait\x3a\x3a_Unavailable,\x0a"
"    __copy_constructor(const __copy_constructor\x26) = delete;);\x0a"
"\x0a"
"#undef _LIBCPP_VARIANT_COPY_CONSTRUCTOR\x0a"
"\x0a"
"template <class _Traits>\x0a"
"class _LIBCPP_TEMPLATE_VIS __assignment \x3a public __copy_constructor<_Traits> {\x0a"
"  using __base_type = __copy_constructor<_Traits>;\x0a"
"\x0a"
"public\x3a\x0a"
"  using __base_type\x3a\x3a__base_type;\x0a"
"  using __base_type\x3a\x3aoperator=;\x0a"
"\x0a"
"  template <size_t _Ip, class... _Args>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  auto\x26 __emplace(_Args\x26\x26... __args) {\x0a"
"    this->__destroy();\x0a"
"    auto\x26 __res = this->__construct_alt(__access\x3a\x3a__base\x3a\x3a__get_alt<_Ip>(*this),\x0a"
"                          _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    this->__index = _Ip;\x0a"
"    return __res;\x0a"
"  }\x0a"
"\x0a"
"protected\x3a\x0a"
"  template <size_t _Ip, class _Tp, class _Arg>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  void __assign_alt(__alt<_Ip, _Tp>\x26 __a, _Arg\x26\x26 __arg) {\x0a"
"    if (this->index() == _Ip) {\x0a"
"      __a.__value = _VSTD\x3a\x3a""forward<_Arg>(__arg);\x0a"
"    } else {\x0a"
"      struct {\x0a"
"        void operator()(true_type) const {\x0a"
"          __this->__emplace<_Ip>(_VSTD\x3a\x3a""forward<_Arg>(__arg));\x0a"
"        }\x0a"
"        void operator()(false_type) const {\x0a"
"          __this->__emplace<_Ip>(_Tp(_VSTD\x3a\x3a""forward<_Arg>(__arg)));\x0a"
"        }\x0a"
"        __assignment* __this;\x0a"
"        _Arg\x26\x26 __arg;\x0a"
"      } __impl{this, _VSTD\x3a\x3a""forward<_Arg>(__arg)};\x0a"
"      __impl(bool_constant<is_nothrow_constructible_v<_Tp, _Arg> \x7c\x7c\x0a"
"                           \x21is_nothrow_move_constructible_v<_Tp>>{});\x0a"
"    }\x0a"
"  }\x0a"
"\x0a"
"  template <class _That>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  void __generic_assign(_That\x26\x26 __that) {\x0a"
"    if (this->valueless_by_exception() \x26\x26 __that.valueless_by_exception()) {\x0a"
"      // do nothing.\x0a"
"    } else if (__that.valueless_by_exception()) {\x0a"
"      this->__destroy();\x0a"
"    } else {\x0a"
"      __visitation\x3a\x3a__base\x3a\x3a__visit_alt_at(\x0a"
"          __that.index(),\x0a"
"          \x5bthis\x5d(auto\x26 __this_alt, auto\x26\x26 __that_alt) {\x0a"
"            this->__assign_alt(\x0a"
"                __this_alt,\x0a"
"                _VSTD\x3a\x3a""forward<decltype(__that_alt)>(__that_alt).__value);\x0a"
"          },\x0a"
"          *this, _VSTD\x3a\x3a""forward<_That>(__that));\x0a"
"    }\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Traits, _Trait = _Traits\x3a\x3a__move_assignable_trait>\x0a"
"class _LIBCPP_TEMPLATE_VIS __move_assignment;\x0a"
"\x0a"
"#define _LIBCPP_VARIANT_MOVE_ASSIGNMENT(move_assignable_trait,                 \x5c\x0a"
"                                        move_assignment)                       \x5c\x0a"
"  template <class... _Types>                                                   \x5c\x0a"
"  class _LIBCPP_TEMPLATE_VIS __move_assignment<__traits<_Types...>,           \x5c\x0a"
"                                                move_assignable_trait>         \x5c\x0a"
"      \x3a public __assignment<__traits<_Types...>> {                             \x5c\x0a"
"    using __base_type = __assignment<__traits<_Types...>>;                     \x5c\x0a"
"                                                                               \x5c\x0a"
"  public\x3a                                                                      \x5c\x0a"
"    using __base_type\x3a\x3a__base_type;                                            \x5c\x0a"
"    using __base_type\x3a\x3aoperator=;                                              \x5c\x0a"
"                                                                               \x5c\x0a"
"    __move_assignment(const __move_assignment\x26) = default;                     \x5c\x0a"
"    __move_assignment(__move_assignment\x26\x26) = default;                          \x5c\x0a"
"    \x7e__move_assignment() = default;                                            \x5c\x0a"
"    __move_assignment\x26 operator=(const __move_assignment\x26) = default;          \x5c\x0a"
"    move_assignment                                                            \x5c\x0a"
"  }\x0a"
"\x0a"
"_LIBCPP_VARIANT_MOVE_ASSIGNMENT(\x0a"
"    _Trait\x3a\x3a_TriviallyAvailable,\x0a"
"    __move_assignment\x26 operator=(__move_assignment\x26\x26 __that) = default;);\x0a"
"\x0a"
"_LIBCPP_VARIANT_MOVE_ASSIGNMENT(\x0a"
"    _Trait\x3a\x3a_Available,\x0a"
"    __move_assignment\x26 operator=(__move_assignment\x26\x26 __that) noexcept(\x0a"
"        __all<(is_nothrow_move_constructible_v<_Types> \x26\x26\x0a"
"               is_nothrow_move_assignable_v<_Types>)...>\x3a\x3avalue) {\x0a"
"      this->__generic_assign(_VSTD\x3a\x3amove(__that));\x0a"
"      return *this;\x0a"
"    });\x0a"
"\x0a"
"_LIBCPP_VARIANT_MOVE_ASSIGNMENT(\x0a"
"    _Trait\x3a\x3a_Unavailable,\x0a"
"    __move_assignment\x26 operator=(__move_assignment\x26\x26) = delete;);\x0a"
"\x0a"
"#undef _LIBCPP_VARIANT_MOVE_ASSIGNMENT\x0a"
"\x0a"
"template <class _Traits, _Trait = _Traits\x3a\x3a__copy_assignable_trait>\x0a"
"class _LIBCPP_TEMPLATE_VIS __copy_assignment;\x0a"
"\x0a"
"#define _LIBCPP_VARIANT_COPY_ASSIGNMENT(copy_assignable_trait,                 \x5c\x0a"
"                                        copy_assignment)                       \x5c\x0a"
"  template <class... _Types>                                                   \x5c\x0a"
"  class _LIBCPP_TEMPLATE_VIS __copy_assignment<__traits<_Types...>,           \x5c\x0a"
"                                                copy_assignable_trait>         \x5c\x0a"
"      \x3a public __move_assignment<__traits<_Types...>> {                        \x5c\x0a"
"    using __base_type = __move_assignment<__traits<_Types...>>;                \x5c\x0a"
"                                                                               \x5c\x0a"
"  public\x3a                                                                      \x5c\x0a"
"    using __base_type\x3a\x3a__base_type;                                            \x5c\x0a"
"    using __base_type\x3a\x3aoperator=;                                              \x5c\x0a"
"                                                                               \x5c\x0a"
"    __copy_assignment(const __copy_assignment\x26) = default;                     \x5c\x0a"
"    __copy_assignment(__copy_assignment\x26\x26) = default;                          \x5c\x0a"
"    \x7e__copy_assignment() = default;                                            \x5c\x0a"
"    copy_assignment                                                            \x5c\x0a"
"    __copy_assignment\x26 operator=(__copy_assignment\x26\x26) = default;               \x5c\x0a"
"  }\x0a"
"\x0a"
"_LIBCPP_VARIANT_COPY_ASSIGNMENT(\x0a"
"    _Trait\x3a\x3a_TriviallyAvailable,\x0a"
"    __copy_assignment\x26 operator=(const __copy_assignment\x26 __that) = default;);\x0a"
"\x0a"
"_LIBCPP_VARIANT_COPY_ASSIGNMENT(\x0a"
"    _Trait\x3a\x3a_Available,\x0a"
"    __copy_assignment\x26 operator=(const __copy_assignment\x26 __that) {\x0a"
"      this->__generic_assign(__that);\x0a"
"      return *this;\x0a"
"    });\x0a"
"\x0a"
"_LIBCPP_VARIANT_COPY_ASSIGNMENT(\x0a"
"    _Trait\x3a\x3a_Unavailable,\x0a"
"    __copy_assignment\x26 operator=(const __copy_assignment\x26) = delete;);\x0a"
"\x0a"
"#undef _LIBCPP_VARIANT_COPY_ASSIGNMENT\x0a"
"\x0a"
"template <class... _Types>\x0a"
"class _LIBCPP_TEMPLATE_VIS __impl\x0a"
"    \x3a public __copy_assignment<__traits<_Types...>> {\x0a"
"  using __base_type = __copy_assignment<__traits<_Types...>>;\x0a"
"\x0a"
"public\x3a\x0a"
"  using __base_type\x3a\x3a__base_type;\x0a"
"  using __base_type\x3a\x3aoperator=;\x0a"
"\x0a"
"  template <size_t _Ip, class _Arg>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  void __assign(_Arg\x26\x26 __arg) {\x0a"
"    this->__assign_alt(__access\x3a\x3a__base\x3a\x3a__get_alt<_Ip>(*this),\x0a"
"                       _VSTD\x3a\x3a""forward<_Arg>(__arg));\x0a"
"  }\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  void __swap(__impl\x26 __that)  {\x0a"
"    if (this->valueless_by_exception() \x26\x26 __that.valueless_by_exception()) {\x0a"
"      // do nothing.\x0a"
"    } else if (this->index() == __that.index()) {\x0a"
"      __visitation\x3a\x3a__base\x3a\x3a__visit_alt_at(\x0a"
"          this->index(),\x0a"
"          \x5b\x5d(auto\x26 __this_alt, auto\x26 __that_alt) {\x0a"
"            using _VSTD\x3a\x3aswap;\x0a"
"            swap(__this_alt.__value, __that_alt.__value);\x0a"
"          },\x0a"
"          *this,\x0a"
"          __that);\x0a"
"    } else {\x0a"
"      __impl* __lhs = this;\x0a"
"      __impl* __rhs = _VSTD\x3a\x3a""addressof(__that);\x0a"
"      if (__lhs->__move_nothrow() \x26\x26 \x21__rhs->__move_nothrow()) {\x0a"
"        _VSTD\x3a\x3aswap(__lhs, __rhs);\x0a"
"      }\x0a"
"      __impl __tmp(_VSTD\x3a\x3amove(*__rhs));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"      // EXTENSION\x3a When the move construction of \x60__lhs\x60 into \x60__rhs\x60 throws\x0a"
"      // and \x60__tmp\x60 is nothrow move constructible then we move \x60__tmp\x60 back\x0a"
"      // into \x60__rhs\x60 and provide the strong exception safety guarantee.\x0a"
"      try {\x0a"
"        this->__generic_construct(*__rhs, _VSTD\x3a\x3amove(*__lhs));\x0a"
"      } catch (...) {\x0a"
"        if (__tmp.__move_nothrow()) {\x0a"
"          this->__generic_construct(*__rhs, _VSTD\x3a\x3amove(__tmp));\x0a"
"        }\x0a"
"        throw;\x0a"
"      }\x0a"
"#else\x0a"
"      this->__generic_construct(*__rhs, _VSTD\x3a\x3amove(*__lhs));\x0a"
"#endif\x0a"
"      this->__generic_construct(*__lhs, _VSTD\x3a\x3amove(__tmp));\x0a"
"    }\x0a"
"  }\x0a"
"\x0a"
"private\x3a\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  bool __move_nothrow() const {\x0a"
"    constexpr bool __results\x5b\x5d = {is_nothrow_move_constructible_v<_Types>...};\x0a"
"    return this->valueless_by_exception() \x7c\x7c __results\x5bthis->index()\x5d;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"struct __no_narrowing_check {\x0a"
"  template <class _Dest, class _Source>\x0a"
"  using _Apply = __identity<_Dest>;\x0a"
"};\x0a"
"\x0a"
"struct __narrowing_check {\x0a"
"  template <class _Dest>\x0a"
"  static auto __test_impl(_Dest (\x26\x26)\x5b""1\x5d) -> __identity<_Dest>;\x0a"
"  template <class _Dest, class _Source>\x0a"
"  using _Apply _LIBCPP_NODEBUG_TYPE = decltype(__test_impl<_Dest>({std\x3a\x3a""declval<_Source>()}));\x0a"
"};\x0a"
"\x0a"
"template <class _Dest, class _Source>\x0a"
"using __check_for_narrowing _LIBCPP_NODEBUG_TYPE =\x0a"
"  typename _If<\x0a"
"#ifdef _LIBCPP_ENABLE_NARROWING_CONVERSIONS_IN_VARIANT\x0a"
"    false \x26\x26\x0a"
"#endif\x0a"
"    is_arithmetic<_Dest>\x3a\x3avalue,\x0a"
"    __narrowing_check,\x0a"
"    __no_narrowing_check\x0a"
"  >\x3a\x3atemplate _Apply<_Dest, _Source>;\x0a"
"\x0a"
"template <class _Tp, size_t _Idx>\x0a"
"struct __overload {\x0a"
"  template <class _Up>\x0a"
"  auto operator()(_Tp, _Up\x26\x26) const -> __check_for_narrowing<_Tp, _Up>;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, size_t>\x0a"
"struct __overload_bool  {\x0a"
"  template <class _Up, class _Ap = __uncvref_t<_Up>>\x0a"
"  auto operator()(bool, _Up\x26\x26) const\x0a"
"      -> enable_if_t<is_same_v<_Ap, bool>, __identity<_Tp>>;\x0a"
"};\x0a"
"\x0a"
"template <size_t _Idx>\x0a"
"struct __overload<bool, _Idx> \x3a __overload_bool<bool, _Idx> {};\x0a"
"template <size_t _Idx>\x0a"
"struct __overload<bool const, _Idx> \x3a __overload_bool<bool const, _Idx> {};\x0a"
"template <size_t _Idx>\x0a"
"struct __overload<bool volatile, _Idx> \x3a __overload_bool<bool volatile, _Idx> {};\x0a"
"template <size_t _Idx>\x0a"
"struct __overload<bool const volatile, _Idx> \x3a __overload_bool<bool const volatile, _Idx> {};\x0a"
"\x0a"
"template <class ..._Bases>\x0a"
"struct __all_overloads \x3a _Bases... {\x0a"
"  void operator()() const;\x0a"
"  using _Bases\x3a\x3aoperator()...;\x0a"
"};\x0a"
"\x0a"
"template <class IdxSeq>\x0a"
"struct __make_overloads_imp;\x0a"
"\x0a"
"template <size_t ..._Idx>\x0a"
"struct __make_overloads_imp<__tuple_indices<_Idx...> > {\x0a"
"  template <class ..._Types>\x0a"
"  using _Apply _LIBCPP_NODEBUG_TYPE = __all_overloads<__overload<_Types, _Idx>...>;\x0a"
"};\x0a"
"\x0a"
"template <class ..._Types>\x0a"
"using _MakeOverloads _LIBCPP_NODEBUG_TYPE = typename __make_overloads_imp<\x0a"
"    __make_indices_imp<sizeof...(_Types), 0> >\x3a\x3atemplate _Apply<_Types...>;\x0a"
"\x0a"
"template <class _Tp, class... _Types>\x0a"
"using __best_match_t =\x0a"
"    typename invoke_result_t<_MakeOverloads<_Types...>, _Tp, _Tp>\x3a\x3atype;\x0a"
"\x0a"
"} // __variant_detail\x0a"
"\x0a"
"template <class... _Types>\x0a"
"class _LIBCPP_TEMPLATE_VIS variant\x0a"
"    \x3a private __sfinae_ctor_base<\x0a"
"          __all<is_copy_constructible_v<_Types>...>\x3a\x3avalue,\x0a"
"          __all<is_move_constructible_v<_Types>...>\x3a\x3avalue>,\x0a"
"      private __sfinae_assign_base<\x0a"
"          __all<(is_copy_constructible_v<_Types> \x26\x26\x0a"
"                 is_copy_assignable_v<_Types>)...>\x3a\x3avalue,\x0a"
"          __all<(is_move_constructible_v<_Types> \x26\x26\x0a"
"                 is_move_assignable_v<_Types>)...>\x3a\x3avalue> {\x0a"
"  static_assert(0 < sizeof...(_Types),\x0a"
"                \x22variant must consist of at least one alternative.\x22);\x0a"
"\x0a"
"  static_assert(__all<\x21is_array_v<_Types>...>\x3a\x3avalue,\x0a"
"                \x22variant can not have an array type as an alternative.\x22);\x0a"
"\x0a"
"  static_assert(__all<\x21is_reference_v<_Types>...>\x3a\x3avalue,\x0a"
"                \x22variant can not have a reference type as an alternative.\x22);\x0a"
"\x0a"
"  static_assert(__all<\x21is_void_v<_Types>...>\x3a\x3avalue,\x0a"
"                \x22variant can not have a void type as an alternative.\x22);\x0a"
"\x0a"
"  using __first_type = variant_alternative_t<0, variant>;\x0a"
"\x0a"
"public\x3a\x0a"
"  template <bool _Dummy = true,\x0a"
"            enable_if_t<__dependent_type<is_default_constructible<__first_type>,\x0a"
"                                         _Dummy>\x3a\x3avalue,\x0a"
"                        int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr variant() noexcept(is_nothrow_default_constructible_v<__first_type>)\x0a"
"      \x3a __impl(in_place_index<0>) {}\x0a"
"\x0a"
"  variant(const variant\x26) = default;\x0a"
"  variant(variant\x26\x26) = default;\x0a"
"\x0a"
"  template <\x0a"
"      class _Arg,\x0a"
"      enable_if_t<\x21is_same_v<__uncvref_t<_Arg>, variant>, int> = 0,\x0a"
"      enable_if_t<\x21__is_inplace_type<__uncvref_t<_Arg>>\x3a\x3avalue, int> = 0,\x0a"
"      enable_if_t<\x21__is_inplace_index<__uncvref_t<_Arg>>\x3a\x3avalue, int> = 0,\x0a"
"      class _Tp = __variant_detail\x3a\x3a__best_match_t<_Arg, _Types...>,\x0a"
"      size_t _Ip =\x0a"
"          __find_detail\x3a\x3a__find_unambiguous_index_sfinae<_Tp, _Types...>\x3a\x3avalue,\x0a"
"      enable_if_t<is_constructible_v<_Tp, _Arg>, int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr variant(_Arg\x26\x26 __arg) noexcept(\x0a"
"      is_nothrow_constructible_v<_Tp, _Arg>)\x0a"
"      \x3a __impl(in_place_index<_Ip>, _VSTD\x3a\x3a""forward<_Arg>(__arg)) {}\x0a"
"\x0a"
"  template <size_t _Ip, class... _Args,\x0a"
"            class = enable_if_t<(_Ip < sizeof...(_Types)), int>,\x0a"
"            class _Tp = variant_alternative_t<_Ip, variant<_Types...>>,\x0a"
"            enable_if_t<is_constructible_v<_Tp, _Args...>, int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr variant(\x0a"
"      in_place_index_t<_Ip>,\x0a"
"      _Args\x26\x26... __args) noexcept(is_nothrow_constructible_v<_Tp, _Args...>)\x0a"
"      \x3a __impl(in_place_index<_Ip>, _VSTD\x3a\x3a""forward<_Args>(__args)...) {}\x0a"
"\x0a"
"  template <\x0a"
"      size_t _Ip,\x0a"
"      class _Up,\x0a"
"      class... _Args,\x0a"
"      enable_if_t<(_Ip < sizeof...(_Types)), int> = 0,\x0a"
"      class _Tp = variant_alternative_t<_Ip, variant<_Types...>>,\x0a"
"      enable_if_t<is_constructible_v<_Tp, initializer_list<_Up>\x26, _Args...>,\x0a"
"                  int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr variant(\x0a"
"      in_place_index_t<_Ip>,\x0a"
"      initializer_list<_Up> __il,\x0a"
"      _Args\x26\x26... __args) noexcept(\x0a"
"      is_nothrow_constructible_v<_Tp, initializer_list<_Up>\x26, _Args...>)\x0a"
"      \x3a __impl(in_place_index<_Ip>, __il, _VSTD\x3a\x3a""forward<_Args>(__args)...) {}\x0a"
"\x0a"
"  template <\x0a"
"      class _Tp,\x0a"
"      class... _Args,\x0a"
"      size_t _Ip =\x0a"
"          __find_detail\x3a\x3a__find_unambiguous_index_sfinae<_Tp, _Types...>\x3a\x3avalue,\x0a"
"      enable_if_t<is_constructible_v<_Tp, _Args...>, int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr variant(in_place_type_t<_Tp>, _Args\x26\x26... __args) noexcept(\x0a"
"      is_nothrow_constructible_v<_Tp, _Args...>)\x0a"
"      \x3a __impl(in_place_index<_Ip>, _VSTD\x3a\x3a""forward<_Args>(__args)...) {}\x0a"
"\x0a"
"  template <\x0a"
"      class _Tp,\x0a"
"      class _Up,\x0a"
"      class... _Args,\x0a"
"      size_t _Ip =\x0a"
"          __find_detail\x3a\x3a__find_unambiguous_index_sfinae<_Tp, _Types...>\x3a\x3avalue,\x0a"
"      enable_if_t<is_constructible_v<_Tp, initializer_list<_Up>\x26, _Args...>,\x0a"
"                  int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit constexpr variant(\x0a"
"      in_place_type_t<_Tp>,\x0a"
"      initializer_list<_Up> __il,\x0a"
"      _Args\x26\x26... __args) noexcept(\x0a"
"      is_nothrow_constructible_v<_Tp, initializer_list< _Up>\x26, _Args...>)\x0a"
"      \x3a __impl(in_place_index<_Ip>, __il, _VSTD\x3a\x3a""forward<_Args>(__args)...) {}\x0a"
"\x0a"
"  \x7evariant() = default;\x0a"
"\x0a"
"  variant\x26 operator=(const variant\x26) = default;\x0a"
"  variant\x26 operator=(variant\x26\x26) = default;\x0a"
"\x0a"
"  template <\x0a"
"      class _Arg,\x0a"
"      enable_if_t<\x21is_same_v<__uncvref_t<_Arg>, variant>, int> = 0,\x0a"
"      class _Tp = __variant_detail\x3a\x3a__best_match_t<_Arg, _Types...>,\x0a"
"      size_t _Ip =\x0a"
"          __find_detail\x3a\x3a__find_unambiguous_index_sfinae<_Tp, _Types...>\x3a\x3avalue,\x0a"
"      enable_if_t<is_assignable_v<_Tp\x26, _Arg> \x26\x26 is_constructible_v<_Tp, _Arg>,\x0a"
"                  int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  variant\x26 operator=(_Arg\x26\x26 __arg) noexcept(\x0a"
"      is_nothrow_assignable_v<_Tp\x26, _Arg> \x26\x26\x0a"
"      is_nothrow_constructible_v<_Tp, _Arg>) {\x0a"
"    __impl.template __assign<_Ip>(_VSTD\x3a\x3a""forward<_Arg>(__arg));\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <\x0a"
"      size_t _Ip,\x0a"
"      class... _Args,\x0a"
"      enable_if_t<(_Ip < sizeof...(_Types)), int> = 0,\x0a"
"      class _Tp = variant_alternative_t<_Ip, variant<_Types...>>,\x0a"
"      enable_if_t<is_constructible_v<_Tp, _Args...>, int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  _Tp\x26 emplace(_Args\x26\x26... __args) {\x0a"
"    return __impl.template __emplace<_Ip>(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"  }\x0a"
"\x0a"
"  template <\x0a"
"      size_t _Ip,\x0a"
"      class _Up,\x0a"
"      class... _Args,\x0a"
"      enable_if_t<(_Ip < sizeof...(_Types)), int> = 0,\x0a"
"      class _Tp = variant_alternative_t<_Ip, variant<_Types...>>,\x0a"
"      enable_if_t<is_constructible_v<_Tp, initializer_list<_Up>\x26, _Args...>,\x0a"
"                  int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  _Tp\x26 emplace(initializer_list<_Up> __il, _Args\x26\x26... __args) {\x0a"
"    return __impl.template __emplace<_Ip>(__il, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"  }\x0a"
"\x0a"
"  template <\x0a"
"      class _Tp,\x0a"
"      class... _Args,\x0a"
"      size_t _Ip =\x0a"
"          __find_detail\x3a\x3a__find_unambiguous_index_sfinae<_Tp, _Types...>\x3a\x3avalue,\x0a"
"      enable_if_t<is_constructible_v<_Tp, _Args...>, int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  _Tp\x26 emplace(_Args\x26\x26... __args) {\x0a"
"    return __impl.template __emplace<_Ip>(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"  }\x0a"
"\x0a"
"  template <\x0a"
"      class _Tp,\x0a"
"      class _Up,\x0a"
"      class... _Args,\x0a"
"      size_t _Ip =\x0a"
"          __find_detail\x3a\x3a__find_unambiguous_index_sfinae<_Tp, _Types...>\x3a\x3avalue,\x0a"
"      enable_if_t<is_constructible_v<_Tp, initializer_list<_Up>\x26, _Args...>,\x0a"
"                  int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  _Tp\x26 emplace(initializer_list<_Up> __il, _Args\x26\x26... __args) {\x0a"
"    return __impl.template __emplace<_Ip>(__il, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"  }\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr bool valueless_by_exception() const noexcept {\x0a"
"    return __impl.valueless_by_exception();\x0a"
"  }\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr size_t index() const noexcept { return __impl.index(); }\x0a"
"\x0a"
"  template <\x0a"
"      bool _Dummy = true,\x0a"
"      enable_if_t<\x0a"
"          __all<(\x0a"
"              __dependent_type<is_move_constructible<_Types>, _Dummy>\x3a\x3avalue \x26\x26\x0a"
"              __dependent_type<is_swappable<_Types>, _Dummy>\x3a\x3avalue)...>\x3a\x3avalue,\x0a"
"          int> = 0>\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  void swap(variant\x26 __that) noexcept(\x0a"
"      __all<(is_nothrow_move_constructible_v<_Types> \x26\x26\x0a"
"             is_nothrow_swappable_v<_Types>)...>\x3a\x3avalue) {\x0a"
"    __impl.__swap(__that.__impl);\x0a"
"  }\x0a"
"\x0a"
"private\x3a\x0a"
"  __variant_detail\x3a\x3a__impl<_Types...> __impl;\x0a"
"\x0a"
"  friend struct __variant_detail\x3a\x3a__access\x3a\x3a__variant;\x0a"
"  friend struct __variant_detail\x3a\x3a__visitation\x3a\x3a__variant;\x0a"
"};\x0a"
"\x0a"
"template <size_t _Ip, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool __holds_alternative(const variant<_Types...>\x26 __v) noexcept {\x0a"
"  return __v.index() == _Ip;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool holds_alternative(const variant<_Types...>\x26 __v) noexcept {\x0a"
"  return __holds_alternative<__find_exactly_one_t<_Tp, _Types...>\x3a\x3avalue>(__v);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class _Vp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"constexpr auto\x26\x26 __generic_get(_Vp\x26\x26 __v) {\x0a"
"  using __variant_detail\x3a\x3a__access\x3a\x3a__variant;\x0a"
"  if (\x21__holds_alternative<_Ip>(__v)) {\x0a"
"    __throw_bad_variant_access();\x0a"
"  }\x0a"
"  return __variant\x3a\x3a__get_alt<_Ip>(_VSTD\x3a\x3a""forward<_Vp>(__v)).__value;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"constexpr variant_alternative_t<_Ip, variant<_Types...>>\x26 get(\x0a"
"    variant<_Types...>\x26 __v) {\x0a"
"  static_assert(_Ip < sizeof...(_Types));\x0a"
"  static_assert(\x21is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);\x0a"
"  return __generic_get<_Ip>(__v);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"constexpr variant_alternative_t<_Ip, variant<_Types...>>\x26\x26 get(\x0a"
"    variant<_Types...>\x26\x26 __v) {\x0a"
"  static_assert(_Ip < sizeof...(_Types));\x0a"
"  static_assert(\x21is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);\x0a"
"  return __generic_get<_Ip>(_VSTD\x3a\x3amove(__v));\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"constexpr const variant_alternative_t<_Ip, variant<_Types...>>\x26 get(\x0a"
"    const variant<_Types...>\x26 __v) {\x0a"
"  static_assert(_Ip < sizeof...(_Types));\x0a"
"  static_assert(\x21is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);\x0a"
"  return __generic_get<_Ip>(__v);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"constexpr const variant_alternative_t<_Ip, variant<_Types...>>\x26\x26 get(\x0a"
"    const variant<_Types...>\x26\x26 __v) {\x0a"
"  static_assert(_Ip < sizeof...(_Types));\x0a"
"  static_assert(\x21is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);\x0a"
"  return __generic_get<_Ip>(_VSTD\x3a\x3amove(__v));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"constexpr _Tp\x26 get(variant<_Types...>\x26 __v) {\x0a"
"  static_assert(\x21is_void_v<_Tp>);\x0a"
"  return _VSTD\x3a\x3aget<__find_exactly_one_t<_Tp, _Types...>\x3a\x3avalue>(__v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"constexpr _Tp\x26\x26 get(variant<_Types...>\x26\x26 __v) {\x0a"
"  static_assert(\x21is_void_v<_Tp>);\x0a"
"  return _VSTD\x3a\x3aget<__find_exactly_one_t<_Tp, _Types...>\x3a\x3avalue>(\x0a"
"      _VSTD\x3a\x3amove(__v));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"constexpr const _Tp\x26 get(const variant<_Types...>\x26 __v) {\x0a"
"  static_assert(\x21is_void_v<_Tp>);\x0a"
"  return _VSTD\x3a\x3aget<__find_exactly_one_t<_Tp, _Types...>\x3a\x3avalue>(__v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"constexpr const _Tp\x26\x26 get(const variant<_Types...>\x26\x26 __v) {\x0a"
"  static_assert(\x21is_void_v<_Tp>);\x0a"
"  return _VSTD\x3a\x3aget<__find_exactly_one_t<_Tp, _Types...>\x3a\x3avalue>(\x0a"
"      _VSTD\x3a\x3amove(__v));\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class _Vp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr auto* __generic_get_if(_Vp* __v) noexcept {\x0a"
"  using __variant_detail\x3a\x3a__access\x3a\x3a__variant;\x0a"
"  return __v \x26\x26 __holds_alternative<_Ip>(*__v)\x0a"
"             \x3f _VSTD\x3a\x3a""addressof(__variant\x3a\x3a__get_alt<_Ip>(*__v).__value)\x0a"
"             \x3a nullptr;\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr add_pointer_t<variant_alternative_t<_Ip, variant<_Types...>>>\x0a"
"get_if(variant<_Types...>* __v) noexcept {\x0a"
"  static_assert(_Ip < sizeof...(_Types));\x0a"
"  static_assert(\x21is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);\x0a"
"  return __generic_get_if<_Ip>(__v);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Ip, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr add_pointer_t<const variant_alternative_t<_Ip, variant<_Types...>>>\x0a"
"get_if(const variant<_Types...>* __v) noexcept {\x0a"
"  static_assert(_Ip < sizeof...(_Types));\x0a"
"  static_assert(\x21is_void_v<variant_alternative_t<_Ip, variant<_Types...>>>);\x0a"
"  return __generic_get_if<_Ip>(__v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr add_pointer_t<_Tp>\x0a"
"get_if(variant<_Types...>* __v) noexcept {\x0a"
"  static_assert(\x21is_void_v<_Tp>);\x0a"
"  return _VSTD\x3a\x3aget_if<__find_exactly_one_t<_Tp, _Types...>\x3a\x3avalue>(__v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr add_pointer_t<const _Tp>\x0a"
"get_if(const variant<_Types...>* __v) noexcept {\x0a"
"  static_assert(\x21is_void_v<_Tp>);\x0a"
"  return _VSTD\x3a\x3aget_if<__find_exactly_one_t<_Tp, _Types...>\x3a\x3avalue>(__v);\x0a"
"}\x0a"
"\x0a"
"template <class _Operator>\x0a"
"struct __convert_to_bool {\x0a"
"  template <class _T1, class _T2>\x0a"
"  _LIBCPP_INLINE_VISIBILITY constexpr bool operator()(_T1 \x26\x26 __t1, _T2\x26\x26 __t2) const {\x0a"
"    static_assert(std\x3a\x3ais_convertible<decltype(_Operator{}(_VSTD\x3a\x3a""forward<_T1>(__t1), _VSTD\x3a\x3a""forward<_T2>(__t2))), bool>\x3a\x3avalue,\x0a"
"        \x22the relational operator does not return a type which is implicitly convertible to bool\x22);\x0a"
"    return _Operator{}(_VSTD\x3a\x3a""forward<_T1>(__t1), _VSTD\x3a\x3a""forward<_T2>(__t2));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator==(const variant<_Types...>\x26 __lhs,\x0a"
"                          const variant<_Types...>\x26 __rhs) {\x0a"
"  using __variant_detail\x3a\x3a__visitation\x3a\x3a__variant;\x0a"
"  if (__lhs.index() \x21= __rhs.index()) return false;\x0a"
"  if (__lhs.valueless_by_exception()) return true;\x0a"
"  return __variant\x3a\x3a__visit_value_at(__lhs.index(), __convert_to_bool<equal_to<>>{}, __lhs, __rhs);\x0a"
"}\x0a"
"\x0a"
"template <class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator\x21=(const variant<_Types...>\x26 __lhs,\x0a"
"                          const variant<_Types...>\x26 __rhs) {\x0a"
"  using __variant_detail\x3a\x3a__visitation\x3a\x3a__variant;\x0a"
"  if (__lhs.index() \x21= __rhs.index()) return true;\x0a"
"  if (__lhs.valueless_by_exception()) return false;\x0a"
"  return __variant\x3a\x3a__visit_value_at(\x0a"
"      __lhs.index(), __convert_to_bool<not_equal_to<>>{}, __lhs, __rhs);\x0a"
"}\x0a"
"\x0a"
"template <class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator<(const variant<_Types...>\x26 __lhs,\x0a"
"                         const variant<_Types...>\x26 __rhs) {\x0a"
"  using __variant_detail\x3a\x3a__visitation\x3a\x3a__variant;\x0a"
"  if (__rhs.valueless_by_exception()) return false;\x0a"
"  if (__lhs.valueless_by_exception()) return true;\x0a"
"  if (__lhs.index() < __rhs.index()) return true;\x0a"
"  if (__lhs.index() > __rhs.index()) return false;\x0a"
"  return __variant\x3a\x3a__visit_value_at(__lhs.index(), __convert_to_bool<less<>>{}, __lhs, __rhs);\x0a"
"}\x0a"
"\x0a"
"template <class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator>(const variant<_Types...>\x26 __lhs,\x0a"
"                         const variant<_Types...>\x26 __rhs) {\x0a"
"  using __variant_detail\x3a\x3a__visitation\x3a\x3a__variant;\x0a"
"  if (__lhs.valueless_by_exception()) return false;\x0a"
"  if (__rhs.valueless_by_exception()) return true;\x0a"
"  if (__lhs.index() > __rhs.index()) return true;\x0a"
"  if (__lhs.index() < __rhs.index()) return false;\x0a"
"  return __variant\x3a\x3a__visit_value_at(__lhs.index(), __convert_to_bool<greater<>>{}, __lhs, __rhs);\x0a"
"}\x0a"
"\x0a"
"template <class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator<=(const variant<_Types...>\x26 __lhs,\x0a"
"                          const variant<_Types...>\x26 __rhs) {\x0a"
"  using __variant_detail\x3a\x3a__visitation\x3a\x3a__variant;\x0a"
"  if (__lhs.valueless_by_exception()) return true;\x0a"
"  if (__rhs.valueless_by_exception()) return false;\x0a"
"  if (__lhs.index() < __rhs.index()) return true;\x0a"
"  if (__lhs.index() > __rhs.index()) return false;\x0a"
"  return __variant\x3a\x3a__visit_value_at(\x0a"
"      __lhs.index(), __convert_to_bool<less_equal<>>{}, __lhs, __rhs);\x0a"
"}\x0a"
"\x0a"
"template <class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator>=(const variant<_Types...>\x26 __lhs,\x0a"
"                          const variant<_Types...>\x26 __rhs) {\x0a"
"  using __variant_detail\x3a\x3a__visitation\x3a\x3a__variant;\x0a"
"  if (__rhs.valueless_by_exception()) return true;\x0a"
"  if (__lhs.valueless_by_exception()) return false;\x0a"
"  if (__lhs.index() > __rhs.index()) return true;\x0a"
"  if (__lhs.index() < __rhs.index()) return false;\x0a"
"  return __variant\x3a\x3a__visit_value_at(\x0a"
"      __lhs.index(), __convert_to_bool<greater_equal<>>{}, __lhs, __rhs);\x0a"
"}\x0a"
"\x0a"
"template <class _Visitor, class... _Vs>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_THROW_BAD_VARIANT_ACCESS\x0a"
"constexpr decltype(auto) visit(_Visitor\x26\x26 __visitor, _Vs\x26\x26... __vs) {\x0a"
"  using __variant_detail\x3a\x3a__visitation\x3a\x3a__variant;\x0a"
"  bool __results\x5b\x5d = {__vs.valueless_by_exception()...};\x0a"
"  for (bool __result \x3a __results) {\x0a"
"    if (__result) {\x0a"
"      __throw_bad_variant_access();\x0a"
"    }\x0a"
"  }\x0a"
"  return __variant\x3a\x3a__visit_value(_VSTD\x3a\x3a""forward<_Visitor>(__visitor),\x0a"
"                                  _VSTD\x3a\x3a""forward<_Vs>(__vs)...);\x0a"
"}\x0a"
"\x0a"
"struct _LIBCPP_TEMPLATE_VIS monostate {};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator<(monostate, monostate) noexcept { return false; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator>(monostate, monostate) noexcept { return false; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator<=(monostate, monostate) noexcept { return true; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator>=(monostate, monostate) noexcept { return true; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator==(monostate, monostate) noexcept { return true; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"constexpr bool operator\x21=(monostate, monostate) noexcept { return false; }\x0a"
"\x0a"
"template <class... _Types>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto swap(variant<_Types...>\x26 __lhs,\x0a"
"          variant<_Types...>\x26 __rhs) noexcept(noexcept(__lhs.swap(__rhs)))\x0a"
"    -> decltype(__lhs.swap(__rhs)) {\x0a"
"  __lhs.swap(__rhs);\x0a"
"}\x0a"
"\x0a"
"template <class... _Types>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<\x0a"
"    __enable_hash_helper<variant<_Types...>, remove_const_t<_Types>...>> {\x0a"
"  using argument_type = variant<_Types...>;\x0a"
"  using result_type = size_t;\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  result_type operator()(const argument_type\x26 __v) const {\x0a"
"    using __variant_detail\x3a\x3a__visitation\x3a\x3a__variant;\x0a"
"    size_t __res =\x0a"
"        __v.valueless_by_exception()\x0a"
"               \x3f 299792458 // Random value chosen by the universe upon creation\x0a"
"               \x3a __variant\x3a\x3a__visit_alt(\x0a"
"                     \x5b\x5d(const auto\x26 __alt) {\x0a"
"                       using __alt_type = __uncvref_t<decltype(__alt)>;\x0a"
"                       using __value_type = remove_const_t<\x0a"
"                         typename __alt_type\x3a\x3a__value_type>;\x0a"
"                       return hash<__value_type>{}(__alt.__value);\x0a"
"                     },\x0a"
"                     __v);\x0a"
"    return __hash_combine(__res, hash<size_t>{}(__v.index()));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<monostate> {\x0a"
"  using argument_type = monostate;\x0a"
"  using result_type = size_t;\x0a"
"\x0a"
"  inline _LIBCPP_INLINE_VISIBILITY\x0a"
"  result_type operator()(const argument_type\x26) const _NOEXCEPT {\x0a"
"    return 66740831; // return a fundamentally attractive random value.\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_VARIANT\x0a"
"", 62010 ); }