#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_algorithm_cpp( 
"//===----------------------- algorithm.cpp --------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22""algorithm\x22\x0a"
"#include \x22random\x22\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"#include \x22mutex\x22\x0a"
"#if defined(__unix__) \x26\x26  defined(__ELF__) \x26\x26 defined(_LIBCPP_HAS_COMMENT_LIB_PRAGMA)\x0a"
"#pragma comment(lib, \x22pthread\x22)\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template void __sort<__less<char>\x26, char*>(char*, char*, __less<char>\x26);\x0a"
"template void __sort<__less<wchar_t>\x26, wchar_t*>(wchar_t*, wchar_t*, __less<wchar_t>\x26);\x0a"
"template void __sort<__less<signed char>\x26, signed char*>(signed char*, signed char*, __less<signed char>\x26);\x0a"
"template void __sort<__less<unsigned char>\x26, unsigned char*>(unsigned char*, unsigned char*, __less<unsigned char>\x26);\x0a"
"template void __sort<__less<short>\x26, short*>(short*, short*, __less<short>\x26);\x0a"
"template void __sort<__less<unsigned short>\x26, unsigned short*>(unsigned short*, unsigned short*, __less<unsigned short>\x26);\x0a"
"template void __sort<__less<int>\x26, int*>(int*, int*, __less<int>\x26);\x0a"
"template void __sort<__less<unsigned>\x26, unsigned*>(unsigned*, unsigned*, __less<unsigned>\x26);\x0a"
"template void __sort<__less<long>\x26, long*>(long*, long*, __less<long>\x26);\x0a"
"template void __sort<__less<unsigned long>\x26, unsigned long*>(unsigned long*, unsigned long*, __less<unsigned long>\x26);\x0a"
"template void __sort<__less<long long>\x26, long long*>(long long*, long long*, __less<long long>\x26);\x0a"
"template void __sort<__less<unsigned long long>\x26, unsigned long long*>(unsigned long long*, unsigned long long*, __less<unsigned long long>\x26);\x0a"
"template void __sort<__less<float>\x26, float*>(float*, float*, __less<float>\x26);\x0a"
"template void __sort<__less<double>\x26, double*>(double*, double*, __less<double>\x26);\x0a"
"template void __sort<__less<long double>\x26, long double*>(long double*, long double*, __less<long double>\x26);\x0a"
"\x0a"
"template bool __insertion_sort_incomplete<__less<char>\x26, char*>(char*, char*, __less<char>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<wchar_t>\x26, wchar_t*>(wchar_t*, wchar_t*, __less<wchar_t>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<signed char>\x26, signed char*>(signed char*, signed char*, __less<signed char>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<unsigned char>\x26, unsigned char*>(unsigned char*, unsigned char*, __less<unsigned char>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<short>\x26, short*>(short*, short*, __less<short>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<unsigned short>\x26, unsigned short*>(unsigned short*, unsigned short*, __less<unsigned short>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<int>\x26, int*>(int*, int*, __less<int>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<unsigned>\x26, unsigned*>(unsigned*, unsigned*, __less<unsigned>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<long>\x26, long*>(long*, long*, __less<long>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<unsigned long>\x26, unsigned long*>(unsigned long*, unsigned long*, __less<unsigned long>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<long long>\x26, long long*>(long long*, long long*, __less<long long>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<unsigned long long>\x26, unsigned long long*>(unsigned long long*, unsigned long long*, __less<unsigned long long>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<float>\x26, float*>(float*, float*, __less<float>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<double>\x26, double*>(double*, double*, __less<double>\x26);\x0a"
"template bool __insertion_sort_incomplete<__less<long double>\x26, long double*>(long double*, long double*, __less<long double>\x26);\x0a"
"\x0a"
"template unsigned __sort5<__less<long double>\x26, long double*>(long double*, long double*, long double*, long double*, long double*, __less<long double>\x26);\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"_LIBCPP_SAFE_STATIC static __libcpp_mutex_t __rs_mut = _LIBCPP_MUTEX_INITIALIZER;\x0a"
"#endif\x0a"
"unsigned __rs_default\x3a\x3a__c_ = 0;\x0a"
"\x0a"
"__rs_default\x3a\x3a__rs_default()\x0a"
"{\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"    __libcpp_mutex_lock(\x26__rs_mut);\x0a"
"#endif\x0a"
"    __c_ = 1;\x0a"
"}\x0a"
"\x0a"
"__rs_default\x3a\x3a__rs_default(const __rs_default\x26)\x0a"
"{\x0a"
"    ++__c_;\x0a"
"}\x0a"
"\x0a"
"__rs_default\x3a\x3a\x7e__rs_default()\x0a"
"{\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"    if (--__c_ == 0)\x0a"
"       __libcpp_mutex_unlock(\x26__rs_mut);\x0a"
"#else\x0a"
"    --__c_;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"__rs_default\x3a\x3aresult_type\x0a"
"__rs_default\x3a\x3aoperator()()\x0a"
"{\x0a"
"    static mt19937 __rs_g;\x0a"
"    return __rs_g();\x0a"
"}\x0a"
"\x0a"
"__rs_default\x0a"
"__rs_get()\x0a"
"{\x0a"
"    return __rs_default();\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 4674 ); }