#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_charconv_cpp( 
"//===------------------------- charconv.cpp -------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22""charconv\x22\x0a"
"#include <string.h>\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"namespace __itoa\x0a"
"{\x0a"
"\x0a"
"static constexpr char cDigitsLut\x5b""200\x5d = {\x0a"
"    '0', '0', '0', '1', '0', '2', '0', '3', '0', '4', '0', '5', '0', '6', '0',\x0a"
"    '7', '0', '8', '0', '9', '1', '0', '1', '1', '1', '2', '1', '3', '1', '4',\x0a"
"    '1', '5', '1', '6', '1', '7', '1', '8', '1', '9', '2', '0', '2', '1', '2',\x0a"
"    '2', '2', '3', '2', '4', '2', '5', '2', '6', '2', '7', '2', '8', '2', '9',\x0a"
"    '3', '0', '3', '1', '3', '2', '3', '3', '3', '4', '3', '5', '3', '6', '3',\x0a"
"    '7', '3', '8', '3', '9', '4', '0', '4', '1', '4', '2', '4', '3', '4', '4',\x0a"
"    '4', '5', '4', '6', '4', '7', '4', '8', '4', '9', '5', '0', '5', '1', '5',\x0a"
"    '2', '5', '3', '5', '4', '5', '5', '5', '6', '5', '7', '5', '8', '5', '9',\x0a"
"    '6', '0', '6', '1', '6', '2', '6', '3', '6', '4', '6', '5', '6', '6', '6',\x0a"
"    '7', '6', '8', '6', '9', '7', '0', '7', '1', '7', '2', '7', '3', '7', '4',\x0a"
"    '7', '5', '7', '6', '7', '7', '7', '8', '7', '9', '8', '0', '8', '1', '8',\x0a"
"    '2', '8', '3', '8', '4', '8', '5', '8', '6', '8', '7', '8', '8', '8', '9',\x0a"
"    '9', '0', '9', '1', '9', '2', '9', '3', '9', '4', '9', '5', '9', '6', '9',\x0a"
"    '7', '9', '8', '9', '9'};\x0a"
"\x0a"
"template <typename T>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY char*\x0a"
"append1(char* buffer, T i)\x0a"
"{\x0a"
"    *buffer = '0' + static_cast<char>(i);\x0a"
"    return buffer + 1;\x0a"
"}\x0a"
"\x0a"
"template <typename T>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY char*\x0a"
"append2(char* buffer, T i)\x0a"
"{\x0a"
"    memcpy(buffer, \x26""cDigitsLut\x5b(i)*2\x5d, 2);\x0a"
"    return buffer + 2;\x0a"
"}\x0a"
"\x0a"
"template <typename T>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY char*\x0a"
"append3(char* buffer, T i)\x0a"
"{\x0a"
"    return append2(append1(buffer, (i) / 100), (i) \x25 100);\x0a"
"}\x0a"
"\x0a"
"template <typename T>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY char*\x0a"
"append4(char* buffer, T i)\x0a"
"{\x0a"
"    return append2(append2(buffer, (i) / 100), (i) \x25 100);\x0a"
"}\x0a"
"\x0a"
"template <typename T>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY char*\x0a"
"append2_no_zeros(char* buffer, T v)\x0a"
"{\x0a"
"    if (v < 10)\x0a"
"        return append1(buffer, v);\x0a"
"    else\x0a"
"        return append2(buffer, v);\x0a"
"}\x0a"
"\x0a"
"template <typename T>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY char*\x0a"
"append4_no_zeros(char* buffer, T v)\x0a"
"{\x0a"
"    if (v < 100)\x0a"
"        return append2_no_zeros(buffer, v);\x0a"
"    else if (v < 1000)\x0a"
"        return append3(buffer, v);\x0a"
"    else\x0a"
"        return append4(buffer, v);\x0a"
"}\x0a"
"\x0a"
"template <typename T>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY char*\x0a"
"append8_no_zeros(char* buffer, T v)\x0a"
"{\x0a"
"    if (v < 10000)\x0a"
"    {\x0a"
"        buffer = append4_no_zeros(buffer, v);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        buffer = append4_no_zeros(buffer, v / 10000);\x0a"
"        buffer = append4(buffer, v \x25 10000);\x0a"
"    }\x0a"
"    return buffer;\x0a"
"}\x0a"
"\x0a"
"char*\x0a"
"__u32toa(uint32_t value, char* buffer)\x0a"
"{\x0a"
"    if (value < 100000000)\x0a"
"    {\x0a"
"        buffer = append8_no_zeros(buffer, value);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        // value = aabbbbcccc in decimal\x0a"
"        const uint32_t a = value / 100000000;  // 1 to 42\x0a"
"        value \x25= 100000000;\x0a"
"\x0a"
"        buffer = append2_no_zeros(buffer, a);\x0a"
"        buffer = append4(buffer, value / 10000);\x0a"
"        buffer = append4(buffer, value \x25 10000);\x0a"
"    }\x0a"
"\x0a"
"    return buffer;\x0a"
"}\x0a"
"\x0a"
"char*\x0a"
"__u64toa(uint64_t value, char* buffer)\x0a"
"{\x0a"
"    if (value < 100000000)\x0a"
"    {\x0a"
"        uint32_t v = static_cast<uint32_t>(value);\x0a"
"        buffer = append8_no_zeros(buffer, v);\x0a"
"    }\x0a"
"    else if (value < 10000000000000000)\x0a"
"    {\x0a"
"        const uint32_t v0 = static_cast<uint32_t>(value / 100000000);\x0a"
"        const uint32_t v1 = static_cast<uint32_t>(value \x25 100000000);\x0a"
"\x0a"
"        buffer = append8_no_zeros(buffer, v0);\x0a"
"        buffer = append4(buffer, v1 / 10000);\x0a"
"        buffer = append4(buffer, v1 \x25 10000);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        const uint32_t a =\x0a"
"            static_cast<uint32_t>(value / 10000000000000000);  // 1 to 1844\x0a"
"        value \x25= 10000000000000000;\x0a"
"\x0a"
"        buffer = append4_no_zeros(buffer, a);\x0a"
"\x0a"
"        const uint32_t v0 = static_cast<uint32_t>(value / 100000000);\x0a"
"        const uint32_t v1 = static_cast<uint32_t>(value \x25 100000000);\x0a"
"        buffer = append4(buffer, v0 / 10000);\x0a"
"        buffer = append4(buffer, v0 \x25 10000);\x0a"
"        buffer = append4(buffer, v1 / 10000);\x0a"
"        buffer = append4(buffer, v1 \x25 10000);\x0a"
"    }\x0a"
"\x0a"
"    return buffer;\x0a"
"}\x0a"
"\x0a"
"}  // namespace __itoa\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 4533 ); }