#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_condition_variable_cpp( 
"//===-------------------- condition_variable.cpp --------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22__config\x22\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"#include \x22""condition_variable\x22\x0a"
"#include \x22thread\x22\x0a"
"#include \x22system_error\x22\x0a"
"#include \x22__undef_macros\x22\x0a"
"\x0a"
"#if defined(__unix__) \x26\x26  defined(__ELF__) \x26\x26 defined(_LIBCPP_HAS_COMMENT_LIB_PRAGMA)\x0a"
"#pragma comment(lib, \x22pthread\x22)\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// \x7e""condition_variable is defined elsewhere.\x0a"
"\x0a"
"void\x0a"
"condition_variable\x3a\x3anotify_one() _NOEXCEPT\x0a"
"{\x0a"
"    __libcpp_condvar_signal(\x26__cv_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"condition_variable\x3a\x3anotify_all() _NOEXCEPT\x0a"
"{\x0a"
"    __libcpp_condvar_broadcast(\x26__cv_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"condition_variable\x3a\x3await(unique_lock<mutex>\x26 lk) _NOEXCEPT\x0a"
"{\x0a"
"    if (\x21lk.owns_lock())\x0a"
"        __throw_system_error(EPERM,\x0a"
"                                  \x22""condition_variable\x3a\x3await\x3a mutex not locked\x22);\x0a"
"    int ec = __libcpp_condvar_wait(\x26__cv_, lk.mutex()->native_handle());\x0a"
"    if (ec)\x0a"
"        __throw_system_error(ec, \x22""condition_variable wait failed\x22);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"condition_variable\x3a\x3a__do_timed_wait(unique_lock<mutex>\x26 lk,\x0a"
"     chrono\x3a\x3atime_point<chrono\x3a\x3asystem_clock, chrono\x3a\x3ananoseconds> tp) _NOEXCEPT\x0a"
"{\x0a"
"    using namespace chrono;\x0a"
"    if (\x21lk.owns_lock())\x0a"
"        __throw_system_error(EPERM,\x0a"
"                            \x22""condition_variable\x3a\x3atimed wait\x3a mutex not locked\x22);\x0a"
"    nanoseconds d = tp.time_since_epoch();\x0a"
"    if (d > nanoseconds(0x59682F000000E941))\x0a"
"        d = nanoseconds(0x59682F000000E941);\x0a"
"    __libcpp_timespec_t ts;\x0a"
"    seconds s = duration_cast<seconds>(d);\x0a"
"    typedef decltype(ts.tv_sec) ts_sec;\x0a"
"    _LIBCPP_CONSTEXPR ts_sec ts_sec_max = numeric_limits<ts_sec>\x3a\x3amax();\x0a"
"    if (s.count() < ts_sec_max)\x0a"
"    {\x0a"
"        ts.tv_sec = static_cast<ts_sec>(s.count());\x0a"
"        ts.tv_nsec = static_cast<decltype(ts.tv_nsec)>((d - s).count());\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        ts.tv_sec = ts_sec_max;\x0a"
"        ts.tv_nsec = giga\x3a\x3anum - 1;\x0a"
"    }\x0a"
"    int ec = __libcpp_condvar_timedwait(\x26__cv_, lk.mutex()->native_handle(), \x26ts);\x0a"
"    if (ec \x21= 0 \x26\x26 ec \x21= ETIMEDOUT)\x0a"
"        __throw_system_error(ec, \x22""condition_variable timed_wait failed\x22);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"notify_all_at_thread_exit(condition_variable\x26 cond, unique_lock<mutex> lk)\x0a"
"{\x0a"
"    auto\x26 tl_ptr = __thread_local_data();\x0a"
"    // If this thread was not created using std\x3a\x3athread then it will not have\x0a"
"    // previously allocated.\x0a"
"    if (tl_ptr.get() == nullptr) {\x0a"
"        tl_ptr.set_pointer(new __thread_struct);\x0a"
"    }\x0a"
"    __thread_local_data()->notify_all_at_thread_exit(\x26""cond, lk.release());\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"", 2819 ); }