#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_condition_variable_destructor_cpp( 
"//===---------------- condition_variable_destructor.cpp ------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"// Define \x7e""condition_variable.\x0a"
"//\x0a"
"// On some platforms \x7e""condition_variable has been made trivial and the\x0a"
"// definition is only provided for ABI compatibility.\x0a"
"\x0a"
"#include \x22__config\x22\x0a"
"#include \x22__threading_support\x22\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_THREADS)\x0a"
"# if _LIBCPP_ABI_VERSION == 1 \x7c\x7c \x21""defined(_LIBCPP_HAS_TRIVIAL_CONDVAR_DESTRUCTION)\x0a"
"#   define NEEDS_CONDVAR_DESTRUCTOR\x0a"
"# endif\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#ifdef NEEDS_CONDVAR_DESTRUCTOR\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS condition_variable\x0a"
"{\x0a"
"    __libcpp_condvar_t __cv_ = _LIBCPP_CONDVAR_INITIALIZER;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr condition_variable() noexcept = default;\x0a"
"\x0a"
"    \x7e""condition_variable();\x0a"
"\x0a"
"    condition_variable(const condition_variable\x26) = delete;\x0a"
"    condition_variable\x26 operator=(const condition_variable\x26)  = delete;\x0a"
"};\x0a"
"\x0a"
"condition_variable\x3a\x3a\x7e""condition_variable()\x0a"
"{\x0a"
"    __libcpp_condvar_destroy(\x26__cv_);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 1295 ); }