#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_future_cpp( 
"//===------------------------- future.cpp ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22__config\x22\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"#include \x22""future\x22\x0a"
"#include \x22string\x22\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"class _LIBCPP_HIDDEN __future_error_category\x0a"
"    \x3a public __do_message\x0a"
"{\x0a"
"public\x3a\x0a"
"    virtual const char* name() const _NOEXCEPT;\x0a"
"    virtual string message(int ev) const;\x0a"
"};\x0a"
"\x0a"
"const char*\x0a"
"__future_error_category\x3a\x3aname() const _NOEXCEPT\x0a"
"{\x0a"
"    return \x22""future\x22;\x0a"
"}\x0a"
"\x0a"
"#if defined(__clang__)\x0a"
"#pragma clang diagnostic push\x0a"
"#pragma clang diagnostic ignored \x22-Wswitch\x22\x0a"
"#elif defined(__GNUC__) \x7c\x7c defined(__GNUG__)\x0a"
"#pragma GCC diagnostic push\x0a"
"#pragma GCC diagnostic ignored \x22-Wswitch\x22\x0a"
"#endif\x0a"
"\x0a"
"string\x0a"
"__future_error_category\x3a\x3amessage(int ev) const\x0a"
"{\x0a"
"    switch (static_cast<future_errc>(ev))\x0a"
"    {\x0a"
"    case future_errc(0)\x3a  // For backwards compatibility with C++11 (LWG 2056)\x0a"
"    case future_errc\x3a\x3a""broken_promise\x3a\x0a"
"        return string(\x22The associated promise has been destructed prior \x22\x0a"
"                      \x22to the associated state becoming ready.\x22);\x0a"
"    case future_errc\x3a\x3a""future_already_retrieved\x3a\x0a"
"        return string(\x22The future has already been retrieved from \x22\x0a"
"                      \x22the promise or packaged_task.\x22);\x0a"
"    case future_errc\x3a\x3apromise_already_satisfied\x3a\x0a"
"        return string(\x22The state of the promise has already been set.\x22);\x0a"
"    case future_errc\x3a\x3ano_state\x3a\x0a"
"        return string(\x22Operation not permitted on an object without \x22\x0a"
"                      \x22""an associated state.\x22);\x0a"
"    }\x0a"
"    return string(\x22unspecified future_errc value\x5cn\x22);\x0a"
"}\x0a"
"\x0a"
"#if defined(__clang__)\x0a"
"#pragma clang diagnostic pop\x0a"
"#elif defined(__GNUC__) \x7c\x7c defined(__GNUG__)\x0a"
"#pragma GCC diagnostic pop\x0a"
"#endif\x0a"
"\x0a"
"const error_category\x26\x0a"
"future_category() _NOEXCEPT\x0a"
"{\x0a"
"    static __future_error_category __f;\x0a"
"    return __f;\x0a"
"}\x0a"
"\x0a"
"future_error\x3a\x3a""future_error(error_code __ec)\x0a"
"    \x3a logic_error(__ec.message()),\x0a"
"      __ec_(__ec)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"future_error\x3a\x3a\x7e""future_error() _NOEXCEPT\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__assoc_sub_state\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    delete this;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__assoc_sub_state\x3a\x3aset_value()\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(__mut_);\x0a"
"    if (__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"    __state_ \x7c= __constructed \x7c ready;\x0a"
"    __cv_.notify_all();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__assoc_sub_state\x3a\x3aset_value_at_thread_exit()\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(__mut_);\x0a"
"    if (__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"    __state_ \x7c= __constructed;\x0a"
"    __thread_local_data()->__make_ready_at_thread_exit(this);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__assoc_sub_state\x3a\x3aset_exception(exception_ptr __p)\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(__mut_);\x0a"
"    if (__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"    __exception_ = __p;\x0a"
"    __state_ \x7c= ready;\x0a"
"    __cv_.notify_all();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__assoc_sub_state\x3a\x3aset_exception_at_thread_exit(exception_ptr __p)\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(__mut_);\x0a"
"    if (__has_value())\x0a"
"        __throw_future_error(future_errc\x3a\x3apromise_already_satisfied);\x0a"
"    __exception_ = __p;\x0a"
"    __thread_local_data()->__make_ready_at_thread_exit(this);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__assoc_sub_state\x3a\x3a__make_ready()\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(__mut_);\x0a"
"    __state_ \x7c= ready;\x0a"
"    __cv_.notify_all();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__assoc_sub_state\x3a\x3a""copy()\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(__mut_);\x0a"
"    __sub_wait(__lk);\x0a"
"    if (__exception_ \x21= nullptr)\x0a"
"        rethrow_exception(__exception_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__assoc_sub_state\x3a\x3await()\x0a"
"{\x0a"
"    unique_lock<mutex> __lk(__mut_);\x0a"
"    __sub_wait(__lk);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__assoc_sub_state\x3a\x3a__sub_wait(unique_lock<mutex>\x26 __lk)\x0a"
"{\x0a"
"    if (\x21__is_ready())\x0a"
"    {\x0a"
"        if (__state_ \x26 static_cast<unsigned>(deferred))\x0a"
"        {\x0a"
"            __state_ \x26= \x7estatic_cast<unsigned>(deferred);\x0a"
"            __lk.unlock();\x0a"
"            __execute();\x0a"
"        }\x0a"
"        else\x0a"
"            while (\x21__is_ready())\x0a"
"                __cv_.wait(__lk);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__assoc_sub_state\x3a\x3a__execute()\x0a"
"{\x0a"
"    __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"}\x0a"
"\x0a"
"future<void>\x3a\x3a""future(__assoc_sub_state* __state)\x0a"
"    \x3a __state_(__state)\x0a"
"{\x0a"
"    __state_->__attach_future();\x0a"
"}\x0a"
"\x0a"
"future<void>\x3a\x3a\x7e""future()\x0a"
"{\x0a"
"    if (__state_)\x0a"
"        __state_->__release_shared();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"future<void>\x3a\x3aget()\x0a"
"{\x0a"
"    unique_ptr<__shared_count, __release_shared_count> __(__state_);\x0a"
"    __assoc_sub_state* __s = __state_;\x0a"
"    __state_ = nullptr;\x0a"
"    __s->copy();\x0a"
"}\x0a"
"\x0a"
"promise<void>\x3a\x3apromise()\x0a"
"    \x3a __state_(new __assoc_sub_state)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"promise<void>\x3a\x3a\x7epromise()\x0a"
"{\x0a"
"    if (__state_)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        if (\x21__state_->__has_value() \x26\x26 __state_->use_count() > 1)\x0a"
"            __state_->set_exception(make_exception_ptr(\x0a"
"                      future_error(make_error_code(future_errc\x3a\x3a""broken_promise))\x0a"
"                                                      ));\x0a"
"#endif // _LIBCPP_NO_EXCEPTIONS\x0a"
"        __state_->__release_shared();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"future<void>\x0a"
"promise<void>\x3a\x3aget_future()\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    return future<void>(__state_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"promise<void>\x3a\x3aset_value()\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_value();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"promise<void>\x3a\x3aset_exception(exception_ptr __p)\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_exception(__p);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"promise<void>\x3a\x3aset_value_at_thread_exit()\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_value_at_thread_exit();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"promise<void>\x3a\x3aset_exception_at_thread_exit(exception_ptr __p)\x0a"
"{\x0a"
"    if (__state_ == nullptr)\x0a"
"        __throw_future_error(future_errc\x3a\x3ano_state);\x0a"
"    __state_->set_exception_at_thread_exit(__p);\x0a"
"}\x0a"
"\x0a"
"shared_future<void>\x3a\x3a\x7eshared_future()\x0a"
"{\x0a"
"    if (__state_)\x0a"
"        __state_->__release_shared();\x0a"
"}\x0a"
"\x0a"
"shared_future<void>\x26\x0a"
"shared_future<void>\x3a\x3aoperator=(const shared_future\x26 __rhs)\x0a"
"{\x0a"
"    if (__rhs.__state_)\x0a"
"        __rhs.__state_->__add_shared();\x0a"
"    if (__state_)\x0a"
"        __state_->__release_shared();\x0a"
"    __state_ = __rhs.__state_;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"", 6364 ); }