#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_hash_cpp( 
"//===-------------------------- hash.cpp ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22__hash_table\x22\x0a"
"#include \x22""algorithm\x22\x0a"
"#include \x22stdexcept\x22\x0a"
"#include \x22type_traits\x22\x0a"
"\x0a"
"#ifdef __clang__\x0a"
"#pragma clang diagnostic ignored \x22-Wtautological-constant-out-of-range-compare\x22\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"namespace {\x0a"
"\x0a"
"// handle all next_prime(i) for i in \x5b""1, 210), special case 0\x0a"
"const unsigned small_primes\x5b\x5d =\x0a"
"{\x0a"
"    0,\x0a"
"    2,\x0a"
"    3,\x0a"
"    5,\x0a"
"    7,\x0a"
"    11,\x0a"
"    13,\x0a"
"    17,\x0a"
"    19,\x0a"
"    23,\x0a"
"    29,\x0a"
"    31,\x0a"
"    37,\x0a"
"    41,\x0a"
"    43,\x0a"
"    47,\x0a"
"    53,\x0a"
"    59,\x0a"
"    61,\x0a"
"    67,\x0a"
"    71,\x0a"
"    73,\x0a"
"    79,\x0a"
"    83,\x0a"
"    89,\x0a"
"    97,\x0a"
"    101,\x0a"
"    103,\x0a"
"    107,\x0a"
"    109,\x0a"
"    113,\x0a"
"    127,\x0a"
"    131,\x0a"
"    137,\x0a"
"    139,\x0a"
"    149,\x0a"
"    151,\x0a"
"    157,\x0a"
"    163,\x0a"
"    167,\x0a"
"    173,\x0a"
"    179,\x0a"
"    181,\x0a"
"    191,\x0a"
"    193,\x0a"
"    197,\x0a"
"    199,\x0a"
"    211\x0a"
"};\x0a"
"\x0a"
"// potential primes = 210*k + indices\x5bi\x5d, k >= 1\x0a"
"//   these numbers are not divisible by 2, 3, 5 or 7\x0a"
"//   (or any integer 2 <= j <= 10 for that matter).\x0a"
"const unsigned indices\x5b\x5d =\x0a"
"{\x0a"
"    1,\x0a"
"    11,\x0a"
"    13,\x0a"
"    17,\x0a"
"    19,\x0a"
"    23,\x0a"
"    29,\x0a"
"    31,\x0a"
"    37,\x0a"
"    41,\x0a"
"    43,\x0a"
"    47,\x0a"
"    53,\x0a"
"    59,\x0a"
"    61,\x0a"
"    67,\x0a"
"    71,\x0a"
"    73,\x0a"
"    79,\x0a"
"    83,\x0a"
"    89,\x0a"
"    97,\x0a"
"    101,\x0a"
"    103,\x0a"
"    107,\x0a"
"    109,\x0a"
"    113,\x0a"
"    121,\x0a"
"    127,\x0a"
"    131,\x0a"
"    137,\x0a"
"    139,\x0a"
"    143,\x0a"
"    149,\x0a"
"    151,\x0a"
"    157,\x0a"
"    163,\x0a"
"    167,\x0a"
"    169,\x0a"
"    173,\x0a"
"    179,\x0a"
"    181,\x0a"
"    187,\x0a"
"    191,\x0a"
"    193,\x0a"
"    197,\x0a"
"    199,\x0a"
"    209\x0a"
"};\x0a"
"\x0a"
"}\x0a"
"\x0a"
"// Returns\x3a  If n == 0, returns 0.  Else returns the lowest prime number that\x0a"
"// is greater than or equal to n.\x0a"
"//\x0a"
"// The algorithm creates a list of small primes, plus an open-ended list of\x0a"
"// potential primes.  All prime numbers are potential prime numbers.  However\x0a"
"// some potential prime numbers are not prime.  In an ideal world, all potential\x0a"
"// prime numbers would be prime.  Candidate prime numbers are chosen as the next\x0a"
"// highest potential prime.  Then this number is tested for prime by dividing it\x0a"
"// by all potential prime numbers less than the sqrt of the candidate.\x0a"
"//\x0a"
"// This implementation defines potential primes as those numbers not divisible\x0a"
"// by 2, 3, 5, and 7.  Other (common) implementations define potential primes\x0a"
"// as those not divisible by 2.  A few other implementations define potential\x0a"
"// primes as those not divisible by 2 or 3.  By raising the number of small\x0a"
"// primes which the potential prime is not divisible by, the set of potential\x0a"
"// primes more closely approximates the set of prime numbers.  And thus there\x0a"
"// are fewer potential primes to search, and fewer potential primes to divide\x0a"
"// against.\x0a"
"\x0a"
"template <size_t _Sz = sizeof(size_t)>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if<_Sz == 4, void>\x3a\x3atype\x0a"
"__check_for_overflow(size_t N)\x0a"
"{\x0a"
"    if (N > 0xFFFFFFFB)\x0a"
"        __throw_overflow_error(\x22__next_prime overflow\x22);\x0a"
"}\x0a"
"\x0a"
"template <size_t _Sz = sizeof(size_t)>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if<_Sz == 8, void>\x3a\x3atype\x0a"
"__check_for_overflow(size_t N)\x0a"
"{\x0a"
"    if (N > 0xFFFFFFFFFFFFFFC5ull)\x0a"
"        __throw_overflow_error(\x22__next_prime overflow\x22);\x0a"
"}\x0a"
"\x0a"
"size_t\x0a"
"__next_prime(size_t n)\x0a"
"{\x0a"
"    const size_t L = 210;\x0a"
"    const size_t N = sizeof(small_primes) / sizeof(small_primes\x5b""0\x5d);\x0a"
"    // If n is small enough, search in small_primes\x0a"
"    if (n <= small_primes\x5bN-1\x5d)\x0a"
"        return *std\x3a\x3alower_bound(small_primes, small_primes + N, n);\x0a"
"    // Else n > largest small_primes\x0a"
"    // Check for overflow\x0a"
"    __check_for_overflow(n);\x0a"
"    // Start searching list of potential primes\x3a L * k0 + indices\x5bin\x5d\x0a"
"    const size_t M = sizeof(indices) / sizeof(indices\x5b""0\x5d);\x0a"
"    // Select first potential prime >= n\x0a"
"    //   Known a-priori n >= L\x0a"
"    size_t k0 = n / L;\x0a"
"    size_t in = static_cast<size_t>(std\x3a\x3alower_bound(indices, indices + M, n - k0 * L)\x0a"
"                                    - indices);\x0a"
"    n = L * k0 + indices\x5bin\x5d;\x0a"
"    while (true)\x0a"
"    {\x0a"
"        // Divide n by all primes or potential primes (i) until\x3a\x0a"
"        //    1.  The division is even, so try next potential prime.\x0a"
"        //    2.  The i > sqrt(n), in which case n is prime.\x0a"
"        // It is known a-priori that n is not divisible by 2, 3, 5 or 7,\x0a"
"        //    so don't test those (j == 5 ->  divide by 11 first).  And the\x0a"
"        //    potential primes start with 211, so don't test against the last\x0a"
"        //    small prime.\x0a"
"        for (size_t j = 5; j < N - 1; ++j)\x0a"
"        {\x0a"
"            const std\x3a\x3asize_t p = small_primes\x5bj\x5d;\x0a"
"            const std\x3a\x3asize_t q = n / p;\x0a"
"            if (q < p)\x0a"
"                return n;\x0a"
"            if (n == q * p)\x0a"
"                goto next;\x0a"
"        }\x0a"
"        // n wasn't divisible by small primes, try potential primes\x0a"
"        {\x0a"
"            size_t i = 211;\x0a"
"            while (true)\x0a"
"            {\x0a"
"                std\x3a\x3asize_t q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 10;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 8;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 8;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 6;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 4;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 2;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                i += 10;\x0a"
"                q = n / i;\x0a"
"                if (q < i)\x0a"
"                    return n;\x0a"
"                if (n == q * i)\x0a"
"                    break;\x0a"
"\x0a"
"                // This will loop i to the next \x22plane\x22 of potential primes\x0a"
"                i += 2;\x0a"
"            }\x0a"
"        }\x0a"
"next\x3a\x0a"
"        // n is not prime.  Increment n to next potential prime.\x0a"
"        if (++in == M)\x0a"
"        {\x0a"
"            ++k0;\x0a"
"            in = 0;\x0a"
"        }\x0a"
"        n = L * k0 + indices\x5bin\x5d;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 13356 ); }