#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_ios_cpp( 
"//===-------------------------- ios.cpp -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22__config\x22\x0a"
"\x0a"
"#include \x22ios\x22\x0a"
"\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"#include \x22__locale\x22\x0a"
"#include \x22""algorithm\x22\x0a"
"#include \x22include/config_elast.h\x22\x0a"
"#include \x22istream\x22\x0a"
"#include \x22limits\x22\x0a"
"#include \x22memory\x22\x0a"
"#include \x22new\x22\x0a"
"#include \x22streambuf\x22\x0a"
"#include \x22string\x22\x0a"
"#include \x22__undef_macros\x22\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_ios<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_ios<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_streambuf<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_streambuf<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_istream<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_istream<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_ostream<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_ostream<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_iostream<char>;\x0a"
"\x0a"
"class _LIBCPP_HIDDEN __iostream_category\x0a"
"    \x3a public __do_message\x0a"
"{\x0a"
"public\x3a\x0a"
"    virtual const char* name() const _NOEXCEPT;\x0a"
"    virtual string message(int ev) const;\x0a"
"};\x0a"
"\x0a"
"const char*\x0a"
"__iostream_category\x3a\x3aname() const _NOEXCEPT\x0a"
"{\x0a"
"    return \x22iostream\x22;\x0a"
"}\x0a"
"\x0a"
"string\x0a"
"__iostream_category\x3a\x3amessage(int ev) const\x0a"
"{\x0a"
"    if (ev \x21= static_cast<int>(io_errc\x3a\x3astream)\x0a"
"#ifdef _LIBCPP_ELAST\x0a"
"        \x26\x26 ev <= _LIBCPP_ELAST\x0a"
"#endif  // _LIBCPP_ELAST\x0a"
"        )\x0a"
"        return __do_message\x3a\x3amessage(ev);\x0a"
"    return string(\x22unspecified iostream_category error\x22);\x0a"
"}\x0a"
"\x0a"
"const error_category\x26\x0a"
"iostream_category() _NOEXCEPT\x0a"
"{\x0a"
"    static __iostream_category s;\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"// ios_base\x3a\x3a""failure\x0a"
"\x0a"
"ios_base\x3a\x3a""failure\x3a\x3a""failure(const string\x26 msg, const error_code\x26 ec)\x0a"
"    \x3a system_error(ec, msg)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"ios_base\x3a\x3a""failure\x3a\x3a""failure(const char* msg, const error_code\x26 ec)\x0a"
"    \x3a system_error(ec, msg)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"ios_base\x3a\x3a""failure\x3a\x3a\x7e""failure() throw()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// ios_base locale\x0a"
"\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3a""boolalpha;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3a""dec;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3a""fixed;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3ahex;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3ainternal;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3aleft;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3aoct;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3aright;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3ascientific;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3ashowbase;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3ashowpoint;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3ashowpos;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3askipws;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3aunitbuf;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3auppercase;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3a""adjustfield;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3a""basefield;\x0a"
"const ios_base\x3a\x3a""fmtflags ios_base\x3a\x3a""floatfield;\x0a"
"\x0a"
"const ios_base\x3a\x3aiostate ios_base\x3a\x3a""badbit;\x0a"
"const ios_base\x3a\x3aiostate ios_base\x3a\x3a""eofbit;\x0a"
"const ios_base\x3a\x3aiostate ios_base\x3a\x3a""failbit;\x0a"
"const ios_base\x3a\x3aiostate ios_base\x3a\x3agoodbit;\x0a"
"\x0a"
"const ios_base\x3a\x3aopenmode ios_base\x3a\x3a""app;\x0a"
"const ios_base\x3a\x3aopenmode ios_base\x3a\x3a""ate;\x0a"
"const ios_base\x3a\x3aopenmode ios_base\x3a\x3a""binary;\x0a"
"const ios_base\x3a\x3aopenmode ios_base\x3a\x3ain;\x0a"
"const ios_base\x3a\x3aopenmode ios_base\x3a\x3aout;\x0a"
"const ios_base\x3a\x3aopenmode ios_base\x3a\x3atrunc;\x0a"
"\x0a"
"void\x0a"
"ios_base\x3a\x3a__call_callbacks(event ev)\x0a"
"{\x0a"
"    for (size_t i = __event_size_; i;)\x0a"
"    {\x0a"
"        --i;\x0a"
"        __fn_\x5bi\x5d(ev, *this, __index_\x5bi\x5d);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// locale\x0a"
"\x0a"
"locale\x0a"
"ios_base\x3a\x3aimbue(const locale\x26 newloc)\x0a"
"{\x0a"
"    static_assert(sizeof(locale) == sizeof(__loc_), \x22\x22);\x0a"
"    locale\x26 loc_storage = *reinterpret_cast<locale*>(\x26__loc_);\x0a"
"    locale oldloc = loc_storage;\x0a"
"    loc_storage = newloc;\x0a"
"    __call_callbacks(imbue_event);\x0a"
"    return oldloc;\x0a"
"}\x0a"
"\x0a"
"locale\x0a"
"ios_base\x3a\x3agetloc() const\x0a"
"{\x0a"
"    const locale\x26 loc_storage = *reinterpret_cast<const locale*>(\x26__loc_);\x0a"
"    return loc_storage;\x0a"
"}\x0a"
"\x0a"
"// xalloc\x0a"
"#if defined(_LIBCPP_HAS_C_ATOMIC_IMP) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_THREADS)\x0a"
"atomic<int> ios_base\x3a\x3a__xindex_ = ATOMIC_VAR_INIT(0);\x0a"
"#else\x0a"
"int ios_base\x3a\x3a__xindex_ = 0;\x0a"
"#endif\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"static size_t __ios_new_cap(size_t __req_size, size_t __current_cap)\x0a"
"{ // Precondition\x3a __req_size > __current_cap\x0a"
"\x09""const size_t mx = std\x3a\x3anumeric_limits<size_t>\x3a\x3amax() / sizeof(_Tp);\x0a"
"\x09if (__req_size < mx/2)\x0a"
"\x09\x09return _VSTD\x3a\x3amax(2 * __current_cap, __req_size);\x0a"
"\x09""else\x0a"
"\x09\x09return mx;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"ios_base\x3a\x3axalloc()\x0a"
"{\x0a"
"    return __xindex_++;\x0a"
"}\x0a"
"\x0a"
"long\x26\x0a"
"ios_base\x3a\x3aiword(int index)\x0a"
"{\x0a"
"    size_t req_size = static_cast<size_t>(index)+1;\x0a"
"    if (req_size > __iarray_cap_)\x0a"
"    {\x0a"
"        size_t newcap = __ios_new_cap<long>(req_size, __iarray_cap_);\x0a"
"        long* iarray = static_cast<long*>(realloc(__iarray_, newcap * sizeof(long)));\x0a"
"        if (iarray == 0)\x0a"
"        {\x0a"
"            setstate(badbit);\x0a"
"            static long error;\x0a"
"            error = 0;\x0a"
"            return error;\x0a"
"        }\x0a"
"        __iarray_ = iarray;\x0a"
"        for (long* p = __iarray_ + __iarray_size_; p < __iarray_ + newcap; ++p)\x0a"
"            *p = 0;\x0a"
"        __iarray_cap_ = newcap;\x0a"
"    }\x0a"
"    __iarray_size_ = max<size_t>(__iarray_size_, req_size);\x0a"
"    return __iarray_\x5bindex\x5d;\x0a"
"}\x0a"
"\x0a"
"void*\x26\x0a"
"ios_base\x3a\x3apword(int index)\x0a"
"{\x0a"
"    size_t req_size = static_cast<size_t>(index)+1;\x0a"
"    if (req_size > __parray_cap_)\x0a"
"    {\x0a"
"        size_t newcap = __ios_new_cap<void *>(req_size, __iarray_cap_);\x0a"
"        void** parray = static_cast<void**>(realloc(__parray_, newcap * sizeof(void *)));\x0a"
"        if (parray == 0)\x0a"
"        {\x0a"
"            setstate(badbit);\x0a"
"            static void* error;\x0a"
"            error = 0;\x0a"
"            return error;\x0a"
"        }\x0a"
"        __parray_ = parray;\x0a"
"        for (void** p = __parray_ + __parray_size_; p < __parray_ + newcap; ++p)\x0a"
"            *p = 0;\x0a"
"        __parray_cap_ = newcap;\x0a"
"    }\x0a"
"    __parray_size_ = max<size_t>(__parray_size_, req_size);\x0a"
"    return __parray_\x5bindex\x5d;\x0a"
"}\x0a"
"\x0a"
"// register_callback\x0a"
"\x0a"
"void\x0a"
"ios_base\x3a\x3aregister_callback(event_callback fn, int index)\x0a"
"{\x0a"
"    size_t req_size = __event_size_ + 1;\x0a"
"    if (req_size > __event_cap_)\x0a"
"    {\x0a"
"        size_t newcap = __ios_new_cap<event_callback>(req_size, __event_cap_);\x0a"
"        event_callback* fns = static_cast<event_callback*>(realloc(__fn_, newcap * sizeof(event_callback)));\x0a"
"        if (fns == 0)\x0a"
"            setstate(badbit);\x0a"
"        __fn_ = fns;\x0a"
"        int* indxs = static_cast<int *>(realloc(__index_, newcap * sizeof(int)));\x0a"
"        if (indxs == 0)\x0a"
"            setstate(badbit);\x0a"
"        __index_ = indxs;\x0a"
"        __event_cap_ = newcap;\x0a"
"    }\x0a"
"    __fn_\x5b__event_size_\x5d = fn;\x0a"
"    __index_\x5b__event_size_\x5d = index;\x0a"
"    ++__event_size_;\x0a"
"}\x0a"
"\x0a"
"ios_base\x3a\x3a\x7eios_base()\x0a"
"{\x0a"
"    __call_callbacks(erase_event);\x0a"
"    locale\x26 loc_storage = *reinterpret_cast<locale*>(\x26__loc_);\x0a"
"    loc_storage.\x7elocale();\x0a"
"    free(__fn_);\x0a"
"    free(__index_);\x0a"
"    free(__iarray_);\x0a"
"    free(__parray_);\x0a"
"}\x0a"
"\x0a"
"// iostate\x0a"
"\x0a"
"void\x0a"
"ios_base\x3a\x3a""clear(iostate state)\x0a"
"{\x0a"
"    if (__rdbuf_)\x0a"
"        __rdstate_ = state;\x0a"
"    else\x0a"
"        __rdstate_ = state \x7c badbit;\x0a"
"\x0a"
"    if (((state \x7c (__rdbuf_ \x3f goodbit \x3a badbit)) \x26 __exceptions_) \x21= 0)\x0a"
"        __throw_failure(\x22ios_base\x3a\x3a""clear\x22);\x0a"
"}\x0a"
"\x0a"
"// init\x0a"
"\x0a"
"void\x0a"
"ios_base\x3a\x3ainit(void* sb)\x0a"
"{\x0a"
"    __rdbuf_ = sb;\x0a"
"    __rdstate_ = __rdbuf_ \x3f goodbit \x3a badbit;\x0a"
"    __exceptions_ = goodbit;\x0a"
"    __fmtflags_ = skipws \x7c dec;\x0a"
"    __width_ = 0;\x0a"
"    __precision_ = 6;\x0a"
"    __fn_ = 0;\x0a"
"    __index_ = 0;\x0a"
"    __event_size_ = 0;\x0a"
"    __event_cap_ = 0;\x0a"
"    __iarray_ = 0;\x0a"
"    __iarray_size_ = 0;\x0a"
"    __iarray_cap_ = 0;\x0a"
"    __parray_ = 0;\x0a"
"    __parray_size_ = 0;\x0a"
"    __parray_cap_ = 0;\x0a"
"    \x3a\x3anew(\x26__loc_) locale;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"ios_base\x3a\x3a""copyfmt(const ios_base\x26 rhs)\x0a"
"{\x0a"
"    // If we can't acquire the needed resources, throw bad_alloc (can't set badbit)\x0a"
"    // Don't alter *this until all needed resources are acquired\x0a"
"    unique_ptr<event_callback, void (*)(void*)> new_callbacks(0, free);\x0a"
"    unique_ptr<int, void (*)(void*)> new_ints(0, free);\x0a"
"    unique_ptr<long, void (*)(void*)> new_longs(0, free);\x0a"
"    unique_ptr<void*, void (*)(void*)> new_pointers(0, free);\x0a"
"    if (__event_cap_ < rhs.__event_size_)\x0a"
"    {\x0a"
"        size_t newesize = sizeof(event_callback) * rhs.__event_size_;\x0a"
"        new_callbacks.reset(static_cast<event_callback*>(malloc(newesize)));\x0a"
"        if (\x21new_callbacks)\x0a"
"            __throw_bad_alloc();\x0a"
"\x0a"
"        size_t newisize = sizeof(int) * rhs.__event_size_;\x0a"
"        new_ints.reset(static_cast<int *>(malloc(newisize)));\x0a"
"        if (\x21new_ints)\x0a"
"            __throw_bad_alloc();\x0a"
"    }\x0a"
"    if (__iarray_cap_ < rhs.__iarray_size_)\x0a"
"    {\x0a"
"        size_t newsize = sizeof(long) * rhs.__iarray_size_;\x0a"
"        new_longs.reset(static_cast<long*>(malloc(newsize)));\x0a"
"        if (\x21new_longs)\x0a"
"            __throw_bad_alloc();\x0a"
"    }\x0a"
"    if (__parray_cap_ < rhs.__parray_size_)\x0a"
"    {\x0a"
"        size_t newsize = sizeof(void*) * rhs.__parray_size_;\x0a"
"        new_pointers.reset(static_cast<void**>(malloc(newsize)));\x0a"
"        if (\x21new_pointers)\x0a"
"            __throw_bad_alloc();\x0a"
"    }\x0a"
"    // Got everything we need.  Copy everything but __rdstate_, __rdbuf_ and __exceptions_\x0a"
"    __fmtflags_ = rhs.__fmtflags_;\x0a"
"    __precision_ = rhs.__precision_;\x0a"
"    __width_ = rhs.__width_;\x0a"
"    locale\x26 lhs_loc = *reinterpret_cast<locale*>(\x26__loc_);\x0a"
"    const locale\x26 rhs_loc = *reinterpret_cast<const locale*>(\x26rhs.__loc_);\x0a"
"    lhs_loc = rhs_loc;\x0a"
"    if (__event_cap_ < rhs.__event_size_)\x0a"
"    {\x0a"
"        free(__fn_);\x0a"
"        __fn_ = new_callbacks.release();\x0a"
"        free(__index_);\x0a"
"        __index_ = new_ints.release();\x0a"
"        __event_cap_ = rhs.__event_size_;\x0a"
"    }\x0a"
"    for (__event_size_ = 0; __event_size_ < rhs.__event_size_; ++__event_size_)\x0a"
"    {\x0a"
"        __fn_\x5b__event_size_\x5d = rhs.__fn_\x5b__event_size_\x5d;\x0a"
"        __index_\x5b__event_size_\x5d = rhs.__index_\x5b__event_size_\x5d;\x0a"
"    }\x0a"
"    if (__iarray_cap_ < rhs.__iarray_size_)\x0a"
"    {\x0a"
"        free(__iarray_);\x0a"
"        __iarray_ = new_longs.release();\x0a"
"        __iarray_cap_ = rhs.__iarray_size_;\x0a"
"    }\x0a"
"    for (__iarray_size_ = 0; __iarray_size_ < rhs.__iarray_size_; ++__iarray_size_)\x0a"
"        __iarray_\x5b__iarray_size_\x5d = rhs.__iarray_\x5b__iarray_size_\x5d;\x0a"
"    if (__parray_cap_ < rhs.__parray_size_)\x0a"
"    {\x0a"
"        free(__parray_);\x0a"
"        __parray_ = new_pointers.release();\x0a"
"        __parray_cap_ = rhs.__parray_size_;\x0a"
"    }\x0a"
"    for (__parray_size_ = 0; __parray_size_ < rhs.__parray_size_; ++__parray_size_)\x0a"
"        __parray_\x5b__parray_size_\x5d = rhs.__parray_\x5b__parray_size_\x5d;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"ios_base\x3a\x3amove(ios_base\x26 rhs)\x0a"
"{\x0a"
"    // *this is uninitialized\x0a"
"    __fmtflags_ = rhs.__fmtflags_;\x0a"
"    __precision_ = rhs.__precision_;\x0a"
"    __width_ = rhs.__width_;\x0a"
"    __rdstate_ = rhs.__rdstate_;\x0a"
"    __exceptions_ = rhs.__exceptions_;\x0a"
"    __rdbuf_ = 0;\x0a"
"    locale\x26 rhs_loc = *reinterpret_cast<locale*>(\x26rhs.__loc_);\x0a"
"    \x3a\x3anew(\x26__loc_) locale(rhs_loc);\x0a"
"    __fn_ = rhs.__fn_;\x0a"
"    rhs.__fn_ = 0;\x0a"
"    __index_ = rhs.__index_;\x0a"
"    rhs.__index_ = 0;\x0a"
"    __event_size_ = rhs.__event_size_;\x0a"
"    rhs.__event_size_ = 0;\x0a"
"    __event_cap_ = rhs.__event_cap_;\x0a"
"    rhs.__event_cap_ = 0;\x0a"
"    __iarray_ = rhs.__iarray_;\x0a"
"    rhs.__iarray_ = 0;\x0a"
"    __iarray_size_ = rhs.__iarray_size_;\x0a"
"    rhs.__iarray_size_ = 0;\x0a"
"    __iarray_cap_ = rhs.__iarray_cap_;\x0a"
"    rhs.__iarray_cap_ = 0;\x0a"
"    __parray_ = rhs.__parray_;\x0a"
"    rhs.__parray_ = 0;\x0a"
"    __parray_size_ = rhs.__parray_size_;\x0a"
"    rhs.__parray_size_ = 0;\x0a"
"    __parray_cap_ = rhs.__parray_cap_;\x0a"
"    rhs.__parray_cap_ = 0;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"ios_base\x3a\x3aswap(ios_base\x26 rhs) _NOEXCEPT\x0a"
"{\x0a"
"    _VSTD\x3a\x3aswap(__fmtflags_, rhs.__fmtflags_);\x0a"
"    _VSTD\x3a\x3aswap(__precision_, rhs.__precision_);\x0a"
"    _VSTD\x3a\x3aswap(__width_, rhs.__width_);\x0a"
"    _VSTD\x3a\x3aswap(__rdstate_, rhs.__rdstate_);\x0a"
"    _VSTD\x3a\x3aswap(__exceptions_, rhs.__exceptions_);\x0a"
"    locale\x26 lhs_loc = *reinterpret_cast<locale*>(\x26__loc_);\x0a"
"    locale\x26 rhs_loc = *reinterpret_cast<locale*>(\x26rhs.__loc_);\x0a"
"    _VSTD\x3a\x3aswap(lhs_loc, rhs_loc);\x0a"
"    _VSTD\x3a\x3aswap(__fn_, rhs.__fn_);\x0a"
"    _VSTD\x3a\x3aswap(__index_, rhs.__index_);\x0a"
"    _VSTD\x3a\x3aswap(__event_size_, rhs.__event_size_);\x0a"
"    _VSTD\x3a\x3aswap(__event_cap_, rhs.__event_cap_);\x0a"
"    _VSTD\x3a\x3aswap(__iarray_, rhs.__iarray_);\x0a"
"    _VSTD\x3a\x3aswap(__iarray_size_, rhs.__iarray_size_);\x0a"
"    _VSTD\x3a\x3aswap(__iarray_cap_, rhs.__iarray_cap_);\x0a"
"    _VSTD\x3a\x3aswap(__parray_, rhs.__parray_);\x0a"
"    _VSTD\x3a\x3aswap(__parray_size_, rhs.__parray_size_);\x0a"
"    _VSTD\x3a\x3aswap(__parray_cap_, rhs.__parray_cap_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"ios_base\x3a\x3a__set_badbit_and_consider_rethrow()\x0a"
"{\x0a"
"    __rdstate_ \x7c= badbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    if (__exceptions_ \x26 badbit)\x0a"
"        throw;\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"ios_base\x3a\x3a__set_failbit_and_consider_rethrow()\x0a"
"{\x0a"
"    __rdstate_ \x7c= failbit;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    if (__exceptions_ \x26 failbit)\x0a"
"        throw;\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"ios_base\x3a\x3async_with_stdio(bool sync)\x0a"
"{\x0a"
"    static bool previous_state = true;\x0a"
"    bool r = previous_state;\x0a"
"    previous_state = sync;\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 12923 ); }