#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_iostream_cpp( 
"//===------------------------ iostream.cpp --------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22__std_stream\x22\x0a"
"#include \x22__locale\x22\x0a"
"#include \x22string\x22\x0a"
"#include \x22new\x22\x0a"
"\x0a"
"#define _str(s) #s\x0a"
"#define str(s) _str(s)\x0a"
"#define _LIBCPP_ABI_NAMESPACE_STR str(_LIBCPP_ABI_NAMESPACE)\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_STDIN\x0a"
"_ALIGNAS_TYPE (istream) _LIBCPP_FUNC_VIS char cin\x5bsizeof(istream)\x5d\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT) \x26\x26 defined(__clang__)\x0a"
"__asm__(\x22\x3f""cin\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40""3V\x3f\x24""basic_istream\x40""DU\x3f\x24""char_traits\x40""D\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40\x40""12\x40""A\x22)\x0a"
"#endif\x0a"
";\x0a"
"_ALIGNAS_TYPE (__stdinbuf<char> ) static char __cin\x5bsizeof(__stdinbuf <char>)\x5d;\x0a"
"static mbstate_t mb_cin;\x0a"
"_ALIGNAS_TYPE (wistream) _LIBCPP_FUNC_VIS char wcin\x5bsizeof(wistream)\x5d\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT) \x26\x26 defined(__clang__)\x0a"
"__asm__(\x22\x3fwcin\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40""3V\x3f\x24""basic_istream\x40_WU\x3f\x24""char_traits\x40_W\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40\x40""12\x40""A\x22)\x0a"
"#endif\x0a"
";\x0a"
"_ALIGNAS_TYPE (__stdinbuf<wchar_t> ) static char __wcin\x5bsizeof(__stdinbuf <wchar_t>)\x5d;\x0a"
"static mbstate_t mb_wcin;\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_STDOUT\x0a"
"_ALIGNAS_TYPE (ostream) _LIBCPP_FUNC_VIS char cout\x5bsizeof(ostream)\x5d\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT) \x26\x26 defined(__clang__)\x0a"
"__asm__(\x22\x3f""cout\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40""3V\x3f\x24""basic_ostream\x40""DU\x3f\x24""char_traits\x40""D\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40\x40""12\x40""A\x22)\x0a"
"#endif\x0a"
";\x0a"
"_ALIGNAS_TYPE (__stdoutbuf<char>) static char __cout\x5bsizeof(__stdoutbuf<char>)\x5d;\x0a"
"static mbstate_t mb_cout;\x0a"
"_ALIGNAS_TYPE (wostream) _LIBCPP_FUNC_VIS char wcout\x5bsizeof(wostream)\x5d\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT) \x26\x26 defined(__clang__)\x0a"
"__asm__(\x22\x3fwcout\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40""3V\x3f\x24""basic_ostream\x40_WU\x3f\x24""char_traits\x40_W\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40\x40""12\x40""A\x22)\x0a"
"#endif\x0a"
";\x0a"
"_ALIGNAS_TYPE (__stdoutbuf<wchar_t>) static char __wcout\x5bsizeof(__stdoutbuf<wchar_t>)\x5d;\x0a"
"static mbstate_t mb_wcout;\x0a"
"#endif\x0a"
"\x0a"
"_ALIGNAS_TYPE (ostream) _LIBCPP_FUNC_VIS char cerr\x5bsizeof(ostream)\x5d\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT) \x26\x26 defined(__clang__)\x0a"
"__asm__(\x22\x3f""cerr\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40""3V\x3f\x24""basic_ostream\x40""DU\x3f\x24""char_traits\x40""D\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40\x40""12\x40""A\x22)\x0a"
"#endif\x0a"
";\x0a"
"_ALIGNAS_TYPE (__stdoutbuf<char>) static char __cerr\x5bsizeof(__stdoutbuf<char>)\x5d;\x0a"
"static mbstate_t mb_cerr;\x0a"
"_ALIGNAS_TYPE (wostream) _LIBCPP_FUNC_VIS char wcerr\x5bsizeof(wostream)\x5d\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT) \x26\x26 defined(__clang__)\x0a"
"__asm__(\x22\x3fwcerr\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40""3V\x3f\x24""basic_ostream\x40_WU\x3f\x24""char_traits\x40_W\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40\x40""12\x40""A\x22)\x0a"
"#endif\x0a"
";\x0a"
"_ALIGNAS_TYPE (__stdoutbuf<wchar_t>) static char __wcerr\x5bsizeof(__stdoutbuf<wchar_t>)\x5d;\x0a"
"static mbstate_t mb_wcerr;\x0a"
"\x0a"
"_ALIGNAS_TYPE (ostream) _LIBCPP_FUNC_VIS char clog\x5bsizeof(ostream)\x5d\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT) \x26\x26 defined(__clang__)\x0a"
"__asm__(\x22\x3f""clog\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40""3V\x3f\x24""basic_ostream\x40""DU\x3f\x24""char_traits\x40""D\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40\x40""12\x40""A\x22)\x0a"
"#endif\x0a"
";\x0a"
"_ALIGNAS_TYPE (wostream) _LIBCPP_FUNC_VIS char wclog\x5bsizeof(wostream)\x5d\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT) \x26\x26 defined(__clang__)\x0a"
"__asm__(\x22\x3fwclog\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40""3V\x3f\x24""basic_ostream\x40_WU\x3f\x24""char_traits\x40_W\x40\x22 _LIBCPP_ABI_NAMESPACE_STR \x22\x40std\x40\x40\x40""12\x40""A\x22)\x0a"
"#endif\x0a"
";\x0a"
"\x0a"
"_LIBCPP_HIDDEN ios_base\x3a\x3aInit __start_std_streams;\x0a"
"\x0a"
"// On Windows the TLS storage for locales needs to be initialized before we create\x0a"
"// the standard streams, otherwise it may not be alive during program termination\x0a"
"// when we flush the streams.\x0a"
"static void force_locale_initialization() {\x0a"
"#if defined(_LIBCPP_MSVCRT_LIKE)\x0a"
"  static bool once = \x5b\x5d() {\x0a"
"    auto loc = newlocale(LC_ALL_MASK, \x22""C\x22, 0);\x0a"
"    {\x0a"
"        __libcpp_locale_guard g(loc); // forces initialization of locale TLS\x0a"
"        ((void)g);\x0a"
"    }\x0a"
"    freelocale(loc);\x0a"
"    return true;\x0a"
"  }();\x0a"
"  ((void)once);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"ios_base\x3a\x3aInit\x3a\x3aInit()\x0a"
"{\x0a"
"    force_locale_initialization();\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_STDIN\x0a"
"    istream* cin_ptr  = \x3a\x3anew(cin)  istream(\x3a\x3anew(__cin)  __stdinbuf <char>(stdin, \x26mb_cin));\x0a"
"    wistream* wcin_ptr  = \x3a\x3anew(wcin)  wistream(\x3a\x3anew(__wcin)  __stdinbuf <wchar_t>(stdin, \x26mb_wcin));\x0a"
"#endif\x0a"
"#ifndef _LIBCPP_HAS_NO_STDOUT\x0a"
"    ostream* cout_ptr = \x3a\x3anew(cout) ostream(\x3a\x3anew(__cout) __stdoutbuf<char>(stdout, \x26mb_cout));\x0a"
"    wostream* wcout_ptr = \x3a\x3anew(wcout) wostream(\x3a\x3anew(__wcout) __stdoutbuf<wchar_t>(stdout, \x26mb_wcout));\x0a"
"#endif\x0a"
"    ostream* cerr_ptr = \x3a\x3anew(cerr) ostream(\x3a\x3anew(__cerr) __stdoutbuf<char>(stderr, \x26mb_cerr));\x0a"
"                        \x3a\x3anew(clog) ostream(cerr_ptr->rdbuf());\x0a"
"    wostream* wcerr_ptr = \x3a\x3anew(wcerr) wostream(\x3a\x3anew(__wcerr) __stdoutbuf<wchar_t>(stderr, \x26mb_wcerr));\x0a"
"                          \x3a\x3anew(wclog) wostream(wcerr_ptr->rdbuf());\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_STDIN) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_STDOUT)\x0a"
"    cin_ptr->tie(cout_ptr);\x0a"
"    wcin_ptr->tie(wcout_ptr);\x0a"
"#endif\x0a"
"    _VSTD\x3a\x3aunitbuf(*cerr_ptr);\x0a"
"    _VSTD\x3a\x3aunitbuf(*wcerr_ptr);\x0a"
"#ifndef _LIBCPP_HAS_NO_STDOUT\x0a"
"    cerr_ptr->tie(cout_ptr);\x0a"
"    wcerr_ptr->tie(wcout_ptr);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"ios_base\x3a\x3aInit\x3a\x3a\x7eInit()\x0a"
"{\x0a"
"#ifndef _LIBCPP_HAS_NO_STDOUT\x0a"
"    ostream* cout_ptr = reinterpret_cast<ostream*>(cout);\x0a"
"    wostream* wcout_ptr = reinterpret_cast<wostream*>(wcout);\x0a"
"    cout_ptr->flush();\x0a"
"    wcout_ptr->flush();\x0a"
"#endif\x0a"
"\x0a"
"    ostream* clog_ptr = reinterpret_cast<ostream*>(clog);\x0a"
"    wostream* wclog_ptr = reinterpret_cast<wostream*>(wclog);\x0a"
"    clog_ptr->flush();\x0a"
"    wclog_ptr->flush();\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 5614 ); }