#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_memory_cpp( 
"//===------------------------ memory.cpp ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22memory\x22\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"#include \x22mutex\x22\x0a"
"#include \x22thread\x22\x0a"
"#if defined(__unix__) \x26\x26  defined(__ELF__) \x26\x26 defined(_LIBCPP_HAS_COMMENT_LIB_PRAGMA)\x0a"
"#pragma comment(lib, \x22pthread\x22)\x0a"
"#endif\x0a"
"#endif\x0a"
"#include \x22include/atomic_support.h\x22\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"const allocator_arg_t allocator_arg = allocator_arg_t();\x0a"
"\x0a"
"bad_weak_ptr\x3a\x3a\x7e""bad_weak_ptr() _NOEXCEPT {}\x0a"
"\x0a"
"const char*\x0a"
"bad_weak_ptr\x3a\x3awhat() const _NOEXCEPT\x0a"
"{\x0a"
"    return \x22""bad_weak_ptr\x22;\x0a"
"}\x0a"
"\x0a"
"__shared_count\x3a\x3a\x7e__shared_count()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"__shared_weak_count\x3a\x3a\x7e__shared_weak_count()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#if defined(_LIBCPP_DEPRECATED_ABI_LEGACY_LIBRARY_DEFINITIONS_FOR_INLINE_FUNCTIONS)\x0a"
"void\x0a"
"__shared_count\x3a\x3a__add_shared() _NOEXCEPT\x0a"
"{\x0a"
"    __libcpp_atomic_refcount_increment(__shared_owners_);\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__shared_count\x3a\x3a__release_shared() _NOEXCEPT\x0a"
"{\x0a"
"    if (__libcpp_atomic_refcount_decrement(__shared_owners_) == -1)\x0a"
"    {\x0a"
"        __on_zero_shared();\x0a"
"        return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__shared_weak_count\x3a\x3a__add_shared() _NOEXCEPT\x0a"
"{\x0a"
"    __shared_count\x3a\x3a__add_shared();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__shared_weak_count\x3a\x3a__add_weak() _NOEXCEPT\x0a"
"{\x0a"
"    __libcpp_atomic_refcount_increment(__shared_weak_owners_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__shared_weak_count\x3a\x3a__release_shared() _NOEXCEPT\x0a"
"{\x0a"
"    if (__shared_count\x3a\x3a__release_shared())\x0a"
"        __release_weak();\x0a"
"}\x0a"
"\x0a"
"#endif // _LIBCPP_DEPRECATED_ABI_LEGACY_LIBRARY_DEFINITIONS_FOR_INLINE_FUNCTIONS\x0a"
"\x0a"
"void\x0a"
"__shared_weak_count\x3a\x3a__release_weak() _NOEXCEPT\x0a"
"{\x0a"
"    // NOTE\x3a The acquire load here is an optimization of the very\x0a"
"    // common case where a shared pointer is being destructed while\x0a"
"    // having no other contended references.\x0a"
"    //\x0a"
"    // BENEFIT\x3a We avoid expensive atomic stores like XADD and STREX\x0a"
"    // in a common case.  Those instructions are slow and do nasty\x0a"
"    // things to caches.\x0a"
"    //\x0a"
"    // IS THIS SAFE\x3f  Yes.  During weak destruction, if we see that we\x0a"
"    // are the last reference, we know that no-one else is accessing\x0a"
"    // us. If someone were accessing us, then they would be doing so\x0a"
"    // while the last shared / weak_ptr was being destructed, and\x0a"
"    // that's undefined anyway.\x0a"
"    //\x0a"
"    // If we see anything other than a 0, then we have possible\x0a"
"    // contention, and need to use an atomicrmw primitive.\x0a"
"    // The same arguments don't apply for increment, where it is legal\x0a"
"    // (though inadvisable) to share shared_ptr references between\x0a"
"    // threads, and have them all get copied at once.  The argument\x0a"
"    // also doesn't apply for __release_shared, because an outstanding\x0a"
"    // weak_ptr\x3a\x3alock() could read / modify the shared count.\x0a"
"    if (__libcpp_atomic_load(\x26__shared_weak_owners_, _AO_Acquire) == 0)\x0a"
"    {\x0a"
"        // no need to do this store, because we are about\x0a"
"        // to destroy everything.\x0a"
"        //__libcpp_atomic_store(\x26__shared_weak_owners_, -1, _AO_Release);\x0a"
"        __on_zero_shared_weak();\x0a"
"    }\x0a"
"    else if (__libcpp_atomic_refcount_decrement(__shared_weak_owners_) == -1)\x0a"
"        __on_zero_shared_weak();\x0a"
"}\x0a"
"\x0a"
"__shared_weak_count*\x0a"
"__shared_weak_count\x3a\x3alock() _NOEXCEPT\x0a"
"{\x0a"
"    long object_owners = __libcpp_atomic_load(\x26__shared_owners_);\x0a"
"    while (object_owners \x21= -1)\x0a"
"    {\x0a"
"        if (__libcpp_atomic_compare_exchange(\x26__shared_owners_,\x0a"
"                                             \x26object_owners,\x0a"
"                                             object_owners+1))\x0a"
"            return this;\x0a"
"    }\x0a"
"    return nullptr;\x0a"
"}\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_NO_RTTI) \x7c\x7c \x21""defined(_LIBCPP_BUILD_STATIC)\x0a"
"\x0a"
"const void*\x0a"
"__shared_weak_count\x3a\x3a__get_deleter(const type_info\x26) const _NOEXCEPT\x0a"
"{\x0a"
"    return nullptr;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_NO_RTTI\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_ATOMIC_HEADER)\x0a"
"\x0a"
"_LIBCPP_SAFE_STATIC static const std\x3a\x3asize_t __sp_mut_count = 16;\x0a"
"_LIBCPP_SAFE_STATIC static __libcpp_mutex_t mut_back\x5b__sp_mut_count\x5d =\x0a"
"{\x0a"
"    _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER,\x0a"
"    _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER,\x0a"
"    _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER,\x0a"
"    _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER, _LIBCPP_MUTEX_INITIALIZER\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_CONSTEXPR __sp_mut\x3a\x3a__sp_mut(void* p) _NOEXCEPT\x0a"
"   \x3a __lx(p)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__sp_mut\x3a\x3alock() _NOEXCEPT\x0a"
"{\x0a"
"    auto m = static_cast<__libcpp_mutex_t*>(__lx);\x0a"
"    unsigned count = 0;\x0a"
"    while (\x21__libcpp_mutex_trylock(m))\x0a"
"    {\x0a"
"        if (++count > 16)\x0a"
"        {\x0a"
"            __libcpp_mutex_lock(m);\x0a"
"            break;\x0a"
"        }\x0a"
"        this_thread\x3a\x3ayield();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__sp_mut\x3a\x3aunlock() _NOEXCEPT\x0a"
"{\x0a"
"    __libcpp_mutex_unlock(static_cast<__libcpp_mutex_t*>(__lx));\x0a"
"}\x0a"
"\x0a"
"__sp_mut\x26\x0a"
"__get_sp_mut(const void* p)\x0a"
"{\x0a"
"    static __sp_mut muts\x5b__sp_mut_count\x5d\x0a"
"    {\x0a"
"        \x26mut_back\x5b 0\x5d, \x26mut_back\x5b 1\x5d, \x26mut_back\x5b 2\x5d, \x26mut_back\x5b 3\x5d,\x0a"
"        \x26mut_back\x5b 4\x5d, \x26mut_back\x5b 5\x5d, \x26mut_back\x5b 6\x5d, \x26mut_back\x5b 7\x5d,\x0a"
"        \x26mut_back\x5b 8\x5d, \x26mut_back\x5b 9\x5d, \x26mut_back\x5b""10\x5d, \x26mut_back\x5b""11\x5d,\x0a"
"        \x26mut_back\x5b""12\x5d, \x26mut_back\x5b""13\x5d, \x26mut_back\x5b""14\x5d, \x26mut_back\x5b""15\x5d\x0a"
"    };\x0a"
"    return muts\x5bhash<const void*>()(p) \x26 (__sp_mut_count-1)\x5d;\x0a"
"}\x0a"
"\x0a"
"#endif // \x21""defined(_LIBCPP_HAS_NO_ATOMIC_HEADER)\x0a"
"\x0a"
"void\x0a"
"declare_reachable(void*)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"declare_no_pointers(char*, size_t)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"undeclare_no_pointers(char*, size_t)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_ABI_POINTER_SAFETY_ENUM_TYPE)\x0a"
"pointer_safety get_pointer_safety() _NOEXCEPT\x0a"
"{\x0a"
"    return pointer_safety\x3a\x3arelaxed;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"void*\x0a"
"__undeclare_reachable(void* p)\x0a"
"{\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"void*\x0a"
"align(size_t alignment, size_t size, void*\x26 ptr, size_t\x26 space)\x0a"
"{\x0a"
"    void* r = nullptr;\x0a"
"    if (size <= space)\x0a"
"    {\x0a"
"        char* p1 = static_cast<char*>(ptr);\x0a"
"        char* p2 = reinterpret_cast<char*>(reinterpret_cast<size_t>(p1 + (alignment - 1)) \x26 -alignment);\x0a"
"        size_t d = static_cast<size_t>(p2 - p1);\x0a"
"        if (d <= space - size)\x0a"
"        {\x0a"
"            r = p2;\x0a"
"            ptr = r;\x0a"
"            space -= d;\x0a"
"        }\x0a"
"    }\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 6328 ); }