#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_mutex_cpp( 
"//===------------------------- mutex.cpp ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22mutex\x22\x0a"
"#include \x22limits\x22\x0a"
"#include \x22system_error\x22\x0a"
"#include \x22include/atomic_support.h\x22\x0a"
"#include \x22__undef_macros\x22\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"#if defined(__unix__) \x26\x26  defined(__ELF__) \x26\x26 defined(_LIBCPP_HAS_COMMENT_LIB_PRAGMA)\x0a"
"#pragma comment(lib, \x22pthread\x22)\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"const defer_lock_t  defer_lock = {};\x0a"
"const try_to_lock_t try_to_lock = {};\x0a"
"const adopt_lock_t  adopt_lock = {};\x0a"
"\x0a"
"// \x7emutex is defined elsewhere\x0a"
"\x0a"
"void\x0a"
"mutex\x3a\x3alock()\x0a"
"{\x0a"
"    int ec = __libcpp_mutex_lock(\x26__m_);\x0a"
"    if (ec)\x0a"
"        __throw_system_error(ec, \x22mutex lock failed\x22);\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"mutex\x3a\x3atry_lock() _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_mutex_trylock(\x26__m_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"mutex\x3a\x3aunlock() _NOEXCEPT\x0a"
"{\x0a"
"    int ec = __libcpp_mutex_unlock(\x26__m_);\x0a"
"    (void)ec;\x0a"
"    _LIBCPP_ASSERT(ec == 0, \x22""call to mutex\x3a\x3aunlock failed\x22);\x0a"
"}\x0a"
"\x0a"
"// recursive_mutex\x0a"
"\x0a"
"recursive_mutex\x3a\x3arecursive_mutex()\x0a"
"{\x0a"
"    int ec = __libcpp_recursive_mutex_init(\x26__m_);\x0a"
"    if (ec)\x0a"
"        __throw_system_error(ec, \x22recursive_mutex constructor failed\x22);\x0a"
"}\x0a"
"\x0a"
"recursive_mutex\x3a\x3a\x7erecursive_mutex()\x0a"
"{\x0a"
"    int e = __libcpp_recursive_mutex_destroy(\x26__m_);\x0a"
"    (void)e;\x0a"
"    _LIBCPP_ASSERT(e == 0, \x22""call to \x7erecursive_mutex() failed\x22);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"recursive_mutex\x3a\x3alock()\x0a"
"{\x0a"
"    int ec = __libcpp_recursive_mutex_lock(\x26__m_);\x0a"
"    if (ec)\x0a"
"        __throw_system_error(ec, \x22recursive_mutex lock failed\x22);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"recursive_mutex\x3a\x3aunlock() _NOEXCEPT\x0a"
"{\x0a"
"    int e = __libcpp_recursive_mutex_unlock(\x26__m_);\x0a"
"    (void)e;\x0a"
"    _LIBCPP_ASSERT(e == 0, \x22""call to recursive_mutex\x3a\x3aunlock() failed\x22);\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"recursive_mutex\x3a\x3atry_lock() _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_recursive_mutex_trylock(\x26__m_);\x0a"
"}\x0a"
"\x0a"
"// timed_mutex\x0a"
"\x0a"
"timed_mutex\x3a\x3atimed_mutex()\x0a"
"    \x3a __locked_(false)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"timed_mutex\x3a\x3a\x7etimed_mutex()\x0a"
"{\x0a"
"    lock_guard<mutex> _(__m_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"timed_mutex\x3a\x3alock()\x0a"
"{\x0a"
"    unique_lock<mutex> lk(__m_);\x0a"
"    while (__locked_)\x0a"
"        __cv_.wait(lk);\x0a"
"    __locked_ = true;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"timed_mutex\x3a\x3atry_lock() _NOEXCEPT\x0a"
"{\x0a"
"    unique_lock<mutex> lk(__m_, try_to_lock);\x0a"
"    if (lk.owns_lock() \x26\x26 \x21__locked_)\x0a"
"    {\x0a"
"        __locked_ = true;\x0a"
"        return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"timed_mutex\x3a\x3aunlock() _NOEXCEPT\x0a"
"{\x0a"
"    lock_guard<mutex> _(__m_);\x0a"
"    __locked_ = false;\x0a"
"    __cv_.notify_one();\x0a"
"}\x0a"
"\x0a"
"// recursive_timed_mutex\x0a"
"\x0a"
"recursive_timed_mutex\x3a\x3arecursive_timed_mutex()\x0a"
"    \x3a __count_(0),\x0a"
"      __id_{}\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"recursive_timed_mutex\x3a\x3a\x7erecursive_timed_mutex()\x0a"
"{\x0a"
"    lock_guard<mutex> _(__m_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"recursive_timed_mutex\x3a\x3alock()\x0a"
"{\x0a"
"    __thread_id id = this_thread\x3a\x3aget_id();\x0a"
"    unique_lock<mutex> lk(__m_);\x0a"
"    if (id ==__id_)\x0a"
"    {\x0a"
"        if (__count_ == numeric_limits<size_t>\x3a\x3amax())\x0a"
"            __throw_system_error(EAGAIN, \x22recursive_timed_mutex lock limit reached\x22);\x0a"
"        ++__count_;\x0a"
"        return;\x0a"
"    }\x0a"
"    while (__count_ \x21= 0)\x0a"
"        __cv_.wait(lk);\x0a"
"    __count_ = 1;\x0a"
"    __id_ = id;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"recursive_timed_mutex\x3a\x3atry_lock() _NOEXCEPT\x0a"
"{\x0a"
"    __thread_id id = this_thread\x3a\x3aget_id();\x0a"
"    unique_lock<mutex> lk(__m_, try_to_lock);\x0a"
"    if (lk.owns_lock() \x26\x26 (__count_ == 0 \x7c\x7c id == __id_))\x0a"
"    {\x0a"
"        if (__count_ == numeric_limits<size_t>\x3a\x3amax())\x0a"
"            return false;\x0a"
"        ++__count_;\x0a"
"        __id_ = id;\x0a"
"        return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"recursive_timed_mutex\x3a\x3aunlock() _NOEXCEPT\x0a"
"{\x0a"
"    unique_lock<mutex> lk(__m_);\x0a"
"    if (--__count_ == 0)\x0a"
"    {\x0a"
"        __id_.__reset();\x0a"
"        lk.unlock();\x0a"
"        __cv_.notify_one();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"// If dispatch_once_f ever handles C++ exceptions, and if one can get to it\x0a"
"// without illegal macros (unexpected macros not beginning with _UpperCase or\x0a"
"// __lowercase), and if it stops spinning waiting threads, then call_once should\x0a"
"// call into dispatch_once_f instead of here. Relevant radar this code needs to\x0a"
"// keep in sync with\x3a  7741191.\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"_LIBCPP_SAFE_STATIC static __libcpp_mutex_t mut = _LIBCPP_MUTEX_INITIALIZER;\x0a"
"_LIBCPP_SAFE_STATIC static __libcpp_condvar_t cv = _LIBCPP_CONDVAR_INITIALIZER;\x0a"
"#endif\x0a"
"\x0a"
"void __call_once(volatile once_flag\x3a\x3a_State_type\x26 flag, void* arg,\x0a"
"                 void (*func)(void*))\x0a"
"{\x0a"
"#if defined(_LIBCPP_HAS_NO_THREADS)\x0a"
"    if (flag == 0)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            flag = 1;\x0a"
"            func(arg);\x0a"
"            flag = \x7eonce_flag\x3a\x3a_State_type(0);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            flag = 0;\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"#else // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"    __libcpp_mutex_lock(\x26mut);\x0a"
"    while (flag == 1)\x0a"
"        __libcpp_condvar_wait(\x26""cv, \x26mut);\x0a"
"    if (flag == 0)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            __libcpp_relaxed_store(\x26""flag, once_flag\x3a\x3a_State_type(1));\x0a"
"            __libcpp_mutex_unlock(\x26mut);\x0a"
"            func(arg);\x0a"
"            __libcpp_mutex_lock(\x26mut);\x0a"
"            __libcpp_atomic_store(\x26""flag, \x7eonce_flag\x3a\x3a_State_type(0),\x0a"
"                                  _AO_Release);\x0a"
"            __libcpp_mutex_unlock(\x26mut);\x0a"
"            __libcpp_condvar_broadcast(\x26""cv);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __libcpp_mutex_lock(\x26mut);\x0a"
"            __libcpp_relaxed_store(\x26""flag, once_flag\x3a\x3a_State_type(0));\x0a"
"            __libcpp_mutex_unlock(\x26mut);\x0a"
"            __libcpp_condvar_broadcast(\x26""cv);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    else\x0a"
"        __libcpp_mutex_unlock(\x26mut);\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 5945 ); }