#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_mutex_destructor_cpp( 
"//===--------------------- mutex_destructor.cpp ---------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"// Define \x7emutex.\x0a"
"//\x0a"
"// On some platforms \x7emutex has been made trivial and the definition is only\x0a"
"// provided for ABI compatibility.\x0a"
"//\x0a"
"// In order to avoid ODR violations within libc++ itself, we need to ensure\x0a"
"// that *nothing* sees the non-trivial mutex declaration. For this reason\x0a"
"// we re-declare the entire class in this file instead of using\x0a"
"// _LIBCPP_BUILDING_LIBRARY to change the definition in the headers.\x0a"
"\x0a"
"#include \x22__config\x22\x0a"
"#include \x22__threading_support\x22\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_THREADS)\x0a"
"#if _LIBCPP_ABI_VERSION == 1 \x7c\x7c \x21""defined(_LIBCPP_HAS_TRIVIAL_MUTEX_DESTRUCTION)\x0a"
"#define NEEDS_MUTEX_DESTRUCTOR\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#ifdef NEEDS_MUTEX_DESTRUCTOR\x0a"
"class _LIBCPP_TYPE_VIS mutex\x0a"
"{\x0a"
"    __libcpp_mutex_t __m_ = _LIBCPP_MUTEX_INITIALIZER;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_ALWAYS_INLINE _LIBCPP_INLINE_VISIBILITY\x0a"
"    constexpr mutex() = default;\x0a"
"    mutex(const mutex\x26) = delete;\x0a"
"    mutex\x26 operator=(const mutex\x26) = delete;\x0a"
"    \x7emutex() noexcept;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"mutex\x3a\x3a\x7emutex() _NOEXCEPT\x0a"
"{\x0a"
"    __libcpp_mutex_destroy(\x26__m_);\x0a"
"}\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"", 1478 ); }