#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_new_cpp( 
"//===--------------------------- new.cpp ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"#include \x22new\x22\x0a"
"#include \x22include/atomic_support.h\x22\x0a"
"\x0a"
"#if defined(_LIBCPP_ABI_MICROSOFT)\x0a"
"#   if \x21""defined(_LIBCPP_ABI_VCRUNTIME)\x0a"
"#       include \x22support/runtime/new_handler_fallback.ipp\x22\x0a"
"#   endif\x0a"
"#elif defined(LIBCXX_BUILDING_LIBCXXABI)\x0a"
"#   include <cxxabi.h>\x0a"
"#elif defined(LIBCXXRT)\x0a"
"#   include <cxxabi.h>\x0a"
"#   include \x22support/runtime/new_handler_fallback.ipp\x22\x0a"
"#elif defined(__GLIBCXX__)\x0a"
"    // nothing to do\x0a"
"#else\x0a"
"#   include \x22support/runtime/new_handler_fallback.ipp\x22\x0a"
"#endif\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"#ifndef __GLIBCXX__\x0a"
"const nothrow_t nothrow{};\x0a"
"#endif\x0a"
"\x0a"
"#ifndef LIBSTDCXX\x0a"
"\x0a"
"void\x0a"
"__throw_bad_alloc()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw bad_alloc();\x0a"
"#else\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#endif // \x21LIBSTDCXX\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"#if \x21""defined(__GLIBCXX__) \x26\x26                                                   \x5c\x0a"
"    \x21""defined(_LIBCPP_ABI_VCRUNTIME) \x26\x26      \x5c\x0a"
"    \x21""defined(_LIBCPP_DISABLE_NEW_DELETE_DEFINITIONS)\x0a"
"\x0a"
"// Implement all new and delete operators as weak definitions\x0a"
"// in this shared library, so that they can be overridden by programs\x0a"
"// that define non-weak copies of the functions.\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void *\x0a"
"operator new(std\x3a\x3asize_t size) _THROW_BAD_ALLOC\x0a"
"{\x0a"
"    if (size == 0)\x0a"
"        size = 1;\x0a"
"    void* p;\x0a"
"    while ((p = \x3a\x3amalloc(size)) == 0)\x0a"
"    {\x0a"
"        // If malloc fails and there is a new_handler,\x0a"
"        // call it to try free up memory.\x0a"
"        std\x3a\x3anew_handler nh = std\x3a\x3aget_new_handler();\x0a"
"        if (nh)\x0a"
"            nh();\x0a"
"        else\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"            throw std\x3a\x3a""bad_alloc();\x0a"
"#else\x0a"
"            break;\x0a"
"#endif\x0a"
"    }\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void*\x0a"
"operator new(size_t size, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    void* p = 0;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        p = \x3a\x3aoperator new(size);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void*\x0a"
"operator new\x5b\x5d(size_t size) _THROW_BAD_ALLOC\x0a"
"{\x0a"
"    return \x3a\x3aoperator new(size);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void*\x0a"
"operator new\x5b\x5d(size_t size, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    void* p = 0;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        p = \x3a\x3aoperator new\x5b\x5d(size);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3a""free(ptr);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr, size_t) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete\x5b\x5d(ptr);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr, size_t) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete\x5b\x5d(ptr);\x0a"
"}\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_LIBRARY_ALIGNED_ALLOCATION)\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void *\x0a"
"operator new(std\x3a\x3asize_t size, std\x3a\x3a""align_val_t alignment) _THROW_BAD_ALLOC\x0a"
"{\x0a"
"    if (size == 0)\x0a"
"        size = 1;\x0a"
"    if (static_cast<size_t>(alignment) < sizeof(void*))\x0a"
"      alignment = std\x3a\x3a""align_val_t(sizeof(void*));\x0a"
"    void* p;\x0a"
"#if defined(_LIBCPP_MSVCRT_LIKE)\x0a"
"    while ((p = _aligned_malloc(size, static_cast<size_t>(alignment))) == nullptr)\x0a"
"#else\x0a"
"    while (\x3a\x3aposix_memalign(\x26p, static_cast<size_t>(alignment), size) \x21= 0)\x0a"
"#endif\x0a"
"    {\x0a"
"        // If posix_memalign fails and there is a new_handler,\x0a"
"        // call it to try free up memory.\x0a"
"        std\x3a\x3anew_handler nh = std\x3a\x3aget_new_handler();\x0a"
"        if (nh)\x0a"
"            nh();\x0a"
"        else {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"            throw std\x3a\x3a""bad_alloc();\x0a"
"#else\x0a"
"            p = nullptr; // posix_memalign doesn't initialize 'p' on failure\x0a"
"            break;\x0a"
"#endif\x0a"
"        }\x0a"
"    }\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void*\x0a"
"operator new(size_t size, std\x3a\x3a""align_val_t alignment, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    void* p = 0;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        p = \x3a\x3aoperator new(size, alignment);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void*\x0a"
"operator new\x5b\x5d(size_t size, std\x3a\x3a""align_val_t alignment) _THROW_BAD_ALLOC\x0a"
"{\x0a"
"    return \x3a\x3aoperator new(size, alignment);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void*\x0a"
"operator new\x5b\x5d(size_t size, std\x3a\x3a""align_val_t alignment, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    void* p = 0;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        p = \x3a\x3aoperator new\x5b\x5d(size, alignment);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr, std\x3a\x3a""align_val_t) _NOEXCEPT\x0a"
"{\x0a"
"#if defined(_LIBCPP_MSVCRT_LIKE)\x0a"
"    \x3a\x3a_aligned_free(ptr);\x0a"
"#else\x0a"
"    \x3a\x3a""free(ptr);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr, std\x3a\x3a""align_val_t alignment, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr, alignment);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr, size_t, std\x3a\x3a""align_val_t alignment) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr, alignment);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr, std\x3a\x3a""align_val_t alignment) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr, alignment);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr, std\x3a\x3a""align_val_t alignment, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete\x5b\x5d(ptr, alignment);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr, size_t, std\x3a\x3a""align_val_t alignment) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete\x5b\x5d(ptr, alignment);\x0a"
"}\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_LIBRARY_ALIGNED_ALLOCATION\x0a"
"#endif // \x21__GLIBCXX__ \x26\x26 \x21_LIBCPP_ABI_VCRUNTIME \x26\x26 \x21_LIBCPP_DISABLE_NEW_DELETE_DEFINITIONS\x0a"
"", 6125 ); }