#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_random_cpp( 
"//===-------------------------- random.cpp --------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include <__config>\x0a"
"\x0a"
"#if defined(_LIBCPP_USING_WIN32_RANDOM)\x0a"
"// Must be defined before including stdlib.h to enable rand_s().\x0a"
"#define _CRT_RAND_S\x0a"
"#endif // defined(_LIBCPP_USING_WIN32_RANDOM)\x0a"
"\x0a"
"#include \x22random\x22\x0a"
"#include \x22system_error\x22\x0a"
"\x0a"
"#if defined(__sun__)\x0a"
"#define rename solaris_headers_are_broken\x0a"
"#endif // defined(__sun__)\x0a"
"\x0a"
"#include <errno.h>\x0a"
"#include <stdio.h>\x0a"
"#include <stdlib.h>\x0a"
"\x0a"
"#if defined(_LIBCPP_USING_GETENTROPY)\x0a"
"#include <sys/random.h>\x0a"
"#elif defined(_LIBCPP_USING_DEV_RANDOM)\x0a"
"#include <fcntl.h>\x0a"
"#include <unistd.h>\x0a"
"#elif defined(_LIBCPP_USING_NACL_RANDOM)\x0a"
"#include <nacl/nacl_random.h>\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"#if defined(_LIBCPP_USING_GETENTROPY)\x0a"
"\x0a"
"random_device\x3a\x3arandom_device(const string\x26 __token)\x0a"
"{\x0a"
"    if (__token \x21= \x22/dev/urandom\x22)\x0a"
"        __throw_system_error(ENOENT, (\x22random device not supported \x22 + __token).c_str());\x0a"
"}\x0a"
"\x0a"
"random_device\x3a\x3a\x7erandom_device()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"unsigned\x0a"
"random_device\x3a\x3aoperator()()\x0a"
"{\x0a"
"    unsigned r;\x0a"
"    size_t n = sizeof(r);\x0a"
"    int err = getentropy(\x26r, n);\x0a"
"    if (err)\x0a"
"        __throw_system_error(errno, \x22random_device getentropy failed\x22);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"#elif defined(_LIBCPP_USING_ARC4_RANDOM)\x0a"
"\x0a"
"random_device\x3a\x3arandom_device(const string\x26 __token)\x0a"
"{\x0a"
"    if (__token \x21= \x22/dev/urandom\x22)\x0a"
"        __throw_system_error(ENOENT, (\x22random device not supported \x22 + __token).c_str());\x0a"
"}\x0a"
"\x0a"
"random_device\x3a\x3a\x7erandom_device()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"unsigned\x0a"
"random_device\x3a\x3aoperator()()\x0a"
"{\x0a"
"    return arc4random();\x0a"
"}\x0a"
"\x0a"
"#elif defined(_LIBCPP_USING_DEV_RANDOM)\x0a"
"\x0a"
"random_device\x3a\x3arandom_device(const string\x26 __token)\x0a"
"    \x3a __f_(open(__token.c_str(), O_RDONLY))\x0a"
"{\x0a"
"    if (__f_ < 0)\x0a"
"        __throw_system_error(errno, (\x22random_device failed to open \x22 + __token).c_str());\x0a"
"}\x0a"
"\x0a"
"random_device\x3a\x3a\x7erandom_device()\x0a"
"{\x0a"
"    close(__f_);\x0a"
"}\x0a"
"\x0a"
"unsigned\x0a"
"random_device\x3a\x3aoperator()()\x0a"
"{\x0a"
"    unsigned r;\x0a"
"    size_t n = sizeof(r);\x0a"
"    char* p = reinterpret_cast<char*>(\x26r);\x0a"
"    while (n > 0)\x0a"
"    {\x0a"
"        ssize_t s = read(__f_, p, n);\x0a"
"        if (s == 0)\x0a"
"            __throw_system_error(ENODATA, \x22random_device got EOF\x22);\x0a"
"        if (s == -1)\x0a"
"        {\x0a"
"            if (errno \x21= EINTR)\x0a"
"                __throw_system_error(errno, \x22random_device got an unexpected error\x22);\x0a"
"            continue;\x0a"
"        }\x0a"
"        n -= static_cast<size_t>(s);\x0a"
"        p += static_cast<size_t>(s);\x0a"
"    }\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"#elif defined(_LIBCPP_USING_NACL_RANDOM)\x0a"
"\x0a"
"random_device\x3a\x3arandom_device(const string\x26 __token)\x0a"
"{\x0a"
"    if (__token \x21= \x22/dev/urandom\x22)\x0a"
"        __throw_system_error(ENOENT, (\x22random device not supported \x22 + __token).c_str());\x0a"
"    int error = nacl_secure_random_init();\x0a"
"    if (error)\x0a"
"        __throw_system_error(error, (\x22random device failed to open \x22 + __token).c_str());\x0a"
"}\x0a"
"\x0a"
"random_device\x3a\x3a\x7erandom_device()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"unsigned\x0a"
"random_device\x3a\x3aoperator()()\x0a"
"{\x0a"
"    unsigned r;\x0a"
"    size_t n = sizeof(r);\x0a"
"    size_t bytes_written;\x0a"
"    int error = nacl_secure_random(\x26r, n, \x26""bytes_written);\x0a"
"    if (error \x21= 0)\x0a"
"        __throw_system_error(error, \x22random_device failed getting bytes\x22);\x0a"
"    else if (bytes_written \x21= n)\x0a"
"        __throw_runtime_error(\x22random_device failed to obtain enough bytes\x22);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"#elif defined(_LIBCPP_USING_WIN32_RANDOM)\x0a"
"\x0a"
"random_device\x3a\x3arandom_device(const string\x26 __token)\x0a"
"{\x0a"
"    if (__token \x21= \x22/dev/urandom\x22)\x0a"
"        __throw_system_error(ENOENT, (\x22random device not supported \x22 + __token).c_str());\x0a"
"}\x0a"
"\x0a"
"random_device\x3a\x3a\x7erandom_device()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"unsigned\x0a"
"random_device\x3a\x3aoperator()()\x0a"
"{\x0a"
"    unsigned r;\x0a"
"    errno_t err = rand_s(\x26r);\x0a"
"    if (err)\x0a"
"        __throw_system_error(err, \x22random_device rand_s failed.\x22);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"#else\x0a"
"#error \x22Random device not implemented for this architecture\x22\x0a"
"#endif\x0a"
"\x0a"
"double\x0a"
"random_device\x3a\x3a""entropy() const _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 4074 ); }