#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_regex_cpp( 
"//===-------------------------- regex.cpp ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22regex\x22\x0a"
"#include \x22""algorithm\x22\x0a"
"#include \x22iterator\x22\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"static\x0a"
"const char*\x0a"
"make_error_type_string(regex_constants\x3a\x3a""error_type ecode)\x0a"
"{\x0a"
"    switch (ecode)\x0a"
"    {\x0a"
"    case regex_constants\x3a\x3a""error_collate\x3a\x0a"
"        return \x22The expression contained an invalid collating element name.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_ctype\x3a\x0a"
"        return \x22The expression contained an invalid character class name.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_escape\x3a\x0a"
"        return \x22The expression contained an invalid escaped character, or a \x22\x0a"
"               \x22trailing escape.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_backref\x3a\x0a"
"        return \x22The expression contained an invalid back reference.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_brack\x3a\x0a"
"        return \x22The expression contained mismatched \x5b and \x5d.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_paren\x3a\x0a"
"        return \x22The expression contained mismatched ( and ).\x22;\x0a"
"    case regex_constants\x3a\x3a""error_brace\x3a\x0a"
"        return \x22The expression contained mismatched { and }.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_badbrace\x3a\x0a"
"        return \x22The expression contained an invalid range in a {} expression.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_range\x3a\x0a"
"        return \x22The expression contained an invalid character range, \x22\x0a"
"               \x22such as \x5b""b-a\x5d in most encodings.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_space\x3a\x0a"
"        return \x22There was insufficient memory to convert the expression into \x22\x0a"
"               \x22""a finite state machine.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_badrepeat\x3a\x0a"
"        return \x22One of *\x3f+{ was not preceded by a valid regular expression.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_complexity\x3a\x0a"
"        return \x22The complexity of an attempted match against a regular \x22\x0a"
"               \x22""expression exceeded a pre-set level.\x22;\x0a"
"    case regex_constants\x3a\x3a""error_stack\x3a\x0a"
"        return \x22There was insufficient memory to determine whether the regular \x22\x0a"
"               \x22""expression could match the specified character sequence.\x22;\x0a"
"    case regex_constants\x3a\x3a__re_err_grammar\x3a\x0a"
"        return \x22""An invalid regex grammar has been requested.\x22;\x0a"
"    case regex_constants\x3a\x3a__re_err_empty\x3a\x0a"
"        return \x22""An empty regex is not allowed in the POSIX grammar.\x22;\x0a"
"    default\x3a\x0a"
"        break;\x0a"
"    }\x0a"
"    return \x22Unknown error type\x22;\x0a"
"}\x0a"
"\x0a"
"regex_error\x3a\x3aregex_error(regex_constants\x3a\x3a""error_type ecode)\x0a"
"    \x3a runtime_error(make_error_type_string(ecode)),\x0a"
"      __code_(ecode)\x0a"
"{}\x0a"
"\x0a"
"regex_error\x3a\x3a\x7eregex_error() throw() {}\x0a"
"\x0a"
"namespace {\x0a"
"\x0a"
"struct collationnames\x0a"
"{\x0a"
"    const char* elem_;\x0a"
"    char char_;\x0a"
"};\x0a"
"\x0a"
"const collationnames collatenames\x5b\x5d =\x0a"
"{\x0a"
"    {\x22""A\x22, 0x41},\x0a"
"    {\x22""B\x22, 0x42},\x0a"
"    {\x22""C\x22, 0x43},\x0a"
"    {\x22""D\x22, 0x44},\x0a"
"    {\x22""E\x22, 0x45},\x0a"
"    {\x22""F\x22, 0x46},\x0a"
"    {\x22G\x22, 0x47},\x0a"
"    {\x22H\x22, 0x48},\x0a"
"    {\x22I\x22, 0x49},\x0a"
"    {\x22J\x22, 0x4a},\x0a"
"    {\x22K\x22, 0x4b},\x0a"
"    {\x22L\x22, 0x4c},\x0a"
"    {\x22M\x22, 0x4d},\x0a"
"    {\x22N\x22, 0x4e},\x0a"
"    {\x22NUL\x22, 0x00},\x0a"
"    {\x22O\x22, 0x4f},\x0a"
"    {\x22P\x22, 0x50},\x0a"
"    {\x22Q\x22, 0x51},\x0a"
"    {\x22R\x22, 0x52},\x0a"
"    {\x22S\x22, 0x53},\x0a"
"    {\x22T\x22, 0x54},\x0a"
"    {\x22U\x22, 0x55},\x0a"
"    {\x22V\x22, 0x56},\x0a"
"    {\x22W\x22, 0x57},\x0a"
"    {\x22X\x22, 0x58},\x0a"
"    {\x22Y\x22, 0x59},\x0a"
"    {\x22Z\x22, 0x5a},\x0a"
"    {\x22""a\x22, 0x61},\x0a"
"    {\x22""alert\x22, 0x07},\x0a"
"    {\x22""ampersand\x22, 0x26},\x0a"
"    {\x22""apostrophe\x22, 0x27},\x0a"
"    {\x22""asterisk\x22, 0x2a},\x0a"
"    {\x22""b\x22, 0x62},\x0a"
"    {\x22""backslash\x22, 0x5c},\x0a"
"    {\x22""backspace\x22, 0x08},\x0a"
"    {\x22""c\x22, 0x63},\x0a"
"    {\x22""carriage-return\x22, 0x0d},\x0a"
"    {\x22""circumflex\x22, 0x5e},\x0a"
"    {\x22""circumflex-accent\x22, 0x5e},\x0a"
"    {\x22""colon\x22, 0x3a},\x0a"
"    {\x22""comma\x22, 0x2c},\x0a"
"    {\x22""commercial-at\x22, 0x40},\x0a"
"    {\x22""d\x22, 0x64},\x0a"
"    {\x22""dollar-sign\x22, 0x24},\x0a"
"    {\x22""e\x22, 0x65},\x0a"
"    {\x22""eight\x22, 0x38},\x0a"
"    {\x22""equals-sign\x22, 0x3d},\x0a"
"    {\x22""exclamation-mark\x22, 0x21},\x0a"
"    {\x22""f\x22, 0x66},\x0a"
"    {\x22""five\x22, 0x35},\x0a"
"    {\x22""form-feed\x22, 0x0c},\x0a"
"    {\x22""four\x22, 0x34},\x0a"
"    {\x22""full-stop\x22, 0x2e},\x0a"
"    {\x22g\x22, 0x67},\x0a"
"    {\x22grave-accent\x22, 0x60},\x0a"
"    {\x22greater-than-sign\x22, 0x3e},\x0a"
"    {\x22h\x22, 0x68},\x0a"
"    {\x22hyphen\x22, 0x2d},\x0a"
"    {\x22hyphen-minus\x22, 0x2d},\x0a"
"    {\x22i\x22, 0x69},\x0a"
"    {\x22j\x22, 0x6a},\x0a"
"    {\x22k\x22, 0x6b},\x0a"
"    {\x22l\x22, 0x6c},\x0a"
"    {\x22left-brace\x22, 0x7b},\x0a"
"    {\x22left-curly-bracket\x22, 0x7b},\x0a"
"    {\x22left-parenthesis\x22, 0x28},\x0a"
"    {\x22left-square-bracket\x22, 0x5b},\x0a"
"    {\x22less-than-sign\x22, 0x3c},\x0a"
"    {\x22low-line\x22, 0x5f},\x0a"
"    {\x22m\x22, 0x6d},\x0a"
"    {\x22n\x22, 0x6e},\x0a"
"    {\x22newline\x22, 0x0a},\x0a"
"    {\x22nine\x22, 0x39},\x0a"
"    {\x22number-sign\x22, 0x23},\x0a"
"    {\x22o\x22, 0x6f},\x0a"
"    {\x22one\x22, 0x31},\x0a"
"    {\x22p\x22, 0x70},\x0a"
"    {\x22percent-sign\x22, 0x25},\x0a"
"    {\x22period\x22, 0x2e},\x0a"
"    {\x22plus-sign\x22, 0x2b},\x0a"
"    {\x22q\x22, 0x71},\x0a"
"    {\x22question-mark\x22, 0x3f},\x0a"
"    {\x22quotation-mark\x22, 0x22},\x0a"
"    {\x22r\x22, 0x72},\x0a"
"    {\x22reverse-solidus\x22, 0x5c},\x0a"
"    {\x22right-brace\x22, 0x7d},\x0a"
"    {\x22right-curly-bracket\x22, 0x7d},\x0a"
"    {\x22right-parenthesis\x22, 0x29},\x0a"
"    {\x22right-square-bracket\x22, 0x5d},\x0a"
"    {\x22s\x22, 0x73},\x0a"
"    {\x22semicolon\x22, 0x3b},\x0a"
"    {\x22seven\x22, 0x37},\x0a"
"    {\x22six\x22, 0x36},\x0a"
"    {\x22slash\x22, 0x2f},\x0a"
"    {\x22solidus\x22, 0x2f},\x0a"
"    {\x22space\x22, 0x20},\x0a"
"    {\x22t\x22, 0x74},\x0a"
"    {\x22tab\x22, 0x09},\x0a"
"    {\x22three\x22, 0x33},\x0a"
"    {\x22tilde\x22, 0x7e},\x0a"
"    {\x22two\x22, 0x32},\x0a"
"    {\x22u\x22, 0x75},\x0a"
"    {\x22underscore\x22, 0x5f},\x0a"
"    {\x22v\x22, 0x76},\x0a"
"    {\x22vertical-line\x22, 0x7c},\x0a"
"    {\x22vertical-tab\x22, 0x0b},\x0a"
"    {\x22w\x22, 0x77},\x0a"
"    {\x22x\x22, 0x78},\x0a"
"    {\x22y\x22, 0x79},\x0a"
"    {\x22z\x22, 0x7a},\x0a"
"    {\x22zero\x22, 0x30}\x0a"
"};\x0a"
"\x0a"
"struct classnames\x0a"
"{\x0a"
"    const char* elem_;\x0a"
"    regex_traits<char>\x3a\x3a""char_class_type mask_;\x0a"
"};\x0a"
"\x0a"
"const classnames ClassNames\x5b\x5d =\x0a"
"{\x0a"
"    {\x22""alnum\x22,  ctype_base\x3a\x3a""alnum},\x0a"
"    {\x22""alpha\x22,  ctype_base\x3a\x3a""alpha},\x0a"
"    {\x22""blank\x22,  ctype_base\x3a\x3a""blank},\x0a"
"    {\x22""cntrl\x22,  ctype_base\x3a\x3a""cntrl},\x0a"
"    {\x22""d\x22,      ctype_base\x3a\x3a""digit},\x0a"
"    {\x22""digit\x22,  ctype_base\x3a\x3a""digit},\x0a"
"    {\x22graph\x22,  ctype_base\x3a\x3agraph},\x0a"
"    {\x22lower\x22,  ctype_base\x3a\x3alower},\x0a"
"    {\x22print\x22,  ctype_base\x3a\x3aprint},\x0a"
"    {\x22punct\x22,  ctype_base\x3a\x3apunct},\x0a"
"    {\x22s\x22,      ctype_base\x3a\x3aspace},\x0a"
"    {\x22space\x22,  ctype_base\x3a\x3aspace},\x0a"
"    {\x22upper\x22,  ctype_base\x3a\x3aupper},\x0a"
"    {\x22w\x22,      regex_traits<char>\x3a\x3a__regex_word},\x0a"
"    {\x22xdigit\x22, ctype_base\x3a\x3axdigit}\x0a"
"};\x0a"
"\x0a"
"struct use_strcmp\x0a"
"{\x0a"
"    bool operator()(const collationnames\x26 x, const char* y)\x0a"
"        {return strcmp(x.elem_, y) < 0;}\x0a"
"    bool operator()(const classnames\x26 x, const char* y)\x0a"
"        {return strcmp(x.elem_, y) < 0;}\x0a"
"};\x0a"
"\x0a"
"}\x0a"
"\x0a"
"string\x0a"
"__get_collation_name(const char* s)\x0a"
"{\x0a"
"    const collationnames* i =\x0a"
"            _VSTD\x3a\x3alower_bound(begin(collatenames), end(collatenames), s, use_strcmp());\x0a"
"    string r;\x0a"
"    if (i \x21= end(collatenames) \x26\x26 strcmp(s, i->elem_) == 0)\x0a"
"        r = char(i->char_);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"regex_traits<char>\x3a\x3a""char_class_type\x0a"
"__get_classname(const char* s, bool __icase)\x0a"
"{\x0a"
"    const classnames* i =\x0a"
"            _VSTD\x3a\x3alower_bound(begin(ClassNames), end(ClassNames), s, use_strcmp());\x0a"
"    regex_traits<char>\x3a\x3a""char_class_type r = 0;\x0a"
"    if (i \x21= end(ClassNames) \x26\x26 strcmp(s, i->elem_) == 0)\x0a"
"    {\x0a"
"        r = i->mask_;\x0a"
"        if (r == regex_traits<char>\x3a\x3a__regex_word)\x0a"
"            r \x7c= ctype_base\x3a\x3a""alnum \x7c ctype_base\x3a\x3aupper \x7c ctype_base\x3a\x3alower;\x0a"
"        else if (__icase)\x0a"
"        {\x0a"
"            if (r \x26 (ctype_base\x3a\x3alower \x7c ctype_base\x3a\x3aupper))\x0a"
"                r \x7c= ctype_base\x3a\x3a""alpha;\x0a"
"        }\x0a"
"    }\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"void\x0a"
"__match_any_but_newline<char>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    if (__s.__current_ \x21= __s.__last_)\x0a"
"    {\x0a"
"        switch (*__s.__current_)\x0a"
"        {\x0a"
"        case '\x5cr'\x3a\x0a"
"        case '\x5cn'\x3a\x0a"
"            __s.__do_ = __state\x3a\x3a__reject;\x0a"
"            __s.__node_ = nullptr;\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            __s.__do_ = __state\x3a\x3a__accept_and_consume;\x0a"
"            ++__s.__current_;\x0a"
"            __s.__node_ = this->first();\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"void\x0a"
"__match_any_but_newline<wchar_t>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    if (__s.__current_ \x21= __s.__last_)\x0a"
"    {\x0a"
"        switch (*__s.__current_)\x0a"
"        {\x0a"
"        case '\x5cr'\x3a\x0a"
"        case '\x5cn'\x3a\x0a"
"        case 0x2028\x3a\x0a"
"        case 0x2029\x3a\x0a"
"            __s.__do_ = __state\x3a\x3a__reject;\x0a"
"            __s.__node_ = nullptr;\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            __s.__do_ = __state\x3a\x3a__accept_and_consume;\x0a"
"            ++__s.__current_;\x0a"
"            __s.__node_ = this->first();\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 8302 ); }