#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_shared_mutex_cpp( 
"//===---------------------- shared_mutex.cpp ------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22__config\x22\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"#include \x22shared_mutex\x22\x0a"
"#if defined(__unix__) \x26\x26  defined(__ELF__) \x26\x26 defined(_LIBCPP_HAS_COMMENT_LIB_PRAGMA)\x0a"
"#pragma comment(lib, \x22pthread\x22)\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// Shared Mutex Base\x0a"
"__shared_mutex_base\x3a\x3a__shared_mutex_base()\x0a"
"    \x3a __state_(0)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// Exclusive ownership\x0a"
"\x0a"
"void\x0a"
"__shared_mutex_base\x3a\x3alock()\x0a"
"{\x0a"
"    unique_lock<mutex> lk(__mut_);\x0a"
"    while (__state_ \x26 __write_entered_)\x0a"
"        __gate1_.wait(lk);\x0a"
"    __state_ \x7c= __write_entered_;\x0a"
"    while (__state_ \x26 __n_readers_)\x0a"
"        __gate2_.wait(lk);\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__shared_mutex_base\x3a\x3atry_lock()\x0a"
"{\x0a"
"    unique_lock<mutex> lk(__mut_);\x0a"
"    if (__state_ == 0)\x0a"
"    {\x0a"
"        __state_ = __write_entered_;\x0a"
"        return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__shared_mutex_base\x3a\x3aunlock()\x0a"
"{\x0a"
"    lock_guard<mutex> _(__mut_);\x0a"
"    __state_ = 0;\x0a"
"    __gate1_.notify_all();\x0a"
"}\x0a"
"\x0a"
"// Shared ownership\x0a"
"\x0a"
"void\x0a"
"__shared_mutex_base\x3a\x3alock_shared()\x0a"
"{\x0a"
"    unique_lock<mutex> lk(__mut_);\x0a"
"    while ((__state_ \x26 __write_entered_) \x7c\x7c (__state_ \x26 __n_readers_) == __n_readers_)\x0a"
"        __gate1_.wait(lk);\x0a"
"    unsigned num_readers = (__state_ \x26 __n_readers_) + 1;\x0a"
"    __state_ \x26= \x7e__n_readers_;\x0a"
"    __state_ \x7c= num_readers;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__shared_mutex_base\x3a\x3atry_lock_shared()\x0a"
"{\x0a"
"    unique_lock<mutex> lk(__mut_);\x0a"
"    unsigned num_readers = __state_ \x26 __n_readers_;\x0a"
"    if (\x21(__state_ \x26 __write_entered_) \x26\x26 num_readers \x21= __n_readers_)\x0a"
"    {\x0a"
"        ++num_readers;\x0a"
"        __state_ \x26= \x7e__n_readers_;\x0a"
"        __state_ \x7c= num_readers;\x0a"
"        return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__shared_mutex_base\x3a\x3aunlock_shared()\x0a"
"{\x0a"
"    lock_guard<mutex> _(__mut_);\x0a"
"    unsigned num_readers = (__state_ \x26 __n_readers_) - 1;\x0a"
"    __state_ \x26= \x7e__n_readers_;\x0a"
"    __state_ \x7c= num_readers;\x0a"
"    if (__state_ \x26 __write_entered_)\x0a"
"    {\x0a"
"        if (num_readers == 0)\x0a"
"            __gate2_.notify_one();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        if (num_readers == __n_readers_ - 1)\x0a"
"            __gate1_.notify_one();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// Shared Timed Mutex\x0a"
"// These routines are here for ABI stability\x0a"
"shared_timed_mutex\x3a\x3ashared_timed_mutex() \x3a __base() {}\x0a"
"void shared_timed_mutex\x3a\x3alock()     { return __base.lock(); }\x0a"
"bool shared_timed_mutex\x3a\x3atry_lock() { return __base.try_lock(); }\x0a"
"void shared_timed_mutex\x3a\x3aunlock()   { return __base.unlock(); }\x0a"
"void shared_timed_mutex\x3a\x3alock_shared() { return __base.lock_shared(); }\x0a"
"bool shared_timed_mutex\x3a\x3atry_lock_shared() { return __base.try_lock_shared(); }\x0a"
"void shared_timed_mutex\x3a\x3aunlock_shared() { return __base.unlock_shared(); }\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"", 2955 ); }