#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_string_cpp( 
"//===------------------------- string.cpp ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22string\x22\x0a"
"#include \x22""charconv\x22\x0a"
"#include \x22""cstdlib\x22\x0a"
"#include \x22""cwchar\x22\x0a"
"#include \x22""cerrno\x22\x0a"
"#include \x22limits\x22\x0a"
"#include \x22stdexcept\x22\x0a"
"#include <stdio.h>\x0a"
"#include \x22__debug\x22\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS __basic_string_common<true>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_string<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS basic_string<wchar_t>;\x0a"
"\x0a"
"template\x0a"
"    string\x0a"
"    operator+<char, char_traits<char>, allocator<char> >(char const*, string const\x26);\x0a"
"\x0a"
"namespace\x0a"
"{\x0a"
"\x0a"
"template<typename T>\x0a"
"inline\x0a"
"void throw_helper( const string\x26 msg )\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw T( msg );\x0a"
"#else\x0a"
"    fprintf(stderr, \x22\x25s\x5cn\x22, msg.c_str());\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"void throw_from_string_out_of_range( const string\x26 func )\x0a"
"{\x0a"
"    throw_helper<out_of_range>(func + \x22\x3a out of range\x22);\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"void throw_from_string_invalid_arg( const string\x26 func )\x0a"
"{\x0a"
"    throw_helper<invalid_argument>(func + \x22\x3a no conversion\x22);\x0a"
"}\x0a"
"\x0a"
"// as_integer\x0a"
"\x0a"
"template<typename V, typename S, typename F>\x0a"
"inline\x0a"
"V\x0a"
"as_integer_helper(const string\x26 func, const S\x26 str, size_t* idx, int base, F f)\x0a"
"{\x0a"
"    typename S\x3a\x3avalue_type* ptr = nullptr;\x0a"
"    const typename S\x3a\x3avalue_type* const p = str.c_str();\x0a"
"    typename remove_reference<decltype(errno)>\x3a\x3atype errno_save = errno;\x0a"
"    errno = 0;\x0a"
"    V r = f(p, \x26ptr, base);\x0a"
"    swap(errno, errno_save);\x0a"
"    if (errno_save == ERANGE)\x0a"
"        throw_from_string_out_of_range(func);\x0a"
"    if (ptr == p)\x0a"
"        throw_from_string_invalid_arg(func);\x0a"
"    if (idx)\x0a"
"        *idx = static_cast<size_t>(ptr - p);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"template<typename V, typename S>\x0a"
"inline\x0a"
"V\x0a"
"as_integer(const string\x26 func, const S\x26 s, size_t* idx, int base);\x0a"
"\x0a"
"// string\x0a"
"template<>\x0a"
"inline\x0a"
"int\x0a"
"as_integer(const string\x26 func, const string\x26 s, size_t* idx, int base )\x0a"
"{\x0a"
"    // Use long as no Standard string to integer exists.\x0a"
"    long r = as_integer_helper<long>( func, s, idx, base, strtol );\x0a"
"    if (r < numeric_limits<int>\x3a\x3amin() \x7c\x7c numeric_limits<int>\x3a\x3amax() < r)\x0a"
"        throw_from_string_out_of_range(func);\x0a"
"    return static_cast<int>(r);\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"long\x0a"
"as_integer(const string\x26 func, const string\x26 s, size_t* idx, int base )\x0a"
"{\x0a"
"    return as_integer_helper<long>( func, s, idx, base, strtol );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"unsigned long\x0a"
"as_integer( const string\x26 func, const string\x26 s, size_t* idx, int base )\x0a"
"{\x0a"
"    return as_integer_helper<unsigned long>( func, s, idx, base, strtoul );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"long long\x0a"
"as_integer( const string\x26 func, const string\x26 s, size_t* idx, int base )\x0a"
"{\x0a"
"    return as_integer_helper<long long>( func, s, idx, base, strtoll );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"unsigned long long\x0a"
"as_integer( const string\x26 func, const string\x26 s, size_t* idx, int base )\x0a"
"{\x0a"
"    return as_integer_helper<unsigned long long>( func, s, idx, base, strtoull );\x0a"
"}\x0a"
"\x0a"
"// wstring\x0a"
"template<>\x0a"
"inline\x0a"
"int\x0a"
"as_integer( const string\x26 func, const wstring\x26 s, size_t* idx, int base )\x0a"
"{\x0a"
"    // Use long as no Stantard string to integer exists.\x0a"
"    long r = as_integer_helper<long>( func, s, idx, base, wcstol );\x0a"
"    if (r < numeric_limits<int>\x3a\x3amin() \x7c\x7c numeric_limits<int>\x3a\x3amax() < r)\x0a"
"        throw_from_string_out_of_range(func);\x0a"
"    return static_cast<int>(r);\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"long\x0a"
"as_integer( const string\x26 func, const wstring\x26 s, size_t* idx, int base )\x0a"
"{\x0a"
"    return as_integer_helper<long>( func, s, idx, base, wcstol );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"unsigned long\x0a"
"as_integer( const string\x26 func, const wstring\x26 s, size_t* idx, int base )\x0a"
"{\x0a"
"    return as_integer_helper<unsigned long>( func, s, idx, base, wcstoul );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"long long\x0a"
"as_integer( const string\x26 func, const wstring\x26 s, size_t* idx, int base )\x0a"
"{\x0a"
"    return as_integer_helper<long long>( func, s, idx, base, wcstoll );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"unsigned long long\x0a"
"as_integer( const string\x26 func, const wstring\x26 s, size_t* idx, int base )\x0a"
"{\x0a"
"    return as_integer_helper<unsigned long long>( func, s, idx, base, wcstoull );\x0a"
"}\x0a"
"\x0a"
"// as_float\x0a"
"\x0a"
"template<typename V, typename S, typename F>\x0a"
"inline\x0a"
"V\x0a"
"as_float_helper(const string\x26 func, const S\x26 str, size_t* idx, F f )\x0a"
"{\x0a"
"    typename S\x3a\x3avalue_type* ptr = nullptr;\x0a"
"    const typename S\x3a\x3avalue_type* const p = str.c_str();\x0a"
"    typename remove_reference<decltype(errno)>\x3a\x3atype errno_save = errno;\x0a"
"    errno = 0;\x0a"
"    V r = f(p, \x26ptr);\x0a"
"    swap(errno, errno_save);\x0a"
"    if (errno_save == ERANGE)\x0a"
"        throw_from_string_out_of_range(func);\x0a"
"    if (ptr == p)\x0a"
"        throw_from_string_invalid_arg(func);\x0a"
"    if (idx)\x0a"
"        *idx = static_cast<size_t>(ptr - p);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"template<typename V, typename S>\x0a"
"inline\x0a"
"V as_float( const string\x26 func, const S\x26 s, size_t* idx = nullptr );\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"float\x0a"
"as_float( const string\x26 func, const string\x26 s, size_t* idx )\x0a"
"{\x0a"
"    return as_float_helper<float>( func, s, idx, strtof );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"double\x0a"
"as_float(const string\x26 func, const string\x26 s, size_t* idx )\x0a"
"{\x0a"
"    return as_float_helper<double>( func, s, idx, strtod );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"long double\x0a"
"as_float( const string\x26 func, const string\x26 s, size_t* idx )\x0a"
"{\x0a"
"    return as_float_helper<long double>( func, s, idx, strtold );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"float\x0a"
"as_float( const string\x26 func, const wstring\x26 s, size_t* idx )\x0a"
"{\x0a"
"    return as_float_helper<float>( func, s, idx, wcstof );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"double\x0a"
"as_float( const string\x26 func, const wstring\x26 s, size_t* idx )\x0a"
"{\x0a"
"    return as_float_helper<double>( func, s, idx, wcstod );\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"inline\x0a"
"long double\x0a"
"as_float( const string\x26 func, const wstring\x26 s, size_t* idx )\x0a"
"{\x0a"
"    return as_float_helper<long double>( func, s, idx, wcstold );\x0a"
"}\x0a"
"\x0a"
"}  // unnamed namespace\x0a"
"\x0a"
"int\x0a"
"stoi(const string\x26 str, size_t* idx, int base)\x0a"
"{\x0a"
"    return as_integer<int>( \x22stoi\x22, str, idx, base );\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"stoi(const wstring\x26 str, size_t* idx, int base)\x0a"
"{\x0a"
"    return as_integer<int>( \x22stoi\x22, str, idx, base );\x0a"
"}\x0a"
"\x0a"
"long\x0a"
"stol(const string\x26 str, size_t* idx, int base)\x0a"
"{\x0a"
"    return as_integer<long>( \x22stol\x22, str, idx, base );\x0a"
"}\x0a"
"\x0a"
"long\x0a"
"stol(const wstring\x26 str, size_t* idx, int base)\x0a"
"{\x0a"
"    return as_integer<long>( \x22stol\x22, str, idx, base );\x0a"
"}\x0a"
"\x0a"
"unsigned long\x0a"
"stoul(const string\x26 str, size_t* idx, int base)\x0a"
"{\x0a"
"    return as_integer<unsigned long>( \x22stoul\x22, str, idx, base );\x0a"
"}\x0a"
"\x0a"
"unsigned long\x0a"
"stoul(const wstring\x26 str, size_t* idx, int base)\x0a"
"{\x0a"
"    return as_integer<unsigned long>( \x22stoul\x22, str, idx, base );\x0a"
"}\x0a"
"\x0a"
"long long\x0a"
"stoll(const string\x26 str, size_t* idx, int base)\x0a"
"{\x0a"
"    return as_integer<long long>( \x22stoll\x22, str, idx, base );\x0a"
"}\x0a"
"\x0a"
"long long\x0a"
"stoll(const wstring\x26 str, size_t* idx, int base)\x0a"
"{\x0a"
"    return as_integer<long long>( \x22stoll\x22, str, idx, base );\x0a"
"}\x0a"
"\x0a"
"unsigned long long\x0a"
"stoull(const string\x26 str, size_t* idx, int base)\x0a"
"{\x0a"
"    return as_integer<unsigned long long>( \x22stoull\x22, str, idx, base );\x0a"
"}\x0a"
"\x0a"
"unsigned long long\x0a"
"stoull(const wstring\x26 str, size_t* idx, int base)\x0a"
"{\x0a"
"    return as_integer<unsigned long long>( \x22stoull\x22, str, idx, base );\x0a"
"}\x0a"
"\x0a"
"float\x0a"
"stof(const string\x26 str, size_t* idx)\x0a"
"{\x0a"
"    return as_float<float>( \x22stof\x22, str, idx );\x0a"
"}\x0a"
"\x0a"
"float\x0a"
"stof(const wstring\x26 str, size_t* idx)\x0a"
"{\x0a"
"    return as_float<float>( \x22stof\x22, str, idx );\x0a"
"}\x0a"
"\x0a"
"double\x0a"
"stod(const string\x26 str, size_t* idx)\x0a"
"{\x0a"
"    return as_float<double>( \x22stod\x22, str, idx );\x0a"
"}\x0a"
"\x0a"
"double\x0a"
"stod(const wstring\x26 str, size_t* idx)\x0a"
"{\x0a"
"    return as_float<double>( \x22stod\x22, str, idx );\x0a"
"}\x0a"
"\x0a"
"long double\x0a"
"stold(const string\x26 str, size_t* idx)\x0a"
"{\x0a"
"    return as_float<long double>( \x22stold\x22, str, idx );\x0a"
"}\x0a"
"\x0a"
"long double\x0a"
"stold(const wstring\x26 str, size_t* idx)\x0a"
"{\x0a"
"    return as_float<long double>( \x22stold\x22, str, idx );\x0a"
"}\x0a"
"\x0a"
"// to_string\x0a"
"\x0a"
"namespace\x0a"
"{\x0a"
"\x0a"
"// as_string\x0a"
"\x0a"
"template<typename S, typename P, typename V >\x0a"
"inline\x0a"
"S\x0a"
"as_string(P sprintf_like, S s, const typename S\x3a\x3avalue_type* fmt, V a)\x0a"
"{\x0a"
"    typedef typename S\x3a\x3asize_type size_type;\x0a"
"    size_type available = s.size();\x0a"
"    while (true)\x0a"
"    {\x0a"
"        int status = sprintf_like(\x26s\x5b""0\x5d, available + 1, fmt, a);\x0a"
"        if ( status >= 0 )\x0a"
"        {\x0a"
"            size_type used = static_cast<size_type>(status);\x0a"
"            if ( used <= available )\x0a"
"            {\x0a"
"                s.resize( used );\x0a"
"                break;\x0a"
"            }\x0a"
"            available = used; // Assume this is advice of how much space we need.\x0a"
"        }\x0a"
"        else\x0a"
"            available = available * 2 + 1;\x0a"
"        s.resize(available);\x0a"
"    }\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"template <class S>\x0a"
"struct initial_string;\x0a"
"\x0a"
"template <>\x0a"
"struct initial_string<string>\x0a"
"{\x0a"
"    string\x0a"
"    operator()() const\x0a"
"    {\x0a"
"        string s;\x0a"
"        s.resize(s.capacity());\x0a"
"        return s;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct initial_string<wstring>\x0a"
"{\x0a"
"    wstring\x0a"
"    operator()() const\x0a"
"    {\x0a"
"        wstring s(20, wchar_t());\x0a"
"        s.resize(s.capacity());\x0a"
"        return s;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"typedef int (*wide_printf)(wchar_t* __restrict, size_t, const wchar_t*__restrict, ...);\x0a"
"\x0a"
"inline\x0a"
"wide_printf\x0a"
"get_swprintf()\x0a"
"{\x0a"
"#ifndef _LIBCPP_MSVCRT\x0a"
"    return swprintf;\x0a"
"#else\x0a"
"    return static_cast<int (__cdecl*)(wchar_t* __restrict, size_t, const wchar_t*__restrict, ...)>(_snwprintf);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <typename S, typename V>\x0a"
"S i_to_string(const V v)\x0a"
"{\x0a"
"//  numeric_limits\x3a\x3a""digits10 returns value less on 1 than desired for unsigned numbers.\x0a"
"//  For example, for 1-byte unsigned value digits10 is 2 (999 can not be represented),\x0a"
"//  so we need +1 here.\x0a"
"    constexpr size_t bufsize = numeric_limits<V>\x3a\x3a""digits10 + 2;  // +1 for minus, +1 for digits10\x0a"
"    char buf\x5b""bufsize\x5d;\x0a"
"    const auto res = to_chars(buf, buf + bufsize, v);\x0a"
"    _LIBCPP_ASSERT(res.ec == errc(), \x22""bufsize must be large enough to accomodate the value\x22);\x0a"
"    return S(buf, res.ptr);\x0a"
"}\x0a"
"\x0a"
"}  // unnamed namespace\x0a"
"\x0a"
"string  to_string (int val)                { return i_to_string< string>(val); }\x0a"
"string  to_string (long val)               { return i_to_string< string>(val); }\x0a"
"string  to_string (long long val)          { return i_to_string< string>(val); }\x0a"
"string  to_string (unsigned val)           { return i_to_string< string>(val); }\x0a"
"string  to_string (unsigned long val)      { return i_to_string< string>(val); }\x0a"
"string  to_string (unsigned long long val) { return i_to_string< string>(val); }\x0a"
"\x0a"
"wstring to_wstring(int val)                { return i_to_string<wstring>(val); }\x0a"
"wstring to_wstring(long val)               { return i_to_string<wstring>(val); }\x0a"
"wstring to_wstring(long long val)          { return i_to_string<wstring>(val); }\x0a"
"wstring to_wstring(unsigned val)           { return i_to_string<wstring>(val); }\x0a"
"wstring to_wstring(unsigned long val)      { return i_to_string<wstring>(val); }\x0a"
"wstring to_wstring(unsigned long long val) { return i_to_string<wstring>(val); }\x0a"
"\x0a"
"\x0a"
"string  to_string (float val)       { return as_string(snprintf,       initial_string< string>()(),   \x22\x25""f\x22, val); }\x0a"
"string  to_string (double val)      { return as_string(snprintf,       initial_string< string>()(),   \x22\x25""f\x22, val); }\x0a"
"string  to_string (long double val) { return as_string(snprintf,       initial_string< string>()(),  \x22\x25Lf\x22, val); }\x0a"
"\x0a"
"wstring to_wstring(float val)       { return as_string(get_swprintf(), initial_string<wstring>()(),  L\x22\x25""f\x22, val); }\x0a"
"wstring to_wstring(double val)      { return as_string(get_swprintf(), initial_string<wstring>()(),  L\x22\x25""f\x22, val); }\x0a"
"wstring to_wstring(long double val) { return as_string(get_swprintf(), initial_string<wstring>()(), L\x22\x25Lf\x22, val); }\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 11577 ); }