#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_strstream_cpp( 
"//===------------------------ strstream.cpp -------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22strstream\x22\x0a"
"#include \x22""algorithm\x22\x0a"
"#include \x22""climits\x22\x0a"
"#include \x22""cstring\x22\x0a"
"#include \x22""cstdlib\x22\x0a"
"#include \x22__debug\x22\x0a"
"#include \x22__undef_macros\x22\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"strstreambuf\x3a\x3astrstreambuf(streamsize __alsize)\x0a"
"    \x3a __strmode_(__dynamic),\x0a"
"      __alsize_(__alsize),\x0a"
"      __palloc_(nullptr),\x0a"
"      __pfree_(nullptr)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3astrstreambuf(void* (*__palloc)(size_t), void (*__pfree)(void*))\x0a"
"    \x3a __strmode_(__dynamic),\x0a"
"      __alsize_(__default_alsize),\x0a"
"      __palloc_(__palloc),\x0a"
"      __pfree_(__pfree)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"strstreambuf\x3a\x3a__init(char* __gnext, streamsize __n, char* __pbeg)\x0a"
"{\x0a"
"    if (__n == 0)\x0a"
"        __n = static_cast<streamsize>(strlen(__gnext));\x0a"
"    else if (__n < 0)\x0a"
"        __n = INT_MAX;\x0a"
"    if (__pbeg == nullptr)\x0a"
"        setg(__gnext, __gnext, __gnext + __n);\x0a"
"    else\x0a"
"    {\x0a"
"        setg(__gnext, __gnext, __pbeg);\x0a"
"        setp(__pbeg, __pbeg + __n);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3astrstreambuf(char* __gnext, streamsize __n, char* __pbeg)\x0a"
"    \x3a __strmode_(),\x0a"
"      __alsize_(__default_alsize),\x0a"
"      __palloc_(nullptr),\x0a"
"      __pfree_(nullptr)\x0a"
"{\x0a"
"    __init(__gnext, __n, __pbeg);\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3astrstreambuf(const char* __gnext, streamsize __n)\x0a"
"    \x3a __strmode_(__constant),\x0a"
"      __alsize_(__default_alsize),\x0a"
"      __palloc_(nullptr),\x0a"
"      __pfree_(nullptr)\x0a"
"{\x0a"
"    __init(const_cast<char *>(__gnext), __n, nullptr);\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3astrstreambuf(signed char* __gnext, streamsize __n, signed char* __pbeg)\x0a"
"    \x3a __strmode_(),\x0a"
"      __alsize_(__default_alsize),\x0a"
"      __palloc_(nullptr),\x0a"
"      __pfree_(nullptr)\x0a"
"{\x0a"
"    __init(const_cast<char *>(reinterpret_cast<const char*>(__gnext)), __n, reinterpret_cast<char*>(__pbeg));\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3astrstreambuf(const signed char* __gnext, streamsize __n)\x0a"
"    \x3a __strmode_(__constant),\x0a"
"      __alsize_(__default_alsize),\x0a"
"      __palloc_(nullptr),\x0a"
"      __pfree_(nullptr)\x0a"
"{\x0a"
"    __init(const_cast<char *>(reinterpret_cast<const char*>(__gnext)), __n, nullptr);\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3astrstreambuf(unsigned char* __gnext, streamsize __n, unsigned char* __pbeg)\x0a"
"    \x3a __strmode_(),\x0a"
"      __alsize_(__default_alsize),\x0a"
"      __palloc_(nullptr),\x0a"
"      __pfree_(nullptr)\x0a"
"{\x0a"
"    __init(const_cast<char *>(reinterpret_cast<const char*>(__gnext)), __n, reinterpret_cast<char*>(__pbeg));\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3astrstreambuf(const unsigned char* __gnext, streamsize __n)\x0a"
"    \x3a __strmode_(__constant),\x0a"
"      __alsize_(__default_alsize),\x0a"
"      __palloc_(nullptr),\x0a"
"      __pfree_(nullptr)\x0a"
"{\x0a"
"    __init(const_cast<char *>(reinterpret_cast<const char*>(__gnext)), __n, nullptr);\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3a\x7estrstreambuf()\x0a"
"{\x0a"
"    if (eback() \x26\x26 (__strmode_ \x26 __allocated) \x21= 0 \x26\x26 (__strmode_ \x26 __frozen) == 0)\x0a"
"    {\x0a"
"        if (__pfree_)\x0a"
"            __pfree_(eback());\x0a"
"        else\x0a"
"            delete \x5b\x5d eback();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"strstreambuf\x3a\x3aswap(strstreambuf\x26 __rhs)\x0a"
"{\x0a"
"    streambuf\x3a\x3aswap(__rhs);\x0a"
"    _VSTD\x3a\x3aswap(__strmode_, __rhs.__strmode_);\x0a"
"    _VSTD\x3a\x3aswap(__alsize_, __rhs.__alsize_);\x0a"
"    _VSTD\x3a\x3aswap(__palloc_, __rhs.__palloc_);\x0a"
"    _VSTD\x3a\x3aswap(__pfree_, __rhs.__pfree_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"strstreambuf\x3a\x3a""freeze(bool __freezefl)\x0a"
"{\x0a"
"    if (__strmode_ \x26 __dynamic)\x0a"
"    {\x0a"
"        if (__freezefl)\x0a"
"            __strmode_ \x7c= __frozen;\x0a"
"        else\x0a"
"            __strmode_ \x26= \x7e__frozen;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"char*\x0a"
"strstreambuf\x3a\x3astr()\x0a"
"{\x0a"
"    if (__strmode_ \x26 __dynamic)\x0a"
"        __strmode_ \x7c= __frozen;\x0a"
"    return eback();\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"strstreambuf\x3a\x3apcount() const\x0a"
"{\x0a"
"    return static_cast<int>(pptr() - pbase());\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3aint_type\x0a"
"strstreambuf\x3a\x3aoverflow(int_type __c)\x0a"
"{\x0a"
"    if (__c == EOF)\x0a"
"        return int_type(0);\x0a"
"    if (pptr() == epptr())\x0a"
"    {\x0a"
"        if ((__strmode_ \x26 __dynamic) == 0 \x7c\x7c (__strmode_ \x26 __frozen) \x21= 0)\x0a"
"            return int_type(EOF);\x0a"
"        size_t old_size = static_cast<size_t> ((epptr() \x3f epptr() \x3a egptr()) - eback());\x0a"
"        size_t new_size = max<size_t>(static_cast<size_t>(__alsize_), 2*old_size);\x0a"
"        if (new_size == 0)\x0a"
"            new_size = __default_alsize;\x0a"
"        char* buf = nullptr;\x0a"
"        if (__palloc_)\x0a"
"            buf = static_cast<char*>(__palloc_(new_size));\x0a"
"        else\x0a"
"            buf = new char\x5bnew_size\x5d;\x0a"
"        if (buf == nullptr)\x0a"
"            return int_type(EOF);\x0a"
"        if (old_size \x21= 0) {\x0a"
"            _LIBCPP_ASSERT(eback(), \x22overflow copying from NULL\x22);\x0a"
"            memcpy(buf, eback(), static_cast<size_t>(old_size));\x0a"
"        }\x0a"
"        ptrdiff_t ninp = gptr()  - eback();\x0a"
"        ptrdiff_t einp = egptr() - eback();\x0a"
"        ptrdiff_t nout = pptr()  - pbase();\x0a"
"        if (__strmode_ \x26 __allocated)\x0a"
"        {\x0a"
"            if (__pfree_)\x0a"
"                __pfree_(eback());\x0a"
"            else\x0a"
"                delete \x5b\x5d eback();\x0a"
"        }\x0a"
"        setg(buf, buf + ninp, buf + einp);\x0a"
"        setp(buf + einp, buf + new_size);\x0a"
"        __pbump(nout);\x0a"
"        __strmode_ \x7c= __allocated;\x0a"
"    }\x0a"
"    *pptr() = static_cast<char>(__c);\x0a"
"    pbump(1);\x0a"
"    return int_type(static_cast<unsigned char>(__c));\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3aint_type\x0a"
"strstreambuf\x3a\x3apbackfail(int_type __c)\x0a"
"{\x0a"
"    if (eback() == gptr())\x0a"
"        return EOF;\x0a"
"    if (__c == EOF)\x0a"
"    {\x0a"
"        gbump(-1);\x0a"
"        return int_type(0);\x0a"
"    }\x0a"
"    if (__strmode_ \x26 __constant)\x0a"
"    {\x0a"
"        if (gptr()\x5b-1\x5d == static_cast<char>(__c))\x0a"
"        {\x0a"
"            gbump(-1);\x0a"
"            return __c;\x0a"
"        }\x0a"
"        return EOF;\x0a"
"    }\x0a"
"    gbump(-1);\x0a"
"    *gptr() = static_cast<char>(__c);\x0a"
"    return __c;\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3aint_type\x0a"
"strstreambuf\x3a\x3aunderflow()\x0a"
"{\x0a"
"    if (gptr() == egptr())\x0a"
"    {\x0a"
"        if (egptr() >= pptr())\x0a"
"            return EOF;\x0a"
"        setg(eback(), gptr(), pptr());\x0a"
"    }\x0a"
"    return int_type(static_cast<unsigned char>(*gptr()));\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3apos_type\x0a"
"strstreambuf\x3a\x3aseekoff(off_type __off, ios_base\x3a\x3aseekdir __way, ios_base\x3a\x3aopenmode __which)\x0a"
"{\x0a"
"    off_type __p(-1);\x0a"
"    bool pos_in = (__which \x26 ios\x3a\x3ain) \x21= 0;\x0a"
"    bool pos_out = (__which \x26 ios\x3a\x3aout) \x21= 0;\x0a"
"    bool legal = false;\x0a"
"    switch (__way)\x0a"
"    {\x0a"
"    case ios\x3a\x3a""beg\x3a\x0a"
"    case ios\x3a\x3a""end\x3a\x0a"
"        if (pos_in \x7c\x7c pos_out)\x0a"
"            legal = true;\x0a"
"        break;\x0a"
"    case ios\x3a\x3a""cur\x3a\x0a"
"        if (pos_in \x21= pos_out)\x0a"
"            legal = true;\x0a"
"        break;\x0a"
"    }\x0a"
"    if (pos_in \x26\x26 gptr() == nullptr)\x0a"
"        legal = false;\x0a"
"    if (pos_out \x26\x26 pptr() == nullptr)\x0a"
"        legal = false;\x0a"
"    if (legal)\x0a"
"    {\x0a"
"        off_type newoff;\x0a"
"        char* seekhigh = epptr() \x3f epptr() \x3a egptr();\x0a"
"        switch (__way)\x0a"
"        {\x0a"
"        case ios\x3a\x3a""beg\x3a\x0a"
"            newoff = 0;\x0a"
"            break;\x0a"
"        case ios\x3a\x3a""cur\x3a\x0a"
"            newoff = (pos_in \x3f gptr() \x3a pptr()) - eback();\x0a"
"            break;\x0a"
"        case ios\x3a\x3a""end\x3a\x0a"
"            newoff = seekhigh - eback();\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            _LIBCPP_UNREACHABLE();\x0a"
"        }\x0a"
"        newoff += __off;\x0a"
"        if (0 <= newoff \x26\x26 newoff <= seekhigh - eback())\x0a"
"        {\x0a"
"            char* newpos = eback() + newoff;\x0a"
"            if (pos_in)\x0a"
"                setg(eback(), newpos, _VSTD\x3a\x3amax(newpos, egptr()));\x0a"
"            if (pos_out)\x0a"
"            {\x0a"
"                // min(pbase, newpos), newpos, epptr()\x0a"
"                __off = epptr() - newpos;\x0a"
"                setp(min(pbase(), newpos), epptr());\x0a"
"                __pbump((epptr() - pbase()) - __off);\x0a"
"            }\x0a"
"            __p = newoff;\x0a"
"        }\x0a"
"    }\x0a"
"    return pos_type(__p);\x0a"
"}\x0a"
"\x0a"
"strstreambuf\x3a\x3apos_type\x0a"
"strstreambuf\x3a\x3aseekpos(pos_type __sp, ios_base\x3a\x3aopenmode __which)\x0a"
"{\x0a"
"    off_type __p(-1);\x0a"
"    bool pos_in = (__which \x26 ios\x3a\x3ain) \x21= 0;\x0a"
"    bool pos_out = (__which \x26 ios\x3a\x3aout) \x21= 0;\x0a"
"    if (pos_in \x7c\x7c pos_out)\x0a"
"    {\x0a"
"        if (\x21((pos_in \x26\x26 gptr() == nullptr) \x7c\x7c (pos_out \x26\x26 pptr() == nullptr)))\x0a"
"        {\x0a"
"            off_type newoff = __sp;\x0a"
"            char* seekhigh = epptr() \x3f epptr() \x3a egptr();\x0a"
"            if (0 <= newoff \x26\x26 newoff <= seekhigh - eback())\x0a"
"            {\x0a"
"                char* newpos = eback() + newoff;\x0a"
"                if (pos_in)\x0a"
"                    setg(eback(), newpos, _VSTD\x3a\x3amax(newpos, egptr()));\x0a"
"                if (pos_out)\x0a"
"                {\x0a"
"                    // min(pbase, newpos), newpos, epptr()\x0a"
"                    off_type temp = epptr() - newpos;\x0a"
"                    setp(min(pbase(), newpos), epptr());\x0a"
"                    __pbump((epptr() - pbase()) - temp);\x0a"
"                }\x0a"
"                __p = newoff;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return pos_type(__p);\x0a"
"}\x0a"
"\x0a"
"istrstream\x3a\x3a\x7eistrstream()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"ostrstream\x3a\x3a\x7eostrstream()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"strstream\x3a\x3a\x7estrstream()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 8666 ); }