#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_system_error_cpp( 
"//===---------------------- system_error.cpp ------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22__config\x22\x0a"
"\x0a"
"#include \x22system_error\x22\x0a"
"\x0a"
"#include \x22include/config_elast.h\x22\x0a"
"#include \x22""cerrno\x22\x0a"
"#include \x22""cstring\x22\x0a"
"#include \x22""cstdio\x22\x0a"
"#include \x22""cstdlib\x22\x0a"
"#include \x22string\x22\x0a"
"#include \x22string.h\x22\x0a"
"#include \x22__debug\x22\x0a"
"\x0a"
"#if defined(__ANDROID__)\x0a"
"#include <android/api-level.h>\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// class error_category\x0a"
"\x0a"
"#if defined(_LIBCPP_DEPRECATED_ABI_LEGACY_LIBRARY_DEFINITIONS_FOR_INLINE_FUNCTIONS)\x0a"
"error_category\x3a\x3a""error_category() _NOEXCEPT\x0a"
"{\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"error_category\x3a\x3a\x7e""error_category() _NOEXCEPT\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"error_condition\x0a"
"error_category\x3a\x3a""default_error_condition(int ev) const _NOEXCEPT\x0a"
"{\x0a"
"    return error_condition(ev, *this);\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"error_category\x3a\x3a""equivalent(int code, const error_condition\x26 condition) const _NOEXCEPT\x0a"
"{\x0a"
"    return default_error_condition(code) == condition;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"error_category\x3a\x3a""equivalent(const error_code\x26 code, int condition) const _NOEXCEPT\x0a"
"{\x0a"
"    return *this == code.category() \x26\x26 code.value() == condition;\x0a"
"}\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_THREADS)\x0a"
"namespace {\x0a"
"\x0a"
"//  GLIBC also uses 1024 as the maximum buffer size internally.\x0a"
"constexpr size_t strerror_buff_size = 1024;\x0a"
"\x0a"
"string do_strerror_r(int ev);\x0a"
"\x0a"
"#if defined(_LIBCPP_MSVCRT_LIKE)\x0a"
"string do_strerror_r(int ev) {\x0a"
"  char buffer\x5bstrerror_buff_size\x5d;\x0a"
"  if (\x3a\x3astrerror_s(buffer, strerror_buff_size, ev) == 0)\x0a"
"    return string(buffer);\x0a"
"  std\x3a\x3asnprintf(buffer, strerror_buff_size, \x22unknown error \x25""d\x22, ev);\x0a"
"  return string(buffer);\x0a"
"}\x0a"
"#else\x0a"
"\x0a"
"// Only one of the two following functions will be used, depending on\x0a"
"// the return type of strerror_r\x3a\x0a"
"\x0a"
"// For the GNU variant, a char* return value\x3a\x0a"
"__attribute__((unused)) const char *\x0a"
"handle_strerror_r_return(char *strerror_return, char *) {\x0a"
"  // GNU always returns a string pointer in its return value. The\x0a"
"  // string might point to either the input buffer, or a static\x0a"
"  // buffer, but we don't care which.\x0a"
"  return strerror_return;\x0a"
"}\x0a"
"\x0a"
"// For the POSIX variant\x3a an int return value.\x0a"
"__attribute__((unused)) const char *\x0a"
"handle_strerror_r_return(int strerror_return, char *buffer) {\x0a"
"  // The POSIX variant either\x3a\x0a"
"  // - fills in the provided buffer and returns 0\x0a"
"  // - returns a positive error value, or\x0a"
"  // - returns -1 and fills in errno with an error value.\x0a"
"  if (strerror_return == 0)\x0a"
"    return buffer;\x0a"
"\x0a"
"  // Only handle EINVAL. Other errors abort.\x0a"
"  int new_errno = strerror_return == -1 \x3f errno \x3a strerror_return;\x0a"
"  if (new_errno == EINVAL)\x0a"
"    return \x22\x22;\x0a"
"\x0a"
"  _LIBCPP_ASSERT(new_errno == ERANGE, \x22unexpected error from \x3a\x3astrerror_r\x22);\x0a"
"  // FIXME maybe\x3f 'strerror_buff_size' is likely to exceed the\x0a"
"  // maximum error size so ERANGE shouldn't be returned.\x0a"
"  std\x3a\x3a""abort();\x0a"
"}\x0a"
"\x0a"
"// This function handles both GNU and POSIX variants, dispatching to\x0a"
"// one of the two above functions.\x0a"
"string do_strerror_r(int ev) {\x0a"
"    char buffer\x5bstrerror_buff_size\x5d;\x0a"
"    // Preserve errno around the call. (The C++ standard requires that\x0a"
"    // system_error functions not modify errno).\x0a"
"    const int old_errno = errno;\x0a"
"    const char *error_message = handle_strerror_r_return(\x0a"
"        \x3a\x3astrerror_r(ev, buffer, strerror_buff_size), buffer);\x0a"
"    // If we didn't get any message, print one now.\x0a"
"    if (\x21""error_message\x5b""0\x5d) {\x0a"
"      std\x3a\x3asnprintf(buffer, strerror_buff_size, \x22Unknown error \x25""d\x22, ev);\x0a"
"      error_message = buffer;\x0a"
"    }\x0a"
"    errno = old_errno;\x0a"
"    return string(error_message);\x0a"
"}\x0a"
"#endif\x0a"
"} // end namespace\x0a"
"#endif\x0a"
"\x0a"
"string\x0a"
"__do_message\x3a\x3amessage(int ev) const\x0a"
"{\x0a"
"#if defined(_LIBCPP_HAS_NO_THREADS)\x0a"
"    return string(\x3a\x3astrerror(ev));\x0a"
"#else\x0a"
"    return do_strerror_r(ev);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"class _LIBCPP_HIDDEN __generic_error_category\x0a"
"    \x3a public __do_message\x0a"
"{\x0a"
"public\x3a\x0a"
"    virtual const char* name() const _NOEXCEPT;\x0a"
"    virtual string message(int ev) const;\x0a"
"};\x0a"
"\x0a"
"const char*\x0a"
"__generic_error_category\x3a\x3aname() const _NOEXCEPT\x0a"
"{\x0a"
"    return \x22generic\x22;\x0a"
"}\x0a"
"\x0a"
"string\x0a"
"__generic_error_category\x3a\x3amessage(int ev) const\x0a"
"{\x0a"
"#ifdef _LIBCPP_ELAST\x0a"
"    if (ev > _LIBCPP_ELAST)\x0a"
"      return string(\x22unspecified generic_category error\x22);\x0a"
"#endif  // _LIBCPP_ELAST\x0a"
"    return __do_message\x3a\x3amessage(ev);\x0a"
"}\x0a"
"\x0a"
"const error_category\x26\x0a"
"generic_category() _NOEXCEPT\x0a"
"{\x0a"
"    static __generic_error_category s;\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"class _LIBCPP_HIDDEN __system_error_category\x0a"
"    \x3a public __do_message\x0a"
"{\x0a"
"public\x3a\x0a"
"    virtual const char* name() const _NOEXCEPT;\x0a"
"    virtual string message(int ev) const;\x0a"
"    virtual error_condition default_error_condition(int ev) const _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"const char*\x0a"
"__system_error_category\x3a\x3aname() const _NOEXCEPT\x0a"
"{\x0a"
"    return \x22system\x22;\x0a"
"}\x0a"
"\x0a"
"string\x0a"
"__system_error_category\x3a\x3amessage(int ev) const\x0a"
"{\x0a"
"#ifdef _LIBCPP_ELAST\x0a"
"    if (ev > _LIBCPP_ELAST)\x0a"
"      return string(\x22unspecified system_category error\x22);\x0a"
"#endif  // _LIBCPP_ELAST\x0a"
"    return __do_message\x3a\x3amessage(ev);\x0a"
"}\x0a"
"\x0a"
"error_condition\x0a"
"__system_error_category\x3a\x3a""default_error_condition(int ev) const _NOEXCEPT\x0a"
"{\x0a"
"#ifdef _LIBCPP_ELAST\x0a"
"    if (ev > _LIBCPP_ELAST)\x0a"
"      return error_condition(ev, system_category());\x0a"
"#endif  // _LIBCPP_ELAST\x0a"
"    return error_condition(ev, generic_category());\x0a"
"}\x0a"
"\x0a"
"const error_category\x26\x0a"
"system_category() _NOEXCEPT\x0a"
"{\x0a"
"    static __system_error_category s;\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"// error_condition\x0a"
"\x0a"
"string\x0a"
"error_condition\x3a\x3amessage() const\x0a"
"{\x0a"
"    return __cat_->message(__val_);\x0a"
"}\x0a"
"\x0a"
"// error_code\x0a"
"\x0a"
"string\x0a"
"error_code\x3a\x3amessage() const\x0a"
"{\x0a"
"    return __cat_->message(__val_);\x0a"
"}\x0a"
"\x0a"
"// system_error\x0a"
"\x0a"
"string\x0a"
"system_error\x3a\x3a__init(const error_code\x26 ec, string what_arg)\x0a"
"{\x0a"
"    if (ec)\x0a"
"    {\x0a"
"        if (\x21what_arg.empty())\x0a"
"            what_arg += \x22\x3a \x22;\x0a"
"        what_arg += ec.message();\x0a"
"    }\x0a"
"    return what_arg;\x0a"
"}\x0a"
"\x0a"
"system_error\x3a\x3asystem_error(error_code ec, const string\x26 what_arg)\x0a"
"    \x3a runtime_error(__init(ec, what_arg)),\x0a"
"      __ec_(ec)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"system_error\x3a\x3asystem_error(error_code ec, const char* what_arg)\x0a"
"    \x3a runtime_error(__init(ec, what_arg)),\x0a"
"      __ec_(ec)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"system_error\x3a\x3asystem_error(error_code ec)\x0a"
"    \x3a runtime_error(__init(ec, \x22\x22)),\x0a"
"      __ec_(ec)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"system_error\x3a\x3asystem_error(int ev, const error_category\x26 ecat, const string\x26 what_arg)\x0a"
"    \x3a runtime_error(__init(error_code(ev, ecat), what_arg)),\x0a"
"      __ec_(error_code(ev, ecat))\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"system_error\x3a\x3asystem_error(int ev, const error_category\x26 ecat, const char* what_arg)\x0a"
"    \x3a runtime_error(__init(error_code(ev, ecat), what_arg)),\x0a"
"      __ec_(error_code(ev, ecat))\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"system_error\x3a\x3asystem_error(int ev, const error_category\x26 ecat)\x0a"
"    \x3a runtime_error(__init(error_code(ev, ecat), \x22\x22)),\x0a"
"      __ec_(error_code(ev, ecat))\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"system_error\x3a\x3a\x7esystem_error() _NOEXCEPT\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__throw_system_error(int ev, const char* what_arg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw system_error(error_code(ev, system_category()), what_arg);\x0a"
"#else\x0a"
"    (void)ev;\x0a"
"    (void)what_arg;\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 7035 ); }