#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_thread_cpp( 
"//===------------------------- thread.cpp----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22__config\x22\x0a"
"#ifndef _LIBCPP_HAS_NO_THREADS\x0a"
"\x0a"
"#include \x22thread\x22\x0a"
"#include \x22""exception\x22\x0a"
"#include \x22vector\x22\x0a"
"#include \x22""future\x22\x0a"
"#include \x22limits\x22\x0a"
"#include <sys/types.h>\x0a"
"\x0a"
"#if defined(__unix__) \x7c\x7c (defined(__APPLE__) \x26\x26 defined(__MACH__))\x0a"
"# include <sys/param.h>\x0a"
"# if defined(__FreeBSD__) \x7c\x7c defined(__NetBSD__) \x7c\x7c defined(__OpenBSD__) \x7c\x7c defined(__DragonFly__) \x7c\x7c defined(__APPLE__)\x0a"
"#   include <sys/sysctl.h>\x0a"
"# endif\x0a"
"#endif // defined(__unix__) \x7c\x7c (defined(__APPLE__) \x26\x26 defined(__MACH__))\x0a"
"\x0a"
"#if defined(__unix__) \x7c\x7c (defined(__APPLE__) \x26\x26 defined(__MACH__)) \x7c\x7c defined(__CloudABI__) \x7c\x7c defined(__Fuchsia__) \x7c\x7c defined(__wasi__)\x0a"
"# include <unistd.h>\x0a"
"#endif // defined(__unix__) \x7c\x7c (defined(__APPLE__) \x26\x26 defined(__MACH__)) \x7c\x7c defined(__CloudABI__) \x7c\x7c defined(__Fuchsia__) \x7c\x7c defined(__wasi__)\x0a"
"\x0a"
"#if defined(__NetBSD__)\x0a"
"#pragma weak pthread_create // Do not create libpthread dependency\x0a"
"#endif\x0a"
"\x0a"
"#if defined(_LIBCPP_WIN32API)\x0a"
"#include <windows.h>\x0a"
"#endif\x0a"
"\x0a"
"#if defined(__unix__) \x26\x26  defined(__ELF__) \x26\x26 defined(_LIBCPP_HAS_COMMENT_LIB_PRAGMA)\x0a"
"#pragma comment(lib, \x22pthread\x22)\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"thread\x3a\x3a\x7ethread()\x0a"
"{\x0a"
"    if (\x21__libcpp_thread_isnull(\x26__t_))\x0a"
"        terminate();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"thread\x3a\x3ajoin()\x0a"
"{\x0a"
"    int ec = EINVAL;\x0a"
"    if (\x21__libcpp_thread_isnull(\x26__t_))\x0a"
"    {\x0a"
"        ec = __libcpp_thread_join(\x26__t_);\x0a"
"        if (ec == 0)\x0a"
"            __t_ = _LIBCPP_NULL_THREAD;\x0a"
"    }\x0a"
"\x0a"
"    if (ec)\x0a"
"        __throw_system_error(ec, \x22thread\x3a\x3ajoin failed\x22);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"thread\x3a\x3a""detach()\x0a"
"{\x0a"
"    int ec = EINVAL;\x0a"
"    if (\x21__libcpp_thread_isnull(\x26__t_))\x0a"
"    {\x0a"
"        ec = __libcpp_thread_detach(\x26__t_);\x0a"
"        if (ec == 0)\x0a"
"            __t_ = _LIBCPP_NULL_THREAD;\x0a"
"    }\x0a"
"\x0a"
"    if (ec)\x0a"
"        __throw_system_error(ec, \x22thread\x3a\x3a""detach failed\x22);\x0a"
"}\x0a"
"\x0a"
"unsigned\x0a"
"thread\x3a\x3ahardware_concurrency() _NOEXCEPT\x0a"
"{\x0a"
"#if defined(__divine__)\x0a"
"    return __dios_hardware_concurrency();\x0a"
"#elif defined(CTL_HW) \x26\x26 defined(HW_NCPU)\x0a"
"    unsigned n;\x0a"
"    int mib\x5b""2\x5d = {CTL_HW, HW_NCPU};\x0a"
"    std\x3a\x3asize_t s = sizeof(n);\x0a"
"    sysctl(mib, 2, \x26n, \x26s, 0, 0);\x0a"
"    return n;\x0a"
"#elif defined(_SC_NPROCESSORS_ONLN)\x0a"
"    long result = sysconf(_SC_NPROCESSORS_ONLN);\x0a"
"    // sysconf returns -1 if the name is invalid, the option does not exist or\x0a"
"    // does not have a definite limit.\x0a"
"    // if sysconf returns some other negative number, we have no idea\x0a"
"    // what is going on. Default to something safe.\x0a"
"    if (result < 0)\x0a"
"        return 0;\x0a"
"    return static_cast<unsigned>(result);\x0a"
"#elif defined(_LIBCPP_WIN32API)\x0a"
"    SYSTEM_INFO info;\x0a"
"    GetSystemInfo(\x26info);\x0a"
"    return info.dwNumberOfProcessors;\x0a"
"#else  // defined(CTL_HW) \x26\x26 defined(HW_NCPU)\x0a"
"    // TODO\x3a grovel through /proc or check cpuid on x86 and similar\x0a"
"    // instructions on other architectures.\x0a"
"#   if defined(_LIBCPP_WARNING)\x0a"
"        _LIBCPP_WARNING(\x22hardware_concurrency not yet implemented\x22)\x0a"
"#   else\x0a"
"#       warning hardware_concurrency not yet implemented\x0a"
"#   endif\x0a"
"    return 0;  // Means not computable \x5bthread.thread.static\x5d\x0a"
"#endif  // defined(CTL_HW) \x26\x26 defined(HW_NCPU)\x0a"
"}\x0a"
"\x0a"
"namespace this_thread\x0a"
"{\x0a"
"\x0a"
"void\x0a"
"sleep_for(const chrono\x3a\x3ananoseconds\x26 ns)\x0a"
"{\x0a"
"    if (ns > chrono\x3a\x3ananoseconds\x3a\x3azero())\x0a"
"    {\x0a"
"        __libcpp_thread_sleep_for(ns);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"}  // this_thread\x0a"
"\x0a"
"__thread_specific_ptr<__thread_struct>\x26\x0a"
"__thread_local_data()\x0a"
"{\x0a"
"    static __thread_specific_ptr<__thread_struct> __p;\x0a"
"    return __p;\x0a"
"}\x0a"
"\x0a"
"// __thread_struct_imp\x0a"
"\x0a"
"template <class T>\x0a"
"class _LIBCPP_HIDDEN __hidden_allocator\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T  value_type;\x0a"
"    \x0a"
"    T* allocate(size_t __n)\x0a"
"        {return static_cast<T*>(\x3a\x3aoperator new(__n * sizeof(T)));}\x0a"
"    void deallocate(T* __p, size_t) {\x3a\x3aoperator delete(static_cast<void*>(__p));}\x0a"
"\x0a"
"    size_t max_size() const {return size_t(\x7e""0) / sizeof(T);}\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_HIDDEN __thread_struct_imp\x0a"
"{\x0a"
"    typedef vector<__assoc_sub_state*,\x0a"
"                          __hidden_allocator<__assoc_sub_state*> > _AsyncStates;\x0a"
"    typedef vector<pair<condition_variable*, mutex*>,\x0a"
"               __hidden_allocator<pair<condition_variable*, mutex*> > > _Notify;\x0a"
"\x0a"
"    _AsyncStates async_states_;\x0a"
"    _Notify notify_;\x0a"
"\x0a"
"    __thread_struct_imp(const __thread_struct_imp\x26);\x0a"
"    __thread_struct_imp\x26 operator=(const __thread_struct_imp\x26);\x0a"
"public\x3a\x0a"
"    __thread_struct_imp() {}\x0a"
"    \x7e__thread_struct_imp();\x0a"
"\x0a"
"    void notify_all_at_thread_exit(condition_variable* cv, mutex* m);\x0a"
"    void __make_ready_at_thread_exit(__assoc_sub_state* __s);\x0a"
"};\x0a"
"\x0a"
"__thread_struct_imp\x3a\x3a\x7e__thread_struct_imp()\x0a"
"{\x0a"
"    for (_Notify\x3a\x3aiterator i = notify_.begin(), e = notify_.end();\x0a"
"            i \x21= e; ++i)\x0a"
"    {\x0a"
"        i->second->unlock();\x0a"
"        i->first->notify_all();\x0a"
"    }\x0a"
"    for (_AsyncStates\x3a\x3aiterator i = async_states_.begin(), e = async_states_.end();\x0a"
"            i \x21= e; ++i)\x0a"
"    {\x0a"
"        (*i)->__make_ready();\x0a"
"        (*i)->__release_shared();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__thread_struct_imp\x3a\x3anotify_all_at_thread_exit(condition_variable* cv, mutex* m)\x0a"
"{\x0a"
"    notify_.push_back(pair<condition_variable*, mutex*>(cv, m));\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__thread_struct_imp\x3a\x3a__make_ready_at_thread_exit(__assoc_sub_state* __s)\x0a"
"{\x0a"
"    async_states_.push_back(__s);\x0a"
"    __s->__add_shared();\x0a"
"}\x0a"
"\x0a"
"// __thread_struct\x0a"
"\x0a"
"__thread_struct\x3a\x3a__thread_struct()\x0a"
"    \x3a __p_(new __thread_struct_imp)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"__thread_struct\x3a\x3a\x7e__thread_struct()\x0a"
"{\x0a"
"    delete __p_;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__thread_struct\x3a\x3anotify_all_at_thread_exit(condition_variable* cv, mutex* m)\x0a"
"{\x0a"
"    __p_->notify_all_at_thread_exit(cv, m);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__thread_struct\x3a\x3a__make_ready_at_thread_exit(__assoc_sub_state* __s)\x0a"
"{\x0a"
"    __p_->__make_ready_at_thread_exit(__s);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_THREADS\x0a"
"", 5899 ); }