#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxxabi_src_cxa_default_handlers_cpp( 
"//===------------------------- cxa_default_handlers.cpp -------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//\x0a"
"// This file implements the default terminate_handler and unexpected_handler.\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#define _LIBCPP_BUILDING_LIBRARY\x0a"
"#include <stdexcept>\x0a"
"#include <new>\x0a"
"#include <exception>\x0a"
"#include <cstdlib>\x0a"
"#include \x22""abort_message.h\x22\x0a"
"#include \x22""cxxabi.h\x22\x0a"
"#include \x22""cxa_handlers.hpp\x22\x0a"
"#include \x22""cxa_exception.hpp\x22\x0a"
"#include \x22private_typeinfo.h\x22\x0a"
"#include \x22include/atomic_support.h\x22\x0a"
"\x0a"
"#if \x21""defined(LIBCXXABI_SILENT_TERMINATE)\x0a"
"static const char* cause = \x22uncaught\x22;\x0a"
"\x0a"
"__attribute__((noreturn))\x0a"
"static void demangling_terminate_handler()\x0a"
"{\x0a"
"    // If there might be an uncaught exception\x0a"
"    using namespace __cxxabiv1;\x0a"
"    __cxa_eh_globals* globals = __cxa_get_globals_fast();\x0a"
"    if (globals)\x0a"
"    {\x0a"
"        __cxa_exception* exception_header = globals->caughtExceptions;\x0a"
"        // If there is an uncaught exception\x0a"
"        if (exception_header)\x0a"
"        {\x0a"
"            _Unwind_Exception* unwind_exception =\x0a"
"                reinterpret_cast<_Unwind_Exception*>(exception_header + 1) - 1;\x0a"
"            if (__isOurExceptionClass(unwind_exception))\x0a"
"            {\x0a"
"                void* thrown_object =\x0a"
"                    __getExceptionClass(unwind_exception) == kOurDependentExceptionClass \x3f\x0a"
"                        ((__cxa_dependent_exception*)exception_header)->primaryException \x3a\x0a"
"                        exception_header + 1;\x0a"
"                const __shim_type_info* thrown_type =\x0a"
"                    static_cast<const __shim_type_info*>(exception_header->exceptionType);\x0a"
"                // Try to get demangled name of thrown_type\x0a"
"                int status;\x0a"
"                char buf\x5b""1024\x5d;\x0a"
"                size_t len = sizeof(buf);\x0a"
"                const char* name = __cxa_demangle(thrown_type->name(), buf, \x26len, \x26status);\x0a"
"                if (status \x21= 0)\x0a"
"                    name = thrown_type->name();\x0a"
"                // If the uncaught exception can be caught with std\x3a\x3a""exception\x26\x0a"
"                const __shim_type_info* catch_type =\x0a"
"\x09\x09\x09\x09 static_cast<const __shim_type_info*>(\x26typeid(std\x3a\x3a""exception));\x0a"
"                if (catch_type->can_catch(thrown_type, thrown_object))\x0a"
"                {\x0a"
"                    // Include the what() message from the exception\x0a"
"                    const std\x3a\x3a""exception* e = static_cast<const std\x3a\x3a""exception*>(thrown_object);\x0a"
"                    abort_message(\x22terminating with \x25s exception of type \x25s\x3a \x25s\x22,\x0a"
"                                  cause, name, e->what());\x0a"
"                }\x0a"
"                else\x0a"
"                    // Else just note that we're terminating with an exception\x0a"
"                    abort_message(\x22terminating with \x25s exception of type \x25s\x22,\x0a"
"                                   cause, name);\x0a"
"            }\x0a"
"            else\x0a"
"                // Else we're terminating with a foreign exception\x0a"
"                abort_message(\x22terminating with \x25s foreign exception\x22, cause);\x0a"
"        }\x0a"
"    }\x0a"
"    // Else just note that we're terminating\x0a"
"    abort_message(\x22terminating\x22);\x0a"
"}\x0a"
"\x0a"
"__attribute__((noreturn))\x0a"
"static void demangling_unexpected_handler()\x0a"
"{\x0a"
"    cause = \x22unexpected\x22;\x0a"
"    std\x3a\x3aterminate();\x0a"
"}\x0a"
"\x0a"
"static std\x3a\x3aterminate_handler default_terminate_handler = demangling_terminate_handler;\x0a"
"static std\x3a\x3aterminate_handler default_unexpected_handler = demangling_unexpected_handler;\x0a"
"#else\x0a"
"static std\x3a\x3aterminate_handler default_terminate_handler = std\x3a\x3a""abort;\x0a"
"static std\x3a\x3aterminate_handler default_unexpected_handler = std\x3a\x3aterminate;\x0a"
"#endif\x0a"
"\x0a"
"//\x0a"
"// Global variables that hold the pointers to the current handler\x0a"
"//\x0a"
"_LIBCXXABI_DATA_VIS\x0a"
"std\x3a\x3aterminate_handler __cxa_terminate_handler = default_terminate_handler;\x0a"
"\x0a"
"_LIBCXXABI_DATA_VIS\x0a"
"std\x3a\x3aunexpected_handler __cxa_unexpected_handler = default_unexpected_handler;\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"unexpected_handler\x0a"
"set_unexpected(unexpected_handler func) _NOEXCEPT\x0a"
"{\x0a"
"    if (func == 0)\x0a"
"        func = default_unexpected_handler;\x0a"
"    return __libcpp_atomic_exchange(\x26__cxa_unexpected_handler, func,\x0a"
"                                    _AO_Acq_Rel);\x0a"
"}\x0a"
"\x0a"
"terminate_handler\x0a"
"set_terminate(terminate_handler func) _NOEXCEPT\x0a"
"{\x0a"
"    if (func == 0)\x0a"
"        func = default_terminate_handler;\x0a"
"    return __libcpp_atomic_exchange(\x26__cxa_terminate_handler, func,\x0a"
"                                    _AO_Acq_Rel);\x0a"
"}\x0a"
"\x0a"
"}\x0a"
"", 4503 ); }