#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxxabi_src_cxa_exception_cpp( 
"//===------------------------- cxa_exception.cpp --------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//  \x0a"
"//  This file implements the \x22""Exception Handling APIs\x22\x0a"
"//  http\x3a//mentorembedded.github.io/cxx-abi/abi-eh.html\x0a"
"//  \x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22""cxxabi.h\x22\x0a"
"\x0a"
"#define _LIBCPP_BUILDING_LIBRARY\x0a"
"#include <exception>        // for std\x3a\x3aterminate\x0a"
"#include <cstring>          // for memset\x0a"
"#include \x22""cxa_exception.hpp\x22\x0a"
"#include \x22""cxa_handlers.hpp\x22\x0a"
"#include \x22""fallback_malloc.h\x22\x0a"
"#include \x22include/atomic_support.h\x22\x0a"
"\x0a"
"#if __has_feature(address_sanitizer)\x0a"
"extern \x22""C\x22 void __asan_handle_no_return(void);\x0a"
"#endif\x0a"
"\x0a"
"// +---------------------------+-----------------------------+---------------+\x0a"
"// \x7c __cxa_exception           \x7c _Unwind_Exception CLNGC++\x5c""0 \x7c thrown object \x7c\x0a"
"// +---------------------------+-----------------------------+---------------+\x0a"
"//                                                           ^\x0a"
"//                                                           \x7c\x0a"
"//   +-------------------------------------------------------+\x0a"
"//   \x7c\x0a"
"// +---------------------------+-----------------------------+\x0a"
"// \x7c __cxa_dependent_exception \x7c _Unwind_Exception CLNGC++\x5c""1 \x7c\x0a"
"// +---------------------------+-----------------------------+\x0a"
"\x0a"
"namespace __cxxabiv1 {\x0a"
"\x0a"
"//  Utility routines\x0a"
"static\x0a"
"inline\x0a"
"__cxa_exception*\x0a"
"cxa_exception_from_thrown_object(void* thrown_object)\x0a"
"{\x0a"
"    return static_cast<__cxa_exception*>(thrown_object) - 1;\x0a"
"}\x0a"
"\x0a"
"// Note\x3a  This is never called when exception_header is masquerading as a\x0a"
"//        __cxa_dependent_exception.\x0a"
"static\x0a"
"inline\x0a"
"void*\x0a"
"thrown_object_from_cxa_exception(__cxa_exception* exception_header)\x0a"
"{\x0a"
"    return static_cast<void*>(exception_header + 1);\x0a"
"}\x0a"
"\x0a"
"//  Get the exception object from the unwind pointer.\x0a"
"//  Relies on the structure layout, where the unwind pointer is right in\x0a"
"//  front of the user's exception object\x0a"
"static\x0a"
"inline\x0a"
"__cxa_exception*\x0a"
"cxa_exception_from_exception_unwind_exception(_Unwind_Exception* unwind_exception)\x0a"
"{\x0a"
"    return cxa_exception_from_thrown_object(unwind_exception + 1 );\x0a"
"}\x0a"
"\x0a"
"// Round s up to next multiple of a.\x0a"
"static inline\x0a"
"size_t aligned_allocation_size(size_t s, size_t a) {\x0a"
"    return (s + a - 1) \x26 \x7e(a - 1);\x0a"
"}\x0a"
"\x0a"
"static inline\x0a"
"size_t cxa_exception_size_from_exception_thrown_size(size_t size) {\x0a"
"    return aligned_allocation_size(size + sizeof (__cxa_exception),\x0a"
"                                   alignof(__cxa_exception));\x0a"
"}\x0a"
"\x0a"
"void __setExceptionClass(_Unwind_Exception* unwind_exception, uint64_t newValue) {\x0a"
"\x09\x3a\x3amemcpy(\x26unwind_exception->exception_class, \x26newValue, sizeof(newValue));\x0a"
"\x09}\x0a"
"\x09\x0a"
"\x0a"
"static void setOurExceptionClass(_Unwind_Exception* unwind_exception) {\x0a"
"    __setExceptionClass(unwind_exception, kOurExceptionClass);\x0a"
"}\x0a"
"\x0a"
"static void setDependentExceptionClass(_Unwind_Exception* unwind_exception) {\x0a"
"    __setExceptionClass(unwind_exception, kOurDependentExceptionClass);\x0a"
"}\x0a"
"\x0a"
"//  Is it one of ours\x3f\x0a"
"uint64_t __getExceptionClass(const _Unwind_Exception* unwind_exception) {\x0a"
"//\x09On x86 and some ARM unwinders, unwind_exception->exception_class is\x0a"
"//\x09\x09""a uint64_t. On other ARM unwinders, it is a char\x5b""8\x5d\x0a"
"//\x09See\x3a http\x3a//infocenter.arm.com/help/topic/com.arm.doc.ihi0038b/IHI0038B_ehabi.pdf\x0a"
"//\x09So we just copy it into a uint64_t to be sure.\x0a"
"\x09uint64_t exClass;\x0a"
"\x09\x3a\x3amemcpy(\x26""exClass, \x26unwind_exception->exception_class, sizeof(exClass));\x0a"
"\x09return exClass;\x0a"
"}\x0a"
"\x0a"
"bool __isOurExceptionClass(const _Unwind_Exception* unwind_exception) {\x0a"
"    return (__getExceptionClass(unwind_exception) \x26 get_vendor_and_language) == \x0a"
"           (kOurExceptionClass                    \x26 get_vendor_and_language);\x0a"
"}\x0a"
"\x0a"
"static bool isDependentException(_Unwind_Exception* unwind_exception) {\x0a"
"    return (__getExceptionClass(unwind_exception) \x26 0xFF) == 0x01;\x0a"
"}\x0a"
"\x0a"
"//  This does not need to be atomic\x0a"
"static inline int incrementHandlerCount(__cxa_exception *exception) {\x0a"
"    return ++exception->handlerCount;\x0a"
"}\x0a"
"\x0a"
"//  This does not need to be atomic\x0a"
"static inline  int decrementHandlerCount(__cxa_exception *exception) {\x0a"
"    return --exception->handlerCount;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"    If reason isn't _URC_FOREIGN_EXCEPTION_CAUGHT, then the terminateHandler\x0a"
"    stored in exc is called.  Otherwise the exceptionDestructor stored in \x0a"
"    exc is called, and then the memory for the exception is deallocated.\x0a"
"\x0a"
"    This is never called for a __cxa_dependent_exception.\x0a"
"*/\x0a"
"static\x0a"
"void\x0a"
"exception_cleanup_func(_Unwind_Reason_Code reason, _Unwind_Exception* unwind_exception)\x0a"
"{\x0a"
"    __cxa_exception* exception_header = cxa_exception_from_exception_unwind_exception(unwind_exception);\x0a"
"    if (_URC_FOREIGN_EXCEPTION_CAUGHT \x21= reason)\x0a"
"        std\x3a\x3a__terminate(exception_header->terminateHandler);\x0a"
"    // Just in case there exists a dependent exception that is pointing to this,\x0a"
"    //    check the reference count and only destroy this if that count goes to zero.\x0a"
"    __cxa_decrement_exception_refcount(unwind_exception + 1);\x0a"
"}\x0a"
"\x0a"
"static _LIBCXXABI_NORETURN void failed_throw(__cxa_exception* exception_header) {\x0a"
"//  Section 2.5.3 says\x3a\x0a"
"//      * For purposes of this ABI, several things are considered exception handlers\x3a\x0a"
"//      ** A terminate() call due to a throw.\x0a"
"//  and\x0a"
"//      * Upon entry, Following initialization of the catch parameter, \x0a"
"//          a handler must call\x3a\x0a"
"//      * void *__cxa_begin_catch(void *exceptionObject );\x0a"
"    (void) __cxa_begin_catch(\x26""exception_header->unwindHeader);\x0a"
"    std\x3a\x3a__terminate(exception_header->terminateHandler);\x0a"
"}\x0a"
"\x0a"
"// Return the offset of the __cxa_exception header from the start of the\x0a"
"// allocated buffer. If __cxa_exception's alignment is smaller than the maximum\x0a"
"// useful alignment for the target machine, padding has to be inserted before\x0a"
"// the header to ensure the thrown object that follows the header is\x0a"
"// sufficiently aligned. This happens if _Unwind_exception isn't double-word\x0a"
"// aligned (on Darwin, for example).\x0a"
"static size_t get_cxa_exception_offset() {\x0a"
"  struct S {\x0a"
"  } __attribute__((aligned));\x0a"
"\x0a"
"  // Compute the maximum alignment for the target machine.\x0a"
"  constexpr size_t alignment = std\x3a\x3a""alignment_of<S>\x3a\x3avalue;\x0a"
"  constexpr size_t excp_size = sizeof(__cxa_exception);\x0a"
"  constexpr size_t aligned_size =\x0a"
"      (excp_size + alignment - 1) / alignment * alignment;\x0a"
"  constexpr size_t offset = aligned_size - excp_size;\x0a"
"  static_assert((offset == 0 \x7c\x7c\x0a"
"                 std\x3a\x3a""alignment_of<_Unwind_Exception>\x3a\x3avalue < alignment),\x0a"
"                \x22offset is non-zero only if _Unwind_Exception isn't aligned\x22);\x0a"
"  return offset;\x0a"
"}\x0a"
"\x0a"
"extern \x22""C\x22 {\x0a"
"\x0a"
"//  Allocate a __cxa_exception object, and zero-fill it.\x0a"
"//  Reserve \x22thrown_size\x22 bytes on the end for the user's exception\x0a"
"//  object. Zero-fill the object. If memory can't be allocated, call\x0a"
"//  std\x3a\x3aterminate. Return a pointer to the memory to be used for the\x0a"
"//  user's exception object.\x0a"
"void *__cxa_allocate_exception(size_t thrown_size) throw() {\x0a"
"    size_t actual_size = cxa_exception_size_from_exception_thrown_size(thrown_size);\x0a"
"\x0a"
"    // Allocate extra space before the __cxa_exception header to ensure the\x0a"
"    // start of the thrown object is sufficiently aligned.\x0a"
"    size_t header_offset = get_cxa_exception_offset();\x0a"
"    char *raw_buffer =\x0a"
"        (char *)__aligned_malloc_with_fallback(header_offset + actual_size);\x0a"
"    if (NULL == raw_buffer)\x0a"
"        std\x3a\x3aterminate();\x0a"
"    __cxa_exception *exception_header =\x0a"
"        static_cast<__cxa_exception *>((void *)(raw_buffer + header_offset));\x0a"
"    std\x3a\x3amemset(exception_header, 0, actual_size);\x0a"
"    return thrown_object_from_cxa_exception(exception_header);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"//  Free a __cxa_exception object allocated with __cxa_allocate_exception.\x0a"
"void __cxa_free_exception(void *thrown_object) throw() {\x0a"
"    // Compute the size of the padding before the header.\x0a"
"    size_t header_offset = get_cxa_exception_offset();\x0a"
"    char *raw_buffer =\x0a"
"        ((char *)cxa_exception_from_thrown_object(thrown_object)) - header_offset;\x0a"
"    __aligned_free_with_fallback((void *)raw_buffer);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"//  This function shall allocate a __cxa_dependent_exception and\x0a"
"//  return a pointer to it. (Really to the object, not past its' end).\x0a"
"//  Otherwise, it will work like __cxa_allocate_exception.\x0a"
"void * __cxa_allocate_dependent_exception () {\x0a"
"    size_t actual_size = sizeof(__cxa_dependent_exception);\x0a"
"    void *ptr = __aligned_malloc_with_fallback(actual_size);\x0a"
"    if (NULL == ptr)\x0a"
"        std\x3a\x3aterminate();\x0a"
"    std\x3a\x3amemset(ptr, 0, actual_size);\x0a"
"    return ptr;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"//  This function shall free a dependent_exception.\x0a"
"//  It does not affect the reference count of the primary exception.\x0a"
"void __cxa_free_dependent_exception (void * dependent_exception) {\x0a"
"    __aligned_free_with_fallback(dependent_exception);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// 2.4.3 Throwing the Exception Object\x0a"
"/*\x0a"
"After constructing the exception object with the throw argument value,\x0a"
"the generated code calls the __cxa_throw runtime library routine. This\x0a"
"routine never returns.\x0a"
"\x0a"
"The __cxa_throw routine will do the following\x3a\x0a"
"\x0a"
"* Obtain the __cxa_exception header from the thrown exception object address,\x0a"
"which can be computed as follows\x3a \x0a"
" __cxa_exception *header = ((__cxa_exception *) thrown_exception - 1); \x0a"
"* Save the current unexpected_handler and terminate_handler in the __cxa_exception header.\x0a"
"* Save the tinfo and dest arguments in the __cxa_exception header. \x0a"
"* Set the exception_class field in the unwind header. This is a 64-bit value\x0a"
"representing the ASCII string \x22XXXXC++\x5c""0\x22, where \x22XXXX\x22 is a\x0a"
"vendor-dependent string. That is, for implementations conforming to this\x0a"
"ABI, the low-order 4 bytes of this 64-bit value will be \x22""C++\x5c""0\x22.\x0a"
"* Increment the uncaught_exception flag. \x0a"
"* Call _Unwind_RaiseException in the system unwind library, Its argument is the\x0a"
"pointer to the thrown exception, which __cxa_throw itself received as an argument.\x0a"
"__Unwind_RaiseException begins the process of stack unwinding, described\x0a"
"in Section 2.5. In special cases, such as an inability to find a\x0a"
"handler, _Unwind_RaiseException may return. In that case, __cxa_throw\x0a"
"will call terminate, assuming that there was no handler for the\x0a"
"exception.\x0a"
"*/\x0a"
"void\x0a"
"__cxa_throw(void *thrown_object, std\x3a\x3atype_info *tinfo, void (*dest)(void *)) {\x0a"
"    __cxa_eh_globals *globals = __cxa_get_globals();\x0a"
"    __cxa_exception* exception_header = cxa_exception_from_thrown_object(thrown_object);\x0a"
"\x0a"
"    exception_header->unexpectedHandler = std\x3a\x3aget_unexpected();\x0a"
"    exception_header->terminateHandler  = std\x3a\x3aget_terminate();\x0a"
"    exception_header->exceptionType = tinfo;\x0a"
"    exception_header->exceptionDestructor = dest;\x0a"
"    setOurExceptionClass(\x26""exception_header->unwindHeader);\x0a"
"    exception_header->referenceCount = 1;  // This is a newly allocated exception, no need for thread safety.\x0a"
"    globals->uncaughtExceptions += 1;   // Not atomically, since globals are thread-local\x0a"
"\x0a"
"    exception_header->unwindHeader.exception_cleanup = exception_cleanup_func;\x0a"
"\x0a"
"#if __has_feature(address_sanitizer)\x0a"
"    // Inform the ASan runtime that now might be a good time to clean stuff up.\x0a"
"    __asan_handle_no_return();\x0a"
"#endif\x0a"
"\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"    _Unwind_SjLj_RaiseException(\x26""exception_header->unwindHeader);\x0a"
"#else\x0a"
"    _Unwind_RaiseException(\x26""exception_header->unwindHeader);\x0a"
"#endif\x0a"
"    //  This only happens when there is no handler, or some unexpected unwinding\x0a"
"    //     error happens.\x0a"
"    failed_throw(exception_header);\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// 2.5.3 Exception Handlers\x0a"
"/*\x0a"
"The adjusted pointer is computed by the personality routine during phase 1\x0a"
"  and saved in the exception header (either __cxa_exception or\x0a"
"  __cxa_dependent_exception).\x0a"
"\x0a"
"  Requires\x3a  exception is native\x0a"
"*/\x0a"
"void *__cxa_get_exception_ptr(void *unwind_exception) throw() {\x0a"
"#if defined(_LIBCXXABI_ARM_EHABI)\x0a"
"    return reinterpret_cast<void*>(\x0a"
"        static_cast<_Unwind_Control_Block*>(unwind_exception)->barrier_cache.bitpattern\x5b""0\x5d);\x0a"
"#else\x0a"
"    return cxa_exception_from_exception_unwind_exception(\x0a"
"        static_cast<_Unwind_Exception*>(unwind_exception))->adjustedPtr;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#if defined(_LIBCXXABI_ARM_EHABI)\x0a"
"/*\x0a"
"The routine to be called before the cleanup.  This will save __cxa_exception in\x0a"
"__cxa_eh_globals, so that __cxa_end_cleanup() can recover later.\x0a"
"*/\x0a"
"bool __cxa_begin_cleanup(void *unwind_arg) throw() {\x0a"
"    _Unwind_Exception* unwind_exception = static_cast<_Unwind_Exception*>(unwind_arg);\x0a"
"    __cxa_eh_globals* globals = __cxa_get_globals();\x0a"
"    __cxa_exception* exception_header =\x0a"
"        cxa_exception_from_exception_unwind_exception(unwind_exception);\x0a"
"\x0a"
"    if (__isOurExceptionClass(unwind_exception))\x0a"
"    {\x0a"
"        if (0 == exception_header->propagationCount)\x0a"
"        {\x0a"
"            exception_header->nextPropagatingException = globals->propagatingExceptions;\x0a"
"            globals->propagatingExceptions = exception_header;\x0a"
"        }\x0a"
"        ++exception_header->propagationCount;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        // If the propagatingExceptions stack is not empty, since we can't\x0a"
"        // chain the foreign exception, terminate it.\x0a"
"        if (NULL \x21= globals->propagatingExceptions)\x0a"
"            std\x3a\x3aterminate();\x0a"
"        globals->propagatingExceptions = exception_header;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"The routine to be called after the cleanup has been performed.  It will get the\x0a"
"propagating __cxa_exception from __cxa_eh_globals, and continue the stack\x0a"
"unwinding with _Unwind_Resume.\x0a"
"\x0a"
"According to ARM EHABI 8.4.1, __cxa_end_cleanup() should not clobber any\x0a"
"register, thus we have to write this function in assembly so that we can save\x0a"
"{r1, r2, r3}.  We don't have to save r0 because it is the return value and the\x0a"
"first argument to _Unwind_Resume().  In addition, we are saving r4 in order to\x0a"
"align the stack to 16 bytes, even though it is a callee-save register.\x0a"
"*/\x0a"
"__attribute__((used)) static _Unwind_Exception *\x0a"
"__cxa_end_cleanup_impl()\x0a"
"{\x0a"
"    __cxa_eh_globals* globals = __cxa_get_globals();\x0a"
"    __cxa_exception* exception_header = globals->propagatingExceptions;\x0a"
"    if (NULL == exception_header)\x0a"
"    {\x0a"
"        // It seems that __cxa_begin_cleanup() is not called properly.\x0a"
"        // We have no choice but terminate the program now.\x0a"
"        std\x3a\x3aterminate();\x0a"
"    }\x0a"
"\x0a"
"    if (__isOurExceptionClass(\x26""exception_header->unwindHeader))\x0a"
"    {\x0a"
"        --exception_header->propagationCount;\x0a"
"        if (0 == exception_header->propagationCount)\x0a"
"        {\x0a"
"            globals->propagatingExceptions = exception_header->nextPropagatingException;\x0a"
"            exception_header->nextPropagatingException = NULL;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        globals->propagatingExceptions = NULL;\x0a"
"    }\x0a"
"    return \x26""exception_header->unwindHeader;\x0a"
"}\x0a"
"\x0a"
"asm (\x0a"
"    \x22\x09.pushsection\x09.text.__cxa_end_cleanup,\x5c\x22""ax\x5c\x22,\x25progbits\x5cn\x22\x0a"
"    \x22\x09.globl\x09__cxa_end_cleanup\x5cn\x22\x0a"
"    \x22\x09.type\x09__cxa_end_cleanup,\x25""function\x5cn\x22\x0a"
"    \x22__cxa_end_cleanup\x3a\x5cn\x22\x0a"
"    \x22\x09push\x09{r1, r2, r3, r4}\x5cn\x22\x0a"
"    \x22\x09""bl\x09__cxa_end_cleanup_impl\x5cn\x22\x0a"
"    \x22\x09pop\x09{r1, r2, r3, r4}\x5cn\x22\x0a"
"    \x22\x09""bl\x09_Unwind_Resume\x5cn\x22\x0a"
"    \x22\x09""bl\x09""abort\x5cn\x22\x0a"
"    \x22\x09.popsection\x22\x0a"
");\x0a"
"#endif  // defined(_LIBCXXABI_ARM_EHABI)\x0a"
"    \x0a"
"/*\x0a"
"This routine can catch foreign or native exceptions.  If native, the exception\x0a"
"can be a primary or dependent variety.  This routine may remain blissfully\x0a"
"ignorant of whether the native exception is primary or dependent.\x0a"
"\x0a"
"If the exception is native\x3a\x0a"
"* Increment's the exception's handler count.\x0a"
"* Push the exception on the stack of currently-caught exceptions if it is not \x0a"
"  already there (from a rethrow).\x0a"
"* Decrements the uncaught_exception count.\x0a"
"* Returns the adjusted pointer to the exception object, which is stored in\x0a"
"  the __cxa_exception by the personality routine.\x0a"
"\x0a"
"If the exception is foreign, this means it did not originate from one of throw\x0a"
"routines.  The foreign exception does not necessarily have a __cxa_exception\x0a"
"header.  However we can catch it here with a catch (...), or with a call\x0a"
"to terminate or unexpected during unwinding.\x0a"
"* Do not try to increment the exception's handler count, we don't know where\x0a"
"  it is.\x0a"
"* Push the exception on the stack of currently-caught exceptions only if the\x0a"
"  stack is empty.  The foreign exception has no way to link to the current\x0a"
"  top of stack.  If the stack is not empty, call terminate.  Even with an\x0a"
"  empty stack, this is hacked in by pushing a pointer to an imaginary\x0a"
"  __cxa_exception block in front of the foreign exception.  It would be better\x0a"
"  if the __cxa_eh_globals structure had a stack of _Unwind_Exception, but it\x0a"
"  doesn't.  It has a stack of __cxa_exception (which has a next* in it).\x0a"
"* Do not decrement the uncaught_exception count because we didn't increment it\x0a"
"  in __cxa_throw (or one of our rethrow functions).\x0a"
"* If we haven't terminated, assume the exception object is just past the \x0a"
"  _Unwind_Exception and return a pointer to that.\x0a"
"*/\x0a"
"void*\x0a"
"__cxa_begin_catch(void* unwind_arg) throw()\x0a"
"{\x0a"
"    _Unwind_Exception* unwind_exception = static_cast<_Unwind_Exception*>(unwind_arg);\x0a"
"    bool native_exception = __isOurExceptionClass(unwind_exception);\x0a"
"    __cxa_eh_globals* globals = __cxa_get_globals();\x0a"
"    // exception_header is a hackish offset from a foreign exception, but it\x0a"
"    //   works as long as we're careful not to try to access any __cxa_exception\x0a"
"    //   parts.\x0a"
"    __cxa_exception* exception_header =\x0a"
"            cxa_exception_from_exception_unwind_exception\x0a"
"            (\x0a"
"                static_cast<_Unwind_Exception*>(unwind_exception)\x0a"
"            );\x0a"
"    if (native_exception)\x0a"
"    {\x0a"
"        // Increment the handler count, removing the flag about being rethrown\x0a"
"        exception_header->handlerCount = exception_header->handlerCount < 0 \x3f\x0a"
"            -exception_header->handlerCount + 1 \x3a exception_header->handlerCount + 1;\x0a"
"        //  place the exception on the top of the stack if it's not already\x0a"
"        //    there by a previous rethrow\x0a"
"        if (exception_header \x21= globals->caughtExceptions)\x0a"
"        {\x0a"
"            exception_header->nextException = globals->caughtExceptions;\x0a"
"            globals->caughtExceptions = exception_header;\x0a"
"        }\x0a"
"        globals->uncaughtExceptions -= 1;   // Not atomically, since globals are thread-local\x0a"
"#if defined(_LIBCXXABI_ARM_EHABI)\x0a"
"        return reinterpret_cast<void*>(exception_header->unwindHeader.barrier_cache.bitpattern\x5b""0\x5d);\x0a"
"#else\x0a"
"        return exception_header->adjustedPtr;\x0a"
"#endif\x0a"
"    }\x0a"
"    // Else this is a foreign exception\x0a"
"    // If the caughtExceptions stack is not empty, terminate\x0a"
"    if (globals->caughtExceptions \x21= 0)\x0a"
"        std\x3a\x3aterminate();\x0a"
"    // Push the foreign exception on to the stack\x0a"
"    globals->caughtExceptions = exception_header;\x0a"
"    return unwind_exception + 1;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/*\x0a"
"Upon exit for any reason, a handler must call\x3a\x0a"
"    void __cxa_end_catch ();\x0a"
"\x0a"
"This routine can be called for either a native or foreign exception.\x0a"
"For a native exception\x3a\x0a"
"* Locates the most recently caught exception and decrements its handler count.\x0a"
"* Removes the exception from the caught exception stack, if the handler count goes to zero.\x0a"
"* If the handler count goes down to zero, and the exception was not re-thrown\x0a"
"  by throw, it locates the primary exception (which may be the same as the one\x0a"
"  it's handling) and decrements its reference count. If that reference count\x0a"
"  goes to zero, the function destroys the exception. In any case, if the current\x0a"
"  exception is a dependent exception, it destroys that.\x0a"
"\x0a"
"For a foreign exception\x3a\x0a"
"* If it has been rethrown, there is nothing to do.\x0a"
"* Otherwise delete the exception and pop the catch stack to empty.\x0a"
"*/\x0a"
"void __cxa_end_catch() {\x0a"
"  static_assert(sizeof(__cxa_exception) == sizeof(__cxa_dependent_exception),\x0a"
"                \x22sizeof(__cxa_exception) must be equal to \x22\x0a"
"                \x22sizeof(__cxa_dependent_exception)\x22);\x0a"
"  static_assert(__builtin_offsetof(__cxa_exception, referenceCount) ==\x0a"
"                    __builtin_offsetof(__cxa_dependent_exception,\x0a"
"                                       primaryException),\x0a"
"                \x22the layout of __cxa_exception must match the layout of \x22\x0a"
"                \x22__cxa_dependent_exception\x22);\x0a"
"  static_assert(__builtin_offsetof(__cxa_exception, handlerCount) ==\x0a"
"                    __builtin_offsetof(__cxa_dependent_exception, handlerCount),\x0a"
"                \x22the layout of __cxa_exception must match the layout of \x22\x0a"
"                \x22__cxa_dependent_exception\x22);\x0a"
"    __cxa_eh_globals* globals = __cxa_get_globals_fast(); // __cxa_get_globals called in __cxa_begin_catch\x0a"
"    __cxa_exception* exception_header = globals->caughtExceptions;\x0a"
"    // If we've rethrown a foreign exception, then globals->caughtExceptions\x0a"
"    //    will have been made an empty stack by __cxa_rethrow() and there is\x0a"
"    //    nothing more to be done.  Do nothing\x21\x0a"
"    if (NULL \x21= exception_header)\x0a"
"    {\x0a"
"        bool native_exception = __isOurExceptionClass(\x26""exception_header->unwindHeader);\x0a"
"        if (native_exception)\x0a"
"        {\x0a"
"            // This is a native exception\x0a"
"            if (exception_header->handlerCount < 0)\x0a"
"            {\x0a"
"                //  The exception has been rethrown by __cxa_rethrow, so don't delete it\x0a"
"                if (0 == incrementHandlerCount(exception_header))\x0a"
"                {\x0a"
"                    //  Remove from the chain of uncaught exceptions\x0a"
"                    globals->caughtExceptions = exception_header->nextException;\x0a"
"                    // but don't destroy\x0a"
"                }\x0a"
"                // Keep handlerCount negative in case there are nested catch's\x0a"
"                //   that need to be told that this exception is rethrown.  Don't\x0a"
"                //   erase this rethrow flag until the exception is recaught.\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                // The native exception has not been rethrown\x0a"
"                if (0 == decrementHandlerCount(exception_header))\x0a"
"                {\x0a"
"                    //  Remove from the chain of uncaught exceptions\x0a"
"                    globals->caughtExceptions = exception_header->nextException;\x0a"
"                    // Destroy this exception, being careful to distinguish\x0a"
"                    //    between dependent and primary exceptions\x0a"
"                    if (isDependentException(\x26""exception_header->unwindHeader))\x0a"
"                    {\x0a"
"                        // Reset exception_header to primaryException and deallocate the dependent exception\x0a"
"                        __cxa_dependent_exception* dep_exception_header =\x0a"
"                            reinterpret_cast<__cxa_dependent_exception*>(exception_header);\x0a"
"                        exception_header =\x0a"
"                            cxa_exception_from_thrown_object(dep_exception_header->primaryException);\x0a"
"                        __cxa_free_dependent_exception(dep_exception_header);\x0a"
"                    }\x0a"
"                    // Destroy the primary exception only if its referenceCount goes to 0\x0a"
"                    //    (this decrement must be atomic)\x0a"
"                    __cxa_decrement_exception_refcount(thrown_object_from_cxa_exception(exception_header));\x0a"
"                }\x0a"
"            }\x0a"
"        }       \x0a"
"        else\x0a"
"        {\x0a"
"            // The foreign exception has not been rethrown.  Pop the stack\x0a"
"            //    and delete it.  If there are nested catch's and they try\x0a"
"            //    to touch a foreign exception in any way, that is undefined\x0a"
"            //     behavior.  They likely can't since the only way to catch\x0a"
"            //     a foreign exception is with catch (...)\x21\x0a"
"            _Unwind_DeleteException(\x26globals->caughtExceptions->unwindHeader);\x0a"
"            globals->caughtExceptions = 0;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Note\x3a  exception_header may be masquerading as a __cxa_dependent_exception\x0a"
"//        and that's ok.  exceptionType is there too.\x0a"
"//        However watch out for foreign exceptions.  Return null for them.\x0a"
"std\x3a\x3atype_info *__cxa_current_exception_type() {\x0a"
"//  get the current exception\x0a"
"    __cxa_eh_globals *globals = __cxa_get_globals_fast();\x0a"
"    if (NULL == globals)\x0a"
"        return NULL;     //  If there have never been any exceptions, there are none now.\x0a"
"    __cxa_exception *exception_header = globals->caughtExceptions;\x0a"
"    if (NULL == exception_header)\x0a"
"        return NULL;        //  No current exception\x0a"
"    if (\x21__isOurExceptionClass(\x26""exception_header->unwindHeader))\x0a"
"        return NULL;\x0a"
"    return exception_header->exceptionType;\x0a"
"}\x0a"
"\x0a"
"// 2.5.4 Rethrowing Exceptions\x0a"
"/*  This routine can rethrow native or foreign exceptions.\x0a"
"If the exception is native\x3a\x0a"
"* marks the exception object on top of the caughtExceptions stack \x0a"
"  (in an implementation-defined way) as being rethrown. \x0a"
"* If the caughtExceptions stack is empty, it calls terminate() \x0a"
"  (see \x5b""C++FDIS\x5d \x5b""except.throw\x5d, 15.1.8). \x0a"
"* It then calls _Unwind_RaiseException which should not return\x0a"
"   (terminate if it does).\x0a"
"  Note\x3a  exception_header may be masquerading as a __cxa_dependent_exception\x0a"
"         and that's ok.\x0a"
"*/\x0a"
"void __cxa_rethrow() {\x0a"
"    __cxa_eh_globals* globals = __cxa_get_globals();\x0a"
"    __cxa_exception* exception_header = globals->caughtExceptions;\x0a"
"    if (NULL == exception_header)\x0a"
"        std\x3a\x3aterminate();      // throw; called outside of a exception handler\x0a"
"    bool native_exception = __isOurExceptionClass(\x26""exception_header->unwindHeader);\x0a"
"    if (native_exception)\x0a"
"    {\x0a"
"        //  Mark the exception as being rethrown (reverse the effects of __cxa_begin_catch)\x0a"
"        exception_header->handlerCount = -exception_header->handlerCount;\x0a"
"        globals->uncaughtExceptions += 1;\x0a"
"        //  __cxa_end_catch will remove this exception from the caughtExceptions stack if necessary\x0a"
"    }\x0a"
"    else  // this is a foreign exception\x0a"
"    {\x0a"
"        // The only way to communicate to __cxa_end_catch that we've rethrown\x0a"
"        //   a foreign exception, so don't delete us, is to pop the stack here\x0a"
"        //   which must be empty afterwards.  Then __cxa_end_catch will do\x0a"
"        //   nothing\x0a"
"        globals->caughtExceptions = 0;\x0a"
"    }\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"    _Unwind_SjLj_RaiseException(\x26""exception_header->unwindHeader);\x0a"
"#else\x0a"
"    _Unwind_RaiseException(\x26""exception_header->unwindHeader);\x0a"
"#endif\x0a"
"\x0a"
"    //  If we get here, some kind of unwinding error has occurred.\x0a"
"    //  There is some weird code generation bug happening with \x0a"
"    //     Apple clang version 4.0 (tags/Apple/clang-418.0.2) (based on LLVM 3.1svn)\x0a"
"    //     If we call failed_throw here.  Turns up with -O2 or higher, and -Os.\x0a"
"    __cxa_begin_catch(\x26""exception_header->unwindHeader);\x0a"
"    if (native_exception)\x0a"
"        std\x3a\x3a__terminate(exception_header->terminateHandler);\x0a"
"    // Foreign exception\x3a can't get exception_header->terminateHandler\x0a"
"    std\x3a\x3aterminate();\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"    If thrown_object is not null, atomically increment the referenceCount field\x0a"
"    of the __cxa_exception header associated with the thrown object referred to\x0a"
"    by thrown_object.\x0a"
"\x0a"
"    Requires\x3a  If thrown_object is not NULL, it is a native exception.\x0a"
"*/\x0a"
"void\x0a"
"__cxa_increment_exception_refcount(void *thrown_object) throw() {\x0a"
"    if (thrown_object \x21= NULL )\x0a"
"    {\x0a"
"        __cxa_exception* exception_header = cxa_exception_from_thrown_object(thrown_object);\x0a"
"        std\x3a\x3a__libcpp_atomic_add(\x26""exception_header->referenceCount, size_t(1));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"    If thrown_object is not null, atomically decrement the referenceCount field\x0a"
"    of the __cxa_exception header associated with the thrown object referred to\x0a"
"    by thrown_object.  If the referenceCount drops to zero, destroy and\x0a"
"    deallocate the exception.\x0a"
"\x0a"
"    Requires\x3a  If thrown_object is not NULL, it is a native exception.\x0a"
"*/\x0a"
"_LIBCXXABI_NO_CFI\x0a"
"void __cxa_decrement_exception_refcount(void *thrown_object) throw() {\x0a"
"    if (thrown_object \x21= NULL )\x0a"
"    {\x0a"
"        __cxa_exception* exception_header = cxa_exception_from_thrown_object(thrown_object);\x0a"
"        if (std\x3a\x3a__libcpp_atomic_add(\x26""exception_header->referenceCount, size_t(-1)) == 0)\x0a"
"        {\x0a"
"            if (NULL \x21= exception_header->exceptionDestructor)\x0a"
"                exception_header->exceptionDestructor(thrown_object);\x0a"
"            __cxa_free_exception(thrown_object);\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"    Returns a pointer to the thrown object (if any) at the top of the\x0a"
"    caughtExceptions stack.  Atomically increment the exception's referenceCount.\x0a"
"    If there is no such thrown object or if the thrown object is foreign,\x0a"
"    returns null.\x0a"
"\x0a"
"    We can use __cxa_get_globals_fast here to get the globals because if there have\x0a"
"    been no exceptions thrown, ever, on this thread, we can return NULL without \x0a"
"    the need to allocate the exception-handling globals.\x0a"
"*/\x0a"
"void *__cxa_current_primary_exception() throw() {\x0a"
"//  get the current exception\x0a"
"    __cxa_eh_globals* globals = __cxa_get_globals_fast();\x0a"
"    if (NULL == globals)\x0a"
"        return NULL;        //  If there are no globals, there is no exception\x0a"
"    __cxa_exception* exception_header = globals->caughtExceptions;\x0a"
"    if (NULL == exception_header)\x0a"
"        return NULL;        //  No current exception\x0a"
"    if (\x21__isOurExceptionClass(\x26""exception_header->unwindHeader))\x0a"
"        return NULL;        // Can't capture a foreign exception (no way to refcount it)\x0a"
"    if (isDependentException(\x26""exception_header->unwindHeader)) {\x0a"
"        __cxa_dependent_exception* dep_exception_header =\x0a"
"            reinterpret_cast<__cxa_dependent_exception*>(exception_header);\x0a"
"        exception_header = cxa_exception_from_thrown_object(dep_exception_header->primaryException);\x0a"
"    }\x0a"
"    void* thrown_object = thrown_object_from_cxa_exception(exception_header);\x0a"
"    __cxa_increment_exception_refcount(thrown_object);\x0a"
"    return thrown_object;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"    If reason isn't _URC_FOREIGN_EXCEPTION_CAUGHT, then the terminateHandler\x0a"
"    stored in exc is called.  Otherwise the referenceCount stored in the\x0a"
"    primary exception is decremented, destroying the primary if necessary.\x0a"
"    Finally the dependent exception is destroyed.\x0a"
"*/\x0a"
"static\x0a"
"void\x0a"
"dependent_exception_cleanup(_Unwind_Reason_Code reason, _Unwind_Exception* unwind_exception)\x0a"
"{\x0a"
"    __cxa_dependent_exception* dep_exception_header = \x0a"
"                      reinterpret_cast<__cxa_dependent_exception*>(unwind_exception + 1) - 1;\x0a"
"    if (_URC_FOREIGN_EXCEPTION_CAUGHT \x21= reason)\x0a"
"        std\x3a\x3a__terminate(dep_exception_header->terminateHandler);\x0a"
"    __cxa_decrement_exception_refcount(dep_exception_header->primaryException);\x0a"
"    __cxa_free_dependent_exception(dep_exception_header);\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"    If thrown_object is not null, allocate, initialize and throw a dependent\x0a"
"    exception.\x0a"
"*/\x0a"
"void\x0a"
"__cxa_rethrow_primary_exception(void* thrown_object)\x0a"
"{\x0a"
"    if ( thrown_object \x21= NULL )\x0a"
"    {\x0a"
"        // thrown_object guaranteed to be native because\x0a"
"        //   __cxa_current_primary_exception returns NULL for foreign exceptions\x0a"
"        __cxa_exception* exception_header = cxa_exception_from_thrown_object(thrown_object);\x0a"
"        __cxa_dependent_exception* dep_exception_header =\x0a"
"            static_cast<__cxa_dependent_exception*>(__cxa_allocate_dependent_exception());\x0a"
"        dep_exception_header->primaryException = thrown_object;\x0a"
"        __cxa_increment_exception_refcount(thrown_object);\x0a"
"        dep_exception_header->exceptionType = exception_header->exceptionType;\x0a"
"        dep_exception_header->unexpectedHandler = std\x3a\x3aget_unexpected();\x0a"
"        dep_exception_header->terminateHandler = std\x3a\x3aget_terminate();\x0a"
"        setDependentExceptionClass(\x26""dep_exception_header->unwindHeader);\x0a"
"        __cxa_get_globals()->uncaughtExceptions += 1;\x0a"
"        dep_exception_header->unwindHeader.exception_cleanup = dependent_exception_cleanup;\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"        _Unwind_SjLj_RaiseException(\x26""dep_exception_header->unwindHeader);\x0a"
"#else\x0a"
"        _Unwind_RaiseException(\x26""dep_exception_header->unwindHeader);\x0a"
"#endif\x0a"
"        // Some sort of unwinding error.  Note that terminate is a handler.\x0a"
"        __cxa_begin_catch(\x26""dep_exception_header->unwindHeader);\x0a"
"    }\x0a"
"    // If we return client will call terminate()\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__cxa_uncaught_exception() throw() { return __cxa_uncaught_exceptions() \x21= 0; }\x0a"
"\x0a"
"unsigned int\x0a"
"__cxa_uncaught_exceptions() throw()\x0a"
"{\x0a"
"    // This does not report foreign exceptions in flight\x0a"
"    __cxa_eh_globals* globals = __cxa_get_globals_fast();\x0a"
"    if (globals == 0)\x0a"
"        return 0;\x0a"
"    return globals->uncaughtExceptions;\x0a"
"}\x0a"
"\x0a"
"}  // extern \x22""C\x22\x0a"
"\x0a"
"}  // abi\x0a"
"", 32030 ); }