#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxxabi_src_cxa_guard_cpp( 
"//===---------------------------- cxa_guard.cpp ---------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22__cxxabi_config.h\x22\x0a"
"\x0a"
"#include \x22""abort_message.h\x22\x0a"
"#include <__threading_support>\x0a"
"\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"/*\x0a"
"    This implementation must be careful to not call code external to this file\x0a"
"    which will turn around and try to call __cxa_guard_acquire reentrantly.\x0a"
"    For this reason, the headers of this file are as restricted as possible.\x0a"
"    Previous implementations of this code for __APPLE__ have used\x0a"
"    std\x3a\x3a__libcpp_mutex_lock and the abort_message utility without problem. This\x0a"
"    implementation also uses std\x3a\x3a__libcpp_condvar_wait which has tested\x0a"
"    to not be a problem.\x0a"
"*/\x0a"
"\x0a"
"namespace __cxxabiv1\x0a"
"{\x0a"
"\x0a"
"namespace\x0a"
"{\x0a"
"\x0a"
"#ifdef __arm__\x0a"
"// A 32-bit, 4-byte-aligned static data value. The least significant 2 bits must\x0a"
"// be statically initialized to 0.\x0a"
"typedef uint32_t guard_type;\x0a"
"\x0a"
"inline void set_initialized(guard_type* guard_object) {\x0a"
"    *guard_object \x7c= 1;\x0a"
"}\x0a"
"#else\x0a"
"typedef uint64_t guard_type;\x0a"
"\x0a"
"void set_initialized(guard_type* guard_object) {\x0a"
"    char* initialized = (char*)guard_object;\x0a"
"    *initialized = 1;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#if defined(_LIBCXXABI_HAS_NO_THREADS) \x7c\x7c (defined(__APPLE__) \x26\x26 \x21""defined(__arm__))\x0a"
"#ifdef __arm__\x0a"
"\x0a"
"// Test the lowest bit.\x0a"
"inline bool is_initialized(guard_type* guard_object) {\x0a"
"    return (*guard_object) \x26 1;\x0a"
"}\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"bool is_initialized(guard_type* guard_object) {\x0a"
"    char* initialized = (char*)guard_object;\x0a"
"    return *initialized;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCXXABI_HAS_NO_THREADS\x0a"
"std\x3a\x3a__libcpp_mutex_t guard_mut = _LIBCPP_MUTEX_INITIALIZER;\x0a"
"std\x3a\x3a__libcpp_condvar_t guard_cv = _LIBCPP_CONDVAR_INITIALIZER;\x0a"
"#endif\x0a"
"\x0a"
"#if defined(__APPLE__) \x26\x26 \x21""defined(__arm__)\x0a"
"\x0a"
"typedef uint32_t lock_type;\x0a"
"\x0a"
"#if __LITTLE_ENDIAN__\x0a"
"\x0a"
"inline\x0a"
"lock_type\x0a"
"get_lock(uint64_t x)\x0a"
"{\x0a"
"    return static_cast<lock_type>(x >> 32);\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"void\x0a"
"set_lock(uint64_t\x26 x, lock_type y)\x0a"
"{\x0a"
"    x = static_cast<uint64_t>(y) << 32;\x0a"
"}\x0a"
"\x0a"
"#else  // __LITTLE_ENDIAN__\x0a"
"\x0a"
"inline\x0a"
"lock_type\x0a"
"get_lock(uint64_t x)\x0a"
"{\x0a"
"    return static_cast<lock_type>(x);\x0a"
"}\x0a"
"\x0a"
"inline\x0a"
"void\x0a"
"set_lock(uint64_t\x26 x, lock_type y)\x0a"
"{\x0a"
"    x = y;\x0a"
"}\x0a"
"\x0a"
"#endif  // __LITTLE_ENDIAN__\x0a"
"\x0a"
"#else  // \x21__APPLE__ \x7c\x7c __arm__\x0a"
"\x0a"
"typedef bool lock_type;\x0a"
"\x0a"
"#if \x21""defined(__arm__)\x0a"
"static_assert(std\x3a\x3ais_same<guard_type, uint64_t>\x3a\x3avalue, \x22\x22);\x0a"
"\x0a"
"inline lock_type get_lock(uint64_t x)\x0a"
"{\x0a"
"    union\x0a"
"    {\x0a"
"        uint64_t guard;\x0a"
"        uint8_t lock\x5b""2\x5d;\x0a"
"    } f = {x};\x0a"
"    return f.lock\x5b""1\x5d \x21= 0;\x0a"
"}\x0a"
"\x0a"
"inline void set_lock(uint64_t\x26 x, lock_type y)\x0a"
"{\x0a"
"    union\x0a"
"    {\x0a"
"        uint64_t guard;\x0a"
"        uint8_t lock\x5b""2\x5d;\x0a"
"    } f = {0};\x0a"
"    f.lock\x5b""1\x5d = y;\x0a"
"    x = f.guard;\x0a"
"}\x0a"
"#else // defined(__arm__)\x0a"
"static_assert(std\x3a\x3ais_same<guard_type, uint32_t>\x3a\x3avalue, \x22\x22);\x0a"
"\x0a"
"inline lock_type get_lock(uint32_t x)\x0a"
"{\x0a"
"    union\x0a"
"    {\x0a"
"        uint32_t guard;\x0a"
"        uint8_t lock\x5b""2\x5d;\x0a"
"    } f = {x};\x0a"
"    return f.lock\x5b""1\x5d \x21= 0;\x0a"
"}\x0a"
"\x0a"
"inline void set_lock(uint32_t\x26 x, lock_type y)\x0a"
"{\x0a"
"    union\x0a"
"    {\x0a"
"        uint32_t guard;\x0a"
"        uint8_t lock\x5b""2\x5d;\x0a"
"    } f = {0};\x0a"
"    f.lock\x5b""1\x5d = y;\x0a"
"    x = f.guard;\x0a"
"}\x0a"
"\x0a"
"#endif // \x21""defined(__arm__)\x0a"
"\x0a"
"#endif  // __APPLE__ \x26\x26 \x21__arm__\x0a"
"\x0a"
"}  // unnamed namespace\x0a"
"\x0a"
"extern \x22""C\x22\x0a"
"{\x0a"
"\x0a"
"#ifndef _LIBCXXABI_HAS_NO_THREADS\x0a"
"_LIBCXXABI_FUNC_VIS int __cxa_guard_acquire(guard_type *guard_object) {\x0a"
"    char* initialized = (char*)guard_object;\x0a"
"    if (std\x3a\x3a__libcpp_mutex_lock(\x26guard_mut))\x0a"
"        abort_message(\x22__cxa_guard_acquire failed to acquire mutex\x22);\x0a"
"    int result = *initialized == 0;\x0a"
"    if (result)\x0a"
"    {\x0a"
"#if defined(__APPLE__) \x26\x26 \x21""defined(__arm__)\x0a"
"        // This is a special-case pthread dependency for Mac. We can't pull this\x0a"
"        // out into libcxx's threading API (__threading_support) because not all\x0a"
"        // supported Mac environments provide this function (in pthread.h). To\x0a"
"        // make it possible to build/use libcxx in those environments, we have to\x0a"
"        // keep this pthread dependency local to libcxxabi. If there is some\x0a"
"        // convenient way to detect precisely when pthread_mach_thread_np is\x0a"
"        // available in a given Mac environment, it might still be possible to\x0a"
"        // bury this dependency in __threading_support.\x0a"
"        #ifdef _LIBCPP_HAS_THREAD_API_PTHREAD\x0a"
"           const lock_type id = pthread_mach_thread_np(std\x3a\x3a__libcpp_thread_get_current_id());\x0a"
"        #else\x0a"
"           #error \x22How do I pthread_mach_thread_np()\x3f\x22\x0a"
"        #endif\x0a"
"        lock_type lock = get_lock(*guard_object);\x0a"
"        if (lock)\x0a"
"        {\x0a"
"            // if this thread set lock for this same guard_object, abort\x0a"
"            if (lock == id)\x0a"
"                abort_message(\x22__cxa_guard_acquire detected deadlock\x22);\x0a"
"            do\x0a"
"            {\x0a"
"                if (std\x3a\x3a__libcpp_condvar_wait(\x26guard_cv, \x26guard_mut))\x0a"
"                    abort_message(\x22__cxa_guard_acquire condition variable wait failed\x22);\x0a"
"                lock = get_lock(*guard_object);\x0a"
"            } while (lock);\x0a"
"            result = \x21is_initialized(guard_object);\x0a"
"            if (result)\x0a"
"                set_lock(*guard_object, id);\x0a"
"        }\x0a"
"        else\x0a"
"            set_lock(*guard_object, id);\x0a"
"#else  // \x21__APPLE__ \x7c\x7c __arm__\x0a"
"        while (get_lock(*guard_object))\x0a"
"            if (std\x3a\x3a__libcpp_condvar_wait(\x26guard_cv, \x26guard_mut))\x0a"
"                abort_message(\x22__cxa_guard_acquire condition variable wait failed\x22);\x0a"
"        result = *initialized == 0;\x0a"
"        if (result)\x0a"
"            set_lock(*guard_object, true);\x0a"
"#endif  // \x21__APPLE__ \x7c\x7c __arm__\x0a"
"    }\x0a"
"    if (std\x3a\x3a__libcpp_mutex_unlock(\x26guard_mut))\x0a"
"        abort_message(\x22__cxa_guard_acquire failed to release mutex\x22);\x0a"
"    return result;\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_FUNC_VIS void __cxa_guard_release(guard_type *guard_object) {\x0a"
"    if (std\x3a\x3a__libcpp_mutex_lock(\x26guard_mut))\x0a"
"        abort_message(\x22__cxa_guard_release failed to acquire mutex\x22);\x0a"
"    *guard_object = 0;\x0a"
"    set_initialized(guard_object);\x0a"
"    if (std\x3a\x3a__libcpp_mutex_unlock(\x26guard_mut))\x0a"
"        abort_message(\x22__cxa_guard_release failed to release mutex\x22);\x0a"
"    if (std\x3a\x3a__libcpp_condvar_broadcast(\x26guard_cv))\x0a"
"        abort_message(\x22__cxa_guard_release failed to broadcast condition variable\x22);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_FUNC_VIS void __cxa_guard_abort(guard_type *guard_object) {\x0a"
"    if (std\x3a\x3a__libcpp_mutex_lock(\x26guard_mut))\x0a"
"        abort_message(\x22__cxa_guard_abort failed to acquire mutex\x22);\x0a"
"    *guard_object = 0;\x0a"
"    if (std\x3a\x3a__libcpp_mutex_unlock(\x26guard_mut))\x0a"
"        abort_message(\x22__cxa_guard_abort failed to release mutex\x22);\x0a"
"    if (std\x3a\x3a__libcpp_condvar_broadcast(\x26guard_cv))\x0a"
"        abort_message(\x22__cxa_guard_abort failed to broadcast condition variable\x22);\x0a"
"}\x0a"
"\x0a"
"#else // _LIBCXXABI_HAS_NO_THREADS\x0a"
"\x0a"
"_LIBCXXABI_FUNC_VIS int __cxa_guard_acquire(guard_type *guard_object) {\x0a"
"    return \x21is_initialized(guard_object);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_FUNC_VIS void __cxa_guard_release(guard_type *guard_object) {\x0a"
"    *guard_object = 0;\x0a"
"    set_initialized(guard_object);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_FUNC_VIS void __cxa_guard_abort(guard_type *guard_object) {\x0a"
"    *guard_object = 0;\x0a"
"}\x0a"
"\x0a"
"#endif // \x21_LIBCXXABI_HAS_NO_THREADS\x0a"
"\x0a"
"}  // extern \x22""C\x22\x0a"
"\x0a"
"}  // __cxxabiv1\x0a"
"", 7198 ); }