#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxxabi_src_cxa_handlers_cpp( 
"//===------------------------- cxa_handlers.cpp ---------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//\x0a"
"// This file implements the functionality associated with the terminate_handler,\x0a"
"//   unexpected_handler, and new_handler.\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#define _LIBCPP_BUILDING_LIBRARY\x0a"
"#include <stdexcept>\x0a"
"#include <new>\x0a"
"#include <exception>\x0a"
"#include \x22""abort_message.h\x22\x0a"
"#include \x22""cxxabi.h\x22\x0a"
"#include \x22""cxa_handlers.hpp\x22\x0a"
"#include \x22""cxa_exception.hpp\x22\x0a"
"#include \x22private_typeinfo.h\x22\x0a"
"#include \x22include/atomic_support.h\x22\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"unexpected_handler\x0a"
"get_unexpected() _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_atomic_load(\x26__cxa_unexpected_handler, _AO_Acquire);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__unexpected(unexpected_handler func)\x0a"
"{\x0a"
"    func();\x0a"
"    // unexpected handler should not return\x0a"
"    abort_message(\x22unexpected_handler unexpectedly returned\x22);\x0a"
"}\x0a"
"\x0a"
"__attribute__((noreturn))\x0a"
"void\x0a"
"unexpected()\x0a"
"{\x0a"
"    __unexpected(get_unexpected());\x0a"
"}\x0a"
"\x0a"
"terminate_handler\x0a"
"get_terminate() _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_atomic_load(\x26__cxa_terminate_handler, _AO_Acquire);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__terminate(terminate_handler func) _NOEXCEPT\x0a"
"{\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCXXABI_NO_EXCEPTIONS\x0a"
"        func();\x0a"
"        // handler should not return\x0a"
"        abort_message(\x22terminate_handler unexpectedly returned\x22);\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        // handler should not throw exception\x0a"
"        abort_message(\x22terminate_handler unexpectedly threw an exception\x22);\x0a"
"    }\x0a"
"#endif  // _LIBCXXABI_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"__attribute__((noreturn))\x0a"
"void\x0a"
"terminate() _NOEXCEPT\x0a"
"{\x0a"
"    // If there might be an uncaught exception\x0a"
"    using namespace __cxxabiv1;\x0a"
"    __cxa_eh_globals* globals = __cxa_get_globals_fast();\x0a"
"    if (globals)\x0a"
"    {\x0a"
"        __cxa_exception* exception_header = globals->caughtExceptions;\x0a"
"        if (exception_header)\x0a"
"        {\x0a"
"            _Unwind_Exception* unwind_exception =\x0a"
"                reinterpret_cast<_Unwind_Exception*>(exception_header + 1) - 1;\x0a"
"            if (__isOurExceptionClass(unwind_exception))\x0a"
"                __terminate(exception_header->terminateHandler);\x0a"
"        }\x0a"
"    }\x0a"
"    __terminate(get_terminate());\x0a"
"}\x0a"
"\x0a"
"extern \x22""C\x22 {\x0a"
"new_handler __cxa_new_handler = 0;\x0a"
"}\x0a"
"\x0a"
"new_handler\x0a"
"set_new_handler(new_handler handler) _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_atomic_exchange(\x26__cxa_new_handler, handler, _AO_Acq_Rel);\x0a"
"}\x0a"
"\x0a"
"new_handler\x0a"
"get_new_handler() _NOEXCEPT\x0a"
"{\x0a"
"    return __libcpp_atomic_load(\x26__cxa_new_handler, _AO_Acquire);\x0a"
"}\x0a"
"\x0a"
"}  // std\x0a"
"", 2687 ); }