#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxxabi_src_cxa_thread_atexit_cpp( 
"//===----------------------- cxa_thread_atexit.cpp ------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22""abort_message.h\x22\x0a"
"#include \x22""cxxabi.h\x22\x0a"
"#include <__threading_support>\x0a"
"#include <cstdlib>\x0a"
"\x0a"
"namespace __cxxabiv1 {\x0a"
"\x0a"
"  using Dtor = void(*)(void*);\x0a"
"\x0a"
"  extern \x22""C\x22\x0a"
"#ifndef HAVE___CXA_THREAD_ATEXIT_IMPL\x0a"
"  // A weak symbol is used to detect this function's presence in the C library\x0a"
"  // at runtime, even if libc++ is built against an older libc\x0a"
"  _LIBCXXABI_WEAK\x0a"
"#endif\x0a"
"  int __cxa_thread_atexit_impl(Dtor, void*, void*);\x0a"
"\x0a"
"#ifndef HAVE___CXA_THREAD_ATEXIT_IMPL\x0a"
"\x0a"
"namespace {\x0a"
"  // This implementation is used if the C library does not provide\x0a"
"  // __cxa_thread_atexit_impl() for us.  It has a number of limitations that are\x0a"
"  // difficult to impossible to address without ..._impl()\x3a\x0a"
"  //\x0a"
"  // - dso_symbol is ignored.  This means that a shared library may be unloaded\x0a"
"  //   (via dlclose()) before its thread_local destructors have run.\x0a"
"  //\x0a"
"  // - thread_local destructors for the main thread are run by the destructor of\x0a"
"  //   a static object.  This is later than expected; they should run before the\x0a"
"  //   destructors of any objects with static storage duration.\x0a"
"  //\x0a"
"  // - thread_local destructors on non-main threads run on the first iteration\x0a"
"  //   through the __libccpp_tls_key destructors.\x0a"
"  //   std\x3a\x3anotify_all_at_thread_exit() and similar functions must be careful to\x0a"
"  //   wait until the second iteration to provide their intended ordering\x0a"
"  //   guarantees.\x0a"
"  //\x0a"
"  // Another limitation, though one shared with ..._impl(), is that any\x0a"
"  // thread_locals that are first initialized after non-thread_local global\x0a"
"  // destructors begin to run will not be destroyed.  \x5b""basic.start.term\x5d states\x0a"
"  // that all thread_local destructors are sequenced before the destruction of\x0a"
"  // objects with static storage duration, resulting in a contradiction if a\x0a"
"  // thread_local is constructed after that point.  Thus we consider such\x0a"
"  // programs ill-formed, and don't bother to run those destructors.  (If the\x0a"
"  // program terminates abnormally after such a thread_local is constructed,\x0a"
"  // the destructor is not expected to run and thus there is no contradiction.\x0a"
"  // So construction still has to work.)\x0a"
"\x0a"
"  struct DtorList {\x0a"
"    Dtor dtor;\x0a"
"    void* obj;\x0a"
"    DtorList* next;\x0a"
"  };\x0a"
"\x0a"
"  // The linked list of thread-local destructors to run\x0a"
"  __thread DtorList* dtors = nullptr;\x0a"
"  // True if the destructors are currently scheduled to run on this thread\x0a"
"  __thread bool dtors_alive = false;\x0a"
"  // Used to trigger destructors on thread exit; value is ignored\x0a"
"  std\x3a\x3a__libcpp_tls_key dtors_key;\x0a"
"\x0a"
"  void run_dtors(void*) {\x0a"
"    while (auto head = dtors) {\x0a"
"      dtors = head->next;\x0a"
"      head->dtor(head->obj);\x0a"
"      std\x3a\x3a""free(head);\x0a"
"    }\x0a"
"\x0a"
"    dtors_alive = false;\x0a"
"  }\x0a"
"\x0a"
"  struct DtorsManager {\x0a"
"    DtorsManager() {\x0a"
"      // There is intentionally no matching std\x3a\x3a__libcpp_tls_delete call, as\x0a"
"      // __cxa_thread_atexit() may be called arbitrarily late (for example, from\x0a"
"      // global destructors or atexit() handlers).\x0a"
"      if (std\x3a\x3a__libcpp_tls_create(\x26""dtors_key, run_dtors) \x21= 0) {\x0a"
"        abort_message(\x22std\x3a\x3a__libcpp_tls_create() failed in __cxa_thread_atexit()\x22);\x0a"
"      }\x0a"
"    }\x0a"
"\x0a"
"    \x7e""DtorsManager() {\x0a"
"      // std\x3a\x3a__libcpp_tls_key destructors do not run on threads that call exit()\x0a"
"      // (including when the main thread returns from main()), so we explicitly\x0a"
"      // call the destructor here.  This runs at exit time (potentially earlier\x0a"
"      // if libc++abi is dlclose()'d).  Any thread_locals initialized after this\x0a"
"      // point will not be destroyed.\x0a"
"      run_dtors(nullptr);\x0a"
"    }\x0a"
"  };\x0a"
"} // namespace\x0a"
"\x0a"
"#endif // HAVE___CXA_THREAD_ATEXIT_IMPL\x0a"
"\x0a"
"extern \x22""C\x22 {\x0a"
"\x0a"
"  _LIBCXXABI_FUNC_VIS int __cxa_thread_atexit(Dtor dtor, void* obj, void* dso_symbol) throw() {\x0a"
"#ifdef HAVE___CXA_THREAD_ATEXIT_IMPL\x0a"
"    return __cxa_thread_atexit_impl(dtor, obj, dso_symbol);\x0a"
"#else\x0a"
"    if (__cxa_thread_atexit_impl) {\x0a"
"      return __cxa_thread_atexit_impl(dtor, obj, dso_symbol);\x0a"
"    } else {\x0a"
"      // Initialize the dtors std\x3a\x3a__libcpp_tls_key (uses __cxa_guard_*() for\x0a"
"      // one-time initialization and __cxa_atexit() for destruction)\x0a"
"      static DtorsManager manager;\x0a"
"\x0a"
"      if (\x21""dtors_alive) {\x0a"
"        if (std\x3a\x3a__libcpp_tls_set(dtors_key, \x26""dtors_key) \x21= 0) {\x0a"
"          return -1;\x0a"
"        }\x0a"
"        dtors_alive = true;\x0a"
"      }\x0a"
"\x0a"
"      auto head = static_cast<DtorList*>(std\x3a\x3amalloc(sizeof(DtorList)));\x0a"
"      if (\x21head) {\x0a"
"        return -1;\x0a"
"      }\x0a"
"\x0a"
"      head->dtor = dtor;\x0a"
"      head->obj = obj;\x0a"
"      head->next = dtors;\x0a"
"      dtors = head;\x0a"
"\x0a"
"      return 0;\x0a"
"    }\x0a"
"#endif // HAVE___CXA_THREAD_ATEXIT_IMPL\x0a"
"  }\x0a"
"\x0a"
"} // extern \x22""C\x22\x0a"
"} // namespace __cxxabiv1\x0a"
"", 4918 ); }