#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxxabi_src_cxa_vector_cpp( 
"//===-------------------------- cxa_vector.cpp ---------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//  \x0a"
"//  This file implements the \x22""Array Construction and Destruction APIs\x22\x0a"
"//  http\x3a//mentorembedded.github.io/cxx-abi/abi.html#array-ctor\x0a"
"//  \x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22""cxxabi.h\x22\x0a"
"\x0a"
"#include <exception>        // for std\x3a\x3aterminate\x0a"
"\x0a"
"namespace __cxxabiv1 {\x0a"
"\x0a"
"#if 0\x0a"
"#pragma mark --Helper routines and classes --\x0a"
"#endif\x0a"
"\x0a"
"namespace {\x0a"
"    inline static size_t __get_element_count ( void *p ) {\x0a"
"        return static_cast <size_t *> (p)\x5b-1\x5d;\x0a"
"        }\x0a"
"\x0a"
"    inline static void __set_element_count ( void *p, size_t element_count ) {\x0a"
"        static_cast <size_t *> (p)\x5b-1\x5d = element_count;\x0a"
"        }\x0a"
"\x0a"
"\x0a"
"//  A pair of classes to simplify exception handling and control flow.\x0a"
"//  They get passed a block of memory in the constructor, and unless the\x0a"
"//  'release' method is called, they deallocate the memory in the destructor.\x0a"
"//  Preferred usage is to allocate some memory, attach it to one of these objects,\x0a"
"//  and then, when all the operations to set up the memory block have succeeded,\x0a"
"//  call 'release'. If any of the setup operations fail, or an exception is\x0a"
"//  thrown, then the block is automatically deallocated.\x0a"
"//\x0a"
"//  The only difference between these two classes is the signature for the\x0a"
"//  deallocation function (to match new2/new3 and delete2/delete3.\x0a"
"    class st_heap_block2 {\x0a"
"    public\x3a\x0a"
"        typedef void (*dealloc_f)(void *);\x0a"
"        \x0a"
"        st_heap_block2 ( dealloc_f dealloc, void *ptr ) \x0a"
"            \x3a dealloc_ ( dealloc ), ptr_ ( ptr ), enabled_ ( true ) {}\x0a"
"        \x7est_heap_block2 () { if ( enabled_ ) dealloc_ ( ptr_ ) ; }\x0a"
"        void release () { enabled_ = false; }\x0a"
"    \x0a"
"    private\x3a\x0a"
"        dealloc_f dealloc_;\x0a"
"        void *ptr_;\x0a"
"        bool enabled_;\x0a"
"    };\x0a"
"    \x0a"
"    class st_heap_block3 {\x0a"
"    public\x3a\x0a"
"        typedef void (*dealloc_f)(void *, size_t);\x0a"
"        \x0a"
"        st_heap_block3 ( dealloc_f dealloc, void *ptr, size_t size ) \x0a"
"            \x3a dealloc_ ( dealloc ), ptr_ ( ptr ), size_ ( size ), enabled_ ( true ) {}\x0a"
"        \x7est_heap_block3 () { if ( enabled_ ) dealloc_ ( ptr_, size_ ) ; }\x0a"
"        void release () { enabled_ = false; }\x0a"
"    \x0a"
"    private\x3a\x0a"
"        dealloc_f dealloc_;\x0a"
"        void *ptr_;\x0a"
"        size_t size_;\x0a"
"        bool enabled_;\x0a"
"    };\x0a"
"\x0a"
"    class st_cxa_cleanup {\x0a"
"    public\x3a\x0a"
"        typedef void (*destruct_f)(void *);\x0a"
"        \x0a"
"        st_cxa_cleanup ( void *ptr, size_t \x26idx, size_t element_size, destruct_f destructor )\x0a"
"            \x3a ptr_ ( ptr ), idx_ ( idx ), element_size_ ( element_size ), \x0a"
"                destructor_ ( destructor ), enabled_ ( true ) {}\x0a"
"        \x7est_cxa_cleanup () {\x0a"
"            if ( enabled_ ) \x0a"
"                __cxa_vec_cleanup ( ptr_, idx_, element_size_, destructor_ );\x0a"
"            }\x0a"
"        \x0a"
"        void release () { enabled_ = false; }\x0a"
"    \x0a"
"    private\x3a\x0a"
"        void *ptr_;\x0a"
"        size_t \x26idx_;\x0a"
"        size_t element_size_;\x0a"
"        destruct_f destructor_;\x0a"
"        bool enabled_;\x0a"
"    };\x0a"
"    \x0a"
"    class st_terminate {\x0a"
"    public\x3a\x0a"
"        st_terminate ( bool enabled = true ) \x3a enabled_ ( enabled ) {}\x0a"
"        \x7est_terminate () { if ( enabled_ ) std\x3a\x3aterminate (); }\x0a"
"        void release () { enabled_ = false; }\x0a"
"    private\x3a\x0a"
"        bool enabled_ ;\x0a"
"    };\x0a"
"}\x0a"
"\x0a"
"#if 0\x0a"
"#pragma mark --Externally visible routines--\x0a"
"#endif\x0a"
"\x0a"
"extern \x22""C\x22 {\x0a"
"\x0a"
"// Equivalent to\x0a"
"// \x0a"
"//   __cxa_vec_new2(element_count, element_size, padding_size, constructor,\x0a"
"//                  destructor, \x26\x3a\x3aoperator new\x5b\x5d, \x26\x3a\x3aoperator delete\x5b\x5d)\x0a"
"_LIBCXXABI_FUNC_VIS void *\x0a"
"__cxa_vec_new(size_t element_count, size_t element_size, size_t padding_size,\x0a"
"              void (*constructor)(void *), void (*destructor)(void *)) {\x0a"
"    return __cxa_vec_new2 ( element_count, element_size, padding_size, \x0a"
"        constructor, destructor, \x26\x3a\x3aoperator new \x5b\x5d, \x26\x3a\x3aoperator delete \x5b\x5d );\x0a"
"}\x0a"
"\x0a"
"\x0a"
"\x0a"
"// Given the number and size of elements for an array and the non-negative\x0a"
"// size of prefix padding for a cookie, allocate space (using alloc) for\x0a"
"// the array preceded by the specified padding, initialize the cookie if\x0a"
"// the padding is non-zero, and call the given constructor on each element.\x0a"
"// Return the address of the array proper, after the padding.\x0a"
"// \x0a"
"// If alloc throws an exception, rethrow the exception. If alloc returns\x0a"
"// NULL, return NULL. If the constructor throws an exception, call\x0a"
"// destructor for any already constructed elements, and rethrow the\x0a"
"// exception. If the destructor throws an exception, call std\x3a\x3aterminate.\x0a"
"// \x0a"
"// The constructor may be NULL, in which case it must not be called. If the\x0a"
"// padding_size is zero, the destructor may be NULL; in that case it must\x0a"
"// not be called.\x0a"
"// \x0a"
"// Neither alloc nor dealloc may be NULL.\x0a"
"_LIBCXXABI_FUNC_VIS void *\x0a"
"__cxa_vec_new2(size_t element_count, size_t element_size, size_t padding_size,\x0a"
"               void (*constructor)(void *), void (*destructor)(void *),\x0a"
"               void *(*alloc)(size_t), void (*dealloc)(void *)) {\x0a"
"    const size_t heap_size = element_count * element_size + padding_size;\x0a"
"    char * const heap_block = static_cast<char *> ( alloc ( heap_size ));\x0a"
"    char *vec_base = heap_block;\x0a"
"    \x0a"
"    if ( NULL \x21= vec_base ) {\x0a"
"        st_heap_block2 heap ( dealloc, heap_block );\x0a"
"\x0a"
"    //  put the padding before the array elements\x0a"
"        if ( 0 \x21= padding_size ) {\x0a"
"            vec_base += padding_size;\x0a"
"            __set_element_count ( vec_base, element_count );\x0a"
"        }\x0a"
"            \x0a"
"    //  Construct the elements\x0a"
"        __cxa_vec_ctor ( vec_base, element_count, element_size, constructor, destructor );\x0a"
"        heap.release ();    // We're good\x21\x0a"
"    }\x0a"
"    \x0a"
"    return vec_base;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// Same as __cxa_vec_new2 except that the deallocation function takes both\x0a"
"// the object address and its size.\x0a"
"_LIBCXXABI_FUNC_VIS void *\x0a"
"__cxa_vec_new3(size_t element_count, size_t element_size, size_t padding_size,\x0a"
"               void (*constructor)(void *), void (*destructor)(void *),\x0a"
"               void *(*alloc)(size_t), void (*dealloc)(void *, size_t)) {\x0a"
"    const size_t heap_size = element_count * element_size + padding_size;\x0a"
"    char * const heap_block = static_cast<char *> ( alloc ( heap_size ));\x0a"
"    char *vec_base = heap_block;\x0a"
"    \x0a"
"    if ( NULL \x21= vec_base ) {\x0a"
"        st_heap_block3 heap ( dealloc, heap_block, heap_size );\x0a"
"\x0a"
"    //  put the padding before the array elements\x0a"
"        if ( 0 \x21= padding_size ) {\x0a"
"            vec_base += padding_size;\x0a"
"            __set_element_count ( vec_base, element_count );\x0a"
"        }\x0a"
"            \x0a"
"    //  Construct the elements\x0a"
"        __cxa_vec_ctor ( vec_base, element_count, element_size, constructor, destructor );\x0a"
"        heap.release ();    // We're good\x21\x0a"
"    }\x0a"
"    \x0a"
"    return vec_base;\x0a"
"}\x0a"
" \x0a"
" \x0a"
"// Given the (data) addresses of a destination and a source array, an\x0a"
"// element count and an element size, call the given copy constructor to\x0a"
"// copy each element from the source array to the destination array. The\x0a"
"// copy constructor's arguments are the destination address and source\x0a"
"// address, respectively. If an exception occurs, call the given destructor\x0a"
"// (if non-NULL) on each copied element and rethrow. If the destructor\x0a"
"// throws an exception, call terminate(). The constructor and or destructor\x0a"
"// pointers may be NULL. If either is NULL, no action is taken when it\x0a"
"// would have been called.\x0a"
"\x0a"
"_LIBCXXABI_FUNC_VIS void __cxa_vec_cctor(void *dest_array, void *src_array,\x0a"
"                                         size_t element_count,\x0a"
"                                         size_t element_size,\x0a"
"                                         void (*constructor)(void *, void *),\x0a"
"                                         void (*destructor)(void *)) {\x0a"
"    if ( NULL \x21= constructor ) {\x0a"
"        size_t idx = 0;\x0a"
"        char *src_ptr  = static_cast<char *>(src_array);\x0a"
"        char *dest_ptr = static_cast<char *>(dest_array);\x0a"
"        st_cxa_cleanup cleanup ( dest_array, idx, element_size, destructor );        \x0a"
"\x0a"
"        for ( idx = 0; idx < element_count; \x0a"
"                    ++idx, src_ptr += element_size, dest_ptr += element_size )\x0a"
"            constructor ( dest_ptr, src_ptr );\x0a"
"        cleanup.release ();     // We're good\x21\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// Given the (data) address of an array, not including any cookie padding,\x0a"
"// and the number and size of its elements, call the given constructor on\x0a"
"// each element. If the constructor throws an exception, call the given\x0a"
"// destructor for any already-constructed elements, and rethrow the\x0a"
"// exception. If the destructor throws an exception, call terminate(). The\x0a"
"// constructor and/or destructor pointers may be NULL. If either is NULL,\x0a"
"// no action is taken when it would have been called.\x0a"
"_LIBCXXABI_FUNC_VIS void\x0a"
"__cxa_vec_ctor(void *array_address, size_t element_count, size_t element_size,\x0a"
"               void (*constructor)(void *), void (*destructor)(void *)) {\x0a"
"    if ( NULL \x21= constructor ) {\x0a"
"        size_t idx;\x0a"
"        char *ptr = static_cast <char *> ( array_address );\x0a"
"        st_cxa_cleanup cleanup ( array_address, idx, element_size, destructor );        \x0a"
"        \x0a"
"    //  Construct the elements\x0a"
"        for ( idx = 0; idx < element_count; ++idx, ptr += element_size )\x0a"
"            constructor ( ptr );\x0a"
"        cleanup.release ();     // We're good\x21\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Given the (data) address of an array, the number of elements, and the\x0a"
"// size of its elements, call the given destructor on each element. If the\x0a"
"// destructor throws an exception, rethrow after destroying the remaining\x0a"
"// elements if possible. If the destructor throws a second exception, call\x0a"
"// terminate(). The destructor pointer may be NULL, in which case this\x0a"
"// routine does nothing.\x0a"
"_LIBCXXABI_FUNC_VIS void __cxa_vec_dtor(void *array_address,\x0a"
"                                        size_t element_count,\x0a"
"                                        size_t element_size,\x0a"
"                                        void (*destructor)(void *)) {\x0a"
"    if ( NULL \x21= destructor ) {\x0a"
"        char *ptr = static_cast <char *> (array_address);\x0a"
"        size_t idx = element_count;\x0a"
"        st_cxa_cleanup cleanup ( array_address, idx, element_size, destructor );        \x0a"
"        {\x0a"
"            st_terminate exception_guard (__cxa_uncaught_exception ());\x0a"
"            ptr +=  element_count * element_size;   // one past the last element\x0a"
"\x0a"
"            while ( idx-- > 0 ) {\x0a"
"                ptr -= element_size;\x0a"
"                destructor ( ptr );\x0a"
"            }\x0a"
"            exception_guard.release (); //  We're good \x21\x0a"
"        }\x0a"
"        cleanup.release ();     // We're still good\x21\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Given the (data) address of an array, the number of elements, and the\x0a"
"// size of its elements, call the given destructor on each element. If the\x0a"
"// destructor throws an exception, call terminate(). The destructor pointer\x0a"
"// may be NULL, in which case this routine does nothing.\x0a"
"_LIBCXXABI_FUNC_VIS void __cxa_vec_cleanup(void *array_address,\x0a"
"                                           size_t element_count,\x0a"
"                                           size_t element_size,\x0a"
"                                           void (*destructor)(void *)) {\x0a"
"    if ( NULL \x21= destructor ) {\x0a"
"        char *ptr = static_cast <char *> (array_address);\x0a"
"        size_t idx = element_count;\x0a"
"        st_terminate exception_guard;\x0a"
"        \x0a"
"        ptr += element_count * element_size;    // one past the last element\x0a"
"        while ( idx-- > 0 ) {\x0a"
"            ptr -= element_size;\x0a"
"            destructor ( ptr );\x0a"
"            }\x0a"
"        exception_guard.release ();     // We're done\x21\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// If the array_address is NULL, return immediately. Otherwise, given the\x0a"
"// (data) address of an array, the non-negative size of prefix padding for\x0a"
"// the cookie, and the size of its elements, call the given destructor on\x0a"
"// each element, using the cookie to determine the number of elements, and\x0a"
"// then delete the space by calling \x3a\x3aoperator delete\x5b\x5d(void *). If the\x0a"
"// destructor throws an exception, rethrow after (a) destroying the\x0a"
"// remaining elements, and (b) deallocating the storage. If the destructor\x0a"
"// throws a second exception, call terminate(). If padding_size is 0, the\x0a"
"// destructor pointer must be NULL. If the destructor pointer is NULL, no\x0a"
"// destructor call is to be made.\x0a"
"// \x0a"
"// The intent of this function is to permit an implementation to call this\x0a"
"// function when confronted with an expression of the form delete\x5b\x5d p in\x0a"
"// the source code, provided that the default deallocation function can be\x0a"
"// used. Therefore, the semantics of this function are consistent with\x0a"
"// those required by the standard. The requirement that the deallocation\x0a"
"// function be called even if the destructor throws an exception derives\x0a"
"// from the resolution to DR 353 to the C++ standard, which was adopted in\x0a"
"// April, 2003.\x0a"
"_LIBCXXABI_FUNC_VIS void __cxa_vec_delete(void *array_address,\x0a"
"                                          size_t element_size,\x0a"
"                                          size_t padding_size,\x0a"
"                                          void (*destructor)(void *)) {\x0a"
"    __cxa_vec_delete2 ( array_address, element_size, padding_size,\x0a"
"               destructor, \x26\x3a\x3aoperator delete \x5b\x5d );\x0a"
"}\x0a"
"\x0a"
"// Same as __cxa_vec_delete, except that the given function is used for\x0a"
"// deallocation instead of the default delete function. If dealloc throws\x0a"
"// an exception, the result is undefined. The dealloc pointer may not be\x0a"
"// NULL.\x0a"
"_LIBCXXABI_FUNC_VIS void\x0a"
"__cxa_vec_delete2(void *array_address, size_t element_size, size_t padding_size,\x0a"
"                  void (*destructor)(void *), void (*dealloc)(void *)) {\x0a"
"    if ( NULL \x21= array_address ) {\x0a"
"        char *vec_base   = static_cast <char *> (array_address);\x0a"
"        char *heap_block = vec_base - padding_size;\x0a"
"        st_heap_block2 heap ( dealloc, heap_block );\x0a"
"        \x0a"
"        if ( 0 \x21= padding_size \x26\x26 NULL \x21= destructor ) // call the destructors\x0a"
"            __cxa_vec_dtor ( array_address, __get_element_count ( vec_base ), \x0a"
"                                    element_size, destructor );\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// Same as __cxa_vec_delete, except that the given function is used for\x0a"
"// deallocation instead of the default delete function. The deallocation\x0a"
"// function takes both the object address and its size. If dealloc throws\x0a"
"// an exception, the result is undefined. The dealloc pointer may not be\x0a"
"// NULL.\x0a"
"_LIBCXXABI_FUNC_VIS void\x0a"
"__cxa_vec_delete3(void *array_address, size_t element_size, size_t padding_size,\x0a"
"                  void (*destructor)(void *), void (*dealloc)(void *, size_t)) {\x0a"
"    if ( NULL \x21= array_address ) {\x0a"
"        char *vec_base   = static_cast <char *> (array_address);\x0a"
"        char *heap_block = vec_base - padding_size;\x0a"
"        const size_t element_count = padding_size \x3f __get_element_count ( vec_base ) \x3a 0;\x0a"
"        const size_t heap_block_size = element_size * element_count + padding_size;\x0a"
"        st_heap_block3 heap ( dealloc, heap_block, heap_block_size );\x0a"
"\x0a"
"        if ( 0 \x21= padding_size \x26\x26 NULL \x21= destructor ) // call the destructors\x0a"
"            __cxa_vec_dtor ( array_address, element_count, element_size, destructor );\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"\x0a"
"}  // extern \x22""C\x22\x0a"
"\x0a"
"}  // abi\x0a"
"", 15215 ); }