#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxxabi_src_fallback_malloc_cpp( 
"//===------------------------ fallback_malloc.cpp -------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"// Define _LIBCPP_BUILDING_LIBRARY to ensure _LIBCPP_HAS_NO_LIBRARY_ALIGNED_ALLOCATION\x0a"
"// is only defined when libc aligned allocation is not available.\x0a"
"#define _LIBCPP_BUILDING_LIBRARY\x0a"
"#include \x22""fallback_malloc.h\x22\x0a"
"\x0a"
"#include <__threading_support>\x0a"
"\x0a"
"#include <cstdlib> // for malloc, calloc, free\x0a"
"#include <cstring> // for memset\x0a"
"\x0a"
"//  A small, simple heap manager based (loosely) on\x0a"
"//  the startup heap manager from FreeBSD, optimized for space.\x0a"
"//\x0a"
"//  Manages a fixed-size memory pool, supports malloc and free only.\x0a"
"//  No support for realloc.\x0a"
"//\x0a"
"//  Allocates chunks in multiples of four bytes, with a four byte header\x0a"
"//  for each chunk. The overhead of each chunk is kept low by keeping pointers\x0a"
"//  as two byte offsets within the heap, rather than (4 or 8 byte) pointers.\x0a"
"\x0a"
"namespace {\x0a"
"\x0a"
"// When POSIX threads are not available, make the mutex operations a nop\x0a"
"#ifndef _LIBCXXABI_HAS_NO_THREADS\x0a"
"_LIBCPP_SAFE_STATIC\x0a"
"static std\x3a\x3a__libcpp_mutex_t heap_mutex = _LIBCPP_MUTEX_INITIALIZER;\x0a"
"#else\x0a"
"static void* heap_mutex = 0;\x0a"
"#endif\x0a"
"\x0a"
"class mutexor {\x0a"
"public\x3a\x0a"
"#ifndef _LIBCXXABI_HAS_NO_THREADS\x0a"
"  mutexor(std\x3a\x3a__libcpp_mutex_t* m) \x3a mtx_(m) {\x0a"
"    std\x3a\x3a__libcpp_mutex_lock(mtx_);\x0a"
"  }\x0a"
"  \x7emutexor() { std\x3a\x3a__libcpp_mutex_unlock(mtx_); }\x0a"
"#else\x0a"
"  mutexor(void*) {}\x0a"
"  \x7emutexor() {}\x0a"
"#endif\x0a"
"private\x3a\x0a"
"  mutexor(const mutexor\x26 rhs);\x0a"
"  mutexor\x26 operator=(const mutexor\x26 rhs);\x0a"
"#ifndef _LIBCXXABI_HAS_NO_THREADS\x0a"
"  std\x3a\x3a__libcpp_mutex_t* mtx_;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"static const size_t HEAP_SIZE = 512;\x0a"
"char heap\x5bHEAP_SIZE\x5d __attribute__((aligned));\x0a"
"\x0a"
"typedef unsigned short heap_offset;\x0a"
"typedef unsigned short heap_size;\x0a"
"\x0a"
"struct heap_node {\x0a"
"  heap_offset next_node; // offset into heap\x0a"
"  heap_size len;         // size in units of \x22sizeof(heap_node)\x22\x0a"
"};\x0a"
"\x0a"
"static const heap_node* list_end =\x0a"
"    (heap_node*)(\x26heap\x5bHEAP_SIZE\x5d); // one past the end of the heap\x0a"
"static heap_node* freelist = NULL;\x0a"
"\x0a"
"heap_node* node_from_offset(const heap_offset offset) {\x0a"
"  return (heap_node*)(heap + (offset * sizeof(heap_node)));\x0a"
"}\x0a"
"\x0a"
"heap_offset offset_from_node(const heap_node* ptr) {\x0a"
"  return static_cast<heap_offset>(\x0a"
"      static_cast<size_t>(reinterpret_cast<const char*>(ptr) - heap) /\x0a"
"      sizeof(heap_node));\x0a"
"}\x0a"
"\x0a"
"void init_heap() {\x0a"
"  freelist = (heap_node*)heap;\x0a"
"  freelist->next_node = offset_from_node(list_end);\x0a"
"  freelist->len = HEAP_SIZE / sizeof(heap_node);\x0a"
"}\x0a"
"\x0a"
"//  How big a chunk we allocate\x0a"
"size_t alloc_size(size_t len) {\x0a"
"  return (len + sizeof(heap_node) - 1) / sizeof(heap_node) + 1;\x0a"
"}\x0a"
"\x0a"
"bool is_fallback_ptr(void* ptr) {\x0a"
"  return ptr >= heap \x26\x26 ptr < (heap + HEAP_SIZE);\x0a"
"}\x0a"
"\x0a"
"void* fallback_malloc(size_t len) {\x0a"
"  heap_node *p, *prev;\x0a"
"  const size_t nelems = alloc_size(len);\x0a"
"  mutexor mtx(\x26heap_mutex);\x0a"
"\x0a"
"  if (NULL == freelist)\x0a"
"    init_heap();\x0a"
"\x0a"
"  //  Walk the free list, looking for a \x22""big enough\x22 chunk\x0a"
"  for (p = freelist, prev = 0; p \x26\x26 p \x21= list_end;\x0a"
"       prev = p, p = node_from_offset(p->next_node)) {\x0a"
"\x0a"
"    if (p->len > nelems) { //  chunk is larger, shorten, and return the tail\x0a"
"      heap_node* q;\x0a"
"\x0a"
"      p->len = static_cast<heap_size>(p->len - nelems);\x0a"
"      q = p + p->len;\x0a"
"      q->next_node = 0;\x0a"
"      q->len = static_cast<heap_size>(nelems);\x0a"
"      return (void*)(q + 1);\x0a"
"    }\x0a"
"\x0a"
"    if (p->len == nelems) { // exact size match\x0a"
"      if (prev == 0)\x0a"
"        freelist = node_from_offset(p->next_node);\x0a"
"      else\x0a"
"        prev->next_node = p->next_node;\x0a"
"      p->next_node = 0;\x0a"
"      return (void*)(p + 1);\x0a"
"    }\x0a"
"  }\x0a"
"  return NULL; // couldn't find a spot big enough\x0a"
"}\x0a"
"\x0a"
"//  Return the start of the next block\x0a"
"heap_node* after(struct heap_node* p) { return p + p->len; }\x0a"
"\x0a"
"void fallback_free(void* ptr) {\x0a"
"  struct heap_node* cp = ((struct heap_node*)ptr) - 1; // retrieve the chunk\x0a"
"  struct heap_node *p, *prev;\x0a"
"\x0a"
"  mutexor mtx(\x26heap_mutex);\x0a"
"\x0a"
"#ifdef DEBUG_FALLBACK_MALLOC\x0a"
"  std\x3a\x3a""cout << \x22""Freeing item at \x22 << offset_from_node(cp) << \x22 of size \x22\x0a"
"            << cp->len << std\x3a\x3a""endl;\x0a"
"#endif\x0a"
"\x0a"
"  for (p = freelist, prev = 0; p \x26\x26 p \x21= list_end;\x0a"
"       prev = p, p = node_from_offset(p->next_node)) {\x0a"
"#ifdef DEBUG_FALLBACK_MALLOC\x0a"
"    std\x3a\x3a""cout << \x22  p, cp, after (p), after(cp) \x22 << offset_from_node(p) << ' '\x0a"
"              << offset_from_node(cp) << ' ' << offset_from_node(after(p))\x0a"
"              << ' ' << offset_from_node(after(cp)) << std\x3a\x3a""endl;\x0a"
"#endif\x0a"
"    if (after(p) == cp) {\x0a"
"#ifdef DEBUG_FALLBACK_MALLOC\x0a"
"      std\x3a\x3a""cout << \x22  Appending onto chunk at \x22 << offset_from_node(p)\x0a"
"                << std\x3a\x3a""endl;\x0a"
"#endif\x0a"
"      p->len = static_cast<heap_size>(\x0a"
"          p->len + cp->len); // make the free heap_node larger\x0a"
"      return;\x0a"
"    } else if (after(cp) == p) { // there's a free heap_node right after\x0a"
"#ifdef DEBUG_FALLBACK_MALLOC\x0a"
"      std\x3a\x3a""cout << \x22  Appending free chunk at \x22 << offset_from_node(p)\x0a"
"                << std\x3a\x3a""endl;\x0a"
"#endif\x0a"
"      cp->len = static_cast<heap_size>(cp->len + p->len);\x0a"
"      if (prev == 0) {\x0a"
"        freelist = cp;\x0a"
"        cp->next_node = p->next_node;\x0a"
"      } else\x0a"
"        prev->next_node = offset_from_node(cp);\x0a"
"      return;\x0a"
"    }\x0a"
"  }\x0a"
"//  Nothing to merge with, add it to the start of the free list\x0a"
"#ifdef DEBUG_FALLBACK_MALLOC\x0a"
"  std\x3a\x3a""cout << \x22  Making new free list entry \x22 << offset_from_node(cp)\x0a"
"            << std\x3a\x3a""endl;\x0a"
"#endif\x0a"
"  cp->next_node = offset_from_node(freelist);\x0a"
"  freelist = cp;\x0a"
"}\x0a"
"\x0a"
"#ifdef INSTRUMENT_FALLBACK_MALLOC\x0a"
"size_t print_free_list() {\x0a"
"  struct heap_node *p, *prev;\x0a"
"  heap_size total_free = 0;\x0a"
"  if (NULL == freelist)\x0a"
"    init_heap();\x0a"
"\x0a"
"  for (p = freelist, prev = 0; p \x26\x26 p \x21= list_end;\x0a"
"       prev = p, p = node_from_offset(p->next_node)) {\x0a"
"    std\x3a\x3a""cout << (prev == 0 \x3f \x22\x22 \x3a \x22  \x22) << \x22Offset\x3a \x22 << offset_from_node(p)\x0a"
"              << \x22\x5ctsize\x3a \x22 << p->len << \x22 Next\x3a \x22 << p->next_node << std\x3a\x3a""endl;\x0a"
"    total_free += p->len;\x0a"
"  }\x0a"
"  std\x3a\x3a""cout << \x22Total Free space\x3a \x22 << total_free << std\x3a\x3a""endl;\x0a"
"  return total_free;\x0a"
"}\x0a"
"#endif\x0a"
"} // end unnamed namespace\x0a"
"\x0a"
"namespace __cxxabiv1 {\x0a"
"\x0a"
"struct __attribute__((aligned)) __aligned_type {};\x0a"
"\x0a"
"void* __aligned_malloc_with_fallback(size_t size) {\x0a"
"#if defined(_WIN32)\x0a"
"  if (void* dest = _aligned_malloc(size, alignof(__aligned_type)))\x0a"
"    return dest;\x0a"
"#elif defined(_LIBCPP_HAS_NO_LIBRARY_ALIGNED_ALLOCATION)\x0a"
"  if (void* dest = std\x3a\x3amalloc(size))\x0a"
"    return dest;\x0a"
"#else\x0a"
"  if (size == 0)\x0a"
"    size = 1;\x0a"
"  void* dest;\x0a"
"  if (\x3a\x3aposix_memalign(\x26""dest, __alignof(__aligned_type), size) == 0)\x0a"
"    return dest;\x0a"
"#endif\x0a"
"  return fallback_malloc(size);\x0a"
"}\x0a"
"\x0a"
"void* __calloc_with_fallback(size_t count, size_t size) {\x0a"
"  void* ptr = std\x3a\x3a""calloc(count, size);\x0a"
"  if (NULL \x21= ptr)\x0a"
"    return ptr;\x0a"
"  // if calloc fails, fall back to emergency stash\x0a"
"  ptr = fallback_malloc(size * count);\x0a"
"  if (NULL \x21= ptr)\x0a"
"    std\x3a\x3amemset(ptr, 0, size * count);\x0a"
"  return ptr;\x0a"
"}\x0a"
"\x0a"
"void __aligned_free_with_fallback(void* ptr) {\x0a"
"  if (is_fallback_ptr(ptr))\x0a"
"    fallback_free(ptr);\x0a"
"  else {\x0a"
"#if defined(_WIN32)\x0a"
"    \x3a\x3a_aligned_free(ptr);\x0a"
"#else\x0a"
"    std\x3a\x3a""free(ptr);\x0a"
"#endif\x0a"
"  }\x0a"
"}\x0a"
"\x0a"
"void __free_with_fallback(void* ptr) {\x0a"
"  if (is_fallback_ptr(ptr))\x0a"
"    fallback_free(ptr);\x0a"
"  else\x0a"
"    std\x3a\x3a""free(ptr);\x0a"
"}\x0a"
"\x0a"
"} // namespace __cxxabiv1\x0a"
"", 7304 ); }