#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxxabi_src_private_typeinfo_cpp( 
"//===----------------------- private_typeinfo.cpp -------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#include \x22private_typeinfo.h\x22\x0a"
"\x0a"
"// The flag _LIBCXX_DYNAMIC_FALLBACK is used to make dynamic_cast more\x0a"
"// forgiving when type_info's mistakenly have hidden visibility and thus\x0a"
"// multiple type_infos can exist for a single type.\x0a"
"// \x0a"
"// When _LIBCXX_DYNAMIC_FALLBACK is defined, and only in the case where\x0a"
"// there is a detected inconsistency in the type_info hierarchy during a\x0a"
"// dynamic_cast, then the equality operation will fall back to using strcmp\x0a"
"// on type_info names to determine type_info equality.\x0a"
"// \x0a"
"// This change happens *only* under dynamic_cast, and only when\x0a"
"// dynamic_cast is faced with the choice\x3a  abort, or possibly give back the\x0a"
"// wrong answer.  If when the dynamic_cast is done with this fallback\x0a"
"// algorithm and an inconsistency is still detected, dynamic_cast will call\x0a"
"// abort with an appropriate message.\x0a"
"// \x0a"
"// The current implementation of _LIBCXX_DYNAMIC_FALLBACK requires a\x0a"
"// printf-like function called syslog\x3a\x0a"
"// \x0a"
"//     void syslog(int facility_priority, const char* format, ...);\x0a"
"// \x0a"
"// If you want this functionality but your platform doesn't have syslog,\x0a"
"// just implement it in terms of fprintf(stderr, ...).\x0a"
"// \x0a"
"// _LIBCXX_DYNAMIC_FALLBACK is currently off by default.\x0a"
"\x0a"
"\x0a"
"#include <string.h>\x0a"
"\x0a"
"\x0a"
"#ifdef _LIBCXX_DYNAMIC_FALLBACK\x0a"
"#include \x22""abort_message.h\x22\x0a"
"#include <sys/syslog.h>\x0a"
"#endif\x0a"
"\x0a"
"// On Windows, typeids are different between DLLs and EXEs, so comparing\x0a"
"// type_info* will work for typeids from the same compiled file but fail\x0a"
"// for typeids from a DLL and an executable. Among other things, exceptions\x0a"
"// are not caught by handlers since can_catch() returns false.\x0a"
"//\x0a"
"// Defining _LIBCXX_DYNAMIC_FALLBACK does not help since can_catch() calls \x0a"
"// is_equal() with use_strcmp=false so the string names are not compared.\x0a"
"\x0a"
"#ifdef _WIN32\x0a"
"#include <string.h>\x0a"
"#endif\x0a"
"\x0a"
"static inline\x0a"
"bool\x0a"
"is_equal(const std\x3a\x3atype_info* x, const std\x3a\x3atype_info* y, bool use_strcmp)\x0a"
"{\x0a"
"#ifndef _WIN32\x0a"
"    if (\x21use_strcmp)\x0a"
"        return x == y;\x0a"
"    return strcmp(x->name(), y->name()) == 0;\x0a"
"#else\x0a"
"    (void) use_strcmp;\x0a"
"    return (x == y) \x7c\x7c (strcmp(x->name(), y->name()) == 0);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"namespace __cxxabiv1\x0a"
"{\x0a"
"\x0a"
"// __shim_type_info\x0a"
"\x0a"
"__shim_type_info\x3a\x3a\x7e__shim_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"void __shim_type_info\x3a\x3anoop1() const {}\x0a"
"void __shim_type_info\x3a\x3anoop2() const {}\x0a"
"\x0a"
"// __fundamental_type_info\x0a"
"\x0a"
"// This miraculously (compiler magic) emits the type_info's for\x3a\x0a"
"//   1. all of the fundamental types\x0a"
"//   2. pointers to all of the fundamental types\x0a"
"//   3. pointers to all of the const fundamental types\x0a"
"__fundamental_type_info\x3a\x3a\x7e__fundamental_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __array_type_info\x0a"
"\x0a"
"__array_type_info\x3a\x3a\x7e__array_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __function_type_info\x0a"
"\x0a"
"__function_type_info\x3a\x3a\x7e__function_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __enum_type_info\x0a"
"\x0a"
"__enum_type_info\x3a\x3a\x7e__enum_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __class_type_info\x0a"
"\x0a"
"__class_type_info\x3a\x3a\x7e__class_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __si_class_type_info\x0a"
"\x0a"
"__si_class_type_info\x3a\x3a\x7e__si_class_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __vmi_class_type_info\x0a"
"\x0a"
"__vmi_class_type_info\x3a\x3a\x7e__vmi_class_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __pbase_type_info\x0a"
"\x0a"
"__pbase_type_info\x3a\x3a\x7e__pbase_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __pointer_type_info\x0a"
"\x0a"
"__pointer_type_info\x3a\x3a\x7e__pointer_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __pointer_to_member_type_info\x0a"
"\x0a"
"__pointer_to_member_type_info\x3a\x3a\x7e__pointer_to_member_type_info()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// can_catch\x0a"
"\x0a"
"// A handler is a match for an exception object of type E if\x0a"
"//   1. The handler is of type cv T or cv T\x26 and E and T are the same type\x0a"
"//      (ignoring the top-level cv-qualifiers), or\x0a"
"//   2. the handler is of type cv T or cv T\x26 and T is an unambiguous public\x0a"
"//       base class of E, or\x0a"
"//   3. the handler is of type cv1 T* cv2 and E is a pointer type that can be\x0a"
"//      converted to the type of the handler by either or both of\x0a"
"//      A. a standard pointer conversion (4.10) not involving conversions to\x0a"
"//         pointers to private or protected or ambiguous classes\x0a"
"//      B. a qualification conversion\x0a"
"//   4. the handler is a pointer or pointer to member type and E is\x0a"
"//      std\x3a\x3anullptr_t.\x0a"
"\x0a"
"// adjustedPtr\x3a\x0a"
"// \x0a"
"// catch (A\x26 a) \x3a adjustedPtr == \x26""a\x0a"
"// catch (A* a) \x3a adjustedPtr == a\x0a"
"// catch (A** a) \x3a adjustedPtr == a\x0a"
"// \x0a"
"// catch (D2\x26 d2) \x3a adjustedPtr == \x26""d2  (d2 is base class of thrown object)\x0a"
"// catch (D2* d2) \x3a adjustedPtr == d2\x0a"
"// catch (D2*\x26 d2) \x3a adjustedPtr == d2\x0a"
"//\x0a"
"// catch (...) \x3a adjustedPtr == \x26 of the exception\x0a"
"//\x0a"
"// If the thrown type is nullptr_t and the caught type is a pointer to\x0a"
"// member type, adjustedPtr points to a statically-allocated null pointer\x0a"
"// representation of that type.\x0a"
"\x0a"
"// Handles bullet 1\x0a"
"bool\x0a"
"__fundamental_type_info\x3a\x3a""can_catch(const __shim_type_info* thrown_type,\x0a"
"                                   void*\x26) const\x0a"
"{\x0a"
"    return is_equal(this, thrown_type, false);\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__array_type_info\x3a\x3a""can_catch(const __shim_type_info*, void*\x26) const\x0a"
"{\x0a"
"    // We can get here if someone tries to catch an array by reference.\x0a"
"    //   However if someone tries to throw an array, it immediately gets\x0a"
"    //   converted to a pointer, which will not convert back to an array\x0a"
"    //   at the catch clause.  So this can never catch anything.\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__function_type_info\x3a\x3a""can_catch(const __shim_type_info*, void*\x26) const\x0a"
"{\x0a"
"    // We can get here if someone tries to catch a function by reference.\x0a"
"    //   However if someone tries to throw a function, it immediately gets\x0a"
"    //   converted to a pointer, which will not convert back to a function\x0a"
"    //   at the catch clause.  So this can never catch anything.\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"// Handles bullet 1\x0a"
"bool\x0a"
"__enum_type_info\x3a\x3a""can_catch(const __shim_type_info* thrown_type,\x0a"
"                            void*\x26) const\x0a"
"{\x0a"
"    return is_equal(this, thrown_type, false);\x0a"
"}\x0a"
"\x0a"
"#ifdef __clang__\x0a"
"#pragma clang diagnostic push\x0a"
"#pragma clang diagnostic ignored \x22-Wmissing-field-initializers\x22\x0a"
"#endif\x0a"
"\x0a"
"// Handles bullets 1 and 2\x0a"
"bool\x0a"
"__class_type_info\x3a\x3a""can_catch(const __shim_type_info* thrown_type,\x0a"
"                             void*\x26 adjustedPtr) const\x0a"
"{\x0a"
"    // bullet 1\x0a"
"    if (is_equal(this, thrown_type, false))\x0a"
"        return true;\x0a"
"    const __class_type_info* thrown_class_type =\x0a"
"        dynamic_cast<const __class_type_info*>(thrown_type);\x0a"
"    if (thrown_class_type == 0)\x0a"
"        return false;\x0a"
"    // bullet 2\x0a"
"    __dynamic_cast_info info = {thrown_class_type, 0, this, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,};\x0a"
"    info.number_of_dst_type = 1;\x0a"
"    thrown_class_type->has_unambiguous_public_base(\x26info, adjustedPtr, public_path);\x0a"
"    if (info.path_dst_ptr_to_static_ptr == public_path)\x0a"
"    {\x0a"
"        adjustedPtr = const_cast<void*>(info.dst_ptr_leading_to_static_ptr);\x0a"
"        return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"#ifdef __clang__\x0a"
"#pragma clang diagnostic pop\x0a"
"#endif\x0a"
"\x0a"
"void\x0a"
"__class_type_info\x3a\x3aprocess_found_base_class(__dynamic_cast_info* info,\x0a"
"                                               void* adjustedPtr,\x0a"
"                                               int path_below) const\x0a"
"{\x0a"
"    if (info->dst_ptr_leading_to_static_ptr == 0)\x0a"
"    {\x0a"
"        // First time here\x0a"
"        info->dst_ptr_leading_to_static_ptr = adjustedPtr;\x0a"
"        info->path_dst_ptr_to_static_ptr = path_below;\x0a"
"        info->number_to_static_ptr = 1;\x0a"
"    }\x0a"
"    else if (info->dst_ptr_leading_to_static_ptr == adjustedPtr)\x0a"
"    {\x0a"
"        // We've been here before.  Update path to \x22most public\x22\x0a"
"        if (info->path_dst_ptr_to_static_ptr == not_public_path)\x0a"
"            info->path_dst_ptr_to_static_ptr = path_below;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        // We've detected an ambiguous cast from (thrown_class_type, adjustedPtr)\x0a"
"        //   to a static_type\x0a"
"        info->number_to_static_ptr += 1;\x0a"
"        info->path_dst_ptr_to_static_ptr = not_public_path;\x0a"
"        info->search_done = true;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__class_type_info\x3a\x3ahas_unambiguous_public_base(__dynamic_cast_info* info,\x0a"
"                                               void* adjustedPtr,\x0a"
"                                               int path_below) const\x0a"
"{\x0a"
"    if (is_equal(this, info->static_type, false))\x0a"
"        process_found_base_class(info, adjustedPtr, path_below);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__si_class_type_info\x3a\x3ahas_unambiguous_public_base(__dynamic_cast_info* info,\x0a"
"                                                  void* adjustedPtr,\x0a"
"                                                  int path_below) const\x0a"
"{\x0a"
"    if (is_equal(this, info->static_type, false))\x0a"
"        process_found_base_class(info, adjustedPtr, path_below);\x0a"
"    else\x0a"
"        __base_type->has_unambiguous_public_base(info, adjustedPtr, path_below);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__base_class_type_info\x3a\x3ahas_unambiguous_public_base(__dynamic_cast_info* info,\x0a"
"                                                    void* adjustedPtr,\x0a"
"                                                    int path_below) const\x0a"
"{\x0a"
"    ptrdiff_t offset_to_base = 0;\x0a"
"    if (adjustedPtr \x21= nullptr)\x0a"
"    {\x0a"
"        offset_to_base = __offset_flags >> __offset_shift;\x0a"
"        if (__offset_flags \x26 __virtual_mask)\x0a"
"        {\x0a"
"            const char* vtable = *static_cast<const char*const*>(adjustedPtr);\x0a"
"            offset_to_base = *reinterpret_cast<const ptrdiff_t*>(vtable + offset_to_base);\x0a"
"        }\x0a"
"    }\x0a"
"    __base_type->has_unambiguous_public_base(\x0a"
"            info,\x0a"
"            static_cast<char*>(adjustedPtr) + offset_to_base,\x0a"
"            (__offset_flags \x26 __public_mask) \x3f path_below \x3a not_public_path);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__vmi_class_type_info\x3a\x3ahas_unambiguous_public_base(__dynamic_cast_info* info,\x0a"
"                                                   void* adjustedPtr,\x0a"
"                                                   int path_below) const\x0a"
"{\x0a"
"    if (is_equal(this, info->static_type, false))\x0a"
"        process_found_base_class(info, adjustedPtr, path_below);\x0a"
"    else\x0a"
"    {\x0a"
"        typedef const __base_class_type_info* Iter;\x0a"
"        const Iter e = __base_info + __base_count;\x0a"
"        Iter p = __base_info;\x0a"
"        p->has_unambiguous_public_base(info, adjustedPtr, path_below);\x0a"
"        if (++p < e)\x0a"
"        {\x0a"
"            do\x0a"
"            {\x0a"
"                p->has_unambiguous_public_base(info, adjustedPtr, path_below);\x0a"
"                if (info->search_done)\x0a"
"                    break;\x0a"
"            } while (++p < e);\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Handles bullet 1 for both pointers and member pointers\x0a"
"bool\x0a"
"__pbase_type_info\x3a\x3a""can_catch(const __shim_type_info* thrown_type,\x0a"
"                             void*\x26) const\x0a"
"{\x0a"
"    bool use_strcmp = this->__flags \x26 (__incomplete_class_mask \x7c\x0a"
"                                       __incomplete_mask);\x0a"
"    if (\x21use_strcmp) {\x0a"
"        const __pbase_type_info* thrown_pbase = dynamic_cast<const __pbase_type_info*>(\x0a"
"                thrown_type);\x0a"
"        if (\x21thrown_pbase) return false;\x0a"
"        use_strcmp = thrown_pbase->__flags \x26 (__incomplete_class_mask \x7c\x0a"
"                                              __incomplete_mask);\x0a"
"    }\x0a"
"    return is_equal(this, thrown_type, use_strcmp);\x0a"
"}\x0a"
"\x0a"
"#ifdef __clang__\x0a"
"#pragma clang diagnostic push\x0a"
"#pragma clang diagnostic ignored \x22-Wmissing-field-initializers\x22\x0a"
"#endif\x0a"
"\x0a"
"// Handles bullets 1, 3 and 4\x0a"
"// NOTE\x3a It might not be safe to adjust the pointer if it is not not a pointer\x0a"
"// type. Only adjust the pointer after we know it is safe to do so.\x0a"
"bool\x0a"
"__pointer_type_info\x3a\x3a""can_catch(const __shim_type_info* thrown_type,\x0a"
"                               void*\x26 adjustedPtr) const\x0a"
"{\x0a"
"    // bullet 4\x0a"
"    if (is_equal(thrown_type, \x26typeid(std\x3a\x3anullptr_t), false)) {\x0a"
"      adjustedPtr = nullptr;\x0a"
"      return true;\x0a"
"    }\x0a"
"\x0a"
"    // bullet 1\x0a"
"    if (__pbase_type_info\x3a\x3a""can_catch(thrown_type, adjustedPtr)) {\x0a"
"        if (adjustedPtr \x21= NULL)\x0a"
"            adjustedPtr = *static_cast<void**>(adjustedPtr);\x0a"
"        return true;\x0a"
"    }\x0a"
"    // bullet 3\x0a"
"    const __pointer_type_info* thrown_pointer_type =\x0a"
"        dynamic_cast<const __pointer_type_info*>(thrown_type);\x0a"
"    if (thrown_pointer_type == 0)\x0a"
"        return false;\x0a"
"    // Do the dereference adjustment\x0a"
"    if (adjustedPtr \x21= NULL)\x0a"
"        adjustedPtr = *static_cast<void**>(adjustedPtr);\x0a"
"    // bullet 3B and 3C\x0a"
"    if (thrown_pointer_type->__flags \x26 \x7e__flags \x26 __no_remove_flags_mask)\x0a"
"        return false;\x0a"
"    if (__flags \x26 \x7ethrown_pointer_type->__flags \x26 __no_add_flags_mask)\x0a"
"        return false;\x0a"
"    if (is_equal(__pointee, thrown_pointer_type->__pointee, false))\x0a"
"        return true;\x0a"
"    // bullet 3A\x0a"
"    if (is_equal(__pointee, \x26typeid(void), false)) {\x0a"
"        // pointers to functions cannot be converted to void*.\x0a"
"        // pointers to member functions are not handled here.\x0a"
"        const __function_type_info* thrown_function =\x0a"
"            dynamic_cast<const __function_type_info*>(thrown_pointer_type->__pointee);\x0a"
"        return (thrown_function == nullptr);\x0a"
"    }\x0a"
"    // Handle pointer to pointer\x0a"
"    const __pointer_type_info* nested_pointer_type =\x0a"
"        dynamic_cast<const __pointer_type_info*>(__pointee);\x0a"
"    if (nested_pointer_type) {\x0a"
"        if (\x7e__flags \x26 __const_mask) return false;\x0a"
"        return nested_pointer_type->can_catch_nested(thrown_pointer_type->__pointee);\x0a"
"    }\x0a"
"\x0a"
"    // Handle pointer to pointer to member\x0a"
"    const __pointer_to_member_type_info* member_ptr_type =\x0a"
"        dynamic_cast<const __pointer_to_member_type_info*>(__pointee);\x0a"
"    if (member_ptr_type) {\x0a"
"        if (\x7e__flags \x26 __const_mask) return false;\x0a"
"        return member_ptr_type->can_catch_nested(thrown_pointer_type->__pointee);\x0a"
"    }\x0a"
"\x0a"
"    // Handle pointer to class type\x0a"
"    const __class_type_info* catch_class_type =\x0a"
"        dynamic_cast<const __class_type_info*>(__pointee);\x0a"
"    if (catch_class_type == 0)\x0a"
"        return false;\x0a"
"    const __class_type_info* thrown_class_type =\x0a"
"        dynamic_cast<const __class_type_info*>(thrown_pointer_type->__pointee);\x0a"
"    if (thrown_class_type == 0)\x0a"
"        return false;\x0a"
"    __dynamic_cast_info info = {thrown_class_type, 0, catch_class_type, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,};\x0a"
"    info.number_of_dst_type = 1;\x0a"
"    thrown_class_type->has_unambiguous_public_base(\x26info, adjustedPtr, public_path);\x0a"
"    if (info.path_dst_ptr_to_static_ptr == public_path)\x0a"
"    {\x0a"
"        if (adjustedPtr \x21= NULL)\x0a"
"            adjustedPtr = const_cast<void*>(info.dst_ptr_leading_to_static_ptr);\x0a"
"        return true;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"bool __pointer_type_info\x3a\x3a""can_catch_nested(\x0a"
"    const __shim_type_info* thrown_type) const\x0a"
"{\x0a"
"  const __pointer_type_info* thrown_pointer_type =\x0a"
"        dynamic_cast<const __pointer_type_info*>(thrown_type);\x0a"
"    if (thrown_pointer_type == 0)\x0a"
"        return false;\x0a"
"    // bullet 3B\x0a"
"    if (thrown_pointer_type->__flags \x26 \x7e__flags)\x0a"
"        return false;\x0a"
"    if (is_equal(__pointee, thrown_pointer_type->__pointee, false))\x0a"
"        return true;\x0a"
"    // If the pointed to types differ then the catch type must be const\x0a"
"    // qualified.\x0a"
"    if (\x7e__flags \x26 __const_mask)\x0a"
"        return false;\x0a"
"\x0a"
"    // Handle pointer to pointer\x0a"
"    const __pointer_type_info* nested_pointer_type =\x0a"
"        dynamic_cast<const __pointer_type_info*>(__pointee);\x0a"
"    if (nested_pointer_type) {\x0a"
"        return nested_pointer_type->can_catch_nested(\x0a"
"            thrown_pointer_type->__pointee);\x0a"
"    }\x0a"
"\x0a"
"    // Handle pointer to pointer to member\x0a"
"    const __pointer_to_member_type_info* member_ptr_type =\x0a"
"        dynamic_cast<const __pointer_to_member_type_info*>(__pointee);\x0a"
"    if (member_ptr_type) {\x0a"
"        return member_ptr_type->can_catch_nested(thrown_pointer_type->__pointee);\x0a"
"    }\x0a"
"\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"bool __pointer_to_member_type_info\x3a\x3a""can_catch(\x0a"
"    const __shim_type_info* thrown_type, void*\x26 adjustedPtr) const {\x0a"
"    // bullet 4\x0a"
"    if (is_equal(thrown_type, \x26typeid(std\x3a\x3anullptr_t), false)) {\x0a"
"      // We assume that the pointer to member representation is the same for\x0a"
"      // all pointers to data members and for all pointers to member functions.\x0a"
"      struct X {};\x0a"
"      if (dynamic_cast<const __function_type_info*>(__pointee)) {\x0a"
"        static int (X\x3a\x3a*const null_ptr_rep)() = nullptr;\x0a"
"        adjustedPtr = const_cast<int (X\x3a\x3a**)()>(\x26null_ptr_rep);\x0a"
"      } else {\x0a"
"        static int X\x3a\x3a*const null_ptr_rep = nullptr;\x0a"
"        adjustedPtr = const_cast<int X\x3a\x3a**>(\x26null_ptr_rep);\x0a"
"      }\x0a"
"      return true;\x0a"
"    }\x0a"
"\x0a"
"    // bullet 1\x0a"
"    if (__pbase_type_info\x3a\x3a""can_catch(thrown_type, adjustedPtr))\x0a"
"        return true;\x0a"
"\x0a"
"    const __pointer_to_member_type_info* thrown_pointer_type =\x0a"
"        dynamic_cast<const __pointer_to_member_type_info*>(thrown_type);\x0a"
"    if (thrown_pointer_type == 0)\x0a"
"        return false;\x0a"
"    if (thrown_pointer_type->__flags \x26 \x7e__flags \x26 __no_remove_flags_mask)\x0a"
"        return false;\x0a"
"    if (__flags \x26 \x7ethrown_pointer_type->__flags \x26 __no_add_flags_mask)\x0a"
"        return false;\x0a"
"    if (\x21is_equal(__pointee, thrown_pointer_type->__pointee, false))\x0a"
"        return false;\x0a"
"    if (is_equal(__context, thrown_pointer_type->__context, false))\x0a"
"        return true;\x0a"
"\x0a"
"    // \x5b""except.handle\x5d does not allow the pointer-to-member conversions mentioned\x0a"
"    // in \x5bmem.conv\x5d to take place. For this reason we don't check Derived->Base\x0a"
"    // for Derived->Base conversions.\x0a"
"\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"bool __pointer_to_member_type_info\x3a\x3a""can_catch_nested(\x0a"
"    const __shim_type_info* thrown_type) const\x0a"
"{\x0a"
"    const __pointer_to_member_type_info* thrown_member_ptr_type =\x0a"
"        dynamic_cast<const __pointer_to_member_type_info*>(thrown_type);\x0a"
"    if (thrown_member_ptr_type == 0)\x0a"
"        return false;\x0a"
"    if (\x7e__flags \x26 thrown_member_ptr_type->__flags)\x0a"
"        return false;\x0a"
"    if (\x21is_equal(__pointee, thrown_member_ptr_type->__pointee, false))\x0a"
"        return false;\x0a"
"    if (\x21is_equal(__context, thrown_member_ptr_type->__context, false))\x0a"
"        return false;\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"#ifdef __clang__\x0a"
"#pragma clang diagnostic pop\x0a"
"#endif\x0a"
"\x0a"
"#ifdef __clang__\x0a"
"#pragma clang diagnostic push\x0a"
"#pragma clang diagnostic ignored \x22-Wmissing-field-initializers\x22\x0a"
"#endif\x0a"
"\x0a"
"// __dynamic_cast\x0a"
"\x0a"
"// static_ptr\x3a pointer to an object of type static_type; nonnull, and since the\x0a"
"//   object is polymorphic, *(void**)static_ptr is a virtual table pointer.\x0a"
"//   static_ptr is \x26v in the expression dynamic_cast<T>(v).\x0a"
"// static_type\x3a static type of the object pointed to by static_ptr.\x0a"
"// dst_type\x3a destination type of the cast (the \x22T\x22 in \x22""dynamic_cast<T>(v)\x22).\x0a"
"// src2dst_offset\x3a a static hint about the location of the\x0a"
"//                 source subobject with respect to the complete object;\x0a"
"//                 special negative values are\x3a\x0a"
"//                     -1\x3a no hint\x0a"
"//                     -2\x3a static_type is not a public base of dst_type\x0a"
"//                     -3\x3a static_type is a multiple public base type but never a\x0a"
"//                         virtual base type\x0a"
"//                 otherwise, the static_type type is a unique public nonvirtual\x0a"
"//                 base type of dst_type at offset src2dst_offset from the\x0a"
"//                 origin of dst_type.\x0a"
"//\x0a"
"// (dynamic_ptr, dynamic_type) are the run time type of the complete object\x0a"
"// referred to by static_ptr and a pointer to it.  These can be found from\x0a"
"// static_ptr for polymorphic types.\x0a"
"// static_type is guaranteed to be a polymorphic type.\x0a"
"//\x0a"
"// (dynamic_ptr, dynamic_type) is the root of a DAG that grows upward.  Each\x0a"
"// node of the tree represents a base class/object of its parent (or parents) below.\x0a"
"// Each node is uniquely represented by a pointer to the object, and a pointer\x0a"
"// to a type_info - its type.  Different nodes may have the same pointer and\x0a"
"// different nodes may have the same type.  But only one node has a specific\x0a"
"// (pointer-value, type) pair.  In C++ two objects of the same type can not\x0a"
"// share the same address.\x0a"
"//\x0a"
"// There are two flavors of nodes which have the type dst_type\x3a\x0a"
"//    1.  Those that are derived from (below) (static_ptr, static_type).\x0a"
"//    2.  Those that are not derived from (below) (static_ptr, static_type).\x0a"
"//\x0a"
"// Invariants of the DAG\x3a\x0a"
"//\x0a"
"// There is at least one path from the root (dynamic_ptr, dynamic_type) to\x0a"
"// the node (static_ptr, static_type).  This path may or may not be public.\x0a"
"// There may be more than one such path (some public some not).  Such a path may\x0a"
"// or may not go through a node having type dst_type.\x0a"
"//\x0a"
"// No node of type T appears above a node of the same type.  That means that\x0a"
"// there is only one node with dynamic_type.  And if dynamic_type == dst_type,\x0a"
"// then there is only one dst_type in the DAG.\x0a"
"//\x0a"
"// No node of type dst_type appears above a node of type static_type.  Such\x0a"
"// DAG's are possible in C++, but the compiler computes those dynamic_casts at\x0a"
"// compile time, and only calls __dynamic_cast when dst_type lies below\x0a"
"// static_type in the DAG.\x0a"
"//\x0a"
"// dst_type \x21= static_type\x3a  The compiler computes the dynamic_cast in this case too.\x0a"
"// dynamic_type \x21= static_type\x3a  The compiler computes the dynamic_cast in this case too.\x0a"
"//\x0a"
"// Returns\x3a\x0a"
"//\x0a"
"// If there is exactly one dst_type of flavor 1, and\x0a"
"//    If there is a public path from that dst_type to (static_ptr, static_type), or\x0a"
"//    If there are 0 dst_types of flavor 2, and there is a public path from\x0a"
"//        (dynamic_ptr, dynamic_type) to (static_ptr, static_type) and a public\x0a"
"//        path from (dynamic_ptr, dynamic_type) to the one dst_type, then return\x0a"
"//        a pointer to that dst_type.\x0a"
"// Else if there are 0 dst_types of flavor 1 and exactly 1 dst_type of flavor 2, and\x0a"
"//    if there is a public path from (dynamic_ptr, dynamic_type) to\x0a"
"//    (static_ptr, static_type) and a public path from (dynamic_ptr, dynamic_type)\x0a"
"//    to the one dst_type, then return a pointer to that one dst_type.\x0a"
"// Else return nullptr.\x0a"
"//\x0a"
"// If dynamic_type == dst_type, then the above algorithm collapses to the\x0a"
"// following cheaper algorithm\x3a\x0a"
"//\x0a"
"// If there is a public path from (dynamic_ptr, dynamic_type) to\x0a"
"//    (static_ptr, static_type), then return dynamic_ptr.\x0a"
"// Else return nullptr.\x0a"
"\x0a"
"extern \x22""C\x22 _LIBCXXABI_FUNC_VIS void *\x0a"
"__dynamic_cast(const void *static_ptr, const __class_type_info *static_type,\x0a"
"               const __class_type_info *dst_type,\x0a"
"               std\x3a\x3aptrdiff_t src2dst_offset) {\x0a"
"    // Possible future optimization\x3a  Take advantage of src2dst_offset\x0a"
"    // Currently clang always sets src2dst_offset to -1 (no hint).\x0a"
"\x0a"
"    // Get (dynamic_ptr, dynamic_type) from static_ptr\x0a"
"    void **vtable = *static_cast<void ** const *>(static_ptr);\x0a"
"    ptrdiff_t offset_to_derived = reinterpret_cast<ptrdiff_t>(vtable\x5b-2\x5d);\x0a"
"    const void* dynamic_ptr = static_cast<const char*>(static_ptr) + offset_to_derived;\x0a"
"    const __class_type_info* dynamic_type = static_cast<const __class_type_info*>(vtable\x5b-1\x5d);\x0a"
"\x0a"
"    // Initialize answer to nullptr.  This will be changed from the search\x0a"
"    //    results if a non-null answer is found.  Regardless, this is what will\x0a"
"    //    be returned.\x0a"
"    const void* dst_ptr = 0;\x0a"
"    // Initialize info struct for this search.\x0a"
"    __dynamic_cast_info info = {dst_type, static_ptr, static_type, src2dst_offset, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,};\x0a"
"\x0a"
"    // Find out if we can use a giant short cut in the search\x0a"
"    if (is_equal(dynamic_type, dst_type, false))\x0a"
"    {\x0a"
"        // Using giant short cut.  Add that information to info.\x0a"
"        info.number_of_dst_type = 1;\x0a"
"        // Do the  search\x0a"
"        dynamic_type->search_above_dst(\x26info, dynamic_ptr, dynamic_ptr, public_path, false);\x0a"
"#ifdef _LIBCXX_DYNAMIC_FALLBACK\x0a"
"        // The following if should always be false because we should definitely\x0a"
"        //   find (static_ptr, static_type), either on a public or private path\x0a"
"        if (info.path_dst_ptr_to_static_ptr == unknown)\x0a"
"        {\x0a"
"            // We get here only if there is some kind of visibility problem\x0a"
"            //   in client code.\x0a"
"            syslog(LOG_ERR, \x22""dynamic_cast error 1\x3a Both of the following type_info's \x22\x0a"
"                    \x22should have public visibility. At least one of them is hidden. \x25s\x22\x0a"
"                    \x22, \x25s.\x5cn\x22, static_type->name(), dynamic_type->name());\x0a"
"            // Redo the search comparing type_info's using strcmp\x0a"
"            info = {dst_type, static_ptr, static_type, src2dst_offset, 0};\x0a"
"            info.number_of_dst_type = 1;\x0a"
"            dynamic_type->search_above_dst(\x26info, dynamic_ptr, dynamic_ptr, public_path, true);\x0a"
"        }\x0a"
"#endif  // _LIBCXX_DYNAMIC_FALLBACK\x0a"
"        // Query the search.\x0a"
"        if (info.path_dst_ptr_to_static_ptr == public_path)\x0a"
"            dst_ptr = dynamic_ptr;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        // Not using giant short cut.  Do the search\x0a"
"        dynamic_type->search_below_dst(\x26info, dynamic_ptr, public_path, false);\x0a"
" #ifdef _LIBCXX_DYNAMIC_FALLBACK\x0a"
"        // The following if should always be false because we should definitely\x0a"
"        //   find (static_ptr, static_type), either on a public or private path\x0a"
"        if (info.path_dst_ptr_to_static_ptr == unknown \x26\x26\x0a"
"            info.path_dynamic_ptr_to_static_ptr == unknown)\x0a"
"        {\x0a"
"            syslog(LOG_ERR, \x22""dynamic_cast error 2\x3a One or more of the following type_info's \x22\x0a"
"                            \x22has hidden visibility or is defined in more than one translation \x22\x0a"
"                            \x22unit. They should all have public visibility. \x22\x0a"
"                            \x22\x25s, \x25s, \x25s.\x5cn\x22, static_type->name(), dynamic_type->name(),\x0a"
"                    dst_type->name());\x0a"
"            // Redo the search comparing type_info's using strcmp\x0a"
"            info = {dst_type, static_ptr, static_type, src2dst_offset, 0};\x0a"
"            dynamic_type->search_below_dst(\x26info, dynamic_ptr, public_path, true);\x0a"
"        }\x0a"
"#endif  // _LIBCXX_DYNAMIC_FALLBACK\x0a"
"        // Query the search.\x0a"
"        switch (info.number_to_static_ptr)\x0a"
"        {\x0a"
"        case 0\x3a\x0a"
"            if (info.number_to_dst_ptr == 1 \x26\x26\x0a"
"                    info.path_dynamic_ptr_to_static_ptr == public_path \x26\x26\x0a"
"                    info.path_dynamic_ptr_to_dst_ptr == public_path)\x0a"
"                dst_ptr = info.dst_ptr_not_leading_to_static_ptr;\x0a"
"            break;\x0a"
"        case 1\x3a\x0a"
"            if (info.path_dst_ptr_to_static_ptr == public_path \x7c\x7c\x0a"
"                   (\x0a"
"                       info.number_to_dst_ptr == 0 \x26\x26\x0a"
"                       info.path_dynamic_ptr_to_static_ptr == public_path \x26\x26\x0a"
"                       info.path_dynamic_ptr_to_dst_ptr == public_path\x0a"
"                   )\x0a"
"               )\x0a"
"                dst_ptr = info.dst_ptr_leading_to_static_ptr;\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return const_cast<void*>(dst_ptr);\x0a"
"}\x0a"
"\x0a"
"#ifdef __clang__\x0a"
"#pragma clang diagnostic pop\x0a"
"#endif\x0a"
"\x0a"
"// Call this function when you hit a static_type which is a base (above) a dst_type.\x0a"
"// Let caller know you hit a static_type.  But only start recording details if\x0a"
"// this is (static_ptr, static_type) -- the node we are casting from.\x0a"
"// If this is (static_ptr, static_type)\x0a"
"//   Record the path (public or not) from the dst_type to here.  There may be\x0a"
"//   multiple paths from the same dst_type to here, record the \x22most public\x22 one.\x0a"
"//   Record the dst_ptr as pointing to (static_ptr, static_type).\x0a"
"//   If more than one (dst_ptr, dst_type) points to (static_ptr, static_type),\x0a"
"//   then mark this dyanmic_cast as ambiguous and stop the search.\x0a"
"void\x0a"
"__class_type_info\x3a\x3aprocess_static_type_above_dst(__dynamic_cast_info* info,\x0a"
"                                                 const void* dst_ptr,\x0a"
"                                                 const void* current_ptr,\x0a"
"                                                 int path_below) const\x0a"
"{\x0a"
"    // Record that we found a static_type\x0a"
"    info->found_any_static_type = true;\x0a"
"    if (current_ptr == info->static_ptr)\x0a"
"    {\x0a"
"        // Record that we found (static_ptr, static_type)\x0a"
"        info->found_our_static_ptr = true;\x0a"
"        if (info->dst_ptr_leading_to_static_ptr == 0)\x0a"
"        {\x0a"
"            // First time here\x0a"
"            info->dst_ptr_leading_to_static_ptr = dst_ptr;\x0a"
"            info->path_dst_ptr_to_static_ptr = path_below;\x0a"
"            info->number_to_static_ptr = 1;\x0a"
"            // If there is only one dst_type in the entire tree and the path from\x0a"
"            //    there to here is public then we are done\x21\x0a"
"            if (info->number_of_dst_type == 1 \x26\x26 info->path_dst_ptr_to_static_ptr == public_path)\x0a"
"                info->search_done = true;\x0a"
"        }\x0a"
"        else if (info->dst_ptr_leading_to_static_ptr == dst_ptr)\x0a"
"        {\x0a"
"            // We've been here before.  Update path to \x22most public\x22\x0a"
"            if (info->path_dst_ptr_to_static_ptr == not_public_path)\x0a"
"                info->path_dst_ptr_to_static_ptr = path_below;\x0a"
"            // If there is only one dst_type in the entire tree and the path from\x0a"
"            //    there to here is public then we are done\x21\x0a"
"            if (info->number_of_dst_type == 1 \x26\x26 info->path_dst_ptr_to_static_ptr == public_path)\x0a"
"                info->search_done = true;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            // We've detected an ambiguous cast from (static_ptr, static_type)\x0a"
"            //   to a dst_type\x0a"
"            info->number_to_static_ptr += 1;\x0a"
"            info->search_done = true;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Call this function when you hit a static_type which is not a base (above) a dst_type.\x0a"
"// If this is (static_ptr, static_type)\x0a"
"//   Record the path (public or not) from (dynamic_ptr, dynamic_type) to here.  There may be\x0a"
"//   multiple paths from (dynamic_ptr, dynamic_type) to here, record the \x22most public\x22 one.\x0a"
"void\x0a"
"__class_type_info\x3a\x3aprocess_static_type_below_dst(__dynamic_cast_info* info,\x0a"
"                                                 const void* current_ptr,\x0a"
"                                                 int path_below) const\x0a"
"{\x0a"
"    if (current_ptr == info->static_ptr)\x0a"
"    {\x0a"
"        // Record the most public path from (dynamic_ptr, dynamic_type) to\x0a"
"        //                                  (static_ptr, static_type)\x0a"
"        if (info->path_dynamic_ptr_to_static_ptr \x21= public_path)\x0a"
"            info->path_dynamic_ptr_to_static_ptr = path_below;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Call this function when searching below a dst_type node.  This function searches\x0a"
"// for a path to (static_ptr, static_type) and for paths to one or more dst_type nodes.\x0a"
"// If it finds a static_type node, there is no need to further search base classes\x0a"
"// above.\x0a"
"// If it finds a dst_type node it should search base classes using search_above_dst\x0a"
"// to find out if this dst_type points to (static_ptr, static_type) or not.\x0a"
"// Either way, the dst_type is recorded as one of two \x22""flavors\x22\x3a  one that does\x0a"
"// or does not point to (static_ptr, static_type).\x0a"
"// If this is neither a static_type nor a dst_type node, continue searching\x0a"
"// base classes above.\x0a"
"// All the hoopla surrounding the search code is doing nothing but looking for\x0a"
"// excuses to stop the search prematurely (break out of the for-loop).  That is,\x0a"
"// the algorithm below is simply an optimization of this\x3a\x0a"
"// void\x0a"
"// __vmi_class_type_info\x3a\x3asearch_below_dst(__dynamic_cast_info* info,\x0a"
"//                                         const void* current_ptr,\x0a"
"//                                         int path_below) const\x0a"
"// {\x0a"
"//     typedef const __base_class_type_info* Iter;\x0a"
"//     if (this == info->static_type)\x0a"
"//         process_static_type_below_dst(info, current_ptr, path_below);\x0a"
"//     else if (this == info->dst_type)\x0a"
"//     {\x0a"
"//         // Record the most public access path that got us here\x0a"
"//         if (info->path_dynamic_ptr_to_dst_ptr \x21= public_path)\x0a"
"//             info->path_dynamic_ptr_to_dst_ptr = path_below;\x0a"
"//         bool does_dst_type_point_to_our_static_type = false;\x0a"
"//         for (Iter p = __base_info, e= __base_info + __base_count; p < e; ++p)\x0a"
"//         {\x0a"
"//             p->search_above_dst(info, current_ptr, current_ptr, public_path);\x0a"
"//             if (info->found_our_static_ptr)\x0a"
"//                 does_dst_type_point_to_our_static_type = true;\x0a"
"//             // break out early here if you can detect it doesn't matter if you do\x0a"
"//         }\x0a"
"//         if (\x21""does_dst_type_point_to_our_static_type)\x0a"
"//         {\x0a"
"//             // We found a dst_type that doesn't point to (static_ptr, static_type)\x0a"
"//             // So record the address of this dst_ptr and increment the\x0a"
"//             // count of the number of such dst_types found in the tree.\x0a"
"//             info->dst_ptr_not_leading_to_static_ptr = current_ptr;\x0a"
"//             info->number_to_dst_ptr += 1;\x0a"
"//         }\x0a"
"//     }\x0a"
"//     else\x0a"
"//     {\x0a"
"//         // This is not a static_type and not a dst_type.\x0a"
"//         for (Iter p = __base_info, e = __base_info + __base_count; p < e; ++p)\x0a"
"//         {\x0a"
"//             p->search_below_dst(info, current_ptr, public_path);\x0a"
"//             // break out early here if you can detect it doesn't matter if you do\x0a"
"//         }\x0a"
"//     }\x0a"
"// }\x0a"
"void\x0a"
"__vmi_class_type_info\x3a\x3asearch_below_dst(__dynamic_cast_info* info,\x0a"
"                                        const void* current_ptr,\x0a"
"                                        int path_below,\x0a"
"                                        bool use_strcmp) const\x0a"
"{\x0a"
"    typedef const __base_class_type_info* Iter;\x0a"
"    if (is_equal(this, info->static_type, use_strcmp))\x0a"
"        process_static_type_below_dst(info, current_ptr, path_below);\x0a"
"    else if (is_equal(this, info->dst_type, use_strcmp))\x0a"
"    {\x0a"
"        // We've been here before if we've recorded current_ptr in one of these\x0a"
"        //   two places\x3a\x0a"
"        if (current_ptr == info->dst_ptr_leading_to_static_ptr \x7c\x7c\x0a"
"            current_ptr == info->dst_ptr_not_leading_to_static_ptr)\x0a"
"        {\x0a"
"            // We've seen this node before, and therefore have already searched\x0a"
"            // its base classes above.\x0a"
"            //  Update path to here that is \x22most public\x22.\x0a"
"            if (path_below == public_path)\x0a"
"                info->path_dynamic_ptr_to_dst_ptr = public_path;\x0a"
"        }\x0a"
"        else  // We have haven't been here before\x0a"
"        {\x0a"
"            // Record the access path that got us here\x0a"
"            //   If there is more than one dst_type this path doesn't matter.\x0a"
"            info->path_dynamic_ptr_to_dst_ptr = path_below;\x0a"
"            bool does_dst_type_point_to_our_static_type = false;\x0a"
"            // Only search above here if dst_type derives from static_type, or\x0a"
"            //    if it is unknown if dst_type derives from static_type.\x0a"
"            if (info->is_dst_type_derived_from_static_type \x21= no)\x0a"
"            {\x0a"
"                // Set up flags to record results from all base classes\x0a"
"                bool is_dst_type_derived_from_static_type = false;\x0a"
"\x0a"
"                // We've found a dst_type with a potentially public path to here.\x0a"
"                // We have to assume the path is public because it may become\x0a"
"                //   public later (if we get back to here with a public path).\x0a"
"                // We can stop looking above if\x3a\x0a"
"                //    1.  We've found a public path to (static_ptr, static_type).\x0a"
"                //    2.  We've found an ambiguous cast from (static_ptr, static_type) to a dst_type.\x0a"
"                //        This is detected at the (static_ptr, static_type).\x0a"
"                //    3.  We can prove that there is no public path to (static_ptr, static_type)\x0a"
"                //        above here.\x0a"
"                const Iter e = __base_info + __base_count;\x0a"
"                for (Iter p = __base_info; p < e; ++p)\x0a"
"                {\x0a"
"                    // Zero out found flags\x0a"
"                    info->found_our_static_ptr = false;\x0a"
"                    info->found_any_static_type = false;\x0a"
"                    p->search_above_dst(info, current_ptr, current_ptr, public_path, use_strcmp);\x0a"
"                    if (info->search_done)\x0a"
"                        break;\x0a"
"                    if (info->found_any_static_type)\x0a"
"                    {\x0a"
"                        is_dst_type_derived_from_static_type = true;\x0a"
"                        if (info->found_our_static_ptr)\x0a"
"                        {\x0a"
"                            does_dst_type_point_to_our_static_type = true;\x0a"
"                            // If we found what we're looking for, stop looking above.\x0a"
"                            if (info->path_dst_ptr_to_static_ptr == public_path)\x0a"
"                                break;\x0a"
"                            // We found a private path to (static_ptr, static_type)\x0a"
"                            //   If there is no diamond then there is only one path\x0a"
"                            //   to (static_ptr, static_type) and we just found it.\x0a"
"                            if (\x21(__flags \x26 __diamond_shaped_mask))\x0a"
"                                break;\x0a"
"                        }\x0a"
"                        else\x0a"
"                        {\x0a"
"                            // If we found a static_type that isn't the one we're looking\x0a"
"                            //    for, and if there are no repeated types above here,\x0a"
"                            //    then stop looking.\x0a"
"                            if (\x21(__flags \x26 __non_diamond_repeat_mask))\x0a"
"                                break;\x0a"
"                        }\x0a"
"                    }\x0a"
"                }\x0a"
"                // If we found no static_type,s then dst_type doesn't derive\x0a"
"                //   from static_type, else it does.  Record this result so that\x0a"
"                //   next time we hit a dst_type we will know not to search above\x0a"
"                //   it if it doesn't derive from static_type.\x0a"
"                if (is_dst_type_derived_from_static_type)\x0a"
"                    info->is_dst_type_derived_from_static_type = yes;\x0a"
"                else\x0a"
"                    info->is_dst_type_derived_from_static_type = no;\x0a"
"              }\x0a"
"              if (\x21""does_dst_type_point_to_our_static_type)\x0a"
"              {\x0a"
"                  // We found a dst_type that doesn't point to (static_ptr, static_type)\x0a"
"                  // So record the address of this dst_ptr and increment the\x0a"
"                  // count of the number of such dst_types found in the tree.\x0a"
"                  info->dst_ptr_not_leading_to_static_ptr = current_ptr;\x0a"
"                  info->number_to_dst_ptr += 1;\x0a"
"                  // If there exists another dst with a private path to\x0a"
"                  //    (static_ptr, static_type), then the cast from\x0a"
"                  //     (dynamic_ptr, dynamic_type) to dst_type is now ambiguous,\x0a"
"                  //      so stop search.\x0a"
"                  if (info->number_to_static_ptr == 1 \x26\x26\x0a"
"                          info->path_dst_ptr_to_static_ptr == not_public_path)\x0a"
"                      info->search_done = true;\x0a"
"              }\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        // This is not a static_type and not a dst_type.\x0a"
"        const Iter e = __base_info + __base_count;\x0a"
"        Iter p = __base_info;\x0a"
"        p->search_below_dst(info, current_ptr, path_below, use_strcmp);\x0a"
"        if (++p < e)\x0a"
"        {\x0a"
"            if ((__flags \x26 __diamond_shaped_mask) \x7c\x7c info->number_to_static_ptr == 1)\x0a"
"            {\x0a"
"                // If there are multiple paths to a base above from here, or if\x0a"
"                //    a dst_type pointing to (static_ptr, static_type) has been found,\x0a"
"                //    then there is no way to break out of this loop early unless\x0a"
"                //    something below detects the search is done.\x0a"
"                do\x0a"
"                {\x0a"
"                    if (info->search_done)\x0a"
"                        break;\x0a"
"                    p->search_below_dst(info, current_ptr, path_below, use_strcmp);\x0a"
"                } while (++p < e);\x0a"
"            }\x0a"
"            else if (__flags \x26 __non_diamond_repeat_mask)\x0a"
"            {\x0a"
"                // There are not multiple paths to any base class from here and a\x0a"
"                //   dst_type pointing to (static_ptr, static_type) has not yet been\x0a"
"                //   found.\x0a"
"                do\x0a"
"                {\x0a"
"                    if (info->search_done)\x0a"
"                        break;\x0a"
"                    // If we just found a dst_type with a public path to (static_ptr, static_type),\x0a"
"                    //    then the only reason to continue the search is to make sure\x0a"
"                    //    no other dst_type points to (static_ptr, static_type).\x0a"
"                    //    If \x21""diamond, then we don't need to search here.\x0a"
"                    if (info->number_to_static_ptr == 1 \x26\x26\x0a"
"                              info->path_dst_ptr_to_static_ptr == public_path)\x0a"
"                        break;\x0a"
"                    p->search_below_dst(info, current_ptr, path_below, use_strcmp);\x0a"
"                } while (++p < e);\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                // There are no repeated types above this node.\x0a"
"                // There are no nodes with multiple parents above this node.\x0a"
"                // no dst_type has been found to (static_ptr, static_type)\x0a"
"                do\x0a"
"                {\x0a"
"                    if (info->search_done)\x0a"
"                        break;\x0a"
"                    // If we just found a dst_type with a public path to (static_ptr, static_type),\x0a"
"                    //    then the only reason to continue the search is to make sure sure\x0a"
"                    //    no other dst_type points to (static_ptr, static_type).\x0a"
"                    //    If \x21""diamond, then we don't need to search here.\x0a"
"                    // if we just found a dst_type with a private path to (static_ptr, static_type),\x0a"
"                    //    then we're only looking for a public path to (static_ptr, static_type)\x0a"
"                    //    and to check for other dst_types.\x0a"
"                    //    If \x21""diamond \x26 \x21repeat, then there is not a pointer to (static_ptr, static_type)\x0a"
"                    //    and not a dst_type under here.\x0a"
"                    if (info->number_to_static_ptr == 1)\x0a"
"                        break;\x0a"
"                    p->search_below_dst(info, current_ptr, path_below, use_strcmp);\x0a"
"                } while (++p < e);\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// This is the same algorithm as __vmi_class_type_info\x3a\x3asearch_below_dst but\x0a"
"//   simplified to the case that there is only a single base class.\x0a"
"void\x0a"
"__si_class_type_info\x3a\x3asearch_below_dst(__dynamic_cast_info* info,\x0a"
"                                       const void* current_ptr,\x0a"
"                                       int path_below,\x0a"
"                                       bool use_strcmp) const\x0a"
"{\x0a"
"    if (is_equal(this, info->static_type, use_strcmp))\x0a"
"        process_static_type_below_dst(info, current_ptr, path_below);\x0a"
"    else if (is_equal(this, info->dst_type, use_strcmp))\x0a"
"    {\x0a"
"        // We've been here before if we've recorded current_ptr in one of these\x0a"
"        //   two places\x3a\x0a"
"        if (current_ptr == info->dst_ptr_leading_to_static_ptr \x7c\x7c\x0a"
"            current_ptr == info->dst_ptr_not_leading_to_static_ptr)\x0a"
"        {\x0a"
"            // We've seen this node before, and therefore have already searched\x0a"
"            // its base classes above.\x0a"
"            //  Update path to here that is \x22most public\x22.\x0a"
"            if (path_below == public_path)\x0a"
"                info->path_dynamic_ptr_to_dst_ptr = public_path;\x0a"
"        }\x0a"
"        else  // We have haven't been here before\x0a"
"        {\x0a"
"            // Record the access path that got us here\x0a"
"            //   If there is more than one dst_type this path doesn't matter.\x0a"
"            info->path_dynamic_ptr_to_dst_ptr = path_below;\x0a"
"            bool does_dst_type_point_to_our_static_type = false;\x0a"
"            // Only search above here if dst_type derives from static_type, or\x0a"
"            //    if it is unknown if dst_type derives from static_type.\x0a"
"            if (info->is_dst_type_derived_from_static_type \x21= no)\x0a"
"            {\x0a"
"                // Set up flags to record results from all base classes\x0a"
"                bool is_dst_type_derived_from_static_type = false;\x0a"
"                // Zero out found flags\x0a"
"                info->found_our_static_ptr = false;\x0a"
"                info->found_any_static_type = false;\x0a"
"                __base_type->search_above_dst(info, current_ptr, current_ptr, public_path, use_strcmp);\x0a"
"                if (info->found_any_static_type)\x0a"
"                {\x0a"
"                    is_dst_type_derived_from_static_type = true;\x0a"
"                    if (info->found_our_static_ptr)\x0a"
"                        does_dst_type_point_to_our_static_type = true;\x0a"
"                }\x0a"
"                // If we found no static_type,s then dst_type doesn't derive\x0a"
"                //   from static_type, else it does.  Record this result so that\x0a"
"                //   next time we hit a dst_type we will know not to search above\x0a"
"                //   it if it doesn't derive from static_type.\x0a"
"                if (is_dst_type_derived_from_static_type)\x0a"
"                    info->is_dst_type_derived_from_static_type = yes;\x0a"
"                else\x0a"
"                    info->is_dst_type_derived_from_static_type = no;\x0a"
"            }\x0a"
"            if (\x21""does_dst_type_point_to_our_static_type)\x0a"
"            {\x0a"
"                // We found a dst_type that doesn't point to (static_ptr, static_type)\x0a"
"                // So record the address of this dst_ptr and increment the\x0a"
"                // count of the number of such dst_types found in the tree.\x0a"
"                info->dst_ptr_not_leading_to_static_ptr = current_ptr;\x0a"
"                info->number_to_dst_ptr += 1;\x0a"
"                // If there exists another dst with a private path to\x0a"
"                //    (static_ptr, static_type), then the cast from\x0a"
"                //     (dynamic_ptr, dynamic_type) to dst_type is now ambiguous.\x0a"
"                if (info->number_to_static_ptr == 1 \x26\x26\x0a"
"                        info->path_dst_ptr_to_static_ptr == not_public_path)\x0a"
"                    info->search_done = true;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        // This is not a static_type and not a dst_type\x0a"
"        __base_type->search_below_dst(info, current_ptr, path_below, use_strcmp);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// This is the same algorithm as __vmi_class_type_info\x3a\x3asearch_below_dst but\x0a"
"//   simplified to the case that there is no base class.\x0a"
"void\x0a"
"__class_type_info\x3a\x3asearch_below_dst(__dynamic_cast_info* info,\x0a"
"                                    const void* current_ptr,\x0a"
"                                    int path_below,\x0a"
"                                    bool use_strcmp) const\x0a"
"{\x0a"
"    if (is_equal(this, info->static_type, use_strcmp))\x0a"
"        process_static_type_below_dst(info, current_ptr, path_below);\x0a"
"    else if (is_equal(this, info->dst_type, use_strcmp))\x0a"
"    {\x0a"
"        // We've been here before if we've recorded current_ptr in one of these\x0a"
"        //   two places\x3a\x0a"
"        if (current_ptr == info->dst_ptr_leading_to_static_ptr \x7c\x7c\x0a"
"            current_ptr == info->dst_ptr_not_leading_to_static_ptr)\x0a"
"        {\x0a"
"            // We've seen this node before, and therefore have already searched\x0a"
"            // its base classes above.\x0a"
"            //  Update path to here that is \x22most public\x22.\x0a"
"            if (path_below == public_path)\x0a"
"                info->path_dynamic_ptr_to_dst_ptr = public_path;\x0a"
"        }\x0a"
"        else  // We have haven't been here before\x0a"
"        {\x0a"
"            // Record the access path that got us here\x0a"
"            //   If there is more than one dst_type this path doesn't matter.\x0a"
"            info->path_dynamic_ptr_to_dst_ptr = path_below;\x0a"
"            // We found a dst_type that doesn't point to (static_ptr, static_type)\x0a"
"            // So record the address of this dst_ptr and increment the\x0a"
"            // count of the number of such dst_types found in the tree.\x0a"
"            info->dst_ptr_not_leading_to_static_ptr = current_ptr;\x0a"
"            info->number_to_dst_ptr += 1;\x0a"
"            // If there exists another dst with a private path to\x0a"
"            //    (static_ptr, static_type), then the cast from \x0a"
"            //     (dynamic_ptr, dynamic_type) to dst_type is now ambiguous.\x0a"
"            if (info->number_to_static_ptr == 1 \x26\x26\x0a"
"                    info->path_dst_ptr_to_static_ptr == not_public_path)\x0a"
"                info->search_done = true;\x0a"
"            // We found that dst_type does not derive from static_type\x0a"
"            info->is_dst_type_derived_from_static_type = no;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Call this function when searching above a dst_type node.  This function searches\x0a"
"// for a public path to (static_ptr, static_type).\x0a"
"// This function is guaranteed not to find a node of type dst_type.\x0a"
"// Theoretically this is a very simple function which just stops if it finds a\x0a"
"// static_type node\x3a  All the hoopla surrounding the search code is doing\x0a"
"// nothing but looking for excuses to stop the search prematurely (break out of\x0a"
"// the for-loop).  That is, the algorithm below is simply an optimization of this\x3a\x0a"
"// void\x0a"
"// __vmi_class_type_info\x3a\x3asearch_above_dst(__dynamic_cast_info* info,\x0a"
"//                                         const void* dst_ptr,\x0a"
"//                                         const void* current_ptr,\x0a"
"//                                         int path_below) const\x0a"
"// {\x0a"
"//     if (this == info->static_type)\x0a"
"//         process_static_type_above_dst(info, dst_ptr, current_ptr, path_below);\x0a"
"//     else\x0a"
"//     {\x0a"
"//         typedef const __base_class_type_info* Iter;\x0a"
"//         // This is not a static_type and not a dst_type\x0a"
"//         for (Iter p = __base_info, e = __base_info + __base_count; p < e; ++p)\x0a"
"//         {\x0a"
"//             p->search_above_dst(info, dst_ptr, current_ptr, public_path);\x0a"
"//             // break out early here if you can detect it doesn't matter if you do\x0a"
"//         }\x0a"
"//     }\x0a"
"// }\x0a"
"void\x0a"
"__vmi_class_type_info\x3a\x3asearch_above_dst(__dynamic_cast_info* info,\x0a"
"                                        const void* dst_ptr,\x0a"
"                                        const void* current_ptr,\x0a"
"                                        int path_below,\x0a"
"                                        bool use_strcmp) const\x0a"
"{\x0a"
"    if (is_equal(this, info->static_type, use_strcmp))\x0a"
"        process_static_type_above_dst(info, dst_ptr, current_ptr, path_below);\x0a"
"    else\x0a"
"    {\x0a"
"        typedef const __base_class_type_info* Iter;\x0a"
"        // This is not a static_type and not a dst_type\x0a"
"        // Save flags so they can be restored when returning to nodes below.\x0a"
"        bool found_our_static_ptr = info->found_our_static_ptr;\x0a"
"        bool found_any_static_type = info->found_any_static_type;\x0a"
"        // We've found a dst_type below with a path to here.  If the path\x0a"
"        //    to here is not public, there may be another path to here that\x0a"
"        //    is public.  So we have to assume that the path to here is public.\x0a"
"        //  We can stop looking above if\x3a\x0a"
"        //    1.  We've found a public path to (static_ptr, static_type).\x0a"
"        //    2.  We've found an ambiguous cast from (static_ptr, static_type) to a dst_type.\x0a"
"        //        This is detected at the (static_ptr, static_type).\x0a"
"        //    3.  We can prove that there is no public path to (static_ptr, static_type)\x0a"
"        //        above here.\x0a"
"        const Iter e = __base_info + __base_count;\x0a"
"        Iter p = __base_info;\x0a"
"        // Zero out found flags\x0a"
"        info->found_our_static_ptr = false;\x0a"
"        info->found_any_static_type = false;\x0a"
"        p->search_above_dst(info, dst_ptr, current_ptr, path_below, use_strcmp);\x0a"
"        found_our_static_ptr \x7c= info->found_our_static_ptr;\x0a"
"        found_any_static_type \x7c= info->found_any_static_type;\x0a"
"        if (++p < e)\x0a"
"        {\x0a"
"            do\x0a"
"            {\x0a"
"                if (info->search_done)\x0a"
"                    break;\x0a"
"                if (info->found_our_static_ptr)\x0a"
"                {\x0a"
"                    // If we found what we're looking for, stop looking above.\x0a"
"                    if (info->path_dst_ptr_to_static_ptr == public_path)\x0a"
"                        break;\x0a"
"                    // We found a private path to (static_ptr, static_type)\x0a"
"                    //   If there is no diamond then there is only one path\x0a"
"                    //   to (static_ptr, static_type) from here and we just found it.\x0a"
"                    if (\x21(__flags \x26 __diamond_shaped_mask))\x0a"
"                        break;\x0a"
"                }\x0a"
"                else if (info->found_any_static_type)\x0a"
"                {\x0a"
"                    // If we found a static_type that isn't the one we're looking\x0a"
"                    //    for, and if there are no repeated types above here,\x0a"
"                    //    then stop looking.\x0a"
"                    if (\x21(__flags \x26 __non_diamond_repeat_mask))\x0a"
"                        break;\x0a"
"                }\x0a"
"                // Zero out found flags\x0a"
"                info->found_our_static_ptr = false;\x0a"
"                info->found_any_static_type = false;\x0a"
"                p->search_above_dst(info, dst_ptr, current_ptr, path_below, use_strcmp);\x0a"
"                found_our_static_ptr \x7c= info->found_our_static_ptr;\x0a"
"                found_any_static_type \x7c= info->found_any_static_type;\x0a"
"            } while (++p < e);\x0a"
"        }\x0a"
"        // Restore flags\x0a"
"        info->found_our_static_ptr = found_our_static_ptr;\x0a"
"        info->found_any_static_type = found_any_static_type;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// This is the same algorithm as __vmi_class_type_info\x3a\x3asearch_above_dst but\x0a"
"//   simplified to the case that there is only a single base class.\x0a"
"void\x0a"
"__si_class_type_info\x3a\x3asearch_above_dst(__dynamic_cast_info* info,\x0a"
"                                       const void* dst_ptr,\x0a"
"                                       const void* current_ptr,\x0a"
"                                       int path_below,\x0a"
"                                       bool use_strcmp) const\x0a"
"{\x0a"
"    if (is_equal(this, info->static_type, use_strcmp))\x0a"
"        process_static_type_above_dst(info, dst_ptr, current_ptr, path_below);\x0a"
"    else\x0a"
"        __base_type->search_above_dst(info, dst_ptr, current_ptr, path_below, use_strcmp);\x0a"
"}\x0a"
"\x0a"
"// This is the same algorithm as __vmi_class_type_info\x3a\x3asearch_above_dst but\x0a"
"//   simplified to the case that there is no base class.\x0a"
"void\x0a"
"__class_type_info\x3a\x3asearch_above_dst(__dynamic_cast_info* info,\x0a"
"                                    const void* dst_ptr,\x0a"
"                                    const void* current_ptr,\x0a"
"                                    int path_below,\x0a"
"                                    bool use_strcmp) const\x0a"
"{\x0a"
"    if (is_equal(this, info->static_type, use_strcmp))\x0a"
"        process_static_type_above_dst(info, dst_ptr, current_ptr, path_below);\x0a"
"}\x0a"
"\x0a"
"// The search functions for __base_class_type_info are simply convenience\x0a"
"//   functions for adjusting the current_ptr and path_below as the search is\x0a"
"//   passed up to the base class node.\x0a"
"\x0a"
"void\x0a"
"__base_class_type_info\x3a\x3asearch_above_dst(__dynamic_cast_info* info,\x0a"
"                                         const void* dst_ptr,\x0a"
"                                         const void* current_ptr,\x0a"
"                                         int path_below,\x0a"
"                                         bool use_strcmp) const\x0a"
"{\x0a"
"    ptrdiff_t offset_to_base = __offset_flags >> __offset_shift;\x0a"
"    if (__offset_flags \x26 __virtual_mask)\x0a"
"    {\x0a"
"        const char* vtable = *static_cast<const char*const*>(current_ptr);\x0a"
"        offset_to_base = *reinterpret_cast<const ptrdiff_t*>(vtable + offset_to_base);\x0a"
"    }\x0a"
"    __base_type->search_above_dst(info, dst_ptr,\x0a"
"                                  static_cast<const char*>(current_ptr) + offset_to_base,\x0a"
"                                  (__offset_flags \x26 __public_mask) \x3f\x0a"
"                                      path_below \x3a\x0a"
"                                      not_public_path,\x0a"
"                                  use_strcmp);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__base_class_type_info\x3a\x3asearch_below_dst(__dynamic_cast_info* info,\x0a"
"                                         const void* current_ptr,\x0a"
"                                         int path_below,\x0a"
"                                         bool use_strcmp) const\x0a"
"{\x0a"
"    ptrdiff_t offset_to_base = __offset_flags >> __offset_shift;\x0a"
"    if (__offset_flags \x26 __virtual_mask)\x0a"
"    {\x0a"
"        const char* vtable = *static_cast<const char*const*>(current_ptr);\x0a"
"        offset_to_base = *reinterpret_cast<const ptrdiff_t*>(vtable + offset_to_base);\x0a"
"    }\x0a"
"    __base_type->search_below_dst(info,\x0a"
"                                  static_cast<const char*>(current_ptr) + offset_to_base,\x0a"
"                                  (__offset_flags \x26 __public_mask) \x3f\x0a"
"                                      path_below \x3a\x0a"
"                                      not_public_path,\x0a"
"                                  use_strcmp);\x0a"
"}\x0a"
"\x0a"
"}  // __cxxabiv1\x0a"
"", 55764 ); }