#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxxabi_src_stdlib_new_delete_cpp( 
"//===--------------------- stdlib_new_delete.cpp --------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//\x0a"
"// This file implements the new and delete operators.\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#define _LIBCPP_BUILDING_LIBRARY\x0a"
"#include \x22__cxxabi_config.h\x22\x0a"
"#include <new>\x0a"
"#include <cstdlib>\x0a"
"\x0a"
"#if \x21""defined(_THROW_BAD_ALLOC) \x7c\x7c \x21""defined(_NOEXCEPT) \x7c\x7c \x21""defined(_LIBCXXABI_WEAK)\x0a"
"#error The _THROW_BAD_ALLOC, _NOEXCEPT, and _LIBCXXABI_WEAK libc++ macros must \x5c\x0a"
"       already be defined by libc++.\x0a"
"#endif\x0a"
"// Implement all new and delete operators as weak definitions\x0a"
"// in this shared library, so that they can be overridden by programs\x0a"
"// that define non-weak copies of the functions.\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void *\x0a"
"operator new(std\x3a\x3asize_t size) _THROW_BAD_ALLOC\x0a"
"{\x0a"
"    if (size == 0)\x0a"
"        size = 1;\x0a"
"    void* p;\x0a"
"    while ((p = \x3a\x3amalloc(size)) == 0)\x0a"
"    {\x0a"
"        // If malloc fails and there is a new_handler,\x0a"
"        // call it to try free up memory.\x0a"
"        std\x3a\x3anew_handler nh = std\x3a\x3aget_new_handler();\x0a"
"        if (nh)\x0a"
"            nh();\x0a"
"        else\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"            throw std\x3a\x3a""bad_alloc();\x0a"
"#else\x0a"
"            break;\x0a"
"#endif\x0a"
"    }\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void*\x0a"
"operator new(size_t size, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    void* p = 0;\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCXXABI_NO_EXCEPTIONS\x0a"
"        p = \x3a\x3aoperator new(size);\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"    }\x0a"
"#endif  // _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void*\x0a"
"operator new\x5b\x5d(size_t size) _THROW_BAD_ALLOC\x0a"
"{\x0a"
"    return \x3a\x3aoperator new(size);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void*\x0a"
"operator new\x5b\x5d(size_t size, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    void* p = 0;\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCXXABI_NO_EXCEPTIONS\x0a"
"        p = \x3a\x3aoperator new\x5b\x5d(size);\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"    }\x0a"
"#endif  // _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr) _NOEXCEPT\x0a"
"{\x0a"
"    if (ptr)\x0a"
"        \x3a\x3a""free(ptr);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr, size_t) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete\x5b\x5d(ptr);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr, size_t) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete\x5b\x5d(ptr);\x0a"
"}\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_LIBRARY_ALIGNED_ALLOCATION)\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void *\x0a"
"operator new(std\x3a\x3asize_t size, std\x3a\x3a""align_val_t alignment) _THROW_BAD_ALLOC\x0a"
"{\x0a"
"    if (size == 0)\x0a"
"        size = 1;\x0a"
"    if (static_cast<size_t>(alignment) < sizeof(void*))\x0a"
"      alignment = std\x3a\x3a""align_val_t(sizeof(void*));\x0a"
"    void* p;\x0a"
"#if defined(_LIBCPP_WIN32API)\x0a"
"    while ((p = _aligned_malloc(size, static_cast<size_t>(alignment))) == nullptr)\x0a"
"#else\x0a"
"    while (\x3a\x3aposix_memalign(\x26p, static_cast<size_t>(alignment), size) \x21= 0)\x0a"
"#endif\x0a"
"    {\x0a"
"        // If posix_memalign fails and there is a new_handler,\x0a"
"        // call it to try free up memory.\x0a"
"        std\x3a\x3anew_handler nh = std\x3a\x3aget_new_handler();\x0a"
"        if (nh)\x0a"
"            nh();\x0a"
"        else {\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"            throw std\x3a\x3a""bad_alloc();\x0a"
"#else\x0a"
"            p = nullptr; // posix_memalign doesn't initialize 'p' on failure\x0a"
"            break;\x0a"
"#endif\x0a"
"        }\x0a"
"    }\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void*\x0a"
"operator new(size_t size, std\x3a\x3a""align_val_t alignment, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    void* p = 0;\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCXXABI_NO_EXCEPTIONS\x0a"
"        p = \x3a\x3aoperator new(size, alignment);\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"    }\x0a"
"#endif  // _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void*\x0a"
"operator new\x5b\x5d(size_t size, std\x3a\x3a""align_val_t alignment) _THROW_BAD_ALLOC\x0a"
"{\x0a"
"    return \x3a\x3aoperator new(size, alignment);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void*\x0a"
"operator new\x5b\x5d(size_t size, std\x3a\x3a""align_val_t alignment, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    void* p = 0;\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCXXABI_NO_EXCEPTIONS\x0a"
"        p = \x3a\x3aoperator new\x5b\x5d(size, alignment);\x0a"
"#ifndef _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"    }\x0a"
"#endif  // _LIBCXXABI_NO_EXCEPTIONS\x0a"
"    return p;\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr, std\x3a\x3a""align_val_t) _NOEXCEPT\x0a"
"{\x0a"
"    if (ptr)\x0a"
"#if defined(_LIBCPP_WIN32API)\x0a"
"        \x3a\x3a_aligned_free(ptr);\x0a"
"#else\x0a"
"        \x3a\x3a""free(ptr);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr, std\x3a\x3a""align_val_t alignment, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr, alignment);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete(void* ptr, size_t, std\x3a\x3a""align_val_t alignment) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr, alignment);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr, std\x3a\x3a""align_val_t alignment) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete(ptr, alignment);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr, std\x3a\x3a""align_val_t alignment, const std\x3a\x3anothrow_t\x26) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete\x5b\x5d(ptr, alignment);\x0a"
"}\x0a"
"\x0a"
"_LIBCXXABI_WEAK\x0a"
"void\x0a"
"operator delete\x5b\x5d (void* ptr, size_t, std\x3a\x3a""align_val_t alignment) _NOEXCEPT\x0a"
"{\x0a"
"    \x3a\x3aoperator delete\x5b\x5d(ptr, alignment);\x0a"
"}\x0a"
"\x0a"
"#endif // \x21_LIBCPP_HAS_NO_LIBRARY_ALIGNED_ALLOCATION\x0a"
"", 5608 ); }