#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_b_exp__D_c( 
"/*\x09\x24OpenBSD\x3a b_exp__D.c,v 1.5 2009/10/27 23\x3a""59\x3a""29 deraadt Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 1985, 1993\x0a"
" *\x09The Regents of the University of California.  All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" * 3. Neither the name of the University nor the names of its contributors\x0a"
" *    may be used to endorse or promote products derived from this software\x0a"
" *    without specific prior written permission.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"/* EXP(X)\x0a"
" * RETURN THE EXPONENTIAL OF X\x0a"
" * DOUBLE PRECISION (IEEE 53 bits, VAX D FORMAT 56 BITS)\x0a"
" * CODED IN C BY K.C. NG, 1/19/85;\x0a"
" * REVISED BY K.C. NG on 2/6/85, 2/15/85, 3/7/85, 3/24/85, 4/16/85, 6/14/86.\x0a"
" *\x0a"
" * Required system supported functions\x3a\x0a"
" *\x09scalb(x,n)\x0a"
" *\x09""copysign(x,y)\x0a"
" *\x09""finite(x)\x0a"
" *\x0a"
" * Method\x3a\x0a"
" *\x09""1. Argument Reduction\x3a given the input x, find r and integer k such\x0a"
" *\x09   that\x0a"
" *\x09                   x = k*ln2 + r,  \x7cr\x7c <= 0.5*ln2 .\x0a"
" *\x09   r will be represented as r \x3a= z+c for better accuracy.\x0a"
" *\x0a"
" *\x09""2. Compute exp(r) by\x0a"
" *\x0a"
" *\x09\x09""exp(r) = 1 + r + r*R1/(2-R1),\x0a"
" *\x09   where\x0a"
" *\x09\x09R1 = x - x^2*(p1+x^2*(p2+x^2*(p3+x^2*(p4+p5*x^2)))).\x0a"
" *\x0a"
" *\x09""3. exp(x) = 2^k * exp(r) .\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09""exp(INF) is INF, exp(NaN) is NaN;\x0a"
" *\x09""exp(-INF)=  0;\x0a"
" *\x09""for finite argument, only exp(0)=1 is exact.\x0a"
" *\x0a"
" * Accuracy\x3a\x0a"
" *\x09""exp(x) returns the exponential of x nearly rounded. In a test run\x0a"
" *\x09with 1,156,000 random arguments on a VAX, the maximum observed\x0a"
" *\x09""error was 0.869 ulps (units in the last place).\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double p1 = 0x1.555555555553ep-3;\x0a"
"static const double p2 = -0x1.6c16c16bebd93p-9;\x0a"
"static const double p3 = 0x1.1566aaf25de2cp-14;\x0a"
"static const double p4 = -0x1.bbd41c5d26bf1p-20;\x0a"
"static const double p5 = 0x1.6376972bea4d0p-25;\x0a"
"static const double ln2hi = 0x1.62e42fee00000p-1;\x0a"
"static const double ln2lo = 0x1.a39ef35793c76p-33;\x0a"
"static const double lnhuge = 0x1.6602b15b7ecf2p9;\x0a"
"static const double lntiny = -0x1.77af8ebeae354p9;\x0a"
"static const double invln2 = 0x1.71547652b82fep0;\x0a"
"\x0a"
"/* returns exp(r = x + c) for \x7c""c\x7c < \x7cx\x7c with no overlap.  */\x0a"
"\x0a"
"double\x0a"
"__exp__D(double x, double c)\x0a"
"{\x0a"
"\x09""double z, hi, lo;\x0a"
"\x09int k;\x0a"
"\x0a"
"\x09if (isnan(x))\x09/* x is NaN */\x0a"
"\x09\x09return(x);\x0a"
"\x09if ( x <= lnhuge ) {\x0a"
"\x09\x09if ( x >= lntiny ) {\x0a"
"\x0a"
"\x09\x09    /* argument reduction \x3a x --> x - k*ln2 */\x0a"
"\x09\x09\x09z = invln2*x;\x0a"
"\x09\x09\x09k = z + copysign(.5, x);\x0a"
"\x0a"
"\x09\x09    /* express (x+c)-k*ln2 as hi-lo and let x=hi-lo rounded */\x0a"
"\x0a"
"\x09\x09\x09hi=(x-k*ln2hi);\x09\x09\x09/* Exact. */\x0a"
"\x09\x09\x09x= hi - (lo = k*ln2lo-c);\x0a"
"\x09\x09    /* return 2^k*\x5b""1+x+x*c/(2+c)\x5d  */\x0a"
"\x09\x09\x09z=x*x;\x0a"
"\x09\x09\x09""c= x - z*(p1+z*(p2+z*(p3+z*(p4+z*p5))));\x0a"
"\x09\x09\x09""c = (x*c)/(2.0-c);\x0a"
"\x0a"
"\x09\x09\x09return  scalb(1.+(hi-(lo - c)), k);\x0a"
"\x09\x09}\x0a"
"\x09\x09/* end of x > lntiny */\x0a"
"\x0a"
"\x09\x09""else\x0a"
"\x09\x09     /* exp(-big#) underflows to zero */\x0a"
"\x09\x09     if(finite(x))  return(scalb(1.0,-5000));\x0a"
"\x0a"
"\x09\x09     /* exp(-INF) is zero */\x0a"
"\x09\x09     else return(0.0);\x0a"
"\x09}\x0a"
"\x09/* end of x < lnhuge */\x0a"
"\x0a"
"\x09""else\x0a"
"\x09/* exp(INF) is INF, exp(+big#) overflows to INF */\x0a"
"\x09    return( finite(x) \x3f  scalb(1.0,5000)  \x3a x);\x0a"
"}\x0a"
"", 4127 ); }