#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_b_log__D_c( 
"/*\x09\x24OpenBSD\x3a b_log__D.c,v 1.4 2009/10/27 23\x3a""59\x3a""29 deraadt Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 1992, 1993\x0a"
" *\x09The Regents of the University of California.  All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" * 3. Neither the name of the University nor the names of its contributors\x0a"
" *    may be used to endorse or promote products derived from this software\x0a"
" *    without specific prior written permission.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/* Table-driven natural logarithm.\x0a"
" *\x0a"
" * This code was derived, with minor modifications, from\x3a\x0a"
" *\x09Peter Tang, \x22Table-Driven Implementation of the\x0a"
" *\x09Logarithm in IEEE Floating-Point arithmetic.\x22 ACM Trans.\x0a"
" *\x09Math Software, vol 16. no 4, pp 378-400, Dec 1990).\x0a"
" *\x0a"
" * Calculates log(2^m*F*(1+f/F)), \x7c""f/j\x7c <= 1/256,\x0a"
" * where F = j/128 for j an integer in \x5b""0, 128\x5d.\x0a"
" *\x0a"
" * log(2^m) = log2_hi*m + log2_tail*m\x0a"
" * since m is an integer, the dominant term is exact.\x0a"
" * m has at most 10 digits (for subnormal numbers),\x0a"
" * and log2_hi has 11 trailing zero bits.\x0a"
" *\x0a"
" * log(F) = logF_hi\x5bj\x5d + logF_lo\x5bj\x5d is in tabular form in log_table.h\x0a"
" * logF_hi\x5b\x5d + 512 is exact.\x0a"
" *\x0a"
" * log(1+f/F) = 2*f/(2*F + f) + 1/12 * (2*f/(2*F + f))**3 + ...\x0a"
" * the leading term is calculated to extra precision in two\x0a"
" * parts, the larger of which adds exactly to the dominant\x0a"
" * m and F terms.\x0a"
" * There are two cases\x3a\x0a"
" *\x09""1. when m, j are non-zero (m \x7c j), use absolute\x0a"
" *\x09   precision for the leading term.\x0a"
" *\x09""2. when m = j = 0, \x7c""1-x\x7c < 1/256, and log(x) \x7e= (x-1).\x0a"
" *\x09   In this case, use a relative precision of 24 bits.\x0a"
" * (This is done differently in the original paper)\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09""0\x09return signalling -Inf\x0a"
" *\x09neg\x09return signalling NaN\x0a"
" *\x09+Inf\x09return +Inf\x0a"
"*/\x0a"
"\x0a"
"#define N 128\x0a"
"\x0a"
"/* Table of log(Fj) = logF_head\x5bj\x5d + logF_tail\x5bj\x5d, for Fj = 1+j/128.\x0a"
" * Used for generation of extend precision logarithms.\x0a"
" * The constant 35184372088832 is 2^45, so the divide is exact.\x0a"
" * It ensures correct reading of logF_head, even for inaccurate\x0a"
" * decimal-to-binary conversion routines.  (Everybody gets the\x0a"
" * right answer for integers less than 2^53.)\x0a"
" * Values for log(F) were generated using error < 10^-57 absolute\x0a"
" * with the bc -l package.\x0a"
"*/\x0a"
"static const double\x09""A1 = \x09  .08333333333333178827;\x0a"
"static const double\x09""A2 = \x09  .01250000000377174923;\x0a"
"static const double\x09""A3 =\x09 .002232139987919447809;\x0a"
"static const double\x09""A4 =\x09.0004348877777076145742;\x0a"
"\x0a"
"static const double logF_head\x5bN+1\x5d = {\x0a"
"\x09""0.,\x0a"
"\x09.007782140442060381246,\x0a"
"\x09.015504186535963526694,\x0a"
"\x09.023167059281547608406,\x0a"
"\x09.030771658666765233647,\x0a"
"\x09.038318864302141264488,\x0a"
"\x09.045809536031242714670,\x0a"
"\x09.053244514518837604555,\x0a"
"\x09.060624621816486978786,\x0a"
"\x09.067950661908525944454,\x0a"
"\x09.075223421237524235039,\x0a"
"\x09.082443669210988446138,\x0a"
"\x09.089612158689760690322,\x0a"
"\x09.096729626458454731618,\x0a"
"\x09.103796793681567578460,\x0a"
"\x09.110814366340264314203,\x0a"
"\x09.117783035656430001836,\x0a"
"\x09.124703478501032805070,\x0a"
"\x09.131576357788617315236,\x0a"
"\x09.138402322859292326029,\x0a"
"\x09.145182009844575077295,\x0a"
"\x09.151916042025732167530,\x0a"
"\x09.158605030176659056451,\x0a"
"\x09.165249572895390883786,\x0a"
"\x09.171850256926518341060,\x0a"
"\x09.178407657472689606947,\x0a"
"\x09.184922338493834104156,\x0a"
"\x09.191394852999565046047,\x0a"
"\x09.197825743329758552135,\x0a"
"\x09.204215541428766300668,\x0a"
"\x09.210564769107350002741,\x0a"
"\x09.216873938300523150246,\x0a"
"\x09.223143551314024080056,\x0a"
"\x09.229374101064877322642,\x0a"
"\x09.235566071312860003672,\x0a"
"\x09.241719936886966024758,\x0a"
"\x09.247836163904594286577,\x0a"
"\x09.253915209980732470285,\x0a"
"\x09.259957524436686071567,\x0a"
"\x09.265963548496984003577,\x0a"
"\x09.271933715484010463114,\x0a"
"\x09.277868451003087102435,\x0a"
"\x09.283768173130738432519,\x0a"
"\x09.289633292582948342896,\x0a"
"\x09.295464212893421063199,\x0a"
"\x09.301261330578199704177,\x0a"
"\x09.307025035294827830512,\x0a"
"\x09.312755710004239517729,\x0a"
"\x09.318453731118097493890,\x0a"
"\x09.324119468654316733591,\x0a"
"\x09.329753286372579168528,\x0a"
"\x09.335355541920762334484,\x0a"
"\x09.340926586970454081892,\x0a"
"\x09.346466767346100823488,\x0a"
"\x09.351976423156884266063,\x0a"
"\x09.357455888922231679316,\x0a"
"\x09.362905493689140712376,\x0a"
"\x09.368325561158599157352,\x0a"
"\x09.373716409793814818840,\x0a"
"\x09.379078352934811846353,\x0a"
"\x09.384411698910298582632,\x0a"
"\x09.389716751140440464951,\x0a"
"\x09.394993808240542421117,\x0a"
"\x09.400243164127459749579,\x0a"
"\x09.405465108107819105498,\x0a"
"\x09.410659924985338875558,\x0a"
"\x09.415827895143593195825,\x0a"
"\x09.420969294644237379543,\x0a"
"\x09.426084395310681429691,\x0a"
"\x09.431173464818130014464,\x0a"
"\x09.436236766774527495726,\x0a"
"\x09.441274560805140936281,\x0a"
"\x09.446287102628048160113,\x0a"
"\x09.451274644139630254358,\x0a"
"\x09.456237433481874177232,\x0a"
"\x09.461175715122408291790,\x0a"
"\x09.466089729924533457960,\x0a"
"\x09.470979715219073113985,\x0a"
"\x09.475845904869856894947,\x0a"
"\x09.480688529345570714212,\x0a"
"\x09.485507815781602403149,\x0a"
"\x09.490303988045525329653,\x0a"
"\x09.495077266798034543171,\x0a"
"\x09.499827869556611403822,\x0a"
"\x09.504556010751912253908,\x0a"
"\x09.509261901790523552335,\x0a"
"\x09.513945751101346104405,\x0a"
"\x09.518607764208354637958,\x0a"
"\x09.523248143765158602036,\x0a"
"\x09.527867089620485785417,\x0a"
"\x09.532464798869114019908,\x0a"
"\x09.537041465897345915436,\x0a"
"\x09.541597282432121573947,\x0a"
"\x09.546132437597407260909,\x0a"
"\x09.550647117952394182793,\x0a"
"\x09.555141507540611200965,\x0a"
"\x09.559615787935399566777,\x0a"
"\x09.564070138285387656651,\x0a"
"\x09.568504735352689749561,\x0a"
"\x09.572919753562018740922,\x0a"
"\x09.577315365035246941260,\x0a"
"\x09.581691739635061821900,\x0a"
"\x09.586049045003164792433,\x0a"
"\x09.590387446602107957005,\x0a"
"\x09.594707107746216934174,\x0a"
"\x09.599008189645246602594,\x0a"
"\x09.603290851438941899687,\x0a"
"\x09.607555250224322662688,\x0a"
"\x09.611801541106615331955,\x0a"
"\x09.616029877215623855590,\x0a"
"\x09.620240409751204424537,\x0a"
"\x09.624433288012369303032,\x0a"
"\x09.628608659422752680256,\x0a"
"\x09.632766669570628437213,\x0a"
"\x09.636907462236194987781,\x0a"
"\x09.641031179420679109171,\x0a"
"\x09.645137961373620782978,\x0a"
"\x09.649227946625615004450,\x0a"
"\x09.653301272011958644725,\x0a"
"\x09.657358072709030238911,\x0a"
"\x09.661398482245203922502,\x0a"
"\x09.665422632544505177065,\x0a"
"\x09.669430653942981734871,\x0a"
"\x09.673422675212350441142,\x0a"
"\x09.677398823590920073911,\x0a"
"\x09.681359224807238206267,\x0a"
"\x09.685304003098281100392,\x0a"
"\x09.689233281238557538017,\x0a"
"\x09.693147180560117703862\x0a"
"};\x0a"
"\x0a"
"static const double logF_tail\x5bN+1\x5d = {\x0a"
"\x09""0.,\x0a"
"\x09-.00000000000000543229938420049,\x0a"
"\x09 .00000000000000172745674997061,\x0a"
"\x09-.00000000000001323017818229233,\x0a"
"\x09-.00000000000001154527628289872,\x0a"
"\x09-.00000000000000466529469958300,\x0a"
"\x09 .00000000000005148849572685810,\x0a"
"\x09-.00000000000002532168943117445,\x0a"
"\x09-.00000000000005213620639136504,\x0a"
"\x09-.00000000000001819506003016881,\x0a"
"\x09 .00000000000006329065958724544,\x0a"
"\x09 .00000000000008614512936087814,\x0a"
"\x09-.00000000000007355770219435028,\x0a"
"\x09 .00000000000009638067658552277,\x0a"
"\x09 .00000000000007598636597194141,\x0a"
"\x09 .00000000000002579999128306990,\x0a"
"\x09-.00000000000004654729747598444,\x0a"
"\x09-.00000000000007556920687451336,\x0a"
"\x09 .00000000000010195735223708472,\x0a"
"\x09-.00000000000017319034406422306,\x0a"
"\x09-.00000000000007718001336828098,\x0a"
"\x09 .00000000000010980754099855238,\x0a"
"\x09-.00000000000002047235780046195,\x0a"
"\x09-.00000000000008372091099235912,\x0a"
"\x09 .00000000000014088127937111135,\x0a"
"\x09 .00000000000012869017157588257,\x0a"
"\x09 .00000000000017788850778198106,\x0a"
"\x09 .00000000000006440856150696891,\x0a"
"\x09 .00000000000016132822667240822,\x0a"
"\x09-.00000000000007540916511956188,\x0a"
"\x09-.00000000000000036507188831790,\x0a"
"\x09 .00000000000009120937249914984,\x0a"
"\x09 .00000000000018567570959796010,\x0a"
"\x09-.00000000000003149265065191483,\x0a"
"\x09-.00000000000009309459495196889,\x0a"
"\x09 .00000000000017914338601329117,\x0a"
"\x09-.00000000000001302979717330866,\x0a"
"\x09 .00000000000023097385217586939,\x0a"
"\x09 .00000000000023999540484211737,\x0a"
"\x09 .00000000000015393776174455408,\x0a"
"\x09-.00000000000036870428315837678,\x0a"
"\x09 .00000000000036920375082080089,\x0a"
"\x09-.00000000000009383417223663699,\x0a"
"\x09 .00000000000009433398189512690,\x0a"
"\x09 .00000000000041481318704258568,\x0a"
"\x09-.00000000000003792316480209314,\x0a"
"\x09 .00000000000008403156304792424,\x0a"
"\x09-.00000000000034262934348285429,\x0a"
"\x09 .00000000000043712191957429145,\x0a"
"\x09-.00000000000010475750058776541,\x0a"
"\x09-.00000000000011118671389559323,\x0a"
"\x09 .00000000000037549577257259853,\x0a"
"\x09 .00000000000013912841212197565,\x0a"
"\x09 .00000000000010775743037572640,\x0a"
"\x09 .00000000000029391859187648000,\x0a"
"\x09-.00000000000042790509060060774,\x0a"
"\x09 .00000000000022774076114039555,\x0a"
"\x09 .00000000000010849569622967912,\x0a"
"\x09-.00000000000023073801945705758,\x0a"
"\x09 .00000000000015761203773969435,\x0a"
"\x09 .00000000000003345710269544082,\x0a"
"\x09-.00000000000041525158063436123,\x0a"
"\x09 .00000000000032655698896907146,\x0a"
"\x09-.00000000000044704265010452446,\x0a"
"\x09 .00000000000034527647952039772,\x0a"
"\x09-.00000000000007048962392109746,\x0a"
"\x09 .00000000000011776978751369214,\x0a"
"\x09-.00000000000010774341461609578,\x0a"
"\x09 .00000000000021863343293215910,\x0a"
"\x09 .00000000000024132639491333131,\x0a"
"\x09 .00000000000039057462209830700,\x0a"
"\x09-.00000000000026570679203560751,\x0a"
"\x09 .00000000000037135141919592021,\x0a"
"\x09-.00000000000017166921336082431,\x0a"
"\x09-.00000000000028658285157914353,\x0a"
"\x09-.00000000000023812542263446809,\x0a"
"\x09 .00000000000006576659768580062,\x0a"
"\x09-.00000000000028210143846181267,\x0a"
"\x09 .00000000000010701931762114254,\x0a"
"\x09 .00000000000018119346366441110,\x0a"
"\x09 .00000000000009840465278232627,\x0a"
"\x09-.00000000000033149150282752542,\x0a"
"\x09-.00000000000018302857356041668,\x0a"
"\x09-.00000000000016207400156744949,\x0a"
"\x09 .00000000000048303314949553201,\x0a"
"\x09-.00000000000071560553172382115,\x0a"
"\x09 .00000000000088821239518571855,\x0a"
"\x09-.00000000000030900580513238244,\x0a"
"\x09-.00000000000061076551972851496,\x0a"
"\x09 .00000000000035659969663347830,\x0a"
"\x09 .00000000000035782396591276383,\x0a"
"\x09-.00000000000046226087001544578,\x0a"
"\x09 .00000000000062279762917225156,\x0a"
"\x09 .00000000000072838947272065741,\x0a"
"\x09 .00000000000026809646615211673,\x0a"
"\x09-.00000000000010960825046059278,\x0a"
"\x09 .00000000000002311949383800537,\x0a"
"\x09-.00000000000058469058005299247,\x0a"
"\x09-.00000000000002103748251144494,\x0a"
"\x09-.00000000000023323182945587408,\x0a"
"\x09-.00000000000042333694288141916,\x0a"
"\x09-.00000000000043933937969737844,\x0a"
"\x09 .00000000000041341647073835565,\x0a"
"\x09 .00000000000006841763641591466,\x0a"
"\x09 .00000000000047585534004430641,\x0a"
"\x09 .00000000000083679678674757695,\x0a"
"\x09-.00000000000085763734646658640,\x0a"
"\x09 .00000000000021913281229340092,\x0a"
"\x09-.00000000000062242842536431148,\x0a"
"\x09-.00000000000010983594325438430,\x0a"
"\x09 .00000000000065310431377633651,\x0a"
"\x09-.00000000000047580199021710769,\x0a"
"\x09-.00000000000037854251265457040,\x0a"
"\x09 .00000000000040939233218678664,\x0a"
"\x09 .00000000000087424383914858291,\x0a"
"\x09 .00000000000025218188456842882,\x0a"
"\x09-.00000000000003608131360422557,\x0a"
"\x09-.00000000000050518555924280902,\x0a"
"\x09 .00000000000078699403323355317,\x0a"
"\x09-.00000000000067020876961949060,\x0a"
"\x09 .00000000000016108575753932458,\x0a"
"\x09 .00000000000058527188436251509,\x0a"
"\x09-.00000000000035246757297904791,\x0a"
"\x09-.00000000000018372084495629058,\x0a"
"\x09 .00000000000088606689813494916,\x0a"
"\x09 .00000000000066486268071468700,\x0a"
"\x09 .00000000000063831615170646519,\x0a"
"\x09 .00000000000025144230728376072,\x0a"
"\x09-.00000000000017239444525614834\x0a"
"};\x0a"
"\x0a"
"/*\x0a"
" * Extra precision variant, returning struct {double a, b;};\x0a"
" * log(x) = a+b to 63 bits, with a rounded to 26 bits.\x0a"
" */\x0a"
"struct Double\x0a"
"__log__D(double x)\x0a"
"{\x0a"
"\x09int m, j;\x0a"
"\x09""double F, f, g, q, u, v, u2;\x0a"
"\x09volatile double u1;\x0a"
"\x09struct Double r;\x0a"
"\x0a"
"\x09/* Argument reduction\x3a 1 <= g < 2; x/2^m = g;\x09*/\x0a"
"\x09/* y = F*(1 + f/F) for \x7c""f\x7c <= 2^-8\x09\x09*/\x0a"
"\x0a"
"\x09m = logb(x);\x0a"
"\x09g = ldexp(x, -m);\x0a"
"\x09if (m == -1022) {\x0a"
"\x09\x09j = logb(g);\x0a"
"\x09\x09m += j;\x0a"
"\x09\x09g = ldexp(g, -j);\x0a"
"\x09}\x0a"
"\x09j = N*(g-1) + .5;\x0a"
"\x09""F = (1.0/N) * j + 1;\x0a"
"\x09""f = g - F;\x0a"
"\x0a"
"\x09g = 1/(2*F+f);\x0a"
"\x09u = 2*f*g;\x0a"
"\x09v = u*u;\x0a"
"\x09q = u*v*(A1 + v*(A2 + v*(A3 + v*A4)));\x0a"
"\x09if (m \x7c j) {\x0a"
"\x09\x09u1 = u + 513;\x0a"
"\x09\x09u1 -= 513;\x0a"
"\x09}\x0a"
"\x09""else {\x0a"
"\x09\x09u1 = u;\x0a"
"\x09\x09TRUNC(u1);\x0a"
"\x09}\x0a"
"\x09u2 = (2.0*(f - F*u1) - u1*f) * g;\x0a"
"\x0a"
"\x09u1 += m*logF_head\x5bN\x5d + logF_head\x5bj\x5d;\x0a"
"\x0a"
"\x09u2 +=  logF_tail\x5bj\x5d; u2 += q;\x0a"
"\x09u2 += logF_tail\x5bN\x5d*m;\x0a"
"\x09r.a = u1 + u2;\x09\x09\x09/* Only difference is here */\x0a"
"\x09TRUNC(r.a);\x0a"
"\x09r.b = (u1 - r.a) + u2;\x0a"
"\x09return (r);\x0a"
"}\x0a"
"", 12140 ); }