#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_b_tgamma_c( 
"/*\x09\x24OpenBSD\x3a b_tgamma.c,v 1.8 2013/07/03 04\x3a""46\x3a""36 espie Exp \x24\x09*/\x0a"
"/*-\x0a"
" * Copyright (c) 1992, 1993\x0a"
" *\x09The Regents of the University of California.  All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" * 3. Neither the name of the University nor the names of its contributors\x0a"
" *    may be used to endorse or promote products derived from this software\x0a"
" *    without specific prior written permission.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * This code by P. McIlroy, Oct 1992;\x0a"
" *\x0a"
" * The financial support of UUNET Communications Services is greatfully\x0a"
" * acknowledged.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/* METHOD\x3a\x0a"
" * x < 0\x3a Use reflection formula, G(x) = pi/(sin(pi*x)*x*G(x))\x0a"
" *\x09""At negative integers, return NaN and raise invalid.\x0a"
" *\x0a"
" * x < 6.5\x3a\x0a"
" *\x09Use argument reduction G(x+1) = xG(x) to reach the\x0a"
" *\x09range \x5b""1.066124,2.066124\x5d.  Use a rational\x0a"
" *\x09""approximation centered at the minimum (x0+1) to\x0a"
" *\x09""ensure monotonicity.\x0a"
" *\x0a"
" * x >= 6.5\x3a Use the asymptotic approximation (Stirling's formula)\x0a"
" *\x09""adjusted for equal-ripples\x3a\x0a"
" *\x0a"
" *\x09log(G(x)) \x7e= (x-.5)*(log(x)-1) + .5(log(2*pi)-1) + 1/x*P(1/(x*x))\x0a"
" *\x0a"
" *\x09Keep extra precision in multiplying (x-.5)(log(x)-1), to\x0a"
" *\x09""avoid premature round-off.\x0a"
" *\x0a"
" * Special values\x3a\x0a"
" *\x09-Inf\x3a\x09\x09\x09return NaN and raise invalid;\x0a"
" *\x09negative integer\x3a\x09return NaN and raise invalid;\x0a"
" *\x09other x \x7e< -177.79\x3a\x09return +-0 and raise underflow;\x0a"
" *\x09+-0\x3a\x09\x09\x09return +-Inf and raise divide-by-zero;\x0a"
" *\x09""finite x \x7e> 171.63\x3a\x09return +Inf and raise overflow;\x0a"
" *\x09+Inf\x3a\x09\x09\x09return +Inf;\x0a"
" *\x09NaN\x3a \x09\x09\x09return NaN.\x0a"
" *\x0a"
" * Accuracy\x3a tgamma(x) is accurate to within\x0a"
" *\x09x > 0\x3a  error provably < 0.9ulp.\x0a"
" *\x09Maximum observed in 1,000,000 trials was .87ulp.\x0a"
" *\x09x < 0\x3a\x0a"
" *\x09Maximum observed error < 4ulp in 1,000,000 trials.\x0a"
" */\x0a"
"\x0a"
"static double neg_gam(double);\x0a"
"static double small_gam(double);\x0a"
"static double smaller_gam(double);\x0a"
"static struct Double large_gam(double);\x0a"
"static struct Double ratfun_gam(double, double);\x0a"
"\x0a"
"/*\x0a"
" * Rational approximation, A0 + x*x*P(x)/Q(x), on the interval\x0a"
" * \x5b""1.066.., 2.066..\x5d accurate to 4.25e-19.\x0a"
" */\x0a"
"#define LEFT -.3955078125\x09/* left boundary for rat. approx */\x0a"
"#define x0 .461632144968362356785\x09/* xmin - 1 */\x0a"
"\x0a"
"#define a0_hi 0.88560319441088874992\x0a"
"#define a0_lo -.00000000000000004996427036469019695\x0a"
"#define P0\x09 6.21389571821820863029017800727e-01\x0a"
"#define P1\x09 2.65757198651533466104979197553e-01\x0a"
"#define P2\x09 5.53859446429917461063308081748e-03\x0a"
"#define P3\x09 1.38456698304096573887145282811e-03\x0a"
"#define P4\x09 2.40659950032711365819348969808e-03\x0a"
"#define Q0\x09 1.45019531250000000000000000000e+00\x0a"
"#define Q1\x09 1.06258521948016171343454061571e+00\x0a"
"#define Q2\x09-2.07474561943859936441469926649e-01\x0a"
"#define Q3\x09-1.46734131782005422506287573015e-01\x0a"
"#define Q4\x09 3.07878176156175520361557573779e-02\x0a"
"#define Q5\x09 5.12449347980666221336054633184e-03\x0a"
"#define Q6\x09-1.76012741431666995019222898833e-03\x0a"
"#define Q7\x09 9.35021023573788935372153030556e-05\x0a"
"#define Q8\x09 6.13275507472443958924745652239e-06\x0a"
"/*\x0a"
" * Constants for large x approximation (x in \x5b""6, Inf\x5d)\x0a"
" * (Accurate to 2.8*10^-19 absolute)\x0a"
" */\x0a"
"#define lns2pi_hi 0.418945312500000\x0a"
"#define lns2pi_lo -.000006779295327258219670263595\x0a"
"#define Pa0\x09 8.33333333333333148296162562474e-02\x0a"
"#define Pa1\x09-2.77777777774548123579378966497e-03\x0a"
"#define Pa2\x09 7.93650778754435631476282786423e-04\x0a"
"#define Pa3\x09-5.95235082566672847950717262222e-04\x0a"
"#define Pa4\x09 8.41428560346653702135821806252e-04\x0a"
"#define Pa5\x09-1.89773526463879200348872089421e-03\x0a"
"#define Pa6\x09 5.69394463439411649408050664078e-03\x0a"
"#define Pa7\x09-1.44705562421428915453880392761e-02\x0a"
"\x0a"
"static const double zero = 0., one = 1.0, tiny = 1e-300;\x0a"
"\x0a"
"double\x0a"
"tgamma(double x)\x0a"
"{\x0a"
"\x09struct Double u;\x0a"
"\x0a"
"\x09if (x >= 6) {\x0a"
"\x09\x09if(x > 171.63)\x0a"
"\x09\x09\x09return(x/zero);\x0a"
"\x09\x09u = large_gam(x);\x0a"
"\x09\x09return(__exp__D(u.a, u.b));\x0a"
"\x09} else if (x >= 1.0 + LEFT + x0)\x0a"
"\x09\x09return (small_gam(x));\x0a"
"\x09""else if (x > 1.e-17)\x0a"
"\x09\x09return (smaller_gam(x));\x0a"
"\x09""else if (x > -1.e-17) {\x0a"
"\x09\x09if (x \x21= 0.0)\x0a"
"\x09\x09\x09u.a = one - tiny;\x09/* raise inexact */\x0a"
"\x09\x09return (one/x);\x0a"
"\x09} else if (\x21""finite(x)) {\x0a"
"\x09\x09return (x - x);\x09\x09\x09/* x = NaN, -Inf */\x0a"
"\x09 } else\x0a"
"\x09\x09return (neg_gam(x));\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
" * We simply call tgamma() rather than bloating the math library\x0a"
" * with a float-optimized version of it.  The reason is that tgammaf()\x0a"
" * is essentially useless, since the function is superexponential\x0a"
" * and floats have very limited range.  -- das\x40""freebsd.org\x0a"
" */\x0a"
"\x0a"
"float\x0a"
"tgammaf(float x)\x0a"
"{\x0a"
"\x09return tgamma(x);\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
" * Accurate to max(ulp(1/128) absolute, 2^-66 relative) error.\x0a"
" */\x0a"
"\x0a"
"static struct Double\x0a"
"large_gam(double x)\x0a"
"{\x0a"
"\x09""double z, p;\x0a"
"\x09struct Double t, u, v;\x0a"
"\x0a"
"\x09z = one/(x*x);\x0a"
"\x09p = Pa0+z*(Pa1+z*(Pa2+z*(Pa3+z*(Pa4+z*(Pa5+z*(Pa6+z*Pa7))))));\x0a"
"\x09p = p/x;\x0a"
"\x0a"
"\x09u = __log__D(x);\x0a"
"\x09u.a -= one;\x0a"
"\x09v.a = (x -= .5);\x0a"
"\x09TRUNC(v.a);\x0a"
"\x09v.b = x - v.a;\x0a"
"\x09t.a = v.a*u.a;\x09\x09\x09/* t = (x-.5)*(log(x)-1) */\x0a"
"\x09t.b = v.b*u.a + x*u.b;\x0a"
"\x09/* return t.a + t.b + lns2pi_hi + lns2pi_lo + p */\x0a"
"\x09t.b += lns2pi_lo; t.b += p;\x0a"
"\x09u.a = lns2pi_hi + t.b; u.a += t.a;\x0a"
"\x09u.b = t.a - u.a;\x0a"
"\x09u.b += lns2pi_hi; u.b += t.b;\x0a"
"\x09return (u);\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
" * Good to < 1 ulp.  (provably .90 ulp; .87 ulp on 1,000,000 runs.)\x0a"
" * It also has correct monotonicity.\x0a"
" */\x0a"
"\x0a"
"static double\x0a"
"small_gam(double x)\x0a"
"{\x0a"
"\x09""double y, ym1, t;\x0a"
"\x09struct Double yy, r;\x0a"
"\x09y = x - one;\x0a"
"\x09ym1 = y - one;\x0a"
"\x09if (y <= 1.0 + (LEFT + x0)) {\x0a"
"\x09\x09yy = ratfun_gam(y - x0, 0);\x0a"
"\x09\x09return (yy.a + yy.b);\x0a"
"\x09}\x0a"
"\x09r.a = y;\x0a"
"\x09TRUNC(r.a);\x0a"
"\x09yy.a = r.a - one;\x0a"
"\x09y = ym1;\x0a"
"\x09yy.b = r.b = y - yy.a;\x0a"
"\x09/* Argument reduction\x3a G(x+1) = x*G(x) */\x0a"
"\x09""for (ym1 = y-one; ym1 > LEFT + x0; y = ym1--, yy.a--) {\x0a"
"\x09\x09t = r.a*yy.a;\x0a"
"\x09\x09r.b = r.a*yy.b + y*r.b;\x0a"
"\x09\x09r.a = t;\x0a"
"\x09\x09TRUNC(r.a);\x0a"
"\x09\x09r.b += (t - r.a);\x0a"
"\x09}\x0a"
"\x09/* Return r*tgamma(y). */\x0a"
"\x09yy = ratfun_gam(y - x0, 0);\x0a"
"\x09y = r.b*(yy.a + yy.b) + r.a*yy.b;\x0a"
"\x09y += yy.a*r.a;\x0a"
"\x09return (y);\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
" * Good on (0, 1+x0+LEFT\x5d.  Accurate to 1ulp.\x0a"
" */\x0a"
"\x0a"
"static double\x0a"
"smaller_gam(double x)\x0a"
"{\x0a"
"\x09""double t, d;\x0a"
"\x09struct Double r, xx;\x0a"
"\x09if (x < x0 + LEFT) {\x0a"
"\x09\x09t = x;\x0a"
"\x09\x09TRUNC(t);\x0a"
"\x09\x09""d = (t+x)*(x-t);\x0a"
"\x09\x09t *= t;\x0a"
"\x09\x09xx.a = (t + x);\x0a"
"\x09\x09TRUNC(xx.a);\x0a"
"\x09\x09xx.b = x - xx.a; xx.b += t; xx.b += d;\x0a"
"\x09\x09t = (one-x0); t += x;\x0a"
"\x09\x09""d = (one-x0); d -= t; d += x;\x0a"
"\x09\x09x = xx.a + xx.b;\x0a"
"\x09} else {\x0a"
"\x09\x09xx.a =  x;\x0a"
"\x09\x09TRUNC(xx.a);\x0a"
"\x09\x09xx.b = x - xx.a;\x0a"
"\x09\x09t = x - x0;\x0a"
"\x09\x09""d = (-x0 -t); d += x;\x0a"
"\x09}\x0a"
"\x09r = ratfun_gam(t, d);\x0a"
"\x09""d = r.a/x;\x0a"
"\x09TRUNC(d);\x0a"
"\x09r.a -= d*xx.a; r.a -= d*xx.b; r.a += r.b;\x0a"
"\x09return (d + r.a/x);\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
" * returns (z+c)^2 * P(z)/Q(z) + a0\x0a"
" */\x0a"
"\x0a"
"static struct Double\x0a"
"ratfun_gam(double z, double c)\x0a"
"{\x0a"
"\x09""double p, q;\x0a"
"\x09struct Double r, t;\x0a"
"\x0a"
"\x09q = Q0 +z*(Q1+z*(Q2+z*(Q3+z*(Q4+z*(Q5+z*(Q6+z*(Q7+z*Q8)))))));\x0a"
"\x09p = P0 + z*(P1 + z*(P2 + z*(P3 + z*P4)));\x0a"
"\x0a"
"\x09/* return r.a + r.b = a0 + (z+c)^2*p/q, with r.a truncated to 26 bits. */\x0a"
"\x09p = p/q;\x0a"
"\x09t.a = z;\x0a"
"\x09TRUNC(t.a);\x09\x09\x09/* t \x7e= z + c */\x0a"
"\x09t.b = (z - t.a) + c;\x0a"
"\x09t.b *= (t.a + z);\x0a"
"\x09q = (t.a *= t.a);\x09\x09/* t = (z+c)^2 */\x0a"
"\x09TRUNC(t.a);\x0a"
"\x09t.b += (q - t.a);\x0a"
"\x09r.a = p;\x0a"
"\x09TRUNC(r.a);\x09\x09\x09/* r = P/Q */\x0a"
"\x09r.b = p - r.a;\x0a"
"\x09t.b = t.b*p + t.a*r.b + a0_lo;\x0a"
"\x09t.a *= r.a;\x09\x09\x09/* t = (z+c)^2*(P/Q) */\x0a"
"\x09r.a = t.a + a0_hi;\x0a"
"\x09TRUNC(r.a);\x0a"
"\x09r.b = ((a0_hi-r.a) + t.a) + t.b;\x0a"
"\x09return (r);\x09\x09\x09/* r = a0 + t */\x0a"
"}\x0a"
"\x0a"
"static double\x0a"
"neg_gam(double x)\x0a"
"{\x0a"
"\x09int sgn = 1;\x0a"
"\x09struct Double lg, lsine;\x0a"
"\x09""double y, z;\x0a"
"\x0a"
"\x09y = ceil(x);\x0a"
"\x09if (y == x)\x09\x09/* Negative integer. */\x0a"
"\x09\x09return ((x - x) / zero);\x0a"
"\x09z = y - x;\x0a"
"\x09if (z > 0.5)\x0a"
"\x09\x09z = one - z;\x0a"
"\x09y = 0.5 * y;\x0a"
"\x09if (y == ceil(y))\x0a"
"\x09\x09sgn = -1;\x0a"
"\x09if (z < .25)\x0a"
"\x09\x09z = sin(M_PI*z);\x0a"
"\x09""else\x0a"
"\x09\x09z = cos(M_PI*(0.5-z));\x0a"
"\x09/* Special case\x3a G(1-x) = Inf; G(x) may be nonzero. */\x0a"
"\x09if (x < -170) {\x0a"
"\x09\x09if (x < -190)\x0a"
"\x09\x09\x09return ((double)sgn*tiny*tiny);\x0a"
"\x09\x09y = one - x;\x09\x09/* exact\x3a 128 < \x7cx\x7c < 255 */\x0a"
"\x09\x09lg = large_gam(y);\x0a"
"\x09\x09lsine = __log__D(M_PI/z);\x09/* = TRUNC(log(u)) + small */\x0a"
"\x09\x09lg.a -= lsine.a;\x09\x09/* exact (opposite signs) */\x0a"
"\x09\x09lg.b -= lsine.b;\x0a"
"\x09\x09y = -(lg.a + lg.b);\x0a"
"\x09\x09z = (y + lg.a) + lg.b;\x0a"
"\x09\x09y = __exp__D(y, z);\x0a"
"\x09\x09if (sgn < 0) y = -y;\x0a"
"\x09\x09return (y);\x0a"
"\x09}\x0a"
"\x09y = one-x;\x0a"
"\x09if (one-y == x)\x0a"
"\x09\x09y = tgamma(y);\x0a"
"\x09""else\x09\x09/* 1-x is inexact */\x0a"
"\x09\x09y = -x*tgamma(-x);\x0a"
"\x09if (sgn < 0) y = -y;\x0a"
"\x09return (M_PI / (y*z));\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(tgammal, tgamma);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 9094 ); }