#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_acos_c( 
"/* \x40(#)e_acos.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* acos(x)\x0a"
" * Method \x3a                  \x0a"
" *\x09""acos(x)  = pi/2 - asin(x)\x0a"
" *\x09""acos(-x) = pi/2 + asin(x)\x0a"
" * For \x7cx\x7c<=0.5\x0a"
" *\x09""acos(x) = pi/2 - (x + x*x^2*R(x^2))\x09(see asin.c)\x0a"
" * For x>0.5\x0a"
" * \x09""acos(x) = pi/2 - (pi/2 - 2asin(sqrt((1-x)/2)))\x0a"
" *\x09\x09= 2asin(sqrt((1-x)/2))  \x0a"
" *\x09\x09= 2s + 2s*z*R(z) \x09...z=(1-x)/2, s=sqrt(z)\x0a"
" *\x09\x09= 2f + (2c + 2s*z*R(z))\x0a"
" *     where f=hi part of s, and c = (z-f*f)/(s+f) is the correction term\x0a"
" *     for f so that f+c \x7e sqrt(z).\x0a"
" * For x<-0.5\x0a"
" *\x09""acos(x) = pi - 2asin(sqrt((1-\x7cx\x7c)/2))\x0a"
" *\x09\x09= pi - 0.5*(s+s*z*R(z)), where z=(1-\x7cx\x7c)/2,s=sqrt(z)\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09if x is NaN, return x itself;\x0a"
" *\x09if \x7cx\x7c>1, return NaN with invalid signal.\x0a"
" *\x0a"
" * Function needed\x3a sqrt\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double \x0a"
"one=  1.00000000000000000000e+00, /* 0x3FF00000, 0x00000000 */\x0a"
"pi =  3.14159265358979311600e+00, /* 0x400921FB, 0x54442D18 */\x0a"
"pio2_hi =  1.57079632679489655800e+00, /* 0x3FF921FB, 0x54442D18 */\x0a"
"pio2_lo =  6.12323399573676603587e-17, /* 0x3C91A626, 0x33145C07 */\x0a"
"pS0 =  1.66666666666666657415e-01, /* 0x3FC55555, 0x55555555 */\x0a"
"pS1 = -3.25565818622400915405e-01, /* 0xBFD4D612, 0x03EB6F7D */\x0a"
"pS2 =  2.01212532134862925881e-01, /* 0x3FC9C155, 0x0E884455 */\x0a"
"pS3 = -4.00555345006794114027e-02, /* 0xBFA48228, 0xB5688F3B */\x0a"
"pS4 =  7.91534994289814532176e-04, /* 0x3F49EFE0, 0x7501B288 */\x0a"
"pS5 =  3.47933107596021167570e-05, /* 0x3F023DE1, 0x0DFDF709 */\x0a"
"qS1 = -2.40339491173441421878e+00, /* 0xC0033A27, 0x1C8A2D4B */\x0a"
"qS2 =  2.02094576023350569471e+00, /* 0x40002AE5, 0x9C598AC8 */\x0a"
"qS3 = -6.88283971605453293030e-01, /* 0xBFE6066C, 0x1B8D0159 */\x0a"
"qS4 =  7.70381505559019352791e-02; /* 0x3FB3B8C5, 0xB12E9282 */\x0a"
"\x0a"
"double\x0a"
"acos(double x)\x0a"
"{\x0a"
"\x09""double z,p,q,r,w,s,c,df;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x3ff00000) {\x09/* \x7cx\x7c >= 1 */\x0a"
"\x09    u_int32_t lx;\x0a"
"\x09    GET_LOW_WORD(lx,x);\x0a"
"\x09    if(((ix-0x3ff00000)\x7clx)==0) {\x09/* \x7cx\x7c==1 */\x0a"
"\x09\x09if(hx>0) return 0.0;\x09\x09/* acos(1) = 0  */\x0a"
"\x09\x09""else return pi+2.0*pio2_lo;\x09/* acos(-1)= pi */\x0a"
"\x09    }\x0a"
"\x09    return (x-x)/(x-x);\x09\x09/* acos(\x7cx\x7c>1) is NaN */\x0a"
"\x09}\x0a"
"\x09if(ix<0x3fe00000) {\x09/* \x7cx\x7c < 0.5 */\x0a"
"\x09    if(ix<=0x3c600000) return pio2_hi+pio2_lo;/*if\x7cx\x7c<2**-57*/\x0a"
"\x09    z = x*x;\x0a"
"\x09    p = z*(pS0+z*(pS1+z*(pS2+z*(pS3+z*(pS4+z*pS5)))));\x0a"
"\x09    q = one+z*(qS1+z*(qS2+z*(qS3+z*qS4)));\x0a"
"\x09    r = p/q;\x0a"
"\x09    return pio2_hi - (x - (pio2_lo-x*r));\x0a"
"\x09} else  if (hx<0) {\x09\x09/* x < -0.5 */\x0a"
"\x09    z = (one+x)*0.5;\x0a"
"\x09    p = z*(pS0+z*(pS1+z*(pS2+z*(pS3+z*(pS4+z*pS5)))));\x0a"
"\x09    q = one+z*(qS1+z*(qS2+z*(qS3+z*qS4)));\x0a"
"\x09    s = sqrt(z);\x0a"
"\x09    r = p/q;\x0a"
"\x09    w = r*s-pio2_lo;\x0a"
"\x09    return pi - 2.0*(s+w);\x0a"
"\x09} else {\x09\x09\x09/* x > 0.5 */\x0a"
"\x09    z = (one-x)*0.5;\x0a"
"\x09    s = sqrt(z);\x0a"
"\x09    df = s;\x0a"
"\x09    SET_LOW_WORD(df,0);\x0a"
"\x09    c  = (z-df*df)/(s+df);\x0a"
"\x09    p = z*(pS0+z*(pS1+z*(pS2+z*(pS3+z*(pS4+z*pS5)))));\x0a"
"\x09    q = one+z*(qS1+z*(qS2+z*(qS3+z*qS4)));\x0a"
"\x09    r = p/q;\x0a"
"\x09    w = r*s+c;\x0a"
"\x09    return 2.0*(df+w);\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(acosl, acos);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 3393 ); }