#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_acosh_c( 
"/* \x40(#)e_acosh.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* acosh(x)\x0a"
" * Method \x3a\x0a"
" *\x09""Based on \x0a"
" *\x09\x09""acosh(x) = log \x5b x + sqrt(x*x-1) \x5d\x0a"
" *\x09we have\x0a"
" *\x09\x09""acosh(x) \x3a= log(x)+ln2,\x09if x is large; else\x0a"
" *\x09\x09""acosh(x) \x3a= log(2x-1/(sqrt(x*x-1)+x)) if x>2; else\x0a"
" *\x09\x09""acosh(x) \x3a= log1p(t+sqrt(2.0*t+t*t)); where t=x-1.\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09""acosh(x) is NaN with signal if x<1.\x0a"
" *\x09""acosh(NaN) is NaN without signal.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double \x0a"
"one\x09= 1.0,\x0a"
"ln2\x09= 6.93147180559945286227e-01;  /* 0x3FE62E42, 0xFEFA39EF */\x0a"
"\x0a"
"double\x0a"
"acosh(double x)\x0a"
"{\x09\x0a"
"\x09""double t;\x0a"
"\x09int32_t hx;\x0a"
"\x09u_int32_t lx;\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"\x09if(hx<0x3ff00000) {\x09\x09/* x < 1 */\x0a"
"\x09    return (x-x)/(x-x);\x0a"
"\x09} else if(hx >=0x41b00000) {\x09/* x > 2**28 */\x0a"
"\x09    if(hx >=0x7ff00000) {\x09/* x is inf of NaN */\x0a"
"\x09        return x+x;\x0a"
"\x09    } else \x0a"
"\x09\x09return log(x)+ln2;\x09/* acosh(huge)=log(2x) */\x0a"
"\x09} else if(((hx-0x3ff00000)\x7clx)==0) {\x0a"
"\x09    return 0.0;\x09\x09\x09/* acosh(1) = 0 */\x0a"
"\x09} else if (hx > 0x40000000) {\x09/* 2**28 > x > 2 */\x0a"
"\x09    t=x*x;\x0a"
"\x09    return log(2.0*x-one/(x+sqrt(t-one)));\x0a"
"\x09} else {\x09\x09\x09/* 1<x<2 */\x0a"
"\x09    t = x-one;\x0a"
"\x09    return log1p(t+sqrt(2.0*t+t*t));\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(acoshl, acosh);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 1624 ); }