#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_acosl_c( 
"/*\x09\x24OpenBSD\x3a e_acosl.c,v 1.1 2008/12/09 20\x3a""00\x3a""35 martynas Exp \x24\x09*/\x0a"
"/* \x40(#)e_acos.c 1.3 95/01/18 */\x0a"
"/* FreeBSD\x3a head/lib/msun/src/e_acos.c 176451 2008-02-22 02\x3a""30\x3a""36Z das */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunSoft, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * See comments in e_acos.c.\x0a"
" * Converted to long double by David Schultz <das\x40""FreeBSD.ORG>.\x0a"
" * Adapted for OpenBSD by Martynas Venckus <martynas\x40openbsd.org>.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22invtrig.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"#ifdef EXT_IMPLICIT_NBIT\x0a"
"#define\x09LDBL_NBIT\x09""0\x0a"
"#else /* EXT_IMPLICIT_NBIT */\x0a"
"#define\x09LDBL_NBIT\x09""0x80000000\x0a"
"#endif /* EXT_IMPLICIT_NBIT */\x0a"
"\x0a"
"static const long double\x0a"
"one=  1.00000000000000000000e+00;\x0a"
"\x0a"
"#if defined(__amd64__) \x7c\x7c defined(__i386__)\x0a"
"/* XXX Work around the fact that gcc truncates long double constants on i386 */\x0a"
"static volatile double\x0a"
"pi1 =  3.14159265358979311600e+00,\x09/*  0x1.921fb54442d18p+1  */\x0a"
"pi2 =  1.22514845490862001043e-16;\x09/*  0x1.1a80000000000p-53 */\x0a"
"#define\x09pi\x09((long double)pi1 + pi2)\x0a"
"#else\x0a"
"static const long double\x0a"
"pi =  3.14159265358979323846264338327950280e+00L;\x0a"
"#endif\x0a"
"\x0a"
"long double\x0a"
"acosl(long double x)\x0a"
"{\x0a"
"\x09union {\x0a"
"\x09\x09long double e;\x0a"
"\x09\x09struct ieee_ext bits;\x0a"
"\x09} u;\x0a"
"\x09long double z,p,q,r,w,s,c,df;\x0a"
"\x09int16_t expsign, expt;\x0a"
"\x09u.e = x;\x0a"
"\x09""expsign = (u.bits.ext_sign << 15) \x7c u.bits.ext_exp;\x0a"
"\x09""expt = expsign \x26 0x7fff;\x0a"
"\x09if(expt >= BIAS) {\x09/* \x7cx\x7c >= 1 */\x0a"
"\x09    if(expt==BIAS \x26\x26 ((u.bits.ext_frach\x26\x7eLDBL_NBIT)\x0a"
"#ifdef EXT_FRACHMBITS\x0a"
"\x09\x09\x7c u.bits.ext_frachm\x0a"
"#endif /* EXT_FRACHMBITS */\x0a"
"#ifdef EXT_FRACLMBITS\x0a"
"\x09\x09\x7c u.bits.ext_fraclm\x0a"
"#endif /* EXT_FRACLMBITS */\x0a"
"\x09\x09\x7c u.bits.ext_fracl)==0) {\x0a"
"\x09\x09if (expsign>0) return 0.0;\x09/* acos(1) = 0  */\x0a"
"\x09\x09""else return pi+2.0*pio2_lo;\x09/* acos(-1)= pi */\x0a"
"\x09    }\x0a"
"\x09    return (x-x)/(x-x);\x09\x09/* acos(\x7cx\x7c>1) is NaN */\x0a"
"\x09}\x0a"
"\x09if(expt<BIAS-1) {\x09/* \x7cx\x7c < 0.5 */\x0a"
"\x09    if(expt<ACOS_CONST) return pio2_hi+pio2_lo;/*x tiny\x3a acosl=pi/2*/\x0a"
"\x09    z = x*x;\x0a"
"\x09    p = P(z);\x0a"
"\x09    q = Q(z);\x0a"
"\x09    r = p/q;\x0a"
"\x09    return pio2_hi - (x - (pio2_lo-x*r));\x0a"
"\x09} else  if (expsign<0) {\x09/* x < -0.5 */\x0a"
"\x09    z = (one+x)*0.5;\x0a"
"\x09    p = P(z);\x0a"
"\x09    q = Q(z);\x0a"
"\x09    s = sqrtl(z);\x0a"
"\x09    r = p/q;\x0a"
"\x09    w = r*s-pio2_lo;\x0a"
"\x09    return pi - 2.0*(s+w);\x0a"
"\x09} else {\x09\x09\x09/* x > 0.5 */\x0a"
"\x09    z = (one-x)*0.5;\x0a"
"\x09    s = sqrtl(z);\x0a"
"\x09    u.e = s;\x0a"
"\x09    u.bits.ext_fracl = 0;\x0a"
"#ifdef EXT_FRACLMBITS\x0a"
"\x09    u.bits.ext_fraclm = 0;\x0a"
"#endif /* EXT_FRACLMBITS */\x0a"
"\x09    df = u.e;\x0a"
"\x09    c  = (z-df*df)/(s+df);\x0a"
"\x09    p = P(z);\x0a"
"\x09    q = Q(z);\x0a"
"\x09    r = p/q;\x0a"
"\x09    w = r*s+c;\x0a"
"\x09    return 2.0*(df+w);\x0a"
"\x09}\x0a"
"}\x0a"
"", 2760 ); }