#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_asin_c( 
"/* \x40(#)e_asin.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* asin(x)\x0a"
" * Method \x3a                  \x0a"
" *\x09Since  asin(x) = x + x^3/6 + x^5*3/40 + x^7*15/336 + ...\x0a"
" *\x09we approximate asin(x) on \x5b""0,0.5\x5d by\x0a"
" *\x09\x09""asin(x) = x + x*x^2*R(x^2)\x0a"
" *\x09where\x0a"
" *\x09\x09R(x^2) is a rational approximation of (asin(x)-x)/x^3 \x0a"
" *\x09""and its Remes error is bounded by\x0a"
" *\x09\x09\x7c(asin(x)-x)/x^3 - R(x^2)\x7c < 2^(-58.75)\x0a"
" *\x0a"
" *\x09""For x in \x5b""0.5,1\x5d\x0a"
" *\x09\x09""asin(x) = pi/2-2*asin(sqrt((1-x)/2))\x0a"
" *\x09Let y = (1-x), z = y/2, s \x3a= sqrt(z), and pio2_hi+pio2_lo=pi/2;\x0a"
" *\x09then for x>0.98\x0a"
" *\x09\x09""asin(x) = pi/2 - 2*(s+s*z*R(z))\x0a"
" *\x09\x09\x09= pio2_hi - (2*(s+s*z*R(z)) - pio2_lo)\x0a"
" *\x09""For x<=0.98, let pio4_hi = pio2_hi/2, then\x0a"
" *\x09\x09""f = hi part of s;\x0a"
" *\x09\x09""c = sqrt(z) - f = (z-f*f)/(s+f) \x09...f+c=sqrt(z)\x0a"
" *\x09""and\x0a"
" *\x09\x09""asin(x) = pi/2 - 2*(s+s*z*R(z))\x0a"
" *\x09\x09\x09= pio4_hi+(pio4-2s)-(2s*z*R(z)-pio2_lo)\x0a"
" *\x09\x09\x09= pio4_hi+(pio4-2f)-(2s*z*R(z)-(pio2_lo+2c))\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09if x is NaN, return x itself;\x0a"
" *\x09if \x7cx\x7c>1, return NaN with invalid signal.\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double \x0a"
"one =  1.00000000000000000000e+00, /* 0x3FF00000, 0x00000000 */\x0a"
"huge =  1.000e+300,\x0a"
"pio2_hi =  1.57079632679489655800e+00, /* 0x3FF921FB, 0x54442D18 */\x0a"
"pio2_lo =  6.12323399573676603587e-17, /* 0x3C91A626, 0x33145C07 */\x0a"
"pio4_hi =  7.85398163397448278999e-01, /* 0x3FE921FB, 0x54442D18 */\x0a"
"\x09/* coefficient for R(x^2) */\x0a"
"pS0 =  1.66666666666666657415e-01, /* 0x3FC55555, 0x55555555 */\x0a"
"pS1 = -3.25565818622400915405e-01, /* 0xBFD4D612, 0x03EB6F7D */\x0a"
"pS2 =  2.01212532134862925881e-01, /* 0x3FC9C155, 0x0E884455 */\x0a"
"pS3 = -4.00555345006794114027e-02, /* 0xBFA48228, 0xB5688F3B */\x0a"
"pS4 =  7.91534994289814532176e-04, /* 0x3F49EFE0, 0x7501B288 */\x0a"
"pS5 =  3.47933107596021167570e-05, /* 0x3F023DE1, 0x0DFDF709 */\x0a"
"qS1 = -2.40339491173441421878e+00, /* 0xC0033A27, 0x1C8A2D4B */\x0a"
"qS2 =  2.02094576023350569471e+00, /* 0x40002AE5, 0x9C598AC8 */\x0a"
"qS3 = -6.88283971605453293030e-01, /* 0xBFE6066C, 0x1B8D0159 */\x0a"
"qS4 =  7.70381505559019352791e-02; /* 0x3FB3B8C5, 0xB12E9282 */\x0a"
"\x0a"
"__link_always double\x0a"
"asin(double x)\x0a"
"{\x0a"
"\x09""double t,w,p,q,c,r,s;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>= 0x3ff00000) {\x09\x09/* \x7cx\x7c>= 1 */\x0a"
"\x09    u_int32_t lx;\x0a"
"\x09    GET_LOW_WORD(lx,x);\x0a"
"\x09    if(((ix-0x3ff00000)\x7clx)==0)\x0a"
"\x09\x09    /* asin(1)=+-pi/2 with inexact */\x0a"
"\x09\x09return x*pio2_hi+x*pio2_lo;\x09\x0a"
"\x09    return (x-x)/(x-x);\x09\x09/* asin(\x7cx\x7c>1) is NaN */   \x0a"
"\x09} else if (ix<0x3fe00000) {\x09/* \x7cx\x7c<0.5 */\x0a"
"\x09    if(ix<0x3e400000) {\x09\x09/* if \x7cx\x7c < 2**-27 */\x0a"
"\x09\x09if(huge+x>one) return x;/* return x with inexact if x\x21=0*/\x0a"
"\x09    }\x0a"
"\x09    t = x*x;\x0a"
"\x09    p = t*(pS0+t*(pS1+t*(pS2+t*(pS3+t*(pS4+t*pS5)))));\x0a"
"\x09    q = one+t*(qS1+t*(qS2+t*(qS3+t*qS4)));\x0a"
"\x09    w = p/q;\x0a"
"\x09    return x+x*w;\x0a"
"\x09}\x0a"
"\x09/* 1> \x7cx\x7c>= 0.5 */\x0a"
"\x09w = one-fabs(x);\x0a"
"\x09t = w*0.5;\x0a"
"\x09p = t*(pS0+t*(pS1+t*(pS2+t*(pS3+t*(pS4+t*pS5)))));\x0a"
"\x09q = one+t*(qS1+t*(qS2+t*(qS3+t*qS4)));\x0a"
"\x09s = sqrt(t);\x0a"
"\x09if(ix>=0x3FEF3333) { \x09/* if \x7cx\x7c > 0.975 */\x0a"
"\x09    w = p/q;\x0a"
"\x09    t = pio2_hi-(2.0*(s+s*w)-pio2_lo);\x0a"
"\x09} else {\x0a"
"\x09    w  = s;\x0a"
"\x09    SET_LOW_WORD(w,0);\x0a"
"\x09    c  = (t-w*w)/(s+w);\x0a"
"\x09    r  = p/q;\x0a"
"\x09    p  = 2.0*s*r-(pio2_lo-2.0*c);\x0a"
"\x09    q  = pio4_hi-2.0*w;\x0a"
"\x09    t  = pio4_hi-(p-q);\x0a"
"\x09}    \x0a"
"\x09if(hx>0) return t; else return -t;    \x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(asinl, asin);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 3626 ); }