#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_asinf_c( 
"/* e_asinf.c -- float version of e_asin.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const float \x0a"
"one =  1.0000000000e+00, /* 0x3F800000 */\x0a"
"huge =  1.000e+30,\x0a"
"pio2_hi =  1.5707962513e+00, /* 0x3fc90fda */\x0a"
"pio2_lo =  7.5497894159e-08, /* 0x33a22168 */\x0a"
"pio4_hi =  7.8539818525e-01, /* 0x3f490fdb */\x0a"
"\x09/* coefficient for R(x^2) */\x0a"
"pS0 =  1.6666667163e-01, /* 0x3e2aaaab */\x0a"
"pS1 = -3.2556581497e-01, /* 0xbea6b090 */\x0a"
"pS2 =  2.0121252537e-01, /* 0x3e4e0aa8 */\x0a"
"pS3 = -4.0055535734e-02, /* 0xbd241146 */\x0a"
"pS4 =  7.9153501429e-04, /* 0x3a4f7f04 */\x0a"
"pS5 =  3.4793309169e-05, /* 0x3811ef08 */\x0a"
"qS1 = -2.4033949375e+00, /* 0xc019d139 */\x0a"
"qS2 =  2.0209457874e+00, /* 0x4001572d */\x0a"
"qS3 = -6.8828397989e-01, /* 0xbf303361 */\x0a"
"qS4 =  7.7038154006e-02; /* 0x3d9dc62e */\x0a"
"\x0a"
"float\x0a"
"asinf(float x)\x0a"
"{\x0a"
"\x09""float t,w,p,q,c,r,s;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix==0x3f800000) {\x0a"
"\x09\x09/* asin(1)=+-pi/2 with inexact */\x0a"
"\x09    return x*pio2_hi+x*pio2_lo;\x09\x0a"
"\x09} else if(ix> 0x3f800000) {\x09/* \x7cx\x7c>= 1 */\x0a"
"\x09    return (x-x)/(x-x);\x09\x09/* asin(\x7cx\x7c>1) is NaN */   \x0a"
"\x09} else if (ix<0x3f000000) {\x09/* \x7cx\x7c<0.5 */\x0a"
"\x09    if(ix<0x32000000) {\x09\x09/* if \x7cx\x7c < 2**-27 */\x0a"
"\x09\x09if(huge+x>one) return x;/* return x with inexact if x\x21=0*/\x0a"
"\x09    }\x0a"
"\x09    t = x*x;\x0a"
"\x09    p = t*(pS0+t*(pS1+t*(pS2+t*(pS3+t*(pS4+t*pS5)))));\x0a"
"\x09    q = one+t*(qS1+t*(qS2+t*(qS3+t*qS4)));\x0a"
"\x09    w = p/q;\x0a"
"\x09    return x+x*w;\x0a"
"\x09}\x0a"
"\x09/* 1> \x7cx\x7c>= 0.5 */\x0a"
"\x09w = one-fabsf(x);\x0a"
"\x09t = w*(float)0.5;\x0a"
"\x09p = t*(pS0+t*(pS1+t*(pS2+t*(pS3+t*(pS4+t*pS5)))));\x0a"
"\x09q = one+t*(qS1+t*(qS2+t*(qS3+t*qS4)));\x0a"
"\x09s = sqrtf(t);\x0a"
"\x09if(ix>=0x3F79999A) { \x09/* if \x7cx\x7c > 0.975 */\x0a"
"\x09    w = p/q;\x0a"
"\x09    t = pio2_hi-((float)2.0*(s+s*w)-pio2_lo);\x0a"
"\x09} else {\x0a"
"\x09    int32_t iw;\x0a"
"\x09    w  = s;\x0a"
"\x09    GET_FLOAT_WORD(iw,w);\x0a"
"\x09    SET_FLOAT_WORD(w,iw\x26""0xfffff000);\x0a"
"\x09    c  = (t-w*w)/(s+w);\x0a"
"\x09    r  = p/q;\x0a"
"\x09    p  = (float)2.0*s*r-(pio2_lo-(float)2.0*c);\x0a"
"\x09    q  = pio4_hi-(float)2.0*w;\x0a"
"\x09    t  = pio4_hi-(p-q);\x0a"
"\x09}    \x0a"
"\x09if(hx>0) return t; else return -t;    \x0a"
"}\x0a"
"", 2394 ); }