#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_atan2_c( 
"/* \x40(#)e_atan2.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* atan2(y,x)\x0a"
" * Method \x3a\x0a"
" *\x09""1. Reduce y to positive by atan2(y,x)=-atan2(-y,x).\x0a"
" *\x09""2. Reduce x to positive by (if x and y are unexceptional)\x3a \x0a"
" *\x09\x09""ARG (x+iy) = arctan(y/x)   \x09   ... if x > 0,\x0a"
" *\x09\x09""ARG (x+iy) = pi - arctan\x5by/(-x)\x5d   ... if x < 0,\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x0a"
" *\x09""ATAN2((anything), NaN ) is NaN;\x0a"
" *\x09""ATAN2(NAN , (anything) ) is NaN;\x0a"
" *\x09""ATAN2(+-0, +(anything but NaN)) is +-0  ;\x0a"
" *\x09""ATAN2(+-0, -(anything but NaN)) is +-pi ;\x0a"
" *\x09""ATAN2(+-(anything but 0 and NaN), 0) is +-pi/2;\x0a"
" *\x09""ATAN2(+-(anything but INF and NaN), +INF) is +-0 ;\x0a"
" *\x09""ATAN2(+-(anything but INF and NaN), -INF) is +-pi;\x0a"
" *\x09""ATAN2(+-INF,+INF ) is +-pi/4 ;\x0a"
" *\x09""ATAN2(+-INF,-INF ) is +-3pi/4;\x0a"
" *\x09""ATAN2(+-INF, (anything but,0,NaN, and INF)) is +-pi/2;\x0a"
" *\x0a"
" * Constants\x3a\x0a"
" * The hexadecimal values are the intended ones for the following \x0a"
" * constants. The decimal values may be used, provided that the \x0a"
" * compiler will convert from decimal to binary accurately enough \x0a"
" * to produce the hexadecimal values shown.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double \x0a"
"tiny  = 1.0e-300,\x0a"
"zero  = 0.0,\x0a"
"pi_o_4  = 7.8539816339744827900E-01, /* 0x3FE921FB, 0x54442D18 */\x0a"
"pi_o_2  = 1.5707963267948965580E+00, /* 0x3FF921FB, 0x54442D18 */\x0a"
"pi      = 3.1415926535897931160E+00, /* 0x400921FB, 0x54442D18 */\x0a"
"pi_lo   = 1.2246467991473531772E-16; /* 0x3CA1A626, 0x33145C07 */\x0a"
"\x0a"
"__link_always double\x0a"
"atan2(double y, double x)\x0a"
"{  \x0a"
"\x09""double z;\x0a"
"\x09int32_t k,m,hx,hy,ix,iy;\x0a"
"\x09u_int32_t lx,ly;\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09""EXTRACT_WORDS(hy,ly,y);\x0a"
"\x09iy = hy\x26""0x7fffffff;\x0a"
"\x09if(((ix\x7c((lx\x7c-lx)>>31))>0x7ff00000)\x7c\x7c\x0a"
"\x09   ((iy\x7c((ly\x7c-ly)>>31))>0x7ff00000))\x09/* x or y is NaN */\x0a"
"\x09   return x+y;\x0a"
"\x09if(((hx-0x3ff00000)\x7clx)==0) return atan(y);   /* x=1.0 */\x0a"
"\x09m = ((hy>>31)\x26""1)\x7c((hx>>30)\x26""2);\x09/* 2*sign(x)+sign(y) */\x0a"
"\x0a"
"    /* when y = 0 */\x0a"
"\x09if((iy\x7cly)==0) {\x0a"
"\x09    switch(m) {\x0a"
"\x09\x09""case 0\x3a \x0a"
"\x09\x09""case 1\x3a return y; \x09/* atan(+-0,+anything)=+-0 */\x0a"
"\x09\x09""case 2\x3a return  pi+tiny;/* atan(+0,-anything) = pi */\x0a"
"\x09\x09""case 3\x3a return -pi-tiny;/* atan(-0,-anything) =-pi */\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    /* when x = 0 */\x0a"
"\x09if((ix\x7clx)==0) return (hy<0)\x3f  -pi_o_2-tiny\x3a pi_o_2+tiny;\x0a"
"\x09    \x0a"
"    /* when x is INF */\x0a"
"\x09if(ix==0x7ff00000) {\x0a"
"\x09    if(iy==0x7ff00000) {\x0a"
"\x09\x09switch(m) {\x0a"
"\x09\x09    case 0\x3a return  pi_o_4+tiny;/* atan(+INF,+INF) */\x0a"
"\x09\x09    case 1\x3a return -pi_o_4-tiny;/* atan(-INF,+INF) */\x0a"
"\x09\x09    case 2\x3a return  3.0*pi_o_4+tiny;/*atan(+INF,-INF)*/\x0a"
"\x09\x09    case 3\x3a return -3.0*pi_o_4-tiny;/*atan(-INF,-INF)*/\x0a"
"\x09\x09}\x0a"
"\x09    } else {\x0a"
"\x09\x09switch(m) {\x0a"
"\x09\x09    case 0\x3a return  zero  ;\x09/* atan(+...,+INF) */\x0a"
"\x09\x09    case 1\x3a return -zero  ;\x09/* atan(-...,+INF) */\x0a"
"\x09\x09    case 2\x3a return  pi+tiny  ;\x09/* atan(+...,-INF) */\x0a"
"\x09\x09    case 3\x3a return -pi-tiny  ;\x09/* atan(-...,-INF) */\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    /* when y is INF */\x0a"
"\x09if(iy==0x7ff00000) return (hy<0)\x3f -pi_o_2-tiny\x3a pi_o_2+tiny;\x0a"
"\x0a"
"    /* compute y/x */\x0a"
"\x09k = (iy-ix)>>20;\x0a"
"\x09if(k > 60) z=pi_o_2+0.5*pi_lo; \x09/* \x7cy/x\x7c >  2**60 */\x0a"
"\x09""else if(hx<0\x26\x26k<-60) z=0.0; \x09/* \x7cy\x7c/x < -2**60 */\x0a"
"\x09""else z=atan(fabs(y/x));\x09\x09/* safe to do y/x */\x0a"
"\x09switch (m) {\x0a"
"\x09    case 0\x3a return       z  ;\x09/* atan(+,+) */\x0a"
"\x09    case 1\x3a {\x0a"
"\x09    \x09      u_int32_t zh;\x0a"
"\x09\x09      GET_HIGH_WORD(zh,z);\x0a"
"\x09\x09      SET_HIGH_WORD(z,zh ^ 0x80000000);\x0a"
"\x09\x09    }\x0a"
"\x09\x09    return       z  ;\x09/* atan(-,+) */\x0a"
"\x09    case 2\x3a return  pi-(z-pi_lo);/* atan(+,-) */\x0a"
"\x09    default\x3a /* case 3 */\x0a"
"\x09    \x09    return  (z-pi_lo)-pi;/* atan(-,-) */\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(atan2l, atan2);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 3844 ); }