#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_atan2f_c( 
"/* e_atan2f.c -- float version of e_atan2.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const float \x0a"
"tiny  = 1.0e-30,\x0a"
"zero  = 0.0,\x0a"
"pi_o_4  = 7.8539818525e-01, /* 0x3f490fdb */\x0a"
"pi_o_2  = 1.5707963705e+00, /* 0x3fc90fdb */\x0a"
"pi      = 3.1415925026e+00, /* 0x40490fda */\x0a"
"pi_lo   = 1.5099578832e-07; /* 0x34222168 */\x0a"
"\x0a"
"float\x0a"
"atan2f(float y, float x)\x0a"
"{  \x0a"
"\x09""float z;\x0a"
"\x09int32_t k,m,hx,hy,ix,iy;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09GET_FLOAT_WORD(hy,y);\x0a"
"\x09iy = hy\x26""0x7fffffff;\x0a"
"\x09if((ix>0x7f800000)\x7c\x7c\x0a"
"\x09   (iy>0x7f800000))\x09/* x or y is NaN */\x0a"
"\x09   return x+y;\x0a"
"\x09if(hx==0x3f800000) return atanf(y);   /* x=1.0 */\x0a"
"\x09m = ((hy>>31)\x26""1)\x7c((hx>>30)\x26""2);\x09/* 2*sign(x)+sign(y) */\x0a"
"\x0a"
"    /* when y = 0 */\x0a"
"\x09if(iy==0) {\x0a"
"\x09    switch(m) {\x0a"
"\x09\x09""case 0\x3a \x0a"
"\x09\x09""case 1\x3a return y; \x09/* atan(+-0,+anything)=+-0 */\x0a"
"\x09\x09""case 2\x3a return  pi+tiny;/* atan(+0,-anything) = pi */\x0a"
"\x09\x09""case 3\x3a return -pi-tiny;/* atan(-0,-anything) =-pi */\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    /* when x = 0 */\x0a"
"\x09if(ix==0) return (hy<0)\x3f  -pi_o_2-tiny\x3a pi_o_2+tiny;\x0a"
"\x09    \x0a"
"    /* when x is INF */\x0a"
"\x09if(ix==0x7f800000) {\x0a"
"\x09    if(iy==0x7f800000) {\x0a"
"\x09\x09switch(m) {\x0a"
"\x09\x09    case 0\x3a return  pi_o_4+tiny;/* atan(+INF,+INF) */\x0a"
"\x09\x09    case 1\x3a return -pi_o_4-tiny;/* atan(-INF,+INF) */\x0a"
"\x09\x09    case 2\x3a return  (float)3.0*pi_o_4+tiny;/*atan(+INF,-INF)*/\x0a"
"\x09\x09    case 3\x3a return (float)-3.0*pi_o_4-tiny;/*atan(-INF,-INF)*/\x0a"
"\x09\x09}\x0a"
"\x09    } else {\x0a"
"\x09\x09switch(m) {\x0a"
"\x09\x09    case 0\x3a return  zero  ;\x09/* atan(+...,+INF) */\x0a"
"\x09\x09    case 1\x3a return -zero  ;\x09/* atan(-...,+INF) */\x0a"
"\x09\x09    case 2\x3a return  pi+tiny  ;\x09/* atan(+...,-INF) */\x0a"
"\x09\x09    case 3\x3a return -pi-tiny  ;\x09/* atan(-...,-INF) */\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    /* when y is INF */\x0a"
"\x09if(iy==0x7f800000) return (hy<0)\x3f -pi_o_2-tiny\x3a pi_o_2+tiny;\x0a"
"\x0a"
"    /* compute y/x */\x0a"
"\x09k = (iy-ix)>>23;\x0a"
"\x09if(k > 60) z=pi_o_2+(float)0.5*pi_lo; \x09/* \x7cy/x\x7c >  2**60 */\x0a"
"\x09""else if(hx<0\x26\x26k<-60) z=0.0; \x09/* \x7cy\x7c/x < -2**60 */\x0a"
"\x09""else z=atanf(fabsf(y/x));\x09/* safe to do y/x */\x0a"
"\x09switch (m) {\x0a"
"\x09    case 0\x3a return       z  ;\x09/* atan(+,+) */\x0a"
"\x09    case 1\x3a {\x0a"
"\x09    \x09      u_int32_t zh;\x0a"
"\x09\x09      GET_FLOAT_WORD(zh,z);\x0a"
"\x09\x09      SET_FLOAT_WORD(z,zh ^ 0x80000000);\x0a"
"\x09\x09    }\x0a"
"\x09\x09    return       z  ;\x09/* atan(-,+) */\x0a"
"\x09    case 2\x3a return  pi-(z-pi_lo);/* atan(+,-) */\x0a"
"\x09    default\x3a /* case 3 */\x0a"
"\x09    \x09    return  (z-pi_lo)-pi;/* atan(-,-) */\x0a"
"\x09}\x0a"
"}\x0a"
"", 2674 ); }