#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_atanh_c( 
"/* \x40(#)e_atanh.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* atanh(x)\x0a"
" * Method \x3a\x0a"
" *    1.Reduced x to positive by atanh(-x) = -atanh(x)\x0a"
" *    2.For x>=0.5\x0a"
" *                  1              2x                          x\x0a"
" *\x09""atanh(x) = --- * log(1 + -------) = 0.5 * log1p(2 * --------)\x0a"
" *                  2             1 - x                      1 - x\x0a"
" *\x09\x0a"
" * \x09""For x<0.5\x0a"
" *\x09""atanh(x) = 0.5*log1p(2x+2x*x/(1-x))\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09""atanh(x) is NaN if \x7cx\x7c > 1 with signal;\x0a"
" *\x09""atanh(NaN) is that NaN with no signal;\x0a"
" *\x09""atanh(+-1) is +-INF with signal.\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double one = 1.0, huge = 1e300;\x0a"
"static const double zero = 0.0;\x0a"
"\x0a"
"double\x0a"
"atanh(double x)\x0a"
"{\x0a"
"\x09""double t;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x09u_int32_t lx;\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if ((ix\x7c((lx\x7c(-lx))>>31))>0x3ff00000) /* \x7cx\x7c>1 */\x0a"
"\x09    return (x-x)/(x-x);\x0a"
"\x09if(ix==0x3ff00000) \x0a"
"\x09    return x/zero;\x0a"
"\x09if(ix<0x3e300000\x26\x26(huge+x)>zero) return x;\x09/* x<2**-28 */\x0a"
"\x09SET_HIGH_WORD(x,ix);\x0a"
"\x09if(ix<0x3fe00000) {\x09\x09/* x < 0.5 */\x0a"
"\x09    t = x+x;\x0a"
"\x09    t = 0.5*log1p(t+t*x/(one-x));\x0a"
"\x09} else \x0a"
"\x09    t = 0.5*log1p((x+x)/(one-x));\x0a"
"\x09if(hx>=0) return t; else return -t;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(atanhl, atanh);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 1648 ); }