#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_cosh_c( 
"/* \x40(#)e_cosh.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* cosh(x)\x0a"
" * Method \x3a \x0a"
" * mathematically cosh(x) if defined to be (exp(x)+exp(-x))/2\x0a"
" *\x09""1. Replace x by \x7cx\x7c (cosh(x) = cosh(-x)). \x0a"
" *\x09""2. \x0a"
" *\x09\x09                                        \x5b exp(x) - 1 \x5d^2 \x0a"
" *\x09    0        <= x <= ln2/2  \x3a  cosh(x) \x3a= 1 + -------------------\x0a"
" *\x09\x09\x09       \x09\x09\x09           2*exp(x)\x0a"
" *\x0a"
" *\x09\x09                                  exp(x) +  1/exp(x)\x0a"
" *\x09    ln2/2    <= x <= 22     \x3a  cosh(x) \x3a= -------------------\x0a"
" *\x09\x09\x09       \x09\x09\x09          2\x0a"
" *\x09    22       <= x <= lnovft \x3a  cosh(x) \x3a= exp(x)/2 \x0a"
" *\x09    lnovft   <= x <= ln2ovft\x3a  cosh(x) \x3a= exp(x/2)/2 * exp(x/2)\x0a"
" *\x09    ln2ovft  <  x\x09    \x3a  cosh(x) \x3a= huge*huge (overflow)\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09""cosh(x) is \x7cx\x7c if x is +INF, -INF, or NaN.\x0a"
" *\x09only cosh(0)=1 is exact for finite x.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double one = 1.0, half=0.5, huge = 1.0e300;\x0a"
"\x0a"
"__link_always double\x0a"
"cosh(double x)\x0a"
"{\x09\x0a"
"\x09""double t,w;\x0a"
"\x09int32_t ix;\x0a"
"\x09u_int32_t lx;\x0a"
"\x0a"
"    /* High word of \x7cx\x7c. */\x0a"
"\x09GET_HIGH_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"\x0a"
"    /* x is INF or NaN */\x0a"
"\x09if(ix>=0x7ff00000) return x*x;\x09\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5b""0,0.5*ln2\x5d, return 1+expm1(\x7cx\x7c)^2/(2*exp(\x7cx\x7c)) */\x0a"
"\x09if(ix<0x3fd62e43) {\x0a"
"\x09    t = expm1(fabs(x));\x0a"
"\x09    w = one+t;\x0a"
"\x09    if (ix<0x3c800000) return w;\x09/* cosh(tiny) = 1 */\x0a"
"\x09    return one+(t*t)/(w+w);\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5b""0.5*ln2,22\x5d, return (exp(\x7cx\x7c)+1/exp(\x7cx\x7c)/2; */\x0a"
"\x09if (ix < 0x40360000) {\x0a"
"\x09\x09t = exp(fabs(x));\x0a"
"\x09\x09return half*t+half/t;\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5b""22, log(maxdouble)\x5d return half*exp(\x7cx\x7c) */\x0a"
"\x09if (ix < 0x40862E42)  return half*exp(fabs(x));\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5blog(maxdouble), overflowthresold\x5d */\x0a"
"\x09GET_LOW_WORD(lx,x);\x0a"
"\x09if (ix<0x408633CE \x7c\x7c \x0a"
"\x09      ((ix==0x408633ce)\x26\x26(lx<=(u_int32_t)0x8fb9f87d))) {\x0a"
"\x09    w = exp(half*fabs(x));\x0a"
"\x09    t = half*w;\x0a"
"\x09    return t*w;\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c > overflowthresold, cosh(x) overflow */\x0a"
"\x09return huge*huge;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(coshl, cosh);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 2357 ); }