#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_exp_c( 
"/* \x40(#)e_exp.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* exp(x)\x0a"
" * Returns the exponential of x.\x0a"
" *\x0a"
" * Method\x0a"
" *   1. Argument reduction\x3a\x0a"
" *      Reduce x to an r so that \x7cr\x7c <= 0.5*ln2 \x7e 0.34658.\x0a"
" *\x09Given x, find r and integer k such that\x0a"
" *\x0a"
" *               x = k*ln2 + r,  \x7cr\x7c <= 0.5*ln2.  \x0a"
" *\x0a"
" *      Here r will be represented as r = hi-lo for better \x0a"
" *\x09""accuracy.\x0a"
" *\x0a"
" *   2. Approximation of exp(r) by a special rational function on\x0a"
" *\x09the interval \x5b""0,0.34658\x5d\x3a\x0a"
" *\x09Write\x0a"
" *\x09    R(r**2) = r*(exp(r)+1)/(exp(r)-1) = 2 + r*r/6 - r**4/360 + ...\x0a"
" *      We use a special Remes algorithm on \x5b""0,0.34658\x5d to generate \x0a"
" * \x09""a polynomial of degree 5 to approximate R. The maximum error \x0a"
" *\x09of this polynomial approximation is bounded by 2**-59. In\x0a"
" *\x09other words,\x0a"
" *\x09    R(z) \x7e 2.0 + P1*z + P2*z**2 + P3*z**3 + P4*z**4 + P5*z**5\x0a"
" *  \x09(where z=r*r, and the values of P1 to P5 are listed below)\x0a"
" *\x09""and\x0a"
" *\x09    \x7c                  5          \x7c     -59\x0a"
" *\x09    \x7c 2.0+P1*z+...+P5*z   -  R(z) \x7c <= 2 \x0a"
" *\x09    \x7c                             \x7c\x0a"
" *\x09The computation of exp(r) thus becomes\x0a"
" *                             2*r\x0a"
" *\x09\x09""exp(r) = 1 + -------\x0a"
" *\x09\x09              R - r\x0a"
" *                                 r*R1(r)\x09\x0a"
" *\x09\x09       = 1 + r + ----------- (for better accuracy)\x0a"
" *\x09\x09                  2 - R1(r)\x0a"
" *\x09where\x0a"
" *\x09\x09\x09         2       4             10\x0a"
" *\x09\x09R1(r) = r - (P1*r  + P2*r  + ... + P5*r   ).\x0a"
" *\x09\x0a"
" *   3. Scale back to obtain exp(x)\x3a\x0a"
" *\x09""From step 1, we have\x0a"
" *\x09   exp(x) = 2^k * exp(r)\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09""exp(INF) is INF, exp(NaN) is NaN;\x0a"
" *\x09""exp(-INF) is 0, and\x0a"
" *\x09""for finite argument, only exp(0)=1 is exact.\x0a"
" *\x0a"
" * Accuracy\x3a\x0a"
" *\x09""according to an error analysis, the error is always less than\x0a"
" *\x09""1 ulp (unit in the last place).\x0a"
" *\x0a"
" * Misc. info.\x0a"
" *\x09""For IEEE double \x0a"
" *\x09    if x >  7.09782712893383973096e+02 then exp(x) overflow\x0a"
" *\x09    if x < -7.45133219101941108420e+02 then exp(x) underflow\x0a"
" *\x0a"
" * Constants\x3a\x0a"
" * The hexadecimal values are the intended ones for the following \x0a"
" * constants. The decimal values may be used, provided that the \x0a"
" * compiler will convert from decimal to binary accurately enough\x0a"
" * to produce the hexadecimal values shown.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double\x0a"
"one\x09= 1.0,\x0a"
"halF\x5b""2\x5d\x09= {0.5,-0.5,},\x0a"
"huge\x09= 1.0e+300,\x0a"
"twom1000= 9.33263618503218878990e-302,     /* 2**-1000=0x01700000,0*/\x0a"
"o_threshold=  7.09782712893383973096e+02,  /* 0x40862E42, 0xFEFA39EF */\x0a"
"u_threshold= -7.45133219101941108420e+02,  /* 0xc0874910, 0xD52D3051 */\x0a"
"ln2HI\x5b""2\x5d   ={ 6.93147180369123816490e-01,  /* 0x3fe62e42, 0xfee00000 */\x0a"
"\x09     -6.93147180369123816490e-01,},/* 0xbfe62e42, 0xfee00000 */\x0a"
"ln2LO\x5b""2\x5d   ={ 1.90821492927058770002e-10,  /* 0x3dea39ef, 0x35793c76 */\x0a"
"\x09     -1.90821492927058770002e-10,},/* 0xbdea39ef, 0x35793c76 */\x0a"
"invln2 =  1.44269504088896338700e+00, /* 0x3ff71547, 0x652b82fe */\x0a"
"P1   =  1.66666666666666019037e-01, /* 0x3FC55555, 0x5555553E */\x0a"
"P2   = -2.77777777770155933842e-03, /* 0xBF66C16C, 0x16BEBD93 */\x0a"
"P3   =  6.61375632143793436117e-05, /* 0x3F11566A, 0xAF25DE2C */\x0a"
"P4   = -1.65339022054652515390e-06, /* 0xBEBBBD41, 0xC5D26BF1 */\x0a"
"P5   =  4.13813679705723846039e-08; /* 0x3E663769, 0x72BEA4D0 */\x0a"
"\x0a"
"\x0a"
"__link_always double\x0a"
"exp(double x)\x09/* default IEEE double exp */\x0a"
"{\x0a"
"\x09""double y,hi,lo,c,t;\x0a"
"\x09int32_t k,xsb;\x0a"
"\x09u_int32_t hx;\x0a"
"\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09xsb = (hx>>31)\x26""1;\x09\x09/* sign bit of x */\x0a"
"\x09hx \x26= 0x7fffffff;\x09\x09/* high word of \x7cx\x7c */\x0a"
"\x0a"
"    /* filter out non-finite argument */\x0a"
"\x09if(hx >= 0x40862E42) {\x09\x09\x09/* if \x7cx\x7c>=709.78... */\x0a"
"            if(hx>=0x7ff00000) {\x0a"
"\x09        u_int32_t lx;\x0a"
"\x09\x09GET_LOW_WORD(lx,x);\x0a"
"\x09\x09if(((hx\x26""0xfffff)\x7clx)\x21=0) \x0a"
"\x09\x09     return x+x; \x09\x09/* NaN */\x0a"
"\x09\x09""else return (xsb==0)\x3f x\x3a""0.0;\x09/* exp(+-inf)={inf,0} */\x0a"
"\x09    }\x0a"
"\x09    if(x > o_threshold) return huge*huge; /* overflow */\x0a"
"\x09    if(x < u_threshold) return twom1000*twom1000; /* underflow */\x0a"
"\x09}\x0a"
"\x0a"
"    /* argument reduction */\x0a"
"\x09if(hx > 0x3fd62e42) {\x09\x09/* if  \x7cx\x7c > 0.5 ln2 */ \x0a"
"\x09    if(hx < 0x3FF0A2B2) {\x09/* and \x7cx\x7c < 1.5 ln2 */\x0a"
"\x09\x09hi = x-ln2HI\x5bxsb\x5d; lo=ln2LO\x5bxsb\x5d; k = 1-xsb-xsb;\x0a"
"\x09    } else {\x0a"
"\x09\x09k  = invln2*x+halF\x5bxsb\x5d;\x0a"
"\x09\x09t  = k;\x0a"
"\x09\x09hi = x - t*ln2HI\x5b""0\x5d;\x09/* t*ln2HI is exact here */\x0a"
"\x09\x09lo = t*ln2LO\x5b""0\x5d;\x0a"
"\x09    }\x0a"
"\x09    x  = hi - lo;\x0a"
"\x09} \x0a"
"\x09""else if(hx < 0x3e300000)  {\x09/* when \x7cx\x7c<2**-28 */\x0a"
"\x09    if(huge+x>one) return one+x;/* trigger inexact */\x0a"
"\x09}\x0a"
"\x09""else k = 0;\x0a"
"\x0a"
"    /* x is now in primary range */\x0a"
"\x09t  = x*x;\x0a"
"\x09""c  = x - t*(P1+t*(P2+t*(P3+t*(P4+t*P5))));\x0a"
"\x09if(k==0) \x09return one-((x*c)/(c-2.0)-x); \x0a"
"\x09""else \x09\x09y = one-((lo-(x*c)/(2.0-c))-hi);\x0a"
"\x09if(k >= -1021) {\x0a"
"\x09    u_int32_t hy;\x0a"
"\x09    GET_HIGH_WORD(hy,y);\x0a"
"\x09    SET_HIGH_WORD(y,hy+(k<<20));\x09/* add k to y's exponent */\x0a"
"\x09    return y;\x0a"
"\x09} else {\x0a"
"\x09    u_int32_t hy;\x0a"
"\x09    GET_HIGH_WORD(hy,y);\x0a"
"\x09    SET_HIGH_WORD(y,hy+((k+1000)<<20));\x09/* add k to y's exponent */\x0a"
"\x09    return y*twom1000;\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(expl, exp);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 5196 ); }