#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_expf_c( 
"/* e_expf.c -- float version of e_exp.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const volatile float huge = 1.0e+30;\x0a"
"\x0a"
"static const float\x0a"
"one\x09= 1.0,\x0a"
"halF\x5b""2\x5d\x09= {0.5,-0.5,},\x0a"
"twom100 = 7.8886090522e-31,      /* 2**-100=0x0d800000 */\x0a"
"o_threshold=  8.8721679688e+01,  /* 0x42b17180 */\x0a"
"u_threshold= -1.0397208405e+02,  /* 0xc2cff1b5 */\x0a"
"ln2HI\x5b""2\x5d   ={ 6.9313812256e-01,\x09\x09/* 0x3f317180 */\x0a"
"\x09     -6.9313812256e-01,},\x09/* 0xbf317180 */\x0a"
"ln2LO\x5b""2\x5d   ={ 9.0580006145e-06,  \x09/* 0x3717f7d1 */\x0a"
"\x09     -9.0580006145e-06,},\x09/* 0xb717f7d1 */\x0a"
"invln2 =  1.4426950216e+00, \x09\x09/* 0x3fb8aa3b */\x0a"
"P1   =  1.6666667163e-01, /* 0x3e2aaaab */\x0a"
"P2   = -2.7777778450e-03, /* 0xbb360b61 */\x0a"
"P3   =  6.6137559770e-05, /* 0x388ab355 */\x0a"
"P4   = -1.6533901999e-06, /* 0xb5ddea0e */\x0a"
"P5   =  4.1381369442e-08; /* 0x3331bb4c */\x0a"
"\x0a"
"float\x0a"
"expf(float x)\x09/* default IEEE double exp */\x0a"
"{\x0a"
"\x09""float y,hi,lo,c,t;\x0a"
"\x09int32_t k,xsb;\x0a"
"\x09u_int32_t hx;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09xsb = (hx>>31)\x26""1;\x09\x09/* sign bit of x */\x0a"
"\x09hx \x26= 0x7fffffff;\x09\x09/* high word of \x7cx\x7c */\x0a"
"\x09k = 0;\x0a"
"\x0a"
"    /* filter out non-finite argument */\x0a"
"\x09if(hx >= 0x42b17218) {\x09\x09\x09/* if \x7cx\x7c>=88.721... */\x0a"
"\x09    if(hx>0x7f800000)\x0a"
"\x09\x09 return x+x;\x09 \x09\x09/* NaN */\x0a"
"            if(hx==0x7f800000)\x0a"
"\x09\x09return (xsb==0)\x3f x\x3a""0.0;\x09\x09/* exp(+-inf)={inf,0} */\x0a"
"\x09    if(x > o_threshold) return huge*huge; /* overflow */\x0a"
"\x09    if(x < u_threshold) return twom100*twom100; /* underflow */\x0a"
"\x09}\x0a"
"\x0a"
"    /* argument reduction */\x0a"
"\x09if(hx > 0x3eb17218) {\x09\x09/* if  \x7cx\x7c > 0.5 ln2 */ \x0a"
"\x09    if(hx < 0x3F851592) {\x09/* and \x7cx\x7c < 1.5 ln2 */\x0a"
"\x09\x09hi = x-ln2HI\x5bxsb\x5d; lo=ln2LO\x5bxsb\x5d; k = 1-xsb-xsb;\x0a"
"\x09    } else {\x0a"
"\x09\x09k  = invln2*x+halF\x5bxsb\x5d;\x0a"
"\x09\x09t  = k;\x0a"
"\x09\x09hi = x - t*ln2HI\x5b""0\x5d;\x09/* t*ln2HI is exact here */\x0a"
"\x09\x09lo = t*ln2LO\x5b""0\x5d;\x0a"
"\x09    }\x0a"
"\x09    x  = hi - lo;\x0a"
"\x09} \x0a"
"\x09""else if(hx < 0x31800000)  {\x09/* when \x7cx\x7c<2**-28 */\x0a"
"\x09    if(huge+x>one) return one+x;/* trigger inexact */\x0a"
"\x09}\x0a"
"\x0a"
"    /* x is now in primary range */\x0a"
"\x09t  = x*x;\x0a"
"\x09""c  = x - t*(P1+t*(P2+t*(P3+t*(P4+t*P5))));\x0a"
"\x09if(k==0) \x09return one-((x*c)/(c-(float)2.0)-x); \x0a"
"\x09""else \x09\x09y = one-((lo-(x*c)/((float)2.0-c))-hi);\x0a"
"\x09if(k >= -125) {\x0a"
"\x09    u_int32_t hy;\x0a"
"\x09    GET_FLOAT_WORD(hy,y);\x0a"
"\x09    SET_FLOAT_WORD(y,hy+(k<<23));\x09/* add k to y's exponent */\x0a"
"\x09    return y;\x0a"
"\x09} else {\x0a"
"\x09    u_int32_t hy;\x0a"
"\x09    GET_FLOAT_WORD(hy,y);\x0a"
"\x09    SET_FLOAT_WORD(y,hy+((k+100)<<23));\x09/* add k to y's exponent */\x0a"
"\x09    return y*twom100;\x0a"
"\x09}\x0a"
"}\x0a"
"", 2751 ); }