#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_fmodf_c( 
"/* e_fmodf.c -- float version of e_fmod.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* \x0a"
" * fmodf(x,y)\x0a"
" * Return x mod y in exact arithmetic\x0a"
" * Method\x3a shift and subtract\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const float one = 1.0, Zero\x5b\x5d = {0.0, -0.0,};\x0a"
"\x0a"
"__link_always float\x0a"
"fmodf(float x, float y)\x0a"
"{\x0a"
"\x09int32_t n,hx,hy,hz,ix,iy,sx,i;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09GET_FLOAT_WORD(hy,y);\x0a"
"\x09sx = hx\x26""0x80000000;\x09\x09/* sign of x */\x0a"
"\x09hx ^=sx;\x09\x09/* \x7cx\x7c */\x0a"
"\x09hy \x26= 0x7fffffff;\x09/* \x7cy\x7c */\x0a"
"\x0a"
"    /* purge off exception values */\x0a"
"\x09if(hy==0\x7c\x7c(hx>=0x7f800000)\x7c\x7c\x09\x09/* y=0,or x not finite */\x0a"
"\x09   (hy>0x7f800000))\x09\x09\x09/* or y is NaN */\x0a"
"\x09    return (x*y)/(x*y);\x0a"
"\x09if(hx<hy) return x;\x09\x09\x09/* \x7cx\x7c<\x7cy\x7c return x */\x0a"
"\x09if(hx==hy)\x0a"
"\x09    return Zero\x5b(u_int32_t)sx>>31\x5d;\x09/* \x7cx\x7c=\x7cy\x7c return x*0*/\x0a"
"\x0a"
"    /* determine ix = ilogb(x) */\x0a"
"\x09if(hx<0x00800000) {\x09/* subnormal x */\x0a"
"\x09    for (ix = -126,i=(hx<<8); i>0; i<<=1) ix -=1;\x0a"
"\x09} else ix = (hx>>23)-127;\x0a"
"\x0a"
"    /* determine iy = ilogb(y) */\x0a"
"\x09if(hy<0x00800000) {\x09/* subnormal y */\x0a"
"\x09    for (iy = -126,i=(hy<<8); i>=0; i<<=1) iy -=1;\x0a"
"\x09} else iy = (hy>>23)-127;\x0a"
"\x0a"
"    /* set up {hx,lx}, {hy,ly} and align y to x */\x0a"
"\x09if(ix >= -126) \x0a"
"\x09    hx = 0x00800000\x7c(0x007fffff\x26hx);\x0a"
"\x09""else {\x09\x09/* subnormal x, shift x to normal */\x0a"
"\x09    n = -126-ix;\x0a"
"\x09    hx = hx<<n;\x0a"
"\x09}\x0a"
"\x09if(iy >= -126) \x0a"
"\x09    hy = 0x00800000\x7c(0x007fffff\x26hy);\x0a"
"\x09""else {\x09\x09/* subnormal y, shift y to normal */\x0a"
"\x09    n = -126-iy;\x0a"
"\x09    hy = hy<<n;\x0a"
"\x09}\x0a"
"\x0a"
"    /* fix point fmod */\x0a"
"\x09n = ix - iy;\x0a"
"\x09while(n--) {\x0a"
"\x09    hz=hx-hy;\x0a"
"\x09    if(hz<0){hx = hx+hx;}\x0a"
"\x09    else {\x0a"
"\x09    \x09if(hz==0) \x09\x09/* return sign(x)*0 */\x0a"
"\x09\x09    return Zero\x5b(u_int32_t)sx>>31\x5d;\x0a"
"\x09    \x09hx = hz+hz;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09hz=hx-hy;\x0a"
"\x09if(hz>=0) {hx=hz;}\x0a"
"\x0a"
"    /* convert back to floating value and restore the sign */\x0a"
"\x09if(hx==0) \x09\x09\x09/* return sign(x)*0 */\x0a"
"\x09    return Zero\x5b(u_int32_t)sx>>31\x5d;\x09\x0a"
"\x09while(hx<0x00800000) {\x09\x09/* normalize x */\x0a"
"\x09    hx = hx+hx;\x0a"
"\x09    iy -= 1;\x0a"
"\x09}\x0a"
"\x09if(iy>= -126) {\x09\x09/* normalize output */\x0a"
"\x09    hx = ((hx-0x00800000)\x7c((iy+127)<<23));\x0a"
"\x09    SET_FLOAT_WORD(x,hx\x7csx);\x0a"
"\x09} else {\x09\x09/* subnormal output */\x0a"
"\x09    n = -126 - iy;\x0a"
"\x09    hx >>= n;\x0a"
"\x09    SET_FLOAT_WORD(x,hx\x7csx);\x0a"
"\x09    x *= one;\x09\x09/* create necessary signal */\x0a"
"\x09}\x0a"
"\x09return x;\x09\x09/* exact output */\x0a"
"}\x0a"
"", 2581 ); }