#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_hypot_c( 
"/* \x40(#)e_hypot.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* hypot(x,y)\x0a"
" *\x0a"
" * Method \x3a                  \x0a"
" *\x09If (assume round-to-nearest) z=x*x+y*y \x0a"
" *\x09has error less than sqrt(2)/2 ulp, than \x0a"
" *\x09sqrt(z) has error less than 1 ulp (exercise).\x0a"
" *\x0a"
" *\x09So, compute sqrt(x*x+y*y) with some care as \x0a"
" *\x09""follows to get the error below 1 ulp\x3a\x0a"
" *\x0a"
" *\x09""Assume x>y>0;\x0a"
" *\x09(if possible, set rounding to round-to-nearest)\x0a"
" *\x09""1. if x > 2y  use\x0a"
" *\x09\x09x1*x1+(y*y+(x2*(x+x1))) for x*x+y*y\x0a"
" *\x09where x1 = x with lower 32 bits cleared, x2 = x-x1; else\x0a"
" *\x09""2. if x <= 2y use\x0a"
" *\x09\x09t1*yy1+((x-y)*(x-y)+(t1*y2+t2*y))\x0a"
" *\x09where t1 = 2x with lower 32 bits cleared, t2 = 2x-t1, \x0a"
" *\x09yy1= y with lower 32 bits chopped, y2 = y-yy1.\x0a"
" *\x09\x09\x0a"
" *\x09NOTE\x3a scaling may be necessary if some argument is too \x0a"
" *\x09      large or too tiny\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09hypot(x,y) is INF if x or y is +INF or -INF; else\x0a"
" *\x09hypot(x,y) is NAN if x or y is NAN.\x0a"
" *\x0a"
" * Accuracy\x3a\x0a"
" * \x09hypot(x,y) returns sqrt(x^2+y^2) with error less \x0a"
" * \x09than 1 ulps (units in the last place) \x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"double\x0a"
"hypot(double x, double y)\x0a"
"{\x0a"
"\x09""double a=x,b=y,t1,t2,yy1,y2,w;\x0a"
"\x09int32_t j,k,ha,hb;\x0a"
"\x0a"
"\x09GET_HIGH_WORD(ha,x);\x0a"
"\x09ha \x26= 0x7fffffff;\x0a"
"\x09GET_HIGH_WORD(hb,y);\x0a"
"\x09hb \x26= 0x7fffffff;\x0a"
"\x09if(hb > ha) {a=y;b=x;j=ha; ha=hb;hb=j;} else {a=x;b=y;}\x0a"
"\x09SET_HIGH_WORD(a,ha);\x09/* a <- \x7c""a\x7c */\x0a"
"\x09SET_HIGH_WORD(b,hb);\x09/* b <- \x7c""b\x7c */\x0a"
"\x09if((ha-hb)>0x3c00000) {return a+b;} /* x/y > 2**60 */\x0a"
"\x09k=0;\x0a"
"\x09if(ha > 0x5f300000) {\x09/* a>2**500 */\x0a"
"\x09   if(ha >= 0x7ff00000) {\x09/* Inf or NaN */\x0a"
"\x09       u_int32_t low;\x0a"
"\x09       w = a+b;\x09\x09\x09/* for sNaN */\x0a"
"\x09       GET_LOW_WORD(low,a);\x0a"
"\x09       if(((ha\x26""0xfffff)\x7clow)==0) w = a;\x0a"
"\x09       GET_LOW_WORD(low,b);\x0a"
"\x09       if(((hb^0x7ff00000)\x7clow)==0) w = b;\x0a"
"\x09       return w;\x0a"
"\x09   }\x0a"
"\x09   /* scale a and b by 2**-600 */\x0a"
"\x09   ha -= 0x25800000; hb -= 0x25800000;\x09k += 600;\x0a"
"\x09   SET_HIGH_WORD(a,ha);\x0a"
"\x09   SET_HIGH_WORD(b,hb);\x0a"
"\x09}\x0a"
"\x09if(hb < 0x20b00000) {\x09/* b < 2**-500 */\x0a"
"\x09    if(hb <= 0x000fffff) {\x09/* subnormal b or 0 */\x09\x0a"
"\x09        u_int32_t low;\x0a"
"\x09\x09GET_LOW_WORD(low,b);\x0a"
"\x09\x09if((hb\x7clow)==0) return a;\x0a"
"\x09\x09t1=0;\x0a"
"\x09\x09SET_HIGH_WORD(t1,0x7fd00000);\x09/* t1=2^1022 */\x0a"
"\x09\x09""b *= t1;\x0a"
"\x09\x09""a *= t1;\x0a"
"\x09\x09k -= 1022;\x0a"
"\x09    } else {\x09\x09/* scale a and b by 2^600 */\x0a"
"\x09        ha += 0x25800000; \x09/* a *= 2^600 */\x0a"
"\x09\x09hb += 0x25800000;\x09/* b *= 2^600 */\x0a"
"\x09\x09k -= 600;\x0a"
"\x09\x09SET_HIGH_WORD(a,ha);\x0a"
"\x09\x09SET_HIGH_WORD(b,hb);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    /* medium size a and b */\x0a"
"\x09w = a-b;\x0a"
"\x09if (w>b) {\x0a"
"\x09    t1 = 0;\x0a"
"\x09    SET_HIGH_WORD(t1,ha);\x0a"
"\x09    t2 = a-t1;\x0a"
"\x09    w  = sqrt(t1*t1-(b*(-b)-t2*(a+t1)));\x0a"
"\x09} else {\x0a"
"\x09    a  = a+a;\x0a"
"\x09    yy1 = 0;\x0a"
"\x09    SET_HIGH_WORD(yy1,hb);\x0a"
"\x09    y2 = b - yy1;\x0a"
"\x09    t1 = 0;\x0a"
"\x09    SET_HIGH_WORD(t1,ha+0x00100000);\x0a"
"\x09    t2 = a - t1;\x0a"
"\x09    w  = sqrt(t1*yy1-(w*(-w)-(t1*y2+t2*b)));\x0a"
"\x09}\x0a"
"\x09if(k\x21=0) {\x0a"
"\x09    u_int32_t high;\x0a"
"\x09    t1 = 1.0;\x0a"
"\x09    GET_HIGH_WORD(high,t1);\x0a"
"\x09    SET_HIGH_WORD(t1,high+(k<<20));\x0a"
"\x09    return t1*w;\x0a"
"\x09} else return w;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(hypotl, hypot);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 3310 ); }