#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_j0_c( 
"/* \x40(#)e_j0.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* j0(x), y0(x)\x0a"
" * Bessel function of the first and second kinds of order zero.\x0a"
" * Method -- j0(x)\x3a\x0a"
" *\x09""1. For tiny x, we use j0(x) = 1 - x^2/4 + x^4/64 - ...\x0a"
" *\x09""2. Reduce x to \x7cx\x7c since j0(x)=j0(-x),  and\x0a"
" *\x09   for x in (0,2)\x0a"
" *\x09\x09j0(x) = 1-z/4+ z^2*R0/S0,  where z = x*x;\x0a"
" *\x09   (precision\x3a  \x7cj0-1+z/4-z^2R0/S0 \x7c<2**-63.67 )\x0a"
" *\x09   for x in (2,inf)\x0a"
" * \x09\x09j0(x) = sqrt(2/(pi*x))*(p0(x)*cos(x0)-q0(x)*sin(x0))\x0a"
" * \x09   where x0 = x-pi/4. It is better to compute sin(x0),cos(x0)\x0a"
" *\x09   as follow\x3a\x0a"
" *\x09\x09""cos(x0) = cos(x)cos(pi/4)+sin(x)sin(pi/4)\x0a"
" *\x09\x09\x09= 1/sqrt(2) * (cos(x) + sin(x))\x0a"
" *\x09\x09sin(x0) = sin(x)cos(pi/4)-cos(x)sin(pi/4)\x0a"
" *\x09\x09\x09= 1/sqrt(2) * (sin(x) - cos(x))\x0a"
" * \x09   (To avoid cancellation, use\x0a"
" *\x09\x09sin(x) +- cos(x) = -cos(2x)/(sin(x) -+ cos(x))\x0a"
" * \x09    to compute the worse one.)\x0a"
" *\x09   \x0a"
" *\x09""3 Special cases\x0a"
" *\x09\x09j0(nan)= nan\x0a"
" *\x09\x09j0(0) = 1\x0a"
" *\x09\x09j0(inf) = 0\x0a"
" *\x09\x09\x0a"
" * Method -- y0(x)\x3a\x0a"
" *\x09""1. For x<2.\x0a"
" *\x09   Since \x0a"
" *\x09\x09y0(x) = 2/pi*(j0(x)*(ln(x/2)+Euler) + x^2/4 - ...)\x0a"
" *\x09   therefore y0(x)-2/pi*j0(x)*ln(x) is an even function.\x0a"
" *\x09   We use the following function to approximate y0,\x0a"
" *\x09\x09y0(x) = U(z)/V(z) + (2/pi)*(j0(x)*ln(x)), z= x^2\x0a"
" *\x09   where \x0a"
" *\x09\x09U(z) = u00 + u01*z + ... + u06*z^6\x0a"
" *\x09\x09V(z) = 1  + v01*z + ... + v04*z^4\x0a"
" *\x09   with absolute approximation error bounded by 2**-72.\x0a"
" *\x09   Note\x3a For tiny x, U/V = u0 and j0(x)\x7e""1, hence\x0a"
" *\x09\x09y0(tiny) = u0 + (2/pi)*ln(tiny), (choose tiny<2**-27)\x0a"
" *\x09""2. For x>=2.\x0a"
" * \x09\x09y0(x) = sqrt(2/(pi*x))*(p0(x)*cos(x0)+q0(x)*sin(x0))\x0a"
" * \x09   where x0 = x-pi/4. It is better to compute sin(x0),cos(x0)\x0a"
" *\x09   by the method mentioned above.\x0a"
" *\x09""3. Special cases\x3a y0(0)=-inf, y0(x<0)=NaN, y0(inf)=0.\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static double pzero(double), qzero(double);\x0a"
"\x0a"
"static const double \x0a"
"huge \x09= 1e300,\x0a"
"one\x09= 1.0,\x0a"
"invsqrtpi=  5.64189583547756279280e-01, /* 0x3FE20DD7, 0x50429B6D */\x0a"
"tpi      =  6.36619772367581382433e-01, /* 0x3FE45F30, 0x6DC9C883 */\x0a"
" \x09\x09/* R0/S0 on \x5b""0, 2.00\x5d */\x0a"
"R02  =  1.56249999999999947958e-02, /* 0x3F8FFFFF, 0xFFFFFFFD */\x0a"
"R03  = -1.89979294238854721751e-04, /* 0xBF28E6A5, 0xB61AC6E9 */\x0a"
"R04  =  1.82954049532700665670e-06, /* 0x3EBEB1D1, 0x0C503919 */\x0a"
"R05  = -4.61832688532103189199e-09, /* 0xBE33D5E7, 0x73D63FCE */\x0a"
"S01  =  1.56191029464890010492e-02, /* 0x3F8FFCE8, 0x82C8C2A4 */\x0a"
"S02  =  1.16926784663337450260e-04, /* 0x3F1EA6D2, 0xDD57DBF4 */\x0a"
"S03  =  5.13546550207318111446e-07, /* 0x3EA13B54, 0xCE84D5A9 */\x0a"
"S04  =  1.16614003333790000205e-09; /* 0x3E1408BC, 0xF4745D8F */\x0a"
"\x0a"
"static const double zero = 0.0;\x0a"
"\x0a"
"double\x0a"
"j0(double x) \x0a"
"{\x0a"
"\x09""double z, s,c,ss,cc,r,u,v;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x7ff00000) return one/(x*x);\x0a"
"\x09x = fabs(x);\x0a"
"\x09if(ix >= 0x40000000) {\x09/* \x7cx\x7c >= 2.0 */\x0a"
"\x09\x09s = sin(x);\x0a"
"\x09\x09""c = cos(x);\x0a"
"\x09\x09ss = s-c;\x0a"
"\x09\x09""cc = s+c;\x0a"
"\x09\x09if(ix<0x7fe00000) {  /* make sure x+x not overflow */\x0a"
"\x09\x09    z = -cos(x+x);\x0a"
"\x09\x09    if ((s*c)<zero) cc = z/ss;\x0a"
"\x09\x09    else \x09    ss = z/cc;\x0a"
"\x09\x09}\x0a"
"\x09/*\x0a"
"\x09 * j0(x) = 1/sqrt(pi) * (P(0,x)*cc - Q(0,x)*ss) / sqrt(x)\x0a"
"\x09 * y0(x) = 1/sqrt(pi) * (P(0,x)*ss + Q(0,x)*cc) / sqrt(x)\x0a"
"\x09 */\x0a"
"\x09\x09if(ix>0x48000000) z = (invsqrtpi*cc)/sqrt(x);\x0a"
"\x09\x09""else {\x0a"
"\x09\x09    u = pzero(x); v = qzero(x);\x0a"
"\x09\x09    z = invsqrtpi*(u*cc-v*ss)/sqrt(x);\x0a"
"\x09\x09}\x0a"
"\x09\x09return z;\x0a"
"\x09}\x0a"
"\x09if(ix<0x3f200000) {\x09/* \x7cx\x7c < 2**-13 */\x0a"
"\x09    if(huge+x>one) {\x09/* raise inexact if x \x21= 0 */\x0a"
"\x09        if(ix<0x3e400000) return one;\x09/* \x7cx\x7c<2**-27 */\x0a"
"\x09        else \x09      return one - 0.25*x*x;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09z = x*x;\x0a"
"\x09r =  z*(R02+z*(R03+z*(R04+z*R05)));\x0a"
"\x09s =  one+z*(S01+z*(S02+z*(S03+z*S04)));\x0a"
"\x09if(ix < 0x3FF00000) {\x09/* \x7cx\x7c < 1.00 */\x0a"
"\x09    return one + z*(-0.25+(r/s));\x0a"
"\x09} else {\x0a"
"\x09    u = 0.5*x;\x0a"
"\x09    return((one+u)*(one-u)+z*(r/s));\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"static const double\x0a"
"u00  = -7.38042951086872317523e-02, /* 0xBFB2E4D6, 0x99CBD01F */\x0a"
"u01  =  1.76666452509181115538e-01, /* 0x3FC69D01, 0x9DE9E3FC */\x0a"
"u02  = -1.38185671945596898896e-02, /* 0xBF8C4CE8, 0xB16CFA97 */\x0a"
"u03  =  3.47453432093683650238e-04, /* 0x3F36C54D, 0x20B29B6B */\x0a"
"u04  = -3.81407053724364161125e-06, /* 0xBECFFEA7, 0x73D25CAD */\x0a"
"u05  =  1.95590137035022920206e-08, /* 0x3E550057, 0x3B4EABD4 */\x0a"
"u06  = -3.98205194132103398453e-11, /* 0xBDC5E43D, 0x693FB3C8 */\x0a"
"v01  =  1.27304834834123699328e-02, /* 0x3F8A1270, 0x91C9C71A */\x0a"
"v02  =  7.60068627350353253702e-05, /* 0x3F13ECBB, 0xF578C6C1 */\x0a"
"v03  =  2.59150851840457805467e-07, /* 0x3E91642D, 0x7FF202FD */\x0a"
"v04  =  4.41110311332675467403e-10; /* 0x3DFE5018, 0x3BD6D9EF */\x0a"
"\x0a"
"double\x0a"
"y0(double x) \x0a"
"{\x0a"
"\x09""double z, s,c,ss,cc,u,v;\x0a"
"\x09int32_t hx,ix,lx;\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"        ix = 0x7fffffff\x26hx;\x0a"
"    /* Y0(NaN) is NaN, y0(-inf) is Nan, y0(inf) is 0  */\x0a"
"\x09if(ix>=0x7ff00000) return  one/(x+x*x); \x0a"
"        if((ix\x7clx)==0) return -one/zero;\x0a"
"        if(hx<0) return zero/zero;\x0a"
"        if(ix >= 0x40000000) {  /* \x7cx\x7c >= 2.0 */\x0a"
"        /* y0(x) = sqrt(2/(pi*x))*(p0(x)*sin(x0)+q0(x)*cos(x0))\x0a"
"         * where x0 = x-pi/4\x0a"
"         *      Better formula\x3a\x0a"
"         *              cos(x0) = cos(x)cos(pi/4)+sin(x)sin(pi/4)\x0a"
"         *                      =  1/sqrt(2) * (sin(x) + cos(x))\x0a"
"         *              sin(x0) = sin(x)cos(3pi/4)-cos(x)sin(3pi/4)\x0a"
"         *                      =  1/sqrt(2) * (sin(x) - cos(x))\x0a"
"         * To avoid cancellation, use\x0a"
"         *              sin(x) +- cos(x) = -cos(2x)/(sin(x) -+ cos(x))\x0a"
"         * to compute the worse one.\x0a"
"         */\x0a"
"                s = sin(x);\x0a"
"                c = cos(x);\x0a"
"                ss = s-c;\x0a"
"                cc = s+c;\x0a"
"\x09/*\x0a"
"\x09 * j0(x) = 1/sqrt(pi) * (P(0,x)*cc - Q(0,x)*ss) / sqrt(x)\x0a"
"\x09 * y0(x) = 1/sqrt(pi) * (P(0,x)*ss + Q(0,x)*cc) / sqrt(x)\x0a"
"\x09 */\x0a"
"                if(ix<0x7fe00000) {  /* make sure x+x not overflow */\x0a"
"                    z = -cos(x+x);\x0a"
"                    if ((s*c)<zero) cc = z/ss;\x0a"
"                    else            ss = z/cc;\x0a"
"                }\x0a"
"                if(ix>0x48000000) z = (invsqrtpi*ss)/sqrt(x);\x0a"
"                else {\x0a"
"                    u = pzero(x); v = qzero(x);\x0a"
"                    z = invsqrtpi*(u*ss+v*cc)/sqrt(x);\x0a"
"                }\x0a"
"                return z;\x0a"
"\x09}\x0a"
"\x09if(ix<=0x3e400000) {\x09/* x < 2**-27 */\x0a"
"\x09    return(u00 + tpi*log(x));\x0a"
"\x09}\x0a"
"\x09z = x*x;\x0a"
"\x09u = u00+z*(u01+z*(u02+z*(u03+z*(u04+z*(u05+z*u06)))));\x0a"
"\x09v = one+z*(v01+z*(v02+z*(v03+z*v04)));\x0a"
"\x09return(u/v + tpi*(j0(x)*log(x)));\x0a"
"}\x0a"
"\x0a"
"/* The asymptotic expansions of pzero is\x0a"
" *\x09""1 - 9/128 s^2 + 11025/98304 s^4 - ...,\x09where s = 1/x.\x0a"
" * For x >= 2, We approximate pzero by\x0a"
" * \x09pzero(x) = 1 + (R/S)\x0a"
" * where  R = pR0 + pR1*s^2 + pR2*s^4 + ... + pR5*s^10\x0a"
" * \x09  S = 1 + pS0*s^2 + ... + pS4*s^10\x0a"
" * and\x0a"
" *\x09\x7c pzero(x)-1-R/S \x7c <= 2  ** ( -60.26)\x0a"
" */\x0a"
"static const double pR8\x5b""6\x5d = { /* for x in \x5binf, 8\x5d=1/\x5b""0,0.125\x5d */\x0a"
"  0.00000000000000000000e+00, /* 0x00000000, 0x00000000 */\x0a"
" -7.03124999999900357484e-02, /* 0xBFB1FFFF, 0xFFFFFD32 */\x0a"
" -8.08167041275349795626e+00, /* 0xC02029D0, 0xB44FA779 */\x0a"
" -2.57063105679704847262e+02, /* 0xC0701102, 0x7B19E863 */\x0a"
" -2.48521641009428822144e+03, /* 0xC0A36A6E, 0xCD4DCAFC */\x0a"
" -5.25304380490729545272e+03, /* 0xC0B4850B, 0x36CC643D */\x0a"
"};\x0a"
"static const double pS8\x5b""5\x5d = {\x0a"
"  1.16534364619668181717e+02, /* 0x405D2233, 0x07A96751 */\x0a"
"  3.83374475364121826715e+03, /* 0x40ADF37D, 0x50596938 */\x0a"
"  4.05978572648472545552e+04, /* 0x40E3D2BB, 0x6EB6B05F */\x0a"
"  1.16752972564375915681e+05, /* 0x40FC810F, 0x8F9FA9BD */\x0a"
"  4.76277284146730962675e+04, /* 0x40E74177, 0x4F2C49DC */\x0a"
"};\x0a"
"\x0a"
"static const double pR5\x5b""6\x5d = { /* for x in \x5b""8,4.5454\x5d=1/\x5b""0.125,0.22001\x5d */\x0a"
" -1.14125464691894502584e-11, /* 0xBDA918B1, 0x47E495CC */\x0a"
" -7.03124940873599280078e-02, /* 0xBFB1FFFF, 0xE69AFBC6 */\x0a"
" -4.15961064470587782438e+00, /* 0xC010A370, 0xF90C6BBF */\x0a"
" -6.76747652265167261021e+01, /* 0xC050EB2F, 0x5A7D1783 */\x0a"
" -3.31231299649172967747e+02, /* 0xC074B3B3, 0x6742CC63 */\x0a"
" -3.46433388365604912451e+02, /* 0xC075A6EF, 0x28A38BD7 */\x0a"
"};\x0a"
"static const double pS5\x5b""5\x5d = {\x0a"
"  6.07539382692300335975e+01, /* 0x404E6081, 0x0C98C5DE */\x0a"
"  1.05125230595704579173e+03, /* 0x40906D02, 0x5C7E2864 */\x0a"
"  5.97897094333855784498e+03, /* 0x40B75AF8, 0x8FBE1D60 */\x0a"
"  9.62544514357774460223e+03, /* 0x40C2CCB8, 0xFA76FA38 */\x0a"
"  2.40605815922939109441e+03, /* 0x40A2CC1D, 0xC70BE864 */\x0a"
"};\x0a"
"\x0a"
"static const double pR3\x5b""6\x5d = {/* for x in \x5b""4.547,2.8571\x5d=1/\x5b""0.2199,0.35001\x5d */\x0a"
" -2.54704601771951915620e-09, /* 0xBE25E103, 0x6FE1AA86 */\x0a"
" -7.03119616381481654654e-02, /* 0xBFB1FFF6, 0xF7C0E24B */\x0a"
" -2.40903221549529611423e+00, /* 0xC00345B2, 0xAEA48074 */\x0a"
" -2.19659774734883086467e+01, /* 0xC035F74A, 0x4CB94E14 */\x0a"
" -5.80791704701737572236e+01, /* 0xC04D0A22, 0x420A1A45 */\x0a"
" -3.14479470594888503854e+01, /* 0xC03F72AC, 0xA892D80F */\x0a"
"};\x0a"
"static const double pS3\x5b""5\x5d = {\x0a"
"  3.58560338055209726349e+01, /* 0x4041ED92, 0x84077DD3 */\x0a"
"  3.61513983050303863820e+02, /* 0x40769839, 0x464A7C0E */\x0a"
"  1.19360783792111533330e+03, /* 0x4092A66E, 0x6D1061D6 */\x0a"
"  1.12799679856907414432e+03, /* 0x40919FFC, 0xB8C39B7E */\x0a"
"  1.73580930813335754692e+02, /* 0x4065B296, 0xFC379081 */\x0a"
"};\x0a"
"\x0a"
"static const double pR2\x5b""6\x5d = {/* for x in \x5b""2.8570,2\x5d=1/\x5b""0.3499,0.5\x5d */\x0a"
" -8.87534333032526411254e-08, /* 0xBE77D316, 0xE927026D */\x0a"
" -7.03030995483624743247e-02, /* 0xBFB1FF62, 0x495E1E42 */\x0a"
" -1.45073846780952986357e+00, /* 0xBFF73639, 0x8A24A843 */\x0a"
" -7.63569613823527770791e+00, /* 0xC01E8AF3, 0xEDAFA7F3 */\x0a"
" -1.11931668860356747786e+01, /* 0xC02662E6, 0xC5246303 */\x0a"
" -3.23364579351335335033e+00, /* 0xC009DE81, 0xAF8FE70F */\x0a"
"};\x0a"
"static const double pS2\x5b""5\x5d = {\x0a"
"  2.22202997532088808441e+01, /* 0x40363865, 0x908B5959 */\x0a"
"  1.36206794218215208048e+02, /* 0x4061069E, 0x0EE8878F */\x0a"
"  2.70470278658083486789e+02, /* 0x4070E786, 0x42EA079B */\x0a"
"  1.53875394208320329881e+02, /* 0x40633C03, 0x3AB6FAFF */\x0a"
"  1.46576176948256193810e+01, /* 0x402D50B3, 0x44391809 */\x0a"
"};\x0a"
"\x0a"
"static double\x0a"
"pzero(double x)\x0a"
"{\x0a"
"\x09""const double *p,*q;\x0a"
"\x09""double z,r,s;\x0a"
"\x09int32_t ix;\x0a"
"\x09GET_HIGH_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"\x09if(ix>=0x40200000)     {p = pR8; q= pS8;}\x0a"
"\x09""else if(ix>=0x40122E8B){p = pR5; q= pS5;}\x0a"
"\x09""else if(ix>=0x4006DB6D){p = pR3; q= pS3;}\x0a"
"\x09""else if(ix>=0x40000000){p = pR2; q= pS2;}\x0a"
"\x09z = one/(x*x);\x0a"
"\x09r = p\x5b""0\x5d+z*(p\x5b""1\x5d+z*(p\x5b""2\x5d+z*(p\x5b""3\x5d+z*(p\x5b""4\x5d+z*p\x5b""5\x5d))));\x0a"
"\x09s = one+z*(q\x5b""0\x5d+z*(q\x5b""1\x5d+z*(q\x5b""2\x5d+z*(q\x5b""3\x5d+z*q\x5b""4\x5d))));\x0a"
"\x09return one+ r/s;\x0a"
"}\x0a"
"\x09\x09\x0a"
"\x0a"
"/* For x >= 8, the asymptotic expansions of qzero is\x0a"
" *\x09-1/8 s + 75/1024 s^3 - ..., where s = 1/x.\x0a"
" * We approximate pzero by\x0a"
" * \x09qzero(x) = s*(-1.25 + (R/S))\x0a"
" * where  R = qR0 + qR1*s^2 + qR2*s^4 + ... + qR5*s^10\x0a"
" * \x09  S = 1 + qS0*s^2 + ... + qS5*s^12\x0a"
" * and\x0a"
" *\x09\x7c qzero(x)/s +1.25-R/S \x7c <= 2  ** ( -61.22)\x0a"
" */\x0a"
"static const double qR8\x5b""6\x5d = { /* for x in \x5binf, 8\x5d=1/\x5b""0,0.125\x5d */\x0a"
"  0.00000000000000000000e+00, /* 0x00000000, 0x00000000 */\x0a"
"  7.32421874999935051953e-02, /* 0x3FB2BFFF, 0xFFFFFE2C */\x0a"
"  1.17682064682252693899e+01, /* 0x40278952, 0x5BB334D6 */\x0a"
"  5.57673380256401856059e+02, /* 0x40816D63, 0x15301825 */\x0a"
"  8.85919720756468632317e+03, /* 0x40C14D99, 0x3E18F46D */\x0a"
"  3.70146267776887834771e+04, /* 0x40E212D4, 0x0E901566 */\x0a"
"};\x0a"
"static const double qS8\x5b""6\x5d = {\x0a"
"  1.63776026895689824414e+02, /* 0x406478D5, 0x365B39BC */\x0a"
"  8.09834494656449805916e+03, /* 0x40BFA258, 0x4E6B0563 */\x0a"
"  1.42538291419120476348e+05, /* 0x41016652, 0x54D38C3F */\x0a"
"  8.03309257119514397345e+05, /* 0x412883DA, 0x83A52B43 */\x0a"
"  8.40501579819060512818e+05, /* 0x4129A66B, 0x28DE0B3D */\x0a"
" -3.43899293537866615225e+05, /* 0xC114FD6D, 0x2C9530C5 */\x0a"
"};\x0a"
"\x0a"
"static const double qR5\x5b""6\x5d = { /* for x in \x5b""8,4.5454\x5d=1/\x5b""0.125,0.22001\x5d */\x0a"
"  1.84085963594515531381e-11, /* 0x3DB43D8F, 0x29CC8CD9 */\x0a"
"  7.32421766612684765896e-02, /* 0x3FB2BFFF, 0xD172B04C */\x0a"
"  5.83563508962056953777e+00, /* 0x401757B0, 0xB9953DD3 */\x0a"
"  1.35111577286449829671e+02, /* 0x4060E392, 0x0A8788E9 */\x0a"
"  1.02724376596164097464e+03, /* 0x40900CF9, 0x9DC8C481 */\x0a"
"  1.98997785864605384631e+03, /* 0x409F17E9, 0x53C6E3A6 */\x0a"
"};\x0a"
"static const double qS5\x5b""6\x5d = {\x0a"
"  8.27766102236537761883e+01, /* 0x4054B1B3, 0xFB5E1543 */\x0a"
"  2.07781416421392987104e+03, /* 0x40A03BA0, 0xDA21C0CE */\x0a"
"  1.88472887785718085070e+04, /* 0x40D267D2, 0x7B591E6D */\x0a"
"  5.67511122894947329769e+04, /* 0x40EBB5E3, 0x97E02372 */\x0a"
"  3.59767538425114471465e+04, /* 0x40E19118, 0x1F7A54A0 */\x0a"
" -5.35434275601944773371e+03, /* 0xC0B4EA57, 0xBEDBC609 */\x0a"
"};\x0a"
"\x0a"
"static const double qR3\x5b""6\x5d = {/* for x in \x5b""4.547,2.8571\x5d=1/\x5b""0.2199,0.35001\x5d */\x0a"
"  4.37741014089738620906e-09, /* 0x3E32CD03, 0x6ADECB82 */\x0a"
"  7.32411180042911447163e-02, /* 0x3FB2BFEE, 0x0E8D0842 */\x0a"
"  3.34423137516170720929e+00, /* 0x400AC0FC, 0x61149CF5 */\x0a"
"  4.26218440745412650017e+01, /* 0x40454F98, 0x962DAEDD */\x0a"
"  1.70808091340565596283e+02, /* 0x406559DB, 0xE25EFD1F */\x0a"
"  1.66733948696651168575e+02, /* 0x4064D77C, 0x81FA21E0 */\x0a"
"};\x0a"
"static const double qS3\x5b""6\x5d = {\x0a"
"  4.87588729724587182091e+01, /* 0x40486122, 0xBFE343A6 */\x0a"
"  7.09689221056606015736e+02, /* 0x40862D83, 0x86544EB3 */\x0a"
"  3.70414822620111362994e+03, /* 0x40ACF04B, 0xE44DFC63 */\x0a"
"  6.46042516752568917582e+03, /* 0x40B93C6C, 0xD7C76A28 */\x0a"
"  2.51633368920368957333e+03, /* 0x40A3A8AA, 0xD94FB1C0 */\x0a"
" -1.49247451836156386662e+02, /* 0xC062A7EB, 0x201CF40F */\x0a"
"};\x0a"
"\x0a"
"static const double qR2\x5b""6\x5d = {/* for x in \x5b""2.8570,2\x5d=1/\x5b""0.3499,0.5\x5d */\x0a"
"  1.50444444886983272379e-07, /* 0x3E84313B, 0x54F76BDB */\x0a"
"  7.32234265963079278272e-02, /* 0x3FB2BEC5, 0x3E883E34 */\x0a"
"  1.99819174093815998816e+00, /* 0x3FFFF897, 0xE727779C */\x0a"
"  1.44956029347885735348e+01, /* 0x402CFDBF, 0xAAF96FE5 */\x0a"
"  3.16662317504781540833e+01, /* 0x403FAA8E, 0x29FBDC4A */\x0a"
"  1.62527075710929267416e+01, /* 0x403040B1, 0x71814BB4 */\x0a"
"};\x0a"
"static const double qS2\x5b""6\x5d = {\x0a"
"  3.03655848355219184498e+01, /* 0x403E5D96, 0xF7C07AED */\x0a"
"  2.69348118608049844624e+02, /* 0x4070D591, 0xE4D14B40 */\x0a"
"  8.44783757595320139444e+02, /* 0x408A6645, 0x22B3BF22 */\x0a"
"  8.82935845112488550512e+02, /* 0x408B977C, 0x9C5CC214 */\x0a"
"  2.12666388511798828631e+02, /* 0x406A9553, 0x0E001365 */\x0a"
" -5.31095493882666946917e+00, /* 0xC0153E6A, 0xF8B32931 */\x0a"
"};\x0a"
"\x0a"
"static double\x0a"
"qzero(double x)\x0a"
"{\x0a"
"\x09""const double *p,*q;\x0a"
"\x09""double s,r,z;\x0a"
"\x09int32_t ix;\x0a"
"\x09GET_HIGH_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"\x09if(ix>=0x40200000)     {p = qR8; q= qS8;}\x0a"
"\x09""else if(ix>=0x40122E8B){p = qR5; q= qS5;}\x0a"
"\x09""else if(ix>=0x4006DB6D){p = qR3; q= qS3;}\x0a"
"\x09""else if(ix>=0x40000000){p = qR2; q= qS2;}\x0a"
"\x09z = one/(x*x);\x0a"
"\x09r = p\x5b""0\x5d+z*(p\x5b""1\x5d+z*(p\x5b""2\x5d+z*(p\x5b""3\x5d+z*(p\x5b""4\x5d+z*p\x5b""5\x5d))));\x0a"
"\x09s = one+z*(q\x5b""0\x5d+z*(q\x5b""1\x5d+z*(q\x5b""2\x5d+z*(q\x5b""3\x5d+z*(q\x5b""4\x5d+z*q\x5b""5\x5d)))));\x0a"
"\x09return (-.125 + r/s)/x;\x0a"
"}\x0a"
"", 14363 ); }