#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_j0f_c( 
"/* e_j0f.c -- float version of e_j0.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static float pzerof(float), qzerof(float);\x0a"
"\x0a"
"static const float \x0a"
"huge \x09= 1e30,\x0a"
"one\x09= 1.0,\x0a"
"invsqrtpi=  5.6418961287e-01, /* 0x3f106ebb */\x0a"
"tpi      =  6.3661974669e-01, /* 0x3f22f983 */\x0a"
" \x09\x09/* R0/S0 on \x5b""0, 2.00\x5d */\x0a"
"R02  =  1.5625000000e-02, /* 0x3c800000 */\x0a"
"R03  = -1.8997929874e-04, /* 0xb947352e */\x0a"
"R04  =  1.8295404516e-06, /* 0x35f58e88 */\x0a"
"R05  = -4.6183270541e-09, /* 0xb19eaf3c */\x0a"
"S01  =  1.5619102865e-02, /* 0x3c7fe744 */\x0a"
"S02  =  1.1692678527e-04, /* 0x38f53697 */\x0a"
"S03  =  5.1354652442e-07, /* 0x3509daa6 */\x0a"
"S04  =  1.1661400734e-09; /* 0x30a045e8 */\x0a"
"\x0a"
"static const float zero = 0.0;\x0a"
"\x0a"
"float\x0a"
"j0f(float x) \x0a"
"{\x0a"
"\x09""float z, s,c,ss,cc,r,u,v;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x7f800000) return one/(x*x);\x0a"
"\x09x = fabsf(x);\x0a"
"\x09if(ix >= 0x40000000) {\x09/* \x7cx\x7c >= 2.0 */\x0a"
"\x09\x09s = sinf(x);\x0a"
"\x09\x09""c = cosf(x);\x0a"
"\x09\x09ss = s-c;\x0a"
"\x09\x09""cc = s+c;\x0a"
"\x09\x09if(ix<0x7f000000) {  /* make sure x+x not overflow */\x0a"
"\x09\x09    z = -cosf(x+x);\x0a"
"\x09\x09    if ((s*c)<zero) cc = z/ss;\x0a"
"\x09\x09    else \x09    ss = z/cc;\x0a"
"\x09\x09}\x0a"
"\x09/*\x0a"
"\x09 * j0(x) = 1/sqrt(pi) * (P(0,x)*cc - Q(0,x)*ss) / sqrt(x)\x0a"
"\x09 * y0(x) = 1/sqrt(pi) * (P(0,x)*ss + Q(0,x)*cc) / sqrt(x)\x0a"
"\x09 */\x0a"
"\x09\x09if(ix>0x80000000U) z = (invsqrtpi*cc)/sqrtf(x);\x0a"
"\x09\x09""else {\x0a"
"\x09\x09    u = pzerof(x); v = qzerof(x);\x0a"
"\x09\x09    z = invsqrtpi*(u*cc-v*ss)/sqrtf(x);\x0a"
"\x09\x09}\x0a"
"\x09\x09return z;\x0a"
"\x09}\x0a"
"\x09if(ix<0x39000000) {\x09/* \x7cx\x7c < 2**-13 */\x0a"
"\x09    if(huge+x>one) {\x09/* raise inexact if x \x21= 0 */\x0a"
"\x09        if(ix<0x32000000) return one;\x09/* \x7cx\x7c<2**-27 */\x0a"
"\x09        else \x09      return one - (float)0.25*x*x;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09z = x*x;\x0a"
"\x09r =  z*(R02+z*(R03+z*(R04+z*R05)));\x0a"
"\x09s =  one+z*(S01+z*(S02+z*(S03+z*S04)));\x0a"
"\x09if(ix < 0x3F800000) {\x09/* \x7cx\x7c < 1.00 */\x0a"
"\x09    return one + z*((float)-0.25+(r/s));\x0a"
"\x09} else {\x0a"
"\x09    u = (float)0.5*x;\x0a"
"\x09    return((one+u)*(one-u)+z*(r/s));\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"static const float\x0a"
"u00  = -7.3804296553e-02, /* 0xbd9726b5 */\x0a"
"u01  =  1.7666645348e-01, /* 0x3e34e80d */\x0a"
"u02  = -1.3818567619e-02, /* 0xbc626746 */\x0a"
"u03  =  3.4745343146e-04, /* 0x39b62a69 */\x0a"
"u04  = -3.8140706238e-06, /* 0xb67ff53c */\x0a"
"u05  =  1.9559013964e-08, /* 0x32a802ba */\x0a"
"u06  = -3.9820518410e-11, /* 0xae2f21eb */\x0a"
"v01  =  1.2730483897e-02, /* 0x3c509385 */\x0a"
"v02  =  7.6006865129e-05, /* 0x389f65e0 */\x0a"
"v03  =  2.5915085189e-07, /* 0x348b216c */\x0a"
"v04  =  4.4111031494e-10; /* 0x2ff280c2 */\x0a"
"\x0a"
"float\x0a"
"y0f(float x) \x0a"
"{\x0a"
"\x09""float z, s,c,ss,cc,u,v;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"        ix = 0x7fffffff\x26hx;\x0a"
"    /* Y0(NaN) is NaN, y0(-inf) is Nan, y0(inf) is 0  */\x0a"
"\x09if(ix>=0x7f800000) return  one/(x+x*x); \x0a"
"        if(ix==0) return -one/zero;\x0a"
"        if(hx<0) return zero/zero;\x0a"
"        if(ix >= 0x40000000) {  /* \x7cx\x7c >= 2.0 */\x0a"
"        /* y0(x) = sqrt(2/(pi*x))*(p0(x)*sin(x0)+q0(x)*cos(x0))\x0a"
"         * where x0 = x-pi/4\x0a"
"         *      Better formula\x3a\x0a"
"         *              cos(x0) = cos(x)cos(pi/4)+sin(x)sin(pi/4)\x0a"
"         *                      =  1/sqrt(2) * (sin(x) + cos(x))\x0a"
"         *              sin(x0) = sin(x)cos(3pi/4)-cos(x)sin(3pi/4)\x0a"
"         *                      =  1/sqrt(2) * (sin(x) - cos(x))\x0a"
"         * To avoid cancellation, use\x0a"
"         *              sin(x) +- cos(x) = -cos(2x)/(sin(x) -+ cos(x))\x0a"
"         * to compute the worse one.\x0a"
"         */\x0a"
"                s = sinf(x);\x0a"
"                c = cosf(x);\x0a"
"                ss = s-c;\x0a"
"                cc = s+c;\x0a"
"\x09/*\x0a"
"\x09 * j0(x) = 1/sqrt(pi) * (P(0,x)*cc - Q(0,x)*ss) / sqrt(x)\x0a"
"\x09 * y0(x) = 1/sqrt(pi) * (P(0,x)*ss + Q(0,x)*cc) / sqrt(x)\x0a"
"\x09 */\x0a"
"                if(ix<0x7f000000) {  /* make sure x+x not overflow */\x0a"
"                    z = -cosf(x+x);\x0a"
"                    if ((s*c)<zero) cc = z/ss;\x0a"
"                    else            ss = z/cc;\x0a"
"                }\x0a"
"                if(ix>0x80000000U) z = (invsqrtpi*ss)/sqrtf(x);\x0a"
"                else {\x0a"
"                    u = pzerof(x); v = qzerof(x);\x0a"
"                    z = invsqrtpi*(u*ss+v*cc)/sqrtf(x);\x0a"
"                }\x0a"
"                return z;\x0a"
"\x09}\x0a"
"\x09if(ix<=0x32000000) {\x09/* x < 2**-27 */\x0a"
"\x09    return(u00 + tpi*logf(x));\x0a"
"\x09}\x0a"
"\x09z = x*x;\x0a"
"\x09u = u00+z*(u01+z*(u02+z*(u03+z*(u04+z*(u05+z*u06)))));\x0a"
"\x09v = one+z*(v01+z*(v02+z*(v03+z*v04)));\x0a"
"\x09return(u/v + tpi*(j0f(x)*logf(x)));\x0a"
"}\x0a"
"\x0a"
"/* The asymptotic expansions of pzero is\x0a"
" *\x09""1 - 9/128 s^2 + 11025/98304 s^4 - ...,\x09where s = 1/x.\x0a"
" * For x >= 2, We approximate pzero by\x0a"
" * \x09pzero(x) = 1 + (R/S)\x0a"
" * where  R = pR0 + pR1*s^2 + pR2*s^4 + ... + pR5*s^10\x0a"
" * \x09  S = 1 + pS0*s^2 + ... + pS4*s^10\x0a"
" * and\x0a"
" *\x09\x7c pzero(x)-1-R/S \x7c <= 2  ** ( -60.26)\x0a"
" */\x0a"
"static const float pR8\x5b""6\x5d = { /* for x in \x5binf, 8\x5d=1/\x5b""0,0.125\x5d */\x0a"
"  0.0000000000e+00, /* 0x00000000 */\x0a"
" -7.0312500000e-02, /* 0xbd900000 */\x0a"
" -8.0816707611e+00, /* 0xc1014e86 */\x0a"
" -2.5706311035e+02, /* 0xc3808814 */\x0a"
" -2.4852163086e+03, /* 0xc51b5376 */\x0a"
" -5.2530439453e+03, /* 0xc5a4285a */\x0a"
"};\x0a"
"static const float pS8\x5b""5\x5d = {\x0a"
"  1.1653436279e+02, /* 0x42e91198 */\x0a"
"  3.8337448730e+03, /* 0x456f9beb */\x0a"
"  4.0597855469e+04, /* 0x471e95db */\x0a"
"  1.1675296875e+05, /* 0x47e4087c */\x0a"
"  4.7627726562e+04, /* 0x473a0bba */\x0a"
"};\x0a"
"static const float pR5\x5b""6\x5d = { /* for x in \x5b""8,4.5454\x5d=1/\x5b""0.125,0.22001\x5d */\x0a"
" -1.1412546255e-11, /* 0xad48c58a */\x0a"
" -7.0312492549e-02, /* 0xbd8fffff */\x0a"
" -4.1596107483e+00, /* 0xc0851b88 */\x0a"
" -6.7674766541e+01, /* 0xc287597b */\x0a"
" -3.3123129272e+02, /* 0xc3a59d9b */\x0a"
" -3.4643338013e+02, /* 0xc3ad3779 */\x0a"
"};\x0a"
"static const float pS5\x5b""5\x5d = {\x0a"
"  6.0753936768e+01, /* 0x42730408 */\x0a"
"  1.0512523193e+03, /* 0x44836813 */\x0a"
"  5.9789707031e+03, /* 0x45bad7c4 */\x0a"
"  9.6254453125e+03, /* 0x461665c8 */\x0a"
"  2.4060581055e+03, /* 0x451660ee */\x0a"
"};\x0a"
"\x0a"
"static const float pR3\x5b""6\x5d = {/* for x in \x5b""4.547,2.8571\x5d=1/\x5b""0.2199,0.35001\x5d */\x0a"
" -2.5470459075e-09, /* 0xb12f081b */\x0a"
" -7.0311963558e-02, /* 0xbd8fffb8 */\x0a"
" -2.4090321064e+00, /* 0xc01a2d95 */\x0a"
" -2.1965976715e+01, /* 0xc1afba52 */\x0a"
" -5.8079170227e+01, /* 0xc2685112 */\x0a"
" -3.1447946548e+01, /* 0xc1fb9565 */\x0a"
"};\x0a"
"static const float pS3\x5b""5\x5d = {\x0a"
"  3.5856033325e+01, /* 0x420f6c94 */\x0a"
"  3.6151397705e+02, /* 0x43b4c1ca */\x0a"
"  1.1936077881e+03, /* 0x44953373 */\x0a"
"  1.1279968262e+03, /* 0x448cffe6 */\x0a"
"  1.7358093262e+02, /* 0x432d94b8 */\x0a"
"};\x0a"
"\x0a"
"static const float pR2\x5b""6\x5d = {/* for x in \x5b""2.8570,2\x5d=1/\x5b""0.3499,0.5\x5d */\x0a"
" -8.8753431271e-08, /* 0xb3be98b7 */\x0a"
" -7.0303097367e-02, /* 0xbd8ffb12 */\x0a"
" -1.4507384300e+00, /* 0xbfb9b1cc */\x0a"
" -7.6356959343e+00, /* 0xc0f4579f */\x0a"
" -1.1193166733e+01, /* 0xc1331736 */\x0a"
" -3.2336456776e+00, /* 0xc04ef40d */\x0a"
"};\x0a"
"static const float pS2\x5b""5\x5d = {\x0a"
"  2.2220300674e+01, /* 0x41b1c32d */\x0a"
"  1.3620678711e+02, /* 0x430834f0 */\x0a"
"  2.7047027588e+02, /* 0x43873c32 */\x0a"
"  1.5387539673e+02, /* 0x4319e01a */\x0a"
"  1.4657617569e+01, /* 0x416a859a */\x0a"
"};\x0a"
"\x0a"
"static float\x0a"
"pzerof(float x)\x0a"
"{\x0a"
"\x09""const float *p,*q;\x0a"
"\x09""float z,r,s;\x0a"
"\x09int32_t ix;\x0a"
"\x09GET_FLOAT_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"\x09if(ix>=0x41000000)     {p = pR8; q= pS8;}\x0a"
"\x09""else if(ix>=0x40f71c58){p = pR5; q= pS5;}\x0a"
"\x09""else if(ix>=0x4036db68){p = pR3; q= pS3;}\x0a"
"\x09""else if(ix>=0x40000000){p = pR2; q= pS2;}\x0a"
"\x09z = one/(x*x);\x0a"
"\x09r = p\x5b""0\x5d+z*(p\x5b""1\x5d+z*(p\x5b""2\x5d+z*(p\x5b""3\x5d+z*(p\x5b""4\x5d+z*p\x5b""5\x5d))));\x0a"
"\x09s = one+z*(q\x5b""0\x5d+z*(q\x5b""1\x5d+z*(q\x5b""2\x5d+z*(q\x5b""3\x5d+z*q\x5b""4\x5d))));\x0a"
"\x09return one+ r/s;\x0a"
"}\x0a"
"\x09\x09\x0a"
"\x0a"
"/* For x >= 8, the asymptotic expansions of qzero is\x0a"
" *\x09-1/8 s + 75/1024 s^3 - ..., where s = 1/x.\x0a"
" * We approximate pzero by\x0a"
" * \x09qzero(x) = s*(-1.25 + (R/S))\x0a"
" * where  R = qR0 + qR1*s^2 + qR2*s^4 + ... + qR5*s^10\x0a"
" * \x09  S = 1 + qS0*s^2 + ... + qS5*s^12\x0a"
" * and\x0a"
" *\x09\x7c qzero(x)/s +1.25-R/S \x7c <= 2  ** ( -61.22)\x0a"
" */\x0a"
"static const float qR8\x5b""6\x5d = { /* for x in \x5binf, 8\x5d=1/\x5b""0,0.125\x5d */\x0a"
"  0.0000000000e+00, /* 0x00000000 */\x0a"
"  7.3242187500e-02, /* 0x3d960000 */\x0a"
"  1.1768206596e+01, /* 0x413c4a93 */\x0a"
"  5.5767340088e+02, /* 0x440b6b19 */\x0a"
"  8.8591972656e+03, /* 0x460a6cca */\x0a"
"  3.7014625000e+04, /* 0x471096a0 */\x0a"
"};\x0a"
"static const float qS8\x5b""6\x5d = {\x0a"
"  1.6377603149e+02, /* 0x4323c6aa */\x0a"
"  8.0983447266e+03, /* 0x45fd12c2 */\x0a"
"  1.4253829688e+05, /* 0x480b3293 */\x0a"
"  8.0330925000e+05, /* 0x49441ed4 */\x0a"
"  8.4050156250e+05, /* 0x494d3359 */\x0a"
" -3.4389928125e+05, /* 0xc8a7eb69 */\x0a"
"};\x0a"
"\x0a"
"static const float qR5\x5b""6\x5d = { /* for x in \x5b""8,4.5454\x5d=1/\x5b""0.125,0.22001\x5d */\x0a"
"  1.8408595828e-11, /* 0x2da1ec79 */\x0a"
"  7.3242180049e-02, /* 0x3d95ffff */\x0a"
"  5.8356351852e+00, /* 0x40babd86 */\x0a"
"  1.3511157227e+02, /* 0x43071c90 */\x0a"
"  1.0272437744e+03, /* 0x448067cd */\x0a"
"  1.9899779053e+03, /* 0x44f8bf4b */\x0a"
"};\x0a"
"static const float qS5\x5b""6\x5d = {\x0a"
"  8.2776611328e+01, /* 0x42a58da0 */\x0a"
"  2.0778142090e+03, /* 0x4501dd07 */\x0a"
"  1.8847289062e+04, /* 0x46933e94 */\x0a"
"  5.6751113281e+04, /* 0x475daf1d */\x0a"
"  3.5976753906e+04, /* 0x470c88c1 */\x0a"
" -5.3543427734e+03, /* 0xc5a752be */\x0a"
"};\x0a"
"\x0a"
"static const float qR3\x5b""6\x5d = {/* for x in \x5b""4.547,2.8571\x5d=1/\x5b""0.2199,0.35001\x5d */\x0a"
"  4.3774099900e-09, /* 0x3196681b */\x0a"
"  7.3241114616e-02, /* 0x3d95ff70 */\x0a"
"  3.3442313671e+00, /* 0x405607e3 */\x0a"
"  4.2621845245e+01, /* 0x422a7cc5 */\x0a"
"  1.7080809021e+02, /* 0x432acedf */\x0a"
"  1.6673394775e+02, /* 0x4326bbe4 */\x0a"
"};\x0a"
"static const float qS3\x5b""6\x5d = {\x0a"
"  4.8758872986e+01, /* 0x42430916 */\x0a"
"  7.0968920898e+02, /* 0x44316c1c */\x0a"
"  3.7041481934e+03, /* 0x4567825f */\x0a"
"  6.4604252930e+03, /* 0x45c9e367 */\x0a"
"  2.5163337402e+03, /* 0x451d4557 */\x0a"
" -1.4924745178e+02, /* 0xc3153f59 */\x0a"
"};\x0a"
"\x0a"
"static const float qR2\x5b""6\x5d = {/* for x in \x5b""2.8570,2\x5d=1/\x5b""0.3499,0.5\x5d */\x0a"
"  1.5044444979e-07, /* 0x342189db */\x0a"
"  7.3223426938e-02, /* 0x3d95f62a */\x0a"
"  1.9981917143e+00, /* 0x3fffc4bf */\x0a"
"  1.4495602608e+01, /* 0x4167edfd */\x0a"
"  3.1666231155e+01, /* 0x41fd5471 */\x0a"
"  1.6252708435e+01, /* 0x4182058c */\x0a"
"};\x0a"
"static const float qS2\x5b""6\x5d = {\x0a"
"  3.0365585327e+01, /* 0x41f2ecb8 */\x0a"
"  2.6934811401e+02, /* 0x4386ac8f */\x0a"
"  8.4478375244e+02, /* 0x44533229 */\x0a"
"  8.8293585205e+02, /* 0x445cbbe5 */\x0a"
"  2.1266638184e+02, /* 0x4354aa98 */\x0a"
" -5.3109550476e+00, /* 0xc0a9f358 */\x0a"
"};\x0a"
"\x0a"
"static float\x0a"
"qzerof(float x)\x0a"
"{\x0a"
"\x09""const float *p,*q;\x0a"
"\x09""float s,r,z;\x0a"
"\x09int32_t ix;\x0a"
"\x09GET_FLOAT_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"\x09if(ix>=0x41000000)     {p = qR8; q= qS8;}\x0a"
"\x09""else if(ix>=0x40f71c58){p = qR5; q= qS5;}\x0a"
"\x09""else if(ix>=0x4036db68){p = qR3; q= qS3;}\x0a"
"\x09""else if(ix>=0x40000000){p = qR2; q= qS2;}\x0a"
"\x09z = one/(x*x);\x0a"
"\x09r = p\x5b""0\x5d+z*(p\x5b""1\x5d+z*(p\x5b""2\x5d+z*(p\x5b""3\x5d+z*(p\x5b""4\x5d+z*p\x5b""5\x5d))));\x0a"
"\x09s = one+z*(q\x5b""0\x5d+z*(q\x5b""1\x5d+z*(q\x5b""2\x5d+z*(q\x5b""3\x5d+z*(q\x5b""4\x5d+z*q\x5b""5\x5d)))));\x0a"
"\x09return (-(float).125 + r/s)/x;\x0a"
"}\x0a"
"", 10354 ); }