#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_j1_c( 
"/* \x40(#)e_j1.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* j1(x), y1(x)\x0a"
" * Bessel function of the first and second kinds of order zero.\x0a"
" * Method -- j1(x)\x3a\x0a"
" *\x09""1. For tiny x, we use j1(x) = x/2 - x^3/16 + x^5/384 - ...\x0a"
" *\x09""2. Reduce x to \x7cx\x7c since j1(x)=-j1(-x),  and\x0a"
" *\x09   for x in (0,2)\x0a"
" *\x09\x09j1(x) = x/2 + x*z*R0/S0,  where z = x*x;\x0a"
" *\x09   (precision\x3a  \x7cj1/x - 1/2 - R0/S0 \x7c<2**-61.51 )\x0a"
" *\x09   for x in (2,inf)\x0a"
" * \x09\x09j1(x) = sqrt(2/(pi*x))*(p1(x)*cos(x1)-q1(x)*sin(x1))\x0a"
" * \x09\x09y1(x) = sqrt(2/(pi*x))*(p1(x)*sin(x1)+q1(x)*cos(x1))\x0a"
" * \x09   where x1 = x-3*pi/4. It is better to compute sin(x1),cos(x1)\x0a"
" *\x09   as follow\x3a\x0a"
" *\x09\x09""cos(x1) =  cos(x)cos(3pi/4)+sin(x)sin(3pi/4)\x0a"
" *\x09\x09\x09=  1/sqrt(2) * (sin(x) - cos(x))\x0a"
" *\x09\x09sin(x1) =  sin(x)cos(3pi/4)-cos(x)sin(3pi/4)\x0a"
" *\x09\x09\x09= -1/sqrt(2) * (sin(x) + cos(x))\x0a"
" * \x09   (To avoid cancellation, use\x0a"
" *\x09\x09sin(x) +- cos(x) = -cos(2x)/(sin(x) -+ cos(x))\x0a"
" * \x09    to compute the worse one.)\x0a"
" *\x09   \x0a"
" *\x09""3 Special cases\x0a"
" *\x09\x09j1(nan)= nan\x0a"
" *\x09\x09j1(0) = 0\x0a"
" *\x09\x09j1(inf) = 0\x0a"
" *\x09\x09\x0a"
" * Method -- y1(x)\x3a\x0a"
" *\x09""1. screen out x<=0 cases\x3a y1(0)=-inf, y1(x<0)=NaN \x0a"
" *\x09""2. For x<2.\x0a"
" *\x09   Since \x0a"
" *\x09\x09y1(x) = 2/pi*(j1(x)*(ln(x/2)+Euler)-1/x-x/2+5/64*x^3-...)\x0a"
" *\x09   therefore y1(x)-2/pi*j1(x)*ln(x)-1/x is an odd function.\x0a"
" *\x09   We use the following function to approximate y1,\x0a"
" *\x09\x09y1(x) = x*U(z)/V(z) + (2/pi)*(j1(x)*ln(x)-1/x), z= x^2\x0a"
" *\x09   where for x in \x5b""0,2\x5d (abs err less than 2**-65.89)\x0a"
" *\x09\x09U(z) = U0\x5b""0\x5d + U0\x5b""1\x5d*z + ... + U0\x5b""4\x5d*z^4\x0a"
" *\x09\x09V(z) = 1  + v0\x5b""0\x5d*z + ... + v0\x5b""4\x5d*z^5\x0a"
" *\x09   Note\x3a For tiny x, 1/x dominate y1 and hence\x0a"
" *\x09\x09y1(tiny) = -2/pi/tiny, (choose tiny<2**-54)\x0a"
" *\x09""3. For x>=2.\x0a"
" * \x09\x09y1(x) = sqrt(2/(pi*x))*(p1(x)*sin(x1)+q1(x)*cos(x1))\x0a"
" * \x09   where x1 = x-3*pi/4. It is better to compute sin(x1),cos(x1)\x0a"
" *\x09   by method mentioned above.\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static double pone(double), qone(double);\x0a"
"\x0a"
"static const double \x0a"
"huge    = 1e300,\x0a"
"one\x09= 1.0,\x0a"
"invsqrtpi=  5.64189583547756279280e-01, /* 0x3FE20DD7, 0x50429B6D */\x0a"
"tpi      =  6.36619772367581382433e-01, /* 0x3FE45F30, 0x6DC9C883 */\x0a"
"\x09/* R0/S0 on \x5b""0,2\x5d */\x0a"
"r00  = -6.25000000000000000000e-02, /* 0xBFB00000, 0x00000000 */\x0a"
"r01  =  1.40705666955189706048e-03, /* 0x3F570D9F, 0x98472C61 */\x0a"
"r02  = -1.59955631084035597520e-05, /* 0xBEF0C5C6, 0xBA169668 */\x0a"
"r03  =  4.96727999609584448412e-08, /* 0x3E6AAAFA, 0x46CA0BD9 */\x0a"
"s01  =  1.91537599538363460805e-02, /* 0x3F939D0B, 0x12637E53 */\x0a"
"s02  =  1.85946785588630915560e-04, /* 0x3F285F56, 0xB9CDF664 */\x0a"
"s03  =  1.17718464042623683263e-06, /* 0x3EB3BFF8, 0x333F8498 */\x0a"
"s04  =  5.04636257076217042715e-09, /* 0x3E35AC88, 0xC97DFF2C */\x0a"
"s05  =  1.23542274426137913908e-11; /* 0x3DAB2ACF, 0xCFB97ED8 */\x0a"
"\x0a"
"static const double zero    = 0.0;\x0a"
"\x0a"
"double\x0a"
"j1(double x) \x0a"
"{\x0a"
"\x09""double z, s,c,ss,cc,r,u,v,y;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x7ff00000) return one/x;\x0a"
"\x09y = fabs(x);\x0a"
"\x09if(ix >= 0x40000000) {\x09/* \x7cx\x7c >= 2.0 */\x0a"
"\x09\x09s = sin(y);\x0a"
"\x09\x09""c = cos(y);\x0a"
"\x09\x09ss = -s-c;\x0a"
"\x09\x09""cc = s-c;\x0a"
"\x09\x09if(ix<0x7fe00000) {  /* make sure y+y not overflow */\x0a"
"\x09\x09    z = cos(y+y);\x0a"
"\x09\x09    if ((s*c)>zero) cc = z/ss;\x0a"
"\x09\x09    else \x09    ss = z/cc;\x0a"
"\x09\x09}\x0a"
"\x09/*\x0a"
"\x09 * j1(x) = 1/sqrt(pi) * (P(1,x)*cc - Q(1,x)*ss) / sqrt(x)\x0a"
"\x09 * y1(x) = 1/sqrt(pi) * (P(1,x)*ss + Q(1,x)*cc) / sqrt(x)\x0a"
"\x09 */\x0a"
"\x09\x09if(ix>0x48000000) z = (invsqrtpi*cc)/sqrt(y);\x0a"
"\x09\x09""else {\x0a"
"\x09\x09    u = pone(y); v = qone(y);\x0a"
"\x09\x09    z = invsqrtpi*(u*cc-v*ss)/sqrt(y);\x0a"
"\x09\x09}\x0a"
"\x09\x09if(hx<0) return -z;\x0a"
"\x09\x09""else  \x09 return  z;\x0a"
"\x09}\x0a"
"\x09if(ix<0x3e400000) {\x09/* \x7cx\x7c<2**-27 */\x0a"
"\x09    if(huge+x>one) return 0.5*x;/* inexact if x\x21=0 necessary */\x0a"
"\x09}\x0a"
"\x09z = x*x;\x0a"
"\x09r =  z*(r00+z*(r01+z*(r02+z*r03)));\x0a"
"\x09s =  one+z*(s01+z*(s02+z*(s03+z*(s04+z*s05))));\x0a"
"\x09r *= x;\x0a"
"\x09return(x*0.5+r/s);\x0a"
"}\x0a"
"\x0a"
"static const double U0\x5b""5\x5d = {\x0a"
" -1.96057090646238940668e-01, /* 0xBFC91866, 0x143CBC8A */\x0a"
"  5.04438716639811282616e-02, /* 0x3FA9D3C7, 0x76292CD1 */\x0a"
" -1.91256895875763547298e-03, /* 0xBF5F55E5, 0x4844F50F */\x0a"
"  2.35252600561610495928e-05, /* 0x3EF8AB03, 0x8FA6B88E */\x0a"
" -9.19099158039878874504e-08, /* 0xBE78AC00, 0x569105B8 */\x0a"
"};\x0a"
"static const double V0\x5b""5\x5d = {\x0a"
"  1.99167318236649903973e-02, /* 0x3F94650D, 0x3F4DA9F0 */\x0a"
"  2.02552581025135171496e-04, /* 0x3F2A8C89, 0x6C257764 */\x0a"
"  1.35608801097516229404e-06, /* 0x3EB6C05A, 0x894E8CA6 */\x0a"
"  6.22741452364621501295e-09, /* 0x3E3ABF1D, 0x5BA69A86 */\x0a"
"  1.66559246207992079114e-11, /* 0x3DB25039, 0xDACA772A */\x0a"
"};\x0a"
"\x0a"
"double\x0a"
"y1(double x) \x0a"
"{\x0a"
"\x09""double z, s,c,ss,cc,u,v;\x0a"
"\x09int32_t hx,ix,lx;\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"        ix = 0x7fffffff\x26hx;\x0a"
"    /* if Y1(NaN) is NaN, Y1(-inf) is NaN, Y1(inf) is 0 */\x0a"
"\x09if(ix>=0x7ff00000) return  one/(x+x*x); \x0a"
"        if((ix\x7clx)==0) return -one/zero;\x0a"
"        if(hx<0) return zero/zero;\x0a"
"        if(ix >= 0x40000000) {  /* \x7cx\x7c >= 2.0 */\x0a"
"                s = sin(x);\x0a"
"                c = cos(x);\x0a"
"                ss = -s-c;\x0a"
"                cc = s-c;\x0a"
"                if(ix<0x7fe00000) {  /* make sure x+x not overflow */\x0a"
"                    z = cos(x+x);\x0a"
"                    if ((s*c)>zero) cc = z/ss;\x0a"
"                    else            ss = z/cc;\x0a"
"                }\x0a"
"        /* y1(x) = sqrt(2/(pi*x))*(p1(x)*sin(x0)+q1(x)*cos(x0))\x0a"
"         * where x0 = x-3pi/4\x0a"
"         *      Better formula\x3a\x0a"
"         *              cos(x0) = cos(x)cos(3pi/4)+sin(x)sin(3pi/4)\x0a"
"         *                      =  1/sqrt(2) * (sin(x) - cos(x))\x0a"
"         *              sin(x0) = sin(x)cos(3pi/4)-cos(x)sin(3pi/4)\x0a"
"         *                      = -1/sqrt(2) * (cos(x) + sin(x))\x0a"
"         * To avoid cancellation, use\x0a"
"         *              sin(x) +- cos(x) = -cos(2x)/(sin(x) -+ cos(x))\x0a"
"         * to compute the worse one.\x0a"
"         */\x0a"
"                if(ix>0x48000000) z = (invsqrtpi*ss)/sqrt(x);\x0a"
"                else {\x0a"
"                    u = pone(x); v = qone(x);\x0a"
"                    z = invsqrtpi*(u*ss+v*cc)/sqrt(x);\x0a"
"                }\x0a"
"                return z;\x0a"
"        } \x0a"
"        if(ix<=0x3c900000) {    /* x < 2**-54 */\x0a"
"            return(-tpi/x);\x0a"
"        } \x0a"
"        z = x*x;\x0a"
"        u = U0\x5b""0\x5d+z*(U0\x5b""1\x5d+z*(U0\x5b""2\x5d+z*(U0\x5b""3\x5d+z*U0\x5b""4\x5d)));\x0a"
"        v = one+z*(V0\x5b""0\x5d+z*(V0\x5b""1\x5d+z*(V0\x5b""2\x5d+z*(V0\x5b""3\x5d+z*V0\x5b""4\x5d))));\x0a"
"        return(x*(u/v) + tpi*(j1(x)*log(x)-one/x));\x0a"
"}\x0a"
"\x0a"
"/* For x >= 8, the asymptotic expansions of pone is\x0a"
" *\x09""1 + 15/128 s^2 - 4725/2^15 s^4 - ...,\x09where s = 1/x.\x0a"
" * We approximate pone by\x0a"
" * \x09pone(x) = 1 + (R/S)\x0a"
" * where  R = pr0 + pr1*s^2 + pr2*s^4 + ... + pr5*s^10\x0a"
" * \x09  S = 1 + ps0*s^2 + ... + ps4*s^10\x0a"
" * and\x0a"
" *\x09\x7c pone(x)-1-R/S \x7c <= 2  ** ( -60.06)\x0a"
" */\x0a"
"\x0a"
"static const double pr8\x5b""6\x5d = { /* for x in \x5binf, 8\x5d=1/\x5b""0,0.125\x5d */\x0a"
"  0.00000000000000000000e+00, /* 0x00000000, 0x00000000 */\x0a"
"  1.17187499999988647970e-01, /* 0x3FBDFFFF, 0xFFFFFCCE */\x0a"
"  1.32394806593073575129e+01, /* 0x402A7A9D, 0x357F7FCE */\x0a"
"  4.12051854307378562225e+02, /* 0x4079C0D4, 0x652EA590 */\x0a"
"  3.87474538913960532227e+03, /* 0x40AE457D, 0xA3A532CC */\x0a"
"  7.91447954031891731574e+03, /* 0x40BEEA7A, 0xC32782DD */\x0a"
"};\x0a"
"static const double ps8\x5b""5\x5d = {\x0a"
"  1.14207370375678408436e+02, /* 0x405C8D45, 0x8E656CAC */\x0a"
"  3.65093083420853463394e+03, /* 0x40AC85DC, 0x964D274F */\x0a"
"  3.69562060269033463555e+04, /* 0x40E20B86, 0x97C5BB7F */\x0a"
"  9.76027935934950801311e+04, /* 0x40F7D42C, 0xB28F17BB */\x0a"
"  3.08042720627888811578e+04, /* 0x40DE1511, 0x697A0B2D */\x0a"
"};\x0a"
"\x0a"
"static const double pr5\x5b""6\x5d = { /* for x in \x5b""8,4.5454\x5d=1/\x5b""0.125,0.22001\x5d */\x0a"
"  1.31990519556243522749e-11, /* 0x3DAD0667, 0xDAE1CA7D */\x0a"
"  1.17187493190614097638e-01, /* 0x3FBDFFFF, 0xE2C10043 */\x0a"
"  6.80275127868432871736e+00, /* 0x401B3604, 0x6E6315E3 */\x0a"
"  1.08308182990189109773e+02, /* 0x405B13B9, 0x452602ED */\x0a"
"  5.17636139533199752805e+02, /* 0x40802D16, 0xD052D649 */\x0a"
"  5.28715201363337541807e+02, /* 0x408085B8, 0xBB7E0CB7 */\x0a"
"};\x0a"
"static const double ps5\x5b""5\x5d = {\x0a"
"  5.92805987221131331921e+01, /* 0x404DA3EA, 0xA8AF633D */\x0a"
"  9.91401418733614377743e+02, /* 0x408EFB36, 0x1B066701 */\x0a"
"  5.35326695291487976647e+03, /* 0x40B4E944, 0x5706B6FB */\x0a"
"  7.84469031749551231769e+03, /* 0x40BEA4B0, 0xB8A5BB15 */\x0a"
"  1.50404688810361062679e+03, /* 0x40978030, 0x036F5E51 */\x0a"
"};\x0a"
"\x0a"
"static const double pr3\x5b""6\x5d = {\x0a"
"  3.02503916137373618024e-09, /* 0x3E29FC21, 0xA7AD9EDD */\x0a"
"  1.17186865567253592491e-01, /* 0x3FBDFFF5, 0x5B21D17B */\x0a"
"  3.93297750033315640650e+00, /* 0x400F76BC, 0xE85EAD8A */\x0a"
"  3.51194035591636932736e+01, /* 0x40418F48, 0x9DA6D129 */\x0a"
"  9.10550110750781271918e+01, /* 0x4056C385, 0x4D2C1837 */\x0a"
"  4.85590685197364919645e+01, /* 0x4048478F, 0x8EA83EE5 */\x0a"
"};\x0a"
"static const double ps3\x5b""5\x5d = {\x0a"
"  3.47913095001251519989e+01, /* 0x40416549, 0xA134069C */\x0a"
"  3.36762458747825746741e+02, /* 0x40750C33, 0x07F1A75F */\x0a"
"  1.04687139975775130551e+03, /* 0x40905B7C, 0x5037D523 */\x0a"
"  8.90811346398256432622e+02, /* 0x408BD67D, 0xA32E31E9 */\x0a"
"  1.03787932439639277504e+02, /* 0x4059F26D, 0x7C2EED53 */\x0a"
"};\x0a"
"\x0a"
"static const double pr2\x5b""6\x5d = {/* for x in \x5b""2.8570,2\x5d=1/\x5b""0.3499,0.5\x5d */\x0a"
"  1.07710830106873743082e-07, /* 0x3E7CE9D4, 0xF65544F4 */\x0a"
"  1.17176219462683348094e-01, /* 0x3FBDFF42, 0xBE760D83 */\x0a"
"  2.36851496667608785174e+00, /* 0x4002F2B7, 0xF98FAEC0 */\x0a"
"  1.22426109148261232917e+01, /* 0x40287C37, 0x7F71A964 */\x0a"
"  1.76939711271687727390e+01, /* 0x4031B1A8, 0x177F8EE2 */\x0a"
"  5.07352312588818499250e+00, /* 0x40144B49, 0xA574C1FE */\x0a"
"};\x0a"
"static const double ps2\x5b""5\x5d = {\x0a"
"  2.14364859363821409488e+01, /* 0x40356FBD, 0x8AD5ECDC */\x0a"
"  1.25290227168402751090e+02, /* 0x405F5293, 0x14F92CD5 */\x0a"
"  2.32276469057162813669e+02, /* 0x406D08D8, 0xD5A2DBD9 */\x0a"
"  1.17679373287147100768e+02, /* 0x405D6B7A, 0xDA1884A9 */\x0a"
"  8.36463893371618283368e+00, /* 0x4020BAB1, 0xF44E5192 */\x0a"
"};\x0a"
"\x0a"
"static double\x0a"
"pone(double x)\x0a"
"{\x0a"
"\x09""const double *p,*q;\x0a"
"\x09""double z,r,s;\x0a"
"        int32_t ix;\x0a"
"\x09GET_HIGH_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"        if(ix>=0x40200000)     {p = pr8; q= ps8;}\x0a"
"        else if(ix>=0x40122E8B){p = pr5; q= ps5;}\x0a"
"        else if(ix>=0x4006DB6D){p = pr3; q= ps3;}\x0a"
"        else if(ix>=0x40000000){p = pr2; q= ps2;}\x0a"
"        z = one/(x*x);\x0a"
"        r = p\x5b""0\x5d+z*(p\x5b""1\x5d+z*(p\x5b""2\x5d+z*(p\x5b""3\x5d+z*(p\x5b""4\x5d+z*p\x5b""5\x5d))));\x0a"
"        s = one+z*(q\x5b""0\x5d+z*(q\x5b""1\x5d+z*(q\x5b""2\x5d+z*(q\x5b""3\x5d+z*q\x5b""4\x5d))));\x0a"
"        return one+ r/s;\x0a"
"}\x0a"
"\x09\x09\x0a"
"\x0a"
"/* For x >= 8, the asymptotic expansions of qone is\x0a"
" *\x09""3/8 s - 105/1024 s^3 - ..., where s = 1/x.\x0a"
" * We approximate pone by\x0a"
" * \x09qone(x) = s*(0.375 + (R/S))\x0a"
" * where  R = qr1*s^2 + qr2*s^4 + ... + qr5*s^10\x0a"
" * \x09  S = 1 + qs1*s^2 + ... + qs6*s^12\x0a"
" * and\x0a"
" *\x09\x7c qone(x)/s -0.375-R/S \x7c <= 2  ** ( -61.13)\x0a"
" */\x0a"
"\x0a"
"static const double qr8\x5b""6\x5d = { /* for x in \x5binf, 8\x5d=1/\x5b""0,0.125\x5d */\x0a"
"  0.00000000000000000000e+00, /* 0x00000000, 0x00000000 */\x0a"
" -1.02539062499992714161e-01, /* 0xBFBA3FFF, 0xFFFFFDF3 */\x0a"
" -1.62717534544589987888e+01, /* 0xC0304591, 0xA26779F7 */\x0a"
" -7.59601722513950107896e+02, /* 0xC087BCD0, 0x53E4B576 */\x0a"
" -1.18498066702429587167e+04, /* 0xC0C724E7, 0x40F87415 */\x0a"
" -4.84385124285750353010e+04, /* 0xC0E7A6D0, 0x65D09C6A */\x0a"
"};\x0a"
"static const double qs8\x5b""6\x5d = {\x0a"
"  1.61395369700722909556e+02, /* 0x40642CA6, 0xDE5BCDE5 */\x0a"
"  7.82538599923348465381e+03, /* 0x40BE9162, 0xD0D88419 */\x0a"
"  1.33875336287249578163e+05, /* 0x4100579A, 0xB0B75E98 */\x0a"
"  7.19657723683240939863e+05, /* 0x4125F653, 0x72869C19 */\x0a"
"  6.66601232617776375264e+05, /* 0x412457D2, 0x7719AD5C */\x0a"
" -2.94490264303834643215e+05, /* 0xC111F969, 0x0EA5AA18 */\x0a"
"};\x0a"
"\x0a"
"static const double qr5\x5b""6\x5d = { /* for x in \x5b""8,4.5454\x5d=1/\x5b""0.125,0.22001\x5d */\x0a"
" -2.08979931141764104297e-11, /* 0xBDB6FA43, 0x1AA1A098 */\x0a"
" -1.02539050241375426231e-01, /* 0xBFBA3FFF, 0xCB597FEF */\x0a"
" -8.05644828123936029840e+00, /* 0xC0201CE6, 0xCA03AD4B */\x0a"
" -1.83669607474888380239e+02, /* 0xC066F56D, 0x6CA7B9B0 */\x0a"
" -1.37319376065508163265e+03, /* 0xC09574C6, 0x6931734F */\x0a"
" -2.61244440453215656817e+03, /* 0xC0A468E3, 0x88FDA79D */\x0a"
"};\x0a"
"static const double qs5\x5b""6\x5d = {\x0a"
"  8.12765501384335777857e+01, /* 0x405451B2, 0xFF5A11B2 */\x0a"
"  1.99179873460485964642e+03, /* 0x409F1F31, 0xE77BF839 */\x0a"
"  1.74684851924908907677e+04, /* 0x40D10F1F, 0x0D64CE29 */\x0a"
"  4.98514270910352279316e+04, /* 0x40E8576D, 0xAABAD197 */\x0a"
"  2.79480751638918118260e+04, /* 0x40DB4B04, 0xCF7C364B */\x0a"
" -4.71918354795128470869e+03, /* 0xC0B26F2E, 0xFCFFA004 */\x0a"
"};\x0a"
"\x0a"
"static const double qr3\x5b""6\x5d = {\x0a"
" -5.07831226461766561369e-09, /* 0xBE35CFA9, 0xD38FC84F */\x0a"
" -1.02537829820837089745e-01, /* 0xBFBA3FEB, 0x51AEED54 */\x0a"
" -4.61011581139473403113e+00, /* 0xC01270C2, 0x3302D9FF */\x0a"
" -5.78472216562783643212e+01, /* 0xC04CEC71, 0xC25D16DA */\x0a"
" -2.28244540737631695038e+02, /* 0xC06C87D3, 0x4718D55F */\x0a"
" -2.19210128478909325622e+02, /* 0xC06B66B9, 0x5F5C1BF6 */\x0a"
"};\x0a"
"static const double qs3\x5b""6\x5d = {\x0a"
"  4.76651550323729509273e+01, /* 0x4047D523, 0xCCD367E4 */\x0a"
"  6.73865112676699709482e+02, /* 0x40850EEB, 0xC031EE3E */\x0a"
"  3.38015286679526343505e+03, /* 0x40AA684E, 0x448E7C9A */\x0a"
"  5.54772909720722782367e+03, /* 0x40B5ABBA, 0xA61D54A6 */\x0a"
"  1.90311919338810798763e+03, /* 0x409DBC7A, 0x0DD4DF4B */\x0a"
" -1.35201191444307340817e+02, /* 0xC060E670, 0x290A311F */\x0a"
"};\x0a"
"\x0a"
"static const double qr2\x5b""6\x5d = {/* for x in \x5b""2.8570,2\x5d=1/\x5b""0.3499,0.5\x5d */\x0a"
" -1.78381727510958865572e-07, /* 0xBE87F126, 0x44C626D2 */\x0a"
" -1.02517042607985553460e-01, /* 0xBFBA3E8E, 0x9148B010 */\x0a"
" -2.75220568278187460720e+00, /* 0xC0060484, 0x69BB4EDA */\x0a"
" -1.96636162643703720221e+01, /* 0xC033A9E2, 0xC168907F */\x0a"
" -4.23253133372830490089e+01, /* 0xC04529A3, 0xDE104AAA */\x0a"
" -2.13719211703704061733e+01, /* 0xC0355F36, 0x39CF6E52 */\x0a"
"};\x0a"
"static const double qs2\x5b""6\x5d = {\x0a"
"  2.95333629060523854548e+01, /* 0x403D888A, 0x78AE64FF */\x0a"
"  2.52981549982190529136e+02, /* 0x406F9F68, 0xDB821CBA */\x0a"
"  7.57502834868645436472e+02, /* 0x4087AC05, 0xCE49A0F7 */\x0a"
"  7.39393205320467245656e+02, /* 0x40871B25, 0x48D4C029 */\x0a"
"  1.55949003336666123687e+02, /* 0x40637E5E, 0x3C3ED8D4 */\x0a"
" -4.95949898822628210127e+00, /* 0xC013D686, 0xE71BE86B */\x0a"
"};\x0a"
"\x0a"
"static double\x0a"
"qone(double x)\x0a"
"{\x0a"
"\x09""const double *p,*q;\x0a"
"\x09""double  s,r,z;\x0a"
"\x09int32_t ix;\x0a"
"\x09GET_HIGH_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"\x09if(ix>=0x40200000)     {p = qr8; q= qs8;}\x0a"
"\x09""else if(ix>=0x40122E8B){p = qr5; q= qs5;}\x0a"
"\x09""else if(ix>=0x4006DB6D){p = qr3; q= qs3;}\x0a"
"\x09""else if(ix>=0x40000000){p = qr2; q= qs2;}\x0a"
"\x09z = one/(x*x);\x0a"
"\x09r = p\x5b""0\x5d+z*(p\x5b""1\x5d+z*(p\x5b""2\x5d+z*(p\x5b""3\x5d+z*(p\x5b""4\x5d+z*p\x5b""5\x5d))));\x0a"
"\x09s = one+z*(q\x5b""0\x5d+z*(q\x5b""1\x5d+z*(q\x5b""2\x5d+z*(q\x5b""3\x5d+z*(q\x5b""4\x5d+z*q\x5b""5\x5d)))));\x0a"
"\x09return (.375 + r/s)/x;\x0a"
"}\x0a"
"", 14141 ); }