#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_j1f_c( 
"/* e_j1f.c -- float version of e_j1.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static float ponef(float), qonef(float);\x0a"
"\x0a"
"static const float \x0a"
"huge    = 1e30,\x0a"
"one\x09= 1.0,\x0a"
"invsqrtpi=  5.6418961287e-01, /* 0x3f106ebb */\x0a"
"tpi      =  6.3661974669e-01, /* 0x3f22f983 */\x0a"
"\x09/* R0/S0 on \x5b""0,2\x5d */\x0a"
"r00  = -6.2500000000e-02, /* 0xbd800000 */\x0a"
"r01  =  1.4070566976e-03, /* 0x3ab86cfd */\x0a"
"r02  = -1.5995563444e-05, /* 0xb7862e36 */\x0a"
"r03  =  4.9672799207e-08, /* 0x335557d2 */\x0a"
"s01  =  1.9153760746e-02, /* 0x3c9ce859 */\x0a"
"s02  =  1.8594678841e-04, /* 0x3942fab6 */\x0a"
"s03  =  1.1771846857e-06, /* 0x359dffc2 */\x0a"
"s04  =  5.0463624390e-09, /* 0x31ad6446 */\x0a"
"s05  =  1.2354227016e-11; /* 0x2d59567e */\x0a"
"\x0a"
"static const float zero    = 0.0;\x0a"
"\x0a"
"float\x0a"
"j1f(float x) \x0a"
"{\x0a"
"\x09""float z, s,c,ss,cc,r,u,v,y;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x7f800000) return one/x;\x0a"
"\x09y = fabsf(x);\x0a"
"\x09if(ix >= 0x40000000) {\x09/* \x7cx\x7c >= 2.0 */\x0a"
"\x09\x09s = sinf(y);\x0a"
"\x09\x09""c = cosf(y);\x0a"
"\x09\x09ss = -s-c;\x0a"
"\x09\x09""cc = s-c;\x0a"
"\x09\x09if(ix<0x7f000000) {  /* make sure y+y not overflow */\x0a"
"\x09\x09    z = cosf(y+y);\x0a"
"\x09\x09    if ((s*c)>zero) cc = z/ss;\x0a"
"\x09\x09    else \x09    ss = z/cc;\x0a"
"\x09\x09}\x0a"
"\x09/*\x0a"
"\x09 * j1(x) = 1/sqrt(pi) * (P(1,x)*cc - Q(1,x)*ss) / sqrt(x)\x0a"
"\x09 * y1(x) = 1/sqrt(pi) * (P(1,x)*ss + Q(1,x)*cc) / sqrt(x)\x0a"
"\x09 */\x0a"
"\x09\x09if(ix>0x80000000U) z = (invsqrtpi*cc)/sqrtf(y);\x0a"
"\x09\x09""else {\x0a"
"\x09\x09    u = ponef(y); v = qonef(y);\x0a"
"\x09\x09    z = invsqrtpi*(u*cc-v*ss)/sqrtf(y);\x0a"
"\x09\x09}\x0a"
"\x09\x09if(hx<0) return -z;\x0a"
"\x09\x09""else  \x09 return  z;\x0a"
"\x09}\x0a"
"\x09if(ix<0x32000000) {\x09/* \x7cx\x7c<2**-27 */\x0a"
"\x09    if(huge+x>one) return (float)0.5*x;/* inexact if x\x21=0 necessary */\x0a"
"\x09}\x0a"
"\x09z = x*x;\x0a"
"\x09r =  z*(r00+z*(r01+z*(r02+z*r03)));\x0a"
"\x09s =  one+z*(s01+z*(s02+z*(s03+z*(s04+z*s05))));\x0a"
"\x09r *= x;\x0a"
"\x09return(x*(float)0.5+r/s);\x0a"
"}\x0a"
"\x0a"
"static const float U0\x5b""5\x5d = {\x0a"
" -1.9605709612e-01, /* 0xbe48c331 */\x0a"
"  5.0443872809e-02, /* 0x3d4e9e3c */\x0a"
" -1.9125689287e-03, /* 0xbafaaf2a */\x0a"
"  2.3525259166e-05, /* 0x37c5581c */\x0a"
" -9.1909917899e-08, /* 0xb3c56003 */\x0a"
"};\x0a"
"static const float V0\x5b""5\x5d = {\x0a"
"  1.9916731864e-02, /* 0x3ca3286a */\x0a"
"  2.0255257550e-04, /* 0x3954644b */\x0a"
"  1.3560879779e-06, /* 0x35b602d4 */\x0a"
"  6.2274145840e-09, /* 0x31d5f8eb */\x0a"
"  1.6655924903e-11, /* 0x2d9281cf */\x0a"
"};\x0a"
"\x0a"
"float\x0a"
"y1f(float x) \x0a"
"{\x0a"
"\x09""float z, s,c,ss,cc,u,v;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"        ix = 0x7fffffff\x26hx;\x0a"
"    /* if Y1(NaN) is NaN, Y1(-inf) is NaN, Y1(inf) is 0 */\x0a"
"\x09if(ix>=0x7f800000) return  one/(x+x*x); \x0a"
"        if(ix==0) return -one/zero;\x0a"
"        if(hx<0) return zero/zero;\x0a"
"        if(ix >= 0x40000000) {  /* \x7cx\x7c >= 2.0 */\x0a"
"                s = sinf(x);\x0a"
"                c = cosf(x);\x0a"
"                ss = -s-c;\x0a"
"                cc = s-c;\x0a"
"                if(ix<0x7f000000) {  /* make sure x+x not overflow */\x0a"
"                    z = cosf(x+x);\x0a"
"                    if ((s*c)>zero) cc = z/ss;\x0a"
"                    else            ss = z/cc;\x0a"
"                }\x0a"
"        /* y1(x) = sqrt(2/(pi*x))*(p1(x)*sin(x0)+q1(x)*cos(x0))\x0a"
"         * where x0 = x-3pi/4\x0a"
"         *      Better formula\x3a\x0a"
"         *              cos(x0) = cos(x)cos(3pi/4)+sin(x)sin(3pi/4)\x0a"
"         *                      =  1/sqrt(2) * (sin(x) - cos(x))\x0a"
"         *              sin(x0) = sin(x)cos(3pi/4)-cos(x)sin(3pi/4)\x0a"
"         *                      = -1/sqrt(2) * (cos(x) + sin(x))\x0a"
"         * To avoid cancellation, use\x0a"
"         *              sin(x) +- cos(x) = -cos(2x)/(sin(x) -+ cos(x))\x0a"
"         * to compute the worse one.\x0a"
"         */\x0a"
"                if(ix>0x48000000) z = (invsqrtpi*ss)/sqrtf(x);\x0a"
"                else {\x0a"
"                    u = ponef(x); v = qonef(x);\x0a"
"                    z = invsqrtpi*(u*ss+v*cc)/sqrtf(x);\x0a"
"                }\x0a"
"                return z;\x0a"
"        } \x0a"
"        if(ix<=0x24800000) {    /* x < 2**-54 */\x0a"
"            return(-tpi/x);\x0a"
"        } \x0a"
"        z = x*x;\x0a"
"        u = U0\x5b""0\x5d+z*(U0\x5b""1\x5d+z*(U0\x5b""2\x5d+z*(U0\x5b""3\x5d+z*U0\x5b""4\x5d)));\x0a"
"        v = one+z*(V0\x5b""0\x5d+z*(V0\x5b""1\x5d+z*(V0\x5b""2\x5d+z*(V0\x5b""3\x5d+z*V0\x5b""4\x5d))));\x0a"
"        return(x*(u/v) + tpi*(j1f(x)*logf(x)-one/x));\x0a"
"}\x0a"
"\x0a"
"/* For x >= 8, the asymptotic expansions of pone is\x0a"
" *\x09""1 + 15/128 s^2 - 4725/2^15 s^4 - ...,\x09where s = 1/x.\x0a"
" * We approximate pone by\x0a"
" * \x09pone(x) = 1 + (R/S)\x0a"
" * where  R = pr0 + pr1*s^2 + pr2*s^4 + ... + pr5*s^10\x0a"
" * \x09  S = 1 + ps0*s^2 + ... + ps4*s^10\x0a"
" * and\x0a"
" *\x09\x7c pone(x)-1-R/S \x7c <= 2  ** ( -60.06)\x0a"
" */\x0a"
"\x0a"
"static const float pr8\x5b""6\x5d = { /* for x in \x5binf, 8\x5d=1/\x5b""0,0.125\x5d */\x0a"
"  0.0000000000e+00, /* 0x00000000 */\x0a"
"  1.1718750000e-01, /* 0x3df00000 */\x0a"
"  1.3239480972e+01, /* 0x4153d4ea */\x0a"
"  4.1205184937e+02, /* 0x43ce06a3 */\x0a"
"  3.8747453613e+03, /* 0x45722bed */\x0a"
"  7.9144794922e+03, /* 0x45f753d6 */\x0a"
"};\x0a"
"static const float ps8\x5b""5\x5d = {\x0a"
"  1.1420736694e+02, /* 0x42e46a2c */\x0a"
"  3.6509309082e+03, /* 0x45642ee5 */\x0a"
"  3.6956207031e+04, /* 0x47105c35 */\x0a"
"  9.7602796875e+04, /* 0x47bea166 */\x0a"
"  3.0804271484e+04, /* 0x46f0a88b */\x0a"
"};\x0a"
"\x0a"
"static const float pr5\x5b""6\x5d = { /* for x in \x5b""8,4.5454\x5d=1/\x5b""0.125,0.22001\x5d */\x0a"
"  1.3199052094e-11, /* 0x2d68333f */\x0a"
"  1.1718749255e-01, /* 0x3defffff */\x0a"
"  6.8027510643e+00, /* 0x40d9b023 */\x0a"
"  1.0830818176e+02, /* 0x42d89dca */\x0a"
"  5.1763616943e+02, /* 0x440168b7 */\x0a"
"  5.2871520996e+02, /* 0x44042dc6 */\x0a"
"};\x0a"
"static const float ps5\x5b""5\x5d = {\x0a"
"  5.9280597687e+01, /* 0x426d1f55 */\x0a"
"  9.9140142822e+02, /* 0x4477d9b1 */\x0a"
"  5.3532670898e+03, /* 0x45a74a23 */\x0a"
"  7.8446904297e+03, /* 0x45f52586 */\x0a"
"  1.5040468750e+03, /* 0x44bc0180 */\x0a"
"};\x0a"
"\x0a"
"static const float pr3\x5b""6\x5d = {\x0a"
"  3.0250391081e-09, /* 0x314fe10d */\x0a"
"  1.1718686670e-01, /* 0x3defffab */\x0a"
"  3.9329774380e+00, /* 0x407bb5e7 */\x0a"
"  3.5119403839e+01, /* 0x420c7a45 */\x0a"
"  9.1055007935e+01, /* 0x42b61c2a */\x0a"
"  4.8559066772e+01, /* 0x42423c7c */\x0a"
"};\x0a"
"static const float ps3\x5b""5\x5d = {\x0a"
"  3.4791309357e+01, /* 0x420b2a4d */\x0a"
"  3.3676245117e+02, /* 0x43a86198 */\x0a"
"  1.0468714600e+03, /* 0x4482dbe3 */\x0a"
"  8.9081134033e+02, /* 0x445eb3ed */\x0a"
"  1.0378793335e+02, /* 0x42cf936c */\x0a"
"};\x0a"
"\x0a"
"static const float pr2\x5b""6\x5d = {/* for x in \x5b""2.8570,2\x5d=1/\x5b""0.3499,0.5\x5d */\x0a"
"  1.0771083225e-07, /* 0x33e74ea8 */\x0a"
"  1.1717621982e-01, /* 0x3deffa16 */\x0a"
"  2.3685150146e+00, /* 0x401795c0 */\x0a"
"  1.2242610931e+01, /* 0x4143e1bc */\x0a"
"  1.7693971634e+01, /* 0x418d8d41 */\x0a"
"  5.0735230446e+00, /* 0x40a25a4d */\x0a"
"};\x0a"
"static const float ps2\x5b""5\x5d = {\x0a"
"  2.1436485291e+01, /* 0x41ab7dec */\x0a"
"  1.2529022980e+02, /* 0x42fa9499 */\x0a"
"  2.3227647400e+02, /* 0x436846c7 */\x0a"
"  1.1767937469e+02, /* 0x42eb5bd7 */\x0a"
"  8.3646392822e+00, /* 0x4105d590 */\x0a"
"};\x0a"
"\x0a"
"static float\x0a"
"ponef(float x)\x0a"
"{\x0a"
"\x09""const float *p,*q;\x0a"
"\x09""float z,r,s;\x0a"
"        int32_t ix;\x0a"
"\x09GET_FLOAT_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"        if(ix>=0x41000000)     {p = pr8; q= ps8;}\x0a"
"        else if(ix>=0x40f71c58){p = pr5; q= ps5;}\x0a"
"        else if(ix>=0x4036db68){p = pr3; q= ps3;}\x0a"
"        else if(ix>=0x40000000){p = pr2; q= ps2;}\x0a"
"        z = one/(x*x);\x0a"
"        r = p\x5b""0\x5d+z*(p\x5b""1\x5d+z*(p\x5b""2\x5d+z*(p\x5b""3\x5d+z*(p\x5b""4\x5d+z*p\x5b""5\x5d))));\x0a"
"        s = one+z*(q\x5b""0\x5d+z*(q\x5b""1\x5d+z*(q\x5b""2\x5d+z*(q\x5b""3\x5d+z*q\x5b""4\x5d))));\x0a"
"        return one+ r/s;\x0a"
"}\x0a"
"\x09\x09\x0a"
"\x0a"
"/* For x >= 8, the asymptotic expansions of qone is\x0a"
" *\x09""3/8 s - 105/1024 s^3 - ..., where s = 1/x.\x0a"
" * We approximate pone by\x0a"
" * \x09qone(x) = s*(0.375 + (R/S))\x0a"
" * where  R = qr1*s^2 + qr2*s^4 + ... + qr5*s^10\x0a"
" * \x09  S = 1 + qs1*s^2 + ... + qs6*s^12\x0a"
" * and\x0a"
" *\x09\x7c qone(x)/s -0.375-R/S \x7c <= 2  ** ( -61.13)\x0a"
" */\x0a"
"\x0a"
"static const float qr8\x5b""6\x5d = { /* for x in \x5binf, 8\x5d=1/\x5b""0,0.125\x5d */\x0a"
"  0.0000000000e+00, /* 0x00000000 */\x0a"
" -1.0253906250e-01, /* 0xbdd20000 */\x0a"
" -1.6271753311e+01, /* 0xc1822c8d */\x0a"
" -7.5960174561e+02, /* 0xc43de683 */\x0a"
" -1.1849806641e+04, /* 0xc639273a */\x0a"
" -4.8438511719e+04, /* 0xc73d3683 */\x0a"
"};\x0a"
"static const float qs8\x5b""6\x5d = {\x0a"
"  1.6139537048e+02, /* 0x43216537 */\x0a"
"  7.8253862305e+03, /* 0x45f48b17 */\x0a"
"  1.3387534375e+05, /* 0x4802bcd6 */\x0a"
"  7.1965775000e+05, /* 0x492fb29c */\x0a"
"  6.6660125000e+05, /* 0x4922be94 */\x0a"
" -2.9449025000e+05, /* 0xc88fcb48 */\x0a"
"};\x0a"
"\x0a"
"static const float qr5\x5b""6\x5d = { /* for x in \x5b""8,4.5454\x5d=1/\x5b""0.125,0.22001\x5d */\x0a"
" -2.0897993405e-11, /* 0xadb7d219 */\x0a"
" -1.0253904760e-01, /* 0xbdd1fffe */\x0a"
" -8.0564479828e+00, /* 0xc100e736 */\x0a"
" -1.8366960144e+02, /* 0xc337ab6b */\x0a"
" -1.3731937256e+03, /* 0xc4aba633 */\x0a"
" -2.6124443359e+03, /* 0xc523471c */\x0a"
"};\x0a"
"static const float qs5\x5b""6\x5d = {\x0a"
"  8.1276550293e+01, /* 0x42a28d98 */\x0a"
"  1.9917987061e+03, /* 0x44f8f98f */\x0a"
"  1.7468484375e+04, /* 0x468878f8 */\x0a"
"  4.9851425781e+04, /* 0x4742bb6d */\x0a"
"  2.7948074219e+04, /* 0x46da5826 */\x0a"
" -4.7191835938e+03, /* 0xc5937978 */\x0a"
"};\x0a"
"\x0a"
"static const float qr3\x5b""6\x5d = {\x0a"
" -5.0783124372e-09, /* 0xb1ae7d4f */\x0a"
" -1.0253783315e-01, /* 0xbdd1ff5b */\x0a"
" -4.6101160049e+00, /* 0xc0938612 */\x0a"
" -5.7847221375e+01, /* 0xc267638e */\x0a"
" -2.2824453735e+02, /* 0xc3643e9a */\x0a"
" -2.1921012878e+02, /* 0xc35b35cb */\x0a"
"};\x0a"
"static const float qs3\x5b""6\x5d = {\x0a"
"  4.7665153503e+01, /* 0x423ea91e */\x0a"
"  6.7386511230e+02, /* 0x4428775e */\x0a"
"  3.3801528320e+03, /* 0x45534272 */\x0a"
"  5.5477290039e+03, /* 0x45ad5dd5 */\x0a"
"  1.9031191406e+03, /* 0x44ede3d0 */\x0a"
" -1.3520118713e+02, /* 0xc3073381 */\x0a"
"};\x0a"
"\x0a"
"static const float qr2\x5b""6\x5d = {/* for x in \x5b""2.8570,2\x5d=1/\x5b""0.3499,0.5\x5d */\x0a"
" -1.7838172539e-07, /* 0xb43f8932 */\x0a"
" -1.0251704603e-01, /* 0xbdd1f475 */\x0a"
" -2.7522056103e+00, /* 0xc0302423 */\x0a"
" -1.9663616180e+01, /* 0xc19d4f16 */\x0a"
" -4.2325313568e+01, /* 0xc2294d1f */\x0a"
" -2.1371921539e+01, /* 0xc1aaf9b2 */\x0a"
"};\x0a"
"static const float qs2\x5b""6\x5d = {\x0a"
"  2.9533363342e+01, /* 0x41ec4454 */\x0a"
"  2.5298155212e+02, /* 0x437cfb47 */\x0a"
"  7.5750280762e+02, /* 0x443d602e */\x0a"
"  7.3939318848e+02, /* 0x4438d92a */\x0a"
"  1.5594900513e+02, /* 0x431bf2f2 */\x0a"
" -4.9594988823e+00, /* 0xc09eb437 */\x0a"
"};\x0a"
"\x0a"
"static float\x0a"
"qonef(float x)\x0a"
"{\x0a"
"\x09""const float *p,*q;\x0a"
"\x09""float  s,r,z;\x0a"
"\x09int32_t ix;\x0a"
"\x09GET_FLOAT_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"\x09if(ix>=0x40200000)     {p = qr8; q= qs8;}\x0a"
"\x09""else if(ix>=0x40f71c58){p = qr5; q= qs5;}\x0a"
"\x09""else if(ix>=0x4036db68){p = qr3; q= qs3;}\x0a"
"\x09""else if(ix>=0x40000000){p = qr2; q= qs2;}\x0a"
"\x09z = one/(x*x);\x0a"
"\x09r = p\x5b""0\x5d+z*(p\x5b""1\x5d+z*(p\x5b""2\x5d+z*(p\x5b""3\x5d+z*(p\x5b""4\x5d+z*p\x5b""5\x5d))));\x0a"
"\x09s = one+z*(q\x5b""0\x5d+z*(q\x5b""1\x5d+z*(q\x5b""2\x5d+z*(q\x5b""3\x5d+z*(q\x5b""4\x5d+z*q\x5b""5\x5d)))));\x0a"
"\x09return ((float).375 + r/s)/x;\x0a"
"}\x0a"
"", 10056 ); }