#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_jn_c( 
"/* \x40(#)e_jn.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * jn(n, x), yn(n, x)\x0a"
" * floating point Bessel's function of the 1st and 2nd kind\x0a"
" * of order n\x0a"
" *          \x0a"
" * Special cases\x3a\x0a"
" *\x09y0(0)=y1(0)=yn(n,0) = -inf with division by zero signal;\x0a"
" *\x09y0(-ve)=y1(-ve)=yn(n,-ve) are NaN with invalid signal.\x0a"
" * Note 2. About jn(n,x), yn(n,x)\x0a"
" *\x09""For n=0, j0(x) is called,\x0a"
" *\x09""for n=1, j1(x) is called,\x0a"
" *\x09""for n<x, forward recursion us used starting\x0a"
" *\x09""from values of j0(x) and j1(x).\x0a"
" *\x09""for n>x, a continued fraction approximation to\x0a"
" *\x09j(n,x)/j(n-1,x) is evaluated and then backward\x0a"
" *\x09recursion is used starting from a supposed value\x0a"
" *\x09""for j(n,x). The resulting value of j(0,x) is\x0a"
" *\x09""compared with the actual value to correct the\x0a"
" *\x09supposed value of j(n,x).\x0a"
" *\x0a"
" *\x09yn(n,x) is similar in all respects, except\x0a"
" *\x09that forward recursion is used for all\x0a"
" *\x09values of n>1.\x0a"
" *\x09\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double\x0a"
"invsqrtpi=  5.64189583547756279280e-01, /* 0x3FE20DD7, 0x50429B6D */\x0a"
"two   =  2.00000000000000000000e+00, /* 0x40000000, 0x00000000 */\x0a"
"one   =  1.00000000000000000000e+00; /* 0x3FF00000, 0x00000000 */\x0a"
"\x0a"
"static const double zero  =  0.00000000000000000000e+00;\x0a"
"\x0a"
"double\x0a"
"jn(int n, double x)\x0a"
"{\x0a"
"\x09int32_t i,hx,ix,lx, sgn;\x0a"
"\x09""double a, b, temp, di;\x0a"
"\x09""double z, w;\x0a"
"\x0a"
"    /* J(-n,x) = (-1)^n * J(n, x), J(n, -x) = (-1)^n * J(n, x)\x0a"
"     * Thus, J(-n,x) = J(n,-x)\x0a"
"     */\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"\x09ix = 0x7fffffff\x26hx;\x0a"
"    /* if J(n,NaN) is NaN */\x0a"
"\x09if((ix\x7c((u_int32_t)(lx\x7c-lx))>>31)>0x7ff00000) return x+x;\x0a"
"\x09if(n<0){\x09\x09\x0a"
"\x09\x09n = -n;\x0a"
"\x09\x09x = -x;\x0a"
"\x09\x09hx ^= 0x80000000;\x0a"
"\x09}\x0a"
"\x09if(n==0) return(j0(x));\x0a"
"\x09if(n==1) return(j1(x));\x0a"
"\x09sgn = (n\x26""1)\x26(hx>>31);\x09/* even n -- 0, odd n -- sign(x) */\x0a"
"\x09x = fabs(x);\x0a"
"\x09if((ix\x7clx)==0\x7c\x7cix>=0x7ff00000) \x09/* if x is 0 or inf */\x0a"
"\x09    b = zero;\x0a"
"\x09""else if((double)n<=x) {   \x0a"
"\x09\x09/* Safe to use J(n+1,x)=2n/x *J(n,x)-J(n-1,x) */\x0a"
"\x09    if(ix>=0x52D00000) { /* x > 2**302 */\x0a"
"    /* (x >> n**2) \x0a"
"     *\x09    Jn(x) = cos(x-(2n+1)*pi/4)*sqrt(2/x*pi)\x0a"
"     *\x09    Yn(x) = sin(x-(2n+1)*pi/4)*sqrt(2/x*pi)\x0a"
"     *\x09    Let s=sin(x), c=cos(x), \x0a"
"     *\x09\x09xn=x-(2n+1)*pi/4, sqt2 = sqrt(2),then\x0a"
"     *\x0a"
"     *\x09\x09   n\x09sin(xn)*sqt2\x09""cos(xn)*sqt2\x0a"
"     *\x09\x09----------------------------------\x0a"
"     *\x09\x09   0\x09 s-c\x09\x09 c+s\x0a"
"     *\x09\x09   1\x09-s-c \x09\x09-c+s\x0a"
"     *\x09\x09   2\x09-s+c\x09\x09-c-s\x0a"
"     *\x09\x09   3\x09 s+c\x09\x09 c-s\x0a"
"     */\x0a"
"\x09\x09switch(n\x26""3) {\x0a"
"\x09\x09    case 0\x3a temp =  cos(x)+sin(x); break;\x0a"
"\x09\x09    case 1\x3a temp = -cos(x)+sin(x); break;\x0a"
"\x09\x09    case 2\x3a temp = -cos(x)-sin(x); break;\x0a"
"\x09\x09    case 3\x3a temp =  cos(x)-sin(x); break;\x0a"
"\x09\x09}\x0a"
"\x09\x09""b = invsqrtpi*temp/sqrt(x);\x0a"
"\x09    } else {\x09\x0a"
"\x09        a = j0(x);\x0a"
"\x09        b = j1(x);\x0a"
"\x09        for(i=1;i<n;i++){\x0a"
"\x09\x09    temp = b;\x0a"
"\x09\x09    b = b*((double)(i+i)/x) - a; /* avoid underflow */\x0a"
"\x09\x09    a = temp;\x0a"
"\x09        }\x0a"
"\x09    }\x0a"
"\x09} else {\x0a"
"\x09    if(ix<0x3e100000) {\x09/* x < 2**-29 */\x0a"
"    /* x is tiny, return the first Taylor expansion of J(n,x) \x0a"
"     * J(n,x) = 1/n\x21*(x/2)^n  - ...\x0a"
"     */\x0a"
"\x09\x09if(n>33)\x09/* underflow */\x0a"
"\x09\x09    b = zero;\x0a"
"\x09\x09""else {\x0a"
"\x09\x09    temp = x*0.5; b = temp;\x0a"
"\x09\x09    for (a=one,i=2;i<=n;i++) {\x0a"
"\x09\x09\x09""a *= (double)i;\x09\x09/* a = n\x21 */\x0a"
"\x09\x09\x09""b *= temp;\x09\x09/* b = (x/2)^n */\x0a"
"\x09\x09    }\x0a"
"\x09\x09    b = b/a;\x0a"
"\x09\x09}\x0a"
"\x09    } else {\x0a"
"\x09\x09/* use backward recurrence */\x0a"
"\x09\x09/* \x09\x09\x09x      x^2      x^2       \x0a"
"\x09\x09 *  J(n,x)/J(n-1,x) =  ----   ------   ------   .....\x0a"
"\x09\x09 *\x09\x09\x09""2n  - 2(n+1) - 2(n+2)\x0a"
"\x09\x09 *\x0a"
"\x09\x09 * \x09\x09\x09""1      1        1       \x0a"
"\x09\x09 *  (for large x)   =  ----  ------   ------   .....\x0a"
"\x09\x09 *\x09\x09\x09""2n   2(n+1)   2(n+2)\x0a"
"\x09\x09 *\x09\x09\x09-- - ------ - ------ - \x0a"
"\x09\x09 *\x09\x09\x09 x     x         x\x0a"
"\x09\x09 *\x0a"
"\x09\x09 * Let w = 2n/x and h=2/x, then the above quotient\x0a"
"\x09\x09 * is equal to the continued fraction\x3a\x0a"
"\x09\x09 *\x09\x09    1\x0a"
"\x09\x09 *\x09= -----------------------\x0a"
"\x09\x09 *\x09\x09       1\x0a"
"\x09\x09 *\x09   w - -----------------\x0a"
"\x09\x09 *\x09\x09\x09  1\x0a"
"\x09\x09 * \x09        w+h - ---------\x0a"
"\x09\x09 *\x09\x09       w+2h - ...\x0a"
"\x09\x09 *\x0a"
"\x09\x09 * To determine how many terms needed, let\x0a"
"\x09\x09 * Q(0) = w, Q(1) = w(w+h) - 1,\x0a"
"\x09\x09 * Q(k) = (w+k*h)*Q(k-1) - Q(k-2),\x0a"
"\x09\x09 * When Q(k) > 1e4\x09good for single \x0a"
"\x09\x09 * When Q(k) > 1e9\x09good for double \x0a"
"\x09\x09 * When Q(k) > 1e17\x09good for quadruple \x0a"
"\x09\x09 */\x0a"
"\x09    /* determine k */\x0a"
"\x09\x09""double t,v;\x0a"
"\x09\x09""double q0,q1,h,tmp; int32_t k,m;\x0a"
"\x09\x09w  = (n+n)/(double)x; h = 2.0/(double)x;\x0a"
"\x09\x09q0 = w;  z = w+h; q1 = w*z - 1.0; k=1;\x0a"
"\x09\x09while(q1<1.0e9) {\x0a"
"\x09\x09\x09k += 1; z += h;\x0a"
"\x09\x09\x09tmp = z*q1 - q0;\x0a"
"\x09\x09\x09q0 = q1;\x0a"
"\x09\x09\x09q1 = tmp;\x0a"
"\x09\x09}\x0a"
"\x09\x09m = n+n;\x0a"
"\x09\x09""for(t=zero, i = 2*(n+k); i>=m; i -= 2) t = one/(i/x-t);\x0a"
"\x09\x09""a = t;\x0a"
"\x09\x09""b = one;\x0a"
"\x09\x09/*  estimate log((2/x)^n*n\x21) = n*log(2/x)+n*ln(n)\x0a"
"\x09\x09 *  Hence, if n*(log(2n/x)) > ...\x0a"
"\x09\x09 *  single 8.8722839355e+01\x0a"
"\x09\x09 *  double 7.09782712893383973096e+02\x0a"
"\x09\x09 *  long double 1.1356523406294143949491931077970765006170e+04\x0a"
"\x09\x09 *  then recurrent value may overflow and the result is \x0a"
"\x09\x09 *  likely underflow to zero\x0a"
"\x09\x09 */\x0a"
"\x09\x09tmp = n;\x0a"
"\x09\x09v = two/x;\x0a"
"\x09\x09tmp = tmp*log(fabs(v*tmp));\x0a"
"\x09\x09if(tmp<7.09782712893383973096e+02) {\x0a"
"\x09    \x09    for(i=n-1,di=(double)(i+i);i>0;i--){\x0a"
"\x09\x09        temp = b;\x0a"
"\x09\x09\x09""b *= di;\x0a"
"\x09\x09\x09""b  = b/x - a;\x0a"
"\x09\x09        a = temp;\x0a"
"\x09\x09\x09""di -= two;\x0a"
"\x09     \x09    }\x0a"
"\x09\x09} else {\x0a"
"\x09    \x09    for(i=n-1,di=(double)(i+i);i>0;i--){\x0a"
"\x09\x09        temp = b;\x0a"
"\x09\x09\x09""b *= di;\x0a"
"\x09\x09\x09""b  = b/x - a;\x0a"
"\x09\x09        a = temp;\x0a"
"\x09\x09\x09""di -= two;\x0a"
"\x09\x09    /* scale b to avoid spurious overflow */\x0a"
"\x09\x09\x09if(b>1e100) {\x0a"
"\x09\x09\x09    a /= b;\x0a"
"\x09\x09\x09    t /= b;\x0a"
"\x09\x09\x09    b  = one;\x0a"
"\x09\x09\x09}\x0a"
"\x09     \x09    }\x0a"
"\x09\x09}\x0a"
"\x09    \x09""b = (t*j0(x)/b);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09if(sgn==1) return -b; else return b;\x0a"
"}\x0a"
"\x0a"
"double\x0a"
"yn(int n, double x) \x0a"
"{\x0a"
"\x09int32_t i,hx,ix,lx;\x0a"
"\x09int32_t sign;\x0a"
"\x09""double a, b, temp;\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"\x09ix = 0x7fffffff\x26hx;\x0a"
"    /* if Y(n,NaN) is NaN */\x0a"
"\x09if((ix\x7c((u_int32_t)(lx\x7c-lx))>>31)>0x7ff00000) return x+x;\x0a"
"\x09if((ix\x7clx)==0) return -one/zero;\x0a"
"\x09if(hx<0) return zero/zero;\x0a"
"\x09sign = 1;\x0a"
"\x09if(n<0){\x0a"
"\x09\x09n = -n;\x0a"
"\x09\x09sign = 1 - ((n\x26""1)<<1);\x0a"
"\x09}\x0a"
"\x09if(n==0) return(y0(x));\x0a"
"\x09if(n==1) return(sign*y1(x));\x0a"
"\x09if(ix==0x7ff00000) return zero;\x0a"
"\x09if(ix>=0x52D00000) { /* x > 2**302 */\x0a"
"    /* (x >> n**2) \x0a"
"     *\x09    Jn(x) = cos(x-(2n+1)*pi/4)*sqrt(2/x*pi)\x0a"
"     *\x09    Yn(x) = sin(x-(2n+1)*pi/4)*sqrt(2/x*pi)\x0a"
"     *\x09    Let s=sin(x), c=cos(x), \x0a"
"     *\x09\x09xn=x-(2n+1)*pi/4, sqt2 = sqrt(2),then\x0a"
"     *\x0a"
"     *\x09\x09   n\x09sin(xn)*sqt2\x09""cos(xn)*sqt2\x0a"
"     *\x09\x09----------------------------------\x0a"
"     *\x09\x09   0\x09 s-c\x09\x09 c+s\x0a"
"     *\x09\x09   1\x09-s-c \x09\x09-c+s\x0a"
"     *\x09\x09   2\x09-s+c\x09\x09-c-s\x0a"
"     *\x09\x09   3\x09 s+c\x09\x09 c-s\x0a"
"     */\x0a"
"\x09\x09switch(n\x26""3) {\x0a"
"\x09\x09    case 0\x3a temp =  sin(x)-cos(x); break;\x0a"
"\x09\x09    case 1\x3a temp = -sin(x)-cos(x); break;\x0a"
"\x09\x09    case 2\x3a temp = -sin(x)+cos(x); break;\x0a"
"\x09\x09    case 3\x3a temp =  sin(x)+cos(x); break;\x0a"
"\x09\x09}\x0a"
"\x09\x09""b = invsqrtpi*temp/sqrt(x);\x0a"
"\x09} else {\x0a"
"\x09    u_int32_t high;\x0a"
"\x09    a = y0(x);\x0a"
"\x09    b = y1(x);\x0a"
"\x09/* quit if b is -inf */\x0a"
"\x09    GET_HIGH_WORD(high,b);\x0a"
"\x09    for(i=1;i<n\x26\x26high\x21=0xfff00000;i++){ \x0a"
"\x09\x09temp = b;\x0a"
"\x09\x09""b = ((double)(i+i)/x)*b - a;\x0a"
"\x09\x09GET_HIGH_WORD(high,b);\x0a"
"\x09\x09""a = temp;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09if(sign>0) return b; else return -b;\x0a"
"}\x0a"
"", 6894 ); }