#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_jnf_c( 
"/* e_jnf.c -- float version of e_jn.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const float\x0a"
"two   =  2.0000000000e+00, /* 0x40000000 */\x0a"
"one   =  1.0000000000e+00; /* 0x3F800000 */\x0a"
"\x0a"
"static const float zero  =  0.0000000000e+00;\x0a"
"\x0a"
"float\x0a"
"jnf(int n, float x)\x0a"
"{\x0a"
"\x09int32_t i,hx,ix, sgn;\x0a"
"\x09""float a, b, temp, di;\x0a"
"\x09""float z, w;\x0a"
"\x0a"
"    /* J(-n,x) = (-1)^n * J(n, x), J(n, -x) = (-1)^n * J(n, x)\x0a"
"     * Thus, J(-n,x) = J(n,-x)\x0a"
"     */\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09ix = 0x7fffffff\x26hx;\x0a"
"    /* if J(n,NaN) is NaN */\x0a"
"\x09if(ix>0x7f800000) return x+x;\x0a"
"\x09if(n<0){\x09\x09\x0a"
"\x09\x09n = -n;\x0a"
"\x09\x09x = -x;\x0a"
"\x09\x09hx ^= 0x80000000;\x0a"
"\x09}\x0a"
"\x09if(n==0) return(j0f(x));\x0a"
"\x09if(n==1) return(j1f(x));\x0a"
"\x09sgn = (n\x26""1)\x26(hx>>31);\x09/* even n -- 0, odd n -- sign(x) */\x0a"
"\x09x = fabsf(x);\x0a"
"\x09if(ix==0\x7c\x7cix>=0x7f800000) \x09/* if x is 0 or inf */\x0a"
"\x09    b = zero;\x0a"
"\x09""else if((float)n<=x) {   \x0a"
"\x09\x09/* Safe to use J(n+1,x)=2n/x *J(n,x)-J(n-1,x) */\x0a"
"\x09    a = j0f(x);\x0a"
"\x09    b = j1f(x);\x0a"
"\x09    for(i=1;i<n;i++){\x0a"
"\x09\x09temp = b;\x0a"
"\x09\x09""b = b*((float)(i+i)/x) - a; /* avoid underflow */\x0a"
"\x09\x09""a = temp;\x0a"
"\x09    }\x0a"
"\x09} else {\x0a"
"\x09    if(ix<0x30800000) {\x09/* x < 2**-29 */\x0a"
"    /* x is tiny, return the first Taylor expansion of J(n,x) \x0a"
"     * J(n,x) = 1/n\x21*(x/2)^n  - ...\x0a"
"     */\x0a"
"\x09\x09if(n>33)\x09/* underflow */\x0a"
"\x09\x09    b = zero;\x0a"
"\x09\x09""else {\x0a"
"\x09\x09    temp = x*(float)0.5; b = temp;\x0a"
"\x09\x09    for (a=one,i=2;i<=n;i++) {\x0a"
"\x09\x09\x09""a *= (float)i;\x09\x09/* a = n\x21 */\x0a"
"\x09\x09\x09""b *= temp;\x09\x09/* b = (x/2)^n */\x0a"
"\x09\x09    }\x0a"
"\x09\x09    b = b/a;\x0a"
"\x09\x09}\x0a"
"\x09    } else {\x0a"
"\x09\x09/* use backward recurrence */\x0a"
"\x09\x09/* \x09\x09\x09x      x^2      x^2       \x0a"
"\x09\x09 *  J(n,x)/J(n-1,x) =  ----   ------   ------   .....\x0a"
"\x09\x09 *\x09\x09\x09""2n  - 2(n+1) - 2(n+2)\x0a"
"\x09\x09 *\x0a"
"\x09\x09 * \x09\x09\x09""1      1        1       \x0a"
"\x09\x09 *  (for large x)   =  ----  ------   ------   .....\x0a"
"\x09\x09 *\x09\x09\x09""2n   2(n+1)   2(n+2)\x0a"
"\x09\x09 *\x09\x09\x09-- - ------ - ------ - \x0a"
"\x09\x09 *\x09\x09\x09 x     x         x\x0a"
"\x09\x09 *\x0a"
"\x09\x09 * Let w = 2n/x and h=2/x, then the above quotient\x0a"
"\x09\x09 * is equal to the continued fraction\x3a\x0a"
"\x09\x09 *\x09\x09    1\x0a"
"\x09\x09 *\x09= -----------------------\x0a"
"\x09\x09 *\x09\x09       1\x0a"
"\x09\x09 *\x09   w - -----------------\x0a"
"\x09\x09 *\x09\x09\x09  1\x0a"
"\x09\x09 * \x09        w+h - ---------\x0a"
"\x09\x09 *\x09\x09       w+2h - ...\x0a"
"\x09\x09 *\x0a"
"\x09\x09 * To determine how many terms needed, let\x0a"
"\x09\x09 * Q(0) = w, Q(1) = w(w+h) - 1,\x0a"
"\x09\x09 * Q(k) = (w+k*h)*Q(k-1) - Q(k-2),\x0a"
"\x09\x09 * When Q(k) > 1e4\x09good for single \x0a"
"\x09\x09 * When Q(k) > 1e9\x09good for double \x0a"
"\x09\x09 * When Q(k) > 1e17\x09good for quadruple \x0a"
"\x09\x09 */\x0a"
"\x09    /* determine k */\x0a"
"\x09\x09""float t,v;\x0a"
"\x09\x09""float q0,q1,h,tmp; int32_t k,m;\x0a"
"\x09\x09w  = (n+n)/(float)x; h = (float)2.0/(float)x;\x0a"
"\x09\x09q0 = w;  z = w+h; q1 = w*z - (float)1.0; k=1;\x0a"
"\x09\x09while(q1<(float)1.0e9) {\x0a"
"\x09\x09\x09k += 1; z += h;\x0a"
"\x09\x09\x09tmp = z*q1 - q0;\x0a"
"\x09\x09\x09q0 = q1;\x0a"
"\x09\x09\x09q1 = tmp;\x0a"
"\x09\x09}\x0a"
"\x09\x09m = n+n;\x0a"
"\x09\x09""for(t=zero, i = 2*(n+k); i>=m; i -= 2) t = one/(i/x-t);\x0a"
"\x09\x09""a = t;\x0a"
"\x09\x09""b = one;\x0a"
"\x09\x09/*  estimate log((2/x)^n*n\x21) = n*log(2/x)+n*ln(n)\x0a"
"\x09\x09 *  Hence, if n*(log(2n/x)) > ...\x0a"
"\x09\x09 *  single 8.8722839355e+01\x0a"
"\x09\x09 *  double 7.09782712893383973096e+02\x0a"
"\x09\x09 *  long double 1.1356523406294143949491931077970765006170e+04\x0a"
"\x09\x09 *  then recurrent value may overflow and the result is \x0a"
"\x09\x09 *  likely underflow to zero\x0a"
"\x09\x09 */\x0a"
"\x09\x09tmp = n;\x0a"
"\x09\x09v = two/x;\x0a"
"\x09\x09tmp = tmp*logf(fabsf(v*tmp));\x0a"
"\x09\x09if(tmp<(float)8.8721679688e+01) {\x0a"
"\x09    \x09    for(i=n-1,di=(float)(i+i);i>0;i--){\x0a"
"\x09\x09        temp = b;\x0a"
"\x09\x09\x09""b *= di;\x0a"
"\x09\x09\x09""b  = b/x - a;\x0a"
"\x09\x09        a = temp;\x0a"
"\x09\x09\x09""di -= two;\x0a"
"\x09     \x09    }\x0a"
"\x09\x09} else {\x0a"
"\x09    \x09    for(i=n-1,di=(float)(i+i);i>0;i--){\x0a"
"\x09\x09        temp = b;\x0a"
"\x09\x09\x09""b *= di;\x0a"
"\x09\x09\x09""b  = b/x - a;\x0a"
"\x09\x09        a = temp;\x0a"
"\x09\x09\x09""di -= two;\x0a"
"\x09\x09    /* scale b to avoid spurious overflow */\x0a"
"\x09\x09\x09if(b>(float)1e10) {\x0a"
"\x09\x09\x09    a /= b;\x0a"
"\x09\x09\x09    t /= b;\x0a"
"\x09\x09\x09    b  = one;\x0a"
"\x09\x09\x09}\x0a"
"\x09     \x09    }\x0a"
"\x09\x09}\x0a"
"\x09    \x09""b = (t*j0f(x)/b);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09if(sgn==1) return -b; else return b;\x0a"
"}\x0a"
"\x0a"
"float\x0a"
"ynf(int n, float x) \x0a"
"{\x0a"
"\x09int32_t i,hx,ix,ib;\x0a"
"\x09int32_t sign;\x0a"
"\x09""float a, b, temp;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09ix = 0x7fffffff\x26hx;\x0a"
"    /* if Y(n,NaN) is NaN */\x0a"
"\x09if(ix>0x7f800000) return x+x;\x0a"
"\x09if(ix==0) return -one/zero;\x0a"
"\x09if(hx<0) return zero/zero;\x0a"
"\x09sign = 1;\x0a"
"\x09if(n<0){\x0a"
"\x09\x09n = -n;\x0a"
"\x09\x09sign = 1 - ((n\x26""1)<<1);\x0a"
"\x09}\x0a"
"\x09if(n==0) return(y0f(x));\x0a"
"\x09if(n==1) return(sign*y1f(x));\x0a"
"\x09if(ix==0x7f800000) return zero;\x0a"
"\x0a"
"\x09""a = y0f(x);\x0a"
"\x09""b = y1f(x);\x0a"
"\x09/* quit if b is -inf */\x0a"
"\x09GET_FLOAT_WORD(ib,b);\x0a"
"\x09""for(i=1;i<n\x26\x26ib\x21=0xff800000;i++){ \x0a"
"\x09    temp = b;\x0a"
"\x09    b = ((float)(i+i)/x)*b - a;\x0a"
"\x09    GET_FLOAT_WORD(ib,b);\x0a"
"\x09    a = temp;\x0a"
"\x09}\x0a"
"\x09if(sign>0) return b; else return -b;\x0a"
"}\x0a"
"", 4571 ); }