#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_lgamma_r_c( 
"/* \x40(#)er_lgamma.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* lgamma_r(x, signgamp)\x0a"
" * Reentrant version of the logarithm of the Gamma function \x0a"
" * with user provide pointer for the sign of Gamma(x). \x0a"
" *\x0a"
" * Method\x3a\x0a"
" *   1. Argument Reduction for 0 < x <= 8\x0a"
" * \x09Since gamma(1+s)=s*gamma(s), for x in \x5b""0,8\x5d, we may \x0a"
" * \x09reduce x to a number in \x5b""1.5,2.5\x5d by\x0a"
" * \x09\x09lgamma(1+s) = log(s) + lgamma(s)\x0a"
" *\x09""for example,\x0a"
" *\x09\x09lgamma(7.3) = log(6.3) + lgamma(6.3)\x0a"
" *\x09\x09\x09    = log(6.3*5.3) + lgamma(5.3)\x0a"
" *\x09\x09\x09    = log(6.3*5.3*4.3*3.3*2.3) + lgamma(2.3)\x0a"
" *   2. Polynomial approximation of lgamma around its\x0a"
" *\x09minimun ymin=1.461632144968362245 to maintain monotonicity.\x0a"
" *\x09On \x5bymin-0.23, ymin+0.27\x5d (i.e., \x5b""1.23164,1.73163\x5d), use\x0a"
" *\x09\x09Let z = x-ymin;\x0a"
" *\x09\x09lgamma(x) = -1.214862905358496078218 + z^2*poly(z)\x0a"
" *\x09where\x0a"
" *\x09\x09poly(z) is a 14 degree polynomial.\x0a"
" *   2. Rational approximation in the primary interval \x5b""2,3\x5d\x0a"
" *\x09We use the following approximation\x3a\x0a"
" *\x09\x09s = x-2.0;\x0a"
" *\x09\x09lgamma(x) = 0.5*s + s*P(s)/Q(s)\x0a"
" *\x09with accuracy\x0a"
" *\x09\x09\x7cP/Q - (lgamma(x)-0.5s)\x7c < 2**-61.71\x0a"
" *\x09Our algorithms are based on the following observation\x0a"
" *\x0a"
" *                             zeta(2)-1    2    zeta(3)-1    3\x0a"
" * lgamma(2+s) = s*(1-Euler) + --------- * s  -  --------- * s  + ...\x0a"
" *                                 2                 3\x0a"
" *\x0a"
" *\x09where Euler = 0.5771... is the Euler constant, which is very\x0a"
" *\x09""close to 0.5.\x0a"
" *\x0a"
" *   3. For x>=8, we have\x0a"
" *\x09lgamma(x)\x7e(x-0.5)log(x)-x+0.5*log(2pi)+1/(12x)-1/(360x**3)+....\x0a"
" *\x09(better formula\x3a\x0a"
" *\x09   lgamma(x)\x7e(x-0.5)*(log(x)-1)-.5*(log(2pi)-1) + ...)\x0a"
" *\x09Let z = 1/x, then we approximation\x0a"
" *\x09\x09""f(z) = lgamma(x) - (x-0.5)(log(x)-1)\x0a"
" *\x09""by\x0a"
" *\x09  \x09\x09\x09    3       5             11\x0a"
" *\x09\x09w = w0 + w1*z + w2*z  + w3*z  + ... + w6*z\x0a"
" *\x09where \x0a"
" *\x09\x09\x7cw - f(z)\x7c < 2**-58.74\x0a"
" *\x09\x09\x0a"
" *   4. For negative x, since (G is gamma function)\x0a"
" *\x09\x09-x*G(-x)*G(x) = pi/sin(pi*x),\x0a"
" * \x09we have\x0a"
" * \x09\x09G(x) = pi/(sin(pi*x)*(-x)*G(-x))\x0a"
" *\x09since G(-x) is positive, sign(G(x)) = sign(sin(pi*x)) for x<0\x0a"
" *\x09Hence, for x<0, signgam = sign(sin(pi*x)) and \x0a"
" *\x09\x09lgamma(x) = log(\x7cGamma(x)\x7c)\x0a"
" *\x09\x09\x09  = log(pi/(\x7cx*sin(pi*x)\x7c)) - lgamma(-x);\x0a"
" *\x09Note\x3a one should avoid compute pi*(-x) directly in the \x0a"
" *\x09      computation of sin(pi*(-x)).\x0a"
" *\x09\x09\x0a"
" *   5. Special Cases\x0a"
" *\x09\x09lgamma(2+s) \x7e s*(1-Euler) for tiny s\x0a"
" *\x09\x09lgamma(1)=lgamma(2)=0\x0a"
" *\x09\x09lgamma(x) \x7e -log(x) for tiny x\x0a"
" *\x09\x09lgamma(0) = lgamma(inf) = inf\x0a"
" *\x09 \x09lgamma(-integer) = +-inf\x0a"
" *\x09\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double \x0a"
"two52=  4.50359962737049600000e+15, /* 0x43300000, 0x00000000 */\x0a"
"half=  5.00000000000000000000e-01, /* 0x3FE00000, 0x00000000 */\x0a"
"one =  1.00000000000000000000e+00, /* 0x3FF00000, 0x00000000 */\x0a"
"pi  =  3.14159265358979311600e+00, /* 0x400921FB, 0x54442D18 */\x0a"
"a0  =  7.72156649015328655494e-02, /* 0x3FB3C467, 0xE37DB0C8 */\x0a"
"a1  =  3.22467033424113591611e-01, /* 0x3FD4A34C, 0xC4A60FAD */\x0a"
"a2  =  6.73523010531292681824e-02, /* 0x3FB13E00, 0x1A5562A7 */\x0a"
"a3  =  2.05808084325167332806e-02, /* 0x3F951322, 0xAC92547B */\x0a"
"a4  =  7.38555086081402883957e-03, /* 0x3F7E404F, 0xB68FEFE8 */\x0a"
"a5  =  2.89051383673415629091e-03, /* 0x3F67ADD8, 0xCCB7926B */\x0a"
"a6  =  1.19270763183362067845e-03, /* 0x3F538A94, 0x116F3F5D */\x0a"
"a7  =  5.10069792153511336608e-04, /* 0x3F40B6C6, 0x89B99C00 */\x0a"
"a8  =  2.20862790713908385557e-04, /* 0x3F2CF2EC, 0xED10E54D */\x0a"
"a9  =  1.08011567247583939954e-04, /* 0x3F1C5088, 0x987DFB07 */\x0a"
"a10 =  2.52144565451257326939e-05, /* 0x3EFA7074, 0x428CFA52 */\x0a"
"a11 =  4.48640949618915160150e-05, /* 0x3F07858E, 0x90A45837 */\x0a"
"tc  =  1.46163214496836224576e+00, /* 0x3FF762D8, 0x6356BE3F */\x0a"
"tf  = -1.21486290535849611461e-01, /* 0xBFBF19B9, 0xBCC38A42 */\x0a"
"/* tt = -(tail of tf) */\x0a"
"tt  = -3.63867699703950536541e-18, /* 0xBC50C7CA, 0xA48A971F */\x0a"
"t0  =  4.83836122723810047042e-01, /* 0x3FDEF72B, 0xC8EE38A2 */\x0a"
"t1  = -1.47587722994593911752e-01, /* 0xBFC2E427, 0x8DC6C509 */\x0a"
"t2  =  6.46249402391333854778e-02, /* 0x3FB08B42, 0x94D5419B */\x0a"
"t3  = -3.27885410759859649565e-02, /* 0xBFA0C9A8, 0xDF35B713 */\x0a"
"t4  =  1.79706750811820387126e-02, /* 0x3F9266E7, 0x970AF9EC */\x0a"
"t5  = -1.03142241298341437450e-02, /* 0xBF851F9F, 0xBA91EC6A */\x0a"
"t6  =  6.10053870246291332635e-03, /* 0x3F78FCE0, 0xE370E344 */\x0a"
"t7  = -3.68452016781138256760e-03, /* 0xBF6E2EFF, 0xB3E914D7 */\x0a"
"t8  =  2.25964780900612472250e-03, /* 0x3F6282D3, 0x2E15C915 */\x0a"
"t9  = -1.40346469989232843813e-03, /* 0xBF56FE8E, 0xBF2D1AF1 */\x0a"
"t10 =  8.81081882437654011382e-04, /* 0x3F4CDF0C, 0xEF61A8E9 */\x0a"
"t11 = -5.38595305356740546715e-04, /* 0xBF41A610, 0x9C73E0EC */\x0a"
"t12 =  3.15632070903625950361e-04, /* 0x3F34AF6D, 0x6C0EBBF7 */\x0a"
"t13 = -3.12754168375120860518e-04, /* 0xBF347F24, 0xECC38C38 */\x0a"
"t14 =  3.35529192635519073543e-04, /* 0x3F35FD3E, 0xE8C2D3F4 */\x0a"
"u0  = -7.72156649015328655494e-02, /* 0xBFB3C467, 0xE37DB0C8 */\x0a"
"u1  =  6.32827064025093366517e-01, /* 0x3FE4401E, 0x8B005DFF */\x0a"
"u2  =  1.45492250137234768737e+00, /* 0x3FF7475C, 0xD119BD6F */\x0a"
"u3  =  9.77717527963372745603e-01, /* 0x3FEF4976, 0x44EA8450 */\x0a"
"u4  =  2.28963728064692451092e-01, /* 0x3FCD4EAE, 0xF6010924 */\x0a"
"u5  =  1.33810918536787660377e-02, /* 0x3F8B678B, 0xBF2BAB09 */\x0a"
"v1  =  2.45597793713041134822e+00, /* 0x4003A5D7, 0xC2BD619C */\x0a"
"v2  =  2.12848976379893395361e+00, /* 0x40010725, 0xA42B18F5 */\x0a"
"v3  =  7.69285150456672783825e-01, /* 0x3FE89DFB, 0xE45050AF */\x0a"
"v4  =  1.04222645593369134254e-01, /* 0x3FBAAE55, 0xD6537C88 */\x0a"
"v5  =  3.21709242282423911810e-03, /* 0x3F6A5ABB, 0x57D0CF61 */\x0a"
"s0  = -7.72156649015328655494e-02, /* 0xBFB3C467, 0xE37DB0C8 */\x0a"
"s1  =  2.14982415960608852501e-01, /* 0x3FCB848B, 0x36E20878 */\x0a"
"s2  =  3.25778796408930981787e-01, /* 0x3FD4D98F, 0x4F139F59 */\x0a"
"s3  =  1.46350472652464452805e-01, /* 0x3FC2BB9C, 0xBEE5F2F7 */\x0a"
"s4  =  2.66422703033638609560e-02, /* 0x3F9B481C, 0x7E939961 */\x0a"
"s5  =  1.84028451407337715652e-03, /* 0x3F5E26B6, 0x7368F239 */\x0a"
"s6  =  3.19475326584100867617e-05, /* 0x3F00BFEC, 0xDD17E945 */\x0a"
"r1  =  1.39200533467621045958e+00, /* 0x3FF645A7, 0x62C4AB74 */\x0a"
"r2  =  7.21935547567138069525e-01, /* 0x3FE71A18, 0x93D3DCDC */\x0a"
"r3  =  1.71933865632803078993e-01, /* 0x3FC601ED, 0xCCFBDF27 */\x0a"
"r4  =  1.86459191715652901344e-02, /* 0x3F9317EA, 0x742ED475 */\x0a"
"r5  =  7.77942496381893596434e-04, /* 0x3F497DDA, 0xCA41A95B */\x0a"
"r6  =  7.32668430744625636189e-06, /* 0x3EDEBAF7, 0xA5B38140 */\x0a"
"w0  =  4.18938533204672725052e-01, /* 0x3FDACFE3, 0x90C97D69 */\x0a"
"w1  =  8.33333333333329678849e-02, /* 0x3FB55555, 0x5555553B */\x0a"
"w2  = -2.77777777728775536470e-03, /* 0xBF66C16C, 0x16B02E5C */\x0a"
"w3  =  7.93650558643019558500e-04, /* 0x3F4A019F, 0x98CF38B6 */\x0a"
"w4  = -5.95187557450339963135e-04, /* 0xBF4380CB, 0x8C0FE741 */\x0a"
"w5  =  8.36339918996282139126e-04, /* 0x3F4B67BA, 0x4CDAD5D1 */\x0a"
"w6  = -1.63092934096575273989e-03; /* 0xBF5AB89D, 0x0B9E43E4 */\x0a"
"\x0a"
"static const double zero=  0.00000000000000000000e+00;\x0a"
"\x0a"
"static double\x0a"
"sin_pi(double x)\x0a"
"{\x0a"
"\x09""double y,z;\x0a"
"\x09int n,ix;\x0a"
"\x0a"
"\x09GET_HIGH_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"\x0a"
"\x09if(ix<0x3fd00000) return __kernel_sin(pi*x,zero,0);\x0a"
"\x09y = -x;\x09\x09/* x is assume negative */\x0a"
"\x0a"
"    /*\x0a"
"     * argument reduction, make sure inexact flag not raised if input\x0a"
"     * is an integer\x0a"
"     */\x0a"
"\x09z = floor(y);\x0a"
"\x09if(z\x21=y) {\x09\x09\x09\x09/* inexact anyway */\x0a"
"\x09    y  *= 0.5;\x0a"
"\x09    y   = 2.0*(y - floor(y));\x09\x09/* y = \x7cx\x7c mod 2.0 */\x0a"
"\x09    n   = (int) (y*4.0);\x0a"
"\x09} else {\x0a"
"            if(ix>=0x43400000) {\x0a"
"                y = zero; n = 0;                 /* y must be even */\x0a"
"            } else {\x0a"
"                if(ix<0x43300000) z = y+two52;\x09/* exact */\x0a"
"\x09\x09GET_LOW_WORD(n,z);\x0a"
"\x09\x09n \x26= 1;\x0a"
"                y  = n;\x0a"
"                n<<= 2;\x0a"
"            }\x0a"
"        }\x0a"
"\x09switch (n) {\x0a"
"\x09    case 0\x3a   y =  __kernel_sin(pi*y,zero,0); break;\x0a"
"\x09    case 1\x3a   \x0a"
"\x09    case 2\x3a   y =  __kernel_cos(pi*(0.5-y),zero); break;\x0a"
"\x09    case 3\x3a  \x0a"
"\x09    case 4\x3a   y =  __kernel_sin(pi*(one-y),zero,0); break;\x0a"
"\x09    case 5\x3a\x0a"
"\x09    case 6\x3a   y = -__kernel_cos(pi*(y-1.5),zero); break;\x0a"
"\x09    default\x3a  y =  __kernel_sin(pi*(y-2.0),zero,0); break;\x0a"
"\x09    }\x0a"
"\x09return -y;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"__link_always double\x0a"
"lgamma_r(double x, int *signgamp)\x0a"
"{\x0a"
"\x09""double t,y,z,nadj,p,p1,p2,p3,q,r,w;\x0a"
"\x09int i,hx,lx,ix;\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"\x0a"
"    /* purge off +-inf, NaN, +-0, and negative arguments */\x0a"
"\x09*signgamp = 1;\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x7ff00000) return x*x;\x0a"
"\x09if((ix\x7clx)==0) {\x0a"
"\x09    if(hx<0)\x0a"
"\x09\x09*signgamp = -1;\x0a"
"\x09    return one/zero;\x0a"
"\x09}\x0a"
"\x09if(ix<0x3b900000) {\x09/* \x7cx\x7c<2**-70, return -log(\x7cx\x7c) */\x0a"
"\x09    if(hx<0) {\x0a"
"\x09        *signgamp = -1;\x0a"
"\x09        return - log(-x);\x0a"
"\x09    } else return - log(x);\x0a"
"\x09}\x0a"
"\x09if(hx<0) {\x0a"
"\x09    if(ix>=0x43300000) \x09/* \x7cx\x7c>=2**52, must be -integer */\x0a"
"\x09\x09return one/zero;\x0a"
"\x09    t = sin_pi(x);\x0a"
"\x09    if(t==zero) return one/zero; /* -integer */\x0a"
"\x09    nadj = log(pi/fabs(t*x));\x0a"
"\x09    if(t<zero) *signgamp = -1;\x0a"
"\x09    x = -x;\x0a"
"\x09}\x0a"
"\x0a"
"    /* purge off 1 and 2 */\x0a"
"\x09if((((ix-0x3ff00000)\x7clx)==0)\x7c\x7c(((ix-0x40000000)\x7clx)==0)) r = 0;\x0a"
"    /* for x < 2.0 */\x0a"
"\x09""else if(ix<0x40000000) {\x0a"
"\x09    if(ix<=0x3feccccc) { \x09/* lgamma(x) = lgamma(x+1)-log(x) */\x0a"
"\x09\x09r = - log(x);\x0a"
"\x09\x09if(ix>=0x3FE76944) {y = one-x; i= 0;}\x0a"
"\x09\x09""else if(ix>=0x3FCDA661) {y= x-(tc-one); i=1;}\x0a"
"\x09  \x09""else {y = x; i=2;}\x0a"
"\x09    } else {\x0a"
"\x09  \x09r = zero;\x0a"
"\x09        if(ix>=0x3FFBB4C3) {y=2.0-x;i=0;} /* \x5b""1.7316,2\x5d */\x0a"
"\x09        else if(ix>=0x3FF3B4C4) {y=x-tc;i=1;} /* \x5b""1.23,1.73\x5d */\x0a"
"\x09\x09""else {y=x-one;i=2;}\x0a"
"\x09    }\x0a"
"\x09    switch(i) {\x0a"
"\x09      case 0\x3a\x0a"
"\x09\x09z = y*y;\x0a"
"\x09\x09p1 = a0+z*(a2+z*(a4+z*(a6+z*(a8+z*a10))));\x0a"
"\x09\x09p2 = z*(a1+z*(a3+z*(a5+z*(a7+z*(a9+z*a11)))));\x0a"
"\x09\x09p  = y*p1+p2;\x0a"
"\x09\x09r  += (p-0.5*y); break;\x0a"
"\x09      case 1\x3a\x0a"
"\x09\x09z = y*y;\x0a"
"\x09\x09w = z*y;\x0a"
"\x09\x09p1 = t0+w*(t3+w*(t6+w*(t9 +w*t12)));\x09/* parallel comp */\x0a"
"\x09\x09p2 = t1+w*(t4+w*(t7+w*(t10+w*t13)));\x0a"
"\x09\x09p3 = t2+w*(t5+w*(t8+w*(t11+w*t14)));\x0a"
"\x09\x09p  = z*p1-(tt-w*(p2+y*p3));\x0a"
"\x09\x09r += (tf + p); break;\x0a"
"\x09      case 2\x3a\x09\x0a"
"\x09\x09p1 = y*(u0+y*(u1+y*(u2+y*(u3+y*(u4+y*u5)))));\x0a"
"\x09\x09p2 = one+y*(v1+y*(v2+y*(v3+y*(v4+y*v5))));\x0a"
"\x09\x09r += (-0.5*y + p1/p2);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09""else if(ix<0x40200000) { \x09\x09\x09/* x < 8.0 */\x0a"
"\x09    i = (int)x;\x0a"
"\x09    t = zero;\x0a"
"\x09    y = x-(double)i;\x0a"
"\x09    p = y*(s0+y*(s1+y*(s2+y*(s3+y*(s4+y*(s5+y*s6))))));\x0a"
"\x09    q = one+y*(r1+y*(r2+y*(r3+y*(r4+y*(r5+y*r6)))));\x0a"
"\x09    r = half*y+p/q;\x0a"
"\x09    z = one;\x09/* lgamma(1+s) = log(s) + lgamma(s) */\x0a"
"\x09    switch(i) {\x0a"
"\x09    case 7\x3a z *= (y+6.0);\x09/* FALLTHRU */\x0a"
"\x09    case 6\x3a z *= (y+5.0);\x09/* FALLTHRU */\x0a"
"\x09    case 5\x3a z *= (y+4.0);\x09/* FALLTHRU */\x0a"
"\x09    case 4\x3a z *= (y+3.0);\x09/* FALLTHRU */\x0a"
"\x09    case 3\x3a z *= (y+2.0);\x09/* FALLTHRU */\x0a"
"\x09\x09    r += log(z); break;\x0a"
"\x09    }\x0a"
"    /* 8.0 <= x < 2**58 */\x0a"
"\x09} else if (ix < 0x43900000) {\x0a"
"\x09    t = log(x);\x0a"
"\x09    z = one/x;\x0a"
"\x09    y = z*z;\x0a"
"\x09    w = w0+z*(w1+y*(w2+y*(w3+y*(w4+y*(w5+y*w6)))));\x0a"
"\x09    r = (x-half)*(t-one)+w;\x0a"
"\x09} else \x0a"
"    /* 2**58 <= x <= inf */\x0a"
"\x09    r =  x*(log(x)-one);\x0a"
"\x09if(hx<0) r = nadj - r;\x0a"
"\x09return r;\x0a"
"}\x0a"
"", 10804 ); }