#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_log10_c( 
"/* \x40(#)e_log10.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* log10(x)\x0a"
" * Return the base 10 logarithm of x\x0a"
" * \x0a"
" * Method \x3a\x0a"
" *\x09Let log10_2hi = leading 40 bits of log10(2) and\x0a"
" *\x09    log10_2lo = log10(2) - log10_2hi,\x0a"
" *\x09    ivln10   = 1/log(10) rounded.\x0a"
" *\x09Then\x0a"
" *\x09\x09n = ilogb(x), \x0a"
" *\x09\x09if(n<0)  n = n+1;\x0a"
" *\x09\x09x = scalbn(x,-n);\x0a"
" *\x09\x09log10(x) \x3a= n*log10_2hi + (n*log10_2lo + ivln10*log(x))\x0a"
" *\x0a"
" * Note 1\x3a\x0a"
" *\x09To guarantee log10(10**n)=n, where 10**n is normal, the rounding \x0a"
" *\x09mode must set to Round-to-Nearest.\x0a"
" * Note 2\x3a\x0a"
" *\x09\x5b""1/log(10)\x5d rounded to 53 bits has error  .198   ulps;\x0a"
" *\x09log10 is monotonic at all binary break points.\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09log10(x) is NaN with signal if x < 0; \x0a"
" *\x09log10(+INF) is +INF with no signal; log10(0) is -INF with signal;\x0a"
" *\x09log10(NaN) is that NaN with no signal;\x0a"
" *\x09log10(10**N) = N  for N=0,1,...,22.\x0a"
" *\x0a"
" * Constants\x3a\x0a"
" * The hexadecimal values are the intended ones for the following constants.\x0a"
" * The decimal values may be used, provided that the compiler will convert\x0a"
" * from decimal to binary accurately enough to produce the hexadecimal values\x0a"
" * shown.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double\x0a"
"two54      =  1.80143985094819840000e+16, /* 0x43500000, 0x00000000 */\x0a"
"ivln10     =  4.34294481903251816668e-01, /* 0x3FDBCB7B, 0x1526E50E */\x0a"
"log10_2hi  =  3.01029995663611771306e-01, /* 0x3FD34413, 0x509F6000 */\x0a"
"log10_2lo  =  3.69423907715893078616e-13; /* 0x3D59FEF3, 0x11F12B36 */\x0a"
"\x0a"
"static const double zero   =  0.0;\x0a"
"\x0a"
"__link_always double\x0a"
"log10(double x)\x0a"
"{\x0a"
"\x09""double y,z;\x0a"
"\x09int32_t i,k,hx;\x0a"
"\x09u_int32_t lx;\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"\x0a"
"        k=0;\x0a"
"        if (hx < 0x00100000) {                  /* x < 2**-1022  */\x0a"
"            if (((hx\x26""0x7fffffff)\x7clx)==0)\x0a"
"                return -two54/zero;             /* log(+-0)=-inf */\x0a"
"            if (hx<0) return (x-x)/zero;        /* log(-#) = NaN */\x0a"
"            k -= 54; x *= two54; /* subnormal number, scale up x */\x0a"
"\x09    GET_HIGH_WORD(hx,x);\x0a"
"        }\x0a"
"\x09if (hx >= 0x7ff00000) return x+x;\x0a"
"\x09k += (hx>>20)-1023;\x0a"
"\x09i  = ((u_int32_t)k\x26""0x80000000)>>31;\x0a"
"        hx = (hx\x26""0x000fffff)\x7c((0x3ff-i)<<20);\x0a"
"        y  = (double)(k+i);\x0a"
"\x09SET_HIGH_WORD(x,hx);\x0a"
"\x09z  = y*log10_2lo + ivln10*log(x);\x0a"
"\x09return  z+y*log10_2hi;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(log10l, log10);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 2693 ); }