#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_pow_c( 
"/* \x40(#)e_pow.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice\x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* pow(x,y) return x**y\x0a"
" *\x0a"
" *\x09\x09      n\x0a"
" * Method\x3a  Let x =  2   * (1+f)\x0a"
" *\x09""1. Compute and return log2(x) in two pieces\x3a\x0a"
" *\x09\x09log2(x) = w1 + w2,\x0a"
" *\x09   where w1 has 53-24 = 29 bit trailing zeros.\x0a"
" *\x09""2. Perform y*log2(x) = n+y' by simulating multi-precision\x0a"
" *\x09   arithmetic, where \x7cy'\x7c<=0.5.\x0a"
" *\x09""3. Return x**y = 2**n*exp(y'*log2)\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09""1.  (anything) ** 0  is 1\x0a"
" *\x09""2.  (anything) ** 1  is itself\x0a"
" *\x09""3.  (anything except 1) ** NAN is NAN\x0a"
" *\x09""4.  NAN ** (anything except 0) is NAN\x0a"
" *\x09""5.  +-(\x7cx\x7c > 1) **  +INF is +INF\x0a"
" *\x09""6.  +-(\x7cx\x7c > 1) **  -INF is +0\x0a"
" *\x09""7.  +-(\x7cx\x7c < 1) **  +INF is +0\x0a"
" *\x09""8.  +-(\x7cx\x7c < 1) **  -INF is +INF\x0a"
" *\x09""9.  +-1         ** +-INF is 1\x0a"
" *\x09""10. +0 ** (+anything except 0, NAN)               is +0\x0a"
" *\x09""11. -0 ** (+anything except 0, NAN, odd integer)  is +0\x0a"
" *\x09""12. +0 ** (-anything except 0, NAN)               is +INF\x0a"
" *\x09""13. -0 ** (-anything except 0, NAN, odd integer)  is +INF\x0a"
" *\x09""14. -0 ** (odd integer) = -( +0 ** (odd integer) )\x0a"
" *\x09""15. +INF ** (+anything except 0,NAN) is +INF\x0a"
" *\x09""16. +INF ** (-anything except 0,NAN) is +0\x0a"
" *\x09""17. -INF ** (anything)  = -0 ** (-anything)\x0a"
" *\x09""18. (-anything) ** (integer) is (-1)**(integer)*(+anything**integer)\x0a"
" *\x09""19. (-anything except 0 and inf) ** (non-integer) is NAN\x0a"
" *\x0a"
" * Accuracy\x3a\x0a"
" *\x09pow(x,y) returns x**y nearly rounded. In particular\x0a"
" *\x09\x09\x09pow(integer,integer)\x0a"
" *\x09""always returns the correct integer provided it is\x0a"
" *\x09representable.\x0a"
" *\x0a"
" * Constants \x3a\x0a"
" * The hexadecimal values are the intended ones for the following\x0a"
" * constants. The decimal values may be used, provided that the\x0a"
" * compiler will convert from decimal to binary accurately enough\x0a"
" * to produce the hexadecimal values shown.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double\x0a"
"bp\x5b\x5d = {1.0, 1.5,},\x0a"
"dp_h\x5b\x5d = { 0.0, 5.84962487220764160156e-01,}, /* 0x3FE2B803, 0x40000000 */\x0a"
"dp_l\x5b\x5d = { 0.0, 1.35003920212974897128e-08,}, /* 0x3E4CFDEB, 0x43CFD006 */\x0a"
"zero    =  0.0,\x0a"
"one\x09=  1.0,\x0a"
"two\x09=  2.0,\x0a"
"two53\x09=  9007199254740992.0,\x09/* 0x43400000, 0x00000000 */\x0a"
"huge\x09=  1.0e300,\x0a"
"tiny    =  1.0e-300,\x0a"
"\x09/* poly coefs for (3/2)*(log(x)-2s-2/3*s**3 */\x0a"
"L1  =  5.99999999999994648725e-01, /* 0x3FE33333, 0x33333303 */\x0a"
"L2  =  4.28571428578550184252e-01, /* 0x3FDB6DB6, 0xDB6FABFF */\x0a"
"L3  =  3.33333329818377432918e-01, /* 0x3FD55555, 0x518F264D */\x0a"
"L4  =  2.72728123808534006489e-01, /* 0x3FD17460, 0xA91D4101 */\x0a"
"L5  =  2.30660745775561754067e-01, /* 0x3FCD864A, 0x93C9DB65 */\x0a"
"L6  =  2.06975017800338417784e-01, /* 0x3FCA7E28, 0x4A454EEF */\x0a"
"P1   =  1.66666666666666019037e-01, /* 0x3FC55555, 0x5555553E */\x0a"
"P2   = -2.77777777770155933842e-03, /* 0xBF66C16C, 0x16BEBD93 */\x0a"
"P3   =  6.61375632143793436117e-05, /* 0x3F11566A, 0xAF25DE2C */\x0a"
"P4   = -1.65339022054652515390e-06, /* 0xBEBBBD41, 0xC5D26BF1 */\x0a"
"P5   =  4.13813679705723846039e-08, /* 0x3E663769, 0x72BEA4D0 */\x0a"
"lg2  =  6.93147180559945286227e-01, /* 0x3FE62E42, 0xFEFA39EF */\x0a"
"lg2_h  =  6.93147182464599609375e-01, /* 0x3FE62E43, 0x00000000 */\x0a"
"lg2_l  = -1.90465429995776804525e-09, /* 0xBE205C61, 0x0CA86C39 */\x0a"
"ovt =  8.0085662595372944372e-0017, /* -(1024-log2(ovfl+.5ulp)) */\x0a"
"cp    =  9.61796693925975554329e-01, /* 0x3FEEC709, 0xDC3A03FD =2/(3ln2) */\x0a"
"cp_h  =  9.61796700954437255859e-01, /* 0x3FEEC709, 0xE0000000 =(float)cp */\x0a"
"cp_l  = -7.02846165095275826516e-09, /* 0xBE3E2FE0, 0x145B01F5 =tail of cp_h*/\x0a"
"ivln2    =  1.44269504088896338700e+00, /* 0x3FF71547, 0x652B82FE =1/ln2 */\x0a"
"ivln2_h  =  1.44269502162933349609e+00, /* 0x3FF71547, 0x60000000 =24b 1/ln2*/\x0a"
"ivln2_l  =  1.92596299112661746887e-08; /* 0x3E54AE0B, 0xF85DDF44 =1/ln2 tail*/\x0a"
"\x0a"
"__link_always double\x0a"
"pow(double x, double y)\x0a"
"{\x0a"
"\x09""double z,ax,z_h,z_l,p_h,p_l;\x0a"
"\x09""double yy1,t1,t2,r,s,t,u,v,w;\x0a"
"\x09int32_t i,j,k,yisint,n;\x0a"
"\x09int32_t hx,hy,ix,iy;\x0a"
"\x09u_int32_t lx,ly;\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"\x09""EXTRACT_WORDS(hy,ly,y);\x0a"
"\x09ix = hx\x26""0x7fffffff;  iy = hy\x26""0x7fffffff;\x0a"
"\x0a"
"    /* y==zero\x3a x**0 = 1 */\x0a"
"\x09if((iy\x7cly)==0) return one;\x0a"
"\x0a"
"    /* x==1\x3a 1**y = 1, even if y is NaN */\x0a"
"\x09if (hx==0x3ff00000 \x26\x26 lx == 0) return one;\x0a"
"\x0a"
"    /* +-NaN return x+y */\x0a"
"\x09if(ix > 0x7ff00000 \x7c\x7c ((ix==0x7ff00000)\x26\x26(lx\x21=0)) \x7c\x7c\x0a"
"\x09   iy > 0x7ff00000 \x7c\x7c ((iy==0x7ff00000)\x26\x26(ly\x21=0)))\x0a"
"\x09\x09return x+y;\x0a"
"\x0a"
"    /* determine if y is an odd int when x < 0\x0a"
"     * yisint = 0\x09... y is not an integer\x0a"
"     * yisint = 1\x09... y is an odd int\x0a"
"     * yisint = 2\x09... y is an even int\x0a"
"     */\x0a"
"\x09yisint  = 0;\x0a"
"\x09if(hx<0) {\x0a"
"\x09    if(iy>=0x43400000) yisint = 2; /* even integer y */\x0a"
"\x09    else if(iy>=0x3ff00000) {\x0a"
"\x09\x09k = (iy>>20)-0x3ff;\x09   /* exponent */\x0a"
"\x09\x09if(k>20) {\x0a"
"\x09\x09    j = ly>>(52-k);\x0a"
"\x09\x09    if((j<<(52-k))==ly) yisint = 2-(j\x26""1);\x0a"
"\x09\x09} else if(ly==0) {\x0a"
"\x09\x09    j = iy>>(20-k);\x0a"
"\x09\x09    if((j<<(20-k))==iy) yisint = 2-(j\x26""1);\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* special value of y */\x0a"
"\x09if(ly==0) {\x0a"
"\x09    if (iy==0x7ff00000) {\x09/* y is +-inf */\x0a"
"\x09        if(((ix-0x3ff00000)\x7clx)==0)\x0a"
"\x09\x09    return  one;\x09/* (-1)**+-inf is 1 */\x0a"
"\x09        else if (ix >= 0x3ff00000)/* (\x7cx\x7c>1)**+-inf = inf,0 */\x0a"
"\x09\x09    return (hy>=0)\x3f y\x3a zero;\x0a"
"\x09        else\x09\x09\x09/* (\x7cx\x7c<1)**-,+inf = inf,0 */\x0a"
"\x09\x09    return (hy<0)\x3f-y\x3a zero;\x0a"
"\x09    }\x0a"
"\x09    if(iy==0x3ff00000) {\x09/* y is  +-1 */\x0a"
"\x09\x09if(hy<0) return one/x; else return x;\x0a"
"\x09    }\x0a"
"\x09    if(hy==0x40000000) return x*x; /* y is  2 */\x0a"
"\x09    if(hy==0x3fe00000) {\x09/* y is  0.5 */\x0a"
"\x09\x09if(hx>=0)\x09/* x >= +0 */\x0a"
"\x09\x09return sqrt(x);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"\x09""ax   = fabs(x);\x0a"
"    /* special value of x */\x0a"
"\x09if(lx==0) {\x0a"
"\x09    if(ix==0x7ff00000\x7c\x7cix==0\x7c\x7cix==0x3ff00000){\x0a"
"\x09\x09z = ax;\x09\x09\x09/*x is +-0,+-inf,+-1*/\x0a"
"\x09\x09if(hy<0) z = one/z;\x09/* z = (1/\x7cx\x7c) */\x0a"
"\x09\x09if(hx<0) {\x0a"
"\x09\x09    if(((ix-0x3ff00000)\x7cyisint)==0) {\x0a"
"\x09\x09\x09z = (z-z)/(z-z); /* (-1)**non-int is NaN */\x0a"
"\x09\x09    } else if(yisint==1)\x0a"
"\x09\x09\x09z = -z;\x09\x09/* (x<0)**odd = -(\x7cx\x7c**odd) */\x0a"
"\x09\x09}\x0a"
"\x09\x09return z;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"\x09n = (hx>>31)+1;\x0a"
"\x0a"
"    /* (x<0)**(non-int) is NaN */\x0a"
"\x09if((n\x7cyisint)==0) return (x-x)/(x-x);\x0a"
"\x0a"
"\x09s = one; /* s (sign of result -ve**odd) = -1 else = 1 */\x0a"
"\x09if((n\x7c(yisint-1))==0) s = -one;/* (-ve)**(odd int) */\x0a"
"\x0a"
"    /* \x7cy\x7c is huge */\x0a"
"\x09if(iy>0x41e00000) { /* if \x7cy\x7c > 2**31 */\x0a"
"\x09    if(iy>0x43f00000){\x09/* if \x7cy\x7c > 2**64, must o/uflow */\x0a"
"\x09\x09if(ix<=0x3fefffff) return (hy<0)\x3f huge*huge\x3atiny*tiny;\x0a"
"\x09\x09if(ix>=0x3ff00000) return (hy>0)\x3f huge*huge\x3atiny*tiny;\x0a"
"\x09    }\x0a"
"\x09/* over/underflow if x is not close to one */\x0a"
"\x09    if(ix<0x3fefffff) return (hy<0)\x3f s*huge*huge\x3as*tiny*tiny;\x0a"
"\x09    if(ix>0x3ff00000) return (hy>0)\x3f s*huge*huge\x3as*tiny*tiny;\x0a"
"\x09/* now \x7c""1-x\x7c is tiny <= 2**-20, suffice to compute\x0a"
"\x09   log(x) by x-x^2/2+x^3/3-x^4/4 */\x0a"
"\x09    t = ax-one;\x09\x09/* t has 20 trailing zeros */\x0a"
"\x09    w = (t*t)*(0.5-t*(0.3333333333333333333333-t*0.25));\x0a"
"\x09    u = ivln2_h*t;\x09/* ivln2_h has 21 sig. bits */\x0a"
"\x09    v = t*ivln2_l-w*ivln2;\x0a"
"\x09    t1 = u+v;\x0a"
"\x09    SET_LOW_WORD(t1,0);\x0a"
"\x09    t2 = v-(t1-u);\x0a"
"\x09} else {\x0a"
"\x09    double ss,s2,s_h,s_l,t_h,t_l;\x0a"
"\x09    n = 0;\x0a"
"\x09/* take care subnormal number */\x0a"
"\x09    if(ix<0x00100000)\x0a"
"\x09\x09{ax *= two53; n -= 53; GET_HIGH_WORD(ix,ax); }\x0a"
"\x09    n  += ((ix)>>20)-0x3ff;\x0a"
"\x09    j  = ix\x26""0x000fffff;\x0a"
"\x09/* determine interval */\x0a"
"\x09    ix = j\x7c""0x3ff00000;\x09\x09/* normalize ix */\x0a"
"\x09    if(j<=0x3988E) k=0;\x09\x09/* \x7cx\x7c<sqrt(3/2) */\x0a"
"\x09    else if(j<0xBB67A) k=1;\x09/* \x7cx\x7c<sqrt(3)   */\x0a"
"\x09    else {k=0;n+=1;ix -= 0x00100000;}\x0a"
"\x09    SET_HIGH_WORD(ax,ix);\x0a"
"\x0a"
"\x09/* compute ss = s_h+s_l = (x-1)/(x+1) or (x-1.5)/(x+1.5) */\x0a"
"\x09    u = ax-bp\x5bk\x5d;\x09\x09/* bp\x5b""0\x5d=1.0, bp\x5b""1\x5d=1.5 */\x0a"
"\x09    v = one/(ax+bp\x5bk\x5d);\x0a"
"\x09    ss = u*v;\x0a"
"\x09    s_h = ss;\x0a"
"\x09    SET_LOW_WORD(s_h,0);\x0a"
"\x09/* t_h=ax+bp\x5bk\x5d High */\x0a"
"\x09    t_h = zero;\x0a"
"\x09    SET_HIGH_WORD(t_h,((ix>>1)\x7c""0x20000000)+0x00080000+(k<<18));\x0a"
"\x09    t_l = ax - (t_h-bp\x5bk\x5d);\x0a"
"\x09    s_l = v*((u-s_h*t_h)-s_h*t_l);\x0a"
"\x09/* compute log(ax) */\x0a"
"\x09    s2 = ss*ss;\x0a"
"\x09    r = s2*s2*(L1+s2*(L2+s2*(L3+s2*(L4+s2*(L5+s2*L6)))));\x0a"
"\x09    r += s_l*(s_h+ss);\x0a"
"\x09    s2  = s_h*s_h;\x0a"
"\x09    t_h = 3.0+s2+r;\x0a"
"\x09    SET_LOW_WORD(t_h,0);\x0a"
"\x09    t_l = r-((t_h-3.0)-s2);\x0a"
"\x09/* u+v = ss*(1+...) */\x0a"
"\x09    u = s_h*t_h;\x0a"
"\x09    v = s_l*t_h+t_l*ss;\x0a"
"\x09/* 2/(3log2)*(ss+...) */\x0a"
"\x09    p_h = u+v;\x0a"
"\x09    SET_LOW_WORD(p_h,0);\x0a"
"\x09    p_l = v-(p_h-u);\x0a"
"\x09    z_h = cp_h*p_h;\x09\x09/* cp_h+cp_l = 2/(3*log2) */\x0a"
"\x09    z_l = cp_l*p_h+p_l*cp+dp_l\x5bk\x5d;\x0a"
"\x09/* log2(ax) = (ss+..)*2/(3*log2) = n + dp_h + z_h + z_l */\x0a"
"\x09    t = (double)n;\x0a"
"\x09    t1 = (((z_h+z_l)+dp_h\x5bk\x5d)+t);\x0a"
"\x09    SET_LOW_WORD(t1,0);\x0a"
"\x09    t2 = z_l-(((t1-t)-dp_h\x5bk\x5d)-z_h);\x0a"
"\x09}\x0a"
"\x0a"
"    /* split up y into yy1+y2 and compute (yy1+y2)*(t1+t2) */\x0a"
"\x09yy1  = y;\x0a"
"\x09SET_LOW_WORD(yy1,0);\x0a"
"\x09p_l = (y-yy1)*t1+y*t2;\x0a"
"\x09p_h = yy1*t1;\x0a"
"\x09z = p_l+p_h;\x0a"
"\x09""EXTRACT_WORDS(j,i,z);\x0a"
"\x09if (j>=0x40900000) {\x09\x09\x09\x09/* z >= 1024 */\x0a"
"\x09    if(((j-0x40900000)\x7ci)\x21=0)\x09\x09\x09/* if z > 1024 */\x0a"
"\x09\x09return s*huge*huge;\x09\x09\x09/* overflow */\x0a"
"\x09    else {\x0a"
"\x09\x09if(p_l+ovt>z-p_h) return s*huge*huge;\x09/* overflow */\x0a"
"\x09    }\x0a"
"\x09} else if((j\x26""0x7fffffff)>=0x4090cc00 ) {\x09/* z <= -1075 */\x0a"
"\x09    if(((j-0xc090cc00)\x7ci)\x21=0) \x09\x09/* z < -1075 */\x0a"
"\x09\x09return s*tiny*tiny;\x09\x09/* underflow */\x0a"
"\x09    else {\x0a"
"\x09\x09if(p_l<=z-p_h) return s*tiny*tiny;\x09/* underflow */\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    /*\x0a"
"     * compute 2**(p_h+p_l)\x0a"
"     */\x0a"
"\x09i = j\x26""0x7fffffff;\x0a"
"\x09k = (i>>20)-0x3ff;\x0a"
"\x09n = 0;\x0a"
"\x09if(i>0x3fe00000) {\x09\x09/* if \x7cz\x7c > 0.5, set n = \x5bz+0.5\x5d */\x0a"
"\x09    n = j+(0x00100000>>(k+1));\x0a"
"\x09    k = ((n\x26""0x7fffffff)>>20)-0x3ff;\x09/* new k for n */\x0a"
"\x09    t = zero;\x0a"
"\x09    SET_HIGH_WORD(t,n\x26\x7e(0x000fffff>>k));\x0a"
"\x09    n = ((n\x26""0x000fffff)\x7c""0x00100000)>>(20-k);\x0a"
"\x09    if(j<0) n = -n;\x0a"
"\x09    p_h -= t;\x0a"
"\x09}\x0a"
"\x09t = p_l+p_h;\x0a"
"\x09SET_LOW_WORD(t,0);\x0a"
"\x09u = t*lg2_h;\x0a"
"\x09v = (p_l-(t-p_h))*lg2+t*lg2_l;\x0a"
"\x09z = u+v;\x0a"
"\x09w = v-(z-u);\x0a"
"\x09t  = z*z;\x0a"
"\x09t1  = z - t*(P1+t*(P2+t*(P3+t*(P4+t*P5))));\x0a"
"\x09r  = (z*t1)/(t1-two)-(w+z*w);\x0a"
"\x09z  = one-(r-z);\x0a"
"\x09GET_HIGH_WORD(j,z);\x0a"
"\x09j += (n<<20);\x0a"
"\x09if((j>>20)<=0) z = scalbn(z,n);\x09/* subnormal output */\x0a"
"\x09""else SET_HIGH_WORD(z,j);\x0a"
"\x09return s*z;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(powl, pow);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 9817 ); }