#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_powf_c( 
"/* e_powf.c -- float version of e_pow.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const volatile float huge = 1.0e+30, tiny = 1.0e-30;\x0a"
"\x0a"
"static const float\x0a"
"bp\x5b\x5d = {1.0, 1.5,},\x0a"
"dp_h\x5b\x5d = { 0.0, 5.84960938e-01,}, /* 0x3f15c000 */\x0a"
"dp_l\x5b\x5d = { 0.0, 1.56322085e-06,}, /* 0x35d1cfdc */\x0a"
"zero    =  0.0,\x0a"
"one\x09=  1.0,\x0a"
"two\x09=  2.0,\x0a"
"two24\x09=  16777216.0,\x09/* 0x4b800000 */\x0a"
"\x09/* poly coefs for (3/2)*(log(x)-2s-2/3*s**3 */\x0a"
"L1  =  6.0000002384e-01, /* 0x3f19999a */\x0a"
"L2  =  4.2857143283e-01, /* 0x3edb6db7 */\x0a"
"L3  =  3.3333334327e-01, /* 0x3eaaaaab */\x0a"
"L4  =  2.7272811532e-01, /* 0x3e8ba305 */\x0a"
"L5  =  2.3066075146e-01, /* 0x3e6c3255 */\x0a"
"L6  =  2.0697501302e-01, /* 0x3e53f142 */\x0a"
"P1   =  1.6666667163e-01, /* 0x3e2aaaab */\x0a"
"P2   = -2.7777778450e-03, /* 0xbb360b61 */\x0a"
"P3   =  6.6137559770e-05, /* 0x388ab355 */\x0a"
"P4   = -1.6533901999e-06, /* 0xb5ddea0e */\x0a"
"P5   =  4.1381369442e-08, /* 0x3331bb4c */\x0a"
"lg2  =  6.9314718246e-01, /* 0x3f317218 */\x0a"
"lg2_h  =  6.93145752e-01, /* 0x3f317200 */\x0a"
"lg2_l  =  1.42860654e-06, /* 0x35bfbe8c */\x0a"
"ovt =  4.2995665694e-08, /* -(128-log2(ovfl+.5ulp)) */\x0a"
"cp    =  9.6179670095e-01, /* 0x3f76384f =2/(3ln2) */\x0a"
"cp_h  =  9.6179199219e-01, /* 0x3f763800 =head of cp */\x0a"
"cp_l  =  4.7017383622e-06, /* 0x369dc3a0 =tail of cp_h */\x0a"
"ivln2    =  1.4426950216e+00, /* 0x3fb8aa3b =1/ln2 */\x0a"
"ivln2_h  =  1.4426879883e+00, /* 0x3fb8aa00 =16b 1/ln2*/\x0a"
"ivln2_l  =  7.0526075433e-06; /* 0x36eca570 =1/ln2 tail*/\x0a"
"\x0a"
"float\x0a"
"powf(float x, float y)\x0a"
"{\x0a"
"\x09""float z,ax,z_h,z_l,p_h,p_l;\x0a"
"\x09""float yy1,t1,t2,r,s,t,u,v,w;\x0a"
"\x09int32_t i,j,k,yisint,n;\x0a"
"\x09int32_t hx,hy,ix,iy,is;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09GET_FLOAT_WORD(hy,y);\x0a"
"\x09ix = hx\x26""0x7fffffff;  iy = hy\x26""0x7fffffff;\x0a"
"\x0a"
"    /* y==zero\x3a x**0 = 1 */\x0a"
"\x09if(iy==0) return one; \x09\x0a"
"\x0a"
"    /* x==1\x3a 1**y = 1, even if y is NaN */\x0a"
"\x09if (hx==0x3f800000) return one;\x0a"
"\x0a"
"    /* +-NaN return x+y */\x0a"
"\x09if(ix > 0x7f800000 \x7c\x7c\x0a"
"\x09   iy > 0x7f800000)\x0a"
"\x09\x09return x+y;\x09\x0a"
"\x0a"
"    /* determine if y is an odd int when x < 0\x0a"
"     * yisint = 0\x09... y is not an integer\x0a"
"     * yisint = 1\x09... y is an odd int\x0a"
"     * yisint = 2\x09... y is an even int\x0a"
"     */\x0a"
"\x09yisint  = 0;\x0a"
"\x09if(hx<0) {\x09\x0a"
"\x09    if(iy>=0x4b800000) yisint = 2; /* even integer y */\x0a"
"\x09    else if(iy>=0x3f800000) {\x0a"
"\x09\x09k = (iy>>23)-0x7f;\x09   /* exponent */\x0a"
"\x09\x09j = iy>>(23-k);\x0a"
"\x09\x09if((j<<(23-k))==iy) yisint = 2-(j\x26""1);\x0a"
"\x09    }\x09\x09\x0a"
"\x09} \x0a"
"\x0a"
"    /* special value of y */\x0a"
"\x09if (iy==0x7f800000) {\x09/* y is +-inf */\x0a"
"\x09    if (ix==0x3f800000)\x0a"
"\x09        return  one;\x09/* (-1)**+-inf is NaN */\x0a"
"\x09    else if (ix > 0x3f800000)/* (\x7cx\x7c>1)**+-inf = inf,0 */\x0a"
"\x09        return (hy>=0)\x3f y\x3a zero;\x0a"
"\x09    else\x09\x09\x09/* (\x7cx\x7c<1)**-,+inf = inf,0 */\x0a"
"\x09        return (hy<0)\x3f-y\x3a zero;\x0a"
"\x09} \x0a"
"\x09if(iy==0x3f800000) {\x09/* y is  +-1 */\x0a"
"\x09    if(hy<0) return one/x; else return x;\x0a"
"\x09}\x0a"
"\x09if(hy==0x40000000) return x*x; /* y is  2 */\x0a"
"\x09if(hy==0x3f000000) {\x09/* y is  0.5 */\x0a"
"\x09    if(hx>=0)\x09/* x >= +0 */\x0a"
"\x09    return sqrtf(x);\x09\x0a"
"\x09}\x0a"
"\x0a"
"\x09""ax   = fabsf(x);\x0a"
"    /* special value of x */\x0a"
"\x09if(ix==0x7f800000\x7c\x7cix==0\x7c\x7cix==0x3f800000){\x0a"
"\x09    z = ax;\x09\x09\x09/*x is +-0,+-inf,+-1*/\x0a"
"\x09    if(hy<0) z = one/z;\x09/* z = (1/\x7cx\x7c) */\x0a"
"\x09    if(hx<0) {\x0a"
"\x09\x09if(((ix-0x3f800000)\x7cyisint)==0) {\x0a"
"\x09\x09    z = (z-z)/(z-z); /* (-1)**non-int is NaN */\x0a"
"\x09\x09} else if(yisint==1) \x0a"
"\x09\x09    z = -z;\x09\x09/* (x<0)**odd = -(\x7cx\x7c**odd) */\x0a"
"\x09    }\x0a"
"\x09    return z;\x0a"
"\x09}\x0a"
"    \x0a"
"    /* (x<0)**(non-int) is NaN */\x0a"
"\x09if(((((u_int32_t)hx>>31)-1)\x7cyisint)==0) return (x-x)/(x-x);\x0a"
"\x0a"
"    /* \x7cy\x7c is huge */\x0a"
"\x09if(iy>0x4d000000) { /* if \x7cy\x7c > 2**27 */\x0a"
"\x09/* over/underflow if x is not close to one */\x0a"
"\x09    if(ix<0x3f7ffff8) return (hy<0)\x3f huge*huge\x3atiny*tiny;\x0a"
"\x09    if(ix>0x3f800007) return (hy>0)\x3f huge*huge\x3atiny*tiny;\x0a"
"\x09/* now \x7c""1-x\x7c is tiny <= 2**-20, suffice to compute \x0a"
"\x09   log(x) by x-x^2/2+x^3/3-x^4/4 */\x0a"
"\x09    t = ax-one;\x09\x09/* t has 20 trailing zeros */\x0a"
"\x09    w = (t*t)*((float)0.5-t*((float)0.333333333333-t*(float)0.25));\x0a"
"\x09    u = ivln2_h*t;\x09/* ivln2_h has 16 sig. bits */\x0a"
"\x09    v = t*ivln2_l-w*ivln2;\x0a"
"\x09    t1 = u+v;\x0a"
"\x09    GET_FLOAT_WORD(is,t1);\x0a"
"\x09    SET_FLOAT_WORD(t1,is\x26""0xfffff000);\x0a"
"\x09    t2 = v-(t1-u);\x0a"
"\x09} else {\x0a"
"\x09    float s2,s_h,s_l,t_h,t_l;\x0a"
"\x09    n = 0;\x0a"
"\x09/* take care subnormal number */\x0a"
"\x09    if(ix<0x00800000)\x0a"
"\x09\x09{ax *= two24; n -= 24; GET_FLOAT_WORD(ix,ax); }\x0a"
"\x09    n  += ((ix)>>23)-0x7f;\x0a"
"\x09    j  = ix\x26""0x007fffff;\x0a"
"\x09/* determine interval */\x0a"
"\x09    ix = j\x7c""0x3f800000;\x09\x09/* normalize ix */\x0a"
"\x09    if(j<=0x1cc471) k=0;\x09/* \x7cx\x7c<sqrt(3/2) */\x0a"
"\x09    else if(j<0x5db3d7) k=1;\x09/* \x7cx\x7c<sqrt(3)   */\x0a"
"\x09    else {k=0;n+=1;ix -= 0x00800000;}\x0a"
"\x09    SET_FLOAT_WORD(ax,ix);\x0a"
"\x0a"
"\x09/* compute s = s_h+s_l = (x-1)/(x+1) or (x-1.5)/(x+1.5) */\x0a"
"\x09    u = ax-bp\x5bk\x5d;\x09\x09/* bp\x5b""0\x5d=1.0, bp\x5b""1\x5d=1.5 */\x0a"
"\x09    v = one/(ax+bp\x5bk\x5d);\x0a"
"\x09    s = u*v;\x0a"
"\x09    s_h = s;\x0a"
"\x09    GET_FLOAT_WORD(is,s_h);\x0a"
"\x09    SET_FLOAT_WORD(s_h,is\x26""0xfffff000);\x0a"
"\x09/* t_h=ax+bp\x5bk\x5d High */\x0a"
"\x09    SET_FLOAT_WORD(t_h,((ix>>1)\x7c""0x20000000)+0x0040000+(k<<21));\x0a"
"\x09    t_l = ax - (t_h-bp\x5bk\x5d);\x0a"
"\x09    s_l = v*((u-s_h*t_h)-s_h*t_l);\x0a"
"\x09/* compute log(ax) */\x0a"
"\x09    s2 = s*s;\x0a"
"\x09    r = s2*s2*(L1+s2*(L2+s2*(L3+s2*(L4+s2*(L5+s2*L6)))));\x0a"
"\x09    r += s_l*(s_h+s);\x0a"
"\x09    s2  = s_h*s_h;\x0a"
"\x09    t_h = (float)3.0+s2+r;\x0a"
"\x09    GET_FLOAT_WORD(is,t_h);\x0a"
"\x09    SET_FLOAT_WORD(t_h,is\x26""0xfffff000);\x0a"
"\x09    t_l = r-((t_h-(float)3.0)-s2);\x0a"
"\x09/* u+v = s*(1+...) */\x0a"
"\x09    u = s_h*t_h;\x0a"
"\x09    v = s_l*t_h+t_l*s;\x0a"
"\x09/* 2/(3log2)*(s+...) */\x0a"
"\x09    p_h = u+v;\x0a"
"\x09    GET_FLOAT_WORD(is,p_h);\x0a"
"\x09    SET_FLOAT_WORD(p_h,is\x26""0xfffff000);\x0a"
"\x09    p_l = v-(p_h-u);\x0a"
"\x09    z_h = cp_h*p_h;\x09\x09/* cp_h+cp_l = 2/(3*log2) */\x0a"
"\x09    z_l = cp_l*p_h+p_l*cp+dp_l\x5bk\x5d;\x0a"
"\x09/* log2(ax) = (s+..)*2/(3*log2) = n + dp_h + z_h + z_l */\x0a"
"\x09    t = (float)n;\x0a"
"\x09    t1 = (((z_h+z_l)+dp_h\x5bk\x5d)+t);\x0a"
"\x09    GET_FLOAT_WORD(is,t1);\x0a"
"\x09    SET_FLOAT_WORD(t1,is\x26""0xfffff000);\x0a"
"\x09    t2 = z_l-(((t1-t)-dp_h\x5bk\x5d)-z_h);\x0a"
"\x09}\x0a"
"\x0a"
"\x09s = one; /* s (sign of result -ve**odd) = -1 else = 1 */\x0a"
"\x09if(((((u_int32_t)hx>>31)-1)\x7c(yisint-1))==0)\x0a"
"\x09    s = -one;\x09/* (-ve)**(odd int) */\x0a"
"\x0a"
"    /* split up y into yy1+y2 and compute (yy1+y2)*(t1+t2) */\x0a"
"\x09GET_FLOAT_WORD(is,y);\x0a"
"\x09SET_FLOAT_WORD(yy1,is\x26""0xfffff000);\x0a"
"\x09p_l = (y-yy1)*t1+y*t2;\x0a"
"\x09p_h = yy1*t1;\x0a"
"\x09z = p_l+p_h;\x0a"
"\x09GET_FLOAT_WORD(j,z);\x0a"
"\x09if (j>0x43000000)\x09\x09\x09\x09/* if z > 128 */\x0a"
"\x09    return s*huge*huge;\x09\x09\x09\x09/* overflow */\x0a"
"\x09""else if (j==0x43000000) {\x09\x09\x09/* if z == 128 */\x0a"
"\x09    if(p_l+ovt>z-p_h) return s*huge*huge;\x09/* overflow */\x0a"
"\x09}\x0a"
"\x09""else if ((j\x26""0x7fffffff)>0x43160000)\x09\x09/* z <= -150 */\x0a"
"\x09    return s*tiny*tiny;\x09\x09\x09\x09/* underflow */\x0a"
"\x09""else if (j==0xc3160000){\x09\x09\x09/* z == -150 */\x0a"
"\x09    if(p_l<=z-p_h) return s*tiny*tiny;\x09\x09/* underflow */\x0a"
"\x09}\x0a"
"    /*\x0a"
"     * compute 2**(p_h+p_l)\x0a"
"     */\x0a"
"\x09i = j\x26""0x7fffffff;\x0a"
"\x09k = (i>>23)-0x7f;\x0a"
"\x09n = 0;\x0a"
"\x09if(i>0x3f000000) {\x09\x09/* if \x7cz\x7c > 0.5, set n = \x5bz+0.5\x5d */\x0a"
"\x09    n = j+(0x00800000>>(k+1));\x0a"
"\x09    k = ((n\x26""0x7fffffff)>>23)-0x7f;\x09/* new k for n */\x0a"
"\x09    SET_FLOAT_WORD(t,n\x26\x7e(0x007fffff>>k));\x0a"
"\x09    n = ((n\x26""0x007fffff)\x7c""0x00800000)>>(23-k);\x0a"
"\x09    if(j<0) n = -n;\x0a"
"\x09    p_h -= t;\x0a"
"\x09} \x0a"
"\x09t = p_l+p_h;\x0a"
"\x09GET_FLOAT_WORD(is,t);\x0a"
"\x09SET_FLOAT_WORD(t,is\x26""0xfffff000);\x0a"
"\x09u = t*lg2_h;\x0a"
"\x09v = (p_l-(t-p_h))*lg2+t*lg2_l;\x0a"
"\x09z = u+v;\x0a"
"\x09w = v-(z-u);\x0a"
"\x09t  = z*z;\x0a"
"\x09t1  = z - t*(P1+t*(P2+t*(P3+t*(P4+t*P5))));\x0a"
"\x09r  = (z*t1)/(t1-two)-(w+z*w);\x0a"
"\x09z  = one-(r-z);\x0a"
"\x09GET_FLOAT_WORD(j,z);\x0a"
"\x09j += (n<<23);\x0a"
"\x09if((j>>23)<=0) z = scalbnf(z,n);\x09/* subnormal output */\x0a"
"\x09""else SET_FLOAT_WORD(z,j);\x0a"
"\x09return s*z;\x0a"
"}\x0a"
"", 7420 ); }