#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_remainder_c( 
"/* \x40(#)e_remainder.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* remainder(x,p)\x0a"
" * Return \x3a                  \x0a"
" * \x09returns  x REM p  =  x - \x5bx/p\x5d*p as if in infinite \x0a"
" * \x09precise arithmetic, where \x5bx/p\x5d is the (infinite bit) \x0a"
" *\x09integer nearest x/p (in half way case choose the even one).\x0a"
" * Method \x3a \x0a"
" *\x09""Based on fmod() return x-\x5bx/p\x5d""chopped*p exactlp.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double zero = 0.0;\x0a"
"\x0a"
"\x0a"
"__link_always double\x0a"
"remainder(double x, double p)\x0a"
"{\x0a"
"\x09int32_t hx,hp;\x0a"
"\x09u_int32_t sx,lx,lp;\x0a"
"\x09""double p_half;\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"\x09""EXTRACT_WORDS(hp,lp,p);\x0a"
"\x09sx = hx\x26""0x80000000;\x0a"
"\x09hp \x26= 0x7fffffff;\x0a"
"\x09hx \x26= 0x7fffffff;\x0a"
"\x0a"
"    /* purge off exception values */\x0a"
"\x09if((hp\x7clp)==0) return (x*p)/(x*p); \x09/* p = 0 */\x0a"
"\x09if((hx>=0x7ff00000)\x7c\x7c\x09\x09\x09/* x not finite */\x0a"
"\x09  ((hp>=0x7ff00000)\x26\x26\x09\x09\x09/* p is NaN */\x0a"
"\x09  (((hp-0x7ff00000)\x7clp)\x21=0)))\x0a"
"\x09    return (x*p)/(x*p);\x0a"
"\x0a"
"\x0a"
"\x09if (hp<=0x7fdfffff) x = fmod(x,p+p);\x09/* now x < 2p */\x0a"
"\x09if (((hx-hp)\x7c(lx-lp))==0) return zero*x;\x0a"
"\x09x  = fabs(x);\x0a"
"\x09p  = fabs(p);\x0a"
"\x09if (hp<0x00200000) {\x0a"
"\x09    if(x+x>p) {\x0a"
"\x09\x09x-=p;\x0a"
"\x09\x09if(x+x>=p) x -= p;\x0a"
"\x09    }\x0a"
"\x09} else {\x0a"
"\x09    p_half = 0.5*p;\x0a"
"\x09    if(x>p_half) {\x0a"
"\x09\x09x-=p;\x0a"
"\x09\x09if(x>=p_half) x -= p;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09SET_HIGH_WORD(x,hx^sx);\x0a"
"\x09return x;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(remainderl, remainder);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 1731 ); }