#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_remainderf_c( 
"/* e_remainderf.c -- float version of e_remainder.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const float zero = 0.0;\x0a"
"\x0a"
"float\x0a"
"remainderf(float x, float p)\x0a"
"{\x0a"
"\x09int32_t hx,hp;\x0a"
"\x09u_int32_t sx;\x0a"
"\x09""float p_half;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09GET_FLOAT_WORD(hp,p);\x0a"
"\x09sx = hx\x26""0x80000000;\x0a"
"\x09hp \x26= 0x7fffffff;\x0a"
"\x09hx \x26= 0x7fffffff;\x0a"
"\x0a"
"    /* purge off exception values */\x0a"
"\x09if(hp==0) return (x*p)/(x*p);\x09 \x09/* p = 0 */\x0a"
"\x09if((hx>=0x7f800000)\x7c\x7c\x09\x09\x09/* x not finite */\x0a"
"\x09  ((hp>0x7f800000)))\x09\x09\x09/* p is NaN */\x0a"
"\x09    return (x*p)/(x*p);\x0a"
"\x0a"
"\x0a"
"\x09if (hp<=0x7effffff) x = fmodf(x,p+p);\x09/* now x < 2p */\x0a"
"\x09if ((hx-hp)==0) return zero*x;\x0a"
"\x09x  = fabsf(x);\x0a"
"\x09p  = fabsf(p);\x0a"
"\x09if (hp<0x01000000) {\x0a"
"\x09    if(x+x>p) {\x0a"
"\x09\x09x-=p;\x0a"
"\x09\x09if(x+x>=p) x -= p;\x0a"
"\x09    }\x0a"
"\x09} else {\x0a"
"\x09    p_half = (float)0.5*p;\x0a"
"\x09    if(x>p_half) {\x0a"
"\x09\x09x-=p;\x0a"
"\x09\x09if(x>=p_half) x -= p;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09SET_FLOAT_WORD(x,hx^sx);\x0a"
"\x09return x;\x0a"
"}\x0a"
"", 1332 ); }