#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_sinh_c( 
"/* \x40(#)e_sinh.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* sinh(x)\x0a"
" * Method \x3a \x0a"
" * mathematically sinh(x) if defined to be (exp(x)-exp(-x))/2\x0a"
" *\x09""1. Replace x by \x7cx\x7c (sinh(-x) = -sinh(x)). \x0a"
" *\x09""2. \x0a"
" *\x09\x09                                    E + E/(E+1)\x0a"
" *\x09    0        <= x <= 22     \x3a  sinh(x) \x3a= --------------, E=expm1(x)\x0a"
" *\x09\x09\x09       \x09\x09\x09        2\x0a"
" *\x0a"
" *\x09    22       <= x <= lnovft \x3a  sinh(x) \x3a= exp(x)/2 \x0a"
" *\x09    lnovft   <= x <= ln2ovft\x3a  sinh(x) \x3a= exp(x/2)/2 * exp(x/2)\x0a"
" *\x09    ln2ovft  <  x\x09    \x3a  sinh(x) \x3a= x*shuge (overflow)\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09sinh(x) is \x7cx\x7c if x is +INF, -INF, or NaN.\x0a"
" *\x09only sinh(0)=0 is exact for finite x.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double one = 1.0, shuge = 1.0e307;\x0a"
"\x0a"
"__link_always double\x0a"
"sinh(double x)\x0a"
"{\x09\x0a"
"\x09""double t,w,h;\x0a"
"\x09int32_t ix,jx;\x0a"
"\x09u_int32_t lx;\x0a"
"\x0a"
"    /* High word of \x7cx\x7c. */\x0a"
"\x09GET_HIGH_WORD(jx,x);\x0a"
"\x09ix = jx\x26""0x7fffffff;\x0a"
"\x0a"
"    /* x is INF or NaN */\x0a"
"\x09if(ix>=0x7ff00000) return x+x;\x09\x0a"
"\x0a"
"\x09h = 0.5;\x0a"
"\x09if (jx<0) h = -h;\x0a"
"    /* \x7cx\x7c in \x5b""0,22\x5d, return sign(x)*0.5*(E+E/(E+1))) */\x0a"
"\x09if (ix < 0x40360000) {\x09\x09/* \x7cx\x7c<22 */\x0a"
"\x09    if (ix<0x3e300000) \x09\x09/* \x7cx\x7c<2**-28 */\x0a"
"\x09\x09if(shuge+x>one) return x;/* sinh(tiny) = tiny with inexact */\x0a"
"\x09    t = expm1(fabs(x));\x0a"
"\x09    if(ix<0x3ff00000) return h*(2.0*t-t*t/(t+one));\x0a"
"\x09    return h*(t+t/(t+one));\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5b""22, log(maxdouble)\x5d return 0.5*exp(\x7cx\x7c) */\x0a"
"\x09if (ix < 0x40862E42)  return h*exp(fabs(x));\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5blog(maxdouble), overflowthresold\x5d */\x0a"
"\x09GET_LOW_WORD(lx,x);\x0a"
"\x09if (ix<0x408633CE \x7c\x7c ((ix==0x408633ce)\x26\x26(lx<=(u_int32_t)0x8fb9f87d))) {\x0a"
"\x09    w = exp(0.5*fabs(x));\x0a"
"\x09    t = h*w;\x0a"
"\x09    return t*w;\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c > overflowthresold, sinh(x) overflow */\x0a"
"\x09return x*shuge;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(sinhl, sinh);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 2163 ); }