#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_sqrt_c( 
"/* \x40(#)e_sqrt.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* sqrt(x)\x0a"
" * Return correctly rounded sqrt.\x0a"
" *           ------------------------------------------\x0a"
" *\x09     \x7c  Use the hardware sqrt if you have one \x7c\x0a"
" *           ------------------------------------------\x0a"
" * Method\x3a \x0a"
" *   Bit by bit method using integer arithmetic. (Slow, but portable) \x0a"
" *   1. Normalization\x0a"
" *\x09Scale x to y in \x5b""1,4) with even powers of 2\x3a \x0a"
" *\x09""find an integer k such that  1 <= (y=x*2^(2k)) < 4, then\x0a"
" *\x09\x09sqrt(x) = 2^k * sqrt(y)\x0a"
" *   2. Bit by bit computation\x0a"
" *\x09Let q  = sqrt(y) truncated to i bit after binary point (q = 1),\x0a"
" *\x09     i\x09\x09\x09\x09\x09\x09\x09 0\x0a"
" *                                     i+1         2\x0a"
" *\x09    s  = 2*q , and\x09y  =  2   * ( y - q  ).\x09\x09(1)\x0a"
" *\x09     i      i            i                 i\x0a"
" *                                                        \x0a"
" *\x09To compute q    from q , one checks whether \x0a"
" *\x09\x09    i+1       i                       \x0a"
" *\x0a"
" *\x09\x09\x09      -(i+1) 2\x0a"
" *\x09\x09\x09(q + 2      ) <= y.\x09\x09\x09(2)\x0a"
" *     \x09\x09\x09  i\x0a"
" *\x09\x09\x09\x09\x09\x09\x09      -(i+1)\x0a"
" *\x09If (2) is false, then q   = q ; otherwise q   = q  + 2      .\x0a"
" *\x09\x09 \x09       i+1   i             i+1   i\x0a"
" *\x0a"
" *\x09With some algebric manipulation, it is not difficult to see\x0a"
" *\x09that (2) is equivalent to \x0a"
" *                             -(i+1)\x0a"
" *\x09\x09\x09s  +  2       <= y\x09\x09\x09(3)\x0a"
" *\x09\x09\x09 i                i\x0a"
" *\x0a"
" *\x09The advantage of (3) is that s  and y  can be computed by \x0a"
" *\x09\x09\x09\x09      i      i\x0a"
" *\x09the following recurrence formula\x3a\x0a"
" *\x09    if (3) is false\x0a"
" *\x0a"
" *\x09    s     =  s  ,\x09y    = y   ;\x09\x09\x09(4)\x0a"
" *\x09     i+1      i\x09\x09 i+1    i\x0a"
" *\x0a"
" *\x09    otherwise,\x0a"
" *                         -i                     -(i+1)\x0a"
" *\x09    s\x09  =  s  + 2  ,  y    = y  -  s  - 2  \x09\x09(5)\x0a"
" *           i+1      i          i+1    i     i\x0a"
" *\x09\x09\x09\x09\x0a"
" *\x09One may easily use induction to prove (4) and (5). \x0a"
" *\x09Note. Since the left hand side of (3) contain only i+2 bits,\x0a"
" *\x09      it does not necessary to do a full (53-bit) comparison \x0a"
" *\x09      in (3).\x0a"
" *   3. Final rounding\x0a"
" *\x09""After generating the 53 bits result, we compute one more bit.\x0a"
" *\x09Together with the remainder, we can decide whether the\x0a"
" *\x09result is exact, bigger than 1/2ulp, or less than 1/2ulp\x0a"
" *\x09(it will never equal to 1/2ulp).\x0a"
" *\x09The rounding mode can be detected by checking whether\x0a"
" *\x09huge + tiny is equal to huge, and whether huge - tiny is\x0a"
" *\x09""equal to huge for some floating point number \x22huge\x22 and \x22tiny\x22.\x0a"
" *\x09\x09\x0a"
" * Special cases\x3a\x0a"
" *\x09sqrt(+-0) = +-0 \x09... exact\x0a"
" *\x09sqrt(inf) = inf\x0a"
" *\x09sqrt(-ve) = NaN\x09\x09... with invalid signal\x0a"
" *\x09sqrt(NaN) = NaN\x09\x09... with invalid signal for signaling NaN\x0a"
" *\x0a"
" * Other methods \x3a see the appended file at the end of the program below.\x0a"
" *---------------\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static\x09""const double\x09one\x09= 1.0, tiny=1.0e-300;\x0a"
"\x0a"
"double\x0a"
"sqrt(double x)\x0a"
"{\x0a"
"\x09""double z;\x0a"
"\x09int32_t sign = (int)0x80000000; \x0a"
"\x09int32_t ix0,s0,q,m,t,i;\x0a"
"\x09u_int32_t r,t1,s1,ix1,q1;\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(ix0,ix1,x);\x0a"
"\x0a"
"    /* take care of Inf and NaN */\x0a"
"\x09if((ix0\x26""0x7ff00000)==0x7ff00000) {\x09\x09\x09\x0a"
"\x09    return x*x+x;\x09\x09/* sqrt(NaN)=NaN, sqrt(+inf)=+inf\x0a"
"\x09\x09\x09\x09\x09   sqrt(-inf)=sNaN */\x0a"
"\x09} \x0a"
"    /* take care of zero */\x0a"
"\x09if(ix0<=0) {\x0a"
"\x09    if(((ix0\x26(\x7esign))\x7cix1)==0) return x;/* sqrt(+-0) = +-0 */\x0a"
"\x09    else if(ix0<0)\x0a"
"\x09\x09return (x-x)/(x-x);\x09\x09/* sqrt(-ve) = sNaN */\x0a"
"\x09}\x0a"
"    /* normalize x */\x0a"
"\x09m = (ix0>>20);\x0a"
"\x09if(m==0) {\x09\x09\x09\x09/* subnormal x */\x0a"
"\x09    while(ix0==0) {\x0a"
"\x09\x09m -= 21;\x0a"
"\x09\x09ix0 \x7c= (ix1>>11); ix1 <<= 21;\x0a"
"\x09    }\x0a"
"\x09    for(i=0;(ix0\x26""0x00100000)==0;i++) ix0<<=1;\x0a"
"\x09    m -= i-1;\x0a"
"\x09    ix0 \x7c= (ix1>>(32-i));\x0a"
"\x09    ix1 <<= i;\x0a"
"\x09}\x0a"
"\x09m -= 1023;\x09/* unbias exponent */\x0a"
"\x09ix0 = (ix0\x26""0x000fffff)\x7c""0x00100000;\x0a"
"\x09if(m\x26""1){\x09/* odd m, double x to make it even */\x0a"
"\x09    ix0 += ix0 + ((ix1\x26sign)>>31);\x0a"
"\x09    ix1 += ix1;\x0a"
"\x09}\x0a"
"\x09m >>= 1;\x09/* m = \x5bm/2\x5d */\x0a"
"\x0a"
"    /* generate sqrt(x) bit by bit */\x0a"
"\x09ix0 += ix0 + ((ix1\x26sign)>>31);\x0a"
"\x09ix1 += ix1;\x0a"
"\x09q = q1 = s0 = s1 = 0;\x09/* \x5bq,q1\x5d = sqrt(x) */\x0a"
"\x09r = 0x00200000;\x09\x09/* r = moving bit from right to left */\x0a"
"\x0a"
"\x09while(r\x21=0) {\x0a"
"\x09    t = s0+r; \x0a"
"\x09    if(t<=ix0) { \x0a"
"\x09\x09s0   = t+r; \x0a"
"\x09\x09ix0 -= t; \x0a"
"\x09\x09q   += r; \x0a"
"\x09    } \x0a"
"\x09    ix0 += ix0 + ((ix1\x26sign)>>31);\x0a"
"\x09    ix1 += ix1;\x0a"
"\x09    r>>=1;\x0a"
"\x09}\x0a"
"\x0a"
"\x09r = sign;\x0a"
"\x09while(r\x21=0) {\x0a"
"\x09    t1 = s1+r; \x0a"
"\x09    t  = s0;\x0a"
"\x09    if((t<ix0)\x7c\x7c((t==ix0)\x26\x26(t1<=ix1))) { \x0a"
"\x09\x09s1  = t1+r;\x0a"
"\x09\x09if(((t1\x26sign)==sign)\x26\x26(s1\x26sign)==0) s0 += 1;\x0a"
"\x09\x09ix0 -= t;\x0a"
"\x09\x09if (ix1 < t1) ix0 -= 1;\x0a"
"\x09\x09ix1 -= t1;\x0a"
"\x09\x09q1  += r;\x0a"
"\x09    }\x0a"
"\x09    ix0 += ix0 + ((ix1\x26sign)>>31);\x0a"
"\x09    ix1 += ix1;\x0a"
"\x09    r>>=1;\x0a"
"\x09}\x0a"
"\x0a"
"    /* use floating add to find out rounding direction */\x0a"
"\x09if((ix0\x7cix1)\x21=0) {\x0a"
"\x09    z = one-tiny; /* trigger inexact flag */\x0a"
"\x09    if (z>=one) {\x0a"
"\x09        z = one+tiny;\x0a"
"\x09        if (q1==(u_int32_t)0xffffffff) { q1=0; q += 1;}\x0a"
"\x09\x09""else if (z>one) {\x0a"
"\x09\x09    if (q1==(u_int32_t)0xfffffffe) q+=1;\x0a"
"\x09\x09    q1+=2; \x0a"
"\x09\x09} else\x0a"
"\x09            q1 += (q1\x26""1);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09ix0 = (q>>1)+0x3fe00000;\x0a"
"\x09ix1 =  q1>>1;\x0a"
"\x09if ((q\x26""1)==1) ix1 \x7c= sign;\x0a"
"\x09ix0 += (m <<20);\x0a"
"\x09INSERT_WORDS(z,ix0,ix1);\x0a"
"\x09return z;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
"Other methods  (use floating-point arithmetic)\x0a"
"-------------\x0a"
"(This is a copy of a drafted paper by Prof W. Kahan \x0a"
"and K.C. Ng, written in May, 1986)\x0a"
"\x0a"
"\x09Two algorithms are given here to implement sqrt(x) \x0a"
"\x09(IEEE double precision arithmetic) in software.\x0a"
"\x09""Both supply sqrt(x) correctly rounded. The first algorithm (in\x0a"
"\x09Section A) uses newton iterations and involves four divisions.\x0a"
"\x09The second one uses reciproot iterations to avoid division, but\x0a"
"\x09requires more multiplications. Both algorithms need the ability\x0a"
"\x09to chop results of arithmetic operations instead of round them, \x0a"
"\x09""and the INEXACT flag to indicate when an arithmetic operation\x0a"
"\x09is executed exactly with no roundoff error, all part of the \x0a"
"\x09standard (IEEE 754-1985). The ability to perform shift, add,\x0a"
"\x09subtract and logical AND operations upon 32-bit words is needed\x0a"
"\x09too, though not part of the standard.\x0a"
"\x0a"
"A.  sqrt(x) by Newton Iteration\x0a"
"\x0a"
"   (1)\x09Initial approximation\x0a"
"\x0a"
"\x09Let x0 and x1 be the leading and the trailing 32-bit words of\x0a"
"\x09""a floating point number x (in IEEE double format) respectively \x0a"
"\x0a"
"\x09    1    11\x09\x09     52\x09\x09\x09\x09  ...widths\x0a"
"\x09   ------------------------------------------------------\x0a"
"\x09x\x3a \x7cs\x7c\x09  e     \x7c\x09      f\x09\x09\x09\x09\x7c\x0a"
"\x09   ------------------------------------------------------\x0a"
"\x09      msb    lsb  msb\x09\x09\x09\x09      lsb ...order\x0a"
"\x0a"
" \x0a"
"\x09     ------------------------  \x09     ------------------------\x0a"
"\x09x0\x3a  \x7cs\x7c   e    \x7c    f1     \x7c\x09 x1\x3a \x7c          f2           \x7c\x0a"
"\x09     ------------------------  \x09     ------------------------\x0a"
"\x0a"
"\x09""By performing shifts and subtracts on x0 and x1 (both regarded\x0a"
"\x09""as integers), we obtain an 8-bit approximation of sqrt(x) as\x0a"
"\x09""follows.\x0a"
"\x0a"
"\x09\x09k  \x3a= (x0>>1) + 0x1ff80000;\x0a"
"\x09\x09y0 \x3a= k - T1\x5b""31\x26(k>>15)\x5d.\x09... y \x7e sqrt(x) to 8 bits\x0a"
"\x09Here k is a 32-bit integer and T1\x5b\x5d is an integer array containing\x0a"
"\x09""correction terms. Now magically the floating value of y (y's\x0a"
"\x09leading 32-bit word is y0, the value of its trailing word is 0)\x0a"
"\x09""approximates sqrt(x) to almost 8-bit.\x0a"
"\x0a"
"\x09Value of T1\x3a\x0a"
"\x09static int T1\x5b""32\x5d= {\x0a"
"\x09""0,\x09""1024,\x09""3062,\x09""5746,\x09""9193,\x09""13348,\x09""18162,\x09""23592,\x0a"
"\x09""29598,\x09""36145,\x09""43202,\x09""50740,\x09""58733,\x09""67158,\x09""75992,\x09""85215,\x0a"
"\x09""83599,\x09""71378,\x09""60428,\x09""50647,\x09""41945,\x09""34246,\x09""27478,\x09""21581,\x0a"
"\x09""16499,\x09""12183,\x09""8588,\x09""5674,\x09""3403,\x09""1742,\x09""661,\x09""130,};\x0a"
"\x0a"
"    (2)\x09Iterative refinement\x0a"
"\x0a"
"\x09""Apply Heron's rule three times to y, we have y approximates \x0a"
"\x09sqrt(x) to within 1 ulp (Unit in the Last Place)\x3a\x0a"
"\x0a"
"\x09\x09y \x3a= (y+x/y)/2\x09\x09... almost 17 sig. bits\x0a"
"\x09\x09y \x3a= (y+x/y)/2\x09\x09... almost 35 sig. bits\x0a"
"\x09\x09y \x3a= y-(y-x/y)/2\x09... within 1 ulp\x0a"
"\x0a"
"\x0a"
"\x09Remark 1.\x0a"
"\x09    Another way to improve y to within 1 ulp is\x3a\x0a"
"\x0a"
"\x09\x09y \x3a= (y+x/y)\x09\x09... almost 17 sig. bits to 2*sqrt(x)\x0a"
"\x09\x09y \x3a= y - 0x00100006\x09... almost 18 sig. bits to sqrt(x)\x0a"
"\x0a"
"\x09\x09\x09\x09""2\x0a"
"\x09\x09\x09    (x-y )*y\x0a"
"\x09\x09y \x3a= y + 2* ----------\x09...within 1 ulp\x0a"
"\x09\x09\x09       2\x0a"
"\x09\x09\x09     3y  + x\x0a"
"\x0a"
"\x0a"
"\x09This formula has one division fewer than the one above; however,\x0a"
"\x09it requires more multiplications and additions. Also x must be\x0a"
"\x09scaled in advance to avoid spurious overflow in evaluating the\x0a"
"\x09""expression 3y*y+x. Hence it is not recommended uless division\x0a"
"\x09is slow. If division is very slow, then one should use the \x0a"
"\x09reciproot algorithm given in section B.\x0a"
"\x0a"
"    (3) Final adjustment\x0a"
"\x0a"
"\x09""By twiddling y's last bit it is possible to force y to be \x0a"
"\x09""correctly rounded according to the prevailing rounding mode\x0a"
"\x09""as follows. Let r and i be copies of the rounding mode and\x0a"
"\x09inexact flag before entering the square root program. Also we\x0a"
"\x09use the expression y+-ulp for the next representable floating\x0a"
"\x09numbers (up and down) of y. Note that y+-ulp = either fixed\x0a"
"\x09point y+-1, or multiply y by nextafter(1,+-inf) in chopped\x0a"
"\x09mode.\x0a"
"\x0a"
"\x09\x09I \x3a= FALSE;\x09... reset INEXACT flag I\x0a"
"\x09\x09R \x3a= RZ;\x09... set rounding mode to round-toward-zero\x0a"
"\x09\x09z \x3a= x/y;\x09... chopped quotient, possibly inexact\x0a"
"\x09\x09If(not I) then {\x09... if the quotient is exact\x0a"
"\x09\x09    if(z=y) {\x0a"
"\x09\x09        I \x3a= i;\x09 ... restore inexact flag\x0a"
"\x09\x09        R \x3a= r;  ... restore rounded mode\x0a"
"\x09\x09        return sqrt(x)\x3a=y.\x0a"
"\x09\x09    } else {\x0a"
"\x09\x09\x09z \x3a= z - ulp;\x09... special rounding\x0a"
"\x09\x09    }\x0a"
"\x09\x09}\x0a"
"\x09\x09i \x3a= TRUE;\x09\x09... sqrt(x) is inexact\x0a"
"\x09\x09If (r=RN) then z=z+ulp\x09... rounded-to-nearest\x0a"
"\x09\x09If (r=RP) then {\x09... round-toward-+inf\x0a"
"\x09\x09    y = y+ulp; z=z+ulp;\x0a"
"\x09\x09}\x0a"
"\x09\x09y \x3a= y+z;\x09\x09... chopped sum\x0a"
"\x09\x09y0\x3a=y0-0x00100000;\x09... y \x3a= y/2 is correctly rounded.\x0a"
"\x09        I \x3a= i;\x09 \x09\x09... restore inexact flag\x0a"
"\x09        R \x3a= r;  \x09\x09... restore rounded mode\x0a"
"\x09        return sqrt(x)\x3a=y.\x0a"
"\x09\x09    \x0a"
"    (4)\x09Special cases\x0a"
"\x0a"
"\x09Square root of +inf, +-0, or NaN is itself;\x0a"
"\x09Square root of a negative number is NaN with invalid signal.\x0a"
"\x0a"
"\x0a"
"B.  sqrt(x) by Reciproot Iteration\x0a"
"\x0a"
"   (1)\x09Initial approximation\x0a"
"\x0a"
"\x09Let x0 and x1 be the leading and the trailing 32-bit words of\x0a"
"\x09""a floating point number x (in IEEE double format) respectively\x0a"
"\x09(see section A). By performing shifs and subtracts on x0 and y0,\x0a"
"\x09we obtain a 7.8-bit approximation of 1/sqrt(x) as follows.\x0a"
"\x0a"
"\x09    k \x3a= 0x5fe80000 - (x0>>1);\x0a"
"\x09    y0\x3a= k - T2\x5b""63\x26(k>>14)\x5d.\x09... y \x7e 1/sqrt(x) to 7.8 bits\x0a"
"\x0a"
"\x09Here k is a 32-bit integer and T2\x5b\x5d is an integer array \x0a"
"\x09""containing correction terms. Now magically the floating\x0a"
"\x09value of y (y's leading 32-bit word is y0, the value of\x0a"
"\x09its trailing word y1 is set to zero) approximates 1/sqrt(x)\x0a"
"\x09to almost 7.8-bit.\x0a"
"\x0a"
"\x09Value of T2\x3a\x0a"
"\x09static int T2\x5b""64\x5d= {\x0a"
"\x09""0x1500,\x09""0x2ef8,\x09""0x4d67,\x09""0x6b02,\x09""0x87be,\x09""0xa395,\x09""0xbe7a,\x09""0xd866,\x0a"
"\x09""0xf14a,\x09""0x1091b,0x11fcd,0x13552,0x14999,0x15c98,0x16e34,0x17e5f,\x0a"
"\x09""0x18d03,0x19a01,0x1a545,0x1ae8a,0x1b5c4,0x1bb01,0x1bfde,0x1c28d,\x0a"
"\x09""0x1c2de,0x1c0db,0x1ba73,0x1b11c,0x1a4b5,0x1953d,0x18266,0x16be0,\x0a"
"\x09""0x1683e,0x179d8,0x18a4d,0x19992,0x1a789,0x1b445,0x1bf61,0x1c989,\x0a"
"\x09""0x1d16d,0x1d77b,0x1dddf,0x1e2ad,0x1e5bf,0x1e6e8,0x1e654,0x1e3cd,\x0a"
"\x09""0x1df2a,0x1d635,0x1cb16,0x1be2c,0x1ae4e,0x19bde,0x1868e,0x16e2e,\x0a"
"\x09""0x1527f,0x1334a,0x11051,0xe951,\x09""0xbe01,\x09""0x8e0d,\x09""0x5924,\x09""0x1edd,};\x0a"
"\x0a"
"    (2)\x09Iterative refinement\x0a"
"\x0a"
"\x09""Apply Reciproot iteration three times to y and multiply the\x0a"
"\x09result by x to get an approximation z that matches sqrt(x)\x0a"
"\x09to about 1 ulp. To be exact, we will have \x0a"
"\x09\x09-1ulp < sqrt(x)-z<1.0625ulp.\x0a"
"\x09\x0a"
"\x09... set rounding mode to Round-to-nearest\x0a"
"\x09   y \x3a= y*(1.5-0.5*x*y*y)\x09... almost 15 sig. bits to 1/sqrt(x)\x0a"
"\x09   y \x3a= y*((1.5-2^-30)+0.5*x*y*y)... about 29 sig. bits to 1/sqrt(x)\x0a"
"\x09... special arrangement for better accuracy\x0a"
"\x09   z \x3a= x*y\x09\x09\x09... 29 bits to sqrt(x), with z*y<1\x0a"
"\x09   z \x3a= z + 0.5*z*(1-z*y)\x09... about 1 ulp to sqrt(x)\x0a"
"\x0a"
"\x09Remark 2. The constant 1.5-2^-30 is chosen to bias the error so that\x0a"
"\x09(a) the term z*y in the final iteration is always less than 1; \x0a"
"\x09(b) the error in the final result is biased upward so that\x0a"
"\x09\x09-1 ulp < sqrt(x) - z < 1.0625 ulp\x0a"
"\x09    instead of \x7csqrt(x)-z\x7c<1.03125ulp.\x0a"
"\x0a"
"    (3)\x09""Final adjustment\x0a"
"\x0a"
"\x09""By twiddling y's last bit it is possible to force y to be \x0a"
"\x09""correctly rounded according to the prevailing rounding mode\x0a"
"\x09""as follows. Let r and i be copies of the rounding mode and\x0a"
"\x09inexact flag before entering the square root program. Also we\x0a"
"\x09use the expression y+-ulp for the next representable floating\x0a"
"\x09numbers (up and down) of y. Note that y+-ulp = either fixed\x0a"
"\x09point y+-1, or multiply y by nextafter(1,+-inf) in chopped\x0a"
"\x09mode.\x0a"
"\x0a"
"\x09R \x3a= RZ;\x09\x09... set rounding mode to round-toward-zero\x0a"
"\x09switch(r) {\x0a"
"\x09    case RN\x3a\x09\x09... round-to-nearest\x0a"
"\x09       if(x<= z*(z-ulp)...chopped) z = z - ulp; else\x0a"
"\x09       if(x<= z*(z+ulp)...chopped) z = z; else z = z+ulp;\x0a"
"\x09       break;\x0a"
"\x09    case RZ\x3a""case RM\x3a\x09... round-to-zero or round-to--inf\x0a"
"\x09       R\x3a=RP;\x09\x09... reset rounding mod to round-to-+inf\x0a"
"\x09       if(x<z*z ... rounded up) z = z - ulp; else\x0a"
"\x09       if(x>=(z+ulp)*(z+ulp) ...rounded up) z = z+ulp;\x0a"
"\x09       break;\x0a"
"\x09    case RP\x3a\x09\x09... round-to-+inf\x0a"
"\x09       if(x>(z+ulp)*(z+ulp)...chopped) z = z+2*ulp; else\x0a"
"\x09       if(x>z*z ...chopped) z = z+ulp;\x0a"
"\x09       break;\x0a"
"\x09}\x0a"
"\x0a"
"\x09Remark 3. The above comparisons can be done in fixed point. For\x0a"
"\x09""example, to compare x and w=z*z chopped, it suffices to compare\x0a"
"\x09x1 and w1 (the trailing parts of x and w), regarding them as\x0a"
"\x09two's complement integers.\x0a"
"\x0a"
"\x09...Is z an exact square root\x3f\x0a"
"\x09To determine whether z is an exact square root of x, let z1 be the\x0a"
"\x09trailing part of z, and also let x0 and x1 be the leading and\x0a"
"\x09trailing parts of x.\x0a"
"\x0a"
"\x09If ((z1\x26""0x03ffffff)\x21=0)\x09... not exact if trailing 26 bits of z\x21=0\x0a"
"\x09    I \x3a= 1;\x09\x09... Raise Inexact flag\x3a z is not exact\x0a"
"\x09""else {\x0a"
"\x09    j \x3a= 1 - \x5b(x0>>20)\x26""1\x5d\x09... j = logb(x) mod 2\x0a"
"\x09    k \x3a= z1 >> 26;\x09\x09... get z's 25-th and 26-th \x0a"
"\x09\x09\x09\x09\x09    fraction bits\x0a"
"\x09    I \x3a= i or (k\x26j) or ((k\x26(j+j+1))\x21=(x1\x26""3));\x0a"
"\x09}\x0a"
"\x09R\x3a= r\x09\x09... restore rounded mode\x0a"
"\x09return sqrt(x)\x3a=z.\x0a"
"\x0a"
"\x09If multiplication is cheaper then the foregoing red tape, the \x0a"
"\x09Inexact flag can be evaluated by\x0a"
"\x0a"
"\x09    I \x3a= i;\x0a"
"\x09    I \x3a= (z*z\x21=x) or I.\x0a"
"\x0a"
"\x09Note that z*z can overwrite I; this value must be sensed if it is \x0a"
"\x09True.\x0a"
"\x0a"
"\x09Remark 4. If z*z = x exactly, then bit 25 to bit 0 of z1 must be\x0a"
"\x09zero.\x0a"
"\x0a"
"\x09\x09    --------------------\x0a"
"\x09\x09z1\x3a \x7c        f2        \x7c \x0a"
"\x09\x09    --------------------\x0a"
"\x09\x09""bit 31\x09\x09   bit 0\x0a"
"\x0a"
"\x09""Further more, bit 27 and 26 of z1, bit 0 and 1 of x1, and the odd\x0a"
"\x09or even of logb(x) have the following relations\x3a\x0a"
"\x0a"
"\x09-------------------------------------------------\x0a"
"\x09""bit 27,26 of z1\x09\x09""bit 1,0 of x1\x09logb(x)\x0a"
"\x09-------------------------------------------------\x0a"
"\x09""00\x09\x09\x09""00\x09\x09odd and even\x0a"
"\x09""01\x09\x09\x09""01\x09\x09""even\x0a"
"\x09""10\x09\x09\x09""10\x09\x09odd\x0a"
"\x09""10\x09\x09\x09""00\x09\x09""even\x0a"
"\x09""11\x09\x09\x09""01\x09\x09""even\x0a"
"\x09-------------------------------------------------\x0a"
"\x0a"
"    (4)\x09Special cases (see (4) of Section A).\x09\x0a"
" \x0a"
" */\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(sqrtl, sqrt);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 14428 ); }