#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_sqrtf_c( 
"/* e_sqrtf.c -- float version of e_sqrt.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static\x09""const float\x09one\x09= 1.0, tiny=1.0e-30;\x0a"
"\x0a"
"float\x0a"
"sqrtf(float x)\x0a"
"{\x0a"
"\x09""float z;\x0a"
"\x09int32_t sign = (int)0x80000000; \x0a"
"\x09int32_t ix,s,q,m,t,i;\x0a"
"\x09u_int32_t r;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(ix,x);\x0a"
"\x0a"
"    /* take care of Inf and NaN */\x0a"
"\x09if((ix\x26""0x7f800000)==0x7f800000) {\x09\x09\x09\x0a"
"\x09    return x*x+x;\x09\x09/* sqrt(NaN)=NaN, sqrt(+inf)=+inf\x0a"
"\x09\x09\x09\x09\x09   sqrt(-inf)=sNaN */\x0a"
"\x09} \x0a"
"    /* take care of zero */\x0a"
"\x09if(ix<=0) {\x0a"
"\x09    if((ix\x26(\x7esign))==0) return x;/* sqrt(+-0) = +-0 */\x0a"
"\x09    else if(ix<0)\x0a"
"\x09\x09return (x-x)/(x-x);\x09\x09/* sqrt(-ve) = sNaN */\x0a"
"\x09}\x0a"
"    /* normalize x */\x0a"
"\x09m = (ix>>23);\x0a"
"\x09if(m==0) {\x09\x09\x09\x09/* subnormal x */\x0a"
"\x09    for(i=0;(ix\x26""0x00800000)==0;i++) ix<<=1;\x0a"
"\x09    m -= i-1;\x0a"
"\x09}\x0a"
"\x09m -= 127;\x09/* unbias exponent */\x0a"
"\x09ix = (ix\x26""0x007fffff)\x7c""0x00800000;\x0a"
"\x09if(m\x26""1)\x09/* odd m, double x to make it even */\x0a"
"\x09    ix += ix;\x0a"
"\x09m >>= 1;\x09/* m = \x5bm/2\x5d */\x0a"
"\x0a"
"    /* generate sqrt(x) bit by bit */\x0a"
"\x09ix += ix;\x0a"
"\x09q = s = 0;\x09\x09/* q = sqrt(x) */\x0a"
"\x09r = 0x01000000;\x09\x09/* r = moving bit from right to left */\x0a"
"\x0a"
"\x09while(r\x21=0) {\x0a"
"\x09    t = s+r; \x0a"
"\x09    if(t<=ix) { \x0a"
"\x09\x09s    = t+r; \x0a"
"\x09\x09ix  -= t; \x0a"
"\x09\x09q   += r; \x0a"
"\x09    } \x0a"
"\x09    ix += ix;\x0a"
"\x09    r>>=1;\x0a"
"\x09}\x0a"
"\x0a"
"    /* use floating add to find out rounding direction */\x0a"
"\x09if(ix\x21=0) {\x0a"
"\x09    z = one-tiny; /* trigger inexact flag */\x0a"
"\x09    if (z>=one) {\x0a"
"\x09        z = one+tiny;\x0a"
"\x09\x09if (z>one)\x0a"
"\x09\x09    q += 2;\x0a"
"\x09\x09""else\x0a"
"\x09\x09    q += (q\x26""1);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09ix = (q>>1)+0x3f000000;\x0a"
"\x09ix += (m <<23);\x0a"
"\x09SET_FLOAT_WORD(z,ix);\x0a"
"\x09return z;\x0a"
"}\x0a"
"", 1903 ); }