#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_e_sqrtl_c( 
"/*\x09\x24OpenBSD\x3a e_sqrtl.c,v 1.1 2008/12/09 20\x3a""00\x3a""35 martynas Exp \x24\x09*/\x0a"
"/*-\x0a"
" * Copyright (c) 2007 Steven G. Kargl\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice unmodified, this list of conditions, and the following\x0a"
" *    disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE AUTHOR \x60\x60""AS IS'' AND ANY EXPRESS OR\x0a"
" * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES\x0a"
" * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.\x0a"
" * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,\x0a"
" * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT\x0a"
" * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,\x0a"
" * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY\x0a"
" * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\x0a"
" * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF\x0a"
" * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#include <sys/types.h>\x0a"
"#include <machine/ieee.h>\x0a"
"#include <float.h>\x0a"
"#include <ieeefp.h>\x0a"
"#include <math.h>\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"#ifdef EXT_IMPLICIT_NBIT\x0a"
"#define\x09LDBL_NBIT\x09""0\x0a"
"#else /* EXT_IMPLICIT_NBIT */\x0a"
"#define\x09LDBL_NBIT\x09""0x80000000\x0a"
"#endif /* EXT_IMPLICIT_NBIT */\x0a"
"\x0a"
"/* Return (x + ulp) for normal positive x. Assumes no overflow. */\x0a"
"static inline long double\x0a"
"inc(long double x)\x0a"
"{\x0a"
"\x09struct ieee_ext *p = (struct ieee_ext *)\x26x;\x0a"
"\x0a"
"#ifdef EXT_FRACHMBITS\x0a"
"\x09uint64_t frach;\x0a"
"\x0a"
"\x09""frach = ((uint64_t)p->ext_frach << EXT_FRACHMBITS) \x7c p->ext_frachm;\x0a"
"\x09""frach++;\x0a"
"\x09p->ext_frach = frach >> EXT_FRACHMBITS;\x0a"
"\x09p->ext_frachm = frach \x26 0x00000000ffffffff;\x0a"
"#else /* EXT_FRACHMBITS */\x0a"
"\x09uint32_t frach;\x0a"
"\x0a"
"\x09p->ext_frach++;\x0a"
"\x09""frach = p->ext_frach;\x0a"
"#endif /* EXT_FRACHMBITS */\x0a"
"\x0a"
"\x09if (frach == 0) {\x0a"
"\x0a"
"#ifdef EXT_FRACLMBITS\x0a"
"\x09\x09uint64_t fracl;\x0a"
"\x0a"
"\x09\x09""fracl = ((uint64_t)p->ext_fraclm << EXT_FRACLBITS) \x7c\x0a"
"\x09\x09\x09p->ext_fracl;\x0a"
"\x09\x09""fracl++;\x0a"
"\x09\x09p->ext_fraclm = fracl >> EXT_FRACLBITS;\x0a"
"\x09\x09p->ext_fracl = fracl \x26 0x00000000ffffffff;\x0a"
"#else /* EXT_FRACLMBITS */\x0a"
"\x09\x09uint32_t fracl;\x0a"
"\x0a"
"\x09\x09p->ext_fracl++;\x0a"
"\x09\x09""fracl = p->ext_fracl;\x0a"
"#endif /* EXT_FRACLMBITS */\x0a"
"\x0a"
"\x09\x09if (fracl == 0) {\x0a"
"\x09\x09\x09p->ext_exp++;\x0a"
"\x09\x09\x09p->ext_frach \x7c= LDBL_NBIT;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x0a"
"\x09return x;\x0a"
"}\x0a"
"\x0a"
"/* Return (x - ulp) for normal positive x. Assumes no underflow. */\x0a"
"static inline long double\x0a"
"dec(long double x)\x0a"
"{\x0a"
"\x09struct ieee_ext *p = (struct ieee_ext *)\x26x;\x0a"
"\x0a"
"#ifdef EXT_FRACLMBITS\x0a"
"\x09uint64_t fracl;\x0a"
"\x0a"
"\x09""fracl = ((uint64_t)p->ext_fraclm << EXT_FRACLBITS) \x7c p->ext_fracl;\x0a"
"\x09""fracl--;\x0a"
"\x09p->ext_fraclm = fracl >> EXT_FRACLBITS;\x0a"
"\x09p->ext_fracl = fracl \x26 0x00000000ffffffff;\x0a"
"#else /* EXT_FRACLMBITS */\x0a"
"\x09uint32_t fracl;\x0a"
"\x0a"
"\x09p->ext_fracl--;\x0a"
"\x09""fracl = p->ext_fracl;\x0a"
"#endif /* EXT_FRACLMBITS */\x0a"
"\x0a"
"\x09if (fracl == 0) {\x0a"
"\x0a"
"#ifdef EXT_FRACHMBITS\x0a"
"\x09\x09uint64_t frach;\x0a"
"\x0a"
"\x09\x09""frach = ((uint64_t)p->ext_frach << EXT_FRACHMBITS) \x7c\x0a"
"\x09\x09\x09p->ext_frachm;\x0a"
"\x09\x09""frach--;\x0a"
"\x09\x09p->ext_frach = frach >> EXT_FRACHMBITS;\x0a"
"\x09\x09p->ext_frachm = frach \x26 0x00000000ffffffff;\x0a"
"#else /* EXT_FRACHMBITS */\x0a"
"\x09\x09uint32_t frach;\x0a"
"\x0a"
"\x09\x09p->ext_frach--;\x0a"
"\x09\x09""frach = p->ext_frach;\x0a"
"#endif /* EXT_FRACHMBITS */\x0a"
"\x0a"
"\x09\x09if (frach == LDBL_NBIT) {\x0a"
"\x09\x09\x09p->ext_exp--;\x0a"
"\x09\x09\x09p->ext_frach \x7c= LDBL_NBIT;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x0a"
"\x09return x;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
" * This is slow, but simple and portable. You should use hardware sqrt\x0a"
" * if possible.\x0a"
" */\x0a"
"\x0a"
"__link_always long double\x0a"
"sqrtl(long double x)\x0a"
"{\x0a"
"\x09union {\x0a"
"\x09\x09long double e;\x0a"
"\x09\x09struct ieee_ext bits;\x0a"
"\x09} u;\x0a"
"\x09int k, r;\x0a"
"\x09long double lo, xn;\x0a"
"\x0a"
"\x09u.e = x;\x0a"
"\x0a"
"\x09/* If x = NaN, then sqrt(x) = NaN. */\x0a"
"\x09/* If x = Inf, then sqrt(x) = Inf. */\x0a"
"\x09/* If x = -Inf, then sqrt(x) = NaN. */\x0a"
"\x09if (u.bits.ext_exp == LDBL_MAX_EXP * 2 - 1)\x0a"
"\x09\x09return (x * x + x);\x0a"
"\x0a"
"\x09/* If x = +-0, then sqrt(x) = +-0. */\x0a"
"\x09if ((u.bits.ext_frach\x0a"
"#ifdef EXT_FRACHMBITS\x0a"
"\x09\x09\x7c u.bits.ext_frachm\x0a"
"#endif /* EXT_FRACHMBITS */\x0a"
"#ifdef EXT_FRACLMBITS\x0a"
"\x09\x09\x7c u.bits.ext_fraclm\x0a"
"#endif /* EXT_FRACLMBITS */\x0a"
"\x09\x09\x7c u.bits.ext_fracl \x7c u.bits.ext_exp) == 0)\x0a"
"\x09\x09return (x);\x0a"
"\x0a"
"\x09/* If x < 0, then raise invalid and return NaN */\x0a"
"\x09if (u.bits.ext_sign)\x0a"
"\x09\x09return ((x - x) / (x - x));\x0a"
"\x0a"
"\x09if (u.bits.ext_exp == 0) {\x0a"
"\x09\x09/* Adjust subnormal numbers. */\x0a"
"\x09\x09u.e *= 0x1.0p514;\x0a"
"\x09\x09k = -514;\x0a"
"\x09} else {\x0a"
"\x09\x09k = 0;\x0a"
"\x09}\x0a"
"\x09/*\x0a"
"\x09 * u.e is a normal number, so break it into u.e = e*2^n where\x0a"
"\x09 * u.e = (2*e)*2^2k for odd n and u.e = (4*e)*2^2k for even n.\x0a"
"\x09 */\x0a"
"\x09if ((u.bits.ext_exp - 0x3ffe) \x26 1) {\x09/* n is odd.     */\x0a"
"\x09\x09k += u.bits.ext_exp - 0x3fff;\x09/* 2k = n - 1.   */\x0a"
"\x09\x09u.bits.ext_exp = 0x3fff;\x09/* u.e in \x5b""1,2). */\x0a"
"\x09} else {\x0a"
"\x09\x09k += u.bits.ext_exp - 0x4000;\x09/* 2k = n - 2.   */\x0a"
"\x09\x09u.bits.ext_exp = 0x4000;\x09/* u.e in \x5b""2,4). */\x0a"
"\x09}\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * Newton's iteration.\x0a"
"\x09 * Split u.e into a high and low part to achieve additional precision.\x0a"
"\x09 */\x0a"
"\x09xn = sqrt(u.e);\x09\x09\x09/* 53-bit estimate of sqrtl(x). */\x0a"
"#if LDBL_MANT_DIG > 100\x0a"
"\x09xn = (xn + (u.e / xn)) * 0.5;\x09/* 106-bit estimate. */\x0a"
"#endif\x0a"
"\x09lo = u.e;\x0a"
"\x09u.bits.ext_fracl = 0;\x09\x09/* Zero out lower bits. */\x0a"
"#ifdef EXT_FRACLMBITS\x0a"
"\x09u.bits.ext_fraclm = 0;\x0a"
"#endif /* EXT_FRACLMBITS */\x0a"
"\x09lo = (lo - u.e) / xn;\x09\x09/* Low bits divided by xn. */\x0a"
"\x09xn = xn + (u.e / xn);\x09\x09/* High portion of estimate. */\x0a"
"\x09u.e = xn + lo;\x09\x09\x09/* Combine everything. */\x0a"
"\x09u.bits.ext_exp += (k >> 1) - 1;\x0a"
"\x0a"
"\x09""fpsetsticky(fpgetsticky() \x26 \x7e""FP_X_IMP);\x0a"
"\x09r = fpsetround(FP_RZ);\x09\x09/* Set to round-toward-zero. */\x0a"
"\x09xn = x / u.e;\x09\x09\x09/* Chopped quotient (inexact\x3f). */\x0a"
"\x0a"
"\x09if (\x21(fpgetsticky() \x26 FP_X_IMP)) { /* Quotient is exact. */\x0a"
"\x09\x09if (xn == u.e) {\x0a"
"\x09\x09\x09""fpsetround(r);\x0a"
"\x09\x09\x09return (u.e);\x0a"
"\x09\x09}\x0a"
"\x09\x09/* Round correctly for inputs like x = y**2 - ulp. */\x0a"
"\x09\x09xn = dec(xn);\x09\x09/* xn = xn - ulp. */\x0a"
"\x09}\x0a"
"\x0a"
"\x09if (r == FP_RN) {\x0a"
"\x09\x09xn = inc(xn);\x09\x09/* xn = xn + ulp. */\x0a"
"\x09} else if (r == FP_RP) {\x0a"
"\x09\x09u.e = inc(u.e);\x09\x09/* u.e = u.e + ulp. */\x0a"
"\x09\x09xn = inc(xn);\x09\x09/* xn  = xn + ulp. */\x0a"
"\x09}\x0a"
"\x09u.e = u.e + xn;\x09\x09\x09/* Chopped sum. */\x0a"
"\x09""fpsetround(r);\x09\x09\x09/* Restore env and raise inexact */\x0a"
"\x09u.bits.ext_exp--;\x0a"
"\x09return (u.e);\x0a"
"}\x0a"
"", 6070 ); }