#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_k_rem_pio2_c( 
"/* \x40(#)k_rem_pio2.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * __kernel_rem_pio2(x,y,e0,nx,prec)\x0a"
" * double x\x5b\x5d,y\x5b\x5d; int e0,nx,prec;\x0a"
" * \x0a"
" * __kernel_rem_pio2 return the last three digits of N with \x0a"
" *\x09\x09y = x - N*pi/2\x0a"
" * so that \x7cy\x7c < pi/2.\x0a"
" *\x0a"
" * The method is to compute the integer (mod 8) and fraction parts of \x0a"
" * (2/pi)*x without doing the full multiplication. In general we\x0a"
" * skip the part of the product that are known to be a huge integer (\x0a"
" * more accurately, = 0 mod 8 ). Thus the number of operations are\x0a"
" * independent of the exponent of the input.\x0a"
" *\x0a"
" * (2/pi) is represented by an array of 24-bit integers in ipio2\x5b\x5d.\x0a"
" *\x0a"
" * Input parameters\x3a\x0a"
" * \x09x\x5b\x5d\x09The input value (must be positive) is broken into nx \x0a"
" *\x09\x09pieces of 24-bit integers in double precision format.\x0a"
" *\x09\x09x\x5bi\x5d will be the i-th 24 bit of x. The scaled exponent \x0a"
" *\x09\x09of x\x5b""0\x5d is given in input parameter e0 (i.e., x\x5b""0\x5d*2^e0 \x0a"
" *\x09\x09match x's up to 24 bits.\x0a"
" *\x0a"
" *\x09\x09""Example of breaking a double positive z into x\x5b""0\x5d+x\x5b""1\x5d+x\x5b""2\x5d\x3a\x0a"
" *\x09\x09\x09""e0 = ilogb(z)-23\x0a"
" *\x09\x09\x09z  = scalbn(z,-e0)\x0a"
" *\x09\x09""for i = 0,1,2\x0a"
" *\x09\x09\x09x\x5bi\x5d = floor(z)\x0a"
" *\x09\x09\x09z    = (z-x\x5bi\x5d)*2**24\x0a"
" *\x0a"
" *\x0a"
" *\x09y\x5b\x5d\x09output result in an array of double precision numbers.\x0a"
" *\x09\x09The dimension of y\x5b\x5d is\x3a\x0a"
" *\x09\x09\x09""24-bit  precision\x09""1\x0a"
" *\x09\x09\x09""53-bit  precision\x09""2\x0a"
" *\x09\x09\x09""64-bit  precision\x09""2\x0a"
" *\x09\x09\x09""113-bit precision\x09""3\x0a"
" *\x09\x09The actual value is the sum of them. Thus for 113-bit\x0a"
" *\x09\x09precison, one may have to do something like\x3a\x0a"
" *\x0a"
" *\x09\x09long double t,w,r_head, r_tail;\x0a"
" *\x09\x09t = (long double)y\x5b""2\x5d + (long double)y\x5b""1\x5d;\x0a"
" *\x09\x09w = (long double)y\x5b""0\x5d;\x0a"
" *\x09\x09r_head = t+w;\x0a"
" *\x09\x09r_tail = w - (r_head - t);\x0a"
" *\x0a"
" *\x09""e0\x09The exponent of x\x5b""0\x5d. Must be <= 16360 or you need to\x0a"
" *              expand the ipio2 table.\x0a"
" *\x0a"
" *\x09nx\x09""dimension of x\x5b\x5d\x0a"
" *\x0a"
" *  \x09prec\x09""an integer indicating the precision\x3a\x0a"
" *\x09\x09\x09""0\x09""24  bits (single)\x0a"
" *\x09\x09\x09""1\x09""53  bits (double)\x0a"
" *\x09\x09\x09""2\x09""64  bits (extended)\x0a"
" *\x09\x09\x09""3\x09""113 bits (quad)\x0a"
" *\x0a"
" * External function\x3a\x0a"
" *\x09""double scalbn(), floor();\x0a"
" *\x0a"
" *\x0a"
" * Here is the description of some local variables\x3a\x0a"
" *\x0a"
" * \x09jk\x09jk+1 is the initial number of terms of ipio2\x5b\x5d needed\x0a"
" *\x09\x09in the computation. The recommended value is 2,3,4,\x0a"
" *\x09\x09""6 for single, double, extended,and quad.\x0a"
" *\x0a"
" * \x09jz\x09local integer variable indicating the number of \x0a"
" *\x09\x09terms of ipio2\x5b\x5d used. \x0a"
" *\x0a"
" *\x09jx\x09nx - 1\x0a"
" *\x0a"
" *\x09jv\x09index for pointing to the suitable ipio2\x5b\x5d for the\x0a"
" *\x09\x09""computation. In general, we want\x0a"
" *\x09\x09\x09( 2^e0*x\x5b""0\x5d * ipio2\x5bjv-1\x5d*2^(-24jv) )/8\x0a"
" *\x09\x09is an integer. Thus\x0a"
" *\x09\x09\x09""e0-3-24*jv >= 0 or (e0-3)/24 >= jv\x0a"
" *\x09\x09Hence jv = max(0,(e0-3)/24).\x0a"
" *\x0a"
" *\x09jp\x09jp+1 is the number of terms in PIo2\x5b\x5d needed, jp = jk.\x0a"
" *\x0a"
" * \x09q\x5b\x5d\x09""double array with integral value, representing the\x0a"
" *\x09\x09""24-bits chunk of the product of x and 2/pi.\x0a"
" *\x0a"
" *\x09q0\x09the corresponding exponent of q\x5b""0\x5d. Note that the\x0a"
" *\x09\x09""exponent for q\x5bi\x5d would be q0-24*i.\x0a"
" *\x0a"
" *\x09PIo2\x5b\x5d\x09""double precision array, obtained by cutting pi/2\x0a"
" *\x09\x09into 24 bits chunks. \x0a"
" *\x0a"
" *\x09""f\x5b\x5d\x09ipio2\x5b\x5d in floating point \x0a"
" *\x0a"
" *\x09iq\x5b\x5d\x09integer array by breaking up q\x5b\x5d in 24-bits chunk.\x0a"
" *\x0a"
" *\x09""fq\x5b\x5d\x09""final product of x*(2/pi) in fq\x5b""0\x5d,..,fq\x5bjk\x5d\x0a"
" *\x0a"
" *\x09ih\x09integer. If >0 it indicates q\x5b\x5d is >= 0.5, hence\x0a"
" *\x09\x09it also indicates the *sign* of the result.\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"\x0a"
"/*\x0a"
" * Constants\x3a\x0a"
" * The hexadecimal values are the intended ones for the following \x0a"
" * constants. The decimal values may be used, provided that the \x0a"
" * compiler will convert from decimal to binary accurately enough \x0a"
" * to produce the hexadecimal values shown.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const int init_jk\x5b\x5d = {2,3,4,6}; /* initial value for jk */\x0a"
"\x0a"
"/*\x0a"
" * Table of constants for 2/pi, 396 Hex digits (476 decimal) of 2/pi\x0a"
" *\x0a"
" *\x09\x09integer array, contains the (24*i)-th to (24*i+23)-th \x0a"
" *\x09\x09""bit of 2/pi after binary point. The corresponding \x0a"
" *\x09\x09""floating value is\x0a"
" *\x0a"
" *\x09\x09\x09ipio2\x5bi\x5d * 2^(-24(i+1)).\x0a"
" *\x0a"
" * NB\x3a This table must have at least (e0-3)/24 + jk terms.\x0a"
" *     For quad precision (e0 <= 16360, jk = 6), this is 686.\x0a"
" */\x0a"
"static const int32_t ipio2\x5b\x5d = {\x0a"
"0xA2F983, 0x6E4E44, 0x1529FC, 0x2757D1, 0xF534DD, 0xC0DB62, \x0a"
"0x95993C, 0x439041, 0xFE5163, 0xABDEBB, 0xC561B7, 0x246E3A, \x0a"
"0x424DD2, 0xE00649, 0x2EEA09, 0xD1921C, 0xFE1DEB, 0x1CB129, \x0a"
"0xA73EE8, 0x8235F5, 0x2EBB44, 0x84E99C, 0x7026B4, 0x5F7E41, \x0a"
"0x3991D6, 0x398353, 0x39F49C, 0x845F8B, 0xBDF928, 0x3B1FF8, \x0a"
"0x97FFDE, 0x05980F, 0xEF2F11, 0x8B5A0A, 0x6D1F6D, 0x367ECF, \x0a"
"0x27CB09, 0xB74F46, 0x3F669E, 0x5FEA2D, 0x7527BA, 0xC7EBE5, \x0a"
"0xF17B3D, 0x0739F7, 0x8A5292, 0xEA6BFB, 0x5FB11F, 0x8D5D08, \x0a"
"0x560330, 0x46FC7B, 0x6BABF0, 0xCFBC20, 0x9AF436, 0x1DA9E3, \x0a"
"0x91615E, 0xE61B08, 0x659985, 0x5F14A0, 0x68408D, 0xFFD880, \x0a"
"0x4D7327, 0x310606, 0x1556CA, 0x73A8C9, 0x60E27B, 0xC08C6B, \x0a"
"\x0a"
"#if LDBL_MAX_EXP > 1024\x0a"
"#if LDBL_MAX_EXP > 16384\x0a"
"#error \x22ipio2 table needs to be expanded\x22\x0a"
"#endif\x0a"
"0x47C419, 0xC367CD, 0xDCE809, 0x2A8359, 0xC4768B, 0x961CA6,\x0a"
"0xDDAF44, 0xD15719, 0x053EA5, 0xFF0705, 0x3F7E33, 0xE832C2,\x0a"
"0xDE4F98, 0x327DBB, 0xC33D26, 0xEF6B1E, 0x5EF89F, 0x3A1F35,\x0a"
"0xCAF27F, 0x1D87F1, 0x21907C, 0x7C246A, 0xFA6ED5, 0x772D30,\x0a"
"0x433B15, 0xC614B5, 0x9D19C3, 0xC2C4AD, 0x414D2C, 0x5D000C,\x0a"
"0x467D86, 0x2D71E3, 0x9AC69B, 0x006233, 0x7CD2B4, 0x97A7B4,\x0a"
"0xD55537, 0xF63ED7, 0x1810A3, 0xFC764D, 0x2A9D64, 0xABD770,\x0a"
"0xF87C63, 0x57B07A, 0xE71517, 0x5649C0, 0xD9D63B, 0x3884A7,\x0a"
"0xCB2324, 0x778AD6, 0x23545A, 0xB91F00, 0x1B0AF1, 0xDFCE19,\x0a"
"0xFF319F, 0x6A1E66, 0x615799, 0x47FBAC, 0xD87F7E, 0xB76522,\x0a"
"0x89E832, 0x60BFE6, 0xCDC4EF, 0x09366C, 0xD43F5D, 0xD7DE16,\x0a"
"0xDE3B58, 0x929BDE, 0x2822D2, 0xE88628, 0x4D58E2, 0x32CAC6,\x0a"
"0x16E308, 0xCB7DE0, 0x50C017, 0xA71DF3, 0x5BE018, 0x34132E,\x0a"
"0x621283, 0x014883, 0x5B8EF5, 0x7FB0AD, 0xF2E91E, 0x434A48,\x0a"
"0xD36710, 0xD8DDAA, 0x425FAE, 0xCE616A, 0xA4280A, 0xB499D3,\x0a"
"0xF2A606, 0x7F775C, 0x83C2A3, 0x883C61, 0x78738A, 0x5A8CAF,\x0a"
"0xBDD76F, 0x63A62D, 0xCBBFF4, 0xEF818D, 0x67C126, 0x45CA55,\x0a"
"0x36D9CA, 0xD2A828, 0x8D61C2, 0x77C912, 0x142604, 0x9B4612,\x0a"
"0xC459C4, 0x44C5C8, 0x91B24D, 0xF31700, 0xAD43D4, 0xE54929,\x0a"
"0x10D5FD, 0xFCBE00, 0xCC941E, 0xEECE70, 0xF53E13, 0x80F1EC,\x0a"
"0xC3E7B3, 0x28F8C7, 0x940593, 0x3E71C1, 0xB3092E, 0xF3450B,\x0a"
"0x9C1288, 0x7B20AB, 0x9FB52E, 0xC29247, 0x2F327B, 0x6D550C,\x0a"
"0x90A772, 0x1FE76B, 0x96CB31, 0x4A1679, 0xE27941, 0x89DFF4,\x0a"
"0x9794E8, 0x84E6E2, 0x973199, 0x6BED88, 0x365F5F, 0x0EFDBB,\x0a"
"0xB49A48, 0x6CA467, 0x427271, 0x325D8D, 0xB8159F, 0x09E5BC,\x0a"
"0x25318D, 0x3974F7, 0x1C0530, 0x010C0D, 0x68084B, 0x58EE2C,\x0a"
"0x90AA47, 0x02E774, 0x24D6BD, 0xA67DF7, 0x72486E, 0xEF169F,\x0a"
"0xA6948E, 0xF691B4, 0x5153D1, 0xF20ACF, 0x339820, 0x7E4BF5,\x0a"
"0x6863B2, 0x5F3EDD, 0x035D40, 0x7F8985, 0x295255, 0xC06437,\x0a"
"0x10D86D, 0x324832, 0x754C5B, 0xD4714E, 0x6E5445, 0xC1090B,\x0a"
"0x69F52A, 0xD56614, 0x9D0727, 0x50045D, 0xDB3BB4, 0xC576EA,\x0a"
"0x17F987, 0x7D6B49, 0xBA271D, 0x296996, 0xACCCC6, 0x5414AD,\x0a"
"0x6AE290, 0x89D988, 0x50722C, 0xBEA404, 0x940777, 0x7030F3,\x0a"
"0x27FC00, 0xA871EA, 0x49C266, 0x3DE064, 0x83DD97, 0x973FA3,\x0a"
"0xFD9443, 0x8C860D, 0xDE4131, 0x9D3992, 0x8C70DD, 0xE7B717,\x0a"
"0x3BDF08, 0x2B3715, 0xA0805C, 0x93805A, 0x921110, 0xD8E80F,\x0a"
"0xAF806C, 0x4BFFDB, 0x0F9038, 0x761859, 0x15A562, 0xBBCB61,\x0a"
"0xB989C7, 0xBD4010, 0x04F2D2, 0x277549, 0xF6B6EB, 0xBB22DB,\x0a"
"0xAA140A, 0x2F2689, 0x768364, 0x333B09, 0x1A940E, 0xAA3A51,\x0a"
"0xC2A31D, 0xAEEDAF, 0x12265C, 0x4DC26D, 0x9C7A2D, 0x9756C0,\x0a"
"0x833F03, 0xF6F009, 0x8C402B, 0x99316D, 0x07B439, 0x15200C,\x0a"
"0x5BC3D8, 0xC492F5, 0x4BADC6, 0xA5CA4E, 0xCD37A7, 0x36A9E6,\x0a"
"0x9492AB, 0x6842DD, 0xDE6319, 0xEF8C76, 0x528B68, 0x37DBFC,\x0a"
"0xABA1AE, 0x3115DF, 0xA1AE00, 0xDAFB0C, 0x664D64, 0xB705ED,\x0a"
"0x306529, 0xBF5657, 0x3AFF47, 0xB9F96A, 0xF3BE75, 0xDF9328,\x0a"
"0x3080AB, 0xF68C66, 0x15CB04, 0x0622FA, 0x1DE4D9, 0xA4B33D,\x0a"
"0x8F1B57, 0x09CD36, 0xE9424E, 0xA4BE13, 0xB52333, 0x1AAAF0,\x0a"
"0xA8654F, 0xA5C1D2, 0x0F3F0B, 0xCD785B, 0x76F923, 0x048B7B,\x0a"
"0x721789, 0x53A6C6, 0xE26E6F, 0x00EBEF, 0x584A9B, 0xB7DAC4,\x0a"
"0xBA66AA, 0xCFCF76, 0x1D02D1, 0x2DF1B1, 0xC1998C, 0x77ADC3,\x0a"
"0xDA4886, 0xA05DF7, 0xF480C6, 0x2FF0AC, 0x9AECDD, 0xBC5C3F,\x0a"
"0x6DDED0, 0x1FC790, 0xB6DB2A, 0x3A25A3, 0x9AAF00, 0x9353AD,\x0a"
"0x0457B6, 0xB42D29, 0x7E804B, 0xA707DA, 0x0EAA76, 0xA1597B,\x0a"
"0x2A1216, 0x2DB7DC, 0xFDE5FA, 0xFEDB89, 0xFDBE89, 0x6C76E4,\x0a"
"0xFCA906, 0x70803E, 0x156E85, 0xFF87FD, 0x073E28, 0x336761,\x0a"
"0x86182A, 0xEABD4D, 0xAFE7B3, 0x6E6D8F, 0x396795, 0x5BBF31,\x0a"
"0x48D784, 0x16DF30, 0x432DC7, 0x356125, 0xCE70C9, 0xB8CB30,\x0a"
"0xFD6CBF, 0xA200A4, 0xE46C05, 0xA0DD5A, 0x476F21, 0xD21262,\x0a"
"0x845CB9, 0x496170, 0xE0566B, 0x015299, 0x375550, 0xB7D51E,\x0a"
"0xC4F133, 0x5F6E13, 0xE4305D, 0xA92E85, 0xC3B21D, 0x3632A1,\x0a"
"0xA4B708, 0xD4B1EA, 0x21F716, 0xE4698F, 0x77FF27, 0x80030C,\x0a"
"0x2D408D, 0xA0CD4F, 0x99A520, 0xD3A2B3, 0x0A5D2F, 0x42F9B4,\x0a"
"0xCBDA11, 0xD0BE7D, 0xC1DB9B, 0xBD17AB, 0x81A2CA, 0x5C6A08,\x0a"
"0x17552E, 0x550027, 0xF0147F, 0x8607E1, 0x640B14, 0x8D4196,\x0a"
"0xDEBE87, 0x2AFDDA, 0xB6256B, 0x34897B, 0xFEF305, 0x9EBFB9,\x0a"
"0x4F6A68, 0xA82A4A, 0x5AC44F, 0xBCF82D, 0x985AD7, 0x95C7F4,\x0a"
"0x8D4D0D, 0xA63A20, 0x5F57A4, 0xB13F14, 0x953880, 0x0120CC,\x0a"
"0x86DD71, 0xB6DEC9, 0xF560BF, 0x11654D, 0x6B0701, 0xACB08C,\x0a"
"0xD0C0B2, 0x485551, 0x0EFB1E, 0xC37295, 0x3B06A3, 0x3540C0,\x0a"
"0x7BDC06, 0xCC45E0, 0xFA294E, 0xC8CAD6, 0x41F3E8, 0xDE647C,\x0a"
"0xD8649B, 0x31BED9, 0xC397A4, 0xD45877, 0xC5E369, 0x13DAF0,\x0a"
"0x3C3ABA, 0x461846, 0x5F7555, 0xF5BDD2, 0xC6926E, 0x5D2EAC,\x0a"
"0xED440E, 0x423E1C, 0x87C461, 0xE9FD29, 0xF3D6E7, 0xCA7C22,\x0a"
"0x35916F, 0xC5E008, 0x8DD7FF, 0xE26A6E, 0xC6FDB0, 0xC10893,\x0a"
"0x745D7C, 0xB2AD6B, 0x9D6ECD, 0x7B723E, 0x6A11C6, 0xA9CFF7,\x0a"
"0xDF7329, 0xBAC9B5, 0x5100B7, 0x0DB2E2, 0x24BA74, 0x607DE5,\x0a"
"0x8AD874, 0x2C150D, 0x0C1881, 0x94667E, 0x162901, 0x767A9F,\x0a"
"0xBEFDFD, 0xEF4556, 0x367ED9, 0x13D9EC, 0xB9BA8B, 0xFC97C4,\x0a"
"0x27A831, 0xC36EF1, 0x36C594, 0x56A8D8, 0xB5A8B4, 0x0ECCCF,\x0a"
"0x2D8912, 0x34576F, 0x89562C, 0xE3CE99, 0xB920D6, 0xAA5E6B,\x0a"
"0x9C2A3E, 0xCC5F11, 0x4A0BFD, 0xFBF4E1, 0x6D3B8E, 0x2C86E2,\x0a"
"0x84D4E9, 0xA9B4FC, 0xD1EEEF, 0xC9352E, 0x61392F, 0x442138,\x0a"
"0xC8D91B, 0x0AFC81, 0x6A4AFB, 0xD81C2F, 0x84B453, 0x8C994E,\x0a"
"0xCC2254, 0xDC552A, 0xD6C6C0, 0x96190B, 0xB8701A, 0x649569,\x0a"
"0x605A26, 0xEE523F, 0x0F117F, 0x11B5F4, 0xF5CBFC, 0x2DBC34,\x0a"
"0xEEBC34, 0xCC5DE8, 0x605EDD, 0x9B8E67, 0xEF3392, 0xB817C9,\x0a"
"0x9B5861, 0xBC57E1, 0xC68351, 0x103ED8, 0x4871DD, 0xDD1C2D,\x0a"
"0xA118AF, 0x462C21, 0xD7F359, 0x987AD9, 0xC0549E, 0xFA864F,\x0a"
"0xFC0656, 0xAE79E5, 0x362289, 0x22AD38, 0xDC9367, 0xAAE855,\x0a"
"0x382682, 0x9BE7CA, 0xA40D51, 0xB13399, 0x0ED7A9, 0x480569,\x0a"
"0xF0B265, 0xA7887F, 0x974C88, 0x36D1F9, 0xB39221, 0x4A827B,\x0a"
"0x21CF98, 0xDC9F40, 0x5547DC, 0x3A74E1, 0x42EB67, 0xDF9DFE,\x0a"
"0x5FD45E, 0xA4677B, 0x7AACBA, 0xA2F655, 0x23882B, 0x55BA41,\x0a"
"0x086E59, 0x862A21, 0x834739, 0xE6E389, 0xD49EE5, 0x40FB49,\x0a"
"0xE956FF, 0xCA0F1C, 0x8A59C5, 0x2BFA94, 0xC5C1D3, 0xCFC50F,\x0a"
"0xAE5ADB, 0x86C547, 0x624385, 0x3B8621, 0x94792C, 0x876110,\x0a"
"0x7B4C2A, 0x1A2C80, 0x12BF43, 0x902688, 0x893C78, 0xE4C4A8,\x0a"
"0x7BDBE5, 0xC23AC4, 0xEAF426, 0x8A67F7, 0xBF920D, 0x2BA365,\x0a"
"0xB1933D, 0x0B7CBD, 0xDC51A4, 0x63DD27, 0xDDE169, 0x19949A,\x0a"
"0x9529A8, 0x28CE68, 0xB4ED09, 0x209F44, 0xCA984E, 0x638270,\x0a"
"0x237C7E, 0x32B90F, 0x8EF5A7, 0xE75614, 0x08F121, 0x2A9DB5,\x0a"
"0x4D7E6F, 0x5119A5, 0xABF9B5, 0xD6DF82, 0x61DD96, 0x023616,\x0a"
"0x9F3AC4, 0xA1A283, 0x6DED72, 0x7A8D39, 0xA9B882, 0x5C326B,\x0a"
"0x5B2746, 0xED3400, 0x7700D2, 0x55F4FC, 0x4D5901, 0x8071E0,\x0a"
"#endif\x0a"
"\x0a"
"};\x0a"
"\x0a"
"static const double PIo2\x5b\x5d = {\x0a"
"  1.57079625129699707031e+00, /* 0x3FF921FB, 0x40000000 */\x0a"
"  7.54978941586159635335e-08, /* 0x3E74442D, 0x00000000 */\x0a"
"  5.39030252995776476554e-15, /* 0x3CF84698, 0x80000000 */\x0a"
"  3.28200341580791294123e-22, /* 0x3B78CC51, 0x60000000 */\x0a"
"  1.27065575308067607349e-29, /* 0x39F01B83, 0x80000000 */\x0a"
"  1.22933308981111328932e-36, /* 0x387A2520, 0x40000000 */\x0a"
"  2.73370053816464559624e-44, /* 0x36E38222, 0x80000000 */\x0a"
"  2.16741683877804819444e-51, /* 0x3569F31D, 0x00000000 */\x0a"
"};\x0a"
"\x0a"
"static const double\x09\x09\x09\x0a"
"zero   = 0.0,\x0a"
"one    = 1.0,\x0a"
"two24   =  1.67772160000000000000e+07, /* 0x41700000, 0x00000000 */\x0a"
"twon24  =  5.96046447753906250000e-08; /* 0x3E700000, 0x00000000 */\x0a"
"\x0a"
"int\x0a"
"__kernel_rem_pio2(double *x, double *y, int e0, int nx, int prec)\x0a"
"{\x0a"
"\x09int32_t jz,jx,jv,jp,jk,carry,n,iq\x5b""20\x5d,i,j,k,m,q0,ih;\x0a"
"\x09""double z,fw,f\x5b""20\x5d,fq\x5b""20\x5d,q\x5b""20\x5d;\x0a"
"\x0a"
"    /* initialize jk*/\x0a"
"\x09jk = init_jk\x5bprec\x5d;\x0a"
"\x09jp = jk;\x0a"
"\x0a"
"    /* determine jx,jv,q0, note that 3>q0 */\x0a"
"\x09jx =  nx-1;\x0a"
"\x09jv = (e0-3)/24; if(jv<0) jv=0;\x0a"
"\x09q0 =  e0-24*(jv+1);\x0a"
"\x0a"
"    /* set up f\x5b""0\x5d to f\x5bjx+jk\x5d where f\x5bjx+jk\x5d = ipio2\x5bjv+jk\x5d */\x0a"
"\x09j = jv-jx; m = jx+jk;\x0a"
"\x09""for(i=0;i<=m;i++,j++) f\x5bi\x5d = (j<0)\x3f zero \x3a (double) ipio2\x5bj\x5d;\x0a"
"\x0a"
"    /* compute q\x5b""0\x5d,q\x5b""1\x5d,...q\x5bjk\x5d */\x0a"
"\x09""for (i=0;i<=jk;i++) {\x0a"
"\x09    for(j=0,fw=0.0;j<=jx;j++) fw += x\x5bj\x5d*f\x5bjx+i-j\x5d; q\x5bi\x5d = fw;\x0a"
"\x09}\x0a"
"\x0a"
"\x09jz = jk;\x0a"
"recompute\x3a\x0a"
"    /* distill q\x5b\x5d into iq\x5b\x5d reversingly */\x0a"
"\x09""for(i=0,j=jz,z=q\x5bjz\x5d;j>0;i++,j--) {\x0a"
"\x09    fw    =  (double)((int32_t)(twon24* z));\x0a"
"\x09    iq\x5bi\x5d =  (int32_t)(z-two24*fw);\x0a"
"\x09    z     =  q\x5bj-1\x5d+fw;\x0a"
"\x09}\x0a"
"\x0a"
"    /* compute n */\x0a"
"\x09z  = scalbn(z,q0);\x09\x09/* actual value of z */\x0a"
"\x09z -= 8.0*floor(z*0.125);\x09\x09/* trim off integer >= 8 */\x0a"
"\x09n  = (int32_t) z;\x0a"
"\x09z -= (double)n;\x0a"
"\x09ih = 0;\x0a"
"\x09if(q0>0) {\x09/* need iq\x5bjz-1\x5d to determine n */\x0a"
"\x09    i  = (iq\x5bjz-1\x5d>>(24-q0)); n += i;\x0a"
"\x09    iq\x5bjz-1\x5d -= i<<(24-q0);\x0a"
"\x09    ih = iq\x5bjz-1\x5d>>(23-q0);\x0a"
"\x09} \x0a"
"\x09""else if(q0==0) ih = iq\x5bjz-1\x5d>>23;\x0a"
"\x09""else if(z>=0.5) ih=2;\x0a"
"\x0a"
"\x09if(ih>0) {\x09/* q > 0.5 */\x0a"
"\x09    n += 1; carry = 0;\x0a"
"\x09    for(i=0;i<jz ;i++) {\x09/* compute 1-q */\x0a"
"\x09\x09j = iq\x5bi\x5d;\x0a"
"\x09\x09if(carry==0) {\x0a"
"\x09\x09    if(j\x21=0) {\x0a"
"\x09\x09\x09""carry = 1; iq\x5bi\x5d = 0x1000000- j;\x0a"
"\x09\x09    }\x0a"
"\x09\x09} else  iq\x5bi\x5d = 0xffffff - j;\x0a"
"\x09    }\x0a"
"\x09    if(q0>0) {\x09\x09/* rare case\x3a chance is 1 in 12 */\x0a"
"\x09        switch(q0) {\x0a"
"\x09        case 1\x3a\x0a"
"\x09    \x09   iq\x5bjz-1\x5d \x26= 0x7fffff; break;\x0a"
"\x09    \x09""case 2\x3a\x0a"
"\x09    \x09   iq\x5bjz-1\x5d \x26= 0x3fffff; break;\x0a"
"\x09        }\x0a"
"\x09    }\x0a"
"\x09    if(ih==2) {\x0a"
"\x09\x09z = one - z;\x0a"
"\x09\x09if(carry\x21=0) z -= scalbn(one,q0);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* check if recomputation is needed */\x0a"
"\x09if(z==zero) {\x0a"
"\x09    j = 0;\x0a"
"\x09    for (i=jz-1;i>=jk;i--) j \x7c= iq\x5bi\x5d;\x0a"
"\x09    if(j==0) { /* need recomputation */\x0a"
"\x09\x09""for(k=1;iq\x5bjk-k\x5d==0;k++);   /* k = no. of terms needed */\x0a"
"\x0a"
"\x09\x09""for(i=jz+1;i<=jz+k;i++) {   /* add q\x5bjz+1\x5d to q\x5bjz+k\x5d */\x0a"
"\x09\x09    f\x5bjx+i\x5d = (double) ipio2\x5bjv+i\x5d;\x0a"
"\x09\x09    for(j=0,fw=0.0;j<=jx;j++) fw += x\x5bj\x5d*f\x5bjx+i-j\x5d;\x0a"
"\x09\x09    q\x5bi\x5d = fw;\x0a"
"\x09\x09}\x0a"
"\x09\x09jz += k;\x0a"
"\x09\x09goto recompute;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* chop off zero terms */\x0a"
"\x09if(z==0.0) {\x0a"
"\x09    jz -= 1; q0 -= 24;\x0a"
"\x09    while(iq\x5bjz\x5d==0) { jz--; q0-=24;}\x0a"
"\x09} else { /* break z into 24-bit if necessary */\x0a"
"\x09    z = scalbn(z,-q0);\x0a"
"\x09    if(z>=two24) { \x0a"
"\x09\x09""fw = (double)((int32_t)(twon24*z));\x0a"
"\x09\x09iq\x5bjz\x5d = (int32_t)(z-two24*fw);\x0a"
"\x09\x09jz += 1; q0 += 24;\x0a"
"\x09\x09iq\x5bjz\x5d = (int32_t) fw;\x0a"
"\x09    } else iq\x5bjz\x5d = (int32_t) z ;\x0a"
"\x09}\x0a"
"\x0a"
"    /* convert integer \x22""bit\x22 chunk to floating-point value */\x0a"
"\x09""fw = scalbn(one,q0);\x0a"
"\x09""for(i=jz;i>=0;i--) {\x0a"
"\x09    q\x5bi\x5d = fw*(double)iq\x5bi\x5d; fw*=twon24;\x0a"
"\x09}\x0a"
"\x0a"
"    /* compute PIo2\x5b""0,...,jp\x5d*q\x5bjz,...,0\x5d */\x0a"
"\x09""for(i=jz;i>=0;i--) {\x0a"
"\x09    for(fw=0.0,k=0;k<=jp\x26\x26k<=jz-i;k++) fw += PIo2\x5bk\x5d*q\x5bi+k\x5d;\x0a"
"\x09    fq\x5bjz-i\x5d = fw;\x0a"
"\x09}\x0a"
"\x0a"
"    /* compress fq\x5b\x5d into y\x5b\x5d */\x0a"
"\x09switch(prec) {\x0a"
"\x09    case 0\x3a\x0a"
"\x09\x09""fw = 0.0;\x0a"
"\x09\x09""for (i=jz;i>=0;i--) fw += fq\x5bi\x5d;\x0a"
"\x09\x09y\x5b""0\x5d = (ih==0)\x3f fw\x3a -fw; \x0a"
"\x09\x09""break;\x0a"
"\x09    case 1\x3a\x0a"
"\x09    case 2\x3a\x0a"
"\x09\x09""fw = 0.0;\x0a"
"\x09\x09""for (i=jz;i>=0;i--) fw += fq\x5bi\x5d; \x0a"
"\x09\x09STRICT_ASSIGN(double,fw,fw);\x0a"
"\x09\x09y\x5b""0\x5d = (ih==0)\x3f fw\x3a -fw; \x0a"
"\x09\x09""fw = fq\x5b""0\x5d-fw;\x0a"
"\x09\x09""for (i=1;i<=jz;i++) fw += fq\x5bi\x5d;\x0a"
"\x09\x09y\x5b""1\x5d = (ih==0)\x3f fw\x3a -fw; \x0a"
"\x09\x09""break;\x0a"
"\x09    case 3\x3a\x09/* painful */\x0a"
"\x09\x09""for (i=jz;i>0;i--) {\x0a"
"\x09\x09    fw      = fq\x5bi-1\x5d+fq\x5bi\x5d; \x0a"
"\x09\x09    fq\x5bi\x5d  += fq\x5bi-1\x5d-fw;\x0a"
"\x09\x09    fq\x5bi-1\x5d = fw;\x0a"
"\x09\x09}\x0a"
"\x09\x09""for (i=jz;i>1;i--) {\x0a"
"\x09\x09    fw      = fq\x5bi-1\x5d+fq\x5bi\x5d; \x0a"
"\x09\x09    fq\x5bi\x5d  += fq\x5bi-1\x5d-fw;\x0a"
"\x09\x09    fq\x5bi-1\x5d = fw;\x0a"
"\x09\x09}\x0a"
"\x09\x09""for (fw=0.0,i=jz;i>=2;i--) fw += fq\x5bi\x5d; \x0a"
"\x09\x09if(ih==0) {\x0a"
"\x09\x09    y\x5b""0\x5d =  fq\x5b""0\x5d; y\x5b""1\x5d =  fq\x5b""1\x5d; y\x5b""2\x5d =  fw;\x0a"
"\x09\x09} else {\x0a"
"\x09\x09    y\x5b""0\x5d = -fq\x5b""0\x5d; y\x5b""1\x5d = -fq\x5b""1\x5d; y\x5b""2\x5d = -fw;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09return n\x26""7;\x0a"
"}\x0a"
"", 15557 ); }