#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_k_rem_pio2f_c( 
"/* k_rem_pio2f.c -- float version of k_rem_pio2.c\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/* In the float version, the input parameter x contains 8 bit\x0a"
"   integers, not 24 bit integers.  113 bit precision is not supported.  */\x0a"
"\x0a"
"static const int init_jk\x5b\x5d = {4,7,9}; /* initial value for jk */\x0a"
"\x0a"
"static const float PIo2\x5b\x5d = {\x0a"
"  1.5703125000e+00, /* 0x3fc90000 */\x0a"
"  4.5776367188e-04, /* 0x39f00000 */\x0a"
"  2.5987625122e-05, /* 0x37da0000 */\x0a"
"  7.5437128544e-08, /* 0x33a20000 */\x0a"
"  6.0026650317e-11, /* 0x2e840000 */\x0a"
"  7.3896444519e-13, /* 0x2b500000 */\x0a"
"  5.3845816694e-15, /* 0x27c20000 */\x0a"
"  5.6378512969e-18, /* 0x22d00000 */\x0a"
"  8.3009228831e-20, /* 0x1fc40000 */\x0a"
"  3.2756352257e-22, /* 0x1bc60000 */\x0a"
"  6.3331015649e-25, /* 0x17440000 */\x0a"
"};\x0a"
"\x0a"
"static const float\x09\x09\x09\x0a"
"zero   = 0.0,\x0a"
"one    = 1.0,\x0a"
"two8   =  2.5600000000e+02, /* 0x43800000 */\x0a"
"twon8  =  3.9062500000e-03; /* 0x3b800000 */\x0a"
"\x0a"
"int\x0a"
"__kernel_rem_pio2f(float *x, float *y, int e0, int nx, int prec,\x0a"
"    const int32_t *ipio2) \x0a"
"{\x0a"
"\x09int32_t jz,jx,jv,jp,jk,carry,n,iq\x5b""20\x5d,i,j,k,m,q0,ih;\x0a"
"\x09""float z,fw,f\x5b""20\x5d,fq\x5b""20\x5d,q\x5b""20\x5d;\x0a"
"\x0a"
"    /* initialize jk*/\x0a"
"\x09jk = init_jk\x5bprec\x5d;\x0a"
"\x09jp = jk;\x0a"
"\x0a"
"    /* determine jx,jv,q0, note that 3>q0 */\x0a"
"\x09jx =  nx-1;\x0a"
"\x09jv = (e0-3)/8; if(jv<0) jv=0;\x0a"
"\x09q0 =  e0-8*(jv+1);\x0a"
"\x0a"
"    /* set up f\x5b""0\x5d to f\x5bjx+jk\x5d where f\x5bjx+jk\x5d = ipio2\x5bjv+jk\x5d */\x0a"
"\x09j = jv-jx; m = jx+jk;\x0a"
"\x09""for(i=0;i<=m;i++,j++) f\x5bi\x5d = (j<0)\x3f zero \x3a (float) ipio2\x5bj\x5d;\x0a"
"\x0a"
"    /* compute q\x5b""0\x5d,q\x5b""1\x5d,...q\x5bjk\x5d */\x0a"
"\x09""for (i=0;i<=jk;i++) {\x0a"
"\x09    for(j=0,fw=0.0;j<=jx;j++) fw += x\x5bj\x5d*f\x5bjx+i-j\x5d; q\x5bi\x5d = fw;\x0a"
"\x09}\x0a"
"\x0a"
"\x09jz = jk;\x0a"
"recompute\x3a\x0a"
"    /* distill q\x5b\x5d into iq\x5b\x5d reversingly */\x0a"
"\x09""for(i=0,j=jz,z=q\x5bjz\x5d;j>0;i++,j--) {\x0a"
"\x09    fw    =  (float)((int32_t)(twon8* z));\x0a"
"\x09    iq\x5bi\x5d =  (int32_t)(z-two8*fw);\x0a"
"\x09    z     =  q\x5bj-1\x5d+fw;\x0a"
"\x09}\x0a"
"\x0a"
"    /* compute n */\x0a"
"\x09z  = scalbnf(z,q0);\x09\x09/* actual value of z */\x0a"
"\x09z -= (float)8.0*floorf(z*(float)0.125);\x09/* trim off integer >= 8 */\x0a"
"\x09n  = (int32_t) z;\x0a"
"\x09z -= (float)n;\x0a"
"\x09ih = 0;\x0a"
"\x09if(q0>0) {\x09/* need iq\x5bjz-1\x5d to determine n */\x0a"
"\x09    i  = (iq\x5bjz-1\x5d>>(8-q0)); n += i;\x0a"
"\x09    iq\x5bjz-1\x5d -= i<<(8-q0);\x0a"
"\x09    ih = iq\x5bjz-1\x5d>>(7-q0);\x0a"
"\x09} \x0a"
"\x09""else if(q0==0) ih = iq\x5bjz-1\x5d>>8;\x0a"
"\x09""else if(z>=(float)0.5) ih=2;\x0a"
"\x0a"
"\x09if(ih>0) {\x09/* q > 0.5 */\x0a"
"\x09    n += 1; carry = 0;\x0a"
"\x09    for(i=0;i<jz ;i++) {\x09/* compute 1-q */\x0a"
"\x09\x09j = iq\x5bi\x5d;\x0a"
"\x09\x09if(carry==0) {\x0a"
"\x09\x09    if(j\x21=0) {\x0a"
"\x09\x09\x09""carry = 1; iq\x5bi\x5d = 0x100- j;\x0a"
"\x09\x09    }\x0a"
"\x09\x09} else  iq\x5bi\x5d = 0xff - j;\x0a"
"\x09    }\x0a"
"\x09    if(q0>0) {\x09\x09/* rare case\x3a chance is 1 in 12 */\x0a"
"\x09        switch(q0) {\x0a"
"\x09        case 1\x3a\x0a"
"\x09    \x09   iq\x5bjz-1\x5d \x26= 0x7f; break;\x0a"
"\x09    \x09""case 2\x3a\x0a"
"\x09    \x09   iq\x5bjz-1\x5d \x26= 0x3f; break;\x0a"
"\x09        }\x0a"
"\x09    }\x0a"
"\x09    if(ih==2) {\x0a"
"\x09\x09z = one - z;\x0a"
"\x09\x09if(carry\x21=0) z -= scalbnf(one,q0);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* check if recomputation is needed */\x0a"
"\x09if(z==zero) {\x0a"
"\x09    j = 0;\x0a"
"\x09    for (i=jz-1;i>=jk;i--) j \x7c= iq\x5bi\x5d;\x0a"
"\x09    if(j==0) { /* need recomputation */\x0a"
"\x09\x09""for(k=1;iq\x5bjk-k\x5d==0;k++);   /* k = no. of terms needed */\x0a"
"\x0a"
"\x09\x09""for(i=jz+1;i<=jz+k;i++) {   /* add q\x5bjz+1\x5d to q\x5bjz+k\x5d */\x0a"
"\x09\x09    f\x5bjx+i\x5d = (float) ipio2\x5bjv+i\x5d;\x0a"
"\x09\x09    for(j=0,fw=0.0;j<=jx;j++) fw += x\x5bj\x5d*f\x5bjx+i-j\x5d;\x0a"
"\x09\x09    q\x5bi\x5d = fw;\x0a"
"\x09\x09}\x0a"
"\x09\x09jz += k;\x0a"
"\x09\x09goto recompute;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* chop off zero terms */\x0a"
"\x09if(z==(float)0.0) {\x0a"
"\x09    jz -= 1; q0 -= 8;\x0a"
"\x09    while(iq\x5bjz\x5d==0) { jz--; q0-=8;}\x0a"
"\x09} else { /* break z into 8-bit if necessary */\x0a"
"\x09    z = scalbnf(z,-q0);\x0a"
"\x09    if(z>=two8) { \x0a"
"\x09\x09""fw = (float)((int32_t)(twon8*z));\x0a"
"\x09\x09iq\x5bjz\x5d = (int32_t)(z-two8*fw);\x0a"
"\x09\x09jz += 1; q0 += 8;\x0a"
"\x09\x09iq\x5bjz\x5d = (int32_t) fw;\x0a"
"\x09    } else iq\x5bjz\x5d = (int32_t) z ;\x0a"
"\x09}\x0a"
"\x0a"
"    /* convert integer \x22""bit\x22 chunk to floating-point value */\x0a"
"\x09""fw = scalbnf(one,q0);\x0a"
"\x09""for(i=jz;i>=0;i--) {\x0a"
"\x09    q\x5bi\x5d = fw*(float)iq\x5bi\x5d; fw*=twon8;\x0a"
"\x09}\x0a"
"\x0a"
"    /* compute PIo2\x5b""0,...,jp\x5d*q\x5bjz,...,0\x5d */\x0a"
"\x09""for(i=jz;i>=0;i--) {\x0a"
"\x09    for(fw=0.0,k=0;k<=jp\x26\x26k<=jz-i;k++) fw += PIo2\x5bk\x5d*q\x5bi+k\x5d;\x0a"
"\x09    fq\x5bjz-i\x5d = fw;\x0a"
"\x09}\x0a"
"\x0a"
"    /* compress fq\x5b\x5d into y\x5b\x5d */\x0a"
"\x09switch(prec) {\x0a"
"\x09    case 0\x3a\x0a"
"\x09\x09""fw = 0.0;\x0a"
"\x09\x09""for (i=jz;i>=0;i--) fw += fq\x5bi\x5d;\x0a"
"\x09\x09y\x5b""0\x5d = (ih==0)\x3f fw\x3a -fw; \x0a"
"\x09\x09""break;\x0a"
"\x09    case 1\x3a\x0a"
"\x09    case 2\x3a\x0a"
"\x09\x09""fw = 0.0;\x0a"
"\x09\x09""for (i=jz;i>=0;i--) fw += fq\x5bi\x5d; \x0a"
"\x09\x09y\x5b""0\x5d = (ih==0)\x3f fw\x3a -fw; \x0a"
"\x09\x09""fw = fq\x5b""0\x5d-fw;\x0a"
"\x09\x09""for (i=1;i<=jz;i++) fw += fq\x5bi\x5d;\x0a"
"\x09\x09y\x5b""1\x5d = (ih==0)\x3f fw\x3a -fw; \x0a"
"\x09\x09""break;\x0a"
"\x09    case 3\x3a\x09/* painful */\x0a"
"\x09\x09""for (i=jz;i>0;i--) {\x0a"
"\x09\x09    fw      = fq\x5bi-1\x5d+fq\x5bi\x5d; \x0a"
"\x09\x09    fq\x5bi\x5d  += fq\x5bi-1\x5d-fw;\x0a"
"\x09\x09    fq\x5bi-1\x5d = fw;\x0a"
"\x09\x09}\x0a"
"\x09\x09""for (i=jz;i>1;i--) {\x0a"
"\x09\x09    fw      = fq\x5bi-1\x5d+fq\x5bi\x5d; \x0a"
"\x09\x09    fq\x5bi\x5d  += fq\x5bi-1\x5d-fw;\x0a"
"\x09\x09    fq\x5bi-1\x5d = fw;\x0a"
"\x09\x09}\x0a"
"\x09\x09""for (fw=0.0,i=jz;i>=2;i--) fw += fq\x5bi\x5d; \x0a"
"\x09\x09if(ih==0) {\x0a"
"\x09\x09    y\x5b""0\x5d =  fq\x5b""0\x5d; y\x5b""1\x5d =  fq\x5b""1\x5d; y\x5b""2\x5d =  fw;\x0a"
"\x09\x09} else {\x0a"
"\x09\x09    y\x5b""0\x5d = -fq\x5b""0\x5d; y\x5b""1\x5d = -fq\x5b""1\x5d; y\x5b""2\x5d = -fw;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09return n\x26""7;\x0a"
"}\x0a"
"", 4908 ); }