#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_k_sin_c( 
"/* \x40(#)k_sin.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* __kernel_sin( x, y, iy)\x0a"
" * kernel sin function on \x5b-pi/4, pi/4\x5d, pi/4 \x7e 0.7854\x0a"
" * Input x is assumed to be bounded by \x7epi/4 in magnitude.\x0a"
" * Input y is the tail of x.\x0a"
" * Input iy indicates whether y is 0. (if iy=0, y assume to be 0). \x0a"
" *\x0a"
" * Algorithm\x0a"
" *\x09""1. Since sin(-x) = -sin(x), we need only to consider positive x. \x0a"
" *\x09""2. if x < 2^-27 (hx<0x3e400000 0), return x with inexact if x\x21=0.\x0a"
" *\x09""3. sin(x) is approximated by a polynomial of degree 13 on\x0a"
" *\x09   \x5b""0,pi/4\x5d\x0a"
" *\x09\x09  \x09         3            13\x0a"
" *\x09   \x09sin(x) \x7e x + S1*x + ... + S6*x\x0a"
" *\x09   where\x0a"
" *\x09\x0a"
" * \x09\x7csin(x)         2     4     6     8     10     12  \x7c     -58\x0a"
" * \x09\x7c----- - (1+S1*x +S2*x +S3*x +S4*x +S5*x  +S6*x   )\x7c <= 2\x0a"
" * \x09\x7c  x \x09\x09\x09\x09\x09           \x7c \x0a"
" * \x0a"
" *\x09""4. sin(x+y) = sin(x) + sin'(x')*y\x0a"
" *\x09\x09    \x7e sin(x) + (1-x*x/2)*y\x0a"
" *\x09   For better accuracy, let \x0a"
" *\x09\x09     3      2      2      2      2\x0a"
" *\x09\x09r = x *(S2+x *(S3+x *(S4+x *(S5+x *S6))))\x0a"
" *\x09   then                   3    2\x0a"
" *\x09\x09sin(x) = x + (S1*x + (x *(r-y/2)+y))\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double \x0a"
"half =  5.00000000000000000000e-01, /* 0x3FE00000, 0x00000000 */\x0a"
"S1  = -1.66666666666666324348e-01, /* 0xBFC55555, 0x55555549 */\x0a"
"S2  =  8.33333333332248946124e-03, /* 0x3F811111, 0x1110F8A6 */\x0a"
"S3  = -1.98412698298579493134e-04, /* 0xBF2A01A0, 0x19C161D5 */\x0a"
"S4  =  2.75573137070700676789e-06, /* 0x3EC71DE3, 0x57B1FE7D */\x0a"
"S5  = -2.50507602534068634195e-08, /* 0xBE5AE5E6, 0x8A2B9CEB */\x0a"
"S6  =  1.58969099521155010221e-10; /* 0x3DE5D93A, 0x5ACFD57C */\x0a"
"\x0a"
"double\x0a"
"__kernel_sin(double x, double y, int iy)\x0a"
"{\x0a"
"\x09""double z,r,v;\x0a"
"\x09int32_t ix;\x0a"
"\x09GET_HIGH_WORD(ix,x);\x0a"
"\x09ix \x26= 0x7fffffff;\x09\x09\x09/* high word of x */\x0a"
"\x09if(ix<0x3e400000)\x09\x09\x09/* \x7cx\x7c < 2**-27 */\x0a"
"\x09   {if((int)x==0) return x;}\x09\x09/* generate inexact */\x0a"
"\x09z\x09=  x*x;\x0a"
"\x09v\x09=  z*x;\x0a"
"\x09r\x09=  S2+z*(S3+z*(S4+z*(S5+z*S6)));\x0a"
"\x09if(iy==0) return x+v*(S1+z*r);\x0a"
"\x09""else      return x-((z*(half*y-v*r)-y)-v*S1);\x0a"
"}\x0a"
"", 2284 ); }