#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_k_tanf_c( 
"/* k_tanf.c -- float version of k_tan.c\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const float \x0a"
"one   =  1.0000000000e+00, /* 0x3f800000 */\x0a"
"pio4  =  7.8539812565e-01, /* 0x3f490fda */\x0a"
"pio4lo=  3.7748947079e-08, /* 0x33222168 */\x0a"
"T\x5b\x5d =  {\x0a"
"  3.3333334327e-01, /* 0x3eaaaaab */\x0a"
"  1.3333334029e-01, /* 0x3e088889 */\x0a"
"  5.3968254477e-02, /* 0x3d5d0dd1 */\x0a"
"  2.1869488060e-02, /* 0x3cb327a4 */\x0a"
"  8.8632395491e-03, /* 0x3c11371f */\x0a"
"  3.5920790397e-03, /* 0x3b6b6916 */\x0a"
"  1.4562094584e-03, /* 0x3abede48 */\x0a"
"  5.8804126456e-04, /* 0x3a1a26c8 */\x0a"
"  2.4646313977e-04, /* 0x398137b9 */\x0a"
"  7.8179444245e-05, /* 0x38a3f445 */\x0a"
"  7.1407252108e-05, /* 0x3895c07a */\x0a"
" -1.8558637748e-05, /* 0xb79bae5f */\x0a"
"  2.5907305826e-05, /* 0x37d95384 */\x0a"
"};\x0a"
"\x0a"
"float\x0a"
"__kernel_tanf(float x, float y, int iy)\x0a"
"{\x0a"
"\x09""float z,r,v,w,s;\x0a"
"\x09int32_t ix,hx;\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x09/* high word of \x7cx\x7c */\x0a"
"\x09if(ix<0x31800000)\x09\x09\x09/* x < 2**-28 */\x0a"
"\x09    {if((int)x==0) {\x09\x09\x09/* generate inexact */\x0a"
"\x09\x09if((ix\x7c(iy+1))==0) return one/fabsf(x);\x0a"
"\x09\x09""else return (iy==1)\x3f x\x3a -one/x;\x0a"
"\x09    }\x0a"
"\x09    }\x0a"
"\x09if(ix>=0x3f2ca140) { \x09\x09\x09/* \x7cx\x7c>=0.6744 */\x0a"
"\x09    if(hx<0) {x = -x; y = -y;}\x0a"
"\x09    z = pio4-x;\x0a"
"\x09    w = pio4lo-y;\x0a"
"\x09    x = z+w; y = 0.0;\x0a"
"\x09}\x0a"
"\x09z\x09=  x*x;\x0a"
"\x09w \x09=  z*z;\x0a"
"    /* Break x^5*(T\x5b""1\x5d+x^2*T\x5b""2\x5d+...) into\x0a"
"     *\x09  x^5(T\x5b""1\x5d+x^4*T\x5b""3\x5d+...+x^20*T\x5b""11\x5d) +\x0a"
"     *\x09  x^5(x^2*(T\x5b""2\x5d+x^4*T\x5b""4\x5d+...+x^22*\x5bT12\x5d))\x0a"
"     */\x0a"
"\x09r = T\x5b""1\x5d+w*(T\x5b""3\x5d+w*(T\x5b""5\x5d+w*(T\x5b""7\x5d+w*(T\x5b""9\x5d+w*T\x5b""11\x5d))));\x0a"
"\x09v = z*(T\x5b""2\x5d+w*(T\x5b""4\x5d+w*(T\x5b""6\x5d+w*(T\x5b""8\x5d+w*(T\x5b""10\x5d+w*T\x5b""12\x5d)))));\x0a"
"\x09s = z*x;\x0a"
"\x09r = y + z*(s*(r+v)+y);\x0a"
"\x09r += T\x5b""0\x5d*s;\x0a"
"\x09w = x+r;\x0a"
"\x09if(ix>=0x3f2ca140) {\x0a"
"\x09    v = (float)iy;\x0a"
"\x09    return (float)(1-((hx>>30)\x26""2))*(v-(float)2.0*(x-(w*w/(w+v)-r)));\x0a"
"\x09}\x0a"
"\x09if(iy==1) return w;\x0a"
"\x09""else {\x09\x09/* if allow error up to 2 ulp, \x0a"
"\x09\x09\x09   simply return -1.0/(x+r) here */\x0a"
"     /*  compute -1.0/(x+r) accurately */\x0a"
"\x09    float a,t;\x0a"
"\x09    int32_t i;\x0a"
"\x09    z  = w;\x0a"
"\x09    GET_FLOAT_WORD(i,z);\x0a"
"\x09    SET_FLOAT_WORD(z,i\x26""0xfffff000);\x0a"
"\x09    v  = r-(z - x); \x09/* z+v = r+x */\x0a"
"\x09    t = a  = -(float)1.0/w;\x09/* a = -1.0/w */\x0a"
"\x09    GET_FLOAT_WORD(i,t);\x0a"
"\x09    SET_FLOAT_WORD(t,i\x26""0xfffff000);\x0a"
"\x09    s  = (float)1.0+t*z;\x0a"
"\x09    return t+a*(s+t*v);\x0a"
"\x09}\x0a"
"}\x0a"
"", 2564 ); }