#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_e_atanhl_c( 
"/* \x40(#)e_atanh.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice\x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* atanhl(x)\x0a"
" * Method \x3a\x0a"
" *    1.Reduced x to positive by atanh(-x) = -atanh(x)\x0a"
" *    2.For x>=0.5\x0a"
" *                   1              2x                          x\x0a"
" *\x09""atanhl(x) = --- * log(1 + -------) = 0.5 * log1p(2 * --------)\x0a"
" *                   2             1 - x                      1 - x\x0a"
" *\x0a"
" * \x09""For x<0.5\x0a"
" *\x09""atanhl(x) = 0.5*log1pl(2x+2x*x/(1-x))\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09""atanhl(x) is NaN if \x7cx\x7c > 1 with signal;\x0a"
" *\x09""atanhl(NaN) is that NaN with no signal;\x0a"
" *\x09""atanhl(+-1) is +-INF with signal.\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const long double one = 1.0, huge = 1e4900L;\x0a"
"\x0a"
"static const long double zero = 0.0;\x0a"
"\x0a"
"long double\x0a"
"atanhl(long double x)\x0a"
"{\x0a"
"\x09long double t;\x0a"
"\x09int32_t ix;\x0a"
"\x09u_int32_t se,i0,i1;\x0a"
"\x09GET_LDOUBLE_WORDS(se,i0,i1,x);\x0a"
"\x09ix = se\x26""0x7fff;\x0a"
"\x09if ((ix+((((i0\x26""0x7fffffff)\x7ci1)\x7c(-((i0\x26""0x7fffffff)\x7ci1)))>>31))>0x3fff)\x0a"
"\x09  /* \x7cx\x7c>1 */\x0a"
"\x09    return (x-x)/(x-x);\x0a"
"\x09if(ix==0x3fff)\x0a"
"\x09    return x/zero;\x0a"
"\x09if(ix<0x3fe3\x26\x26(huge+x)>zero) return x;\x09/* x<2**-28 */\x0a"
"\x09SET_LDOUBLE_EXP(x,ix);\x0a"
"\x09if(ix<0x3ffe) {\x09\x09/* x < 0.5 */\x0a"
"\x09    t = x+x;\x0a"
"\x09    t = 0.5*log1pl(t+t*x/(one-x));\x0a"
"\x09} else\x0a"
"\x09    t = 0.5*log1pl((x+x)/(one-x));\x0a"
"\x09if(se<=0x7fff) return t; else return -t;\x0a"
"}\x0a"
"", 1592 ); }