#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_e_coshl_c( 
"/* \x40(#)e_cosh.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice\x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* coshl(x)\x0a"
" * Method \x3a\x0a"
" * mathematically coshl(x) if defined to be (exp(x)+exp(-x))/2\x0a"
" *\x09""1. Replace x by \x7cx\x7c (coshl(x) = coshl(-x)).\x0a"
" *\x09""2.\x0a"
" *\x09\x09                                        \x5b exp(x) - 1 \x5d^2\x0a"
" *\x09    0        <= x <= ln2/2  \x3a  coshl(x) \x3a= 1 + -------------------\x0a"
" *\x09\x09\x09       \x09\x09\x09           2*exp(x)\x0a"
" *\x0a"
" *\x09\x09                                   exp(x) +  1/exp(x)\x0a"
" *\x09    ln2/2    <= x <= 22     \x3a  coshl(x) \x3a= -------------------\x0a"
" *\x09\x09\x09       \x09\x09\x09           2\x0a"
" *\x09    22       <= x <= lnovft \x3a  coshl(x) \x3a= expl(x)/2\x0a"
" *\x09    lnovft   <= x <= ln2ovft\x3a  coshl(x) \x3a= expl(x/2)/2 * expl(x/2)\x0a"
" *\x09    ln2ovft  <  x\x09    \x3a  coshl(x) \x3a= huge*huge (overflow)\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09""coshl(x) is \x7cx\x7c if x is +INF, -INF, or NaN.\x0a"
" *\x09only coshl(0)=1 is exact for finite x.\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const long double one = 1.0, half=0.5, huge = 1.0e4900L;\x0a"
"\x0a"
"long double\x0a"
"coshl(long double x)\x0a"
"{\x0a"
"\x09long double t,w;\x0a"
"\x09int32_t ex;\x0a"
"\x09u_int32_t mx,lx;\x0a"
"\x0a"
"    /* High word of \x7cx\x7c. */\x0a"
"\x09GET_LDOUBLE_WORDS(ex,mx,lx,x);\x0a"
"\x09""ex \x26= 0x7fff;\x0a"
"\x0a"
"    /* x is INF or NaN */\x0a"
"\x09if(ex==0x7fff) return x*x;\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5b""0,0.5*ln2\x5d, return 1+expm1l(\x7cx\x7c)^2/(2*expl(\x7cx\x7c)) */\x0a"
"\x09if(ex < 0x3ffd \x7c\x7c (ex == 0x3ffd \x26\x26 mx < 0xb17217f7u)) {\x0a"
"\x09    t = expm1l(fabsl(x));\x0a"
"\x09    w = one+t;\x0a"
"\x09    if (ex<0x3fbc) return w;\x09/* cosh(tiny) = 1 */\x0a"
"\x09    return one+(t*t)/(w+w);\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5b""0.5*ln2,22\x5d, return (exp(\x7cx\x7c)+1/exp(\x7cx\x7c)/2; */\x0a"
"\x09if (ex < 0x4003 \x7c\x7c (ex == 0x4003 \x26\x26 mx < 0xb0000000u)) {\x0a"
"\x09\x09t = expl(fabsl(x));\x0a"
"\x09\x09return half*t+half/t;\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5b""22, ln(maxdouble)\x5d return half*exp(\x7cx\x7c) */\x0a"
"\x09if (ex < 0x400c \x7c\x7c (ex == 0x400c \x26\x26 mx < 0xb1700000u))\x0a"
"\x09\x09return half*expl(fabsl(x));\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5blog(maxdouble), log(2*maxdouble)) */\x0a"
"\x09if (ex == 0x400c \x26\x26 (mx < 0xb174ddc0u\x0a"
"\x09\x09\x09     \x7c\x7c (mx == 0xb174ddc0u \x26\x26 lx < 0x31aec0ebu)))\x0a"
"\x09{\x0a"
"\x09    w = expl(half*fabsl(x));\x0a"
"\x09    t = half*w;\x0a"
"\x09    return t*w;\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c >= log(2*maxdouble), cosh(x) overflow */\x0a"
"\x09return huge*huge;\x0a"
"}\x0a"
"", 2356 ); }