#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_e_fmodl_c( 
"/* \x40(#)e_fmod.c 1.3 95/01/18 */\x0a"
"/*-\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunSoft, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include <sys/types.h>\x0a"
"#include <machine/ieee.h>\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"#define\x09""BIAS (LDBL_MAX_EXP - 1)\x0a"
"\x0a"
"/*\x0a"
" * These macros add and remove an explicit integer bit in front of the\x0a"
" * fractional mantissa, if the architecture doesn't have such a bit by\x0a"
" * default already.\x0a"
" */\x0a"
"#ifdef LDBL_IMPLICIT_NBIT\x0a"
"#define\x09LDBL_NBIT\x09""0\x0a"
"#define\x09SET_NBIT(hx)\x09((hx) \x7c (1ULL << LDBL_MANH_SIZE))\x0a"
"#define\x09HFRAC_BITS\x09""EXT_FRACHBITS\x0a"
"#else\x0a"
"#define\x09LDBL_NBIT\x09""0x80000000\x0a"
"#define\x09SET_NBIT(hx)\x09(hx)\x0a"
"#define\x09HFRAC_BITS\x09(EXT_FRACHBITS - 1)\x0a"
"#endif\x0a"
"\x0a"
"#define\x09MANL_SHIFT\x09(EXT_FRACLBITS - 1)\x0a"
"\x0a"
"static const long double one = 1.0, Zero\x5b\x5d = {0.0, -0.0,};\x0a"
"\x0a"
"/*\x0a"
" * fmodl(x,y)\x0a"
" * Return x mod y in exact arithmetic\x0a"
" * Method\x3a shift and subtract\x0a"
" *\x0a"
" * Assumptions\x3a\x0a"
" * - The low part of the mantissa fits in a manl_t exactly.\x0a"
" * - The high part of the mantissa fits in an int64_t with enough room\x0a"
" *   for an explicit integer bit in front of the fractional bits.\x0a"
" */\x0a"
"long double\x0a"
"fmodl(long double x, long double y)\x0a"
"{\x0a"
"\x09union {\x0a"
"\x09\x09long double e;\x0a"
"\x09\x09struct ieee_ext bits;\x0a"
"\x09} ux, uy;\x0a"
"\x09int64_t hx,hz;\x09/* We need a carry bit even if LDBL_MANH_SIZE is 32. */\x0a"
"\x09uint32_t hy;\x0a"
"\x09uint32_t lx,ly,lz;\x0a"
"\x09int ix,iy,n,sx;\x0a"
"\x0a"
"\x09ux.e = x;\x0a"
"\x09uy.e = y;\x0a"
"\x09sx = ux.bits.ext_sign;\x0a"
"\x0a"
"    /* purge off exception values */\x0a"
"\x09if((uy.bits.ext_exp\x7cuy.bits.ext_frach\x7cuy.bits.ext_fracl)==0 \x7c\x7c /* y=0 */\x0a"
"\x09   (ux.bits.ext_exp == BIAS + LDBL_MAX_EXP) \x7c\x7c\x09 /* or x not finite */\x0a"
"\x09   (uy.bits.ext_exp == BIAS + LDBL_MAX_EXP \x26\x26\x0a"
"\x09    ((uy.bits.ext_frach\x26\x7eLDBL_NBIT)\x7cuy.bits.ext_fracl)\x21=0)) /* or y is NaN */\x0a"
"\x09    return (x*y)/(x*y);\x0a"
"\x09if(ux.bits.ext_exp<=uy.bits.ext_exp) {\x0a"
"\x09    if((ux.bits.ext_exp<uy.bits.ext_exp) \x7c\x7c\x0a"
"\x09       (ux.bits.ext_frach<=uy.bits.ext_frach \x26\x26\x0a"
"\x09\x09(ux.bits.ext_frach<uy.bits.ext_frach \x7c\x7c\x0a"
"\x09\x09 ux.bits.ext_fracl<uy.bits.ext_fracl))) {\x0a"
"\x09\x09return x;\x09\x09/* \x7cx\x7c<\x7cy\x7c return x or x-y */\x0a"
"\x09    }\x0a"
"\x09    if(ux.bits.ext_frach==uy.bits.ext_frach \x26\x26\x0a"
"\x09\x09ux.bits.ext_fracl==uy.bits.ext_fracl) {\x0a"
"\x09\x09return Zero\x5bsx\x5d;\x09/* \x7cx\x7c=\x7cy\x7c return x*0*/\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* determine ix = ilogb(x) */\x0a"
"\x09if(ux.bits.ext_exp == 0) {\x09/* subnormal x */\x0a"
"\x09    ux.e *= 0x1.0p512;\x0a"
"\x09    ix = ux.bits.ext_exp - (BIAS + 512);\x0a"
"\x09} else {\x0a"
"\x09    ix = ux.bits.ext_exp - BIAS;\x0a"
"\x09}\x0a"
"\x0a"
"    /* determine iy = ilogb(y) */\x0a"
"\x09if(uy.bits.ext_exp == 0) {\x09/* subnormal y */\x0a"
"\x09    uy.e *= 0x1.0p512;\x0a"
"\x09    iy = uy.bits.ext_exp - (BIAS + 512);\x0a"
"\x09} else {\x0a"
"\x09    iy = uy.bits.ext_exp - BIAS;\x0a"
"\x09}\x0a"
"\x0a"
"    /* set up {hx,lx}, {hy,ly} and align y to x */\x0a"
"\x09hx = SET_NBIT(ux.bits.ext_frach);\x0a"
"\x09hy = SET_NBIT(uy.bits.ext_frach);\x0a"
"\x09lx = ux.bits.ext_fracl;\x0a"
"\x09ly = uy.bits.ext_fracl;\x0a"
"\x0a"
"    /* fix point fmod */\x0a"
"\x09n = ix - iy;\x0a"
"\x0a"
"\x09while(n--) {\x0a"
"\x09    hz=hx-hy;lz=lx-ly; if(lx<ly) hz -= 1;\x0a"
"\x09    if(hz<0){hx = hx+hx+(lx>>MANL_SHIFT); lx = lx+lx;}\x0a"
"\x09    else {\x0a"
"\x09\x09if ((hz\x7clz)==0)\x09\x09/* return sign(x)*0 */\x0a"
"\x09\x09    return Zero\x5bsx\x5d;\x0a"
"\x09\x09hx = hz+hz+(lz>>MANL_SHIFT); lx = lz+lz;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09hz=hx-hy;lz=lx-ly; if(lx<ly) hz -= 1;\x0a"
"\x09if(hz>=0) {hx=hz;lx=lz;}\x0a"
"\x0a"
"    /* convert back to floating value and restore the sign */\x0a"
"\x09if((hx\x7clx)==0)\x09\x09\x09/* return sign(x)*0 */\x0a"
"\x09    return Zero\x5bsx\x5d;\x0a"
"\x09while(hx<(1ULL<<HFRAC_BITS)) {\x09/* normalize x */\x0a"
"\x09    hx = hx+hx+(lx>>MANL_SHIFT); lx = lx+lx;\x0a"
"\x09    iy -= 1;\x0a"
"\x09}\x0a"
"\x09ux.bits.ext_frach = hx; /* The mantissa is truncated here if needed. */\x0a"
"\x09ux.bits.ext_fracl = lx;\x0a"
"\x09if (iy < LDBL_MIN_EXP) {\x0a"
"\x09    ux.bits.ext_exp = iy + (BIAS + 512);\x0a"
"\x09    ux.e *= 0x1p-512;\x0a"
"\x09} else {\x0a"
"\x09    ux.bits.ext_exp = iy + BIAS;\x0a"
"\x09}\x0a"
"\x09x = ux.e * one;\x09\x09/* create necessary signal */\x0a"
"\x09return x;\x09\x09/* exact output */\x0a"
"}\x0a"
"", 3893 ); }