#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_e_hypotl_c( 
"/* \x40(#)e_hypot.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice\x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* hypotl(x,y)\x0a"
" *\x0a"
" * Method \x3a\x0a"
" *\x09If (assume round-to-nearest) z=x*x+y*y\x0a"
" *\x09has error less than sqrt(2)/2 ulp, than\x0a"
" *\x09sqrt(z) has error less than 1 ulp (exercise).\x0a"
" *\x0a"
" *\x09So, compute sqrt(x*x+y*y) with some care as\x0a"
" *\x09""follows to get the error below 1 ulp\x3a\x0a"
" *\x0a"
" *\x09""Assume x>y>0;\x0a"
" *\x09(if possible, set rounding to round-to-nearest)\x0a"
" *\x09""1. if x > 2y  use\x0a"
" *\x09\x09x1*x1+(y*y+(x2*(x+x1))) for x*x+y*y\x0a"
" *\x09where x1 = x with lower 32 bits cleared, x2 = x-x1; else\x0a"
" *\x09""2. if x <= 2y use\x0a"
" *\x09\x09t1*yy1+((x-y)*(x-y)+(t1*y2+t2*y))\x0a"
" *\x09where t1 = 2x with lower 32 bits cleared, t2 = 2x-t1,\x0a"
" *\x09yy1= y with lower 32 bits chopped, y2 = y-yy1.\x0a"
" *\x0a"
" *\x09NOTE\x3a scaling may be necessary if some argument is too\x0a"
" *\x09      large or too tiny\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09hypot(x,y) is INF if x or y is +INF or -INF; else\x0a"
" *\x09hypot(x,y) is NAN if x or y is NAN.\x0a"
" *\x0a"
" * Accuracy\x3a\x0a"
" * \x09hypot(x,y) returns sqrt(x^2+y^2) with error less\x0a"
" * \x09than 1 ulps (units in the last place)\x0a"
" */\x0a"
"\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"long double\x0a"
"hypotl(long double x, long double y)\x0a"
"{\x0a"
"\x09long double a,b,t1,t2,yy1,y2,w;\x0a"
"\x09u_int32_t j,k,ea,eb;\x0a"
"\x0a"
"\x09GET_LDOUBLE_EXP(ea,x);\x0a"
"\x09""ea \x26= 0x7fff;\x0a"
"\x09GET_LDOUBLE_EXP(eb,y);\x0a"
"\x09""eb \x26= 0x7fff;\x0a"
"\x09if(eb > ea) {a=y;b=x;j=ea; ea=eb;eb=j;} else {a=x;b=y;}\x0a"
"\x09SET_LDOUBLE_EXP(a,ea);\x09/* a <- \x7c""a\x7c */\x0a"
"\x09SET_LDOUBLE_EXP(b,eb);\x09/* b <- \x7c""b\x7c */\x0a"
"\x09if((ea-eb)>0x46) {return a+b;} /* x/y > 2**70 */\x0a"
"\x09k=0;\x0a"
"\x09if(ea > 0x5f3f) {\x09/* a>2**8000 */\x0a"
"\x09   if(ea == 0x7fff) {\x09/* Inf or NaN */\x0a"
"\x09       u_int32_t es,high,low;\x0a"
"\x09       w = a+b;\x09\x09\x09/* for sNaN */\x0a"
"\x09       GET_LDOUBLE_WORDS(es,high,low,a);\x0a"
"\x09       if(((high\x26""0x7fffffff)\x7clow)==0) w = a;\x0a"
"\x09       GET_LDOUBLE_WORDS(es,high,low,b);\x0a"
"\x09       if(((eb^0x7fff)\x7c(high\x26""0x7fffffff)\x7clow)==0) w = b;\x0a"
"\x09       return w;\x0a"
"\x09   }\x0a"
"\x09   /* scale a and b by 2**-9600 */\x0a"
"\x09   ea -= 0x2580; eb -= 0x2580;\x09k += 9600;\x0a"
"\x09   SET_LDOUBLE_EXP(a,ea);\x0a"
"\x09   SET_LDOUBLE_EXP(b,eb);\x0a"
"\x09}\x0a"
"\x09if(eb < 0x20bf) {\x09/* b < 2**-8000 */\x0a"
"\x09    if(eb == 0) {\x09/* subnormal b or 0 */\x0a"
"\x09\x09u_int32_t es,high,low;\x0a"
"\x09\x09GET_LDOUBLE_WORDS(es,high,low,b);\x0a"
"\x09\x09if((high\x7clow)==0) return a;\x0a"
"\x09\x09SET_LDOUBLE_WORDS(t1, 0x7ffd, 0, 0);\x09/* t1=2^16382 */\x0a"
"\x09\x09""b *= t1;\x0a"
"\x09\x09""a *= t1;\x0a"
"\x09\x09k -= 16382;\x0a"
"\x09    } else {\x09\x09/* scale a and b by 2^9600 */\x0a"
"\x09\x09""ea += 0x2580;\x09/* a *= 2^9600 */\x0a"
"\x09\x09""eb += 0x2580;\x09/* b *= 2^9600 */\x0a"
"\x09\x09k -= 9600;\x0a"
"\x09\x09SET_LDOUBLE_EXP(a,ea);\x0a"
"\x09\x09SET_LDOUBLE_EXP(b,eb);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"    /* medium size a and b */\x0a"
"\x09w = a-b;\x0a"
"\x09if (w>b) {\x0a"
"\x09    u_int32_t high;\x0a"
"\x09    GET_LDOUBLE_MSW(high,a);\x0a"
"\x09    SET_LDOUBLE_WORDS(t1,ea,high,0);\x0a"
"\x09    t2 = a-t1;\x0a"
"\x09    w  = sqrtl(t1*t1-(b*(-b)-t2*(a+t1)));\x0a"
"\x09} else {\x0a"
"\x09    u_int32_t high;\x0a"
"\x09    GET_LDOUBLE_MSW(high,b);\x0a"
"\x09    a  = a+a;\x0a"
"\x09    SET_LDOUBLE_WORDS(yy1,eb,high,0);\x0a"
"\x09    y2 = b - yy1;\x0a"
"\x09    GET_LDOUBLE_MSW(high,a);\x0a"
"\x09    SET_LDOUBLE_WORDS(t1,ea+1,high,0);\x0a"
"\x09    t2 = a - t1;\x0a"
"\x09    w  = sqrtl(t1*yy1-(w*(-w)-(t1*y2+t2*b)));\x0a"
"\x09}\x0a"
"\x09if(k\x21=0) {\x0a"
"\x09    u_int32_t es;\x0a"
"\x09    t1 = 1.0;\x0a"
"\x09    GET_LDOUBLE_EXP(es,t1);\x0a"
"\x09    SET_LDOUBLE_EXP(t1,es+k);\x0a"
"\x09    return t1*w;\x0a"
"\x09} else return w;\x0a"
"}\x0a"
"", 3319 ); }