#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_e_lgammal_c( 
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice\x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/* lgammal(x)\x0a"
" * Reentrant version of the logarithm of the Gamma function\x0a"
" * with user provide pointer for the sign of Gamma(x).\x0a"
" *\x0a"
" * Method\x3a\x0a"
" *   1. Argument Reduction for 0 < x <= 8\x0a"
" *\x09Since gamma(1+s)=s*gamma(s), for x in \x5b""0,8\x5d, we may\x0a"
" *\x09reduce x to a number in \x5b""1.5,2.5\x5d by\x0a"
" *\x09\x09lgamma(1+s) = log(s) + lgamma(s)\x0a"
" *\x09""for example,\x0a"
" *\x09\x09lgamma(7.3) = log(6.3) + lgamma(6.3)\x0a"
" *\x09\x09\x09    = log(6.3*5.3) + lgamma(5.3)\x0a"
" *\x09\x09\x09    = log(6.3*5.3*4.3*3.3*2.3) + lgamma(2.3)\x0a"
" *   2. Polynomial approximation of lgamma around its\x0a"
" *\x09minimun ymin=1.461632144968362245 to maintain monotonicity.\x0a"
" *\x09On \x5bymin-0.23, ymin+0.27\x5d (i.e., \x5b""1.23164,1.73163\x5d), use\x0a"
" *\x09\x09Let z = x-ymin;\x0a"
" *\x09\x09lgamma(x) = -1.214862905358496078218 + z^2*poly(z)\x0a"
" *   2. Rational approximation in the primary interval \x5b""2,3\x5d\x0a"
" *\x09We use the following approximation\x3a\x0a"
" *\x09\x09s = x-2.0;\x0a"
" *\x09\x09lgamma(x) = 0.5*s + s*P(s)/Q(s)\x0a"
" *\x09Our algorithms are based on the following observation\x0a"
" *\x0a"
" *                             zeta(2)-1    2    zeta(3)-1    3\x0a"
" * lgamma(2+s) = s*(1-Euler) + --------- * s  -  --------- * s  + ...\x0a"
" *                                 2                 3\x0a"
" *\x0a"
" *\x09where Euler = 0.5771... is the Euler constant, which is very\x0a"
" *\x09""close to 0.5.\x0a"
" *\x0a"
" *   3. For x>=8, we have\x0a"
" *\x09lgamma(x)\x7e(x-0.5)log(x)-x+0.5*log(2pi)+1/(12x)-1/(360x**3)+....\x0a"
" *\x09(better formula\x3a\x0a"
" *\x09   lgamma(x)\x7e(x-0.5)*(log(x)-1)-.5*(log(2pi)-1) + ...)\x0a"
" *\x09Let z = 1/x, then we approximation\x0a"
" *\x09\x09""f(z) = lgamma(x) - (x-0.5)(log(x)-1)\x0a"
" *\x09""by\x0a"
" *\x09\x09\x09\x09    3       5             11\x0a"
" *\x09\x09w = w0 + w1*z + w2*z  + w3*z  + ... + w6*z\x0a"
" *\x0a"
" *   4. For negative x, since (G is gamma function)\x0a"
" *\x09\x09-x*G(-x)*G(x) = pi/sin(pi*x),\x0a"
" *\x09we have\x0a"
" *\x09\x09G(x) = pi/(sin(pi*x)*(-x)*G(-x))\x0a"
" *\x09since G(-x) is positive, sign(G(x)) = sign(sin(pi*x)) for x<0\x0a"
" *\x09Hence, for x<0, signgam = sign(sin(pi*x)) and\x0a"
" *\x09\x09lgamma(x) = log(\x7cGamma(x)\x7c)\x0a"
" *\x09\x09\x09  = log(pi/(\x7cx*sin(pi*x)\x7c)) - lgamma(-x);\x0a"
" *\x09Note\x3a one should avoid compute pi*(-x) directly in the\x0a"
" *\x09      computation of sin(pi*(-x)).\x0a"
" *\x0a"
" *   5. Special Cases\x0a"
" *\x09\x09lgamma(2+s) \x7e s*(1-Euler) for tiny s\x0a"
" *\x09\x09lgamma(1)=lgamma(2)=0\x0a"
" *\x09\x09lgamma(x) \x7e -log(x) for tiny x\x0a"
" *\x09\x09lgamma(0) = lgamma(inf) = inf\x0a"
" *\x09\x09lgamma(-integer) = +-inf\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const long double\x0a"
"  half = 0.5L,\x0a"
"  one = 1.0L,\x0a"
"  pi = 3.14159265358979323846264L,\x0a"
"  two63 = 9.223372036854775808e18L,\x0a"
"\x0a"
"  /* lgam(1+x) = 0.5 x + x a(x)/b(x)\x0a"
"     -0.268402099609375 <= x <= 0\x0a"
"     peak relative error 6.6e-22 */\x0a"
"  a0 = -6.343246574721079391729402781192128239938E2L,\x0a"
"  a1 =  1.856560238672465796768677717168371401378E3L,\x0a"
"  a2 =  2.404733102163746263689288466865843408429E3L,\x0a"
"  a3 =  8.804188795790383497379532868917517596322E2L,\x0a"
"  a4 =  1.135361354097447729740103745999661157426E2L,\x0a"
"  a5 =  3.766956539107615557608581581190400021285E0L,\x0a"
"\x0a"
"  b0 =  8.214973713960928795704317259806842490498E3L,\x0a"
"  b1 =  1.026343508841367384879065363925870888012E4L,\x0a"
"  b2 =  4.553337477045763320522762343132210919277E3L,\x0a"
"  b3 =  8.506975785032585797446253359230031874803E2L,\x0a"
"  b4 =  6.042447899703295436820744186992189445813E1L,\x0a"
"  /* b5 =  1.000000000000000000000000000000000000000E0 */\x0a"
"\x0a"
"\x0a"
"  tc =  1.4616321449683623412626595423257213284682E0L,\x0a"
"  tf = -1.2148629053584961146050602565082954242826E-1,/* double precision */\x0a"
"/* tt = (tail of tf), i.e. tf + tt has extended precision. */\x0a"
"  tt = 3.3649914684731379602768989080467587736363E-18L,\x0a"
"  /* lgam ( 1.4616321449683623412626595423257213284682E0 ) =\x0a"
"-1.2148629053584960809551455717769158215135617312999903886372437313313530E-1 */\x0a"
"\x0a"
"  /* lgam (x + tc) = tf + tt + x g(x)/h(x)\x0a"
"     - 0.230003726999612341262659542325721328468 <= x\x0a"
"     <= 0.2699962730003876587373404576742786715318\x0a"
"     peak relative error 2.1e-21 */\x0a"
"  g0 = 3.645529916721223331888305293534095553827E-18L,\x0a"
"  g1 = 5.126654642791082497002594216163574795690E3L,\x0a"
"  g2 = 8.828603575854624811911631336122070070327E3L,\x0a"
"  g3 = 5.464186426932117031234820886525701595203E3L,\x0a"
"  g4 = 1.455427403530884193180776558102868592293E3L,\x0a"
"  g5 = 1.541735456969245924860307497029155838446E2L,\x0a"
"  g6 = 4.335498275274822298341872707453445815118E0L,\x0a"
"\x0a"
"  h0 = 1.059584930106085509696730443974495979641E4L,\x0a"
"  h1 =  2.147921653490043010629481226937850618860E4L,\x0a"
"  h2 = 1.643014770044524804175197151958100656728E4L,\x0a"
"  h3 =  5.869021995186925517228323497501767586078E3L,\x0a"
"  h4 =  9.764244777714344488787381271643502742293E2L,\x0a"
"  h5 =  6.442485441570592541741092969581997002349E1L,\x0a"
"  /* h6 = 1.000000000000000000000000000000000000000E0 */\x0a"
"\x0a"
"\x0a"
"  /* lgam (x+1) = -0.5 x + x u(x)/v(x)\x0a"
"     -0.100006103515625 <= x <= 0.231639862060546875\x0a"
"     peak relative error 1.3e-21 */\x0a"
"  u0 = -8.886217500092090678492242071879342025627E1L,\x0a"
"  u1 =  6.840109978129177639438792958320783599310E2L,\x0a"
"  u2 =  2.042626104514127267855588786511809932433E3L,\x0a"
"  u3 =  1.911723903442667422201651063009856064275E3L,\x0a"
"  u4 =  7.447065275665887457628865263491667767695E2L,\x0a"
"  u5 =  1.132256494121790736268471016493103952637E2L,\x0a"
"  u6 =  4.484398885516614191003094714505960972894E0L,\x0a"
"\x0a"
"  v0 =  1.150830924194461522996462401210374632929E3L,\x0a"
"  v1 =  3.399692260848747447377972081399737098610E3L,\x0a"
"  v2 =  3.786631705644460255229513563657226008015E3L,\x0a"
"  v3 =  1.966450123004478374557778781564114347876E3L,\x0a"
"  v4 =  4.741359068914069299837355438370682773122E2L,\x0a"
"  v5 =  4.508989649747184050907206782117647852364E1L,\x0a"
"  /* v6 =  1.000000000000000000000000000000000000000E0 */\x0a"
"\x0a"
"\x0a"
"  /* lgam (x+2) = .5 x + x s(x)/r(x)\x0a"
"     0 <= x <= 1\x0a"
"     peak relative error 7.2e-22 */\x0a"
"  s0 =  1.454726263410661942989109455292824853344E6L,\x0a"
"  s1 = -3.901428390086348447890408306153378922752E6L,\x0a"
"  s2 = -6.573568698209374121847873064292963089438E6L,\x0a"
"  s3 = -3.319055881485044417245964508099095984643E6L,\x0a"
"  s4 = -7.094891568758439227560184618114707107977E5L,\x0a"
"  s5 = -6.263426646464505837422314539808112478303E4L,\x0a"
"  s6 = -1.684926520999477529949915657519454051529E3L,\x0a"
"\x0a"
"  r0 = -1.883978160734303518163008696712983134698E7L,\x0a"
"  r1 = -2.815206082812062064902202753264922306830E7L,\x0a"
"  r2 = -1.600245495251915899081846093343626358398E7L,\x0a"
"  r3 = -4.310526301881305003489257052083370058799E6L,\x0a"
"  r4 = -5.563807682263923279438235987186184968542E5L,\x0a"
"  r5 = -3.027734654434169996032905158145259713083E4L,\x0a"
"  r6 = -4.501995652861105629217250715790764371267E2L,\x0a"
"  /* r6 =  1.000000000000000000000000000000000000000E0 */\x0a"
"\x0a"
"\x0a"
"/* lgam(x) = ( x - 0.5 ) * log(x) - x + LS2PI + 1/x w(1/x^2)\x0a"
"   x >= 8\x0a"
"   Peak relative error 1.51e-21\x0a"
"   w0 = LS2PI - 0.5 */\x0a"
"  w0 =  4.189385332046727417803e-1L,\x0a"
"  w1 =  8.333333333333331447505E-2L,\x0a"
"  w2 = -2.777777777750349603440E-3L,\x0a"
"  w3 =  7.936507795855070755671E-4L,\x0a"
"  w4 = -5.952345851765688514613E-4L,\x0a"
"  w5 =  8.412723297322498080632E-4L,\x0a"
"  w6 = -1.880801938119376907179E-3L,\x0a"
"  w7 =  4.885026142432270781165E-3L;\x0a"
"\x0a"
"static const long double zero = 0.0L;\x0a"
"\x0a"
"static long double\x0a"
"sin_pi(long double x)\x0a"
"{\x0a"
"  long double y, z;\x0a"
"  int n, ix;\x0a"
"  u_int32_t se, i0, i1;\x0a"
"\x0a"
"  GET_LDOUBLE_WORDS (se, i0, i1, x);\x0a"
"  ix = se \x26 0x7fff;\x0a"
"  ix = (ix << 16) \x7c (i0 >> 16);\x0a"
"  if (ix < 0x3ffd8000) /* 0.25 */\x0a"
"    return sinl (pi * x);\x0a"
"  y = -x;\x09\x09\x09/* x is assume negative */\x0a"
"\x0a"
"  /*\x0a"
"   * argument reduction, make sure inexact flag not raised if input\x0a"
"   * is an integer\x0a"
"   */\x0a"
"  z = floorl (y);\x0a"
"  if (z \x21= y)\x0a"
"    {\x09\x09\x09\x09/* inexact anyway */\x0a"
"      y  *= 0.5;\x0a"
"      y = 2.0*(y - floorl(y));\x09\x09/* y = \x7cx\x7c mod 2.0 */\x0a"
"      n = (int) (y*4.0);\x0a"
"    }\x0a"
"  else\x0a"
"    {\x0a"
"      if (ix >= 0x403f8000)  /* 2^64 */\x0a"
"\x09{\x0a"
"\x09  y = zero; n = 0;\x09\x09/* y must be even */\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09if (ix < 0x403e8000)  /* 2^63 */\x0a"
"\x09  z = y + two63;\x09/* exact */\x0a"
"\x09GET_LDOUBLE_WORDS (se, i0, i1, z);\x0a"
"\x09n = i1 \x26 1;\x0a"
"\x09y  = n;\x0a"
"\x09n <<= 2;\x0a"
"      }\x0a"
"    }\x0a"
"\x0a"
"  switch (n)\x0a"
"    {\x0a"
"    case 0\x3a\x0a"
"      y = sinl (pi * y);\x0a"
"      break;\x0a"
"    case 1\x3a\x0a"
"    case 2\x3a\x0a"
"      y = cosl (pi * (half - y));\x0a"
"      break;\x0a"
"    case 3\x3a\x0a"
"    case 4\x3a\x0a"
"      y = sinl (pi * (one - y));\x0a"
"      break;\x0a"
"    case 5\x3a\x0a"
"    case 6\x3a\x0a"
"      y = -cosl (pi * (y - 1.5));\x0a"
"      break;\x0a"
"    default\x3a\x0a"
"      y = sinl (pi * (y - 2.0));\x0a"
"      break;\x0a"
"    }\x0a"
"  return -y;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"long double\x0a"
"lgammal(long double x)\x0a"
"{\x0a"
"  long double t, y, z, nadj, p, p1, p2, q, r, w;\x0a"
"  int i, ix;\x0a"
"  u_int32_t se, i0, i1;\x0a"
"\x0a"
"  signgam = 1;\x0a"
"  GET_LDOUBLE_WORDS (se, i0, i1, x);\x0a"
"  ix = se \x26 0x7fff;\x0a"
"\x0a"
"  if ((ix \x7c i0 \x7c i1) == 0)\x0a"
"    {\x0a"
"      if (se \x26 0x8000)\x0a"
"\x09signgam = -1;\x0a"
"      return one / fabsl (x);\x0a"
"    }\x0a"
"\x0a"
"  ix = (ix << 16) \x7c (i0 >> 16);\x0a"
"\x0a"
"  /* purge off +-inf, NaN, +-0, and negative arguments */\x0a"
"  if (ix >= 0x7fff0000)\x0a"
"    return x * x;\x0a"
"\x0a"
"  if (ix < 0x3fc08000) /* 2^-63 */\x0a"
"    {\x09\x09\x09\x09/* \x7cx\x7c<2**-63, return -log(\x7cx\x7c) */\x0a"
"      if (se \x26 0x8000)\x0a"
"\x09{\x0a"
"\x09  signgam = -1;\x0a"
"\x09  return -logl (-x);\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09return -logl (x);\x0a"
"    }\x0a"
"  if (se \x26 0x8000)\x0a"
"    {\x0a"
"      t = sin_pi (x);\x0a"
"      if (t == zero)\x0a"
"\x09return one / fabsl (t);\x09/* -integer */\x0a"
"      nadj = logl (pi / fabsl (t * x));\x0a"
"      if (t < zero)\x0a"
"\x09signgam = -1;\x0a"
"      x = -x;\x0a"
"    }\x0a"
"\x0a"
"  /* purge off 1 and 2 */\x0a"
"  if ((((ix - 0x3fff8000) \x7c i0 \x7c i1) == 0)\x0a"
"      \x7c\x7c (((ix - 0x40008000) \x7c i0 \x7c i1) == 0))\x0a"
"    r = 0;\x0a"
"  else if (ix < 0x40008000) /* 2.0 */\x0a"
"    {\x0a"
"      /* x < 2.0 */\x0a"
"      if (ix <= 0x3ffee666) /* 8.99993896484375e-1 */\x0a"
"\x09{\x0a"
"\x09  /* lgamma(x) = lgamma(x+1) - log(x) */\x0a"
"\x09  r = -logl (x);\x0a"
"\x09  if (ix >= 0x3ffebb4a) /* 7.31597900390625e-1 */\x0a"
"\x09    {\x0a"
"\x09      y = x - one;\x0a"
"\x09      i = 0;\x0a"
"\x09    }\x0a"
"\x09  else if (ix >= 0x3ffced33)/* 2.31639862060546875e-1 */\x0a"
"\x09    {\x0a"
"\x09      y = x - (tc - one);\x0a"
"\x09      i = 1;\x0a"
"\x09    }\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      /* x < 0.23 */\x0a"
"\x09      y = x;\x0a"
"\x09      i = 2;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"      else\x0a"
"\x09{\x0a"
"\x09  r = zero;\x0a"
"\x09  if (ix >= 0x3fffdda6) /* 1.73162841796875 */\x0a"
"\x09    {\x0a"
"\x09      /* \x5b""1.7316,2\x5d */\x0a"
"\x09      y = x - 2.0;\x0a"
"\x09      i = 0;\x0a"
"\x09    }\x0a"
"\x09  else if (ix >= 0x3fff9da6)/* 1.23162841796875 */\x0a"
"\x09    {\x0a"
"\x09      /* \x5b""1.23,1.73\x5d */\x0a"
"\x09      y = x - tc;\x0a"
"\x09      i = 1;\x0a"
"\x09    }\x0a"
"\x09  else\x0a"
"\x09    {\x0a"
"\x09      /* \x5b""0.9, 1.23\x5d */\x0a"
"\x09      y = x - one;\x0a"
"\x09      i = 2;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"      switch (i)\x0a"
"\x09{\x0a"
"\x09""case 0\x3a\x0a"
"\x09  p1 = a0 + y * (a1 + y * (a2 + y * (a3 + y * (a4 + y * a5))));\x0a"
"\x09  p2 = b0 + y * (b1 + y * (b2 + y * (b3 + y * (b4 + y))));\x0a"
"\x09  r += half * y + y * p1/p2;\x0a"
"\x09  break;\x0a"
"\x09""case 1\x3a\x0a"
"    p1 = g0 + y * (g1 + y * (g2 + y * (g3 + y * (g4 + y * (g5 + y * g6)))));\x0a"
"    p2 = h0 + y * (h1 + y * (h2 + y * (h3 + y * (h4 + y * (h5 + y)))));\x0a"
"    p = tt + y * p1/p2;\x0a"
"\x09  r += (tf + p);\x0a"
"\x09  break;\x0a"
"\x09""case 2\x3a\x0a"
" p1 = y * (u0 + y * (u1 + y * (u2 + y * (u3 + y * (u4 + y * (u5 + y * u6))))));\x0a"
"      p2 = v0 + y * (v1 + y * (v2 + y * (v3 + y * (v4 + y * (v5 + y)))));\x0a"
"\x09  r += (-half * y + p1 / p2);\x0a"
"\x09}\x0a"
"    }\x0a"
"  else if (ix < 0x40028000) /* 8.0 */\x0a"
"    {\x0a"
"      /* x < 8.0 */\x0a"
"      i = (int) x;\x0a"
"      t = zero;\x0a"
"      y = x - (double) i;\x0a"
"  p = y *\x0a"
"     (s0 + y * (s1 + y * (s2 + y * (s3 + y * (s4 + y * (s5 + y * s6))))));\x0a"
"  q = r0 + y * (r1 + y * (r2 + y * (r3 + y * (r4 + y * (r5 + y * (r6 + y))))));\x0a"
"      r = half * y + p / q;\x0a"
"      z = one;\x09\x09\x09/* lgamma(1+s) = log(s) + lgamma(s) */\x0a"
"      switch (i)\x0a"
"\x09{\x0a"
"\x09""case 7\x3a\x0a"
"\x09  z *= (y + 6.0);\x09/* FALLTHRU */\x0a"
"\x09""case 6\x3a\x0a"
"\x09  z *= (y + 5.0);\x09/* FALLTHRU */\x0a"
"\x09""case 5\x3a\x0a"
"\x09  z *= (y + 4.0);\x09/* FALLTHRU */\x0a"
"\x09""case 4\x3a\x0a"
"\x09  z *= (y + 3.0);\x09/* FALLTHRU */\x0a"
"\x09""case 3\x3a\x0a"
"\x09  z *= (y + 2.0);\x09/* FALLTHRU */\x0a"
"\x09  r += logl (z);\x0a"
"\x09  break;\x0a"
"\x09}\x0a"
"    }\x0a"
"  else if (ix < 0x40418000) /* 2^66 */\x0a"
"    {\x0a"
"      /* 8.0 <= x < 2**66 */\x0a"
"      t = logl (x);\x0a"
"      z = one / x;\x0a"
"      y = z * z;\x0a"
"      w = w0 + z * (w1\x0a"
"\x09  + y * (w2 + y * (w3 + y * (w4 + y * (w5 + y * (w6 + y * w7))))));\x0a"
"      r = (x - half) * (t - one) + w;\x0a"
"    }\x0a"
"  else\x0a"
"    /* 2**66 <= x <= inf */\x0a"
"    r = x * (logl (x) - one);\x0a"
"  if (se \x26 0x8000)\x0a"
"    r = nadj - r;\x0a"
"  return r;\x0a"
"}\x0a"
"", 12455 ); }