#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_e_log10l_c( 
"/*\x09\x24OpenBSD\x3a e_log10l.c,v 1.2 2013/11/12 20\x3a""35\x3a""19 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09log10l.c\x0a"
" *\x0a"
" *\x09""Common logarithm, long double precision\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double x, y, log10l();\x0a"
" *\x0a"
" * y = log10l( x );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Returns the base 10 logarithm of x.\x0a"
" *\x0a"
" * The argument is separated into its exponent and fractional\x0a"
" * parts.  If the exponent is between -1 and +1, the logarithm\x0a"
" * of the fraction is approximated by\x0a"
" *\x0a"
" *     log(1+x) = x - 0.5 x**2 + x**3 P(x)/Q(x).\x0a"
" *\x0a"
" * Otherwise, setting  z = 2(x-1)/x+1),\x0a"
" *\x0a"
" *     log(x) = z + z**3 P(z)/Q(z).\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE      0.5, 2.0     30000      9.0e-20     2.6e-20\x0a"
" *    IEEE     exp(+-10000)  30000      6.0e-20     2.3e-20\x0a"
" *\x0a"
" * In the tests over the interval exp(+-10000), the logarithms\x0a"
" * of the random arguments were uniformly distributed over\x0a"
" * \x5b-10000, +10000\x5d.\x0a"
" *\x0a"
" * ERROR MESSAGES\x3a\x0a"
" *\x0a"
" * log singularity\x3a  x = 0; returns MINLOG\x0a"
" * log domain\x3a       x < 0; returns MINLOG\x0a"
" */\x0a"
"\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/* Coefficients for log(1+x) = x - x**2/2 + x**3 P(x)/Q(x)\x0a"
" * 1/sqrt(2) <= x < sqrt(2)\x0a"
" * Theoretical peak relative error = 6.2e-22\x0a"
" */\x0a"
"static long double P\x5b\x5d = {\x0a"
" 4.9962495940332550844739E-1L,\x0a"
" 1.0767376367209449010438E1L,\x0a"
" 7.7671073698359539859595E1L,\x0a"
" 2.5620629828144409632571E2L,\x0a"
" 4.2401812743503691187826E2L,\x0a"
" 3.4258224542413922935104E2L,\x0a"
" 1.0747524399916215149070E2L,\x0a"
"};\x0a"
"static long double Q\x5b\x5d = {\x0a"
"/* 1.0000000000000000000000E0,*/\x0a"
" 2.3479774160285863271658E1L,\x0a"
" 1.9444210022760132894510E2L,\x0a"
" 7.7952888181207260646090E2L,\x0a"
" 1.6911722418503949084863E3L,\x0a"
" 2.0307734695595183428202E3L,\x0a"
" 1.2695660352705325274404E3L,\x0a"
" 3.2242573199748645407652E2L,\x0a"
"};\x0a"
"\x0a"
"/* Coefficients for log(x) = z + z^3 P(z^2)/Q(z^2),\x0a"
" * where z = 2(x-1)/(x+1)\x0a"
" * 1/sqrt(2) <= x < sqrt(2)\x0a"
" * Theoretical peak relative error = 6.16e-22\x0a"
" */\x0a"
"\x0a"
"static long double R\x5b""4\x5d = {\x0a"
" 1.9757429581415468984296E-3L,\x0a"
"-7.1990767473014147232598E-1L,\x0a"
" 1.0777257190312272158094E1L,\x0a"
"-3.5717684488096787370998E1L,\x0a"
"};\x0a"
"static long double S\x5b""4\x5d = {\x0a"
"/* 1.00000000000000000000E0L,*/\x0a"
"-2.6201045551331104417768E1L,\x0a"
" 1.9361891836232102174846E2L,\x0a"
"-4.2861221385716144629696E2L,\x0a"
"};\x0a"
"/* log10(2) */\x0a"
"#define L102A 0.3125L\x0a"
"#define L102B -1.1470004336018804786261e-2L\x0a"
"/* log10(e) */\x0a"
"#define L10EA 0.5L\x0a"
"#define L10EB -6.5705518096748172348871e-2L\x0a"
"\x0a"
"#define SQRTH 0.70710678118654752440L\x0a"
"\x0a"
"long double\x0a"
"log10l(long double x)\x0a"
"{\x0a"
"long double y;\x0a"
"volatile long double z;\x0a"
"int e;\x0a"
"\x0a"
"if( isnan(x) )\x0a"
"\x09return(x);\x0a"
"/* Test for domain */\x0a"
"if( x <= 0.0L )\x0a"
"\x09{\x0a"
"\x09if( x == 0.0L )\x0a"
"\x09\x09return (-1.0L / (x - x));\x0a"
"\x09""else\x0a"
"\x09\x09return (x - x) / (x - x);\x0a"
"\x09}\x0a"
"if( x == INFINITY )\x0a"
"\x09return(INFINITY);\x0a"
"/* separate mantissa from exponent */\x0a"
"\x0a"
"/* Note, frexp is used so that denormal numbers\x0a"
" * will be handled properly.\x0a"
" */\x0a"
"x = frexpl( x, \x26""e );\x0a"
"\x0a"
"\x0a"
"/* logarithm using log(x) = z + z**3 P(z)/Q(z),\x0a"
" * where z = 2(x-1)/x+1)\x0a"
" */\x0a"
"if( (e > 2) \x7c\x7c (e < -2) )\x0a"
"{\x0a"
"if( x < SQRTH )\x0a"
"\x09{ /* 2( 2x-1 )/( 2x+1 ) */\x0a"
"\x09""e -= 1;\x0a"
"\x09z = x - 0.5L;\x0a"
"\x09y = 0.5L * z + 0.5L;\x0a"
"\x09}\x09\x0a"
"else\x0a"
"\x09{ /*  2 (x-1)/(x+1)   */\x0a"
"\x09z = x - 0.5L;\x0a"
"\x09z -= 0.5L;\x0a"
"\x09y = 0.5L * x  + 0.5L;\x0a"
"\x09}\x0a"
"x = z / y;\x0a"
"z = x*x;\x0a"
"y = x * ( z * __polevll( z, R, 3 ) / __p1evll( z, S, 3 ) );\x0a"
"goto done;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* logarithm using log(1+x) = x - .5x**2 + x**3 P(x)/Q(x) */\x0a"
"\x0a"
"if( x < SQRTH )\x0a"
"\x09{\x0a"
"\x09""e -= 1;\x0a"
"\x09x = ldexpl( x, 1 ) - 1.0L; /*  2x - 1  */\x0a"
"\x09}\x09\x0a"
"else\x0a"
"\x09{\x0a"
"\x09x = x - 1.0L;\x0a"
"\x09}\x0a"
"z = x*x;\x0a"
"y = x * ( z * __polevll( x, P, 6 ) / __p1evll( x, Q, 7 ) );\x0a"
"y = y - ldexpl( z, -1 );   /* -0.5x^2 + ... */\x0a"
"\x0a"
"done\x3a\x0a"
"\x0a"
"/* Multiply log of fraction by log10(e)\x0a"
" * and base 2 exponent by log10(2).\x0a"
" *\x0a"
" * ***CAUTION***\x0a"
" *\x0a"
" * This sequence of operations is critical and it may\x0a"
" * be horribly defeated by some compiler optimizers.\x0a"
" */\x0a"
"z = y * (L10EB);\x0a"
"z += x * (L10EB);\x0a"
"z += e * (L102B);\x0a"
"z += y * (L10EA);\x0a"
"z += x * (L10EA);\x0a"
"z += e * (L102A);\x0a"
"\x0a"
"return( z );\x0a"
"}\x0a"
"", 4654 ); }