#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_e_powl_c( 
"/*\x09\x24OpenBSD\x3a e_powl.c,v 1.5 2013/11/12 20\x3a""35\x3a""19 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09powl.c\x0a"
" *\x0a"
" *\x09Power function, long double precision\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double x, y, z, powl();\x0a"
" *\x0a"
" * z = powl( x, y );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Computes x raised to the yth power.  Analytically,\x0a"
" *\x0a"
" *      x**y  =  exp( y log(x) ).\x0a"
" *\x0a"
" * Following Cody and Waite, this program uses a lookup table\x0a"
" * of 2**-i/32 and pseudo extended precision arithmetic to\x0a"
" * obtain several extra bits of accuracy in both the logarithm\x0a"
" * and the exponential.\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" * The relative error of pow(x,y) can be estimated\x0a"
" * by   y dl ln(2),   where dl is the absolute error of\x0a"
" * the internally computed base 2 logarithm.  At the ends\x0a"
" * of the approximation interval the logarithm equal 1/32\x0a"
" * and its relative error is about 1 lsb = 1.1e-19.  Hence\x0a"
" * the predicted relative error in the result is 2.3e-21 y .\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *\x0a"
" *    IEEE     +-1000       40000      2.8e-18      3.7e-19\x0a"
" * .001 < x < 1000, with log(x) uniformly distributed.\x0a"
" * -1000 < y < 1000, y uniformly distributed.\x0a"
" *\x0a"
" *    IEEE     0,8700       60000      6.5e-18      1.0e-18\x0a"
" * 0.99 < x < 1.01, 0 < y < 8700, uniformly distributed.\x0a"
" *\x0a"
" *\x0a"
" * ERROR MESSAGES\x3a\x0a"
" *\x0a"
" *   message         condition      value returned\x0a"
" * pow overflow     x**y > MAXNUM      INFINITY\x0a"
" * pow underflow   x**y < 1/MAXNUM       0.0\x0a"
" * pow domain      x<0 and y noninteger  0.0\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/* Table size */\x0a"
"#define NXT 32\x0a"
"/* log2(Table size) */\x0a"
"#define LNXT 5\x0a"
"\x0a"
"/* log(1+x) =  x - .5x^2 + x^3 *  P(z)/Q(z)\x0a"
" * on the domain  2^(-1/32) - 1  <=  x  <=  2^(1/32) - 1\x0a"
" */\x0a"
"static long double P\x5b\x5d = {\x0a"
" 8.3319510773868690346226E-4L,\x0a"
" 4.9000050881978028599627E-1L,\x0a"
" 1.7500123722550302671919E0L,\x0a"
" 1.4000100839971580279335E0L,\x0a"
"};\x0a"
"static long double Q\x5b\x5d = {\x0a"
"/* 1.0000000000000000000000E0L,*/\x0a"
" 5.2500282295834889175431E0L,\x0a"
" 8.4000598057587009834666E0L,\x0a"
" 4.2000302519914740834728E0L,\x0a"
"};\x0a"
"/* A\x5bi\x5d = 2^(-i/32), rounded to IEEE long double precision.\x0a"
" * If i is even, A\x5bi\x5d + B\x5bi/2\x5d gives additional accuracy.\x0a"
" */\x0a"
"static long double A\x5b""33\x5d = {\x0a"
" 1.0000000000000000000000E0L,\x0a"
" 9.7857206208770013448287E-1L,\x0a"
" 9.5760328069857364691013E-1L,\x0a"
" 9.3708381705514995065011E-1L,\x0a"
" 9.1700404320467123175367E-1L,\x0a"
" 8.9735453750155359320742E-1L,\x0a"
" 8.7812608018664974155474E-1L,\x0a"
" 8.5930964906123895780165E-1L,\x0a"
" 8.4089641525371454301892E-1L,\x0a"
" 8.2287773907698242225554E-1L,\x0a"
" 8.0524516597462715409607E-1L,\x0a"
" 7.8799042255394324325455E-1L,\x0a"
" 7.7110541270397041179298E-1L,\x0a"
" 7.5458221379671136985669E-1L,\x0a"
" 7.3841307296974965571198E-1L,\x0a"
" 7.2259040348852331001267E-1L,\x0a"
" 7.0710678118654752438189E-1L,\x0a"
" 6.9195494098191597746178E-1L,\x0a"
" 6.7712777346844636413344E-1L,\x0a"
" 6.6261832157987064729696E-1L,\x0a"
" 6.4841977732550483296079E-1L,\x0a"
" 6.3452547859586661129850E-1L,\x0a"
" 6.2092890603674202431705E-1L,\x0a"
" 6.0762367999023443907803E-1L,\x0a"
" 5.9460355750136053334378E-1L,\x0a"
" 5.8186242938878875689693E-1L,\x0a"
" 5.6939431737834582684856E-1L,\x0a"
" 5.5719337129794626814472E-1L,\x0a"
" 5.4525386633262882960438E-1L,\x0a"
" 5.3357020033841180906486E-1L,\x0a"
" 5.2213689121370692017331E-1L,\x0a"
" 5.1094857432705833910408E-1L,\x0a"
" 5.0000000000000000000000E-1L,\x0a"
"};\x0a"
"static long double B\x5b""17\x5d = {\x0a"
" 0.0000000000000000000000E0L,\x0a"
" 2.6176170809902549338711E-20L,\x0a"
"-1.0126791927256478897086E-20L,\x0a"
" 1.3438228172316276937655E-21L,\x0a"
" 1.2207982955417546912101E-20L,\x0a"
"-6.3084814358060867200133E-21L,\x0a"
" 1.3164426894366316434230E-20L,\x0a"
"-1.8527916071632873716786E-20L,\x0a"
" 1.8950325588932570796551E-20L,\x0a"
" 1.5564775779538780478155E-20L,\x0a"
" 6.0859793637556860974380E-21L,\x0a"
"-2.0208749253662532228949E-20L,\x0a"
" 1.4966292219224761844552E-20L,\x0a"
" 3.3540909728056476875639E-21L,\x0a"
"-8.6987564101742849540743E-22L,\x0a"
"-1.2327176863327626135542E-20L,\x0a"
" 0.0000000000000000000000E0L,\x0a"
"};\x0a"
"\x0a"
"/* 2^x = 1 + x P(x),\x0a"
" * on the interval -1/32 <= x <= 0\x0a"
" */\x0a"
"static long double R\x5b\x5d = {\x0a"
" 1.5089970579127659901157E-5L,\x0a"
" 1.5402715328927013076125E-4L,\x0a"
" 1.3333556028915671091390E-3L,\x0a"
" 9.6181291046036762031786E-3L,\x0a"
" 5.5504108664798463044015E-2L,\x0a"
" 2.4022650695910062854352E-1L,\x0a"
" 6.9314718055994530931447E-1L,\x0a"
"};\x0a"
"\x0a"
"#define douba(k) A\x5bk\x5d\x0a"
"#define doubb(k) B\x5bk\x5d\x0a"
"#define MEXP (NXT*16384.0L)\x0a"
"/* The following if denormal numbers are supported, else -MEXP\x3a */\x0a"
"#define MNEXP (-NXT*(16384.0L+64.0L))\x0a"
"/* log2(e) - 1 */\x0a"
"#define LOG2EA 0.44269504088896340735992L\x0a"
"\x0a"
"#define F W\x0a"
"#define Fa Wa\x0a"
"#define Fb Wb\x0a"
"#define G W\x0a"
"#define Ga Wa\x0a"
"#define Gb u\x0a"
"#define H W\x0a"
"#define Ha Wb\x0a"
"#define Hb Wb\x0a"
"\x0a"
"static const long double MAXLOGL = 1.1356523406294143949492E4L;\x0a"
"static const long double MINLOGL = -1.13994985314888605586758E4L;\x0a"
"static const long double LOGE2L = 6.9314718055994530941723E-1L;\x0a"
"static volatile long double z;\x0a"
"static long double w, W, Wa, Wb, ya, yb, u;\x0a"
"static const long double huge = 0x1p10000L;\x0a"
"#if 0 /* XXX Prevent gcc from erroneously constant folding this. */\x0a"
"static const long double twom10000 = 0x1p-10000L;\x0a"
"#else\x0a"
"static volatile long double twom10000 = 0x1p-10000L;\x0a"
"#endif\x0a"
"\x0a"
"static long double reducl( long double );\x0a"
"static long double powil ( long double, int );\x0a"
"\x0a"
"long double\x0a"
"powl(long double x, long double y)\x0a"
"{\x0a"
"/* double F, Fa, Fb, G, Ga, Gb, H, Ha, Hb */\x0a"
"int i, nflg, iyflg, yoddint;\x0a"
"long e;\x0a"
"\x0a"
"if( y == 0.0L )\x0a"
"\x09return( 1.0L );\x0a"
"\x0a"
"if( x == 1.0L )\x0a"
"\x09return( 1.0L );\x0a"
"\x0a"
"if( isnan(x) )\x0a"
"\x09return( x );\x0a"
"if( isnan(y) )\x0a"
"\x09return( y );\x0a"
"\x0a"
"if( y == 1.0L )\x0a"
"\x09return( x );\x0a"
"\x0a"
"if( \x21isfinite(y) \x26\x26 x == -1.0L )\x0a"
"\x09return( 1.0L );\x0a"
"\x0a"
"if( y >= LDBL_MAX )\x0a"
"\x09{\x0a"
"\x09if( x > 1.0L )\x0a"
"\x09\x09return( INFINITY );\x0a"
"\x09if( x > 0.0L \x26\x26 x < 1.0L )\x0a"
"\x09\x09return( 0.0L );\x0a"
"\x09if( x < -1.0L )\x0a"
"\x09\x09return( INFINITY );\x0a"
"\x09if( x > -1.0L \x26\x26 x < 0.0L )\x0a"
"\x09\x09return( 0.0L );\x0a"
"\x09}\x0a"
"if( y <= -LDBL_MAX )\x0a"
"\x09{\x0a"
"\x09if( x > 1.0L )\x0a"
"\x09\x09return( 0.0L );\x0a"
"\x09if( x > 0.0L \x26\x26 x < 1.0L )\x0a"
"\x09\x09return( INFINITY );\x0a"
"\x09if( x < -1.0L )\x0a"
"\x09\x09return( 0.0L );\x0a"
"\x09if( x > -1.0L \x26\x26 x < 0.0L )\x0a"
"\x09\x09return( INFINITY );\x0a"
"\x09}\x0a"
"if( x >= LDBL_MAX )\x0a"
"\x09{\x0a"
"\x09if( y > 0.0L )\x0a"
"\x09\x09return( INFINITY );\x0a"
"\x09return( 0.0L );\x0a"
"\x09}\x0a"
"\x0a"
"w = floorl(y);\x0a"
"/* Set iyflg to 1 if y is an integer.  */\x0a"
"iyflg = 0;\x0a"
"if( w == y )\x0a"
"\x09iyflg = 1;\x0a"
"\x0a"
"/* Test for odd integer y.  */\x0a"
"yoddint = 0;\x0a"
"if( iyflg )\x0a"
"\x09{\x0a"
"\x09ya = fabsl(y);\x0a"
"\x09ya = floorl(0.5L * ya);\x0a"
"\x09yb = 0.5L * fabsl(w);\x0a"
"\x09if( ya \x21= yb )\x0a"
"\x09\x09yoddint = 1;\x0a"
"\x09}\x0a"
"\x0a"
"if( x <= -LDBL_MAX )\x0a"
"\x09{\x0a"
"\x09if( y > 0.0L )\x0a"
"\x09\x09{\x0a"
"\x09\x09if( yoddint )\x0a"
"\x09\x09\x09return( -INFINITY );\x0a"
"\x09\x09return( INFINITY );\x0a"
"\x09\x09}\x0a"
"\x09if( y < 0.0L )\x0a"
"\x09\x09{\x0a"
"\x09\x09if( yoddint )\x0a"
"\x09\x09\x09return( -0.0L );\x0a"
"\x09\x09return( 0.0 );\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x0a"
"\x0a"
"nflg = 0;\x09/* flag = 1 if x<0 raised to integer power */\x0a"
"if( x <= 0.0L )\x0a"
"\x09{\x0a"
"\x09if( x == 0.0L )\x0a"
"\x09\x09{\x0a"
"\x09\x09if( y < 0.0 )\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09if( signbit(x) \x26\x26 yoddint )\x0a"
"\x09\x09\x09\x09return( -INFINITY );\x0a"
"\x09\x09\x09return( INFINITY );\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09if( y > 0.0 )\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09if( signbit(x) \x26\x26 yoddint )\x0a"
"\x09\x09\x09\x09return( -0.0L );\x0a"
"\x09\x09\x09return( 0.0 );\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09if( y == 0.0L )\x0a"
"\x09\x09\x09return( 1.0L );  /*   0**0   */\x0a"
"\x09\x09""else\x0a"
"\x09\x09\x09return( 0.0L );  /*   0**y   */\x0a"
"\x09\x09}\x0a"
"\x09""else\x0a"
"\x09\x09{\x0a"
"\x09\x09if( iyflg == 0 )\x0a"
"\x09\x09\x09return (x - x) / (x - x); /* (x<0)**(non-int) is NaN */\x0a"
"\x09\x09nflg = 1;\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x0a"
"/* Integer power of an integer.  */\x0a"
"\x0a"
"if( iyflg )\x0a"
"\x09{\x0a"
"\x09i = w;\x0a"
"\x09w = floorl(x);\x0a"
"\x09if( (w == x) \x26\x26 (fabsl(y) < 32768.0) )\x0a"
"\x09\x09{\x0a"
"\x09\x09w = powil( x, (int) y );\x0a"
"\x09\x09return( w );\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x0a"
"\x0a"
"if( nflg )\x0a"
"\x09x = fabsl(x);\x0a"
"\x0a"
"/* separate significand from exponent */\x0a"
"x = frexpl( x, \x26i );\x0a"
"e = i;\x0a"
"\x0a"
"/* find significand in antilog table A\x5b\x5d */\x0a"
"i = 1;\x0a"
"if( x <= douba(17) )\x0a"
"\x09i = 17;\x0a"
"if( x <= douba(i+8) )\x0a"
"\x09i += 8;\x0a"
"if( x <= douba(i+4) )\x0a"
"\x09i += 4;\x0a"
"if( x <= douba(i+2) )\x0a"
"\x09i += 2;\x0a"
"if( x >= douba(1) )\x0a"
"\x09i = -1;\x0a"
"i += 1;\x0a"
"\x0a"
"\x0a"
"/* Find (x - A\x5bi\x5d)/A\x5bi\x5d\x0a"
" * in order to compute log(x/A\x5bi\x5d)\x3a\x0a"
" *\x0a"
" * log(x) = log( a x/a ) = log(a) + log(x/a)\x0a"
" *\x0a"
" * log(x/a) = log(1+v),  v = x/a - 1 = (x-a)/a\x0a"
" */\x0a"
"x -= douba(i);\x0a"
"x -= doubb(i/2);\x0a"
"x /= douba(i);\x0a"
"\x0a"
"\x0a"
"/* rational approximation for log(1+v)\x3a\x0a"
" *\x0a"
" * log(1+v)  =  v  -  v**2/2  +  v**3 P(v) / Q(v)\x0a"
" */\x0a"
"z = x*x;\x0a"
"w = x * ( z * __polevll( x, P, 3 ) / __p1evll( x, Q, 3 ) );\x0a"
"w = w - ldexpl( z, -1 );   /*  w - 0.5 * z  */\x0a"
"\x0a"
"/* Convert to base 2 logarithm\x3a\x0a"
" * multiply by log2(e) = 1 + LOG2EA\x0a"
" */\x0a"
"z = LOG2EA * w;\x0a"
"z += w;\x0a"
"z += LOG2EA * x;\x0a"
"z += x;\x0a"
"\x0a"
"/* Compute exponent term of the base 2 logarithm. */\x0a"
"w = -i;\x0a"
"w = ldexpl( w, -LNXT );\x09/* divide by NXT */\x0a"
"w += e;\x0a"
"/* Now base 2 log of x is w + z. */\x0a"
"\x0a"
"/* Multiply base 2 log by y, in extended precision. */\x0a"
"\x0a"
"/* separate y into large part ya\x0a"
" * and small part yb less than 1/NXT\x0a"
" */\x0a"
"ya = reducl(y);\x0a"
"yb = y - ya;\x0a"
"\x0a"
"/* (w+z)(ya+yb)\x0a"
" * = w*ya + w*yb + z*y\x0a"
" */\x0a"
"F = z * y  +  w * yb;\x0a"
"Fa = reducl(F);\x0a"
"Fb = F - Fa;\x0a"
"\x0a"
"G = Fa + w * ya;\x0a"
"Ga = reducl(G);\x0a"
"Gb = G - Ga;\x0a"
"\x0a"
"H = Fb + Gb;\x0a"
"Ha = reducl(H);\x0a"
"w = ldexpl( Ga+Ha, LNXT );\x0a"
"\x0a"
"/* Test the power of 2 for overflow */\x0a"
"if( w > MEXP )\x0a"
"\x09return (huge * huge);\x09\x09/* overflow */\x0a"
"\x0a"
"if( w < MNEXP )\x0a"
"\x09return (twom10000 * twom10000);\x09/* underflow */\x0a"
"\x0a"
"e = w;\x0a"
"Hb = H - Ha;\x0a"
"\x0a"
"if( Hb > 0.0L )\x0a"
"\x09{\x0a"
"\x09""e += 1;\x0a"
"\x09Hb -= (1.0L/NXT);  /*0.0625L;*/\x0a"
"\x09}\x0a"
"\x0a"
"/* Now the product y * log2(x)  =  Hb + e/NXT.\x0a"
" *\x0a"
" * Compute base 2 exponential of Hb,\x0a"
" * where -0.0625 <= Hb <= 0.\x0a"
" */\x0a"
"z = Hb * __polevll( Hb, R, 6 );  /*    z  =  2**Hb - 1    */\x0a"
"\x0a"
"/* Express e/NXT as an integer plus a negative number of (1/NXT)ths.\x0a"
" * Find lookup table entry for the fractional power of 2.\x0a"
" */\x0a"
"if( e < 0 )\x0a"
"\x09i = 0;\x0a"
"else\x0a"
"\x09i = 1;\x0a"
"i = e/NXT + i;\x0a"
"e = NXT*i - e;\x0a"
"w = douba( e );\x0a"
"z = w * z;      /*    2**-e * ( 1 + (2**Hb-1) )    */\x0a"
"z = z + w;\x0a"
"z = ldexpl( z, i );  /* multiply by integer power of 2 */\x0a"
"\x0a"
"if( nflg )\x0a"
"\x09{\x0a"
"/* For negative x,\x0a"
" * find out if the integer exponent\x0a"
" * is odd or even.\x0a"
" */\x0a"
"\x09w = ldexpl( y, -1 );\x0a"
"\x09w = floorl(w);\x0a"
"\x09w = ldexpl( w, 1 );\x0a"
"\x09if( w \x21= y )\x0a"
"\x09\x09z = -z; /* odd exponent */\x0a"
"\x09}\x0a"
"\x0a"
"return( z );\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* Find a multiple of 1/NXT that is within 1/NXT of x. */\x0a"
"static long double\x0a"
"reducl(long double x)\x0a"
"{\x0a"
"long double t;\x0a"
"\x0a"
"t = ldexpl( x, LNXT );\x0a"
"t = floorl( t );\x0a"
"t = ldexpl( t, -LNXT );\x0a"
"return(t);\x0a"
"}\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09powil.c\x0a"
" *\x0a"
" *\x09Real raised to integer power, long double precision\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double x, y, powil();\x0a"
" * int n;\x0a"
" *\x0a"
" * y = powil( x, n );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Returns argument x raised to the nth power.\x0a"
" * The routine efficiently decomposes n as a sum of powers of\x0a"
" * two. The desired power is a product of two-to-the-kth\x0a"
" * powers of x.  Thus to compute the 32767 power of x requires\x0a"
" * 28 multiplications instead of 32767 multiplications.\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   x domain   n domain  # trials      peak         rms\x0a"
" *    IEEE     .001,1000  -1022,1023  50000       4.3e-17     7.8e-18\x0a"
" *    IEEE        1,2     -1022,1023  20000       3.9e-17     7.6e-18\x0a"
" *    IEEE     .99,1.01     0,8700    10000       3.6e-16     7.2e-17\x0a"
" *\x0a"
" * Returns MAXNUM on overflow, zero on underflow.\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"static long double\x0a"
"powil(long double x, int nn)\x0a"
"{\x0a"
"long double ww, y;\x0a"
"long double s;\x0a"
"int n, e, sign, asign, lx;\x0a"
"\x0a"
"if( x == 0.0L )\x0a"
"\x09{\x0a"
"\x09if( nn == 0 )\x0a"
"\x09\x09return( 1.0L );\x0a"
"\x09""else if( nn < 0 )\x0a"
"\x09\x09return( LDBL_MAX );\x0a"
"\x09""else\x0a"
"\x09\x09return( 0.0L );\x0a"
"\x09}\x0a"
"\x0a"
"if( nn == 0 )\x0a"
"\x09return( 1.0L );\x0a"
"\x0a"
"\x0a"
"if( x < 0.0L )\x0a"
"\x09{\x0a"
"\x09""asign = -1;\x0a"
"\x09x = -x;\x0a"
"\x09}\x0a"
"else\x0a"
"\x09""asign = 0;\x0a"
"\x0a"
"\x0a"
"if( nn < 0 )\x0a"
"\x09{\x0a"
"\x09sign = -1;\x0a"
"\x09n = -nn;\x0a"
"\x09}\x0a"
"else\x0a"
"\x09{\x0a"
"\x09sign = 1;\x0a"
"\x09n = nn;\x0a"
"\x09}\x0a"
"\x0a"
"/* Overflow detection */\x0a"
"\x0a"
"/* Calculate approximate logarithm of answer */\x0a"
"s = x;\x0a"
"s = frexpl( s, \x26lx );\x0a"
"e = (lx - 1)*n;\x0a"
"if( (e == 0) \x7c\x7c (e > 64) \x7c\x7c (e < -64) )\x0a"
"\x09{\x0a"
"\x09s = (s - 7.0710678118654752e-1L) / (s +  7.0710678118654752e-1L);\x0a"
"\x09s = (2.9142135623730950L * s - 0.5L + lx) * nn * LOGE2L;\x0a"
"\x09}\x0a"
"else\x0a"
"\x09{\x0a"
"\x09s = LOGE2L * e;\x0a"
"\x09}\x0a"
"\x0a"
"if( s > MAXLOGL )\x0a"
"\x09return (huge * huge);\x09\x09/* overflow */\x0a"
"\x0a"
"if( s < MINLOGL )\x0a"
"\x09return (twom10000 * twom10000);\x09/* underflow */\x0a"
"/* Handle tiny denormal answer, but with less accuracy\x0a"
" * since roundoff error in 1.0/x will be amplified.\x0a"
" * The precise demarcation should be the gradual underflow threshold.\x0a"
" */\x0a"
"if( s < (-MAXLOGL+2.0L) )\x0a"
"\x09{\x0a"
"\x09x = 1.0L/x;\x0a"
"\x09sign = -sign;\x0a"
"\x09}\x0a"
"\x0a"
"/* First bit of the power */\x0a"
"if( n \x26 1 )\x0a"
"\x09y = x;\x0a"
"\x09\x09\x0a"
"else\x0a"
"\x09{\x0a"
"\x09y = 1.0L;\x0a"
"\x09""asign = 0;\x0a"
"\x09}\x0a"
"\x0a"
"ww = x;\x0a"
"n >>= 1;\x0a"
"while( n )\x0a"
"\x09{\x0a"
"\x09ww = ww * ww;\x09/* arg to the 2-to-the-kth power */\x0a"
"\x09if( n \x26 1 )\x09/* if that bit is set, then include in product */\x0a"
"\x09\x09y *= ww;\x0a"
"\x09n >>= 1;\x0a"
"\x09}\x0a"
"\x0a"
"if( asign )\x0a"
"\x09y = -y; /* odd power of negative number */\x0a"
"if( sign < 0 )\x0a"
"\x09y = 1.0L/y;\x0a"
"return(y);\x0a"
"}\x0a"
"", 12663 ); }