#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_e_sinhl_c( 
"/* \x40(#)e_sinh.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice\x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* sinhl(x)\x0a"
" * Method \x3a\x0a"
" * mathematically sinh(x) if defined to be (exp(x)-exp(-x))/2\x0a"
" *\x09""1. Replace x by \x7cx\x7c (sinhl(-x) = -sinhl(x)).\x0a"
" *\x09""2.\x0a"
" *\x09\x09                                     E + E/(E+1)\x0a"
" *\x09    0        <= x <= 25     \x3a  sinhl(x) \x3a= --------------, E=expm1l(x)\x0a"
" *\x09\x09\x09       \x09\x09\x09         2\x0a"
" *\x0a"
" *\x09    25       <= x <= lnovft \x3a  sinhl(x) \x3a= expl(x)/2\x0a"
" *\x09    lnovft   <= x <= ln2ovft\x3a  sinhl(x) \x3a= expl(x/2)/2 * expl(x/2)\x0a"
" *\x09    ln2ovft  <  x\x09    \x3a  sinhl(x) \x3a= x*shuge (overflow)\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09sinhl(x) is \x7cx\x7c if x is +INF, -INF, or NaN.\x0a"
" *\x09only sinhl(0)=0 is exact for finite x.\x0a"
" */\x0a"
"\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const long double one = 1.0, shuge = 1.0e4931L;\x0a"
"\x0a"
"long double\x0a"
"sinhl(long double x)\x0a"
"{\x0a"
"\x09long double t,w,h;\x0a"
"\x09u_int32_t jx,ix,i0,i1;\x0a"
"\x0a"
"    /* Words of \x7cx\x7c. */\x0a"
"\x09GET_LDOUBLE_WORDS(jx,i0,i1,x);\x0a"
"\x09ix = jx\x26""0x7fff;\x0a"
"\x0a"
"    /* x is INF or NaN */\x0a"
"\x09if(ix==0x7fff) return x+x;\x0a"
"\x0a"
"\x09h = 0.5;\x0a"
"\x09if (jx \x26 0x8000) h = -h;\x0a"
"    /* \x7cx\x7c in \x5b""0,25\x5d, return sign(x)*0.5*(E+E/(E+1))) */\x0a"
"\x09if (ix < 0x4003 \x7c\x7c (ix == 0x4003 \x26\x26 i0 <= 0xc8000000)) { /* \x7cx\x7c<25 */\x0a"
"\x09    if (ix<0x3fdf)\x09\x09 /* \x7cx\x7c<2**-32 */\x0a"
"\x09\x09if(shuge+x>one) return x;/* sinh(tiny) = tiny with inexact */\x0a"
"\x09    t = expm1l(fabsl(x));\x0a"
"\x09    if(ix<0x3fff) return h*(2.0*t-t*t/(t+one));\x0a"
"\x09    return h*(t+t/(t+one));\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5b""25, log(maxdouble)\x5d return 0.5*exp(\x7cx\x7c) */\x0a"
"\x09if (ix < 0x400c \x7c\x7c (ix == 0x400c \x26\x26 i0 < 0xb17217f7))\x0a"
"\x09\x09return h*expl(fabsl(x));\x0a"
"\x0a"
"    /* \x7cx\x7c in \x5blog(maxdouble), overflowthreshold\x5d */\x0a"
"\x09if (ix<0x400c \x7c\x7c (ix == 0x400c \x26\x26 (i0 < 0xb174ddc0\x0a"
"\x09\x09\x09\x09\x09   \x7c\x7c (i0 == 0xb174ddc0\x0a"
"\x09\x09\x09\x09\x09       \x26\x26 i1 <= 0x31aec0ea)))) {\x0a"
"\x09    w = expl(0.5*fabsl(x));\x0a"
"\x09    t = h*w;\x0a"
"\x09    return t*w;\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c > overflowthreshold, sinhl(x) overflow */\x0a"
"\x09return x*shuge;\x0a"
"}\x0a"
"", 2145 ); }