#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_e_tgammal_c( 
"/*\x09\x24OpenBSD\x3a e_tgammal.c,v 1.4 2013/11/12 20\x3a""35\x3a""19 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09tgammal.c\x0a"
" *\x0a"
" *\x09Gamma function\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double x, y, tgammal();\x0a"
" * extern int signgam;\x0a"
" *\x0a"
" * y = tgammal( x );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Returns gamma function of the argument.  The result is\x0a"
" * correctly signed, and the sign (+1 or -1) is also\x0a"
" * returned in a global (extern) variable named signgam.\x0a"
" * This variable is also filled in by the logarithmic gamma\x0a"
" * function lgamma().\x0a"
" *\x0a"
" * Arguments \x7cx\x7c <= 13 are reduced by recurrence and the function\x0a"
" * approximated by a rational function of degree 7/8 in the\x0a"
" * interval (2,3).  Large arguments are handled by Stirling's\x0a"
" * formula. Large negative arguments are made positive using\x0a"
" * a reflection formula.\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE     -40,+40      10000       3.6e-19     7.9e-20\x0a"
" *    IEEE    -1755,+1755   10000       4.8e-18     6.5e-19\x0a"
" *\x0a"
" * Accuracy for large arguments is dominated by error in powl().\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/*\x0a"
"tgamma(x+2)  = tgamma(x+2) P(x)/Q(x)\x0a"
"0 <= x <= 1\x0a"
"Relative error\x0a"
"n=7, d=8\x0a"
"Peak error =  1.83e-20\x0a"
"Relative error spread =  8.4e-23\x0a"
"*/\x0a"
"\x0a"
"static long double P\x5b""8\x5d = {\x0a"
" 4.212760487471622013093E-5L,\x0a"
" 4.542931960608009155600E-4L,\x0a"
" 4.092666828394035500949E-3L,\x0a"
" 2.385363243461108252554E-2L,\x0a"
" 1.113062816019361559013E-1L,\x0a"
" 3.629515436640239168939E-1L,\x0a"
" 8.378004301573126728826E-1L,\x0a"
" 1.000000000000000000009E0L,\x0a"
"};\x0a"
"static long double Q\x5b""9\x5d = {\x0a"
"-1.397148517476170440917E-5L,\x0a"
" 2.346584059160635244282E-4L,\x0a"
"-1.237799246653152231188E-3L,\x0a"
"-7.955933682494738320586E-4L,\x0a"
" 2.773706565840072979165E-2L,\x0a"
"-4.633887671244534213831E-2L,\x0a"
"-2.243510905670329164562E-1L,\x0a"
" 4.150160950588455434583E-1L,\x0a"
" 9.999999999999999999908E-1L,\x0a"
"};\x0a"
"\x0a"
"/*\x0a"
"static long double P\x5b\x5d = {\x0a"
"-3.01525602666895735709e0L,\x0a"
"-3.25157411956062339893e1L,\x0a"
"-2.92929976820724030353e2L,\x0a"
"-1.70730828800510297666e3L,\x0a"
"-7.96667499622741999770e3L,\x0a"
"-2.59780216007146401957e4L,\x0a"
"-5.99650230220855581642e4L,\x0a"
"-7.15743521530849602425e4L\x0a"
"};\x0a"
"static long double Q\x5b\x5d = {\x0a"
" 1.00000000000000000000e0L,\x0a"
"-1.67955233807178858919e1L,\x0a"
" 8.85946791747759881659e1L,\x0a"
" 5.69440799097468430177e1L,\x0a"
"-1.98526250512761318471e3L,\x0a"
" 3.31667508019495079814e3L,\x0a"
" 1.60577839621734713377e4L,\x0a"
"-2.97045081369399940529e4L,\x0a"
"-7.15743521530849602412e4L\x0a"
"};\x0a"
"*/\x0a"
"#define MAXGAML 1755.455L\x0a"
"/*static const long double LOGPI = 1.14472988584940017414L;*/\x0a"
"\x0a"
"/* Stirling's formula for the gamma function\x0a"
"tgamma(x) = sqrt(2 pi) x^(x-.5) exp(-x) (1 + 1/x P(1/x))\x0a"
"z(x) = x\x0a"
"13 <= x <= 1024\x0a"
"Relative error\x0a"
"n=8, d=0\x0a"
"Peak error =  9.44e-21\x0a"
"Relative error spread =  8.8e-4\x0a"
"*/\x0a"
"\x0a"
"static long double STIR\x5b""9\x5d = {\x0a"
" 7.147391378143610789273E-4L,\x0a"
"-2.363848809501759061727E-5L,\x0a"
"-5.950237554056330156018E-4L,\x0a"
" 6.989332260623193171870E-5L,\x0a"
" 7.840334842744753003862E-4L,\x0a"
"-2.294719747873185405699E-4L,\x0a"
"-2.681327161876304418288E-3L,\x0a"
" 3.472222222230075327854E-3L,\x0a"
" 8.333333333333331800504E-2L,\x0a"
"};\x0a"
"\x0a"
"#define MAXSTIR 1024.0L\x0a"
"static const long double SQTPI = 2.50662827463100050242E0L;\x0a"
"\x0a"
"/* 1/tgamma(x) = z P(z)\x0a"
" * z(x) = 1/x\x0a"
" * 0 < x < 0.03125\x0a"
" * Peak relative error 4.2e-23\x0a"
" */\x0a"
"\x0a"
"static long double S\x5b""9\x5d = {\x0a"
"-1.193945051381510095614E-3L,\x0a"
" 7.220599478036909672331E-3L,\x0a"
"-9.622023360406271645744E-3L,\x0a"
"-4.219773360705915470089E-2L,\x0a"
" 1.665386113720805206758E-1L,\x0a"
"-4.200263503403344054473E-2L,\x0a"
"-6.558780715202540684668E-1L,\x0a"
" 5.772156649015328608253E-1L,\x0a"
" 1.000000000000000000000E0L,\x0a"
"};\x0a"
"\x0a"
"/* 1/tgamma(-x) = z P(z)\x0a"
" * z(x) = 1/x\x0a"
" * 0 < x < 0.03125\x0a"
" * Peak relative error 5.16e-23\x0a"
" * Relative error spread =  2.5e-24\x0a"
" */\x0a"
"\x0a"
"static long double SN\x5b""9\x5d = {\x0a"
" 1.133374167243894382010E-3L,\x0a"
" 7.220837261893170325704E-3L,\x0a"
" 9.621911155035976733706E-3L,\x0a"
"-4.219773343731191721664E-2L,\x0a"
"-1.665386113944413519335E-1L,\x0a"
"-4.200263503402112910504E-2L,\x0a"
" 6.558780715202536547116E-1L,\x0a"
" 5.772156649015328608727E-1L,\x0a"
"-1.000000000000000000000E0L,\x0a"
"};\x0a"
"\x0a"
"static const long double PIL = 3.1415926535897932384626L;\x0a"
"\x0a"
"static long double stirf ( long double );\x0a"
"\x0a"
"/* Gamma function computed by Stirling's formula.\x0a"
" */\x0a"
"static long double stirf(long double x)\x0a"
"{\x0a"
"long double y, w, v;\x0a"
"\x0a"
"w = 1.0L/x;\x0a"
"/* For large x, use rational coefficients from the analytical expansion.  */\x0a"
"if( x > 1024.0L )\x0a"
"\x09w = (((((6.97281375836585777429E-5L * w\x0a"
"\x09\x09+ 7.84039221720066627474E-4L) * w\x0a"
"\x09\x09- 2.29472093621399176955E-4L) * w\x0a"
"\x09\x09- 2.68132716049382716049E-3L) * w\x0a"
"\x09\x09+ 3.47222222222222222222E-3L) * w\x0a"
"\x09\x09+ 8.33333333333333333333E-2L) * w\x0a"
"\x09\x09+ 1.0L;\x0a"
"else\x0a"
"\x09w = 1.0L + w * __polevll( w, STIR, 8 );\x0a"
"y = expl(x);\x0a"
"if( x > MAXSTIR )\x0a"
"\x09{ /* Avoid overflow in pow() */\x0a"
"\x09v = powl( x, 0.5L * x - 0.25L );\x0a"
"\x09y = v * (v / y);\x0a"
"\x09}\x0a"
"else\x0a"
"\x09{\x0a"
"\x09y = powl( x, x - 0.5L ) / y;\x0a"
"\x09}\x0a"
"y = SQTPI * y * w;\x0a"
"return( y );\x0a"
"}\x0a"
"\x0a"
"long double\x0a"
"tgammal(long double x)\x0a"
"{\x0a"
"long double p, q, z;\x0a"
"int i;\x0a"
"\x0a"
"signgam = 1;\x0a"
"if( isnan(x) )\x0a"
"\x09return(NAN);\x0a"
"if(x == INFINITY)\x0a"
"\x09return(INFINITY);\x0a"
"if(x == -INFINITY)\x0a"
"\x09return(x - x);\x0a"
"if( x == 0.0L )\x0a"
"\x09return( 1.0L / x );\x0a"
"q = fabsl(x);\x0a"
"\x0a"
"if( q > 13.0L )\x0a"
"\x09{\x0a"
"\x09if( q > MAXGAML )\x0a"
"\x09\x09goto goverf;\x0a"
"\x09if( x < 0.0L )\x0a"
"\x09\x09{\x0a"
"\x09\x09p = floorl(q);\x0a"
"\x09\x09if( p == q )\x0a"
"\x09\x09\x09return (x - x) / (x - x);\x0a"
"\x09\x09i = p;\x0a"
"\x09\x09if( (i \x26 1) == 0 )\x0a"
"\x09\x09\x09signgam = -1;\x0a"
"\x09\x09z = q - p;\x0a"
"\x09\x09if( z > 0.5L )\x0a"
"\x09\x09\x09{\x0a"
"\x09\x09\x09p += 1.0L;\x0a"
"\x09\x09\x09z = q - p;\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09z = q * sinl( PIL * z );\x0a"
"\x09\x09z = fabsl(z) * stirf(q);\x0a"
"\x09\x09if( z <= PIL/LDBL_MAX )\x0a"
"\x09\x09\x09{\x0a"
"goverf\x3a\x0a"
"\x09\x09\x09return( signgam * INFINITY);\x0a"
"\x09\x09\x09}\x0a"
"\x09\x09z = PIL/z;\x0a"
"\x09\x09}\x0a"
"\x09""else\x0a"
"\x09\x09{\x0a"
"\x09\x09z = stirf(x);\x0a"
"\x09\x09}\x0a"
"\x09return( signgam * z );\x0a"
"\x09}\x0a"
"\x0a"
"z = 1.0L;\x0a"
"while( x >= 3.0L )\x0a"
"\x09{\x0a"
"\x09x -= 1.0L;\x0a"
"\x09z *= x;\x0a"
"\x09}\x0a"
"\x0a"
"while( x < -0.03125L )\x0a"
"\x09{\x0a"
"\x09z /= x;\x0a"
"\x09x += 1.0L;\x0a"
"\x09}\x0a"
"\x0a"
"if( x <= 0.03125L )\x0a"
"\x09goto small;\x0a"
"\x0a"
"while( x < 2.0L )\x0a"
"\x09{\x0a"
"\x09z /= x;\x0a"
"\x09x += 1.0L;\x0a"
"\x09}\x0a"
"\x0a"
"if( x == 2.0L )\x0a"
"\x09return(z);\x0a"
"\x0a"
"x -= 2.0L;\x0a"
"p = __polevll( x, P, 7 );\x0a"
"q = __polevll( x, Q, 8 );\x0a"
"z = z * p / q;\x0a"
"if( z < 0 )\x0a"
"\x09signgam = -1;\x0a"
"return z;\x0a"
"\x0a"
"small\x3a\x0a"
"if( x == 0.0L )\x0a"
"\x09return (x - x) / (x - x);\x0a"
"else\x0a"
"\x09{\x0a"
"\x09if( x < 0.0L )\x0a"
"\x09\x09{\x0a"
"\x09\x09x = -x;\x0a"
"\x09\x09q = z / (x * __polevll( x, SN, 8 ));\x0a"
"\x09\x09signgam = -1;\x0a"
"\x09\x09}\x0a"
"\x09""else\x0a"
"\x09\x09q = z / (x * __polevll( x, S, 8 ));\x0a"
"\x09}\x0a"
"return q;\x0a"
"}\x0a"
"", 6736 ); }