#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_k_cosl_c( 
"/*\x09\x24OpenBSD\x3a k_cosl.c,v 1.1 2008/12/09 20\x3a""00\x3a""35 martynas Exp \x24\x09*/\x0a"
"/* From\x3a \x40(#)k_cos.c 1.3 95/01/18 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" * Copyright (c) 2008 Steven G. Kargl, David Schultz, Bruce D. Evans.\x0a"
" *\x0a"
" * Developed at SunSoft, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ld80 version of k_cos.c.  See ../k_cos.c for most comments.\x0a"
" */\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/*\x0a"
" * Domain \x5b-0.7854, 0.7854\x5d, range \x7e\x5b-2.43e-23, 2.425e-23\x5d\x3a\x0a"
" * \x7c""cos(x) - c(x)\x7c < 2**-75.1\x0a"
" *\x0a"
" * The coefficients of c(x) were generated by a pari-gp script using\x0a"
" * a Remez algorithm that searches for the best higher coefficients\x0a"
" * after rounding leading coefficients to a specified precision.\x0a"
" *\x0a"
" * Simpler methods like Chebyshev or basic Remez barely suffice for\x0a"
" * cos() in 64-bit precision, because we want the coefficient of x^2\x0a"
" * to be precisely -0.5 so that multiplying by it is exact, and plain\x0a"
" * rounding of the coefficients of a good polynomial approximation only\x0a"
" * gives this up to about 64-bit precision.  Plain rounding also gives\x0a"
" * a mediocre approximation for the coefficient of x^4, but a rounding\x0a"
" * error of 0.5 ulps for this coefficient would only contribute \x7e""0.01\x0a"
" * ulps to the final error, so this is unimportant.  Rounding errors in\x0a"
" * higher coefficients are even less important.\x0a"
" *\x0a"
" * In fact, coefficients above the x^4 one only need to have 53-bit\x0a"
" * precision, and this is more efficient.  We get this optimization\x0a"
" * almost for free from the complications needed to search for the best\x0a"
" * higher coefficients.\x0a"
" */\x0a"
"static const double\x0a"
"one = 1.0;\x0a"
"\x0a"
"#if defined(__amd64__) \x7c\x7c defined(__i386__)\x0a"
"/* Long double constants are slow on these arches, and broken on i386. */\x0a"
"static const volatile double\x0a"
"C1hi = 0.041666666666666664,\x09\x09/*  0x15555555555555.0p-57 */\x0a"
"C1lo = 2.2598839032744733e-18;\x09\x09/*  0x14d80000000000.0p-111 */\x0a"
"#define\x09""C1\x09((long double)C1hi + C1lo)\x0a"
"#else\x0a"
"static const long double\x0a"
"C1 =  0.0416666666666666666136L;\x09/*  0xaaaaaaaaaaaaaa9b.0p-68 */\x0a"
"#endif\x0a"
"\x0a"
"static const double\x0a"
"C2 = -0.0013888888888888874,\x09\x09/* -0x16c16c16c16c10.0p-62 */\x0a"
"C3 =  0.000024801587301571716,\x09\x09/*  0x1a01a01a018e22.0p-68 */\x0a"
"C4 = -0.00000027557319215507120,\x09/* -0x127e4fb7602f22.0p-74 */\x0a"
"C5 =  0.0000000020876754400407278,\x09/*  0x11eed8caaeccf1.0p-81 */\x0a"
"C6 = -1.1470297442401303e-11,\x09\x09/* -0x19393412bd1529.0p-89 */\x0a"
"C7 =  4.7383039476436467e-14;\x09\x09/*  0x1aac9d9af5c43e.0p-97 */\x0a"
"\x0a"
"long double\x0a"
"__kernel_cosl(long double x, long double y)\x0a"
"{\x0a"
"\x09long double hz,z,r,w;\x0a"
"\x0a"
"\x09z  = x*x;\x0a"
"\x09r  = z*(C1+z*(C2+z*(C3+z*(C4+z*(C5+z*(C6+z*C7))))));\x0a"
"\x09hz = 0.5*z;\x0a"
"\x09w  = one-hz;\x0a"
"\x09return w + (((one-w)-hz) + (z*r-x*y));\x0a"
"}\x0a"
"", 2858 ); }