#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_s_cbrtl_c( 
"/*-\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" * Copyright (c) 2009-2011, Bruce D. Evans, Steven G. Kargl, David Schultz.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice\x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" *\x0a"
" * The argument reduction and testing for exceptional cases was\x0a"
" * written by Steven G. Kargl with input from Bruce D. Evans\x0a"
" * and David A. Schultz.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <ieeefp.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"#define\x09""BIAS\x09(LDBL_MAX_EXP - 1)\x0a"
"\x0a"
"static const unsigned\x0a"
"    B1 = 709958130;\x09/* B1 = (127-127.0/3-0.03306235651)*2**23 */\x0a"
"\x0a"
"long double\x0a"
"cbrtl(long double x)\x0a"
"{\x0a"
"\x09long double v, r, s, t, w;\x0a"
"\x09""double dr, dt, dx;\x0a"
"\x09""float ft, fx;\x0a"
"\x09uint32_t hx, lx;\x0a"
"\x09uint16_t expsign, es;\x0a"
"\x09int k;\x0a"
"\x09volatile double vd1, vd2;\x0a"
"\x0a"
"\x09GET_LDOUBLE_EXP(expsign,x);\x0a"
"\x09k = expsign \x26 0x7fff;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * If x = +-Inf, then cbrt(x) = +-Inf.\x0a"
"\x09 * If x = NaN, then cbrt(x) = NaN.\x0a"
"\x09 */\x0a"
"\x09if (k == BIAS + LDBL_MAX_EXP)\x0a"
"\x09\x09return (x + x);\x0a"
"\x0a"
"\x09if (k == 0) {\x0a"
"\x09\x09/* If x = +-0, then cbrt(x) = +-0. */\x0a"
"\x09\x09GET_LDOUBLE_WORDS(es,hx,lx,x);\x0a"
"\x09\x09if ((hx\x7clx) == 0) {\x0a"
"\x09\x09\x09return (x);\x0a"
"\x09\x09}\x0a"
"\x09\x09/* Adjust subnormal numbers. */\x0a"
"\x09\x09x *= 0x1.0p514;\x0a"
"\x09\x09GET_LDOUBLE_EXP(k,x);\x0a"
"\x09\x09k \x26= 0x7fff;\x0a"
"\x09\x09k -= BIAS + 514;\x0a"
"\x09} else\x0a"
"\x09\x09k -= BIAS;\x0a"
"\x09SET_LDOUBLE_EXP(x,BIAS);\x0a"
"\x09v = 1;\x0a"
"\x0a"
"\x09switch (k \x25 3) {\x0a"
"\x09""case 1\x3a\x0a"
"\x09""case -2\x3a\x0a"
"\x09\x09x = 2*x;\x0a"
"\x09\x09k--;\x0a"
"\x09\x09""break;\x0a"
"\x09""case 2\x3a\x0a"
"\x09""case -1\x3a\x0a"
"\x09\x09x = 4*x;\x0a"
"\x09\x09k -= 2;\x0a"
"\x09\x09""break;\x0a"
"\x09}\x0a"
"\x09SET_LDOUBLE_EXP(v, (expsign \x26 0x8000) \x7c (BIAS + k / 3));\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * The following is the guts of s_cbrtf, with the handling of\x0a"
"\x09 * special values removed and extra care for accuracy not taken,\x0a"
"\x09 * but with most of the extra accuracy not discarded.\x0a"
"\x09 */\x0a"
"\x0a"
"\x09/* \x7e""5-bit estimate\x3a */\x0a"
"\x09""fx = x;\x0a"
"\x09GET_FLOAT_WORD(hx, fx);\x0a"
"\x09SET_FLOAT_WORD(ft, ((hx \x26 0x7fffffff) / 3 + B1));\x0a"
"\x0a"
"\x09/* \x7e""16-bit estimate\x3a */\x0a"
"\x09""dx = x;\x0a"
"\x09""dt = ft;\x0a"
"\x09""dr = dt * dt * dt;\x0a"
"\x09""dt = dt * (dx + dx + dr) / (dx + dr + dr);\x0a"
"\x0a"
"\x09/* \x7e""47-bit estimate\x3a */\x0a"
"\x09""dr = dt * dt * dt;\x0a"
"\x09""dt = dt * (dx + dx + dr) / (dx + dr + dr);\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * dt is cbrtl(x) to \x7e""47 bits (after x has been reduced to 1 <= x < 8).\x0a"
"\x09 * Round it away from zero to 32 bits (32 so that t*t is exact, and\x0a"
"\x09 * away from zero for technical reasons).\x0a"
"\x09 */\x0a"
"\x09vd2 = 0x1.0p32;\x0a"
"\x09vd1 = 0x1.0p-31;\x0a"
"\x09#define vd ((long double)vd2 + vd1)\x0a"
"\x0a"
"\x09t = dt + vd - 0x1.0p32;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * Final step Newton iteration to 64 or 113 bits with\x0a"
"\x09 * error < 0.667 ulps\x0a"
"\x09 */\x0a"
"\x09s=t*t;\x09\x09\x09\x09/* t*t is exact */\x0a"
"\x09r=x/s;\x09\x09\x09\x09/* error <= 0.5 ulps; \x7cr\x7c < \x7ct\x7c */\x0a"
"\x09w=t+t;\x09\x09\x09\x09/* t+t is exact */\x0a"
"\x09r=(r-t)/(w+r);\x09\x09\x09/* r-t is exact; w+r \x7e= 3*t */\x0a"
"\x09t=t+t*r;\x09\x09\x09/* error <= 0.5 + 0.5/3 + epsilon */\x0a"
"\x0a"
"\x09t *= v;\x0a"
"\x09return (t);\x0a"
"}\x0a"
"", 2762 ); }