#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_s_floorl_c( 
"/* \x40(#)s_floor.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice\x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * floorl(x)\x0a"
" * Return x rounded toward -inf to integral value\x0a"
" * Method\x3a\x0a"
" *\x09""Bit twiddling.\x0a"
" * Exception\x3a\x0a"
" *\x09Inexact flag raised if x not equal to floor(x).\x0a"
" */\x0a"
"\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const long double huge = 1.0e4930L;\x0a"
"\x0a"
"long double\x0a"
"floorl(long double x)\x0a"
"{\x0a"
"\x09int32_t i1,jj0;\x0a"
"\x09u_int32_t i,j,se,i0,sx;\x0a"
"\x09GET_LDOUBLE_WORDS(se,i0,i1,x);\x0a"
"\x09sx = (se>>15)\x26""1;\x0a"
"\x09jj0 = (se\x26""0x7fff)-0x3fff;\x0a"
"\x09if(jj0<31) {\x0a"
"\x09    if(jj0<0) {\x09/* raise inexact if x \x21= 0 */\x0a"
"\x09\x09if(huge+x>0.0) {\x0a"
"\x09\x09    if(sx==0)\x0a"
"\x09\x09\x09return 0.0L;\x0a"
"\x09\x09    else if(((se\x26""0x7fff)\x7ci0\x7ci1)\x21=0)\x0a"
"\x09\x09\x09return -1.0L;\x0a"
"\x09\x09}\x0a"
"\x09    } else {\x0a"
"\x09\x09i = (0x7fffffff)>>jj0;\x0a"
"\x09\x09if(((i0\x26i)\x7ci1)==0) return x; /* x is integral */\x0a"
"\x09\x09if(huge+x>0.0) {\x09/* raise inexact flag */\x0a"
"\x09\x09    if(sx) {\x0a"
"\x09\x09\x09if (jj0>0 \x26\x26 (i0+(0x80000000>>jj0))>i0)\x0a"
"\x09\x09\x09  i0 += (0x80000000)>>jj0;\x0a"
"\x09\x09\x09""else\x0a"
"\x09\x09\x09  {\x0a"
"\x09\x09\x09    i = 0x7fffffff;\x0a"
"\x09\x09\x09    ++se;\x0a"
"\x09\x09\x09  }\x0a"
"\x09\x09    }\x0a"
"\x09\x09    i0 \x26= (\x7ei); i1=0;\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09} else if (jj0>62) {\x0a"
"\x09    if(jj0==0x4000) return x+x;\x09/* inf or NaN */\x0a"
"\x09    else return x;\x09\x09/* x is integral */\x0a"
"\x09} else {\x0a"
"\x09    i = ((u_int32_t)(0xffffffff))>>(jj0-31);\x0a"
"\x09    if((i1\x26i)==0) return x;\x09/* x is integral */\x0a"
"\x09    if(huge+x>0.0) {\x09\x09/* raise inexact flag */\x0a"
"\x09\x09if(sx) {\x0a"
"\x09\x09    if(jj0==31) i0+=1;\x0a"
"\x09\x09    else {\x0a"
"\x09\x09\x09j = i1+(1<<(63-jj0));\x0a"
"\x09\x09\x09if(j<i1) i0 +=1 ;\x09/* got a carry */\x0a"
"\x09\x09\x09i1=j;\x0a"
"\x09\x09    }\x0a"
"\x09\x09}\x0a"
"\x09\x09i1 \x26= (\x7ei);\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09SET_LDOUBLE_WORDS(x,se,i0,i1);\x0a"
"\x09return x;\x0a"
"}\x0a"
"", 1787 ); }