#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_s_log1pl_c( 
"/*\x09\x24OpenBSD\x3a s_log1pl.c,v 1.3 2013/11/12 20\x3a""35\x3a""19 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09log1pl.c\x0a"
" *\x0a"
" *      Relative error logarithm\x0a"
" *\x09Natural logarithm of 1+x, long double precision\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double x, y, log1pl();\x0a"
" *\x0a"
" * y = log1pl( x );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Returns the base e (2.718...) logarithm of 1+x.\x0a"
" *\x0a"
" * The argument 1+x is separated into its exponent and fractional\x0a"
" * parts.  If the exponent is between -1 and +1, the logarithm\x0a"
" * of the fraction is approximated by\x0a"
" *\x0a"
" *     log(1+x) = x - 0.5 x^2 + x^3 P(x)/Q(x).\x0a"
" *\x0a"
" * Otherwise, setting  z = 2(x-1)/x+1),\x0a"
" *\x0a"
" *     log(x) = z + z^3 P(z)/Q(z).\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE     -1.0, 9.0    100000      8.2e-20    2.5e-20\x0a"
" *\x0a"
" * ERROR MESSAGES\x3a\x0a"
" *\x0a"
" * log singularity\x3a  x-1 = 0; returns -INFINITY\x0a"
" * log domain\x3a       x-1 < 0; returns NAN\x0a"
" */\x0a"
"\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/* Coefficients for log(1+x) = x - x^2 / 2 + x^3 P(x)/Q(x)\x0a"
" * 1/sqrt(2) <= x < sqrt(2)\x0a"
" * Theoretical peak relative error = 2.32e-20\x0a"
" */\x0a"
"\x0a"
"static long double P\x5b\x5d = {\x0a"
" 4.5270000862445199635215E-5L,\x0a"
" 4.9854102823193375972212E-1L,\x0a"
" 6.5787325942061044846969E0L,\x0a"
" 2.9911919328553073277375E1L,\x0a"
" 6.0949667980987787057556E1L,\x0a"
" 5.7112963590585538103336E1L,\x0a"
" 2.0039553499201281259648E1L,\x0a"
"};\x0a"
"static long double Q\x5b\x5d = {\x0a"
"/* 1.0000000000000000000000E0,*/\x0a"
" 1.5062909083469192043167E1L,\x0a"
" 8.3047565967967209469434E1L,\x0a"
" 2.2176239823732856465394E2L,\x0a"
" 3.0909872225312059774938E2L,\x0a"
" 2.1642788614495947685003E2L,\x0a"
" 6.0118660497603843919306E1L,\x0a"
"};\x0a"
"\x0a"
"/* Coefficients for log(x) = z + z^3 P(z^2)/Q(z^2),\x0a"
" * where z = 2(x-1)/(x+1)\x0a"
" * 1/sqrt(2) <= x < sqrt(2)\x0a"
" * Theoretical peak relative error = 6.16e-22\x0a"
" */\x0a"
"\x0a"
"static long double R\x5b""4\x5d = {\x0a"
" 1.9757429581415468984296E-3L,\x0a"
"-7.1990767473014147232598E-1L,\x0a"
" 1.0777257190312272158094E1L,\x0a"
"-3.5717684488096787370998E1L,\x0a"
"};\x0a"
"static long double S\x5b""4\x5d = {\x0a"
"/* 1.00000000000000000000E0L,*/\x0a"
"-2.6201045551331104417768E1L,\x0a"
" 1.9361891836232102174846E2L,\x0a"
"-4.2861221385716144629696E2L,\x0a"
"};\x0a"
"static const long double C1 = 6.9314575195312500000000E-1L;\x0a"
"static const long double C2 = 1.4286068203094172321215E-6L;\x0a"
"\x0a"
"#define SQRTH 0.70710678118654752440L\x0a"
"\x0a"
"long double\x0a"
"log1pl(long double xm1)\x0a"
"{\x0a"
"long double x, y, z;\x0a"
"int e;\x0a"
"\x0a"
"if( isnan(xm1) )\x0a"
"\x09return(xm1);\x0a"
"if( xm1 == INFINITY )\x0a"
"\x09return(xm1);\x0a"
"if(xm1 == 0.0)\x0a"
"\x09return(xm1);\x0a"
"\x0a"
"x = xm1 + 1.0L;\x0a"
"\x0a"
"/* Test for domain errors.  */\x0a"
"if( x <= 0.0L )\x0a"
"\x09{\x0a"
"\x09if( x == 0.0L )\x0a"
"\x09\x09return( -INFINITY );\x0a"
"\x09""else\x0a"
"\x09\x09return( NAN );\x0a"
"\x09}\x0a"
"\x0a"
"/* Separate mantissa from exponent.\x0a"
"   Use frexp so that denormal numbers will be handled properly.  */\x0a"
"x = frexpl( x, \x26""e );\x0a"
"\x0a"
"/* logarithm using log(x) = z + z^3 P(z)/Q(z),\x0a"
"   where z = 2(x-1)/x+1)  */\x0a"
"if( (e > 2) \x7c\x7c (e < -2) )\x0a"
"{\x0a"
"if( x < SQRTH )\x0a"
"\x09{ /* 2( 2x-1 )/( 2x+1 ) */\x0a"
"\x09""e -= 1;\x0a"
"\x09z = x - 0.5L;\x0a"
"\x09y = 0.5L * z + 0.5L;\x0a"
"\x09}\x09\x0a"
"else\x0a"
"\x09{ /*  2 (x-1)/(x+1)   */\x0a"
"\x09z = x - 0.5L;\x0a"
"\x09z -= 0.5L;\x0a"
"\x09y = 0.5L * x  + 0.5L;\x0a"
"\x09}\x0a"
"x = z / y;\x0a"
"z = x*x;\x0a"
"z = x * ( z * __polevll( z, R, 3 ) / __p1evll( z, S, 3 ) );\x0a"
"z = z + e * C2;\x0a"
"z = z + x;\x0a"
"z = z + e * C1;\x0a"
"return( z );\x0a"
"}\x0a"
"\x0a"
"\x0a"
"/* logarithm using log(1+x) = x - .5x**2 + x**3 P(x)/Q(x) */\x0a"
"\x0a"
"if( x < SQRTH )\x0a"
"\x09{\x0a"
"\x09""e -= 1;\x0a"
"\x09if (e \x21= 0)\x0a"
"\x09  x = 2.0 * x - 1.0L;\x0a"
"\x09""else\x0a"
"\x09  x = xm1;\x0a"
"\x09}\x09\x0a"
"else\x0a"
"\x09{\x0a"
"\x09  if (e \x21= 0)\x0a"
"\x09    x = x - 1.0L;\x0a"
"\x09  else\x0a"
"\x09    x = xm1;\x0a"
"\x09}\x0a"
"z = x*x;\x0a"
"y = x * ( z * __polevll( x, P, 6 ) / __p1evll( x, Q, 6 ) );\x0a"
"y = y + e * C2;\x0a"
"z = y - 0.5 * z;\x0a"
"z = z + x;\x0a"
"z = z + e * C1;\x0a"
"return( z );\x0a"
"}\x0a"
"", 4231 ); }