#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_s_nextafterl_c( 
"/* \x40(#)s_nextafter.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice\x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* IEEE functions\x0a"
" *\x09nextafterl(x,y)\x0a"
" *\x09return the next machine floating-point number of x in the\x0a"
" *\x09""direction toward y.\x0a"
" *   Special cases\x3a\x0a"
" */\x0a"
"\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"long double\x0a"
"nextafterl(long double x, long double y)\x0a"
"{\x0a"
"\x09int32_t hx,hy,ix,iy;\x0a"
"\x09u_int32_t lx,ly;\x0a"
"\x09int32_t esx,esy;\x0a"
"\x0a"
"\x09GET_LDOUBLE_WORDS(esx,hx,lx,x);\x0a"
"\x09GET_LDOUBLE_WORDS(esy,hy,ly,y);\x0a"
"\x09ix = esx\x26""0x7fff;\x09\x09/* \x7cx\x7c */\x0a"
"\x09iy = esy\x26""0x7fff;\x09\x09/* \x7cy\x7c */\x0a"
"\x0a"
"\x09if (((ix==0x7fff)\x26\x26((hx\x26""0x7fffffff\x7clx)\x21=0)) \x7c\x7c   /* x is nan */\x0a"
"\x09    ((iy==0x7fff)\x26\x26((hy\x26""0x7fffffff\x7cly)\x21=0)))     /* y is nan */\x0a"
"\x09   return x+y;\x0a"
"\x09if(x==y) return y;\x09\x09/* x=y, return y */\x0a"
"\x09if((ix\x7chx\x7clx)==0) {\x09\x09\x09/* x == 0 */\x0a"
"\x09    volatile long double u;\x0a"
"\x09    SET_LDOUBLE_WORDS(x,esy\x26""0x8000,0,1);/* return +-minsubnormal */\x0a"
"\x09    u = x;\x0a"
"\x09    u = u * u;\x09\x09\x09\x09/* raise underflow flag */\x0a"
"\x09    return x;\x0a"
"\x09}\x0a"
"\x09if(esx>=0) {\x09\x09\x09/* x > 0 */\x0a"
"\x09    if(esx>esy\x7c\x7c((esx==esy) \x26\x26 (hx>hy\x7c\x7c((hx==hy)\x26\x26(lx>ly))))) {\x0a"
"\x09      /* x > y, x -= ulp */\x0a"
"\x09\x09if(lx==0) {\x0a"
"\x09\x09    if ((hx\x26""0x7fffffff)==0) esx -= 1;\x0a"
"\x09\x09    hx = (hx - 1) \x7c (hx \x26 0x80000000);\x0a"
"\x09\x09}\x0a"
"\x09\x09lx -= 1;\x0a"
"\x09    } else {\x09\x09\x09\x09/* x < y, x += ulp */\x0a"
"\x09\x09lx += 1;\x0a"
"\x09\x09if(lx==0) {\x0a"
"\x09\x09    hx = (hx + 1) \x7c (hx \x26 0x80000000);\x0a"
"\x09\x09    if ((hx\x26""0x7fffffff)==0) esx += 1;\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09} else {\x09\x09\x09\x09/* x < 0 */\x0a"
"\x09    if(esy>=0\x7c\x7c(esx>esy\x7c\x7c((esx==esy)\x26\x26(hx>hy\x7c\x7c((hx==hy)\x26\x26(lx>ly)))))){\x0a"
"\x09      /* x < y, x -= ulp */\x0a"
"\x09\x09if(lx==0) {\x0a"
"\x09\x09    if ((hx\x26""0x7fffffff)==0) esx -= 1;\x0a"
"\x09\x09    hx = (hx - 1) \x7c (hx \x26 0x80000000);\x0a"
"\x09\x09}\x0a"
"\x09\x09lx -= 1;\x0a"
"\x09    } else {\x09\x09\x09\x09/* x > y, x += ulp */\x0a"
"\x09\x09lx += 1;\x0a"
"\x09\x09if(lx==0) {\x0a"
"\x09\x09    hx = (hx + 1) \x7c (hx \x26 0x80000000);\x0a"
"\x09\x09    if ((hx\x26""0x7fffffff)==0) esx += 1;\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09""esy = esx\x26""0x7fff;\x0a"
"\x09if(esy==0x7fff) return x+x;\x09\x09/* overflow  */\x0a"
"\x09if(esy==0) {\x0a"
"\x09    volatile long double u = x*x;\x09/* underflow */\x0a"
"\x09    if(u==x) {\x0a"
"\x09\x09SET_LDOUBLE_WORDS(x,esx,hx,lx);\x0a"
"\x09\x09return x;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09SET_LDOUBLE_WORDS(x,esx,hx,lx);\x0a"
"\x09return x;\x0a"
"}\x0a"
"\x0a"
"//__strong_alias(nexttowardl, nextafterl);\x0a"
"", 2321 ); }