#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_ld80_s_remquol_c( 
"/* \x40(#)e_fmod.c 1.3 95/01/18 */\x0a"
"/*-\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunSoft, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include <sys/types.h>\x0a"
"#include <machine/ieee.h>\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"#define\x09""BIAS (LDBL_MAX_EXP - 1)\x0a"
"\x0a"
"/*\x0a"
" * These macros add and remove an explicit integer bit in front of the\x0a"
" * fractional mantissa, if the architecture doesn't have such a bit by\x0a"
" * default already.\x0a"
" */\x0a"
"#ifdef LDBL_IMPLICIT_NBIT\x0a"
"#define\x09LDBL_NBIT\x09""0\x0a"
"#define\x09SET_NBIT(hx)\x09((hx) \x7c (1ULL << LDBL_MANH_SIZE))\x0a"
"#define\x09HFRAC_BITS\x09""EXT_FRACHBITS\x0a"
"#else\x0a"
"#define\x09LDBL_NBIT\x09""0x80000000\x0a"
"#define\x09SET_NBIT(hx)\x09(hx)\x0a"
"#define\x09HFRAC_BITS\x09(EXT_FRACHBITS - 1)\x0a"
"#endif\x0a"
"\x0a"
"#define\x09MANL_SHIFT\x09(EXT_FRACLBITS - 1)\x0a"
"\x0a"
"static const long double Zero\x5b\x5d = {0.0L, -0.0L};\x0a"
"\x0a"
"/*\x0a"
" * Return the IEEE remainder and set *quo to the last n bits of the\x0a"
" * quotient, rounded to the nearest integer.  We choose n=31 because\x0a"
" * we wind up computing all the integer bits of the quotient anyway as\x0a"
" * a side-effect of computing the remainder by the shift and subtract\x0a"
" * method.  In practice, this is far more bits than are needed to use\x0a"
" * remquo in reduction algorithms.\x0a"
" *\x0a"
" * Assumptions\x3a\x0a"
" * - The low part of the mantissa fits in a manl_t exactly.\x0a"
" * - The high part of the mantissa fits in an int64_t with enough room\x0a"
" *   for an explicit integer bit in front of the fractional bits.\x0a"
" */\x0a"
"long double\x0a"
"remquol(long double x, long double y, int *quo)\x0a"
"{\x0a"
"\x09int64_t hx,hz;\x09/* We need a carry bit even if LDBL_MANH_SIZE is 32. */\x0a"
"\x09uint32_t hy;\x0a"
"\x09uint32_t lx,ly,lz;\x0a"
"\x09uint32_t esx, esy;\x0a"
"\x09int ix,iy,n,q,sx,sxy;\x0a"
"\x0a"
"\x09GET_LDOUBLE_WORDS(esx,hx,lx,x);\x0a"
"\x09GET_LDOUBLE_WORDS(esy,hy,ly,y);\x0a"
"\x09sx = esx \x26 0x8000;\x0a"
"\x09sxy = sx ^ (esy \x26 0x8000);\x0a"
"\x09""esx \x26= 0x7fff;\x09\x09\x09\x09/* \x7cx\x7c */\x0a"
"\x09""esy \x26= 0x7fff;\x09\x09\x09\x09/* \x7cy\x7c */\x0a"
"\x09SET_LDOUBLE_EXP(x,esx);\x0a"
"\x09SET_LDOUBLE_EXP(y,esy);\x0a"
"\x0a"
"    /* purge off exception values */\x0a"
"\x09if((esy\x7chy\x7cly)==0 \x7c\x7c\x09\x09\x09/* y=0 */\x0a"
"\x09   (esx == BIAS + LDBL_MAX_EXP) \x7c\x7c\x09/* or x not finite */\x0a"
"\x09   (esy == BIAS + LDBL_MAX_EXP \x26\x26\x0a"
"\x09    ((hy\x26\x7eLDBL_NBIT)\x7cly)\x21=0))\x09\x09/* or y is NaN */\x0a"
"\x09    return (x*y)/(x*y);\x0a"
"\x09if(esx<=esy) {\x0a"
"\x09    if((esx<esy) \x7c\x7c\x0a"
"\x09       (hx<=hy \x26\x26\x0a"
"\x09\x09(hx<hy \x7c\x7c\x0a"
"\x09\x09 lx<ly))) {\x0a"
"\x09\x09q = 0;\x0a"
"\x09\x09goto fixup;\x09\x09\x09/* \x7cx\x7c<\x7cy\x7c return x or x-y */\x0a"
"\x09    }\x0a"
"\x09    if(hx==hy \x26\x26 lx==ly) {\x0a"
"\x09\x09*quo = 1;\x0a"
"\x09\x09return Zero\x5bsx\x21=0\x5d;\x09\x09/* \x7cx\x7c=\x7cy\x7c return x*0*/\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* determine ix = ilogb(x) */\x0a"
"\x09if(esx == 0) {\x09\x09\x09\x09/* subnormal x */\x0a"
"\x09    x *= 0x1.0p512;\x0a"
"\x09    GET_LDOUBLE_WORDS(esx,hx,lx,x);\x0a"
"\x09    ix = esx - (BIAS + 512);\x0a"
"\x09} else {\x0a"
"\x09    ix = esx - BIAS;\x0a"
"\x09}\x0a"
"\x0a"
"    /* determine iy = ilogb(y) */\x0a"
"\x09if(esy == 0) {\x09\x09\x09\x09/* subnormal y */\x0a"
"\x09    y *= 0x1.0p512;\x0a"
"\x09    GET_LDOUBLE_WORDS(esy,hy,ly,y);\x0a"
"\x09    iy = esy - (BIAS + 512);\x0a"
"\x09} else {\x0a"
"\x09    iy = esy - BIAS;\x0a"
"\x09}\x0a"
"\x0a"
"    /* set up {hx,lx}, {hy,ly} and align y to x */\x0a"
"\x09hx = SET_NBIT(hx);\x0a"
"\x09lx = SET_NBIT(lx);\x0a"
"\x0a"
"    /* fix point fmod */\x0a"
"\x09n = ix - iy;\x0a"
"\x09q = 0;\x0a"
"\x0a"
"\x09while(n--) {\x0a"
"\x09    hz=hx-hy;lz=lx-ly; if(lx<ly) hz -= 1;\x0a"
"\x09    if(hz<0){hx = hx+hx+(lx>>MANL_SHIFT); lx = lx+lx;}\x0a"
"\x09    else {hx = hz+hz+(lz>>MANL_SHIFT); lx = lz+lz; q++;}\x0a"
"\x09    q <<= 1;\x0a"
"\x09}\x0a"
"\x09hz=hx-hy;lz=lx-ly; if(lx<ly) hz -= 1;\x0a"
"\x09if(hz>=0) {hx=hz;lx=lz;q++;}\x0a"
"\x0a"
"    /* convert back to floating value and restore the sign */\x0a"
"\x09if((hx\x7clx)==0) {\x09\x09\x09/* return sign(x)*0 */\x0a"
"\x09    *quo = (sxy \x3f -q \x3a q);\x0a"
"\x09    return Zero\x5bsx\x21=0\x5d;\x0a"
"\x09}\x0a"
"\x09while(hx<(1ULL<<HFRAC_BITS)) {\x09/* normalize x */\x0a"
"\x09    hx = hx+hx+(lx>>MANL_SHIFT); lx = lx+lx;\x0a"
"\x09    iy -= 1;\x0a"
"\x09}\x0a"
"\x09if (iy < LDBL_MIN_EXP) {\x0a"
"\x09    esx = (iy + BIAS + 512) \x26 0x7fff;\x0a"
"\x09    SET_LDOUBLE_WORDS(x,esx,hx,lx);\x0a"
"\x09    x *= 0x1p-512;\x0a"
"\x09    GET_LDOUBLE_WORDS(esx,hx,lx,x);\x0a"
"\x09} else {\x0a"
"\x09    esx = (iy + BIAS) \x26 0x7fff;\x0a"
"\x09}\x0a"
"\x09SET_LDOUBLE_WORDS(x,esx,hx,lx);\x0a"
"fixup\x3a\x0a"
"\x09y = fabsl(y);\x0a"
"\x09if (y < LDBL_MIN * 2) {\x0a"
"\x09    if (x+x>y \x7c\x7c (x+x==y \x26\x26 (q \x26 1))) {\x0a"
"\x09\x09q++;\x0a"
"\x09\x09x-=y;\x0a"
"\x09    }\x0a"
"\x09} else if (x>0.5*y \x7c\x7c (x==0.5*y \x26\x26 (q \x26 1))) {\x0a"
"\x09    q++;\x0a"
"\x09    x-=y;\x0a"
"\x09}\x0a"
"\x0a"
"\x09GET_LDOUBLE_EXP(esx,x);\x0a"
"\x09""esx ^= sx;\x0a"
"\x09SET_LDOUBLE_EXP(x,esx);\x0a"
"\x0a"
"\x09q \x26= 0x7fffffff;\x0a"
"\x09*quo = (sxy \x3f -q \x3a q);\x0a"
"\x09return x;\x0a"
"}\x0a"
"", 4208 ); }