#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_modf_c( 
"/*\x09\x24OpenBSD\x3a modf.c,v 1.6 2013/07/03 04\x3a""46\x3a""36 espie Exp \x24\x09*/\x0a"
"/*\x09\x24NetBSD\x3a modf.c,v 1.1 1995/02/10 17\x3a""50\x3a""25 cgd Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 1994, 1995 Carnegie-Mellon University.\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * Author\x3a Chris G. Demetriou\x0a"
" * \x0a"
" * Permission to use, copy, modify and distribute this software and\x0a"
" * its documentation is hereby granted, provided that both the copyright\x0a"
" * notice and this permission notice appear in all copies of the\x0a"
" * software, derivative works or modified versions, and any portions\x0a"
" * thereof, and that both notices appear in supporting documentation.\x0a"
" * \x0a"
" * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS \x22""AS IS\x22 \x0a"
" * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND \x0a"
" * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.\x0a"
" * \x0a"
" * Carnegie Mellon requests users of this software to return to\x0a"
" *\x0a"
" *  Software Distribution Coordinator  or  Software.Distribution\x40""CS.CMU.EDU\x0a"
" *  School of Computer Science\x0a"
" *  Carnegie Mellon University\x0a"
" *  Pittsburgh PA 15213-3890\x0a"
" *\x0a"
" * any improvements or extensions that they make and grant Carnegie the\x0a"
" * rights to redistribute these changes.\x0a"
" */\x0a"
"\x0a"
"#include <sys/types.h>\x0a"
"#include <machine/ieee.h>\x0a"
"#include <stdint.h>\x0a"
"#include <errno.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"/*\x0a"
" * double modf(double val, double *iptr)\x0a"
" * returns\x3a f and i such that \x7c""f\x7c < 1.0, (f + i) = val, and\x0a"
" *\x09sign(f) == sign(i) == sign(val).\x0a"
" *\x0a"
" * Beware signedness when doing subtraction, and also operand size\x21\x0a"
" */\x0a"
"double\x0a"
"modf(double val, double *iptr)\x0a"
"{\x0a"
"\x09union doub {\x0a"
"\x09\x09""double v;\x0a"
"\x09\x09struct ieee_double s;\x0a"
"\x09} u, v;\x0a"
"\x09uint64_t frac;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * If input is Inf or NaN, return it and leave i alone.\x0a"
"\x09 */\x0a"
"\x09u.v = val;\x0a"
"\x09if (u.s.dbl_exp == DBL_EXP_INFNAN)\x0a"
"\x09\x09return (u.v);\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * If input can't have a fractional part, return\x0a"
"\x09 * (appropriately signed) zero, and make i be the input.\x0a"
"\x09 */\x0a"
"\x09if ((int)u.s.dbl_exp - DBL_EXP_BIAS > DBL_FRACBITS - 1) {\x0a"
"\x09\x09*iptr = u.v;\x0a"
"\x09\x09v.v = 0.0;\x0a"
"\x09\x09v.s.dbl_sign = u.s.dbl_sign;\x0a"
"\x09\x09return (v.v);\x0a"
"\x09}\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * If \x7cinput\x7c < 1.0, return it, and set i to the appropriately\x0a"
"\x09 * signed zero.\x0a"
"\x09 */\x0a"
"\x09if (u.s.dbl_exp < DBL_EXP_BIAS) {\x0a"
"\x09\x09v.v = 0.0;\x0a"
"\x09\x09v.s.dbl_sign = u.s.dbl_sign;\x0a"
"\x09\x09*iptr = v.v;\x0a"
"\x09\x09return (u.v);\x0a"
"\x09}\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * There can be a fractional part of the input.\x0a"
"\x09 * If you look at the math involved for a few seconds, it's\x0a"
"\x09 * plain to see that the integral part is the input, with the\x0a"
"\x09 * low (DBL_FRACBITS - (exponent - DBL_EXP_BIAS)) bits zeroed,\x0a"
"\x09 * the fractional part is the part with the rest of the\x0a"
"\x09 * bits zeroed.  Just zeroing the high bits to get the\x0a"
"\x09 * fractional part would yield a fraction in need of\x0a"
"\x09 * normalization.  Therefore, we take the easy way out, and\x0a"
"\x09 * just use subtraction to get the fractional part.\x0a"
"\x09 */\x0a"
"\x09v.v = u.v;\x0a"
"\x09/* Zero the low bits of the fraction, the sleazy way. */\x0a"
"\x09""frac = ((uint64_t)v.s.dbl_frach << 32) + v.s.dbl_fracl;\x0a"
"\x09""frac >>= DBL_FRACBITS - (u.s.dbl_exp - DBL_EXP_BIAS);\x0a"
"\x09""frac <<= DBL_FRACBITS - (u.s.dbl_exp - DBL_EXP_BIAS);\x0a"
"\x09v.s.dbl_fracl = frac \x26 0xffffffff;\x0a"
"\x09v.s.dbl_frach = frac >> 32;\x0a"
"\x09*iptr = v.v;\x0a"
"\x0a"
"\x09u.v -= v.v;\x0a"
"\x09u.s.dbl_sign = v.s.dbl_sign;\x0a"
"\x09return (u.v);\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(modfl, modf);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 3213 ); }