#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_polevll_c( 
"/*\x09\x24OpenBSD\x3a polevll.c,v 1.2 2013/11/12 20\x3a""35\x3a""09 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09polevll.c\x0a"
" *\x09\x09\x09\x09\x09\x09\x09p1evll.c\x0a"
" *\x0a"
" *\x09""Evaluate polynomial\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * int N;\x0a"
" * long double x, y, coef\x5bN+1\x5d, polevl\x5b\x5d;\x0a"
" *\x0a"
" * y = polevll( x, coef, N );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Evaluates polynomial of degree N\x3a\x0a"
" *\x0a"
" *                     2          N\x0a"
" * y  =  C  + C x + C x  +...+ C x\x0a"
" *        0    1     2          N\x0a"
" *\x0a"
" * Coefficients are stored in reverse order\x3a\x0a"
" *\x0a"
" * coef\x5b""0\x5d = C  , ..., coef\x5bN\x5d = C  .\x0a"
" *            N                   0\x0a"
" *\x0a"
" *  The function p1evll() assumes that coef\x5bN\x5d = 1.0 and is\x0a"
" * omitted from the array.  Its calling arguments are\x0a"
" * otherwise the same as polevll().\x0a"
" *\x0a"
" *\x0a"
" * SPEED\x3a\x0a"
" *\x0a"
" * In the interest of speed, there are no checks for out\x0a"
" * of bounds arithmetic.  This routine is used by most of\x0a"
" * the functions in the library.  Depending on available\x0a"
" * equipment features, the user may wish to rewrite the\x0a"
" * program in microcode or assembly language.\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/*\x0a"
" * Polynomial evaluator\x3a\x0a"
" *  P\x5b""0\x5d x^n  +  P\x5b""1\x5d x^(n-1)  +  ...  +  P\x5bn\x5d\x0a"
" */\x0a"
"long double\x0a"
"__polevll(long double x, void *PP, int n)\x0a"
"{\x0a"
"\x09long double y;\x0a"
"\x09long double *P;\x0a"
"\x0a"
"\x09P = (long double *)PP;\x0a"
"\x09y = *P++;\x0a"
"\x09""do {\x0a"
"\x09\x09y = y * x + *P++;\x0a"
"\x09} while (--n);\x0a"
"\x0a"
"\x09return (y);\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
" * Polynomial evaluator\x3a\x0a"
" *  x^n  +  P\x5b""0\x5d x^(n-1)  +  P\x5b""1\x5d x^(n-2)  +  ...  +  P\x5bn\x5d\x0a"
" */\x0a"
"long double\x0a"
"__p1evll(long double x, void *PP, int n)\x0a"
"{\x0a"
"\x09long double y;\x0a"
"\x09long double *P;\x0a"
"\x0a"
"\x09P = (long double *)PP;\x0a"
"\x09n -= 1;\x0a"
"\x09y = x + *P++;\x0a"
"\x09""do {\x0a"
"\x09\x09y = y * x + *P++;\x0a"
"\x09} while (--n);\x0a"
"\x0a"
"\x09return (y);\x0a"
"}\x0a"
"", 2386 ); }