#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_asinh_c( 
"/* \x40(#)s_asinh.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* asinh(x)\x0a"
" * Method \x3a\x0a"
" *\x09""Based on \x0a"
" *\x09\x09""asinh(x) = sign(x) * log \x5b \x7cx\x7c + sqrt(x*x+1) \x5d\x0a"
" *\x09we have\x0a"
" *\x09""asinh(x) \x3a= x  if  1+x*x=1,\x0a"
" *\x09\x09 \x3a= sign(x)*(log(x)+ln2)) for large \x7cx\x7c, else\x0a"
" *\x09\x09 \x3a= sign(x)*log(2\x7cx\x7c+1/(\x7cx\x7c+sqrt(x*x+1))) if\x7cx\x7c>2, else\x0a"
" *\x09\x09 \x3a= sign(x)*log1p(\x7cx\x7c + x^2/(1 + sqrt(1+x^2)))  \x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double \x0a"
"one =  1.00000000000000000000e+00, /* 0x3FF00000, 0x00000000 */\x0a"
"ln2 =  6.93147180559945286227e-01, /* 0x3FE62E42, 0xFEFA39EF */\x0a"
"huge=  1.00000000000000000000e+300; \x0a"
"\x0a"
"double\x0a"
"asinh(double x)\x0a"
"{\x09\x0a"
"\x09""double t,w;\x0a"
"\x09int32_t hx,ix;\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x7ff00000) return x+x;\x09/* x is inf or NaN */\x0a"
"\x09if(ix< 0x3e300000) {\x09/* \x7cx\x7c<2**-28 */\x0a"
"\x09    if(huge+x>one) return x;\x09/* return x inexact except 0 */\x0a"
"\x09} \x0a"
"\x09if(ix>0x41b00000) {\x09/* \x7cx\x7c > 2**28 */\x0a"
"\x09    w = log(fabs(x))+ln2;\x0a"
"\x09} else if (ix>0x40000000) {\x09/* 2**28 > \x7cx\x7c > 2.0 */\x0a"
"\x09    t = fabs(x);\x0a"
"\x09    w = log(2.0*t+one/(sqrt(x*x+one)+t));\x0a"
"\x09} else {\x09\x09/* 2.0 > \x7cx\x7c > 2**-28 */\x0a"
"\x09    t = x*x;\x0a"
"\x09    w =log1p(fabs(x)+t/(one+sqrt(one+t)));\x0a"
"\x09}\x0a"
"\x09if(hx>0) return w; else return -w;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(asinhl, asinh);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 1646 ); }