#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_atan_c( 
"/* \x40(#)s_atan.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* atan(x)\x0a"
" * Method\x0a"
" *   1. Reduce x to positive by atan(x) = -atan(-x).\x0a"
" *   2. According to the integer k=4t+0.25 chopped, t=x, the argument\x0a"
" *      is further reduced to one of the following intervals and the\x0a"
" *      arctangent of t is evaluated by the corresponding formula\x3a\x0a"
" *\x0a"
" *      \x5b""0,7/16\x5d      atan(x) = t-t^3*(a1+t^2*(a2+...(a10+t^2*a11)...)\x0a"
" *      \x5b""7/16,11/16\x5d  atan(x) = atan(1/2) + atan( (t-0.5)/(1+t/2) )\x0a"
" *      \x5b""11/16.19/16\x5d atan(x) = atan( 1 ) + atan( (t-1)/(1+t) )\x0a"
" *      \x5b""19/16,39/16\x5d atan(x) = atan(3/2) + atan( (t-1.5)/(1+1.5t) )\x0a"
" *      \x5b""39/16,INF\x5d   atan(x) = atan(INF) + atan( -1/t )\x0a"
" *\x0a"
" * Constants\x3a\x0a"
" * The hexadecimal values are the intended ones for the following \x0a"
" * constants. The decimal values may be used, provided that the \x0a"
" * compiler will convert from decimal to binary accurately enough \x0a"
" * to produce the hexadecimal values shown.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double atanhi\x5b\x5d = {\x0a"
"  4.63647609000806093515e-01, /* atan(0.5)hi 0x3FDDAC67, 0x0561BB4F */\x0a"
"  7.85398163397448278999e-01, /* atan(1.0)hi 0x3FE921FB, 0x54442D18 */\x0a"
"  9.82793723247329054082e-01, /* atan(1.5)hi 0x3FEF730B, 0xD281F69B */\x0a"
"  1.57079632679489655800e+00, /* atan(inf)hi 0x3FF921FB, 0x54442D18 */\x0a"
"};\x0a"
"\x0a"
"static const double atanlo\x5b\x5d = {\x0a"
"  2.26987774529616870924e-17, /* atan(0.5)lo 0x3C7A2B7F, 0x222F65E2 */\x0a"
"  3.06161699786838301793e-17, /* atan(1.0)lo 0x3C81A626, 0x33145C07 */\x0a"
"  1.39033110312309984516e-17, /* atan(1.5)lo 0x3C700788, 0x7AF0CBBD */\x0a"
"  6.12323399573676603587e-17, /* atan(inf)lo 0x3C91A626, 0x33145C07 */\x0a"
"};\x0a"
"\x0a"
"static const double aT\x5b\x5d = {\x0a"
"  3.33333333333329318027e-01, /* 0x3FD55555, 0x5555550D */\x0a"
" -1.99999999998764832476e-01, /* 0xBFC99999, 0x9998EBC4 */\x0a"
"  1.42857142725034663711e-01, /* 0x3FC24924, 0x920083FF */\x0a"
" -1.11111104054623557880e-01, /* 0xBFBC71C6, 0xFE231671 */\x0a"
"  9.09088713343650656196e-02, /* 0x3FB745CD, 0xC54C206E */\x0a"
" -7.69187620504482999495e-02, /* 0xBFB3B0F2, 0xAF749A6D */\x0a"
"  6.66107313738753120669e-02, /* 0x3FB10D66, 0xA0D03D51 */\x0a"
" -5.83357013379057348645e-02, /* 0xBFADDE2D, 0x52DEFD9A */\x0a"
"  4.97687799461593236017e-02, /* 0x3FA97B4B, 0x24760DEB */\x0a"
" -3.65315727442169155270e-02, /* 0xBFA2B444, 0x2C6A6C2F */\x0a"
"  1.62858201153657823623e-02, /* 0x3F90AD3A, 0xE322DA11 */\x0a"
"};\x0a"
"\x0a"
"static const double \x0a"
"one   = 1.0,\x0a"
"huge   = 1.0e300;\x0a"
"\x0a"
"__link_always double\x0a"
"atan(double x)\x0a"
"{\x0a"
"\x09""double w,s1,s2,z;\x0a"
"\x09int32_t ix,hx,id;\x0a"
"\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x44100000) {\x09/* if \x7cx\x7c >= 2^66 */\x0a"
"\x09    u_int32_t low;\x0a"
"\x09    GET_LOW_WORD(low,x);\x0a"
"\x09    if(ix>0x7ff00000\x7c\x7c\x0a"
"\x09\x09(ix==0x7ff00000\x26\x26(low\x21=0)))\x0a"
"\x09\x09return x+x;\x09\x09/* NaN */\x0a"
"\x09    if(hx>0) return  atanhi\x5b""3\x5d+atanlo\x5b""3\x5d;\x0a"
"\x09    else     return -atanhi\x5b""3\x5d-atanlo\x5b""3\x5d;\x0a"
"\x09} if (ix < 0x3fdc0000) {\x09/* \x7cx\x7c < 0.4375 */\x0a"
"\x09    if (ix < 0x3e200000) {\x09/* \x7cx\x7c < 2^-29 */\x0a"
"\x09\x09if(huge+x>one) return x;\x09/* raise inexact */\x0a"
"\x09    }\x0a"
"\x09    id = -1;\x0a"
"\x09} else {\x0a"
"\x09x = fabs(x);\x0a"
"\x09if (ix < 0x3ff30000) {\x09\x09/* \x7cx\x7c < 1.1875 */\x0a"
"\x09    if (ix < 0x3fe60000) {\x09/* 7/16 <=\x7cx\x7c<11/16 */\x0a"
"\x09\x09id = 0; x = (2.0*x-one)/(2.0+x); \x0a"
"\x09    } else {\x09\x09\x09/* 11/16<=\x7cx\x7c< 19/16 */\x0a"
"\x09\x09id = 1; x  = (x-one)/(x+one); \x0a"
"\x09    }\x0a"
"\x09} else {\x0a"
"\x09    if (ix < 0x40038000) {\x09/* \x7cx\x7c < 2.4375 */\x0a"
"\x09\x09id = 2; x  = (x-1.5)/(one+1.5*x);\x0a"
"\x09    } else {\x09\x09\x09/* 2.4375 <= \x7cx\x7c < 2^66 */\x0a"
"\x09\x09id = 3; x  = -1.0/x;\x0a"
"\x09    }\x0a"
"\x09}}\x0a"
"    /* end of argument reduction */\x0a"
"\x09z = x*x;\x0a"
"\x09w = z*z;\x0a"
"    /* break sum from i=0 to 10 aT\x5bi\x5dz**(i+1) into odd and even poly */\x0a"
"\x09s1 = z*(aT\x5b""0\x5d+w*(aT\x5b""2\x5d+w*(aT\x5b""4\x5d+w*(aT\x5b""6\x5d+w*(aT\x5b""8\x5d+w*aT\x5b""10\x5d)))));\x0a"
"\x09s2 = w*(aT\x5b""1\x5d+w*(aT\x5b""3\x5d+w*(aT\x5b""5\x5d+w*(aT\x5b""7\x5d+w*aT\x5b""9\x5d))));\x0a"
"\x09if (id<0) return x - x*(s1+s2);\x0a"
"\x09""else {\x0a"
"\x09    z = atanhi\x5bid\x5d - ((x*(s1+s2) - atanlo\x5bid\x5d) - x);\x0a"
"\x09    return (hx<0)\x3f -z\x3az;\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(atanl, atan);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 4153 ); }