#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_atanf_c( 
"/* s_atanf.c -- float version of s_atan.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const float atanhi\x5b\x5d = {\x0a"
"  4.6364760399e-01, /* atan(0.5)hi 0x3eed6338 */\x0a"
"  7.8539812565e-01, /* atan(1.0)hi 0x3f490fda */\x0a"
"  9.8279368877e-01, /* atan(1.5)hi 0x3f7b985e */\x0a"
"  1.5707962513e+00, /* atan(inf)hi 0x3fc90fda */\x0a"
"};\x0a"
"\x0a"
"static const float atanlo\x5b\x5d = {\x0a"
"  5.0121582440e-09, /* atan(0.5)lo 0x31ac3769 */\x0a"
"  3.7748947079e-08, /* atan(1.0)lo 0x33222168 */\x0a"
"  3.4473217170e-08, /* atan(1.5)lo 0x33140fb4 */\x0a"
"  7.5497894159e-08, /* atan(inf)lo 0x33a22168 */\x0a"
"};\x0a"
"\x0a"
"static const float aT\x5b\x5d = {\x0a"
"  3.3333334327e-01, /* 0x3eaaaaaa */\x0a"
" -2.0000000298e-01, /* 0xbe4ccccd */\x0a"
"  1.4285714924e-01, /* 0x3e124925 */\x0a"
" -1.1111110449e-01, /* 0xbde38e38 */\x0a"
"  9.0908870101e-02, /* 0x3dba2e6e */\x0a"
" -7.6918758452e-02, /* 0xbd9d8795 */\x0a"
"  6.6610731184e-02, /* 0x3d886b35 */\x0a"
" -5.8335702866e-02, /* 0xbd6ef16b */\x0a"
"  4.9768779427e-02, /* 0x3d4bda59 */\x0a"
" -3.6531571299e-02, /* 0xbd15a221 */\x0a"
"  1.6285819933e-02, /* 0x3c8569d7 */\x0a"
"};\x0a"
"\x0a"
"static const float \x0a"
"one   = 1.0,\x0a"
"huge   = 1.0e30;\x0a"
"\x0a"
"float\x0a"
"atanf(float x)\x0a"
"{\x0a"
"\x09""float w,s1,s2,z;\x0a"
"\x09int32_t ix,hx,id;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x50800000) {\x09/* if \x7cx\x7c >= 2^34 */\x0a"
"\x09    if(ix>0x7f800000)\x0a"
"\x09\x09return x+x;\x09\x09/* NaN */\x0a"
"\x09    if(hx>0) return  atanhi\x5b""3\x5d+atanlo\x5b""3\x5d;\x0a"
"\x09    else     return -atanhi\x5b""3\x5d-atanlo\x5b""3\x5d;\x0a"
"\x09} if (ix < 0x3ee00000) {\x09/* \x7cx\x7c < 0.4375 */\x0a"
"\x09    if (ix < 0x31000000) {\x09/* \x7cx\x7c < 2^-29 */\x0a"
"\x09\x09if(huge+x>one) return x;\x09/* raise inexact */\x0a"
"\x09    }\x0a"
"\x09    id = -1;\x0a"
"\x09} else {\x0a"
"\x09x = fabsf(x);\x0a"
"\x09if (ix < 0x3f980000) {\x09\x09/* \x7cx\x7c < 1.1875 */\x0a"
"\x09    if (ix < 0x3f300000) {\x09/* 7/16 <=\x7cx\x7c<11/16 */\x0a"
"\x09\x09id = 0; x = ((float)2.0*x-one)/((float)2.0+x); \x0a"
"\x09    } else {\x09\x09\x09/* 11/16<=\x7cx\x7c< 19/16 */\x0a"
"\x09\x09id = 1; x  = (x-one)/(x+one); \x0a"
"\x09    }\x0a"
"\x09} else {\x0a"
"\x09    if (ix < 0x401c0000) {\x09/* \x7cx\x7c < 2.4375 */\x0a"
"\x09\x09id = 2; x  = (x-(float)1.5)/(one+(float)1.5*x);\x0a"
"\x09    } else {\x09\x09\x09/* 2.4375 <= \x7cx\x7c < 2^66 */\x0a"
"\x09\x09id = 3; x  = -(float)1.0/x;\x0a"
"\x09    }\x0a"
"\x09}}\x0a"
"    /* end of argument reduction */\x0a"
"\x09z = x*x;\x0a"
"\x09w = z*z;\x0a"
"    /* break sum from i=0 to 10 aT\x5bi\x5dz**(i+1) into odd and even poly */\x0a"
"\x09s1 = z*(aT\x5b""0\x5d+w*(aT\x5b""2\x5d+w*(aT\x5b""4\x5d+w*(aT\x5b""6\x5d+w*(aT\x5b""8\x5d+w*aT\x5b""10\x5d)))));\x0a"
"\x09s2 = w*(aT\x5b""1\x5d+w*(aT\x5b""3\x5d+w*(aT\x5b""5\x5d+w*(aT\x5b""7\x5d+w*aT\x5b""9\x5d))));\x0a"
"\x09if (id<0) return x - x*(s1+s2);\x0a"
"\x09""else {\x0a"
"\x09    z = atanhi\x5bid\x5d - ((x*(s1+s2) - atanlo\x5bid\x5d) - x);\x0a"
"\x09    return (hx<0)\x3f -z\x3az;\x0a"
"\x09}\x0a"
"}\x0a"
"", 2762 ); }