#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_cacosl_c( 
"/*\x09\x24OpenBSD\x3a s_cacosl.c,v 1.3 2011/07/20 21\x3a""02\x3a""51 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""cacosl()\x0a"
" *\x0a"
" *\x09""Complex circular arc cosine\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double complex cacosl();\x0a"
" * long double complex z, w;\x0a"
" *\x0a"
" * w = cacosl( z );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" *\x0a"
" * w = arccos z  =  PI/2 - arcsin z.\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    DEC       -10,+10      5200      1.6e-15      2.8e-16\x0a"
" *    IEEE      -10,+10     30000      1.8e-14      2.2e-15\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"static const long double PIO2L = 1.570796326794896619231321691639751442098585L;\x0a"
"\x0a"
"long double complex\x0a"
"cacosl(long double complex z)\x0a"
"{\x0a"
"\x09long double complex w;\x0a"
"\x0a"
"\x09w = casinl(z);\x0a"
"\x09w = (PIO2L - creall(w)) - cimagl(w) * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 1619 ); }