#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_casinf_c( 
"/*\x09\x24OpenBSD\x3a s_casinf.c,v 1.4 2015/12/18 12\x3a""17\x3a""44 shadchin Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""casinf()\x0a"
" *\x0a"
" *\x09""Complex circular arc sine\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * void casinf();\x0a"
" * cmplxf z, w;\x0a"
" *\x0a"
" * casinf( \x26z, \x26w );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Inverse complex sine\x3a\x0a"
" *\x0a"
" *                               2\x0a"
" * w = -i clog( iz + csqrt( 1 - z ) ).\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE      -10,+10     30000       1.1e-5      1.5e-6\x0a"
" * Larger relative error can be observed for z near zero.\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"float complex\x0a"
"casinf(float complex z)\x0a"
"{\x0a"
"\x09""float complex w;\x0a"
"\x09""float x, y;\x0a"
"\x09static float complex ca, ct, zz, z2;\x0a"
"\x09/*\x0a"
"\x09""float cn, n;\x0a"
"\x09static float a, b, s, t, u, v, y2;\x0a"
"\x09static cmplxf sum;\x0a"
"\x09*/\x0a"
"\x0a"
"\x09x = crealf(z);\x0a"
"\x09y = cimagf(z);\x0a"
"\x0a"
"#if 0\x0a"
"\x09if(y == 0.0f) {\x0a"
"\x09\x09if(fabsf(x) > 1.0f) {\x0a"
"\x09\x09\x09w = (float)M_PI_2 + 0.0f * I;\x0a"
"\x09\x09\x09/*mtherr( \x22""casinf\x22, DOMAIN );*/\x0a"
"\x09\x09}\x0a"
"\x09\x09""else {\x0a"
"\x09\x09\x09w = asinf (x) + 0.0f * I;\x0a"
"\x09\x09}\x0a"
"\x09\x09return (w);\x0a"
"\x09}\x0a"
"#endif\x0a"
"\x0a"
"\x09/* Power series expansion */\x0a"
"\x09/*\x0a"
"\x09""b = cabsf(z);\x0a"
"\x09if(b < 0.125) {\x0a"
"\x09\x09z2.r = (x - y) * (x + y);\x0a"
"\x09\x09z2.i = 2.0 * x * y;\x0a"
"\x0a"
"\x09\x09""cn = 1.0;\x0a"
"\x09\x09n = 1.0;\x0a"
"\x09\x09""ca.r = x;\x0a"
"\x09\x09""ca.i = y;\x0a"
"\x09\x09sum.r = x;\x0a"
"\x09\x09sum.i = y;\x0a"
"\x09\x09""do {\x0a"
"\x09\x09\x09""ct.r = z2.r * ca.r  -  z2.i * ca.i;\x0a"
"\x09\x09\x09""ct.i = z2.r * ca.i  +  z2.i * ca.r;\x0a"
"\x09\x09\x09""ca.r = ct.r;\x0a"
"\x09\x09\x09""ca.i = ct.i;\x0a"
"\x0a"
"\x09\x09\x09""cn *= n;\x0a"
"\x09\x09\x09n += 1.0;\x0a"
"\x09\x09\x09""cn /= n;\x0a"
"\x09\x09\x09n += 1.0;\x0a"
"\x09\x09\x09""b = cn/n;\x0a"
"\x0a"
"\x09\x09\x09""ct.r *= b;\x0a"
"\x09\x09\x09""ct.i *= b;\x0a"
"\x09\x09\x09sum.r += ct.r;\x0a"
"\x09\x09\x09sum.i += ct.i;\x0a"
"\x09\x09\x09""b = fabsf(ct.r) + fabsf(ct.i);\x0a"
"\x09\x09}\x0a"
"\x09\x09while(b > MACHEPF);\x0a"
"\x09\x09w->r = sum.r;\x0a"
"\x09\x09w->i = sum.i;\x0a"
"\x09\x09return;\x0a"
"\x09}\x0a"
"\x09*/\x0a"
"\x0a"
"\x0a"
"\x09""ca = x + y * I;\x0a"
"\x09""ct = ca * I;\x09/* iz */\x0a"
"\x09/* sqrt( 1 - z*z) */\x0a"
"\x09/* cmul( \x26""ca, \x26""ca, \x26zz ) */\x0a"
"\x09/*x * x  -  y * y */\x0a"
"\x09zz = (x - y) * (x + y) + (2.0f * x * y) * I;\x0a"
"\x09zz = 1.0f - crealf(zz) - cimagf(zz) * I;\x0a"
"\x09z2 = csqrtf (zz);\x0a"
"\x0a"
"\x09zz = ct + z2;\x0a"
"\x09zz = clogf (zz);\x0a"
"\x09/* multiply by 1/i = -i */\x0a"
"\x09w = zz * (-1.0f * I);\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 2688 ); }