#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_casinl_c( 
"/*\x09\x24OpenBSD\x3a s_casinl.c,v 1.4 2015/12/18 12\x3a""17\x3a""44 shadchin Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""casinl()\x0a"
" *\x0a"
" *\x09""Complex circular arc sine\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double complex casinl();\x0a"
" * long double complex z, w;\x0a"
" *\x0a"
" * w = casinl( z );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Inverse complex sine\x3a\x0a"
" *\x0a"
" *                               2\x0a"
" * w = -i clog( iz + csqrt( 1 - z ) ).\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    DEC       -10,+10     10100       2.1e-15     3.4e-16\x0a"
" *    IEEE      -10,+10     30000       2.2e-14     2.7e-15\x0a"
" * Larger relative error can be observed for z near zero.\x0a"
" * Also tested by csin(casin(z)) = z.\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == 64\x0a"
"static const long double MACHEPL= 5.42101086242752217003726400434970855712890625E-20L;\x0a"
"#elif\x09LDBL_MANT_DIG == 113\x0a"
"static const long double MACHEPL = 9.629649721936179265279889712924636592690508e-35L;\x0a"
"#endif\x0a"
"\x0a"
"static const long double PIO2L = 1.570796326794896619231321691639751442098585L;\x0a"
"\x0a"
"long double complex\x0a"
"casinl(long double complex z)\x0a"
"{\x0a"
"\x09long double complex w;\x0a"
"\x09long double x, y, b;\x0a"
"\x09static long double complex ca, ct, zz, z2;\x0a"
"\x0a"
"\x09x = creall(z);\x0a"
"\x09y = cimagl(z);\x0a"
"\x0a"
"#if 0\x0a"
"\x09if (y == 0.0L) {\x0a"
"\x09\x09if (fabsl(x) > 1.0L) {\x0a"
"\x09\x09\x09w = PIO2L + 0.0L * I;\x0a"
"\x09\x09\x09/*mtherr( \x22""casinl\x22, DOMAIN );*/\x0a"
"\x09\x09}\x0a"
"\x09\x09""else {\x0a"
"\x09\x09\x09w = asinl(x) + 0.0L * I;\x0a"
"\x09\x09}\x0a"
"\x09\x09return (w);\x0a"
"\x09}\x0a"
"#endif\x0a"
"\x0a"
"\x09/* Power series expansion */\x0a"
"\x09""b = cabsl(z);\x0a"
"\x09if (b < 0.125L) {\x0a"
"\x09\x09long double complex sum;\x0a"
"\x09\x09long double n, cn;\x0a"
"\x0a"
"\x09\x09z2 = (x - y) * (x + y) + (2.0L * x * y) * I;\x0a"
"\x09\x09""cn = 1.0L;\x0a"
"\x09\x09n = 1.0L;\x0a"
"\x09\x09""ca = x + y * I;\x0a"
"\x09\x09sum = x + y * I;\x0a"
"\x09\x09""do {\x0a"
"\x09\x09\x09""ct = z2 * ca;\x0a"
"\x09\x09\x09""ca = ct;\x0a"
"\x0a"
"\x09\x09\x09""cn *= n;\x0a"
"\x09\x09\x09n += 1.0L;\x0a"
"\x09\x09\x09""cn /= n;\x0a"
"\x09\x09\x09n += 1.0L;\x0a"
"\x09\x09\x09""b = cn/n;\x0a"
"\x0a"
"\x09\x09\x09""ct *= b;\x0a"
"\x09\x09\x09sum += ct;\x0a"
"\x09\x09\x09""b = cabsl(ct);\x0a"
"\x09\x09}\x0a"
"\x0a"
"\x09\x09while (b > MACHEPL);\x0a"
"\x09\x09w = sum;\x0a"
"\x09\x09return w;\x0a"
"\x09}\x0a"
"\x0a"
"\x09""ca = x + y * I;\x0a"
"\x09""ct = ca * I;\x09/* iz */\x0a"
"\x09/* sqrt(1 - z*z) */\x0a"
"\x09/* cmul(\x26""ca, \x26""ca, \x26zz) */\x0a"
"\x09/* x * x  -  y * y */\x0a"
"\x09zz = (x - y) * (x + y) + (2.0L * x * y) * I;\x0a"
"\x09zz = 1.0L - creall(zz) - cimagl(zz) * I;\x0a"
"\x09z2 = csqrtl(zz);\x0a"
"\x0a"
"\x09zz = ct + z2;\x0a"
"\x09zz = clogl(zz);\x0a"
"\x09/* multiply by 1/i = -i */\x0a"
"\x09w = zz * (-1.0L * I);\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 2965 ); }