#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_catanf_c( 
"/*\x09\x24OpenBSD\x3a s_catanf.c,v 1.2 2010/07/18 18\x3a""42\x3a""26 guenther Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""catanf()\x0a"
" *\x0a"
" *\x09""Complex circular arc tangent\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * float complex catanf();\x0a"
" * float complex z, w;\x0a"
" *\x0a"
" * w = catanf( z );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * If\x0a"
" *     z = x + iy,\x0a"
" *\x0a"
" * then\x0a"
" *          1       (    2x     )\x0a"
" * Re w  =  - arctan(-----------)  +  k PI\x0a"
" *          2       (     2    2)\x0a"
" *                  (1 - x  - y )\x0a"
" *\x0a"
" *               ( 2         2)\x0a"
" *          1    (x  +  (y+1) )\x0a"
" * Im w  =  - log(------------)\x0a"
" *          4    ( 2         2)\x0a"
" *               (x  +  (y-1) )\x0a"
" *\x0a"
" * Where k is an arbitrary integer.\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE      -10,+10     30000        2.3e-6      5.2e-8\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#define MAXNUMF 1.0e38F\x0a"
"\x0a"
"static const double DP1 = 3.140625;\x0a"
"static const double DP2 = 9.67502593994140625E-4;\x0a"
"static const double DP3 = 1.509957990978376432E-7;\x0a"
"\x0a"
"static float\x0a"
"_redupif(float xx)\x0a"
"{\x0a"
"\x09""float x, t;\x0a"
"\x09long i;\x0a"
"\x0a"
"\x09x = xx;\x0a"
"\x09t = x/(float)M_PI;\x0a"
"\x09if(t >= 0.0)\x0a"
"\x09\x09t += 0.5;\x0a"
"\x09""else\x0a"
"\x09\x09t -= 0.5;\x0a"
"\x0a"
"\x09i = t;\x09/* the multiple */\x0a"
"\x09t = i;\x0a"
"\x09t = ((x - t * DP1) - t * DP2) - t * DP3;\x0a"
"\x09return(t);\x0a"
"}\x0a"
"\x0a"
"float complex\x0a"
"catanf(float complex z)\x0a"
"{\x0a"
"\x09""float complex w;\x0a"
"\x09""float a, t, x, x2, y;\x0a"
"\x0a"
"\x09x = crealf(z);\x0a"
"\x09y = cimagf(z);\x0a"
"\x0a"
"\x09if((x == 0.0f) \x26\x26 (y > 1.0f))\x0a"
"\x09\x09goto ovrf;\x0a"
"\x0a"
"\x09x2 = x * x;\x0a"
"\x09""a = 1.0f - x2 - (y * y);\x0a"
"\x09if (a == 0.0f)\x0a"
"\x09\x09goto ovrf;\x0a"
"\x0a"
"\x09t = 0.5f * atan2f(2.0f * x, a);\x0a"
"\x09w = _redupif(t);\x0a"
"\x0a"
"\x09t = y - 1.0f;\x0a"
"\x09""a = x2 + (t * t);\x0a"
"\x09if(a == 0.0f)\x0a"
"\x09\x09goto ovrf;\x0a"
"\x0a"
"\x09t = y + 1.0f;\x0a"
"\x09""a = (x2 + (t * t))/a;\x0a"
"\x09w = w + (0.25f * logf (a)) * I;\x0a"
"\x09return (w);\x0a"
"\x0a"
"ovrf\x3a\x0a"
"\x09/*mtherr( \x22""catanf\x22, OVERFLOW );*/\x0a"
"\x09w = MAXNUMF + MAXNUMF * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 2558 ); }