#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_catanl_c( 
"/*\x09\x24OpenBSD\x3a s_catanl.c,v 1.3 2011/07/20 21\x3a""02\x3a""51 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""catanl()\x0a"
" *\x0a"
" *\x09""Complex circular arc tangent\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double complex catanl();\x0a"
" * long double complex z, w;\x0a"
" *\x0a"
" * w = catanl( z );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * If\x0a"
" *     z = x + iy,\x0a"
" *\x0a"
" * then\x0a"
" *          1       (    2x     )\x0a"
" * Re w  =  - arctan(-----------)  +  k PI\x0a"
" *          2       (     2    2)\x0a"
" *                  (1 - x  - y )\x0a"
" *\x0a"
" *               ( 2         2)\x0a"
" *          1    (x  +  (y+1) )\x0a"
" * Im w  =  - log(------------)\x0a"
" *          4    ( 2         2)\x0a"
" *               (x  +  (y-1) )\x0a"
" *\x0a"
" * Where k is an arbitrary integer.\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    DEC       -10,+10      5900       1.3e-16     7.8e-18\x0a"
" *    IEEE      -10,+10     30000       2.3e-15     8.5e-17\x0a"
" * The check catan( ctan(z) )  =  z, with \x7cx\x7c and \x7cy\x7c < PI/2,\x0a"
" * had peak relative error 1.5e-16, rms relative error\x0a"
" * 2.9e-17.  See also clog().\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"static const long double PIL = 3.141592653589793238462643383279502884197169L;\x0a"
"static const long double DP1 = 3.14159265358979323829596852490908531763125L;\x0a"
"static const long double DP2 = 1.6667485837041756656403424829301998703007e-19L;\x0a"
"static const long double DP3 = 1.8830410776607851167459095484560349402753e-39L;\x0a"
"\x0a"
"static long double\x0a"
"redupil(long double x)\x0a"
"{\x0a"
"\x09long double t;\x0a"
"\x09long i;\x0a"
"\x0a"
"\x09t = x / PIL;\x0a"
"\x09if (t >= 0.0L)\x0a"
"\x09\x09t += 0.5L;\x0a"
"\x09""else\x0a"
"\x09\x09t -= 0.5L;\x0a"
"\x0a"
"\x09i = t;\x09/* the multiple */\x0a"
"\x09t = i;\x0a"
"\x09t = ((x - t * DP1) - t * DP2) - t * DP3;\x0a"
"\x09return (t);\x0a"
"}\x0a"
"\x0a"
"long double complex\x0a"
"catanl(long double complex z)\x0a"
"{\x0a"
"\x09long double complex w;\x0a"
"\x09long double a, t, x, x2, y;\x0a"
"\x0a"
"\x09x = creall(z);\x0a"
"\x09y = cimagl(z);\x0a"
"\x0a"
"\x09if ((x == 0.0L) \x26\x26 (y > 1.0L))\x0a"
"\x09\x09goto ovrf;\x0a"
"\x0a"
"\x09x2 = x * x;\x0a"
"\x09""a = 1.0L - x2 - (y * y);\x0a"
"\x09if (a == 0.0L)\x0a"
"\x09\x09goto ovrf;\x0a"
"\x0a"
"\x09t = atan2l(2.0L * x, a) * 0.5L;\x0a"
"\x09w = redupil(t);\x0a"
"\x0a"
"\x09t = y - 1.0L;\x0a"
"\x09""a = x2 + (t * t);\x0a"
"\x09if (a == 0.0L)\x0a"
"\x09\x09goto ovrf;\x0a"
"\x0a"
"\x09t = y + 1.0L;\x0a"
"\x09""a = (x2 + (t * t)) / a;\x0a"
"\x09w = w + (0.25L * logl(a)) * I;\x0a"
"\x09return (w);\x0a"
"\x0a"
"ovrf\x3a\x0a"
"\x09/*mtherr( \x22""catanl\x22, OVERFLOW );*/\x0a"
"\x09w = LDBL_MAX + LDBL_MAX * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 2978 ); }