#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_cbrt_c( 
"/* \x40(#)s_cbrt.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/* cbrt(x)\x0a"
" * Return cube root of x\x0a"
" */\x0a"
"static const u_int32_t\x0a"
"\x09""B1 = 715094163, /* B1 = (682-0.03306235651)*2**20 */\x0a"
"\x09""B2 = 696219795; /* B2 = (664-0.03306235651)*2**20 */\x0a"
"\x0a"
"static const double\x0a"
"C =  5.42857142857142815906e-01, /* 19/35     = 0x3FE15F15, 0xF15F15F1 */\x0a"
"D = -7.05306122448979611050e-01, /* -864/1225 = 0xBFE691DE, 0x2532C834 */\x0a"
"E =  1.41428571428571436819e+00, /* 99/70     = 0x3FF6A0EA, 0x0EA0EA0F */\x0a"
"F =  1.60714285714285720630e+00, /* 45/28     = 0x3FF9B6DB, 0x6DB6DB6E */\x0a"
"G =  3.57142857142857150787e-01; /* 5/14      = 0x3FD6DB6D, 0xB6DB6DB7 */\x0a"
"\x0a"
"double\x0a"
"cbrt(double x) \x0a"
"{\x0a"
"\x09int32_t\x09hx;\x0a"
"\x09""double r,s,t=0.0,w;\x0a"
"\x09u_int32_t sign;\x0a"
"\x09u_int32_t high,low;\x0a"
"\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09sign=hx\x26""0x80000000; \x09\x09/* sign= sign(x) */\x0a"
"\x09hx  ^=sign;\x0a"
"\x09if(hx>=0x7ff00000) return(x+x); /* cbrt(NaN,INF) is itself */\x0a"
"\x09GET_LOW_WORD(low,x);\x0a"
"\x09if((hx\x7clow)==0) \x0a"
"\x09    return(x);\x09\x09/* cbrt(0) is itself */\x0a"
"\x0a"
"\x09SET_HIGH_WORD(x,hx);\x09/* x <- \x7cx\x7c */\x0a"
"    /* rough cbrt to 5 bits */\x0a"
"\x09if(hx<0x00100000) \x09\x09/* subnormal number */\x0a"
"\x09  {SET_HIGH_WORD(t,0x43500000);\x09/* set t= 2**54 */\x0a"
"\x09   t*=x; GET_HIGH_WORD(high,t); SET_HIGH_WORD(t,high/3+B2);\x0a"
"\x09  }\x0a"
"\x09""else\x0a"
"\x09  SET_HIGH_WORD(t,hx/3+B1);\x0a"
"\x0a"
"\x0a"
"    /* new cbrt to 23 bits, may be implemented in single precision */\x0a"
"\x09r=t*t/x;\x0a"
"\x09s=C+r*t;\x0a"
"\x09t*=G+F/(s+E+D/s);\x09\x0a"
"\x0a"
"    /* chopped to 20 bits and make it larger than cbrt(x) */ \x0a"
"\x09GET_HIGH_WORD(high,t);\x0a"
"\x09INSERT_WORDS(t,high+0x00000001,0);\x0a"
"\x0a"
"\x0a"
"    /* one step newton iteration to 53 bits with error less than 0.667 ulps */\x0a"
"\x09s=t*t;\x09\x09/* t*t is exact */\x0a"
"\x09r=x/s;\x0a"
"\x09w=t+t;\x0a"
"\x09r=(r-t)/(w+r);\x09/* r-s is exact */\x0a"
"\x09t=t+t*r;\x0a"
"\x0a"
"    /* retore the sign bit */\x0a"
"\x09GET_HIGH_WORD(high,t);\x0a"
"\x09SET_HIGH_WORD(t,high\x7csign);\x0a"
"\x09return(t);\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(cbrtl, cbrt);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 2238 ); }