#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_cbrtf_c( 
"/* s_cbrtf.c -- float version of s_cbrt.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/* cbrtf(x)\x0a"
" * Return cube root of x\x0a"
" */\x0a"
"static const unsigned \x0a"
"B1 = 709958130, /* B1 = (84+2/3-0.03306235651)*2**23 */\x0a"
"B2 = 642849266; /* B2 = (76+2/3-0.03306235651)*2**23 */\x0a"
"\x0a"
"static const float\x0a"
"C =  5.4285717010e-01, /* 19/35     = 0x3f0af8b0 */\x0a"
"D = -7.0530611277e-01, /* -864/1225 = 0xbf348ef1 */\x0a"
"E =  1.4142856598e+00, /* 99/70     = 0x3fb50750 */\x0a"
"F =  1.6071428061e+00, /* 45/28     = 0x3fcdb6db */\x0a"
"G =  3.5714286566e-01; /* 5/14      = 0x3eb6db6e */\x0a"
"\x0a"
"float\x0a"
"cbrtf(float x) \x0a"
"{\x0a"
"\x09""float r,s,t;\x0a"
"\x09int32_t hx;\x0a"
"\x09u_int32_t sign;\x0a"
"\x09u_int32_t high;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09sign=hx\x26""0x80000000; \x09\x09/* sign= sign(x) */\x0a"
"\x09hx  ^=sign;\x0a"
"\x09if(hx>=0x7f800000) return(x+x); /* cbrt(NaN,INF) is itself */\x0a"
"\x09if(hx==0) \x0a"
"\x09    return(x);\x09\x09/* cbrt(0) is itself */\x0a"
"\x0a"
"\x09SET_FLOAT_WORD(x,hx);\x09/* x <- \x7cx\x7c */\x0a"
"    /* rough cbrt to 5 bits */\x0a"
"\x09if(hx<0x00800000) \x09\x09/* subnormal number */\x0a"
"\x09  {SET_FLOAT_WORD(t,0x4b800000); /* set t= 2**24 */\x0a"
"\x09   t*=x; GET_FLOAT_WORD(high,t); SET_FLOAT_WORD(t,high/3+B2);\x0a"
"\x09  }\x0a"
"\x09""else\x0a"
"\x09  SET_FLOAT_WORD(t,hx/3+B1);\x0a"
"\x0a"
"\x0a"
"    /* new cbrt to 23 bits */\x0a"
"\x09r=t*t/x;\x0a"
"\x09s=C+r*t;\x0a"
"\x09t*=G+F/(s+E+D/s);\x09\x0a"
"\x0a"
"    /* retore the sign bit */\x0a"
"\x09GET_FLOAT_WORD(high,t);\x0a"
"\x09SET_FLOAT_WORD(t,high\x7csign);\x0a"
"\x09return(t);\x0a"
"}\x0a"
"", 1732 ); }