#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_ccosf_c( 
"/*\x09\x24OpenBSD\x3a s_ccosf.c,v 1.2 2010/07/18 18\x3a""42\x3a""26 guenther Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""ccosf()\x0a"
" *\x0a"
" *\x09""Complex circular cosine\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * void ccosf();\x0a"
" * cmplxf z, w;\x0a"
" *\x0a"
" * ccosf( \x26z, \x26w );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * If\x0a"
" *     z = x + iy,\x0a"
" *\x0a"
" * then\x0a"
" *\x0a"
" *     w = cos x  cosh y  -  i sin x sinh y.\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE      -10,+10     30000       1.8e-7       5.5e-8\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"/* calculate cosh and sinh */\x0a"
"\x0a"
"static void\x0a"
"_cchshf(float xx, float *c, float *s)\x0a"
"{\x0a"
"\x09""float x, e, ei;\x0a"
"\x0a"
"\x09x = xx;\x0a"
"\x09if(fabsf(x) <= 0.5f) {\x0a"
"\x09\x09*c = coshf(x);\x0a"
"\x09\x09*s = sinhf(x);\x0a"
"\x09}\x0a"
"\x09""else {\x0a"
"\x09\x09""e = expf(x);\x0a"
"\x09\x09""ei = 0.5f/e;\x0a"
"\x09\x09""e = 0.5f * e;\x0a"
"\x09\x09*s = e - ei;\x0a"
"\x09\x09*c = e + ei;\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"float complex\x0a"
"ccosf(float complex z)\x0a"
"{\x0a"
"\x09""float complex w;\x0a"
"\x09""float ch, sh;\x0a"
"\x0a"
"\x09_cchshf( cimagf(z), \x26""ch, \x26sh );\x0a"
"\x09w = cosf( crealf(z) ) * ch + ( -sinf( crealf(z) ) * sh) * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 1777 ); }