#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_ccosh_c( 
"/*\x09\x24OpenBSD\x3a s_ccosh.c,v 1.6 2013/07/03 04\x3a""46\x3a""36 espie Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""ccosh\x0a"
" *\x0a"
" *\x09""Complex hyperbolic cosine\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * double complex ccosh();\x0a"
" * double complex z, w;\x0a"
" *\x0a"
" * w = ccosh (z);\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * ccosh(z) = cosh x  cos y + i sinh x sin y .\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE      -10,+10     30000       2.9e-16     8.1e-17\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"double complex\x0a"
"ccosh(double complex z)\x0a"
"{\x0a"
"\x09""double complex w;\x0a"
"\x09""double x, y;\x0a"
"\x0a"
"\x09x = creal(z);\x0a"
"\x09y = cimag(z);\x0a"
"\x09w = cosh (x) * cos (y)  +  (sinh (x) * sin (y)) * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(ccoshl, ccosh);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 1608 ); }