#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_cexpl_c( 
"/*\x09\x24OpenBSD\x3a s_cexpl.c,v 1.2 2011/07/20 19\x3a""28\x3a""33 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""cexpl()\x0a"
" *\x0a"
" *\x09""Complex exponential function\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double complex cexpl();\x0a"
" * long double complex z, w;\x0a"
" *\x0a"
" * w = cexpl( z );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Returns the exponential of the complex argument z\x0a"
" * into the complex result w.\x0a"
" *\x0a"
" * If\x0a"
" *     z = x + iy,\x0a"
" *     r = exp(x),\x0a"
" *\x0a"
" * then\x0a"
" *\x0a"
" *     w = r cos y + i r sin y.\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    DEC       -10,+10      8700       3.7e-17     1.1e-17\x0a"
" *    IEEE      -10,+10     30000       3.0e-16     8.7e-17\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"long double complex\x0a"
"cexpl(long double complex z)\x0a"
"{\x0a"
"\x09long double complex w;\x0a"
"\x09long double r;\x0a"
"\x0a"
"\x09r = expl(creall(z));\x0a"
"\x09w = r * cosl(cimagl(z)) + (r * sinl(cimagl(z))) * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 1701 ); }