#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_clogf_c( 
"/*\x09\x24OpenBSD\x3a s_clogf.c,v 1.2 2010/07/18 18\x3a""42\x3a""26 guenther Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""clogf.c\x0a"
" *\x0a"
" *\x09""Complex natural logarithm\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * void clogf();\x0a"
" * cmplxf z, w;\x0a"
" *\x0a"
" * clogf( \x26z, \x26w );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Returns complex logarithm to the base e (2.718...) of\x0a"
" * the complex argument x.\x0a"
" *\x0a"
" * If z = x + iy, r = sqrt( x**2 + y**2 ),\x0a"
" * then\x0a"
" *       w = log(r) + i arctan(y/x).\x0a"
" *\x0a"
" * The arctangent ranges from -PI to +PI.\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE      -10,+10     30000       1.9e-6       6.2e-8\x0a"
" *\x0a"
" * Larger relative error can be observed for z near 1 +i0.\x0a"
" * In IEEE arithmetic the peak absolute error is 3.1e-7.\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"float complex\x0a"
"clogf(float complex z)\x0a"
"{\x0a"
"\x09""float complex w;\x0a"
"\x09""float p, rr, x, y;\x0a"
"\x0a"
"\x09x = crealf(z);\x0a"
"\x09y = cimagf(z);\x0a"
"\x09rr = atan2f(y, x);\x0a"
"\x09p = cabsf(z);\x0a"
"\x09p = logf(p);\x0a"
"\x09w = p + rr * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 1781 ); }