#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_clogl_c( 
"/*\x09\x24OpenBSD\x3a s_clogl.c,v 1.2 2011/07/20 19\x3a""28\x3a""33 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""clogl.c\x0a"
" *\x0a"
" *\x09""Complex natural logarithm\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double complex clogl();\x0a"
" * long double complex z, w;\x0a"
" *\x0a"
" * w = clogl( z );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Returns complex logarithm to the base e (2.718...) of\x0a"
" * the complex argument x.\x0a"
" *\x0a"
" * If z = x + iy, r = sqrt( x**2 + y**2 ),\x0a"
" * then\x0a"
" *       w = log(r) + i arctan(y/x).\x0a"
" *\x0a"
" * The arctangent ranges from -PI to +PI.\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    DEC       -10,+10      7000       8.5e-17     1.9e-17\x0a"
" *    IEEE      -10,+10     30000       5.0e-15     1.1e-16\x0a"
" *\x0a"
" * Larger relative error can be observed for z near 1 +i0.\x0a"
" * In IEEE arithmetic the peak absolute error is 5.2e-16, rms\x0a"
" * absolute error 1.0e-16.\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"long double complex\x0a"
"clogl(long double complex z)\x0a"
"{\x0a"
"\x09long double complex w;\x0a"
"\x09long double p, rr;\x0a"
"\x0a"
"\x09/*rr = sqrt(z->r * z->r  +  z->i * z->i);*/\x0a"
"\x09p = cabsl(z);\x0a"
"\x09p = logl(p);\x0a"
"\x09rr = atan2l(cimagl(z), creall(z));\x0a"
"\x09w = p + rr * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 1945 ); }