#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_cosl_c( 
"/*\x09\x24OpenBSD\x3a s_cosl.c,v 1.1 2008/12/09 20\x3a""00\x3a""35 martynas Exp \x24\x09*/\x0a"
"/*-\x0a"
" * Copyright (c) 2007 Steven G. Kargl\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice unmodified, this list of conditions, and the following\x0a"
" *    disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE AUTHOR \x60\x60""AS IS'' AND ANY EXPRESS OR\x0a"
" * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES\x0a"
" * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.\x0a"
" * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,\x0a"
" * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT\x0a"
" * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,\x0a"
" * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY\x0a"
" * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\x0a"
" * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF\x0a"
" * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * Compute cos(x) for x where x is reduced to y = x - k * pi / 2.\x0a"
" * Limited testing on pseudorandom numbers drawn within \x5b-2e8\x3a""4e8\x5d shows\x0a"
" * an accuracy of <= 0.7412 ULP.\x0a"
" */\x0a"
"\x0a"
"#include <sys/types.h>\x0a"
"#include <machine/ieee.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"#if LDBL_MANT_DIG == 64\x0a"
"#define\x09NX\x09""3\x0a"
"#define\x09PREC\x09""2\x0a"
"#elif LDBL_MANT_DIG == 113\x0a"
"#define\x09NX\x09""5\x0a"
"#define\x09PREC\x09""3\x0a"
"#else\x0a"
"#error \x22Unsupported long double format\x22\x0a"
"#endif\x0a"
"\x0a"
"static const long double two24 = 1.67772160000000000000e+07L;\x0a"
"\x0a"
"long double\x0a"
"cosl(long double x)\x0a"
"{\x0a"
"\x09union {\x0a"
"\x09\x09long double e;\x0a"
"\x09\x09struct ieee_ext bits;\x0a"
"\x09} z;\x0a"
"\x09int i, e0;\x0a"
"\x09""double xd\x5bNX\x5d, yd\x5bPREC\x5d;\x0a"
"\x09long double hi, lo;\x0a"
"\x0a"
"\x09z.e = x;\x0a"
"\x09z.bits.ext_sign = 0;\x0a"
"\x0a"
"\x09/* If x = +-0 or x is a subnormal number, then cos(x) = 1 */\x0a"
"\x09if (z.bits.ext_exp == 0)\x0a"
"\x09\x09return (1.0);\x0a"
"\x0a"
"\x09/* If x = NaN or Inf, then cos(x) = NaN. */\x0a"
"\x09if (z.bits.ext_exp == 32767)\x0a"
"\x09\x09return ((x - x) / (x - x));\x0a"
"\x0a"
"\x09/* Optimize the case where x is already within range. */\x0a"
"\x09if (z.e < M_PI_4)\x0a"
"\x09\x09return (__kernel_cosl(z.e, 0));\x0a"
"\x0a"
"\x09/* Split z.e into a 24-bit representation. */\x0a"
"\x09""e0 = ilogbl(z.e) - 23;\x0a"
"\x09z.e = scalbnl(z.e, -e0);\x0a"
"\x09""for (i = 0; i < NX; i++) {\x0a"
"\x09\x09xd\x5bi\x5d = (double)((int32_t)z.e);\x0a"
"\x09\x09z.e = (z.e - xd\x5bi\x5d) * two24;\x0a"
"\x09}\x0a"
"\x09\x0a"
"\x09/* yd contains the pieces of xd rem pi/2 such that \x7cyd\x7c < pi/4. */\x0a"
"\x09""e0 = __kernel_rem_pio2(xd, yd, e0, NX, PREC);\x0a"
"\x0a"
"#if PREC == 2\x0a"
"\x09hi = (long double)yd\x5b""0\x5d + yd\x5b""1\x5d;\x0a"
"\x09lo = yd\x5b""1\x5d - (hi - yd\x5b""0\x5d);\x0a"
"#else /* PREC == 3 */\x0a"
"\x09long double t;\x0a"
"\x09t = (long double)yd\x5b""2\x5d + yd\x5b""1\x5d;\x0a"
"\x09hi = t + yd\x5b""0\x5d;\x0a"
"\x09lo = yd\x5b""0\x5d - (hi - t);\x0a"
"#endif\x0a"
"\x0a"
"\x09switch (e0 \x26 3) {\x0a"
"\x09""case 0\x3a\x0a"
"\x09    hi = __kernel_cosl(hi, lo);\x0a"
"\x09    break;\x0a"
"\x09""case 1\x3a\x0a"
"\x09    hi = - __kernel_sinl(hi, lo, 1);\x0a"
"\x09    break;\x0a"
"\x09""case 2\x3a\x0a"
"\x09    hi = - __kernel_cosl(hi, lo);\x0a"
"\x09    break;\x0a"
"\x09""case 3\x3a\x0a"
"\x09    hi = __kernel_sinl(hi, lo, 1);\x0a"
"\x09    break;\x0a"
"\x09}\x0a"
"\x09\x0a"
"\x09return (hi);\x0a"
"}\x0a"
"", 3202 ); }