#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_cpow_c( 
"/*\x09\x24OpenBSD\x3a s_cpow.c,v 1.6 2013/07/03 04\x3a""46\x3a""36 espie Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""cpow\x0a"
" *\x0a"
" *\x09""Complex power function\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * double complex cpow();\x0a"
" * double complex a, z, w;\x0a"
" *\x0a"
" * w = cpow (a, z);\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * Raises complex A to the complex Zth power.\x0a"
" * Definition is per AMS55 # 4.2.8,\x0a"
" * analytically equivalent to cpow(a,z) = cexp(z clog(a)).\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE      -10,+10     30000       9.4e-15     1.5e-15\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"double complex\x0a"
"cpow(double complex a, double complex z)\x0a"
"{\x0a"
"\x09""double complex w;\x0a"
"\x09""double x, y, r, theta, absa, arga;\x0a"
"\x0a"
"\x09x = creal (z);\x0a"
"\x09y = cimag (z);\x0a"
"\x09""absa = cabs (a);\x0a"
"\x09if (absa == 0.0) {\x0a"
"\x09\x09return (0.0 + 0.0 * I);\x0a"
"\x09}\x0a"
"\x09""arga = carg (a);\x0a"
"\x09r = pow (absa, x);\x0a"
"\x09theta = x * arga;\x0a"
"\x09if (y \x21= 0.0) {\x0a"
"\x09\x09r = r * exp (-y * arga);\x0a"
"\x09\x09theta = theta + y * log (absa);\x0a"
"\x09}\x0a"
"\x09w = r * cos (theta) + (r * sin (theta)) * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(cpowl, cpow);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 1937 ); }