#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_csin_c( 
"/*\x09\x24OpenBSD\x3a s_csin.c,v 1.6 2013/07/03 04\x3a""46\x3a""36 espie Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""csin()\x0a"
" *\x0a"
" *\x09""Complex circular sine\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * double complex csin();\x0a"
" * double complex z, w;\x0a"
" *\x0a"
" * w = csin (z);\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * If\x0a"
" *     z = x + iy,\x0a"
" *\x0a"
" * then\x0a"
" *\x0a"
" *     w = sin x  cosh y  +  i cos x sinh y.\x0a"
" *\x0a"
" * csin(z) = -i csinh(iz).\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    DEC       -10,+10      8400       5.3e-17     1.3e-17\x0a"
" *    IEEE      -10,+10     30000       3.8e-16     1.0e-16\x0a"
" * Also tested by csin(casin(z)) = z.\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"/* calculate cosh and sinh */\x0a"
"\x0a"
"static void\x0a"
"cchsh(double x, double *c, double *s)\x0a"
"{\x0a"
"\x09""double e, ei;\x0a"
"\x0a"
"\x09if (fabs(x) <= 0.5) {\x0a"
"\x09\x09*c = cosh(x);\x0a"
"\x09\x09*s = sinh(x);\x0a"
"\x09}\x0a"
"\x09""else {\x0a"
"\x09\x09""e = exp(x);\x0a"
"\x09\x09""ei = 0.5/e;\x0a"
"\x09\x09""e = 0.5 * e;\x0a"
"\x09\x09*s = e - ei;\x0a"
"\x09\x09*c = e + ei;\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"double complex\x0a"
"csin(double complex z)\x0a"
"{\x0a"
"\x09""double complex w;\x0a"
"\x09""double ch, sh;\x0a"
"\x0a"
"\x09""cchsh( cimag (z), \x26""ch, \x26sh );\x0a"
"\x09w = sin (creal(z)) * ch + (cos (creal(z)) * sh) * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(csinl, csin);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 2011 ); }