#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_csinhf_c( 
"/*\x09\x24OpenBSD\x3a s_csinhf.c,v 1.2 2010/07/18 18\x3a""42\x3a""26 guenther Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""csinhf\x0a"
" *\x0a"
" *\x09""Complex hyperbolic sine\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * float complex csinhf();\x0a"
" * float complex z, w;\x0a"
" *\x0a"
" * w = csinhf (z);\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * csinh z = (cexp(z) - cexp(-z))/2\x0a"
" *         = sinh x * cos y  +  i cosh x * sin y .\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE      -10,+10     30000       3.1e-16     8.2e-17\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"float complex\x0a"
"csinhf(float complex z)\x0a"
"{\x0a"
"\x09""float complex w;\x0a"
"\x09""float x, y;\x0a"
"\x0a"
"\x09x = crealf(z);\x0a"
"\x09y = cimagf(z);\x0a"
"\x09w = sinhf (x) * cosf (y)  +  (coshf (x) * sinf (y)) * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 1520 ); }