#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_csqrtl_c( 
"/*\x09\x24OpenBSD\x3a s_csqrtl.c,v 1.3 2015/12/18 12\x3a""10\x3a""30 shadchin Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""csqrtl()\x0a"
" *\x0a"
" *\x09""Complex square root\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double complex csqrtl();\x0a"
" * long double complex z, w;\x0a"
" *\x0a"
" * w = csqrtl( z );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" *\x0a"
" * If z = x + iy,  r = \x7cz\x7c, then\x0a"
" *\x0a"
" *                       1/2\x0a"
" * Re w  =  \x5b (r + x)/2 \x5d   ,\x0a"
" *\x0a"
" *                       1/2\x0a"
" * Im w  =  \x5b (r - x)/2 \x5d   .\x0a"
" *\x0a"
" * Cancellation error in r-x or r+x is avoided by using the\x0a"
" * identity  2 Re w Im w  =  y.\x0a"
" *\x0a"
" * Note that -w is also a square root of z.  The root chosen\x0a"
" * is always in the right half plane and Im w has the same sign as y.\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE      -10,+10     500000      1.1e-19     3.0e-20\x0a"
" *\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"long double complex\x0a"
"csqrtl(long double complex z)\x0a"
"{\x0a"
"\x09long double complex w;\x0a"
"\x09long double x, y, r, t, scale;\x0a"
"\x0a"
"\x09x = creall(z);\x0a"
"\x09y = cimagl(z);\x0a"
"\x0a"
"\x09if (y == 0.0L) {\x0a"
"\x09\x09if (x < 0.0L) {\x0a"
"\x09\x09\x09w = 0.0L + copysign(sqrtl(-x), y) * I;\x0a"
"\x09\x09\x09return (w);\x0a"
"\x09\x09}\x0a"
"\x09\x09""else {\x0a"
"\x09\x09\x09w = sqrtl(x) + 0.0L * I;\x0a"
"\x09\x09\x09return (w);\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x0a"
"\x09if (x == 0.0L) {\x0a"
"\x09\x09r = fabsl(y);\x0a"
"\x09\x09r = sqrtl(0.5L * r);\x0a"
"\x09\x09if (y > 0.0L)\x0a"
"\x09\x09\x09w = r + r * I;\x0a"
"\x09\x09""else\x0a"
"\x09\x09\x09w = r - r * I;\x0a"
"\x09\x09return (w);\x0a"
"\x09}\x0a"
"\x0a"
"\x09/* Rescale to avoid internal overflow or underflow.  */\x0a"
"\x09if ((fabsl(x) > 4.0L) \x7c\x7c (fabsl(y) > 4.0L)) {\x0a"
"\x09\x09x *= 0.25L;\x0a"
"\x09\x09y *= 0.25L;\x0a"
"\x09\x09scale = 2.0L;\x0a"
"\x09}\x0a"
"\x09""else {\x0a"
"#if 1\x0a"
"\x09\x09x *= 7.3786976294838206464e19;  /* 2^66 */\x0a"
"\x09\x09y *= 7.3786976294838206464e19;\x0a"
"\x09\x09scale = 1.16415321826934814453125e-10;  /* 2^-33 */\x0a"
"#else\x0a"
"\x09\x09x *= 4.0L;\x0a"
"\x09\x09y *= 4.0L;\x0a"
"\x09\x09scale = 0.5L;\x0a"
"#endif\x0a"
"\x09}\x0a"
"\x09w = x + y * I;\x0a"
"\x09r = cabsl(w);\x0a"
"\x09if (x > 0) {\x0a"
"\x09\x09t = sqrtl(0.5L * r + 0.5L * x);\x0a"
"\x09\x09r = scale * fabsl((0.5L * y) / t);\x0a"
"\x09\x09t *= scale;\x0a"
"\x09}\x0a"
"\x09""else {\x0a"
"\x09\x09r = sqrtl(0.5L * r - 0.5L * x);\x0a"
"\x09\x09t = scale * fabsl((0.5L * y) / r);\x0a"
"\x09\x09r *= scale;\x0a"
"\x09}\x0a"
"\x09if (y < 0)\x0a"
"\x09\x09w = t - r * I;\x0a"
"\x09""else\x0a"
"\x09\x09w = t + r * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 2753 ); }