#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_ctanf_c( 
"/*\x09\x24OpenBSD\x3a s_ctanf.c,v 1.2 2011/07/20 19\x3a""28\x3a""33 martynas Exp \x24\x09*/\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""ctanf()\x0a"
" *\x0a"
" *\x09""Complex circular tangent\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * void ctanf();\x0a"
" * cmplxf z, w;\x0a"
" *\x0a"
" * ctanf( \x26z, \x26w );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * If\x0a"
" *     z = x + iy,\x0a"
" *\x0a"
" * then\x0a"
" *\x0a"
" *           sin 2x  +  i sinh 2y\x0a"
" *     w  =  --------------------.\x0a"
" *            cos 2x  +  cosh 2y\x0a"
" *\x0a"
" * On the real axis the denominator is zero at odd multiples\x0a"
" * of PI/2.  The denominator is evaluated by its Taylor\x0a"
" * series near these points.\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    IEEE      -10,+10     30000       3.3e-7       5.1e-8\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#define MACHEPF 3.0e-8\x0a"
"#define MAXNUMF 1.0e38f\x0a"
"\x0a"
"static const double DP1 = 3.140625;\x0a"
"static const double DP2 = 9.67502593994140625E-4;\x0a"
"static const double DP3 = 1.509957990978376432E-7;\x0a"
"\x0a"
"static float\x0a"
"_redupif(float xx)\x0a"
"{\x0a"
"\x09""float x, t;\x0a"
"\x09long i;\x0a"
"\x0a"
"\x09x = xx;\x0a"
"\x09t = x/(float)M_PI;\x0a"
"\x09if(t >= 0.0)\x0a"
"\x09\x09t += 0.5;\x0a"
"\x09""else\x0a"
"\x09\x09t -= 0.5;\x0a"
"\x0a"
"\x09i = t;\x09/* the multiple */\x0a"
"\x09t = i;\x0a"
"\x09t = ((x - t * DP1) - t * DP2) - t * DP3;\x0a"
"\x09return(t);\x0a"
"}\x0a"
"\x0a"
"/*  Taylor series expansion for cosh(2y) - cos(2x)\x09*/\x0a"
"\x0a"
"static float\x0a"
"_ctansf(float complex z)\x0a"
"{\x0a"
"\x09""float f, x, x2, y, y2, rn, t, d;\x0a"
"\x0a"
"\x09x = fabsf(2.0f * crealf(z));\x0a"
"\x09y = fabsf(2.0f * cimagf(z));\x0a"
"\x0a"
"\x09x = _redupif(x);\x0a"
"\x0a"
"\x09x = x * x;\x0a"
"\x09y = y * y;\x0a"
"\x09x2 = 1.0f;\x0a"
"\x09y2 = 1.0f;\x0a"
"\x09""f = 1.0f;\x0a"
"\x09rn = 0.0f;\x0a"
"\x09""d = 0.0f;\x0a"
"\x09""do {\x0a"
"\x09\x09rn += 1.0f;\x0a"
"\x09\x09""f *= rn;\x0a"
"\x09\x09rn += 1.0f;\x0a"
"\x09\x09""f *= rn;\x0a"
"\x09\x09x2 *= x;\x0a"
"\x09\x09y2 *= y;\x0a"
"\x09\x09t = y2 + x2;\x0a"
"\x09\x09t /= f;\x0a"
"\x09\x09""d += t;\x0a"
"\x0a"
"\x09\x09rn += 1.0f;\x0a"
"\x09\x09""f *= rn;\x0a"
"\x09\x09rn += 1.0f;\x0a"
"\x09\x09""f *= rn;\x0a"
"\x09\x09x2 *= x;\x0a"
"\x09\x09y2 *= y;\x0a"
"\x09\x09t = y2 - x2;\x0a"
"\x09\x09t /= f;\x0a"
"\x09\x09""d += t;\x0a"
"\x09}\x0a"
"\x09while (fabsf(t/d) > MACHEPF)\x0a"
"\x09\x09;\x0a"
"\x09return(d);\x0a"
"}\x0a"
"\x0a"
"float complex\x0a"
"ctanf(float complex z)\x0a"
"{\x0a"
"\x09""float complex w;\x0a"
"\x09""float d;\x0a"
"\x0a"
"\x09""d = cosf( 2.0f * crealf(z) ) + coshf( 2.0f * cimagf(z) );\x0a"
"\x0a"
"\x09if(fabsf(d) < 0.25f)\x0a"
"\x09\x09""d = _ctansf(z);\x0a"
"\x0a"
"\x09if (d == 0.0f) {\x0a"
"\x09\x09/*mtherr( \x22""ctanf\x22, OVERFLOW );*/\x0a"
"\x09\x09w = MAXNUMF + MAXNUMF * I;\x0a"
"\x09\x09return (w);\x0a"
"\x09}\x0a"
"\x09w = sinf (2.0f * crealf(z)) / d + (sinhf (2.0f * cimagf(z)) / d) * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 2865 ); }