#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_ctanl_c( 
"/*\x09\x24OpenBSD\x3a s_ctanl.c,v 1.3 2011/07/20 21\x3a""02\x3a""51 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*\x0a"
" * Copyright (c) 2008 Stephen L. Moshier <steve\x40moshier.net>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"/*\x09\x09\x09\x09\x09\x09\x09""ctanl()\x0a"
" *\x0a"
" *\x09""Complex circular tangent\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * SYNOPSIS\x3a\x0a"
" *\x0a"
" * long double complex ctanl();\x0a"
" * long double complex z, w;\x0a"
" *\x0a"
" * w = ctanl( z );\x0a"
" *\x0a"
" *\x0a"
" *\x0a"
" * DESCRIPTION\x3a\x0a"
" *\x0a"
" * If\x0a"
" *     z = x + iy,\x0a"
" *\x0a"
" * then\x0a"
" *\x0a"
" *           sin 2x  +  i sinh 2y\x0a"
" *     w  =  --------------------.\x0a"
" *            cos 2x  +  cosh 2y\x0a"
" *\x0a"
" * On the real axis the denominator is zero at odd multiples\x0a"
" * of PI/2.  The denominator is evaluated by its Taylor\x0a"
" * series near these points.\x0a"
" *\x0a"
" *\x0a"
" * ACCURACY\x3a\x0a"
" *\x0a"
" *                      Relative error\x3a\x0a"
" * arithmetic   domain     # trials      peak         rms\x0a"
" *    DEC       -10,+10      5200       7.1e-17     1.6e-17\x0a"
" *    IEEE      -10,+10     30000       7.2e-16     1.2e-16\x0a"
" * Also tested by ctan * ccot = 1 and catan(ctan(z))  =  z.\x0a"
" */\x0a"
"\x0a"
"#include <complex.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == 64\x0a"
"static const long double MACHEPL= 5.42101086242752217003726400434970855712890625E-20L;\x0a"
"#elif\x09LDBL_MANT_DIG == 113\x0a"
"static const long double MACHEPL = 9.629649721936179265279889712924636592690508e-35L;\x0a"
"#endif\x0a"
"\x0a"
"static const long double PIL = 3.141592653589793238462643383279502884197169L;\x0a"
"static const long double DP1 = 3.14159265358979323829596852490908531763125L;\x0a"
"static const long double DP2 = 1.6667485837041756656403424829301998703007e-19L;\x0a"
"static const long double DP3 = 1.8830410776607851167459095484560349402753e-39L;\x0a"
"\x0a"
"static long double\x0a"
"redupil(long double x)\x0a"
"{\x0a"
"\x09long double t;\x0a"
"\x09long i;\x0a"
"\x0a"
"\x09t = x / PIL;\x0a"
"\x09if (t >= 0.0L)\x0a"
"\x09\x09t += 0.5L;\x0a"
"\x09""else\x0a"
"\x09\x09t -= 0.5L;\x0a"
"\x0a"
"\x09i = t;\x09/* the multiple */\x0a"
"\x09t = i;\x0a"
"\x09t = ((x - t * DP1) - t * DP2) - t * DP3;\x0a"
"\x09return (t);\x0a"
"}\x0a"
"\x0a"
"static long double\x0a"
"ctansl(long double complex z)\x0a"
"{\x0a"
"\x09long double f, x, x2, y, y2, rn, t;\x0a"
"\x09long double d;\x0a"
"\x0a"
"\x09x = fabsl(2.0L * creall(z));\x0a"
"\x09y = fabsl(2.0L * cimagl(z));\x0a"
"\x0a"
"\x09x = redupil(x);\x0a"
"\x0a"
"\x09x = x * x;\x0a"
"\x09y = y * y;\x0a"
"\x09x2 = 1.0L;\x0a"
"\x09y2 = 1.0L;\x0a"
"\x09""f = 1.0L;\x0a"
"\x09rn = 0.0L;\x0a"
"\x09""d = 0.0L;\x0a"
"\x09""do {\x0a"
"\x09\x09rn += 1.0L;\x0a"
"\x09\x09""f *= rn;\x0a"
"\x09\x09rn += 1.0L;\x0a"
"\x09\x09""f *= rn;\x0a"
"\x09\x09x2 *= x;\x0a"
"\x09\x09y2 *= y;\x0a"
"\x09\x09t = y2 + x2;\x0a"
"\x09\x09t /= f;\x0a"
"\x09\x09""d += t;\x0a"
"\x0a"
"\x09\x09rn += 1.0L;\x0a"
"\x09\x09""f *= rn;\x0a"
"\x09\x09rn += 1.0L;\x0a"
"\x09\x09""f *= rn;\x0a"
"\x09\x09x2 *= x;\x0a"
"\x09\x09y2 *= y;\x0a"
"\x09\x09t = y2 - x2;\x0a"
"\x09\x09t /= f;\x0a"
"\x09\x09""d += t;\x0a"
"\x09}\x0a"
"\x09while (fabsl(t/d) > MACHEPL);\x0a"
"\x09return(d);\x0a"
"}\x0a"
"\x0a"
"long double complex\x0a"
"ctanl(long double complex z)\x0a"
"{\x0a"
"\x09long double complex w;\x0a"
"\x09long double d, x, y;\x0a"
"\x0a"
"\x09x = creall(z);\x0a"
"\x09y = cimagl(z);\x0a"
"\x09""d = cosl(2.0L * x) + coshl(2.0L * y);\x0a"
"\x0a"
"\x09if (fabsl(d) < 0.25L) {\x0a"
"\x09\x09""d = fabsl(d);\x0a"
"\x09\x09""d = ctansl(z);\x0a"
"\x09}\x0a"
"\x09if (d == 0.0L) {\x0a"
"\x09\x09/*mtherr( \x22""ctan\x22, OVERFLOW );*/\x0a"
"\x09\x09w = LDBL_MAX + LDBL_MAX * I;\x0a"
"\x09\x09return (w);\x0a"
"\x09}\x0a"
"\x0a"
"\x09w = sinl(2.0L * x) / d + (sinhl(2.0L * y) / d) * I;\x0a"
"\x09return (w);\x0a"
"}\x0a"
"", 3414 ); }