#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_erf_c( 
"/* \x40(#)s_erf.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* double erf(double x)\x0a"
" * double erfc(double x)\x0a"
" *\x09\x09\x09     x\x0a"
" *\x09\x09      2      \x7c\x5c\x0a"
" *     erf(x)  =  ---------  \x7c exp(-t*t)dt\x0a"
" *\x09 \x09   sqrt(pi) \x5c\x7c \x0a"
" *\x09\x09\x09     0\x0a"
" *\x0a"
" *     erfc(x) =  1-erf(x)\x0a"
" *  Note that \x0a"
" *\x09\x09""erf(-x) = -erf(x)\x0a"
" *\x09\x09""erfc(-x) = 2 - erfc(x)\x0a"
" *\x0a"
" * Method\x3a\x0a"
" *\x09""1. For \x7cx\x7c in \x5b""0, 0.84375\x5d\x0a"
" *\x09    erf(x)  = x + x*R(x^2)\x0a"
" *          erfc(x) = 1 - erf(x)           if x in \x5b-.84375,0.25\x5d\x0a"
" *                  = 0.5 + ((0.5-x)-x*R)  if x in \x5b""0.25,0.84375\x5d\x0a"
" *\x09   where R = P/Q where P is an odd poly of degree 8 and\x0a"
" *\x09   Q is an odd poly of degree 10.\x0a"
" *\x09\x09\x09\x09\x09\x09 -57.90\x0a"
" *\x09\x09\x09\x7c R - (erf(x)-x)/x \x7c <= 2\x0a"
" *\x09\x0a"
" *\x0a"
" *\x09   Remark. The formula is derived by noting\x0a"
" *          erf(x) = (2/sqrt(pi))*(x - x^3/3 + x^5/10 - x^7/42 + ....)\x0a"
" *\x09   and that\x0a"
" *          2/sqrt(pi) = 1.128379167095512573896158903121545171688\x0a"
" *\x09   is close to one. The interval is chosen because the fix\x0a"
" *\x09   point of erf(x) is near 0.6174 (i.e., erf(x)=x when x is\x0a"
" *\x09   near 0.6174), and by some experiment, 0.84375 is chosen to\x0a"
" * \x09   guarantee the error is less than one ulp for erf.\x0a"
" *\x0a"
" *      2. For \x7cx\x7c in \x5b""0.84375,1.25\x5d, let s = \x7cx\x7c - 1, and\x0a"
" *         c = 0.84506291151 rounded to single (24 bits)\x0a"
" *         \x09""erf(x)  = sign(x) * (c  + P1(s)/Q1(s))\x0a"
" *         \x09""erfc(x) = (1-c)  - P1(s)/Q1(s) if x > 0\x0a"
" *\x09\x09\x09  1+(c+P1(s)/Q1(s))    if x < 0\x0a"
" *         \x09\x7cP1/Q1 - (erf(\x7cx\x7c)-c)\x7c <= 2**-59.06\x0a"
" *\x09   Remark\x3a here we use the taylor series expansion at x=1.\x0a"
" *\x09\x09""erf(1+s) = erf(1) + s*Poly(s)\x0a"
" *\x09\x09\x09 = 0.845.. + P1(s)/Q1(s)\x0a"
" *\x09   That is, we use rational approximation to approximate\x0a"
" *\x09\x09\x09""erf(1+s) - (c = (single)0.84506291151)\x0a"
" *\x09   Note that \x7cP1/Q1\x7c< 0.078 for x in \x5b""0.84375,1.25\x5d\x0a"
" *\x09   where \x0a"
" *\x09\x09P1(s) = degree 6 poly in s\x0a"
" *\x09\x09Q1(s) = degree 6 poly in s\x0a"
" *\x0a"
" *      3. For x in \x5b""1.25,1/0.35(\x7e""2.857143)\x5d, \x0a"
" *         \x09""erfc(x) = (1/x)*exp(-x*x-0.5625+R1/S1)\x0a"
" *         \x09""erf(x)  = 1 - erfc(x)\x0a"
" *\x09   where \x0a"
" *\x09\x09R1(z) = degree 7 poly in z, (z=1/x^2)\x0a"
" *\x09\x09S1(z) = degree 8 poly in z\x0a"
" *\x0a"
" *      4. For x in \x5b""1/0.35,28\x5d\x0a"
" *         \x09""erfc(x) = (1/x)*exp(-x*x-0.5625+R2/S2) if x > 0\x0a"
" *\x09\x09\x09= 2.0 - (1/x)*exp(-x*x-0.5625+R2/S2) if -6<x<0\x0a"
" *\x09\x09\x09= 2.0 - tiny\x09\x09(if x <= -6)\x0a"
" *         \x09""erf(x)  = sign(x)*(1.0 - erfc(x)) if x < 6, else\x0a"
" *         \x09""erf(x)  = sign(x)*(1.0 - tiny)\x0a"
" *\x09   where\x0a"
" *\x09\x09R2(z) = degree 6 poly in z, (z=1/x^2)\x0a"
" *\x09\x09S2(z) = degree 7 poly in z\x0a"
" *\x0a"
" *      Note1\x3a\x0a"
" *\x09   To compute exp(-x*x-0.5625+R/S), let s be a single\x0a"
" *\x09   precision number and s \x3a= x; then\x0a"
" *\x09\x09-x*x = -s*s + (s-x)*(s+x)\x0a"
" *\x09        exp(-x*x-0.5626+R/S) = \x0a"
" *\x09\x09\x09""exp(-s*s-0.5625)*exp((s-x)*(s+x)+R/S);\x0a"
" *      Note2\x3a\x0a"
" *\x09   Here 4 and 5 make use of the asymptotic series\x0a"
" *\x09\x09\x09  exp(-x*x)\x0a"
" *\x09\x09""erfc(x) \x7e ---------- * ( 1 + Poly(1/x^2) )\x0a"
" *\x09\x09\x09  x*sqrt(pi)\x0a"
" *\x09   We use rational approximation to approximate\x0a"
" *      \x09g(s)=f(1/x^2) = log(erfc(x)*x) - x*x + 0.5625\x0a"
" *\x09   Here is the error bound for R1/S1 and R2/S2\x0a"
" *      \x09\x7cR1/S1 - f(x)\x7c  < 2**(-62.57)\x0a"
" *      \x09\x7cR2/S2 - f(x)\x7c  < 2**(-61.52)\x0a"
" *\x0a"
" *      5. For inf > x >= 28\x0a"
" *         \x09""erf(x)  = sign(x) *(1 - tiny)  (raise inexact)\x0a"
" *         \x09""erfc(x) = tiny*tiny (raise underflow) if x > 0\x0a"
" *\x09\x09\x09= 2 - tiny if x<0\x0a"
" *\x0a"
" *      7. Special case\x3a\x0a"
" *         \x09""erf(0)  = 0, erf(inf)  = 1, erf(-inf) = -1,\x0a"
" *         \x09""erfc(0) = 1, erfc(inf) = 0, erfc(-inf) = 2, \x0a"
" *\x09   \x09""erfc/erf(NaN) is NaN\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double\x0a"
"tiny\x09    = 1e-300,\x0a"
"half=  5.00000000000000000000e-01, /* 0x3FE00000, 0x00000000 */\x0a"
"one =  1.00000000000000000000e+00, /* 0x3FF00000, 0x00000000 */\x0a"
"two =  2.00000000000000000000e+00, /* 0x40000000, 0x00000000 */\x0a"
"\x09/* c = (float)0.84506291151 */\x0a"
"erx =  8.45062911510467529297e-01, /* 0x3FEB0AC1, 0x60000000 */\x0a"
"/*\x0a"
" * Coefficients for approximation to  erf on \x5b""0,0.84375\x5d\x0a"
" */\x0a"
"efx =  1.28379167095512586316e-01, /* 0x3FC06EBA, 0x8214DB69 */\x0a"
"efx8=  1.02703333676410069053e+00, /* 0x3FF06EBA, 0x8214DB69 */\x0a"
"pp0  =  1.28379167095512558561e-01, /* 0x3FC06EBA, 0x8214DB68 */\x0a"
"pp1  = -3.25042107247001499370e-01, /* 0xBFD4CD7D, 0x691CB913 */\x0a"
"pp2  = -2.84817495755985104766e-02, /* 0xBF9D2A51, 0xDBD7194F */\x0a"
"pp3  = -5.77027029648944159157e-03, /* 0xBF77A291, 0x236668E4 */\x0a"
"pp4  = -2.37630166566501626084e-05, /* 0xBEF8EAD6, 0x120016AC */\x0a"
"qq1  =  3.97917223959155352819e-01, /* 0x3FD97779, 0xCDDADC09 */\x0a"
"qq2  =  6.50222499887672944485e-02, /* 0x3FB0A54C, 0x5536CEBA */\x0a"
"qq3  =  5.08130628187576562776e-03, /* 0x3F74D022, 0xC4D36B0F */\x0a"
"qq4  =  1.32494738004321644526e-04, /* 0x3F215DC9, 0x221C1A10 */\x0a"
"qq5  = -3.96022827877536812320e-06, /* 0xBED09C43, 0x42A26120 */\x0a"
"/*\x0a"
" * Coefficients for approximation to  erf  in \x5b""0.84375,1.25\x5d \x0a"
" */\x0a"
"pa0  = -2.36211856075265944077e-03, /* 0xBF6359B8, 0xBEF77538 */\x0a"
"pa1  =  4.14856118683748331666e-01, /* 0x3FDA8D00, 0xAD92B34D */\x0a"
"pa2  = -3.72207876035701323847e-01, /* 0xBFD7D240, 0xFBB8C3F1 */\x0a"
"pa3  =  3.18346619901161753674e-01, /* 0x3FD45FCA, 0x805120E4 */\x0a"
"pa4  = -1.10894694282396677476e-01, /* 0xBFBC6398, 0x3D3E28EC */\x0a"
"pa5  =  3.54783043256182359371e-02, /* 0x3FA22A36, 0x599795EB */\x0a"
"pa6  = -2.16637559486879084300e-03, /* 0xBF61BF38, 0x0A96073F */\x0a"
"qa1  =  1.06420880400844228286e-01, /* 0x3FBB3E66, 0x18EEE323 */\x0a"
"qa2  =  5.40397917702171048937e-01, /* 0x3FE14AF0, 0x92EB6F33 */\x0a"
"qa3  =  7.18286544141962662868e-02, /* 0x3FB2635C, 0xD99FE9A7 */\x0a"
"qa4  =  1.26171219808761642112e-01, /* 0x3FC02660, 0xE763351F */\x0a"
"qa5  =  1.36370839120290507362e-02, /* 0x3F8BEDC2, 0x6B51DD1C */\x0a"
"qa6  =  1.19844998467991074170e-02, /* 0x3F888B54, 0x5735151D */\x0a"
"/*\x0a"
" * Coefficients for approximation to  erfc in \x5b""1.25,1/0.35\x5d\x0a"
" */\x0a"
"ra0  = -9.86494403484714822705e-03, /* 0xBF843412, 0x600D6435 */\x0a"
"ra1  = -6.93858572707181764372e-01, /* 0xBFE63416, 0xE4BA7360 */\x0a"
"ra2  = -1.05586262253232909814e+01, /* 0xC0251E04, 0x41B0E726 */\x0a"
"ra3  = -6.23753324503260060396e+01, /* 0xC04F300A, 0xE4CBA38D */\x0a"
"ra4  = -1.62396669462573470355e+02, /* 0xC0644CB1, 0x84282266 */\x0a"
"ra5  = -1.84605092906711035994e+02, /* 0xC067135C, 0xEBCCABB2 */\x0a"
"ra6  = -8.12874355063065934246e+01, /* 0xC0545265, 0x57E4D2F2 */\x0a"
"ra7  = -9.81432934416914548592e+00, /* 0xC023A0EF, 0xC69AC25C */\x0a"
"sa1  =  1.96512716674392571292e+01, /* 0x4033A6B9, 0xBD707687 */\x0a"
"sa2  =  1.37657754143519042600e+02, /* 0x4061350C, 0x526AE721 */\x0a"
"sa3  =  4.34565877475229228821e+02, /* 0x407B290D, 0xD58A1A71 */\x0a"
"sa4  =  6.45387271733267880336e+02, /* 0x40842B19, 0x21EC2868 */\x0a"
"sa5  =  4.29008140027567833386e+02, /* 0x407AD021, 0x57700314 */\x0a"
"sa6  =  1.08635005541779435134e+02, /* 0x405B28A3, 0xEE48AE2C */\x0a"
"sa7  =  6.57024977031928170135e+00, /* 0x401A47EF, 0x8E484A93 */\x0a"
"sa8  = -6.04244152148580987438e-02, /* 0xBFAEEFF2, 0xEE749A62 */\x0a"
"/*\x0a"
" * Coefficients for approximation to  erfc in \x5b""1/.35,28\x5d\x0a"
" */\x0a"
"rb0  = -9.86494292470009928597e-03, /* 0xBF843412, 0x39E86F4A */\x0a"
"rb1  = -7.99283237680523006574e-01, /* 0xBFE993BA, 0x70C285DE */\x0a"
"rb2  = -1.77579549177547519889e+01, /* 0xC031C209, 0x555F995A */\x0a"
"rb3  = -1.60636384855821916062e+02, /* 0xC064145D, 0x43C5ED98 */\x0a"
"rb4  = -6.37566443368389627722e+02, /* 0xC083EC88, 0x1375F228 */\x0a"
"rb5  = -1.02509513161107724954e+03, /* 0xC0900461, 0x6A2E5992 */\x0a"
"rb6  = -4.83519191608651397019e+02, /* 0xC07E384E, 0x9BDC383F */\x0a"
"sb1  =  3.03380607434824582924e+01, /* 0x403E568B, 0x261D5190 */\x0a"
"sb2  =  3.25792512996573918826e+02, /* 0x40745CAE, 0x221B9F0A */\x0a"
"sb3  =  1.53672958608443695994e+03, /* 0x409802EB, 0x189D5118 */\x0a"
"sb4  =  3.19985821950859553908e+03, /* 0x40A8FFB7, 0x688C246A */\x0a"
"sb5  =  2.55305040643316442583e+03, /* 0x40A3F219, 0xCEDF3BE6 */\x0a"
"sb6  =  4.74528541206955367215e+02, /* 0x407DA874, 0xE79FE763 */\x0a"
"sb7  = -2.24409524465858183362e+01; /* 0xC03670E2, 0x42712D62 */\x0a"
"\x0a"
"double\x0a"
"erf(double x) \x0a"
"{\x0a"
"\x09int32_t hx,ix,i;\x0a"
"\x09""double R,S,P,Q,s,y,z,r;\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x7ff00000) {\x09\x09/* erf(nan)=nan */\x0a"
"\x09    i = ((u_int32_t)hx>>31)<<1;\x0a"
"\x09    return (double)(1-i)+one/x;\x09/* erf(+-inf)=+-1 */\x0a"
"\x09}\x0a"
"\x0a"
"\x09if(ix < 0x3feb0000) {\x09\x09/* \x7cx\x7c<0.84375 */\x0a"
"\x09    if(ix < 0x3e300000) { \x09/* \x7cx\x7c<2**-28 */\x0a"
"\x09        if (ix < 0x00800000) \x0a"
"\x09\x09    return 0.125*(8.0*x+efx8*x);  /*avoid underflow */\x0a"
"\x09\x09return x + efx*x;\x0a"
"\x09    }\x0a"
"\x09    z = x*x;\x0a"
"\x09    r = pp0+z*(pp1+z*(pp2+z*(pp3+z*pp4)));\x0a"
"\x09    s = one+z*(qq1+z*(qq2+z*(qq3+z*(qq4+z*qq5))));\x0a"
"\x09    y = r/s;\x0a"
"\x09    return x + x*y;\x0a"
"\x09}\x0a"
"\x09if(ix < 0x3ff40000) {\x09\x09/* 0.84375 <= \x7cx\x7c < 1.25 */\x0a"
"\x09    s = fabs(x)-one;\x0a"
"\x09    P = pa0+s*(pa1+s*(pa2+s*(pa3+s*(pa4+s*(pa5+s*pa6)))));\x0a"
"\x09    Q = one+s*(qa1+s*(qa2+s*(qa3+s*(qa4+s*(qa5+s*qa6)))));\x0a"
"\x09    if(hx>=0) return erx + P/Q; else return -erx - P/Q;\x0a"
"\x09}\x0a"
"\x09if (ix >= 0x40180000) {\x09\x09/* inf>\x7cx\x7c>=6 */\x0a"
"\x09    if(hx>=0) return one-tiny; else return tiny-one;\x0a"
"\x09}\x0a"
"\x09x = fabs(x);\x0a"
" \x09s = one/(x*x);\x0a"
"\x09if(ix< 0x4006DB6E) {\x09/* \x7cx\x7c < 1/0.35 */\x0a"
"\x09    R=ra0+s*(ra1+s*(ra2+s*(ra3+s*(ra4+s*(\x0a"
"\x09\x09\x09\x09ra5+s*(ra6+s*ra7))))));\x0a"
"\x09    S=one+s*(sa1+s*(sa2+s*(sa3+s*(sa4+s*(\x0a"
"\x09\x09\x09\x09sa5+s*(sa6+s*(sa7+s*sa8)))))));\x0a"
"\x09} else {\x09/* \x7cx\x7c >= 1/0.35 */\x0a"
"\x09    R=rb0+s*(rb1+s*(rb2+s*(rb3+s*(rb4+s*(\x0a"
"\x09\x09\x09\x09rb5+s*rb6)))));\x0a"
"\x09    S=one+s*(sb1+s*(sb2+s*(sb3+s*(sb4+s*(\x0a"
"\x09\x09\x09\x09sb5+s*(sb6+s*sb7))))));\x0a"
"\x09}\x0a"
"\x09z  = x;  \x0a"
"\x09SET_LOW_WORD(z,0);\x0a"
"\x09r  =  exp(-z*z-0.5625)*exp((z-x)*(z+x)+R/S);\x0a"
"\x09if(hx>=0) return one-r/x; else return  r/x-one;\x0a"
"}\x0a"
"\x0a"
"double\x0a"
"erfc(double x) \x0a"
"{\x0a"
"\x09int32_t hx,ix;\x0a"
"\x09""double R,S,P,Q,s,y,z,r;\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09ix = hx\x26""0x7fffffff;\x0a"
"\x09if(ix>=0x7ff00000) {\x09\x09\x09/* erfc(nan)=nan */\x0a"
"\x09\x09\x09\x09\x09\x09/* erfc(+-inf)=0,2 */\x0a"
"\x09    return (double)(((u_int32_t)hx>>31)<<1)+one/x;\x0a"
"\x09}\x0a"
"\x0a"
"\x09if(ix < 0x3feb0000) {\x09\x09/* \x7cx\x7c<0.84375 */\x0a"
"\x09    if(ix < 0x3c700000)  \x09/* \x7cx\x7c<2**-56 */\x0a"
"\x09\x09return one-x;\x0a"
"\x09    z = x*x;\x0a"
"\x09    r = pp0+z*(pp1+z*(pp2+z*(pp3+z*pp4)));\x0a"
"\x09    s = one+z*(qq1+z*(qq2+z*(qq3+z*(qq4+z*qq5))));\x0a"
"\x09    y = r/s;\x0a"
"\x09    if(hx < 0x3fd00000) {  \x09/* x<1/4 */\x0a"
"\x09\x09return one-(x+x*y);\x0a"
"\x09    } else {\x0a"
"\x09\x09r = x*y;\x0a"
"\x09\x09r += (x-half);\x0a"
"\x09        return half - r ;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09if(ix < 0x3ff40000) {\x09\x09/* 0.84375 <= \x7cx\x7c < 1.25 */\x0a"
"\x09    s = fabs(x)-one;\x0a"
"\x09    P = pa0+s*(pa1+s*(pa2+s*(pa3+s*(pa4+s*(pa5+s*pa6)))));\x0a"
"\x09    Q = one+s*(qa1+s*(qa2+s*(qa3+s*(qa4+s*(qa5+s*qa6)))));\x0a"
"\x09    if(hx>=0) {\x0a"
"\x09        z  = one-erx; return z - P/Q; \x0a"
"\x09    } else {\x0a"
"\x09\x09z = erx+P/Q; return one+z;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09if (ix < 0x403c0000) {\x09\x09/* \x7cx\x7c<28 */\x0a"
"\x09    x = fabs(x);\x0a"
" \x09    s = one/(x*x);\x0a"
"\x09    if(ix< 0x4006DB6D) {\x09/* \x7cx\x7c < 1/.35 \x7e 2.857143*/\x0a"
"\x09        R=ra0+s*(ra1+s*(ra2+s*(ra3+s*(ra4+s*(\x0a"
"\x09\x09\x09\x09ra5+s*(ra6+s*ra7))))));\x0a"
"\x09        S=one+s*(sa1+s*(sa2+s*(sa3+s*(sa4+s*(\x0a"
"\x09\x09\x09\x09sa5+s*(sa6+s*(sa7+s*sa8)))))));\x0a"
"\x09    } else {\x09\x09\x09/* \x7cx\x7c >= 1/.35 \x7e 2.857143 */\x0a"
"\x09\x09if(hx<0\x26\x26ix>=0x40180000) return two-tiny;/* x < -6 */\x0a"
"\x09        R=rb0+s*(rb1+s*(rb2+s*(rb3+s*(rb4+s*(\x0a"
"\x09\x09\x09\x09rb5+s*rb6)))));\x0a"
"\x09        S=one+s*(sb1+s*(sb2+s*(sb3+s*(sb4+s*(\x0a"
"\x09\x09\x09\x09sb5+s*(sb6+s*sb7))))));\x0a"
"\x09    }\x0a"
"\x09    z  = x;\x0a"
"\x09    SET_LOW_WORD(z,0);\x0a"
"\x09    r  =  exp(-z*z-0.5625) * exp((z-x)*(z+x)+R/S);\x0a"
"\x09    if(hx>0) return r/x; else return two-r/x;\x0a"
"\x09} else {\x0a"
"\x09    if(hx>0) return tiny*tiny; else return two-tiny;\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(erfl, erf);\x0a"
"__strong_alias(erfcl, erf);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 11160 ); }