#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_exp2f_c( 
"/*\x09\x24OpenBSD\x3a s_exp2f.c,v 1.2 2012/12/05 23\x3a""20\x3a""04 deraadt Exp \x24\x09*/\x0a"
"/*-\x0a"
" * Copyright (c) 2005 David Schultz <das\x40""FreeBSD.ORG>\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"#define\x09TBLBITS\x09""4\x0a"
"#define\x09TBLSIZE\x09(1 << TBLBITS)\x0a"
"\x0a"
"static const float\x0a"
"    huge    = 0x1p100f,\x0a"
"    redux   = 0x1.8p23f / TBLSIZE,\x0a"
"    P1\x09    = 0x1.62e430p-1f,\x0a"
"    P2\x09    = 0x1.ebfbe0p-3f,\x0a"
"    P3\x09    = 0x1.c6b348p-5f,\x0a"
"    P4\x09    = 0x1.3b2c9cp-7f;\x0a"
"\x0a"
"static volatile float twom100 = 0x1p-100f;\x0a"
"\x0a"
"static const double exp2ft\x5bTBLSIZE\x5d = {\x0a"
"\x09""0x1.6a09e667f3bcdp-1,\x0a"
"\x09""0x1.7a11473eb0187p-1,\x0a"
"\x09""0x1.8ace5422aa0dbp-1,\x0a"
"\x09""0x1.9c49182a3f090p-1,\x0a"
"\x09""0x1.ae89f995ad3adp-1,\x0a"
"\x09""0x1.c199bdd85529cp-1,\x0a"
"\x09""0x1.d5818dcfba487p-1,\x0a"
"\x09""0x1.ea4afa2a490dap-1,\x0a"
"\x09""0x1.0000000000000p+0,\x0a"
"\x09""0x1.0b5586cf9890fp+0,\x0a"
"\x09""0x1.172b83c7d517bp+0,\x0a"
"\x09""0x1.2387a6e756238p+0,\x0a"
"\x09""0x1.306fe0a31b715p+0,\x0a"
"\x09""0x1.3dea64c123422p+0,\x0a"
"\x09""0x1.4bfdad5362a27p+0,\x0a"
"\x09""0x1.5ab07dd485429p+0,\x0a"
"};\x0a"
"\x09\x0a"
"/*\x0a"
" * exp2f(x)\x3a compute the base 2 exponential of x\x0a"
" *\x0a"
" * Accuracy\x3a Peak error < 0.501 ulp; location of peak\x3a -0.030110927.\x0a"
" *\x0a"
" * Method\x3a (equally-spaced tables)\x0a"
" *\x0a"
" *   Reduce x\x3a\x0a"
" *     x = 2**k + y, for integer k and \x7cy\x7c <= 1/2.\x0a"
" *     Thus we have exp2f(x) = 2**k * exp2(y).\x0a"
" *\x0a"
" *   Reduce y\x3a\x0a"
" *     y = i/TBLSIZE + z for integer i near y * TBLSIZE.\x0a"
" *     Thus we have exp2(y) = exp2(i/TBLSIZE) * exp2(z),\x0a"
" *     with \x7cz\x7c <= 2**-(TBLSIZE+1).\x0a"
" *\x0a"
" *   We compute exp2(i/TBLSIZE) via table lookup and exp2(z) via a\x0a"
" *   degree-4 minimax polynomial with maximum error under 1.4 * 2**-33.\x0a"
" *   Using double precision for everything except the reduction makes\x0a"
" *   roundoff error insignificant and simplifies the scaling step.\x0a"
" *\x0a"
" *   This method is due to Tang, but I do not use his suggested parameters\x3a\x0a"
" *\x0a"
" *\x09Tang, P.  Table-driven Implementation of the Exponential Function\x0a"
" *\x09in IEEE Floating-Point Arithmetic.  TOMS 15(2), 144-157 (1989).\x0a"
" */\x0a"
"float\x0a"
"exp2f(float x)\x0a"
"{\x0a"
"\x09""double tv, twopk, u, z;\x0a"
"\x09""float t;\x0a"
"\x09uint32_t hx, ix, i0;\x0a"
"\x09int32_t k;\x0a"
"\x0a"
"\x09/* Filter out exceptional cases. */\x0a"
"\x09GET_FLOAT_WORD(hx, x);\x0a"
"\x09ix = hx \x26 0x7fffffff;\x09\x09/* high word of \x7cx\x7c */\x0a"
"\x09if(ix >= 0x43000000) {\x09\x09\x09/* \x7cx\x7c >= 128 */\x0a"
"\x09\x09if(ix >= 0x7f800000) {\x0a"
"\x09\x09\x09if ((ix \x26 0x7fffff) \x21= 0 \x7c\x7c (hx \x26 0x80000000) == 0)\x0a"
"\x09\x09\x09\x09return (x + x);\x09/* x is NaN or +Inf */\x0a"
"\x09\x09\x09""else \x0a"
"\x09\x09\x09\x09return (0.0);\x09/* x is -Inf */\x0a"
"\x09\x09}\x0a"
"\x09\x09if(x >= 0x1.0p7f)\x0a"
"\x09\x09\x09return (huge * huge);\x09/* overflow */\x0a"
"\x09\x09if(x <= -0x1.2cp7f)\x0a"
"\x09\x09\x09return (twom100 * twom100); /* underflow */\x0a"
"\x09} else if (ix <= 0x33000000) {\x09\x09/* \x7cx\x7c <= 0x1p-25 */\x0a"
"\x09\x09return (1.0f + x);\x0a"
"\x09}\x0a"
"\x0a"
"\x09/* Reduce x, computing z, i0, and k. */\x0a"
"\x09STRICT_ASSIGN(float, t, x + redux);\x0a"
"\x09GET_FLOAT_WORD(i0, t);\x0a"
"\x09i0 += TBLSIZE / 2;\x0a"
"\x09k = (i0 >> TBLBITS) << 20;\x0a"
"\x09i0 \x26= TBLSIZE - 1;\x0a"
"\x09t -= redux;\x0a"
"\x09z = x - t;\x0a"
"\x09INSERT_WORDS(twopk, 0x3ff00000 + k, 0);\x0a"
"\x0a"
"\x09/* Compute r = exp2(y) = exp2ft\x5bi0\x5d * p(z). */\x0a"
"\x09tv = exp2ft\x5bi0\x5d;\x0a"
"\x09u = tv * z;\x0a"
"\x09tv = tv + u * (P1 + z * P2) + u * (z * z) * (P3 + z * P4);\x0a"
"\x0a"
"\x09/* Scale by 2**(k>>20). */\x0a"
"\x09return (tv * twopk);\x0a"
"}\x0a"
"", 4205 ); }