#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_expm1_c( 
"/* \x40(#)s_expm1.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* expm1(x)\x0a"
" * Returns exp(x)-1, the exponential of x minus 1.\x0a"
" *\x0a"
" * Method\x0a"
" *   1. Argument reduction\x3a\x0a"
" *\x09Given x, find r and integer k such that\x0a"
" *\x0a"
" *               x = k*ln2 + r,  \x7cr\x7c <= 0.5*ln2 \x7e 0.34658  \x0a"
" *\x0a"
" *      Here a correction term c will be computed to compensate \x0a"
" *\x09the error in r when rounded to a floating-point number.\x0a"
" *\x0a"
" *   2. Approximating expm1(r) by a special rational function on\x0a"
" *\x09the interval \x5b""0,0.34658\x5d\x3a\x0a"
" *\x09Since\x0a"
" *\x09    r*(exp(r)+1)/(exp(r)-1) = 2+ r^2/6 - r^4/360 + ...\x0a"
" *\x09we define R1(r*r) by\x0a"
" *\x09    r*(exp(r)+1)/(exp(r)-1) = 2+ r^2/6 * R1(r*r)\x0a"
" *\x09That is,\x0a"
" *\x09    R1(r**2) = 6/r *((exp(r)+1)/(exp(r)-1) - 2/r)\x0a"
" *\x09\x09     = 6/r * ( 1 + 2.0*(1/(exp(r)-1) - 1/r))\x0a"
" *\x09\x09     = 1 - r^2/60 + r^4/2520 - r^6/100800 + ...\x0a"
" *      We use a special Remes algorithm on \x5b""0,0.347\x5d to generate \x0a"
" * \x09""a polynomial of degree 5 in r*r to approximate R1. The \x0a"
" *\x09maximum error of this polynomial approximation is bounded \x0a"
" *\x09""by 2**-61. In other words,\x0a"
" *\x09    R1(z) \x7e 1.0 + Q1*z + Q2*z**2 + Q3*z**3 + Q4*z**4 + Q5*z**5\x0a"
" *\x09where \x09Q1  =  -1.6666666666666567384E-2,\x0a"
" * \x09\x09Q2  =   3.9682539681370365873E-4,\x0a"
" * \x09\x09Q3  =  -9.9206344733435987357E-6,\x0a"
" * \x09\x09Q4  =   2.5051361420808517002E-7,\x0a"
" * \x09\x09Q5  =  -6.2843505682382617102E-9;\x0a"
" *  \x09(where z=r*r, and the values of Q1 to Q5 are listed below)\x0a"
" *\x09with error bounded by\x0a"
" *\x09    \x7c                  5           \x7c     -61\x0a"
" *\x09    \x7c 1.0+Q1*z+...+Q5*z   -  R1(z) \x7c <= 2 \x0a"
" *\x09    \x7c                              \x7c\x0a"
" *\x09\x0a"
" *\x09""expm1(r) = exp(r)-1 is then computed by the following \x0a"
" * \x09specific way which minimize the accumulation rounding error\x3a \x0a"
" *\x09\x09\x09       2     3\x0a"
" *\x09\x09\x09      r     r    \x5b 3 - (R1 + R1*r/2)  \x5d\x0a"
" *\x09      expm1(r) = r + --- + --- * \x5b--------------------\x5d\x0a"
" *\x09\x09              2     2    \x5b 6 - r*(3 - R1*r/2) \x5d\x0a"
" *\x09\x0a"
" *\x09To compensate the error in the argument reduction, we use\x0a"
" *\x09\x09""expm1(r+c) = expm1(r) + c + expm1(r)*c \x0a"
" *\x09\x09\x09   \x7e expm1(r) + c + r*c \x0a"
" *\x09Thus c+r*c will be added in as the correction terms for\x0a"
" *\x09""expm1(r+c). Now rearrange the term to avoid optimization \x0a"
" * \x09screw up\x3a\x0a"
" *\x09\x09        (      2                                    2 )\x0a"
" *\x09\x09        ({  ( r    \x5b R1 -  (3 - R1*r/2) \x5d  )  }    r  )\x0a"
" *\x09 expm1(r+c)\x7er - ({r*(--- * \x5b--------------------\x5d-c)-c} - --- )\x0a"
" *\x09                ({  ( 2    \x5b 6 - r*(3 - R1*r/2) \x5d  )  }    2  )\x0a"
" *                      (                                             )\x0a"
" *    \x09\x0a"
" *\x09\x09   = r - E\x0a"
" *   3. Scale back to obtain expm1(x)\x3a\x0a"
" *\x09""From step 1, we have\x0a"
" *\x09   expm1(x) = either 2^k*\x5b""expm1(r)+1\x5d - 1\x0a"
" *\x09\x09    = or     2^k*\x5b""expm1(r) + (1-2^-k)\x5d\x0a"
" *   4. Implementation notes\x3a\x0a"
" *\x09(A). To save one multiplication, we scale the coefficient Qi\x0a"
" *\x09     to Qi*2^i, and replace z by (x^2)/2.\x0a"
" *\x09(B). To achieve maximum accuracy, we compute expm1(x) by\x0a"
" *\x09  (i)   if x < -56*ln2, return -1.0, (raise inexact if x\x21=inf)\x0a"
" *\x09  (ii)  if k=0, return r-E\x0a"
" *\x09  (iii) if k=-1, return 0.5*(r-E)-0.5\x0a"
" *        (iv)\x09if k=1 if r < -0.25, return 2*((r+0.5)- E)\x0a"
" *\x09       \x09       else\x09     return  1.0+2.0*(r-E);\x0a"
" *\x09  (v)   if (k<-2\x7c\x7ck>56) return 2^k(1-(E-r)) - 1 (or exp(x)-1)\x0a"
" *\x09  (vi)  if k <= 20, return 2^k((1-2^-k)-(E-r)), else\x0a"
" *\x09  (vii) return 2^k(1-((E+2^-k)-r)) \x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09""expm1(INF) is INF, expm1(NaN) is NaN;\x0a"
" *\x09""expm1(-INF) is -1, and\x0a"
" *\x09""for finite argument, only expm1(0)=0 is exact.\x0a"
" *\x0a"
" * Accuracy\x3a\x0a"
" *\x09""according to an error analysis, the error is always less than\x0a"
" *\x09""1 ulp (unit in the last place).\x0a"
" *\x0a"
" * Misc. info.\x0a"
" *\x09""For IEEE double \x0a"
" *\x09    if x >  7.09782712893383973096e+02 then expm1(x) overflow\x0a"
" *\x0a"
" * Constants\x3a\x0a"
" * The hexadecimal values are the intended ones for the following \x0a"
" * constants. The decimal values may be used, provided that the \x0a"
" * compiler will convert from decimal to binary accurately enough\x0a"
" * to produce the hexadecimal values shown.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double\x0a"
"one\x09\x09= 1.0,\x0a"
"huge\x09\x09= 1.0e+300,\x0a"
"tiny\x09\x09= 1.0e-300,\x0a"
"o_threshold\x09= 7.09782712893383973096e+02,/* 0x40862E42, 0xFEFA39EF */\x0a"
"ln2_hi\x09\x09= 6.93147180369123816490e-01,/* 0x3fe62e42, 0xfee00000 */\x0a"
"ln2_lo\x09\x09= 1.90821492927058770002e-10,/* 0x3dea39ef, 0x35793c76 */\x0a"
"invln2\x09\x09= 1.44269504088896338700e+00,/* 0x3ff71547, 0x652b82fe */\x0a"
"\x09/* scaled coefficients related to expm1 */\x0a"
"Q1  =  -3.33333333333331316428e-02, /* BFA11111 111110F4 */\x0a"
"Q2  =   1.58730158725481460165e-03, /* 3F5A01A0 19FE5585 */\x0a"
"Q3  =  -7.93650757867487942473e-05, /* BF14CE19 9EAADBB7 */\x0a"
"Q4  =   4.00821782732936239552e-06, /* 3ED0CFCA 86E65239 */\x0a"
"Q5  =  -2.01099218183624371326e-07; /* BE8AFDB7 6E09C32D */\x0a"
"\x0a"
"double\x0a"
"expm1(double x)\x0a"
"{\x0a"
"\x09""double y,hi,lo,c,t,e,hxs,hfx,r1;\x0a"
"\x09int32_t k,xsb;\x0a"
"\x09u_int32_t hx;\x0a"
"\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09xsb = hx\x26""0x80000000;\x09\x09/* sign bit of x */\x0a"
"\x09if(xsb==0) y=x; else y= -x;\x09/* y = \x7cx\x7c */\x0a"
"\x09hx \x26= 0x7fffffff;\x09\x09/* high word of \x7cx\x7c */\x0a"
"\x0a"
"    /* filter out huge and non-finite argument */\x0a"
"\x09if(hx >= 0x4043687A) {\x09\x09\x09/* if \x7cx\x7c>=56*ln2 */\x0a"
"\x09    if(hx >= 0x40862E42) {\x09\x09/* if \x7cx\x7c>=709.78... */\x0a"
"                if(hx>=0x7ff00000) {\x0a"
"\x09\x09    u_int32_t low;\x0a"
"\x09\x09    GET_LOW_WORD(low,x);\x0a"
"\x09\x09    if(((hx\x26""0xfffff)\x7clow)\x21=0) \x0a"
"\x09\x09         return x+x; \x09 /* NaN */\x0a"
"\x09\x09    else return (xsb==0)\x3f x\x3a-1.0;/* exp(+-inf)={inf,-1} */\x0a"
"\x09        }\x0a"
"\x09        if(x > o_threshold) return huge*huge; /* overflow */\x0a"
"\x09    }\x0a"
"\x09    if(xsb\x21=0) { /* x < -56*ln2, return -1.0 with inexact */\x0a"
"\x09\x09if(x+tiny<0.0)\x09\x09/* raise inexact */\x0a"
"\x09\x09return tiny-one;\x09/* return -1 */\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* argument reduction */\x0a"
"\x09if(hx > 0x3fd62e42) {\x09\x09/* if  \x7cx\x7c > 0.5 ln2 */ \x0a"
"\x09    if(hx < 0x3FF0A2B2) {\x09/* and \x7cx\x7c < 1.5 ln2 */\x0a"
"\x09\x09if(xsb==0)\x0a"
"\x09\x09    {hi = x - ln2_hi; lo =  ln2_lo;  k =  1;}\x0a"
"\x09\x09""else\x0a"
"\x09\x09    {hi = x + ln2_hi; lo = -ln2_lo;  k = -1;}\x0a"
"\x09    } else {\x0a"
"\x09\x09k  = invln2*x+((xsb==0)\x3f""0.5\x3a-0.5);\x0a"
"\x09\x09t  = k;\x0a"
"\x09\x09hi = x - t*ln2_hi;\x09/* t*ln2_hi is exact here */\x0a"
"\x09\x09lo = t*ln2_lo;\x0a"
"\x09    }\x0a"
"\x09    x  = hi - lo;\x0a"
"\x09    c  = (hi-x)-lo;\x0a"
"\x09} \x0a"
"\x09""else if(hx < 0x3c900000) {  \x09/* when \x7cx\x7c<2**-54, return x */\x0a"
"\x09    t = huge+x;\x09/* return x with inexact flags when x\x21=0 */\x0a"
"\x09    return x - (t-(huge+x));\x09\x0a"
"\x09}\x0a"
"\x09""else k = 0;\x0a"
"\x0a"
"    /* x is now in primary range */\x0a"
"\x09hfx = 0.5*x;\x0a"
"\x09hxs = x*hfx;\x0a"
"\x09r1 = one+hxs*(Q1+hxs*(Q2+hxs*(Q3+hxs*(Q4+hxs*Q5))));\x0a"
"\x09t  = 3.0-r1*hfx;\x0a"
"\x09""e  = hxs*((r1-t)/(6.0 - x*t));\x0a"
"\x09if(k==0) return x - (x*e-hxs);\x09\x09/* c is 0 */\x0a"
"\x09""else {\x0a"
"\x09    e  = (x*(e-c)-c);\x0a"
"\x09    e -= hxs;\x0a"
"\x09    if(k== -1) return 0.5*(x-e)-0.5;\x0a"
"\x09    if(k==1) {\x0a"
"\x09       \x09if(x < -0.25) return -2.0*(e-(x+0.5));\x0a"
"\x09       \x09""else \x09      return  one+2.0*(x-e);\x0a"
"\x09    }\x0a"
"\x09    if (k <= -2 \x7c\x7c k>56) {   /* suffice to return exp(x)-1 */\x0a"
"\x09        u_int32_t high;\x0a"
"\x09        y = one-(e-x);\x0a"
"\x09\x09GET_HIGH_WORD(high,y);\x0a"
"\x09\x09SET_HIGH_WORD(y,high+(k<<20));\x09/* add k to y's exponent */\x0a"
"\x09        return y-one;\x0a"
"\x09    }\x0a"
"\x09    t = one;\x0a"
"\x09    if(k<20) {\x0a"
"\x09        u_int32_t high;\x0a"
"\x09        SET_HIGH_WORD(t,0x3ff00000 - (0x200000>>k));  /* t=1-2^-k */\x0a"
"\x09       \x09y = t-(e-x);\x0a"
"\x09\x09GET_HIGH_WORD(high,y);\x0a"
"\x09\x09SET_HIGH_WORD(y,high+(k<<20));\x09/* add k to y's exponent */\x0a"
"\x09   } else {\x0a"
"\x09        u_int32_t high;\x0a"
"\x09\x09SET_HIGH_WORD(t,((0x3ff-k)<<20));\x09/* 2^-k */\x0a"
"\x09       \x09y = x-(e+t);\x0a"
"\x09       \x09y += one;\x0a"
"\x09\x09GET_HIGH_WORD(high,y);\x0a"
"\x09\x09SET_HIGH_WORD(y,high+(k<<20));\x09/* add k to y's exponent */\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09return y;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(expm1l, expm1);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 7561 ); }