#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_expm1f_c( 
"/* s_expm1f.c -- float version of s_expm1.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const volatile float huge = 1.0e+30, tiny = 1.0e-30;\x0a"
"\x0a"
"static const float\x0a"
"one\x09\x09= 1.0,\x0a"
"o_threshold\x09= 8.8721679688e+01,/* 0x42b17180 */\x0a"
"ln2_hi\x09\x09= 6.9313812256e-01,/* 0x3f317180 */\x0a"
"ln2_lo\x09\x09= 9.0580006145e-06,/* 0x3717f7d1 */\x0a"
"invln2\x09\x09= 1.4426950216e+00,/* 0x3fb8aa3b */\x0a"
"\x09/* scaled coefficients related to expm1 */\x0a"
"Q1  =  -3.3333335072e-02, /* 0xbd088889 */\x0a"
"Q2  =   1.5873016091e-03, /* 0x3ad00d01 */\x0a"
"Q3  =  -7.9365076090e-05, /* 0xb8a670cd */\x0a"
"Q4  =   4.0082177293e-06, /* 0x36867e54 */\x0a"
"Q5  =  -2.0109921195e-07; /* 0xb457edbb */\x0a"
"\x0a"
"float\x0a"
"expm1f(float x)\x0a"
"{\x0a"
"\x09""float y,hi,lo,c,t,e,hxs,hfx,r1;\x0a"
"\x09int32_t k,xsb;\x0a"
"\x09u_int32_t hx;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09xsb = hx\x26""0x80000000;\x09\x09/* sign bit of x */\x0a"
"\x09if(xsb==0) y=x; else y= -x;\x09/* y = \x7cx\x7c */\x0a"
"\x09hx \x26= 0x7fffffff;\x09\x09/* high word of \x7cx\x7c */\x0a"
"\x0a"
"    /* filter out huge and non-finite argument */\x0a"
"\x09if(hx >= 0x4195b844) {\x09\x09\x09/* if \x7cx\x7c>=27*ln2 */\x0a"
"\x09    if(hx >= 0x42b17218) {\x09\x09/* if \x7cx\x7c>=88.721... */\x0a"
"                if(hx>0x7f800000)\x0a"
"\x09\x09    return x+x; \x09 /* NaN */\x0a"
"\x09\x09if(hx==0x7f800000)\x0a"
"\x09\x09    return (xsb==0)\x3f x\x3a-1.0;/* exp(+-inf)={inf,-1} */\x0a"
"\x09        if(x > o_threshold) return huge*huge; /* overflow */\x0a"
"\x09    }\x0a"
"\x09    if(xsb\x21=0) { /* x < -27*ln2, return -1.0 with inexact */\x0a"
"\x09\x09if(x+tiny<(float)0.0)\x09/* raise inexact */\x0a"
"\x09\x09return tiny-one;\x09/* return -1 */\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* argument reduction */\x0a"
"\x09if(hx > 0x3eb17218) {\x09\x09/* if  \x7cx\x7c > 0.5 ln2 */ \x0a"
"\x09    if(hx < 0x3F851592) {\x09/* and \x7cx\x7c < 1.5 ln2 */\x0a"
"\x09\x09if(xsb==0)\x0a"
"\x09\x09    {hi = x - ln2_hi; lo =  ln2_lo;  k =  1;}\x0a"
"\x09\x09""else\x0a"
"\x09\x09    {hi = x + ln2_hi; lo = -ln2_lo;  k = -1;}\x0a"
"\x09    } else {\x0a"
"\x09\x09k  = invln2*x+((xsb==0)\x3f(float)0.5\x3a(float)-0.5);\x0a"
"\x09\x09t  = k;\x0a"
"\x09\x09hi = x - t*ln2_hi;\x09/* t*ln2_hi is exact here */\x0a"
"\x09\x09lo = t*ln2_lo;\x0a"
"\x09    }\x0a"
"\x09    x  = hi - lo;\x0a"
"\x09    c  = (hi-x)-lo;\x0a"
"\x09} \x0a"
"\x09""else if(hx < 0x33000000) {  \x09/* when \x7cx\x7c<2**-25, return x */\x0a"
"\x09    t = huge+x;\x09/* return x with inexact flags when x\x21=0 */\x0a"
"\x09    return x - (t-(huge+x));\x09\x0a"
"\x09}\x0a"
"\x09""else k = 0;\x0a"
"\x0a"
"    /* x is now in primary range */\x0a"
"\x09hfx = (float)0.5*x;\x0a"
"\x09hxs = x*hfx;\x0a"
"\x09r1 = one+hxs*(Q1+hxs*(Q2+hxs*(Q3+hxs*(Q4+hxs*Q5))));\x0a"
"\x09t  = (float)3.0-r1*hfx;\x0a"
"\x09""e  = hxs*((r1-t)/((float)6.0 - x*t));\x0a"
"\x09if(k==0) return x - (x*e-hxs);\x09\x09/* c is 0 */\x0a"
"\x09""else {\x0a"
"\x09    e  = (x*(e-c)-c);\x0a"
"\x09    e -= hxs;\x0a"
"\x09    if(k== -1) return (float)0.5*(x-e)-(float)0.5;\x0a"
"\x09    if(k==1) {\x0a"
"\x09       \x09if(x < (float)-0.25) return -(float)2.0*(e-(x+(float)0.5));\x0a"
"\x09       \x09""else \x09      return  one+(float)2.0*(x-e);\x0a"
"\x09    }\x0a"
"\x09    if (k <= -2 \x7c\x7c k>56) {   /* suffice to return exp(x)-1 */\x0a"
"\x09        int32_t i;\x0a"
"\x09        y = one-(e-x);\x0a"
"\x09\x09GET_FLOAT_WORD(i,y);\x0a"
"\x09\x09SET_FLOAT_WORD(y,i+(k<<23));\x09/* add k to y's exponent */\x0a"
"\x09        return y-one;\x0a"
"\x09    }\x0a"
"\x09    t = one;\x0a"
"\x09    if(k<23) {\x0a"
"\x09        int32_t i;\x0a"
"\x09        SET_FLOAT_WORD(t,0x3f800000 - (0x1000000>>k)); /* t=1-2^-k */\x0a"
"\x09       \x09y = t-(e-x);\x0a"
"\x09\x09GET_FLOAT_WORD(i,y);\x0a"
"\x09\x09SET_FLOAT_WORD(y,i+(k<<23));\x09/* add k to y's exponent */\x0a"
"\x09   } else {\x0a"
"\x09        int32_t i;\x0a"
"\x09\x09SET_FLOAT_WORD(t,((0x7f-k)<<23));\x09/* 2^-k */\x0a"
"\x09       \x09y = x-(e+t);\x0a"
"\x09       \x09y += one;\x0a"
"\x09\x09GET_FLOAT_WORD(i,y);\x0a"
"\x09\x09SET_FLOAT_WORD(y,i+(k<<23));\x09/* add k to y's exponent */\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09return y;\x0a"
"}\x0a"
"", 3594 ); }