#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_fmal_c( 
"/*\x09\x24OpenBSD\x3a s_fmal.c,v 1.3 2013/11/12 19\x3a""00\x3a""38 martynas Exp \x24\x09*/\x0a"
"\x0a"
"/*-\x0a"
" * Copyright (c) 2005 David Schultz <das\x40""FreeBSD.ORG>\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#include <fenv.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"/*\x0a"
" * Fused multiply-add\x3a Compute x * y + z with a single rounding error.\x0a"
" *\x0a"
" * We use scaling to avoid overflow/underflow, along with the\x0a"
" * canonical precision-doubling technique adapted from\x3a\x0a"
" *\x0a"
" *\x09""Dekker, T.  A Floating-Point Technique for Extending the\x0a"
" *\x09""Available Precision.  Numer. Math. 18, 224-242 (1971).\x0a"
" */\x0a"
"long double\x0a"
"fmal(long double x, long double y, long double z)\x0a"
"{\x0a"
"#if LDBL_MANT_DIG == 64\x0a"
"\x09static const long double split = 0x1p32L + 1.0;\x0a"
"#elif LDBL_MANT_DIG == 113\x0a"
"\x09static const long double split = 0x1p57L + 1.0;\x0a"
"#endif\x0a"
"\x09long double xs, ys, zs;\x0a"
"\x09long double c, cc, hx, hy, p, q, tx, ty;\x0a"
"\x09long double r, rr, s;\x0a"
"\x09int oround;\x0a"
"\x09int ex, ey, ez;\x0a"
"\x09int spread;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * Handle special cases. The order of operations and the particular\x0a"
"\x09 * return values here are crucial in handling special cases involving\x0a"
"\x09 * infinities, NaNs, overflows, and signed zeroes correctly.\x0a"
"\x09 */\x0a"
"\x09if (x == 0.0 \x7c\x7c y == 0.0)\x0a"
"\x09\x09return (x * y + z);\x0a"
"\x09if (z == 0.0)\x0a"
"\x09\x09return (x * y);\x0a"
"\x09if (\x21isfinite(x) \x7c\x7c \x21isfinite(y))\x0a"
"\x09\x09return (x * y + z);\x0a"
"\x09if (\x21isfinite(z))\x0a"
"\x09\x09return (z);\x0a"
"\x0a"
"\x09xs = frexpl(x, \x26""ex);\x0a"
"\x09ys = frexpl(y, \x26""ey);\x0a"
"\x09zs = frexpl(z, \x26""ez);\x0a"
"\x09oround = fegetround();\x0a"
"\x09spread = ex + ey - ez;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * If x * y and z are many orders of magnitude apart, the scaling\x0a"
"\x09 * will overflow, so we handle these cases specially.  Rounding\x0a"
"\x09 * modes other than FE_TONEAREST are painful.\x0a"
"\x09 */\x0a"
"\x09if (spread > LDBL_MANT_DIG * 2) {\x0a"
"\x09\x09""fenv_t env;\x0a"
"\x09\x09""feraiseexcept(FE_INEXACT);\x0a"
"\x09\x09switch(oround) {\x0a"
"\x09\x09""case FE_TONEAREST\x3a\x0a"
"\x09\x09\x09return (x * y);\x0a"
"\x09\x09""case FE_TOWARDZERO\x3a\x0a"
"\x09\x09\x09if ((x > 0.0) ^ (y < 0.0) ^ (z < 0.0))\x0a"
"\x09\x09\x09\x09return (x * y);\x0a"
"\x09\x09\x09""feholdexcept(\x26""env);\x0a"
"\x09\x09\x09r = x * y;\x0a"
"\x09\x09\x09if (\x21""fetestexcept(FE_INEXACT))\x0a"
"\x09\x09\x09\x09r = nextafterl(r, 0);\x0a"
"\x09\x09\x09""feupdateenv(\x26""env);\x0a"
"\x09\x09\x09return (r);\x0a"
"\x09\x09""case FE_DOWNWARD\x3a\x0a"
"\x09\x09\x09if (z > 0.0)\x0a"
"\x09\x09\x09\x09return (x * y);\x0a"
"\x09\x09\x09""feholdexcept(\x26""env);\x0a"
"\x09\x09\x09r = x * y;\x0a"
"\x09\x09\x09if (\x21""fetestexcept(FE_INEXACT))\x0a"
"\x09\x09\x09\x09r = nextafterl(r, -INFINITY);\x0a"
"\x09\x09\x09""feupdateenv(\x26""env);\x0a"
"\x09\x09\x09return (r);\x0a"
"\x09\x09""default\x3a\x09/* FE_UPWARD */\x0a"
"\x09\x09\x09if (z < 0.0)\x0a"
"\x09\x09\x09\x09return (x * y);\x0a"
"\x09\x09\x09""feholdexcept(\x26""env);\x0a"
"\x09\x09\x09r = x * y;\x0a"
"\x09\x09\x09if (\x21""fetestexcept(FE_INEXACT))\x0a"
"\x09\x09\x09\x09r = nextafterl(r, INFINITY);\x0a"
"\x09\x09\x09""feupdateenv(\x26""env);\x0a"
"\x09\x09\x09return (r);\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x09if (spread < -LDBL_MANT_DIG) {\x0a"
"\x09\x09""feraiseexcept(FE_INEXACT);\x0a"
"\x09\x09if (\x21isnormal(z))\x0a"
"\x09\x09\x09""feraiseexcept(FE_UNDERFLOW);\x0a"
"\x09\x09switch (oround) {\x0a"
"\x09\x09""case FE_TONEAREST\x3a\x0a"
"\x09\x09\x09return (z);\x0a"
"\x09\x09""case FE_TOWARDZERO\x3a\x0a"
"\x09\x09\x09if ((x > 0.0) ^ (y < 0.0) ^ (z < 0.0))\x0a"
"\x09\x09\x09\x09return (z);\x0a"
"\x09\x09\x09""else\x0a"
"\x09\x09\x09\x09return (nextafterl(z, 0));\x0a"
"\x09\x09""case FE_DOWNWARD\x3a\x0a"
"\x09\x09\x09if ((x > 0.0) ^ (y < 0.0))\x0a"
"\x09\x09\x09\x09return (z);\x0a"
"\x09\x09\x09""else\x0a"
"\x09\x09\x09\x09return (nextafterl(z, -INFINITY));\x0a"
"\x09\x09""default\x3a\x09/* FE_UPWARD */\x0a"
"\x09\x09\x09if ((x > 0.0) ^ (y < 0.0))\x0a"
"\x09\x09\x09\x09return (nextafterl(z, INFINITY));\x0a"
"\x09\x09\x09""else\x0a"
"\x09\x09\x09\x09return (z);\x0a"
"\x09\x09}\x0a"
"\x09}\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * Use Dekker's algorithm to perform the multiplication and\x0a"
"\x09 * subsequent addition in twice the machine precision.\x0a"
"\x09 * Arrange so that x * y = c + cc, and x * y + z = r + rr.\x0a"
"\x09 */\x0a"
"\x09""fesetround(FE_TONEAREST);\x0a"
"\x0a"
"\x09p = xs * split;\x0a"
"\x09hx = xs - p;\x0a"
"\x09hx += p;\x0a"
"\x09tx = xs - hx;\x0a"
"\x0a"
"\x09p = ys * split;\x0a"
"\x09hy = ys - p;\x0a"
"\x09hy += p;\x0a"
"\x09ty = ys - hy;\x0a"
"\x0a"
"\x09p = hx * hy;\x0a"
"\x09q = hx * ty + tx * hy;\x0a"
"\x09""c = p + q;\x0a"
"\x09""cc = p - c + q + tx * ty;\x0a"
"\x0a"
"\x09zs = ldexpl(zs, -spread);\x0a"
"\x09r = c + zs;\x0a"
"\x09s = r - c;\x0a"
"\x09rr = (c - (r - s)) + (zs - s) + cc;\x0a"
"\x0a"
"\x09spread = ex + ey;\x0a"
"\x09if (spread + ilogbl(r) > -16383) {\x0a"
"\x09\x09""fesetround(oround);\x0a"
"\x09\x09r = r + rr;\x0a"
"\x09} else {\x0a"
"\x09\x09/*\x0a"
"\x09\x09 * The result is subnormal, so we round before scaling to\x0a"
"\x09\x09 * avoid double rounding.\x0a"
"\x09\x09 */\x0a"
"\x09\x09p = ldexpl(copysignl(0x1p-16382L, r), -spread);\x0a"
"\x09\x09""c = r + p;\x0a"
"\x09\x09s = c - r;\x0a"
"\x09\x09""cc = (r - (c - s)) + (p - s) + rr;\x0a"
"\x09\x09""fesetround(oround);\x0a"
"\x09\x09r = (c + cc) - p;\x0a"
"\x09}\x0a"
"\x09return (ldexpl(r, spread));\x0a"
"}\x0a"
"", 5035 ); }