#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_log1p_c( 
"/* \x40(#)s_log1p.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* double log1p(double x)\x0a"
" *\x0a"
" * Method \x3a                  \x0a"
" *   1. Argument Reduction\x3a find k and f such that \x0a"
" *\x09\x09\x09""1+x = 2^k * (1+f), \x0a"
" *\x09   where  sqrt(2)/2 < 1+f < sqrt(2) .\x0a"
" *\x0a"
" *      Note. If k=0, then f=x is exact. However, if k\x21=0, then f\x0a"
" *\x09may not be representable exactly. In that case, a correction\x0a"
" *\x09term is need. Let u=1+x rounded. Let c = (1+x)-u, then\x0a"
" *\x09log(1+x) - log(u) \x7e c/u. Thus, we proceed to compute log(u),\x0a"
" *\x09""and add back the correction term c/u.\x0a"
" *\x09(Note\x3a when x > 2**53, one can simply return log(x))\x0a"
" *\x0a"
" *   2. Approximation of log1p(f).\x0a"
" *\x09Let s = f/(2+f) ; based on log(1+f) = log(1+s) - log(1-s)\x0a"
" *\x09\x09 = 2s + 2/3 s**3 + 2/5 s**5 + .....,\x0a"
" *\x09     \x09 = 2s + s*R\x0a"
" *      We use a special Remes algorithm on \x5b""0,0.1716\x5d to generate \x0a"
" * \x09""a polynomial of degree 14 to approximate R The maximum error \x0a"
" *\x09of this polynomial approximation is bounded by 2**-58.45. In\x0a"
" *\x09other words,\x0a"
" *\x09\x09        2      4      6      8      10      12      14\x0a"
" *\x09    R(z) \x7e Lp1*s +Lp2*s +Lp3*s +Lp4*s +Lp5*s  +Lp6*s  +Lp7*s\x0a"
" *  \x09(the values of Lp1 to Lp7 are listed in the program)\x0a"
" *\x09""and\x0a"
" *\x09    \x7c      2          14          \x7c     -58.45\x0a"
" *\x09    \x7c Lp1*s +...+Lp7*s    -  R(z) \x7c <= 2 \x0a"
" *\x09    \x7c                             \x7c\x0a"
" *\x09Note that 2s = f - s*f = f - hfsq + s*hfsq, where hfsq = f*f/2.\x0a"
" *\x09In order to guarantee error in log below 1ulp, we compute log\x0a"
" *\x09""by\x0a"
" *\x09\x09log1p(f) = f - (hfsq - s*(hfsq+R)).\x0a"
" *\x09\x0a"
" *\x09""3. Finally, log1p(x) = k*ln2 + log1p(f).  \x0a"
" *\x09\x09 \x09     = k*ln2_hi+(f-(hfsq-(s*(hfsq+R)+k*ln2_lo)))\x0a"
" *\x09   Here ln2 is split into two floating point number\x3a \x0a"
" *\x09\x09\x09ln2_hi + ln2_lo,\x0a"
" *\x09   where n*ln2_hi is always exact for \x7cn\x7c < 2000.\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09log1p(x) is NaN with signal if x < -1 (including -INF) ; \x0a"
" *\x09log1p(+INF) is +INF; log1p(-1) is -INF with signal;\x0a"
" *\x09log1p(NaN) is that NaN with no signal.\x0a"
" *\x0a"
" * Accuracy\x3a\x0a"
" *\x09""according to an error analysis, the error is always less than\x0a"
" *\x09""1 ulp (unit in the last place).\x0a"
" *\x0a"
" * Constants\x3a\x0a"
" * The hexadecimal values are the intended ones for the following \x0a"
" * constants. The decimal values may be used, provided that the \x0a"
" * compiler will convert from decimal to binary accurately enough \x0a"
" * to produce the hexadecimal values shown.\x0a"
" *\x0a"
" * Note\x3a Assuming log() return accurate answer, the following\x0a"
" * \x09 algorithm can be used to compute log1p(x) to within a few ULP\x3a\x0a"
" *\x09\x0a"
" *\x09\x09u = 1+x;\x0a"
" *\x09\x09if(u==1.0) return x ; else\x0a"
" *\x09\x09\x09   return log(u)*(x/(u-1.0));\x0a"
" *\x0a"
" *\x09 See HP-15C Advanced Functions Handbook, p.193.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double\x0a"
"ln2_hi  =  6.93147180369123816490e-01,\x09/* 3fe62e42 fee00000 */\x0a"
"ln2_lo  =  1.90821492927058770002e-10,\x09/* 3dea39ef 35793c76 */\x0a"
"two54   =  1.80143985094819840000e+16,  /* 43500000 00000000 */\x0a"
"Lp1 = 6.666666666666735130e-01,  /* 3FE55555 55555593 */\x0a"
"Lp2 = 3.999999999940941908e-01,  /* 3FD99999 9997FA04 */\x0a"
"Lp3 = 2.857142874366239149e-01,  /* 3FD24924 94229359 */\x0a"
"Lp4 = 2.222219843214978396e-01,  /* 3FCC71C5 1D8E78AF */\x0a"
"Lp5 = 1.818357216161805012e-01,  /* 3FC74664 96CB03DE */\x0a"
"Lp6 = 1.531383769920937332e-01,  /* 3FC39A09 D078C69F */\x0a"
"Lp7 = 1.479819860511658591e-01;  /* 3FC2F112 DF3E5244 */\x0a"
"\x0a"
"static const double zero = 0.0;\x0a"
"\x0a"
"double\x0a"
"log1p(double x)\x0a"
"{\x0a"
"\x09""double hfsq,f,c,s,z,R,u;\x0a"
"\x09int32_t k,hx,hu,ax;\x0a"
"\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09""ax = hx\x26""0x7fffffff;\x0a"
"\x0a"
"\x09k = 1;\x0a"
"\x09if (hx < 0x3FDA827A) {\x09\x09\x09/* x < 0.41422  */\x0a"
"\x09    if(ax>=0x3ff00000) {\x09\x09/* x <= -1.0 */\x0a"
"\x09\x09if(x==-1.0) return -two54/zero; /* log1p(-1)=+inf */\x0a"
"\x09\x09""else return (x-x)/(x-x);\x09/* log1p(x<-1)=NaN */\x0a"
"\x09    }\x0a"
"\x09    if(ax<0x3e200000) {\x09\x09\x09/* \x7cx\x7c < 2**-29 */\x0a"
"\x09\x09if(two54+x>zero\x09\x09\x09/* raise inexact */\x0a"
"\x09            \x26\x26""ax<0x3c900000) \x09\x09/* \x7cx\x7c < 2**-54 */\x0a"
"\x09\x09    return x;\x0a"
"\x09\x09""else\x0a"
"\x09\x09    return x - x*x*0.5;\x0a"
"\x09    }\x0a"
"\x09    if(hx>0\x7c\x7chx<=((int32_t)0xbfd2bec3)) {\x0a"
"\x09\x09k=0;f=x;hu=1;}\x09/* -0.2929<x<0.41422 */\x0a"
"\x09} \x0a"
"\x09if (hx >= 0x7ff00000) return x+x;\x0a"
"\x09if(k\x21=0) {\x0a"
"\x09    if(hx<0x43400000) {\x0a"
"\x09\x09u  = 1.0+x; \x0a"
"\x09\x09GET_HIGH_WORD(hu,u);\x0a"
"\x09        k  = (hu>>20)-1023;\x0a"
"\x09        c  = (k>0)\x3f 1.0-(u-x)\x3ax-(u-1.0);/* correction term */\x0a"
"\x09\x09""c /= u;\x0a"
"\x09    } else {\x0a"
"\x09\x09u  = x;\x0a"
"\x09\x09GET_HIGH_WORD(hu,u);\x0a"
"\x09        k  = (hu>>20)-1023;\x0a"
"\x09\x09""c  = 0;\x0a"
"\x09    }\x0a"
"\x09    hu \x26= 0x000fffff;\x0a"
"\x09    if(hu<0x6a09e) {\x0a"
"\x09        SET_HIGH_WORD(u,hu\x7c""0x3ff00000);\x09/* normalize u */\x0a"
"\x09    } else {\x0a"
"\x09        k += 1; \x0a"
"\x09\x09SET_HIGH_WORD(u,hu\x7c""0x3fe00000);\x09/* normalize u/2 */\x0a"
"\x09        hu = (0x00100000-hu)>>2;\x0a"
"\x09    }\x0a"
"\x09    f = u-1.0;\x0a"
"\x09}\x0a"
"\x09hfsq=0.5*f*f;\x0a"
"\x09if(hu==0) {\x09/* \x7c""f\x7c < 2**-20 */\x0a"
"\x09    if(f==zero) if(k==0) return zero;  \x0a"
"\x09\x09\x09""else {c += k*ln2_lo; return k*ln2_hi+c;}\x0a"
"\x09    R = hfsq*(1.0-0.66666666666666666*f);\x0a"
"\x09    if(k==0) return f-R; else\x0a"
"\x09    \x09     return k*ln2_hi-((R-(k*ln2_lo+c))-f);\x0a"
"\x09}\x0a"
" \x09s = f/(2.0+f); \x0a"
"\x09z = s*s;\x0a"
"\x09R = z*(Lp1+z*(Lp2+z*(Lp3+z*(Lp4+z*(Lp5+z*(Lp6+z*Lp7))))));\x0a"
"\x09if(k==0) return f-(hfsq-s*(hfsq+R)); else\x0a"
"\x09\x09 return k*ln2_hi-((hfsq-(s*(hfsq+R)+(k*ln2_lo+c)))-f);\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(log1pl, log1p);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 5311 ); }