#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_log1pf_c( 
"/* s_log1pf.c -- float version of s_log1p.c.\x0a"
" * Conversion to float by Ian Lance Taylor, Cygnus Support, ian\x40""cygnus.com.\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const float\x0a"
"ln2_hi =   6.9313812256e-01,\x09/* 0x3f317180 */\x0a"
"ln2_lo =   9.0580006145e-06,\x09/* 0x3717f7d1 */\x0a"
"two25 =    3.355443200e+07,\x09/* 0x4c000000 */\x0a"
"Lp1 = 6.6666668653e-01,\x09/* 3F2AAAAB */\x0a"
"Lp2 = 4.0000000596e-01,\x09/* 3ECCCCCD */\x0a"
"Lp3 = 2.8571429849e-01, /* 3E924925 */\x0a"
"Lp4 = 2.2222198546e-01, /* 3E638E29 */\x0a"
"Lp5 = 1.8183572590e-01, /* 3E3A3325 */\x0a"
"Lp6 = 1.5313838422e-01, /* 3E1CD04F */\x0a"
"Lp7 = 1.4798198640e-01; /* 3E178897 */\x0a"
"\x0a"
"static const float zero = 0.0;\x0a"
"\x0a"
"float\x0a"
"log1pf(float x)\x0a"
"{\x0a"
"\x09""float hfsq,f,c,s,z,R,u;\x0a"
"\x09int32_t k,hx,hu,ax;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09""ax = hx\x26""0x7fffffff;\x0a"
"\x0a"
"\x09k = 1;\x0a"
"\x09if (hx < 0x3ed413d7) {\x09\x09\x09/* x < 0.41422  */\x0a"
"\x09    if(ax>=0x3f800000) {\x09\x09/* x <= -1.0 */\x0a"
"\x09\x09if(x==(float)-1.0) return -two25/zero; /* log1p(-1)=+inf */\x0a"
"\x09\x09""else return (x-x)/(x-x);\x09/* log1p(x<-1)=NaN */\x0a"
"\x09    }\x0a"
"\x09    if(ax<0x31000000) {\x09\x09\x09/* \x7cx\x7c < 2**-29 */\x0a"
"\x09\x09if(two25+x>zero\x09\x09\x09/* raise inexact */\x0a"
"\x09            \x26\x26""ax<0x24800000) \x09\x09/* \x7cx\x7c < 2**-54 */\x0a"
"\x09\x09    return x;\x0a"
"\x09\x09""else\x0a"
"\x09\x09    return x - x*x*(float)0.5;\x0a"
"\x09    }\x0a"
"\x09    if(hx>0\x7c\x7chx<=((int32_t)0xbe95f61f)) {\x0a"
"\x09\x09k=0;f=x;hu=1;}\x09/* -0.2929<x<0.41422 */\x0a"
"\x09} \x0a"
"\x09if (hx >= 0x7f800000) return x+x;\x0a"
"\x09if(k\x21=0) {\x0a"
"\x09    if(hx<0x5a000000) {\x0a"
"\x09\x09u  = (float)1.0+x; \x0a"
"\x09\x09GET_FLOAT_WORD(hu,u);\x0a"
"\x09        k  = (hu>>23)-127;\x0a"
"\x09\x09/* correction term */\x0a"
"\x09        c  = (k>0)\x3f (float)1.0-(u-x)\x3ax-(u-(float)1.0);\x0a"
"\x09\x09""c /= u;\x0a"
"\x09    } else {\x0a"
"\x09\x09u  = x;\x0a"
"\x09\x09GET_FLOAT_WORD(hu,u);\x0a"
"\x09        k  = (hu>>23)-127;\x0a"
"\x09\x09""c  = 0;\x0a"
"\x09    }\x0a"
"\x09    hu \x26= 0x007fffff;\x0a"
"\x09    if(hu<0x3504f7) {\x0a"
"\x09        SET_FLOAT_WORD(u,hu\x7c""0x3f800000);/* normalize u */\x0a"
"\x09    } else {\x0a"
"\x09        k += 1; \x0a"
"\x09\x09SET_FLOAT_WORD(u,hu\x7c""0x3f000000);\x09/* normalize u/2 */\x0a"
"\x09        hu = (0x00800000-hu)>>2;\x0a"
"\x09    }\x0a"
"\x09    f = u-(float)1.0;\x0a"
"\x09}\x0a"
"\x09hfsq=(float)0.5*f*f;\x0a"
"\x09if(hu==0) {\x09/* \x7c""f\x7c < 2**-20 */\x0a"
"\x09    if(f==zero) if(k==0) return zero;  \x0a"
"\x09\x09\x09""else {c += k*ln2_lo; return k*ln2_hi+c;}\x0a"
"\x09    R = hfsq*((float)1.0-(float)0.66666666666666666*f);\x0a"
"\x09    if(k==0) return f-R; else\x0a"
"\x09    \x09     return k*ln2_hi-((R-(k*ln2_lo+c))-f);\x0a"
"\x09}\x0a"
" \x09s = f/((float)2.0+f); \x0a"
"\x09z = s*s;\x0a"
"\x09R = z*(Lp1+z*(Lp2+z*(Lp3+z*(Lp4+z*(Lp5+z*(Lp6+z*Lp7))))));\x0a"
"\x09if(k==0) return f-(hfsq-s*(hfsq+R)); else\x0a"
"\x09\x09 return k*ln2_hi-((hfsq-(s*(hfsq+R)+(k*ln2_lo+c)))-f);\x0a"
"}\x0a"
"", 2697 ); }