#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_lrint_c( 
"/*\x09\x24OpenBSD\x3a s_lrint.c,v 1.10 2013/07/03 04\x3a""46\x3a""36 espie Exp \x24\x09*/\x0a"
"/* \x24NetBSD\x3a lrint.c,v 1.3 2004/10/13 15\x3a""18\x3a""32 drochner Exp \x24 */\x0a"
"\x0a"
"/*-\x0a"
" * Copyright (c) 2004\x0a"
" *\x09Matthias Drochner. All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#include <sys/types.h>\x0a"
"#include <sys/limits.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"#include <ieeefp.h>\x0a"
"#include <machine/ieee.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"#ifndef LRINTNAME\x0a"
"#define LRINTNAME lrint\x0a"
"#define RESTYPE long int\x0a"
"#define RESTYPE_MIN LONG_MIN\x0a"
"#define RESTYPE_MAX LONG_MAX\x0a"
"#endif\x0a"
"\x0a"
"#define RESTYPE_BITS (sizeof(RESTYPE) * 8)\x0a"
"\x0a"
"static const double\x0a"
"TWO52\x5b""2\x5d={\x0a"
"  4.50359962737049600000e+15, /* 0x43300000, 0x00000000 */\x0a"
" -4.50359962737049600000e+15, /* 0xC3300000, 0x00000000 */\x0a"
"};\x0a"
"\x0a"
"__link_always RESTYPE\x0a"
"LRINTNAME(double x)\x0a"
"{\x0a"
"\x09u_int32_t i0, i1;\x0a"
"\x09int e, s, shift;\x0a"
"\x09RESTYPE res;\x0a"
"\x0a"
"\x09GET_HIGH_WORD(i0, x);\x0a"
"\x09""e = i0 >> DBL_FRACHBITS;\x0a"
"\x09s = e >> DBL_EXPBITS;\x0a"
"\x09""e = (e \x26 0x7ff) - DBL_EXP_BIAS;\x0a"
"\x0a"
"\x09/* 1.0 x 2^31 (or 2^63) is already too large */\x0a"
"\x09if (e >= (int)RESTYPE_BITS - 1)\x0a"
"\x09\x09return (s \x3f RESTYPE_MIN \x3a RESTYPE_MAX); /* \x3f\x3f\x3f unspecified */\x0a"
"\x0a"
"\x09/* >= 2^52 is already an exact integer */\x0a"
"\x09if (e < DBL_FRACBITS) {\x0a"
"\x09\x09volatile double t = x;\x09/* clip extra precision */\x0a"
"\x09\x09/* round, using current direction */\x0a"
"\x09\x09t += TWO52\x5bs\x5d;\x0a"
"\x09\x09t -= TWO52\x5bs\x5d;\x0a"
"\x09\x09x = t;\x0a"
"\x09}\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(i0, i1, x);\x0a"
"\x09""e = ((i0 >> DBL_FRACHBITS) \x26 0x7ff) - DBL_EXP_BIAS;\x0a"
"\x09i0 \x26= 0xfffff;\x0a"
"\x09i0 \x7c= (1 << DBL_FRACHBITS);\x0a"
"\x0a"
"\x09if (e < 0)\x0a"
"\x09\x09return (0);\x0a"
"\x0a"
"\x09shift = e - DBL_FRACBITS;\x0a"
"\x09if (shift >=0)\x0a"
"\x09\x09res = (shift < RESTYPE_BITS \x3f (RESTYPE)i1 << shift \x3a 0);\x0a"
"\x09""else\x0a"
"\x09\x09res = (shift > -RESTYPE_BITS \x3f (RESTYPE)i1 >> -shift \x3a 0);\x0a"
"\x09shift += 32;\x0a"
"\x09if (shift >=0)\x0a"
"\x09\x09res \x7c= (shift < RESTYPE_BITS \x3f (RESTYPE)i0 << shift \x3a 0);\x0a"
"\x09""else\x0a"
"\x09\x09res \x7c= (shift > -RESTYPE_BITS \x3f (RESTYPE)i0 >> -shift \x3a 0);\x0a"
"\x0a"
"\x09return (s \x3f -res \x3a res);\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(lrintl, lrint);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 3152 ); }