#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_lroundf_c( 
"/*\x09\x24OpenBSD\x3a s_lroundf.c,v 1.2 2011/04/17 13\x3a""59\x3a""54 martynas Exp \x24\x09*/\x0a"
"/* \x24NetBSD\x3a lroundf.c,v 1.2 2004/10/13 15\x3a""18\x3a""32 drochner Exp \x24 */\x0a"
"\x0a"
"/*-\x0a"
" * Copyright (c) 2004\x0a"
" *\x09Matthias Drochner. All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#include <math.h>\x0a"
"#include <sys/types.h>\x0a"
"#include <sys/limits.h>\x0a"
"#include <ieeefp.h>\x0a"
"#include <machine/ieee.h>\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"#ifndef LROUNDNAME\x0a"
"#define LROUNDNAME lroundf\x0a"
"#define RESTYPE long int\x0a"
"#define RESTYPE_MIN LONG_MIN\x0a"
"#define RESTYPE_MAX LONG_MAX\x0a"
"#endif\x0a"
"\x0a"
"#define RESTYPE_BITS (sizeof(RESTYPE) * 8)\x0a"
"\x0a"
"RESTYPE\x0a"
"LROUNDNAME(float x)\x0a"
"{\x0a"
"\x09u_int32_t i0;\x0a"
"\x09int e, s, shift;\x0a"
"\x09RESTYPE res;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(i0, x);\x0a"
"\x09""e = i0 >> SNG_FRACBITS;\x0a"
"\x09s = e >> SNG_EXPBITS;\x0a"
"\x09""e = (e \x26 0xff) - SNG_EXP_BIAS;\x0a"
"\x0a"
"\x09/* 1.0 x 2^-1 is the smallest number which can be rounded to 1 */\x0a"
"\x09if (e < -1)\x0a"
"\x09\x09return (0);\x0a"
"\x09/* 1.0 x 2^31 (or 2^63) is already too large */\x0a"
"\x09if (e >= (int)RESTYPE_BITS - 1)\x0a"
"\x09\x09return (s \x3f RESTYPE_MIN \x3a RESTYPE_MAX); /* \x3f\x3f\x3f unspecified */\x0a"
"\x0a"
"\x09/* >= 2^23 is already an exact integer */\x0a"
"\x09if (e < SNG_FRACBITS) {\x0a"
"\x09\x09/* add 0.5, extraction below will truncate */\x0a"
"\x09\x09x += (s \x3f -0.5 \x3a 0.5);\x0a"
"\x09}\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(i0, x);\x0a"
"\x09""e = ((i0 >> SNG_FRACBITS) \x26 0xff) - SNG_EXP_BIAS;\x0a"
"\x09i0 \x26= 0x7fffff;\x0a"
"\x09i0 \x7c= (1 << SNG_FRACBITS);\x0a"
"\x0a"
"\x09shift = e - SNG_FRACBITS;\x0a"
"\x09if (shift >=0)\x0a"
"\x09\x09res = (shift < RESTYPE_BITS \x3f (RESTYPE)i0 << shift \x3a 0);\x0a"
"\x09""else\x0a"
"\x09\x09res = (shift > -RESTYPE_BITS \x3f (RESTYPE)i0 >> -shift \x3a 0);\x0a"
"\x0a"
"\x09return (s \x3f -res \x3a res);\x0a"
"}\x0a"
"", 2704 ); }