#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_nan_c( 
"/*\x09\x24OpenBSD\x3a s_nan.c,v 1.13 2014/07/21 01\x3a""51\x3a""11 guenther Exp \x24\x09*/\x0a"
"/*-\x0a"
" * Copyright (c) 2007 David Schultz\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" *\x0a"
" * \x24""FreeBSD\x3a src/lib/msun/src/s_nan.c,v 1.2 2007/12/18 23\x3a""46\x3a""32 das Exp \x24\x0a"
" */\x0a"
"\x0a"
"#include <sys/types.h>\x0a"
"#include <ctype.h>\x0a"
"#include <endian.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"#include <stdint.h>\x0a"
"#include <strings.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"/*\x0a"
" * OpenBSD's ctype doesn't have digittoint, so we define it here.\x0a"
" */\x0a"
"static int\x0a"
"_digittoint(int c)\x0a"
"{\x0a"
"\x09if (\x21isxdigit(c))\x0a"
"\x09\x09return 0;\x0a"
"\x0a"
"\x09if (isdigit(c))\x0a"
"\x09\x09return c - '0';\x0a"
"\x09""else\x0a"
"\x09\x09return isupper(c) \x3f c - 'A' + 10 \x3a c - 'a' + 10;\x0a"
"}\x0a"
"\x0a"
"/*\x0a"
" * Scan a string of hexadecimal digits (the format nan(3) expects) and\x0a"
" * make a bit array (using the local endianness). We stop when we\x0a"
" * encounter an invalid character, NUL, etc.  If we overflow, we do\x0a"
" * the same as gcc's __builtin_nan(), namely, discard the high order bits.\x0a"
" *\x0a"
" * The format this routine accepts needs to be compatible with what is used\x0a"
" * in contrib/gdtoa/hexnan.c (for strtod/scanf) and what is used in\x0a"
" * __builtin_nan(). In fact, we're only 100\x25 compatible for strings we\x0a"
" * consider valid, so we might be violating the C standard. But it's\x0a"
" * impossible to use nan(3) portably anyway, so this seems good enough.\x0a"
" */\x0a"
"void\x0a"
"_scan_nan(uint32_t *words, int num_words, const char *s)\x0a"
"{\x0a"
"\x09int si;\x09\x09/* index into s */\x0a"
"\x09int bitpos;\x09/* index into words (in bits) */\x0a"
"\x0a"
"\x09""bzero(words, num_words * sizeof(uint32_t));\x0a"
"\x0a"
"\x09/* Allow a leading '0x'. (It's expected, but redundant.) */\x0a"
"\x09if (s\x5b""0\x5d == '0' \x26\x26 (s\x5b""1\x5d == 'x' \x7c\x7c s\x5b""1\x5d == 'X'))\x0a"
"\x09\x09s += 2;\x0a"
"\x0a"
"\x09/* Scan forwards in the string, looking for the end of the sequence. */\x0a"
"\x09""for (si = 0; isxdigit((unsigned char)s\x5bsi\x5d); si++)\x0a"
"\x09\x09;\x0a"
"\x0a"
"\x09/* Scan backwards, filling in the bits in words\x5b\x5d as we go. */\x0a"
"#if BYTE_ORDER == LITTLE_ENDIAN\x0a"
"\x09""for (bitpos = 0; bitpos < 32 * num_words; bitpos += 4) {\x0a"
"#else\x0a"
"\x09""for (bitpos = 32 * num_words - 4; bitpos >= 0; bitpos -= 4) {\x0a"
"#endif\x0a"
"\x09\x09if (--si < 0)\x0a"
"\x09\x09\x09""break;\x0a"
"\x09\x09words\x5b""bitpos / 32\x5d \x7c= _digittoint((unsigned char)s\x5bsi\x5d) << (bitpos \x25 32);\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"double\x0a"
"nan(const char *s)\x0a"
"{\x0a"
"\x09union {\x0a"
"\x09\x09""double d;\x0a"
"\x09\x09uint32_t bits\x5b""2\x5d;\x0a"
"\x09} u;\x0a"
"\x0a"
"\x09_scan_nan(u.bits, 2, s);\x0a"
"#if BYTE_ORDER == LITTLE_ENDIAN\x0a"
"\x09u.bits\x5b""1\x5d \x7c= 0x7ff80000;\x0a"
"#else\x0a"
"\x09u.bits\x5b""0\x5d \x7c= 0x7ff80000;\x0a"
"#endif\x0a"
"\x09return (u.d);\x0a"
"}\x0a"
"\x0a"
"float\x0a"
"nanf(const char *s)\x0a"
"{\x0a"
"\x09union {\x0a"
"\x09\x09""float f;\x0a"
"\x09\x09uint32_t bits\x5b""1\x5d;\x0a"
"\x09} u;\x0a"
"\x0a"
"\x09_scan_nan(u.bits, 1, s);\x0a"
"\x09u.bits\x5b""0\x5d \x7c= 0x7fc00000;\x0a"
"\x09return (u.f);\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(nanl, nan);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 3779 ); }