#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_remquo_c( 
"/* \x40(#)e_fmod.c 1.3 95/01/18 */\x0a"
"/*-\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunSoft, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double Zero\x5b\x5d = {0.0, -0.0,};\x0a"
"\x0a"
"/*\x0a"
" * Return the IEEE remainder and set *quo to the last n bits of the\x0a"
" * quotient, rounded to the nearest integer.  We choose n=31 because\x0a"
" * we wind up computing all the integer bits of the quotient anyway as\x0a"
" * a side-effect of computing the remainder by the shift and subtract\x0a"
" * method.  In practice, this is far more bits than are needed to use\x0a"
" * remquo in reduction algorithms.\x0a"
" */\x0a"
"double\x0a"
"remquo(double x, double y, int *quo)\x0a"
"{\x0a"
"\x09int32_t n,hx,hy,hz,ix,iy,sx,i;\x0a"
"\x09u_int32_t lx,ly,lz,q,sxy;\x0a"
"\x0a"
"\x09""EXTRACT_WORDS(hx,lx,x);\x0a"
"\x09""EXTRACT_WORDS(hy,ly,y);\x0a"
"\x09sxy = (hx ^ hy) \x26 0x80000000;\x0a"
"\x09sx = hx\x26""0x80000000;\x09\x09/* sign of x */\x0a"
"\x09hx ^=sx;\x09\x09/* \x7cx\x7c */\x0a"
"\x09hy \x26= 0x7fffffff;\x09/* \x7cy\x7c */\x0a"
"\x0a"
"    /* purge off exception values */\x0a"
"\x09if((hy\x7cly)==0\x7c\x7c(hx>=0x7ff00000)\x7c\x7c\x09/* y=0,or x not finite */\x0a"
"\x09  ((hy\x7c((ly\x7c-ly)>>31))>0x7ff00000))\x09/* or y is NaN */\x0a"
"\x09    return (x*y)/(x*y);\x0a"
"\x09if(hx<=hy) {\x0a"
"\x09    if((hx<hy)\x7c\x7c(lx<ly)) {\x0a"
"\x09\x09q = 0;\x0a"
"\x09\x09goto fixup;\x09/* \x7cx\x7c<\x7cy\x7c return x or x-y */\x0a"
"\x09    }\x0a"
"\x09    if(lx==ly) {\x0a"
"\x09\x09*quo = 1;\x0a"
"\x09\x09return Zero\x5b(u_int32_t)sx>>31\x5d;\x09/* \x7cx\x7c=\x7cy\x7c return x*0*/\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* determine ix = ilogb(x) */\x0a"
"\x09if(hx<0x00100000) {\x09/* subnormal x */\x0a"
"\x09    if(hx==0) {\x0a"
"\x09\x09""for (ix = -1043, i=lx; i>0; i<<=1) ix -=1;\x0a"
"\x09    } else {\x0a"
"\x09\x09""for (ix = -1022,i=(hx<<11); i>0; i<<=1) ix -=1;\x0a"
"\x09    }\x0a"
"\x09} else ix = (hx>>20)-1023;\x0a"
"\x0a"
"    /* determine iy = ilogb(y) */\x0a"
"\x09if(hy<0x00100000) {\x09/* subnormal y */\x0a"
"\x09    if(hy==0) {\x0a"
"\x09\x09""for (iy = -1043, i=ly; i>0; i<<=1) iy -=1;\x0a"
"\x09    } else {\x0a"
"\x09\x09""for (iy = -1022,i=(hy<<11); i>0; i<<=1) iy -=1;\x0a"
"\x09    }\x0a"
"\x09} else iy = (hy>>20)-1023;\x0a"
"\x0a"
"    /* set up {hx,lx}, {hy,ly} and align y to x */\x0a"
"\x09if(ix >= -1022) \x0a"
"\x09    hx = 0x00100000\x7c(0x000fffff\x26hx);\x0a"
"\x09""else {\x09\x09/* subnormal x, shift x to normal */\x0a"
"\x09    n = -1022-ix;\x0a"
"\x09    if(n<=31) {\x0a"
"\x09        hx = (hx<<n)\x7c(lx>>(32-n));\x0a"
"\x09        lx <<= n;\x0a"
"\x09    } else {\x0a"
"\x09\x09hx = lx<<(n-32);\x0a"
"\x09\x09lx = 0;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x09if(iy >= -1022) \x0a"
"\x09    hy = 0x00100000\x7c(0x000fffff\x26hy);\x0a"
"\x09""else {\x09\x09/* subnormal y, shift y to normal */\x0a"
"\x09    n = -1022-iy;\x0a"
"\x09    if(n<=31) {\x0a"
"\x09        hy = (hy<<n)\x7c(ly>>(32-n));\x0a"
"\x09        ly <<= n;\x0a"
"\x09    } else {\x0a"
"\x09\x09hy = ly<<(n-32);\x0a"
"\x09\x09ly = 0;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"\x0a"
"    /* fix point fmod */\x0a"
"\x09n = ix - iy;\x0a"
"\x09q = 0;\x0a"
"\x09while(n--) {\x0a"
"\x09    hz=hx-hy;lz=lx-ly; if(lx<ly) hz -= 1;\x0a"
"\x09    if(hz<0){hx = hx+hx+(lx>>31); lx = lx+lx;}\x0a"
"\x09    else {hx = hz+hz+(lz>>31); lx = lz+lz; q++;}\x0a"
"\x09    q <<= 1;\x0a"
"\x09}\x0a"
"\x09hz=hx-hy;lz=lx-ly; if(lx<ly) hz -= 1;\x0a"
"\x09if(hz>=0) {hx=hz;lx=lz;q++;}\x0a"
"\x0a"
"    /* convert back to floating value and restore the sign */\x0a"
"\x09if((hx\x7clx)==0) {\x09\x09\x09/* return sign(x)*0 */\x0a"
"\x09    *quo = (sxy \x3f -q \x3a q);\x0a"
"\x09    return Zero\x5b(u_int32_t)sx>>31\x5d;\x0a"
"\x09}\x0a"
"\x09while(hx<0x00100000) {\x09\x09/* normalize x */\x0a"
"\x09    hx = hx+hx+(lx>>31); lx = lx+lx;\x0a"
"\x09    iy -= 1;\x0a"
"\x09}\x0a"
"\x09if(iy>= -1022) {\x09/* normalize output */\x0a"
"\x09    hx = ((hx-0x00100000)\x7c((iy+1023)<<20));\x0a"
"\x09} else {\x09\x09/* subnormal output */\x0a"
"\x09    n = -1022 - iy;\x0a"
"\x09    if(n<=20) {\x0a"
"\x09\x09lx = (lx>>n)\x7c((u_int32_t)hx<<(32-n));\x0a"
"\x09\x09hx >>= n;\x0a"
"\x09    } else if (n<=31) {\x0a"
"\x09\x09lx = (hx<<(32-n))\x7c(lx>>n); hx = sx;\x0a"
"\x09    } else {\x0a"
"\x09\x09lx = hx>>(n-32); hx = sx;\x0a"
"\x09    }\x0a"
"\x09}\x0a"
"fixup\x3a\x0a"
"\x09INSERT_WORDS(x,hx,lx);\x0a"
"\x09y = fabs(y);\x0a"
"\x09if (y < 0x1p-1021) {\x0a"
"\x09    if (x+x>y \x7c\x7c (x+x==y \x26\x26 (q \x26 1))) {\x0a"
"\x09\x09q++;\x0a"
"\x09\x09x-=y;\x0a"
"\x09    }\x0a"
"\x09} else if (x>0.5*y \x7c\x7c (x==0.5*y \x26\x26 (q \x26 1))) {\x0a"
"\x09    q++;\x0a"
"\x09    x-=y;\x0a"
"\x09}\x0a"
"\x09GET_HIGH_WORD(hx,x);\x0a"
"\x09SET_HIGH_WORD(x,hx^sx);\x0a"
"\x09q \x26= 0x7fffffff;\x0a"
"\x09*quo = (sxy \x3f -q \x3a q);\x0a"
"\x09return x;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(remquol, remquo);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 3884 ); }