#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_remquof_c( 
"/* \x40(#)e_fmod.c 1.3 95/01/18 */\x0a"
"/*-\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunSoft, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"#include \x22math.h\x22\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const float Zero\x5b\x5d = {0.0, -0.0,};\x0a"
"\x0a"
"/*\x0a"
" * Return the IEEE remainder and set *quo to the last n bits of the\x0a"
" * quotient, rounded to the nearest integer.  We choose n=31 because\x0a"
" * we wind up computing all the integer bits of the quotient anyway as\x0a"
" * a side-effect of computing the remainder by the shift and subtract\x0a"
" * method.  In practice, this is far more bits than are needed to use\x0a"
" * remquo in reduction algorithms.\x0a"
" */\x0a"
"float\x0a"
"remquof(float x, float y, int *quo)\x0a"
"{\x0a"
"\x09int32_t n,hx,hy,hz,ix,iy,sx,i;\x0a"
"\x09u_int32_t q,sxy;\x0a"
"\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09GET_FLOAT_WORD(hy,y);\x0a"
"\x09sxy = (hx ^ hy) \x26 0x80000000;\x0a"
"\x09sx = hx\x26""0x80000000;\x09\x09/* sign of x */\x0a"
"\x09hx ^=sx;\x09\x09/* \x7cx\x7c */\x0a"
"\x09hy \x26= 0x7fffffff;\x09/* \x7cy\x7c */\x0a"
"\x0a"
"    /* purge off exception values */\x0a"
"\x09if(hy==0\x7c\x7chx>=0x7f800000\x7c\x7chy>0x7f800000) /* y=0,NaN;or x not finite */\x0a"
"\x09    return (x*y)/(x*y);\x0a"
"\x09if(hx<hy) {\x0a"
"\x09    q = 0;\x0a"
"\x09    goto fixup;\x09/* \x7cx\x7c<\x7cy\x7c return x or x-y */\x0a"
"\x09} else if(hx==hy) {\x0a"
"\x09    *quo = 1;\x0a"
"\x09    return Zero\x5b(u_int32_t)sx>>31\x5d;\x09/* \x7cx\x7c=\x7cy\x7c return x*0*/\x0a"
"\x09}\x0a"
"\x0a"
"    /* determine ix = ilogb(x) */\x0a"
"\x09if(hx<0x00800000) {\x09/* subnormal x */\x0a"
"\x09    for (ix = -126,i=(hx<<8); i>0; i<<=1) ix -=1;\x0a"
"\x09} else ix = (hx>>23)-127;\x0a"
"\x0a"
"    /* determine iy = ilogb(y) */\x0a"
"\x09if(hy<0x00800000) {\x09/* subnormal y */\x0a"
"\x09    for (iy = -126,i=(hy<<8); i>0; i<<=1) iy -=1;\x0a"
"\x09} else iy = (hy>>23)-127;\x0a"
"\x0a"
"    /* set up {hx,lx}, {hy,ly} and align y to x */\x0a"
"\x09if(ix >= -126)\x0a"
"\x09    hx = 0x00800000\x7c(0x007fffff\x26hx);\x0a"
"\x09""else {\x09\x09/* subnormal x, shift x to normal */\x0a"
"\x09    n = -126-ix;\x0a"
"\x09    hx <<= n;\x0a"
"\x09}\x0a"
"\x09if(iy >= -126)\x0a"
"\x09    hy = 0x00800000\x7c(0x007fffff\x26hy);\x0a"
"\x09""else {\x09\x09/* subnormal y, shift y to normal */\x0a"
"\x09    n = -126-iy;\x0a"
"\x09    hy <<= n;\x0a"
"\x09}\x0a"
"\x0a"
"    /* fix point fmod */\x0a"
"\x09n = ix - iy;\x0a"
"\x09q = 0;\x0a"
"\x09while(n--) {\x0a"
"\x09    hz=hx-hy;\x0a"
"\x09    if(hz<0) hx = hx << 1;\x0a"
"\x09    else {hx = hz << 1; q++;}\x0a"
"\x09    q <<= 1;\x0a"
"\x09}\x0a"
"\x09hz=hx-hy;\x0a"
"\x09if(hz>=0) {hx=hz;q++;}\x0a"
"\x0a"
"    /* convert back to floating value and restore the sign */\x0a"
"\x09if(hx==0) {\x09\x09\x09\x09/* return sign(x)*0 */\x0a"
"\x09    *quo = (sxy \x3f -q \x3a q);\x0a"
"\x09    return Zero\x5b(u_int32_t)sx>>31\x5d;\x0a"
"\x09}\x0a"
"\x09while(hx<0x00800000) {\x09\x09/* normalize x */\x0a"
"\x09    hx <<= 1;\x0a"
"\x09    iy -= 1;\x0a"
"\x09}\x0a"
"\x09if(iy>= -126) {\x09\x09/* normalize output */\x0a"
"\x09    hx = ((hx-0x00800000)\x7c((iy+127)<<23));\x0a"
"\x09} else {\x09\x09/* subnormal output */\x0a"
"\x09    n = -126 - iy;\x0a"
"\x09    hx >>= n;\x0a"
"\x09}\x0a"
"fixup\x3a\x0a"
"\x09SET_FLOAT_WORD(x,hx);\x0a"
"\x09y = fabsf(y);\x0a"
"\x09if (y < 0x1p-125f) {\x0a"
"\x09    if (x+x>y \x7c\x7c (x+x==y \x26\x26 (q \x26 1))) {\x0a"
"\x09\x09q++;\x0a"
"\x09\x09x-=y;\x0a"
"\x09    }\x0a"
"\x09} else if (x>0.5f*y \x7c\x7c (x==0.5f*y \x26\x26 (q \x26 1))) {\x0a"
"\x09    q++;\x0a"
"\x09    x-=y;\x0a"
"\x09}\x0a"
"\x09GET_FLOAT_WORD(hx,x);\x0a"
"\x09SET_FLOAT_WORD(x,hx^sx);\x0a"
"\x09q \x26= 0x7fffffff;\x0a"
"\x09*quo = (sxy \x3f -q \x3a q);\x0a"
"\x09return x;\x0a"
"}\x0a"
"", 2987 ); }