#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_rint_c( 
"/* \x40(#)s_rint.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/*\x0a"
" * rint(x)\x0a"
" * Return x rounded to integral value according to the prevailing\x0a"
" * rounding mode.\x0a"
" * Method\x3a\x0a"
" *\x09Using floating addition.\x0a"
" * Exception\x3a\x0a"
" *\x09Inexact flag raised if x not equal to rint(x).\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double\x0a"
"TWO52\x5b""2\x5d={\x0a"
"  4.50359962737049600000e+15, /* 0x43300000, 0x00000000 */\x0a"
" -4.50359962737049600000e+15, /* 0xC3300000, 0x00000000 */\x0a"
"};\x0a"
"\x0a"
"__link_always double\x0a"
"rint(double x)\x0a"
"{\x0a"
"\x09int32_t i0,jj0,sx;\x0a"
"\x09u_int32_t i,i1;\x0a"
"\x09""double t;\x0a"
"\x09volatile double w;\x09/* clip extra precision */\x0a"
"\x09""EXTRACT_WORDS(i0,i1,x);\x0a"
"\x09sx = (i0>>31)\x26""1;\x0a"
"\x09jj0 = ((i0>>20)\x26""0x7ff)-0x3ff;\x0a"
"\x09if(jj0<20) {\x0a"
"\x09    if(jj0<0) { \x09\x0a"
"\x09\x09if(((i0\x26""0x7fffffff)\x7ci1)==0) return x;\x0a"
"\x09\x09i1 \x7c= (i0\x26""0x0fffff);\x0a"
"\x09\x09i0 \x26= 0xfffe0000;\x0a"
"\x09\x09i0 \x7c= ((i1\x7c-i1)>>12)\x26""0x80000;\x0a"
"\x09\x09SET_HIGH_WORD(x,i0);\x0a"
"\x09        w = TWO52\x5bsx\x5d+x;\x0a"
"\x09        t =  w-TWO52\x5bsx\x5d;\x0a"
"\x09\x09GET_HIGH_WORD(i0,t);\x0a"
"\x09\x09SET_HIGH_WORD(t,(i0\x26""0x7fffffff)\x7c(sx<<31));\x0a"
"\x09        return t;\x0a"
"\x09    } else {\x0a"
"\x09\x09i = (0x000fffff)>>jj0;\x0a"
"\x09\x09if(((i0\x26i)\x7ci1)==0) return x; /* x is integral */\x0a"
"\x09\x09i>>=1;\x0a"
"\x09\x09if(((i0\x26i)\x7ci1)\x21=0) {\x0a"
"\x09\x09    if(jj0==19) i1 = 0x40000000; else\x0a"
"\x09\x09    i0 = (i0\x26(\x7ei))\x7c((0x20000)>>jj0);\x0a"
"\x09\x09}\x0a"
"\x09    }\x0a"
"\x09} else if (jj0>51) {\x0a"
"\x09    if(jj0==0x400) return x+x;\x09/* inf or NaN */\x0a"
"\x09    else return x;\x09\x09/* x is integral */\x0a"
"\x09} else {\x0a"
"\x09    i = ((u_int32_t)(0xffffffff))>>(jj0-20);\x0a"
"\x09    if((i1\x26i)==0) return x;\x09/* x is integral */\x0a"
"\x09    i>>=1;\x0a"
"\x09    if((i1\x26i)\x21=0) i1 = (i1\x26(\x7ei))\x7c((0x40000000)>>(jj0-20));\x0a"
"\x09}\x0a"
"\x09INSERT_WORDS(x,i0,i1);\x0a"
"\x09w = TWO52\x5bsx\x5d+x;\x0a"
"\x09return w-TWO52\x5bsx\x5d;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(rintl, rint);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 2032 ); }