#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_rintl_c( 
"/*\x09\x24OpenBSD\x3a s_rintl.c,v 1.1 2008/12/09 20\x3a""00\x3a""35 martynas Exp \x24\x09*/\x0a"
"/*-\x0a"
" * Copyright (c) 2008 David Schultz <das\x40""FreeBSD.ORG>\x0a"
" * All rights reserved.\x0a"
" *\x0a"
" * Redistribution and use in source and binary forms, with or without\x0a"
" * modification, are permitted provided that the following conditions\x0a"
" * are met\x3a\x0a"
" * 1. Redistributions of source code must retain the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer.\x0a"
" * 2. Redistributions in binary form must reproduce the above copyright\x0a"
" *    notice, this list of conditions and the following disclaimer in the\x0a"
" *    documentation and/or other materials provided with the distribution.\x0a"
" *\x0a"
" * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS \x60\x60""AS IS'' AND\x0a"
" * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\x0a"
" * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\x0a"
" * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE\x0a"
" * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL\x0a"
" * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS\x0a"
" * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)\x0a"
" * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT\x0a"
" * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY\x0a"
" * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF\x0a"
" * SUCH DAMAGE.\x0a"
" */\x0a"
"\x0a"
"#include <sys/types.h>\x0a"
"#include <machine/ieee.h>\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"#if LDBL_MAX_EXP \x21= 0x4000\x0a"
"/* We also require the usual bias, min exp and expsign packing. */\x0a"
"#error \x22Unsupported long double format\x22\x0a"
"#endif\x0a"
"\x0a"
"#define\x09""BIAS\x09(LDBL_MAX_EXP - 1)\x0a"
"\x0a"
"static const float\x0a"
"shift\x5b""2\x5d = {\x0a"
"#if LDBL_MANT_DIG == 64\x0a"
"\x09""0x1.0p63, -0x1.0p63\x0a"
"#elif LDBL_MANT_DIG == 113\x0a"
"\x09""0x1.0p112, -0x1.0p112\x0a"
"#else\x0a"
"#error \x22Unsupported long double format\x22\x0a"
"#endif\x0a"
"};\x0a"
"static const float zero\x5b""2\x5d = { 0.0, -0.0 };\x0a"
"\x0a"
"__link_always long double\x0a"
"rintl(long double x)\x0a"
"{\x0a"
"\x09union {\x0a"
"\x09\x09long double e;\x0a"
"\x09\x09struct ieee_ext bits;\x0a"
"\x09} u;\x0a"
"\x09uint32_t expsign;\x0a"
"\x09int ex, sign;\x0a"
"\x0a"
"\x09u.e = x;\x0a"
"\x09""expsign = (u.bits.ext_sign << 15) \x7c u.bits.ext_exp;\x0a"
"\x09""ex = expsign \x26 0x7fff;\x0a"
"\x0a"
"\x09if (ex >= BIAS + LDBL_MANT_DIG - 1) {\x0a"
"\x09\x09if (ex == BIAS + LDBL_MAX_EXP)\x0a"
"\x09\x09\x09return (x + x);\x09/* Inf, NaN, or unsupported format */\x0a"
"\x09\x09return (x);\x09\x09/* finite and already an integer */\x0a"
"\x09}\x0a"
"\x09sign = expsign >> 15;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * The following code assumes that intermediate results are\x0a"
"\x09 * evaluated in long double precision. If they are evaluated in\x0a"
"\x09 * greater precision, double rounding may occur, and if they are\x0a"
"\x09 * evaluated in less precision (as on i386), results will be\x0a"
"\x09 * wildly incorrect.\x0a"
"\x09 */\x0a"
"\x09x += shift\x5bsign\x5d;\x0a"
"\x09x -= shift\x5bsign\x5d;\x0a"
"\x0a"
"\x09/*\x0a"
"\x09 * If the result is +-0, then it must have the same sign as x, but\x0a"
"\x09 * the above calculation doesn't always give this.  Fix up the sign.\x0a"
"\x09 */\x0a"
"\x09if (ex < BIAS \x26\x26 x == 0.0L)\x0a"
"\x09\x09return (zero\x5bsign\x5d);\x0a"
"\x0a"
"\x09return (x);\x0a"
"}\x0a"
"", 2931 ); }