#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_tan_c( 
"/* \x40(#)s_tan.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* tan(x)\x0a"
" * Return tangent function of x.\x0a"
" *\x0a"
" * kernel function\x3a\x0a"
" *\x09__kernel_tan\x09\x09... tangent function on \x5b-pi/4,pi/4\x5d\x0a"
" *\x09__ieee754_rem_pio2\x09... argument reduction routine\x0a"
" *\x0a"
" * Method.\x0a"
" *      Let S,C and T denote the sin, cos and tan respectively on \x0a"
" *\x09\x5b-PI/4, +PI/4\x5d. Reduce the argument x to y1+y2 = x-k*pi/2 \x0a"
" *\x09in \x5b-pi/4 , +pi/4\x5d, and let n = k mod 4.\x0a"
" *\x09We have\x0a"
" *\x0a"
" *          n        sin(x)      cos(x)        tan(x)\x0a"
" *     ----------------------------------------------------------\x0a"
" *\x09    0\x09       S\x09   C\x09\x09 T\x0a"
" *\x09    1\x09       C\x09  -S\x09\x09-1/T\x0a"
" *\x09    2\x09      -S\x09  -C\x09\x09 T\x0a"
" *\x09    3\x09      -C\x09   S\x09\x09-1/T\x0a"
" *     ----------------------------------------------------------\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *      Let trig be any of sin, cos, or tan.\x0a"
" *      trig(+-INF)  is NaN, with signals;\x0a"
" *      trig(NaN)    is that NaN;\x0a"
" *\x0a"
" * Accuracy\x3a\x0a"
" *\x09TRIG(x) returns trig(x) nearly rounded \x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"double\x0a"
"tan(double x)\x0a"
"{\x0a"
"\x09""double y\x5b""2\x5d,z=0.0;\x0a"
"\x09int32_t n, ix;\x0a"
"\x0a"
"    /* High word of x. */\x0a"
"\x09GET_HIGH_WORD(ix,x);\x0a"
"\x0a"
"    /* \x7cx\x7c \x7e< pi/4 */\x0a"
"\x09ix \x26= 0x7fffffff;\x0a"
"\x09if(ix <= 0x3fe921fb) return __kernel_tan(x,z,1);\x0a"
"\x0a"
"    /* tan(Inf or NaN) is NaN */\x0a"
"\x09""else if (ix>=0x7ff00000) return x-x;\x09\x09/* NaN */\x0a"
"\x0a"
"    /* argument reduction needed */\x0a"
"\x09""else {\x0a"
"\x09    n = __ieee754_rem_pio2(x,y);\x0a"
"\x09    return __kernel_tan(y\x5b""0\x5d,y\x5b""1\x5d,1-((n\x26""1)<<1)); /*   1 -- n even\x0a"
"\x09\x09\x09\x09\x09\x09\x09-1 -- n odd */\x0a"
"\x09}\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(tanl, tan);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 1918 ); }