#include <string_view>
namespace divine::str::dios {
extern const std::string_view libm_s_tanh_c( 
"/* \x40(#)s_tanh.c 5.1 93/09/24 */\x0a"
"/*\x0a"
" * ====================================================\x0a"
" * Copyright (C) 1993 by Sun Microsystems, Inc. All rights reserved.\x0a"
" *\x0a"
" * Developed at SunPro, a Sun Microsystems, Inc. business.\x0a"
" * Permission to use, copy, modify, and distribute this\x0a"
" * software is freely granted, provided that this notice \x0a"
" * is preserved.\x0a"
" * ====================================================\x0a"
" */\x0a"
"\x0a"
"/* Tanh(x)\x0a"
" * Return the Hyperbolic Tangent of x\x0a"
" *\x0a"
" * Method \x3a\x0a"
" *\x09\x09\x09\x09       x    -x\x0a"
" *\x09\x09\x09\x09      e  - e\x0a"
" *\x09""0. tanh(x) is defined to be -----------\x0a"
" *\x09\x09\x09\x09       x    -x\x0a"
" *\x09\x09\x09\x09      e  + e\x0a"
" *\x09""1. reduce x to non-negative by tanh(-x) = -tanh(x).\x0a"
" *\x09""2.  0      <= x <  2**-55 \x3a tanh(x) \x3a= x*(one+x)\x0a"
" *\x09\x09\x09\x09\x09        -t\x0a"
" *\x09    2**-55 <= x <  1      \x3a tanh(x) \x3a= -----; t = expm1(-2x)\x0a"
" *\x09\x09\x09\x09\x09       t + 2\x0a"
" *\x09\x09\x09\x09\x09\x09     2\x0a"
" *\x09    1      <= x <  22.0   \x3a tanh(x) \x3a= 1-  ----- ; t=expm1(2x)\x0a"
" *\x09\x09\x09\x09\x09\x09   t + 2\x0a"
" *\x09    22.0   <= x <= INF    \x3a tanh(x) \x3a= 1.\x0a"
" *\x0a"
" * Special cases\x3a\x0a"
" *\x09tanh(NaN) is NaN;\x0a"
" *\x09only tanh(0)=0 is exact for finite argument.\x0a"
" */\x0a"
"\x0a"
"#include <float.h>\x0a"
"#include <math.h>\x0a"
"\x0a"
"#include \x22math_private.h\x22\x0a"
"\x0a"
"static const double one=1.0, two=2.0, tiny = 1.0e-300;\x0a"
"\x0a"
"__link_always double\x0a"
"tanh(double x)\x0a"
"{\x0a"
"\x09""double t,z;\x0a"
"\x09int32_t jx,ix,lx;\x0a"
"\x0a"
"    /* High word of \x7cx\x7c. */\x0a"
"\x09""EXTRACT_WORDS(jx,lx,x);\x0a"
"\x09ix = jx\x26""0x7fffffff;\x0a"
"\x0a"
"    /* x is INF or NaN */\x0a"
"\x09if(ix>=0x7ff00000) { \x0a"
"\x09    if (jx>=0) return one/x+one;    /* tanh(+-inf)=+-1 */\x0a"
"\x09    else       return one/x-one;    /* tanh(NaN) = NaN */\x0a"
"\x09}\x0a"
"\x0a"
"    /* \x7cx\x7c < 22 */\x0a"
"\x09if (ix < 0x40360000) {\x09\x09/* \x7cx\x7c<22 */\x0a"
"\x09    if ((ix \x7c lx) == 0)\x0a"
"\x09\x09return x;\x09\x09/* x == +-0 */\x0a"
"\x09    if (ix<0x3c800000) \x09\x09/* \x7cx\x7c<2**-55 */\x0a"
"\x09\x09return x*(one+x);    \x09/* tanh(small) = small */\x0a"
"\x09    if (ix>=0x3ff00000) {\x09/* \x7cx\x7c>=1  */\x0a"
"\x09\x09t = expm1(two*fabs(x));\x0a"
"\x09\x09z = one - two/(t+two);\x0a"
"\x09    } else {\x0a"
"\x09        t = expm1(-two*fabs(x));\x0a"
"\x09        z= -t/(t+two);\x0a"
"\x09    }\x0a"
"    /* \x7cx\x7c >= 22, return +-1 */\x0a"
"\x09} else {\x0a"
"\x09    z = one - tiny;\x09\x09/* raised inexact flag */\x0a"
"\x09}\x0a"
"\x09return (jx>=0)\x3f z\x3a -z;\x0a"
"}\x0a"
"\x0a"
"#if\x09LDBL_MANT_DIG == DBL_MANT_DIG\x0a"
"__strong_alias(tanhl, tanh);\x0a"
"#endif\x09/* LDBL_MANT_DIG == DBL_MANT_DIG */\x0a"
"", 2086 ); }