#include <string_view>
namespace divine::str::dios {
extern const std::string_view libpthread_pthread_barrier_cpp( 
"// -*- C++ -*- (c) 2013 Milan Lenco <lencomilan\x40gmail.com>\x0a"
"//             (c) 2014-2018 Vladim\xc3\xadr \xc5\xa0till <xstill\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Henrich Lauko <xlauko\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"/* Includes */\x0a"
"#include <sys/thread.h>\x0a"
"\x0a"
"using namespace __dios;\x0a"
"\x0a"
"/* Barrier */\x0a"
"\x0a"
"/*\x0a"
"  pthread_barrier_t representation\x3a\x0a"
"\x0a"
"   { .counter\x3a\x0a"
"     initialized\x3a 1 bit\x0a"
"     .nthreads\x3a the number of threads to synchronize\x3a 15 bits\x0a"
"   }\x0a"
"*/\x0a"
"\x0a"
"int pthread_barrier_destroy( pthread_barrier_t *barrier ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( barrier == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    int r = _destroy_cond_or_barrier( barrier );\x0a"
"    if ( r == 0 ) {\x0a"
"        int uninit;\x0a"
"        barrier->__nthreads = uninit;\x0a"
"    }\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"int pthread_barrier_init(\x0a"
"        pthread_barrier_t *barrier,\x0a"
"        const pthread_barrierattr_t * /* TODO\x3a barrier attributes */,\x0a"
"        unsigned count ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( count == 0 \x7c\x7c barrier == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    // Set the number of threads that must call pthread_barrier_wait() before\x0a"
"    // any of them successfully return from the call.\x0a"
"    *barrier = ( pthread_barrier_t ){ .__nthreads = uint16_t( count ), .__counter = 0 };\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_barrier_wait( pthread_barrier_t *barrier ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( barrier == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    int ret = 0;\x0a"
"    int counter = barrier->__counter;\x0a"
"    int release_count = barrier->__nthreads;\x0a"
"\x0a"
"    if ( ( counter + 1 ) == release_count ) {\x0a"
"        _cond_signal< true >( barrier );\x0a"
"        ret = PTHREAD_BARRIER_SERIAL_THREAD;\x0a"
"    } else {\x0a"
"        // WARNING\x3a this is not immune from spurious wakeup.\x0a"
"        // As of this writing, spurious wakeup is not implemented (and probably\x0a"
"        // never will).\x0a"
"\x0a"
"        // fall asleep\x0a"
"        _PThread \x26thread = getThread();\x0a"
"        thread.setSleeping( barrier );\x0a"
"\x0a"
"        _cond_adjust_count( barrier, 1 ); // one more thread is blocked on this barrier\x0a"
"\x0a"
"        // sleeping\x0a"
"        waitOrCancel( mask, \x5b\x26\x5d { return thread.sleeping == Barrier; } );\x0a"
"    }\x0a"
"\x0a"
"    return ret;\x0a"
"}\x0a"
"\x0a"
"/* Barrier attributes */\x0a"
"int pthread_barrierattr_destroy( pthread_barrierattr_t * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_barrierattr_getpshared( const pthread_barrierattr_t *, int * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_barrierattr_init( pthread_barrierattr_t * ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_barrierattr_setpshared( pthread_barrierattr_t *, int ) noexcept {\x0a"
"    /* TODO */\x0a"
"    return 0;\x0a"
"}\x0a"
"", 2625 ); }