#include <string_view>
namespace divine::str::dios {
extern const std::string_view libpthread_pthread_rwlock_cpp( 
"// -*- C++ -*- (c) 2013 Milan Lenco <lencomilan\x40gmail.com>\x0a"
"//             (c) 2014-2018 Vladim\xc3\xadr \xc5\xa0till <xstill\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Henrich Lauko <xlauko\x40""fi.muni.cz>\x0a"
"//             (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"/* Includes */\x0a"
"#include <sys/thread.h>\x0a"
"\x0a"
"/* Readers-Writer lock */\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"static int _rlock_adjust_count( _ReadLock *rlock, int adj ) noexcept {\x0a"
"    int count = rlock->__count;\x0a"
"    count += adj;\x0a"
"    if ( count < 0 )\x0a"
"        return EAGAIN;\x0a"
"    rlock->__count = count;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"static _ReadLock *_get_rlock( pthread_rwlock_t *rwlock, _PThread \x26tid, _ReadLock **prev = nullptr ) noexcept {\x0a"
"    _ReadLock *rlock = rwlock->__rlocks;\x0a"
"    _ReadLock *_prev = nullptr;\x0a"
"\x0a"
"    while ( rlock \x26\x26 ( rlock->__owner \x21= \x26tid ) ) {\x0a"
"        _prev = rlock;\x0a"
"        rlock = rlock->__next;\x0a"
"    }\x0a"
"\x0a"
"    if ( rlock \x26\x26 prev )\x0a"
"        *prev = _prev;\x0a"
"\x0a"
"    return rlock;\x0a"
"}\x0a"
"\x0a"
"static _ReadLock *_create_rlock( pthread_rwlock_t *rwlock, _PThread \x26tid ) noexcept {\x0a"
"    _ReadLock *rlock = static_cast< _ReadLock * >( __vm_obj_make( sizeof( _ReadLock ), _VM_PT_Heap ) );\x0a"
"    acquireThread( tid );\x0a"
"    rlock->__owner = \x26tid;\x0a"
"    rlock->__count = 1;\x0a"
"    rlock->__next = rwlock->__rlocks;\x0a"
"    rwlock->__rlocks = rlock;\x0a"
"    return rlock;\x0a"
"}\x0a"
"\x0a"
"static bool _rwlock_can_lock( pthread_rwlock_t *rwlock, bool writer ) noexcept {\x0a"
"    return \x21rwlock->__wrowner \x26\x26 \x21( writer \x26\x26 rwlock->__rlocks );\x0a"
"}\x0a"
"\x0a"
"static int _rwlock_lock( __dios\x3a\x3a""FencedInterruptMask \x26mask, pthread_rwlock_t *rwlock, bool shouldwait, bool writer ) noexcept {\x0a"
"    _PThread \x26thr = getThread();\x0a"
"\x0a"
"    if ( rwlock == nullptr ) {\x0a"
"        return EINVAL; // rwlock does not refer to an initialized rwlock object\x0a"
"    }\x0a"
"\x0a"
"    if ( rwlock->__wrowner == \x26thr )\x0a"
"        // thread already owns write lock\x0a"
"        return EDEADLK;\x0a"
"\x0a"
"    _ReadLock *rlock = _get_rlock( rwlock, thr );\x0a"
"    // existing read lock implies read lock counter having value more than zero\x0a"
"    assert( \x21rlock \x7c\x7c rlock->__count );\x0a"
"\x0a"
"    if ( writer \x26\x26 rlock )\x0a"
"        // thread already owns read lock\x0a"
"        return EDEADLK;\x0a"
"\x0a"
"    if ( \x21_rwlock_can_lock( rwlock, writer ) ) {\x0a"
"        if ( \x21shouldwait )\x0a"
"            return EBUSY;\x0a"
"    }\x0a"
"    wait( mask, \x5b\x26\x5d { return \x21_rwlock_can_lock( rwlock, writer ); } );\x0a"
"\x0a"
"    if ( writer ) {\x0a"
"        acquireThread( thr );\x0a"
"        rwlock->__wrowner = \x26thr;\x0a"
"    }\x0a"
"    else {\x0a"
"        if ( \x21rlock )\x0a"
"            rlock = _create_rlock( rwlock, thr );\x0a"
"        else {\x0a"
"            int err = _rlock_adjust_count( rlock, 1 );\x0a"
"            if ( err )\x0a"
"                return err;\x0a"
"        }\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"}\x0a"
"\x0a"
"using namespace __dios;\x0a"
"\x0a"
"int pthread_rwlock_destroy( pthread_rwlock_t *rwlock ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( rwlock == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    if ( rwlock->__wrowner \x7c\x7c rwlock->__rlocks )\x0a"
"        // rwlock is locked\x0a"
"        return EBUSY;\x0a"
"\x0a"
"    pthread_rwlock_t uninit;\x0a"
"    *rwlock = uninit;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_rwlock_init( pthread_rwlock_t *rwlock, const pthread_rwlockattr_t *attr ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( rwlock == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    rwlock->__processShared = attr \x26\x26 bool( *attr \x26 _RWLOCK_ATTR_SHARING_MASK );\x0a"
"    rwlock->__wrowner = nullptr;\x0a"
"    rwlock->__rlocks = nullptr;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_rwlock_rdlock( pthread_rwlock_t *rwlock ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    return _rwlock_lock( mask, rwlock, true, false );\x0a"
"}\x0a"
"\x0a"
"int pthread_rwlock_wrlock( pthread_rwlock_t *rwlock ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    return _rwlock_lock( mask, rwlock, true, true );\x0a"
"}\x0a"
"\x0a"
"int pthread_rwlock_tryrdlock( pthread_rwlock_t *rwlock ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    return _rwlock_lock( mask, rwlock, false, false );\x0a"
"}\x0a"
"\x0a"
"int pthread_rwlock_trywrlock( pthread_rwlock_t *rwlock ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"    return _rwlock_lock( mask, rwlock, false, true );\x0a"
"}\x0a"
"\x0a"
"int pthread_rwlock_unlock( pthread_rwlock_t *rwlock ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    _PThread \x26thr = getThread();\x0a"
"\x0a"
"    if ( rwlock == NULL ) {\x0a"
"        return EINVAL; // rwlock does not refer to an initialized rwlock object\x0a"
"    }\x0a"
"\x0a"
"    _ReadLock *rlock, *prev;\x0a"
"    rlock = _get_rlock( rwlock, thr, \x26prev );\x0a"
"    // existing read lock implies read lock counter having value more than zero\x0a"
"    assert( \x21rlock \x7c\x7c rlock->__count );\x0a"
"\x0a"
"    if ( rwlock->__wrowner \x21= \x26thr \x26\x26 \x21rlock ) {\x0a"
"        // the current thread does not own the read-write lock\x0a"
"        return EPERM;\x0a"
"    }\x0a"
"\x0a"
"    if ( rwlock->__wrowner == \x26thr ) {\x0a"
"        assert( \x21rlock );\x0a"
"        // release write lock\x0a"
"        releaseThread( *rwlock->__wrowner );\x0a"
"        rwlock->__wrowner = nullptr;\x0a"
"    } else {\x0a"
"        // release read lock\x0a"
"        _rlock_adjust_count( rlock, -1 );\x0a"
"        if ( rlock->__count == 0 ) {\x0a"
"            // no more read locks are owned by this thread\x0a"
"            if ( prev )\x0a"
"                prev->__next = rlock->__next;\x0a"
"            else\x0a"
"                rwlock->__rlocks = rlock->__next;\x0a"
"            releaseThread( *rlock->__owner );\x0a"
"            __vm_obj_free( rlock );\x0a"
"        }\x0a"
"    }\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"/* Readers-Write lock attributes */\x0a"
"\x0a"
"/*\x0a"
"  pthread_rwlockattr_t representation\x3a\x0a"
"     -------------------------\x0a"
"    \x7c *free* \x7c sharing\x3a 1 bit \x7c\x0a"
"     -------------------------\x0a"
"*/\x0a"
"\x0a"
"int pthread_rwlockattr_destroy( pthread_rwlockattr_t *attr ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( attr == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    pthread_rwlockattr_t uninit;\x0a"
"    *attr = uninit;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_rwlockattr_getpshared( const pthread_rwlockattr_t *attr, int *pshared ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( attr == NULL \x7c\x7c pshared == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    *pshared = *attr \x26 _RWLOCK_ATTR_SHARING_MASK;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_rwlockattr_init( pthread_rwlockattr_t *attr ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( attr == NULL )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    *attr = PTHREAD_PROCESS_PRIVATE;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"int pthread_rwlockattr_setpshared( pthread_rwlockattr_t *attr, int pshared ) noexcept {\x0a"
"    __dios\x3a\x3a""FencedInterruptMask mask;\x0a"
"\x0a"
"    if ( attr == NULL \x7c\x7c ( pshared \x26 \x7e_RWLOCK_ATTR_SHARING_MASK ) )\x0a"
"        return EINVAL;\x0a"
"\x0a"
"    *attr \x26= \x7e_RWLOCK_ATTR_SHARING_MASK;\x0a"
"    *attr \x7c= pshared;\x0a"
"    return 0;\x0a"
"}\x0a"
"", 6296 ); }