#include <string_view>
namespace divine::str::dios {
extern const std::string_view libunwind_include_libunwind_h( 
"//===---------------------------- libunwind.h -----------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//\x0a"
"// Compatible with libunwind API documented at\x3a\x0a"
"//   http\x3a//www.nongnu.org/libunwind/man/libunwind(3).html\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef __LIBUNWIND__\x0a"
"#define __LIBUNWIND__\x0a"
"\x0a"
"#include <__libunwind_config.h>\x0a"
"\x0a"
"#include <stdint.h>\x0a"
"#include <stddef.h>\x0a"
"\x0a"
"#ifdef __APPLE__\x0a"
"  #if __clang__\x0a"
"    #if __has_include(<Availability.h>)\x0a"
"      #include <Availability.h>\x0a"
"    #endif\x0a"
"  #elif __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ >= 1050\x0a"
"    #include <Availability.h>\x0a"
"  #endif\x0a"
"\x0a"
"  #ifdef __arm__\x0a"
"     #define LIBUNWIND_AVAIL __attribute__((unavailable))\x0a"
"  #elif defined(__OSX_AVAILABLE_STARTING)\x0a"
"    #define LIBUNWIND_AVAIL __OSX_AVAILABLE_STARTING(__MAC_10_6, __IPHONE_5_0)\x0a"
"  #else\x0a"
"    #include <AvailabilityMacros.h>\x0a"
"    #ifdef AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER\x0a"
"      #define LIBUNWIND_AVAIL AVAILABLE_MAC_OS_X_VERSION_10_6_AND_LATER\x0a"
"    #else\x0a"
"      #define LIBUNWIND_AVAIL __attribute__((unavailable))\x0a"
"    #endif\x0a"
"  #endif\x0a"
"#else\x0a"
"  #define LIBUNWIND_AVAIL\x0a"
"#endif\x0a"
"\x0a"
"/* error codes */\x0a"
"enum {\x0a"
"  UNW_ESUCCESS      = 0,     /* no error */\x0a"
"  UNW_EUNSPEC       = -6540, /* unspecified (general) error */\x0a"
"  UNW_ENOMEM        = -6541, /* out of memory */\x0a"
"  UNW_EBADREG       = -6542, /* bad register number */\x0a"
"  UNW_EREADONLYREG  = -6543, /* attempt to write read-only register */\x0a"
"  UNW_ESTOPUNWIND   = -6544, /* stop unwinding */\x0a"
"  UNW_EINVALIDIP    = -6545, /* invalid IP */\x0a"
"  UNW_EBADFRAME     = -6546, /* bad frame */\x0a"
"  UNW_EINVAL        = -6547, /* unsupported operation or bad value */\x0a"
"  UNW_EBADVERSION   = -6548, /* unwind info has unsupported version */\x0a"
"  UNW_ENOINFO       = -6549  /* no unwind info found */\x0a"
"};\x0a"
"\x0a"
"struct unw_context_t {\x0a"
"  uint64_t data\x5b_LIBUNWIND_CONTEXT_SIZE\x5d;\x0a"
"};\x0a"
"typedef struct unw_context_t unw_context_t;\x0a"
"\x0a"
"struct unw_cursor_t {\x0a"
"  uint64_t data\x5b_LIBUNWIND_CURSOR_SIZE\x5d;\x0a"
"};\x0a"
"typedef struct unw_cursor_t unw_cursor_t;\x0a"
"\x0a"
"typedef struct unw_addr_space *unw_addr_space_t;\x0a"
"\x0a"
"typedef int unw_regnum_t;\x0a"
"#if _LIBUNWIND_ARM_EHABI\x0a"
"typedef uint32_t unw_word_t;\x0a"
"typedef uint64_t unw_fpreg_t;\x0a"
"#else\x0a"
"typedef uint64_t unw_word_t;\x0a"
"typedef double unw_fpreg_t;\x0a"
"#endif\x0a"
"\x0a"
"struct unw_proc_info_t {\x0a"
"  unw_word_t  start_ip;         /* start address of function */\x0a"
"  unw_word_t  end_ip;           /* address after end of function */\x0a"
"  unw_word_t  lsda;             /* address of language specific data area, */\x0a"
"                                /*  or zero if not used */\x0a"
"  unw_word_t  handler;          /* personality routine, or zero if not used */\x0a"
"  unw_word_t  gp;               /* not used */\x0a"
"  unw_word_t  flags;            /* not used */\x0a"
"  uint32_t    format;           /* compact unwind encoding, or zero if none */\x0a"
"  uint32_t    unwind_info_size; /* size of DWARF unwind info, or zero if none */\x0a"
"  unw_word_t  unwind_info;      /* address of DWARF unwind info, or zero */\x0a"
"  unw_word_t  extra;            /* mach_header of mach-o image containing func */\x0a"
"};\x0a"
"typedef struct unw_proc_info_t unw_proc_info_t;\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"extern \x22""C\x22 {\x0a"
"#endif\x0a"
"\x0a"
"extern int unw_getcontext(unw_context_t *) LIBUNWIND_AVAIL;\x0a"
"extern int unw_init_local(unw_cursor_t *, unw_context_t *) LIBUNWIND_AVAIL;\x0a"
"extern int unw_step(unw_cursor_t *) LIBUNWIND_AVAIL;\x0a"
"extern int unw_get_reg(unw_cursor_t *, unw_regnum_t, unw_word_t *) LIBUNWIND_AVAIL;\x0a"
"extern int unw_get_fpreg(unw_cursor_t *, unw_regnum_t, unw_fpreg_t *) LIBUNWIND_AVAIL;\x0a"
"extern int unw_set_reg(unw_cursor_t *, unw_regnum_t, unw_word_t) LIBUNWIND_AVAIL;\x0a"
"extern int unw_set_fpreg(unw_cursor_t *, unw_regnum_t, unw_fpreg_t)  LIBUNWIND_AVAIL;\x0a"
"extern int unw_resume(unw_cursor_t *) LIBUNWIND_AVAIL;\x0a"
"\x0a"
"#ifdef __arm__\x0a"
"/* Save VFP registers in FSTMX format (instead of FSTMD). */\x0a"
"extern void unw_save_vfp_as_X(unw_cursor_t *) LIBUNWIND_AVAIL;\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"extern const char *unw_regname(unw_cursor_t *, unw_regnum_t) LIBUNWIND_AVAIL;\x0a"
"extern int unw_get_proc_info(unw_cursor_t *, unw_proc_info_t *) LIBUNWIND_AVAIL;\x0a"
"extern int unw_is_fpreg(unw_cursor_t *, unw_regnum_t) LIBUNWIND_AVAIL;\x0a"
"extern int unw_is_signal_frame(unw_cursor_t *) LIBUNWIND_AVAIL;\x0a"
"extern int unw_get_proc_name(unw_cursor_t *, char *, size_t, unw_word_t *) LIBUNWIND_AVAIL;\x0a"
"//extern int       unw_get_save_loc(unw_cursor_t*, int, unw_save_loc_t*);\x0a"
"\x0a"
"extern unw_addr_space_t unw_local_addr_space;\x0a"
"\x0a"
"#ifdef UNW_REMOTE\x0a"
"/*\x0a"
" * Mac OS X \x22remote\x22 API for unwinding other processes on same machine\x0a"
" *\x0a"
" */\x0a"
"extern unw_addr_space_t unw_create_addr_space_for_task(task_t);\x0a"
"extern void unw_destroy_addr_space(unw_addr_space_t);\x0a"
"extern int unw_init_remote_thread(unw_cursor_t *, unw_addr_space_t, thread_t *);\x0a"
"#endif /* UNW_REMOTE */\x0a"
"\x0a"
"/*\x0a"
" * traditional libunwind \x22remote\x22 API\x0a"
" *   NOT IMPLEMENTED on Mac OS X\x0a"
" *\x0a"
" * extern int               unw_init_remote(unw_cursor_t*, unw_addr_space_t,\x0a"
" *                                          thread_t*);\x0a"
" * extern unw_accessors_t   unw_get_accessors(unw_addr_space_t);\x0a"
" * extern unw_addr_space_t  unw_create_addr_space(unw_accessors_t, int);\x0a"
" * extern void              unw_flush_cache(unw_addr_space_t, unw_word_t,\x0a"
" *                                          unw_word_t);\x0a"
" * extern int               unw_set_caching_policy(unw_addr_space_t,\x0a"
" *                                                 unw_caching_policy_t);\x0a"
" * extern void              _U_dyn_register(unw_dyn_info_t*);\x0a"
" * extern void              _U_dyn_cancel(unw_dyn_info_t*);\x0a"
" */\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"// architecture independent register numbers\x0a"
"enum {\x0a"
"  UNW_REG_IP = -1, // instruction pointer\x0a"
"  UNW_REG_SP = -2, // stack pointer\x0a"
"};\x0a"
"\x0a"
"// 32-bit x86 registers\x0a"
"enum {\x0a"
"  UNW_X86_EAX = 0,\x0a"
"  UNW_X86_ECX = 1,\x0a"
"  UNW_X86_EDX = 2,\x0a"
"  UNW_X86_EBX = 3,\x0a"
"  UNW_X86_EBP = 4,\x0a"
"  UNW_X86_ESP = 5,\x0a"
"  UNW_X86_ESI = 6,\x0a"
"  UNW_X86_EDI = 7\x0a"
"};\x0a"
"\x0a"
"// 64-bit x86_64 registers\x0a"
"enum {\x0a"
"  UNW_X86_64_RAX = 0,\x0a"
"  UNW_X86_64_RDX = 1,\x0a"
"  UNW_X86_64_RCX = 2,\x0a"
"  UNW_X86_64_RBX = 3,\x0a"
"  UNW_X86_64_RSI = 4,\x0a"
"  UNW_X86_64_RDI = 5,\x0a"
"  UNW_X86_64_RBP = 6,\x0a"
"  UNW_X86_64_RSP = 7,\x0a"
"  UNW_X86_64_R8  = 8,\x0a"
"  UNW_X86_64_R9  = 9,\x0a"
"  UNW_X86_64_R10 = 10,\x0a"
"  UNW_X86_64_R11 = 11,\x0a"
"  UNW_X86_64_R12 = 12,\x0a"
"  UNW_X86_64_R13 = 13,\x0a"
"  UNW_X86_64_R14 = 14,\x0a"
"  UNW_X86_64_R15 = 15\x0a"
"};\x0a"
"\x0a"
"\x0a"
"// 32-bit ppc register numbers\x0a"
"enum {\x0a"
"  UNW_PPC_R0  = 0,\x0a"
"  UNW_PPC_R1  = 1,\x0a"
"  UNW_PPC_R2  = 2,\x0a"
"  UNW_PPC_R3  = 3,\x0a"
"  UNW_PPC_R4  = 4,\x0a"
"  UNW_PPC_R5  = 5,\x0a"
"  UNW_PPC_R6  = 6,\x0a"
"  UNW_PPC_R7  = 7,\x0a"
"  UNW_PPC_R8  = 8,\x0a"
"  UNW_PPC_R9  = 9,\x0a"
"  UNW_PPC_R10 = 10,\x0a"
"  UNW_PPC_R11 = 11,\x0a"
"  UNW_PPC_R12 = 12,\x0a"
"  UNW_PPC_R13 = 13,\x0a"
"  UNW_PPC_R14 = 14,\x0a"
"  UNW_PPC_R15 = 15,\x0a"
"  UNW_PPC_R16 = 16,\x0a"
"  UNW_PPC_R17 = 17,\x0a"
"  UNW_PPC_R18 = 18,\x0a"
"  UNW_PPC_R19 = 19,\x0a"
"  UNW_PPC_R20 = 20,\x0a"
"  UNW_PPC_R21 = 21,\x0a"
"  UNW_PPC_R22 = 22,\x0a"
"  UNW_PPC_R23 = 23,\x0a"
"  UNW_PPC_R24 = 24,\x0a"
"  UNW_PPC_R25 = 25,\x0a"
"  UNW_PPC_R26 = 26,\x0a"
"  UNW_PPC_R27 = 27,\x0a"
"  UNW_PPC_R28 = 28,\x0a"
"  UNW_PPC_R29 = 29,\x0a"
"  UNW_PPC_R30 = 30,\x0a"
"  UNW_PPC_R31 = 31,\x0a"
"  UNW_PPC_F0  = 32,\x0a"
"  UNW_PPC_F1  = 33,\x0a"
"  UNW_PPC_F2  = 34,\x0a"
"  UNW_PPC_F3  = 35,\x0a"
"  UNW_PPC_F4  = 36,\x0a"
"  UNW_PPC_F5  = 37,\x0a"
"  UNW_PPC_F6  = 38,\x0a"
"  UNW_PPC_F7  = 39,\x0a"
"  UNW_PPC_F8  = 40,\x0a"
"  UNW_PPC_F9  = 41,\x0a"
"  UNW_PPC_F10 = 42,\x0a"
"  UNW_PPC_F11 = 43,\x0a"
"  UNW_PPC_F12 = 44,\x0a"
"  UNW_PPC_F13 = 45,\x0a"
"  UNW_PPC_F14 = 46,\x0a"
"  UNW_PPC_F15 = 47,\x0a"
"  UNW_PPC_F16 = 48,\x0a"
"  UNW_PPC_F17 = 49,\x0a"
"  UNW_PPC_F18 = 50,\x0a"
"  UNW_PPC_F19 = 51,\x0a"
"  UNW_PPC_F20 = 52,\x0a"
"  UNW_PPC_F21 = 53,\x0a"
"  UNW_PPC_F22 = 54,\x0a"
"  UNW_PPC_F23 = 55,\x0a"
"  UNW_PPC_F24 = 56,\x0a"
"  UNW_PPC_F25 = 57,\x0a"
"  UNW_PPC_F26 = 58,\x0a"
"  UNW_PPC_F27 = 59,\x0a"
"  UNW_PPC_F28 = 60,\x0a"
"  UNW_PPC_F29 = 61,\x0a"
"  UNW_PPC_F30 = 62,\x0a"
"  UNW_PPC_F31 = 63,\x0a"
"  UNW_PPC_MQ  = 64,\x0a"
"  UNW_PPC_LR  = 65,\x0a"
"  UNW_PPC_CTR = 66,\x0a"
"  UNW_PPC_AP  = 67,\x0a"
"  UNW_PPC_CR0 = 68,\x0a"
"  UNW_PPC_CR1 = 69,\x0a"
"  UNW_PPC_CR2 = 70,\x0a"
"  UNW_PPC_CR3 = 71,\x0a"
"  UNW_PPC_CR4 = 72,\x0a"
"  UNW_PPC_CR5 = 73,\x0a"
"  UNW_PPC_CR6 = 74,\x0a"
"  UNW_PPC_CR7 = 75,\x0a"
"  UNW_PPC_XER = 76,\x0a"
"  UNW_PPC_V0  = 77,\x0a"
"  UNW_PPC_V1  = 78,\x0a"
"  UNW_PPC_V2  = 79,\x0a"
"  UNW_PPC_V3  = 80,\x0a"
"  UNW_PPC_V4  = 81,\x0a"
"  UNW_PPC_V5  = 82,\x0a"
"  UNW_PPC_V6  = 83,\x0a"
"  UNW_PPC_V7  = 84,\x0a"
"  UNW_PPC_V8  = 85,\x0a"
"  UNW_PPC_V9  = 86,\x0a"
"  UNW_PPC_V10 = 87,\x0a"
"  UNW_PPC_V11 = 88,\x0a"
"  UNW_PPC_V12 = 89,\x0a"
"  UNW_PPC_V13 = 90,\x0a"
"  UNW_PPC_V14 = 91,\x0a"
"  UNW_PPC_V15 = 92,\x0a"
"  UNW_PPC_V16 = 93,\x0a"
"  UNW_PPC_V17 = 94,\x0a"
"  UNW_PPC_V18 = 95,\x0a"
"  UNW_PPC_V19 = 96,\x0a"
"  UNW_PPC_V20 = 97,\x0a"
"  UNW_PPC_V21 = 98,\x0a"
"  UNW_PPC_V22 = 99,\x0a"
"  UNW_PPC_V23 = 100,\x0a"
"  UNW_PPC_V24 = 101,\x0a"
"  UNW_PPC_V25 = 102,\x0a"
"  UNW_PPC_V26 = 103,\x0a"
"  UNW_PPC_V27 = 104,\x0a"
"  UNW_PPC_V28 = 105,\x0a"
"  UNW_PPC_V29 = 106,\x0a"
"  UNW_PPC_V30 = 107,\x0a"
"  UNW_PPC_V31 = 108,\x0a"
"  UNW_PPC_VRSAVE  = 109,\x0a"
"  UNW_PPC_VSCR    = 110,\x0a"
"  UNW_PPC_SPE_ACC = 111,\x0a"
"  UNW_PPC_SPEFSCR = 112\x0a"
"};\x0a"
"\x0a"
"// 64-bit ARM64 registers\x0a"
"enum {\x0a"
"  UNW_ARM64_X0  = 0,\x0a"
"  UNW_ARM64_X1  = 1,\x0a"
"  UNW_ARM64_X2  = 2,\x0a"
"  UNW_ARM64_X3  = 3,\x0a"
"  UNW_ARM64_X4  = 4,\x0a"
"  UNW_ARM64_X5  = 5,\x0a"
"  UNW_ARM64_X6  = 6,\x0a"
"  UNW_ARM64_X7  = 7,\x0a"
"  UNW_ARM64_X8  = 8,\x0a"
"  UNW_ARM64_X9  = 9,\x0a"
"  UNW_ARM64_X10 = 10,\x0a"
"  UNW_ARM64_X11 = 11,\x0a"
"  UNW_ARM64_X12 = 12,\x0a"
"  UNW_ARM64_X13 = 13,\x0a"
"  UNW_ARM64_X14 = 14,\x0a"
"  UNW_ARM64_X15 = 15,\x0a"
"  UNW_ARM64_X16 = 16,\x0a"
"  UNW_ARM64_X17 = 17,\x0a"
"  UNW_ARM64_X18 = 18,\x0a"
"  UNW_ARM64_X19 = 19,\x0a"
"  UNW_ARM64_X20 = 20,\x0a"
"  UNW_ARM64_X21 = 21,\x0a"
"  UNW_ARM64_X22 = 22,\x0a"
"  UNW_ARM64_X23 = 23,\x0a"
"  UNW_ARM64_X24 = 24,\x0a"
"  UNW_ARM64_X25 = 25,\x0a"
"  UNW_ARM64_X26 = 26,\x0a"
"  UNW_ARM64_X27 = 27,\x0a"
"  UNW_ARM64_X28 = 28,\x0a"
"  UNW_ARM64_X29 = 29,\x0a"
"  UNW_ARM64_FP  = 29,\x0a"
"  UNW_ARM64_X30 = 30,\x0a"
"  UNW_ARM64_LR  = 30,\x0a"
"  UNW_ARM64_X31 = 31,\x0a"
"  UNW_ARM64_SP  = 31,\x0a"
"  // reserved block\x0a"
"  UNW_ARM64_D0  = 64,\x0a"
"  UNW_ARM64_D1  = 65,\x0a"
"  UNW_ARM64_D2  = 66,\x0a"
"  UNW_ARM64_D3  = 67,\x0a"
"  UNW_ARM64_D4  = 68,\x0a"
"  UNW_ARM64_D5  = 69,\x0a"
"  UNW_ARM64_D6  = 70,\x0a"
"  UNW_ARM64_D7  = 71,\x0a"
"  UNW_ARM64_D8  = 72,\x0a"
"  UNW_ARM64_D9  = 73,\x0a"
"  UNW_ARM64_D10 = 74,\x0a"
"  UNW_ARM64_D11 = 75,\x0a"
"  UNW_ARM64_D12 = 76,\x0a"
"  UNW_ARM64_D13 = 77,\x0a"
"  UNW_ARM64_D14 = 78,\x0a"
"  UNW_ARM64_D15 = 79,\x0a"
"  UNW_ARM64_D16 = 80,\x0a"
"  UNW_ARM64_D17 = 81,\x0a"
"  UNW_ARM64_D18 = 82,\x0a"
"  UNW_ARM64_D19 = 83,\x0a"
"  UNW_ARM64_D20 = 84,\x0a"
"  UNW_ARM64_D21 = 85,\x0a"
"  UNW_ARM64_D22 = 86,\x0a"
"  UNW_ARM64_D23 = 87,\x0a"
"  UNW_ARM64_D24 = 88,\x0a"
"  UNW_ARM64_D25 = 89,\x0a"
"  UNW_ARM64_D26 = 90,\x0a"
"  UNW_ARM64_D27 = 91,\x0a"
"  UNW_ARM64_D28 = 92,\x0a"
"  UNW_ARM64_D29 = 93,\x0a"
"  UNW_ARM64_D30 = 94,\x0a"
"  UNW_ARM64_D31 = 95,\x0a"
"};\x0a"
"\x0a"
"// 32-bit ARM registers. Numbers match DWARF for ARM spec #3.1 Table 1.\x0a"
"// Naming scheme uses recommendations given in Note 4 for VFP-v2 and VFP-v3.\x0a"
"// In this scheme, even though the 64-bit floating point registers D0-D31\x0a"
"// overlap physically with the 32-bit floating pointer registers S0-S31,\x0a"
"// they are given a non-overlapping range of register numbers.\x0a"
"//\x0a"
"// Commented out ranges are not preserved during unwinding.\x0a"
"enum {\x0a"
"  UNW_ARM_R0  = 0,\x0a"
"  UNW_ARM_R1  = 1,\x0a"
"  UNW_ARM_R2  = 2,\x0a"
"  UNW_ARM_R3  = 3,\x0a"
"  UNW_ARM_R4  = 4,\x0a"
"  UNW_ARM_R5  = 5,\x0a"
"  UNW_ARM_R6  = 6,\x0a"
"  UNW_ARM_R7  = 7,\x0a"
"  UNW_ARM_R8  = 8,\x0a"
"  UNW_ARM_R9  = 9,\x0a"
"  UNW_ARM_R10 = 10,\x0a"
"  UNW_ARM_R11 = 11,\x0a"
"  UNW_ARM_R12 = 12,\x0a"
"  UNW_ARM_SP  = 13,  // Logical alias for UNW_REG_SP\x0a"
"  UNW_ARM_R13 = 13,\x0a"
"  UNW_ARM_LR  = 14,\x0a"
"  UNW_ARM_R14 = 14,\x0a"
"  UNW_ARM_IP  = 15,  // Logical alias for UNW_REG_IP\x0a"
"  UNW_ARM_R15 = 15,\x0a"
"  // 16-63 -- OBSOLETE. Used in VFP1 to represent both S0-S31 and D0-D31.\x0a"
"  UNW_ARM_S0  = 64,\x0a"
"  UNW_ARM_S1  = 65,\x0a"
"  UNW_ARM_S2  = 66,\x0a"
"  UNW_ARM_S3  = 67,\x0a"
"  UNW_ARM_S4  = 68,\x0a"
"  UNW_ARM_S5  = 69,\x0a"
"  UNW_ARM_S6  = 70,\x0a"
"  UNW_ARM_S7  = 71,\x0a"
"  UNW_ARM_S8  = 72,\x0a"
"  UNW_ARM_S9  = 73,\x0a"
"  UNW_ARM_S10 = 74,\x0a"
"  UNW_ARM_S11 = 75,\x0a"
"  UNW_ARM_S12 = 76,\x0a"
"  UNW_ARM_S13 = 77,\x0a"
"  UNW_ARM_S14 = 78,\x0a"
"  UNW_ARM_S15 = 79,\x0a"
"  UNW_ARM_S16 = 80,\x0a"
"  UNW_ARM_S17 = 81,\x0a"
"  UNW_ARM_S18 = 82,\x0a"
"  UNW_ARM_S19 = 83,\x0a"
"  UNW_ARM_S20 = 84,\x0a"
"  UNW_ARM_S21 = 85,\x0a"
"  UNW_ARM_S22 = 86,\x0a"
"  UNW_ARM_S23 = 87,\x0a"
"  UNW_ARM_S24 = 88,\x0a"
"  UNW_ARM_S25 = 89,\x0a"
"  UNW_ARM_S26 = 90,\x0a"
"  UNW_ARM_S27 = 91,\x0a"
"  UNW_ARM_S28 = 92,\x0a"
"  UNW_ARM_S29 = 93,\x0a"
"  UNW_ARM_S30 = 94,\x0a"
"  UNW_ARM_S31 = 95,\x0a"
"  //  96-103 -- OBSOLETE. F0-F7. Used by the FPA system. Superseded by VFP.\x0a"
"  // 104-111 -- wCGR0-wCGR7, ACC0-ACC7 (Intel wireless MMX)\x0a"
"  UNW_ARM_WR0 = 112,\x0a"
"  UNW_ARM_WR1 = 113,\x0a"
"  UNW_ARM_WR2 = 114,\x0a"
"  UNW_ARM_WR3 = 115,\x0a"
"  UNW_ARM_WR4 = 116,\x0a"
"  UNW_ARM_WR5 = 117,\x0a"
"  UNW_ARM_WR6 = 118,\x0a"
"  UNW_ARM_WR7 = 119,\x0a"
"  UNW_ARM_WR8 = 120,\x0a"
"  UNW_ARM_WR9 = 121,\x0a"
"  UNW_ARM_WR10 = 122,\x0a"
"  UNW_ARM_WR11 = 123,\x0a"
"  UNW_ARM_WR12 = 124,\x0a"
"  UNW_ARM_WR13 = 125,\x0a"
"  UNW_ARM_WR14 = 126,\x0a"
"  UNW_ARM_WR15 = 127,\x0a"
"  // 128-133 -- SPSR, SPSR_{FIQ\x7cIRQ\x7c""ABT\x7cUND\x7cSVC}\x0a"
"  // 134-143 -- Reserved\x0a"
"  // 144-150 -- R8_USR-R14_USR\x0a"
"  // 151-157 -- R8_FIQ-R14_FIQ\x0a"
"  // 158-159 -- R13_IRQ-R14_IRQ\x0a"
"  // 160-161 -- R13_ABT-R14_ABT\x0a"
"  // 162-163 -- R13_UND-R14_UND\x0a"
"  // 164-165 -- R13_SVC-R14_SVC\x0a"
"  // 166-191 -- Reserved\x0a"
"  UNW_ARM_WC0 = 192,\x0a"
"  UNW_ARM_WC1 = 193,\x0a"
"  UNW_ARM_WC2 = 194,\x0a"
"  UNW_ARM_WC3 = 195,\x0a"
"  // 196-199 -- wC4-wC7 (Intel wireless MMX control)\x0a"
"  // 200-255 -- Reserved\x0a"
"  UNW_ARM_D0  = 256,\x0a"
"  UNW_ARM_D1  = 257,\x0a"
"  UNW_ARM_D2  = 258,\x0a"
"  UNW_ARM_D3  = 259,\x0a"
"  UNW_ARM_D4  = 260,\x0a"
"  UNW_ARM_D5  = 261,\x0a"
"  UNW_ARM_D6  = 262,\x0a"
"  UNW_ARM_D7  = 263,\x0a"
"  UNW_ARM_D8  = 264,\x0a"
"  UNW_ARM_D9  = 265,\x0a"
"  UNW_ARM_D10 = 266,\x0a"
"  UNW_ARM_D11 = 267,\x0a"
"  UNW_ARM_D12 = 268,\x0a"
"  UNW_ARM_D13 = 269,\x0a"
"  UNW_ARM_D14 = 270,\x0a"
"  UNW_ARM_D15 = 271,\x0a"
"  UNW_ARM_D16 = 272,\x0a"
"  UNW_ARM_D17 = 273,\x0a"
"  UNW_ARM_D18 = 274,\x0a"
"  UNW_ARM_D19 = 275,\x0a"
"  UNW_ARM_D20 = 276,\x0a"
"  UNW_ARM_D21 = 277,\x0a"
"  UNW_ARM_D22 = 278,\x0a"
"  UNW_ARM_D23 = 279,\x0a"
"  UNW_ARM_D24 = 280,\x0a"
"  UNW_ARM_D25 = 281,\x0a"
"  UNW_ARM_D26 = 282,\x0a"
"  UNW_ARM_D27 = 283,\x0a"
"  UNW_ARM_D28 = 284,\x0a"
"  UNW_ARM_D29 = 285,\x0a"
"  UNW_ARM_D30 = 286,\x0a"
"  UNW_ARM_D31 = 287,\x0a"
"  // 288-319 -- Reserved for VFP/Neon\x0a"
"  // 320-8191 -- Reserved\x0a"
"  // 8192-16383 -- Unspecified vendor co-processor register.\x0a"
"};\x0a"
"\x0a"
"// OpenRISC1000 register numbers\x0a"
"enum {\x0a"
"  UNW_OR1K_R0  = 0,\x0a"
"  UNW_OR1K_R1  = 1,\x0a"
"  UNW_OR1K_R2  = 2,\x0a"
"  UNW_OR1K_R3  = 3,\x0a"
"  UNW_OR1K_R4  = 4,\x0a"
"  UNW_OR1K_R5  = 5,\x0a"
"  UNW_OR1K_R6  = 6,\x0a"
"  UNW_OR1K_R7  = 7,\x0a"
"  UNW_OR1K_R8  = 8,\x0a"
"  UNW_OR1K_R9  = 9,\x0a"
"  UNW_OR1K_R10 = 10,\x0a"
"  UNW_OR1K_R11 = 11,\x0a"
"  UNW_OR1K_R12 = 12,\x0a"
"  UNW_OR1K_R13 = 13,\x0a"
"  UNW_OR1K_R14 = 14,\x0a"
"  UNW_OR1K_R15 = 15,\x0a"
"  UNW_OR1K_R16 = 16,\x0a"
"  UNW_OR1K_R17 = 17,\x0a"
"  UNW_OR1K_R18 = 18,\x0a"
"  UNW_OR1K_R19 = 19,\x0a"
"  UNW_OR1K_R20 = 20,\x0a"
"  UNW_OR1K_R21 = 21,\x0a"
"  UNW_OR1K_R22 = 22,\x0a"
"  UNW_OR1K_R23 = 23,\x0a"
"  UNW_OR1K_R24 = 24,\x0a"
"  UNW_OR1K_R25 = 25,\x0a"
"  UNW_OR1K_R26 = 26,\x0a"
"  UNW_OR1K_R27 = 27,\x0a"
"  UNW_OR1K_R28 = 28,\x0a"
"  UNW_OR1K_R29 = 29,\x0a"
"  UNW_OR1K_R30 = 30,\x0a"
"  UNW_OR1K_R31 = 31,\x0a"
"};\x0a"
"\x0a"
"#endif\x0a"
"", 14200 ); }