#include <string_view>
namespace divine::str::dios {
extern const std::string_view libunwind_include_mach_o_compact_unwind_encoding_h( 
"//===------------------ mach-o/compact_unwind_encoding.h ------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//\x0a"
"// Darwin's alternative to DWARF based unwind encodings.\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"\x0a"
"#ifndef __COMPACT_UNWIND_ENCODING__\x0a"
"#define __COMPACT_UNWIND_ENCODING__\x0a"
"\x0a"
"#include <stdint.h>\x0a"
"\x0a"
"//\x0a"
"// Compilers can emit standard DWARF FDEs in the __TEXT,__eh_frame section\x0a"
"// of object files. Or compilers can emit compact unwind information in\x0a"
"// the __LD,__compact_unwind section.\x0a"
"//\x0a"
"// When the linker creates a final linked image, it will create a\x0a"
"// __TEXT,__unwind_info section.  This section is a small and fast way for the\x0a"
"// runtime to access unwind info for any given function.  If the compiler\x0a"
"// emitted compact unwind info for the function, that compact unwind info will\x0a"
"// be encoded in the __TEXT,__unwind_info section. If the compiler emitted\x0a"
"// DWARF unwind info, the __TEXT,__unwind_info section will contain the offset\x0a"
"// of the FDE in the __TEXT,__eh_frame section in the final linked image.\x0a"
"//\x0a"
"// Note\x3a Previously, the linker would transform some DWARF unwind infos into\x0a"
"//       compact unwind info.  But that is fragile and no longer done.\x0a"
"\x0a"
"\x0a"
"//\x0a"
"// The compact unwind endoding is a 32-bit value which encoded in an\x0a"
"// architecture specific way, which registers to restore from where, and how\x0a"
"// to unwind out of the function.\x0a"
"//\x0a"
"typedef uint32_t compact_unwind_encoding_t;\x0a"
"\x0a"
"\x0a"
"// architecture independent bits\x0a"
"enum {\x0a"
"    UNWIND_IS_NOT_FUNCTION_START           = 0x80000000,\x0a"
"    UNWIND_HAS_LSDA                        = 0x40000000,\x0a"
"    UNWIND_PERSONALITY_MASK                = 0x30000000,\x0a"
"};\x0a"
"\x0a"
"\x0a"
"\x0a"
"\x0a"
"//\x0a"
"// x86\x0a"
"//\x0a"
"// 1-bit\x3a start\x0a"
"// 1-bit\x3a has lsda\x0a"
"// 2-bit\x3a personality index\x0a"
"//\x0a"
"// 4-bits\x3a 0=old, 1=ebp based, 2=stack-imm, 3=stack-ind, 4=DWARF\x0a"
"//  ebp based\x3a\x0a"
"//        15-bits (5*3-bits per reg) register permutation\x0a"
"//        8-bits for stack offset\x0a"
"//  frameless\x3a\x0a"
"//        8-bits stack size\x0a"
"//        3-bits stack adjust\x0a"
"//        3-bits register count\x0a"
"//        10-bits register permutation\x0a"
"//\x0a"
"enum {\x0a"
"    UNWIND_X86_MODE_MASK                         = 0x0F000000,\x0a"
"    UNWIND_X86_MODE_EBP_FRAME                    = 0x01000000,\x0a"
"    UNWIND_X86_MODE_STACK_IMMD                   = 0x02000000,\x0a"
"    UNWIND_X86_MODE_STACK_IND                    = 0x03000000,\x0a"
"    UNWIND_X86_MODE_DWARF                        = 0x04000000,\x0a"
"\x0a"
"    UNWIND_X86_EBP_FRAME_REGISTERS               = 0x00007FFF,\x0a"
"    UNWIND_X86_EBP_FRAME_OFFSET                  = 0x00FF0000,\x0a"
"\x0a"
"    UNWIND_X86_FRAMELESS_STACK_SIZE              = 0x00FF0000,\x0a"
"    UNWIND_X86_FRAMELESS_STACK_ADJUST            = 0x0000E000,\x0a"
"    UNWIND_X86_FRAMELESS_STACK_REG_COUNT         = 0x00001C00,\x0a"
"    UNWIND_X86_FRAMELESS_STACK_REG_PERMUTATION   = 0x000003FF,\x0a"
"\x0a"
"    UNWIND_X86_DWARF_SECTION_OFFSET              = 0x00FFFFFF,\x0a"
"};\x0a"
"\x0a"
"enum {\x0a"
"    UNWIND_X86_REG_NONE     = 0,\x0a"
"    UNWIND_X86_REG_EBX      = 1,\x0a"
"    UNWIND_X86_REG_ECX      = 2,\x0a"
"    UNWIND_X86_REG_EDX      = 3,\x0a"
"    UNWIND_X86_REG_EDI      = 4,\x0a"
"    UNWIND_X86_REG_ESI      = 5,\x0a"
"    UNWIND_X86_REG_EBP      = 6,\x0a"
"};\x0a"
"\x0a"
"//\x0a"
"// For x86 there are four modes for the compact unwind encoding\x3a\x0a"
"// UNWIND_X86_MODE_EBP_FRAME\x3a\x0a"
"//    EBP based frame where EBP is push on stack immediately after return address,\x0a"
"//    then ESP is moved to EBP. Thus, to unwind ESP is restored with the current\x0a"
"//    EPB value, then EBP is restored by popping off the stack, and the return\x0a"
"//    is done by popping the stack once more into the pc.\x0a"
"//    All non-volatile registers that need to be restored must have been saved\x0a"
"//    in a small range in the stack that starts EBP-4 to EBP-1020.  The offset/4\x0a"
"//    is encoded in the UNWIND_X86_EBP_FRAME_OFFSET bits.  The registers saved\x0a"
"//    are encoded in the UNWIND_X86_EBP_FRAME_REGISTERS bits as five 3-bit entries.\x0a"
"//    Each entry contains which register to restore.\x0a"
"// UNWIND_X86_MODE_STACK_IMMD\x3a\x0a"
"//    A \x22""frameless\x22 (EBP not used as frame pointer) function with a small \x0a"
"//    constant stack size.  To return, a constant (encoded in the compact\x0a"
"//    unwind encoding) is added to the ESP. Then the return is done by\x0a"
"//    popping the stack into the pc.\x0a"
"//    All non-volatile registers that need to be restored must have been saved\x0a"
"//    on the stack immediately after the return address.  The stack_size/4 is\x0a"
"//    encoded in the UNWIND_X86_FRAMELESS_STACK_SIZE (max stack size is 1024).\x0a"
"//    The number of registers saved is encoded in UNWIND_X86_FRAMELESS_STACK_REG_COUNT.\x0a"
"//    UNWIND_X86_FRAMELESS_STACK_REG_PERMUTATION constains which registers were\x0a"
"//    saved and their order.\x0a"
"// UNWIND_X86_MODE_STACK_IND\x3a\x0a"
"//    A \x22""frameless\x22 (EBP not used as frame pointer) function large constant \x0a"
"//    stack size.  This case is like the previous, except the stack size is too\x0a"
"//    large to encode in the compact unwind encoding.  Instead it requires that \x0a"
"//    the function contains \x22subl \x24nnnnnnnn,ESP\x22 in its prolog.  The compact \x0a"
"//    encoding contains the offset to the nnnnnnnn value in the function in\x0a"
"//    UNWIND_X86_FRAMELESS_STACK_SIZE.  \x0a"
"// UNWIND_X86_MODE_DWARF\x3a\x0a"
"//    No compact unwind encoding is available.  Instead the low 24-bits of the\x0a"
"//    compact encoding is the offset of the DWARF FDE in the __eh_frame section.\x0a"
"//    This mode is never used in object files.  It is only generated by the \x0a"
"//    linker in final linked images which have only DWARF unwind info for a\x0a"
"//    function.\x0a"
"//\x0a"
"// The permutation encoding is a Lehmer code sequence encoded into a\x0a"
"// single variable-base number so we can encode the ordering of up to\x0a"
"// six registers in a 10-bit space.\x0a"
"//\x0a"
"// The following is the algorithm used to create the permutation encoding used\x0a"
"// with frameless stacks.  It is passed the number of registers to be saved and\x0a"
"// an array of the register numbers saved.\x0a"
"//\x0a"
"//uint32_t permute_encode(uint32_t registerCount, const uint32_t registers\x5b""6\x5d)\x0a"
"//{\x0a"
"//    uint32_t renumregs\x5b""6\x5d;\x0a"
"//    for (int i=6-registerCount; i < 6; ++i) {\x0a"
"//        int countless = 0;\x0a"
"//        for (int j=6-registerCount; j < i; ++j) {\x0a"
"//            if ( registers\x5bj\x5d < registers\x5bi\x5d )\x0a"
"//                ++countless;\x0a"
"//        }\x0a"
"//        renumregs\x5bi\x5d = registers\x5bi\x5d - countless -1;\x0a"
"//    }\x0a"
"//    uint32_t permutationEncoding = 0;\x0a"
"//    switch ( registerCount ) {\x0a"
"//        case 6\x3a\x0a"
"//            permutationEncoding \x7c= (120*renumregs\x5b""0\x5d + 24*renumregs\x5b""1\x5d\x0a"
"//                                    + 6*renumregs\x5b""2\x5d + 2*renumregs\x5b""3\x5d\x0a"
"//                                      + renumregs\x5b""4\x5d);\x0a"
"//            break;\x0a"
"//        case 5\x3a\x0a"
"//            permutationEncoding \x7c= (120*renumregs\x5b""1\x5d + 24*renumregs\x5b""2\x5d\x0a"
"//                                    + 6*renumregs\x5b""3\x5d + 2*renumregs\x5b""4\x5d\x0a"
"//                                      + renumregs\x5b""5\x5d);\x0a"
"//            break;\x0a"
"//        case 4\x3a\x0a"
"//            permutationEncoding \x7c= (60*renumregs\x5b""2\x5d + 12*renumregs\x5b""3\x5d\x0a"
"//                                   + 3*renumregs\x5b""4\x5d + renumregs\x5b""5\x5d);\x0a"
"//            break;\x0a"
"//        case 3\x3a\x0a"
"//            permutationEncoding \x7c= (20*renumregs\x5b""3\x5d + 4*renumregs\x5b""4\x5d\x0a"
"//                                     + renumregs\x5b""5\x5d);\x0a"
"//            break;\x0a"
"//        case 2\x3a\x0a"
"//            permutationEncoding \x7c= (5*renumregs\x5b""4\x5d + renumregs\x5b""5\x5d);\x0a"
"//            break;\x0a"
"//        case 1\x3a\x0a"
"//            permutationEncoding \x7c= (renumregs\x5b""5\x5d);\x0a"
"//            break;\x0a"
"//    }\x0a"
"//    return permutationEncoding;\x0a"
"//}\x0a"
"//\x0a"
"\x0a"
"\x0a"
"\x0a"
"\x0a"
"//\x0a"
"// x86_64\x0a"
"//\x0a"
"// 1-bit\x3a start\x0a"
"// 1-bit\x3a has lsda\x0a"
"// 2-bit\x3a personality index\x0a"
"//\x0a"
"// 4-bits\x3a 0=old, 1=rbp based, 2=stack-imm, 3=stack-ind, 4=DWARF\x0a"
"//  rbp based\x3a\x0a"
"//        15-bits (5*3-bits per reg) register permutation\x0a"
"//        8-bits for stack offset\x0a"
"//  frameless\x3a\x0a"
"//        8-bits stack size\x0a"
"//        3-bits stack adjust\x0a"
"//        3-bits register count\x0a"
"//        10-bits register permutation\x0a"
"//\x0a"
"enum {\x0a"
"    UNWIND_X86_64_MODE_MASK                         = 0x0F000000,\x0a"
"    UNWIND_X86_64_MODE_RBP_FRAME                    = 0x01000000,\x0a"
"    UNWIND_X86_64_MODE_STACK_IMMD                   = 0x02000000,\x0a"
"    UNWIND_X86_64_MODE_STACK_IND                    = 0x03000000,\x0a"
"    UNWIND_X86_64_MODE_DWARF                        = 0x04000000,\x0a"
"\x0a"
"    UNWIND_X86_64_RBP_FRAME_REGISTERS               = 0x00007FFF,\x0a"
"    UNWIND_X86_64_RBP_FRAME_OFFSET                  = 0x00FF0000,\x0a"
"\x0a"
"    UNWIND_X86_64_FRAMELESS_STACK_SIZE              = 0x00FF0000,\x0a"
"    UNWIND_X86_64_FRAMELESS_STACK_ADJUST            = 0x0000E000,\x0a"
"    UNWIND_X86_64_FRAMELESS_STACK_REG_COUNT         = 0x00001C00,\x0a"
"    UNWIND_X86_64_FRAMELESS_STACK_REG_PERMUTATION   = 0x000003FF,\x0a"
"\x0a"
"    UNWIND_X86_64_DWARF_SECTION_OFFSET              = 0x00FFFFFF,\x0a"
"};\x0a"
"\x0a"
"enum {\x0a"
"    UNWIND_X86_64_REG_NONE       = 0,\x0a"
"    UNWIND_X86_64_REG_RBX        = 1,\x0a"
"    UNWIND_X86_64_REG_R12        = 2,\x0a"
"    UNWIND_X86_64_REG_R13        = 3,\x0a"
"    UNWIND_X86_64_REG_R14        = 4,\x0a"
"    UNWIND_X86_64_REG_R15        = 5,\x0a"
"    UNWIND_X86_64_REG_RBP        = 6,\x0a"
"};\x0a"
"//\x0a"
"// For x86_64 there are four modes for the compact unwind encoding\x3a\x0a"
"// UNWIND_X86_64_MODE_RBP_FRAME\x3a\x0a"
"//    RBP based frame where RBP is push on stack immediately after return address,\x0a"
"//    then RSP is moved to RBP. Thus, to unwind RSP is restored with the current \x0a"
"//    EPB value, then RBP is restored by popping off the stack, and the return \x0a"
"//    is done by popping the stack once more into the pc.\x0a"
"//    All non-volatile registers that need to be restored must have been saved\x0a"
"//    in a small range in the stack that starts RBP-8 to RBP-2040.  The offset/8 \x0a"
"//    is encoded in the UNWIND_X86_64_RBP_FRAME_OFFSET bits.  The registers saved\x0a"
"//    are encoded in the UNWIND_X86_64_RBP_FRAME_REGISTERS bits as five 3-bit entries.\x0a"
"//    Each entry contains which register to restore.  \x0a"
"// UNWIND_X86_64_MODE_STACK_IMMD\x3a\x0a"
"//    A \x22""frameless\x22 (RBP not used as frame pointer) function with a small \x0a"
"//    constant stack size.  To return, a constant (encoded in the compact \x0a"
"//    unwind encoding) is added to the RSP. Then the return is done by \x0a"
"//    popping the stack into the pc.\x0a"
"//    All non-volatile registers that need to be restored must have been saved\x0a"
"//    on the stack immediately after the return address.  The stack_size/8 is\x0a"
"//    encoded in the UNWIND_X86_64_FRAMELESS_STACK_SIZE (max stack size is 2048).\x0a"
"//    The number of registers saved is encoded in UNWIND_X86_64_FRAMELESS_STACK_REG_COUNT.\x0a"
"//    UNWIND_X86_64_FRAMELESS_STACK_REG_PERMUTATION constains which registers were\x0a"
"//    saved and their order.  \x0a"
"// UNWIND_X86_64_MODE_STACK_IND\x3a\x0a"
"//    A \x22""frameless\x22 (RBP not used as frame pointer) function large constant \x0a"
"//    stack size.  This case is like the previous, except the stack size is too\x0a"
"//    large to encode in the compact unwind encoding.  Instead it requires that \x0a"
"//    the function contains \x22subq \x24nnnnnnnn,RSP\x22 in its prolog.  The compact \x0a"
"//    encoding contains the offset to the nnnnnnnn value in the function in\x0a"
"//    UNWIND_X86_64_FRAMELESS_STACK_SIZE.  \x0a"
"// UNWIND_X86_64_MODE_DWARF\x3a\x0a"
"//    No compact unwind encoding is available.  Instead the low 24-bits of the\x0a"
"//    compact encoding is the offset of the DWARF FDE in the __eh_frame section.\x0a"
"//    This mode is never used in object files.  It is only generated by the \x0a"
"//    linker in final linked images which have only DWARF unwind info for a\x0a"
"//    function.\x0a"
"//\x0a"
"\x0a"
"\x0a"
"// ARM64\x0a"
"//\x0a"
"// 1-bit\x3a start\x0a"
"// 1-bit\x3a has lsda\x0a"
"// 2-bit\x3a personality index\x0a"
"//\x0a"
"// 4-bits\x3a 4=frame-based, 3=DWARF, 2=frameless\x0a"
"//  frameless\x3a\x0a"
"//        12-bits of stack size\x0a"
"//  frame-based\x3a\x0a"
"//        4-bits D reg pairs saved\x0a"
"//        5-bits X reg pairs saved\x0a"
"//  DWARF\x3a\x0a"
"//        24-bits offset of DWARF FDE in __eh_frame section\x0a"
"//\x0a"
"enum {\x0a"
"    UNWIND_ARM64_MODE_MASK                     = 0x0F000000,\x0a"
"    UNWIND_ARM64_MODE_FRAMELESS                = 0x02000000,\x0a"
"    UNWIND_ARM64_MODE_DWARF                    = 0x03000000,\x0a"
"    UNWIND_ARM64_MODE_FRAME                    = 0x04000000,\x0a"
"\x0a"
"    UNWIND_ARM64_FRAME_X19_X20_PAIR            = 0x00000001,\x0a"
"    UNWIND_ARM64_FRAME_X21_X22_PAIR            = 0x00000002,\x0a"
"    UNWIND_ARM64_FRAME_X23_X24_PAIR            = 0x00000004,\x0a"
"    UNWIND_ARM64_FRAME_X25_X26_PAIR            = 0x00000008,\x0a"
"    UNWIND_ARM64_FRAME_X27_X28_PAIR            = 0x00000010,\x0a"
"    UNWIND_ARM64_FRAME_D8_D9_PAIR              = 0x00000100,\x0a"
"    UNWIND_ARM64_FRAME_D10_D11_PAIR            = 0x00000200,\x0a"
"    UNWIND_ARM64_FRAME_D12_D13_PAIR            = 0x00000400,\x0a"
"    UNWIND_ARM64_FRAME_D14_D15_PAIR            = 0x00000800,\x0a"
"\x0a"
"    UNWIND_ARM64_FRAMELESS_STACK_SIZE_MASK     = 0x00FFF000,\x0a"
"    UNWIND_ARM64_DWARF_SECTION_OFFSET          = 0x00FFFFFF,\x0a"
"};\x0a"
"// For arm64 there are three modes for the compact unwind encoding\x3a\x0a"
"// UNWIND_ARM64_MODE_FRAME\x3a\x0a"
"//    This is a standard arm64 prolog where FP/LR are immediately pushed on the\x0a"
"//    stack, then SP is copied to FP. If there are any non-volatile registers\x0a"
"//    saved, then are copied into the stack frame in pairs in a contiguous\x0a"
"//    range right below the saved FP/LR pair.  Any subset of the five X pairs \x0a"
"//    and four D pairs can be saved, but the memory layout must be in register\x0a"
"//    number order.  \x0a"
"// UNWIND_ARM64_MODE_FRAMELESS\x3a\x0a"
"//    A \x22""frameless\x22 leaf function, where FP/LR are not saved. The return address \x0a"
"//    remains in LR throughout the function. If any non-volatile registers\x0a"
"//    are saved, they must be pushed onto the stack before any stack space is\x0a"
"//    allocated for local variables.  The stack sized (including any saved\x0a"
"//    non-volatile registers) divided by 16 is encoded in the bits \x0a"
"//    UNWIND_ARM64_FRAMELESS_STACK_SIZE_MASK.\x0a"
"// UNWIND_ARM64_MODE_DWARF\x3a\x0a"
"//    No compact unwind encoding is available.  Instead the low 24-bits of the\x0a"
"//    compact encoding is the offset of the DWARF FDE in the __eh_frame section.\x0a"
"//    This mode is never used in object files.  It is only generated by the \x0a"
"//    linker in final linked images which have only DWARF unwind info for a\x0a"
"//    function.\x0a"
"//\x0a"
"\x0a"
"\x0a"
"\x0a"
"\x0a"
"\x0a"
"////////////////////////////////////////////////////////////////////////////////\x0a"
"//\x0a"
"//  Relocatable Object Files\x3a __LD,__compact_unwind\x0a"
"//\x0a"
"////////////////////////////////////////////////////////////////////////////////\x0a"
"\x0a"
"//\x0a"
"// A compiler can generated compact unwind information for a function by adding\x0a"
"// a \x22row\x22 to the __LD,__compact_unwind section.  This section has the \x0a"
"// S_ATTR_DEBUG bit set, so the section will be ignored by older linkers. \x0a"
"// It is removed by the new linker, so never ends up in final executables. \x0a"
"// This section is a table, initially with one row per function (that needs \x0a"
"// unwind info).  The table columns and some conceptual entries are\x3a\x0a"
"//\x0a"
"//     range-start               pointer to start of function/range\x0a"
"//     range-length              \x0a"
"//     compact-unwind-encoding   32-bit encoding  \x0a"
"//     personality-function      or zero if no personality function\x0a"
"//     lsda                      or zero if no LSDA data\x0a"
"//\x0a"
"// The length and encoding fields are 32-bits.  The other are all pointer sized. \x0a"
"//\x0a"
"// In x86_64 assembly, these entry would look like\x3a\x0a"
"//\x0a"
"//     .section __LD,__compact_unwind,regular,debug\x0a"
"//\x0a"
"//     #compact unwind for _foo\x0a"
"//     .quad    _foo\x0a"
"//     .set     L1,LfooEnd-_foo\x0a"
"//     .long    L1\x0a"
"//     .long    0x01010001\x0a"
"//     .quad    0\x0a"
"//     .quad    0\x0a"
"//\x0a"
"//     #compact unwind for _bar\x0a"
"//     .quad    _bar\x0a"
"//     .set     L2,LbarEnd-_bar\x0a"
"//     .long    L2\x0a"
"//     .long    0x01020011\x0a"
"//     .quad    __gxx_personality\x0a"
"//     .quad    except_tab1\x0a"
"//\x0a"
"//\x0a"
"// Notes\x3a There is no need for any labels in the the __compact_unwind section.  \x0a"
"//        The use of the .set directive is to force the evaluation of the \x0a"
"//        range-length at assembly time, instead of generating relocations.\x0a"
"//\x0a"
"// To support future compiler optimizations where which non-volatile registers \x0a"
"// are saved changes within a function (e.g. delay saving non-volatiles until\x0a"
"// necessary), there can by multiple lines in the __compact_unwind table for one\x0a"
"// function, each with a different (non-overlapping) range and each with \x0a"
"// different compact unwind encodings that correspond to the non-volatiles \x0a"
"// saved at that range of the function.\x0a"
"//\x0a"
"// If a particular function is so wacky that there is no compact unwind way\x0a"
"// to encode it, then the compiler can emit traditional DWARF unwind info.  \x0a"
"// The runtime will use which ever is available.\x0a"
"//\x0a"
"// Runtime support for compact unwind encodings are only available on 10.6 \x0a"
"// and later.  So, the compiler should not generate it when targeting pre-10.6. \x0a"
"\x0a"
"\x0a"
"\x0a"
"\x0a"
"////////////////////////////////////////////////////////////////////////////////\x0a"
"//\x0a"
"//  Final Linked Images\x3a __TEXT,__unwind_info\x0a"
"//\x0a"
"////////////////////////////////////////////////////////////////////////////////\x0a"
"\x0a"
"//\x0a"
"// The __TEXT,__unwind_info section is laid out for an efficient two level lookup.\x0a"
"// The header of the section contains a coarse index that maps function address\x0a"
"// to the page (4096 byte block) containing the unwind info for that function.  \x0a"
"//\x0a"
"\x0a"
"#define UNWIND_SECTION_VERSION 1\x0a"
"struct unwind_info_section_header\x0a"
"{\x0a"
"    uint32_t    version;            // UNWIND_SECTION_VERSION\x0a"
"    uint32_t    commonEncodingsArraySectionOffset;\x0a"
"    uint32_t    commonEncodingsArrayCount;\x0a"
"    uint32_t    personalityArraySectionOffset;\x0a"
"    uint32_t    personalityArrayCount;\x0a"
"    uint32_t    indexSectionOffset;\x0a"
"    uint32_t    indexCount;\x0a"
"    // compact_unwind_encoding_t\x5b\x5d\x0a"
"    // uint32_t personalities\x5b\x5d\x0a"
"    // unwind_info_section_header_index_entry\x5b\x5d\x0a"
"    // unwind_info_section_header_lsda_index_entry\x5b\x5d\x0a"
"};\x0a"
"\x0a"
"struct unwind_info_section_header_index_entry\x0a"
"{\x0a"
"    uint32_t        functionOffset;\x0a"
"    uint32_t        secondLevelPagesSectionOffset;  // section offset to start of regular or compress page\x0a"
"    uint32_t        lsdaIndexArraySectionOffset;    // section offset to start of lsda_index array for this range\x0a"
"};\x0a"
"\x0a"
"struct unwind_info_section_header_lsda_index_entry\x0a"
"{\x0a"
"    uint32_t        functionOffset;\x0a"
"    uint32_t        lsdaOffset;\x0a"
"};\x0a"
"\x0a"
"//\x0a"
"// There are two kinds of second level index pages\x3a regular and compressed.\x0a"
"// A compressed page can hold up to 1021 entries, but it cannot be used\x0a"
"// if too many different encoding types are used.  The regular page holds\x0a"
"// 511 entries.\x0a"
"//\x0a"
"\x0a"
"struct unwind_info_regular_second_level_entry\x0a"
"{\x0a"
"    uint32_t                    functionOffset;\x0a"
"    compact_unwind_encoding_t    encoding;\x0a"
"};\x0a"
"\x0a"
"#define UNWIND_SECOND_LEVEL_REGULAR 2\x0a"
"struct unwind_info_regular_second_level_page_header\x0a"
"{\x0a"
"    uint32_t    kind;    // UNWIND_SECOND_LEVEL_REGULAR\x0a"
"    uint16_t    entryPageOffset;\x0a"
"    uint16_t    entryCount;\x0a"
"    // entry array\x0a"
"};\x0a"
"\x0a"
"#define UNWIND_SECOND_LEVEL_COMPRESSED 3\x0a"
"struct unwind_info_compressed_second_level_page_header\x0a"
"{\x0a"
"    uint32_t    kind;    // UNWIND_SECOND_LEVEL_COMPRESSED\x0a"
"    uint16_t    entryPageOffset;\x0a"
"    uint16_t    entryCount;\x0a"
"    uint16_t    encodingsPageOffset;\x0a"
"    uint16_t    encodingsCount;\x0a"
"    // 32-bit entry array\x0a"
"    // encodings array\x0a"
"};\x0a"
"\x0a"
"#define UNWIND_INFO_COMPRESSED_ENTRY_FUNC_OFFSET(entry)            (entry \x26 0x00FFFFFF)\x0a"
"#define UNWIND_INFO_COMPRESSED_ENTRY_ENCODING_INDEX(entry)        ((entry >> 24) \x26 0xFF)\x0a"
"\x0a"
"\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"", 19080 ); }