#include <string_view>
namespace divine::str::dios {
extern const std::string_view libunwind_include_unwind_h( 
"//===------------------------------- unwind.h -----------------------------===//\x0a"
"//\x0a"
"//                     The LLVM Compiler Infrastructure\x0a"
"//\x0a"
"// This file is dual licensed under the MIT and the University of Illinois Open\x0a"
"// Source Licenses. See LICENSE.TXT for details.\x0a"
"//\x0a"
"//\x0a"
"// C++ ABI Level 1 ABI documented at\x3a\x0a"
"//   http\x3a//mentorembedded.github.io/cxx-abi/abi-eh.html\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef __UNWIND_H__\x0a"
"#define __UNWIND_H__\x0a"
"\x0a"
"#include <__libunwind_config.h>\x0a"
"\x0a"
"#include <stdint.h>\x0a"
"#include <stddef.h>\x0a"
"\x0a"
"#if defined(__APPLE__)\x0a"
"#define LIBUNWIND_UNAVAIL __attribute__ (( unavailable ))\x0a"
"#else\x0a"
"#define LIBUNWIND_UNAVAIL\x0a"
"#endif\x0a"
"\x0a"
"typedef enum {\x0a"
"  _URC_NO_REASON = 0,\x0a"
"  _URC_OK = 0,\x0a"
"  _URC_FOREIGN_EXCEPTION_CAUGHT = 1,\x0a"
"  _URC_FATAL_PHASE2_ERROR = 2,\x0a"
"  _URC_FATAL_PHASE1_ERROR = 3,\x0a"
"  _URC_NORMAL_STOP = 4,\x0a"
"  _URC_END_OF_STACK = 5,\x0a"
"  _URC_HANDLER_FOUND = 6,\x0a"
"  _URC_INSTALL_CONTEXT = 7,\x0a"
"  _URC_CONTINUE_UNWIND = 8,\x0a"
"#if _LIBUNWIND_ARM_EHABI\x0a"
"  _URC_FAILURE = 9\x0a"
"#endif\x0a"
"} _Unwind_Reason_Code;\x0a"
"\x0a"
"typedef enum {\x0a"
"  _UA_SEARCH_PHASE = 1,\x0a"
"  _UA_CLEANUP_PHASE = 2,\x0a"
"  _UA_HANDLER_FRAME = 4,\x0a"
"  _UA_FORCE_UNWIND = 8,\x0a"
"  _UA_END_OF_STACK = 16 // gcc extension to C++ ABI\x0a"
"} _Unwind_Action;\x0a"
"\x0a"
"typedef struct _Unwind_Context _Unwind_Context;   // opaque\x0a"
"\x0a"
"#if _LIBUNWIND_ARM_EHABI\x0a"
"typedef uint32_t _Unwind_State;\x0a"
"\x0a"
"static const _Unwind_State _US_VIRTUAL_UNWIND_FRAME   = 0;\x0a"
"static const _Unwind_State _US_UNWIND_FRAME_STARTING  = 1;\x0a"
"static const _Unwind_State _US_UNWIND_FRAME_RESUME    = 2;\x0a"
"static const _Unwind_State _US_ACTION_MASK            = 3;\x0a"
"/* Undocumented flag for force unwinding. */\x0a"
"static const _Unwind_State _US_FORCE_UNWIND           = 8;\x0a"
"\x0a"
"typedef uint32_t _Unwind_EHT_Header;\x0a"
"\x0a"
"struct _Unwind_Control_Block;\x0a"
"typedef struct _Unwind_Control_Block _Unwind_Control_Block;\x0a"
"typedef struct _Unwind_Control_Block _Unwind_Exception; /* Alias */\x0a"
"\x0a"
"struct _Unwind_Control_Block {\x0a"
"  uint64_t exception_class;\x0a"
"  void (*exception_cleanup)(_Unwind_Reason_Code, _Unwind_Control_Block*);\x0a"
"\x0a"
"  /* Unwinder cache, private fields for the unwinder's use */\x0a"
"  struct {\x0a"
"    uint32_t reserved1; /* init reserved1 to 0, then don't touch */\x0a"
"    uint32_t reserved2;\x0a"
"    uint32_t reserved3;\x0a"
"    uint32_t reserved4;\x0a"
"    uint32_t reserved5;\x0a"
"  } unwinder_cache;\x0a"
"\x0a"
"  /* Propagation barrier cache (valid after phase 1)\x3a */\x0a"
"  struct {\x0a"
"    uint32_t sp;\x0a"
"    uint32_t bitpattern\x5b""5\x5d;\x0a"
"  } barrier_cache;\x0a"
"\x0a"
"  /* Cleanup cache (preserved over cleanup)\x3a */\x0a"
"  struct {\x0a"
"    uint32_t bitpattern\x5b""4\x5d;\x0a"
"  } cleanup_cache;\x0a"
"\x0a"
"  /* Pr cache (for pr's benefit)\x3a */\x0a"
"  struct {\x0a"
"    uint32_t fnstart; /* function start address */\x0a"
"    _Unwind_EHT_Header* ehtp; /* pointer to EHT entry header word */\x0a"
"    uint32_t additional;\x0a"
"    uint32_t reserved1;\x0a"
"  } pr_cache;\x0a"
"\x0a"
"  long long int \x3a""0; /* Enforce the 8-byte alignment */\x0a"
"};\x0a"
"\x0a"
"typedef _Unwind_Reason_Code (*_Unwind_Stop_Fn)\x0a"
"      (_Unwind_State state,\x0a"
"       _Unwind_Exception* exceptionObject,\x0a"
"       struct _Unwind_Context* context);\x0a"
"\x0a"
"typedef _Unwind_Reason_Code (*__personality_routine)\x0a"
"      (_Unwind_State state,\x0a"
"       _Unwind_Exception* exceptionObject,\x0a"
"       struct _Unwind_Context* context);\x0a"
"#else\x0a"
"struct _Unwind_Context;   // opaque\x0a"
"struct _Unwind_Exception; // forward declaration\x0a"
"typedef struct _Unwind_Exception _Unwind_Exception;\x0a"
"\x0a"
"struct _Unwind_Exception {\x0a"
"  uint64_t exception_class;\x0a"
"  void (*exception_cleanup)(_Unwind_Reason_Code reason,\x0a"
"                            _Unwind_Exception *exc);\x0a"
"  uintptr_t private_1; // non-zero means forced unwind\x0a"
"  uintptr_t private_2; // holds sp that phase1 found for phase2 to use\x0a"
"#ifndef __LP64__\x0a"
"  // The implementation of _Unwind_Exception uses an attribute mode on the\x0a"
"  // above fields which has the side effect of causing this whole struct to\x0a"
"  // round up to 32 bytes in size. To be more explicit, we add pad fields\x0a"
"  // added for binary compatibility.\x0a"
"  uint32_t reserved\x5b""3\x5d;\x0a"
"#endif\x0a"
"  // The Itanium ABI requires that _Unwind_Exception objects are \x22""double-word\x0a"
"  // aligned\x22.  GCC has interpreted this to mean \x22use the maximum useful\x0a"
"  // alignment for the target\x22; so do we.\x0a"
"} __attribute__((__aligned__));\x0a"
"\x0a"
"typedef _Unwind_Reason_Code (*_Unwind_Stop_Fn)\x0a"
"    (int version,\x0a"
"     _Unwind_Action actions,\x0a"
"     uint64_t exceptionClass,\x0a"
"     _Unwind_Exception* exceptionObject,\x0a"
"     struct _Unwind_Context* context,\x0a"
"     void* stop_parameter );\x0a"
"\x0a"
"typedef _Unwind_Reason_Code (*__personality_routine)\x0a"
"      (int version,\x0a"
"       _Unwind_Action actions,\x0a"
"       uint64_t exceptionClass,\x0a"
"       _Unwind_Exception* exceptionObject,\x0a"
"       struct _Unwind_Context* context);\x0a"
"#endif\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"extern \x22""C\x22 {\x0a"
"#endif\x0a"
"\x0a"
"//\x0a"
"// The following are the base functions documented by the C++ ABI\x0a"
"//\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_SjLj_RaiseException(_Unwind_Exception *exception_object);\x0a"
"extern void _Unwind_SjLj_Resume(_Unwind_Exception *exception_object);\x0a"
"#else\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_RaiseException(_Unwind_Exception *exception_object);\x0a"
"extern void _Unwind_Resume(_Unwind_Exception *exception_object);\x0a"
"#endif\x0a"
"extern void _Unwind_DeleteException(_Unwind_Exception *exception_object);\x0a"
"\x0a"
"#if _LIBUNWIND_ARM_EHABI\x0a"
"typedef enum {\x0a"
"  _UVRSC_CORE = 0, /* integer register */\x0a"
"  _UVRSC_VFP = 1, /* vfp */\x0a"
"  _UVRSC_WMMXD = 3, /* Intel WMMX data register */\x0a"
"  _UVRSC_WMMXC = 4 /* Intel WMMX control register */\x0a"
"} _Unwind_VRS_RegClass;\x0a"
"\x0a"
"typedef enum {\x0a"
"  _UVRSD_UINT32 = 0,\x0a"
"  _UVRSD_VFPX = 1,\x0a"
"  _UVRSD_UINT64 = 3,\x0a"
"  _UVRSD_FLOAT = 4,\x0a"
"  _UVRSD_DOUBLE = 5\x0a"
"} _Unwind_VRS_DataRepresentation;\x0a"
"\x0a"
"typedef enum {\x0a"
"  _UVRSR_OK = 0,\x0a"
"  _UVRSR_NOT_IMPLEMENTED = 1,\x0a"
"  _UVRSR_FAILED = 2\x0a"
"} _Unwind_VRS_Result;\x0a"
"\x0a"
"extern void _Unwind_Complete(_Unwind_Exception* exception_object);\x0a"
"\x0a"
"extern _Unwind_VRS_Result\x0a"
"_Unwind_VRS_Get(_Unwind_Context *context, _Unwind_VRS_RegClass regclass,\x0a"
"                uint32_t regno, _Unwind_VRS_DataRepresentation representation,\x0a"
"                void *valuep);\x0a"
"\x0a"
"extern _Unwind_VRS_Result\x0a"
"_Unwind_VRS_Set(_Unwind_Context *context, _Unwind_VRS_RegClass regclass,\x0a"
"                uint32_t regno, _Unwind_VRS_DataRepresentation representation,\x0a"
"                void *valuep);\x0a"
"\x0a"
"extern _Unwind_VRS_Result\x0a"
"_Unwind_VRS_Pop(_Unwind_Context *context, _Unwind_VRS_RegClass regclass,\x0a"
"                uint32_t discriminator,\x0a"
"                _Unwind_VRS_DataRepresentation representation);\x0a"
"#endif\x0a"
"\x0a"
"#if \x21_LIBUNWIND_ARM_EHABI\x0a"
"\x0a"
"extern uintptr_t _Unwind_GetGR(struct _Unwind_Context *context, int index);\x0a"
"extern void _Unwind_SetGR(struct _Unwind_Context *context, int index,\x0a"
"                          uintptr_t new_value);\x0a"
"extern uintptr_t _Unwind_GetIP(struct _Unwind_Context *context);\x0a"
"extern void _Unwind_SetIP(struct _Unwind_Context *, uintptr_t new_value);\x0a"
"\x0a"
"#else  // _LIBUNWIND_ARM_EHABI\x0a"
"\x0a"
"#if defined(_LIBUNWIND_UNWIND_LEVEL1_EXTERNAL_LINKAGE)\x0a"
"#define _LIBUNWIND_EXPORT_UNWIND_LEVEL1 extern\x0a"
"#else\x0a"
"#define _LIBUNWIND_EXPORT_UNWIND_LEVEL1 static __inline__\x0a"
"#endif\x0a"
"\x0a"
"// These are de facto helper functions for ARM, which delegate the function\x0a"
"// calls to _Unwind_VRS_Get/Set().  These are not a part of ARM EHABI\x0a"
"// specification, thus these function MUST be inlined.  Please don't replace\x0a"
"// these with the \x22""extern\x22 function declaration; otherwise, the program\x0a"
"// including this <unwind.h> header won't be ABI compatible and will result in\x0a"
"// link error when we are linking the program with libgcc.\x0a"
"\x0a"
"_LIBUNWIND_EXPORT_UNWIND_LEVEL1\x0a"
"uintptr_t _Unwind_GetGR(struct _Unwind_Context *context, int index) {\x0a"
"  uintptr_t value = 0;\x0a"
"  _Unwind_VRS_Get(context, _UVRSC_CORE, (uint32_t)index, _UVRSD_UINT32, \x26value);\x0a"
"  return value;\x0a"
"}\x0a"
"\x0a"
"_LIBUNWIND_EXPORT_UNWIND_LEVEL1\x0a"
"void _Unwind_SetGR(struct _Unwind_Context *context, int index,\x0a"
"                   uintptr_t value) {\x0a"
"  _Unwind_VRS_Set(context, _UVRSC_CORE, (uint32_t)index, _UVRSD_UINT32, \x26value);\x0a"
"}\x0a"
"\x0a"
"_LIBUNWIND_EXPORT_UNWIND_LEVEL1\x0a"
"uintptr_t _Unwind_GetIP(struct _Unwind_Context *context) {\x0a"
"  // remove the thumb-bit before returning\x0a"
"  return _Unwind_GetGR(context, 15) \x26 (\x7e(uintptr_t)0x1);\x0a"
"}\x0a"
"\x0a"
"_LIBUNWIND_EXPORT_UNWIND_LEVEL1\x0a"
"void _Unwind_SetIP(struct _Unwind_Context *context, uintptr_t value) {\x0a"
"  uintptr_t thumb_bit = _Unwind_GetGR(context, 15) \x26 ((uintptr_t)0x1);\x0a"
"  _Unwind_SetGR(context, 15, value \x7c thumb_bit);\x0a"
"}\x0a"
"#endif  // _LIBUNWIND_ARM_EHABI\x0a"
"\x0a"
"extern uintptr_t _Unwind_GetRegionStart(struct _Unwind_Context *context);\x0a"
"extern uintptr_t\x0a"
"    _Unwind_GetLanguageSpecificData(struct _Unwind_Context *context);\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_SjLj_ForcedUnwind(_Unwind_Exception *exception_object,\x0a"
"                              _Unwind_Stop_Fn stop, void *stop_parameter);\x0a"
"#else\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_ForcedUnwind(_Unwind_Exception *exception_object,\x0a"
"                         _Unwind_Stop_Fn stop, void *stop_parameter);\x0a"
"#endif\x0a"
"\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"typedef struct _Unwind_FunctionContext *_Unwind_FunctionContext_t;\x0a"
"extern void _Unwind_SjLj_Register(_Unwind_FunctionContext_t fc);\x0a"
"extern void _Unwind_SjLj_Unregister(_Unwind_FunctionContext_t fc);\x0a"
"#endif\x0a"
"\x0a"
"//\x0a"
"// The following are semi-suppoted extensions to the C++ ABI\x0a"
"//\x0a"
"\x0a"
"//\x0a"
"//  called by __cxa_rethrow().\x0a"
"//\x0a"
"#ifdef __USING_SJLJ_EXCEPTIONS__\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_SjLj_Resume_or_Rethrow(_Unwind_Exception *exception_object);\x0a"
"#else\x0a"
"extern _Unwind_Reason_Code\x0a"
"    _Unwind_Resume_or_Rethrow(_Unwind_Exception *exception_object);\x0a"
"#endif\x0a"
"\x0a"
"// _Unwind_Backtrace() is a gcc extension that walks the stack and calls the\x0a"
"// _Unwind_Trace_Fn once per frame until it reaches the bottom of the stack\x0a"
"// or the _Unwind_Trace_Fn function returns something other than _URC_NO_REASON.\x0a"
"typedef _Unwind_Reason_Code (*_Unwind_Trace_Fn)(struct _Unwind_Context *,\x0a"
"                                                void *);\x0a"
"extern _Unwind_Reason_Code _Unwind_Backtrace(_Unwind_Trace_Fn, void *);\x0a"
"\x0a"
"// _Unwind_GetCFA is a gcc extension that can be called from within a\x0a"
"// personality handler to get the CFA (stack pointer before call) of\x0a"
"// current frame.\x0a"
"extern uintptr_t _Unwind_GetCFA(struct _Unwind_Context *);\x0a"
"\x0a"
"\x0a"
"// _Unwind_GetIPInfo is a gcc extension that can be called from within a\x0a"
"// personality handler.  Similar to _Unwind_GetIP() but also returns in\x0a"
"// *ipBefore a non-zero value if the instruction pointer is at or before the\x0a"
"// instruction causing the unwind. Normally, in a function call, the IP returned\x0a"
"// is the return address which is after the call instruction and may be past the\x0a"
"// end of the function containing the call instruction.\x0a"
"extern uintptr_t _Unwind_GetIPInfo(struct _Unwind_Context *context,\x0a"
"                                   int *ipBefore);\x0a"
"\x0a"
"\x0a"
"// __register_frame() is used with dynamically generated code to register the\x0a"
"// FDE for a generated (JIT) code.  The FDE must use pc-rel addressing to point\x0a"
"// to its function and optional LSDA.\x0a"
"// __register_frame() has existed in all versions of Mac OS X, but in 10.4 and\x0a"
"// 10.5 it was buggy and did not actually register the FDE with the unwinder.\x0a"
"// In 10.6 and later it does register properly.\x0a"
"extern void __register_frame(const void *fde);\x0a"
"extern void __deregister_frame(const void *fde);\x0a"
"\x0a"
"// _Unwind_Find_FDE() will locate the FDE if the pc is in some function that has\x0a"
"// an associated FDE. Note, Mac OS X 10.6 and later, introduces \x22""compact unwind\x0a"
"// info\x22 which the runtime uses in preference to DWARF unwind info.  This\x0a"
"// function will only work if the target function has an FDE but no compact\x0a"
"// unwind info.\x0a"
"struct dwarf_eh_bases {\x0a"
"  uintptr_t tbase;\x0a"
"  uintptr_t dbase;\x0a"
"  uintptr_t func;\x0a"
"};\x0a"
"extern const void *_Unwind_Find_FDE(const void *pc, struct dwarf_eh_bases *);\x0a"
"\x0a"
"\x0a"
"// This function attempts to find the start (address of first instruction) of\x0a"
"// a function given an address inside the function.  It only works if the\x0a"
"// function has an FDE (DWARF unwind info).\x0a"
"// This function is unimplemented on Mac OS X 10.6 and later.  Instead, use\x0a"
"// _Unwind_Find_FDE() and look at the dwarf_eh_bases.func result.\x0a"
"extern void *_Unwind_FindEnclosingFunction(void *pc);\x0a"
"\x0a"
"// Mac OS X does not support text-rel and data-rel addressing so these functions\x0a"
"// are unimplemented\x0a"
"extern uintptr_t _Unwind_GetDataRelBase(struct _Unwind_Context *context)\x0a"
"    LIBUNWIND_UNAVAIL;\x0a"
"extern uintptr_t _Unwind_GetTextRelBase(struct _Unwind_Context *context)\x0a"
"    LIBUNWIND_UNAVAIL;\x0a"
"\x0a"
"// Mac OS X 10.4 and 10.5 had implementations of these functions in\x0a"
"// libgcc_s.dylib, but they never worked.\x0a"
"/// These functions are no longer available on Mac OS X.\x0a"
"extern void __register_frame_info_bases(const void *fde, void *ob, void *tb,\x0a"
"                                        void *db) LIBUNWIND_UNAVAIL;\x0a"
"extern void __register_frame_info(const void *fde, void *ob)\x0a"
"    LIBUNWIND_UNAVAIL;\x0a"
"extern void __register_frame_info_table_bases(const void *fde, void *ob,\x0a"
"                                              void *tb, void *db)\x0a"
"    LIBUNWIND_UNAVAIL;\x0a"
"extern void __register_frame_info_table(const void *fde, void *ob)\x0a"
"    LIBUNWIND_UNAVAIL;\x0a"
"extern void __register_frame_table(const void *fde)\x0a"
"    LIBUNWIND_UNAVAIL;\x0a"
"extern void *__deregister_frame_info(const void *fde)\x0a"
"    LIBUNWIND_UNAVAIL;\x0a"
"extern void *__deregister_frame_info_bases(const void *fde)\x0a"
"    LIBUNWIND_UNAVAIL;\x0a"
"\x0a"
"#ifdef __cplusplus\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#endif // __UNWIND_H__\x0a"
"", 13172 ); }