#include <string_view>
namespace divine::str::dios {
extern const std::string_view rst_lart_cpp( 
"#include <rst/lart.h>\x0a"
"#include <sys/task.h>\x0a"
"\x0a"
"#include <rst/common.hpp>\x0a"
"\x0a"
"#include <string.h>\x0a"
"\x0a"
"using namespace __dios\x3a\x3arst\x3a\x3a""abstract;\x0a"
"\x0a"
"/* Abstract versions of arguments and return values are passed in a 'stash', a\x0a"
" * global (per-thread) location. On 'unstash', we clear the stash for two\x0a"
" * reasons\x3a 1) it flags up otherwise hard-to-pin bugs where mismatched\x0a"
" * stash/unstash reads an old value of the stash, and 2) when verification\x0a"
" * encounters a possible diamond (the explicit content of the state is the\x0a"
" * same, e.g.  after an if/else) and we leave old stashes around, it might so\x0a"
" * happen that the stashed values in the candidate states are of different\x0a"
" * types, leading to a type mismatch in the comparison.\x0a"
" *\x0a"
" * TODO The second problem might have to be tackled in the verification\x0a"
" * algorithm anyway, since there might be other ways to trigger the same\x0a"
" * problem. */\x0a"
"\x0a"
"extern \x22""C\x22\x0a"
"{\x0a"
"    _LART_INTERFACE void * __lart_unstash()\x0a"
"    {\x0a"
"        auto \x26stash = __dios_this_task()->__rst_stash;\x0a"
"        auto rv = stash;\x0a"
"        stash = nullptr;\x0a"
"        return rv;\x0a"
"    }\x0a"
"\x0a"
"    _LART_INTERFACE void __lart_stash( void *val )\x0a"
"    {\x0a"
"        __dios_this_task()->__rst_stash = val;\x0a"
"    }\x0a"
"\x0a"
"    _LART_INTERFACE void __lart_freeze( void *value, void * addr )\x0a"
"    {\x0a"
"        poke_object( value, addr );\x0a"
"    }\x0a"
"\x0a"
"    _LART_INTERFACE void * __lart_thaw( void * addr )\x0a"
"    {\x0a"
"        return peek_object< void * >( addr );\x0a"
"    }\x0a"
"\x0a"
"\x0a"
"\x0a"
"    #define operation( name ) \x5c\x0a"
"        _LART_NOINLINE_WEAK \x5c\x0a"
"        uint8_t __lart_abstract_ ## name () { \x5c\x0a"
"            return 0; /* correct index is generated by lart */ \x5c\x0a"
"        }\x0a"
"\x0a"
"    operation( op_load )\x0a"
"    operation( op_store )\x0a"
"    operation( op_gep )\x0a"
"    operation( op_alloca )\x0a"
"    operation( op_int_to_fp )\x0a"
"    operation( op_fp_to_int )\x0a"
"\x0a"
"\x0a"
"    _LART_NOINLINE_WEAK\x0a"
"    void * __lart_get_domain_operation( uint32_t /*domain*/, uint32_t /*op_index*/ ) {\x0a"
"        return nullptr; // implementation is generated by lart\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"/* lifter templates */\x0a"
"\x0a"
"using abstract_t = void *;\x0a"
"\x0a"
"using alloca_op = abstract_t ( abstract_t size , size_t bitwidth );\x0a"
"using load_op = abstract_t ( abstract_t val, size_t bitwidth );\x0a"
"using store_op = void ( abstract_t val, abstract_t addr, size_t bitwidth );\x0a"
"using gep_op = abstract_t ( size_t base, abstract_t addr, abstract_t off );\x0a"
"\x0a"
"using int_to_fp_op = abstract_t ( abstract_t ptr, abstract_t bitwidth );\x0a"
"using fp_to_int_op = abstract_t ( abstract_t ptr, abstract_t bitwidth );\x0a"
"\x0a"
"template< typename op_t >\x0a"
"auto get_operation( uint8_t domain, uint8_t op_index ) noexcept\x0a"
"{\x0a"
"    return reinterpret_cast< op_t * >( __lart_get_domain_operation( domain, op_index ) );\x0a"
"}\x0a"
"\x0a"
"template< typename concrete_t >\x0a"
"struct argument_t { bool tainted; concrete_t concrete; abstract_t abstract; };\x0a"
"\x0a"
"template< typename concrete_t >\x0a"
"argument_t( bool b, concrete_t c, abstract_t a ) -> argument_t< concrete_t >;\x0a"
"\x0a"
"#if 0\x0a"
"template< typename value_t >\x0a"
"_LART_INLINE\x0a"
"value_t __lart_load_lifter_impl( abstract_t addr )\x0a"
"{\x0a"
"    auto op = __lart_abstract_op_load();\x0a"
"    auto load = get_operation< load_op >( domain( object( addr ) ), op );\x0a"
"    __lart_stash( load( addr, bitwidth< value_t >() ) );\x0a"
"    return taint< value_t >();\x0a"
"}\x0a"
"\x0a"
"#define LART_LOAD_LIFTER( name, value_t ) \x5c\x0a"
"    _LART_INTERFACE \x5c\x0a"
"    value_t __lart_load_lifter_ ##name( abstract_t a_addr ) \x5c\x0a"
"    { \x5c\x0a"
"        return __lart_load_lifter_impl< value_t >( a_addr ); \x5c\x0a"
"    }\x0a"
"\x0a"
"template< typename value_t >\x0a"
"_LART_INLINE\x0a"
"void __lart_store_lifter_impl( argument_t< value_t > value\x0a"
"                             , argument_t< void * > addr )\x0a"
"{\x0a"
"    auto bw = bitwidth< value_t >();\x0a"
"    if ( \x21""addr.tainted ) { // therefore value is abstract\x0a"
"        __lart_freeze( value.abstract, addr.concrete );\x0a"
"        return;\x0a"
"    }\x0a"
"\x0a"
"    auto op = __lart_abstract_op_store();\x0a"
"    auto store = get_operation< store_op >( domain( addr.abstract ), op );\x0a"
"    abstract_t val = value.tainted \x3f value.abstract \x3a constant_t\x3a\x3alift( value.concrete );\x0a"
"    store( val, addr.abstract, bw );\x0a"
"}\x0a"
"\x0a"
"#define LART_STORE_LIFTER( name, T ) \x5c\x0a"
"    __invisible \x5c\x0a"
"    void __lart_store_lifter_ ##name( bool taint_value, T value, abstract_t a_value \x5c\x0a"
"                                    , bool taint_addr, void * addr, abstract_t a_addr ) \x5c\x0a"
"    { \x5c\x0a"
"        __lart_store_lifter_impl< T >( { taint_value, value, a_value } \x5c\x0a"
"                                     , { taint_addr, addr, a_addr } ); \x5c\x0a"
"    }\x0a"
"\x0a"
"template< typename value_t >\x0a"
"_LART_INLINE\x0a"
"abstract_t __lart_gep_lifter_impl( argument_t< void * > ptr\x0a"
"                                 , argument_t< value_t > off\x0a"
"                                 , size_t base )\x0a"
"{\x0a"
"    if ( \x21ptr.tainted ) { // offset is tainted\x0a"
"        __dios_fault( _VM_Fault\x3a\x3a_VM_F_Control, \x22unsupported abstract offset of concrete pointer\x22 );\x0a"
"        return nullptr;\x0a"
"    }\x0a"
"\x0a"
"    auto op = __lart_abstract_op_gep();\x0a"
"    auto gep = get_operation< gep_op >( domain( ptr.abstract ), op );\x0a"
"    auto offset = off.tainted \x3f off.abstract \x3a constant_t\x3a\x3alift( off.concrete );\x0a"
"\x0a"
"    // TODO\x3a correct bytewise index\x0a"
"    __lart_stash( gep( base, ptr.abstract, offset ) );\x0a"
"    return taint< abstract_t >();\x0a"
"}\x0a"
"\x0a"
"#define LART_GEP_LIFTER( off_t ) \x5c\x0a"
"    __invisible \x5c\x0a"
"    abstract_t __lart_gep_lifter( bool taint_ptr, void * ptr, abstract_t a_ptr \x5c\x0a"
"                                , bool taint_off, off_t off, abstract_t a_off \x5c\x0a"
"                                , size_t base ) \x5c\x0a"
"    { \x5c\x0a"
"        return __lart_gep_lifter_impl< uint64_t >( { taint_ptr, ptr, a_ptr } \x5c\x0a"
"                                                 , { taint_off, off, a_off } \x5c\x0a"
"                                                 , base ); \x5c\x0a"
"    }\x0a"
"\x0a"
"template< typename int_t >\x0a"
"_LART_INLINE\x0a"
"abstract_t __lart_int_to_fp_impl( abstract_t a_int )\x0a"
"{\x0a"
"    auto op = __lart_abstract_op_int_to_fp();\x0a"
"    auto to_fp = get_operation< int_to_fp_op >( domain( a_int ), op );\x0a"
"    auto bw = constant_t\x3a\x3alift( bitwidth< int_t >() );\x0a"
"    return to_fp( a_int, bw );\x0a"
"}\x0a"
"\x0a"
"#define LART_INT_TO_FP( name, float_t ) \x5c\x0a"
"    __invisible \x5c\x0a"
"    abstract_t __lart_int_to_ ## name( abstract_t a_int ) \x5c\x0a"
"    { \x5c\x0a"
"        return __lart_int_to_fp_impl< float_t >( a_int ); \x5c\x0a"
"    }\x0a"
"\x0a"
"template< typename int_t >\x0a"
"_LART_INLINE\x0a"
"abstract_t __lart_fp_to_int_impl( abstract_t fp)\x0a"
"{\x0a"
"    auto op = __lart_abstract_op_fp_to_int();\x0a"
"    auto to_int = get_operation< fp_to_int_op >( domain( fp ), op );\x0a"
"    auto bw = constant_t\x3a\x3alift( bitwidth< int_t >() );\x0a"
"    return to_int( fp, bw );\x0a"
"}\x0a"
"\x0a"
"#define LART_FP_TO_INT( name, int_t ) \x5c\x0a"
"    __invisible \x5c\x0a"
"    abstract_t __lart_fp_to_ ## name( abstract_t fp ) \x5c\x0a"
"    { \x5c\x0a"
"        return __lart_fp_to_int_impl< int_t >( fp ); \x5c\x0a"
"    }\x0a"
"\x0a"
"extern \x22""C\x22 {\x0a"
"\x0a"
"    _LART_INTERFACE\x0a"
"    void *__lart_alloca_lifter( abstract_t a_size, size_t bw )\x0a"
"    {\x0a"
"        auto op = __lart_abstract_op_alloca();\x0a"
"        auto alloc = get_operation< alloca_op >( domain( object( a_size ) ), op );\x0a"
"        __lart_stash( alloc( a_size, bw ) );\x0a"
"        return taint< void * >( nullptr );\x0a"
"    }\x0a"
"\x0a"
"    LART_STORE_LIFTER(  i8, uint8_t )\x0a"
"    LART_STORE_LIFTER( i16, uint16_t )\x0a"
"    LART_STORE_LIFTER( i32, uint32_t )\x0a"
"    LART_STORE_LIFTER( i64, uint64_t )\x0a"
"\x0a"
"    LART_LOAD_LIFTER(  i8, uint8_t )\x0a"
"    LART_LOAD_LIFTER( i16, uint16_t )\x0a"
"    LART_LOAD_LIFTER( i32, uint32_t )\x0a"
"    LART_LOAD_LIFTER( i64, uint64_t )\x0a"
"\x0a"
"    LART_GEP_LIFTER( uint64_t )\x0a"
"\x0a"
"    LART_FP_TO_INT( i8, uint8_t )\x0a"
"    LART_FP_TO_INT( i16, uint16_t )\x0a"
"    LART_FP_TO_INT( i32, uint32_t )\x0a"
"    LART_FP_TO_INT( i64, uint64_t )\x0a"
"\x0a"
"    LART_INT_TO_FP( float, float )\x0a"
"    LART_INT_TO_FP( double, double )\x0a"
"}\x0a"
"#endif\x0a"
"", 7408 ); }