#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_boot_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
" *     2016 Vladimir Still <xstill\x40""fi.muni.cz>\x0a"
" *     2016, 2019 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#include <algorithm>\x0a"
"#include <unistd.h>\x0a"
"\x0a"
"#include <sys/utsname.h>\x0a"
"#include <sys/bitcode.h>\x0a"
"#include <sys/metadata.h>\x0a"
"\x0a"
"#include <dios.h>\x0a"
"#include <dios/sys/options.hpp>\x0a"
"\x0a"
"#include <dios/vfs/manager.h>\x0a"
"\x0a"
"/* This file implements the boot sequence of DiOS. The real entrypoint is\x0a"
" * extern \x22""C\x22 __boot(), implemented in config. It doesn't do anything other\x0a"
" * than call __dios\x3a\x3a""boot with the correct template parameter. Most of this\x0a"
" * file is concerned with parsing the environment passed down by the platform. */\x0a"
"\x0a"
"extern \x22""C\x22 void *__dios_term_init();\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"    void trace_option( int i, std\x3a\x3astring_view opt, std\x3a\x3astring_view desc,\x0a"
"                       const Array< std\x3a\x3astring_view >\x26 args )\x0a"
"    {\x0a"
"        __dios_trace_i( i, \x22- \x25.*s\x3a \x25.*s\x22,\x0a"
"                        int( opt.size() ), opt.begin(), int( desc.size() ), desc.begin() );\x0a"
"        __dios_trace_i( i, \x22  arguments\x3a\x22 );\x0a"
"        for ( const auto\x26 arg \x3a args )\x0a"
"            __dios_trace_i( i, \x22   - \x25.*s\x22, int( arg.size() ), arg.begin() );\x0a"
"    }\x0a"
"\x0a"
"    void trace_help( int i, const ArrayMap< std\x3a\x3astring_view, HelpOption >\x26 help )\x0a"
"    {\x0a"
"        for ( const auto\x26 option \x3a help )\x0a"
"            trace_option( i, option.first, option.second.description,\x0a"
"                          option.second.options );\x0a"
"    }\x0a"
"\x0a"
"    void trace_env( int ind, const _VM_Env *env )\x0a"
"    {\x0a"
"        __dios_trace_i( ind, \x22raw env options\x3a\x22 );\x0a"
"        for ( ; env->key; env++ ) {\x0a"
"            __dios_trace_i( ind + 1, \x22\x25s\x3a \x5c\x22\x25.*s\x5c\x22\x22, env->key, env->size, env->value );\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    void temporary_scheduler()\x0a"
"    {\x0a"
"        __vm_cancel();\x0a"
"    }\x0a"
"\x0a"
"    void temporary_fault( _VM_Fault, _VM_Frame *, void (*)() )\x0a"
"    {\x0a"
"        __vm_ctl_flag( 0, _VM_CF_Error );\x0a"
"        __vm_ctl_set( _VM_CR_Scheduler, nullptr );\x0a"
"        __dios_this_frame()->parent = nullptr;\x0a"
"    }\x0a"
"\x0a"
"    /* The configuration-specific (but platform-neutral) entry point.\x0a"
"     * Instantiated in \x60""dios/config/\x3f.cpp\x60. Handles environment parsing and\x0a"
"     * basic platform setup and then creates an instance of the configuration\x0a"
"     * stack. After boot() is done, the platform is expected to call the\x0a"
"     * scheduler. This is either done by a platform-specific entry point (e.g.\x0a"
"     * \x60klee_boot\x60) or by the platform itself (e.g. DiVM). */\x0a"
"\x0a"
"    template < typename Configuration >\x0a"
"    void boot( const _VM_Env *env )\x0a"
"    {\x0a"
"        /* On DiVM, addresses of objects obtained from __vm_obj_make depend on\x0a"
"         * the execution history until that point. If two executions differ in\x0a"
"         * just a single system call, the object numbering will be different\x0a"
"         * and things that depend on it will change behaviour. This used to\x0a"
"         * cause problems with counterexample replays. This causes memory for\x0a"
"         * persistent objects to be allocated before any decisions based on\x0a"
"         * configuration options are made. I also think this is no longer\x0a"
"         * needed on modern DiVM with dbg.call and with counterexamples\x0a"
"         * embedded in verification reports. */\x0a"
"\x0a"
"        MemoryPool deterministic_memory( 2 );\x0a"
"        SysOpts opt;\x0a"
"\x0a"
"        __vm_ctl_set( _VM_CR_User1, nullptr );\x0a"
"        __vm_ctl_set( _VM_CR_FaultHandler, reinterpret_cast< void * >( temporary_fault ) );\x0a"
"        __vm_ctl_set( _VM_CR_Scheduler, reinterpret_cast< void * >( temporary_scheduler ) );\x0a"
"\x0a"
"        if ( \x21parse_sys_options( env, opt ) )\x0a"
"        {\x0a"
"            __vm_ctl_flag( 0, _VM_CF_Error );\x0a"
"            return;\x0a"
"        }\x0a"
"\x0a"
"        auto *context = new Configuration();\x0a"
"        __vm_trace( _VM_T_StateType, context );\x0a"
"        traceAlias< Configuration >( \x22{Context}\x22 );\x0a"
"        __vm_ctl_set( _VM_CR_State, context );\x0a"
"\x0a"
"        if ( extract_opt( \x22""debug\x22, \x22help\x22, opt ) ) /* please send hulp */\x0a"
"        {\x0a"
"            ArrayMap< std\x3a\x3astring_view, HelpOption > help;\x0a"
"\x0a"
"            help.emplace( \x22""debug\x22, HelpOption\x0a"
"                          { \x22print debug information during boot\x22,\x0a"
"                             { \x22help - help of selected configuration and exit\x22,\x0a"
"                               // ToDo\x3a trace binary blobs\x0a"
"                               /*\x22rawenvironment - user DiOS boot parameters\x22,*/\x0a"
"                               \x22machineparams - specified by user, e.g. number of cpus\x22,\x0a"
"                               \x22mainargs - argv and envp\x22,\x0a"
"                               \x22""faultcfg - fault and simfail configuration\x22 } } );\x0a"
"\x0a"
"            context->getHelp( help );\x0a"
"            trace_help( 0, help );\x0a"
"            __vm_cancel();\x0a"
"            return;\x0a"
"        }\x0a"
"\x0a"
"        if ( extract_opt( \x22""debug\x22, \x22rawenvironment\x22, opt ) )\x0a"
"            trace_env( 1, env );\x0a"
"\x0a"
"        /* The Setup structure is passed down the stack and each component in\x0a"
"         * turn parses the options that it understands and removes them from\x0a"
"         * .opts. If some options remain when we hit bottom, that's an error.\x0a"
"         * The structure is passed by value, hence the removal of options does\x0a"
"         * not propagate back up. */\x0a"
"        Setup< Configuration > s = SetupBase{ .pool = \x26""deterministic_memory,\x0a"
"                                              .env = env, .opts = opt };\x0a"
"\x0a"
"        __vm_trace( _VM_T_Constraints, __dios_term_init() );\x0a"
"\x0a"
"        /* The first process is special and is created during boot. Other\x0a"
"         * processes can only be created using \x60""fork\x60. Components that maintain\x0a"
"         * per-process data should initialize their fields in proc1. The\x0a"
"         * Process structure itself is stacked the same way the configuration\x0a"
"         * stack is. */\x0a"
"        s.proc1 = new typename Configuration\x3a\x3aProcess();\x0a"
"        context->setup( s );\x0a"
"    }\x0a"
"}\x0a"
"", 6475 ); }