#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_clock_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"#include <dios/sys/syscall.hpp>\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"    /* Simulate clocks. Tick (or not) whenever the clock is observed, depending\x0a"
"     * on the configuration. See \x60""configure\x60. Supports symbolic and\x0a"
"     * non-deterministic clocks, and also setting the time. TODO Only currently\x0a"
"     * deals with whole seconds, we may want to do something about usec/nsec\x0a"
"     * values. */\x0a"
"\x0a"
"    template< typename Next >\x0a"
"    struct Clock \x3a Next\x0a"
"    {\x0a"
"        enum { Fixed, DetTick, NDetTick, Sym, Sloppy } _clock_mode = Fixed;\x0a"
"        int _clock_delta = 0;\x0a"
"        short _clock_ticks = 0, _clock_max_ticks = 3;\x0a"
"\x0a"
"        time_t _clock_mbase = 1262277040, /* monotonic */\x0a"
"               _clock_rbase = _clock_mbase; /* real-time */\x0a"
"\x0a"
"        struct timezone _clock_tz = { 0, 1 };\x0a"
"\x0a"
"        void configure( SysOpts \x26opts )\x0a"
"        {\x0a"
"            auto sv = extract_opt( \x22""clock-type\x22, opts );\x0a"
"            auto mt = extract_opt( \x22""clock-maxticks\x22, opts );\x0a"
"            auto base = extract_opt( \x22""clock-start\x22, opts );\x0a"
"\x0a"
"            if ( sv.empty() \x7c\x7c sv == \x22""fixed\x22 )\x0a"
"                _clock_mode = Fixed;\x0a"
"            else if ( sv == \x22""det\x22 )\x0a"
"                _clock_mode = DetTick;\x0a"
"            else if ( sv == \x22ndet\x22 )\x0a"
"                _clock_mode = NDetTick;\x0a"
"            else if ( sv == \x22sym\x22 )\x0a"
"                _clock_mode = Sym;\x0a"
"            else if ( sv == \x22sloppy\x22 )\x0a"
"                _clock_mode = Sloppy;\x0a"
"            else\x0a"
"                __dios_fault( _DiOS_F_Config, \x22invalid clock type\x22 );\x0a"
"\x0a"
"            if ( \x21mt.empty() )\x0a"
"                _clock_max_ticks = _DIVINE_strtol( mt.begin(), mt.size(), nullptr );\x0a"
"            if ( \x21""base.empty() )\x0a"
"                _clock_mbase = _clock_rbase = _DIVINE_strtol( base.begin(), base.size(), nullptr );\x0a"
"        }\x0a"
"\x0a"
"        template< typename Setup >\x0a"
"        void setup( Setup s )\x0a"
"        {\x0a"
"            traceAlias< Clock >( \x22{Clock}\x22 );\x0a"
"            configure( s.opts );\x0a"
"            Next\x3a\x3asetup( s );\x0a"
"        }\x0a"
"\x0a"
"        int gettimeofday( struct timeval *tp, struct timezone *tzp )\x0a"
"        {\x0a"
"            if ( tp )\x0a"
"            {\x0a"
"                tp->tv_sec = _clock_rbase + _clock_delta;\x0a"
"                tp->tv_usec = 0;\x0a"
"                clock_tick();\x0a"
"            }\x0a"
"\x0a"
"            if ( tzp )\x0a"
"                *tzp = _clock_tz;\x0a"
"\x0a"
"            return 0;\x0a"
"        }\x0a"
"\x0a"
"        int settimeofday( const struct timeval *tp, const struct timezone *tzp )\x0a"
"        {\x0a"
"            if ( tp )\x0a"
"                _clock_rbase = tp->tv_sec - _clock_delta;\x0a"
"\x0a"
"            if ( tzp )\x0a"
"                _clock_tz = *tzp;\x0a"
"\x0a"
"            return 0;\x0a"
"        }\x0a"
"\x0a"
"        int clock_gettime( clockid_t id, struct timespec *sp )\x0a"
"        {\x0a"
"            sp->tv_nsec = 0;\x0a"
"\x0a"
"            switch ( id )\x0a"
"            {\x0a"
"                case CLOCK_REALTIME\x3a\x0a"
"                    sp->tv_sec = _clock_rbase + _clock_delta; break;\x0a"
"                case CLOCK_MONOTONIC\x3a\x0a"
"                case CLOCK_PROCESS_CPUTIME_ID\x3a\x0a"
"                case CLOCK_THREAD_CPUTIME_ID\x3a\x0a"
"                case CLOCK_BOOTTIME\x3a\x0a"
"                case CLOCK_UPTIME\x3a\x0a"
"                    sp->tv_sec = _clock_mbase + _clock_delta; break;\x0a"
"                default\x3a\x0a"
"                    *__dios_errno() = EINVAL; return -1;\x0a"
"            }\x0a"
"\x0a"
"            clock_tick();\x0a"
"            return 0;\x0a"
"        }\x0a"
"\x0a"
"        int clock_settime( clockid_t id, const struct timespec *sp )\x0a"
"        {\x0a"
"            if ( id \x21= CLOCK_REALTIME )\x0a"
"                return *__dios_errno() = EINVAL, -1;\x0a"
"\x0a"
"            if ( sp->tv_nsec < 0 \x7c\x7c sp->tv_nsec > 1'000'000'000 )\x0a"
"                return *__dios_errno() = EINVAL, -1;\x0a"
"\x0a"
"            _clock_rbase = sp->tv_sec - _clock_delta;\x0a"
"            return 0;\x0a"
"        }\x0a"
"\x0a"
"        void clock_tick()\x0a"
"        {\x0a"
"            if ( _clock_mode == Fixed )\x0a"
"                return; /* no ticks */\x0a"
"\x0a"
"            if ( _clock_ticks >= _clock_max_ticks )\x0a"
"                return; /* do nothing */\x0a"
"\x0a"
"            if ( _clock_mode == NDetTick \x26\x26 __vm_choose( 2 ) == 0 )\x0a"
"                return;\x0a"
"\x0a"
"            ++ _clock_ticks;\x0a"
"\x0a"
"            if ( _clock_mode == Sym \x7c\x7c _clock_mode == Sloppy )\x0a"
"            {\x0a"
"                __dios_fault( _VM_F_NotImplemented, \x22symbolic clocks\x22 );\x0a"
"                /*\x0a"
"                int offset = __sym_val_i32();\x0a"
"                if ( offset < 0 )\x0a"
"                    __vm_cancel();\x0a"
"                _clock_delta += offset;\x0a"
"                */\x0a"
"            }\x0a"
"            else\x0a"
"                ++ _clock_delta;\x0a"
"            /*\x0a"
"            if ( _clock_mode == Sloppy )\x0a"
"            {\x0a"
"                _clock_rbase = __sym_val_i64();\x0a"
"                if ( _clock_rbase < 0 )\x0a"
"                    __vm_cancel;\x0a"
"            }\x0a"
"            */\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"}\x0a"
"", 5416 ); }