#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_debug_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"#include <cstdint>\x0a"
"#include <cstdarg>\x0a"
"\x0a"
"#include <util/map.hpp>\x0a"
"#include <dios.h>\x0a"
"#include <dios/sys/kobject.hpp>\x0a"
"\x0a"
"#define DIOS_DBG( ... ) __dios_trace_f( __VA_ARGS__ )\x0a"
"\x0a"
"extern \x22""C\x22 void __dios_assert_debug() noexcept;\x0a"
"\x0a"
"/* Data that is not part of the execution of the system, but instead only\x0a"
" * serves to generate human-readable outputs during counterexample generation.\x0a"
" * None of this is instantiated during standard execution, since the code that\x0a"
" * uses the data is hidden in \x60""dbg.call\x60 instructions, which are in turn\x0a"
" * generated from the \x60__debugfn\x60 annotations in the source code. A function\x0a"
" * that is annotated with \x60__debugfn\x60 switches the VM into a \xe2\x80\x98""debug mode\xe2\x80\x99 in\x0a"
" * which the program is not allowed to make any persistent changes to data\x0a"
" * outside of objects are allocated as \xe2\x80\x98weak\xe2\x80\x99 (see also \x60""DbgObject\x60). */\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"    struct Debug \x3a DbgObject\x0a"
"    {\x0a"
"        AutoIncMap< __dios_task, int, _VM_PT_Weak > hids;\x0a"
"        ArrayMap< __dios_task, short, _VM_PT_Weak > trace_indent;\x0a"
"        ArrayMap< __dios_task, short, _VM_PT_Weak > trace_inhibit;\x0a"
"        ArrayMap< __dios_task, Array< char, _VM_PT_Weak >, _VM_PT_Weak > trace_buf;\x0a"
"        short kernel_indent = 0;\x0a"
"        void persist();\x0a"
"        void persist_buffers();\x0a"
"    };\x0a"
"\x0a"
"    static inline bool debug_mode() noexcept\x0a"
"    {\x0a"
"        return __vm_ctl_flag( 0, 0 ) \x26 _VM_CF_DebugMode;\x0a"
"    }\x0a"
"\x0a"
"    static inline bool have_debug() noexcept\x0a"
"    {\x0a"
"        return debug_mode() \x26\x26 __vm_ctl_get( _VM_CR_User3 );\x0a"
"    }\x0a"
"\x0a"
"    static inline Debug \x26get_debug() noexcept\x0a"
"    {\x0a"
"        if ( debug_mode() \x26\x26 \x21have_debug() )\x0a"
"        {\x0a"
"            __vm_trace( _VM_T_Text, \x22have_debug() failed in debug mode\x22 );\x0a"
"            __vm_ctl_set( _VM_CR_Flags, 0 ); /* fault \x26 force abandonment of the debug call */\x0a"
"        }\x0a"
"        __dios_assert_debug();\x0a"
"        void *dbg = __vm_ctl_get( _VM_CR_User3 );\x0a"
"        return *static_cast< Debug * >( dbg );\x0a"
"    }\x0a"
"\x0a"
"}\x0a"
"", 2774 ); }