#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_fault_cpp( 
"// -*- C++ -*- (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"//                 2016 Vladimir Still <xstill\x40""fi.muni.cz>\x0a"
"\x0a"
"#include <cstdint>\x0a"
"#include <dios/sys/fault.hpp>\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"    void FaultBase\x3a\x3aupdateSimFail( uint8_t *config )\x0a"
"    {\x0a"
"        config = config \x3f config \x3a this->config();\x0a"
"        uint8_t flags = 0;\x0a"
"        uint8_t bit = 1;\x0a"
"        for ( int x = _DiOS_SF_First; x \x21= _DiOS_SF_Last; x++, bit <<= 1 )\x0a"
"            flags \x7c= config\x5b x \x5d \x26 FaultFlag\x3a\x3a""Enabled \x3f bit \x3a 0;\x0a"
"        auto *meta = __md_get_global_meta( \x22__dios_simfail_flags\x22 );\x0a"
"        if ( \x21meta )\x0a"
"            __dios_trace_t( \x22Warning\x3a Cannot update SimFail\x22 );\x0a"
"        else\x0a"
"            *reinterpret_cast< char *>( meta->address ) = flags;\x0a"
"    }\x0a"
"\x0a"
"    void FaultBase\x3a\x3a""backtrace( _VM_Frame * frame )\x0a"
"    {\x0a"
"        if ( ( _flags \x26 PrintBacktrace ) == 0 )\x0a"
"            return;\x0a"
"        __dios_trace_t( \x22""Backtrace\x3a\x22 );\x0a"
"        auto guard = makeMallocNofail();\x0a"
"        char *buffer = static_cast< char * >( malloc( 1024 ) );\x0a"
"        int i = 0;\x0a"
"        for ( auto *f = frame; f \x21= nullptr; f = f->parent )\x0a"
"        {\x0a"
"            const char *name = __md_get_pc_meta( f->pc )->name;\x0a"
"            __dios_trace_f( \x22  \x25""d\x3a \x25s\x22, ++i, name );\x0a"
"        }\x0a"
"        free( buffer );\x0a"
"    }\x0a"
"\x0a"
"    void FaultBase\x3a\x3a""fault_handler( int kernel, _VM_Frame * frame, int what )\x0a"
"    {\x0a"
"        if ( what >= fault_count )\x0a"
"        {\x0a"
"            __dios_trace_t( \x22Unknown fault in handler\x22 );\x0a"
"            die();\x0a"
"        }\x0a"
"\x0a"
"        auto *cfg = config();\x0a"
"        // If no task exists, trigger the fault\x0a"
"        uint8_t fault_cfg = cfg \x3f cfg\x5b what \x5d \x3a FaultFlag\x3a\x3a""Enabled;\x0a"
"\x0a"
"        if ( fault_cfg \x26 FaultFlag\x3a\x3a""Detect )\x0a"
"            __vm_ctl_flag( 0, _DiOS_CF_Fault );\x0a"
"\x0a"
"        if ( \x21( _flags \x26 Ready ) \x7c\x7c fault_cfg \x26 FaultFlag\x3a\x3a""Enabled )\x0a"
"        {\x0a"
"            __vm_ctl_flag( 0, _VM_CF_Error );\x0a"
"            __dios_trace_f( \x22""FATAL\x3a \x25s in \x25s\x22, fault_to_str( what, true ).begin(),\x0a"
"                            kernel \x3f \x22kernel\x22 \x3a \x22userspace\x22 );\x0a"
"            backtrace( frame );\x0a"
"\x0a"
"            if ( \x21( _flags \x26 Ready ) \x7c\x7c \x21( fault_cfg \x26 FaultFlag\x3a\x3a""Continue ) )\x0a"
"                die();\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    int FaultBase\x3a\x3astr_to_fault( std\x3a\x3astring_view fault )\x0a"
"    {\x0a"
"        if ( fault == \x22""assert\x22 )\x0a"
"            return _VM_F_Assert;\x0a"
"        if ( fault == \x22integer\x22 )\x0a"
"            return _VM_F_Integer;\x0a"
"        if ( fault == \x22""float\x22 )\x0a"
"            return _VM_F_Float;\x0a"
"        if ( fault == \x22memory\x22 )\x0a"
"            return _VM_F_Memory;\x0a"
"        if ( fault == \x22ptrcmp\x22 )\x0a"
"            return _VM_F_PtrCompare;\x0a"
"        if ( fault == \x22leak\x22 )\x0a"
"            return _VM_F_Leak;\x0a"
"        if ( fault == \x22""control\x22 )\x0a"
"            return _VM_F_Control;\x0a"
"        if ( fault == \x22locking\x22 )\x0a"
"            return _VM_F_Locking;\x0a"
"        if ( fault == \x22hypercall\x22 )\x0a"
"            return _VM_F_Hypercall;\x0a"
"        if ( fault == \x22notimplemented\x22 )\x0a"
"            return _VM_F_NotImplemented;\x0a"
"        if ( fault == \x22""exit\x22 )\x0a"
"            return static_cast< _VM_Fault >( _DiOS_F_Exit );\x0a"
"        if ( fault == \x22""diosassert\x22 )\x0a"
"            return static_cast< _VM_Fault >( _DiOS_F_Assert );\x0a"
"        if ( fault == \x22""diosconfig\x22 )\x0a"
"            return static_cast< _VM_Fault >( _DiOS_F_Config );\x0a"
"        if ( fault == \x22malloc\x22 )\x0a"
"            return static_cast< _VM_Fault >( _DiOS_SF_Malloc );\x0a"
"        return static_cast< _VM_Fault >( -1 );\x0a"
"    }\x0a"
"\x0a"
"    std\x3a\x3astring_view FaultBase\x3a\x3a""fault_to_str( int f, bool ext )\x0a"
"    {\x0a"
"        switch( f )\x0a"
"        {\x0a"
"            case _VM_F_Assert\x3a return ext \x3f \x22""assertion failure\x22 \x3a \x22""assert\x22;\x0a"
"            case _VM_F_Integer\x3a return ext \x3f \x22integer arithmetic error\x22 \x3a \x22integer\x22;\x0a"
"            case _VM_F_Float\x3a return ext \x3f \x22""floating-point arithmetic error\x22 \x3a \x22""float\x22;\x0a"
"            case _VM_F_Memory\x3a return ext \x3f \x22memory error\x22 \x3a \x22memory\x22;\x0a"
"            case _VM_F_PtrCompare\x3a return ext \x3f \x22pointer comparison\x22 \x3a \x22ptrcmp\x22;\x0a"
"            case _VM_F_Leak\x3a return ext \x3f \x22memory leak\x22 \x3a \x22leak\x22;\x0a"
"            case _VM_F_Control\x3a return ext \x3f \x22""control error\x22 \x3a \x22""control\x22;\x0a"
"            case _VM_F_Locking\x3a return ext \x3f \x22locking error\x22 \x3a \x22locking\x22;\x0a"
"            case _VM_F_Hypercall\x3a return ext \x3f \x22""bad hypercall\x22 \x3a \x22hypercall\x22;\x0a"
"            case _VM_F_NotImplemented\x3a return ext \x3f \x22not implemented\x22 \x3a \x22notimplemented\x22;\x0a"
"            case _DiOS_F_Assert\x3a return ext \x3f \x22""dios assertion violation\x22 \x3a \x22""diosassert\x22;\x0a"
"            case _DiOS_F_Config\x3a return ext \x3f \x22""config error\x22 \x3a \x22""diosconfig\x22;\x0a"
"            case _DiOS_SF_Malloc\x3a return \x22malloc\x22;\x0a"
"        }\x0a"
"        return \x22unknown\x22;\x0a"
"    }\x0a"
"\x0a"
"    void FaultBase\x3a\x3atrace_config( int indent )\x0a"
"    {\x0a"
"        auto config = this->config();\x0a"
"        __dios_trace_i( indent, \x22""fault and simfail configuration\x3a\x22 );\x0a"
"        for (int f = _VM_F_NoFault + 1; f \x21= _DiOS_SF_Last; f++ ) {\x0a"
"            uint8_t cfg = config\x5b""f\x5d;\x0a"
"            std\x3a\x3astring_view name = fault_to_str( f );\x0a"
"            std\x3a\x3astring_view force = cfg \x26 FaultFlag\x3a\x3a""AllowOverride \x3f \x22\x22 \x3a \x22""force-\x22;\x0a"
"            std\x3a\x3astring_view state;\x0a"
"            if ( f >= _DiOS_F_Last )\x0a"
"                state = cfg \x26 FaultFlag\x3a\x3a""Enabled \x3f \x22simfail\x22 \x3a \x22nofail\x22;\x0a"
"            else {\x0a"
"                if ( cfg \x26 FaultFlag\x3a\x3a""Enabled \x26\x26 cfg \x26 FaultFlag\x3a\x3a""Continue )\x0a"
"                    state = \x22report\x22;\x0a"
"                else if ( cfg \x26 FaultFlag\x3a\x3a""Enabled )\x0a"
"                    state = \x22""abort\x22;\x0a"
"                else\x0a"
"                    state = \x22ignore\x22;\x0a"
"            }\x0a"
"            std\x3a\x3astring_view def = cfg \x26 FaultFlag\x3a\x3aUserSpec \x3f \x22user\x22 \x3a \x22""default\x22;\x0a"
"\x0a"
"            __dios_trace_i( indent + 1, \x22\x25s\x3a \x25s\x25s, \x25s\x22, name.begin(), force.begin(),\x0a"
"                                                        state.begin(), def.begin() );\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    void FaultBase\x3a\x3aload_user_pref( uint8_t *config, SysOpts\x26 opts )\x0a"
"    {\x0a"
"        SysOpts unused;\x0a"
"        for ( const auto\x26 i \x3a opts )\x0a"
"        {\x0a"
"            std\x3a\x3astring_view cmd = i.first;\x0a"
"            std\x3a\x3astring_view f = i.second;\x0a"
"\x0a"
"            uint8_t cfg = FaultFlag\x3a\x3a""AllowOverride \x7c FaultFlag\x3a\x3aUserSpec;\x0a"
"            std\x3a\x3astring_view force(\x22""force-\x22);\x0a"
"            if ( cmd.size() > force.size() \x26\x26 std\x3a\x3a""equal( force.begin(), force.end(), cmd.begin() ) ) {\x0a"
"                cfg \x26= \x7e""FaultFlag\x3a\x3a""AllowOverride;\x0a"
"                cmd = cmd.substr( force.size() );\x0a"
"            }\x0a"
"\x0a"
"            bool simfail = false;\x0a"
"            if      ( cmd == \x22ignore\x22 )  { }\x0a"
"            else if ( cmd == \x22report\x22 )  { cfg \x7c= FaultFlag\x3a\x3a""Enabled \x7c FaultFlag\x3a\x3a""Continue; }\x0a"
"            else if ( cmd == \x22""abort\x22 )   { cfg \x7c= FaultFlag\x3a\x3a""Enabled; }\x0a"
"            else if ( cmd == \x22nofail\x22 )  { simfail = true; }\x0a"
"            else if ( cmd == \x22simfail\x22 ) { cfg \x7c= FaultFlag\x3a\x3a""Enabled; simfail = true; }\x0a"
"            else {\x0a"
"                unused.push_back( i );\x0a"
"                continue;\x0a"
"            };\x0a"
"\x0a"
"            int f_num = str_to_fault( f );\x0a"
"            if ( f_num == - 1 )\x0a"
"            {\x0a"
"                __dios_trace( 0, \x22Invalid argument '\x25s' in option '\x25s\x3a\x25s'\x22,\x0a"
"                              f.begin(), cmd.begin(), f.begin() );\x0a"
"                __dios_fault( _DiOS_F_Config, \x22Invalid configuration of fault handler\x22 );\x0a"
"            }\x0a"
"\x0a"
"            if ( simfail \x26\x26 f_num < _DiOS_F_Last )\x0a"
"            {\x0a"
"                __dios_trace( 0, \x22Invalid argument '\x25s' for command '\x25s'\x22,\x0a"
"                              f.begin(), cmd.begin() );\x0a"
"                __dios_fault( _DiOS_F_Config, \x22Invalid configuration of fault handler\x22 );\x0a"
"            }\x0a"
"\x0a"
"            config\x5b f_num \x5d = cfg;\x0a"
"        }\x0a"
"        opts = unused;\x0a"
"        updateSimFail( config );\x0a"
"    }\x0a"
"\x0a"
"    int FaultBase\x3a\x3a_faultToStatus( int fault )\x0a"
"    {\x0a"
"        auto config = this->config();\x0a"
"        uint8_t cfg = config\x5b fault \x5d;\x0a"
"        if ( fault < _DiOS_F_Last) // Fault\x0a"
"        {\x0a"
"            switch ( cfg \x26 ( FaultFlag\x3a\x3a""Enabled \x7c FaultFlag\x3a\x3a""Continue \x7c FaultFlag\x3a\x3a""Detect ) )\x0a"
"            {\x0a"
"                case 0\x3a\x0a"
"                    return _DiOS_FC_Ignore;\x0a"
"                case FaultFlag\x3a\x3a""Enabled\x3a\x0a"
"                    return _DiOS_FC_Abort;\x0a"
"                case FaultFlag\x3a\x3a""Enabled \x7c FaultFlag\x3a\x3a""Continue\x3a\x0a"
"                    return _DiOS_FC_Report;\x0a"
"                case FaultFlag\x3a\x3a""Detect\x3a\x0a"
"                    return _DiOS_FC_Detect;\x0a"
"                default\x3a\x0a"
"                    __builtin_unreachable();\x0a"
"            }\x0a"
"        }\x0a"
"        else // Simfail\x0a"
"        {\x0a"
"            if ( cfg \x7c FaultFlag\x3a\x3a""Enabled )\x0a"
"                return _DiOS_FC_SimFail;\x0a"
"            else\x0a"
"                return _DiOS_FC_NoFail;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    int FaultBase\x3a\x3a""configure_fault( int fault, int cfg )\x0a"
"    {\x0a"
"        auto config = this->config();\x0a"
"        if ( fault >= fault_count )\x0a"
"            return _DiOS_FC_EInvalidFault;\x0a"
"\x0a"
"        uint8_t\x26 fc = config\x5b fault \x5d;\x0a"
"        if ( \x21( fc \x26 FaultFlag\x3a\x3a""AllowOverride ) )\x0a"
"            return _DiOS_FC_ELocked;\x0a"
"\x0a"
"        int lastCfg = _faultToStatus( fault );\x0a"
"        if ( fault < _DiOS_F_Last ) // Fault\x0a"
"        {\x0a"
"            switch( cfg )\x0a"
"            {\x0a"
"                case _DiOS_FC_Ignore\x3a\x0a"
"                    fc = FaultFlag\x3a\x3a""AllowOverride;\x0a"
"                    break;\x0a"
"                case _DiOS_FC_Detect\x3a\x0a"
"                    fc = FaultFlag\x3a\x3a""AllowOverride \x7c FaultFlag\x3a\x3a""Detect;\x0a"
"                    break;\x0a"
"                case _DiOS_FC_Report\x3a\x0a"
"                    fc = FaultFlag\x3a\x3a""AllowOverride \x7c FaultFlag\x3a\x3a""Enabled \x7c FaultFlag\x3a\x3a""Continue;\x0a"
"                    break;\x0a"
"                case _DiOS_FC_Abort\x3a\x0a"
"                    fc = FaultFlag\x3a\x3a""AllowOverride \x7c FaultFlag\x3a\x3a""Enabled;\x0a"
"                    break;\x0a"
"                default\x3a\x0a"
"                    return _DiOS_FC_EInvalidCfg;\x0a"
"            }\x0a"
"        }\x0a"
"        else // Simfail\x0a"
"        {\x0a"
"            switch( cfg )\x0a"
"            {\x0a"
"                case _DiOS_FC_SimFail\x3a\x0a"
"                    fc = FaultFlag\x3a\x3a""AllowOverride \x7c FaultFlag\x3a\x3a""Enabled;\x0a"
"                    break;\x0a"
"                case _DiOS_FC_NoFail\x3a\x0a"
"                    fc = FaultFlag\x3a\x3a""AllowOverride;\x0a"
"                    break;\x0a"
"                default\x3a\x0a"
"                    return _DiOS_FC_EInvalidCfg;\x0a"
"            }\x0a"
"        }\x0a"
"        updateSimFail();\x0a"
"        return lastCfg;\x0a"
"    }\x0a"
"\x0a"
"    int FaultBase\x3a\x3aget_fault_config( int fault )\x0a"
"    {\x0a"
"        if ( fault >= fault_count )\x0a"
"            return _DiOS_FC_EInvalidFault;\x0a"
"        return _faultToStatus( fault );\x0a"
"    }\x0a"
"}\x0a"
"", 10079 ); }