#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_fault_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
" *     2016 Vladimir Still <xstill\x40""fi.muni.cz>\x0a"
" *     2016, 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"#include <algorithm>\x0a"
"#include <cstdarg>\x0a"
"#include <sys/metadata.h>\x0a"
"#include <sys/trace.h>\x0a"
"\x0a"
"#include <dios/sys/syscall.hpp>\x0a"
"\x0a"
"/* There are two things going on in this file. The first is configuration of\x0a"
" * simulated failures from \x60malloc\x60, via the \x60{simfail,nofail}\x3amalloc\x60 options.\x0a"
" * It doesn't really belong here and should be moved (TODO). */\x0a"
"\x0a"
"/* The second is the actual fault handler, which serves two purposes\x3a it\x0a"
" * decides whether a particular fault is \xe2\x80\x98interesting\xe2\x80\x99, and if it is, it asks\x0a"
" * the VM to report a counterexample to the user. There are two ways to enter\x0a"
" * the fault handler\x3a either the VM pushes it onto the stack because it\x0a"
" * detected an illegal operation (e.g. out of bounds access), or library code\x0a"
" * can enter it via \x60__dios_fault\x60 (e.g. when an assertion fails). */\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"    enum FaultFlag\x0a"
"    {\x0a"
"        Enabled       = 0x01,\x0a"
"        Continue      = 0x02,\x0a"
"        UserSpec      = 0x04,\x0a"
"        AllowOverride = 0x08,\x0a"
"        Artificial    = 0x10,\x0a"
"        Detect        = 0x20\x0a"
"    };\x0a"
"\x0a"
"    struct ProcessFaultInfo\x0a"
"    {\x0a"
"        ProcessFaultInfo()\x0a"
"        {\x0a"
"            std\x3a\x3a""fill_n( faultConfig, _DiOS_SF_Last, FaultFlag\x3a\x3a""Enabled \x7c FaultFlag\x3a\x3a""AllowOverride );\x0a"
"            faultConfig\x5b _VM_F_PtrCompare \x5d = FaultFlag\x3a\x3a""Continue \x7c FaultFlag\x3a\x3a""AllowOverride;\x0a"
"        }\x0a"
"\x0a"
"        uint8_t faultConfig\x5b _DiOS_SF_Last \x5d;\x0a"
"    };\x0a"
"\x0a"
"    /* This class is intentionally not part of the stack, because nothing\x0a"
"     * inside uses services of other components. This means the code for the\x0a"
"     * methods is only generated once instead of once per configuration, which\x0a"
"     * reduces the bitcode size a bit. */\x0a"
"\x0a"
"    struct FaultBase\x0a"
"    {\x0a"
"        virtual uint8_t *config() = 0;\x0a"
"        virtual void die() = 0;\x0a"
"\x0a"
"        uint8_t _flags;\x0a"
"        enum Flags { Ready = 1, PrintBacktrace = 2 };\x0a"
"        static constexpr int fault_count = _DiOS_SF_Last;\x0a"
"\x0a"
"        struct MallocNofailGuard {\x0a"
"        private\x3a\x0a"
"            MallocNofailGuard( FaultBase \x26 f )\x0a"
"                \x3a _f( f ),\x0a"
"                  _config( _f.config() ),\x0a"
"                  _s( _config\x5b _DiOS_SF_Malloc \x5d )\x0a"
"            {\x0a"
"                _config\x5b _DiOS_SF_Malloc \x5d = 0;\x0a"
"                _f.updateSimFail();\x0a"
"            }\x0a"
"        public\x3a\x0a"
"            \x7eMallocNofailGuard() {\x0a"
"                _config\x5b _DiOS_SF_Malloc \x5d = _s;\x0a"
"                _f.updateSimFail();\x0a"
"            }\x0a"
"\x0a"
"            FaultBase\x26 _f;\x0a"
"            uint8_t *_config;\x0a"
"            uint8_t _s;\x0a"
"\x0a"
"            friend FaultBase;\x0a"
"        };\x0a"
"\x0a"
"        MallocNofailGuard makeMallocNofail()\x0a"
"        {\x0a"
"            return { *this };\x0a"
"        }\x0a"
"\x0a"
"        FaultBase() \x3a _flags( 0 ) {}\x0a"
"\x0a"
"        /* This is the actual entry point of the fault handler, the address of\x0a"
"         * which is stored in _VM_CR_FaultHandler. It's also a __trapfn because\x0a"
"         * we need to switch to kernel mode if we got called from\x0a"
"         * \x60__dios_fault\x60. The actual logic is implemented in \x60""fault_handler()\x60\x0a"
"         * below. */\x0a"
"\x0a"
"        template < typename Context >\x0a"
"        static __trapfn void handler( _VM_Fault _what, _VM_Frame *cont_frame,\x0a"
"                                      void (*cont_pc)() ) noexcept\x0a"
"        {\x0a"
"            uint64_t old = __vm_ctl_flag( 0, _VM_CF_KernelMode \x7c _VM_CF_IgnoreCrit \x7c\x0a"
"                                             _VM_CF_IgnoreLoop \x7c _DiOS_CF_IgnoreFault );\x0a"
"\x0a"
"            if ( old \x26 _DiOS_CF_IgnoreFault )\x0a"
"                goto ret;\x0a"
"\x0a"
"            __dios_sync_parent_frame();\x0a"
"\x0a"
"            {\x0a"
"                bool kernel = old \x26 _VM_CF_KernelMode;\x0a"
"                auto *frame = __dios_parent_frame();\x0a"
"                auto\x26 fault = get_state< Context >();\x0a"
"                fault.fault_handler( kernel, frame, _what );\x0a"
"            }\x0a"
"\x0a"
"            // Continue if we get the control back\x0a"
"            old \x7c= uint64_t( __vm_ctl_get( _VM_CR_Flags ) ) \x26 ( _DiOS_CF_Fault \x7c _VM_CF_Error );\x0a"
"            // clean possible intermediate frames to avoid memory leaks\x0a"
"            __dios_stack_free( __dios_parent_frame(), cont_frame );\x0a"
"          ret\x3a\x0a"
"            __vm_ctl_set( _VM_CR_Flags, reinterpret_cast< void * >( old ) );\x0a"
"            __vm_ctl_set( _VM_CR_Frame, cont_frame, cont_pc );\x0a"
"            __builtin_trap();\x0a"
"        }\x0a"
"\x0a"
"        void updateSimFail( uint8_t *config = nullptr );\x0a"
"        void backtrace( _VM_Frame * frame );\x0a"
"        void fault_handler( int kernel, _VM_Frame * frame, int what );\x0a"
"\x0a"
"        static int str_to_fault( std\x3a\x3astring_view fault );\x0a"
"        static std\x3a\x3astring_view fault_to_str( int f, bool ext = false );\x0a"
"        void trace_config( int indent );\x0a"
"        void load_user_pref( uint8_t *config, SysOpts\x26 opts );\x0a"
"        int _faultToStatus( int fault );\x0a"
"        int configure_fault( int fault, int cfg );\x0a"
"        int get_fault_config( int fault );\x0a"
"    };\x0a"
"\x0a"
"    template < typename Next >\x0a"
"    struct Fault\x3a FaultBase, Next\x0a"
"    {\x0a"
"\x0a"
"        struct Process \x3a Next\x3a\x3aProcess, ProcessFaultInfo {};\x0a"
"\x0a"
"        template< typename Setup >\x0a"
"        void setup( Setup s )\x0a"
"        {\x0a"
"            traceAlias< Fault >( \x22{Fault}\x22 );\x0a"
"            __vm_ctl_set( _VM_CR_FaultHandler,\x0a"
"                          reinterpret_cast< void * >( handler< typename Setup\x3a\x3a""Context > ) );\x0a"
"            load_user_pref( s.proc1->faultConfig, s.opts );\x0a"
"\x0a"
"            if ( extract_opt( \x22""debug\x22, \x22""faultcfg\x22, s.opts ) )\x0a"
"            {\x0a"
"                trace_config( 1 );\x0a"
"                __vm_ctl_flag( 0, _VM_CF_Error );\x0a"
"            }\x0a"
"            _flags = Ready;\x0a"
"            if ( extract_opt( \x22""debug\x22, \x22""faultbt\x22, s.opts ) )\x0a"
"                _flags \x7c= PrintBacktrace;\x0a"
"            Next\x3a\x3asetup( s );\x0a"
"        }\x0a"
"\x0a"
"        void getHelp( ArrayMap< std\x3a\x3astring_view, HelpOption >\x26 options )\x0a"
"        {\x0a"
"            const char *opt1 = \x22\x5b""force-\x5d{ignore\x7creport\x7c""abort}\x22;\x0a"
"            if ( options.find( opt1 ) \x21= options.end() ) {\x0a"
"                __dios_trace_f( \x22Option \x25s already present\x22, opt1 );\x0a"
"                __dios_fault( _DiOS_F_Config, \x22Option conflict\x22 );\x0a"
"            }\x0a"
"            options\x5b opt1 \x5d = { \x22""configure the fault handler\x22,\x0a"
"                                { \x22""assert\x22, \x22""arithmetic\x22, \x22memory\x22, \x22""control\x22,\x0a"
"                                  \x22locking\x22, \x22hypercall\x22, \x22notimplemented\x22, \x22""diosassert\x22 } };\x0a"
"\x0a"
"            const char *opt2 = \x22{nofail\x7csimfail}\x22;\x0a"
"            if ( options.find( opt2 ) \x21= options.end() ) {\x0a"
"                __dios_trace_f( \x22Option \x25s already present\x22, opt2 );\x0a"
"                __dios_fault( _DiOS_F_Config, \x22Option conflict\x22 );\x0a"
"            }\x0a"
"            options\x5b opt2 \x5d = { \x22""enable/disable simulation of failure\x22,\x0a"
"              { \x22malloc\x22 } };\x0a"
"\x0a"
"            Next\x3a\x3agetHelp( options );\x0a"
"        }\x0a"
"\x0a"
"        uint8_t *config() override\x0a"
"        {\x0a"
"            auto *task = Next\x3a\x3a""current_task();\x0a"
"            if ( \x21task )\x0a"
"                return nullptr;\x0a"
"            return static_cast< Process * >( task->_proc )->faultConfig;\x0a"
"        }\x0a"
"\x0a"
"        void die() override { Next\x3a\x3a""die(); }\x0a"
"\x0a"
"        using FaultBase\x3a\x3aget_fault_config;\x0a"
"        using FaultBase\x3a\x3a""configure_fault;\x0a"
"        using FaultBase\x3a\x3a""fault_handler;\x0a"
"    };\x0a"
"\x0a"
"}\x0a"
"", 7889 ); }