#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_memory_hpp( 
"// -*- C++ -*- (c) 2015 Ji\xc5\x99\xc3\xad Weiser\x0a"
"//             (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"#include <memory>\x0a"
"#include <cstdlib>\x0a"
"#include <limits>\x0a"
"\x0a"
"#include \x22sys/divm.h\x22\x0a"
"\x0a"
"#ifndef _DIOS_MEMORY_H_\x0a"
"#define _DIOS_MEMORY_H_\x0a"
"\x0a"
"#if __cplusplus >= 201103L\x0a"
"#define NOTHROW noexcept\x0a"
"#else\x0a"
"#define NOTHROW throw()\x0a"
"#endif\x0a"
"\x0a"
"namespace __dios {\x0a"
"\x0a"
"struct MemoryPool {\x0a"
"    MemoryPool( int size ) noexcept \x3a\x0a"
"        _pos( 0 ),\x0a"
"        _pool( static_cast< void ** >( __vm_obj_make( size * sizeof( void * ), _VM_PT_Heap ) ) )\x0a"
"    {\x0a"
"        for ( int i = 0; i \x21= size; i++ ) {\x0a"
"            _pool\x5b i \x5d = __vm_obj_make( 1, _VM_PT_Heap );\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    MemoryPool( const MemoryPool\x26 ) = delete;\x0a"
"    MemoryPool\x26 operator=( const MemoryPool\x26 ) = delete;\x0a"
"\x0a"
"    \x7eMemoryPool()\x0a"
"    {\x0a"
"        for ( int i = _pos; i < __vm_obj_size( _pool ) / sizeof( void * ); ++i )\x0a"
"            __vm_obj_free( _pool\x5b i \x5d );\x0a"
"        __vm_obj_free( _pool );\x0a"
"    }\x0a"
"\x0a"
"    void *get() noexcept\x0a"
"    {\x0a"
"        if ( __vm_obj_size( _pool ) \x21= sizeof( void * ) * _pos )\x0a"
"            return _pool\x5b _pos++ \x5d;\x0a"
"        return nullptr;\x0a"
"    }\x0a"
"\x0a"
"    int _pos;\x0a"
"    void **_pool;\x0a"
"};\x0a"
"\x0a"
"struct AllocatorBase {\x0a"
"\x0a"
"    using pointer = void *;\x0a"
"    using const_pointer = const void *;\x0a"
"    using size_type = std\x3a\x3asize_t;\x0a"
"    using difference_type = std\x3a\x3aptrdiff_t;\x0a"
"\x0a"
"    AllocatorBase() {}\x0a"
"    AllocatorBase( const AllocatorBase \x26 ) {};\x0a"
"    template< typename U >\x0a"
"    AllocatorBase( const std\x3a\x3a""allocator< U > \x26 ) {}\x0a"
"\x0a"
"    pointer allocate( size_type n, __attribute__((unused)) const_pointer hint = nullptr ) {\x0a"
"#ifdef __divine__\x0a"
"        return static_cast< pointer >( __vm_obj_make( n, _VM_PT_Heap ) );\x0a"
"#else\x0a"
"        return std\x3a\x3a""allocator< char >().allocate( n, hint );\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    void deallocate( pointer p, __attribute__((unused)) size_type n ) {\x0a"
"#ifdef __divine__\x0a"
"        __vm_obj_free( p );\x0a"
"#else\x0a"
"        char *_p = static_cast< char * >( p );\x0a"
"        std\x3a\x3a""allocator< char >().deallocate( _p, n );\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    size_type max_size() const {\x0a"
"#ifdef __divine__\x0a"
"        return std\x3a\x3anumeric_limits< std\x3a\x3aint32_t >\x3a\x3amax();\x0a"
"#else\x0a"
"        return std\x3a\x3anumeric_limits< size_type >\x3a\x3amax();\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    template< typename U, typename... Args >\x0a"
"    void construct( U *p, Args \x26\x26... args ) {\x0a"
"        \x3a\x3anew( (void *)p ) U( std\x3a\x3a""forward< Args >( args )... );\x0a"
"    }\x0a"
"\x0a"
"    template< typename U >\x0a"
"    void destroy( U *p ) {\x0a"
"        p->\x7eU();\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template< typename T >\x0a"
"struct Allocator \x3a AllocatorBase {\x0a"
"    // STL compatibility typedefs\x0a"
"    using value_type = T;\x0a"
"    using pointer = T *;\x0a"
"    using const_pointer = const T *;\x0a"
"    using reference = T \x26;\x0a"
"    using const_reference = const T \x26;\x0a"
"\x0a"
"    // using propagate_on_container_move_assignment = std\x3a\x3atrue_type; // C++14\x0a"
"    // using is_always_equal = std\x3a\x3atrue_type; // C++17\x0a"
"\x0a"
"    Allocator() {}\x0a"
"    Allocator( const Allocator \x26 ) {};\x0a"
"    template< typename U >\x0a"
"    Allocator( const Allocator< U > \x26 ) {}\x0a"
"    template< typename U >\x0a"
"    Allocator( const std\x3a\x3a""allocator< U > \x26 ) {}\x0a"
"\x0a"
"    template< typename U >\x0a"
"    struct rebind {\x0a"
"        using other = Allocator< U >;\x0a"
"    };\x0a"
"\x0a"
"    pointer address( reference x ) const {\x0a"
"        return \x26x;\x0a"
"    }\x0a"
"    const_pointer address( const_reference x ) const {\x0a"
"        return \x26x;\x0a"
"    }\x0a"
"\x0a"
"    pointer allocate( size_type n, const_pointer hint = nullptr ) {\x0a"
"        return static_cast< pointer >( AllocatorBase\x3a\x3a""allocate( n * sizeof( value_type ), hint ) );\x0a"
"    }\x0a"
"\x0a"
"    void deallocate( pointer p, size_type n ) {\x0a"
"        AllocatorBase\x3a\x3a""deallocate( p, n * sizeof( value_type ) );\x0a"
"    }\x0a"
"\x0a"
"};\x0a"
"\x0a"
"using AllocatorPure = Allocator< char >;\x0a"
"\x0a"
"template< typename T1, typename T2 >\x0a"
"bool operator==( const Allocator< T1 > \x26, const Allocator< T2 > \x26 ) {\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template< typename T1, typename T2 >\x0a"
"bool operator\x21=( const Allocator< T1 > \x26, const Allocator< T2 > \x26 ) {\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"struct nofail_t {};\x0a"
"extern nofail_t nofail;\x0a"
"\x0a"
"} // namespace __dios\x0a"
"\x0a"
"void *operator new( std\x3a\x3asize_t count, const __dios\x3a\x3anofail_t \x26 ) NOTHROW;\x0a"
"void *operator new\x5b\x5d( std\x3a\x3asize_t count, const __dios\x3a\x3anofail_t \x26 ) NOTHROW;\x0a"
"\x0a"
"#endif // _DIOS_MEMORY_H_\x0a"
"", 4052 ); }