#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_options_cpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
" *     2016 Vladimir Still <xstill\x40""fi.muni.cz>\x0a"
" *     2019 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"\x0a"
"#include <algorithm>\x0a"
"#include <cstdlib>\x0a"
"#include <pthread.h>\x0a"
"\x0a"
"#include <sys/metadata.h>\x0a"
"#include <dios/sys/options.hpp>\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"    char *env_to_string( const _VM_Env *env ) noexcept\x0a"
"    {\x0a"
"        auto arg = static_cast< char * >( __vm_obj_make( env->size + 1, _VM_PT_Heap ) );\x0a"
"        memcpy( arg, env->value, env->size );\x0a"
"        arg\x5b env->size \x5d = '\x5c""0';\x0a"
"        return arg;\x0a"
"    }\x0a"
"\x0a"
"    bool parse_sys_options( const _VM_Env *e, SysOpts\x26 res )\x0a"
"    {\x0a"
"        const char *prefix = \x22sys.\x22;\x0a"
"        int pref_len = strlen( prefix );\x0a"
"        res.clear();\x0a"
"\x0a"
"        for( ; e->key \x21= nullptr; e++ )\x0a"
"        {\x0a"
"            if ( memcmp( prefix, e->key, pref_len ) \x21= 0 )\x0a"
"                continue;\x0a"
"\x0a"
"            // Add sugar for help command\x0a"
"            std\x3a\x3astring_view s( e->value, e->size );\x0a"
"            if ( s == \x22help\x22)\x0a"
"            {\x0a"
"                res.emplace_back( \x22""debug\x22, \x22help\x22 );\x0a"
"                continue;\x0a"
"            }\x0a"
"\x0a"
"            auto p = std\x3a\x3a""find( s.begin(), s.end(), '\x3a' );\x0a"
"            if ( p == s.end() )\x0a"
"            {\x0a"
"                __dios_trace_f( \x22Missing '\x3a' in parameter '\x25.*s'\x22, e->size, e->value );\x0a"
"                return false;\x0a"
"            }\x0a"
"\x0a"
"            if ( std\x3a\x3a""find( ++p, s.end(), '\x3a') \x21= s.end() )\x0a"
"            {\x0a"
"                __dios_trace_f(  \x22Multiple '\x3a' in parameter '\x25.*s'\x22, e->size, e->value );\x0a"
"                return false;\x0a"
"            }\x0a"
"\x0a"
"            std\x3a\x3astring_view val( p, s.end() - p );\x0a"
"            std\x3a\x3astring_view key( s.begin(), --p - s.begin() );\x0a"
"            res.emplace_back( key, val );\x0a"
"        }\x0a"
"\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    std\x3a\x3astring_view extract_opt( std\x3a\x3astring_view key, SysOpts\x26 opts )\x0a"
"    {\x0a"
"        auto r = std\x3a\x3a""find_if( opts.begin(), opts.end(), \x5b\x26\x5d( const auto\x26 opt )\x0a"
"        {\x0a"
"            return key == opt.first;\x0a"
"        } );\x0a"
"        if ( r == opts.end() )\x0a"
"            return std\x3a\x3astring_view{};\x0a"
"        std\x3a\x3astring_view s = r->second;\x0a"
"        opts.erase( r );\x0a"
"        return s;\x0a"
"    }\x0a"
"\x0a"
"    bool extract_opt( std\x3a\x3astring_view key, std\x3a\x3astring_view value, SysOpts\x26 opts )\x0a"
"    {\x0a"
"        auto r = std\x3a\x3a""find_if( opts.begin(), opts.end(), \x5b\x26\x5d( const auto\x26 opt ) {\x0a"
"            return key == opt.first \x26\x26 value == opt.second;\x0a"
"        } );\x0a"
"        if ( r == opts.end() )\x0a"
"            return false;\x0a"
"        opts.erase( r );\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    const _VM_Env *get_env_key( const char* key, const _VM_Env *e ) noexcept\x0a"
"    {\x0a"
"        for ( ; e->key; e++ )\x0a"
"            if ( strcmp( e->key, key ) == 0)\x0a"
"                return e;\x0a"
"\x0a"
"        return nullptr;\x0a"
"    }\x0a"
"\x0a"
"    std\x3a\x3apair<int, char**> construct_main_arg( const char* prefix, const _VM_Env *env,\x0a"
"                                               bool prepend_name) noexcept\x0a"
"    {\x0a"
"        int argc = prepend_name \x3f 1 \x3a 0;\x0a"
"        int pref_len = strlen( prefix );\x0a"
"        const _VM_Env *name = nullptr;\x0a"
"        const _VM_Env *e = env;\x0a"
"\x0a"
"        for ( ; e->key; e++ )\x0a"
"        {\x0a"
"            if ( memcmp( prefix, e->key, pref_len ) == 0 )\x0a"
"                argc++;\x0a"
"            else if ( strcmp( e->key, \x22""divine.bcname\x22 ) == 0 )\x0a"
"            {\x0a"
"                __dios_assert_v( \x21name, \x22Multiple divine.bcname provided\x22 );\x0a"
"                name = e;\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"        auto mem = __vm_obj_make( ( argc + 1 ) * sizeof( char * ), _VM_PT_Heap );\x0a"
"        auto argv = static_cast< char ** >( mem );\x0a"
"\x0a"
"        char **arg = argv;\x0a"
"        if ( prepend_name )\x0a"
"        {\x0a"
"            __dios_assert_v( name, \x22Missing binary name\x3a divine.bcname\x22 );\x0a"
"            *argv = env_to_string( name );\x0a"
"            arg++;\x0a"
"        }\x0a"
"\x0a"
"        for ( ; env->key; env++ )\x0a"
"            if ( memcmp( prefix, env->key, pref_len ) == 0 )\x0a"
"                *arg++ = env_to_string( env );\x0a"
"\x0a"
"        *arg = nullptr;\x0a"
"\x0a"
"        return { argc, argv };\x0a"
"    }\x0a"
"\x0a"
"    void trace_main_arg( int indent, std\x3a\x3astring_view name, std\x3a\x3apair< int, char** > args )\x0a"
"    {\x0a"
"        __dios_trace_i( indent, \x22\x25.*s\x3a\x22, int( name.size() ), name.begin() );\x0a"
"        for ( int i = 0; i \x21= args.first; i++ )\x0a"
"            __dios_trace_i( indent + 1, \x22\x25""d\x3a \x25s\x22, i, args.second\x5bi\x5d );\x0a"
"    }\x0a"
"\x0a"
"}\x0a"
"", 4968 ); }