#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_options_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2016 Jan Mr\xc3\xa1zek  <email\x40honzamrazek.cz>\x0a"
" *     2019 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"#include <utility>\x0a"
"\x0a"
"#include <dios.h>\x0a"
"#include <dios/sys/kernel.hpp>\x0a"
"\x0a"
"/* Utilities to deal with the environment (which is passed down from the\x0a"
" * verification tool and contains options for DiOS itself, command-line\x0a"
" * arguments, the UNIX environment and a filesystem snapshot). This file deals\x0a"
" * with everything other than the vfs snapshot. */\x0a"
"\x0a"
"/* The keys that DiOS expects and understands in the environment are as follows\x3a\x0a"
" *\x0a"
" *  - arg.\x5b""0-9\x5d+\x3a the argv\x5b\x5d to be passed to main() of pid 1\x0a"
" *  - env.\x5b""0-9\x5d+\x3a the envp\x5b\x5d (and __environ) passed to pid 1\x0a"
" *  - sys.\x5b""0-9\x5d+\x3a the options intended for the kernel (-o xxx in DIVINE)\x0a"
" *  - vfs.*\x3a the filesystem snapshot (details in \x60""dios/vfs/base.cpp\x60)\x0a"
" *  - \x60""divine.bcname\x60\x3a argv\x5b""0\x5d (TODO rename this key or merge into arg.*) */\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"    bool parse_sys_options( const _VM_Env *e, SysOpts\x26 res );\x0a"
"\x0a"
"    std\x3a\x3astring_view extract_opt( std\x3a\x3astring_view key, SysOpts\x26 opts );\x0a"
"    bool extract_opt( std\x3a\x3astring_view key, std\x3a\x3astring_view value, SysOpts\x26 opts );\x0a"
"\x0a"
"    /* Construct a null-terminated string from env->value. */\x0a"
"    char *env_to_string( const _VM_Env *env ) noexcept;\x0a"
"\x0a"
"    /* Find an env key by name, nullptr if key does not exist. */\x0a"
"    const _VM_Env *get_env_key( const char* key, const _VM_Env *e ) noexcept;\x0a"
"\x0a"
"    /* Construct argv/envp-like arguments from env keys beginning with\x0a"
"     * \x60prefix\x60.  If \x60prepend_name\x60, the binary name is prepended to the array.\x0a"
"     * Return (argc, argv). */\x0a"
"    std\x3a\x3apair< int, char** > construct_main_arg( const char* prefix, const _VM_Env *env,\x0a"
"                                                 bool prepend_name = false ) noexcept;\x0a"
"\x0a"
"    /* Trace arguments constructed by construct_main_arg. */\x0a"
"    void trace_main_arg( int indent, std\x3a\x3astring_view name, std\x3a\x3apair< int, char** > arg );\x0a"
"\x0a"
"    /* Free argv/envp-like arguments created by construct_main_arg. */\x0a"
"    void free_main_arg( char** argv ) noexcept;\x0a"
"\x0a"
"}\x0a"
"", 2816 ); }