#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_procmanager_hpp( 
"#pragma once\x0a"
"#include <string.h>\x0a"
"#include <errno.h>\x0a"
"#include <sys/wait.h>\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"template < typename Next >\x0a"
"struct ProcessManager \x3a public Next\x0a"
"{\x0a"
"    struct Process \x3a Next\x3a\x3aProcess\x0a"
"    {\x0a"
"        uint16_t ppid;\x0a"
"        uint16_t sid;\x0a"
"        uint16_t pgid;\x0a"
"        uint16_t exitStatus = 0;\x0a"
"        bool calledExecve = false;\x0a"
"    };\x0a"
"\x0a"
"    using Task = typename Next\x3a\x3aTask;\x0a"
"\x0a"
"    Process* proc( Task *t )\x0a"
"    {\x0a"
"        return static_cast< Process* >( t->_proc );\x0a"
"    }\x0a"
"\x0a"
"    template < typename P >\x0a"
"    Process* proc( P *p )\x0a"
"    {\x0a"
"        return static_cast< Process* >( p );\x0a"
"    }\x0a"
"\x0a"
"    template< typename Setup >\x0a"
"    void setup( Setup s )\x0a"
"    {\x0a"
"        traceAlias< ProcessManager >( \x22{ProcMan}\x22 );\x0a"
"        s.proc1->ppid = 0;\x0a"
"        s.proc1->sid = 1;\x0a"
"        s.proc1->pgid = 1;\x0a"
"        bool calledExecve = false;\x0a"
"        Next\x3a\x3asetup( s );\x0a"
"    }\x0a"
"\x0a"
"    bool isChild( Process* child, Process* parent )\x0a"
"    {\x0a"
"        if (\x21""child \x7c\x7c \x21parent)\x0a"
"            return false;\x0a"
"        return child->ppid == parent->pid;\x0a"
"    }\x0a"
"\x0a"
"    Process* findProcess( pid_t pid )\x0a"
"    {\x0a"
"        auto task = std\x3a\x3a""find_if( this->tasks.begin(), this->tasks.end(), \x5b\x26\x5d( auto\x26 t )\x0a"
"                                     { return proc(t.get())->pid == pid; } );\x0a"
"        if ( task == this->tasks.end() )\x0a"
"        {\x0a"
"            *__dios_errno() = ESRCH;\x0a"
"            return nullptr;\x0a"
"        }\x0a"
"        return proc(task->get());\x0a"
"    }\x0a"
"\x0a"
"    pid_t getppid()\x0a"
"    {\x0a"
"        return proc( this->current_task() )->ppid;\x0a"
"    }\x0a"
"\x0a"
"    pid_t getsid( pid_t pid )\x0a"
"    {\x0a"
"        if ( pid == 0 )\x0a"
"            return proc( this->current_task() )->sid;\x0a"
"        Process* proc = this->findProcess( pid );\x0a"
"        return proc \x3f proc->sid \x3a -1;\x0a"
"    }\x0a"
"\x0a"
"    pid_t setsid()\x0a"
"    {\x0a"
"        Process* p = proc( this->current_task() );\x0a"
"        for( auto\x26 t \x3a this->tasks )\x0a"
"            if( proc(t.get())->sid == p->sid \x26\x26 proc(t.get())->pgid == p->pid )\x0a"
"            {\x0a"
"                *__dios_errno() = EPERM;\x0a"
"                return -1;\x0a"
"            }\x0a"
"        p->sid = p->pid;\x0a"
"        p->pgid = p->pid;\x0a"
"        return p->sid;\x0a"
"    }\x0a"
"\x0a"
"    pid_t getpgid( pid_t pid )\x0a"
"    {\x0a"
"        if ( pid == 0 )\x0a"
"            return proc( this->current_task() )->pgid;\x0a"
"        Process* proc = this->findProcess( pid );\x0a"
"        return proc \x3f proc->pgid \x3a -1;\x0a"
"    }\x0a"
"\x0a"
"    int setpgid( pid_t pid, pid_t pgid )\x0a"
"    {\x0a"
"        if ( pgid < 0 )\x0a"
"        {\x0a"
"            *__dios_errno() = EINVAL;\x0a"
"            return -1;\x0a"
"        }\x0a"
"\x0a"
"        Process* procToSet;\x0a"
"        Process* currentProc = proc( this->current_task() );\x0a"
"        if ( pid == 0 )\x0a"
"            procToSet = currentProc;\x0a"
"        else\x0a"
"        {\x0a"
"            procToSet = this->findProcess( pid );\x0a"
"            if ( \x21procToSet )\x0a"
"                return -1;\x0a"
"            if ( \x21isChild( procToSet, currentProc ) \x26\x26 pid \x21= currentProc->pid )\x0a"
"            {\x0a"
"                *__dios_errno() = ESRCH;\x0a"
"                return -1;\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"        if ( procToSet->pgid == procToSet->pid \x7c\x7c\x0a"
"             ( isChild( procToSet, currentProc ) \x26\x26 procToSet->sid \x21= currentProc->sid ) )\x0a"
"        {\x0a"
"            *__dios_errno() = EPERM;\x0a"
"            return -1;\x0a"
"        }\x0a"
"        if ( std\x3a\x3a""find_if( this->tasks.begin(), this->tasks.end(), \x5b\x26\x5d( auto\x26 t )\x0a"
"                          { return proc(t.get())->pgid == pgid \x26\x26 proc(t.get())->sid == procToSet->sid; } )\x0a"
"            == this->tasks.end() )\x0a"
"            if ( procToSet->pid \x21= pgid \x26\x26 pgid \x21= 0 )\x0a"
"            {\x0a"
"                *__dios_errno() = EPERM;\x0a"
"                return -1;\x0a"
"            }\x0a"
"\x0a"
"        if ( isChild( procToSet, currentProc ) \x26\x26 procToSet->calledExecve )\x0a"
"        {\x0a"
"            *__dios_errno() = EACCES;\x0a"
"            return -1;\x0a"
"        }\x0a"
"        if ( pgid == 0 )\x0a"
"            procToSet->pgid = procToSet->pid;\x0a"
"        else\x0a"
"            procToSet->pgid = pgid;\x0a"
"\x0a"
"        return 0;\x0a"
"    }\x0a"
"\x0a"
"    pid_t getpgrp()\x0a"
"    {\x0a"
"        return getpgid( 0 );\x0a"
"    }\x0a"
"\x0a"
"    int setpgrp()\x0a"
"    {\x0a"
"        return setpgid( 0, 0 );\x0a"
"    }\x0a"
"\x0a"
"    struct Clone \x3a KObject\x0a"
"    {\x0a"
"        Task *task;\x0a"
"        void *globals;\x0a"
"    };\x0a"
"\x0a"
"    void sysfork( pid_t *child )\x0a"
"    {\x0a"
"        auto tid = __dios_this_task();\x0a"
"        auto oldtask = this->find_task( tid );\x0a"
"        __dios_assert( oldtask );\x0a"
"\x0a"
"        auto oldproc = proc( oldtask );\x0a"
"        Array< const void * > blocked;\x0a"
"\x0a"
"        pid_t maxPid = 0;\x0a"
"        for( auto\x26 t \x3a this->tasks )\x0a"
"        {\x0a"
"            if ( proc( t.get() )->pid > maxPid )\x0a"
"                maxPid = proc( t.get() )->pid;\x0a"
"            if ( t.get() \x21= oldtask )\x0a"
"                blocked.push_back( t->_tls );\x0a"
"        }\x0a"
"\x0a"
"        *child = maxPid + 1;\x0a"
"\x0a"
"        oldtask->_frame = this->sysenter()->parent;\x0a"
"        oldtask->_proc = nullptr;\x0a"
"\x0a"
"\x0a"
"        Clone *oldclone = new Clone, *newclone;\x0a"
"        oldclone->task = oldtask;\x0a"
"        oldclone->globals = oldproc->globals;\x0a"
"        newclone = static_cast< Clone * >( __vm_obj_clone( oldclone, blocked.begin() ) );\x0a"
"\x0a"
"        Process *newproc = static_cast< Process * >( this->make_process( oldproc ) );\x0a"
"        Task *newtask = newclone->task;\x0a"
"\x0a"
"        oldtask->_proc = oldproc;\x0a"
"        newtask->_proc = newproc;\x0a"
"\x0a"
"        newproc->globals = newclone->globals;\x0a"
"        newproc->pid  = maxPid + 1;\x0a"
"        newproc->ppid = oldproc->pid;\x0a"
"        newproc->sid  = oldproc->sid;\x0a"
"        newproc->pgid = oldproc->pgid;\x0a"
"\x0a"
"        delete oldclone;\x0a"
"        delete newclone;\x0a"
"\x0a"
"        this->tasks.emplace_back( newtask );\x0a"
"    }\x0a"
"\x0a"
"    pid_t wait4(pid_t pid, int *wstatus, int options, struct rusage *rusage)\x0a"
"    {\x0a"
"        if ( options \x26 \x7e( WNOHANG \x7c WUNTRACED \x7c WCONTINUED ) )\x0a"
"        {\x0a"
"            *__dios_errno() = EINVAL;\x0a"
"            return -1;\x0a"
"        }\x0a"
"\x0a"
"        if ( rusage )\x0a"
"            memset( rusage, 0, sizeof( struct rusage ) );\x0a"
"\x0a"
"        Process* parent = proc( this->tasks.find( __dios_this_task() ) );\x0a"
"        pid_t childpid;\x0a"
"\x0a"
"        auto pid_criteria_func = \x5b\x26\x5d( auto\x26 pr )\x0a"
"        {\x0a"
"            Process* p = proc( pr );\x0a"
"\x0a"
"            if ( p->ppid \x21= parent->pid )\x0a"
"                return false;\x0a"
"            if ( pid < -1 )\x0a"
"                return p->pgid == abs( pid );\x0a"
"            if ( pid == -1 )\x0a"
"                return true;\x0a"
"            if ( pid == 0 )\x0a"
"                return p->pgid == parent->pgid;\x0a"
"            return p->pid == pid;\x0a"
"        };\x0a"
"\x0a"
"        auto child = std\x3a\x3a""find_if( this->zombies.begin(), this->zombies.end(),\x0a"
"                                   \x5b\x26\x5d( auto\x26 p ) { return pid_criteria_func( p.second ); } );\x0a"
"\x0a"
"        if ( child == this->zombies.end() )\x0a"
"        {\x0a"
"            if ( options \x26 WNOHANG )\x0a"
"            {\x0a"
"                *__dios_errno() = ECHILD;\x0a"
"                if ( std\x3a\x3a""count_if( this->tasks.begin(), this->tasks.end(), \x5b\x26\x5d( auto\x26 pr ) {\x0a"
"                    return pid_criteria_func( pr->_proc );\x0a"
"                } ) )\x0a"
"                    return 0;\x0a"
"                else\x0a"
"                    return -1;\x0a"
"            }\x0a"
"            else\x0a"
"                __vm_cancel();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            Process *p = proc( child->second );\x0a"
"            if ( wstatus )\x0a"
"                *wstatus = p->exitStatus;\x0a"
"            childpid = p->pid;\x0a"
"            delete_object( p );\x0a"
"            this->zombies.erase( pid );\x0a"
"        }\x0a"
"        return childpid;\x0a"
"    }\x0a"
"\x0a"
"    int kill( pid_t pid, int sig )\x0a"
"    {\x0a"
"        return Next\x3a\x3a_kill( pid, sig,\x0a"
"                            \x5b\x26\x5d( auto* p ) { proc( p )->exitStatus = sig; } );\x0a"
"    }\x0a"
"\x0a"
"    void exit_process( int code )\x0a"
"    {\x0a"
"        Process* p = proc( this->current_task() );\x0a"
"        p->exitStatus = code << 8;\x0a"
"        Next\x3a\x3akill_process( p->pid );\x0a"
"    }\x0a"
"\x0a"
"    ArrayMap< pid_t, Process* > zombies;\x0a"
"};\x0a"
"\x0a"
"} //namespace __dios\x0a"
"", 7510 ); }