#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_sched_base_hpp( 
"// -*- C++ -*- (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"//                 2016 Vladimir Still <xstill\x40""fi.muni.cz>\x0a"
"//                 2016 Petr Rockai <me\x40mornfall.net>\x0a"
"\x0a"
"#ifndef __DIOS_SCHEDULING_H__\x0a"
"#define __DIOS_SCHEDULING_H__\x0a"
"\x0a"
"#include <dios/sys/task.hpp>\x0a"
"#include <dios/sys/options.hpp>\x0a"
"#include <dios/sys/syscall.hpp>\x0a"
"\x0a"
"#include <cstring>\x0a"
"#include <signal.h>\x0a"
"#include <sys/monitor.h>\x0a"
"#include <sys/signal.h>\x0a"
"#include <sys/start.h>\x0a"
"#include <sys/metadata.h>\x0a"
"#include <dios.h>\x0a"
"\x0a"
"#include <util/map.hpp>\x0a"
"\x0a"
"#include <rst/common.hpp>\x0a"
"\x0a"
"namespace __dios {\x0a"
"\x0a"
"struct DiosMainFrame \x3a _VM_Frame {\x0a"
"    int l;\x0a"
"    int argc;\x0a"
"    char** argv;\x0a"
"    char** envp;\x0a"
"};\x0a"
"\x0a"
"struct TaskRoutineFrame \x3a _VM_Frame {\x0a"
"    void* arg;\x0a"
"};\x0a"
"\x0a"
"struct CleanupFrame \x3a _VM_Frame {\x0a"
"    int reason;\x0a"
"};\x0a"
"\x0a"
"struct TrampolineFrame \x3a _VM_Frame\x0a"
"{\x0a"
"    void *arg1, *arg2;\x0a"
"    int rv;\x0a"
"};\x0a"
"\x0a"
"#ifdef __dios_kernel__\x0a"
"\x0a"
"void sig_ign( int );\x0a"
"void sig_die( int );\x0a"
"void sig_fault( int );\x0a"
"\x0a"
"extern const sighandler_t defhandlers\x5b 32 \x5d;\x0a"
"\x0a"
"template < typename Next >\x0a"
"struct Scheduler \x3a public Next\x0a"
"{\x0a"
"    struct Process \x3a Next\x3a\x3aProcess\x0a"
"    {\x0a"
"        uint16_t pid;\x0a"
"        void *globals;\x0a"
"        virtual \x7eProcess()\x0a"
"        {\x0a"
"            __vm_obj_free( globals );\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"    using Task = __dios\x3a\x3atask< Process >;\x0a"
"    using Tasks = task_array< Task >;\x0a"
"\x0a"
"    Scheduler() \x3a\x0a"
"        debug( new Debug() ),\x0a"
"        sighandlers( nullptr )\x0a"
"    {}\x0a"
"\x0a"
"    \x7eScheduler()\x0a"
"    {\x0a"
"        delete_object( debug );\x0a"
"    }\x0a"
"\x0a"
"    void sortTasks() {\x0a"
"        if ( tasks.empty() )\x0a"
"            return;\x0a"
"        std\x3a\x3asort( tasks.begin(), tasks.end(), \x5b\x5d( const auto\x26 a, const auto\x26 b ) {\x0a"
"            return a->get_id() < b->get_id();\x0a"
"        });\x0a"
"    }\x0a"
"\x0a"
"    template< typename Setup >\x0a"
"    void setup( Setup s )\x0a"
"    {\x0a"
"        traceAlias< Scheduler >( \x22{Scheduler}\x22 );\x0a"
"\x0a"
"        s.proc1->globals = __vm_ctl_get( _VM_CR_Globals );\x0a"
"        s.proc1->pid = 1;\x0a"
"\x0a"
"        auto mainTask = newTaskMem( s.pool->get(), s.pool->get(), __dios_start, 0, s.proc1 );\x0a"
"        auto argv = construct_main_arg( \x22""arg.\x22, s.env, true );\x0a"
"        auto envp = construct_main_arg( \x22""env.\x22, s.env );\x0a"
"        setupMainTask( mainTask, argv.first, argv.second, envp.second );\x0a"
"\x0a"
"        __vm_ctl_set( _VM_CR_Scheduler,\x0a"
"                      reinterpret_cast< void * >( run_scheduler< typename Setup\x3a\x3a""Context > ) );\x0a"
"        setupDebug( s, argv, envp );\x0a"
"\x0a"
"        Next\x3a\x3asetup( s );\x0a"
"    }\x0a"
"\x0a"
"    template < typename Setup >\x0a"
"    void setupDebug( Setup s, std\x3a\x3apair< int, char** >\x26 argv, std\x3a\x3apair< int, char** >\x26 envp )\x0a"
"    {\x0a"
"        if ( extract_opt( \x22""debug\x22, \x22mainargs\x22, s.opts ) \x7c\x7c\x0a"
"             extract_opt( \x22""debug\x22, \x22mainarg\x22, s.opts ) )\x0a"
"        {\x0a"
"            trace_main_arg( 1, \x22main argv\x22, argv );\x0a"
"            trace_main_arg( 1, \x22main envp\x22, envp );\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    int taskCount() const noexcept { return tasks.size(); }\x0a"
"    Task *chooseTask() noexcept\x0a"
"    {\x0a"
"        if ( tasks.empty() )\x0a"
"            return nullptr;\x0a"
"        return tasks\x5b __vm_choose( tasks.size() ) \x5d.get();\x0a"
"    }\x0a"
"\x0a"
"    __debugfn void traceTasks() const noexcept\x0a"
"    {\x0a"
"        int c = tasks.size();\x0a"
"        if ( c == 0 )\x0a"
"            return;\x0a"
"        struct PI { int pid, tid; unsigned choice; };\x0a"
"        PI *pi = reinterpret_cast< PI * >( __vm_obj_make( c * sizeof( PI ), _VM_PT_Heap ) );\x0a"
"        PI *pi_it = pi;\x0a"
"\x0a"
"        for ( int i = 0; i \x21= c; i++ )\x0a"
"        {\x0a"
"            pi_it->pid = 0;\x0a"
"            auto tid = tasks\x5b i \x5d->get_id();\x0a"
"            auto tidhid = debug->hids.find( tid );\x0a"
"            if ( tidhid \x21= debug->hids.end() )\x0a"
"                pi_it->tid = tidhid->second;\x0a"
"            else\x0a"
"            {\x0a"
"                pi_it->tid = debug->hids.push( tid );\x0a"
"                debug->persist();\x0a"
"            }\x0a"
"            pi_it->choice = i;\x0a"
"            ++pi_it;\x0a"
"        }\x0a"
"\x0a"
"        std\x3a\x3asort( pi, pi + c, \x5b\x5d( const PI\x26 a, const PI\x26 b ) {\x0a"
"            if ( a.pid == b.pid )\x0a"
"                return a.tid < b.tid;\x0a"
"            return a.pid < b.pid;\x0a"
"        } );\x0a"
"\x0a"
"        __vm_trace( _VM_T_SchedChoice, pi );\x0a"
"        __vm_obj_free( pi );\x0a"
"    }\x0a"
"\x0a"
"    template< typename... Args >\x0a"
"    Task *newTaskMem( void *mainFrame, void *mainTls, void ( *routine )( Args... ), int tls_size, Process *proc ) noexcept\x0a"
"    {\x0a"
"        __dios_assert_v( routine, \x22Invalid task routine\x22 );\x0a"
"        Task *ret = tasks.emplace_back( new Task( mainFrame, mainTls, routine, tls_size, proc ) ).get();\x0a"
"        sortTasks();\x0a"
"        return ret;\x0a"
"    }\x0a"
"\x0a"
"    template< typename... Args >\x0a"
"    Task *newTask( void ( *routine )( Args... ), int tls_size, Process *proc ) noexcept\x0a"
"    {\x0a"
"        __dios_assert_v( routine, \x22Invalid task routine\x22 );\x0a"
"        Task *ret = tasks.emplace_back( new Task( routine, tls_size, proc ) ).get();\x0a"
"        sortTasks();\x0a"
"        return ret;\x0a"
"    }\x0a"
"\x0a"
"    void setupMainTask( Task * t, int argc, char** argv, char** envp ) noexcept {\x0a"
"        DiosMainFrame *frame = reinterpret_cast< DiosMainFrame * >( t->_frame );\x0a"
"        frame->l = __md_get_pc_meta( reinterpret_cast< _VM_CodePointer >( main ) )->arg_count;\x0a"
"\x0a"
"        frame->argc = argc;\x0a"
"        frame->argv = argv;\x0a"
"        frame->envp = envp;\x0a"
"    }\x0a"
"\x0a"
"    void setupTask( Task * t, void *arg ) noexcept {\x0a"
"        TaskRoutineFrame *frame = reinterpret_cast< TaskRoutineFrame * >( t->_frame );\x0a"
"        frame->arg = arg;\x0a"
"    }\x0a"
"\x0a"
"    void killTask( __dios_task tid ) noexcept\x0a"
"    {\x0a"
"        bool res = tasks.remove( tid );\x0a"
"        __dios_assert_v( res, \x22Killing non-existing task\x22 );\x0a"
"        if ( tid == __dios_this_task() )\x0a"
"            this->reschedule();\x0a"
"    }\x0a"
"\x0a"
"    template< typename I >\x0a"
"    void eraseProcesses( I pivot )\x0a"
"    {\x0a"
"        ArrayMap< Process *, bool > p;\x0a"
"        for ( auto i = pivot; i \x21= tasks.end(); ++i )\x0a"
"            p.emplace( (*i)->_proc, true );\x0a"
"        for ( auto i = tasks.begin(); i \x21= pivot; ++i )\x0a"
"            p.erase( (*i)->_proc );\x0a"
"        for ( auto item \x3a p )\x0a"
"            delete item.first;\x0a"
"    }\x0a"
"\x0a"
"    void kill_process( pid_t id ) noexcept\x0a"
"    {\x0a"
"        if ( \x21id )\x0a"
"        {\x0a"
"            size_t c = tasks.size();\x0a"
"            eraseProcesses( tasks.begin() );\x0a"
"            tasks.erase( tasks.begin(), tasks.end() );\x0a"
"            this->reschedule();\x0a"
"        }\x0a"
"\x0a"
"        bool resched = false;\x0a"
"        auto r = std\x3a\x3apartition( tasks.begin(), tasks.end(), \x5b\x26\x5d( auto\x26 t )\x0a"
"                                 {\x0a"
"                                     if ( t->_proc->pid \x21= id )\x0a"
"                                         return true;\x0a"
"                                     if ( t->_tls == __dios_this_task() )\x0a"
"                                         resched = true;\x0a"
"                                     return false;\x0a"
"                                 } );\x0a"
"\x0a"
"        eraseProcesses( r );\x0a"
"        tasks.erase( r, tasks.end() );\x0a"
"        if ( resched )\x0a"
"            this->reschedule();\x0a"
"    }\x0a"
"\x0a"
"    int sigaction( int sig, const struct \x3a\x3asigaction *act, struct sigaction *oldact )\x0a"
"    {\x0a"
"        if ( sig <= 0 \x7c\x7c sig > static_cast< int >( sizeof(defhandlers) / sizeof(__dios\x3a\x3asighandler_t) )\x0a"
"            \x7c\x7c sig == SIGKILL \x7c\x7c sig == SIGSTOP )\x0a"
"        {\x0a"
"            *__dios_errno() = EINVAL;\x0a"
"            return -1 ;\x0a"
"        }\x0a"
"\x0a"
"        if ( \x21sighandlers )\x0a"
"        {\x0a"
"            sighandlers = reinterpret_cast< sighandler_t * >(\x0a"
"                    __vm_obj_make( sizeof( defhandlers ), _VM_PT_Heap ) );\x0a"
"            std\x3a\x3amemcpy( sighandlers, defhandlers, sizeof(defhandlers) );\x0a"
"        }\x0a"
"\x0a"
"        if ( oldact )\x0a"
"            oldact->sa_handler = sighandlers\x5bsig\x5d.f;\x0a"
"        if ( act )\x0a"
"            sighandlers\x5bsig\x5d.f = act->sa_handler;\x0a"
"\x0a"
"        return 0;\x0a"
"    }\x0a"
"\x0a"
"    int rt_sigaction( int sig, const struct \x3a\x3asigaction *act, struct sigaction *oldact, size_t sz )\x0a"
"    {\x0a"
"        if ( sz == sizeof( sigset_t ) )\x0a"
"            return sigaction( sig, act, oldact );\x0a"
"        __dios_fault( _VM_F_NotImplemented, \x22rt_sigaction with size \x21= sizeof( sigset_t )\x22 );\x0a"
"    }\x0a"
"\x0a"
"    Task *find_task( __dios_task id ) { return tasks.find( id ); }\x0a"
"    Task *current_task() { return tasks.find( __dios_this_task() ); }\x0a"
"    Process *current_process() { return current_task()->_proc; }\x0a"
"\x0a"
"    pid_t getpid() { return current_process()->pid; }\x0a"
"\x0a"
"    __dios_task start_task( __dios_task_routine routine, void * arg, int tls_size )\x0a"
"    {\x0a"
"        auto t = newTask( routine, tls_size, current_task()->_proc );\x0a"
"        setupTask( t, arg );\x0a"
"        return t->get_id();\x0a"
"    }\x0a"
"\x0a"
"    void exit_process( int code )\x0a"
"    {\x0a"
"        kill_process( 0 );\x0a"
"    }\x0a"
"\x0a"
"    void kill_task( __dios_task id )\x0a"
"    {\x0a"
"        killTask( id );\x0a"
"    }\x0a"
"\x0a"
"    __dios_task *get_process_tasks( __dios_task tid )\x0a"
"    {\x0a"
"        Process *proc;\x0a"
"        for ( auto \x26t \x3a tasks ) {\x0a"
"            if ( t->_tls == tid ) {\x0a"
"                proc = t->_proc;\x0a"
"                break;\x0a"
"            }\x0a"
"        }\x0a"
"        int count = 0;\x0a"
"        for ( auto \x26t \x3a tasks ) {\x0a"
"            if ( t->_proc == proc )\x0a"
"                ++count;\x0a"
"        }\x0a"
"        auto ret = static_cast< __dios_task * >( __vm_obj_make( sizeof( __dios_task ) * count,\x0a"
"                                                                _VM_PT_Heap ) );\x0a"
"        int i = 0;\x0a"
"        for ( auto \x26t \x3a tasks ) {\x0a"
"            if ( t->_proc == proc ) {\x0a"
"                ret\x5b i \x5d = t->_tls;\x0a"
"                ++i;\x0a"
"            }\x0a"
"        }\x0a"
"        return ret;\x0a"
"    }\x0a"
"\x0a"
"    template< typename F >\x0a"
"    _VM_Frame *mkframe( F f )\x0a"
"    {\x0a"
"        auto fun = __md_get_pc_meta( reinterpret_cast< _VM_CodePointer >( f ) );\x0a"
"        auto frame = static_cast< _VM_Frame * >( __vm_obj_make( fun->frame_size, _VM_PT_Heap ) );\x0a"
"        frame->pc = reinterpret_cast< _VM_CodePointer >( f );\x0a"
"        return frame;\x0a"
"    }\x0a"
"\x0a"
"    _VM_Frame *sysenter( bool skip_invoke = true )\x0a"
"    {\x0a"
"        _VM_Frame *f = static_cast< _VM_Frame * >( __vm_ctl_get( _VM_CR_Frame ) );\x0a"
"        while ( \x21__md_get_pc_meta( f->pc )->is_trap )\x0a"
"            f = f->parent;\x0a"
"        /* sysenter goes through a function pointer to a lambda, i.e. __invoke */\x0a"
"        return skip_invoke \x3f f->parent \x3a f;\x0a"
"    }\x0a"
"\x0a"
"    int trampoline_return( int rv )\x0a"
"    {\x0a"
"        auto ltf = static_cast< TrampolineFrame * >( mkframe( __dios_simple_trampoline ) );\x0a"
"        ltf->rv = rv;\x0a"
"        ltf->parent = sysenter()->parent;\x0a"
"        sysenter()->parent = ltf;\x0a"
"        return rv;\x0a"
"    }\x0a"
"\x0a"
"    void trampoline_to( Task *task,\x0a"
"                        int (*trampoline_ret)( void *, void *, int ),\x0a"
"                        int (*trampoline_noret)( void *, void *, int ),\x0a"
"                        int rv, void *arg1, void *arg2 )\x0a"
"    {\x0a"
"        if ( task->_tls == __dios_this_task() )\x0a"
"        {\x0a"
"            auto tf = static_cast< TrampolineFrame * >( mkframe( trampoline_ret ) );\x0a"
"            tf->parent = sysenter()->parent;\x0a"
"            tf->rv = rv;\x0a"
"            tf->arg1 = arg1;\x0a"
"            tf->arg2 = arg2;\x0a"
"            sysenter()->parent = tf;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            auto tf = static_cast< TrampolineFrame * >( mkframe( trampoline_noret ) );\x0a"
"            tf->arg1 = arg1;\x0a"
"            tf->arg2 = arg2;\x0a"
"            tf->parent = task->_frame;\x0a"
"            task->_frame = tf;\x0a"
"            trampoline_return( rv );\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    int kill( pid_t pid, int sig )\x0a"
"    {\x0a"
"        return _kill( pid, sig, \x5b\x5d( auto ){} );\x0a"
"    }\x0a"
"\x0a"
"    template < typename F >\x0a"
"    int _kill( pid_t pid, int sig, F func )\x0a"
"    {\x0a"
"        sighandler_t handler;\x0a"
"        bool found = false;\x0a"
"        Task *task;\x0a"
"        for ( auto\x26 t \x3a tasks )\x0a"
"            if ( t->_proc->pid == pid )\x0a"
"            {\x0a"
"                found = true;\x0a"
"                task = t.get();\x0a"
"                break;\x0a"
"            }\x0a"
"        if ( \x21""found )\x0a"
"        {\x0a"
"            *__dios_errno() = ESRCH;\x0a"
"            return trampoline_return( -1 );\x0a"
"        }\x0a"
"        if ( sighandlers )\x0a"
"            handler = sighandlers\x5bsig\x5d;\x0a"
"        else\x0a"
"            handler = defhandlers\x5bsig\x5d;\x0a"
"        if ( handler.f == sig_ign )\x0a"
"            return trampoline_return( 0 );\x0a"
"        if ( handler.f == sig_die )\x0a"
"        {\x0a"
"            func( task->_proc );\x0a"
"            kill_process( pid );\x0a"
"        }\x0a"
"        else if ( handler.f == sig_fault )\x0a"
"            __dios_fault( _VM_F_Control, \x22Uncaught signal.\x22 );\x0a"
"        else\x0a"
"        {\x0a"
"            trampoline_to( task, __dios_signal_trampoline_ret, __dios_signal_trampoline_noret, 0,\x0a"
"                           reinterpret_cast< void * >( handler.f ),\x0a"
"                           reinterpret_cast< void * >( sig ) );\x0a"
"            return 0;\x0a"
"        }\x0a"
"\x0a"
"        return trampoline_return( 0 );\x0a"
"    }\x0a"
"\x0a"
"    void die() noexcept\x0a"
"    {\x0a"
"        /* we are in the fault handler, do not touch anything that may trigger a double fault */\x0a"
"        for ( auto\x26 t \x3a tasks )\x0a"
"            t->_frame = nullptr;\x0a"
"        kill_process( 0 );\x0a"
"    }\x0a"
"\x0a"
"    bool check_final()\x0a"
"    {\x0a"
"        return tasks.empty();\x0a"
"    }\x0a"
"\x0a"
"    __inline void prepare( Task \x26t )\x0a"
"    {\x0a"
"        __vm_ctl_set( _VM_CR_Globals, t._proc->globals );\x0a"
"        __vm_ctl_set( _VM_CR_User1, \x26t._frame );\x0a"
"        __vm_ctl_set( _VM_CR_User2, t.get_id() );\x0a"
"        __vm_ctl_set( _VM_CR_User3, debug );\x0a"
"    }\x0a"
"\x0a"
"    __inline void monitor( Task \x26t )\x0a"
"    {\x0a"
"        this->runMonitors();\x0a"
"    }\x0a"
"\x0a"
"    __inline void jump( Task \x26t )\x0a"
"    {\x0a"
"        auto f = t._frame;\x0a"
"        __vm_ctl_flag( _VM_CF_KernelMode \x7c _VM_CF_IgnoreCrit \x7c _VM_CF_IgnoreLoop, 0 );\x0a"
"        __vm_ctl_set( _VM_CR_Frame, f );\x0a"
"    }\x0a"
"\x0a"
"    __inline void run( Task \x26t )\x0a"
"    {\x0a"
"        prepare( t );\x0a"
"        monitor( t ); /* hmm. */\x0a"
"        jump( t );\x0a"
"    }\x0a"
"\x0a"
"    template < typename Context >\x0a"
"    static void run_scheduler() noexcept\x0a"
"    {\x0a"
"        auto\x26 scheduler = get_state< Context >();\x0a"
"\x0a"
"        scheduler.traceTasks();\x0a"
"        Task *t = scheduler.chooseTask();\x0a"
"\x0a"
"        if ( t )\x0a"
"            __vm_trace( _VM_T_TaskID, t );\x0a"
"\x0a"
"        if ( t \x26\x26 t->_frame )\x0a"
"            scheduler.run( *t ); /* does not return */\x0a"
"\x0a"
"        __vm_ctl_flag( 0, _VM_CF_Stop );\x0a"
"        __vm_cancel();\x0a"
"    }\x0a"
"\x0a"
"    Tasks tasks;\x0a"
"    Debug *debug;\x0a"
"    sighandler_t *sighandlers;\x0a"
"};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"} // namespace __dios\x0a"
"\x0a"
"\x0a"
"#endif // __DIOS_SCHEDULING_H__\x0a"
"", 13711 ); }