#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_sched_fair_hpp( 
"// -*- C++ -*- (c) 2018 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"#ifndef __DIOS_FAIR_SCHEDULING_H__\x0a"
"#define __DIOS_FAIR_SCHEDULING_H__\x0a"
"\x0a"
"#include <dios/sys/sched_base.hpp>\x0a"
"\x0a"
"namespace __dios {\x0a"
"\x0a"
"template < typename Next >\x0a"
"struct FairScheduler \x3a public Scheduler< Next > {\x0a"
"     using Task = __dios\x3a\x3atask< typename Scheduler< Next >\x3a\x3aProcess >;\x0a"
"     using Process = typename Scheduler< Next >\x3a\x3aProcess;\x0a"
"\x0a"
"    FairScheduler() \x3a _workingGroup( 0 ) {\x0a"
"        _fairGroup.push_back( nullptr );\x0a"
"    }\x0a"
"\x0a"
"    template< typename Setup >\x0a"
"    void setup( Setup s ) {\x0a"
"        traceAlias< FairScheduler >( \x22{Scheduler}\x22 );\x0a"
"\x0a"
"        s.proc1->globals = __vm_ctl_get( _VM_CR_Globals );\x0a"
"        s.proc1->pid = 1;\x0a"
"\x0a"
"        auto mainTask = this->newTaskMem( s.pool->get(), s.pool->get(), __dios_start, 0, s.proc1 );\x0a"
"        _fairGroup.push_back( mainTask->get_id() );\x0a"
"        auto argv = construct_main_arg( \x22""arg.\x22, s.env, true );\x0a"
"        auto envp = construct_main_arg( \x22""env.\x22, s.env );\x0a"
"        this->setupMainTask( mainTask, argv.first, argv.second, envp.second );\x0a"
"\x0a"
"        __vm_ctl_set( _VM_CR_Scheduler,\x0a"
"                      reinterpret_cast< void * >( run_scheduler< typename Setup\x3a\x3a""Context > ) );\x0a"
"        this->setupDebug( s, argv, envp );\x0a"
"\x0a"
"        Next\x3a\x3asetup( s );\x0a"
"    }\x0a"
"\x0a"
"    __dios_task start_task( __dios_task_routine routine, void * arg, int tls_size )\x0a"
"    {\x0a"
"        auto t = this->newTask( routine, tls_size, this->current_process() );\x0a"
"        this->setupTask( t, arg );\x0a"
"        _fairGroup.push_back( t->get_id() );\x0a"
"        return t->get_id();\x0a"
"    }\x0a"
"\x0a"
"    void killTask( __dios_task tid ) noexcept\x0a"
"    {\x0a"
"        Scheduler< Next >\x3a\x3akillTask( tid );\x0a"
"        auto it = std\x3a\x3a""find( _fairGroup.begin(), _fairGroup.end(), tid );\x0a"
"        int idx = it - _fairGroup.begin();\x0a"
"        if ( idx >= _workingGroup )\x0a"
"            _workingGroup--;\x0a"
"        _fairGroup.erase( it );\x0a"
"    }\x0a"
"\x0a"
"    void moveToNextGroup()\x0a"
"    {\x0a"
"        _workingGroup++;\x0a"
"        if ( _workingGroup == _fairGroup.size() )\x0a"
"            _workingGroup = 0;\x0a"
"    }\x0a"
"\x0a"
"    __inline void run( Task \x26t )\x0a"
"    {\x0a"
"        this->prepare( t );\x0a"
"        this->monitor( t );\x0a"
"        check_fairness();\x0a"
"        this->jump( t );\x0a"
"    }\x0a"
"\x0a"
"    template < typename Context >\x0a"
"    static void run_scheduler() noexcept\x0a"
"    {\x0a"
"        auto \x26scheduler = get_state< Context >();\x0a"
"\x0a"
"        scheduler.traceTasks();\x0a"
"        Task *t = scheduler.chooseTask();\x0a"
"\x0a"
"        if ( t )\x0a"
"            __vm_trace( _VM_T_TaskID, t );\x0a"
"\x0a"
"        __vm_ctl_flag( 0, _DiOS_CF_Fairness );\x0a"
"\x0a"
"        if ( t \x26\x26 t->_frame )\x0a"
"            scheduler.run( *t );\x0a"
"\x0a"
"        __vm_cancel();\x0a"
"    }\x0a"
"\x0a"
"    void check_fairness() /* figure out fairness constraints */\x0a"
"    {\x0a"
"        bool accepting = __vm_ctl_flag( 0, 0 ) \x26 _VM_CF_Accepting;\x0a"
"\x0a"
"        if ( _workingGroup == 0 \x26\x26 accepting )\x0a"
"            moveToNextGroup();\x0a"
"        else if ( _workingGroup \x21= 0 )\x0a"
"        {\x0a"
"            if ( _fairGroup\x5b _workingGroup \x5d == __dios_this_task() )\x0a"
"                moveToNextGroup();\x0a"
"            __vm_ctl_flag( /* clear */ _VM_CF_Accepting, 0 );\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    __dios\x3a\x3a""Array< __dios_task > _fairGroup;\x0a"
"    int _workingGroup;\x0a"
"};\x0a"
"\x0a"
"} // namespace __dios\x0a"
"\x0a"
"#endif // __DIOS_FAIR_SCHEDULING_H\x0a"
"", 3137 ); }