#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_sched_sync_hpp( 
"// -*- C++ -*- (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"#ifndef __DIOS_SYNC_SCHEDULING_H__\x0a"
"#define __DIOS_SYNC_SCHEDULING_H__\x0a"
"\x0a"
"#include <dios/sys/sched_base.hpp>\x0a"
"\x0a"
"namespace __dios {\x0a"
"\x0a"
"template < typename Next >\x0a"
"struct SyncScheduler \x3a public Scheduler< Next >\x0a"
"{\x0a"
"    using Task = __dios\x3a\x3atask< typename Scheduler< Next >\x3a\x3aProcess >;\x0a"
"\x0a"
"    template < typename Setup >\x0a"
"    void setup( Setup s ) {\x0a"
"        traceAlias< SyncScheduler >( \x22{Scheduler}\x22 );\x0a"
"        s.proc1->globals = __vm_ctl_get( _VM_CR_Globals );\x0a"
"        s.proc1->pid = 1;\x0a"
"\x0a"
"        _setupTask.reset( new Task( s.pool->get(), s.pool->get(),\x0a"
"                                    __dios_start_synchronous, 0, s.proc1 ) );\x0a"
"        assert( _setupTask );\x0a"
"        auto argv = construct_main_arg( \x22""arg.\x22, s.env, true );\x0a"
"        auto envp = construct_main_arg( \x22""env.\x22, s.env );\x0a"
"        this->setupMainTask( _setupTask.get(), argv.first, argv.second, envp.second );\x0a"
"\x0a"
"        __vm_ctl_set( _VM_CR_Scheduler,\x0a"
"                      reinterpret_cast< void * >( runScheduler< typename Setup\x3a\x3a""Context > ) );\x0a"
"\x0a"
"        this->setupDebug( s, argv, envp );\x0a"
"        Next\x3a\x3asetup( s );\x0a"
"    }\x0a"
"\x0a"
"    Task* getCurrentTask()\x0a"
"    {\x0a"
"        if ( _setupTask )\x0a"
"            return _setupTask.get();\x0a"
"        auto tid = __dios_this_task();\x0a"
"        return this->tasks.find( tid );\x0a"
"    }\x0a"
"\x0a"
"    void yield()\x0a"
"    {\x0a"
"        void *sched = __vm_ctl_get( _VM_CR_User4 );\x0a"
"        getCurrentTask()->_frame = this->sysenter( false );\x0a"
"        __vm_ctl_set( _VM_CR_Frame, sched ); /* jump back into the scheduler */\x0a"
"    }\x0a"
"\x0a"
"    __dios_task start_task( __dios_task_routine routine, void * arg, int tls_size )\x0a"
"    {\x0a"
"        if ( \x21_setupTask )\x0a"
"            __dios_fault( _VM_F_Control, \x22""Cannot start task outside setup\x22 );\x0a"
"        auto t_obj = new Task( routine, tls_size, _setupTask->_proc );\x0a"
"        auto t = this->tasks.emplace_back( t_obj ).get();\x0a"
"        this->setupTask( t, arg );\x0a"
"        return t->get_id();\x0a"
"    }\x0a"
"\x0a"
"    __inline void run( Task\x26 t ) noexcept\x0a"
"    {\x0a"
"        __vm_ctl_set( _VM_CR_User2, t.get_id() );\x0a"
"\x0a"
"         // In synchronous mode, interrupts don't happen, but RESCHEDULE simply\x0a"
"         // calls __dios_interrupt and we need to prevent that.\x0a"
"        __vm_ctl_flag( _VM_CF_KernelMode, _VM_CF_KeepFrame \x7c _DiOS_CF_Mask );\x0a"
"        __vm_ctl_set( _VM_CR_Frame, t._frame );\x0a"
"    }\x0a"
"\x0a"
"    template < typename Context >\x0a"
"    static void runScheduler() noexcept\x0a"
"    {\x0a"
"        auto \x26scheduler = get_state< Context >();\x0a"
"        __vm_ctl_set( _VM_CR_User4, __dios_this_frame() );\x0a"
"        __vm_ctl_set( _VM_CR_User3, scheduler.debug );\x0a"
"\x0a"
"        if ( scheduler._setupTask )\x0a"
"        {\x0a"
"            scheduler.run( *scheduler._setupTask );\x0a"
"            /* make sure task destructor can see we are not reusing\x0a"
"             * _setupTask's stack */\x0a"
"            __vm_ctl_set( _VM_CR_User2, nullptr );\x0a"
"            scheduler._setupTask.reset( nullptr );\x0a"
"            __vm_suspend();\x0a"
"        }\x0a"
"\x0a"
"        for ( int i = 0; i < scheduler.tasks.size(); i++ )\x0a"
"        {\x0a"
"            auto\x26 t = scheduler.tasks\x5b i \x5d;\x0a"
"            scheduler.run( *t );\x0a"
"        }\x0a"
"\x0a"
"        scheduler.runMonitors();\x0a"
"        if ( scheduler.tasks.empty() )\x0a"
"            scheduler.finalize();\x0a"
"        __vm_suspend();\x0a"
"    }\x0a"
"\x0a"
"    std\x3a\x3aunique_ptr< Task > _setupTask;\x0a"
"};\x0a"
"\x0a"
"} // namespace __dios\x0a"
"\x0a"
"#endif\x0a"
"", 3260 ); }