#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_syscall_hpp( 
"// -*- C++ -*- (c) 2016 Jan Mr\xc3\xa1zek <email\x40honzamrazek.cz>\x0a"
"\x0a"
"#pragma once\x0a"
"#include <dios/sys/kernel.hpp>\x0a"
"#include <dios/sys/kobject.hpp>\x0a"
"#include <dios/sys/memory.hpp>\x0a"
"\x0a"
"// Syscall argument types\x0a"
"#include <sys/syscall.h>\x0a"
"#include <sys/stat.h>\x0a"
"#include <sys/types.h>\x0a"
"#include <sys/socket.h>\x0a"
"#include <sys/resource.h>\x0a"
"#include <sys/monitor.h>\x0a"
"#include <sys/argpad.hpp>\x0a"
"#include <signal.h>\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"struct SetupBase\x0a"
"{\x0a"
"    MemoryPool *pool;\x0a"
"    const _VM_Env *env;\x0a"
"    SysOpts opts;\x0a"
"};\x0a"
"\x0a"
"template< typename Context_ >\x0a"
"struct Setup \x3a SetupBase\x0a"
"{\x0a"
"    using Context = Context_;\x0a"
"    typename Context\x3a\x3aProcess *proc1;\x0a"
"\x0a"
"    Setup( const SetupBase \x26s ) \x3a SetupBase( s ) {}\x0a"
"};\x0a"
"\x0a"
"/* Trap into the kernel and get back out. Each system call gets a separate trap\x0a"
" * function, and those are part of the configuration. They are instantiated in\x0a"
" * \x60""dios/config/common.hpp\x60. DiVM enforces that _VM_CF_Kernel mode is only set\x0a"
" * by functions annotated with \x60""divine.trap\x60 (available as \x60__trapfn\x60, defined\x0a"
" * in \x60""dios/include/sys/cdefs.h\x60). */\x0a"
"\x0a"
"/* Each of the trap functions is expected to locally instantiate the Trap\x0a"
" * class, which takes care of the technicalities of the system call protocol\x0a"
" * (using the RAII idiom). We force the compiler to inline both the ctor and\x0a"
" * the dtor, because we rely on the exact stack layout and also on the __trapfn\x0a"
" * annotations which allow us to switch into kernel mode. */\x0a"
"\x0a"
"/* Other than that, syscalls are normal function calls (and they are performed\x0a"
" * using the \x60""call\x60 LLVM instruction). */\x0a"
"\x0a"
"struct Trap\x0a"
"{\x0a"
"    enum RM { CONTINUE, RESCHEDULE, TRAMPOLINE } retmode;\x0a"
"    uint64_t keepflags;\x0a"
"    static const uint64_t kern = _VM_CF_KernelMode \x7c _VM_CF_IgnoreLoop \x7c _VM_CF_IgnoreCrit;\x0a"
"\x0a"
"    /* Enter the kernel. Nothing too interesting, but if reschedule might\x0a"
"     * happen, we need to sync the _frame pointer of the active task now. */\x0a"
"\x0a"
"    __inline Trap( RM rm ) \x3a retmode( rm )\x0a"
"    {\x0a"
"        __sync_synchronize(); // for the sake of weakmem\x0a"
"        keepflags = __vm_ctl_flag( 0, kern ) \x26 kern;\x0a"
"        if ( retmode == CONTINUE )\x0a"
"            return;\x0a"
"        __dios_sync_this_frame();\x0a"
"    }\x0a"
"\x0a"
"    /* Leave the kernel. This is a little more complicated in case the syscall\x0a"
"     * needs to return into userspace via a trampoline. The syscall handler\x0a"
"     * creates the trampoline frame on top of the userspace portion of the\x0a"
"     * stack. We must transfer control to the trampoline in a somewhat\x0a"
"     * convoluted way, because it's not executing a call instruction and hence\x0a"
"     * we cannot \x60ret\x60 into it. */\x0a"
"\x0a"
"    __inline \x7eTrap()\x0a"
"    {\x0a"
"        __vm_ctl_flag( kern \x26 \x7ekeepflags, 0 );\x0a"
"        if ( retmode == RESCHEDULE )\x0a"
"            __dios_reschedule();\x0a"
"        if ( retmode == TRAMPOLINE )\x0a"
"        {\x0a"
"            /* our parent is the __invoke of the sysenter lambda */\x0a"
"            auto frame = __dios_this_frame();\x0a"
"            auto parent = frame->parent;\x0a"
"            auto target = parent->parent;\x0a"
"            /* free the in-between frame */\x0a"
"            __dios_stack_free( parent, target );\x0a"
"            __dios_set_frame( target );\x0a"
"        }\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"/* This is the bottom of the configuration stack. We do 3 things here\x3a\x0a"
" *  - if a syscall falls through the entire stack and hits the bottom, raise an error\x0a"
" *  - if any options are left unprocessed during setup(), raise an error\x0a"
" *  - provide the interface for the Upcall component. */\x0a"
"\x0a"
"struct BaseContext \x3a KObject\x0a"
"{\x0a"
"    struct Process \x3a KObject\x0a"
"    {\x0a"
"        virtual \x7eProcess() {}\x0a"
"    };\x0a"
"\x0a"
"    template< typename Setup >\x0a"
"    void setup( Setup s )\x0a"
"    {\x0a"
"        traceAlias< BaseContext >( \x22{BaseContext}\x22 );\x0a"
"        using Ctx = typename Setup\x3a\x3a""Context;\x0a"
"\x0a"
"        if ( s.opts.empty() )\x0a"
"            return;\x0a"
"        for ( const auto\x26 opt \x3a s.opts )\x0a"
"            __dios_trace_f( \x22""ERROR\x3a Unused option \x25.*s\x3a\x25.*s\x22,\x0a"
"                            int( opt.first.size() ), opt.first.begin(),\x0a"
"                            int( opt.second.size() ), opt.second.begin() );\x0a"
"        __dios_fault( _DiOS_F_Config, \x22Unused options\x22 );\x0a"
"    }\x0a"
"\x0a"
"    /* The interface to the \x60Upcall\x60 component. */\x0a"
"    virtual void reschedule() = 0;\x0a"
"    virtual Process *make_process( Process * ) = 0;\x0a"
"\x0a"
"    void finalize() {}\x0a"
"    Process *findProcess( pid_t ) { return nullptr; }\x0a"
"\x0a"
"    void getHelp( ArrayMap< std\x3a\x3astring_view, HelpOption >\x26 ) {}\x0a"
"\x0a"
"    /* Instantiate a method for each system call known to us. Implementations\x0a"
"     * in \x60syscall.cpp\x60. */\x0a"
"\x0a"
"    #include <sys/no_memory_tags.def>\x0a"
"    #define SYSCALL( name, schedule, ret, arg ) ret name arg;\x0a"
"\x0a"
"    #include <sys/syscall.def>\x0a"
"\x0a"
"    #undef SYSCALL\x0a"
"    #include <sys/no_memory_tags.undef>\x0a"
"};\x0a"
"\x0a"
"}\x0a"
"", 4585 ); }