#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_task_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2018, 2019 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"#include <dios/sys/kobject.hpp>\x0a"
"#include <util/array.hpp>\x0a"
"#include <sys/metadata.h>\x0a"
"#include <utility>\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"    template < typename T >\x0a"
"    struct task_array \x3a Array< std\x3a\x3aunique_ptr< T > >\x0a"
"    {\x0a"
"        using tid_t = decltype( std\x3a\x3a""declval< T >().get_id() );\x0a"
"\x0a"
"        T *find( tid_t id ) noexcept\x0a"
"        {\x0a"
"            for ( auto \x26t \x3a *this )\x0a"
"                if ( t->get_id() == id )\x0a"
"                    return t.get();\x0a"
"            return nullptr;\x0a"
"        }\x0a"
"\x0a"
"        bool remove( tid_t id ) noexcept\x0a"
"        {\x0a"
"            for ( auto \x26t \x3a *this )\x0a"
"            {\x0a"
"                if ( t ->get_id() \x21= id )\x0a"
"                    continue;\x0a"
"                std\x3a\x3aswap( t, this->back() );\x0a"
"                this->pop_back();\x0a"
"                return true;\x0a"
"            }\x0a"
"            return false;\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"    template < typename process >\x0a"
"    struct task \x3a KObject\x0a"
"    {\x0a"
"        _VM_Frame *_frame;\x0a"
"        __dios_tls *_tls;\x0a"
"        process *_proc;\x0a"
"        const _MD_Function *_fun;\x0a"
"\x0a"
"        task() \x3a _frame( nullptr ),\x0a"
"                 _tls( static_cast< __dios_tls * >(\x0a"
"                             __vm_obj_make( sizeof( __dios_tls ) , _VM_PT_Heap ) ) ),\x0a"
"                 _proc( nullptr ), _fun( nullptr )\x0a"
"        {}\x0a"
"\x0a"
"        template< typename F >\x0a"
"        task( F routine, int tls_size, process *proc ) noexcept\x0a"
"            \x3a _frame( nullptr ),\x0a"
"              _proc( proc ),\x0a"
"              _fun( __md_get_pc_meta( reinterpret_cast< _VM_CodePointer >( routine ) ) )\x0a"
"        {\x0a"
"            setup_stack();\x0a"
"            const auto size = sizeof( __dios_tls ) + tls_size;\x0a"
"            _tls = static_cast< __dios_tls * >( __vm_obj_make( size, _VM_PT_Heap ) );\x0a"
"            _tls->__errno = 0;\x0a"
"        }\x0a"
"\x0a"
"        template< typename F >\x0a"
"        task( void *frame, void *tls, F routine, int tls_size, process *proc ) noexcept\x0a"
"            \x3a _frame( nullptr ),\x0a"
"              _proc( proc ),\x0a"
"              _fun( __md_get_pc_meta( reinterpret_cast< _VM_CodePointer >( routine ) ) )\x0a"
"        {\x0a"
"            setup_stack( frame );\x0a"
"            _tls = static_cast< __dios_tls * >( tls );\x0a"
"            __vm_obj_resize( _tls, sizeof( __dios_tls ) + tls_size );\x0a"
"            _tls->__errno = 0;\x0a"
"        }\x0a"
"\x0a"
"        task( const task\x26 o ) noexcept = delete;\x0a"
"        task\x26 operator=( const task\x26 o ) noexcept = delete;\x0a"
"\x0a"
"        task( task \x26\x26o ) noexcept\x0a"
"            \x3a _frame( o._frame ), _tls( o._tls ), _proc( o._proc )\x0a"
"        {\x0a"
"            o._frame = nullptr;\x0a"
"            o._tls = nullptr;\x0a"
"        }\x0a"
"\x0a"
"        task \x26operator=( task \x26\x26o ) noexcept\x0a"
"        {\x0a"
"            std\x3a\x3aswap( _frame, o._frame );\x0a"
"            std\x3a\x3aswap( _tls, o._tls );\x0a"
"            std\x3a\x3aswap( _proc, o._proc );\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"        \x7etask() noexcept\x0a"
"        {\x0a"
"            free_stack();\x0a"
"            __vm_obj_free( _tls );\x0a"
"        }\x0a"
"\x0a"
"        bool active() const noexcept { return _frame; }\x0a"
"        __dios_task get_id() const noexcept { return _tls; }\x0a"
"        uint32_t get_user_id() const noexcept\x0a"
"        {\x0a"
"            auto tid = reinterpret_cast< uint64_t >( _tls ) >> 32;\x0a"
"            return static_cast< uint32_t >( tid );\x0a"
"        }\x0a"
"\x0a"
"        void setup_stack( void *frame = nullptr ) noexcept\x0a"
"        {\x0a"
"            free_stack();\x0a"
"            if ( frame )\x0a"
"            {\x0a"
"                _frame = static_cast< _VM_Frame * >( frame );\x0a"
"                __vm_obj_resize( _frame, _fun->frame_size );\x0a"
"            }\x0a"
"            else\x0a"
"                _frame = static_cast< _VM_Frame * >( __vm_obj_make( _fun->frame_size, _VM_PT_Heap ) );\x0a"
"            _frame->pc = _fun->entry_point;\x0a"
"            _frame->parent = nullptr;\x0a"
"        }\x0a"
"\x0a"
"    private\x3a\x0a"
"\x0a"
"        void free_stack() noexcept\x0a"
"        {\x0a"
"            if ( _frame \x26\x26 _tls == __dios_this_task() )\x0a"
"                __dios_stack_cut( __dios_this_frame(), _frame );\x0a"
"            if ( _frame )\x0a"
"                __dios_stack_free( _frame, nullptr );\x0a"
"\x0a"
"            _frame = nullptr;\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"}\x0a"
"", 4759 ); }