#include <string_view>
namespace divine::str::dios {
extern const std::string_view sys_upcall_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"#include <dios/sys/syscall.hpp>\x0a"
"\x0a"
"namespace __dios\x0a"
"{\x0a"
"\x0a"
"    /* Implements calls that depend on the entire stack. This component is\x0a"
"     * always at the top of the stack and its functionality is in virtual\x0a"
"     * method overrides (and they are declared in \x60""BaseContext\x60). */\x0a"
"\x0a"
"    template< typename Conf >\x0a"
"    struct Upcall \x3a Conf\x0a"
"    {\x0a"
"        using Process = typename Conf\x3a\x3aProcess;\x0a"
"        using BaseProcess = typename BaseContext\x3a\x3aProcess;\x0a"
"\x0a"
"        /* This method is used by the kernel to force a reschedule in the\x0a"
"         * middle of a system call, usually because the task that is currently\x0a"
"         * running was killed. Do not confuse with __dios_reschedule() which is\x0a"
"         * instrumented into userspace code by LART to facilitate task\x0a"
"         * preemption. */\x0a"
"\x0a"
"        virtual void reschedule() override\x0a"
"        {\x0a"
"            if ( this->check_final() )\x0a"
"                this->finalize();\x0a"
"            __dios_stack_free( __dios_parent_frame(), nullptr );\x0a"
"            __vm_suspend();\x0a"
"        }\x0a"
"\x0a"
"        virtual BaseProcess *make_process( BaseProcess *bp ) override\x0a"
"        {\x0a"
"            if ( bp )\x0a"
"                return new Process( *static_cast< Process * >( bp ) );\x0a"
"            else\x0a"
"                return new Process();\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"}\x0a"
"", 2104 ); }