#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_base_cpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#include <dios/vfs/base.hpp>\x0a"
"#include <sys/vmutil.h>\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"    bool check_key( const _VM_Env *env, const char *suffix )\x0a"
"    {\x0a"
"        const auto npos = std\x3a\x3astring_view\x3a\x3anpos;\x0a"
"        std\x3a\x3astring_view key( env->key );\x0a"
"\x0a"
"        if ( key.substr( 0, 4 ) \x21= \x22vfs.\x22 \x7c\x7c key == \x22vfs.stdin\x22 )\x0a"
"            return false;\x0a"
"\x0a"
"        if ( key.find( suffix ) == npos )\x0a"
"            return __dios_trace_f( \x22unexpected vfs key \x25s\x22, env->key ), false;\x0a"
"\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    bool Base\x3a\x3aimport( const _VM_Env *env, ArrayMap< ino_t, Node > \x26nodes )\x0a"
"    {\x0a"
"        if ( \x21""env->key )\x0a"
"            return true;\x0a"
"\x0a"
"        if ( \x21""check_key( env, \x22.name\x22 ) )\x0a"
"            return import( env + 1, nodes );\x0a"
"\x0a"
"        std\x3a\x3astring_view name( env->value, env->size );\x0a"
"        ++ env;\x0a"
"\x0a"
"        if ( \x21""check_key( env, \x22.stat\x22 ) )\x0a"
"            return false;\x0a"
"\x0a"
"        const auto \x26st = *reinterpret_cast< const __vmutil_stat * >( env->value );\x0a"
"        ++env;\x0a"
"\x0a"
"        if ( \x21""check_key( env, \x22.content\x22 ) )\x0a"
"            return false;\x0a"
"\x0a"
"        if ( name == \x22/\x22 \x7c\x7c name == \x22.\x22 )\x0a"
"        {\x0a"
"            root()->set_stat( st );\x0a"
"            __dios_assert( root()->mode().is_dir() );\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            std\x3a\x3astring_view content( env->value, env->size );\x0a"
"            auto ino = nodes.count( st.st_ino ) \x3f nodes\x5b st.st_ino \x5d \x3a new_node( st.st_mode, false );\x0a"
"\x0a"
"            if ( ino->mode().is_link() )\x0a"
"                ino->as< SymLink >()->target( content );\x0a"
"\x0a"
"            if ( ino->mode().is_file() )\x0a"
"                ino->as< RegularFile >()->content( content );\x0a"
"\x0a"
"            ino->set_stat( st );\x0a"
"            nodes\x5b st.st_ino \x5d = ino;\x0a"
"            link_node( root(), name, ino );\x0a"
"        }\x0a"
"\x0a"
"        return import( env + 1, nodes );\x0a"
"    }\x0a"
"}\x0a"
"", 2574 ); }