#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_base_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#include <dios/vfs/inode.hpp>\x0a"
"#include <dios/vfs/fd.hpp>\x0a"
"#include <dios/vfs/directory.hpp>\x0a"
"#include <dios/vfs/file.hpp>\x0a"
"#include <dios/vfs/socket.hpp>\x0a"
"#include <sys/un.h>\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"    /* A per-process information related to the filesystem.\x0a"
"       This gets injected the Process struct which is part of the scheduler\x0a"
"       configuration (see VFS). */\x0a"
"    struct ProcessInfo\x0a"
"    {\x0a"
"        Mode _umask;\x0a"
"        Node _cwd;\x0a"
"        Array< short > _fd_refs;\x0a"
"        Array< FileDescriptor > _fds;\x0a"
"    };\x0a"
"\x0a"
"    /* A base of the virtual file system. Defines basic building operations and\x0a"
"       import of VFS images. */\x0a"
"    struct Base\x0a"
"    {\x0a"
"        virtual ProcessInfo \x26proc() = 0;\x0a"
"        virtual Node root() = 0;\x0a"
"\x0a"
"        FileDescriptor *get_fd( int fd )\x0a"
"        {\x0a"
"            auto \x26open = proc()._fd_refs;\x0a"
"            if ( fd >= 0 \x26\x26 fd < int( open.size() ) \x26\x26 open\x5b fd \x5d >= 0 )\x0a"
"                return \x26proc()._fds\x5b open\x5b fd \x5d \x5d;\x0a"
"            return nullptr;\x0a"
"        }\x0a"
"\x0a"
"        int new_fd( Node n, OFlags flags, int min = 0 )\x0a"
"        {\x0a"
"            auto \x26open = proc()._fd_refs;\x0a"
"            int fd;\x0a"
"\x0a"
"            if ( min >= int( open.size() ) )\x0a"
"                open.resize( min + 1 );\x0a"
"\x0a"
"            for ( fd = min; fd < int( open.size() ); ++ fd )\x0a"
"                if ( \x21get_fd( fd ) )\x0a"
"                    break;\x0a"
"\x0a"
"            if ( fd == int( open.size() ) )\x0a"
"                open.emplace_back();\x0a"
"\x0a"
"            if ( n )\x0a"
"            {\x0a"
"                open\x5b fd \x5d = proc()._fds.size();\x0a"
"                auto \x26newfd = proc()._fds.emplace_back( n, flags );\x0a"
"                newfd.ref();\x0a"
"            }\x0a"
"\x0a"
"            return fd;\x0a"
"        }\x0a"
"\x0a"
"        Node new_node( Mode mode, bool apply_umask = true )\x0a"
"        {\x0a"
"            Node r;\x0a"
"\x0a"
"            if ( mode.is_socket() )\x0a"
"                r = new SocketDatagram();\x0a"
"\x0a"
"            if ( mode.is_file() )\x0a"
"                r = new RegularFile();\x0a"
"\x0a"
"            if ( mode.is_dir() )\x0a"
"                r = new Directory();\x0a"
"\x0a"
"            if ( mode.is_fifo() )\x0a"
"                r = new Pipe();\x0a"
"\x0a"
"            if ( mode.is_link() )\x0a"
"                r = new SymLink();\x0a"
"\x0a"
"            if ( apply_umask )\x0a"
"                mode \x26= \x7eproc()._umask;\x0a"
"\x0a"
"            if ( r )\x0a"
"                r->mode( mode );\x0a"
"\x0a"
"            return r;\x0a"
"        }\x0a"
"\x0a"
"        FileDescriptor *check_fd( int fd_, int acc )\x0a"
"        {\x0a"
"            auto fd = get_fd( fd_ );\x0a"
"            if ( \x21""fd )\x0a"
"                return error( EBADF ), nullptr;\x0a"
"\x0a"
"            auto ino = fd->inode();\x0a"
"            if ( \x21ino )\x0a"
"                return error( EBADF ), nullptr;\x0a"
"\x0a"
"            if ( ( acc \x26 W_OK ) \x26\x26 \x21""fd->flags().write() )\x0a"
"                return error( EBADF ), nullptr;\x0a"
"            if ( ( acc \x26 R_OK ) \x26\x26 \x21""fd->flags().read() )\x0a"
"                return error( EBADF ), nullptr;\x0a"
"\x0a"
"            if ( fd->inode()->mode().is_dir() )\x0a"
"                if ( ( acc \x26 R_OK ) \x26\x26 \x21""fd->flags().has( O_DIRECTORY ) )\x0a"
"                    return error( EISDIR ), nullptr;\x0a"
"\x0a"
"            return fd;\x0a"
"        }\x0a"
"\x0a"
"        Node get_dir( int fd = AT_FDCWD )\x0a"
"        {\x0a"
"            if ( fd == AT_FDCWD )\x0a"
"                return proc()._cwd;\x0a"
"            else if ( auto n = get_fd( fd ) )\x0a"
"                return n->inode();\x0a"
"            else return error( EBADF ), nullptr;\x0a"
"        }\x0a"
"\x0a"
"        using split_view = std\x3a\x3apair< std\x3a\x3astring_view, std\x3a\x3astring_view >;\x0a"
"\x0a"
"        split_view split( std\x3a\x3astring_view p, char d, bool reverse = false )\x0a"
"        {\x0a"
"            auto npos = std\x3a\x3astring\x3a\x3anpos;\x0a"
"            auto s = reverse \x3f p.rfind( d ) \x3a p.find( d );\x0a"
"            if ( s == npos )\x0a"
"                return reverse \x3f split_view{ \x22\x22, p } \x3a split_view{ p, \x22\x22 };\x0a"
"            return { p.substr( 0, s ), p.substr( s + 1, npos ) };\x0a"
"        }\x0a"
"\x0a"
"        Node lookup_relative( Node dir, std\x3a\x3astring_view path, bool follow, int depth = 8 )\x0a"
"        {\x0a"
"            if ( path.empty() )\x0a"
"                return dir;\x0a"
"\x0a"
"            if ( \x21""depth )\x0a"
"                return error( ELOOP ), nullptr;\x0a"
"\x0a"
"            if ( \x21""dir->mode().is_dir() )\x0a"
"                return error( ENOTDIR ), nullptr;\x0a"
"\x0a"
"            if ( \x21""dir->mode().user_exec() )\x0a"
"                return error( EACCES ), nullptr;\x0a"
"\x0a"
"            auto \x5b name, tail \x5d = split( path, '/' );\x0a"
"            if ( name.size() > FILE_NAME_LIMIT )\x0a"
"                return error( ENAMETOOLONG ), nullptr;\x0a"
"\x0a"
"            if ( auto next = dir->template as< Directory >()->find( name ) )\x0a"
"            {\x0a"
"                if ( next->mode().is_link() )\x0a"
"                {\x0a"
"                    auto link = next->template as< SymLink >();\x0a"
"                    if ( follow \x7c\x7c \x21tail.empty() )\x0a"
"                        return lookup_relative( lookup( dir, link->target(), follow ),\x0a"
"                                                tail, follow, depth - 1 );\x0a"
"                }\x0a"
"\x0a"
"                return lookup_relative( next, tail, follow, depth - 1 );\x0a"
"            }\x0a"
"            else\x0a"
"                return error( ENOENT ), nullptr;\x0a"
"        }\x0a"
"\x0a"
"        Node lookup( Node dir, std\x3a\x3astring_view path, bool follow )\x0a"
"        {\x0a"
"            auto npos = std\x3a\x3astring\x3a\x3anpos;\x0a"
"\x0a"
"            if ( path.size() > PATH_LIMIT )\x0a"
"                return error( ENAMETOOLONG ), nullptr;\x0a"
"\x0a"
"            if ( path.size() \x26\x26 path\x5b""0\x5d == '/' )\x0a"
"                return lookup( root(), path.substr( 1, npos ), follow );\x0a"
"            else\x0a"
"                return lookup_relative( dir, path, follow, 8 );\x0a"
"        }\x0a"
"\x0a"
"        std\x3a\x3apair< Node, std\x3a\x3astring_view > lookup_dir( Node dir, std\x3a\x3astring_view path, bool follow )\x0a"
"        {\x0a"
"            auto null = std\x3a\x3amake_pair( nullptr, \x22\x22 );\x0a"
"\x0a"
"            if ( path.size() > PATH_LIMIT )\x0a"
"                return error( ENAMETOOLONG ), null;\x0a"
"\x0a"
"            if ( \x21path.empty() \x26\x26 path\x5b""0\x5d == '/' )\x0a"
"                return lookup_dir( root(), path.substr( 1, String\x3a\x3anpos ), follow );\x0a"
"\x0a"
"            auto \x5b parent_path, name \x5d = split( path, '/', true );\x0a"
"            auto parent = lookup( dir, parent_path, follow );\x0a"
"\x0a"
"            if ( \x21parent )\x0a"
"                return null;\x0a"
"            if ( \x21parent->mode().is_dir() )\x0a"
"                return error( ENOTDIR ), null;\x0a"
"\x0a"
"            return { parent, name };\x0a"
"        }\x0a"
"\x0a"
"        bool link_node( Node dir, std\x3a\x3astring_view path, Node ino, bool overwrite = false )\x0a"
"        {\x0a"
"            auto \x5b parent, name \x5d = lookup_dir( dir, path, true );\x0a"
"\x0a"
"            if ( \x21parent )\x0a"
"                return false;\x0a"
"\x0a"
"            if ( ino->mode().is_dir() )\x0a"
"                ino->as< Directory >()->parent( parent );\x0a"
"            return parent->as< Directory >()->create( name, ino, overwrite );\x0a"
"        }\x0a"
"\x0a"
"        std\x3a\x3apair< Node, std\x3a\x3astring_view > get_sock( int sockfd, const sockaddr *addr, socklen_t )\x0a"
"        {\x0a"
"            auto null = std\x3a\x3amake_pair( nullptr, \x22\x22 );\x0a"
"            auto sock = check_fd( sockfd, F_OK );\x0a"
"\x0a"
"            if ( \x21sock )\x0a"
"                return null;\x0a"
"            if ( \x21""addr )\x0a"
"                return error( EFAULT ), null;\x0a"
"\x0a"
"            if ( addr->sa_family \x21= AF_UNIX )\x0a"
"                return error( EAFNOSUPPORT ), null;\x0a"
"\x0a"
"            /* FIXME check the size of addr against len */\x0a"
"            auto un = reinterpret_cast< const sockaddr_un * >( addr );\x0a"
"            return { sock->inode(), un->sun_path };\x0a"
"        }\x0a"
"\x0a"
"        bool address_out( Node socket, sockaddr *addr, socklen_t *len )\x0a"
"        {\x0a"
"            if ( \x21len )\x0a"
"                return error( EFAULT ), false;\x0a"
"\x0a"
"            if ( addr )\x0a"
"            {\x0a"
"                auto asun = reinterpret_cast< sockaddr_un * >( addr );\x0a"
"                asun->sun_family = AF_UNIX;\x0a"
"                size_t space = *len - sizeof( sockaddr ),\x0a"
"                       size = socket->address().size();\x0a"
"                std\x3a\x3astrncpy( asun->sun_path, socket->address().begin(), std\x3a\x3amin( space, size ) );\x0a"
"                if ( space > size )\x0a"
"                    asun->sun_path\x5b size \x5d = 0;\x0a"
"                *len = size + 1 + sizeof( sockaddr );\x0a"
"            }\x0a"
"\x0a"
"            return true;\x0a"
"        }\x0a"
"\x0a"
"        bool import( const _VM_Env *env, ArrayMap< ino_t, Node > \x26 );\x0a"
"        bool import( const _VM_Env *env )\x0a"
"        {\x0a"
"            ArrayMap< ino_t, Node > map;\x0a"
"            return import( env, map );\x0a"
"        }\x0a"
"    };\x0a"
"}\x0a"
"", 8855 ); }