#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_directory_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2015 Ji\xc5\x99\xc3\xad Weiser\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"#include <memory>\x0a"
"#include <cerrno>\x0a"
"#include <dirent.h>\x0a"
"#include <string_view>\x0a"
"#include <util/array.hpp>\x0a"
"#include <dios.h> /* __dios_assert */\x0a"
"\x0a"
"#include <dios/vfs/inode.hpp>\x0a"
"#include <dios/vfs/flags.hpp>\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"\x0a"
"/* A name and a pointer to corresponding inode */\x0a"
"struct DirectoryEntry\x0a"
"{\x0a"
"    DirectoryEntry( std\x3a\x3astring_view name, Node inode ) \x3a\x0a"
"        _inode( std\x3a\x3amove( inode ) )\x0a"
"    {\x0a"
"        _name.assign( name.size(), name.begin(), name.end() );\x0a"
"    }\x0a"
"\x0a"
"    std\x3a\x3astring_view name() const { return { _name.begin(), _name.size() }; }\x0a"
"    Node inode() const { return _inode; }\x0a"
"\x0a"
"private\x3a\x0a"
"    Array< char > _name;\x0a"
"    Node _inode;\x0a"
"};\x0a"
"\x0a"
"/* Directory is a list of entries + a pointer to inode of its parent.\x0a"
"   It makes it possible to create, delete (unlink), and find its sub-entries.\x0a"
"   Reading it produces a list of struct dirent elements. */\x0a"
"struct Directory \x3a INode\x0a"
"{\x0a"
"    using Items = Array< DirectoryEntry >;\x0a"
"\x0a"
"    Directory( Node parent = Node{} )\x0a"
"        \x3a _items{}, _parent( parent )\x0a"
"    {}\x0a"
"\x0a"
"    size_t size() const override { return _items.size() + 2; }\x0a"
"    bool special_name( std\x3a\x3astring_view name ) const { return name == \x22.\x22 \x7c\x7c name == \x22..\x22; }\x0a"
"\x0a"
"    std\x3a\x3astring_view name()\x0a"
"    {\x0a"
"        if ( _parent == this )\x0a"
"            return \x22/\x22;\x0a"
"        for ( const auto \x26""entry \x3a _parent->as< Directory >()->_items )\x0a"
"            if ( entry.inode() == this )\x0a"
"                return entry.name();\x0a"
"        __builtin_unreachable();\x0a"
"    }\x0a"
"\x0a"
"    void parent( Node p ) { _parent = p; }\x0a"
"    Node parent() const { return _parent; }\x0a"
"\x0a"
"    bool create( std\x3a\x3astring_view name, Node inode, bool overwrite )\x0a"
"    {\x0a"
"        if ( name.size() > FILE_NAME_LIMIT )\x0a"
"            return error( ENAMETOOLONG ), false;\x0a"
"        if ( special_name( name ) )\x0a"
"            return error( EEXIST ), false;\x0a"
"        if ( _insertItem( DirectoryEntry( name, std\x3a\x3amove( inode ) ), overwrite ) )\x0a"
"        {\x0a"
"            inode->link();\x0a"
"            if ( inode->mode().is_dir() )\x0a"
"                link();\x0a"
"            return true;\x0a"
"        }\x0a"
"        return false;\x0a"
"    }\x0a"
"\x0a"
"    Node find( std\x3a\x3astring_view name )\x0a"
"    {\x0a"
"        if ( name == \x22.\x22 )\x0a"
"            return this;\x0a"
"        if ( name == \x22..\x22 )\x0a"
"            return _parent \x3f _parent \x3a this;\x0a"
"\x0a"
"        auto position = _findItem( name );\x0a"
"        if ( position == _items.end() \x7c\x7c name \x21= position->name() )\x0a"
"            return Node();\x0a"
"        return position->inode();\x0a"
"    }\x0a"
"\x0a"
"    bool unlink( std\x3a\x3astring_view name )\x0a"
"    {\x0a"
"        auto position = _findItem( name );\x0a"
"        if ( position == _items.end() \x7c\x7c name \x21= position->name() )\x0a"
"            return error( ENOENT ), false;\x0a"
"        else\x0a"
"        {\x0a"
"            if ( position->inode()->mode().is_dir() )\x0a"
"                INode\x3a\x3aunlink();\x0a"
"            position->inode()->unlink();\x0a"
"            _items.erase( position );\x0a"
"            return true;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    bool empty() { return _items.empty(); }\x0a"
"\x0a"
"    bool read( char *buf, size_t offset, size_t \x26length ) override\x0a"
"    {\x0a"
"        if ( length \x21= sizeof( struct dirent ) )\x0a"
"            return error( EINVAL ), false;\x0a"
"\x0a"
"        int idx = offset / sizeof( struct dirent );\x0a"
"\x0a"
"        auto do_read = \x5b\x26\x5d( std\x3a\x3astring_view name, int inode )\x0a"
"        {\x0a"
"            struct dirent *dst = reinterpret_cast< struct dirent *>( buf );\x0a"
"            dst->d_ino = inode;\x0a"
"            char *x = std\x3a\x3a""copy( name.begin(), name.end(), dst->d_name );\x0a"
"            *x = '\x5c""0';\x0a"
"            return true;\x0a"
"        };\x0a"
"\x0a"
"        if ( idx == 0 )\x0a"
"            return do_read( \x22.\x22, ino() );\x0a"
"        if ( idx == 1 )\x0a"
"            return do_read( \x22..\x22, _parent \x3f _parent->ino() \x3a ino() );\x0a"
"        if ( idx - 2 == int( _items.size() ) )\x0a"
"            return length = 0, true;\x0a"
"\x0a"
"        __dios_assert( idx - 2 < int( _items.size() ) );\x0a"
"\x0a"
"        auto \x26item = _items\x5b idx - 2 \x5d;\x0a"
"        return do_read( item.name(), item.inode()->ino() );\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"    bool _insertItem( DirectoryEntry \x26\x26""entry, bool force )\x0a"
"    {\x0a"
"        auto position = _findItem( entry.name() );\x0a"
"        if ( position == _items.end() )\x0a"
"            _items.emplace_back( std\x3a\x3amove( entry ) );\x0a"
"        else if ( position->name() \x21= entry.name() )\x0a"
"            _items.insert( position, std\x3a\x3amove( entry ) );\x0a"
"        else if ( force )\x0a"
"            *position = std\x3a\x3amove( entry );\x0a"
"        else\x0a"
"            return error( EEXIST ), false;\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    Items\x3a\x3aiterator _findItem( std\x3a\x3astring_view name )\x0a"
"    {\x0a"
"        return std\x3a\x3alower_bound(\x0a"
"            _items.begin(),\x0a"
"            _items.end(),\x0a"
"            name,\x0a"
"            \x5b\x5d( const DirectoryEntry \x26""entry, std\x3a\x3astring_view name ) {\x0a"
"                return entry.name() < name;\x0a"
"            } );\x0a"
"    }\x0a"
"\x0a"
"    Items _items;\x0a"
"    Node _parent;\x0a"
"};\x0a"
"\x0a"
"}\x0a"
"", 5521 ); }