#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_fd_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2015 Ji\xc5\x99\xc3\xad Weiser\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"#include <memory>\x0a"
"#include <dirent.h>\x0a"
"\x0a"
"#include <dios/vfs/flags.hpp>\x0a"
"#include <dios/vfs/inode.hpp>\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"\x0a"
"/* Keeps track of an inode and offset using for writing to it/reading from it. */\x0a"
"struct FileDescriptor\x0a"
"{\x0a"
"    FileDescriptor( Node inode, OFlags fl, size_t offset = 0 ) \x3a\x0a"
"        _inode( inode ),\x0a"
"        _flags( fl ),\x0a"
"        _offset( offset )\x0a"
"    {\x0a"
"        inode->open( *this );\x0a"
"    }\x0a"
"\x0a"
"    \x7e""FileDescriptor()\x0a"
"    {\x0a"
"        if ( _inode )\x0a"
"            _inode->close( *this );\x0a"
"    }\x0a"
"\x0a"
"    FileDescriptor( const FileDescriptor \x26 ) noexcept = default; /* used during fork */\x0a"
"    FileDescriptor( FileDescriptor \x26\x26 ) noexcept = default;\x0a"
"    FileDescriptor \x26operator=( FileDescriptor \x26\x26 ) noexcept = default;\x0a"
"\x0a"
"    long long read( void *buf, size_t length )\x0a"
"    {\x0a"
"        if ( length == 0 )\x0a"
"            return 0;\x0a"
"\x0a"
"        if ( _flags.nonblock() \x26\x26 \x21_inode->canRead() )\x0a"
"            return error( EAGAIN ), -1;\x0a"
"\x0a"
"        char *dst = reinterpret_cast< char * >( buf );\x0a"
"        if ( \x21_inode->read( dst, _offset, length ) )\x0a"
"            return -1;\x0a"
"\x0a"
"        _offset += length;\x0a"
"        return length;\x0a"
"    }\x0a"
"\x0a"
"    long long write( const void *buf, size_t length, Node remote = nullptr )\x0a"
"    {\x0a"
"        if ( _flags.nonblock() \x26\x26 \x21_inode->canWrite( length, remote ) )\x0a"
"            return error( EAGAIN ), -1;\x0a"
"\x0a"
"        if ( _flags.has( O_APPEND ) )\x0a"
"            _offset = _inode->size();\x0a"
"\x0a"
"        const char *src = reinterpret_cast< const char * >( buf );\x0a"
"\x0a"
"        if ( \x21_inode->write( src, _offset, length, remote ) )\x0a"
"            return -1;\x0a"
"\x0a"
"        _offset += length;\x0a"
"        return length;\x0a"
"    }\x0a"
"\x0a"
"    size_t offset() const { return _offset; }\x0a"
"    void offset( size_t off ) { _offset = off; }\x0a"
"    size_t size() { return _inode \x3f _inode->size() \x3a 0; }\x0a"
"    Node inode() const { return _inode; }\x0a"
"    OFlags flags() const { return _flags; }\x0a"
"    OFlags \x26""flags() { return _flags; }\x0a"
"    explicit operator bool() const { return bool( _inode );}\x0a"
"\x0a"
"    void close()\x0a"
"    {\x0a"
"        _inode->close( *this );\x0a"
"        _inode = nullptr;\x0a"
"        _flags = 0;\x0a"
"        _offset = 0;\x0a"
"    }\x0a"
"\x0a"
"    void ref() { ++_refcnt; }\x0a"
"    void unref() { if ( \x21--_refcnt ) close(); }\x0a"
"\x0a"
"protected\x3a\x0a"
"    Node _inode;\x0a"
"    OFlags _flags;\x0a"
"    size_t _offset;\x0a"
"    short _refcnt = 0;\x0a"
"};\x0a"
"\x0a"
"}\x0a"
"", 3120 ); }