#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_file_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2015 Ji\xc5\x99\xc3\xad Weiser\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"#include <algorithm>\x0a"
"#include <signal.h>\x0a"
"#include <dios.h>\x0a"
"#include <sys/fault.h>\x0a"
"#include <sys/trace.h>\x0a"
"\x0a"
"#include <dios/sys/memory.hpp>\x0a"
"#include <dios/sys/kernel.hpp> /* get_debug */\x0a"
"\x0a"
"#include <dios/vfs/inode.hpp>\x0a"
"#include <dios/vfs/fd.hpp>\x0a"
"#include <dios/vfs/stream.hpp>\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"\x0a"
"struct SymLink \x3a INode\x0a"
"{\x0a"
"    SymLink( std\x3a\x3astring_view t = \x22\x22 ) { target( t ); }\x0a"
"\x0a"
"    size_t size() const override { return _target.size(); }\x0a"
"    std\x3a\x3astring_view target() const { return { _target.begin(), _target.size() }; }\x0a"
"    void target( std\x3a\x3astring_view s ) { _target.assign( s.size(), s.begin(), s.end() ); }\x0a"
"\x0a"
"private\x3a\x0a"
"    Array< char > _target;\x0a"
"};\x0a"
"\x0a"
"struct RegularFile \x3a INode\x0a"
"{\x0a"
"    RegularFile() = default;\x0a"
"\x0a"
"    RegularFile( const RegularFile \x26other ) = default;\x0a"
"    RegularFile( RegularFile \x26\x26other ) = default;\x0a"
"    RegularFile \x26operator=( RegularFile ) = delete;\x0a"
"\x0a"
"    size_t size() const override { return _content.size(); }\x0a"
"    bool canRead() const override { return true; }\x0a"
"    bool canWrite( int, Node ) const override { return true; }\x0a"
"\x0a"
"    bool read( char *buffer, size_t offset, size_t \x26length ) override\x0a"
"    {\x0a"
"        if ( offset >= size() )\x0a"
"        {\x0a"
"            length = 0;\x0a"
"            return true;\x0a"
"        }\x0a"
"\x0a"
"        auto begin = _content.begin() + offset;\x0a"
"        if ( offset + length > size() )\x0a"
"            length = size() - offset;\x0a"
"        std\x3a\x3a""copy( begin, begin + length, buffer );\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    bool write( const char *buffer, size_t offset, size_t \x26length, Node ) override\x0a"
"    {\x0a"
"        if ( _content.size() < offset + length )\x0a"
"            resize( offset + length );\x0a"
"\x0a"
"        std\x3a\x3a""copy( buffer, buffer + length, _content.begin() + offset );\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    void resize( size_t length )\x0a"
"    {\x0a"
"        _content.resize( length );\x0a"
"    }\x0a"
"\x0a"
"    void content( std\x3a\x3astring_view s )\x0a"
"    {\x0a"
"        resize( s.size() );\x0a"
"        std\x3a\x3a""copy( s.begin(), s.end(), _content.begin() );\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    Array< char > _content;\x0a"
"};\x0a"
"\x0a"
"struct NullFile \x3a INode\x0a"
"{\x0a"
"    bool canWrite( int, Node ) const override { return true; }\x0a"
"    bool write( const char *, size_t, size_t \x26, Node ) override { return true; }\x0a"
"};\x0a"
"\x0a"
"/* Each write is propagated to the trace/counterexample. */\x0a"
"struct VmTraceFile \x3a INode\x0a"
"{\x0a"
"    bool canWrite( int, Node ) const override { return true; }\x0a"
"\x0a"
"    __debugfn void do_write( const char *buffer, size_t \x26length ) noexcept\x0a"
"    {\x0a"
"        if ( buffer\x5b length - 1 \x5d == 0 )\x0a"
"            __dios_trace_internal( 0, \x22\x25s\x22, buffer );\x0a"
"        else\x0a"
"        {\x0a"
"            char buf\x5b length + 1 \x5d;\x0a"
"            std\x3a\x3a""copy( buffer, buffer + length, buf );\x0a"
"            buf\x5b length \x5d = 0;\x0a"
"            __dios_trace_internal( 0, \x22\x25s\x22, buf );\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    bool write( const char *buffer, size_t, size_t \x26length, Node ) override\x0a"
"    {\x0a"
"        do_write( buffer, length );\x0a"
"        return true;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"/* Each written line is propagated to the trace/counterexample. */\x0a"
"struct VmBuffTraceFile \x3a INode\x0a"
"{\x0a"
"    bool canWrite( int, Node ) const override { return true; }\x0a"
"\x0a"
"    __debugfn void do_write( const char *data, size_t \x26length ) noexcept\x0a"
"    {\x0a"
"        auto \x26""buf = get_debug().trace_buf\x5b __dios_this_task() \x5d;\x0a"
"        buf.append( length, data, data + length );\x0a"
"        void *mem = buf.begin();\x0a"
"        auto nl = std\x3a\x3a""find( buf.rbegin(), buf.rend(), '\x5cn' );\x0a"
"        if ( nl \x21= buf.rend() )\x0a"
"        {\x0a"
"            __dios_trace_internal( 0, \x22\x25.*s\x22, int( buf.rend() - nl - 1 ), buf.begin() );\x0a"
"            buf.erase( buf.begin(), nl.base() );\x0a"
"        }\x0a"
"        get_debug().persist();\x0a"
"        get_debug().persist_buffers();\x0a"
"        __vm_trace( _VM_T_DebugPersist, mem );\x0a"
"    }\x0a"
"\x0a"
"    __debugfn void do_flush() noexcept\x0a"
"    {\x0a"
"        for ( auto \x26""b \x3a get_debug().trace_buf )\x0a"
"        {\x0a"
"            if ( \x21""b.second.empty() )\x0a"
"                __dios_trace_internal( 0, \x22\x25.*s\x22, b.second.size(), b.second.begin() );\x0a"
"            b.second.clear();\x0a"
"        }\x0a"
"        get_debug().persist();\x0a"
"        get_debug().persist_buffers();\x0a"
"    }\x0a"
"\x0a"
"    bool write( const char *data, size_t, size_t \x26 length, Node ) override\x0a"
"    {\x0a"
"        do_write( data, length );\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    \x7eVmBuffTraceFile() { do_flush(); }\x0a"
"};\x0a"
"\x0a"
"/* For simulation of stdin from a file (passed to the verifier) */\x0a"
"struct StandardInput \x3a INode\x0a"
"{\x0a"
"    StandardInput() \x3a\x0a"
"        _content( nullptr ),\x0a"
"        _size( 0 )\x0a"
"    {}\x0a"
"\x0a"
"    StandardInput( const char *content, size_t size ) \x3a\x0a"
"        _content( content ),\x0a"
"        _size( size )\x0a"
"    {}\x0a"
"\x0a"
"    size_t size() const override { return _size; }\x0a"
"\x0a"
"    bool canRead() const override\x0a"
"    {\x0a"
"        // simulate user drinking coffee\x0a"
"        if ( _size )\x0a"
"            return __vm_choose( 2 ) == 0;\x0a"
"        return false;\x0a"
"    }\x0a"
"\x0a"
"    bool read( char *buffer, size_t offset, size_t \x26length ) override\x0a"
"    {\x0a"
"        if ( offset >= _size ) {\x0a"
"            length = 0;\x0a"
"            return true;\x0a"
"        }\x0a"
"        const char *source = _content + offset;\x0a"
"        if ( offset + length > _size )\x0a"
"            length = _size - offset;\x0a"
"        std\x3a\x3a""copy( source, source + length, buffer );\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    const char *_content;\x0a"
"    size_t _size;\x0a"
"};\x0a"
"\x0a"
"struct Pipe \x3a INode\x0a"
"{\x0a"
"    Pipe() \x3a\x0a"
"        _stream( PIPE_SIZE_LIMIT ),\x0a"
"        _reader( false ),\x0a"
"        _writer( false )\x0a"
"    {}\x0a"
"\x0a"
"    Pipe( bool r, bool w ) \x3a\x0a"
"        _stream( PIPE_SIZE_LIMIT ),\x0a"
"        _reader( r ),\x0a"
"        _writer( w )\x0a"
"    {}\x0a"
"\x0a"
"    size_t size() const override { return _stream.size(); }\x0a"
"    bool canRead() const override { return size() > 0; }\x0a"
"    bool canWrite( int, Node ) const override { return size() < PIPE_SIZE_LIMIT; }\x0a"
"\x0a"
"    void open( FileDescriptor \x26""fd ) override\x0a"
"    {\x0a"
"        __dios_assert( fd.inode() == this );\x0a"
"\x0a"
"        if ( fd.flags().read() \x26\x26 fd.flags().write() )\x0a"
"            __dios_fault( _VM_Fault\x3a\x3a_VM_F_Assert, \x22Pipe is opened both for reading and writing\x22 );\x0a"
"\x0a"
"        if ( fd.flags().read() )\x0a"
"        {\x0a"
"            if ( \x21""fd.flags().has( O_NONBLOCK ) \x26\x26 \x21writer() )\x0a"
"               __vm_cancel();\x0a"
"            assignReader();\x0a"
"        }\x0a"
"\x0a"
"        if ( fd.flags().write() )\x0a"
"        {\x0a"
"            if ( \x21""fd.flags().has( O_NONBLOCK ) \x26\x26 \x21reader() )\x0a"
"               __vm_cancel();\x0a"
"            assignWriter();\x0a"
"        }\x0a"
"\x0a"
"        fd.flags().clear( O_NONBLOCK );\x0a"
"        INode\x3a\x3aopen( fd );\x0a"
"    }\x0a"
"\x0a"
"    void close( FileDescriptor \x26""fd ) override\x0a"
"    {\x0a"
"        __dios_assert( fd.inode() == this );\x0a"
"        if ( fd.flags().read() )\x0a"
"            releaseReader();\x0a"
"        INode\x3a\x3a""close( fd );\x0a"
"    }\x0a"
"\x0a"
"    bool read( char *buffer, size_t, size_t \x26length ) override\x0a"
"    {\x0a"
"        if ( length == 0 )\x0a"
"            return true;\x0a"
"\x0a"
"        // progress or deadlock\x0a"
"        while ( ( length = _stream.pop( buffer, length ) ) == 0 )\x0a"
"            __vm_cancel();\x0a"
"\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    bool write( const char *buffer, size_t, size_t \x26length, Node ) override\x0a"
"    {\x0a"
"        if ( \x21_reader )\x0a"
"        {\x0a"
"            raise( SIGPIPE );\x0a"
"            return error( EPIPE ), false;\x0a"
"        }\x0a"
"\x0a"
"        // progress or deadlock\x0a"
"        while ( ( length = _stream.push( buffer, length ) ) == 0 )\x0a"
"            __vm_cancel();\x0a"
"\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    void releaseReader() { _reader = false; }\x0a"
"    bool reader() const { return _reader; }\x0a"
"    bool writer() const { return _writer; }\x0a"
"\x0a"
"    void assignReader()\x0a"
"    {\x0a"
"        if ( _reader )\x0a"
"            __dios_fault( _VM_Fault\x3a\x3a_VM_F_Assert, \x22Pipe is opened for reading again.\x22 );\x0a"
"        _reader = true;\x0a"
"    }\x0a"
"\x0a"
"    void assignWriter()\x0a"
"    {\x0a"
"        if ( _writer )\x0a"
"            __dios_fault( _VM_Fault\x3a\x3a_VM_F_Assert, \x22Pipe is opened for writing again.\x22 );\x0a"
"        _writer = true;\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    Stream _stream;\x0a"
"    bool _reader;\x0a"
"    bool _writer;\x0a"
"};\x0a"
"\x0a"
"}\x0a"
"", 8464 ); }