#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_flags_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2015 Ji\xc5\x99\xc3\xad Weiser\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"#include <unistd.h>\x0a"
"#include <fcntl.h>\x0a"
"#include <sys/stat.h>\x0a"
"#include <sys/socket.h>\x0a"
"#include <errno.h>\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"\x0a"
"/* Enable operators for types which inherit from it. */\x0a"
"struct Flags {};\x0a"
"\x0a"
"template< typename Int = unsigned >\x0a"
"struct FlagVal \x3a Flags\x0a"
"{\x0a"
"    Int _value = 0;\x0a"
"    constexpr FlagVal() = default;\x0a"
"    constexpr FlagVal( Int o ) \x3a _value( o ) {} /* implicit */\x0a"
"    explicit constexpr operator bool() const { return _value; }\x0a"
"    constexpr Int to_i() const { return _value; }\x0a"
"};\x0a"
"\x0a"
"template< typename Self, typename Int = unsigned >\x0a"
"struct FlagOps \x3a FlagVal< Int >\x0a"
"{\x0a"
"    using FlagVal< Int >\x3a\x3a""FlagVal;\x0a"
"    constexpr bool has( Self s ) const { return this->_value \x26 s._value; }\x0a"
"    constexpr void clear( Self s ) { this->_value \x26= \x7es._value; }\x0a"
"    constexpr void set( Self s ) { this->_value \x7c= s._value; }\x0a"
"};\x0a"
"\x0a"
"struct OFlags \x3a FlagOps< OFlags >\x0a"
"{\x0a"
"    using FlagOps< OFlags >\x3a\x3a""FlagOps;\x0a"
"    static constexpr unsigned NOACC = O_WRONLY \x7c O_RDWR;\x0a"
"\x0a"
"    constexpr bool read() const     { return \x21( _value \x26 O_WRONLY ); }\x0a"
"    constexpr bool write() const    { return _value \x26 ( O_WRONLY \x7c O_RDWR ); }\x0a"
"    constexpr bool noaccess() const { return ( _value \x26 NOACC ) == NOACC; }\x0a"
"    constexpr bool nonblock() const { return _value \x26 O_NONBLOCK; }\x0a"
"    constexpr bool follow() const   { return \x21( _value \x26 O_NOFOLLOW ) \x26\x26 \x21( _value \x26 O_EXCL ) ; }\x0a"
"};\x0a"
"\x0a"
"struct SFlags \x3a FlagOps< SFlags >\x0a"
"{\x0a"
"    using FlagOps< SFlags >\x3a\x3a""FlagOps;\x0a"
"    constexpr unsigned type() const { return _value \x26 __SOCK_TYPE_MASK; }\x0a"
"};\x0a"
"\x0a"
"struct MFlags \x3a FlagOps< MFlags >\x0a"
"{\x0a"
"    using FlagOps< MFlags >\x3a\x3a""FlagOps;\x0a"
"};\x0a"
"\x0a"
"#undef O_RDONLY\x0a"
"#undef O_WRONLY\x0a"
"#undef O_RDWR\x0a"
"#undef O_CREAT\x0a"
"#undef O_EXCL\x0a"
"#undef O_NOCTTY\x0a"
"#undef O_TRUNC\x0a"
"#undef O_APPEND\x0a"
"#undef O_NONBLOCK\x0a"
"#undef O_NDELAY\x0a"
"#undef O_DIRECTORY\x0a"
"#undef O_NOFOLLOW\x0a"
"\x0a"
"constexpr OFlags O_RDONLY    = _HOST_O_RDONLY;\x0a"
"constexpr OFlags O_WRONLY    = _HOST_O_WRONLY;\x0a"
"constexpr OFlags O_RDWR      = _HOST_O_RDWR;\x0a"
"constexpr OFlags O_CREAT     = _HOST_O_CREAT;\x0a"
"constexpr OFlags O_EXCL      = _HOST_O_EXCL;\x0a"
"constexpr OFlags O_NOCTTY    = _HOST_O_NOCTTY;\x0a"
"constexpr OFlags O_TRUNC     = _HOST_O_TRUNC;\x0a"
"constexpr OFlags O_APPEND    = _HOST_O_APPEND;\x0a"
"constexpr OFlags O_NONBLOCK  = _HOST_O_NONBLOCK;\x0a"
"constexpr OFlags O_DIRECTORY = _HOST_O_DIRECTORY;\x0a"
"constexpr OFlags O_NOFOLLOW  = _HOST_O_NOFOLLOW;\x0a"
"constexpr OFlags O_NDELAY    = O_NONBLOCK;\x0a"
"\x0a"
"#undef SOCK_NONBLOCK\x0a"
"#undef SOCK_CLOEXEC\x0a"
"\x0a"
"constexpr SFlags SOCK_NONBLOCK = _HOST_SOCK_NONBLOCK;\x0a"
"constexpr SFlags SOCK_CLOEXEC  = _HOST_SOCK_CLOEXEC;\x0a"
"\x0a"
"#undef MSG_PEEK\x0a"
"#undef MSG_DONTWAIT\x0a"
"#undef MSG_WAITALL\x0a"
"\x0a"
"constexpr MFlags MSG_PEEK = _HOST_MSG_PEEK;\x0a"
"constexpr MFlags MSG_DONTWAIT = _HOST_MSG_DONTWAIT;\x0a"
"constexpr MFlags MSG_WAITALL = _HOST_MSG_WAITALL;\x0a"
"\x0a"
"template< typename F >\x0a"
"constexpr std\x3a\x3a""enable_if_t< std\x3a\x3ais_base_of_v< Flags, F >, F > operator \x26( F a, F b )\x0a"
"{\x0a"
"    return F( a._value \x26 b._value );\x0a"
"}\x0a"
"\x0a"
"template< typename F >\x0a"
"constexpr std\x3a\x3a""enable_if_t< std\x3a\x3ais_base_of_v< Flags, F >, F > operator \x7c( F a, F b )\x0a"
"{\x0a"
"    return F( a._value \x7c b._value );\x0a"
"}\x0a"
"\x0a"
"template< typename F >\x0a"
"constexpr std\x3a\x3a""enable_if_t< std\x3a\x3ais_base_of_v< Flags, F >, F > operator \x7e( F a )\x0a"
"{\x0a"
"    return F( \x7e""a._value );\x0a"
"}\x0a"
"\x0a"
"template< typename F >\x0a"
"constexpr std\x3a\x3a""enable_if_t< std\x3a\x3ais_base_of_v< Flags, F >, F > \x26operator \x7c= ( F \x26""a, F b )\x0a"
"{\x0a"
"    a._value \x7c= b._value;\x0a"
"    return a;\x0a"
"}\x0a"
"\x0a"
"template< typename F >\x0a"
"constexpr std\x3a\x3a""enable_if_t< std\x3a\x3ais_base_of_v< Flags, F >, F > \x26operator \x26= ( F \x26""a, F b )\x0a"
"{\x0a"
"    a._value \x26= b._value;\x0a"
"    return a;\x0a"
"}\x0a"
"\x0a"
"template< typename F >\x0a"
"constexpr std\x3a\x3a""enable_if_t< std\x3a\x3ais_base_of_v< Flags, F >, bool > operator == ( F a, F b )\x0a"
"{\x0a"
"    return a._value == b._value;\x0a"
"}\x0a"
"\x0a"
"template< typename F >\x0a"
"constexpr std\x3a\x3a""enable_if_t< std\x3a\x3ais_base_of_v< Flags, F >, bool > operator \x21= ( F a, F b )\x0a"
"{\x0a"
"    return a._value \x21= b._value;\x0a"
"}\x0a"
"\x0a"
"const int CURRENT_DIRECTORY = -100;\x0a"
"const int PATH_LIMIT = 1023;\x0a"
"const int FILE_NAME_LIMIT = 255;\x0a"
"const int FILE_DESCRIPTOR_LIMIT = 1024;\x0a"
"const int PIPE_SIZE_LIMIT = 1024;\x0a"
"\x0a"
"static inline void error( int e )\x0a"
"{\x0a"
"    *__dios_errno() = e;\x0a"
"}\x0a"
"\x0a"
"}\x0a"
"", 4872 ); }