#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_fscalls_cpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#include <dios/vfs/syscall.hpp>\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"\x0a"
"    int Syscall\x3a\x3a""fchmodat( int dirfd, const char *path, Mode mode, int flags )\x0a"
"    {\x0a"
"        if ( ( flags \x7c AT_SYMLINK_NOFOLLOW ) \x21= AT_SYMLINK_NOFOLLOW )\x0a"
"            return error( EINVAL ), -1;\x0a"
"\x0a"
"        if ( auto ino = lookup( get_dir( dirfd ), path, \x21( flags \x26 AT_SYMLINK_NOFOLLOW ) ) )\x0a"
"            return _chmod( ino, mode ), 0;\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""fchmod( int fd_, Mode mode )\x0a"
"    {\x0a"
"        if ( auto fd = check_fd( fd_, W_OK ) )\x0a"
"            return _chmod( fd->inode(), mode ), 0;\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""chmod( const char *path, Mode mode )\x0a"
"    {\x0a"
"        return fchmodat( AT_FDCWD, path, mode, 0 );\x0a"
"    }\x0a"
"\x0a"
"    ssize_t Syscall\x3a\x3awrite( int fd_, const void *buf, size_t count )\x0a"
"    {\x0a"
"        if ( auto fd = check_fd( fd_, W_OK ) )\x0a"
"            return fd->write( buf, count );\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    ssize_t Syscall\x3a\x3aread( int fd_, void* buf, size_t count )\x0a"
"    {\x0a"
"        if ( auto fd = check_fd( fd_, R_OK ) )\x0a"
"            return fd->read( buf, count );\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3amkdirat( int dirfd, const char *path, Mode mode )\x0a"
"    {\x0a"
"        auto ino = new_node( mode \x7c S_IFDIR );\x0a"
"        if ( link_node( get_dir( dirfd ), path, ino ) )\x0a"
"            return 0;\x0a"
"        else\x0a"
"            return delete ino, -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3amkdir( const char *path, Mode mode )\x0a"
"    {\x0a"
"        return mkdirat( AT_FDCWD, path, mode );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3amknodat( int dirfd, const char *path, Mode mode, dev_t dev )\x0a"
"    {\x0a"
"        if ( dev \x21= 0 )\x0a"
"            return error( EINVAL ), -1;\x0a"
"        if ( \x21mode.is_char() \x26\x26 \x21mode.is_block() \x26\x26 \x21mode.is_file() \x26\x26 \x21mode.is_fifo() \x26\x26\x0a"
"             \x21mode.is_socket() )\x0a"
"            return error( EINVAL ), -1;\x0a"
"\x0a"
"        if ( link_node( get_dir( dirfd ), path, new_node( mode ) ) )\x0a"
"            return 0;\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3amknod( const char *path, Mode mode, dev_t dev )\x0a"
"    {\x0a"
"        return mknodat( AT_FDCWD, path, mode, dev );\x0a"
"    }\x0a"
"\x0a"
"    off_t Syscall\x3a\x3alseek( int fd_, off_t offset, int whence )\x0a"
"    {\x0a"
"        auto fd = check_fd( fd_, F_OK );\x0a"
"        if ( \x21""fd )\x0a"
"            return -1;\x0a"
"\x0a"
"        if ( fd->inode()->mode().is_fifo() )\x0a"
"            return error( ESPIPE ), -1;\x0a"
"\x0a"
"        auto size_t_max = std\x3a\x3anumeric_limits< size_t >\x3a\x3amax();\x0a"
"\x0a"
"        switch ( whence )\x0a"
"        {\x0a"
"            case SEEK_SET\x3a\x0a"
"                if ( offset < 0 )\x0a"
"                    return error( EINVAL ), -1;\x0a"
"                fd->offset( offset );\x0a"
"                break;\x0a"
"\x0a"
"            case SEEK_CUR\x3a\x0a"
"                if ( offset > 0 \x26\x26 size_t_max - fd->offset() < size_t( offset ) )\x0a"
"                    return error( EOVERFLOW ), -1;\x0a"
"                if ( int( fd->offset() ) < -offset )\x0a"
"                    return error( EINVAL ), -1;\x0a"
"                fd->offset( offset + fd->offset() );\x0a"
"                break;\x0a"
"\x0a"
"            case SEEK_END\x3a\x0a"
"                if ( offset > 0 \x26\x26 size_t_max - fd->size() < size_t( offset ) )\x0a"
"                    return error( EOVERFLOW ), -1;\x0a"
"                if ( offset < 0 \x26\x26 int( fd->size() ) < -offset )\x0a"
"                    return error( EINVAL ), -1;\x0a"
"                fd->offset( fd->size() + offset );\x0a"
"                break;\x0a"
"\x0a"
"            default\x3a\x0a"
"                return error( EINVAL ), -1;\x0a"
"        }\x0a"
"\x0a"
"        return fd->offset();\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""ftruncate( int fd_, off_t length )\x0a"
"    {\x0a"
"        if ( auto fd = check_fd( fd_, W_OK ) )\x0a"
"            return _truncate( fd->inode(), length );\x0a"
"\x0a"
"        if ( \x21""check_fd( fd_, F_OK ) )\x0a"
"            return -1;\x0a"
"\x0a"
"        return error( EINVAL ), -1; /* also override EBADF from check_fd */\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3atruncate( const char *path, off_t length )\x0a"
"    {\x0a"
"        if ( auto ino = lookup( get_dir(), path, true ) )\x0a"
"            return _truncate( ino, length );\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3aopen( const char *path, int flags, Mode mode )\x0a"
"    {\x0a"
"        return openat( AT_FDCWD, path, flags, mode );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3aopenat( int dirfd, const char *path, OFlags flags, Mode mode )\x0a"
"    {\x0a"
"        auto ino = lookup( get_dir( dirfd ), path, flags.follow() );\x0a"
"\x0a"
"        if ( ino \x26\x26 flags.has( O_CREAT ) \x26\x26 flags.has( O_EXCL ) )\x0a"
"            return error( EEXIST ), -1;\x0a"
"\x0a"
"        if ( \x21ino \x26\x26 flags.has( O_CREAT ) )\x0a"
"            if ( \x21link_node( get_dir( dirfd ), path, ino = new_node( mode \x7c S_IFREG ) ) )\x0a"
"                return -1;\x0a"
"\x0a"
"        if ( \x21ino )\x0a"
"            return -1;\x0a"
"\x0a"
"        /* FIXME check the uid \x26""c. */\x0a"
"\x0a"
"        if ( ( flags.read() \x7c\x7c flags.noaccess() ) \x26\x26 \x21ino->mode().user_read() )\x0a"
"            return error( EACCES ), -1;\x0a"
"\x0a"
"        if ( flags.write() \x7c\x7c flags.noaccess() )\x0a"
"        {\x0a"
"            if ( \x21ino->mode().user_write() )\x0a"
"                return error( EACCES ), -1;\x0a"
"            if ( ino->mode().is_dir())\x0a"
"                return error( EISDIR ), -1;\x0a"
"        }\x0a"
"\x0a"
"        if ( flags.has( O_DIRECTORY ) \x26\x26 \x21ino->mode().is_dir() )\x0a"
"            return error( ENOTDIR ), -1;\x0a"
"\x0a"
"        return new_fd( ino, flags );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a_dup( int fd_, int min )\x0a"
"    {\x0a"
"        if ( auto fd = check_fd( fd_, F_OK ) )\x0a"
"        {\x0a"
"            int newfd = new_fd( nullptr, 0, min );\x0a"
"            proc()._fd_refs\x5b newfd \x5d = proc()._fd_refs\x5b fd_ \x5d;\x0a"
"            fd->ref();\x0a"
"            return newfd;\x0a"
"        }\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""dup2( int fd_, int newfd )\x0a"
"    {\x0a"
"        if ( newfd < 0 \x7c\x7c newfd > FILE_DESCRIPTOR_LIMIT )\x0a"
"            return error( EBADF ), -1;\x0a"
"\x0a"
"        if ( auto fd = check_fd( newfd, F_OK ) )\x0a"
"            fd->unref();\x0a"
"\x0a"
"        auto \x26""fd_refs = proc()._fd_refs;\x0a"
"\x0a"
"        if ( int( fd_refs.size() ) <= newfd )\x0a"
"            fd_refs.resize( newfd + 1 );\x0a"
"\x0a"
"        if ( auto fd = check_fd( fd_, F_OK ) )\x0a"
"        {\x0a"
"            fd->ref();\x0a"
"            fd_refs\x5b newfd \x5d = fd_refs\x5b fd_ \x5d;\x0a"
"            return newfd;\x0a"
"        }\x0a"
"\x0a"
"        return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""fcntl( int fd_, int cmd, va_list *vl )\x0a"
"    {\x0a"
"        auto fd = check_fd( fd_, F_OK );\x0a"
"        if ( \x21""fd )\x0a"
"            return -1;\x0a"
"\x0a"
"\x09switch ( cmd )\x0a"
"        {\x0a"
"\x09    case F_SETFD\x3a\x0a"
"\x09    case F_GETFD\x3a\x0a"
"\x09\x09va_end( *vl );\x0a"
"\x09\x09return 0;\x0a"
"\x09    case F_DUPFD_CLOEXEC\x3a // for now let assume we cannot handle O_CLOEXEC\x0a"
"\x09\x09va_end( *vl );\x0a"
"\x09\x09return -1;\x0a"
"\x09    case F_DUPFD\x3a\x0a"
"\x09    {\x0a"
"\x09\x09int min = va_arg(  *vl, int );\x0a"
"\x09\x09va_end( *vl );\x0a"
"\x09\x09return _dup( fd_, min );\x0a"
"\x09    }\x0a"
"\x09    case F_GETFL\x3a\x0a"
"\x09\x09va_end( *vl );\x0a"
"\x09\x09return fd->flags().to_i();\x0a"
"\x09    case F_SETFL\x3a\x0a"
"\x09    {\x0a"
"\x09\x09OFlags mode = va_arg( *vl, int );\x0a"
"\x0a"
"\x09\x09if ( mode \x26 \x7e( O_APPEND \x7c O_NONBLOCK ) )\x0a"
"\x09\x09    return error( EINVAL ), -1;\x0a"
"\x09\x09if ( \x21( mode \x26 O_APPEND ) \x26\x26 ( fd->flags() \x26 O_APPEND ) )\x0a"
"\x09\x09    return error( EPERM ), -1;\x0a"
"\x0a"
"\x09\x09""fd->flags() \x26= \x7e( O_APPEND \x7c O_NONBLOCK );\x0a"
"\x09\x09""fd->flags() \x7c= mode;\x0a"
"\x0a"
"\x09\x09va_end( *vl );\x0a"
"\x09\x09return 0;\x0a"
"\x09    }\x0a"
"\x09    default\x3a\x0a"
"\x09\x09__dios_trace_f( \x22the fcntl command \x25""d is not implemented\x22, cmd );\x0a"
"\x09\x09va_end( *vl );\x0a"
"\x09\x09return -1;\x0a"
"\x09}\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3aunlink( const char *path )\x0a"
"    {\x0a"
"        return unlinkat( AT_FDCWD, path, 0 );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3armdir( const char *path )\x0a"
"    {\x0a"
"        return unlinkat( AT_FDCWD, path, AT_REMOVEDIR );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3aunlinkat( int dirfd, const char *path, int flags )\x0a"
"    {\x0a"
"        auto \x5b dir, name \x5d = lookup_dir( get_dir( dirfd ), path, true );\x0a"
"        if ( \x21""dir )\x0a"
"            return -1;\x0a"
"\x0a"
"        auto ino = lookup( dir, name, false );\x0a"
"        if ( \x21ino )\x0a"
"            return -1;\x0a"
"\x0a"
"        if ( flags == AT_REMOVEDIR )\x0a"
"        {\x0a"
"            if ( \x21ino->mode().is_dir() )\x0a"
"                return error( ENOTDIR ), -1;\x0a"
"            if ( \x21ino->as< Directory >()->empty() )\x0a"
"                return error( ENOTEMPTY ), -1;\x0a"
"        }\x0a"
"\x0a"
"        if ( flags == 0 \x26\x26 ino->mode().is_dir() )\x0a"
"            return error( EISDIR ), -1;\x0a"
"\x0a"
"        return dir->as< Directory >()->unlink( name ) \x3f 0 \x3a -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""fstatat( int dirfd, const char *path, struct stat *buf, int flag )\x0a"
"    {\x0a"
"        auto \x5b dir, name \x5d = lookup_dir( get_dir( dirfd ), path, true );\x0a"
"        if ( \x21""dir )\x0a"
"            return -1;\x0a"
"        if ( auto ino = lookup( dir, name, \x21( flag \x26 AT_SYMLINK_NOFOLLOW ) ) )\x0a"
"            return ino->stat( *buf ), 0;\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3astat( const char *path, struct stat *buf )\x0a"
"    {\x0a"
"        return fstatat( AT_FDCWD, path, buf, 0 );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3alstat( const char *path, struct stat *buf  )\x0a"
"    {\x0a"
"        return fstatat( AT_FDCWD, path, buf, AT_SYMLINK_NOFOLLOW );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""fstat( int fd_, struct stat *buf )\x0a"
"    {\x0a"
"        if ( auto fd = check_fd( fd_, F_OK ) )\x0a"
"            return fd->inode()->stat( *buf ), 0;\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3alinkat( int odirfd, const char *target, int ndirfd, const char *link, int flags )\x0a"
"    {\x0a"
"        if ( ( flags \x7c AT_SYMLINK_FOLLOW ) \x21= AT_SYMLINK_FOLLOW )\x0a"
"            return error( EINVAL ), -1;\x0a"
"\x0a"
"        if ( auto ino = lookup( get_dir( odirfd ), target, flags \x26 AT_SYMLINK_FOLLOW ) )\x0a"
"        {\x0a"
"            if ( ino->mode().is_dir() )\x0a"
"                return error( EPERM ), -1;\x0a"
"            if ( link_node( get_dir( ndirfd ), link, ino ) )\x0a"
"                return 0;\x0a"
"        }\x0a"
"\x0a"
"        return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3alink( const char *target, const char *linkpath )\x0a"
"    {\x0a"
"        return linkat( AT_FDCWD, target, AT_FDCWD, linkpath, 0 );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3asymlinkat( const char *target_, int dirfd, const char *linkpath )\x0a"
"    {\x0a"
"        std\x3a\x3astring_view target( target_ );\x0a"
"\x0a"
"        if ( target.size() > PATH_LIMIT )\x0a"
"            return error( ENAMETOOLONG ), -1;\x0a"
"\x0a"
"        auto ino = new SymLink( target );\x0a"
"        ino->mode( ACCESSPERMS \x7c S_IFLNK );\x0a"
"        if ( link_node( get_dir( dirfd ), linkpath, ino ) )\x0a"
"            return 0;\x0a"
"        else\x0a"
"            return delete ino, -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3asymlink( const char *target, const char *linkpath )\x0a"
"    {\x0a"
"        return symlinkat( target, AT_FDCWD, linkpath );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3arenameat( int odirfd, const char *opath, int ndirfd, const char *npath )\x0a"
"    {\x0a"
"        auto \x5b odir, oname \x5d = lookup_dir( get_dir( odirfd ), opath, true );\x0a"
"        auto \x5b ndir, nname \x5d = lookup_dir( get_dir( ndirfd ), npath, true );\x0a"
"\x0a"
"        if ( \x21odir \x7c\x7c \x21ndir )\x0a"
"            return error( ENOENT ), -1;\x0a"
"\x0a"
"        auto oino = lookup( odir, oname, false ), nino = lookup( ndir, nname, false );\x0a"
"        if ( \x21oino )\x0a"
"            return error( ENOENT ), -1;\x0a"
"\x0a"
"        if ( \x21odir->mode().user_write() \x7c\x7c \x21ndir->mode().user_write() )\x0a"
"            return error( EACCES ), -1;\x0a"
"\x0a"
"        if ( oino == nino )\x0a"
"            return error( EINVAL ), -1;\x0a"
"\x0a"
"        if ( nino )\x0a"
"        {\x0a"
"            if ( oino->mode().is_dir() \x26\x26 \x21nino->mode().is_dir() )\x0a"
"                return error( ENOTDIR ), -1;\x0a"
"\x0a"
"            if ( \x21oino->mode().is_dir() \x26\x26 nino->mode().is_dir() )\x0a"
"                return error( EISDIR ), -1;\x0a"
"\x0a"
"            if ( nino->mode().is_dir() \x26\x26 nino->size() > 2 )\x0a"
"                return error( ENOTEMPTY ), -1;\x0a"
"\x0a"
"            nino->unlink();\x0a"
"        }\x0a"
"\x0a"
"        if ( \x21link_node( ndir, nname, oino, true ) )\x0a"
"            __builtin_trap();\x0a"
"\x0a"
"        if ( \x21odir->as< Directory >()->unlink( oname ) )\x0a"
"            __builtin_trap();\x0a"
"\x0a"
"        return 0;\x0a"
"    }\x0a"
"\x0a"
"    bool rappend( char *\x26""buff, size_t \x26size, std\x3a\x3astring_view add )\x0a"
"    {\x0a"
"        if ( size <= add.size() )\x0a"
"            return false;\x0a"
"        std\x3a\x3a""copy( add.rbegin(), add.rend(), buff );\x0a"
"        buff += add.size();\x0a"
"        size -= add.size();\x0a"
"        *buff = 0;\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    char *Syscall\x3a\x3agetcwd( char *buff, size_t size )\x0a"
"    {\x0a"
"        auto buff_start = buff;\x0a"
"\x0a"
"        if ( \x21""buff )\x0a"
"            return error( EFAULT ), nullptr;\x0a"
"        if ( \x21size )\x0a"
"            return error( EINVAL ), nullptr;\x0a"
"\x0a"
"        for ( auto dir = proc()._cwd; dir \x21= root(); dir = dir->as< Directory >()->parent() )\x0a"
"        {\x0a"
"            if ( \x21rappend( buff, size, dir->as< Directory >()->name() ) )\x0a"
"                return error( ERANGE ), nullptr;\x0a"
"\x0a"
"            if ( \x21rappend( buff, size, \x22/\x22 ) )\x0a"
"                return error( ERANGE ), nullptr;\x0a"
"        }\x0a"
"\x0a"
"        if ( proc()._cwd == root() )\x0a"
"            if ( \x21rappend( buff, size, \x22/\x22 ) )\x0a"
"                return error( ERANGE ), nullptr;\x0a"
"\x0a"
"        for ( auto c = buff_start; c < buff; ++c )\x0a"
"            std\x3a\x3aswap( *c, *--buff );\x0a"
"\x0a"
"        return buff_start;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a__getcwd( char *buf, size_t size )\x0a"
"    {\x0a"
"        if ( \x21getcwd( buf, size ) )\x0a"
"            return -1;\x0a"
"        else\x0a"
"            return 0;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""chdir( const char *path )\x0a"
"    {\x0a"
"        return _chdir( lookup( get_dir(), path, true ) );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""fchdir( int dirfd )\x0a"
"    {\x0a"
"        return _chdir( get_dir( dirfd ) );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""access( const char *path, int amode )\x0a"
"    {\x0a"
"        return faccessat( AT_FDCWD, path, amode, 0 );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""faccessat( int dirfd, const char *path, int mode, int flag )\x0a"
"    {\x0a"
"        if ( ( flag \x7c AT_EACCESS ) \x21= AT_EACCESS )\x0a"
"            return error( EINVAL ), -1;\x0a"
"\x0a"
"        if ( ( mode \x7c R_OK \x7c W_OK \x7c X_OK ) \x21= ( R_OK \x7c W_OK \x7c X_OK ) )\x0a"
"            return error( EINVAL ), -1;\x0a"
"\x0a"
"        if ( auto ino = lookup( get_dir( dirfd ), path, true ) )\x0a"
"        {\x0a"
"            if ( ( ( mode \x26 R_OK ) \x26\x26 \x21ino->mode().user_read() ) \x7c\x7c\x0a"
"                 ( ( mode \x26 W_OK ) \x26\x26 \x21ino->mode().user_write() ) \x7c\x7c\x0a"
"                 ( ( mode \x26 X_OK ) \x26\x26 \x21ino->mode().user_exec() ) )\x0a"
"                return error( EACCES ), -1;\x0a"
"            else\x0a"
"                return 0;\x0a"
"        }\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    ssize_t Syscall\x3a\x3areadlink( const char *path, char *buf, size_t size )\x0a"
"    {\x0a"
"        return readlinkat( AT_FDCWD, path, buf, size );\x0a"
"    }\x0a"
"\x0a"
"    ssize_t Syscall\x3a\x3areadlinkat( int dirfd, const char *path, char *buf, size_t size )\x0a"
"    {\x0a"
"        if ( auto ino = lookup( get_dir( dirfd ), path, false ) )\x0a"
"        {\x0a"
"            if ( \x21ino->mode().is_link() )\x0a"
"                return error( EINVAL ), -1;\x0a"
"            auto tgt = ino->as< SymLink >()->target();\x0a"
"            size = std\x3a\x3amin( tgt.size(), size );\x0a"
"            std\x3a\x3a""copy( tgt.begin(), tgt.begin() + size, buf );\x0a"
"            return size;\x0a"
"        }\x0a"
"        else\x0a"
"            return error( ENOENT ), -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3asocketpair( int dom, int type, int proto, int fds\x5b""2\x5d )\x0a"
"    {\x0a"
"        if ( dom \x21= AF_UNIX )\x0a"
"            return error( EAFNOSUPPORT ), -1;\x0a"
"\x0a"
"        if ( type \x21= SOCK_STREAM )\x0a"
"            return error( EPROTOTYPE ), -1;\x0a"
"\x0a"
"        if ( proto ) /* TODO\x3a support SOCK_NONBLOCK */\x0a"
"            return error( EOPNOTSUPP ), -1;\x0a"
"\x0a"
"        auto ino_a = new SocketStream(), ino_b = new SocketStream();\x0a"
"        ino_a->connect( ino_b, false );\x0a"
"        ino_a->mode( ACCESSPERMS \x7c S_IFSOCK );\x0a"
"        ino_b->mode( ACCESSPERMS \x7c S_IFSOCK );\x0a"
"\x0a"
"        fds\x5b""0\x5d = new_fd( ino_a, O_RDWR );\x0a"
"        fds\x5b""1\x5d = new_fd( ino_b, O_RDWR );\x0a"
"        return 0;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3apipe( int fds\x5b""2\x5d )\x0a"
"    {\x0a"
"        auto ino = new Pipe();\x0a"
"        ino->mode( S_IRWXU \x7c S_IFIFO );\x0a"
"\x0a"
"        fds\x5b""0\x5d = new_fd( ino, O_RDONLY \x7c O_NONBLOCK );\x0a"
"        fds\x5b""1\x5d = new_fd( ino, O_WRONLY \x7c O_NONBLOCK );\x0a"
"        return 0;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3asocket( int domain, SFlags t, int protocol )\x0a"
"    {\x0a"
"        if ( domain \x21= AF_UNIX )\x0a"
"            return error( EAFNOSUPPORT ), -1;\x0a"
"        if ( protocol )\x0a"
"            return error( EPROTONOSUPPORT ), -1;\x0a"
"\x0a"
"        Node ino;\x0a"
"\x0a"
"        switch ( t.type() )\x0a"
"        {\x0a"
"            case SOCK_STREAM\x3a\x0a"
"                ino = new SocketStream(); break;\x0a"
"            case SOCK_DGRAM\x3a\x0a"
"                ino = new SocketDatagram(); break;\x0a"
"            default\x3a\x0a"
"                return error( EPROTONOSUPPORT ), -1;\x0a"
"        }\x0a"
"\x0a"
"        ino->mode( ACCESSPERMS \x7c S_IFSOCK );\x0a"
"        return new_fd( ino, O_RDWR \x7c ( t \x26 SOCK_NONBLOCK \x3f O_NONBLOCK \x3a 0 ) );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3agetsockname( int sockfd, struct sockaddr *addr, socklen_t *len )\x0a"
"    {\x0a"
"        auto fd = check_fd( sockfd, F_OK );\x0a"
"        if ( address_out( fd->inode(), addr, len ) )\x0a"
"            return 0;\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3agetpeername( int sockfd, struct sockaddr *addr, socklen_t *len )\x0a"
"    {\x0a"
"        auto fd = check_fd( sockfd, F_OK );\x0a"
"        if ( address_out( fd->inode()->peer(), addr, len ) )\x0a"
"            return 0;\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""connect( int sockfd, const struct sockaddr *addr, socklen_t len )\x0a"
"    {\x0a"
"        auto \x5b ino, path \x5d = get_sock( sockfd, addr, len );\x0a"
"        if ( \x21ino )\x0a"
"            return -1;\x0a"
"\x0a"
"        if ( auto remote = lookup( get_dir(), path, true ) )\x0a"
"        {\x0a"
"            if ( \x21remote->mode().user_read() )\x0a"
"                return error( EACCES ), -1;\x0a"
"            if ( ino->connect( remote ) )\x0a"
"                return 0;\x0a"
"        }\x0a"
"\x0a"
"        return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3alisten( int sockfd, int n )\x0a"
"    {\x0a"
"        if ( auto fd = check_fd( sockfd, F_OK ) )\x0a"
"            return fd->inode()->listen( n ) \x3f 0 \x3a -1;\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""bind( int sockfd, const struct sockaddr *addr, socklen_t len )\x0a"
"    {\x0a"
"        if ( addr->sa_family \x21= AF_UNIX )\x0a"
"            return error( EINVAL ), -1;\x0a"
"\x0a"
"        auto \x5b ino, path \x5d = get_sock( sockfd, addr, len );\x0a"
"        if ( \x21ino )\x0a"
"            return -1;\x0a"
"\x0a"
"        auto \x5b dir, name \x5d = lookup_dir( get_dir(), path, true );\x0a"
"        if ( \x21""dir )\x0a"
"            return -1;\x0a"
"\x0a"
"        if ( \x21link_node( dir, name, ino, false ) )\x0a"
"            return -1;\x0a"
"\x0a"
"        if ( ino->bind( path ) )\x0a"
"            return 0;\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""accept( int fd, struct sockaddr *addr, socklen_t *len )\x0a"
"    {\x0a"
"        return accept4( fd, addr, len, 0 );\x0a"
"    }\x0a"
"\x0a"
"    int Syscall\x3a\x3a""accept4( int sockfd, struct sockaddr *addr, socklen_t *len, SFlags flags )\x0a"
"    {\x0a"
"        if ( ( flags \x7c SOCK_NONBLOCK ) \x21= SOCK_NONBLOCK )\x0a"
"            return error( EINVAL ), -1;\x0a"
"\x0a"
"        auto sock = check_fd( sockfd, F_OK );\x0a"
"        OFlags fd_flags;\x0a"
"\x0a"
"        if ( \x21sock )\x0a"
"            return -1;\x0a"
"\x0a"
"        if ( flags \x26 SOCK_NONBLOCK )\x0a"
"            fd_flags \x7c= O_NONBLOCK;\x0a"
"\x0a"
"        auto ino = sock->inode()->accept();\x0a"
"        if ( \x21ino )\x0a"
"            return -1;\x0a"
"\x0a"
"        if ( addr \x26\x26 \x21""address_out( ino, addr, len ) )\x0a"
"            return -1;\x0a"
"\x0a"
"        return new_fd( ino, fd_flags );\x0a"
"    }\x0a"
"\x0a"
"    ssize_t Syscall\x3a\x3asend( int sockfd, const void *buf, size_t n, int )\x0a"
"    {\x0a"
"        if ( auto sock = check_fd( sockfd, W_OK ) )\x0a"
"            return sock->write( buf, n );\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    ssize_t Syscall\x3a\x3asendto( int sockfd, const void *buf, size_t n, int flags,\x0a"
"                             const sockaddr *addr, socklen_t len )\x0a"
"    {\x0a"
"        if ( \x21""addr )\x0a"
"            return send( sockfd, buf, n, flags );\x0a"
"\x0a"
"        auto \x5b ino, path \x5d = get_sock( sockfd, addr, len );\x0a"
"        if ( \x21ino )\x0a"
"            return -1;\x0a"
"\x0a"
"        if ( auto remote = lookup( get_dir(), path, true ) )\x0a"
"            return check_fd( sockfd, F_OK )->write( buf, n, remote );\x0a"
"        else\x0a"
"            return -1;\x0a"
"    }\x0a"
"\x0a"
"    ssize_t Syscall\x3a\x3arecv( int sockfd, void *buf, size_t n, MFlags flags )\x0a"
"    {\x0a"
"        return recvfrom( sockfd, buf, n, flags, nullptr, nullptr );\x0a"
"    }\x0a"
"\x0a"
"    ssize_t Syscall\x3a\x3arecvfrom( int sockfd, void *buf, size_t n, MFlags flags,\x0a"
"                               struct sockaddr *addr, socklen_t *len )\x0a"
"    {\x0a"
"        auto fd = check_fd( sockfd, F_OK );\x0a"
"        if ( \x21""fd )\x0a"
"            return -1;\x0a"
"\x0a"
"        if ( fd->flags().nonblock() \x26\x26 \x21""fd->inode()->canRead() )\x0a"
"            return error( EAGAIN ), -1;\x0a"
"\x0a"
"        if ( fd->flags().nonblock() )\x0a"
"            flags \x7c= MSG_DONTWAIT;\x0a"
"\x0a"
"        if ( auto peer = fd->inode()->receive( static_cast< char * >( buf ), n, flags ) )\x0a"
"        {\x0a"
"            if ( addr \x26\x26 \x21""address_out( peer, addr, len ) )\x0a"
"                return -1;\x0a"
"            else\x0a"
"                return n;\x0a"
"        }\x0a"
"\x0a"
"        return -1;\x0a"
"    }\x0a"
"\x0a"
"}\x0a"
"", 20524 ); }