#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_inode_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2015 Ji\xc5\x99\xc3\xad Weiser\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"#include <string_view>\x0a"
"#include <memory>\x0a"
"#include <sys/types.h>\x0a"
"\x0a"
"#include <dios/sys/kobject.hpp>\x0a"
"#include <dios/vfs/flags.hpp>\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"\x0a"
"/* A file mode and type saved in the INode. Please note that S_* are now\x0a"
"   integral macros defined in sys/stat.h (through #include\x0a"
"   <dios/vfs/flags.hpp>), but they will be later replaced by corresponding\x0a"
"   instances of this struct. */\x0a"
"struct Mode \x3a FlagOps< Mode, uint16_t >\x0a"
"{\x0a"
"    using FlagOps< Mode, uint16_t >\x3a\x3a""FlagOps;\x0a"
"\x0a"
"    bool is_socket() const { return _is( S_IFSOCK ); }\x0a"
"    bool is_link()   const { return _is( S_IFLNK ); }\x0a"
"    bool is_file()   const { return _is( S_IFREG ); }\x0a"
"    bool is_block()  const { return _is( S_IFBLK ); }\x0a"
"    bool is_char()   const { return _is( S_IFCHR ); }\x0a"
"    bool is_dir()    const { return _is( S_IFDIR ); }\x0a"
"    bool is_fifo ()  const { return _is( S_IFIFO ); }\x0a"
"\x0a"
"    bool has_suid()   const { return _has( S_ISUID ); }\x0a"
"    bool has_sgid()   const { return _has( S_ISGID ); }\x0a"
"    bool has_sticky() const { return _has( S_ISVTX ); }\x0a"
"\x0a"
"    bool user_read()  const { return _has( S_IRUSR ); }\x0a"
"    bool user_write() const { return _has( S_IWUSR ); }\x0a"
"    bool user_exec()  const { return _has( S_IXUSR ); }\x0a"
"\x0a"
"    bool group_read()  const { return _has( S_IRGRP ); }\x0a"
"    bool group_write() const { return _has( S_IWGRP ); }\x0a"
"    bool group_exec()  const { return _has( S_IXGRP ); }\x0a"
"\x0a"
"    bool other_read()  const { return _has( S_IROTH ); }\x0a"
"    bool other_write() const { return _has( S_IWOTH ); }\x0a"
"    bool other_exec()  const { return _has( S_IXOTH ); }\x0a"
"\x0a"
"private\x3a\x0a"
"    bool _is( unsigned p )  const { return _check( p, S_IFMT ); }\x0a"
"    bool _has( unsigned p ) const { return _check( p, p ); }\x0a"
"    bool _check( unsigned p, unsigned mask ) const\x0a"
"    {\x0a"
"        return ( this->to_i() \x26 mask ) == p;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"#undef S_ISUID\x0a"
"#undef S_ISGID\x0a"
"\x0a"
"#undef S_IRWXU\x0a"
"#undef S_IRUSR\x0a"
"#undef S_IWUSR\x0a"
"#undef S_IXUSR\x0a"
"\x0a"
"#undef S_IRWXG\x0a"
"#undef S_IRGRP\x0a"
"#undef S_IWGRP\x0a"
"#undef S_IXGRP\x0a"
"\x0a"
"#undef S_IRWXO\x0a"
"#undef S_IROTH\x0a"
"#undef S_IWOTH\x0a"
"#undef S_IXOTH\x0a"
"\x0a"
"#undef S_IFMT\x0a"
"#undef S_IFIFO\x0a"
"#undef S_IFCHR\x0a"
"#undef S_IFDIR\x0a"
"#undef S_IFBLK\x0a"
"#undef S_IFREG\x0a"
"#undef S_IFLNK\x0a"
"#undef S_IFSOCK\x0a"
"#undef S_ISVTX\x0a"
"\x0a"
"#undef ACCESSPERMS\x0a"
"#undef ALLPERMS\x0a"
"\x0a"
"constexpr Mode S_ISUID = _HOST_S_ISUID;\x0a"
"constexpr Mode S_ISGID = _HOST_S_ISGID;\x0a"
"\x0a"
"constexpr Mode S_IRWXU = _HOST_S_IRWXU;\x0a"
"constexpr Mode S_IRUSR = _HOST_S_IRUSR;\x0a"
"constexpr Mode S_IWUSR = _HOST_S_IWUSR;\x0a"
"constexpr Mode S_IXUSR = _HOST_S_IXUSR;\x0a"
"\x0a"
"constexpr Mode S_IRWXG = _HOST_S_IRWXG;\x0a"
"constexpr Mode S_IRGRP = _HOST_S_IRGRP;\x0a"
"constexpr Mode S_IWGRP = _HOST_S_IWGRP;\x0a"
"constexpr Mode S_IXGRP = _HOST_S_IXGRP;\x0a"
"\x0a"
"constexpr Mode S_IRWXO = _HOST_S_IRWXO;\x0a"
"constexpr Mode S_IROTH = _HOST_S_IROTH;\x0a"
"constexpr Mode S_IWOTH = _HOST_S_IWOTH;\x0a"
"constexpr Mode S_IXOTH = _HOST_S_IXOTH;\x0a"
"\x0a"
"constexpr Mode S_IFMT   = _HOST_S_IFMT;\x0a"
"constexpr Mode S_IFIFO  = _HOST_S_IFIFO;\x0a"
"constexpr Mode S_IFCHR  = _HOST_S_IFCHR;\x0a"
"constexpr Mode S_IFDIR  = _HOST_S_IFDIR;\x0a"
"constexpr Mode S_IFBLK  = _HOST_S_IFBLK;\x0a"
"constexpr Mode S_IFREG  = _HOST_S_IFREG;\x0a"
"constexpr Mode S_IFLNK  = _HOST_S_IFLNK;\x0a"
"constexpr Mode S_IFSOCK = _HOST_S_IFSOCK;\x0a"
"constexpr Mode S_ISVTX  = _HOST_S_ISVTX;\x0a"
"\x0a"
"constexpr Mode ACCESSPERMS = S_IRWXU \x7c S_IRWXG \x7c S_IRWXO;\x0a"
"constexpr Mode ALLPERMS = ACCESSPERMS \x7c S_ISUID \x7c S_ISGID \x7c S_ISVTX;\x0a"
"\x0a"
"struct FileDescriptor;\x0a"
"struct INode;\x0a"
"\x0a"
"using Node = INode *;\x0a"
"\x0a"
"/* An object in the virtual file system. This is a base type for all types of\x0a"
"   filesystem objects, each of them can override their operations and own its\x0a"
"   data. INode itself defines operations for many file types, but mostly in a\x0a"
"   way which reports an error.\x0a"
"   See file.hpp for these objects.\x0a"
"   An INode contains a refference count and self-destructs if it reaches zero.\x0a"
"   For this reason, an INode must be always allocated dynamically. */\x0a"
"struct INode \x3a KObject\x0a"
"{\x0a"
"    INode() \x3a\x0a"
"        _mode( 0 ),\x0a"
"        _ino( getIno() ),\x0a"
"        _uid( 0 ),\x0a"
"        _gid( 0 ),\x0a"
"        _nlink( 0 ),\x0a"
"        _nopen( 0 )\x0a"
"    {}\x0a"
"\x0a"
"    virtual \x7eINode() {}\x0a"
"\x0a"
"    template< typename T >\x0a"
"    T *as() {\x0a"
"        return static_cast< T * >( this );\x0a"
"    }\x0a"
"\x0a"
"    template< typename T >\x0a"
"    const T *as() const {\x0a"
"        return static_cast< const T * >( this );\x0a"
"    }\x0a"
"\x0a"
"    virtual size_t size() const { return 0; }\x0a"
"    virtual bool read( char *, size_t, size_t \x26 ) { return false; }\x0a"
"    virtual bool write( const char *, size_t, size_t \x26, Node ) { return false; }\x0a"
"    virtual bool canRead() const { return false; }\x0a"
"    virtual bool canWrite( int, Node ) const { return false; }\x0a"
"\x0a"
"    void open() { ++ _nopen; }\x0a"
"    void close() { -- _nopen; checkref(); }\x0a"
"\x0a"
"    virtual void open( FileDescriptor \x26 ) { open(); }\x0a"
"    virtual void close( FileDescriptor \x26 ) { close(); }\x0a"
"\x0a"
"    virtual bool listen( int ) { return error( ENOTSOCK ), false; }\x0a"
"    virtual bool connect( Node ) { return error( ENOTSOCK ), false; }\x0a"
"    virtual bool bind( std\x3a\x3astring_view ) { return error( ENOTSOCK ), false; }\x0a"
"    virtual Node receive( char *, size_t \x26, MFlags ) { return error( ENOTSOCK ), nullptr; }\x0a"
"    virtual Node accept() { return error( ENOTSOCK ), nullptr; }\x0a"
"    virtual Node peer() const { return error( ENOTSOCK ), nullptr; }\x0a"
"    virtual std\x3a\x3astring_view address() { return \x22\x22; }\x0a"
"\x0a"
"    Mode mode() const { return _mode; }\x0a"
"    void mode( Mode mode ) { _mode = mode; }\x0a"
"\x0a"
"    unsigned ino() const { return _ino; }\x0a"
"    unsigned uid() const { return _uid; }\x0a"
"    unsigned gid() const { return _gid; }\x0a"
"\x0a"
"    void link() { ++ _nlink; }\x0a"
"    void unlink() { -- _nlink; checkref(); }\x0a"
"\x0a"
"    void checkref()\x0a"
"    {\x0a"
"        if ( \x21_nlink \x26\x26 \x21_nopen )\x0a"
"            delete this;\x0a"
"    }\x0a"
"\x0a"
"    void stat( struct stat \x26""buf )\x0a"
"    {\x0a"
"        buf.st_dev = 0;\x0a"
"        buf.st_rdev = 0;\x0a"
"        buf.st_atime = 0;\x0a"
"        buf.st_mtime = 0;\x0a"
"        buf.st_ctime = 0;\x0a"
"        buf.st_ino = ino();\x0a"
"        buf.st_mode = mode().to_i();\x0a"
"        buf.st_nlink = _nlink;\x0a"
"        buf.st_size = size();\x0a"
"        buf.st_uid = uid();\x0a"
"        buf.st_gid = gid();\x0a"
"        buf.st_blksize = 512;\x0a"
"        buf.st_blocks = ( buf.st_size + 1 ) / buf.st_blksize;\x0a"
"    }\x0a"
"\x0a"
"    template< typename stat >\x0a"
"    void set_stat( const stat \x26s )\x0a"
"    {\x0a"
"        _ino  = s.st_ino;\x0a"
"        _mode = s.st_mode;\x0a"
"        _uid  = s.st_uid;\x0a"
"        _gid  = s.st_gid;\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    Mode _mode;\x0a"
"    unsigned _ino;\x0a"
"    uint16_t _uid;\x0a"
"    uint16_t _gid;\x0a"
"    uint16_t _nlink;\x0a"
"    uint16_t _nopen;\x0a"
"\x0a"
"    static unsigned getIno()\x0a"
"    {\x0a"
"        static unsigned ino = 0;\x0a"
"        return ++ino;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"}\x0a"
"", 7260 ); }