#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_manager_h( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2018, 2019 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"#include <tuple>\x0a"
"#include <memory>\x0a"
"#include <algorithm>\x0a"
"#include <utility>\x0a"
"#include <array>\x0a"
"#include <sys/stat.h>\x0a"
"#include <sys/socket.h>\x0a"
"#include <bits/types.h>\x0a"
"#include <unistd.h>\x0a"
"#include <fcntl.h>\x0a"
"#include <sys/socket.h>\x0a"
"#include <sys/un.h>\x0a"
"#include <dios.h>\x0a"
"#include <sys/vmutil.h>\x0a"
"#include <string_view>\x0a"
"\x0a"
"#include \x22inode.hpp\x22\x0a"
"#include \x22""flags.hpp\x22\x0a"
"#include \x22""file.hpp\x22\x0a"
"#include \x22""directory.hpp\x22\x0a"
"#include \x22""fd.hpp\x22\x0a"
"#include \x22syscall.hpp\x22\x0a"
"\x0a"
"#include <dios/sys/options.hpp>\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"\x0a"
"    /* This is a part of the DiOS config stack which provides filesystem\x0a"
"       functionality.\x0a"
"\x0a"
"       - Extends process-local information (struct Process) with filesystem\x0a"
"         data.\x0a"
"       - Overrideds fork to keep files open.\x0a"
"       - In setup initializes stdin (empty, or with a specified content if\x0a"
"         passed to it), creates stdout \x26 stder, and imports filesystem\x0a"
"         snapshot. */\x0a"
"    template < typename Next >\x0a"
"    struct VFS\x3a Syscall, Next\x0a"
"    {\x0a"
"        struct Process \x3a Next\x3a\x3aProcess, fs\x3a\x3aProcessInfo\x0a"
"        {};\x0a"
"\x0a"
"        Node root() override { return _root; }\x0a"
"        ProcessInfo \x26proc() override { return *static_cast< Process * >( this->current_process() ); }\x0a"
"\x0a"
"        using Syscall\x3a\x3aopen;\x0a"
"        using Syscall\x3a\x3aopenat;\x0a"
"\x0a"
"        using Syscall\x3a\x3a""dup;\x0a"
"        using Syscall\x3a\x3a""dup2;\x0a"
"        using Syscall\x3a\x3a""fcntl;\x0a"
"\x0a"
"        using Syscall\x3a\x3a""chmod;\x0a"
"        using Syscall\x3a\x3a""fchmod;\x0a"
"        using Syscall\x3a\x3a""fchmodat;\x0a"
"\x0a"
"        using Syscall\x3a\x3aread;\x0a"
"        using Syscall\x3a\x3awrite;\x0a"
"\x0a"
"        using Syscall\x3a\x3amkdir;\x0a"
"        using Syscall\x3a\x3amkdirat;\x0a"
"        using Syscall\x3a\x3amknod;\x0a"
"        using Syscall\x3a\x3amknodat;\x0a"
"\x0a"
"        using Syscall\x3a\x3atruncate;\x0a"
"        using Syscall\x3a\x3a""ftruncate;\x0a"
"        using Syscall\x3a\x3alseek;\x0a"
"\x0a"
"        using Syscall\x3a\x3aunlink;\x0a"
"        using Syscall\x3a\x3armdir;\x0a"
"        using Syscall\x3a\x3aunlinkat;\x0a"
"\x0a"
"        using Syscall\x3a\x3a""fstatat;\x0a"
"        using Syscall\x3a\x3astat;\x0a"
"        using Syscall\x3a\x3alstat;\x0a"
"        using Syscall\x3a\x3a""fstat;\x0a"
"\x0a"
"        using Syscall\x3a\x3alinkat;\x0a"
"        using Syscall\x3a\x3alink;\x0a"
"        using Syscall\x3a\x3asymlinkat;\x0a"
"        using Syscall\x3a\x3asymlink;\x0a"
"        using Syscall\x3a\x3areadlinkat;\x0a"
"        using Syscall\x3a\x3areadlink;\x0a"
"\x0a"
"        using Syscall\x3a\x3aumask;\x0a"
"\x0a"
"        using Syscall\x3a\x3arenameat;\x0a"
"        using Syscall\x3a\x3arename;\x0a"
"\x0a"
"        using Syscall\x3a\x3a""chdir;\x0a"
"        using Syscall\x3a\x3a""fchdir;\x0a"
"        using Syscall\x3a\x3agetcwd;\x0a"
"        using Syscall\x3a\x3a__getcwd;\x0a"
"\x0a"
"        using Syscall\x3a\x3a""faccessat;\x0a"
"        using Syscall\x3a\x3a""access;\x0a"
"\x0a"
"        using Syscall\x3a\x3apipe;\x0a"
"        using Syscall\x3a\x3asocketpair;\x0a"
"        using Syscall\x3a\x3asocket;\x0a"
"\x0a"
"        using Syscall\x3a\x3agetsockname;\x0a"
"        using Syscall\x3a\x3agetpeername;\x0a"
"\x0a"
"        using Syscall\x3a\x3a""connect;\x0a"
"        using Syscall\x3a\x3alisten;\x0a"
"        using Syscall\x3a\x3a""bind;\x0a"
"        using Syscall\x3a\x3a""accept;\x0a"
"        using Syscall\x3a\x3a""accept4;\x0a"
"\x0a"
"        using Syscall\x3a\x3asend;\x0a"
"        using Syscall\x3a\x3asendto;\x0a"
"        using Syscall\x3a\x3arecv;\x0a"
"        using Syscall\x3a\x3arecvfrom;\x0a"
"\x0a"
"        void sysfork( pid_t *child )\x0a"
"        {\x0a"
"            Next\x3a\x3asysfork( child );\x0a"
"            Process *proc = static_cast< Process * >( Next\x3a\x3a""findProcess( *child ) );\x0a"
"            if ( proc )\x0a"
"                for ( auto \x26""fd \x3a proc->_fds )\x0a"
"                    if ( fd.inode() )\x0a"
"                        fd.inode()->open(); /* update refcount */\x0a"
"            return proc;\x0a"
"        }\x0a"
"\x0a"
"        template< typename Setup >\x0a"
"        void setup( Setup s )\x0a"
"        {\x0a"
"            traceAlias< VFS >( \x22{VFS}\x22 );\x0a"
"\x0a"
"            for ( auto env = s.env ; env->key; env++ )\x0a"
"                if ( \x21strcmp( env->key, \x22vfs.stdin\x22 ) )\x0a"
"                    _stdio\x5b 0 \x5d = new StandardInput( env->value, env->size );\x0a"
"\x0a"
"            if ( \x21_stdio\x5b 0 \x5d )\x0a"
"                _stdio\x5b 0 \x5d = new StandardInput();\x0a"
"            _stdio\x5b 1 \x5d = make_tracefile( s.opts, \x22stdout\x22 );\x0a"
"            _stdio\x5b 2 \x5d = make_tracefile( s.opts, \x22stderr\x22 );\x0a"
"\x0a"
"            for ( int i = 0; i <= 2; ++i )\x0a"
"            {\x0a"
"                _stdio\x5b i \x5d->mode( S_IFREG \x7c S_IRUSR );\x0a"
"                s.proc1->_fds.emplace_back( _stdio\x5b i \x5d, i \x3f O_WRONLY \x3a O_RDONLY );\x0a"
"                s.proc1->_fd_refs.emplace_back( i );\x0a"
"            }\x0a"
"\x0a"
"            s.proc1->_umask = S_IWGRP \x7c S_IWOTH;\x0a"
"\x0a"
"            _root = new Directory();\x0a"
"            _root->mode( S_IFDIR \x7c ACCESSPERMS );\x0a"
"            _root->link();\x0a"
"            s.proc1->_cwd = _root;\x0a"
"\x0a"
"            import( s.env );\x0a"
"            Next\x3a\x3asetup( s );\x0a"
"        }\x0a"
"\x0a"
"         void getHelp( ArrayMap< std\x3a\x3astring_view, HelpOption >\x26 options )\x0a"
"         {\x0a"
"            const char *opt1 = \x22{stdout\x7cstderr}\x22;\x0a"
"            if ( options.find( opt1 ) \x21= options.end() )\x0a"
"            {\x0a"
"                __dios_trace_f( \x22Option \x25s already present\x22, opt1 );\x0a"
"                __dios_fault( _DiOS_F_Config, \x22Option conflict\x22 );\x0a"
"            };\x0a"
"\x0a"
"            options\x5b { opt1 } \x5d = { \x22specify how to treat program output\x22,\x0a"
"              { \x22notrace - ignore the stream\x22,\x0a"
"                \x22unbuffered - trace each write\x22,\x0a"
"                \x22trace - trace after each newline (default)\x22} };\x0a"
"\x0a"
"            Next\x3a\x3agetHelp( options );\x0a"
"        }\x0a"
"\x0a"
"        static Node make_tracefile( SysOpts\x26 o, std\x3a\x3astring_view stream )\x0a"
"        {\x0a"
"            auto r = extract_opt( stream, o );\x0a"
"\x0a"
"            if ( r.empty() \x7c\x7c r == \x22trace\x22 )\x0a"
"                return new VmBuffTraceFile();\x0a"
"            if ( r == \x22unbuffered\x22 )\x0a"
"                return new VmTraceFile();\x0a"
"            if ( r == \x22notrace\x22 )\x0a"
"                return new NullFile();\x0a"
"\x0a"
"            __dios_trace_f( \x22Invalid configuration for file \x25.*s\x22,\x0a"
"                            int( stream.size() ), stream.begin() );\x0a"
"            __vm_ctl_flag( 0, _VM_CF_Error );\x0a"
"\x0a"
"            return new NullFile();\x0a"
"        }\x0a"
"\x0a"
"    private\x3a /* helper methods */\x0a"
"\x0a"
"        Node _root;\x0a"
"        std\x3a\x3a""array< Node, 3 > _stdio;\x0a"
"\x0a"
"    public\x3a /* system call implementation */\x0a"
"\x0a"
"        int creat( const char *path, Mode mode )\x0a"
"        {\x0a"
"            return mknodat( AT_FDCWD, path, mode \x7c S_IFREG, 0 );\x0a"
"        }\x0a"
"\x0a"
"        int close( int fd_ )\x0a"
"        {\x0a"
"            if ( auto fd = check_fd( fd_, F_OK ) )\x0a"
"            {\x0a"
"                fd->unref();\x0a"
"                proc()._fd_refs\x5b fd_ \x5d = -1;\x0a"
"                return 0;\x0a"
"            }\x0a"
"            else\x0a"
"                return -1;\x0a"
"        }\x0a"
"\x0a"
"        int fdatasync( int fd  )\x0a"
"        {\x0a"
"            return fsync( fd ); /* same thing for us */\x0a"
"        }\x0a"
"\x0a"
"        int fsync( int fd )\x0a"
"        {\x0a"
"            if ( \x21""check_fd( fd, F_OK ) )\x0a"
"                return -1;\x0a"
"            else\x0a"
"                return 0;\x0a"
"        }\x0a"
"\x0a"
"        int syncfs( int fd )\x0a"
"        {\x0a"
"            if ( \x21""check_fd( fd, F_OK ) )\x0a"
"                return -1;\x0a"
"            else\x0a"
"                return 0;\x0a"
"        }\x0a"
"\x0a"
"        void sync()\x0a"
"        {\x0a"
"        }\x0a"
"\x0a"
"        int fstatfs( int, struct statfs* )\x0a"
"        {\x0a"
"            __dios_trace_t( \x22""fstatfs() is not implemented\x22 );\x0a"
"            return -1;\x0a"
"        }\x0a"
"\x0a"
"        int statfs( const char *, struct statfs * )\x0a"
"        {\x0a"
"            __dios_trace_t( \x22statfs() is not implemented\x22 );\x0a"
"            return -1;\x0a"
"        }\x0a"
"    };\x0a"
"\x0a"
"}\x0a"
"", 7732 ); }