#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_socket_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2015 Ji\xc5\x99\xc3\xad Weiser\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"\x0a"
"#include <algorithm>\x0a"
"#include <signal.h>\x0a"
"#include <dios.h>\x0a"
"#include <dios/sys/memory.hpp>\x0a"
"#include <dios/sys/stdlibwrap.hpp> // Queue\x0a"
"#include <rst/common.hpp>\x0a"
"#include <sys/fault.h>\x0a"
"#include <sys/trace.h>\x0a"
"\x0a"
"#include <dios/vfs/inode.hpp>\x0a"
"#include <dios/vfs/fd.hpp>\x0a"
"#include <dios/vfs/stream.hpp>\x0a"
"\x0a"
"#define FS_CHOICE_GOAL          0\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"\x0a"
"struct Socket \x3a INode\x0a"
"{\x0a"
"    struct Address\x0a"
"    {\x0a"
"        Address() \x3a\x0a"
"            _anonymous( true ),\x0a"
"            _valid( false )\x0a"
"        {}\x0a"
"\x0a"
"        explicit Address( std\x3a\x3astring_view value, bool anonymous = false ) \x3a\x0a"
"            _anonymous( anonymous ),\x0a"
"            _valid( true )\x0a"
"        {\x0a"
"            _value.assign( value.size(), value.begin(), value.end() );\x0a"
"        }\x0a"
"\x0a"
"        Address( const Address \x26 ) = default;\x0a"
"        Address( Address \x26\x26 ) = default;\x0a"
"\x0a"
"        Address \x26operator=( Address other ) {\x0a"
"            swap( other );\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"        std\x3a\x3astring_view value() const { return { _value.begin(), _value.size() }; }\x0a"
"\x0a"
"        bool anonymous() const {\x0a"
"            return _anonymous;\x0a"
"        }\x0a"
"\x0a"
"        bool valid() const {\x0a"
"            return _valid;\x0a"
"        }\x0a"
"\x0a"
"        size_t size() const {\x0a"
"            return _value.size();\x0a"
"        }\x0a"
"\x0a"
"        explicit operator bool() const {\x0a"
"            return _valid;\x0a"
"        }\x0a"
"\x0a"
"        void swap( Address \x26other ) {\x0a"
"            using std\x3a\x3aswap;\x0a"
"\x0a"
"            swap( _value, other._value );\x0a"
"            swap( _anonymous, other._anonymous );\x0a"
"            swap( _valid, other._valid );\x0a"
"        }\x0a"
"\x0a"
"        bool operator==( const Address \x26other ) const {\x0a"
"            return\x0a"
"                _valid == other._valid \x26\x26\x0a"
"                _anonymous == other._anonymous \x26\x26\x0a"
"                _value == other._value;\x0a"
"        }\x0a"
"\x0a"
"        bool operator\x21=( const Address \x26other ) const {\x0a"
"            return \x21operator==( other );\x0a"
"        }\x0a"
"\x0a"
"    private\x3a\x0a"
"        Array< char > _value;\x0a"
"        bool _anonymous;\x0a"
"        bool _valid;\x0a"
"    };\x0a"
"\x0a"
"    void open( FileDescriptor \x26""fd ) override\x0a"
"    {\x0a"
"        fd.flags().clear( O_RDONLY \x7c O_WRONLY );\x0a"
"        fd.flags().set( O_RDWR );\x0a"
"        INode\x3a\x3aopen( fd );\x0a"
"    }\x0a"
"\x0a"
"    bool read( char *buffer, size_t, size_t \x26length ) override\x0a"
"    {\x0a"
"        return \x21\x21receive( buffer, length, 0 );\x0a"
"    }\x0a"
"\x0a"
"    std\x3a\x3astring_view address() override { return _address.value(); }\x0a"
"    bool bind( std\x3a\x3astring_view addr ) override { _address = Address( addr ); return true; }\x0a"
"\x0a"
"    virtual Socket *sock_peer() const = 0;\x0a"
"    const Address \x26sock_address() const { return _address; }\x0a"
"\x0a"
"    virtual bool canReceive( size_t ) const = 0;\x0a"
"    virtual bool canConnect() const = 0;\x0a"
"\x0a"
"    virtual bool addBacklog( Node ) = 0;\x0a"
"\x0a"
"    virtual bool fillBuffer( const char*, size_t \x26 ) = 0;\x0a"
"    virtual bool fillBuffer( Node sender, const char *, size_t \x26 ) = 0;\x0a"
"\x0a"
"private\x3a\x0a"
"    Address _address;\x0a"
"};\x0a"
"\x0a"
"}\x0a"
"\x0a"
"namespace std {\x0a"
"template<>\x0a"
"struct hash< \x3a\x3a__dios\x3a\x3a""fs\x3a\x3aSocket\x3a\x3a""Address > {\x0a"
"    size_t operator()( const \x3a\x3a__dios\x3a\x3a""fs\x3a\x3aSocket\x3a\x3a""Address \x26""a ) const {\x0a"
"        return hash< std\x3a\x3astring_view >()( a.value() );\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template<>\x0a"
"inline void swap( \x3a\x3a__dios\x3a\x3a""fs\x3a\x3aSocket\x3a\x3a""Address \x26lhs, \x3a\x3a__dios\x3a\x3a""fs\x3a\x3aSocket\x3a\x3a""Address \x26rhs ) {\x0a"
"    lhs.swap( rhs );\x0a"
"}\x0a"
"\x0a"
"} // namespace std\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs {\x0a"
"\x0a"
"struct SocketStream \x3a Socket\x0a"
"{\x0a"
"    SocketStream() \x3a\x0a"
"        _peer( nullptr ),\x0a"
"        _stream( 1024 ),\x0a"
"        _passive( false ),\x0a"
"        _limit( 0 )\x0a"
"    {}\x0a"
"\x0a"
"    SocketStream( Node partner ) \x3a\x0a"
"        _peer( std\x3a\x3amove( partner ) ),\x0a"
"        _stream( 1024 ),\x0a"
"        _passive( true ),\x0a"
"        _limit( 0 )\x0a"
"    {}\x0a"
"\x0a"
"    virtual \x7eSocketStream() { abort( false ); }\x0a"
"    Node peer() const override { return _peer; }\x0a"
"\x0a"
"    SocketStream *sock_peer() const override\x0a"
"    {\x0a"
"        return _peer \x3f _peer->as< SocketStream >() \x3a nullptr;\x0a"
"    }\x0a"
"\x0a"
"    void abort( bool remote )\x0a"
"    {\x0a"
"        if ( _peer \x26\x26 \x21remote )\x0a"
"            sock_peer()->abort( true );\x0a"
"        _peer = nullptr;\x0a"
"    }\x0a"
"\x0a"
"    bool listen( int limit ) override\x0a"
"    {\x0a"
"        _passive = true;\x0a"
"        _limit = limit;\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    Node accept() override\x0a"
"    {\x0a"
"        if ( \x21_passive )\x0a"
"            return error( EINVAL ), nullptr;\x0a"
"\x0a"
"        // progress or deadlock\x0a"
"        if ( _backlog.empty() )\x0a"
"            __vm_cancel();\x0a"
"\x0a"
"        Node result( std\x3a\x3amove( _backlog.front() ) );\x0a"
"        _backlog.pop();\x0a"
"        return result;\x0a"
"    }\x0a"
"\x0a"
"    bool connect( Node remote, bool allocateNew )\x0a"
"    {\x0a"
"        if ( _peer )\x0a"
"            return error( EISCONN ), false;\x0a"
"\x0a"
"        SocketStream *m = remote->as< SocketStream >();\x0a"
"\x0a"
"        if ( allocateNew )\x0a"
"        {\x0a"
"            if ( \x21m->canConnect() )\x0a"
"                return error( ECONNREFUSED ), false;\x0a"
"\x0a"
"            _peer = new SocketStream( this );\x0a"
"            _peer->mode( ACCESSPERMS );\x0a"
"            return m->addBacklog( _peer );\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            _peer = remote;\x0a"
"            m->_peer = this;\x0a"
"            return true;\x0a"
"        }\x0a"
"    }\x0a"
"\x0a"
"    bool connect( Node remote ) override\x0a"
"    {\x0a"
"        return connect( remote, true );\x0a"
"    }\x0a"
"\x0a"
"    bool addBacklog( Node incoming ) override\x0a"
"    {\x0a"
"        if ( int( _backlog.size() ) == _limit )\x0a"
"            return error( ECONNREFUSED ), false;\x0a"
"        incoming->bind( address() );\x0a"
"        _backlog.push( std\x3a\x3amove( incoming ) );\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    bool canRead() const override {\x0a"
"        return \x21_stream.empty();\x0a"
"    }\x0a"
"\x0a"
"    bool canWrite( int size, Node ) const override\x0a"
"    {\x0a"
"        return peer() \x26\x26 sock_peer()->canReceive( size );\x0a"
"    }\x0a"
"\x0a"
"    bool canReceive( size_t amount ) const override {\x0a"
"        return _stream.size() + amount <= _stream.capacity();\x0a"
"    }\x0a"
"    bool canConnect() const override {\x0a"
"        return _passive;\x0a"
"    }\x0a"
"\x0a"
"    bool write( const char *buffer, size_t, size_t \x26length, Node ) override\x0a"
"    {\x0a"
"        if ( \x21peer() )\x0a"
"            return error( ENOTCONN ), false;\x0a"
"\x0a"
"        if ( \x21peer()->mode().user_write() )\x0a"
"            return error( EACCES ), false;\x0a"
"\x0a"
"        return sock_peer()->fillBuffer( buffer, length );\x0a"
"    }\x0a"
"\x0a"
"    Node receive( char *buffer, size_t \x26length, MFlags flags ) override\x0a"
"    {\x0a"
"        if ( \x21peer() )\x0a"
"            return error( ENOTCONN ), nullptr;\x0a"
"\x0a"
"        if ( _stream.empty() )\x0a"
"            __vm_cancel();\x0a"
"\x0a"
"        if ( flags.has( MSG_WAITALL ) \x26\x26 _stream.size() < length )\x0a"
"            __vm_cancel();\x0a"
"\x0a"
"        if ( flags.has( MSG_PEEK ) )\x0a"
"            length = _stream.peek( buffer, length );\x0a"
"        else\x0a"
"            length = _stream.pop( buffer, length );\x0a"
"\x0a"
"        return peer();\x0a"
"    }\x0a"
"\x0a"
"    bool fillBuffer( Node, const char *, size_t \x26 ) override\x0a"
"    {\x0a"
"        return error( EPROTOTYPE ), false;\x0a"
"    }\x0a"
"\x0a"
"    bool fillBuffer( const char *buffer, size_t \x26length ) override\x0a"
"    {\x0a"
"        if ( \x21peer() )\x0a"
"            return error( ECONNRESET ), false;\x0a"
"\x0a"
"        length = _stream.push( buffer, length );\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    Node _peer;\x0a"
"    Stream _stream;\x0a"
"    bool _passive;\x0a"
"    Queue< Node > _backlog;\x0a"
"    int _limit;\x0a"
"};\x0a"
"\x0a"
"struct SocketDatagram \x3a Socket\x0a"
"{\x0a"
"\x0a"
"    SocketDatagram()\x0a"
"    {}\x0a"
"\x0a"
"    Node peer()  const override\x0a"
"    {\x0a"
"        if ( auto dr = _defaultRecipient )\x0a"
"        {\x0a"
"            SocketDatagram *defRec = dr->as< SocketDatagram >();\x0a"
"            if ( auto self = defRec->_defaultRecipient )\x0a"
"                if ( self == this )\x0a"
"                    return dr;\x0a"
"        }\x0a"
"        return nullptr;\x0a"
"    }\x0a"
"\x0a"
"    Socket *sock_peer() const override\x0a"
"    {\x0a"
"        auto p = peer();\x0a"
"        return p \x3f p->as< Socket >() \x3a nullptr;\x0a"
"    }\x0a"
"\x0a"
"    bool canRead() const override {\x0a"
"        return \x21_packets.empty();\x0a"
"    }\x0a"
"\x0a"
"    bool canWrite( int size, Node remote ) const override\x0a"
"    {\x0a"
"        if ( \x21remote )\x0a"
"            remote = _defaultRecipient;\x0a"
"        if ( \x21remote )\x0a"
"            return true;\x0a"
"        return \x21remote->as< Socket >()->canReceive( size );\x0a"
"    }\x0a"
"\x0a"
"    bool canReceive( size_t ) const override {\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    bool canConnect() const override {\x0a"
"        return false;\x0a"
"    }\x0a"
"\x0a"
"    bool listen( int ) override\x0a"
"    {\x0a"
"        return error( EOPNOTSUPP ), false;\x0a"
"    }\x0a"
"\x0a"
"    Node accept() override {\x0a"
"        return error( EOPNOTSUPP ), nullptr;\x0a"
"    }\x0a"
"\x0a"
"    bool addBacklog( Node ) override { return true; }\x0a"
"\x0a"
"    bool connect( Node defaultRecipient ) override\x0a"
"    {\x0a"
"        /* FIXME the default recipient might disappear any time */\x0a"
"        _defaultRecipient = defaultRecipient;\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"    bool write( const char *buffer, size_t, size_t \x26length, Node remote ) override\x0a"
"    {\x0a"
"        if ( \x21remote )\x0a"
"            remote = _defaultRecipient;\x0a"
"\x0a"
"        if ( \x21remote )\x0a"
"            return error( EDESTADDRREQ ), false;\x0a"
"\x0a"
"        if ( \x21remote->mode().user_write() )\x0a"
"            return error( EACCES ), false;\x0a"
"\x0a"
"        Socket *socket = remote->as< Socket >();\x0a"
"        return socket->fillBuffer( this, buffer, length );\x0a"
"    }\x0a"
"\x0a"
"    Node receive( char *buffer, size_t \x26length, MFlags flags ) override\x0a"
"    {\x0a"
"        if ( flags.has( MSG_DONTWAIT ) \x26\x26 _packets.empty() )\x0a"
"            return error( EAGAIN ), nullptr;\x0a"
"\x0a"
"        if  ( _packets.empty() )\x0a"
"            __vm_cancel();\x0a"
"\x0a"
"        length = _packets.front().read( buffer, length );\x0a"
"        auto peer = _packets.front().from();\x0a"
"        if ( \x21""flags.has( MSG_PEEK ) )\x0a"
"            _packets.pop();\x0a"
"\x0a"
"        return peer;\x0a"
"    }\x0a"
"\x0a"
"    bool fillBuffer( const char *, size_t \x26/*length*/ ) override\x0a"
"    {\x0a"
"        return error( EPROTOTYPE ), false;\x0a"
"    }\x0a"
"\x0a"
"    bool fillBuffer( Node sender, const char *buffer, size_t \x26length ) override\x0a"
"    {\x0a"
"        _packets.emplace( sender, buffer, length );\x0a"
"        return true;\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    struct Packet {\x0a"
"\x0a"
"        Packet( Node from, const char *data, size_t length ) \x3a\x0a"
"            _from( std\x3a\x3amove( from ) ),\x0a"
"            _data( length, data, data + length )\x0a"
"        {}\x0a"
"\x0a"
"        Packet( const Packet \x26 ) = delete;\x0a"
"        Packet( Packet \x26\x26 ) = default;\x0a"
"        Packet \x26operator=( Packet other ) {\x0a"
"            swap( other );\x0a"
"            return *this;\x0a"
"        }\x0a"
"\x0a"
"        size_t read( char *buffer, size_t max ) const {\x0a"
"            size_t result = std\x3a\x3amin( max, size_t( _data.size() ) );\x0a"
"            std\x3a\x3a""copy( _data.begin(), _data.begin() + result, buffer );\x0a"
"            return result;\x0a"
"        }\x0a"
"\x0a"
"        Node from() const {\x0a"
"            return _from;\x0a"
"        }\x0a"
"\x0a"
"        void swap( Packet \x26other ) {\x0a"
"            using std\x3a\x3aswap;\x0a"
"\x0a"
"            swap( _from, other._from );\x0a"
"            swap( _data, other._data );\x0a"
"        }\x0a"
"\x0a"
"    private\x3a\x0a"
"        Node _from;\x0a"
"        Array< char > _data;\x0a"
"    };\x0a"
"\x0a"
"    Queue< Packet > _packets;\x0a"
"    Node _defaultRecipient;\x0a"
"};\x0a"
"\x0a"
"}\x0a"
"", 11251 ); }