#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_stream_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2019 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" * (c) 2015 Ji\xc5\x99\xc3\xad Weiser\x0a"
" * (c) 2014 Vladim\xc3\xadr \xc5\xa0till\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#pragma once\x0a"
"#include <util/array.hpp>\x0a"
"#include <algorithm>\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"\x0a"
"    struct Stream\x0a"
"    {\x0a"
"\x0a"
"        Stream( size_t capacity ) \x3a\x0a"
"            _data( capacity ),\x0a"
"            _head( 0 ),\x0a"
"            _occupied( 0 )\x0a"
"        {}\x0a"
"\x0a"
"        size_t size() const { return _occupied; }\x0a"
"        bool empty() const { return _occupied == 0; }\x0a"
"        size_t capacity() const { return _data.size(); }\x0a"
"\x0a"
"        size_t push( const char *data, size_t length )\x0a"
"        {\x0a"
"            if ( _occupied + length > capacity() )\x0a"
"                length = capacity() - _occupied;\x0a"
"\x0a"
"            if ( \x21length )\x0a"
"                return 0;\x0a"
"\x0a"
"            size_t usedLength = std\x3a\x3amin( length, capacity() - ( _head + _occupied ) \x25 capacity() );\x0a"
"            std\x3a\x3a""copy( data, data + usedLength, end() );\x0a"
"            _occupied += usedLength;\x0a"
"\x0a"
"            if ( usedLength < length )\x0a"
"            {\x0a"
"                std\x3a\x3a""copy( data + usedLength, data + length, end() );\x0a"
"                _occupied += length - usedLength;\x0a"
"            }\x0a"
"            return length;\x0a"
"        }\x0a"
"\x0a"
"        size_t pop( char *data, size_t length )\x0a"
"        {\x0a"
"            if ( _occupied < length )\x0a"
"                length = _occupied;\x0a"
"\x0a"
"            if ( \x21length )\x0a"
"                return 0;\x0a"
"\x0a"
"            size_t usedLength = std\x3a\x3amin( length, capacity() - _head );\x0a"
"            std\x3a\x3a""copy( begin(), begin() + usedLength, data );\x0a"
"            _head = ( _head + usedLength ) \x25 capacity();\x0a"
"\x0a"
"            if ( usedLength < length )\x0a"
"            {\x0a"
"                std\x3a\x3a""copy( begin(), begin() + length - usedLength, data + usedLength );\x0a"
"                _head = ( _head + length - usedLength ) \x25 capacity();\x0a"
"            }\x0a"
"            _occupied -= length;\x0a"
"            return length;\x0a"
"        }\x0a"
"\x0a"
"        size_t peek( char *data, size_t length )\x0a"
"        {\x0a"
"            size_t head = _head;\x0a"
"            size_t occupied = _occupied;\x0a"
"            size_t r = pop( data, length );\x0a"
"            _head = head;\x0a"
"            _occupied = occupied;\x0a"
"            return r;\x0a"
"        }\x0a"
"\x0a"
"        bool resize( size_t newCapacity )\x0a"
"        {\x0a"
"            if ( newCapacity < size() )\x0a"
"                return false;\x0a"
"\x0a"
"            Array< char > newData( newCapacity );\x0a"
"\x0a"
"            _occupied = pop( \x26newData.front(), _occupied );\x0a"
"            _head = 0;\x0a"
"            _data.swap( newData );\x0a"
"            return true;\x0a"
"        }\x0a"
"\x0a"
"    private\x3a\x0a"
"        using Iterator = Array< char >\x3a\x3aiterator;\x0a"
"\x0a"
"        Iterator begin() { return _data.begin() + _head; }\x0a"
"        Iterator end() { return _data.begin() + ( _head + _occupied ) \x25 capacity(); }\x0a"
"\x0a"
"        Array< char > _data;\x0a"
"        unsigned _head;\x0a"
"        unsigned _occupied;\x0a"
"    };\x0a"
"\x0a"
"}\x0a"
"", 3513 ); }