#include <string_view>
namespace divine::str::dios {
extern const std::string_view vfs_syscall_hpp( 
"// -*- mode\x3a C++; indent-tabs-mode\x3a nil; c-basic-offset\x3a 4 -*-\x0a"
"\x0a"
"/*\x0a"
" * (c) 2018 Petr Ro\xc4\x8dkai <code\x40""fixp.eu>\x0a"
" *\x0a"
" * Permission to use, copy, modify, and distribute this software for any\x0a"
" * purpose with or without fee is hereby granted, provided that the above\x0a"
" * copyright notice and this permission notice appear in all copies.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22 AND THE AUTHOR DISCLAIMS ALL WARRANTIES\x0a"
" * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF\x0a"
" * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR\x0a"
" * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\x0a"
" * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN\x0a"
" * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF\x0a"
" * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.\x0a"
" */\x0a"
"\x0a"
"#include <dios/vfs/base.hpp>\x0a"
"#pragma once\x0a"
"\x0a"
"namespace __dios\x3a\x3a""fs\x0a"
"{\x0a"
"\x0a"
"    struct Syscall \x3a Base\x0a"
"    {\x0a"
"        using Base\x3a\x3a""Base;\x0a"
"\x0a"
"        int open( const char *path, int flags, Mode mode );\x0a"
"        int openat( int dirfd, const char *path, OFlags flags, Mode mode );\x0a"
"\x0a"
"        int _dup( int fd, int min );\x0a"
"        int dup( int fd ) { return _dup( fd, 0 ); }\x0a"
"        int dup2( int oldfd, int newfd );\x0a"
"        int fcntl( int fd, int cmd, va_list *va );\x0a"
"\x0a"
"        void _chmod( Node ino, Mode mode )\x0a"
"        {\x0a"
"            ino->mode() = ( ino->mode() \x26 \x7e""ALLPERMS ) \x7c ( mode \x26 ALLPERMS );\x0a"
"        }\x0a"
"\x0a"
"        int fchmodat( int dirfd, const char *path, Mode mode, int flags );\x0a"
"        int fchmod( int fd_, Mode mode );\x0a"
"        int chmod( const char *path, Mode mode );\x0a"
"\x0a"
"        ssize_t write( int fd_, const void *buf, size_t count );\x0a"
"        ssize_t read( int fd_, void* buf, size_t count );\x0a"
"\x0a"
"        int mkdirat( int dirfd, const char *path, Mode mode );\x0a"
"        int mkdir( const char *path, Mode mode );\x0a"
"        int mknodat( int dirfd, const char *path, Mode mode, dev_t dev );\x0a"
"        int mknod( const char *path, Mode mode, dev_t dev );\x0a"
"\x0a"
"        int _truncate( Node ino, off_t length )\x0a"
"        {\x0a"
"            if ( length < 0 )\x0a"
"                return error( EINVAL ), -1;\x0a"
"            if ( ino->mode().is_dir() )\x0a"
"                return error( EISDIR ), -1;\x0a"
"            if ( auto file = ino->template as< RegularFile >() )\x0a"
"                return file->resize( length ), 0;\x0a"
"            else\x0a"
"                return error( EINVAL ), -1;\x0a"
"        }\x0a"
"\x0a"
"        off_t lseek( int fd_, off_t off, int whence );\x0a"
"        int ftruncate( int fd_, off_t length );\x0a"
"        int truncate( const char *path, off_t length );\x0a"
"\x0a"
"        int unlink( const char *path );\x0a"
"        int rmdir( const char *path );\x0a"
"        int unlinkat( int dirfd, const char *path, int flags );\x0a"
"\x0a"
"        int stat( const char *path, struct stat *buf );\x0a"
"        int lstat( const char *path, struct stat *buf  );\x0a"
"        int fstat( int fd, struct stat *buf );\x0a"
"        int fstatat( int dirfd, const char *path, struct stat *buf, int flag );\x0a"
"\x0a"
"        int linkat( int olddirfd, const char *target, int newdirfd, const char * linkpath, int flags );\x0a"
"        int link( const char *target, const char *linkpath );\x0a"
"        int symlinkat( const char *target, int dirfd, const char *linkpath );\x0a"
"        int symlink( const char *target, const char *linkpath );\x0a"
"\x0a"
"        int umask( Mode mask )\x0a"
"        {\x0a"
"            auto old = proc()._umask;\x0a"
"            proc()._umask = mask \x26 ACCESSPERMS;\x0a"
"            return old.to_i();\x0a"
"        }\x0a"
"\x0a"
"        int renameat( int olddirfd, const char *oldpath, int newdirfd, const char *newpath );\x0a"
"        int rename( const char *oldpath, const char *newpath )\x0a"
"        {\x0a"
"            return renameat( AT_FDCWD, oldpath, AT_FDCWD, newpath );\x0a"
"        }\x0a"
"\x0a"
"        int _chdir( Node ino )\x0a"
"        {\x0a"
"            if ( \x21ino )\x0a"
"                return -1;\x0a"
"            if ( \x21ino->mode().is_dir() )\x0a"
"                return error( ENOTDIR ), -1;\x0a"
"            if ( \x21ino->mode().user_exec() )\x0a"
"                return error( EACCES ), -1;\x0a"
"            proc()._cwd = ino;\x0a"
"            return 0;\x0a"
"        }\x0a"
"\x0a"
"        int chdir( const char *path );\x0a"
"        int fchdir( int dirfd );\x0a"
"        char *getcwd( char *buf, size_t size );\x0a"
"        int __getcwd( char *buf, size_t size );\x0a"
"\x0a"
"        ssize_t readlinkat( int dirfd, const char *path, char *buf, size_t size );\x0a"
"        ssize_t readlink( const char *path, char *buf, size_t size );\x0a"
"\x0a"
"        int access( const char *path, int amode );\x0a"
"        int faccessat( int dirfd, const char *path, int amode, int flag );\x0a"
"\x0a"
"        int pipe( int fds\x5b""2\x5d );\x0a"
"        int socketpair( int dom, int type, int proto, int fds\x5b""2\x5d );\x0a"
"        int socket( int dom, SFlags type, int proto );\x0a"
"\x0a"
"        int getpeername( int sockfd, struct sockaddr *addr, socklen_t *len );\x0a"
"        int getsockname( int sockfd, struct sockaddr *addr, socklen_t *len );\x0a"
"\x0a"
"        int listen( int sockfd, int n );\x0a"
"        int connect( int sockfd, const struct sockaddr *addr, socklen_t len );\x0a"
"        int bind( int sockfd, const struct sockaddr *addr, socklen_t len );\x0a"
"        int accept( int fd, struct sockaddr *addr, socklen_t *len );\x0a"
"        int accept4( int fd, struct sockaddr *addr, socklen_t *len, SFlags flags );\x0a"
"\x0a"
"        ssize_t send( int sockfd, const void *buf, size_t n, int flags );\x0a"
"        ssize_t sendto( int sockfd, const void *buf, size_t n, int flags,\x0a"
"                        const sockaddr *addr, socklen_t len );\x0a"
"\x0a"
"        ssize_t recv( int sockfd, void *buf, size_t n, MFlags flags );\x0a"
"        ssize_t recvfrom( int sockfd, void *buf, size_t n, MFlags flags,\x0a"
"                          struct sockaddr *addr, socklen_t *len );\x0a"
"    };\x0a"
"\x0a"
"}\x0a"
"", 5520 ); }