#include <string_view>
namespace divine::str::cc {
extern const std::string_view float_h( 
"/*===---- float.h - Characteristics of floating point types ----------------===\x0a"
" *\x0a"
" * Permission is hereby granted, free of charge, to any person obtaining a copy\x0a"
" * of this software and associated documentation files (the \x22Software\x22), to deal\x0a"
" * in the Software without restriction, including without limitation the rights\x0a"
" * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\x0a"
" * copies of the Software, and to permit persons to whom the Software is\x0a"
" * furnished to do so, subject to the following conditions\x3a\x0a"
" *\x0a"
" * The above copyright notice and this permission notice shall be included in\x0a"
" * all copies or substantial portions of the Software.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\x0a"
" * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\x0a"
" * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\x0a"
" * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\x0a"
" * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\x0a"
" * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\x0a"
" * THE SOFTWARE.\x0a"
" *\x0a"
" *===-----------------------------------------------------------------------===\x0a"
" */\x0a"
"\x0a"
"#ifndef __CLANG_FLOAT_H\x0a"
"#define __CLANG_FLOAT_H\x0a"
"\x0a"
"/* If we're on MinGW, fall back to the system's float.h, which might have\x0a"
" * additional definitions provided for Windows.\x0a"
" * For more details see http\x3a//msdn.microsoft.com/en-us/library/y0ybw9fy.aspx\x0a"
" *\x0a"
" * Also fall back on Darwin to allow additional definitions and\x0a"
" * implementation-defined values.\x0a"
" */\x0a"
"#if (defined(__APPLE__) \x7c\x7c (defined(__MINGW32__) \x7c\x7c defined(_MSC_VER))) \x26\x26 \x5c\x0a"
"    __STDC_HOSTED__ \x26\x26 __has_include_next(<float.h>)\x0a"
"\x0a"
"/* Prior to Apple's 10.7 SDK, float.h SDK header used to apply an extra level\x0a"
" * of #include_next<float.h> to keep Metrowerks compilers happy. Avoid this\x0a"
" * extra indirection.\x0a"
" */\x0a"
"#ifdef __APPLE__\x0a"
"#define _FLOAT_H_\x0a"
"#endif\x0a"
"\x0a"
"#  include_next <float.h>\x0a"
"\x0a"
"/* Undefine anything that we'll be redefining below. */\x0a"
"#  undef FLT_EVAL_METHOD\x0a"
"#  undef FLT_ROUNDS\x0a"
"#  undef FLT_RADIX\x0a"
"#  undef FLT_MANT_DIG\x0a"
"#  undef DBL_MANT_DIG\x0a"
"#  undef LDBL_MANT_DIG\x0a"
"#  if __STDC_VERSION__ >= 199901L \x7c\x7c \x21""defined(__STRICT_ANSI__)\x0a"
"#    undef DECIMAL_DIG\x0a"
"#  endif\x0a"
"#  undef FLT_DIG\x0a"
"#  undef DBL_DIG\x0a"
"#  undef LDBL_DIG\x0a"
"#  undef FLT_MIN_EXP\x0a"
"#  undef DBL_MIN_EXP\x0a"
"#  undef LDBL_MIN_EXP\x0a"
"#  undef FLT_MIN_10_EXP\x0a"
"#  undef DBL_MIN_10_EXP\x0a"
"#  undef LDBL_MIN_10_EXP\x0a"
"#  undef FLT_MAX_EXP\x0a"
"#  undef DBL_MAX_EXP\x0a"
"#  undef LDBL_MAX_EXP\x0a"
"#  undef FLT_MAX_10_EXP\x0a"
"#  undef DBL_MAX_10_EXP\x0a"
"#  undef LDBL_MAX_10_EXP\x0a"
"#  undef FLT_MAX\x0a"
"#  undef DBL_MAX\x0a"
"#  undef LDBL_MAX\x0a"
"#  undef FLT_EPSILON\x0a"
"#  undef DBL_EPSILON\x0a"
"#  undef LDBL_EPSILON\x0a"
"#  undef FLT_MIN\x0a"
"#  undef DBL_MIN\x0a"
"#  undef LDBL_MIN\x0a"
"#  if __STDC_VERSION__ >= 201112L \x7c\x7c \x21""defined(__STRICT_ANSI__)\x0a"
"#    undef FLT_TRUE_MIN\x0a"
"#    undef DBL_TRUE_MIN\x0a"
"#    undef LDBL_TRUE_MIN\x0a"
"#    undef FLT_DECIMAL_DIG\x0a"
"#    undef DBL_DECIMAL_DIG\x0a"
"#    undef LDBL_DECIMAL_DIG\x0a"
"#    undef FLT_HAS_SUBNORM\x0a"
"#    undef DBL_HAS_SUBNORM\x0a"
"#    undef LDBL_HAS_SUBNORM\x0a"
"#  endif\x0a"
"#endif\x0a"
"\x0a"
"/* Characteristics of floating point types, C99 5.2.4.2.2 */\x0a"
"\x0a"
"#define FLT_EVAL_METHOD __FLT_EVAL_METHOD__\x0a"
"#define FLT_ROUNDS (__builtin_flt_rounds())\x0a"
"#define FLT_RADIX __FLT_RADIX__\x0a"
"\x0a"
"#define FLT_MANT_DIG __FLT_MANT_DIG__\x0a"
"#define DBL_MANT_DIG __DBL_MANT_DIG__\x0a"
"#define LDBL_MANT_DIG __LDBL_MANT_DIG__\x0a"
"\x0a"
"#if __STDC_VERSION__ >= 199901L \x7c\x7c \x21""defined(__STRICT_ANSI__)\x0a"
"#  define DECIMAL_DIG __DECIMAL_DIG__\x0a"
"#endif\x0a"
"\x0a"
"#define FLT_DIG __FLT_DIG__\x0a"
"#define DBL_DIG __DBL_DIG__\x0a"
"#define LDBL_DIG __LDBL_DIG__\x0a"
"\x0a"
"#define FLT_MIN_EXP __FLT_MIN_EXP__\x0a"
"#define DBL_MIN_EXP __DBL_MIN_EXP__\x0a"
"#define LDBL_MIN_EXP __LDBL_MIN_EXP__\x0a"
"\x0a"
"#define FLT_MIN_10_EXP __FLT_MIN_10_EXP__\x0a"
"#define DBL_MIN_10_EXP __DBL_MIN_10_EXP__\x0a"
"#define LDBL_MIN_10_EXP __LDBL_MIN_10_EXP__\x0a"
"\x0a"
"#define FLT_MAX_EXP __FLT_MAX_EXP__\x0a"
"#define DBL_MAX_EXP __DBL_MAX_EXP__\x0a"
"#define LDBL_MAX_EXP __LDBL_MAX_EXP__\x0a"
"\x0a"
"#define FLT_MAX_10_EXP __FLT_MAX_10_EXP__\x0a"
"#define DBL_MAX_10_EXP __DBL_MAX_10_EXP__\x0a"
"#define LDBL_MAX_10_EXP __LDBL_MAX_10_EXP__\x0a"
"\x0a"
"#define FLT_MAX __FLT_MAX__\x0a"
"#define DBL_MAX __DBL_MAX__\x0a"
"#define LDBL_MAX __LDBL_MAX__\x0a"
"\x0a"
"#define FLT_EPSILON __FLT_EPSILON__\x0a"
"#define DBL_EPSILON __DBL_EPSILON__\x0a"
"#define LDBL_EPSILON __LDBL_EPSILON__\x0a"
"\x0a"
"#define FLT_MIN __FLT_MIN__\x0a"
"#define DBL_MIN __DBL_MIN__\x0a"
"#define LDBL_MIN __LDBL_MIN__\x0a"
"\x0a"
"#if __STDC_VERSION__ >= 201112L \x7c\x7c \x21""defined(__STRICT_ANSI__)\x0a"
"#  define FLT_TRUE_MIN __FLT_DENORM_MIN__\x0a"
"#  define DBL_TRUE_MIN __DBL_DENORM_MIN__\x0a"
"#  define LDBL_TRUE_MIN __LDBL_DENORM_MIN__\x0a"
"#  define FLT_DECIMAL_DIG __FLT_DECIMAL_DIG__\x0a"
"#  define DBL_DECIMAL_DIG __DBL_DECIMAL_DIG__\x0a"
"#  define LDBL_DECIMAL_DIG __LDBL_DECIMAL_DIG__\x0a"
"#  define FLT_HAS_SUBNORM __FLT_HAS_DENORM__\x0a"
"#  define DBL_HAS_SUBNORM __DBL_HAS_DENORM__\x0a"
"#  define LDBL_HAS_SUBNORM __LDBL_HAS_DENORM__\x0a"
"#endif\x0a"
"\x0a"
"#ifdef __STDC_WANT_IEC_60559_TYPES_EXT__\x0a"
"#  define FLT16_MANT_DIG    __FLT16_MANT_DIG__\x0a"
"#  define FLT16_DECIMAL_DIG __FLT16_DECIMAL_DIG__\x0a"
"#  define FLT16_DIG         __FLT16_DIG__\x0a"
"#  define FLT16_MIN_EXP     __FLT16_MIN_EXP__\x0a"
"#  define FLT16_MIN_10_EXP  __FLT16_MIN_10_EXP__\x0a"
"#  define FLT16_MAX_EXP     __FLT16_MAX_EXP__\x0a"
"#  define FLT16_MAX_10_EXP  __FLT16_MAX_10_EXP__\x0a"
"#  define FLT16_MAX         __FLT16_MAX__\x0a"
"#  define FLT16_EPSILON     __FLT16_EPSILON__\x0a"
"#  define FLT16_MIN         __FLT16_MIN__\x0a"
"#  define FLT16_TRUE_MIN    __FLT16_TRUE_MIN__\x0a"
"#endif /* __STDC_WANT_IEC_60559_TYPES_EXT__ */\x0a"
"\x0a"
"#endif /* __CLANG_FLOAT_H */\x0a"
"", 5428 ); }