#include <string_view>
namespace divine::str::cc {
extern const std::string_view limits_h( 
"/*===---- limits.h - Standard header for integer sizes --------------------===*\x5c\x0a"
" *\x0a"
" * Copyright (c) 2009 Chris Lattner\x0a"
" *\x0a"
" * Permission is hereby granted, free of charge, to any person obtaining a copy\x0a"
" * of this software and associated documentation files (the \x22Software\x22), to deal\x0a"
" * in the Software without restriction, including without limitation the rights\x0a"
" * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\x0a"
" * copies of the Software, and to permit persons to whom the Software is\x0a"
" * furnished to do so, subject to the following conditions\x3a\x0a"
" *\x0a"
" * The above copyright notice and this permission notice shall be included in\x0a"
" * all copies or substantial portions of the Software.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\x0a"
" * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\x0a"
" * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\x0a"
" * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\x0a"
" * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\x0a"
" * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\x0a"
" * THE SOFTWARE.\x0a"
" *\x0a"
"\x5c*===----------------------------------------------------------------------===*/\x0a"
"\x0a"
"#ifndef __CLANG_LIMITS_H\x0a"
"#define __CLANG_LIMITS_H\x0a"
"\x0a"
"/* The system's limits.h may, in turn, try to #include_next GCC's limits.h.\x0a"
"   Avert this #include_next madness. */\x0a"
"#if defined __GNUC__ \x26\x26 \x21""defined _GCC_LIMITS_H_\x0a"
"#define _GCC_LIMITS_H_\x0a"
"#endif\x0a"
"\x0a"
"/* System headers include a number of constants from POSIX in <limits.h>.\x0a"
"   Include it if we're hosted. */\x0a"
"#if __STDC_HOSTED__ \x26\x26 __has_include_next(<limits.h>)\x0a"
"#include_next <limits.h>\x0a"
"#endif\x0a"
"\x0a"
"/* Many system headers try to \x22help us out\x22 by defining these.  No really, we\x0a"
"   know how big each datatype is. */\x0a"
"#undef  SCHAR_MIN\x0a"
"#undef  SCHAR_MAX\x0a"
"#undef  UCHAR_MAX\x0a"
"#undef  SHRT_MIN\x0a"
"#undef  SHRT_MAX\x0a"
"#undef  USHRT_MAX\x0a"
"#undef  INT_MIN\x0a"
"#undef  INT_MAX\x0a"
"#undef  UINT_MAX\x0a"
"#undef  LONG_MIN\x0a"
"#undef  LONG_MAX\x0a"
"#undef  ULONG_MAX\x0a"
"\x0a"
"#undef  CHAR_BIT\x0a"
"#undef  CHAR_MIN\x0a"
"#undef  CHAR_MAX\x0a"
"\x0a"
"/* C90/99 5.2.4.2.1 */\x0a"
"#define SCHAR_MAX __SCHAR_MAX__\x0a"
"#define SHRT_MAX  __SHRT_MAX__\x0a"
"#define INT_MAX   __INT_MAX__\x0a"
"#define LONG_MAX  __LONG_MAX__\x0a"
"\x0a"
"#define SCHAR_MIN (-__SCHAR_MAX__-1)\x0a"
"#define SHRT_MIN  (-__SHRT_MAX__ -1)\x0a"
"#define INT_MIN   (-__INT_MAX__  -1)\x0a"
"#define LONG_MIN  (-__LONG_MAX__ -1L)\x0a"
"\x0a"
"#define UCHAR_MAX (__SCHAR_MAX__*2  +1)\x0a"
"#define USHRT_MAX (__SHRT_MAX__ *2  +1)\x0a"
"#define UINT_MAX  (__INT_MAX__  *2U +1U)\x0a"
"#define ULONG_MAX (__LONG_MAX__ *2UL+1UL)\x0a"
"\x0a"
"#ifndef MB_LEN_MAX\x0a"
"#define MB_LEN_MAX 1\x0a"
"#endif\x0a"
"\x0a"
"#define CHAR_BIT  __CHAR_BIT__\x0a"
"\x0a"
"#ifdef __CHAR_UNSIGNED__  /* -funsigned-char */\x0a"
"#define CHAR_MIN 0\x0a"
"#define CHAR_MAX UCHAR_MAX\x0a"
"#else\x0a"
"#define CHAR_MIN SCHAR_MIN\x0a"
"#define CHAR_MAX __SCHAR_MAX__\x0a"
"#endif\x0a"
"\x0a"
"/* C99 5.2.4.2.1\x3a Added long long.\x0a"
"   C++11 18.3.3.2\x3a same contents as the Standard C Library header <limits.h>.\x0a"
" */\x0a"
"#if __STDC_VERSION__ >= 199901L \x7c\x7c __cplusplus >= 201103L\x0a"
"\x0a"
"#undef  LLONG_MIN\x0a"
"#undef  LLONG_MAX\x0a"
"#undef  ULLONG_MAX\x0a"
"\x0a"
"#define LLONG_MAX  __LONG_LONG_MAX__\x0a"
"#define LLONG_MIN  (-__LONG_LONG_MAX__-1LL)\x0a"
"#define ULLONG_MAX (__LONG_LONG_MAX__*2ULL+1ULL)\x0a"
"#endif\x0a"
"\x0a"
"/* LONG_LONG_MIN/LONG_LONG_MAX/ULONG_LONG_MAX are a GNU extension.  It's too bad\x0a"
"   that we don't have something like #pragma poison that could be used to\x0a"
"   deprecate a macro - the code should just use LLONG_MAX and friends.\x0a"
" */\x0a"
"#if defined(__GNU_LIBRARY__) \x3f defined(__USE_GNU) \x3a \x21""defined(__STRICT_ANSI__)\x0a"
"\x0a"
"#undef   LONG_LONG_MIN\x0a"
"#undef   LONG_LONG_MAX\x0a"
"#undef   ULONG_LONG_MAX\x0a"
"\x0a"
"#define LONG_LONG_MAX  __LONG_LONG_MAX__\x0a"
"#define LONG_LONG_MIN  (-__LONG_LONG_MAX__-1LL)\x0a"
"#define ULONG_LONG_MAX (__LONG_LONG_MAX__*2ULL+1ULL)\x0a"
"#endif\x0a"
"\x0a"
"#endif /* __CLANG_LIMITS_H */\x0a"
"", 3734 ); }