#include <string_view>
namespace divine::str::cc {
extern const std::string_view stddef_h( 
"/*===---- stddef.h - Basic type definitions --------------------------------===\x0a"
" *\x0a"
" * Copyright (c) 2008 Eli Friedman\x0a"
" *\x0a"
" * Permission is hereby granted, free of charge, to any person obtaining a copy\x0a"
" * of this software and associated documentation files (the \x22Software\x22), to deal\x0a"
" * in the Software without restriction, including without limitation the rights\x0a"
" * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\x0a"
" * copies of the Software, and to permit persons to whom the Software is\x0a"
" * furnished to do so, subject to the following conditions\x3a\x0a"
" *\x0a"
" * The above copyright notice and this permission notice shall be included in\x0a"
" * all copies or substantial portions of the Software.\x0a"
" *\x0a"
" * THE SOFTWARE IS PROVIDED \x22""AS IS\x22, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\x0a"
" * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\x0a"
" * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\x0a"
" * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\x0a"
" * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\x0a"
" * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\x0a"
" * THE SOFTWARE.\x0a"
" *\x0a"
" *===-----------------------------------------------------------------------===\x0a"
" */\x0a"
"\x0a"
"#if \x21""defined(__STDDEF_H) \x7c\x7c defined(__need_ptrdiff_t) \x7c\x7c                       \x5c\x0a"
"    defined(__need_size_t) \x7c\x7c defined(__need_wchar_t) \x7c\x7c                       \x5c\x0a"
"    defined(__need_NULL) \x7c\x7c defined(__need_wint_t)\x0a"
"\x0a"
"#if \x21""defined(__need_ptrdiff_t) \x26\x26 \x21""defined(__need_size_t) \x26\x26                   \x5c\x0a"
"    \x21""defined(__need_wchar_t) \x26\x26 \x21""defined(__need_NULL) \x26\x26                       \x5c\x0a"
"    \x21""defined(__need_wint_t)\x0a"
"/* Always define miscellaneous pieces when modules are available. */\x0a"
"#if \x21__has_feature(modules)\x0a"
"#define __STDDEF_H\x0a"
"#endif\x0a"
"#define __need_ptrdiff_t\x0a"
"#define __need_size_t\x0a"
"#define __need_wchar_t\x0a"
"#define __need_NULL\x0a"
"#define __need_STDDEF_H_misc\x0a"
"/* __need_wint_t is intentionally not defined here. */\x0a"
"#endif\x0a"
"\x0a"
"#if defined(__need_ptrdiff_t)\x0a"
"#if \x21""defined(_PTRDIFF_T) \x7c\x7c __has_feature(modules)\x0a"
"/* Always define ptrdiff_t when modules are available. */\x0a"
"#if \x21__has_feature(modules)\x0a"
"#define _PTRDIFF_T\x0a"
"#endif\x0a"
"typedef __PTRDIFF_TYPE__ ptrdiff_t;\x0a"
"#endif\x0a"
"#undef __need_ptrdiff_t\x0a"
"#endif /* defined(__need_ptrdiff_t) */\x0a"
"\x0a"
"#if defined(__need_size_t)\x0a"
"#if \x21""defined(_SIZE_T) \x7c\x7c __has_feature(modules)\x0a"
"/* Always define size_t when modules are available. */\x0a"
"#if \x21__has_feature(modules)\x0a"
"#define _SIZE_T\x0a"
"#endif\x0a"
"typedef __SIZE_TYPE__ size_t;\x0a"
"#endif\x0a"
"#undef __need_size_t\x0a"
"#endif /*defined(__need_size_t) */\x0a"
"\x0a"
"#if defined(__need_STDDEF_H_misc)\x0a"
"/* ISO9899\x3a""2011 7.20 (C11 Annex K)\x3a Define rsize_t if __STDC_WANT_LIB_EXT1__ is\x0a"
" * enabled. */\x0a"
"#if (defined(__STDC_WANT_LIB_EXT1__) \x26\x26 __STDC_WANT_LIB_EXT1__ >= 1 \x26\x26 \x5c\x0a"
"     \x21""defined(_RSIZE_T)) \x7c\x7c __has_feature(modules)\x0a"
"/* Always define rsize_t when modules are available. */\x0a"
"#if \x21__has_feature(modules)\x0a"
"#define _RSIZE_T\x0a"
"#endif\x0a"
"typedef __SIZE_TYPE__ rsize_t;\x0a"
"#endif\x0a"
"#endif /* defined(__need_STDDEF_H_misc) */\x0a"
"\x0a"
"#if defined(__need_wchar_t)\x0a"
"#ifndef __cplusplus\x0a"
"/* Always define wchar_t when modules are available. */\x0a"
"#if \x21""defined(_WCHAR_T) \x7c\x7c __has_feature(modules)\x0a"
"#if \x21__has_feature(modules)\x0a"
"#define _WCHAR_T\x0a"
"#if defined(_MSC_EXTENSIONS)\x0a"
"#define _WCHAR_T_DEFINED\x0a"
"#endif\x0a"
"#endif\x0a"
"typedef __WCHAR_TYPE__ wchar_t;\x0a"
"#endif\x0a"
"#endif\x0a"
"#undef __need_wchar_t\x0a"
"#endif /* defined(__need_wchar_t) */\x0a"
"\x0a"
"#if defined(__need_NULL)\x0a"
"#undef NULL\x0a"
"#ifdef __cplusplus\x0a"
"#  if \x21""defined(__MINGW32__) \x26\x26 \x21""defined(_MSC_VER)\x0a"
"#    define NULL __null\x0a"
"#  else\x0a"
"#    define NULL 0\x0a"
"#  endif\x0a"
"#else\x0a"
"#  define NULL ((void*)0)\x0a"
"#endif\x0a"
"#ifdef __cplusplus\x0a"
"#if defined(_MSC_EXTENSIONS) \x26\x26 defined(_NATIVE_NULLPTR_SUPPORTED)\x0a"
"namespace std { typedef decltype(nullptr) nullptr_t; }\x0a"
"using \x3a\x3astd\x3a\x3anullptr_t;\x0a"
"#endif\x0a"
"#endif\x0a"
"#undef __need_NULL\x0a"
"#endif /* defined(__need_NULL) */\x0a"
"\x0a"
"#if defined(__need_STDDEF_H_misc)\x0a"
"#if __STDC_VERSION__ >= 201112L \x7c\x7c __cplusplus >= 201103L\x0a"
"/*#include \x22__stddef_max_align_t.h\x22*/\x0a"
"\x0a"
"#ifndef __CLANG_MAX_ALIGN_T_DEFINED\x0a"
"#define __CLANG_MAX_ALIGN_T_DEFINED\x0a"
"\x0a"
"#if defined(_MSC_VER)\x0a"
"typedef double max_align_t;\x0a"
"#elif defined(__APPLE__)\x0a"
"typedef long double max_align_t;\x0a"
"#else\x0a"
"// Define 'max_align_t' to match the GCC definition.\x0a"
"typedef struct {\x0a"
"  long long __clang_max_align_nonce1\x0a"
"      __attribute__((__aligned__(__alignof__(long long))));\x0a"
"  long double __clang_max_align_nonce2\x0a"
"      __attribute__((__aligned__(__alignof__(long double))));\x0a"
"} max_align_t;\x0a"
"#endif\x0a"
"\x0a"
"#endif\x0a"
"/************************/\x0a"
"\x0a"
"\x0a"
"#endif\x0a"
"#define offsetof(t, d) __builtin_offsetof(t, d)\x0a"
"#undef __need_STDDEF_H_misc\x0a"
"#endif  /* defined(__need_STDDEF_H_misc) */\x0a"
"\x0a"
"/* Some C libraries expect to see a wint_t here. Others (notably MinGW) will use\x0a"
"__WINT_TYPE__ directly; accommodate both by requiring __need_wint_t */\x0a"
"#if defined(__need_wint_t)\x0a"
"/* Always define wint_t when modules are available. */\x0a"
"#if \x21""defined(_WINT_T) \x7c\x7c __has_feature(modules)\x0a"
"#if \x21__has_feature(modules)\x0a"
"#define _WINT_T\x0a"
"#endif\x0a"
"typedef __WINT_TYPE__ wint_t;\x0a"
"#endif\x0a"
"#undef __need_wint_t\x0a"
"#endif /* __need_wint_t */\x0a"
"\x0a"
"#endif\x0a"
"", 5017 ); }