#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_algorithm( 
"// -*- C++ -*-\x0a"
"//===-------------------------- algorithm ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_ALGORITHM\x0a"
"#define _LIBCPP_ALGORITHM\x0a"
"\x0a"
"/*\x0a"
"    algorithm synopsis\x0a"
"\x0a"
"#include <initializer_list>\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class InputIterator, class Predicate>\x0a"
"    constexpr bool     // constexpr in C++20\x0a"
"    all_of(InputIterator first, InputIterator last, Predicate pred);\x0a"
"\x0a"
"template <class InputIterator, class Predicate>\x0a"
"    constexpr bool     // constexpr in C++20\x0a"
"    any_of(InputIterator first, InputIterator last, Predicate pred);\x0a"
"\x0a"
"template <class InputIterator, class Predicate>\x0a"
"    constexpr bool     // constexpr in C++20\x0a"
"    none_of(InputIterator first, InputIterator last, Predicate pred);\x0a"
"\x0a"
"template <class InputIterator, class Function>\x0a"
"    constexpr Function          // constexpr in C++20\x0a"
"    for_each(InputIterator first, InputIterator last, Function f);\x0a"
"\x0a"
"template<class InputIterator, class Size, class Function>\x0a"
"    constexpr InputIterator     // constexpr in C++20\x0a"
"    for_each_n(InputIterator first, Size n, Function f); // C++17\x0a"
"\x0a"
"template <class InputIterator, class T>\x0a"
"    constexpr InputIterator     // constexpr in C++20\x0a"
"    find(InputIterator first, InputIterator last, const T\x26 value);\x0a"
"\x0a"
"template <class InputIterator, class Predicate>\x0a"
"    constexpr InputIterator     // constexpr in C++20\x0a"
"    find_if(InputIterator first, InputIterator last, Predicate pred);\x0a"
"\x0a"
"template<class InputIterator, class Predicate>\x0a"
"    InputIterator               // constexpr in C++20\x0a"
"    find_if_not(InputIterator first, InputIterator last, Predicate pred);\x0a"
"\x0a"
"template <class ForwardIterator1, class ForwardIterator2>\x0a"
"    ForwardIterator1            // constexpr in C++20\x0a"
"    find_end(ForwardIterator1 first1, ForwardIterator1 last1,\x0a"
"             ForwardIterator2 first2, ForwardIterator2 last2);\x0a"
"\x0a"
"template <class ForwardIterator1, class ForwardIterator2, class BinaryPredicate>\x0a"
"    ForwardIterator1            // constexpr in C++20\x0a"
"    find_end(ForwardIterator1 first1, ForwardIterator1 last1,\x0a"
"             ForwardIterator2 first2, ForwardIterator2 last2, BinaryPredicate pred);\x0a"
"\x0a"
"template <class ForwardIterator1, class ForwardIterator2>\x0a"
"    constexpr ForwardIterator1  // constexpr in C++20\x0a"
"    find_first_of(ForwardIterator1 first1, ForwardIterator1 last1,\x0a"
"                  ForwardIterator2 first2, ForwardIterator2 last2);\x0a"
"\x0a"
"template <class ForwardIterator1, class ForwardIterator2, class BinaryPredicate>\x0a"
"    constexpr ForwardIterator1  // constexpr in C++20\x0a"
"    find_first_of(ForwardIterator1 first1, ForwardIterator1 last1,\x0a"
"                  ForwardIterator2 first2, ForwardIterator2 last2, BinaryPredicate pred);\x0a"
"\x0a"
"template <class ForwardIterator>\x0a"
"    constexpr ForwardIterator   // constexpr in C++20\x0a"
"    adjacent_find(ForwardIterator first, ForwardIterator last);\x0a"
"\x0a"
"template <class ForwardIterator, class BinaryPredicate>\x0a"
"    constexpr ForwardIterator   // constexpr in C++20\x0a"
"    adjacent_find(ForwardIterator first, ForwardIterator last, BinaryPredicate pred);\x0a"
"\x0a"
"template <class InputIterator, class T>\x0a"
"    constexpr typename iterator_traits<InputIterator>\x3a\x3a""difference_type  // constexpr in C++20\x0a"
"    count(InputIterator first, InputIterator last, const T\x26 value);\x0a"
"\x0a"
"template <class InputIterator, class Predicate>\x0a"
"    constexpr typename iterator_traits<InputIterator>\x3a\x3a""difference_type // constexpr in C++20\x0a"
"    count_if(InputIterator first, InputIterator last, Predicate pred);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2>\x0a"
"    constexpr pair<InputIterator1, InputIterator2>   // constexpr in C++20\x0a"
"    mismatch(InputIterator1 first1, InputIterator1 last1, InputIterator2 first2);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2>\x0a"
"    constexpr pair<InputIterator1, InputIterator2>   // constexpr in C++20\x0a"
"    mismatch(InputIterator1 first1, InputIterator1 last1,\x0a"
"             InputIterator2 first2, InputIterator2 last2); // **C++14**\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class BinaryPredicate>\x0a"
"    constexpr pair<InputIterator1, InputIterator2>   // constexpr in C++20\x0a"
"    mismatch(InputIterator1 first1, InputIterator1 last1,\x0a"
"             InputIterator2 first2, BinaryPredicate pred);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class BinaryPredicate>\x0a"
"    constexpr pair<InputIterator1, InputIterator2>   // constexpr in C++20\x0a"
"    mismatch(InputIterator1 first1, InputIterator1 last1,\x0a"
"             InputIterator2 first2, InputIterator2 last2,\x0a"
"             BinaryPredicate pred); // **C++14**\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2>\x0a"
"    constexpr bool      // constexpr in C++20\x0a"
"    equal(InputIterator1 first1, InputIterator1 last1, InputIterator2 first2);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2>\x0a"
"    constexpr bool      // constexpr in C++20\x0a"
"    equal(InputIterator1 first1, InputIterator1 last1,\x0a"
"          InputIterator2 first2, InputIterator2 last2); // **C++14**\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class BinaryPredicate>\x0a"
"    constexpr bool      // constexpr in C++20\x0a"
"    equal(InputIterator1 first1, InputIterator1 last1,\x0a"
"          InputIterator2 first2, BinaryPredicate pred);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class BinaryPredicate>\x0a"
"    constexpr bool      // constexpr in C++20\x0a"
"    equal(InputIterator1 first1, InputIterator1 last1,\x0a"
"          InputIterator2 first2, InputIterator2 last2,\x0a"
"          BinaryPredicate pred); // **C++14**\x0a"
"\x0a"
"template<class ForwardIterator1, class ForwardIterator2>\x0a"
"    constexpr bool      // constexpr in C++20\x0a"
"    is_permutation(ForwardIterator1 first1, ForwardIterator1 last1,\x0a"
"                   ForwardIterator2 first2);\x0a"
"\x0a"
"template<class ForwardIterator1, class ForwardIterator2>\x0a"
"    constexpr bool      // constexpr in C++20\x0a"
"    is_permutation(ForwardIterator1 first1, ForwardIterator1 last1,\x0a"
"                   ForwardIterator2 first2, ForwardIterator2 last2); // **C++14**\x0a"
"\x0a"
"template<class ForwardIterator1, class ForwardIterator2, class BinaryPredicate>\x0a"
"    constexpr bool      // constexpr in C++20\x0a"
"    is_permutation(ForwardIterator1 first1, ForwardIterator1 last1,\x0a"
"                   ForwardIterator2 first2, BinaryPredicate pred);\x0a"
"\x0a"
"template<class ForwardIterator1, class ForwardIterator2, class BinaryPredicate>\x0a"
"    constexpr bool      // constexpr in C++20\x0a"
"    is_permutation(ForwardIterator1 first1, ForwardIterator1 last1,\x0a"
"                   ForwardIterator2 first2, ForwardIterator2 last2,\x0a"
"                   BinaryPredicate pred);  // **C++14**\x0a"
"\x0a"
"template <class ForwardIterator1, class ForwardIterator2>\x0a"
"    constexpr ForwardIterator1      // constexpr in C++20\x0a"
"    search(ForwardIterator1 first1, ForwardIterator1 last1,\x0a"
"           ForwardIterator2 first2, ForwardIterator2 last2);\x0a"
"\x0a"
"template <class ForwardIterator1, class ForwardIterator2, class BinaryPredicate>\x0a"
"    constexpr ForwardIterator1      // constexpr in C++20\x0a"
"    search(ForwardIterator1 first1, ForwardIterator1 last1,\x0a"
"           ForwardIterator2 first2, ForwardIterator2 last2, BinaryPredicate pred);\x0a"
"\x0a"
"template <class ForwardIterator, class Size, class T>\x0a"
"    constexpr ForwardIterator       // constexpr in C++20\x0a"
"    search_n(ForwardIterator first, ForwardIterator last, Size count, const T\x26 value);\x0a"
"\x0a"
"template <class ForwardIterator, class Size, class T, class BinaryPredicate>\x0a"
"    constexpr ForwardIterator       // constexpr in C++20\x0a"
"    search_n(ForwardIterator first, ForwardIterator last,\x0a"
"             Size count, const T\x26 value, BinaryPredicate pred);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    copy(InputIterator first, InputIterator last, OutputIterator result);\x0a"
"\x0a"
"template<class InputIterator, class OutputIterator, class Predicate>\x0a"
"    OutputIterator\x0a"
"    copy_if(InputIterator first, InputIterator last,\x0a"
"            OutputIterator result, Predicate pred);\x0a"
"\x0a"
"template<class InputIterator, class Size, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    copy_n(InputIterator first, Size n, OutputIterator result);\x0a"
"\x0a"
"template <class BidirectionalIterator1, class BidirectionalIterator2>\x0a"
"    BidirectionalIterator2\x0a"
"    copy_backward(BidirectionalIterator1 first, BidirectionalIterator1 last,\x0a"
"                  BidirectionalIterator2 result);\x0a"
"\x0a"
"template <class ForwardIterator1, class ForwardIterator2>\x0a"
"    ForwardIterator2\x0a"
"    swap_ranges(ForwardIterator1 first1, ForwardIterator1 last1, ForwardIterator2 first2);\x0a"
"\x0a"
"template <class ForwardIterator1, class ForwardIterator2>\x0a"
"    void\x0a"
"    iter_swap(ForwardIterator1 a, ForwardIterator2 b);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator, class UnaryOperation>\x0a"
"    constexpr OutputIterator      // constexpr in C++20\x0a"
"    transform(InputIterator first, InputIterator last, OutputIterator result, UnaryOperation op);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator, class BinaryOperation>\x0a"
"    constexpr OutputIterator      // constexpr in C++20\x0a"
"    transform(InputIterator1 first1, InputIterator1 last1, InputIterator2 first2,\x0a"
"              OutputIterator result, BinaryOperation binary_op);\x0a"
"\x0a"
"template <class ForwardIterator, class T>\x0a"
"    constexpr void      // constexpr in C++20\x0a"
"    replace(ForwardIterator first, ForwardIterator last, const T\x26 old_value, const T\x26 new_value);\x0a"
"\x0a"
"template <class ForwardIterator, class Predicate, class T>\x0a"
"    constexpr void      // constexpr in C++20\x0a"
"    replace_if(ForwardIterator first, ForwardIterator last, Predicate pred, const T\x26 new_value);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator, class T>\x0a"
"    constexpr OutputIterator      // constexpr in C++20\x0a"
"    replace_copy(InputIterator first, InputIterator last, OutputIterator result,\x0a"
"                 const T\x26 old_value, const T\x26 new_value);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator, class Predicate, class T>\x0a"
"    constexpr OutputIterator      // constexpr in C++20\x0a"
"    replace_copy_if(InputIterator first, InputIterator last, OutputIterator result, Predicate pred, const T\x26 new_value);\x0a"
"\x0a"
"template <class ForwardIterator, class T>\x0a"
"    constexpr void      // constexpr in C++20\x0a"
"    fill(ForwardIterator first, ForwardIterator last, const T\x26 value);\x0a"
"\x0a"
"template <class OutputIterator, class Size, class T>\x0a"
"    constexpr OutputIterator      // constexpr in C++20\x0a"
"    fill_n(OutputIterator first, Size n, const T\x26 value);\x0a"
"\x0a"
"template <class ForwardIterator, class Generator>\x0a"
"    constexpr void      // constexpr in C++20\x0a"
"    generate(ForwardIterator first, ForwardIterator last, Generator gen);\x0a"
"\x0a"
"template <class OutputIterator, class Size, class Generator>\x0a"
"    constexpr OutputIterator      // constexpr in C++20\x0a"
"    generate_n(OutputIterator first, Size n, Generator gen);\x0a"
"\x0a"
"template <class ForwardIterator, class T>\x0a"
"    constexpr ForwardIterator     // constexpr in C++20\x0a"
"    remove(ForwardIterator first, ForwardIterator last, const T\x26 value);\x0a"
"\x0a"
"template <class ForwardIterator, class Predicate>\x0a"
"    constexpr ForwardIterator     // constexpr in C++20\x0a"
"    remove_if(ForwardIterator first, ForwardIterator last, Predicate pred);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator, class T>\x0a"
"    constexpr OutputIterator     // constexpr in C++20\x0a"
"    remove_copy(InputIterator first, InputIterator last, OutputIterator result, const T\x26 value);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator, class Predicate>\x0a"
"    constexpr OutputIterator     // constexpr in C++20\x0a"
"    remove_copy_if(InputIterator first, InputIterator last, OutputIterator result, Predicate pred);\x0a"
"\x0a"
"template <class ForwardIterator>\x0a"
"    ForwardIterator\x0a"
"    unique(ForwardIterator first, ForwardIterator last);\x0a"
"\x0a"
"template <class ForwardIterator, class BinaryPredicate>\x0a"
"    ForwardIterator\x0a"
"    unique(ForwardIterator first, ForwardIterator last, BinaryPredicate pred);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    unique_copy(InputIterator first, InputIterator last, OutputIterator result);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator, class BinaryPredicate>\x0a"
"    OutputIterator\x0a"
"    unique_copy(InputIterator first, InputIterator last, OutputIterator result, BinaryPredicate pred);\x0a"
"\x0a"
"template <class BidirectionalIterator>\x0a"
"    void\x0a"
"    reverse(BidirectionalIterator first, BidirectionalIterator last);\x0a"
"\x0a"
"template <class BidirectionalIterator, class OutputIterator>\x0a"
"    constexpr OutputIterator       // constexpr in C++20\x0a"
"    reverse_copy(BidirectionalIterator first, BidirectionalIterator last, OutputIterator result);\x0a"
"\x0a"
"template <class ForwardIterator>\x0a"
"    ForwardIterator\x0a"
"    rotate(ForwardIterator first, ForwardIterator middle, ForwardIterator last);\x0a"
"\x0a"
"template <class ForwardIterator, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    rotate_copy(ForwardIterator first, ForwardIterator middle, ForwardIterator last, OutputIterator result);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    void\x0a"
"    random_shuffle(RandomAccessIterator first, RandomAccessIterator last); // deprecated in C++14, removed in C++17\x0a"
"\x0a"
"template <class RandomAccessIterator, class RandomNumberGenerator>\x0a"
"    void\x0a"
"    random_shuffle(RandomAccessIterator first, RandomAccessIterator last,\x0a"
"                   RandomNumberGenerator\x26 rand);  // deprecated in C++14, removed in C++17\x0a"
"\x0a"
"template<class PopulationIterator, class SampleIterator,\x0a"
"         class Distance, class UniformRandomBitGenerator>\x0a"
"    SampleIterator sample(PopulationIterator first, PopulationIterator last,\x0a"
"                          SampleIterator out, Distance n,\x0a"
"                          UniformRandomBitGenerator\x26\x26 g); // C++17\x0a"
"\x0a"
"template<class RandomAccessIterator, class UniformRandomNumberGenerator>\x0a"
"    void shuffle(RandomAccessIterator first, RandomAccessIterator last,\x0a"
"                 UniformRandomNumberGenerator\x26\x26 g);\x0a"
"\x0a"
"template <class InputIterator, class Predicate>\x0a"
"    constexpr bool  // constexpr in C++20\x0a"
"    is_partitioned(InputIterator first, InputIterator last, Predicate pred);\x0a"
"\x0a"
"template <class ForwardIterator, class Predicate>\x0a"
"    ForwardIterator\x0a"
"    partition(ForwardIterator first, ForwardIterator last, Predicate pred);\x0a"
"\x0a"
"template <class InputIterator, class OutputIterator1,\x0a"
"          class OutputIterator2, class Predicate>\x0a"
"    constexpr pair<OutputIterator1, OutputIterator2>   // constexpr in C++20\x0a"
"    partition_copy(InputIterator first, InputIterator last,\x0a"
"                   OutputIterator1 out_true, OutputIterator2 out_false,\x0a"
"                   Predicate pred);\x0a"
"\x0a"
"template <class ForwardIterator, class Predicate>\x0a"
"    ForwardIterator\x0a"
"    stable_partition(ForwardIterator first, ForwardIterator last, Predicate pred);\x0a"
"\x0a"
"template<class ForwardIterator, class Predicate>\x0a"
"    constexpr ForwardIterator  // constexpr in C++20\x0a"
"    partition_point(ForwardIterator first, ForwardIterator last, Predicate pred);\x0a"
"\x0a"
"template <class ForwardIterator>\x0a"
"    constexpr bool  // constexpr in C++20\x0a"
"    is_sorted(ForwardIterator first, ForwardIterator last);\x0a"
"\x0a"
"template <class ForwardIterator, class Compare>\x0a"
"    bool\x0a"
"    is_sorted(ForwardIterator first, ForwardIterator last, Compare comp);\x0a"
"\x0a"
"template<class ForwardIterator>\x0a"
"    constexpr ForwardIterator    // constexpr in C++20\x0a"
"    is_sorted_until(ForwardIterator first, ForwardIterator last);\x0a"
"\x0a"
"template <class ForwardIterator, class Compare>\x0a"
"    constexpr ForwardIterator    // constexpr in C++20\x0a"
"    is_sorted_until(ForwardIterator first, ForwardIterator last, Compare comp);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    void\x0a"
"    sort(RandomAccessIterator first, RandomAccessIterator last);\x0a"
"\x0a"
"template <class RandomAccessIterator, class Compare>\x0a"
"    void\x0a"
"    sort(RandomAccessIterator first, RandomAccessIterator last, Compare comp);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    void\x0a"
"    stable_sort(RandomAccessIterator first, RandomAccessIterator last);\x0a"
"\x0a"
"template <class RandomAccessIterator, class Compare>\x0a"
"    void\x0a"
"    stable_sort(RandomAccessIterator first, RandomAccessIterator last, Compare comp);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    void\x0a"
"    partial_sort(RandomAccessIterator first, RandomAccessIterator middle, RandomAccessIterator last);\x0a"
"\x0a"
"template <class RandomAccessIterator, class Compare>\x0a"
"    void\x0a"
"    partial_sort(RandomAccessIterator first, RandomAccessIterator middle, RandomAccessIterator last, Compare comp);\x0a"
"\x0a"
"template <class InputIterator, class RandomAccessIterator>\x0a"
"    RandomAccessIterator\x0a"
"    partial_sort_copy(InputIterator first, InputIterator last,\x0a"
"                      RandomAccessIterator result_first, RandomAccessIterator result_last);\x0a"
"\x0a"
"template <class InputIterator, class RandomAccessIterator, class Compare>\x0a"
"    RandomAccessIterator\x0a"
"    partial_sort_copy(InputIterator first, InputIterator last,\x0a"
"                      RandomAccessIterator result_first, RandomAccessIterator result_last, Compare comp);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    void\x0a"
"    nth_element(RandomAccessIterator first, RandomAccessIterator nth, RandomAccessIterator last);\x0a"
"\x0a"
"template <class RandomAccessIterator, class Compare>\x0a"
"    void\x0a"
"    nth_element(RandomAccessIterator first, RandomAccessIterator nth, RandomAccessIterator last, Compare comp);\x0a"
"\x0a"
"template <class ForwardIterator, class T>\x0a"
"    constexpr ForwardIterator                         // constexpr in C++20\x0a"
"    lower_bound(ForwardIterator first, ForwardIterator last, const T\x26 value);\x0a"
"\x0a"
"template <class ForwardIterator, class T, class Compare>\x0a"
"    constexpr ForwardIterator                         // constexpr in C++20\x0a"
"    lower_bound(ForwardIterator first, ForwardIterator last, const T\x26 value, Compare comp);\x0a"
"\x0a"
"template <class ForwardIterator, class T>\x0a"
"    constexpr ForwardIterator                         // constexpr in C++20\x0a"
"    upper_bound(ForwardIterator first, ForwardIterator last, const T\x26 value);\x0a"
"\x0a"
"template <class ForwardIterator, class T, class Compare>\x0a"
"    constexpr ForwardIterator                         // constexpr in C++20\x0a"
"    upper_bound(ForwardIterator first, ForwardIterator last, const T\x26 value, Compare comp);\x0a"
"\x0a"
"template <class ForwardIterator, class T>\x0a"
"    constexpr pair<ForwardIterator, ForwardIterator>  // constexpr in C++20\x0a"
"    equal_range(ForwardIterator first, ForwardIterator last, const T\x26 value);\x0a"
"\x0a"
"template <class ForwardIterator, class T, class Compare>\x0a"
"    constexpr pair<ForwardIterator, ForwardIterator>  // constexpr in C++20\x0a"
"    equal_range(ForwardIterator first, ForwardIterator last, const T\x26 value, Compare comp);\x0a"
"\x0a"
"template <class ForwardIterator, class T>\x0a"
"    constexpr bool                                    // constexpr in C++20\x0a"
"    binary_search(ForwardIterator first, ForwardIterator last, const T\x26 value);\x0a"
"\x0a"
"template <class ForwardIterator, class T, class Compare>\x0a"
"    constexpr bool                                    // constexpr in C++20\x0a"
"    binary_search(ForwardIterator first, ForwardIterator last, const T\x26 value, Compare comp);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    merge(InputIterator1 first1, InputIterator1 last1,\x0a"
"          InputIterator2 first2, InputIterator2 last2, OutputIterator result);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator, class Compare>\x0a"
"    OutputIterator\x0a"
"    merge(InputIterator1 first1, InputIterator1 last1,\x0a"
"          InputIterator2 first2, InputIterator2 last2, OutputIterator result, Compare comp);\x0a"
"\x0a"
"template <class BidirectionalIterator>\x0a"
"    void\x0a"
"    inplace_merge(BidirectionalIterator first, BidirectionalIterator middle, BidirectionalIterator last);\x0a"
"\x0a"
"template <class BidirectionalIterator, class Compare>\x0a"
"    void\x0a"
"    inplace_merge(BidirectionalIterator first, BidirectionalIterator middle, BidirectionalIterator last, Compare comp);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2>\x0a"
"    constexpr bool                                    // constexpr in C++20\x0a"
"    includes(InputIterator1 first1, InputIterator1 last1, InputIterator2 first2, InputIterator2 last2);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class Compare>\x0a"
"    constexpr bool                                    // constexpr in C++20\x0a"
"    includes(InputIterator1 first1, InputIterator1 last1, InputIterator2 first2, InputIterator2 last2, Compare comp);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    set_union(InputIterator1 first1, InputIterator1 last1,\x0a"
"              InputIterator2 first2, InputIterator2 last2, OutputIterator result);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator, class Compare>\x0a"
"    OutputIterator\x0a"
"    set_union(InputIterator1 first1, InputIterator1 last1,\x0a"
"              InputIterator2 first2, InputIterator2 last2, OutputIterator result, Compare comp);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator>\x0a"
"    constexpr OutputIterator                         // constexpr in C++20\x0a"
"    set_intersection(InputIterator1 first1, InputIterator1 last1,\x0a"
"                     InputIterator2 first2, InputIterator2 last2, OutputIterator result);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator, class Compare>\x0a"
"    constexpr OutputIterator                         // constexpr in C++20\x0a"
"    set_intersection(InputIterator1 first1, InputIterator1 last1,\x0a"
"                     InputIterator2 first2, InputIterator2 last2, OutputIterator result, Compare comp);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    set_difference(InputIterator1 first1, InputIterator1 last1,\x0a"
"                   InputIterator2 first2, InputIterator2 last2, OutputIterator result);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator, class Compare>\x0a"
"    OutputIterator\x0a"
"    set_difference(InputIterator1 first1, InputIterator1 last1,\x0a"
"                   InputIterator2 first2, InputIterator2 last2, OutputIterator result, Compare comp);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator>\x0a"
"    OutputIterator\x0a"
"    set_symmetric_difference(InputIterator1 first1, InputIterator1 last1,\x0a"
"                             InputIterator2 first2, InputIterator2 last2, OutputIterator result);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class OutputIterator, class Compare>\x0a"
"    OutputIterator\x0a"
"    set_symmetric_difference(InputIterator1 first1, InputIterator1 last1,\x0a"
"                             InputIterator2 first2, InputIterator2 last2, OutputIterator result, Compare comp);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    void\x0a"
"    push_heap(RandomAccessIterator first, RandomAccessIterator last);\x0a"
"\x0a"
"template <class RandomAccessIterator, class Compare>\x0a"
"    void\x0a"
"    push_heap(RandomAccessIterator first, RandomAccessIterator last, Compare comp);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    void\x0a"
"    pop_heap(RandomAccessIterator first, RandomAccessIterator last);\x0a"
"\x0a"
"template <class RandomAccessIterator, class Compare>\x0a"
"    void\x0a"
"    pop_heap(RandomAccessIterator first, RandomAccessIterator last, Compare comp);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    void\x0a"
"    make_heap(RandomAccessIterator first, RandomAccessIterator last);\x0a"
"\x0a"
"template <class RandomAccessIterator, class Compare>\x0a"
"    void\x0a"
"    make_heap(RandomAccessIterator first, RandomAccessIterator last, Compare comp);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    void\x0a"
"    sort_heap(RandomAccessIterator first, RandomAccessIterator last);\x0a"
"\x0a"
"template <class RandomAccessIterator, class Compare>\x0a"
"    void\x0a"
"    sort_heap(RandomAccessIterator first, RandomAccessIterator last, Compare comp);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    constexpr bool   // constexpr in C++20\x0a"
"    is_heap(RandomAccessIterator first, RandomAccessiterator last);\x0a"
"\x0a"
"template <class RandomAccessIterator, class Compare>\x0a"
"    constexpr bool   // constexpr in C++20\x0a"
"    is_heap(RandomAccessIterator first, RandomAccessiterator last, Compare comp);\x0a"
"\x0a"
"template <class RandomAccessIterator>\x0a"
"    constexpr RandomAccessIterator   // constexpr in C++20\x0a"
"    is_heap_until(RandomAccessIterator first, RandomAccessiterator last);\x0a"
"\x0a"
"template <class RandomAccessIterator, class Compare>\x0a"
"    constexpr RandomAccessIterator   // constexpr in C++20\x0a"
"    is_heap_until(RandomAccessIterator first, RandomAccessiterator last, Compare comp);\x0a"
"\x0a"
"template <class ForwardIterator>\x0a"
"    ForwardIterator\x0a"
"    min_element(ForwardIterator first, ForwardIterator last);  // constexpr in C++14\x0a"
"\x0a"
"template <class ForwardIterator, class Compare>\x0a"
"    ForwardIterator\x0a"
"    min_element(ForwardIterator first, ForwardIterator last, Compare comp);  // constexpr in C++14\x0a"
"\x0a"
"template <class T>\x0a"
"    const T\x26\x0a"
"    min(const T\x26 a, const T\x26 b);  // constexpr in C++14\x0a"
"\x0a"
"template <class T, class Compare>\x0a"
"    const T\x26\x0a"
"    min(const T\x26 a, const T\x26 b, Compare comp);  // constexpr in C++14\x0a"
"\x0a"
"template<class T>\x0a"
"    T\x0a"
"    min(initializer_list<T> t);  // constexpr in C++14\x0a"
"\x0a"
"template<class T, class Compare>\x0a"
"    T\x0a"
"    min(initializer_list<T> t, Compare comp);  // constexpr in C++14\x0a"
"\x0a"
"template<class T>\x0a"
"    constexpr const T\x26 clamp( const T\x26 v, const T\x26 lo, const T\x26 hi );               // C++17\x0a"
"\x0a"
"template<class T, class Compare>\x0a"
"    constexpr const T\x26 clamp( const T\x26 v, const T\x26 lo, const T\x26 hi, Compare comp ); // C++17\x0a"
"\x0a"
"template <class ForwardIterator>\x0a"
"    ForwardIterator\x0a"
"    max_element(ForwardIterator first, ForwardIterator last);  // constexpr in C++14\x0a"
"\x0a"
"template <class ForwardIterator, class Compare>\x0a"
"    ForwardIterator\x0a"
"    max_element(ForwardIterator first, ForwardIterator last, Compare comp);  // constexpr in C++14\x0a"
"\x0a"
"template <class T>\x0a"
"    const T\x26\x0a"
"    max(const T\x26 a, const T\x26 b); // constexpr in C++14\x0a"
"\x0a"
"template <class T, class Compare>\x0a"
"    const T\x26\x0a"
"    max(const T\x26 a, const T\x26 b, Compare comp);  // constexpr in C++14\x0a"
"\x0a"
"template<class T>\x0a"
"    T\x0a"
"    max(initializer_list<T> t);  // constexpr in C++14\x0a"
"\x0a"
"template<class T, class Compare>\x0a"
"    T\x0a"
"    max(initializer_list<T> t, Compare comp);  // constexpr in C++14\x0a"
"\x0a"
"template<class ForwardIterator>\x0a"
"    pair<ForwardIterator, ForwardIterator>\x0a"
"    minmax_element(ForwardIterator first, ForwardIterator last);   // constexpr in C++14\x0a"
"\x0a"
"template<class ForwardIterator, class Compare>\x0a"
"    pair<ForwardIterator, ForwardIterator>\x0a"
"    minmax_element(ForwardIterator first, ForwardIterator last, Compare comp);   // constexpr in C++14\x0a"
"\x0a"
"template<class T>\x0a"
"    pair<const T\x26, const T\x26>\x0a"
"    minmax(const T\x26 a, const T\x26 b);  // constexpr in C++14\x0a"
"\x0a"
"template<class T, class Compare>\x0a"
"    pair<const T\x26, const T\x26>\x0a"
"    minmax(const T\x26 a, const T\x26 b, Compare comp);  // constexpr in C++14\x0a"
"\x0a"
"template<class T>\x0a"
"    pair<T, T>\x0a"
"    minmax(initializer_list<T> t);  // constexpr in C++14\x0a"
"\x0a"
"template<class T, class Compare>\x0a"
"    pair<T, T>\x0a"
"    minmax(initializer_list<T> t, Compare comp);  // constexpr in C++14\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2>\x0a"
"    constexpr bool     // constexpr in C++20\x0a"
"    lexicographical_compare(InputIterator1 first1, InputIterator1 last1, InputIterator2 first2, InputIterator2 last2);\x0a"
"\x0a"
"template <class InputIterator1, class InputIterator2, class Compare>\x0a"
"    constexpr bool     // constexpr in C++20\x0a"
"    lexicographical_compare(InputIterator1 first1, InputIterator1 last1,\x0a"
"                            InputIterator2 first2, InputIterator2 last2, Compare comp);\x0a"
"\x0a"
"template <class BidirectionalIterator>\x0a"
"    bool\x0a"
"    next_permutation(BidirectionalIterator first, BidirectionalIterator last);\x0a"
"\x0a"
"template <class BidirectionalIterator, class Compare>\x0a"
"    bool\x0a"
"    next_permutation(BidirectionalIterator first, BidirectionalIterator last, Compare comp);\x0a"
"\x0a"
"template <class BidirectionalIterator>\x0a"
"    bool\x0a"
"    prev_permutation(BidirectionalIterator first, BidirectionalIterator last);\x0a"
"\x0a"
"template <class BidirectionalIterator, class Compare>\x0a"
"    bool\x0a"
"    prev_permutation(BidirectionalIterator first, BidirectionalIterator last, Compare comp);\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <initializer_list>\x0a"
"#include <type_traits>\x0a"
"#include <cstring>\x0a"
"#include <utility> // needed to provide swap_ranges.\x0a"
"#include <memory>\x0a"
"#include <functional>\x0a"
"#include <iterator>\x0a"
"#include <cstddef>\x0a"
"#include <bit>\x0a"
"#include <version>\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// I'd like to replace these with _VSTD\x3a\x3a""equal_to<void>, but can't because\x3a\x0a"
"//   * That only works with C++14 and later, and\x0a"
"//   * We haven't included <functional> here.\x0a"
"template <class _T1, class _T2 = _T1>\x0a"
"struct __equal_to\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 bool operator()(const _T1\x26 __x, const _T1\x26 __y) const {return __x == __y;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 bool operator()(const _T1\x26 __x, const _T2\x26 __y) const {return __x == __y;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 bool operator()(const _T2\x26 __x, const _T1\x26 __y) const {return __x == __y;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11 bool operator()(const _T2\x26 __x, const _T2\x26 __y) const {return __x == __y;}\x0a"
"};\x0a"
"\x0a"
"template <class _T1>\x0a"
"struct __equal_to<_T1, _T1>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _T1\x26 __x, const _T1\x26 __y) const {return __x == __y;}\x0a"
"};\x0a"
"\x0a"
"template <class _T1>\x0a"
"struct __equal_to<const _T1, _T1>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _T1\x26 __x, const _T1\x26 __y) const {return __x == __y;}\x0a"
"};\x0a"
"\x0a"
"template <class _T1>\x0a"
"struct __equal_to<_T1, const _T1>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _T1\x26 __x, const _T1\x26 __y) const {return __x == __y;}\x0a"
"};\x0a"
"\x0a"
"template <class _T1, class _T2 = _T1>\x0a"
"struct __less\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _T1\x26 __x, const _T1\x26 __y) const {return __x < __y;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _T1\x26 __x, const _T2\x26 __y) const {return __x < __y;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _T2\x26 __x, const _T1\x26 __y) const {return __x < __y;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _T2\x26 __x, const _T2\x26 __y) const {return __x < __y;}\x0a"
"};\x0a"
"\x0a"
"template <class _T1>\x0a"
"struct __less<_T1, _T1>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _T1\x26 __x, const _T1\x26 __y) const {return __x < __y;}\x0a"
"};\x0a"
"\x0a"
"template <class _T1>\x0a"
"struct __less<const _T1, _T1>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _T1\x26 __x, const _T1\x26 __y) const {return __x < __y;}\x0a"
"};\x0a"
"\x0a"
"template <class _T1>\x0a"
"struct __less<_T1, const _T1>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"    bool operator()(const _T1\x26 __x, const _T1\x26 __y) const {return __x < __y;}\x0a"
"};\x0a"
"\x0a"
"template <class _Predicate>\x0a"
"class __invert // invert the sense of a comparison\x0a"
"{\x0a"
"private\x3a\x0a"
"    _Predicate __p_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY __invert() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __invert(_Predicate __p) \x3a __p_(__p) {}\x0a"
"\x0a"
"    template <class _T1>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _T1\x26 __x) {return \x21__p_(__x);}\x0a"
"\x0a"
"    template <class _T1, class _T2>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const _T1\x26 __x, const _T2\x26 __y) {return __p_(__y, __x);}\x0a"
"};\x0a"
"\x0a"
"// Perform division by two quickly for positive integers (llvm.org/PR39129)\x0a"
"\x0a"
"template <typename _Integral>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_integral<_Integral>\x3a\x3avalue,\x0a"
"    _Integral\x0a"
">\x3a\x3atype\x0a"
"__half_positive(_Integral __value)\x0a"
"{\x0a"
"    return static_cast<_Integral>(static_cast<typename make_unsigned<_Integral>\x3a\x3atype>(__value) / 2);\x0a"
"}\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_integral<_Tp>\x3a\x3avalue,\x0a"
"    _Tp\x0a"
">\x3a\x3atype\x0a"
"__half_positive(_Tp __value)\x0a"
"{\x0a"
"    return __value / 2;\x0a"
"}\x0a"
"\x0a"
"#ifdef _LIBCPP_DEBUG\x0a"
"\x0a"
"template <class _Compare>\x0a"
"struct __debug_less\x0a"
"{\x0a"
"    _Compare \x26__comp_;\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"    __debug_less(_Compare\x26 __c) \x3a __comp_(__c) {}\x0a"
"\x0a"
"    template <class _Tp, class _Up>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"    bool operator()(const _Tp\x26 __x,  const _Up\x26 __y)\x0a"
"    {\x0a"
"        bool __r = __comp_(__x, __y);\x0a"
"        if (__r)\x0a"
"            __do_compare_assert(0, __y, __x);\x0a"
"        return __r;\x0a"
"    }\x0a"
"\x0a"
"    template <class _Tp, class _Up>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"    bool operator()(_Tp\x26 __x,  _Up\x26 __y)\x0a"
"    {\x0a"
"        bool __r = __comp_(__x, __y);\x0a"
"        if (__r)\x0a"
"            __do_compare_assert(0, __y, __x);\x0a"
"        return __r;\x0a"
"    }\x0a"
"\x0a"
"    template <class _LHS, class _RHS>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    decltype((void)_VSTD\x3a\x3a""declval<_Compare\x26>()(\x0a"
"        _VSTD\x3a\x3a""declval<_LHS \x26>(), _VSTD\x3a\x3a""declval<_RHS \x26>()))\x0a"
"    __do_compare_assert(int, _LHS \x26 __l, _RHS \x26 __r) {\x0a"
"        _LIBCPP_ASSERT(\x21__comp_(__l, __r),\x0a"
"            \x22""Comparator does not induce a strict weak ordering\x22);\x0a"
"    }\x0a"
"\x0a"
"    template <class _LHS, class _RHS>\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __do_compare_assert(long, _LHS \x26, _RHS \x26) {}\x0a"
"};\x0a"
"\x0a"
"#endif // _LIBCPP_DEBUG\x0a"
"\x0a"
"template <class _Comp>\x0a"
"struct __comp_ref_type {\x0a"
"  // Pass the comparator by lvalue reference. Or in debug mode, using a\x0a"
"  // debugging wrapper that stores a reference.\x0a"
"#ifndef _LIBCPP_DEBUG\x0a"
"  typedef typename add_lvalue_reference<_Comp>\x3a\x3atype type;\x0a"
"#else\x0a"
"  typedef __debug_less<_Comp> type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"// all_of\x0a"
"\x0a"
"template <class _InputIterator, class _Predicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"all_of(_InputIterator __first, _InputIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (\x21__pred(*__first))\x0a"
"            return false;\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"// any_of\x0a"
"\x0a"
"template <class _InputIterator, class _Predicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"any_of(_InputIterator __first, _InputIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (__pred(*__first))\x0a"
"            return true;\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"// none_of\x0a"
"\x0a"
"template <class _InputIterator, class _Predicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"none_of(_InputIterator __first, _InputIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (__pred(*__first))\x0a"
"            return false;\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"// for_each\x0a"
"\x0a"
"template <class _InputIterator, class _Function>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_Function\x0a"
"for_each(_InputIterator __first, _InputIterator __last, _Function __f)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __f(*__first);\x0a"
"    return __f;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"// for_each_n\x0a"
"\x0a"
"template <class _InputIterator, class _Size, class _Function>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_InputIterator\x0a"
"for_each_n(_InputIterator __first, _Size __orig_n, _Function __f)\x0a"
"{\x0a"
"    typedef decltype(__convert_to_integral(__orig_n)) _IntegralSize;\x0a"
"    _IntegralSize __n = __orig_n;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"         __f(*__first);\x0a"
"         ++__first;\x0a"
"         --__n;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"// find\x0a"
"\x0a"
"template <class _InputIterator, class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_InputIterator\x0a"
"find(_InputIterator __first, _InputIterator __last, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (*__first == __value_)\x0a"
"            break;\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"// find_if\x0a"
"\x0a"
"template <class _InputIterator, class _Predicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_InputIterator\x0a"
"find_if(_InputIterator __first, _InputIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (__pred(*__first))\x0a"
"            break;\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"// find_if_not\x0a"
"\x0a"
"template<class _InputIterator, class _Predicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_InputIterator\x0a"
"find_if_not(_InputIterator __first, _InputIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (\x21__pred(*__first))\x0a"
"            break;\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"// find_end\x0a"
"\x0a"
"template <class _BinaryPredicate, class _ForwardIterator1, class _ForwardIterator2>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _ForwardIterator1\x0a"
"__find_end(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"           _ForwardIterator2 __first2, _ForwardIterator2 __last2, _BinaryPredicate __pred,\x0a"
"           forward_iterator_tag, forward_iterator_tag)\x0a"
"{\x0a"
"    // modeled after search algorithm\x0a"
"    _ForwardIterator1 __r = __last1;  // __last1 is the \x22""default\x22 answer\x0a"
"    if (__first2 == __last2)\x0a"
"        return __r;\x0a"
"    while (true)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (__first1 == __last1)         // if source exhausted return last correct answer\x0a"
"                return __r;                  //    (or __last1 if never found)\x0a"
"            if (__pred(*__first1, *__first2))\x0a"
"                break;\x0a"
"            ++__first1;\x0a"
"        }\x0a"
"        // *__first1 matches *__first2, now match elements after here\x0a"
"        _ForwardIterator1 __m1 = __first1;\x0a"
"        _ForwardIterator2 __m2 = __first2;\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (++__m2 == __last2)\x0a"
"            {                         // Pattern exhaused, record answer and search for another one\x0a"
"                __r = __first1;\x0a"
"                ++__first1;\x0a"
"                break;\x0a"
"            }\x0a"
"            if (++__m1 == __last1)     // Source exhausted, return last answer\x0a"
"                return __r;\x0a"
"            if (\x21__pred(*__m1, *__m2))  // mismatch, restart with a new __first\x0a"
"            {\x0a"
"                ++__first1;\x0a"
"                break;\x0a"
"            }  // else there is a match, check next elements\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _BinaryPredicate, class _BidirectionalIterator1, class _BidirectionalIterator2>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _BidirectionalIterator1\x0a"
"__find_end(_BidirectionalIterator1 __first1, _BidirectionalIterator1 __last1,\x0a"
"           _BidirectionalIterator2 __first2, _BidirectionalIterator2 __last2, _BinaryPredicate __pred,\x0a"
"           bidirectional_iterator_tag, bidirectional_iterator_tag)\x0a"
"{\x0a"
"    // modeled after search algorithm (in reverse)\x0a"
"    if (__first2 == __last2)\x0a"
"        return __last1;  // Everything matches an empty sequence\x0a"
"    _BidirectionalIterator1 __l1 = __last1;\x0a"
"    _BidirectionalIterator2 __l2 = __last2;\x0a"
"    --__l2;\x0a"
"    while (true)\x0a"
"    {\x0a"
"        // Find last element in sequence 1 that matchs *(__last2-1), with a mininum of loop checks\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (__first1 == __l1)  // return __last1 if no element matches *__first2\x0a"
"                return __last1;\x0a"
"            if (__pred(*--__l1, *__l2))\x0a"
"                break;\x0a"
"        }\x0a"
"        // *__l1 matches *__l2, now match elements before here\x0a"
"        _BidirectionalIterator1 __m1 = __l1;\x0a"
"        _BidirectionalIterator2 __m2 = __l2;\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (__m2 == __first2)  // If pattern exhausted, __m1 is the answer (works for 1 element pattern)\x0a"
"                return __m1;\x0a"
"            if (__m1 == __first1)  // Otherwise if source exhaused, pattern not found\x0a"
"                return __last1;\x0a"
"            if (\x21__pred(*--__m1, *--__m2))  // if there is a mismatch, restart with a new __l1\x0a"
"            {\x0a"
"                break;\x0a"
"            }  // else there is a match, check next elements\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _BinaryPredicate, class _RandomAccessIterator1, class _RandomAccessIterator2>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _RandomAccessIterator1\x0a"
"__find_end(_RandomAccessIterator1 __first1, _RandomAccessIterator1 __last1,\x0a"
"           _RandomAccessIterator2 __first2, _RandomAccessIterator2 __last2, _BinaryPredicate __pred,\x0a"
"           random_access_iterator_tag, random_access_iterator_tag)\x0a"
"{\x0a"
"    // Take advantage of knowing source and pattern lengths.  Stop short when source is smaller than pattern\x0a"
"    typename iterator_traits<_RandomAccessIterator2>\x3a\x3a""difference_type __len2 = __last2 - __first2;\x0a"
"    if (__len2 == 0)\x0a"
"        return __last1;\x0a"
"    typename iterator_traits<_RandomAccessIterator1>\x3a\x3a""difference_type __len1 = __last1 - __first1;\x0a"
"    if (__len1 < __len2)\x0a"
"        return __last1;\x0a"
"    const _RandomAccessIterator1 __s = __first1 + (__len2 - 1);  // End of pattern match can't go before here\x0a"
"    _RandomAccessIterator1 __l1 = __last1;\x0a"
"    _RandomAccessIterator2 __l2 = __last2;\x0a"
"    --__l2;\x0a"
"    while (true)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (__s == __l1)\x0a"
"                return __last1;\x0a"
"            if (__pred(*--__l1, *__l2))\x0a"
"                break;\x0a"
"        }\x0a"
"        _RandomAccessIterator1 __m1 = __l1;\x0a"
"        _RandomAccessIterator2 __m2 = __l2;\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (__m2 == __first2)\x0a"
"                return __m1;\x0a"
"                                 // no need to check range on __m1 because __s guarantees we have enough source\x0a"
"            if (\x21__pred(*--__m1, *--__m2))\x0a"
"            {\x0a"
"                break;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator1, class _ForwardIterator2, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator1\x0a"
"find_end(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"         _ForwardIterator2 __first2, _ForwardIterator2 __last2, _BinaryPredicate __pred)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__find_end<typename add_lvalue_reference<_BinaryPredicate>\x3a\x3atype>\x0a"
"                         (__first1, __last1, __first2, __last2, __pred,\x0a"
"                          typename iterator_traits<_ForwardIterator1>\x3a\x3aiterator_category(),\x0a"
"                          typename iterator_traits<_ForwardIterator2>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator1, class _ForwardIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator1\x0a"
"find_end(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"         _ForwardIterator2 __first2, _ForwardIterator2 __last2)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator1>\x3a\x3avalue_type __v1;\x0a"
"    typedef typename iterator_traits<_ForwardIterator2>\x3a\x3avalue_type __v2;\x0a"
"    return _VSTD\x3a\x3a""find_end(__first1, __last1, __first2, __last2, __equal_to<__v1, __v2>());\x0a"
"}\x0a"
"\x0a"
"// find_first_of\x0a"
"\x0a"
"template <class _ForwardIterator1, class _ForwardIterator2, class _BinaryPredicate>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX11 _ForwardIterator1\x0a"
"__find_first_of_ce(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"              _ForwardIterator2 __first2, _ForwardIterator2 __last2, _BinaryPredicate __pred)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__first1)\x0a"
"        for (_ForwardIterator2 __j = __first2; __j \x21= __last2; ++__j)\x0a"
"            if (__pred(*__first1, *__j))\x0a"
"                return __first1;\x0a"
"    return __last1;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _ForwardIterator1, class _ForwardIterator2, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator1\x0a"
"find_first_of(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"              _ForwardIterator2 __first2, _ForwardIterator2 __last2, _BinaryPredicate __pred)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__find_first_of_ce(__first1, __last1, __first2, __last2, __pred);\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator1, class _ForwardIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator1\x0a"
"find_first_of(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"              _ForwardIterator2 __first2, _ForwardIterator2 __last2)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator1>\x3a\x3avalue_type __v1;\x0a"
"    typedef typename iterator_traits<_ForwardIterator2>\x3a\x3avalue_type __v2;\x0a"
"    return _VSTD\x3a\x3a__find_first_of_ce(__first1, __last1, __first2, __last2, __equal_to<__v1, __v2>());\x0a"
"}\x0a"
"\x0a"
"// adjacent_find\x0a"
"\x0a"
"template <class _ForwardIterator, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator\x0a"
"adjacent_find(_ForwardIterator __first, _ForwardIterator __last, _BinaryPredicate __pred)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __i = __first;\x0a"
"        while (++__i \x21= __last)\x0a"
"        {\x0a"
"            if (__pred(*__first, *__i))\x0a"
"                return __first;\x0a"
"            __first = __i;\x0a"
"        }\x0a"
"    }\x0a"
"    return __last;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator\x0a"
"adjacent_find(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type __v;\x0a"
"    return _VSTD\x3a\x3a""adjacent_find(__first, __last, __equal_to<__v>());\x0a"
"}\x0a"
"\x0a"
"// count\x0a"
"\x0a"
"template <class _InputIterator, class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"typename iterator_traits<_InputIterator>\x3a\x3a""difference_type\x0a"
"count(_InputIterator __first, _InputIterator __last, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    typename iterator_traits<_InputIterator>\x3a\x3a""difference_type __r(0);\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (*__first == __value_)\x0a"
"            ++__r;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// count_if\x0a"
"\x0a"
"template <class _InputIterator, class _Predicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"typename iterator_traits<_InputIterator>\x3a\x3a""difference_type\x0a"
"count_if(_InputIterator __first, _InputIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    typename iterator_traits<_InputIterator>\x3a\x3a""difference_type __r(0);\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (__pred(*__first))\x0a"
"            ++__r;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// mismatch\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"pair<_InputIterator1, _InputIterator2>\x0a"
"mismatch(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"         _InputIterator2 __first2, _BinaryPredicate __pred)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__first1, (void) ++__first2)\x0a"
"        if (\x21__pred(*__first1, *__first2))\x0a"
"            break;\x0a"
"    return pair<_InputIterator1, _InputIterator2>(__first1, __first2);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"pair<_InputIterator1, _InputIterator2>\x0a"
"mismatch(_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_InputIterator1>\x3a\x3avalue_type __v1;\x0a"
"    typedef typename iterator_traits<_InputIterator2>\x3a\x3avalue_type __v2;\x0a"
"    return _VSTD\x3a\x3amismatch(__first1, __last1, __first2, __equal_to<__v1, __v2>());\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _InputIterator1, class _InputIterator2, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"pair<_InputIterator1, _InputIterator2>\x0a"
"mismatch(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"         _InputIterator2 __first2, _InputIterator2 __last2,\x0a"
"         _BinaryPredicate __pred)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1 \x26\x26 __first2 \x21= __last2; ++__first1, (void) ++__first2)\x0a"
"        if (\x21__pred(*__first1, *__first2))\x0a"
"            break;\x0a"
"    return pair<_InputIterator1, _InputIterator2>(__first1, __first2);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"pair<_InputIterator1, _InputIterator2>\x0a"
"mismatch(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"         _InputIterator2 __first2, _InputIterator2 __last2)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_InputIterator1>\x3a\x3avalue_type __v1;\x0a"
"    typedef typename iterator_traits<_InputIterator2>\x3a\x3avalue_type __v2;\x0a"
"    return _VSTD\x3a\x3amismatch(__first1, __last1, __first2, __last2, __equal_to<__v1, __v2>());\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"// equal\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"equal(_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _BinaryPredicate __pred)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__first1, (void) ++__first2)\x0a"
"        if (\x21__pred(*__first1, *__first2))\x0a"
"            return false;\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"equal(_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_InputIterator1>\x3a\x3avalue_type __v1;\x0a"
"    typedef typename iterator_traits<_InputIterator2>\x3a\x3avalue_type __v2;\x0a"
"    return _VSTD\x3a\x3a""equal(__first1, __last1, __first2, __equal_to<__v1, __v2>());\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _BinaryPredicate, class _InputIterator1, class _InputIterator2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"__equal(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"        _InputIterator2 __first2, _InputIterator2 __last2, _BinaryPredicate __pred,\x0a"
"        input_iterator_tag, input_iterator_tag )\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1 \x26\x26 __first2 \x21= __last2; ++__first1, (void) ++__first2)\x0a"
"        if (\x21__pred(*__first1, *__first2))\x0a"
"            return false;\x0a"
"    return __first1 == __last1 \x26\x26 __first2 == __last2;\x0a"
"}\x0a"
"\x0a"
"template <class _BinaryPredicate, class _RandomAccessIterator1, class _RandomAccessIterator2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"__equal(_RandomAccessIterator1 __first1, _RandomAccessIterator1 __last1,\x0a"
"        _RandomAccessIterator2 __first2, _RandomAccessIterator2 __last2, _BinaryPredicate __pred,\x0a"
"      random_access_iterator_tag, random_access_iterator_tag )\x0a"
"{\x0a"
"    if ( _VSTD\x3a\x3a""distance(__first1, __last1) \x21= _VSTD\x3a\x3a""distance(__first2, __last2))\x0a"
"        return false;\x0a"
"    return _VSTD\x3a\x3a""equal<_RandomAccessIterator1, _RandomAccessIterator2,\x0a"
"                        typename add_lvalue_reference<_BinaryPredicate>\x3a\x3atype>\x0a"
"                       (__first1, __last1, __first2, __pred );\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"equal(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"      _InputIterator2 __first2, _InputIterator2 __last2, _BinaryPredicate __pred )\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__equal<typename add_lvalue_reference<_BinaryPredicate>\x3a\x3atype>\x0a"
"       (__first1, __last1, __first2, __last2, __pred,\x0a"
"        typename iterator_traits<_InputIterator1>\x3a\x3aiterator_category(),\x0a"
"        typename iterator_traits<_InputIterator2>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"equal(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"      _InputIterator2 __first2, _InputIterator2 __last2)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_InputIterator1>\x3a\x3avalue_type __v1;\x0a"
"    typedef typename iterator_traits<_InputIterator2>\x3a\x3avalue_type __v2;\x0a"
"    return _VSTD\x3a\x3a__equal(__first1, __last1, __first2, __last2, __equal_to<__v1, __v2>(),\x0a"
"        typename iterator_traits<_InputIterator1>\x3a\x3aiterator_category(),\x0a"
"        typename iterator_traits<_InputIterator2>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"// is_permutation\x0a"
"\x0a"
"template<class _ForwardIterator1, class _ForwardIterator2, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT _LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"is_permutation(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"               _ForwardIterator2 __first2, _BinaryPredicate __pred)\x0a"
"{\x0a"
"//  shorten sequences as much as possible by lopping of any equal prefix\x0a"
"    for (; __first1 \x21= __last1; ++__first1, (void) ++__first2)\x0a"
"        if (\x21__pred(*__first1, *__first2))\x0a"
"            break;\x0a"
"    if (__first1 == __last1)\x0a"
"        return true;\x0a"
"\x0a"
"//  __first1 \x21= __last1 \x26\x26 *__first1 \x21= *__first2\x0a"
"    typedef typename iterator_traits<_ForwardIterator1>\x3a\x3a""difference_type _D1;\x0a"
"    _D1 __l1 = _VSTD\x3a\x3a""distance(__first1, __last1);\x0a"
"    if (__l1 == _D1(1))\x0a"
"        return false;\x0a"
"    _ForwardIterator2 __last2 = _VSTD\x3a\x3anext(__first2, __l1);\x0a"
"    // For each element in \x5b""f1, l1) see if there are the same number of\x0a"
"    //    equal elements in \x5b""f2, l2)\x0a"
"    for (_ForwardIterator1 __i = __first1; __i \x21= __last1; ++__i)\x0a"
"    {\x0a"
"    //  Have we already counted the number of *__i in \x5b""f1, l1)\x3f\x0a"
"        _ForwardIterator1 __match = __first1;\x0a"
"        for (; __match \x21= __i; ++__match)\x0a"
"            if (__pred(*__match, *__i))\x0a"
"                break;\x0a"
"        if (__match == __i) {\x0a"
"            // Count number of *__i in \x5b""f2, l2)\x0a"
"            _D1 __c2 = 0;\x0a"
"            for (_ForwardIterator2 __j = __first2; __j \x21= __last2; ++__j)\x0a"
"                if (__pred(*__i, *__j))\x0a"
"                    ++__c2;\x0a"
"            if (__c2 == 0)\x0a"
"                return false;\x0a"
"            // Count number of *__i in \x5b__i, l1) (we can start with 1)\x0a"
"            _D1 __c1 = 1;\x0a"
"            for (_ForwardIterator1 __j = _VSTD\x3a\x3anext(__i); __j \x21= __last1; ++__j)\x0a"
"                if (__pred(*__i, *__j))\x0a"
"                    ++__c1;\x0a"
"            if (__c1 \x21= __c2)\x0a"
"                return false;\x0a"
"        }\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template<class _ForwardIterator1, class _ForwardIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"is_permutation(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"               _ForwardIterator2 __first2)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator1>\x3a\x3avalue_type __v1;\x0a"
"    typedef typename iterator_traits<_ForwardIterator2>\x3a\x3avalue_type __v2;\x0a"
"    return _VSTD\x3a\x3ais_permutation(__first1, __last1, __first2, __equal_to<__v1, __v2>());\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template<class _BinaryPredicate, class _ForwardIterator1, class _ForwardIterator2>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"__is_permutation(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"                 _ForwardIterator2 __first2, _ForwardIterator2 __last2,\x0a"
"                 _BinaryPredicate __pred,\x0a"
"                 forward_iterator_tag, forward_iterator_tag )\x0a"
"{\x0a"
"//  shorten sequences as much as possible by lopping of any equal prefix\x0a"
"    for (; __first1 \x21= __last1 \x26\x26 __first2 \x21= __last2; ++__first1, (void) ++__first2)\x0a"
"        if (\x21__pred(*__first1, *__first2))\x0a"
"            break;\x0a"
"    if (__first1 == __last1)\x0a"
"        return __first2 == __last2;\x0a"
"    else if (__first2 == __last2)\x0a"
"        return false;\x0a"
"\x0a"
"    typedef typename iterator_traits<_ForwardIterator1>\x3a\x3a""difference_type _D1;\x0a"
"    _D1 __l1 = _VSTD\x3a\x3a""distance(__first1, __last1);\x0a"
"\x0a"
"    typedef typename iterator_traits<_ForwardIterator2>\x3a\x3a""difference_type _D2;\x0a"
"    _D2 __l2 = _VSTD\x3a\x3a""distance(__first2, __last2);\x0a"
"    if (__l1 \x21= __l2)\x0a"
"        return false;\x0a"
"\x0a"
"    // For each element in \x5b""f1, l1) see if there are the same number of\x0a"
"    //    equal elements in \x5b""f2, l2)\x0a"
"    for (_ForwardIterator1 __i = __first1; __i \x21= __last1; ++__i)\x0a"
"    {\x0a"
"    //  Have we already counted the number of *__i in \x5b""f1, l1)\x3f\x0a"
"        _ForwardIterator1 __match = __first1;\x0a"
"        for (; __match \x21= __i; ++__match)\x0a"
"            if (__pred(*__match, *__i))\x0a"
"                break;\x0a"
"        if (__match == __i) {\x0a"
"            // Count number of *__i in \x5b""f2, l2)\x0a"
"            _D1 __c2 = 0;\x0a"
"            for (_ForwardIterator2 __j = __first2; __j \x21= __last2; ++__j)\x0a"
"                if (__pred(*__i, *__j))\x0a"
"                    ++__c2;\x0a"
"            if (__c2 == 0)\x0a"
"                return false;\x0a"
"            // Count number of *__i in \x5b__i, l1) (we can start with 1)\x0a"
"            _D1 __c1 = 1;\x0a"
"            for (_ForwardIterator1 __j = _VSTD\x3a\x3anext(__i); __j \x21= __last1; ++__j)\x0a"
"                if (__pred(*__i, *__j))\x0a"
"                    ++__c1;\x0a"
"            if (__c1 \x21= __c2)\x0a"
"                return false;\x0a"
"        }\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template<class _BinaryPredicate, class _RandomAccessIterator1, class _RandomAccessIterator2>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"__is_permutation(_RandomAccessIterator1 __first1, _RandomAccessIterator2 __last1,\x0a"
"               _RandomAccessIterator1 __first2, _RandomAccessIterator2 __last2,\x0a"
"               _BinaryPredicate __pred,\x0a"
"               random_access_iterator_tag, random_access_iterator_tag )\x0a"
"{\x0a"
"    if ( _VSTD\x3a\x3a""distance(__first1, __last1) \x21= _VSTD\x3a\x3a""distance(__first2, __last2))\x0a"
"        return false;\x0a"
"    return _VSTD\x3a\x3ais_permutation<_RandomAccessIterator1, _RandomAccessIterator2,\x0a"
"                                 typename add_lvalue_reference<_BinaryPredicate>\x3a\x3atype>\x0a"
"                                (__first1, __last1, __first2, __pred );\x0a"
"}\x0a"
"\x0a"
"template<class _ForwardIterator1, class _ForwardIterator2, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"is_permutation(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"               _ForwardIterator2 __first2, _ForwardIterator2 __last2,\x0a"
"               _BinaryPredicate __pred )\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__is_permutation<typename add_lvalue_reference<_BinaryPredicate>\x3a\x3atype>\x0a"
"       (__first1, __last1, __first2, __last2, __pred,\x0a"
"        typename iterator_traits<_ForwardIterator1>\x3a\x3aiterator_category(),\x0a"
"        typename iterator_traits<_ForwardIterator2>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"template<class _ForwardIterator1, class _ForwardIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"is_permutation(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"               _ForwardIterator2 __first2, _ForwardIterator2 __last2)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator1>\x3a\x3avalue_type __v1;\x0a"
"    typedef typename iterator_traits<_ForwardIterator2>\x3a\x3avalue_type __v2;\x0a"
"    return _VSTD\x3a\x3a__is_permutation(__first1, __last1, __first2, __last2,\x0a"
"        __equal_to<__v1, __v2>(),\x0a"
"        typename iterator_traits<_ForwardIterator1>\x3a\x3aiterator_category(),\x0a"
"        typename iterator_traits<_ForwardIterator2>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"// search\x0a"
"// __search is in <functional>\x0a"
"\x0a"
"template <class _ForwardIterator1, class _ForwardIterator2, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator1\x0a"
"search(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"       _ForwardIterator2 __first2, _ForwardIterator2 __last2, _BinaryPredicate __pred)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__search<typename add_lvalue_reference<_BinaryPredicate>\x3a\x3atype>\x0a"
"                         (__first1, __last1, __first2, __last2, __pred,\x0a"
"                          typename iterator_traits<_ForwardIterator1>\x3a\x3aiterator_category(),\x0a"
"                          typename iterator_traits<_ForwardIterator2>\x3a\x3aiterator_category())\x0a"
"            .first;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator1, class _ForwardIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator1\x0a"
"search(_ForwardIterator1 __first1, _ForwardIterator1 __last1,\x0a"
"       _ForwardIterator2 __first2, _ForwardIterator2 __last2)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator1>\x3a\x3avalue_type __v1;\x0a"
"    typedef typename iterator_traits<_ForwardIterator2>\x3a\x3avalue_type __v2;\x0a"
"    return _VSTD\x3a\x3asearch(__first1, __last1, __first2, __last2, __equal_to<__v1, __v2>());\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _ForwardIterator, class _Searcher>\x0a"
"_LIBCPP_NODISCARD_EXT _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator search(_ForwardIterator __f, _ForwardIterator __l, const _Searcher \x26__s)\x0a"
"{ return __s(__f, __l).first; }\x0a"
"#endif\x0a"
"\x0a"
"// search_n\x0a"
"\x0a"
"template <class _BinaryPredicate, class _ForwardIterator, class _Size, class _Tp>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _ForwardIterator\x0a"
"__search_n(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"           _Size __count, const _Tp\x26 __value_, _BinaryPredicate __pred, forward_iterator_tag)\x0a"
"{\x0a"
"    if (__count <= 0)\x0a"
"        return __first;\x0a"
"    while (true)\x0a"
"    {\x0a"
"        // Find first element in sequence that matchs __value_, with a mininum of loop checks\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (__first == __last)  // return __last if no element matches __value_\x0a"
"                return __last;\x0a"
"            if (__pred(*__first, __value_))\x0a"
"                break;\x0a"
"            ++__first;\x0a"
"        }\x0a"
"        // *__first matches __value_, now match elements after here\x0a"
"        _ForwardIterator __m = __first;\x0a"
"        _Size __c(0);\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (++__c == __count)  // If pattern exhausted, __first is the answer (works for 1 element pattern)\x0a"
"                return __first;\x0a"
"            if (++__m == __last)  // Otherwise if source exhaused, pattern not found\x0a"
"                return __last;\x0a"
"            if (\x21__pred(*__m, __value_))  // if there is a mismatch, restart with a new __first\x0a"
"            {\x0a"
"                __first = __m;\x0a"
"                ++__first;\x0a"
"                break;\x0a"
"            }  // else there is a match, check next elements\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _BinaryPredicate, class _RandomAccessIterator, class _Size, class _Tp>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _RandomAccessIterator\x0a"
"__search_n(_RandomAccessIterator __first, _RandomAccessIterator __last,\x0a"
"           _Size __count, const _Tp\x26 __value_, _BinaryPredicate __pred, random_access_iterator_tag)\x0a"
"{\x0a"
"    if (__count <= 0)\x0a"
"        return __first;\x0a"
"    _Size __len = static_cast<_Size>(__last - __first);\x0a"
"    if (__len < __count)\x0a"
"        return __last;\x0a"
"    const _RandomAccessIterator __s = __last - (__count - 1);  // Start of pattern match can't go beyond here\x0a"
"    while (true)\x0a"
"    {\x0a"
"        // Find first element in sequence that matchs __value_, with a mininum of loop checks\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (__first >= __s)  // return __last if no element matches __value_\x0a"
"                return __last;\x0a"
"            if (__pred(*__first, __value_))\x0a"
"                break;\x0a"
"            ++__first;\x0a"
"        }\x0a"
"        // *__first matches __value_, now match elements after here\x0a"
"        _RandomAccessIterator __m = __first;\x0a"
"        _Size __c(0);\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (++__c == __count)  // If pattern exhausted, __first is the answer (works for 1 element pattern)\x0a"
"                return __first;\x0a"
"             ++__m;          // no need to check range on __m because __s guarantees we have enough source\x0a"
"            if (\x21__pred(*__m, __value_))  // if there is a mismatch, restart with a new __first\x0a"
"            {\x0a"
"                __first = __m;\x0a"
"                ++__first;\x0a"
"                break;\x0a"
"            }  // else there is a match, check next elements\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Size, class _Tp, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator\x0a"
"search_n(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"         _Size __count, const _Tp\x26 __value_, _BinaryPredicate __pred)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__search_n<typename add_lvalue_reference<_BinaryPredicate>\x3a\x3atype>\x0a"
"           (__first, __last, __convert_to_integral(__count), __value_, __pred,\x0a"
"           typename iterator_traits<_ForwardIterator>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Size, class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator\x0a"
"search_n(_ForwardIterator __first, _ForwardIterator __last, _Size __count, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type __v;\x0a"
"    return _VSTD\x3a\x3asearch_n(__first, __last, __convert_to_integral(__count),\x0a"
"                           __value_, __equal_to<__v, _Tp>());\x0a"
"}\x0a"
"\x0a"
"// copy\x0a"
"template <class _Iter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Iter\x0a"
"__unwrap_iter(_Iter __i)\x0a"
"{\x0a"
"    return __i;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_trivially_copy_assignable<_Tp>\x3a\x3avalue,\x0a"
"    _Tp*\x0a"
">\x3a\x3atype\x0a"
"__unwrap_iter(move_iterator<_Tp*> __i)\x0a"
"{\x0a"
"    return __i.base();\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL < 2\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_trivially_copy_assignable<_Tp>\x3a\x3avalue,\x0a"
"    _Tp*\x0a"
">\x3a\x3atype\x0a"
"__unwrap_iter(__wrap_iter<_Tp*> __i)\x0a"
"{\x0a"
"    return __i.base();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_trivially_copy_assignable<_Tp>\x3a\x3avalue,\x0a"
"    const _Tp*\x0a"
">\x3a\x3atype\x0a"
"__unwrap_iter(__wrap_iter<const _Tp*> __i)\x0a"
"{\x0a"
"    return __i.base();\x0a"
"}\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_IF_NODEBUG\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_trivially_copy_assignable<_Tp>\x3a\x3avalue,\x0a"
"    __wrap_iter<_Tp*>\x0a"
">\x3a\x3atype\x0a"
"__unwrap_iter(__wrap_iter<_Tp*> __i)\x0a"
"{\x0a"
"    return __i;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL < 2\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"__copy(_InputIterator __first, _InputIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first, (void) ++__result)\x0a"
"        *__result = *__first;\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_same<typename remove_const<_Tp>\x3a\x3atype, _Up>\x3a\x3avalue \x26\x26\x0a"
"    is_trivially_copy_assignable<_Up>\x3a\x3avalue,\x0a"
"    _Up*\x0a"
">\x3a\x3atype\x0a"
"__copy(_Tp* __first, _Tp* __last, _Up* __result)\x0a"
"{\x0a"
"    const size_t __n = static_cast<size_t>(__last - __first);\x0a"
"    if (__n > 0)\x0a"
"        _VSTD\x3a\x3amemmove(__result, __first, __n * sizeof(_Up));\x0a"
"    return __result + __n;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"copy(_InputIterator __first, _InputIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__copy(__unwrap_iter(__first), __unwrap_iter(__last), __unwrap_iter(__result));\x0a"
"}\x0a"
"\x0a"
"// copy_backward\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"__copy_backward(_BidirectionalIterator __first, _BidirectionalIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    while (__first \x21= __last)\x0a"
"        *--__result = *--__last;\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_same<typename remove_const<_Tp>\x3a\x3atype, _Up>\x3a\x3avalue \x26\x26\x0a"
"    is_trivially_copy_assignable<_Up>\x3a\x3avalue,\x0a"
"    _Up*\x0a"
">\x3a\x3atype\x0a"
"__copy_backward(_Tp* __first, _Tp* __last, _Up* __result)\x0a"
"{\x0a"
"    const size_t __n = static_cast<size_t>(__last - __first);\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __result -= __n;\x0a"
"        _VSTD\x3a\x3amemmove(__result, __first, __n * sizeof(_Up));\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator1, class _BidirectionalIterator2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_BidirectionalIterator2\x0a"
"copy_backward(_BidirectionalIterator1 __first, _BidirectionalIterator1 __last,\x0a"
"              _BidirectionalIterator2 __result)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__copy_backward(__unwrap_iter(__first),\x0a"
"                                  __unwrap_iter(__last),\x0a"
"                                  __unwrap_iter(__result));\x0a"
"}\x0a"
"\x0a"
"// copy_if\x0a"
"\x0a"
"template<class _InputIterator, class _OutputIterator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"copy_if(_InputIterator __first, _InputIterator __last,\x0a"
"        _OutputIterator __result, _Predicate __pred)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"    {\x0a"
"        if (__pred(*__first))\x0a"
"        {\x0a"
"            *__result = *__first;\x0a"
"            ++__result;\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"// copy_n\x0a"
"\x0a"
"template<class _InputIterator, class _Size, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_input_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"   \x21__is_random_access_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"    _OutputIterator\x0a"
">\x3a\x3atype\x0a"
"copy_n(_InputIterator __first, _Size __orig_n, _OutputIterator __result)\x0a"
"{\x0a"
"    typedef decltype(__convert_to_integral(__orig_n)) _IntegralSize;\x0a"
"    _IntegralSize __n = __orig_n;\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        *__result = *__first;\x0a"
"        ++__result;\x0a"
"        for (--__n; __n > 0; --__n)\x0a"
"        {\x0a"
"            ++__first;\x0a"
"            *__result = *__first;\x0a"
"            ++__result;\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template<class _InputIterator, class _Size, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_random_access_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"    _OutputIterator\x0a"
">\x3a\x3atype\x0a"
"copy_n(_InputIterator __first, _Size __orig_n, _OutputIterator __result)\x0a"
"{\x0a"
"    typedef decltype(__convert_to_integral(__orig_n)) _IntegralSize;\x0a"
"    _IntegralSize __n = __orig_n;\x0a"
"    return _VSTD\x3a\x3a""copy(__first, __first + __n, __result);\x0a"
"}\x0a"
"\x0a"
"// move\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"__move(_InputIterator __first, _InputIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first, (void) ++__result)\x0a"
"        *__result = _VSTD\x3a\x3amove(*__first);\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_same<typename remove_const<_Tp>\x3a\x3atype, _Up>\x3a\x3avalue \x26\x26\x0a"
"    is_trivially_copy_assignable<_Up>\x3a\x3avalue,\x0a"
"    _Up*\x0a"
">\x3a\x3atype\x0a"
"__move(_Tp* __first, _Tp* __last, _Up* __result)\x0a"
"{\x0a"
"    const size_t __n = static_cast<size_t>(__last - __first);\x0a"
"    if (__n > 0)\x0a"
"        _VSTD\x3a\x3amemmove(__result, __first, __n * sizeof(_Up));\x0a"
"    return __result + __n;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"move(_InputIterator __first, _InputIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__move(__unwrap_iter(__first), __unwrap_iter(__last), __unwrap_iter(__result));\x0a"
"}\x0a"
"\x0a"
"// move_backward\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"__move_backward(_InputIterator __first, _InputIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    while (__first \x21= __last)\x0a"
"        *--__result = _VSTD\x3a\x3amove(*--__last);\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_same<typename remove_const<_Tp>\x3a\x3atype, _Up>\x3a\x3avalue \x26\x26\x0a"
"    is_trivially_copy_assignable<_Up>\x3a\x3avalue,\x0a"
"    _Up*\x0a"
">\x3a\x3atype\x0a"
"__move_backward(_Tp* __first, _Tp* __last, _Up* __result)\x0a"
"{\x0a"
"    const size_t __n = static_cast<size_t>(__last - __first);\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __result -= __n;\x0a"
"        _VSTD\x3a\x3amemmove(__result, __first, __n * sizeof(_Up));\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator1, class _BidirectionalIterator2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_BidirectionalIterator2\x0a"
"move_backward(_BidirectionalIterator1 __first, _BidirectionalIterator1 __last,\x0a"
"              _BidirectionalIterator2 __result)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__move_backward(__unwrap_iter(__first), __unwrap_iter(__last), __unwrap_iter(__result));\x0a"
"}\x0a"
"\x0a"
"// iter_swap\x0a"
"\x0a"
"// moved to <type_traits> for better swap / noexcept support\x0a"
"\x0a"
"// transform\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _UnaryOperation>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"transform(_InputIterator __first, _InputIterator __last, _OutputIterator __result, _UnaryOperation __op)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first, (void) ++__result)\x0a"
"        *__result = __op(*__first);\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator, class _BinaryOperation>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"transform(_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2,\x0a"
"          _OutputIterator __result, _BinaryOperation __binary_op)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__first1, (void) ++__first2, ++__result)\x0a"
"        *__result = __binary_op(*__first1, *__first2);\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"// replace\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"void\x0a"
"replace(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __old_value, const _Tp\x26 __new_value)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (*__first == __old_value)\x0a"
"            *__first = __new_value;\x0a"
"}\x0a"
"\x0a"
"// replace_if\x0a"
"\x0a"
"template <class _ForwardIterator, class _Predicate, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"void\x0a"
"replace_if(_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred, const _Tp\x26 __new_value)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (__pred(*__first))\x0a"
"            *__first = __new_value;\x0a"
"}\x0a"
"\x0a"
"// replace_copy\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"replace_copy(_InputIterator __first, _InputIterator __last, _OutputIterator __result,\x0a"
"             const _Tp\x26 __old_value, const _Tp\x26 __new_value)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first, (void) ++__result)\x0a"
"        if (*__first == __old_value)\x0a"
"            *__result = __new_value;\x0a"
"        else\x0a"
"            *__result = *__first;\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"// replace_copy_if\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _Predicate, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"replace_copy_if(_InputIterator __first, _InputIterator __last, _OutputIterator __result,\x0a"
"                _Predicate __pred, const _Tp\x26 __new_value)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first, (void) ++__result)\x0a"
"        if (__pred(*__first))\x0a"
"            *__result = __new_value;\x0a"
"        else\x0a"
"            *__result = *__first;\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"// fill_n\x0a"
"\x0a"
"template <class _OutputIterator, class _Size, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"__fill_n(_OutputIterator __first, _Size __n, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    for (; __n > 0; ++__first, (void) --__n)\x0a"
"        *__first = __value_;\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _OutputIterator, class _Size, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"fill_n(_OutputIterator __first, _Size __n, const _Tp\x26 __value_)\x0a"
"{\x0a"
"   return _VSTD\x3a\x3a__fill_n(__first, __convert_to_integral(__n), __value_);\x0a"
"}\x0a"
"\x0a"
"// fill\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"void\x0a"
"__fill(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_, forward_iterator_tag)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        *__first = __value_;\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"void\x0a"
"__fill(_RandomAccessIterator __first, _RandomAccessIterator __last, const _Tp\x26 __value_, random_access_iterator_tag)\x0a"
"{\x0a"
"    _VSTD\x3a\x3a""fill_n(__first, __last - __first, __value_);\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"void\x0a"
"fill(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    _VSTD\x3a\x3a__fill(__first, __last, __value_, typename iterator_traits<_ForwardIterator>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"// generate\x0a"
"\x0a"
"template <class _ForwardIterator, class _Generator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"void\x0a"
"generate(_ForwardIterator __first, _ForwardIterator __last, _Generator __gen)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        *__first = __gen();\x0a"
"}\x0a"
"\x0a"
"// generate_n\x0a"
"\x0a"
"template <class _OutputIterator, class _Size, class _Generator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"generate_n(_OutputIterator __first, _Size __orig_n, _Generator __gen)\x0a"
"{\x0a"
"    typedef decltype(__convert_to_integral(__orig_n)) _IntegralSize;\x0a"
"    _IntegralSize __n = __orig_n;\x0a"
"    for (; __n > 0; ++__first, (void) --__n)\x0a"
"        *__first = __gen();\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"// remove\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT _LIBCPP_CONSTEXPR_AFTER_CXX17 _ForwardIterator\x0a"
"remove(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    __first = _VSTD\x3a\x3a""find(__first, __last, __value_);\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __i = __first;\x0a"
"        while (++__i \x21= __last)\x0a"
"        {\x0a"
"            if (\x21(*__i == __value_))\x0a"
"            {\x0a"
"                *__first = _VSTD\x3a\x3amove(*__i);\x0a"
"                ++__first;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"// remove_if\x0a"
"\x0a"
"template <class _ForwardIterator, class _Predicate>\x0a"
"_LIBCPP_NODISCARD_EXT _LIBCPP_CONSTEXPR_AFTER_CXX17 _ForwardIterator\x0a"
"remove_if(_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    __first = _VSTD\x3a\x3a""find_if<_ForwardIterator, typename add_lvalue_reference<_Predicate>\x3a\x3atype>\x0a"
"                           (__first, __last, __pred);\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __i = __first;\x0a"
"        while (++__i \x21= __last)\x0a"
"        {\x0a"
"            if (\x21__pred(*__i))\x0a"
"            {\x0a"
"                *__first = _VSTD\x3a\x3amove(*__i);\x0a"
"                ++__first;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"// remove_copy\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"remove_copy(_InputIterator __first, _InputIterator __last, _OutputIterator __result, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"    {\x0a"
"        if (\x21(*__first == __value_))\x0a"
"        {\x0a"
"            *__result = *__first;\x0a"
"            ++__result;\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"// remove_copy_if\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"remove_copy_if(_InputIterator __first, _InputIterator __last, _OutputIterator __result, _Predicate __pred)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"    {\x0a"
"        if (\x21__pred(*__first))\x0a"
"        {\x0a"
"            *__result = *__first;\x0a"
"            ++__result;\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"// unique\x0a"
"\x0a"
"template <class _ForwardIterator, class _BinaryPredicate>\x0a"
"_LIBCPP_NODISCARD_EXT _LIBCPP_CONSTEXPR_AFTER_CXX17 _ForwardIterator\x0a"
"unique(_ForwardIterator __first, _ForwardIterator __last, _BinaryPredicate __pred)\x0a"
"{\x0a"
"    __first = _VSTD\x3a\x3a""adjacent_find<_ForwardIterator, typename add_lvalue_reference<_BinaryPredicate>\x3a\x3atype>\x0a"
"                                 (__first, __last, __pred);\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        // ...  a  a  \x3f  ...\x0a"
"        //      f     i\x0a"
"        _ForwardIterator __i = __first;\x0a"
"        for (++__i; ++__i \x21= __last;)\x0a"
"            if (\x21__pred(*__first, *__i))\x0a"
"                *++__first = _VSTD\x3a\x3amove(*__i);\x0a"
"        ++__first;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator\x0a"
"unique(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type __v;\x0a"
"    return _VSTD\x3a\x3aunique(__first, __last, __equal_to<__v>());\x0a"
"}\x0a"
"\x0a"
"// unique_copy\x0a"
"\x0a"
"template <class _BinaryPredicate, class _InputIterator, class _OutputIterator>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _OutputIterator\x0a"
"__unique_copy(_InputIterator __first, _InputIterator __last, _OutputIterator __result, _BinaryPredicate __pred,\x0a"
"              input_iterator_tag, output_iterator_tag)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        typename iterator_traits<_InputIterator>\x3a\x3avalue_type __t(*__first);\x0a"
"        *__result = __t;\x0a"
"        ++__result;\x0a"
"        while (++__first \x21= __last)\x0a"
"        {\x0a"
"            if (\x21__pred(__t, *__first))\x0a"
"            {\x0a"
"                __t = *__first;\x0a"
"                *__result = __t;\x0a"
"                ++__result;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _BinaryPredicate, class _ForwardIterator, class _OutputIterator>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _OutputIterator\x0a"
"__unique_copy(_ForwardIterator __first, _ForwardIterator __last, _OutputIterator __result, _BinaryPredicate __pred,\x0a"
"              forward_iterator_tag, output_iterator_tag)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __i = __first;\x0a"
"        *__result = *__i;\x0a"
"        ++__result;\x0a"
"        while (++__first \x21= __last)\x0a"
"        {\x0a"
"            if (\x21__pred(*__i, *__first))\x0a"
"            {\x0a"
"                *__result = *__first;\x0a"
"                ++__result;\x0a"
"                __i = __first;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _BinaryPredicate, class _InputIterator, class _ForwardIterator>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _ForwardIterator\x0a"
"__unique_copy(_InputIterator __first, _InputIterator __last, _ForwardIterator __result, _BinaryPredicate __pred,\x0a"
"              input_iterator_tag, forward_iterator_tag)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        *__result = *__first;\x0a"
"        while (++__first \x21= __last)\x0a"
"            if (\x21__pred(*__result, *__first))\x0a"
"                *++__result = *__first;\x0a"
"        ++__result;\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator, class _BinaryPredicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"unique_copy(_InputIterator __first, _InputIterator __last, _OutputIterator __result, _BinaryPredicate __pred)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__unique_copy<typename add_lvalue_reference<_BinaryPredicate>\x3a\x3atype>\x0a"
"                              (__first, __last, __result, __pred,\x0a"
"                               typename iterator_traits<_InputIterator>\x3a\x3aiterator_category(),\x0a"
"                               typename iterator_traits<_OutputIterator>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"unique_copy(_InputIterator __first, _InputIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_InputIterator>\x3a\x3avalue_type __v;\x0a"
"    return _VSTD\x3a\x3aunique_copy(__first, __last, __result, __equal_to<__v>());\x0a"
"}\x0a"
"\x0a"
"// reverse\x0a"
"\x0a"
"template <class _BidirectionalIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"__reverse(_BidirectionalIterator __first, _BidirectionalIterator __last, bidirectional_iterator_tag)\x0a"
"{\x0a"
"    while (__first \x21= __last)\x0a"
"    {\x0a"
"        if (__first == --__last)\x0a"
"            break;\x0a"
"        _VSTD\x3a\x3aiter_swap(__first, __last);\x0a"
"        ++__first;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"__reverse(_RandomAccessIterator __first, _RandomAccessIterator __last, random_access_iterator_tag)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"        for (; __first < --__last; ++__first)\x0a"
"            _VSTD\x3a\x3aiter_swap(__first, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"reverse(_BidirectionalIterator __first, _BidirectionalIterator __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3a__reverse(__first, __last, typename iterator_traits<_BidirectionalIterator>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"// reverse_copy\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"reverse_copy(_BidirectionalIterator __first, _BidirectionalIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__result)\x0a"
"        *__result = *--__last;\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"// rotate\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"__rotate_left(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type value_type;\x0a"
"    value_type __tmp = _VSTD\x3a\x3amove(*__first);\x0a"
"    _ForwardIterator __lm1 = _VSTD\x3a\x3amove(_VSTD\x3a\x3anext(__first), __last, __first);\x0a"
"    *__lm1 = _VSTD\x3a\x3amove(__tmp);\x0a"
"    return __lm1;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator>\x0a"
"_BidirectionalIterator\x0a"
"__rotate_right(_BidirectionalIterator __first, _BidirectionalIterator __last)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type value_type;\x0a"
"    _BidirectionalIterator __lm1 = _VSTD\x3a\x3aprev(__last);\x0a"
"    value_type __tmp = _VSTD\x3a\x3amove(*__lm1);\x0a"
"    _BidirectionalIterator __fp1 = _VSTD\x3a\x3amove_backward(__first, __lm1, __last);\x0a"
"    *__first = _VSTD\x3a\x3amove(__tmp);\x0a"
"    return __fp1;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"__rotate_forward(_ForwardIterator __first, _ForwardIterator __middle, _ForwardIterator __last)\x0a"
"{\x0a"
"    _ForwardIterator __i = __middle;\x0a"
"    while (true)\x0a"
"    {\x0a"
"        swap(*__first, *__i);\x0a"
"        ++__first;\x0a"
"        if (++__i == __last)\x0a"
"            break;\x0a"
"        if (__first == __middle)\x0a"
"            __middle = __i;\x0a"
"    }\x0a"
"    _ForwardIterator __r = __first;\x0a"
"    if (__first \x21= __middle)\x0a"
"    {\x0a"
"        __i = __middle;\x0a"
"        while (true)\x0a"
"        {\x0a"
"            swap(*__first, *__i);\x0a"
"            ++__first;\x0a"
"            if (++__i == __last)\x0a"
"            {\x0a"
"                if (__first == __middle)\x0a"
"                    break;\x0a"
"                __i = __middle;\x0a"
"            }\x0a"
"            else if (__first == __middle)\x0a"
"                __middle = __i;\x0a"
"        }\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<typename _Integral>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Integral\x0a"
"__algo_gcd(_Integral __x, _Integral __y)\x0a"
"{\x0a"
"    do\x0a"
"    {\x0a"
"        _Integral __t = __x \x25 __y;\x0a"
"        __x = __y;\x0a"
"        __y = __t;\x0a"
"    } while (__y);\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"template<typename _RandomAccessIterator>\x0a"
"_RandomAccessIterator\x0a"
"__rotate_gcd(_RandomAccessIterator __first, _RandomAccessIterator __middle, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type value_type;\x0a"
"\x0a"
"    const difference_type __m1 = __middle - __first;\x0a"
"    const difference_type __m2 = __last - __middle;\x0a"
"    if (__m1 == __m2)\x0a"
"    {\x0a"
"        _VSTD\x3a\x3aswap_ranges(__first, __middle, __middle);\x0a"
"        return __middle;\x0a"
"    }\x0a"
"    const difference_type __g = _VSTD\x3a\x3a__algo_gcd(__m1, __m2);\x0a"
"    for (_RandomAccessIterator __p = __first + __g; __p \x21= __first;)\x0a"
"    {\x0a"
"        value_type __t(_VSTD\x3a\x3amove(*--__p));\x0a"
"        _RandomAccessIterator __p1 = __p;\x0a"
"        _RandomAccessIterator __p2 = __p1 + __m1;\x0a"
"        do\x0a"
"        {\x0a"
"            *__p1 = _VSTD\x3a\x3amove(*__p2);\x0a"
"            __p1 = __p2;\x0a"
"            const difference_type __d = __last - __p2;\x0a"
"            if (__m1 < __d)\x0a"
"                __p2 += __m1;\x0a"
"            else\x0a"
"                __p2 = __first + (__m1 - __d);\x0a"
"        } while (__p2 \x21= __p);\x0a"
"        *__p1 = _VSTD\x3a\x3amove(__t);\x0a"
"    }\x0a"
"    return __first + __m2;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_ForwardIterator\x0a"
"__rotate(_ForwardIterator __first, _ForwardIterator __middle, _ForwardIterator __last,\x0a"
"         _VSTD\x3a\x3a""forward_iterator_tag)\x0a"
"{\x0a"
"    typedef typename _VSTD\x3a\x3aiterator_traits<_ForwardIterator>\x3a\x3avalue_type value_type;\x0a"
"    if (_VSTD\x3a\x3ais_trivially_move_assignable<value_type>\x3a\x3avalue)\x0a"
"    {\x0a"
"        if (_VSTD\x3a\x3anext(__first) == __middle)\x0a"
"            return _VSTD\x3a\x3a__rotate_left(__first, __last);\x0a"
"    }\x0a"
"    return _VSTD\x3a\x3a__rotate_forward(__first, __middle, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_BidirectionalIterator\x0a"
"__rotate(_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last,\x0a"
"         _VSTD\x3a\x3a""bidirectional_iterator_tag)\x0a"
"{\x0a"
"    typedef typename _VSTD\x3a\x3aiterator_traits<_BidirectionalIterator>\x3a\x3avalue_type value_type;\x0a"
"    if (_VSTD\x3a\x3ais_trivially_move_assignable<value_type>\x3a\x3avalue)\x0a"
"    {\x0a"
"        if (_VSTD\x3a\x3anext(__first) == __middle)\x0a"
"            return _VSTD\x3a\x3a__rotate_left(__first, __last);\x0a"
"        if (_VSTD\x3a\x3anext(__middle) == __last)\x0a"
"            return _VSTD\x3a\x3a__rotate_right(__first, __last);\x0a"
"    }\x0a"
"    return _VSTD\x3a\x3a__rotate_forward(__first, __middle, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_RandomAccessIterator\x0a"
"__rotate(_RandomAccessIterator __first, _RandomAccessIterator __middle, _RandomAccessIterator __last,\x0a"
"         _VSTD\x3a\x3arandom_access_iterator_tag)\x0a"
"{\x0a"
"    typedef typename _VSTD\x3a\x3aiterator_traits<_RandomAccessIterator>\x3a\x3avalue_type value_type;\x0a"
"    if (_VSTD\x3a\x3ais_trivially_move_assignable<value_type>\x3a\x3avalue)\x0a"
"    {\x0a"
"        if (_VSTD\x3a\x3anext(__first) == __middle)\x0a"
"            return _VSTD\x3a\x3a__rotate_left(__first, __last);\x0a"
"        if (_VSTD\x3a\x3anext(__middle) == __last)\x0a"
"            return _VSTD\x3a\x3a__rotate_right(__first, __last);\x0a"
"        return _VSTD\x3a\x3a__rotate_gcd(__first, __middle, __last);\x0a"
"    }\x0a"
"    return _VSTD\x3a\x3a__rotate_forward(__first, __middle, __last);\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_ForwardIterator\x0a"
"rotate(_ForwardIterator __first, _ForwardIterator __middle, _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first == __middle)\x0a"
"        return __last;\x0a"
"    if (__middle == __last)\x0a"
"        return __first;\x0a"
"    return _VSTD\x3a\x3a__rotate(__first, __middle, __last,\x0a"
"                           typename _VSTD\x3a\x3aiterator_traits<_ForwardIterator>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"// rotate_copy\x0a"
"\x0a"
"template <class _ForwardIterator, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"rotate_copy(_ForwardIterator __first, _ForwardIterator __middle, _ForwardIterator __last, _OutputIterator __result)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""copy(__first, __middle, _VSTD\x3a\x3a""copy(__middle, __last, __result));\x0a"
"}\x0a"
"\x0a"
"// min_element\x0a"
"\x0a"
"template <class _ForwardIterator, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_ForwardIterator\x0a"
"min_element(_ForwardIterator __first, _ForwardIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    static_assert(__is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"        \x22std\x3a\x3amin_element requires a ForwardIterator\x22);\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __i = __first;\x0a"
"        while (++__i \x21= __last)\x0a"
"            if (__comp(*__i, *__first))\x0a"
"                __first = __i;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_ForwardIterator\x0a"
"min_element(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amin_element(__first, __last,\x0a"
"              __less<typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// min\x0a"
"\x0a"
"template <class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const _Tp\x26\x0a"
"min(const _Tp\x26 __a, const _Tp\x26 __b, _Compare __comp)\x0a"
"{\x0a"
"    return __comp(__b, __a) \x3f __b \x3a __a;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const _Tp\x26\x0a"
"min(const _Tp\x26 __a, const _Tp\x26 __b)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amin(__a, __b, __less<_Tp>());\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp\x0a"
"min(initializer_list<_Tp> __t, _Compare __comp)\x0a"
"{\x0a"
"    return *_VSTD\x3a\x3amin_element(__t.begin(), __t.end(), __comp);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp\x0a"
"min(initializer_list<_Tp> __t)\x0a"
"{\x0a"
"    return *_VSTD\x3a\x3amin_element(__t.begin(), __t.end(), __less<_Tp>());\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"// max_element\x0a"
"\x0a"
"template <class _ForwardIterator, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_ForwardIterator\x0a"
"max_element(_ForwardIterator __first, _ForwardIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    static_assert(__is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"        \x22std\x3a\x3amax_element requires a ForwardIterator\x22);\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __i = __first;\x0a"
"        while (++__i \x21= __last)\x0a"
"            if (__comp(*__first, *__i))\x0a"
"                __first = __i;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_ForwardIterator\x0a"
"max_element(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amax_element(__first, __last,\x0a"
"              __less<typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// max\x0a"
"\x0a"
"template <class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const _Tp\x26\x0a"
"max(const _Tp\x26 __a, const _Tp\x26 __b, _Compare __comp)\x0a"
"{\x0a"
"    return __comp(__a, __b) \x3f __b \x3a __a;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"const _Tp\x26\x0a"
"max(const _Tp\x26 __a, const _Tp\x26 __b)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amax(__a, __b, __less<_Tp>());\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp\x0a"
"max(initializer_list<_Tp> __t, _Compare __comp)\x0a"
"{\x0a"
"    return *_VSTD\x3a\x3amax_element(__t.begin(), __t.end(), __comp);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"_Tp\x0a"
"max(initializer_list<_Tp> __t)\x0a"
"{\x0a"
"    return *_VSTD\x3a\x3amax_element(__t.begin(), __t.end(), __less<_Tp>());\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"// clamp\x0a"
"template<class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"const _Tp\x26\x0a"
"clamp(const _Tp\x26 __v, const _Tp\x26 __lo, const _Tp\x26 __hi, _Compare __comp)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(\x21__comp(__hi, __lo), \x22""Bad bounds passed to std\x3a\x3a""clamp\x22);\x0a"
"    return __comp(__v, __lo) \x3f __lo \x3a __comp(__hi, __v) \x3f __hi \x3a __v;\x0a"
"\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"const _Tp\x26\x0a"
"clamp(const _Tp\x26 __v, const _Tp\x26 __lo, const _Tp\x26 __hi)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""clamp(__v, __lo, __hi, __less<_Tp>());\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"// minmax_element\x0a"
"\x0a"
"template <class _ForwardIterator, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"std\x3a\x3apair<_ForwardIterator, _ForwardIterator>\x0a"
"minmax_element(_ForwardIterator __first, _ForwardIterator __last, _Compare __comp)\x0a"
"{\x0a"
"  static_assert(__is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"        \x22std\x3a\x3aminmax_element requires a ForwardIterator\x22);\x0a"
"  std\x3a\x3apair<_ForwardIterator, _ForwardIterator> __result(__first, __first);\x0a"
"  if (__first \x21= __last)\x0a"
"  {\x0a"
"      if (++__first \x21= __last)\x0a"
"      {\x0a"
"          if (__comp(*__first, *__result.first))\x0a"
"              __result.first = __first;\x0a"
"          else\x0a"
"              __result.second = __first;\x0a"
"          while (++__first \x21= __last)\x0a"
"          {\x0a"
"              _ForwardIterator __i = __first;\x0a"
"              if (++__first == __last)\x0a"
"              {\x0a"
"                  if (__comp(*__i, *__result.first))\x0a"
"                      __result.first = __i;\x0a"
"                  else if (\x21__comp(*__i, *__result.second))\x0a"
"                      __result.second = __i;\x0a"
"                  break;\x0a"
"              }\x0a"
"              else\x0a"
"              {\x0a"
"                  if (__comp(*__first, *__i))\x0a"
"                  {\x0a"
"                      if (__comp(*__first, *__result.first))\x0a"
"                          __result.first = __first;\x0a"
"                      if (\x21__comp(*__i, *__result.second))\x0a"
"                          __result.second = __i;\x0a"
"                  }\x0a"
"                  else\x0a"
"                  {\x0a"
"                      if (__comp(*__i, *__result.first))\x0a"
"                          __result.first = __i;\x0a"
"                      if (\x21__comp(*__first, *__result.second))\x0a"
"                          __result.second = __first;\x0a"
"                  }\x0a"
"              }\x0a"
"          }\x0a"
"      }\x0a"
"  }\x0a"
"  return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"std\x3a\x3apair<_ForwardIterator, _ForwardIterator>\x0a"
"minmax_element(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aminmax_element(__first, __last,\x0a"
"              __less<typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// minmax\x0a"
"\x0a"
"template<class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"pair<const _Tp\x26, const _Tp\x26>\x0a"
"minmax(const _Tp\x26 __a, const _Tp\x26 __b, _Compare __comp)\x0a"
"{\x0a"
"    return __comp(__b, __a) \x3f pair<const _Tp\x26, const _Tp\x26>(__b, __a) \x3a\x0a"
"                              pair<const _Tp\x26, const _Tp\x26>(__a, __b);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"pair<const _Tp\x26, const _Tp\x26>\x0a"
"minmax(const _Tp\x26 __a, const _Tp\x26 __b)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aminmax(__a, __b, __less<_Tp>());\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"pair<_Tp, _Tp>\x0a"
"minmax(initializer_list<_Tp> __t, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename initializer_list<_Tp>\x3a\x3a""const_iterator _Iter;\x0a"
"    _Iter __first = __t.begin();\x0a"
"    _Iter __last  = __t.end();\x0a"
"    std\x3a\x3apair<_Tp, _Tp> __result(*__first, *__first);\x0a"
"\x0a"
"    ++__first;\x0a"
"    if (__t.size() \x25 2 == 0)\x0a"
"    {\x0a"
"        if (__comp(*__first,  __result.first))\x0a"
"            __result.first  = *__first;\x0a"
"        else\x0a"
"            __result.second = *__first;\x0a"
"        ++__first;\x0a"
"    }\x0a"
"\x0a"
"    while (__first \x21= __last)\x0a"
"    {\x0a"
"        _Tp __prev = *__first++;\x0a"
"        if (__comp(*__first, __prev)) {\x0a"
"            if ( __comp(*__first, __result.first)) __result.first  = *__first;\x0a"
"            if (\x21__comp(__prev, __result.second))  __result.second = __prev;\x0a"
"            }\x0a"
"        else {\x0a"
"            if ( __comp(__prev, __result.first))    __result.first  = __prev;\x0a"
"            if (\x21__comp(*__first, __result.second)) __result.second = *__first;\x0a"
"            }\x0a"
"\x0a"
"        __first++;\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX11\x0a"
"pair<_Tp, _Tp>\x0a"
"minmax(initializer_list<_Tp> __t)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aminmax(__t, __less<_Tp>());\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"// random_shuffle\x0a"
"\x0a"
"// __independent_bits_engine\x0a"
"\x0a"
"template <unsigned long long _Xp, size_t _Rp>\x0a"
"struct __log2_imp\x0a"
"{\x0a"
"    static const size_t value = _Xp \x26 ((unsigned long long)(1) << _Rp) \x3f _Rp\x0a"
"                                           \x3a __log2_imp<_Xp, _Rp - 1>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <unsigned long long _Xp>\x0a"
"struct __log2_imp<_Xp, 0>\x0a"
"{\x0a"
"    static const size_t value = 0;\x0a"
"};\x0a"
"\x0a"
"template <size_t _Rp>\x0a"
"struct __log2_imp<0, _Rp>\x0a"
"{\x0a"
"    static const size_t value = _Rp + 1;\x0a"
"};\x0a"
"\x0a"
"template <class _UIntType, _UIntType _Xp>\x0a"
"struct __log2\x0a"
"{\x0a"
"    static const size_t value = __log2_imp<_Xp,\x0a"
"                                         sizeof(_UIntType) * __CHAR_BIT__ - 1>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template<class _Engine, class _UIntType>\x0a"
"class __independent_bits_engine\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _UIntType result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef typename _Engine\x3a\x3aresult_type _Engine_result_type;\x0a"
"    typedef typename conditional\x0a"
"        <\x0a"
"            sizeof(_Engine_result_type) <= sizeof(result_type),\x0a"
"                result_type,\x0a"
"                _Engine_result_type\x0a"
"        >\x3a\x3atype _Working_result_type;\x0a"
"\x0a"
"    _Engine\x26 __e_;\x0a"
"    size_t __w_;\x0a"
"    size_t __w0_;\x0a"
"    size_t __n_;\x0a"
"    size_t __n0_;\x0a"
"    _Working_result_type __y0_;\x0a"
"    _Working_result_type __y1_;\x0a"
"    _Engine_result_type __mask0_;\x0a"
"    _Engine_result_type __mask1_;\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    static const _Working_result_type _Rp = _Engine\x3a\x3a_Max - _Engine\x3a\x3a_Min\x0a"
"                                          + _Working_result_type(1);\x0a"
"#else\x0a"
"    static _LIBCPP_CONSTEXPR const _Working_result_type _Rp = _Engine\x3a\x3amax() - _Engine\x3a\x3amin()\x0a"
"                                                      + _Working_result_type(1);\x0a"
"#endif\x0a"
"    static _LIBCPP_CONSTEXPR const size_t __m = __log2<_Working_result_type, _Rp>\x3a\x3avalue;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t _WDt = numeric_limits<_Working_result_type>\x3a\x3a""digits;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t _EDt = numeric_limits<_Engine_result_type>\x3a\x3a""digits;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructors and seeding functions\x0a"
"    __independent_bits_engine(_Engine\x26 __e, size_t __w);\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()() {return __eval(integral_constant<bool, _Rp \x21= 0>());}\x0a"
"\x0a"
"private\x3a\x0a"
"    result_type __eval(false_type);\x0a"
"    result_type __eval(true_type);\x0a"
"};\x0a"
"\x0a"
"template<class _Engine, class _UIntType>\x0a"
"__independent_bits_engine<_Engine, _UIntType>\x0a"
"    \x3a\x3a__independent_bits_engine(_Engine\x26 __e, size_t __w)\x0a"
"        \x3a __e_(__e),\x0a"
"          __w_(__w)\x0a"
"{\x0a"
"    __n_ = __w_ / __m + (__w_ \x25 __m \x21= 0);\x0a"
"    __w0_ = __w_ / __n_;\x0a"
"    if (_Rp == 0)\x0a"
"        __y0_ = _Rp;\x0a"
"    else if (__w0_ < _WDt)\x0a"
"        __y0_ = (_Rp >> __w0_) << __w0_;\x0a"
"    else\x0a"
"        __y0_ = 0;\x0a"
"    if (_Rp - __y0_ > __y0_ / __n_)\x0a"
"    {\x0a"
"        ++__n_;\x0a"
"        __w0_ = __w_ / __n_;\x0a"
"        if (__w0_ < _WDt)\x0a"
"            __y0_ = (_Rp >> __w0_) << __w0_;\x0a"
"        else\x0a"
"            __y0_ = 0;\x0a"
"    }\x0a"
"    __n0_ = __n_ - __w_ \x25 __n_;\x0a"
"    if (__w0_ < _WDt - 1)\x0a"
"        __y1_ = (_Rp >> (__w0_ + 1)) << (__w0_ + 1);\x0a"
"    else\x0a"
"        __y1_ = 0;\x0a"
"    __mask0_ = __w0_ > 0 \x3f _Engine_result_type(\x7e""0) >> (_EDt - __w0_) \x3a\x0a"
"                          _Engine_result_type(0);\x0a"
"    __mask1_ = __w0_ < _EDt - 1 \x3f\x0a"
"                               _Engine_result_type(\x7e""0) >> (_EDt - (__w0_ + 1)) \x3a\x0a"
"                               _Engine_result_type(\x7e""0);\x0a"
"}\x0a"
"\x0a"
"template<class _Engine, class _UIntType>\x0a"
"inline\x0a"
"_UIntType\x0a"
"__independent_bits_engine<_Engine, _UIntType>\x3a\x3a__eval(false_type)\x0a"
"{\x0a"
"    return static_cast<result_type>(__e_() \x26 __mask0_);\x0a"
"}\x0a"
"\x0a"
"template<class _Engine, class _UIntType>\x0a"
"_UIntType\x0a"
"__independent_bits_engine<_Engine, _UIntType>\x3a\x3a__eval(true_type)\x0a"
"{\x0a"
"    const size_t _WRt = numeric_limits<result_type>\x3a\x3a""digits;\x0a"
"    result_type _Sp = 0;\x0a"
"    for (size_t __k = 0; __k < __n0_; ++__k)\x0a"
"    {\x0a"
"        _Engine_result_type __u;\x0a"
"        do\x0a"
"        {\x0a"
"            __u = __e_() - _Engine\x3a\x3amin();\x0a"
"        } while (__u >= __y0_);\x0a"
"        if (__w0_ < _WRt)\x0a"
"            _Sp <<= __w0_;\x0a"
"        else\x0a"
"            _Sp = 0;\x0a"
"        _Sp += __u \x26 __mask0_;\x0a"
"    }\x0a"
"    for (size_t __k = __n0_; __k < __n_; ++__k)\x0a"
"    {\x0a"
"        _Engine_result_type __u;\x0a"
"        do\x0a"
"        {\x0a"
"            __u = __e_() - _Engine\x3a\x3amin();\x0a"
"        } while (__u >= __y1_);\x0a"
"        if (__w0_ < _WRt - 1)\x0a"
"            _Sp <<= __w0_ + 1;\x0a"
"        else\x0a"
"            _Sp = 0;\x0a"
"        _Sp += __u \x26 __mask1_;\x0a"
"    }\x0a"
"    return _Sp;\x0a"
"}\x0a"
"\x0a"
"// uniform_int_distribution\x0a"
"\x0a"
"template<class _IntType = int>\x0a"
"class uniform_int_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _IntType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"        result_type __a_;\x0a"
"        result_type __b_;\x0a"
"    public\x3a\x0a"
"        typedef uniform_int_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type __a = 0,\x0a"
"                            result_type __b = numeric_limits<result_type>\x3a\x3amax())\x0a"
"            \x3a __a_(__a), __b_(__b) {}\x0a"
"\x0a"
"        result_type a() const {return __a_;}\x0a"
"        result_type b() const {return __b_;}\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__a_ == __y.__a_ \x26\x26 __x.__b_ == __y.__b_;}\x0a"
"        friend bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructors and reset functions\x0a"
"    explicit uniform_int_distribution(result_type __a = 0,\x0a"
"                                      result_type __b = numeric_limits<result_type>\x3a\x3amax())\x0a"
"        \x3a __p_(param_type(__a, __b)) {}\x0a"
"    explicit uniform_int_distribution(const param_type\x26 __p) \x3a __p_(__p) {}\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type a() const {return __p_.a();}\x0a"
"    result_type b() const {return __p_.b();}\x0a"
"\x0a"
"    param_type param() const {return __p_;}\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    result_type min() const {return a();}\x0a"
"    result_type max() const {return b();}\x0a"
"\x0a"
"    friend bool operator==(const uniform_int_distribution\x26 __x,\x0a"
"                           const uniform_int_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend bool operator\x21=(const uniform_int_distribution\x26 __x,\x0a"
"                           const uniform_int_distribution\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template<class _IntType>\x0a"
"template<class _URNG>\x0a"
"typename uniform_int_distribution<_IntType>\x3a\x3aresult_type\x0a"
"uniform_int_distribution<_IntType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"_LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"{\x0a"
"    typedef typename conditional<sizeof(result_type) <= sizeof(uint32_t),\x0a"
"                                            uint32_t, uint64_t>\x3a\x3atype _UIntType;\x0a"
"    const _UIntType _Rp = _UIntType(__p.b()) - _UIntType(__p.a()) + _UIntType(1);\x0a"
"    if (_Rp == 1)\x0a"
"        return __p.a();\x0a"
"    const size_t _Dt = numeric_limits<_UIntType>\x3a\x3a""digits;\x0a"
"    typedef __independent_bits_engine<_URNG, _UIntType> _Eng;\x0a"
"    if (_Rp == 0)\x0a"
"        return static_cast<result_type>(_Eng(__g, _Dt)());\x0a"
"    size_t __w = _Dt - __libcpp_clz(_Rp) - 1;\x0a"
"    if ((_Rp \x26 (std\x3a\x3anumeric_limits<_UIntType>\x3a\x3amax() >> (_Dt - __w))) \x21= 0)\x0a"
"        ++__w;\x0a"
"    _Eng __e(__g, __w);\x0a"
"    _UIntType __u;\x0a"
"    do\x0a"
"    {\x0a"
"        __u = __e();\x0a"
"    } while (__u >= _Rp);\x0a"
"    return static_cast<result_type>(__u + __p.a());\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_RANDOM_SHUFFLE) \x5c\x0a"
"  \x7c\x7c defined(_LIBCPP_BUILDING_LIBRARY)\x0a"
"class _LIBCPP_TYPE_VIS __rs_default;\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS __rs_default __rs_get();\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS __rs_default\x0a"
"{\x0a"
"    static unsigned __c_;\x0a"
"\x0a"
"    __rs_default();\x0a"
"public\x3a\x0a"
"    typedef uint_fast32_t result_type;\x0a"
"\x0a"
"    static const result_type _Min = 0;\x0a"
"    static const result_type _Max = 0xFFFFFFFF;\x0a"
"\x0a"
"    __rs_default(const __rs_default\x26);\x0a"
"    \x7e__rs_default();\x0a"
"\x0a"
"    result_type operator()();\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR result_type min() {return _Min;}\x0a"
"    static _LIBCPP_CONSTEXPR result_type max() {return _Max;}\x0a"
"\x0a"
"    friend _LIBCPP_FUNC_VIS __rs_default __rs_get();\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS __rs_default __rs_get();\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX14 void\x0a"
"random_shuffle(_RandomAccessIterator __first, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef uniform_int_distribution<ptrdiff_t> _Dp;\x0a"
"    typedef typename _Dp\x3a\x3aparam_type _Pp;\x0a"
"    difference_type __d = __last - __first;\x0a"
"    if (__d > 1)\x0a"
"    {\x0a"
"        _Dp __uid;\x0a"
"        __rs_default __g = __rs_get();\x0a"
"        for (--__last, (void) --__d; __first < __last; ++__first, (void) --__d)\x0a"
"        {\x0a"
"            difference_type __i = __uid(__g, _Pp(0, __d));\x0a"
"            if (__i \x21= difference_type(0))\x0a"
"                swap(*__first, *(__first + __i));\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _RandomNumberGenerator>\x0a"
"_LIBCPP_DEPRECATED_IN_CXX14 void\x0a"
"random_shuffle(_RandomAccessIterator __first, _RandomAccessIterator __last,\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"               _RandomNumberGenerator\x26\x26 __rand)\x0a"
"#else\x0a"
"               _RandomNumberGenerator\x26 __rand)\x0a"
"#endif\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    difference_type __d = __last - __first;\x0a"
"    if (__d > 1)\x0a"
"    {\x0a"
"        for (--__last; __first < __last; ++__first, (void) --__d)\x0a"
"        {\x0a"
"            difference_type __i = __rand(__d);\x0a"
"            if (__i \x21= difference_type(0))\x0a"
"              swap(*__first, *(__first + __i));\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _PopulationIterator, class _SampleIterator, class _Distance,\x0a"
"          class _UniformRandomNumberGenerator>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_SampleIterator __sample(_PopulationIterator __first,\x0a"
"                         _PopulationIterator __last, _SampleIterator __output_iter,\x0a"
"                         _Distance __n,\x0a"
"                         _UniformRandomNumberGenerator \x26 __g,\x0a"
"                         input_iterator_tag) {\x0a"
"\x0a"
"  _Distance __k = 0;\x0a"
"  for (; __first \x21= __last \x26\x26 __k < __n; ++__first, (void)++__k)\x0a"
"    __output_iter\x5b__k\x5d = *__first;\x0a"
"  _Distance __sz = __k;\x0a"
"  for (; __first \x21= __last; ++__first, (void)++__k) {\x0a"
"    _Distance __r = _VSTD\x3a\x3auniform_int_distribution<_Distance>(0, __k)(__g);\x0a"
"    if (__r < __sz)\x0a"
"      __output_iter\x5b__r\x5d = *__first;\x0a"
"  }\x0a"
"  return __output_iter + _VSTD\x3a\x3amin(__n, __k);\x0a"
"}\x0a"
"\x0a"
"template <class _PopulationIterator, class _SampleIterator, class _Distance,\x0a"
"          class _UniformRandomNumberGenerator>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_SampleIterator __sample(_PopulationIterator __first,\x0a"
"                         _PopulationIterator __last, _SampleIterator __output_iter,\x0a"
"                         _Distance __n,\x0a"
"                         _UniformRandomNumberGenerator\x26 __g,\x0a"
"                         forward_iterator_tag) {\x0a"
"  _Distance __unsampled_sz = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"  for (__n = _VSTD\x3a\x3amin(__n, __unsampled_sz); __n \x21= 0; ++__first) {\x0a"
"    _Distance __r =\x0a"
"        _VSTD\x3a\x3auniform_int_distribution<_Distance>(0, --__unsampled_sz)(__g);\x0a"
"    if (__r < __n) {\x0a"
"      *__output_iter++ = *__first;\x0a"
"      --__n;\x0a"
"    }\x0a"
"  }\x0a"
"  return __output_iter;\x0a"
"}\x0a"
"\x0a"
"template <class _PopulationIterator, class _SampleIterator, class _Distance,\x0a"
"          class _UniformRandomNumberGenerator>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_SampleIterator __sample(_PopulationIterator __first,\x0a"
"                         _PopulationIterator __last, _SampleIterator __output_iter,\x0a"
"                         _Distance __n, _UniformRandomNumberGenerator\x26 __g) {\x0a"
"  typedef typename iterator_traits<_PopulationIterator>\x3a\x3aiterator_category\x0a"
"        _PopCategory;\x0a"
"  typedef typename iterator_traits<_PopulationIterator>\x3a\x3a""difference_type\x0a"
"        _Difference;\x0a"
"  static_assert(__is_forward_iterator<_PopulationIterator>\x3a\x3avalue \x7c\x7c\x0a"
"                __is_random_access_iterator<_SampleIterator>\x3a\x3avalue,\x0a"
"                \x22SampleIterator must meet the requirements of RandomAccessIterator\x22);\x0a"
"  typedef typename common_type<_Distance, _Difference>\x3a\x3atype _CommonType;\x0a"
"  _LIBCPP_ASSERT(__n >= 0, \x22N must be a positive number.\x22);\x0a"
"  return _VSTD\x3a\x3a__sample(\x0a"
"      __first, __last, __output_iter, _CommonType(__n),\x0a"
"      __g, _PopCategory());\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _PopulationIterator, class _SampleIterator, class _Distance,\x0a"
"          class _UniformRandomNumberGenerator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_SampleIterator sample(_PopulationIterator __first,\x0a"
"                       _PopulationIterator __last, _SampleIterator __output_iter,\x0a"
"                       _Distance __n, _UniformRandomNumberGenerator\x26\x26 __g) {\x0a"
"    return _VSTD\x3a\x3a__sample(__first, __last, __output_iter, __n, __g);\x0a"
"}\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"template<class _RandomAccessIterator, class _UniformRandomNumberGenerator>\x0a"
"    void shuffle(_RandomAccessIterator __first, _RandomAccessIterator __last,\x0a"
"                 _UniformRandomNumberGenerator\x26\x26 __g)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef uniform_int_distribution<ptrdiff_t> _Dp;\x0a"
"    typedef typename _Dp\x3a\x3aparam_type _Pp;\x0a"
"    difference_type __d = __last - __first;\x0a"
"    if (__d > 1)\x0a"
"    {\x0a"
"        _Dp __uid;\x0a"
"        for (--__last, --__d; __first < __last; ++__first, --__d)\x0a"
"        {\x0a"
"            difference_type __i = __uid(__g, _Pp(0, __d));\x0a"
"            if (__i \x21= difference_type(0))\x0a"
"                swap(*__first, *(__first + __i));\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _Predicate>\x0a"
"_LIBCPP_NODISCARD_EXT _LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"is_partitioned(_InputIterator __first, _InputIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (\x21__pred(*__first))\x0a"
"            break;\x0a"
"    if ( __first == __last )\x0a"
"        return true;\x0a"
"    ++__first;\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        if (__pred(*__first))\x0a"
"            return false;\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"// partition\x0a"
"\x0a"
"template <class _Predicate, class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"__partition(_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred, forward_iterator_tag)\x0a"
"{\x0a"
"    while (true)\x0a"
"    {\x0a"
"        if (__first == __last)\x0a"
"            return __first;\x0a"
"        if (\x21__pred(*__first))\x0a"
"            break;\x0a"
"        ++__first;\x0a"
"    }\x0a"
"    for (_ForwardIterator __p = __first; ++__p \x21= __last;)\x0a"
"    {\x0a"
"        if (__pred(*__p))\x0a"
"        {\x0a"
"            swap(*__first, *__p);\x0a"
"            ++__first;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _Predicate, class _BidirectionalIterator>\x0a"
"_BidirectionalIterator\x0a"
"__partition(_BidirectionalIterator __first, _BidirectionalIterator __last, _Predicate __pred,\x0a"
"            bidirectional_iterator_tag)\x0a"
"{\x0a"
"    while (true)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            if (__first == __last)\x0a"
"                return __first;\x0a"
"            if (\x21__pred(*__first))\x0a"
"                break;\x0a"
"            ++__first;\x0a"
"        }\x0a"
"        do\x0a"
"        {\x0a"
"            if (__first == --__last)\x0a"
"                return __first;\x0a"
"        } while (\x21__pred(*__last));\x0a"
"        swap(*__first, *__last);\x0a"
"        ++__first;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_ForwardIterator\x0a"
"partition(_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__partition<typename add_lvalue_reference<_Predicate>\x3a\x3atype>\x0a"
"                            (__first, __last, __pred, typename iterator_traits<_ForwardIterator>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"// partition_copy\x0a"
"\x0a"
"template <class _InputIterator, class _OutputIterator1,\x0a"
"          class _OutputIterator2, class _Predicate>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 pair<_OutputIterator1, _OutputIterator2>\x0a"
"partition_copy(_InputIterator __first, _InputIterator __last,\x0a"
"               _OutputIterator1 __out_true, _OutputIterator2 __out_false,\x0a"
"               _Predicate __pred)\x0a"
"{\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"    {\x0a"
"        if (__pred(*__first))\x0a"
"        {\x0a"
"            *__out_true = *__first;\x0a"
"            ++__out_true;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            *__out_false = *__first;\x0a"
"            ++__out_false;\x0a"
"        }\x0a"
"    }\x0a"
"    return pair<_OutputIterator1, _OutputIterator2>(__out_true, __out_false);\x0a"
"}\x0a"
"\x0a"
"// partition_point\x0a"
"\x0a"
"template<class _ForwardIterator, class _Predicate>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _ForwardIterator\x0a"
"partition_point(_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    difference_type __len = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    while (__len \x21= 0)\x0a"
"    {\x0a"
"        difference_type __l2 = _VSTD\x3a\x3a__half_positive(__len);\x0a"
"        _ForwardIterator __m = __first;\x0a"
"        _VSTD\x3a\x3a""advance(__m, __l2);\x0a"
"        if (__pred(*__m))\x0a"
"        {\x0a"
"            __first = ++__m;\x0a"
"            __len -= __l2 + 1;\x0a"
"        }\x0a"
"        else\x0a"
"            __len = __l2;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"// stable_partition\x0a"
"\x0a"
"template <class _Predicate, class _ForwardIterator, class _Distance, class _Pair>\x0a"
"_ForwardIterator\x0a"
"__stable_partition(_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred,\x0a"
"                   _Distance __len, _Pair __p, forward_iterator_tag __fit)\x0a"
"{\x0a"
"    // *__first is known to be false\x0a"
"    // __len >= 1\x0a"
"    if (__len == 1)\x0a"
"        return __first;\x0a"
"    if (__len == 2)\x0a"
"    {\x0a"
"        _ForwardIterator __m = __first;\x0a"
"        if (__pred(*++__m))\x0a"
"        {\x0a"
"            swap(*__first, *__m);\x0a"
"            return __m;\x0a"
"        }\x0a"
"        return __first;\x0a"
"    }\x0a"
"    if (__len <= __p.second)\x0a"
"    {   // The buffer is big enough to use\x0a"
"        typedef typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type value_type;\x0a"
"        __destruct_n __d(0);\x0a"
"        unique_ptr<value_type, __destruct_n\x26> __h(__p.first, __d);\x0a"
"        // Move the falses into the temporary buffer, and the trues to the front of the line\x0a"
"        // Update __first to always point to the end of the trues\x0a"
"        value_type* __t = __p.first;\x0a"
"        \x3a\x3anew(__t) value_type(_VSTD\x3a\x3amove(*__first));\x0a"
"        __d.__incr((value_type*)0);\x0a"
"        ++__t;\x0a"
"        _ForwardIterator __i = __first;\x0a"
"        while (++__i \x21= __last)\x0a"
"        {\x0a"
"            if (__pred(*__i))\x0a"
"            {\x0a"
"                *__first = _VSTD\x3a\x3amove(*__i);\x0a"
"                ++__first;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                \x3a\x3anew(__t) value_type(_VSTD\x3a\x3amove(*__i));\x0a"
"                __d.__incr((value_type*)0);\x0a"
"                ++__t;\x0a"
"            }\x0a"
"        }\x0a"
"        // All trues now at start of range, all falses in buffer\x0a"
"        // Move falses back into range, but don't mess up __first which points to first false\x0a"
"        __i = __first;\x0a"
"        for (value_type* __t2 = __p.first; __t2 < __t; ++__t2, ++__i)\x0a"
"            *__i = _VSTD\x3a\x3amove(*__t2);\x0a"
"        // __h destructs moved-from values out of the temp buffer, but doesn't deallocate buffer\x0a"
"        return __first;\x0a"
"    }\x0a"
"    // Else not enough buffer, do in place\x0a"
"    // __len >= 3\x0a"
"    _ForwardIterator __m = __first;\x0a"
"    _Distance __len2 = __len / 2;  // __len2 >= 2\x0a"
"    _VSTD\x3a\x3a""advance(__m, __len2);\x0a"
"    // recurse on \x5b__first, __m), *__first know to be false\x0a"
"    // F\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x0a"
"    // f       m         l\x0a"
"    typedef typename add_lvalue_reference<_Predicate>\x3a\x3atype _PredRef;\x0a"
"    _ForwardIterator __first_false = __stable_partition<_PredRef>(__first, __m, __pred, __len2, __p, __fit);\x0a"
"    // TTTFFFFF\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x0a"
"    // f  ff   m         l\x0a"
"    // recurse on \x5b__m, __last\x5d, except increase __m until *(__m) is false, *__last know to be true\x0a"
"    _ForwardIterator __m1 = __m;\x0a"
"    _ForwardIterator __second_false = __last;\x0a"
"    _Distance __len_half = __len - __len2;\x0a"
"    while (__pred(*__m1))\x0a"
"    {\x0a"
"        if (++__m1 == __last)\x0a"
"            goto __second_half_done;\x0a"
"        --__len_half;\x0a"
"    }\x0a"
"    // TTTFFFFFTTTF\x3f\x3f\x3f\x3f\x3f\x3f\x0a"
"    // f  ff   m  m1     l\x0a"
"    __second_false = __stable_partition<_PredRef>(__m1, __last, __pred, __len_half, __p, __fit);\x0a"
"__second_half_done\x3a\x0a"
"    // TTTFFFFFTTTTTFFFFF\x0a"
"    // f  ff   m    sf   l\x0a"
"    return _VSTD\x3a\x3arotate(__first_false, __m, __second_false);\x0a"
"    // TTTTTTTTFFFFFFFFFF\x0a"
"    //         \x7c\x0a"
"}\x0a"
"\x0a"
"struct __return_temporary_buffer\x0a"
"{\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY void operator()(_Tp* __p) const {_VSTD\x3a\x3areturn_temporary_buffer(__p);}\x0a"
"};\x0a"
"\x0a"
"template <class _Predicate, class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"__stable_partition(_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred,\x0a"
"                   forward_iterator_tag)\x0a"
"{\x0a"
"    const unsigned __alloc_limit = 3;  // might want to make this a function of trivial assignment\x0a"
"    // Either prove all true and return __first or point to first false\x0a"
"    while (true)\x0a"
"    {\x0a"
"        if (__first == __last)\x0a"
"            return __first;\x0a"
"        if (\x21__pred(*__first))\x0a"
"            break;\x0a"
"        ++__first;\x0a"
"    }\x0a"
"    // We now have a reduced range \x5b__first, __last)\x0a"
"    // *__first is known to be false\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type value_type;\x0a"
"    difference_type __len = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    pair<value_type*, ptrdiff_t> __p(0, 0);\x0a"
"    unique_ptr<value_type, __return_temporary_buffer> __h;\x0a"
"    if (__len >= __alloc_limit)\x0a"
"    {\x0a"
"        __p = _VSTD\x3a\x3aget_temporary_buffer<value_type>(__len);\x0a"
"        __h.reset(__p.first);\x0a"
"    }\x0a"
"    return __stable_partition<typename add_lvalue_reference<_Predicate>\x3a\x3atype>\x0a"
"                             (__first, __last, __pred, __len, __p, forward_iterator_tag());\x0a"
"}\x0a"
"\x0a"
"template <class _Predicate, class _BidirectionalIterator, class _Distance, class _Pair>\x0a"
"_BidirectionalIterator\x0a"
"__stable_partition(_BidirectionalIterator __first, _BidirectionalIterator __last, _Predicate __pred,\x0a"
"                   _Distance __len, _Pair __p, bidirectional_iterator_tag __bit)\x0a"
"{\x0a"
"    // *__first is known to be false\x0a"
"    // *__last is known to be true\x0a"
"    // __len >= 2\x0a"
"    if (__len == 2)\x0a"
"    {\x0a"
"        swap(*__first, *__last);\x0a"
"        return __last;\x0a"
"    }\x0a"
"    if (__len == 3)\x0a"
"    {\x0a"
"        _BidirectionalIterator __m = __first;\x0a"
"        if (__pred(*++__m))\x0a"
"        {\x0a"
"            swap(*__first, *__m);\x0a"
"            swap(*__m, *__last);\x0a"
"            return __last;\x0a"
"        }\x0a"
"        swap(*__m, *__last);\x0a"
"        swap(*__first, *__m);\x0a"
"        return __m;\x0a"
"    }\x0a"
"    if (__len <= __p.second)\x0a"
"    {   // The buffer is big enough to use\x0a"
"        typedef typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type value_type;\x0a"
"        __destruct_n __d(0);\x0a"
"        unique_ptr<value_type, __destruct_n\x26> __h(__p.first, __d);\x0a"
"        // Move the falses into the temporary buffer, and the trues to the front of the line\x0a"
"        // Update __first to always point to the end of the trues\x0a"
"        value_type* __t = __p.first;\x0a"
"        \x3a\x3anew(__t) value_type(_VSTD\x3a\x3amove(*__first));\x0a"
"        __d.__incr((value_type*)0);\x0a"
"        ++__t;\x0a"
"        _BidirectionalIterator __i = __first;\x0a"
"        while (++__i \x21= __last)\x0a"
"        {\x0a"
"            if (__pred(*__i))\x0a"
"            {\x0a"
"                *__first = _VSTD\x3a\x3amove(*__i);\x0a"
"                ++__first;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                \x3a\x3anew(__t) value_type(_VSTD\x3a\x3amove(*__i));\x0a"
"                __d.__incr((value_type*)0);\x0a"
"                ++__t;\x0a"
"            }\x0a"
"        }\x0a"
"        // move *__last, known to be true\x0a"
"        *__first = _VSTD\x3a\x3amove(*__i);\x0a"
"        __i = ++__first;\x0a"
"        // All trues now at start of range, all falses in buffer\x0a"
"        // Move falses back into range, but don't mess up __first which points to first false\x0a"
"        for (value_type* __t2 = __p.first; __t2 < __t; ++__t2, ++__i)\x0a"
"            *__i = _VSTD\x3a\x3amove(*__t2);\x0a"
"        // __h destructs moved-from values out of the temp buffer, but doesn't deallocate buffer\x0a"
"        return __first;\x0a"
"    }\x0a"
"    // Else not enough buffer, do in place\x0a"
"    // __len >= 4\x0a"
"    _BidirectionalIterator __m = __first;\x0a"
"    _Distance __len2 = __len / 2;  // __len2 >= 2\x0a"
"    _VSTD\x3a\x3a""advance(__m, __len2);\x0a"
"    // recurse on \x5b__first, __m-1\x5d, except reduce __m-1 until *(__m-1) is true, *__first know to be false\x0a"
"    // F\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3fT\x0a"
"    // f       m        l\x0a"
"    _BidirectionalIterator __m1 = __m;\x0a"
"    _BidirectionalIterator __first_false = __first;\x0a"
"    _Distance __len_half = __len2;\x0a"
"    while (\x21__pred(*--__m1))\x0a"
"    {\x0a"
"        if (__m1 == __first)\x0a"
"            goto __first_half_done;\x0a"
"        --__len_half;\x0a"
"    }\x0a"
"    // F\x3f\x3f\x3fTFFF\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3fT\x0a"
"    // f   m1  m        l\x0a"
"    typedef typename add_lvalue_reference<_Predicate>\x3a\x3atype _PredRef;\x0a"
"    __first_false = __stable_partition<_PredRef>(__first, __m1, __pred, __len_half, __p, __bit);\x0a"
"__first_half_done\x3a\x0a"
"    // TTTFFFFF\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3f\x3fT\x0a"
"    // f  ff   m        l\x0a"
"    // recurse on \x5b__m, __last\x5d, except increase __m until *(__m) is false, *__last know to be true\x0a"
"    __m1 = __m;\x0a"
"    _BidirectionalIterator __second_false = __last;\x0a"
"    ++__second_false;\x0a"
"    __len_half = __len - __len2;\x0a"
"    while (__pred(*__m1))\x0a"
"    {\x0a"
"        if (++__m1 == __last)\x0a"
"            goto __second_half_done;\x0a"
"        --__len_half;\x0a"
"    }\x0a"
"    // TTTFFFFFTTTF\x3f\x3f\x3f\x3f\x3fT\x0a"
"    // f  ff   m  m1    l\x0a"
"    __second_false = __stable_partition<_PredRef>(__m1, __last, __pred, __len_half, __p, __bit);\x0a"
"__second_half_done\x3a\x0a"
"    // TTTFFFFFTTTTTFFFFF\x0a"
"    // f  ff   m    sf  l\x0a"
"    return _VSTD\x3a\x3arotate(__first_false, __m, __second_false);\x0a"
"    // TTTTTTTTFFFFFFFFFF\x0a"
"    //         \x7c\x0a"
"}\x0a"
"\x0a"
"template <class _Predicate, class _BidirectionalIterator>\x0a"
"_BidirectionalIterator\x0a"
"__stable_partition(_BidirectionalIterator __first, _BidirectionalIterator __last, _Predicate __pred,\x0a"
"                   bidirectional_iterator_tag)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_BidirectionalIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type value_type;\x0a"
"    const difference_type __alloc_limit = 4;  // might want to make this a function of trivial assignment\x0a"
"    // Either prove all true and return __first or point to first false\x0a"
"    while (true)\x0a"
"    {\x0a"
"        if (__first == __last)\x0a"
"            return __first;\x0a"
"        if (\x21__pred(*__first))\x0a"
"            break;\x0a"
"        ++__first;\x0a"
"    }\x0a"
"    // __first points to first false, everything prior to __first is already set.\x0a"
"    // Either prove \x5b__first, __last) is all false and return __first, or point __last to last true\x0a"
"    do\x0a"
"    {\x0a"
"        if (__first == --__last)\x0a"
"            return __first;\x0a"
"    } while (\x21__pred(*__last));\x0a"
"    // We now have a reduced range \x5b__first, __last\x5d\x0a"
"    // *__first is known to be false\x0a"
"    // *__last is known to be true\x0a"
"    // __len >= 2\x0a"
"    difference_type __len = _VSTD\x3a\x3a""distance(__first, __last) + 1;\x0a"
"    pair<value_type*, ptrdiff_t> __p(0, 0);\x0a"
"    unique_ptr<value_type, __return_temporary_buffer> __h;\x0a"
"    if (__len >= __alloc_limit)\x0a"
"    {\x0a"
"        __p = _VSTD\x3a\x3aget_temporary_buffer<value_type>(__len);\x0a"
"        __h.reset(__p.first);\x0a"
"    }\x0a"
"    return __stable_partition<typename add_lvalue_reference<_Predicate>\x3a\x3atype>\x0a"
"                             (__first, __last, __pred, __len, __p, bidirectional_iterator_tag());\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_ForwardIterator\x0a"
"stable_partition(_ForwardIterator __first, _ForwardIterator __last, _Predicate __pred)\x0a"
"{\x0a"
"    return __stable_partition<typename add_lvalue_reference<_Predicate>\x3a\x3atype>\x0a"
"                             (__first, __last, __pred, typename iterator_traits<_ForwardIterator>\x3a\x3aiterator_category());\x0a"
"}\x0a"
"\x0a"
"// is_sorted_until\x0a"
"\x0a"
"template <class _ForwardIterator, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT _LIBCPP_CONSTEXPR_AFTER_CXX17 _ForwardIterator\x0a"
"is_sorted_until(_ForwardIterator __first, _ForwardIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __i = __first;\x0a"
"        while (++__i \x21= __last)\x0a"
"        {\x0a"
"            if (__comp(*__i, *__first))\x0a"
"                return __i;\x0a"
"            __first = __i;\x0a"
"        }\x0a"
"    }\x0a"
"    return __last;\x0a"
"}\x0a"
"\x0a"
"template<class _ForwardIterator>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator\x0a"
"is_sorted_until(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3ais_sorted_until(__first, __last, __less<typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// is_sorted\x0a"
"\x0a"
"template <class _ForwardIterator, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"is_sorted(_ForwardIterator __first, _ForwardIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3ais_sorted_until(__first, __last, __comp) == __last;\x0a"
"}\x0a"
"\x0a"
"template<class _ForwardIterator>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"is_sorted(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3ais_sorted(__first, __last, __less<typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// sort\x0a"
"\x0a"
"// stable, 2-3 compares, 0-2 swaps\x0a"
"\x0a"
"template <class _Compare, class _ForwardIterator>\x0a"
"unsigned\x0a"
"__sort3(_ForwardIterator __x, _ForwardIterator __y, _ForwardIterator __z, _Compare __c)\x0a"
"{\x0a"
"    unsigned __r = 0;\x0a"
"    if (\x21__c(*__y, *__x))          // if x <= y\x0a"
"    {\x0a"
"        if (\x21__c(*__z, *__y))      // if y <= z\x0a"
"            return __r;            // x <= y \x26\x26 y <= z\x0a"
"                                   // x <= y \x26\x26 y > z\x0a"
"        swap(*__y, *__z);          // x <= z \x26\x26 y < z\x0a"
"        __r = 1;\x0a"
"        if (__c(*__y, *__x))       // if x > y\x0a"
"        {\x0a"
"            swap(*__x, *__y);      // x < y \x26\x26 y <= z\x0a"
"            __r = 2;\x0a"
"        }\x0a"
"        return __r;                // x <= y \x26\x26 y < z\x0a"
"    }\x0a"
"    if (__c(*__z, *__y))           // x > y, if y > z\x0a"
"    {\x0a"
"        swap(*__x, *__z);          // x < y \x26\x26 y < z\x0a"
"        __r = 1;\x0a"
"        return __r;\x0a"
"    }\x0a"
"    swap(*__x, *__y);              // x > y \x26\x26 y <= z\x0a"
"    __r = 1;                       // x < y \x26\x26 x <= z\x0a"
"    if (__c(*__z, *__y))           // if y > z\x0a"
"    {\x0a"
"        swap(*__y, *__z);          // x <= y \x26\x26 y < z\x0a"
"        __r = 2;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}                                  // x <= y \x26\x26 y <= z\x0a"
"\x0a"
"// stable, 3-6 compares, 0-5 swaps\x0a"
"\x0a"
"template <class _Compare, class _ForwardIterator>\x0a"
"unsigned\x0a"
"__sort4(_ForwardIterator __x1, _ForwardIterator __x2, _ForwardIterator __x3,\x0a"
"            _ForwardIterator __x4, _Compare __c)\x0a"
"{\x0a"
"    unsigned __r = __sort3<_Compare>(__x1, __x2, __x3, __c);\x0a"
"    if (__c(*__x4, *__x3))\x0a"
"    {\x0a"
"        swap(*__x3, *__x4);\x0a"
"        ++__r;\x0a"
"        if (__c(*__x3, *__x2))\x0a"
"        {\x0a"
"            swap(*__x2, *__x3);\x0a"
"            ++__r;\x0a"
"            if (__c(*__x2, *__x1))\x0a"
"            {\x0a"
"                swap(*__x1, *__x2);\x0a"
"                ++__r;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// stable, 4-10 compares, 0-9 swaps\x0a"
"\x0a"
"template <class _Compare, class _ForwardIterator>\x0a"
"_LIBCPP_HIDDEN\x0a"
"unsigned\x0a"
"__sort5(_ForwardIterator __x1, _ForwardIterator __x2, _ForwardIterator __x3,\x0a"
"            _ForwardIterator __x4, _ForwardIterator __x5, _Compare __c)\x0a"
"{\x0a"
"    unsigned __r = __sort4<_Compare>(__x1, __x2, __x3, __x4, __c);\x0a"
"    if (__c(*__x5, *__x4))\x0a"
"    {\x0a"
"        swap(*__x4, *__x5);\x0a"
"        ++__r;\x0a"
"        if (__c(*__x4, *__x3))\x0a"
"        {\x0a"
"            swap(*__x3, *__x4);\x0a"
"            ++__r;\x0a"
"            if (__c(*__x3, *__x2))\x0a"
"            {\x0a"
"                swap(*__x2, *__x3);\x0a"
"                ++__r;\x0a"
"                if (__c(*__x2, *__x1))\x0a"
"                {\x0a"
"                    swap(*__x1, *__x2);\x0a"
"                    ++__r;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// Assumes size > 0\x0a"
"template <class _Compare, class _BirdirectionalIterator>\x0a"
"void\x0a"
"__selection_sort(_BirdirectionalIterator __first, _BirdirectionalIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    _BirdirectionalIterator __lm1 = __last;\x0a"
"    for (--__lm1; __first \x21= __lm1; ++__first)\x0a"
"    {\x0a"
"        _BirdirectionalIterator __i = _VSTD\x3a\x3amin_element<_BirdirectionalIterator,\x0a"
"                                                        typename add_lvalue_reference<_Compare>\x3a\x3atype>\x0a"
"                                                       (__first, __last, __comp);\x0a"
"        if (__i \x21= __first)\x0a"
"            swap(*__first, *__i);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Compare, class _BirdirectionalIterator>\x0a"
"void\x0a"
"__insertion_sort(_BirdirectionalIterator __first, _BirdirectionalIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_BirdirectionalIterator>\x3a\x3avalue_type value_type;\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _BirdirectionalIterator __i = __first;\x0a"
"        for (++__i; __i \x21= __last; ++__i)\x0a"
"        {\x0a"
"            _BirdirectionalIterator __j = __i;\x0a"
"            value_type __t(_VSTD\x3a\x3amove(*__j));\x0a"
"            for (_BirdirectionalIterator __k = __i; __k \x21= __first \x26\x26 __comp(__t,  *--__k); --__j)\x0a"
"                *__j = _VSTD\x3a\x3amove(*__k);\x0a"
"            *__j = _VSTD\x3a\x3amove(__t);\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__insertion_sort_3(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type value_type;\x0a"
"    _RandomAccessIterator __j = __first+2;\x0a"
"    __sort3<_Compare>(__first, __first+1, __j, __comp);\x0a"
"    for (_RandomAccessIterator __i = __j+1; __i \x21= __last; ++__i)\x0a"
"    {\x0a"
"        if (__comp(*__i, *__j))\x0a"
"        {\x0a"
"            value_type __t(_VSTD\x3a\x3amove(*__i));\x0a"
"            _RandomAccessIterator __k = __j;\x0a"
"            __j = __i;\x0a"
"            do\x0a"
"            {\x0a"
"                *__j = _VSTD\x3a\x3amove(*__k);\x0a"
"                __j = __k;\x0a"
"            } while (__j \x21= __first \x26\x26 __comp(__t, *--__k));\x0a"
"            *__j = _VSTD\x3a\x3amove(__t);\x0a"
"        }\x0a"
"        __j = __i;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"bool\x0a"
"__insertion_sort_incomplete(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    switch (__last - __first)\x0a"
"    {\x0a"
"    case 0\x3a\x0a"
"    case 1\x3a\x0a"
"        return true;\x0a"
"    case 2\x3a\x0a"
"        if (__comp(*--__last, *__first))\x0a"
"            swap(*__first, *__last);\x0a"
"        return true;\x0a"
"    case 3\x3a\x0a"
"        _VSTD\x3a\x3a__sort3<_Compare>(__first, __first+1, --__last, __comp);\x0a"
"        return true;\x0a"
"    case 4\x3a\x0a"
"        _VSTD\x3a\x3a__sort4<_Compare>(__first, __first+1, __first+2, --__last, __comp);\x0a"
"        return true;\x0a"
"    case 5\x3a\x0a"
"        _VSTD\x3a\x3a__sort5<_Compare>(__first, __first+1, __first+2, __first+3, --__last, __comp);\x0a"
"        return true;\x0a"
"    }\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type value_type;\x0a"
"    _RandomAccessIterator __j = __first+2;\x0a"
"    __sort3<_Compare>(__first, __first+1, __j, __comp);\x0a"
"    const unsigned __limit = 8;\x0a"
"    unsigned __count = 0;\x0a"
"    for (_RandomAccessIterator __i = __j+1; __i \x21= __last; ++__i)\x0a"
"    {\x0a"
"        if (__comp(*__i, *__j))\x0a"
"        {\x0a"
"            value_type __t(_VSTD\x3a\x3amove(*__i));\x0a"
"            _RandomAccessIterator __k = __j;\x0a"
"            __j = __i;\x0a"
"            do\x0a"
"            {\x0a"
"                *__j = _VSTD\x3a\x3amove(*__k);\x0a"
"                __j = __k;\x0a"
"            } while (__j \x21= __first \x26\x26 __comp(__t, *--__k));\x0a"
"            *__j = _VSTD\x3a\x3amove(__t);\x0a"
"            if (++__count == __limit)\x0a"
"                return ++__i == __last;\x0a"
"        }\x0a"
"        __j = __i;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Compare, class _BirdirectionalIterator>\x0a"
"void\x0a"
"__insertion_sort_move(_BirdirectionalIterator __first1, _BirdirectionalIterator __last1,\x0a"
"                      typename iterator_traits<_BirdirectionalIterator>\x3a\x3avalue_type* __first2, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_BirdirectionalIterator>\x3a\x3avalue_type value_type;\x0a"
"    if (__first1 \x21= __last1)\x0a"
"    {\x0a"
"        __destruct_n __d(0);\x0a"
"        unique_ptr<value_type, __destruct_n\x26> __h(__first2, __d);\x0a"
"        value_type* __last2 = __first2;\x0a"
"        \x3a\x3anew(__last2) value_type(_VSTD\x3a\x3amove(*__first1));\x0a"
"        __d.__incr((value_type*)0);\x0a"
"        for (++__last2; ++__first1 \x21= __last1; ++__last2)\x0a"
"        {\x0a"
"            value_type* __j2 = __last2;\x0a"
"            value_type* __i2 = __j2;\x0a"
"            if (__comp(*__first1, *--__i2))\x0a"
"            {\x0a"
"                \x3a\x3anew(__j2) value_type(_VSTD\x3a\x3amove(*__i2));\x0a"
"                __d.__incr((value_type*)0);\x0a"
"                for (--__j2; __i2 \x21= __first2 \x26\x26 __comp(*__first1,  *--__i2); --__j2)\x0a"
"                    *__j2 = _VSTD\x3a\x3amove(*__i2);\x0a"
"                *__j2 = _VSTD\x3a\x3amove(*__first1);\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                \x3a\x3anew(__j2) value_type(_VSTD\x3a\x3amove(*__first1));\x0a"
"                __d.__incr((value_type*)0);\x0a"
"            }\x0a"
"        }\x0a"
"        __h.release();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__sort(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    // _Compare is known to be a reference type\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type value_type;\x0a"
"    const difference_type __limit = is_trivially_copy_constructible<value_type>\x3a\x3avalue \x26\x26\x0a"
"                                    is_trivially_copy_assignable<value_type>\x3a\x3avalue \x3f 30 \x3a 6;\x0a"
"    while (true)\x0a"
"    {\x0a"
"    __restart\x3a\x0a"
"        difference_type __len = __last - __first;\x0a"
"        switch (__len)\x0a"
"        {\x0a"
"        case 0\x3a\x0a"
"        case 1\x3a\x0a"
"            return;\x0a"
"        case 2\x3a\x0a"
"            if (__comp(*--__last, *__first))\x0a"
"                swap(*__first, *__last);\x0a"
"            return;\x0a"
"        case 3\x3a\x0a"
"            _VSTD\x3a\x3a__sort3<_Compare>(__first, __first+1, --__last, __comp);\x0a"
"            return;\x0a"
"        case 4\x3a\x0a"
"            _VSTD\x3a\x3a__sort4<_Compare>(__first, __first+1, __first+2, --__last, __comp);\x0a"
"            return;\x0a"
"        case 5\x3a\x0a"
"            _VSTD\x3a\x3a__sort5<_Compare>(__first, __first+1, __first+2, __first+3, --__last, __comp);\x0a"
"            return;\x0a"
"        }\x0a"
"        if (__len <= __limit)\x0a"
"        {\x0a"
"            _VSTD\x3a\x3a__insertion_sort_3<_Compare>(__first, __last, __comp);\x0a"
"            return;\x0a"
"        }\x0a"
"        // __len > 5\x0a"
"        _RandomAccessIterator __m = __first;\x0a"
"        _RandomAccessIterator __lm1 = __last;\x0a"
"        --__lm1;\x0a"
"        unsigned __n_swaps;\x0a"
"        {\x0a"
"        difference_type __delta;\x0a"
"        if (__len >= 1000)\x0a"
"        {\x0a"
"            __delta = __len/2;\x0a"
"            __m += __delta;\x0a"
"            __delta /= 2;\x0a"
"            __n_swaps = _VSTD\x3a\x3a__sort5<_Compare>(__first, __first + __delta, __m, __m+__delta, __lm1, __comp);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __delta = __len/2;\x0a"
"            __m += __delta;\x0a"
"            __n_swaps = _VSTD\x3a\x3a__sort3<_Compare>(__first, __m, __lm1, __comp);\x0a"
"        }\x0a"
"        }\x0a"
"        // *__m is median\x0a"
"        // partition \x5b__first, __m) < *__m and *__m <= \x5b__m, __last)\x0a"
"        // (this inhibits tossing elements equivalent to __m around unnecessarily)\x0a"
"        _RandomAccessIterator __i = __first;\x0a"
"        _RandomAccessIterator __j = __lm1;\x0a"
"        // j points beyond range to be tested, *__m is known to be <= *__lm1\x0a"
"        // The search going up is known to be guarded but the search coming down isn't.\x0a"
"        // Prime the downward search with a guard.\x0a"
"        if (\x21__comp(*__i, *__m))  // if *__first == *__m\x0a"
"        {\x0a"
"            // *__first == *__m, *__first doesn't go in first part\x0a"
"            // manually guard downward moving __j against __i\x0a"
"            while (true)\x0a"
"            {\x0a"
"                if (__i == --__j)\x0a"
"                {\x0a"
"                    // *__first == *__m, *__m <= all other elements\x0a"
"                    // Parition instead into \x5b__first, __i) == *__first and *__first < \x5b__i, __last)\x0a"
"                    ++__i;  // __first + 1\x0a"
"                    __j = __last;\x0a"
"                    if (\x21__comp(*__first, *--__j))  // we need a guard if *__first == *(__last-1)\x0a"
"                    {\x0a"
"                        while (true)\x0a"
"                        {\x0a"
"                            if (__i == __j)\x0a"
"                                return;  // \x5b__first, __last) all equivalent elements\x0a"
"                            if (__comp(*__first, *__i))\x0a"
"                            {\x0a"
"                                swap(*__i, *__j);\x0a"
"                                ++__n_swaps;\x0a"
"                                ++__i;\x0a"
"                                break;\x0a"
"                            }\x0a"
"                            ++__i;\x0a"
"                        }\x0a"
"                    }\x0a"
"                    // \x5b__first, __i) == *__first and *__first < \x5b__j, __last) and __j == __last - 1\x0a"
"                    if (__i == __j)\x0a"
"                        return;\x0a"
"                    while (true)\x0a"
"                    {\x0a"
"                        while (\x21__comp(*__first, *__i))\x0a"
"                            ++__i;\x0a"
"                        while (__comp(*__first, *--__j))\x0a"
"                            ;\x0a"
"                        if (__i >= __j)\x0a"
"                            break;\x0a"
"                        swap(*__i, *__j);\x0a"
"                        ++__n_swaps;\x0a"
"                        ++__i;\x0a"
"                    }\x0a"
"                    // \x5b__first, __i) == *__first and *__first < \x5b__i, __last)\x0a"
"                    // The first part is sorted, sort the secod part\x0a"
"                    // _VSTD\x3a\x3a__sort<_Compare>(__i, __last, __comp);\x0a"
"                    __first = __i;\x0a"
"                    goto __restart;\x0a"
"                }\x0a"
"                if (__comp(*__j, *__m))\x0a"
"                {\x0a"
"                    swap(*__i, *__j);\x0a"
"                    ++__n_swaps;\x0a"
"                    break;  // found guard for downward moving __j, now use unguarded partition\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"        // It is known that *__i < *__m\x0a"
"        ++__i;\x0a"
"        // j points beyond range to be tested, *__m is known to be <= *__lm1\x0a"
"        // if not yet partitioned...\x0a"
"        if (__i < __j)\x0a"
"        {\x0a"
"            // known that *(__i - 1) < *__m\x0a"
"            // known that __i <= __m\x0a"
"            while (true)\x0a"
"            {\x0a"
"                // __m still guards upward moving __i\x0a"
"                while (__comp(*__i, *__m))\x0a"
"                    ++__i;\x0a"
"                // It is now known that a guard exists for downward moving __j\x0a"
"                while (\x21__comp(*--__j, *__m))\x0a"
"                    ;\x0a"
"                if (__i > __j)\x0a"
"                    break;\x0a"
"                swap(*__i, *__j);\x0a"
"                ++__n_swaps;\x0a"
"                // It is known that __m \x21= __j\x0a"
"                // If __m just moved, follow it\x0a"
"                if (__m == __i)\x0a"
"                    __m = __j;\x0a"
"                ++__i;\x0a"
"            }\x0a"
"        }\x0a"
"        // \x5b__first, __i) < *__m and *__m <= \x5b__i, __last)\x0a"
"        if (__i \x21= __m \x26\x26 __comp(*__m, *__i))\x0a"
"        {\x0a"
"            swap(*__i, *__m);\x0a"
"            ++__n_swaps;\x0a"
"        }\x0a"
"        // \x5b__first, __i) < *__i and *__i <= \x5b__i+1, __last)\x0a"
"        // If we were given a perfect partition, see if insertion sort is quick...\x0a"
"        if (__n_swaps == 0)\x0a"
"        {\x0a"
"            bool __fs = _VSTD\x3a\x3a__insertion_sort_incomplete<_Compare>(__first, __i, __comp);\x0a"
"            if (_VSTD\x3a\x3a__insertion_sort_incomplete<_Compare>(__i+1, __last, __comp))\x0a"
"            {\x0a"
"                if (__fs)\x0a"
"                    return;\x0a"
"                __last = __i;\x0a"
"                continue;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                if (__fs)\x0a"
"                {\x0a"
"                    __first = ++__i;\x0a"
"                    continue;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"        // sort smaller range with recursive call and larger with tail recursion elimination\x0a"
"        if (__i - __first < __last - __i)\x0a"
"        {\x0a"
"            _VSTD\x3a\x3a__sort<_Compare>(__first, __i, __comp);\x0a"
"            // _VSTD\x3a\x3a__sort<_Compare>(__i+1, __last, __comp);\x0a"
"            __first = ++__i;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            _VSTD\x3a\x3a__sort<_Compare>(__i+1, __last, __comp);\x0a"
"            // _VSTD\x3a\x3a__sort<_Compare>(__first, __i, __comp);\x0a"
"            __last = __i;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// This forwarder keeps the top call and the recursive calls using the same instantiation, forcing a reference _Compare\x0a"
"template <class _RandomAccessIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"sort(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    _VSTD\x3a\x3a__sort<_Comp_ref>(__first, __last, _Comp_ref(__comp));\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"sort(_RandomAccessIterator __first, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3asort(__first, __last, __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"sort(_Tp** __first, _Tp** __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3asort((size_t*)__first, (size_t*)__last, __less<size_t>());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"sort(__wrap_iter<_Tp*> __first, __wrap_iter<_Tp*> __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3asort(__first.base(), __last.base());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"sort(__wrap_iter<_Tp*> __first, __wrap_iter<_Tp*> __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename add_lvalue_reference<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    _VSTD\x3a\x3asort<_Tp*, _Comp_ref>(__first.base(), __last.base(), __comp);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<char>\x26, char*>(char*, char*, __less<char>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<wchar_t>\x26, wchar_t*>(wchar_t*, wchar_t*, __less<wchar_t>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<signed char>\x26, signed char*>(signed char*, signed char*, __less<signed char>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<unsigned char>\x26, unsigned char*>(unsigned char*, unsigned char*, __less<unsigned char>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<short>\x26, short*>(short*, short*, __less<short>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<unsigned short>\x26, unsigned short*>(unsigned short*, unsigned short*, __less<unsigned short>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<int>\x26, int*>(int*, int*, __less<int>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<unsigned>\x26, unsigned*>(unsigned*, unsigned*, __less<unsigned>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<long>\x26, long*>(long*, long*, __less<long>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<unsigned long>\x26, unsigned long*>(unsigned long*, unsigned long*, __less<unsigned long>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<long long>\x26, long long*>(long long*, long long*, __less<long long>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<unsigned long long>\x26, unsigned long long*>(unsigned long long*, unsigned long long*, __less<unsigned long long>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<float>\x26, float*>(float*, float*, __less<float>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<double>\x26, double*>(double*, double*, __less<double>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void __sort<__less<long double>\x26, long double*>(long double*, long double*, __less<long double>\x26))\x0a"
"\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<char>\x26, char*>(char*, char*, __less<char>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<wchar_t>\x26, wchar_t*>(wchar_t*, wchar_t*, __less<wchar_t>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<signed char>\x26, signed char*>(signed char*, signed char*, __less<signed char>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<unsigned char>\x26, unsigned char*>(unsigned char*, unsigned char*, __less<unsigned char>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<short>\x26, short*>(short*, short*, __less<short>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<unsigned short>\x26, unsigned short*>(unsigned short*, unsigned short*, __less<unsigned short>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<int>\x26, int*>(int*, int*, __less<int>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<unsigned>\x26, unsigned*>(unsigned*, unsigned*, __less<unsigned>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<long>\x26, long*>(long*, long*, __less<long>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<unsigned long>\x26, unsigned long*>(unsigned long*, unsigned long*, __less<unsigned long>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<long long>\x26, long long*>(long long*, long long*, __less<long long>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<unsigned long long>\x26, unsigned long long*>(unsigned long long*, unsigned long long*, __less<unsigned long long>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<float>\x26, float*>(float*, float*, __less<float>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<double>\x26, double*>(double*, double*, __less<double>\x26))\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS bool __insertion_sort_incomplete<__less<long double>\x26, long double*>(long double*, long double*, __less<long double>\x26))\x0a"
"\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS unsigned __sort5<__less<long double>\x26, long double*>(long double*, long double*, long double*, long double*, long double*, __less<long double>\x26))\x0a"
"\x0a"
"// lower_bound\x0a"
"\x0a"
"template <class _Compare, class _ForwardIterator, class _Tp>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _ForwardIterator\x0a"
"__lower_bound(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    difference_type __len = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    while (__len \x21= 0)\x0a"
"    {\x0a"
"        difference_type __l2 = _VSTD\x3a\x3a__half_positive(__len);\x0a"
"        _ForwardIterator __m = __first;\x0a"
"        _VSTD\x3a\x3a""advance(__m, __l2);\x0a"
"        if (__comp(*__m, __value_))\x0a"
"        {\x0a"
"            __first = ++__m;\x0a"
"            __len -= __l2 + 1;\x0a"
"        }\x0a"
"        else\x0a"
"            __len = __l2;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator\x0a"
"lower_bound(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename add_lvalue_reference<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __lower_bound<_Comp_ref>(__first, __last, __value_, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator\x0a"
"lower_bound(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alower_bound(__first, __last, __value_,\x0a"
"                             __less<typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type, _Tp>());\x0a"
"}\x0a"
"\x0a"
"// upper_bound\x0a"
"\x0a"
"template <class _Compare, class _ForwardIterator, class _Tp>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _ForwardIterator\x0a"
"__upper_bound(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    difference_type __len = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    while (__len \x21= 0)\x0a"
"    {\x0a"
"        difference_type __l2 = _VSTD\x3a\x3a__half_positive(__len);\x0a"
"        _ForwardIterator __m = __first;\x0a"
"        _VSTD\x3a\x3a""advance(__m, __l2);\x0a"
"        if (__comp(__value_, *__m))\x0a"
"            __len = __l2;\x0a"
"        else\x0a"
"        {\x0a"
"            __first = ++__m;\x0a"
"            __len -= __l2 + 1;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator\x0a"
"upper_bound(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename add_lvalue_reference<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __upper_bound<_Comp_ref>(__first, __last, __value_, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_ForwardIterator\x0a"
"upper_bound(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aupper_bound(__first, __last, __value_,\x0a"
"                             __less<_Tp, typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// equal_range\x0a"
"\x0a"
"template <class _Compare, class _ForwardIterator, class _Tp>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 pair<_ForwardIterator, _ForwardIterator>\x0a"
"__equal_range(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    difference_type __len = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    while (__len \x21= 0)\x0a"
"    {\x0a"
"        difference_type __l2 = _VSTD\x3a\x3a__half_positive(__len);\x0a"
"        _ForwardIterator __m = __first;\x0a"
"        _VSTD\x3a\x3a""advance(__m, __l2);\x0a"
"        if (__comp(*__m, __value_))\x0a"
"        {\x0a"
"            __first = ++__m;\x0a"
"            __len -= __l2 + 1;\x0a"
"        }\x0a"
"        else if (__comp(__value_, *__m))\x0a"
"        {\x0a"
"            __last = __m;\x0a"
"            __len = __l2;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            _ForwardIterator __mp1 = __m;\x0a"
"            return pair<_ForwardIterator, _ForwardIterator>\x0a"
"                   (\x0a"
"                      __lower_bound<_Compare>(__first, __m, __value_, __comp),\x0a"
"                      __upper_bound<_Compare>(++__mp1, __last, __value_, __comp)\x0a"
"                   );\x0a"
"        }\x0a"
"    }\x0a"
"    return pair<_ForwardIterator, _ForwardIterator>(__first, __first);\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"pair<_ForwardIterator, _ForwardIterator>\x0a"
"equal_range(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __equal_range<_Comp_ref>(__first, __last, __value_, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"pair<_ForwardIterator, _ForwardIterator>\x0a"
"equal_range(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""equal_range(__first, __last, __value_,\x0a"
"                             __less<typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type, _Tp>());\x0a"
"}\x0a"
"\x0a"
"// binary_search\x0a"
"\x0a"
"template <class _Compare, class _ForwardIterator, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"__binary_search(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_, _Compare __comp)\x0a"
"{\x0a"
"    __first = __lower_bound<_Compare>(__first, __last, __value_, __comp);\x0a"
"    return __first \x21= __last \x26\x26 \x21__comp(__value_, *__first);\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"binary_search(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __binary_search<_Comp_ref>(__first, __last, __value_, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"binary_search(_ForwardIterator __first, _ForwardIterator __last, const _Tp\x26 __value_)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""binary_search(__first, __last, __value_,\x0a"
"                             __less<typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type, _Tp>());\x0a"
"}\x0a"
"\x0a"
"// merge\x0a"
"\x0a"
"template <class _Compare, class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"__merge(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"        _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__result)\x0a"
"    {\x0a"
"        if (__first2 == __last2)\x0a"
"            return _VSTD\x3a\x3a""copy(__first1, __last1, __result);\x0a"
"        if (__comp(*__first2, *__first1))\x0a"
"        {\x0a"
"            *__result = *__first2;\x0a"
"            ++__first2;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            *__result = *__first1;\x0a"
"            ++__first1;\x0a"
"        }\x0a"
"    }\x0a"
"    return _VSTD\x3a\x3a""copy(__first2, __last2, __result);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"merge(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"      _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return _VSTD\x3a\x3a__merge<_Comp_ref>(__first1, __last1, __first2, __last2, __result, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"merge(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"      _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_InputIterator1>\x3a\x3avalue_type __v1;\x0a"
"    typedef typename iterator_traits<_InputIterator2>\x3a\x3avalue_type __v2;\x0a"
"    return merge(__first1, __last1, __first2, __last2, __result, __less<__v1, __v2>());\x0a"
"}\x0a"
"\x0a"
"// inplace_merge\x0a"
"\x0a"
"template <class _Compare, class _InputIterator1, class _InputIterator2,\x0a"
"          class _OutputIterator>\x0a"
"void __half_inplace_merge(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                          _InputIterator2 __first2, _InputIterator2 __last2,\x0a"
"                          _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__result)\x0a"
"    {\x0a"
"        if (__first2 == __last2)\x0a"
"        {\x0a"
"            _VSTD\x3a\x3amove(__first1, __last1, __result);\x0a"
"            return;\x0a"
"        }\x0a"
"\x0a"
"        if (__comp(*__first2, *__first1))\x0a"
"        {\x0a"
"            *__result = _VSTD\x3a\x3amove(*__first2);\x0a"
"            ++__first2;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            *__result = _VSTD\x3a\x3amove(*__first1);\x0a"
"            ++__first1;\x0a"
"        }\x0a"
"    }\x0a"
"    // __first2 through __last2 are already in the right spot.\x0a"
"}\x0a"
"\x0a"
"template <class _Compare, class _BidirectionalIterator>\x0a"
"void\x0a"
"__buffered_inplace_merge(_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last,\x0a"
"                _Compare __comp, typename iterator_traits<_BidirectionalIterator>\x3a\x3a""difference_type __len1,\x0a"
"                                 typename iterator_traits<_BidirectionalIterator>\x3a\x3a""difference_type __len2,\x0a"
"                typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type* __buff)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type value_type;\x0a"
"    __destruct_n __d(0);\x0a"
"    unique_ptr<value_type, __destruct_n\x26> __h2(__buff, __d);\x0a"
"    if (__len1 <= __len2)\x0a"
"    {\x0a"
"        value_type* __p = __buff;\x0a"
"        for (_BidirectionalIterator __i = __first; __i \x21= __middle; __d.__incr((value_type*)0), (void) ++__i, ++__p)\x0a"
"            \x3a\x3anew(__p) value_type(_VSTD\x3a\x3amove(*__i));\x0a"
"        __half_inplace_merge(__buff, __p, __middle, __last, __first, __comp);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        value_type* __p = __buff;\x0a"
"        for (_BidirectionalIterator __i = __middle; __i \x21= __last; __d.__incr((value_type*)0), (void) ++__i, ++__p)\x0a"
"            \x3a\x3anew(__p) value_type(_VSTD\x3a\x3amove(*__i));\x0a"
"        typedef reverse_iterator<_BidirectionalIterator> _RBi;\x0a"
"        typedef reverse_iterator<value_type*> _Rv;\x0a"
"        __half_inplace_merge(_Rv(__p), _Rv(__buff),\x0a"
"                             _RBi(__middle), _RBi(__first),\x0a"
"                             _RBi(__last), __invert<_Compare>(__comp));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Compare, class _BidirectionalIterator>\x0a"
"void\x0a"
"__inplace_merge(_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last,\x0a"
"                _Compare __comp, typename iterator_traits<_BidirectionalIterator>\x3a\x3a""difference_type __len1,\x0a"
"                                 typename iterator_traits<_BidirectionalIterator>\x3a\x3a""difference_type __len2,\x0a"
"                typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type* __buff, ptrdiff_t __buff_size)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_BidirectionalIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    while (true)\x0a"
"    {\x0a"
"        // if __middle == __last, we're done\x0a"
"        if (__len2 == 0)\x0a"
"            return;\x0a"
"        if (__len1 <= __buff_size \x7c\x7c __len2 <= __buff_size)\x0a"
"            return __buffered_inplace_merge<_Compare>\x0a"
"                   (__first, __middle, __last, __comp, __len1, __len2, __buff);\x0a"
"        // shrink \x5b__first, __middle) as much as possible (with no moves), returning if it shrinks to 0\x0a"
"        for (; true; ++__first, (void) --__len1)\x0a"
"        {\x0a"
"            if (__len1 == 0)\x0a"
"                return;\x0a"
"            if (__comp(*__middle, *__first))\x0a"
"                break;\x0a"
"        }\x0a"
"        // __first < __middle < __last\x0a"
"        // *__first > *__middle\x0a"
"        // partition \x5b__first, __m1) \x5b__m1, __middle) \x5b__middle, __m2) \x5b__m2, __last) such that\x0a"
"        //     all elements in\x3a\x0a"
"        //         \x5b__first, __m1)  <= \x5b__middle, __m2)\x0a"
"        //         \x5b__middle, __m2) <  \x5b__m1, __middle)\x0a"
"        //         \x5b__m1, __middle) <= \x5b__m2, __last)\x0a"
"        //     and __m1 or __m2 is in the middle of its range\x0a"
"        _BidirectionalIterator __m1;  // \x22median\x22 of \x5b__first, __middle)\x0a"
"        _BidirectionalIterator __m2;  // \x22median\x22 of \x5b__middle, __last)\x0a"
"        difference_type __len11;      // distance(__first, __m1)\x0a"
"        difference_type __len21;      // distance(__middle, __m2)\x0a"
"        // binary search smaller range\x0a"
"        if (__len1 < __len2)\x0a"
"        {   // __len >= 1, __len2 >= 2\x0a"
"            __len21 = __len2 / 2;\x0a"
"            __m2 = __middle;\x0a"
"            _VSTD\x3a\x3a""advance(__m2, __len21);\x0a"
"            __m1 = __upper_bound<_Compare>(__first, __middle, *__m2, __comp);\x0a"
"            __len11 = _VSTD\x3a\x3a""distance(__first, __m1);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (__len1 == 1)\x0a"
"            {   // __len1 >= __len2 \x26\x26 __len2 > 0, therefore __len2 == 1\x0a"
"                // It is known *__first > *__middle\x0a"
"                swap(*__first, *__middle);\x0a"
"                return;\x0a"
"            }\x0a"
"            // __len1 >= 2, __len2 >= 1\x0a"
"            __len11 = __len1 / 2;\x0a"
"            __m1 = __first;\x0a"
"            _VSTD\x3a\x3a""advance(__m1, __len11);\x0a"
"            __m2 = __lower_bound<_Compare>(__middle, __last, *__m1, __comp);\x0a"
"            __len21 = _VSTD\x3a\x3a""distance(__middle, __m2);\x0a"
"        }\x0a"
"        difference_type __len12 = __len1 - __len11;  // distance(__m1, __middle)\x0a"
"        difference_type __len22 = __len2 - __len21;  // distance(__m2, __last)\x0a"
"        // \x5b__first, __m1) \x5b__m1, __middle) \x5b__middle, __m2) \x5b__m2, __last)\x0a"
"        // swap middle two partitions\x0a"
"        __middle = _VSTD\x3a\x3arotate(__m1, __middle, __m2);\x0a"
"        // __len12 and __len21 now have swapped meanings\x0a"
"        // merge smaller range with recurisve call and larger with tail recursion elimination\x0a"
"        if (__len11 + __len21 < __len12 + __len22)\x0a"
"        {\x0a"
"            __inplace_merge<_Compare>(__first, __m1, __middle, __comp, __len11, __len21, __buff, __buff_size);\x0a"
"//          __inplace_merge<_Compare>(__middle, __m2, __last, __comp, __len12, __len22, __buff, __buff_size);\x0a"
"            __first = __middle;\x0a"
"            __middle = __m2;\x0a"
"            __len1 = __len12;\x0a"
"            __len2 = __len22;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __inplace_merge<_Compare>(__middle, __m2, __last, __comp, __len12, __len22, __buff, __buff_size);\x0a"
"//          __inplace_merge<_Compare>(__first, __m1, __middle, __comp, __len11, __len21, __buff, __buff_size);\x0a"
"            __last = __middle;\x0a"
"            __middle = __m1;\x0a"
"            __len1 = __len11;\x0a"
"            __len2 = __len21;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"inplace_merge(_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last,\x0a"
"              _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type value_type;\x0a"
"    typedef typename iterator_traits<_BidirectionalIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    difference_type __len1 = _VSTD\x3a\x3a""distance(__first, __middle);\x0a"
"    difference_type __len2 = _VSTD\x3a\x3a""distance(__middle, __last);\x0a"
"    difference_type __buf_size = _VSTD\x3a\x3amin(__len1, __len2);\x0a"
"    pair<value_type*, ptrdiff_t> __buf = _VSTD\x3a\x3aget_temporary_buffer<value_type>(__buf_size);\x0a"
"    unique_ptr<value_type, __return_temporary_buffer> __h(__buf.first);\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return _VSTD\x3a\x3a__inplace_merge<_Comp_ref>(__first, __middle, __last, __comp, __len1, __len2,\x0a"
"                                            __buf.first, __buf.second);\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"inplace_merge(_BidirectionalIterator __first, _BidirectionalIterator __middle, _BidirectionalIterator __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3ainplace_merge(__first, __middle, __last,\x0a"
"                        __less<typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// stable_sort\x0a"
"\x0a"
"template <class _Compare, class _InputIterator1, class _InputIterator2>\x0a"
"void\x0a"
"__merge_move_construct(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"        _InputIterator2 __first2, _InputIterator2 __last2,\x0a"
"        typename iterator_traits<_InputIterator1>\x3a\x3avalue_type* __result, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_InputIterator1>\x3a\x3avalue_type value_type;\x0a"
"    __destruct_n __d(0);\x0a"
"    unique_ptr<value_type, __destruct_n\x26> __h(__result, __d);\x0a"
"    for (; true; ++__result)\x0a"
"    {\x0a"
"        if (__first1 == __last1)\x0a"
"        {\x0a"
"            for (; __first2 \x21= __last2; ++__first2, ++__result, __d.__incr((value_type*)0))\x0a"
"                \x3a\x3anew (__result) value_type(_VSTD\x3a\x3amove(*__first2));\x0a"
"            __h.release();\x0a"
"            return;\x0a"
"        }\x0a"
"        if (__first2 == __last2)\x0a"
"        {\x0a"
"            for (; __first1 \x21= __last1; ++__first1, ++__result, __d.__incr((value_type*)0))\x0a"
"                \x3a\x3anew (__result) value_type(_VSTD\x3a\x3amove(*__first1));\x0a"
"            __h.release();\x0a"
"            return;\x0a"
"        }\x0a"
"        if (__comp(*__first2, *__first1))\x0a"
"        {\x0a"
"            \x3a\x3anew (__result) value_type(_VSTD\x3a\x3amove(*__first2));\x0a"
"            __d.__incr((value_type*)0);\x0a"
"            ++__first2;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            \x3a\x3anew (__result) value_type(_VSTD\x3a\x3amove(*__first1));\x0a"
"            __d.__incr((value_type*)0);\x0a"
"            ++__first1;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Compare, class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"void\x0a"
"__merge_move_assign(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"        _InputIterator2 __first2, _InputIterator2 __last2,\x0a"
"        _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__result)\x0a"
"    {\x0a"
"        if (__first2 == __last2)\x0a"
"        {\x0a"
"            for (; __first1 \x21= __last1; ++__first1, ++__result)\x0a"
"                *__result = _VSTD\x3a\x3amove(*__first1);\x0a"
"            return;\x0a"
"        }\x0a"
"        if (__comp(*__first2, *__first1))\x0a"
"        {\x0a"
"            *__result = _VSTD\x3a\x3amove(*__first2);\x0a"
"            ++__first2;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            *__result = _VSTD\x3a\x3amove(*__first1);\x0a"
"            ++__first1;\x0a"
"        }\x0a"
"    }\x0a"
"    for (; __first2 \x21= __last2; ++__first2, ++__result)\x0a"
"        *__result = _VSTD\x3a\x3amove(*__first2);\x0a"
"}\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__stable_sort(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp,\x0a"
"              typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type __len,\x0a"
"              typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type* __buff, ptrdiff_t __buff_size);\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__stable_sort_move(_RandomAccessIterator __first1, _RandomAccessIterator __last1, _Compare __comp,\x0a"
"                   typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type __len,\x0a"
"                   typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type* __first2)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type value_type;\x0a"
"    switch (__len)\x0a"
"    {\x0a"
"    case 0\x3a\x0a"
"        return;\x0a"
"    case 1\x3a\x0a"
"        \x3a\x3anew(__first2) value_type(_VSTD\x3a\x3amove(*__first1));\x0a"
"        return;\x0a"
"    case 2\x3a\x0a"
"        __destruct_n __d(0);\x0a"
"        unique_ptr<value_type, __destruct_n\x26> __h2(__first2, __d);\x0a"
"        if (__comp(*--__last1, *__first1))\x0a"
"        {\x0a"
"            \x3a\x3anew(__first2) value_type(_VSTD\x3a\x3amove(*__last1));\x0a"
"            __d.__incr((value_type*)0);\x0a"
"            ++__first2;\x0a"
"            \x3a\x3anew(__first2) value_type(_VSTD\x3a\x3amove(*__first1));\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            \x3a\x3anew(__first2) value_type(_VSTD\x3a\x3amove(*__first1));\x0a"
"            __d.__incr((value_type*)0);\x0a"
"            ++__first2;\x0a"
"            \x3a\x3anew(__first2) value_type(_VSTD\x3a\x3amove(*__last1));\x0a"
"        }\x0a"
"        __h2.release();\x0a"
"        return;\x0a"
"    }\x0a"
"    if (__len <= 8)\x0a"
"    {\x0a"
"        __insertion_sort_move<_Compare>(__first1, __last1, __first2, __comp);\x0a"
"        return;\x0a"
"    }\x0a"
"    typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type __l2 = __len / 2;\x0a"
"    _RandomAccessIterator __m = __first1 + __l2;\x0a"
"    __stable_sort<_Compare>(__first1, __m, __comp, __l2, __first2, __l2);\x0a"
"    __stable_sort<_Compare>(__m, __last1, __comp, __len - __l2, __first2 + __l2, __len - __l2);\x0a"
"    __merge_move_construct<_Compare>(__first1, __m, __m, __last1, __first2, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __stable_sort_switch\x0a"
"{\x0a"
"    static const unsigned value = 128*is_trivially_copy_assignable<_Tp>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__stable_sort(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp,\x0a"
"              typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type __len,\x0a"
"              typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type* __buff, ptrdiff_t __buff_size)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type value_type;\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    switch (__len)\x0a"
"    {\x0a"
"    case 0\x3a\x0a"
"    case 1\x3a\x0a"
"        return;\x0a"
"    case 2\x3a\x0a"
"        if (__comp(*--__last, *__first))\x0a"
"            swap(*__first, *__last);\x0a"
"        return;\x0a"
"    }\x0a"
"    if (__len <= static_cast<difference_type>(__stable_sort_switch<value_type>\x3a\x3avalue))\x0a"
"    {\x0a"
"        __insertion_sort<_Compare>(__first, __last, __comp);\x0a"
"        return;\x0a"
"    }\x0a"
"    typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type __l2 = __len / 2;\x0a"
"    _RandomAccessIterator __m = __first + __l2;\x0a"
"    if (__len <= __buff_size)\x0a"
"    {\x0a"
"        __destruct_n __d(0);\x0a"
"        unique_ptr<value_type, __destruct_n\x26> __h2(__buff, __d);\x0a"
"        __stable_sort_move<_Compare>(__first, __m, __comp, __l2, __buff);\x0a"
"        __d.__set(__l2, (value_type*)0);\x0a"
"        __stable_sort_move<_Compare>(__m, __last, __comp, __len - __l2, __buff + __l2);\x0a"
"        __d.__set(__len, (value_type*)0);\x0a"
"        __merge_move_assign<_Compare>(__buff, __buff + __l2, __buff + __l2, __buff + __len, __first, __comp);\x0a"
"//         __merge<_Compare>(move_iterator<value_type*>(__buff),\x0a"
"//                           move_iterator<value_type*>(__buff + __l2),\x0a"
"//                           move_iterator<_RandomAccessIterator>(__buff + __l2),\x0a"
"//                           move_iterator<_RandomAccessIterator>(__buff + __len),\x0a"
"//                           __first, __comp);\x0a"
"        return;\x0a"
"    }\x0a"
"    __stable_sort<_Compare>(__first, __m, __comp, __l2, __buff, __buff_size);\x0a"
"    __stable_sort<_Compare>(__m, __last, __comp, __len - __l2, __buff, __buff_size);\x0a"
"    __inplace_merge<_Compare>(__first, __m, __last, __comp, __l2, __len - __l2, __buff, __buff_size);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"stable_sort(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type value_type;\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    difference_type __len = __last - __first;\x0a"
"    pair<value_type*, ptrdiff_t> __buf(0, 0);\x0a"
"    unique_ptr<value_type, __return_temporary_buffer> __h;\x0a"
"    if (__len > static_cast<difference_type>(__stable_sort_switch<value_type>\x3a\x3avalue))\x0a"
"    {\x0a"
"        __buf = _VSTD\x3a\x3aget_temporary_buffer<value_type>(__len);\x0a"
"        __h.reset(__buf.first);\x0a"
"    }\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    __stable_sort<_Comp_ref>(__first, __last, __comp, __len, __buf.first, __buf.second);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"stable_sort(_RandomAccessIterator __first, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3astable_sort(__first, __last, __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// is_heap_until\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT _LIBCPP_CONSTEXPR_AFTER_CXX17 _RandomAccessIterator\x0a"
"is_heap_until(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename _VSTD\x3a\x3aiterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    difference_type __len = __last - __first;\x0a"
"    difference_type __p = 0;\x0a"
"    difference_type __c = 1;\x0a"
"    _RandomAccessIterator __pp = __first;\x0a"
"    while (__c < __len)\x0a"
"    {\x0a"
"        _RandomAccessIterator __cp = __first + __c;\x0a"
"        if (__comp(*__pp, *__cp))\x0a"
"            return __cp;\x0a"
"        ++__c;\x0a"
"        ++__cp;\x0a"
"        if (__c == __len)\x0a"
"            return __last;\x0a"
"        if (__comp(*__pp, *__cp))\x0a"
"            return __cp;\x0a"
"        ++__p;\x0a"
"        ++__pp;\x0a"
"        __c = 2 * __p + 1;\x0a"
"    }\x0a"
"    return __last;\x0a"
"}\x0a"
"\x0a"
"template<class _RandomAccessIterator>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_RandomAccessIterator\x0a"
"is_heap_until(_RandomAccessIterator __first, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3ais_heap_until(__first, __last, __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// is_heap\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"is_heap(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3ais_heap_until(__first, __last, __comp) == __last;\x0a"
"}\x0a"
"\x0a"
"template<class _RandomAccessIterator>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"is_heap(_RandomAccessIterator __first, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3ais_heap(__first, __last, __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// push_heap\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__sift_up(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp,\x0a"
"          typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type __len)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type value_type;\x0a"
"    if (__len > 1)\x0a"
"    {\x0a"
"        __len = (__len - 2) / 2;\x0a"
"        _RandomAccessIterator __ptr = __first + __len;\x0a"
"        if (__comp(*__ptr, *--__last))\x0a"
"        {\x0a"
"            value_type __t(_VSTD\x3a\x3amove(*__last));\x0a"
"            do\x0a"
"            {\x0a"
"                *__last = _VSTD\x3a\x3amove(*__ptr);\x0a"
"                __last = __ptr;\x0a"
"                if (__len == 0)\x0a"
"                    break;\x0a"
"                __len = (__len - 1) / 2;\x0a"
"                __ptr = __first + __len;\x0a"
"            } while (__comp(*__ptr, __t));\x0a"
"            *__last = _VSTD\x3a\x3amove(__t);\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"push_heap(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    __sift_up<_Comp_ref>(__first, __last, __comp, __last - __first);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"push_heap(_RandomAccessIterator __first, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3apush_heap(__first, __last, __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// pop_heap\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__sift_down(_RandomAccessIterator __first, _RandomAccessIterator /*__last*/,\x0a"
"            _Compare __comp,\x0a"
"            typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type __len,\x0a"
"            _RandomAccessIterator __start)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type value_type;\x0a"
"    // left-child of __start is at 2 * __start + 1\x0a"
"    // right-child of __start is at 2 * __start + 2\x0a"
"    difference_type __child = __start - __first;\x0a"
"\x0a"
"    if (__len < 2 \x7c\x7c (__len - 2) / 2 < __child)\x0a"
"        return;\x0a"
"\x0a"
"    __child = 2 * __child + 1;\x0a"
"    _RandomAccessIterator __child_i = __first + __child;\x0a"
"\x0a"
"    if ((__child + 1) < __len \x26\x26 __comp(*__child_i, *(__child_i + 1))) {\x0a"
"        // right-child exists and is greater than left-child\x0a"
"        ++__child_i;\x0a"
"        ++__child;\x0a"
"    }\x0a"
"\x0a"
"    // check if we are in heap-order\x0a"
"    if (__comp(*__child_i, *__start))\x0a"
"        // we are, __start is larger than it's largest child\x0a"
"        return;\x0a"
"\x0a"
"    value_type __top(_VSTD\x3a\x3amove(*__start));\x0a"
"    do\x0a"
"    {\x0a"
"        // we are not in heap-order, swap the parent with it's largest child\x0a"
"        *__start = _VSTD\x3a\x3amove(*__child_i);\x0a"
"        __start = __child_i;\x0a"
"\x0a"
"        if ((__len - 2) / 2 < __child)\x0a"
"            break;\x0a"
"\x0a"
"        // recompute the child based off of the updated parent\x0a"
"        __child = 2 * __child + 1;\x0a"
"        __child_i = __first + __child;\x0a"
"\x0a"
"        if ((__child + 1) < __len \x26\x26 __comp(*__child_i, *(__child_i + 1))) {\x0a"
"            // right-child exists and is greater than left-child\x0a"
"            ++__child_i;\x0a"
"            ++__child;\x0a"
"        }\x0a"
"\x0a"
"        // check if we are in heap-order\x0a"
"    } while (\x21__comp(*__child_i, __top));\x0a"
"    *__start = _VSTD\x3a\x3amove(__top);\x0a"
"}\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"__pop_heap(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp,\x0a"
"           typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type __len)\x0a"
"{\x0a"
"    if (__len > 1)\x0a"
"    {\x0a"
"        swap(*__first, *--__last);\x0a"
"        __sift_down<_Compare>(__first, __last, __comp, __len - 1, __first);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"pop_heap(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    __pop_heap<_Comp_ref>(__first, __last, __comp, __last - __first);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"pop_heap(_RandomAccessIterator __first, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3apop_heap(__first, __last, __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// make_heap\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__make_heap(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    difference_type __n = __last - __first;\x0a"
"    if (__n > 1)\x0a"
"    {\x0a"
"        // start from the first parent, there is no need to consider children\x0a"
"        for (difference_type __start = (__n - 2) / 2; __start >= 0; --__start)\x0a"
"        {\x0a"
"            __sift_down<_Compare>(__first, __last, __comp, __n, __first + __start);\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"make_heap(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    __make_heap<_Comp_ref>(__first, __last, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"make_heap(_RandomAccessIterator __first, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3amake_heap(__first, __last, __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// sort_heap\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__sort_heap(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    for (difference_type __n = __last - __first; __n > 1; --__last, --__n)\x0a"
"        __pop_heap<_Compare>(__first, __last, __comp, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"sort_heap(_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    __sort_heap<_Comp_ref>(__first, __last, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"sort_heap(_RandomAccessIterator __first, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3asort_heap(__first, __last, __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// partial_sort\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__partial_sort(_RandomAccessIterator __first, _RandomAccessIterator __middle, _RandomAccessIterator __last,\x0a"
"             _Compare __comp)\x0a"
"{\x0a"
"    __make_heap<_Compare>(__first, __middle, __comp);\x0a"
"    typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type __len = __middle - __first;\x0a"
"    for (_RandomAccessIterator __i = __middle; __i \x21= __last; ++__i)\x0a"
"    {\x0a"
"        if (__comp(*__i, *__first))\x0a"
"        {\x0a"
"            swap(*__i, *__first);\x0a"
"            __sift_down<_Compare>(__first, __middle, __comp, __len, __first);\x0a"
"        }\x0a"
"    }\x0a"
"    __sort_heap<_Compare>(__first, __middle, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"partial_sort(_RandomAccessIterator __first, _RandomAccessIterator __middle, _RandomAccessIterator __last,\x0a"
"             _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    __partial_sort<_Comp_ref>(__first, __middle, __last, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"partial_sort(_RandomAccessIterator __first, _RandomAccessIterator __middle, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3apartial_sort(__first, __middle, __last,\x0a"
"                       __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// partial_sort_copy\x0a"
"\x0a"
"template <class _Compare, class _InputIterator, class _RandomAccessIterator>\x0a"
"_RandomAccessIterator\x0a"
"__partial_sort_copy(_InputIterator __first, _InputIterator __last,\x0a"
"                    _RandomAccessIterator __result_first, _RandomAccessIterator __result_last, _Compare __comp)\x0a"
"{\x0a"
"    _RandomAccessIterator __r = __result_first;\x0a"
"    if (__r \x21= __result_last)\x0a"
"    {\x0a"
"        for (; __first \x21= __last \x26\x26 __r \x21= __result_last; (void) ++__first, ++__r)\x0a"
"            *__r = *__first;\x0a"
"        __make_heap<_Compare>(__result_first, __r, __comp);\x0a"
"        typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type __len = __r - __result_first;\x0a"
"        for (; __first \x21= __last; ++__first)\x0a"
"            if (__comp(*__first, *__result_first))\x0a"
"            {\x0a"
"                *__result_first = *__first;\x0a"
"                __sift_down<_Compare>(__result_first, __r, __comp, __len, __result_first);\x0a"
"            }\x0a"
"        __sort_heap<_Compare>(__result_first, __r, __comp);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _RandomAccessIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_RandomAccessIterator\x0a"
"partial_sort_copy(_InputIterator __first, _InputIterator __last,\x0a"
"                  _RandomAccessIterator __result_first, _RandomAccessIterator __result_last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __partial_sort_copy<_Comp_ref>(__first, __last, __result_first, __result_last, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_RandomAccessIterator\x0a"
"partial_sort_copy(_InputIterator __first, _InputIterator __last,\x0a"
"                  _RandomAccessIterator __result_first, _RandomAccessIterator __result_last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3apartial_sort_copy(__first, __last, __result_first, __result_last,\x0a"
"                                   __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// nth_element\x0a"
"\x0a"
"template <class _Compare, class _RandomAccessIterator>\x0a"
"void\x0a"
"__nth_element(_RandomAccessIterator __first, _RandomAccessIterator __nth, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    // _Compare is known to be a reference type\x0a"
"    typedef typename iterator_traits<_RandomAccessIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    const difference_type __limit = 7;\x0a"
"    while (true)\x0a"
"    {\x0a"
"    __restart\x3a\x0a"
"        if (__nth == __last)\x0a"
"            return;\x0a"
"        difference_type __len = __last - __first;\x0a"
"        switch (__len)\x0a"
"        {\x0a"
"        case 0\x3a\x0a"
"        case 1\x3a\x0a"
"            return;\x0a"
"        case 2\x3a\x0a"
"            if (__comp(*--__last, *__first))\x0a"
"                swap(*__first, *__last);\x0a"
"            return;\x0a"
"        case 3\x3a\x0a"
"            {\x0a"
"            _RandomAccessIterator __m = __first;\x0a"
"            _VSTD\x3a\x3a__sort3<_Compare>(__first, ++__m, --__last, __comp);\x0a"
"            return;\x0a"
"            }\x0a"
"        }\x0a"
"        if (__len <= __limit)\x0a"
"        {\x0a"
"            __selection_sort<_Compare>(__first, __last, __comp);\x0a"
"            return;\x0a"
"        }\x0a"
"        // __len > __limit >= 3\x0a"
"        _RandomAccessIterator __m = __first + __len/2;\x0a"
"        _RandomAccessIterator __lm1 = __last;\x0a"
"        unsigned __n_swaps = _VSTD\x3a\x3a__sort3<_Compare>(__first, __m, --__lm1, __comp);\x0a"
"        // *__m is median\x0a"
"        // partition \x5b__first, __m) < *__m and *__m <= \x5b__m, __last)\x0a"
"        // (this inhibits tossing elements equivalent to __m around unnecessarily)\x0a"
"        _RandomAccessIterator __i = __first;\x0a"
"        _RandomAccessIterator __j = __lm1;\x0a"
"        // j points beyond range to be tested, *__lm1 is known to be <= *__m\x0a"
"        // The search going up is known to be guarded but the search coming down isn't.\x0a"
"        // Prime the downward search with a guard.\x0a"
"        if (\x21__comp(*__i, *__m))  // if *__first == *__m\x0a"
"        {\x0a"
"            // *__first == *__m, *__first doesn't go in first part\x0a"
"            // manually guard downward moving __j against __i\x0a"
"            while (true)\x0a"
"            {\x0a"
"                if (__i == --__j)\x0a"
"                {\x0a"
"                    // *__first == *__m, *__m <= all other elements\x0a"
"                    // Parition instead into \x5b__first, __i) == *__first and *__first < \x5b__i, __last)\x0a"
"                    ++__i;  // __first + 1\x0a"
"                    __j = __last;\x0a"
"                    if (\x21__comp(*__first, *--__j))  // we need a guard if *__first == *(__last-1)\x0a"
"                    {\x0a"
"                        while (true)\x0a"
"                        {\x0a"
"                            if (__i == __j)\x0a"
"                                return;  // \x5b__first, __last) all equivalent elements\x0a"
"                            if (__comp(*__first, *__i))\x0a"
"                            {\x0a"
"                                swap(*__i, *__j);\x0a"
"                                ++__n_swaps;\x0a"
"                                ++__i;\x0a"
"                                break;\x0a"
"                            }\x0a"
"                            ++__i;\x0a"
"                        }\x0a"
"                    }\x0a"
"                    // \x5b__first, __i) == *__first and *__first < \x5b__j, __last) and __j == __last - 1\x0a"
"                    if (__i == __j)\x0a"
"                        return;\x0a"
"                    while (true)\x0a"
"                    {\x0a"
"                        while (\x21__comp(*__first, *__i))\x0a"
"                            ++__i;\x0a"
"                        while (__comp(*__first, *--__j))\x0a"
"                            ;\x0a"
"                        if (__i >= __j)\x0a"
"                            break;\x0a"
"                        swap(*__i, *__j);\x0a"
"                        ++__n_swaps;\x0a"
"                        ++__i;\x0a"
"                    }\x0a"
"                    // \x5b__first, __i) == *__first and *__first < \x5b__i, __last)\x0a"
"                    // The first part is sorted,\x0a"
"                    if (__nth < __i)\x0a"
"                        return;\x0a"
"                    // __nth_element the secod part\x0a"
"                    // __nth_element<_Compare>(__i, __nth, __last, __comp);\x0a"
"                    __first = __i;\x0a"
"                    goto __restart;\x0a"
"                }\x0a"
"                if (__comp(*__j, *__m))\x0a"
"                {\x0a"
"                    swap(*__i, *__j);\x0a"
"                    ++__n_swaps;\x0a"
"                    break;  // found guard for downward moving __j, now use unguarded partition\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"        ++__i;\x0a"
"        // j points beyond range to be tested, *__lm1 is known to be <= *__m\x0a"
"        // if not yet partitioned...\x0a"
"        if (__i < __j)\x0a"
"        {\x0a"
"            // known that *(__i - 1) < *__m\x0a"
"            while (true)\x0a"
"            {\x0a"
"                // __m still guards upward moving __i\x0a"
"                while (__comp(*__i, *__m))\x0a"
"                    ++__i;\x0a"
"                // It is now known that a guard exists for downward moving __j\x0a"
"                while (\x21__comp(*--__j, *__m))\x0a"
"                    ;\x0a"
"                if (__i >= __j)\x0a"
"                    break;\x0a"
"                swap(*__i, *__j);\x0a"
"                ++__n_swaps;\x0a"
"                // It is known that __m \x21= __j\x0a"
"                // If __m just moved, follow it\x0a"
"                if (__m == __i)\x0a"
"                    __m = __j;\x0a"
"                ++__i;\x0a"
"            }\x0a"
"        }\x0a"
"        // \x5b__first, __i) < *__m and *__m <= \x5b__i, __last)\x0a"
"        if (__i \x21= __m \x26\x26 __comp(*__m, *__i))\x0a"
"        {\x0a"
"            swap(*__i, *__m);\x0a"
"            ++__n_swaps;\x0a"
"        }\x0a"
"        // \x5b__first, __i) < *__i and *__i <= \x5b__i+1, __last)\x0a"
"        if (__nth == __i)\x0a"
"            return;\x0a"
"        if (__n_swaps == 0)\x0a"
"        {\x0a"
"            // We were given a perfectly partitioned sequence.  Coincidence\x3f\x0a"
"            if (__nth < __i)\x0a"
"            {\x0a"
"                // Check for \x5b__first, __i) already sorted\x0a"
"                __j = __m = __first;\x0a"
"                while (++__j \x21= __i)\x0a"
"                {\x0a"
"                    if (__comp(*__j, *__m))\x0a"
"                        // not yet sorted, so sort\x0a"
"                        goto not_sorted;\x0a"
"                    __m = __j;\x0a"
"                }\x0a"
"                // \x5b__first, __i) sorted\x0a"
"                return;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                // Check for \x5b__i, __last) already sorted\x0a"
"                __j = __m = __i;\x0a"
"                while (++__j \x21= __last)\x0a"
"                {\x0a"
"                    if (__comp(*__j, *__m))\x0a"
"                        // not yet sorted, so sort\x0a"
"                        goto not_sorted;\x0a"
"                    __m = __j;\x0a"
"                }\x0a"
"                // \x5b__i, __last) sorted\x0a"
"                return;\x0a"
"            }\x0a"
"        }\x0a"
"not_sorted\x3a\x0a"
"        // __nth_element on range containing __nth\x0a"
"        if (__nth < __i)\x0a"
"        {\x0a"
"            // __nth_element<_Compare>(__first, __nth, __i, __comp);\x0a"
"            __last = __i;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            // __nth_element<_Compare>(__i+1, __nth, __last, __comp);\x0a"
"            __first = ++__i;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"nth_element(_RandomAccessIterator __first, _RandomAccessIterator __nth, _RandomAccessIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    __nth_element<_Comp_ref>(__first, __nth, __last, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _RandomAccessIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"nth_element(_RandomAccessIterator __first, _RandomAccessIterator __nth, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    _VSTD\x3a\x3anth_element(__first, __nth, __last, __less<typename iterator_traits<_RandomAccessIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// includes\x0a"
"\x0a"
"template <class _Compare, class _InputIterator1, class _InputIterator2>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"__includes(_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2,\x0a"
"           _Compare __comp)\x0a"
"{\x0a"
"    for (; __first2 \x21= __last2; ++__first1)\x0a"
"    {\x0a"
"        if (__first1 == __last1 \x7c\x7c __comp(*__first2, *__first1))\x0a"
"            return false;\x0a"
"        if (\x21__comp(*__first1, *__first2))\x0a"
"            ++__first2;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"includes(_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2,\x0a"
"         _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __includes<_Comp_ref>(__first1, __last1, __first2, __last2, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"includes(_InputIterator1 __first1, _InputIterator1 __last1, _InputIterator2 __first2, _InputIterator2 __last2)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aincludes(__first1, __last1, __first2, __last2,\x0a"
"                          __less<typename iterator_traits<_InputIterator1>\x3a\x3avalue_type,\x0a"
"                                 typename iterator_traits<_InputIterator2>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// set_union\x0a"
"\x0a"
"template <class _Compare, class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"__set_union(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"            _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    for (; __first1 \x21= __last1; ++__result)\x0a"
"    {\x0a"
"        if (__first2 == __last2)\x0a"
"            return _VSTD\x3a\x3a""copy(__first1, __last1, __result);\x0a"
"        if (__comp(*__first2, *__first1))\x0a"
"        {\x0a"
"            *__result = *__first2;\x0a"
"            ++__first2;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (\x21__comp(*__first1, *__first2))\x0a"
"                ++__first2;\x0a"
"            *__result = *__first1;\x0a"
"            ++__first1;\x0a"
"        }\x0a"
"    }\x0a"
"    return _VSTD\x3a\x3a""copy(__first2, __last2, __result);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"set_union(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"          _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __set_union<_Comp_ref>(__first1, __last1, __first2, __last2, __result, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"set_union(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"          _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aset_union(__first1, __last1, __first2, __last2, __result,\x0a"
"                          __less<typename iterator_traits<_InputIterator1>\x3a\x3avalue_type,\x0a"
"                                 typename iterator_traits<_InputIterator2>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// set_intersection\x0a"
"\x0a"
"template <class _Compare, class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 _OutputIterator\x0a"
"__set_intersection(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                   _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    while (__first1 \x21= __last1 \x26\x26 __first2 \x21= __last2)\x0a"
"    {\x0a"
"        if (__comp(*__first1, *__first2))\x0a"
"            ++__first1;\x0a"
"        else\x0a"
"        {\x0a"
"            if (\x21__comp(*__first2, *__first1))\x0a"
"            {\x0a"
"                *__result = *__first1;\x0a"
"                ++__result;\x0a"
"                ++__first1;\x0a"
"            }\x0a"
"            ++__first2;\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"set_intersection(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                 _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __set_intersection<_Comp_ref>(__first1, __last1, __first2, __last2, __result, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"_OutputIterator\x0a"
"set_intersection(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                 _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aset_intersection(__first1, __last1, __first2, __last2, __result,\x0a"
"                                  __less<typename iterator_traits<_InputIterator1>\x3a\x3avalue_type,\x0a"
"                                         typename iterator_traits<_InputIterator2>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// set_difference\x0a"
"\x0a"
"template <class _Compare, class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"__set_difference(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                 _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    while (__first1 \x21= __last1)\x0a"
"    {\x0a"
"        if (__first2 == __last2)\x0a"
"            return _VSTD\x3a\x3a""copy(__first1, __last1, __result);\x0a"
"        if (__comp(*__first1, *__first2))\x0a"
"        {\x0a"
"            *__result = *__first1;\x0a"
"            ++__result;\x0a"
"            ++__first1;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (\x21__comp(*__first2, *__first1))\x0a"
"                ++__first1;\x0a"
"            ++__first2;\x0a"
"        }\x0a"
"    }\x0a"
"    return __result;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"set_difference(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"               _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __set_difference<_Comp_ref>(__first1, __last1, __first2, __last2, __result, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"set_difference(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"               _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aset_difference(__first1, __last1, __first2, __last2, __result,\x0a"
"                                __less<typename iterator_traits<_InputIterator1>\x3a\x3avalue_type,\x0a"
"                                       typename iterator_traits<_InputIterator2>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// set_symmetric_difference\x0a"
"\x0a"
"template <class _Compare, class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"__set_symmetric_difference(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                           _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    while (__first1 \x21= __last1)\x0a"
"    {\x0a"
"        if (__first2 == __last2)\x0a"
"            return _VSTD\x3a\x3a""copy(__first1, __last1, __result);\x0a"
"        if (__comp(*__first1, *__first2))\x0a"
"        {\x0a"
"            *__result = *__first1;\x0a"
"            ++__result;\x0a"
"            ++__first1;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (__comp(*__first2, *__first1))\x0a"
"            {\x0a"
"                *__result = *__first2;\x0a"
"                ++__result;\x0a"
"            }\x0a"
"            else\x0a"
"                ++__first1;\x0a"
"            ++__first2;\x0a"
"        }\x0a"
"    }\x0a"
"    return _VSTD\x3a\x3a""copy(__first2, __last2, __result);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"set_symmetric_difference(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                         _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __set_symmetric_difference<_Comp_ref>(__first1, __last1, __first2, __last2, __result, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _OutputIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"set_symmetric_difference(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                         _InputIterator2 __first2, _InputIterator2 __last2, _OutputIterator __result)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aset_symmetric_difference(__first1, __last1, __first2, __last2, __result,\x0a"
"                                          __less<typename iterator_traits<_InputIterator1>\x3a\x3avalue_type,\x0a"
"                                                 typename iterator_traits<_InputIterator2>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// lexicographical_compare\x0a"
"\x0a"
"template <class _Compare, class _InputIterator1, class _InputIterator2>\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17 bool\x0a"
"__lexicographical_compare(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                          _InputIterator2 __first2, _InputIterator2 __last2, _Compare __comp)\x0a"
"{\x0a"
"    for (; __first2 \x21= __last2; ++__first1, (void) ++__first2)\x0a"
"    {\x0a"
"        if (__first1 == __last1 \x7c\x7c __comp(*__first1, *__first2))\x0a"
"            return true;\x0a"
"        if (__comp(*__first2, *__first1))\x0a"
"            return false;\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2, class _Compare>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"lexicographical_compare(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                        _InputIterator2 __first2, _InputIterator2 __last2, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __lexicographical_compare<_Comp_ref>(__first1, __last1, __first2, __last2, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator1, class _InputIterator2>\x0a"
"_LIBCPP_NODISCARD_EXT inline\x0a"
"_LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"bool\x0a"
"lexicographical_compare(_InputIterator1 __first1, _InputIterator1 __last1,\x0a"
"                        _InputIterator2 __first2, _InputIterator2 __last2)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alexicographical_compare(__first1, __last1, __first2, __last2,\x0a"
"                                         __less<typename iterator_traits<_InputIterator1>\x3a\x3avalue_type,\x0a"
"                                                typename iterator_traits<_InputIterator2>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// next_permutation\x0a"
"\x0a"
"template <class _Compare, class _BidirectionalIterator>\x0a"
"bool\x0a"
"__next_permutation(_BidirectionalIterator __first, _BidirectionalIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    _BidirectionalIterator __i = __last;\x0a"
"    if (__first == __last \x7c\x7c __first == --__i)\x0a"
"        return false;\x0a"
"    while (true)\x0a"
"    {\x0a"
"        _BidirectionalIterator __ip1 = __i;\x0a"
"        if (__comp(*--__i, *__ip1))\x0a"
"        {\x0a"
"            _BidirectionalIterator __j = __last;\x0a"
"            while (\x21__comp(*__i, *--__j))\x0a"
"                ;\x0a"
"            swap(*__i, *__j);\x0a"
"            _VSTD\x3a\x3areverse(__ip1, __last);\x0a"
"            return true;\x0a"
"        }\x0a"
"        if (__i == __first)\x0a"
"        {\x0a"
"            _VSTD\x3a\x3areverse(__first, __last);\x0a"
"            return false;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"next_permutation(_BidirectionalIterator __first, _BidirectionalIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __next_permutation<_Comp_ref>(__first, __last, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"next_permutation(_BidirectionalIterator __first, _BidirectionalIterator __last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3anext_permutation(__first, __last,\x0a"
"                                  __less<typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"// prev_permutation\x0a"
"\x0a"
"template <class _Compare, class _BidirectionalIterator>\x0a"
"bool\x0a"
"__prev_permutation(_BidirectionalIterator __first, _BidirectionalIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    _BidirectionalIterator __i = __last;\x0a"
"    if (__first == __last \x7c\x7c __first == --__i)\x0a"
"        return false;\x0a"
"    while (true)\x0a"
"    {\x0a"
"        _BidirectionalIterator __ip1 = __i;\x0a"
"        if (__comp(*__ip1, *--__i))\x0a"
"        {\x0a"
"            _BidirectionalIterator __j = __last;\x0a"
"            while (\x21__comp(*--__j, *__i))\x0a"
"                ;\x0a"
"            swap(*__i, *__j);\x0a"
"            _VSTD\x3a\x3areverse(__ip1, __last);\x0a"
"            return true;\x0a"
"        }\x0a"
"        if (__i == __first)\x0a"
"        {\x0a"
"            _VSTD\x3a\x3areverse(__first, __last);\x0a"
"            return false;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Compare>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"prev_permutation(_BidirectionalIterator __first, _BidirectionalIterator __last, _Compare __comp)\x0a"
"{\x0a"
"    typedef typename __comp_ref_type<_Compare>\x3a\x3atype _Comp_ref;\x0a"
"    return __prev_permutation<_Comp_ref>(__first, __last, __comp);\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"prev_permutation(_BidirectionalIterator __first, _BidirectionalIterator __last)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aprev_permutation(__first, __last,\x0a"
"                                  __less<typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type>());\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_ALGORITHM\x0a"
"", 201954 ); }