#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_deque( 
"// -*- C++ -*-\x0a"
"//===---------------------------- deque -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_DEQUE\x0a"
"#define _LIBCPP_DEQUE\x0a"
"\x0a"
"/*\x0a"
"    deque synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class T, class Allocator = allocator<T> >\x0a"
"class deque\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef T value_type;\x0a"
"    typedef Allocator allocator_type;\x0a"
"\x0a"
"    typedef typename allocator_type\x3a\x3areference       reference;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef implementation-defined                   iterator;\x0a"
"    typedef implementation-defined                   const_iterator;\x0a"
"    typedef typename allocator_type\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_type\x3a\x3a""difference_type difference_type;\x0a"
"\x0a"
"    typedef typename allocator_type\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator>          reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator>    const_reverse_iterator;\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    deque() noexcept(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    explicit deque(const allocator_type\x26 a);\x0a"
"    explicit deque(size_type n);\x0a"
"    explicit deque(size_type n, const allocator_type\x26 a); // C++14\x0a"
"    deque(size_type n, const value_type\x26 v);\x0a"
"    deque(size_type n, const value_type\x26 v, const allocator_type\x26 a);\x0a"
"    template <class InputIterator>\x0a"
"        deque(InputIterator f, InputIterator l);\x0a"
"    template <class InputIterator>\x0a"
"        deque(InputIterator f, InputIterator l, const allocator_type\x26 a);\x0a"
"    deque(const deque\x26 c);\x0a"
"    deque(deque\x26\x26 c)\x0a"
"        noexcept(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    deque(initializer_list<value_type> il, const Allocator\x26 a = allocator_type());\x0a"
"    deque(const deque\x26 c, const allocator_type\x26 a);\x0a"
"    deque(deque\x26\x26 c, const allocator_type\x26 a);\x0a"
"    \x7e""deque();\x0a"
"\x0a"
"    deque\x26 operator=(const deque\x26 c);\x0a"
"    deque\x26 operator=(deque\x26\x26 c)\x0a"
"        noexcept(\x0a"
"             allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"             is_nothrow_move_assignable<allocator_type>\x3a\x3avalue);\x0a"
"    deque\x26 operator=(initializer_list<value_type> il);\x0a"
"\x0a"
"    template <class InputIterator>\x0a"
"        void assign(InputIterator f, InputIterator l);\x0a"
"    void assign(size_type n, const value_type\x26 v);\x0a"
"    void assign(initializer_list<value_type> il);\x0a"
"\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"\x0a"
"    // iterators\x3a\x0a"
"\x0a"
"    iterator       begin() noexcept;\x0a"
"    const_iterator begin() const noexcept;\x0a"
"    iterator       end() noexcept;\x0a"
"    const_iterator end() const noexcept;\x0a"
"\x0a"
"    reverse_iterator       rbegin() noexcept;\x0a"
"    const_reverse_iterator rbegin() const noexcept;\x0a"
"    reverse_iterator       rend() noexcept;\x0a"
"    const_reverse_iterator rend() const noexcept;\x0a"
"\x0a"
"    const_iterator         cbegin() const noexcept;\x0a"
"    const_iterator         cend() const noexcept;\x0a"
"    const_reverse_iterator crbegin() const noexcept;\x0a"
"    const_reverse_iterator crend() const noexcept;\x0a"
"\x0a"
"    // capacity\x3a\x0a"
"    size_type size() const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"    void resize(size_type n);\x0a"
"    void resize(size_type n, const value_type\x26 v);\x0a"
"    void shrink_to_fit();\x0a"
"    bool empty() const noexcept;\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    reference operator\x5b\x5d(size_type i);\x0a"
"    const_reference operator\x5b\x5d(size_type i) const;\x0a"
"    reference at(size_type i);\x0a"
"    const_reference at(size_type i) const;\x0a"
"    reference front();\x0a"
"    const_reference front() const;\x0a"
"    reference back();\x0a"
"    const_reference back() const;\x0a"
"\x0a"
"    // modifiers\x3a\x0a"
"    void push_front(const value_type\x26 v);\x0a"
"    void push_front(value_type\x26\x26 v);\x0a"
"    void push_back(const value_type\x26 v);\x0a"
"    void push_back(value_type\x26\x26 v);\x0a"
"    template <class... Args> reference emplace_front(Args\x26\x26... args);  // reference in C++17\x0a"
"    template <class... Args> reference emplace_back(Args\x26\x26... args);   // reference in C++17\x0a"
"    template <class... Args> iterator emplace(const_iterator p, Args\x26\x26... args);\x0a"
"    iterator insert(const_iterator p, const value_type\x26 v);\x0a"
"    iterator insert(const_iterator p, value_type\x26\x26 v);\x0a"
"    iterator insert(const_iterator p, size_type n, const value_type\x26 v);\x0a"
"    template <class InputIterator>\x0a"
"        iterator insert(const_iterator p, InputIterator f, InputIterator l);\x0a"
"    iterator insert(const_iterator p, initializer_list<value_type> il);\x0a"
"    void pop_front();\x0a"
"    void pop_back();\x0a"
"    iterator erase(const_iterator p);\x0a"
"    iterator erase(const_iterator f, const_iterator l);\x0a"
"    void swap(deque\x26 c)\x0a"
"        noexcept(allocator_traits<allocator_type>\x3a\x3ais_always_equal\x3a\x3avalue);  // C++17\x0a"
"    void clear() noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class InputIterator, class Allocator = allocator<typename iterator_traits<InputIterator>\x3a\x3avalue_type>>\x0a"
"   deque(InputIterator, InputIterator, Allocator = Allocator())\x0a"
"   -> deque<typename iterator_traits<InputIterator>\x3a\x3avalue_type, Allocator>;\x0a"
"\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator==(const deque<T,Allocator>\x26 x, const deque<T,Allocator>\x26 y);\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator< (const deque<T,Allocator>\x26 x, const deque<T,Allocator>\x26 y);\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator\x21=(const deque<T,Allocator>\x26 x, const deque<T,Allocator>\x26 y);\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator> (const deque<T,Allocator>\x26 x, const deque<T,Allocator>\x26 y);\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator>=(const deque<T,Allocator>\x26 x, const deque<T,Allocator>\x26 y);\x0a"
"template <class T, class Allocator>\x0a"
"    bool operator<=(const deque<T,Allocator>\x26 x, const deque<T,Allocator>\x26 y);\x0a"
"\x0a"
"// specialized algorithms\x3a\x0a"
"template <class T, class Allocator>\x0a"
"    void swap(deque<T,Allocator>\x26 x, deque<T,Allocator>\x26 y)\x0a"
"         noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class T, class Allocator, class U>\x0a"
"    void erase(deque<T, Allocator>\x26 c, const U\x26 value);       // C++20\x0a"
"template <class T, class Allocator, class Predicate>\x0a"
"    void erase_if(deque<T, Allocator>\x26 c, Predicate pred);    // C++20\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <__split_buffer>\x0a"
"#include <type_traits>\x0a"
"#include <initializer_list>\x0a"
"#include <iterator>\x0a"
"#include <algorithm>\x0a"
"#include <stdexcept>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _Tp, class _Allocator> class __deque_base;\x0a"
"template <class _Tp, class _Allocator = allocator<_Tp> > class _LIBCPP_TEMPLATE_VIS deque;\x0a"
"\x0a"
"template <class _ValueType, class _Pointer, class _Reference, class _MapPointer,\x0a"
"          class _DiffType, _DiffType _BlockSize>\x0a"
"class _LIBCPP_TEMPLATE_VIS __deque_iterator;\x0a"
"\x0a"
"template <class _RAIter,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"copy(_RAIter __f,\x0a"
"     _RAIter __l,\x0a"
"     __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"     typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"copy(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"     __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"     _OutputIterator __r);\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"copy(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"     __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"     __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r);\x0a"
"\x0a"
"template <class _RAIter,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"copy_backward(_RAIter __f,\x0a"
"              _RAIter __l,\x0a"
"              __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"              typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"copy_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"              __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"              _OutputIterator __r);\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"copy_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"              __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"              __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r);\x0a"
"\x0a"
"template <class _RAIter,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"move(_RAIter __f,\x0a"
"     _RAIter __l,\x0a"
"     __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"     typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"move(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"     __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"     _OutputIterator __r);\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"move(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"     __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"     __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r);\x0a"
"\x0a"
"template <class _RAIter,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"move_backward(_RAIter __f,\x0a"
"              _RAIter __l,\x0a"
"              __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"              typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"move_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"              __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"              _OutputIterator __r);\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"move_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"              __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"              __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r);\x0a"
"\x0a"
"template <class _ValueType, class _DiffType>\x0a"
"struct __deque_block_size {\x0a"
"  static const _DiffType value = sizeof(_ValueType) < 256 \x3f 4096 / sizeof(_ValueType) \x3a 16;\x0a"
"};\x0a"
"\x0a"
"template <class _ValueType, class _Pointer, class _Reference, class _MapPointer,\x0a"
"          class _DiffType, _DiffType _BS =\x0a"
"#ifdef _LIBCPP_ABI_INCOMPLETE_TYPES_IN_DEQUE\x0a"
"// Keep template parameter to avoid changing all template declarations thoughout\x0a"
"// this file.\x0a"
"                               0\x0a"
"#else\x0a"
"                               __deque_block_size<_ValueType, _DiffType>\x3a\x3avalue\x0a"
"#endif\x0a"
"          >\x0a"
"class _LIBCPP_TEMPLATE_VIS __deque_iterator\x0a"
"{\x0a"
"    typedef _MapPointer __map_iterator;\x0a"
"public\x3a\x0a"
"    typedef _Pointer  pointer;\x0a"
"    typedef _DiffType difference_type;\x0a"
"private\x3a\x0a"
"    __map_iterator __m_iter_;\x0a"
"    pointer        __ptr_;\x0a"
"\x0a"
"    static const difference_type __block_size;\x0a"
"public\x3a\x0a"
"    typedef _ValueType                  value_type;\x0a"
"    typedef random_access_iterator_tag  iterator_category;\x0a"
"    typedef _Reference                  reference;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __deque_iterator() _NOEXCEPT\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"     \x3a __m_iter_(nullptr), __ptr_(nullptr)\x0a"
"#endif\x0a"
"     {}\x0a"
"\x0a"
"    template <class _Pp, class _Rp, class _MP>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __deque_iterator(const __deque_iterator<value_type, _Pp, _Rp, _MP, difference_type, _BS>\x26 __it,\x0a"
"                typename enable_if<is_convertible<_Pp, pointer>\x3a\x3avalue>\x3a\x3atype* = 0) _NOEXCEPT\x0a"
"        \x3a __m_iter_(__it.__m_iter_), __ptr_(__it.__ptr_) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference operator*() const {return *__ptr_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY pointer operator->() const {return __ptr_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __deque_iterator\x26 operator++()\x0a"
"    {\x0a"
"        if (++__ptr_ - *__m_iter_ == __block_size)\x0a"
"        {\x0a"
"            ++__m_iter_;\x0a"
"            __ptr_ = *__m_iter_;\x0a"
"        }\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __deque_iterator operator++(int)\x0a"
"    {\x0a"
"        __deque_iterator __tmp = *this;\x0a"
"        ++(*this);\x0a"
"        return __tmp;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __deque_iterator\x26 operator--()\x0a"
"    {\x0a"
"        if (__ptr_ == *__m_iter_)\x0a"
"        {\x0a"
"            --__m_iter_;\x0a"
"            __ptr_ = *__m_iter_ + __block_size;\x0a"
"        }\x0a"
"        --__ptr_;\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __deque_iterator operator--(int)\x0a"
"    {\x0a"
"        __deque_iterator __tmp = *this;\x0a"
"        --(*this);\x0a"
"        return __tmp;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __deque_iterator\x26 operator+=(difference_type __n)\x0a"
"    {\x0a"
"        if (__n \x21= 0)\x0a"
"        {\x0a"
"            __n += __ptr_ - *__m_iter_;\x0a"
"            if (__n > 0)\x0a"
"            {\x0a"
"                __m_iter_ += __n / __block_size;\x0a"
"                __ptr_ = *__m_iter_ + __n \x25 __block_size;\x0a"
"            }\x0a"
"            else // (__n < 0)\x0a"
"            {\x0a"
"                difference_type __z = __block_size - 1 - __n;\x0a"
"                __m_iter_ -= __z / __block_size;\x0a"
"                __ptr_ = *__m_iter_ + (__block_size - 1 - __z \x25 __block_size);\x0a"
"            }\x0a"
"        }\x0a"
"        return *this;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __deque_iterator\x26 operator-=(difference_type __n)\x0a"
"    {\x0a"
"        return *this += -__n;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __deque_iterator operator+(difference_type __n) const\x0a"
"    {\x0a"
"        __deque_iterator __t(*this);\x0a"
"        __t += __n;\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY __deque_iterator operator-(difference_type __n) const\x0a"
"    {\x0a"
"        __deque_iterator __t(*this);\x0a"
"        __t -= __n;\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    friend __deque_iterator operator+(difference_type __n, const __deque_iterator\x26 __it)\x0a"
"        {return __it + __n;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    friend difference_type operator-(const __deque_iterator\x26 __x, const __deque_iterator\x26 __y)\x0a"
"    {\x0a"
"        if (__x \x21= __y)\x0a"
"            return (__x.__m_iter_ - __y.__m_iter_) * __block_size\x0a"
"                 + (__x.__ptr_ - *__x.__m_iter_)\x0a"
"                 - (__y.__ptr_ - *__y.__m_iter_);\x0a"
"        return 0;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference operator\x5b\x5d(difference_type __n) const\x0a"
"        {return *(*this + __n);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY friend\x0a"
"        bool operator==(const __deque_iterator\x26 __x, const __deque_iterator\x26 __y)\x0a"
"        {return __x.__ptr_ == __y.__ptr_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY friend\x0a"
"        bool operator\x21=(const __deque_iterator\x26 __x, const __deque_iterator\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY friend\x0a"
"        bool operator<(const __deque_iterator\x26 __x, const __deque_iterator\x26 __y)\x0a"
"        {return __x.__m_iter_ < __y.__m_iter_ \x7c\x7c\x0a"
"               (__x.__m_iter_ == __y.__m_iter_ \x26\x26 __x.__ptr_ < __y.__ptr_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY friend\x0a"
"        bool operator>(const __deque_iterator\x26 __x, const __deque_iterator\x26 __y)\x0a"
"        {return __y < __x;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY friend\x0a"
"        bool operator<=(const __deque_iterator\x26 __x, const __deque_iterator\x26 __y)\x0a"
"        {return \x21(__y < __x);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY friend\x0a"
"        bool operator>=(const __deque_iterator\x26 __x, const __deque_iterator\x26 __y)\x0a"
"        {return \x21(__x < __y);}\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY __deque_iterator(__map_iterator __m, pointer __p) _NOEXCEPT\x0a"
"        \x3a __m_iter_(__m), __ptr_(__p) {}\x0a"
"\x0a"
"    template <class _Tp, class _Ap> friend class __deque_base;\x0a"
"    template <class _Tp, class _Ap> friend class _LIBCPP_TEMPLATE_VIS deque;\x0a"
"    template <class _Vp, class _Pp, class _Rp, class _MP, class _Dp, _Dp>\x0a"
"        friend class _LIBCPP_TEMPLATE_VIS __deque_iterator;\x0a"
"\x0a"
"    template <class _RAIter,\x0a"
"              class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"    friend\x0a"
"    __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"    copy(_RAIter __f,\x0a"
"         _RAIter __l,\x0a"
"         __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"         typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype*);\x0a"
"\x0a"
"    template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"              class _OutputIterator>\x0a"
"    friend\x0a"
"    _OutputIterator\x0a"
"    copy(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"         __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"         _OutputIterator __r);\x0a"
"\x0a"
"    template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"              class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"    friend\x0a"
"    __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"    copy(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"         __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"         __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r);\x0a"
"\x0a"
"    template <class _RAIter,\x0a"
"              class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"    friend\x0a"
"    __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"    copy_backward(_RAIter __f,\x0a"
"                  _RAIter __l,\x0a"
"                  __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"                  typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype*);\x0a"
"\x0a"
"    template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"              class _OutputIterator>\x0a"
"    friend\x0a"
"    _OutputIterator\x0a"
"    copy_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"                  __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"                  _OutputIterator __r);\x0a"
"\x0a"
"    template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"              class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"    friend\x0a"
"    __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"    copy_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"                  __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"                  __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r);\x0a"
"\x0a"
"    template <class _RAIter,\x0a"
"              class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"    friend\x0a"
"    __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"    move(_RAIter __f,\x0a"
"         _RAIter __l,\x0a"
"         __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"         typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype*);\x0a"
"\x0a"
"    template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"              class _OutputIterator>\x0a"
"    friend\x0a"
"    _OutputIterator\x0a"
"    move(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"         __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"         _OutputIterator __r);\x0a"
"\x0a"
"    template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"              class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"    friend\x0a"
"    __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"    move(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"         __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"         __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r);\x0a"
"\x0a"
"    template <class _RAIter,\x0a"
"              class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"    friend\x0a"
"    __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"    move_backward(_RAIter __f,\x0a"
"                  _RAIter __l,\x0a"
"                  __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"                  typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype*);\x0a"
"\x0a"
"    template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"              class _OutputIterator>\x0a"
"    friend\x0a"
"    _OutputIterator\x0a"
"    move_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"                  __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"                  _OutputIterator __r);\x0a"
"\x0a"
"    template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"              class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"    friend\x0a"
"    __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"    move_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"                  __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"                  __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r);\x0a"
"};\x0a"
"\x0a"
"template <class _ValueType, class _Pointer, class _Reference, class _MapPointer,\x0a"
"          class _DiffType, _DiffType _BlockSize>\x0a"
"const _DiffType __deque_iterator<_ValueType, _Pointer, _Reference, _MapPointer,\x0a"
"                                 _DiffType, _BlockSize>\x3a\x3a__block_size =\x0a"
"    __deque_block_size<_ValueType, _DiffType>\x3a\x3avalue;\x0a"
"\x0a"
"// copy\x0a"
"\x0a"
"template <class _RAIter,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"copy(_RAIter __f,\x0a"
"     _RAIter __l,\x0a"
"     __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"     typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x3a\x3apointer pointer;\x0a"
"    const difference_type __block_size = __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x3a\x3a__block_size;\x0a"
"    while (__f \x21= __l)\x0a"
"    {\x0a"
"        pointer __rb = __r.__ptr_;\x0a"
"        pointer __re = *__r.__m_iter_ + __block_size;\x0a"
"        difference_type __bs = __re - __rb;\x0a"
"        difference_type __n = __l - __f;\x0a"
"        _RAIter __m = __l;\x0a"
"        if (__n > __bs)\x0a"
"        {\x0a"
"            __n = __bs;\x0a"
"            __m = __f + __n;\x0a"
"        }\x0a"
"        _VSTD\x3a\x3a""copy(__f, __m, __rb);\x0a"
"        __f = __m;\x0a"
"        __r += __n;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"copy(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"     __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"     _OutputIterator __r)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3apointer pointer;\x0a"
"    const difference_type __block_size = __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a__block_size;\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        pointer __fb = __f.__ptr_;\x0a"
"        pointer __fe = *__f.__m_iter_ + __block_size;\x0a"
"        difference_type __bs = __fe - __fb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __fe = __fb + __bs;\x0a"
"        }\x0a"
"        __r = _VSTD\x3a\x3a""copy(__fb, __fe, __r);\x0a"
"        __n -= __bs;\x0a"
"        __f += __bs;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"copy(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"     __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"     __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3apointer pointer;\x0a"
"    const difference_type __block_size = __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a__block_size;\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        pointer __fb = __f.__ptr_;\x0a"
"        pointer __fe = *__f.__m_iter_ + __block_size;\x0a"
"        difference_type __bs = __fe - __fb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __fe = __fb + __bs;\x0a"
"        }\x0a"
"        __r = _VSTD\x3a\x3a""copy(__fb, __fe, __r);\x0a"
"        __n -= __bs;\x0a"
"        __f += __bs;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// copy_backward\x0a"
"\x0a"
"template <class _RAIter,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"copy_backward(_RAIter __f,\x0a"
"              _RAIter __l,\x0a"
"              __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"              typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x3a\x3apointer pointer;\x0a"
"    while (__f \x21= __l)\x0a"
"    {\x0a"
"        __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __rp = _VSTD\x3a\x3aprev(__r);\x0a"
"        pointer __rb = *__rp.__m_iter_;\x0a"
"        pointer __re = __rp.__ptr_ + 1;\x0a"
"        difference_type __bs = __re - __rb;\x0a"
"        difference_type __n = __l - __f;\x0a"
"        _RAIter __m = __f;\x0a"
"        if (__n > __bs)\x0a"
"        {\x0a"
"            __n = __bs;\x0a"
"            __m = __l - __n;\x0a"
"        }\x0a"
"        _VSTD\x3a\x3a""copy_backward(__m, __l, __re);\x0a"
"        __l = __m;\x0a"
"        __r -= __n;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"copy_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"              __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"              _OutputIterator __r)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3apointer pointer;\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        --__l;\x0a"
"        pointer __lb = *__l.__m_iter_;\x0a"
"        pointer __le = __l.__ptr_ + 1;\x0a"
"        difference_type __bs = __le - __lb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __lb = __le - __bs;\x0a"
"        }\x0a"
"        __r = _VSTD\x3a\x3a""copy_backward(__lb, __le, __r);\x0a"
"        __n -= __bs;\x0a"
"        __l -= __bs - 1;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"copy_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"              __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"              __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3apointer pointer;\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        --__l;\x0a"
"        pointer __lb = *__l.__m_iter_;\x0a"
"        pointer __le = __l.__ptr_ + 1;\x0a"
"        difference_type __bs = __le - __lb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __lb = __le - __bs;\x0a"
"        }\x0a"
"        __r = _VSTD\x3a\x3a""copy_backward(__lb, __le, __r);\x0a"
"        __n -= __bs;\x0a"
"        __l -= __bs - 1;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// move\x0a"
"\x0a"
"template <class _RAIter,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"move(_RAIter __f,\x0a"
"     _RAIter __l,\x0a"
"     __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"     typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x3a\x3apointer pointer;\x0a"
"    const difference_type __block_size = __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x3a\x3a__block_size;\x0a"
"    while (__f \x21= __l)\x0a"
"    {\x0a"
"        pointer __rb = __r.__ptr_;\x0a"
"        pointer __re = *__r.__m_iter_ + __block_size;\x0a"
"        difference_type __bs = __re - __rb;\x0a"
"        difference_type __n = __l - __f;\x0a"
"        _RAIter __m = __l;\x0a"
"        if (__n > __bs)\x0a"
"        {\x0a"
"            __n = __bs;\x0a"
"            __m = __f + __n;\x0a"
"        }\x0a"
"        _VSTD\x3a\x3amove(__f, __m, __rb);\x0a"
"        __f = __m;\x0a"
"        __r += __n;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"move(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"     __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"     _OutputIterator __r)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3apointer pointer;\x0a"
"    const difference_type __block_size = __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a__block_size;\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        pointer __fb = __f.__ptr_;\x0a"
"        pointer __fe = *__f.__m_iter_ + __block_size;\x0a"
"        difference_type __bs = __fe - __fb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __fe = __fb + __bs;\x0a"
"        }\x0a"
"        __r = _VSTD\x3a\x3amove(__fb, __fe, __r);\x0a"
"        __n -= __bs;\x0a"
"        __f += __bs;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"move(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"     __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"     __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3apointer pointer;\x0a"
"    const difference_type __block_size = __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a__block_size;\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        pointer __fb = __f.__ptr_;\x0a"
"        pointer __fe = *__f.__m_iter_ + __block_size;\x0a"
"        difference_type __bs = __fe - __fb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __fe = __fb + __bs;\x0a"
"        }\x0a"
"        __r = _VSTD\x3a\x3amove(__fb, __fe, __r);\x0a"
"        __n -= __bs;\x0a"
"        __f += __bs;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// move_backward\x0a"
"\x0a"
"template <class _RAIter,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"move_backward(_RAIter __f,\x0a"
"              _RAIter __l,\x0a"
"              __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r,\x0a"
"              typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x3a\x3apointer pointer;\x0a"
"    while (__f \x21= __l)\x0a"
"    {\x0a"
"        __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __rp = _VSTD\x3a\x3aprev(__r);\x0a"
"        pointer __rb = *__rp.__m_iter_;\x0a"
"        pointer __re = __rp.__ptr_ + 1;\x0a"
"        difference_type __bs = __re - __rb;\x0a"
"        difference_type __n = __l - __f;\x0a"
"        _RAIter __m = __f;\x0a"
"        if (__n > __bs)\x0a"
"        {\x0a"
"            __n = __bs;\x0a"
"            __m = __l - __n;\x0a"
"        }\x0a"
"        _VSTD\x3a\x3amove_backward(__m, __l, __re);\x0a"
"        __l = __m;\x0a"
"        __r -= __n;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _OutputIterator>\x0a"
"_OutputIterator\x0a"
"move_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"              __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"              _OutputIterator __r)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3apointer pointer;\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        --__l;\x0a"
"        pointer __lb = *__l.__m_iter_;\x0a"
"        pointer __le = __l.__ptr_ + 1;\x0a"
"        difference_type __bs = __le - __lb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __lb = __le - __bs;\x0a"
"        }\x0a"
"        __r = _VSTD\x3a\x3amove_backward(__lb, __le, __r);\x0a"
"        __n -= __bs;\x0a"
"        __l -= __bs - 1;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _V1, class _P1, class _R1, class _M1, class _D1, _D1 _B1,\x0a"
"          class _V2, class _P2, class _R2, class _M2, class _D2, _D2 _B2>\x0a"
"__deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2>\x0a"
"move_backward(__deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __f,\x0a"
"              __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1> __l,\x0a"
"              __deque_iterator<_V2, _P2, _R2, _M2, _D2, _B2> __r)\x0a"
"{\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __deque_iterator<_V1, _P1, _R1, _M1, _D1, _B1>\x3a\x3apointer pointer;\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        --__l;\x0a"
"        pointer __lb = *__l.__m_iter_;\x0a"
"        pointer __le = __l.__ptr_ + 1;\x0a"
"        difference_type __bs = __le - __lb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __lb = __le - __bs;\x0a"
"        }\x0a"
"        __r = _VSTD\x3a\x3amove_backward(__lb, __le, __r);\x0a"
"        __n -= __bs;\x0a"
"        __l -= __bs - 1;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <bool>\x0a"
"class __deque_base_common\x0a"
"{\x0a"
"protected\x3a\x0a"
"    _LIBCPP_NORETURN void __throw_length_error() const;\x0a"
"    _LIBCPP_NORETURN void __throw_out_of_range() const;\x0a"
"};\x0a"
"\x0a"
"template <bool __b>\x0a"
"void\x0a"
"__deque_base_common<__b>\x3a\x3a__throw_length_error() const\x0a"
"{\x0a"
"    _VSTD\x3a\x3a__throw_length_error(\x22""deque\x22);\x0a"
"}\x0a"
"\x0a"
"template <bool __b>\x0a"
"void\x0a"
"__deque_base_common<__b>\x3a\x3a__throw_out_of_range() const\x0a"
"{\x0a"
"    _VSTD\x3a\x3a__throw_out_of_range(\x22""deque\x22);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"class __deque_base\x0a"
"    \x3a protected __deque_base_common<true>\x0a"
"{\x0a"
"    __deque_base(const __deque_base\x26 __c);\x0a"
"    __deque_base\x26 operator=(const __deque_base\x26 __c);\x0a"
"public\x3a\x0a"
"    typedef _Allocator                               allocator_type;\x0a"
"    typedef allocator_traits<allocator_type>         __alloc_traits;\x0a"
"    typedef typename __alloc_traits\x3a\x3asize_type       size_type;\x0a"
"protected\x3a\x0a"
"    typedef _Tp                                      value_type;\x0a"
"    typedef value_type\x26                              reference;\x0a"
"    typedef const value_type\x26                        const_reference;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer         pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer   const_pointer;\x0a"
"\x0a"
"    static const difference_type __block_size;\x0a"
"\x0a"
"    typedef typename __rebind_alloc_helper<__alloc_traits, pointer>\x3a\x3atype __pointer_allocator;\x0a"
"    typedef allocator_traits<__pointer_allocator>        __map_traits;\x0a"
"    typedef typename __map_traits\x3a\x3apointer               __map_pointer;\x0a"
"    typedef typename __rebind_alloc_helper<__alloc_traits, const_pointer>\x3a\x3atype __const_pointer_allocator;\x0a"
"    typedef typename allocator_traits<__const_pointer_allocator>\x3a\x3a""const_pointer __map_const_pointer;\x0a"
"    typedef __split_buffer<pointer, __pointer_allocator> __map;\x0a"
"\x0a"
"    typedef __deque_iterator<value_type, pointer, reference, __map_pointer,\x0a"
"                             difference_type>    iterator;\x0a"
"    typedef __deque_iterator<value_type, const_pointer, const_reference, __map_const_pointer,\x0a"
"                             difference_type>    const_iterator;\x0a"
"\x0a"
"protected\x3a\x0a"
"    __map __map_;\x0a"
"    size_type __start_;\x0a"
"    __compressed_pair<size_type, allocator_type> __size_;\x0a"
"\x0a"
"    iterator       begin() _NOEXCEPT;\x0a"
"    const_iterator begin() const _NOEXCEPT;\x0a"
"    iterator       end() _NOEXCEPT;\x0a"
"    const_iterator end() const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_type\x26            size()          {return __size_.first();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const size_type\x26 size() const _NOEXCEPT {return __size_.first();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY allocator_type\x26       __alloc()       {return __size_.second();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const allocator_type\x26 __alloc() const _NOEXCEPT {return __size_.second();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __deque_base()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __deque_base(const allocator_type\x26 __a);\x0a"
"public\x3a\x0a"
"    \x7e__deque_base();\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    __deque_base(__deque_base\x26\x26 __c)\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    __deque_base(__deque_base\x26\x26 __c, const allocator_type\x26 __a);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    void swap(__deque_base\x26 __c)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT;\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<allocator_type>\x3a\x3avalue);\x0a"
"#endif\x0a"
"protected\x3a\x0a"
"    void clear() _NOEXCEPT;\x0a"
"\x0a"
"    bool __invariants() const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign(__deque_base\x26 __c)\x0a"
"        _NOEXCEPT_(__alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"    {\x0a"
"        __map_ = _VSTD\x3a\x3amove(__c.__map_);\x0a"
"        __start_ = __c.__start_;\x0a"
"        size() = __c.size();\x0a"
"        __move_assign_alloc(__c);\x0a"
"        __c.__start_ = __c.size() = 0;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__deque_base\x26 __c)\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"                   is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"        {__move_assign_alloc(__c, integral_constant<bool,\x0a"
"                      __alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__deque_base\x26 __c, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"        {\x0a"
"            __alloc() = _VSTD\x3a\x3amove(__c.__alloc());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__deque_base\x26, false_type) _NOEXCEPT\x0a"
"        {}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"const typename __deque_base<_Tp, _Allocator>\x3a\x3a""difference_type\x0a"
"    __deque_base<_Tp, _Allocator>\x3a\x3a__block_size =\x0a"
"        __deque_block_size<value_type, difference_type>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"bool\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a__invariants() const\x0a"
"{\x0a"
"    if (\x21__map_.__invariants())\x0a"
"        return false;\x0a"
"    if (__map_.size() >= size_type(-1) / __block_size)\x0a"
"        return false;\x0a"
"    for (typename __map\x3a\x3a""const_iterator __i = __map_.begin(), __e = __map_.end();\x0a"
"         __i \x21= __e; ++__i)\x0a"
"        if (*__i == nullptr)\x0a"
"            return false;\x0a"
"    if (__map_.size() \x21= 0)\x0a"
"    {\x0a"
"        if (size() >= __map_.size() * __block_size)\x0a"
"            return false;\x0a"
"        if (__start_ >= __map_.size() * __block_size - size())\x0a"
"            return false;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        if (size() \x21= 0)\x0a"
"            return false;\x0a"
"        if (__start_ \x21= 0)\x0a"
"            return false;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename __deque_base<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a""begin() _NOEXCEPT\x0a"
"{\x0a"
"    __map_pointer __mp = __map_.begin() + __start_ / __block_size;\x0a"
"    return iterator(__mp, __map_.empty() \x3f 0 \x3a *__mp + __start_ \x25 __block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename __deque_base<_Tp, _Allocator>\x3a\x3a""const_iterator\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a""begin() const _NOEXCEPT\x0a"
"{\x0a"
"    __map_const_pointer __mp = static_cast<__map_const_pointer>(__map_.begin() + __start_ / __block_size);\x0a"
"    return const_iterator(__mp, __map_.empty() \x3f 0 \x3a *__mp + __start_ \x25 __block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename __deque_base<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a""end() _NOEXCEPT\x0a"
"{\x0a"
"    size_type __p = size() + __start_;\x0a"
"    __map_pointer __mp = __map_.begin() + __p / __block_size;\x0a"
"    return iterator(__mp, __map_.empty() \x3f 0 \x3a *__mp + __p \x25 __block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename __deque_base<_Tp, _Allocator>\x3a\x3a""const_iterator\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a""end() const _NOEXCEPT\x0a"
"{\x0a"
"    size_type __p = size() + __start_;\x0a"
"    __map_const_pointer __mp = static_cast<__map_const_pointer>(__map_.begin() + __p / __block_size);\x0a"
"    return const_iterator(__mp, __map_.empty() \x3f 0 \x3a *__mp + __p \x25 __block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a__deque_base()\x0a"
"    _NOEXCEPT_(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue)\x0a"
"    \x3a __start_(0), __size_(0) {}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a__deque_base(const allocator_type\x26 __a)\x0a"
"    \x3a __map_(__pointer_allocator(__a)), __start_(0), __size_(0, __a) {}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a\x7e__deque_base()\x0a"
"{\x0a"
"    clear();\x0a"
"    typename __map\x3a\x3aiterator __i = __map_.begin();\x0a"
"    typename __map\x3a\x3aiterator __e = __map_.end();\x0a"
"    for (; __i \x21= __e; ++__i)\x0a"
"        __alloc_traits\x3a\x3a""deallocate(__alloc(), *__i, __block_size);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a__deque_base(__deque_base\x26\x26 __c)\x0a"
"    _NOEXCEPT_(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue)\x0a"
"    \x3a __map_(_VSTD\x3a\x3amove(__c.__map_)),\x0a"
"      __start_(_VSTD\x3a\x3amove(__c.__start_)),\x0a"
"      __size_(_VSTD\x3a\x3amove(__c.__size_))\x0a"
"{\x0a"
"    __c.__start_ = 0;\x0a"
"    __c.size() = 0;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a__deque_base(__deque_base\x26\x26 __c, const allocator_type\x26 __a)\x0a"
"    \x3a __map_(_VSTD\x3a\x3amove(__c.__map_), __pointer_allocator(__a)),\x0a"
"      __start_(_VSTD\x3a\x3amove(__c.__start_)),\x0a"
"      __size_(_VSTD\x3a\x3amove(__c.size()), __a)\x0a"
"{\x0a"
"    if (__a == __c.__alloc())\x0a"
"    {\x0a"
"        __c.__start_ = 0;\x0a"
"        __c.size() = 0;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __map_.clear();\x0a"
"        __start_ = 0;\x0a"
"        size() = 0;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3aswap(__deque_base\x26 __c)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<allocator_type>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"    __map_.swap(__c.__map_);\x0a"
"    _VSTD\x3a\x3aswap(__start_, __c.__start_);\x0a"
"    _VSTD\x3a\x3aswap(size(), __c.size());\x0a"
"    __swap_allocator(__alloc(), __c.__alloc());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"__deque_base<_Tp, _Allocator>\x3a\x3a""clear() _NOEXCEPT\x0a"
"{\x0a"
"    allocator_type\x26 __a = __alloc();\x0a"
"    for (iterator __i = begin(), __e = end(); __i \x21= __e; ++__i)\x0a"
"        __alloc_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(*__i));\x0a"
"    size() = 0;\x0a"
"    while (__map_.size() > 2)\x0a"
"    {\x0a"
"        __alloc_traits\x3a\x3a""deallocate(__a, __map_.front(), __block_size);\x0a"
"        __map_.pop_front();\x0a"
"    }\x0a"
"    switch (__map_.size())\x0a"
"    {\x0a"
"    case 1\x3a\x0a"
"        __start_ = __block_size / 2;\x0a"
"        break;\x0a"
"    case 2\x3a\x0a"
"        __start_ = __block_size;\x0a"
"        break;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator /*= allocator<_Tp>*/>\x0a"
"class _LIBCPP_TEMPLATE_VIS deque\x0a"
"    \x3a private __deque_base<_Tp, _Allocator>\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"\x0a"
"    typedef _Tp value_type;\x0a"
"    typedef _Allocator allocator_type;\x0a"
"\x0a"
"    static_assert((is_same<typename allocator_type\x3a\x3avalue_type, value_type>\x3a\x3avalue),\x0a"
"                  \x22""Allocator\x3a\x3avalue_type must be same type as value_type\x22);\x0a"
"\x0a"
"    typedef __deque_base<value_type, allocator_type> __base;\x0a"
"\x0a"
"    typedef typename __base\x3a\x3a__alloc_traits        __alloc_traits;\x0a"
"    typedef typename __base\x3a\x3areference             reference;\x0a"
"    typedef typename __base\x3a\x3a""const_reference       const_reference;\x0a"
"    typedef typename __base\x3a\x3aiterator              iterator;\x0a"
"    typedef typename __base\x3a\x3a""const_iterator        const_iterator;\x0a"
"    typedef typename __base\x3a\x3asize_type             size_type;\x0a"
"    typedef typename __base\x3a\x3a""difference_type       difference_type;\x0a"
"\x0a"
"    typedef typename __base\x3a\x3apointer               pointer;\x0a"
"    typedef typename __base\x3a\x3a""const_pointer         const_pointer;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<iterator>       reverse_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<const_iterator> const_reverse_iterator;\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    deque()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue)\x0a"
"        {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit deque(const allocator_type\x26 __a) \x3a __base(__a) {}\x0a"
"    explicit deque(size_type __n);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    explicit deque(size_type __n, const _Allocator\x26 __a);\x0a"
"#endif\x0a"
"    deque(size_type __n, const value_type\x26 __v);\x0a"
"    deque(size_type __n, const value_type\x26 __v, const allocator_type\x26 __a);\x0a"
"    template <class _InputIter>\x0a"
"        deque(_InputIter __f, _InputIter __l,\x0a"
"              typename enable_if<__is_input_iterator<_InputIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _InputIter>\x0a"
"        deque(_InputIter __f, _InputIter __l, const allocator_type\x26 __a,\x0a"
"              typename enable_if<__is_input_iterator<_InputIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    deque(const deque\x26 __c);\x0a"
"    deque(const deque\x26 __c, const allocator_type\x26 __a);\x0a"
"\x0a"
"    deque\x26 operator=(const deque\x26 __c);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    deque(initializer_list<value_type> __il);\x0a"
"    deque(initializer_list<value_type> __il, const allocator_type\x26 __a);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    deque\x26 operator=(initializer_list<value_type> __il) {assign(__il); return *this;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    deque(deque\x26\x26 __c) _NOEXCEPT_(is_nothrow_move_constructible<__base>\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    deque(deque\x26\x26 __c, const allocator_type\x26 __a);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    deque\x26 operator=(deque\x26\x26 __c)\x0a"
"        _NOEXCEPT_(__alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_move_assignable<allocator_type>\x3a\x3avalue);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void assign(initializer_list<value_type> __il) {assign(__il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template <class _InputIter>\x0a"
"        void assign(_InputIter __f, _InputIter __l,\x0a"
"                    typename enable_if<__is_input_iterator<_InputIter>\x3a\x3avalue \x26\x26\x0a"
"                                      \x21__is_random_access_iterator<_InputIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _RAIter>\x0a"
"        void assign(_RAIter __f, _RAIter __l,\x0a"
"                    typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    void assign(size_type __n, const value_type\x26 __v);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT;\x0a"
"\x0a"
"    // iterators\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       begin() _NOEXCEPT       {return __base\x3a\x3a""begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT {return __base\x3a\x3a""begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       end() _NOEXCEPT         {return __base\x3a\x3a""end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()   const _NOEXCEPT {return __base\x3a\x3a""end();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reverse_iterator       rbegin() _NOEXCEPT\x0a"
"        {return       reverse_iterator(__base\x3a\x3a""end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(__base\x3a\x3a""end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reverse_iterator       rend() _NOEXCEPT\x0a"
"        {return       reverse_iterator(__base\x3a\x3a""begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend()   const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(__base\x3a\x3a""begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator         cbegin()  const _NOEXCEPT\x0a"
"        {return __base\x3a\x3a""begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator         cend()    const _NOEXCEPT\x0a"
"        {return __base\x3a\x3a""end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(__base\x3a\x3a""end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend()   const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(__base\x3a\x3a""begin());}\x0a"
"\x0a"
"    // capacity\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT {return __base\x3a\x3asize();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT\x0a"
"        {return std\x3a\x3amin<size_type>(\x0a"
"            __alloc_traits\x3a\x3amax_size(__base\x3a\x3a__alloc()),\x0a"
"            numeric_limits<difference_type>\x3a\x3amax());}\x0a"
"    void resize(size_type __n);\x0a"
"    void resize(size_type __n, const value_type\x26 __v);\x0a"
"    void shrink_to_fit() _NOEXCEPT;\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT {return __base\x3a\x3asize() == 0;}\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator\x5b\x5d(size_type __i) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference operator\x5b\x5d(size_type __i) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference at(size_type __i);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference at(size_type __i) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference front() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference front() const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference back() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference back() const _NOEXCEPT;\x0a"
"\x0a"
"    // 23.2.2.3 modifiers\x3a\x0a"
"    void push_front(const value_type\x26 __v);\x0a"
"    void push_back(const value_type\x26 __v);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    template <class... _Args> reference emplace_front(_Args\x26\x26... __args);\x0a"
"    template <class... _Args> reference emplace_back (_Args\x26\x26... __args);\x0a"
"#else\x0a"
"    template <class... _Args> void      emplace_front(_Args\x26\x26... __args);\x0a"
"    template <class... _Args> void      emplace_back (_Args\x26\x26... __args);\x0a"
"#endif\x0a"
"    template <class... _Args> iterator emplace(const_iterator __p, _Args\x26\x26... __args);\x0a"
"\x0a"
"    void push_front(value_type\x26\x26 __v);\x0a"
"    void push_back(value_type\x26\x26 __v);\x0a"
"    iterator insert(const_iterator __p, value_type\x26\x26 __v);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __p, initializer_list<value_type> __il)\x0a"
"        {return insert(__p, __il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    iterator insert(const_iterator __p, const value_type\x26 __v);\x0a"
"    iterator insert(const_iterator __p, size_type __n, const value_type\x26 __v);\x0a"
"    template <class _InputIter>\x0a"
"        iterator insert(const_iterator __p, _InputIter __f, _InputIter __l,\x0a"
"                         typename enable_if<__is_input_iterator<_InputIter>\x3a\x3avalue\x0a"
"                                         \x26\x26\x21__is_forward_iterator<_InputIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _ForwardIterator>\x0a"
"        iterator insert(const_iterator __p, _ForwardIterator __f, _ForwardIterator __l,\x0a"
"                               typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue\x0a"
"                                         \x26\x26\x21__is_bidirectional_iterator<_ForwardIterator>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _BiIter>\x0a"
"        iterator insert(const_iterator __p, _BiIter __f, _BiIter __l,\x0a"
"                         typename enable_if<__is_bidirectional_iterator<_BiIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"\x0a"
"    void pop_front();\x0a"
"    void pop_back();\x0a"
"    iterator erase(const_iterator __p);\x0a"
"    iterator erase(const_iterator __f, const_iterator __l);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(deque\x26 __c)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT;\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                   __is_nothrow_swappable<allocator_type>\x3a\x3avalue);\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool __invariants() const {return __base\x3a\x3a__invariants();}\x0a"
"private\x3a\x0a"
"    typedef typename __base\x3a\x3a__map_const_pointer __map_const_pointer;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static size_type __recommend_blocks(size_type __n)\x0a"
"    {\x0a"
"        return __n / __base\x3a\x3a__block_size + (__n \x25 __base\x3a\x3a__block_size \x21= 0);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type __capacity() const\x0a"
"    {\x0a"
"        return __base\x3a\x3a__map_.size() == 0 \x3f 0 \x3a __base\x3a\x3a__map_.size() * __base\x3a\x3a__block_size - 1;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type __front_spare() const\x0a"
"    {\x0a"
"        return __base\x3a\x3a__start_;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type __back_spare() const\x0a"
"    {\x0a"
"        return __capacity() - (__base\x3a\x3a__start_ + __base\x3a\x3asize());\x0a"
"    }\x0a"
"\x0a"
"    template <class _InpIter>\x0a"
"        void __append(_InpIter __f, _InpIter __l,\x0a"
"                 typename enable_if<__is_input_iterator<_InpIter>\x3a\x3avalue \x26\x26\x0a"
"                                   \x21__is_forward_iterator<_InpIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _ForIter>\x0a"
"        void __append(_ForIter __f, _ForIter __l,\x0a"
"                      typename enable_if<__is_forward_iterator<_ForIter>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    void __append(size_type __n);\x0a"
"    void __append(size_type __n, const value_type\x26 __v);\x0a"
"    void __erase_to_end(const_iterator __f);\x0a"
"    void __add_front_capacity();\x0a"
"    void __add_front_capacity(size_type __n);\x0a"
"    void __add_back_capacity();\x0a"
"    void __add_back_capacity(size_type __n);\x0a"
"    iterator __move_and_check(iterator __f, iterator __l, iterator __r,\x0a"
"                              const_pointer\x26 __vt);\x0a"
"    iterator __move_backward_and_check(iterator __f, iterator __l, iterator __r,\x0a"
"                                       const_pointer\x26 __vt);\x0a"
"    void __move_construct_and_check(iterator __f, iterator __l,\x0a"
"                                    iterator __r, const_pointer\x26 __vt);\x0a"
"    void __move_construct_backward_and_check(iterator __f, iterator __l,\x0a"
"                                             iterator __r, const_pointer\x26 __vt);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const deque\x26 __c)\x0a"
"        {__copy_assign_alloc(__c, integral_constant<bool,\x0a"
"                      __alloc_traits\x3a\x3apropagate_on_container_copy_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const deque\x26 __c, true_type)\x0a"
"        {\x0a"
"            if (__base\x3a\x3a__alloc() \x21= __c.__alloc())\x0a"
"            {\x0a"
"                clear();\x0a"
"                shrink_to_fit();\x0a"
"            }\x0a"
"            __base\x3a\x3a__alloc() = __c.__alloc();\x0a"
"            __base\x3a\x3a__map_.__alloc() = __c.__map_.__alloc();\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const deque\x26, false_type)\x0a"
"        {}\x0a"
"\x0a"
"    void __move_assign(deque\x26 __c, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue);\x0a"
"    void __move_assign(deque\x26 __c, false_type);\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _Alloc = typename std\x3a\x3a""allocator<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>,\x0a"
"         class = typename enable_if<__is_allocator<_Alloc>\x3a\x3avalue, void>\x3a\x3atype\x0a"
"         >\x0a"
"deque(_InputIterator, _InputIterator)\x0a"
"  -> deque<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Alloc>;\x0a"
"\x0a"
"template<class _InputIterator,\x0a"
"         class _Alloc,\x0a"
"         class = typename enable_if<__is_allocator<_Alloc>\x3a\x3avalue, void>\x3a\x3atype\x0a"
"         >\x0a"
"deque(_InputIterator, _InputIterator, _Alloc)\x0a"
"  -> deque<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Alloc>;\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(size_type __n)\x0a"
"{\x0a"
"    if (__n > 0)\x0a"
"        __append(__n);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp, class _Allocator>\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(size_type __n, const _Allocator\x26 __a)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"    if (__n > 0)\x0a"
"        __append(__n);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(size_type __n, const value_type\x26 __v)\x0a"
"{\x0a"
"    if (__n > 0)\x0a"
"        __append(__n, __v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(size_type __n, const value_type\x26 __v, const allocator_type\x26 __a)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"    if (__n > 0)\x0a"
"        __append(__n, __v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _InputIter>\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(_InputIter __f, _InputIter __l,\x0a"
"              typename enable_if<__is_input_iterator<_InputIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    __append(__f, __l);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _InputIter>\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(_InputIter __f, _InputIter __l, const allocator_type\x26 __a,\x0a"
"              typename enable_if<__is_input_iterator<_InputIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"    __append(__f, __l);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(const deque\x26 __c)\x0a"
"    \x3a __base(__alloc_traits\x3a\x3aselect_on_container_copy_construction(__c.__alloc()))\x0a"
"{\x0a"
"    __append(__c.begin(), __c.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(const deque\x26 __c, const allocator_type\x26 __a)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"    __append(__c.begin(), __c.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"deque<_Tp, _Allocator>\x26\x0a"
"deque<_Tp, _Allocator>\x3a\x3aoperator=(const deque\x26 __c)\x0a"
"{\x0a"
"    if (this \x21= \x26__c)\x0a"
"    {\x0a"
"        __copy_assign_alloc(__c);\x0a"
"        assign(__c.begin(), __c.end());\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(initializer_list<value_type> __il)\x0a"
"{\x0a"
"    __append(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(initializer_list<value_type> __il, const allocator_type\x26 __a)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"    __append(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(deque\x26\x26 __c)\x0a"
"    _NOEXCEPT_(is_nothrow_move_constructible<__base>\x3a\x3avalue)\x0a"
"    \x3a __base(_VSTD\x3a\x3amove(__c))\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""deque(deque\x26\x26 __c, const allocator_type\x26 __a)\x0a"
"    \x3a __base(_VSTD\x3a\x3amove(__c), __a)\x0a"
"{\x0a"
"    if (__a \x21= __c.__alloc())\x0a"
"    {\x0a"
"        typedef move_iterator<iterator> _Ip;\x0a"
"        assign(_Ip(__c.begin()), _Ip(__c.end()));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"deque<_Tp, _Allocator>\x26\x0a"
"deque<_Tp, _Allocator>\x3a\x3aoperator=(deque\x26\x26 __c)\x0a"
"        _NOEXCEPT_(__alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x26\x26\x0a"
"                   is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"{\x0a"
"    __move_assign(__c, integral_constant<bool,\x0a"
"          __alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__move_assign(deque\x26 __c, false_type)\x0a"
"{\x0a"
"    if (__base\x3a\x3a__alloc() \x21= __c.__alloc())\x0a"
"    {\x0a"
"        typedef move_iterator<iterator> _Ip;\x0a"
"        assign(_Ip(__c.begin()), _Ip(__c.end()));\x0a"
"    }\x0a"
"    else\x0a"
"        __move_assign(__c, true_type());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__move_assign(deque\x26 __c, true_type)\x0a"
"    _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"{\x0a"
"    clear();\x0a"
"    shrink_to_fit();\x0a"
"    __base\x3a\x3a__move_assign(__c);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _InputIter>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""assign(_InputIter __f, _InputIter __l,\x0a"
"                               typename enable_if<__is_input_iterator<_InputIter>\x3a\x3avalue \x26\x26\x0a"
"                                                 \x21__is_random_access_iterator<_InputIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    iterator __i = __base\x3a\x3a""begin();\x0a"
"    iterator __e = __base\x3a\x3a""end();\x0a"
"    for (; __f \x21= __l \x26\x26 __i \x21= __e; ++__f, (void) ++__i)\x0a"
"        *__i = *__f;\x0a"
"    if (__f \x21= __l)\x0a"
"        __append(__f, __l);\x0a"
"    else\x0a"
"        __erase_to_end(__i);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _RAIter>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""assign(_RAIter __f, _RAIter __l,\x0a"
"                               typename enable_if<__is_random_access_iterator<_RAIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    if (static_cast<size_type>(__l - __f) > __base\x3a\x3asize())\x0a"
"    {\x0a"
"        _RAIter __m = __f + __base\x3a\x3asize();\x0a"
"        _VSTD\x3a\x3a""copy(__f, __m, __base\x3a\x3a""begin());\x0a"
"        __append(__m, __l);\x0a"
"    }\x0a"
"    else\x0a"
"        __erase_to_end(_VSTD\x3a\x3a""copy(__f, __l, __base\x3a\x3a""begin()));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""assign(size_type __n, const value_type\x26 __v)\x0a"
"{\x0a"
"    if (__n > __base\x3a\x3asize())\x0a"
"    {\x0a"
"        _VSTD\x3a\x3a""fill_n(__base\x3a\x3a""begin(), __base\x3a\x3asize(), __v);\x0a"
"        __n -= __base\x3a\x3asize();\x0a"
"        __append(__n, __v);\x0a"
"    }\x0a"
"    else\x0a"
"        __erase_to_end(_VSTD\x3a\x3a""fill_n(__base\x3a\x3a""begin(), __n, __v));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"_Allocator\x0a"
"deque<_Tp, _Allocator>\x3a\x3aget_allocator() const _NOEXCEPT\x0a"
"{\x0a"
"    return __base\x3a\x3a__alloc();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3aresize(size_type __n)\x0a"
"{\x0a"
"    if (__n > __base\x3a\x3asize())\x0a"
"        __append(__n - __base\x3a\x3asize());\x0a"
"    else if (__n < __base\x3a\x3asize())\x0a"
"        __erase_to_end(__base\x3a\x3a""begin() + __n);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3aresize(size_type __n, const value_type\x26 __v)\x0a"
"{\x0a"
"    if (__n > __base\x3a\x3asize())\x0a"
"        __append(__n - __base\x3a\x3asize(), __v);\x0a"
"    else if (__n < __base\x3a\x3asize())\x0a"
"        __erase_to_end(__base\x3a\x3a""begin() + __n);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3ashrink_to_fit() _NOEXCEPT\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (empty())\x0a"
"    {\x0a"
"        while (__base\x3a\x3a__map_.size() > 0)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__a, __base\x3a\x3a__map_.back(), __base\x3a\x3a__block_size);\x0a"
"            __base\x3a\x3a__map_.pop_back();\x0a"
"        }\x0a"
"        __base\x3a\x3a__start_ = 0;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        if (__front_spare() >= __base\x3a\x3a__block_size)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__a, __base\x3a\x3a__map_.front(), __base\x3a\x3a__block_size);\x0a"
"            __base\x3a\x3a__map_.pop_front();\x0a"
"            __base\x3a\x3a__start_ -= __base\x3a\x3a__block_size;\x0a"
"        }\x0a"
"        if (__back_spare() >= __base\x3a\x3a__block_size)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__a, __base\x3a\x3a__map_.back(), __base\x3a\x3a__block_size);\x0a"
"            __base\x3a\x3a__map_.pop_back();\x0a"
"        }\x0a"
"    }\x0a"
"    __base\x3a\x3a__map_.shrink_to_fit();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3areference\x0a"
"deque<_Tp, _Allocator>\x3a\x3aoperator\x5b\x5d(size_type __i) _NOEXCEPT\x0a"
"{\x0a"
"    size_type __p = __base\x3a\x3a__start_ + __i;\x0a"
"    return *(*(__base\x3a\x3a__map_.begin() + __p / __base\x3a\x3a__block_size) + __p \x25 __base\x3a\x3a__block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3a""const_reference\x0a"
"deque<_Tp, _Allocator>\x3a\x3aoperator\x5b\x5d(size_type __i) const _NOEXCEPT\x0a"
"{\x0a"
"    size_type __p = __base\x3a\x3a__start_ + __i;\x0a"
"    return *(*(__base\x3a\x3a__map_.begin() + __p / __base\x3a\x3a__block_size) + __p \x25 __base\x3a\x3a__block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3areference\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""at(size_type __i)\x0a"
"{\x0a"
"    if (__i >= __base\x3a\x3asize())\x0a"
"        __base\x3a\x3a__throw_out_of_range();\x0a"
"    size_type __p = __base\x3a\x3a__start_ + __i;\x0a"
"    return *(*(__base\x3a\x3a__map_.begin() + __p / __base\x3a\x3a__block_size) + __p \x25 __base\x3a\x3a__block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3a""const_reference\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""at(size_type __i) const\x0a"
"{\x0a"
"    if (__i >= __base\x3a\x3asize())\x0a"
"        __base\x3a\x3a__throw_out_of_range();\x0a"
"    size_type __p = __base\x3a\x3a__start_ + __i;\x0a"
"    return *(*(__base\x3a\x3a__map_.begin() + __p / __base\x3a\x3a__block_size) + __p \x25 __base\x3a\x3a__block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3areference\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""front() _NOEXCEPT\x0a"
"{\x0a"
"    return *(*(__base\x3a\x3a__map_.begin() + __base\x3a\x3a__start_ / __base\x3a\x3a__block_size)\x0a"
"                                      + __base\x3a\x3a__start_ \x25 __base\x3a\x3a__block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3a""const_reference\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""front() const _NOEXCEPT\x0a"
"{\x0a"
"    return *(*(__base\x3a\x3a__map_.begin() + __base\x3a\x3a__start_ / __base\x3a\x3a__block_size)\x0a"
"                                      + __base\x3a\x3a__start_ \x25 __base\x3a\x3a__block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3areference\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""back() _NOEXCEPT\x0a"
"{\x0a"
"    size_type __p = __base\x3a\x3asize() + __base\x3a\x3a__start_ - 1;\x0a"
"    return *(*(__base\x3a\x3a__map_.begin() + __p / __base\x3a\x3a__block_size) + __p \x25 __base\x3a\x3a__block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3a""const_reference\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""back() const _NOEXCEPT\x0a"
"{\x0a"
"    size_type __p = __base\x3a\x3asize() + __base\x3a\x3a__start_ - 1;\x0a"
"    return *(*(__base\x3a\x3a__map_.begin() + __p / __base\x3a\x3a__block_size) + __p \x25 __base\x3a\x3a__block_size);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3apush_back(const value_type\x26 __v)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__back_spare() == 0)\x0a"
"        __add_back_capacity();\x0a"
"    // __back_spare() >= 1\x0a"
"    __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__base\x3a\x3a""end()), __v);\x0a"
"    ++__base\x3a\x3asize();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3apush_front(const value_type\x26 __v)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__front_spare() == 0)\x0a"
"        __add_front_capacity();\x0a"
"    // __front_spare() >= 1\x0a"
"    __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*--__base\x3a\x3a""begin()), __v);\x0a"
"    --__base\x3a\x3a__start_;\x0a"
"    ++__base\x3a\x3asize();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3apush_back(value_type\x26\x26 __v)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__back_spare() == 0)\x0a"
"        __add_back_capacity();\x0a"
"    // __back_spare() >= 1\x0a"
"    __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__base\x3a\x3a""end()), _VSTD\x3a\x3amove(__v));\x0a"
"    ++__base\x3a\x3asize();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class... _Args>\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3areference\x0a"
"#else\x0a"
"void\x0a"
"#endif\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""emplace_back(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__back_spare() == 0)\x0a"
"        __add_back_capacity();\x0a"
"    // __back_spare() >= 1\x0a"
"    __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__base\x3a\x3a""end()),\x0a"
"                              _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    ++__base\x3a\x3asize();\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    return *--__base\x3a\x3a""end();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3apush_front(value_type\x26\x26 __v)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__front_spare() == 0)\x0a"
"        __add_front_capacity();\x0a"
"    // __front_spare() >= 1\x0a"
"    __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*--__base\x3a\x3a""begin()), _VSTD\x3a\x3amove(__v));\x0a"
"    --__base\x3a\x3a__start_;\x0a"
"    ++__base\x3a\x3asize();\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class... _Args>\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3areference\x0a"
"#else\x0a"
"void\x0a"
"#endif\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""emplace_front(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__front_spare() == 0)\x0a"
"        __add_front_capacity();\x0a"
"    // __front_spare() >= 1\x0a"
"    __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*--__base\x3a\x3a""begin()), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    --__base\x3a\x3a__start_;\x0a"
"    ++__base\x3a\x3asize();\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    return *__base\x3a\x3a""begin();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __p, value_type\x26\x26 __v)\x0a"
"{\x0a"
"    size_type __pos = __p - __base\x3a\x3a""begin();\x0a"
"    size_type __to_end = __base\x3a\x3asize() - __pos;\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__pos < __to_end)\x0a"
"    {   // insert by shifting things backward\x0a"
"        if (__front_spare() == 0)\x0a"
"            __add_front_capacity();\x0a"
"        // __front_spare() >= 1\x0a"
"        if (__pos == 0)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*--__base\x3a\x3a""begin()), _VSTD\x3a\x3amove(__v));\x0a"
"            --__base\x3a\x3a__start_;\x0a"
"            ++__base\x3a\x3asize();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            iterator __b = __base\x3a\x3a""begin();\x0a"
"            iterator __bm1 = _VSTD\x3a\x3aprev(__b);\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__bm1), _VSTD\x3a\x3amove(*__b));\x0a"
"            --__base\x3a\x3a__start_;\x0a"
"            ++__base\x3a\x3asize();\x0a"
"            if (__pos > 1)\x0a"
"                __b = _VSTD\x3a\x3amove(_VSTD\x3a\x3anext(__b), __b + __pos, __b);\x0a"
"            *__b = _VSTD\x3a\x3amove(__v);\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {   // insert by shifting things forward\x0a"
"        if (__back_spare() == 0)\x0a"
"            __add_back_capacity();\x0a"
"        // __back_capacity >= 1\x0a"
"        size_type __de = __base\x3a\x3asize() - __pos;\x0a"
"        if (__de == 0)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__base\x3a\x3a""end()), _VSTD\x3a\x3amove(__v));\x0a"
"            ++__base\x3a\x3asize();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            iterator __e = __base\x3a\x3a""end();\x0a"
"            iterator __em1 = _VSTD\x3a\x3aprev(__e);\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__e), _VSTD\x3a\x3amove(*__em1));\x0a"
"            ++__base\x3a\x3asize();\x0a"
"            if (__de > 1)\x0a"
"                __e = _VSTD\x3a\x3amove_backward(__e - __de, __em1, __e);\x0a"
"            *--__e = _VSTD\x3a\x3amove(__v);\x0a"
"        }\x0a"
"    }\x0a"
"    return __base\x3a\x3a""begin() + __pos;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class... _Args>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""emplace(const_iterator __p, _Args\x26\x26... __args)\x0a"
"{\x0a"
"    size_type __pos = __p - __base\x3a\x3a""begin();\x0a"
"    size_type __to_end = __base\x3a\x3asize() - __pos;\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__pos < __to_end)\x0a"
"    {   // insert by shifting things backward\x0a"
"        if (__front_spare() == 0)\x0a"
"            __add_front_capacity();\x0a"
"        // __front_spare() >= 1\x0a"
"        if (__pos == 0)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*--__base\x3a\x3a""begin()), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"            --__base\x3a\x3a__start_;\x0a"
"            ++__base\x3a\x3asize();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __temp_value<value_type, _Allocator> __tmp(this->__alloc(), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"            iterator __b = __base\x3a\x3a""begin();\x0a"
"            iterator __bm1 = _VSTD\x3a\x3aprev(__b);\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__bm1), _VSTD\x3a\x3amove(*__b));\x0a"
"            --__base\x3a\x3a__start_;\x0a"
"            ++__base\x3a\x3asize();\x0a"
"            if (__pos > 1)\x0a"
"                __b = _VSTD\x3a\x3amove(_VSTD\x3a\x3anext(__b), __b + __pos, __b);\x0a"
"            *__b = _VSTD\x3a\x3amove(__tmp.get());\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {   // insert by shifting things forward\x0a"
"        if (__back_spare() == 0)\x0a"
"            __add_back_capacity();\x0a"
"        // __back_capacity >= 1\x0a"
"        size_type __de = __base\x3a\x3asize() - __pos;\x0a"
"        if (__de == 0)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__base\x3a\x3a""end()), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"            ++__base\x3a\x3asize();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __temp_value<value_type, _Allocator> __tmp(this->__alloc(), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"            iterator __e = __base\x3a\x3a""end();\x0a"
"            iterator __em1 = _VSTD\x3a\x3aprev(__e);\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__e), _VSTD\x3a\x3amove(*__em1));\x0a"
"            ++__base\x3a\x3asize();\x0a"
"            if (__de > 1)\x0a"
"                __e = _VSTD\x3a\x3amove_backward(__e - __de, __em1, __e);\x0a"
"            *--__e = _VSTD\x3a\x3amove(__tmp.get());\x0a"
"        }\x0a"
"    }\x0a"
"    return __base\x3a\x3a""begin() + __pos;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __p, const value_type\x26 __v)\x0a"
"{\x0a"
"    size_type __pos = __p - __base\x3a\x3a""begin();\x0a"
"    size_type __to_end = __base\x3a\x3asize() - __pos;\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__pos < __to_end)\x0a"
"    {   // insert by shifting things backward\x0a"
"        if (__front_spare() == 0)\x0a"
"            __add_front_capacity();\x0a"
"        // __front_spare() >= 1\x0a"
"        if (__pos == 0)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*--__base\x3a\x3a""begin()), __v);\x0a"
"            --__base\x3a\x3a__start_;\x0a"
"            ++__base\x3a\x3asize();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            const_pointer __vt = pointer_traits<const_pointer>\x3a\x3apointer_to(__v);\x0a"
"            iterator __b = __base\x3a\x3a""begin();\x0a"
"            iterator __bm1 = _VSTD\x3a\x3aprev(__b);\x0a"
"            if (__vt == pointer_traits<const_pointer>\x3a\x3apointer_to(*__b))\x0a"
"                __vt = pointer_traits<const_pointer>\x3a\x3apointer_to(*__bm1);\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__bm1), _VSTD\x3a\x3amove(*__b));\x0a"
"            --__base\x3a\x3a__start_;\x0a"
"            ++__base\x3a\x3asize();\x0a"
"            if (__pos > 1)\x0a"
"                __b = __move_and_check(_VSTD\x3a\x3anext(__b), __b + __pos, __b, __vt);\x0a"
"            *__b = *__vt;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {   // insert by shifting things forward\x0a"
"        if (__back_spare() == 0)\x0a"
"            __add_back_capacity();\x0a"
"        // __back_capacity >= 1\x0a"
"        size_type __de = __base\x3a\x3asize() - __pos;\x0a"
"        if (__de == 0)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__base\x3a\x3a""end()), __v);\x0a"
"            ++__base\x3a\x3asize();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            const_pointer __vt = pointer_traits<const_pointer>\x3a\x3apointer_to(__v);\x0a"
"            iterator __e = __base\x3a\x3a""end();\x0a"
"            iterator __em1 = _VSTD\x3a\x3aprev(__e);\x0a"
"            if (__vt == pointer_traits<const_pointer>\x3a\x3apointer_to(*__em1))\x0a"
"                __vt = pointer_traits<const_pointer>\x3a\x3apointer_to(*__e);\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__e), _VSTD\x3a\x3amove(*__em1));\x0a"
"            ++__base\x3a\x3asize();\x0a"
"            if (__de > 1)\x0a"
"                __e = __move_backward_and_check(__e - __de, __em1, __e, __vt);\x0a"
"            *--__e = *__vt;\x0a"
"        }\x0a"
"    }\x0a"
"    return __base\x3a\x3a""begin() + __pos;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __p, size_type __n, const value_type\x26 __v)\x0a"
"{\x0a"
"    size_type __pos = __p - __base\x3a\x3a""begin();\x0a"
"    size_type __to_end = __base\x3a\x3asize() - __pos;\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__pos < __to_end)\x0a"
"    {   // insert by shifting things backward\x0a"
"        if (__n > __front_spare())\x0a"
"            __add_front_capacity(__n - __front_spare());\x0a"
"        // __n <= __front_spare()\x0a"
"        iterator __old_begin = __base\x3a\x3a""begin();\x0a"
"        iterator __i = __old_begin;\x0a"
"        if (__n > __pos)\x0a"
"        {\x0a"
"            for (size_type __m = __n - __pos; __m; --__m, --__base\x3a\x3a__start_, ++__base\x3a\x3asize())\x0a"
"                __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*--__i), __v);\x0a"
"            __n = __pos;\x0a"
"        }\x0a"
"        if (__n > 0)\x0a"
"        {\x0a"
"            const_pointer __vt = pointer_traits<const_pointer>\x3a\x3apointer_to(__v);\x0a"
"            iterator __obn = __old_begin + __n;\x0a"
"            __move_construct_backward_and_check(__old_begin, __obn, __i, __vt);\x0a"
"            if (__n < __pos)\x0a"
"                __old_begin = __move_and_check(__obn, __old_begin + __pos, __old_begin, __vt);\x0a"
"            _VSTD\x3a\x3a""fill_n(__old_begin, __n, *__vt);\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {   // insert by shifting things forward\x0a"
"        size_type __back_capacity = __back_spare();\x0a"
"        if (__n > __back_capacity)\x0a"
"            __add_back_capacity(__n - __back_capacity);\x0a"
"        // __n <= __back_capacity\x0a"
"        iterator __old_end = __base\x3a\x3a""end();\x0a"
"        iterator __i = __old_end;\x0a"
"        size_type __de = __base\x3a\x3asize() - __pos;\x0a"
"        if (__n > __de)\x0a"
"        {\x0a"
"            for (size_type __m = __n - __de; __m; --__m, ++__i, ++__base\x3a\x3asize())\x0a"
"                __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__i), __v);\x0a"
"            __n = __de;\x0a"
"        }\x0a"
"        if (__n > 0)\x0a"
"        {\x0a"
"            const_pointer __vt = pointer_traits<const_pointer>\x3a\x3apointer_to(__v);\x0a"
"            iterator __oen = __old_end - __n;\x0a"
"            __move_construct_and_check(__oen, __old_end, __i, __vt);\x0a"
"            if (__n < __de)\x0a"
"                __old_end = __move_backward_and_check(__old_end - __de, __oen, __old_end, __vt);\x0a"
"            _VSTD\x3a\x3a""fill_n(__old_end - __n, __n, *__vt);\x0a"
"        }\x0a"
"    }\x0a"
"    return __base\x3a\x3a""begin() + __pos;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _InputIter>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __p, _InputIter __f, _InputIter __l,\x0a"
"                               typename enable_if<__is_input_iterator<_InputIter>\x3a\x3avalue\x0a"
"                                               \x26\x26\x21__is_forward_iterator<_InputIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    __split_buffer<value_type, allocator_type\x26> __buf(__base\x3a\x3a__alloc());\x0a"
"    __buf.__construct_at_end(__f, __l);\x0a"
"    typedef typename __split_buffer<value_type, allocator_type\x26>\x3a\x3aiterator __bi;\x0a"
"    return insert(__p, move_iterator<__bi>(__buf.begin()), move_iterator<__bi>(__buf.end()));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __p, _ForwardIterator __f, _ForwardIterator __l,\x0a"
"                               typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue\x0a"
"                                               \x26\x26\x21__is_bidirectional_iterator<_ForwardIterator>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    size_type __n = _VSTD\x3a\x3a""distance(__f, __l);\x0a"
"    __split_buffer<value_type, allocator_type\x26> __buf(__n, 0, __base\x3a\x3a__alloc());\x0a"
"    __buf.__construct_at_end(__f, __l);\x0a"
"    typedef typename __split_buffer<value_type, allocator_type\x26>\x3a\x3aiterator __fwd;\x0a"
"    return insert(__p, move_iterator<__fwd>(__buf.begin()), move_iterator<__fwd>(__buf.end()));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _BiIter>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __p, _BiIter __f, _BiIter __l,\x0a"
"                               typename enable_if<__is_bidirectional_iterator<_BiIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    size_type __n = _VSTD\x3a\x3a""distance(__f, __l);\x0a"
"    size_type __pos = __p - __base\x3a\x3a""begin();\x0a"
"    size_type __to_end = __base\x3a\x3asize() - __pos;\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__pos < __to_end)\x0a"
"    {   // insert by shifting things backward\x0a"
"        if (__n > __front_spare())\x0a"
"            __add_front_capacity(__n - __front_spare());\x0a"
"        // __n <= __front_spare()\x0a"
"        iterator __old_begin = __base\x3a\x3a""begin();\x0a"
"        iterator __i = __old_begin;\x0a"
"        _BiIter __m = __f;\x0a"
"        if (__n > __pos)\x0a"
"        {\x0a"
"            __m = __pos < __n / 2 \x3f _VSTD\x3a\x3aprev(__l, __pos) \x3a _VSTD\x3a\x3anext(__f, __n - __pos);\x0a"
"            for (_BiIter __j = __m; __j \x21= __f; --__base\x3a\x3a__start_, ++__base\x3a\x3asize())\x0a"
"                __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*--__i), *--__j);\x0a"
"            __n = __pos;\x0a"
"        }\x0a"
"        if (__n > 0)\x0a"
"        {\x0a"
"            iterator __obn = __old_begin + __n;\x0a"
"            for (iterator __j = __obn; __j \x21= __old_begin;)\x0a"
"            {\x0a"
"                __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*--__i), _VSTD\x3a\x3amove(*--__j));\x0a"
"                --__base\x3a\x3a__start_;\x0a"
"                ++__base\x3a\x3asize();\x0a"
"            }\x0a"
"            if (__n < __pos)\x0a"
"                __old_begin = _VSTD\x3a\x3amove(__obn, __old_begin + __pos, __old_begin);\x0a"
"            _VSTD\x3a\x3a""copy(__m, __l, __old_begin);\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {   // insert by shifting things forward\x0a"
"        size_type __back_capacity = __back_spare();\x0a"
"        if (__n > __back_capacity)\x0a"
"            __add_back_capacity(__n - __back_capacity);\x0a"
"        // __n <= __back_capacity\x0a"
"        iterator __old_end = __base\x3a\x3a""end();\x0a"
"        iterator __i = __old_end;\x0a"
"        _BiIter __m = __l;\x0a"
"        size_type __de = __base\x3a\x3asize() - __pos;\x0a"
"        if (__n > __de)\x0a"
"        {\x0a"
"            __m = __de < __n / 2 \x3f _VSTD\x3a\x3anext(__f, __de) \x3a _VSTD\x3a\x3aprev(__l, __n - __de);\x0a"
"            for (_BiIter __j = __m; __j \x21= __l; ++__i, (void) ++__j, ++__base\x3a\x3asize())\x0a"
"                __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__i), *__j);\x0a"
"            __n = __de;\x0a"
"        }\x0a"
"        if (__n > 0)\x0a"
"        {\x0a"
"            iterator __oen = __old_end - __n;\x0a"
"            for (iterator __j = __oen; __j \x21= __old_end; ++__i, ++__j, ++__base\x3a\x3asize())\x0a"
"                __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__i), _VSTD\x3a\x3amove(*__j));\x0a"
"            if (__n < __de)\x0a"
"                __old_end = _VSTD\x3a\x3amove_backward(__old_end - __de, __oen, __old_end);\x0a"
"            _VSTD\x3a\x3a""copy_backward(__f, __m, __old_end);\x0a"
"        }\x0a"
"    }\x0a"
"    return __base\x3a\x3a""begin() + __pos;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _InpIter>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__append(_InpIter __f, _InpIter __l,\x0a"
"                                 typename enable_if<__is_input_iterator<_InpIter>\x3a\x3avalue \x26\x26\x0a"
"                                                   \x21__is_forward_iterator<_InpIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    for (; __f \x21= __l; ++__f)\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"        push_back(*__f);\x0a"
"#else\x0a"
"        emplace_back(*__f);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _ForIter>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__append(_ForIter __f, _ForIter __l,\x0a"
"                                 typename enable_if<__is_forward_iterator<_ForIter>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"{\x0a"
"    size_type __n = _VSTD\x3a\x3a""distance(__f, __l);\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    size_type __back_capacity = __back_spare();\x0a"
"    if (__n > __back_capacity)\x0a"
"        __add_back_capacity(__n - __back_capacity);\x0a"
"    // __n <= __back_capacity\x0a"
"    for (iterator __i = __base\x3a\x3a""end(); __f \x21= __l; ++__i, (void) ++__f, ++__base\x3a\x3asize())\x0a"
"        __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__i), *__f);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__append(size_type __n)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    size_type __back_capacity = __back_spare();\x0a"
"    if (__n > __back_capacity)\x0a"
"        __add_back_capacity(__n - __back_capacity);\x0a"
"    // __n <= __back_capacity\x0a"
"    for (iterator __i = __base\x3a\x3a""end(); __n; --__n, ++__i, ++__base\x3a\x3asize())\x0a"
"        __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__i));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__append(size_type __n, const value_type\x26 __v)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    size_type __back_capacity = __back_spare();\x0a"
"    if (__n > __back_capacity)\x0a"
"        __add_back_capacity(__n - __back_capacity);\x0a"
"    // __n <= __back_capacity\x0a"
"    for (iterator __i = __base\x3a\x3a""end(); __n; --__n, ++__i, ++__base\x3a\x3asize())\x0a"
"        __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__i), __v);\x0a"
"}\x0a"
"\x0a"
"// Create front capacity for one block of elements.\x0a"
"// Strong guarantee.  Either do it or don't touch anything.\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__add_front_capacity()\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__back_spare() >= __base\x3a\x3a__block_size)\x0a"
"    {\x0a"
"        __base\x3a\x3a__start_ += __base\x3a\x3a__block_size;\x0a"
"        pointer __pt = __base\x3a\x3a__map_.back();\x0a"
"        __base\x3a\x3a__map_.pop_back();\x0a"
"        __base\x3a\x3a__map_.push_front(__pt);\x0a"
"    }\x0a"
"    // Else if __base\x3a\x3a__map_.size() < __base\x3a\x3a__map_.capacity() then we need to allocate 1 buffer\x0a"
"    else if (__base\x3a\x3a__map_.size() < __base\x3a\x3a__map_.capacity())\x0a"
"    {   // we can put the new buffer into the map, but don't shift things around\x0a"
"        // until all buffers are allocated.  If we throw, we don't need to fix\x0a"
"        // anything up (any added buffers are undetectible)\x0a"
"        if (__base\x3a\x3a__map_.__front_spare() > 0)\x0a"
"            __base\x3a\x3a__map_.push_front(__alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size));\x0a"
"        else\x0a"
"        {\x0a"
"            __base\x3a\x3a__map_.push_back(__alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size));\x0a"
"            // Done allocating, reorder capacity\x0a"
"            pointer __pt = __base\x3a\x3a__map_.back();\x0a"
"            __base\x3a\x3a__map_.pop_back();\x0a"
"            __base\x3a\x3a__map_.push_front(__pt);\x0a"
"        }\x0a"
"        __base\x3a\x3a__start_ = __base\x3a\x3a__map_.size() == 1 \x3f\x0a"
"                               __base\x3a\x3a__block_size / 2 \x3a\x0a"
"                               __base\x3a\x3a__start_ + __base\x3a\x3a__block_size;\x0a"
"    }\x0a"
"    // Else need to allocate 1 buffer, *and* we need to reallocate __map_.\x0a"
"    else\x0a"
"    {\x0a"
"        __split_buffer<pointer, typename __base\x3a\x3a__pointer_allocator\x26>\x0a"
"            __buf(max<size_type>(2 * __base\x3a\x3a__map_.capacity(), 1),\x0a"
"                  0, __base\x3a\x3a__map_.__alloc());\x0a"
"\x0a"
"        typedef __allocator_destructor<_Allocator> _Dp;\x0a"
"        unique_ptr<pointer, _Dp> __hold(\x0a"
"            __alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size),\x0a"
"                _Dp(__a, __base\x3a\x3a__block_size));\x0a"
"        __buf.push_back(__hold.get());\x0a"
"        __hold.release();\x0a"
"\x0a"
"        for (typename __base\x3a\x3a__map_pointer __i = __base\x3a\x3a__map_.begin();\x0a"
"                __i \x21= __base\x3a\x3a__map_.end(); ++__i)\x0a"
"            __buf.push_back(*__i);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__first_, __buf.__first_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__begin_, __buf.__begin_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__end_, __buf.__end_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__end_cap(), __buf.__end_cap());\x0a"
"        __base\x3a\x3a__start_ = __base\x3a\x3a__map_.size() == 1 \x3f\x0a"
"                               __base\x3a\x3a__block_size / 2 \x3a\x0a"
"                               __base\x3a\x3a__start_ + __base\x3a\x3a__block_size;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Create front capacity for __n elements.\x0a"
"// Strong guarantee.  Either do it or don't touch anything.\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__add_front_capacity(size_type __n)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    size_type __nb = __recommend_blocks(__n + __base\x3a\x3a__map_.empty());\x0a"
"    // Number of unused blocks at back\x3a\x0a"
"    size_type __back_capacity = __back_spare() / __base\x3a\x3a__block_size;\x0a"
"    __back_capacity = _VSTD\x3a\x3amin(__back_capacity, __nb);  // don't take more than you need\x0a"
"    __nb -= __back_capacity;  // number of blocks need to allocate\x0a"
"    // If __nb == 0, then we have sufficient capacity.\x0a"
"    if (__nb == 0)\x0a"
"    {\x0a"
"        __base\x3a\x3a__start_ += __base\x3a\x3a__block_size * __back_capacity;\x0a"
"        for (; __back_capacity > 0; --__back_capacity)\x0a"
"        {\x0a"
"            pointer __pt = __base\x3a\x3a__map_.back();\x0a"
"            __base\x3a\x3a__map_.pop_back();\x0a"
"            __base\x3a\x3a__map_.push_front(__pt);\x0a"
"        }\x0a"
"    }\x0a"
"    // Else if __nb <= __map_.capacity() - __map_.size() then we need to allocate __nb buffers\x0a"
"    else if (__nb <= __base\x3a\x3a__map_.capacity() - __base\x3a\x3a__map_.size())\x0a"
"    {   // we can put the new buffers into the map, but don't shift things around\x0a"
"        // until all buffers are allocated.  If we throw, we don't need to fix\x0a"
"        // anything up (any added buffers are undetectible)\x0a"
"        for (; __nb > 0; --__nb, __base\x3a\x3a__start_ += __base\x3a\x3a__block_size - (__base\x3a\x3a__map_.size() == 1))\x0a"
"        {\x0a"
"            if (__base\x3a\x3a__map_.__front_spare() == 0)\x0a"
"                break;\x0a"
"            __base\x3a\x3a__map_.push_front(__alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size));\x0a"
"        }\x0a"
"        for (; __nb > 0; --__nb, ++__back_capacity)\x0a"
"            __base\x3a\x3a__map_.push_back(__alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size));\x0a"
"        // Done allocating, reorder capacity\x0a"
"        __base\x3a\x3a__start_ += __back_capacity * __base\x3a\x3a__block_size;\x0a"
"        for (; __back_capacity > 0; --__back_capacity)\x0a"
"        {\x0a"
"            pointer __pt = __base\x3a\x3a__map_.back();\x0a"
"            __base\x3a\x3a__map_.pop_back();\x0a"
"            __base\x3a\x3a__map_.push_front(__pt);\x0a"
"        }\x0a"
"    }\x0a"
"    // Else need to allocate __nb buffers, *and* we need to reallocate __map_.\x0a"
"    else\x0a"
"    {\x0a"
"        size_type __ds = (__nb + __back_capacity) * __base\x3a\x3a__block_size - __base\x3a\x3a__map_.empty();\x0a"
"        __split_buffer<pointer, typename __base\x3a\x3a__pointer_allocator\x26>\x0a"
"            __buf(max<size_type>(2* __base\x3a\x3a__map_.capacity(),\x0a"
"                                 __nb + __base\x3a\x3a__map_.size()),\x0a"
"                  0, __base\x3a\x3a__map_.__alloc());\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (; __nb > 0; --__nb)\x0a"
"                __buf.push_back(__alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            for (typename __base\x3a\x3a__map_pointer __i = __buf.begin();\x0a"
"                    __i \x21= __buf.end(); ++__i)\x0a"
"                __alloc_traits\x3a\x3a""deallocate(__a, *__i, __base\x3a\x3a__block_size);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        for (; __back_capacity > 0; --__back_capacity)\x0a"
"        {\x0a"
"            __buf.push_back(__base\x3a\x3a__map_.back());\x0a"
"            __base\x3a\x3a__map_.pop_back();\x0a"
"        }\x0a"
"        for (typename __base\x3a\x3a__map_pointer __i = __base\x3a\x3a__map_.begin();\x0a"
"                __i \x21= __base\x3a\x3a__map_.end(); ++__i)\x0a"
"            __buf.push_back(*__i);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__first_, __buf.__first_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__begin_, __buf.__begin_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__end_, __buf.__end_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__end_cap(), __buf.__end_cap());\x0a"
"        __base\x3a\x3a__start_ += __ds;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Create back capacity for one block of elements.\x0a"
"// Strong guarantee.  Either do it or don't touch anything.\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__add_back_capacity()\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (__front_spare() >= __base\x3a\x3a__block_size)\x0a"
"    {\x0a"
"        __base\x3a\x3a__start_ -= __base\x3a\x3a__block_size;\x0a"
"        pointer __pt = __base\x3a\x3a__map_.front();\x0a"
"        __base\x3a\x3a__map_.pop_front();\x0a"
"        __base\x3a\x3a__map_.push_back(__pt);\x0a"
"    }\x0a"
"    // Else if __nb <= __map_.capacity() - __map_.size() then we need to allocate __nb buffers\x0a"
"    else if (__base\x3a\x3a__map_.size() < __base\x3a\x3a__map_.capacity())\x0a"
"    {   // we can put the new buffer into the map, but don't shift things around\x0a"
"        // until it is allocated.  If we throw, we don't need to fix\x0a"
"        // anything up (any added buffers are undetectible)\x0a"
"        if (__base\x3a\x3a__map_.__back_spare() \x21= 0)\x0a"
"            __base\x3a\x3a__map_.push_back(__alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size));\x0a"
"        else\x0a"
"        {\x0a"
"            __base\x3a\x3a__map_.push_front(__alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size));\x0a"
"            // Done allocating, reorder capacity\x0a"
"            pointer __pt = __base\x3a\x3a__map_.front();\x0a"
"            __base\x3a\x3a__map_.pop_front();\x0a"
"            __base\x3a\x3a__map_.push_back(__pt);\x0a"
"        }\x0a"
"    }\x0a"
"    // Else need to allocate 1 buffer, *and* we need to reallocate __map_.\x0a"
"    else\x0a"
"    {\x0a"
"        __split_buffer<pointer, typename __base\x3a\x3a__pointer_allocator\x26>\x0a"
"            __buf(max<size_type>(2* __base\x3a\x3a__map_.capacity(), 1),\x0a"
"                  __base\x3a\x3a__map_.size(),\x0a"
"                  __base\x3a\x3a__map_.__alloc());\x0a"
"\x0a"
"        typedef __allocator_destructor<_Allocator> _Dp;\x0a"
"        unique_ptr<pointer, _Dp> __hold(\x0a"
"            __alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size),\x0a"
"                _Dp(__a, __base\x3a\x3a__block_size));\x0a"
"        __buf.push_back(__hold.get());\x0a"
"        __hold.release();\x0a"
"\x0a"
"        for (typename __base\x3a\x3a__map_pointer __i = __base\x3a\x3a__map_.end();\x0a"
"                __i \x21= __base\x3a\x3a__map_.begin();)\x0a"
"            __buf.push_front(*--__i);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__first_, __buf.__first_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__begin_, __buf.__begin_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__end_, __buf.__end_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__end_cap(), __buf.__end_cap());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Create back capacity for __n elements.\x0a"
"// Strong guarantee.  Either do it or don't touch anything.\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__add_back_capacity(size_type __n)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    size_type __nb = __recommend_blocks(__n + __base\x3a\x3a__map_.empty());\x0a"
"    // Number of unused blocks at front\x3a\x0a"
"    size_type __front_capacity = __front_spare() / __base\x3a\x3a__block_size;\x0a"
"    __front_capacity = _VSTD\x3a\x3amin(__front_capacity, __nb);  // don't take more than you need\x0a"
"    __nb -= __front_capacity;  // number of blocks need to allocate\x0a"
"    // If __nb == 0, then we have sufficient capacity.\x0a"
"    if (__nb == 0)\x0a"
"    {\x0a"
"        __base\x3a\x3a__start_ -= __base\x3a\x3a__block_size * __front_capacity;\x0a"
"        for (; __front_capacity > 0; --__front_capacity)\x0a"
"        {\x0a"
"            pointer __pt = __base\x3a\x3a__map_.front();\x0a"
"            __base\x3a\x3a__map_.pop_front();\x0a"
"            __base\x3a\x3a__map_.push_back(__pt);\x0a"
"        }\x0a"
"    }\x0a"
"    // Else if __nb <= __map_.capacity() - __map_.size() then we need to allocate __nb buffers\x0a"
"    else if (__nb <= __base\x3a\x3a__map_.capacity() - __base\x3a\x3a__map_.size())\x0a"
"    {   // we can put the new buffers into the map, but don't shift things around\x0a"
"        // until all buffers are allocated.  If we throw, we don't need to fix\x0a"
"        // anything up (any added buffers are undetectible)\x0a"
"        for (; __nb > 0; --__nb)\x0a"
"        {\x0a"
"            if (__base\x3a\x3a__map_.__back_spare() == 0)\x0a"
"                break;\x0a"
"            __base\x3a\x3a__map_.push_back(__alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size));\x0a"
"        }\x0a"
"        for (; __nb > 0; --__nb, ++__front_capacity, __base\x3a\x3a__start_ +=\x0a"
"                                 __base\x3a\x3a__block_size - (__base\x3a\x3a__map_.size() == 1))\x0a"
"            __base\x3a\x3a__map_.push_front(__alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size));\x0a"
"        // Done allocating, reorder capacity\x0a"
"        __base\x3a\x3a__start_ -= __base\x3a\x3a__block_size * __front_capacity;\x0a"
"        for (; __front_capacity > 0; --__front_capacity)\x0a"
"        {\x0a"
"            pointer __pt = __base\x3a\x3a__map_.front();\x0a"
"            __base\x3a\x3a__map_.pop_front();\x0a"
"            __base\x3a\x3a__map_.push_back(__pt);\x0a"
"        }\x0a"
"    }\x0a"
"    // Else need to allocate __nb buffers, *and* we need to reallocate __map_.\x0a"
"    else\x0a"
"    {\x0a"
"        size_type __ds = __front_capacity * __base\x3a\x3a__block_size;\x0a"
"        __split_buffer<pointer, typename __base\x3a\x3a__pointer_allocator\x26>\x0a"
"            __buf(max<size_type>(2* __base\x3a\x3a__map_.capacity(),\x0a"
"                                 __nb + __base\x3a\x3a__map_.size()),\x0a"
"                  __base\x3a\x3a__map_.size() - __front_capacity,\x0a"
"                  __base\x3a\x3a__map_.__alloc());\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (; __nb > 0; --__nb)\x0a"
"                __buf.push_back(__alloc_traits\x3a\x3a""allocate(__a, __base\x3a\x3a__block_size));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            for (typename __base\x3a\x3a__map_pointer __i = __buf.begin();\x0a"
"                    __i \x21= __buf.end(); ++__i)\x0a"
"                __alloc_traits\x3a\x3a""deallocate(__a, *__i, __base\x3a\x3a__block_size);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        for (; __front_capacity > 0; --__front_capacity)\x0a"
"        {\x0a"
"            __buf.push_back(__base\x3a\x3a__map_.front());\x0a"
"            __base\x3a\x3a__map_.pop_front();\x0a"
"        }\x0a"
"        for (typename __base\x3a\x3a__map_pointer __i = __base\x3a\x3a__map_.end();\x0a"
"                __i \x21= __base\x3a\x3a__map_.begin();)\x0a"
"            __buf.push_front(*--__i);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__first_, __buf.__first_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__begin_, __buf.__begin_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__end_, __buf.__end_);\x0a"
"        _VSTD\x3a\x3aswap(__base\x3a\x3a__map_.__end_cap(), __buf.__end_cap());\x0a"
"        __base\x3a\x3a__start_ -= __ds;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3apop_front()\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    __alloc_traits\x3a\x3a""destroy(__a, __to_raw_pointer(*(__base\x3a\x3a__map_.begin() +\x0a"
"                                                    __base\x3a\x3a__start_ / __base\x3a\x3a__block_size) +\x0a"
"                                                    __base\x3a\x3a__start_ \x25 __base\x3a\x3a__block_size));\x0a"
"    --__base\x3a\x3asize();\x0a"
"    if (++__base\x3a\x3a__start_ >= 2 * __base\x3a\x3a__block_size)\x0a"
"    {\x0a"
"        __alloc_traits\x3a\x3a""deallocate(__a, __base\x3a\x3a__map_.front(), __base\x3a\x3a__block_size);\x0a"
"        __base\x3a\x3a__map_.pop_front();\x0a"
"        __base\x3a\x3a__start_ -= __base\x3a\x3a__block_size;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3apop_back()\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(\x21""empty(), \x22""deque\x3a\x3apop_back called for empty deque\x22);\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    size_type __p = __base\x3a\x3asize() + __base\x3a\x3a__start_ - 1;\x0a"
"    __alloc_traits\x3a\x3a""destroy(__a, __to_raw_pointer(*(__base\x3a\x3a__map_.begin() +\x0a"
"                                                    __p / __base\x3a\x3a__block_size) +\x0a"
"                                                    __p \x25 __base\x3a\x3a__block_size));\x0a"
"    --__base\x3a\x3asize();\x0a"
"    if (__back_spare() >= 2 * __base\x3a\x3a__block_size)\x0a"
"    {\x0a"
"        __alloc_traits\x3a\x3a""deallocate(__a, __base\x3a\x3a__map_.back(), __base\x3a\x3a__block_size);\x0a"
"        __base\x3a\x3a__map_.pop_back();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// move assign \x5b__f, __l) to \x5b__r, __r + (__l-__f)).\x0a"
"// If __vt points into \x5b__f, __l), then subtract (__f - __r) from __vt.\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__move_and_check(iterator __f, iterator __l, iterator __r,\x0a"
"                                         const_pointer\x26 __vt)\x0a"
"{\x0a"
"    // as if\x0a"
"    //   for (; __f \x21= __l; ++__f, ++__r)\x0a"
"    //       *__r = _VSTD\x3a\x3amove(*__f);\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        pointer __fb = __f.__ptr_;\x0a"
"        pointer __fe = *__f.__m_iter_ + __base\x3a\x3a__block_size;\x0a"
"        difference_type __bs = __fe - __fb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __fe = __fb + __bs;\x0a"
"        }\x0a"
"        if (__fb <= __vt \x26\x26 __vt < __fe)\x0a"
"            __vt = (const_iterator(static_cast<__map_const_pointer>(__f.__m_iter_), __vt) -= __f - __r).__ptr_;\x0a"
"        __r = _VSTD\x3a\x3amove(__fb, __fe, __r);\x0a"
"        __n -= __bs;\x0a"
"        __f += __bs;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// move assign \x5b__f, __l) to \x5b__r - (__l-__f), __r) backwards.\x0a"
"// If __vt points into \x5b__f, __l), then add (__r - __l) to __vt.\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__move_backward_and_check(iterator __f, iterator __l, iterator __r,\x0a"
"                                                  const_pointer\x26 __vt)\x0a"
"{\x0a"
"    // as if\x0a"
"    //   while (__f \x21= __l)\x0a"
"    //       *--__r = _VSTD\x3a\x3amove(*--__l);\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        --__l;\x0a"
"        pointer __lb = *__l.__m_iter_;\x0a"
"        pointer __le = __l.__ptr_ + 1;\x0a"
"        difference_type __bs = __le - __lb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __lb = __le - __bs;\x0a"
"        }\x0a"
"        if (__lb <= __vt \x26\x26 __vt < __le)\x0a"
"            __vt = (const_iterator(static_cast<__map_const_pointer>(__l.__m_iter_), __vt) += __r - __l - 1).__ptr_;\x0a"
"        __r = _VSTD\x3a\x3amove_backward(__lb, __le, __r);\x0a"
"        __n -= __bs;\x0a"
"        __l -= __bs - 1;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// move construct \x5b__f, __l) to \x5b__r, __r + (__l-__f)).\x0a"
"// If __vt points into \x5b__f, __l), then add (__r - __f) to __vt.\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__move_construct_and_check(iterator __f, iterator __l,\x0a"
"                                                   iterator __r, const_pointer\x26 __vt)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    // as if\x0a"
"    //   for (; __f \x21= __l; ++__r, ++__f, ++__base\x3a\x3asize())\x0a"
"    //       __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__r), _VSTD\x3a\x3amove(*__f));\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        pointer __fb = __f.__ptr_;\x0a"
"        pointer __fe = *__f.__m_iter_ + __base\x3a\x3a__block_size;\x0a"
"        difference_type __bs = __fe - __fb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __fe = __fb + __bs;\x0a"
"        }\x0a"
"        if (__fb <= __vt \x26\x26 __vt < __fe)\x0a"
"            __vt = (const_iterator(static_cast<__map_const_pointer>(__f.__m_iter_), __vt) += __r - __f).__ptr_;\x0a"
"        for (; __fb \x21= __fe; ++__fb, ++__r, ++__base\x3a\x3asize())\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*__r), _VSTD\x3a\x3amove(*__fb));\x0a"
"        __n -= __bs;\x0a"
"        __f += __bs;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// move construct \x5b__f, __l) to \x5b__r - (__l-__f), __r) backwards.\x0a"
"// If __vt points into \x5b__f, __l), then subtract (__l - __r) from __vt.\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__move_construct_backward_and_check(iterator __f, iterator __l,\x0a"
"                                                            iterator __r, const_pointer\x26 __vt)\x0a"
"{\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    // as if\x0a"
"    //   for (iterator __j = __l; __j \x21= __f;)\x0a"
"    //   {\x0a"
"    //       __alloc_traitsconstruct(__a, _VSTD\x3a\x3a""addressof(*--__r), _VSTD\x3a\x3amove(*--__j));\x0a"
"    //       --__base\x3a\x3a__start_;\x0a"
"    //       ++__base\x3a\x3asize();\x0a"
"    //   }\x0a"
"    difference_type __n = __l - __f;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"        --__l;\x0a"
"        pointer __lb = *__l.__m_iter_;\x0a"
"        pointer __le = __l.__ptr_ + 1;\x0a"
"        difference_type __bs = __le - __lb;\x0a"
"        if (__bs > __n)\x0a"
"        {\x0a"
"            __bs = __n;\x0a"
"            __lb = __le - __bs;\x0a"
"        }\x0a"
"        if (__lb <= __vt \x26\x26 __vt < __le)\x0a"
"            __vt = (const_iterator(static_cast<__map_const_pointer>(__l.__m_iter_), __vt) -= __l - __r + 1).__ptr_;\x0a"
"        while (__le \x21= __lb)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a""addressof(*--__r), _VSTD\x3a\x3amove(*--__le));\x0a"
"            --__base\x3a\x3a__start_;\x0a"
"            ++__base\x3a\x3asize();\x0a"
"        }\x0a"
"        __n -= __bs;\x0a"
"        __l -= __bs - 1;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""erase(const_iterator __f)\x0a"
"{\x0a"
"    iterator __b = __base\x3a\x3a""begin();\x0a"
"    difference_type __pos = __f - __b;\x0a"
"    iterator __p = __b + __pos;\x0a"
"    allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"    if (static_cast<size_t>(__pos) <= (__base\x3a\x3asize() - 1) / 2)\x0a"
"    {   // erase from front\x0a"
"        _VSTD\x3a\x3amove_backward(__b, __p, _VSTD\x3a\x3anext(__p));\x0a"
"        __alloc_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(*__b));\x0a"
"        --__base\x3a\x3asize();\x0a"
"        ++__base\x3a\x3a__start_;\x0a"
"        if (__front_spare() >= 2 * __base\x3a\x3a__block_size)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__a, __base\x3a\x3a__map_.front(), __base\x3a\x3a__block_size);\x0a"
"            __base\x3a\x3a__map_.pop_front();\x0a"
"            __base\x3a\x3a__start_ -= __base\x3a\x3a__block_size;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {   // erase from back\x0a"
"        iterator __i = _VSTD\x3a\x3amove(_VSTD\x3a\x3anext(__p), __base\x3a\x3a""end(), __p);\x0a"
"        __alloc_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(*__i));\x0a"
"        --__base\x3a\x3asize();\x0a"
"        if (__back_spare() >= 2 * __base\x3a\x3a__block_size)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__a, __base\x3a\x3a__map_.back(), __base\x3a\x3a__block_size);\x0a"
"            __base\x3a\x3a__map_.pop_back();\x0a"
"        }\x0a"
"    }\x0a"
"    return __base\x3a\x3a""begin() + __pos;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename deque<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""erase(const_iterator __f, const_iterator __l)\x0a"
"{\x0a"
"    difference_type __n = __l - __f;\x0a"
"    iterator __b = __base\x3a\x3a""begin();\x0a"
"    difference_type __pos = __f - __b;\x0a"
"    iterator __p = __b + __pos;\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"        if (static_cast<size_t>(__pos) <= (__base\x3a\x3asize() - __n) / 2)\x0a"
"        {   // erase from front\x0a"
"            iterator __i = _VSTD\x3a\x3amove_backward(__b, __p, __p + __n);\x0a"
"            for (; __b \x21= __i; ++__b)\x0a"
"                __alloc_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(*__b));\x0a"
"            __base\x3a\x3asize() -= __n;\x0a"
"            __base\x3a\x3a__start_ += __n;\x0a"
"            while (__front_spare() >= 2 * __base\x3a\x3a__block_size)\x0a"
"            {\x0a"
"                __alloc_traits\x3a\x3a""deallocate(__a, __base\x3a\x3a__map_.front(), __base\x3a\x3a__block_size);\x0a"
"                __base\x3a\x3a__map_.pop_front();\x0a"
"                __base\x3a\x3a__start_ -= __base\x3a\x3a__block_size;\x0a"
"            }\x0a"
"        }\x0a"
"        else\x0a"
"        {   // erase from back\x0a"
"            iterator __i = _VSTD\x3a\x3amove(__p + __n, __base\x3a\x3a""end(), __p);\x0a"
"            for (iterator __e = __base\x3a\x3a""end(); __i \x21= __e; ++__i)\x0a"
"                __alloc_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(*__i));\x0a"
"            __base\x3a\x3asize() -= __n;\x0a"
"            while (__back_spare() >= 2 * __base\x3a\x3a__block_size)\x0a"
"            {\x0a"
"                __alloc_traits\x3a\x3a""deallocate(__a, __base\x3a\x3a__map_.back(), __base\x3a\x3a__block_size);\x0a"
"                __base\x3a\x3a__map_.pop_back();\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __base\x3a\x3a""begin() + __pos;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a__erase_to_end(const_iterator __f)\x0a"
"{\x0a"
"    iterator __e = __base\x3a\x3a""end();\x0a"
"    difference_type __n = __e - __f;\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        allocator_type\x26 __a = __base\x3a\x3a__alloc();\x0a"
"        iterator __b = __base\x3a\x3a""begin();\x0a"
"        difference_type __pos = __f - __b;\x0a"
"        for (iterator __p = __b + __pos; __p \x21= __e; ++__p)\x0a"
"            __alloc_traits\x3a\x3a""destroy(__a, _VSTD\x3a\x3a""addressof(*__p));\x0a"
"        __base\x3a\x3asize() -= __n;\x0a"
"        while (__back_spare() >= 2 * __base\x3a\x3a__block_size)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__a, __base\x3a\x3a__map_.back(), __base\x3a\x3a__block_size);\x0a"
"            __base\x3a\x3a__map_.pop_back();\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3aswap(deque\x26 __c)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<allocator_type>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"    __base\x3a\x3aswap(__c);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"deque<_Tp, _Allocator>\x3a\x3a""clear() _NOEXCEPT\x0a"
"{\x0a"
"    __base\x3a\x3a""clear();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const deque<_Tp, _Allocator>\x26 __x, const deque<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    const typename deque<_Tp, _Allocator>\x3a\x3asize_type __sz = __x.size();\x0a"
"    return __sz == __y.size() \x26\x26 _VSTD\x3a\x3a""equal(__x.begin(), __x.end(), __y.begin());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const deque<_Tp, _Allocator>\x26 __x, const deque<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const deque<_Tp, _Allocator>\x26 __x, const deque<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alexicographical_compare(__x.begin(), __x.end(), __y.begin(), __y.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const deque<_Tp, _Allocator>\x26 __x, const deque<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const deque<_Tp, _Allocator>\x26 __x, const deque<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const deque<_Tp, _Allocator>\x26 __x, const deque<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(deque<_Tp, _Allocator>\x26 __x, deque<_Tp, _Allocator>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Tp, class _Allocator, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase(deque<_Tp, _Allocator>\x26 __c, const _Up\x26 __v)\x0a"
"{ __c.erase(_VSTD\x3a\x3aremove(__c.begin(), __c.end(), __v), __c.end()); }\x0a"
"\x0a"
"template <class _Tp, class _Allocator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(deque<_Tp, _Allocator>\x26 __c, _Predicate __pred)\x0a"
"{ __c.erase(_VSTD\x3a\x3aremove_if(__c.begin(), __c.end(), __pred), __c.end()); }\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_DEQUE\x0a"
"", 106308 ); }