#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_memory( 
"// -*- C++ -*-\x0a"
"//===-------------------------- memory ------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_MEMORY\x0a"
"#define _LIBCPP_MEMORY\x0a"
"\x0a"
"/*\x0a"
"    memory synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"struct allocator_arg_t { };\x0a"
"inline constexpr allocator_arg_t allocator_arg = allocator_arg_t();\x0a"
"\x0a"
"template <class T, class Alloc> struct uses_allocator;\x0a"
"\x0a"
"template <class Ptr>\x0a"
"struct pointer_traits\x0a"
"{\x0a"
"    typedef Ptr pointer;\x0a"
"    typedef <details> element_type;\x0a"
"    typedef <details> difference_type;\x0a"
"\x0a"
"    template <class U> using rebind = <details>;\x0a"
"\x0a"
"    static pointer pointer_to(<details>);\x0a"
"};\x0a"
"\x0a"
"template <class T>\x0a"
"struct pointer_traits<T*>\x0a"
"{\x0a"
"    typedef T* pointer;\x0a"
"    typedef T element_type;\x0a"
"    typedef ptrdiff_t difference_type;\x0a"
"\x0a"
"    template <class U> using rebind = U*;\x0a"
"\x0a"
"    static pointer pointer_to(<details>) noexcept; // constexpr in C++20\x0a"
"};\x0a"
"\x0a"
"template <class T> constexpr T* to_address(T* p) noexcept; // C++20\x0a"
"template <class Ptr> auto to_address(const Ptr\x26 p) noexcept; // C++20\x0a"
"\x0a"
"template <class Alloc>\x0a"
"struct allocator_traits\x0a"
"{\x0a"
"    typedef Alloc                        allocator_type;\x0a"
"    typedef typename allocator_type\x3a\x3avalue_type\x0a"
"                                         value_type;\x0a"
"\x0a"
"    typedef Alloc\x3a\x3apointer \x7c value_type* pointer;\x0a"
"    typedef Alloc\x3a\x3a""const_pointer\x0a"
"          \x7c pointer_traits<pointer>\x3a\x3arebind<const value_type>\x0a"
"                                         const_pointer;\x0a"
"    typedef Alloc\x3a\x3avoid_pointer\x0a"
"          \x7c pointer_traits<pointer>\x3a\x3arebind<void>\x0a"
"                                         void_pointer;\x0a"
"    typedef Alloc\x3a\x3a""const_void_pointer\x0a"
"          \x7c pointer_traits<pointer>\x3a\x3arebind<const void>\x0a"
"                                         const_void_pointer;\x0a"
"    typedef Alloc\x3a\x3a""difference_type\x0a"
"          \x7c pointer_traits<pointer>\x3a\x3a""difference_type\x0a"
"                                         difference_type;\x0a"
"    typedef Alloc\x3a\x3asize_type\x0a"
"          \x7c make_unsigned<difference_type>\x3a\x3atype\x0a"
"                                         size_type;\x0a"
"    typedef Alloc\x3a\x3apropagate_on_container_copy_assignment\x0a"
"          \x7c false_type                   propagate_on_container_copy_assignment;\x0a"
"    typedef Alloc\x3a\x3apropagate_on_container_move_assignment\x0a"
"          \x7c false_type                   propagate_on_container_move_assignment;\x0a"
"    typedef Alloc\x3a\x3apropagate_on_container_swap\x0a"
"          \x7c false_type                   propagate_on_container_swap;\x0a"
"    typedef Alloc\x3a\x3ais_always_equal\x0a"
"          \x7c is_empty                     is_always_equal;\x0a"
"\x0a"
"    template <class T> using rebind_alloc  = Alloc\x3a\x3arebind<U>\x3a\x3aother \x7c Alloc<T, Args...>;\x0a"
"    template <class T> using rebind_traits = allocator_traits<rebind_alloc<T>>;\x0a"
"\x0a"
"    static pointer allocate(allocator_type\x26 a, size_type n);                          // \x5b\x5bnodiscard\x5d\x5d in C++20\x0a"
"    static pointer allocate(allocator_type\x26 a, size_type n, const_void_pointer hint); // \x5b\x5bnodiscard\x5d\x5d in C++20\x0a"
"\x0a"
"    static void deallocate(allocator_type\x26 a, pointer p, size_type n) noexcept;\x0a"
"\x0a"
"    template <class T, class... Args>\x0a"
"        static void construct(allocator_type\x26 a, T* p, Args\x26\x26... args);\x0a"
"\x0a"
"    template <class T>\x0a"
"        static void destroy(allocator_type\x26 a, T* p);\x0a"
"\x0a"
"    static size_type max_size(const allocator_type\x26 a); // noexcept in C++14\x0a"
"\x0a"
"    static allocator_type\x0a"
"        select_on_container_copy_construction(const allocator_type\x26 a);\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class allocator<void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef void*                                 pointer;\x0a"
"    typedef const void*                           const_pointer;\x0a"
"    typedef void                                  value_type;\x0a"
"\x0a"
"    template <class _Up> struct rebind {typedef allocator<_Up> other;};\x0a"
"};\x0a"
"\x0a"
"template <class T>\x0a"
"class allocator\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef size_t                                size_type;\x0a"
"    typedef ptrdiff_t                             difference_type;\x0a"
"    typedef T*                                    pointer;\x0a"
"    typedef const T*                              const_pointer;\x0a"
"    typedef typename add_lvalue_reference<T>\x3a\x3atype       reference;\x0a"
"    typedef typename add_lvalue_reference<const T>\x3a\x3atype const_reference;\x0a"
"    typedef T                                     value_type;\x0a"
"\x0a"
"    template <class U> struct rebind {typedef allocator<U> other;};\x0a"
"\x0a"
"    constexpr allocator() noexcept;                      // constexpr in C++20\x0a"
"    constexpr allocator(const allocator\x26) noexcept;      // constexpr in C++20\x0a"
"    template <class U>\x0a"
"      constexpr allocator(const allocator<U>\x26) noexcept; // constexpr in C++20\x0a"
"    \x7e""allocator();\x0a"
"    pointer address(reference x) const noexcept;\x0a"
"    const_pointer address(const_reference x) const noexcept;\x0a"
"    pointer allocate(size_type, allocator<void>\x3a\x3a""const_pointer hint = 0);\x0a"
"    void deallocate(pointer p, size_type n) noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"    template<class U, class... Args>\x0a"
"        void construct(U* p, Args\x26\x26... args);\x0a"
"    template <class U>\x0a"
"        void destroy(U* p);\x0a"
"};\x0a"
"\x0a"
"template <class T, class U>\x0a"
"bool operator==(const allocator<T>\x26, const allocator<U>\x26) noexcept;\x0a"
"\x0a"
"template <class T, class U>\x0a"
"bool operator\x21=(const allocator<T>\x26, const allocator<U>\x26) noexcept;\x0a"
"\x0a"
"template <class OutputIterator, class T>\x0a"
"class raw_storage_iterator\x0a"
"    \x3a public iterator<output_iterator_tag,\x0a"
"                      T,                               // purposefully not C++03\x0a"
"                      ptrdiff_t,                       // purposefully not C++03\x0a"
"                      T*,                              // purposefully not C++03\x0a"
"                      raw_storage_iterator\x26>           // purposefully not C++03\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit raw_storage_iterator(OutputIterator x);\x0a"
"    raw_storage_iterator\x26 operator*();\x0a"
"    raw_storage_iterator\x26 operator=(const T\x26 element);\x0a"
"    raw_storage_iterator\x26 operator++();\x0a"
"    raw_storage_iterator  operator++(int);\x0a"
"};\x0a"
"\x0a"
"template <class T> pair<T*,ptrdiff_t> get_temporary_buffer(ptrdiff_t n) noexcept;\x0a"
"template <class T> void               return_temporary_buffer(T* p) noexcept;\x0a"
"\x0a"
"template <class T> T* addressof(T\x26 r) noexcept;\x0a"
"template <class T> T* addressof(const T\x26\x26 r) noexcept = delete;\x0a"
"\x0a"
"template <class InputIterator, class ForwardIterator>\x0a"
"ForwardIterator\x0a"
"uninitialized_copy(InputIterator first, InputIterator last, ForwardIterator result);\x0a"
"\x0a"
"template <class InputIterator, class Size, class ForwardIterator>\x0a"
"ForwardIterator\x0a"
"uninitialized_copy_n(InputIterator first, Size n, ForwardIterator result);\x0a"
"\x0a"
"template <class ForwardIterator, class T>\x0a"
"void uninitialized_fill(ForwardIterator first, ForwardIterator last, const T\x26 x);\x0a"
"\x0a"
"template <class ForwardIterator, class Size, class T>\x0a"
"ForwardIterator\x0a"
"uninitialized_fill_n(ForwardIterator first, Size n, const T\x26 x);\x0a"
"\x0a"
"template <class T>\x0a"
"void destroy_at(T* location);\x0a"
"\x0a"
"template <class ForwardIterator>\x0a"
" void destroy(ForwardIterator first, ForwardIterator last);\x0a"
"\x0a"
"template <class ForwardIterator, class Size>\x0a"
" ForwardIterator destroy_n(ForwardIterator first, Size n);\x0a"
"\x0a"
"template <class InputIterator, class ForwardIterator>\x0a"
" ForwardIterator uninitialized_move(InputIterator first, InputIterator last, ForwardIterator result);\x0a"
"\x0a"
"template <class InputIterator, class Size, class ForwardIterator>\x0a"
" pair<InputIterator,ForwardIterator> uninitialized_move_n(InputIterator first, Size n, ForwardIterator result);\x0a"
"\x0a"
"template <class ForwardIterator>\x0a"
" void uninitialized_value_construct(ForwardIterator first, ForwardIterator last);\x0a"
"\x0a"
"template <class ForwardIterator, class Size>\x0a"
" ForwardIterator uninitialized_value_construct_n(ForwardIterator first, Size n);\x0a"
"\x0a"
"template <class ForwardIterator>\x0a"
" void uninitialized_default_construct(ForwardIterator first, ForwardIterator last);\x0a"
"\x0a"
"template <class ForwardIterator, class Size>\x0a"
" ForwardIterator uninitialized_default_construct_n(ForwardIterator first, Size n);\x0a"
"\x0a"
"template <class Y> struct auto_ptr_ref {};      // deprecated in C++11, removed in C++17\x0a"
"\x0a"
"template<class X>\x0a"
"class auto_ptr                                  // deprecated in C++11, removed in C++17\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef X element_type;\x0a"
"\x0a"
"    explicit auto_ptr(X* p =0) throw();\x0a"
"    auto_ptr(auto_ptr\x26) throw();\x0a"
"    template<class Y> auto_ptr(auto_ptr<Y>\x26) throw();\x0a"
"    auto_ptr\x26 operator=(auto_ptr\x26) throw();\x0a"
"    template<class Y> auto_ptr\x26 operator=(auto_ptr<Y>\x26) throw();\x0a"
"    auto_ptr\x26 operator=(auto_ptr_ref<X> r) throw();\x0a"
"    \x7e""auto_ptr() throw();\x0a"
"\x0a"
"    typename add_lvalue_reference<X>\x3a\x3atype operator*() const throw();\x0a"
"    X* operator->() const throw();\x0a"
"    X* get() const throw();\x0a"
"    X* release() throw();\x0a"
"    void reset(X* p =0) throw();\x0a"
"\x0a"
"    auto_ptr(auto_ptr_ref<X>) throw();\x0a"
"    template<class Y> operator auto_ptr_ref<Y>() throw();\x0a"
"    template<class Y> operator auto_ptr<Y>() throw();\x0a"
"};\x0a"
"\x0a"
"template <class T>\x0a"
"struct default_delete\x0a"
"{\x0a"
"    constexpr default_delete() noexcept = default;\x0a"
"    template <class U> default_delete(const default_delete<U>\x26) noexcept;\x0a"
"\x0a"
"    void operator()(T*) const noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class T>\x0a"
"struct default_delete<T\x5b\x5d>\x0a"
"{\x0a"
"    constexpr default_delete() noexcept = default;\x0a"
"    void operator()(T*) const noexcept;\x0a"
"    template <class U> void operator()(U*) const = delete;\x0a"
"};\x0a"
"\x0a"
"template <class T, class D = default_delete<T>>\x0a"
"class unique_ptr\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef see below pointer;\x0a"
"    typedef T element_type;\x0a"
"    typedef D deleter_type;\x0a"
"\x0a"
"    // constructors\x0a"
"    constexpr unique_ptr() noexcept;\x0a"
"    explicit unique_ptr(pointer p) noexcept;\x0a"
"    unique_ptr(pointer p, see below d1) noexcept;\x0a"
"    unique_ptr(pointer p, see below d2) noexcept;\x0a"
"    unique_ptr(unique_ptr\x26\x26 u) noexcept;\x0a"
"    unique_ptr(nullptr_t) noexcept \x3a unique_ptr() { }\x0a"
"    template <class U, class E>\x0a"
"        unique_ptr(unique_ptr<U, E>\x26\x26 u) noexcept;\x0a"
"    template <class U>\x0a"
"        unique_ptr(auto_ptr<U>\x26\x26 u) noexcept;       // removed in C++17\x0a"
"\x0a"
"    // destructor\x0a"
"    \x7eunique_ptr();\x0a"
"\x0a"
"    // assignment\x0a"
"    unique_ptr\x26 operator=(unique_ptr\x26\x26 u) noexcept;\x0a"
"    template <class U, class E> unique_ptr\x26 operator=(unique_ptr<U, E>\x26\x26 u) noexcept;\x0a"
"    unique_ptr\x26 operator=(nullptr_t) noexcept;\x0a"
"\x0a"
"    // observers\x0a"
"    typename add_lvalue_reference<T>\x3a\x3atype operator*() const;\x0a"
"    pointer operator->() const noexcept;\x0a"
"    pointer get() const noexcept;\x0a"
"    deleter_type\x26 get_deleter() noexcept;\x0a"
"    const deleter_type\x26 get_deleter() const noexcept;\x0a"
"    explicit operator bool() const noexcept;\x0a"
"\x0a"
"    // modifiers\x0a"
"    pointer release() noexcept;\x0a"
"    void reset(pointer p = pointer()) noexcept;\x0a"
"    void swap(unique_ptr\x26 u) noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class T, class D>\x0a"
"class unique_ptr<T\x5b\x5d, D>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef implementation-defined pointer;\x0a"
"    typedef T element_type;\x0a"
"    typedef D deleter_type;\x0a"
"\x0a"
"    // constructors\x0a"
"    constexpr unique_ptr() noexcept;\x0a"
"    explicit unique_ptr(pointer p) noexcept;\x0a"
"    unique_ptr(pointer p, see below d) noexcept;\x0a"
"    unique_ptr(pointer p, see below d) noexcept;\x0a"
"    unique_ptr(unique_ptr\x26\x26 u) noexcept;\x0a"
"    unique_ptr(nullptr_t) noexcept \x3a unique_ptr() { }\x0a"
"\x0a"
"    // destructor\x0a"
"    \x7eunique_ptr();\x0a"
"\x0a"
"    // assignment\x0a"
"    unique_ptr\x26 operator=(unique_ptr\x26\x26 u) noexcept;\x0a"
"    unique_ptr\x26 operator=(nullptr_t) noexcept;\x0a"
"\x0a"
"    // observers\x0a"
"    T\x26 operator\x5b\x5d(size_t i) const;\x0a"
"    pointer get() const noexcept;\x0a"
"    deleter_type\x26 get_deleter() noexcept;\x0a"
"    const deleter_type\x26 get_deleter() const noexcept;\x0a"
"    explicit operator bool() const noexcept;\x0a"
"\x0a"
"    // modifiers\x0a"
"    pointer release() noexcept;\x0a"
"    void reset(pointer p = pointer()) noexcept;\x0a"
"    void reset(nullptr_t) noexcept;\x0a"
"    template <class U> void reset(U) = delete;\x0a"
"    void swap(unique_ptr\x26 u) noexcept;\x0a"
"};\x0a"
"\x0a"
"template <class T, class D>\x0a"
"    void swap(unique_ptr<T, D>\x26 x, unique_ptr<T, D>\x26 y) noexcept;\x0a"
"\x0a"
"template <class T1, class D1, class T2, class D2>\x0a"
"    bool operator==(const unique_ptr<T1, D1>\x26 x, const unique_ptr<T2, D2>\x26 y);\x0a"
"template <class T1, class D1, class T2, class D2>\x0a"
"    bool operator\x21=(const unique_ptr<T1, D1>\x26 x, const unique_ptr<T2, D2>\x26 y);\x0a"
"template <class T1, class D1, class T2, class D2>\x0a"
"    bool operator<(const unique_ptr<T1, D1>\x26 x, const unique_ptr<T2, D2>\x26 y);\x0a"
"template <class T1, class D1, class T2, class D2>\x0a"
"    bool operator<=(const unique_ptr<T1, D1>\x26 x, const unique_ptr<T2, D2>\x26 y);\x0a"
"template <class T1, class D1, class T2, class D2>\x0a"
"    bool operator>(const unique_ptr<T1, D1>\x26 x, const unique_ptr<T2, D2>\x26 y);\x0a"
"template <class T1, class D1, class T2, class D2>\x0a"
"    bool operator>=(const unique_ptr<T1, D1>\x26 x, const unique_ptr<T2, D2>\x26 y);\x0a"
"\x0a"
"template <class T, class D>\x0a"
"    bool operator==(const unique_ptr<T, D>\x26 x, nullptr_t) noexcept;\x0a"
"template <class T, class D>\x0a"
"    bool operator==(nullptr_t, const unique_ptr<T, D>\x26 y) noexcept;\x0a"
"template <class T, class D>\x0a"
"    bool operator\x21=(const unique_ptr<T, D>\x26 x, nullptr_t) noexcept;\x0a"
"template <class T, class D>\x0a"
"    bool operator\x21=(nullptr_t, const unique_ptr<T, D>\x26 y) noexcept;\x0a"
"\x0a"
"template <class T, class D>\x0a"
"    bool operator<(const unique_ptr<T, D>\x26 x, nullptr_t);\x0a"
"template <class T, class D>\x0a"
"    bool operator<(nullptr_t, const unique_ptr<T, D>\x26 y);\x0a"
"template <class T, class D>\x0a"
"    bool operator<=(const unique_ptr<T, D>\x26 x, nullptr_t);\x0a"
"template <class T, class D>\x0a"
"    bool operator<=(nullptr_t, const unique_ptr<T, D>\x26 y);\x0a"
"template <class T, class D>\x0a"
"    bool operator>(const unique_ptr<T, D>\x26 x, nullptr_t);\x0a"
"template <class T, class D>\x0a"
"    bool operator>(nullptr_t, const unique_ptr<T, D>\x26 y);\x0a"
"template <class T, class D>\x0a"
"    bool operator>=(const unique_ptr<T, D>\x26 x, nullptr_t);\x0a"
"template <class T, class D>\x0a"
"    bool operator>=(nullptr_t, const unique_ptr<T, D>\x26 y);\x0a"
"\x0a"
"class bad_weak_ptr\x0a"
"    \x3a public std\x3a\x3a""exception\x0a"
"{\x0a"
"    bad_weak_ptr() noexcept;\x0a"
"};\x0a"
"\x0a"
"template<class T, class... Args> unique_ptr<T> make_unique(Args\x26\x26... args);     // C++14\x0a"
"template<class T>                unique_ptr<T> make_unique(size_t n);           // C++14\x0a"
"template<class T, class... Args> unspecified   make_unique(Args\x26\x26...) = delete; // C++14, T == U\x5bN\x5d\x0a"
"\x0a"
"template<class E, class T, class Y, class D>\x0a"
"    basic_ostream<E, T>\x26 operator<< (basic_ostream<E, T>\x26 os, unique_ptr<Y, D> const\x26 p);\x0a"
"\x0a"
"template<class T>\x0a"
"class shared_ptr\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T element_type;\x0a"
"    typedef weak_ptr<T> weak_type; // C++17\x0a"
"\x0a"
"    // constructors\x3a\x0a"
"    constexpr shared_ptr() noexcept;\x0a"
"    template<class Y> explicit shared_ptr(Y* p);\x0a"
"    template<class Y, class D> shared_ptr(Y* p, D d);\x0a"
"    template<class Y, class D, class A> shared_ptr(Y* p, D d, A a);\x0a"
"    template <class D> shared_ptr(nullptr_t p, D d);\x0a"
"    template <class D, class A> shared_ptr(nullptr_t p, D d, A a);\x0a"
"    template<class Y> shared_ptr(const shared_ptr<Y>\x26 r, T *p) noexcept;\x0a"
"    shared_ptr(const shared_ptr\x26 r) noexcept;\x0a"
"    template<class Y> shared_ptr(const shared_ptr<Y>\x26 r) noexcept;\x0a"
"    shared_ptr(shared_ptr\x26\x26 r) noexcept;\x0a"
"    template<class Y> shared_ptr(shared_ptr<Y>\x26\x26 r) noexcept;\x0a"
"    template<class Y> explicit shared_ptr(const weak_ptr<Y>\x26 r);\x0a"
"    template<class Y> shared_ptr(auto_ptr<Y>\x26\x26 r);          // removed in C++17\x0a"
"    template <class Y, class D> shared_ptr(unique_ptr<Y, D>\x26\x26 r);\x0a"
"    shared_ptr(nullptr_t) \x3a shared_ptr() { }\x0a"
"\x0a"
"    // destructor\x3a\x0a"
"    \x7eshared_ptr();\x0a"
"\x0a"
"    // assignment\x3a\x0a"
"    shared_ptr\x26 operator=(const shared_ptr\x26 r) noexcept;\x0a"
"    template<class Y> shared_ptr\x26 operator=(const shared_ptr<Y>\x26 r) noexcept;\x0a"
"    shared_ptr\x26 operator=(shared_ptr\x26\x26 r) noexcept;\x0a"
"    template<class Y> shared_ptr\x26 operator=(shared_ptr<Y>\x26\x26 r);\x0a"
"    template<class Y> shared_ptr\x26 operator=(auto_ptr<Y>\x26\x26 r); // removed in C++17\x0a"
"    template <class Y, class D> shared_ptr\x26 operator=(unique_ptr<Y, D>\x26\x26 r);\x0a"
"\x0a"
"    // modifiers\x3a\x0a"
"    void swap(shared_ptr\x26 r) noexcept;\x0a"
"    void reset() noexcept;\x0a"
"    template<class Y> void reset(Y* p);\x0a"
"    template<class Y, class D> void reset(Y* p, D d);\x0a"
"    template<class Y, class D, class A> void reset(Y* p, D d, A a);\x0a"
"\x0a"
"    // observers\x3a\x0a"
"    T* get() const noexcept;\x0a"
"    T\x26 operator*() const noexcept;\x0a"
"    T* operator->() const noexcept;\x0a"
"    long use_count() const noexcept;\x0a"
"    bool unique() const noexcept;\x0a"
"    explicit operator bool() const noexcept;\x0a"
"    template<class U> bool owner_before(shared_ptr<U> const\x26 b) const noexcept;\x0a"
"    template<class U> bool owner_before(weak_ptr<U> const\x26 b) const noexcept;\x0a"
"};\x0a"
"\x0a"
"// shared_ptr comparisons\x3a\x0a"
"template<class T, class U>\x0a"
"    bool operator==(shared_ptr<T> const\x26 a, shared_ptr<U> const\x26 b) noexcept;\x0a"
"template<class T, class U>\x0a"
"    bool operator\x21=(shared_ptr<T> const\x26 a, shared_ptr<U> const\x26 b) noexcept;\x0a"
"template<class T, class U>\x0a"
"    bool operator<(shared_ptr<T> const\x26 a, shared_ptr<U> const\x26 b) noexcept;\x0a"
"template<class T, class U>\x0a"
"    bool operator>(shared_ptr<T> const\x26 a, shared_ptr<U> const\x26 b) noexcept;\x0a"
"template<class T, class U>\x0a"
"    bool operator<=(shared_ptr<T> const\x26 a, shared_ptr<U> const\x26 b) noexcept;\x0a"
"template<class T, class U>\x0a"
"    bool operator>=(shared_ptr<T> const\x26 a, shared_ptr<U> const\x26 b) noexcept;\x0a"
"\x0a"
"template <class T>\x0a"
"    bool operator==(const shared_ptr<T>\x26 x, nullptr_t) noexcept;\x0a"
"template <class T>\x0a"
"    bool operator==(nullptr_t, const shared_ptr<T>\x26 y) noexcept;\x0a"
"template <class T>\x0a"
"    bool operator\x21=(const shared_ptr<T>\x26 x, nullptr_t) noexcept;\x0a"
"template <class T>\x0a"
"    bool operator\x21=(nullptr_t, const shared_ptr<T>\x26 y) noexcept;\x0a"
"template <class T>\x0a"
"    bool operator<(const shared_ptr<T>\x26 x, nullptr_t) noexcept;\x0a"
"template <class T>\x0a"
"bool operator<(nullptr_t, const shared_ptr<T>\x26 y) noexcept;\x0a"
"template <class T>\x0a"
"    bool operator<=(const shared_ptr<T>\x26 x, nullptr_t) noexcept;\x0a"
"template <class T>\x0a"
"    bool operator<=(nullptr_t, const shared_ptr<T>\x26 y) noexcept;\x0a"
"template <class T>\x0a"
"    bool operator>(const shared_ptr<T>\x26 x, nullptr_t) noexcept;\x0a"
"template <class T>\x0a"
"    bool operator>(nullptr_t, const shared_ptr<T>\x26 y) noexcept;\x0a"
"template <class T>\x0a"
"    bool operator>=(const shared_ptr<T>\x26 x, nullptr_t) noexcept;\x0a"
"template <class T>\x0a"
"    bool operator>=(nullptr_t, const shared_ptr<T>\x26 y) noexcept;\x0a"
"\x0a"
"// shared_ptr specialized algorithms\x3a\x0a"
"template<class T> void swap(shared_ptr<T>\x26 a, shared_ptr<T>\x26 b) noexcept;\x0a"
"\x0a"
"// shared_ptr casts\x3a\x0a"
"template<class T, class U>\x0a"
"    shared_ptr<T> static_pointer_cast(shared_ptr<U> const\x26 r) noexcept;\x0a"
"template<class T, class U>\x0a"
"    shared_ptr<T> dynamic_pointer_cast(shared_ptr<U> const\x26 r) noexcept;\x0a"
"template<class T, class U>\x0a"
"    shared_ptr<T> const_pointer_cast(shared_ptr<U> const\x26 r) noexcept;\x0a"
"\x0a"
"// shared_ptr I/O\x3a\x0a"
"template<class E, class T, class Y>\x0a"
"    basic_ostream<E, T>\x26 operator<< (basic_ostream<E, T>\x26 os, shared_ptr<Y> const\x26 p);\x0a"
"\x0a"
"// shared_ptr get_deleter\x3a\x0a"
"template<class D, class T> D* get_deleter(shared_ptr<T> const\x26 p) noexcept;\x0a"
"\x0a"
"template<class T, class... Args>\x0a"
"    shared_ptr<T> make_shared(Args\x26\x26... args);\x0a"
"template<class T, class A, class... Args>\x0a"
"    shared_ptr<T> allocate_shared(const A\x26 a, Args\x26\x26... args);\x0a"
"\x0a"
"template<class T>\x0a"
"class weak_ptr\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T element_type;\x0a"
"\x0a"
"    // constructors\x0a"
"    constexpr weak_ptr() noexcept;\x0a"
"    template<class Y> weak_ptr(shared_ptr<Y> const\x26 r) noexcept;\x0a"
"    weak_ptr(weak_ptr const\x26 r) noexcept;\x0a"
"    template<class Y> weak_ptr(weak_ptr<Y> const\x26 r) noexcept;\x0a"
"    weak_ptr(weak_ptr\x26\x26 r) noexcept;                      // C++14\x0a"
"    template<class Y> weak_ptr(weak_ptr<Y>\x26\x26 r) noexcept; // C++14\x0a"
"\x0a"
"    // destructor\x0a"
"    \x7eweak_ptr();\x0a"
"\x0a"
"    // assignment\x0a"
"    weak_ptr\x26 operator=(weak_ptr const\x26 r) noexcept;\x0a"
"    template<class Y> weak_ptr\x26 operator=(weak_ptr<Y> const\x26 r) noexcept;\x0a"
"    template<class Y> weak_ptr\x26 operator=(shared_ptr<Y> const\x26 r) noexcept;\x0a"
"    weak_ptr\x26 operator=(weak_ptr\x26\x26 r) noexcept;                      // C++14\x0a"
"    template<class Y> weak_ptr\x26 operator=(weak_ptr<Y>\x26\x26 r) noexcept; // C++14\x0a"
"\x0a"
"    // modifiers\x0a"
"    void swap(weak_ptr\x26 r) noexcept;\x0a"
"    void reset() noexcept;\x0a"
"\x0a"
"    // observers\x0a"
"    long use_count() const noexcept;\x0a"
"    bool expired() const noexcept;\x0a"
"    shared_ptr<T> lock() const noexcept;\x0a"
"    template<class U> bool owner_before(shared_ptr<U> const\x26 b) const noexcept;\x0a"
"    template<class U> bool owner_before(weak_ptr<U> const\x26 b) const noexcept;\x0a"
"};\x0a"
"\x0a"
"// weak_ptr specialized algorithms\x3a\x0a"
"template<class T> void swap(weak_ptr<T>\x26 a, weak_ptr<T>\x26 b) noexcept;\x0a"
"\x0a"
"// class owner_less\x3a\x0a"
"template<class T> struct owner_less;\x0a"
"\x0a"
"template<class T>\x0a"
"struct owner_less<shared_ptr<T> >\x0a"
"    \x3a binary_function<shared_ptr<T>, shared_ptr<T>, bool>\x0a"
"{\x0a"
"    typedef bool result_type;\x0a"
"    bool operator()(shared_ptr<T> const\x26, shared_ptr<T> const\x26) const noexcept;\x0a"
"    bool operator()(shared_ptr<T> const\x26, weak_ptr<T> const\x26) const noexcept;\x0a"
"    bool operator()(weak_ptr<T> const\x26, shared_ptr<T> const\x26) const noexcept;\x0a"
"};\x0a"
"\x0a"
"template<class T>\x0a"
"struct owner_less<weak_ptr<T> >\x0a"
"    \x3a binary_function<weak_ptr<T>, weak_ptr<T>, bool>\x0a"
"{\x0a"
"    typedef bool result_type;\x0a"
"    bool operator()(weak_ptr<T> const\x26, weak_ptr<T> const\x26) const noexcept;\x0a"
"    bool operator()(shared_ptr<T> const\x26, weak_ptr<T> const\x26) const noexcept;\x0a"
"    bool operator()(weak_ptr<T> const\x26, shared_ptr<T> const\x26) const noexcept;\x0a"
"};\x0a"
"\x0a"
"template <>  // Added in C++14\x0a"
"struct owner_less<void>\x0a"
"{\x0a"
"    template <class _Tp, class _Up>\x0a"
"    bool operator()( shared_ptr<_Tp> const\x26 __x, shared_ptr<_Up> const\x26 __y) const noexcept;\x0a"
"    template <class _Tp, class _Up>\x0a"
"    bool operator()( shared_ptr<_Tp> const\x26 __x,   weak_ptr<_Up> const\x26 __y) const noexcept;\x0a"
"    template <class _Tp, class _Up>\x0a"
"    bool operator()(   weak_ptr<_Tp> const\x26 __x, shared_ptr<_Up> const\x26 __y) const noexcept;\x0a"
"    template <class _Tp, class _Up>\x0a"
"    bool operator()(   weak_ptr<_Tp> const\x26 __x,   weak_ptr<_Up> const\x26 __y) const noexcept;\x0a"
"\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"\x0a"
"template<class T>\x0a"
"class enable_shared_from_this\x0a"
"{\x0a"
"protected\x3a\x0a"
"    constexpr enable_shared_from_this() noexcept;\x0a"
"    enable_shared_from_this(enable_shared_from_this const\x26) noexcept;\x0a"
"    enable_shared_from_this\x26 operator=(enable_shared_from_this const\x26) noexcept;\x0a"
"    \x7e""enable_shared_from_this();\x0a"
"public\x3a\x0a"
"    shared_ptr<T> shared_from_this();\x0a"
"    shared_ptr<T const> shared_from_this() const;\x0a"
"};\x0a"
"\x0a"
"template<class T>\x0a"
"    bool atomic_is_lock_free(const shared_ptr<T>* p);\x0a"
"template<class T>\x0a"
"    shared_ptr<T> atomic_load(const shared_ptr<T>* p);\x0a"
"template<class T>\x0a"
"    shared_ptr<T> atomic_load_explicit(const shared_ptr<T>* p, memory_order mo);\x0a"
"template<class T>\x0a"
"    void atomic_store(shared_ptr<T>* p, shared_ptr<T> r);\x0a"
"template<class T>\x0a"
"    void atomic_store_explicit(shared_ptr<T>* p, shared_ptr<T> r, memory_order mo);\x0a"
"template<class T>\x0a"
"    shared_ptr<T> atomic_exchange(shared_ptr<T>* p, shared_ptr<T> r);\x0a"
"template<class T>\x0a"
"    shared_ptr<T>\x0a"
"    atomic_exchange_explicit(shared_ptr<T>* p, shared_ptr<T> r, memory_order mo);\x0a"
"template<class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_weak(shared_ptr<T>* p, shared_ptr<T>* v, shared_ptr<T> w);\x0a"
"template<class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_strong( shared_ptr<T>* p, shared_ptr<T>* v, shared_ptr<T> w);\x0a"
"template<class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_weak_explicit(shared_ptr<T>* p, shared_ptr<T>* v,\x0a"
"                                          shared_ptr<T> w, memory_order success,\x0a"
"                                          memory_order failure);\x0a"
"template<class T>\x0a"
"    bool\x0a"
"    atomic_compare_exchange_strong_explicit(shared_ptr<T>* p, shared_ptr<T>* v,\x0a"
"                                            shared_ptr<T> w, memory_order success,\x0a"
"                                            memory_order failure);\x0a"
"// Hash support\x0a"
"template <class T> struct hash;\x0a"
"template <class T, class D> struct hash<unique_ptr<T, D> >;\x0a"
"template <class T> struct hash<shared_ptr<T> >;\x0a"
"\x0a"
"template <class T, class Alloc>\x0a"
"  inline constexpr bool uses_allocator_v = uses_allocator<T, Alloc>\x3a\x3avalue;\x0a"
"\x0a"
"// Pointer safety\x0a"
"enum class pointer_safety { relaxed, preferred, strict };\x0a"
"void declare_reachable(void *p);\x0a"
"template <class T> T *undeclare_reachable(T *p);\x0a"
"void declare_no_pointers(char *p, size_t n);\x0a"
"void undeclare_no_pointers(char *p, size_t n);\x0a"
"pointer_safety get_pointer_safety() noexcept;\x0a"
"\x0a"
"void* align(size_t alignment, size_t size, void*\x26 ptr, size_t\x26 space);\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <type_traits>\x0a"
"#include <typeinfo>\x0a"
"#include <cstddef>\x0a"
"#include <cstdint>\x0a"
"#include <new>\x0a"
"#include <utility>\x0a"
"#include <limits>\x0a"
"#include <iterator>\x0a"
"#include <__functional_base>\x0a"
"#include <iosfwd>\x0a"
"#include <tuple>\x0a"
"#include <stdexcept>\x0a"
"#include <cstring>\x0a"
"#include <cassert>\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_ATOMIC_HEADER)\x0a"
"#  include <atomic>\x0a"
"#endif\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _ValueType>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_ValueType __libcpp_relaxed_load(_ValueType const* __value) {\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_THREADS) \x26\x26 \x5c\x0a"
"    defined(__ATOMIC_RELAXED) \x26\x26        \x5c\x0a"
"    (__has_builtin(__atomic_load_n) \x7c\x7c defined(_LIBCPP_COMPILER_GCC))\x0a"
"    return __atomic_load_n(__value, __ATOMIC_RELAXED);\x0a"
"#else\x0a"
"    return *__value;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _ValueType>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_ValueType __libcpp_acquire_load(_ValueType const* __value) {\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_THREADS) \x26\x26 \x5c\x0a"
"    defined(__ATOMIC_ACQUIRE) \x26\x26        \x5c\x0a"
"    (__has_builtin(__atomic_load_n) \x7c\x7c defined(_LIBCPP_COMPILER_GCC))\x0a"
"    return __atomic_load_n(__value, __ATOMIC_ACQUIRE);\x0a"
"#else\x0a"
"    return *__value;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"// addressof moved to <type_traits>\x0a"
"\x0a"
"template <class _Tp> class allocator;\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TEMPLATE_VIS allocator<void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef void*             pointer;\x0a"
"    typedef const void*       const_pointer;\x0a"
"    typedef void              value_type;\x0a"
"\x0a"
"    template <class _Up> struct rebind {typedef allocator<_Up> other;};\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TEMPLATE_VIS allocator<const void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef const void*       pointer;\x0a"
"    typedef const void*       const_pointer;\x0a"
"    typedef const void        value_type;\x0a"
"\x0a"
"    template <class _Up> struct rebind {typedef allocator<_Up> other;};\x0a"
"};\x0a"
"\x0a"
"// pointer_traits\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_element_type \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_element_type<_Tp,\x0a"
"              typename __void_t<typename _Tp\x3a\x3a""element_type>\x3a\x3atype> \x3a true_type {};\x0a"
"\x0a"
"template <class _Ptr, bool = __has_element_type<_Ptr>\x3a\x3avalue>\x0a"
"struct __pointer_traits_element_type;\x0a"
"\x0a"
"template <class _Ptr>\x0a"
"struct __pointer_traits_element_type<_Ptr, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Ptr\x3a\x3a""element_type type;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template <template <class, class...> class _Sp, class _Tp, class ..._Args>\x0a"
"struct __pointer_traits_element_type<_Sp<_Tp, _Args...>, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Sp<_Tp, _Args...>\x3a\x3a""element_type type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class...> class _Sp, class _Tp, class ..._Args>\x0a"
"struct __pointer_traits_element_type<_Sp<_Tp, _Args...>, false>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE _Tp type;\x0a"
"};\x0a"
"\x0a"
"#else  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template <template <class> class _Sp, class _Tp>\x0a"
"struct __pointer_traits_element_type<_Sp<_Tp>, true>\x0a"
"{\x0a"
"    typedef typename _Sp<_Tp>\x3a\x3a""element_type type;\x0a"
"};\x0a"
"\x0a"
"template <template <class> class _Sp, class _Tp>\x0a"
"struct __pointer_traits_element_type<_Sp<_Tp>, false>\x0a"
"{\x0a"
"    typedef _Tp type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class> class _Sp, class _Tp, class _A0>\x0a"
"struct __pointer_traits_element_type<_Sp<_Tp, _A0>, true>\x0a"
"{\x0a"
"    typedef typename _Sp<_Tp, _A0>\x3a\x3a""element_type type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class> class _Sp, class _Tp, class _A0>\x0a"
"struct __pointer_traits_element_type<_Sp<_Tp, _A0>, false>\x0a"
"{\x0a"
"    typedef _Tp type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class> class _Sp, class _Tp, class _A0, class _A1>\x0a"
"struct __pointer_traits_element_type<_Sp<_Tp, _A0, _A1>, true>\x0a"
"{\x0a"
"    typedef typename _Sp<_Tp, _A0, _A1>\x3a\x3a""element_type type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class> class _Sp, class _Tp, class _A0, class _A1>\x0a"
"struct __pointer_traits_element_type<_Sp<_Tp, _A0, _A1>, false>\x0a"
"{\x0a"
"    typedef _Tp type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class, class> class _Sp, class _Tp, class _A0,\x0a"
"                                                           class _A1, class _A2>\x0a"
"struct __pointer_traits_element_type<_Sp<_Tp, _A0, _A1, _A2>, true>\x0a"
"{\x0a"
"    typedef typename _Sp<_Tp, _A0, _A1, _A2>\x3a\x3a""element_type type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class, class> class _Sp, class _Tp, class _A0,\x0a"
"                                                           class _A1, class _A2>\x0a"
"struct __pointer_traits_element_type<_Sp<_Tp, _A0, _A1, _A2>, false>\x0a"
"{\x0a"
"    typedef _Tp type;\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_difference_type \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_difference_type<_Tp,\x0a"
"            typename __void_t<typename _Tp\x3a\x3a""difference_type>\x3a\x3atype> \x3a true_type {};\x0a"
"\x0a"
"template <class _Ptr, bool = __has_difference_type<_Ptr>\x3a\x3avalue>\x0a"
"struct __pointer_traits_difference_type\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE ptrdiff_t type;\x0a"
"};\x0a"
"\x0a"
"template <class _Ptr>\x0a"
"struct __pointer_traits_difference_type<_Ptr, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Ptr\x3a\x3a""difference_type type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __has_rebind\x0a"
"{\x0a"
"private\x3a\x0a"
"    struct __two {char __lx; char __lxx;};\x0a"
"    template <class _Xp> static __two __test(...);\x0a"
"    template <class _Xp> static char __test(typename _Xp\x3a\x3atemplate rebind<_Up>* = 0);\x0a"
"public\x3a\x0a"
"    static const bool value = sizeof(__test<_Tp>(0)) == 1;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up, bool = __has_rebind<_Tp, _Up>\x3a\x3avalue>\x0a"
"struct __pointer_traits_rebind\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Tp\x3a\x3atemplate rebind<_Up> type;\x0a"
"#else\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Tp\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template <template <class, class...> class _Sp, class _Tp, class ..._Args, class _Up>\x0a"
"struct __pointer_traits_rebind<_Sp<_Tp, _Args...>, _Up, true>\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Sp<_Tp, _Args...>\x3a\x3atemplate rebind<_Up> type;\x0a"
"#else\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Sp<_Tp, _Args...>\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <template <class, class...> class _Sp, class _Tp, class ..._Args, class _Up>\x0a"
"struct __pointer_traits_rebind<_Sp<_Tp, _Args...>, _Up, false>\x0a"
"{\x0a"
"    typedef _Sp<_Up, _Args...> type;\x0a"
"};\x0a"
"\x0a"
"#else  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template <template <class> class _Sp, class _Tp, class _Up>\x0a"
"struct __pointer_traits_rebind<_Sp<_Tp>, _Up, true>\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef typename _Sp<_Tp>\x3a\x3atemplate rebind<_Up> type;\x0a"
"#else\x0a"
"    typedef typename _Sp<_Tp>\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <template <class> class _Sp, class _Tp, class _Up>\x0a"
"struct __pointer_traits_rebind<_Sp<_Tp>, _Up, false>\x0a"
"{\x0a"
"    typedef _Sp<_Up> type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class> class _Sp, class _Tp, class _A0, class _Up>\x0a"
"struct __pointer_traits_rebind<_Sp<_Tp, _A0>, _Up, true>\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef typename _Sp<_Tp, _A0>\x3a\x3atemplate rebind<_Up> type;\x0a"
"#else\x0a"
"    typedef typename _Sp<_Tp, _A0>\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <template <class, class> class _Sp, class _Tp, class _A0, class _Up>\x0a"
"struct __pointer_traits_rebind<_Sp<_Tp, _A0>, _Up, false>\x0a"
"{\x0a"
"    typedef _Sp<_Up, _A0> type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class> class _Sp, class _Tp, class _A0,\x0a"
"                                         class _A1, class _Up>\x0a"
"struct __pointer_traits_rebind<_Sp<_Tp, _A0, _A1>, _Up, true>\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef typename _Sp<_Tp, _A0, _A1>\x3a\x3atemplate rebind<_Up> type;\x0a"
"#else\x0a"
"    typedef typename _Sp<_Tp, _A0, _A1>\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class> class _Sp, class _Tp, class _A0,\x0a"
"                                         class _A1, class _Up>\x0a"
"struct __pointer_traits_rebind<_Sp<_Tp, _A0, _A1>, _Up, false>\x0a"
"{\x0a"
"    typedef _Sp<_Up, _A0, _A1> type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class, class> class _Sp, class _Tp, class _A0,\x0a"
"                                                class _A1, class _A2, class _Up>\x0a"
"struct __pointer_traits_rebind<_Sp<_Tp, _A0, _A1, _A2>, _Up, true>\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef typename _Sp<_Tp, _A0, _A1, _A2>\x3a\x3atemplate rebind<_Up> type;\x0a"
"#else\x0a"
"    typedef typename _Sp<_Tp, _A0, _A1, _A2>\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class, class> class _Sp, class _Tp, class _A0,\x0a"
"                                                class _A1, class _A2, class _Up>\x0a"
"struct __pointer_traits_rebind<_Sp<_Tp, _A0, _A1, _A2>, _Up, false>\x0a"
"{\x0a"
"    typedef _Sp<_Up, _A0, _A1, _A2> type;\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template <class _Ptr>\x0a"
"struct _LIBCPP_TEMPLATE_VIS pointer_traits\x0a"
"{\x0a"
"    typedef _Ptr                                                     pointer;\x0a"
"    typedef typename __pointer_traits_element_type<pointer>\x3a\x3atype    element_type;\x0a"
"    typedef typename __pointer_traits_difference_type<pointer>\x3a\x3atype difference_type;\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Up> using rebind = typename __pointer_traits_rebind<pointer, _Up>\x3a\x3atype;\x0a"
"#else\x0a"
"    template <class _Up> struct rebind\x0a"
"        {typedef typename __pointer_traits_rebind<pointer, _Up>\x3a\x3atype other;};\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"private\x3a\x0a"
"    struct __nat {};\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static pointer pointer_to(typename conditional<is_void<element_type>\x3a\x3avalue,\x0a"
"                                           __nat, element_type>\x3a\x3atype\x26 __r)\x0a"
"        {return pointer\x3a\x3apointer_to(__r);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS pointer_traits<_Tp*>\x0a"
"{\x0a"
"    typedef _Tp*      pointer;\x0a"
"    typedef _Tp       element_type;\x0a"
"    typedef ptrdiff_t difference_type;\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Up> using rebind = _Up*;\x0a"
"#else\x0a"
"    template <class _Up> struct rebind {typedef _Up* other;};\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"    struct __nat {};\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"    static pointer pointer_to(typename conditional<is_void<element_type>\x3a\x3avalue,\x0a"
"                                      __nat, element_type>\x3a\x3atype\x26 __r) _NOEXCEPT\x0a"
"        {return _VSTD\x3a\x3a""addressof(__r);}\x0a"
"};\x0a"
"\x0a"
"template <class _From, class _To>\x0a"
"struct __rebind_pointer {\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef typename pointer_traits<_From>\x3a\x3atemplate rebind<_To>        type;\x0a"
"#else\x0a"
"    typedef typename pointer_traits<_From>\x3a\x3atemplate rebind<_To>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"// allocator_traits\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_pointer_type \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_pointer_type<_Tp,\x0a"
"          typename __void_t<typename _Tp\x3a\x3apointer>\x3a\x3atype> \x3a true_type {};\x0a"
"\x0a"
"namespace __pointer_type_imp\x0a"
"{\x0a"
"\x0a"
"template <class _Tp, class _Dp, bool = __has_pointer_type<_Dp>\x3a\x3avalue>\x0a"
"struct __pointer_type\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Dp\x3a\x3apointer type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Dp>\x0a"
"struct __pointer_type<_Tp, _Dp, false>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE _Tp* type;\x0a"
"};\x0a"
"\x0a"
"}  // __pointer_type_imp\x0a"
"\x0a"
"template <class _Tp, class _Dp>\x0a"
"struct __pointer_type\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename __pointer_type_imp\x3a\x3a__pointer_type<_Tp, typename remove_reference<_Dp>\x3a\x3atype>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_const_pointer \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_const_pointer<_Tp,\x0a"
"            typename __void_t<typename _Tp\x3a\x3a""const_pointer>\x3a\x3atype> \x3a true_type {};\x0a"
"\x0a"
"template <class _Tp, class _Ptr, class _Alloc, bool = __has_const_pointer<_Alloc>\x3a\x3avalue>\x0a"
"struct __const_pointer\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Alloc\x3a\x3a""const_pointer type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Ptr, class _Alloc>\x0a"
"struct __const_pointer<_Tp, _Ptr, _Alloc, false>\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename pointer_traits<_Ptr>\x3a\x3atemplate rebind<const _Tp> type;\x0a"
"#else\x0a"
"    typedef typename pointer_traits<_Ptr>\x3a\x3atemplate rebind<const _Tp>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_void_pointer \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_void_pointer<_Tp,\x0a"
"               typename __void_t<typename _Tp\x3a\x3avoid_pointer>\x3a\x3atype> \x3a true_type {};\x0a"
"\x0a"
"template <class _Ptr, class _Alloc, bool = __has_void_pointer<_Alloc>\x3a\x3avalue>\x0a"
"struct __void_pointer\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Alloc\x3a\x3avoid_pointer type;\x0a"
"};\x0a"
"\x0a"
"template <class _Ptr, class _Alloc>\x0a"
"struct __void_pointer<_Ptr, _Alloc, false>\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename pointer_traits<_Ptr>\x3a\x3atemplate rebind<void> type;\x0a"
"#else\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename pointer_traits<_Ptr>\x3a\x3atemplate rebind<void>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_const_void_pointer \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_const_void_pointer<_Tp,\x0a"
"            typename __void_t<typename _Tp\x3a\x3a""const_void_pointer>\x3a\x3atype> \x3a true_type {};\x0a"
"\x0a"
"template <class _Ptr, class _Alloc, bool = __has_const_void_pointer<_Alloc>\x3a\x3avalue>\x0a"
"struct __const_void_pointer\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Alloc\x3a\x3a""const_void_pointer type;\x0a"
"};\x0a"
"\x0a"
"template <class _Ptr, class _Alloc>\x0a"
"struct __const_void_pointer<_Ptr, _Alloc, false>\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename pointer_traits<_Ptr>\x3a\x3atemplate rebind<const void> type;\x0a"
"#else\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename pointer_traits<_Ptr>\x3a\x3atemplate rebind<const void>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"_Tp*\x0a"
"__to_raw_pointer(_Tp* __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __p;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 17\x0a"
"template <class _Pointer>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename pointer_traits<_Pointer>\x3a\x3a""element_type*\x0a"
"__to_raw_pointer(_Pointer __p) _NOEXCEPT\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__to_raw_pointer(__p.operator->());\x0a"
"}\x0a"
"#else\x0a"
"template <class _Pointer>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto\x0a"
"__to_raw_pointer(const _Pointer\x26 __p) _NOEXCEPT\x0a"
"-> decltype(pointer_traits<_Pointer>\x3a\x3ato_address(__p))\x0a"
"{\x0a"
"    return pointer_traits<_Pointer>\x3a\x3ato_address(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _Pointer, class... _None>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto\x0a"
"__to_raw_pointer(const _Pointer\x26 __p, _None...) _NOEXCEPT\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__to_raw_pointer(__p.operator->());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"_Tp*\x0a"
"to_address(_Tp* __p) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(\x21is_function_v<_Tp>, \x22_Tp is a function type\x22);\x0a"
"    return __p;\x0a"
"}\x0a"
"\x0a"
"template <class _Pointer>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto\x0a"
"to_address(const _Pointer\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a__to_raw_pointer(__p);\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_size_type \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_size_type<_Tp,\x0a"
"               typename __void_t<typename _Tp\x3a\x3asize_type>\x3a\x3atype> \x3a true_type {};\x0a"
"\x0a"
"template <class _Alloc, class _DiffType, bool = __has_size_type<_Alloc>\x3a\x3avalue>\x0a"
"struct __size_type\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename make_unsigned<_DiffType>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc, class _DiffType>\x0a"
"struct __size_type<_Alloc, _DiffType, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Alloc\x3a\x3asize_type type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_propagate_on_container_copy_assignment \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_propagate_on_container_copy_assignment<_Tp,\x0a"
"    typename __void_t<typename _Tp\x3a\x3apropagate_on_container_copy_assignment>\x3a\x3atype>\x0a"
"        \x3a true_type {};\x0a"
"\x0a"
"template <class _Alloc, bool = __has_propagate_on_container_copy_assignment<_Alloc>\x3a\x3avalue>\x0a"
"struct __propagate_on_container_copy_assignment\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE false_type type;\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct __propagate_on_container_copy_assignment<_Alloc, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Alloc\x3a\x3apropagate_on_container_copy_assignment type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_propagate_on_container_move_assignment \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_propagate_on_container_move_assignment<_Tp,\x0a"
"           typename __void_t<typename _Tp\x3a\x3apropagate_on_container_move_assignment>\x3a\x3atype>\x0a"
"               \x3a true_type {};\x0a"
"\x0a"
"template <class _Alloc, bool = __has_propagate_on_container_move_assignment<_Alloc>\x3a\x3avalue>\x0a"
"struct __propagate_on_container_move_assignment\x0a"
"{\x0a"
"    typedef false_type type;\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct __propagate_on_container_move_assignment<_Alloc, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Alloc\x3a\x3apropagate_on_container_move_assignment type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_propagate_on_container_swap \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_propagate_on_container_swap<_Tp,\x0a"
"           typename __void_t<typename _Tp\x3a\x3apropagate_on_container_swap>\x3a\x3atype>\x0a"
"               \x3a true_type {};\x0a"
"\x0a"
"template <class _Alloc, bool = __has_propagate_on_container_swap<_Alloc>\x3a\x3avalue>\x0a"
"struct __propagate_on_container_swap\x0a"
"{\x0a"
"    typedef false_type type;\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct __propagate_on_container_swap<_Alloc, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Alloc\x3a\x3apropagate_on_container_swap type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class = void>\x0a"
"struct __has_is_always_equal \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_is_always_equal<_Tp,\x0a"
"           typename __void_t<typename _Tp\x3a\x3ais_always_equal>\x3a\x3atype>\x0a"
"               \x3a true_type {};\x0a"
"\x0a"
"template <class _Alloc, bool = __has_is_always_equal<_Alloc>\x3a\x3avalue>\x0a"
"struct __is_always_equal\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _VSTD\x3a\x3ais_empty<_Alloc>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct __is_always_equal<_Alloc, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Alloc\x3a\x3ais_always_equal type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up, bool = __has_rebind<_Tp, _Up>\x3a\x3avalue>\x0a"
"struct __has_rebind_other\x0a"
"{\x0a"
"private\x3a\x0a"
"    struct __two {char __lx; char __lxx;};\x0a"
"    template <class _Xp> static __two __test(...);\x0a"
"    template <class _Xp> static char __test(typename _Xp\x3a\x3atemplate rebind<_Up>\x3a\x3aother* = 0);\x0a"
"public\x3a\x0a"
"    static const bool value = sizeof(__test<_Tp>(0)) == 1;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __has_rebind_other<_Tp, _Up, false>\x0a"
"{\x0a"
"    static const bool value = false;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up, bool = __has_rebind_other<_Tp, _Up>\x3a\x3avalue>\x0a"
"struct __allocator_traits_rebind\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Tp\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template <template <class, class...> class _Alloc, class _Tp, class ..._Args, class _Up>\x0a"
"struct __allocator_traits_rebind<_Alloc<_Tp, _Args...>, _Up, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Alloc<_Tp, _Args...>\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class...> class _Alloc, class _Tp, class ..._Args, class _Up>\x0a"
"struct __allocator_traits_rebind<_Alloc<_Tp, _Args...>, _Up, false>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE _Alloc<_Up, _Args...> type;\x0a"
"};\x0a"
"\x0a"
"#else  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template <template <class> class _Alloc, class _Tp, class _Up>\x0a"
"struct __allocator_traits_rebind<_Alloc<_Tp>, _Up, true>\x0a"
"{\x0a"
"    typedef typename _Alloc<_Tp>\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"};\x0a"
"\x0a"
"template <template <class> class _Alloc, class _Tp, class _Up>\x0a"
"struct __allocator_traits_rebind<_Alloc<_Tp>, _Up, false>\x0a"
"{\x0a"
"    typedef _Alloc<_Up> type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class> class _Alloc, class _Tp, class _A0, class _Up>\x0a"
"struct __allocator_traits_rebind<_Alloc<_Tp, _A0>, _Up, true>\x0a"
"{\x0a"
"    typedef typename _Alloc<_Tp, _A0>\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class> class _Alloc, class _Tp, class _A0, class _Up>\x0a"
"struct __allocator_traits_rebind<_Alloc<_Tp, _A0>, _Up, false>\x0a"
"{\x0a"
"    typedef _Alloc<_Up, _A0> type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class> class _Alloc, class _Tp, class _A0,\x0a"
"                                         class _A1, class _Up>\x0a"
"struct __allocator_traits_rebind<_Alloc<_Tp, _A0, _A1>, _Up, true>\x0a"
"{\x0a"
"    typedef typename _Alloc<_Tp, _A0, _A1>\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class> class _Alloc, class _Tp, class _A0,\x0a"
"                                         class _A1, class _Up>\x0a"
"struct __allocator_traits_rebind<_Alloc<_Tp, _A0, _A1>, _Up, false>\x0a"
"{\x0a"
"    typedef _Alloc<_Up, _A0, _A1> type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class, class> class _Alloc, class _Tp, class _A0,\x0a"
"                                                class _A1, class _A2, class _Up>\x0a"
"struct __allocator_traits_rebind<_Alloc<_Tp, _A0, _A1, _A2>, _Up, true>\x0a"
"{\x0a"
"    typedef typename _Alloc<_Tp, _A0, _A1, _A2>\x3a\x3atemplate rebind<_Up>\x3a\x3aother type;\x0a"
"};\x0a"
"\x0a"
"template <template <class, class, class, class> class _Alloc, class _Tp, class _A0,\x0a"
"                                                class _A1, class _A2, class _Up>\x0a"
"struct __allocator_traits_rebind<_Alloc<_Tp, _A0, _A1, _A2>, _Up, false>\x0a"
"{\x0a"
"    typedef _Alloc<_Up, _A0, _A1, _A2> type;\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Alloc, class _SizeType, class _ConstVoidPtr>\x0a"
"auto\x0a"
"__has_allocate_hint_test(_Alloc\x26\x26 __a, _SizeType\x26\x26 __sz, _ConstVoidPtr\x26\x26 __p)\x0a"
"    -> decltype((void)__a.allocate(__sz, __p), true_type());\x0a"
"\x0a"
"template <class _Alloc, class _SizeType, class _ConstVoidPtr>\x0a"
"auto\x0a"
"__has_allocate_hint_test(const _Alloc\x26 __a, _SizeType\x26\x26 __sz, _ConstVoidPtr\x26\x26 __p)\x0a"
"    -> false_type;\x0a"
"\x0a"
"template <class _Alloc, class _SizeType, class _ConstVoidPtr>\x0a"
"struct __has_allocate_hint\x0a"
"    \x3a integral_constant<bool,\x0a"
"        is_same<\x0a"
"            decltype(_VSTD\x3a\x3a__has_allocate_hint_test(declval<_Alloc>(),\x0a"
"                                          declval<_SizeType>(),\x0a"
"                                          declval<_ConstVoidPtr>())),\x0a"
"            true_type>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Alloc, class _SizeType, class _ConstVoidPtr>\x0a"
"struct __has_allocate_hint\x0a"
"    \x3a true_type\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"\x0a"
"template <class _Alloc, class _Tp, class ..._Args>\x0a"
"decltype(_VSTD\x3a\x3a""declval<_Alloc>().construct(_VSTD\x3a\x3a""declval<_Tp*>(),\x0a"
"                                           _VSTD\x3a\x3a""declval<_Args>()...),\x0a"
"                                           true_type())\x0a"
"__has_construct_test(_Alloc\x26\x26 __a, _Tp* __p, _Args\x26\x26 ...__args);\x0a"
"\x0a"
"template <class _Alloc, class _Pointer, class ..._Args>\x0a"
"false_type\x0a"
"__has_construct_test(const _Alloc\x26 __a, _Pointer\x26\x26 __p, _Args\x26\x26 ...__args);\x0a"
"\x0a"
"template <class _Alloc, class _Pointer, class ..._Args>\x0a"
"struct __has_construct\x0a"
"    \x3a integral_constant<bool,\x0a"
"        is_same<\x0a"
"            decltype(_VSTD\x3a\x3a__has_construct_test(declval<_Alloc>(),\x0a"
"                                          declval<_Pointer>(),\x0a"
"                                          declval<_Args>()...)),\x0a"
"            true_type>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc, class _Pointer>\x0a"
"auto\x0a"
"__has_destroy_test(_Alloc\x26\x26 __a, _Pointer\x26\x26 __p)\x0a"
"    -> decltype(__a.destroy(__p), true_type());\x0a"
"\x0a"
"template <class _Alloc, class _Pointer>\x0a"
"auto\x0a"
"__has_destroy_test(const _Alloc\x26 __a, _Pointer\x26\x26 __p)\x0a"
"    -> false_type;\x0a"
"\x0a"
"template <class _Alloc, class _Pointer>\x0a"
"struct __has_destroy\x0a"
"    \x3a integral_constant<bool,\x0a"
"        is_same<\x0a"
"            decltype(_VSTD\x3a\x3a__has_destroy_test(declval<_Alloc>(),\x0a"
"                                        declval<_Pointer>())),\x0a"
"            true_type>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"auto\x0a"
"__has_max_size_test(_Alloc\x26\x26 __a)\x0a"
"    -> decltype(__a.max_size(), true_type());\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"auto\x0a"
"__has_max_size_test(const volatile _Alloc\x26 __a)\x0a"
"    -> false_type;\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct __has_max_size\x0a"
"    \x3a integral_constant<bool,\x0a"
"        is_same<\x0a"
"            decltype(_VSTD\x3a\x3a__has_max_size_test(declval<_Alloc\x26>())),\x0a"
"            true_type>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"auto\x0a"
"__has_select_on_container_copy_construction_test(_Alloc\x26\x26 __a)\x0a"
"    -> decltype(__a.select_on_container_copy_construction(), true_type());\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"auto\x0a"
"__has_select_on_container_copy_construction_test(const volatile _Alloc\x26 __a)\x0a"
"    -> false_type;\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct __has_select_on_container_copy_construction\x0a"
"    \x3a integral_constant<bool,\x0a"
"        is_same<\x0a"
"            decltype(_VSTD\x3a\x3a__has_select_on_container_copy_construction_test(declval<_Alloc\x26>())),\x0a"
"            true_type>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Alloc, class _Pointer, class _Tp, class = void>\x0a"
"struct __has_construct \x3a std\x3a\x3a""false_type {};\x0a"
"\x0a"
"template <class _Alloc, class _Pointer, class _Tp>\x0a"
"struct __has_construct<_Alloc, _Pointer, _Tp, typename __void_t<\x0a"
"    decltype(_VSTD\x3a\x3a""declval<_Alloc>().construct(_VSTD\x3a\x3a""declval<_Pointer>(), _VSTD\x3a\x3a""declval<_Tp>()))\x0a"
">\x3a\x3atype> \x3a std\x3a\x3atrue_type {};\x0a"
"\x0a"
"template <class _Alloc, class _Pointer, class = void>\x0a"
"struct __has_destroy \x3a false_type {};\x0a"
"\x0a"
"template <class _Alloc, class _Pointer>\x0a"
"struct __has_destroy<_Alloc, _Pointer, typename __void_t<\x0a"
"    decltype(_VSTD\x3a\x3a""declval<_Alloc>().destroy(_VSTD\x3a\x3a""declval<_Pointer>()))\x0a"
">\x3a\x3atype> \x3a std\x3a\x3atrue_type {};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct __has_max_size\x0a"
"    \x3a true_type\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct __has_select_on_container_copy_construction\x0a"
"    \x3a false_type\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Alloc, class _Ptr, bool = __has_difference_type<_Alloc>\x3a\x3avalue>\x0a"
"struct __alloc_traits_difference_type\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename pointer_traits<_Ptr>\x3a\x3a""difference_type type;\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc, class _Ptr>\x0a"
"struct __alloc_traits_difference_type<_Alloc, _Ptr, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Alloc\x3a\x3a""difference_type type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_default_allocator \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_default_allocator<_VSTD\x3a\x3a""allocator<_Tp> > \x3a true_type {};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"struct _LIBCPP_TEMPLATE_VIS allocator_traits\x0a"
"{\x0a"
"    typedef _Alloc                              allocator_type;\x0a"
"    typedef typename allocator_type\x3a\x3avalue_type value_type;\x0a"
"\x0a"
"    typedef typename __pointer_type<value_type, allocator_type>\x3a\x3atype pointer;\x0a"
"    typedef typename __const_pointer<value_type, pointer, allocator_type>\x3a\x3atype const_pointer;\x0a"
"    typedef typename __void_pointer<pointer, allocator_type>\x3a\x3atype void_pointer;\x0a"
"    typedef typename __const_void_pointer<pointer, allocator_type>\x3a\x3atype const_void_pointer;\x0a"
"\x0a"
"    typedef typename __alloc_traits_difference_type<allocator_type, pointer>\x3a\x3atype difference_type;\x0a"
"    typedef typename __size_type<allocator_type, difference_type>\x3a\x3atype size_type;\x0a"
"\x0a"
"    typedef typename __propagate_on_container_copy_assignment<allocator_type>\x3a\x3atype\x0a"
"                     propagate_on_container_copy_assignment;\x0a"
"    typedef typename __propagate_on_container_move_assignment<allocator_type>\x3a\x3atype\x0a"
"                     propagate_on_container_move_assignment;\x0a"
"    typedef typename __propagate_on_container_swap<allocator_type>\x3a\x3atype\x0a"
"                     propagate_on_container_swap;\x0a"
"    typedef typename __is_always_equal<allocator_type>\x3a\x3atype\x0a"
"                     is_always_equal;\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Tp> using rebind_alloc =\x0a"
"                  typename __allocator_traits_rebind<allocator_type, _Tp>\x3a\x3atype;\x0a"
"    template <class _Tp> using rebind_traits = allocator_traits<rebind_alloc<_Tp> >;\x0a"
"#else  // _LIBCPP_CXX03_LANG\x0a"
"    template <class _Tp> struct rebind_alloc\x0a"
"        {typedef typename __allocator_traits_rebind<allocator_type, _Tp>\x3a\x3atype other;};\x0a"
"    template <class _Tp> struct rebind_traits\x0a"
"        {typedef allocator_traits<typename rebind_alloc<_Tp>\x3a\x3aother> other;};\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    static pointer allocate(allocator_type\x26 __a, size_type __n)\x0a"
"        {return __a.allocate(__n);}\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    static pointer allocate(allocator_type\x26 __a, size_type __n, const_void_pointer __hint)\x0a"
"        {return __allocate(__a, __n, __hint,\x0a"
"            __has_allocate_hint<allocator_type, size_type, const_void_pointer>());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static void deallocate(allocator_type\x26 __a, pointer __p, size_type __n) _NOEXCEPT\x0a"
"        {__a.deallocate(__p, __n);}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"    template <class _Tp, class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void construct(allocator_type\x26 __a, _Tp* __p, _Args\x26\x26... __args)\x0a"
"            {__construct(__has_construct<allocator_type, _Tp*, _Args...>(),\x0a"
"                         __a, __p, _VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"#else  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"    template <class _Tp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void construct(allocator_type\x26, _Tp* __p)\x0a"
"            {\x0a"
"                \x3a\x3anew ((void*)__p) _Tp();\x0a"
"            }\x0a"
"    template <class _Tp, class _A0>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void construct(allocator_type\x26 __a, _Tp* __p, const _A0\x26 __a0)\x0a"
"            {\x0a"
"                __construct(__has_construct<allocator_type, _Tp*, const _A0\x26>(),\x0a"
"                            __a, __p, __a0);\x0a"
"            }\x0a"
"    template <class _Tp, class _A0, class _A1>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void construct(allocator_type\x26, _Tp* __p, const _A0\x26 __a0,\x0a"
"                              const _A1\x26 __a1)\x0a"
"            {\x0a"
"                \x3a\x3anew ((void*)__p) _Tp(__a0, __a1);\x0a"
"            }\x0a"
"    template <class _Tp, class _A0, class _A1, class _A2>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void construct(allocator_type\x26, _Tp* __p, const _A0\x26 __a0,\x0a"
"                              const _A1\x26 __a1, const _A2\x26 __a2)\x0a"
"            {\x0a"
"                \x3a\x3anew ((void*)__p) _Tp(__a0, __a1, __a2);\x0a"
"            }\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void destroy(allocator_type\x26 __a, _Tp* __p)\x0a"
"            {__destroy(__has_destroy<allocator_type, _Tp*>(), __a, __p);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static size_type max_size(const allocator_type\x26 __a) _NOEXCEPT\x0a"
"        {return __max_size(__has_max_size<const allocator_type>(), __a);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static allocator_type\x0a"
"        select_on_container_copy_construction(const allocator_type\x26 __a)\x0a"
"            {return __select_on_container_copy_construction(\x0a"
"                __has_select_on_container_copy_construction<const allocator_type>(),\x0a"
"                __a);}\x0a"
"\x0a"
"    template <class _Ptr>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        void\x0a"
"        __construct_forward(allocator_type\x26 __a, _Ptr __begin1, _Ptr __end1, _Ptr\x26 __begin2)\x0a"
"        {\x0a"
"            for (; __begin1 \x21= __end1; ++__begin1, (void) ++__begin2)\x0a"
"                construct(__a, _VSTD\x3a\x3a__to_raw_pointer(__begin2), _VSTD\x3a\x3amove_if_noexcept(*__begin1));\x0a"
"        }\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            (__is_default_allocator<allocator_type>\x3a\x3avalue\x0a"
"                \x7c\x7c \x21__has_construct<allocator_type, _Tp*, _Tp>\x3a\x3avalue) \x26\x26\x0a"
"             is_trivially_move_constructible<_Tp>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        __construct_forward(allocator_type\x26, _Tp* __begin1, _Tp* __end1, _Tp*\x26 __begin2)\x0a"
"        {\x0a"
"            ptrdiff_t _Np = __end1 - __begin1;\x0a"
"            if (_Np > 0)\x0a"
"            {\x0a"
"                _VSTD\x3a\x3amemcpy(__begin2, __begin1, _Np * sizeof(_Tp));\x0a"
"                __begin2 += _Np;\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"    template <class _Iter, class _Ptr>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        void\x0a"
"        __construct_range_forward(allocator_type\x26 __a, _Iter __begin1, _Iter __end1, _Ptr\x26 __begin2)\x0a"
"        {\x0a"
"            for (; __begin1 \x21= __end1; ++__begin1, (void) ++__begin2)\x0a"
"                construct(__a, _VSTD\x3a\x3a__to_raw_pointer(__begin2), *__begin1);\x0a"
"        }\x0a"
"\x0a"
"    template <class _SourceTp, class _DestTp,\x0a"
"              class _RawSourceTp = typename remove_const<_SourceTp>\x3a\x3atype,\x0a"
"              class _RawDestTp = typename remove_const<_DestTp>\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_trivially_move_constructible<_DestTp>\x3a\x3avalue \x26\x26\x0a"
"            is_same<_RawSourceTp, _RawDestTp>\x3a\x3avalue \x26\x26\x0a"
"            (__is_default_allocator<allocator_type>\x3a\x3avalue \x7c\x7c\x0a"
"             \x21__has_construct<allocator_type, _DestTp*, _SourceTp\x26>\x3a\x3avalue),\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        __construct_range_forward(allocator_type\x26, _SourceTp* __begin1, _SourceTp* __end1, _DestTp*\x26 __begin2)\x0a"
"        {\x0a"
"            ptrdiff_t _Np = __end1 - __begin1;\x0a"
"            if (_Np > 0)\x0a"
"            {\x0a"
"                _VSTD\x3a\x3amemcpy(const_cast<_RawDestTp*>(__begin2), __begin1, _Np * sizeof(_DestTp));\x0a"
"                __begin2 += _Np;\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"    template <class _Ptr>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        void\x0a"
"        __construct_backward(allocator_type\x26 __a, _Ptr __begin1, _Ptr __end1, _Ptr\x26 __end2)\x0a"
"        {\x0a"
"            while (__end1 \x21= __begin1)\x0a"
"            {\x0a"
"                construct(__a, _VSTD\x3a\x3a__to_raw_pointer(__end2-1), _VSTD\x3a\x3amove_if_noexcept(*--__end1));\x0a"
"                --__end2;\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            (__is_default_allocator<allocator_type>\x3a\x3avalue\x0a"
"                \x7c\x7c \x21__has_construct<allocator_type, _Tp*, _Tp>\x3a\x3avalue) \x26\x26\x0a"
"             is_trivially_move_constructible<_Tp>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        __construct_backward(allocator_type\x26, _Tp* __begin1, _Tp* __end1, _Tp*\x26 __end2)\x0a"
"        {\x0a"
"            ptrdiff_t _Np = __end1 - __begin1;\x0a"
"            __end2 -= _Np;\x0a"
"            if (_Np > 0)\x0a"
"                _VSTD\x3a\x3amemcpy(__end2, __begin1, _Np * sizeof(_Tp));\x0a"
"        }\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static pointer __allocate(allocator_type\x26 __a, size_type __n,\x0a"
"        const_void_pointer __hint, true_type)\x0a"
"        {return __a.allocate(__n, __hint);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static pointer __allocate(allocator_type\x26 __a, size_type __n,\x0a"
"        const_void_pointer, false_type)\x0a"
"        {return __a.allocate(__n);}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"    template <class _Tp, class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void __construct(true_type, allocator_type\x26 __a, _Tp* __p, _Args\x26\x26... __args)\x0a"
"            {__a.construct(__p, _VSTD\x3a\x3a""forward<_Args>(__args)...);}\x0a"
"    template <class _Tp, class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void __construct(false_type, allocator_type\x26, _Tp* __p, _Args\x26\x26... __args)\x0a"
"            {\x0a"
"                \x3a\x3anew ((void*)__p) _Tp(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"            }\x0a"
"#else  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"    template <class _Tp, class _A0>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void __construct(true_type, allocator_type\x26 __a, _Tp* __p,\x0a"
"                                const _A0\x26 __a0)\x0a"
"            {__a.construct(__p, __a0);}\x0a"
"    template <class _Tp, class _A0>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void __construct(false_type, allocator_type\x26, _Tp* __p,\x0a"
"                                const _A0\x26 __a0)\x0a"
"            {\x0a"
"                \x3a\x3anew ((void*)__p) _Tp(__a0);\x0a"
"            }\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void __destroy(true_type, allocator_type\x26 __a, _Tp* __p)\x0a"
"            {__a.destroy(__p);}\x0a"
"    template <class _Tp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static void __destroy(false_type, allocator_type\x26, _Tp* __p)\x0a"
"            {\x0a"
"                __p->\x7e_Tp();\x0a"
"            }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static size_type __max_size(true_type, const allocator_type\x26 __a) _NOEXCEPT\x0a"
"            {return __a.max_size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static size_type __max_size(false_type, const allocator_type\x26) _NOEXCEPT\x0a"
"            {return numeric_limits<size_type>\x3a\x3amax() / sizeof(value_type);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static allocator_type\x0a"
"        __select_on_container_copy_construction(true_type, const allocator_type\x26 __a)\x0a"
"            {return __a.select_on_container_copy_construction();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static allocator_type\x0a"
"        __select_on_container_copy_construction(false_type, const allocator_type\x26 __a)\x0a"
"            {return __a;}\x0a"
"};\x0a"
"\x0a"
"template <class _Traits, class _Tp>\x0a"
"struct __rebind_alloc_helper\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename _Traits\x3a\x3atemplate rebind_alloc<_Tp>        type;\x0a"
"#else\x0a"
"    typedef typename _Traits\x3a\x3atemplate rebind_alloc<_Tp>\x3a\x3aother type;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"// allocator\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS allocator\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef size_t            size_type;\x0a"
"    typedef ptrdiff_t         difference_type;\x0a"
"    typedef _Tp*              pointer;\x0a"
"    typedef const _Tp*        const_pointer;\x0a"
"    typedef _Tp\x26              reference;\x0a"
"    typedef const _Tp\x26        const_reference;\x0a"
"    typedef _Tp               value_type;\x0a"
"\x0a"
"    typedef true_type propagate_on_container_move_assignment;\x0a"
"    typedef true_type is_always_equal;\x0a"
"\x0a"
"    template <class _Up> struct rebind {typedef allocator<_Up> other;};\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"    allocator() _NOEXCEPT {}\x0a"
"\x0a"
"    template <class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"    allocator(const allocator<_Up>\x26) _NOEXCEPT {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY pointer address(reference __x) const _NOEXCEPT\x0a"
"        {return _VSTD\x3a\x3a""addressof(__x);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_pointer address(const_reference __x) const _NOEXCEPT\x0a"
"        {return _VSTD\x3a\x3a""addressof(__x);}\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer allocate(size_type __n, allocator<void>\x3a\x3a""const_pointer = 0)\x0a"
"        {\x0a"
"        if (__n > max_size())\x0a"
"            __throw_length_error(\x22""allocator<T>\x3a\x3a""allocate(size_t n)\x22\x0a"
"                                 \x22 'n' exceeds maximum supported size\x22);\x0a"
"        return static_cast<pointer>(_VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(_Tp), _LIBCPP_ALIGNOF(_Tp)));\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY void deallocate(pointer __p, size_type __n) _NOEXCEPT\x0a"
"        {_VSTD\x3a\x3a__libcpp_deallocate((void*)__p, __n * sizeof(_Tp), _LIBCPP_ALIGNOF(_Tp));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_type max_size() const _NOEXCEPT\x0a"
"        {return size_type(\x7e""0) / sizeof(_Tp);}\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_RVALUE_REFERENCES) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIADICS)\x0a"
"    template <class _Up, class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(_Up* __p, _Args\x26\x26... __args)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*)__p) _Up(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        }\x0a"
"#else  // \x21""defined(_LIBCPP_HAS_NO_RVALUE_REFERENCES) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIADICS)\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*)__p) _Tp();\x0a"
"        }\x0a"
"# if defined(_LIBCPP_HAS_NO_RVALUE_REFERENCES)\x0a"
"\x0a"
"    template <class _A0>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, _A0\x26 __a0)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*)__p) _Tp(__a0);\x0a"
"        }\x0a"
"    template <class _A0>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, const _A0\x26 __a0)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*)__p) _Tp(__a0);\x0a"
"        }\x0a"
"# endif  // defined(_LIBCPP_HAS_NO_RVALUE_REFERENCES)\x0a"
"    template <class _A0, class _A1>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, _A0\x26 __a0, _A1\x26 __a1)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*)__p) _Tp(__a0, __a1);\x0a"
"        }\x0a"
"    template <class _A0, class _A1>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, const _A0\x26 __a0, _A1\x26 __a1)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*)__p) _Tp(__a0, __a1);\x0a"
"        }\x0a"
"    template <class _A0, class _A1>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, _A0\x26 __a0, const _A1\x26 __a1)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*)__p) _Tp(__a0, __a1);\x0a"
"        }\x0a"
"    template <class _A0, class _A1>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, const _A0\x26 __a0, const _A1\x26 __a1)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*)__p) _Tp(__a0, __a1);\x0a"
"        }\x0a"
"#endif  // \x21""defined(_LIBCPP_HAS_NO_RVALUE_REFERENCES) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIADICS)\x0a"
"    _LIBCPP_INLINE_VISIBILITY void destroy(pointer __p) {__p->\x7e_Tp();}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS allocator<const _Tp>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef size_t            size_type;\x0a"
"    typedef ptrdiff_t         difference_type;\x0a"
"    typedef const _Tp*        pointer;\x0a"
"    typedef const _Tp*        const_pointer;\x0a"
"    typedef const _Tp\x26        reference;\x0a"
"    typedef const _Tp\x26        const_reference;\x0a"
"    typedef const _Tp         value_type;\x0a"
"\x0a"
"    typedef true_type propagate_on_container_move_assignment;\x0a"
"    typedef true_type is_always_equal;\x0a"
"\x0a"
"    template <class _Up> struct rebind {typedef allocator<_Up> other;};\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"    allocator() _NOEXCEPT {}\x0a"
"\x0a"
"    template <class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"    allocator(const allocator<_Up>\x26) _NOEXCEPT {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_pointer address(const_reference __x) const _NOEXCEPT\x0a"
"        {return _VSTD\x3a\x3a""addressof(__x);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY pointer allocate(size_type __n, allocator<void>\x3a\x3a""const_pointer = 0)\x0a"
"    {\x0a"
"        if (__n > max_size())\x0a"
"            __throw_length_error(\x22""allocator<const T>\x3a\x3a""allocate(size_t n)\x22\x0a"
"                                 \x22 'n' exceeds maximum supported size\x22);\x0a"
"        return static_cast<pointer>(_VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(_Tp), _LIBCPP_ALIGNOF(_Tp)));\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY void deallocate(pointer __p, size_type __n) _NOEXCEPT\x0a"
"        {_VSTD\x3a\x3a__libcpp_deallocate((void*) const_cast<_Tp *>(__p), __n * sizeof(_Tp), _LIBCPP_ALIGNOF(_Tp));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_type max_size() const _NOEXCEPT\x0a"
"        {return size_type(\x7e""0) / sizeof(_Tp);}\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_RVALUE_REFERENCES) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIADICS)\x0a"
"    template <class _Up, class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(_Up* __p, _Args\x26\x26... __args)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*)__p) _Up(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        }\x0a"
"#else  // \x21""defined(_LIBCPP_HAS_NO_RVALUE_REFERENCES) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIADICS)\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*) const_cast<_Tp *>(__p)) _Tp();\x0a"
"        }\x0a"
"# if defined(_LIBCPP_HAS_NO_RVALUE_REFERENCES)\x0a"
"\x0a"
"    template <class _A0>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, _A0\x26 __a0)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*) const_cast<_Tp *>(__p)) _Tp(__a0);\x0a"
"        }\x0a"
"    template <class _A0>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, const _A0\x26 __a0)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*) const_cast<_Tp *>(__p)) _Tp(__a0);\x0a"
"        }\x0a"
"# endif  // defined(_LIBCPP_HAS_NO_RVALUE_REFERENCES)\x0a"
"    template <class _A0, class _A1>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, _A0\x26 __a0, _A1\x26 __a1)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*) const_cast<_Tp *>(__p)) _Tp(__a0, __a1);\x0a"
"        }\x0a"
"    template <class _A0, class _A1>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, const _A0\x26 __a0, _A1\x26 __a1)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*) const_cast<_Tp *>(__p)) _Tp(__a0, __a1);\x0a"
"        }\x0a"
"    template <class _A0, class _A1>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, _A0\x26 __a0, const _A1\x26 __a1)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*) const_cast<_Tp *>(__p)) _Tp(__a0, __a1);\x0a"
"        }\x0a"
"    template <class _A0, class _A1>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void\x0a"
"        construct(pointer __p, const _A0\x26 __a0, const _A1\x26 __a1)\x0a"
"        {\x0a"
"            \x3a\x3anew((void*) const_cast<_Tp *>(__p)) _Tp(__a0, __a1);\x0a"
"        }\x0a"
"#endif  // \x21""defined(_LIBCPP_HAS_NO_RVALUE_REFERENCES) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIADICS)\x0a"
"    _LIBCPP_INLINE_VISIBILITY void destroy(pointer __p) {__p->\x7e_Tp();}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator==(const allocator<_Tp>\x26, const allocator<_Up>\x26) _NOEXCEPT {return true;}\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(const allocator<_Tp>\x26, const allocator<_Up>\x26) _NOEXCEPT {return false;}\x0a"
"\x0a"
"template <class _OutputIterator, class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS raw_storage_iterator\x0a"
"    \x3a public iterator<output_iterator_tag,\x0a"
"                      _Tp,                                         // purposefully not C++03\x0a"
"                      ptrdiff_t,                                   // purposefully not C++03\x0a"
"                      _Tp*,                                        // purposefully not C++03\x0a"
"                      raw_storage_iterator<_OutputIterator, _Tp>\x26> // purposefully not C++03\x0a"
"{\x0a"
"private\x3a\x0a"
"    _OutputIterator __x_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit raw_storage_iterator(_OutputIterator __x) \x3a __x_(__x) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY raw_storage_iterator\x26 operator*() {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY raw_storage_iterator\x26 operator=(const _Tp\x26 __element)\x0a"
"        {\x3a\x3anew(_VSTD\x3a\x3a""addressof(*__x_)) _Tp(__element); return *this;}\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY raw_storage_iterator\x26 operator=(_Tp\x26\x26 __element)\x0a"
"        {\x3a\x3anew(_VSTD\x3a\x3a""addressof(*__x_)) _Tp(_VSTD\x3a\x3amove(__element)); return *this;}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY raw_storage_iterator\x26 operator++() {++__x_; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY raw_storage_iterator  operator++(int)\x0a"
"        {raw_storage_iterator __t(*this); ++__x_; return __t;}\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY _OutputIterator base() const { return __x_; }\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_NODISCARD_EXT _LIBCPP_NO_CFI\x0a"
"pair<_Tp*, ptrdiff_t>\x0a"
"get_temporary_buffer(ptrdiff_t __n) _NOEXCEPT\x0a"
"{\x0a"
"    pair<_Tp*, ptrdiff_t> __r(0, 0);\x0a"
"    const ptrdiff_t __m = (\x7eptrdiff_t(0) ^\x0a"
"                           ptrdiff_t(ptrdiff_t(1) << (sizeof(ptrdiff_t) * __CHAR_BIT__ - 1)))\x0a"
"                           / sizeof(_Tp);\x0a"
"    if (__n > __m)\x0a"
"        __n = __m;\x0a"
"    while (__n > 0)\x0a"
"    {\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_ALIGNED_ALLOCATION)\x0a"
"    if (__is_overaligned_for_new(_LIBCPP_ALIGNOF(_Tp)))\x0a"
"        {\x0a"
"            std\x3a\x3a""align_val_t __al =\x0a"
"                std\x3a\x3a""align_val_t(std\x3a\x3a""alignment_of<_Tp>\x3a\x3avalue);\x0a"
"            __r.first = static_cast<_Tp*>(\x3a\x3aoperator new(\x0a"
"                __n * sizeof(_Tp), __al, nothrow));\x0a"
"        } else {\x0a"
"            __r.first = static_cast<_Tp*>(\x3a\x3aoperator new(\x0a"
"                __n * sizeof(_Tp), nothrow));\x0a"
"        }\x0a"
"#else\x0a"
"    if (__is_overaligned_for_new(_LIBCPP_ALIGNOF(_Tp)))\x0a"
"        {\x0a"
"            // Since aligned operator new is unavailable, return an empty\x0a"
"            // buffer rather than one with invalid alignment.\x0a"
"            return __r;\x0a"
"        }\x0a"
"\x0a"
"        __r.first = static_cast<_Tp*>(\x3a\x3aoperator new(__n * sizeof(_Tp), nothrow));\x0a"
"#endif\x0a"
"\x0a"
"        if (__r.first)\x0a"
"        {\x0a"
"            __r.second = __n;\x0a"
"            break;\x0a"
"        }\x0a"
"        __n /= 2;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void return_temporary_buffer(_Tp* __p) _NOEXCEPT\x0a"
"{\x0a"
"  _VSTD\x3a\x3a__libcpp_deallocate_unsized((void*)__p, _LIBCPP_ALIGNOF(_Tp));\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR)\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_DEPRECATED_IN_CXX11 auto_ptr_ref\x0a"
"{\x0a"
"    _Tp* __ptr_;\x0a"
"};\x0a"
"\x0a"
"template<class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 auto_ptr\x0a"
"{\x0a"
"private\x3a\x0a"
"    _Tp* __ptr_;\x0a"
"public\x3a\x0a"
"    typedef _Tp element_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit auto_ptr(_Tp* __p = 0) throw() \x3a __ptr_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY auto_ptr(auto_ptr\x26 __p) throw() \x3a __ptr_(__p.release()) {}\x0a"
"    template<class _Up> _LIBCPP_INLINE_VISIBILITY auto_ptr(auto_ptr<_Up>\x26 __p) throw()\x0a"
"        \x3a __ptr_(__p.release()) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY auto_ptr\x26 operator=(auto_ptr\x26 __p) throw()\x0a"
"        {reset(__p.release()); return *this;}\x0a"
"    template<class _Up> _LIBCPP_INLINE_VISIBILITY auto_ptr\x26 operator=(auto_ptr<_Up>\x26 __p) throw()\x0a"
"        {reset(__p.release()); return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY auto_ptr\x26 operator=(auto_ptr_ref<_Tp> __p) throw()\x0a"
"        {reset(__p.__ptr_); return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY \x7e""auto_ptr() throw() {delete __ptr_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Tp\x26 operator*() const throw()\x0a"
"        {return *__ptr_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Tp* operator->() const throw() {return __ptr_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Tp* get() const throw() {return __ptr_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY _Tp* release() throw()\x0a"
"    {\x0a"
"        _Tp* __t = __ptr_;\x0a"
"        __ptr_ = 0;\x0a"
"        return __t;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY void reset(_Tp* __p = 0) throw()\x0a"
"    {\x0a"
"        if (__ptr_ \x21= __p)\x0a"
"            delete __ptr_;\x0a"
"        __ptr_ = __p;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY auto_ptr(auto_ptr_ref<_Tp> __p) throw() \x3a __ptr_(__p.__ptr_) {}\x0a"
"    template<class _Up> _LIBCPP_INLINE_VISIBILITY operator auto_ptr_ref<_Up>() throw()\x0a"
"        {auto_ptr_ref<_Up> __t; __t.__ptr_ = release(); return __t;}\x0a"
"    template<class _Up> _LIBCPP_INLINE_VISIBILITY operator auto_ptr<_Up>() throw()\x0a"
"        {return auto_ptr<_Up>(release());}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"class _LIBCPP_TEMPLATE_VIS _LIBCPP_DEPRECATED_IN_CXX11 auto_ptr<void>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef void element_type;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, int _Idx,\x0a"
"          bool _CanBeEmptyBase =\x0a"
"              is_empty<_Tp>\x3a\x3avalue \x26\x26 \x21__libcpp_is_final<_Tp>\x3a\x3avalue>\x0a"
"struct __compressed_pair_elem {\x0a"
"  typedef _Tp _ParamT;\x0a"
"  typedef _Tp\x26 reference;\x0a"
"  typedef const _Tp\x26 const_reference;\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"  _LIBCPP_INLINE_VISIBILITY constexpr __compressed_pair_elem() \x3a __value_() {}\x0a"
"\x0a"
"  template <class _Up, class = typename enable_if<\x0a"
"      \x21is_same<__compressed_pair_elem, typename decay<_Up>\x3a\x3atype>\x3a\x3avalue\x0a"
"  >\x3a\x3atype>\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr explicit\x0a"
"  __compressed_pair_elem(_Up\x26\x26 __u)\x0a"
"      \x3a __value_(_VSTD\x3a\x3a""forward<_Up>(__u))\x0a"
"    {\x0a"
"    }\x0a"
"\x0a"
"  template <class... _Args, size_t... _Indexes>\x0a"
"  _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"  __compressed_pair_elem(piecewise_construct_t, tuple<_Args...> __args,\x0a"
"                         __tuple_indices<_Indexes...>)\x0a"
"      \x3a __value_(_VSTD\x3a\x3a""forward<_Args>(_VSTD\x3a\x3aget<_Indexes>(__args))...) {}\x0a"
"#else\x0a"
"  _LIBCPP_INLINE_VISIBILITY __compressed_pair_elem() \x3a __value_() {}\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  __compressed_pair_elem(_ParamT __p) \x3a __value_(std\x3a\x3a""forward<_ParamT>(__p)) {}\x0a"
"#endif\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY reference __get() _NOEXCEPT { return __value_; }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const_reference __get() const _NOEXCEPT { return __value_; }\x0a"
"\x0a"
"private\x3a\x0a"
"  _Tp __value_;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, int _Idx>\x0a"
"struct __compressed_pair_elem<_Tp, _Idx, true> \x3a private _Tp {\x0a"
"  typedef _Tp _ParamT;\x0a"
"  typedef _Tp\x26 reference;\x0a"
"  typedef const _Tp\x26 const_reference;\x0a"
"  typedef _Tp __value_type;\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"  _LIBCPP_INLINE_VISIBILITY constexpr __compressed_pair_elem() = default;\x0a"
"\x0a"
"  template <class _Up, class = typename enable_if<\x0a"
"        \x21is_same<__compressed_pair_elem, typename decay<_Up>\x3a\x3atype>\x3a\x3avalue\x0a"
"  >\x3a\x3atype>\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr explicit\x0a"
"  __compressed_pair_elem(_Up\x26\x26 __u)\x0a"
"      \x3a __value_type(_VSTD\x3a\x3a""forward<_Up>(__u))\x0a"
"  {}\x0a"
"\x0a"
"  template <class... _Args, size_t... _Indexes>\x0a"
"  _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"  __compressed_pair_elem(piecewise_construct_t, tuple<_Args...> __args,\x0a"
"                         __tuple_indices<_Indexes...>)\x0a"
"      \x3a __value_type(_VSTD\x3a\x3a""forward<_Args>(_VSTD\x3a\x3aget<_Indexes>(__args))...) {}\x0a"
"#else\x0a"
"  _LIBCPP_INLINE_VISIBILITY __compressed_pair_elem() \x3a __value_type() {}\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  __compressed_pair_elem(_ParamT __p)\x0a"
"      \x3a __value_type(std\x3a\x3a""forward<_ParamT>(__p)) {}\x0a"
"#endif\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY reference __get() _NOEXCEPT { return *this; }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const_reference __get() const _NOEXCEPT { return *this; }\x0a"
"};\x0a"
"\x0a"
"// Tag used to construct the second element of the compressed pair.\x0a"
"struct __second_tag {};\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"class __compressed_pair \x3a private __compressed_pair_elem<_T1, 0>,\x0a"
"                          private __compressed_pair_elem<_T2, 1> {\x0a"
"  typedef _LIBCPP_NODEBUG_TYPE __compressed_pair_elem<_T1, 0> _Base1;\x0a"
"  typedef _LIBCPP_NODEBUG_TYPE __compressed_pair_elem<_T2, 1> _Base2;\x0a"
"\x0a"
"  // NOTE\x3a This static assert should never fire because __compressed_pair\x0a"
"  // is *almost never* used in a scenario where it's possible for T1 == T2.\x0a"
"  // (The exception is std\x3a\x3a""function where it is possible that the function\x0a"
"  //  object and the allocator have the same type).\x0a"
"  static_assert((\x21is_same<_T1, _T2>\x3a\x3avalue),\x0a"
"    \x22__compressed_pair cannot be instantated when T1 and T2 are the same type; \x22\x0a"
"    \x22The current implementation is NOT ABI-compatible with the previous \x22\x0a"
"    \x22implementation for this configuration\x22);\x0a"
"\x0a"
"public\x3a\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"  template <bool _Dummy = true,\x0a"
"      class = typename enable_if<\x0a"
"          __dependent_type<is_default_constructible<_T1>, _Dummy>\x3a\x3avalue \x26\x26\x0a"
"          __dependent_type<is_default_constructible<_T2>, _Dummy>\x3a\x3avalue\x0a"
"      >\x3a\x3atype\x0a"
"  >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr __compressed_pair() {}\x0a"
"\x0a"
"  template <class _Tp, typename enable_if<\x21is_same<typename decay<_Tp>\x3a\x3atype,\x0a"
"                                                   __compressed_pair>\x3a\x3avalue,\x0a"
"                                          bool>\x3a\x3atype = true>\x0a"
"  _LIBCPP_INLINE_VISIBILITY constexpr explicit\x0a"
"  __compressed_pair(_Tp\x26\x26 __t)\x0a"
"      \x3a _Base1(std\x3a\x3a""forward<_Tp>(__t)), _Base2() {}\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  _LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"  __compressed_pair(__second_tag, _Tp\x26\x26 __t)\x0a"
"      \x3a _Base1(), _Base2(std\x3a\x3a""forward<_Tp>(__t)) {}\x0a"
"\x0a"
"  template <class _U1, class _U2>\x0a"
"  _LIBCPP_INLINE_VISIBILITY constexpr\x0a"
"  __compressed_pair(_U1\x26\x26 __t1, _U2\x26\x26 __t2)\x0a"
"      \x3a _Base1(std\x3a\x3a""forward<_U1>(__t1)), _Base2(std\x3a\x3a""forward<_U2>(__t2)) {}\x0a"
"\x0a"
"  template <class... _Args1, class... _Args2>\x0a"
"  _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"  __compressed_pair(piecewise_construct_t __pc, tuple<_Args1...> __first_args,\x0a"
"                    tuple<_Args2...> __second_args)\x0a"
"      \x3a _Base1(__pc, _VSTD\x3a\x3amove(__first_args),\x0a"
"               typename __make_tuple_indices<sizeof...(_Args1)>\x3a\x3atype()),\x0a"
"        _Base2(__pc, _VSTD\x3a\x3amove(__second_args),\x0a"
"               typename __make_tuple_indices<sizeof...(_Args2)>\x3a\x3atype()) {}\x0a"
"\x0a"
"#else\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  __compressed_pair() {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY explicit\x0a"
"  __compressed_pair(_T1 __t1) \x3a _Base1(_VSTD\x3a\x3a""forward<_T1>(__t1)) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  __compressed_pair(__second_tag, _T2 __t2)\x0a"
"      \x3a _Base1(), _Base2(_VSTD\x3a\x3a""forward<_T2>(__t2)) {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  __compressed_pair(_T1 __t1, _T2 __t2)\x0a"
"      \x3a _Base1(_VSTD\x3a\x3a""forward<_T1>(__t1)), _Base2(_VSTD\x3a\x3a""forward<_T2>(__t2)) {}\x0a"
"#endif\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  typename _Base1\x3a\x3areference first() _NOEXCEPT {\x0a"
"    return static_cast<_Base1\x26>(*this).__get();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  typename _Base1\x3a\x3a""const_reference first() const _NOEXCEPT {\x0a"
"    return static_cast<_Base1 const\x26>(*this).__get();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  typename _Base2\x3a\x3areference second() _NOEXCEPT {\x0a"
"    return static_cast<_Base2\x26>(*this).__get();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  typename _Base2\x3a\x3a""const_reference second() const _NOEXCEPT {\x0a"
"    return static_cast<_Base2 const\x26>(*this).__get();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void swap(__compressed_pair\x26 __x)\x0a"
"    _NOEXCEPT_(__is_nothrow_swappable<_T1>\x3a\x3avalue \x26\x26\x0a"
"               __is_nothrow_swappable<_T2>\x3a\x3avalue)\x0a"
"  {\x0a"
"    using std\x3a\x3aswap;\x0a"
"    swap(first(), __x.first());\x0a"
"    swap(second(), __x.second());\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _T1, class _T2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void swap(__compressed_pair<_T1, _T2>\x26 __x, __compressed_pair<_T1, _T2>\x26 __y)\x0a"
"    _NOEXCEPT_(__is_nothrow_swappable<_T1>\x3a\x3avalue \x26\x26\x0a"
"               __is_nothrow_swappable<_T2>\x3a\x3avalue) {\x0a"
"  __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"// default_delete\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS default_delete {\x0a"
"    static_assert(\x21is_function<_Tp>\x3a\x3avalue,\x0a"
"                  \x22""default_delete cannot be instantiated for function types\x22);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"  _LIBCPP_INLINE_VISIBILITY constexpr default_delete() _NOEXCEPT = default;\x0a"
"#else\x0a"
"  _LIBCPP_INLINE_VISIBILITY default_delete() {}\x0a"
"#endif\x0a"
"  template <class _Up>\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  default_delete(const default_delete<_Up>\x26,\x0a"
"                 typename enable_if<is_convertible<_Up*, _Tp*>\x3a\x3avalue>\x3a\x3atype* =\x0a"
"                     0) _NOEXCEPT {}\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY void operator()(_Tp* __ptr) const _NOEXCEPT {\x0a"
"    static_assert(sizeof(_Tp) > 0,\x0a"
"                  \x22""default_delete can not delete incomplete type\x22);\x0a"
"    static_assert(\x21is_void<_Tp>\x3a\x3avalue,\x0a"
"                  \x22""default_delete can not delete incomplete type\x22);\x0a"
"    delete __ptr;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS default_delete<_Tp\x5b\x5d> {\x0a"
"private\x3a\x0a"
"  template <class _Up>\x0a"
"  struct _EnableIfConvertible\x0a"
"      \x3a enable_if<is_convertible<_Up(*)\x5b\x5d, _Tp(*)\x5b\x5d>\x3a\x3avalue> {};\x0a"
"\x0a"
"public\x3a\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"  _LIBCPP_INLINE_VISIBILITY constexpr default_delete() _NOEXCEPT = default;\x0a"
"#else\x0a"
"  _LIBCPP_INLINE_VISIBILITY default_delete() {}\x0a"
"#endif\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  default_delete(const default_delete<_Up\x5b\x5d>\x26,\x0a"
"                 typename _EnableIfConvertible<_Up>\x3a\x3atype* = 0) _NOEXCEPT {}\x0a"
"\x0a"
"  template <class _Up>\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  typename _EnableIfConvertible<_Up>\x3a\x3atype\x0a"
"  operator()(_Up* __ptr) const _NOEXCEPT {\x0a"
"    static_assert(sizeof(_Tp) > 0,\x0a"
"                  \x22""default_delete can not delete incomplete type\x22);\x0a"
"    static_assert(\x21is_void<_Tp>\x3a\x3avalue,\x0a"
"                  \x22""default_delete can not delete void type\x22);\x0a"
"    delete\x5b\x5d __ptr;\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"template <class _Deleter>\x0a"
"struct __unique_ptr_deleter_sfinae {\x0a"
"  static_assert(\x21is_reference<_Deleter>\x3a\x3avalue, \x22incorrect specialization\x22);\x0a"
"  typedef const _Deleter\x26 __lval_ref_type;\x0a"
"  typedef _Deleter\x26\x26 __good_rval_ref_type;\x0a"
"  typedef true_type __enable_rval_overload;\x0a"
"};\x0a"
"\x0a"
"template <class _Deleter>\x0a"
"struct __unique_ptr_deleter_sfinae<_Deleter const\x26> {\x0a"
"  typedef const _Deleter\x26 __lval_ref_type;\x0a"
"  typedef const _Deleter\x26\x26 __bad_rval_ref_type;\x0a"
"  typedef false_type __enable_rval_overload;\x0a"
"};\x0a"
"\x0a"
"template <class _Deleter>\x0a"
"struct __unique_ptr_deleter_sfinae<_Deleter\x26> {\x0a"
"  typedef _Deleter\x26 __lval_ref_type;\x0a"
"  typedef _Deleter\x26\x26 __bad_rval_ref_type;\x0a"
"  typedef false_type __enable_rval_overload;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Dp = default_delete<_Tp> >\x0a"
"class _LIBCPP_TEMPLATE_VIS unique_ptr {\x0a"
"public\x3a\x0a"
"  typedef _Tp element_type;\x0a"
"  typedef _Dp deleter_type;\x0a"
"  typedef _LIBCPP_NODEBUG_TYPE typename __pointer_type<_Tp, deleter_type>\x3a\x3atype pointer;\x0a"
"\x0a"
"  static_assert(\x21is_rvalue_reference<deleter_type>\x3a\x3avalue,\x0a"
"                \x22the specified deleter type cannot be an rvalue reference\x22);\x0a"
"\x0a"
"private\x3a\x0a"
"  __compressed_pair<pointer, deleter_type> __ptr_;\x0a"
"\x0a"
"  struct __nat { int __for_bool_; };\x0a"
"\x0a"
"  typedef _LIBCPP_NODEBUG_TYPE __unique_ptr_deleter_sfinae<_Dp> _DeleterSFINAE;\x0a"
"\x0a"
"  template <bool _Dummy>\x0a"
"  using _LValRefType _LIBCPP_NODEBUG_TYPE =\x0a"
"      typename __dependent_type<_DeleterSFINAE, _Dummy>\x3a\x3a__lval_ref_type;\x0a"
"\x0a"
"  template <bool _Dummy>\x0a"
"  using _GoodRValRefType _LIBCPP_NODEBUG_TYPE =\x0a"
"      typename __dependent_type<_DeleterSFINAE, _Dummy>\x3a\x3a__good_rval_ref_type;\x0a"
"\x0a"
"  template <bool _Dummy>\x0a"
"  using _BadRValRefType _LIBCPP_NODEBUG_TYPE  =\x0a"
"      typename __dependent_type<_DeleterSFINAE, _Dummy>\x3a\x3a__bad_rval_ref_type;\x0a"
"\x0a"
"  template <bool _Dummy, class _Deleter = typename __dependent_type<\x0a"
"                             __identity<deleter_type>, _Dummy>\x3a\x3atype>\x0a"
"  using _EnableIfDeleterDefaultConstructible _LIBCPP_NODEBUG_TYPE =\x0a"
"      typename enable_if<is_default_constructible<_Deleter>\x3a\x3avalue \x26\x26\x0a"
"                         \x21is_pointer<_Deleter>\x3a\x3avalue>\x3a\x3atype;\x0a"
"\x0a"
"  template <class _ArgType>\x0a"
"  using _EnableIfDeleterConstructible _LIBCPP_NODEBUG_TYPE  =\x0a"
"      typename enable_if<is_constructible<deleter_type, _ArgType>\x3a\x3avalue>\x3a\x3atype;\x0a"
"\x0a"
"  template <class _UPtr, class _Up>\x0a"
"  using _EnableIfMoveConvertible _LIBCPP_NODEBUG_TYPE  = typename enable_if<\x0a"
"      is_convertible<typename _UPtr\x3a\x3apointer, pointer>\x3a\x3avalue \x26\x26\x0a"
"      \x21is_array<_Up>\x3a\x3avalue\x0a"
"  >\x3a\x3atype;\x0a"
"\x0a"
"  template <class _UDel>\x0a"
"  using _EnableIfDeleterConvertible _LIBCPP_NODEBUG_TYPE  = typename enable_if<\x0a"
"      (is_reference<_Dp>\x3a\x3avalue \x26\x26 is_same<_Dp, _UDel>\x3a\x3avalue) \x7c\x7c\x0a"
"      (\x21is_reference<_Dp>\x3a\x3avalue \x26\x26 is_convertible<_UDel, _Dp>\x3a\x3avalue)\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"  template <class _UDel>\x0a"
"  using _EnableIfDeleterAssignable = typename enable_if<\x0a"
"      is_assignable<_Dp\x26, _UDel\x26\x26>\x3a\x3avalue\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"public\x3a\x0a"
"  template <bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterDefaultConstructible<_Dummy> >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _LIBCPP_CONSTEXPR unique_ptr() _NOEXCEPT \x3a __ptr_(pointer()) {}\x0a"
"\x0a"
"  template <bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterDefaultConstructible<_Dummy> >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _LIBCPP_CONSTEXPR unique_ptr(nullptr_t) _NOEXCEPT \x3a __ptr_(pointer()) {}\x0a"
"\x0a"
"  template <bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterDefaultConstructible<_Dummy> >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit unique_ptr(pointer __p) _NOEXCEPT \x3a __ptr_(__p) {}\x0a"
"\x0a"
"  template <bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterConstructible<_LValRefType<_Dummy> > >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(pointer __p, _LValRefType<_Dummy> __d) _NOEXCEPT\x0a"
"      \x3a __ptr_(__p, __d) {}\x0a"
"\x0a"
"  template <bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterConstructible<_GoodRValRefType<_Dummy> > >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(pointer __p, _GoodRValRefType<_Dummy> __d) _NOEXCEPT\x0a"
"      \x3a __ptr_(__p, _VSTD\x3a\x3amove(__d)) {\x0a"
"    static_assert(\x21is_reference<deleter_type>\x3a\x3avalue,\x0a"
"                  \x22rvalue deleter bound to reference\x22);\x0a"
"  }\x0a"
"\x0a"
"  template <bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterConstructible<_BadRValRefType<_Dummy> > >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(pointer __p, _BadRValRefType<_Dummy> __d) = delete;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(unique_ptr\x26\x26 __u) _NOEXCEPT\x0a"
"      \x3a __ptr_(__u.release(), _VSTD\x3a\x3a""forward<deleter_type>(__u.get_deleter())) {\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up, class _Ep,\x0a"
"      class = _EnableIfMoveConvertible<unique_ptr<_Up, _Ep>, _Up>,\x0a"
"      class = _EnableIfDeleterConvertible<_Ep>\x0a"
"  >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(unique_ptr<_Up, _Ep>\x26\x26 __u) _NOEXCEPT\x0a"
"      \x3a __ptr_(__u.release(), _VSTD\x3a\x3a""forward<_Ep>(__u.get_deleter())) {}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR)\x0a"
"  template <class _Up>\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(auto_ptr<_Up>\x26\x26 __p,\x0a"
"             typename enable_if<is_convertible<_Up*, _Tp*>\x3a\x3avalue \x26\x26\x0a"
"                                    is_same<_Dp, default_delete<_Tp> >\x3a\x3avalue,\x0a"
"                                __nat>\x3a\x3atype = __nat()) _NOEXCEPT\x0a"
"      \x3a __ptr_(__p.release()) {}\x0a"
"#endif\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr\x26 operator=(unique_ptr\x26\x26 __u) _NOEXCEPT {\x0a"
"    reset(__u.release());\x0a"
"    __ptr_.second() = _VSTD\x3a\x3a""forward<deleter_type>(__u.get_deleter());\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up, class _Ep,\x0a"
"      class = _EnableIfMoveConvertible<unique_ptr<_Up, _Ep>, _Up>,\x0a"
"      class = _EnableIfDeleterAssignable<_Ep>\x0a"
"  >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr\x26 operator=(unique_ptr<_Up, _Ep>\x26\x26 __u) _NOEXCEPT {\x0a"
"    reset(__u.release());\x0a"
"    __ptr_.second() = _VSTD\x3a\x3a""forward<_Ep>(__u.get_deleter());\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR)\x0a"
"  template <class _Up>\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"      typename enable_if<is_convertible<_Up*, _Tp*>\x3a\x3avalue \x26\x26\x0a"
"                             is_same<_Dp, default_delete<_Tp> >\x3a\x3avalue,\x0a"
"                         unique_ptr\x26>\x3a\x3atype\x0a"
"      operator=(auto_ptr<_Up> __p) {\x0a"
"    reset(__p.release());\x0a"
"    return *this;\x0a"
"  }\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"  unique_ptr(unique_ptr const\x26) = delete;\x0a"
"  unique_ptr\x26 operator=(unique_ptr const\x26) = delete;\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  \x7eunique_ptr() { reset(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr\x26 operator=(nullptr_t) _NOEXCEPT {\x0a"
"    reset();\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  typename add_lvalue_reference<_Tp>\x3a\x3atype\x0a"
"  operator*() const {\x0a"
"    return *__ptr_.first();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  pointer operator->() const _NOEXCEPT {\x0a"
"    return __ptr_.first();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  pointer get() const _NOEXCEPT {\x0a"
"    return __ptr_.first();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  deleter_type\x26 get_deleter() _NOEXCEPT {\x0a"
"    return __ptr_.second();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const deleter_type\x26 get_deleter() const _NOEXCEPT {\x0a"
"    return __ptr_.second();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _LIBCPP_EXPLICIT operator bool() const _NOEXCEPT {\x0a"
"    return __ptr_.first() \x21= nullptr;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  pointer release() _NOEXCEPT {\x0a"
"    pointer __t = __ptr_.first();\x0a"
"    __ptr_.first() = pointer();\x0a"
"    return __t;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void reset(pointer __p = pointer()) _NOEXCEPT {\x0a"
"    pointer __tmp = __ptr_.first();\x0a"
"    __ptr_.first() = __p;\x0a"
"    if (__tmp)\x0a"
"      __ptr_.second()(__tmp);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void swap(unique_ptr\x26 __u) _NOEXCEPT {\x0a"
"    __ptr_.swap(__u.__ptr_);\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Dp>\x0a"
"class _LIBCPP_TEMPLATE_VIS unique_ptr<_Tp\x5b\x5d, _Dp> {\x0a"
"public\x3a\x0a"
"  typedef _Tp element_type;\x0a"
"  typedef _Dp deleter_type;\x0a"
"  typedef typename __pointer_type<_Tp, deleter_type>\x3a\x3atype pointer;\x0a"
"\x0a"
"private\x3a\x0a"
"  __compressed_pair<pointer, deleter_type> __ptr_;\x0a"
"\x0a"
"  template <class _From>\x0a"
"  struct _CheckArrayPointerConversion \x3a is_same<_From, pointer> {};\x0a"
"\x0a"
"  template <class _FromElem>\x0a"
"  struct _CheckArrayPointerConversion<_FromElem*>\x0a"
"      \x3a integral_constant<bool,\x0a"
"          is_same<_FromElem*, pointer>\x3a\x3avalue \x7c\x7c\x0a"
"            (is_same<pointer, element_type*>\x3a\x3avalue \x26\x26\x0a"
"             is_convertible<_FromElem(*)\x5b\x5d, element_type(*)\x5b\x5d>\x3a\x3avalue)\x0a"
"      >\x0a"
"  {};\x0a"
"\x0a"
"  typedef __unique_ptr_deleter_sfinae<_Dp> _DeleterSFINAE;\x0a"
"\x0a"
"  template <bool _Dummy>\x0a"
"  using _LValRefType _LIBCPP_NODEBUG_TYPE =\x0a"
"      typename __dependent_type<_DeleterSFINAE, _Dummy>\x3a\x3a__lval_ref_type;\x0a"
"\x0a"
"  template <bool _Dummy>\x0a"
"  using _GoodRValRefType _LIBCPP_NODEBUG_TYPE =\x0a"
"      typename __dependent_type<_DeleterSFINAE, _Dummy>\x3a\x3a__good_rval_ref_type;\x0a"
"\x0a"
"  template <bool _Dummy>\x0a"
"  using _BadRValRefType _LIBCPP_NODEBUG_TYPE =\x0a"
"      typename __dependent_type<_DeleterSFINAE, _Dummy>\x3a\x3a__bad_rval_ref_type;\x0a"
"\x0a"
"  template <bool _Dummy, class _Deleter = typename __dependent_type<\x0a"
"                             __identity<deleter_type>, _Dummy>\x3a\x3atype>\x0a"
"  using _EnableIfDeleterDefaultConstructible _LIBCPP_NODEBUG_TYPE  =\x0a"
"      typename enable_if<is_default_constructible<_Deleter>\x3a\x3avalue \x26\x26\x0a"
"                         \x21is_pointer<_Deleter>\x3a\x3avalue>\x3a\x3atype;\x0a"
"\x0a"
"  template <class _ArgType>\x0a"
"  using _EnableIfDeleterConstructible _LIBCPP_NODEBUG_TYPE  =\x0a"
"      typename enable_if<is_constructible<deleter_type, _ArgType>\x3a\x3avalue>\x3a\x3atype;\x0a"
"\x0a"
"  template <class _Pp>\x0a"
"  using _EnableIfPointerConvertible _LIBCPP_NODEBUG_TYPE  = typename enable_if<\x0a"
"      _CheckArrayPointerConversion<_Pp>\x3a\x3avalue\x0a"
"  >\x3a\x3atype;\x0a"
"\x0a"
"  template <class _UPtr, class _Up,\x0a"
"        class _ElemT = typename _UPtr\x3a\x3a""element_type>\x0a"
"  using _EnableIfMoveConvertible _LIBCPP_NODEBUG_TYPE  = typename enable_if<\x0a"
"      is_array<_Up>\x3a\x3avalue \x26\x26\x0a"
"      is_same<pointer, element_type*>\x3a\x3avalue \x26\x26\x0a"
"      is_same<typename _UPtr\x3a\x3apointer, _ElemT*>\x3a\x3avalue \x26\x26\x0a"
"      is_convertible<_ElemT(*)\x5b\x5d, element_type(*)\x5b\x5d>\x3a\x3avalue\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"  template <class _UDel>\x0a"
"  using _EnableIfDeleterConvertible _LIBCPP_NODEBUG_TYPE  = typename enable_if<\x0a"
"      (is_reference<_Dp>\x3a\x3avalue \x26\x26 is_same<_Dp, _UDel>\x3a\x3avalue) \x7c\x7c\x0a"
"      (\x21is_reference<_Dp>\x3a\x3avalue \x26\x26 is_convertible<_UDel, _Dp>\x3a\x3avalue)\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"  template <class _UDel>\x0a"
"  using _EnableIfDeleterAssignable _LIBCPP_NODEBUG_TYPE  = typename enable_if<\x0a"
"      is_assignable<_Dp\x26, _UDel\x26\x26>\x3a\x3avalue\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"public\x3a\x0a"
"  template <bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterDefaultConstructible<_Dummy> >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _LIBCPP_CONSTEXPR unique_ptr() _NOEXCEPT \x3a __ptr_(pointer()) {}\x0a"
"\x0a"
"  template <bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterDefaultConstructible<_Dummy> >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _LIBCPP_CONSTEXPR unique_ptr(nullptr_t) _NOEXCEPT \x3a __ptr_(pointer()) {}\x0a"
"\x0a"
"  template <class _Pp, bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterDefaultConstructible<_Dummy>,\x0a"
"            class = _EnableIfPointerConvertible<_Pp> >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  explicit unique_ptr(_Pp __p) _NOEXCEPT\x0a"
"      \x3a __ptr_(__p) {}\x0a"
"\x0a"
"  template <class _Pp, bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterConstructible<_LValRefType<_Dummy> >,\x0a"
"            class = _EnableIfPointerConvertible<_Pp> >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(_Pp __p, _LValRefType<_Dummy> __d) _NOEXCEPT\x0a"
"      \x3a __ptr_(__p, __d) {}\x0a"
"\x0a"
"  template <bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterConstructible<_LValRefType<_Dummy> > >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(nullptr_t, _LValRefType<_Dummy> __d) _NOEXCEPT\x0a"
"      \x3a __ptr_(nullptr, __d) {}\x0a"
"\x0a"
"  template <class _Pp, bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterConstructible<_GoodRValRefType<_Dummy> >,\x0a"
"            class = _EnableIfPointerConvertible<_Pp> >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(_Pp __p, _GoodRValRefType<_Dummy> __d) _NOEXCEPT\x0a"
"      \x3a __ptr_(__p, _VSTD\x3a\x3amove(__d)) {\x0a"
"    static_assert(\x21is_reference<deleter_type>\x3a\x3avalue,\x0a"
"                  \x22rvalue deleter bound to reference\x22);\x0a"
"  }\x0a"
"\x0a"
"  template <bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterConstructible<_GoodRValRefType<_Dummy> > >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(nullptr_t, _GoodRValRefType<_Dummy> __d) _NOEXCEPT\x0a"
"      \x3a __ptr_(nullptr, _VSTD\x3a\x3amove(__d)) {\x0a"
"    static_assert(\x21is_reference<deleter_type>\x3a\x3avalue,\x0a"
"                  \x22rvalue deleter bound to reference\x22);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Pp, bool _Dummy = true,\x0a"
"            class = _EnableIfDeleterConstructible<_BadRValRefType<_Dummy> >,\x0a"
"            class = _EnableIfPointerConvertible<_Pp> >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(_Pp __p, _BadRValRefType<_Dummy> __d) = delete;\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(unique_ptr\x26\x26 __u) _NOEXCEPT\x0a"
"      \x3a __ptr_(__u.release(), _VSTD\x3a\x3a""forward<deleter_type>(__u.get_deleter())) {\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr\x26 operator=(unique_ptr\x26\x26 __u) _NOEXCEPT {\x0a"
"    reset(__u.release());\x0a"
"    __ptr_.second() = _VSTD\x3a\x3a""forward<deleter_type>(__u.get_deleter());\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up, class _Ep,\x0a"
"      class = _EnableIfMoveConvertible<unique_ptr<_Up, _Ep>, _Up>,\x0a"
"      class = _EnableIfDeleterConvertible<_Ep>\x0a"
"  >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr(unique_ptr<_Up, _Ep>\x26\x26 __u) _NOEXCEPT\x0a"
"      \x3a __ptr_(__u.release(), _VSTD\x3a\x3a""forward<_Ep>(__u.get_deleter())) {\x0a"
"  }\x0a"
"\x0a"
"  template <class _Up, class _Ep,\x0a"
"      class = _EnableIfMoveConvertible<unique_ptr<_Up, _Ep>, _Up>,\x0a"
"      class = _EnableIfDeleterAssignable<_Ep>\x0a"
"  >\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr\x26\x0a"
"  operator=(unique_ptr<_Up, _Ep>\x26\x26 __u) _NOEXCEPT {\x0a"
"    reset(__u.release());\x0a"
"    __ptr_.second() = _VSTD\x3a\x3a""forward<_Ep>(__u.get_deleter());\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"  unique_ptr(unique_ptr const\x26) = delete;\x0a"
"  unique_ptr\x26 operator=(unique_ptr const\x26) = delete;\x0a"
"#endif\x0a"
"\x0a"
"public\x3a\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  \x7eunique_ptr() { reset(); }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  unique_ptr\x26 operator=(nullptr_t) _NOEXCEPT {\x0a"
"    reset();\x0a"
"    return *this;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  typename add_lvalue_reference<_Tp>\x3a\x3atype\x0a"
"  operator\x5b\x5d(size_t __i) const {\x0a"
"    return __ptr_.first()\x5b__i\x5d;\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  pointer get() const _NOEXCEPT {\x0a"
"    return __ptr_.first();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  deleter_type\x26 get_deleter() _NOEXCEPT {\x0a"
"    return __ptr_.second();\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  const deleter_type\x26 get_deleter() const _NOEXCEPT {\x0a"
"    return __ptr_.second();\x0a"
"  }\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _LIBCPP_EXPLICIT operator bool() const _NOEXCEPT {\x0a"
"    return __ptr_.first() \x21= nullptr;\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  pointer release() _NOEXCEPT {\x0a"
"    pointer __t = __ptr_.first();\x0a"
"    __ptr_.first() = pointer();\x0a"
"    return __t;\x0a"
"  }\x0a"
"\x0a"
"  template <class _Pp>\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  typename enable_if<\x0a"
"      _CheckArrayPointerConversion<_Pp>\x3a\x3avalue\x0a"
"  >\x3a\x3atype\x0a"
"  reset(_Pp __p) _NOEXCEPT {\x0a"
"    pointer __tmp = __ptr_.first();\x0a"
"    __ptr_.first() = __p;\x0a"
"    if (__tmp)\x0a"
"      __ptr_.second()(__tmp);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void reset(nullptr_t = nullptr) _NOEXCEPT {\x0a"
"    pointer __tmp = __ptr_.first();\x0a"
"    __ptr_.first() = nullptr;\x0a"
"    if (__tmp)\x0a"
"      __ptr_.second()(__tmp);\x0a"
"  }\x0a"
"\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  void swap(unique_ptr\x26 __u) _NOEXCEPT {\x0a"
"    __ptr_.swap(__u.__ptr_);\x0a"
"  }\x0a"
"\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Dp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if<\x0a"
"    __is_swappable<_Dp>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"swap(unique_ptr<_Tp, _Dp>\x26 __x, unique_ptr<_Tp, _Dp>\x26 __y) _NOEXCEPT {__x.swap(__y);}\x0a"
"\x0a"
"template <class _T1, class _D1, class _T2, class _D2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const unique_ptr<_T1, _D1>\x26 __x, const unique_ptr<_T2, _D2>\x26 __y) {return __x.get() == __y.get();}\x0a"
"\x0a"
"template <class _T1, class _D1, class _T2, class _D2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const unique_ptr<_T1, _D1>\x26 __x, const unique_ptr<_T2, _D2>\x26 __y) {return \x21(__x == __y);}\x0a"
"\x0a"
"template <class _T1, class _D1, class _T2, class _D2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const unique_ptr<_T1, _D1>\x26 __x, const unique_ptr<_T2, _D2>\x26 __y)\x0a"
"{\x0a"
"    typedef typename unique_ptr<_T1, _D1>\x3a\x3apointer _P1;\x0a"
"    typedef typename unique_ptr<_T2, _D2>\x3a\x3apointer _P2;\x0a"
"    typedef typename common_type<_P1, _P2>\x3a\x3atype _Vp;\x0a"
"    return less<_Vp>()(__x.get(), __y.get());\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1, class _T2, class _D2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const unique_ptr<_T1, _D1>\x26 __x, const unique_ptr<_T2, _D2>\x26 __y) {return __y < __x;}\x0a"
"\x0a"
"template <class _T1, class _D1, class _T2, class _D2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const unique_ptr<_T1, _D1>\x26 __x, const unique_ptr<_T2, _D2>\x26 __y) {return \x21(__y < __x);}\x0a"
"\x0a"
"template <class _T1, class _D1, class _T2, class _D2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const unique_ptr<_T1, _D1>\x26 __x, const unique_ptr<_T2, _D2>\x26 __y) {return \x21(__x < __y);}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const unique_ptr<_T1, _D1>\x26 __x, nullptr_t) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21__x;\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(nullptr_t, const unique_ptr<_T1, _D1>\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21__x;\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const unique_ptr<_T1, _D1>\x26 __x, nullptr_t) _NOEXCEPT\x0a"
"{\x0a"
"    return static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(nullptr_t, const unique_ptr<_T1, _D1>\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"    return static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(const unique_ptr<_T1, _D1>\x26 __x, nullptr_t)\x0a"
"{\x0a"
"    typedef typename unique_ptr<_T1, _D1>\x3a\x3apointer _P1;\x0a"
"    return less<_P1>()(__x.get(), nullptr);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(nullptr_t, const unique_ptr<_T1, _D1>\x26 __x)\x0a"
"{\x0a"
"    typedef typename unique_ptr<_T1, _D1>\x3a\x3apointer _P1;\x0a"
"    return less<_P1>()(nullptr, __x.get());\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(const unique_ptr<_T1, _D1>\x26 __x, nullptr_t)\x0a"
"{\x0a"
"    return nullptr < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(nullptr_t, const unique_ptr<_T1, _D1>\x26 __x)\x0a"
"{\x0a"
"    return __x < nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const unique_ptr<_T1, _D1>\x26 __x, nullptr_t)\x0a"
"{\x0a"
"    return \x21(nullptr < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(nullptr_t, const unique_ptr<_T1, _D1>\x26 __x)\x0a"
"{\x0a"
"    return \x21(__x < nullptr);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const unique_ptr<_T1, _D1>\x26 __x, nullptr_t)\x0a"
"{\x0a"
"    return \x21(__x < nullptr);\x0a"
"}\x0a"
"\x0a"
"template <class _T1, class _D1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(nullptr_t, const unique_ptr<_T1, _D1>\x26 __x)\x0a"
"{\x0a"
"    return \x21(nullptr < __x);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"template<class _Tp>\x0a"
"struct __unique_if\x0a"
"{\x0a"
"    typedef unique_ptr<_Tp> __unique_single;\x0a"
"};\x0a"
"\x0a"
"template<class _Tp>\x0a"
"struct __unique_if<_Tp\x5b\x5d>\x0a"
"{\x0a"
"    typedef unique_ptr<_Tp\x5b\x5d> __unique_array_unknown_bound;\x0a"
"};\x0a"
"\x0a"
"template<class _Tp, size_t _Np>\x0a"
"struct __unique_if<_Tp\x5b_Np\x5d>\x0a"
"{\x0a"
"    typedef void __unique_array_known_bound;\x0a"
"};\x0a"
"\x0a"
"template<class _Tp, class... _Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename __unique_if<_Tp>\x3a\x3a__unique_single\x0a"
"make_unique(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    return unique_ptr<_Tp>(new _Tp(_VSTD\x3a\x3a""forward<_Args>(__args)...));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename __unique_if<_Tp>\x3a\x3a__unique_array_unknown_bound\x0a"
"make_unique(size_t __n)\x0a"
"{\x0a"
"    typedef typename remove_extent<_Tp>\x3a\x3atype _Up;\x0a"
"    return unique_ptr<_Tp>(new _Up\x5b__n\x5d());\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class... _Args>\x0a"
"    typename __unique_if<_Tp>\x3a\x3a__unique_array_known_bound\x0a"
"    make_unique(_Args\x26\x26...) = delete;\x0a"
"\x0a"
"#endif  // _LIBCPP_STD_VER > 11\x0a"
"\x0a"
"template <class _Tp, class _Dp>\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<unique_ptr<_Tp, _Dp> >\x0a"
"#else\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<__enable_hash_helper<\x0a"
"    unique_ptr<_Tp, _Dp>, typename unique_ptr<_Tp, _Dp>\x3a\x3apointer> >\x0a"
"#endif\x0a"
"{\x0a"
"    typedef unique_ptr<_Tp, _Dp> argument_type;\x0a"
"    typedef size_t               result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator()(const argument_type\x26 __ptr) const\x0a"
"    {\x0a"
"        typedef typename argument_type\x3a\x3apointer pointer;\x0a"
"        return hash<pointer>()(__ptr.get());\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"struct __destruct_n\x0a"
"{\x0a"
"private\x3a\x0a"
"    size_t __size_;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __process(_Tp* __p, false_type) _NOEXCEPT\x0a"
"        {for (size_t __i = 0; __i < __size_; ++__i, ++__p) __p->\x7e_Tp();}\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __process(_Tp*, true_type) _NOEXCEPT\x0a"
"        {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __incr(false_type) _NOEXCEPT\x0a"
"        {++__size_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __incr(true_type) _NOEXCEPT\x0a"
"        {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __set(size_t __s, false_type) _NOEXCEPT\x0a"
"        {__size_ = __s;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __set(size_t, true_type) _NOEXCEPT\x0a"
"        {}\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit __destruct_n(size_t __s) _NOEXCEPT\x0a"
"        \x3a __size_(__s) {}\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __incr(_Tp*) _NOEXCEPT\x0a"
"        {__incr(integral_constant<bool, is_trivially_destructible<_Tp>\x3a\x3avalue>());}\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __set(size_t __s, _Tp*) _NOEXCEPT\x0a"
"        {__set(__s, integral_constant<bool, is_trivially_destructible<_Tp>\x3a\x3avalue>());}\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_INLINE_VISIBILITY void operator()(_Tp* __p) _NOEXCEPT\x0a"
"        {__process(__p, integral_constant<bool, is_trivially_destructible<_Tp>\x3a\x3avalue>());}\x0a"
"};\x0a"
"\x0a"
"template <class _Alloc>\x0a"
"class __allocator_destructor\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE allocator_traits<_Alloc> __alloc_traits;\x0a"
"public\x3a\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename __alloc_traits\x3a\x3apointer pointer;\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename __alloc_traits\x3a\x3asize_type size_type;\x0a"
"private\x3a\x0a"
"    _Alloc\x26 __alloc_;\x0a"
"    size_type __s_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY __allocator_destructor(_Alloc\x26 __a, size_type __s)\x0a"
"             _NOEXCEPT\x0a"
"        \x3a __alloc_(__a), __s_(__s) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator()(pointer __p) _NOEXCEPT\x0a"
"        {__alloc_traits\x3a\x3a""deallocate(__alloc_, __p, __s_);}\x0a"
"};\x0a"
"\x0a"
"template <class _InputIterator, class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"uninitialized_copy(_InputIterator __f, _InputIterator __l, _ForwardIterator __r)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type value_type;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    _ForwardIterator __s = __r;\x0a"
"    try\x0a"
"    {\x0a"
"#endif\x0a"
"        for (; __f \x21= __l; ++__f, (void) ++__r)\x0a"
"            \x3a\x3anew (static_cast<void*>(_VSTD\x3a\x3a""addressof(*__r))) value_type(*__f);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        for (; __s \x21= __r; ++__s)\x0a"
"            __s->\x7evalue_type();\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _InputIterator, class _Size, class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"uninitialized_copy_n(_InputIterator __f, _Size __n, _ForwardIterator __r)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type value_type;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    _ForwardIterator __s = __r;\x0a"
"    try\x0a"
"    {\x0a"
"#endif\x0a"
"        for (; __n > 0; ++__f, (void) ++__r, (void) --__n)\x0a"
"            \x3a\x3anew (static_cast<void*>(_VSTD\x3a\x3a""addressof(*__r))) value_type(*__f);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        for (; __s \x21= __r; ++__s)\x0a"
"            __s->\x7evalue_type();\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Tp>\x0a"
"void\x0a"
"uninitialized_fill(_ForwardIterator __f, _ForwardIterator __l, const _Tp\x26 __x)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type value_type;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    _ForwardIterator __s = __f;\x0a"
"    try\x0a"
"    {\x0a"
"#endif\x0a"
"        for (; __f \x21= __l; ++__f)\x0a"
"            \x3a\x3anew (static_cast<void*>(_VSTD\x3a\x3a""addressof(*__f))) value_type(__x);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        for (; __s \x21= __f; ++__s)\x0a"
"            __s->\x7evalue_type();\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Size, class _Tp>\x0a"
"_ForwardIterator\x0a"
"uninitialized_fill_n(_ForwardIterator __f, _Size __n, const _Tp\x26 __x)\x0a"
"{\x0a"
"    typedef typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type value_type;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    _ForwardIterator __s = __f;\x0a"
"    try\x0a"
"    {\x0a"
"#endif\x0a"
"        for (; __n > 0; ++__f, (void) --__n)\x0a"
"            \x3a\x3anew (static_cast<void*>(_VSTD\x3a\x3a""addressof(*__f))) value_type(__x);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        for (; __s \x21= __f; ++__s)\x0a"
"            __s->\x7evalue_type();\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif\x0a"
"    return __f;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void destroy_at(_Tp* __loc) {\x0a"
"    _LIBCPP_ASSERT(__loc, \x22null pointer given to destroy_at\x22);\x0a"
"    __loc->\x7e_Tp();\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void destroy(_ForwardIterator __first, _ForwardIterator __last) {\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        _VSTD\x3a\x3a""destroy_at(_VSTD\x3a\x3a""addressof(*__first));\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_ForwardIterator destroy_n(_ForwardIterator __first, _Size __n) {\x0a"
"    for (; __n > 0; (void)++__first, --__n)\x0a"
"        _VSTD\x3a\x3a""destroy_at(_VSTD\x3a\x3a""addressof(*__first));\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void uninitialized_default_construct(_ForwardIterator __first, _ForwardIterator __last) {\x0a"
"    using _Vt = typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type;\x0a"
"    auto __idx = __first;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try {\x0a"
"#endif\x0a"
"    for (; __idx \x21= __last; ++__idx)\x0a"
"        \x3a\x3anew((void*)_VSTD\x3a\x3a""addressof(*__idx)) _Vt;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    } catch (...) {\x0a"
"        _VSTD\x3a\x3a""destroy(__first, __idx);\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_ForwardIterator uninitialized_default_construct_n(_ForwardIterator __first, _Size __n) {\x0a"
"    using _Vt = typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type;\x0a"
"    auto __idx = __first;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try {\x0a"
"#endif\x0a"
"    for (; __n > 0; (void)++__idx, --__n)\x0a"
"        \x3a\x3anew((void*)_VSTD\x3a\x3a""addressof(*__idx)) _Vt;\x0a"
"    return __idx;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    } catch (...) {\x0a"
"        _VSTD\x3a\x3a""destroy(__first, __idx);\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _ForwardIterator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void uninitialized_value_construct(_ForwardIterator __first, _ForwardIterator __last) {\x0a"
"    using _Vt = typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type;\x0a"
"    auto __idx = __first;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try {\x0a"
"#endif\x0a"
"    for (; __idx \x21= __last; ++__idx)\x0a"
"        \x3a\x3anew((void*)_VSTD\x3a\x3a""addressof(*__idx)) _Vt();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    } catch (...) {\x0a"
"        _VSTD\x3a\x3a""destroy(__first, __idx);\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _ForwardIterator, class _Size>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_ForwardIterator uninitialized_value_construct_n(_ForwardIterator __first, _Size __n) {\x0a"
"    using _Vt = typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type;\x0a"
"    auto __idx = __first;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try {\x0a"
"#endif\x0a"
"    for (; __n > 0; (void)++__idx, --__n)\x0a"
"        \x3a\x3anew((void*)_VSTD\x3a\x3a""addressof(*__idx)) _Vt();\x0a"
"    return __idx;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    } catch (...) {\x0a"
"        _VSTD\x3a\x3a""destroy(__first, __idx);\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _InputIt, class _ForwardIt>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_ForwardIt uninitialized_move(_InputIt __first, _InputIt __last, _ForwardIt __first_res) {\x0a"
"    using _Vt = typename iterator_traits<_ForwardIt>\x3a\x3avalue_type;\x0a"
"    auto __idx = __first_res;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try {\x0a"
"#endif\x0a"
"    for (; __first \x21= __last; (void)++__idx, ++__first)\x0a"
"        \x3a\x3anew((void*)_VSTD\x3a\x3a""addressof(*__idx)) _Vt(std\x3a\x3amove(*__first));\x0a"
"    return __idx;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    } catch (...) {\x0a"
"        _VSTD\x3a\x3a""destroy(__first_res, __idx);\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _InputIt, class _Size, class _ForwardIt>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"pair<_InputIt, _ForwardIt>\x0a"
"uninitialized_move_n(_InputIt __first, _Size __n, _ForwardIt __first_res) {\x0a"
"    using _Vt = typename iterator_traits<_ForwardIt>\x3a\x3avalue_type;\x0a"
"    auto __idx = __first_res;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try {\x0a"
"#endif\x0a"
"    for (; __n > 0; ++__idx, (void)++__first, --__n)\x0a"
"        \x3a\x3anew((void*)_VSTD\x3a\x3a""addressof(*__idx)) _Vt(std\x3a\x3amove(*__first));\x0a"
"    return {__first, __idx};\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    } catch (...) {\x0a"
"        _VSTD\x3a\x3a""destroy(__first_res, __idx);\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"// NOTE\x3a Relaxed and acq/rel atomics (for increment and decrement respectively)\x0a"
"// should be sufficient for thread safety.\x0a"
"// See https\x3a//bugs.llvm.org/show_bug.cgi\x3fid=22803\x0a"
"#if defined(__clang__) \x26\x26 __has_builtin(__atomic_add_fetch)          \x5c\x0a"
"                       \x26\x26 defined(__ATOMIC_RELAXED)                  \x5c\x0a"
"                       \x26\x26 defined(__ATOMIC_ACQ_REL)\x0a"
"#   define _LIBCPP_HAS_BUILTIN_ATOMIC_SUPPORT\x0a"
"#elif defined(_LIBCPP_COMPILER_GCC)\x0a"
"#   define _LIBCPP_HAS_BUILTIN_ATOMIC_SUPPORT\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _Tp\x0a"
"__libcpp_atomic_refcount_increment(_Tp\x26 __t) _NOEXCEPT\x0a"
"{\x0a"
"#if defined(_LIBCPP_HAS_BUILTIN_ATOMIC_SUPPORT) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_THREADS)\x0a"
"    return __atomic_add_fetch(\x26__t, 1, __ATOMIC_RELAXED);\x0a"
"#else\x0a"
"    return __t += 1;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _Tp\x0a"
"__libcpp_atomic_refcount_decrement(_Tp\x26 __t) _NOEXCEPT\x0a"
"{\x0a"
"#if defined(_LIBCPP_HAS_BUILTIN_ATOMIC_SUPPORT) \x26\x26 \x21""defined(_LIBCPP_HAS_NO_THREADS)\x0a"
"    return __atomic_add_fetch(\x26__t, -1, __ATOMIC_ACQ_REL);\x0a"
"#else\x0a"
"    return __t -= 1;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI bad_weak_ptr\x0a"
"    \x3a public std\x3a\x3a""exception\x0a"
"{\x0a"
"public\x3a\x0a"
"    virtual \x7e""bad_weak_ptr() _NOEXCEPT;\x0a"
"    virtual const char* what() const  _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_bad_weak_ptr()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw bad_weak_ptr();\x0a"
"#else\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template<class _Tp> class _LIBCPP_TEMPLATE_VIS weak_ptr;\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS __shared_count\x0a"
"{\x0a"
"    __shared_count(const __shared_count\x26);\x0a"
"    __shared_count\x26 operator=(const __shared_count\x26);\x0a"
"\x0a"
"protected\x3a\x0a"
"    long __shared_owners_;\x0a"
"    virtual \x7e__shared_count();\x0a"
"private\x3a\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT = 0;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __shared_count(long __refs = 0) _NOEXCEPT\x0a"
"        \x3a __shared_owners_(__refs) {}\x0a"
"\x0a"
"#if defined(_LIBCPP_BUILDING_LIBRARY) \x26\x26 \x5c\x0a"
"    defined(_LIBCPP_DEPRECATED_ABI_LEGACY_LIBRARY_DEFINITIONS_FOR_INLINE_FUNCTIONS)\x0a"
"    void __add_shared() _NOEXCEPT;\x0a"
"    bool __release_shared() _NOEXCEPT;\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __add_shared() _NOEXCEPT {\x0a"
"      __libcpp_atomic_refcount_increment(__shared_owners_);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool __release_shared() _NOEXCEPT {\x0a"
"      if (__libcpp_atomic_refcount_decrement(__shared_owners_) == -1) {\x0a"
"        __on_zero_shared();\x0a"
"        return true;\x0a"
"      }\x0a"
"      return false;\x0a"
"    }\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    long use_count() const _NOEXCEPT {\x0a"
"        return __libcpp_relaxed_load(\x26__shared_owners_) + 1;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS __shared_weak_count\x0a"
"    \x3a private __shared_count\x0a"
"{\x0a"
"    long __shared_weak_owners_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __shared_weak_count(long __refs = 0) _NOEXCEPT\x0a"
"        \x3a __shared_count(__refs),\x0a"
"          __shared_weak_owners_(__refs) {}\x0a"
"protected\x3a\x0a"
"    virtual \x7e__shared_weak_count();\x0a"
"\x0a"
"public\x3a\x0a"
"#if defined(_LIBCPP_BUILDING_LIBRARY) \x26\x26 \x5c\x0a"
"    defined(_LIBCPP_DEPRECATED_ABI_LEGACY_LIBRARY_DEFINITIONS_FOR_INLINE_FUNCTIONS)\x0a"
"    void __add_shared() _NOEXCEPT;\x0a"
"    void __add_weak() _NOEXCEPT;\x0a"
"    void __release_shared() _NOEXCEPT;\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __add_shared() _NOEXCEPT {\x0a"
"      __shared_count\x3a\x3a__add_shared();\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __add_weak() _NOEXCEPT {\x0a"
"      __libcpp_atomic_refcount_increment(__shared_weak_owners_);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __release_shared() _NOEXCEPT {\x0a"
"      if (__shared_count\x3a\x3a__release_shared())\x0a"
"        __release_weak();\x0a"
"    }\x0a"
"#endif\x0a"
"    void __release_weak() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    long use_count() const _NOEXCEPT {return __shared_count\x3a\x3ause_count();}\x0a"
"    __shared_weak_count* lock() _NOEXCEPT;\x0a"
"\x0a"
"    // Define the function out only if we build static libc++ without RTTI.\x0a"
"    // Otherwise we may break clients who need to compile their projects with\x0a"
"    // -fno-rtti and yet link against a libc++.dylib compiled\x0a"
"    // without -fno-rtti.\x0a"
"#if \x21""defined(_LIBCPP_NO_RTTI) \x7c\x7c \x21""defined(_LIBCPP_BUILD_STATIC)\x0a"
"    virtual const void* __get_deleter(const type_info\x26) const _NOEXCEPT;\x0a"
"#endif\x0a"
"private\x3a\x0a"
"    virtual void __on_zero_shared_weak() _NOEXCEPT = 0;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Dp, class _Alloc>\x0a"
"class __shared_ptr_pointer\x0a"
"    \x3a public __shared_weak_count\x0a"
"{\x0a"
"    __compressed_pair<__compressed_pair<_Tp, _Dp>, _Alloc> __data_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __shared_ptr_pointer(_Tp __p, _Dp __d, _Alloc __a)\x0a"
"        \x3a  __data_(__compressed_pair<_Tp, _Dp>(__p, _VSTD\x3a\x3amove(__d)), _VSTD\x3a\x3amove(__a)) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"    virtual const void* __get_deleter(const type_info\x26) const _NOEXCEPT;\x0a"
"#endif\x0a"
"\x0a"
"private\x3a\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT;\x0a"
"    virtual void __on_zero_shared_weak() _NOEXCEPT;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"\x0a"
"template <class _Tp, class _Dp, class _Alloc>\x0a"
"const void*\x0a"
"__shared_ptr_pointer<_Tp, _Dp, _Alloc>\x3a\x3a__get_deleter(const type_info\x26 __t) const _NOEXCEPT\x0a"
"{\x0a"
"    return __t == typeid(_Dp) \x3f _VSTD\x3a\x3a""addressof(__data_.first().second()) \x3a nullptr;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_NO_RTTI\x0a"
"\x0a"
"template <class _Tp, class _Dp, class _Alloc>\x0a"
"void\x0a"
"__shared_ptr_pointer<_Tp, _Dp, _Alloc>\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    __data_.first().second()(__data_.first().first());\x0a"
"    __data_.first().second().\x7e_Dp();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Dp, class _Alloc>\x0a"
"void\x0a"
"__shared_ptr_pointer<_Tp, _Dp, _Alloc>\x3a\x3a__on_zero_shared_weak() _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, __shared_ptr_pointer>\x3a\x3atype _Al;\x0a"
"    typedef allocator_traits<_Al> _ATraits;\x0a"
"    typedef pointer_traits<typename _ATraits\x3a\x3apointer> _PTraits;\x0a"
"\x0a"
"    _Al __a(__data_.second());\x0a"
"    __data_.second().\x7e_Alloc();\x0a"
"    __a.deallocate(_PTraits\x3a\x3apointer_to(*this), 1);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"class __shared_ptr_emplace\x0a"
"    \x3a public __shared_weak_count\x0a"
"{\x0a"
"    __compressed_pair<_Alloc, _Tp> __data_;\x0a"
"public\x3a\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __shared_ptr_emplace(_Alloc __a)\x0a"
"        \x3a  __data_(_VSTD\x3a\x3amove(__a)) {}\x0a"
"\x0a"
"    template <class ..._Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __shared_ptr_emplace(_Alloc __a, _Args\x26\x26 ...__args)\x0a"
"            \x3a  __data_(piecewise_construct, _VSTD\x3a\x3a""forward_as_tuple(__a),\x0a"
"                   _VSTD\x3a\x3a""forward_as_tuple(_VSTD\x3a\x3a""forward<_Args>(__args)...)) {}\x0a"
"\x0a"
"#else  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __shared_ptr_emplace(_Alloc __a)\x0a"
"        \x3a  __data_(__a) {}\x0a"
"\x0a"
"    template <class _A0>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __shared_ptr_emplace(_Alloc __a, _A0\x26 __a0)\x0a"
"            \x3a  __data_(__a, _Tp(__a0)) {}\x0a"
"\x0a"
"    template <class _A0, class _A1>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __shared_ptr_emplace(_Alloc __a, _A0\x26 __a0, _A1\x26 __a1)\x0a"
"            \x3a  __data_(__a, _Tp(__a0, __a1)) {}\x0a"
"\x0a"
"    template <class _A0, class _A1, class _A2>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        __shared_ptr_emplace(_Alloc __a, _A0\x26 __a0, _A1\x26 __a1, _A2\x26 __a2)\x0a"
"            \x3a  __data_(__a, _Tp(__a0, __a1, __a2)) {}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"private\x3a\x0a"
"    virtual void __on_zero_shared() _NOEXCEPT;\x0a"
"    virtual void __on_zero_shared_weak() _NOEXCEPT;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp* get() _NOEXCEPT {return _VSTD\x3a\x3a""addressof(__data_.second());}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"__shared_ptr_emplace<_Tp, _Alloc>\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    __data_.second().\x7e_Tp();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Alloc>\x0a"
"void\x0a"
"__shared_ptr_emplace<_Tp, _Alloc>\x3a\x3a__on_zero_shared_weak() _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, __shared_ptr_emplace>\x3a\x3atype _Al;\x0a"
"    typedef allocator_traits<_Al> _ATraits;\x0a"
"    typedef pointer_traits<typename _ATraits\x3a\x3apointer> _PTraits;\x0a"
"    _Al __a(__data_.first());\x0a"
"    __data_.first().\x7e_Alloc();\x0a"
"    __a.deallocate(_PTraits\x3a\x3apointer_to(*this), 1);\x0a"
"}\x0a"
"\x0a"
"struct __shared_ptr_dummy_rebind_allocator_type;\x0a"
"template <>\x0a"
"class _LIBCPP_TEMPLATE_VIS allocator<__shared_ptr_dummy_rebind_allocator_type>\x0a"
"{\x0a"
"public\x3a\x0a"
"    template <class _Other>\x0a"
"    struct rebind\x0a"
"    {\x0a"
"        typedef allocator<_Other> other;\x0a"
"    };\x0a"
"};\x0a"
"\x0a"
"template<class _Tp> class _LIBCPP_TEMPLATE_VIS enable_shared_from_this;\x0a"
"\x0a"
"template<class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS shared_ptr\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp element_type;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    typedef weak_ptr<_Tp> weak_type;\x0a"
"#endif\x0a"
"private\x3a\x0a"
"    element_type*      __ptr_;\x0a"
"    __shared_weak_count* __cntrl_;\x0a"
"\x0a"
"    struct __nat {int __for_bool_;};\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR shared_ptr() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR shared_ptr(nullptr_t) _NOEXCEPT;\x0a"
"    template<class _Yp>\x0a"
"        explicit shared_ptr(_Yp* __p,\x0a"
"                            typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype = __nat());\x0a"
"    template<class _Yp, class _Dp>\x0a"
"        shared_ptr(_Yp* __p, _Dp __d,\x0a"
"                   typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype = __nat());\x0a"
"    template<class _Yp, class _Dp, class _Alloc>\x0a"
"        shared_ptr(_Yp* __p, _Dp __d, _Alloc __a,\x0a"
"                   typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype = __nat());\x0a"
"    template <class _Dp> shared_ptr(nullptr_t __p, _Dp __d);\x0a"
"    template <class _Dp, class _Alloc> shared_ptr(nullptr_t __p, _Dp __d, _Alloc __a);\x0a"
"    template<class _Yp> _LIBCPP_INLINE_VISIBILITY shared_ptr(const shared_ptr<_Yp>\x26 __r, element_type* __p) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_ptr(const shared_ptr\x26 __r) _NOEXCEPT;\x0a"
"    template<class _Yp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        shared_ptr(const shared_ptr<_Yp>\x26 __r,\x0a"
"                   typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype = __nat())\x0a"
"                       _NOEXCEPT;\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_ptr(shared_ptr\x26\x26 __r) _NOEXCEPT;\x0a"
"    template<class _Yp> _LIBCPP_INLINE_VISIBILITY  shared_ptr(shared_ptr<_Yp>\x26\x26 __r,\x0a"
"                   typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype = __nat())\x0a"
"                       _NOEXCEPT;\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    template<class _Yp> explicit shared_ptr(const weak_ptr<_Yp>\x26 __r,\x0a"
"                   typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype= __nat());\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR)\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    template<class _Yp>\x0a"
"        shared_ptr(auto_ptr<_Yp>\x26\x26 __r,\x0a"
"                   typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype = __nat());\x0a"
"#else\x0a"
"    template<class _Yp>\x0a"
"        shared_ptr(auto_ptr<_Yp> __r,\x0a"
"                   typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype = __nat());\x0a"
"#endif\x0a"
"#endif\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    template <class _Yp, class _Dp>\x0a"
"        shared_ptr(unique_ptr<_Yp, _Dp>\x26\x26,\x0a"
"                   typename enable_if\x0a"
"                   <\x0a"
"                       \x21is_lvalue_reference<_Dp>\x3a\x3avalue \x26\x26\x0a"
"                       \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"                       is_convertible<typename unique_ptr<_Yp, _Dp>\x3a\x3apointer, element_type*>\x3a\x3avalue,\x0a"
"                       __nat\x0a"
"                   >\x3a\x3atype = __nat());\x0a"
"    template <class _Yp, class _Dp>\x0a"
"        shared_ptr(unique_ptr<_Yp, _Dp>\x26\x26,\x0a"
"                   typename enable_if\x0a"
"                   <\x0a"
"                       is_lvalue_reference<_Dp>\x3a\x3avalue \x26\x26\x0a"
"                       \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"                       is_convertible<typename unique_ptr<_Yp, _Dp>\x3a\x3apointer, element_type*>\x3a\x3avalue,\x0a"
"                       __nat\x0a"
"                   >\x3a\x3atype = __nat());\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    template <class _Yp, class _Dp>\x0a"
"        shared_ptr(unique_ptr<_Yp, _Dp>,\x0a"
"                   typename enable_if\x0a"
"                   <\x0a"
"                       \x21is_lvalue_reference<_Dp>\x3a\x3avalue \x26\x26\x0a"
"                       \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"                       is_convertible<typename unique_ptr<_Yp, _Dp>\x3a\x3apointer, element_type*>\x3a\x3avalue,\x0a"
"                       __nat\x0a"
"                   >\x3a\x3atype = __nat());\x0a"
"    template <class _Yp, class _Dp>\x0a"
"        shared_ptr(unique_ptr<_Yp, _Dp>,\x0a"
"                   typename enable_if\x0a"
"                   <\x0a"
"                       is_lvalue_reference<_Dp>\x3a\x3avalue \x26\x26\x0a"
"                       \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"                       is_convertible<typename unique_ptr<_Yp, _Dp>\x3a\x3apointer, element_type*>\x3a\x3avalue,\x0a"
"                       __nat\x0a"
"                   >\x3a\x3atype = __nat());\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"    \x7eshared_ptr();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_ptr\x26 operator=(const shared_ptr\x26 __r) _NOEXCEPT;\x0a"
"    template<class _Yp>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<_Yp*, element_type*>\x3a\x3avalue,\x0a"
"            shared_ptr\x26\x0a"
"        >\x3a\x3atype\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        operator=(const shared_ptr<_Yp>\x26 __r) _NOEXCEPT;\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_ptr\x26 operator=(shared_ptr\x26\x26 __r) _NOEXCEPT;\x0a"
"    template<class _Yp>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<_Yp*, element_type*>\x3a\x3avalue,\x0a"
"            shared_ptr<_Tp>\x26\x0a"
"        >\x3a\x3atype\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        operator=(shared_ptr<_Yp>\x26\x26 __r);\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR)\x0a"
"    template<class _Yp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"            is_convertible<_Yp*, element_type*>\x3a\x3avalue,\x0a"
"            shared_ptr\x0a"
"        >\x3a\x3atype\x26\x0a"
"        operator=(auto_ptr<_Yp>\x26\x26 __r);\x0a"
"#endif\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR)\x0a"
"    template<class _Yp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"            is_convertible<_Yp*, element_type*>\x3a\x3avalue,\x0a"
"            shared_ptr\x26\x0a"
"        >\x3a\x3atype\x0a"
"        operator=(auto_ptr<_Yp> __r);\x0a"
"#endif\x0a"
"#endif\x0a"
"    template <class _Yp, class _Dp>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"            is_convertible<typename unique_ptr<_Yp, _Dp>\x3a\x3apointer, element_type*>\x3a\x3avalue,\x0a"
"            shared_ptr\x26\x0a"
"        >\x3a\x3atype\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        operator=(unique_ptr<_Yp, _Dp>\x26\x26 __r);\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        operator=(unique_ptr<_Yp, _Dp> __r);\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(shared_ptr\x26 __r) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() _NOEXCEPT;\x0a"
"    template<class _Yp>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<_Yp*, element_type*>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        reset(_Yp* __p);\x0a"
"    template<class _Yp, class _Dp>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<_Yp*, element_type*>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        reset(_Yp* __p, _Dp __d);\x0a"
"    template<class _Yp, class _Dp, class _Alloc>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<_Yp*, element_type*>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        reset(_Yp* __p, _Dp __d, _Alloc __a);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    element_type* get() const _NOEXCEPT {return __ptr_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    typename add_lvalue_reference<element_type>\x3a\x3atype operator*() const _NOEXCEPT\x0a"
"        {return *__ptr_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    element_type* operator->() const _NOEXCEPT {return __ptr_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    long use_count() const _NOEXCEPT {return __cntrl_ \x3f __cntrl_->use_count() \x3a 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool unique() const _NOEXCEPT {return use_count() == 1;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_EXPLICIT operator bool() const _NOEXCEPT {return get() \x21= 0;}\x0a"
"    template <class _Up>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool owner_before(shared_ptr<_Up> const\x26 __p) const _NOEXCEPT\x0a"
"        {return __cntrl_ < __p.__cntrl_;}\x0a"
"    template <class _Up>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool owner_before(weak_ptr<_Up> const\x26 __p) const _NOEXCEPT\x0a"
"        {return __cntrl_ < __p.__cntrl_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool\x0a"
"    __owner_equivalent(const shared_ptr\x26 __p) const\x0a"
"        {return __cntrl_ == __p.__cntrl_;}\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"    template <class _Dp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        _Dp* __get_deleter() const _NOEXCEPT\x0a"
"            {return static_cast<_Dp*>(__cntrl_\x0a"
"                    \x3f const_cast<void *>(__cntrl_->__get_deleter(typeid(_Dp)))\x0a"
"                      \x3a nullptr);}\x0a"
"#endif  // _LIBCPP_NO_RTTI\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"    template<class ..._Args>\x0a"
"        static\x0a"
"        shared_ptr<_Tp>\x0a"
"        make_shared(_Args\x26\x26 ...__args);\x0a"
"\x0a"
"    template<class _Alloc, class ..._Args>\x0a"
"        static\x0a"
"        shared_ptr<_Tp>\x0a"
"        allocate_shared(const _Alloc\x26 __a, _Args\x26\x26 ...__args);\x0a"
"\x0a"
"#else  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"    static shared_ptr<_Tp> make_shared();\x0a"
"\x0a"
"    template<class _A0>\x0a"
"        static shared_ptr<_Tp> make_shared(_A0\x26);\x0a"
"\x0a"
"    template<class _A0, class _A1>\x0a"
"        static shared_ptr<_Tp> make_shared(_A0\x26, _A1\x26);\x0a"
"\x0a"
"    template<class _A0, class _A1, class _A2>\x0a"
"        static shared_ptr<_Tp> make_shared(_A0\x26, _A1\x26, _A2\x26);\x0a"
"\x0a"
"    template<class _Alloc>\x0a"
"        static shared_ptr<_Tp>\x0a"
"        allocate_shared(const _Alloc\x26 __a);\x0a"
"\x0a"
"    template<class _Alloc, class _A0>\x0a"
"        static shared_ptr<_Tp>\x0a"
"        allocate_shared(const _Alloc\x26 __a, _A0\x26 __a0);\x0a"
"\x0a"
"    template<class _Alloc, class _A0, class _A1>\x0a"
"        static shared_ptr<_Tp>\x0a"
"        allocate_shared(const _Alloc\x26 __a, _A0\x26 __a0, _A1\x26 __a1);\x0a"
"\x0a"
"    template<class _Alloc, class _A0, class _A1, class _A2>\x0a"
"        static shared_ptr<_Tp>\x0a"
"        allocate_shared(const _Alloc\x26 __a, _A0\x26 __a0, _A1\x26 __a1, _A2\x26 __a2);\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"private\x3a\x0a"
"    template <class _Yp, bool = is_function<_Yp>\x3a\x3avalue>\x0a"
"        struct __shared_ptr_default_allocator\x0a"
"        {\x0a"
"            typedef allocator<_Yp> type;\x0a"
"        };\x0a"
"\x0a"
"    template <class _Yp>\x0a"
"        struct __shared_ptr_default_allocator<_Yp, true>\x0a"
"        {\x0a"
"            typedef allocator<__shared_ptr_dummy_rebind_allocator_type> type;\x0a"
"        };\x0a"
"\x0a"
"    template <class _Yp, class _OrigPtr>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if<is_convertible<_OrigPtr*,\x0a"
"                                          const enable_shared_from_this<_Yp>*\x0a"
"        >\x3a\x3avalue,\x0a"
"            void>\x3a\x3atype\x0a"
"        __enable_weak_this(const enable_shared_from_this<_Yp>* __e,\x0a"
"                           _OrigPtr* __ptr) _NOEXCEPT\x0a"
"        {\x0a"
"            typedef typename remove_cv<_Yp>\x3a\x3atype _RawYp;\x0a"
"            if (__e \x26\x26 __e->__weak_this_.expired())\x0a"
"            {\x0a"
"                __e->__weak_this_ = shared_ptr<_RawYp>(*this,\x0a"
"                    const_cast<_RawYp*>(static_cast<const _Yp*>(__ptr)));\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __enable_weak_this(...) _NOEXCEPT {}\x0a"
"\x0a"
"    template <class _Up> friend class _LIBCPP_TEMPLATE_VIS shared_ptr;\x0a"
"    template <class _Up> friend class _LIBCPP_TEMPLATE_VIS weak_ptr;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr() _NOEXCEPT\x0a"
"    \x3a __ptr_(0),\x0a"
"      __cntrl_(0)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(nullptr_t) _NOEXCEPT\x0a"
"    \x3a __ptr_(0),\x0a"
"      __cntrl_(0)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(_Yp* __p,\x0a"
"                            typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype)\x0a"
"    \x3a __ptr_(__p)\x0a"
"{\x0a"
"    unique_ptr<_Yp> __hold(__p);\x0a"
"    typedef typename __shared_ptr_default_allocator<_Yp>\x3a\x3atype _AllocT;\x0a"
"    typedef __shared_ptr_pointer<_Yp*, default_delete<_Yp>, _AllocT > _CntrlBlk;\x0a"
"    __cntrl_ = new _CntrlBlk(__p, default_delete<_Yp>(), _AllocT());\x0a"
"    __hold.release();\x0a"
"    __enable_weak_this(__p, __p);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp, class _Dp>\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(_Yp* __p, _Dp __d,\x0a"
"                            typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype)\x0a"
"    \x3a __ptr_(__p)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typedef typename __shared_ptr_default_allocator<_Yp>\x3a\x3atype _AllocT;\x0a"
"        typedef __shared_ptr_pointer<_Yp*, _Dp, _AllocT > _CntrlBlk;\x0a"
"        __cntrl_ = new _CntrlBlk(__p, __d, _AllocT());\x0a"
"        __enable_weak_this(__p, __p);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __d(__p);\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Dp>\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(nullptr_t __p, _Dp __d)\x0a"
"    \x3a __ptr_(0)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typedef typename __shared_ptr_default_allocator<_Tp>\x3a\x3atype _AllocT;\x0a"
"        typedef __shared_ptr_pointer<nullptr_t, _Dp, _AllocT > _CntrlBlk;\x0a"
"        __cntrl_ = new _CntrlBlk(__p, __d, _AllocT());\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __d(__p);\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp, class _Dp, class _Alloc>\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(_Yp* __p, _Dp __d, _Alloc __a,\x0a"
"                            typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype)\x0a"
"    \x3a __ptr_(__p)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typedef __shared_ptr_pointer<_Yp*, _Dp, _Alloc> _CntrlBlk;\x0a"
"        typedef typename __allocator_traits_rebind<_Alloc, _CntrlBlk>\x3a\x3atype _A2;\x0a"
"        typedef __allocator_destructor<_A2> _D2;\x0a"
"        _A2 __a2(__a);\x0a"
"        unique_ptr<_CntrlBlk, _D2> __hold2(__a2.allocate(1), _D2(__a2, 1));\x0a"
"        \x3a\x3anew(static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold2.get())))\x0a"
"            _CntrlBlk(__p, __d, __a);\x0a"
"        __cntrl_ = _VSTD\x3a\x3a""addressof(*__hold2.release());\x0a"
"        __enable_weak_this(__p, __p);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __d(__p);\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Dp, class _Alloc>\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(nullptr_t __p, _Dp __d, _Alloc __a)\x0a"
"    \x3a __ptr_(0)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        typedef __shared_ptr_pointer<nullptr_t, _Dp, _Alloc> _CntrlBlk;\x0a"
"        typedef typename __allocator_traits_rebind<_Alloc, _CntrlBlk>\x3a\x3atype _A2;\x0a"
"        typedef __allocator_destructor<_A2> _D2;\x0a"
"        _A2 __a2(__a);\x0a"
"        unique_ptr<_CntrlBlk, _D2> __hold2(__a2.allocate(1), _D2(__a2, 1));\x0a"
"        \x3a\x3anew(static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold2.get())))\x0a"
"            _CntrlBlk(__p, __d, __a);\x0a"
"        __cntrl_ = _VSTD\x3a\x3a""addressof(*__hold2.release());\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        __d(__p);\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(const shared_ptr<_Yp>\x26 __r, element_type *__p) _NOEXCEPT\x0a"
"    \x3a __ptr_(__p),\x0a"
"      __cntrl_(__r.__cntrl_)\x0a"
"{\x0a"
"    if (__cntrl_)\x0a"
"        __cntrl_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(const shared_ptr\x26 __r) _NOEXCEPT\x0a"
"    \x3a __ptr_(__r.__ptr_),\x0a"
"      __cntrl_(__r.__cntrl_)\x0a"
"{\x0a"
"    if (__cntrl_)\x0a"
"        __cntrl_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(const shared_ptr<_Yp>\x26 __r,\x0a"
"                            typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype)\x0a"
"         _NOEXCEPT\x0a"
"    \x3a __ptr_(__r.__ptr_),\x0a"
"      __cntrl_(__r.__cntrl_)\x0a"
"{\x0a"
"    if (__cntrl_)\x0a"
"        __cntrl_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(shared_ptr\x26\x26 __r) _NOEXCEPT\x0a"
"    \x3a __ptr_(__r.__ptr_),\x0a"
"      __cntrl_(__r.__cntrl_)\x0a"
"{\x0a"
"    __r.__ptr_ = 0;\x0a"
"    __r.__cntrl_ = 0;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(shared_ptr<_Yp>\x26\x26 __r,\x0a"
"                            typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype)\x0a"
"         _NOEXCEPT\x0a"
"    \x3a __ptr_(__r.__ptr_),\x0a"
"      __cntrl_(__r.__cntrl_)\x0a"
"{\x0a"
"    __r.__ptr_ = 0;\x0a"
"    __r.__cntrl_ = 0;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR)\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(auto_ptr<_Yp>\x26\x26 __r,\x0a"
"#else\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(auto_ptr<_Yp> __r,\x0a"
"#endif\x0a"
"                            typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype)\x0a"
"    \x3a __ptr_(__r.get())\x0a"
"{\x0a"
"    typedef __shared_ptr_pointer<_Yp*, default_delete<_Yp>, allocator<_Yp> > _CntrlBlk;\x0a"
"    __cntrl_ = new _CntrlBlk(__r.get(), default_delete<_Yp>(), allocator<_Yp>());\x0a"
"    __enable_weak_this(__r.get(), __r.get());\x0a"
"    __r.release();\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template <class _Yp, class _Dp>\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(unique_ptr<_Yp, _Dp>\x26\x26 __r,\x0a"
"#else\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(unique_ptr<_Yp, _Dp> __r,\x0a"
"#endif\x0a"
"                            typename enable_if\x0a"
"                            <\x0a"
"                                \x21is_lvalue_reference<_Dp>\x3a\x3avalue \x26\x26\x0a"
"                                \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"                                is_convertible<typename unique_ptr<_Yp, _Dp>\x3a\x3apointer, element_type*>\x3a\x3avalue,\x0a"
"                                __nat\x0a"
"                            >\x3a\x3atype)\x0a"
"    \x3a __ptr_(__r.get())\x0a"
"{\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    if (__ptr_ == nullptr)\x0a"
"        __cntrl_ = nullptr;\x0a"
"    else\x0a"
"#endif\x0a"
"    {\x0a"
"        typedef typename __shared_ptr_default_allocator<_Yp>\x3a\x3atype _AllocT;\x0a"
"        typedef __shared_ptr_pointer<_Yp*, _Dp, _AllocT > _CntrlBlk;\x0a"
"        __cntrl_ = new _CntrlBlk(__r.get(), __r.get_deleter(), _AllocT());\x0a"
"        __enable_weak_this(__r.get(), __r.get());\x0a"
"    }\x0a"
"    __r.release();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template <class _Yp, class _Dp>\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(unique_ptr<_Yp, _Dp>\x26\x26 __r,\x0a"
"#else\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(unique_ptr<_Yp, _Dp> __r,\x0a"
"#endif\x0a"
"                            typename enable_if\x0a"
"                            <\x0a"
"                                is_lvalue_reference<_Dp>\x3a\x3avalue \x26\x26\x0a"
"                                \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"                                is_convertible<typename unique_ptr<_Yp, _Dp>\x3a\x3apointer, element_type*>\x3a\x3avalue,\x0a"
"                                __nat\x0a"
"                            >\x3a\x3atype)\x0a"
"    \x3a __ptr_(__r.get())\x0a"
"{\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    if (__ptr_ == nullptr)\x0a"
"        __cntrl_ = nullptr;\x0a"
"    else\x0a"
"#endif\x0a"
"    {\x0a"
"        typedef typename __shared_ptr_default_allocator<_Yp>\x3a\x3atype _AllocT;\x0a"
"        typedef __shared_ptr_pointer<_Yp*,\x0a"
"                                     reference_wrapper<typename remove_reference<_Dp>\x3a\x3atype>,\x0a"
"                                     _AllocT > _CntrlBlk;\x0a"
"        __cntrl_ = new _CntrlBlk(__r.get(), ref(__r.get_deleter()), _AllocT());\x0a"
"        __enable_weak_this(__r.get(), __r.get());\x0a"
"    }\x0a"
"    __r.release();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class ..._Args>\x0a"
"shared_ptr<_Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3amake_shared(_Args\x26\x26 ...__args)\x0a"
"{\x0a"
"    static_assert( is_constructible<_Tp, _Args...>\x3a\x3avalue, \x22""Can't construct object in make_shared\x22 );\x0a"
"    typedef __shared_ptr_emplace<_Tp, allocator<_Tp> > _CntrlBlk;\x0a"
"    typedef allocator<_CntrlBlk> _A2;\x0a"
"    typedef __allocator_destructor<_A2> _D2;\x0a"
"    _A2 __a2;\x0a"
"    unique_ptr<_CntrlBlk, _D2> __hold2(__a2.allocate(1), _D2(__a2, 1));\x0a"
"    \x3a\x3anew(__hold2.get()) _CntrlBlk(__a2, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__ptr_ = __hold2.get()->get();\x0a"
"    __r.__cntrl_ = __hold2.release();\x0a"
"    __r.__enable_weak_this(__r.__ptr_, __r.__ptr_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Alloc, class ..._Args>\x0a"
"shared_ptr<_Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3a""allocate_shared(const _Alloc\x26 __a, _Args\x26\x26 ...__args)\x0a"
"{\x0a"
"    static_assert( is_constructible<_Tp, _Args...>\x3a\x3avalue, \x22""Can't construct object in allocate_shared\x22 );\x0a"
"    typedef __shared_ptr_emplace<_Tp, _Alloc> _CntrlBlk;\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, _CntrlBlk>\x3a\x3atype _A2;\x0a"
"    typedef __allocator_destructor<_A2> _D2;\x0a"
"    _A2 __a2(__a);\x0a"
"    unique_ptr<_CntrlBlk, _D2> __hold2(__a2.allocate(1), _D2(__a2, 1));\x0a"
"    \x3a\x3anew(static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold2.get())))\x0a"
"        _CntrlBlk(__a, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__ptr_ = __hold2.get()->get();\x0a"
"    __r.__cntrl_ = _VSTD\x3a\x3a""addressof(*__hold2.release());\x0a"
"    __r.__enable_weak_this(__r.__ptr_, __r.__ptr_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"#else  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template<class _Tp>\x0a"
"shared_ptr<_Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3amake_shared()\x0a"
"{\x0a"
"    static_assert((is_constructible<_Tp>\x3a\x3avalue), \x22""Can't construct object in make_shared\x22 );\x0a"
"    typedef __shared_ptr_emplace<_Tp, allocator<_Tp> > _CntrlBlk;\x0a"
"    typedef allocator<_CntrlBlk> _Alloc2;\x0a"
"    typedef __allocator_destructor<_Alloc2> _D2;\x0a"
"    _Alloc2 __alloc2;\x0a"
"    unique_ptr<_CntrlBlk, _D2> __hold2(__alloc2.allocate(1), _D2(__alloc2, 1));\x0a"
"    \x3a\x3anew(__hold2.get()) _CntrlBlk(__alloc2);\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__ptr_ = __hold2.get()->get();\x0a"
"    __r.__cntrl_ = __hold2.release();\x0a"
"    __r.__enable_weak_this(__r.__ptr_, __r.__ptr_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _A0>\x0a"
"shared_ptr<_Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3amake_shared(_A0\x26 __a0)\x0a"
"{\x0a"
"    static_assert((is_constructible<_Tp, _A0>\x3a\x3avalue), \x22""Can't construct object in make_shared\x22 );\x0a"
"    typedef __shared_ptr_emplace<_Tp, allocator<_Tp> > _CntrlBlk;\x0a"
"    typedef allocator<_CntrlBlk> _Alloc2;\x0a"
"    typedef __allocator_destructor<_Alloc2> _D2;\x0a"
"    _Alloc2 __alloc2;\x0a"
"    unique_ptr<_CntrlBlk, _D2> __hold2(__alloc2.allocate(1), _D2(__alloc2, 1));\x0a"
"    \x3a\x3anew(__hold2.get()) _CntrlBlk(__alloc2, __a0);\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__ptr_ = __hold2.get()->get();\x0a"
"    __r.__cntrl_ = __hold2.release();\x0a"
"    __r.__enable_weak_this(__r.__ptr_, __r.__ptr_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _A0, class _A1>\x0a"
"shared_ptr<_Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3amake_shared(_A0\x26 __a0, _A1\x26 __a1)\x0a"
"{\x0a"
"    static_assert((is_constructible<_Tp, _A0, _A1>\x3a\x3avalue), \x22""Can't construct object in make_shared\x22 );\x0a"
"    typedef __shared_ptr_emplace<_Tp, allocator<_Tp> > _CntrlBlk;\x0a"
"    typedef allocator<_CntrlBlk> _Alloc2;\x0a"
"    typedef __allocator_destructor<_Alloc2> _D2;\x0a"
"    _Alloc2 __alloc2;\x0a"
"    unique_ptr<_CntrlBlk, _D2> __hold2(__alloc2.allocate(1), _D2(__alloc2, 1));\x0a"
"    \x3a\x3anew(__hold2.get()) _CntrlBlk(__alloc2, __a0, __a1);\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__ptr_ = __hold2.get()->get();\x0a"
"    __r.__cntrl_ = __hold2.release();\x0a"
"    __r.__enable_weak_this(__r.__ptr_, __r.__ptr_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _A0, class _A1, class _A2>\x0a"
"shared_ptr<_Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3amake_shared(_A0\x26 __a0, _A1\x26 __a1, _A2\x26 __a2)\x0a"
"{\x0a"
"    static_assert((is_constructible<_Tp, _A0, _A1, _A2>\x3a\x3avalue), \x22""Can't construct object in make_shared\x22 );\x0a"
"    typedef __shared_ptr_emplace<_Tp, allocator<_Tp> > _CntrlBlk;\x0a"
"    typedef allocator<_CntrlBlk> _Alloc2;\x0a"
"    typedef __allocator_destructor<_Alloc2> _D2;\x0a"
"    _Alloc2 __alloc2;\x0a"
"    unique_ptr<_CntrlBlk, _D2> __hold2(__alloc2.allocate(1), _D2(__alloc2, 1));\x0a"
"    \x3a\x3anew(__hold2.get()) _CntrlBlk(__alloc2, __a0, __a1, __a2);\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__ptr_ = __hold2.get()->get();\x0a"
"    __r.__cntrl_ = __hold2.release();\x0a"
"    __r.__enable_weak_this(__r.__ptr_, __r.__ptr_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Alloc>\x0a"
"shared_ptr<_Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3a""allocate_shared(const _Alloc\x26 __a)\x0a"
"{\x0a"
"    static_assert((is_constructible<_Tp>\x3a\x3avalue), \x22""Can't construct object in allocate_shared\x22 );\x0a"
"    typedef __shared_ptr_emplace<_Tp, _Alloc> _CntrlBlk;\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, _CntrlBlk>\x3a\x3atype _Alloc2;\x0a"
"    typedef __allocator_destructor<_Alloc2> _D2;\x0a"
"    _Alloc2 __alloc2(__a);\x0a"
"    unique_ptr<_CntrlBlk, _D2> __hold2(__alloc2.allocate(1), _D2(__alloc2, 1));\x0a"
"    \x3a\x3anew(static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold2.get())))\x0a"
"        _CntrlBlk(__a);\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__ptr_ = __hold2.get()->get();\x0a"
"    __r.__cntrl_ = _VSTD\x3a\x3a""addressof(*__hold2.release());\x0a"
"    __r.__enable_weak_this(__r.__ptr_, __r.__ptr_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Alloc, class _A0>\x0a"
"shared_ptr<_Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3a""allocate_shared(const _Alloc\x26 __a, _A0\x26 __a0)\x0a"
"{\x0a"
"    static_assert((is_constructible<_Tp, _A0>\x3a\x3avalue), \x22""Can't construct object in allocate_shared\x22 );\x0a"
"    typedef __shared_ptr_emplace<_Tp, _Alloc> _CntrlBlk;\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, _CntrlBlk>\x3a\x3atype _Alloc2;\x0a"
"    typedef __allocator_destructor<_Alloc2> _D2;\x0a"
"    _Alloc2 __alloc2(__a);\x0a"
"    unique_ptr<_CntrlBlk, _D2> __hold2(__alloc2.allocate(1), _D2(__alloc2, 1));\x0a"
"    \x3a\x3anew(static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold2.get())))\x0a"
"        _CntrlBlk(__a, __a0);\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__ptr_ = __hold2.get()->get();\x0a"
"    __r.__cntrl_ = _VSTD\x3a\x3a""addressof(*__hold2.release());\x0a"
"    __r.__enable_weak_this(__r.__ptr_, __r.__ptr_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Alloc, class _A0, class _A1>\x0a"
"shared_ptr<_Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3a""allocate_shared(const _Alloc\x26 __a, _A0\x26 __a0, _A1\x26 __a1)\x0a"
"{\x0a"
"    static_assert((is_constructible<_Tp, _A0, _A1>\x3a\x3avalue), \x22""Can't construct object in allocate_shared\x22 );\x0a"
"    typedef __shared_ptr_emplace<_Tp, _Alloc> _CntrlBlk;\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, _CntrlBlk>\x3a\x3atype _Alloc2;\x0a"
"    typedef __allocator_destructor<_Alloc2> _D2;\x0a"
"    _Alloc2 __alloc2(__a);\x0a"
"    unique_ptr<_CntrlBlk, _D2> __hold2(__alloc2.allocate(1), _D2(__alloc2, 1));\x0a"
"    \x3a\x3anew(static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold2.get())))\x0a"
"        _CntrlBlk(__a, __a0, __a1);\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__ptr_ = __hold2.get()->get();\x0a"
"    __r.__cntrl_ = _VSTD\x3a\x3a""addressof(*__hold2.release());\x0a"
"    __r.__enable_weak_this(__r.__ptr_, __r.__ptr_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Alloc, class _A0, class _A1, class _A2>\x0a"
"shared_ptr<_Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3a""allocate_shared(const _Alloc\x26 __a, _A0\x26 __a0, _A1\x26 __a1, _A2\x26 __a2)\x0a"
"{\x0a"
"    static_assert((is_constructible<_Tp, _A0, _A1, _A2>\x3a\x3avalue), \x22""Can't construct object in allocate_shared\x22 );\x0a"
"    typedef __shared_ptr_emplace<_Tp, _Alloc> _CntrlBlk;\x0a"
"    typedef typename __allocator_traits_rebind<_Alloc, _CntrlBlk>\x3a\x3atype _Alloc2;\x0a"
"    typedef __allocator_destructor<_Alloc2> _D2;\x0a"
"    _Alloc2 __alloc2(__a);\x0a"
"    unique_ptr<_CntrlBlk, _D2> __hold2(__alloc2.allocate(1), _D2(__alloc2, 1));\x0a"
"    \x3a\x3anew(static_cast<void*>(_VSTD\x3a\x3a""addressof(*__hold2.get())))\x0a"
"        _CntrlBlk(__a, __a0, __a1, __a2);\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__ptr_ = __hold2.get()->get();\x0a"
"    __r.__cntrl_ = _VSTD\x3a\x3a""addressof(*__hold2.release());\x0a"
"    __r.__enable_weak_this(__r.__ptr_, __r.__ptr_);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template<class _Tp>\x0a"
"shared_ptr<_Tp>\x3a\x3a\x7eshared_ptr()\x0a"
"{\x0a"
"    if (__cntrl_)\x0a"
"        __cntrl_->__release_shared();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"shared_ptr<_Tp>\x26\x0a"
"shared_ptr<_Tp>\x3a\x3aoperator=(const shared_ptr\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    shared_ptr(__r).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_convertible<_Yp*, typename shared_ptr<_Tp>\x3a\x3a""element_type*>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"shared_ptr<_Tp>\x3a\x3aoperator=(const shared_ptr<_Yp>\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    shared_ptr(__r).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"shared_ptr<_Tp>\x26\x0a"
"shared_ptr<_Tp>\x3a\x3aoperator=(shared_ptr\x26\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    shared_ptr(_VSTD\x3a\x3amove(__r)).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_convertible<_Yp*, typename shared_ptr<_Tp>\x3a\x3a""element_type*>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"shared_ptr<_Tp>\x3a\x3aoperator=(shared_ptr<_Yp>\x26\x26 __r)\x0a"
"{\x0a"
"    shared_ptr(_VSTD\x3a\x3amove(__r)).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR)\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"    is_convertible<_Yp*, typename shared_ptr<_Tp>\x3a\x3a""element_type*>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x0a"
">\x3a\x3atype\x26\x0a"
"shared_ptr<_Tp>\x3a\x3aoperator=(auto_ptr<_Yp>\x26\x26 __r)\x0a"
"{\x0a"
"    shared_ptr(_VSTD\x3a\x3amove(__r)).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template <class _Yp, class _Dp>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"    is_convertible<typename unique_ptr<_Yp, _Dp>\x3a\x3apointer,\x0a"
"                   typename shared_ptr<_Tp>\x3a\x3a""element_type*>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"shared_ptr<_Tp>\x3a\x3aoperator=(unique_ptr<_Yp, _Dp>\x26\x26 __r)\x0a"
"{\x0a"
"    shared_ptr(_VSTD\x3a\x3amove(__r)).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#else  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"#if _LIBCPP_STD_VER <= 14 \x7c\x7c defined(_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR)\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"    is_convertible<_Yp*, typename shared_ptr<_Tp>\x3a\x3a""element_type*>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"shared_ptr<_Tp>\x3a\x3aoperator=(auto_ptr<_Yp> __r)\x0a"
"{\x0a"
"    shared_ptr(__r).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template <class _Yp, class _Dp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_array<_Yp>\x3a\x3avalue \x26\x26\x0a"
"    is_convertible<typename unique_ptr<_Yp, _Dp>\x3a\x3apointer,\x0a"
"                   typename shared_ptr<_Tp>\x3a\x3a""element_type*>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"shared_ptr<_Tp>\x3a\x3aoperator=(unique_ptr<_Yp, _Dp> __r)\x0a"
"{\x0a"
"    shared_ptr(_VSTD\x3a\x3amove(__r)).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"void\x0a"
"shared_ptr<_Tp>\x3a\x3aswap(shared_ptr\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    _VSTD\x3a\x3aswap(__ptr_, __r.__ptr_);\x0a"
"    _VSTD\x3a\x3aswap(__cntrl_, __r.__cntrl_);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"void\x0a"
"shared_ptr<_Tp>\x3a\x3areset() _NOEXCEPT\x0a"
"{\x0a"
"    shared_ptr().swap(*this);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_convertible<_Yp*, typename shared_ptr<_Tp>\x3a\x3a""element_type*>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"shared_ptr<_Tp>\x3a\x3areset(_Yp* __p)\x0a"
"{\x0a"
"    shared_ptr(__p).swap(*this);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp, class _Dp>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_convertible<_Yp*, typename shared_ptr<_Tp>\x3a\x3a""element_type*>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"shared_ptr<_Tp>\x3a\x3areset(_Yp* __p, _Dp __d)\x0a"
"{\x0a"
"    shared_ptr(__p, __d).swap(*this);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp, class _Dp, class _Alloc>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_convertible<_Yp*, typename shared_ptr<_Tp>\x3a\x3a""element_type*>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"shared_ptr<_Tp>\x3a\x3areset(_Yp* __p, _Dp __d, _Alloc __a)\x0a"
"{\x0a"
"    shared_ptr(__p, __d, __a).swap(*this);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template<class _Tp, class ..._Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_array<_Tp>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x0a"
">\x3a\x3atype\x0a"
"make_shared(_Args\x26\x26 ...__args)\x0a"
"{\x0a"
"    return shared_ptr<_Tp>\x3a\x3amake_shared(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Alloc, class ..._Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_array<_Tp>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x0a"
">\x3a\x3atype\x0a"
"allocate_shared(const _Alloc\x26 __a, _Args\x26\x26 ...__args)\x0a"
"{\x0a"
"    return shared_ptr<_Tp>\x3a\x3a""allocate_shared(__a, _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"}\x0a"
"\x0a"
"#else  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"shared_ptr<_Tp>\x0a"
"make_shared()\x0a"
"{\x0a"
"    return shared_ptr<_Tp>\x3a\x3amake_shared();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _A0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"shared_ptr<_Tp>\x0a"
"make_shared(_A0\x26 __a0)\x0a"
"{\x0a"
"    return shared_ptr<_Tp>\x3a\x3amake_shared(__a0);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _A0, class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"shared_ptr<_Tp>\x0a"
"make_shared(_A0\x26 __a0, _A1\x26 __a1)\x0a"
"{\x0a"
"    return shared_ptr<_Tp>\x3a\x3amake_shared(__a0, __a1);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _A0, class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"shared_ptr<_Tp>\x0a"
"make_shared(_A0\x26 __a0, _A1\x26 __a1, _A2\x26 __a2)\x0a"
"{\x0a"
"    return shared_ptr<_Tp>\x3a\x3amake_shared(__a0, __a1, __a2);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"shared_ptr<_Tp>\x0a"
"allocate_shared(const _Alloc\x26 __a)\x0a"
"{\x0a"
"    return shared_ptr<_Tp>\x3a\x3a""allocate_shared(__a);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Alloc, class _A0>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"shared_ptr<_Tp>\x0a"
"allocate_shared(const _Alloc\x26 __a, _A0\x26 __a0)\x0a"
"{\x0a"
"    return shared_ptr<_Tp>\x3a\x3a""allocate_shared(__a, __a0);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Alloc, class _A0, class _A1>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"shared_ptr<_Tp>\x0a"
"allocate_shared(const _Alloc\x26 __a, _A0\x26 __a0, _A1\x26 __a1)\x0a"
"{\x0a"
"    return shared_ptr<_Tp>\x3a\x3a""allocate_shared(__a, __a0, __a1);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Alloc, class _A0, class _A1, class _A2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"shared_ptr<_Tp>\x0a"
"allocate_shared(const _Alloc\x26 __a, _A0\x26 __a0, _A1\x26 __a1, _A2\x26 __a2)\x0a"
"{\x0a"
"    return shared_ptr<_Tp>\x3a\x3a""allocate_shared(__a, __a0, __a1, __a2);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const shared_ptr<_Tp>\x26 __x, const shared_ptr<_Up>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __x.get() == __y.get();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const shared_ptr<_Tp>\x26 __x, const shared_ptr<_Up>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(const shared_ptr<_Tp>\x26 __x, const shared_ptr<_Up>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"#if _LIBCPP_STD_VER <= 11\x0a"
"    typedef typename common_type<_Tp*, _Up*>\x3a\x3atype _Vp;\x0a"
"    return less<_Vp>()(__x.get(), __y.get());\x0a"
"#else\x0a"
"    return less<>()(__x.get(), __y.get());\x0a"
"#endif\x0a"
"\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(const shared_ptr<_Tp>\x26 __x, const shared_ptr<_Up>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const shared_ptr<_Tp>\x26 __x, const shared_ptr<_Up>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const shared_ptr<_Tp>\x26 __x, const shared_ptr<_Up>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const shared_ptr<_Tp>\x26 __x, nullptr_t) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21__x;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(nullptr_t, const shared_ptr<_Tp>\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21__x;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const shared_ptr<_Tp>\x26 __x, nullptr_t) _NOEXCEPT\x0a"
"{\x0a"
"    return static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(nullptr_t, const shared_ptr<_Tp>\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"    return static_cast<bool>(__x);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(const shared_ptr<_Tp>\x26 __x, nullptr_t) _NOEXCEPT\x0a"
"{\x0a"
"    return less<_Tp*>()(__x.get(), nullptr);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(nullptr_t, const shared_ptr<_Tp>\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"    return less<_Tp*>()(nullptr, __x.get());\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(const shared_ptr<_Tp>\x26 __x, nullptr_t) _NOEXCEPT\x0a"
"{\x0a"
"    return nullptr < __x;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(nullptr_t, const shared_ptr<_Tp>\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"    return __x < nullptr;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const shared_ptr<_Tp>\x26 __x, nullptr_t) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(nullptr < __x);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(nullptr_t, const shared_ptr<_Tp>\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__x < nullptr);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const shared_ptr<_Tp>\x26 __x, nullptr_t) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__x < nullptr);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(nullptr_t, const shared_ptr<_Tp>\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(nullptr < __x);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(shared_ptr<_Tp>\x26 __x, shared_ptr<_Tp>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_array<_Tp>\x3a\x3avalue \x26\x26 \x21is_array<_Up>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x0a"
">\x3a\x3atype\x0a"
"static_pointer_cast(const shared_ptr<_Up>\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    return shared_ptr<_Tp>(__r, static_cast<_Tp*>(__r.get()));\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    \x21is_array<_Tp>\x3a\x3avalue \x26\x26 \x21is_array<_Up>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x0a"
">\x3a\x3atype\x0a"
"dynamic_pointer_cast(const shared_ptr<_Up>\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    _Tp* __p = dynamic_cast<_Tp*>(__r.get());\x0a"
"    return __p \x3f shared_ptr<_Tp>(__r, __p) \x3a shared_ptr<_Tp>();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, class _Up>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_array<_Tp>\x3a\x3avalue == is_array<_Up>\x3a\x3avalue,\x0a"
"    shared_ptr<_Tp>\x0a"
">\x3a\x3atype\x0a"
"const_pointer_cast(const shared_ptr<_Up>\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    typedef typename remove_extent<_Tp>\x3a\x3atype _RTp;\x0a"
"    return shared_ptr<_Tp>(__r, const_cast<_RTp*>(__r.get()));\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_RTTI\x0a"
"\x0a"
"template<class _Dp, class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Dp*\x0a"
"get_deleter(const shared_ptr<_Tp>\x26 __p) _NOEXCEPT\x0a"
"{\x0a"
"    return __p.template __get_deleter<_Dp>();\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_NO_RTTI\x0a"
"\x0a"
"template<class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS weak_ptr\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp element_type;\x0a"
"private\x3a\x0a"
"    element_type*        __ptr_;\x0a"
"    __shared_weak_count* __cntrl_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR weak_ptr() _NOEXCEPT;\x0a"
"    template<class _Yp> _LIBCPP_INLINE_VISIBILITY weak_ptr(shared_ptr<_Yp> const\x26 __r,\x0a"
"                   typename enable_if<is_convertible<_Yp*, _Tp*>\x3a\x3avalue, __nat*>\x3a\x3atype = 0)\x0a"
"                        _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    weak_ptr(weak_ptr const\x26 __r) _NOEXCEPT;\x0a"
"    template<class _Yp> _LIBCPP_INLINE_VISIBILITY weak_ptr(weak_ptr<_Yp> const\x26 __r,\x0a"
"                   typename enable_if<is_convertible<_Yp*, _Tp*>\x3a\x3avalue, __nat*>\x3a\x3atype = 0)\x0a"
"                         _NOEXCEPT;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    weak_ptr(weak_ptr\x26\x26 __r) _NOEXCEPT;\x0a"
"    template<class _Yp> _LIBCPP_INLINE_VISIBILITY weak_ptr(weak_ptr<_Yp>\x26\x26 __r,\x0a"
"                   typename enable_if<is_convertible<_Yp*, _Tp*>\x3a\x3avalue, __nat*>\x3a\x3atype = 0)\x0a"
"                         _NOEXCEPT;\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"    \x7eweak_ptr();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    weak_ptr\x26 operator=(weak_ptr const\x26 __r) _NOEXCEPT;\x0a"
"    template<class _Yp>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<_Yp*, element_type*>\x3a\x3avalue,\x0a"
"            weak_ptr\x26\x0a"
"        >\x3a\x3atype\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        operator=(weak_ptr<_Yp> const\x26 __r) _NOEXCEPT;\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    weak_ptr\x26 operator=(weak_ptr\x26\x26 __r) _NOEXCEPT;\x0a"
"    template<class _Yp>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<_Yp*, element_type*>\x3a\x3avalue,\x0a"
"            weak_ptr\x26\x0a"
"        >\x3a\x3atype\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        operator=(weak_ptr<_Yp>\x26\x26 __r) _NOEXCEPT;\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"    template<class _Yp>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            is_convertible<_Yp*, element_type*>\x3a\x3avalue,\x0a"
"            weak_ptr\x26\x0a"
"        >\x3a\x3atype\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        operator=(shared_ptr<_Yp> const\x26 __r) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(weak_ptr\x26 __r) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    long use_count() const _NOEXCEPT\x0a"
"        {return __cntrl_ \x3f __cntrl_->use_count() \x3a 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool expired() const _NOEXCEPT\x0a"
"        {return __cntrl_ == 0 \x7c\x7c __cntrl_->use_count() == 0;}\x0a"
"    shared_ptr<_Tp> lock() const _NOEXCEPT;\x0a"
"    template<class _Up>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool owner_before(const shared_ptr<_Up>\x26 __r) const _NOEXCEPT\x0a"
"        {return __cntrl_ < __r.__cntrl_;}\x0a"
"    template<class _Up>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool owner_before(const weak_ptr<_Up>\x26 __r) const _NOEXCEPT\x0a"
"        {return __cntrl_ < __r.__cntrl_;}\x0a"
"\x0a"
"    template <class _Up> friend class _LIBCPP_TEMPLATE_VIS weak_ptr;\x0a"
"    template <class _Up> friend class _LIBCPP_TEMPLATE_VIS shared_ptr;\x0a"
"};\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"weak_ptr<_Tp>\x3a\x3aweak_ptr() _NOEXCEPT\x0a"
"    \x3a __ptr_(0),\x0a"
"      __cntrl_(0)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"weak_ptr<_Tp>\x3a\x3aweak_ptr(weak_ptr const\x26 __r) _NOEXCEPT\x0a"
"    \x3a __ptr_(__r.__ptr_),\x0a"
"      __cntrl_(__r.__cntrl_)\x0a"
"{\x0a"
"    if (__cntrl_)\x0a"
"        __cntrl_->__add_weak();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"weak_ptr<_Tp>\x3a\x3aweak_ptr(shared_ptr<_Yp> const\x26 __r,\x0a"
"                        typename enable_if<is_convertible<_Yp*, _Tp*>\x3a\x3avalue, __nat*>\x3a\x3atype)\x0a"
"                         _NOEXCEPT\x0a"
"    \x3a __ptr_(__r.__ptr_),\x0a"
"      __cntrl_(__r.__cntrl_)\x0a"
"{\x0a"
"    if (__cntrl_)\x0a"
"        __cntrl_->__add_weak();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"weak_ptr<_Tp>\x3a\x3aweak_ptr(weak_ptr<_Yp> const\x26 __r,\x0a"
"                        typename enable_if<is_convertible<_Yp*, _Tp*>\x3a\x3avalue, __nat*>\x3a\x3atype)\x0a"
"         _NOEXCEPT\x0a"
"    \x3a __ptr_(__r.__ptr_),\x0a"
"      __cntrl_(__r.__cntrl_)\x0a"
"{\x0a"
"    if (__cntrl_)\x0a"
"        __cntrl_->__add_weak();\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"weak_ptr<_Tp>\x3a\x3aweak_ptr(weak_ptr\x26\x26 __r) _NOEXCEPT\x0a"
"    \x3a __ptr_(__r.__ptr_),\x0a"
"      __cntrl_(__r.__cntrl_)\x0a"
"{\x0a"
"    __r.__ptr_ = 0;\x0a"
"    __r.__cntrl_ = 0;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"weak_ptr<_Tp>\x3a\x3aweak_ptr(weak_ptr<_Yp>\x26\x26 __r,\x0a"
"                        typename enable_if<is_convertible<_Yp*, _Tp*>\x3a\x3avalue, __nat*>\x3a\x3atype)\x0a"
"         _NOEXCEPT\x0a"
"    \x3a __ptr_(__r.__ptr_),\x0a"
"      __cntrl_(__r.__cntrl_)\x0a"
"{\x0a"
"    __r.__ptr_ = 0;\x0a"
"    __r.__cntrl_ = 0;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template<class _Tp>\x0a"
"weak_ptr<_Tp>\x3a\x3a\x7eweak_ptr()\x0a"
"{\x0a"
"    if (__cntrl_)\x0a"
"        __cntrl_->__release_weak();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"weak_ptr<_Tp>\x26\x0a"
"weak_ptr<_Tp>\x3a\x3aoperator=(weak_ptr const\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    weak_ptr(__r).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_convertible<_Yp*, _Tp*>\x3a\x3avalue,\x0a"
"    weak_ptr<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"weak_ptr<_Tp>\x3a\x3aoperator=(weak_ptr<_Yp> const\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    weak_ptr(__r).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"weak_ptr<_Tp>\x26\x0a"
"weak_ptr<_Tp>\x3a\x3aoperator=(weak_ptr\x26\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    weak_ptr(_VSTD\x3a\x3amove(__r)).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_convertible<_Yp*, _Tp*>\x3a\x3avalue,\x0a"
"    weak_ptr<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"weak_ptr<_Tp>\x3a\x3aoperator=(weak_ptr<_Yp>\x26\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    weak_ptr(_VSTD\x3a\x3amove(__r)).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_RVALUE_REFERENCES\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_convertible<_Yp*, _Tp*>\x3a\x3avalue,\x0a"
"    weak_ptr<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"weak_ptr<_Tp>\x3a\x3aoperator=(shared_ptr<_Yp> const\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    weak_ptr(__r).swap(*this);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"void\x0a"
"weak_ptr<_Tp>\x3a\x3aswap(weak_ptr\x26 __r) _NOEXCEPT\x0a"
"{\x0a"
"    _VSTD\x3a\x3aswap(__ptr_, __r.__ptr_);\x0a"
"    _VSTD\x3a\x3aswap(__cntrl_, __r.__cntrl_);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(weak_ptr<_Tp>\x26 __x, weak_ptr<_Tp>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline\x0a"
"void\x0a"
"weak_ptr<_Tp>\x3a\x3areset() _NOEXCEPT\x0a"
"{\x0a"
"    weak_ptr().swap(*this);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"template<class _Yp>\x0a"
"shared_ptr<_Tp>\x3a\x3ashared_ptr(const weak_ptr<_Yp>\x26 __r,\x0a"
"                            typename enable_if<is_convertible<_Yp*, element_type*>\x3a\x3avalue, __nat>\x3a\x3atype)\x0a"
"    \x3a __ptr_(__r.__ptr_),\x0a"
"      __cntrl_(__r.__cntrl_ \x3f __r.__cntrl_->lock() \x3a __r.__cntrl_)\x0a"
"{\x0a"
"    if (__cntrl_ == 0)\x0a"
"        __throw_bad_weak_ptr();\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"shared_ptr<_Tp>\x0a"
"weak_ptr<_Tp>\x3a\x3alock() const _NOEXCEPT\x0a"
"{\x0a"
"    shared_ptr<_Tp> __r;\x0a"
"    __r.__cntrl_ = __cntrl_ \x3f __cntrl_->lock() \x3a __cntrl_;\x0a"
"    if (__r.__cntrl_)\x0a"
"        __r.__ptr_ = __ptr_;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <class _Tp = void> struct owner_less;\x0a"
"#else\x0a"
"template <class _Tp> struct owner_less;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS owner_less<shared_ptr<_Tp> >\x0a"
"    \x3a binary_function<shared_ptr<_Tp>, shared_ptr<_Tp>, bool>\x0a"
"{\x0a"
"    typedef bool result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(shared_ptr<_Tp> const\x26 __x, shared_ptr<_Tp> const\x26 __y) const _NOEXCEPT\x0a"
"        {return __x.owner_before(__y);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(shared_ptr<_Tp> const\x26 __x,   weak_ptr<_Tp> const\x26 __y) const _NOEXCEPT\x0a"
"        {return __x.owner_before(__y);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(  weak_ptr<_Tp> const\x26 __x, shared_ptr<_Tp> const\x26 __y) const _NOEXCEPT\x0a"
"        {return __x.owner_before(__y);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS owner_less<weak_ptr<_Tp> >\x0a"
"    \x3a binary_function<weak_ptr<_Tp>, weak_ptr<_Tp>, bool>\x0a"
"{\x0a"
"    typedef bool result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(  weak_ptr<_Tp> const\x26 __x,   weak_ptr<_Tp> const\x26 __y) const _NOEXCEPT\x0a"
"        {return __x.owner_before(__y);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(shared_ptr<_Tp> const\x26 __x,   weak_ptr<_Tp> const\x26 __y) const _NOEXCEPT\x0a"
"        {return __x.owner_before(__y);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(  weak_ptr<_Tp> const\x26 __x, shared_ptr<_Tp> const\x26 __y) const _NOEXCEPT\x0a"
"        {return __x.owner_before(__y);}\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS owner_less<void>\x0a"
"{\x0a"
"    template <class _Tp, class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()( shared_ptr<_Tp> const\x26 __x, shared_ptr<_Up> const\x26 __y) const _NOEXCEPT\x0a"
"        {return __x.owner_before(__y);}\x0a"
"    template <class _Tp, class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()( shared_ptr<_Tp> const\x26 __x,   weak_ptr<_Up> const\x26 __y) const _NOEXCEPT\x0a"
"        {return __x.owner_before(__y);}\x0a"
"    template <class _Tp, class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(   weak_ptr<_Tp> const\x26 __x, shared_ptr<_Up> const\x26 __y) const _NOEXCEPT\x0a"
"        {return __x.owner_before(__y);}\x0a"
"    template <class _Tp, class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(   weak_ptr<_Tp> const\x26 __x,   weak_ptr<_Up> const\x26 __y) const _NOEXCEPT\x0a"
"        {return __x.owner_before(__y);}\x0a"
"    typedef void is_transparent;\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"template<class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS enable_shared_from_this\x0a"
"{\x0a"
"    mutable weak_ptr<_Tp> __weak_this_;\x0a"
"protected\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"    enable_shared_from_this() _NOEXCEPT {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    enable_shared_from_this(enable_shared_from_this const\x26) _NOEXCEPT {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    enable_shared_from_this\x26 operator=(enable_shared_from_this const\x26) _NOEXCEPT\x0a"
"        {return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7e""enable_shared_from_this() {}\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_ptr<_Tp> shared_from_this()\x0a"
"        {return shared_ptr<_Tp>(__weak_this_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shared_ptr<_Tp const> shared_from_this() const\x0a"
"        {return shared_ptr<const _Tp>(__weak_this_);}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    weak_ptr<_Tp> weak_from_this() _NOEXCEPT\x0a"
"       { return __weak_this_; }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    weak_ptr<const _Tp> weak_from_this() const _NOEXCEPT\x0a"
"        { return __weak_this_; }\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"    template <class _Up> friend class shared_ptr;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<shared_ptr<_Tp> >\x0a"
"{\x0a"
"    typedef shared_ptr<_Tp>      argument_type;\x0a"
"    typedef size_t               result_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator()(const argument_type\x26 __ptr) const _NOEXCEPT\x0a"
"    {\x0a"
"        return hash<_Tp*>()(__ptr.get());\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Yp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, shared_ptr<_Yp> const\x26 __p);\x0a"
"\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_ATOMIC_HEADER)\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS __sp_mut\x0a"
"{\x0a"
"    void* __lx;\x0a"
"public\x3a\x0a"
"    void lock() _NOEXCEPT;\x0a"
"    void unlock() _NOEXCEPT;\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_CONSTEXPR __sp_mut(void*) _NOEXCEPT;\x0a"
"    __sp_mut(const __sp_mut\x26);\x0a"
"    __sp_mut\x26 operator=(const __sp_mut\x26);\x0a"
"\x0a"
"    friend _LIBCPP_FUNC_VIS __sp_mut\x26 __get_sp_mut(const void*);\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS _LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"__sp_mut\x26 __get_sp_mut(const void*);\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"atomic_is_lock_free(const shared_ptr<_Tp>*)\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"shared_ptr<_Tp>\x0a"
"atomic_load(const shared_ptr<_Tp>* __p)\x0a"
"{\x0a"
"    __sp_mut\x26 __m = __get_sp_mut(__p);\x0a"
"    __m.lock();\x0a"
"    shared_ptr<_Tp> __q = *__p;\x0a"
"    __m.unlock();\x0a"
"    return __q;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"shared_ptr<_Tp>\x0a"
"atomic_load_explicit(const shared_ptr<_Tp>* __p, memory_order)\x0a"
"{\x0a"
"    return atomic_load(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"void\x0a"
"atomic_store(shared_ptr<_Tp>* __p, shared_ptr<_Tp> __r)\x0a"
"{\x0a"
"    __sp_mut\x26 __m = __get_sp_mut(__p);\x0a"
"    __m.lock();\x0a"
"    __p->swap(__r);\x0a"
"    __m.unlock();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"void\x0a"
"atomic_store_explicit(shared_ptr<_Tp>* __p, shared_ptr<_Tp> __r, memory_order)\x0a"
"{\x0a"
"    atomic_store(__p, __r);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"shared_ptr<_Tp>\x0a"
"atomic_exchange(shared_ptr<_Tp>* __p, shared_ptr<_Tp> __r)\x0a"
"{\x0a"
"    __sp_mut\x26 __m = __get_sp_mut(__p);\x0a"
"    __m.lock();\x0a"
"    __p->swap(__r);\x0a"
"    __m.unlock();\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"shared_ptr<_Tp>\x0a"
"atomic_exchange_explicit(shared_ptr<_Tp>* __p, shared_ptr<_Tp> __r, memory_order)\x0a"
"{\x0a"
"    return atomic_exchange(__p, __r);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"bool\x0a"
"atomic_compare_exchange_strong(shared_ptr<_Tp>* __p, shared_ptr<_Tp>* __v, shared_ptr<_Tp> __w)\x0a"
"{\x0a"
"    shared_ptr<_Tp> __temp;\x0a"
"    __sp_mut\x26 __m = __get_sp_mut(__p);\x0a"
"    __m.lock();\x0a"
"    if (__p->__owner_equivalent(*__v))\x0a"
"    {\x0a"
"        _VSTD\x3a\x3aswap(__temp, *__p);\x0a"
"        *__p = __w;\x0a"
"        __m.unlock();\x0a"
"        return true;\x0a"
"    }\x0a"
"    _VSTD\x3a\x3aswap(__temp, *__v);\x0a"
"    *__v = *__p;\x0a"
"    __m.unlock();\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"bool\x0a"
"atomic_compare_exchange_weak(shared_ptr<_Tp>* __p, shared_ptr<_Tp>* __v, shared_ptr<_Tp> __w)\x0a"
"{\x0a"
"    return atomic_compare_exchange_strong(__p, __v, __w);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"bool\x0a"
"atomic_compare_exchange_strong_explicit(shared_ptr<_Tp>* __p, shared_ptr<_Tp>* __v,\x0a"
"                                        shared_ptr<_Tp> __w, memory_order, memory_order)\x0a"
"{\x0a"
"    return atomic_compare_exchange_strong(__p, __v, __w);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_AVAILABILITY_ATOMIC_SHARED_PTR\x0a"
"bool\x0a"
"atomic_compare_exchange_weak_explicit(shared_ptr<_Tp>* __p, shared_ptr<_Tp>* __v,\x0a"
"                                      shared_ptr<_Tp> __w, memory_order, memory_order)\x0a"
"{\x0a"
"    return atomic_compare_exchange_weak(__p, __v, __w);\x0a"
"}\x0a"
"\x0a"
"#endif  // \x21""defined(_LIBCPP_HAS_NO_ATOMIC_HEADER)\x0a"
"\x0a"
"//enum class\x0a"
"#if defined(_LIBCPP_ABI_POINTER_SAFETY_ENUM_TYPE)\x0a"
"# ifndef _LIBCPP_CXX03_LANG\x0a"
"enum class pointer_safety \x3a unsigned char {\x0a"
"  relaxed,\x0a"
"  preferred,\x0a"
"  strict\x0a"
"};\x0a"
"# endif\x0a"
"#else\x0a"
"struct _LIBCPP_TYPE_VIS pointer_safety\x0a"
"{\x0a"
"    enum __lx\x0a"
"    {\x0a"
"        relaxed,\x0a"
"        preferred,\x0a"
"        strict\x0a"
"    };\x0a"
"\x0a"
"    __lx __v_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer_safety() \x3a __v_() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer_safety(__lx __v) \x3a __v_(__v) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator int() const {return __v_;}\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_ABI_POINTER_SAFETY_ENUM_TYPE) \x26\x26 \x5c\x0a"
"    defined(_LIBCPP_BUILDING_LIBRARY)\x0a"
"_LIBCPP_FUNC_VIS pointer_safety get_pointer_safety() _NOEXCEPT;\x0a"
"#else\x0a"
"// This function is only offered in C++03 under ABI v1.\x0a"
"# if \x21""defined(_LIBCPP_ABI_POINTER_SAFETY_ENUM_TYPE) \x7c\x7c \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"pointer_safety get_pointer_safety() _NOEXCEPT {\x0a"
"  return pointer_safety\x3a\x3arelaxed;\x0a"
"}\x0a"
"# endif\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS void declare_reachable(void* __p);\x0a"
"_LIBCPP_FUNC_VIS void declare_no_pointers(char* __p, size_t __n);\x0a"
"_LIBCPP_FUNC_VIS void undeclare_no_pointers(char* __p, size_t __n);\x0a"
"_LIBCPP_FUNC_VIS void* __undeclare_reachable(void* __p);\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"undeclare_reachable(_Tp* __p)\x0a"
"{\x0a"
"    return static_cast<_Tp*>(__undeclare_reachable(__p));\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS void* align(size_t __align, size_t __sz, void*\x26 __ptr, size_t\x26 __space);\x0a"
"\x0a"
"// --- Helper for container swap --\x0a"
"template <typename _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __swap_allocator(_Alloc \x26 __a1, _Alloc \x26 __a2)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"    _NOEXCEPT\x0a"
"#else\x0a"
"    _NOEXCEPT_(__is_nothrow_swappable<_Alloc>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"    __swap_allocator(__a1, __a2,\x0a"
"      integral_constant<bool, _VSTD\x3a\x3a""allocator_traits<_Alloc>\x3a\x3apropagate_on_container_swap\x3a\x3avalue>());\x0a"
"}\x0a"
"\x0a"
"template <typename _Alloc>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"void __swap_allocator(_Alloc \x26 __a1, _Alloc \x26 __a2, true_type)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"    _NOEXCEPT\x0a"
"#else\x0a"
"    _NOEXCEPT_(__is_nothrow_swappable<_Alloc>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"    using _VSTD\x3a\x3aswap;\x0a"
"    swap(__a1, __a2);\x0a"
"}\x0a"
"\x0a"
"template <typename _Alloc>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __swap_allocator(_Alloc \x26, _Alloc \x26, false_type) _NOEXCEPT {}\x0a"
"\x0a"
"template <typename _Alloc, typename _Traits=allocator_traits<_Alloc> >\x0a"
"struct __noexcept_move_assign_container \x3a public integral_constant<bool,\x0a"
"    _Traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        \x7c\x7c _Traits\x3a\x3ais_always_equal\x3a\x3avalue\x0a"
"#else\x0a"
"        \x26\x26 is_nothrow_move_assignable<_Alloc>\x3a\x3avalue\x0a"
"#endif\x0a"
"    > {};\x0a"
"\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_VARIADICS\x0a"
"template <class _Tp, class _Alloc>\x0a"
"struct __temp_value {\x0a"
"    typedef allocator_traits<_Alloc> _Traits;\x0a"
"\x0a"
"    typename aligned_storage<sizeof(_Tp), _LIBCPP_ALIGNOF(_Tp)>\x3a\x3atype __v;\x0a"
"    _Alloc \x26__a;\x0a"
"\x0a"
"    _Tp *__addr() { return reinterpret_cast<_Tp *>(addressof(__v)); }\x0a"
"    _Tp \x26   get() { return *__addr(); }\x0a"
"\x0a"
"    template<class... _Args>\x0a"
"    _LIBCPP_NO_CFI\x0a"
"    __temp_value(_Alloc \x26__alloc, _Args\x26\x26 ... __args) \x3a __a(__alloc) {\x0a"
"      _Traits\x3a\x3a""construct(__a, reinterpret_cast<_Tp*>(addressof(__v)),\x0a"
"                         _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    }\x0a"
"\x0a"
"    \x7e__temp_value() { _Traits\x3a\x3a""destroy(__a, __addr()); }\x0a"
"    };\x0a"
"#endif\x0a"
"\x0a"
"template<typename _Alloc, typename = void, typename = void>\x0a"
"struct __is_allocator \x3a false_type {};\x0a"
"\x0a"
"template<typename _Alloc>\x0a"
"struct __is_allocator<_Alloc,\x0a"
"       typename __void_t<typename _Alloc\x3a\x3avalue_type>\x3a\x3atype,\x0a"
"       typename __void_t<decltype(_VSTD\x3a\x3a""declval<_Alloc\x26>().allocate(size_t(0)))>\x3a\x3atype\x0a"
"     >\x0a"
"   \x3a true_type {};\x0a"
"\x0a"
"// __builtin_new_allocator -- A non-templated helper for allocating and\x0a"
"// deallocating memory using __builtin_operator_new and\x0a"
"// __builtin_operator_delete. It should be used in preference to\x0a"
"// \x60std\x3a\x3a""allocator<T>\x60 to avoid additional instantiations.\x0a"
"struct __builtin_new_allocator {\x0a"
"  struct __builtin_new_deleter {\x0a"
"    typedef void* pointer_type;\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR explicit __builtin_new_deleter(size_t __size, size_t __align)\x0a"
"        \x3a __size_(__size), __align_(__align) {}\x0a"
"\x0a"
"    void operator()(void* p) const _NOEXCEPT {\x0a"
"        std\x3a\x3a__libcpp_deallocate(p, __size_, __align_);\x0a"
"    }\x0a"
"\x0a"
"   private\x3a\x0a"
"    size_t __size_;\x0a"
"    size_t __align_;\x0a"
"  };\x0a"
"\x0a"
"  typedef unique_ptr<void, __builtin_new_deleter> __holder_t;\x0a"
"\x0a"
"  static __holder_t __allocate_bytes(size_t __s, size_t __align) {\x0a"
"      return __holder_t(std\x3a\x3a__libcpp_allocate(__s, __align),\x0a"
"                     __builtin_new_deleter(__s, __align));\x0a"
"  }\x0a"
"\x0a"
"  static void __deallocate_bytes(void* __p, size_t __s,\x0a"
"                                 size_t __align) _NOEXCEPT {\x0a"
"      std\x3a\x3a__libcpp_deallocate(__p, __s, __align);\x0a"
"  }\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  _LIBCPP_NODEBUG _LIBCPP_ALWAYS_INLINE\x0a"
"  static __holder_t __allocate_type(size_t __n) {\x0a"
"      return __allocate_bytes(__n * sizeof(_Tp), _LIBCPP_ALIGNOF(_Tp));\x0a"
"  }\x0a"
"\x0a"
"  template <class _Tp>\x0a"
"  _LIBCPP_NODEBUG _LIBCPP_ALWAYS_INLINE\x0a"
"  static void __deallocate_type(void* __p, size_t __n) _NOEXCEPT {\x0a"
"      __deallocate_bytes(__p, __n * sizeof(_Tp), _LIBCPP_ALIGNOF(_Tp));\x0a"
"  }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_MEMORY\x0a"
"", 174389 ); }