#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_random( 
"// -*- C++ -*-\x0a"
"//===--------------------------- random -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_RANDOM\x0a"
"#define _LIBCPP_RANDOM\x0a"
"\x0a"
"/*\x0a"
"    random synopsis\x0a"
"\x0a"
"#include <initializer_list>\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"// Engines\x0a"
"\x0a"
"template <class UIntType, UIntType a, UIntType c, UIntType m>\x0a"
"class linear_congruential_engine\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef UIntType result_type;\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    static constexpr result_type multiplier = a;\x0a"
"    static constexpr result_type increment = c;\x0a"
"    static constexpr result_type modulus = m;\x0a"
"    static constexpr result_type min() { return c == 0u \x3f 1u\x3a 0u;}\x0a"
"    static constexpr result_type max() { return m - 1u;}\x0a"
"    static constexpr result_type default_seed = 1u;\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    explicit linear_congruential_engine(result_type s = default_seed);\x0a"
"    template<class Sseq> explicit linear_congruential_engine(Sseq\x26 q);\x0a"
"    void seed(result_type s = default_seed);\x0a"
"    template<class Sseq> void seed(Sseq\x26 q);\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()();\x0a"
"    void discard(unsigned long long z);\x0a"
"};\x0a"
"\x0a"
"template <class UIntType, UIntType a, UIntType c, UIntType m>\x0a"
"bool\x0a"
"operator==(const linear_congruential_engine<UIntType, a, c, m>\x26 x,\x0a"
"           const linear_congruential_engine<UIntType, a, c, m>\x26 y);\x0a"
"\x0a"
"template <class UIntType, UIntType a, UIntType c, UIntType m>\x0a"
"bool\x0a"
"operator\x21=(const linear_congruential_engine<UIntType, a, c, m>\x26 x,\x0a"
"           const linear_congruential_engine<UIntType, a, c, m>\x26 y);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class UIntType, UIntType a, UIntType c, UIntType m>\x0a"
"basic_ostream<charT, traits>\x26\x0a"
"operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"           const linear_congruential_engine<UIntType, a, c, m>\x26 x);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class UIntType, UIntType a, UIntType c, UIntType m>\x0a"
"basic_istream<charT, traits>\x26\x0a"
"operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"           linear_congruential_engine<UIntType, a, c, m>\x26 x);\x0a"
"\x0a"
"template <class UIntType, size_t w, size_t n, size_t m, size_t r,\x0a"
"          UIntType a, size_t u, UIntType d, size_t s,\x0a"
"          UIntType b, size_t t, UIntType c, size_t l, UIntType f>\x0a"
"class mersenne_twister_engine\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef UIntType result_type;\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    static constexpr size_t word_size = w;\x0a"
"    static constexpr size_t state_size = n;\x0a"
"    static constexpr size_t shift_size = m;\x0a"
"    static constexpr size_t mask_bits = r;\x0a"
"    static constexpr result_type xor_mask = a;\x0a"
"    static constexpr size_t tempering_u = u;\x0a"
"    static constexpr result_type tempering_d = d;\x0a"
"    static constexpr size_t tempering_s = s;\x0a"
"    static constexpr result_type tempering_b = b;\x0a"
"    static constexpr size_t tempering_t = t;\x0a"
"    static constexpr result_type tempering_c = c;\x0a"
"    static constexpr size_t tempering_l = l;\x0a"
"    static constexpr result_type initialization_multiplier = f;\x0a"
"    static constexpr result_type min () { return 0; }\x0a"
"    static constexpr result_type max() { return 2^w - 1; }\x0a"
"    static constexpr result_type default_seed = 5489u;\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    explicit mersenne_twister_engine(result_type value = default_seed);\x0a"
"    template<class Sseq> explicit mersenne_twister_engine(Sseq\x26 q);\x0a"
"    void seed(result_type value = default_seed);\x0a"
"    template<class Sseq> void seed(Sseq\x26 q);\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()();\x0a"
"    void discard(unsigned long long z);\x0a"
"};\x0a"
"\x0a"
"template <class UIntType, size_t w, size_t n, size_t m, size_t r,\x0a"
"          UIntType a, size_t u, UIntType d, size_t s,\x0a"
"          UIntType b, size_t t, UIntType c, size_t l, UIntType f>\x0a"
"bool\x0a"
"operator==(\x0a"
"    const mersenne_twister_engine<UIntType, w, n, m, r, a, u, d, s, b, t, c, l, f>\x26 x,\x0a"
"    const mersenne_twister_engine<UIntType, w, n, m, r, a, u, d, s, b, t, c, l, f>\x26 y);\x0a"
"\x0a"
"template <class UIntType, size_t w, size_t n, size_t m, size_t r,\x0a"
"          UIntType a, size_t u, UIntType d, size_t s,\x0a"
"          UIntType b, size_t t, UIntType c, size_t l, UIntType f>\x0a"
"bool\x0a"
"operator\x21=(\x0a"
"    const mersenne_twister_engine<UIntType, w, n, m, r, a, u, d, s, b, t, c, l, f>\x26 x,\x0a"
"    const mersenne_twister_engine<UIntType, w, n, m, r, a, u, d, s, b, t, c, l, f>\x26 y);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class UIntType, size_t w, size_t n, size_t m, size_t r,\x0a"
"          UIntType a, size_t u, UIntType d, size_t s,\x0a"
"          UIntType b, size_t t, UIntType c, size_t l, UIntType f>\x0a"
"basic_ostream<charT, traits>\x26\x0a"
"operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"           const mersenne_twister_engine<UIntType, w, n, m, r, a, u, d, s, b, t, c, l, f>\x26 x);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class UIntType, size_t w, size_t n, size_t m, size_t r,\x0a"
"          UIntType a, size_t u, UIntType d, size_t s,\x0a"
"          UIntType b, size_t t, UIntType c, size_t l, UIntType f>\x0a"
"basic_istream<charT, traits>\x26\x0a"
"operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"           mersenne_twister_engine<UIntType, w, n, m, r, a, u, d, s, b, t, c, l, f>\x26 x);\x0a"
"\x0a"
"template<class UIntType, size_t w, size_t s, size_t r>\x0a"
"class subtract_with_carry_engine\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef UIntType result_type;\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    static constexpr size_t word_size = w;\x0a"
"    static constexpr size_t short_lag = s;\x0a"
"    static constexpr size_t long_lag = r;\x0a"
"    static constexpr result_type min() { return 0; }\x0a"
"    static constexpr result_type max() { return m-1; }\x0a"
"    static constexpr result_type default_seed = 19780503u;\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    explicit subtract_with_carry_engine(result_type value = default_seed);\x0a"
"    template<class Sseq> explicit subtract_with_carry_engine(Sseq\x26 q);\x0a"
"    void seed(result_type value = default_seed);\x0a"
"    template<class Sseq> void seed(Sseq\x26 q);\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()();\x0a"
"    void discard(unsigned long long z);\x0a"
"};\x0a"
"\x0a"
"template<class UIntType, size_t w, size_t s, size_t r>\x0a"
"bool\x0a"
"operator==(\x0a"
"    const subtract_with_carry_engine<UIntType, w, s, r>\x26 x,\x0a"
"    const subtract_with_carry_engine<UIntType, w, s, r>\x26 y);\x0a"
"\x0a"
"template<class UIntType, size_t w, size_t s, size_t r>\x0a"
"bool\x0a"
"operator\x21=(\x0a"
"    const subtract_with_carry_engine<UIntType, w, s, r>\x26 x,\x0a"
"    const subtract_with_carry_engine<UIntType, w, s, r>\x26 y);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class UIntType, size_t w, size_t s, size_t r>\x0a"
"basic_ostream<charT, traits>\x26\x0a"
"operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"           const subtract_with_carry_engine<UIntType, w, s, r>\x26 x);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class UIntType, size_t w, size_t s, size_t r>\x0a"
"basic_istream<charT, traits>\x26\x0a"
"operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"           subtract_with_carry_engine<UIntType, w, s, r>\x26 x);\x0a"
"\x0a"
"template<class Engine, size_t p, size_t r>\x0a"
"class discard_block_engine\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef typename Engine\x3a\x3aresult_type result_type;\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    static constexpr size_t block_size = p;\x0a"
"    static constexpr size_t used_block = r;\x0a"
"    static constexpr result_type min() { return Engine\x3a\x3amin(); }\x0a"
"    static constexpr result_type max() { return Engine\x3a\x3amax(); }\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    discard_block_engine();\x0a"
"    explicit discard_block_engine(const Engine\x26 e);\x0a"
"    explicit discard_block_engine(Engine\x26\x26 e);\x0a"
"    explicit discard_block_engine(result_type s);\x0a"
"    template<class Sseq> explicit discard_block_engine(Sseq\x26 q);\x0a"
"    void seed();\x0a"
"    void seed(result_type s);\x0a"
"    template<class Sseq> void seed(Sseq\x26 q);\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()();\x0a"
"    void discard(unsigned long long z);\x0a"
"\x0a"
"    // property functions\x0a"
"    const Engine\x26 base() const noexcept;\x0a"
"};\x0a"
"\x0a"
"template<class Engine, size_t p, size_t r>\x0a"
"bool\x0a"
"operator==(\x0a"
"    const discard_block_engine<Engine, p, r>\x26 x,\x0a"
"    const discard_block_engine<Engine, p, r>\x26 y);\x0a"
"\x0a"
"template<class Engine, size_t p, size_t r>\x0a"
"bool\x0a"
"operator\x21=(\x0a"
"    const discard_block_engine<Engine, p, r>\x26 x,\x0a"
"    const discard_block_engine<Engine, p, r>\x26 y);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class Engine, size_t p, size_t r>\x0a"
"basic_ostream<charT, traits>\x26\x0a"
"operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"           const discard_block_engine<Engine, p, r>\x26 x);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class Engine, size_t p, size_t r>\x0a"
"basic_istream<charT, traits>\x26\x0a"
"operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"           discard_block_engine<Engine, p, r>\x26 x);\x0a"
"\x0a"
"template<class Engine, size_t w, class UIntType>\x0a"
"class independent_bits_engine\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef UIntType result_type;\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    static constexpr result_type min() { return 0; }\x0a"
"    static constexpr result_type max() { return 2^w - 1; }\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    independent_bits_engine();\x0a"
"    explicit independent_bits_engine(const Engine\x26 e);\x0a"
"    explicit independent_bits_engine(Engine\x26\x26 e);\x0a"
"    explicit independent_bits_engine(result_type s);\x0a"
"    template<class Sseq> explicit independent_bits_engine(Sseq\x26 q);\x0a"
"    void seed();\x0a"
"    void seed(result_type s);\x0a"
"    template<class Sseq> void seed(Sseq\x26 q);\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()(); void discard(unsigned long long z);\x0a"
"\x0a"
"    // property functions\x0a"
"    const Engine\x26 base() const noexcept;\x0a"
"};\x0a"
"\x0a"
"template<class Engine, size_t w, class UIntType>\x0a"
"bool\x0a"
"operator==(\x0a"
"    const independent_bits_engine<Engine, w, UIntType>\x26 x,\x0a"
"    const independent_bits_engine<Engine, w, UIntType>\x26 y);\x0a"
"\x0a"
"template<class Engine, size_t w, class UIntType>\x0a"
"bool\x0a"
"operator\x21=(\x0a"
"    const independent_bits_engine<Engine, w, UIntType>\x26 x,\x0a"
"    const independent_bits_engine<Engine, w, UIntType>\x26 y);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class Engine, size_t w, class UIntType>\x0a"
"basic_ostream<charT, traits>\x26\x0a"
"operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"           const independent_bits_engine<Engine, w, UIntType>\x26 x);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class Engine, size_t w, class UIntType>\x0a"
"basic_istream<charT, traits>\x26\x0a"
"operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"           independent_bits_engine<Engine, w, UIntType>\x26 x);\x0a"
"\x0a"
"template<class Engine, size_t k>\x0a"
"class shuffle_order_engine\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef typename Engine\x3a\x3aresult_type result_type;\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    static constexpr size_t table_size = k;\x0a"
"    static constexpr result_type min() { return Engine\x3a\x3amin; }\x0a"
"    static constexpr result_type max() { return Engine\x3a\x3amax; }\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    shuffle_order_engine();\x0a"
"    explicit shuffle_order_engine(const Engine\x26 e);\x0a"
"    explicit shuffle_order_engine(Engine\x26\x26 e);\x0a"
"    explicit shuffle_order_engine(result_type s);\x0a"
"    template<class Sseq> explicit shuffle_order_engine(Sseq\x26 q);\x0a"
"    void seed();\x0a"
"    void seed(result_type s);\x0a"
"    template<class Sseq> void seed(Sseq\x26 q);\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()();\x0a"
"    void discard(unsigned long long z);\x0a"
"\x0a"
"    // property functions\x0a"
"    const Engine\x26 base() const noexcept;\x0a"
"};\x0a"
"\x0a"
"template<class Engine, size_t k>\x0a"
"bool\x0a"
"operator==(\x0a"
"    const shuffle_order_engine<Engine, k>\x26 x,\x0a"
"    const shuffle_order_engine<Engine, k>\x26 y);\x0a"
"\x0a"
"template<class Engine, size_t k>\x0a"
"bool\x0a"
"operator\x21=(\x0a"
"    const shuffle_order_engine<Engine, k>\x26 x,\x0a"
"    const shuffle_order_engine<Engine, k>\x26 y);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class Engine, size_t k>\x0a"
"basic_ostream<charT, traits>\x26\x0a"
"operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"           const shuffle_order_engine<Engine, k>\x26 x);\x0a"
"\x0a"
"template <class charT, class traits,\x0a"
"          class Engine, size_t k>\x0a"
"basic_istream<charT, traits>\x26\x0a"
"operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"           shuffle_order_engine<Engine, k>\x26 x);\x0a"
"\x0a"
"typedef linear_congruential_engine<uint_fast32_t, 16807, 0, 2147483647>\x0a"
"                                                                   minstd_rand0;\x0a"
"typedef linear_congruential_engine<uint_fast32_t, 48271, 0, 2147483647>\x0a"
"                                                                    minstd_rand;\x0a"
"typedef mersenne_twister_engine<uint_fast32_t, 32, 624, 397, 31,\x0a"
"                                0x9908b0df,\x0a"
"                                11, 0xffffffff,\x0a"
"                                7,  0x9d2c5680,\x0a"
"                                15, 0xefc60000,\x0a"
"                                18, 1812433253>                         mt19937;\x0a"
"typedef mersenne_twister_engine<uint_fast64_t, 64, 312, 156, 31,\x0a"
"                                0xb5026f5aa96619e9,\x0a"
"                                29, 0x5555555555555555,\x0a"
"                                17, 0x71d67fffeda60000,\x0a"
"                                37, 0xfff7eee000000000,\x0a"
"                                43, 6364136223846793005>             mt19937_64;\x0a"
"typedef subtract_with_carry_engine<uint_fast32_t, 24, 10, 24>     ranlux24_base;\x0a"
"typedef subtract_with_carry_engine<uint_fast64_t, 48,  5, 12>     ranlux48_base;\x0a"
"typedef discard_block_engine<ranlux24_base, 223, 23>                   ranlux24;\x0a"
"typedef discard_block_engine<ranlux48_base, 389, 11>                   ranlux48;\x0a"
"typedef shuffle_order_engine<minstd_rand0, 256>                         knuth_b;\x0a"
"typedef minstd_rand                                       default_random_engine;\x0a"
"\x0a"
"// Generators\x0a"
"\x0a"
"class random_device\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef unsigned int result_type;\x0a"
"\x0a"
"    // generator characteristics\x0a"
"    static constexpr result_type min() { return numeric_limits<result_type>\x3a\x3amin(); }\x0a"
"    static constexpr result_type max() { return numeric_limits<result_type>\x3a\x3amax(); }\x0a"
"\x0a"
"    // constructors\x0a"
"    explicit random_device(const string\x26 token = \x22/dev/urandom\x22);\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()();\x0a"
"\x0a"
"    // property functions\x0a"
"    double entropy() const noexcept;\x0a"
"\x0a"
"    // no copy functions\x0a"
"    random_device(const random_device\x26 ) = delete;\x0a"
"    void operator=(const random_device\x26 ) = delete;\x0a"
"};\x0a"
"\x0a"
"// Utilities\x0a"
"\x0a"
"class seed_seq\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef uint_least32_t result_type;\x0a"
"\x0a"
"    // constructors\x0a"
"    seed_seq();\x0a"
"    template<class T>\x0a"
"        seed_seq(initializer_list<T> il);\x0a"
"    template<class InputIterator>\x0a"
"        seed_seq(InputIterator begin, InputIterator end);\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class RandomAccessIterator>\x0a"
"        void generate(RandomAccessIterator begin, RandomAccessIterator end);\x0a"
"\x0a"
"    // property functions\x0a"
"    size_t size() const;\x0a"
"    template<class OutputIterator>\x0a"
"        void param(OutputIterator dest) const;\x0a"
"\x0a"
"    // no copy functions\x0a"
"    seed_seq(const seed_seq\x26) = delete;\x0a"
"    void operator=(const seed_seq\x26 ) = delete;\x0a"
"};\x0a"
"\x0a"
"template<class RealType, size_t bits, class URNG>\x0a"
"    RealType generate_canonical(URNG\x26 g);\x0a"
"\x0a"
"// Distributions\x0a"
"\x0a"
"template<class IntType = int>\x0a"
"class uniform_int_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef IntType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef uniform_int_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(IntType a = 0,\x0a"
"                                    IntType b = numeric_limits<IntType>\x3a\x3amax());\x0a"
"\x0a"
"        result_type a() const;\x0a"
"        result_type b() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructors and reset functions\x0a"
"    explicit uniform_int_distribution(IntType a = 0,\x0a"
"                                    IntType b = numeric_limits<IntType>\x3a\x3amax());\x0a"
"    explicit uniform_int_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type a() const;\x0a"
"    result_type b() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const uniform_int_distribution\x26 x,\x0a"
"                           const uniform_int_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const uniform_int_distribution\x26 x,\x0a"
"                           const uniform_int_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const uniform_int_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               uniform_int_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class uniform_real_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef uniform_real_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(RealType a = 0,\x0a"
"                            RealType b = 1);\x0a"
"\x0a"
"        result_type a() const;\x0a"
"        result_type b() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructors and reset functions\x0a"
"    explicit uniform_real_distribution(RealType a = 0.0, RealType b = 1.0);\x0a"
"    explicit uniform_real_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type a() const;\x0a"
"    result_type b() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const uniform_real_distribution\x26 x,\x0a"
"                           const uniform_real_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const uniform_real_distribution\x26 x,\x0a"
"                           const uniform_real_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const uniform_real_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               uniform_real_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"class bernoulli_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef bool result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef bernoulli_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(double p = 0.5);\x0a"
"\x0a"
"        double p() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructors and reset functions\x0a"
"    explicit bernoulli_distribution(double p = 0.5);\x0a"
"    explicit bernoulli_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    double p() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const bernoulli_distribution\x26 x,\x0a"
"                           const bernoulli_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const bernoulli_distribution\x26 x,\x0a"
"                           const bernoulli_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const bernoulli_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               bernoulli_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class IntType = int>\x0a"
"class binomial_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef IntType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef binomial_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(IntType t = 1, double p = 0.5);\x0a"
"\x0a"
"        IntType t() const;\x0a"
"        double p() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructors and reset functions\x0a"
"    explicit binomial_distribution(IntType t = 1, double p = 0.5);\x0a"
"    explicit binomial_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    IntType t() const;\x0a"
"    double p() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const binomial_distribution\x26 x,\x0a"
"                           const binomial_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const binomial_distribution\x26 x,\x0a"
"                           const binomial_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const binomial_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               binomial_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class IntType = int>\x0a"
"class geometric_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef IntType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef geometric_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(double p = 0.5);\x0a"
"\x0a"
"        double p() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructors and reset functions\x0a"
"    explicit geometric_distribution(double p = 0.5);\x0a"
"    explicit geometric_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    double p() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const geometric_distribution\x26 x,\x0a"
"                           const geometric_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const geometric_distribution\x26 x,\x0a"
"                           const geometric_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const geometric_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               geometric_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class IntType = int>\x0a"
"class negative_binomial_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef IntType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef negative_binomial_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type k = 1, double p = 0.5);\x0a"
"\x0a"
"        result_type k() const;\x0a"
"        double p() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    explicit negative_binomial_distribution(result_type k = 1, double p = 0.5);\x0a"
"    explicit negative_binomial_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type k() const;\x0a"
"    double p() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const negative_binomial_distribution\x26 x,\x0a"
"                           const negative_binomial_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const negative_binomial_distribution\x26 x,\x0a"
"                           const negative_binomial_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const negative_binomial_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               negative_binomial_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class IntType = int>\x0a"
"class poisson_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef IntType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef poisson_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(double mean = 1.0);\x0a"
"\x0a"
"        double mean() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructors and reset functions\x0a"
"    explicit poisson_distribution(double mean = 1.0);\x0a"
"    explicit poisson_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    double mean() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const poisson_distribution\x26 x,\x0a"
"                           const poisson_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const poisson_distribution\x26 x,\x0a"
"                           const poisson_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const poisson_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               poisson_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class exponential_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef exponential_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type lambda = 1.0);\x0a"
"\x0a"
"        result_type lambda() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructors and reset functions\x0a"
"    explicit exponential_distribution(result_type lambda = 1.0);\x0a"
"    explicit exponential_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type lambda() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const exponential_distribution\x26 x,\x0a"
"                           const exponential_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const exponential_distribution\x26 x,\x0a"
"                           const exponential_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const exponential_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               exponential_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class gamma_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef gamma_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type alpha = 1, result_type beta = 1);\x0a"
"\x0a"
"        result_type alpha() const;\x0a"
"        result_type beta() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructors and reset functions\x0a"
"    explicit gamma_distribution(result_type alpha = 1, result_type beta = 1);\x0a"
"    explicit gamma_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type alpha() const;\x0a"
"    result_type beta() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const gamma_distribution\x26 x,\x0a"
"                           const gamma_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const gamma_distribution\x26 x,\x0a"
"                           const gamma_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const gamma_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               gamma_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class weibull_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef weibull_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type alpha = 1, result_type beta = 1);\x0a"
"\x0a"
"        result_type a() const;\x0a"
"        result_type b() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    explicit weibull_distribution(result_type a = 1, result_type b = 1);\x0a"
"    explicit weibull_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type a() const;\x0a"
"    result_type b() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const weibull_distribution\x26 x,\x0a"
"                           const weibull_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const weibull_distribution\x26 x,\x0a"
"                           const weibull_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const weibull_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               weibull_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class extreme_value_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef extreme_value_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type a = 0, result_type b = 1);\x0a"
"\x0a"
"        result_type a() const;\x0a"
"        result_type b() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    explicit extreme_value_distribution(result_type a = 0, result_type b = 1);\x0a"
"    explicit extreme_value_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type a() const;\x0a"
"    result_type b() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const extreme_value_distribution\x26 x,\x0a"
"                           const extreme_value_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const extreme_value_distribution\x26 x,\x0a"
"                           const extreme_value_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const extreme_value_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               extreme_value_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class normal_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef normal_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type mean = 0, result_type stddev = 1);\x0a"
"\x0a"
"        result_type mean() const;\x0a"
"        result_type stddev() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructors and reset functions\x0a"
"    explicit normal_distribution(result_type mean = 0, result_type stddev = 1);\x0a"
"    explicit normal_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type mean() const;\x0a"
"    result_type stddev() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const normal_distribution\x26 x,\x0a"
"                           const normal_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const normal_distribution\x26 x,\x0a"
"                           const normal_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const normal_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               normal_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class lognormal_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef lognormal_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type m = 0, result_type s = 1);\x0a"
"\x0a"
"        result_type m() const;\x0a"
"        result_type s() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    explicit lognormal_distribution(result_type m = 0, result_type s = 1);\x0a"
"    explicit lognormal_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type m() const;\x0a"
"    result_type s() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const lognormal_distribution\x26 x,\x0a"
"                           const lognormal_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const lognormal_distribution\x26 x,\x0a"
"                           const lognormal_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const lognormal_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               lognormal_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class chi_squared_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef chi_squared_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type n = 1);\x0a"
"\x0a"
"        result_type n() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    explicit chi_squared_distribution(result_type n = 1);\x0a"
"    explicit chi_squared_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type n() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const chi_squared_distribution\x26 x,\x0a"
"                           const chi_squared_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const chi_squared_distribution\x26 x,\x0a"
"                           const chi_squared_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const chi_squared_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               chi_squared_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class cauchy_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef cauchy_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type a = 0, result_type b = 1);\x0a"
"\x0a"
"        result_type a() const;\x0a"
"        result_type b() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    explicit cauchy_distribution(result_type a = 0, result_type b = 1);\x0a"
"    explicit cauchy_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type a() const;\x0a"
"    result_type b() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const cauchy_distribution\x26 x,\x0a"
"                           const cauchy_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const cauchy_distribution\x26 x,\x0a"
"                           const cauchy_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const cauchy_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               cauchy_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class fisher_f_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef fisher_f_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type m = 1, result_type n = 1);\x0a"
"\x0a"
"        result_type m() const;\x0a"
"        result_type n() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    explicit fisher_f_distribution(result_type m = 1, result_type n = 1);\x0a"
"    explicit fisher_f_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type m() const;\x0a"
"    result_type n() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const fisher_f_distribution\x26 x,\x0a"
"                           const fisher_f_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const fisher_f_distribution\x26 x,\x0a"
"                           const fisher_f_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const fisher_f_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               fisher_f_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class student_t_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef student_t_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type n = 1);\x0a"
"\x0a"
"        result_type n() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    explicit student_t_distribution(result_type n = 1);\x0a"
"    explicit student_t_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    result_type n() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const student_t_distribution\x26 x,\x0a"
"                           const student_t_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const student_t_distribution\x26 x,\x0a"
"                           const student_t_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const student_t_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               student_t_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class IntType = int>\x0a"
"class discrete_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef IntType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef discrete_distribution distribution_type;\x0a"
"\x0a"
"        param_type();\x0a"
"        template<class InputIterator>\x0a"
"            param_type(InputIterator firstW, InputIterator lastW);\x0a"
"        param_type(initializer_list<double> wl);\x0a"
"        template<class UnaryOperation>\x0a"
"            param_type(size_t nw, double xmin, double xmax, UnaryOperation fw);\x0a"
"\x0a"
"        vector<double> probabilities() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    discrete_distribution();\x0a"
"    template<class InputIterator>\x0a"
"        discrete_distribution(InputIterator firstW, InputIterator lastW);\x0a"
"    discrete_distribution(initializer_list<double> wl);\x0a"
"    template<class UnaryOperation>\x0a"
"        discrete_distribution(size_t nw, double xmin, double xmax,\x0a"
"                              UnaryOperation fw);\x0a"
"    explicit discrete_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    vector<double> probabilities() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const discrete_distribution\x26 x,\x0a"
"                           const discrete_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const discrete_distribution\x26 x,\x0a"
"                           const discrete_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const discrete_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               discrete_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class piecewise_constant_distribution\x0a"
"{\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef piecewise_constant_distribution distribution_type;\x0a"
"\x0a"
"        param_type();\x0a"
"        template<class InputIteratorB, class InputIteratorW>\x0a"
"            param_type(InputIteratorB firstB, InputIteratorB lastB,\x0a"
"                       InputIteratorW firstW);\x0a"
"        template<class UnaryOperation>\x0a"
"            param_type(initializer_list<result_type> bl, UnaryOperation fw);\x0a"
"        template<class UnaryOperation>\x0a"
"            param_type(size_t nw, result_type xmin, result_type xmax,\x0a"
"                       UnaryOperation fw);\x0a"
"\x0a"
"        vector<result_type> intervals() const;\x0a"
"        vector<result_type> densities() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    piecewise_constant_distribution();\x0a"
"    template<class InputIteratorB, class InputIteratorW>\x0a"
"        piecewise_constant_distribution(InputIteratorB firstB,\x0a"
"                                        InputIteratorB lastB,\x0a"
"                                        InputIteratorW firstW);\x0a"
"    template<class UnaryOperation>\x0a"
"        piecewise_constant_distribution(initializer_list<result_type> bl,\x0a"
"                                        UnaryOperation fw);\x0a"
"    template<class UnaryOperation>\x0a"
"        piecewise_constant_distribution(size_t nw, result_type xmin,\x0a"
"                                        result_type xmax, UnaryOperation fw);\x0a"
"    explicit piecewise_constant_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    vector<result_type> intervals() const;\x0a"
"    vector<result_type> densities() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const piecewise_constant_distribution\x26 x,\x0a"
"                           const piecewise_constant_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const piecewise_constant_distribution\x26 x,\x0a"
"                           const piecewise_constant_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const piecewise_constant_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               piecewise_constant_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"template<class RealType = double>\x0a"
"class piecewise_linear_distribution\x0a"
"{\x0a"
"    // types\x0a"
"    typedef RealType result_type;\x0a"
"\x0a"
"    class param_type\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        typedef piecewise_linear_distribution distribution_type;\x0a"
"\x0a"
"        param_type();\x0a"
"        template<class InputIteratorB, class InputIteratorW>\x0a"
"            param_type(InputIteratorB firstB, InputIteratorB lastB,\x0a"
"                       InputIteratorW firstW);\x0a"
"        template<class UnaryOperation>\x0a"
"            param_type(initializer_list<result_type> bl, UnaryOperation fw);\x0a"
"        template<class UnaryOperation>\x0a"
"            param_type(size_t nw, result_type xmin, result_type xmax,\x0a"
"                       UnaryOperation fw);\x0a"
"\x0a"
"        vector<result_type> intervals() const;\x0a"
"        vector<result_type> densities() const;\x0a"
"\x0a"
"        friend bool operator==(const param_type\x26 x, const param_type\x26 y);\x0a"
"        friend bool operator\x21=(const param_type\x26 x, const param_type\x26 y);\x0a"
"    };\x0a"
"\x0a"
"    // constructor and reset functions\x0a"
"    piecewise_linear_distribution();\x0a"
"    template<class InputIteratorB, class InputIteratorW>\x0a"
"        piecewise_linear_distribution(InputIteratorB firstB,\x0a"
"                                      InputIteratorB lastB,\x0a"
"                                      InputIteratorW firstW);\x0a"
"\x0a"
"    template<class UnaryOperation>\x0a"
"        piecewise_linear_distribution(initializer_list<result_type> bl,\x0a"
"                                      UnaryOperation fw);\x0a"
"\x0a"
"    template<class UnaryOperation>\x0a"
"        piecewise_linear_distribution(size_t nw, result_type xmin,\x0a"
"                                      result_type xmax, UnaryOperation fw);\x0a"
"\x0a"
"    explicit piecewise_linear_distribution(const param_type\x26 parm);\x0a"
"    void reset();\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g);\x0a"
"    template<class URNG> result_type operator()(URNG\x26 g, const param_type\x26 parm);\x0a"
"\x0a"
"    // property functions\x0a"
"    vector<result_type> intervals() const;\x0a"
"    vector<result_type> densities() const;\x0a"
"\x0a"
"    param_type param() const;\x0a"
"    void param(const param_type\x26 parm);\x0a"
"\x0a"
"    result_type min() const;\x0a"
"    result_type max() const;\x0a"
"\x0a"
"    friend bool operator==(const piecewise_linear_distribution\x26 x,\x0a"
"                           const piecewise_linear_distribution\x26 y);\x0a"
"    friend bool operator\x21=(const piecewise_linear_distribution\x26 x,\x0a"
"                           const piecewise_linear_distribution\x26 y);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_ostream<charT, traits>\x26\x0a"
"    operator<<(basic_ostream<charT, traits>\x26 os,\x0a"
"               const piecewise_linear_distribution\x26 x);\x0a"
"\x0a"
"    template <class charT, class traits>\x0a"
"    friend\x0a"
"    basic_istream<charT, traits>\x26\x0a"
"    operator>>(basic_istream<charT, traits>\x26 is,\x0a"
"               piecewise_linear_distribution\x26 x);\x0a"
"};\x0a"
"\x0a"
"} // std\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <cstddef>\x0a"
"#include <cstdint>\x0a"
"#include <cmath>\x0a"
"#include <type_traits>\x0a"
"#include <initializer_list>\x0a"
"#include <limits>\x0a"
"#include <algorithm>\x0a"
"#include <numeric>\x0a"
"#include <vector>\x0a"
"#include <string>\x0a"
"#include <istream>\x0a"
"#include <ostream>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// __is_seed_sequence\x0a"
"\x0a"
"template <class _Sseq, class _Engine>\x0a"
"struct __is_seed_sequence\x0a"
"{\x0a"
"    static _LIBCPP_CONSTEXPR const bool value =\x0a"
"              \x21is_convertible<_Sseq, typename _Engine\x3a\x3aresult_type>\x3a\x3avalue \x26\x26\x0a"
"              \x21is_same<typename remove_cv<_Sseq>\x3a\x3atype, _Engine>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"// linear_congruential_engine\x0a"
"\x0a"
"template <unsigned long long __a, unsigned long long __c,\x0a"
"          unsigned long long __m, unsigned long long _Mp,\x0a"
"          bool _MightOverflow = (__a \x21= 0 \x26\x26 __m \x21= 0 \x26\x26 __m-1 > (_Mp-__c)/__a)>\x0a"
"struct __lce_ta;\x0a"
"\x0a"
"// 64\x0a"
"\x0a"
"template <unsigned long long __a, unsigned long long __c, unsigned long long __m>\x0a"
"struct __lce_ta<__a, __c, __m, (unsigned long long)(\x7e""0), true>\x0a"
"{\x0a"
"    typedef unsigned long long result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static result_type next(result_type __x)\x0a"
"    {\x0a"
"        // Schrage's algorithm\x0a"
"        const result_type __q = __m / __a;\x0a"
"        const result_type __r = __m \x25 __a;\x0a"
"        const result_type __t0 = __a * (__x \x25 __q);\x0a"
"        const result_type __t1 = __r * (__x / __q);\x0a"
"        __x = __t0 + (__t0 < __t1) * __m - __t1;\x0a"
"        __x += __c - (__x >= __m - __c) * __m;\x0a"
"        return __x;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <unsigned long long __a, unsigned long long __m>\x0a"
"struct __lce_ta<__a, 0, __m, (unsigned long long)(\x7e""0), true>\x0a"
"{\x0a"
"    typedef unsigned long long result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static result_type next(result_type __x)\x0a"
"    {\x0a"
"        // Schrage's algorithm\x0a"
"        const result_type __q = __m / __a;\x0a"
"        const result_type __r = __m \x25 __a;\x0a"
"        const result_type __t0 = __a * (__x \x25 __q);\x0a"
"        const result_type __t1 = __r * (__x / __q);\x0a"
"        __x = __t0 + (__t0 < __t1) * __m - __t1;\x0a"
"        return __x;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <unsigned long long __a, unsigned long long __c, unsigned long long __m>\x0a"
"struct __lce_ta<__a, __c, __m, (unsigned long long)(\x7e""0), false>\x0a"
"{\x0a"
"    typedef unsigned long long result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static result_type next(result_type __x)\x0a"
"    {\x0a"
"        return (__a * __x + __c) \x25 __m;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <unsigned long long __a, unsigned long long __c>\x0a"
"struct __lce_ta<__a, __c, 0, (unsigned long long)(\x7e""0), false>\x0a"
"{\x0a"
"    typedef unsigned long long result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static result_type next(result_type __x)\x0a"
"    {\x0a"
"        return __a * __x + __c;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"// 32\x0a"
"\x0a"
"template <unsigned long long _Ap, unsigned long long _Cp, unsigned long long _Mp>\x0a"
"struct __lce_ta<_Ap, _Cp, _Mp, unsigned(\x7e""0), true>\x0a"
"{\x0a"
"    typedef unsigned result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static result_type next(result_type __x)\x0a"
"    {\x0a"
"        const result_type __a = static_cast<result_type>(_Ap);\x0a"
"        const result_type __c = static_cast<result_type>(_Cp);\x0a"
"        const result_type __m = static_cast<result_type>(_Mp);\x0a"
"        // Schrage's algorithm\x0a"
"        const result_type __q = __m / __a;\x0a"
"        const result_type __r = __m \x25 __a;\x0a"
"        const result_type __t0 = __a * (__x \x25 __q);\x0a"
"        const result_type __t1 = __r * (__x / __q);\x0a"
"        __x = __t0 + (__t0 < __t1) * __m - __t1;\x0a"
"        __x += __c - (__x >= __m - __c) * __m;\x0a"
"        return __x;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <unsigned long long _Ap, unsigned long long _Mp>\x0a"
"struct __lce_ta<_Ap, 0, _Mp, unsigned(\x7e""0), true>\x0a"
"{\x0a"
"    typedef unsigned result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static result_type next(result_type __x)\x0a"
"    {\x0a"
"        const result_type __a = static_cast<result_type>(_Ap);\x0a"
"        const result_type __m = static_cast<result_type>(_Mp);\x0a"
"        // Schrage's algorithm\x0a"
"        const result_type __q = __m / __a;\x0a"
"        const result_type __r = __m \x25 __a;\x0a"
"        const result_type __t0 = __a * (__x \x25 __q);\x0a"
"        const result_type __t1 = __r * (__x / __q);\x0a"
"        __x = __t0 + (__t0 < __t1) * __m - __t1;\x0a"
"        return __x;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <unsigned long long _Ap, unsigned long long _Cp, unsigned long long _Mp>\x0a"
"struct __lce_ta<_Ap, _Cp, _Mp, unsigned(\x7e""0), false>\x0a"
"{\x0a"
"    typedef unsigned result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static result_type next(result_type __x)\x0a"
"    {\x0a"
"        const result_type __a = static_cast<result_type>(_Ap);\x0a"
"        const result_type __c = static_cast<result_type>(_Cp);\x0a"
"        const result_type __m = static_cast<result_type>(_Mp);\x0a"
"        return (__a * __x + __c) \x25 __m;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <unsigned long long _Ap, unsigned long long _Cp>\x0a"
"struct __lce_ta<_Ap, _Cp, 0, unsigned(\x7e""0), false>\x0a"
"{\x0a"
"    typedef unsigned result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static result_type next(result_type __x)\x0a"
"    {\x0a"
"        const result_type __a = static_cast<result_type>(_Ap);\x0a"
"        const result_type __c = static_cast<result_type>(_Cp);\x0a"
"        return __a * __x + __c;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"// 16\x0a"
"\x0a"
"template <unsigned long long __a, unsigned long long __c, unsigned long long __m, bool __b>\x0a"
"struct __lce_ta<__a, __c, __m, (unsigned short)(\x7e""0), __b>\x0a"
"{\x0a"
"    typedef unsigned short result_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static result_type next(result_type __x)\x0a"
"    {\x0a"
"        return static_cast<result_type>(__lce_ta<__a, __c, __m, unsigned(\x7e""0)>\x3a\x3anext(__x));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>\x0a"
"class _LIBCPP_TEMPLATE_VIS linear_congruential_engine;\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _Up, _Up _Ap, _Up _Cp, _Up _Np>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const linear_congruential_engine<_Up, _Ap, _Cp, _Np>\x26);\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _Up, _Up _Ap, _Up _Cp, _Up _Np>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           linear_congruential_engine<_Up, _Ap, _Cp, _Np>\x26 __x);\x0a"
"\x0a"
"template <class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>\x0a"
"class _LIBCPP_TEMPLATE_VIS linear_congruential_engine\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _UIntType result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    result_type __x_;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Mp = result_type(\x7e""0);\x0a"
"\x0a"
"    static_assert(__m == 0 \x7c\x7c __a < __m, \x22linear_congruential_engine invalid parameters\x22);\x0a"
"    static_assert(__m == 0 \x7c\x7c __c < __m, \x22linear_congruential_engine invalid parameters\x22);\x0a"
"public\x3a\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Min = __c == 0u \x3f 1u\x3a 0u;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Max = __m - 1u;\x0a"
"    static_assert(_Min < _Max,           \x22linear_congruential_engine invalid parameters\x22);\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    static _LIBCPP_CONSTEXPR const result_type multiplier = __a;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type increment = __c;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type modulus = __m;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type min() {return _Min;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type max() {return _Max;}\x0a"
"    static _LIBCPP_CONSTEXPR const result_type default_seed = 1u;\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit linear_congruential_engine(result_type __s = default_seed)\x0a"
"        {seed(__s);}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit linear_congruential_engine(_Sseq\x26 __q,\x0a"
"        typename enable_if<__is_seed_sequence<_Sseq, linear_congruential_engine>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"        {seed(__q);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed(result_type __s = default_seed)\x0a"
"        {seed(integral_constant<bool, __m == 0>(),\x0a"
"              integral_constant<bool, __c == 0>(), __s);}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_seed_sequence<_Sseq, linear_congruential_engine>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        seed(_Sseq\x26 __q)\x0a"
"            {__seed(__q, integral_constant<unsigned,\x0a"
"                1 + (__m == 0 \x3f (sizeof(result_type) * __CHAR_BIT__ - 1)/32\x0a"
"                             \x3a  (__m > 0x100000000ull))>());}\x0a"
"\x0a"
"    // generating functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator()()\x0a"
"        {return __x_ = static_cast<result_type>(__lce_ta<__a, __c, __m, _Mp>\x3a\x3anext(__x_));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void discard(unsigned long long __z) {for (; __z; --__z) operator()();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator==(const linear_congruential_engine\x26 __x,\x0a"
"                    const linear_congruential_engine\x26 __y)\x0a"
"        {return __x.__x_ == __y.__x_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const linear_congruential_engine\x26 __x,\x0a"
"                    const linear_congruential_engine\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed(true_type, true_type, result_type __s) {__x_ = __s == 0 \x3f 1 \x3a __s;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed(true_type, false_type, result_type __s) {__x_ = __s;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed(false_type, true_type, result_type __s) {__x_ = __s \x25 __m == 0 \x3f\x0a"
"                                                                 1 \x3a __s \x25 __m;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed(false_type, false_type, result_type __s) {__x_ = __s \x25 __m;}\x0a"
"\x0a"
"    template<class _Sseq>\x0a"
"        void __seed(_Sseq\x26 __q, integral_constant<unsigned, 1>);\x0a"
"    template<class _Sseq>\x0a"
"        void __seed(_Sseq\x26 __q, integral_constant<unsigned, 2>);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _Up, _Up _Ap, _Up _Cp, _Up _Np>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const linear_congruential_engine<_Up, _Ap, _Cp, _Np>\x26);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _Up, _Up _Ap, _Up _Cp, _Up _Np>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               linear_congruential_engine<_Up, _Ap, _Cp, _Np>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template <class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>\x0a"
"    _LIBCPP_CONSTEXPR const typename linear_congruential_engine<_UIntType, __a, __c, __m>\x3a\x3aresult_type\x0a"
"    linear_congruential_engine<_UIntType, __a, __c, __m>\x3a\x3amultiplier;\x0a"
"\x0a"
"template <class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>\x0a"
"    _LIBCPP_CONSTEXPR const typename linear_congruential_engine<_UIntType, __a, __c, __m>\x3a\x3aresult_type\x0a"
"    linear_congruential_engine<_UIntType, __a, __c, __m>\x3a\x3aincrement;\x0a"
"\x0a"
"template <class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>\x0a"
"    _LIBCPP_CONSTEXPR const typename linear_congruential_engine<_UIntType, __a, __c, __m>\x3a\x3aresult_type\x0a"
"    linear_congruential_engine<_UIntType, __a, __c, __m>\x3a\x3amodulus;\x0a"
"\x0a"
"template <class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>\x0a"
"    _LIBCPP_CONSTEXPR const typename linear_congruential_engine<_UIntType, __a, __c, __m>\x3a\x3aresult_type\x0a"
"    linear_congruential_engine<_UIntType, __a, __c, __m>\x3a\x3a""default_seed;\x0a"
"\x0a"
"template <class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>\x0a"
"template<class _Sseq>\x0a"
"void\x0a"
"linear_congruential_engine<_UIntType, __a, __c, __m>\x3a\x3a__seed(_Sseq\x26 __q,\x0a"
"                                                 integral_constant<unsigned, 1>)\x0a"
"{\x0a"
"    const unsigned __k = 1;\x0a"
"    uint32_t __ar\x5b__k+3\x5d;\x0a"
"    __q.generate(__ar, __ar + __k + 3);\x0a"
"    result_type __s = static_cast<result_type>(__ar\x5b""3\x5d \x25 __m);\x0a"
"    __x_ = __c == 0 \x26\x26 __s == 0 \x3f result_type(1) \x3a __s;\x0a"
"}\x0a"
"\x0a"
"template <class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>\x0a"
"template<class _Sseq>\x0a"
"void\x0a"
"linear_congruential_engine<_UIntType, __a, __c, __m>\x3a\x3a__seed(_Sseq\x26 __q,\x0a"
"                                                 integral_constant<unsigned, 2>)\x0a"
"{\x0a"
"    const unsigned __k = 2;\x0a"
"    uint32_t __ar\x5b__k+3\x5d;\x0a"
"    __q.generate(__ar, __ar + __k + 3);\x0a"
"    result_type __s = static_cast<result_type>((__ar\x5b""3\x5d +\x0a"
"                                              ((uint64_t)__ar\x5b""4\x5d << 32)) \x25 __m);\x0a"
"    __x_ = __c == 0 \x26\x26 __s == 0 \x3f result_type(1) \x3a __s;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const linear_congruential_engine<_UIntType, __a, __c, __m>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft);\x0a"
"    __os.fill(__os.widen(' '));\x0a"
"    return __os << __x.__x_;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           linear_congruential_engine<_UIntType, __a, __c, __m>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    _UIntType __t;\x0a"
"    __is >> __t;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.__x_ = __t;\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"typedef linear_congruential_engine<uint_fast32_t, 16807, 0, 2147483647>\x0a"
"                                                                   minstd_rand0;\x0a"
"typedef linear_congruential_engine<uint_fast32_t, 48271, 0, 2147483647>\x0a"
"                                                                    minstd_rand;\x0a"
"typedef minstd_rand                                       default_random_engine;\x0a"
"// mersenne_twister_engine\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"class _LIBCPP_TEMPLATE_VIS mersenne_twister_engine;\x0a"
"\x0a"
"template <class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"          _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"          _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"bool\x0a"
"operator==(const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                         _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x,\x0a"
"           const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                         _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __y);\x0a"
"\x0a"
"template <class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"          _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"          _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                         _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x,\x0a"
"           const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                         _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __y);\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"          _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"          _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                         _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x);\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"          _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"          _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                   _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x);\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"class _LIBCPP_TEMPLATE_VIS mersenne_twister_engine\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _UIntType result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    result_type __x_\x5b__n\x5d;\x0a"
"    size_t      __i_;\x0a"
"\x0a"
"    static_assert(  0 <  __m, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__m <= __n, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Dt = numeric_limits<result_type>\x3a\x3a""digits;\x0a"
"    static_assert(__w <= _Dt, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(  2 <= __w, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__r <= __w, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__u <= __w, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__s <= __w, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__t <= __w, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__l <= __w, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"public\x3a\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Min = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Max = __w == _Dt \x3f result_type(\x7e""0) \x3a\x0a"
"                                                      (result_type(1) << __w) - result_type(1);\x0a"
"    static_assert(_Min < _Max, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__a <= _Max, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__b <= _Max, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__c <= _Max, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__d <= _Max, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"    static_assert(__f <= _Max, \x22mersenne_twister_engine invalid parameters\x22);\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    static _LIBCPP_CONSTEXPR const size_t word_size = __w;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t state_size = __n;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t shift_size = __m;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t mask_bits = __r;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type xor_mask = __a;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t tempering_u = __u;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type tempering_d = __d;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t tempering_s = __s;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type tempering_b = __b;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t tempering_t = __t;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type tempering_c = __c;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t tempering_l = __l;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type initialization_multiplier = __f;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type min() { return _Min; }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type max() { return _Max; }\x0a"
"    static _LIBCPP_CONSTEXPR const result_type default_seed = 5489u;\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit mersenne_twister_engine(result_type __sd = default_seed)\x0a"
"        {seed(__sd);}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit mersenne_twister_engine(_Sseq\x26 __q,\x0a"
"        typename enable_if<__is_seed_sequence<_Sseq, mersenne_twister_engine>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"        {seed(__q);}\x0a"
"    void seed(result_type __sd = default_seed);\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_seed_sequence<_Sseq, mersenne_twister_engine>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        seed(_Sseq\x26 __q)\x0a"
"            {__seed(__q, integral_constant<unsigned, 1 + (__w - 1) / 32>());}\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void discard(unsigned long long __z) {for (; __z; --__z) operator()();}\x0a"
"\x0a"
"    template <class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"              _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"              _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator==(const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                             _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x,\x0a"
"               const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                             _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __y);\x0a"
"\x0a"
"    template <class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"              _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"              _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator\x21=(const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                             _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x,\x0a"
"               const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                             _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __y);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"              _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"              _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                             _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"              _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"              _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                       _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x);\x0a"
"private\x3a\x0a"
"\x0a"
"    template<class _Sseq>\x0a"
"        void __seed(_Sseq\x26 __q, integral_constant<unsigned, 1>);\x0a"
"    template<class _Sseq>\x0a"
"        void __seed(_Sseq\x26 __q, integral_constant<unsigned, 2>);\x0a"
"\x0a"
"    template <size_t __count>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __count < __w,\x0a"
"            result_type\x0a"
"        >\x3a\x3atype\x0a"
"        __lshift(result_type __x) {return (__x << __count) \x26 _Max;}\x0a"
"\x0a"
"    template <size_t __count>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            (__count >= __w),\x0a"
"            result_type\x0a"
"        >\x3a\x3atype\x0a"
"        __lshift(result_type) {return result_type(0);}\x0a"
"\x0a"
"    template <size_t __count>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __count < _Dt,\x0a"
"            result_type\x0a"
"        >\x3a\x3atype\x0a"
"        __rshift(result_type __x) {return __x >> __count;}\x0a"
"\x0a"
"    template <size_t __count>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            (__count >= _Dt),\x0a"
"            result_type\x0a"
"        >\x3a\x3atype\x0a"
"        __rshift(result_type) {return result_type(0);}\x0a"
"};\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const size_t\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3aword_size;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const size_t\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3astate_size;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const size_t\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3ashift_size;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const size_t\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3amask_bits;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const typename mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3aresult_type\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3axor_mask;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const size_t\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3atempering_u;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const typename mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3aresult_type\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3atempering_d;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const size_t\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3atempering_s;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const typename mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3aresult_type\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3atempering_b;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const size_t\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3atempering_t;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const typename mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3aresult_type\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3atempering_c;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const size_t\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3atempering_l;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const typename mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3aresult_type\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3ainitialization_multiplier;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"    _LIBCPP_CONSTEXPR const typename mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3aresult_type\x0a"
"    mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b, __t, __c, __l, __f>\x3a\x3a""default_seed;\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"void\x0a"
"mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b,\x0a"
"    __t, __c, __l, __f>\x3a\x3aseed(result_type __sd)\x0a"
"    _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"{   // __w >= 2\x0a"
"    __x_\x5b""0\x5d = __sd \x26 _Max;\x0a"
"    for (size_t __i = 1; __i < __n; ++__i)\x0a"
"        __x_\x5b__i\x5d = (__f * (__x_\x5b__i-1\x5d ^ __rshift<__w - 2>(__x_\x5b__i-1\x5d)) + __i) \x26 _Max;\x0a"
"    __i_ = 0;\x0a"
"}\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"template<class _Sseq>\x0a"
"void\x0a"
"mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b,\x0a"
"    __t, __c, __l, __f>\x3a\x3a__seed(_Sseq\x26 __q, integral_constant<unsigned, 1>)\x0a"
"{\x0a"
"    const unsigned __k = 1;\x0a"
"    uint32_t __ar\x5b__n * __k\x5d;\x0a"
"    __q.generate(__ar, __ar + __n * __k);\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __x_\x5b__i\x5d = static_cast<result_type>(__ar\x5b__i\x5d \x26 _Max);\x0a"
"    const result_type __mask = __r == _Dt \x3f result_type(\x7e""0) \x3a\x0a"
"                                       (result_type(1) << __r) - result_type(1);\x0a"
"    __i_ = 0;\x0a"
"    if ((__x_\x5b""0\x5d \x26 \x7e__mask) == 0)\x0a"
"    {\x0a"
"        for (size_t __i = 1; __i < __n; ++__i)\x0a"
"            if (__x_\x5b__i\x5d \x21= 0)\x0a"
"                return;\x0a"
"        __x_\x5b""0\x5d = result_type(1) << (__w - 1);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"template<class _Sseq>\x0a"
"void\x0a"
"mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b,\x0a"
"    __t, __c, __l, __f>\x3a\x3a__seed(_Sseq\x26 __q, integral_constant<unsigned, 2>)\x0a"
"{\x0a"
"    const unsigned __k = 2;\x0a"
"    uint32_t __ar\x5b__n * __k\x5d;\x0a"
"    __q.generate(__ar, __ar + __n * __k);\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __x_\x5b__i\x5d = static_cast<result_type>(\x0a"
"            (__ar\x5b""2 * __i\x5d + ((uint64_t)__ar\x5b""2 * __i + 1\x5d << 32)) \x26 _Max);\x0a"
"    const result_type __mask = __r == _Dt \x3f result_type(\x7e""0) \x3a\x0a"
"                                       (result_type(1) << __r) - result_type(1);\x0a"
"    __i_ = 0;\x0a"
"    if ((__x_\x5b""0\x5d \x26 \x7e__mask) == 0)\x0a"
"    {\x0a"
"        for (size_t __i = 1; __i < __n; ++__i)\x0a"
"            if (__x_\x5b__i\x5d \x21= 0)\x0a"
"                return;\x0a"
"        __x_\x5b""0\x5d = result_type(1) << (__w - 1);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _UIntType, size_t __w, size_t __n, size_t __m, size_t __r,\x0a"
"          _UIntType __a, size_t __u, _UIntType __d, size_t __s,\x0a"
"          _UIntType __b, size_t __t, _UIntType __c, size_t __l, _UIntType __f>\x0a"
"_UIntType\x0a"
"mersenne_twister_engine<_UIntType, __w, __n, __m, __r, __a, __u, __d, __s, __b,\x0a"
"    __t, __c, __l, __f>\x3a\x3aoperator()()\x0a"
"{\x0a"
"    const size_t __j = (__i_ + 1) \x25 __n;\x0a"
"    const result_type __mask = __r == _Dt \x3f result_type(\x7e""0) \x3a\x0a"
"                                       (result_type(1) << __r) - result_type(1);\x0a"
"    const result_type _Yp = (__x_\x5b__i_\x5d \x26 \x7e__mask) \x7c (__x_\x5b__j\x5d \x26 __mask);\x0a"
"    const size_t __k = (__i_ + __m) \x25 __n;\x0a"
"    __x_\x5b__i_\x5d = __x_\x5b__k\x5d ^ __rshift<1>(_Yp) ^ (__a * (_Yp \x26 1));\x0a"
"    result_type __z = __x_\x5b__i_\x5d ^ (__rshift<__u>(__x_\x5b__i_\x5d) \x26 __d);\x0a"
"    __i_ = __j;\x0a"
"    __z ^= __lshift<__s>(__z) \x26 __b;\x0a"
"    __z ^= __lshift<__t>(__z) \x26 __c;\x0a"
"    return __z ^ __rshift<__l>(__z);\x0a"
"}\x0a"
"\x0a"
"template <class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"          _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"          _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"bool\x0a"
"operator==(const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                         _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x,\x0a"
"           const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                         _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __y)\x0a"
"{\x0a"
"    if (__x.__i_ == __y.__i_)\x0a"
"        return _VSTD\x3a\x3a""equal(__x.__x_, __x.__x_ + _Np, __y.__x_);\x0a"
"    if (__x.__i_ == 0 \x7c\x7c __y.__i_ == 0)\x0a"
"    {\x0a"
"        size_t __j = _VSTD\x3a\x3amin(_Np - __x.__i_, _Np - __y.__i_);\x0a"
"        if (\x21_VSTD\x3a\x3a""equal(__x.__x_ + __x.__i_, __x.__x_ + __x.__i_ + __j,\x0a"
"                         __y.__x_ + __y.__i_))\x0a"
"            return false;\x0a"
"        if (__x.__i_ == 0)\x0a"
"            return _VSTD\x3a\x3a""equal(__x.__x_ + __j, __x.__x_ + _Np, __y.__x_);\x0a"
"        return _VSTD\x3a\x3a""equal(__x.__x_, __x.__x_ + (_Np - __j), __y.__x_ + __j);\x0a"
"    }\x0a"
"    if (__x.__i_ < __y.__i_)\x0a"
"    {\x0a"
"        size_t __j = _Np - __y.__i_;\x0a"
"        if (\x21_VSTD\x3a\x3a""equal(__x.__x_ + __x.__i_, __x.__x_ + (__x.__i_ + __j),\x0a"
"                         __y.__x_ + __y.__i_))\x0a"
"            return false;\x0a"
"        if (\x21_VSTD\x3a\x3a""equal(__x.__x_ + (__x.__i_ + __j), __x.__x_ + _Np,\x0a"
"                         __y.__x_))\x0a"
"            return false;\x0a"
"        return _VSTD\x3a\x3a""equal(__x.__x_, __x.__x_ + __x.__i_,\x0a"
"                           __y.__x_ + (_Np - (__x.__i_ + __j)));\x0a"
"    }\x0a"
"    size_t __j = _Np - __x.__i_;\x0a"
"    if (\x21_VSTD\x3a\x3a""equal(__y.__x_ + __y.__i_, __y.__x_ + (__y.__i_ + __j),\x0a"
"                     __x.__x_ + __x.__i_))\x0a"
"        return false;\x0a"
"    if (\x21_VSTD\x3a\x3a""equal(__y.__x_ + (__y.__i_ + __j), __y.__x_ + _Np,\x0a"
"                     __x.__x_))\x0a"
"        return false;\x0a"
"    return _VSTD\x3a\x3a""equal(__y.__x_, __y.__x_ + __y.__i_,\x0a"
"                       __x.__x_ + (_Np - (__y.__i_ + __j)));\x0a"
"}\x0a"
"\x0a"
"template <class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"          _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"          _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                         _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x,\x0a"
"           const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                         _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"          _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"          _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                         _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    __os << __x.__x_\x5b__x.__i_\x5d;\x0a"
"    for (size_t __j = __x.__i_ + 1; __j < _Np; ++__j)\x0a"
"        __os << __sp << __x.__x_\x5b__j\x5d;\x0a"
"    for (size_t __j = 0; __j < __x.__i_; ++__j)\x0a"
"        __os << __sp << __x.__x_\x5b__j\x5d;\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _UInt, size_t _Wp, size_t _Np, size_t _Mp, size_t _Rp,\x0a"
"          _UInt _Ap, size_t _Up, _UInt _Dp, size_t _Sp,\x0a"
"          _UInt _Bp, size_t _Tp, _UInt _Cp, size_t _Lp, _UInt _Fp>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           mersenne_twister_engine<_UInt, _Wp, _Np, _Mp, _Rp, _Ap, _Up, _Dp, _Sp,\x0a"
"                                   _Bp, _Tp, _Cp, _Lp, _Fp>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    _UInt __t\x5b_Np\x5d;\x0a"
"    for (size_t __i = 0; __i < _Np; ++__i)\x0a"
"        __is >> __t\x5b__i\x5d;\x0a"
"    if (\x21__is.fail())\x0a"
"    {\x0a"
"        for (size_t __i = 0; __i < _Np; ++__i)\x0a"
"            __x.__x_\x5b__i\x5d = __t\x5b__i\x5d;\x0a"
"        __x.__i_ = 0;\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"typedef mersenne_twister_engine<uint_fast32_t, 32, 624, 397, 31,\x0a"
"                                0x9908b0df, 11, 0xffffffff,\x0a"
"                                7,  0x9d2c5680,\x0a"
"                                15, 0xefc60000,\x0a"
"                                18, 1812433253>                         mt19937;\x0a"
"typedef mersenne_twister_engine<uint_fast64_t, 64, 312, 156, 31,\x0a"
"                                0xb5026f5aa96619e9ULL, 29, 0x5555555555555555ULL,\x0a"
"                                17, 0x71d67fffeda60000ULL,\x0a"
"                                37, 0xfff7eee000000000ULL,\x0a"
"                                43, 6364136223846793005ULL>          mt19937_64;\x0a"
"\x0a"
"// subtract_with_carry_engine\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"class _LIBCPP_TEMPLATE_VIS subtract_with_carry_engine;\x0a"
"\x0a"
"template<class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"bool\x0a"
"operator==(\x0a"
"    const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x,\x0a"
"    const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __y);\x0a"
"\x0a"
"template<class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(\x0a"
"    const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x,\x0a"
"    const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __y);\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x);\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x);\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"class _LIBCPP_TEMPLATE_VIS subtract_with_carry_engine\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _UIntType result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    result_type __x_\x5b__r\x5d;\x0a"
"    result_type  __c_;\x0a"
"    size_t      __i_;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Dt = numeric_limits<result_type>\x3a\x3a""digits;\x0a"
"    static_assert(  0 <  __w, \x22subtract_with_carry_engine invalid parameters\x22);\x0a"
"    static_assert(__w <= _Dt, \x22subtract_with_carry_engine invalid parameters\x22);\x0a"
"    static_assert(  0 <  __s, \x22subtract_with_carry_engine invalid parameters\x22);\x0a"
"    static_assert(__s <  __r, \x22subtract_with_carry_engine invalid parameters\x22);\x0a"
"public\x3a\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Min = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Max = __w == _Dt \x3f result_type(\x7e""0) \x3a\x0a"
"                                                      (result_type(1) << __w) - result_type(1);\x0a"
"    static_assert(_Min < _Max, \x22subtract_with_carry_engine invalid parameters\x22);\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    static _LIBCPP_CONSTEXPR const size_t word_size = __w;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t short_lag = __s;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t long_lag = __r;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type min() { return _Min; }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type max() { return _Max; }\x0a"
"    static _LIBCPP_CONSTEXPR const result_type default_seed = 19780503u;\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit subtract_with_carry_engine(result_type __sd = default_seed)\x0a"
"        {seed(__sd);}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit subtract_with_carry_engine(_Sseq\x26 __q,\x0a"
"        typename enable_if<__is_seed_sequence<_Sseq, subtract_with_carry_engine>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"        {seed(__q);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed(result_type __sd = default_seed)\x0a"
"        {seed(__sd, integral_constant<unsigned, 1 + (__w - 1) / 32>());}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_seed_sequence<_Sseq, subtract_with_carry_engine>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        seed(_Sseq\x26 __q)\x0a"
"            {__seed(__q, integral_constant<unsigned, 1 + (__w - 1) / 32>());}\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void discard(unsigned long long __z) {for (; __z; --__z) operator()();}\x0a"
"\x0a"
"    template<class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator==(\x0a"
"        const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x,\x0a"
"        const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __y);\x0a"
"\x0a"
"    template<class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator\x21=(\x0a"
"        const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x,\x0a"
"        const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __y);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x);\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"    void seed(result_type __sd, integral_constant<unsigned, 1>);\x0a"
"    void seed(result_type __sd, integral_constant<unsigned, 2>);\x0a"
"    template<class _Sseq>\x0a"
"        void __seed(_Sseq\x26 __q, integral_constant<unsigned, 1>);\x0a"
"    template<class _Sseq>\x0a"
"        void __seed(_Sseq\x26 __q, integral_constant<unsigned, 2>);\x0a"
"};\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"    _LIBCPP_CONSTEXPR const size_t subtract_with_carry_engine<_UIntType, __w, __s, __r>\x3a\x3aword_size;\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"    _LIBCPP_CONSTEXPR const size_t subtract_with_carry_engine<_UIntType, __w, __s, __r>\x3a\x3ashort_lag;\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"    _LIBCPP_CONSTEXPR const size_t subtract_with_carry_engine<_UIntType, __w, __s, __r>\x3a\x3along_lag;\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"    _LIBCPP_CONSTEXPR const typename subtract_with_carry_engine<_UIntType, __w, __s, __r>\x3a\x3aresult_type\x0a"
"    subtract_with_carry_engine<_UIntType, __w, __s, __r>\x3a\x3a""default_seed;\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"void\x0a"
"subtract_with_carry_engine<_UIntType, __w, __s, __r>\x3a\x3aseed(result_type __sd,\x0a"
"        integral_constant<unsigned, 1>)\x0a"
"{\x0a"
"    linear_congruential_engine<result_type, 40014u, 0u, 2147483563u>\x0a"
"        __e(__sd == 0u \x3f default_seed \x3a __sd);\x0a"
"    for (size_t __i = 0; __i < __r; ++__i)\x0a"
"        __x_\x5b__i\x5d = static_cast<result_type>(__e() \x26 _Max);\x0a"
"    __c_ = __x_\x5b__r-1\x5d == 0;\x0a"
"    __i_ = 0;\x0a"
"}\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"void\x0a"
"subtract_with_carry_engine<_UIntType, __w, __s, __r>\x3a\x3aseed(result_type __sd,\x0a"
"        integral_constant<unsigned, 2>)\x0a"
"{\x0a"
"    linear_congruential_engine<result_type, 40014u, 0u, 2147483563u>\x0a"
"        __e(__sd == 0u \x3f default_seed \x3a __sd);\x0a"
"    for (size_t __i = 0; __i < __r; ++__i)\x0a"
"    {\x0a"
"        result_type __e0 = __e();\x0a"
"        __x_\x5b__i\x5d = static_cast<result_type>(\x0a"
"                                    (__e0 + ((uint64_t)__e() << 32)) \x26 _Max);\x0a"
"    }\x0a"
"    __c_ = __x_\x5b__r-1\x5d == 0;\x0a"
"    __i_ = 0;\x0a"
"}\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"template<class _Sseq>\x0a"
"void\x0a"
"subtract_with_carry_engine<_UIntType, __w, __s, __r>\x3a\x3a__seed(_Sseq\x26 __q,\x0a"
"        integral_constant<unsigned, 1>)\x0a"
"{\x0a"
"    const unsigned __k = 1;\x0a"
"    uint32_t __ar\x5b__r * __k\x5d;\x0a"
"    __q.generate(__ar, __ar + __r * __k);\x0a"
"    for (size_t __i = 0; __i < __r; ++__i)\x0a"
"        __x_\x5b__i\x5d = static_cast<result_type>(__ar\x5b__i\x5d \x26 _Max);\x0a"
"    __c_ = __x_\x5b__r-1\x5d == 0;\x0a"
"    __i_ = 0;\x0a"
"}\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"template<class _Sseq>\x0a"
"void\x0a"
"subtract_with_carry_engine<_UIntType, __w, __s, __r>\x3a\x3a__seed(_Sseq\x26 __q,\x0a"
"        integral_constant<unsigned, 2>)\x0a"
"{\x0a"
"    const unsigned __k = 2;\x0a"
"    uint32_t __ar\x5b__r * __k\x5d;\x0a"
"    __q.generate(__ar, __ar + __r * __k);\x0a"
"    for (size_t __i = 0; __i < __r; ++__i)\x0a"
"        __x_\x5b__i\x5d = static_cast<result_type>(\x0a"
"                  (__ar\x5b""2 * __i\x5d + ((uint64_t)__ar\x5b""2 * __i + 1\x5d << 32)) \x26 _Max);\x0a"
"    __c_ = __x_\x5b__r-1\x5d == 0;\x0a"
"    __i_ = 0;\x0a"
"}\x0a"
"\x0a"
"template<class _UIntType, size_t __w, size_t __s, size_t __r>\x0a"
"_UIntType\x0a"
"subtract_with_carry_engine<_UIntType, __w, __s, __r>\x3a\x3aoperator()()\x0a"
"{\x0a"
"    const result_type\x26 __xs = __x_\x5b(__i_ + (__r - __s)) \x25 __r\x5d;\x0a"
"    result_type\x26 __xr = __x_\x5b__i_\x5d;\x0a"
"    result_type __new_c = __c_ == 0 \x3f __xs < __xr \x3a __xs \x21= 0 \x3f __xs <= __xr \x3a 1;\x0a"
"    __xr = (__xs - __xr - __c_) \x26 _Max;\x0a"
"    __c_ = __new_c;\x0a"
"    __i_ = (__i_ + 1) \x25 __r;\x0a"
"    return __xr;\x0a"
"}\x0a"
"\x0a"
"template<class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"bool\x0a"
"operator==(\x0a"
"    const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x,\x0a"
"    const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __y)\x0a"
"{\x0a"
"    if (__x.__c_ \x21= __y.__c_)\x0a"
"        return false;\x0a"
"    if (__x.__i_ == __y.__i_)\x0a"
"        return _VSTD\x3a\x3a""equal(__x.__x_, __x.__x_ + _Rp, __y.__x_);\x0a"
"    if (__x.__i_ == 0 \x7c\x7c __y.__i_ == 0)\x0a"
"    {\x0a"
"        size_t __j = _VSTD\x3a\x3amin(_Rp - __x.__i_, _Rp - __y.__i_);\x0a"
"        if (\x21_VSTD\x3a\x3a""equal(__x.__x_ + __x.__i_, __x.__x_ + __x.__i_ + __j,\x0a"
"                         __y.__x_ + __y.__i_))\x0a"
"            return false;\x0a"
"        if (__x.__i_ == 0)\x0a"
"            return _VSTD\x3a\x3a""equal(__x.__x_ + __j, __x.__x_ + _Rp, __y.__x_);\x0a"
"        return _VSTD\x3a\x3a""equal(__x.__x_, __x.__x_ + (_Rp - __j), __y.__x_ + __j);\x0a"
"    }\x0a"
"    if (__x.__i_ < __y.__i_)\x0a"
"    {\x0a"
"        size_t __j = _Rp - __y.__i_;\x0a"
"        if (\x21_VSTD\x3a\x3a""equal(__x.__x_ + __x.__i_, __x.__x_ + (__x.__i_ + __j),\x0a"
"                         __y.__x_ + __y.__i_))\x0a"
"            return false;\x0a"
"        if (\x21_VSTD\x3a\x3a""equal(__x.__x_ + (__x.__i_ + __j), __x.__x_ + _Rp,\x0a"
"                         __y.__x_))\x0a"
"            return false;\x0a"
"        return _VSTD\x3a\x3a""equal(__x.__x_, __x.__x_ + __x.__i_,\x0a"
"                           __y.__x_ + (_Rp - (__x.__i_ + __j)));\x0a"
"    }\x0a"
"    size_t __j = _Rp - __x.__i_;\x0a"
"    if (\x21_VSTD\x3a\x3a""equal(__y.__x_ + __y.__i_, __y.__x_ + (__y.__i_ + __j),\x0a"
"                     __x.__x_ + __x.__i_))\x0a"
"        return false;\x0a"
"    if (\x21_VSTD\x3a\x3a""equal(__y.__x_ + (__y.__i_ + __j), __y.__x_ + _Rp,\x0a"
"                     __x.__x_))\x0a"
"        return false;\x0a"
"    return _VSTD\x3a\x3a""equal(__y.__x_, __y.__x_ + __y.__i_,\x0a"
"                       __x.__x_ + (_Rp - (__y.__i_ + __j)));\x0a"
"}\x0a"
"\x0a"
"template<class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(\x0a"
"    const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x,\x0a"
"    const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    __os << __x.__x_\x5b__x.__i_\x5d;\x0a"
"    for (size_t __j = __x.__i_ + 1; __j < _Rp; ++__j)\x0a"
"        __os << __sp << __x.__x_\x5b__j\x5d;\x0a"
"    for (size_t __j = 0; __j < __x.__i_; ++__j)\x0a"
"        __os << __sp << __x.__x_\x5b__j\x5d;\x0a"
"    __os << __sp << __x.__c_;\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _UInt, size_t _Wp, size_t _Sp, size_t _Rp>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           subtract_with_carry_engine<_UInt, _Wp, _Sp, _Rp>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    _UInt __t\x5b_Rp+1\x5d;\x0a"
"    for (size_t __i = 0; __i < _Rp+1; ++__i)\x0a"
"        __is >> __t\x5b__i\x5d;\x0a"
"    if (\x21__is.fail())\x0a"
"    {\x0a"
"        for (size_t __i = 0; __i < _Rp; ++__i)\x0a"
"            __x.__x_\x5b__i\x5d = __t\x5b__i\x5d;\x0a"
"        __x.__c_ = __t\x5b_Rp\x5d;\x0a"
"        __x.__i_ = 0;\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"typedef subtract_with_carry_engine<uint_fast32_t, 24, 10, 24>     ranlux24_base;\x0a"
"typedef subtract_with_carry_engine<uint_fast64_t, 48,  5, 12>     ranlux48_base;\x0a"
"\x0a"
"// discard_block_engine\x0a"
"\x0a"
"template<class _Engine, size_t __p, size_t __r>\x0a"
"class _LIBCPP_TEMPLATE_VIS discard_block_engine\x0a"
"{\x0a"
"    _Engine __e_;\x0a"
"    int     __n_;\x0a"
"\x0a"
"    static_assert(  0 <  __r, \x22""discard_block_engine invalid parameters\x22);\x0a"
"    static_assert(__r <= __p, \x22""discard_block_engine invalid parameters\x22);\x0a"
"    static_assert(__r <= INT_MAX, \x22""discard_block_engine invalid parameters\x22);\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef typename _Engine\x3a\x3aresult_type result_type;\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    static _LIBCPP_CONSTEXPR const size_t block_size = __p;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t used_block = __r;\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    static const result_type _Min = _Engine\x3a\x3a_Min;\x0a"
"    static const result_type _Max = _Engine\x3a\x3a_Max;\x0a"
"#else\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Min = _Engine\x3a\x3amin();\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Max = _Engine\x3a\x3amax();\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type min() { return _Engine\x3a\x3amin(); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type max() { return _Engine\x3a\x3amax(); }\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    discard_block_engine() \x3a __n_(0) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit discard_block_engine(const _Engine\x26 __e)\x0a"
"        \x3a __e_(__e), __n_(0) {}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit discard_block_engine(_Engine\x26\x26 __e)\x0a"
"        \x3a __e_(_VSTD\x3a\x3amove(__e)), __n_(0) {}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit discard_block_engine(result_type __sd) \x3a __e_(__sd), __n_(0) {}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit discard_block_engine(_Sseq\x26 __q,\x0a"
"        typename enable_if<__is_seed_sequence<_Sseq, discard_block_engine>\x3a\x3avalue \x26\x26\x0a"
"                           \x21is_convertible<_Sseq, _Engine>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"        \x3a __e_(__q), __n_(0) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed() {__e_.seed(); __n_ = 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed(result_type __sd) {__e_.seed(__sd); __n_ = 0;}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_seed_sequence<_Sseq, discard_block_engine>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        seed(_Sseq\x26 __q) {__e_.seed(__q); __n_ = 0;}\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void discard(unsigned long long __z) {for (; __z; --__z) operator()();}\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Engine\x26 base() const _NOEXCEPT {return __e_;}\x0a"
"\x0a"
"    template<class _Eng, size_t _Pp, size_t _Rp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator==(\x0a"
"        const discard_block_engine<_Eng, _Pp, _Rp>\x26 __x,\x0a"
"        const discard_block_engine<_Eng, _Pp, _Rp>\x26 __y);\x0a"
"\x0a"
"    template<class _Eng, size_t _Pp, size_t _Rp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator\x21=(\x0a"
"        const discard_block_engine<_Eng, _Pp, _Rp>\x26 __x,\x0a"
"        const discard_block_engine<_Eng, _Pp, _Rp>\x26 __y);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _Eng, size_t _Pp, size_t _Rp>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const discard_block_engine<_Eng, _Pp, _Rp>\x26 __x);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _Eng, size_t _Pp, size_t _Rp>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               discard_block_engine<_Eng, _Pp, _Rp>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template<class _Engine, size_t __p, size_t __r>\x0a"
"    _LIBCPP_CONSTEXPR const size_t discard_block_engine<_Engine, __p, __r>\x3a\x3a""block_size;\x0a"
"\x0a"
"template<class _Engine, size_t __p, size_t __r>\x0a"
"    _LIBCPP_CONSTEXPR const size_t discard_block_engine<_Engine, __p, __r>\x3a\x3aused_block;\x0a"
"\x0a"
"template<class _Engine, size_t __p, size_t __r>\x0a"
"typename discard_block_engine<_Engine, __p, __r>\x3a\x3aresult_type\x0a"
"discard_block_engine<_Engine, __p, __r>\x3a\x3aoperator()()\x0a"
"{\x0a"
"    if (__n_ >= static_cast<int>(__r))\x0a"
"    {\x0a"
"        __e_.discard(__p - __r);\x0a"
"        __n_ = 0;\x0a"
"    }\x0a"
"    ++__n_;\x0a"
"    return __e_();\x0a"
"}\x0a"
"\x0a"
"template<class _Eng, size_t _Pp, size_t _Rp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const discard_block_engine<_Eng, _Pp, _Rp>\x26 __x,\x0a"
"           const discard_block_engine<_Eng, _Pp, _Rp>\x26 __y)\x0a"
"{\x0a"
"    return __x.__n_ == __y.__n_ \x26\x26 __x.__e_ == __y.__e_;\x0a"
"}\x0a"
"\x0a"
"template<class _Eng, size_t _Pp, size_t _Rp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const discard_block_engine<_Eng, _Pp, _Rp>\x26 __x,\x0a"
"           const discard_block_engine<_Eng, _Pp, _Rp>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _Eng, size_t _Pp, size_t _Rp>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const discard_block_engine<_Eng, _Pp, _Rp>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    return __os << __x.__e_ << __sp << __x.__n_;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _Eng, size_t _Pp, size_t _Rp>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           discard_block_engine<_Eng, _Pp, _Rp>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    _Eng __e;\x0a"
"    int __n;\x0a"
"    __is >> __e >> __n;\x0a"
"    if (\x21__is.fail())\x0a"
"    {\x0a"
"        __x.__e_ = __e;\x0a"
"        __x.__n_ = __n;\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"typedef discard_block_engine<ranlux24_base, 223, 23> ranlux24;\x0a"
"typedef discard_block_engine<ranlux48_base, 389, 11> ranlux48;\x0a"
"\x0a"
"// independent_bits_engine\x0a"
"\x0a"
"template<class _Engine, size_t __w, class _UIntType>\x0a"
"class _LIBCPP_TEMPLATE_VIS independent_bits_engine\x0a"
"{\x0a"
"    template <class _UInt, _UInt _R0, size_t _Wp, size_t _Mp>\x0a"
"    class __get_n\x0a"
"    {\x0a"
"        static _LIBCPP_CONSTEXPR const size_t _Dt = numeric_limits<_UInt>\x3a\x3a""digits;\x0a"
"        static _LIBCPP_CONSTEXPR const size_t _Np = _Wp / _Mp + (_Wp \x25 _Mp \x21= 0);\x0a"
"        static _LIBCPP_CONSTEXPR const size_t _W0 = _Wp / _Np;\x0a"
"        static _LIBCPP_CONSTEXPR const _UInt _Y0 = _W0 >= _Dt \x3f 0 \x3a (_R0 >> _W0) << _W0;\x0a"
"    public\x3a\x0a"
"        static _LIBCPP_CONSTEXPR const size_t value = _R0 - _Y0 > _Y0 / _Np \x3f _Np + 1 \x3a _Np;\x0a"
"    };\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _UIntType result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    _Engine __e_;\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Dt = numeric_limits<result_type>\x3a\x3a""digits;\x0a"
"    static_assert(  0 <  __w, \x22independent_bits_engine invalid parameters\x22);\x0a"
"    static_assert(__w <= _Dt, \x22independent_bits_engine invalid parameters\x22);\x0a"
"\x0a"
"    typedef typename _Engine\x3a\x3aresult_type _Engine_result_type;\x0a"
"    typedef typename conditional\x0a"
"        <\x0a"
"            sizeof(_Engine_result_type) <= sizeof(result_type),\x0a"
"                result_type,\x0a"
"                _Engine_result_type\x0a"
"        >\x3a\x3atype _Working_result_type;\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    static const _Working_result_type _Rp = _Engine\x3a\x3a_Max - _Engine\x3a\x3a_Min\x0a"
"                                          + _Working_result_type(1);\x0a"
"#else\x0a"
"    static _LIBCPP_CONSTEXPR const _Working_result_type _Rp = _Engine\x3a\x3amax() - _Engine\x3a\x3amin()\x0a"
"                                                            + _Working_result_type(1);\x0a"
"#endif\x0a"
"    static _LIBCPP_CONSTEXPR const size_t __m = __log2<_Working_result_type, _Rp>\x3a\x3avalue;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t __n = __get_n<_Working_result_type, _Rp, __w, __m>\x3a\x3avalue;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t __w0 = __w / __n;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t __n0 = __n - __w \x25 __n;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t _WDt = numeric_limits<_Working_result_type>\x3a\x3a""digits;\x0a"
"    static _LIBCPP_CONSTEXPR const size_t _EDt = numeric_limits<_Engine_result_type>\x3a\x3a""digits;\x0a"
"    static _LIBCPP_CONSTEXPR const _Working_result_type __y0 = __w0 >= _WDt \x3f 0 \x3a\x0a"
"                                                               (_Rp >> __w0) << __w0;\x0a"
"    static _LIBCPP_CONSTEXPR const _Working_result_type __y1 = __w0 >= _WDt - 1 \x3f 0 \x3a\x0a"
"                                                               (_Rp >> (__w0+1)) << (__w0+1);\x0a"
"    static _LIBCPP_CONSTEXPR const _Engine_result_type __mask0 = __w0 > 0 \x3f\x0a"
"                                _Engine_result_type(\x7e""0) >> (_EDt - __w0) \x3a\x0a"
"                                _Engine_result_type(0);\x0a"
"    static _LIBCPP_CONSTEXPR const _Engine_result_type __mask1 = __w0 < _EDt - 1 \x3f\x0a"
"                                _Engine_result_type(\x7e""0) >> (_EDt - (__w0 + 1)) \x3a\x0a"
"                                _Engine_result_type(\x7e""0);\x0a"
"public\x3a\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Min = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Max = __w == _Dt \x3f result_type(\x7e""0) \x3a\x0a"
"                                                      (result_type(1) << __w) - result_type(1);\x0a"
"    static_assert(_Min < _Max, \x22independent_bits_engine invalid parameters\x22);\x0a"
"\x0a"
"    // engine characteristics\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type min() { return _Min; }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type max() { return _Max; }\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    independent_bits_engine() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit independent_bits_engine(const _Engine\x26 __e)\x0a"
"        \x3a __e_(__e) {}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit independent_bits_engine(_Engine\x26\x26 __e)\x0a"
"        \x3a __e_(_VSTD\x3a\x3amove(__e)) {}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit independent_bits_engine(result_type __sd) \x3a __e_(__sd) {}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit independent_bits_engine(_Sseq\x26 __q,\x0a"
"        typename enable_if<__is_seed_sequence<_Sseq, independent_bits_engine>\x3a\x3avalue \x26\x26\x0a"
"                           \x21is_convertible<_Sseq, _Engine>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"         \x3a __e_(__q) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed() {__e_.seed();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed(result_type __sd) {__e_.seed(__sd);}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_seed_sequence<_Sseq, independent_bits_engine>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        seed(_Sseq\x26 __q) {__e_.seed(__q);}\x0a"
"\x0a"
"    // generating functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator()() {return __eval(integral_constant<bool, _Rp \x21= 0>());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void discard(unsigned long long __z) {for (; __z; --__z) operator()();}\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Engine\x26 base() const _NOEXCEPT {return __e_;}\x0a"
"\x0a"
"    template<class _Eng, size_t _Wp, class _UInt>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator==(\x0a"
"        const independent_bits_engine<_Eng, _Wp, _UInt>\x26 __x,\x0a"
"        const independent_bits_engine<_Eng, _Wp, _UInt>\x26 __y);\x0a"
"\x0a"
"    template<class _Eng, size_t _Wp, class _UInt>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator\x21=(\x0a"
"        const independent_bits_engine<_Eng, _Wp, _UInt>\x26 __x,\x0a"
"        const independent_bits_engine<_Eng, _Wp, _UInt>\x26 __y);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _Eng, size_t _Wp, class _UInt>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const independent_bits_engine<_Eng, _Wp, _UInt>\x26 __x);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _Eng, size_t _Wp, class _UInt>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               independent_bits_engine<_Eng, _Wp, _UInt>\x26 __x);\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type __eval(false_type);\x0a"
"    result_type __eval(true_type);\x0a"
"\x0a"
"    template <size_t __count>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __count < _Dt,\x0a"
"            result_type\x0a"
"        >\x3a\x3atype\x0a"
"        __lshift(result_type __x) {return __x << __count;}\x0a"
"\x0a"
"    template <size_t __count>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        static\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            (__count >= _Dt),\x0a"
"            result_type\x0a"
"        >\x3a\x3atype\x0a"
"        __lshift(result_type) {return result_type(0);}\x0a"
"};\x0a"
"\x0a"
"template<class _Engine, size_t __w, class _UIntType>\x0a"
"inline\x0a"
"_UIntType\x0a"
"independent_bits_engine<_Engine, __w, _UIntType>\x3a\x3a__eval(false_type)\x0a"
"{\x0a"
"    return static_cast<result_type>(__e_() \x26 __mask0);\x0a"
"}\x0a"
"\x0a"
"template<class _Engine, size_t __w, class _UIntType>\x0a"
"_UIntType\x0a"
"independent_bits_engine<_Engine, __w, _UIntType>\x3a\x3a__eval(true_type)\x0a"
"{\x0a"
"    result_type _Sp = 0;\x0a"
"    for (size_t __k = 0; __k < __n0; ++__k)\x0a"
"    {\x0a"
"        _Engine_result_type __u;\x0a"
"        do\x0a"
"        {\x0a"
"            __u = __e_() - _Engine\x3a\x3amin();\x0a"
"        } while (__u >= __y0);\x0a"
"        _Sp = static_cast<result_type>(__lshift<__w0>(_Sp) + (__u \x26 __mask0));\x0a"
"    }\x0a"
"    for (size_t __k = __n0; __k < __n; ++__k)\x0a"
"    {\x0a"
"        _Engine_result_type __u;\x0a"
"        do\x0a"
"        {\x0a"
"            __u = __e_() - _Engine\x3a\x3amin();\x0a"
"        } while (__u >= __y1);\x0a"
"        _Sp = static_cast<result_type>(__lshift<__w0+1>(_Sp) + (__u \x26 __mask1));\x0a"
"    }\x0a"
"    return _Sp;\x0a"
"}\x0a"
"\x0a"
"template<class _Eng, size_t _Wp, class _UInt>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(\x0a"
"    const independent_bits_engine<_Eng, _Wp, _UInt>\x26 __x,\x0a"
"    const independent_bits_engine<_Eng, _Wp, _UInt>\x26 __y)\x0a"
"{\x0a"
"    return __x.base() == __y.base();\x0a"
"}\x0a"
"\x0a"
"template<class _Eng, size_t _Wp, class _UInt>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(\x0a"
"    const independent_bits_engine<_Eng, _Wp, _UInt>\x26 __x,\x0a"
"    const independent_bits_engine<_Eng, _Wp, _UInt>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _Eng, size_t _Wp, class _UInt>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const independent_bits_engine<_Eng, _Wp, _UInt>\x26 __x)\x0a"
"{\x0a"
"    return __os << __x.base();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _Eng, size_t _Wp, class _UInt>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           independent_bits_engine<_Eng, _Wp, _UInt>\x26 __x)\x0a"
"{\x0a"
"    _Eng __e;\x0a"
"    __is >> __e;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.__e_ = __e;\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// shuffle_order_engine\x0a"
"\x0a"
"template <uint64_t _Xp, uint64_t _Yp>\x0a"
"struct __ugcd\x0a"
"{\x0a"
"    static _LIBCPP_CONSTEXPR const uint64_t value = __ugcd<_Yp, _Xp \x25 _Yp>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <uint64_t _Xp>\x0a"
"struct __ugcd<_Xp, 0>\x0a"
"{\x0a"
"    static _LIBCPP_CONSTEXPR const uint64_t value = _Xp;\x0a"
"};\x0a"
"\x0a"
"template <uint64_t _Np, uint64_t _Dp>\x0a"
"class __uratio\x0a"
"{\x0a"
"    static_assert(_Dp \x21= 0, \x22__uratio divide by 0\x22);\x0a"
"    static _LIBCPP_CONSTEXPR const uint64_t __gcd = __ugcd<_Np, _Dp>\x3a\x3avalue;\x0a"
"public\x3a\x0a"
"    static _LIBCPP_CONSTEXPR const uint64_t num = _Np / __gcd;\x0a"
"    static _LIBCPP_CONSTEXPR const uint64_t den = _Dp / __gcd;\x0a"
"\x0a"
"    typedef __uratio<num, den> type;\x0a"
"};\x0a"
"\x0a"
"template<class _Engine, size_t __k>\x0a"
"class _LIBCPP_TEMPLATE_VIS shuffle_order_engine\x0a"
"{\x0a"
"    static_assert(0 < __k, \x22shuffle_order_engine invalid parameters\x22);\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef typename _Engine\x3a\x3aresult_type result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    _Engine __e_;\x0a"
"    result_type _V_\x5b__k\x5d;\x0a"
"    result_type _Y_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // engine characteristics\x0a"
"    static _LIBCPP_CONSTEXPR const size_t table_size = __k;\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    static const result_type _Min = _Engine\x3a\x3a_Min;\x0a"
"    static const result_type _Max = _Engine\x3a\x3a_Max;\x0a"
"#else\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Min = _Engine\x3a\x3amin();\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Max = _Engine\x3a\x3amax();\x0a"
"#endif\x0a"
"    static_assert(_Min < _Max, \x22shuffle_order_engine invalid parameters\x22);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type min() { return _Min; }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type max() { return _Max; }\x0a"
"\x0a"
"    static _LIBCPP_CONSTEXPR const unsigned long long _Rp = _Max - _Min + 1ull;\x0a"
"\x0a"
"    // constructors and seeding functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    shuffle_order_engine() {__init();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit shuffle_order_engine(const _Engine\x26 __e)\x0a"
"        \x3a __e_(__e) {__init();}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit shuffle_order_engine(_Engine\x26\x26 __e)\x0a"
"        \x3a __e_(_VSTD\x3a\x3amove(__e)) {__init();}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit shuffle_order_engine(result_type __sd) \x3a __e_(__sd) {__init();}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit shuffle_order_engine(_Sseq\x26 __q,\x0a"
"        typename enable_if<__is_seed_sequence<_Sseq, shuffle_order_engine>\x3a\x3avalue \x26\x26\x0a"
"                           \x21is_convertible<_Sseq, _Engine>\x3a\x3avalue>\x3a\x3atype* = 0)\x0a"
"         \x3a __e_(__q) {__init();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed() {__e_.seed(); __init();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void seed(result_type __sd) {__e_.seed(__sd); __init();}\x0a"
"    template<class _Sseq>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_seed_sequence<_Sseq, shuffle_order_engine>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        seed(_Sseq\x26 __q) {__e_.seed(__q); __init();}\x0a"
"\x0a"
"    // generating functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator()() {return __eval(integral_constant<bool, _Rp \x21= 0>());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void discard(unsigned long long __z) {for (; __z; --__z) operator()();}\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const _Engine\x26 base() const _NOEXCEPT {return __e_;}\x0a"
"\x0a"
"private\x3a\x0a"
"    template<class _Eng, size_t _Kp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator==(\x0a"
"        const shuffle_order_engine<_Eng, _Kp>\x26 __x,\x0a"
"        const shuffle_order_engine<_Eng, _Kp>\x26 __y);\x0a"
"\x0a"
"    template<class _Eng, size_t _Kp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator\x21=(\x0a"
"        const shuffle_order_engine<_Eng, _Kp>\x26 __x,\x0a"
"        const shuffle_order_engine<_Eng, _Kp>\x26 __y);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _Eng, size_t _Kp>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const shuffle_order_engine<_Eng, _Kp>\x26 __x);\x0a"
"\x0a"
"    template <class _CharT, class _Traits,\x0a"
"              class _Eng, size_t _Kp>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               shuffle_order_engine<_Eng, _Kp>\x26 __x);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __init()\x0a"
"    {\x0a"
"        for (size_t __i = 0; __i < __k; ++__i)\x0a"
"            _V_\x5b__i\x5d = __e_();\x0a"
"        _Y_ = __e_();\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type __eval(false_type) {return __eval2(integral_constant<bool, __k \x26 1>());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type __eval(true_type) {return __eval(__uratio<__k, _Rp>());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type __eval2(false_type) {return __eval(__uratio<__k/2, 0x8000000000000000ull>());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type __eval2(true_type) {return __evalf<__k, 0>();}\x0a"
"\x0a"
"    template <uint64_t _Np, uint64_t _Dp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            (__uratio<_Np, _Dp>\x3a\x3anum > 0xFFFFFFFFFFFFFFFFull / (_Max - _Min)),\x0a"
"            result_type\x0a"
"        >\x3a\x3atype\x0a"
"        __eval(__uratio<_Np, _Dp>)\x0a"
"            {return __evalf<__uratio<_Np, _Dp>\x3a\x3anum, __uratio<_Np, _Dp>\x3a\x3a""den>();}\x0a"
"\x0a"
"    template <uint64_t _Np, uint64_t _Dp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __uratio<_Np, _Dp>\x3a\x3anum <= 0xFFFFFFFFFFFFFFFFull / (_Max - _Min),\x0a"
"            result_type\x0a"
"        >\x3a\x3atype\x0a"
"        __eval(__uratio<_Np, _Dp>)\x0a"
"        {\x0a"
"            const size_t __j = static_cast<size_t>(__uratio<_Np, _Dp>\x3a\x3anum * (_Y_ - _Min)\x0a"
"                                                   / __uratio<_Np, _Dp>\x3a\x3a""den);\x0a"
"            _Y_ = _V_\x5b__j\x5d;\x0a"
"            _V_\x5b__j\x5d = __e_();\x0a"
"            return _Y_;\x0a"
"        }\x0a"
"\x0a"
"    template <uint64_t __n, uint64_t __d>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type __evalf()\x0a"
"        {\x0a"
"            const double _Fp = __d == 0 \x3f\x0a"
"                __n / (2. * 0x8000000000000000ull) \x3a\x0a"
"                __n / (double)__d;\x0a"
"            const size_t __j = static_cast<size_t>(_Fp * (_Y_ - _Min));\x0a"
"            _Y_ = _V_\x5b__j\x5d;\x0a"
"            _V_\x5b__j\x5d = __e_();\x0a"
"            return _Y_;\x0a"
"        }\x0a"
"};\x0a"
"\x0a"
"template<class _Engine, size_t __k>\x0a"
"    _LIBCPP_CONSTEXPR const size_t shuffle_order_engine<_Engine, __k>\x3a\x3atable_size;\x0a"
"\x0a"
"template<class _Eng, size_t _Kp>\x0a"
"bool\x0a"
"operator==(\x0a"
"    const shuffle_order_engine<_Eng, _Kp>\x26 __x,\x0a"
"    const shuffle_order_engine<_Eng, _Kp>\x26 __y)\x0a"
"{\x0a"
"    return __x._Y_ == __y._Y_ \x26\x26 _VSTD\x3a\x3a""equal(__x._V_, __x._V_ + _Kp, __y._V_) \x26\x26\x0a"
"           __x.__e_ == __y.__e_;\x0a"
"}\x0a"
"\x0a"
"template<class _Eng, size_t _Kp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(\x0a"
"    const shuffle_order_engine<_Eng, _Kp>\x26 __x,\x0a"
"    const shuffle_order_engine<_Eng, _Kp>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _Eng, size_t _Kp>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const shuffle_order_engine<_Eng, _Kp>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    __os << __x.__e_ << __sp << __x._V_\x5b""0\x5d;\x0a"
"    for (size_t __i = 1; __i < _Kp; ++__i)\x0a"
"        __os << __sp << __x._V_\x5b__i\x5d;\x0a"
"    return __os << __sp << __x._Y_;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits,\x0a"
"          class _Eng, size_t _Kp>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           shuffle_order_engine<_Eng, _Kp>\x26 __x)\x0a"
"{\x0a"
"    typedef typename shuffle_order_engine<_Eng, _Kp>\x3a\x3aresult_type result_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    _Eng __e;\x0a"
"    result_type _Vp\x5b_Kp+1\x5d;\x0a"
"    __is >> __e;\x0a"
"    for (size_t __i = 0; __i < _Kp+1; ++__i)\x0a"
"        __is >> _Vp\x5b__i\x5d;\x0a"
"    if (\x21__is.fail())\x0a"
"    {\x0a"
"        __x.__e_ = __e;\x0a"
"        for (size_t __i = 0; __i < _Kp; ++__i)\x0a"
"            __x._V_\x5b__i\x5d = _Vp\x5b__i\x5d;\x0a"
"        __x._Y_ = _Vp\x5b_Kp\x5d;\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"typedef shuffle_order_engine<minstd_rand0, 256>                         knuth_b;\x0a"
"\x0a"
"// random_device\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS random_device\x0a"
"{\x0a"
"#ifdef _LIBCPP_USING_DEV_RANDOM\x0a"
"    int __f_;\x0a"
"#endif // defined(_LIBCPP_USING_DEV_RANDOM)\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef unsigned result_type;\x0a"
"\x0a"
"    // generator characteristics\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Min = 0;\x0a"
"    static _LIBCPP_CONSTEXPR const result_type _Max = 0xFFFFFFFFu;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type min() { return _Min;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static _LIBCPP_CONSTEXPR result_type max() { return _Max;}\x0a"
"\x0a"
"    // constructors\x0a"
"    explicit random_device(const string\x26 __token = \x22/dev/urandom\x22);\x0a"
"    \x7erandom_device();\x0a"
"\x0a"
"    // generating functions\x0a"
"    result_type operator()();\x0a"
"\x0a"
"    // property functions\x0a"
"    double entropy() const _NOEXCEPT;\x0a"
"\x0a"
"private\x3a\x0a"
"    // no copy functions\x0a"
"    random_device(const random_device\x26); // = delete;\x0a"
"    random_device\x26 operator=(const random_device\x26); // = delete;\x0a"
"};\x0a"
"\x0a"
"// seed_seq\x0a"
"\x0a"
"class _LIBCPP_TEMPLATE_VIS seed_seq\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef uint32_t result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    vector<result_type> __v_;\x0a"
"\x0a"
"    template<class _InputIterator>\x0a"
"        void init(_InputIterator __first, _InputIterator __last);\x0a"
"public\x3a\x0a"
"    // constructors\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    seed_seq() _NOEXCEPT {}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template<class _Tp>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        seed_seq(initializer_list<_Tp> __il) {init(__il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template<class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        seed_seq(_InputIterator __first, _InputIterator __last)\x0a"
"             {init(__first, __last);}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _RandomAccessIterator>\x0a"
"        void generate(_RandomAccessIterator __first, _RandomAccessIterator __last);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const _NOEXCEPT {return __v_.size();}\x0a"
"    template<class _OutputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void param(_OutputIterator __dest) const\x0a"
"            {_VSTD\x3a\x3a""copy(__v_.begin(), __v_.end(), __dest);}\x0a"
"\x0a"
"private\x3a\x0a"
"    // no copy functions\x0a"
"    seed_seq(const seed_seq\x26); // = delete;\x0a"
"    void operator=(const seed_seq\x26); // = delete;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static result_type _Tp(result_type __x) {return __x ^ (__x >> 27);}\x0a"
"};\x0a"
"\x0a"
"template<class _InputIterator>\x0a"
"void\x0a"
"seed_seq\x3a\x3ainit(_InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    for (_InputIterator __s = __first; __s \x21= __last; ++__s)\x0a"
"        __v_.push_back(*__s \x26 0xFFFFFFFF);\x0a"
"}\x0a"
"\x0a"
"template<class _RandomAccessIterator>\x0a"
"void\x0a"
"seed_seq\x3a\x3agenerate(_RandomAccessIterator __first, _RandomAccessIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _VSTD\x3a\x3a""fill(__first, __last, 0x8b8b8b8b);\x0a"
"        const size_t __n = static_cast<size_t>(__last - __first);\x0a"
"        const size_t __s = __v_.size();\x0a"
"        const size_t __t = (__n >= 623) \x3f 11\x0a"
"                         \x3a (__n >= 68) \x3f 7\x0a"
"                         \x3a (__n >= 39) \x3f 5\x0a"
"                         \x3a (__n >= 7)  \x3f 3\x0a"
"                         \x3a (__n - 1) / 2;\x0a"
"        const size_t __p = (__n - __t) / 2;\x0a"
"        const size_t __q = __p + __t;\x0a"
"        const size_t __m = _VSTD\x3a\x3amax(__s + 1, __n);\x0a"
"        // __k = 0;\x0a"
"        {\x0a"
"            result_type __r = 1664525 * _Tp(__first\x5b""0\x5d ^ __first\x5b__p\x5d\x0a"
"                                                      ^  __first\x5b__n - 1\x5d);\x0a"
"            __first\x5b__p\x5d += __r;\x0a"
"            __r += __s;\x0a"
"            __first\x5b__q\x5d += __r;\x0a"
"            __first\x5b""0\x5d = __r;\x0a"
"        }\x0a"
"        for (size_t __k = 1; __k <= __s; ++__k)\x0a"
"        {\x0a"
"            const size_t __kmodn = __k \x25 __n;\x0a"
"            const size_t __kpmodn = (__k + __p) \x25 __n;\x0a"
"            result_type __r = 1664525 * _Tp(__first\x5b__kmodn\x5d ^ __first\x5b__kpmodn\x5d\x0a"
"                                           ^ __first\x5b(__k - 1) \x25 __n\x5d);\x0a"
"            __first\x5b__kpmodn\x5d += __r;\x0a"
"            __r +=  __kmodn + __v_\x5b__k-1\x5d;\x0a"
"            __first\x5b(__k + __q) \x25 __n\x5d += __r;\x0a"
"            __first\x5b__kmodn\x5d = __r;\x0a"
"        }\x0a"
"        for (size_t __k = __s + 1; __k < __m; ++__k)\x0a"
"        {\x0a"
"            const size_t __kmodn = __k \x25 __n;\x0a"
"            const size_t __kpmodn = (__k + __p) \x25 __n;\x0a"
"            result_type __r = 1664525 * _Tp(__first\x5b__kmodn\x5d ^ __first\x5b__kpmodn\x5d\x0a"
"                                           ^ __first\x5b(__k - 1) \x25 __n\x5d);\x0a"
"            __first\x5b__kpmodn\x5d += __r;\x0a"
"            __r +=  __kmodn;\x0a"
"            __first\x5b(__k + __q) \x25 __n\x5d += __r;\x0a"
"            __first\x5b__kmodn\x5d = __r;\x0a"
"        }\x0a"
"        for (size_t __k = __m; __k < __m + __n; ++__k)\x0a"
"        {\x0a"
"            const size_t __kmodn = __k \x25 __n;\x0a"
"            const size_t __kpmodn = (__k + __p) \x25 __n;\x0a"
"            result_type __r = 1566083941 * _Tp(__first\x5b__kmodn\x5d +\x0a"
"                                              __first\x5b__kpmodn\x5d +\x0a"
"                                              __first\x5b(__k - 1) \x25 __n\x5d);\x0a"
"            __first\x5b__kpmodn\x5d ^= __r;\x0a"
"            __r -= __kmodn;\x0a"
"            __first\x5b(__k + __q) \x25 __n\x5d ^= __r;\x0a"
"            __first\x5b__kmodn\x5d = __r;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// generate_canonical\x0a"
"\x0a"
"template<class _RealType, size_t __bits, class _URNG>\x0a"
"_RealType\x0a"
"generate_canonical(_URNG\x26 __g)\x0a"
"{\x0a"
"    const size_t _Dt = numeric_limits<_RealType>\x3a\x3a""digits;\x0a"
"    const size_t __b = _Dt < __bits \x3f _Dt \x3a __bits;\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    const size_t __logR = __log2<uint64_t, _URNG\x3a\x3a_Max - _URNG\x3a\x3a_Min + uint64_t(1)>\x3a\x3avalue;\x0a"
"#else\x0a"
"    const size_t __logR = __log2<uint64_t, _URNG\x3a\x3amax() - _URNG\x3a\x3amin() + uint64_t(1)>\x3a\x3avalue;\x0a"
"#endif\x0a"
"    const size_t __k = __b / __logR + (__b \x25 __logR \x21= 0) + (__b == 0);\x0a"
"    const _RealType _Rp = _URNG\x3a\x3amax() - _URNG\x3a\x3amin() + _RealType(1);\x0a"
"    _RealType __base = _Rp;\x0a"
"    _RealType _Sp = __g() - _URNG\x3a\x3amin();\x0a"
"    for (size_t __i = 1; __i < __k; ++__i, __base *= _Rp)\x0a"
"        _Sp += (__g() - _URNG\x3a\x3amin()) * __base;\x0a"
"    return _Sp / __base;\x0a"
"}\x0a"
"\x0a"
"// uniform_int_distribution\x0a"
"\x0a"
"// in <algorithm>\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const uniform_int_distribution<_IT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    return __os << __x.a() << __sp << __x.b();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           uniform_int_distribution<_IT>\x26 __x)\x0a"
"{\x0a"
"    typedef uniform_int_distribution<_IT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __a;\x0a"
"    result_type __b;\x0a"
"    __is >> __a >> __b;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__a, __b));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// uniform_real_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS uniform_real_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __a_;\x0a"
"        result_type __b_;\x0a"
"    public\x3a\x0a"
"        typedef uniform_real_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __a = 0,\x0a"
"                            result_type __b = 1)\x0a"
"            \x3a __a_(__a), __b_(__b) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type a() const {return __a_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type b() const {return __b_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__a_ == __y.__a_ \x26\x26 __x.__b_ == __y.__b_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructors and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit uniform_real_distribution(result_type __a = 0, result_type __b = 1)\x0a"
"        \x3a __p_(param_type(__a, __b)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit uniform_real_distribution(const param_type\x26 __p) \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> _LIBCPP_INLINE_VISIBILITY result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type a() const {return __p_.a();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type b() const {return __p_.b();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return a();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return b();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const uniform_real_distribution\x26 __x,\x0a"
"                        const uniform_real_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const uniform_real_distribution\x26 __x,\x0a"
"                        const uniform_real_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template<class _RealType>\x0a"
"template<class _URNG>\x0a"
"inline\x0a"
"typename uniform_real_distribution<_RealType>\x3a\x3aresult_type\x0a"
"uniform_real_distribution<_RealType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    return (__p.b() - __p.a())\x0a"
"        * _VSTD\x3a\x3agenerate_canonical<_RealType, numeric_limits<_RealType>\x3a\x3a""digits>(__g)\x0a"
"        + __p.a();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const uniform_real_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    return __os << __x.a() << __sp << __x.b();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           uniform_real_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef uniform_real_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __a;\x0a"
"    result_type __b;\x0a"
"    __is >> __a >> __b;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__a, __b));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// bernoulli_distribution\x0a"
"\x0a"
"class _LIBCPP_TEMPLATE_VIS bernoulli_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef bool result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        double __p_;\x0a"
"    public\x3a\x0a"
"        typedef bernoulli_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(double __p = 0.5) \x3a __p_(__p) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        double p() const {return __p_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__p_ == __y.__p_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructors and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit bernoulli_distribution(double __p = 0.5)\x0a"
"        \x3a __p_(param_type(__p)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit bernoulli_distribution(const param_type\x26 __p) \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> _LIBCPP_INLINE_VISIBILITY result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    double p() const {return __p_.p();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return false;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return true;}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const bernoulli_distribution\x26 __x,\x0a"
"                        const bernoulli_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const bernoulli_distribution\x26 __x,\x0a"
"                        const bernoulli_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template<class _URNG>\x0a"
"inline\x0a"
"bernoulli_distribution\x3a\x3aresult_type\x0a"
"bernoulli_distribution\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    uniform_real_distribution<double> __gen;\x0a"
"    return __gen(__g) < __p.p();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os, const bernoulli_distribution\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    return __os << __x.p();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is, bernoulli_distribution\x26 __x)\x0a"
"{\x0a"
"    typedef bernoulli_distribution _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    double __p;\x0a"
"    __is >> __p;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__p));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// binomial_distribution\x0a"
"\x0a"
"template<class _IntType = int>\x0a"
"class _LIBCPP_TEMPLATE_VIS binomial_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _IntType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __t_;\x0a"
"        double __p_;\x0a"
"        double __pr_;\x0a"
"        double __odds_ratio_;\x0a"
"        result_type __r0_;\x0a"
"    public\x3a\x0a"
"        typedef binomial_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(result_type __t = 1, double __p = 0.5);\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type t() const {return __t_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        double p() const {return __p_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__t_ == __y.__t_ \x26\x26 __x.__p_ == __y.__p_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"\x0a"
"        friend class binomial_distribution;\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructors and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit binomial_distribution(result_type __t = 1, double __p = 0.5)\x0a"
"        \x3a __p_(param_type(__t, __p)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit binomial_distribution(const param_type\x26 __p) \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type t() const {return __p_.t();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    double p() const {return __p_.p();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return t();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const binomial_distribution\x26 __x,\x0a"
"                        const binomial_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const binomial_distribution\x26 __x,\x0a"
"                        const binomial_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_MSVCRT\x0a"
"extern \x22""C\x22 double lgamma_r(double, int *);\x0a"
"#endif\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY double __libcpp_lgamma(double __d) {\x0a"
"#if defined(_LIBCPP_MSVCRT)\x0a"
"  return lgamma(__d);\x0a"
"#else\x0a"
"  int __sign;\x0a"
"  return lgamma_r(__d, \x26__sign);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template<class _IntType>\x0a"
"binomial_distribution<_IntType>\x3a\x3aparam_type\x3a\x3aparam_type(const result_type __t, const double __p)\x0a"
"    \x3a __t_(__t), __p_(__p)\x0a"
"{\x0a"
"    if (0 < __p_ \x26\x26 __p_ < 1)\x0a"
"    {\x0a"
"        __r0_ = static_cast<result_type>((__t_ + 1) * __p_);\x0a"
"        __pr_ = _VSTD\x3a\x3a""exp(__libcpp_lgamma(__t_ + 1.) -\x0a"
"                           __libcpp_lgamma(__r0_ + 1.) -\x0a"
"                           __libcpp_lgamma(__t_ - __r0_ + 1.) + __r0_ * _VSTD\x3a\x3alog(__p_) +\x0a"
"                           (__t_ - __r0_) * _VSTD\x3a\x3alog(1 - __p_));\x0a"
"        __odds_ratio_ = __p_ / (1 - __p_);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// Reference\x3a Kemp, C.D. (1986). \x60""A modal method for generating binomial\x0a"
"//           variables', Commun. Statist. - Theor. Meth. 15(3), 805-813.\x0a"
"template<class _IntType>\x0a"
"template<class _URNG>\x0a"
"_IntType\x0a"
"binomial_distribution<_IntType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __pr)\x0a"
"{\x0a"
"    if (__pr.__t_ == 0 \x7c\x7c __pr.__p_ == 0)\x0a"
"        return 0;\x0a"
"    if (__pr.__p_ == 1)\x0a"
"        return __pr.__t_;\x0a"
"    uniform_real_distribution<double> __gen;\x0a"
"    double __u = __gen(__g) - __pr.__pr_;\x0a"
"    if (__u < 0)\x0a"
"        return __pr.__r0_;\x0a"
"    double __pu = __pr.__pr_;\x0a"
"    double __pd = __pu;\x0a"
"    result_type __ru = __pr.__r0_;\x0a"
"    result_type __rd = __ru;\x0a"
"    while (true)\x0a"
"    {\x0a"
"        if (__rd >= 1)\x0a"
"        {\x0a"
"            __pd *= __rd / (__pr.__odds_ratio_ * (__pr.__t_ - __rd + 1));\x0a"
"            __u -= __pd;\x0a"
"            if (__u < 0)\x0a"
"                return __rd - 1;\x0a"
"        }\x0a"
"        if ( __rd \x21= 0 )\x0a"
"            --__rd;\x0a"
"        ++__ru;\x0a"
"        if (__ru <= __pr.__t_)\x0a"
"        {\x0a"
"            __pu *= (__pr.__t_ - __ru + 1) * __pr.__odds_ratio_ / __ru;\x0a"
"            __u -= __pu;\x0a"
"            if (__u < 0)\x0a"
"                return __ru;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IntType>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const binomial_distribution<_IntType>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    return __os << __x.t() << __sp << __x.p();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IntType>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           binomial_distribution<_IntType>\x26 __x)\x0a"
"{\x0a"
"    typedef binomial_distribution<_IntType> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __t;\x0a"
"    double __p;\x0a"
"    __is >> __t >> __p;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__t, __p));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// exponential_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS exponential_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __lambda_;\x0a"
"    public\x3a\x0a"
"        typedef exponential_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __lambda = 1) \x3a __lambda_(__lambda) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type lambda() const {return __lambda_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__lambda_ == __y.__lambda_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructors and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit exponential_distribution(result_type __lambda = 1)\x0a"
"        \x3a __p_(param_type(__lambda)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit exponential_distribution(const param_type\x26 __p) \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type lambda() const {return __p_.lambda();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const exponential_distribution\x26 __x,\x0a"
"                        const exponential_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const exponential_distribution\x26 __x,\x0a"
"                        const exponential_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _RealType>\x0a"
"template<class _URNG>\x0a"
"_RealType\x0a"
"exponential_distribution<_RealType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    return -_VSTD\x3a\x3alog\x0a"
"                  (\x0a"
"                      result_type(1) -\x0a"
"                      _VSTD\x3a\x3agenerate_canonical<result_type,\x0a"
"                                       numeric_limits<result_type>\x3a\x3a""digits>(__g)\x0a"
"                  )\x0a"
"                  / __p.lambda();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RealType>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const exponential_distribution<_RealType>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    return __os << __x.lambda();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RealType>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           exponential_distribution<_RealType>\x26 __x)\x0a"
"{\x0a"
"    typedef exponential_distribution<_RealType> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __lambda;\x0a"
"    __is >> __lambda;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__lambda));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// normal_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS normal_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __mean_;\x0a"
"        result_type __stddev_;\x0a"
"    public\x3a\x0a"
"        typedef normal_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __mean = 0, result_type __stddev = 1)\x0a"
"            \x3a __mean_(__mean), __stddev_(__stddev) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type mean() const {return __mean_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type stddev() const {return __stddev_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__mean_ == __y.__mean_ \x26\x26 __x.__stddev_ == __y.__stddev_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"    result_type _V_;\x0a"
"    bool _V_hot_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructors and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit normal_distribution(result_type __mean = 0, result_type __stddev = 1)\x0a"
"        \x3a __p_(param_type(__mean, __stddev)), _V_hot_(false) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit normal_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p), _V_hot_(false) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {_V_hot_ = false;}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type mean() const {return __p_.mean();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type stddev() const {return __p_.stddev();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return -numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const normal_distribution\x26 __x,\x0a"
"                        const normal_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_ \x26\x26 __x._V_hot_ == __y._V_hot_ \x26\x26\x0a"
"                (\x21__x._V_hot_ \x7c\x7c __x._V_ == __y._V_);}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const normal_distribution\x26 __x,\x0a"
"                        const normal_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _RT>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const normal_distribution<_RT>\x26 __x);\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _RT>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               normal_distribution<_RT>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template <class _RealType>\x0a"
"template<class _URNG>\x0a"
"_RealType\x0a"
"normal_distribution<_RealType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    result_type _Up;\x0a"
"    if (_V_hot_)\x0a"
"    {\x0a"
"        _V_hot_ = false;\x0a"
"        _Up = _V_;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        uniform_real_distribution<result_type> _Uni(-1, 1);\x0a"
"        result_type __u;\x0a"
"        result_type __v;\x0a"
"        result_type __s;\x0a"
"        do\x0a"
"        {\x0a"
"            __u = _Uni(__g);\x0a"
"            __v = _Uni(__g);\x0a"
"            __s = __u * __u + __v * __v;\x0a"
"        } while (__s > 1 \x7c\x7c __s == 0);\x0a"
"        result_type _Fp = _VSTD\x3a\x3asqrt(-2 * _VSTD\x3a\x3alog(__s) / __s);\x0a"
"        _V_ = __v * _Fp;\x0a"
"        _V_hot_ = true;\x0a"
"        _Up = __u * _Fp;\x0a"
"    }\x0a"
"    return _Up * __p.stddev() + __p.mean();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const normal_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    __os << __x.mean() << __sp << __x.stddev() << __sp << __x._V_hot_;\x0a"
"    if (__x._V_hot_)\x0a"
"        __os << __sp << __x._V_;\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           normal_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef normal_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __mean;\x0a"
"    result_type __stddev;\x0a"
"    result_type _Vp = 0;\x0a"
"    bool _V_hot = false;\x0a"
"    __is >> __mean >> __stddev >> _V_hot;\x0a"
"    if (_V_hot)\x0a"
"        __is >> _Vp;\x0a"
"    if (\x21__is.fail())\x0a"
"    {\x0a"
"        __x.param(param_type(__mean, __stddev));\x0a"
"        __x._V_hot_ = _V_hot;\x0a"
"        __x._V_ = _Vp;\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// lognormal_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS lognormal_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        normal_distribution<result_type> __nd_;\x0a"
"    public\x3a\x0a"
"        typedef lognormal_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __m = 0, result_type __s = 1)\x0a"
"            \x3a __nd_(__m, __s) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type m() const {return __nd_.mean();}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type s() const {return __nd_.stddev();}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__nd_ == __y.__nd_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"        friend class lognormal_distribution;\x0a"
"\x0a"
"        template <class _CharT, class _Traits, class _RT>\x0a"
"        friend\x0a"
"        basic_ostream<_CharT, _Traits>\x26\x0a"
"        operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"                   const lognormal_distribution<_RT>\x26 __x);\x0a"
"\x0a"
"        template <class _CharT, class _Traits, class _RT>\x0a"
"        friend\x0a"
"        basic_istream<_CharT, _Traits>\x26\x0a"
"        operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"                   lognormal_distribution<_RT>\x26 __x);\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit lognormal_distribution(result_type __m = 0, result_type __s = 1)\x0a"
"        \x3a __p_(param_type(__m, __s)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit lognormal_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {__p_.__nd_.reset();}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"        {return _VSTD\x3a\x3a""exp(const_cast<normal_distribution<result_type>\x26>(__p.__nd_)(__g));}\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type m() const {return __p_.m();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type s() const {return __p_.s();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const lognormal_distribution\x26 __x,\x0a"
"                        const lognormal_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const lognormal_distribution\x26 __x,\x0a"
"                        const lognormal_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _RT>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const lognormal_distribution<_RT>\x26 __x);\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _RT>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               lognormal_distribution<_RT>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const lognormal_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    return __os << __x.__p_.__nd_;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           lognormal_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    return __is >> __x.__p_.__nd_;\x0a"
"}\x0a"
"\x0a"
"// poisson_distribution\x0a"
"\x0a"
"template<class _IntType = int>\x0a"
"class _LIBCPP_TEMPLATE_VIS poisson_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _IntType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        double __mean_;\x0a"
"        double __s_;\x0a"
"        double __d_;\x0a"
"        double __l_;\x0a"
"        double __omega_;\x0a"
"        double __c0_;\x0a"
"        double __c1_;\x0a"
"        double __c2_;\x0a"
"        double __c3_;\x0a"
"        double __c_;\x0a"
"\x0a"
"    public\x3a\x0a"
"        typedef poisson_distribution distribution_type;\x0a"
"\x0a"
"        explicit param_type(double __mean = 1.0);\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        double mean() const {return __mean_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__mean_ == __y.__mean_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"\x0a"
"        friend class poisson_distribution;\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructors and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit poisson_distribution(double __mean = 1.0) \x3a __p_(__mean) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit poisson_distribution(const param_type\x26 __p) \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    double mean() const {return __p_.mean();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3amax();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const poisson_distribution\x26 __x,\x0a"
"                        const poisson_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const poisson_distribution\x26 __x,\x0a"
"                        const poisson_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template<class _IntType>\x0a"
"poisson_distribution<_IntType>\x3a\x3aparam_type\x3a\x3aparam_type(double __mean)\x0a"
"    \x3a __mean_(__mean)\x0a"
"{\x0a"
"    if (__mean_ < 10)\x0a"
"    {\x0a"
"        __s_ = 0;\x0a"
"        __d_ = 0;\x0a"
"        __l_ = _VSTD\x3a\x3a""exp(-__mean_);\x0a"
"        __omega_ = 0;\x0a"
"        __c3_ = 0;\x0a"
"        __c2_ = 0;\x0a"
"        __c1_ = 0;\x0a"
"        __c0_ = 0;\x0a"
"        __c_ = 0;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s_ = _VSTD\x3a\x3asqrt(__mean_);\x0a"
"        __d_ = 6 * __mean_ * __mean_;\x0a"
"        __l_ = static_cast<result_type>(__mean_ - 1.1484);\x0a"
"        __omega_ = .3989423 / __s_;\x0a"
"        double __b1_ = .4166667E-1 / __mean_;\x0a"
"        double __b2_ = .3 * __b1_ * __b1_;\x0a"
"        __c3_ = .1428571 * __b1_ * __b2_;\x0a"
"        __c2_ = __b2_ - 15. * __c3_;\x0a"
"        __c1_ = __b1_ - 6. * __b2_ + 45. * __c3_;\x0a"
"        __c0_ = 1. - __b1_ + 3. * __b2_ - 15. * __c3_;\x0a"
"        __c_ = .1069 / __mean_;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _IntType>\x0a"
"template<class _URNG>\x0a"
"_IntType\x0a"
"poisson_distribution<_IntType>\x3a\x3aoperator()(_URNG\x26 __urng, const param_type\x26 __pr)\x0a"
"{\x0a"
"    result_type __x;\x0a"
"    uniform_real_distribution<double> __urd;\x0a"
"    if (__pr.__mean_ < 10)\x0a"
"    {\x0a"
"         __x = 0;\x0a"
"        for (double __p = __urd(__urng); __p > __pr.__l_; ++__x)\x0a"
"            __p *= __urd(__urng);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        double __difmuk;\x0a"
"        double __g = __pr.__mean_ + __pr.__s_ * normal_distribution<double>()(__urng);\x0a"
"        double __u;\x0a"
"        if (__g > 0)\x0a"
"        {\x0a"
"            __x = static_cast<result_type>(__g);\x0a"
"            if (__x >= __pr.__l_)\x0a"
"                return __x;\x0a"
"            __difmuk = __pr.__mean_ - __x;\x0a"
"            __u = __urd(__urng);\x0a"
"            if (__pr.__d_ * __u >= __difmuk * __difmuk * __difmuk)\x0a"
"                return __x;\x0a"
"        }\x0a"
"        exponential_distribution<double> __edist;\x0a"
"        for (bool __using_exp_dist = false; true; __using_exp_dist = true)\x0a"
"        {\x0a"
"            double __e;\x0a"
"            if (__using_exp_dist \x7c\x7c __g < 0)\x0a"
"            {\x0a"
"                double __t;\x0a"
"                do\x0a"
"                {\x0a"
"                    __e = __edist(__urng);\x0a"
"                    __u = __urd(__urng);\x0a"
"                    __u += __u - 1;\x0a"
"                    __t = 1.8 + (__u < 0 \x3f -__e \x3a __e);\x0a"
"                } while (__t <= -.6744);\x0a"
"                __x = __pr.__mean_ + __pr.__s_ * __t;\x0a"
"                __difmuk = __pr.__mean_ - __x;\x0a"
"                __using_exp_dist = true;\x0a"
"            }\x0a"
"            double __px;\x0a"
"            double __py;\x0a"
"            if (__x < 10)\x0a"
"            {\x0a"
"                const double __fac\x5b\x5d = {1, 1, 2, 6, 24, 120, 720, 5040,\x0a"
"                                             40320, 362880};\x0a"
"                __px = -__pr.__mean_;\x0a"
"                __py = _VSTD\x3a\x3apow(__pr.__mean_, (double)__x) / __fac\x5b__x\x5d;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                double __del = .8333333E-1 / __x;\x0a"
"                __del -= 4.8 * __del * __del * __del;\x0a"
"                double __v = __difmuk / __x;\x0a"
"                if (_VSTD\x3a\x3a""abs(__v) > 0.25)\x0a"
"                    __px = __x * _VSTD\x3a\x3alog(1 + __v) - __difmuk - __del;\x0a"
"                else\x0a"
"                    __px = __x * __v * __v * (((((((.1250060 * __v + -.1384794) *\x0a"
"                           __v + .1421878) * __v + -.1661269) * __v + .2000118) *\x0a"
"                           __v + -.2500068) * __v + .3333333) * __v + -.5) - __del;\x0a"
"                __py = .3989423 / _VSTD\x3a\x3asqrt(__x);\x0a"
"            }\x0a"
"            double __r = (0.5 - __difmuk) / __pr.__s_;\x0a"
"            double __r2 = __r * __r;\x0a"
"            double __fx = -0.5 * __r2;\x0a"
"            double __fy = __pr.__omega_ * (((__pr.__c3_ * __r2 + __pr.__c2_) *\x0a"
"                                        __r2 + __pr.__c1_) * __r2 + __pr.__c0_);\x0a"
"            if (__using_exp_dist)\x0a"
"            {\x0a"
"                if (__pr.__c_ * _VSTD\x3a\x3a""abs(__u) <= __py * _VSTD\x3a\x3a""exp(__px + __e) -\x0a"
"                                                   __fy * _VSTD\x3a\x3a""exp(__fx + __e))\x0a"
"                    break;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                if (__fy - __u * __fy <= __py * _VSTD\x3a\x3a""exp(__px - __fx))\x0a"
"                    break;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IntType>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const poisson_distribution<_IntType>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    return __os << __x.mean();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IntType>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           poisson_distribution<_IntType>\x26 __x)\x0a"
"{\x0a"
"    typedef poisson_distribution<_IntType> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    double __mean;\x0a"
"    __is >> __mean;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__mean));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// weibull_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS weibull_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __a_;\x0a"
"        result_type __b_;\x0a"
"    public\x3a\x0a"
"        typedef weibull_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __a = 1, result_type __b = 1)\x0a"
"            \x3a __a_(__a), __b_(__b) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type a() const {return __a_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type b() const {return __b_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__a_ == __y.__a_ \x26\x26 __x.__b_ == __y.__b_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit weibull_distribution(result_type __a = 1, result_type __b = 1)\x0a"
"        \x3a __p_(param_type(__a, __b)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit weibull_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"        {return __p.b() *\x0a"
"            _VSTD\x3a\x3apow(exponential_distribution<result_type>()(__g), 1/__p.a());}\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type a() const {return __p_.a();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type b() const {return __p_.b();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const weibull_distribution\x26 __x,\x0a"
"                        const weibull_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const weibull_distribution\x26 __x,\x0a"
"                        const weibull_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const weibull_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    __os << __x.a() << __sp << __x.b();\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           weibull_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef weibull_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __a;\x0a"
"    result_type __b;\x0a"
"    __is >> __a >> __b;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__a, __b));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS extreme_value_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __a_;\x0a"
"        result_type __b_;\x0a"
"    public\x3a\x0a"
"        typedef extreme_value_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __a = 0, result_type __b = 1)\x0a"
"            \x3a __a_(__a), __b_(__b) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type a() const {return __a_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type b() const {return __b_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__a_ == __y.__a_ \x26\x26 __x.__b_ == __y.__b_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit extreme_value_distribution(result_type __a = 0, result_type __b = 1)\x0a"
"        \x3a __p_(param_type(__a, __b)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit extreme_value_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type a() const {return __p_.a();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type b() const {return __p_.b();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return -numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const extreme_value_distribution\x26 __x,\x0a"
"                        const extreme_value_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const extreme_value_distribution\x26 __x,\x0a"
"                        const extreme_value_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template<class _RealType>\x0a"
"template<class _URNG>\x0a"
"_RealType\x0a"
"extreme_value_distribution<_RealType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    return __p.a() - __p.b() *\x0a"
"         _VSTD\x3a\x3alog(-_VSTD\x3a\x3alog(1-uniform_real_distribution<result_type>()(__g)));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const extreme_value_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    __os << __x.a() << __sp << __x.b();\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           extreme_value_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef extreme_value_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __a;\x0a"
"    result_type __b;\x0a"
"    __is >> __a >> __b;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__a, __b));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// gamma_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS gamma_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __alpha_;\x0a"
"        result_type __beta_;\x0a"
"    public\x3a\x0a"
"        typedef gamma_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __alpha = 1, result_type __beta = 1)\x0a"
"            \x3a __alpha_(__alpha), __beta_(__beta) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type alpha() const {return __alpha_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type beta() const {return __beta_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__alpha_ == __y.__alpha_ \x26\x26 __x.__beta_ == __y.__beta_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructors and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit gamma_distribution(result_type __alpha = 1, result_type __beta = 1)\x0a"
"        \x3a __p_(param_type(__alpha, __beta)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit gamma_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type alpha() const {return __p_.alpha();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type beta() const {return __p_.beta();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const gamma_distribution\x26 __x,\x0a"
"                        const gamma_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const gamma_distribution\x26 __x,\x0a"
"                        const gamma_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _RealType>\x0a"
"template<class _URNG>\x0a"
"_RealType\x0a"
"gamma_distribution<_RealType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    result_type __a = __p.alpha();\x0a"
"    uniform_real_distribution<result_type> __gen(0, 1);\x0a"
"    exponential_distribution<result_type> __egen;\x0a"
"    result_type __x;\x0a"
"    if (__a == 1)\x0a"
"        __x = __egen(__g);\x0a"
"    else if (__a > 1)\x0a"
"    {\x0a"
"        const result_type __b = __a - 1;\x0a"
"        const result_type __c = 3 * __a - result_type(0.75);\x0a"
"        while (true)\x0a"
"        {\x0a"
"            const result_type __u = __gen(__g);\x0a"
"            const result_type __v = __gen(__g);\x0a"
"            const result_type __w = __u * (1 - __u);\x0a"
"            if (__w \x21= 0)\x0a"
"            {\x0a"
"                const result_type __y = _VSTD\x3a\x3asqrt(__c / __w) *\x0a"
"                                        (__u - result_type(0.5));\x0a"
"                __x = __b + __y;\x0a"
"                if (__x >= 0)\x0a"
"                {\x0a"
"                    const result_type __z = 64 * __w * __w * __w * __v * __v;\x0a"
"                    if (__z <= 1 - 2 * __y * __y / __x)\x0a"
"                        break;\x0a"
"                    if (_VSTD\x3a\x3alog(__z) <= 2 * (__b * _VSTD\x3a\x3alog(__x / __b) - __y))\x0a"
"                        break;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    else  // __a < 1\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            const result_type __u = __gen(__g);\x0a"
"            const result_type __es = __egen(__g);\x0a"
"            if (__u <= 1 - __a)\x0a"
"            {\x0a"
"                __x = _VSTD\x3a\x3apow(__u, 1 / __a);\x0a"
"                if (__x <= __es)\x0a"
"                    break;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                const result_type __e = -_VSTD\x3a\x3alog((1-__u)/__a);\x0a"
"                __x = _VSTD\x3a\x3apow(1 - __a + __a * __e, 1 / __a);\x0a"
"                if (__x <= __e + __es)\x0a"
"                    break;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __x * __p.beta();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const gamma_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    __os << __x.alpha() << __sp << __x.beta();\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           gamma_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef gamma_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __alpha;\x0a"
"    result_type __beta;\x0a"
"    __is >> __alpha >> __beta;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__alpha, __beta));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// negative_binomial_distribution\x0a"
"\x0a"
"template<class _IntType = int>\x0a"
"class _LIBCPP_TEMPLATE_VIS negative_binomial_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _IntType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __k_;\x0a"
"        double __p_;\x0a"
"    public\x3a\x0a"
"        typedef negative_binomial_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __k = 1, double __p = 0.5)\x0a"
"            \x3a __k_(__k), __p_(__p) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type k() const {return __k_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        double p() const {return __p_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__k_ == __y.__k_ \x26\x26 __x.__p_ == __y.__p_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit negative_binomial_distribution(result_type __k = 1, double __p = 0.5)\x0a"
"        \x3a __p_(__k, __p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit negative_binomial_distribution(const param_type\x26 __p) \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type k() const {return __p_.k();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    double p() const {return __p_.p();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3amax();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const negative_binomial_distribution\x26 __x,\x0a"
"                        const negative_binomial_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const negative_binomial_distribution\x26 __x,\x0a"
"                        const negative_binomial_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _IntType>\x0a"
"template<class _URNG>\x0a"
"_IntType\x0a"
"negative_binomial_distribution<_IntType>\x3a\x3aoperator()(_URNG\x26 __urng, const param_type\x26 __pr)\x0a"
"{\x0a"
"    result_type __k = __pr.k();\x0a"
"    double __p = __pr.p();\x0a"
"    if (__k <= 21 * __p)\x0a"
"    {\x0a"
"        bernoulli_distribution __gen(__p);\x0a"
"        result_type __f = 0;\x0a"
"        result_type __s = 0;\x0a"
"        while (__s < __k)\x0a"
"        {\x0a"
"            if (__gen(__urng))\x0a"
"                ++__s;\x0a"
"            else\x0a"
"                ++__f;\x0a"
"        }\x0a"
"        return __f;\x0a"
"    }\x0a"
"    return poisson_distribution<result_type>(gamma_distribution<double>\x0a"
"                                            (__k, (1-__p)/__p)(__urng))(__urng);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IntType>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const negative_binomial_distribution<_IntType>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    return __os << __x.k() << __sp << __x.p();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IntType>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           negative_binomial_distribution<_IntType>\x26 __x)\x0a"
"{\x0a"
"    typedef negative_binomial_distribution<_IntType> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __k;\x0a"
"    double __p;\x0a"
"    __is >> __k >> __p;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__k, __p));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// geometric_distribution\x0a"
"\x0a"
"template<class _IntType = int>\x0a"
"class _LIBCPP_TEMPLATE_VIS geometric_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _IntType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        double __p_;\x0a"
"    public\x3a\x0a"
"        typedef geometric_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(double __p = 0.5) \x3a __p_(__p) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        double p() const {return __p_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__p_ == __y.__p_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructors and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit geometric_distribution(double __p = 0.5) \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit geometric_distribution(const param_type\x26 __p) \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"        {return negative_binomial_distribution<result_type>(1, __p.p())(__g);}\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    double p() const {return __p_.p();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3amax();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const geometric_distribution\x26 __x,\x0a"
"                        const geometric_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const geometric_distribution\x26 __x,\x0a"
"                        const geometric_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IntType>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const geometric_distribution<_IntType>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    return __os << __x.p();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IntType>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           geometric_distribution<_IntType>\x26 __x)\x0a"
"{\x0a"
"    typedef geometric_distribution<_IntType> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    double __p;\x0a"
"    __is >> __p;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__p));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// chi_squared_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS chi_squared_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __n_;\x0a"
"    public\x3a\x0a"
"        typedef chi_squared_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __n = 1) \x3a __n_(__n) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type n() const {return __n_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__n_ == __y.__n_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit chi_squared_distribution(result_type __n = 1)\x0a"
"        \x3a __p_(param_type(__n)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit chi_squared_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"        {return gamma_distribution<result_type>(__p.n() / 2, 2)(__g);}\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type n() const {return __p_.n();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const chi_squared_distribution\x26 __x,\x0a"
"                        const chi_squared_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const chi_squared_distribution\x26 __x,\x0a"
"                        const chi_squared_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const chi_squared_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    __os << __x.n();\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           chi_squared_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef chi_squared_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __n;\x0a"
"    __is >> __n;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__n));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// cauchy_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS cauchy_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __a_;\x0a"
"        result_type __b_;\x0a"
"    public\x3a\x0a"
"        typedef cauchy_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __a = 0, result_type __b = 1)\x0a"
"            \x3a __a_(__a), __b_(__b) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type a() const {return __a_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type b() const {return __b_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__a_ == __y.__a_ \x26\x26 __x.__b_ == __y.__b_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit cauchy_distribution(result_type __a = 0, result_type __b = 1)\x0a"
"        \x3a __p_(param_type(__a, __b)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit cauchy_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> _LIBCPP_INLINE_VISIBILITY result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type a() const {return __p_.a();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type b() const {return __p_.b();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return -numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const cauchy_distribution\x26 __x,\x0a"
"                        const cauchy_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const cauchy_distribution\x26 __x,\x0a"
"                        const cauchy_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _RealType>\x0a"
"template<class _URNG>\x0a"
"inline\x0a"
"_RealType\x0a"
"cauchy_distribution<_RealType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    uniform_real_distribution<result_type> __gen;\x0a"
"    // purposefully let tan arg get as close to pi/2 as it wants, tan will return a finite\x0a"
"    return __p.a() + __p.b() * _VSTD\x3a\x3atan(3.1415926535897932384626433832795 * __gen(__g));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const cauchy_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    __os << __x.a() << __sp << __x.b();\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           cauchy_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef cauchy_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __a;\x0a"
"    result_type __b;\x0a"
"    __is >> __a >> __b;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__a, __b));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// fisher_f_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS fisher_f_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __m_;\x0a"
"        result_type __n_;\x0a"
"    public\x3a\x0a"
"        typedef fisher_f_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __m = 1, result_type __n = 1)\x0a"
"            \x3a __m_(__m), __n_(__n) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type m() const {return __m_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type n() const {return __n_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__m_ == __y.__m_ \x26\x26 __x.__n_ == __y.__n_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit fisher_f_distribution(result_type __m = 1, result_type __n = 1)\x0a"
"        \x3a __p_(param_type(__m, __n)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit fisher_f_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type m() const {return __p_.m();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type n() const {return __p_.n();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const fisher_f_distribution\x26 __x,\x0a"
"                        const fisher_f_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const fisher_f_distribution\x26 __x,\x0a"
"                        const fisher_f_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _RealType>\x0a"
"template<class _URNG>\x0a"
"_RealType\x0a"
"fisher_f_distribution<_RealType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    gamma_distribution<result_type> __gdm(__p.m() * result_type(.5));\x0a"
"    gamma_distribution<result_type> __gdn(__p.n() * result_type(.5));\x0a"
"    return __p.n() * __gdm(__g) / (__p.m() * __gdn(__g));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const fisher_f_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    __os << __x.m() << __sp << __x.n();\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           fisher_f_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef fisher_f_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __m;\x0a"
"    result_type __n;\x0a"
"    __is >> __m >> __n;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__m, __n));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// student_t_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS student_t_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        result_type __n_;\x0a"
"    public\x3a\x0a"
"        typedef student_t_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit param_type(result_type __n = 1) \x3a __n_(__n) {}\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type n() const {return __n_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__n_ == __y.__n_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"    normal_distribution<result_type> __nd_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit student_t_distribution(result_type __n = 1)\x0a"
"        \x3a __p_(param_type(__n)) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit student_t_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {__nd_.reset();}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type n() const {return __p_.n();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return -numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return numeric_limits<result_type>\x3a\x3ainfinity();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const student_t_distribution\x26 __x,\x0a"
"                        const student_t_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const student_t_distribution\x26 __x,\x0a"
"                        const student_t_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _RealType>\x0a"
"template<class _URNG>\x0a"
"_RealType\x0a"
"student_t_distribution<_RealType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    gamma_distribution<result_type> __gd(__p.n() * .5, 2);\x0a"
"    return __nd_(__g) * _VSTD\x3a\x3asqrt(__p.n()/__gd(__g));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const student_t_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    __os << __x.n();\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           student_t_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef student_t_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _Eng\x3a\x3aparam_type param_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    result_type __n;\x0a"
"    __is >> __n;\x0a"
"    if (\x21__is.fail())\x0a"
"        __x.param(param_type(__n));\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// discrete_distribution\x0a"
"\x0a"
"template<class _IntType = int>\x0a"
"class _LIBCPP_TEMPLATE_VIS discrete_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _IntType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        vector<double> __p_;\x0a"
"    public\x3a\x0a"
"        typedef discrete_distribution distribution_type;\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        param_type() {}\x0a"
"        template<class _InputIterator>\x0a"
"            _LIBCPP_INLINE_VISIBILITY\x0a"
"            param_type(_InputIterator __f, _InputIterator __l)\x0a"
"            \x3a __p_(__f, __l) {__init();}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        param_type(initializer_list<double> __wl)\x0a"
"            \x3a __p_(__wl.begin(), __wl.end()) {__init();}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"        template<class _UnaryOperation>\x0a"
"            param_type(size_t __nw, double __xmin, double __xmax,\x0a"
"                       _UnaryOperation __fw);\x0a"
"\x0a"
"        vector<double> probabilities() const;\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__p_ == __y.__p_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"\x0a"
"    private\x3a\x0a"
"        void __init();\x0a"
"\x0a"
"        friend class discrete_distribution;\x0a"
"\x0a"
"        template <class _CharT, class _Traits, class _IT>\x0a"
"        friend\x0a"
"        basic_ostream<_CharT, _Traits>\x26\x0a"
"        operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"                   const discrete_distribution<_IT>\x26 __x);\x0a"
"\x0a"
"        template <class _CharT, class _Traits, class _IT>\x0a"
"        friend\x0a"
"        basic_istream<_CharT, _Traits>\x26\x0a"
"        operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"                   discrete_distribution<_IT>\x26 __x);\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    discrete_distribution() {}\x0a"
"    template<class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        discrete_distribution(_InputIterator __f, _InputIterator __l)\x0a"
"            \x3a __p_(__f, __l) {}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    discrete_distribution(initializer_list<double> __wl)\x0a"
"        \x3a __p_(__wl) {}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    template<class _UnaryOperation>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        discrete_distribution(size_t __nw, double __xmin, double __xmax,\x0a"
"                              _UnaryOperation __fw)\x0a"
"        \x3a __p_(__nw, __xmin, __xmax, __fw) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit discrete_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector<double> probabilities() const {return __p_.probabilities();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return __p_.__p_.size();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const discrete_distribution\x26 __x,\x0a"
"                        const discrete_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const discrete_distribution\x26 __x,\x0a"
"                        const discrete_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _IT>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const discrete_distribution<_IT>\x26 __x);\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _IT>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               discrete_distribution<_IT>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template<class _IntType>\x0a"
"template<class _UnaryOperation>\x0a"
"discrete_distribution<_IntType>\x3a\x3aparam_type\x3a\x3aparam_type(size_t __nw,\x0a"
"                                                        double __xmin,\x0a"
"                                                        double __xmax,\x0a"
"                                                        _UnaryOperation __fw)\x0a"
"{\x0a"
"    if (__nw > 1)\x0a"
"    {\x0a"
"        __p_.reserve(__nw - 1);\x0a"
"        double __d = (__xmax - __xmin) / __nw;\x0a"
"        double __d2 = __d / 2;\x0a"
"        for (size_t __k = 0; __k < __nw; ++__k)\x0a"
"            __p_.push_back(__fw(__xmin + __k * __d + __d2));\x0a"
"        __init();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template<class _IntType>\x0a"
"void\x0a"
"discrete_distribution<_IntType>\x3a\x3aparam_type\x3a\x3a__init()\x0a"
"{\x0a"
"    if (\x21__p_.empty())\x0a"
"    {\x0a"
"        if (__p_.size() > 1)\x0a"
"        {\x0a"
"            double __s = _VSTD\x3a\x3a""accumulate(__p_.begin(), __p_.end(), 0.0);\x0a"
"            for (_VSTD\x3a\x3avector<double>\x3a\x3aiterator __i = __p_.begin(), __e = __p_.end();\x0a"
"                                                                       __i < __e; ++__i)\x0a"
"                *__i /= __s;\x0a"
"            vector<double> __t(__p_.size() - 1);\x0a"
"            _VSTD\x3a\x3apartial_sum(__p_.begin(), __p_.end() - 1, __t.begin());\x0a"
"            swap(__p_, __t);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __p_.clear();\x0a"
"            __p_.shrink_to_fit();\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template<class _IntType>\x0a"
"vector<double>\x0a"
"discrete_distribution<_IntType>\x3a\x3aparam_type\x3a\x3aprobabilities() const\x0a"
"{\x0a"
"    size_t __n = __p_.size();\x0a"
"    _VSTD\x3a\x3avector<double> __p(__n+1);\x0a"
"    _VSTD\x3a\x3a""adjacent_difference(__p_.begin(), __p_.end(), __p.begin());\x0a"
"    if (__n > 0)\x0a"
"        __p\x5b__n\x5d = 1 - __p_\x5b__n-1\x5d;\x0a"
"    else\x0a"
"        __p\x5b""0\x5d = 1;\x0a"
"    return __p;\x0a"
"}\x0a"
"\x0a"
"template<class _IntType>\x0a"
"template<class _URNG>\x0a"
"_IntType\x0a"
"discrete_distribution<_IntType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    uniform_real_distribution<double> __gen;\x0a"
"    return static_cast<_IntType>(\x0a"
"           _VSTD\x3a\x3aupper_bound(__p.__p_.begin(), __p.__p_.end(), __gen(__g)) -\x0a"
"                                                              __p.__p_.begin());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const discrete_distribution<_IT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    size_t __n = __x.__p_.__p_.size();\x0a"
"    __os << __n;\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __os << __sp << __x.__p_.__p_\x5b__i\x5d;\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _IT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           discrete_distribution<_IT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    size_t __n;\x0a"
"    __is >> __n;\x0a"
"    vector<double> __p(__n);\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __is >> __p\x5b__i\x5d;\x0a"
"    if (\x21__is.fail())\x0a"
"        swap(__x.__p_.__p_, __p);\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// piecewise_constant_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS piecewise_constant_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        vector<result_type> __b_;\x0a"
"        vector<result_type> __densities_;\x0a"
"        vector<result_type> __areas_;\x0a"
"    public\x3a\x0a"
"        typedef piecewise_constant_distribution distribution_type;\x0a"
"\x0a"
"        param_type();\x0a"
"        template<class _InputIteratorB, class _InputIteratorW>\x0a"
"            param_type(_InputIteratorB __fB, _InputIteratorB __lB,\x0a"
"                       _InputIteratorW __fW);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"        template<class _UnaryOperation>\x0a"
"            param_type(initializer_list<result_type> __bl, _UnaryOperation __fw);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"        template<class _UnaryOperation>\x0a"
"            param_type(size_t __nw, result_type __xmin, result_type __xmax,\x0a"
"                       _UnaryOperation __fw);\x0a"
"        param_type \x26 operator=(const param_type\x26 __rhs);\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        vector<result_type> intervals() const {return __b_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        vector<result_type> densities() const {return __densities_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__densities_ == __y.__densities_ \x26\x26 __x.__b_ == __y.__b_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"\x0a"
"    private\x3a\x0a"
"        void __init();\x0a"
"\x0a"
"        friend class piecewise_constant_distribution;\x0a"
"\x0a"
"        template <class _CharT, class _Traits, class _RT>\x0a"
"        friend\x0a"
"        basic_ostream<_CharT, _Traits>\x26\x0a"
"        operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"                   const piecewise_constant_distribution<_RT>\x26 __x);\x0a"
"\x0a"
"        template <class _CharT, class _Traits, class _RT>\x0a"
"        friend\x0a"
"        basic_istream<_CharT, _Traits>\x26\x0a"
"        operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"                   piecewise_constant_distribution<_RT>\x26 __x);\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    piecewise_constant_distribution() {}\x0a"
"    template<class _InputIteratorB, class _InputIteratorW>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        piecewise_constant_distribution(_InputIteratorB __fB,\x0a"
"                                        _InputIteratorB __lB,\x0a"
"                                        _InputIteratorW __fW)\x0a"
"        \x3a __p_(__fB, __lB, __fW) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template<class _UnaryOperation>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        piecewise_constant_distribution(initializer_list<result_type> __bl,\x0a"
"                                        _UnaryOperation __fw)\x0a"
"        \x3a __p_(__bl, __fw) {}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template<class _UnaryOperation>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        piecewise_constant_distribution(size_t __nw, result_type __xmin,\x0a"
"                                        result_type __xmax, _UnaryOperation __fw)\x0a"
"        \x3a __p_(__nw, __xmin, __xmax, __fw) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit piecewise_constant_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector<result_type> intervals() const {return __p_.intervals();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector<result_type> densities() const {return __p_.densities();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return __p_.__b_.front();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return __p_.__b_.back();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const piecewise_constant_distribution\x26 __x,\x0a"
"                        const piecewise_constant_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const piecewise_constant_distribution\x26 __x,\x0a"
"                           const piecewise_constant_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _RT>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const piecewise_constant_distribution<_RT>\x26 __x);\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _RT>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               piecewise_constant_distribution<_RT>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template<class _RealType>\x0a"
"typename piecewise_constant_distribution<_RealType>\x3a\x3aparam_type \x26\x0a"
"piecewise_constant_distribution<_RealType>\x3a\x3aparam_type\x3a\x3aoperator=\x0a"
"                                                       (const param_type\x26 __rhs)\x0a"
"{\x0a"
"//  These can throw\x0a"
"    __b_.reserve        (__rhs.__b_.size ());\x0a"
"    __densities_.reserve(__rhs.__densities_.size());\x0a"
"    __areas_.reserve    (__rhs.__areas_.size());\x0a"
"\x0a"
"//  These can not throw\x0a"
"    __b_         = __rhs.__b_;\x0a"
"    __densities_ = __rhs.__densities_;\x0a"
"    __areas_     =  __rhs.__areas_;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template<class _RealType>\x0a"
"void\x0a"
"piecewise_constant_distribution<_RealType>\x3a\x3aparam_type\x3a\x3a__init()\x0a"
"{\x0a"
"    // __densities_ contains non-normalized areas\x0a"
"    result_type __total_area = _VSTD\x3a\x3a""accumulate(__densities_.begin(),\x0a"
"                                                __densities_.end(),\x0a"
"                                                result_type());\x0a"
"    for (size_t __i = 0; __i < __densities_.size(); ++__i)\x0a"
"        __densities_\x5b__i\x5d /= __total_area;\x0a"
"    // __densities_ contains normalized areas\x0a"
"    __areas_.assign(__densities_.size(), result_type());\x0a"
"    _VSTD\x3a\x3apartial_sum(__densities_.begin(), __densities_.end() - 1,\x0a"
"                                                          __areas_.begin() + 1);\x0a"
"    // __areas_ contains partial sums of normalized areas\x3a \x5b""0, __densities_ - 1\x5d\x0a"
"    __densities_.back() = 1 - __areas_.back();  // correct round off error\x0a"
"    for (size_t __i = 0; __i < __densities_.size(); ++__i)\x0a"
"        __densities_\x5b__i\x5d /= (__b_\x5b__i+1\x5d - __b_\x5b__i\x5d);\x0a"
"    // __densities_ now contains __densities_\x0a"
"}\x0a"
"\x0a"
"template<class _RealType>\x0a"
"piecewise_constant_distribution<_RealType>\x3a\x3aparam_type\x3a\x3aparam_type()\x0a"
"    \x3a __b_(2),\x0a"
"      __densities_(1, 1.0),\x0a"
"      __areas_(1, 0.0)\x0a"
"{\x0a"
"    __b_\x5b""1\x5d = 1;\x0a"
"}\x0a"
"\x0a"
"template<class _RealType>\x0a"
"template<class _InputIteratorB, class _InputIteratorW>\x0a"
"piecewise_constant_distribution<_RealType>\x3a\x3aparam_type\x3a\x3aparam_type(\x0a"
"        _InputIteratorB __fB, _InputIteratorB __lB, _InputIteratorW __fW)\x0a"
"    \x3a __b_(__fB, __lB)\x0a"
"{\x0a"
"    if (__b_.size() < 2)\x0a"
"    {\x0a"
"        __b_.resize(2);\x0a"
"        __b_\x5b""0\x5d = 0;\x0a"
"        __b_\x5b""1\x5d = 1;\x0a"
"        __densities_.assign(1, 1.0);\x0a"
"        __areas_.assign(1, 0.0);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __densities_.reserve(__b_.size() - 1);\x0a"
"        for (size_t __i = 0; __i < __b_.size() - 1; ++__i, ++__fW)\x0a"
"            __densities_.push_back(*__fW);\x0a"
"        __init();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _RealType>\x0a"
"template<class _UnaryOperation>\x0a"
"piecewise_constant_distribution<_RealType>\x3a\x3aparam_type\x3a\x3aparam_type(\x0a"
"        initializer_list<result_type> __bl, _UnaryOperation __fw)\x0a"
"    \x3a __b_(__bl.begin(), __bl.end())\x0a"
"{\x0a"
"    if (__b_.size() < 2)\x0a"
"    {\x0a"
"        __b_.resize(2);\x0a"
"        __b_\x5b""0\x5d = 0;\x0a"
"        __b_\x5b""1\x5d = 1;\x0a"
"        __densities_.assign(1, 1.0);\x0a"
"        __areas_.assign(1, 0.0);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __densities_.reserve(__b_.size() - 1);\x0a"
"        for (size_t __i = 0; __i < __b_.size() - 1; ++__i)\x0a"
"            __densities_.push_back(__fw((__b_\x5b__i+1\x5d + __b_\x5b__i\x5d)*.5));\x0a"
"        __init();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _RealType>\x0a"
"template<class _UnaryOperation>\x0a"
"piecewise_constant_distribution<_RealType>\x3a\x3aparam_type\x3a\x3aparam_type(\x0a"
"        size_t __nw, result_type __xmin, result_type __xmax, _UnaryOperation __fw)\x0a"
"    \x3a __b_(__nw == 0 \x3f 2 \x3a __nw + 1)\x0a"
"{\x0a"
"    size_t __n = __b_.size() - 1;\x0a"
"    result_type __d = (__xmax - __xmin) / __n;\x0a"
"    __densities_.reserve(__n);\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"    {\x0a"
"        __b_\x5b__i\x5d = __xmin + __i * __d;\x0a"
"        __densities_.push_back(__fw(__b_\x5b__i\x5d + __d*.5));\x0a"
"    }\x0a"
"    __b_\x5b__n\x5d = __xmax;\x0a"
"    __init();\x0a"
"}\x0a"
"\x0a"
"template<class _RealType>\x0a"
"template<class _URNG>\x0a"
"_RealType\x0a"
"piecewise_constant_distribution<_RealType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    typedef uniform_real_distribution<result_type> _Gen;\x0a"
"    result_type __u = _Gen()(__g);\x0a"
"    ptrdiff_t __k = _VSTD\x3a\x3aupper_bound(__p.__areas_.begin(), __p.__areas_.end(),\x0a"
"                                      __u) - __p.__areas_.begin() - 1;\x0a"
"    return (__u - __p.__areas_\x5b__k\x5d) / __p.__densities_\x5b__k\x5d + __p.__b_\x5b__k\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const piecewise_constant_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    size_t __n = __x.__p_.__b_.size();\x0a"
"    __os << __n;\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __os << __sp << __x.__p_.__b_\x5b__i\x5d;\x0a"
"    __n = __x.__p_.__densities_.size();\x0a"
"    __os << __sp << __n;\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __os << __sp << __x.__p_.__densities_\x5b__i\x5d;\x0a"
"    __n = __x.__p_.__areas_.size();\x0a"
"    __os << __sp << __n;\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __os << __sp << __x.__p_.__areas_\x5b__i\x5d;\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           piecewise_constant_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef piecewise_constant_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    size_t __n;\x0a"
"    __is >> __n;\x0a"
"    vector<result_type> __b(__n);\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __is >> __b\x5b__i\x5d;\x0a"
"    __is >> __n;\x0a"
"    vector<result_type> __densities(__n);\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __is >> __densities\x5b__i\x5d;\x0a"
"    __is >> __n;\x0a"
"    vector<result_type> __areas(__n);\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __is >> __areas\x5b__i\x5d;\x0a"
"    if (\x21__is.fail())\x0a"
"    {\x0a"
"        swap(__x.__p_.__b_, __b);\x0a"
"        swap(__x.__p_.__densities_, __densities);\x0a"
"        swap(__x.__p_.__areas_, __areas);\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"// piecewise_linear_distribution\x0a"
"\x0a"
"template<class _RealType = double>\x0a"
"class _LIBCPP_TEMPLATE_VIS piecewise_linear_distribution\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x0a"
"    typedef _RealType result_type;\x0a"
"\x0a"
"    class _LIBCPP_TEMPLATE_VIS param_type\x0a"
"    {\x0a"
"        vector<result_type> __b_;\x0a"
"        vector<result_type> __densities_;\x0a"
"        vector<result_type> __areas_;\x0a"
"    public\x3a\x0a"
"        typedef piecewise_linear_distribution distribution_type;\x0a"
"\x0a"
"        param_type();\x0a"
"        template<class _InputIteratorB, class _InputIteratorW>\x0a"
"            param_type(_InputIteratorB __fB, _InputIteratorB __lB,\x0a"
"                       _InputIteratorW __fW);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"        template<class _UnaryOperation>\x0a"
"            param_type(initializer_list<result_type> __bl, _UnaryOperation __fw);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"        template<class _UnaryOperation>\x0a"
"            param_type(size_t __nw, result_type __xmin, result_type __xmax,\x0a"
"                       _UnaryOperation __fw);\x0a"
"        param_type \x26 operator=(const param_type\x26 __rhs);\x0a"
"\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        vector<result_type> intervals() const {return __b_;}\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        vector<result_type> densities() const {return __densities_;}\x0a"
"\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator==(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return __x.__densities_ == __y.__densities_ \x26\x26 __x.__b_ == __y.__b_;}\x0a"
"        friend _LIBCPP_INLINE_VISIBILITY\x0a"
"            bool operator\x21=(const param_type\x26 __x, const param_type\x26 __y)\x0a"
"            {return \x21(__x == __y);}\x0a"
"\x0a"
"    private\x3a\x0a"
"        void __init();\x0a"
"\x0a"
"        friend class piecewise_linear_distribution;\x0a"
"\x0a"
"        template <class _CharT, class _Traits, class _RT>\x0a"
"        friend\x0a"
"        basic_ostream<_CharT, _Traits>\x26\x0a"
"        operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"                   const piecewise_linear_distribution<_RT>\x26 __x);\x0a"
"\x0a"
"        template <class _CharT, class _Traits, class _RT>\x0a"
"        friend\x0a"
"        basic_istream<_CharT, _Traits>\x26\x0a"
"        operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"                   piecewise_linear_distribution<_RT>\x26 __x);\x0a"
"    };\x0a"
"\x0a"
"private\x3a\x0a"
"    param_type __p_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constructor and reset functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    piecewise_linear_distribution() {}\x0a"
"    template<class _InputIteratorB, class _InputIteratorW>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        piecewise_linear_distribution(_InputIteratorB __fB,\x0a"
"                                      _InputIteratorB __lB,\x0a"
"                                      _InputIteratorW __fW)\x0a"
"        \x3a __p_(__fB, __lB, __fW) {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template<class _UnaryOperation>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        piecewise_linear_distribution(initializer_list<result_type> __bl,\x0a"
"                                      _UnaryOperation __fw)\x0a"
"        \x3a __p_(__bl, __fw) {}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template<class _UnaryOperation>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        piecewise_linear_distribution(size_t __nw, result_type __xmin,\x0a"
"                                      result_type __xmax, _UnaryOperation __fw)\x0a"
"        \x3a __p_(__nw, __xmin, __xmax, __fw) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit piecewise_linear_distribution(const param_type\x26 __p)\x0a"
"        \x3a __p_(__p) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reset() {}\x0a"
"\x0a"
"    // generating functions\x0a"
"    template<class _URNG>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        result_type operator()(_URNG\x26 __g)\x0a"
"        {return (*this)(__g, __p_);}\x0a"
"    template<class _URNG> result_type operator()(_URNG\x26 __g, const param_type\x26 __p);\x0a"
"\x0a"
"    // property functions\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector<result_type> intervals() const {return __p_.intervals();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector<result_type> densities() const {return __p_.densities();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    param_type param() const {return __p_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void param(const param_type\x26 __p) {__p_ = __p;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const {return __p_.__b_.front();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const {return __p_.__b_.back();}\x0a"
"\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator==(const piecewise_linear_distribution\x26 __x,\x0a"
"                        const piecewise_linear_distribution\x26 __y)\x0a"
"        {return __x.__p_ == __y.__p_;}\x0a"
"    friend _LIBCPP_INLINE_VISIBILITY\x0a"
"        bool operator\x21=(const piecewise_linear_distribution\x26 __x,\x0a"
"                        const piecewise_linear_distribution\x26 __y)\x0a"
"        {return \x21(__x == __y);}\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _RT>\x0a"
"    friend\x0a"
"    basic_ostream<_CharT, _Traits>\x26\x0a"
"    operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"               const piecewise_linear_distribution<_RT>\x26 __x);\x0a"
"\x0a"
"    template <class _CharT, class _Traits, class _RT>\x0a"
"    friend\x0a"
"    basic_istream<_CharT, _Traits>\x26\x0a"
"    operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"               piecewise_linear_distribution<_RT>\x26 __x);\x0a"
"};\x0a"
"\x0a"
"template<class _RealType>\x0a"
"typename piecewise_linear_distribution<_RealType>\x3a\x3aparam_type \x26\x0a"
"piecewise_linear_distribution<_RealType>\x3a\x3aparam_type\x3a\x3aoperator=\x0a"
"                                                       (const param_type\x26 __rhs)\x0a"
"{\x0a"
"//  These can throw\x0a"
"    __b_.reserve        (__rhs.__b_.size ());\x0a"
"    __densities_.reserve(__rhs.__densities_.size());\x0a"
"    __areas_.reserve    (__rhs.__areas_.size());\x0a"
"\x0a"
"//  These can not throw\x0a"
"    __b_         = __rhs.__b_;\x0a"
"    __densities_ = __rhs.__densities_;\x0a"
"    __areas_     =  __rhs.__areas_;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template<class _RealType>\x0a"
"void\x0a"
"piecewise_linear_distribution<_RealType>\x3a\x3aparam_type\x3a\x3a__init()\x0a"
"{\x0a"
"    __areas_.assign(__densities_.size() - 1, result_type());\x0a"
"    result_type _Sp = 0;\x0a"
"    for (size_t __i = 0; __i < __areas_.size(); ++__i)\x0a"
"    {\x0a"
"        __areas_\x5b__i\x5d = (__densities_\x5b__i+1\x5d + __densities_\x5b__i\x5d) *\x0a"
"                        (__b_\x5b__i+1\x5d - __b_\x5b__i\x5d) * .5;\x0a"
"        _Sp += __areas_\x5b__i\x5d;\x0a"
"    }\x0a"
"    for (size_t __i = __areas_.size(); __i > 1;)\x0a"
"    {\x0a"
"        --__i;\x0a"
"        __areas_\x5b__i\x5d = __areas_\x5b__i-1\x5d / _Sp;\x0a"
"    }\x0a"
"    __areas_\x5b""0\x5d = 0;\x0a"
"    for (size_t __i = 1; __i < __areas_.size(); ++__i)\x0a"
"        __areas_\x5b__i\x5d += __areas_\x5b__i-1\x5d;\x0a"
"    for (size_t __i = 0; __i < __densities_.size(); ++__i)\x0a"
"        __densities_\x5b__i\x5d /= _Sp;\x0a"
"}\x0a"
"\x0a"
"template<class _RealType>\x0a"
"piecewise_linear_distribution<_RealType>\x3a\x3aparam_type\x3a\x3aparam_type()\x0a"
"    \x3a __b_(2),\x0a"
"      __densities_(2, 1.0),\x0a"
"      __areas_(1, 0.0)\x0a"
"{\x0a"
"    __b_\x5b""1\x5d = 1;\x0a"
"}\x0a"
"\x0a"
"template<class _RealType>\x0a"
"template<class _InputIteratorB, class _InputIteratorW>\x0a"
"piecewise_linear_distribution<_RealType>\x3a\x3aparam_type\x3a\x3aparam_type(\x0a"
"        _InputIteratorB __fB, _InputIteratorB __lB, _InputIteratorW __fW)\x0a"
"    \x3a __b_(__fB, __lB)\x0a"
"{\x0a"
"    if (__b_.size() < 2)\x0a"
"    {\x0a"
"        __b_.resize(2);\x0a"
"        __b_\x5b""0\x5d = 0;\x0a"
"        __b_\x5b""1\x5d = 1;\x0a"
"        __densities_.assign(2, 1.0);\x0a"
"        __areas_.assign(1, 0.0);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __densities_.reserve(__b_.size());\x0a"
"        for (size_t __i = 0; __i < __b_.size(); ++__i, ++__fW)\x0a"
"            __densities_.push_back(*__fW);\x0a"
"        __init();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _RealType>\x0a"
"template<class _UnaryOperation>\x0a"
"piecewise_linear_distribution<_RealType>\x3a\x3aparam_type\x3a\x3aparam_type(\x0a"
"        initializer_list<result_type> __bl, _UnaryOperation __fw)\x0a"
"    \x3a __b_(__bl.begin(), __bl.end())\x0a"
"{\x0a"
"    if (__b_.size() < 2)\x0a"
"    {\x0a"
"        __b_.resize(2);\x0a"
"        __b_\x5b""0\x5d = 0;\x0a"
"        __b_\x5b""1\x5d = 1;\x0a"
"        __densities_.assign(2, 1.0);\x0a"
"        __areas_.assign(1, 0.0);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __densities_.reserve(__b_.size());\x0a"
"        for (size_t __i = 0; __i < __b_.size(); ++__i)\x0a"
"            __densities_.push_back(__fw(__b_\x5b__i\x5d));\x0a"
"        __init();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _RealType>\x0a"
"template<class _UnaryOperation>\x0a"
"piecewise_linear_distribution<_RealType>\x3a\x3aparam_type\x3a\x3aparam_type(\x0a"
"        size_t __nw, result_type __xmin, result_type __xmax, _UnaryOperation __fw)\x0a"
"    \x3a __b_(__nw == 0 \x3f 2 \x3a __nw + 1)\x0a"
"{\x0a"
"    size_t __n = __b_.size() - 1;\x0a"
"    result_type __d = (__xmax - __xmin) / __n;\x0a"
"    __densities_.reserve(__b_.size());\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"    {\x0a"
"        __b_\x5b__i\x5d = __xmin + __i * __d;\x0a"
"        __densities_.push_back(__fw(__b_\x5b__i\x5d));\x0a"
"    }\x0a"
"    __b_\x5b__n\x5d = __xmax;\x0a"
"    __densities_.push_back(__fw(__b_\x5b__n\x5d));\x0a"
"    __init();\x0a"
"}\x0a"
"\x0a"
"template<class _RealType>\x0a"
"template<class _URNG>\x0a"
"_RealType\x0a"
"piecewise_linear_distribution<_RealType>\x3a\x3aoperator()(_URNG\x26 __g, const param_type\x26 __p)\x0a"
"{\x0a"
"    typedef uniform_real_distribution<result_type> _Gen;\x0a"
"    result_type __u = _Gen()(__g);\x0a"
"    ptrdiff_t __k = _VSTD\x3a\x3aupper_bound(__p.__areas_.begin(), __p.__areas_.end(),\x0a"
"                                      __u) - __p.__areas_.begin() - 1;\x0a"
"    __u -= __p.__areas_\x5b__k\x5d;\x0a"
"    const result_type __dk = __p.__densities_\x5b__k\x5d;\x0a"
"    const result_type __dk1 = __p.__densities_\x5b__k+1\x5d;\x0a"
"    const result_type __deltad = __dk1 - __dk;\x0a"
"    const result_type __bk = __p.__b_\x5b__k\x5d;\x0a"
"    if (__deltad == 0)\x0a"
"        return __u / __dk + __bk;\x0a"
"    const result_type __bk1 = __p.__b_\x5b__k+1\x5d;\x0a"
"    const result_type __deltab = __bk1 - __bk;\x0a"
"    return (__bk * __dk1 - __bk1 * __dk +\x0a"
"        _VSTD\x3a\x3asqrt(__deltab * (__deltab * __dk * __dk + 2 * __deltad * __u))) /\x0a"
"        __deltad;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const piecewise_linear_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    __save_flags<_CharT, _Traits> __lx(__os);\x0a"
"    __os.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3aleft \x7c ios_base\x3a\x3a""fixed \x7c\x0a"
"               ios_base\x3a\x3ascientific);\x0a"
"    _CharT __sp = __os.widen(' ');\x0a"
"    __os.fill(__sp);\x0a"
"    size_t __n = __x.__p_.__b_.size();\x0a"
"    __os << __n;\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __os << __sp << __x.__p_.__b_\x5b__i\x5d;\x0a"
"    __n = __x.__p_.__densities_.size();\x0a"
"    __os << __sp << __n;\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __os << __sp << __x.__p_.__densities_\x5b__i\x5d;\x0a"
"    __n = __x.__p_.__areas_.size();\x0a"
"    __os << __sp << __n;\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __os << __sp << __x.__p_.__areas_\x5b__i\x5d;\x0a"
"    return __os;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _RT>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           piecewise_linear_distribution<_RT>\x26 __x)\x0a"
"{\x0a"
"    typedef piecewise_linear_distribution<_RT> _Eng;\x0a"
"    typedef typename _Eng\x3a\x3aresult_type result_type;\x0a"
"    __save_flags<_CharT, _Traits> __lx(__is);\x0a"
"    __is.flags(ios_base\x3a\x3a""dec \x7c ios_base\x3a\x3askipws);\x0a"
"    size_t __n;\x0a"
"    __is >> __n;\x0a"
"    vector<result_type> __b(__n);\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __is >> __b\x5b__i\x5d;\x0a"
"    __is >> __n;\x0a"
"    vector<result_type> __densities(__n);\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __is >> __densities\x5b__i\x5d;\x0a"
"    __is >> __n;\x0a"
"    vector<result_type> __areas(__n);\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __is >> __areas\x5b__i\x5d;\x0a"
"    if (\x21__is.fail())\x0a"
"    {\x0a"
"        swap(__x.__p_.__b_, __b);\x0a"
"        swap(__x.__p_.__densities_, __densities);\x0a"
"        swap(__x.__p_.__areas_, __areas);\x0a"
"    }\x0a"
"    return __is;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_RANDOM\x0a"
"", 225994 ); }