#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_regex( 
"// -*- C++ -*-\x0a"
"//===--------------------------- regex ------------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_REGEX\x0a"
"#define _LIBCPP_REGEX\x0a"
"\x0a"
"/*\x0a"
"    regex synopsis\x0a"
"\x0a"
"#include <initializer_list>\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"namespace regex_constants\x0a"
"{\x0a"
"\x0a"
"emum syntax_option_type\x0a"
"{\x0a"
"    icase      = unspecified,\x0a"
"    nosubs     = unspecified,\x0a"
"    optimize   = unspecified,\x0a"
"    collate    = unspecified,\x0a"
"    ECMAScript = unspecified,\x0a"
"    basic      = unspecified,\x0a"
"    extended   = unspecified,\x0a"
"    awk        = unspecified,\x0a"
"    grep       = unspecified,\x0a"
"    egrep      = unspecified\x0a"
"};\x0a"
"\x0a"
"constexpr syntax_option_type operator\x7e(syntax_option_type f);\x0a"
"constexpr syntax_option_type operator\x26(syntax_option_type lhs, syntax_option_type rhs);\x0a"
"constexpr syntax_option_type operator\x7c(syntax_option_type lhs, syntax_option_type rhs);\x0a"
"\x0a"
"enum match_flag_type\x0a"
"{\x0a"
"    match_default     = 0,\x0a"
"    match_not_bol     = unspecified,\x0a"
"    match_not_eol     = unspecified,\x0a"
"    match_not_bow     = unspecified,\x0a"
"    match_not_eow     = unspecified,\x0a"
"    match_any         = unspecified,\x0a"
"    match_not_null    = unspecified,\x0a"
"    match_continuous  = unspecified,\x0a"
"    match_prev_avail  = unspecified,\x0a"
"    format_default    = 0,\x0a"
"    format_sed        = unspecified,\x0a"
"    format_no_copy    = unspecified,\x0a"
"    format_first_only = unspecified\x0a"
"};\x0a"
"\x0a"
"constexpr match_flag_type operator\x7e(match_flag_type f);\x0a"
"constexpr match_flag_type operator\x26(match_flag_type lhs, match_flag_type rhs);\x0a"
"constexpr match_flag_type operator\x7c(match_flag_type lhs, match_flag_type rhs);\x0a"
"\x0a"
"enum error_type\x0a"
"{\x0a"
"    error_collate    = unspecified,\x0a"
"    error_ctype      = unspecified,\x0a"
"    error_escape     = unspecified,\x0a"
"    error_backref    = unspecified,\x0a"
"    error_brack      = unspecified,\x0a"
"    error_paren      = unspecified,\x0a"
"    error_brace      = unspecified,\x0a"
"    error_badbrace   = unspecified,\x0a"
"    error_range      = unspecified,\x0a"
"    error_space      = unspecified,\x0a"
"    error_badrepeat  = unspecified,\x0a"
"    error_complexity = unspecified,\x0a"
"    error_stack      = unspecified\x0a"
"};\x0a"
"\x0a"
"}  // regex_constants\x0a"
"\x0a"
"class regex_error\x0a"
"    \x3a public runtime_error\x0a"
"{\x0a"
"public\x3a\x0a"
"    explicit regex_error(regex_constants\x3a\x3a""error_type ecode);\x0a"
"    regex_constants\x3a\x3a""error_type code() const;\x0a"
"};\x0a"
"\x0a"
"template <class charT>\x0a"
"struct regex_traits\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef charT                   char_type;\x0a"
"    typedef basic_string<char_type> string_type;\x0a"
"    typedef locale                  locale_type;\x0a"
"    typedef /bitmask_type/          char_class_type;\x0a"
"\x0a"
"    regex_traits();\x0a"
"\x0a"
"    static size_t length(const char_type* p);\x0a"
"    charT translate(charT c) const;\x0a"
"    charT translate_nocase(charT c) const;\x0a"
"    template <class ForwardIterator>\x0a"
"        string_type\x0a"
"        transform(ForwardIterator first, ForwardIterator last) const;\x0a"
"    template <class ForwardIterator>\x0a"
"        string_type\x0a"
"        transform_primary( ForwardIterator first, ForwardIterator last) const;\x0a"
"    template <class ForwardIterator>\x0a"
"        string_type\x0a"
"        lookup_collatename(ForwardIterator first, ForwardIterator last) const;\x0a"
"    template <class ForwardIterator>\x0a"
"        char_class_type\x0a"
"        lookup_classname(ForwardIterator first, ForwardIterator last,\x0a"
"                         bool icase = false) const;\x0a"
"    bool isctype(charT c, char_class_type f) const;\x0a"
"    int value(charT ch, int radix) const;\x0a"
"    locale_type imbue(locale_type l);\x0a"
"    locale_type getloc()const;\x0a"
"};\x0a"
"\x0a"
"template <class charT, class traits = regex_traits<charT>>\x0a"
"class basic_regex\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef charT                               value_type;\x0a"
"    typedef traits                              traits_type;\x0a"
"    typedef typename traits\x3a\x3astring_type        string_type;\x0a"
"    typedef regex_constants\x3a\x3asyntax_option_type flag_type;\x0a"
"    typedef typename traits\x3a\x3alocale_type        locale_type;\x0a"
"\x0a"
"    // constants\x3a\x0a"
"    static constexpr regex_constants\x3a\x3asyntax_option_type icase = regex_constants\x3a\x3aicase;\x0a"
"    static constexpr regex_constants\x3a\x3asyntax_option_type nosubs = regex_constants\x3a\x3anosubs;\x0a"
"    static constexpr regex_constants\x3a\x3asyntax_option_type optimize = regex_constants\x3a\x3aoptimize;\x0a"
"    static constexpr regex_constants\x3a\x3asyntax_option_type collate = regex_constants\x3a\x3a""collate;\x0a"
"    static constexpr regex_constants\x3a\x3asyntax_option_type ECMAScript = regex_constants\x3a\x3a""ECMAScript;\x0a"
"    static constexpr regex_constants\x3a\x3asyntax_option_type basic = regex_constants\x3a\x3a""basic;\x0a"
"    static constexpr regex_constants\x3a\x3asyntax_option_type extended = regex_constants\x3a\x3a""extended;\x0a"
"    static constexpr regex_constants\x3a\x3asyntax_option_type awk = regex_constants\x3a\x3a""awk;\x0a"
"    static constexpr regex_constants\x3a\x3asyntax_option_type grep = regex_constants\x3a\x3agrep;\x0a"
"    static constexpr regex_constants\x3a\x3asyntax_option_type egrep = regex_constants\x3a\x3a""egrep;\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    basic_regex();\x0a"
"    explicit basic_regex(const charT* p, flag_type f = regex_constants\x3a\x3a""ECMAScript);\x0a"
"    basic_regex(const charT* p, size_t len, flag_type f = regex_constants\x3a\x3a""ECMAScript);\x0a"
"    basic_regex(const basic_regex\x26);\x0a"
"    basic_regex(basic_regex\x26\x26) noexcept;\x0a"
"    template <class ST, class SA>\x0a"
"        explicit basic_regex(const basic_string<charT, ST, SA>\x26 p,\x0a"
"                             flag_type f = regex_constants\x3a\x3a""ECMAScript);\x0a"
"    template <class ForwardIterator>\x0a"
"        basic_regex(ForwardIterator first, ForwardIterator last,\x0a"
"                    flag_type f = regex_constants\x3a\x3a""ECMAScript);\x0a"
"    basic_regex(initializer_list<charT>, flag_type = regex_constants\x3a\x3a""ECMAScript);\x0a"
"\x0a"
"    \x7e""basic_regex();\x0a"
"\x0a"
"    basic_regex\x26 operator=(const basic_regex\x26);\x0a"
"    basic_regex\x26 operator=(basic_regex\x26\x26) noexcept;\x0a"
"    basic_regex\x26 operator=(const charT* ptr);\x0a"
"    basic_regex\x26 operator=(initializer_list<charT> il);\x0a"
"    template <class ST, class SA>\x0a"
"        basic_regex\x26 operator=(const basic_string<charT, ST, SA>\x26 p);\x0a"
"\x0a"
"    // assign\x3a\x0a"
"    basic_regex\x26 assign(const basic_regex\x26 that);\x0a"
"    basic_regex\x26 assign(basic_regex\x26\x26 that) noexcept;\x0a"
"    basic_regex\x26 assign(const charT* ptr, flag_type f = regex_constants\x3a\x3a""ECMAScript);\x0a"
"    basic_regex\x26 assign(const charT* p, size_t len, flag_type f);\x0a"
"    template <class string_traits, class A>\x0a"
"        basic_regex\x26 assign(const basic_string<charT, string_traits, A>\x26 s,\x0a"
"                            flag_type f = regex_constants\x3a\x3a""ECMAScript);\x0a"
"    template <class InputIterator>\x0a"
"        basic_regex\x26 assign(InputIterator first, InputIterator last,\x0a"
"                            flag_type f = regex_constants\x3a\x3a""ECMAScript);\x0a"
"    basic_regex\x26 assign(initializer_list<charT>, flag_type = regex_constants\x3a\x3a""ECMAScript);\x0a"
"\x0a"
"    // const operations\x3a\x0a"
"    unsigned mark_count() const;\x0a"
"    flag_type flags() const;\x0a"
"\x0a"
"    // locale\x3a\x0a"
"    locale_type imbue(locale_type loc);\x0a"
"    locale_type getloc() const;\x0a"
"\x0a"
"    // swap\x3a\x0a"
"    void swap(basic_regex\x26);\x0a"
"};\x0a"
"\x0a"
"template<class ForwardIterator>\x0a"
"basic_regex(ForwardIterator, ForwardIterator,\x0a"
"            regex_constants\x3a\x3asyntax_option_type = regex_constants\x3a\x3a""ECMAScript)\x0a"
"    -> basic_regex<typename iterator_traits<ForwardIterator>\x3a\x3avalue_type>; // C++17\x0a"
"\x0a"
"typedef basic_regex<char>    regex;\x0a"
"typedef basic_regex<wchar_t> wregex;\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"    void swap(basic_regex<charT, traits>\x26 e1, basic_regex<charT, traits>\x26 e2);\x0a"
"\x0a"
"template <class BidirectionalIterator>\x0a"
"class sub_match\x0a"
"    \x3a public pair<BidirectionalIterator, BidirectionalIterator>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef typename iterator_traits<BidirectionalIterator>\x3a\x3avalue_type value_type;\x0a"
"    typedef typename iterator_traits<BidirectionalIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef BidirectionalIterator                                      iterator;\x0a"
"    typedef basic_string<value_type>                                string_type;\x0a"
"\x0a"
"    bool matched;\x0a"
"\x0a"
"    constexpr sub_match();\x0a"
"\x0a"
"    difference_type length() const;\x0a"
"    operator string_type() const;\x0a"
"    string_type str() const;\x0a"
"\x0a"
"    int compare(const sub_match\x26 s) const;\x0a"
"    int compare(const string_type\x26 s) const;\x0a"
"    int compare(const value_type* s) const;\x0a"
"};\x0a"
"\x0a"
"typedef sub_match<const char*>             csub_match;\x0a"
"typedef sub_match<const wchar_t*>          wcsub_match;\x0a"
"typedef sub_match<string\x3a\x3a""const_iterator>  ssub_match;\x0a"
"typedef sub_match<wstring\x3a\x3a""const_iterator> wssub_match;\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator==(const sub_match<BiIter>\x26 lhs, const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator\x21=(const sub_match<BiIter>\x26 lhs, const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator<(const sub_match<BiIter>\x26 lhs, const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator<=(const sub_match<BiIter>\x26 lhs, const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator>=(const sub_match<BiIter>\x26 lhs, const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator>(const sub_match<BiIter>\x26 lhs, const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool\x0a"
"    operator==(const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool\x0a"
"    operator\x21=(const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool\x0a"
"    operator<(const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 lhs,\x0a"
"              const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool\x0a"
"    operator>(const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 lhs,\x0a"
"              const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool operator>=(const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 lhs,\x0a"
"                    const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool\x0a"
"    operator<=(const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool\x0a"
"    operator==(const sub_match<BiIter>\x26 lhs,\x0a"
"               const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool\x0a"
"    operator\x21=(const sub_match<BiIter>\x26 lhs,\x0a"
"               const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool\x0a"
"    operator<(const sub_match<BiIter>\x26 lhs,\x0a"
"              const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool operator>(const sub_match<BiIter>\x26 lhs,\x0a"
"                   const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool\x0a"
"    operator>=(const sub_match<BiIter>\x26 lhs,\x0a"
"               const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter, class ST, class SA>\x0a"
"    bool\x0a"
"    operator<=(const sub_match<BiIter>\x26 lhs,\x0a"
"               const basic_string<typename iterator_traits<BiIter>\x3a\x3avalue_type, ST, SA>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator==(typename iterator_traits<BiIter>\x3a\x3avalue_type const* lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator\x21=(typename iterator_traits<BiIter>\x3a\x3avalue_type const* lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator<(typename iterator_traits<BiIter>\x3a\x3avalue_type const* lhs,\x0a"
"              const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator>(typename iterator_traits<BiIter>\x3a\x3avalue_type const* lhs,\x0a"
"              const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator>=(typename iterator_traits<BiIter>\x3a\x3avalue_type const* lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator<=(typename iterator_traits<BiIter>\x3a\x3avalue_type const* lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator==(const sub_match<BiIter>\x26 lhs,\x0a"
"               typename iterator_traits<BiIter>\x3a\x3avalue_type const* rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator\x21=(const sub_match<BiIter>\x26 lhs,\x0a"
"               typename iterator_traits<BiIter>\x3a\x3avalue_type const* rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator<(const sub_match<BiIter>\x26 lhs,\x0a"
"              typename iterator_traits<BiIter>\x3a\x3avalue_type const* rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator>(const sub_match<BiIter>\x26 lhs,\x0a"
"              typename iterator_traits<BiIter>\x3a\x3avalue_type const* rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator>=(const sub_match<BiIter>\x26 lhs,\x0a"
"               typename iterator_traits<BiIter>\x3a\x3avalue_type const* rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator<=(const sub_match<BiIter>\x26 lhs,\x0a"
"               typename iterator_traits<BiIter>\x3a\x3avalue_type const* rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator==(typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator\x21=(typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator<(typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 lhs,\x0a"
"              const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator>(typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 lhs,\x0a"
"              const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator>=(typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator<=(typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 lhs,\x0a"
"               const sub_match<BiIter>\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator==(const sub_match<BiIter>\x26 lhs,\x0a"
"               typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator\x21=(const sub_match<BiIter>\x26 lhs,\x0a"
"               typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator<(const sub_match<BiIter>\x26 lhs,\x0a"
"              typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator>(const sub_match<BiIter>\x26 lhs,\x0a"
"              typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator>=(const sub_match<BiIter>\x26 lhs,\x0a"
"               typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 rhs);\x0a"
"\x0a"
"template <class BiIter>\x0a"
"    bool\x0a"
"    operator<=(const sub_match<BiIter>\x26 lhs,\x0a"
"               typename iterator_traits<BiIter>\x3a\x3avalue_type const\x26 rhs);\x0a"
"\x0a"
"template <class charT, class ST, class BiIter>\x0a"
"    basic_ostream<charT, ST>\x26\x0a"
"    operator<<(basic_ostream<charT, ST>\x26 os, const sub_match<BiIter>\x26 m);\x0a"
"\x0a"
"template <class BidirectionalIterator,\x0a"
"          class Allocator = allocator<sub_match<BidirectionalIterator>>>\x0a"
"class match_results\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef sub_match<BidirectionalIterator>                  value_type;\x0a"
"    typedef const value_type\x26                                 const_reference;\x0a"
"    typedef value_type\x26                                       reference;\x0a"
"    typedef /implementation-defined/                          const_iterator;\x0a"
"    typedef const_iterator                                    iterator;\x0a"
"    typedef typename iterator_traits<BidirectionalIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename allocator_traits<Allocator>\x3a\x3asize_type   size_type;\x0a"
"    typedef Allocator                                         allocator_type;\x0a"
"    typedef typename iterator_traits<BidirectionalIterator>\x3a\x3avalue_type char_type;\x0a"
"    typedef basic_string<char_type>                           string_type;\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    explicit match_results(const Allocator\x26 a = Allocator());\x0a"
"    match_results(const match_results\x26 m);\x0a"
"    match_results(match_results\x26\x26 m) noexcept;\x0a"
"    match_results\x26 operator=(const match_results\x26 m);\x0a"
"    match_results\x26 operator=(match_results\x26\x26 m);\x0a"
"    \x7ematch_results();\x0a"
"\x0a"
"    bool ready() const;\x0a"
"\x0a"
"    // size\x3a\x0a"
"    size_type size() const;\x0a"
"    size_type max_size() const;\x0a"
"    bool empty() const;\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    difference_type length(size_type sub = 0) const;\x0a"
"    difference_type position(size_type sub = 0) const;\x0a"
"    string_type str(size_type sub = 0) const;\x0a"
"    const_reference operator\x5b\x5d(size_type n) const;\x0a"
"\x0a"
"    const_reference prefix() const;\x0a"
"    const_reference suffix() const;\x0a"
"\x0a"
"    const_iterator begin() const;\x0a"
"    const_iterator end() const;\x0a"
"    const_iterator cbegin() const;\x0a"
"    const_iterator cend() const;\x0a"
"\x0a"
"    // format\x3a\x0a"
"    template <class OutputIter>\x0a"
"        OutputIter\x0a"
"        format(OutputIter out, const char_type* fmt_first,\x0a"
"               const char_type* fmt_last,\x0a"
"               regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3a""format_default) const;\x0a"
"    template <class OutputIter, class ST, class SA>\x0a"
"        OutputIter\x0a"
"        format(OutputIter out, const basic_string<char_type, ST, SA>\x26 fmt,\x0a"
"               regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3a""format_default) const;\x0a"
"    template <class ST, class SA>\x0a"
"        basic_string<char_type, ST, SA>\x0a"
"        format(const basic_string<char_type, ST, SA>\x26 fmt,\x0a"
"               regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3a""format_default) const;\x0a"
"    string_type\x0a"
"        format(const char_type* fmt,\x0a"
"               regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3a""format_default) const;\x0a"
"\x0a"
"    // allocator\x3a\x0a"
"    allocator_type get_allocator() const;\x0a"
"\x0a"
"    // swap\x3a\x0a"
"    void swap(match_results\x26 that);\x0a"
"};\x0a"
"\x0a"
"typedef match_results<const char*>             cmatch;\x0a"
"typedef match_results<const wchar_t*>          wcmatch;\x0a"
"typedef match_results<string\x3a\x3a""const_iterator>  smatch;\x0a"
"typedef match_results<wstring\x3a\x3a""const_iterator> wsmatch;\x0a"
"\x0a"
"template <class BidirectionalIterator, class Allocator>\x0a"
"    bool\x0a"
"    operator==(const match_results<BidirectionalIterator, Allocator>\x26 m1,\x0a"
"               const match_results<BidirectionalIterator, Allocator>\x26 m2);\x0a"
"\x0a"
"template <class BidirectionalIterator, class Allocator>\x0a"
"    bool\x0a"
"    operator\x21=(const match_results<BidirectionalIterator, Allocator>\x26 m1,\x0a"
"               const match_results<BidirectionalIterator, Allocator>\x26 m2);\x0a"
"\x0a"
"template <class BidirectionalIterator, class Allocator>\x0a"
"    void\x0a"
"    swap(match_results<BidirectionalIterator, Allocator>\x26 m1,\x0a"
"         match_results<BidirectionalIterator, Allocator>\x26 m2);\x0a"
"\x0a"
"template <class BidirectionalIterator, class Allocator, class charT, class traits>\x0a"
"    bool\x0a"
"    regex_match(BidirectionalIterator first, BidirectionalIterator last,\x0a"
"                match_results<BidirectionalIterator, Allocator>\x26 m,\x0a"
"                const basic_regex<charT, traits>\x26 e,\x0a"
"                regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class BidirectionalIterator, class charT, class traits>\x0a"
"    bool\x0a"
"    regex_match(BidirectionalIterator first, BidirectionalIterator last,\x0a"
"                const basic_regex<charT, traits>\x26 e,\x0a"
"                regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class charT, class Allocator, class traits>\x0a"
"    bool\x0a"
"    regex_match(const charT* str, match_results<const charT*, Allocator>\x26 m,\x0a"
"                const basic_regex<charT, traits>\x26 e,\x0a"
"                regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class ST, class SA, class Allocator, class charT, class traits>\x0a"
"    bool\x0a"
"    regex_match(const basic_string<charT, ST, SA>\x26 s,\x0a"
"                match_results<typename basic_string<charT, ST, SA>\x3a\x3a""const_iterator, Allocator>\x26 m,\x0a"
"                const basic_regex<charT, traits>\x26 e,\x0a"
"                regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class ST, class SA, class Allocator, class charT, class traits>\x0a"
"    bool\x0a"
"    regex_match(const basic_string<charT, ST, SA>\x26\x26 s,\x0a"
"                match_results<typename basic_string<charT, ST, SA>\x3a\x3a""const_iterator, Allocator>\x26 m,\x0a"
"                const basic_regex<charT, traits>\x26 e,\x0a"
"                regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default) = delete; // C++14\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"    bool\x0a"
"    regex_match(const charT* str, const basic_regex<charT, traits>\x26 e,\x0a"
"                regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class ST, class SA, class charT, class traits>\x0a"
"    bool\x0a"
"    regex_match(const basic_string<charT, ST, SA>\x26 s,\x0a"
"                const basic_regex<charT, traits>\x26 e,\x0a"
"                regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class BidirectionalIterator, class Allocator, class charT, class traits>\x0a"
"    bool\x0a"
"    regex_search(BidirectionalIterator first, BidirectionalIterator last,\x0a"
"                 match_results<BidirectionalIterator, Allocator>\x26 m,\x0a"
"                 const basic_regex<charT, traits>\x26 e,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class BidirectionalIterator, class charT, class traits>\x0a"
"    bool\x0a"
"    regex_search(BidirectionalIterator first, BidirectionalIterator last,\x0a"
"                 const basic_regex<charT, traits>\x26 e,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class charT, class Allocator, class traits>\x0a"
"    bool\x0a"
"    regex_search(const charT* str, match_results<const charT*, Allocator>\x26 m,\x0a"
"                 const basic_regex<charT, traits>\x26 e,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class charT, class traits>\x0a"
"    bool\x0a"
"    regex_search(const charT* str, const basic_regex<charT, traits>\x26 e,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class ST, class SA, class charT, class traits>\x0a"
"    bool\x0a"
"    regex_search(const basic_string<charT, ST, SA>\x26 s,\x0a"
"                 const basic_regex<charT, traits>\x26 e,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class ST, class SA, class Allocator, class charT, class traits>\x0a"
"    bool\x0a"
"    regex_search(const basic_string<charT, ST, SA>\x26 s,\x0a"
"                 match_results<typename basic_string<charT, ST, SA>\x3a\x3a""const_iterator, Allocator>\x26 m,\x0a"
"                 const basic_regex<charT, traits>\x26 e,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class ST, class SA, class Allocator, class charT, class traits>\x0a"
"    bool\x0a"
"    regex_search(const basic_string<charT, ST, SA>\x26\x26 s,\x0a"
"                 match_results<typename basic_string<charT, ST, SA>\x3a\x3a""const_iterator, Allocator>\x26 m,\x0a"
"                 const basic_regex<charT, traits>\x26 e,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default) = delete; // C++14\x0a"
"\x0a"
"template <class OutputIterator, class BidirectionalIterator,\x0a"
"          class traits, class charT, class ST, class SA>\x0a"
"    OutputIterator\x0a"
"    regex_replace(OutputIterator out,\x0a"
"                  BidirectionalIterator first, BidirectionalIterator last,\x0a"
"                  const basic_regex<charT, traits>\x26 e,\x0a"
"                  const basic_string<charT, ST, SA>\x26 fmt,\x0a"
"                  regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class OutputIterator, class BidirectionalIterator,\x0a"
"          class traits, class charT>\x0a"
"    OutputIterator\x0a"
"    regex_replace(OutputIterator out,\x0a"
"                  BidirectionalIterator first, BidirectionalIterator last,\x0a"
"                  const basic_regex<charT, traits>\x26 e, const charT* fmt,\x0a"
"                  regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class traits, class charT, class ST, class SA, class FST, class FSA>>\x0a"
"    basic_string<charT, ST, SA>\x0a"
"    regex_replace(const basic_string<charT, ST, SA>\x26 s,\x0a"
"                  const basic_regex<charT, traits>\x26 e,\x0a"
"                  const basic_string<charT, FST, FSA>\x26 fmt,\x0a"
"                  regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class traits, class charT, class ST, class SA>\x0a"
"    basic_string<charT, ST, SA>\x0a"
"    regex_replace(const basic_string<charT, ST, SA>\x26 s,\x0a"
"                  const basic_regex<charT, traits>\x26 e, const charT* fmt,\x0a"
"                  regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class traits, class charT, class ST, class SA>\x0a"
"    basic_string<charT>\x0a"
"    regex_replace(const charT* s,\x0a"
"                  const basic_regex<charT, traits>\x26 e,\x0a"
"                  const basic_string<charT, ST, SA>\x26 fmt,\x0a"
"                  regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class traits, class charT>\x0a"
"    basic_string<charT>\x0a"
"    regex_replace(const charT* s,\x0a"
"                  const basic_regex<charT, traits>\x26 e,\x0a"
"                  const charT* fmt,\x0a"
"                  regex_constants\x3a\x3amatch_flag_type flags = regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"template <class BidirectionalIterator,\x0a"
"          class charT = typename iterator_traits< BidirectionalIterator>\x3a\x3avalue_type,\x0a"
"          class traits = regex_traits<charT>>\x0a"
"class regex_iterator\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef basic_regex<charT, traits>           regex_type;\x0a"
"    typedef match_results<BidirectionalIterator> value_type;\x0a"
"    typedef ptrdiff_t                            difference_type;\x0a"
"    typedef const value_type*                    pointer;\x0a"
"    typedef const value_type\x26                    reference;\x0a"
"    typedef forward_iterator_tag                 iterator_category;\x0a"
"\x0a"
"    regex_iterator();\x0a"
"    regex_iterator(BidirectionalIterator a, BidirectionalIterator b,\x0a"
"                   const regex_type\x26 re,\x0a"
"                   regex_constants\x3a\x3amatch_flag_type m = regex_constants\x3a\x3amatch_default);\x0a"
"    regex_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                   const regex_type\x26\x26 __re,\x0a"
"                   regex_constants\x3a\x3amatch_flag_type __m\x0a"
"                                     = regex_constants\x3a\x3amatch_default) = delete; // C++14\x0a"
"    regex_iterator(const regex_iterator\x26);\x0a"
"    regex_iterator\x26 operator=(const regex_iterator\x26);\x0a"
"\x0a"
"    bool operator==(const regex_iterator\x26) const;\x0a"
"    bool operator\x21=(const regex_iterator\x26) const;\x0a"
"\x0a"
"    const value_type\x26 operator*() const;\x0a"
"    const value_type* operator->() const;\x0a"
"\x0a"
"    regex_iterator\x26 operator++();\x0a"
"    regex_iterator operator++(int);\x0a"
"};\x0a"
"\x0a"
"typedef regex_iterator<const char*>             cregex_iterator;\x0a"
"typedef regex_iterator<const wchar_t*>          wcregex_iterator;\x0a"
"typedef regex_iterator<string\x3a\x3a""const_iterator>  sregex_iterator;\x0a"
"typedef regex_iterator<wstring\x3a\x3a""const_iterator> wsregex_iterator;\x0a"
"\x0a"
"template <class BidirectionalIterator,\x0a"
"          class charT = typename iterator_traits< BidirectionalIterator>\x3a\x3avalue_type,\x0a"
"          class traits = regex_traits<charT>>\x0a"
"class regex_token_iterator\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef basic_regex<charT, traits>       regex_type;\x0a"
"    typedef sub_match<BidirectionalIterator> value_type;\x0a"
"    typedef ptrdiff_t                        difference_type;\x0a"
"    typedef const value_type*                pointer;\x0a"
"    typedef const value_type\x26                reference;\x0a"
"    typedef forward_iterator_tag             iterator_category;\x0a"
"\x0a"
"    regex_token_iterator();\x0a"
"    regex_token_iterator(BidirectionalIterator a, BidirectionalIterator b,\x0a"
"                         const regex_type\x26 re, int submatch = 0,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type m = regex_constants\x3a\x3amatch_default);\x0a"
"    regex_token_iterator(BidirectionalIterator a, BidirectionalIterator b,\x0a"
"                         const regex_type\x26\x26 re, int submatch = 0,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type m = regex_constants\x3a\x3amatch_default) = delete; // C++14\x0a"
"    regex_token_iterator(BidirectionalIterator a, BidirectionalIterator b,\x0a"
"                         const regex_type\x26 re, const vector<int>\x26 submatches,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type m = regex_constants\x3a\x3amatch_default);\x0a"
"    regex_token_iterator(BidirectionalIterator a, BidirectionalIterator b,\x0a"
"                         const regex_type\x26\x26 re, const vector<int>\x26 submatches,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type m = regex_constants\x3a\x3amatch_default) = delete; // C++14\x0a"
"    regex_token_iterator(BidirectionalIterator a, BidirectionalIterator b,\x0a"
"                         const regex_type\x26 re, initializer_list<int> submatches,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type m = regex_constants\x3a\x3amatch_default);\x0a"
"    regex_token_iterator(BidirectionalIterator a, BidirectionalIterator b,\x0a"
"                         const regex_type\x26\x26 re, initializer_list<int> submatches,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type m = regex_constants\x3a\x3amatch_default) = delete; // C++14\x0a"
"    template <size_t N>\x0a"
"        regex_token_iterator(BidirectionalIterator a, BidirectionalIterator b,\x0a"
"                             const regex_type\x26 re, const int (\x26submatches)\x5bN\x5d,\x0a"
"                             regex_constants\x3a\x3amatch_flag_type m = regex_constants\x3a\x3amatch_default);\x0a"
"    template <size_t N>\x0a"
"        regex_token_iterator(BidirectionalIterator a, BidirectionalIterator b,\x0a"
"                             const regex_type\x26 re, const int (\x26submatches)\x5bN\x5d,\x0a"
"                             regex_constants\x3a\x3amatch_flag_type m = regex_constants\x3a\x3amatch_default) = delete // C++14;\x0a"
"    regex_token_iterator(const regex_token_iterator\x26);\x0a"
"    regex_token_iterator\x26 operator=(const regex_token_iterator\x26);\x0a"
"\x0a"
"    bool operator==(const regex_token_iterator\x26) const;\x0a"
"    bool operator\x21=(const regex_token_iterator\x26) const;\x0a"
"\x0a"
"    const value_type\x26 operator*() const;\x0a"
"    const value_type* operator->() const;\x0a"
"\x0a"
"    regex_token_iterator\x26 operator++();\x0a"
"    regex_token_iterator operator++(int);\x0a"
"};\x0a"
"\x0a"
"typedef regex_token_iterator<const char*>             cregex_token_iterator;\x0a"
"typedef regex_token_iterator<const wchar_t*>          wcregex_token_iterator;\x0a"
"typedef regex_token_iterator<string\x3a\x3a""const_iterator>  sregex_token_iterator;\x0a"
"typedef regex_token_iterator<wstring\x3a\x3a""const_iterator> wsregex_token_iterator;\x0a"
"\x0a"
"} // std\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <stdexcept>\x0a"
"#include <__locale>\x0a"
"#include <initializer_list>\x0a"
"#include <utility>\x0a"
"#include <iterator>\x0a"
"#include <string>\x0a"
"#include <memory>\x0a"
"#include <vector>\x0a"
"#include <deque>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"#define _LIBCPP_REGEX_COMPLEXITY_FACTOR 4096\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"namespace regex_constants\x0a"
"{\x0a"
"\x0a"
"// syntax_option_type\x0a"
"\x0a"
"enum syntax_option_type\x0a"
"{\x0a"
"    icase      = 1 << 0,\x0a"
"    nosubs     = 1 << 1,\x0a"
"    optimize   = 1 << 2,\x0a"
"    collate    = 1 << 3,\x0a"
"#ifdef _LIBCPP_ABI_REGEX_CONSTANTS_NONZERO\x0a"
"    ECMAScript = 1 << 9,\x0a"
"#else\x0a"
"    ECMAScript = 0,\x0a"
"#endif\x0a"
"    basic      = 1 << 4,\x0a"
"    extended   = 1 << 5,\x0a"
"    awk        = 1 << 6,\x0a"
"    grep       = 1 << 7,\x0a"
"    egrep      = 1 << 8\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR\x0a"
"syntax_option_type __get_grammar(syntax_option_type __g)\x0a"
"{\x0a"
"#ifdef _LIBCPP_ABI_REGEX_CONSTANTS_NONZERO\x0a"
"    return static_cast<syntax_option_type>(__g \x26 0x3F0);\x0a"
"#else\x0a"
"    return static_cast<syntax_option_type>(__g \x26 0x1F0);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"syntax_option_type\x0a"
"operator\x7e(syntax_option_type __x)\x0a"
"{\x0a"
"    return syntax_option_type(\x7eint(__x) \x26 0x1FF);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"syntax_option_type\x0a"
"operator\x26(syntax_option_type __x, syntax_option_type __y)\x0a"
"{\x0a"
"    return syntax_option_type(int(__x) \x26 int(__y));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"syntax_option_type\x0a"
"operator\x7c(syntax_option_type __x, syntax_option_type __y)\x0a"
"{\x0a"
"    return syntax_option_type(int(__x) \x7c int(__y));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"syntax_option_type\x0a"
"operator^(syntax_option_type __x, syntax_option_type __y)\x0a"
"{\x0a"
"    return syntax_option_type(int(__x) ^ int(__y));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"syntax_option_type\x26\x0a"
"operator\x26=(syntax_option_type\x26 __x, syntax_option_type __y)\x0a"
"{\x0a"
"    __x = __x \x26 __y;\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"syntax_option_type\x26\x0a"
"operator\x7c=(syntax_option_type\x26 __x, syntax_option_type __y)\x0a"
"{\x0a"
"    __x = __x \x7c __y;\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"syntax_option_type\x26\x0a"
"operator^=(syntax_option_type\x26 __x, syntax_option_type __y)\x0a"
"{\x0a"
"    __x = __x ^ __y;\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"// match_flag_type\x0a"
"\x0a"
"enum match_flag_type\x0a"
"{\x0a"
"    match_default     = 0,\x0a"
"    match_not_bol     = 1 << 0,\x0a"
"    match_not_eol     = 1 << 1,\x0a"
"    match_not_bow     = 1 << 2,\x0a"
"    match_not_eow     = 1 << 3,\x0a"
"    match_any         = 1 << 4,\x0a"
"    match_not_null    = 1 << 5,\x0a"
"    match_continuous  = 1 << 6,\x0a"
"    match_prev_avail  = 1 << 7,\x0a"
"    format_default    = 0,\x0a"
"    format_sed        = 1 << 8,\x0a"
"    format_no_copy    = 1 << 9,\x0a"
"    format_first_only = 1 << 10,\x0a"
"    __no_update_pos   = 1 << 11,\x0a"
"    __full_match      = 1 << 12\x0a"
"};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"match_flag_type\x0a"
"operator\x7e(match_flag_type __x)\x0a"
"{\x0a"
"    return match_flag_type(\x7eint(__x) \x26 0x0FFF);\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"match_flag_type\x0a"
"operator\x26(match_flag_type __x, match_flag_type __y)\x0a"
"{\x0a"
"    return match_flag_type(int(__x) \x26 int(__y));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"match_flag_type\x0a"
"operator\x7c(match_flag_type __x, match_flag_type __y)\x0a"
"{\x0a"
"    return match_flag_type(int(__x) \x7c int(__y));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"match_flag_type\x0a"
"operator^(match_flag_type __x, match_flag_type __y)\x0a"
"{\x0a"
"    return match_flag_type(int(__x) ^ int(__y));\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"match_flag_type\x26\x0a"
"operator\x26=(match_flag_type\x26 __x, match_flag_type __y)\x0a"
"{\x0a"
"    __x = __x \x26 __y;\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"match_flag_type\x26\x0a"
"operator\x7c=(match_flag_type\x26 __x, match_flag_type __y)\x0a"
"{\x0a"
"    __x = __x \x7c __y;\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"match_flag_type\x26\x0a"
"operator^=(match_flag_type\x26 __x, match_flag_type __y)\x0a"
"{\x0a"
"    __x = __x ^ __y;\x0a"
"    return __x;\x0a"
"}\x0a"
"\x0a"
"enum error_type\x0a"
"{\x0a"
"    error_collate = 1,\x0a"
"    error_ctype,\x0a"
"    error_escape,\x0a"
"    error_backref,\x0a"
"    error_brack,\x0a"
"    error_paren,\x0a"
"    error_brace,\x0a"
"    error_badbrace,\x0a"
"    error_range,\x0a"
"    error_space,\x0a"
"    error_badrepeat,\x0a"
"    error_complexity,\x0a"
"    error_stack,\x0a"
"    __re_err_grammar,\x0a"
"    __re_err_empty,\x0a"
"    __re_err_unknown\x0a"
"};\x0a"
"\x0a"
"}  // regex_constants\x0a"
"\x0a"
"class _LIBCPP_EXCEPTION_ABI regex_error\x0a"
"    \x3a public runtime_error\x0a"
"{\x0a"
"    regex_constants\x3a\x3a""error_type __code_;\x0a"
"public\x3a\x0a"
"    explicit regex_error(regex_constants\x3a\x3a""error_type __ecode);\x0a"
"    virtual \x7eregex_error() throw();\x0a"
"     _LIBCPP_INLINE_VISIBILITY\x0a"
"    regex_constants\x3a\x3a""error_type code() const {return __code_;}\x0a"
"};\x0a"
"\x0a"
"template <regex_constants\x3a\x3a""error_type _Ev>\x0a"
"_LIBCPP_NORETURN inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void __throw_regex_error()\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw regex_error(_Ev);\x0a"
"#else\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"struct _LIBCPP_TEMPLATE_VIS regex_traits\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _CharT                  char_type;\x0a"
"    typedef basic_string<char_type> string_type;\x0a"
"    typedef locale                  locale_type;\x0a"
"    typedef ctype_base\x3a\x3amask        char_class_type;\x0a"
"\x0a"
"    static const char_class_type __regex_word = ctype_base\x3a\x3a__regex_word;\x0a"
"private\x3a\x0a"
"    locale __loc_;\x0a"
"    const ctype<char_type>* __ct_;\x0a"
"    const collate<char_type>* __col_;\x0a"
"\x0a"
"public\x3a\x0a"
"    regex_traits();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static size_t length(const char_type* __p)\x0a"
"        {return char_traits<char_type>\x3a\x3alength(__p);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    char_type translate(char_type __c) const {return __c;}\x0a"
"    char_type translate_nocase(char_type __c) const;\x0a"
"    template <class _ForwardIterator>\x0a"
"        string_type\x0a"
"        transform(_ForwardIterator __f, _ForwardIterator __l) const;\x0a"
"    template <class _ForwardIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        string_type\x0a"
"        transform_primary( _ForwardIterator __f, _ForwardIterator __l) const\x0a"
"            {return __transform_primary(__f, __l, char_type());}\x0a"
"    template <class _ForwardIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        string_type\x0a"
"        lookup_collatename(_ForwardIterator __f, _ForwardIterator __l) const\x0a"
"            {return __lookup_collatename(__f, __l, char_type());}\x0a"
"    template <class _ForwardIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        char_class_type\x0a"
"        lookup_classname(_ForwardIterator __f, _ForwardIterator __l,\x0a"
"                         bool __icase = false) const\x0a"
"            {return __lookup_classname(__f, __l, __icase, char_type());}\x0a"
"    bool isctype(char_type __c, char_class_type __m) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int value(char_type __ch, int __radix) const\x0a"
"        {return __regex_traits_value(__ch, __radix);}\x0a"
"    locale_type imbue(locale_type __l);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    locale_type getloc()const {return __loc_;}\x0a"
"\x0a"
"private\x3a\x0a"
"    void __init();\x0a"
"\x0a"
"    template <class _ForwardIterator>\x0a"
"        string_type\x0a"
"        __transform_primary(_ForwardIterator __f, _ForwardIterator __l, char) const;\x0a"
"    template <class _ForwardIterator>\x0a"
"        string_type\x0a"
"        __transform_primary(_ForwardIterator __f, _ForwardIterator __l, wchar_t) const;\x0a"
"\x0a"
"    template <class _ForwardIterator>\x0a"
"        string_type\x0a"
"        __lookup_collatename(_ForwardIterator __f, _ForwardIterator __l, char) const;\x0a"
"    template <class _ForwardIterator>\x0a"
"        string_type\x0a"
"        __lookup_collatename(_ForwardIterator __f, _ForwardIterator __l, wchar_t) const;\x0a"
"\x0a"
"    template <class _ForwardIterator>\x0a"
"        char_class_type\x0a"
"        __lookup_classname(_ForwardIterator __f, _ForwardIterator __l,\x0a"
"                           bool __icase, char) const;\x0a"
"    template <class _ForwardIterator>\x0a"
"        char_class_type\x0a"
"        __lookup_classname(_ForwardIterator __f, _ForwardIterator __l,\x0a"
"                           bool __icase, wchar_t) const;\x0a"
"\x0a"
"    static int __regex_traits_value(unsigned char __ch, int __radix);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int __regex_traits_value(char __ch, int __radix) const\x0a"
"        {return __regex_traits_value(static_cast<unsigned char>(__ch), __radix);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int __regex_traits_value(wchar_t __ch, int __radix) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"const typename regex_traits<_CharT>\x3a\x3a""char_class_type\x0a"
"regex_traits<_CharT>\x3a\x3a__regex_word;\x0a"
"\x0a"
"template <class _CharT>\x0a"
"regex_traits<_CharT>\x3a\x3aregex_traits()\x0a"
"{\x0a"
"    __init();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"typename regex_traits<_CharT>\x3a\x3a""char_type\x0a"
"regex_traits<_CharT>\x3a\x3atranslate_nocase(char_type __c) const\x0a"
"{\x0a"
"    return __ct_->tolower(__c);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"template <class _ForwardIterator>\x0a"
"typename regex_traits<_CharT>\x3a\x3astring_type\x0a"
"regex_traits<_CharT>\x3a\x3atransform(_ForwardIterator __f, _ForwardIterator __l) const\x0a"
"{\x0a"
"    string_type __s(__f, __l);\x0a"
"    return __col_->transform(__s.data(), __s.data() + __s.size());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"regex_traits<_CharT>\x3a\x3a__init()\x0a"
"{\x0a"
"    __ct_ = \x26use_facet<ctype<char_type> >(__loc_);\x0a"
"    __col_ = \x26use_facet<collate<char_type> >(__loc_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"typename regex_traits<_CharT>\x3a\x3alocale_type\x0a"
"regex_traits<_CharT>\x3a\x3aimbue(locale_type __l)\x0a"
"{\x0a"
"    locale __r = __loc_;\x0a"
"    __loc_ = __l;\x0a"
"    __init();\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// transform_primary is very FreeBSD-specific\x0a"
"\x0a"
"template <class _CharT>\x0a"
"template <class _ForwardIterator>\x0a"
"typename regex_traits<_CharT>\x3a\x3astring_type\x0a"
"regex_traits<_CharT>\x3a\x3a__transform_primary(_ForwardIterator __f,\x0a"
"                                          _ForwardIterator __l, char) const\x0a"
"{\x0a"
"    const string_type __s(__f, __l);\x0a"
"    string_type __d = __col_->transform(__s.data(), __s.data() + __s.size());\x0a"
"    switch (__d.size())\x0a"
"    {\x0a"
"    case 1\x3a\x0a"
"        break;\x0a"
"    case 12\x3a\x0a"
"        __d\x5b""11\x5d = __d\x5b""3\x5d;\x0a"
"        break;\x0a"
"    default\x3a\x0a"
"        __d.clear();\x0a"
"        break;\x0a"
"    }\x0a"
"    return __d;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"template <class _ForwardIterator>\x0a"
"typename regex_traits<_CharT>\x3a\x3astring_type\x0a"
"regex_traits<_CharT>\x3a\x3a__transform_primary(_ForwardIterator __f,\x0a"
"                                          _ForwardIterator __l, wchar_t) const\x0a"
"{\x0a"
"    const string_type __s(__f, __l);\x0a"
"    string_type __d = __col_->transform(__s.data(), __s.data() + __s.size());\x0a"
"    switch (__d.size())\x0a"
"    {\x0a"
"    case 1\x3a\x0a"
"        break;\x0a"
"    case 3\x3a\x0a"
"        __d\x5b""2\x5d = __d\x5b""0\x5d;\x0a"
"        break;\x0a"
"    default\x3a\x0a"
"        __d.clear();\x0a"
"        break;\x0a"
"    }\x0a"
"    return __d;\x0a"
"}\x0a"
"\x0a"
"// lookup_collatename is very FreeBSD-specific\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS string __get_collation_name(const char* __s);\x0a"
"\x0a"
"template <class _CharT>\x0a"
"template <class _ForwardIterator>\x0a"
"typename regex_traits<_CharT>\x3a\x3astring_type\x0a"
"regex_traits<_CharT>\x3a\x3a__lookup_collatename(_ForwardIterator __f,\x0a"
"                                           _ForwardIterator __l, char) const\x0a"
"{\x0a"
"    string_type __s(__f, __l);\x0a"
"    string_type __r;\x0a"
"    if (\x21__s.empty())\x0a"
"    {\x0a"
"        __r = __get_collation_name(__s.c_str());\x0a"
"        if (__r.empty() \x26\x26 __s.size() <= 2)\x0a"
"        {\x0a"
"            __r = __col_->transform(__s.data(), __s.data() + __s.size());\x0a"
"            if (__r.size() == 1 \x7c\x7c __r.size() == 12)\x0a"
"                __r = __s;\x0a"
"            else\x0a"
"                __r.clear();\x0a"
"        }\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"template <class _ForwardIterator>\x0a"
"typename regex_traits<_CharT>\x3a\x3astring_type\x0a"
"regex_traits<_CharT>\x3a\x3a__lookup_collatename(_ForwardIterator __f,\x0a"
"                                           _ForwardIterator __l, wchar_t) const\x0a"
"{\x0a"
"    string_type __s(__f, __l);\x0a"
"    string __n;\x0a"
"    __n.reserve(__s.size());\x0a"
"    for (typename string_type\x3a\x3a""const_iterator __i = __s.begin(), __e = __s.end();\x0a"
"                                                              __i \x21= __e; ++__i)\x0a"
"    {\x0a"
"        if (static_cast<unsigned>(*__i) >= 127)\x0a"
"            return string_type();\x0a"
"        __n.push_back(char(*__i));\x0a"
"    }\x0a"
"    string_type __r;\x0a"
"    if (\x21__s.empty())\x0a"
"    {\x0a"
"        __n = __get_collation_name(__n.c_str());\x0a"
"        if (\x21__n.empty())\x0a"
"            __r.assign(__n.begin(), __n.end());\x0a"
"        else if (__s.size() <= 2)\x0a"
"        {\x0a"
"            __r = __col_->transform(__s.data(), __s.data() + __s.size());\x0a"
"            if (__r.size() == 1 \x7c\x7c __r.size() == 3)\x0a"
"                __r = __s;\x0a"
"            else\x0a"
"                __r.clear();\x0a"
"        }\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// lookup_classname\x0a"
"\x0a"
"regex_traits<char>\x3a\x3a""char_class_type _LIBCPP_FUNC_VIS\x0a"
"__get_classname(const char* __s, bool __icase);\x0a"
"\x0a"
"template <class _CharT>\x0a"
"template <class _ForwardIterator>\x0a"
"typename regex_traits<_CharT>\x3a\x3a""char_class_type\x0a"
"regex_traits<_CharT>\x3a\x3a__lookup_classname(_ForwardIterator __f,\x0a"
"                                         _ForwardIterator __l,\x0a"
"                                         bool __icase, char) const\x0a"
"{\x0a"
"    string_type __s(__f, __l);\x0a"
"    __ct_->tolower(\x26__s\x5b""0\x5d, \x26__s\x5b""0\x5d + __s.size());\x0a"
"    return __get_classname(__s.c_str(), __icase);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"template <class _ForwardIterator>\x0a"
"typename regex_traits<_CharT>\x3a\x3a""char_class_type\x0a"
"regex_traits<_CharT>\x3a\x3a__lookup_classname(_ForwardIterator __f,\x0a"
"                                         _ForwardIterator __l,\x0a"
"                                         bool __icase, wchar_t) const\x0a"
"{\x0a"
"    string_type __s(__f, __l);\x0a"
"    __ct_->tolower(\x26__s\x5b""0\x5d, \x26__s\x5b""0\x5d + __s.size());\x0a"
"    string __n;\x0a"
"    __n.reserve(__s.size());\x0a"
"    for (typename string_type\x3a\x3a""const_iterator __i = __s.begin(), __e = __s.end();\x0a"
"                                                              __i \x21= __e; ++__i)\x0a"
"    {\x0a"
"        if (static_cast<unsigned>(*__i) >= 127)\x0a"
"            return char_class_type();\x0a"
"        __n.push_back(char(*__i));\x0a"
"    }\x0a"
"    return __get_classname(__n.c_str(), __icase);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"bool\x0a"
"regex_traits<_CharT>\x3a\x3aisctype(char_type __c, char_class_type __m) const\x0a"
"{\x0a"
"    if (__ct_->is(__m, __c))\x0a"
"        return true;\x0a"
"    return (__c == '_' \x26\x26 (__m \x26 __regex_word));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"int\x0a"
"regex_traits<_CharT>\x3a\x3a__regex_traits_value(unsigned char __ch, int __radix)\x0a"
"{\x0a"
"    if ((__ch \x26 0xF8u) == 0x30)  // '0' <= __ch \x26\x26 __ch <= '7'\x0a"
"        return __ch - '0';\x0a"
"    if (__radix \x21= 8)\x0a"
"    {\x0a"
"        if ((__ch \x26 0xFEu) == 0x38)  // '8' <= __ch \x26\x26 __ch <= '9'\x0a"
"            return __ch - '0';\x0a"
"        if (__radix == 16)\x0a"
"        {\x0a"
"            __ch \x7c= 0x20;  // tolower\x0a"
"            if ('a' <= __ch \x26\x26 __ch <= 'f')\x0a"
"                return __ch - ('a' - 10);\x0a"
"        }\x0a"
"    }\x0a"
"    return -1;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"inline\x0a"
"int\x0a"
"regex_traits<_CharT>\x3a\x3a__regex_traits_value(wchar_t __ch, int __radix) const\x0a"
"{\x0a"
"    return __regex_traits_value(static_cast<unsigned char>(__ct_->narrow(__ch, char_type())), __radix);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT> class __node;\x0a"
"\x0a"
"template <class _BidirectionalIterator> class _LIBCPP_TEMPLATE_VIS sub_match;\x0a"
"\x0a"
"template <class _BidirectionalIterator,\x0a"
"          class _Allocator = allocator<sub_match<_BidirectionalIterator> > >\x0a"
"class _LIBCPP_TEMPLATE_VIS match_results;\x0a"
"\x0a"
"template <class _CharT>\x0a"
"struct __state\x0a"
"{\x0a"
"    enum\x0a"
"    {\x0a"
"        __end_state = -1000,\x0a"
"        __consume_input,  // -999\x0a"
"        __begin_marked_expr, // -998\x0a"
"        __end_marked_expr,   // -997\x0a"
"        __pop_state,           // -996\x0a"
"        __accept_and_consume,  // -995\x0a"
"        __accept_but_not_consume,  // -994\x0a"
"        __reject,                  // -993\x0a"
"        __split,\x0a"
"        __repeat\x0a"
"    };\x0a"
"\x0a"
"    int __do_;\x0a"
"    const _CharT* __first_;\x0a"
"    const _CharT* __current_;\x0a"
"    const _CharT* __last_;\x0a"
"    vector<sub_match<const _CharT*> > __sub_matches_;\x0a"
"    vector<pair<size_t, const _CharT*> > __loop_data_;\x0a"
"    const __node<_CharT>* __node_;\x0a"
"    regex_constants\x3a\x3amatch_flag_type __flags_;\x0a"
"    bool __at_first_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __state()\x0a"
"        \x3a __do_(0), __first_(nullptr), __current_(nullptr), __last_(nullptr),\x0a"
"          __node_(nullptr), __flags_() {}\x0a"
"};\x0a"
"\x0a"
"// __node\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __node\x0a"
"{\x0a"
"    __node(const __node\x26);\x0a"
"    __node\x26 operator=(const __node\x26);\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __node() {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    virtual \x7e__node() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    virtual void __exec(__state\x26) const {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    virtual void __exec_split(bool, __state\x26) const {}\x0a"
"};\x0a"
"\x0a"
"// __end_state\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __end_state\x0a"
"    \x3a public __node<_CharT>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __end_state() {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__end_state<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    __s.__do_ = __state\x3a\x3a__end_state;\x0a"
"}\x0a"
"\x0a"
"// __has_one_state\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __has_one_state\x0a"
"    \x3a public __node<_CharT>\x0a"
"{\x0a"
"    __node<_CharT>* __first_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __has_one_state(__node<_CharT>* __s)\x0a"
"        \x3a __first_(__s) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __node<_CharT>*  first() const {return __first_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __node<_CharT>*\x26 first()       {return __first_;}\x0a"
"};\x0a"
"\x0a"
"// __owns_one_state\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __owns_one_state\x0a"
"    \x3a public __has_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __has_one_state<_CharT> base;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __owns_one_state(__node<_CharT>* __s)\x0a"
"        \x3a base(__s) {}\x0a"
"\x0a"
"    virtual \x7e__owns_one_state();\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"__owns_one_state<_CharT>\x3a\x3a\x7e__owns_one_state()\x0a"
"{\x0a"
"    delete this->first();\x0a"
"}\x0a"
"\x0a"
"// __empty_state\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __empty_state\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __empty_state(__node<_CharT>* __s)\x0a"
"        \x3a base(__s) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__empty_state<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"    __s.__node_ = this->first();\x0a"
"}\x0a"
"\x0a"
"// __empty_non_own_state\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __empty_non_own_state\x0a"
"    \x3a public __has_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __has_one_state<_CharT> base;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __empty_non_own_state(__node<_CharT>* __s)\x0a"
"        \x3a base(__s) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__empty_non_own_state<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"    __s.__node_ = this->first();\x0a"
"}\x0a"
"\x0a"
"// __repeat_one_loop\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __repeat_one_loop\x0a"
"    \x3a public __has_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __has_one_state<_CharT> base;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __repeat_one_loop(__node<_CharT>* __s)\x0a"
"        \x3a base(__s) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__repeat_one_loop<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    __s.__do_ = __state\x3a\x3a__repeat;\x0a"
"    __s.__node_ = this->first();\x0a"
"}\x0a"
"\x0a"
"// __owns_two_states\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __owns_two_states\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    base* __second_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __owns_two_states(__node<_CharT>* __s1, base* __s2)\x0a"
"        \x3a base(__s1), __second_(__s2) {}\x0a"
"\x0a"
"    virtual \x7e__owns_two_states();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    base*  second() const {return __second_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    base*\x26 second()       {return __second_;}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"__owns_two_states<_CharT>\x3a\x3a\x7e__owns_two_states()\x0a"
"{\x0a"
"    delete __second_;\x0a"
"}\x0a"
"\x0a"
"// __loop\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __loop\x0a"
"    \x3a public __owns_two_states<_CharT>\x0a"
"{\x0a"
"    typedef __owns_two_states<_CharT> base;\x0a"
"\x0a"
"    size_t __min_;\x0a"
"    size_t __max_;\x0a"
"    unsigned __loop_id_;\x0a"
"    unsigned __mexp_begin_;\x0a"
"    unsigned __mexp_end_;\x0a"
"    bool __greedy_;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __loop(unsigned __loop_id,\x0a"
"                          __node<_CharT>* __s1, __owns_one_state<_CharT>* __s2,\x0a"
"                          unsigned __mexp_begin, unsigned __mexp_end,\x0a"
"                          bool __greedy = true,\x0a"
"                          size_t __min = 0,\x0a"
"                          size_t __max = numeric_limits<size_t>\x3a\x3amax())\x0a"
"        \x3a base(__s1, __s2), __min_(__min), __max_(__max), __loop_id_(__loop_id),\x0a"
"          __mexp_begin_(__mexp_begin), __mexp_end_(__mexp_end),\x0a"
"          __greedy_(__greedy) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26 __s) const;\x0a"
"    virtual void __exec_split(bool __second, __state\x26 __s) const;\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __init_repeat(__state\x26 __s) const\x0a"
"    {\x0a"
"        __s.__loop_data_\x5b__loop_id_\x5d.second = __s.__current_;\x0a"
"        for (size_t __i = __mexp_begin_-1; __i \x21= __mexp_end_-1; ++__i)\x0a"
"        {\x0a"
"            __s.__sub_matches_\x5b__i\x5d.first = __s.__last_;\x0a"
"            __s.__sub_matches_\x5b__i\x5d.second = __s.__last_;\x0a"
"            __s.__sub_matches_\x5b__i\x5d.matched = false;\x0a"
"        }\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__loop<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    if (__s.__do_ == __state\x3a\x3a__repeat)\x0a"
"    {\x0a"
"        bool __do_repeat = ++__s.__loop_data_\x5b__loop_id_\x5d.first < __max_;\x0a"
"        bool __do_alt = __s.__loop_data_\x5b__loop_id_\x5d.first >= __min_;\x0a"
"        if (__do_repeat \x26\x26 __do_alt \x26\x26\x0a"
"                               __s.__loop_data_\x5b__loop_id_\x5d.second == __s.__current_)\x0a"
"            __do_repeat = false;\x0a"
"        if (__do_repeat \x26\x26 __do_alt)\x0a"
"            __s.__do_ = __state\x3a\x3a__split;\x0a"
"        else if (__do_repeat)\x0a"
"        {\x0a"
"            __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"            __s.__node_ = this->first();\x0a"
"            __init_repeat(__s);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"            __s.__node_ = this->second();\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__loop_data_\x5b__loop_id_\x5d.first = 0;\x0a"
"        bool __do_repeat = 0 < __max_;\x0a"
"        bool __do_alt = 0 >= __min_;\x0a"
"        if (__do_repeat \x26\x26 __do_alt)\x0a"
"            __s.__do_ = __state\x3a\x3a__split;\x0a"
"        else if (__do_repeat)\x0a"
"        {\x0a"
"            __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"            __s.__node_ = this->first();\x0a"
"            __init_repeat(__s);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"            __s.__node_ = this->second();\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__loop<_CharT>\x3a\x3a__exec_split(bool __second, __state\x26 __s) const\x0a"
"{\x0a"
"    __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"    if (__greedy_ \x21= __second)\x0a"
"    {\x0a"
"        __s.__node_ = this->first();\x0a"
"        __init_repeat(__s);\x0a"
"    }\x0a"
"    else\x0a"
"        __s.__node_ = this->second();\x0a"
"}\x0a"
"\x0a"
"// __alternate\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __alternate\x0a"
"    \x3a public __owns_two_states<_CharT>\x0a"
"{\x0a"
"    typedef __owns_two_states<_CharT> base;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __alternate(__owns_one_state<_CharT>* __s1,\x0a"
"                         __owns_one_state<_CharT>* __s2)\x0a"
"        \x3a base(__s1, __s2) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26 __s) const;\x0a"
"    virtual void __exec_split(bool __second, __state\x26 __s) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__alternate<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    __s.__do_ = __state\x3a\x3a__split;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__alternate<_CharT>\x3a\x3a__exec_split(bool __second, __state\x26 __s) const\x0a"
"{\x0a"
"    __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"    if (__second)\x0a"
"        __s.__node_ = this->second();\x0a"
"    else\x0a"
"        __s.__node_ = this->first();\x0a"
"}\x0a"
"\x0a"
"// __begin_marked_subexpression\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __begin_marked_subexpression\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    unsigned __mexp_;\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __begin_marked_subexpression(unsigned __mexp, __node<_CharT>* __s)\x0a"
"        \x3a base(__s), __mexp_(__mexp) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__begin_marked_subexpression<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"    __s.__sub_matches_\x5b__mexp_-1\x5d.first = __s.__current_;\x0a"
"    __s.__node_ = this->first();\x0a"
"}\x0a"
"\x0a"
"// __end_marked_subexpression\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __end_marked_subexpression\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    unsigned __mexp_;\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __end_marked_subexpression(unsigned __mexp, __node<_CharT>* __s)\x0a"
"        \x3a base(__s), __mexp_(__mexp) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__end_marked_subexpression<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"    __s.__sub_matches_\x5b__mexp_-1\x5d.second = __s.__current_;\x0a"
"    __s.__sub_matches_\x5b__mexp_-1\x5d.matched = true;\x0a"
"    __s.__node_ = this->first();\x0a"
"}\x0a"
"\x0a"
"// __back_ref\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __back_ref\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    unsigned __mexp_;\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __back_ref(unsigned __mexp, __node<_CharT>* __s)\x0a"
"        \x3a base(__s), __mexp_(__mexp) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__back_ref<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    if (__mexp_ > __s.__sub_matches_.size())\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a""error_backref>();\x0a"
"    sub_match<const _CharT*>\x26 __sm = __s.__sub_matches_\x5b__mexp_-1\x5d;\x0a"
"    if (__sm.matched)\x0a"
"    {\x0a"
"        ptrdiff_t __len = __sm.second - __sm.first;\x0a"
"        if (__s.__last_ - __s.__current_ >= __len \x26\x26\x0a"
"            _VSTD\x3a\x3a""equal(__sm.first, __sm.second, __s.__current_))\x0a"
"        {\x0a"
"            __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"            __s.__current_ += __len;\x0a"
"            __s.__node_ = this->first();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __s.__do_ = __state\x3a\x3a__reject;\x0a"
"            __s.__node_ = nullptr;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// __back_ref_icase\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class __back_ref_icase\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    _Traits __traits_;\x0a"
"    unsigned __mexp_;\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __back_ref_icase(const _Traits\x26 __traits, unsigned __mexp,\x0a"
"                              __node<_CharT>* __s)\x0a"
"        \x3a base(__s), __traits_(__traits), __mexp_(__mexp) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"__back_ref_icase<_CharT, _Traits>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    sub_match<const _CharT*>\x26 __sm = __s.__sub_matches_\x5b__mexp_-1\x5d;\x0a"
"    if (__sm.matched)\x0a"
"    {\x0a"
"        ptrdiff_t __len = __sm.second - __sm.first;\x0a"
"        if (__s.__last_ - __s.__current_ >= __len)\x0a"
"        {\x0a"
"            for (ptrdiff_t __i = 0; __i < __len; ++__i)\x0a"
"            {\x0a"
"                if (__traits_.translate_nocase(__sm.first\x5b__i\x5d) \x21=\x0a"
"                                __traits_.translate_nocase(__s.__current_\x5b__i\x5d))\x0a"
"                    goto __not_equal;\x0a"
"            }\x0a"
"            __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"            __s.__current_ += __len;\x0a"
"            __s.__node_ = this->first();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __s.__do_ = __state\x3a\x3a__reject;\x0a"
"            __s.__node_ = nullptr;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"__not_equal\x3a\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// __back_ref_collate\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class __back_ref_collate\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    _Traits __traits_;\x0a"
"    unsigned __mexp_;\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __back_ref_collate(const _Traits\x26 __traits, unsigned __mexp,\x0a"
"                              __node<_CharT>* __s)\x0a"
"        \x3a base(__s), __traits_(__traits), __mexp_(__mexp) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"__back_ref_collate<_CharT, _Traits>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    sub_match<const _CharT*>\x26 __sm = __s.__sub_matches_\x5b__mexp_-1\x5d;\x0a"
"    if (__sm.matched)\x0a"
"    {\x0a"
"        ptrdiff_t __len = __sm.second - __sm.first;\x0a"
"        if (__s.__last_ - __s.__current_ >= __len)\x0a"
"        {\x0a"
"            for (ptrdiff_t __i = 0; __i < __len; ++__i)\x0a"
"            {\x0a"
"                if (__traits_.translate(__sm.first\x5b__i\x5d) \x21=\x0a"
"                                       __traits_.translate(__s.__current_\x5b__i\x5d))\x0a"
"                    goto __not_equal;\x0a"
"            }\x0a"
"            __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"            __s.__current_ += __len;\x0a"
"            __s.__node_ = this->first();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __s.__do_ = __state\x3a\x3a__reject;\x0a"
"            __s.__node_ = nullptr;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"__not_equal\x3a\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// __word_boundary\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class __word_boundary\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    _Traits __traits_;\x0a"
"    bool __invert_;\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __word_boundary(const _Traits\x26 __traits, bool __invert,\x0a"
"                             __node<_CharT>* __s)\x0a"
"        \x3a base(__s), __traits_(__traits), __invert_(__invert) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"__word_boundary<_CharT, _Traits>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    bool __is_word_b = false;\x0a"
"    if (__s.__first_ \x21= __s.__last_)\x0a"
"    {\x0a"
"        if (__s.__current_ == __s.__last_)\x0a"
"        {\x0a"
"            if (\x21(__s.__flags_ \x26 regex_constants\x3a\x3amatch_not_eow))\x0a"
"            {\x0a"
"                _CharT __c = __s.__current_\x5b-1\x5d;\x0a"
"                __is_word_b = __c == '_' \x7c\x7c\x0a"
"                              __traits_.isctype(__c, ctype_base\x3a\x3a""alnum);\x0a"
"            }\x0a"
"        }\x0a"
"        else if (__s.__current_ == __s.__first_ \x26\x26\x0a"
"                \x21(__s.__flags_ \x26 regex_constants\x3a\x3amatch_prev_avail))\x0a"
"        {\x0a"
"            if (\x21(__s.__flags_ \x26 regex_constants\x3a\x3amatch_not_bow))\x0a"
"            {\x0a"
"                _CharT __c = *__s.__current_;\x0a"
"                __is_word_b = __c == '_' \x7c\x7c\x0a"
"                              __traits_.isctype(__c, ctype_base\x3a\x3a""alnum);\x0a"
"            }\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            _CharT __c1 = __s.__current_\x5b-1\x5d;\x0a"
"            _CharT __c2 = *__s.__current_;\x0a"
"            bool __is_c1_b = __c1 == '_' \x7c\x7c\x0a"
"                             __traits_.isctype(__c1, ctype_base\x3a\x3a""alnum);\x0a"
"            bool __is_c2_b = __c2 == '_' \x7c\x7c\x0a"
"                             __traits_.isctype(__c2, ctype_base\x3a\x3a""alnum);\x0a"
"            __is_word_b = __is_c1_b \x21= __is_c2_b;\x0a"
"        }\x0a"
"    }\x0a"
"    if (__is_word_b \x21= __invert_)\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"        __s.__node_ = this->first();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// __l_anchor\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __l_anchor\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __l_anchor(__node<_CharT>* __s)\x0a"
"        \x3a base(__s) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__l_anchor<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    if (__s.__at_first_ \x26\x26 __s.__current_ == __s.__first_ \x26\x26\x0a"
"        \x21(__s.__flags_ \x26 regex_constants\x3a\x3amatch_not_bol))\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"        __s.__node_ = this->first();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// __r_anchor\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __r_anchor\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __r_anchor(__node<_CharT>* __s)\x0a"
"        \x3a base(__s) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__r_anchor<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    if (__s.__current_ == __s.__last_ \x26\x26\x0a"
"        \x21(__s.__flags_ \x26 regex_constants\x3a\x3amatch_not_eol))\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"        __s.__node_ = this->first();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// __match_any\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __match_any\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __match_any(__node<_CharT>* __s)\x0a"
"        \x3a base(__s) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__match_any<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    if (__s.__current_ \x21= __s.__last_ \x26\x26 *__s.__current_ \x21= 0)\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__accept_and_consume;\x0a"
"        ++__s.__current_;\x0a"
"        __s.__node_ = this->first();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// __match_any_but_newline\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __match_any_but_newline\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __match_any_but_newline(__node<_CharT>* __s)\x0a"
"        \x3a base(__s) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <> _LIBCPP_FUNC_VIS void __match_any_but_newline<char>\x3a\x3a__exec(__state\x26) const;\x0a"
"template <> _LIBCPP_FUNC_VIS void __match_any_but_newline<wchar_t>\x3a\x3a__exec(__state\x26) const;\x0a"
"\x0a"
"// __match_char\x0a"
"\x0a"
"template <class _CharT>\x0a"
"class __match_char\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    _CharT __c_;\x0a"
"\x0a"
"    __match_char(const __match_char\x26);\x0a"
"    __match_char\x26 operator=(const __match_char\x26);\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __match_char(_CharT __c, __node<_CharT>* __s)\x0a"
"        \x3a base(__s), __c_(__c) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"void\x0a"
"__match_char<_CharT>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    if (__s.__current_ \x21= __s.__last_ \x26\x26 *__s.__current_ == __c_)\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__accept_and_consume;\x0a"
"        ++__s.__current_;\x0a"
"        __s.__node_ = this->first();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// __match_char_icase\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class __match_char_icase\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    _Traits __traits_;\x0a"
"    _CharT __c_;\x0a"
"\x0a"
"    __match_char_icase(const __match_char_icase\x26);\x0a"
"    __match_char_icase\x26 operator=(const __match_char_icase\x26);\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __match_char_icase(const _Traits\x26 __traits, _CharT __c, __node<_CharT>* __s)\x0a"
"        \x3a base(__s), __traits_(__traits), __c_(__traits.translate_nocase(__c)) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"__match_char_icase<_CharT, _Traits>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    if (__s.__current_ \x21= __s.__last_ \x26\x26\x0a"
"        __traits_.translate_nocase(*__s.__current_) == __c_)\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__accept_and_consume;\x0a"
"        ++__s.__current_;\x0a"
"        __s.__node_ = this->first();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// __match_char_collate\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class __match_char_collate\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    _Traits __traits_;\x0a"
"    _CharT __c_;\x0a"
"\x0a"
"    __match_char_collate(const __match_char_collate\x26);\x0a"
"    __match_char_collate\x26 operator=(const __match_char_collate\x26);\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __match_char_collate(const _Traits\x26 __traits, _CharT __c, __node<_CharT>* __s)\x0a"
"        \x3a base(__s), __traits_(__traits), __c_(__traits.translate(__c)) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"__match_char_collate<_CharT, _Traits>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    if (__s.__current_ \x21= __s.__last_ \x26\x26\x0a"
"        __traits_.translate(*__s.__current_) == __c_)\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__accept_and_consume;\x0a"
"        ++__s.__current_;\x0a"
"        __s.__node_ = this->first();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// __bracket_expression\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class __bracket_expression\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"    typedef typename _Traits\x3a\x3astring_type string_type;\x0a"
"\x0a"
"    _Traits __traits_;\x0a"
"    vector<_CharT> __chars_;\x0a"
"    vector<_CharT> __neg_chars_;\x0a"
"    vector<pair<string_type, string_type> > __ranges_;\x0a"
"    vector<pair<_CharT, _CharT> > __digraphs_;\x0a"
"    vector<string_type> __equivalences_;\x0a"
"    typename regex_traits<_CharT>\x3a\x3a""char_class_type __mask_;\x0a"
"    typename regex_traits<_CharT>\x3a\x3a""char_class_type __neg_mask_;\x0a"
"    bool __negate_;\x0a"
"    bool __icase_;\x0a"
"    bool __collate_;\x0a"
"    bool __might_have_digraph_;\x0a"
"\x0a"
"    __bracket_expression(const __bracket_expression\x26);\x0a"
"    __bracket_expression\x26 operator=(const __bracket_expression\x26);\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __bracket_expression(const _Traits\x26 __traits, __node<_CharT>* __s,\x0a"
"                                 bool __negate, bool __icase, bool __collate)\x0a"
"        \x3a base(__s), __traits_(__traits), __mask_(), __neg_mask_(),\x0a"
"          __negate_(__negate), __icase_(__icase), __collate_(__collate),\x0a"
"          __might_have_digraph_(__traits_.getloc().name() \x21= \x22""C\x22) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool __negated() const {return __negate_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __add_char(_CharT __c)\x0a"
"        {\x0a"
"            if (__icase_)\x0a"
"                __chars_.push_back(__traits_.translate_nocase(__c));\x0a"
"            else if (__collate_)\x0a"
"                __chars_.push_back(__traits_.translate(__c));\x0a"
"            else\x0a"
"                __chars_.push_back(__c);\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __add_neg_char(_CharT __c)\x0a"
"        {\x0a"
"            if (__icase_)\x0a"
"                __neg_chars_.push_back(__traits_.translate_nocase(__c));\x0a"
"            else if (__collate_)\x0a"
"                __neg_chars_.push_back(__traits_.translate(__c));\x0a"
"            else\x0a"
"                __neg_chars_.push_back(__c);\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __add_range(string_type __b, string_type __e)\x0a"
"        {\x0a"
"            if (__collate_)\x0a"
"            {\x0a"
"                if (__icase_)\x0a"
"                {\x0a"
"                    for (size_t __i = 0; __i < __b.size(); ++__i)\x0a"
"                        __b\x5b__i\x5d = __traits_.translate_nocase(__b\x5b__i\x5d);\x0a"
"                    for (size_t __i = 0; __i < __e.size(); ++__i)\x0a"
"                        __e\x5b__i\x5d = __traits_.translate_nocase(__e\x5b__i\x5d);\x0a"
"                }\x0a"
"                else\x0a"
"                {\x0a"
"                    for (size_t __i = 0; __i < __b.size(); ++__i)\x0a"
"                        __b\x5b__i\x5d = __traits_.translate(__b\x5b__i\x5d);\x0a"
"                    for (size_t __i = 0; __i < __e.size(); ++__i)\x0a"
"                        __e\x5b__i\x5d = __traits_.translate(__e\x5b__i\x5d);\x0a"
"                }\x0a"
"                __ranges_.push_back(make_pair(\x0a"
"                                  __traits_.transform(__b.begin(), __b.end()),\x0a"
"                                  __traits_.transform(__e.begin(), __e.end())));\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                if (__b.size() \x21= 1 \x7c\x7c __e.size() \x21= 1)\x0a"
"                    __throw_regex_error<regex_constants\x3a\x3a""error_range>();\x0a"
"                if (__icase_)\x0a"
"                {\x0a"
"                    __b\x5b""0\x5d = __traits_.translate_nocase(__b\x5b""0\x5d);\x0a"
"                    __e\x5b""0\x5d = __traits_.translate_nocase(__e\x5b""0\x5d);\x0a"
"                }\x0a"
"                __ranges_.push_back(make_pair(_VSTD\x3a\x3amove(__b), _VSTD\x3a\x3amove(__e)));\x0a"
"            }\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __add_digraph(_CharT __c1, _CharT __c2)\x0a"
"        {\x0a"
"            if (__icase_)\x0a"
"                __digraphs_.push_back(make_pair(__traits_.translate_nocase(__c1),\x0a"
"                                                __traits_.translate_nocase(__c2)));\x0a"
"            else if (__collate_)\x0a"
"                __digraphs_.push_back(make_pair(__traits_.translate(__c1),\x0a"
"                                                __traits_.translate(__c2)));\x0a"
"            else\x0a"
"                __digraphs_.push_back(make_pair(__c1, __c2));\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __add_equivalence(const string_type\x26 __s)\x0a"
"        {__equivalences_.push_back(__s);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __add_class(typename regex_traits<_CharT>\x3a\x3a""char_class_type __mask)\x0a"
"        {__mask_ \x7c= __mask;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __add_neg_class(typename regex_traits<_CharT>\x3a\x3a""char_class_type __mask)\x0a"
"        {__neg_mask_ \x7c= __mask;}\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"__bracket_expression<_CharT, _Traits>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    bool __found = false;\x0a"
"    unsigned __consumed = 0;\x0a"
"    if (__s.__current_ \x21= __s.__last_)\x0a"
"    {\x0a"
"        ++__consumed;\x0a"
"        if (__might_have_digraph_)\x0a"
"        {\x0a"
"            const _CharT* __next = _VSTD\x3a\x3anext(__s.__current_);\x0a"
"            if (__next \x21= __s.__last_)\x0a"
"            {\x0a"
"                pair<_CharT, _CharT> __ch2(*__s.__current_, *__next);\x0a"
"                if (__icase_)\x0a"
"                {\x0a"
"                    __ch2.first = __traits_.translate_nocase(__ch2.first);\x0a"
"                    __ch2.second = __traits_.translate_nocase(__ch2.second);\x0a"
"                }\x0a"
"                else if (__collate_)\x0a"
"                {\x0a"
"                    __ch2.first = __traits_.translate(__ch2.first);\x0a"
"                    __ch2.second = __traits_.translate(__ch2.second);\x0a"
"                }\x0a"
"                if (\x21__traits_.lookup_collatename(\x26__ch2.first, \x26__ch2.first+2).empty())\x0a"
"                {\x0a"
"                    // __ch2 is a digraph in this locale\x0a"
"                    ++__consumed;\x0a"
"                    for (size_t __i = 0; __i < __digraphs_.size(); ++__i)\x0a"
"                    {\x0a"
"                        if (__ch2 == __digraphs_\x5b__i\x5d)\x0a"
"                        {\x0a"
"                            __found = true;\x0a"
"                            goto __exit;\x0a"
"                        }\x0a"
"                    }\x0a"
"                    if (__collate_ \x26\x26 \x21__ranges_.empty())\x0a"
"                    {\x0a"
"                        string_type __s2 = __traits_.transform(\x26__ch2.first,\x0a"
"                                                               \x26__ch2.first + 2);\x0a"
"                        for (size_t __i = 0; __i < __ranges_.size(); ++__i)\x0a"
"                        {\x0a"
"                            if (__ranges_\x5b__i\x5d.first <= __s2 \x26\x26\x0a"
"                                __s2 <= __ranges_\x5b__i\x5d.second)\x0a"
"                            {\x0a"
"                                __found = true;\x0a"
"                                goto __exit;\x0a"
"                            }\x0a"
"                        }\x0a"
"                    }\x0a"
"                    if (\x21__equivalences_.empty())\x0a"
"                    {\x0a"
"                        string_type __s2 = __traits_.transform_primary(\x26__ch2.first,\x0a"
"                                                                       \x26__ch2.first + 2);\x0a"
"                        for (size_t __i = 0; __i < __equivalences_.size(); ++__i)\x0a"
"                        {\x0a"
"                            if (__s2 == __equivalences_\x5b__i\x5d)\x0a"
"                            {\x0a"
"                                __found = true;\x0a"
"                                goto __exit;\x0a"
"                            }\x0a"
"                        }\x0a"
"                    }\x0a"
"                    if (__traits_.isctype(__ch2.first, __mask_) \x26\x26\x0a"
"                        __traits_.isctype(__ch2.second, __mask_))\x0a"
"                    {\x0a"
"                        __found = true;\x0a"
"                        goto __exit;\x0a"
"                    }\x0a"
"                    if (\x21__traits_.isctype(__ch2.first, __neg_mask_) \x26\x26\x0a"
"                        \x21__traits_.isctype(__ch2.second, __neg_mask_))\x0a"
"                    {\x0a"
"                        __found = true;\x0a"
"                        goto __exit;\x0a"
"                    }\x0a"
"                    goto __exit;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"        // test *__s.__current_ as not a digraph\x0a"
"        _CharT __ch = *__s.__current_;\x0a"
"        if (__icase_)\x0a"
"            __ch = __traits_.translate_nocase(__ch);\x0a"
"        else if (__collate_)\x0a"
"            __ch = __traits_.translate(__ch);\x0a"
"        for (size_t __i = 0; __i < __chars_.size(); ++__i)\x0a"
"        {\x0a"
"            if (__ch == __chars_\x5b__i\x5d)\x0a"
"            {\x0a"
"                __found = true;\x0a"
"                goto __exit;\x0a"
"            }\x0a"
"        }\x0a"
"        // When there's at least one of __neg_chars_ and __neg_mask_, the set\x0a"
"        // of \x22__found\x22 chars is\x0a"
"        //   union(complement(union(__neg_chars_, __neg_mask_)),\x0a"
"        //         other cases...)\x0a"
"        //\x0a"
"        // It doesn't make sense to check this when there are no __neg_chars_\x0a"
"        // and no __neg_mask_.\x0a"
"        if (\x21(__neg_mask_ == 0 \x26\x26 __neg_chars_.empty()))\x0a"
"        {\x0a"
"            const bool __in_neg_mask = __traits_.isctype(__ch, __neg_mask_);\x0a"
"          const bool __in_neg_chars =\x0a"
"              std\x3a\x3a""find(__neg_chars_.begin(), __neg_chars_.end(), __ch) \x21=\x0a"
"              __neg_chars_.end();\x0a"
"          if (\x21(__in_neg_mask \x7c\x7c __in_neg_chars))\x0a"
"          {\x0a"
"            __found = true;\x0a"
"            goto __exit;\x0a"
"          }\x0a"
"        }\x0a"
"        if (\x21__ranges_.empty())\x0a"
"        {\x0a"
"            string_type __s2 = __collate_ \x3f\x0a"
"                                   __traits_.transform(\x26__ch, \x26__ch + 1) \x3a\x0a"
"                                   string_type(1, __ch);\x0a"
"            for (size_t __i = 0; __i < __ranges_.size(); ++__i)\x0a"
"            {\x0a"
"                if (__ranges_\x5b__i\x5d.first <= __s2 \x26\x26 __s2 <= __ranges_\x5b__i\x5d.second)\x0a"
"                {\x0a"
"                    __found = true;\x0a"
"                    goto __exit;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"        if (\x21__equivalences_.empty())\x0a"
"        {\x0a"
"            string_type __s2 = __traits_.transform_primary(\x26__ch, \x26__ch + 1);\x0a"
"            for (size_t __i = 0; __i < __equivalences_.size(); ++__i)\x0a"
"            {\x0a"
"                if (__s2 == __equivalences_\x5b__i\x5d)\x0a"
"                {\x0a"
"                    __found = true;\x0a"
"                    goto __exit;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"        if (__traits_.isctype(__ch, __mask_))\x0a"
"        {\x0a"
"            __found = true;\x0a"
"            goto __exit;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"        __found = __negate_;  // force reject\x0a"
"__exit\x3a\x0a"
"    if (__found \x21= __negate_)\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__accept_and_consume;\x0a"
"        __s.__current_ += __consumed;\x0a"
"        __s.__node_ = this->first();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits> class __lookahead;\x0a"
"\x0a"
"template <class _CharT, class _Traits = regex_traits<_CharT> >\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_regex\x0a"
"{\x0a"
"public\x3a\x0a"
"    // types\x3a\x0a"
"    typedef _CharT                              value_type;\x0a"
"    typedef _Traits                             traits_type;\x0a"
"    typedef typename _Traits\x3a\x3astring_type       string_type;\x0a"
"    typedef regex_constants\x3a\x3asyntax_option_type flag_type;\x0a"
"    typedef typename _Traits\x3a\x3alocale_type       locale_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    _Traits   __traits_;\x0a"
"    flag_type __flags_;\x0a"
"    unsigned __marked_count_;\x0a"
"    unsigned __loop_count_;\x0a"
"    int __open_count_;\x0a"
"    shared_ptr<__empty_state<_CharT> > __start_;\x0a"
"    __owns_one_state<_CharT>* __end_;\x0a"
"\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"    typedef _VSTD\x3a\x3a__node<_CharT> __node;\x0a"
"\x0a"
"public\x3a\x0a"
"    // constants\x3a\x0a"
"    static const regex_constants\x3a\x3asyntax_option_type icase = regex_constants\x3a\x3aicase;\x0a"
"    static const regex_constants\x3a\x3asyntax_option_type nosubs = regex_constants\x3a\x3anosubs;\x0a"
"    static const regex_constants\x3a\x3asyntax_option_type optimize = regex_constants\x3a\x3aoptimize;\x0a"
"    static const regex_constants\x3a\x3asyntax_option_type collate = regex_constants\x3a\x3a""collate;\x0a"
"    static const regex_constants\x3a\x3asyntax_option_type ECMAScript = regex_constants\x3a\x3a""ECMAScript;\x0a"
"    static const regex_constants\x3a\x3asyntax_option_type basic = regex_constants\x3a\x3a""basic;\x0a"
"    static const regex_constants\x3a\x3asyntax_option_type extended = regex_constants\x3a\x3a""extended;\x0a"
"    static const regex_constants\x3a\x3asyntax_option_type awk = regex_constants\x3a\x3a""awk;\x0a"
"    static const regex_constants\x3a\x3asyntax_option_type grep = regex_constants\x3a\x3agrep;\x0a"
"    static const regex_constants\x3a\x3asyntax_option_type egrep = regex_constants\x3a\x3a""egrep;\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_regex()\x0a"
"        \x3a __flags_(regex_constants\x3a\x3a""ECMAScript), __marked_count_(0), __loop_count_(0), __open_count_(0),\x0a"
"          __end_(0)\x0a"
"        {}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit basic_regex(const value_type* __p, flag_type __f = regex_constants\x3a\x3a""ECMAScript)\x0a"
"        \x3a __flags_(__f), __marked_count_(0), __loop_count_(0), __open_count_(0),\x0a"
"          __end_(0)\x0a"
"        {\x0a"
"        if (__get_grammar(__flags_) == 0) __flags_ \x7c= regex_constants\x3a\x3a""ECMAScript;\x0a"
"        __parse(__p, __p + __traits_.length(__p));\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_regex(const value_type* __p, size_t __len, flag_type __f = regex_constants\x3a\x3a""ECMAScript)\x0a"
"        \x3a __flags_(__f), __marked_count_(0), __loop_count_(0), __open_count_(0),\x0a"
"          __end_(0)\x0a"
"        {\x0a"
"        if (__get_grammar(__flags_) == 0) __flags_ \x7c= regex_constants\x3a\x3a""ECMAScript;\x0a"
"        __parse(__p, __p + __len);\x0a"
"        }\x0a"
"\x0a"
"//     basic_regex(const basic_regex\x26) = default;\x0a"
"//     basic_regex(basic_regex\x26\x26) = default;\x0a"
"    template <class _ST, class _SA>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        explicit basic_regex(const basic_string<value_type, _ST, _SA>\x26 __p,\x0a"
"                             flag_type __f = regex_constants\x3a\x3a""ECMAScript)\x0a"
"        \x3a __flags_(__f), __marked_count_(0), __loop_count_(0), __open_count_(0),\x0a"
"          __end_(0)\x0a"
"        {\x0a"
"        if (__get_grammar(__flags_) == 0) __flags_ \x7c= regex_constants\x3a\x3a""ECMAScript;\x0a"
"        __parse(__p.begin(), __p.end());\x0a"
"        }\x0a"
"\x0a"
"    template <class _ForwardIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        basic_regex(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                    flag_type __f = regex_constants\x3a\x3a""ECMAScript)\x0a"
"        \x3a __flags_(__f), __marked_count_(0), __loop_count_(0), __open_count_(0),\x0a"
"          __end_(0)\x0a"
"        {\x0a"
"        if (__get_grammar(__flags_) == 0) __flags_ \x7c= regex_constants\x3a\x3a""ECMAScript;\x0a"
"        __parse(__first, __last);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_regex(initializer_list<value_type> __il,\x0a"
"                flag_type __f = regex_constants\x3a\x3a""ECMAScript)\x0a"
"        \x3a __flags_(__f), __marked_count_(0), __loop_count_(0), __open_count_(0),\x0a"
"          __end_(0)\x0a"
"        {\x0a"
"        if (__get_grammar(__flags_) == 0) __flags_ \x7c= regex_constants\x3a\x3a""ECMAScript;\x0a"
"        __parse(__il.begin(), __il.end());\x0a"
"        }\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"//    \x7e""basic_regex() = default;\x0a"
"\x0a"
"//     basic_regex\x26 operator=(const basic_regex\x26) = default;\x0a"
"//     basic_regex\x26 operator=(basic_regex\x26\x26) = default;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_regex\x26 operator=(const value_type* __p)\x0a"
"        {return assign(__p);}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_regex\x26 operator=(initializer_list<value_type> __il)\x0a"
"        {return assign(__il);}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    template <class _ST, class _SA>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        basic_regex\x26 operator=(const basic_string<value_type, _ST, _SA>\x26 __p)\x0a"
"        {return assign(__p);}\x0a"
"\x0a"
"    // assign\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_regex\x26 assign(const basic_regex\x26 __that)\x0a"
"        {return *this = __that;}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_regex\x26 assign(basic_regex\x26\x26 __that) _NOEXCEPT\x0a"
"        {return *this = _VSTD\x3a\x3amove(__that);}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_regex\x26 assign(const value_type* __p, flag_type __f = regex_constants\x3a\x3a""ECMAScript)\x0a"
"        {return assign(__p, __p + __traits_.length(__p), __f);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_regex\x26 assign(const value_type* __p, size_t __len, flag_type __f)\x0a"
"        {return assign(__p, __p + __len, __f);}\x0a"
"    template <class _ST, class _SA>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        basic_regex\x26 assign(const basic_string<value_type, _ST, _SA>\x26 __s,\x0a"
"                            flag_type __f = regex_constants\x3a\x3a""ECMAScript)\x0a"
"            {return assign(__s.begin(), __s.end(), __f);}\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"             __is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"            \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"            basic_regex\x26\x0a"
"        >\x3a\x3atype\x0a"
"        assign(_InputIterator __first, _InputIterator __last,\x0a"
"                            flag_type __f = regex_constants\x3a\x3a""ECMAScript)\x0a"
"        {\x0a"
"            basic_string<_CharT> __t(__first, __last);\x0a"
"            return assign(__t.begin(), __t.end(), __f);\x0a"
"        }\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __member_init(flag_type __f)\x0a"
"    {\x0a"
"        __flags_ = __f;\x0a"
"        __marked_count_ = 0;\x0a"
"        __loop_count_ = 0;\x0a"
"        __open_count_ = 0;\x0a"
"        __end_ = nullptr;\x0a"
"    }\x0a"
"public\x3a\x0a"
"\x0a"
"    template <class _ForwardIterator>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"            basic_regex\x26\x0a"
"        >\x3a\x3atype\x0a"
"        assign(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                            flag_type __f = regex_constants\x3a\x3a""ECMAScript)\x0a"
"        {\x0a"
"            return assign(basic_regex(__first, __last, __f));\x0a"
"        }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_regex\x26 assign(initializer_list<value_type> __il,\x0a"
"                        flag_type __f = regex_constants\x3a\x3a""ECMAScript)\x0a"
"        {return assign(__il.begin(), __il.end(), __f);}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    // const operations\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unsigned mark_count() const {return __marked_count_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    flag_type flags() const {return __flags_;}\x0a"
"\x0a"
"    // locale\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    locale_type imbue(locale_type __loc)\x0a"
"    {\x0a"
"        __member_init(ECMAScript);\x0a"
"        __start_.reset();\x0a"
"        return __traits_.imbue(__loc);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    locale_type getloc() const {return __traits_.getloc();}\x0a"
"\x0a"
"    // swap\x3a\x0a"
"    void swap(basic_regex\x26 __r);\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    unsigned __loop_count() const {return __loop_count_;}\x0a"
"\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_basic_reg_exp(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_RE_expression(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_simple_RE(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_nondupl_RE(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_one_char_or_coll_elem_RE(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_Back_open_paren(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_Back_close_paren(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_Back_open_brace(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_Back_close_brace(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_BACKREF(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_ORD_CHAR(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_QUOTED_CHAR(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_RE_dupl_symbol(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                               __owns_one_state<_CharT>* __s,\x0a"
"                               unsigned __mexp_begin, unsigned __mexp_end);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_ERE_dupl_symbol(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                                __owns_one_state<_CharT>* __s,\x0a"
"                                unsigned __mexp_begin, unsigned __mexp_end);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_bracket_expression(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_follow_list(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                            __bracket_expression<_CharT, _Traits>* __ml);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_expression_term(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                                __bracket_expression<_CharT, _Traits>* __ml);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_equivalence_class(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                                  __bracket_expression<_CharT, _Traits>* __ml);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_character_class(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                                __bracket_expression<_CharT, _Traits>* __ml);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_collating_symbol(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                                 basic_string<_CharT>\x26 __col_sym);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_DUP_COUNT(_ForwardIterator __first, _ForwardIterator __last, int\x26 __c);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_extended_reg_exp(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_ERE_branch(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_ERE_expression(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_one_char_or_coll_elem_ERE(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_ORD_CHAR_ERE(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_QUOTED_CHAR_ERE(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_ecma_exp(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_alternative(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_term(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_assertion(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_atom(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_atom_escape(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_decimal_escape(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_character_class_escape(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_character_escape(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                                 basic_string<_CharT>* __str = nullptr);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_pattern_character(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_grep(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_egrep(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_class_escape(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                          basic_string<_CharT>\x26 __str,\x0a"
"                          __bracket_expression<_CharT, _Traits>* __ml);\x0a"
"    template <class _ForwardIterator>\x0a"
"        _ForwardIterator\x0a"
"        __parse_awk_escape(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                          basic_string<_CharT>* __str = nullptr);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __push_l_anchor();\x0a"
"    void __push_r_anchor();\x0a"
"    void __push_match_any();\x0a"
"    void __push_match_any_but_newline();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __push_greedy_inf_repeat(size_t __min, __owns_one_state<_CharT>* __s,\x0a"
"                                  unsigned __mexp_begin = 0, unsigned __mexp_end = 0)\x0a"
"        {__push_loop(__min, numeric_limits<size_t>\x3a\x3amax(), __s,\x0a"
"                     __mexp_begin, __mexp_end);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __push_nongreedy_inf_repeat(size_t __min, __owns_one_state<_CharT>* __s,\x0a"
"                                  unsigned __mexp_begin = 0, unsigned __mexp_end = 0)\x0a"
"        {__push_loop(__min, numeric_limits<size_t>\x3a\x3amax(), __s,\x0a"
"                     __mexp_begin, __mexp_end, false);}\x0a"
"    void __push_loop(size_t __min, size_t __max, __owns_one_state<_CharT>* __s,\x0a"
"                     size_t __mexp_begin = 0, size_t __mexp_end = 0,\x0a"
"                     bool __greedy = true);\x0a"
"    __bracket_expression<_CharT, _Traits>* __start_matching_list(bool __negate);\x0a"
"    void __push_char(value_type __c);\x0a"
"    void __push_back_ref(int __i);\x0a"
"    void __push_alternation(__owns_one_state<_CharT>* __sa,\x0a"
"                            __owns_one_state<_CharT>* __sb);\x0a"
"    void __push_begin_marked_subexpression();\x0a"
"    void __push_end_marked_subexpression(unsigned);\x0a"
"    void __push_empty();\x0a"
"    void __push_word_boundary(bool);\x0a"
"    void __push_lookahead(const basic_regex\x26, bool, unsigned);\x0a"
"\x0a"
"    template <class _Allocator>\x0a"
"        bool\x0a"
"        __search(const _CharT* __first, const _CharT* __last,\x0a"
"                 match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type __flags) const;\x0a"
"\x0a"
"    template <class _Allocator>\x0a"
"        bool\x0a"
"        __match_at_start(const _CharT* __first, const _CharT* __last,\x0a"
"                 match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type __flags, bool) const;\x0a"
"    template <class _Allocator>\x0a"
"        bool\x0a"
"        __match_at_start_ecma(const _CharT* __first, const _CharT* __last,\x0a"
"                 match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type __flags, bool) const;\x0a"
"    template <class _Allocator>\x0a"
"        bool\x0a"
"        __match_at_start_posix_nosubs(const _CharT* __first, const _CharT* __last,\x0a"
"                 match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type __flags, bool) const;\x0a"
"    template <class _Allocator>\x0a"
"        bool\x0a"
"        __match_at_start_posix_subs(const _CharT* __first, const _CharT* __last,\x0a"
"                 match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type __flags, bool) const;\x0a"
"\x0a"
"    template <class _Bp, class _Ap, class _Cp, class _Tp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    regex_search(_Bp, _Bp, match_results<_Bp, _Ap>\x26, const basic_regex<_Cp, _Tp>\x26,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type);\x0a"
"\x0a"
"    template <class _Ap, class _Cp, class _Tp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    regex_search(const _Cp*, const _Cp*, match_results<const _Cp*, _Ap>\x26,\x0a"
"                 const basic_regex<_Cp, _Tp>\x26, regex_constants\x3a\x3amatch_flag_type);\x0a"
"\x0a"
"    template <class _Bp, class _Cp, class _Tp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    regex_search(_Bp, _Bp, const basic_regex<_Cp, _Tp>\x26,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type);\x0a"
"\x0a"
"    template <class _Cp, class _Tp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    regex_search(const _Cp*, const _Cp*,\x0a"
"                 const basic_regex<_Cp, _Tp>\x26, regex_constants\x3a\x3amatch_flag_type);\x0a"
"\x0a"
"    template <class _Cp, class _Ap, class _Tp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    regex_search(const _Cp*, match_results<const _Cp*, _Ap>\x26, const basic_regex<_Cp, _Tp>\x26,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type);\x0a"
"\x0a"
"    template <class _ST, class _SA, class _Cp, class _Tp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    regex_search(const basic_string<_Cp, _ST, _SA>\x26 __s,\x0a"
"                 const basic_regex<_Cp, _Tp>\x26 __e,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type __flags);\x0a"
"\x0a"
"    template <class _ST, class _SA, class _Ap, class _Cp, class _Tp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    regex_search(const basic_string<_Cp, _ST, _SA>\x26 __s,\x0a"
"                 match_results<typename basic_string<_Cp, _ST, _SA>\x3a\x3a""const_iterator, _Ap>\x26,\x0a"
"                 const basic_regex<_Cp, _Tp>\x26 __e,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type __flags);\x0a"
"\x0a"
"    template <class _Iter, class _Ap, class _Cp, class _Tp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    regex_search(__wrap_iter<_Iter> __first,\x0a"
"                 __wrap_iter<_Iter> __last,\x0a"
"                 match_results<__wrap_iter<_Iter>, _Ap>\x26 __m,\x0a"
"                 const basic_regex<_Cp, _Tp>\x26 __e,\x0a"
"                 regex_constants\x3a\x3amatch_flag_type __flags);\x0a"
"\x0a"
"    template <class, class> friend class __lookahead;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template <class _ForwardIterator,\x0a"
"          class = typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue, nullptr_t>\x3a\x3atype\x0a"
">\x0a"
"basic_regex(_ForwardIterator, _ForwardIterator,\x0a"
"            regex_constants\x3a\x3asyntax_option_type = regex_constants\x3a\x3a""ECMAScript)\x0a"
"    -> basic_regex<typename iterator_traits<_ForwardIterator>\x3a\x3avalue_type>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"    const regex_constants\x3a\x3asyntax_option_type basic_regex<_CharT, _Traits>\x3a\x3aicase;\x0a"
"template <class _CharT, class _Traits>\x0a"
"    const regex_constants\x3a\x3asyntax_option_type basic_regex<_CharT, _Traits>\x3a\x3anosubs;\x0a"
"template <class _CharT, class _Traits>\x0a"
"    const regex_constants\x3a\x3asyntax_option_type basic_regex<_CharT, _Traits>\x3a\x3aoptimize;\x0a"
"template <class _CharT, class _Traits>\x0a"
"    const regex_constants\x3a\x3asyntax_option_type basic_regex<_CharT, _Traits>\x3a\x3a""collate;\x0a"
"template <class _CharT, class _Traits>\x0a"
"    const regex_constants\x3a\x3asyntax_option_type basic_regex<_CharT, _Traits>\x3a\x3a""ECMAScript;\x0a"
"template <class _CharT, class _Traits>\x0a"
"    const regex_constants\x3a\x3asyntax_option_type basic_regex<_CharT, _Traits>\x3a\x3a""basic;\x0a"
"template <class _CharT, class _Traits>\x0a"
"    const regex_constants\x3a\x3asyntax_option_type basic_regex<_CharT, _Traits>\x3a\x3a""extended;\x0a"
"template <class _CharT, class _Traits>\x0a"
"    const regex_constants\x3a\x3asyntax_option_type basic_regex<_CharT, _Traits>\x3a\x3a""awk;\x0a"
"template <class _CharT, class _Traits>\x0a"
"    const regex_constants\x3a\x3asyntax_option_type basic_regex<_CharT, _Traits>\x3a\x3agrep;\x0a"
"template <class _CharT, class _Traits>\x0a"
"    const regex_constants\x3a\x3asyntax_option_type basic_regex<_CharT, _Traits>\x3a\x3a""egrep;\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3aswap(basic_regex\x26 __r)\x0a"
"{\x0a"
"    using _VSTD\x3a\x3aswap;\x0a"
"    swap(__traits_, __r.__traits_);\x0a"
"    swap(__flags_, __r.__flags_);\x0a"
"    swap(__marked_count_, __r.__marked_count_);\x0a"
"    swap(__loop_count_, __r.__loop_count_);\x0a"
"    swap(__open_count_, __r.__open_count_);\x0a"
"    swap(__start_, __r.__start_);\x0a"
"    swap(__end_, __r.__end_);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(basic_regex<_CharT, _Traits>\x26 __x, basic_regex<_CharT, _Traits>\x26 __y)\x0a"
"{\x0a"
"    return __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"// __lookahead\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"class __lookahead\x0a"
"    \x3a public __owns_one_state<_CharT>\x0a"
"{\x0a"
"    typedef __owns_one_state<_CharT> base;\x0a"
"\x0a"
"    basic_regex<_CharT, _Traits> __exp_;\x0a"
"    unsigned __mexp_;\x0a"
"    bool __invert_;\x0a"
"\x0a"
"    __lookahead(const __lookahead\x26);\x0a"
"    __lookahead\x26 operator=(const __lookahead\x26);\x0a"
"public\x3a\x0a"
"    typedef _VSTD\x3a\x3a__state<_CharT> __state;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __lookahead(const basic_regex<_CharT, _Traits>\x26 __exp, bool __invert, __node<_CharT>* __s, unsigned __mexp)\x0a"
"        \x3a base(__s), __exp_(__exp), __mexp_(__mexp), __invert_(__invert) {}\x0a"
"\x0a"
"    virtual void __exec(__state\x26) const;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"__lookahead<_CharT, _Traits>\x3a\x3a__exec(__state\x26 __s) const\x0a"
"{\x0a"
"    match_results<const _CharT*> __m;\x0a"
"    __m.__init(1 + __exp_.mark_count(), __s.__current_, __s.__last_);\x0a"
"    bool __matched = __exp_.__match_at_start_ecma(\x0a"
"        __s.__current_, __s.__last_,\x0a"
"        __m,\x0a"
"        (__s.__flags_ \x7c regex_constants\x3a\x3amatch_continuous) \x26\x0a"
"        \x7eregex_constants\x3a\x3a__full_match,\x0a"
"        __s.__at_first_ \x26\x26 __s.__current_ == __s.__first_);\x0a"
"    if (__matched \x21= __invert_)\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__accept_but_not_consume;\x0a"
"        __s.__node_ = this->first();\x0a"
"        for (unsigned __i = 1; __i < __m.size(); ++__i) {\x0a"
"            __s.__sub_matches_\x5b__mexp_ + __i - 1\x5d = __m.__matches_\x5b__i\x5d;\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __s.__do_ = __state\x3a\x3a__reject;\x0a"
"        __s.__node_ = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse(_ForwardIterator __first,\x0a"
"                                      _ForwardIterator __last)\x0a"
"{\x0a"
"    {\x0a"
"        unique_ptr<__node> __h(new __end_state<_CharT>);\x0a"
"        __start_.reset(new __empty_state<_CharT>(__h.get()));\x0a"
"        __h.release();\x0a"
"        __end_ = __start_.get();\x0a"
"    }\x0a"
"    switch (__get_grammar(__flags_))\x0a"
"    {\x0a"
"    case ECMAScript\x3a\x0a"
"        __first = __parse_ecma_exp(__first, __last);\x0a"
"        break;\x0a"
"    case basic\x3a\x0a"
"        __first = __parse_basic_reg_exp(__first, __last);\x0a"
"        break;\x0a"
"    case extended\x3a\x0a"
"    case awk\x3a\x0a"
"        __first = __parse_extended_reg_exp(__first, __last);\x0a"
"        break;\x0a"
"    case grep\x3a\x0a"
"        __first = __parse_grep(__first, __last);\x0a"
"        break;\x0a"
"    case egrep\x3a\x0a"
"        __first = __parse_egrep(__first, __last);\x0a"
"        break;\x0a"
"    default\x3a\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a__re_err_grammar>();\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_basic_reg_exp(_ForwardIterator __first,\x0a"
"                                                    _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        if (*__first == '^')\x0a"
"        {\x0a"
"            __push_l_anchor();\x0a"
"            ++__first;\x0a"
"        }\x0a"
"        if (__first \x21= __last)\x0a"
"        {\x0a"
"            __first = __parse_RE_expression(__first, __last);\x0a"
"            if (__first \x21= __last)\x0a"
"            {\x0a"
"                _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"                if (__temp == __last \x26\x26 *__first == '\x24')\x0a"
"                {\x0a"
"                    __push_r_anchor();\x0a"
"                    ++__first;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"        if (__first \x21= __last)\x0a"
"            __throw_regex_error<regex_constants\x3a\x3a__re_err_empty>();\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_extended_reg_exp(_ForwardIterator __first,\x0a"
"                                                       _ForwardIterator __last)\x0a"
"{\x0a"
"    __owns_one_state<_CharT>* __sa = __end_;\x0a"
"    _ForwardIterator __temp = __parse_ERE_branch(__first, __last);\x0a"
"    if (__temp == __first)\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a__re_err_empty>();\x0a"
"    __first = __temp;\x0a"
"    while (__first \x21= __last \x26\x26 *__first == '\x7c')\x0a"
"    {\x0a"
"        __owns_one_state<_CharT>* __sb = __end_;\x0a"
"        __temp = __parse_ERE_branch(++__first, __last);\x0a"
"        if (__temp == __first)\x0a"
"            __throw_regex_error<regex_constants\x3a\x3a__re_err_empty>();\x0a"
"        __push_alternation(__sa, __sb);\x0a"
"        __first = __temp;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_ERE_branch(_ForwardIterator __first,\x0a"
"                                                 _ForwardIterator __last)\x0a"
"{\x0a"
"    _ForwardIterator __temp = __parse_ERE_expression(__first, __last);\x0a"
"    if (__temp == __first)\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a__re_err_empty>();\x0a"
"    do\x0a"
"    {\x0a"
"        __first = __temp;\x0a"
"        __temp = __parse_ERE_expression(__first, __last);\x0a"
"    } while (__temp \x21= __first);\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_ERE_expression(_ForwardIterator __first,\x0a"
"                                                     _ForwardIterator __last)\x0a"
"{\x0a"
"    __owns_one_state<_CharT>* __e = __end_;\x0a"
"    unsigned __mexp_begin = __marked_count_;\x0a"
"    _ForwardIterator __temp = __parse_one_char_or_coll_elem_ERE(__first, __last);\x0a"
"    if (__temp == __first \x26\x26 __temp \x21= __last)\x0a"
"    {\x0a"
"        switch (*__temp)\x0a"
"        {\x0a"
"        case '^'\x3a\x0a"
"            __push_l_anchor();\x0a"
"            ++__temp;\x0a"
"            break;\x0a"
"        case '\x24'\x3a\x0a"
"            __push_r_anchor();\x0a"
"            ++__temp;\x0a"
"            break;\x0a"
"        case '('\x3a\x0a"
"            __push_begin_marked_subexpression();\x0a"
"            unsigned __temp_count = __marked_count_;\x0a"
"            ++__open_count_;\x0a"
"            __temp = __parse_extended_reg_exp(++__temp, __last);\x0a"
"            if (__temp == __last \x7c\x7c *__temp \x21= ')')\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_paren>();\x0a"
"            __push_end_marked_subexpression(__temp_count);\x0a"
"            --__open_count_;\x0a"
"            ++__temp;\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    if (__temp \x21= __first)\x0a"
"        __temp = __parse_ERE_dupl_symbol(__temp, __last, __e, __mexp_begin+1,\x0a"
"                                         __marked_count_+1);\x0a"
"    __first = __temp;\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_RE_expression(_ForwardIterator __first,\x0a"
"                                                    _ForwardIterator __last)\x0a"
"{\x0a"
"    while (true)\x0a"
"    {\x0a"
"        _ForwardIterator __temp = __parse_simple_RE(__first, __last);\x0a"
"        if (__temp == __first)\x0a"
"            break;\x0a"
"        __first = __temp;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_simple_RE(_ForwardIterator __first,\x0a"
"                                                _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        __owns_one_state<_CharT>* __e = __end_;\x0a"
"        unsigned __mexp_begin = __marked_count_;\x0a"
"        _ForwardIterator __temp = __parse_nondupl_RE(__first, __last);\x0a"
"        if (__temp \x21= __first)\x0a"
"            __first = __parse_RE_dupl_symbol(__temp, __last, __e,\x0a"
"                                             __mexp_begin+1, __marked_count_+1);\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_nondupl_RE(_ForwardIterator __first,\x0a"
"                                                 _ForwardIterator __last)\x0a"
"{\x0a"
"    _ForwardIterator __temp = __first;\x0a"
"    __first = __parse_one_char_or_coll_elem_RE(__first, __last);\x0a"
"    if (__temp == __first)\x0a"
"    {\x0a"
"        __temp = __parse_Back_open_paren(__first, __last);\x0a"
"        if (__temp \x21= __first)\x0a"
"        {\x0a"
"            __push_begin_marked_subexpression();\x0a"
"            unsigned __temp_count = __marked_count_;\x0a"
"            __first = __parse_RE_expression(__temp, __last);\x0a"
"            __temp = __parse_Back_close_paren(__first, __last);\x0a"
"            if (__temp == __first)\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_paren>();\x0a"
"            __push_end_marked_subexpression(__temp_count);\x0a"
"            __first = __temp;\x0a"
"        }\x0a"
"        else\x0a"
"            __first = __parse_BACKREF(__first, __last);\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_one_char_or_coll_elem_RE(\x0a"
"                                                       _ForwardIterator __first,\x0a"
"                                                       _ForwardIterator __last)\x0a"
"{\x0a"
"    _ForwardIterator __temp = __parse_ORD_CHAR(__first, __last);\x0a"
"    if (__temp == __first)\x0a"
"    {\x0a"
"        __temp = __parse_QUOTED_CHAR(__first, __last);\x0a"
"        if (__temp == __first)\x0a"
"        {\x0a"
"            if (__temp \x21= __last \x26\x26 *__temp == '.')\x0a"
"            {\x0a"
"                __push_match_any();\x0a"
"                ++__temp;\x0a"
"            }\x0a"
"            else\x0a"
"                __temp = __parse_bracket_expression(__first, __last);\x0a"
"        }\x0a"
"    }\x0a"
"    __first = __temp;\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_one_char_or_coll_elem_ERE(\x0a"
"                                                       _ForwardIterator __first,\x0a"
"                                                       _ForwardIterator __last)\x0a"
"{\x0a"
"    _ForwardIterator __temp = __parse_ORD_CHAR_ERE(__first, __last);\x0a"
"    if (__temp == __first)\x0a"
"    {\x0a"
"        __temp = __parse_QUOTED_CHAR_ERE(__first, __last);\x0a"
"        if (__temp == __first)\x0a"
"        {\x0a"
"            if (__temp \x21= __last \x26\x26 *__temp == '.')\x0a"
"            {\x0a"
"                __push_match_any();\x0a"
"                ++__temp;\x0a"
"            }\x0a"
"            else\x0a"
"                __temp = __parse_bracket_expression(__first, __last);\x0a"
"        }\x0a"
"    }\x0a"
"    __first = __temp;\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_Back_open_paren(_ForwardIterator __first,\x0a"
"                                                      _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"        if (__temp \x21= __last)\x0a"
"        {\x0a"
"            if (*__first == '\x5c\x5c' \x26\x26 *__temp == '(')\x0a"
"                __first = ++__temp;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_Back_close_paren(_ForwardIterator __first,\x0a"
"                                                       _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"        if (__temp \x21= __last)\x0a"
"        {\x0a"
"            if (*__first == '\x5c\x5c' \x26\x26 *__temp == ')')\x0a"
"                __first = ++__temp;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_Back_open_brace(_ForwardIterator __first,\x0a"
"                                                      _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"        if (__temp \x21= __last)\x0a"
"        {\x0a"
"            if (*__first == '\x5c\x5c' \x26\x26 *__temp == '{')\x0a"
"                __first = ++__temp;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_Back_close_brace(_ForwardIterator __first,\x0a"
"                                                       _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"        if (__temp \x21= __last)\x0a"
"        {\x0a"
"            if (*__first == '\x5c\x5c' \x26\x26 *__temp == '}')\x0a"
"                __first = ++__temp;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_BACKREF(_ForwardIterator __first,\x0a"
"                                              _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"        if (__temp \x21= __last)\x0a"
"        {\x0a"
"            if (*__first == '\x5c\x5c')\x0a"
"            {\x0a"
"                int __val = __traits_.value(*__temp, 10);\x0a"
"                if (__val >= 1 \x26\x26 __val <= 9)\x0a"
"                {\x0a"
"                    __push_back_ref(__val);\x0a"
"                    __first = ++__temp;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_ORD_CHAR(_ForwardIterator __first,\x0a"
"                                               _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"        if (__temp == __last \x26\x26 *__first == '\x24')\x0a"
"            return __first;\x0a"
"        // Not called inside a bracket\x0a"
"        if (*__first == '.' \x7c\x7c *__first == '\x5c\x5c' \x7c\x7c *__first == '\x5b')\x0a"
"            return __first;\x0a"
"        __push_char(*__first);\x0a"
"        ++__first;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_ORD_CHAR_ERE(_ForwardIterator __first,\x0a"
"                                                   _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        switch (*__first)\x0a"
"        {\x0a"
"        case '^'\x3a\x0a"
"        case '.'\x3a\x0a"
"        case '\x5b'\x3a\x0a"
"        case '\x24'\x3a\x0a"
"        case '('\x3a\x0a"
"        case '\x7c'\x3a\x0a"
"        case '*'\x3a\x0a"
"        case '+'\x3a\x0a"
"        case '\x3f'\x3a\x0a"
"        case '{'\x3a\x0a"
"        case '\x5c\x5c'\x3a\x0a"
"            break;\x0a"
"        case ')'\x3a\x0a"
"            if (__open_count_ == 0)\x0a"
"            {\x0a"
"                __push_char(*__first);\x0a"
"                ++__first;\x0a"
"            }\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            __push_char(*__first);\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_QUOTED_CHAR(_ForwardIterator __first,\x0a"
"                                                  _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"        if (__temp \x21= __last)\x0a"
"        {\x0a"
"            if (*__first == '\x5c\x5c')\x0a"
"            {\x0a"
"                switch (*__temp)\x0a"
"                {\x0a"
"                case '^'\x3a\x0a"
"                case '.'\x3a\x0a"
"                case '*'\x3a\x0a"
"                case '\x5b'\x3a\x0a"
"                case '\x24'\x3a\x0a"
"                case '\x5c\x5c'\x3a\x0a"
"                    __push_char(*__temp);\x0a"
"                    __first = ++__temp;\x0a"
"                    break;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_QUOTED_CHAR_ERE(_ForwardIterator __first,\x0a"
"                                                      _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"        if (__temp \x21= __last)\x0a"
"        {\x0a"
"            if (*__first == '\x5c\x5c')\x0a"
"            {\x0a"
"                switch (*__temp)\x0a"
"                {\x0a"
"                case '^'\x3a\x0a"
"                case '.'\x3a\x0a"
"                case '*'\x3a\x0a"
"                case '\x5b'\x3a\x0a"
"                case '\x24'\x3a\x0a"
"                case '\x5c\x5c'\x3a\x0a"
"                case '('\x3a\x0a"
"                case ')'\x3a\x0a"
"                case '\x7c'\x3a\x0a"
"                case '+'\x3a\x0a"
"                case '\x3f'\x3a\x0a"
"                case '{'\x3a\x0a"
"                case '}'\x3a\x0a"
"                    __push_char(*__temp);\x0a"
"                    __first = ++__temp;\x0a"
"                    break;\x0a"
"                default\x3a\x0a"
"                    if (__get_grammar(__flags_) == awk)\x0a"
"                        __first = __parse_awk_escape(++__first, __last);\x0a"
"                    break;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_RE_dupl_symbol(_ForwardIterator __first,\x0a"
"                                                     _ForwardIterator __last,\x0a"
"                                                     __owns_one_state<_CharT>* __s,\x0a"
"                                                     unsigned __mexp_begin,\x0a"
"                                                     unsigned __mexp_end)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        if (*__first == '*')\x0a"
"        {\x0a"
"            __push_greedy_inf_repeat(0, __s, __mexp_begin, __mexp_end);\x0a"
"            ++__first;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            _ForwardIterator __temp = __parse_Back_open_brace(__first, __last);\x0a"
"            if (__temp \x21= __first)\x0a"
"            {\x0a"
"                int __min = 0;\x0a"
"                __first = __temp;\x0a"
"                __temp = __parse_DUP_COUNT(__first, __last, __min);\x0a"
"                if (__temp == __first)\x0a"
"                    __throw_regex_error<regex_constants\x3a\x3a""error_badbrace>();\x0a"
"                __first = __temp;\x0a"
"                if (__first == __last)\x0a"
"                    __throw_regex_error<regex_constants\x3a\x3a""error_brace>();\x0a"
"                if (*__first \x21= ',')\x0a"
"                {\x0a"
"                    __temp = __parse_Back_close_brace(__first, __last);\x0a"
"                    if (__temp == __first)\x0a"
"                        __throw_regex_error<regex_constants\x3a\x3a""error_brace>();\x0a"
"                    __push_loop(__min, __min, __s, __mexp_begin, __mexp_end,\x0a"
"                                    true);\x0a"
"                    __first = __temp;\x0a"
"                }\x0a"
"                else\x0a"
"                {\x0a"
"                    ++__first;  // consume ','\x0a"
"                    int __max = -1;\x0a"
"                    __first = __parse_DUP_COUNT(__first, __last, __max);\x0a"
"                    __temp = __parse_Back_close_brace(__first, __last);\x0a"
"                    if (__temp == __first)\x0a"
"                        __throw_regex_error<regex_constants\x3a\x3a""error_brace>();\x0a"
"                    if (__max == -1)\x0a"
"                        __push_greedy_inf_repeat(__min, __s, __mexp_begin, __mexp_end);\x0a"
"                    else\x0a"
"                    {\x0a"
"                        if (__max < __min)\x0a"
"                            __throw_regex_error<regex_constants\x3a\x3a""error_badbrace>();\x0a"
"                        __push_loop(__min, __max, __s, __mexp_begin, __mexp_end,\x0a"
"                                    true);\x0a"
"                    }\x0a"
"                    __first = __temp;\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_ERE_dupl_symbol(_ForwardIterator __first,\x0a"
"                                                      _ForwardIterator __last,\x0a"
"                                                      __owns_one_state<_CharT>* __s,\x0a"
"                                                      unsigned __mexp_begin,\x0a"
"                                                      unsigned __mexp_end)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        unsigned __grammar = __get_grammar(__flags_);\x0a"
"        switch (*__first)\x0a"
"        {\x0a"
"        case '*'\x3a\x0a"
"            ++__first;\x0a"
"            if (__grammar == ECMAScript \x26\x26 __first \x21= __last \x26\x26 *__first == '\x3f')\x0a"
"            {\x0a"
"                ++__first;\x0a"
"                __push_nongreedy_inf_repeat(0, __s, __mexp_begin, __mexp_end);\x0a"
"            }\x0a"
"            else\x0a"
"                __push_greedy_inf_repeat(0, __s, __mexp_begin, __mexp_end);\x0a"
"            break;\x0a"
"        case '+'\x3a\x0a"
"            ++__first;\x0a"
"            if (__grammar == ECMAScript \x26\x26 __first \x21= __last \x26\x26 *__first == '\x3f')\x0a"
"            {\x0a"
"                ++__first;\x0a"
"                __push_nongreedy_inf_repeat(1, __s, __mexp_begin, __mexp_end);\x0a"
"            }\x0a"
"            else\x0a"
"                __push_greedy_inf_repeat(1, __s, __mexp_begin, __mexp_end);\x0a"
"            break;\x0a"
"        case '\x3f'\x3a\x0a"
"            ++__first;\x0a"
"            if (__grammar == ECMAScript \x26\x26 __first \x21= __last \x26\x26 *__first == '\x3f')\x0a"
"            {\x0a"
"                ++__first;\x0a"
"                __push_loop(0, 1, __s, __mexp_begin, __mexp_end, false);\x0a"
"            }\x0a"
"            else\x0a"
"                __push_loop(0, 1, __s, __mexp_begin, __mexp_end);\x0a"
"            break;\x0a"
"        case '{'\x3a\x0a"
"            {\x0a"
"                int __min;\x0a"
"                _ForwardIterator __temp = __parse_DUP_COUNT(++__first, __last, __min);\x0a"
"                if (__temp == __first)\x0a"
"                    __throw_regex_error<regex_constants\x3a\x3a""error_badbrace>();\x0a"
"                __first = __temp;\x0a"
"                if (__first == __last)\x0a"
"                    __throw_regex_error<regex_constants\x3a\x3a""error_brace>();\x0a"
"                switch (*__first)\x0a"
"                {\x0a"
"                case '}'\x3a\x0a"
"                    ++__first;\x0a"
"                    if (__grammar == ECMAScript \x26\x26 __first \x21= __last \x26\x26 *__first == '\x3f')\x0a"
"                    {\x0a"
"                        ++__first;\x0a"
"                        __push_loop(__min, __min, __s, __mexp_begin, __mexp_end, false);\x0a"
"                    }\x0a"
"                    else\x0a"
"                        __push_loop(__min, __min, __s, __mexp_begin, __mexp_end);\x0a"
"                    break;\x0a"
"                case ','\x3a\x0a"
"                    ++__first;\x0a"
"                    if (__first == __last)\x0a"
"                        __throw_regex_error<regex_constants\x3a\x3a""error_badbrace>();\x0a"
"                    if (*__first == '}')\x0a"
"                    {\x0a"
"                        ++__first;\x0a"
"                        if (__grammar == ECMAScript \x26\x26 __first \x21= __last \x26\x26 *__first == '\x3f')\x0a"
"                        {\x0a"
"                            ++__first;\x0a"
"                            __push_nongreedy_inf_repeat(__min, __s, __mexp_begin, __mexp_end);\x0a"
"                        }\x0a"
"                        else\x0a"
"                            __push_greedy_inf_repeat(__min, __s, __mexp_begin, __mexp_end);\x0a"
"                    }\x0a"
"                    else\x0a"
"                    {\x0a"
"                        int __max = -1;\x0a"
"                        __temp = __parse_DUP_COUNT(__first, __last, __max);\x0a"
"                        if (__temp == __first)\x0a"
"                            __throw_regex_error<regex_constants\x3a\x3a""error_brace>();\x0a"
"                        __first = __temp;\x0a"
"                        if (__first == __last \x7c\x7c *__first \x21= '}')\x0a"
"                            __throw_regex_error<regex_constants\x3a\x3a""error_brace>();\x0a"
"                        ++__first;\x0a"
"                        if (__max < __min)\x0a"
"                            __throw_regex_error<regex_constants\x3a\x3a""error_badbrace>();\x0a"
"                        if (__grammar == ECMAScript \x26\x26 __first \x21= __last \x26\x26 *__first == '\x3f')\x0a"
"                        {\x0a"
"                            ++__first;\x0a"
"                            __push_loop(__min, __max, __s, __mexp_begin, __mexp_end, false);\x0a"
"                        }\x0a"
"                        else\x0a"
"                            __push_loop(__min, __max, __s, __mexp_begin, __mexp_end);\x0a"
"                    }\x0a"
"                    break;\x0a"
"                default\x3a\x0a"
"                    __throw_regex_error<regex_constants\x3a\x3a""error_badbrace>();\x0a"
"                }\x0a"
"            }\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_bracket_expression(_ForwardIterator __first,\x0a"
"                                                         _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last \x26\x26 *__first == '\x5b')\x0a"
"    {\x0a"
"        ++__first;\x0a"
"        if (__first == __last)\x0a"
"            __throw_regex_error<regex_constants\x3a\x3a""error_brack>();\x0a"
"        bool __negate = false;\x0a"
"        if (*__first == '^')\x0a"
"        {\x0a"
"            ++__first;\x0a"
"            __negate = true;\x0a"
"        }\x0a"
"        __bracket_expression<_CharT, _Traits>* __ml = __start_matching_list(__negate);\x0a"
"        // __ml owned by *this\x0a"
"        if (__first == __last)\x0a"
"            __throw_regex_error<regex_constants\x3a\x3a""error_brack>();\x0a"
"        if (__get_grammar(__flags_) \x21= ECMAScript \x26\x26 *__first == '\x5d')\x0a"
"        {\x0a"
"            __ml->__add_char('\x5d');\x0a"
"            ++__first;\x0a"
"        }\x0a"
"        __first = __parse_follow_list(__first, __last, __ml);\x0a"
"        if (__first == __last)\x0a"
"            __throw_regex_error<regex_constants\x3a\x3a""error_brack>();\x0a"
"        if (*__first == '-')\x0a"
"        {\x0a"
"            __ml->__add_char('-');\x0a"
"            ++__first;\x0a"
"        }\x0a"
"        if (__first == __last \x7c\x7c *__first \x21= '\x5d')\x0a"
"            __throw_regex_error<regex_constants\x3a\x3a""error_brack>();\x0a"
"        ++__first;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_follow_list(_ForwardIterator __first,\x0a"
"                                    _ForwardIterator __last,\x0a"
"                                    __bracket_expression<_CharT, _Traits>* __ml)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        while (true)\x0a"
"        {\x0a"
"            _ForwardIterator __temp = __parse_expression_term(__first, __last,\x0a"
"                                                              __ml);\x0a"
"            if (__temp == __first)\x0a"
"                break;\x0a"
"            __first = __temp;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_expression_term(_ForwardIterator __first,\x0a"
"                                    _ForwardIterator __last,\x0a"
"                                    __bracket_expression<_CharT, _Traits>* __ml)\x0a"
"{\x0a"
"    if (__first \x21= __last \x26\x26 *__first \x21= '\x5d')\x0a"
"    {\x0a"
"        _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"        basic_string<_CharT> __start_range;\x0a"
"        if (__temp \x21= __last \x26\x26 *__first == '\x5b')\x0a"
"        {\x0a"
"            if (*__temp == '=')\x0a"
"                return __parse_equivalence_class(++__temp, __last, __ml);\x0a"
"            else if (*__temp == '\x3a')\x0a"
"                return __parse_character_class(++__temp, __last, __ml);\x0a"
"            else if (*__temp == '.')\x0a"
"                __first = __parse_collating_symbol(++__temp, __last, __start_range);\x0a"
"        }\x0a"
"        unsigned __grammar = __get_grammar(__flags_);\x0a"
"        if (__start_range.empty())\x0a"
"        {\x0a"
"            if ((__grammar == ECMAScript \x7c\x7c __grammar == awk) \x26\x26 *__first == '\x5c\x5c')\x0a"
"            {\x0a"
"                if (__grammar == ECMAScript)\x0a"
"                    __first = __parse_class_escape(++__first, __last, __start_range, __ml);\x0a"
"                else\x0a"
"                    __first = __parse_awk_escape(++__first, __last, \x26__start_range);\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                __start_range = *__first;\x0a"
"                ++__first;\x0a"
"            }\x0a"
"        }\x0a"
"        if (__first \x21= __last \x26\x26 *__first \x21= '\x5d')\x0a"
"        {\x0a"
"            __temp = _VSTD\x3a\x3anext(__first);\x0a"
"            if (__temp \x21= __last \x26\x26 *__first == '-' \x26\x26 *__temp \x21= '\x5d')\x0a"
"            {\x0a"
"                // parse a range\x0a"
"                basic_string<_CharT> __end_range;\x0a"
"                __first = __temp;\x0a"
"                ++__temp;\x0a"
"                if (__temp \x21= __last \x26\x26 *__first == '\x5b' \x26\x26 *__temp == '.')\x0a"
"                    __first = __parse_collating_symbol(++__temp, __last, __end_range);\x0a"
"                else\x0a"
"                {\x0a"
"                    if ((__grammar == ECMAScript \x7c\x7c __grammar == awk) \x26\x26 *__first == '\x5c\x5c')\x0a"
"                    {\x0a"
"                        if (__grammar == ECMAScript)\x0a"
"                            __first = __parse_class_escape(++__first, __last,\x0a"
"                                                           __end_range, __ml);\x0a"
"                        else\x0a"
"                            __first = __parse_awk_escape(++__first, __last,\x0a"
"                                                         \x26__end_range);\x0a"
"                    }\x0a"
"                    else\x0a"
"                    {\x0a"
"                        __end_range = *__first;\x0a"
"                        ++__first;\x0a"
"                    }\x0a"
"                }\x0a"
"                __ml->__add_range(_VSTD\x3a\x3amove(__start_range), _VSTD\x3a\x3amove(__end_range));\x0a"
"            }\x0a"
"            else if (\x21__start_range.empty())\x0a"
"            {\x0a"
"                if (__start_range.size() == 1)\x0a"
"                    __ml->__add_char(__start_range\x5b""0\x5d);\x0a"
"                else\x0a"
"                    __ml->__add_digraph(__start_range\x5b""0\x5d, __start_range\x5b""1\x5d);\x0a"
"            }\x0a"
"        }\x0a"
"        else if (\x21__start_range.empty())\x0a"
"        {\x0a"
"            if (__start_range.size() == 1)\x0a"
"                __ml->__add_char(__start_range\x5b""0\x5d);\x0a"
"            else\x0a"
"                __ml->__add_digraph(__start_range\x5b""0\x5d, __start_range\x5b""1\x5d);\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_class_escape(_ForwardIterator __first,\x0a"
"                          _ForwardIterator __last,\x0a"
"                          basic_string<_CharT>\x26 __str,\x0a"
"                          __bracket_expression<_CharT, _Traits>* __ml)\x0a"
"{\x0a"
"    if (__first == __last)\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"    switch (*__first)\x0a"
"    {\x0a"
"    case 0\x3a\x0a"
"        __str = *__first;\x0a"
"        return ++__first;\x0a"
"    case 'b'\x3a\x0a"
"        __str = _CharT(8);\x0a"
"        return ++__first;\x0a"
"    case 'd'\x3a\x0a"
"        __ml->__add_class(ctype_base\x3a\x3a""digit);\x0a"
"        return ++__first;\x0a"
"    case 'D'\x3a\x0a"
"        __ml->__add_neg_class(ctype_base\x3a\x3a""digit);\x0a"
"        return ++__first;\x0a"
"    case 's'\x3a\x0a"
"        __ml->__add_class(ctype_base\x3a\x3aspace);\x0a"
"        return ++__first;\x0a"
"    case 'S'\x3a\x0a"
"        __ml->__add_neg_class(ctype_base\x3a\x3aspace);\x0a"
"        return ++__first;\x0a"
"    case 'w'\x3a\x0a"
"        __ml->__add_class(ctype_base\x3a\x3a""alnum);\x0a"
"        __ml->__add_char('_');\x0a"
"        return ++__first;\x0a"
"    case 'W'\x3a\x0a"
"        __ml->__add_neg_class(ctype_base\x3a\x3a""alnum);\x0a"
"        __ml->__add_neg_char('_');\x0a"
"        return ++__first;\x0a"
"    }\x0a"
"    __first = __parse_character_escape(__first, __last, \x26__str);\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_awk_escape(_ForwardIterator __first,\x0a"
"                          _ForwardIterator __last,\x0a"
"                          basic_string<_CharT>* __str)\x0a"
"{\x0a"
"    if (__first == __last)\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"    switch (*__first)\x0a"
"    {\x0a"
"    case '\x5c\x5c'\x3a\x0a"
"    case '\x22'\x3a\x0a"
"    case '/'\x3a\x0a"
"        if (__str)\x0a"
"            *__str = *__first;\x0a"
"        else\x0a"
"            __push_char(*__first);\x0a"
"        return ++__first;\x0a"
"    case 'a'\x3a\x0a"
"        if (__str)\x0a"
"            *__str = _CharT(7);\x0a"
"        else\x0a"
"            __push_char(_CharT(7));\x0a"
"        return ++__first;\x0a"
"    case 'b'\x3a\x0a"
"        if (__str)\x0a"
"            *__str = _CharT(8);\x0a"
"        else\x0a"
"            __push_char(_CharT(8));\x0a"
"        return ++__first;\x0a"
"    case 'f'\x3a\x0a"
"        if (__str)\x0a"
"            *__str = _CharT(0xC);\x0a"
"        else\x0a"
"            __push_char(_CharT(0xC));\x0a"
"        return ++__first;\x0a"
"    case 'n'\x3a\x0a"
"        if (__str)\x0a"
"            *__str = _CharT(0xA);\x0a"
"        else\x0a"
"            __push_char(_CharT(0xA));\x0a"
"        return ++__first;\x0a"
"    case 'r'\x3a\x0a"
"        if (__str)\x0a"
"            *__str = _CharT(0xD);\x0a"
"        else\x0a"
"            __push_char(_CharT(0xD));\x0a"
"        return ++__first;\x0a"
"    case 't'\x3a\x0a"
"        if (__str)\x0a"
"            *__str = _CharT(0x9);\x0a"
"        else\x0a"
"            __push_char(_CharT(0x9));\x0a"
"        return ++__first;\x0a"
"    case 'v'\x3a\x0a"
"        if (__str)\x0a"
"            *__str = _CharT(0xB);\x0a"
"        else\x0a"
"            __push_char(_CharT(0xB));\x0a"
"        return ++__first;\x0a"
"    }\x0a"
"    if ('0' <= *__first \x26\x26 *__first <= '7')\x0a"
"    {\x0a"
"        unsigned __val = *__first - '0';\x0a"
"        if (++__first \x21= __last \x26\x26 ('0' <= *__first \x26\x26 *__first <= '7'))\x0a"
"        {\x0a"
"            __val = 8 * __val + *__first - '0';\x0a"
"            if (++__first \x21= __last \x26\x26 ('0' <= *__first \x26\x26 *__first <= '7'))\x0a"
"                __val = 8 * __val + *__first++ - '0';\x0a"
"        }\x0a"
"        if (__str)\x0a"
"            *__str = _CharT(__val);\x0a"
"        else\x0a"
"            __push_char(_CharT(__val));\x0a"
"    }\x0a"
"    else\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_equivalence_class(_ForwardIterator __first,\x0a"
"                                    _ForwardIterator __last,\x0a"
"                                    __bracket_expression<_CharT, _Traits>* __ml)\x0a"
"{\x0a"
"    // Found \x5b=\x0a"
"    //   This means =\x5d must exist\x0a"
"    value_type _Equal_close\x5b""2\x5d = {'=', '\x5d'};\x0a"
"    _ForwardIterator __temp = _VSTD\x3a\x3asearch(__first, __last, _Equal_close,\x0a"
"                                                            _Equal_close+2);\x0a"
"    if (__temp == __last)\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a""error_brack>();\x0a"
"    // \x5b__first, __temp) contains all text in \x5b= ... =\x5d\x0a"
"    string_type __collate_name =\x0a"
"        __traits_.lookup_collatename(__first, __temp);\x0a"
"    if (__collate_name.empty())\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a""error_collate>();\x0a"
"    string_type __equiv_name =\x0a"
"        __traits_.transform_primary(__collate_name.begin(),\x0a"
"                                    __collate_name.end());\x0a"
"    if (\x21__equiv_name.empty())\x0a"
"        __ml->__add_equivalence(__equiv_name);\x0a"
"    else\x0a"
"    {\x0a"
"        switch (__collate_name.size())\x0a"
"        {\x0a"
"        case 1\x3a\x0a"
"            __ml->__add_char(__collate_name\x5b""0\x5d);\x0a"
"            break;\x0a"
"        case 2\x3a\x0a"
"            __ml->__add_digraph(__collate_name\x5b""0\x5d, __collate_name\x5b""1\x5d);\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            __throw_regex_error<regex_constants\x3a\x3a""error_collate>();\x0a"
"        }\x0a"
"    }\x0a"
"    __first = _VSTD\x3a\x3anext(__temp, 2);\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_character_class(_ForwardIterator __first,\x0a"
"                                    _ForwardIterator __last,\x0a"
"                                    __bracket_expression<_CharT, _Traits>* __ml)\x0a"
"{\x0a"
"    // Found \x5b\x3a\x0a"
"    //   This means \x3a\x5d must exist\x0a"
"    value_type _Colon_close\x5b""2\x5d = {'\x3a', '\x5d'};\x0a"
"    _ForwardIterator __temp = _VSTD\x3a\x3asearch(__first, __last, _Colon_close,\x0a"
"                                                            _Colon_close+2);\x0a"
"    if (__temp == __last)\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a""error_brack>();\x0a"
"    // \x5b__first, __temp) contains all text in \x5b\x3a ... \x3a\x5d\x0a"
"    typedef typename _Traits\x3a\x3a""char_class_type char_class_type;\x0a"
"    char_class_type __class_type =\x0a"
"        __traits_.lookup_classname(__first, __temp, __flags_ \x26 icase);\x0a"
"    if (__class_type == 0)\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a""error_ctype>();\x0a"
"    __ml->__add_class(__class_type);\x0a"
"    __first = _VSTD\x3a\x3anext(__temp, 2);\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_collating_symbol(_ForwardIterator __first,\x0a"
"                                                _ForwardIterator __last,\x0a"
"                                                basic_string<_CharT>\x26 __col_sym)\x0a"
"{\x0a"
"    // Found \x5b.\x0a"
"    //   This means .\x5d must exist\x0a"
"    value_type _Dot_close\x5b""2\x5d = {'.', '\x5d'};\x0a"
"    _ForwardIterator __temp = _VSTD\x3a\x3asearch(__first, __last, _Dot_close,\x0a"
"                                                            _Dot_close+2);\x0a"
"    if (__temp == __last)\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a""error_brack>();\x0a"
"    // \x5b__first, __temp) contains all text in \x5b. ... .\x5d\x0a"
"    __col_sym = __traits_.lookup_collatename(__first, __temp);\x0a"
"    switch (__col_sym.size())\x0a"
"    {\x0a"
"    case 1\x3a\x0a"
"    case 2\x3a\x0a"
"        break;\x0a"
"    default\x3a\x0a"
"        __throw_regex_error<regex_constants\x3a\x3a""error_collate>();\x0a"
"    }\x0a"
"    __first = _VSTD\x3a\x3anext(__temp, 2);\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_DUP_COUNT(_ForwardIterator __first,\x0a"
"                                                _ForwardIterator __last,\x0a"
"                                                int\x26 __c)\x0a"
"{\x0a"
"    if (__first \x21= __last )\x0a"
"    {\x0a"
"        int __val = __traits_.value(*__first, 10);\x0a"
"        if ( __val \x21= -1 )\x0a"
"        {\x0a"
"            __c = __val;\x0a"
"            for (++__first;\x0a"
"                 __first \x21= __last \x26\x26 ( __val = __traits_.value(*__first, 10)) \x21= -1;\x0a"
"                 ++__first)\x0a"
"            {\x0a"
"                if (__c >= std\x3a\x3anumeric_limits<int>\x3a\x3amax() / 10)\x0a"
"                    __throw_regex_error<regex_constants\x3a\x3a""error_badbrace>();\x0a"
"                __c *= 10;\x0a"
"                __c += __val;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_ecma_exp(_ForwardIterator __first,\x0a"
"                                               _ForwardIterator __last)\x0a"
"{\x0a"
"    __owns_one_state<_CharT>* __sa = __end_;\x0a"
"    _ForwardIterator __temp = __parse_alternative(__first, __last);\x0a"
"    if (__temp == __first)\x0a"
"        __push_empty();\x0a"
"    __first = __temp;\x0a"
"    while (__first \x21= __last \x26\x26 *__first == '\x7c')\x0a"
"    {\x0a"
"        __owns_one_state<_CharT>* __sb = __end_;\x0a"
"        __temp = __parse_alternative(++__first, __last);\x0a"
"        if (__temp == __first)\x0a"
"            __push_empty();\x0a"
"        __push_alternation(__sa, __sb);\x0a"
"        __first = __temp;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_alternative(_ForwardIterator __first,\x0a"
"                                                  _ForwardIterator __last)\x0a"
"{\x0a"
"    while (true)\x0a"
"    {\x0a"
"        _ForwardIterator __temp = __parse_term(__first, __last);\x0a"
"        if (__temp == __first)\x0a"
"            break;\x0a"
"        __first = __temp;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_term(_ForwardIterator __first,\x0a"
"                                           _ForwardIterator __last)\x0a"
"{\x0a"
"    _ForwardIterator __temp = __parse_assertion(__first, __last);\x0a"
"    if (__temp == __first)\x0a"
"    {\x0a"
"        __owns_one_state<_CharT>* __e = __end_;\x0a"
"        unsigned __mexp_begin = __marked_count_;\x0a"
"        __temp = __parse_atom(__first, __last);\x0a"
"        if (__temp \x21= __first)\x0a"
"            __first = __parse_ERE_dupl_symbol(__temp, __last, __e,\x0a"
"                                              __mexp_begin+1, __marked_count_+1);\x0a"
"    }\x0a"
"    else\x0a"
"        __first = __temp;\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_assertion(_ForwardIterator __first,\x0a"
"                                                _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        switch (*__first)\x0a"
"        {\x0a"
"        case '^'\x3a\x0a"
"            __push_l_anchor();\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case '\x24'\x3a\x0a"
"            __push_r_anchor();\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case '\x5c\x5c'\x3a\x0a"
"            {\x0a"
"                _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"                if (__temp \x21= __last)\x0a"
"                {\x0a"
"                    if (*__temp == 'b')\x0a"
"                    {\x0a"
"                        __push_word_boundary(false);\x0a"
"                        __first = ++__temp;\x0a"
"                    }\x0a"
"                    else if (*__temp == 'B')\x0a"
"                    {\x0a"
"                        __push_word_boundary(true);\x0a"
"                        __first = ++__temp;\x0a"
"                    }\x0a"
"                }\x0a"
"            }\x0a"
"            break;\x0a"
"        case '('\x3a\x0a"
"            {\x0a"
"                _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"                if (__temp \x21= __last \x26\x26 *__temp == '\x3f')\x0a"
"                {\x0a"
"                    if (++__temp \x21= __last)\x0a"
"                    {\x0a"
"                        switch (*__temp)\x0a"
"                        {\x0a"
"                        case '='\x3a\x0a"
"                            {\x0a"
"                                basic_regex __exp;\x0a"
"                                __exp.__flags_ = __flags_;\x0a"
"                                __temp = __exp.__parse(++__temp, __last);\x0a"
"                                unsigned __mexp = __exp.__marked_count_;\x0a"
"                                __push_lookahead(_VSTD\x3a\x3amove(__exp), false, __marked_count_);\x0a"
"                                __marked_count_ += __mexp;\x0a"
"                                if (__temp == __last \x7c\x7c *__temp \x21= ')')\x0a"
"                                    __throw_regex_error<regex_constants\x3a\x3a""error_paren>();\x0a"
"                                __first = ++__temp;\x0a"
"                            }\x0a"
"                            break;\x0a"
"                        case '\x21'\x3a\x0a"
"                            {\x0a"
"                                basic_regex __exp;\x0a"
"                                __exp.__flags_ = __flags_;\x0a"
"                                __temp = __exp.__parse(++__temp, __last);\x0a"
"                                unsigned __mexp = __exp.__marked_count_;\x0a"
"                                __push_lookahead(_VSTD\x3a\x3amove(__exp), true, __marked_count_);\x0a"
"                                __marked_count_ += __mexp;\x0a"
"                                if (__temp == __last \x7c\x7c *__temp \x21= ')')\x0a"
"                                    __throw_regex_error<regex_constants\x3a\x3a""error_paren>();\x0a"
"                                __first = ++__temp;\x0a"
"                            }\x0a"
"                            break;\x0a"
"                        }\x0a"
"                    }\x0a"
"                }\x0a"
"            }\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_atom(_ForwardIterator __first,\x0a"
"                                           _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        switch (*__first)\x0a"
"        {\x0a"
"        case '.'\x3a\x0a"
"            __push_match_any_but_newline();\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case '\x5c\x5c'\x3a\x0a"
"            __first = __parse_atom_escape(__first, __last);\x0a"
"            break;\x0a"
"        case '\x5b'\x3a\x0a"
"            __first = __parse_bracket_expression(__first, __last);\x0a"
"            break;\x0a"
"        case '('\x3a\x0a"
"            {\x0a"
"                ++__first;\x0a"
"                if (__first == __last)\x0a"
"                    __throw_regex_error<regex_constants\x3a\x3a""error_paren>();\x0a"
"                _ForwardIterator __temp = _VSTD\x3a\x3anext(__first);\x0a"
"                if (__temp \x21= __last \x26\x26 *__first == '\x3f' \x26\x26 *__temp == '\x3a')\x0a"
"                {\x0a"
"                    ++__open_count_;\x0a"
"                    __first = __parse_ecma_exp(++__temp, __last);\x0a"
"                    if (__first == __last \x7c\x7c *__first \x21= ')')\x0a"
"                        __throw_regex_error<regex_constants\x3a\x3a""error_paren>();\x0a"
"                    --__open_count_;\x0a"
"                    ++__first;\x0a"
"                }\x0a"
"                else\x0a"
"                {\x0a"
"                    __push_begin_marked_subexpression();\x0a"
"                    unsigned __temp_count = __marked_count_;\x0a"
"                    ++__open_count_;\x0a"
"                    __first = __parse_ecma_exp(__first, __last);\x0a"
"                    if (__first == __last \x7c\x7c *__first \x21= ')')\x0a"
"                        __throw_regex_error<regex_constants\x3a\x3a""error_paren>();\x0a"
"                    __push_end_marked_subexpression(__temp_count);\x0a"
"                    --__open_count_;\x0a"
"                    ++__first;\x0a"
"                }\x0a"
"            }\x0a"
"            break;\x0a"
"        case '*'\x3a\x0a"
"        case '+'\x3a\x0a"
"        case '\x3f'\x3a\x0a"
"        case '{'\x3a\x0a"
"            __throw_regex_error<regex_constants\x3a\x3a""error_badrepeat>();\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            __first = __parse_pattern_character(__first, __last);\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_atom_escape(_ForwardIterator __first,\x0a"
"                                                  _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last \x26\x26 *__first == '\x5c\x5c')\x0a"
"    {\x0a"
"        _ForwardIterator __t1 = _VSTD\x3a\x3anext(__first);\x0a"
"        if (__t1 == __last)\x0a"
"            __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"\x0a"
"        _ForwardIterator __t2 = __parse_decimal_escape(__t1, __last);\x0a"
"        if (__t2 \x21= __t1)\x0a"
"            __first = __t2;\x0a"
"        else\x0a"
"        {\x0a"
"            __t2 = __parse_character_class_escape(__t1, __last);\x0a"
"            if (__t2 \x21= __t1)\x0a"
"                __first = __t2;\x0a"
"            else\x0a"
"            {\x0a"
"                __t2 = __parse_character_escape(__t1, __last);\x0a"
"                if (__t2 \x21= __t1)\x0a"
"                    __first = __t2;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_decimal_escape(_ForwardIterator __first,\x0a"
"                                                     _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        if (*__first == '0')\x0a"
"        {\x0a"
"            __push_char(_CharT());\x0a"
"            ++__first;\x0a"
"        }\x0a"
"        else if ('1' <= *__first \x26\x26 *__first <= '9')\x0a"
"        {\x0a"
"            unsigned __v = *__first - '0';\x0a"
"            for (++__first;\x0a"
"                    __first \x21= __last \x26\x26 '0' <= *__first \x26\x26 *__first <= '9'; ++__first)\x0a"
"                {\x0a"
"                if (__v >= std\x3a\x3anumeric_limits<unsigned>\x3a\x3amax() / 10)\x0a"
"                    __throw_regex_error<regex_constants\x3a\x3a""error_backref>();\x0a"
"                __v = 10 * __v + *__first - '0';\x0a"
"                }\x0a"
"            if (__v == 0 \x7c\x7c __v > mark_count())\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_backref>();\x0a"
"            __push_back_ref(__v);\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_character_class_escape(_ForwardIterator __first,\x0a"
"                                                             _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        __bracket_expression<_CharT, _Traits>* __ml;\x0a"
"        switch (*__first)\x0a"
"        {\x0a"
"        case 'd'\x3a\x0a"
"            __ml = __start_matching_list(false);\x0a"
"            __ml->__add_class(ctype_base\x3a\x3a""digit);\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case 'D'\x3a\x0a"
"            __ml = __start_matching_list(true);\x0a"
"            __ml->__add_class(ctype_base\x3a\x3a""digit);\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case 's'\x3a\x0a"
"            __ml = __start_matching_list(false);\x0a"
"            __ml->__add_class(ctype_base\x3a\x3aspace);\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case 'S'\x3a\x0a"
"            __ml = __start_matching_list(true);\x0a"
"            __ml->__add_class(ctype_base\x3a\x3aspace);\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case 'w'\x3a\x0a"
"            __ml = __start_matching_list(false);\x0a"
"            __ml->__add_class(ctype_base\x3a\x3a""alnum);\x0a"
"            __ml->__add_char('_');\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case 'W'\x3a\x0a"
"            __ml = __start_matching_list(true);\x0a"
"            __ml->__add_class(ctype_base\x3a\x3a""alnum);\x0a"
"            __ml->__add_char('_');\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_character_escape(_ForwardIterator __first,\x0a"
"                                                    _ForwardIterator __last,\x0a"
"                                                    basic_string<_CharT>* __str)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        _ForwardIterator __t;\x0a"
"        unsigned __sum = 0;\x0a"
"        int __hd;\x0a"
"        switch (*__first)\x0a"
"        {\x0a"
"        case 'f'\x3a\x0a"
"            if (__str)\x0a"
"                *__str = _CharT(0xC);\x0a"
"            else\x0a"
"                __push_char(_CharT(0xC));\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case 'n'\x3a\x0a"
"            if (__str)\x0a"
"                *__str = _CharT(0xA);\x0a"
"            else\x0a"
"                __push_char(_CharT(0xA));\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case 'r'\x3a\x0a"
"            if (__str)\x0a"
"                *__str = _CharT(0xD);\x0a"
"            else\x0a"
"                __push_char(_CharT(0xD));\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case 't'\x3a\x0a"
"            if (__str)\x0a"
"                *__str = _CharT(0x9);\x0a"
"            else\x0a"
"                __push_char(_CharT(0x9));\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case 'v'\x3a\x0a"
"            if (__str)\x0a"
"                *__str = _CharT(0xB);\x0a"
"            else\x0a"
"                __push_char(_CharT(0xB));\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case 'c'\x3a\x0a"
"            if ((__t = _VSTD\x3a\x3anext(__first)) \x21= __last)\x0a"
"            {\x0a"
"                if (('A' <= *__t \x26\x26 *__t <= 'Z') \x7c\x7c\x0a"
"                    ('a' <= *__t \x26\x26 *__t <= 'z'))\x0a"
"                {\x0a"
"                    if (__str)\x0a"
"                        *__str = _CharT(*__t \x25 32);\x0a"
"                    else\x0a"
"                        __push_char(_CharT(*__t \x25 32));\x0a"
"                    __first = ++__t;\x0a"
"                }\x0a"
"                else\x0a"
"                    __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            }\x0a"
"            else\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            break;\x0a"
"        case 'u'\x3a\x0a"
"            ++__first;\x0a"
"            if (__first == __last)\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            __hd = __traits_.value(*__first, 16);\x0a"
"            if (__hd == -1)\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            __sum = 16 * __sum + static_cast<unsigned>(__hd);\x0a"
"            ++__first;\x0a"
"            if (__first == __last)\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            __hd = __traits_.value(*__first, 16);\x0a"
"            if (__hd == -1)\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            __sum = 16 * __sum + static_cast<unsigned>(__hd);\x0a"
"            // drop through\x0a"
"        case 'x'\x3a\x0a"
"            ++__first;\x0a"
"            if (__first == __last)\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            __hd = __traits_.value(*__first, 16);\x0a"
"            if (__hd == -1)\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            __sum = 16 * __sum + static_cast<unsigned>(__hd);\x0a"
"            ++__first;\x0a"
"            if (__first == __last)\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            __hd = __traits_.value(*__first, 16);\x0a"
"            if (__hd == -1)\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            __sum = 16 * __sum + static_cast<unsigned>(__hd);\x0a"
"            if (__str)\x0a"
"                *__str = _CharT(__sum);\x0a"
"            else\x0a"
"                __push_char(_CharT(__sum));\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        case '0'\x3a\x0a"
"            if (__str)\x0a"
"                *__str = _CharT(0);\x0a"
"            else\x0a"
"                __push_char(_CharT(0));\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            if (*__first \x21= '_' \x26\x26 \x21__traits_.isctype(*__first, ctype_base\x3a\x3a""alnum))\x0a"
"            {\x0a"
"                if (__str)\x0a"
"                    *__str = *__first;\x0a"
"                else\x0a"
"                    __push_char(*__first);\x0a"
"                ++__first;\x0a"
"            }\x0a"
"            else\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_pattern_character(_ForwardIterator __first,\x0a"
"                                                        _ForwardIterator __last)\x0a"
"{\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"        switch (*__first)\x0a"
"        {\x0a"
"        case '^'\x3a\x0a"
"        case '\x24'\x3a\x0a"
"        case '\x5c\x5c'\x3a\x0a"
"        case '.'\x3a\x0a"
"        case '*'\x3a\x0a"
"        case '+'\x3a\x0a"
"        case '\x3f'\x3a\x0a"
"        case '('\x3a\x0a"
"        case ')'\x3a\x0a"
"        case '\x5b'\x3a\x0a"
"        case '\x5d'\x3a\x0a"
"        case '{'\x3a\x0a"
"        case '}'\x3a\x0a"
"        case '\x7c'\x3a\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            __push_char(*__first);\x0a"
"            ++__first;\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_grep(_ForwardIterator __first,\x0a"
"                                           _ForwardIterator __last)\x0a"
"{\x0a"
"    __owns_one_state<_CharT>* __sa = __end_;\x0a"
"    _ForwardIterator __t1 = _VSTD\x3a\x3a""find(__first, __last, _CharT('\x5cn'));\x0a"
"    if (__t1 \x21= __first)\x0a"
"        __parse_basic_reg_exp(__first, __t1);\x0a"
"    else\x0a"
"        __push_empty();\x0a"
"    __first = __t1;\x0a"
"    if (__first \x21= __last)\x0a"
"        ++__first;\x0a"
"    while (__first \x21= __last)\x0a"
"    {\x0a"
"        __t1 = _VSTD\x3a\x3a""find(__first, __last, _CharT('\x5cn'));\x0a"
"        __owns_one_state<_CharT>* __sb = __end_;\x0a"
"        if (__t1 \x21= __first)\x0a"
"            __parse_basic_reg_exp(__first, __t1);\x0a"
"        else\x0a"
"            __push_empty();\x0a"
"        __push_alternation(__sa, __sb);\x0a"
"        __first = __t1;\x0a"
"        if (__first \x21= __last)\x0a"
"            ++__first;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _ForwardIterator>\x0a"
"_ForwardIterator\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__parse_egrep(_ForwardIterator __first,\x0a"
"                                            _ForwardIterator __last)\x0a"
"{\x0a"
"    __owns_one_state<_CharT>* __sa = __end_;\x0a"
"    _ForwardIterator __t1 = _VSTD\x3a\x3a""find(__first, __last, _CharT('\x5cn'));\x0a"
"    if (__t1 \x21= __first)\x0a"
"        __parse_extended_reg_exp(__first, __t1);\x0a"
"    else\x0a"
"        __push_empty();\x0a"
"    __first = __t1;\x0a"
"    if (__first \x21= __last)\x0a"
"        ++__first;\x0a"
"    while (__first \x21= __last)\x0a"
"    {\x0a"
"        __t1 = _VSTD\x3a\x3a""find(__first, __last, _CharT('\x5cn'));\x0a"
"        __owns_one_state<_CharT>* __sb = __end_;\x0a"
"        if (__t1 \x21= __first)\x0a"
"            __parse_extended_reg_exp(__first, __t1);\x0a"
"        else\x0a"
"            __push_empty();\x0a"
"        __push_alternation(__sa, __sb);\x0a"
"        __first = __t1;\x0a"
"        if (__first \x21= __last)\x0a"
"            ++__first;\x0a"
"    }\x0a"
"    return __first;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_loop(size_t __min, size_t __max,\x0a"
"        __owns_one_state<_CharT>* __s, size_t __mexp_begin, size_t __mexp_end,\x0a"
"        bool __greedy)\x0a"
"{\x0a"
"    unique_ptr<__empty_state<_CharT> > __e1(new __empty_state<_CharT>(__end_->first()));\x0a"
"    __end_->first() = nullptr;\x0a"
"    unique_ptr<__loop<_CharT> > __e2(new __loop<_CharT>(__loop_count_,\x0a"
"                __s->first(), __e1.get(), __mexp_begin, __mexp_end, __greedy,\x0a"
"                __min, __max));\x0a"
"    __s->first() = nullptr;\x0a"
"    __e1.release();\x0a"
"    __end_->first() = new __repeat_one_loop<_CharT>(__e2.get());\x0a"
"    __end_ = __e2->second();\x0a"
"    __s->first() = __e2.release();\x0a"
"    ++__loop_count_;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_char(value_type __c)\x0a"
"{\x0a"
"    if (flags() \x26 icase)\x0a"
"        __end_->first() = new __match_char_icase<_CharT, _Traits>\x0a"
"                                              (__traits_, __c, __end_->first());\x0a"
"    else if (flags() \x26 collate)\x0a"
"        __end_->first() = new __match_char_collate<_CharT, _Traits>\x0a"
"                                              (__traits_, __c, __end_->first());\x0a"
"    else\x0a"
"        __end_->first() = new __match_char<_CharT>(__c, __end_->first());\x0a"
"    __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_begin_marked_subexpression()\x0a"
"{\x0a"
"    if (\x21(__flags_ \x26 nosubs))\x0a"
"    {\x0a"
"        __end_->first() =\x0a"
"                new __begin_marked_subexpression<_CharT>(++__marked_count_,\x0a"
"                                                         __end_->first());\x0a"
"        __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_end_marked_subexpression(unsigned __sub)\x0a"
"{\x0a"
"    if (\x21(__flags_ \x26 nosubs))\x0a"
"    {\x0a"
"        __end_->first() =\x0a"
"                new __end_marked_subexpression<_CharT>(__sub, __end_->first());\x0a"
"        __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_l_anchor()\x0a"
"{\x0a"
"    __end_->first() = new __l_anchor<_CharT>(__end_->first());\x0a"
"    __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_r_anchor()\x0a"
"{\x0a"
"    __end_->first() = new __r_anchor<_CharT>(__end_->first());\x0a"
"    __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_match_any()\x0a"
"{\x0a"
"    __end_->first() = new __match_any<_CharT>(__end_->first());\x0a"
"    __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_match_any_but_newline()\x0a"
"{\x0a"
"    __end_->first() = new __match_any_but_newline<_CharT>(__end_->first());\x0a"
"    __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_empty()\x0a"
"{\x0a"
"    __end_->first() = new __empty_state<_CharT>(__end_->first());\x0a"
"    __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_word_boundary(bool __invert)\x0a"
"{\x0a"
"    __end_->first() = new __word_boundary<_CharT, _Traits>(__traits_, __invert,\x0a"
"                                                           __end_->first());\x0a"
"    __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_back_ref(int __i)\x0a"
"{\x0a"
"    if (flags() \x26 icase)\x0a"
"        __end_->first() = new __back_ref_icase<_CharT, _Traits>\x0a"
"                                              (__traits_, __i, __end_->first());\x0a"
"    else if (flags() \x26 collate)\x0a"
"        __end_->first() = new __back_ref_collate<_CharT, _Traits>\x0a"
"                                              (__traits_, __i, __end_->first());\x0a"
"    else\x0a"
"        __end_->first() = new __back_ref<_CharT>(__i, __end_->first());\x0a"
"    __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_alternation(__owns_one_state<_CharT>* __sa,\x0a"
"                                                 __owns_one_state<_CharT>* __ea)\x0a"
"{\x0a"
"    __sa->first() = new __alternate<_CharT>(\x0a"
"                         static_cast<__owns_one_state<_CharT>*>(__sa->first()),\x0a"
"                         static_cast<__owns_one_state<_CharT>*>(__ea->first()));\x0a"
"    __ea->first() = nullptr;\x0a"
"    __ea->first() = new __empty_state<_CharT>(__end_->first());\x0a"
"    __end_->first() = nullptr;\x0a"
"    __end_->first() = new __empty_non_own_state<_CharT>(__ea->first());\x0a"
"    __end_ = static_cast<__owns_one_state<_CharT>*>(__ea->first());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"__bracket_expression<_CharT, _Traits>*\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__start_matching_list(bool __negate)\x0a"
"{\x0a"
"    __bracket_expression<_CharT, _Traits>* __r =\x0a"
"        new __bracket_expression<_CharT, _Traits>(__traits_, __end_->first(),\x0a"
"                                                  __negate, __flags_ \x26 icase,\x0a"
"                                                  __flags_ \x26 collate);\x0a"
"    __end_->first() = __r;\x0a"
"    __end_ = __r;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"void\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__push_lookahead(const basic_regex\x26 __exp,\x0a"
"                                               bool __invert,\x0a"
"                                               unsigned __mexp)\x0a"
"{\x0a"
"    __end_->first() = new __lookahead<_CharT, _Traits>(__exp, __invert,\x0a"
"                                                           __end_->first(), __mexp);\x0a"
"    __end_ = static_cast<__owns_one_state<_CharT>*>(__end_->first());\x0a"
"}\x0a"
"\x0a"
"typedef basic_regex<char>    regex;\x0a"
"typedef basic_regex<wchar_t> wregex;\x0a"
"\x0a"
"// sub_match\x0a"
"\x0a"
"template <class _BidirectionalIterator>\x0a"
"class _LIBCPP_TEMPLATE_VIS sub_match\x0a"
"    \x3a public pair<_BidirectionalIterator, _BidirectionalIterator>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _BidirectionalIterator                              iterator;\x0a"
"    typedef typename iterator_traits<iterator>\x3a\x3avalue_type      value_type;\x0a"
"    typedef typename iterator_traits<iterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef basic_string<value_type>                            string_type;\x0a"
"\x0a"
"    bool matched;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _LIBCPP_CONSTEXPR sub_match() \x3a matched() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    difference_type length() const\x0a"
"        {return matched \x3f _VSTD\x3a\x3a""distance(this->first, this->second) \x3a 0;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    string_type str() const\x0a"
"        {return matched \x3f string_type(this->first, this->second) \x3a string_type();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator string_type() const\x0a"
"        {return str();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int compare(const sub_match\x26 __s) const\x0a"
"        {return str().compare(__s.str());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int compare(const string_type\x26 __s) const\x0a"
"        {return str().compare(__s);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int compare(const value_type* __s) const\x0a"
"        {return str().compare(__s);}\x0a"
"};\x0a"
"\x0a"
"typedef sub_match<const char*>             csub_match;\x0a"
"typedef sub_match<const wchar_t*>          wcsub_match;\x0a"
"typedef sub_match<string\x3a\x3a""const_iterator>  ssub_match;\x0a"
"typedef sub_match<wstring\x3a\x3a""const_iterator> wssub_match;\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const sub_match<_BiIter>\x26 __x, const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return __x.compare(__y) == 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const sub_match<_BiIter>\x26 __x, const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(const sub_match<_BiIter>\x26 __x, const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return __x.compare(__y) < 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const sub_match<_BiIter>\x26 __x, const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const sub_match<_BiIter>\x26 __x, const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(const sub_match<_BiIter>\x26 __x, const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return __y.compare(typename sub_match<_BiIter>\x3a\x3astring_type(__x.data(), __x.size())) == 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __x,\x0a"
"          const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return __y.compare(typename sub_match<_BiIter>\x3a\x3astring_type(__x.data(), __x.size())) > 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __x,\x0a"
"          const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator>=(const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __x,\x0a"
"                const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const sub_match<_BiIter>\x26 __x,\x0a"
"           const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __y)\x0a"
"{\x0a"
"    return __x.compare(typename sub_match<_BiIter>\x3a\x3astring_type(__y.data(), __y.size())) == 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const sub_match<_BiIter>\x26 __x,\x0a"
"           const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(const sub_match<_BiIter>\x26 __x,\x0a"
"          const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __y)\x0a"
"{\x0a"
"    return __x.compare(typename sub_match<_BiIter>\x3a\x3astring_type(__y.data(), __y.size())) < 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator>(const sub_match<_BiIter>\x26 __x,\x0a"
"               const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const sub_match<_BiIter>\x26 __x,\x0a"
"           const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const sub_match<_BiIter>\x26 __x,\x0a"
"           const basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type, _ST, _SA>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return __y.compare(__x) == 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __x,\x0a"
"          const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return __y.compare(__x) > 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __x,\x0a"
"          const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const sub_match<_BiIter>\x26 __x,\x0a"
"           typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __y)\x0a"
"{\x0a"
"    return __x.compare(__y) == 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const sub_match<_BiIter>\x26 __x,\x0a"
"           typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(const sub_match<_BiIter>\x26 __x,\x0a"
"          typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __y)\x0a"
"{\x0a"
"    return __x.compare(__y) < 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(const sub_match<_BiIter>\x26 __x,\x0a"
"          typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const sub_match<_BiIter>\x26 __x,\x0a"
"           typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const sub_match<_BiIter>\x26 __x,\x0a"
"           typename iterator_traits<_BiIter>\x3a\x3avalue_type const* __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    typedef basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type> string_type;\x0a"
"    return __y.compare(string_type(1, __x)) == 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __x,\x0a"
"          const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    typedef basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type> string_type;\x0a"
"    return __y.compare(string_type(1, __x)) > 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __x,\x0a"
"          const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __x,\x0a"
"           const sub_match<_BiIter>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const sub_match<_BiIter>\x26 __x,\x0a"
"           typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __y)\x0a"
"{\x0a"
"    typedef basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type> string_type;\x0a"
"    return __x.compare(string_type(1, __y)) == 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const sub_match<_BiIter>\x26 __x,\x0a"
"           typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<(const sub_match<_BiIter>\x26 __x,\x0a"
"          typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __y)\x0a"
"{\x0a"
"    typedef basic_string<typename iterator_traits<_BiIter>\x3a\x3avalue_type> string_type;\x0a"
"    return __x.compare(string_type(1, __y)) < 0;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>(const sub_match<_BiIter>\x26 __x,\x0a"
"          typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const sub_match<_BiIter>\x26 __x,\x0a"
"           typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const sub_match<_BiIter>\x26 __x,\x0a"
"           typename iterator_traits<_BiIter>\x3a\x3avalue_type const\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _ST, class _BiIter>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_ostream<_CharT, _ST>\x26\x0a"
"operator<<(basic_ostream<_CharT, _ST>\x26 __os, const sub_match<_BiIter>\x26 __m)\x0a"
"{\x0a"
"    return __os << __m.str();\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Allocator>\x0a"
"class _LIBCPP_TEMPLATE_VIS match_results\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Allocator                                        allocator_type;\x0a"
"    typedef sub_match<_BidirectionalIterator>                 value_type;\x0a"
"private\x3a\x0a"
"    typedef vector<value_type, allocator_type>                __container_type;\x0a"
"\x0a"
"    __container_type  __matches_;\x0a"
"    value_type __unmatched_;\x0a"
"    value_type __prefix_;\x0a"
"    value_type __suffix_;\x0a"
"    bool       __ready_;\x0a"
"public\x3a\x0a"
"    _BidirectionalIterator __position_start_;\x0a"
"    typedef const value_type\x26                                 const_reference;\x0a"
"    typedef value_type\x26                                       reference;\x0a"
"    typedef typename __container_type\x3a\x3a""const_iterator         const_iterator;\x0a"
"    typedef const_iterator                                    iterator;\x0a"
"    typedef typename iterator_traits<_BidirectionalIterator>\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename allocator_traits<allocator_type>\x3a\x3asize_type size_type;\x0a"
"    typedef typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type char_type;\x0a"
"    typedef basic_string<char_type>                           string_type;\x0a"
"\x0a"
"    // construct/copy/destroy\x3a\x0a"
"    explicit match_results(const allocator_type\x26 __a = allocator_type());\x0a"
"//    match_results(const match_results\x26) = default;\x0a"
"//    match_results\x26 operator=(const match_results\x26) = default;\x0a"
"//    match_results(match_results\x26\x26 __m) = default;\x0a"
"//    match_results\x26 operator=(match_results\x26\x26 __m) = default;\x0a"
"//    \x7ematch_results() = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool ready() const {return __ready_;}\x0a"
"\x0a"
"    // size\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT {return __matches_.size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type max_size() const _NOEXCEPT {return __matches_.max_size();}\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT {return size() == 0;}\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    difference_type length(size_type __sub = 0) const\x0a"
"        {\x0a"
"        _LIBCPP_ASSERT(ready(), \x22match_results\x3a\x3alength() called when not ready\x22);\x0a"
"        return (*this)\x5b__sub\x5d.length();\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    difference_type position(size_type __sub = 0) const\x0a"
"        {\x0a"
"        _LIBCPP_ASSERT(ready(), \x22match_results\x3a\x3aposition() called when not ready\x22);\x0a"
"        return _VSTD\x3a\x3a""distance(__position_start_, (*this)\x5b__sub\x5d.first);\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    string_type str(size_type __sub = 0) const\x0a"
"        {\x0a"
"        _LIBCPP_ASSERT(ready(), \x22match_results\x3a\x3astr() called when not ready\x22);\x0a"
"        return (*this)\x5b__sub\x5d.str();\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference operator\x5b\x5d(size_type __n) const\x0a"
"        {\x0a"
"        _LIBCPP_ASSERT(ready(), \x22match_results\x3a\x3aoperator\x5b\x5d() called when not ready\x22);\x0a"
"        return __n < __matches_.size() \x3f __matches_\x5b__n\x5d \x3a __unmatched_;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference prefix() const\x0a"
"        {\x0a"
"        _LIBCPP_ASSERT(ready(), \x22match_results\x3a\x3aprefix() called when not ready\x22);\x0a"
"        return __prefix_;\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference suffix() const\x0a"
"        {\x0a"
"        _LIBCPP_ASSERT(ready(), \x22match_results\x3a\x3asuffix() called when not ready\x22);\x0a"
"        return __suffix_;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const {return empty() \x3f __matches_.end() \x3a __matches_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end() const {return __matches_.end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const {return empty() \x3f __matches_.end() \x3a __matches_.begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend() const {return __matches_.end();}\x0a"
"\x0a"
"    // format\x3a\x0a"
"    template <class _OutputIter>\x0a"
"        _OutputIter\x0a"
"        format(_OutputIter __output_iter, const char_type* __fmt_first,\x0a"
"               const char_type* __fmt_last,\x0a"
"               regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3a""format_default) const;\x0a"
"    template <class _OutputIter, class _ST, class _SA>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        _OutputIter\x0a"
"        format(_OutputIter __output_iter, const basic_string<char_type, _ST, _SA>\x26 __fmt,\x0a"
"               regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3a""format_default) const\x0a"
"            {return format(__output_iter, __fmt.data(), __fmt.data() + __fmt.size(), __flags);}\x0a"
"    template <class _ST, class _SA>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        basic_string<char_type, _ST, _SA>\x0a"
"        format(const basic_string<char_type, _ST, _SA>\x26 __fmt,\x0a"
"               regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3a""format_default) const\x0a"
"        {\x0a"
"            basic_string<char_type, _ST, _SA> __r;\x0a"
"            format(back_inserter(__r), __fmt.data(), __fmt.data() + __fmt.size(),\x0a"
"                   __flags);\x0a"
"            return __r;\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    string_type\x0a"
"        format(const char_type* __fmt,\x0a"
"               regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3a""format_default) const\x0a"
"        {\x0a"
"            string_type __r;\x0a"
"            format(back_inserter(__r), __fmt,\x0a"
"                   __fmt + char_traits<char_type>\x3a\x3alength(__fmt), __flags);\x0a"
"            return __r;\x0a"
"        }\x0a"
"\x0a"
"    // allocator\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const {return __matches_.get_allocator();}\x0a"
"\x0a"
"    // swap\x3a\x0a"
"    void swap(match_results\x26 __m);\x0a"
"\x0a"
"    template <class _Bp, class _Ap>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        void __assign(_BidirectionalIterator __f, _BidirectionalIterator __l,\x0a"
"                      const match_results<_Bp, _Ap>\x26 __m, bool __no_update_pos)\x0a"
"    {\x0a"
"        _Bp __mf = __m.prefix().first;\x0a"
"        __matches_.resize(__m.size());\x0a"
"        for (size_type __i = 0; __i < __matches_.size(); ++__i)\x0a"
"        {\x0a"
"            __matches_\x5b__i\x5d.first = _VSTD\x3a\x3anext(__f, _VSTD\x3a\x3a""distance(__mf, __m\x5b__i\x5d.first));\x0a"
"            __matches_\x5b__i\x5d.second = _VSTD\x3a\x3anext(__f, _VSTD\x3a\x3a""distance(__mf, __m\x5b__i\x5d.second));\x0a"
"            __matches_\x5b__i\x5d.matched = __m\x5b__i\x5d.matched;\x0a"
"        }\x0a"
"        __unmatched_.first   = __l;\x0a"
"        __unmatched_.second  = __l;\x0a"
"        __unmatched_.matched = false;\x0a"
"        __prefix_.first = _VSTD\x3a\x3anext(__f, _VSTD\x3a\x3a""distance(__mf, __m.prefix().first));\x0a"
"        __prefix_.second = _VSTD\x3a\x3anext(__f, _VSTD\x3a\x3a""distance(__mf, __m.prefix().second));\x0a"
"        __prefix_.matched = __m.prefix().matched;\x0a"
"        __suffix_.first = _VSTD\x3a\x3anext(__f, _VSTD\x3a\x3a""distance(__mf, __m.suffix().first));\x0a"
"        __suffix_.second = _VSTD\x3a\x3anext(__f, _VSTD\x3a\x3a""distance(__mf, __m.suffix().second));\x0a"
"        __suffix_.matched = __m.suffix().matched;\x0a"
"        if (\x21__no_update_pos)\x0a"
"            __position_start_ = __prefix_.first;\x0a"
"        __ready_ = __m.ready();\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    void __init(unsigned __s,\x0a"
"                _BidirectionalIterator __f, _BidirectionalIterator __l,\x0a"
"                bool __no_update_pos = false);\x0a"
"\x0a"
"    template <class, class> friend class basic_regex;\x0a"
"\x0a"
"    template <class _Bp, class _Ap, class _Cp, class _Tp>\x0a"
"    friend\x0a"
"    bool\x0a"
"    regex_match(_Bp, _Bp, match_results<_Bp, _Ap>\x26, const basic_regex<_Cp, _Tp>\x26,\x0a"
"                regex_constants\x3a\x3amatch_flag_type);\x0a"
"\x0a"
"    template <class _Bp, class _Ap>\x0a"
"    friend\x0a"
"    bool\x0a"
"    operator==(const match_results<_Bp, _Ap>\x26, const match_results<_Bp, _Ap>\x26);\x0a"
"\x0a"
"    template <class, class> friend class __lookahead;\x0a"
"};\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Allocator>\x0a"
"match_results<_BidirectionalIterator, _Allocator>\x3a\x3amatch_results(\x0a"
"        const allocator_type\x26 __a)\x0a"
"    \x3a __matches_(__a),\x0a"
"      __unmatched_(),\x0a"
"      __prefix_(),\x0a"
"      __suffix_(),\x0a"
"      __ready_(false),\x0a"
"      __position_start_()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Allocator>\x0a"
"void\x0a"
"match_results<_BidirectionalIterator, _Allocator>\x3a\x3a__init(unsigned __s,\x0a"
"                         _BidirectionalIterator __f, _BidirectionalIterator __l,\x0a"
"                         bool __no_update_pos)\x0a"
"{\x0a"
"    __unmatched_.first   = __l;\x0a"
"    __unmatched_.second  = __l;\x0a"
"    __unmatched_.matched = false;\x0a"
"    __matches_.assign(__s, __unmatched_);\x0a"
"    __prefix_.first      = __f;\x0a"
"    __prefix_.second     = __f;\x0a"
"    __prefix_.matched    = false;\x0a"
"    __suffix_ = __unmatched_;\x0a"
"    if (\x21__no_update_pos)\x0a"
"        __position_start_ = __prefix_.first;\x0a"
"    __ready_ = true;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Allocator>\x0a"
"template <class _OutputIter>\x0a"
"_OutputIter\x0a"
"match_results<_BidirectionalIterator, _Allocator>\x3a\x3a""format(_OutputIter __output_iter,\x0a"
"        const char_type* __fmt_first, const char_type* __fmt_last,\x0a"
"        regex_constants\x3a\x3amatch_flag_type __flags) const\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(ready(), \x22match_results\x3a\x3a""format() called when not ready\x22);\x0a"
"    if (__flags \x26 regex_constants\x3a\x3a""format_sed)\x0a"
"    {\x0a"
"        for (; __fmt_first \x21= __fmt_last; ++__fmt_first)\x0a"
"        {\x0a"
"            if (*__fmt_first == '\x26')\x0a"
"                __output_iter = _VSTD\x3a\x3a""copy(__matches_\x5b""0\x5d.first, __matches_\x5b""0\x5d.second,\x0a"
"                                   __output_iter);\x0a"
"            else if (*__fmt_first == '\x5c\x5c' \x26\x26 __fmt_first + 1 \x21= __fmt_last)\x0a"
"            {\x0a"
"                ++__fmt_first;\x0a"
"                if ('0' <= *__fmt_first \x26\x26 *__fmt_first <= '9')\x0a"
"                {\x0a"
"                    size_t __i = *__fmt_first - '0';\x0a"
"                    __output_iter = _VSTD\x3a\x3a""copy((*this)\x5b__i\x5d.first,\x0a"
"                                        (*this)\x5b__i\x5d.second, __output_iter);\x0a"
"                }\x0a"
"                else\x0a"
"                {\x0a"
"                    *__output_iter = *__fmt_first;\x0a"
"                    ++__output_iter;\x0a"
"                }\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                *__output_iter = *__fmt_first;\x0a"
"                ++__output_iter;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        for (; __fmt_first \x21= __fmt_last; ++__fmt_first)\x0a"
"        {\x0a"
"            if (*__fmt_first == '\x24' \x26\x26 __fmt_first + 1 \x21= __fmt_last)\x0a"
"            {\x0a"
"                switch (__fmt_first\x5b""1\x5d)\x0a"
"                {\x0a"
"                case '\x24'\x3a\x0a"
"                    *__output_iter = *++__fmt_first;\x0a"
"                    ++__output_iter;\x0a"
"                    break;\x0a"
"                case '\x26'\x3a\x0a"
"                    ++__fmt_first;\x0a"
"                    __output_iter = _VSTD\x3a\x3a""copy(__matches_\x5b""0\x5d.first, __matches_\x5b""0\x5d.second,\x0a"
"                                       __output_iter);\x0a"
"                    break;\x0a"
"                case '\x60'\x3a\x0a"
"                    ++__fmt_first;\x0a"
"                    __output_iter = _VSTD\x3a\x3a""copy(__prefix_.first, __prefix_.second, __output_iter);\x0a"
"                    break;\x0a"
"                case '\x5c''\x3a\x0a"
"                    ++__fmt_first;\x0a"
"                    __output_iter = _VSTD\x3a\x3a""copy(__suffix_.first, __suffix_.second, __output_iter);\x0a"
"                    break;\x0a"
"                default\x3a\x0a"
"                    if ('0' <= __fmt_first\x5b""1\x5d \x26\x26 __fmt_first\x5b""1\x5d <= '9')\x0a"
"                    {\x0a"
"                        ++__fmt_first;\x0a"
"                        size_t __idx = *__fmt_first - '0';\x0a"
"                        if (__fmt_first + 1 \x21= __fmt_last \x26\x26\x0a"
"                            '0' <= __fmt_first\x5b""1\x5d \x26\x26 __fmt_first\x5b""1\x5d <= '9')\x0a"
"                        {\x0a"
"                            ++__fmt_first;\x0a"
"                            if (__idx >= std\x3a\x3anumeric_limits<size_t>\x3a\x3amax() / 10)\x0a"
"                                __throw_regex_error<regex_constants\x3a\x3a""error_escape>();\x0a"
"                            __idx = 10 * __idx + *__fmt_first - '0';\x0a"
"                        }\x0a"
"                        __output_iter = _VSTD\x3a\x3a""copy((*this)\x5b__idx\x5d.first,\x0a"
"                                            (*this)\x5b__idx\x5d.second, __output_iter);\x0a"
"                    }\x0a"
"                    else\x0a"
"                    {\x0a"
"                        *__output_iter = *__fmt_first;\x0a"
"                        ++__output_iter;\x0a"
"                    }\x0a"
"                    break;\x0a"
"                }\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                *__output_iter = *__fmt_first;\x0a"
"                ++__output_iter;\x0a"
"            }\x0a"
"        }\x0a"
"    }\x0a"
"    return __output_iter;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Allocator>\x0a"
"void\x0a"
"match_results<_BidirectionalIterator, _Allocator>\x3a\x3aswap(match_results\x26 __m)\x0a"
"{\x0a"
"    using _VSTD\x3a\x3aswap;\x0a"
"    swap(__matches_, __m.__matches_);\x0a"
"    swap(__unmatched_, __m.__unmatched_);\x0a"
"    swap(__prefix_, __m.__prefix_);\x0a"
"    swap(__suffix_, __m.__suffix_);\x0a"
"    swap(__position_start_, __m.__position_start_);\x0a"
"    swap(__ready_, __m.__ready_);\x0a"
"}\x0a"
"\x0a"
"typedef match_results<const char*>             cmatch;\x0a"
"typedef match_results<const wchar_t*>          wcmatch;\x0a"
"typedef match_results<string\x3a\x3a""const_iterator>  smatch;\x0a"
"typedef match_results<wstring\x3a\x3a""const_iterator> wsmatch;\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Allocator>\x0a"
"bool\x0a"
"operator==(const match_results<_BidirectionalIterator, _Allocator>\x26 __x,\x0a"
"           const match_results<_BidirectionalIterator, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    if (__x.__ready_ \x21= __y.__ready_)\x0a"
"        return false;\x0a"
"    if (\x21__x.__ready_)\x0a"
"        return true;\x0a"
"    return __x.__matches_ == __y.__matches_ \x26\x26\x0a"
"           __x.__prefix_ == __y.__prefix_ \x26\x26\x0a"
"           __x.__suffix_ == __y.__suffix_;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const match_results<_BidirectionalIterator, _Allocator>\x26 __x,\x0a"
"           const match_results<_BidirectionalIterator, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(match_results<_BidirectionalIterator, _Allocator>\x26 __x,\x0a"
"     match_results<_BidirectionalIterator, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"// regex_search\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _Allocator>\x0a"
"bool\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__match_at_start_ecma(\x0a"
"        const _CharT* __first, const _CharT* __last,\x0a"
"        match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"        regex_constants\x3a\x3amatch_flag_type __flags, bool __at_first) const\x0a"
"{\x0a"
"    vector<__state> __states;\x0a"
"    __node* __st = __start_.get();\x0a"
"    if (__st)\x0a"
"    {\x0a"
"        sub_match<const _CharT*> __unmatched;\x0a"
"        __unmatched.first   = __last;\x0a"
"        __unmatched.second  = __last;\x0a"
"        __unmatched.matched = false;\x0a"
"\x0a"
"        __states.push_back(__state());\x0a"
"        __states.back().__do_ = 0;\x0a"
"        __states.back().__first_ = __first;\x0a"
"        __states.back().__current_ = __first;\x0a"
"        __states.back().__last_ = __last;\x0a"
"        __states.back().__sub_matches_.resize(mark_count(), __unmatched);\x0a"
"        __states.back().__loop_data_.resize(__loop_count());\x0a"
"        __states.back().__node_ = __st;\x0a"
"        __states.back().__flags_ = __flags;\x0a"
"        __states.back().__at_first_ = __at_first;\x0a"
"        int __counter = 0;\x0a"
"        int __length = __last - __first;\x0a"
"        do\x0a"
"        {\x0a"
"            ++__counter;\x0a"
"            if (__counter \x25 _LIBCPP_REGEX_COMPLEXITY_FACTOR == 0 \x26\x26\x0a"
"                __counter / _LIBCPP_REGEX_COMPLEXITY_FACTOR >= __length)\x0a"
"              __throw_regex_error<regex_constants\x3a\x3a""error_complexity>();\x0a"
"            __state\x26 __s = __states.back();\x0a"
"            if (__s.__node_)\x0a"
"                __s.__node_->__exec(__s);\x0a"
"            switch (__s.__do_)\x0a"
"            {\x0a"
"            case __state\x3a\x3a__end_state\x3a\x0a"
"                if ((__flags \x26 regex_constants\x3a\x3amatch_not_null) \x26\x26\x0a"
"                    __s.__current_ == __first)\x0a"
"                {\x0a"
"                  __states.pop_back();\x0a"
"                  break;\x0a"
"                }\x0a"
"                if ((__flags \x26 regex_constants\x3a\x3a__full_match) \x26\x26\x0a"
"                    __s.__current_ \x21= __last)\x0a"
"                {\x0a"
"                  __states.pop_back();\x0a"
"                  break;\x0a"
"                }\x0a"
"                __m.__matches_\x5b""0\x5d.first = __first;\x0a"
"                __m.__matches_\x5b""0\x5d.second = _VSTD\x3a\x3anext(__first, __s.__current_ - __first);\x0a"
"                __m.__matches_\x5b""0\x5d.matched = true;\x0a"
"                for (unsigned __i = 0; __i < __s.__sub_matches_.size(); ++__i)\x0a"
"                    __m.__matches_\x5b__i+1\x5d = __s.__sub_matches_\x5b__i\x5d;\x0a"
"                return true;\x0a"
"            case __state\x3a\x3a__accept_and_consume\x3a\x0a"
"            case __state\x3a\x3a__repeat\x3a\x0a"
"            case __state\x3a\x3a__accept_but_not_consume\x3a\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__split\x3a\x0a"
"                {\x0a"
"                __state __snext = __s;\x0a"
"                __s.__node_->__exec_split(true, __s);\x0a"
"                __snext.__node_->__exec_split(false, __snext);\x0a"
"                __states.push_back(_VSTD\x3a\x3amove(__snext));\x0a"
"                }\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__reject\x3a\x0a"
"                __states.pop_back();\x0a"
"                break;\x0a"
"            default\x3a\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a__re_err_unknown>();\x0a"
"                break;\x0a"
"\x0a"
"            }\x0a"
"        } while (\x21__states.empty());\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _Allocator>\x0a"
"bool\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__match_at_start_posix_nosubs(\x0a"
"        const _CharT* __first, const _CharT* __last,\x0a"
"        match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"        regex_constants\x3a\x3amatch_flag_type __flags, bool __at_first) const\x0a"
"{\x0a"
"    deque<__state> __states;\x0a"
"    ptrdiff_t __highest_j = 0;\x0a"
"    ptrdiff_t _Np = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    __node* __st = __start_.get();\x0a"
"    if (__st)\x0a"
"    {\x0a"
"        __states.push_back(__state());\x0a"
"        __states.back().__do_ = 0;\x0a"
"        __states.back().__first_ = __first;\x0a"
"        __states.back().__current_ = __first;\x0a"
"        __states.back().__last_ = __last;\x0a"
"        __states.back().__loop_data_.resize(__loop_count());\x0a"
"        __states.back().__node_ = __st;\x0a"
"        __states.back().__flags_ = __flags;\x0a"
"        __states.back().__at_first_ = __at_first;\x0a"
"        bool __matched = false;\x0a"
"        int __counter = 0;\x0a"
"        int __length = __last - __first;\x0a"
"        do\x0a"
"        {\x0a"
"            ++__counter;\x0a"
"            if (__counter \x25 _LIBCPP_REGEX_COMPLEXITY_FACTOR == 0 \x26\x26\x0a"
"                __counter / _LIBCPP_REGEX_COMPLEXITY_FACTOR >= __length)\x0a"
"              __throw_regex_error<regex_constants\x3a\x3a""error_complexity>();\x0a"
"            __state\x26 __s = __states.back();\x0a"
"            if (__s.__node_)\x0a"
"                __s.__node_->__exec(__s);\x0a"
"            switch (__s.__do_)\x0a"
"            {\x0a"
"            case __state\x3a\x3a__end_state\x3a\x0a"
"                if ((__flags \x26 regex_constants\x3a\x3amatch_not_null) \x26\x26\x0a"
"                    __s.__current_ == __first)\x0a"
"                {\x0a"
"                  __states.pop_back();\x0a"
"                  break;\x0a"
"                }\x0a"
"                if ((__flags \x26 regex_constants\x3a\x3a__full_match) \x26\x26\x0a"
"                    __s.__current_ \x21= __last)\x0a"
"                {\x0a"
"                  __states.pop_back();\x0a"
"                  break;\x0a"
"                }\x0a"
"                if (\x21__matched \x7c\x7c __highest_j < __s.__current_ - __s.__first_)\x0a"
"                    __highest_j = __s.__current_ - __s.__first_;\x0a"
"                __matched = true;\x0a"
"                if (__highest_j == _Np)\x0a"
"                    __states.clear();\x0a"
"                else\x0a"
"                    __states.pop_back();\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__consume_input\x3a\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__accept_and_consume\x3a\x0a"
"                __states.push_front(_VSTD\x3a\x3amove(__s));\x0a"
"                __states.pop_back();\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__repeat\x3a\x0a"
"            case __state\x3a\x3a__accept_but_not_consume\x3a\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__split\x3a\x0a"
"                {\x0a"
"                __state __snext = __s;\x0a"
"                __s.__node_->__exec_split(true, __s);\x0a"
"                __snext.__node_->__exec_split(false, __snext);\x0a"
"                __states.push_back(_VSTD\x3a\x3amove(__snext));\x0a"
"                }\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__reject\x3a\x0a"
"                __states.pop_back();\x0a"
"                break;\x0a"
"            default\x3a\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a__re_err_unknown>();\x0a"
"                break;\x0a"
"            }\x0a"
"        } while (\x21__states.empty());\x0a"
"        if (__matched)\x0a"
"        {\x0a"
"            __m.__matches_\x5b""0\x5d.first = __first;\x0a"
"            __m.__matches_\x5b""0\x5d.second = _VSTD\x3a\x3anext(__first, __highest_j);\x0a"
"            __m.__matches_\x5b""0\x5d.matched = true;\x0a"
"            return true;\x0a"
"        }\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _Allocator>\x0a"
"bool\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__match_at_start_posix_subs(\x0a"
"        const _CharT* __first, const _CharT* __last,\x0a"
"        match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"        regex_constants\x3a\x3amatch_flag_type __flags, bool __at_first) const\x0a"
"{\x0a"
"    vector<__state> __states;\x0a"
"    __state __best_state;\x0a"
"    ptrdiff_t __j = 0;\x0a"
"    ptrdiff_t __highest_j = 0;\x0a"
"    ptrdiff_t _Np = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    __node* __st = __start_.get();\x0a"
"    if (__st)\x0a"
"    {\x0a"
"        sub_match<const _CharT*> __unmatched;\x0a"
"        __unmatched.first   = __last;\x0a"
"        __unmatched.second  = __last;\x0a"
"        __unmatched.matched = false;\x0a"
"\x0a"
"        __states.push_back(__state());\x0a"
"        __states.back().__do_ = 0;\x0a"
"        __states.back().__first_ = __first;\x0a"
"        __states.back().__current_ = __first;\x0a"
"        __states.back().__last_ = __last;\x0a"
"        __states.back().__sub_matches_.resize(mark_count(), __unmatched);\x0a"
"        __states.back().__loop_data_.resize(__loop_count());\x0a"
"        __states.back().__node_ = __st;\x0a"
"        __states.back().__flags_ = __flags;\x0a"
"        __states.back().__at_first_ = __at_first;\x0a"
"        const _CharT* __current = __first;\x0a"
"        bool __matched = false;\x0a"
"        int __counter = 0;\x0a"
"        int __length = __last - __first;\x0a"
"        do\x0a"
"        {\x0a"
"            ++__counter;\x0a"
"            if (__counter \x25 _LIBCPP_REGEX_COMPLEXITY_FACTOR == 0 \x26\x26\x0a"
"                __counter / _LIBCPP_REGEX_COMPLEXITY_FACTOR >= __length)\x0a"
"              __throw_regex_error<regex_constants\x3a\x3a""error_complexity>();\x0a"
"            __state\x26 __s = __states.back();\x0a"
"            if (__s.__node_)\x0a"
"                __s.__node_->__exec(__s);\x0a"
"            switch (__s.__do_)\x0a"
"            {\x0a"
"            case __state\x3a\x3a__end_state\x3a\x0a"
"                if ((__flags \x26 regex_constants\x3a\x3amatch_not_null) \x26\x26\x0a"
"                    __s.__current_ == __first)\x0a"
"                {\x0a"
"                  __states.pop_back();\x0a"
"                  break;\x0a"
"                }\x0a"
"                if ((__flags \x26 regex_constants\x3a\x3a__full_match) \x26\x26\x0a"
"                    __s.__current_ \x21= __last)\x0a"
"                {\x0a"
"                  __states.pop_back();\x0a"
"                  break;\x0a"
"                }\x0a"
"                if (\x21__matched \x7c\x7c __highest_j < __s.__current_ - __s.__first_)\x0a"
"                {\x0a"
"                    __highest_j = __s.__current_ - __s.__first_;\x0a"
"                    __best_state = __s;\x0a"
"                }\x0a"
"                __matched = true;\x0a"
"                if (__highest_j == _Np)\x0a"
"                    __states.clear();\x0a"
"                else\x0a"
"                    __states.pop_back();\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__accept_and_consume\x3a\x0a"
"                __j += __s.__current_ - __current;\x0a"
"                __current = __s.__current_;\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__repeat\x3a\x0a"
"            case __state\x3a\x3a__accept_but_not_consume\x3a\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__split\x3a\x0a"
"                {\x0a"
"                __state __snext = __s;\x0a"
"                __s.__node_->__exec_split(true, __s);\x0a"
"                __snext.__node_->__exec_split(false, __snext);\x0a"
"                __states.push_back(_VSTD\x3a\x3amove(__snext));\x0a"
"                }\x0a"
"                break;\x0a"
"            case __state\x3a\x3a__reject\x3a\x0a"
"                __states.pop_back();\x0a"
"                break;\x0a"
"            default\x3a\x0a"
"                __throw_regex_error<regex_constants\x3a\x3a__re_err_unknown>();\x0a"
"                break;\x0a"
"            }\x0a"
"        } while (\x21__states.empty());\x0a"
"        if (__matched)\x0a"
"        {\x0a"
"            __m.__matches_\x5b""0\x5d.first = __first;\x0a"
"            __m.__matches_\x5b""0\x5d.second = _VSTD\x3a\x3anext(__first, __highest_j);\x0a"
"            __m.__matches_\x5b""0\x5d.matched = true;\x0a"
"            for (unsigned __i = 0; __i < __best_state.__sub_matches_.size(); ++__i)\x0a"
"                __m.__matches_\x5b__i+1\x5d = __best_state.__sub_matches_\x5b__i\x5d;\x0a"
"            return true;\x0a"
"        }\x0a"
"    }\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _Allocator>\x0a"
"bool\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__match_at_start(\x0a"
"        const _CharT* __first, const _CharT* __last,\x0a"
"        match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"        regex_constants\x3a\x3amatch_flag_type __flags, bool __at_first) const\x0a"
"{\x0a"
"    if (__get_grammar(__flags_) == ECMAScript)\x0a"
"        return __match_at_start_ecma(__first, __last, __m, __flags, __at_first);\x0a"
"    if (mark_count() == 0)\x0a"
"        return __match_at_start_posix_nosubs(__first, __last, __m, __flags, __at_first);\x0a"
"    return __match_at_start_posix_subs(__first, __last, __m, __flags, __at_first);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"template <class _Allocator>\x0a"
"bool\x0a"
"basic_regex<_CharT, _Traits>\x3a\x3a__search(\x0a"
"        const _CharT* __first, const _CharT* __last,\x0a"
"        match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"        regex_constants\x3a\x3amatch_flag_type __flags) const\x0a"
"{\x0a"
"    __m.__init(1 + mark_count(), __first, __last,\x0a"
"                                    __flags \x26 regex_constants\x3a\x3a__no_update_pos);\x0a"
"    if (__match_at_start(__first, __last, __m, __flags,\x0a"
"                                    \x21(__flags \x26 regex_constants\x3a\x3a__no_update_pos)))\x0a"
"    {\x0a"
"        __m.__prefix_.second = __m\x5b""0\x5d.first;\x0a"
"        __m.__prefix_.matched = __m.__prefix_.first \x21= __m.__prefix_.second;\x0a"
"        __m.__suffix_.first = __m\x5b""0\x5d.second;\x0a"
"        __m.__suffix_.matched = __m.__suffix_.first \x21= __m.__suffix_.second;\x0a"
"        return true;\x0a"
"    }\x0a"
"    if (__first \x21= __last \x26\x26 \x21(__flags \x26 regex_constants\x3a\x3amatch_continuous))\x0a"
"    {\x0a"
"        __flags \x7c= regex_constants\x3a\x3amatch_prev_avail;\x0a"
"        for (++__first; __first \x21= __last; ++__first)\x0a"
"        {\x0a"
"            __m.__matches_.assign(__m.size(), __m.__unmatched_);\x0a"
"            if (__match_at_start(__first, __last, __m, __flags, false))\x0a"
"            {\x0a"
"                __m.__prefix_.second = __m\x5b""0\x5d.first;\x0a"
"                __m.__prefix_.matched = __m.__prefix_.first \x21= __m.__prefix_.second;\x0a"
"                __m.__suffix_.first = __m\x5b""0\x5d.second;\x0a"
"                __m.__suffix_.matched = __m.__suffix_.first \x21= __m.__suffix_.second;\x0a"
"                return true;\x0a"
"            }\x0a"
"            __m.__matches_.assign(__m.size(), __m.__unmatched_);\x0a"
"        }\x0a"
"    }\x0a"
"    __m.__matches_.clear();\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Allocator, class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_search(_BidirectionalIterator __first, _BidirectionalIterator __last,\x0a"
"             match_results<_BidirectionalIterator, _Allocator>\x26 __m,\x0a"
"             const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"             regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    int __offset = (__flags \x26 regex_constants\x3a\x3amatch_prev_avail) \x3f 1 \x3a 0;\x0a"
"    basic_string<_CharT> __s(_VSTD\x3a\x3aprev(__first, __offset), __last);\x0a"
"    match_results<const _CharT*> __mc;\x0a"
"    bool __r = __e.__search(__s.data() + __offset, __s.data() + __s.size(), __mc, __flags);\x0a"
"    __m.__assign(__first, __last, __mc, __flags \x26 regex_constants\x3a\x3a__no_update_pos);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Iter, class _Allocator, class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_search(__wrap_iter<_Iter> __first,\x0a"
"             __wrap_iter<_Iter> __last,\x0a"
"             match_results<__wrap_iter<_Iter>, _Allocator>\x26 __m,\x0a"
"             const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"             regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    match_results<const _CharT*> __mc;\x0a"
"    bool __r = __e.__search(__first.base(), __last.base(), __mc, __flags);\x0a"
"    __m.__assign(__first, __last, __mc, __flags \x26 regex_constants\x3a\x3a__no_update_pos);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator, class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_search(const _CharT* __first, const _CharT* __last,\x0a"
"             match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"             const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"             regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    return __e.__search(__first, __last, __m, __flags);\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_search(_BidirectionalIterator __first, _BidirectionalIterator __last,\x0a"
"             const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"             regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    basic_string<_CharT> __s(__first, __last);\x0a"
"    match_results<const _CharT*> __mc;\x0a"
"    return __e.__search(__s.data(), __s.data() + __s.size(), __mc, __flags);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_search(const _CharT* __first, const _CharT* __last,\x0a"
"             const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"             regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    match_results<const _CharT*> __mc;\x0a"
"    return __e.__search(__first, __last, __mc, __flags);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Allocator, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_search(const _CharT* __str, match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"             const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"             regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    return __e.__search(__str, __str + _Traits\x3a\x3alength(__str), __m, __flags);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_search(const _CharT* __str, const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"             regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    match_results<const _CharT*> __m;\x0a"
"    return _VSTD\x3a\x3aregex_search(__str, __m, __e, __flags);\x0a"
"}\x0a"
"\x0a"
"template <class _ST, class _SA, class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_search(const basic_string<_CharT, _ST, _SA>\x26 __s,\x0a"
"             const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"             regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    match_results<const _CharT*> __mc;\x0a"
"    return __e.__search(__s.data(), __s.data() + __s.size(), __mc, __flags);\x0a"
"}\x0a"
"\x0a"
"template <class _ST, class _SA, class _Allocator, class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_search(const basic_string<_CharT, _ST, _SA>\x26 __s,\x0a"
"             match_results<typename basic_string<_CharT, _ST, _SA>\x3a\x3a""const_iterator, _Allocator>\x26 __m,\x0a"
"             const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"             regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    match_results<const _CharT*> __mc;\x0a"
"    bool __r = __e.__search(__s.data(), __s.data() + __s.size(), __mc, __flags);\x0a"
"    __m.__assign(__s.begin(), __s.end(), __mc, __flags \x26 regex_constants\x3a\x3a__no_update_pos);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _ST, class _SA, class _Ap, class _Cp, class _Tp>\x0a"
"bool\x0a"
"regex_search(const basic_string<_Cp, _ST, _SA>\x26\x26 __s,\x0a"
"             match_results<typename basic_string<_Cp, _ST, _SA>\x3a\x3a""const_iterator, _Ap>\x26,\x0a"
"             const basic_regex<_Cp, _Tp>\x26 __e,\x0a"
"             regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default) = delete;\x0a"
"#endif\x0a"
"\x0a"
"// regex_match\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _Allocator, class _CharT, class _Traits>\x0a"
"bool\x0a"
"regex_match(_BidirectionalIterator __first, _BidirectionalIterator __last,\x0a"
"            match_results<_BidirectionalIterator, _Allocator>\x26 __m,\x0a"
"            const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"            regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    bool __r = _VSTD\x3a\x3aregex_search(\x0a"
"        __first, __last, __m, __e,\x0a"
"        __flags \x7c regex_constants\x3a\x3amatch_continuous \x7c\x0a"
"        regex_constants\x3a\x3a__full_match);\x0a"
"    if (__r)\x0a"
"    {\x0a"
"        __r = \x21__m.suffix().matched;\x0a"
"        if (\x21__r)\x0a"
"            __m.__matches_.clear();\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_match(_BidirectionalIterator __first, _BidirectionalIterator __last,\x0a"
"            const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"            regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    match_results<_BidirectionalIterator> __m;\x0a"
"    return _VSTD\x3a\x3aregex_match(__first, __last, __m, __e, __flags);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Allocator, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_match(const _CharT* __str, match_results<const _CharT*, _Allocator>\x26 __m,\x0a"
"            const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"            regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aregex_match(__str, __str + _Traits\x3a\x3alength(__str), __m, __e, __flags);\x0a"
"}\x0a"
"\x0a"
"template <class _ST, class _SA, class _Allocator, class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_match(const basic_string<_CharT, _ST, _SA>\x26 __s,\x0a"
"            match_results<typename basic_string<_CharT, _ST, _SA>\x3a\x3a""const_iterator, _Allocator>\x26 __m,\x0a"
"            const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"            regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aregex_match(__s.begin(), __s.end(), __m, __e, __flags);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _ST, class _SA, class _Allocator, class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_match(const basic_string<_CharT, _ST, _SA>\x26\x26 __s,\x0a"
"            match_results<typename basic_string<_CharT, _ST, _SA>\x3a\x3a""const_iterator, _Allocator>\x26 __m,\x0a"
"            const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"            regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default) = delete;\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_match(const _CharT* __str, const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"            regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aregex_match(__str, __str + _Traits\x3a\x3alength(__str), __e, __flags);\x0a"
"}\x0a"
"\x0a"
"template <class _ST, class _SA, class _CharT, class _Traits>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"regex_match(const basic_string<_CharT, _ST, _SA>\x26 __s,\x0a"
"            const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"            regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aregex_match(__s.begin(), __s.end(), __e, __flags);\x0a"
"}\x0a"
"\x0a"
"// regex_iterator\x0a"
"\x0a"
"template <class _BidirectionalIterator,\x0a"
"          class _CharT = typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type,\x0a"
"          class _Traits = regex_traits<_CharT> >\x0a"
"class _LIBCPP_TEMPLATE_VIS regex_iterator\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef basic_regex<_CharT, _Traits>          regex_type;\x0a"
"    typedef match_results<_BidirectionalIterator> value_type;\x0a"
"    typedef ptrdiff_t                             difference_type;\x0a"
"    typedef const value_type*                     pointer;\x0a"
"    typedef const value_type\x26                     reference;\x0a"
"    typedef forward_iterator_tag                  iterator_category;\x0a"
"\x0a"
"private\x3a\x0a"
"    _BidirectionalIterator           __begin_;\x0a"
"    _BidirectionalIterator           __end_;\x0a"
"    const regex_type*                __pregex_;\x0a"
"    regex_constants\x3a\x3amatch_flag_type __flags_;\x0a"
"    value_type                       __match_;\x0a"
"\x0a"
"public\x3a\x0a"
"    regex_iterator();\x0a"
"    regex_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                   const regex_type\x26 __re,\x0a"
"                   regex_constants\x3a\x3amatch_flag_type __m\x0a"
"                                              = regex_constants\x3a\x3amatch_default);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    regex_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                   const regex_type\x26\x26 __re,\x0a"
"                   regex_constants\x3a\x3amatch_flag_type __m\x0a"
"                                     = regex_constants\x3a\x3amatch_default) = delete;\x0a"
"#endif\x0a"
"\x0a"
"    bool operator==(const regex_iterator\x26 __x) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const regex_iterator\x26 __x) const {return \x21(*this == __x);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference operator*() const {return  __match_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer operator->() const  {return _VSTD\x3a\x3a""addressof(__match_);}\x0a"
"\x0a"
"    regex_iterator\x26 operator++();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    regex_iterator operator++(int)\x0a"
"    {\x0a"
"        regex_iterator __t(*this);\x0a"
"        ++(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"regex_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3aregex_iterator()\x0a"
"    \x3a __begin_(), __end_(), __pregex_(nullptr), __flags_(), __match_()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"regex_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    regex_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                   const regex_type\x26 __re, regex_constants\x3a\x3amatch_flag_type __m)\x0a"
"    \x3a __begin_(__a),\x0a"
"      __end_(__b),\x0a"
"      __pregex_(_VSTD\x3a\x3a""addressof(__re)),\x0a"
"      __flags_(__m)\x0a"
"{\x0a"
"    _VSTD\x3a\x3aregex_search(__begin_, __end_, __match_, *__pregex_, __flags_);\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"bool\x0a"
"regex_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    operator==(const regex_iterator\x26 __x) const\x0a"
"{\x0a"
"    if (__match_.empty() \x26\x26 __x.__match_.empty())\x0a"
"        return true;\x0a"
"    if (__match_.empty() \x7c\x7c __x.__match_.empty())\x0a"
"        return false;\x0a"
"    return __begin_ == __x.__begin_       \x26\x26\x0a"
"           __end_ == __x.__end_           \x26\x26\x0a"
"           __pregex_ == __x.__pregex_     \x26\x26\x0a"
"           __flags_ == __x.__flags_       \x26\x26\x0a"
"           __match_\x5b""0\x5d == __x.__match_\x5b""0\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"regex_iterator<_BidirectionalIterator, _CharT, _Traits>\x26\x0a"
"regex_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3aoperator++()\x0a"
"{\x0a"
"    __flags_ \x7c= regex_constants\x3a\x3a__no_update_pos;\x0a"
"    _BidirectionalIterator __start = __match_\x5b""0\x5d.second;\x0a"
"    if (__match_\x5b""0\x5d.first == __match_\x5b""0\x5d.second)\x0a"
"    {\x0a"
"        if (__start == __end_)\x0a"
"        {\x0a"
"            __match_ = value_type();\x0a"
"            return *this;\x0a"
"        }\x0a"
"        else if (_VSTD\x3a\x3aregex_search(__start, __end_, __match_, *__pregex_,\x0a"
"                                    __flags_ \x7c regex_constants\x3a\x3amatch_not_null \x7c\x0a"
"                                    regex_constants\x3a\x3amatch_continuous))\x0a"
"            return *this;\x0a"
"        else\x0a"
"            ++__start;\x0a"
"    }\x0a"
"    __flags_ \x7c= regex_constants\x3a\x3amatch_prev_avail;\x0a"
"    if (\x21_VSTD\x3a\x3aregex_search(__start, __end_, __match_, *__pregex_, __flags_))\x0a"
"        __match_ = value_type();\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"typedef regex_iterator<const char*>             cregex_iterator;\x0a"
"typedef regex_iterator<const wchar_t*>          wcregex_iterator;\x0a"
"typedef regex_iterator<string\x3a\x3a""const_iterator>  sregex_iterator;\x0a"
"typedef regex_iterator<wstring\x3a\x3a""const_iterator> wsregex_iterator;\x0a"
"\x0a"
"// regex_token_iterator\x0a"
"\x0a"
"template <class _BidirectionalIterator,\x0a"
"          class _CharT = typename iterator_traits<_BidirectionalIterator>\x3a\x3avalue_type,\x0a"
"          class _Traits = regex_traits<_CharT> >\x0a"
"class _LIBCPP_TEMPLATE_VIS regex_token_iterator\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef basic_regex<_CharT, _Traits>      regex_type;\x0a"
"    typedef sub_match<_BidirectionalIterator> value_type;\x0a"
"    typedef ptrdiff_t                         difference_type;\x0a"
"    typedef const value_type*                 pointer;\x0a"
"    typedef const value_type\x26                 reference;\x0a"
"    typedef forward_iterator_tag              iterator_category;\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef regex_iterator<_BidirectionalIterator, _CharT, _Traits> _Position;\x0a"
"\x0a"
"    _Position         __position_;\x0a"
"    const value_type* __result_;\x0a"
"    value_type        __suffix_;\x0a"
"    ptrdiff_t         __n_;\x0a"
"    vector<int>       __subs_;\x0a"
"\x0a"
"public\x3a\x0a"
"    regex_token_iterator();\x0a"
"    regex_token_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                         const regex_type\x26 __re, int __submatch = 0,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type __m =\x0a"
"                                                regex_constants\x3a\x3amatch_default);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    regex_token_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                         const regex_type\x26\x26 __re, int __submatch = 0,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type __m =\x0a"
"                                       regex_constants\x3a\x3amatch_default) = delete;\x0a"
"#endif\x0a"
"\x0a"
"    regex_token_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                         const regex_type\x26 __re, const vector<int>\x26 __submatches,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type __m =\x0a"
"                                                regex_constants\x3a\x3amatch_default);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    regex_token_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                         const regex_type\x26\x26 __re, const vector<int>\x26 __submatches,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type __m =\x0a"
"                                     regex_constants\x3a\x3amatch_default) = delete;\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    regex_token_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                         const regex_type\x26 __re,\x0a"
"                         initializer_list<int> __submatches,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type __m =\x0a"
"                                                regex_constants\x3a\x3amatch_default);\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    regex_token_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                         const regex_type\x26\x26 __re,\x0a"
"                         initializer_list<int> __submatches,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type __m =\x0a"
"                                       regex_constants\x3a\x3amatch_default) = delete;\x0a"
"#endif\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    template <size_t _Np>\x0a"
"        regex_token_iterator(_BidirectionalIterator __a,\x0a"
"                             _BidirectionalIterator __b,\x0a"
"                             const regex_type\x26 __re,\x0a"
"                             const int (\x26__submatches)\x5b_Np\x5d,\x0a"
"                             regex_constants\x3a\x3amatch_flag_type __m =\x0a"
"                                                regex_constants\x3a\x3amatch_default);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <std\x3a\x3asize_t _Np>\x0a"
"        regex_token_iterator(_BidirectionalIterator __a,\x0a"
"                             _BidirectionalIterator __b,\x0a"
"                             const regex_type\x26\x26 __re,\x0a"
"                             const int (\x26__submatches)\x5b_Np\x5d,\x0a"
"                             regex_constants\x3a\x3amatch_flag_type __m =\x0a"
"                                      regex_constants\x3a\x3amatch_default) = delete;\x0a"
"#endif\x0a"
"\x0a"
"    regex_token_iterator(const regex_token_iterator\x26);\x0a"
"    regex_token_iterator\x26 operator=(const regex_token_iterator\x26);\x0a"
"\x0a"
"    bool operator==(const regex_token_iterator\x26 __x) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator\x21=(const regex_token_iterator\x26 __x) const {return \x21(*this == __x);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type\x26 operator*() const {return *__result_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type* operator->() const {return __result_;}\x0a"
"\x0a"
"    regex_token_iterator\x26 operator++();\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    regex_token_iterator operator++(int)\x0a"
"    {\x0a"
"        regex_token_iterator __t(*this);\x0a"
"        ++(*this);\x0a"
"        return __t;\x0a"
"    }\x0a"
"\x0a"
"private\x3a\x0a"
"    void __init(_BidirectionalIterator __a, _BidirectionalIterator __b);\x0a"
"    void __establish_result () {\x0a"
"        if (__subs_\x5b__n_\x5d == -1)\x0a"
"            __result_ = \x26__position_->prefix();\x0a"
"        else\x0a"
"            __result_ = \x26(*__position_)\x5b__subs_\x5b__n_\x5d\x5d;\x0a"
"        }\x0a"
"};\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    regex_token_iterator()\x0a"
"    \x3a __result_(nullptr),\x0a"
"      __suffix_(),\x0a"
"      __n_(0)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"void\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    __init(_BidirectionalIterator __a, _BidirectionalIterator __b)\x0a"
"{\x0a"
"    if (__position_ \x21= _Position())\x0a"
"        __establish_result ();\x0a"
"    else if (__subs_\x5b__n_\x5d == -1)\x0a"
"    {\x0a"
"        __suffix_.matched = true;\x0a"
"        __suffix_.first = __a;\x0a"
"        __suffix_.second = __b;\x0a"
"        __result_ = \x26__suffix_;\x0a"
"    }\x0a"
"    else\x0a"
"        __result_ = nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    regex_token_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                         const regex_type\x26 __re, int __submatch,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type __m)\x0a"
"    \x3a __position_(__a, __b, __re, __m),\x0a"
"      __n_(0),\x0a"
"      __subs_(1, __submatch)\x0a"
"{\x0a"
"    __init(__a, __b);\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    regex_token_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                         const regex_type\x26 __re, const vector<int>\x26 __submatches,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type __m)\x0a"
"    \x3a __position_(__a, __b, __re, __m),\x0a"
"      __n_(0),\x0a"
"      __subs_(__submatches)\x0a"
"{\x0a"
"    __init(__a, __b);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    regex_token_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                         const regex_type\x26 __re,\x0a"
"                         initializer_list<int> __submatches,\x0a"
"                         regex_constants\x3a\x3amatch_flag_type __m)\x0a"
"    \x3a __position_(__a, __b, __re, __m),\x0a"
"      __n_(0),\x0a"
"      __subs_(__submatches)\x0a"
"{\x0a"
"    __init(__a, __b);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"template <size_t _Np>\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    regex_token_iterator(_BidirectionalIterator __a, _BidirectionalIterator __b,\x0a"
"                             const regex_type\x26 __re,\x0a"
"                             const int (\x26__submatches)\x5b_Np\x5d,\x0a"
"                             regex_constants\x3a\x3amatch_flag_type __m)\x0a"
"    \x3a __position_(__a, __b, __re, __m),\x0a"
"      __n_(0),\x0a"
"      __subs_(begin(__submatches), end(__submatches))\x0a"
"{\x0a"
"    __init(__a, __b);\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    regex_token_iterator(const regex_token_iterator\x26 __x)\x0a"
"    \x3a __position_(__x.__position_),\x0a"
"      __result_(__x.__result_),\x0a"
"      __suffix_(__x.__suffix_),\x0a"
"      __n_(__x.__n_),\x0a"
"      __subs_(__x.__subs_)\x0a"
"{\x0a"
"    if (__x.__result_ == \x26__x.__suffix_)\x0a"
"        __result_ = \x26__suffix_;\x0a"
"    else if ( __result_ \x21= nullptr )\x0a"
"        __establish_result ();\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x26\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    operator=(const regex_token_iterator\x26 __x)\x0a"
"{\x0a"
"    if (this \x21= \x26__x)\x0a"
"    {\x0a"
"        __position_ = __x.__position_;\x0a"
"        if (__x.__result_ == \x26__x.__suffix_)\x0a"
"            __result_ = \x26__suffix_;\x0a"
"        else\x0a"
"            __result_ = __x.__result_;\x0a"
"        __suffix_ = __x.__suffix_;\x0a"
"        __n_ = __x.__n_;\x0a"
"        __subs_ = __x.__subs_;\x0a"
"\x0a"
"        if ( __result_ \x21= nullptr \x26\x26 __result_ \x21= \x26__suffix_ )\x0a"
"            __establish_result();\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"bool\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3a\x0a"
"    operator==(const regex_token_iterator\x26 __x) const\x0a"
"{\x0a"
"    if (__result_ == nullptr \x26\x26 __x.__result_ == nullptr)\x0a"
"        return true;\x0a"
"    if (__result_ == \x26__suffix_ \x26\x26 __x.__result_ == \x26__x.__suffix_ \x26\x26\x0a"
"            __suffix_ == __x.__suffix_)\x0a"
"        return true;\x0a"
"    if (__result_ == nullptr \x7c\x7c __x.__result_ == nullptr)\x0a"
"        return false;\x0a"
"    if (__result_ == \x26__suffix_ \x7c\x7c __x.__result_ == \x26__x.__suffix_)\x0a"
"        return false;\x0a"
"    return __position_ == __x.__position_ \x26\x26 __n_ == __x.__n_ \x26\x26\x0a"
"           __subs_ == __x.__subs_;\x0a"
"}\x0a"
"\x0a"
"template <class _BidirectionalIterator, class _CharT, class _Traits>\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x26\x0a"
"regex_token_iterator<_BidirectionalIterator, _CharT, _Traits>\x3a\x3aoperator++()\x0a"
"{\x0a"
"    _Position __prev = __position_;\x0a"
"    if (__result_ == \x26__suffix_)\x0a"
"        __result_ = nullptr;\x0a"
"    else if (static_cast<size_t>(__n_ + 1) < __subs_.size())\x0a"
"    {\x0a"
"        ++__n_;\x0a"
"        __establish_result();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __n_ = 0;\x0a"
"        ++__position_;\x0a"
"        if (__position_ \x21= _Position())\x0a"
"            __establish_result();\x0a"
"        else\x0a"
"        {\x0a"
"            if (_VSTD\x3a\x3a""find(__subs_.begin(), __subs_.end(), -1) \x21= __subs_.end()\x0a"
"                \x26\x26 __prev->suffix().length() \x21= 0)\x0a"
"            {\x0a"
"                __suffix_.matched = true;\x0a"
"                __suffix_.first = __prev->suffix().first;\x0a"
"                __suffix_.second = __prev->suffix().second;\x0a"
"                __result_ = \x26__suffix_;\x0a"
"            }\x0a"
"            else\x0a"
"                __result_ = nullptr;\x0a"
"        }\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"typedef regex_token_iterator<const char*>             cregex_token_iterator;\x0a"
"typedef regex_token_iterator<const wchar_t*>          wcregex_token_iterator;\x0a"
"typedef regex_token_iterator<string\x3a\x3a""const_iterator>  sregex_token_iterator;\x0a"
"typedef regex_token_iterator<wstring\x3a\x3a""const_iterator> wsregex_token_iterator;\x0a"
"\x0a"
"// regex_replace\x0a"
"\x0a"
"template <class _OutputIterator, class _BidirectionalIterator,\x0a"
"          class _Traits, class _CharT>\x0a"
"_OutputIterator\x0a"
"regex_replace(_OutputIterator __output_iter,\x0a"
"              _BidirectionalIterator __first, _BidirectionalIterator __last,\x0a"
"              const basic_regex<_CharT, _Traits>\x26 __e, const _CharT* __fmt,\x0a"
"              regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    typedef regex_iterator<_BidirectionalIterator, _CharT, _Traits> _Iter;\x0a"
"    _Iter __i(__first, __last, __e, __flags);\x0a"
"    _Iter __eof;\x0a"
"    if (__i == __eof)\x0a"
"    {\x0a"
"        if (\x21(__flags \x26 regex_constants\x3a\x3a""format_no_copy))\x0a"
"            __output_iter = _VSTD\x3a\x3a""copy(__first, __last, __output_iter);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        sub_match<_BidirectionalIterator> __lm;\x0a"
"        for (size_t __len = char_traits<_CharT>\x3a\x3alength(__fmt); __i \x21= __eof; ++__i)\x0a"
"        {\x0a"
"            if (\x21(__flags \x26 regex_constants\x3a\x3a""format_no_copy))\x0a"
"                __output_iter = _VSTD\x3a\x3a""copy(__i->prefix().first, __i->prefix().second, __output_iter);\x0a"
"            __output_iter = __i->format(__output_iter, __fmt, __fmt + __len, __flags);\x0a"
"            __lm = __i->suffix();\x0a"
"            if (__flags \x26 regex_constants\x3a\x3a""format_first_only)\x0a"
"                break;\x0a"
"        }\x0a"
"        if (\x21(__flags \x26 regex_constants\x3a\x3a""format_no_copy))\x0a"
"            __output_iter = _VSTD\x3a\x3a""copy(__lm.first, __lm.second, __output_iter);\x0a"
"    }\x0a"
"    return __output_iter;\x0a"
"}\x0a"
"\x0a"
"template <class _OutputIterator, class _BidirectionalIterator,\x0a"
"          class _Traits, class _CharT, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_OutputIterator\x0a"
"regex_replace(_OutputIterator __output_iter,\x0a"
"              _BidirectionalIterator __first, _BidirectionalIterator __last,\x0a"
"              const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"              const basic_string<_CharT, _ST, _SA>\x26 __fmt,\x0a"
"              regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3aregex_replace(__output_iter, __first, __last, __e, __fmt.c_str(), __flags);\x0a"
"}\x0a"
"\x0a"
"template <class _Traits, class _CharT, class _ST, class _SA, class _FST,\x0a"
"          class _FSA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT, _ST, _SA>\x0a"
"regex_replace(const basic_string<_CharT, _ST, _SA>\x26 __s,\x0a"
"              const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"              const basic_string<_CharT, _FST, _FSA>\x26 __fmt,\x0a"
"              regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    basic_string<_CharT, _ST, _SA> __r;\x0a"
"    _VSTD\x3a\x3aregex_replace(back_inserter(__r), __s.begin(), __s.end(), __e,\x0a"
"                        __fmt.c_str(), __flags);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Traits, class _CharT, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT, _ST, _SA>\x0a"
"regex_replace(const basic_string<_CharT, _ST, _SA>\x26 __s,\x0a"
"              const basic_regex<_CharT, _Traits>\x26 __e, const _CharT* __fmt,\x0a"
"              regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    basic_string<_CharT, _ST, _SA> __r;\x0a"
"    _VSTD\x3a\x3aregex_replace(back_inserter(__r), __s.begin(), __s.end(), __e,\x0a"
"                        __fmt, __flags);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Traits, class _CharT, class _ST, class _SA>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT>\x0a"
"regex_replace(const _CharT* __s,\x0a"
"              const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"              const basic_string<_CharT, _ST, _SA>\x26 __fmt,\x0a"
"              regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    basic_string<_CharT> __r;\x0a"
"    _VSTD\x3a\x3aregex_replace(back_inserter(__r), __s,\x0a"
"                        __s + char_traits<_CharT>\x3a\x3alength(__s), __e,\x0a"
"                        __fmt.c_str(), __flags);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Traits, class _CharT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT>\x0a"
"regex_replace(const _CharT* __s,\x0a"
"              const basic_regex<_CharT, _Traits>\x26 __e,\x0a"
"              const _CharT* __fmt,\x0a"
"              regex_constants\x3a\x3amatch_flag_type __flags = regex_constants\x3a\x3amatch_default)\x0a"
"{\x0a"
"    basic_string<_CharT> __r;\x0a"
"    _VSTD\x3a\x3aregex_replace(back_inserter(__r), __s,\x0a"
"                        __s + char_traits<_CharT>\x3a\x3alength(__s), __e,\x0a"
"                        __fmt, __flags);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_REGEX\x0a"
"", 223527 ); }