#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_string( 
"// -*- C++ -*-\x0a"
"//===--------------------------- string -----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_STRING\x0a"
"#define _LIBCPP_STRING\x0a"
"\x0a"
"/*\x0a"
"    string synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class stateT>\x0a"
"class fpos\x0a"
"{\x0a"
"private\x3a\x0a"
"    stateT st;\x0a"
"public\x3a\x0a"
"    fpos(streamoff = streamoff());\x0a"
"\x0a"
"    operator streamoff() const;\x0a"
"\x0a"
"    stateT state() const;\x0a"
"    void state(stateT);\x0a"
"\x0a"
"    fpos\x26 operator+=(streamoff);\x0a"
"    fpos  operator+ (streamoff) const;\x0a"
"    fpos\x26 operator-=(streamoff);\x0a"
"    fpos  operator- (streamoff) const;\x0a"
"};\x0a"
"\x0a"
"template <class stateT> streamoff operator-(const fpos<stateT>\x26 x, const fpos<stateT>\x26 y);\x0a"
"\x0a"
"template <class stateT> bool operator==(const fpos<stateT>\x26 x, const fpos<stateT>\x26 y);\x0a"
"template <class stateT> bool operator\x21=(const fpos<stateT>\x26 x, const fpos<stateT>\x26 y);\x0a"
"\x0a"
"template <class charT>\x0a"
"struct char_traits\x0a"
"{\x0a"
"    typedef charT     char_type;\x0a"
"    typedef ...       int_type;\x0a"
"    typedef streamoff off_type;\x0a"
"    typedef streampos pos_type;\x0a"
"    typedef mbstate_t state_type;\x0a"
"\x0a"
"    static void assign(char_type\x26 c1, const char_type\x26 c2) noexcept;\x0a"
"    static constexpr bool eq(char_type c1, char_type c2) noexcept;\x0a"
"    static constexpr bool lt(char_type c1, char_type c2) noexcept;\x0a"
"\x0a"
"    static int              compare(const char_type* s1, const char_type* s2, size_t n);\x0a"
"    static size_t           length(const char_type* s);\x0a"
"    static const char_type* find(const char_type* s, size_t n, const char_type\x26 a);\x0a"
"    static char_type*       move(char_type* s1, const char_type* s2, size_t n);\x0a"
"    static char_type*       copy(char_type* s1, const char_type* s2, size_t n);\x0a"
"    static char_type*       assign(char_type* s, size_t n, char_type a);\x0a"
"\x0a"
"    static constexpr int_type  not_eof(int_type c) noexcept;\x0a"
"    static constexpr char_type to_char_type(int_type c) noexcept;\x0a"
"    static constexpr int_type  to_int_type(char_type c) noexcept;\x0a"
"    static constexpr bool      eq_int_type(int_type c1, int_type c2) noexcept;\x0a"
"    static constexpr int_type  eof() noexcept;\x0a"
"};\x0a"
"\x0a"
"template <> struct char_traits<char>;\x0a"
"template <> struct char_traits<wchar_t>;\x0a"
"\x0a"
"template<class charT, class traits = char_traits<charT>, class Allocator = allocator<charT> >\x0a"
"class basic_string\x0a"
"{\x0a"
"public\x3a\x0a"
"// types\x3a\x0a"
"    typedef traits traits_type;\x0a"
"    typedef typename traits_type\x3a\x3a""char_type value_type;\x0a"
"    typedef Allocator allocator_type;\x0a"
"    typedef typename allocator_type\x3a\x3asize_type size_type;\x0a"
"    typedef typename allocator_type\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename allocator_type\x3a\x3areference reference;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef typename allocator_type\x3a\x3apointer pointer;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_pointer const_pointer;\x0a"
"    typedef implementation-defined iterator;\x0a"
"    typedef implementation-defined const_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator> reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator> const_reverse_iterator;\x0a"
"\x0a"
"    static const size_type npos = -1;\x0a"
"\x0a"
"    basic_string()\x0a"
"        noexcept(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    explicit basic_string(const allocator_type\x26 a);\x0a"
"    basic_string(const basic_string\x26 str);\x0a"
"    basic_string(basic_string\x26\x26 str)\x0a"
"        noexcept(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    basic_string(const basic_string\x26 str, size_type pos,\x0a"
"                 const allocator_type\x26 a = allocator_type());\x0a"
"    basic_string(const basic_string\x26 str, size_type pos, size_type n,\x0a"
"                 const Allocator\x26 a = Allocator());\x0a"
"    template<class T>\x0a"
"        basic_string(const T\x26 t, size_type pos, size_type n, const Allocator\x26 a = Allocator()); // C++17\x0a"
"    template <class T>\x0a"
"        explicit basic_string(const T\x26 t, const Allocator\x26 a = Allocator()); // C++17\x0a"
"    basic_string(const value_type* s, const allocator_type\x26 a = allocator_type());\x0a"
"    basic_string(const value_type* s, size_type n, const allocator_type\x26 a = allocator_type());\x0a"
"    basic_string(size_type n, value_type c, const allocator_type\x26 a = allocator_type());\x0a"
"    template<class InputIterator>\x0a"
"        basic_string(InputIterator begin, InputIterator end,\x0a"
"                     const allocator_type\x26 a = allocator_type());\x0a"
"    basic_string(initializer_list<value_type>, const Allocator\x26 = Allocator());\x0a"
"    basic_string(const basic_string\x26, const Allocator\x26);\x0a"
"    basic_string(basic_string\x26\x26, const Allocator\x26);\x0a"
"\x0a"
"    \x7e""basic_string();\x0a"
"\x0a"
"    operator basic_string_view<charT, traits>() const noexcept;\x0a"
"\x0a"
"    basic_string\x26 operator=(const basic_string\x26 str);\x0a"
"    template <class T>\x0a"
"        basic_string\x26 operator=(const T\x26 t); // C++17\x0a"
"    basic_string\x26 operator=(basic_string\x26\x26 str)\x0a"
"        noexcept(\x0a"
"             allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"             allocator_type\x3a\x3ais_always_equal\x3a\x3avalue ); // C++17\x0a"
"    basic_string\x26 operator=(const value_type* s);\x0a"
"    basic_string\x26 operator=(value_type c);\x0a"
"    basic_string\x26 operator=(initializer_list<value_type>);\x0a"
"\x0a"
"    iterator       begin() noexcept;\x0a"
"    const_iterator begin() const noexcept;\x0a"
"    iterator       end() noexcept;\x0a"
"    const_iterator end() const noexcept;\x0a"
"\x0a"
"    reverse_iterator       rbegin() noexcept;\x0a"
"    const_reverse_iterator rbegin() const noexcept;\x0a"
"    reverse_iterator       rend() noexcept;\x0a"
"    const_reverse_iterator rend() const noexcept;\x0a"
"\x0a"
"    const_iterator         cbegin() const noexcept;\x0a"
"    const_iterator         cend() const noexcept;\x0a"
"    const_reverse_iterator crbegin() const noexcept;\x0a"
"    const_reverse_iterator crend() const noexcept;\x0a"
"\x0a"
"    size_type size() const noexcept;\x0a"
"    size_type length() const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"    size_type capacity() const noexcept;\x0a"
"\x0a"
"    void resize(size_type n, value_type c);\x0a"
"    void resize(size_type n);\x0a"
"\x0a"
"    void reserve(size_type res_arg = 0);\x0a"
"    void shrink_to_fit();\x0a"
"    void clear() noexcept;\x0a"
"    bool empty() const noexcept;\x0a"
"\x0a"
"    const_reference operator\x5b\x5d(size_type pos) const;\x0a"
"    reference       operator\x5b\x5d(size_type pos);\x0a"
"\x0a"
"    const_reference at(size_type n) const;\x0a"
"    reference       at(size_type n);\x0a"
"\x0a"
"    basic_string\x26 operator+=(const basic_string\x26 str);\x0a"
"    template <class T>\x0a"
"        basic_string\x26 operator+=(const T\x26 t);              // C++17\x0a"
"    basic_string\x26 operator+=(const value_type* s);\x0a"
"    basic_string\x26 operator+=(value_type c);\x0a"
"    basic_string\x26 operator+=(initializer_list<value_type>);\x0a"
"\x0a"
"    basic_string\x26 append(const basic_string\x26 str);\x0a"
"    template <class T>\x0a"
"        basic_string\x26 append(const T\x26 t);                 // C++17\x0a"
"    basic_string\x26 append(const basic_string\x26 str, size_type pos, size_type n=npos); //C++14\x0a"
"    template <class T>\x0a"
"        basic_string\x26 append(const T\x26 t, size_type pos, size_type n=npos); // C++17\x0a"
"    basic_string\x26 append(const value_type* s, size_type n);\x0a"
"    basic_string\x26 append(const value_type* s);\x0a"
"    basic_string\x26 append(size_type n, value_type c);\x0a"
"    template<class InputIterator>\x0a"
"        basic_string\x26 append(InputIterator first, InputIterator last);\x0a"
"    basic_string\x26 append(initializer_list<value_type>);\x0a"
"\x0a"
"    void push_back(value_type c);\x0a"
"    void pop_back();\x0a"
"    reference       front();\x0a"
"    const_reference front() const;\x0a"
"    reference       back();\x0a"
"    const_reference back() const;\x0a"
"\x0a"
"    basic_string\x26 assign(const basic_string\x26 str);\x0a"
"    template <class T>\x0a"
"        basic_string\x26 assign(const T\x26 t);  // C++17\x0a"
"    basic_string\x26 assign(basic_string\x26\x26 str);\x0a"
"    basic_string\x26 assign(const basic_string\x26 str, size_type pos, size_type n=npos); // C++14\x0a"
"    template <class T>\x0a"
"        basic_string\x26 assign(const T\x26 t, size_type pos, size_type n=npos); // C++17\x0a"
"    basic_string\x26 assign(const value_type* s, size_type n);\x0a"
"    basic_string\x26 assign(const value_type* s);\x0a"
"    basic_string\x26 assign(size_type n, value_type c);\x0a"
"    template<class InputIterator>\x0a"
"        basic_string\x26 assign(InputIterator first, InputIterator last);\x0a"
"    basic_string\x26 assign(initializer_list<value_type>);\x0a"
"\x0a"
"    basic_string\x26 insert(size_type pos1, const basic_string\x26 str);\x0a"
"    template <class T>\x0a"
"        basic_string\x26 insert(size_type pos1, const T\x26 t);\x0a"
"    basic_string\x26 insert(size_type pos1, const basic_string\x26 str,\x0a"
"                         size_type pos2, size_type n);\x0a"
"    template <class T>\x0a"
"        basic_string\x26 insert(size_type pos1, const T\x26 t, size_type pos2, size_type n); // C++17\x0a"
"    basic_string\x26 insert(size_type pos, const value_type* s, size_type n=npos); //C++14\x0a"
"    basic_string\x26 insert(size_type pos, const value_type* s);\x0a"
"    basic_string\x26 insert(size_type pos, size_type n, value_type c);\x0a"
"    iterator      insert(const_iterator p, value_type c);\x0a"
"    iterator      insert(const_iterator p, size_type n, value_type c);\x0a"
"    template<class InputIterator>\x0a"
"        iterator insert(const_iterator p, InputIterator first, InputIterator last);\x0a"
"    iterator      insert(const_iterator p, initializer_list<value_type>);\x0a"
"\x0a"
"    basic_string\x26 erase(size_type pos = 0, size_type n = npos);\x0a"
"    iterator      erase(const_iterator position);\x0a"
"    iterator      erase(const_iterator first, const_iterator last);\x0a"
"\x0a"
"    basic_string\x26 replace(size_type pos1, size_type n1, const basic_string\x26 str);\x0a"
"    template <class T>\x0a"
"    basic_string\x26 replace(size_type pos1, size_type n1, const T\x26 t);  // C++17\x0a"
"    basic_string\x26 replace(size_type pos1, size_type n1, const basic_string\x26 str,\x0a"
"                          size_type pos2, size_type n2=npos); // C++14\x0a"
"    template <class T>\x0a"
"        basic_string\x26 replace(size_type pos1, size_type n1, const T\x26 t,\x0a"
"                              size_type pos2, size_type n); // C++17\x0a"
"    basic_string\x26 replace(size_type pos, size_type n1, const value_type* s, size_type n2);\x0a"
"    basic_string\x26 replace(size_type pos, size_type n1, const value_type* s);\x0a"
"    basic_string\x26 replace(size_type pos, size_type n1, size_type n2, value_type c);\x0a"
"    basic_string\x26 replace(const_iterator i1, const_iterator i2, const basic_string\x26 str);\x0a"
"    template <class T>\x0a"
"        basic_string\x26 replace(const_iterator i1, const_iterator i2, const T\x26 t);  // C++17\x0a"
"    basic_string\x26 replace(const_iterator i1, const_iterator i2, const value_type* s, size_type n);\x0a"
"    basic_string\x26 replace(const_iterator i1, const_iterator i2, const value_type* s);\x0a"
"    basic_string\x26 replace(const_iterator i1, const_iterator i2, size_type n, value_type c);\x0a"
"    template<class InputIterator>\x0a"
"        basic_string\x26 replace(const_iterator i1, const_iterator i2, InputIterator j1, InputIterator j2);\x0a"
"    basic_string\x26 replace(const_iterator i1, const_iterator i2, initializer_list<value_type>);\x0a"
"\x0a"
"    size_type copy(value_type* s, size_type n, size_type pos = 0) const;\x0a"
"    basic_string substr(size_type pos = 0, size_type n = npos) const;\x0a"
"\x0a"
"    void swap(basic_string\x26 str)\x0a"
"        noexcept(allocator_traits<allocator_type>\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                 allocator_traits<allocator_type>\x3a\x3ais_always_equal\x3a\x3avalue);  // C++17\x0a"
"\x0a"
"    const value_type* c_str() const noexcept;\x0a"
"    const value_type* data() const noexcept;\x0a"
"          value_type* data()       noexcept;   // C++17\x0a"
"\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"\x0a"
"    size_type find(const basic_string\x26 str, size_type pos = 0) const noexcept;\x0a"
"    template <class T>\x0a"
"        size_type find(const T\x26 t, size_type pos = 0) const;  // C++17\x0a"
"    size_type find(const value_type* s, size_type pos, size_type n) const noexcept;\x0a"
"    size_type find(const value_type* s, size_type pos = 0) const noexcept;\x0a"
"    size_type find(value_type c, size_type pos = 0) const noexcept;\x0a"
"\x0a"
"    size_type rfind(const basic_string\x26 str, size_type pos = npos) const noexcept;\x0a"
"    template <class T>\x0a"
"        size_type rfind(const T\x26 t, size_type pos = npos) const;  // C++17\x0a"
"    size_type rfind(const value_type* s, size_type pos, size_type n) const noexcept;\x0a"
"    size_type rfind(const value_type* s, size_type pos = npos) const noexcept;\x0a"
"    size_type rfind(value_type c, size_type pos = npos) const noexcept;\x0a"
"\x0a"
"    size_type find_first_of(const basic_string\x26 str, size_type pos = 0) const noexcept;\x0a"
"    template <class T>\x0a"
"        size_type find_first_of(const T\x26 t, size_type pos = 0) const; // C++17\x0a"
"    size_type find_first_of(const value_type* s, size_type pos, size_type n) const noexcept;\x0a"
"    size_type find_first_of(const value_type* s, size_type pos = 0) const noexcept;\x0a"
"    size_type find_first_of(value_type c, size_type pos = 0) const noexcept;\x0a"
"\x0a"
"    size_type find_last_of(const basic_string\x26 str, size_type pos = npos) const noexcept;\x0a"
"    template <class T>\x0a"
"        size_type find_last_of(const T\x26 t, size_type pos = npos) const noexcept;  // C++17\x0a"
"    size_type find_last_of(const value_type* s, size_type pos, size_type n) const noexcept;\x0a"
"    size_type find_last_of(const value_type* s, size_type pos = npos) const noexcept;\x0a"
"    size_type find_last_of(value_type c, size_type pos = npos) const noexcept;\x0a"
"\x0a"
"    size_type find_first_not_of(const basic_string\x26 str, size_type pos = 0) const noexcept;\x0a"
"    template <class T>\x0a"
"        size_type find_first_not_of(const T\x26 t, size_type pos = 0) const; // C++17\x0a"
"    size_type find_first_not_of(const value_type* s, size_type pos, size_type n) const noexcept;\x0a"
"    size_type find_first_not_of(const value_type* s, size_type pos = 0) const noexcept;\x0a"
"    size_type find_first_not_of(value_type c, size_type pos = 0) const noexcept;\x0a"
"\x0a"
"    size_type find_last_not_of(const basic_string\x26 str, size_type pos = npos) const noexcept;\x0a"
"    template <class T>\x0a"
"        size_type find_last_not_of(const T\x26 t, size_type pos = npos) const; // C++17\x0a"
"    size_type find_last_not_of(const value_type* s, size_type pos, size_type n) const noexcept;\x0a"
"    size_type find_last_not_of(const value_type* s, size_type pos = npos) const noexcept;\x0a"
"    size_type find_last_not_of(value_type c, size_type pos = npos) const noexcept;\x0a"
"\x0a"
"    int compare(const basic_string\x26 str) const noexcept;\x0a"
"    template <class T>\x0a"
"        int compare(const T\x26 t) const noexcept;  // C++17\x0a"
"    int compare(size_type pos1, size_type n1, const basic_string\x26 str) const;\x0a"
"    template <class T>\x0a"
"        int compare(size_type pos1, size_type n1, const T\x26 t) const;  // C++17\x0a"
"    int compare(size_type pos1, size_type n1, const basic_string\x26 str,\x0a"
"                size_type pos2, size_type n2=npos) const; // C++14\x0a"
"    template <class T>\x0a"
"        int compare(size_type pos1, size_type n1, const T\x26 t,\x0a"
"                    size_type pos2, size_type n2=npos) const; // C++17\x0a"
"    int compare(const value_type* s) const noexcept;\x0a"
"    int compare(size_type pos1, size_type n1, const value_type* s) const;\x0a"
"    int compare(size_type pos1, size_type n1, const value_type* s, size_type n2) const;\x0a"
"\x0a"
"    bool starts_with(basic_string_view<charT, traits> sv) const noexcept; // C++2a\x0a"
"    bool starts_with(charT c) const noexcept;                             // C++2a\x0a"
"    bool starts_with(const charT* s) const;                               // C++2a\x0a"
"    bool ends_with(basic_string_view<charT, traits> sv) const noexcept;   // C++2a\x0a"
"    bool ends_with(charT c) const noexcept;                               // C++2a\x0a"
"    bool ends_with(const charT* s) const;                                 // C++2a\x0a"
"\x0a"
"    bool __invariants() const;\x0a"
"};\x0a"
"\x0a"
"template<class InputIterator,\x0a"
"         class Allocator = allocator<typename iterator_traits<InputIterator>\x3a\x3avalue_type>>\x0a"
"basic_string(InputIterator, InputIterator, Allocator = Allocator())\x0a"
"   -> basic_string<typename iterator_traits<InputIterator>\x3a\x3avalue_type,\x0a"
"                  char_traits<typename iterator_traits<InputIterator>\x3a\x3avalue_type>,\x0a"
"                  Allocator>;   // C++17\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"basic_string<charT, traits, Allocator>\x0a"
"operator+(const basic_string<charT, traits, Allocator>\x26 lhs,\x0a"
"          const basic_string<charT, traits, Allocator>\x26 rhs);\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"basic_string<charT, traits, Allocator>\x0a"
"operator+(const charT* lhs , const basic_string<charT,traits,Allocator>\x26rhs);\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"basic_string<charT, traits, Allocator>\x0a"
"operator+(charT lhs, const basic_string<charT,traits,Allocator>\x26 rhs);\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"basic_string<charT, traits, Allocator>\x0a"
"operator+(const basic_string<charT, traits, Allocator>\x26 lhs, const charT* rhs);\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"basic_string<charT, traits, Allocator>\x0a"
"operator+(const basic_string<charT, traits, Allocator>\x26 lhs, charT rhs);\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator==(const basic_string<charT, traits, Allocator>\x26 lhs,\x0a"
"                const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator==(const charT* lhs, const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator==(const basic_string<charT,traits,Allocator>\x26 lhs, const charT* rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator\x21=(const basic_string<charT,traits,Allocator>\x26 lhs,\x0a"
"                const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator\x21=(const charT* lhs, const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator\x21=(const basic_string<charT, traits, Allocator>\x26 lhs, const charT* rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator< (const basic_string<charT, traits, Allocator>\x26 lhs,\x0a"
"                const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator< (const basic_string<charT, traits, Allocator>\x26 lhs, const charT* rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator< (const charT* lhs, const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator> (const basic_string<charT, traits, Allocator>\x26 lhs,\x0a"
"                const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator> (const basic_string<charT, traits, Allocator>\x26 lhs, const charT* rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator> (const charT* lhs, const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator<=(const basic_string<charT, traits, Allocator>\x26 lhs,\x0a"
"                const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator<=(const basic_string<charT, traits, Allocator>\x26 lhs, const charT* rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator<=(const charT* lhs, const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator>=(const basic_string<charT, traits, Allocator>\x26 lhs,\x0a"
"                const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator>=(const basic_string<charT, traits, Allocator>\x26 lhs, const charT* rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"bool operator>=(const charT* lhs, const basic_string<charT, traits, Allocator>\x26 rhs) noexcept;\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"void swap(basic_string<charT, traits, Allocator>\x26 lhs,\x0a"
"          basic_string<charT, traits, Allocator>\x26 rhs)\x0a"
"            noexcept(noexcept(lhs.swap(rhs)));\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"basic_istream<charT, traits>\x26\x0a"
"operator>>(basic_istream<charT, traits>\x26 is, basic_string<charT, traits, Allocator>\x26 str);\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"basic_ostream<charT, traits>\x26\x0a"
"operator<<(basic_ostream<charT, traits>\x26 os, const basic_string<charT, traits, Allocator>\x26 str);\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"basic_istream<charT, traits>\x26\x0a"
"getline(basic_istream<charT, traits>\x26 is, basic_string<charT, traits, Allocator>\x26 str,\x0a"
"        charT delim);\x0a"
"\x0a"
"template<class charT, class traits, class Allocator>\x0a"
"basic_istream<charT, traits>\x26\x0a"
"getline(basic_istream<charT, traits>\x26 is, basic_string<charT, traits, Allocator>\x26 str);\x0a"
"\x0a"
"template<class charT, class traits, class Allocator, class U>\x0a"
"void erase(basic_string<charT, traits, Allocator>\x26 c, const U\x26 value); // C++20\x0a"
"template<class charT, class traits, class Allocator, class Predicate>\x0a"
"void erase_if(basic_string<charT, traits, Allocator>\x26 c, Predicate pred); // C++20\x0a"
"\x0a"
"typedef basic_string<char>    string;\x0a"
"typedef basic_string<wchar_t> wstring;\x0a"
"typedef basic_string<char16_t> u16string;\x0a"
"typedef basic_string<char32_t> u32string;\x0a"
"\x0a"
"int                stoi  (const string\x26 str, size_t* idx = 0, int base = 10);\x0a"
"long               stol  (const string\x26 str, size_t* idx = 0, int base = 10);\x0a"
"unsigned long      stoul (const string\x26 str, size_t* idx = 0, int base = 10);\x0a"
"long long          stoll (const string\x26 str, size_t* idx = 0, int base = 10);\x0a"
"unsigned long long stoull(const string\x26 str, size_t* idx = 0, int base = 10);\x0a"
"\x0a"
"float       stof (const string\x26 str, size_t* idx = 0);\x0a"
"double      stod (const string\x26 str, size_t* idx = 0);\x0a"
"long double stold(const string\x26 str, size_t* idx = 0);\x0a"
"\x0a"
"string to_string(int val);\x0a"
"string to_string(unsigned val);\x0a"
"string to_string(long val);\x0a"
"string to_string(unsigned long val);\x0a"
"string to_string(long long val);\x0a"
"string to_string(unsigned long long val);\x0a"
"string to_string(float val);\x0a"
"string to_string(double val);\x0a"
"string to_string(long double val);\x0a"
"\x0a"
"int                stoi  (const wstring\x26 str, size_t* idx = 0, int base = 10);\x0a"
"long               stol  (const wstring\x26 str, size_t* idx = 0, int base = 10);\x0a"
"unsigned long      stoul (const wstring\x26 str, size_t* idx = 0, int base = 10);\x0a"
"long long          stoll (const wstring\x26 str, size_t* idx = 0, int base = 10);\x0a"
"unsigned long long stoull(const wstring\x26 str, size_t* idx = 0, int base = 10);\x0a"
"\x0a"
"float       stof (const wstring\x26 str, size_t* idx = 0);\x0a"
"double      stod (const wstring\x26 str, size_t* idx = 0);\x0a"
"long double stold(const wstring\x26 str, size_t* idx = 0);\x0a"
"\x0a"
"wstring to_wstring(int val);\x0a"
"wstring to_wstring(unsigned val);\x0a"
"wstring to_wstring(long val);\x0a"
"wstring to_wstring(unsigned long val);\x0a"
"wstring to_wstring(long long val);\x0a"
"wstring to_wstring(unsigned long long val);\x0a"
"wstring to_wstring(float val);\x0a"
"wstring to_wstring(double val);\x0a"
"wstring to_wstring(long double val);\x0a"
"\x0a"
"template <> struct hash<string>;\x0a"
"template <> struct hash<u16string>;\x0a"
"template <> struct hash<u32string>;\x0a"
"template <> struct hash<wstring>;\x0a"
"\x0a"
"basic_string<char>     operator \x22\x22 s( const char *str,     size_t len ); // C++14\x0a"
"basic_string<wchar_t>  operator \x22\x22 s( const wchar_t *str,  size_t len ); // C++14\x0a"
"basic_string<char16_t> operator \x22\x22 s( const char16_t *str, size_t len ); // C++14\x0a"
"basic_string<char32_t> operator \x22\x22 s( const char32_t *str, size_t len ); // C++14\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <string_view>\x0a"
"#include <iosfwd>\x0a"
"#include <cstring>\x0a"
"#include <cstdio>  // For EOF.\x0a"
"#include <cwchar>\x0a"
"#include <algorithm>\x0a"
"#include <iterator>\x0a"
"#include <utility>\x0a"
"#include <memory>\x0a"
"#include <stdexcept>\x0a"
"#include <type_traits>\x0a"
"#include <initializer_list>\x0a"
"#include <__functional_base>\x0a"
"#include <version>\x0a"
"#ifndef _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"#include <cstdint>\x0a"
"#endif\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"// fpos\x0a"
"\x0a"
"template <class _StateT>\x0a"
"class _LIBCPP_TEMPLATE_VIS fpos\x0a"
"{\x0a"
"private\x3a\x0a"
"    _StateT __st_;\x0a"
"    streamoff __off_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY fpos(streamoff __off = streamoff()) \x3a __st_(), __off_(__off) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY operator streamoff() const {return __off_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY _StateT state() const {return __st_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY void state(_StateT __st) {__st_ = __st;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY fpos\x26 operator+=(streamoff __off) {__off_ += __off; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY fpos  operator+ (streamoff __off) const {fpos __t(*this); __t += __off; return __t;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY fpos\x26 operator-=(streamoff __off) {__off_ -= __off; return *this;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY fpos  operator- (streamoff __off) const {fpos __t(*this); __t -= __off; return __t;}\x0a"
"};\x0a"
"\x0a"
"template <class _StateT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"streamoff operator-(const fpos<_StateT>\x26 __x, const fpos<_StateT>\x26 __y)\x0a"
"    {return streamoff(__x) - streamoff(__y);}\x0a"
"\x0a"
"template <class _StateT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator==(const fpos<_StateT>\x26 __x, const fpos<_StateT>\x26 __y)\x0a"
"    {return streamoff(__x) == streamoff(__y);}\x0a"
"\x0a"
"template <class _StateT>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool operator\x21=(const fpos<_StateT>\x26 __x, const fpos<_StateT>\x26 __y)\x0a"
"    {return streamoff(__x) \x21= streamoff(__y);}\x0a"
"\x0a"
"// basic_string\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(const basic_string<_CharT, _Traits, _Allocator>\x26 __x,\x0a"
"          const basic_string<_CharT, _Traits, _Allocator>\x26 __y);\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(const _CharT* __x, const basic_string<_CharT,_Traits,_Allocator>\x26 __y);\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(_CharT __x, const basic_string<_CharT,_Traits,_Allocator>\x26 __y);\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(const basic_string<_CharT, _Traits, _Allocator>\x26 __x, const _CharT* __y);\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(const basic_string<_CharT, _Traits, _Allocator>\x26 __x, _CharT __y);\x0a"
"\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS string operator+<char, char_traits<char>, allocator<char> >(char const*, string const\x26))\x0a"
"\x0a"
"template <bool>\x0a"
"class _LIBCPP_TEMPLATE_VIS __basic_string_common\x0a"
"{\x0a"
"protected\x3a\x0a"
"    _LIBCPP_NORETURN void __throw_length_error() const;\x0a"
"    _LIBCPP_NORETURN void __throw_out_of_range() const;\x0a"
"};\x0a"
"\x0a"
"template <bool __b>\x0a"
"void\x0a"
"__basic_string_common<__b>\x3a\x3a__throw_length_error() const\x0a"
"{\x0a"
"    _VSTD\x3a\x3a__throw_length_error(\x22""basic_string\x22);\x0a"
"}\x0a"
"\x0a"
"template <bool __b>\x0a"
"void\x0a"
"__basic_string_common<__b>\x3a\x3a__throw_out_of_range() const\x0a"
"{\x0a"
"    _VSTD\x3a\x3a__throw_out_of_range(\x22""basic_string\x22);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS __basic_string_common<true>)\x0a"
"\x0a"
"#ifdef _LIBCPP_NO_EXCEPTIONS\x0a"
"template <class _Iter>\x0a"
"struct __libcpp_string_gets_noexcept_iterator_impl \x3a public true_type {};\x0a"
"#elif defined(_LIBCPP_HAS_NO_NOEXCEPT)\x0a"
"template <class _Iter>\x0a"
"struct __libcpp_string_gets_noexcept_iterator_impl \x3a public false_type {};\x0a"
"#else\x0a"
"template <class _Iter, bool = __is_forward_iterator<_Iter>\x3a\x3avalue>\x0a"
"struct __libcpp_string_gets_noexcept_iterator_impl \x3a public _LIBCPP_BOOL_CONSTANT((\x0a"
"    noexcept(++(declval<_Iter\x26>())) \x26\x26\x0a"
"    is_nothrow_assignable<_Iter\x26, _Iter>\x3a\x3avalue \x26\x26\x0a"
"    noexcept(declval<_Iter>() == declval<_Iter>()) \x26\x26\x0a"
"    noexcept(*declval<_Iter>())\x0a"
")) {};\x0a"
"\x0a"
"template <class _Iter>\x0a"
"struct __libcpp_string_gets_noexcept_iterator_impl<_Iter, false> \x3a public false_type {};\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"template <class _Iter>\x0a"
"struct __libcpp_string_gets_noexcept_iterator\x0a"
"    \x3a public _LIBCPP_BOOL_CONSTANT(__libcpp_is_trivial_iterator<_Iter>\x3a\x3avalue \x7c\x7c __libcpp_string_gets_noexcept_iterator_impl<_Iter>\x3a\x3avalue) {};\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Tp>\x0a"
"struct __can_be_converted_to_string_view \x3a public _LIBCPP_BOOL_CONSTANT(\x0a"
"    ( is_convertible<const _Tp\x26, basic_string_view<_CharT, _Traits> >\x3a\x3avalue \x26\x26\x0a"
"     \x21is_convertible<const _Tp\x26, const _CharT*>\x3a\x3avalue)) {};\x0a"
"\x0a"
"#ifdef _LIBCPP_ABI_ALTERNATE_STRING_LAYOUT\x0a"
"\x0a"
"template <class _CharT, size_t = sizeof(_CharT)>\x0a"
"struct __padding\x0a"
"{\x0a"
"    unsigned char __xx\x5bsizeof(_CharT)-1\x5d;\x0a"
"};\x0a"
"\x0a"
"template <class _CharT>\x0a"
"struct __padding<_CharT, 1>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_ABI_ALTERNATE_STRING_LAYOUT\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"class _LIBCPP_TEMPLATE_VIS basic_string\x0a"
"    \x3a private __basic_string_common<true>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef basic_string                                 __self;\x0a"
"    typedef basic_string_view<_CharT, _Traits>           __self_view;\x0a"
"    typedef _Traits                                      traits_type;\x0a"
"    typedef _CharT                                       value_type;\x0a"
"    typedef _Allocator                                   allocator_type;\x0a"
"    typedef allocator_traits<allocator_type>             __alloc_traits;\x0a"
"    typedef typename __alloc_traits\x3a\x3asize_type           size_type;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""difference_type     difference_type;\x0a"
"    typedef value_type\x26                                  reference;\x0a"
"    typedef const value_type\x26                            const_reference;\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer             pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer       const_pointer;\x0a"
"\x0a"
"    static_assert((\x21is_array<value_type>\x3a\x3avalue), \x22""Character type of basic_string must not be an array\x22);\x0a"
"    static_assert(( is_standard_layout<value_type>\x3a\x3avalue), \x22""Character type of basic_string must be standard-layout\x22);\x0a"
"    static_assert(( is_trivial<value_type>\x3a\x3avalue), \x22""Character type of basic_string must be trivial\x22);\x0a"
"    static_assert(( is_same<_CharT, typename traits_type\x3a\x3a""char_type>\x3a\x3avalue),\x0a"
"                  \x22traits_type\x3a\x3a""char_type must be the same type as CharT\x22);\x0a"
"    static_assert(( is_same<typename allocator_type\x3a\x3avalue_type, value_type>\x3a\x3avalue),\x0a"
"                  \x22""Allocator\x3a\x3avalue_type must be same type as value_type\x22);\x0a"
"\x0a"
"#if defined(_LIBCPP_RAW_ITERATORS)\x0a"
"    typedef pointer                                      iterator;\x0a"
"    typedef const_pointer                                const_iterator;\x0a"
"#else  // defined(_LIBCPP_RAW_ITERATORS)\x0a"
"    typedef __wrap_iter<pointer>                         iterator;\x0a"
"    typedef __wrap_iter<const_pointer>                   const_iterator;\x0a"
"#endif  // defined(_LIBCPP_RAW_ITERATORS)\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<iterator>             reverse_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<const_iterator>       const_reverse_iterator;\x0a"
"\x0a"
"private\x3a\x0a"
"\x0a"
"#ifdef _LIBCPP_ABI_ALTERNATE_STRING_LAYOUT\x0a"
"\x0a"
"    struct __long\x0a"
"    {\x0a"
"        pointer   __data_;\x0a"
"        size_type __size_;\x0a"
"        size_type __cap_;\x0a"
"    };\x0a"
"\x0a"
"#ifdef _LIBCPP_BIG_ENDIAN\x0a"
"    static const size_type __short_mask = 0x01;\x0a"
"    static const size_type __long_mask  = 0x1ul;\x0a"
"#else  // _LIBCPP_BIG_ENDIAN\x0a"
"    static const size_type __short_mask = 0x80;\x0a"
"    static const size_type __long_mask  = \x7e(size_type(\x7e""0) >> 1);\x0a"
"#endif  // _LIBCPP_BIG_ENDIAN\x0a"
"\x0a"
"    enum {__min_cap = (sizeof(__long) - 1)/sizeof(value_type) > 2 \x3f\x0a"
"                      (sizeof(__long) - 1)/sizeof(value_type) \x3a 2};\x0a"
"\x0a"
"    struct __short\x0a"
"    {\x0a"
"        value_type __data_\x5b__min_cap\x5d;\x0a"
"        struct\x0a"
"            \x3a __padding<value_type>\x0a"
"        {\x0a"
"            unsigned char __size_;\x0a"
"        };\x0a"
"    };\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"    struct __long\x0a"
"    {\x0a"
"        size_type __cap_;\x0a"
"        size_type __size_;\x0a"
"        pointer   __data_;\x0a"
"    };\x0a"
"\x0a"
"#ifdef _LIBCPP_BIG_ENDIAN\x0a"
"    static const size_type __short_mask = 0x80;\x0a"
"    static const size_type __long_mask  = \x7e(size_type(\x7e""0) >> 1);\x0a"
"#else  // _LIBCPP_BIG_ENDIAN\x0a"
"    static const size_type __short_mask = 0x01;\x0a"
"    static const size_type __long_mask  = 0x1ul;\x0a"
"#endif  // _LIBCPP_BIG_ENDIAN\x0a"
"\x0a"
"    enum {__min_cap = (sizeof(__long) - 1)/sizeof(value_type) > 2 \x3f\x0a"
"                      (sizeof(__long) - 1)/sizeof(value_type) \x3a 2};\x0a"
"\x0a"
"    struct __short\x0a"
"    {\x0a"
"        union\x0a"
"        {\x0a"
"            unsigned char __size_;\x0a"
"            value_type __lx;\x0a"
"        };\x0a"
"        value_type __data_\x5b__min_cap\x5d;\x0a"
"    };\x0a"
"\x0a"
"#endif  // _LIBCPP_ABI_ALTERNATE_STRING_LAYOUT\x0a"
"\x0a"
"    union __ulx{__long __lx; __short __lxx;};\x0a"
"\x0a"
"    enum {__n_words = sizeof(__ulx) / sizeof(size_type)};\x0a"
"\x0a"
"    struct __raw\x0a"
"    {\x0a"
"        size_type __words\x5b__n_words\x5d;\x0a"
"    };\x0a"
"\x0a"
"    struct __rep\x0a"
"    {\x0a"
"        union\x0a"
"        {\x0a"
"            __long  __l;\x0a"
"            __short __s;\x0a"
"            __raw   __r;\x0a"
"        };\x0a"
"    };\x0a"
"\x0a"
"    __compressed_pair<__rep, allocator_type> __r_;\x0a"
"\x0a"
"public\x3a\x0a"
"    static const size_type npos = -1;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY basic_string()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit basic_string(const allocator_type\x26 __a)\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<allocator_type>\x3a\x3avalue);\x0a"
"#else\x0a"
"        _NOEXCEPT;\x0a"
"#endif\x0a"
"\x0a"
"    basic_string(const basic_string\x26 __str);\x0a"
"    basic_string(const basic_string\x26 __str, const allocator_type\x26 __a);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string(basic_string\x26\x26 __str)\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"#else\x0a"
"        _NOEXCEPT;\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string(basic_string\x26\x26 __str, const allocator_type\x26 __a);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"    template <class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, nullptr_t>\x3a\x3atype>\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string(const _CharT* __s) {\x0a"
"      _LIBCPP_ASSERT(__s \x21= nullptr, \x22""basic_string(const char*) detected nullptr\x22);\x0a"
"      __init(__s, traits_type\x3a\x3alength(__s));\x0a"
"#   if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"      __get_db()->__insert_c(this);\x0a"
"#   endif\x0a"
"    }\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"    template <class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, nullptr_t>\x3a\x3atype>\x0a"
"#endif\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        basic_string(const _CharT* __s, const _Allocator\x26 __a);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string(const _CharT* __s, size_type __n);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string(const _CharT* __s, size_type __n, const _Allocator\x26 __a);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string(size_type __n, _CharT __c);\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"    template <class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, nullptr_t>\x3a\x3atype>\x0a"
"#endif\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        basic_string(size_type __n, _CharT __c, const _Allocator\x26 __a);\x0a"
"\x0a"
"    basic_string(const basic_string\x26 __str, size_type __pos, size_type __n,\x0a"
"                 const _Allocator\x26 __a = _Allocator());\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string(const basic_string\x26 __str, size_type __pos,\x0a"
"                 const _Allocator\x26 __a = _Allocator());\x0a"
"\x0a"
"    template<class _Tp, class = typename enable_if<__can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        basic_string(const _Tp\x26 __t, size_type __pos, size_type __n,\x0a"
"                              const allocator_type\x26 __a = allocator_type());\x0a"
"\x0a"
"    template<class _Tp, class = typename enable_if<__can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        explicit basic_string(const _Tp\x26 __t);\x0a"
"\x0a"
"    template<class _Tp, class = typename enable_if<__can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"        _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"        explicit basic_string(const _Tp\x26 __t, const allocator_type\x26 __a);\x0a"
"\x0a"
"    template<class _InputIterator, class = typename enable_if<__is_input_iterator<_InputIterator>\x3a\x3avalue>\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        basic_string(_InputIterator __first, _InputIterator __last);\x0a"
"    template<class _InputIterator, class = typename enable_if<__is_input_iterator<_InputIterator>\x3a\x3avalue>\x3a\x3atype>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        basic_string(_InputIterator __first, _InputIterator __last, const allocator_type\x26 __a);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string(initializer_list<_CharT> __il);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string(initializer_list<_CharT> __il, const _Allocator\x26 __a);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    inline \x7e""basic_string();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator __self_view() const _NOEXCEPT { return __self_view(data(), size()); }\x0a"
"\x0a"
"    basic_string\x26 operator=(const basic_string\x26 __str);\x0a"
"\x0a"
"    template <class _Tp, class = typename enable_if<__can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue, void>\x3a\x3atype>\x0a"
"    basic_string\x26 operator=(const _Tp\x26 __t)\x0a"
"        {__self_view __sv = __t; return assign(__sv);}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 operator=(basic_string\x26\x26 __str)\x0a"
"        _NOEXCEPT_((__noexcept_move_assign_container<_Allocator, __alloc_traits>\x3a\x3avalue));\x0a"
"     _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 operator=(initializer_list<value_type> __il) {return assign(__il.begin(), __il.size());}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY basic_string\x26 operator=(const value_type* __s) {return assign(__s);}\x0a"
"    basic_string\x26 operator=(value_type __c);\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator begin() _NOEXCEPT\x0a"
"        {return iterator(this, __get_pointer());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT\x0a"
"        {return const_iterator(this, __get_pointer());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator end() _NOEXCEPT\x0a"
"        {return iterator(this, __get_pointer() + size());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end() const _NOEXCEPT\x0a"
"        {return const_iterator(this, __get_pointer() + size());}\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator begin() _NOEXCEPT\x0a"
"        {return iterator(__get_pointer());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT\x0a"
"        {return const_iterator(__get_pointer());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator end() _NOEXCEPT\x0a"
"        {return iterator(__get_pointer() + size());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end() const _NOEXCEPT\x0a"
"        {return const_iterator(__get_pointer() + size());}\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reverse_iterator rbegin() _NOEXCEPT\x0a"
"        {return reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reverse_iterator rend() _NOEXCEPT\x0a"
"        {return reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cbegin() const _NOEXCEPT\x0a"
"        {return begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator cend() const _NOEXCEPT\x0a"
"        {return end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT\x0a"
"        {return rbegin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend() const _NOEXCEPT\x0a"
"        {return rend();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_type size() const _NOEXCEPT\x0a"
"        {return __is_long() \x3f __get_long_size() \x3a __get_short_size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_type length() const _NOEXCEPT {return size();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_type max_size() const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_type capacity() const _NOEXCEPT\x0a"
"        {return (__is_long() \x3f __get_long_cap()\x0a"
"                             \x3a static_cast<size_type>(__min_cap)) - 1;}\x0a"
"\x0a"
"    void resize(size_type __n, value_type __c);\x0a"
"    _LIBCPP_INLINE_VISIBILITY void resize(size_type __n) {resize(__n, value_type());}\x0a"
"\x0a"
"    void reserve(size_type __res_arg);\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __resize_default_init(size_type __n);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void reserve() _NOEXCEPT {reserve(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void shrink_to_fit() _NOEXCEPT {reserve();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT;\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT {return size() == 0;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_reference operator\x5b\x5d(size_type __pos) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference       operator\x5b\x5d(size_type __pos)       _NOEXCEPT;\x0a"
"\x0a"
"    const_reference at(size_type __n) const;\x0a"
"    reference       at(size_type __n);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY basic_string\x26 operator+=(const basic_string\x26 __str) {return append(__str);}\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"                                            operator+=(const _Tp\x26 __t)            {__self_view __sv = __t; return append(__sv);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY basic_string\x26 operator+=(const value_type* __s)     {return append(__s);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY basic_string\x26 operator+=(value_type __c)            {push_back(__c); return *this;}\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY basic_string\x26 operator+=(initializer_list<value_type> __il) {return append(__il);}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 append(const basic_string\x26 __str);\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"                  append(const _Tp\x26 __t) { __self_view __sv = __t; return append(__sv.data(), __sv.size()); }\x0a"
"    basic_string\x26 append(const basic_string\x26 __str, size_type __pos, size_type __n=npos);\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"                  append(const _Tp\x26 __t, size_type __pos, size_type __n=npos);\x0a"
"    basic_string\x26 append(const value_type* __s, size_type __n);\x0a"
"    basic_string\x26 append(const value_type* __s);\x0a"
"    basic_string\x26 append(size_type __n, value_type __c);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __append_default_init(size_type __n);\x0a"
"\x0a"
"    template <class _ForwardIterator>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    basic_string\x26 __append_forward_unsafe(_ForwardIterator, _ForwardIterator);\x0a"
"    template<class _InputIterator>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __is_exactly_input_iterator<_InputIterator>\x3a\x3avalue\x0a"
"                \x7c\x7c \x21__libcpp_string_gets_noexcept_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    append(_InputIterator __first, _InputIterator __last) {\x0a"
"      const basic_string __temp (__first, __last, __alloc());\x0a"
"      append(__temp.data(), __temp.size());\x0a"
"      return *this;\x0a"
"    }\x0a"
"    template<class _ForwardIterator>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __is_forward_iterator<_ForwardIterator>\x3a\x3avalue\x0a"
"                \x26\x26 __libcpp_string_gets_noexcept_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    append(_ForwardIterator __first, _ForwardIterator __last) {\x0a"
"      return __append_forward_unsafe(__first, __last);\x0a"
"    }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 append(initializer_list<value_type> __il) {return append(__il.begin(), __il.size());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    void push_back(value_type __c);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void pop_back();\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference       front() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_reference front() const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference       back() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_reference back() const _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"                 assign(const _Tp \x26 __t) { __self_view __sv = __t; return assign(__sv.data(), __sv.size()); }\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 assign(const basic_string\x26 __str) { return *this = __str; }\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 assign(basic_string\x26\x26 __str)\x0a"
"        _NOEXCEPT_((__noexcept_move_assign_container<_Allocator, __alloc_traits>\x3a\x3avalue))\x0a"
"        {*this = _VSTD\x3a\x3amove(__str); return *this;}\x0a"
"#endif\x0a"
"    basic_string\x26 assign(const basic_string\x26 __str, size_type __pos, size_type __n=npos);\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"                  assign(const _Tp \x26 __t, size_type __pos, size_type __n=npos);\x0a"
"    basic_string\x26 assign(const value_type* __s, size_type __n);\x0a"
"    basic_string\x26 assign(const value_type* __s);\x0a"
"    basic_string\x26 assign(size_type __n, value_type __c);\x0a"
"    template<class _InputIterator>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"           __is_exactly_input_iterator<_InputIterator>\x3a\x3avalue\x0a"
"                \x7c\x7c \x21__libcpp_string_gets_noexcept_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"        assign(_InputIterator __first, _InputIterator __last);\x0a"
"    template<class _ForwardIterator>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __is_forward_iterator<_ForwardIterator>\x3a\x3avalue\x0a"
"                 \x26\x26 __libcpp_string_gets_noexcept_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"        assign(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 assign(initializer_list<value_type> __il) {return assign(__il.begin(), __il.size());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 insert(size_type __pos1, const basic_string\x26 __str);\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"                 insert(size_type __pos1, const _Tp\x26 __t)\x0a"
"    { __self_view __sv = __t; return insert(__pos1, __sv.data(), __sv.size()); }\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"                  insert(size_type __pos1, const _Tp\x26 __t, size_type __pos2, size_type __n=npos);\x0a"
"    basic_string\x26 insert(size_type __pos1, const basic_string\x26 __str, size_type __pos2, size_type __n=npos);\x0a"
"    basic_string\x26 insert(size_type __pos, const value_type* __s, size_type __n);\x0a"
"    basic_string\x26 insert(size_type __pos, const value_type* __s);\x0a"
"    basic_string\x26 insert(size_type __pos, size_type __n, value_type __c);\x0a"
"    iterator      insert(const_iterator __pos, value_type __c);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator      insert(const_iterator __pos, size_type __n, value_type __c);\x0a"
"    template<class _InputIterator>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"           __is_exactly_input_iterator<_InputIterator>\x3a\x3avalue\x0a"
"                \x7c\x7c \x21__libcpp_string_gets_noexcept_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"            iterator\x0a"
"        >\x3a\x3atype\x0a"
"        insert(const_iterator __pos, _InputIterator __first, _InputIterator __last);\x0a"
"    template<class _ForwardIterator>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __is_forward_iterator<_ForwardIterator>\x3a\x3avalue\x0a"
"                 \x26\x26 __libcpp_string_gets_noexcept_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"            iterator\x0a"
"        >\x3a\x3atype\x0a"
"        insert(const_iterator __pos, _ForwardIterator __first, _ForwardIterator __last);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __pos, initializer_list<value_type> __il)\x0a"
"                    {return insert(__pos, __il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    basic_string\x26 erase(size_type __pos = 0, size_type __n = npos);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator      erase(const_iterator __pos);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator      erase(const_iterator __first, const_iterator __last);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 replace(size_type __pos1, size_type __n1, const basic_string\x26 __str);\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"                  replace(size_type __pos1, size_type __n1, const _Tp\x26 __t) { __self_view __sv = __t; return replace(__pos1, __n1, __sv.data(), __sv.size()); }\x0a"
"    basic_string\x26 replace(size_type __pos1, size_type __n1, const basic_string\x26 __str, size_type __pos2, size_type __n2=npos);\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"                  replace(size_type __pos1, size_type __n1, const _Tp\x26 __t, size_type __pos2, size_type __n2=npos);\x0a"
"    basic_string\x26 replace(size_type __pos, size_type __n1, const value_type* __s, size_type __n2);\x0a"
"    basic_string\x26 replace(size_type __pos, size_type __n1, const value_type* __s);\x0a"
"    basic_string\x26 replace(size_type __pos, size_type __n1, size_type __n2, value_type __c);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 replace(const_iterator __i1, const_iterator __i2, const basic_string\x26 __str);\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"                  replace(const_iterator __i1, const_iterator __i2, const _Tp\x26 __t) { __self_view __sv = __t; return replace(__i1 - begin(), __i2 - __i1, __sv); }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 replace(const_iterator __i1, const_iterator __i2, const value_type* __s, size_type __n);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 replace(const_iterator __i1, const_iterator __i2, const value_type* __s);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 replace(const_iterator __i1, const_iterator __i2, size_type __n, value_type __c);\x0a"
"    template<class _InputIterator>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __is_input_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"            basic_string\x26\x0a"
"        >\x3a\x3atype\x0a"
"        replace(const_iterator __i1, const_iterator __i2, _InputIterator __j1, _InputIterator __j2);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string\x26 replace(const_iterator __i1, const_iterator __i2, initializer_list<value_type> __il)\x0a"
"        {return replace(__i1, __i2, __il.begin(), __il.end());}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    size_type copy(value_type* __s, size_type __n, size_type __pos = 0) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string substr(size_type __pos = 0, size_type __n = npos) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(basic_string\x26 __str)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT;\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<allocator_type>\x3a\x3avalue);\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type* c_str() const _NOEXCEPT {return data();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type* data() const _NOEXCEPT  {return _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());}\x0a"
"#if _LIBCPP_STD_VER > 14 \x7c\x7c defined(_LIBCPP_BUILDING_LIBRARY)\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type* data()             _NOEXCEPT  {return _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT {return __alloc();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find(const basic_string\x26 __str, size_type __pos = 0) const _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            size_type\x0a"
"        >\x3a\x3atype\x0a"
"              find(const _Tp\x26 __t, size_type __pos = 0) const;\x0a"
"    size_type find(const value_type* __s, size_type __pos, size_type __n) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find(const value_type* __s, size_type __pos = 0) const _NOEXCEPT;\x0a"
"    size_type find(value_type __c, size_type __pos = 0) const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type rfind(const basic_string\x26 __str, size_type __pos = npos) const _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            size_type\x0a"
"        >\x3a\x3atype\x0a"
"              rfind(const _Tp\x26 __t, size_type __pos = npos) const;\x0a"
"    size_type rfind(const value_type* __s, size_type __pos, size_type __n) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type rfind(const value_type* __s, size_type __pos = npos) const _NOEXCEPT;\x0a"
"    size_type rfind(value_type __c, size_type __pos = npos) const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_of(const basic_string\x26 __str, size_type __pos = 0) const _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            size_type\x0a"
"        >\x3a\x3atype\x0a"
"              find_first_of(const _Tp\x26 __t, size_type __pos = 0) const;\x0a"
"    size_type find_first_of(const value_type* __s, size_type __pos, size_type __n) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_of(const value_type* __s, size_type __pos = 0) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_of(value_type __c, size_type __pos = 0) const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_of(const basic_string\x26 __str, size_type __pos = npos) const _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            size_type\x0a"
"        >\x3a\x3atype\x0a"
"              find_last_of(const _Tp\x26 __t, size_type __pos = npos) const;\x0a"
"    size_type find_last_of(const value_type* __s, size_type __pos, size_type __n) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_of(const value_type* __s, size_type __pos = npos) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_of(value_type __c, size_type __pos = npos) const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_not_of(const basic_string\x26 __str, size_type __pos = 0) const _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            size_type\x0a"
"        >\x3a\x3atype\x0a"
"              find_first_not_of(const _Tp \x26__t, size_type __pos = 0) const;\x0a"
"    size_type find_first_not_of(const value_type* __s, size_type __pos, size_type __n) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_not_of(const value_type* __s, size_type __pos = 0) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_first_not_of(value_type __c, size_type __pos = 0) const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_not_of(const basic_string\x26 __str, size_type __pos = npos) const _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            size_type\x0a"
"        >\x3a\x3atype\x0a"
"              find_last_not_of(const _Tp\x26 __t, size_type __pos = npos) const;\x0a"
"    size_type find_last_not_of(const value_type* __s, size_type __pos, size_type __n) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_not_of(const value_type* __s, size_type __pos = npos) const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type find_last_not_of(value_type __c, size_type __pos = npos) const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int compare(const basic_string\x26 __str) const _NOEXCEPT;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            int\x0a"
"        >\x3a\x3atype\x0a"
"        compare(const _Tp \x26__t) const;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    _LIBCPP_METHOD_TEMPLATE_IMPLICIT_INSTANTIATION_VIS\x0a"
"    typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            int\x0a"
"        >\x3a\x3atype\x0a"
"         compare(size_type __pos1, size_type __n1, const _Tp\x26 __t) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    int compare(size_type __pos1, size_type __n1, const basic_string\x26 __str) const;\x0a"
"    int compare(size_type __pos1, size_type __n1, const basic_string\x26 __str, size_type __pos2, size_type __n2=npos) const;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"            int\x0a"
"        >\x3a\x3atype\x0a"
"        compare(size_type __pos1, size_type __n1, const _Tp\x26 __t, size_type __pos2, size_type __n2=npos) const;\x0a"
"    int compare(const value_type* __s) const _NOEXCEPT;\x0a"
"    int compare(size_type __pos1, size_type __n1, const value_type* __s) const;\x0a"
"    int compare(size_type __pos1, size_type __n1, const value_type* __s, size_type __n2) const;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool starts_with(__self_view __sv) const _NOEXCEPT\x0a"
"    { return __self_view(data(), size()).starts_with(__sv); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool starts_with(value_type __c) const _NOEXCEPT\x0a"
"    { return \x21""empty() \x26\x26 _Traits\x3a\x3a""eq(front(), __c); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool starts_with(const value_type* __s) const _NOEXCEPT\x0a"
"    { return starts_with(__self_view(__s)); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool ends_with(__self_view __sv) const _NOEXCEPT\x0a"
"    { return __self_view(data(), size()).ends_with( __sv); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool ends_with(value_type __c) const _NOEXCEPT\x0a"
"    { return \x21""empty() \x26\x26 _Traits\x3a\x3a""eq(back(), __c); }\x0a"
"\x0a"
"    _LIBCPP_CONSTEXPR_AFTER_CXX11 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool ends_with(const value_type* __s) const _NOEXCEPT\x0a"
"    { return ends_with(__self_view(__s)); }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY bool __invariants() const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __clear_and_shrink() _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool __is_long() const _NOEXCEPT\x0a"
"        {return bool(__r_.first().__s.__size_ \x26 __short_mask);}\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"    bool __dereferenceable(const const_iterator* __i) const;\x0a"
"    bool __decrementable(const const_iterator* __i) const;\x0a"
"    bool __addable(const const_iterator* __i, ptrdiff_t __n) const;\x0a"
"    bool __subscriptable(const const_iterator* __i, ptrdiff_t __n) const;\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type\x26 __alloc() _NOEXCEPT\x0a"
"        {return __r_.second();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const allocator_type\x26 __alloc() const _NOEXCEPT\x0a"
"        {return __r_.second();}\x0a"
"\x0a"
"#ifdef _LIBCPP_ABI_ALTERNATE_STRING_LAYOUT\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __set_short_size(size_type __s) _NOEXCEPT\x0a"
"#   ifdef _LIBCPP_BIG_ENDIAN\x0a"
"        {__r_.first().__s.__size_ = (unsigned char)(__s << 1);}\x0a"
"#   else\x0a"
"        {__r_.first().__s.__size_ = (unsigned char)(__s);}\x0a"
"#   endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type __get_short_size() const _NOEXCEPT\x0a"
"#   ifdef _LIBCPP_BIG_ENDIAN\x0a"
"        {return __r_.first().__s.__size_ >> 1;}\x0a"
"#   else\x0a"
"        {return __r_.first().__s.__size_;}\x0a"
"#   endif\x0a"
"\x0a"
"#else  // _LIBCPP_ABI_ALTERNATE_STRING_LAYOUT\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __set_short_size(size_type __s) _NOEXCEPT\x0a"
"#   ifdef _LIBCPP_BIG_ENDIAN\x0a"
"        {__r_.first().__s.__size_ = (unsigned char)(__s);}\x0a"
"#   else\x0a"
"        {__r_.first().__s.__size_ = (unsigned char)(__s << 1);}\x0a"
"#   endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type __get_short_size() const _NOEXCEPT\x0a"
"#   ifdef _LIBCPP_BIG_ENDIAN\x0a"
"        {return __r_.first().__s.__size_;}\x0a"
"#   else\x0a"
"        {return __r_.first().__s.__size_ >> 1;}\x0a"
"#   endif\x0a"
"\x0a"
"#endif  // _LIBCPP_ABI_ALTERNATE_STRING_LAYOUT\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __set_long_size(size_type __s) _NOEXCEPT\x0a"
"        {__r_.first().__l.__size_ = __s;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type __get_long_size() const _NOEXCEPT\x0a"
"        {return __r_.first().__l.__size_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __set_size(size_type __s) _NOEXCEPT\x0a"
"        {if (__is_long()) __set_long_size(__s); else __set_short_size(__s);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __set_long_cap(size_type __s) _NOEXCEPT\x0a"
"        {__r_.first().__l.__cap_  = __long_mask \x7c __s;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type __get_long_cap() const _NOEXCEPT\x0a"
"        {return __r_.first().__l.__cap_ \x26 size_type(\x7e__long_mask);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __set_long_pointer(pointer __p) _NOEXCEPT\x0a"
"        {__r_.first().__l.__data_ = __p;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer __get_long_pointer() _NOEXCEPT\x0a"
"        {return __r_.first().__l.__data_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_pointer __get_long_pointer() const _NOEXCEPT\x0a"
"        {return __r_.first().__l.__data_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer __get_short_pointer() _NOEXCEPT\x0a"
"        {return pointer_traits<pointer>\x3a\x3apointer_to(__r_.first().__s.__data_\x5b""0\x5d);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_pointer __get_short_pointer() const _NOEXCEPT\x0a"
"        {return pointer_traits<const_pointer>\x3a\x3apointer_to(__r_.first().__s.__data_\x5b""0\x5d);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer __get_pointer() _NOEXCEPT\x0a"
"        {return __is_long() \x3f __get_long_pointer() \x3a __get_short_pointer();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_pointer __get_pointer() const _NOEXCEPT\x0a"
"        {return __is_long() \x3f __get_long_pointer() \x3a __get_short_pointer();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __zero() _NOEXCEPT\x0a"
"        {\x0a"
"            size_type (\x26__a)\x5b__n_words\x5d = __r_.first().__r.__words;\x0a"
"            for (unsigned __i = 0; __i < __n_words; ++__i)\x0a"
"                __a\x5b__i\x5d = 0;\x0a"
"        }\x0a"
"\x0a"
"    template <size_type __a> static\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        size_type __align_it(size_type __s) _NOEXCEPT\x0a"
"            {return (__s + (__a-1)) \x26 \x7e(__a-1);}\x0a"
"    enum {__alignment = 16};\x0a"
"    static _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type __recommend(size_type __s) _NOEXCEPT\x0a"
"        {\x0a"
"        if (__s < __min_cap) return static_cast<size_type>(__min_cap) - 1;\x0a"
"        size_type __guess = __align_it<sizeof(value_type) < __alignment \x3f\x0a"
"                     __alignment/sizeof(value_type) \x3a 1 > (__s+1) - 1;\x0a"
"        if (__guess == __min_cap) ++__guess;\x0a"
"        return __guess;\x0a"
"        }\x0a"
"\x0a"
"    inline\x0a"
"    void __init(const value_type* __s, size_type __sz, size_type __reserve);\x0a"
"    inline\x0a"
"    void __init(const value_type* __s, size_type __sz);\x0a"
"    inline\x0a"
"    void __init(size_type __n, value_type __c);\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"    inline\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_exactly_input_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    __init(_InputIterator __first, _InputIterator __last);\x0a"
"\x0a"
"    template <class _ForwardIterator>\x0a"
"    inline\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    __init(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"\x0a"
"    void __grow_by(size_type __old_cap, size_type __delta_cap, size_type __old_sz,\x0a"
"                   size_type __n_copy,  size_type __n_del,     size_type __n_add = 0);\x0a"
"    void __grow_by_and_replace(size_type __old_cap, size_type __delta_cap, size_type __old_sz,\x0a"
"                               size_type __n_copy,  size_type __n_del,\x0a"
"                               size_type __n_add, const value_type* __p_new_stuff);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __erase_to_end(size_type __pos);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const basic_string\x26 __str)\x0a"
"        {__copy_assign_alloc(__str, integral_constant<bool,\x0a"
"                      __alloc_traits\x3a\x3apropagate_on_container_copy_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const basic_string\x26 __str, true_type)\x0a"
"        {\x0a"
"            if (__alloc() == __str.__alloc())\x0a"
"                __alloc() = __str.__alloc();\x0a"
"            else\x0a"
"            {\x0a"
"                if (\x21__str.__is_long())\x0a"
"                {\x0a"
"                    __clear_and_shrink();\x0a"
"                    __alloc() = __str.__alloc();\x0a"
"                }\x0a"
"                else\x0a"
"                {\x0a"
"                    allocator_type __a = __str.__alloc();\x0a"
"                    pointer __p = __alloc_traits\x3a\x3a""allocate(__a, __str.__get_long_cap());\x0a"
"                    __clear_and_shrink();\x0a"
"                    __alloc() = _VSTD\x3a\x3amove(__a);\x0a"
"                    __set_long_pointer(__p);\x0a"
"                    __set_long_cap(__str.__get_long_cap());\x0a"
"                    __set_long_size(__str.size());\x0a"
"                }\x0a"
"            }\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const basic_string\x26, false_type) _NOEXCEPT\x0a"
"        {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign(basic_string\x26 __str, false_type)\x0a"
"        _NOEXCEPT_(__alloc_traits\x3a\x3ais_always_equal\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign(basic_string\x26 __str, true_type)\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        _NOEXCEPT;\x0a"
"#else\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue);\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void\x0a"
"    __move_assign_alloc(basic_string\x26 __str)\x0a"
"        _NOEXCEPT_(\x0a"
"            \x21__alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"    {__move_assign_alloc(__str, integral_constant<bool,\x0a"
"                      __alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(basic_string\x26 __c, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"        {\x0a"
"            __alloc() = _VSTD\x3a\x3amove(__c.__alloc());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(basic_string\x26, false_type)\x0a"
"        _NOEXCEPT\x0a"
"        {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __invalidate_all_iterators();\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __invalidate_iterators_past(size_type);\x0a"
"\x0a"
"    friend basic_string operator+<>(const basic_string\x26, const basic_string\x26);\x0a"
"    friend basic_string operator+<>(const value_type*, const basic_string\x26);\x0a"
"    friend basic_string operator+<>(value_type, const basic_string\x26);\x0a"
"    friend basic_string operator+<>(const basic_string\x26, const value_type*);\x0a"
"    friend basic_string operator+<>(const basic_string\x26, value_type);\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _CharT = typename iterator_traits<_InputIterator>\x3a\x3avalue_type,\x0a"
"         class _Allocator = allocator<_CharT>,\x0a"
"         class = typename enable_if<__is_input_iterator<_InputIterator>\x3a\x3avalue, void>\x3a\x3atype,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype\x0a"
"         >\x0a"
"basic_string(_InputIterator, _InputIterator, _Allocator = _Allocator())\x0a"
"  -> basic_string<_CharT, char_traits<_CharT>, _Allocator>;\x0a"
"\x0a"
"template<class _CharT,\x0a"
"         class _Traits,\x0a"
"         class _Allocator = allocator<_CharT>,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype\x0a"
"         >\x0a"
"explicit basic_string(basic_string_view<_CharT, _Traits>, const _Allocator\x26 = _Allocator())\x0a"
"  -> basic_string<_CharT, _Traits, _Allocator>;\x0a"
"\x0a"
"template<class _CharT,\x0a"
"         class _Traits,\x0a"
"         class _Allocator = allocator<_CharT>,\x0a"
"         class = typename enable_if<__is_allocator<_Allocator>\x3a\x3avalue, void>\x3a\x3atype,\x0a"
"         class _Sz = typename allocator_traits<_Allocator>\x3a\x3asize_type\x0a"
"         >\x0a"
"basic_string(basic_string_view<_CharT, _Traits>, _Sz, _Sz, const _Allocator\x26 = _Allocator())\x0a"
"  -> basic_string<_CharT, _Traits, _Allocator>;\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__invalidate_all_iterators()\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__invalidate_all(this);\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__invalidate_iterators_past(size_type\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"                                                                        __pos\x0a"
"#endif\x0a"
"                                                                      )\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __c_node* __c = __get_db()->__find_c_and_lock(this);\x0a"
"    if (__c)\x0a"
"    {\x0a"
"        const_pointer __new_last = __get_pointer() + __pos;\x0a"
"        for (__i_node** __p = __c->end_; __p \x21= __c->beg_; )\x0a"
"        {\x0a"
"            --__p;\x0a"
"            const_iterator* __i = static_cast<const_iterator*>((*__p)->__i_);\x0a"
"            if (__i->base() > __new_last)\x0a"
"            {\x0a"
"                (*__p)->__c_ = nullptr;\x0a"
"                if (--__c->end_ \x21= __p)\x0a"
"                    memmove(__p, __p+1, (__c->end_ - __p)*sizeof(__i_node*));\x0a"
"            }\x0a"
"        }\x0a"
"        __get_db()->unlock();\x0a"
"    }\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string()\x0a"
"    _NOEXCEPT_(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __zero();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(const allocator_type\x26 __a)\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<allocator_type>\x3a\x3avalue)\x0a"
"#else\x0a"
"        _NOEXCEPT\x0a"
"#endif\x0a"
"\x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    __zero();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__init(const value_type* __s,\x0a"
"                                                       size_type __sz,\x0a"
"                                                       size_type __reserve)\x0a"
"{\x0a"
"    if (__reserve > max_size())\x0a"
"        this->__throw_length_error();\x0a"
"    pointer __p;\x0a"
"    if (__reserve < __min_cap)\x0a"
"    {\x0a"
"        __set_short_size(__sz);\x0a"
"        __p = __get_short_pointer();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        size_type __cap = __recommend(__reserve);\x0a"
"        __p = __alloc_traits\x3a\x3a""allocate(__alloc(), __cap+1);\x0a"
"        __set_long_pointer(__p);\x0a"
"        __set_long_cap(__cap+1);\x0a"
"        __set_long_size(__sz);\x0a"
"    }\x0a"
"    traits_type\x3a\x3a""copy(_VSTD\x3a\x3a__to_raw_pointer(__p), __s, __sz);\x0a"
"    traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__init(const value_type* __s, size_type __sz)\x0a"
"{\x0a"
"    if (__sz > max_size())\x0a"
"        this->__throw_length_error();\x0a"
"    pointer __p;\x0a"
"    if (__sz < __min_cap)\x0a"
"    {\x0a"
"        __set_short_size(__sz);\x0a"
"        __p = __get_short_pointer();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        size_type __cap = __recommend(__sz);\x0a"
"        __p = __alloc_traits\x3a\x3a""allocate(__alloc(), __cap+1);\x0a"
"        __set_long_pointer(__p);\x0a"
"        __set_long_cap(__cap+1);\x0a"
"        __set_long_size(__sz);\x0a"
"    }\x0a"
"    traits_type\x3a\x3a""copy(_VSTD\x3a\x3a__to_raw_pointer(__p), __s, __sz);\x0a"
"    traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template <class>\x0a"
"#endif\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(const _CharT* __s, const _Allocator\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22""basic_string(const char*, allocator) detected nullptr\x22);\x0a"
"    __init(__s, traits_type\x3a\x3alength(__s));\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(const _CharT* __s, size_type __n)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22""basic_string(const char*, n) detected nullptr\x22);\x0a"
"    __init(__s, __n);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(const _CharT* __s, size_type __n, const _Allocator\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22""basic_string(const char*, n, allocator) detected nullptr\x22);\x0a"
"    __init(__s, __n);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(const basic_string\x26 __str)\x0a"
"    \x3a __r_(__second_tag(), __alloc_traits\x3a\x3aselect_on_container_copy_construction(__str.__alloc()))\x0a"
"{\x0a"
"    if (\x21__str.__is_long())\x0a"
"        __r_.first().__r = __str.__r_.first().__r;\x0a"
"    else\x0a"
"        __init(_VSTD\x3a\x3a__to_raw_pointer(__str.__get_long_pointer()), __str.__get_long_size());\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(\x0a"
"    const basic_string\x26 __str, const allocator_type\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    if (\x21__str.__is_long())\x0a"
"        __r_.first().__r = __str.__r_.first().__r;\x0a"
"    else\x0a"
"        __init(_VSTD\x3a\x3a__to_raw_pointer(__str.__get_long_pointer()), __str.__get_long_size());\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(basic_string\x26\x26 __str)\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue)\x0a"
"#else\x0a"
"        _NOEXCEPT\x0a"
"#endif\x0a"
"    \x3a __r_(_VSTD\x3a\x3amove(__str.__r_))\x0a"
"{\x0a"
"    __str.__zero();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"    if (__is_long())\x0a"
"        __get_db()->swap(this, \x26__str);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(basic_string\x26\x26 __str, const allocator_type\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    if (__str.__is_long() \x26\x26 __a \x21= __str.__alloc()) // copy, not move\x0a"
"        __init(_VSTD\x3a\x3a__to_raw_pointer(__str.__get_long_pointer()), __str.__get_long_size());\x0a"
"    else\x0a"
"    {\x0a"
"        __r_.first().__r = __str.__r_.first().__r;\x0a"
"        __str.__zero();\x0a"
"    }\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"    if (__is_long())\x0a"
"        __get_db()->swap(this, \x26__str);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__init(size_type __n, value_type __c)\x0a"
"{\x0a"
"    if (__n > max_size())\x0a"
"        this->__throw_length_error();\x0a"
"    pointer __p;\x0a"
"    if (__n < __min_cap)\x0a"
"    {\x0a"
"        __set_short_size(__n);\x0a"
"        __p = __get_short_pointer();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        size_type __cap = __recommend(__n);\x0a"
"        __p = __alloc_traits\x3a\x3a""allocate(__alloc(), __cap+1);\x0a"
"        __set_long_pointer(__p);\x0a"
"        __set_long_cap(__cap+1);\x0a"
"        __set_long_size(__n);\x0a"
"    }\x0a"
"    traits_type\x3a\x3a""assign(_VSTD\x3a\x3a__to_raw_pointer(__p), __n, __c);\x0a"
"    traits_type\x3a\x3a""assign(__p\x5b__n\x5d, value_type());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(size_type __n, _CharT __c)\x0a"
"{\x0a"
"    __init(__n, __c);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template <class>\x0a"
"#endif\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(size_type __n, _CharT __c, const _Allocator\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    __init(__n, __c);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(const basic_string\x26 __str,\x0a"
"                                                        size_type __pos, size_type __n,\x0a"
"                                                        const _Allocator\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    size_type __str_sz = __str.size();\x0a"
"    if (__pos > __str_sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    __init(__str.data() + __pos, _VSTD\x3a\x3amin(__n, __str_sz - __pos));\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(const basic_string\x26 __str, size_type __pos,\x0a"
"                                                        const _Allocator\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    size_type __str_sz = __str.size();\x0a"
"    if (__pos > __str_sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    __init(__str.data() + __pos, __str_sz - __pos);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp, class>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(\x0a"
"             const _Tp\x26 __t, size_type __pos, size_type __n, const allocator_type\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    __self_view __sv0 = __t;\x0a"
"    __self_view __sv = __sv0.substr(__pos, __n);\x0a"
"    __init(__sv.data(), __sv.size());\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp, class>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(const _Tp \x26 __t)\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    __init(__sv.data(), __sv.size());\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp, class>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(const _Tp \x26 __t, const _Allocator\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    __init(__sv.data(), __sv.size());\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _InputIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_exactly_input_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__init(_InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    __zero();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        push_back(*__first);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        if (__is_long())\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__alloc(), __get_long_pointer(), __get_long_cap());\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__init(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    size_type __sz = static_cast<size_type>(_VSTD\x3a\x3a""distance(__first, __last));\x0a"
"    if (__sz > max_size())\x0a"
"        this->__throw_length_error();\x0a"
"    pointer __p;\x0a"
"    if (__sz < __min_cap)\x0a"
"    {\x0a"
"        __set_short_size(__sz);\x0a"
"        __p = __get_short_pointer();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        size_type __cap = __recommend(__sz);\x0a"
"        __p = __alloc_traits\x3a\x3a""allocate(__alloc(), __cap+1);\x0a"
"        __set_long_pointer(__p);\x0a"
"        __set_long_cap(__cap+1);\x0a"
"        __set_long_size(__sz);\x0a"
"    }\x0a"
"    for (; __first \x21= __last; ++__first, (void) ++__p)\x0a"
"        traits_type\x3a\x3a""assign(*__p, *__first);\x0a"
"    traits_type\x3a\x3a""assign(*__p, value_type());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template<class _InputIterator, class>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(_InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    __init(__first, __last);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template<class _InputIterator, class>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(_InputIterator __first, _InputIterator __last,\x0a"
"                                                        const allocator_type\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    __init(__first, __last);\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(\x0a"
"    initializer_list<_CharT> __il)\x0a"
"{\x0a"
"    __init(__il.begin(), __il.end());\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""basic_string(\x0a"
"    initializer_list<_CharT> __il, const _Allocator\x26 __a)\x0a"
"    \x3a __r_(__second_tag(), __a)\x0a"
"{\x0a"
"    __init(__il.begin(), __il.end());\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a\x7e""basic_string()\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__erase_c(this);\x0a"
"#endif\x0a"
"    if (__is_long())\x0a"
"        __alloc_traits\x3a\x3a""deallocate(__alloc(), __get_long_pointer(), __get_long_cap());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__grow_by_and_replace\x0a"
"    (size_type __old_cap, size_type __delta_cap, size_type __old_sz,\x0a"
"     size_type __n_copy,  size_type __n_del,     size_type __n_add, const value_type* __p_new_stuff)\x0a"
"{\x0a"
"    size_type __ms = max_size();\x0a"
"    if (__delta_cap > __ms - __old_cap - 1)\x0a"
"        this->__throw_length_error();\x0a"
"    pointer __old_p = __get_pointer();\x0a"
"    size_type __cap = __old_cap < __ms / 2 - __alignment \x3f\x0a"
"                          __recommend(_VSTD\x3a\x3amax(__old_cap + __delta_cap, 2 * __old_cap)) \x3a\x0a"
"                          __ms - 1;\x0a"
"    pointer __p = __alloc_traits\x3a\x3a""allocate(__alloc(), __cap+1);\x0a"
"    __invalidate_all_iterators();\x0a"
"    if (__n_copy \x21= 0)\x0a"
"        traits_type\x3a\x3a""copy(_VSTD\x3a\x3a__to_raw_pointer(__p),\x0a"
"                          _VSTD\x3a\x3a__to_raw_pointer(__old_p), __n_copy);\x0a"
"    if (__n_add \x21= 0)\x0a"
"        traits_type\x3a\x3a""copy(_VSTD\x3a\x3a__to_raw_pointer(__p) + __n_copy, __p_new_stuff, __n_add);\x0a"
"    size_type __sec_cp_sz = __old_sz - __n_del - __n_copy;\x0a"
"    if (__sec_cp_sz \x21= 0)\x0a"
"        traits_type\x3a\x3a""copy(_VSTD\x3a\x3a__to_raw_pointer(__p) + __n_copy + __n_add,\x0a"
"                          _VSTD\x3a\x3a__to_raw_pointer(__old_p) + __n_copy + __n_del, __sec_cp_sz);\x0a"
"    if (__old_cap+1 \x21= __min_cap)\x0a"
"        __alloc_traits\x3a\x3a""deallocate(__alloc(), __old_p, __old_cap+1);\x0a"
"    __set_long_pointer(__p);\x0a"
"    __set_long_cap(__cap+1);\x0a"
"    __old_sz = __n_copy + __n_add + __sec_cp_sz;\x0a"
"    __set_long_size(__old_sz);\x0a"
"    traits_type\x3a\x3a""assign(__p\x5b__old_sz\x5d, value_type());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__grow_by(size_type __old_cap, size_type __delta_cap, size_type __old_sz,\x0a"
"                                                     size_type __n_copy,  size_type __n_del,     size_type __n_add)\x0a"
"{\x0a"
"    size_type __ms = max_size();\x0a"
"    if (__delta_cap > __ms - __old_cap)\x0a"
"        this->__throw_length_error();\x0a"
"    pointer __old_p = __get_pointer();\x0a"
"    size_type __cap = __old_cap < __ms / 2 - __alignment \x3f\x0a"
"                          __recommend(_VSTD\x3a\x3amax(__old_cap + __delta_cap, 2 * __old_cap)) \x3a\x0a"
"                          __ms - 1;\x0a"
"    pointer __p = __alloc_traits\x3a\x3a""allocate(__alloc(), __cap+1);\x0a"
"    __invalidate_all_iterators();\x0a"
"    if (__n_copy \x21= 0)\x0a"
"        traits_type\x3a\x3a""copy(_VSTD\x3a\x3a__to_raw_pointer(__p),\x0a"
"                          _VSTD\x3a\x3a__to_raw_pointer(__old_p), __n_copy);\x0a"
"    size_type __sec_cp_sz = __old_sz - __n_del - __n_copy;\x0a"
"    if (__sec_cp_sz \x21= 0)\x0a"
"        traits_type\x3a\x3a""copy(_VSTD\x3a\x3a__to_raw_pointer(__p) + __n_copy + __n_add,\x0a"
"                          _VSTD\x3a\x3a__to_raw_pointer(__old_p) + __n_copy + __n_del,\x0a"
"                          __sec_cp_sz);\x0a"
"    if (__old_cap+1 \x21= __min_cap)\x0a"
"        __alloc_traits\x3a\x3a""deallocate(__alloc(), __old_p, __old_cap+1);\x0a"
"    __set_long_pointer(__p);\x0a"
"    __set_long_cap(__cap+1);\x0a"
"}\x0a"
"\x0a"
"// assign\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""assign(const value_type* __s, size_type __n)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3a""assign received nullptr\x22);\x0a"
"    size_type __cap = capacity();\x0a"
"    if (__cap >= __n)\x0a"
"    {\x0a"
"        value_type* __p = _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());\x0a"
"        traits_type\x3a\x3amove(__p, __s, __n);\x0a"
"        traits_type\x3a\x3a""assign(__p\x5b__n\x5d, value_type());\x0a"
"        __set_size(__n);\x0a"
"        __invalidate_iterators_past(__n);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        size_type __sz = size();\x0a"
"        __grow_by_and_replace(__cap, __n - __cap, __sz, 0, __sz, __n, __s);\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""assign(size_type __n, value_type __c)\x0a"
"{\x0a"
"    size_type __cap = capacity();\x0a"
"    if (__cap < __n)\x0a"
"    {\x0a"
"        size_type __sz = size();\x0a"
"        __grow_by(__cap, __n - __cap, __sz, 0, __sz);\x0a"
"    }\x0a"
"    else\x0a"
"        __invalidate_iterators_past(__n);\x0a"
"    value_type* __p = _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());\x0a"
"    traits_type\x3a\x3a""assign(__p, __n, __c);\x0a"
"    traits_type\x3a\x3a""assign(__p\x5b__n\x5d, value_type());\x0a"
"    __set_size(__n);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3aoperator=(value_type __c)\x0a"
"{\x0a"
"    pointer __p;\x0a"
"    if (__is_long())\x0a"
"    {\x0a"
"        __p = __get_long_pointer();\x0a"
"        __set_long_size(1);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __p = __get_short_pointer();\x0a"
"        __set_short_size(1);\x0a"
"    }\x0a"
"    traits_type\x3a\x3a""assign(*__p, __c);\x0a"
"    traits_type\x3a\x3a""assign(*++__p, value_type());\x0a"
"    __invalidate_iterators_past(1);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3aoperator=(const basic_string\x26 __str)\x0a"
"{\x0a"
"    if (this \x21= \x26__str)\x0a"
"    {\x0a"
"        __copy_assign_alloc(__str);\x0a"
"        assign(__str.data(), __str.size());\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__move_assign(basic_string\x26 __str, false_type)\x0a"
"    _NOEXCEPT_(__alloc_traits\x3a\x3ais_always_equal\x3a\x3avalue)\x0a"
"{\x0a"
"    if (__alloc() \x21= __str.__alloc())\x0a"
"        assign(__str);\x0a"
"    else\x0a"
"        __move_assign(__str, true_type());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__move_assign(basic_string\x26 __str, true_type)\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _NOEXCEPT\x0a"
"#else\x0a"
"    _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"    __clear_and_shrink();\x0a"
"    __r_.first() = __str.__r_.first();\x0a"
"    __move_assign_alloc(__str);\x0a"
"    __str.__zero();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3aoperator=(basic_string\x26\x26 __str)\x0a"
"    _NOEXCEPT_((__noexcept_move_assign_container<_Allocator, __alloc_traits>\x3a\x3avalue))\x0a"
"{\x0a"
"    __move_assign(__str, integral_constant<bool,\x0a"
"          __alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template<class _InputIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"     __is_exactly_input_iterator <_InputIterator>\x3a\x3avalue\x0a"
"          \x7c\x7c \x21__libcpp_string_gets_noexcept_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"    basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""assign(_InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    const basic_string __temp(__first, __last, __alloc());\x0a"
"    assign(__temp.data(), __temp.size());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template<class _ForwardIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_forward_iterator<_ForwardIterator>\x3a\x3avalue\x0a"
"         \x26\x26 __libcpp_string_gets_noexcept_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"    basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""assign(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    size_type __n = static_cast<size_type>(_VSTD\x3a\x3a""distance(__first, __last));\x0a"
"    size_type __cap = capacity();\x0a"
"    if (__cap < __n)\x0a"
"    {\x0a"
"        size_type __sz = size();\x0a"
"        __grow_by(__cap, __n - __cap, __sz, 0, __sz);\x0a"
"    }\x0a"
"    else\x0a"
"        __invalidate_iterators_past(__n);\x0a"
"    pointer __p = __get_pointer();\x0a"
"    for (; __first \x21= __last; ++__first, ++__p)\x0a"
"        traits_type\x3a\x3a""assign(*__p, *__first);\x0a"
"    traits_type\x3a\x3a""assign(*__p, value_type());\x0a"
"    __set_size(__n);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""assign(const basic_string\x26 __str, size_type __pos, size_type __n)\x0a"
"{\x0a"
"    size_type __sz = __str.size();\x0a"
"    if (__pos > __sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    return assign(__str.data() + __pos, _VSTD\x3a\x3amin(__n, __sz - __pos));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""assign(const _Tp \x26 __t, size_type __pos, size_type __n)\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    size_type __sz = __sv.size();\x0a"
"    if (__pos > __sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    return assign(__sv.data() + __pos, _VSTD\x3a\x3amin(__n, __sz - __pos));\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""assign(const value_type* __s)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3a""assign received nullptr\x22);\x0a"
"    return assign(__s, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"// append\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""append(const value_type* __s, size_type __n)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3a""append received nullptr\x22);\x0a"
"    size_type __cap = capacity();\x0a"
"    size_type __sz = size();\x0a"
"    if (__cap - __sz >= __n)\x0a"
"    {\x0a"
"        if (__n)\x0a"
"        {\x0a"
"            value_type* __p = _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());\x0a"
"            traits_type\x3a\x3a""copy(__p + __sz, __s, __n);\x0a"
"            __sz += __n;\x0a"
"            __set_size(__sz);\x0a"
"            traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"        __grow_by_and_replace(__cap, __sz + __n - __cap, __sz, __sz, 0, __n, __s);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""append(size_type __n, value_type __c)\x0a"
"{\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        size_type __cap = capacity();\x0a"
"        size_type __sz = size();\x0a"
"        if (__cap - __sz < __n)\x0a"
"            __grow_by(__cap, __sz + __n - __cap, __sz, __sz, 0);\x0a"
"        pointer __p = __get_pointer();\x0a"
"        traits_type\x3a\x3a""assign(_VSTD\x3a\x3a__to_raw_pointer(__p) + __sz, __n, __c);\x0a"
"        __sz += __n;\x0a"
"        __set_size(__sz);\x0a"
"        traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__append_default_init(size_type __n)\x0a"
"{\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        size_type __cap = capacity();\x0a"
"        size_type __sz = size();\x0a"
"        if (__cap - __sz < __n)\x0a"
"            __grow_by(__cap, __sz + __n - __cap, __sz, __sz, 0);\x0a"
"        pointer __p = __get_pointer();\x0a"
"        __sz += __n;\x0a"
"        __set_size(__sz);\x0a"
"        traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3apush_back(value_type __c)\x0a"
"{\x0a"
"    bool __is_short = \x21__is_long();\x0a"
"    size_type __cap;\x0a"
"    size_type __sz;\x0a"
"    if (__is_short)\x0a"
"    {\x0a"
"        __cap = __min_cap - 1;\x0a"
"        __sz = __get_short_size();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __cap = __get_long_cap() - 1;\x0a"
"        __sz = __get_long_size();\x0a"
"    }\x0a"
"    if (__sz == __cap)\x0a"
"    {\x0a"
"        __grow_by(__cap, 1, __sz, __sz, 0);\x0a"
"        __is_short = \x21__is_long();\x0a"
"    }\x0a"
"    pointer __p;\x0a"
"    if (__is_short)\x0a"
"    {\x0a"
"        __p = __get_short_pointer() + __sz;\x0a"
"        __set_short_size(__sz+1);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __p = __get_long_pointer() + __sz;\x0a"
"        __set_long_size(__sz+1);\x0a"
"    }\x0a"
"    traits_type\x3a\x3a""assign(*__p, __c);\x0a"
"    traits_type\x3a\x3a""assign(*++__p, value_type());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"bool __ptr_in_range (const _Tp* __p, const _Tp* __first, const _Tp* __last)\x0a"
"{\x0a"
"    return __first <= __p \x26\x26 __p < __last;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp1, class _Tp2>\x0a"
"bool __ptr_in_range (const _Tp1*, const _Tp2*, const _Tp2*)\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template<class _ForwardIterator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__append_forward_unsafe(\x0a"
"    _ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    static_assert(__is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"                  \x22""function requires a ForwardIterator\x22);\x0a"
"    size_type __sz = size();\x0a"
"    size_type __cap = capacity();\x0a"
"    size_type __n = static_cast<size_type>(_VSTD\x3a\x3a""distance(__first, __last));\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        typedef typename iterator_traits<_ForwardIterator>\x3a\x3areference _CharRef;\x0a"
"        _CharRef __tmp_ref = *__first;\x0a"
"        if (__ptr_in_range(_VSTD\x3a\x3a""addressof(__tmp_ref), data(), data() + size()))\x0a"
"        {\x0a"
"            const basic_string __temp (__first, __last, __alloc());\x0a"
"            append(__temp.data(), __temp.size());\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (__cap - __sz < __n)\x0a"
"                __grow_by(__cap, __sz + __n - __cap, __sz, __sz, 0);\x0a"
"            pointer __p = __get_pointer() + __sz;\x0a"
"            for (; __first \x21= __last; ++__p, ++__first)\x0a"
"                traits_type\x3a\x3a""assign(*__p, *__first);\x0a"
"            traits_type\x3a\x3a""assign(*__p, value_type());\x0a"
"            __set_size(__sz + __n);\x0a"
"        }\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""append(const basic_string\x26 __str)\x0a"
"{\x0a"
"    return append(__str.data(), __str.size());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""append(const basic_string\x26 __str, size_type __pos, size_type __n)\x0a"
"{\x0a"
"    size_type __sz = __str.size();\x0a"
"    if (__pos > __sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    return append(__str.data() + __pos, _VSTD\x3a\x3amin(__n, __sz - __pos));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"        basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"    >\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""append(const _Tp \x26 __t, size_type __pos, size_type __n)\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    size_type __sz = __sv.size();\x0a"
"    if (__pos > __sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    return append(__sv.data() + __pos, _VSTD\x3a\x3amin(__n, __sz - __pos));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""append(const value_type* __s)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3a""append received nullptr\x22);\x0a"
"    return append(__s, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"// insert\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3ainsert(size_type __pos, const value_type* __s, size_type __n)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3ainsert received nullptr\x22);\x0a"
"    size_type __sz = size();\x0a"
"    if (__pos > __sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    size_type __cap = capacity();\x0a"
"    if (__cap - __sz >= __n)\x0a"
"    {\x0a"
"        if (__n)\x0a"
"        {\x0a"
"            value_type* __p = _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());\x0a"
"            size_type __n_move = __sz - __pos;\x0a"
"            if (__n_move \x21= 0)\x0a"
"            {\x0a"
"                if (__p + __pos <= __s \x26\x26 __s < __p + __sz)\x0a"
"                    __s += __n;\x0a"
"                traits_type\x3a\x3amove(__p + __pos + __n, __p + __pos, __n_move);\x0a"
"            }\x0a"
"            traits_type\x3a\x3amove(__p + __pos, __s, __n);\x0a"
"            __sz += __n;\x0a"
"            __set_size(__sz);\x0a"
"            traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"        __grow_by_and_replace(__cap, __sz + __n - __cap, __sz, __pos, 0, __n, __s);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3ainsert(size_type __pos, size_type __n, value_type __c)\x0a"
"{\x0a"
"    size_type __sz = size();\x0a"
"    if (__pos > __sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        size_type __cap = capacity();\x0a"
"        value_type* __p;\x0a"
"        if (__cap - __sz >= __n)\x0a"
"        {\x0a"
"            __p = _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());\x0a"
"            size_type __n_move = __sz - __pos;\x0a"
"            if (__n_move \x21= 0)\x0a"
"                traits_type\x3a\x3amove(__p + __pos + __n, __p + __pos, __n_move);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __grow_by(__cap, __sz + __n - __cap, __sz, __pos, 0, __n);\x0a"
"            __p = _VSTD\x3a\x3a__to_raw_pointer(__get_long_pointer());\x0a"
"        }\x0a"
"        traits_type\x3a\x3a""assign(__p + __pos, __n, __c);\x0a"
"        __sz += __n;\x0a"
"        __set_size(__sz);\x0a"
"        traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template<class _InputIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"   __is_exactly_input_iterator<_InputIterator>\x3a\x3avalue\x0a"
"        \x7c\x7c \x21__libcpp_string_gets_noexcept_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"   typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3aiterator\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3ainsert(const_iterator __pos, _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__pos) == this,\x0a"
"        \x22string\x3a\x3ainsert(iterator, range) called with an iterator not\x22\x0a"
"        \x22 referring to this string\x22);\x0a"
"#endif\x0a"
"    const basic_string __temp(__first, __last, __alloc());\x0a"
"    return insert(__pos, __temp.data(), __temp.data() + __temp.size());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template<class _ForwardIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_forward_iterator<_ForwardIterator>\x3a\x3avalue\x0a"
"        \x26\x26 __libcpp_string_gets_noexcept_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3aiterator\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3ainsert(const_iterator __pos, _ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__pos) == this,\x0a"
"        \x22string\x3a\x3ainsert(iterator, range) called with an iterator not\x22\x0a"
"        \x22 referring to this string\x22);\x0a"
"#endif\x0a"
"    size_type __ip = static_cast<size_type>(__pos - begin());\x0a"
"    size_type __n = static_cast<size_type>(_VSTD\x3a\x3a""distance(__first, __last));\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        typedef typename iterator_traits<_ForwardIterator>\x3a\x3areference _CharRef;\x0a"
"        _CharRef __tmp_char = *__first;\x0a"
"        if (__ptr_in_range(_VSTD\x3a\x3a""addressof(__tmp_char), data(), data() + size()))\x0a"
"        {\x0a"
"            const basic_string __temp(__first, __last, __alloc());\x0a"
"            return insert(__pos, __temp.data(), __temp.data() + __temp.size());\x0a"
"        }\x0a"
"\x0a"
"        size_type __sz = size();\x0a"
"        size_type __cap = capacity();\x0a"
"        value_type* __p;\x0a"
"        if (__cap - __sz >= __n)\x0a"
"        {\x0a"
"            __p = _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());\x0a"
"            size_type __n_move = __sz - __ip;\x0a"
"            if (__n_move \x21= 0)\x0a"
"                traits_type\x3a\x3amove(__p + __ip + __n, __p + __ip, __n_move);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __grow_by(__cap, __sz + __n - __cap, __sz, __ip, 0, __n);\x0a"
"            __p = _VSTD\x3a\x3a__to_raw_pointer(__get_long_pointer());\x0a"
"        }\x0a"
"        __sz += __n;\x0a"
"        __set_size(__sz);\x0a"
"        traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"        for (__p += __ip; __first \x21= __last; ++__p, ++__first)\x0a"
"            traits_type\x3a\x3a""assign(*__p, *__first);\x0a"
"    }\x0a"
"    return begin() + __ip;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3ainsert(size_type __pos1, const basic_string\x26 __str)\x0a"
"{\x0a"
"    return insert(__pos1, __str.data(), __str.size());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3ainsert(size_type __pos1, const basic_string\x26 __str,\x0a"
"                                                  size_type __pos2, size_type __n)\x0a"
"{\x0a"
"    size_type __str_sz = __str.size();\x0a"
"    if (__pos2 > __str_sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    return insert(__pos1, __str.data() + __pos2, _VSTD\x3a\x3amin(__n, __str_sz - __pos2));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3ainsert(size_type __pos1, const _Tp\x26 __t,\x0a"
"                                                  size_type __pos2, size_type __n)\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    size_type __str_sz = __sv.size();\x0a"
"    if (__pos2 > __str_sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    return insert(__pos1, __sv.data() + __pos2, _VSTD\x3a\x3amin(__n, __str_sz - __pos2));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3ainsert(size_type __pos, const value_type* __s)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3ainsert received nullptr\x22);\x0a"
"    return insert(__pos, __s, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3aiterator\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3ainsert(const_iterator __pos, value_type __c)\x0a"
"{\x0a"
"    size_type __ip = static_cast<size_type>(__pos - begin());\x0a"
"    size_type __sz = size();\x0a"
"    size_type __cap = capacity();\x0a"
"    value_type* __p;\x0a"
"    if (__cap == __sz)\x0a"
"    {\x0a"
"        __grow_by(__cap, 1, __sz, __ip, 0, 1);\x0a"
"        __p = _VSTD\x3a\x3a__to_raw_pointer(__get_long_pointer());\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __p = _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());\x0a"
"        size_type __n_move = __sz - __ip;\x0a"
"        if (__n_move \x21= 0)\x0a"
"            traits_type\x3a\x3amove(__p + __ip + 1, __p + __ip, __n_move);\x0a"
"    }\x0a"
"    traits_type\x3a\x3a""assign(__p\x5b__ip\x5d, __c);\x0a"
"    traits_type\x3a\x3a""assign(__p\x5b++__sz\x5d, value_type());\x0a"
"    __set_size(__sz);\x0a"
"    return begin() + static_cast<difference_type>(__ip);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3aiterator\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3ainsert(const_iterator __pos, size_type __n, value_type __c)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__pos) == this,\x0a"
"        \x22string\x3a\x3ainsert(iterator, n, value) called with an iterator not\x22\x0a"
"        \x22 referring to this string\x22);\x0a"
"#endif\x0a"
"    difference_type __p = __pos - begin();\x0a"
"    insert(static_cast<size_type>(__p), __n, __c);\x0a"
"    return begin() + __p;\x0a"
"}\x0a"
"\x0a"
"// replace\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(size_type __pos, size_type __n1, const value_type* __s, size_type __n2)\x0a"
"    _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n2 == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3areplace received nullptr\x22);\x0a"
"    size_type __sz = size();\x0a"
"    if (__pos > __sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    __n1 = _VSTD\x3a\x3amin(__n1, __sz - __pos);\x0a"
"    size_type __cap = capacity();\x0a"
"    if (__cap - __sz + __n1 >= __n2)\x0a"
"    {\x0a"
"        value_type* __p = _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());\x0a"
"        if (__n1 \x21= __n2)\x0a"
"        {\x0a"
"            size_type __n_move = __sz - __pos - __n1;\x0a"
"            if (__n_move \x21= 0)\x0a"
"            {\x0a"
"                if (__n1 > __n2)\x0a"
"                {\x0a"
"                    traits_type\x3a\x3amove(__p + __pos, __s, __n2);\x0a"
"                    traits_type\x3a\x3amove(__p + __pos + __n2, __p + __pos + __n1, __n_move);\x0a"
"                    goto __finish;\x0a"
"                }\x0a"
"                if (__p + __pos < __s \x26\x26 __s < __p + __sz)\x0a"
"                {\x0a"
"                    if (__p + __pos + __n1 <= __s)\x0a"
"                        __s += __n2 - __n1;\x0a"
"                    else // __p + __pos < __s < __p + __pos + __n1\x0a"
"                    {\x0a"
"                        traits_type\x3a\x3amove(__p + __pos, __s, __n1);\x0a"
"                        __pos += __n1;\x0a"
"                        __s += __n2;\x0a"
"                        __n2 -= __n1;\x0a"
"                        __n1 = 0;\x0a"
"                    }\x0a"
"                }\x0a"
"                traits_type\x3a\x3amove(__p + __pos + __n2, __p + __pos + __n1, __n_move);\x0a"
"            }\x0a"
"        }\x0a"
"        traits_type\x3a\x3amove(__p + __pos, __s, __n2);\x0a"
"__finish\x3a\x0a"
"// __sz += __n2 - __n1; in this and the below function below can cause unsigned integer overflow,\x0a"
"// but this is a safe operation, so we disable the check.\x0a"
"        __sz += __n2 - __n1;\x0a"
"        __set_size(__sz);\x0a"
"        __invalidate_iterators_past(__sz);\x0a"
"        traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"    }\x0a"
"    else\x0a"
"        __grow_by_and_replace(__cap, __sz - __n1 + __n2 - __cap, __sz, __pos, __n1, __n2, __s);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(size_type __pos, size_type __n1, size_type __n2, value_type __c)\x0a"
"    _LIBCPP_DISABLE_UBSAN_UNSIGNED_INTEGER_CHECK\x0a"
"{\x0a"
"    size_type __sz = size();\x0a"
"    if (__pos > __sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    __n1 = _VSTD\x3a\x3amin(__n1, __sz - __pos);\x0a"
"    size_type __cap = capacity();\x0a"
"    value_type* __p;\x0a"
"    if (__cap - __sz + __n1 >= __n2)\x0a"
"    {\x0a"
"        __p = _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());\x0a"
"        if (__n1 \x21= __n2)\x0a"
"        {\x0a"
"            size_type __n_move = __sz - __pos - __n1;\x0a"
"            if (__n_move \x21= 0)\x0a"
"                traits_type\x3a\x3amove(__p + __pos + __n2, __p + __pos + __n1, __n_move);\x0a"
"        }\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __grow_by(__cap, __sz - __n1 + __n2 - __cap, __sz, __pos, __n1, __n2);\x0a"
"        __p = _VSTD\x3a\x3a__to_raw_pointer(__get_long_pointer());\x0a"
"    }\x0a"
"    traits_type\x3a\x3a""assign(__p + __pos, __n2, __c);\x0a"
"    __sz += __n2 - __n1;\x0a"
"    __set_size(__sz);\x0a"
"    __invalidate_iterators_past(__sz);\x0a"
"    traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template<class _InputIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_input_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"    basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(const_iterator __i1, const_iterator __i2,\x0a"
"                                                   _InputIterator __j1, _InputIterator __j2)\x0a"
"{\x0a"
"    const basic_string __temp(__j1, __j2, __alloc());\x0a"
"    return this->replace(__i1, __i2, __temp);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(size_type __pos1, size_type __n1, const basic_string\x26 __str)\x0a"
"{\x0a"
"    return replace(__pos1, __n1, __str.data(), __str.size());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(size_type __pos1, size_type __n1, const basic_string\x26 __str,\x0a"
"                                                   size_type __pos2, size_type __n2)\x0a"
"{\x0a"
"    size_type __str_sz = __str.size();\x0a"
"    if (__pos2 > __str_sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    return replace(__pos1, __n1, __str.data() + __pos2, _VSTD\x3a\x3amin(__n2, __str_sz - __pos2));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(size_type __pos1, size_type __n1, const _Tp\x26 __t,\x0a"
"                                                   size_type __pos2, size_type __n2)\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    size_type __str_sz = __sv.size();\x0a"
"    if (__pos2 > __str_sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    return replace(__pos1, __n1, __sv.data() + __pos2, _VSTD\x3a\x3amin(__n2, __str_sz - __pos2));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(size_type __pos, size_type __n1, const value_type* __s)\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3areplace received nullptr\x22);\x0a"
"    return replace(__pos, __n1, __s, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(const_iterator __i1, const_iterator __i2, const basic_string\x26 __str)\x0a"
"{\x0a"
"    return replace(static_cast<size_type>(__i1 - begin()), static_cast<size_type>(__i2 - __i1),\x0a"
"                   __str.data(), __str.size());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(const_iterator __i1, const_iterator __i2, const value_type* __s, size_type __n)\x0a"
"{\x0a"
"    return replace(static_cast<size_type>(__i1 - begin()), static_cast<size_type>(__i2 - __i1), __s, __n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(const_iterator __i1, const_iterator __i2, const value_type* __s)\x0a"
"{\x0a"
"    return replace(static_cast<size_type>(__i1 - begin()), static_cast<size_type>(__i2 - __i1), __s);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areplace(const_iterator __i1, const_iterator __i2, size_type __n, value_type __c)\x0a"
"{\x0a"
"    return replace(static_cast<size_type>(__i1 - begin()), static_cast<size_type>(__i2 - __i1), __n, __c);\x0a"
"}\x0a"
"\x0a"
"// erase\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x26\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""erase(size_type __pos, size_type __n)\x0a"
"{\x0a"
"    size_type __sz = size();\x0a"
"    if (__pos > __sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        value_type* __p = _VSTD\x3a\x3a__to_raw_pointer(__get_pointer());\x0a"
"        __n = _VSTD\x3a\x3amin(__n, __sz - __pos);\x0a"
"        size_type __n_move = __sz - __pos - __n;\x0a"
"        if (__n_move \x21= 0)\x0a"
"            traits_type\x3a\x3amove(__p + __pos, __p + __pos + __n, __n_move);\x0a"
"        __sz -= __n;\x0a"
"        __set_size(__sz);\x0a"
"        __invalidate_iterators_past(__sz);\x0a"
"        traits_type\x3a\x3a""assign(__p\x5b__sz\x5d, value_type());\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3aiterator\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""erase(const_iterator __pos)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__pos) == this,\x0a"
"        \x22string\x3a\x3a""erase(iterator) called with an iterator not\x22\x0a"
"        \x22 referring to this string\x22);\x0a"
"#endif\x0a"
"    _LIBCPP_ASSERT(__pos \x21= end(),\x0a"
"        \x22string\x3a\x3a""erase(iterator) called with a non-dereferenceable iterator\x22);\x0a"
"    iterator __b = begin();\x0a"
"    size_type __r = static_cast<size_type>(__pos - __b);\x0a"
"    erase(__r, 1);\x0a"
"    return __b + static_cast<difference_type>(__r);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3aiterator\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""erase(const_iterator __first, const_iterator __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__first) == this,\x0a"
"        \x22string\x3a\x3a""erase(iterator,  iterator) called with an iterator not\x22\x0a"
"        \x22 referring to this string\x22);\x0a"
"#endif\x0a"
"    _LIBCPP_ASSERT(__first <= __last, \x22string\x3a\x3a""erase(first, last) called with invalid range\x22);\x0a"
"    iterator __b = begin();\x0a"
"    size_type __r = static_cast<size_type>(__first - __b);\x0a"
"    erase(__r, static_cast<size_type>(__last - __first));\x0a"
"    return __b + static_cast<difference_type>(__r);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3apop_back()\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(\x21""empty(), \x22string\x3a\x3apop_back()\x3a string is already empty\x22);\x0a"
"    size_type __sz;\x0a"
"    if (__is_long())\x0a"
"    {\x0a"
"        __sz = __get_long_size() - 1;\x0a"
"        __set_long_size(__sz);\x0a"
"        traits_type\x3a\x3a""assign(*(__get_long_pointer() + __sz), value_type());\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __sz = __get_short_size() - 1;\x0a"
"        __set_short_size(__sz);\x0a"
"        traits_type\x3a\x3a""assign(*(__get_short_pointer() + __sz), value_type());\x0a"
"    }\x0a"
"    __invalidate_iterators_past(__sz);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""clear() _NOEXCEPT\x0a"
"{\x0a"
"    __invalidate_all_iterators();\x0a"
"    if (__is_long())\x0a"
"    {\x0a"
"        traits_type\x3a\x3a""assign(*__get_long_pointer(), value_type());\x0a"
"        __set_long_size(0);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        traits_type\x3a\x3a""assign(*__get_short_pointer(), value_type());\x0a"
"        __set_short_size(0);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__erase_to_end(size_type __pos)\x0a"
"{\x0a"
"    if (__is_long())\x0a"
"    {\x0a"
"        traits_type\x3a\x3a""assign(*(__get_long_pointer() + __pos), value_type());\x0a"
"        __set_long_size(__pos);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        traits_type\x3a\x3a""assign(*(__get_short_pointer() + __pos), value_type());\x0a"
"        __set_short_size(__pos);\x0a"
"    }\x0a"
"    __invalidate_iterators_past(__pos);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3aresize(size_type __n, value_type __c)\x0a"
"{\x0a"
"    size_type __sz = size();\x0a"
"    if (__n > __sz)\x0a"
"        append(__n - __sz, __c);\x0a"
"    else\x0a"
"        __erase_to_end(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__resize_default_init(size_type __n)\x0a"
"{\x0a"
"    size_type __sz = size();\x0a"
"    if (__n > __sz) {\x0a"
"       __append_default_init(__n - __sz);\x0a"
"    } else\x0a"
"        __erase_to_end(__n);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3amax_size() const _NOEXCEPT\x0a"
"{\x0a"
"    size_type __m = __alloc_traits\x3a\x3amax_size(__alloc());\x0a"
"#ifdef _LIBCPP_BIG_ENDIAN\x0a"
"    return (__m <= \x7e__long_mask \x3f __m \x3a __m/2) - __alignment;\x0a"
"#else\x0a"
"    return __m - __alignment;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3areserve(size_type __res_arg)\x0a"
"{\x0a"
"    if (__res_arg > max_size())\x0a"
"        this->__throw_length_error();\x0a"
"    size_type __cap = capacity();\x0a"
"    size_type __sz = size();\x0a"
"    __res_arg = _VSTD\x3a\x3amax(__res_arg, __sz);\x0a"
"    __res_arg = __recommend(__res_arg);\x0a"
"    if (__res_arg \x21= __cap)\x0a"
"    {\x0a"
"        pointer __new_data, __p;\x0a"
"        bool __was_long, __now_long;\x0a"
"        if (__res_arg == __min_cap - 1)\x0a"
"        {\x0a"
"            __was_long = true;\x0a"
"            __now_long = false;\x0a"
"            __new_data = __get_short_pointer();\x0a"
"            __p = __get_long_pointer();\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (__res_arg > __cap)\x0a"
"                __new_data = __alloc_traits\x3a\x3a""allocate(__alloc(), __res_arg+1);\x0a"
"            else\x0a"
"            {\x0a"
"            #ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"                try\x0a"
"                {\x0a"
"            #endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"                    __new_data = __alloc_traits\x3a\x3a""allocate(__alloc(), __res_arg+1);\x0a"
"            #ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"                }\x0a"
"                catch (...)\x0a"
"                {\x0a"
"                    return;\x0a"
"                }\x0a"
"            #else  // _LIBCPP_NO_EXCEPTIONS\x0a"
"                if (__new_data == nullptr)\x0a"
"                    return;\x0a"
"            #endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            }\x0a"
"            __now_long = true;\x0a"
"            __was_long = __is_long();\x0a"
"            __p = __get_pointer();\x0a"
"        }\x0a"
"        traits_type\x3a\x3a""copy(_VSTD\x3a\x3a__to_raw_pointer(__new_data),\x0a"
"                          _VSTD\x3a\x3a__to_raw_pointer(__p), size()+1);\x0a"
"        if (__was_long)\x0a"
"            __alloc_traits\x3a\x3a""deallocate(__alloc(), __p, __cap+1);\x0a"
"        if (__now_long)\x0a"
"        {\x0a"
"            __set_long_cap(__res_arg+1);\x0a"
"            __set_long_size(__sz);\x0a"
"            __set_long_pointer(__new_data);\x0a"
"        }\x0a"
"        else\x0a"
"            __set_short_size(__sz);\x0a"
"        __invalidate_all_iterators();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""const_reference\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3aoperator\x5b\x5d(size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__pos <= size(), \x22string index out of bounds\x22);\x0a"
"    return *(data() + __pos);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3areference\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3aoperator\x5b\x5d(size_type __pos) _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__pos <= size(), \x22string index out of bounds\x22);\x0a"
"    return *(__get_pointer() + __pos);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""const_reference\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""at(size_type __n) const\x0a"
"{\x0a"
"    if (__n >= size())\x0a"
"        this->__throw_out_of_range();\x0a"
"    return (*this)\x5b__n\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3areference\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""at(size_type __n)\x0a"
"{\x0a"
"    if (__n >= size())\x0a"
"        this->__throw_out_of_range();\x0a"
"    return (*this)\x5b__n\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3areference\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""front() _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(\x21""empty(), \x22string\x3a\x3a""front()\x3a string is empty\x22);\x0a"
"    return *__get_pointer();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""const_reference\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""front() const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(\x21""empty(), \x22string\x3a\x3a""front()\x3a string is empty\x22);\x0a"
"    return *data();\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3areference\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""back() _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(\x21""empty(), \x22string\x3a\x3a""back()\x3a string is empty\x22);\x0a"
"    return *(__get_pointer() + size() - 1);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""const_reference\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""back() const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(\x21""empty(), \x22string\x3a\x3a""back()\x3a string is empty\x22);\x0a"
"    return *(data() + size() - 1);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""copy(value_type* __s, size_type __n, size_type __pos) const\x0a"
"{\x0a"
"    size_type __sz = size();\x0a"
"    if (__pos > __sz)\x0a"
"        this->__throw_out_of_range();\x0a"
"    size_type __rlen = _VSTD\x3a\x3amin(__n, __sz - __pos);\x0a"
"    traits_type\x3a\x3a""copy(__s, data() + __pos, __rlen);\x0a"
"    return __rlen;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3asubstr(size_type __pos, size_type __n) const\x0a"
"{\x0a"
"    return basic_string(*this, __pos, __n, __alloc());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3aswap(basic_string\x26 __str)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<allocator_type>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    if (\x21__is_long())\x0a"
"        __get_db()->__invalidate_all(this);\x0a"
"    if (\x21__str.__is_long())\x0a"
"        __get_db()->__invalidate_all(\x26__str);\x0a"
"    __get_db()->swap(this, \x26__str);\x0a"
"#endif\x0a"
"    _LIBCPP_ASSERT(\x0a"
"        __alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"        __alloc_traits\x3a\x3ais_always_equal\x3a\x3avalue \x7c\x7c\x0a"
"        __alloc() == __str.__alloc(), \x22swapping non-equal allocators\x22);\x0a"
"    _VSTD\x3a\x3aswap(__r_.first(), __str.__r_.first());\x0a"
"    __swap_allocator(__alloc(), __str.__alloc());\x0a"
"}\x0a"
"\x0a"
"// find\x0a"
"\x0a"
"template <class _Traits>\x0a"
"struct _LIBCPP_HIDDEN __traits_eq\x0a"
"{\x0a"
"    typedef typename _Traits\x3a\x3a""char_type char_type;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool operator()(const char_type\x26 __x, const char_type\x26 __y) _NOEXCEPT\x0a"
"        {return _Traits\x3a\x3a""eq(__x, __y);}\x0a"
"};\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find(const value_type* __s,\x0a"
"                                                size_type __pos,\x0a"
"                                                size_type __n) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3a""find()\x3a received nullptr\x22);\x0a"
"    return __str_find<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, __n);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find(const basic_string\x26 __str,\x0a"
"                                                size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return __str_find<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __str.data(), __pos, __str.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find(const _Tp \x26__t,\x0a"
"                                                size_type __pos) const\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    return __str_find<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __sv.data(), __pos, __sv.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find(const value_type* __s,\x0a"
"                                                size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3a""find()\x3a received nullptr\x22);\x0a"
"    return __str_find<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find(value_type __c,\x0a"
"                                                size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return __str_find<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __c, __pos);\x0a"
"}\x0a"
"\x0a"
"// rfind\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3arfind(const value_type* __s,\x0a"
"                                                 size_type __pos,\x0a"
"                                                 size_type __n) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3arfind()\x3a received nullptr\x22);\x0a"
"    return __str_rfind<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, __n);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3arfind(const basic_string\x26 __str,\x0a"
"                                                 size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return __str_rfind<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __str.data(), __pos, __str.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3arfind(const _Tp\x26 __t,\x0a"
"                                                size_type __pos) const\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    return __str_rfind<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __sv.data(), __pos, __sv.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3arfind(const value_type* __s,\x0a"
"                                                 size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3arfind()\x3a received nullptr\x22);\x0a"
"    return __str_rfind<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3arfind(value_type __c,\x0a"
"                                                 size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return __str_rfind<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __c, __pos);\x0a"
"}\x0a"
"\x0a"
"// find_first_of\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_first_of(const value_type* __s,\x0a"
"                                                         size_type __pos,\x0a"
"                                                         size_type __n) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3a""find_first_of()\x3a received nullptr\x22);\x0a"
"    return __str_find_first_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, __n);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_first_of(const basic_string\x26 __str,\x0a"
"                                                         size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return __str_find_first_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __str.data(), __pos, __str.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_first_of(const _Tp\x26 __t,\x0a"
"                                                size_type __pos) const\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    return __str_find_first_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __sv.data(), __pos, __sv.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_first_of(const value_type* __s,\x0a"
"                                                         size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3a""find_first_of()\x3a received nullptr\x22);\x0a"
"    return __str_find_first_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_first_of(value_type __c,\x0a"
"                                                         size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return find(__c, __pos);\x0a"
"}\x0a"
"\x0a"
"// find_last_of\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_last_of(const value_type* __s,\x0a"
"                                                        size_type __pos,\x0a"
"                                                        size_type __n) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3a""find_last_of()\x3a received nullptr\x22);\x0a"
"    return __str_find_last_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, __n);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_last_of(const basic_string\x26 __str,\x0a"
"                                                        size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return __str_find_last_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __str.data(), __pos, __str.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_last_of(const _Tp\x26 __t,\x0a"
"                                                size_type __pos) const\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    return __str_find_last_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __sv.data(), __pos, __sv.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_last_of(const value_type* __s,\x0a"
"                                                        size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3a""find_last_of()\x3a received nullptr\x22);\x0a"
"    return __str_find_last_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_last_of(value_type __c,\x0a"
"                                                        size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return rfind(__c, __pos);\x0a"
"}\x0a"
"\x0a"
"// find_first_not_of\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_first_not_of(const value_type* __s,\x0a"
"                                                             size_type __pos,\x0a"
"                                                             size_type __n) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3a""find_first_not_of()\x3a received nullptr\x22);\x0a"
"    return __str_find_first_not_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, __n);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_first_not_of(const basic_string\x26 __str,\x0a"
"                                                             size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return __str_find_first_not_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __str.data(), __pos, __str.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_first_not_of(const _Tp\x26 __t,\x0a"
"                                                size_type __pos) const\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    return __str_find_first_not_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __sv.data(), __pos, __sv.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_first_not_of(const value_type* __s,\x0a"
"                                                             size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3a""find_first_not_of()\x3a received nullptr\x22);\x0a"
"    return __str_find_first_not_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_first_not_of(value_type __c,\x0a"
"                                                             size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return __str_find_first_not_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __c, __pos);\x0a"
"}\x0a"
"\x0a"
"// find_last_not_of\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_last_not_of(const value_type* __s,\x0a"
"                                                            size_type __pos,\x0a"
"                                                            size_type __n) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3a""find_last_not_of()\x3a received nullptr\x22);\x0a"
"    return __str_find_last_not_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, __n);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_last_not_of(const basic_string\x26 __str,\x0a"
"                                                            size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return __str_find_last_not_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __str.data(), __pos, __str.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_last_not_of(const _Tp\x26 __t,\x0a"
"                                                size_type __pos) const\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    return __str_find_last_not_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __sv.data(), __pos, __sv.size());\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_last_not_of(const value_type* __s,\x0a"
"                                                            size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3a""find_last_not_of()\x3a received nullptr\x22);\x0a"
"    return __str_find_last_not_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __s, __pos, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""find_last_not_of(value_type __c,\x0a"
"                                                            size_type __pos) const _NOEXCEPT\x0a"
"{\x0a"
"    return __str_find_last_not_of<value_type, size_type, traits_type, npos>\x0a"
"        (data(), size(), __c, __pos);\x0a"
"}\x0a"
"\x0a"
"// compare\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    int\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""compare(const _Tp\x26 __t) const\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    size_t __lhs_sz = size();\x0a"
"    size_t __rhs_sz = __sv.size();\x0a"
"    int __result = traits_type\x3a\x3a""compare(data(), __sv.data(),\x0a"
"                                        _VSTD\x3a\x3amin(__lhs_sz, __rhs_sz));\x0a"
"    if (__result \x21= 0)\x0a"
"        return __result;\x0a"
"    if (__lhs_sz < __rhs_sz)\x0a"
"        return -1;\x0a"
"    if (__lhs_sz > __rhs_sz)\x0a"
"        return 1;\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"int\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""compare(const basic_string\x26 __str) const _NOEXCEPT\x0a"
"{\x0a"
"    return compare(__self_view(__str));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"int\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""compare(size_type __pos1,\x0a"
"                                                   size_type __n1,\x0a"
"                                                   const value_type* __s,\x0a"
"                                                   size_type __n2) const\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n2 == 0 \x7c\x7c __s \x21= nullptr, \x22string\x3a\x3a""compare()\x3a received nullptr\x22);\x0a"
"    size_type __sz = size();\x0a"
"    if (__pos1 > __sz \x7c\x7c __n2 == npos)\x0a"
"        this->__throw_out_of_range();\x0a"
"    size_type __rlen = _VSTD\x3a\x3amin(__n1, __sz - __pos1);\x0a"
"    int __r = traits_type\x3a\x3a""compare(data() + __pos1, __s, _VSTD\x3a\x3amin(__rlen, __n2));\x0a"
"    if (__r == 0)\x0a"
"    {\x0a"
"        if (__rlen < __n2)\x0a"
"            __r = -1;\x0a"
"        else if (__rlen > __n2)\x0a"
"            __r = 1;\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    int\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""compare(size_type __pos1,\x0a"
"                                                   size_type __n1,\x0a"
"                                                   const _Tp\x26 __t) const\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    return compare(__pos1, __n1, __sv.data(), __sv.size());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"int\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""compare(size_type __pos1,\x0a"
"                                                   size_type __n1,\x0a"
"                                                   const basic_string\x26 __str) const\x0a"
"{\x0a"
"    return compare(__pos1, __n1, __str.data(), __str.size());\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"template <class _Tp>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __can_be_converted_to_string_view<_CharT, _Traits, _Tp>\x3a\x3avalue,\x0a"
"    int\x0a"
">\x3a\x3atype\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""compare(size_type __pos1,\x0a"
"                                                   size_type __n1,\x0a"
"                                                   const _Tp\x26 __t,\x0a"
"                                                   size_type __pos2,\x0a"
"                                                   size_type __n2) const\x0a"
"{\x0a"
"    __self_view __sv = __t;\x0a"
"    return __self_view(*this).substr(__pos1, __n1).compare(__sv.substr(__pos2, __n2));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"int\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""compare(size_type __pos1,\x0a"
"                                                   size_type __n1,\x0a"
"                                                   const basic_string\x26 __str,\x0a"
"                                                   size_type __pos2,\x0a"
"                                                   size_type __n2) const\x0a"
"{\x0a"
"        return compare(__pos1, __n1, __self_view(__str), __pos2, __n2);\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"int\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""compare(const value_type* __s) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3a""compare()\x3a received nullptr\x22);\x0a"
"    return compare(0, npos, __s, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"template <class _CharT, class _Traits, class _Allocator>\x0a"
"int\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a""compare(size_type __pos1,\x0a"
"                                                   size_type __n1,\x0a"
"                                                   const value_type* __s) const\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__s \x21= nullptr, \x22string\x3a\x3a""compare()\x3a received nullptr\x22);\x0a"
"    return compare(__pos1, __n1, __s, traits_type\x3a\x3alength(__s));\x0a"
"}\x0a"
"\x0a"
"// __invariants\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"bool\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__invariants() const\x0a"
"{\x0a"
"    if (size() > capacity())\x0a"
"        return false;\x0a"
"    if (capacity() < __min_cap - 1)\x0a"
"        return false;\x0a"
"    if (data() == 0)\x0a"
"        return false;\x0a"
"    if (data()\x5bsize()\x5d \x21= value_type(0))\x0a"
"        return false;\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"// __clear_and_shrink\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__clear_and_shrink() _NOEXCEPT\x0a"
"{\x0a"
"    clear();\x0a"
"    if(__is_long())\x0a"
"    {\x0a"
"        __alloc_traits\x3a\x3a""deallocate(__alloc(), __get_long_pointer(), capacity() + 1);\x0a"
"        __set_long_cap(0);\x0a"
"        __set_short_size(0);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// operator==\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    size_t __lhs_sz = __lhs.size();\x0a"
"    return __lhs_sz == __rhs.size() \x26\x26 _Traits\x3a\x3a""compare(__lhs.data(),\x0a"
"                                                        __rhs.data(),\x0a"
"                                                        __lhs_sz) == 0;\x0a"
"}\x0a"
"\x0a"
"template<class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const basic_string<char, char_traits<char>, _Allocator>\x26 __lhs,\x0a"
"           const basic_string<char, char_traits<char>, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    size_t __lhs_sz = __lhs.size();\x0a"
"    if (__lhs_sz \x21= __rhs.size())\x0a"
"        return false;\x0a"
"    const char* __lp = __lhs.data();\x0a"
"    const char* __rp = __rhs.data();\x0a"
"    if (__lhs.__is_long())\x0a"
"        return char_traits<char>\x3a\x3a""compare(__lp, __rp, __lhs_sz) == 0;\x0a"
"    for (; __lhs_sz \x21= 0; --__lhs_sz, ++__lp, ++__rp)\x0a"
"        if (*__lp \x21= *__rp)\x0a"
"            return false;\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const _CharT* __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    typedef basic_string<_CharT, _Traits, _Allocator> _String;\x0a"
"    _LIBCPP_ASSERT(__lhs \x21= nullptr, \x22operator==(char*, basic_string)\x3a received nullptr\x22);\x0a"
"    size_t __lhs_len = _Traits\x3a\x3alength(__lhs);\x0a"
"    if (__lhs_len \x21= __rhs.size()) return false;\x0a"
"    return __rhs.compare(0, _String\x3a\x3anpos, __lhs, __lhs_len) == 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const basic_string<_CharT,_Traits,_Allocator>\x26 __lhs,\x0a"
"           const _CharT* __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    typedef basic_string<_CharT, _Traits, _Allocator> _String;\x0a"
"    _LIBCPP_ASSERT(__rhs \x21= nullptr, \x22operator==(basic_string, char*)\x3a received nullptr\x22);\x0a"
"    size_t __rhs_len = _Traits\x3a\x3alength(__rhs);\x0a"
"    if (__rhs_len \x21= __lhs.size()) return false;\x0a"
"    return __lhs.compare(0, _String\x3a\x3anpos, __rhs, __rhs_len) == 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const basic_string<_CharT,_Traits,_Allocator>\x26 __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__lhs == __rhs);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const _CharT* __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__lhs == __rhs);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"           const _CharT* __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__lhs == __rhs);\x0a"
"}\x0a"
"\x0a"
"// operator<\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) < 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"           const _CharT* __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __lhs.compare(__rhs) < 0;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const _CharT* __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __rhs.compare(__lhs) > 0;\x0a"
"}\x0a"
"\x0a"
"// operator>\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __rhs < __lhs;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"           const _CharT* __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __rhs < __lhs;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const _CharT* __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return __rhs < __lhs;\x0a"
"}\x0a"
"\x0a"
"// operator<=\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__rhs < __lhs);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"           const _CharT* __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__rhs < __lhs);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const _CharT* __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__rhs < __lhs);\x0a"
"}\x0a"
"\x0a"
"// operator>=\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__lhs < __rhs);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"           const _CharT* __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__lhs < __rhs);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const _CharT* __lhs,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs) _NOEXCEPT\x0a"
"{\x0a"
"    return \x21(__lhs < __rhs);\x0a"
"}\x0a"
"\x0a"
"// operator +\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"          const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs)\x0a"
"{\x0a"
"    basic_string<_CharT, _Traits, _Allocator> __r(__lhs.get_allocator());\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type __lhs_sz = __lhs.size();\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type __rhs_sz = __rhs.size();\x0a"
"    __r.__init(__lhs.data(), __lhs_sz, __lhs_sz + __rhs_sz);\x0a"
"    __r.append(__rhs.data(), __rhs_sz);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(const _CharT* __lhs , const basic_string<_CharT,_Traits,_Allocator>\x26 __rhs)\x0a"
"{\x0a"
"    basic_string<_CharT, _Traits, _Allocator> __r(__rhs.get_allocator());\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type __lhs_sz = _Traits\x3a\x3alength(__lhs);\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type __rhs_sz = __rhs.size();\x0a"
"    __r.__init(__lhs, __lhs_sz, __lhs_sz + __rhs_sz);\x0a"
"    __r.append(__rhs.data(), __rhs_sz);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(_CharT __lhs, const basic_string<_CharT,_Traits,_Allocator>\x26 __rhs)\x0a"
"{\x0a"
"    basic_string<_CharT, _Traits, _Allocator> __r(__rhs.get_allocator());\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type __rhs_sz = __rhs.size();\x0a"
"    __r.__init(\x26__lhs, 1, 1 + __rhs_sz);\x0a"
"    __r.append(__rhs.data(), __rhs_sz);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs, const _CharT* __rhs)\x0a"
"{\x0a"
"    basic_string<_CharT, _Traits, _Allocator> __r(__lhs.get_allocator());\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type __lhs_sz = __lhs.size();\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type __rhs_sz = _Traits\x3a\x3alength(__rhs);\x0a"
"    __r.__init(__lhs.data(), __lhs_sz, __lhs_sz + __rhs_sz);\x0a"
"    __r.append(__rhs, __rhs_sz);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs, _CharT __rhs)\x0a"
"{\x0a"
"    basic_string<_CharT, _Traits, _Allocator> __r(__lhs.get_allocator());\x0a"
"    typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type __lhs_sz = __lhs.size();\x0a"
"    __r.__init(__lhs.data(), __lhs_sz, __lhs_sz + 1);\x0a"
"    __r.push_back(__rhs);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(basic_string<_CharT, _Traits, _Allocator>\x26\x26 __lhs, const basic_string<_CharT, _Traits, _Allocator>\x26 __rhs)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amove(__lhs.append(__rhs));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(const basic_string<_CharT, _Traits, _Allocator>\x26 __lhs, basic_string<_CharT, _Traits, _Allocator>\x26\x26 __rhs)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amove(__rhs.insert(0, __lhs));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(basic_string<_CharT, _Traits, _Allocator>\x26\x26 __lhs, basic_string<_CharT, _Traits, _Allocator>\x26\x26 __rhs)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amove(__lhs.append(__rhs));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(const _CharT* __lhs , basic_string<_CharT,_Traits,_Allocator>\x26\x26 __rhs)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amove(__rhs.insert(0, __lhs));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(_CharT __lhs, basic_string<_CharT,_Traits,_Allocator>\x26\x26 __rhs)\x0a"
"{\x0a"
"    __rhs.insert(__rhs.begin(), __lhs);\x0a"
"    return _VSTD\x3a\x3amove(__rhs);\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(basic_string<_CharT, _Traits, _Allocator>\x26\x26 __lhs, const _CharT* __rhs)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amove(__lhs.append(__rhs));\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x0a"
"operator+(basic_string<_CharT, _Traits, _Allocator>\x26\x26 __lhs, _CharT __rhs)\x0a"
"{\x0a"
"    __lhs.push_back(__rhs);\x0a"
"    return _VSTD\x3a\x3amove(__lhs);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"// swap\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(basic_string<_CharT, _Traits, _Allocator>\x26 __lhs,\x0a"
"     basic_string<_CharT, _Traits, _Allocator>\x26 __rhs)\x0a"
"     _NOEXCEPT_(_NOEXCEPT_(__lhs.swap(__rhs)))\x0a"
"{\x0a"
"    __lhs.swap(__rhs);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_HAS_CHAR8_T\x0a"
"typedef basic_string<char8_t> u8string;\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"typedef basic_string<char16_t> u16string;\x0a"
"typedef basic_string<char32_t> u32string;\x0a"
"#endif  // _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS int                stoi  (const string\x26 __str, size_t* __idx = 0, int __base = 10);\x0a"
"_LIBCPP_FUNC_VIS long               stol  (const string\x26 __str, size_t* __idx = 0, int __base = 10);\x0a"
"_LIBCPP_FUNC_VIS unsigned long      stoul (const string\x26 __str, size_t* __idx = 0, int __base = 10);\x0a"
"_LIBCPP_FUNC_VIS long long          stoll (const string\x26 __str, size_t* __idx = 0, int __base = 10);\x0a"
"_LIBCPP_FUNC_VIS unsigned long long stoull(const string\x26 __str, size_t* __idx = 0, int __base = 10);\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS float       stof (const string\x26 __str, size_t* __idx = 0);\x0a"
"_LIBCPP_FUNC_VIS double      stod (const string\x26 __str, size_t* __idx = 0);\x0a"
"_LIBCPP_FUNC_VIS long double stold(const string\x26 __str, size_t* __idx = 0);\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS string to_string(int __val);\x0a"
"_LIBCPP_FUNC_VIS string to_string(unsigned __val);\x0a"
"_LIBCPP_FUNC_VIS string to_string(long __val);\x0a"
"_LIBCPP_FUNC_VIS string to_string(unsigned long __val);\x0a"
"_LIBCPP_FUNC_VIS string to_string(long long __val);\x0a"
"_LIBCPP_FUNC_VIS string to_string(unsigned long long __val);\x0a"
"_LIBCPP_FUNC_VIS string to_string(float __val);\x0a"
"_LIBCPP_FUNC_VIS string to_string(double __val);\x0a"
"_LIBCPP_FUNC_VIS string to_string(long double __val);\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS int                stoi  (const wstring\x26 __str, size_t* __idx = 0, int __base = 10);\x0a"
"_LIBCPP_FUNC_VIS long               stol  (const wstring\x26 __str, size_t* __idx = 0, int __base = 10);\x0a"
"_LIBCPP_FUNC_VIS unsigned long      stoul (const wstring\x26 __str, size_t* __idx = 0, int __base = 10);\x0a"
"_LIBCPP_FUNC_VIS long long          stoll (const wstring\x26 __str, size_t* __idx = 0, int __base = 10);\x0a"
"_LIBCPP_FUNC_VIS unsigned long long stoull(const wstring\x26 __str, size_t* __idx = 0, int __base = 10);\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS float       stof (const wstring\x26 __str, size_t* __idx = 0);\x0a"
"_LIBCPP_FUNC_VIS double      stod (const wstring\x26 __str, size_t* __idx = 0);\x0a"
"_LIBCPP_FUNC_VIS long double stold(const wstring\x26 __str, size_t* __idx = 0);\x0a"
"\x0a"
"_LIBCPP_FUNC_VIS wstring to_wstring(int __val);\x0a"
"_LIBCPP_FUNC_VIS wstring to_wstring(unsigned __val);\x0a"
"_LIBCPP_FUNC_VIS wstring to_wstring(long __val);\x0a"
"_LIBCPP_FUNC_VIS wstring to_wstring(unsigned long __val);\x0a"
"_LIBCPP_FUNC_VIS wstring to_wstring(long long __val);\x0a"
"_LIBCPP_FUNC_VIS wstring to_wstring(unsigned long long __val);\x0a"
"_LIBCPP_FUNC_VIS wstring to_wstring(float __val);\x0a"
"_LIBCPP_FUNC_VIS wstring to_wstring(double __val);\x0a"
"_LIBCPP_FUNC_VIS wstring to_wstring(long double __val);\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"    const typename basic_string<_CharT, _Traits, _Allocator>\x3a\x3asize_type\x0a"
"                   basic_string<_CharT, _Traits, _Allocator>\x3a\x3anpos;\x0a"
"\x0a"
"template <class _CharT, class _Allocator>\x0a"
"struct _LIBCPP_TEMPLATE_VIS\x0a"
"    hash<basic_string<_CharT, char_traits<_CharT>, _Allocator> >\x0a"
"    \x3a public unary_function<\x0a"
"          basic_string<_CharT, char_traits<_CharT>, _Allocator>, size_t>\x0a"
"{\x0a"
"    size_t\x0a"
"    operator()(const basic_string<_CharT, char_traits<_CharT>, _Allocator>\x26 __val) const _NOEXCEPT\x0a"
"    { return __do_string_hash(__val.data(), __val.data() + __val.size()); }\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_ostream<_CharT, _Traits>\x26\x0a"
"operator<<(basic_ostream<_CharT, _Traits>\x26 __os,\x0a"
"           const basic_string<_CharT, _Traits, _Allocator>\x26 __str);\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"operator>>(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"           basic_string<_CharT, _Traits, _Allocator>\x26 __str);\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"getline(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"        basic_string<_CharT, _Traits, _Allocator>\x26 __str, _CharT __dlm);\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"getline(basic_istream<_CharT, _Traits>\x26 __is,\x0a"
"        basic_string<_CharT, _Traits, _Allocator>\x26 __str);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"getline(basic_istream<_CharT, _Traits>\x26\x26 __is,\x0a"
"        basic_string<_CharT, _Traits, _Allocator>\x26 __str, _CharT __dlm);\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"basic_istream<_CharT, _Traits>\x26\x0a"
"getline(basic_istream<_CharT, _Traits>\x26\x26 __is,\x0a"
"        basic_string<_CharT, _Traits, _Allocator>\x26 __str);\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template<class _CharT, class _Traits, class _Allocator, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase(basic_string<_CharT, _Traits, _Allocator>\x26 __str, const _Up\x26 __v)\x0a"
"{ __str.erase(_VSTD\x3a\x3aremove(__str.begin(), __str.end(), __v), __str.end()); }\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(basic_string<_CharT, _Traits, _Allocator>\x26 __str, _Predicate __pred)\x0a"
"{ __str.erase(_VSTD\x3a\x3aremove_if(__str.begin(), __str.end(), __pred), __str.end()); }\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"bool\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__dereferenceable(const const_iterator* __i) const\x0a"
"{\x0a"
"    return this->data() <= _VSTD\x3a\x3a__to_raw_pointer(__i->base()) \x26\x26\x0a"
"           _VSTD\x3a\x3a__to_raw_pointer(__i->base()) < this->data() + this->size();\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"bool\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__decrementable(const const_iterator* __i) const\x0a"
"{\x0a"
"    return this->data() < _VSTD\x3a\x3a__to_raw_pointer(__i->base()) \x26\x26\x0a"
"           _VSTD\x3a\x3a__to_raw_pointer(__i->base()) <= this->data() + this->size();\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"bool\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__addable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"{\x0a"
"    const value_type* __p = _VSTD\x3a\x3a__to_raw_pointer(__i->base()) + __n;\x0a"
"    return this->data() <= __p \x26\x26 __p <= this->data() + this->size();\x0a"
"}\x0a"
"\x0a"
"template<class _CharT, class _Traits, class _Allocator>\x0a"
"bool\x0a"
"basic_string<_CharT, _Traits, _Allocator>\x3a\x3a__subscriptable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"{\x0a"
"    const value_type* __p = _VSTD\x3a\x3a__to_raw_pointer(__i->base()) + __n;\x0a"
"    return this->data() <= __p \x26\x26 __p < this->data() + this->size();\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_string<char>)\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS basic_string<wchar_t>)\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"// Literal suffixes for basic_string \x5b""basic.string.literals\x5d\x0a"
"inline namespace literals\x0a"
"{\x0a"
"  inline namespace string_literals\x0a"
"  {\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string<char> operator \x22\x22 s( const char *__str, size_t __len )\x0a"
"    {\x0a"
"        return basic_string<char> (__str, __len);\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string<wchar_t> operator \x22\x22 s( const wchar_t *__str, size_t __len )\x0a"
"    {\x0a"
"        return basic_string<wchar_t> (__str, __len);\x0a"
"    }\x0a"
"\x0a"
"#ifndef _LIBCPP_NO_HAS_CHAR8_T\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string<char8_t> operator \x22\x22 s(const char8_t *__str, size_t __len) _NOEXCEPT\x0a"
"    {\x0a"
"        return basic_string<char8_t> (__str, __len);\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string<char16_t> operator \x22\x22 s( const char16_t *__str, size_t __len )\x0a"
"    {\x0a"
"        return basic_string<char16_t> (__str, __len);\x0a"
"    }\x0a"
"\x0a"
"    inline _LIBCPP_INLINE_VISIBILITY\x0a"
"    basic_string<char32_t> operator \x22\x22 s( const char32_t *__str, size_t __len )\x0a"
"    {\x0a"
"        return basic_string<char32_t> (__str, __len);\x0a"
"    }\x0a"
"  }\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_STRING\x0a"
"", 161483 ); }