#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_type_traits( 
"// -*- C++ -*-\x0a"
"//===------------------------ type_traits ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_TYPE_TRAITS\x0a"
"#define _LIBCPP_TYPE_TRAITS\x0a"
"\x0a"
"/*\x0a"
"    type_traits synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"    // helper class\x3a\x0a"
"    template <class T, T v> struct integral_constant;\x0a"
"    typedef integral_constant<bool, true>  true_type;   // C++11\x0a"
"    typedef integral_constant<bool, false> false_type;  // C++11\x0a"
"\x0a"
"    template <bool B>                                   // C++14\x0a"
"    using bool_constant = integral_constant<bool, B>;   // C++14\x0a"
"    typedef bool_constant<true> true_type;              // C++14\x0a"
"    typedef bool_constant<false> false_type;            // C++14\x0a"
"\x0a"
"    // helper traits\x0a"
"    template <bool, class T = void> struct enable_if;\x0a"
"    template <bool, class T, class F> struct conditional;\x0a"
"\x0a"
"    // Primary classification traits\x3a\x0a"
"    template <class T> struct is_void;\x0a"
"    template <class T> struct is_null_pointer;  // C++14\x0a"
"    template <class T> struct is_integral;\x0a"
"    template <class T> struct is_floating_point;\x0a"
"    template <class T> struct is_array;\x0a"
"    template <class T> struct is_pointer;\x0a"
"    template <class T> struct is_lvalue_reference;\x0a"
"    template <class T> struct is_rvalue_reference;\x0a"
"    template <class T> struct is_member_object_pointer;\x0a"
"    template <class T> struct is_member_function_pointer;\x0a"
"    template <class T> struct is_enum;\x0a"
"    template <class T> struct is_union;\x0a"
"    template <class T> struct is_class;\x0a"
"    template <class T> struct is_function;\x0a"
"\x0a"
"    // Secondary classification traits\x3a\x0a"
"    template <class T> struct is_reference;\x0a"
"    template <class T> struct is_arithmetic;\x0a"
"    template <class T> struct is_fundamental;\x0a"
"    template <class T> struct is_member_pointer;\x0a"
"    template <class T> struct is_scalar;\x0a"
"    template <class T> struct is_object;\x0a"
"    template <class T> struct is_compound;\x0a"
"\x0a"
"    // Const-volatile properties and transformations\x3a\x0a"
"    template <class T> struct is_const;\x0a"
"    template <class T> struct is_volatile;\x0a"
"    template <class T> struct remove_const;\x0a"
"    template <class T> struct remove_volatile;\x0a"
"    template <class T> struct remove_cv;\x0a"
"    template <class T> struct add_const;\x0a"
"    template <class T> struct add_volatile;\x0a"
"    template <class T> struct add_cv;\x0a"
"\x0a"
"    // Reference transformations\x3a\x0a"
"    template <class T> struct remove_reference;\x0a"
"    template <class T> struct add_lvalue_reference;\x0a"
"    template <class T> struct add_rvalue_reference;\x0a"
"\x0a"
"    // Pointer transformations\x3a\x0a"
"    template <class T> struct remove_pointer;\x0a"
"    template <class T> struct add_pointer;\x0a"
"\x0a"
"    template<class T> struct type_identity;                     // C++20\x0a"
"    template<class T>\x0a"
"      using type_identity_t = typename type_identity<T>\x3a\x3atype;  // C++20\x0a"
"\x0a"
"    // Integral properties\x3a\x0a"
"    template <class T> struct is_signed;\x0a"
"    template <class T> struct is_unsigned;\x0a"
"    template <class T> struct make_signed;\x0a"
"    template <class T> struct make_unsigned;\x0a"
"\x0a"
"    // Array properties and transformations\x3a\x0a"
"    template <class T> struct rank;\x0a"
"    template <class T, unsigned I = 0> struct extent;\x0a"
"    template <class T> struct remove_extent;\x0a"
"    template <class T> struct remove_all_extents;\x0a"
"\x0a"
"    template <class T> struct is_bounded_array;                 // C++20\x0a"
"    template <class T> struct is_unbounded_array;               // C++20\x0a"
"\x0a"
"    // Member introspection\x3a\x0a"
"    template <class T> struct is_pod;\x0a"
"    template <class T> struct is_trivial;\x0a"
"    template <class T> struct is_trivially_copyable;\x0a"
"    template <class T> struct is_standard_layout;\x0a"
"    template <class T> struct is_literal_type;\x0a"
"    template <class T> struct is_empty;\x0a"
"    template <class T> struct is_polymorphic;\x0a"
"    template <class T> struct is_abstract;\x0a"
"    template <class T> struct is_final; // C++14\x0a"
"    template <class T> struct is_aggregate; // C++17\x0a"
"\x0a"
"    template <class T, class... Args> struct is_constructible;\x0a"
"    template <class T>                struct is_default_constructible;\x0a"
"    template <class T>                struct is_copy_constructible;\x0a"
"    template <class T>                struct is_move_constructible;\x0a"
"    template <class T, class U>       struct is_assignable;\x0a"
"    template <class T>                struct is_copy_assignable;\x0a"
"    template <class T>                struct is_move_assignable;\x0a"
"    template <class T, class U>       struct is_swappable_with;       // C++17\x0a"
"    template <class T>                struct is_swappable;            // C++17\x0a"
"    template <class T>                struct is_destructible;\x0a"
"\x0a"
"    template <class T, class... Args> struct is_trivially_constructible;\x0a"
"    template <class T>                struct is_trivially_default_constructible;\x0a"
"    template <class T>                struct is_trivially_copy_constructible;\x0a"
"    template <class T>                struct is_trivially_move_constructible;\x0a"
"    template <class T, class U>       struct is_trivially_assignable;\x0a"
"    template <class T>                struct is_trivially_copy_assignable;\x0a"
"    template <class T>                struct is_trivially_move_assignable;\x0a"
"    template <class T>                struct is_trivially_destructible;\x0a"
"\x0a"
"    template <class T, class... Args> struct is_nothrow_constructible;\x0a"
"    template <class T>                struct is_nothrow_default_constructible;\x0a"
"    template <class T>                struct is_nothrow_copy_constructible;\x0a"
"    template <class T>                struct is_nothrow_move_constructible;\x0a"
"    template <class T, class U>       struct is_nothrow_assignable;\x0a"
"    template <class T>                struct is_nothrow_copy_assignable;\x0a"
"    template <class T>                struct is_nothrow_move_assignable;\x0a"
"    template <class T, class U>       struct is_nothrow_swappable_with; // C++17\x0a"
"    template <class T>                struct is_nothrow_swappable;      // C++17\x0a"
"    template <class T>                struct is_nothrow_destructible;\x0a"
"\x0a"
"    template <class T> struct has_virtual_destructor;\x0a"
"\x0a"
"    template<class T> struct has_unique_object_representations;         // C++17\x0a"
"\x0a"
"    // Relationships between types\x3a\x0a"
"    template <class T, class U> struct is_same;\x0a"
"    template <class Base, class Derived> struct is_base_of;\x0a"
"\x0a"
"    template <class From, class To> struct is_convertible;\x0a"
"    template <typename From, typename To> struct is_nothrow_convertible;                  // C++20\x0a"
"    template <typename From, typename To> inline constexpr bool is_nothrow_convertible_v; // C++20\x0a"
"\x0a"
"    template <class Fn, class... ArgTypes> struct is_invocable;\x0a"
"    template <class R, class Fn, class... ArgTypes> struct is_invocable_r;\x0a"
"\x0a"
"    template <class Fn, class... ArgTypes> struct is_nothrow_invocable;\x0a"
"    template <class R, class Fn, class... ArgTypes> struct is_nothrow_invocable_r;\x0a"
"\x0a"
"    // Alignment properties and transformations\x3a\x0a"
"    template <class T> struct alignment_of;\x0a"
"    template <size_t Len, size_t Align = most_stringent_alignment_requirement>\x0a"
"        struct aligned_storage;\x0a"
"    template <size_t Len, class... Types> struct aligned_union;\x0a"
"    template <class T> struct remove_cvref; // C++20\x0a"
"\x0a"
"    template <class T> struct decay;\x0a"
"    template <class... T> struct common_type;\x0a"
"    template <class T> struct underlying_type;\x0a"
"    template <class> class result_of; // undefined\x0a"
"    template <class Fn, class... ArgTypes> class result_of<Fn(ArgTypes...)>;\x0a"
"    template <class Fn, class... ArgTypes> struct invoke_result;  // C++17\x0a"
"\x0a"
"    // const-volatile modifications\x3a\x0a"
"    template <class T>\x0a"
"      using remove_const_t    = typename remove_const<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using remove_volatile_t = typename remove_volatile<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using remove_cv_t       = typename remove_cv<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using add_const_t       = typename add_const<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using add_volatile_t    = typename add_volatile<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using add_cv_t          = typename add_cv<T>\x3a\x3atype;  // C++14\x0a"
"\x0a"
"    // reference modifications\x3a\x0a"
"    template <class T>\x0a"
"      using remove_reference_t     = typename remove_reference<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using add_lvalue_reference_t = typename add_lvalue_reference<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using add_rvalue_reference_t = typename add_rvalue_reference<T>\x3a\x3atype;  // C++14\x0a"
"\x0a"
"    // sign modifications\x3a\x0a"
"    template <class T>\x0a"
"      using make_signed_t   = typename make_signed<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using make_unsigned_t = typename make_unsigned<T>\x3a\x3atype;  // C++14\x0a"
"\x0a"
"    // array modifications\x3a\x0a"
"    template <class T>\x0a"
"      using remove_extent_t      = typename remove_extent<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using remove_all_extents_t = typename remove_all_extents<T>\x3a\x3atype;  // C++14\x0a"
"\x0a"
"    template <class T>\x0a"
"      inline constexpr bool is_bounded_array_v\x0a"
"        = is_bounded_array<T>\x3a\x3avalue;                                     // C++20\x0a"
"      inline constexpr bool is_unbounded_array_v\x0a"
"        = is_unbounded_array<T>\x3a\x3avalue;                                   // C++20\x0a"
"\x0a"
"    // pointer modifications\x3a\x0a"
"    template <class T>\x0a"
"      using remove_pointer_t = typename remove_pointer<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using add_pointer_t    = typename add_pointer<T>\x3a\x3atype;  // C++14\x0a"
"\x0a"
"    // other transformations\x3a\x0a"
"    template <size_t Len, std\x3a\x3asize_t Align=default-alignment>\x0a"
"      using aligned_storage_t = typename aligned_storage<Len,Align>\x3a\x3atype;  // C++14\x0a"
"    template <std\x3a\x3asize_t Len, class... Types>\x0a"
"      using aligned_union_t   = typename aligned_union<Len,Types...>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using remove_cvref_t    = typename remove_cvref<T>\x3a\x3atype;  // C++20\x0a"
"    template <class T>\x0a"
"      using decay_t           = typename decay<T>\x3a\x3atype;  // C++14\x0a"
"    template <bool b, class T=void>\x0a"
"      using enable_if_t       = typename enable_if<b,T>\x3a\x3atype;  // C++14\x0a"
"    template <bool b, class T, class F>\x0a"
"      using conditional_t     = typename conditional<b,T,F>\x3a\x3atype;  // C++14\x0a"
"    template <class... T>\x0a"
"      using common_type_t     = typename common_type<T...>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using underlying_type_t = typename underlying_type<T>\x3a\x3atype;  // C++14\x0a"
"    template <class T>\x0a"
"      using result_of_t       = typename result_of<T>\x3a\x3atype;  // C++14\x0a"
"    template <class Fn, class... ArgTypes>\x0a"
"      using invoke_result_t   = typename invoke_result<Fn, ArgTypes...>\x3a\x3atype;  // C++17\x0a"
"\x0a"
"    template <class...>\x0a"
"      using void_t = void;   // C++17\x0a"
"\x0a"
"      // See C++14 20.10.4.1, primary type categories\x0a"
"      template <class T> inline constexpr bool is_void_v\x0a"
"        = is_void<T>\x3a\x3avalue;                                             // C++17\x0a"
"      template <class T> inline constexpr bool is_null_pointer_v\x0a"
"        = is_null_pointer<T>\x3a\x3avalue;                                     // C++17\x0a"
"      template <class T> inline constexpr bool is_integral_v\x0a"
"        = is_integral<T>\x3a\x3avalue;                                         // C++17\x0a"
"      template <class T> inline constexpr bool is_floating_point_v\x0a"
"        = is_floating_point<T>\x3a\x3avalue;                                   // C++17\x0a"
"      template <class T> inline constexpr bool is_array_v\x0a"
"        = is_array<T>\x3a\x3avalue;                                            // C++17\x0a"
"      template <class T> inline constexpr bool is_pointer_v\x0a"
"        = is_pointer<T>\x3a\x3avalue;                                          // C++17\x0a"
"      template <class T> inline constexpr bool is_lvalue_reference_v\x0a"
"        = is_lvalue_reference<T>\x3a\x3avalue;                                 // C++17\x0a"
"      template <class T> inline constexpr bool is_rvalue_reference_v\x0a"
"        = is_rvalue_reference<T>\x3a\x3avalue;                                 // C++17\x0a"
"      template <class T> inline constexpr bool is_member_object_pointer_v\x0a"
"        = is_member_object_pointer<T>\x3a\x3avalue;                            // C++17\x0a"
"      template <class T> inline constexpr bool is_member_function_pointer_v\x0a"
"        = is_member_function_pointer<T>\x3a\x3avalue;                          // C++17\x0a"
"      template <class T> inline constexpr bool is_enum_v\x0a"
"        = is_enum<T>\x3a\x3avalue;                                             // C++17\x0a"
"      template <class T> inline constexpr bool is_union_v\x0a"
"        = is_union<T>\x3a\x3avalue;                                            // C++17\x0a"
"      template <class T> inline constexpr bool is_class_v\x0a"
"        = is_class<T>\x3a\x3avalue;                                            // C++17\x0a"
"      template <class T> inline constexpr bool is_function_v\x0a"
"        = is_function<T>\x3a\x3avalue;                                         // C++17\x0a"
"\x0a"
"      // See C++14 20.10.4.2, composite type categories\x0a"
"      template <class T> inline constexpr bool is_reference_v\x0a"
"        = is_reference<T>\x3a\x3avalue;                                        // C++17\x0a"
"      template <class T> inline constexpr bool is_arithmetic_v\x0a"
"        = is_arithmetic<T>\x3a\x3avalue;                                       // C++17\x0a"
"      template <class T> inline constexpr bool is_fundamental_v\x0a"
"        = is_fundamental<T>\x3a\x3avalue;                                      // C++17\x0a"
"      template <class T> inline constexpr bool is_object_v\x0a"
"        = is_object<T>\x3a\x3avalue;                                           // C++17\x0a"
"      template <class T> inline constexpr bool is_scalar_v\x0a"
"        = is_scalar<T>\x3a\x3avalue;                                           // C++17\x0a"
"      template <class T> inline constexpr bool is_compound_v\x0a"
"        = is_compound<T>\x3a\x3avalue;                                         // C++17\x0a"
"      template <class T> inline constexpr bool is_member_pointer_v\x0a"
"        = is_member_pointer<T>\x3a\x3avalue;                                   // C++17\x0a"
"\x0a"
"      // See C++14 20.10.4.3, type properties\x0a"
"      template <class T> inline constexpr bool is_const_v\x0a"
"        = is_const<T>\x3a\x3avalue;                                            // C++17\x0a"
"      template <class T> inline constexpr bool is_volatile_v\x0a"
"        = is_volatile<T>\x3a\x3avalue;                                         // C++17\x0a"
"      template <class T> inline constexpr bool is_trivial_v\x0a"
"        = is_trivial<T>\x3a\x3avalue;                                          // C++17\x0a"
"      template <class T> inline constexpr bool is_trivially_copyable_v\x0a"
"        = is_trivially_copyable<T>\x3a\x3avalue;                               // C++17\x0a"
"      template <class T> inline constexpr bool is_standard_layout_v\x0a"
"        = is_standard_layout<T>\x3a\x3avalue;                                  // C++17\x0a"
"      template <class T> inline constexpr bool is_pod_v\x0a"
"        = is_pod<T>\x3a\x3avalue;                                              // C++17\x0a"
"      template <class T> inline constexpr bool is_literal_type_v\x0a"
"        = is_literal_type<T>\x3a\x3avalue;                                     // C++17\x0a"
"      template <class T> inline constexpr bool is_empty_v\x0a"
"        = is_empty<T>\x3a\x3avalue;                                            // C++17\x0a"
"      template <class T> inline constexpr bool is_polymorphic_v\x0a"
"        = is_polymorphic<T>\x3a\x3avalue;                                      // C++17\x0a"
"      template <class T> inline constexpr bool is_abstract_v\x0a"
"        = is_abstract<T>\x3a\x3avalue;                                         // C++17\x0a"
"      template <class T> inline constexpr bool is_final_v\x0a"
"        = is_final<T>\x3a\x3avalue;                                            // C++17\x0a"
"      template <class T> inline constexpr bool is_aggregate_v\x0a"
"        = is_aggregate<T>\x3a\x3avalue;                                        // C++17\x0a"
"      template <class T> inline constexpr bool is_signed_v\x0a"
"        = is_signed<T>\x3a\x3avalue;                                           // C++17\x0a"
"      template <class T> inline constexpr bool is_unsigned_v\x0a"
"        = is_unsigned<T>\x3a\x3avalue;                                         // C++17\x0a"
"      template <class T, class... Args> inline constexpr bool is_constructible_v\x0a"
"        = is_constructible<T, Args...>\x3a\x3avalue;                           // C++17\x0a"
"      template <class T> inline constexpr bool is_default_constructible_v\x0a"
"        = is_default_constructible<T>\x3a\x3avalue;                            // C++17\x0a"
"      template <class T> inline constexpr bool is_copy_constructible_v\x0a"
"        = is_copy_constructible<T>\x3a\x3avalue;                               // C++17\x0a"
"      template <class T> inline constexpr bool is_move_constructible_v\x0a"
"        = is_move_constructible<T>\x3a\x3avalue;                               // C++17\x0a"
"      template <class T, class U> inline constexpr bool is_assignable_v\x0a"
"        = is_assignable<T, U>\x3a\x3avalue;                                    // C++17\x0a"
"      template <class T> inline constexpr bool is_copy_assignable_v\x0a"
"        = is_copy_assignable<T>\x3a\x3avalue;                                  // C++17\x0a"
"      template <class T> inline constexpr bool is_move_assignable_v\x0a"
"        = is_move_assignable<T>\x3a\x3avalue;                                  // C++17\x0a"
"      template <class T, class U> inline constexpr bool is_swappable_with_v\x0a"
"        = is_swappable_with<T, U>\x3a\x3avalue;                                // C++17\x0a"
"      template <class T> inline constexpr bool is_swappable_v\x0a"
"        = is_swappable<T>\x3a\x3avalue;                                        // C++17\x0a"
"      template <class T> inline constexpr bool is_destructible_v\x0a"
"        = is_destructible<T>\x3a\x3avalue;                                     // C++17\x0a"
"      template <class T, class... Args> inline constexpr bool is_trivially_constructible_v\x0a"
"        = is_trivially_constructible<T, Args...>\x3a\x3avalue;                 // C++17\x0a"
"      template <class T> inline constexpr bool is_trivially_default_constructible_v\x0a"
"        = is_trivially_default_constructible<T>\x3a\x3avalue;                  // C++17\x0a"
"      template <class T> inline constexpr bool is_trivially_copy_constructible_v\x0a"
"        = is_trivially_copy_constructible<T>\x3a\x3avalue;                     // C++17\x0a"
"      template <class T> inline constexpr bool is_trivially_move_constructible_v\x0a"
"        = is_trivially_move_constructible<T>\x3a\x3avalue;                     // C++17\x0a"
"      template <class T, class U> inline constexpr bool is_trivially_assignable_v\x0a"
"        = is_trivially_assignable<T, U>\x3a\x3avalue;                          // C++17\x0a"
"      template <class T> inline constexpr bool is_trivially_copy_assignable_v\x0a"
"        = is_trivially_copy_assignable<T>\x3a\x3avalue;                        // C++17\x0a"
"      template <class T> inline constexpr bool is_trivially_move_assignable_v\x0a"
"        = is_trivially_move_assignable<T>\x3a\x3avalue;                        // C++17\x0a"
"      template <class T> inline constexpr bool is_trivially_destructible_v\x0a"
"        = is_trivially_destructible<T>\x3a\x3avalue;                           // C++17\x0a"
"      template <class T, class... Args> inline constexpr bool is_nothrow_constructible_v\x0a"
"        = is_nothrow_constructible<T, Args...>\x3a\x3avalue;                   // C++17\x0a"
"      template <class T> inline constexpr bool is_nothrow_default_constructible_v\x0a"
"        = is_nothrow_default_constructible<T>\x3a\x3avalue;                    // C++17\x0a"
"      template <class T> inline constexpr bool is_nothrow_copy_constructible_v\x0a"
"        = is_nothrow_copy_constructible<T>\x3a\x3avalue;                       // C++17\x0a"
"      template <class T> inline constexpr bool is_nothrow_move_constructible_v\x0a"
"        = is_nothrow_move_constructible<T>\x3a\x3avalue;                       // C++17\x0a"
"      template <class T, class U> inline constexpr bool is_nothrow_assignable_v\x0a"
"        = is_nothrow_assignable<T, U>\x3a\x3avalue;                            // C++17\x0a"
"      template <class T> inline constexpr bool is_nothrow_copy_assignable_v\x0a"
"        = is_nothrow_copy_assignable<T>\x3a\x3avalue;                          // C++17\x0a"
"      template <class T> inline constexpr bool is_nothrow_move_assignable_v\x0a"
"        = is_nothrow_move_assignable<T>\x3a\x3avalue;                          // C++17\x0a"
"      template <class T, class U> inline constexpr bool is_nothrow_swappable_with_v\x0a"
"        = is_nothrow_swappable_with<T, U>\x3a\x3avalue;                       // C++17\x0a"
"      template <class T> inline constexpr bool is_nothrow_swappable_v\x0a"
"        = is_nothrow_swappable<T>\x3a\x3avalue;                               // C++17\x0a"
"      template <class T> inline constexpr bool is_nothrow_destructible_v\x0a"
"        = is_nothrow_destructible<T>\x3a\x3avalue;                             // C++17\x0a"
"      template <class T> inline constexpr bool has_virtual_destructor_v\x0a"
"        = has_virtual_destructor<T>\x3a\x3avalue;                              // C++17\x0a"
"      template<class T> inline constexpr bool has_unique_object_representations_v // C++17\x0a"
"        = has_unique_object_representations<T>\x3a\x3avalue;\x0a"
"\x0a"
"      // See C++14 20.10.5, type property queries\x0a"
"      template <class T> inline constexpr size_t alignment_of_v\x0a"
"        = alignment_of<T>\x3a\x3avalue;                                        // C++17\x0a"
"      template <class T> inline constexpr size_t rank_v\x0a"
"        = rank<T>\x3a\x3avalue;                                                // C++17\x0a"
"      template <class T, unsigned I = 0> inline constexpr size_t extent_v\x0a"
"        = extent<T, I>\x3a\x3avalue;                                           // C++17\x0a"
"\x0a"
"      // See C++14 20.10.6, type relations\x0a"
"      template <class T, class U> inline constexpr bool is_same_v\x0a"
"        = is_same<T, U>\x3a\x3avalue;                                          // C++17\x0a"
"      template <class Base, class Derived> inline constexpr bool is_base_of_v\x0a"
"        = is_base_of<Base, Derived>\x3a\x3avalue;                              // C++17\x0a"
"      template <class From, class To> inline constexpr bool is_convertible_v\x0a"
"        = is_convertible<From, To>\x3a\x3avalue;                               // C++17\x0a"
"      template <class Fn, class... ArgTypes> inline constexpr bool is_invocable_v\x0a"
"        = is_invocable<Fn, ArgTypes...>\x3a\x3avalue;                          // C++17\x0a"
"      template <class R, class Fn, class... ArgTypes> inline constexpr bool is_invocable_r_v\x0a"
"        = is_invocable_r<R, Fn, ArgTypes...>\x3a\x3avalue;                     // C++17\x0a"
"      template <class Fn, class... ArgTypes> inline constexpr bool is_nothrow_invocable_v\x0a"
"        = is_nothrow_invocable<Fn, ArgTypes...>\x3a\x3avalue;                  // C++17\x0a"
"      template <class R, class Fn, class... ArgTypes> inline constexpr bool is_nothrow_invocable_r_v\x0a"
"        = is_nothrow_invocable_r<R, Fn, ArgTypes...>\x3a\x3avalue;             // C++17\x0a"
"\x0a"
"      // \x5bmeta.logical\x5d, logical operator traits\x3a\x0a"
"      template<class... B> struct conjunction;                           // C++17\x0a"
"      template<class... B>\x0a"
"        inline constexpr bool conjunction_v = conjunction<B...>\x3a\x3avalue;  // C++17\x0a"
"      template<class... B> struct disjunction;                           // C++17\x0a"
"      template<class... B>\x0a"
"        inline constexpr bool disjunction_v = disjunction<B...>\x3a\x3avalue;  // C++17\x0a"
"      template<class B> struct negation;                                 // C++17\x0a"
"      template<class B>\x0a"
"        inline constexpr bool negation_v = negation<B>\x3a\x3avalue;           // C++17\x0a"
"\x0a"
"}\x0a"
"\x0a"
"*/\x0a"
"#include <__config>\x0a"
"#include <cstddef>\x0a"
"#include <version>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <class _T1, class _T2> struct _LIBCPP_TEMPLATE_VIS pair;\x0a"
"template <class _Tp> class _LIBCPP_TEMPLATE_VIS reference_wrapper;\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS hash;\x0a"
"\x0a"
"\x0a"
"template <class _Tp, _Tp __v>\x0a"
"struct _LIBCPP_TEMPLATE_VIS integral_constant\x0a"
"{\x0a"
"  static _LIBCPP_CONSTEXPR const _Tp      value = __v;\x0a"
"  typedef _Tp               value_type;\x0a"
"  typedef integral_constant type;\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  _LIBCPP_CONSTEXPR operator value_type() const _NOEXCEPT {return value;}\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"  _LIBCPP_INLINE_VISIBILITY\x0a"
"  constexpr value_type operator ()() const _NOEXCEPT {return value;}\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, _Tp __v>\x0a"
"_LIBCPP_CONSTEXPR const _Tp integral_constant<_Tp, __v>\x3a\x3avalue;\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"template <bool __b>\x0a"
"using bool_constant = integral_constant<bool, __b>;\x0a"
"#define _LIBCPP_BOOL_CONSTANT(__b) bool_constant<(__b)>\x0a"
"#else\x0a"
"#define _LIBCPP_BOOL_CONSTANT(__b) integral_constant<bool,(__b)>\x0a"
"#endif\x0a"
"\x0a"
"typedef _LIBCPP_BOOL_CONSTANT(true)  true_type;\x0a"
"typedef _LIBCPP_BOOL_CONSTANT(false) false_type;\x0a"
"\x0a"
"template <bool _Val>\x0a"
"using _BoolConstant _LIBCPP_NODEBUG_TYPE = integral_constant<bool, _Val>;\x0a"
"\x0a"
"template <bool> struct _MetaBase;\x0a"
"template <>\x0a"
"struct _MetaBase<true> {\x0a"
"  template <class _Tp, class _Up>\x0a"
"  using _SelectImpl _LIBCPP_NODEBUG_TYPE = _Tp;\x0a"
"  template <template <class...> class _FirstFn, template <class...> class, class ..._Args>\x0a"
"  using _SelectApplyImpl _LIBCPP_NODEBUG_TYPE = _FirstFn<_Args...>;\x0a"
"  template <class _First, class...>\x0a"
"  using _FirstImpl _LIBCPP_NODEBUG_TYPE = _First;\x0a"
"  template <class, class _Second, class...>\x0a"
"  using _SecondImpl _LIBCPP_NODEBUG_TYPE = _Second;\x0a"
"  template <class _Tp = void>\x0a"
"  using _EnableIfImpl _LIBCPP_NODEBUG_TYPE = _Tp;\x0a"
"  template <class _Result, class _First, class ..._Rest>\x0a"
"  using _OrImpl _LIBCPP_NODEBUG_TYPE = typename _MetaBase<_First\x3a\x3avalue \x21= true \x26\x26 sizeof...(_Rest) \x21= 0>\x3a\x3atemplate _OrImpl<_First, _Rest...>;\x0a"
"  template <class _Result, class _First, class ..._Rest>\x0a"
"  using _AndImpl _LIBCPP_NODEBUG_TYPE = typename _MetaBase<_First\x3a\x3avalue == true \x26\x26 sizeof...(_Rest) \x21= 0>\x3a\x3atemplate _AndImpl<_First, _Rest...>;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct _MetaBase<false> {\x0a"
"  template <class _Tp, class _Up>\x0a"
"  using _SelectImpl _LIBCPP_NODEBUG_TYPE = _Up;\x0a"
"  template <template <class...> class, template <class...> class _SecondFn, class ..._Args>\x0a"
"  using _SelectApplyImpl _LIBCPP_NODEBUG_TYPE = _SecondFn<_Args...>;\x0a"
"  template <class _Result, class ...>\x0a"
"  using _OrImpl _LIBCPP_NODEBUG_TYPE = _Result;\x0a"
"  template <class _Result, class ...>\x0a"
"  using _AndImpl _LIBCPP_NODEBUG_TYPE = _Result;\x0a"
"};\x0a"
"template <bool _Cond, class _Ret = void>\x0a"
"using _EnableIf _LIBCPP_NODEBUG_TYPE = typename _MetaBase<_Cond>\x3a\x3atemplate _EnableIfImpl<_Ret>;\x0a"
"template <bool _Cond, class _IfRes, class _ElseRes>\x0a"
"using _If _LIBCPP_NODEBUG_TYPE = typename _MetaBase<_Cond>\x3a\x3atemplate _SelectImpl<_IfRes, _ElseRes>;\x0a"
"template <class ..._Rest>\x0a"
"using _Or _LIBCPP_NODEBUG_TYPE = typename _MetaBase< sizeof...(_Rest) \x21= 0 >\x3a\x3atemplate _OrImpl<false_type, _Rest...>;\x0a"
"template <class ..._Rest>\x0a"
"using _And _LIBCPP_NODEBUG_TYPE = typename _MetaBase< sizeof...(_Rest) \x21= 0 >\x3a\x3atemplate _AndImpl<true_type, _Rest...>;\x0a"
"template <class _Pred>\x0a"
"struct _Not \x3a _BoolConstant<\x21_Pred\x3a\x3avalue> {};\x0a"
"template <class ..._Args>\x0a"
"using _FirstType _LIBCPP_NODEBUG_TYPE = typename _MetaBase<(sizeof...(_Args) >= 1)>\x3a\x3atemplate _FirstImpl<_Args...>;\x0a"
"template <class ..._Args>\x0a"
"using _SecondType _LIBCPP_NODEBUG_TYPE = typename _MetaBase<(sizeof...(_Args) >= 2)>\x3a\x3atemplate _SecondImpl<_Args...>;\x0a"
"\x0a"
"template <template <class...> class _Func, class ..._Args>\x0a"
"struct _Lazy \x3a _Func<_Args...> {};\x0a"
"\x0a"
"// Member detector base\x0a"
"\x0a"
"template <template <class...> class _Templ, class ..._Args>\x0a"
"true_type __sfinae_test_impl(_FirstType<int, _Templ<_Args...> >);\x0a"
"template <template <class...> class, class ...>\x0a"
"false_type __sfinae_test_impl(...);\x0a"
"\x0a"
"template <template <class ...> class _Templ, class ..._Args>\x0a"
"using _IsValidExpansion _LIBCPP_NODEBUG_TYPE = decltype(std\x3a\x3a__sfinae_test_impl<_Templ, _Args...>(0));\x0a"
"\x0a"
"template <class>\x0a"
"struct __void_t { typedef void type; };\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __identity { typedef _Tp type; };\x0a"
"\x0a"
"template <class _Tp, bool>\x0a"
"struct _LIBCPP_TEMPLATE_VIS __dependent_type \x3a public _Tp {};\x0a"
"\x0a"
"template <bool _Bp, class _If, class _Then>\x0a"
"    struct _LIBCPP_TEMPLATE_VIS conditional {typedef _If type;};\x0a"
"template <class _If, class _Then>\x0a"
"    struct _LIBCPP_TEMPLATE_VIS conditional<false, _If, _Then> {typedef _Then type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <bool _Bp, class _If, class _Then> using conditional_t = typename conditional<_Bp, _If, _Then>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"template <bool, class _Tp = void> struct _LIBCPP_TEMPLATE_VIS enable_if {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS enable_if<true, _Tp> {typedef _Tp type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <bool _Bp, class _Tp = void> using enable_if_t = typename enable_if<_Bp, _Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// is_same\x0a"
"\x0a"
"template <class _Tp, class _Up> struct _LIBCPP_TEMPLATE_VIS is_same           \x3a public false_type {};\x0a"
"template <class _Tp>            struct _LIBCPP_TEMPLATE_VIS is_same<_Tp, _Tp> \x3a public true_type {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_same_v\x0a"
"    = is_same<_Tp, _Up>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"using _IsSame = _BoolConstant<\x0a"
"#ifdef __clang__\x0a"
"    __is_same(_Tp, _Up)\x0a"
"#else\x0a"
"    _VSTD\x3a\x3ais_same<_Tp, _Up>\x3a\x3avalue\x0a"
"#endif\x0a"
">;\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"using _IsNotSame = _BoolConstant<\x0a"
"#ifdef __clang__\x0a"
"    \x21__is_same(_Tp, _Up)\x0a"
"#else\x0a"
"    \x21_VSTD\x3a\x3ais_same<_Tp, _Up>\x3a\x3avalue\x0a"
"#endif\x0a"
">;\x0a"
"// addressof\x0a"
"#ifndef _LIBCPP_HAS_NO_BUILTIN_ADDRESSOF\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_CONSTEXPR_AFTER_CXX14\x0a"
"_LIBCPP_NO_CFI _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"addressof(_Tp\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"    return __builtin_addressof(__x);\x0a"
"}\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_NO_CFI _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"addressof(_Tp\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"  return reinterpret_cast<_Tp *>(\x0a"
"      const_cast<char *>(\x26reinterpret_cast<const volatile char \x26>(__x)));\x0a"
"}\x0a"
"\x0a"
"#endif // _LIBCPP_HAS_NO_BUILTIN_ADDRESSOF\x0a"
"\x0a"
"#if defined(_LIBCPP_HAS_OBJC_ARC) \x26\x26 \x21""defined(_LIBCPP_PREDEFINED_OBJC_ARC_ADDRESSOF)\x0a"
"// Objective-C++ Automatic Reference Counting uses qualified pointers\x0a"
"// that require special addressof() signatures. When\x0a"
"// _LIBCPP_PREDEFINED_OBJC_ARC_ADDRESSOF is defined, the compiler\x0a"
"// itself is providing these definitions. Otherwise, we provide them.\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__strong _Tp*\x0a"
"addressof(__strong _Tp\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"  return \x26__x;\x0a"
"}\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_OBJC_ARC_WEAK\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__weak _Tp*\x0a"
"addressof(__weak _Tp\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"  return \x26__x;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__autoreleasing _Tp*\x0a"
"addressof(__autoreleasing _Tp\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"  return \x26__x;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__unsafe_unretained _Tp*\x0a"
"addressof(__unsafe_unretained _Tp\x26 __x) _NOEXCEPT\x0a"
"{\x0a"
"  return \x26__x;\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"template <class _Tp> _Tp* addressof(const _Tp\x26\x26) noexcept = delete;\x0a"
"#endif\x0a"
"\x0a"
"struct __two {char __lx\x5b""2\x5d;};\x0a"
"\x0a"
"// helper class\x3a\x0a"
"\x0a"
"// is_const\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_const            \x3a public false_type {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_const<_Tp const> \x3a public true_type {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_const_v\x0a"
"    = is_const<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_volatile\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_volatile               \x3a public false_type {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_volatile<_Tp volatile> \x3a public true_type {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_volatile_v\x0a"
"    = is_volatile<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// remove_const\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_const            {typedef _Tp type;};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_const<const _Tp> {typedef _Tp type;};\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using remove_const_t = typename remove_const<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// remove_volatile\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_volatile               {typedef _Tp type;};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_volatile<volatile _Tp> {typedef _Tp type;};\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using remove_volatile_t = typename remove_volatile<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// remove_cv\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_cv\x0a"
"{typedef typename remove_volatile<typename remove_const<_Tp>\x3a\x3atype>\x3a\x3atype type;};\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using remove_cv_t = typename remove_cv<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// is_void\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_is_void       \x3a public false_type {};\x0a"
"template <>          struct __libcpp_is_void<void> \x3a public true_type {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_void\x0a"
"    \x3a public __libcpp_is_void<typename remove_cv<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_void_v\x0a"
"    = is_void<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// __is_nullptr_t\x0a"
"\x0a"
"template <class _Tp> struct __is_nullptr_t_impl       \x3a public false_type {};\x0a"
"template <>          struct __is_nullptr_t_impl<nullptr_t> \x3a public true_type {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS __is_nullptr_t\x0a"
"    \x3a public __is_nullptr_t_impl<typename remove_cv<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_null_pointer\x0a"
"    \x3a public __is_nullptr_t_impl<typename remove_cv<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_null_pointer_v\x0a"
"    = is_null_pointer<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"#endif\x0a"
"\x0a"
"// is_integral\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_is_integral                     \x3a public false_type {};\x0a"
"template <>          struct __libcpp_is_integral<bool>               \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<char>               \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<signed char>        \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<unsigned char>      \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<wchar_t>            \x3a public true_type {};\x0a"
"#ifndef _LIBCPP_NO_HAS_CHAR8_T\x0a"
"template <>          struct __libcpp_is_integral<char8_t>            \x3a public true_type {};\x0a"
"#endif\x0a"
"#ifndef _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"template <>          struct __libcpp_is_integral<char16_t>           \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<char32_t>           \x3a public true_type {};\x0a"
"#endif  // _LIBCPP_HAS_NO_UNICODE_CHARS\x0a"
"template <>          struct __libcpp_is_integral<short>              \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<unsigned short>     \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<int>                \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<unsigned int>       \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<long>               \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<unsigned long>      \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<long long>          \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<unsigned long long> \x3a public true_type {};\x0a"
"#ifndef _LIBCPP_HAS_NO_INT128\x0a"
"template <>          struct __libcpp_is_integral<__int128_t>         \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_integral<__uint128_t>        \x3a public true_type {};\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_integral\x0a"
"    \x3a public __libcpp_is_integral<typename remove_cv<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_integral_v\x0a"
"    = is_integral<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_floating_point\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_is_floating_point              \x3a public false_type {};\x0a"
"template <>          struct __libcpp_is_floating_point<float>       \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_floating_point<double>      \x3a public true_type {};\x0a"
"template <>          struct __libcpp_is_floating_point<long double> \x3a public true_type {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_floating_point\x0a"
"    \x3a public __libcpp_is_floating_point<typename remove_cv<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_floating_point_v\x0a"
"    = is_floating_point<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_array\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_array\x0a"
"    \x3a public false_type {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_array<_Tp\x5b\x5d>\x0a"
"    \x3a public true_type {};\x0a"
"template <class _Tp, size_t _Np> struct _LIBCPP_TEMPLATE_VIS is_array<_Tp\x5b_Np\x5d>\x0a"
"    \x3a public true_type {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_array_v\x0a"
"    = is_array<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_pointer\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_is_pointer       \x3a public false_type {};\x0a"
"template <class _Tp> struct __libcpp_is_pointer<_Tp*> \x3a public true_type {};\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_remove_objc_qualifiers { typedef _Tp type; };\x0a"
"#if defined(_LIBCPP_HAS_OBJC_ARC)\x0a"
"template <class _Tp> struct __libcpp_remove_objc_qualifiers<_Tp __strong> { typedef _Tp type; };\x0a"
"template <class _Tp> struct __libcpp_remove_objc_qualifiers<_Tp __weak> { typedef _Tp type; };\x0a"
"template <class _Tp> struct __libcpp_remove_objc_qualifiers<_Tp __autoreleasing> { typedef _Tp type; };\x0a"
"template <class _Tp> struct __libcpp_remove_objc_qualifiers<_Tp __unsafe_unretained> { typedef _Tp type; };\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_pointer\x0a"
"    \x3a public __libcpp_is_pointer<typename __libcpp_remove_objc_qualifiers<typename remove_cv<_Tp>\x3a\x3atype>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_pointer_v\x0a"
"    = is_pointer<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_reference\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_lvalue_reference       \x3a public false_type {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_lvalue_reference<_Tp\x26> \x3a public true_type {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_rvalue_reference        \x3a public false_type {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_rvalue_reference<_Tp\x26\x26> \x3a public true_type {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_reference        \x3a public false_type {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_reference<_Tp\x26>  \x3a public true_type {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_reference<_Tp\x26\x26> \x3a public true_type {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_reference_v\x0a"
"    = is_reference<_Tp>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_lvalue_reference_v\x0a"
"    = is_lvalue_reference<_Tp>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_rvalue_reference_v\x0a"
"    = is_rvalue_reference<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"// is_union\x0a"
"\x0a"
"#if __has_feature(is_union) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_union\x0a"
"    \x3a public integral_constant<bool, __is_union(_Tp)> {};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_union \x3a public false_type {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_union\x0a"
"    \x3a public __libcpp_union<typename remove_cv<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_union_v\x0a"
"    = is_union<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_class\x0a"
"\x0a"
"#if __has_feature(is_class) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_class\x0a"
"    \x3a public integral_constant<bool, __is_class(_Tp)> {};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"namespace __is_class_imp\x0a"
"{\x0a"
"template <class _Tp> char  __test(int _Tp\x3a\x3a*);\x0a"
"template <class _Tp> __two __test(...);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_class\x0a"
"    \x3a public integral_constant<bool, sizeof(__is_class_imp\x3a\x3a__test<_Tp>(0)) == 1 \x26\x26 \x21is_union<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_class_v\x0a"
"    = is_class<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_function\x0a"
"\x0a"
"namespace __libcpp_is_function_imp\x0a"
"{\x0a"
"struct __dummy_type {};\x0a"
"template <class _Tp> char  __test(_Tp*);\x0a"
"template <class _Tp> char __test(__dummy_type);\x0a"
"template <class _Tp> __two __test(...);\x0a"
"template <class _Tp> _Tp\x26  __source(int);\x0a"
"template <class _Tp> __dummy_type __source(...);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, bool = is_class<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                            is_union<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                            is_void<_Tp>\x3a\x3avalue  \x7c\x7c\x0a"
"                            is_reference<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                            __is_nullptr_t<_Tp>\x3a\x3avalue >\x0a"
"struct __libcpp_is_function\x0a"
"    \x3a public integral_constant<bool, sizeof(__libcpp_is_function_imp\x3a\x3a__test<_Tp>(__libcpp_is_function_imp\x3a\x3a__source<_Tp>(0))) == 1>\x0a"
"    {};\x0a"
"template <class _Tp> struct __libcpp_is_function<_Tp, true> \x3a public false_type {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_function\x0a"
"    \x3a public __libcpp_is_function<_Tp> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_function_v\x0a"
"    = is_function<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_member_function_pointer\x0a"
"\x0a"
"// template <class _Tp> struct            __libcpp_is_member_function_pointer             \x3a public false_type {};\x0a"
"// template <class _Tp, class _Up> struct __libcpp_is_member_function_pointer<_Tp _Up\x3a\x3a*> \x3a public is_function<_Tp> {};\x0a"
"//\x0a"
"\x0a"
"template <class _MP, bool _IsMemberFunctionPtr, bool _IsMemberObjectPtr>\x0a"
"struct __member_pointer_traits_imp\x0a"
"{  // forward declaration; specializations later\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_is_member_function_pointer\x0a"
"    \x3a public false_type {};\x0a"
"\x0a"
"template <class _Ret, class _Class>\x0a"
"struct __libcpp_is_member_function_pointer<_Ret _Class\x3a\x3a*>\x0a"
"    \x3a public is_function<_Ret> {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_member_function_pointer\x0a"
"    \x3a public __libcpp_is_member_function_pointer<typename remove_cv<_Tp>\x3a\x3atype>\x3a\x3atype {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_member_function_pointer_v\x0a"
"    = is_member_function_pointer<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_member_pointer\x0a"
"\x0a"
"template <class _Tp>            struct __libcpp_is_member_pointer             \x3a public false_type {};\x0a"
"template <class _Tp, class _Up> struct __libcpp_is_member_pointer<_Tp _Up\x3a\x3a*> \x3a public true_type {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_member_pointer\x0a"
"    \x3a public __libcpp_is_member_pointer<typename remove_cv<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_member_pointer_v\x0a"
"    = is_member_pointer<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_member_object_pointer\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_member_object_pointer\x0a"
"    \x3a public integral_constant<bool, is_member_pointer<_Tp>\x3a\x3avalue \x26\x26\x0a"
"                                    \x21is_member_function_pointer<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_member_object_pointer_v\x0a"
"    = is_member_object_pointer<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_enum\x0a"
"\x0a"
"#if __has_feature(is_enum) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_enum\x0a"
"    \x3a public integral_constant<bool, __is_enum(_Tp)> {};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_enum\x0a"
"    \x3a public integral_constant<bool, \x21is_void<_Tp>\x3a\x3avalue             \x26\x26\x0a"
"                                     \x21is_integral<_Tp>\x3a\x3avalue         \x26\x26\x0a"
"                                     \x21is_floating_point<_Tp>\x3a\x3avalue   \x26\x26\x0a"
"                                     \x21is_array<_Tp>\x3a\x3avalue            \x26\x26\x0a"
"                                     \x21is_pointer<_Tp>\x3a\x3avalue          \x26\x26\x0a"
"                                     \x21is_reference<_Tp>\x3a\x3avalue        \x26\x26\x0a"
"                                     \x21is_member_pointer<_Tp>\x3a\x3avalue   \x26\x26\x0a"
"                                     \x21is_union<_Tp>\x3a\x3avalue            \x26\x26\x0a"
"                                     \x21is_class<_Tp>\x3a\x3avalue            \x26\x26\x0a"
"                                     \x21is_function<_Tp>\x3a\x3avalue         > {};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_enum_v\x0a"
"    = is_enum<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_arithmetic\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_arithmetic\x0a"
"    \x3a public integral_constant<bool, is_integral<_Tp>\x3a\x3avalue      \x7c\x7c\x0a"
"                                     is_floating_point<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_arithmetic_v\x0a"
"    = is_arithmetic<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_fundamental\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_fundamental\x0a"
"    \x3a public integral_constant<bool, is_void<_Tp>\x3a\x3avalue        \x7c\x7c\x0a"
"                                     __is_nullptr_t<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                                     is_arithmetic<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_fundamental_v\x0a"
"    = is_fundamental<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_scalar\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_scalar\x0a"
"    \x3a public integral_constant<bool, is_arithmetic<_Tp>\x3a\x3avalue     \x7c\x7c\x0a"
"                                     is_member_pointer<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                                     is_pointer<_Tp>\x3a\x3avalue        \x7c\x7c\x0a"
"                                     __is_nullptr_t<_Tp>\x3a\x3avalue    \x7c\x7c\x0a"
"                                     is_enum<_Tp>\x3a\x3avalue           > {};\x0a"
"\x0a"
"template <> struct _LIBCPP_TEMPLATE_VIS is_scalar<nullptr_t> \x3a public true_type {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_scalar_v\x0a"
"    = is_scalar<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_object\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_object\x0a"
"    \x3a public integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                                     is_array<_Tp>\x3a\x3avalue  \x7c\x7c\x0a"
"                                     is_union<_Tp>\x3a\x3avalue  \x7c\x7c\x0a"
"                                     is_class<_Tp>\x3a\x3avalue  > {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_object_v\x0a"
"    = is_object<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_compound\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_compound\x0a"
"    \x3a public integral_constant<bool, \x21is_fundamental<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_compound_v\x0a"
"    = is_compound<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"// __is_referenceable  \x5b""defns.referenceable\x5d\x0a"
"\x0a"
"struct __is_referenceable_impl {\x0a"
"    template <class _Tp> static _Tp\x26 __test(int);\x0a"
"    template <class _Tp> static __two __test(...);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_referenceable \x3a integral_constant<bool,\x0a"
"    _IsNotSame<decltype(__is_referenceable_impl\x3a\x3a__test<_Tp>(0)), __two>\x3a\x3avalue> {};\x0a"
"\x0a"
"\x0a"
"// add_const\x0a"
"\x0a"
"template <class _Tp, bool = is_reference<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                            is_function<_Tp>\x3a\x3avalue  \x7c\x7c\x0a"
"                            is_const<_Tp>\x3a\x3avalue     >\x0a"
"struct __add_const             {typedef _LIBCPP_NODEBUG_TYPE  _Tp type;};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __add_const<_Tp, false> {typedef _LIBCPP_NODEBUG_TYPE  const _Tp type;};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS add_const\x0a"
"    {typedef _LIBCPP_NODEBUG_TYPE  typename __add_const<_Tp>\x3a\x3atype type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using add_const_t = typename add_const<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// add_volatile\x0a"
"\x0a"
"template <class _Tp, bool = is_reference<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                            is_function<_Tp>\x3a\x3avalue  \x7c\x7c\x0a"
"                            is_volatile<_Tp>\x3a\x3avalue  >\x0a"
"struct __add_volatile             {typedef _Tp type;};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __add_volatile<_Tp, false> {typedef volatile _Tp type;};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS add_volatile\x0a"
"    {typedef _LIBCPP_NODEBUG_TYPE typename __add_volatile<_Tp>\x3a\x3atype type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using add_volatile_t = typename add_volatile<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// add_cv\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS add_cv\x0a"
"    {typedef _LIBCPP_NODEBUG_TYPE typename add_const<typename add_volatile<_Tp>\x3a\x3atype>\x3a\x3atype type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using add_cv_t = typename add_cv<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// remove_reference\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_reference        {typedef _LIBCPP_NODEBUG_TYPE _Tp type;};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_reference<_Tp\x26>  {typedef _LIBCPP_NODEBUG_TYPE _Tp type;};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_reference<_Tp\x26\x26> {typedef _LIBCPP_NODEBUG_TYPE _Tp type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using remove_reference_t = typename remove_reference<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// add_lvalue_reference\x0a"
"\x0a"
"template <class _Tp, bool = __is_referenceable<_Tp>\x3a\x3avalue> struct __add_lvalue_reference_impl            { typedef _LIBCPP_NODEBUG_TYPE _Tp  type; };\x0a"
"template <class _Tp                                       > struct __add_lvalue_reference_impl<_Tp, true> { typedef _LIBCPP_NODEBUG_TYPE _Tp\x26 type; };\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS add_lvalue_reference\x0a"
"{typedef _LIBCPP_NODEBUG_TYPE typename  __add_lvalue_reference_impl<_Tp>\x3a\x3atype type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using add_lvalue_reference_t = typename add_lvalue_reference<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, bool = __is_referenceable<_Tp>\x3a\x3avalue> struct __add_rvalue_reference_impl            { typedef _LIBCPP_NODEBUG_TYPE  _Tp   type; };\x0a"
"template <class _Tp                                       > struct __add_rvalue_reference_impl<_Tp, true> { typedef _LIBCPP_NODEBUG_TYPE  _Tp\x26\x26 type; };\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS add_rvalue_reference\x0a"
"{typedef _LIBCPP_NODEBUG_TYPE  typename __add_rvalue_reference_impl<_Tp>\x3a\x3atype type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using add_rvalue_reference_t = typename add_rvalue_reference<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp> _Tp\x26\x26 __declval(int);\x0a"
"template <class _Tp> _Tp   __declval(long);\x0a"
"\x0a"
"template <class _Tp>\x0a"
"decltype(_VSTD\x3a\x3a__declval<_Tp>(0))\x0a"
"declval() _NOEXCEPT;\x0a"
"\x0a"
"// __uncvref\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __uncvref  {\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename remove_cv<typename remove_reference<_Tp>\x3a\x3atype>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __unconstref {\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename remove_const<typename remove_reference<_Tp>\x3a\x3atype>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Tp>\x0a"
"using __uncvref_t _LIBCPP_NODEBUG_TYPE = typename __uncvref<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// __is_same_uncvref\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __is_same_uncvref \x3a _IsSame<typename __uncvref<_Tp>\x3a\x3atype,\x0a"
"                                   typename __uncvref<_Up>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"// remove_cvref - same as __uncvref\x0a"
"template <class _Tp>\x0a"
"struct remove_cvref \x3a public __uncvref<_Tp> {};\x0a"
"\x0a"
"template <class _Tp> using remove_cvref_t = typename remove_cvref<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"struct __any\x0a"
"{\x0a"
"    __any(...);\x0a"
"};\x0a"
"\x0a"
"// remove_pointer\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_pointer                      {typedef _LIBCPP_NODEBUG_TYPE _Tp type;};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_pointer<_Tp*>                {typedef _LIBCPP_NODEBUG_TYPE _Tp type;};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_pointer<_Tp* const>          {typedef _LIBCPP_NODEBUG_TYPE _Tp type;};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_pointer<_Tp* volatile>       {typedef _LIBCPP_NODEBUG_TYPE _Tp type;};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_pointer<_Tp* const volatile> {typedef _LIBCPP_NODEBUG_TYPE _Tp type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using remove_pointer_t = typename remove_pointer<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// add_pointer\x0a"
"\x0a"
"template <class _Tp,\x0a"
"        bool = __is_referenceable<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                _IsSame<typename remove_cv<_Tp>\x3a\x3atype, void>\x3a\x3avalue>\x0a"
"struct __add_pointer_impl\x0a"
"    {typedef _LIBCPP_NODEBUG_TYPE typename remove_reference<_Tp>\x3a\x3atype* type;};\x0a"
"template <class _Tp> struct __add_pointer_impl<_Tp, false>\x0a"
"    {typedef _LIBCPP_NODEBUG_TYPE _Tp type;};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS add_pointer\x0a"
"    {typedef _LIBCPP_NODEBUG_TYPE typename __add_pointer_impl<_Tp>\x3a\x3atype type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using add_pointer_t = typename add_pointer<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// type_identity\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template<class _Tp> struct type_identity { typedef _Tp type; };\x0a"
"template<class _Tp> using type_identity_t = typename type_identity<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// is_signed\x0a"
"\x0a"
"template <class _Tp, bool = is_integral<_Tp>\x3a\x3avalue>\x0a"
"struct __libcpp_is_signed_impl \x3a public _LIBCPP_BOOL_CONSTANT(_Tp(-1) < _Tp(0)) {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __libcpp_is_signed_impl<_Tp, false> \x3a public true_type {};  // floating point\x0a"
"\x0a"
"template <class _Tp, bool = is_arithmetic<_Tp>\x3a\x3avalue>\x0a"
"struct __libcpp_is_signed \x3a public __libcpp_is_signed_impl<_Tp> {};\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_is_signed<_Tp, false> \x3a public false_type {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_signed \x3a public __libcpp_is_signed<_Tp> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_signed_v\x0a"
"    = is_signed<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_unsigned\x0a"
"\x0a"
"template <class _Tp, bool = is_integral<_Tp>\x3a\x3avalue>\x0a"
"struct __libcpp_is_unsigned_impl \x3a public _LIBCPP_BOOL_CONSTANT(_Tp(0) < _Tp(-1)) {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __libcpp_is_unsigned_impl<_Tp, false> \x3a public false_type {};  // floating point\x0a"
"\x0a"
"template <class _Tp, bool = is_arithmetic<_Tp>\x3a\x3avalue>\x0a"
"struct __libcpp_is_unsigned \x3a public __libcpp_is_unsigned_impl<_Tp> {};\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_is_unsigned<_Tp, false> \x3a public false_type {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_unsigned \x3a public __libcpp_is_unsigned<_Tp> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_unsigned_v\x0a"
"    = is_unsigned<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// rank\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS rank\x0a"
"    \x3a public integral_constant<size_t, 0> {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS rank<_Tp\x5b\x5d>\x0a"
"    \x3a public integral_constant<size_t, rank<_Tp>\x3a\x3avalue + 1> {};\x0a"
"template <class _Tp, size_t _Np> struct _LIBCPP_TEMPLATE_VIS rank<_Tp\x5b_Np\x5d>\x0a"
"    \x3a public integral_constant<size_t, rank<_Tp>\x3a\x3avalue + 1> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR size_t rank_v\x0a"
"    = rank<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// extent\x0a"
"\x0a"
"template <class _Tp, unsigned _Ip = 0> struct _LIBCPP_TEMPLATE_VIS extent\x0a"
"    \x3a public integral_constant<size_t, 0> {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS extent<_Tp\x5b\x5d, 0>\x0a"
"    \x3a public integral_constant<size_t, 0> {};\x0a"
"template <class _Tp, unsigned _Ip> struct _LIBCPP_TEMPLATE_VIS extent<_Tp\x5b\x5d, _Ip>\x0a"
"    \x3a public integral_constant<size_t, extent<_Tp, _Ip-1>\x3a\x3avalue> {};\x0a"
"template <class _Tp, size_t _Np> struct _LIBCPP_TEMPLATE_VIS extent<_Tp\x5b_Np\x5d, 0>\x0a"
"    \x3a public integral_constant<size_t, _Np> {};\x0a"
"template <class _Tp, size_t _Np, unsigned _Ip> struct _LIBCPP_TEMPLATE_VIS extent<_Tp\x5b_Np\x5d, _Ip>\x0a"
"    \x3a public integral_constant<size_t, extent<_Tp, _Ip-1>\x3a\x3avalue> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp, unsigned _Ip = 0>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR size_t extent_v\x0a"
"    = extent<_Tp, _Ip>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// remove_extent\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_extent\x0a"
"    {typedef _Tp type;};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_extent<_Tp\x5b\x5d>\x0a"
"    {typedef _Tp type;};\x0a"
"template <class _Tp, size_t _Np> struct _LIBCPP_TEMPLATE_VIS remove_extent<_Tp\x5b_Np\x5d>\x0a"
"    {typedef _Tp type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using remove_extent_t = typename remove_extent<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// remove_all_extents\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_all_extents\x0a"
"    {typedef _Tp type;};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS remove_all_extents<_Tp\x5b\x5d>\x0a"
"    {typedef typename remove_all_extents<_Tp>\x3a\x3atype type;};\x0a"
"template <class _Tp, size_t _Np> struct _LIBCPP_TEMPLATE_VIS remove_all_extents<_Tp\x5b_Np\x5d>\x0a"
"    {typedef typename remove_all_extents<_Tp>\x3a\x3atype type;};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using remove_all_extents_t = typename remove_all_extents<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"// is_bounded_array\x0a"
"\x0a"
"template <class>                 struct _LIBCPP_TEMPLATE_VIS is_bounded_array           \x3a false_type {};\x0a"
"template <class _Tp, size_t _Np> struct _LIBCPP_TEMPLATE_VIS is_bounded_array<_Tp\x5b_Np\x5d> \x3a true_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR\x0a"
"bool is_bounded_array_v  = is_bounded_array<_Tp>\x3a\x3avalue;\x0a"
"\x0a"
"// is_unbounded_array\x0a"
"\x0a"
"template <class>     struct _LIBCPP_TEMPLATE_VIS is_unbounded_array        \x3a false_type {};\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_unbounded_array<_Tp\x5b\x5d> \x3a true_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR\x0a"
"bool is_unbounded_array_v  = is_unbounded_array<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// decay\x0a"
"\x0a"
"template <class _Up, bool>\x0a"
"struct __decay {\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename remove_cv<_Up>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Up>\x0a"
"struct __decay<_Up, true> {\x0a"
"public\x3a\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename conditional\x0a"
"                     <\x0a"
"                         is_array<_Up>\x3a\x3avalue,\x0a"
"                         typename remove_extent<_Up>\x3a\x3atype*,\x0a"
"                         typename conditional\x0a"
"                         <\x0a"
"                              is_function<_Up>\x3a\x3avalue,\x0a"
"                              typename add_pointer<_Up>\x3a\x3atype,\x0a"
"                              typename remove_cv<_Up>\x3a\x3atype\x0a"
"                         >\x3a\x3atype\x0a"
"                     >\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS decay\x0a"
"{\x0a"
"private\x3a\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename remove_reference<_Tp>\x3a\x3atype _Up;\x0a"
"public\x3a\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename __decay<_Up, __is_referenceable<_Up>\x3a\x3avalue>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using decay_t = typename decay<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// is_abstract\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_abstract\x0a"
"    \x3a public integral_constant<bool, __is_abstract(_Tp)> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_abstract_v\x0a"
"    = is_abstract<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_final\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS\x0a"
"__libcpp_is_final \x3a public integral_constant<bool, __is_final(_Tp)> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS\x0a"
"is_final \x3a public integral_constant<bool, __is_final(_Tp)> {};\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_final_v\x0a"
"    = is_final<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_aggregate\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_IS_AGGREGATE)\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS\x0a"
"is_aggregate \x3a public integral_constant<bool, __is_aggregate(_Tp)> {};\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_aggregate_v\x0a"
"    = is_aggregate<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_IS_AGGREGATE)\x0a"
"\x0a"
"// is_base_of\x0a"
"\x0a"
"template <class _Bp, class _Dp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_base_of\x0a"
"    \x3a public integral_constant<bool, __is_base_of(_Bp, _Dp)> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Bp, class _Dp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_base_of_v\x0a"
"    = is_base_of<_Bp, _Dp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_convertible\x0a"
"\x0a"
"#if __has_feature(is_convertible_to) \x26\x26 \x21""defined(_LIBCPP_USE_IS_CONVERTIBLE_FALLBACK)\x0a"
"\x0a"
"template <class _T1, class _T2> struct _LIBCPP_TEMPLATE_VIS is_convertible\x0a"
"    \x3a public integral_constant<bool, __is_convertible_to(_T1, _T2) \x26\x26\x0a"
"                                     \x21is_abstract<_T2>\x3a\x3avalue> {};\x0a"
"\x0a"
"#else  // __has_feature(is_convertible_to)\x0a"
"\x0a"
"namespace __is_convertible_imp\x0a"
"{\x0a"
"template <class _Tp> void  __test_convert(_Tp);\x0a"
"\x0a"
"template <class _From, class _To, class = void>\x0a"
"struct __is_convertible_test \x3a public false_type {};\x0a"
"\x0a"
"template <class _From, class _To>\x0a"
"struct __is_convertible_test<_From, _To,\x0a"
"    decltype(_VSTD\x3a\x3a__is_convertible_imp\x3a\x3a__test_convert<_To>(_VSTD\x3a\x3a""declval<_From>()))> \x3a public true_type\x0a"
"{};\x0a"
"\x0a"
"template <class _Tp, bool _IsArray =    is_array<_Tp>\x3a\x3avalue,\x0a"
"                     bool _IsFunction = is_function<_Tp>\x3a\x3avalue,\x0a"
"                     bool _IsVoid =     is_void<_Tp>\x3a\x3avalue>\x0a"
"                     struct __is_array_function_or_void                          {enum {value = 0};};\x0a"
"template <class _Tp> struct __is_array_function_or_void<_Tp, true, false, false> {enum {value = 1};};\x0a"
"template <class _Tp> struct __is_array_function_or_void<_Tp, false, true, false> {enum {value = 2};};\x0a"
"template <class _Tp> struct __is_array_function_or_void<_Tp, false, false, true> {enum {value = 3};};\x0a"
"}\x0a"
"\x0a"
"template <class _Tp,\x0a"
"    unsigned = __is_convertible_imp\x3a\x3a__is_array_function_or_void<typename remove_reference<_Tp>\x3a\x3atype>\x3a\x3avalue>\x0a"
"struct __is_convertible_check\x0a"
"{\x0a"
"    static const size_t __v = 0;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_convertible_check<_Tp, 0>\x0a"
"{\x0a"
"    static const size_t __v = sizeof(_Tp);\x0a"
"};\x0a"
"\x0a"
"template <class _T1, class _T2,\x0a"
"    unsigned _T1_is_array_function_or_void = __is_convertible_imp\x3a\x3a__is_array_function_or_void<_T1>\x3a\x3avalue,\x0a"
"    unsigned _T2_is_array_function_or_void = __is_convertible_imp\x3a\x3a__is_array_function_or_void<_T2>\x3a\x3avalue>\x0a"
"struct __is_convertible\x0a"
"    \x3a public integral_constant<bool,\x0a"
"        __is_convertible_imp\x3a\x3a__is_convertible_test<_T1, _T2>\x3a\x3avalue\x0a"
"    >\x0a"
"{};\x0a"
"\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 0, 1> \x3a public false_type {};\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 1, 1> \x3a public false_type {};\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 2, 1> \x3a public false_type {};\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 3, 1> \x3a public false_type {};\x0a"
"\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 0, 2> \x3a public false_type {};\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 1, 2> \x3a public false_type {};\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 2, 2> \x3a public false_type {};\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 3, 2> \x3a public false_type {};\x0a"
"\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 0, 3> \x3a public false_type {};\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 1, 3> \x3a public false_type {};\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 2, 3> \x3a public false_type {};\x0a"
"template <class _T1, class _T2> struct __is_convertible<_T1, _T2, 3, 3> \x3a public true_type {};\x0a"
"\x0a"
"template <class _T1, class _T2> struct _LIBCPP_TEMPLATE_VIS is_convertible\x0a"
"    \x3a public __is_convertible<_T1, _T2>\x0a"
"{\x0a"
"    static const size_t __complete_check1 = __is_convertible_check<_T1>\x3a\x3a__v;\x0a"
"    static const size_t __complete_check2 = __is_convertible_check<_T2>\x3a\x3a__v;\x0a"
"};\x0a"
"\x0a"
"#endif  // __has_feature(is_convertible_to)\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _From, class _To>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_convertible_v\x0a"
"    = is_convertible<_From, _To>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_nothrow_convertible\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"static void __test_noexcept(_Tp) noexcept;\x0a"
"\x0a"
"template<typename _Fm, typename _To>\x0a"
"static bool_constant<noexcept(__test_noexcept<_To>(declval<_Fm>()))>\x0a"
"__is_nothrow_convertible_test();\x0a"
"\x0a"
"template <typename _Fm, typename _To>\x0a"
"struct __is_nothrow_convertible_helper\x3a decltype(__is_nothrow_convertible_test<_Fm, _To>())\x0a"
"{ };\x0a"
"\x0a"
"template <typename _Fm, typename _To>\x0a"
"struct is_nothrow_convertible \x3a _Or<\x0a"
"    _And<is_void<_To>, is_void<_Fm>>,\x0a"
"    _Lazy<_And, is_convertible<_Fm, _To>, __is_nothrow_convertible_helper<_Fm, _To>>\x0a"
">\x3a\x3atype { };\x0a"
"\x0a"
"template <typename _Fm, typename _To>\x0a"
"inline constexpr bool is_nothrow_convertible_v = is_nothrow_convertible<_Fm, _To>\x3a\x3avalue;\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 17\x0a"
"\x0a"
"// is_empty\x0a"
"\x0a"
"#if __has_feature(is_empty) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_empty\x0a"
"    \x3a public integral_constant<bool, __is_empty(_Tp)> {};\x0a"
"\x0a"
"#else  // __has_feature(is_empty)\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_empty1\x0a"
"    \x3a public _Tp\x0a"
"{\x0a"
"    double __lx;\x0a"
"};\x0a"
"\x0a"
"struct __is_empty2\x0a"
"{\x0a"
"    double __lx;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool = is_class<_Tp>\x3a\x3avalue>\x0a"
"struct __libcpp_empty \x3a public integral_constant<bool, sizeof(__is_empty1<_Tp>) == sizeof(__is_empty2)> {};\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_empty<_Tp, false> \x3a public false_type {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_empty \x3a public __libcpp_empty<_Tp> {};\x0a"
"\x0a"
"#endif  // __has_feature(is_empty)\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_empty_v\x0a"
"    = is_empty<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_polymorphic\x0a"
"\x0a"
"#if __has_feature(is_polymorphic) \x7c\x7c defined(_LIBCPP_COMPILER_MSVC)\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_polymorphic\x0a"
"    \x3a public integral_constant<bool, __is_polymorphic(_Tp)> {};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template<typename _Tp> char \x26__is_polymorphic_impl(\x0a"
"    typename enable_if<sizeof((_Tp*)dynamic_cast<const volatile void*>(declval<_Tp*>())) \x21= 0,\x0a"
"                       int>\x3a\x3atype);\x0a"
"template<typename _Tp> __two \x26__is_polymorphic_impl(...);\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_polymorphic\x0a"
"    \x3a public integral_constant<bool, sizeof(__is_polymorphic_impl<_Tp>(0)) == 1> {};\x0a"
"\x0a"
"#endif // __has_feature(is_polymorphic)\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_polymorphic_v\x0a"
"    = is_polymorphic<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// has_virtual_destructor\x0a"
"\x0a"
"#if __has_feature(has_virtual_destructor) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS has_virtual_destructor\x0a"
"    \x3a public integral_constant<bool, __has_virtual_destructor(_Tp)> {};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS has_virtual_destructor\x0a"
"    \x3a public false_type {};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool has_virtual_destructor_v\x0a"
"    = has_virtual_destructor<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// has_unique_object_representations\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 defined(_LIBCPP_HAS_UNIQUE_OBJECT_REPRESENTATIONS)\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS has_unique_object_representations\x0a"
"    \x3a public integral_constant<bool,\x0a"
"       __has_unique_object_representations(remove_cv_t<remove_all_extents_t<_Tp>>)> {};\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool has_unique_object_representations_v\x0a"
"    = has_unique_object_representations<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"// alignment_of\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS alignment_of\x0a"
"    \x3a public integral_constant<size_t, _LIBCPP_ALIGNOF(_Tp)> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR size_t alignment_of_v\x0a"
"    = alignment_of<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// aligned_storage\x0a"
"\x0a"
"template <class _Hp, class _Tp>\x0a"
"struct __type_list\x0a"
"{\x0a"
"    typedef _Hp _Head;\x0a"
"    typedef _Tp _Tail;\x0a"
"};\x0a"
"\x0a"
"struct __nat\x0a"
"{\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    __nat() = delete;\x0a"
"    __nat(const __nat\x26) = delete;\x0a"
"    __nat\x26 operator=(const __nat\x26) = delete;\x0a"
"    \x7e__nat() = delete;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __align_type\x0a"
"{\x0a"
"    static const size_t value = _LIBCPP_PREFERRED_ALIGNOF(_Tp);\x0a"
"    typedef _Tp type;\x0a"
"};\x0a"
"\x0a"
"struct __struct_double {long double __lx;};\x0a"
"struct __struct_double4 {double __lx\x5b""4\x5d;};\x0a"
"\x0a"
"typedef\x0a"
"    __type_list<__align_type<unsigned char>,\x0a"
"    __type_list<__align_type<unsigned short>,\x0a"
"    __type_list<__align_type<unsigned int>,\x0a"
"    __type_list<__align_type<unsigned long>,\x0a"
"    __type_list<__align_type<unsigned long long>,\x0a"
"    __type_list<__align_type<double>,\x0a"
"    __type_list<__align_type<long double>,\x0a"
"    __type_list<__align_type<__struct_double>,\x0a"
"    __type_list<__align_type<__struct_double4>,\x0a"
"    __type_list<__align_type<int*>,\x0a"
"    __nat\x0a"
"    > > > > > > > > > > __all_types;\x0a"
"\x0a"
"template <size_t _Align>\x0a"
"struct _ALIGNAS(_Align) __fallback_overaligned {};\x0a"
"\x0a"
"template <class _TL, size_t _Align> struct __find_pod;\x0a"
"\x0a"
"template <class _Hp, size_t _Align>\x0a"
"struct __find_pod<__type_list<_Hp, __nat>, _Align>\x0a"
"{\x0a"
"    typedef typename conditional<\x0a"
"                             _Align == _Hp\x3a\x3avalue,\x0a"
"                             typename _Hp\x3a\x3atype,\x0a"
"                             __fallback_overaligned<_Align>\x0a"
"                         >\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Hp, class _Tp, size_t _Align>\x0a"
"struct __find_pod<__type_list<_Hp, _Tp>, _Align>\x0a"
"{\x0a"
"    typedef typename conditional<\x0a"
"                             _Align == _Hp\x3a\x3avalue,\x0a"
"                             typename _Hp\x3a\x3atype,\x0a"
"                             typename __find_pod<_Tp, _Align>\x3a\x3atype\x0a"
"                         >\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _TL, size_t _Len> struct __find_max_align;\x0a"
"\x0a"
"template <class _Hp, size_t _Len>\x0a"
"struct __find_max_align<__type_list<_Hp, __nat>, _Len> \x3a public integral_constant<size_t, _Hp\x3a\x3avalue> {};\x0a"
"\x0a"
"template <size_t _Len, size_t _A1, size_t _A2>\x0a"
"struct __select_align\x0a"
"{\x0a"
"private\x3a\x0a"
"    static const size_t __min = _A2 < _A1 \x3f _A2 \x3a _A1;\x0a"
"    static const size_t __max = _A1 < _A2 \x3f _A2 \x3a _A1;\x0a"
"public\x3a\x0a"
"    static const size_t value = _Len < __max \x3f __min \x3a __max;\x0a"
"};\x0a"
"\x0a"
"template <class _Hp, class _Tp, size_t _Len>\x0a"
"struct __find_max_align<__type_list<_Hp, _Tp>, _Len>\x0a"
"    \x3a public integral_constant<size_t, __select_align<_Len, _Hp\x3a\x3avalue, __find_max_align<_Tp, _Len>\x3a\x3avalue>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <size_t _Len, size_t _Align = __find_max_align<__all_types, _Len>\x3a\x3avalue>\x0a"
"struct _LIBCPP_TEMPLATE_VIS aligned_storage\x0a"
"{\x0a"
"    typedef typename __find_pod<__all_types, _Align>\x3a\x3atype _Aligner;\x0a"
"    union type\x0a"
"    {\x0a"
"        _Aligner __align;\x0a"
"        unsigned char __data\x5b(_Len + _Align - 1)/_Align * _Align\x5d;\x0a"
"    };\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <size_t _Len, size_t _Align = __find_max_align<__all_types, _Len>\x3a\x3avalue>\x0a"
"    using aligned_storage_t = typename aligned_storage<_Len, _Align>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"#define _CREATE_ALIGNED_STORAGE_SPECIALIZATION(n) \x5c\x0a"
"template <size_t _Len>\x5c\x0a"
"struct _LIBCPP_TEMPLATE_VIS aligned_storage<_Len, n>\x5c\x0a"
"{\x5c\x0a"
"    struct _ALIGNAS(n) type\x5c\x0a"
"    {\x5c\x0a"
"        unsigned char __lx\x5b(_Len + n - 1)/n * n\x5d;\x5c\x0a"
"    };\x5c\x0a"
"}\x0a"
"\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x1);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x2);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x4);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x8);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x10);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x20);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x40);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x80);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x100);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x200);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x400);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x800);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x1000);\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x2000);\x0a"
"// PE/COFF does not support alignment beyond 8192 (=0x2000)\x0a"
"#if \x21""defined(_LIBCPP_OBJECT_FORMAT_COFF)\x0a"
"_CREATE_ALIGNED_STORAGE_SPECIALIZATION(0x4000);\x0a"
"#endif // \x21""defined(_LIBCPP_OBJECT_FORMAT_COFF)\x0a"
"\x0a"
"#undef _CREATE_ALIGNED_STORAGE_SPECIALIZATION\x0a"
"\x0a"
"\x0a"
"// aligned_union\x0a"
"\x0a"
"template <size_t _I0, size_t ..._In>\x0a"
"struct __static_max;\x0a"
"\x0a"
"template <size_t _I0>\x0a"
"struct __static_max<_I0>\x0a"
"{\x0a"
"    static const size_t value = _I0;\x0a"
"};\x0a"
"\x0a"
"template <size_t _I0, size_t _I1, size_t ..._In>\x0a"
"struct __static_max<_I0, _I1, _In...>\x0a"
"{\x0a"
"    static const size_t value = _I0 >= _I1 \x3f __static_max<_I0, _In...>\x3a\x3avalue \x3a\x0a"
"                                             __static_max<_I1, _In...>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <size_t _Len, class _Type0, class ..._Types>\x0a"
"struct aligned_union\x0a"
"{\x0a"
"    static const size_t alignment_value = __static_max<_LIBCPP_PREFERRED_ALIGNOF(_Type0),\x0a"
"                                                       _LIBCPP_PREFERRED_ALIGNOF(_Types)...>\x3a\x3avalue;\x0a"
"    static const size_t __len = __static_max<_Len, sizeof(_Type0),\x0a"
"                                             sizeof(_Types)...>\x3a\x3avalue;\x0a"
"    typedef typename aligned_storage<__len, alignment_value>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <size_t _Len, class ..._Types> using aligned_union_t = typename aligned_union<_Len, _Types...>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __numeric_type\x0a"
"{\x0a"
"   static void __test(...);\x0a"
"   static float __test(float);\x0a"
"   static double __test(char);\x0a"
"   static double __test(int);\x0a"
"   static double __test(unsigned);\x0a"
"   static double __test(long);\x0a"
"   static double __test(unsigned long);\x0a"
"   static double __test(long long);\x0a"
"   static double __test(unsigned long long);\x0a"
"   static double __test(double);\x0a"
"   static long double __test(long double);\x0a"
"\x0a"
"   typedef decltype(__test(declval<_Tp>())) type;\x0a"
"   static const bool value = _IsNotSame<type, void>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"struct __numeric_type<void>\x0a"
"{\x0a"
"   static const bool value = true;\x0a"
"};\x0a"
"\x0a"
"// __promote\x0a"
"\x0a"
"template <class _A1, class _A2 = void, class _A3 = void,\x0a"
"          bool = __numeric_type<_A1>\x3a\x3avalue \x26\x26\x0a"
"                 __numeric_type<_A2>\x3a\x3avalue \x26\x26\x0a"
"                 __numeric_type<_A3>\x3a\x3avalue>\x0a"
"class __promote_imp\x0a"
"{\x0a"
"public\x3a\x0a"
"    static const bool value = false;\x0a"
"};\x0a"
"\x0a"
"template <class _A1, class _A2, class _A3>\x0a"
"class __promote_imp<_A1, _A2, _A3, true>\x0a"
"{\x0a"
"private\x3a\x0a"
"    typedef typename __promote_imp<_A1>\x3a\x3atype __type1;\x0a"
"    typedef typename __promote_imp<_A2>\x3a\x3atype __type2;\x0a"
"    typedef typename __promote_imp<_A3>\x3a\x3atype __type3;\x0a"
"public\x3a\x0a"
"    typedef decltype(__type1() + __type2() + __type3()) type;\x0a"
"    static const bool value = true;\x0a"
"};\x0a"
"\x0a"
"template <class _A1, class _A2>\x0a"
"class __promote_imp<_A1, _A2, void, true>\x0a"
"{\x0a"
"private\x3a\x0a"
"    typedef typename __promote_imp<_A1>\x3a\x3atype __type1;\x0a"
"    typedef typename __promote_imp<_A2>\x3a\x3atype __type2;\x0a"
"public\x3a\x0a"
"    typedef decltype(__type1() + __type2()) type;\x0a"
"    static const bool value = true;\x0a"
"};\x0a"
"\x0a"
"template <class _A1>\x0a"
"class __promote_imp<_A1, void, void, true>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef typename __numeric_type<_A1>\x3a\x3atype type;\x0a"
"    static const bool value = true;\x0a"
"};\x0a"
"\x0a"
"template <class _A1, class _A2 = void, class _A3 = void>\x0a"
"class __promote \x3a public __promote_imp<_A1, _A2, _A3> {};\x0a"
"\x0a"
"// make_signed / make_unsigned\x0a"
"\x0a"
"typedef\x0a"
"    __type_list<signed char,\x0a"
"    __type_list<signed short,\x0a"
"    __type_list<signed int,\x0a"
"    __type_list<signed long,\x0a"
"    __type_list<signed long long,\x0a"
"#ifndef _LIBCPP_HAS_NO_INT128\x0a"
"    __type_list<__int128_t,\x0a"
"#endif\x0a"
"    __nat\x0a"
"#ifndef _LIBCPP_HAS_NO_INT128\x0a"
"    >\x0a"
"#endif\x0a"
"    > > > > > __signed_types;\x0a"
"\x0a"
"typedef\x0a"
"    __type_list<unsigned char,\x0a"
"    __type_list<unsigned short,\x0a"
"    __type_list<unsigned int,\x0a"
"    __type_list<unsigned long,\x0a"
"    __type_list<unsigned long long,\x0a"
"#ifndef _LIBCPP_HAS_NO_INT128\x0a"
"    __type_list<__uint128_t,\x0a"
"#endif\x0a"
"    __nat\x0a"
"#ifndef _LIBCPP_HAS_NO_INT128\x0a"
"    >\x0a"
"#endif\x0a"
"    > > > > > __unsigned_types;\x0a"
"\x0a"
"template <class _TypeList, size_t _Size, bool = _Size <= sizeof(typename _TypeList\x3a\x3a_Head)> struct __find_first;\x0a"
"\x0a"
"template <class _Hp, class _Tp, size_t _Size>\x0a"
"struct __find_first<__type_list<_Hp, _Tp>, _Size, true>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE _Hp type;\x0a"
"};\x0a"
"\x0a"
"template <class _Hp, class _Tp, size_t _Size>\x0a"
"struct __find_first<__type_list<_Hp, _Tp>, _Size, false>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename __find_first<_Tp, _Size>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up, bool = is_const<typename remove_reference<_Tp>\x3a\x3atype>\x3a\x3avalue,\x0a"
"                             bool = is_volatile<typename remove_reference<_Tp>\x3a\x3atype>\x3a\x3avalue>\x0a"
"struct __apply_cv\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE _Up type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __apply_cv<_Tp, _Up, true, false>\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE const _Up type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __apply_cv<_Tp, _Up, false, true>\x0a"
"{\x0a"
"    typedef volatile _Up type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __apply_cv<_Tp, _Up, true, true>\x0a"
"{\x0a"
"    typedef const volatile _Up type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __apply_cv<_Tp\x26, _Up, false, false>\x0a"
"{\x0a"
"    typedef _Up\x26 type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __apply_cv<_Tp\x26, _Up, true, false>\x0a"
"{\x0a"
"    typedef const _Up\x26 type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __apply_cv<_Tp\x26, _Up, false, true>\x0a"
"{\x0a"
"    typedef volatile _Up\x26 type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __apply_cv<_Tp\x26, _Up, true, true>\x0a"
"{\x0a"
"    typedef const volatile _Up\x26 type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool = is_integral<_Tp>\x3a\x3avalue \x7c\x7c is_enum<_Tp>\x3a\x3avalue>\x0a"
"struct __make_signed {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __make_signed<_Tp, true>\x0a"
"{\x0a"
"    typedef typename __find_first<__signed_types, sizeof(_Tp)>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <> struct __make_signed<bool,               true> {};\x0a"
"template <> struct __make_signed<  signed short,     true> {typedef short     type;};\x0a"
"template <> struct __make_signed<unsigned short,     true> {typedef short     type;};\x0a"
"template <> struct __make_signed<  signed int,       true> {typedef int       type;};\x0a"
"template <> struct __make_signed<unsigned int,       true> {typedef int       type;};\x0a"
"template <> struct __make_signed<  signed long,      true> {typedef long      type;};\x0a"
"template <> struct __make_signed<unsigned long,      true> {typedef long      type;};\x0a"
"template <> struct __make_signed<  signed long long, true> {typedef long long type;};\x0a"
"template <> struct __make_signed<unsigned long long, true> {typedef long long type;};\x0a"
"#ifndef _LIBCPP_HAS_NO_INT128\x0a"
"template <> struct __make_signed<__int128_t,         true> {typedef __int128_t type;};\x0a"
"template <> struct __make_signed<__uint128_t,        true> {typedef __int128_t type;};\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS make_signed\x0a"
"{\x0a"
"    typedef typename __apply_cv<_Tp, typename __make_signed<typename remove_cv<_Tp>\x3a\x3atype>\x3a\x3atype>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using make_signed_t = typename make_signed<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, bool = is_integral<_Tp>\x3a\x3avalue \x7c\x7c is_enum<_Tp>\x3a\x3avalue>\x0a"
"struct __make_unsigned {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __make_unsigned<_Tp, true>\x0a"
"{\x0a"
"    typedef typename __find_first<__unsigned_types, sizeof(_Tp)>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <> struct __make_unsigned<bool,               true> {};\x0a"
"template <> struct __make_unsigned<  signed short,     true> {typedef unsigned short     type;};\x0a"
"template <> struct __make_unsigned<unsigned short,     true> {typedef unsigned short     type;};\x0a"
"template <> struct __make_unsigned<  signed int,       true> {typedef unsigned int       type;};\x0a"
"template <> struct __make_unsigned<unsigned int,       true> {typedef unsigned int       type;};\x0a"
"template <> struct __make_unsigned<  signed long,      true> {typedef unsigned long      type;};\x0a"
"template <> struct __make_unsigned<unsigned long,      true> {typedef unsigned long      type;};\x0a"
"template <> struct __make_unsigned<  signed long long, true> {typedef unsigned long long type;};\x0a"
"template <> struct __make_unsigned<unsigned long long, true> {typedef unsigned long long type;};\x0a"
"#ifndef _LIBCPP_HAS_NO_INT128\x0a"
"template <> struct __make_unsigned<__int128_t,         true> {typedef __uint128_t        type;};\x0a"
"template <> struct __make_unsigned<__uint128_t,        true> {typedef __uint128_t        type;};\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS make_unsigned\x0a"
"{\x0a"
"    typedef typename __apply_cv<_Tp, typename __make_unsigned<typename remove_cv<_Tp>\x3a\x3atype>\x3a\x3atype>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using make_unsigned_t = typename make_unsigned<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Up, class = void>\x0a"
"struct __common_type2_imp {};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __common_type2_imp<_Tp, _Up,\x0a"
"                          typename __void_t<decltype(\x0a"
"                                            true \x3f _VSTD\x3a\x3a""declval<_Tp>() \x3a _VSTD\x3a\x3a""declval<_Up>()\x0a"
"                                            )>\x3a\x3atype>\x0a"
"{\x0a"
"  typedef _LIBCPP_NODEBUG_TYPE typename decay<decltype(\x0a"
"                         true \x3f _VSTD\x3a\x3a""declval<_Tp>() \x3a _VSTD\x3a\x3a""declval<_Up>()\x0a"
"                         )>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class, class = void>\x0a"
"struct __common_type_impl {};\x0a"
"\x0a"
"// Clang provides variadic templates in C++03 as an extension.\x0a"
"#if \x21""defined(_LIBCPP_CXX03_LANG) \x7c\x7c defined(__clang__)\x0a"
"# define _LIBCPP_OPTIONAL_PACK(...) , __VA_ARGS__\x0a"
"template <class... Tp>\x0a"
"struct __common_types;\x0a"
"template <class... _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS common_type;\x0a"
"#else\x0a"
"# define _LIBCPP_OPTIONAL_PACK(...)\x0a"
"struct __no_arg;\x0a"
"template <class _Tp, class _Up, class = __no_arg>\x0a"
"struct __common_types;\x0a"
"template <class _Tp = __no_arg, class _Up = __no_arg, class _Vp = __no_arg,\x0a"
"          class _Unused = __no_arg>\x0a"
"struct common_type {\x0a"
"  static_assert(sizeof(_Unused) == 0,\x0a"
"                \x22""common_type accepts at most 3 arguments in C++03\x22);\x0a"
"};\x0a"
"#endif // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __common_type_impl<\x0a"
"    __common_types<_Tp, _Up>,\x0a"
"    typename __void_t<typename common_type<_Tp, _Up>\x3a\x3atype>\x3a\x3atype>\x0a"
"{\x0a"
"  typedef typename common_type<_Tp, _Up>\x3a\x3atype type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up, class _Vp _LIBCPP_OPTIONAL_PACK(class... _Rest)>\x0a"
"struct __common_type_impl<\x0a"
"    __common_types<_Tp, _Up, _Vp _LIBCPP_OPTIONAL_PACK(_Rest...)>,\x0a"
"    typename __void_t<typename common_type<_Tp, _Up>\x3a\x3atype>\x3a\x3atype>\x0a"
"    \x3a __common_type_impl<__common_types<typename common_type<_Tp, _Up>\x3a\x3atype,\x0a"
"                                        _Vp _LIBCPP_OPTIONAL_PACK(_Rest...)> > {\x0a"
"};\x0a"
"\x0a"
"// bullet 1 - sizeof...(Tp) == 0\x0a"
"\x0a"
"template <>\x0a"
"struct _LIBCPP_TEMPLATE_VIS common_type<> {};\x0a"
"\x0a"
"// bullet 2 - sizeof...(Tp) == 1\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS common_type<_Tp>\x0a"
"    \x3a public common_type<_Tp, _Tp> {};\x0a"
"\x0a"
"// bullet 3 - sizeof...(Tp) == 2\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct _LIBCPP_TEMPLATE_VIS common_type<_Tp, _Up>\x0a"
"    \x3a conditional<\x0a"
"        _IsSame<_Tp, typename decay<_Tp>\x3a\x3atype>\x3a\x3avalue \x26\x26 _IsSame<_Up, typename decay<_Up>\x3a\x3atype>\x3a\x3avalue,\x0a"
"        __common_type2_imp<_Tp, _Up>,\x0a"
"        common_type<typename decay<_Tp>\x3a\x3atype, typename decay<_Up>\x3a\x3atype>\x0a"
"    >\x3a\x3atype\x0a"
"{};\x0a"
"\x0a"
"// bullet 4 - sizeof...(Tp) > 2\x0a"
"\x0a"
"template <class _Tp, class _Up, class _Vp _LIBCPP_OPTIONAL_PACK(class... _Rest)>\x0a"
"struct _LIBCPP_TEMPLATE_VIS\x0a"
"    common_type<_Tp, _Up, _Vp _LIBCPP_OPTIONAL_PACK(_Rest...)>\x0a"
"    \x3a __common_type_impl<\x0a"
"          __common_types<_Tp, _Up, _Vp _LIBCPP_OPTIONAL_PACK(_Rest...)> > {};\x0a"
"\x0a"
"#undef _LIBCPP_OPTIONAL_PACK\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class ..._Tp> using common_type_t = typename common_type<_Tp...>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"// is_assignable\x0a"
"\x0a"
"template<typename, typename _Tp> struct __select_2nd { typedef _LIBCPP_NODEBUG_TYPE _Tp type; };\x0a"
"\x0a"
"template <class _Tp, class _Arg>\x0a"
"typename __select_2nd<decltype((_VSTD\x3a\x3a""declval<_Tp>() = _VSTD\x3a\x3a""declval<_Arg>())), true_type>\x3a\x3atype\x0a"
"__is_assignable_test(int);\x0a"
"\x0a"
"template <class, class>\x0a"
"false_type __is_assignable_test(...);\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Arg, bool = is_void<_Tp>\x3a\x3avalue \x7c\x7c is_void<_Arg>\x3a\x3avalue>\x0a"
"struct __is_assignable_imp\x0a"
"    \x3a public decltype((_VSTD\x3a\x3a__is_assignable_test<_Tp, _Arg>(0))) {};\x0a"
"\x0a"
"template <class _Tp, class _Arg>\x0a"
"struct __is_assignable_imp<_Tp, _Arg, true>\x0a"
"    \x3a public false_type\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Arg>\x0a"
"struct is_assignable\x0a"
"    \x3a public __is_assignable_imp<_Tp, _Arg> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp, class _Arg>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_assignable_v\x0a"
"    = is_assignable<_Tp, _Arg>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_copy_assignable\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_copy_assignable\x0a"
"    \x3a public is_assignable<typename add_lvalue_reference<_Tp>\x3a\x3atype,\x0a"
"                  typename add_lvalue_reference<typename add_const<_Tp>\x3a\x3atype>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_copy_assignable_v\x0a"
"    = is_copy_assignable<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_move_assignable\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_move_assignable\x0a"
"    \x3a public is_assignable<typename add_lvalue_reference<_Tp>\x3a\x3atype,\x0a"
"                           typename add_rvalue_reference<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_move_assignable_v\x0a"
"    = is_move_assignable<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_destructible\x0a"
"\x0a"
"//  if it's a reference, return true\x0a"
"//  if it's a function, return false\x0a"
"//  if it's   void,     return false\x0a"
"//  if it's an array of unknown bound, return false\x0a"
"//  Otherwise, return \x22std\x3a\x3a""declval<_Up\x26>().\x7e_Up()\x22 is well-formed\x0a"
"//    where _Up is remove_all_extents<_Tp>\x3a\x3atype\x0a"
"\x0a"
"template <class>\x0a"
"struct __is_destructible_apply { typedef int type; };\x0a"
"\x0a"
"template <typename _Tp>\x0a"
"struct __is_destructor_wellformed {\x0a"
"    template <typename _Tp1>\x0a"
"    static char  __test (\x0a"
"        typename __is_destructible_apply<decltype(_VSTD\x3a\x3a""declval<_Tp1\x26>().\x7e_Tp1())>\x3a\x3atype\x0a"
"    );\x0a"
"\x0a"
"    template <typename _Tp1>\x0a"
"    static __two __test (...);\x0a"
"\x0a"
"    static const bool value = sizeof(__test<_Tp>(12)) == sizeof(char);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool>\x0a"
"struct __destructible_imp;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __destructible_imp<_Tp, false>\x0a"
"   \x3a public _VSTD\x3a\x3aintegral_constant<bool,\x0a"
"        __is_destructor_wellformed<typename _VSTD\x3a\x3aremove_all_extents<_Tp>\x3a\x3atype>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __destructible_imp<_Tp, true>\x0a"
"    \x3a public _VSTD\x3a\x3atrue_type {};\x0a"
"\x0a"
"template <class _Tp, bool>\x0a"
"struct __destructible_false;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __destructible_false<_Tp, false> \x3a public __destructible_imp<_Tp, _VSTD\x3a\x3ais_reference<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __destructible_false<_Tp, true> \x3a public _VSTD\x3a\x3a""false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct is_destructible\x0a"
"    \x3a public __destructible_false<_Tp, _VSTD\x3a\x3ais_function<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct is_destructible<_Tp\x5b\x5d>\x0a"
"    \x3a public _VSTD\x3a\x3a""false_type {};\x0a"
"\x0a"
"template <>\x0a"
"struct is_destructible<void>\x0a"
"    \x3a public _VSTD\x3a\x3a""false_type {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_destructible_v\x0a"
"    = is_destructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// move\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename remove_reference<_Tp>\x3a\x3atype\x26\x26\x0a"
"move(_Tp\x26\x26 __t) _NOEXCEPT\x0a"
"{\x0a"
"    typedef _LIBCPP_NODEBUG_TYPE typename remove_reference<_Tp>\x3a\x3atype _Up;\x0a"
"    return static_cast<_Up\x26\x26>(__t);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"_Tp\x26\x26\x0a"
"forward(typename remove_reference<_Tp>\x3a\x3atype\x26 __t) _NOEXCEPT\x0a"
"{\x0a"
"    return static_cast<_Tp\x26\x26>(__t);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"_Tp\x26\x26\x0a"
"forward(typename remove_reference<_Tp>\x3a\x3atype\x26\x26 __t) _NOEXCEPT\x0a"
"{\x0a"
"    static_assert(\x21is_lvalue_reference<_Tp>\x3a\x3avalue,\x0a"
"                  \x22""can not forward an rvalue as an lvalue\x22);\x0a"
"    return static_cast<_Tp\x26\x26>(__t);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename decay<_Tp>\x3a\x3atype\x0a"
"__decay_copy(_Tp\x26\x26 __t)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3a""forward<_Tp>(__t);\x0a"
"}\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...), true, false>\x0a"
"{\x0a"
"    typedef _Class _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...), true, false>\x0a"
"{\x0a"
"    typedef _Class _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) const, true, false>\x0a"
"{\x0a"
"    typedef _Class const _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) const, true, false>\x0a"
"{\x0a"
"    typedef _Class const _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) volatile, true, false>\x0a"
"{\x0a"
"    typedef _Class volatile _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) volatile, true, false>\x0a"
"{\x0a"
"    typedef _Class volatile _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) const volatile, true, false>\x0a"
"{\x0a"
"    typedef _Class const volatile _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) const volatile, true, false>\x0a"
"{\x0a"
"    typedef _Class const volatile _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"#if __has_feature(cxx_reference_qualified_functions) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) \x26, true, false>\x0a"
"{\x0a"
"    typedef _Class\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) \x26, true, false>\x0a"
"{\x0a"
"    typedef _Class\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) const\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class const\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) const\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class const\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) volatile\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class volatile\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) volatile\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class volatile\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) const volatile\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class const volatile\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) const volatile\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class const volatile\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) \x26\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class\x26\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) \x26\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class\x26\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) const\x26\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class const\x26\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) const\x26\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class const\x26\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) volatile\x26\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class volatile\x26\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) volatile\x26\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class volatile\x26\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param...) const volatile\x26\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class const volatile\x26\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param...);\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class ..._Param>\x0a"
"struct __member_pointer_traits_imp<_Rp (_Class\x3a\x3a*)(_Param..., ...) const volatile\x26\x26, true, false>\x0a"
"{\x0a"
"    typedef _Class const volatile\x26\x26 _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"    typedef _Rp (_FnType) (_Param..., ...);\x0a"
"};\x0a"
"\x0a"
"#endif  // __has_feature(cxx_reference_qualified_functions) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"\x0a"
"\x0a"
"template <class _Rp, class _Class>\x0a"
"struct __member_pointer_traits_imp<_Rp _Class\x3a\x3a*, false, true>\x0a"
"{\x0a"
"    typedef _Class _ClassType;\x0a"
"    typedef _Rp _ReturnType;\x0a"
"};\x0a"
"\x0a"
"template <class _MP>\x0a"
"struct __member_pointer_traits\x0a"
"    \x3a public __member_pointer_traits_imp<typename remove_cv<_MP>\x3a\x3atype,\x0a"
"                    is_member_function_pointer<_MP>\x3a\x3avalue,\x0a"
"                    is_member_object_pointer<_MP>\x3a\x3avalue>\x0a"
"{\x0a"
"//     typedef ... _ClassType;\x0a"
"//     typedef ... _ReturnType;\x0a"
"//     typedef ... _FnType;\x0a"
"};\x0a"
"\x0a"
"\x0a"
"template <class _DecayedFp>\x0a"
"struct __member_pointer_class_type {};\x0a"
"\x0a"
"template <class _Ret, class _ClassType>\x0a"
"struct __member_pointer_class_type<_Ret _ClassType\x3a\x3a*> {\x0a"
"  typedef _ClassType type;\x0a"
"};\x0a"
"\x0a"
"// result_of\x0a"
"\x0a"
"template <class _Callable> class result_of;\x0a"
"\x0a"
"#ifdef _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"template <class _Fn, bool, bool>\x0a"
"class __result_of\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Fn>\x0a"
"class __result_of<_Fn(), true, false>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef decltype(declval<_Fn>()()) type;\x0a"
"};\x0a"
"\x0a"
"template <class _Fn, class _A0>\x0a"
"class __result_of<_Fn(_A0), true, false>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef decltype(declval<_Fn>()(declval<_A0>())) type;\x0a"
"};\x0a"
"\x0a"
"template <class _Fn, class _A0, class _A1>\x0a"
"class __result_of<_Fn(_A0, _A1), true, false>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef decltype(declval<_Fn>()(declval<_A0>(), declval<_A1>())) type;\x0a"
"};\x0a"
"\x0a"
"template <class _Fn, class _A0, class _A1, class _A2>\x0a"
"class __result_of<_Fn(_A0, _A1, _A2), true, false>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef decltype(declval<_Fn>()(declval<_A0>(), declval<_A1>(), declval<_A2>())) type;\x0a"
"};\x0a"
"\x0a"
"template <class _MP, class _Tp, bool _IsMemberFunctionPtr>\x0a"
"struct __result_of_mp;\x0a"
"\x0a"
"// member function pointer\x0a"
"\x0a"
"template <class _MP, class _Tp>\x0a"
"struct __result_of_mp<_MP, _Tp, true>\x0a"
"    \x3a public __identity<typename __member_pointer_traits<_MP>\x3a\x3a_ReturnType>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"// member data pointer\x0a"
"\x0a"
"template <class _MP, class _Tp, bool>\x0a"
"struct __result_of_mdp;\x0a"
"\x0a"
"template <class _Rp, class _Class, class _Tp>\x0a"
"struct __result_of_mdp<_Rp _Class\x3a\x3a*, _Tp, false>\x0a"
"{\x0a"
"    typedef typename __apply_cv<decltype(*_VSTD\x3a\x3a""declval<_Tp>()), _Rp>\x3a\x3atype\x26 type;\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class _Tp>\x0a"
"struct __result_of_mdp<_Rp _Class\x3a\x3a*, _Tp, true>\x0a"
"{\x0a"
"    typedef typename __apply_cv<_Tp, _Rp>\x3a\x3atype\x26 type;\x0a"
"};\x0a"
"\x0a"
"template <class _Rp, class _Class, class _Tp>\x0a"
"struct __result_of_mp<_Rp _Class\x3a\x3a*, _Tp, false>\x0a"
"    \x3a public __result_of_mdp<_Rp _Class\x3a\x3a*, _Tp,\x0a"
"            is_base_of<_Class, typename remove_reference<_Tp>\x3a\x3atype>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"\x0a"
"\x0a"
"template <class _Fn, class _Tp>\x0a"
"class __result_of<_Fn(_Tp), false, true>  // _Fn must be member pointer\x0a"
"    \x3a public __result_of_mp<typename remove_reference<_Fn>\x3a\x3atype,\x0a"
"                            _Tp,\x0a"
"                            is_member_function_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Fn, class _Tp, class _A0>\x0a"
"class __result_of<_Fn(_Tp, _A0), false, true>  // _Fn must be member pointer\x0a"
"    \x3a public __result_of_mp<typename remove_reference<_Fn>\x3a\x3atype,\x0a"
"                            _Tp,\x0a"
"                            is_member_function_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Fn, class _Tp, class _A0, class _A1>\x0a"
"class __result_of<_Fn(_Tp, _A0, _A1), false, true>  // _Fn must be member pointer\x0a"
"    \x3a public __result_of_mp<typename remove_reference<_Fn>\x3a\x3atype,\x0a"
"                            _Tp,\x0a"
"                            is_member_function_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Fn, class _Tp, class _A0, class _A1, class _A2>\x0a"
"class __result_of<_Fn(_Tp, _A0, _A1, _A2), false, true>  // _Fn must be member pointer\x0a"
"    \x3a public __result_of_mp<typename remove_reference<_Fn>\x3a\x3atype,\x0a"
"                            _Tp,\x0a"
"                            is_member_function_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"// result_of\x0a"
"\x0a"
"template <class _Fn>\x0a"
"class _LIBCPP_TEMPLATE_VIS result_of<_Fn()>\x0a"
"    \x3a public __result_of<_Fn(),\x0a"
"                         is_class<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue \x7c\x7c\x0a"
"                         is_function<typename remove_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3atype>\x3a\x3avalue,\x0a"
"                         is_member_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue\x0a"
"                        >\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Fn, class _A0>\x0a"
"class _LIBCPP_TEMPLATE_VIS result_of<_Fn(_A0)>\x0a"
"    \x3a public __result_of<_Fn(_A0),\x0a"
"                         is_class<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue \x7c\x7c\x0a"
"                         is_function<typename remove_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3atype>\x3a\x3avalue,\x0a"
"                         is_member_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue\x0a"
"                        >\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Fn, class _A0, class _A1>\x0a"
"class _LIBCPP_TEMPLATE_VIS result_of<_Fn(_A0, _A1)>\x0a"
"    \x3a public __result_of<_Fn(_A0, _A1),\x0a"
"                         is_class<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue \x7c\x7c\x0a"
"                         is_function<typename remove_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3atype>\x3a\x3avalue,\x0a"
"                         is_member_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue\x0a"
"                        >\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Fn, class _A0, class _A1, class _A2>\x0a"
"class _LIBCPP_TEMPLATE_VIS result_of<_Fn(_A0, _A1, _A2)>\x0a"
"    \x3a public __result_of<_Fn(_A0, _A1, _A2),\x0a"
"                         is_class<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue \x7c\x7c\x0a"
"                         is_function<typename remove_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3atype>\x3a\x3avalue,\x0a"
"                         is_member_pointer<typename remove_reference<_Fn>\x3a\x3atype>\x3a\x3avalue\x0a"
"                        >\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_VARIADICS\x0a"
"\x0a"
"// template <class T, class... Args> struct is_constructible;\x0a"
"\x0a"
"namespace __is_construct\x0a"
"{\x0a"
"struct __nat {};\x0a"
"}\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_CXX03_LANG) \x26\x26 (\x21__has_feature(is_constructible) \x7c\x7c \x5c\x0a"
"    defined(_LIBCPP_TESTING_FALLBACK_IS_CONSTRUCTIBLE))\x0a"
"\x0a"
"template <class _Tp, class... _Args>\x0a"
"struct __libcpp_is_constructible;\x0a"
"\x0a"
"template <class _To, class _From>\x0a"
"struct __is_invalid_base_to_derived_cast {\x0a"
"  static_assert(is_reference<_To>\x3a\x3avalue, \x22Wrong specialization\x22);\x0a"
"  using _RawFrom = __uncvref_t<_From>;\x0a"
"  using _RawTo = __uncvref_t<_To>;\x0a"
"  static const bool value = _And<\x0a"
"        _IsNotSame<_RawFrom, _RawTo>,\x0a"
"        is_base_of<_RawFrom, _RawTo>,\x0a"
"        _Not<__libcpp_is_constructible<_RawTo, _From>>\x0a"
"  >\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _To, class _From>\x0a"
"struct __is_invalid_lvalue_to_rvalue_cast \x3a false_type {\x0a"
"  static_assert(is_reference<_To>\x3a\x3avalue, \x22Wrong specialization\x22);\x0a"
"};\x0a"
"\x0a"
"template <class _ToRef, class _FromRef>\x0a"
"struct __is_invalid_lvalue_to_rvalue_cast<_ToRef\x26\x26, _FromRef\x26> {\x0a"
"  using _RawFrom = __uncvref_t<_FromRef>;\x0a"
"  using _RawTo = __uncvref_t<_ToRef>;\x0a"
"  static const bool value = _And<\x0a"
"      _Not<is_function<_RawTo>>,\x0a"
"      _Or<\x0a"
"        _IsSame<_RawFrom, _RawTo>,\x0a"
"        is_base_of<_RawTo, _RawFrom>>\x0a"
"    >\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"struct __is_constructible_helper\x0a"
"{\x0a"
"    template <class _To>\x0a"
"    static void __eat(_To);\x0a"
"\x0a"
"    // This overload is needed to work around a Clang bug that disallows\x0a"
"    // static_cast<T\x26\x26>(e) for non-reference-compatible types.\x0a"
"    // Example\x3a static_cast<int\x26\x26>(declval<double>());\x0a"
"    // NOTE\x3a The static_cast implementation below is required to support\x0a"
"    //  classes with explicit conversion operators.\x0a"
"    template <class _To, class _From,\x0a"
"              class = decltype(__eat<_To>(_VSTD\x3a\x3a""declval<_From>()))>\x0a"
"    static true_type __test_cast(int);\x0a"
"\x0a"
"    template <class _To, class _From,\x0a"
"              class = decltype(static_cast<_To>(_VSTD\x3a\x3a""declval<_From>()))>\x0a"
"    static integral_constant<bool,\x0a"
"        \x21__is_invalid_base_to_derived_cast<_To, _From>\x3a\x3avalue \x26\x26\x0a"
"        \x21__is_invalid_lvalue_to_rvalue_cast<_To, _From>\x3a\x3avalue\x0a"
"    > __test_cast(long);\x0a"
"\x0a"
"    template <class, class>\x0a"
"    static false_type __test_cast(...);\x0a"
"\x0a"
"    template <class _Tp, class ..._Args,\x0a"
"        class = decltype(_Tp(_VSTD\x3a\x3a""declval<_Args>()...))>\x0a"
"    static true_type __test_nary(int);\x0a"
"    template <class _Tp, class...>\x0a"
"    static false_type __test_nary(...);\x0a"
"\x0a"
"    template <class _Tp, class _A0, class = decltype(\x3a\x3anew _Tp(_VSTD\x3a\x3a""declval<_A0>()))>\x0a"
"    static is_destructible<_Tp> __test_unary(int);\x0a"
"    template <class, class>\x0a"
"    static false_type __test_unary(...);\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool = is_void<_Tp>\x3a\x3avalue>\x0a"
"struct __is_default_constructible\x0a"
"    \x3a decltype(__is_constructible_helper\x3a\x3a__test_nary<_Tp>(0))\x0a"
"{};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_default_constructible<_Tp, true> \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_default_constructible<_Tp\x5b\x5d, false> \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp, size_t _Nx>\x0a"
"struct __is_default_constructible<_Tp\x5b_Nx\x5d, false>\x0a"
"    \x3a __is_default_constructible<typename remove_all_extents<_Tp>\x3a\x3atype>  {};\x0a"
"\x0a"
"template <class _Tp, class... _Args>\x0a"
"struct __libcpp_is_constructible\x0a"
"{\x0a"
"  static_assert(sizeof...(_Args) > 1, \x22Wrong specialization\x22);\x0a"
"  typedef decltype(__is_constructible_helper\x3a\x3a__test_nary<_Tp, _Args...>(0))\x0a"
"      type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __libcpp_is_constructible<_Tp> \x3a __is_default_constructible<_Tp> {};\x0a"
"\x0a"
"template <class _Tp, class _A0>\x0a"
"struct __libcpp_is_constructible<_Tp, _A0>\x0a"
"    \x3a public decltype(__is_constructible_helper\x3a\x3a__test_unary<_Tp, _A0>(0))\x0a"
"{};\x0a"
"\x0a"
"template <class _Tp, class _A0>\x0a"
"struct __libcpp_is_constructible<_Tp\x26, _A0>\x0a"
"    \x3a public decltype(__is_constructible_helper\x3a\x3a\x0a"
"    __test_cast<_Tp\x26, _A0>(0))\x0a"
"{};\x0a"
"\x0a"
"template <class _Tp, class _A0>\x0a"
"struct __libcpp_is_constructible<_Tp\x26\x26, _A0>\x0a"
"    \x3a public decltype(__is_constructible_helper\x3a\x3a\x0a"
"    __test_cast<_Tp\x26\x26, _A0>(0))\x0a"
"{};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if __has_feature(is_constructible)\x0a"
"template <class _Tp, class ..._Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_constructible\x0a"
"    \x3a public integral_constant<bool, __is_constructible(_Tp, _Args...)>\x0a"
"    {};\x0a"
"#else\x0a"
"template <class _Tp, class... _Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_constructible\x0a"
"    \x3a public __libcpp_is_constructible<_Tp, _Args...>\x3a\x3atype {};\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp, class ..._Args>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_constructible_v\x0a"
"    = is_constructible<_Tp, _Args...>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_default_constructible\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_default_constructible\x0a"
"    \x3a public is_constructible<_Tp>\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_default_constructible_v\x0a"
"    = is_default_constructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_copy_constructible\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_copy_constructible\x0a"
"    \x3a public is_constructible<_Tp,\x0a"
"                  typename add_lvalue_reference<typename add_const<_Tp>\x3a\x3atype>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_copy_constructible_v\x0a"
"    = is_copy_constructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_move_constructible\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_move_constructible\x0a"
"    \x3a public is_constructible<_Tp, typename add_rvalue_reference<_Tp>\x3a\x3atype>\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_move_constructible_v\x0a"
"    = is_move_constructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_trivially_constructible\x0a"
"\x0a"
"#if __has_feature(is_trivially_constructible) \x7c\x7c _GNUC_VER >= 501\x0a"
"\x0a"
"template <class _Tp, class... _Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_trivially_constructible\x0a"
"    \x3a integral_constant<bool, __is_trivially_constructible(_Tp, _Args...)>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#else  // \x21__has_feature(is_trivially_constructible)\x0a"
"\x0a"
"template <class _Tp, class... _Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_trivially_constructible\x0a"
"    \x3a false_type\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_trivially_constructible<_Tp>\x0a"
"#if __has_feature(has_trivial_constructor) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"    \x3a integral_constant<bool, __has_trivial_constructor(_Tp)>\x0a"
"#else\x0a"
"    \x3a integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue>\x0a"
"#endif\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_trivially_constructible<_Tp, _Tp\x26\x26>\x0a"
"    \x3a integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_trivially_constructible<_Tp, const _Tp\x26>\x0a"
"    \x3a integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_trivially_constructible<_Tp, _Tp\x26>\x0a"
"    \x3a integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#endif  // \x21__has_feature(is_trivially_constructible)\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp, class... _Args>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_trivially_constructible_v\x0a"
"    = is_trivially_constructible<_Tp, _Args...>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_trivially_default_constructible\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivially_default_constructible\x0a"
"    \x3a public is_trivially_constructible<_Tp>\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_trivially_default_constructible_v\x0a"
"    = is_trivially_default_constructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_trivially_copy_constructible\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivially_copy_constructible\x0a"
"    \x3a public is_trivially_constructible<_Tp, typename add_lvalue_reference<const _Tp>\x3a\x3atype>\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_trivially_copy_constructible_v\x0a"
"    = is_trivially_copy_constructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_trivially_move_constructible\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivially_move_constructible\x0a"
"    \x3a public is_trivially_constructible<_Tp, typename add_rvalue_reference<_Tp>\x3a\x3atype>\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_trivially_move_constructible_v\x0a"
"    = is_trivially_move_constructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_trivially_assignable\x0a"
"\x0a"
"#if __has_feature(is_trivially_assignable) \x7c\x7c _GNUC_VER >= 501\x0a"
"\x0a"
"template <class _Tp, class _Arg>\x0a"
"struct is_trivially_assignable\x0a"
"    \x3a integral_constant<bool, __is_trivially_assignable(_Tp, _Arg)>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#else  // \x21__has_feature(is_trivially_assignable)\x0a"
"\x0a"
"template <class _Tp, class _Arg>\x0a"
"struct is_trivially_assignable\x0a"
"    \x3a public false_type {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct is_trivially_assignable<_Tp\x26, _Tp>\x0a"
"    \x3a integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct is_trivially_assignable<_Tp\x26, _Tp\x26>\x0a"
"    \x3a integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct is_trivially_assignable<_Tp\x26, const _Tp\x26>\x0a"
"    \x3a integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct is_trivially_assignable<_Tp\x26, _Tp\x26\x26>\x0a"
"    \x3a integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"#endif  // \x21__has_feature(is_trivially_assignable)\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp, class _Arg>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_trivially_assignable_v\x0a"
"    = is_trivially_assignable<_Tp, _Arg>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_trivially_copy_assignable\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivially_copy_assignable\x0a"
"    \x3a public is_trivially_assignable<typename add_lvalue_reference<_Tp>\x3a\x3atype,\x0a"
"                  typename add_lvalue_reference<typename add_const<_Tp>\x3a\x3atype>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_trivially_copy_assignable_v\x0a"
"    = is_trivially_copy_assignable<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_trivially_move_assignable\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivially_move_assignable\x0a"
"    \x3a public is_trivially_assignable<typename add_lvalue_reference<_Tp>\x3a\x3atype,\x0a"
"                                     typename add_rvalue_reference<_Tp>\x3a\x3atype>\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_trivially_move_assignable_v\x0a"
"    = is_trivially_move_assignable<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_trivially_destructible\x0a"
"\x0a"
"#if __has_keyword(__is_trivially_destructible)\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivially_destructible\x0a"
"    \x3a public integral_constant<bool, __is_trivially_destructible(_Tp)> {};\x0a"
"\x0a"
"#elif __has_feature(has_trivial_destructor) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivially_destructible\x0a"
"    \x3a public integral_constant<bool, is_destructible<_Tp>\x3a\x3avalue \x26\x26 __has_trivial_destructor(_Tp)> {};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_trivial_destructor\x0a"
"    \x3a public integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                                     is_reference<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivially_destructible\x0a"
"    \x3a public __libcpp_trivial_destructor<typename remove_all_extents<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivially_destructible<_Tp\x5b\x5d>\x0a"
"    \x3a public false_type {};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_trivially_destructible_v\x0a"
"    = is_trivially_destructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_nothrow_constructible\x0a"
"\x0a"
"#if __has_keyword(__is_nothrow_constructible)\x0a"
"\x0a"
"template <class _Tp, class... _Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_constructible\x0a"
"    \x3a public integral_constant<bool, __is_nothrow_constructible(_Tp, _Args...)> {};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <bool, bool, class _Tp, class... _Args> struct __libcpp_is_nothrow_constructible;\x0a"
"\x0a"
"template <class _Tp, class... _Args>\x0a"
"struct __libcpp_is_nothrow_constructible</*is constructible*/true, /*is reference*/false, _Tp, _Args...>\x0a"
"    \x3a public integral_constant<bool, noexcept(_Tp(declval<_Args>()...))>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"void __implicit_conversion_to(_Tp) noexcept { }\x0a"
"\x0a"
"template <class _Tp, class _Arg>\x0a"
"struct __libcpp_is_nothrow_constructible</*is constructible*/true, /*is reference*/true, _Tp, _Arg>\x0a"
"    \x3a public integral_constant<bool, noexcept(__implicit_conversion_to<_Tp>(declval<_Arg>()))>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, bool _IsReference, class... _Args>\x0a"
"struct __libcpp_is_nothrow_constructible</*is constructible*/false, _IsReference, _Tp, _Args...>\x0a"
"    \x3a public false_type\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class... _Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_constructible\x0a"
"    \x3a __libcpp_is_nothrow_constructible<is_constructible<_Tp, _Args...>\x3a\x3avalue, is_reference<_Tp>\x3a\x3avalue, _Tp, _Args...>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, size_t _Ns>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_constructible<_Tp\x5b_Ns\x5d>\x0a"
"    \x3a __libcpp_is_nothrow_constructible<is_constructible<_Tp>\x3a\x3avalue, is_reference<_Tp>\x3a\x3avalue, _Tp>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_NOEXCEPT\x0a"
"\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp, class ..._Args>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_nothrow_constructible_v\x0a"
"    = is_nothrow_constructible<_Tp, _Args...>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_nothrow_default_constructible\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_nothrow_default_constructible\x0a"
"    \x3a public is_nothrow_constructible<_Tp>\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_nothrow_default_constructible_v\x0a"
"    = is_nothrow_default_constructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_nothrow_copy_constructible\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_nothrow_copy_constructible\x0a"
"    \x3a public is_nothrow_constructible<_Tp,\x0a"
"                  typename add_lvalue_reference<typename add_const<_Tp>\x3a\x3atype>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_nothrow_copy_constructible_v\x0a"
"    = is_nothrow_copy_constructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_nothrow_move_constructible\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_nothrow_move_constructible\x0a"
"    \x3a public is_nothrow_constructible<_Tp, typename add_rvalue_reference<_Tp>\x3a\x3atype>\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_nothrow_move_constructible_v\x0a"
"    = is_nothrow_move_constructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_nothrow_assignable\x0a"
"\x0a"
"#if __has_keyword(__is_nothrow_assignable)\x0a"
"\x0a"
"template <class _Tp, class _Arg>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_assignable\x0a"
"    \x3a public integral_constant<bool, __is_nothrow_assignable(_Tp, _Arg)> {};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <bool, class _Tp, class _Arg> struct __libcpp_is_nothrow_assignable;\x0a"
"\x0a"
"template <class _Tp, class _Arg>\x0a"
"struct __libcpp_is_nothrow_assignable<false, _Tp, _Arg>\x0a"
"    \x3a public false_type\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Arg>\x0a"
"struct __libcpp_is_nothrow_assignable<true, _Tp, _Arg>\x0a"
"    \x3a public integral_constant<bool, noexcept(_VSTD\x3a\x3a""declval<_Tp>() = _VSTD\x3a\x3a""declval<_Arg>()) >\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Arg>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_assignable\x0a"
"    \x3a public __libcpp_is_nothrow_assignable<is_assignable<_Tp, _Arg>\x3a\x3avalue, _Tp, _Arg>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#endif  // _LIBCPP_HAS_NO_NOEXCEPT\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp, class _Arg>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_nothrow_assignable_v\x0a"
"    = is_nothrow_assignable<_Tp, _Arg>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_nothrow_copy_assignable\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_nothrow_copy_assignable\x0a"
"    \x3a public is_nothrow_assignable<typename add_lvalue_reference<_Tp>\x3a\x3atype,\x0a"
"                  typename add_lvalue_reference<typename add_const<_Tp>\x3a\x3atype>\x3a\x3atype> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_nothrow_copy_assignable_v\x0a"
"    = is_nothrow_copy_assignable<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_nothrow_move_assignable\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_nothrow_move_assignable\x0a"
"    \x3a public is_nothrow_assignable<typename add_lvalue_reference<_Tp>\x3a\x3atype,\x0a"
"                                     typename add_rvalue_reference<_Tp>\x3a\x3atype>\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_nothrow_move_assignable_v\x0a"
"    = is_nothrow_move_assignable<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_nothrow_destructible\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"\x0a"
"template <bool, class _Tp> struct __libcpp_is_nothrow_destructible;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __libcpp_is_nothrow_destructible<false, _Tp>\x0a"
"    \x3a public false_type\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __libcpp_is_nothrow_destructible<true, _Tp>\x0a"
"    \x3a public integral_constant<bool, noexcept(_VSTD\x3a\x3a""declval<_Tp>().\x7e_Tp()) >\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_destructible\x0a"
"    \x3a public __libcpp_is_nothrow_destructible<is_destructible<_Tp>\x3a\x3avalue, _Tp>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, size_t _Ns>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_destructible<_Tp\x5b_Ns\x5d>\x0a"
"    \x3a public is_nothrow_destructible<_Tp>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_destructible<_Tp\x26>\x0a"
"    \x3a public true_type\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_destructible<_Tp\x26\x26>\x0a"
"    \x3a public true_type\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Tp> struct __libcpp_nothrow_destructor\x0a"
"    \x3a public integral_constant<bool, is_scalar<_Tp>\x3a\x3avalue \x7c\x7c\x0a"
"                                     is_reference<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_nothrow_destructible\x0a"
"    \x3a public __libcpp_nothrow_destructor<typename remove_all_extents<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_destructible<_Tp\x5b\x5d>\x0a"
"    \x3a public false_type {};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_nothrow_destructible_v\x0a"
"    = is_nothrow_destructible<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_pod\x0a"
"\x0a"
"#if __has_feature(is_pod) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_pod\x0a"
"    \x3a public integral_constant<bool, __is_pod(_Tp)> {};\x0a"
"\x0a"
"#else\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_pod\x0a"
"    \x3a public integral_constant<bool, is_trivially_default_constructible<_Tp>\x3a\x3avalue   \x26\x26\x0a"
"                                     is_trivially_copy_constructible<_Tp>\x3a\x3avalue      \x26\x26\x0a"
"                                     is_trivially_copy_assignable<_Tp>\x3a\x3avalue    \x26\x26\x0a"
"                                     is_trivially_destructible<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_pod_v\x0a"
"    = is_pod<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_literal_type;\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_literal_type\x0a"
"    \x3a public integral_constant<bool, __is_literal_type(_Tp)>\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_literal_type_v\x0a"
"    = is_literal_type<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_standard_layout;\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_standard_layout\x0a"
"#if __has_feature(is_standard_layout) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"    \x3a public integral_constant<bool, __is_standard_layout(_Tp)>\x0a"
"#else\x0a"
"    \x3a integral_constant<bool, is_scalar<typename remove_all_extents<_Tp>\x3a\x3atype>\x3a\x3avalue>\x0a"
"#endif\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_standard_layout_v\x0a"
"    = is_standard_layout<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_trivially_copyable;\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivially_copyable\x0a"
"#if __has_feature(is_trivially_copyable)\x0a"
"    \x3a public integral_constant<bool, __is_trivially_copyable(_Tp)>\x0a"
"#elif _GNUC_VER >= 501\x0a"
"    \x3a public integral_constant<bool, \x21is_volatile<_Tp>\x3a\x3avalue \x26\x26 __is_trivially_copyable(_Tp)>\x0a"
"#else\x0a"
"    \x3a integral_constant<bool, is_scalar<typename remove_all_extents<_Tp>\x3a\x3atype>\x3a\x3avalue>\x0a"
"#endif\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_trivially_copyable_v\x0a"
"    = is_trivially_copyable<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"// is_trivial;\x0a"
"\x0a"
"template <class _Tp> struct _LIBCPP_TEMPLATE_VIS is_trivial\x0a"
"#if __has_feature(is_trivial) \x7c\x7c defined(_LIBCPP_COMPILER_GCC)\x0a"
"    \x3a public integral_constant<bool, __is_trivial(_Tp)>\x0a"
"#else\x0a"
"    \x3a integral_constant<bool, is_trivially_copyable<_Tp>\x3a\x3avalue \x26\x26\x0a"
"                                 is_trivially_default_constructible<_Tp>\x3a\x3avalue>\x0a"
"#endif\x0a"
"    {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14 \x26\x26 \x21""defined(_LIBCPP_HAS_NO_VARIABLE_TEMPLATES)\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR _LIBCPP_CONSTEXPR bool is_trivial_v\x0a"
"    = is_trivial<_Tp>\x3a\x3avalue;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp> struct __is_reference_wrapper_impl \x3a public false_type {};\x0a"
"template <class _Tp> struct __is_reference_wrapper_impl<reference_wrapper<_Tp> > \x3a public true_type {};\x0a"
"template <class _Tp> struct __is_reference_wrapper\x0a"
"    \x3a public __is_reference_wrapper_impl<typename remove_cv<_Tp>\x3a\x3atype> {};\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"         class _DecayFp = typename decay<_Fp>\x3a\x3atype,\x0a"
"         class _DecayA0 = typename decay<_A0>\x3a\x3atype,\x0a"
"         class _ClassT = typename __member_pointer_class_type<_DecayFp>\x3a\x3atype>\x0a"
"using __enable_if_bullet1 = typename enable_if\x0a"
"    <\x0a"
"        is_member_function_pointer<_DecayFp>\x3a\x3avalue\x0a"
"        \x26\x26 is_base_of<_ClassT, _DecayA0>\x3a\x3avalue\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"         class _DecayFp = typename decay<_Fp>\x3a\x3atype,\x0a"
"         class _DecayA0 = typename decay<_A0>\x3a\x3atype>\x0a"
"using __enable_if_bullet2 = typename enable_if\x0a"
"    <\x0a"
"        is_member_function_pointer<_DecayFp>\x3a\x3avalue\x0a"
"        \x26\x26 __is_reference_wrapper<_DecayA0>\x3a\x3avalue\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"         class _DecayFp = typename decay<_Fp>\x3a\x3atype,\x0a"
"         class _DecayA0 = typename decay<_A0>\x3a\x3atype,\x0a"
"         class _ClassT = typename __member_pointer_class_type<_DecayFp>\x3a\x3atype>\x0a"
"using __enable_if_bullet3 = typename enable_if\x0a"
"    <\x0a"
"        is_member_function_pointer<_DecayFp>\x3a\x3avalue\x0a"
"        \x26\x26 \x21is_base_of<_ClassT, _DecayA0>\x3a\x3avalue\x0a"
"        \x26\x26 \x21__is_reference_wrapper<_DecayA0>\x3a\x3avalue\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"         class _DecayFp = typename decay<_Fp>\x3a\x3atype,\x0a"
"         class _DecayA0 = typename decay<_A0>\x3a\x3atype,\x0a"
"         class _ClassT = typename __member_pointer_class_type<_DecayFp>\x3a\x3atype>\x0a"
"using __enable_if_bullet4 = typename enable_if\x0a"
"    <\x0a"
"        is_member_object_pointer<_DecayFp>\x3a\x3avalue\x0a"
"        \x26\x26 is_base_of<_ClassT, _DecayA0>\x3a\x3avalue\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"         class _DecayFp = typename decay<_Fp>\x3a\x3atype,\x0a"
"         class _DecayA0 = typename decay<_A0>\x3a\x3atype>\x0a"
"using __enable_if_bullet5 = typename enable_if\x0a"
"    <\x0a"
"        is_member_object_pointer<_DecayFp>\x3a\x3avalue\x0a"
"        \x26\x26 __is_reference_wrapper<_DecayA0>\x3a\x3avalue\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"         class _DecayFp = typename decay<_Fp>\x3a\x3atype,\x0a"
"         class _DecayA0 = typename decay<_A0>\x3a\x3atype,\x0a"
"         class _ClassT = typename __member_pointer_class_type<_DecayFp>\x3a\x3atype>\x0a"
"using __enable_if_bullet6 = typename enable_if\x0a"
"    <\x0a"
"        is_member_object_pointer<_DecayFp>\x3a\x3avalue\x0a"
"        \x26\x26 \x21is_base_of<_ClassT, _DecayA0>\x3a\x3avalue\x0a"
"        \x26\x26 \x21__is_reference_wrapper<_DecayA0>\x3a\x3avalue\x0a"
"    >\x3a\x3atype;\x0a"
"\x0a"
"// __invoke forward declarations\x0a"
"\x0a"
"// fall back - none of the bullets\x0a"
"\x0a"
"#define _LIBCPP_INVOKE_RETURN(...) \x5c\x0a"
"    noexcept(noexcept(__VA_ARGS__)) -> decltype(__VA_ARGS__) \x5c\x0a"
"    { return __VA_ARGS__; }\x0a"
"\x0a"
"template <class ..._Args>\x0a"
"auto __invoke(__any, _Args\x26\x26 ...__args) -> __nat;\x0a"
"\x0a"
"template <class ..._Args>\x0a"
"auto __invoke_constexpr(__any, _Args\x26\x26 ...__args) -> __nat;\x0a"
"\x0a"
"// bullets 1, 2 and 3\x0a"
"\x0a"
"template <class _Fp, class _A0, class ..._Args,\x0a"
"          class = __enable_if_bullet1<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto\x0a"
"__invoke(_Fp\x26\x26 __f, _A0\x26\x26 __a0, _Args\x26\x26 ...__args)\x0a"
"_LIBCPP_INVOKE_RETURN((_VSTD\x3a\x3a""forward<_A0>(__a0).*__f)(_VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"\x0a"
"template <class _Fp, class _A0, class ..._Args,\x0a"
"          class = __enable_if_bullet1<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR auto\x0a"
"__invoke_constexpr(_Fp\x26\x26 __f, _A0\x26\x26 __a0, _Args\x26\x26 ...__args)\x0a"
"_LIBCPP_INVOKE_RETURN((_VSTD\x3a\x3a""forward<_A0>(__a0).*__f)(_VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"\x0a"
"template <class _Fp, class _A0, class ..._Args,\x0a"
"          class = __enable_if_bullet2<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto\x0a"
"__invoke(_Fp\x26\x26 __f, _A0\x26\x26 __a0, _Args\x26\x26 ...__args)\x0a"
"_LIBCPP_INVOKE_RETURN((__a0.get().*__f)(_VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"\x0a"
"template <class _Fp, class _A0, class ..._Args,\x0a"
"          class = __enable_if_bullet2<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR auto\x0a"
"__invoke_constexpr(_Fp\x26\x26 __f, _A0\x26\x26 __a0, _Args\x26\x26 ...__args)\x0a"
"_LIBCPP_INVOKE_RETURN((__a0.get().*__f)(_VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"\x0a"
"template <class _Fp, class _A0, class ..._Args,\x0a"
"          class = __enable_if_bullet3<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto\x0a"
"__invoke(_Fp\x26\x26 __f, _A0\x26\x26 __a0, _Args\x26\x26 ...__args)\x0a"
"_LIBCPP_INVOKE_RETURN(((*_VSTD\x3a\x3a""forward<_A0>(__a0)).*__f)(_VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"\x0a"
"template <class _Fp, class _A0, class ..._Args,\x0a"
"          class = __enable_if_bullet3<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR auto\x0a"
"__invoke_constexpr(_Fp\x26\x26 __f, _A0\x26\x26 __a0, _Args\x26\x26 ...__args)\x0a"
"_LIBCPP_INVOKE_RETURN(((*_VSTD\x3a\x3a""forward<_A0>(__a0)).*__f)(_VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"\x0a"
"// bullets 4, 5 and 6\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"          class = __enable_if_bullet4<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto\x0a"
"__invoke(_Fp\x26\x26 __f, _A0\x26\x26 __a0)\x0a"
"_LIBCPP_INVOKE_RETURN(_VSTD\x3a\x3a""forward<_A0>(__a0).*__f)\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"          class = __enable_if_bullet4<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR auto\x0a"
"__invoke_constexpr(_Fp\x26\x26 __f, _A0\x26\x26 __a0)\x0a"
"_LIBCPP_INVOKE_RETURN(_VSTD\x3a\x3a""forward<_A0>(__a0).*__f)\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"          class = __enable_if_bullet5<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto\x0a"
"__invoke(_Fp\x26\x26 __f, _A0\x26\x26 __a0)\x0a"
"_LIBCPP_INVOKE_RETURN(__a0.get().*__f)\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"          class = __enable_if_bullet5<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR auto\x0a"
"__invoke_constexpr(_Fp\x26\x26 __f, _A0\x26\x26 __a0)\x0a"
"_LIBCPP_INVOKE_RETURN(__a0.get().*__f)\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"          class = __enable_if_bullet6<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto\x0a"
"__invoke(_Fp\x26\x26 __f, _A0\x26\x26 __a0)\x0a"
"_LIBCPP_INVOKE_RETURN((*_VSTD\x3a\x3a""forward<_A0>(__a0)).*__f)\x0a"
"\x0a"
"template <class _Fp, class _A0,\x0a"
"          class = __enable_if_bullet6<_Fp, _A0>>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR auto\x0a"
"__invoke_constexpr(_Fp\x26\x26 __f, _A0\x26\x26 __a0)\x0a"
"_LIBCPP_INVOKE_RETURN((*_VSTD\x3a\x3a""forward<_A0>(__a0)).*__f)\x0a"
"\x0a"
"// bullet 7\x0a"
"\x0a"
"template <class _Fp, class ..._Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"auto\x0a"
"__invoke(_Fp\x26\x26 __f, _Args\x26\x26 ...__args)\x0a"
"_LIBCPP_INVOKE_RETURN(_VSTD\x3a\x3a""forward<_Fp>(__f)(_VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"\x0a"
"template <class _Fp, class ..._Args>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_LIBCPP_CONSTEXPR auto\x0a"
"__invoke_constexpr(_Fp\x26\x26 __f, _Args\x26\x26 ...__args)\x0a"
"_LIBCPP_INVOKE_RETURN(_VSTD\x3a\x3a""forward<_Fp>(__f)(_VSTD\x3a\x3a""forward<_Args>(__args)...))\x0a"
"\x0a"
"#undef _LIBCPP_INVOKE_RETURN\x0a"
"\x0a"
"// __invokable\x0a"
"template <class _Ret, class _Fp, class ..._Args>\x0a"
"struct __invokable_r\x0a"
"{\x0a"
"  template <class _XFp, class ..._XArgs>\x0a"
"  static auto __try_call(int) -> decltype(\x0a"
"    _VSTD\x3a\x3a__invoke(_VSTD\x3a\x3a""declval<_XFp>(), _VSTD\x3a\x3a""declval<_XArgs>()...));\x0a"
"  template <class _XFp, class ..._XArgs>\x0a"
"  static __nat __try_call(...);\x0a"
"\x0a"
"  // FIXME\x3a Check that _Ret, _Fp, and _Args... are all complete types, cv void,\x0a"
"  // or incomplete array types as required by the standard.\x0a"
"  using _Result = decltype(__try_call<_Fp, _Args...>(0));\x0a"
"\x0a"
"  using type =\x0a"
"  typename conditional<\x0a"
"      _IsNotSame<_Result, __nat>\x3a\x3avalue,\x0a"
"      typename conditional<\x0a"
"          is_void<_Ret>\x3a\x3avalue,\x0a"
"          true_type,\x0a"
"          is_convertible<_Result, _Ret>\x0a"
"      >\x3a\x3atype,\x0a"
"      false_type\x0a"
"  >\x3a\x3atype;\x0a"
"  static const bool value = type\x3a\x3avalue;\x0a"
"};\x0a"
"template <class _Fp, class ..._Args>\x0a"
"using __invokable = __invokable_r<void, _Fp, _Args...>;\x0a"
"\x0a"
"template <bool _IsInvokable, bool _IsCVVoid, class _Ret, class _Fp, class ..._Args>\x0a"
"struct __nothrow_invokable_r_imp {\x0a"
"  static const bool value = false;\x0a"
"};\x0a"
"\x0a"
"template <class _Ret, class _Fp, class ..._Args>\x0a"
"struct __nothrow_invokable_r_imp<true, false, _Ret, _Fp, _Args...>\x0a"
"{\x0a"
"    typedef __nothrow_invokable_r_imp _ThisT;\x0a"
"\x0a"
"    template <class _Tp>\x0a"
"    static void __test_noexcept(_Tp) noexcept;\x0a"
"\x0a"
"    static const bool value = noexcept(_ThisT\x3a\x3a__test_noexcept<_Ret>(\x0a"
"        _VSTD\x3a\x3a__invoke(_VSTD\x3a\x3a""declval<_Fp>(), _VSTD\x3a\x3a""declval<_Args>()...)));\x0a"
"};\x0a"
"\x0a"
"template <class _Ret, class _Fp, class ..._Args>\x0a"
"struct __nothrow_invokable_r_imp<true, true, _Ret, _Fp, _Args...>\x0a"
"{\x0a"
"    static const bool value = noexcept(\x0a"
"        _VSTD\x3a\x3a__invoke(_VSTD\x3a\x3a""declval<_Fp>(), _VSTD\x3a\x3a""declval<_Args>()...));\x0a"
"};\x0a"
"\x0a"
"template <class _Ret, class _Fp, class ..._Args>\x0a"
"using __nothrow_invokable_r =\x0a"
"    __nothrow_invokable_r_imp<\x0a"
"            __invokable_r<_Ret, _Fp, _Args...>\x3a\x3avalue,\x0a"
"            is_void<_Ret>\x3a\x3avalue,\x0a"
"            _Ret, _Fp, _Args...\x0a"
"    >;\x0a"
"\x0a"
"template <class _Fp, class ..._Args>\x0a"
"using __nothrow_invokable =\x0a"
"    __nothrow_invokable_r_imp<\x0a"
"            __invokable<_Fp, _Args...>\x3a\x3avalue,\x0a"
"            true, void, _Fp, _Args...\x0a"
"    >;\x0a"
"\x0a"
"template <class _Fp, class ..._Args>\x0a"
"struct __invoke_of\x0a"
"    \x3a public enable_if<\x0a"
"        __invokable<_Fp, _Args...>\x3a\x3avalue,\x0a"
"        typename __invokable_r<void, _Fp, _Args...>\x3a\x3a_Result>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"// result_of\x0a"
"\x0a"
"template <class _Fp, class ..._Args>\x0a"
"class _LIBCPP_TEMPLATE_VIS result_of<_Fp(_Args...)>\x0a"
"    \x3a public __invoke_of<_Fp, _Args...>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using result_of_t = typename result_of<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"// invoke_result\x0a"
"\x0a"
"template <class _Fn, class... _Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS invoke_result\x0a"
"    \x3a __invoke_of<_Fn, _Args...>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Fn, class... _Args>\x0a"
"using invoke_result_t = typename invoke_result<_Fn, _Args...>\x3a\x3atype;\x0a"
"\x0a"
"// is_invocable\x0a"
"\x0a"
"template <class _Fn, class ..._Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_invocable\x0a"
"    \x3a integral_constant<bool, __invokable<_Fn, _Args...>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Ret, class _Fn, class ..._Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_invocable_r\x0a"
"    \x3a integral_constant<bool, __invokable_r<_Ret, _Fn, _Args...>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Fn, class ..._Args>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_invocable_v\x0a"
"    = is_invocable<_Fn, _Args...>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Ret, class _Fn, class ..._Args>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_invocable_r_v\x0a"
"    = is_invocable_r<_Ret, _Fn, _Args...>\x3a\x3avalue;\x0a"
"\x0a"
"// is_nothrow_invocable\x0a"
"\x0a"
"template <class _Fn, class ..._Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_invocable\x0a"
"    \x3a integral_constant<bool, __nothrow_invokable<_Fn, _Args...>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Ret, class _Fn, class ..._Args>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_invocable_r\x0a"
"    \x3a integral_constant<bool, __nothrow_invokable_r<_Ret, _Fn, _Args...>\x3a\x3avalue> {};\x0a"
"\x0a"
"template <class _Fn, class ..._Args>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_nothrow_invocable_v\x0a"
"    = is_nothrow_invocable<_Fn, _Args...>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Ret, class _Fn, class ..._Args>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_nothrow_invocable_r_v\x0a"
"    = is_nothrow_invocable_r<_Ret, _Fn, _Args...>\x3a\x3avalue;\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"#endif  // \x21""defined(_LIBCPP_CXX03_LANG)\x0a"
"\x0a"
"template <class _Tp> struct __is_swappable;\x0a"
"template <class _Tp> struct __is_nothrow_swappable;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"typename enable_if\x0a"
"<\x0a"
"    is_move_constructible<_Tp>\x3a\x3avalue \x26\x26\x0a"
"    is_move_assignable<_Tp>\x3a\x3avalue\x0a"
">\x3a\x3atype\x0a"
"#else\x0a"
"void\x0a"
"#endif\x0a"
"_LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"swap(_Tp\x26 __x, _Tp\x26 __y) _NOEXCEPT_(is_nothrow_move_constructible<_Tp>\x3a\x3avalue \x26\x26\x0a"
"                                    is_nothrow_move_assignable<_Tp>\x3a\x3avalue)\x0a"
"{\x0a"
"    _Tp __t(_VSTD\x3a\x3amove(__x));\x0a"
"    __x = _VSTD\x3a\x3amove(__y);\x0a"
"    __y = _VSTD\x3a\x3amove(__t);\x0a"
"}\x0a"
"\x0a"
"template<class _Tp, size_t _Np>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"typename enable_if<\x0a"
"    __is_swappable<_Tp>\x3a\x3avalue\x0a"
">\x3a\x3atype\x0a"
"swap(_Tp (\x26__a)\x5b_Np\x5d, _Tp (\x26__b)\x5b_Np\x5d) _NOEXCEPT_(__is_nothrow_swappable<_Tp>\x3a\x3avalue);\x0a"
"\x0a"
"template <class _ForwardIterator1, class _ForwardIterator2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR_AFTER_CXX17\x0a"
"void\x0a"
"iter_swap(_ForwardIterator1 __a, _ForwardIterator2 __b)\x0a"
"    //                                  _NOEXCEPT_(_NOEXCEPT_(swap(*__a, *__b)))\x0a"
"               _NOEXCEPT_(_NOEXCEPT_(swap(*_VSTD\x3a\x3a""declval<_ForwardIterator1>(),\x0a"
"                                          *_VSTD\x3a\x3a""declval<_ForwardIterator2>())))\x0a"
"{\x0a"
"    swap(*__a, *__b);\x0a"
"}\x0a"
"\x0a"
"// __swappable\x0a"
"\x0a"
"namespace __detail\x0a"
"{\x0a"
"// ALL generic swap overloads MUST already have a declaration available at this point.\x0a"
"\x0a"
"template <class _Tp, class _Up = _Tp,\x0a"
"          bool _NotVoid = \x21is_void<_Tp>\x3a\x3avalue \x26\x26 \x21is_void<_Up>\x3a\x3avalue>\x0a"
"struct __swappable_with\x0a"
"{\x0a"
"    template <class _LHS, class _RHS>\x0a"
"    static decltype(swap(_VSTD\x3a\x3a""declval<_LHS>(), _VSTD\x3a\x3a""declval<_RHS>()))\x0a"
"    __test_swap(int);\x0a"
"    template <class, class>\x0a"
"    static __nat __test_swap(long);\x0a"
"\x0a"
"    // Extra parens are needed for the C++03 definition of decltype.\x0a"
"    typedef decltype((__test_swap<_Tp, _Up>(0))) __swap1;\x0a"
"    typedef decltype((__test_swap<_Up, _Tp>(0))) __swap2;\x0a"
"\x0a"
"    static const bool value = _IsNotSame<__swap1, __nat>\x3a\x3avalue\x0a"
"                           \x26\x26 _IsNotSame<__swap2, __nat>\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __swappable_with<_Tp, _Up,  false> \x3a false_type {};\x0a"
"\x0a"
"template <class _Tp, class _Up = _Tp, bool _Swappable = __swappable_with<_Tp, _Up>\x3a\x3avalue>\x0a"
"struct __nothrow_swappable_with {\x0a"
"  static const bool value =\x0a"
"#ifndef _LIBCPP_HAS_NO_NOEXCEPT\x0a"
"      noexcept(swap(_VSTD\x3a\x3a""declval<_Tp>(), _VSTD\x3a\x3a""declval<_Up>()))\x0a"
"  \x26\x26  noexcept(swap(_VSTD\x3a\x3a""declval<_Up>(), _VSTD\x3a\x3a""declval<_Tp>()));\x0a"
"#else\x0a"
"      false;\x0a"
"#endif\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct __nothrow_swappable_with<_Tp, _Up, false> \x3a false_type {};\x0a"
"\x0a"
"}  // __detail\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_swappable\x0a"
"    \x3a public integral_constant<bool, __detail\x3a\x3a__swappable_with<_Tp\x26>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __is_nothrow_swappable\x0a"
"    \x3a public integral_constant<bool, __detail\x3a\x3a__nothrow_swappable_with<_Tp\x26>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_swappable_with\x0a"
"    \x3a public integral_constant<bool, __detail\x3a\x3a__swappable_with<_Tp, _Up>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_swappable\x0a"
"    \x3a public conditional<\x0a"
"        __is_referenceable<_Tp>\x3a\x3avalue,\x0a"
"        is_swappable_with<\x0a"
"            typename add_lvalue_reference<_Tp>\x3a\x3atype,\x0a"
"            typename add_lvalue_reference<_Tp>\x3a\x3atype>,\x0a"
"        false_type\x0a"
"    >\x3a\x3atype\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_swappable_with\x0a"
"    \x3a public integral_constant<bool, __detail\x3a\x3a__nothrow_swappable_with<_Tp, _Up>\x3a\x3avalue>\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct _LIBCPP_TEMPLATE_VIS is_nothrow_swappable\x0a"
"    \x3a public conditional<\x0a"
"        __is_referenceable<_Tp>\x3a\x3avalue,\x0a"
"        is_nothrow_swappable_with<\x0a"
"            typename add_lvalue_reference<_Tp>\x3a\x3atype,\x0a"
"            typename add_lvalue_reference<_Tp>\x3a\x3atype>,\x0a"
"        false_type\x0a"
"    >\x3a\x3atype\x0a"
"{\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_swappable_with_v\x0a"
"    = is_swappable_with<_Tp, _Up>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_swappable_v\x0a"
"    = is_swappable<_Tp>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Tp, class _Up>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_nothrow_swappable_with_v\x0a"
"    = is_nothrow_swappable_with<_Tp, _Up>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool is_nothrow_swappable_v\x0a"
"    = is_nothrow_swappable<_Tp>\x3a\x3avalue;\x0a"
"\x0a"
"#endif // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"template <class _Tp, bool = is_enum<_Tp>\x3a\x3avalue> struct __underlying_type_impl;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __underlying_type_impl<_Tp, false> {};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __underlying_type_impl<_Tp, true>\x0a"
"{\x0a"
"    typedef __underlying_type(_Tp) type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct underlying_type \x3a __underlying_type_impl<_Tp, is_enum<_Tp>\x3a\x3avalue> {};\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp> using underlying_type_t = typename underlying_type<_Tp>\x3a\x3atype;\x0a"
"#endif\x0a"
"\x0a"
"\x0a"
"template <class _Tp, bool = is_enum<_Tp>\x3a\x3avalue>\x0a"
"struct __sfinae_underlying_type\x0a"
"{\x0a"
"    typedef typename underlying_type<_Tp>\x3a\x3atype type;\x0a"
"    typedef decltype(((type)1) + 0) __promoted_type;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __sfinae_underlying_type<_Tp, false> {};\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"int __convert_to_integral(int __val) { return __val; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"unsigned __convert_to_integral(unsigned __val) { return __val; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"long __convert_to_integral(long __val) { return __val; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"unsigned long __convert_to_integral(unsigned long __val) { return __val; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"long long __convert_to_integral(long long __val) { return __val; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"unsigned long long __convert_to_integral(unsigned long long __val) {return __val; }\x0a"
"\x0a"
"template<typename _Fp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename enable_if<is_floating_point<_Fp>\x3a\x3avalue, long long>\x3a\x3atype\x0a"
" __convert_to_integral(_Fp __val) { return __val; }\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_INT128\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"__int128_t __convert_to_integral(__int128_t __val) { return __val; }\x0a"
"\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"__uint128_t __convert_to_integral(__uint128_t __val) { return __val; }\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY _LIBCPP_CONSTEXPR\x0a"
"typename __sfinae_underlying_type<_Tp>\x3a\x3a__promoted_type\x0a"
"__convert_to_integral(_Tp __val) { return __val; }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_operator_addressof_member_imp\x0a"
"{\x0a"
"    template <class _Up>\x0a"
"        static auto __test(int)\x0a"
"            -> typename __select_2nd<decltype(_VSTD\x3a\x3a""declval<_Up>().operator\x26()), true_type>\x3a\x3atype;\x0a"
"    template <class>\x0a"
"        static auto __test(long) -> false_type;\x0a"
"\x0a"
"    static const bool value = decltype(__test<_Tp>(0))\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_operator_addressof_free_imp\x0a"
"{\x0a"
"    template <class _Up>\x0a"
"        static auto __test(int)\x0a"
"            -> typename __select_2nd<decltype(operator\x26(_VSTD\x3a\x3a""declval<_Up>())), true_type>\x3a\x3atype;\x0a"
"    template <class>\x0a"
"        static auto __test(long) -> false_type;\x0a"
"\x0a"
"    static const bool value = decltype(__test<_Tp>(0))\x3a\x3avalue;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __has_operator_addressof\x0a"
"    \x3a public integral_constant<bool, __has_operator_addressof_member_imp<_Tp>\x3a\x3avalue\x0a"
"                                  \x7c\x7c __has_operator_addressof_free_imp<_Tp>\x3a\x3avalue>\x0a"
"{};\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"template <class...> using void_t = void;\x0a"
"\x0a"
"template <class... _Args>\x0a"
"struct conjunction \x3a _And<_Args...> {};\x0a"
"template<class... _Args>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool conjunction_v\x0a"
"    = conjunction<_Args...>\x3a\x3avalue;\x0a"
"\x0a"
"template <class... _Args>\x0a"
"struct disjunction \x3a _Or<_Args...> {};\x0a"
"template<class... _Args>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool disjunction_v\x0a"
"    = disjunction<_Args...>\x3a\x3avalue;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct negation \x3a _Not<_Tp> {};\x0a"
"template<class _Tp>\x0a"
"_LIBCPP_INLINE_VAR constexpr bool negation_v\x0a"
"    = negation<_Tp>\x3a\x3avalue;\x0a"
"#endif  // _LIBCPP_STD_VER > 14\x0a"
"\x0a"
"// These traits are used in __tree and __hash_table\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"struct __extract_key_fail_tag {};\x0a"
"struct __extract_key_self_tag {};\x0a"
"struct __extract_key_first_tag {};\x0a"
"\x0a"
"template <class _ValTy, class _Key,\x0a"
"          class _RawValTy = typename __unconstref<_ValTy>\x3a\x3atype>\x0a"
"struct __can_extract_key\x0a"
"    \x3a conditional<_IsSame<_RawValTy, _Key>\x3a\x3avalue, __extract_key_self_tag,\x0a"
"                  __extract_key_fail_tag>\x3a\x3atype {};\x0a"
"\x0a"
"template <class _Pair, class _Key, class _First, class _Second>\x0a"
"struct __can_extract_key<_Pair, _Key, pair<_First, _Second>>\x0a"
"    \x3a conditional<_IsSame<typename remove_const<_First>\x3a\x3atype, _Key>\x3a\x3avalue,\x0a"
"                  __extract_key_first_tag, __extract_key_fail_tag>\x3a\x3atype {};\x0a"
"\x0a"
"// __can_extract_map_key uses true_type/false_type instead of the tags.\x0a"
"// It returns true if _Key \x21= _ContainerValueTy (the container is a map not a set)\x0a"
"// and _ValTy == _Key.\x0a"
"template <class _ValTy, class _Key, class _ContainerValueTy,\x0a"
"          class _RawValTy = typename __unconstref<_ValTy>\x3a\x3atype>\x0a"
"struct __can_extract_map_key\x0a"
"    \x3a integral_constant<bool, _IsSame<_RawValTy, _Key>\x3a\x3avalue> {};\x0a"
"\x0a"
"// This specialization returns __extract_key_fail_tag for non-map containers\x0a"
"// because _Key == _ContainerValueTy\x0a"
"template <class _ValTy, class _Key, class _RawValTy>\x0a"
"struct __can_extract_map_key<_ValTy, _Key, _Key, _RawValTy>\x0a"
"    \x3a false_type {};\x0a"
"\x0a"
"#endif\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"enum class endian\x0a"
"{\x0a"
"    little = 0xDEAD,\x0a"
"    big    = 0xFACE,\x0a"
"#if defined(_LIBCPP_LITTLE_ENDIAN)\x0a"
"    native = little\x0a"
"#elif defined(_LIBCPP_BIG_ENDIAN)\x0a"
"    native = big\x0a"
"#else\x0a"
"    native = 0xCAFE\x0a"
"#endif\x0a"
"};\x0a"
"#endif\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_BUILTIN_IS_CONSTANT_EVALUATED\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"inline constexpr bool is_constant_evaluated() noexcept {\x0a"
"  return __builtin_is_constant_evaluated();\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"inline _LIBCPP_CONSTEXPR\x0a"
"bool __libcpp_is_constant_evaluated() _NOEXCEPT { return __builtin_is_constant_evaluated(); }\x0a"
"#else\x0a"
"inline _LIBCPP_CONSTEXPR\x0a"
"bool __libcpp_is_constant_evaluated() _NOEXCEPT { return false; }\x0a"
"#endif\x0a"
"\x0a"
"template <class _CharT>\x0a"
"using _IsCharLikeType = _And<is_standard_layout<_CharT>, is_trivial<_CharT> >;\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"// std\x3a\x3a""byte\x0a"
"namespace std  // purposefully not versioned\x0a"
"{\x0a"
"template <class _Integer>\x0a"
"  constexpr typename enable_if<is_integral_v<_Integer>, byte>\x3a\x3atype \x26\x0a"
"  operator<<=(byte\x26 __lhs, _Integer __shift) noexcept\x0a"
"  { return __lhs = __lhs << __shift; }\x0a"
"\x0a"
"template <class _Integer>\x0a"
"  constexpr typename enable_if<is_integral_v<_Integer>, byte>\x3a\x3atype\x0a"
"  operator<< (byte  __lhs, _Integer __shift) noexcept\x0a"
"  { return static_cast<byte>(static_cast<unsigned char>(static_cast<unsigned int>(__lhs) << __shift)); }\x0a"
"\x0a"
"template <class _Integer>\x0a"
"  constexpr typename enable_if<is_integral_v<_Integer>, byte>\x3a\x3atype \x26\x0a"
"  operator>>=(byte\x26 __lhs, _Integer __shift) noexcept\x0a"
"  { return __lhs = __lhs >> __shift; }\x0a"
"\x0a"
"template <class _Integer>\x0a"
"  constexpr typename enable_if<is_integral_v<_Integer>, byte>\x3a\x3atype\x0a"
"  operator>> (byte  __lhs, _Integer __shift) noexcept\x0a"
"  { return static_cast<byte>(static_cast<unsigned char>(static_cast<unsigned int>(__lhs) >> __shift)); }\x0a"
"\x0a"
"template <class _Integer>\x0a"
"  constexpr typename enable_if<is_integral_v<_Integer>, _Integer>\x3a\x3atype\x0a"
"  to_integer(byte __b) noexcept { return static_cast<_Integer>(__b); }\x0a"
"\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#endif  // _LIBCPP_TYPE_TRAITS\x0a"
"", 143143 ); }