#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_valarray( 
"// -*- C++ -*-\x0a"
"//===-------------------------- valarray ----------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_VALARRAY\x0a"
"#define _LIBCPP_VALARRAY\x0a"
"\x0a"
"/*\x0a"
"    valarray synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template<class T>\x0a"
"class valarray\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T value_type;\x0a"
"\x0a"
"    // construct/destroy\x3a\x0a"
"    valarray();\x0a"
"    explicit valarray(size_t n);\x0a"
"    valarray(const value_type\x26 x, size_t n);\x0a"
"    valarray(const value_type* px, size_t n);\x0a"
"    valarray(const valarray\x26 v);\x0a"
"    valarray(valarray\x26\x26 v) noexcept;\x0a"
"    valarray(const slice_array<value_type>\x26 sa);\x0a"
"    valarray(const gslice_array<value_type>\x26 ga);\x0a"
"    valarray(const mask_array<value_type>\x26 ma);\x0a"
"    valarray(const indirect_array<value_type>\x26 ia);\x0a"
"    valarray(initializer_list<value_type> il);\x0a"
"    \x7evalarray();\x0a"
"\x0a"
"    // assignment\x3a\x0a"
"    valarray\x26 operator=(const valarray\x26 v);\x0a"
"    valarray\x26 operator=(valarray\x26\x26 v) noexcept;\x0a"
"    valarray\x26 operator=(initializer_list<value_type> il);\x0a"
"    valarray\x26 operator=(const value_type\x26 x);\x0a"
"    valarray\x26 operator=(const slice_array<value_type>\x26 sa);\x0a"
"    valarray\x26 operator=(const gslice_array<value_type>\x26 ga);\x0a"
"    valarray\x26 operator=(const mask_array<value_type>\x26 ma);\x0a"
"    valarray\x26 operator=(const indirect_array<value_type>\x26 ia);\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    const value_type\x26 operator\x5b\x5d(size_t i) const;\x0a"
"    value_type\x26       operator\x5b\x5d(size_t i);\x0a"
"\x0a"
"    // subset operations\x3a\x0a"
"    valarray                   operator\x5b\x5d(slice s) const;\x0a"
"    slice_array<value_type>    operator\x5b\x5d(slice s);\x0a"
"    valarray                   operator\x5b\x5d(const gslice\x26 gs) const;\x0a"
"    gslice_array<value_type>   operator\x5b\x5d(const gslice\x26 gs);\x0a"
"    valarray                   operator\x5b\x5d(const valarray<bool>\x26 vb) const;\x0a"
"    mask_array<value_type>     operator\x5b\x5d(const valarray<bool>\x26 vb);\x0a"
"    valarray                   operator\x5b\x5d(const valarray<size_t>\x26 vs) const;\x0a"
"    indirect_array<value_type> operator\x5b\x5d(const valarray<size_t>\x26 vs);\x0a"
"\x0a"
"    // unary operators\x3a\x0a"
"    valarray       operator+() const;\x0a"
"    valarray       operator-() const;\x0a"
"    valarray       operator\x7e() const;\x0a"
"    valarray<bool> operator\x21() const;\x0a"
"\x0a"
"    // computed assignment\x3a\x0a"
"    valarray\x26 operator*= (const value_type\x26 x);\x0a"
"    valarray\x26 operator/= (const value_type\x26 x);\x0a"
"    valarray\x26 operator\x25= (const value_type\x26 x);\x0a"
"    valarray\x26 operator+= (const value_type\x26 x);\x0a"
"    valarray\x26 operator-= (const value_type\x26 x);\x0a"
"    valarray\x26 operator^= (const value_type\x26 x);\x0a"
"    valarray\x26 operator\x26= (const value_type\x26 x);\x0a"
"    valarray\x26 operator\x7c= (const value_type\x26 x);\x0a"
"    valarray\x26 operator<<=(const value_type\x26 x);\x0a"
"    valarray\x26 operator>>=(const value_type\x26 x);\x0a"
"\x0a"
"    valarray\x26 operator*= (const valarray\x26 v);\x0a"
"    valarray\x26 operator/= (const valarray\x26 v);\x0a"
"    valarray\x26 operator\x25= (const valarray\x26 v);\x0a"
"    valarray\x26 operator+= (const valarray\x26 v);\x0a"
"    valarray\x26 operator-= (const valarray\x26 v);\x0a"
"    valarray\x26 operator^= (const valarray\x26 v);\x0a"
"    valarray\x26 operator\x7c= (const valarray\x26 v);\x0a"
"    valarray\x26 operator\x26= (const valarray\x26 v);\x0a"
"    valarray\x26 operator<<=(const valarray\x26 v);\x0a"
"    valarray\x26 operator>>=(const valarray\x26 v);\x0a"
"\x0a"
"    // member functions\x3a\x0a"
"    void swap(valarray\x26 v) noexcept;\x0a"
"\x0a"
"    size_t size() const;\x0a"
"\x0a"
"    value_type sum() const;\x0a"
"    value_type min() const;\x0a"
"    value_type max() const;\x0a"
"\x0a"
"    valarray shift (int i) const;\x0a"
"    valarray cshift(int i) const;\x0a"
"    valarray apply(value_type f(value_type)) const;\x0a"
"    valarray apply(value_type f(const value_type\x26)) const;\x0a"
"    void resize(size_t n, value_type x = value_type());\x0a"
"};\x0a"
"\x0a"
"class slice\x0a"
"{\x0a"
"public\x3a\x0a"
"    slice();\x0a"
"    slice(size_t start, size_t size, size_t stride);\x0a"
"\x0a"
"    size_t start()  const;\x0a"
"    size_t size()   const;\x0a"
"    size_t stride() const;\x0a"
"};\x0a"
"\x0a"
"template <class T>\x0a"
"class slice_array\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T value_type;\x0a"
"\x0a"
"    const slice_array\x26 operator=(const slice_array\x26 sa) const;\x0a"
"    void operator=  (const valarray<value_type>\x26 v) const;\x0a"
"    void operator*= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator/= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x25= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator+= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator-= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator^= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x26= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x7c= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator<<=(const valarray<value_type>\x26 v) const;\x0a"
"    void operator>>=(const valarray<value_type>\x26 v) const;\x0a"
"\x0a"
"    void operator=(const value_type\x26 x) const;\x0a"
"\x0a"
"    slice_array() = delete;\x0a"
"};\x0a"
"\x0a"
"class gslice\x0a"
"{\x0a"
"public\x3a\x0a"
"    gslice();\x0a"
"    gslice(size_t start, const valarray<size_t>\x26 size,\x0a"
"                         const valarray<size_t>\x26 stride);\x0a"
"\x0a"
"    size_t           start()  const;\x0a"
"    valarray<size_t> size()   const;\x0a"
"    valarray<size_t> stride() const;\x0a"
"};\x0a"
"\x0a"
"template <class T>\x0a"
"class gslice_array\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T value_type;\x0a"
"\x0a"
"    void operator=  (const valarray<value_type>\x26 v) const;\x0a"
"    void operator*= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator/= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x25= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator+= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator-= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator^= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x26= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x7c= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator<<=(const valarray<value_type>\x26 v) const;\x0a"
"    void operator>>=(const valarray<value_type>\x26 v) const;\x0a"
"\x0a"
"    gslice_array(const gslice_array\x26 ga);\x0a"
"    \x7egslice_array();\x0a"
"    const gslice_array\x26 operator=(const gslice_array\x26 ga) const;\x0a"
"    void operator=(const value_type\x26 x) const;\x0a"
"\x0a"
"    gslice_array() = delete;\x0a"
"};\x0a"
"\x0a"
"template <class T>\x0a"
"class mask_array\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T value_type;\x0a"
"\x0a"
"    void operator=  (const valarray<value_type>\x26 v) const;\x0a"
"    void operator*= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator/= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x25= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator+= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator-= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator^= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x26= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x7c= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator<<=(const valarray<value_type>\x26 v) const;\x0a"
"    void operator>>=(const valarray<value_type>\x26 v) const;\x0a"
"\x0a"
"    mask_array(const mask_array\x26 ma);\x0a"
"    \x7emask_array();\x0a"
"    const mask_array\x26 operator=(const mask_array\x26 ma) const;\x0a"
"    void operator=(const value_type\x26 x) const;\x0a"
"\x0a"
"    mask_array() = delete;\x0a"
"};\x0a"
"\x0a"
"template <class T>\x0a"
"class indirect_array\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T value_type;\x0a"
"\x0a"
"    void operator=  (const valarray<value_type>\x26 v) const;\x0a"
"    void operator*= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator/= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x25= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator+= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator-= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator^= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x26= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator\x7c= (const valarray<value_type>\x26 v) const;\x0a"
"    void operator<<=(const valarray<value_type>\x26 v) const;\x0a"
"    void operator>>=(const valarray<value_type>\x26 v) const;\x0a"
"\x0a"
"    indirect_array(const indirect_array\x26 ia);\x0a"
"    \x7eindirect_array();\x0a"
"    const indirect_array\x26 operator=(const indirect_array\x26 ia) const;\x0a"
"    void operator=(const value_type\x26 x) const;\x0a"
"\x0a"
"    indirect_array() = delete;\x0a"
"};\x0a"
"\x0a"
"template<class T> void swap(valarray<T>\x26 x, valarray<T>\x26 y) noexcept;\x0a"
"\x0a"
"template<class T> valarray<T> operator* (const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> operator* (const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> operator* (const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> operator/ (const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> operator/ (const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> operator/ (const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> operator\x25 (const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> operator\x25 (const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> operator\x25 (const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> operator+ (const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> operator+ (const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> operator+ (const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> operator- (const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> operator- (const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> operator- (const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> operator^ (const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> operator^ (const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> operator^ (const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> operator\x26 (const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> operator\x26 (const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> operator\x26 (const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> operator\x7c (const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> operator\x7c (const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> operator\x7c (const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> operator<<(const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> operator<<(const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> operator<<(const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> operator>>(const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> operator>>(const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> operator>>(const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<bool> operator\x26\x26(const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<bool> operator\x26\x26(const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<bool> operator\x26\x26(const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<bool> operator\x7c\x7c(const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<bool> operator\x7c\x7c(const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<bool> operator\x7c\x7c(const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<bool> operator==(const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<bool> operator==(const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<bool> operator==(const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<bool> operator\x21=(const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<bool> operator\x21=(const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<bool> operator\x21=(const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<bool> operator< (const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<bool> operator< (const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<bool> operator< (const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<bool> operator> (const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<bool> operator> (const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<bool> operator> (const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<bool> operator<=(const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<bool> operator<=(const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<bool> operator<=(const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<bool> operator>=(const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<bool> operator>=(const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<bool> operator>=(const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> abs (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> acos (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> asin (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> atan (const valarray<T>\x26 x);\x0a"
"\x0a"
"template<class T> valarray<T> atan2(const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> atan2(const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> atan2(const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> cos (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> cosh (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> exp (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> log (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> log10(const valarray<T>\x26 x);\x0a"
"\x0a"
"template<class T> valarray<T> pow(const valarray<T>\x26 x, const valarray<T>\x26 y);\x0a"
"template<class T> valarray<T> pow(const valarray<T>\x26 x, const T\x26 y);\x0a"
"template<class T> valarray<T> pow(const T\x26 x, const valarray<T>\x26 y);\x0a"
"\x0a"
"template<class T> valarray<T> sin (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> sinh (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> sqrt (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> tan (const valarray<T>\x26 x);\x0a"
"template<class T> valarray<T> tanh (const valarray<T>\x26 x);\x0a"
"\x0a"
"template <class T> unspecified1 begin(valarray<T>\x26 v);\x0a"
"template <class T> unspecified2 begin(const valarray<T>\x26 v);\x0a"
"template <class T> unspecified1 end(valarray<T>\x26 v);\x0a"
"template <class T> unspecified2 end(const valarray<T>\x26 v);\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <cstddef>\x0a"
"#include <cmath>\x0a"
"#include <initializer_list>\x0a"
"#include <algorithm>\x0a"
"#include <functional>\x0a"
"#include <new>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template<class _Tp> class _LIBCPP_TEMPLATE_VIS valarray;\x0a"
"\x0a"
"class _LIBCPP_TEMPLATE_VIS slice\x0a"
"{\x0a"
"    size_t __start_;\x0a"
"    size_t __size_;\x0a"
"    size_t __stride_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    slice()\x0a"
"        \x3a __start_(0),\x0a"
"          __size_(0),\x0a"
"          __stride_(0)\x0a"
"          {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    slice(size_t __start, size_t __size, size_t __stride)\x0a"
"        \x3a __start_(__start),\x0a"
"          __size_(__size),\x0a"
"          __stride_(__stride)\x0a"
"          {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_t start()  const {return __start_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_t size()   const {return __size_;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_t stride() const {return __stride_;}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp> class _LIBCPP_TEMPLATE_VIS slice_array;\x0a"
"class _LIBCPP_TYPE_VIS gslice;\x0a"
"template <class _Tp> class _LIBCPP_TEMPLATE_VIS gslice_array;\x0a"
"template <class _Tp> class _LIBCPP_TEMPLATE_VIS mask_array;\x0a"
"template <class _Tp> class _LIBCPP_TEMPLATE_VIS indirect_array;\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"begin(valarray<_Tp>\x26 __v);\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"const _Tp*\x0a"
"begin(const valarray<_Tp>\x26 __v);\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"end(valarray<_Tp>\x26 __v);\x0a"
"\x0a"
"template <class _Tp>\x0a"
"_LIBCPP_INLINE_VISIBILITY\x0a"
"const _Tp*\x0a"
"end(const valarray<_Tp>\x26 __v);\x0a"
"\x0a"
"template <class _Op, class _A0>\x0a"
"struct _UnaryOp\x0a"
"{\x0a"
"    typedef typename _Op\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _A0\x3a\x3avalue_type value_type;\x0a"
"\x0a"
"    _Op __op_;\x0a"
"    _A0 __a0_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _UnaryOp(const _Op\x26 __op, const _A0\x26 __a0) \x3a __op_(__op), __a0_(__a0) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator\x5b\x5d(size_t __i) const {return __op_(__a0_\x5b__i\x5d);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __a0_.size();}\x0a"
"};\x0a"
"\x0a"
"template <class _Op, class _A0, class _A1>\x0a"
"struct _BinaryOp\x0a"
"{\x0a"
"    typedef typename _Op\x3a\x3aresult_type result_type;\x0a"
"    typedef typename _A0\x3a\x3avalue_type value_type;\x0a"
"\x0a"
"    _Op __op_;\x0a"
"    _A0 __a0_;\x0a"
"    _A1 __a1_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _BinaryOp(const _Op\x26 __op, const _A0\x26 __a0, const _A1\x26 __a1)\x0a"
"        \x3a __op_(__op), __a0_(__a0), __a1_(__a1) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type operator\x5b\x5d(size_t __i) const {return __op_(__a0_\x5b__i\x5d, __a1_\x5b__i\x5d);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __a0_.size();}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class __scalar_expr\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp        value_type;\x0a"
"    typedef const _Tp\x26 result_type;\x0a"
"private\x3a\x0a"
"    const value_type\x26 __t_;\x0a"
"    size_t __s_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __scalar_expr(const value_type\x26 __t, size_t __s) \x3a __t_(__t), __s_(__s) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator\x5b\x5d(size_t) const {return __t_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __s_;}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __unary_plus \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return +__x;}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __bit_not  \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return \x7e__x;}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __bit_shift_left \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x << __y;}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __bit_shift_right \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return __x >> __y;}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Fp>\x0a"
"struct __apply_expr   \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"private\x3a\x0a"
"    _Fp __f_;\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __apply_expr(_Fp __f) \x3a __f_(__f) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return __f_(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __abs_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return abs(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __acos_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return acos(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __asin_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return asin(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __atan_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return atan(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __atan2_expr \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return atan2(__x, __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __cos_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return cos(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __cosh_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return cosh(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __exp_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return exp(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __log_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return log(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __log10_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return log10(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __pow_expr \x3a binary_function<_Tp, _Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x, const _Tp\x26 __y) const\x0a"
"        {return pow(__x, __y);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __sin_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return sin(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __sinh_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return sinh(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __sqrt_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return sqrt(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __tan_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return tan(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"struct __tanh_expr \x3a unary_function<_Tp, _Tp>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _Tp operator()(const _Tp\x26 __x) const\x0a"
"        {return tanh(__x);}\x0a"
"};\x0a"
"\x0a"
"template <class _ValExpr>\x0a"
"class __slice_expr\x0a"
"{\x0a"
"    typedef typename remove_reference<_ValExpr>\x3a\x3atype  _RmExpr;\x0a"
"public\x3a\x0a"
"    typedef typename _RmExpr\x3a\x3avalue_type value_type;\x0a"
"    typedef value_type result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    _ValExpr __expr_;\x0a"
"    size_t __start_;\x0a"
"    size_t __size_;\x0a"
"    size_t __stride_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __slice_expr(const slice\x26 __sl, const _RmExpr\x26 __e)\x0a"
"        \x3a __expr_(__e),\x0a"
"          __start_(__sl.start()),\x0a"
"          __size_(__sl.size()),\x0a"
"          __stride_(__sl.stride())\x0a"
"        {}\x0a"
"public\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator\x5b\x5d(size_t __i) const\x0a"
"        {return __expr_\x5b__start_ + __i * __stride_\x5d;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __size_;}\x0a"
"\x0a"
"    template <class> friend class __val_expr;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS valarray;\x0a"
"};\x0a"
"\x0a"
"template <class _ValExpr>\x0a"
"class __mask_expr;\x0a"
"\x0a"
"template <class _ValExpr>\x0a"
"class __indirect_expr;\x0a"
"\x0a"
"template <class _ValExpr>\x0a"
"class __shift_expr\x0a"
"{\x0a"
"    typedef typename remove_reference<_ValExpr>\x3a\x3atype  _RmExpr;\x0a"
"public\x3a\x0a"
"    typedef typename _RmExpr\x3a\x3avalue_type value_type;\x0a"
"    typedef value_type result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    _ValExpr __expr_;\x0a"
"    size_t __size_;\x0a"
"    ptrdiff_t __ul_;\x0a"
"    ptrdiff_t __sn_;\x0a"
"    ptrdiff_t __n_;\x0a"
"    static const ptrdiff_t _Np = static_cast<ptrdiff_t>(\x0a"
"                                    sizeof(ptrdiff_t) * __CHAR_BIT__ - 1);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __shift_expr(int __n, const _RmExpr\x26 __e)\x0a"
"        \x3a __expr_(__e),\x0a"
"          __size_(__e.size()),\x0a"
"          __n_(__n)\x0a"
"        {\x0a"
"            ptrdiff_t __neg_n = static_cast<ptrdiff_t>(__n_ >> _Np);\x0a"
"            __sn_ = __neg_n \x7c static_cast<ptrdiff_t>(static_cast<size_t>(-__n_) >> _Np);\x0a"
"            __ul_ = ((__size_ - __n_) \x26 \x7e__neg_n) \x7c ((__n_ + 1) \x26 __neg_n);\x0a"
"        }\x0a"
"public\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator\x5b\x5d(size_t __j) const\x0a"
"        {\x0a"
"            ptrdiff_t __i = static_cast<ptrdiff_t>(__j);\x0a"
"            ptrdiff_t __m = (__sn_ * __i - __ul_) >> _Np;\x0a"
"            return (__expr_\x5b(__i + __n_) \x26 __m\x5d \x26 __m) \x7c (value_type() \x26 \x7e__m);\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __size_;}\x0a"
"\x0a"
"    template <class> friend class __val_expr;\x0a"
"};\x0a"
"\x0a"
"template <class _ValExpr>\x0a"
"class __cshift_expr\x0a"
"{\x0a"
"    typedef typename remove_reference<_ValExpr>\x3a\x3atype  _RmExpr;\x0a"
"public\x3a\x0a"
"    typedef typename _RmExpr\x3a\x3avalue_type value_type;\x0a"
"    typedef value_type result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    _ValExpr __expr_;\x0a"
"    size_t __size_;\x0a"
"    size_t __m_;\x0a"
"    size_t __o1_;\x0a"
"    size_t __o2_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __cshift_expr(int __n, const _RmExpr\x26 __e)\x0a"
"        \x3a __expr_(__e),\x0a"
"          __size_(__e.size())\x0a"
"        {\x0a"
"            __n \x25= static_cast<int>(__size_);\x0a"
"            if (__n >= 0)\x0a"
"            {\x0a"
"                __m_ = __size_ - __n;\x0a"
"                __o1_ = __n;\x0a"
"                __o2_ = __n - __size_;\x0a"
"            }\x0a"
"            else\x0a"
"            {\x0a"
"                __m_ = -__n;\x0a"
"                __o1_ = __n + __size_;\x0a"
"                __o2_ = __n;\x0a"
"            }\x0a"
"        }\x0a"
"public\x3a\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator\x5b\x5d(size_t __i) const\x0a"
"        {\x0a"
"            if (__i < __m_)\x0a"
"                return __expr_\x5b__i + __o1_\x5d;\x0a"
"            return __expr_\x5b__i + __o2_\x5d;\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __size_;}\x0a"
"\x0a"
"    template <class> friend class __val_expr;\x0a"
"};\x0a"
"\x0a"
"template<class _ValExpr>\x0a"
"class __val_expr;\x0a"
"\x0a"
"template<class _ValExpr>\x0a"
"struct __is_val_expr \x3a false_type {};\x0a"
"\x0a"
"template<class _ValExpr>\x0a"
"struct __is_val_expr<__val_expr<_ValExpr> > \x3a true_type {};\x0a"
"\x0a"
"template<class _Tp>\x0a"
"struct __is_val_expr<valarray<_Tp> > \x3a true_type {};\x0a"
"\x0a"
"template<class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS valarray\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp value_type;\x0a"
"    typedef _Tp result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    value_type* __begin_;\x0a"
"    value_type* __end_;\x0a"
"\x0a"
"public\x3a\x0a"
"    // construct/destroy\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray() \x3a __begin_(0), __end_(0) {}\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    explicit valarray(size_t __n);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray(const value_type\x26 __x, size_t __n);\x0a"
"    valarray(const value_type* __p, size_t __n);\x0a"
"    valarray(const valarray\x26 __v);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray(valarray\x26\x26 __v) _NOEXCEPT;\x0a"
"    valarray(initializer_list<value_type> __il);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    valarray(const slice_array<value_type>\x26 __sa);\x0a"
"    valarray(const gslice_array<value_type>\x26 __ga);\x0a"
"    valarray(const mask_array<value_type>\x26 __ma);\x0a"
"    valarray(const indirect_array<value_type>\x26 __ia);\x0a"
"    inline _LIBCPP_HIDE_FROM_ABI_AFTER_V1\x0a"
"    \x7evalarray();\x0a"
"\x0a"
"    // assignment\x3a\x0a"
"    valarray\x26 operator=(const valarray\x26 __v);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator=(valarray\x26\x26 __v) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator=(initializer_list<value_type>);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator=(const value_type\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator=(const slice_array<value_type>\x26 __sa);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator=(const gslice_array<value_type>\x26 __ga);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator=(const mask_array<value_type>\x26 __ma);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator=(const indirect_array<value_type>\x26 __ia);\x0a"
"    template <class _ValExpr>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"        valarray\x26 operator=(const __val_expr<_ValExpr>\x26 __v);\x0a"
"\x0a"
"    // element access\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type\x26 operator\x5b\x5d(size_t __i) const {return __begin_\x5b__i\x5d;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type\x26       operator\x5b\x5d(size_t __i)       {return __begin_\x5b__i\x5d;}\x0a"
"\x0a"
"    // subset operations\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__slice_expr<const valarray\x26> >    operator\x5b\x5d(slice __s) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    slice_array<value_type>                       operator\x5b\x5d(slice __s);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__indirect_expr<const valarray\x26> > operator\x5b\x5d(const gslice\x26 __gs) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    gslice_array<value_type>   operator\x5b\x5d(const gslice\x26 __gs);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__indirect_expr<const valarray\x26> > operator\x5b\x5d(gslice\x26\x26 __gs) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    gslice_array<value_type>                      operator\x5b\x5d(gslice\x26\x26 __gs);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__mask_expr<const valarray\x26> >     operator\x5b\x5d(const valarray<bool>\x26 __vb) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    mask_array<value_type>                        operator\x5b\x5d(const valarray<bool>\x26 __vb);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__mask_expr<const valarray\x26> >     operator\x5b\x5d(valarray<bool>\x26\x26 __vb) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    mask_array<value_type>                        operator\x5b\x5d(valarray<bool>\x26\x26 __vb);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__indirect_expr<const valarray\x26> > operator\x5b\x5d(const valarray<size_t>\x26 __vs) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    indirect_array<value_type>                    operator\x5b\x5d(const valarray<size_t>\x26 __vs);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__indirect_expr<const valarray\x26> > operator\x5b\x5d(valarray<size_t>\x26\x26 __vs) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    indirect_array<value_type>                    operator\x5b\x5d(valarray<size_t>\x26\x26 __vs);\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    // unary operators\x3a\x0a"
"    valarray       operator+() const;\x0a"
"    valarray       operator-() const;\x0a"
"    valarray       operator\x7e() const;\x0a"
"    valarray<bool> operator\x21() const;\x0a"
"\x0a"
"    // computed assignment\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator*= (const value_type\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator/= (const value_type\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator\x25= (const value_type\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator+= (const value_type\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator-= (const value_type\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator^= (const value_type\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator\x26= (const value_type\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator\x7c= (const value_type\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator<<=(const value_type\x26 __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray\x26 operator>>=(const value_type\x26 __x);\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        valarray\x26\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator*= (const _Expr\x26 __v);\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        valarray\x26\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator/= (const _Expr\x26 __v);\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        valarray\x26\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x25= (const _Expr\x26 __v);\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        valarray\x26\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator+= (const _Expr\x26 __v);\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        valarray\x26\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator-= (const _Expr\x26 __v);\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        valarray\x26\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator^= (const _Expr\x26 __v);\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        valarray\x26\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x7c= (const _Expr\x26 __v);\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        valarray\x26\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x26= (const _Expr\x26 __v);\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        valarray\x26\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator<<= (const _Expr\x26 __v);\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        valarray\x26\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator>>= (const _Expr\x26 __v);\x0a"
"\x0a"
"    // member functions\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void swap(valarray\x26 __v) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return static_cast<size_t>(__end_ - __begin_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type sum() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type min() const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type max() const;\x0a"
"\x0a"
"    valarray shift (int __i) const;\x0a"
"    valarray cshift(int __i) const;\x0a"
"    valarray apply(value_type __f(value_type)) const;\x0a"
"    valarray apply(value_type __f(const value_type\x26)) const;\x0a"
"    void     resize(size_t __n, value_type __x = value_type());\x0a"
"\x0a"
"private\x3a\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS valarray;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS slice_array;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS gslice_array;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS mask_array;\x0a"
"    template <class> friend class __mask_expr;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS indirect_array;\x0a"
"    template <class> friend class __indirect_expr;\x0a"
"    template <class> friend class __val_expr;\x0a"
"\x0a"
"    template <class _Up>\x0a"
"    friend\x0a"
"    _Up*\x0a"
"    begin(valarray<_Up>\x26 __v);\x0a"
"\x0a"
"    template <class _Up>\x0a"
"    friend\x0a"
"    const _Up*\x0a"
"    begin(const valarray<_Up>\x26 __v);\x0a"
"\x0a"
"    template <class _Up>\x0a"
"    friend\x0a"
"    _Up*\x0a"
"    end(valarray<_Up>\x26 __v);\x0a"
"\x0a"
"    template <class _Up>\x0a"
"    friend\x0a"
"    const _Up*\x0a"
"    end(const valarray<_Up>\x26 __v);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __clear(size_t __capacity);\x0a"
"    valarray\x26 __assign_range(const value_type* __f, const value_type* __l);\x0a"
"};\x0a"
"\x0a"
"_LIBCPP_EXTERN_TEMPLATE(_LIBCPP_FUNC_VIS void valarray<size_t>\x3a\x3aresize(size_t, size_t))\x0a"
"\x0a"
"template <class _Op, class _Tp>\x0a"
"struct _UnaryOp<_Op, valarray<_Tp> >\x0a"
"{\x0a"
"    typedef typename _Op\x3a\x3aresult_type result_type;\x0a"
"    typedef _Tp value_type;\x0a"
"\x0a"
"    _Op __op_;\x0a"
"    const valarray<_Tp>\x26 __a0_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _UnaryOp(const _Op\x26 __op, const valarray<_Tp>\x26 __a0) \x3a __op_(__op), __a0_(__a0) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator\x5b\x5d(size_t __i) const {return __op_(__a0_\x5b__i\x5d);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __a0_.size();}\x0a"
"};\x0a"
"\x0a"
"template <class _Op, class _Tp, class _A1>\x0a"
"struct _BinaryOp<_Op, valarray<_Tp>, _A1>\x0a"
"{\x0a"
"    typedef typename _Op\x3a\x3aresult_type result_type;\x0a"
"    typedef _Tp value_type;\x0a"
"\x0a"
"    _Op __op_;\x0a"
"    const valarray<_Tp>\x26 __a0_;\x0a"
"    _A1 __a1_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _BinaryOp(const _Op\x26 __op, const valarray<_Tp>\x26 __a0, const _A1\x26 __a1)\x0a"
"        \x3a __op_(__op), __a0_(__a0), __a1_(__a1) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type operator\x5b\x5d(size_t __i) const {return __op_(__a0_\x5b__i\x5d, __a1_\x5b__i\x5d);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __a0_.size();}\x0a"
"};\x0a"
"\x0a"
"template <class _Op, class _A0, class _Tp>\x0a"
"struct _BinaryOp<_Op, _A0, valarray<_Tp> >\x0a"
"{\x0a"
"    typedef typename _Op\x3a\x3aresult_type result_type;\x0a"
"    typedef _Tp value_type;\x0a"
"\x0a"
"    _Op __op_;\x0a"
"    _A0 __a0_;\x0a"
"    const valarray<_Tp>\x26 __a1_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _BinaryOp(const _Op\x26 __op, const _A0\x26 __a0, const valarray<_Tp>\x26 __a1)\x0a"
"        \x3a __op_(__op), __a0_(__a0), __a1_(__a1) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type operator\x5b\x5d(size_t __i) const {return __op_(__a0_\x5b__i\x5d, __a1_\x5b__i\x5d);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __a0_.size();}\x0a"
"};\x0a"
"\x0a"
"template <class _Op, class _Tp>\x0a"
"struct _BinaryOp<_Op, valarray<_Tp>, valarray<_Tp> >\x0a"
"{\x0a"
"    typedef typename _Op\x3a\x3aresult_type result_type;\x0a"
"    typedef _Tp value_type;\x0a"
"\x0a"
"    _Op __op_;\x0a"
"    const valarray<_Tp>\x26 __a0_;\x0a"
"    const valarray<_Tp>\x26 __a1_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    _BinaryOp(const _Op\x26 __op, const valarray<_Tp>\x26 __a0, const valarray<_Tp>\x26 __a1)\x0a"
"        \x3a __op_(__op), __a0_(__a0), __a1_(__a1) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type operator\x5b\x5d(size_t __i) const {return __op_(__a0_\x5b__i\x5d, __a1_\x5b__i\x5d);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __a0_.size();}\x0a"
"};\x0a"
"\x0a"
"// slice_array\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS slice_array\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp value_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    value_type* __vp_;\x0a"
"    size_t __size_;\x0a"
"    size_t __stride_;\x0a"
"\x0a"
"public\x3a\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator*=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator/=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x25=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator+=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator-=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator^=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x26=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x7c=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator<<=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator>>=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const slice_array\x26 operator=(const slice_array\x26 __sa) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator=(const value_type\x26 __x) const;\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    slice_array(const slice\x26 __sl, const valarray<value_type>\x26 __v)\x0a"
"        \x3a __vp_(const_cast<value_type*>(__v.__begin_ + __sl.start())),\x0a"
"          __size_(__sl.size()),\x0a"
"          __stride_(__sl.stride())\x0a"
"        {}\x0a"
"\x0a"
"    template <class> friend class valarray;\x0a"
"    template <class> friend class sliceExpr;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"const slice_array<_Tp>\x26\x0a"
"slice_array<_Tp>\x3a\x3aoperator=(const slice_array\x26 __sa) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    const value_type* __s = __sa.__vp_;\x0a"
"    for (size_t __n = __size_; __n; --__n, __t += __stride_, __s += __sa.__stride_)\x0a"
"        *__t = *__s;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t = __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator*=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t *= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator/=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t /= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator\x25=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t \x25= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator+=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t += __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator-=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t -= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator^=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t ^= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator\x26=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t \x26= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator\x7c=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t \x7c= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator<<=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t <<= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"slice_array<_Tp>\x3a\x3aoperator>>=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __i = 0; __i < __size_; ++__i, __t += __stride_)\x0a"
"        *__t >>= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"void\x0a"
"slice_array<_Tp>\x3a\x3aoperator=(const value_type\x26 __x) const\x0a"
"{\x0a"
"    value_type* __t = __vp_;\x0a"
"    for (size_t __n = __size_; __n; --__n, __t += __stride_)\x0a"
"        *__t = __x;\x0a"
"}\x0a"
"\x0a"
"// gslice\x0a"
"\x0a"
"class _LIBCPP_TYPE_VIS gslice\x0a"
"{\x0a"
"    valarray<size_t> __size_;\x0a"
"    valarray<size_t> __stride_;\x0a"
"    valarray<size_t> __1d_;\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    gslice() {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    gslice(size_t __start, const valarray<size_t>\x26 __size,\x0a"
"                           const valarray<size_t>\x26 __stride)\x0a"
"        \x3a __size_(__size),\x0a"
"          __stride_(__stride)\x0a"
"        {__init(__start);}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    gslice(size_t __start, const valarray<size_t>\x26  __size,\x0a"
"                                 valarray<size_t>\x26\x26 __stride)\x0a"
"        \x3a __size_(__size),\x0a"
"          __stride_(move(__stride))\x0a"
"        {__init(__start);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    gslice(size_t __start,       valarray<size_t>\x26\x26 __size,\x0a"
"                           const valarray<size_t>\x26  __stride)\x0a"
"        \x3a __size_(move(__size)),\x0a"
"          __stride_(__stride)\x0a"
"        {__init(__start);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    gslice(size_t __start,       valarray<size_t>\x26\x26 __size,\x0a"
"                                 valarray<size_t>\x26\x26 __stride)\x0a"
"        \x3a __size_(move(__size)),\x0a"
"          __stride_(move(__stride))\x0a"
"        {__init(__start);}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"//  gslice(const gslice\x26)            = default;\x0a"
"//  gslice(gslice\x26\x26)                 = default;\x0a"
"//  gslice\x26 operator=(const gslice\x26) = default;\x0a"
"//  gslice\x26 operator=(gslice\x26\x26)      = default;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t           start()  const {return __1d_.size() \x3f __1d_\x5b""0\x5d \x3a 0;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray<size_t> size()   const {return __size_;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    valarray<size_t> stride() const {return __stride_;}\x0a"
"\x0a"
"private\x3a\x0a"
"    void __init(size_t __start);\x0a"
"\x0a"
"    template <class> friend class gslice_array;\x0a"
"    template <class> friend class valarray;\x0a"
"    template <class> friend class __val_expr;\x0a"
"};\x0a"
"\x0a"
"// gslice_array\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS gslice_array\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp value_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    value_type*      __vp_;\x0a"
"    valarray<size_t> __1d_;\x0a"
"\x0a"
"public\x3a\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator*=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator/=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x25=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator+=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator-=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator^=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x26=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x7c=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator<<=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator>>=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const gslice_array\x26 operator=(const gslice_array\x26 __ga) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator=(const value_type\x26 __x) const;\x0a"
"\x0a"
"//  gslice_array(const gslice_array\x26)            = default;\x0a"
"//  gslice_array(gslice_array\x26\x26)                 = default;\x0a"
"//  gslice_array\x26 operator=(const gslice_array\x26) = default;\x0a"
"//  gslice_array\x26 operator=(gslice_array\x26\x26)      = default;\x0a"
"\x0a"
"private\x3a\x0a"
"    gslice_array(const gslice\x26 __gs, const valarray<value_type>\x26 __v)\x0a"
"        \x3a __vp_(const_cast<value_type*>(__v.__begin_)),\x0a"
"          __1d_(__gs.__1d_)\x0a"
"        {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    gslice_array(gslice\x26\x26 __gs, const valarray<value_type>\x26 __v)\x0a"
"        \x3a __vp_(const_cast<value_type*>(__v.__begin_)),\x0a"
"          __1d_(move(__gs.__1d_))\x0a"
"        {}\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template <class> friend class valarray;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d = __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator*=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d *= __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator/=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d /= __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator\x25=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d \x25= __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator+=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d += __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator-=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d -= __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator^=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d ^= __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator\x26=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d \x26= __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator\x7c=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d \x7c= __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator<<=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d <<= __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"gslice_array<_Tp>\x3a\x3aoperator>>=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    size_t __j = 0;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d >>= __v\x5b__j\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"const gslice_array<_Tp>\x26\x0a"
"gslice_array<_Tp>\x3a\x3aoperator=(const gslice_array\x26 __ga) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    const value_type* __s = __ga.__vp_;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_, __j = __ga.__1d_.__begin_;\x0a"
"            __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d = __s\x5b*__j\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"void\x0a"
"gslice_array<_Tp>\x3a\x3aoperator=(const value_type\x26 __x) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i)\x0a"
"        __vp_\x5b*__i\x5d = __x;\x0a"
"}\x0a"
"\x0a"
"// mask_array\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS mask_array\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp value_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    value_type*      __vp_;\x0a"
"    valarray<size_t> __1d_;\x0a"
"\x0a"
"public\x3a\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator*=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator/=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x25=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator+=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator-=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator^=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x26=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x7c=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator<<=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator>>=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const mask_array\x26 operator=(const mask_array\x26 __ma) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator=(const value_type\x26 __x) const;\x0a"
"\x0a"
"//  mask_array(const mask_array\x26)            = default;\x0a"
"//  mask_array(mask_array\x26\x26)                 = default;\x0a"
"//  mask_array\x26 operator=(const mask_array\x26) = default;\x0a"
"//  mask_array\x26 operator=(mask_array\x26\x26)      = default;\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    mask_array(const valarray<bool>\x26 __vb, const valarray<value_type>\x26 __v)\x0a"
"        \x3a __vp_(const_cast<value_type*>(__v.__begin_)),\x0a"
"          __1d_(static_cast<size_t>(count(__vb.__begin_, __vb.__end_, true)))\x0a"
"          {\x0a"
"              size_t __j = 0;\x0a"
"              for (size_t __i = 0; __i < __vb.size(); ++__i)\x0a"
"                  if (__vb\x5b__i\x5d)\x0a"
"                      __1d_\x5b__j++\x5d = __i;\x0a"
"          }\x0a"
"\x0a"
"    template <class> friend class valarray;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d = __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator*=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d *= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator/=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d /= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator\x25=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d \x25= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator+=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d += __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator-=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d -= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator^=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d ^= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator\x26=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d \x26= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator\x7c=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d \x7c= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator<<=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d <<= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"mask_array<_Tp>\x3a\x3aoperator>>=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d >>= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"const mask_array<_Tp>\x26\x0a"
"mask_array<_Tp>\x3a\x3aoperator=(const mask_array\x26 __ma) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d = __ma.__vp_\x5b__1d_\x5b__i\x5d\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"void\x0a"
"mask_array<_Tp>\x3a\x3aoperator=(const value_type\x26 __x) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d = __x;\x0a"
"}\x0a"
"\x0a"
"template <class _ValExpr>\x0a"
"class __mask_expr\x0a"
"{\x0a"
"    typedef typename remove_reference<_ValExpr>\x3a\x3atype  _RmExpr;\x0a"
"public\x3a\x0a"
"    typedef typename _RmExpr\x3a\x3avalue_type value_type;\x0a"
"    typedef value_type result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    _ValExpr __expr_;\x0a"
"    valarray<size_t> __1d_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __mask_expr(const valarray<bool>\x26 __vb, const _RmExpr\x26 __e)\x0a"
"        \x3a __expr_(__e),\x0a"
"          __1d_(static_cast<size_t>(count(__vb.__begin_, __vb.__end_, true)))\x0a"
"          {\x0a"
"              size_t __j = 0;\x0a"
"              for (size_t __i = 0; __i < __vb.size(); ++__i)\x0a"
"                  if (__vb\x5b__i\x5d)\x0a"
"                      __1d_\x5b__j++\x5d = __i;\x0a"
"          }\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator\x5b\x5d(size_t __i) const\x0a"
"        {return __expr_\x5b__1d_\x5b__i\x5d\x5d;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __1d_.size();}\x0a"
"\x0a"
"    template <class> friend class __val_expr;\x0a"
"    template <class> friend class valarray;\x0a"
"};\x0a"
"\x0a"
"// indirect_array\x0a"
"\x0a"
"template <class _Tp>\x0a"
"class _LIBCPP_TEMPLATE_VIS indirect_array\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Tp value_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    value_type*      __vp_;\x0a"
"    valarray<size_t> __1d_;\x0a"
"\x0a"
"public\x3a\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator*=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator/=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x25=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator+=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator-=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator^=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x26=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator\x7c=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator<<=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    template <class _Expr>\x0a"
"    typename enable_if\x0a"
"    <\x0a"
"        __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"        void\x0a"
"    >\x3a\x3atype\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    operator>>=(const _Expr\x26 __v) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const indirect_array\x26 operator=(const indirect_array\x26 __ia) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void operator=(const value_type\x26 __x) const;\x0a"
"\x0a"
"//  indirect_array(const indirect_array\x26)            = default;\x0a"
"//  indirect_array(indirect_array\x26\x26)                 = default;\x0a"
"//  indirect_array\x26 operator=(const indirect_array\x26) = default;\x0a"
"//  indirect_array\x26 operator=(indirect_array\x26\x26)      = default;\x0a"
"\x0a"
"private\x3a\x0a"
"     _LIBCPP_INLINE_VISIBILITY\x0a"
"   indirect_array(const valarray<size_t>\x26 __ia, const valarray<value_type>\x26 __v)\x0a"
"        \x3a __vp_(const_cast<value_type*>(__v.__begin_)),\x0a"
"          __1d_(__ia)\x0a"
"        {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    indirect_array(valarray<size_t>\x26\x26 __ia, const valarray<value_type>\x26 __v)\x0a"
"        \x3a __vp_(const_cast<value_type*>(__v.__begin_)),\x0a"
"          __1d_(move(__ia))\x0a"
"        {}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template <class> friend class valarray;\x0a"
"};\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d = __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator*=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d *= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator/=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d /= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator\x25=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d \x25= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator+=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d += __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator-=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d -= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator^=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d ^= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator\x26=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d \x26= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator\x7c=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d \x7c= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator<<=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d <<= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"indirect_array<_Tp>\x3a\x3aoperator>>=(const _Expr\x26 __v) const\x0a"
"{\x0a"
"    size_t __n = __1d_.size();\x0a"
"    for (size_t __i = 0; __i < __n; ++__i)\x0a"
"        __vp_\x5b__1d_\x5b__i\x5d\x5d >>= __v\x5b__i\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"const indirect_array<_Tp>\x26\x0a"
"indirect_array<_Tp>\x3a\x3aoperator=(const indirect_array\x26 __ia) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    const value_type* __s = __ia.__vp_;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_, __j = __ia.__1d_.__begin_;\x0a"
"            __i \x21= __e; ++__i, ++__j)\x0a"
"        __vp_\x5b*__i\x5d = __s\x5b*__j\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"void\x0a"
"indirect_array<_Tp>\x3a\x3aoperator=(const value_type\x26 __x) const\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    for (_Ip __i = __1d_.__begin_, __e = __1d_.__end_; __i \x21= __e; ++__i)\x0a"
"        __vp_\x5b*__i\x5d = __x;\x0a"
"}\x0a"
"\x0a"
"template <class _ValExpr>\x0a"
"class __indirect_expr\x0a"
"{\x0a"
"    typedef typename remove_reference<_ValExpr>\x3a\x3atype  _RmExpr;\x0a"
"public\x3a\x0a"
"    typedef typename _RmExpr\x3a\x3avalue_type value_type;\x0a"
"    typedef value_type result_type;\x0a"
"\x0a"
"private\x3a\x0a"
"    _ValExpr __expr_;\x0a"
"    valarray<size_t> __1d_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __indirect_expr(const valarray<size_t>\x26 __ia, const _RmExpr\x26 __e)\x0a"
"        \x3a __expr_(__e),\x0a"
"          __1d_(__ia)\x0a"
"          {}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __indirect_expr(valarray<size_t>\x26\x26 __ia, const _RmExpr\x26 __e)\x0a"
"        \x3a __expr_(__e),\x0a"
"          __1d_(move(__ia))\x0a"
"          {}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator\x5b\x5d(size_t __i) const\x0a"
"        {return __expr_\x5b__1d_\x5b__i\x5d\x5d;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __1d_.size();}\x0a"
"\x0a"
"    template <class> friend class __val_expr;\x0a"
"    template <class> friend class _LIBCPP_TEMPLATE_VIS valarray;\x0a"
"};\x0a"
"\x0a"
"template<class _ValExpr>\x0a"
"class __val_expr\x0a"
"{\x0a"
"    typedef typename remove_reference<_ValExpr>\x3a\x3atype  _RmExpr;\x0a"
"\x0a"
"    _ValExpr __expr_;\x0a"
"public\x3a\x0a"
"    typedef typename _RmExpr\x3a\x3avalue_type value_type;\x0a"
"    typedef typename _RmExpr\x3a\x3aresult_type result_type;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    explicit __val_expr(const _RmExpr\x26 __e) \x3a __expr_(__e) {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type operator\x5b\x5d(size_t __i) const\x0a"
"        {return __expr_\x5b__i\x5d;}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__slice_expr<_ValExpr> > operator\x5b\x5d(slice __s) const\x0a"
"    {\x0a"
"        typedef __slice_expr<_ValExpr> _NewExpr;\x0a"
"        return __val_expr< _NewExpr >(_NewExpr(__s, __expr_));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__indirect_expr<_ValExpr> > operator\x5b\x5d(const gslice\x26 __gs) const\x0a"
"    {\x0a"
"        typedef __indirect_expr<_ValExpr> _NewExpr;\x0a"
"        return __val_expr<_NewExpr >(_NewExpr(__gs.__1d_, __expr_));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__mask_expr<_ValExpr> > operator\x5b\x5d(const valarray<bool>\x26 __vb) const\x0a"
"    {\x0a"
"        typedef __mask_expr<_ValExpr> _NewExpr;\x0a"
"        return __val_expr< _NewExpr >( _NewExpr(__vb, __expr_));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__indirect_expr<_ValExpr> > operator\x5b\x5d(const valarray<size_t>\x26 __vs) const\x0a"
"    {\x0a"
"        typedef __indirect_expr<_ValExpr> _NewExpr;\x0a"
"        return __val_expr< _NewExpr >(_NewExpr(__vs, __expr_));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<_UnaryOp<__unary_plus<value_type>, _ValExpr> >\x0a"
"    operator+() const\x0a"
"    {\x0a"
"        typedef _UnaryOp<__unary_plus<value_type>, _ValExpr> _NewExpr;\x0a"
"        return __val_expr<_NewExpr>(_NewExpr(__unary_plus<value_type>(), __expr_));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<_UnaryOp<negate<value_type>, _ValExpr> >\x0a"
"    operator-() const\x0a"
"    {\x0a"
"        typedef _UnaryOp<negate<value_type>, _ValExpr> _NewExpr;\x0a"
"        return __val_expr<_NewExpr>(_NewExpr(negate<value_type>(), __expr_));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<_UnaryOp<__bit_not<value_type>, _ValExpr> >\x0a"
"    operator\x7e() const\x0a"
"    {\x0a"
"        typedef _UnaryOp<__bit_not<value_type>, _ValExpr> _NewExpr;\x0a"
"        return __val_expr<_NewExpr>(_NewExpr(__bit_not<value_type>(), __expr_));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<_UnaryOp<logical_not<value_type>, _ValExpr> >\x0a"
"    operator\x21() const\x0a"
"    {\x0a"
"        typedef _UnaryOp<logical_not<value_type>, _ValExpr> _NewExpr;\x0a"
"        return __val_expr<_NewExpr>(_NewExpr(logical_not<value_type>(), __expr_));\x0a"
"    }\x0a"
"\x0a"
"    operator valarray<result_type>() const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t size() const {return __expr_.size();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type sum() const\x0a"
"    {\x0a"
"        size_t __n = __expr_.size();\x0a"
"        result_type __r = __n \x3f __expr_\x5b""0\x5d \x3a result_type();\x0a"
"        for (size_t __i = 1; __i < __n; ++__i)\x0a"
"            __r += __expr_\x5b__i\x5d;\x0a"
"        return __r;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type min() const\x0a"
"    {\x0a"
"        size_t __n = size();\x0a"
"        result_type __r = __n \x3f (*this)\x5b""0\x5d \x3a result_type();\x0a"
"        for (size_t __i = 1; __i < __n; ++__i)\x0a"
"        {\x0a"
"            result_type __x = __expr_\x5b__i\x5d;\x0a"
"            if (__x < __r)\x0a"
"                __r = __x;\x0a"
"        }\x0a"
"        return __r;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    result_type max() const\x0a"
"    {\x0a"
"        size_t __n = size();\x0a"
"        result_type __r = __n \x3f (*this)\x5b""0\x5d \x3a result_type();\x0a"
"        for (size_t __i = 1; __i < __n; ++__i)\x0a"
"        {\x0a"
"            result_type __x = __expr_\x5b__i\x5d;\x0a"
"            if (__r < __x)\x0a"
"                __r = __x;\x0a"
"        }\x0a"
"        return __r;\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__shift_expr<_ValExpr> > shift (int __i) const\x0a"
"        {return __val_expr<__shift_expr<_ValExpr> >(__shift_expr<_ValExpr>(__i, __expr_));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<__cshift_expr<_ValExpr> > cshift(int __i) const\x0a"
"        {return __val_expr<__cshift_expr<_ValExpr> >(__cshift_expr<_ValExpr>(__i, __expr_));}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<_UnaryOp<__apply_expr<value_type, value_type(*)(value_type)>, _ValExpr> >\x0a"
"    apply(value_type __f(value_type)) const\x0a"
"    {\x0a"
"        typedef __apply_expr<value_type, value_type(*)(value_type)> _Op;\x0a"
"        typedef _UnaryOp<_Op, _ValExpr> _NewExpr;\x0a"
"        return __val_expr<_NewExpr>(_NewExpr(_Op(__f), __expr_));\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __val_expr<_UnaryOp<__apply_expr<value_type, value_type(*)(const value_type\x26)>, _ValExpr> >\x0a"
"    apply(value_type __f(const value_type\x26)) const\x0a"
"    {\x0a"
"        typedef __apply_expr<value_type, value_type(*)(const value_type\x26)> _Op;\x0a"
"        typedef _UnaryOp<_Op, _ValExpr> _NewExpr;\x0a"
"        return __val_expr<_NewExpr>(_NewExpr(_Op(__f), __expr_));\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"template<class _ValExpr>\x0a"
"__val_expr<_ValExpr>\x3a\x3aoperator valarray<__val_expr\x3a\x3aresult_type>() const\x0a"
"{\x0a"
"    valarray<result_type> __r;\x0a"
"    size_t __n = __expr_.size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __r.__begin_ =\x0a"
"            __r.__end_ =\x0a"
"                static_cast<result_type*>(\x0a"
"                    _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(result_type), _LIBCPP_ALIGNOF(result_type)));\x0a"
"        for (size_t __i = 0; __i \x21= __n; ++__r.__end_, ++__i)\x0a"
"            \x3a\x3anew (__r.__end_) result_type(__expr_\x5b__i\x5d);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"// valarray\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x3a\x3avalarray(size_t __n)\x0a"
"    \x3a __begin_(0),\x0a"
"      __end_(0)\x0a"
"{\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __begin_ = __end_ = static_cast<value_type*>(\x0a"
"            _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (size_t __n_left = __n; __n_left; --__n_left, ++__end_)\x0a"
"                \x3a\x3anew (__end_) value_type();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __clear(__n);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x3a\x3avalarray(const value_type\x26 __x, size_t __n)\x0a"
"    \x3a __begin_(0),\x0a"
"      __end_(0)\x0a"
"{\x0a"
"    resize(__n, __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x3a\x3avalarray(const value_type* __p, size_t __n)\x0a"
"    \x3a __begin_(0),\x0a"
"      __end_(0)\x0a"
"{\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __begin_ = __end_ = static_cast<value_type*>(\x0a"
"            _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (size_t __n_left = __n; __n_left; ++__end_, ++__p, --__n_left)\x0a"
"                \x3a\x3anew (__end_) value_type(*__p);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __clear(__n);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x3a\x3avalarray(const valarray\x26 __v)\x0a"
"    \x3a __begin_(0),\x0a"
"      __end_(0)\x0a"
"{\x0a"
"    if (__v.size())\x0a"
"    {\x0a"
"        __begin_ = __end_ = static_cast<value_type*>(\x0a"
"            _VSTD\x3a\x3a__libcpp_allocate(__v.size() * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (value_type* __p = __v.__begin_; __p \x21= __v.__end_; ++__end_, ++__p)\x0a"
"                \x3a\x3anew (__end_) value_type(*__p);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __clear(__v.size());\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x3a\x3avalarray(valarray\x26\x26 __v) _NOEXCEPT\x0a"
"    \x3a __begin_(__v.__begin_),\x0a"
"      __end_(__v.__end_)\x0a"
"{\x0a"
"    __v.__begin_ = __v.__end_ = nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x3a\x3avalarray(initializer_list<value_type> __il)\x0a"
"    \x3a __begin_(0),\x0a"
"      __end_(0)\x0a"
"{\x0a"
"    const size_t __n = __il.size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __begin_ = __end_ = static_cast<value_type*>(\x0a"
"_VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            size_t __n_left = __n;\x0a"
"            for (const value_type* __p = __il.begin(); __n_left; ++__end_, ++__p, --__n_left)\x0a"
"                \x3a\x3anew (__end_) value_type(*__p);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __clear(__n);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x3a\x3avalarray(const slice_array<value_type>\x26 __sa)\x0a"
"    \x3a __begin_(0),\x0a"
"      __end_(0)\x0a"
"{\x0a"
"    const size_t __n = __sa.__size_;\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __begin_ = __end_ = static_cast<value_type*>(\x0a"
"          _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            size_t __n_left = __n;\x0a"
"            for (const value_type* __p = __sa.__vp_; __n_left; ++__end_, __p += __sa.__stride_, --__n_left)\x0a"
"                \x3a\x3anew (__end_) value_type(*__p);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __clear(__n);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x3a\x3avalarray(const gslice_array<value_type>\x26 __ga)\x0a"
"    \x3a __begin_(0),\x0a"
"      __end_(0)\x0a"
"{\x0a"
"    const size_t __n = __ga.__1d_.size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __begin_ = __end_ = static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            typedef const size_t* _Ip;\x0a"
"            const value_type* __s = __ga.__vp_;\x0a"
"            for (_Ip __i = __ga.__1d_.__begin_, __e = __ga.__1d_.__end_;\x0a"
"                    __i \x21= __e; ++__i, ++__end_)\x0a"
"                \x3a\x3anew (__end_) value_type(__s\x5b*__i\x5d);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __clear(__n);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x3a\x3avalarray(const mask_array<value_type>\x26 __ma)\x0a"
"    \x3a __begin_(0),\x0a"
"      __end_(0)\x0a"
"{\x0a"
"    const size_t __n = __ma.__1d_.size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __begin_ = __end_ = static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            typedef const size_t* _Ip;\x0a"
"            const value_type* __s = __ma.__vp_;\x0a"
"            for (_Ip __i = __ma.__1d_.__begin_, __e = __ma.__1d_.__end_;\x0a"
"                    __i \x21= __e; ++__i, ++__end_)\x0a"
"                \x3a\x3anew (__end_) value_type(__s\x5b*__i\x5d);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __clear(__n);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x3a\x3avalarray(const indirect_array<value_type>\x26 __ia)\x0a"
"    \x3a __begin_(0),\x0a"
"      __end_(0)\x0a"
"{\x0a"
"    const size_t __n = __ia.__1d_.size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __begin_ = __end_ = static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            typedef const size_t* _Ip;\x0a"
"            const value_type* __s = __ia.__vp_;\x0a"
"            for (_Ip __i = __ia.__1d_.__begin_, __e = __ia.__1d_.__end_;\x0a"
"                    __i \x21= __e; ++__i, ++__end_)\x0a"
"                \x3a\x3anew (__end_) value_type(__s\x5b*__i\x5d);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __clear(__n);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x3a\x3a\x7evalarray()\x0a"
"{\x0a"
"    __clear(size());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3a__assign_range(const value_type* __f, const value_type* __l)\x0a"
"{\x0a"
"    size_t __n = __l - __f;\x0a"
"    if (size() \x21= __n)\x0a"
"    {\x0a"
"        __clear(size());\x0a"
"        __begin_ = static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"        __end_ = __begin_ + __n;\x0a"
"        _VSTD\x3a\x3auninitialized_copy(__f, __l, __begin_);\x0a"
"    } else {\x0a"
"        _VSTD\x3a\x3a""copy(__f, __l, __begin_);\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator=(const valarray\x26 __v)\x0a"
"{\x0a"
"    if (this \x21= \x26__v)\x0a"
"        return __assign_range(__v.__begin_, __v.__end_);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator=(valarray\x26\x26 __v) _NOEXCEPT\x0a"
"{\x0a"
"    __clear(size());\x0a"
"    __begin_ = __v.__begin_;\x0a"
"    __end_ = __v.__end_;\x0a"
"    __v.__begin_ = nullptr;\x0a"
"    __v.__end_ = nullptr;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator=(initializer_list<value_type> __il)\x0a"
"{\x0a"
"    return __assign_range(__il.begin(), __il.end());\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator=(const value_type\x26 __x)\x0a"
"{\x0a"
"    _VSTD\x3a\x3a""fill(__begin_, __end_, __x);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator=(const slice_array<value_type>\x26 __sa)\x0a"
"{\x0a"
"    value_type* __t = __begin_;\x0a"
"    const value_type* __s = __sa.__vp_;\x0a"
"    for (size_t __n = __sa.__size_; __n; --__n, __s += __sa.__stride_, ++__t)\x0a"
"        *__t = *__s;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator=(const gslice_array<value_type>\x26 __ga)\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    value_type* __t = __begin_;\x0a"
"    const value_type* __s = __ga.__vp_;\x0a"
"    for (_Ip __i = __ga.__1d_.__begin_, __e = __ga.__1d_.__end_;\x0a"
"                    __i \x21= __e; ++__i, ++__t)\x0a"
"        *__t = __s\x5b*__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator=(const mask_array<value_type>\x26 __ma)\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    value_type* __t = __begin_;\x0a"
"    const value_type* __s = __ma.__vp_;\x0a"
"    for (_Ip __i = __ma.__1d_.__begin_, __e = __ma.__1d_.__end_;\x0a"
"                    __i \x21= __e; ++__i, ++__t)\x0a"
"        *__t = __s\x5b*__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator=(const indirect_array<value_type>\x26 __ia)\x0a"
"{\x0a"
"    typedef const size_t* _Ip;\x0a"
"    value_type* __t = __begin_;\x0a"
"    const value_type* __s = __ia.__vp_;\x0a"
"    for (_Ip __i = __ia.__1d_.__begin_, __e = __ia.__1d_.__end_;\x0a"
"                    __i \x21= __e; ++__i, ++__t)\x0a"
"        *__t = __s\x5b*__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _ValExpr>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator=(const __val_expr<_ValExpr>\x26 __v)\x0a"
"{\x0a"
"    size_t __n = __v.size();\x0a"
"    if (size() \x21= __n)\x0a"
"        resize(__n);\x0a"
"    value_type* __t = __begin_;\x0a"
"    for (size_t __i = 0; __i \x21= __n; ++__t, ++__i)\x0a"
"        *__t = result_type(__v\x5b__i\x5d);\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"__val_expr<__slice_expr<const valarray<_Tp>\x26> >\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(slice __s) const\x0a"
"{\x0a"
"    return __val_expr<__slice_expr<const valarray\x26> >(__slice_expr<const valarray\x26>(__s, *this));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"slice_array<_Tp>\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(slice __s)\x0a"
"{\x0a"
"    return slice_array<value_type>(__s, *this);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"__val_expr<__indirect_expr<const valarray<_Tp>\x26> >\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(const gslice\x26 __gs) const\x0a"
"{\x0a"
"    return __val_expr<__indirect_expr<const valarray\x26> >(__indirect_expr<const valarray\x26>(__gs.__1d_, *this));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"gslice_array<_Tp>\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(const gslice\x26 __gs)\x0a"
"{\x0a"
"    return gslice_array<value_type>(__gs, *this);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"__val_expr<__indirect_expr<const valarray<_Tp>\x26> >\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(gslice\x26\x26 __gs) const\x0a"
"{\x0a"
"    return __val_expr<__indirect_expr<const valarray\x26> >(__indirect_expr<const valarray\x26>(move(__gs.__1d_), *this));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"gslice_array<_Tp>\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(gslice\x26\x26 __gs)\x0a"
"{\x0a"
"    return gslice_array<value_type>(move(__gs), *this);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"__val_expr<__mask_expr<const valarray<_Tp>\x26> >\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(const valarray<bool>\x26 __vb) const\x0a"
"{\x0a"
"    return __val_expr<__mask_expr<const valarray\x26> >(__mask_expr<const valarray\x26>(__vb, *this));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"mask_array<_Tp>\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(const valarray<bool>\x26 __vb)\x0a"
"{\x0a"
"    return mask_array<value_type>(__vb, *this);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"__val_expr<__mask_expr<const valarray<_Tp>\x26> >\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(valarray<bool>\x26\x26 __vb) const\x0a"
"{\x0a"
"    return __val_expr<__mask_expr<const valarray\x26> >(__mask_expr<const valarray\x26>(move(__vb), *this));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"mask_array<_Tp>\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(valarray<bool>\x26\x26 __vb)\x0a"
"{\x0a"
"    return mask_array<value_type>(move(__vb), *this);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"__val_expr<__indirect_expr<const valarray<_Tp>\x26> >\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(const valarray<size_t>\x26 __vs) const\x0a"
"{\x0a"
"    return __val_expr<__indirect_expr<const valarray\x26> >(__indirect_expr<const valarray\x26>(__vs, *this));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"indirect_array<_Tp>\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(const valarray<size_t>\x26 __vs)\x0a"
"{\x0a"
"    return indirect_array<value_type>(__vs, *this);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"__val_expr<__indirect_expr<const valarray<_Tp>\x26> >\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(valarray<size_t>\x26\x26 __vs) const\x0a"
"{\x0a"
"    return __val_expr<__indirect_expr<const valarray\x26> >(__indirect_expr<const valarray\x26>(move(__vs), *this));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"indirect_array<_Tp>\x0a"
"valarray<_Tp>\x3a\x3aoperator\x5b\x5d(valarray<size_t>\x26\x26 __vs)\x0a"
"{\x0a"
"    return indirect_array<value_type>(move(__vs), *this);\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x0a"
"valarray<_Tp>\x3a\x3aoperator+() const\x0a"
"{\x0a"
"    valarray<value_type> __r;\x0a"
"    size_t __n = size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __r.__begin_ =\x0a"
"            __r.__end_ =\x0a"
"                static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"        for (const value_type* __p = __begin_; __n; ++__r.__end_, ++__p, --__n)\x0a"
"            \x3a\x3anew (__r.__end_) value_type(+*__p);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x0a"
"valarray<_Tp>\x3a\x3aoperator-() const\x0a"
"{\x0a"
"    valarray<value_type> __r;\x0a"
"    size_t __n = size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __r.__begin_ =\x0a"
"            __r.__end_ =\x0a"
"                static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"        for (const value_type* __p = __begin_; __n; ++__r.__end_, ++__p, --__n)\x0a"
"            \x3a\x3anew (__r.__end_) value_type(-*__p);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x0a"
"valarray<_Tp>\x3a\x3aoperator\x7e() const\x0a"
"{\x0a"
"    valarray<value_type> __r;\x0a"
"    size_t __n = size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __r.__begin_ =\x0a"
"            __r.__end_ =\x0a"
"                static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"        for (const value_type* __p = __begin_; __n; ++__r.__end_, ++__p, --__n)\x0a"
"            \x3a\x3anew (__r.__end_) value_type(\x7e*__p);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<bool>\x0a"
"valarray<_Tp>\x3a\x3aoperator\x21() const\x0a"
"{\x0a"
"    valarray<bool> __r;\x0a"
"    size_t __n = size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __r.__begin_ =\x0a"
"            __r.__end_ =\x0a"
"                static_cast<bool*>(_VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(bool), _LIBCPP_ALIGNOF(bool)));\x0a"
"        for (const value_type* __p = __begin_; __n; ++__r.__end_, ++__p, --__n)\x0a"
"            \x3a\x3anew (__r.__end_) bool(\x21*__p);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator*=(const value_type\x26 __x)\x0a"
"{\x0a"
"    for (value_type* __p = __begin_; __p \x21= __end_; ++__p)\x0a"
"        *__p *= __x;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator/=(const value_type\x26 __x)\x0a"
"{\x0a"
"    for (value_type* __p = __begin_; __p \x21= __end_; ++__p)\x0a"
"        *__p /= __x;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator\x25=(const value_type\x26 __x)\x0a"
"{\x0a"
"    for (value_type* __p = __begin_; __p \x21= __end_; ++__p)\x0a"
"        *__p \x25= __x;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator+=(const value_type\x26 __x)\x0a"
"{\x0a"
"    for (value_type* __p = __begin_; __p \x21= __end_; ++__p)\x0a"
"        *__p += __x;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator-=(const value_type\x26 __x)\x0a"
"{\x0a"
"    for (value_type* __p = __begin_; __p \x21= __end_; ++__p)\x0a"
"        *__p -= __x;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator^=(const value_type\x26 __x)\x0a"
"{\x0a"
"    for (value_type* __p = __begin_; __p \x21= __end_; ++__p)\x0a"
"        *__p ^= __x;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator\x26=(const value_type\x26 __x)\x0a"
"{\x0a"
"    for (value_type* __p = __begin_; __p \x21= __end_; ++__p)\x0a"
"        *__p \x26= __x;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator\x7c=(const value_type\x26 __x)\x0a"
"{\x0a"
"    for (value_type* __p = __begin_; __p \x21= __end_; ++__p)\x0a"
"        *__p \x7c= __x;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator<<=(const value_type\x26 __x)\x0a"
"{\x0a"
"    for (value_type* __p = __begin_; __p \x21= __end_; ++__p)\x0a"
"        *__p <<= __x;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"valarray<_Tp>\x26\x0a"
"valarray<_Tp>\x3a\x3aoperator>>=(const value_type\x26 __x)\x0a"
"{\x0a"
"    for (value_type* __p = __begin_; __p \x21= __end_; ++__p)\x0a"
"        *__p >>= __x;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    valarray<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"valarray<_Tp>\x3a\x3aoperator*=(const _Expr\x26 __v)\x0a"
"{\x0a"
"    size_t __i = 0;\x0a"
"    for (value_type* __t = __begin_; __t \x21= __end_ ; ++__t, ++__i)\x0a"
"        *__t *= __v\x5b__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    valarray<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"valarray<_Tp>\x3a\x3aoperator/=(const _Expr\x26 __v)\x0a"
"{\x0a"
"    size_t __i = 0;\x0a"
"    for (value_type* __t = __begin_; __t \x21= __end_ ; ++__t, ++__i)\x0a"
"        *__t /= __v\x5b__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    valarray<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"valarray<_Tp>\x3a\x3aoperator\x25=(const _Expr\x26 __v)\x0a"
"{\x0a"
"    size_t __i = 0;\x0a"
"    for (value_type* __t = __begin_; __t \x21= __end_ ; ++__t, ++__i)\x0a"
"        *__t \x25= __v\x5b__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    valarray<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"valarray<_Tp>\x3a\x3aoperator+=(const _Expr\x26 __v)\x0a"
"{\x0a"
"    size_t __i = 0;\x0a"
"    for (value_type* __t = __begin_; __t \x21= __end_ ; ++__t, ++__i)\x0a"
"        *__t += __v\x5b__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    valarray<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"valarray<_Tp>\x3a\x3aoperator-=(const _Expr\x26 __v)\x0a"
"{\x0a"
"    size_t __i = 0;\x0a"
"    for (value_type* __t = __begin_; __t \x21= __end_ ; ++__t, ++__i)\x0a"
"        *__t -= __v\x5b__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    valarray<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"valarray<_Tp>\x3a\x3aoperator^=(const _Expr\x26 __v)\x0a"
"{\x0a"
"    size_t __i = 0;\x0a"
"    for (value_type* __t = __begin_; __t \x21= __end_ ; ++__t, ++__i)\x0a"
"        *__t ^= __v\x5b__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    valarray<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"valarray<_Tp>\x3a\x3aoperator\x7c=(const _Expr\x26 __v)\x0a"
"{\x0a"
"    size_t __i = 0;\x0a"
"    for (value_type* __t = __begin_; __t \x21= __end_ ; ++__t, ++__i)\x0a"
"        *__t \x7c= __v\x5b__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    valarray<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"valarray<_Tp>\x3a\x3aoperator\x26=(const _Expr\x26 __v)\x0a"
"{\x0a"
"    size_t __i = 0;\x0a"
"    for (value_type* __t = __begin_; __t \x21= __end_ ; ++__t, ++__i)\x0a"
"        *__t \x26= __v\x5b__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    valarray<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"valarray<_Tp>\x3a\x3aoperator<<=(const _Expr\x26 __v)\x0a"
"{\x0a"
"    size_t __i = 0;\x0a"
"    for (value_type* __t = __begin_; __t \x21= __end_ ; ++__t, ++__i)\x0a"
"        *__t <<= __v\x5b__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"template <class _Expr>\x0a"
"inline\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    valarray<_Tp>\x26\x0a"
">\x3a\x3atype\x0a"
"valarray<_Tp>\x3a\x3aoperator>>=(const _Expr\x26 __v)\x0a"
"{\x0a"
"    size_t __i = 0;\x0a"
"    for (value_type* __t = __begin_; __t \x21= __end_ ; ++__t, ++__i)\x0a"
"        *__t >>= __v\x5b__i\x5d;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"void\x0a"
"valarray<_Tp>\x3a\x3aswap(valarray\x26 __v) _NOEXCEPT\x0a"
"{\x0a"
"    _VSTD\x3a\x3aswap(__begin_, __v.__begin_);\x0a"
"    _VSTD\x3a\x3aswap(__end_, __v.__end_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"_Tp\x0a"
"valarray<_Tp>\x3a\x3asum() const\x0a"
"{\x0a"
"    if (__begin_ == __end_)\x0a"
"        return value_type();\x0a"
"    const value_type* __p = __begin_;\x0a"
"    _Tp __r = *__p;\x0a"
"    for (++__p; __p \x21= __end_; ++__p)\x0a"
"        __r += *__p;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"_Tp\x0a"
"valarray<_Tp>\x3a\x3amin() const\x0a"
"{\x0a"
"    if (__begin_ == __end_)\x0a"
"        return value_type();\x0a"
"    return *_VSTD\x3a\x3amin_element(__begin_, __end_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"_Tp\x0a"
"valarray<_Tp>\x3a\x3amax() const\x0a"
"{\x0a"
"    if (__begin_ == __end_)\x0a"
"        return value_type();\x0a"
"    return *_VSTD\x3a\x3amax_element(__begin_, __end_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x0a"
"valarray<_Tp>\x3a\x3ashift(int __i) const\x0a"
"{\x0a"
"    valarray<value_type> __r;\x0a"
"    size_t __n = size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __r.__begin_ =\x0a"
"            __r.__end_ =\x0a"
"                static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"        const value_type* __sb;\x0a"
"        value_type* __tb;\x0a"
"        value_type* __te;\x0a"
"        if (__i >= 0)\x0a"
"        {\x0a"
"            __i = _VSTD\x3a\x3amin(__i, static_cast<int>(__n));\x0a"
"            __sb = __begin_ + __i;\x0a"
"            __tb = __r.__begin_;\x0a"
"            __te = __r.__begin_ + (__n - __i);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __i = _VSTD\x3a\x3amin(-__i, static_cast<int>(__n));\x0a"
"            __sb = __begin_;\x0a"
"            __tb = __r.__begin_ + __i;\x0a"
"            __te = __r.__begin_ + __n;\x0a"
"        }\x0a"
"        for (; __r.__end_ \x21= __tb; ++__r.__end_)\x0a"
"            \x3a\x3anew (__r.__end_) value_type();\x0a"
"        for (; __r.__end_ \x21= __te; ++__r.__end_, ++__sb)\x0a"
"            \x3a\x3anew (__r.__end_) value_type(*__sb);\x0a"
"        for (__te = __r.__begin_ + __n; __r.__end_ \x21= __te; ++__r.__end_)\x0a"
"            \x3a\x3anew (__r.__end_) value_type();\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x0a"
"valarray<_Tp>\x3a\x3a""cshift(int __i) const\x0a"
"{\x0a"
"    valarray<value_type> __r;\x0a"
"    size_t __n = size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __r.__begin_ =\x0a"
"            __r.__end_ =\x0a"
"                static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"        __i \x25= static_cast<int>(__n);\x0a"
"        const value_type* __m = __i >= 0 \x3f __begin_ + __i \x3a __end_ + __i;\x0a"
"        for (const value_type* __s = __m; __s \x21= __end_; ++__r.__end_, ++__s)\x0a"
"            \x3a\x3anew (__r.__end_) value_type(*__s);\x0a"
"        for (const value_type* __s = __begin_; __s \x21= __m; ++__r.__end_, ++__s)\x0a"
"            \x3a\x3anew (__r.__end_) value_type(*__s);\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x0a"
"valarray<_Tp>\x3a\x3a""apply(value_type __f(value_type)) const\x0a"
"{\x0a"
"    valarray<value_type> __r;\x0a"
"    size_t __n = size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __r.__begin_ =\x0a"
"            __r.__end_ =\x0a"
"                static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"        for (const value_type* __p = __begin_; __n; ++__r.__end_, ++__p, --__n)\x0a"
"            \x3a\x3anew (__r.__end_) value_type(__f(*__p));\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"valarray<_Tp>\x0a"
"valarray<_Tp>\x3a\x3a""apply(value_type __f(const value_type\x26)) const\x0a"
"{\x0a"
"    valarray<value_type> __r;\x0a"
"    size_t __n = size();\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __r.__begin_ =\x0a"
"            __r.__end_ =\x0a"
"                static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"        for (const value_type* __p = __begin_; __n; ++__r.__end_, ++__p, --__n)\x0a"
"            \x3a\x3anew (__r.__end_) value_type(__f(*__p));\x0a"
"    }\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline\x0a"
"void valarray<_Tp>\x3a\x3a__clear(size_t __capacity)\x0a"
"{\x0a"
"  if (__begin_ \x21= nullptr)\x0a"
"  {\x0a"
"    while (__end_ \x21= __begin_)\x0a"
"      (--__end_)->\x7evalue_type();\x0a"
"    _VSTD\x3a\x3a__libcpp_deallocate(__begin_, __capacity * sizeof(value_type), _LIBCPP_ALIGNOF(value_type));\x0a"
"    __begin_ = __end_ = nullptr;\x0a"
"  }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"void\x0a"
"valarray<_Tp>\x3a\x3aresize(size_t __n, value_type __x)\x0a"
"{\x0a"
"    __clear(size());\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        __begin_ = __end_ = static_cast<value_type*>(\x0a"
"           _VSTD\x3a\x3a__libcpp_allocate(__n * sizeof(value_type), _LIBCPP_ALIGNOF(value_type)));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            for (size_t __n_left = __n; __n_left; --__n_left, ++__end_)\x0a"
"                \x3a\x3anew (__end_) value_type(__x);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            __clear(__n);\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template<class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(valarray<_Tp>\x26 __x, valarray<_Tp>\x26 __y) _NOEXCEPT\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<multiplies<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator*(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<multiplies<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(multiplies<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<multiplies<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator*(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<multiplies<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(multiplies<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<multiplies<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator*(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<multiplies<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(multiplies<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<divides<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator/(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<divides<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(divides<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<divides<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator/(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<divides<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(divides<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<divides<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator/(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<divides<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(divides<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<modulus<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator\x25(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<modulus<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(modulus<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<modulus<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator\x25(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<modulus<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(modulus<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<modulus<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator\x25(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<modulus<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(modulus<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<plus<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator+(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<plus<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(plus<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<plus<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator+(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<plus<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(plus<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<plus<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator+(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<plus<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(plus<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<minus<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator-(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<minus<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(minus<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<minus<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator-(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<minus<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(minus<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<minus<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator-(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<minus<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(minus<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<bit_xor<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator^(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<bit_xor<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(bit_xor<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<bit_xor<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator^(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<bit_xor<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(bit_xor<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<bit_xor<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator^(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<bit_xor<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(bit_xor<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<bit_and<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator\x26(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<bit_and<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(bit_and<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<bit_and<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator\x26(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<bit_and<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(bit_and<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<bit_and<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator\x26(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<bit_and<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(bit_and<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<bit_or<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator\x7c(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<bit_or<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(bit_or<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<bit_or<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator\x7c(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<bit_or<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(bit_or<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<bit_or<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator\x7c(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<bit_or<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(bit_or<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__bit_shift_left<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator<<(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__bit_shift_left<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__bit_shift_left<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__bit_shift_left<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator<<(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__bit_shift_left<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(__bit_shift_left<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__bit_shift_left<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator<<(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__bit_shift_left<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__bit_shift_left<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__bit_shift_right<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator>>(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__bit_shift_right<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__bit_shift_right<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__bit_shift_right<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator>>(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__bit_shift_right<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(__bit_shift_right<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__bit_shift_right<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator>>(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__bit_shift_right<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__bit_shift_right<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<logical_and<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator\x26\x26(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<logical_and<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(logical_and<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<logical_and<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator\x26\x26(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<logical_and<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(logical_and<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<logical_and<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator\x26\x26(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<logical_and<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(logical_and<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<logical_or<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator\x7c\x7c(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<logical_or<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(logical_or<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<logical_or<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator\x7c\x7c(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<logical_or<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(logical_or<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<logical_or<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator\x7c\x7c(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<logical_or<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(logical_or<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<equal_to<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator==(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<equal_to<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(equal_to<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<equal_to<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator==(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<equal_to<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(equal_to<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<equal_to<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator==(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<equal_to<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(equal_to<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<not_equal_to<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator\x21=(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<not_equal_to<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(not_equal_to<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<not_equal_to<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator\x21=(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<not_equal_to<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(not_equal_to<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<not_equal_to<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator\x21=(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<not_equal_to<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(not_equal_to<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<less<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator<(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<less<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(less<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<less<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator<(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<less<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(less<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<less<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator<(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<less<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(less<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<greater<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator>(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<greater<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(greater<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<greater<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator>(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<greater<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(greater<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<greater<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator>(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<greater<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(greater<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<less_equal<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator<=(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<less_equal<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(less_equal<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<less_equal<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator<=(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<less_equal<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(less_equal<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<less_equal<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator<=(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<less_equal<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(less_equal<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<greater_equal<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"operator>=(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<greater_equal<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(greater_equal<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<greater_equal<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"operator>=(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<greater_equal<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(greater_equal<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<greater_equal<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"operator>=(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<greater_equal<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(greater_equal<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__abs_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"abs(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__abs_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__abs_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__acos_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"acos(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__acos_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__acos_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__asin_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"asin(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__asin_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__asin_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__atan_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"atan(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__atan_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__atan_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__atan2_expr<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"atan2(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__atan2_expr<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__atan2_expr<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__atan2_expr<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"atan2(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__atan2_expr<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(__atan2_expr<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__atan2_expr<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"atan2(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__atan2_expr<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__atan2_expr<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__cos_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"cos(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__cos_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__cos_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__cosh_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"cosh(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__cosh_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__cosh_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__exp_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"exp(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__exp_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__exp_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__log_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"log(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__log_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__log_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__log10_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"log10(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__log10_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__log10_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr1, class _Expr2>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr1>\x3a\x3avalue \x26\x26 __is_val_expr<_Expr2>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__pow_expr<typename _Expr1\x3a\x3avalue_type>, _Expr1, _Expr2> >\x0a"
">\x3a\x3atype\x0a"
"pow(const _Expr1\x26 __x, const _Expr2\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr1\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__pow_expr<value_type>, _Expr1, _Expr2> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__pow_expr<value_type>(), __x, __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__pow_expr<typename _Expr\x3a\x3avalue_type>,\x0a"
"               _Expr, __scalar_expr<typename _Expr\x3a\x3avalue_type> > >\x0a"
">\x3a\x3atype\x0a"
"pow(const _Expr\x26 __x, const typename _Expr\x3a\x3avalue_type\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__pow_expr<value_type>, _Expr, __scalar_expr<value_type> > _Op;\x0a"
"    return __val_expr<_Op>(_Op(__pow_expr<value_type>(),\x0a"
"                           __x, __scalar_expr<value_type>(__y, __x.size())));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_BinaryOp<__pow_expr<typename _Expr\x3a\x3avalue_type>,\x0a"
"               __scalar_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"pow(const typename _Expr\x3a\x3avalue_type\x26 __x, const _Expr\x26 __y)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _BinaryOp<__pow_expr<value_type>, __scalar_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__pow_expr<value_type>(),\x0a"
"                           __scalar_expr<value_type>(__x, __y.size()), __y));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__sin_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"sin(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__sin_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__sin_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__sinh_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"sinh(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__sinh_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__sinh_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__sqrt_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"sqrt(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__sqrt_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__sqrt_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__tan_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"tan(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__tan_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__tan_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template<class _Expr>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_val_expr<_Expr>\x3a\x3avalue,\x0a"
"    __val_expr<_UnaryOp<__tanh_expr<typename _Expr\x3a\x3avalue_type>, _Expr> >\x0a"
">\x3a\x3atype\x0a"
"tanh(const _Expr\x26 __x)\x0a"
"{\x0a"
"    typedef typename _Expr\x3a\x3avalue_type value_type;\x0a"
"    typedef _UnaryOp<__tanh_expr<value_type>, _Expr> _Op;\x0a"
"    return __val_expr<_Op>(_Op(__tanh_expr<value_type>(), __x));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"begin(valarray<_Tp>\x26 __v)\x0a"
"{\x0a"
"    return __v.__begin_;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"const _Tp*\x0a"
"begin(const valarray<_Tp>\x26 __v)\x0a"
"{\x0a"
"    return __v.__begin_;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"_Tp*\x0a"
"end(valarray<_Tp>\x26 __v)\x0a"
"{\x0a"
"    return __v.__end_;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"const _Tp*\x0a"
"end(const valarray<_Tp>\x26 __v)\x0a"
"{\x0a"
"    return __v.__end_;\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_VALARRAY\x0a"
"", 135840 ); }