#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_include_vector( 
"// -*- C++ -*-\x0a"
"//===------------------------------ vector --------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"#ifndef _LIBCPP_VECTOR\x0a"
"#define _LIBCPP_VECTOR\x0a"
"\x0a"
"/*\x0a"
"    vector synopsis\x0a"
"\x0a"
"namespace std\x0a"
"{\x0a"
"\x0a"
"template <class T, class Allocator = allocator<T> >\x0a"
"class vector\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef T                                        value_type;\x0a"
"    typedef Allocator                                allocator_type;\x0a"
"    typedef typename allocator_type\x3a\x3areference       reference;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_reference const_reference;\x0a"
"    typedef implementation-defined                   iterator;\x0a"
"    typedef implementation-defined                   const_iterator;\x0a"
"    typedef typename allocator_type\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_type\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename allocator_type\x3a\x3apointer         pointer;\x0a"
"    typedef typename allocator_type\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator>          reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator>    const_reverse_iterator;\x0a"
"\x0a"
"    vector()\x0a"
"        noexcept(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    explicit vector(const allocator_type\x26);\x0a"
"    explicit vector(size_type n);\x0a"
"    explicit vector(size_type n, const allocator_type\x26); // C++14\x0a"
"    vector(size_type n, const value_type\x26 value, const allocator_type\x26 = allocator_type());\x0a"
"    template <class InputIterator>\x0a"
"        vector(InputIterator first, InputIterator last, const allocator_type\x26 = allocator_type());\x0a"
"    vector(const vector\x26 x);\x0a"
"    vector(vector\x26\x26 x)\x0a"
"        noexcept(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    vector(initializer_list<value_type> il);\x0a"
"    vector(initializer_list<value_type> il, const allocator_type\x26 a);\x0a"
"    \x7evector();\x0a"
"    vector\x26 operator=(const vector\x26 x);\x0a"
"    vector\x26 operator=(vector\x26\x26 x)\x0a"
"        noexcept(\x0a"
"             allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"             allocator_type\x3a\x3ais_always_equal\x3a\x3avalue); // C++17\x0a"
"    vector\x26 operator=(initializer_list<value_type> il);\x0a"
"    template <class InputIterator>\x0a"
"        void assign(InputIterator first, InputIterator last);\x0a"
"    void assign(size_type n, const value_type\x26 u);\x0a"
"    void assign(initializer_list<value_type> il);\x0a"
"\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"\x0a"
"    iterator               begin() noexcept;\x0a"
"    const_iterator         begin()   const noexcept;\x0a"
"    iterator               end() noexcept;\x0a"
"    const_iterator         end()     const noexcept;\x0a"
"\x0a"
"    reverse_iterator       rbegin() noexcept;\x0a"
"    const_reverse_iterator rbegin()  const noexcept;\x0a"
"    reverse_iterator       rend() noexcept;\x0a"
"    const_reverse_iterator rend()    const noexcept;\x0a"
"\x0a"
"    const_iterator         cbegin()  const noexcept;\x0a"
"    const_iterator         cend()    const noexcept;\x0a"
"    const_reverse_iterator crbegin() const noexcept;\x0a"
"    const_reverse_iterator crend()   const noexcept;\x0a"
"\x0a"
"    size_type size() const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"    size_type capacity() const noexcept;\x0a"
"    bool empty() const noexcept;\x0a"
"    void reserve(size_type n);\x0a"
"    void shrink_to_fit() noexcept;\x0a"
"\x0a"
"    reference       operator\x5b\x5d(size_type n);\x0a"
"    const_reference operator\x5b\x5d(size_type n) const;\x0a"
"    reference       at(size_type n);\x0a"
"    const_reference at(size_type n) const;\x0a"
"\x0a"
"    reference       front();\x0a"
"    const_reference front() const;\x0a"
"    reference       back();\x0a"
"    const_reference back() const;\x0a"
"\x0a"
"    value_type*       data() noexcept;\x0a"
"    const value_type* data() const noexcept;\x0a"
"\x0a"
"    void push_back(const value_type\x26 x);\x0a"
"    void push_back(value_type\x26\x26 x);\x0a"
"    template <class... Args>\x0a"
"        reference emplace_back(Args\x26\x26... args); // reference in C++17\x0a"
"    void pop_back();\x0a"
"\x0a"
"    template <class... Args> iterator emplace(const_iterator position, Args\x26\x26... args);\x0a"
"    iterator insert(const_iterator position, const value_type\x26 x);\x0a"
"    iterator insert(const_iterator position, value_type\x26\x26 x);\x0a"
"    iterator insert(const_iterator position, size_type n, const value_type\x26 x);\x0a"
"    template <class InputIterator>\x0a"
"        iterator insert(const_iterator position, InputIterator first, InputIterator last);\x0a"
"    iterator insert(const_iterator position, initializer_list<value_type> il);\x0a"
"\x0a"
"    iterator erase(const_iterator position);\x0a"
"    iterator erase(const_iterator first, const_iterator last);\x0a"
"\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    void resize(size_type sz);\x0a"
"    void resize(size_type sz, const value_type\x26 c);\x0a"
"\x0a"
"    void swap(vector\x26)\x0a"
"        noexcept(allocator_traits<allocator_type>\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                 allocator_traits<allocator_type>\x3a\x3ais_always_equal\x3a\x3avalue);  // C++17\x0a"
"\x0a"
"    bool __invariants() const;\x0a"
"};\x0a"
"\x0a"
"template <class Allocator = allocator<T> >\x0a"
"class vector<bool, Allocator>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef bool                                     value_type;\x0a"
"    typedef Allocator                                allocator_type;\x0a"
"    typedef implementation-defined                   iterator;\x0a"
"    typedef implementation-defined                   const_iterator;\x0a"
"    typedef typename allocator_type\x3a\x3asize_type       size_type;\x0a"
"    typedef typename allocator_type\x3a\x3a""difference_type difference_type;\x0a"
"    typedef iterator                                 pointer;\x0a"
"    typedef const_iterator                           const_pointer;\x0a"
"    typedef std\x3a\x3areverse_iterator<iterator>          reverse_iterator;\x0a"
"    typedef std\x3a\x3areverse_iterator<const_iterator>    const_reverse_iterator;\x0a"
"\x0a"
"    class reference\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        reference(const reference\x26) noexcept;\x0a"
"        operator bool() const noexcept;\x0a"
"        reference\x26 operator=(const bool x) noexcept;\x0a"
"        reference\x26 operator=(const reference\x26 x) noexcept;\x0a"
"        iterator operator\x26() const noexcept;\x0a"
"        void flip() noexcept;\x0a"
"    };\x0a"
"\x0a"
"    class const_reference\x0a"
"    {\x0a"
"    public\x3a\x0a"
"        const_reference(const reference\x26) noexcept;\x0a"
"        operator bool() const noexcept;\x0a"
"        const_iterator operator\x26() const noexcept;\x0a"
"    };\x0a"
"\x0a"
"    vector()\x0a"
"        noexcept(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    explicit vector(const allocator_type\x26);\x0a"
"    explicit vector(size_type n, const allocator_type\x26 a = allocator_type()); // C++14\x0a"
"    vector(size_type n, const value_type\x26 value, const allocator_type\x26 = allocator_type());\x0a"
"    template <class InputIterator>\x0a"
"        vector(InputIterator first, InputIterator last, const allocator_type\x26 = allocator_type());\x0a"
"    vector(const vector\x26 x);\x0a"
"    vector(vector\x26\x26 x)\x0a"
"        noexcept(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    vector(initializer_list<value_type> il);\x0a"
"    vector(initializer_list<value_type> il, const allocator_type\x26 a);\x0a"
"    \x7evector();\x0a"
"    vector\x26 operator=(const vector\x26 x);\x0a"
"    vector\x26 operator=(vector\x26\x26 x)\x0a"
"        noexcept(\x0a"
"             allocator_type\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"             allocator_type\x3a\x3ais_always_equal\x3a\x3avalue); // C++17\x0a"
"    vector\x26 operator=(initializer_list<value_type> il);\x0a"
"    template <class InputIterator>\x0a"
"        void assign(InputIterator first, InputIterator last);\x0a"
"    void assign(size_type n, const value_type\x26 u);\x0a"
"    void assign(initializer_list<value_type> il);\x0a"
"\x0a"
"    allocator_type get_allocator() const noexcept;\x0a"
"\x0a"
"    iterator               begin() noexcept;\x0a"
"    const_iterator         begin()   const noexcept;\x0a"
"    iterator               end() noexcept;\x0a"
"    const_iterator         end()     const noexcept;\x0a"
"\x0a"
"    reverse_iterator       rbegin() noexcept;\x0a"
"    const_reverse_iterator rbegin()  const noexcept;\x0a"
"    reverse_iterator       rend() noexcept;\x0a"
"    const_reverse_iterator rend()    const noexcept;\x0a"
"\x0a"
"    const_iterator         cbegin()  const noexcept;\x0a"
"    const_iterator         cend()    const noexcept;\x0a"
"    const_reverse_iterator crbegin() const noexcept;\x0a"
"    const_reverse_iterator crend()   const noexcept;\x0a"
"\x0a"
"    size_type size() const noexcept;\x0a"
"    size_type max_size() const noexcept;\x0a"
"    size_type capacity() const noexcept;\x0a"
"    bool empty() const noexcept;\x0a"
"    void reserve(size_type n);\x0a"
"    void shrink_to_fit() noexcept;\x0a"
"\x0a"
"    reference       operator\x5b\x5d(size_type n);\x0a"
"    const_reference operator\x5b\x5d(size_type n) const;\x0a"
"    reference       at(size_type n);\x0a"
"    const_reference at(size_type n) const;\x0a"
"\x0a"
"    reference       front();\x0a"
"    const_reference front() const;\x0a"
"    reference       back();\x0a"
"    const_reference back() const;\x0a"
"\x0a"
"    void push_back(const value_type\x26 x);\x0a"
"    template <class... Args> reference emplace_back(Args\x26\x26... args);  // C++14; reference in C++17\x0a"
"    void pop_back();\x0a"
"\x0a"
"    template <class... Args> iterator emplace(const_iterator position, Args\x26\x26... args);  // C++14\x0a"
"    iterator insert(const_iterator position, const value_type\x26 x);\x0a"
"    iterator insert(const_iterator position, size_type n, const value_type\x26 x);\x0a"
"    template <class InputIterator>\x0a"
"        iterator insert(const_iterator position, InputIterator first, InputIterator last);\x0a"
"    iterator insert(const_iterator position, initializer_list<value_type> il);\x0a"
"\x0a"
"    iterator erase(const_iterator position);\x0a"
"    iterator erase(const_iterator first, const_iterator last);\x0a"
"\x0a"
"    void clear() noexcept;\x0a"
"\x0a"
"    void resize(size_type sz);\x0a"
"    void resize(size_type sz, value_type x);\x0a"
"\x0a"
"    void swap(vector\x26)\x0a"
"        noexcept(allocator_traits<allocator_type>\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                 allocator_traits<allocator_type>\x3a\x3ais_always_equal\x3a\x3avalue);  // C++17\x0a"
"    void flip() noexcept;\x0a"
"\x0a"
"    bool __invariants() const;\x0a"
"};\x0a"
"\x0a"
"template <class InputIterator, class Allocator = allocator<typename iterator_traits<InputIterator>\x3a\x3avalue_type>>\x0a"
"   vector(InputIterator, InputIterator, Allocator = Allocator())\x0a"
"   -> vector<typename iterator_traits<InputIterator>\x3a\x3avalue_type, Allocator>;\x0a"
"\x0a"
"template <class Allocator> struct hash<std\x3a\x3avector<bool, Allocator>>;\x0a"
"\x0a"
"template <class T, class Allocator> bool operator==(const vector<T,Allocator>\x26 x, const vector<T,Allocator>\x26 y);\x0a"
"template <class T, class Allocator> bool operator< (const vector<T,Allocator>\x26 x, const vector<T,Allocator>\x26 y);\x0a"
"template <class T, class Allocator> bool operator\x21=(const vector<T,Allocator>\x26 x, const vector<T,Allocator>\x26 y);\x0a"
"template <class T, class Allocator> bool operator> (const vector<T,Allocator>\x26 x, const vector<T,Allocator>\x26 y);\x0a"
"template <class T, class Allocator> bool operator>=(const vector<T,Allocator>\x26 x, const vector<T,Allocator>\x26 y);\x0a"
"template <class T, class Allocator> bool operator<=(const vector<T,Allocator>\x26 x, const vector<T,Allocator>\x26 y);\x0a"
"\x0a"
"template <class T, class Allocator>\x0a"
"void swap(vector<T,Allocator>\x26 x, vector<T,Allocator>\x26 y)\x0a"
"    noexcept(noexcept(x.swap(y)));\x0a"
"\x0a"
"template <class T, class Allocator, class U>\x0a"
"    void erase(vector<T, Allocator>\x26 c, const U\x26 value);       // C++20\x0a"
"template <class T, class Allocator, class Predicate>\x0a"
"    void erase_if(vector<T, Allocator>\x26 c, Predicate pred);    // C++20\x0a"
"\x0a"
"}  // std\x0a"
"\x0a"
"*/\x0a"
"\x0a"
"#include <__config>\x0a"
"#include <iosfwd> // for forward declaration of vector\x0a"
"#include <__bit_reference>\x0a"
"#include <type_traits>\x0a"
"#include <climits>\x0a"
"#include <limits>\x0a"
"#include <initializer_list>\x0a"
"#include <memory>\x0a"
"#include <stdexcept>\x0a"
"#include <algorithm>\x0a"
"#include <cstring>\x0a"
"#include <version>\x0a"
"#include <__split_buffer>\x0a"
"#include <__functional_base>\x0a"
"\x0a"
"#include <__debug>\x0a"
"\x0a"
"#if \x21""defined(_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)\x0a"
"#pragma GCC system_header\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_PUSH_MACROS\x0a"
"#include <__undef_macros>\x0a"
"\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"template <bool>\x0a"
"class __vector_base_common\x0a"
"{\x0a"
"protected\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY __vector_base_common() {}\x0a"
"    _LIBCPP_NORETURN void __throw_length_error() const;\x0a"
"    _LIBCPP_NORETURN void __throw_out_of_range() const;\x0a"
"};\x0a"
"\x0a"
"template <bool __b>\x0a"
"void\x0a"
"__vector_base_common<__b>\x3a\x3a__throw_length_error() const\x0a"
"{\x0a"
"    _VSTD\x3a\x3a__throw_length_error(\x22vector\x22);\x0a"
"}\x0a"
"\x0a"
"template <bool __b>\x0a"
"void\x0a"
"__vector_base_common<__b>\x3a\x3a__throw_out_of_range() const\x0a"
"{\x0a"
"    _VSTD\x3a\x3a__throw_out_of_range(\x22vector\x22);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_EXTERN_TEMPLATE(class _LIBCPP_EXTERN_TEMPLATE_TYPE_VIS __vector_base_common<true>)\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"class __vector_base\x0a"
"    \x3a protected __vector_base_common<true>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef _Allocator                               allocator_type;\x0a"
"    typedef allocator_traits<allocator_type>         __alloc_traits;\x0a"
"    typedef typename __alloc_traits\x3a\x3asize_type       size_type;\x0a"
"protected\x3a\x0a"
"    typedef _Tp                                      value_type;\x0a"
"    typedef value_type\x26                              reference;\x0a"
"    typedef const value_type\x26                        const_reference;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""difference_type difference_type;\x0a"
"    typedef typename __alloc_traits\x3a\x3apointer         pointer;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""const_pointer   const_pointer;\x0a"
"    typedef pointer                                  iterator;\x0a"
"    typedef const_pointer                            const_iterator;\x0a"
"\x0a"
"    pointer                                         __begin_;\x0a"
"    pointer                                         __end_;\x0a"
"    __compressed_pair<pointer, allocator_type> __end_cap_;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type\x26 __alloc() _NOEXCEPT\x0a"
"        {return __end_cap_.second();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const allocator_type\x26 __alloc() const _NOEXCEPT\x0a"
"        {return __end_cap_.second();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    pointer\x26 __end_cap() _NOEXCEPT\x0a"
"        {return __end_cap_.first();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const pointer\x26 __end_cap() const _NOEXCEPT\x0a"
"        {return __end_cap_.first();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __vector_base()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY __vector_base(const allocator_type\x26 __a);\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY __vector_base(allocator_type\x26\x26 __a) _NOEXCEPT;\x0a"
"#endif\x0a"
"    \x7e__vector_base();\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {__destruct_at_end(__begin_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type capacity() const _NOEXCEPT\x0a"
"        {return static_cast<size_type>(__end_cap() - __begin_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __destruct_at_end(pointer __new_last) _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __vector_base\x26 __c)\x0a"
"        {__copy_assign_alloc(__c, integral_constant<bool,\x0a"
"                      __alloc_traits\x3a\x3apropagate_on_container_copy_assignment\x3a\x3avalue>());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__vector_base\x26 __c)\x0a"
"        _NOEXCEPT_(\x0a"
"            \x21__alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"        {__move_assign_alloc(__c, integral_constant<bool,\x0a"
"                      __alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());}\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __vector_base\x26 __c, true_type)\x0a"
"        {\x0a"
"            if (__alloc() \x21= __c.__alloc())\x0a"
"            {\x0a"
"                clear();\x0a"
"                __alloc_traits\x3a\x3a""deallocate(__alloc(), __begin_, capacity());\x0a"
"                __begin_ = __end_ = __end_cap() = nullptr;\x0a"
"            }\x0a"
"            __alloc() = __c.__alloc();\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const __vector_base\x26, false_type)\x0a"
"        {}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__vector_base\x26 __c, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"        {\x0a"
"            __alloc() = _VSTD\x3a\x3amove(__c.__alloc());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(__vector_base\x26, false_type)\x0a"
"        _NOEXCEPT\x0a"
"        {}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"__vector_base<_Tp, _Allocator>\x3a\x3a__destruct_at_end(pointer __new_last) _NOEXCEPT\x0a"
"{\x0a"
"    pointer __soon_to_be_end = __end_;\x0a"
"    while (__new_last \x21= __soon_to_be_end)\x0a"
"        __alloc_traits\x3a\x3a""destroy(__alloc(), _VSTD\x3a\x3a__to_raw_pointer(--__soon_to_be_end));\x0a"
"    __end_ = __new_last;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__vector_base<_Tp, _Allocator>\x3a\x3a__vector_base()\x0a"
"        _NOEXCEPT_(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __end_(nullptr),\x0a"
"      __end_cap_(nullptr)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__vector_base<_Tp, _Allocator>\x3a\x3a__vector_base(const allocator_type\x26 __a)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __end_(nullptr),\x0a"
"      __end_cap_(nullptr, __a)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"__vector_base<_Tp, _Allocator>\x3a\x3a__vector_base(allocator_type\x26\x26 __a) _NOEXCEPT\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __end_(nullptr),\x0a"
"      __end_cap_(nullptr, std\x3a\x3amove(__a)) {}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"__vector_base<_Tp, _Allocator>\x3a\x3a\x7e__vector_base()\x0a"
"{\x0a"
"    if (__begin_ \x21= nullptr)\x0a"
"    {\x0a"
"        clear();\x0a"
"        __alloc_traits\x3a\x3a""deallocate(__alloc(), __begin_, capacity());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator /* = allocator<_Tp> */>\x0a"
"class _LIBCPP_TEMPLATE_VIS vector\x0a"
"    \x3a private __vector_base<_Tp, _Allocator>\x0a"
"{\x0a"
"private\x3a\x0a"
"    typedef __vector_base<_Tp, _Allocator>           __base;\x0a"
"    typedef allocator<_Tp>                           __default_allocator_type;\x0a"
"public\x3a\x0a"
"    typedef vector                                   __self;\x0a"
"    typedef _Tp                                      value_type;\x0a"
"    typedef _Allocator                               allocator_type;\x0a"
"    typedef typename __base\x3a\x3a__alloc_traits          __alloc_traits;\x0a"
"    typedef typename __base\x3a\x3areference               reference;\x0a"
"    typedef typename __base\x3a\x3a""const_reference         const_reference;\x0a"
"    typedef typename __base\x3a\x3asize_type               size_type;\x0a"
"    typedef typename __base\x3a\x3a""difference_type         difference_type;\x0a"
"    typedef typename __base\x3a\x3apointer                 pointer;\x0a"
"    typedef typename __base\x3a\x3a""const_pointer           const_pointer;\x0a"
"    typedef __wrap_iter<pointer>                     iterator;\x0a"
"    typedef __wrap_iter<const_pointer>               const_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<iterator>         reverse_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<const_iterator>   const_reverse_iterator;\x0a"
"\x0a"
"    static_assert((is_same<typename allocator_type\x3a\x3avalue_type, value_type>\x3a\x3avalue),\x0a"
"                  \x22""Allocator\x3a\x3avalue_type must be same type as value_type\x22);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector() _NOEXCEPT_(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue)\x0a"
"        {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"            __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"        }\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit vector(const allocator_type\x26 __a)\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<allocator_type>\x3a\x3avalue)\x0a"
"#else\x0a"
"        _NOEXCEPT\x0a"
"#endif\x0a"
"        \x3a __base(__a)\x0a"
"    {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    }\x0a"
"    explicit vector(size_type __n);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    explicit vector(size_type __n, const allocator_type\x26 __a);\x0a"
"#endif\x0a"
"    vector(size_type __n, const value_type\x26 __x);\x0a"
"    vector(size_type __n, const value_type\x26 __x, const allocator_type\x26 __a);\x0a"
"    template <class _InputIterator>\x0a"
"        vector(_InputIterator __first,\x0a"
"               typename enable_if<__is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                                 \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                                 is_constructible<\x0a"
"                                    value_type,\x0a"
"                                    typename iterator_traits<_InputIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"                                 _InputIterator>\x3a\x3atype __last);\x0a"
"    template <class _InputIterator>\x0a"
"        vector(_InputIterator __first, _InputIterator __last, const allocator_type\x26 __a,\x0a"
"               typename enable_if<__is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                                 \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                                 is_constructible<\x0a"
"                                    value_type,\x0a"
"                                    typename iterator_traits<_InputIterator>\x3a\x3areference>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _ForwardIterator>\x0a"
"        vector(_ForwardIterator __first,\x0a"
"               typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue \x26\x26\x0a"
"                                 is_constructible<\x0a"
"                                    value_type,\x0a"
"                                    typename iterator_traits<_ForwardIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"                                 _ForwardIterator>\x3a\x3atype __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        vector(_ForwardIterator __first, _ForwardIterator __last, const allocator_type\x26 __a,\x0a"
"               typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue \x26\x26\x0a"
"                                 is_constructible<\x0a"
"                                    value_type,\x0a"
"                                    typename iterator_traits<_ForwardIterator>\x3a\x3areference>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    \x7evector()\x0a"
"    {\x0a"
"        __annotate_delete();\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __get_db()->__erase_c(this);\x0a"
"#endif\x0a"
"    }\x0a"
"\x0a"
"    vector(const vector\x26 __x);\x0a"
"    vector(const vector\x26 __x, const allocator_type\x26 __a);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector\x26 operator=(const vector\x26 __x);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector(initializer_list<value_type> __il);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector(initializer_list<value_type> __il, const allocator_type\x26 __a);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector(vector\x26\x26 __x)\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        _NOEXCEPT;\x0a"
"#else\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector(vector\x26\x26 __x, const allocator_type\x26 __a);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector\x26 operator=(vector\x26\x26 __x)\x0a"
"        _NOEXCEPT_((__noexcept_move_assign_container<_Allocator, __alloc_traits>\x3a\x3avalue));\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector\x26 operator=(initializer_list<value_type> __il)\x0a"
"        {assign(__il.begin(), __il.end()); return *this;}\x0a"
"\x0a"
"#endif  // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"             __is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"            \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"            is_constructible<\x0a"
"                 value_type,\x0a"
"                 typename iterator_traits<_InputIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        assign(_InputIterator __first, _InputIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_forward_iterator<_ForwardIterator>\x3a\x3avalue \x26\x26\x0a"
"            is_constructible<\x0a"
"                 value_type,\x0a"
"                 typename iterator_traits<_ForwardIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        assign(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"\x0a"
"    void assign(size_type __n, const_reference __u);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void assign(initializer_list<value_type> __il)\x0a"
"        {assign(__il.begin(), __il.end());}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    allocator_type get_allocator() const _NOEXCEPT\x0a"
"        {return this->__alloc();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY iterator               begin() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_iterator         begin()   const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY iterator               end() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_iterator         end()     const _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reverse_iterator       rbegin() _NOEXCEPT\x0a"
"        {return       reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin()  const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reverse_iterator       rend() _NOEXCEPT\x0a"
"        {return       reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend()    const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator         cbegin()  const _NOEXCEPT\x0a"
"        {return begin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator         cend()    const _NOEXCEPT\x0a"
"        {return end();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT\x0a"
"        {return rbegin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend()   const _NOEXCEPT\x0a"
"        {return rend();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT\x0a"
"        {return static_cast<size_type>(this->__end_ - this->__begin_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type capacity() const _NOEXCEPT\x0a"
"        {return __base\x3a\x3a""capacity();}\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT\x0a"
"        {return this->__begin_ == this->__end_;}\x0a"
"    size_type max_size() const _NOEXCEPT;\x0a"
"    void reserve(size_type __n);\x0a"
"    void shrink_to_fit() _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference       operator\x5b\x5d(size_type __n) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_reference operator\x5b\x5d(size_type __n) const _NOEXCEPT;\x0a"
"    reference       at(size_type __n);\x0a"
"    const_reference at(size_type __n) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference       front() _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21""empty(), \x22""front() called for empty vector\x22);\x0a"
"        return *this->__begin_;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_reference front() const _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21""empty(), \x22""front() called for empty vector\x22);\x0a"
"        return *this->__begin_;\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference       back() _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21""empty(), \x22""back() called for empty vector\x22);\x0a"
"        return *(this->__end_ - 1);\x0a"
"    }\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_reference back()  const _NOEXCEPT\x0a"
"    {\x0a"
"        _LIBCPP_ASSERT(\x21""empty(), \x22""back() called for empty vector\x22);\x0a"
"        return *(this->__end_ - 1);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    value_type*       data() _NOEXCEPT\x0a"
"        {return _VSTD\x3a\x3a__to_raw_pointer(this->__begin_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const value_type* data() const _NOEXCEPT\x0a"
"        {return _VSTD\x3a\x3a__to_raw_pointer(this->__begin_);}\x0a"
"\x0a"
"#ifdef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __emplace_back(const value_type\x26 __x) { push_back(__x); }\x0a"
"#else\x0a"
"    template <class _Arg>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __emplace_back(_Arg\x26\x26 __arg) {\x0a"
"      emplace_back(_VSTD\x3a\x3a""forward<_Arg>(__arg));\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void push_back(const_reference __x);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY void push_back(value_type\x26\x26 __x);\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"        _LIBCPP_INLINE_VISIBILITY\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        reference emplace_back(_Args\x26\x26... __args);\x0a"
"#else\x0a"
"        void      emplace_back(_Args\x26\x26... __args);\x0a"
"#endif\x0a"
"#endif // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void pop_back();\x0a"
"\x0a"
"    iterator insert(const_iterator __position, const_reference __x);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    iterator insert(const_iterator __position, value_type\x26\x26 __x);\x0a"
"    template <class... _Args>\x0a"
"        iterator emplace(const_iterator __position, _Args\x26\x26... __args);\x0a"
"#endif  // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    iterator insert(const_iterator __position, size_type __n, const_reference __x);\x0a"
"    template <class _InputIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"             __is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"            \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"            is_constructible<\x0a"
"                 value_type,\x0a"
"                 typename iterator_traits<_InputIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"            iterator\x0a"
"        >\x3a\x3atype\x0a"
"        insert(const_iterator __position, _InputIterator __first, _InputIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_forward_iterator<_ForwardIterator>\x3a\x3avalue \x26\x26\x0a"
"            is_constructible<\x0a"
"                 value_type,\x0a"
"                 typename iterator_traits<_ForwardIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"            iterator\x0a"
"        >\x3a\x3atype\x0a"
"        insert(const_iterator __position, _ForwardIterator __first, _ForwardIterator __last);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __position, initializer_list<value_type> __il)\x0a"
"        {return insert(__position, __il.begin(), __il.end());}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY iterator erase(const_iterator __position);\x0a"
"    iterator erase(const_iterator __first, const_iterator __last);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT\x0a"
"    {\x0a"
"        size_type __old_size = size();\x0a"
"        __base\x3a\x3a""clear();\x0a"
"        __annotate_shrink(__old_size);\x0a"
"        __invalidate_all_iterators();\x0a"
"    }\x0a"
"\x0a"
"    void resize(size_type __sz);\x0a"
"    void resize(size_type __sz, const_reference __x);\x0a"
"\x0a"
"    void swap(vector\x26)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT;\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<allocator_type>\x3a\x3avalue);\x0a"
"#endif\x0a"
"\x0a"
"    bool __invariants() const;\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"    bool __dereferenceable(const const_iterator* __i) const;\x0a"
"    bool __decrementable(const const_iterator* __i) const;\x0a"
"    bool __addable(const const_iterator* __i, ptrdiff_t __n) const;\x0a"
"    bool __subscriptable(const const_iterator* __i, ptrdiff_t __n) const;\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __invalidate_all_iterators();\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __invalidate_iterators_past(pointer __new_last);\x0a"
"    void __vallocate(size_type __n);\x0a"
"    void __vdeallocate() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY size_type __recommend(size_type __new_size) const;\x0a"
"    void __construct_at_end(size_type __n);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __construct_at_end(size_type __n, const_reference __x);\x0a"
"    template <class _ForwardIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        __construct_at_end(_ForwardIterator __first, _ForwardIterator __last, size_type __n);\x0a"
"    void __append(size_type __n);\x0a"
"    void __append(size_type __n, const_reference __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator       __make_iter(pointer __p) _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator __make_iter(const_pointer __p) const _NOEXCEPT;\x0a"
"    void __swap_out_circular_buffer(__split_buffer<value_type, allocator_type\x26>\x26 __v);\x0a"
"    pointer __swap_out_circular_buffer(__split_buffer<value_type, allocator_type\x26>\x26 __v, pointer __p);\x0a"
"    void __move_range(pointer __from_s, pointer __from_e, pointer __to);\x0a"
"    void __move_assign(vector\x26 __c, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue);\x0a"
"    void __move_assign(vector\x26 __c, false_type)\x0a"
"        _NOEXCEPT_(__alloc_traits\x3a\x3ais_always_equal\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __destruct_at_end(pointer __new_last) _NOEXCEPT\x0a"
"    {\x0a"
"        __invalidate_iterators_past(__new_last);\x0a"
"        size_type __old_size = size();\x0a"
"        __base\x3a\x3a__destruct_at_end(__new_last);\x0a"
"        __annotate_shrink(__old_size);\x0a"
"    }\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    template <class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    inline void __push_back_slow_path(_Up\x26\x26 __x);\x0a"
"\x0a"
"    template <class... _Args>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    inline void __emplace_back_slow_path(_Args\x26\x26... __args);\x0a"
"#else\x0a"
"    template <class _Up>\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    inline void __push_back_slow_path(_Up\x26 __x);\x0a"
"#endif\x0a"
"\x0a"
"    // The following functions are no-ops outside of AddressSanitizer mode.\x0a"
"    // We call annotatations only for the default Allocator because other allocators\x0a"
"    // may not meet the AddressSanitizer alignment constraints.\x0a"
"    // See the documentation for __sanitizer_annotate_contiguous_container for more details.\x0a"
"#ifndef _LIBCPP_HAS_NO_ASAN\x0a"
"    void __annotate_contiguous_container(const void *__beg, const void *__end,\x0a"
"                                         const void *__old_mid,\x0a"
"                                         const void *__new_mid) const\x0a"
"    {\x0a"
"\x0a"
"      if (__beg \x26\x26 is_same<allocator_type, __default_allocator_type>\x3a\x3avalue)\x0a"
"        __sanitizer_annotate_contiguous_container(__beg, __end, __old_mid, __new_mid);\x0a"
"    }\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __annotate_contiguous_container(const void*, const void*, const void*,\x0a"
"                                         const void*) const {}\x0a"
"#endif\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __annotate_new(size_type __current_size) const {\x0a"
"      __annotate_contiguous_container(data(), data() + capacity(),\x0a"
"                                      data() + capacity(), data() + __current_size);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __annotate_delete() const {\x0a"
"      __annotate_contiguous_container(data(), data() + capacity(),\x0a"
"                                      data() + size(), data() + capacity());\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __annotate_increase(size_type __n) const\x0a"
"    {\x0a"
"      __annotate_contiguous_container(data(), data() + capacity(),\x0a"
"                                      data() + size(), data() + size() + __n);\x0a"
"    }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __annotate_shrink(size_type __old_size) const\x0a"
"    {\x0a"
"      __annotate_contiguous_container(data(), data() + capacity(),\x0a"
"                                      data() + __old_size, data() + size());\x0a"
"    }\x0a"
"#ifndef _LIBCPP_HAS_NO_ASAN\x0a"
"    // The annotation for size increase should happen before the actual increase,\x0a"
"    // but if an exception is thrown after that the annotation has to be undone.\x0a"
"    struct __RAII_IncreaseAnnotator {\x0a"
"      __RAII_IncreaseAnnotator(const vector \x26__v, size_type __n = 1)\x0a"
"        \x3a __commit(false), __v(__v), __old_size(__v.size() + __n) {\x0a"
"        __v.__annotate_increase(__n);\x0a"
"      }\x0a"
"      void __done() { __commit = true; }\x0a"
"      \x7e__RAII_IncreaseAnnotator() {\x0a"
"        if (__commit) return;\x0a"
"        __v.__annotate_shrink(__old_size);\x0a"
"      }\x0a"
"      bool __commit;\x0a"
"      const vector \x26__v;\x0a"
"      size_type __old_size;\x0a"
"    };\x0a"
"#else\x0a"
"    struct __RAII_IncreaseAnnotator {\x0a"
"      _LIBCPP_INLINE_VISIBILITY\x0a"
"      __RAII_IncreaseAnnotator(const vector \x26, size_type = 1) {}\x0a"
"      _LIBCPP_INLINE_VISIBILITY void __done() {}\x0a"
"    };\x0a"
"#endif\x0a"
"\x0a"
"};\x0a"
"\x0a"
"#ifndef _LIBCPP_HAS_NO_DEDUCTION_GUIDES\x0a"
"template<class _InputIterator,\x0a"
"         class _Alloc = typename std\x3a\x3a""allocator<typename iterator_traits<_InputIterator>\x3a\x3avalue_type>,\x0a"
"         class = typename enable_if<__is_allocator<_Alloc>\x3a\x3avalue, void>\x3a\x3atype\x0a"
"         >\x0a"
"vector(_InputIterator, _InputIterator)\x0a"
"  -> vector<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Alloc>;\x0a"
"\x0a"
"template<class _InputIterator,\x0a"
"         class _Alloc,\x0a"
"         class = typename enable_if<__is_allocator<_Alloc>\x3a\x3avalue, void>\x3a\x3atype\x0a"
"         >\x0a"
"vector(_InputIterator, _InputIterator, _Alloc)\x0a"
"  -> vector<typename iterator_traits<_InputIterator>\x3a\x3avalue_type, _Alloc>;\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__swap_out_circular_buffer(__split_buffer<value_type, allocator_type\x26>\x26 __v)\x0a"
"{\x0a"
"    __annotate_delete();\x0a"
"    __alloc_traits\x3a\x3a__construct_backward(this->__alloc(), this->__begin_, this->__end_, __v.__begin_);\x0a"
"    _VSTD\x3a\x3aswap(this->__begin_, __v.__begin_);\x0a"
"    _VSTD\x3a\x3aswap(this->__end_, __v.__end_);\x0a"
"    _VSTD\x3a\x3aswap(this->__end_cap(), __v.__end_cap());\x0a"
"    __v.__first_ = __v.__begin_;\x0a"
"    __annotate_new(size());\x0a"
"    __invalidate_all_iterators();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3apointer\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__swap_out_circular_buffer(__split_buffer<value_type, allocator_type\x26>\x26 __v, pointer __p)\x0a"
"{\x0a"
"    __annotate_delete();\x0a"
"    pointer __r = __v.__begin_;\x0a"
"    __alloc_traits\x3a\x3a__construct_backward(this->__alloc(), this->__begin_, __p, __v.__begin_);\x0a"
"    __alloc_traits\x3a\x3a__construct_forward(this->__alloc(), __p, this->__end_, __v.__end_);\x0a"
"    _VSTD\x3a\x3aswap(this->__begin_, __v.__begin_);\x0a"
"    _VSTD\x3a\x3aswap(this->__end_, __v.__end_);\x0a"
"    _VSTD\x3a\x3aswap(this->__end_cap(), __v.__end_cap());\x0a"
"    __v.__first_ = __v.__begin_;\x0a"
"    __annotate_new(size());\x0a"
"    __invalidate_all_iterators();\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"//  Allocate space for __n objects\x0a"
"//  throws length_error if __n > max_size()\x0a"
"//  throws (probably bad_alloc) if memory run out\x0a"
"//  Precondition\x3a  __begin_ == __end_ == __end_cap() == 0\x0a"
"//  Precondition\x3a  __n > 0\x0a"
"//  Postcondition\x3a  capacity() == __n\x0a"
"//  Postcondition\x3a  size() == 0\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__vallocate(size_type __n)\x0a"
"{\x0a"
"    if (__n > max_size())\x0a"
"        this->__throw_length_error();\x0a"
"    this->__begin_ = this->__end_ = __alloc_traits\x3a\x3a""allocate(this->__alloc(), __n);\x0a"
"    this->__end_cap() = this->__begin_ + __n;\x0a"
"    __annotate_new(0);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__vdeallocate() _NOEXCEPT\x0a"
"{\x0a"
"    if (this->__begin_ \x21= nullptr)\x0a"
"    {\x0a"
"        clear();\x0a"
"        __alloc_traits\x3a\x3a""deallocate(this->__alloc(), this->__begin_, capacity());\x0a"
"        this->__begin_ = this->__end_ = this->__end_cap() = nullptr;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3asize_type\x0a"
"vector<_Tp, _Allocator>\x3a\x3amax_size() const _NOEXCEPT\x0a"
"{\x0a"
"    return _VSTD\x3a\x3amin<size_type>(__alloc_traits\x3a\x3amax_size(this->__alloc()),\x0a"
"                                 numeric_limits<difference_type>\x3a\x3amax());\x0a"
"}\x0a"
"\x0a"
"//  Precondition\x3a  __new_size > capacity()\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3asize_type\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__recommend(size_type __new_size) const\x0a"
"{\x0a"
"    const size_type __ms = max_size();\x0a"
"    if (__new_size > __ms)\x0a"
"        this->__throw_length_error();\x0a"
"    const size_type __cap = capacity();\x0a"
"    if (__cap >= __ms / 2)\x0a"
"        return __ms;\x0a"
"    return _VSTD\x3a\x3amax<size_type>(2*__cap, __new_size);\x0a"
"}\x0a"
"\x0a"
"//  Default constructs __n objects starting at __end_\x0a"
"//  throws if construction throws\x0a"
"//  Precondition\x3a  __n > 0\x0a"
"//  Precondition\x3a  size() + __n <= capacity()\x0a"
"//  Postcondition\x3a  size() == size() + __n\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__construct_at_end(size_type __n)\x0a"
"{\x0a"
"    allocator_type\x26 __a = this->__alloc();\x0a"
"    do\x0a"
"    {\x0a"
"        __RAII_IncreaseAnnotator __annotator(*this);\x0a"
"        __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a__to_raw_pointer(this->__end_));\x0a"
"        ++this->__end_;\x0a"
"        --__n;\x0a"
"        __annotator.__done();\x0a"
"    } while (__n > 0);\x0a"
"}\x0a"
"\x0a"
"//  Copy constructs __n objects starting at __end_ from __x\x0a"
"//  throws if construction throws\x0a"
"//  Precondition\x3a  __n > 0\x0a"
"//  Precondition\x3a  size() + __n <= capacity()\x0a"
"//  Postcondition\x3a  size() == old size() + __n\x0a"
"//  Postcondition\x3a  \x5bi\x5d == __x for all i in \x5bsize() - __n, __n)\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__construct_at_end(size_type __n, const_reference __x)\x0a"
"{\x0a"
"    allocator_type\x26 __a = this->__alloc();\x0a"
"    do\x0a"
"    {\x0a"
"        __RAII_IncreaseAnnotator __annotator(*this);\x0a"
"        __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a__to_raw_pointer(this->__end_), __x);\x0a"
"        ++this->__end_;\x0a"
"        --__n;\x0a"
"        __annotator.__done();\x0a"
"    } while (__n > 0);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__construct_at_end(_ForwardIterator __first, _ForwardIterator __last, size_type __n)\x0a"
"{\x0a"
"    allocator_type\x26 __a = this->__alloc();\x0a"
"    __RAII_IncreaseAnnotator __annotator(*this, __n);\x0a"
"    __alloc_traits\x3a\x3a__construct_range_forward(__a, __first, __last, this->__end_);\x0a"
"    __annotator.__done();\x0a"
"}\x0a"
"\x0a"
"//  Default constructs __n objects starting at __end_\x0a"
"//  throws if construction throws\x0a"
"//  Postcondition\x3a  size() == size() + __n\x0a"
"//  Exception safety\x3a strong.\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__append(size_type __n)\x0a"
"{\x0a"
"    if (static_cast<size_type>(this->__end_cap() - this->__end_) >= __n)\x0a"
"        this->__construct_at_end(__n);\x0a"
"    else\x0a"
"    {\x0a"
"        allocator_type\x26 __a = this->__alloc();\x0a"
"        __split_buffer<value_type, allocator_type\x26> __v(__recommend(size() + __n), size(), __a);\x0a"
"        __v.__construct_at_end(__n);\x0a"
"        __swap_out_circular_buffer(__v);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"//  Default constructs __n objects starting at __end_\x0a"
"//  throws if construction throws\x0a"
"//  Postcondition\x3a  size() == size() + __n\x0a"
"//  Exception safety\x3a strong.\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__append(size_type __n, const_reference __x)\x0a"
"{\x0a"
"    if (static_cast<size_type>(this->__end_cap() - this->__end_) >= __n)\x0a"
"        this->__construct_at_end(__n, __x);\x0a"
"    else\x0a"
"    {\x0a"
"        allocator_type\x26 __a = this->__alloc();\x0a"
"        __split_buffer<value_type, allocator_type\x26> __v(__recommend(size() + __n), size(), __a);\x0a"
"        __v.__construct_at_end(__n, __x);\x0a"
"        __swap_out_circular_buffer(__v);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(size_type __n)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__n);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Tp, class _Allocator>\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(size_type __n, const allocator_type\x26 __a)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__n);\x0a"
"    }\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(size_type __n, const value_type\x26 __x)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__n, __x);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(size_type __n, const value_type\x26 __x, const allocator_type\x26 __a)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__n, __x);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _InputIterator>\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(_InputIterator __first,\x0a"
"       typename enable_if<__is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                         \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                         is_constructible<\x0a"
"                            value_type,\x0a"
"                            typename iterator_traits<_InputIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"                          _InputIterator>\x3a\x3atype __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __emplace_back(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _InputIterator>\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(_InputIterator __first, _InputIterator __last, const allocator_type\x26 __a,\x0a"
"       typename enable_if<__is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                         \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                         is_constructible<\x0a"
"                            value_type,\x0a"
"                            typename iterator_traits<_InputIterator>\x3a\x3areference>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __emplace_back(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(_ForwardIterator __first,\x0a"
"                                typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue \x26\x26\x0a"
"                                is_constructible<\x0a"
"                                   value_type,\x0a"
"                                   typename iterator_traits<_ForwardIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"                                                   _ForwardIterator>\x3a\x3atype __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    size_type __n = static_cast<size_type>(_VSTD\x3a\x3a""distance(__first, __last));\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__first, __last, __n);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(_ForwardIterator __first, _ForwardIterator __last, const allocator_type\x26 __a,\x0a"
"                                typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue \x26\x26\x0a"
"                                is_constructible<\x0a"
"                                   value_type,\x0a"
"                                   typename iterator_traits<_ForwardIterator>\x3a\x3areference>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    size_type __n = static_cast<size_type>(_VSTD\x3a\x3a""distance(__first, __last));\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__first, __last, __n);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(const vector\x26 __x)\x0a"
"    \x3a __base(__alloc_traits\x3a\x3aselect_on_container_copy_construction(__x.__alloc()))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    size_type __n = __x.size();\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__x.__begin_, __x.__end_, __n);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(const vector\x26 __x, const allocator_type\x26 __a)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    size_type __n = __x.size();\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__x.__begin_, __x.__end_, __n);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(vector\x26\x26 __x)\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        _NOEXCEPT\x0a"
"#else\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue)\x0a"
"#endif\x0a"
"    \x3a __base(_VSTD\x3a\x3amove(__x.__alloc()))\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"    __get_db()->swap(this, \x26__x);\x0a"
"#endif\x0a"
"    this->__begin_ = __x.__begin_;\x0a"
"    this->__end_ = __x.__end_;\x0a"
"    this->__end_cap() = __x.__end_cap();\x0a"
"    __x.__begin_ = __x.__end_ = __x.__end_cap() = nullptr;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(vector\x26\x26 __x, const allocator_type\x26 __a)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__a == __x.__alloc())\x0a"
"    {\x0a"
"        this->__begin_ = __x.__begin_;\x0a"
"        this->__end_ = __x.__end_;\x0a"
"        this->__end_cap() = __x.__end_cap();\x0a"
"        __x.__begin_ = __x.__end_ = __x.__end_cap() = nullptr;\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"        __get_db()->swap(this, \x26__x);\x0a"
"#endif\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        typedef move_iterator<iterator> _Ip;\x0a"
"        assign(_Ip(__x.begin()), _Ip(__x.end()));\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(initializer_list<value_type> __il)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__il.size() > 0)\x0a"
"    {\x0a"
"        __vallocate(__il.size());\x0a"
"        __construct_at_end(__il.begin(), __il.end(), __il.size());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"vector<_Tp, _Allocator>\x3a\x3avector(initializer_list<value_type> __il, const allocator_type\x26 __a)\x0a"
"    \x3a __base(__a)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__insert_c(this);\x0a"
"#endif\x0a"
"    if (__il.size() > 0)\x0a"
"    {\x0a"
"        __vallocate(__il.size());\x0a"
"        __construct_at_end(__il.begin(), __il.end(), __il.size());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"vector<_Tp, _Allocator>\x26\x0a"
"vector<_Tp, _Allocator>\x3a\x3aoperator=(vector\x26\x26 __x)\x0a"
"    _NOEXCEPT_((__noexcept_move_assign_container<_Allocator, __alloc_traits>\x3a\x3avalue))\x0a"
"{\x0a"
"    __move_assign(__x, integral_constant<bool,\x0a"
"          __alloc_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__move_assign(vector\x26 __c, false_type)\x0a"
"    _NOEXCEPT_(__alloc_traits\x3a\x3ais_always_equal\x3a\x3avalue)\x0a"
"{\x0a"
"    if (__base\x3a\x3a__alloc() \x21= __c.__alloc())\x0a"
"    {\x0a"
"        typedef move_iterator<iterator> _Ip;\x0a"
"        assign(_Ip(__c.begin()), _Ip(__c.end()));\x0a"
"    }\x0a"
"    else\x0a"
"        __move_assign(__c, true_type());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__move_assign(vector\x26 __c, true_type)\x0a"
"    _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"{\x0a"
"    __vdeallocate();\x0a"
"    __base\x3a\x3a__move_assign_alloc(__c); // this can throw\x0a"
"    this->__begin_ = __c.__begin_;\x0a"
"    this->__end_ = __c.__end_;\x0a"
"    this->__end_cap() = __c.__end_cap();\x0a"
"    __c.__begin_ = __c.__end_ = __c.__end_cap() = nullptr;\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->swap(this, \x26__c);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#endif  // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"vector<_Tp, _Allocator>\x26\x0a"
"vector<_Tp, _Allocator>\x3a\x3aoperator=(const vector\x26 __x)\x0a"
"{\x0a"
"    if (this \x21= \x26__x)\x0a"
"    {\x0a"
"        __base\x3a\x3a__copy_assign_alloc(__x);\x0a"
"        assign(__x.__begin_, __x.__end_);\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _InputIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"     __is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"    \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"    is_constructible<\x0a"
"       _Tp,\x0a"
"       typename iterator_traits<_InputIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""assign(_InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    clear();\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        __emplace_back(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_forward_iterator<_ForwardIterator>\x3a\x3avalue \x26\x26\x0a"
"    is_constructible<\x0a"
"       _Tp,\x0a"
"       typename iterator_traits<_ForwardIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""assign(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    size_type __new_size = static_cast<size_type>(_VSTD\x3a\x3a""distance(__first, __last));\x0a"
"    if (__new_size <= capacity())\x0a"
"    {\x0a"
"        _ForwardIterator __mid = __last;\x0a"
"        bool __growing = false;\x0a"
"        if (__new_size > size())\x0a"
"        {\x0a"
"            __growing = true;\x0a"
"            __mid =  __first;\x0a"
"            _VSTD\x3a\x3a""advance(__mid, size());\x0a"
"        }\x0a"
"        pointer __m = _VSTD\x3a\x3a""copy(__first, __mid, this->__begin_);\x0a"
"        if (__growing)\x0a"
"            __construct_at_end(__mid, __last, __new_size - size());\x0a"
"        else\x0a"
"            this->__destruct_at_end(__m);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __vdeallocate();\x0a"
"        __vallocate(__recommend(__new_size));\x0a"
"        __construct_at_end(__first, __last, __new_size);\x0a"
"    }\x0a"
"    __invalidate_all_iterators();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""assign(size_type __n, const_reference __u)\x0a"
"{\x0a"
"    if (__n <= capacity())\x0a"
"    {\x0a"
"        size_type __s = size();\x0a"
"        _VSTD\x3a\x3a""fill_n(this->__begin_, _VSTD\x3a\x3amin(__n, __s), __u);\x0a"
"        if (__n > __s)\x0a"
"            __construct_at_end(__n - __s, __u);\x0a"
"        else\x0a"
"            this->__destruct_at_end(this->__begin_ + __n);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        __vdeallocate();\x0a"
"        __vallocate(__recommend(static_cast<size_type>(__n)));\x0a"
"        __construct_at_end(__n, __u);\x0a"
"    }\x0a"
"    __invalidate_all_iterators();\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__make_iter(pointer __p) _NOEXCEPT\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    return iterator(this, __p);\x0a"
"#else\x0a"
"    return iterator(__p);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3a""const_iterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__make_iter(const_pointer __p) const _NOEXCEPT\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    return const_iterator(this, __p);\x0a"
"#else\x0a"
"    return const_iterator(__p);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""begin() _NOEXCEPT\x0a"
"{\x0a"
"    return __make_iter(this->__begin_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3a""const_iterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""begin() const _NOEXCEPT\x0a"
"{\x0a"
"    return __make_iter(this->__begin_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""end() _NOEXCEPT\x0a"
"{\x0a"
"    return __make_iter(this->__end_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3a""const_iterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""end() const _NOEXCEPT\x0a"
"{\x0a"
"    return __make_iter(this->__end_);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3areference\x0a"
"vector<_Tp, _Allocator>\x3a\x3aoperator\x5b\x5d(size_type __n) _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n < size(), \x22vector\x5b\x5d index out of bounds\x22);\x0a"
"    return this->__begin_\x5b__n\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3a""const_reference\x0a"
"vector<_Tp, _Allocator>\x3a\x3aoperator\x5b\x5d(size_type __n) const _NOEXCEPT\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__n < size(), \x22vector\x5b\x5d index out of bounds\x22);\x0a"
"    return this->__begin_\x5b__n\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3areference\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""at(size_type __n)\x0a"
"{\x0a"
"    if (__n >= size())\x0a"
"        this->__throw_out_of_range();\x0a"
"    return this->__begin_\x5b__n\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3a""const_reference\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""at(size_type __n) const\x0a"
"{\x0a"
"    if (__n >= size())\x0a"
"        this->__throw_out_of_range();\x0a"
"    return this->__begin_\x5b__n\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3areserve(size_type __n)\x0a"
"{\x0a"
"    if (__n > capacity())\x0a"
"    {\x0a"
"        allocator_type\x26 __a = this->__alloc();\x0a"
"        __split_buffer<value_type, allocator_type\x26> __v(__n, size(), __a);\x0a"
"        __swap_out_circular_buffer(__v);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3ashrink_to_fit() _NOEXCEPT\x0a"
"{\x0a"
"    if (capacity() > size())\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            allocator_type\x26 __a = this->__alloc();\x0a"
"            __split_buffer<value_type, allocator_type\x26> __v(size(), size(), __a);\x0a"
"            __swap_out_circular_buffer(__v);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _Up>\x0a"
"void\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__push_back_slow_path(_Up\x26\x26 __x)\x0a"
"#else\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__push_back_slow_path(_Up\x26 __x)\x0a"
"#endif\x0a"
"{\x0a"
"    allocator_type\x26 __a = this->__alloc();\x0a"
"    __split_buffer<value_type, allocator_type\x26> __v(__recommend(size() + 1), size(), __a);\x0a"
"    // __v.push_back(_VSTD\x3a\x3a""forward<_Up>(__x));\x0a"
"    __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a__to_raw_pointer(__v.__end_), _VSTD\x3a\x3a""forward<_Up>(__x));\x0a"
"    __v.__end_++;\x0a"
"    __swap_out_circular_buffer(__v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3apush_back(const_reference __x)\x0a"
"{\x0a"
"    if (this->__end_ \x21= this->__end_cap())\x0a"
"    {\x0a"
"        __RAII_IncreaseAnnotator __annotator(*this);\x0a"
"        __alloc_traits\x3a\x3a""construct(this->__alloc(),\x0a"
"                                  _VSTD\x3a\x3a__to_raw_pointer(this->__end_), __x);\x0a"
"        __annotator.__done();\x0a"
"        ++this->__end_;\x0a"
"    }\x0a"
"    else\x0a"
"        __push_back_slow_path(__x);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3apush_back(value_type\x26\x26 __x)\x0a"
"{\x0a"
"    if (this->__end_ < this->__end_cap())\x0a"
"    {\x0a"
"        __RAII_IncreaseAnnotator __annotator(*this);\x0a"
"        __alloc_traits\x3a\x3a""construct(this->__alloc(),\x0a"
"                                  _VSTD\x3a\x3a__to_raw_pointer(this->__end_),\x0a"
"                                  _VSTD\x3a\x3amove(__x));\x0a"
"        __annotator.__done();\x0a"
"        ++this->__end_;\x0a"
"    }\x0a"
"    else\x0a"
"        __push_back_slow_path(_VSTD\x3a\x3amove(__x));\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class... _Args>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__emplace_back_slow_path(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    allocator_type\x26 __a = this->__alloc();\x0a"
"    __split_buffer<value_type, allocator_type\x26> __v(__recommend(size() + 1), size(), __a);\x0a"
"//    __v.emplace_back(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a__to_raw_pointer(__v.__end_), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"    __v.__end_++;\x0a"
"    __swap_out_circular_buffer(__v);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class... _Args>\x0a"
"inline\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3areference\x0a"
"#else\x0a"
"void\x0a"
"#endif\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""emplace_back(_Args\x26\x26... __args)\x0a"
"{\x0a"
"    if (this->__end_ < this->__end_cap())\x0a"
"    {\x0a"
"        __RAII_IncreaseAnnotator __annotator(*this);\x0a"
"        __alloc_traits\x3a\x3a""construct(this->__alloc(),\x0a"
"                                  _VSTD\x3a\x3a__to_raw_pointer(this->__end_),\x0a"
"                                  _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        __annotator.__done();\x0a"
"        ++this->__end_;\x0a"
"    }\x0a"
"    else\x0a"
"        __emplace_back_slow_path(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    return this->back();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"#endif  // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3apop_back()\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(\x21""empty(), \x22vector\x3a\x3apop_back called for empty vector\x22);\x0a"
"    this->__destruct_at_end(this->__end_ - 1);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""erase(const_iterator __position)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__position) == this,\x0a"
"        \x22vector\x3a\x3a""erase(iterator) called with an iterator not\x22\x0a"
"        \x22 referring to this vector\x22);\x0a"
"#endif\x0a"
"    _LIBCPP_ASSERT(__position \x21= end(),\x0a"
"        \x22vector\x3a\x3a""erase(iterator) called with a non-dereferenceable iterator\x22);\x0a"
"    difference_type __ps = __position - cbegin();\x0a"
"    pointer __p = this->__begin_ + __ps;\x0a"
"    this->__destruct_at_end(_VSTD\x3a\x3amove(__p + 1, this->__end_, __p));\x0a"
"    this->__invalidate_iterators_past(__p-1);\x0a"
"    iterator __r = __make_iter(__p);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""erase(const_iterator __first, const_iterator __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__first) == this,\x0a"
"        \x22vector\x3a\x3a""erase(iterator,  iterator) called with an iterator not\x22\x0a"
"        \x22 referring to this vector\x22);\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__last) == this,\x0a"
"        \x22vector\x3a\x3a""erase(iterator,  iterator) called with an iterator not\x22\x0a"
"        \x22 referring to this vector\x22);\x0a"
"#endif\x0a"
"    _LIBCPP_ASSERT(__first <= __last, \x22vector\x3a\x3a""erase(first, last) called with invalid range\x22);\x0a"
"    pointer __p = this->__begin_ + (__first - begin());\x0a"
"    if (__first \x21= __last) {\x0a"
"        this->__destruct_at_end(_VSTD\x3a\x3amove(__p + (__last - __first), this->__end_, __p));\x0a"
"        this->__invalidate_iterators_past(__p - 1);\x0a"
"    }\x0a"
"    iterator __r = __make_iter(__p);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__move_range(pointer __from_s, pointer __from_e, pointer __to)\x0a"
"{\x0a"
"    pointer __old_last = this->__end_;\x0a"
"    difference_type __n = __old_last - __to;\x0a"
"    for (pointer __i = __from_s + __n; __i < __from_e; ++__i, ++this->__end_)\x0a"
"        __alloc_traits\x3a\x3a""construct(this->__alloc(),\x0a"
"                                  _VSTD\x3a\x3a__to_raw_pointer(this->__end_),\x0a"
"                                  _VSTD\x3a\x3amove(*__i));\x0a"
"    _VSTD\x3a\x3amove_backward(__from_s, __from_s + __n, __old_last);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __position, const_reference __x)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__position) == this,\x0a"
"        \x22vector\x3a\x3ainsert(iterator, x) called with an iterator not\x22\x0a"
"        \x22 referring to this vector\x22);\x0a"
"#endif\x0a"
"    pointer __p = this->__begin_ + (__position - begin());\x0a"
"    if (this->__end_ < this->__end_cap())\x0a"
"    {\x0a"
"        __RAII_IncreaseAnnotator __annotator(*this);\x0a"
"        if (__p == this->__end_)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""construct(this->__alloc(),\x0a"
"                                      _VSTD\x3a\x3a__to_raw_pointer(this->__end_), __x);\x0a"
"            ++this->__end_;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __move_range(__p, this->__end_, __p + 1);\x0a"
"            const_pointer __xr = pointer_traits<const_pointer>\x3a\x3apointer_to(__x);\x0a"
"            if (__p <= __xr \x26\x26 __xr < this->__end_)\x0a"
"                ++__xr;\x0a"
"            *__p = *__xr;\x0a"
"        }\x0a"
"        __annotator.__done();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        allocator_type\x26 __a = this->__alloc();\x0a"
"        __split_buffer<value_type, allocator_type\x26> __v(__recommend(size() + 1), __p - this->__begin_, __a);\x0a"
"        __v.push_back(__x);\x0a"
"        __p = __swap_out_circular_buffer(__v, __p);\x0a"
"    }\x0a"
"    return __make_iter(__p);\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __position, value_type\x26\x26 __x)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__position) == this,\x0a"
"        \x22vector\x3a\x3ainsert(iterator, x) called with an iterator not\x22\x0a"
"        \x22 referring to this vector\x22);\x0a"
"#endif\x0a"
"    pointer __p = this->__begin_ + (__position - begin());\x0a"
"    if (this->__end_ < this->__end_cap())\x0a"
"    {\x0a"
"        __RAII_IncreaseAnnotator __annotator(*this);\x0a"
"        if (__p == this->__end_)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""construct(this->__alloc(),\x0a"
"                                      _VSTD\x3a\x3a__to_raw_pointer(this->__end_),\x0a"
"                                      _VSTD\x3a\x3amove(__x));\x0a"
"            ++this->__end_;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __move_range(__p, this->__end_, __p + 1);\x0a"
"            *__p = _VSTD\x3a\x3amove(__x);\x0a"
"        }\x0a"
"        __annotator.__done();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        allocator_type\x26 __a = this->__alloc();\x0a"
"        __split_buffer<value_type, allocator_type\x26> __v(__recommend(size() + 1), __p - this->__begin_, __a);\x0a"
"        __v.push_back(_VSTD\x3a\x3amove(__x));\x0a"
"        __p = __swap_out_circular_buffer(__v, __p);\x0a"
"    }\x0a"
"    return __make_iter(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class... _Args>\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3a""emplace(const_iterator __position, _Args\x26\x26... __args)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__position) == this,\x0a"
"        \x22vector\x3a\x3a""emplace(iterator, x) called with an iterator not\x22\x0a"
"        \x22 referring to this vector\x22);\x0a"
"#endif\x0a"
"    pointer __p = this->__begin_ + (__position - begin());\x0a"
"    if (this->__end_ < this->__end_cap())\x0a"
"    {\x0a"
"        __RAII_IncreaseAnnotator __annotator(*this);\x0a"
"        if (__p == this->__end_)\x0a"
"        {\x0a"
"            __alloc_traits\x3a\x3a""construct(this->__alloc(),\x0a"
"                                      _VSTD\x3a\x3a__to_raw_pointer(this->__end_),\x0a"
"                                      _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"            ++this->__end_;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            __temp_value<value_type, _Allocator> __tmp(this->__alloc(), _VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"            __move_range(__p, this->__end_, __p + 1);\x0a"
"            *__p = _VSTD\x3a\x3amove(__tmp.get());\x0a"
"        }\x0a"
"        __annotator.__done();\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        allocator_type\x26 __a = this->__alloc();\x0a"
"        __split_buffer<value_type, allocator_type\x26> __v(__recommend(size() + 1), __p - this->__begin_, __a);\x0a"
"        __v.emplace_back(_VSTD\x3a\x3a""forward<_Args>(__args)...);\x0a"
"        __p = __swap_out_circular_buffer(__v, __p);\x0a"
"    }\x0a"
"    return __make_iter(__p);\x0a"
"}\x0a"
"\x0a"
"#endif  // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
"vector<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __position, size_type __n, const_reference __x)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__position) == this,\x0a"
"        \x22vector\x3a\x3ainsert(iterator, n, x) called with an iterator not\x22\x0a"
"        \x22 referring to this vector\x22);\x0a"
"#endif\x0a"
"    pointer __p = this->__begin_ + (__position - begin());\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        if (__n <= static_cast<size_type>(this->__end_cap() - this->__end_))\x0a"
"        {\x0a"
"            size_type __old_n = __n;\x0a"
"            pointer __old_last = this->__end_;\x0a"
"            if (__n > static_cast<size_type>(this->__end_ - __p))\x0a"
"            {\x0a"
"                size_type __cx = __n - (this->__end_ - __p);\x0a"
"                __construct_at_end(__cx, __x);\x0a"
"                __n -= __cx;\x0a"
"            }\x0a"
"            if (__n > 0)\x0a"
"            {\x0a"
"                __RAII_IncreaseAnnotator __annotator(*this, __n);\x0a"
"                __move_range(__p, __old_last, __p + __old_n);\x0a"
"                __annotator.__done();\x0a"
"                const_pointer __xr = pointer_traits<const_pointer>\x3a\x3apointer_to(__x);\x0a"
"                if (__p <= __xr \x26\x26 __xr < this->__end_)\x0a"
"                    __xr += __old_n;\x0a"
"                _VSTD\x3a\x3a""fill_n(__p, __n, *__xr);\x0a"
"            }\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            allocator_type\x26 __a = this->__alloc();\x0a"
"            __split_buffer<value_type, allocator_type\x26> __v(__recommend(size() + __n), __p - this->__begin_, __a);\x0a"
"            __v.__construct_at_end(__n, __x);\x0a"
"            __p = __swap_out_circular_buffer(__v, __p);\x0a"
"        }\x0a"
"    }\x0a"
"    return __make_iter(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _InputIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"     __is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"    \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"    is_constructible<\x0a"
"       _Tp,\x0a"
"       typename iterator_traits<_InputIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"    typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
">\x3a\x3atype\x0a"
"vector<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __position, _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__position) == this,\x0a"
"        \x22vector\x3a\x3ainsert(iterator, range) called with an iterator not\x22\x0a"
"        \x22 referring to this vector\x22);\x0a"
"#endif\x0a"
"    difference_type __off = __position - begin();\x0a"
"    pointer __p = this->__begin_ + __off;\x0a"
"    allocator_type\x26 __a = this->__alloc();\x0a"
"    pointer __old_last = this->__end_;\x0a"
"    for (; this->__end_ \x21= this->__end_cap() \x26\x26 __first \x21= __last; ++__first)\x0a"
"    {\x0a"
"        __RAII_IncreaseAnnotator __annotator(*this);\x0a"
"        __alloc_traits\x3a\x3a""construct(__a, _VSTD\x3a\x3a__to_raw_pointer(this->__end_),\x0a"
"                                  *__first);\x0a"
"        ++this->__end_;\x0a"
"        __annotator.__done();\x0a"
"    }\x0a"
"    __split_buffer<value_type, allocator_type\x26> __v(__a);\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            __v.__construct_at_end(__first, __last);\x0a"
"            difference_type __old_size = __old_last - this->__begin_;\x0a"
"            difference_type __old_p = __p - this->__begin_;\x0a"
"            reserve(__recommend(size() + __v.size()));\x0a"
"            __p = this->__begin_ + __old_p;\x0a"
"            __old_last = this->__begin_ + __old_size;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            erase(__make_iter(__old_last), end());\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    __p = _VSTD\x3a\x3arotate(__p, __old_last, this->__end_);\x0a"
"    insert(__make_iter(__p), make_move_iterator(__v.begin()),\x0a"
"                                    make_move_iterator(__v.end()));\x0a"
"    return begin() + __off;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_forward_iterator<_ForwardIterator>\x3a\x3avalue \x26\x26\x0a"
"    is_constructible<\x0a"
"       _Tp,\x0a"
"       typename iterator_traits<_ForwardIterator>\x3a\x3areference>\x3a\x3avalue,\x0a"
"    typename vector<_Tp, _Allocator>\x3a\x3aiterator\x0a"
">\x3a\x3atype\x0a"
"vector<_Tp, _Allocator>\x3a\x3ainsert(const_iterator __position, _ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    _LIBCPP_ASSERT(__get_const_db()->__find_c_from_i(\x26__position) == this,\x0a"
"        \x22vector\x3a\x3ainsert(iterator, range) called with an iterator not\x22\x0a"
"        \x22 referring to this vector\x22);\x0a"
"#endif\x0a"
"    pointer __p = this->__begin_ + (__position - begin());\x0a"
"    difference_type __n = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        if (__n <= this->__end_cap() - this->__end_)\x0a"
"        {\x0a"
"            size_type __old_n = __n;\x0a"
"            pointer __old_last = this->__end_;\x0a"
"            _ForwardIterator __m = __last;\x0a"
"            difference_type __dx = this->__end_ - __p;\x0a"
"            if (__n > __dx)\x0a"
"            {\x0a"
"                __m = __first;\x0a"
"                difference_type __diff = this->__end_ - __p;\x0a"
"                _VSTD\x3a\x3a""advance(__m, __diff);\x0a"
"                __construct_at_end(__m, __last, __n - __diff);\x0a"
"                __n = __dx;\x0a"
"            }\x0a"
"            if (__n > 0)\x0a"
"            {\x0a"
"                __RAII_IncreaseAnnotator __annotator(*this, __n);\x0a"
"                __move_range(__p, __old_last, __p + __old_n);\x0a"
"                __annotator.__done();\x0a"
"                _VSTD\x3a\x3a""copy(__first, __m, __p);\x0a"
"            }\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            allocator_type\x26 __a = this->__alloc();\x0a"
"            __split_buffer<value_type, allocator_type\x26> __v(__recommend(size() + __n), __p - this->__begin_, __a);\x0a"
"            __v.__construct_at_end(__first, __last);\x0a"
"            __p = __swap_out_circular_buffer(__v, __p);\x0a"
"        }\x0a"
"    }\x0a"
"    return __make_iter(__p);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3aresize(size_type __sz)\x0a"
"{\x0a"
"    size_type __cs = size();\x0a"
"    if (__cs < __sz)\x0a"
"        this->__append(__sz - __cs);\x0a"
"    else if (__cs > __sz)\x0a"
"        this->__destruct_at_end(this->__begin_ + __sz);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3aresize(size_type __sz, const_reference __x)\x0a"
"{\x0a"
"    size_type __cs = size();\x0a"
"    if (__cs < __sz)\x0a"
"        this->__append(__sz - __cs, __x);\x0a"
"    else if (__cs > __sz)\x0a"
"        this->__destruct_at_end(this->__begin_ + __sz);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3aswap(vector\x26 __x)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"    _NOEXCEPT\x0a"
"#else\x0a"
"    _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                __is_nothrow_swappable<allocator_type>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"    _LIBCPP_ASSERT(__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                   this->__alloc() == __x.__alloc(),\x0a"
"                   \x22vector\x3a\x3aswap\x3a Either propagate_on_container_swap must be true\x22\x0a"
"                   \x22 or the allocators must compare equal\x22);\x0a"
"    _VSTD\x3a\x3aswap(this->__begin_, __x.__begin_);\x0a"
"    _VSTD\x3a\x3aswap(this->__end_, __x.__end_);\x0a"
"    _VSTD\x3a\x3aswap(this->__end_cap(), __x.__end_cap());\x0a"
"    __swap_allocator(this->__alloc(), __x.__alloc(),\x0a"
"        integral_constant<bool,__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue>());\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->swap(this, \x26__x);\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"bool\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__invariants() const\x0a"
"{\x0a"
"    if (this->__begin_ == nullptr)\x0a"
"    {\x0a"
"        if (this->__end_ \x21= nullptr \x7c\x7c this->__end_cap() \x21= nullptr)\x0a"
"            return false;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        if (this->__begin_ > this->__end_)\x0a"
"            return false;\x0a"
"        if (this->__begin_ == this->__end_cap())\x0a"
"            return false;\x0a"
"        if (this->__end_ > this->__end_cap())\x0a"
"            return false;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"bool\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__dereferenceable(const const_iterator* __i) const\x0a"
"{\x0a"
"    return this->__begin_ <= __i->base() \x26\x26 __i->base() < this->__end_;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"bool\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__decrementable(const const_iterator* __i) const\x0a"
"{\x0a"
"    return this->__begin_ < __i->base() \x26\x26 __i->base() <= this->__end_;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"bool\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__addable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"{\x0a"
"    const_pointer __p = __i->base() + __n;\x0a"
"    return this->__begin_ <= __p \x26\x26 __p <= this->__end_;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"bool\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__subscriptable(const const_iterator* __i, ptrdiff_t __n) const\x0a"
"{\x0a"
"    const_pointer __p = __i->base() + __n;\x0a"
"    return this->__begin_ <= __p \x26\x26 __p < this->__end_;\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__invalidate_all_iterators()\x0a"
"{\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"    __get_db()->__invalidate_all(this);\x0a"
"#endif  // _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"}\x0a"
"\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"vector<_Tp, _Allocator>\x3a\x3a__invalidate_iterators_past(pointer __new_last) {\x0a"
"#if _LIBCPP_DEBUG_LEVEL >= 2\x0a"
"  __c_node* __c = __get_db()->__find_c_and_lock(this);\x0a"
"  for (__i_node** __p = __c->end_; __p \x21= __c->beg_; ) {\x0a"
"    --__p;\x0a"
"    const_iterator* __i = static_cast<const_iterator*>((*__p)->__i_);\x0a"
"    if (__i->base() > __new_last) {\x0a"
"      (*__p)->__c_ = nullptr;\x0a"
"      if (--__c->end_ \x21= __p)\x0a"
"        memmove(__p, __p+1, (__c->end_ - __p)*sizeof(__i_node*));\x0a"
"    }\x0a"
"  }\x0a"
"  __get_db()->unlock();\x0a"
"#else\x0a"
"  ((void)__new_last);\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"// vector<bool>\x0a"
"\x0a"
"template <class _Allocator> class vector<bool, _Allocator>;\x0a"
"\x0a"
"template <class _Allocator> struct hash<vector<bool, _Allocator> >;\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"struct __has_storage_type<vector<bool, _Allocator> >\x0a"
"{\x0a"
"    static const bool value = true;\x0a"
"};\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"class _LIBCPP_TEMPLATE_VIS vector<bool, _Allocator>\x0a"
"    \x3a private __vector_base_common<true>\x0a"
"{\x0a"
"public\x3a\x0a"
"    typedef vector                                   __self;\x0a"
"    typedef bool                                     value_type;\x0a"
"    typedef _Allocator                               allocator_type;\x0a"
"    typedef allocator_traits<allocator_type>         __alloc_traits;\x0a"
"    typedef typename __alloc_traits\x3a\x3asize_type       size_type;\x0a"
"    typedef typename __alloc_traits\x3a\x3a""difference_type difference_type;\x0a"
"    typedef size_type __storage_type;\x0a"
"    typedef __bit_iterator<vector, false>            pointer;\x0a"
"    typedef __bit_iterator<vector, true>             const_pointer;\x0a"
"    typedef pointer                                  iterator;\x0a"
"    typedef const_pointer                            const_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<iterator>         reverse_iterator;\x0a"
"    typedef _VSTD\x3a\x3areverse_iterator<const_iterator>   const_reverse_iterator;\x0a"
"\x0a"
"private\x3a\x0a"
"    typedef typename __rebind_alloc_helper<__alloc_traits, __storage_type>\x3a\x3atype __storage_allocator;\x0a"
"    typedef allocator_traits<__storage_allocator>    __storage_traits;\x0a"
"    typedef typename __storage_traits\x3a\x3apointer       __storage_pointer;\x0a"
"    typedef typename __storage_traits\x3a\x3a""const_pointer __const_storage_pointer;\x0a"
"\x0a"
"    __storage_pointer                                      __begin_;\x0a"
"    size_type                                              __size_;\x0a"
"    __compressed_pair<size_type, __storage_allocator> __cap_alloc_;\x0a"
"public\x3a\x0a"
"    typedef __bit_reference<vector>                  reference;\x0a"
"    typedef __bit_const_reference<vector>            const_reference;\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type\x26 __cap() _NOEXCEPT\x0a"
"        {return __cap_alloc_.first();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const size_type\x26 __cap() const _NOEXCEPT\x0a"
"        {return __cap_alloc_.first();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    __storage_allocator\x26 __alloc() _NOEXCEPT\x0a"
"        {return __cap_alloc_.second();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const __storage_allocator\x26 __alloc() const _NOEXCEPT\x0a"
"        {return __cap_alloc_.second();}\x0a"
"\x0a"
"    static const unsigned __bits_per_word = static_cast<unsigned>(sizeof(__storage_type) * CHAR_BIT);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static size_type __internal_cap_to_external(size_type __n) _NOEXCEPT\x0a"
"        {return __n * __bits_per_word;}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static size_type __external_cap_to_internal(size_type __n) _NOEXCEPT\x0a"
"        {return (__n - 1) / __bits_per_word + 1;}\x0a"
"\x0a"
"public\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector() _NOEXCEPT_(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY explicit vector(const allocator_type\x26 __a)\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<allocator_type>\x3a\x3avalue);\x0a"
"#else\x0a"
"        _NOEXCEPT;\x0a"
"#endif\x0a"
"    \x7evector();\x0a"
"    explicit vector(size_type __n);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    explicit vector(size_type __n, const allocator_type\x26 __a);\x0a"
"#endif\x0a"
"    vector(size_type __n, const value_type\x26 __v);\x0a"
"    vector(size_type __n, const value_type\x26 __v, const allocator_type\x26 __a);\x0a"
"    template <class _InputIterator>\x0a"
"        vector(_InputIterator __first, _InputIterator __last,\x0a"
"               typename enable_if<__is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                                 \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _InputIterator>\x0a"
"        vector(_InputIterator __first, _InputIterator __last, const allocator_type\x26 __a,\x0a"
"               typename enable_if<__is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                                 \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _ForwardIterator>\x0a"
"        vector(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"               typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"    template <class _ForwardIterator>\x0a"
"        vector(_ForwardIterator __first, _ForwardIterator __last, const allocator_type\x26 __a,\x0a"
"               typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue>\x3a\x3atype* = 0);\x0a"
"\x0a"
"    vector(const vector\x26 __v);\x0a"
"    vector(const vector\x26 __v, const allocator_type\x26 __a);\x0a"
"    vector\x26 operator=(const vector\x26 __v);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    vector(initializer_list<value_type> __il);\x0a"
"    vector(initializer_list<value_type> __il, const allocator_type\x26 __a);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector(vector\x26\x26 __v)\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        _NOEXCEPT;\x0a"
"#else\x0a"
"        _NOEXCEPT_(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue);\x0a"
"#endif\x0a"
"    vector(vector\x26\x26 __v, const allocator_type\x26 __a);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector\x26 operator=(vector\x26\x26 __v)\x0a"
"        _NOEXCEPT_((__noexcept_move_assign_container<_Allocator, __alloc_traits>\x3a\x3avalue));\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    vector\x26 operator=(initializer_list<value_type> __il)\x0a"
"        {assign(__il.begin(), __il.end()); return *this;}\x0a"
"\x0a"
"#endif  // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"    template <class _InputIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_input_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"           \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"           void\x0a"
"        >\x3a\x3atype\x0a"
"        assign(_InputIterator __first, _InputIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"           void\x0a"
"        >\x3a\x3atype\x0a"
"        assign(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"\x0a"
"    void assign(size_type __n, const value_type\x26 __x);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void assign(initializer_list<value_type> __il)\x0a"
"        {assign(__il.begin(), __il.end());}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY allocator_type get_allocator() const _NOEXCEPT\x0a"
"        {return allocator_type(this->__alloc());}\x0a"
"\x0a"
"    size_type max_size() const _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type capacity() const _NOEXCEPT\x0a"
"        {return __internal_cap_to_external(__cap());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_type size() const _NOEXCEPT\x0a"
"        {return __size_;}\x0a"
"    _LIBCPP_NODISCARD_AFTER_CXX17 _LIBCPP_INLINE_VISIBILITY\x0a"
"    bool empty() const _NOEXCEPT\x0a"
"        {return __size_ == 0;}\x0a"
"    void reserve(size_type __n);\x0a"
"    void shrink_to_fit() _NOEXCEPT;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator begin() _NOEXCEPT\x0a"
"        {return __make_iter(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator begin() const _NOEXCEPT\x0a"
"        {return __make_iter(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator end() _NOEXCEPT\x0a"
"        {return __make_iter(__size_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator end()   const _NOEXCEPT\x0a"
"        {return __make_iter(__size_);}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reverse_iterator rbegin() _NOEXCEPT\x0a"
"        {return       reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rbegin() const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(end());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reverse_iterator rend() _NOEXCEPT\x0a"
"        {return       reverse_iterator(begin());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator rend()   const _NOEXCEPT\x0a"
"        {return const_reverse_iterator(begin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator         cbegin()  const _NOEXCEPT\x0a"
"        {return __make_iter(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator         cend()    const _NOEXCEPT\x0a"
"        {return __make_iter(__size_);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crbegin() const _NOEXCEPT\x0a"
"        {return rbegin();}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reverse_iterator crend()   const _NOEXCEPT\x0a"
"        {return rend();}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference       operator\x5b\x5d(size_type __n)       {return __make_ref(__n);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_reference operator\x5b\x5d(size_type __n) const {return __make_ref(__n);}\x0a"
"    reference       at(size_type __n);\x0a"
"    const_reference at(size_type __n) const;\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference       front()       {return __make_ref(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_reference front() const {return __make_ref(0);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference       back()        {return __make_ref(__size_ - 1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY const_reference back()  const {return __make_ref(__size_ - 1);}\x0a"
"\x0a"
"    void push_back(const value_type\x26 __x);\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <class... _Args>\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _LIBCPP_INLINE_VISIBILITY reference emplace_back(_Args\x26\x26... __args)\x0a"
"#else\x0a"
"    _LIBCPP_INLINE_VISIBILITY void      emplace_back(_Args\x26\x26... __args)\x0a"
"#endif\x0a"
"    {\x0a"
"        push_back ( value_type ( _VSTD\x3a\x3a""forward<_Args>(__args)... ));\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"        return this->back();\x0a"
"#endif\x0a"
"    }\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY void pop_back() {--__size_;}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"    template <class... _Args>\x0a"
"   _LIBCPP_INLINE_VISIBILITY iterator emplace(const_iterator position, _Args\x26\x26... __args)\x0a"
"        { return insert ( position, value_type ( _VSTD\x3a\x3a""forward<_Args>(__args)... )); }\x0a"
"#endif\x0a"
"\x0a"
"    iterator insert(const_iterator __position, const value_type\x26 __x);\x0a"
"    iterator insert(const_iterator __position, size_type __n, const value_type\x26 __x);\x0a"
"    iterator insert(const_iterator __position, size_type __n, const_reference __x);\x0a"
"    template <class _InputIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"             __is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"            \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"            iterator\x0a"
"        >\x3a\x3atype\x0a"
"        insert(const_iterator __position, _InputIterator __first, _InputIterator __last);\x0a"
"    template <class _ForwardIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"            iterator\x0a"
"        >\x3a\x3atype\x0a"
"        insert(const_iterator __position, _ForwardIterator __first, _ForwardIterator __last);\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator insert(const_iterator __position, initializer_list<value_type> __il)\x0a"
"        {return insert(__position, __il.begin(), __il.end());}\x0a"
"#endif\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY iterator erase(const_iterator __position);\x0a"
"    iterator erase(const_iterator __first, const_iterator __last);\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void clear() _NOEXCEPT {__size_ = 0;}\x0a"
"\x0a"
"    void swap(vector\x26)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"        _NOEXCEPT;\x0a"
"#else\x0a"
"        _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                    __is_nothrow_swappable<allocator_type>\x3a\x3avalue);\x0a"
"#endif\x0a"
"    static void swap(reference __x, reference __y) _NOEXCEPT { _VSTD\x3a\x3aswap(__x, __y); }\x0a"
"\x0a"
"    void resize(size_type __sz, value_type __x = false);\x0a"
"    void flip() _NOEXCEPT;\x0a"
"\x0a"
"    bool __invariants() const;\x0a"
"\x0a"
"private\x3a\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __invalidate_all_iterators();\x0a"
"    void __vallocate(size_type __n);\x0a"
"    void __vdeallocate() _NOEXCEPT;\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    static size_type __align_it(size_type __new_size) _NOEXCEPT\x0a"
"        {return __new_size + (__bits_per_word-1) \x26 \x7e((size_type)__bits_per_word-1);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY  size_type __recommend(size_type __new_size) const;\x0a"
"    _LIBCPP_INLINE_VISIBILITY void __construct_at_end(size_type __n, bool __x);\x0a"
"    template <class _ForwardIterator>\x0a"
"        typename enable_if\x0a"
"        <\x0a"
"            __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"            void\x0a"
"        >\x3a\x3atype\x0a"
"        __construct_at_end(_ForwardIterator __first, _ForwardIterator __last);\x0a"
"    void __append(size_type __n, const_reference __x);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    reference __make_ref(size_type __pos) _NOEXCEPT\x0a"
"        {return reference(__begin_ + __pos / __bits_per_word, __storage_type(1) << __pos \x25 __bits_per_word);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_reference __make_ref(size_type __pos) const _NOEXCEPT\x0a"
"        {return const_reference(__begin_ + __pos / __bits_per_word, __storage_type(1) << __pos \x25 __bits_per_word);}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __make_iter(size_type __pos) _NOEXCEPT\x0a"
"        {return iterator(__begin_ + __pos / __bits_per_word, static_cast<unsigned>(__pos \x25 __bits_per_word));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    const_iterator __make_iter(size_type __pos) const _NOEXCEPT\x0a"
"        {return const_iterator(__begin_ + __pos / __bits_per_word, static_cast<unsigned>(__pos \x25 __bits_per_word));}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    iterator __const_iterator_cast(const_iterator __p) _NOEXCEPT\x0a"
"        {return begin() + (__p - cbegin());}\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const vector\x26 __v)\x0a"
"        {__copy_assign_alloc(__v, integral_constant<bool,\x0a"
"                      __storage_traits\x3a\x3apropagate_on_container_copy_assignment\x3a\x3avalue>());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const vector\x26 __c, true_type)\x0a"
"        {\x0a"
"            if (__alloc() \x21= __c.__alloc())\x0a"
"                __vdeallocate();\x0a"
"            __alloc() = __c.__alloc();\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __copy_assign_alloc(const vector\x26, false_type)\x0a"
"        {}\x0a"
"\x0a"
"    void __move_assign(vector\x26 __c, false_type);\x0a"
"    void __move_assign(vector\x26 __c, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue);\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(vector\x26 __c)\x0a"
"        _NOEXCEPT_(\x0a"
"            \x21__storage_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue \x7c\x7c\x0a"
"            is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"        {__move_assign_alloc(__c, integral_constant<bool,\x0a"
"                      __storage_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());}\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(vector\x26 __c, true_type)\x0a"
"        _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"        {\x0a"
"            __alloc() = _VSTD\x3a\x3amove(__c.__alloc());\x0a"
"        }\x0a"
"\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    void __move_assign_alloc(vector\x26, false_type)\x0a"
"        _NOEXCEPT\x0a"
"        {}\x0a"
"\x0a"
"    size_t __hash_code() const _NOEXCEPT;\x0a"
"\x0a"
"    friend class __bit_reference<vector>;\x0a"
"    friend class __bit_const_reference<vector>;\x0a"
"    friend class __bit_iterator<vector, false>;\x0a"
"    friend class __bit_iterator<vector, true>;\x0a"
"    friend struct __bit_array<vector>;\x0a"
"    friend struct _LIBCPP_TEMPLATE_VIS hash<vector>;\x0a"
"};\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3a__invalidate_all_iterators()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"//  Allocate space for __n objects\x0a"
"//  throws length_error if __n > max_size()\x0a"
"//  throws (probably bad_alloc) if memory run out\x0a"
"//  Precondition\x3a  __begin_ == __end_ == __cap() == 0\x0a"
"//  Precondition\x3a  __n > 0\x0a"
"//  Postcondition\x3a  capacity() == __n\x0a"
"//  Postcondition\x3a  size() == 0\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3a__vallocate(size_type __n)\x0a"
"{\x0a"
"    if (__n > max_size())\x0a"
"        this->__throw_length_error();\x0a"
"    __n = __external_cap_to_internal(__n);\x0a"
"    this->__begin_ = __storage_traits\x3a\x3a""allocate(this->__alloc(), __n);\x0a"
"    this->__size_ = 0;\x0a"
"    this->__cap() = __n;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3a__vdeallocate() _NOEXCEPT\x0a"
"{\x0a"
"    if (this->__begin_ \x21= nullptr)\x0a"
"    {\x0a"
"        __storage_traits\x3a\x3a""deallocate(this->__alloc(), this->__begin_, __cap());\x0a"
"        __invalidate_all_iterators();\x0a"
"        this->__begin_ = nullptr;\x0a"
"        this->__size_ = this->__cap() = 0;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"typename vector<bool, _Allocator>\x3a\x3asize_type\x0a"
"vector<bool, _Allocator>\x3a\x3amax_size() const _NOEXCEPT\x0a"
"{\x0a"
"    size_type __amax = __storage_traits\x3a\x3amax_size(__alloc());\x0a"
"    size_type __nmax = numeric_limits<size_type>\x3a\x3amax() / 2;  // end() >= begin(), always\x0a"
"    if (__nmax / __bits_per_word <= __amax)\x0a"
"        return __nmax;\x0a"
"    return __internal_cap_to_external(__amax);\x0a"
"}\x0a"
"\x0a"
"//  Precondition\x3a  __new_size > capacity()\x0a"
"template <class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<bool, _Allocator>\x3a\x3asize_type\x0a"
"vector<bool, _Allocator>\x3a\x3a__recommend(size_type __new_size) const\x0a"
"{\x0a"
"    const size_type __ms = max_size();\x0a"
"    if (__new_size > __ms)\x0a"
"        this->__throw_length_error();\x0a"
"    const size_type __cap = capacity();\x0a"
"    if (__cap >= __ms / 2)\x0a"
"        return __ms;\x0a"
"    return _VSTD\x3a\x3amax(2*__cap, __align_it(__new_size));\x0a"
"}\x0a"
"\x0a"
"//  Default constructs __n objects starting at __end_\x0a"
"//  Precondition\x3a  __n > 0\x0a"
"//  Precondition\x3a  size() + __n <= capacity()\x0a"
"//  Postcondition\x3a  size() == size() + __n\x0a"
"template <class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3a__construct_at_end(size_type __n, bool __x)\x0a"
"{\x0a"
"    size_type __old_size = this->__size_;\x0a"
"    this->__size_ += __n;\x0a"
"    if (__old_size == 0 \x7c\x7c ((__old_size - 1) / __bits_per_word) \x21= ((this->__size_ - 1) / __bits_per_word))\x0a"
"    {\x0a"
"        if (this->__size_ <= __bits_per_word)\x0a"
"            this->__begin_\x5b""0\x5d = __storage_type(0);\x0a"
"        else\x0a"
"            this->__begin_\x5b(this->__size_ - 1) / __bits_per_word\x5d = __storage_type(0);\x0a"
"    }\x0a"
"    _VSTD\x3a\x3a""fill_n(__make_iter(__old_size), __n, __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"    void\x0a"
">\x3a\x3atype\x0a"
"vector<bool, _Allocator>\x3a\x3a__construct_at_end(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    size_type __old_size = this->__size_;\x0a"
"    this->__size_ += _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    if (__old_size == 0 \x7c\x7c ((__old_size - 1) / __bits_per_word) \x21= ((this->__size_ - 1) / __bits_per_word))\x0a"
"    {\x0a"
"        if (this->__size_ <= __bits_per_word)\x0a"
"            this->__begin_\x5b""0\x5d = __storage_type(0);\x0a"
"        else\x0a"
"            this->__begin_\x5b(this->__size_ - 1) / __bits_per_word\x5d = __storage_type(0);\x0a"
"    }\x0a"
"    _VSTD\x3a\x3a""copy(__first, __last, __make_iter(__old_size));\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"vector<bool, _Allocator>\x3a\x3avector()\x0a"
"    _NOEXCEPT_(is_nothrow_default_constructible<allocator_type>\x3a\x3avalue)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"vector<bool, _Allocator>\x3a\x3avector(const allocator_type\x26 __a)\x0a"
"#if _LIBCPP_STD_VER <= 14\x0a"
"        _NOEXCEPT_(is_nothrow_copy_constructible<allocator_type>\x3a\x3avalue)\x0a"
"#else\x0a"
"        _NOEXCEPT\x0a"
"#endif\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0, static_cast<__storage_allocator>(__a))\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(size_type __n)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0)\x0a"
"{\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__n, false);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 11\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(size_type __n, const allocator_type\x26 __a)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0, static_cast<__storage_allocator>(__a))\x0a"
"{\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__n, false);\x0a"
"    }\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(size_type __n, const value_type\x26 __x)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0)\x0a"
"{\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__n, __x);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(size_type __n, const value_type\x26 __x, const allocator_type\x26 __a)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0, static_cast<__storage_allocator>(__a))\x0a"
"{\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__n, __x);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"template <class _InputIterator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(_InputIterator __first, _InputIterator __last,\x0a"
"       typename enable_if<__is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                         \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        for (; __first \x21= __last; ++__first)\x0a"
"            push_back(*__first);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        if (__begin_ \x21= nullptr)\x0a"
"            __storage_traits\x3a\x3a""deallocate(__alloc(), __begin_, __cap());\x0a"
"        __invalidate_all_iterators();\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"template <class _InputIterator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(_InputIterator __first, _InputIterator __last, const allocator_type\x26 __a,\x0a"
"       typename enable_if<__is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"                         \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0, static_cast<__storage_allocator>(__a))\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        for (; __first \x21= __last; ++__first)\x0a"
"            push_back(*__first);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        if (__begin_ \x21= nullptr)\x0a"
"            __storage_traits\x3a\x3a""deallocate(__alloc(), __begin_, __cap());\x0a"
"        __invalidate_all_iterators();\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(_ForwardIterator __first, _ForwardIterator __last,\x0a"
"                                typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0)\x0a"
"{\x0a"
"    size_type __n = static_cast<size_type>(_VSTD\x3a\x3a""distance(__first, __last));\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__first, __last);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(_ForwardIterator __first, _ForwardIterator __last, const allocator_type\x26 __a,\x0a"
"                                typename enable_if<__is_forward_iterator<_ForwardIterator>\x3a\x3avalue>\x3a\x3atype*)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0, static_cast<__storage_allocator>(__a))\x0a"
"{\x0a"
"    size_type __n = static_cast<size_type>(_VSTD\x3a\x3a""distance(__first, __last));\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__first, __last);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(initializer_list<value_type> __il)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0)\x0a"
"{\x0a"
"    size_type __n = static_cast<size_type>(__il.size());\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__il.begin(), __il.end());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(initializer_list<value_type> __il, const allocator_type\x26 __a)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0, static_cast<__storage_allocator>(__a))\x0a"
"{\x0a"
"    size_type __n = static_cast<size_type>(__il.size());\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __vallocate(__n);\x0a"
"        __construct_at_end(__il.begin(), __il.end());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"#endif  // _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x3a\x3a\x7evector()\x0a"
"{\x0a"
"    if (__begin_ \x21= nullptr)\x0a"
"        __storage_traits\x3a\x3a""deallocate(__alloc(), __begin_, __cap());\x0a"
"    __invalidate_all_iterators();\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(const vector\x26 __v)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0, __storage_traits\x3a\x3aselect_on_container_copy_construction(__v.__alloc()))\x0a"
"{\x0a"
"    if (__v.size() > 0)\x0a"
"    {\x0a"
"        __vallocate(__v.size());\x0a"
"        __construct_at_end(__v.begin(), __v.end());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(const vector\x26 __v, const allocator_type\x26 __a)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0, __a)\x0a"
"{\x0a"
"    if (__v.size() > 0)\x0a"
"    {\x0a"
"        __vallocate(__v.size());\x0a"
"        __construct_at_end(__v.begin(), __v.end());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x26\x0a"
"vector<bool, _Allocator>\x3a\x3aoperator=(const vector\x26 __v)\x0a"
"{\x0a"
"    if (this \x21= \x26__v)\x0a"
"    {\x0a"
"        __copy_assign_alloc(__v);\x0a"
"        if (__v.__size_)\x0a"
"        {\x0a"
"            if (__v.__size_ > capacity())\x0a"
"            {\x0a"
"                __vdeallocate();\x0a"
"                __vallocate(__v.__size_);\x0a"
"            }\x0a"
"            _VSTD\x3a\x3a""copy(__v.__begin_, __v.__begin_ + __external_cap_to_internal(__v.__size_), __begin_);\x0a"
"        }\x0a"
"        __size_ = __v.__size_;\x0a"
"    }\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"#ifndef _LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY vector<bool, _Allocator>\x3a\x3avector(vector\x26\x26 __v)\x0a"
"#if _LIBCPP_STD_VER > 14\x0a"
"    _NOEXCEPT\x0a"
"#else\x0a"
"    _NOEXCEPT_(is_nothrow_move_constructible<allocator_type>\x3a\x3avalue)\x0a"
"#endif\x0a"
"    \x3a __begin_(__v.__begin_),\x0a"
"      __size_(__v.__size_),\x0a"
"      __cap_alloc_(std\x3a\x3amove(__v.__cap_alloc_)) {\x0a"
"    __v.__begin_ = nullptr;\x0a"
"    __v.__size_ = 0;\x0a"
"    __v.__cap() = 0;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"vector<bool, _Allocator>\x3a\x3avector(vector\x26\x26 __v, const allocator_type\x26 __a)\x0a"
"    \x3a __begin_(nullptr),\x0a"
"      __size_(0),\x0a"
"      __cap_alloc_(0, __a)\x0a"
"{\x0a"
"    if (__a == allocator_type(__v.__alloc()))\x0a"
"    {\x0a"
"        this->__begin_ = __v.__begin_;\x0a"
"        this->__size_ = __v.__size_;\x0a"
"        this->__cap() = __v.__cap();\x0a"
"        __v.__begin_ = nullptr;\x0a"
"        __v.__cap() = __v.__size_ = 0;\x0a"
"    }\x0a"
"    else if (__v.size() > 0)\x0a"
"    {\x0a"
"        __vallocate(__v.size());\x0a"
"        __construct_at_end(__v.begin(), __v.end());\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"vector<bool, _Allocator>\x26\x0a"
"vector<bool, _Allocator>\x3a\x3aoperator=(vector\x26\x26 __v)\x0a"
"    _NOEXCEPT_((__noexcept_move_assign_container<_Allocator, __alloc_traits>\x3a\x3avalue))\x0a"
"{\x0a"
"    __move_assign(__v, integral_constant<bool,\x0a"
"          __storage_traits\x3a\x3apropagate_on_container_move_assignment\x3a\x3avalue>());\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3a__move_assign(vector\x26 __c, false_type)\x0a"
"{\x0a"
"    if (__alloc() \x21= __c.__alloc())\x0a"
"        assign(__c.begin(), __c.end());\x0a"
"    else\x0a"
"        __move_assign(__c, true_type());\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3a__move_assign(vector\x26 __c, true_type)\x0a"
"    _NOEXCEPT_(is_nothrow_move_assignable<allocator_type>\x3a\x3avalue)\x0a"
"{\x0a"
"    __vdeallocate();\x0a"
"    __move_assign_alloc(__c);\x0a"
"    this->__begin_ = __c.__begin_;\x0a"
"    this->__size_ = __c.__size_;\x0a"
"    this->__cap() = __c.__cap();\x0a"
"    __c.__begin_ = nullptr;\x0a"
"    __c.__cap() = __c.__size_ = 0;\x0a"
"}\x0a"
"\x0a"
"#endif  // \x21_LIBCPP_CXX03_LANG\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3a""assign(size_type __n, const value_type\x26 __x)\x0a"
"{\x0a"
"    __size_ = 0;\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        size_type __c = capacity();\x0a"
"        if (__n <= __c)\x0a"
"            __size_ = __n;\x0a"
"        else\x0a"
"        {\x0a"
"            vector __v(__alloc());\x0a"
"            __v.reserve(__recommend(__n));\x0a"
"            __v.__size_ = __n;\x0a"
"            swap(__v);\x0a"
"        }\x0a"
"        _VSTD\x3a\x3a""fill_n(begin(), __n, __x);\x0a"
"    }\x0a"
"  __invalidate_all_iterators();\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"template <class _InputIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_input_iterator<_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"   \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"   void\x0a"
">\x3a\x3atype\x0a"
"vector<bool, _Allocator>\x3a\x3a""assign(_InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    clear();\x0a"
"    for (; __first \x21= __last; ++__first)\x0a"
"        push_back(*__first);\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"   void\x0a"
">\x3a\x3atype\x0a"
"vector<bool, _Allocator>\x3a\x3a""assign(_ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    clear();\x0a"
"    difference_type __ns = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    _LIBCPP_ASSERT(__ns >= 0, \x22invalid range specified\x22);\x0a"
"    const size_t __n = static_cast<size_type>(__ns);\x0a"
"    if (__n)\x0a"
"    {\x0a"
"        if (__n > capacity())\x0a"
"        {\x0a"
"            __vdeallocate();\x0a"
"            __vallocate(__n);\x0a"
"        }\x0a"
"        __construct_at_end(__first, __last);\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3areserve(size_type __n)\x0a"
"{\x0a"
"    if (__n > capacity())\x0a"
"    {\x0a"
"        vector __v(this->__alloc());\x0a"
"        __v.__vallocate(__n);\x0a"
"        __v.__construct_at_end(this->begin(), this->end());\x0a"
"        swap(__v);\x0a"
"        __invalidate_all_iterators();\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3ashrink_to_fit() _NOEXCEPT\x0a"
"{\x0a"
"    if (__external_cap_to_internal(size()) > __cap())\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            vector(*this, allocator_type(__alloc())).swap(*this);\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"typename vector<bool, _Allocator>\x3a\x3areference\x0a"
"vector<bool, _Allocator>\x3a\x3a""at(size_type __n)\x0a"
"{\x0a"
"    if (__n >= size())\x0a"
"        this->__throw_out_of_range();\x0a"
"    return (*this)\x5b__n\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"typename vector<bool, _Allocator>\x3a\x3a""const_reference\x0a"
"vector<bool, _Allocator>\x3a\x3a""at(size_type __n) const\x0a"
"{\x0a"
"    if (__n >= size())\x0a"
"        this->__throw_out_of_range();\x0a"
"    return (*this)\x5b__n\x5d;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3apush_back(const value_type\x26 __x)\x0a"
"{\x0a"
"    if (this->__size_ == this->capacity())\x0a"
"        reserve(__recommend(this->__size_ + 1));\x0a"
"    ++this->__size_;\x0a"
"    back() = __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"typename vector<bool, _Allocator>\x3a\x3aiterator\x0a"
"vector<bool, _Allocator>\x3a\x3ainsert(const_iterator __position, const value_type\x26 __x)\x0a"
"{\x0a"
"    iterator __r;\x0a"
"    if (size() < capacity())\x0a"
"    {\x0a"
"        const_iterator __old_end = end();\x0a"
"        ++__size_;\x0a"
"        _VSTD\x3a\x3a""copy_backward(__position, __old_end, end());\x0a"
"        __r = __const_iterator_cast(__position);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        vector __v(__alloc());\x0a"
"        __v.reserve(__recommend(__size_ + 1));\x0a"
"        __v.__size_ = __size_ + 1;\x0a"
"        __r = _VSTD\x3a\x3a""copy(cbegin(), __position, __v.begin());\x0a"
"        _VSTD\x3a\x3a""copy_backward(__position, cend(), __v.end());\x0a"
"        swap(__v);\x0a"
"    }\x0a"
"    *__r = __x;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"typename vector<bool, _Allocator>\x3a\x3aiterator\x0a"
"vector<bool, _Allocator>\x3a\x3ainsert(const_iterator __position, size_type __n, const value_type\x26 __x)\x0a"
"{\x0a"
"    iterator __r;\x0a"
"    size_type __c = capacity();\x0a"
"    if (__n <= __c \x26\x26 size() <= __c - __n)\x0a"
"    {\x0a"
"        const_iterator __old_end = end();\x0a"
"        __size_ += __n;\x0a"
"        _VSTD\x3a\x3a""copy_backward(__position, __old_end, end());\x0a"
"        __r = __const_iterator_cast(__position);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        vector __v(__alloc());\x0a"
"        __v.reserve(__recommend(__size_ + __n));\x0a"
"        __v.__size_ = __size_ + __n;\x0a"
"        __r = _VSTD\x3a\x3a""copy(cbegin(), __position, __v.begin());\x0a"
"        _VSTD\x3a\x3a""copy_backward(__position, cend(), __v.end());\x0a"
"        swap(__v);\x0a"
"    }\x0a"
"    _VSTD\x3a\x3a""fill_n(__r, __n, __x);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"template <class _InputIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"     __is_input_iterator  <_InputIterator>\x3a\x3avalue \x26\x26\x0a"
"    \x21__is_forward_iterator<_InputIterator>\x3a\x3avalue,\x0a"
"    typename vector<bool, _Allocator>\x3a\x3aiterator\x0a"
">\x3a\x3atype\x0a"
"vector<bool, _Allocator>\x3a\x3ainsert(const_iterator __position, _InputIterator __first, _InputIterator __last)\x0a"
"{\x0a"
"    difference_type __off = __position - begin();\x0a"
"    iterator __p = __const_iterator_cast(__position);\x0a"
"    iterator __old_end = end();\x0a"
"    for (; size() \x21= capacity() \x26\x26 __first \x21= __last; ++__first)\x0a"
"    {\x0a"
"        ++this->__size_;\x0a"
"        back() = *__first;\x0a"
"    }\x0a"
"    vector __v(__alloc());\x0a"
"    if (__first \x21= __last)\x0a"
"    {\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        try\x0a"
"        {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"            __v.assign(__first, __last);\x0a"
"            difference_type __old_size = static_cast<difference_type>(__old_end - begin());\x0a"
"            difference_type __old_p = __p - begin();\x0a"
"            reserve(__recommend(size() + __v.size()));\x0a"
"            __p = begin() + __old_p;\x0a"
"            __old_end = begin() + __old_size;\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"        }\x0a"
"        catch (...)\x0a"
"        {\x0a"
"            erase(__old_end, end());\x0a"
"            throw;\x0a"
"        }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    __p = _VSTD\x3a\x3arotate(__p, __old_end, end());\x0a"
"    insert(__p, __v.begin(), __v.end());\x0a"
"    return begin() + __off;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"template <class _ForwardIterator>\x0a"
"typename enable_if\x0a"
"<\x0a"
"    __is_forward_iterator<_ForwardIterator>\x3a\x3avalue,\x0a"
"    typename vector<bool, _Allocator>\x3a\x3aiterator\x0a"
">\x3a\x3atype\x0a"
"vector<bool, _Allocator>\x3a\x3ainsert(const_iterator __position, _ForwardIterator __first, _ForwardIterator __last)\x0a"
"{\x0a"
"    const difference_type __n_signed = _VSTD\x3a\x3a""distance(__first, __last);\x0a"
"    _LIBCPP_ASSERT(__n_signed >= 0, \x22invalid range specified\x22);\x0a"
"    const size_type __n = static_cast<size_type>(__n_signed);\x0a"
"    iterator __r;\x0a"
"    size_type __c = capacity();\x0a"
"    if (__n <= __c \x26\x26 size() <= __c - __n)\x0a"
"    {\x0a"
"        const_iterator __old_end = end();\x0a"
"        __size_ += __n;\x0a"
"        _VSTD\x3a\x3a""copy_backward(__position, __old_end, end());\x0a"
"        __r = __const_iterator_cast(__position);\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        vector __v(__alloc());\x0a"
"        __v.reserve(__recommend(__size_ + __n));\x0a"
"        __v.__size_ = __size_ + __n;\x0a"
"        __r = _VSTD\x3a\x3a""copy(cbegin(), __position, __v.begin());\x0a"
"        _VSTD\x3a\x3a""copy_backward(__position, cend(), __v.end());\x0a"
"        swap(__v);\x0a"
"    }\x0a"
"    _VSTD\x3a\x3a""copy(__first, __last, __r);\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"typename vector<bool, _Allocator>\x3a\x3aiterator\x0a"
"vector<bool, _Allocator>\x3a\x3a""erase(const_iterator __position)\x0a"
"{\x0a"
"    iterator __r = __const_iterator_cast(__position);\x0a"
"    _VSTD\x3a\x3a""copy(__position + 1, this->cend(), __r);\x0a"
"    --__size_;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"typename vector<bool, _Allocator>\x3a\x3aiterator\x0a"
"vector<bool, _Allocator>\x3a\x3a""erase(const_iterator __first, const_iterator __last)\x0a"
"{\x0a"
"    iterator __r = __const_iterator_cast(__first);\x0a"
"    difference_type __d = __last - __first;\x0a"
"    _VSTD\x3a\x3a""copy(__last, this->cend(), __r);\x0a"
"    __size_ -= __d;\x0a"
"    return __r;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3aswap(vector\x26 __x)\x0a"
"#if _LIBCPP_STD_VER >= 14\x0a"
"    _NOEXCEPT\x0a"
"#else\x0a"
"    _NOEXCEPT_(\x21__alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue \x7c\x7c\x0a"
"                __is_nothrow_swappable<allocator_type>\x3a\x3avalue)\x0a"
"#endif\x0a"
"{\x0a"
"    _VSTD\x3a\x3aswap(this->__begin_, __x.__begin_);\x0a"
"    _VSTD\x3a\x3aswap(this->__size_, __x.__size_);\x0a"
"    _VSTD\x3a\x3aswap(this->__cap(), __x.__cap());\x0a"
"    __swap_allocator(this->__alloc(), __x.__alloc(),\x0a"
"        integral_constant<bool, __alloc_traits\x3a\x3apropagate_on_container_swap\x3a\x3avalue>());\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3aresize(size_type __sz, value_type __x)\x0a"
"{\x0a"
"    size_type __cs = size();\x0a"
"    if (__cs < __sz)\x0a"
"    {\x0a"
"        iterator __r;\x0a"
"        size_type __c = capacity();\x0a"
"        size_type __n = __sz - __cs;\x0a"
"        if (__n <= __c \x26\x26 __cs <= __c - __n)\x0a"
"        {\x0a"
"            __r = end();\x0a"
"            __size_ += __n;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            vector __v(__alloc());\x0a"
"            __v.reserve(__recommend(__size_ + __n));\x0a"
"            __v.__size_ = __size_ + __n;\x0a"
"            __r = _VSTD\x3a\x3a""copy(cbegin(), cend(), __v.begin());\x0a"
"            swap(__v);\x0a"
"        }\x0a"
"        _VSTD\x3a\x3a""fill_n(__r, __n, __x);\x0a"
"    }\x0a"
"    else\x0a"
"        __size_ = __sz;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"void\x0a"
"vector<bool, _Allocator>\x3a\x3a""flip() _NOEXCEPT\x0a"
"{\x0a"
"    // do middle whole words\x0a"
"    size_type __n = __size_;\x0a"
"    __storage_pointer __p = __begin_;\x0a"
"    for (; __n >= __bits_per_word; ++__p, __n -= __bits_per_word)\x0a"
"        *__p = \x7e*__p;\x0a"
"    // do last partial word\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        __storage_type __m = \x7e__storage_type(0) >> (__bits_per_word - __n);\x0a"
"        __storage_type __b = *__p \x26 __m;\x0a"
"        *__p \x26= \x7e__m;\x0a"
"        *__p \x7c= \x7e__b \x26 __m;\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"bool\x0a"
"vector<bool, _Allocator>\x3a\x3a__invariants() const\x0a"
"{\x0a"
"    if (this->__begin_ == nullptr)\x0a"
"    {\x0a"
"        if (this->__size_ \x21= 0 \x7c\x7c this->__cap() \x21= 0)\x0a"
"            return false;\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        if (this->__cap() == 0)\x0a"
"            return false;\x0a"
"        if (this->__size_ > this->capacity())\x0a"
"            return false;\x0a"
"    }\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"size_t\x0a"
"vector<bool, _Allocator>\x3a\x3a__hash_code() const _NOEXCEPT\x0a"
"{\x0a"
"    size_t __h = 0;\x0a"
"    // do middle whole words\x0a"
"    size_type __n = __size_;\x0a"
"    __storage_pointer __p = __begin_;\x0a"
"    for (; __n >= __bits_per_word; ++__p, __n -= __bits_per_word)\x0a"
"        __h ^= *__p;\x0a"
"    // do last partial word\x0a"
"    if (__n > 0)\x0a"
"    {\x0a"
"        const __storage_type __m = \x7e__storage_type(0) >> (__bits_per_word - __n);\x0a"
"        __h ^= *__p \x26 __m;\x0a"
"    }\x0a"
"    return __h;\x0a"
"}\x0a"
"\x0a"
"template <class _Allocator>\x0a"
"struct _LIBCPP_TEMPLATE_VIS hash<vector<bool, _Allocator> >\x0a"
"    \x3a public unary_function<vector<bool, _Allocator>, size_t>\x0a"
"{\x0a"
"    _LIBCPP_INLINE_VISIBILITY\x0a"
"    size_t operator()(const vector<bool, _Allocator>\x26 __vec) const _NOEXCEPT\x0a"
"        {return __vec.__hash_code();}\x0a"
"};\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator==(const vector<_Tp, _Allocator>\x26 __x, const vector<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    const typename vector<_Tp, _Allocator>\x3a\x3asize_type __sz = __x.size();\x0a"
"    return __sz == __y.size() \x26\x26 _VSTD\x3a\x3a""equal(__x.begin(), __x.end(), __y.begin());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator\x21=(const vector<_Tp, _Allocator>\x26 __x, const vector<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x == __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator< (const vector<_Tp, _Allocator>\x26 __x, const vector<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return _VSTD\x3a\x3alexicographical_compare(__x.begin(), __x.end(), __y.begin(), __y.end());\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator> (const vector<_Tp, _Allocator>\x26 __x, const vector<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return __y < __x;\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator>=(const vector<_Tp, _Allocator>\x26 __x, const vector<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__x < __y);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"bool\x0a"
"operator<=(const vector<_Tp, _Allocator>\x26 __x, const vector<_Tp, _Allocator>\x26 __y)\x0a"
"{\x0a"
"    return \x21(__y < __x);\x0a"
"}\x0a"
"\x0a"
"template <class _Tp, class _Allocator>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void\x0a"
"swap(vector<_Tp, _Allocator>\x26 __x, vector<_Tp, _Allocator>\x26 __y)\x0a"
"    _NOEXCEPT_(_NOEXCEPT_(__x.swap(__y)))\x0a"
"{\x0a"
"    __x.swap(__y);\x0a"
"}\x0a"
"\x0a"
"#if _LIBCPP_STD_VER > 17\x0a"
"template <class _Tp, class _Allocator, class _Up>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase(vector<_Tp, _Allocator>\x26 __c, const _Up\x26 __v)\x0a"
"{ __c.erase(_VSTD\x3a\x3aremove(__c.begin(), __c.end(), __v), __c.end()); }\x0a"
"\x0a"
"template <class _Tp, class _Allocator, class _Predicate>\x0a"
"inline _LIBCPP_INLINE_VISIBILITY\x0a"
"void erase_if(vector<_Tp, _Allocator>\x26 __c, _Predicate __pred)\x0a"
"{ __c.erase(_VSTD\x3a\x3aremove_if(__c.begin(), __c.end(), __pred), __c.end()); }\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"\x0a"
"_LIBCPP_POP_MACROS\x0a"
"\x0a"
"#endif  // _LIBCPP_VECTOR\x0a"
"", 112743 ); }