#include <string_view>
namespace divine::str::dios {
extern const std::string_view libcxx_src_locale_cpp( 
"//===------------------------- locale.cpp ---------------------------------===//\x0a"
"//\x0a"
"// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.\x0a"
"// See https\x3a//llvm.org/LICENSE.txt for license information.\x0a"
"// SPDX-License-Identifier\x3a Apache-2.0 WITH LLVM-exception\x0a"
"//\x0a"
"//===----------------------------------------------------------------------===//\x0a"
"\x0a"
"// On Solaris, we need to define something to make the C99 parts of localeconv\x0a"
"// visible.\x0a"
"#ifdef __sun__\x0a"
"#define _LCONV_C99\x0a"
"#endif\x0a"
"\x0a"
"#include \x22string\x22\x0a"
"#include \x22locale\x22\x0a"
"#include \x22""codecvt\x22\x0a"
"#include \x22vector\x22\x0a"
"#include \x22""algorithm\x22\x0a"
"#include \x22typeinfo\x22\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"#  include \x22type_traits\x22\x0a"
"#endif\x0a"
"#include \x22""clocale\x22\x0a"
"#include \x22""cstring\x22\x0a"
"#if defined(_LIBCPP_MSVCRT)\x0a"
"#define _CTYPE_DISABLE_MACROS\x0a"
"#endif\x0a"
"#include \x22""cwctype\x22\x0a"
"#include \x22__sso_allocator\x22\x0a"
"#if defined(_LIBCPP_MSVCRT) \x7c\x7c defined(__MINGW32__)\x0a"
"#include \x22support/win32/locale_win32.h\x22\x0a"
"#elif \x21""defined(__BIONIC__) \x26\x26 \x21""defined(__divine__)\x0a"
"#include <langinfo.h>\x0a"
"#endif\x0a"
"#include <stdlib.h>\x0a"
"#include <stdio.h>\x0a"
"#include \x22include/atomic_support.h\x22\x0a"
"#include \x22__undef_macros\x22\x0a"
"\x0a"
"// On Linux, wint_t and wchar_t have different signed-ness, and this causes\x0a"
"// lots of noise in the build log, but no bugs that I know of. \x0a"
"#if defined(__clang__)\x0a"
"#pragma clang diagnostic ignored \x22-Wsign-conversion\x22\x0a"
"#endif\x0a"
"\x0a"
"_LIBCPP_BEGIN_NAMESPACE_STD\x0a"
"\x0a"
"struct __libcpp_unique_locale {\x0a"
"  __libcpp_unique_locale(const char* nm) \x3a __loc_(newlocale(LC_ALL_MASK, nm, 0)) {}\x0a"
"\x0a"
"  \x7e__libcpp_unique_locale() {\x0a"
"    if (__loc_)\x0a"
"      freelocale(__loc_);\x0a"
"  }\x0a"
"\x0a"
"  explicit operator bool() const { return __loc_; }\x0a"
"\x0a"
"  locale_t\x26 get() { return __loc_; }\x0a"
"\x0a"
"  locale_t __loc_;\x0a"
"private\x3a\x0a"
"  __libcpp_unique_locale(__libcpp_unique_locale const\x26);\x0a"
"  __libcpp_unique_locale\x26 operator=(__libcpp_unique_locale const\x26);\x0a"
"};\x0a"
"\x0a"
"#ifdef __cloc_defined\x0a"
"locale_t __cloc() {\x0a"
"  // In theory this could create a race condition. In practice\x0a"
"  // the race condition is non-fatal since it will just create\x0a"
"  // a little resource leak. Better approach would be appreciated.\x0a"
"  static locale_t result = newlocale(LC_ALL_MASK, \x22""C\x22, 0);\x0a"
"  return result;\x0a"
"}\x0a"
"#endif // __cloc_defined\x0a"
"\x0a"
"namespace {\x0a"
"\x0a"
"struct release\x0a"
"{\x0a"
"    void operator()(locale\x3a\x3a""facet* p) {p->__release_shared();}\x0a"
"};\x0a"
"\x0a"
"template <class T, class A0>\x0a"
"inline\x0a"
"T\x26\x0a"
"make(A0 a0)\x0a"
"{\x0a"
"    static typename aligned_storage<sizeof(T)>\x3a\x3atype buf;\x0a"
"    auto *obj = \x3a\x3anew (\x26""buf) T(a0);\x0a"
"    return *obj;\x0a"
"}\x0a"
"\x0a"
"template <class T, class A0, class A1>\x0a"
"inline\x0a"
"T\x26\x0a"
"make(A0 a0, A1 a1)\x0a"
"{\x0a"
"    static typename aligned_storage<sizeof(T)>\x3a\x3atype buf;\x0a"
"    \x3a\x3anew (\x26""buf) T(a0, a1);\x0a"
"    return *reinterpret_cast<T*>(\x26""buf);\x0a"
"}\x0a"
"\x0a"
"template <class T, class A0, class A1, class A2>\x0a"
"inline\x0a"
"T\x26\x0a"
"make(A0 a0, A1 a1, A2 a2)\x0a"
"{\x0a"
"    static typename aligned_storage<sizeof(T)>\x3a\x3atype buf;\x0a"
"    auto *obj = \x3a\x3anew (\x26""buf) T(a0, a1, a2);\x0a"
"    return *obj;\x0a"
"}\x0a"
"\x0a"
"template <typename T, size_t N>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"size_t\x0a"
"countof(const T (\x26)\x5bN\x5d)\x0a"
"{\x0a"
"    return N;\x0a"
"}\x0a"
"\x0a"
"template <typename T>\x0a"
"inline\x0a"
"_LIBCPP_CONSTEXPR\x0a"
"size_t\x0a"
"countof(const T * const begin, const T * const end)\x0a"
"{\x0a"
"    return static_cast<size_t>(end - begin);\x0a"
"}\x0a"
"\x0a"
"_LIBCPP_NORETURN static void __throw_runtime_error(const string \x26msg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw runtime_error(msg);\x0a"
"#else\x0a"
"    (void)msg;\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"}\x0a"
"\x0a"
"#if defined(_AIX)\x0a"
"// Set priority to INT_MIN + 256 + 150\x0a"
"# pragma priority ( -2147483242 )\x0a"
"#endif\x0a"
"\x0a"
"const locale\x3a\x3a""category locale\x3a\x3anone;\x0a"
"const locale\x3a\x3a""category locale\x3a\x3a""collate;\x0a"
"const locale\x3a\x3a""category locale\x3a\x3a""ctype;\x0a"
"const locale\x3a\x3a""category locale\x3a\x3amonetary;\x0a"
"const locale\x3a\x3a""category locale\x3a\x3anumeric;\x0a"
"const locale\x3a\x3a""category locale\x3a\x3atime;\x0a"
"const locale\x3a\x3a""category locale\x3a\x3amessages;\x0a"
"const locale\x3a\x3a""category locale\x3a\x3a""all;\x0a"
"\x0a"
"class _LIBCPP_HIDDEN locale\x3a\x3a__imp\x0a"
"    \x3a public facet\x0a"
"{\x0a"
"    enum {N = 28};\x0a"
"#if defined(_LIBCPP_COMPILER_MSVC)\x0a"
"// FIXME\x3a MSVC doesn't support aligned parameters by value.\x0a"
"// I can't get the __sso_allocator to work here\x0a"
"// for MSVC I think for this reason.\x0a"
"    vector<facet*> facets_;\x0a"
"#else\x0a"
"    vector<facet*, __sso_allocator<facet*, N> > facets_;\x0a"
"#endif\x0a"
"    string         name_;\x0a"
"public\x3a\x0a"
"    explicit __imp(size_t refs = 0);\x0a"
"    explicit __imp(const string\x26 name, size_t refs = 0);\x0a"
"    __imp(const __imp\x26);\x0a"
"    __imp(const __imp\x26, const string\x26, locale\x3a\x3a""category c);\x0a"
"    __imp(const __imp\x26 other, const __imp\x26 one, locale\x3a\x3a""category c);\x0a"
"    __imp(const __imp\x26, facet* f, long id);\x0a"
"    \x7e__imp();\x0a"
"\x0a"
"    const string\x26 name() const {return name_;}\x0a"
"    bool has_facet(long id) const\x0a"
"        {return static_cast<size_t>(id) < facets_.size() \x26\x26 facets_\x5bstatic_cast<size_t>(id)\x5d;}\x0a"
"    const locale\x3a\x3a""facet* use_facet(long id) const;\x0a"
"\x0a"
"    static const locale\x26 make_classic();\x0a"
"    static       locale\x26 make_global();\x0a"
"private\x3a\x0a"
"    void install(facet* f, long id);\x0a"
"    template <class F> void install(F* f) {install(f, f->id.__get());}\x0a"
"    template <class F> void install_from(const __imp\x26 other);\x0a"
"};\x0a"
"\x0a"
"locale\x3a\x3a__imp\x3a\x3a__imp(size_t refs)\x0a"
"    \x3a facet(refs),\x0a"
"      facets_(N),\x0a"
"      name_(\x22""C\x22)\x0a"
"{\x0a"
"    facets_.clear();\x0a"
"    install(\x26make<_VSTD\x3a\x3a""collate<char> >(1u));\x0a"
"    install(\x26make<_VSTD\x3a\x3a""collate<wchar_t> >(1u));\x0a"
"    install(\x26make<_VSTD\x3a\x3a""ctype<char> >(nullptr, false, 1u));\x0a"
"    install(\x26make<_VSTD\x3a\x3a""ctype<wchar_t> >(1u));\x0a"
"    install(\x26make<codecvt<char, char, mbstate_t> >(1u));\x0a"
"    install(\x26make<codecvt<wchar_t, char, mbstate_t> >(1u));\x0a"
"    install(\x26make<codecvt<char16_t, char, mbstate_t> >(1u));\x0a"
"    install(\x26make<codecvt<char32_t, char, mbstate_t> >(1u));\x0a"
"    install(\x26make<numpunct<char> >(1u));\x0a"
"    install(\x26make<numpunct<wchar_t> >(1u));\x0a"
"    install(\x26make<num_get<char> >(1u));\x0a"
"    install(\x26make<num_get<wchar_t> >(1u));\x0a"
"    install(\x26make<num_put<char> >(1u));\x0a"
"    install(\x26make<num_put<wchar_t> >(1u));\x0a"
"    install(\x26make<moneypunct<char, false> >(1u));\x0a"
"    install(\x26make<moneypunct<char, true> >(1u));\x0a"
"    install(\x26make<moneypunct<wchar_t, false> >(1u));\x0a"
"    install(\x26make<moneypunct<wchar_t, true> >(1u));\x0a"
"    install(\x26make<money_get<char> >(1u));\x0a"
"    install(\x26make<money_get<wchar_t> >(1u));\x0a"
"    install(\x26make<money_put<char> >(1u));\x0a"
"    install(\x26make<money_put<wchar_t> >(1u));\x0a"
"    install(\x26make<time_get<char> >(1u));\x0a"
"    install(\x26make<time_get<wchar_t> >(1u));\x0a"
"    install(\x26make<time_put<char> >(1u));\x0a"
"    install(\x26make<time_put<wchar_t> >(1u));\x0a"
"    install(\x26make<_VSTD\x3a\x3amessages<char> >(1u));\x0a"
"    install(\x26make<_VSTD\x3a\x3amessages<wchar_t> >(1u));\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3a__imp\x3a\x3a__imp(const string\x26 name, size_t refs)\x0a"
"    \x3a facet(refs),\x0a"
"      facets_(N),\x0a"
"      name_(name)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        facets_ = locale\x3a\x3a""classic().__locale_->facets_;\x0a"
"        for (unsigned i = 0; i < facets_.size(); ++i)\x0a"
"            if (facets_\x5bi\x5d)\x0a"
"                facets_\x5bi\x5d->__add_shared();\x0a"
"        install(new collate_byname<char>(name_));\x0a"
"        install(new collate_byname<wchar_t>(name_));\x0a"
"        install(new ctype_byname<char>(name_));\x0a"
"        install(new ctype_byname<wchar_t>(name_));\x0a"
"        install(new codecvt_byname<char, char, mbstate_t>(name_));\x0a"
"        install(new codecvt_byname<wchar_t, char, mbstate_t>(name_));\x0a"
"        install(new codecvt_byname<char16_t, char, mbstate_t>(name_));\x0a"
"        install(new codecvt_byname<char32_t, char, mbstate_t>(name_));\x0a"
"        install(new numpunct_byname<char>(name_));\x0a"
"        install(new numpunct_byname<wchar_t>(name_));\x0a"
"        install(new moneypunct_byname<char, false>(name_));\x0a"
"        install(new moneypunct_byname<char, true>(name_));\x0a"
"        install(new moneypunct_byname<wchar_t, false>(name_));\x0a"
"        install(new moneypunct_byname<wchar_t, true>(name_));\x0a"
"        install(new time_get_byname<char>(name_));\x0a"
"        install(new time_get_byname<wchar_t>(name_));\x0a"
"        install(new time_put_byname<char>(name_));\x0a"
"        install(new time_put_byname<wchar_t>(name_));\x0a"
"        install(new messages_byname<char>(name_));\x0a"
"        install(new messages_byname<wchar_t>(name_));\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        for (unsigned i = 0; i < facets_.size(); ++i)\x0a"
"            if (facets_\x5bi\x5d)\x0a"
"                facets_\x5bi\x5d->__release_shared();\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"// NOTE avoid the \x60""base class should be explicitly initialized in the\x0a"
"// copy constructor\x60 warning emitted by GCC\x0a"
"#if defined(__clang__) \x7c\x7c _GNUC_VER >= 406\x0a"
"#pragma GCC diagnostic push\x0a"
"#pragma GCC diagnostic ignored \x22-Wextra\x22\x0a"
"#endif\x0a"
"\x0a"
"locale\x3a\x3a__imp\x3a\x3a__imp(const __imp\x26 other)\x0a"
"    \x3a facets_(max<size_t>(N, other.facets_.size())),\x0a"
"      name_(other.name_)\x0a"
"{\x0a"
"    facets_ = other.facets_;\x0a"
"    for (unsigned i = 0; i < facets_.size(); ++i)\x0a"
"        if (facets_\x5bi\x5d)\x0a"
"            facets_\x5bi\x5d->__add_shared();\x0a"
"}\x0a"
"\x0a"
"#if defined(__clang__) \x7c\x7c _GNUC_VER >= 406\x0a"
"#pragma GCC diagnostic pop\x0a"
"#endif\x0a"
"\x0a"
"locale\x3a\x3a__imp\x3a\x3a__imp(const __imp\x26 other, const string\x26 name, locale\x3a\x3a""category c)\x0a"
"    \x3a facets_(N),\x0a"
"      name_(\x22*\x22)\x0a"
"{\x0a"
"    facets_ = other.facets_;\x0a"
"    for (unsigned i = 0; i < facets_.size(); ++i)\x0a"
"        if (facets_\x5bi\x5d)\x0a"
"            facets_\x5bi\x5d->__add_shared();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        if (c \x26 locale\x3a\x3a""collate)\x0a"
"        {\x0a"
"            install(new collate_byname<char>(name));\x0a"
"            install(new collate_byname<wchar_t>(name));\x0a"
"        }\x0a"
"        if (c \x26 locale\x3a\x3a""ctype)\x0a"
"        {\x0a"
"            install(new ctype_byname<char>(name));\x0a"
"            install(new ctype_byname<wchar_t>(name));\x0a"
"            install(new codecvt_byname<char, char, mbstate_t>(name));\x0a"
"            install(new codecvt_byname<wchar_t, char, mbstate_t>(name));\x0a"
"            install(new codecvt_byname<char16_t, char, mbstate_t>(name));\x0a"
"            install(new codecvt_byname<char32_t, char, mbstate_t>(name));\x0a"
"        }\x0a"
"        if (c \x26 locale\x3a\x3amonetary)\x0a"
"        {\x0a"
"            install(new moneypunct_byname<char, false>(name));\x0a"
"            install(new moneypunct_byname<char, true>(name));\x0a"
"            install(new moneypunct_byname<wchar_t, false>(name));\x0a"
"            install(new moneypunct_byname<wchar_t, true>(name));\x0a"
"        }\x0a"
"        if (c \x26 locale\x3a\x3anumeric)\x0a"
"        {\x0a"
"            install(new numpunct_byname<char>(name));\x0a"
"            install(new numpunct_byname<wchar_t>(name));\x0a"
"        }\x0a"
"        if (c \x26 locale\x3a\x3atime)\x0a"
"        {\x0a"
"            install(new time_get_byname<char>(name));\x0a"
"            install(new time_get_byname<wchar_t>(name));\x0a"
"            install(new time_put_byname<char>(name));\x0a"
"            install(new time_put_byname<wchar_t>(name));\x0a"
"        }\x0a"
"        if (c \x26 locale\x3a\x3amessages)\x0a"
"        {\x0a"
"            install(new messages_byname<char>(name));\x0a"
"            install(new messages_byname<wchar_t>(name));\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        for (unsigned i = 0; i < facets_.size(); ++i)\x0a"
"            if (facets_\x5bi\x5d)\x0a"
"                facets_\x5bi\x5d->__release_shared();\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"template<class F>\x0a"
"inline\x0a"
"void\x0a"
"locale\x3a\x3a__imp\x3a\x3ainstall_from(const locale\x3a\x3a__imp\x26 one)\x0a"
"{\x0a"
"    long id = F\x3a\x3aid.__get();\x0a"
"    install(const_cast<F*>(static_cast<const F*>(one.use_facet(id))), id);\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3a__imp\x3a\x3a__imp(const __imp\x26 other, const __imp\x26 one, locale\x3a\x3a""category c)\x0a"
"    \x3a facets_(N),\x0a"
"      name_(\x22*\x22)\x0a"
"{\x0a"
"    facets_ = other.facets_;\x0a"
"    for (unsigned i = 0; i < facets_.size(); ++i)\x0a"
"        if (facets_\x5bi\x5d)\x0a"
"            facets_\x5bi\x5d->__add_shared();\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    try\x0a"
"    {\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"        if (c \x26 locale\x3a\x3a""collate)\x0a"
"        {\x0a"
"            install_from<_VSTD\x3a\x3a""collate<char> >(one);\x0a"
"            install_from<_VSTD\x3a\x3a""collate<wchar_t> >(one);\x0a"
"        }\x0a"
"        if (c \x26 locale\x3a\x3a""ctype)\x0a"
"        {\x0a"
"            install_from<_VSTD\x3a\x3a""ctype<char> >(one);\x0a"
"            install_from<_VSTD\x3a\x3a""ctype<wchar_t> >(one);\x0a"
"            install_from<_VSTD\x3a\x3a""codecvt<char, char, mbstate_t> >(one);\x0a"
"            install_from<_VSTD\x3a\x3a""codecvt<char16_t, char, mbstate_t> >(one);\x0a"
"            install_from<_VSTD\x3a\x3a""codecvt<char32_t, char, mbstate_t> >(one);\x0a"
"            install_from<_VSTD\x3a\x3a""codecvt<wchar_t, char, mbstate_t> >(one);\x0a"
"        }\x0a"
"        if (c \x26 locale\x3a\x3amonetary)\x0a"
"        {\x0a"
"            install_from<moneypunct<char, false> >(one);\x0a"
"            install_from<moneypunct<char, true> >(one);\x0a"
"            install_from<moneypunct<wchar_t, false> >(one);\x0a"
"            install_from<moneypunct<wchar_t, true> >(one);\x0a"
"            install_from<money_get<char> >(one);\x0a"
"            install_from<money_get<wchar_t> >(one);\x0a"
"            install_from<money_put<char> >(one);\x0a"
"            install_from<money_put<wchar_t> >(one);\x0a"
"        }\x0a"
"        if (c \x26 locale\x3a\x3anumeric)\x0a"
"        {\x0a"
"            install_from<numpunct<char> >(one);\x0a"
"            install_from<numpunct<wchar_t> >(one);\x0a"
"            install_from<num_get<char> >(one);\x0a"
"            install_from<num_get<wchar_t> >(one);\x0a"
"            install_from<num_put<char> >(one);\x0a"
"            install_from<num_put<wchar_t> >(one);\x0a"
"        }\x0a"
"        if (c \x26 locale\x3a\x3atime)\x0a"
"        {\x0a"
"            install_from<time_get<char> >(one);\x0a"
"            install_from<time_get<wchar_t> >(one);\x0a"
"            install_from<time_put<char> >(one);\x0a"
"            install_from<time_put<wchar_t> >(one);\x0a"
"        }\x0a"
"        if (c \x26 locale\x3a\x3amessages)\x0a"
"        {\x0a"
"            install_from<_VSTD\x3a\x3amessages<char> >(one);\x0a"
"            install_from<_VSTD\x3a\x3amessages<wchar_t> >(one);\x0a"
"        }\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    }\x0a"
"    catch (...)\x0a"
"    {\x0a"
"        for (unsigned i = 0; i < facets_.size(); ++i)\x0a"
"            if (facets_\x5bi\x5d)\x0a"
"                facets_\x5bi\x5d->__release_shared();\x0a"
"        throw;\x0a"
"    }\x0a"
"#endif  // _LIBCPP_NO_EXCEPTIONS\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3a__imp\x3a\x3a__imp(const __imp\x26 other, facet* f, long id)\x0a"
"    \x3a facets_(max<size_t>(N, other.facets_.size()+1)),\x0a"
"      name_(\x22*\x22)\x0a"
"{\x0a"
"    f->__add_shared();\x0a"
"    unique_ptr<facet, release> hold(f);\x0a"
"    facets_ = other.facets_;\x0a"
"    for (unsigned i = 0; i < other.facets_.size(); ++i)\x0a"
"        if (facets_\x5bi\x5d)\x0a"
"            facets_\x5bi\x5d->__add_shared();\x0a"
"    install(hold.get(), id);\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3a__imp\x3a\x3a\x7e__imp()\x0a"
"{\x0a"
"    for (unsigned i = 0; i < facets_.size(); ++i)\x0a"
"        if (facets_\x5bi\x5d)\x0a"
"            facets_\x5bi\x5d->__release_shared();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"locale\x3a\x3a__imp\x3a\x3ainstall(facet* f, long id)\x0a"
"{\x0a"
"    f->__add_shared();\x0a"
"    unique_ptr<facet, release> hold(f);\x0a"
"    if (static_cast<size_t>(id) >= facets_.size())\x0a"
"        facets_.resize(static_cast<size_t>(id+1));\x0a"
"    if (facets_\x5bstatic_cast<size_t>(id)\x5d)\x0a"
"        facets_\x5bstatic_cast<size_t>(id)\x5d->__release_shared();\x0a"
"    facets_\x5bstatic_cast<size_t>(id)\x5d = hold.release();\x0a"
"}\x0a"
"\x0a"
"const locale\x3a\x3a""facet*\x0a"
"locale\x3a\x3a__imp\x3a\x3ause_facet(long id) const\x0a"
"{\x0a"
"    if (\x21has_facet(id))\x0a"
"        __throw_bad_cast();\x0a"
"    return facets_\x5bstatic_cast<size_t>(id)\x5d;\x0a"
"}\x0a"
"\x0a"
"// locale\x0a"
"\x0a"
"const locale\x26\x0a"
"locale\x3a\x3a__imp\x3a\x3amake_classic()\x0a"
"{\x0a"
"    // only one thread can get in here and it only gets in once\x0a"
"    static aligned_storage<sizeof(locale)>\x3a\x3atype buf;\x0a"
"    locale* c = reinterpret_cast<locale*>(\x26""buf);\x0a"
"    c->__locale_ = \x26make<__imp>(1u);\x0a"
"    return *c;\x0a"
"}\x0a"
"\x0a"
"const locale\x26\x0a"
"locale\x3a\x3a""classic()\x0a"
"{\x0a"
"    static const locale\x26 c = __imp\x3a\x3amake_classic();\x0a"
"    return c;\x0a"
"}\x0a"
"\x0a"
"locale\x26\x0a"
"locale\x3a\x3a__imp\x3a\x3amake_global()\x0a"
"{\x0a"
"    // only one thread can get in here and it only gets in once\x0a"
"    static aligned_storage<sizeof(locale)>\x3a\x3atype buf;\x0a"
"    auto *obj = \x3a\x3anew (\x26""buf) locale(locale\x3a\x3a""classic());\x0a"
"    return *obj;\x0a"
"}\x0a"
"\x0a"
"locale\x26\x0a"
"locale\x3a\x3a__global()\x0a"
"{\x0a"
"    static locale\x26 g = __imp\x3a\x3amake_global();\x0a"
"    return g;\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3alocale()  _NOEXCEPT\x0a"
"    \x3a __locale_(__global().__locale_)\x0a"
"{\x0a"
"    __locale_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3alocale(const locale\x26 l)  _NOEXCEPT\x0a"
"    \x3a __locale_(l.__locale_)\x0a"
"{\x0a"
"    __locale_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3a\x7elocale()\x0a"
"{\x0a"
"    __locale_->__release_shared();\x0a"
"}\x0a"
"\x0a"
"const locale\x26\x0a"
"locale\x3a\x3aoperator=(const locale\x26 other)  _NOEXCEPT\x0a"
"{\x0a"
"    other.__locale_->__add_shared();\x0a"
"    __locale_->__release_shared();\x0a"
"    __locale_ = other.__locale_;\x0a"
"    return *this;\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3alocale(const char* name)\x0a"
"    \x3a __locale_(name \x3f new __imp(name)\x0a"
"                     \x3a (__throw_runtime_error(\x22locale constructed with null\x22), (__imp*)0))\x0a"
"{\x0a"
"    __locale_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3alocale(const string\x26 name)\x0a"
"    \x3a __locale_(new __imp(name))\x0a"
"{\x0a"
"    __locale_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3alocale(const locale\x26 other, const char* name, category c)\x0a"
"    \x3a __locale_(name \x3f new __imp(*other.__locale_, name, c)\x0a"
"                     \x3a (__throw_runtime_error(\x22locale constructed with null\x22), (__imp*)0))\x0a"
"{\x0a"
"    __locale_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3alocale(const locale\x26 other, const string\x26 name, category c)\x0a"
"    \x3a __locale_(new __imp(*other.__locale_, name, c))\x0a"
"{\x0a"
"    __locale_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"locale\x3a\x3alocale(const locale\x26 other, const locale\x26 one, category c)\x0a"
"    \x3a __locale_(new __imp(*other.__locale_, *one.__locale_, c))\x0a"
"{\x0a"
"    __locale_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"string\x0a"
"locale\x3a\x3aname() const\x0a"
"{\x0a"
"    return __locale_->name();\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"locale\x3a\x3a__install_ctor(const locale\x26 other, facet* f, long id)\x0a"
"{\x0a"
"    if (f)\x0a"
"        __locale_ = new __imp(*other.__locale_, f, id);\x0a"
"    else\x0a"
"        __locale_ = other.__locale_;\x0a"
"    __locale_->__add_shared();\x0a"
"}\x0a"
"\x0a"
"locale\x0a"
"locale\x3a\x3aglobal(const locale\x26 loc)\x0a"
"{\x0a"
"    locale\x26 g = __global();\x0a"
"    locale r = g;\x0a"
"    g = loc;\x0a"
"    if (g.name() \x21= \x22*\x22)\x0a"
"        setlocale(LC_ALL, g.name().c_str());\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"locale\x3a\x3ahas_facet(id\x26 x) const\x0a"
"{\x0a"
"    return __locale_->has_facet(x.__get());\x0a"
"}\x0a"
"\x0a"
"const locale\x3a\x3a""facet*\x0a"
"locale\x3a\x3ause_facet(id\x26 x) const\x0a"
"{\x0a"
"    return __locale_->use_facet(x.__get());\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"locale\x3a\x3aoperator==(const locale\x26 y) const\x0a"
"{\x0a"
"    return (__locale_ == y.__locale_)\x0a"
"        \x7c\x7c (__locale_->name() \x21= \x22*\x22 \x26\x26 __locale_->name() == y.__locale_->name());\x0a"
"}\x0a"
"\x0a"
"// locale\x3a\x3a""facet\x0a"
"\x0a"
"locale\x3a\x3a""facet\x3a\x3a\x7e""facet()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"locale\x3a\x3a""facet\x3a\x3a__on_zero_shared() _NOEXCEPT\x0a"
"{\x0a"
"    delete this;\x0a"
"}\x0a"
"\x0a"
"// locale\x3a\x3aid\x0a"
"\x0a"
"int32_t locale\x3a\x3aid\x3a\x3a__next_id = 0;\x0a"
"\x0a"
"namespace\x0a"
"{\x0a"
"\x0a"
"class __fake_bind\x0a"
"{\x0a"
"    locale\x3a\x3aid* id_;\x0a"
"    void (locale\x3a\x3aid\x3a\x3a* pmf_)();\x0a"
"public\x3a\x0a"
"    __fake_bind(void (locale\x3a\x3aid\x3a\x3a* pmf)(), locale\x3a\x3aid* id)\x0a"
"        \x3a id_(id), pmf_(pmf) {}\x0a"
"\x0a"
"    void operator()() const\x0a"
"    {\x0a"
"        (id_->*pmf_)();\x0a"
"    }\x0a"
"};\x0a"
"\x0a"
"}\x0a"
"\x0a"
"long\x0a"
"locale\x3a\x3aid\x3a\x3a__get()\x0a"
"{\x0a"
"    call_once(__flag_, __fake_bind(\x26locale\x3a\x3aid\x3a\x3a__init, this));\x0a"
"    return __id_ - 1;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"locale\x3a\x3aid\x3a\x3a__init()\x0a"
"{\x0a"
"    __id_ = __libcpp_atomic_add(\x26__next_id, 1);\x0a"
"}\x0a"
"\x0a"
"// template <> class collate_byname<char>\x0a"
"\x0a"
"collate_byname<char>\x3a\x3a""collate_byname(const char* n, size_t refs)\x0a"
"    \x3a collate<char>(refs),\x0a"
"      __l(newlocale(LC_ALL_MASK, n, 0))\x0a"
"{\x0a"
"    if (__l == 0)\x0a"
"        __throw_runtime_error(\x22""collate_byname<char>\x3a\x3a""collate_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + string(n));\x0a"
"}\x0a"
"\x0a"
"collate_byname<char>\x3a\x3a""collate_byname(const string\x26 name, size_t refs)\x0a"
"    \x3a collate<char>(refs),\x0a"
"      __l(newlocale(LC_ALL_MASK, name.c_str(), 0))\x0a"
"{\x0a"
"    if (__l == 0)\x0a"
"        __throw_runtime_error(\x22""collate_byname<char>\x3a\x3a""collate_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + name);\x0a"
"}\x0a"
"\x0a"
"collate_byname<char>\x3a\x3a\x7e""collate_byname()\x0a"
"{\x0a"
"    freelocale(__l);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"collate_byname<char>\x3a\x3a""do_compare(const char_type* __lo1, const char_type* __hi1,\x0a"
"                                 const char_type* __lo2, const char_type* __hi2) const\x0a"
"{\x0a"
"    string_type lhs(__lo1, __hi1);\x0a"
"    string_type rhs(__lo2, __hi2);\x0a"
"    int r = strcoll_l(lhs.c_str(), rhs.c_str(), __l);\x0a"
"    if (r < 0)\x0a"
"        return -1;\x0a"
"    if (r > 0)\x0a"
"        return 1;\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"collate_byname<char>\x3a\x3astring_type\x0a"
"collate_byname<char>\x3a\x3a""do_transform(const char_type* lo, const char_type* hi) const\x0a"
"{\x0a"
"    const string_type in(lo, hi);\x0a"
"    string_type out(strxfrm_l(0, in.c_str(), 0, __l), char());\x0a"
"    strxfrm_l(const_cast<char*>(out.c_str()), in.c_str(), out.size()+1, __l);\x0a"
"    return out;\x0a"
"}\x0a"
"\x0a"
"// template <> class collate_byname<wchar_t>\x0a"
"\x0a"
"collate_byname<wchar_t>\x3a\x3a""collate_byname(const char* n, size_t refs)\x0a"
"    \x3a collate<wchar_t>(refs),\x0a"
"      __l(newlocale(LC_ALL_MASK, n, 0))\x0a"
"{\x0a"
"    if (__l == 0)\x0a"
"        __throw_runtime_error(\x22""collate_byname<wchar_t>\x3a\x3a""collate_byname(size_t refs)\x22\x0a"
"                            \x22 failed to construct for \x22 + string(n));\x0a"
"}\x0a"
"\x0a"
"collate_byname<wchar_t>\x3a\x3a""collate_byname(const string\x26 name, size_t refs)\x0a"
"    \x3a collate<wchar_t>(refs),\x0a"
"      __l(newlocale(LC_ALL_MASK, name.c_str(), 0))\x0a"
"{\x0a"
"    if (__l == 0)\x0a"
"        __throw_runtime_error(\x22""collate_byname<wchar_t>\x3a\x3a""collate_byname(size_t refs)\x22\x0a"
"                            \x22 failed to construct for \x22 + name);\x0a"
"}\x0a"
"\x0a"
"collate_byname<wchar_t>\x3a\x3a\x7e""collate_byname()\x0a"
"{\x0a"
"    freelocale(__l);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"collate_byname<wchar_t>\x3a\x3a""do_compare(const char_type* __lo1, const char_type* __hi1,\x0a"
"                                 const char_type* __lo2, const char_type* __hi2) const\x0a"
"{\x0a"
"    string_type lhs(__lo1, __hi1);\x0a"
"    string_type rhs(__lo2, __hi2);\x0a"
"    int r = wcscoll_l(lhs.c_str(), rhs.c_str(), __l);\x0a"
"    if (r < 0)\x0a"
"        return -1;\x0a"
"    if (r > 0)\x0a"
"        return 1;\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"collate_byname<wchar_t>\x3a\x3astring_type\x0a"
"collate_byname<wchar_t>\x3a\x3a""do_transform(const char_type* lo, const char_type* hi) const\x0a"
"{\x0a"
"    const string_type in(lo, hi);\x0a"
"    string_type out(wcsxfrm_l(0, in.c_str(), 0, __l), wchar_t());\x0a"
"    wcsxfrm_l(const_cast<wchar_t*>(out.c_str()), in.c_str(), out.size()+1, __l);\x0a"
"    return out;\x0a"
"}\x0a"
"\x0a"
"// template <> class ctype<wchar_t>;\x0a"
"\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3aspace;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3aprint;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3a""cntrl;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3aupper;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3alower;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3a""alpha;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3a""digit;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3apunct;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3axdigit;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3a""blank;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3a""alnum;\x0a"
"const ctype_base\x3a\x3amask ctype_base\x3a\x3agraph;\x0a"
"    \x0a"
"locale\x3a\x3aid ctype<wchar_t>\x3a\x3aid;\x0a"
"\x0a"
"ctype<wchar_t>\x3a\x3a\x7e""ctype()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"ctype<wchar_t>\x3a\x3a""do_is(mask m, char_type c) const\x0a"
"{\x0a"
"    return isascii(c) \x3f (ctype<char>\x3a\x3a""classic_table()\x5b""c\x5d \x26 m) \x21= 0 \x3a false;\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype<wchar_t>\x3a\x3a""do_is(const char_type* low, const char_type* high, mask* vec) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low, ++vec)\x0a"
"        *vec = static_cast<mask>(isascii(*low) \x3f\x0a"
"                                   ctype<char>\x3a\x3a""classic_table()\x5b*low\x5d \x3a 0);\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype<wchar_t>\x3a\x3a""do_scan_is(mask m, const char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"        if (isascii(*low) \x26\x26 (ctype<char>\x3a\x3a""classic_table()\x5b*low\x5d \x26 m))\x0a"
"            break;\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype<wchar_t>\x3a\x3a""do_scan_not(mask m, const char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"        if (\x21(isascii(*low) \x26\x26 (ctype<char>\x3a\x3a""classic_table()\x5b*low\x5d \x26 m)))\x0a"
"            break;\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"wchar_t\x0a"
"ctype<wchar_t>\x3a\x3a""do_toupper(char_type c) const\x0a"
"{\x0a"
"#ifdef _LIBCPP_HAS_DEFAULTRUNELOCALE\x0a"
"    return isascii(c) \x3f _DefaultRuneLocale.__mapupper\x5b""c\x5d \x3a c;\x0a"
"#elif defined(__GLIBC__) \x7c\x7c defined(__EMSCRIPTEN__) \x7c\x7c \x5c\x0a"
"      defined(__NetBSD__)\x0a"
"    return isascii(c) \x3f ctype<char>\x3a\x3a__classic_upper_table()\x5b""c\x5d \x3a c;\x0a"
"#else\x0a"
"    return (isascii(c) \x26\x26 iswlower_l(c, _LIBCPP_GET_C_LOCALE)) \x3f c-L'a'+L'A' \x3a c;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype<wchar_t>\x3a\x3a""do_toupper(char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"#ifdef _LIBCPP_HAS_DEFAULTRUNELOCALE\x0a"
"        *low = isascii(*low) \x3f _DefaultRuneLocale.__mapupper\x5b*low\x5d \x3a *low;\x0a"
"#elif defined(__GLIBC__) \x7c\x7c defined(__EMSCRIPTEN__) \x7c\x7c \x5c\x0a"
"      defined(__NetBSD__)\x0a"
"        *low = isascii(*low) \x3f ctype<char>\x3a\x3a__classic_upper_table()\x5b*low\x5d\x0a"
"                             \x3a *low;\x0a"
"#else\x0a"
"        *low = (isascii(*low) \x26\x26 islower_l(*low, _LIBCPP_GET_C_LOCALE)) \x3f (*low-L'a'+L'A') \x3a *low;\x0a"
"#endif\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"wchar_t\x0a"
"ctype<wchar_t>\x3a\x3a""do_tolower(char_type c) const\x0a"
"{\x0a"
"#ifdef _LIBCPP_HAS_DEFAULTRUNELOCALE\x0a"
"    return isascii(c) \x3f _DefaultRuneLocale.__maplower\x5b""c\x5d \x3a c;\x0a"
"#elif defined(__GLIBC__) \x7c\x7c defined(__EMSCRIPTEN__) \x7c\x7c \x5c\x0a"
"      defined(__NetBSD__)\x0a"
"    return isascii(c) \x3f ctype<char>\x3a\x3a__classic_lower_table()\x5b""c\x5d \x3a c;\x0a"
"#else\x0a"
"    return (isascii(c) \x26\x26 isupper_l(c, _LIBCPP_GET_C_LOCALE)) \x3f c-L'A'+'a' \x3a c;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype<wchar_t>\x3a\x3a""do_tolower(char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"#ifdef _LIBCPP_HAS_DEFAULTRUNELOCALE\x0a"
"        *low = isascii(*low) \x3f _DefaultRuneLocale.__maplower\x5b*low\x5d \x3a *low;\x0a"
"#elif defined(__GLIBC__) \x7c\x7c defined(__EMSCRIPTEN__) \x7c\x7c \x5c\x0a"
"      defined(__NetBSD__)\x0a"
"        *low = isascii(*low) \x3f ctype<char>\x3a\x3a__classic_lower_table()\x5b*low\x5d\x0a"
"                             \x3a *low;\x0a"
"#else\x0a"
"        *low = (isascii(*low) \x26\x26 isupper_l(*low, _LIBCPP_GET_C_LOCALE)) \x3f *low-L'A'+L'a' \x3a *low;\x0a"
"#endif\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"wchar_t\x0a"
"ctype<wchar_t>\x3a\x3a""do_widen(char c) const\x0a"
"{\x0a"
"    return c;\x0a"
"}\x0a"
"\x0a"
"const char*\x0a"
"ctype<wchar_t>\x3a\x3a""do_widen(const char* low, const char* high, char_type* dest) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low, ++dest)\x0a"
"        *dest = *low;\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"char\x0a"
"ctype<wchar_t>\x3a\x3a""do_narrow(char_type c, char dfault) const\x0a"
"{\x0a"
"    if (isascii(c))\x0a"
"        return static_cast<char>(c);\x0a"
"    return dfault;\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype<wchar_t>\x3a\x3a""do_narrow(const char_type* low, const char_type* high, char dfault, char* dest) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low, ++dest)\x0a"
"        if (isascii(*low))\x0a"
"            *dest = static_cast<char>(*low);\x0a"
"        else\x0a"
"            *dest = dfault;\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"// template <> class ctype<char>;\x0a"
"\x0a"
"locale\x3a\x3aid ctype<char>\x3a\x3aid;\x0a"
"\x0a"
"ctype<char>\x3a\x3a""ctype(const mask* tab, bool del, size_t refs)\x0a"
"    \x3a locale\x3a\x3a""facet(refs),\x0a"
"      __tab_(tab),\x0a"
"      __del_(del)\x0a"
"{\x0a"
"  if (__tab_ == 0)\x0a"
"      __tab_ = classic_table();\x0a"
"}\x0a"
"\x0a"
"ctype<char>\x3a\x3a\x7e""ctype()\x0a"
"{\x0a"
"    if (__tab_ \x26\x26 __del_)\x0a"
"        delete \x5b\x5d __tab_;\x0a"
"}\x0a"
"\x0a"
"char\x0a"
"ctype<char>\x3a\x3a""do_toupper(char_type c) const\x0a"
"{\x0a"
"#ifdef _LIBCPP_HAS_DEFAULTRUNELOCALE\x0a"
"    return isascii(c) \x3f\x0a"
"      static_cast<char>(_DefaultRuneLocale.__mapupper\x5bstatic_cast<ptrdiff_t>(c)\x5d) \x3a c;\x0a"
"#elif defined(__NetBSD__)\x0a"
"    return static_cast<char>(__classic_upper_table()\x5bstatic_cast<unsigned char>(c)\x5d);\x0a"
"#elif defined(__GLIBC__) \x7c\x7c defined(__EMSCRIPTEN__)\x0a"
"    return isascii(c) \x3f\x0a"
"      static_cast<char>(__classic_upper_table()\x5bstatic_cast<unsigned char>(c)\x5d) \x3a c;\x0a"
"#else\x0a"
"    return (isascii(c) \x26\x26 islower_l(c, _LIBCPP_GET_C_LOCALE)) \x3f c-'a'+'A' \x3a c;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"const char*\x0a"
"ctype<char>\x3a\x3a""do_toupper(char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"#ifdef _LIBCPP_HAS_DEFAULTRUNELOCALE\x0a"
"        *low = isascii(*low) \x3f\x0a"
"          static_cast<char>(_DefaultRuneLocale.__mapupper\x5bstatic_cast<ptrdiff_t>(*low)\x5d) \x3a *low;\x0a"
"#elif defined(__NetBSD__)\x0a"
"        *low = static_cast<char>(__classic_upper_table()\x5bstatic_cast<unsigned char>(*low)\x5d);\x0a"
"#elif defined(__GLIBC__) \x7c\x7c defined(__EMSCRIPTEN__)\x0a"
"        *low = isascii(*low) \x3f\x0a"
"          static_cast<char>(__classic_upper_table()\x5bstatic_cast<size_t>(*low)\x5d) \x3a *low;\x0a"
"#else\x0a"
"        *low = (isascii(*low) \x26\x26 islower_l(*low, _LIBCPP_GET_C_LOCALE)) \x3f *low-'a'+'A' \x3a *low;\x0a"
"#endif\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"char\x0a"
"ctype<char>\x3a\x3a""do_tolower(char_type c) const\x0a"
"{\x0a"
"#ifdef _LIBCPP_HAS_DEFAULTRUNELOCALE\x0a"
"    return isascii(c) \x3f\x0a"
"      static_cast<char>(_DefaultRuneLocale.__maplower\x5bstatic_cast<ptrdiff_t>(c)\x5d) \x3a c;\x0a"
"#elif defined(__NetBSD__)\x0a"
"    return static_cast<char>(__classic_lower_table()\x5bstatic_cast<unsigned char>(c)\x5d);\x0a"
"#elif defined(__GLIBC__) \x7c\x7c defined(__EMSCRIPTEN__)\x0a"
"    return isascii(c) \x3f\x0a"
"      static_cast<char>(__classic_lower_table()\x5bstatic_cast<size_t>(c)\x5d) \x3a c;\x0a"
"#else\x0a"
"    return (isascii(c) \x26\x26 isupper_l(c, _LIBCPP_GET_C_LOCALE)) \x3f c-'A'+'a' \x3a c;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"const char*\x0a"
"ctype<char>\x3a\x3a""do_tolower(char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"#ifdef _LIBCPP_HAS_DEFAULTRUNELOCALE\x0a"
"        *low = isascii(*low) \x3f static_cast<char>(_DefaultRuneLocale.__maplower\x5bstatic_cast<ptrdiff_t>(*low)\x5d) \x3a *low;\x0a"
"#elif defined(__NetBSD__)\x0a"
"        *low = static_cast<char>(__classic_lower_table()\x5bstatic_cast<unsigned char>(*low)\x5d);\x0a"
"#elif defined(__GLIBC__) \x7c\x7c defined(__EMSCRIPTEN__)\x0a"
"        *low = isascii(*low) \x3f static_cast<char>(__classic_lower_table()\x5bstatic_cast<size_t>(*low)\x5d) \x3a *low;\x0a"
"#else\x0a"
"        *low = (isascii(*low) \x26\x26 isupper_l(*low, _LIBCPP_GET_C_LOCALE)) \x3f *low-'A'+'a' \x3a *low;\x0a"
"#endif\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"char\x0a"
"ctype<char>\x3a\x3a""do_widen(char c) const\x0a"
"{\x0a"
"    return c;\x0a"
"}\x0a"
"\x0a"
"const char*\x0a"
"ctype<char>\x3a\x3a""do_widen(const char* low, const char* high, char_type* dest) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low, ++dest)\x0a"
"        *dest = *low;\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"char\x0a"
"ctype<char>\x3a\x3a""do_narrow(char_type c, char dfault) const\x0a"
"{\x0a"
"    if (isascii(c))\x0a"
"        return static_cast<char>(c);\x0a"
"    return dfault;\x0a"
"}\x0a"
"\x0a"
"const char*\x0a"
"ctype<char>\x3a\x3a""do_narrow(const char_type* low, const char_type* high, char dfault, char* dest) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low, ++dest)\x0a"
"        if (isascii(*low))\x0a"
"            *dest = *low;\x0a"
"        else\x0a"
"            *dest = dfault;\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"#if defined(__EMSCRIPTEN__)\x0a"
"extern \x22""C\x22 const unsigned short ** __ctype_b_loc();\x0a"
"extern \x22""C\x22 const int ** __ctype_tolower_loc();\x0a"
"extern \x22""C\x22 const int ** __ctype_toupper_loc();\x0a"
"#endif\x0a"
"\x0a"
"#ifdef _LIBCPP_PROVIDES_DEFAULT_RUNE_TABLE\x0a"
"const ctype<char>\x3a\x3amask*\x0a"
"ctype<char>\x3a\x3a""classic_table()  _NOEXCEPT\x0a"
"{\x0a"
"    static _LIBCPP_CONSTEXPR const ctype<char>\x3a\x3amask builtin_table\x5btable_size\x5d = {\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl \x7c space \x7c blank,\x0a"
"        cntrl \x7c space,                  cntrl \x7c space,\x0a"
"        cntrl \x7c space,                  cntrl \x7c space,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        cntrl,                          cntrl,\x0a"
"        space \x7c blank \x7c print,          punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        digit \x7c print \x7c xdigit,         digit \x7c print \x7c xdigit,\x0a"
"        digit \x7c print \x7c xdigit,         digit \x7c print \x7c xdigit,\x0a"
"        digit \x7c print \x7c xdigit,         digit \x7c print \x7c xdigit,\x0a"
"        digit \x7c print \x7c xdigit,         digit \x7c print \x7c xdigit,\x0a"
"        digit \x7c print \x7c xdigit,         digit \x7c print \x7c xdigit,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  upper \x7c xdigit \x7c print \x7c alpha,\x0a"
"        upper \x7c xdigit \x7c print \x7c alpha, upper \x7c xdigit \x7c print \x7c alpha,\x0a"
"        upper \x7c xdigit \x7c print \x7c alpha, upper \x7c xdigit \x7c print \x7c alpha,\x0a"
"        upper \x7c xdigit \x7c print \x7c alpha, upper \x7c print \x7c alpha,\x0a"
"        upper \x7c print \x7c alpha,          upper \x7c print \x7c alpha,\x0a"
"        upper \x7c print \x7c alpha,          upper \x7c print \x7c alpha,\x0a"
"        upper \x7c print \x7c alpha,          upper \x7c print \x7c alpha,\x0a"
"        upper \x7c print \x7c alpha,          upper \x7c print \x7c alpha,\x0a"
"        upper \x7c print \x7c alpha,          upper \x7c print \x7c alpha,\x0a"
"        upper \x7c print \x7c alpha,          upper \x7c print \x7c alpha,\x0a"
"        upper \x7c print \x7c alpha,          upper \x7c print \x7c alpha,\x0a"
"        upper \x7c print \x7c alpha,          upper \x7c print \x7c alpha,\x0a"
"        upper \x7c print \x7c alpha,          upper \x7c print \x7c alpha,\x0a"
"        upper \x7c print \x7c alpha,          punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  lower \x7c xdigit \x7c print \x7c alpha,\x0a"
"        lower \x7c xdigit \x7c print \x7c alpha, lower \x7c xdigit \x7c print \x7c alpha,\x0a"
"        lower \x7c xdigit \x7c print \x7c alpha, lower \x7c xdigit \x7c print \x7c alpha,\x0a"
"        lower \x7c xdigit \x7c print \x7c alpha, lower \x7c print \x7c alpha,\x0a"
"        lower \x7c print \x7c alpha,          lower \x7c print \x7c alpha,\x0a"
"        lower \x7c print \x7c alpha,          lower \x7c print \x7c alpha,\x0a"
"        lower \x7c print \x7c alpha,          lower \x7c print \x7c alpha,\x0a"
"        lower \x7c print \x7c alpha,          lower \x7c print \x7c alpha,\x0a"
"        lower \x7c print \x7c alpha,          lower \x7c print \x7c alpha,\x0a"
"        lower \x7c print \x7c alpha,          lower \x7c print \x7c alpha,\x0a"
"        lower \x7c print \x7c alpha,          lower \x7c print \x7c alpha,\x0a"
"        lower \x7c print \x7c alpha,          lower \x7c print \x7c alpha,\x0a"
"        lower \x7c print \x7c alpha,          lower \x7c print \x7c alpha,\x0a"
"        lower \x7c print \x7c alpha,          punct \x7c print,\x0a"
"        punct \x7c print,                  punct \x7c print,\x0a"
"        punct \x7c print,                  cntrl,\x0a"
"        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,\x0a"
"        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,\x0a"
"        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,\x0a"
"        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,\x0a"
"        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,\x0a"
"        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,\x0a"
"        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,\x0a"
"        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0\x0a"
"    };\x0a"
"    return builtin_table;\x0a"
"}\x0a"
"#else\x0a"
"const ctype<char>\x3a\x3amask*\x0a"
"ctype<char>\x3a\x3a""classic_table()  _NOEXCEPT\x0a"
"{\x0a"
"#if defined(__APPLE__) \x7c\x7c defined(__FreeBSD__)\x0a"
"    return _DefaultRuneLocale.__runetype;\x0a"
"#elif defined(__NetBSD__)\x0a"
"    return _C_ctype_tab_ + 1;\x0a"
"#elif defined(__GLIBC__)\x0a"
"    return _LIBCPP_GET_C_LOCALE->__ctype_b;\x0a"
"#elif __sun__\x0a"
"    return __ctype_mask;\x0a"
"#elif defined(_LIBCPP_MSVCRT) \x7c\x7c defined(__MINGW32__)\x0a"
"    return __pctype_func();\x0a"
"#elif defined(__EMSCRIPTEN__)\x0a"
"    return *__ctype_b_loc();\x0a"
"#elif defined(_NEWLIB_VERSION) \x7c\x7c defined(__OpenBSD__)\x0a"
"    // Newlib has a 257-entry table in ctype_.c, where (char)0 starts at \x5b""1\x5d.\x0a"
"    return _ctype_ + 1;\x0a"
"#elif defined(_AIX)\x0a"
"    return (const unsigned int *)__lc_ctype_ptr->obj->mask;\x0a"
"#else\x0a"
"    // Platform not supported\x3a abort so the person doing the port knows what to\x0a"
"    // fix\x0a"
"# warning  ctype<char>\x3a\x3a""classic_table() is not implemented\x0a"
"    printf(\x22""ctype<char>\x3a\x3a""classic_table() is not implemented\x5cn\x22);\x0a"
"    abort();\x0a"
"    return NULL;\x0a"
"#endif\x0a"
"}\x0a"
"#endif\x0a"
"\x0a"
"#if defined(__GLIBC__)\x0a"
"const int*\x0a"
"ctype<char>\x3a\x3a__classic_lower_table() _NOEXCEPT\x0a"
"{\x0a"
"    return _LIBCPP_GET_C_LOCALE->__ctype_tolower;\x0a"
"}\x0a"
"\x0a"
"const int*\x0a"
"ctype<char>\x3a\x3a__classic_upper_table() _NOEXCEPT\x0a"
"{\x0a"
"    return _LIBCPP_GET_C_LOCALE->__ctype_toupper;\x0a"
"}\x0a"
"#elif __NetBSD__\x0a"
"const short*\x0a"
"ctype<char>\x3a\x3a__classic_lower_table() _NOEXCEPT\x0a"
"{\x0a"
"    return _C_tolower_tab_ + 1;\x0a"
"}\x0a"
"\x0a"
"const short*\x0a"
"ctype<char>\x3a\x3a__classic_upper_table() _NOEXCEPT\x0a"
"{\x0a"
"    return _C_toupper_tab_ + 1;\x0a"
"}\x0a"
"\x0a"
"#elif defined(__EMSCRIPTEN__)\x0a"
"const int*\x0a"
"ctype<char>\x3a\x3a__classic_lower_table() _NOEXCEPT\x0a"
"{\x0a"
"    return *__ctype_tolower_loc();\x0a"
"}\x0a"
"\x0a"
"const int*\x0a"
"ctype<char>\x3a\x3a__classic_upper_table() _NOEXCEPT\x0a"
"{\x0a"
"    return *__ctype_toupper_loc();\x0a"
"}\x0a"
"#endif // __GLIBC__ \x7c\x7c __NETBSD__ \x7c\x7c __EMSCRIPTEN__\x0a"
"\x0a"
"// template <> class ctype_byname<char>\x0a"
"\x0a"
"ctype_byname<char>\x3a\x3a""ctype_byname(const char* name, size_t refs)\x0a"
"    \x3a ctype<char>(0, false, refs),\x0a"
"      __l(newlocale(LC_ALL_MASK, name, 0))\x0a"
"{\x0a"
"    if (__l == 0)\x0a"
"        __throw_runtime_error(\x22""ctype_byname<char>\x3a\x3a""ctype_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + string(name));\x0a"
"}\x0a"
"\x0a"
"ctype_byname<char>\x3a\x3a""ctype_byname(const string\x26 name, size_t refs)\x0a"
"    \x3a ctype<char>(0, false, refs),\x0a"
"      __l(newlocale(LC_ALL_MASK, name.c_str(), 0))\x0a"
"{\x0a"
"    if (__l == 0)\x0a"
"        __throw_runtime_error(\x22""ctype_byname<char>\x3a\x3a""ctype_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + name);\x0a"
"}\x0a"
"\x0a"
"ctype_byname<char>\x3a\x3a\x7e""ctype_byname()\x0a"
"{\x0a"
"    freelocale(__l);\x0a"
"}\x0a"
"\x0a"
"char\x0a"
"ctype_byname<char>\x3a\x3a""do_toupper(char_type c) const\x0a"
"{\x0a"
"    return static_cast<char>(toupper_l(static_cast<unsigned char>(c), __l));\x0a"
"}\x0a"
"\x0a"
"const char*\x0a"
"ctype_byname<char>\x3a\x3a""do_toupper(char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"        *low = static_cast<char>(toupper_l(static_cast<unsigned char>(*low), __l));\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"char\x0a"
"ctype_byname<char>\x3a\x3a""do_tolower(char_type c) const\x0a"
"{\x0a"
"    return static_cast<char>(tolower_l(static_cast<unsigned char>(c), __l));\x0a"
"}\x0a"
"\x0a"
"const char*\x0a"
"ctype_byname<char>\x3a\x3a""do_tolower(char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"        *low = static_cast<char>(tolower_l(static_cast<unsigned char>(*low), __l));\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"// template <> class ctype_byname<wchar_t>\x0a"
"\x0a"
"ctype_byname<wchar_t>\x3a\x3a""ctype_byname(const char* name, size_t refs)\x0a"
"    \x3a ctype<wchar_t>(refs),\x0a"
"      __l(newlocale(LC_ALL_MASK, name, 0))\x0a"
"{\x0a"
"    if (__l == 0)\x0a"
"        __throw_runtime_error(\x22""ctype_byname<wchar_t>\x3a\x3a""ctype_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + string(name));\x0a"
"}\x0a"
"\x0a"
"ctype_byname<wchar_t>\x3a\x3a""ctype_byname(const string\x26 name, size_t refs)\x0a"
"    \x3a ctype<wchar_t>(refs),\x0a"
"      __l(newlocale(LC_ALL_MASK, name.c_str(), 0))\x0a"
"{\x0a"
"    if (__l == 0)\x0a"
"        __throw_runtime_error(\x22""ctype_byname<wchar_t>\x3a\x3a""ctype_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + name);\x0a"
"}\x0a"
"\x0a"
"ctype_byname<wchar_t>\x3a\x3a\x7e""ctype_byname()\x0a"
"{\x0a"
"    freelocale(__l);\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_is(mask m, char_type c) const\x0a"
"{\x0a"
"#ifdef _LIBCPP_WCTYPE_IS_MASK\x0a"
"    return static_cast<bool>(iswctype_l(c, m, __l));\x0a"
"#else\x0a"
"    bool result = false;\x0a"
"    wint_t ch = static_cast<wint_t>(c);\x0a"
"    if ((m \x26 space) == space) result \x7c= (iswspace_l(ch, __l) \x21= 0);\x0a"
"    if ((m \x26 print) == print) result \x7c= (iswprint_l(ch, __l) \x21= 0);\x0a"
"    if ((m \x26 cntrl) == cntrl) result \x7c= (iswcntrl_l(ch, __l) \x21= 0);\x0a"
"    if ((m \x26 upper) == upper) result \x7c= (iswupper_l(ch, __l) \x21= 0);\x0a"
"    if ((m \x26 lower) == lower) result \x7c= (iswlower_l(ch, __l) \x21= 0);\x0a"
"    if ((m \x26 alpha) == alpha) result \x7c= (iswalpha_l(ch, __l) \x21= 0);\x0a"
"    if ((m \x26 digit) == digit) result \x7c= (iswdigit_l(ch, __l) \x21= 0);\x0a"
"    if ((m \x26 punct) == punct) result \x7c= (iswpunct_l(ch, __l) \x21= 0);\x0a"
"    if ((m \x26 xdigit) == xdigit) result \x7c= (iswxdigit_l(ch, __l) \x21= 0);\x0a"
"    if ((m \x26 blank) == blank) result \x7c= (iswblank_l(ch, __l) \x21= 0);\x0a"
"    return result;\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_is(const char_type* low, const char_type* high, mask* vec) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low, ++vec)\x0a"
"    {\x0a"
"        if (isascii(*low))\x0a"
"            *vec = static_cast<mask>(ctype<char>\x3a\x3a""classic_table()\x5b*low\x5d);\x0a"
"        else\x0a"
"        {\x0a"
"            *vec = 0;\x0a"
"            wint_t ch = static_cast<wint_t>(*low);\x0a"
"            if (iswspace_l(ch, __l))\x0a"
"                *vec \x7c= space;\x0a"
"#ifndef _LIBCPP_CTYPE_MASK_IS_COMPOSITE_PRINT\x0a"
"            if (iswprint_l(ch, __l))\x0a"
"                *vec \x7c= print;\x0a"
"#endif\x0a"
"            if (iswcntrl_l(ch, __l))\x0a"
"                *vec \x7c= cntrl;\x0a"
"            if (iswupper_l(ch, __l))\x0a"
"                *vec \x7c= upper;\x0a"
"            if (iswlower_l(ch, __l))\x0a"
"                *vec \x7c= lower;\x0a"
"#ifndef _LIBCPP_CTYPE_MASK_IS_COMPOSITE_ALPHA\x0a"
"            if (iswalpha_l(ch, __l))\x0a"
"                *vec \x7c= alpha;\x0a"
"#endif\x0a"
"            if (iswdigit_l(ch, __l))\x0a"
"                *vec \x7c= digit;\x0a"
"            if (iswpunct_l(ch, __l))\x0a"
"                *vec \x7c= punct;\x0a"
"#ifndef _LIBCPP_CTYPE_MASK_IS_COMPOSITE_XDIGIT\x0a"
"            if (iswxdigit_l(ch, __l))\x0a"
"                *vec \x7c= xdigit;\x0a"
"#endif\x0a"
"#if \x21""defined(__sun__)\x0a"
"            if (iswblank_l(ch, __l))\x0a"
"                *vec \x7c= blank;\x0a"
"#endif\x0a"
"        }\x0a"
"    }\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_scan_is(mask m, const char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"    {\x0a"
"#ifdef _LIBCPP_WCTYPE_IS_MASK\x0a"
"        if (iswctype_l(*low, m, __l))\x0a"
"            break;\x0a"
"#else\x0a"
"        wint_t ch = static_cast<wint_t>(*low);\x0a"
"        if ((m \x26 space) == space \x26\x26 iswspace_l(ch, __l)) break;\x0a"
"        if ((m \x26 print) == print \x26\x26 iswprint_l(ch, __l)) break;\x0a"
"        if ((m \x26 cntrl) == cntrl \x26\x26 iswcntrl_l(ch, __l)) break;\x0a"
"        if ((m \x26 upper) == upper \x26\x26 iswupper_l(ch, __l)) break;\x0a"
"        if ((m \x26 lower) == lower \x26\x26 iswlower_l(ch, __l)) break;\x0a"
"        if ((m \x26 alpha) == alpha \x26\x26 iswalpha_l(ch, __l)) break;\x0a"
"        if ((m \x26 digit) == digit \x26\x26 iswdigit_l(ch, __l)) break;\x0a"
"        if ((m \x26 punct) == punct \x26\x26 iswpunct_l(ch, __l)) break;\x0a"
"        if ((m \x26 xdigit) == xdigit \x26\x26 iswxdigit_l(ch, __l)) break;\x0a"
"        if ((m \x26 blank) == blank \x26\x26 iswblank_l(ch, __l)) break;\x0a"
"#endif\x0a"
"    }\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_scan_not(mask m, const char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"    {\x0a"
"#ifdef _LIBCPP_WCTYPE_IS_MASK\x0a"
"        if (\x21iswctype_l(*low, m, __l))\x0a"
"            break;\x0a"
"#else\x0a"
"        wint_t ch = static_cast<wint_t>(*low);\x0a"
"        if ((m \x26 space) == space \x26\x26 iswspace_l(ch, __l)) continue;\x0a"
"        if ((m \x26 print) == print \x26\x26 iswprint_l(ch, __l)) continue;\x0a"
"        if ((m \x26 cntrl) == cntrl \x26\x26 iswcntrl_l(ch, __l)) continue;\x0a"
"        if ((m \x26 upper) == upper \x26\x26 iswupper_l(ch, __l)) continue;\x0a"
"        if ((m \x26 lower) == lower \x26\x26 iswlower_l(ch, __l)) continue;\x0a"
"        if ((m \x26 alpha) == alpha \x26\x26 iswalpha_l(ch, __l)) continue;\x0a"
"        if ((m \x26 digit) == digit \x26\x26 iswdigit_l(ch, __l)) continue;\x0a"
"        if ((m \x26 punct) == punct \x26\x26 iswpunct_l(ch, __l)) continue;\x0a"
"        if ((m \x26 xdigit) == xdigit \x26\x26 iswxdigit_l(ch, __l)) continue;\x0a"
"        if ((m \x26 blank) == blank \x26\x26 iswblank_l(ch, __l)) continue;\x0a"
"        break;\x0a"
"#endif\x0a"
"    }\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"wchar_t\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_toupper(char_type c) const\x0a"
"{\x0a"
"    return towupper_l(c, __l);\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_toupper(char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"        *low = towupper_l(*low, __l);\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"wchar_t\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_tolower(char_type c) const\x0a"
"{\x0a"
"    return towlower_l(c, __l);\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_tolower(char_type* low, const char_type* high) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low)\x0a"
"        *low = towlower_l(*low, __l);\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"wchar_t\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_widen(char c) const\x0a"
"{\x0a"
"    return __libcpp_btowc_l(c, __l);\x0a"
"}\x0a"
"\x0a"
"const char*\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_widen(const char* low, const char* high, char_type* dest) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low, ++dest)\x0a"
"        *dest = __libcpp_btowc_l(*low, __l);\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"char\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_narrow(char_type c, char dfault) const\x0a"
"{\x0a"
"    int r = __libcpp_wctob_l(c, __l);\x0a"
"    return r \x21= static_cast<int>(WEOF) \x3f static_cast<char>(r) \x3a dfault;\x0a"
"}\x0a"
"\x0a"
"const wchar_t*\x0a"
"ctype_byname<wchar_t>\x3a\x3a""do_narrow(const char_type* low, const char_type* high, char dfault, char* dest) const\x0a"
"{\x0a"
"    for (; low \x21= high; ++low, ++dest)\x0a"
"    {\x0a"
"        int r = __libcpp_wctob_l(*low, __l);\x0a"
"        *dest = r \x21= static_cast<int>(WEOF) \x3f static_cast<char>(r) \x3a dfault;\x0a"
"    }\x0a"
"    return low;\x0a"
"}\x0a"
"\x0a"
"// template <> class codecvt<char, char, mbstate_t>\x0a"
"\x0a"
"locale\x3a\x3aid codecvt<char, char, mbstate_t>\x3a\x3aid;\x0a"
"\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3a\x7e""codecvt()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type*, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type*, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type*, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 1;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return true;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* end, size_t mx) const\x0a"
"{\x0a"
"    return static_cast<int>(min<size_t>(mx, static_cast<size_t>(end-frm)));\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<char, char, mbstate_t>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 1;\x0a"
"}\x0a"
"\x0a"
"// template <> class codecvt<wchar_t, char, mbstate_t>\x0a"
"\x0a"
"locale\x3a\x3aid codecvt<wchar_t, char, mbstate_t>\x3a\x3aid;\x0a"
"\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3a""codecvt(size_t refs)\x0a"
"    \x3a locale\x3a\x3a""facet(refs),\x0a"
"      __l(_LIBCPP_GET_C_LOCALE)\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3a""codecvt(const char* nm, size_t refs)\x0a"
"    \x3a locale\x3a\x3a""facet(refs),\x0a"
"      __l(newlocale(LC_ALL_MASK, nm, 0))\x0a"
"{\x0a"
"    if (__l == 0)\x0a"
"        __throw_runtime_error(\x22""codecvt_byname<wchar_t, char, mbstate_t>\x3a\x3a""codecvt_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + string(nm));\x0a"
"}\x0a"
"\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3a\x7e""codecvt()\x0a"
"{\x0a"
"    if (__l \x21= _LIBCPP_GET_C_LOCALE)\x0a"
"        freelocale(__l);\x0a"
"}\x0a"
"\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3a""do_out(state_type\x26 st,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    // look for first internal null in frm\x0a"
"    const intern_type* fend = frm;\x0a"
"    for (; fend \x21= frm_end; ++fend)\x0a"
"        if (*fend == 0)\x0a"
"            break;\x0a"
"    // loop over all null-terminated sequences in frm\x0a"
"    to_nxt = to;\x0a"
"    for (frm_nxt = frm; frm \x21= frm_end \x26\x26 to \x21= to_end; frm = frm_nxt, to = to_nxt)\x0a"
"    {\x0a"
"        // save state in case it is needed to recover to_nxt on error\x0a"
"        mbstate_t save_state = st;\x0a"
"        size_t n = __libcpp_wcsnrtombs_l(to, \x26""frm_nxt, static_cast<size_t>(fend-frm),\x0a"
"                                     static_cast<size_t>(to_end-to), \x26st, __l);\x0a"
"        if (n == size_t(-1))\x0a"
"        {\x0a"
"            // need to recover to_nxt\x0a"
"            for (to_nxt = to; frm \x21= frm_nxt; ++frm)\x0a"
"            {\x0a"
"                n = __libcpp_wcrtomb_l(to_nxt, *frm, \x26save_state, __l);\x0a"
"                if (n == size_t(-1))\x0a"
"                    break;\x0a"
"                to_nxt += n;\x0a"
"            }\x0a"
"            frm_nxt = frm;\x0a"
"            return error;\x0a"
"        }\x0a"
"        if (n == 0)\x0a"
"            return partial;\x0a"
"        to_nxt += n;\x0a"
"        if (to_nxt == to_end)\x0a"
"            break;\x0a"
"        if (fend \x21= frm_end)  // set up next null terminated sequence\x0a"
"        {\x0a"
"            // Try to write the terminating null\x0a"
"            extern_type tmp\x5bMB_LEN_MAX\x5d;\x0a"
"            n = __libcpp_wcrtomb_l(tmp, intern_type(), \x26st, __l);\x0a"
"            if (n == size_t(-1))  // on error\x0a"
"                return error;\x0a"
"            if (n > static_cast<size_t>(to_end-to_nxt))  // is there room\x3f\x0a"
"                return partial;\x0a"
"            for (extern_type* p = tmp; n; --n)  // write it\x0a"
"                *to_nxt++ = *p++;\x0a"
"            ++frm_nxt;\x0a"
"            // look for next null in frm\x0a"
"            for (fend = frm_nxt; fend \x21= frm_end; ++fend)\x0a"
"                if (*fend == 0)\x0a"
"                    break;\x0a"
"        }\x0a"
"    }\x0a"
"    return frm_nxt == frm_end \x3f ok \x3a partial;\x0a"
"}\x0a"
"\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3a""do_in(state_type\x26 st,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    // look for first internal null in frm\x0a"
"    const extern_type* fend = frm;\x0a"
"    for (; fend \x21= frm_end; ++fend)\x0a"
"        if (*fend == 0)\x0a"
"            break;\x0a"
"    // loop over all null-terminated sequences in frm\x0a"
"    to_nxt = to;\x0a"
"    for (frm_nxt = frm; frm \x21= frm_end \x26\x26 to \x21= to_end; frm = frm_nxt, to = to_nxt)\x0a"
"    {\x0a"
"        // save state in case it is needed to recover to_nxt on error\x0a"
"        mbstate_t save_state = st;\x0a"
"        size_t n = __libcpp_mbsnrtowcs_l(to, \x26""frm_nxt, static_cast<size_t>(fend-frm),\x0a"
"                                     static_cast<size_t>(to_end-to), \x26st, __l);\x0a"
"        if (n == size_t(-1))\x0a"
"        {\x0a"
"            // need to recover to_nxt\x0a"
"            for (to_nxt = to; frm \x21= frm_nxt; ++to_nxt)\x0a"
"            {\x0a"
"                n = __libcpp_mbrtowc_l(to_nxt, frm, static_cast<size_t>(fend-frm),\x0a"
"                                   \x26save_state, __l);\x0a"
"                switch (n)\x0a"
"                {\x0a"
"                case 0\x3a\x0a"
"                    ++frm;\x0a"
"                    break;\x0a"
"                case size_t(-1)\x3a\x0a"
"                    frm_nxt = frm;\x0a"
"                    return error;\x0a"
"                case size_t(-2)\x3a\x0a"
"                    frm_nxt = frm;\x0a"
"                    return partial;\x0a"
"                default\x3a\x0a"
"                    frm += n;\x0a"
"                    break;\x0a"
"                }\x0a"
"            }\x0a"
"            frm_nxt = frm;\x0a"
"            return frm_nxt == frm_end \x3f ok \x3a partial;\x0a"
"        }\x0a"
"        if (n == size_t(-1))\x0a"
"            return error;\x0a"
"        to_nxt += n;\x0a"
"        if (to_nxt == to_end)\x0a"
"            break;\x0a"
"        if (fend \x21= frm_end)  // set up next null terminated sequence\x0a"
"        {\x0a"
"            // Try to write the terminating null\x0a"
"            n = __libcpp_mbrtowc_l(to_nxt, frm_nxt, 1, \x26st, __l);\x0a"
"            if (n \x21= 0)  // on error\x0a"
"                return error;\x0a"
"            ++to_nxt;\x0a"
"            ++frm_nxt;\x0a"
"            // look for next null in frm\x0a"
"            for (fend = frm_nxt; fend \x21= frm_end; ++fend)\x0a"
"                if (*fend == 0)\x0a"
"                    break;\x0a"
"        }\x0a"
"    }\x0a"
"    return frm_nxt == frm_end \x3f ok \x3a partial;\x0a"
"}\x0a"
"\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3a""do_unshift(state_type\x26 st,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    extern_type tmp\x5bMB_LEN_MAX\x5d;\x0a"
"    size_t n = __libcpp_wcrtomb_l(tmp, intern_type(), \x26st, __l);\x0a"
"    if (n == size_t(-1) \x7c\x7c n == 0)  // on error\x0a"
"        return error;\x0a"
"    --n;\x0a"
"    if (n > static_cast<size_t>(to_end-to_nxt))  // is there room\x3f\x0a"
"        return partial;\x0a"
"    for (extern_type* p = tmp; n; --n)  // write it\x0a"
"        *to_nxt++ = *p++;\x0a"
"    return ok;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (__libcpp_mbtowc_l(nullptr, nullptr, MB_LEN_MAX, __l) \x21= 0)\x0a"
"        return -1;\x0a"
"\x0a"
"    // stateless encoding\x0a"
"    if (__l == 0 \x7c\x7c __libcpp_mb_cur_max_l(__l) == 1)  // there are no known constant length encodings\x0a"
"        return 1;                // which take more than 1 char to form a wchar_t\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3a""do_length(state_type\x26 st,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    int nbytes = 0;\x0a"
"    for (size_t nwchar_t = 0; nwchar_t < mx \x26\x26 frm \x21= frm_end; ++nwchar_t)\x0a"
"    {\x0a"
"        size_t n = __libcpp_mbrlen_l(frm, static_cast<size_t>(frm_end-frm), \x26st, __l);\x0a"
"        switch (n)\x0a"
"        {\x0a"
"        case 0\x3a\x0a"
"            ++nbytes;\x0a"
"            ++frm;\x0a"
"            break;\x0a"
"        case size_t(-1)\x3a\x0a"
"        case size_t(-2)\x3a\x0a"
"            return nbytes;\x0a"
"        default\x3a\x0a"
"            nbytes += n;\x0a"
"            frm += n;\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return nbytes;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<wchar_t, char, mbstate_t>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    return __l == 0 \x3f 1 \x3a static_cast<int>(__libcpp_mb_cur_max_l(__l));\x0a"
"}\x0a"
"\x0a"
"//                                     Valid UTF ranges\x0a"
"//     UTF-32               UTF-16                          UTF-8               # of code points\x0a"
"//                     first      second       first   second    third   fourth\x0a"
"// 000000 - 00007F  0000 - 007F               00 - 7F                                 127\x0a"
"// 000080 - 0007FF  0080 - 07FF               C2 - DF, 80 - BF                       1920\x0a"
"// 000800 - 000FFF  0800 - 0FFF               E0 - E0, A0 - BF, 80 - BF              2048\x0a"
"// 001000 - 00CFFF  1000 - CFFF               E1 - EC, 80 - BF, 80 - BF             49152\x0a"
"// 00D000 - 00D7FF  D000 - D7FF               ED - ED, 80 - 9F, 80 - BF              2048\x0a"
"// 00D800 - 00DFFF                invalid\x0a"
"// 00E000 - 00FFFF  E000 - FFFF               EE - EF, 80 - BF, 80 - BF              8192\x0a"
"// 010000 - 03FFFF  D800 - D8BF, DC00 - DFFF  F0 - F0, 90 - BF, 80 - BF, 80 - BF   196608\x0a"
"// 040000 - 0FFFFF  D8C0 - DBBF, DC00 - DFFF  F1 - F3, 80 - BF, 80 - BF, 80 - BF   786432\x0a"
"// 100000 - 10FFFF  DBC0 - DBFF, DC00 - DFFF  F4 - F4, 80 - 8F, 80 - BF, 80 - BF    65536\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"utf16_to_utf8(const uint16_t* frm, const uint16_t* frm_end, const uint16_t*\x26 frm_nxt,\x0a"
"              uint8_t* to, uint8_t* to_end, uint8_t*\x26 to_nxt,\x0a"
"              unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 generate_header)\x0a"
"    {\x0a"
"        if (to_end-to_nxt < 3)\x0a"
"            return codecvt_base\x3a\x3apartial;\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xEF);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xBB);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xBF);\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end; ++frm_nxt)\x0a"
"    {\x0a"
"        uint16_t wc1 = *frm_nxt;\x0a"
"        if (wc1 > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if (wc1 < 0x0080)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 1)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(wc1);\x0a"
"        }\x0a"
"        else if (wc1 < 0x0800)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xC0 \x7c (wc1 >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c (wc1 \x26 0x03F));\x0a"
"        }\x0a"
"        else if (wc1 < 0xD800)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 3)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xE0 \x7c  (wc1 >> 12));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((wc1 \x26 0x0FC0) >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c  (wc1 \x26 0x003F));\x0a"
"        }\x0a"
"        else if (wc1 < 0xDC00)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint16_t wc2 = frm_nxt\x5b""1\x5d;\x0a"
"            if ((wc2 \x26 0xFC00) \x21= 0xDC00)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            if (to_end-to_nxt < 4)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            if (((((wc1 \x26 0x03C0UL) >> 6) + 1) << 16) +\x0a"
"                ((wc1 \x26 0x003FUL) << 10) + (wc2 \x26 0x03FF) > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            ++frm_nxt;\x0a"
"            uint8_t z = ((wc1 \x26 0x03C0) >> 6) + 1;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xF0 \x7c (z >> 2));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((z \x26 0x03) << 4)     \x7c ((wc1 \x26 0x003C) >> 2));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((wc1 \x26 0x0003) << 4) \x7c ((wc2 \x26 0x03C0) >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c  (wc2 \x26 0x003F));\x0a"
"        }\x0a"
"        else if (wc1 < 0xE000)\x0a"
"        {\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 3)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xE0 \x7c  (wc1 >> 12));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((wc1 \x26 0x0FC0) >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c  (wc1 \x26 0x003F));\x0a"
"        }\x0a"
"    }\x0a"
"    return codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"utf16_to_utf8(const uint32_t* frm, const uint32_t* frm_end, const uint32_t*\x26 frm_nxt,\x0a"
"              uint8_t* to, uint8_t* to_end, uint8_t*\x26 to_nxt,\x0a"
"              unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 generate_header)\x0a"
"    {\x0a"
"        if (to_end-to_nxt < 3)\x0a"
"            return codecvt_base\x3a\x3apartial;\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xEF);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xBB);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xBF);\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end; ++frm_nxt)\x0a"
"    {\x0a"
"        uint16_t wc1 = static_cast<uint16_t>(*frm_nxt);\x0a"
"        if (wc1 > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if (wc1 < 0x0080)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 1)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(wc1);\x0a"
"        }\x0a"
"        else if (wc1 < 0x0800)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xC0 \x7c (wc1 >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c (wc1 \x26 0x03F));\x0a"
"        }\x0a"
"        else if (wc1 < 0xD800)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 3)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xE0 \x7c  (wc1 >> 12));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((wc1 \x26 0x0FC0) >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c  (wc1 \x26 0x003F));\x0a"
"        }\x0a"
"        else if (wc1 < 0xDC00)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint16_t wc2 = static_cast<uint16_t>(frm_nxt\x5b""1\x5d);\x0a"
"            if ((wc2 \x26 0xFC00) \x21= 0xDC00)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            if (to_end-to_nxt < 4)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            if (((((wc1 \x26 0x03C0UL) >> 6) + 1) << 16) +\x0a"
"                ((wc1 \x26 0x003FUL) << 10) + (wc2 \x26 0x03FF) > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            ++frm_nxt;\x0a"
"            uint8_t z = ((wc1 \x26 0x03C0) >> 6) + 1;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xF0 \x7c (z >> 2));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((z \x26 0x03) << 4)     \x7c ((wc1 \x26 0x003C) >> 2));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((wc1 \x26 0x0003) << 4) \x7c ((wc2 \x26 0x03C0) >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c  (wc2 \x26 0x003F));\x0a"
"        }\x0a"
"        else if (wc1 < 0xE000)\x0a"
"        {\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 3)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xE0 \x7c  (wc1 >> 12));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((wc1 \x26 0x0FC0) >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c  (wc1 \x26 0x003F));\x0a"
"        }\x0a"
"    }\x0a"
"    return codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"utf8_to_utf16(const uint8_t* frm, const uint8_t* frm_end, const uint8_t*\x26 frm_nxt,\x0a"
"              uint16_t* to, uint16_t* to_end, uint16_t*\x26 to_nxt,\x0a"
"              unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 3 \x26\x26 frm_nxt\x5b""0\x5d == 0xEF \x26\x26 frm_nxt\x5b""1\x5d == 0xBB \x26\x26\x0a"
"                                                          frm_nxt\x5b""2\x5d == 0xBF)\x0a"
"            frm_nxt += 3;\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end \x26\x26 to_nxt < to_end; ++to_nxt)\x0a"
"    {\x0a"
"        uint8_t c1 = *frm_nxt;\x0a"
"        if (c1 > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if (c1 < 0x80)\x0a"
"        {\x0a"
"            *to_nxt = static_cast<uint16_t>(c1);\x0a"
"            ++frm_nxt;\x0a"
"        }\x0a"
"        else if (c1 < 0xC2)\x0a"
"        {\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        }\x0a"
"        else if (c1 < 0xE0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint16_t t = static_cast<uint16_t>(((c1 \x26 0x1F) << 6) \x7c (c2 \x26 0x3F));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = t;\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else if (c1 < 0xF0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 3)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xE0\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0xA0)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            case 0xED\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint16_t t = static_cast<uint16_t>(((c1 \x26 0x0F) << 12)\x0a"
"                                             \x7c ((c2 \x26 0x3F) << 6)\x0a"
"                                             \x7c  (c3 \x26 0x3F));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = t;\x0a"
"            frm_nxt += 3;\x0a"
"        }\x0a"
"        else if (c1 < 0xF5)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 4)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            uint8_t c4 = frm_nxt\x5b""3\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xF0\x3a\x0a"
"                if (\x21(0x90 <= c2 \x26\x26 c2 <= 0xBF))\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            case 0xF4\x3a\x0a"
"                if ((c2 \x26 0xF0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80 \x7c\x7c (c4 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            if (to_end-to_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            if ((((c1 \x26 7UL) << 18) +\x0a"
"                ((c2 \x26 0x3FUL) << 12) +\x0a"
"                ((c3 \x26 0x3FUL) << 6) + (c4 \x26 0x3F)) > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = static_cast<uint16_t>(\x0a"
"                    0xD800\x0a"
"                  \x7c (((((c1 \x26 0x07) << 2) \x7c ((c2 \x26 0x30) >> 4)) - 1) << 6)\x0a"
"                  \x7c ((c2 \x26 0x0F) << 2)\x0a"
"                  \x7c ((c3 \x26 0x30) >> 4));\x0a"
"            *++to_nxt = static_cast<uint16_t>(\x0a"
"                    0xDC00\x0a"
"                  \x7c ((c3 \x26 0x0F) << 6)\x0a"
"                  \x7c  (c4 \x26 0x3F));\x0a"
"            frm_nxt += 4;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        }\x0a"
"    }\x0a"
"    return frm_nxt < frm_end \x3f codecvt_base\x3a\x3apartial \x3a codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"utf8_to_utf16(const uint8_t* frm, const uint8_t* frm_end, const uint8_t*\x26 frm_nxt,\x0a"
"              uint32_t* to, uint32_t* to_end, uint32_t*\x26 to_nxt,\x0a"
"              unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 3 \x26\x26 frm_nxt\x5b""0\x5d == 0xEF \x26\x26 frm_nxt\x5b""1\x5d == 0xBB \x26\x26\x0a"
"                                                          frm_nxt\x5b""2\x5d == 0xBF)\x0a"
"            frm_nxt += 3;\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end \x26\x26 to_nxt < to_end; ++to_nxt)\x0a"
"    {\x0a"
"        uint8_t c1 = *frm_nxt;\x0a"
"        if (c1 > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if (c1 < 0x80)\x0a"
"        {\x0a"
"            *to_nxt = static_cast<uint32_t>(c1);\x0a"
"            ++frm_nxt;\x0a"
"        }\x0a"
"        else if (c1 < 0xC2)\x0a"
"        {\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        }\x0a"
"        else if (c1 < 0xE0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint16_t t = static_cast<uint16_t>(((c1 \x26 0x1F) << 6) \x7c (c2 \x26 0x3F));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = static_cast<uint32_t>(t);\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else if (c1 < 0xF0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 3)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xE0\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0xA0)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            case 0xED\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint16_t t = static_cast<uint16_t>(((c1 \x26 0x0F) << 12)\x0a"
"                                             \x7c ((c2 \x26 0x3F) << 6)\x0a"
"                                             \x7c  (c3 \x26 0x3F));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = static_cast<uint32_t>(t);\x0a"
"            frm_nxt += 3;\x0a"
"        }\x0a"
"        else if (c1 < 0xF5)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 4)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            uint8_t c4 = frm_nxt\x5b""3\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xF0\x3a\x0a"
"                if (\x21(0x90 <= c2 \x26\x26 c2 <= 0xBF))\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            case 0xF4\x3a\x0a"
"                if ((c2 \x26 0xF0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80 \x7c\x7c (c4 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            if (to_end-to_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            if ((((c1 \x26 7UL) << 18) +\x0a"
"                ((c2 \x26 0x3FUL) << 12) +\x0a"
"                ((c3 \x26 0x3FUL) << 6) + (c4 \x26 0x3F)) > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = static_cast<uint32_t>(\x0a"
"                    0xD800\x0a"
"                  \x7c (((((c1 \x26 0x07) << 2) \x7c ((c2 \x26 0x30) >> 4)) - 1) << 6)\x0a"
"                  \x7c ((c2 \x26 0x0F) << 2)\x0a"
"                  \x7c ((c3 \x26 0x30) >> 4));\x0a"
"            *++to_nxt = static_cast<uint32_t>(\x0a"
"                    0xDC00\x0a"
"                  \x7c ((c3 \x26 0x0F) << 6)\x0a"
"                  \x7c  (c4 \x26 0x3F));\x0a"
"            frm_nxt += 4;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        }\x0a"
"    }\x0a"
"    return frm_nxt < frm_end \x3f codecvt_base\x3a\x3apartial \x3a codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"int\x0a"
"utf8_to_utf16_length(const uint8_t* frm, const uint8_t* frm_end,\x0a"
"                     size_t mx, unsigned long Maxcode = 0x10FFFF,\x0a"
"                     codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    const uint8_t* frm_nxt = frm;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 3 \x26\x26 frm_nxt\x5b""0\x5d == 0xEF \x26\x26 frm_nxt\x5b""1\x5d == 0xBB \x26\x26\x0a"
"                                                          frm_nxt\x5b""2\x5d == 0xBF)\x0a"
"            frm_nxt += 3;\x0a"
"    }\x0a"
"    for (size_t nchar16_t = 0; frm_nxt < frm_end \x26\x26 nchar16_t < mx; ++nchar16_t)\x0a"
"    {\x0a"
"        uint8_t c1 = *frm_nxt;\x0a"
"        if (c1 > Maxcode)\x0a"
"            break;\x0a"
"        if (c1 < 0x80)\x0a"
"        {\x0a"
"            ++frm_nxt;\x0a"
"        }\x0a"
"        else if (c1 < 0xC2)\x0a"
"        {\x0a"
"            break;\x0a"
"        }\x0a"
"        else if (c1 < 0xE0)\x0a"
"        {\x0a"
"            if ((frm_end-frm_nxt < 2) \x7c\x7c (frm_nxt\x5b""1\x5d \x26 0xC0) \x21= 0x80)\x0a"
"                break;\x0a"
"            uint16_t t = static_cast<uint16_t>(((c1 \x26 0x1F) << 6) \x7c (frm_nxt\x5b""1\x5d \x26 0x3F));\x0a"
"            if (t > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else if (c1 < 0xF0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 3)\x0a"
"                break;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xE0\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0xA0)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                break;\x0a"
"            case 0xED\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0x80)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80)\x0a"
"                break;\x0a"
"            if ((((c1 \x26 0x0Fu) << 12) \x7c ((c2 \x26 0x3Fu) << 6) \x7c (c3 \x26 0x3Fu)) > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 3;\x0a"
"        }\x0a"
"        else if (c1 < 0xF5)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 4 \x7c\x7c mx-nchar16_t < 2)\x0a"
"                break;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            uint8_t c4 = frm_nxt\x5b""3\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xF0\x3a\x0a"
"                if (\x21(0x90 <= c2 \x26\x26 c2 <= 0xBF))\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            case 0xF4\x3a\x0a"
"                if ((c2 \x26 0xF0) \x21= 0x80)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80 \x7c\x7c (c4 \x26 0xC0) \x21= 0x80)\x0a"
"                break;\x0a"
"            if ((((c1 \x26 7UL) << 18) +\x0a"
"                ((c2 \x26 0x3FUL) << 12) +\x0a"
"                ((c3 \x26 0x3FUL) << 6) + (c4 \x26 0x3F)) > Maxcode)\x0a"
"                break;\x0a"
"            ++nchar16_t;\x0a"
"            frm_nxt += 4;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return static_cast<int>(frm_nxt - frm);\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"ucs4_to_utf8(const uint32_t* frm, const uint32_t* frm_end, const uint32_t*\x26 frm_nxt,\x0a"
"             uint8_t* to, uint8_t* to_end, uint8_t*\x26 to_nxt,\x0a"
"             unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 generate_header)\x0a"
"    {\x0a"
"        if (to_end-to_nxt < 3)\x0a"
"            return codecvt_base\x3a\x3apartial;\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xEF);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xBB);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xBF);\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end; ++frm_nxt)\x0a"
"    {\x0a"
"        uint32_t wc = *frm_nxt;\x0a"
"        if ((wc \x26 0xFFFFF800) == 0x00D800 \x7c\x7c wc > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if (wc < 0x000080)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 1)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(wc);\x0a"
"        }\x0a"
"        else if (wc < 0x000800)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xC0 \x7c (wc >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c (wc \x26 0x03F));\x0a"
"        }\x0a"
"        else if (wc < 0x010000)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 3)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xE0 \x7c  (wc >> 12));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((wc \x26 0x0FC0) >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c  (wc \x26 0x003F));\x0a"
"        }\x0a"
"        else // if (wc < 0x110000)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 4)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xF0 \x7c  (wc >> 18));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((wc \x26 0x03F000) >> 12));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((wc \x26 0x000FC0) >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c  (wc \x26 0x00003F));\x0a"
"        }\x0a"
"    }\x0a"
"    return codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"utf8_to_ucs4(const uint8_t* frm, const uint8_t* frm_end, const uint8_t*\x26 frm_nxt,\x0a"
"             uint32_t* to, uint32_t* to_end, uint32_t*\x26 to_nxt,\x0a"
"             unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 3 \x26\x26 frm_nxt\x5b""0\x5d == 0xEF \x26\x26 frm_nxt\x5b""1\x5d == 0xBB \x26\x26\x0a"
"                                                          frm_nxt\x5b""2\x5d == 0xBF)\x0a"
"            frm_nxt += 3;\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end \x26\x26 to_nxt < to_end; ++to_nxt)\x0a"
"    {\x0a"
"        uint8_t c1 = static_cast<uint8_t>(*frm_nxt);\x0a"
"        if (c1 < 0x80)\x0a"
"        {\x0a"
"            if (c1 > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = static_cast<uint32_t>(c1);\x0a"
"            ++frm_nxt;\x0a"
"        }\x0a"
"        else if (c1 < 0xC2)\x0a"
"        {\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        }\x0a"
"        else if (c1 < 0xE0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint32_t t = static_cast<uint32_t>(((c1 \x26 0x1F) << 6)\x0a"
"                                              \x7c (c2 \x26 0x3F));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = t;\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else if (c1 < 0xF0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 3)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xE0\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0xA0)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            case 0xED\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint32_t t = static_cast<uint32_t>(((c1 \x26 0x0F) << 12)\x0a"
"                                             \x7c ((c2 \x26 0x3F) << 6)\x0a"
"                                             \x7c  (c3 \x26 0x3F));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = t;\x0a"
"            frm_nxt += 3;\x0a"
"        }\x0a"
"        else if (c1 < 0xF5)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 4)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            uint8_t c4 = frm_nxt\x5b""3\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xF0\x3a\x0a"
"                if (\x21(0x90 <= c2 \x26\x26 c2 <= 0xBF))\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            case 0xF4\x3a\x0a"
"                if ((c2 \x26 0xF0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80 \x7c\x7c (c4 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint32_t t = static_cast<uint32_t>(((c1 \x26 0x07) << 18)\x0a"
"                                             \x7c ((c2 \x26 0x3F) << 12)\x0a"
"                                             \x7c ((c3 \x26 0x3F) << 6)\x0a"
"                                             \x7c  (c4 \x26 0x3F));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = t;\x0a"
"            frm_nxt += 4;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        }\x0a"
"    }\x0a"
"    return frm_nxt < frm_end \x3f codecvt_base\x3a\x3apartial \x3a codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"int\x0a"
"utf8_to_ucs4_length(const uint8_t* frm, const uint8_t* frm_end,\x0a"
"                    size_t mx, unsigned long Maxcode = 0x10FFFF,\x0a"
"                    codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    const uint8_t* frm_nxt = frm;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 3 \x26\x26 frm_nxt\x5b""0\x5d == 0xEF \x26\x26 frm_nxt\x5b""1\x5d == 0xBB \x26\x26\x0a"
"                                                          frm_nxt\x5b""2\x5d == 0xBF)\x0a"
"            frm_nxt += 3;\x0a"
"    }\x0a"
"    for (size_t nchar32_t = 0; frm_nxt < frm_end \x26\x26 nchar32_t < mx; ++nchar32_t)\x0a"
"    {\x0a"
"        uint8_t c1 = static_cast<uint8_t>(*frm_nxt);\x0a"
"        if (c1 < 0x80)\x0a"
"        {\x0a"
"            if (c1 > Maxcode)\x0a"
"                break;\x0a"
"            ++frm_nxt;\x0a"
"        }\x0a"
"        else if (c1 < 0xC2)\x0a"
"        {\x0a"
"            break;\x0a"
"        }\x0a"
"        else if (c1 < 0xE0)\x0a"
"        {\x0a"
"            if ((frm_end-frm_nxt < 2) \x7c\x7c ((frm_nxt\x5b""1\x5d \x26 0xC0) \x21= 0x80))\x0a"
"                break;\x0a"
"            if ((((c1 \x26 0x1Fu) << 6) \x7c (frm_nxt\x5b""1\x5d \x26 0x3Fu)) > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else if (c1 < 0xF0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 3)\x0a"
"                break;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xE0\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0xA0)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                break;\x0a"
"            case 0xED\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0x80)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80)\x0a"
"                break;\x0a"
"            if ((((c1 \x26 0x0Fu) << 12) \x7c ((c2 \x26 0x3Fu) << 6) \x7c (c3 \x26 0x3Fu)) > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 3;\x0a"
"        }\x0a"
"        else if (c1 < 0xF5)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 4)\x0a"
"                break;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            uint8_t c4 = frm_nxt\x5b""3\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xF0\x3a\x0a"
"                if (\x21(0x90 <= c2 \x26\x26 c2 <= 0xBF))\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            case 0xF4\x3a\x0a"
"                if ((c2 \x26 0xF0) \x21= 0x80)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80 \x7c\x7c (c4 \x26 0xC0) \x21= 0x80)\x0a"
"                break;\x0a"
"            if ((((c1 \x26 0x07u) << 18) \x7c ((c2 \x26 0x3Fu) << 12) \x7c\x0a"
"                 ((c3 \x26 0x3Fu) << 6)  \x7c  (c4 \x26 0x3Fu)) > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 4;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return static_cast<int>(frm_nxt - frm);\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"ucs2_to_utf8(const uint16_t* frm, const uint16_t* frm_end, const uint16_t*\x26 frm_nxt,\x0a"
"             uint8_t* to, uint8_t* to_end, uint8_t*\x26 to_nxt,\x0a"
"             unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 generate_header)\x0a"
"    {\x0a"
"        if (to_end-to_nxt < 3)\x0a"
"            return codecvt_base\x3a\x3apartial;\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xEF);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xBB);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xBF);\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end; ++frm_nxt)\x0a"
"    {\x0a"
"        uint16_t wc = *frm_nxt;\x0a"
"        if ((wc \x26 0xF800) == 0xD800 \x7c\x7c wc > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if (wc < 0x0080)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 1)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(wc);\x0a"
"        }\x0a"
"        else if (wc < 0x0800)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xC0 \x7c (wc >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c (wc \x26 0x03F));\x0a"
"        }\x0a"
"        else // if (wc <= 0xFFFF)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 3)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0xE0 \x7c  (wc >> 12));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c ((wc \x26 0x0FC0) >> 6));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(0x80 \x7c  (wc \x26 0x003F));\x0a"
"        }\x0a"
"    }\x0a"
"    return codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"utf8_to_ucs2(const uint8_t* frm, const uint8_t* frm_end, const uint8_t*\x26 frm_nxt,\x0a"
"             uint16_t* to, uint16_t* to_end, uint16_t*\x26 to_nxt,\x0a"
"             unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 3 \x26\x26 frm_nxt\x5b""0\x5d == 0xEF \x26\x26 frm_nxt\x5b""1\x5d == 0xBB \x26\x26\x0a"
"                                                          frm_nxt\x5b""2\x5d == 0xBF)\x0a"
"            frm_nxt += 3;\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end \x26\x26 to_nxt < to_end; ++to_nxt)\x0a"
"    {\x0a"
"        uint8_t c1 = static_cast<uint8_t>(*frm_nxt);\x0a"
"        if (c1 < 0x80)\x0a"
"        {\x0a"
"            if (c1 > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = static_cast<uint16_t>(c1);\x0a"
"            ++frm_nxt;\x0a"
"        }\x0a"
"        else if (c1 < 0xC2)\x0a"
"        {\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        }\x0a"
"        else if (c1 < 0xE0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint16_t t = static_cast<uint16_t>(((c1 \x26 0x1F) << 6)\x0a"
"                                              \x7c (c2 \x26 0x3F));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = t;\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else if (c1 < 0xF0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 3)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xE0\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0xA0)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            case 0xED\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return codecvt_base\x3a\x3a""error;\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint16_t t = static_cast<uint16_t>(((c1 \x26 0x0F) << 12)\x0a"
"                                             \x7c ((c2 \x26 0x3F) << 6)\x0a"
"                                             \x7c  (c3 \x26 0x3F));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = t;\x0a"
"            frm_nxt += 3;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        }\x0a"
"    }\x0a"
"    return frm_nxt < frm_end \x3f codecvt_base\x3a\x3apartial \x3a codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"int\x0a"
"utf8_to_ucs2_length(const uint8_t* frm, const uint8_t* frm_end,\x0a"
"                    size_t mx, unsigned long Maxcode = 0x10FFFF,\x0a"
"                    codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    const uint8_t* frm_nxt = frm;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 3 \x26\x26 frm_nxt\x5b""0\x5d == 0xEF \x26\x26 frm_nxt\x5b""1\x5d == 0xBB \x26\x26\x0a"
"                                                          frm_nxt\x5b""2\x5d == 0xBF)\x0a"
"            frm_nxt += 3;\x0a"
"    }\x0a"
"    for (size_t nchar32_t = 0; frm_nxt < frm_end \x26\x26 nchar32_t < mx; ++nchar32_t)\x0a"
"    {\x0a"
"        uint8_t c1 = static_cast<uint8_t>(*frm_nxt);\x0a"
"        if (c1 < 0x80)\x0a"
"        {\x0a"
"            if (c1 > Maxcode)\x0a"
"                break;\x0a"
"            ++frm_nxt;\x0a"
"        }\x0a"
"        else if (c1 < 0xC2)\x0a"
"        {\x0a"
"            break;\x0a"
"        }\x0a"
"        else if (c1 < 0xE0)\x0a"
"        {\x0a"
"            if ((frm_end-frm_nxt < 2) \x7c\x7c ((frm_nxt\x5b""1\x5d \x26 0xC0) \x21= 0x80))\x0a"
"                break;\x0a"
"            if ((((c1 \x26 0x1Fu) << 6) \x7c (frm_nxt\x5b""1\x5d \x26 0x3Fu)) > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else if (c1 < 0xF0)\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 3)\x0a"
"                break;\x0a"
"            uint8_t c2 = frm_nxt\x5b""1\x5d;\x0a"
"            uint8_t c3 = frm_nxt\x5b""2\x5d;\x0a"
"            switch (c1)\x0a"
"            {\x0a"
"            case 0xE0\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0xA0)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                break;\x0a"
"            case 0xED\x3a\x0a"
"                if ((c2 \x26 0xE0) \x21= 0x80)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            default\x3a\x0a"
"                if ((c2 \x26 0xC0) \x21= 0x80)\x0a"
"                    return static_cast<int>(frm_nxt - frm);\x0a"
"                 break;\x0a"
"            }\x0a"
"            if ((c3 \x26 0xC0) \x21= 0x80)\x0a"
"                break;\x0a"
"            if ((((c1 \x26 0x0Fu) << 12) \x7c ((c2 \x26 0x3Fu) << 6) \x7c (c3 \x26 0x3Fu)) > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 3;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            break;\x0a"
"        }\x0a"
"    }\x0a"
"    return static_cast<int>(frm_nxt - frm);\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"ucs4_to_utf16be(const uint32_t* frm, const uint32_t* frm_end, const uint32_t*\x26 frm_nxt,\x0a"
"                uint8_t* to, uint8_t* to_end, uint8_t*\x26 to_nxt,\x0a"
"                unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 generate_header)\x0a"
"    {\x0a"
"        if (to_end-to_nxt < 2)\x0a"
"            return codecvt_base\x3a\x3apartial;\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xFE);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xFF);\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end; ++frm_nxt)\x0a"
"    {\x0a"
"        uint32_t wc = *frm_nxt;\x0a"
"        if ((wc \x26 0xFFFFF800) == 0x00D800 \x7c\x7c wc > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if (wc < 0x010000)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(wc >> 8);\x0a"
"            *to_nxt++ = static_cast<uint8_t>(wc);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 4)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint16_t t = static_cast<uint16_t>(\x0a"
"                    0xD800\x0a"
"                  \x7c ((((wc \x26 0x1F0000) >> 16) - 1) << 6)\x0a"
"                  \x7c   ((wc \x26 0x00FC00) >> 10));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(t >> 8);\x0a"
"            *to_nxt++ = static_cast<uint8_t>(t);\x0a"
"            t = static_cast<uint16_t>(0xDC00 \x7c (wc \x26 0x03FF));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(t >> 8);\x0a"
"            *to_nxt++ = static_cast<uint8_t>(t);\x0a"
"        }\x0a"
"    }\x0a"
"    return codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"utf16be_to_ucs4(const uint8_t* frm, const uint8_t* frm_end, const uint8_t*\x26 frm_nxt,\x0a"
"                uint32_t* to, uint32_t* to_end, uint32_t*\x26 to_nxt,\x0a"
"                unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 2 \x26\x26 frm_nxt\x5b""0\x5d == 0xFE \x26\x26 frm_nxt\x5b""1\x5d == 0xFF)\x0a"
"            frm_nxt += 2;\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end - 1 \x26\x26 to_nxt < to_end; ++to_nxt)\x0a"
"    {\x0a"
"        uint16_t c1 = static_cast<uint16_t>(frm_nxt\x5b""0\x5d << 8 \x7c frm_nxt\x5b""1\x5d);\x0a"
"        if ((c1 \x26 0xFC00) == 0xDC00)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if ((c1 \x26 0xFC00) \x21= 0xD800)\x0a"
"        {\x0a"
"            if (c1 > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = static_cast<uint32_t>(c1);\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 4)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint16_t c2 = static_cast<uint16_t>(frm_nxt\x5b""2\x5d << 8 \x7c frm_nxt\x5b""3\x5d);\x0a"
"            if ((c2 \x26 0xFC00) \x21= 0xDC00)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint32_t t = static_cast<uint32_t>(\x0a"
"                    ((((c1 \x26 0x03C0) >> 6) + 1) << 16)\x0a"
"                  \x7c   ((c1 \x26 0x003F) << 10)\x0a"
"                  \x7c    (c2 \x26 0x03FF));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = t;\x0a"
"            frm_nxt += 4;\x0a"
"        }\x0a"
"    }\x0a"
"    return frm_nxt < frm_end \x3f codecvt_base\x3a\x3apartial \x3a codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"int\x0a"
"utf16be_to_ucs4_length(const uint8_t* frm, const uint8_t* frm_end,\x0a"
"                       size_t mx, unsigned long Maxcode = 0x10FFFF,\x0a"
"                       codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    const uint8_t* frm_nxt = frm;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 2 \x26\x26 frm_nxt\x5b""0\x5d == 0xFE \x26\x26 frm_nxt\x5b""1\x5d == 0xFF)\x0a"
"            frm_nxt += 2;\x0a"
"    }\x0a"
"    for (size_t nchar32_t = 0; frm_nxt < frm_end - 1 \x26\x26 nchar32_t < mx; ++nchar32_t)\x0a"
"    {\x0a"
"        uint16_t c1 = static_cast<uint16_t>(frm_nxt\x5b""0\x5d << 8 \x7c frm_nxt\x5b""1\x5d);\x0a"
"        if ((c1 \x26 0xFC00) == 0xDC00)\x0a"
"            break;\x0a"
"        if ((c1 \x26 0xFC00) \x21= 0xD800)\x0a"
"        {\x0a"
"            if (c1 > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 4)\x0a"
"                break;\x0a"
"            uint16_t c2 = static_cast<uint16_t>(frm_nxt\x5b""2\x5d << 8 \x7c frm_nxt\x5b""3\x5d);\x0a"
"            if ((c2 \x26 0xFC00) \x21= 0xDC00)\x0a"
"                break;\x0a"
"            uint32_t t = static_cast<uint32_t>(\x0a"
"                    ((((c1 \x26 0x03C0) >> 6) + 1) << 16)\x0a"
"                  \x7c   ((c1 \x26 0x003F) << 10)\x0a"
"                  \x7c    (c2 \x26 0x03FF));\x0a"
"            if (t > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 4;\x0a"
"        }\x0a"
"    }\x0a"
"    return static_cast<int>(frm_nxt - frm);\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"ucs4_to_utf16le(const uint32_t* frm, const uint32_t* frm_end, const uint32_t*\x26 frm_nxt,\x0a"
"                uint8_t* to, uint8_t* to_end, uint8_t*\x26 to_nxt,\x0a"
"                unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 generate_header)\x0a"
"    {\x0a"
"        if (to_end - to_nxt < 2)\x0a"
"            return codecvt_base\x3a\x3apartial;\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xFF);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xFE);\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end; ++frm_nxt)\x0a"
"    {\x0a"
"        uint32_t wc = *frm_nxt;\x0a"
"        if ((wc \x26 0xFFFFF800) == 0x00D800 \x7c\x7c wc > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if (wc < 0x010000)\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 2)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            *to_nxt++ = static_cast<uint8_t>(wc);\x0a"
"            *to_nxt++ = static_cast<uint8_t>(wc >> 8);\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (to_end-to_nxt < 4)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint16_t t = static_cast<uint16_t>(\x0a"
"                    0xD800\x0a"
"                  \x7c ((((wc \x26 0x1F0000) >> 16) - 1) << 6)\x0a"
"                  \x7c   ((wc \x26 0x00FC00) >> 10));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(t);\x0a"
"            *to_nxt++ = static_cast<uint8_t>(t >> 8);\x0a"
"            t = static_cast<uint16_t>(0xDC00 \x7c (wc \x26 0x03FF));\x0a"
"            *to_nxt++ = static_cast<uint8_t>(t);\x0a"
"            *to_nxt++ = static_cast<uint8_t>(t >> 8);\x0a"
"        }\x0a"
"    }\x0a"
"    return codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"utf16le_to_ucs4(const uint8_t* frm, const uint8_t* frm_end, const uint8_t*\x26 frm_nxt,\x0a"
"                uint32_t* to, uint32_t* to_end, uint32_t*\x26 to_nxt,\x0a"
"                unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 2 \x26\x26 frm_nxt\x5b""0\x5d == 0xFF \x26\x26 frm_nxt\x5b""1\x5d == 0xFE)\x0a"
"            frm_nxt += 2;\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end - 1 \x26\x26 to_nxt < to_end; ++to_nxt)\x0a"
"    {\x0a"
"        uint16_t c1 = static_cast<uint16_t>(frm_nxt\x5b""1\x5d << 8 \x7c frm_nxt\x5b""0\x5d);\x0a"
"        if ((c1 \x26 0xFC00) == 0xDC00)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if ((c1 \x26 0xFC00) \x21= 0xD800)\x0a"
"        {\x0a"
"            if (c1 > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = static_cast<uint32_t>(c1);\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 4)\x0a"
"                return codecvt_base\x3a\x3apartial;\x0a"
"            uint16_t c2 = static_cast<uint16_t>(frm_nxt\x5b""3\x5d << 8 \x7c frm_nxt\x5b""2\x5d);\x0a"
"            if ((c2 \x26 0xFC00) \x21= 0xDC00)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            uint32_t t = static_cast<uint32_t>(\x0a"
"                    ((((c1 \x26 0x03C0) >> 6) + 1) << 16)\x0a"
"                  \x7c   ((c1 \x26 0x003F) << 10)\x0a"
"                  \x7c    (c2 \x26 0x03FF));\x0a"
"            if (t > Maxcode)\x0a"
"                return codecvt_base\x3a\x3a""error;\x0a"
"            *to_nxt = t;\x0a"
"            frm_nxt += 4;\x0a"
"        }\x0a"
"    }\x0a"
"    return frm_nxt < frm_end \x3f codecvt_base\x3a\x3apartial \x3a codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"int\x0a"
"utf16le_to_ucs4_length(const uint8_t* frm, const uint8_t* frm_end,\x0a"
"                       size_t mx, unsigned long Maxcode = 0x10FFFF,\x0a"
"                       codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    const uint8_t* frm_nxt = frm;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 2 \x26\x26 frm_nxt\x5b""0\x5d == 0xFF \x26\x26 frm_nxt\x5b""1\x5d == 0xFE)\x0a"
"            frm_nxt += 2;\x0a"
"    }\x0a"
"    for (size_t nchar32_t = 0; frm_nxt < frm_end - 1 \x26\x26 nchar32_t < mx; ++nchar32_t)\x0a"
"    {\x0a"
"        uint16_t c1 = static_cast<uint16_t>(frm_nxt\x5b""1\x5d << 8 \x7c frm_nxt\x5b""0\x5d);\x0a"
"        if ((c1 \x26 0xFC00) == 0xDC00)\x0a"
"            break;\x0a"
"        if ((c1 \x26 0xFC00) \x21= 0xD800)\x0a"
"        {\x0a"
"            if (c1 > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 2;\x0a"
"        }\x0a"
"        else\x0a"
"        {\x0a"
"            if (frm_end-frm_nxt < 4)\x0a"
"                break;\x0a"
"            uint16_t c2 = static_cast<uint16_t>(frm_nxt\x5b""3\x5d << 8 \x7c frm_nxt\x5b""2\x5d);\x0a"
"            if ((c2 \x26 0xFC00) \x21= 0xDC00)\x0a"
"                break;\x0a"
"            uint32_t t = static_cast<uint32_t>(\x0a"
"                    ((((c1 \x26 0x03C0) >> 6) + 1) << 16)\x0a"
"                  \x7c   ((c1 \x26 0x003F) << 10)\x0a"
"                  \x7c    (c2 \x26 0x03FF));\x0a"
"            if (t > Maxcode)\x0a"
"                break;\x0a"
"            frm_nxt += 4;\x0a"
"        }\x0a"
"    }\x0a"
"    return static_cast<int>(frm_nxt - frm);\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"ucs2_to_utf16be(const uint16_t* frm, const uint16_t* frm_end, const uint16_t*\x26 frm_nxt,\x0a"
"                uint8_t* to, uint8_t* to_end, uint8_t*\x26 to_nxt,\x0a"
"                unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 generate_header)\x0a"
"    {\x0a"
"        if (to_end-to_nxt < 2)\x0a"
"            return codecvt_base\x3a\x3apartial;\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xFE);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xFF);\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end; ++frm_nxt)\x0a"
"    {\x0a"
"        uint16_t wc = *frm_nxt;\x0a"
"        if ((wc \x26 0xF800) == 0xD800 \x7c\x7c wc > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if (to_end-to_nxt < 2)\x0a"
"            return codecvt_base\x3a\x3apartial;\x0a"
"        *to_nxt++ = static_cast<uint8_t>(wc >> 8);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(wc);\x0a"
"    }\x0a"
"    return codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"utf16be_to_ucs2(const uint8_t* frm, const uint8_t* frm_end, const uint8_t*\x26 frm_nxt,\x0a"
"                uint16_t* to, uint16_t* to_end, uint16_t*\x26 to_nxt,\x0a"
"                unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 2 \x26\x26 frm_nxt\x5b""0\x5d == 0xFE \x26\x26 frm_nxt\x5b""1\x5d == 0xFF)\x0a"
"            frm_nxt += 2;\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end - 1 \x26\x26 to_nxt < to_end; ++to_nxt)\x0a"
"    {\x0a"
"        uint16_t c1 = static_cast<uint16_t>(frm_nxt\x5b""0\x5d << 8 \x7c frm_nxt\x5b""1\x5d);\x0a"
"        if ((c1 \x26 0xF800) == 0xD800 \x7c\x7c c1 > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        *to_nxt = c1;\x0a"
"        frm_nxt += 2;\x0a"
"    }\x0a"
"    return frm_nxt < frm_end \x3f codecvt_base\x3a\x3apartial \x3a codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"int\x0a"
"utf16be_to_ucs2_length(const uint8_t* frm, const uint8_t* frm_end,\x0a"
"                       size_t mx, unsigned long Maxcode = 0x10FFFF,\x0a"
"                       codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    const uint8_t* frm_nxt = frm;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 2 \x26\x26 frm_nxt\x5b""0\x5d == 0xFE \x26\x26 frm_nxt\x5b""1\x5d == 0xFF)\x0a"
"            frm_nxt += 2;\x0a"
"    }\x0a"
"    for (size_t nchar16_t = 0; frm_nxt < frm_end - 1 \x26\x26 nchar16_t < mx; ++nchar16_t)\x0a"
"    {\x0a"
"        uint16_t c1 = static_cast<uint16_t>(frm_nxt\x5b""0\x5d << 8 \x7c frm_nxt\x5b""1\x5d);\x0a"
"        if ((c1 \x26 0xF800) == 0xD800 \x7c\x7c c1 > Maxcode)\x0a"
"            break;\x0a"
"        frm_nxt += 2;\x0a"
"    }\x0a"
"    return static_cast<int>(frm_nxt - frm);\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"ucs2_to_utf16le(const uint16_t* frm, const uint16_t* frm_end, const uint16_t*\x26 frm_nxt,\x0a"
"                uint8_t* to, uint8_t* to_end, uint8_t*\x26 to_nxt,\x0a"
"                unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 generate_header)\x0a"
"    {\x0a"
"        if (to_end-to_nxt < 2)\x0a"
"            return codecvt_base\x3a\x3apartial;\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xFF);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(0xFE);\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end; ++frm_nxt)\x0a"
"    {\x0a"
"        uint16_t wc = *frm_nxt;\x0a"
"        if ((wc \x26 0xF800) == 0xD800 \x7c\x7c wc > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        if (to_end-to_nxt < 2)\x0a"
"            return codecvt_base\x3a\x3apartial;\x0a"
"        *to_nxt++ = static_cast<uint8_t>(wc);\x0a"
"        *to_nxt++ = static_cast<uint8_t>(wc >> 8);\x0a"
"    }\x0a"
"    return codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"codecvt_base\x3a\x3aresult\x0a"
"utf16le_to_ucs2(const uint8_t* frm, const uint8_t* frm_end, const uint8_t*\x26 frm_nxt,\x0a"
"                uint16_t* to, uint16_t* to_end, uint16_t*\x26 to_nxt,\x0a"
"                unsigned long Maxcode = 0x10FFFF, codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    frm_nxt = frm;\x0a"
"    to_nxt = to;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 2 \x26\x26 frm_nxt\x5b""0\x5d == 0xFF \x26\x26 frm_nxt\x5b""1\x5d == 0xFE)\x0a"
"            frm_nxt += 2;\x0a"
"    }\x0a"
"    for (; frm_nxt < frm_end - 1 \x26\x26 to_nxt < to_end; ++to_nxt)\x0a"
"    {\x0a"
"        uint16_t c1 = static_cast<uint16_t>(frm_nxt\x5b""1\x5d << 8 \x7c frm_nxt\x5b""0\x5d);\x0a"
"        if ((c1 \x26 0xF800) == 0xD800 \x7c\x7c c1 > Maxcode)\x0a"
"            return codecvt_base\x3a\x3a""error;\x0a"
"        *to_nxt = c1;\x0a"
"        frm_nxt += 2;\x0a"
"    }\x0a"
"    return frm_nxt < frm_end \x3f codecvt_base\x3a\x3apartial \x3a codecvt_base\x3a\x3aok;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"int\x0a"
"utf16le_to_ucs2_length(const uint8_t* frm, const uint8_t* frm_end,\x0a"
"                       size_t mx, unsigned long Maxcode = 0x10FFFF,\x0a"
"                       codecvt_mode mode = codecvt_mode(0))\x0a"
"{\x0a"
"    const uint8_t* frm_nxt = frm;\x0a"
"    frm_nxt = frm;\x0a"
"    if (mode \x26 consume_header)\x0a"
"    {\x0a"
"        if (frm_end-frm_nxt >= 2 \x26\x26 frm_nxt\x5b""0\x5d == 0xFF \x26\x26 frm_nxt\x5b""1\x5d == 0xFE)\x0a"
"            frm_nxt += 2;\x0a"
"    }\x0a"
"    for (size_t nchar16_t = 0; frm_nxt < frm_end - 1 \x26\x26 nchar16_t < mx; ++nchar16_t)\x0a"
"    {\x0a"
"        uint16_t c1 = static_cast<uint16_t>(frm_nxt\x5b""1\x5d << 8 \x7c frm_nxt\x5b""0\x5d);\x0a"
"        if ((c1 \x26 0xF800) == 0xD800 \x7c\x7c c1 > Maxcode)\x0a"
"            break;\x0a"
"        frm_nxt += 2;\x0a"
"    }\x0a"
"    return static_cast<int>(frm_nxt - frm);\x0a"
"}\x0a"
"\x0a"
"// template <> class codecvt<char16_t, char, mbstate_t>\x0a"
"\x0a"
"locale\x3a\x3aid codecvt<char16_t, char, mbstate_t>\x3a\x3aid;\x0a"
"\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3a\x7e""codecvt()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint16_t* _frm = reinterpret_cast<const uint16_t*>(frm);\x0a"
"    const uint16_t* _frm_end = reinterpret_cast<const uint16_t*>(frm_end);\x0a"
"    const uint16_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = utf16_to_utf8(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint16_t* _to = reinterpret_cast<uint16_t*>(to);\x0a"
"    uint16_t* _to_end = reinterpret_cast<uint16_t*>(to_end);\x0a"
"    uint16_t* _to_nxt = _to;\x0a"
"    result r = utf8_to_utf16(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf8_to_utf16_length(_frm, _frm_end, mx);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<char16_t, char, mbstate_t>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// template <> class codecvt<char32_t, char, mbstate_t>\x0a"
"\x0a"
"locale\x3a\x3aid codecvt<char32_t, char, mbstate_t>\x3a\x3aid;\x0a"
"\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3a\x7e""codecvt()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint32_t* _frm = reinterpret_cast<const uint32_t*>(frm);\x0a"
"    const uint32_t* _frm_end = reinterpret_cast<const uint32_t*>(frm_end);\x0a"
"    const uint32_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = ucs4_to_utf8(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint32_t* _to = reinterpret_cast<uint32_t*>(to);\x0a"
"    uint32_t* _to_end = reinterpret_cast<uint32_t*>(to_end);\x0a"
"    uint32_t* _to_nxt = _to;\x0a"
"    result r = utf8_to_ucs4(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3aresult\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf8_to_ucs4_length(_frm, _frm_end, mx);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"codecvt<char32_t, char, mbstate_t>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf8<wchar_t>\x0a"
"\x0a"
"__codecvt_utf8<wchar_t>\x3a\x3aresult\x0a"
"__codecvt_utf8<wchar_t>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"#if defined(_LIBCPP_SHORT_WCHAR)\x0a"
"    const uint16_t* _frm = reinterpret_cast<const uint16_t*>(frm);\x0a"
"    const uint16_t* _frm_end = reinterpret_cast<const uint16_t*>(frm_end);\x0a"
"    const uint16_t* _frm_nxt = _frm;\x0a"
"#else\x0a"
"    const uint32_t* _frm = reinterpret_cast<const uint32_t*>(frm);\x0a"
"    const uint32_t* _frm_end = reinterpret_cast<const uint32_t*>(frm_end);\x0a"
"    const uint32_t* _frm_nxt = _frm;\x0a"
"#endif\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"#if defined(_LIBCPP_SHORT_WCHAR)\x0a"
"    result r = ucs2_to_utf8(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                            _Maxcode_, _Mode_);\x0a"
"#else\x0a"
"    result r = ucs4_to_utf8(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                            _Maxcode_, _Mode_);\x0a"
"#endif\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8<wchar_t>\x3a\x3aresult\x0a"
"__codecvt_utf8<wchar_t>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"#if defined(_LIBCPP_SHORT_WCHAR)\x0a"
"    uint16_t* _to = reinterpret_cast<uint16_t*>(to);\x0a"
"    uint16_t* _to_end = reinterpret_cast<uint16_t*>(to_end);\x0a"
"    uint16_t* _to_nxt = _to;\x0a"
"    result r = utf8_to_ucs2(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                            _Maxcode_, _Mode_);\x0a"
"#else\x0a"
"    uint32_t* _to = reinterpret_cast<uint32_t*>(to);\x0a"
"    uint32_t* _to_end = reinterpret_cast<uint32_t*>(to_end);\x0a"
"    uint32_t* _to_nxt = _to;\x0a"
"    result r = utf8_to_ucs4(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                            _Maxcode_, _Mode_);\x0a"
"#endif\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8<wchar_t>\x3a\x3aresult\x0a"
"__codecvt_utf8<wchar_t>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8<wchar_t>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf8<wchar_t>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8<wchar_t>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf8_to_ucs4_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8<wchar_t>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 7;\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf8<char16_t>\x0a"
"\x0a"
"__codecvt_utf8<char16_t>\x3a\x3aresult\x0a"
"__codecvt_utf8<char16_t>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint16_t* _frm = reinterpret_cast<const uint16_t*>(frm);\x0a"
"    const uint16_t* _frm_end = reinterpret_cast<const uint16_t*>(frm_end);\x0a"
"    const uint16_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = ucs2_to_utf8(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                            _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8<char16_t>\x3a\x3aresult\x0a"
"__codecvt_utf8<char16_t>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint16_t* _to = reinterpret_cast<uint16_t*>(to);\x0a"
"    uint16_t* _to_end = reinterpret_cast<uint16_t*>(to_end);\x0a"
"    uint16_t* _to_nxt = _to;\x0a"
"    result r = utf8_to_ucs2(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                            _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8<char16_t>\x3a\x3aresult\x0a"
"__codecvt_utf8<char16_t>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8<char16_t>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf8<char16_t>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8<char16_t>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf8_to_ucs2_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8<char16_t>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 6;\x0a"
"    return 3;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf8<char32_t>\x0a"
"\x0a"
"__codecvt_utf8<char32_t>\x3a\x3aresult\x0a"
"__codecvt_utf8<char32_t>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint32_t* _frm = reinterpret_cast<const uint32_t*>(frm);\x0a"
"    const uint32_t* _frm_end = reinterpret_cast<const uint32_t*>(frm_end);\x0a"
"    const uint32_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = ucs4_to_utf8(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                            _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8<char32_t>\x3a\x3aresult\x0a"
"__codecvt_utf8<char32_t>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint32_t* _to = reinterpret_cast<uint32_t*>(to);\x0a"
"    uint32_t* _to_end = reinterpret_cast<uint32_t*>(to_end);\x0a"
"    uint32_t* _to_nxt = _to;\x0a"
"    result r = utf8_to_ucs4(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                            _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8<char32_t>\x3a\x3aresult\x0a"
"__codecvt_utf8<char32_t>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8<char32_t>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf8<char32_t>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8<char32_t>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf8_to_ucs4_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8<char32_t>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 7;\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf16<wchar_t, false>\x0a"
"\x0a"
"__codecvt_utf16<wchar_t, false>\x3a\x3aresult\x0a"
"__codecvt_utf16<wchar_t, false>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint32_t* _frm = reinterpret_cast<const uint32_t*>(frm);\x0a"
"    const uint32_t* _frm_end = reinterpret_cast<const uint32_t*>(frm_end);\x0a"
"    const uint32_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = ucs4_to_utf16be(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<wchar_t, false>\x3a\x3aresult\x0a"
"__codecvt_utf16<wchar_t, false>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint32_t* _to = reinterpret_cast<uint32_t*>(to);\x0a"
"    uint32_t* _to_end = reinterpret_cast<uint32_t*>(to_end);\x0a"
"    uint32_t* _to_nxt = _to;\x0a"
"    result r = utf16be_to_ucs4(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<wchar_t, false>\x3a\x3aresult\x0a"
"__codecvt_utf16<wchar_t, false>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<wchar_t, false>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf16<wchar_t, false>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<wchar_t, false>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf16be_to_ucs4_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<wchar_t, false>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 6;\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf16<wchar_t, true>\x0a"
"\x0a"
"__codecvt_utf16<wchar_t, true>\x3a\x3aresult\x0a"
"__codecvt_utf16<wchar_t, true>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint32_t* _frm = reinterpret_cast<const uint32_t*>(frm);\x0a"
"    const uint32_t* _frm_end = reinterpret_cast<const uint32_t*>(frm_end);\x0a"
"    const uint32_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = ucs4_to_utf16le(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<wchar_t, true>\x3a\x3aresult\x0a"
"__codecvt_utf16<wchar_t, true>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint32_t* _to = reinterpret_cast<uint32_t*>(to);\x0a"
"    uint32_t* _to_end = reinterpret_cast<uint32_t*>(to_end);\x0a"
"    uint32_t* _to_nxt = _to;\x0a"
"    result r = utf16le_to_ucs4(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<wchar_t, true>\x3a\x3aresult\x0a"
"__codecvt_utf16<wchar_t, true>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<wchar_t, true>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf16<wchar_t, true>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<wchar_t, true>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf16le_to_ucs4_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<wchar_t, true>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 6;\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf16<char16_t, false>\x0a"
"\x0a"
"__codecvt_utf16<char16_t, false>\x3a\x3aresult\x0a"
"__codecvt_utf16<char16_t, false>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint16_t* _frm = reinterpret_cast<const uint16_t*>(frm);\x0a"
"    const uint16_t* _frm_end = reinterpret_cast<const uint16_t*>(frm_end);\x0a"
"    const uint16_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = ucs2_to_utf16be(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<char16_t, false>\x3a\x3aresult\x0a"
"__codecvt_utf16<char16_t, false>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint16_t* _to = reinterpret_cast<uint16_t*>(to);\x0a"
"    uint16_t* _to_end = reinterpret_cast<uint16_t*>(to_end);\x0a"
"    uint16_t* _to_nxt = _to;\x0a"
"    result r = utf16be_to_ucs2(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<char16_t, false>\x3a\x3aresult\x0a"
"__codecvt_utf16<char16_t, false>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char16_t, false>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf16<char16_t, false>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char16_t, false>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf16be_to_ucs2_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char16_t, false>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 4;\x0a"
"    return 2;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf16<char16_t, true>\x0a"
"\x0a"
"__codecvt_utf16<char16_t, true>\x3a\x3aresult\x0a"
"__codecvt_utf16<char16_t, true>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint16_t* _frm = reinterpret_cast<const uint16_t*>(frm);\x0a"
"    const uint16_t* _frm_end = reinterpret_cast<const uint16_t*>(frm_end);\x0a"
"    const uint16_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = ucs2_to_utf16le(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<char16_t, true>\x3a\x3aresult\x0a"
"__codecvt_utf16<char16_t, true>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint16_t* _to = reinterpret_cast<uint16_t*>(to);\x0a"
"    uint16_t* _to_end = reinterpret_cast<uint16_t*>(to_end);\x0a"
"    uint16_t* _to_nxt = _to;\x0a"
"    result r = utf16le_to_ucs2(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<char16_t, true>\x3a\x3aresult\x0a"
"__codecvt_utf16<char16_t, true>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char16_t, true>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf16<char16_t, true>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char16_t, true>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf16le_to_ucs2_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char16_t, true>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 4;\x0a"
"    return 2;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf16<char32_t, false>\x0a"
"\x0a"
"__codecvt_utf16<char32_t, false>\x3a\x3aresult\x0a"
"__codecvt_utf16<char32_t, false>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint32_t* _frm = reinterpret_cast<const uint32_t*>(frm);\x0a"
"    const uint32_t* _frm_end = reinterpret_cast<const uint32_t*>(frm_end);\x0a"
"    const uint32_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = ucs4_to_utf16be(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<char32_t, false>\x3a\x3aresult\x0a"
"__codecvt_utf16<char32_t, false>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint32_t* _to = reinterpret_cast<uint32_t*>(to);\x0a"
"    uint32_t* _to_end = reinterpret_cast<uint32_t*>(to_end);\x0a"
"    uint32_t* _to_nxt = _to;\x0a"
"    result r = utf16be_to_ucs4(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<char32_t, false>\x3a\x3aresult\x0a"
"__codecvt_utf16<char32_t, false>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char32_t, false>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf16<char32_t, false>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char32_t, false>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf16be_to_ucs4_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char32_t, false>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 6;\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf16<char32_t, true>\x0a"
"\x0a"
"__codecvt_utf16<char32_t, true>\x3a\x3aresult\x0a"
"__codecvt_utf16<char32_t, true>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint32_t* _frm = reinterpret_cast<const uint32_t*>(frm);\x0a"
"    const uint32_t* _frm_end = reinterpret_cast<const uint32_t*>(frm_end);\x0a"
"    const uint32_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = ucs4_to_utf16le(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<char32_t, true>\x3a\x3aresult\x0a"
"__codecvt_utf16<char32_t, true>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint32_t* _to = reinterpret_cast<uint32_t*>(to);\x0a"
"    uint32_t* _to_end = reinterpret_cast<uint32_t*>(to_end);\x0a"
"    uint32_t* _to_nxt = _to;\x0a"
"    result r = utf16le_to_ucs4(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                               _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf16<char32_t, true>\x3a\x3aresult\x0a"
"__codecvt_utf16<char32_t, true>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char32_t, true>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf16<char32_t, true>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char32_t, true>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf16le_to_ucs4_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf16<char32_t, true>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 6;\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf8_utf16<wchar_t>\x0a"
"\x0a"
"__codecvt_utf8_utf16<wchar_t>\x3a\x3aresult\x0a"
"__codecvt_utf8_utf16<wchar_t>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint32_t* _frm = reinterpret_cast<const uint32_t*>(frm);\x0a"
"    const uint32_t* _frm_end = reinterpret_cast<const uint32_t*>(frm_end);\x0a"
"    const uint32_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = utf16_to_utf8(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                             _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8_utf16<wchar_t>\x3a\x3aresult\x0a"
"__codecvt_utf8_utf16<wchar_t>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint32_t* _to = reinterpret_cast<uint32_t*>(to);\x0a"
"    uint32_t* _to_end = reinterpret_cast<uint32_t*>(to_end);\x0a"
"    uint32_t* _to_nxt = _to;\x0a"
"    result r = utf8_to_utf16(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                             _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8_utf16<wchar_t>\x3a\x3aresult\x0a"
"__codecvt_utf8_utf16<wchar_t>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8_utf16<wchar_t>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf8_utf16<wchar_t>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8_utf16<wchar_t>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf8_to_utf16_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8_utf16<wchar_t>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 7;\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf8_utf16<char16_t>\x0a"
"\x0a"
"__codecvt_utf8_utf16<char16_t>\x3a\x3aresult\x0a"
"__codecvt_utf8_utf16<char16_t>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint16_t* _frm = reinterpret_cast<const uint16_t*>(frm);\x0a"
"    const uint16_t* _frm_end = reinterpret_cast<const uint16_t*>(frm_end);\x0a"
"    const uint16_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = utf16_to_utf8(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                             _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8_utf16<char16_t>\x3a\x3aresult\x0a"
"__codecvt_utf8_utf16<char16_t>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint16_t* _to = reinterpret_cast<uint16_t*>(to);\x0a"
"    uint16_t* _to_end = reinterpret_cast<uint16_t*>(to_end);\x0a"
"    uint16_t* _to_nxt = _to;\x0a"
"    result r = utf8_to_utf16(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                             _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8_utf16<char16_t>\x3a\x3aresult\x0a"
"__codecvt_utf8_utf16<char16_t>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8_utf16<char16_t>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf8_utf16<char16_t>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8_utf16<char16_t>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf8_to_utf16_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8_utf16<char16_t>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 7;\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// __codecvt_utf8_utf16<char32_t>\x0a"
"\x0a"
"__codecvt_utf8_utf16<char32_t>\x3a\x3aresult\x0a"
"__codecvt_utf8_utf16<char32_t>\x3a\x3a""do_out(state_type\x26,\x0a"
"    const intern_type* frm, const intern_type* frm_end, const intern_type*\x26 frm_nxt,\x0a"
"    extern_type* to, extern_type* to_end, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint32_t* _frm = reinterpret_cast<const uint32_t*>(frm);\x0a"
"    const uint32_t* _frm_end = reinterpret_cast<const uint32_t*>(frm_end);\x0a"
"    const uint32_t* _frm_nxt = _frm;\x0a"
"    uint8_t* _to = reinterpret_cast<uint8_t*>(to);\x0a"
"    uint8_t* _to_end = reinterpret_cast<uint8_t*>(to_end);\x0a"
"    uint8_t* _to_nxt = _to;\x0a"
"    result r = utf16_to_utf8(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                             _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8_utf16<char32_t>\x3a\x3aresult\x0a"
"__codecvt_utf8_utf16<char32_t>\x3a\x3a""do_in(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, const extern_type*\x26 frm_nxt,\x0a"
"    intern_type* to, intern_type* to_end, intern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    const uint8_t* _frm_nxt = _frm;\x0a"
"    uint32_t* _to = reinterpret_cast<uint32_t*>(to);\x0a"
"    uint32_t* _to_end = reinterpret_cast<uint32_t*>(to_end);\x0a"
"    uint32_t* _to_nxt = _to;\x0a"
"    result r = utf8_to_utf16(_frm, _frm_end, _frm_nxt, _to, _to_end, _to_nxt,\x0a"
"                             _Maxcode_, _Mode_);\x0a"
"    frm_nxt = frm + (_frm_nxt - _frm);\x0a"
"    to_nxt = to + (_to_nxt - _to);\x0a"
"    return r;\x0a"
"}\x0a"
"\x0a"
"__codecvt_utf8_utf16<char32_t>\x3a\x3aresult\x0a"
"__codecvt_utf8_utf16<char32_t>\x3a\x3a""do_unshift(state_type\x26,\x0a"
"    extern_type* to, extern_type*, extern_type*\x26 to_nxt) const\x0a"
"{\x0a"
"    to_nxt = to;\x0a"
"    return noconv;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8_utf16<char32_t>\x3a\x3a""do_encoding() const  _NOEXCEPT\x0a"
"{\x0a"
"    return 0;\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__codecvt_utf8_utf16<char32_t>\x3a\x3a""do_always_noconv() const  _NOEXCEPT\x0a"
"{\x0a"
"    return false;\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8_utf16<char32_t>\x3a\x3a""do_length(state_type\x26,\x0a"
"    const extern_type* frm, const extern_type* frm_end, size_t mx) const\x0a"
"{\x0a"
"    const uint8_t* _frm = reinterpret_cast<const uint8_t*>(frm);\x0a"
"    const uint8_t* _frm_end = reinterpret_cast<const uint8_t*>(frm_end);\x0a"
"    return utf8_to_utf16_length(_frm, _frm_end, mx, _Maxcode_, _Mode_);\x0a"
"}\x0a"
"\x0a"
"int\x0a"
"__codecvt_utf8_utf16<char32_t>\x3a\x3a""do_max_length() const  _NOEXCEPT\x0a"
"{\x0a"
"    if (_Mode_ \x26 consume_header)\x0a"
"        return 7;\x0a"
"    return 4;\x0a"
"}\x0a"
"\x0a"
"// __narrow_to_utf8<16>\x0a"
"\x0a"
"__narrow_to_utf8<16>\x3a\x3a\x7e__narrow_to_utf8()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __narrow_to_utf8<32>\x0a"
"\x0a"
"__narrow_to_utf8<32>\x3a\x3a\x7e__narrow_to_utf8()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __widen_from_utf8<16>\x0a"
"\x0a"
"__widen_from_utf8<16>\x3a\x3a\x7e__widen_from_utf8()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"// __widen_from_utf8<32>\x0a"
"\x0a"
"__widen_from_utf8<32>\x3a\x3a\x7e__widen_from_utf8()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"\x0a"
"static bool checked_string_to_wchar_convert(wchar_t\x26 dest,\x0a"
"                                            const char* ptr,\x0a"
"                                            locale_t loc) {\x0a"
"  if (*ptr == '\x5c""0')\x0a"
"    return false;\x0a"
"  mbstate_t mb = {};\x0a"
"  wchar_t out;\x0a"
"  size_t ret = __libcpp_mbrtowc_l(\x26out, ptr, strlen(ptr), \x26mb, loc);\x0a"
"  if (ret == static_cast<size_t>(-1) \x7c\x7c ret == static_cast<size_t>(-2)) {\x0a"
"    return false;\x0a"
"  }\x0a"
"  dest = out;\x0a"
"  return true;\x0a"
"}\x0a"
"\x0a"
"static bool checked_string_to_char_convert(char\x26 dest,\x0a"
"                                           const char* ptr,\x0a"
"                                           locale_t __loc) {\x0a"
"  if (*ptr == '\x5c""0')\x0a"
"    return false;\x0a"
"  if (\x21ptr\x5b""1\x5d) {\x0a"
"    dest = *ptr;\x0a"
"    return true;\x0a"
"  }\x0a"
"  // First convert the MBS into a wide char then attempt to narrow it using\x0a"
"  // wctob_l.\x0a"
"  wchar_t wout;\x0a"
"  if (\x21""checked_string_to_wchar_convert(wout, ptr, __loc))\x0a"
"    return false;\x0a"
"  int res;\x0a"
"  if ((res = __libcpp_wctob_l(wout, __loc)) \x21= char_traits<char>\x3a\x3a""eof()) {\x0a"
"    dest = res;\x0a"
"    return true;\x0a"
"  }\x0a"
"  // FIXME\x3a Work around specific multibyte sequences that we can reasonable\x0a"
"  // translate into a different single byte.\x0a"
"  switch (wout) {\x0a"
"  case L'\x5cu202F'\x3a // narrow non-breaking space\x0a"
"  case L'\x5cu00A0'\x3a // non-breaking space\x0a"
"    dest = ' ';\x0a"
"    return true;\x0a"
"  default\x3a\x0a"
"    return false;\x0a"
"  }\x0a"
"  _LIBCPP_UNREACHABLE();\x0a"
"}\x0a"
"\x0a"
"\x0a"
"// numpunct<char> \x26\x26 numpunct<wchar_t>\x0a"
"\x0a"
"locale\x3a\x3aid numpunct< char  >\x3a\x3aid;\x0a"
"locale\x3a\x3aid numpunct<wchar_t>\x3a\x3aid;\x0a"
"\x0a"
"numpunct<char>\x3a\x3anumpunct(size_t refs)\x0a"
"    \x3a locale\x3a\x3a""facet(refs),\x0a"
"      __decimal_point_('.'),\x0a"
"      __thousands_sep_(',')\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"numpunct<wchar_t>\x3a\x3anumpunct(size_t refs)\x0a"
"    \x3a locale\x3a\x3a""facet(refs),\x0a"
"      __decimal_point_(L'.'),\x0a"
"      __thousands_sep_(L',')\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"numpunct<char>\x3a\x3a\x7enumpunct()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"numpunct<wchar_t>\x3a\x3a\x7enumpunct()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
" char   numpunct< char  >\x3a\x3a""do_decimal_point() const {return __decimal_point_;}\x0a"
"wchar_t numpunct<wchar_t>\x3a\x3a""do_decimal_point() const {return __decimal_point_;}\x0a"
"\x0a"
" char   numpunct< char  >\x3a\x3a""do_thousands_sep() const {return __thousands_sep_;}\x0a"
"wchar_t numpunct<wchar_t>\x3a\x3a""do_thousands_sep() const {return __thousands_sep_;}\x0a"
"\x0a"
"string numpunct< char  >\x3a\x3a""do_grouping() const {return __grouping_;}\x0a"
"string numpunct<wchar_t>\x3a\x3a""do_grouping() const {return __grouping_;}\x0a"
"\x0a"
" string numpunct< char  >\x3a\x3a""do_truename() const {return \x22true\x22;}\x0a"
"wstring numpunct<wchar_t>\x3a\x3a""do_truename() const {return L\x22true\x22;}\x0a"
"\x0a"
" string numpunct< char  >\x3a\x3a""do_falsename() const {return \x22""false\x22;}\x0a"
"wstring numpunct<wchar_t>\x3a\x3a""do_falsename() const {return L\x22""false\x22;}\x0a"
"\x0a"
"// numpunct_byname<char>\x0a"
"\x0a"
"numpunct_byname<char>\x3a\x3anumpunct_byname(const char* nm, size_t refs)\x0a"
"    \x3a numpunct<char>(refs)\x0a"
"{\x0a"
"    __init(nm);\x0a"
"}\x0a"
"\x0a"
"numpunct_byname<char>\x3a\x3anumpunct_byname(const string\x26 nm, size_t refs)\x0a"
"    \x3a numpunct<char>(refs)\x0a"
"{\x0a"
"    __init(nm.c_str());\x0a"
"}\x0a"
"\x0a"
"numpunct_byname<char>\x3a\x3a\x7enumpunct_byname()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"numpunct_byname<char>\x3a\x3a__init(const char* nm)\x0a"
"{\x0a"
"    if (strcmp(nm, \x22""C\x22) \x21= 0)\x0a"
"    {\x0a"
"        __libcpp_unique_locale loc(nm);\x0a"
"        if (\x21loc)\x0a"
"            __throw_runtime_error(\x22numpunct_byname<char>\x3a\x3anumpunct_byname\x22\x0a"
"                                \x22 failed to construct for \x22 + string(nm));\x0a"
"\x0a"
"        lconv* lc = __libcpp_localeconv_l(loc.get());\x0a"
"        checked_string_to_char_convert(__decimal_point_, lc->decimal_point,\x0a"
"                                       loc.get());\x0a"
"        checked_string_to_char_convert(__thousands_sep_, lc->thousands_sep,\x0a"
"                                       loc.get());\x0a"
"        __grouping_ = lc->grouping;\x0a"
"        // localization for truename and falsename is not available\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// numpunct_byname<wchar_t>\x0a"
"\x0a"
"numpunct_byname<wchar_t>\x3a\x3anumpunct_byname(const char* nm, size_t refs)\x0a"
"    \x3a numpunct<wchar_t>(refs)\x0a"
"{\x0a"
"    __init(nm);\x0a"
"}\x0a"
"\x0a"
"numpunct_byname<wchar_t>\x3a\x3anumpunct_byname(const string\x26 nm, size_t refs)\x0a"
"    \x3a numpunct<wchar_t>(refs)\x0a"
"{\x0a"
"    __init(nm.c_str());\x0a"
"}\x0a"
"\x0a"
"numpunct_byname<wchar_t>\x3a\x3a\x7enumpunct_byname()\x0a"
"{\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"numpunct_byname<wchar_t>\x3a\x3a__init(const char* nm)\x0a"
"{\x0a"
"    if (strcmp(nm, \x22""C\x22) \x21= 0)\x0a"
"    {\x0a"
"        __libcpp_unique_locale loc(nm);\x0a"
"        if (\x21loc)\x0a"
"            __throw_runtime_error(\x22numpunct_byname<wchar_t>\x3a\x3anumpunct_byname\x22\x0a"
"                                \x22 failed to construct for \x22 + string(nm));\x0a"
"\x0a"
"        lconv* lc = __libcpp_localeconv_l(loc.get());\x0a"
"        checked_string_to_wchar_convert(__decimal_point_, lc->decimal_point,\x0a"
"                                        loc.get());\x0a"
"        checked_string_to_wchar_convert(__thousands_sep_, lc->thousands_sep,\x0a"
"                                        loc.get());\x0a"
"        __grouping_ = lc->grouping;\x0a"
"        // localization for truename and falsename is not available\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"// num_get helpers\x0a"
"\x0a"
"int\x0a"
"__num_get_base\x3a\x3a__get_base(ios_base\x26 iob)\x0a"
"{\x0a"
"    ios_base\x3a\x3a""fmtflags __basefield = iob.flags() \x26 ios_base\x3a\x3a""basefield;\x0a"
"    if (__basefield == ios_base\x3a\x3aoct)\x0a"
"        return 8;\x0a"
"    else if (__basefield == ios_base\x3a\x3ahex)\x0a"
"        return 16;\x0a"
"    else if (__basefield == 0)\x0a"
"        return 0;\x0a"
"    return 10;\x0a"
"}\x0a"
"\x0a"
"const char __num_get_base\x3a\x3a__src\x5b""33\x5d = \x22""0123456789abcdefABCDEFxX+-pPiInN\x22;\x0a"
"\x0a"
"void\x0a"
"__check_grouping(const string\x26 __grouping, unsigned* __g, unsigned* __g_end,\x0a"
"                 ios_base\x3a\x3aiostate\x26 __err)\x0a"
"{\x0a"
"//  if the grouping pattern is empty _or_ there are no grouping bits, then do nothing\x0a"
"//  we always have at least a single entry in \x5b__g, __g_end); the end of the input sequence\x0a"
"\x09if (__grouping.size() \x21= 0 \x26\x26 __g_end - __g > 1)\x0a"
"    {\x0a"
"        reverse(__g, __g_end);\x0a"
"        const char* __ig = __grouping.data();\x0a"
"        const char* __eg = __ig + __grouping.size();\x0a"
"        for (unsigned* __r = __g; __r < __g_end-1; ++__r)\x0a"
"        {\x0a"
"            if (0 < *__ig \x26\x26 *__ig < numeric_limits<char>\x3a\x3amax())\x0a"
"            {\x0a"
"                if (static_cast<unsigned>(*__ig) \x21= *__r)\x0a"
"                {\x0a"
"                    __err = ios_base\x3a\x3a""failbit;\x0a"
"                    return;\x0a"
"                }\x0a"
"            }\x0a"
"            if (__eg - __ig > 1)\x0a"
"                ++__ig;\x0a"
"        }\x0a"
"        if (0 < *__ig \x26\x26 *__ig < numeric_limits<char>\x3a\x3amax())\x0a"
"        {\x0a"
"            if (static_cast<unsigned>(*__ig) < __g_end\x5b-1\x5d \x7c\x7c __g_end\x5b-1\x5d == 0)\x0a"
"                __err = ios_base\x3a\x3a""failbit;\x0a"
"        }\x0a"
"    }\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__num_put_base\x3a\x3a__format_int(char* __fmtp, const char* __len, bool __signd,\x0a"
"                             ios_base\x3a\x3a""fmtflags __flags)\x0a"
"{\x0a"
"    if (__flags \x26 ios_base\x3a\x3ashowpos)\x0a"
"        *__fmtp++ = '+';\x0a"
"    if (__flags \x26 ios_base\x3a\x3ashowbase)\x0a"
"        *__fmtp++ = '#';\x0a"
"    while(*__len)\x0a"
"        *__fmtp++ = *__len++;\x0a"
"    if ((__flags \x26 ios_base\x3a\x3a""basefield) == ios_base\x3a\x3aoct)\x0a"
"        *__fmtp = 'o';\x0a"
"    else if ((__flags \x26 ios_base\x3a\x3a""basefield) == ios_base\x3a\x3ahex)\x0a"
"    {\x0a"
"        if (__flags \x26 ios_base\x3a\x3auppercase)\x0a"
"            *__fmtp = 'X';\x0a"
"        else\x0a"
"            *__fmtp = 'x';\x0a"
"    }\x0a"
"    else if (__signd)\x0a"
"        *__fmtp = 'd';\x0a"
"    else\x0a"
"        *__fmtp = 'u';\x0a"
"}\x0a"
"\x0a"
"bool\x0a"
"__num_put_base\x3a\x3a__format_float(char* __fmtp, const char* __len,\x0a"
"                               ios_base\x3a\x3a""fmtflags __flags)\x0a"
"{\x0a"
"    bool specify_precision = true;\x0a"
"    if (__flags \x26 ios_base\x3a\x3ashowpos)\x0a"
"        *__fmtp++ = '+';\x0a"
"    if (__flags \x26 ios_base\x3a\x3ashowpoint)\x0a"
"        *__fmtp++ = '#';\x0a"
"    ios_base\x3a\x3a""fmtflags floatfield = __flags \x26 ios_base\x3a\x3a""floatfield;\x0a"
"    bool uppercase = (__flags \x26 ios_base\x3a\x3auppercase) \x21= 0;\x0a"
"    if (floatfield == (ios_base\x3a\x3a""fixed \x7c ios_base\x3a\x3ascientific))\x0a"
"        specify_precision = false;\x0a"
"    else\x0a"
"    {\x0a"
"        *__fmtp++ = '.';\x0a"
"        *__fmtp++ = '*';\x0a"
"    }\x0a"
"    while(*__len)\x0a"
"        *__fmtp++ = *__len++;\x0a"
"    if (floatfield == ios_base\x3a\x3a""fixed)\x0a"
"    {\x0a"
"        if (uppercase)\x0a"
"            *__fmtp = 'F';\x0a"
"        else\x0a"
"            *__fmtp = 'f';\x0a"
"    }\x0a"
"    else if (floatfield == ios_base\x3a\x3ascientific)\x0a"
"    {\x0a"
"        if (uppercase)\x0a"
"            *__fmtp = 'E';\x0a"
"        else\x0a"
"            *__fmtp = 'e';\x0a"
"    }\x0a"
"    else if (floatfield == (ios_base\x3a\x3a""fixed \x7c ios_base\x3a\x3ascientific))\x0a"
"    {\x0a"
"        if (uppercase)\x0a"
"            *__fmtp = 'A';\x0a"
"        else\x0a"
"            *__fmtp = 'a';\x0a"
"    }\x0a"
"    else\x0a"
"    {\x0a"
"        if (uppercase)\x0a"
"            *__fmtp = 'G';\x0a"
"        else\x0a"
"            *__fmtp = 'g';\x0a"
"    }\x0a"
"    return specify_precision;\x0a"
"}\x0a"
"\x0a"
"char*\x0a"
"__num_put_base\x3a\x3a__identify_padding(char* __nb, char* __ne,\x0a"
"                                   const ios_base\x26 __iob)\x0a"
"{\x0a"
"    switch (__iob.flags() \x26 ios_base\x3a\x3a""adjustfield)\x0a"
"    {\x0a"
"    case ios_base\x3a\x3ainternal\x3a\x0a"
"        if (__nb\x5b""0\x5d == '-' \x7c\x7c __nb\x5b""0\x5d == '+')\x0a"
"            return __nb+1;\x0a"
"        if (__ne - __nb >= 2 \x26\x26 __nb\x5b""0\x5d == '0'\x0a"
"                            \x26\x26 (__nb\x5b""1\x5d == 'x' \x7c\x7c __nb\x5b""1\x5d == 'X'))\x0a"
"            return __nb+2;\x0a"
"        break;\x0a"
"    case ios_base\x3a\x3aleft\x3a\x0a"
"        return __ne;\x0a"
"    case ios_base\x3a\x3aright\x3a\x0a"
"    default\x3a\x0a"
"        break;\x0a"
"    }\x0a"
"    return __nb;\x0a"
"}\x0a"
"\x0a"
"// time_get\x0a"
"\x0a"
"static\x0a"
"string*\x0a"
"init_weeks()\x0a"
"{\x0a"
"    static string weeks\x5b""14\x5d;\x0a"
"    weeks\x5b""0\x5d  = \x22Sunday\x22;\x0a"
"    weeks\x5b""1\x5d  = \x22Monday\x22;\x0a"
"    weeks\x5b""2\x5d  = \x22Tuesday\x22;\x0a"
"    weeks\x5b""3\x5d  = \x22Wednesday\x22;\x0a"
"    weeks\x5b""4\x5d  = \x22Thursday\x22;\x0a"
"    weeks\x5b""5\x5d  = \x22""Friday\x22;\x0a"
"    weeks\x5b""6\x5d  = \x22Saturday\x22;\x0a"
"    weeks\x5b""7\x5d  = \x22Sun\x22;\x0a"
"    weeks\x5b""8\x5d  = \x22Mon\x22;\x0a"
"    weeks\x5b""9\x5d  = \x22Tue\x22;\x0a"
"    weeks\x5b""10\x5d = \x22Wed\x22;\x0a"
"    weeks\x5b""11\x5d = \x22Thu\x22;\x0a"
"    weeks\x5b""12\x5d = \x22""Fri\x22;\x0a"
"    weeks\x5b""13\x5d = \x22Sat\x22;\x0a"
"    return weeks;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"wstring*\x0a"
"init_wweeks()\x0a"
"{\x0a"
"    static wstring weeks\x5b""14\x5d;\x0a"
"    weeks\x5b""0\x5d  = L\x22Sunday\x22;\x0a"
"    weeks\x5b""1\x5d  = L\x22Monday\x22;\x0a"
"    weeks\x5b""2\x5d  = L\x22Tuesday\x22;\x0a"
"    weeks\x5b""3\x5d  = L\x22Wednesday\x22;\x0a"
"    weeks\x5b""4\x5d  = L\x22Thursday\x22;\x0a"
"    weeks\x5b""5\x5d  = L\x22""Friday\x22;\x0a"
"    weeks\x5b""6\x5d  = L\x22Saturday\x22;\x0a"
"    weeks\x5b""7\x5d  = L\x22Sun\x22;\x0a"
"    weeks\x5b""8\x5d  = L\x22Mon\x22;\x0a"
"    weeks\x5b""9\x5d  = L\x22Tue\x22;\x0a"
"    weeks\x5b""10\x5d = L\x22Wed\x22;\x0a"
"    weeks\x5b""11\x5d = L\x22Thu\x22;\x0a"
"    weeks\x5b""12\x5d = L\x22""Fri\x22;\x0a"
"    weeks\x5b""13\x5d = L\x22Sat\x22;\x0a"
"    return weeks;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const string*\x0a"
"__time_get_c_storage<char>\x3a\x3a__weeks() const\x0a"
"{\x0a"
"    static const string* weeks = init_weeks();\x0a"
"    return weeks;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const wstring*\x0a"
"__time_get_c_storage<wchar_t>\x3a\x3a__weeks() const\x0a"
"{\x0a"
"    static const wstring* weeks = init_wweeks();\x0a"
"    return weeks;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"string*\x0a"
"init_months()\x0a"
"{\x0a"
"    static string months\x5b""24\x5d;\x0a"
"    months\x5b""0\x5d  = \x22January\x22;\x0a"
"    months\x5b""1\x5d  = \x22""February\x22;\x0a"
"    months\x5b""2\x5d  = \x22March\x22;\x0a"
"    months\x5b""3\x5d  = \x22""April\x22;\x0a"
"    months\x5b""4\x5d  = \x22May\x22;\x0a"
"    months\x5b""5\x5d  = \x22June\x22;\x0a"
"    months\x5b""6\x5d  = \x22July\x22;\x0a"
"    months\x5b""7\x5d  = \x22""August\x22;\x0a"
"    months\x5b""8\x5d  = \x22September\x22;\x0a"
"    months\x5b""9\x5d  = \x22October\x22;\x0a"
"    months\x5b""10\x5d = \x22November\x22;\x0a"
"    months\x5b""11\x5d = \x22""December\x22;\x0a"
"    months\x5b""12\x5d = \x22Jan\x22;\x0a"
"    months\x5b""13\x5d = \x22""Feb\x22;\x0a"
"    months\x5b""14\x5d = \x22Mar\x22;\x0a"
"    months\x5b""15\x5d = \x22""Apr\x22;\x0a"
"    months\x5b""16\x5d = \x22May\x22;\x0a"
"    months\x5b""17\x5d = \x22Jun\x22;\x0a"
"    months\x5b""18\x5d = \x22Jul\x22;\x0a"
"    months\x5b""19\x5d = \x22""Aug\x22;\x0a"
"    months\x5b""20\x5d = \x22Sep\x22;\x0a"
"    months\x5b""21\x5d = \x22Oct\x22;\x0a"
"    months\x5b""22\x5d = \x22Nov\x22;\x0a"
"    months\x5b""23\x5d = \x22""Dec\x22;\x0a"
"    return months;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"wstring*\x0a"
"init_wmonths()\x0a"
"{\x0a"
"    static wstring months\x5b""24\x5d;\x0a"
"    months\x5b""0\x5d  = L\x22January\x22;\x0a"
"    months\x5b""1\x5d  = L\x22""February\x22;\x0a"
"    months\x5b""2\x5d  = L\x22March\x22;\x0a"
"    months\x5b""3\x5d  = L\x22""April\x22;\x0a"
"    months\x5b""4\x5d  = L\x22May\x22;\x0a"
"    months\x5b""5\x5d  = L\x22June\x22;\x0a"
"    months\x5b""6\x5d  = L\x22July\x22;\x0a"
"    months\x5b""7\x5d  = L\x22""August\x22;\x0a"
"    months\x5b""8\x5d  = L\x22September\x22;\x0a"
"    months\x5b""9\x5d  = L\x22October\x22;\x0a"
"    months\x5b""10\x5d = L\x22November\x22;\x0a"
"    months\x5b""11\x5d = L\x22""December\x22;\x0a"
"    months\x5b""12\x5d = L\x22Jan\x22;\x0a"
"    months\x5b""13\x5d = L\x22""Feb\x22;\x0a"
"    months\x5b""14\x5d = L\x22Mar\x22;\x0a"
"    months\x5b""15\x5d = L\x22""Apr\x22;\x0a"
"    months\x5b""16\x5d = L\x22May\x22;\x0a"
"    months\x5b""17\x5d = L\x22Jun\x22;\x0a"
"    months\x5b""18\x5d = L\x22Jul\x22;\x0a"
"    months\x5b""19\x5d = L\x22""Aug\x22;\x0a"
"    months\x5b""20\x5d = L\x22Sep\x22;\x0a"
"    months\x5b""21\x5d = L\x22Oct\x22;\x0a"
"    months\x5b""22\x5d = L\x22Nov\x22;\x0a"
"    months\x5b""23\x5d = L\x22""Dec\x22;\x0a"
"    return months;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const string*\x0a"
"__time_get_c_storage<char>\x3a\x3a__months() const\x0a"
"{\x0a"
"    static const string* months = init_months();\x0a"
"    return months;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const wstring*\x0a"
"__time_get_c_storage<wchar_t>\x3a\x3a__months() const\x0a"
"{\x0a"
"    static const wstring* months = init_wmonths();\x0a"
"    return months;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"string*\x0a"
"init_am_pm()\x0a"
"{\x0a"
"    static string am_pm\x5b""2\x5d;\x0a"
"    am_pm\x5b""0\x5d  = \x22""AM\x22;\x0a"
"    am_pm\x5b""1\x5d  = \x22PM\x22;\x0a"
"    return am_pm;\x0a"
"}\x0a"
"\x0a"
"static\x0a"
"wstring*\x0a"
"init_wam_pm()\x0a"
"{\x0a"
"    static wstring am_pm\x5b""2\x5d;\x0a"
"    am_pm\x5b""0\x5d  = L\x22""AM\x22;\x0a"
"    am_pm\x5b""1\x5d  = L\x22PM\x22;\x0a"
"    return am_pm;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const string*\x0a"
"__time_get_c_storage<char>\x3a\x3a__am_pm() const\x0a"
"{\x0a"
"    static const string* am_pm = init_am_pm();\x0a"
"    return am_pm;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const wstring*\x0a"
"__time_get_c_storage<wchar_t>\x3a\x3a__am_pm() const\x0a"
"{\x0a"
"    static const wstring* am_pm = init_wam_pm();\x0a"
"    return am_pm;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const string\x26\x0a"
"__time_get_c_storage<char>\x3a\x3a__x() const\x0a"
"{\x0a"
"    static string s(\x22\x25m/\x25""d/\x25y\x22);\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const wstring\x26\x0a"
"__time_get_c_storage<wchar_t>\x3a\x3a__x() const\x0a"
"{\x0a"
"    static wstring s(L\x22\x25m/\x25""d/\x25y\x22);\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const string\x26\x0a"
"__time_get_c_storage<char>\x3a\x3a__X() const\x0a"
"{\x0a"
"    static string s(\x22\x25H\x3a\x25M\x3a\x25S\x22);\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const wstring\x26\x0a"
"__time_get_c_storage<wchar_t>\x3a\x3a__X() const\x0a"
"{\x0a"
"    static wstring s(L\x22\x25H\x3a\x25M\x3a\x25S\x22);\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const string\x26\x0a"
"__time_get_c_storage<char>\x3a\x3a__c() const\x0a"
"{\x0a"
"    static string s(\x22\x25""a \x25""b \x25""d \x25H\x3a\x25M\x3a\x25S \x25Y\x22);\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const wstring\x26\x0a"
"__time_get_c_storage<wchar_t>\x3a\x3a__c() const\x0a"
"{\x0a"
"    static wstring s(L\x22\x25""a \x25""b \x25""d \x25H\x3a\x25M\x3a\x25S \x25Y\x22);\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const string\x26\x0a"
"__time_get_c_storage<char>\x3a\x3a__r() const\x0a"
"{\x0a"
"    static string s(\x22\x25I\x3a\x25M\x3a\x25S \x25p\x22);\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"const wstring\x26\x0a"
"__time_get_c_storage<wchar_t>\x3a\x3a__r() const\x0a"
"{\x0a"
"    static wstring s(L\x22\x25I\x3a\x25M\x3a\x25S \x25p\x22);\x0a"
"    return s;\x0a"
"}\x0a"
"\x0a"
"// time_get_byname\x0a"
"\x0a"
"__time_get\x3a\x3a__time_get(const char* nm)\x0a"
"    \x3a __loc_(newlocale(LC_ALL_MASK, nm, 0))\x0a"
"{\x0a"
"    if (__loc_ == 0)\x0a"
"        __throw_runtime_error(\x22time_get_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + string(nm));\x0a"
"}\x0a"
"\x0a"
"__time_get\x3a\x3a__time_get(const string\x26 nm)\x0a"
"    \x3a __loc_(newlocale(LC_ALL_MASK, nm.c_str(), 0))\x0a"
"{\x0a"
"    if (__loc_ == 0)\x0a"
"        __throw_runtime_error(\x22time_get_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + nm);\x0a"
"}\x0a"
"\x0a"
"__time_get\x3a\x3a\x7e__time_get()\x0a"
"{\x0a"
"    freelocale(__loc_);\x0a"
"}\x0a"
"#if defined(__clang__)\x0a"
"#pragma clang diagnostic ignored \x22-Wmissing-field-initializers\x22\x0a"
"#endif\x0a"
"#if defined(__GNUG__)\x0a"
"#pragma GCC   diagnostic ignored \x22-Wmissing-field-initializers\x22\x0a"
"#endif\x0a"
"\x0a"
"template <>\x0a"
"string\x0a"
"__time_get_storage<char>\x3a\x3a__analyze(char fmt, const ctype<char>\x26 ct)\x0a"
"{\x0a"
"    tm t = {0};\x0a"
"    t.tm_sec = 59;\x0a"
"    t.tm_min = 55;\x0a"
"    t.tm_hour = 23;\x0a"
"    t.tm_mday = 31;\x0a"
"    t.tm_mon = 11;\x0a"
"    t.tm_year = 161;\x0a"
"    t.tm_wday = 6;\x0a"
"    t.tm_yday = 364;\x0a"
"    t.tm_isdst = -1;\x0a"
"    char buf\x5b""100\x5d;\x0a"
"    char f\x5b""3\x5d = {0};\x0a"
"    f\x5b""0\x5d = '\x25';\x0a"
"    f\x5b""1\x5d = fmt;\x0a"
"    size_t n = strftime_l(buf, countof(buf), f, \x26t, __loc_);\x0a"
"    char* bb = buf;\x0a"
"    char* be = buf + n;\x0a"
"    string result;\x0a"
"    while (bb \x21= be)\x0a"
"    {\x0a"
"        if (ct.is(ctype_base\x3a\x3aspace, *bb))\x0a"
"        {\x0a"
"            result.push_back(' ');\x0a"
"            for (++bb; bb \x21= be \x26\x26 ct.is(ctype_base\x3a\x3aspace, *bb); ++bb)\x0a"
"                ;\x0a"
"            continue;\x0a"
"        }\x0a"
"        char* w = bb;\x0a"
"        ios_base\x3a\x3aiostate err = ios_base\x3a\x3agoodbit;\x0a"
"        ptrdiff_t i = __scan_keyword(w, be, this->__weeks_, this->__weeks_+14,\x0a"
"                               ct, err, false)\x0a"
"                               - this->__weeks_;\x0a"
"        if (i < 14)\x0a"
"        {\x0a"
"            result.push_back('\x25');\x0a"
"            if (i < 7)\x0a"
"                result.push_back('A');\x0a"
"            else\x0a"
"                result.push_back('a');\x0a"
"            bb = w;\x0a"
"            continue;\x0a"
"        }\x0a"
"        w = bb;\x0a"
"        i = __scan_keyword(w, be, this->__months_, this->__months_+24,\x0a"
"                           ct, err, false)\x0a"
"                           - this->__months_;\x0a"
"        if (i < 24)\x0a"
"        {\x0a"
"            result.push_back('\x25');\x0a"
"            if (i < 12)\x0a"
"                result.push_back('B');\x0a"
"            else\x0a"
"                result.push_back('b');\x0a"
"            if (fmt == 'x' \x26\x26 ct.is(ctype_base\x3a\x3a""digit, this->__months_\x5bi\x5d\x5b""0\x5d))\x0a"
"                result.back() = 'm';\x0a"
"            bb = w;\x0a"
"            continue;\x0a"
"        }\x0a"
"        if (this->__am_pm_\x5b""0\x5d.size() + this->__am_pm_\x5b""1\x5d.size() > 0)\x0a"
"        {\x0a"
"            w = bb;\x0a"
"            i = __scan_keyword(w, be, this->__am_pm_, this->__am_pm_+2,\x0a"
"                               ct, err, false) - this->__am_pm_;\x0a"
"            if (i < 2)\x0a"
"            {\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('p');\x0a"
"                bb = w;\x0a"
"                continue;\x0a"
"            }\x0a"
"        }\x0a"
"        w = bb;\x0a"
"        if (ct.is(ctype_base\x3a\x3a""digit, *bb))\x0a"
"        {\x0a"
"            switch(__get_up_to_n_digits(bb, be, err, ct, 4))\x0a"
"            {\x0a"
"            case 6\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('w');\x0a"
"                break;\x0a"
"            case 7\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('u');\x0a"
"                break;\x0a"
"            case 11\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('I');\x0a"
"                break;\x0a"
"            case 12\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('m');\x0a"
"                break;\x0a"
"            case 23\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('H');\x0a"
"                break;\x0a"
"            case 31\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('d');\x0a"
"                break;\x0a"
"            case 55\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('M');\x0a"
"                break;\x0a"
"            case 59\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('S');\x0a"
"                break;\x0a"
"            case 61\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('y');\x0a"
"                break;\x0a"
"            case 364\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('j');\x0a"
"                break;\x0a"
"            case 2061\x3a\x0a"
"                result.push_back('\x25');\x0a"
"                result.push_back('Y');\x0a"
"                break;\x0a"
"            default\x3a\x0a"
"                for (; w \x21= bb; ++w)\x0a"
"                    result.push_back(*w);\x0a"
"                break;\x0a"
"            }\x0a"
"            continue;\x0a"
"        }\x0a"
"        if (*bb == '\x25')\x0a"
"        {\x0a"
"            result.push_back('\x25');\x0a"
"            result.push_back('\x25');\x0a"
"            ++bb;\x0a"
"            continue;\x0a"
"        }\x0a"
"        result.push_back(*bb);\x0a"
"        ++bb;\x0a"
"    }\x0a"
"    return result;\x0a"
"}\x0a"
"\x0a"
"#if defined(__clang__)\x0a"
"#pragma clang diagnostic ignored \x22-Wmissing-braces\x22\x0a"
"#endif\x0a"
"\x0a"
"template <>\x0a"
"wstring\x0a"
"__time_get_storage<wchar_t>\x3a\x3a__analyze(char fmt, const ctype<wchar_t>\x26 ct)\x0a"
"{\x0a"
"    tm t = {0};\x0a"
"    t.tm_sec = 59;\x0a"
"    t.tm_min = 55;\x0a"
"    t.tm_hour = 23;\x0a"
"    t.tm_mday = 31;\x0a"
"    t.tm_mon = 11;\x0a"
"    t.tm_year = 161;\x0a"
"    t.tm_wday = 6;\x0a"
"    t.tm_yday = 364;\x0a"
"    t.tm_isdst = -1;\x0a"
"    char buf\x5b""100\x5d;\x0a"
"    char f\x5b""3\x5d = {0};\x0a"
"    f\x5b""0\x5d = '\x25';\x0a"
"    f\x5b""1\x5d = fmt;\x0a"
"    strftime_l(buf, countof(buf), f, \x26t, __loc_);\x0a"
"    wchar_t wbuf\x5b""100\x5d;\x0a"
"    wchar_t* wbb = wbuf;\x0a"
"    mbstate_t mb = {0};\x0a"
"    const char* bb = buf;\x0a"
"    size_t j = __libcpp_mbsrtowcs_l( wbb, \x26""bb, countof(wbuf), \x26mb, __loc_);\x0a"
"    if (j == size_t(-1))\x0a"
"        __throw_runtime_error(\x22locale not supported\x22);\x0a"
"    wchar_t* wbe = wbb + j;\x0a"
"    wstring result;\x0a"
"    while (wbb \x21= wbe)\x0a"
"    {\x0a"
"        if (ct.is(ctype_base\x3a\x3aspace, *wbb))\x0a"
"        {\x0a"
"            result.push_back(L' ');\x0a"
"            for (++wbb; wbb \x21= wbe \x26\x26 ct.is(ctype_base\x3a\x3aspace, *wbb); ++wbb)\x0a"
"                ;\x0a"
"            continue;\x0a"
"        }\x0a"
"        wchar_t* w = wbb;\x0a"
"        ios_base\x3a\x3aiostate err = ios_base\x3a\x3agoodbit;\x0a"
"        ptrdiff_t i = __scan_keyword(w, wbe, this->__weeks_, this->__weeks_+14,\x0a"
"                               ct, err, false)\x0a"
"                               - this->__weeks_;\x0a"
"        if (i < 14)\x0a"
"        {\x0a"
"            result.push_back(L'\x25');\x0a"
"            if (i < 7)\x0a"
"                result.push_back(L'A');\x0a"
"            else\x0a"
"                result.push_back(L'a');\x0a"
"            wbb = w;\x0a"
"            continue;\x0a"
"        }\x0a"
"        w = wbb;\x0a"
"        i = __scan_keyword(w, wbe, this->__months_, this->__months_+24,\x0a"
"                           ct, err, false)\x0a"
"                           - this->__months_;\x0a"
"        if (i < 24)\x0a"
"        {\x0a"
"            result.push_back(L'\x25');\x0a"
"            if (i < 12)\x0a"
"                result.push_back(L'B');\x0a"
"            else\x0a"
"                result.push_back(L'b');\x0a"
"            if (fmt == 'x' \x26\x26 ct.is(ctype_base\x3a\x3a""digit, this->__months_\x5bi\x5d\x5b""0\x5d))\x0a"
"                result.back() = L'm';\x0a"
"            wbb = w;\x0a"
"            continue;\x0a"
"        }\x0a"
"        if (this->__am_pm_\x5b""0\x5d.size() + this->__am_pm_\x5b""1\x5d.size() > 0)\x0a"
"        {\x0a"
"            w = wbb;\x0a"
"            i = __scan_keyword(w, wbe, this->__am_pm_, this->__am_pm_+2,\x0a"
"                               ct, err, false) - this->__am_pm_;\x0a"
"            if (i < 2)\x0a"
"            {\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'p');\x0a"
"                wbb = w;\x0a"
"                continue;\x0a"
"            }\x0a"
"        }\x0a"
"        w = wbb;\x0a"
"        if (ct.is(ctype_base\x3a\x3a""digit, *wbb))\x0a"
"        {\x0a"
"            switch(__get_up_to_n_digits(wbb, wbe, err, ct, 4))\x0a"
"            {\x0a"
"            case 6\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'w');\x0a"
"                break;\x0a"
"            case 7\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'u');\x0a"
"                break;\x0a"
"            case 11\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'I');\x0a"
"                break;\x0a"
"            case 12\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'm');\x0a"
"                break;\x0a"
"            case 23\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'H');\x0a"
"                break;\x0a"
"            case 31\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'd');\x0a"
"                break;\x0a"
"            case 55\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'M');\x0a"
"                break;\x0a"
"            case 59\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'S');\x0a"
"                break;\x0a"
"            case 61\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'y');\x0a"
"                break;\x0a"
"            case 364\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'j');\x0a"
"                break;\x0a"
"            case 2061\x3a\x0a"
"                result.push_back(L'\x25');\x0a"
"                result.push_back(L'Y');\x0a"
"                break;\x0a"
"            default\x3a\x0a"
"                for (; w \x21= wbb; ++w)\x0a"
"                    result.push_back(*w);\x0a"
"                break;\x0a"
"            }\x0a"
"            continue;\x0a"
"        }\x0a"
"        if (ct.narrow(*wbb, 0) == '\x25')\x0a"
"        {\x0a"
"            result.push_back(L'\x25');\x0a"
"            result.push_back(L'\x25');\x0a"
"            ++wbb;\x0a"
"            continue;\x0a"
"        }\x0a"
"        result.push_back(*wbb);\x0a"
"        ++wbb;\x0a"
"    }\x0a"
"    return result;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"void\x0a"
"__time_get_storage<char>\x3a\x3ainit(const ctype<char>\x26 ct)\x0a"
"{\x0a"
"    tm t = {0};\x0a"
"    char buf\x5b""100\x5d;\x0a"
"    // __weeks_\x0a"
"    for (int i = 0; i < 7; ++i)\x0a"
"    {\x0a"
"        t.tm_wday = i;\x0a"
"        strftime_l(buf, countof(buf), \x22\x25""A\x22, \x26t, __loc_);\x0a"
"        __weeks_\x5bi\x5d = buf;\x0a"
"        strftime_l(buf, countof(buf), \x22\x25""a\x22, \x26t, __loc_);\x0a"
"        __weeks_\x5bi+7\x5d = buf;\x0a"
"    }\x0a"
"    // __months_\x0a"
"    for (int i = 0; i < 12; ++i)\x0a"
"    {\x0a"
"        t.tm_mon = i;\x0a"
"        strftime_l(buf, countof(buf), \x22\x25""B\x22, \x26t, __loc_);\x0a"
"        __months_\x5bi\x5d = buf;\x0a"
"        strftime_l(buf, countof(buf), \x22\x25""b\x22, \x26t, __loc_);\x0a"
"        __months_\x5bi+12\x5d = buf;\x0a"
"    }\x0a"
"    // __am_pm_\x0a"
"    t.tm_hour = 1;\x0a"
"    strftime_l(buf, countof(buf), \x22\x25p\x22, \x26t, __loc_);\x0a"
"    __am_pm_\x5b""0\x5d = buf;\x0a"
"    t.tm_hour = 13;\x0a"
"    strftime_l(buf, countof(buf), \x22\x25p\x22, \x26t, __loc_);\x0a"
"    __am_pm_\x5b""1\x5d = buf;\x0a"
"    __c_ = __analyze('c', ct);\x0a"
"    __r_ = __analyze('r', ct);\x0a"
"    __x_ = __analyze('x', ct);\x0a"
"    __X_ = __analyze('X', ct);\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"void\x0a"
"__time_get_storage<wchar_t>\x3a\x3ainit(const ctype<wchar_t>\x26 ct)\x0a"
"{\x0a"
"    tm t = {0};\x0a"
"    char buf\x5b""100\x5d;\x0a"
"    wchar_t wbuf\x5b""100\x5d;\x0a"
"    wchar_t* wbe;\x0a"
"    mbstate_t mb = {0};\x0a"
"    // __weeks_\x0a"
"    for (int i = 0; i < 7; ++i)\x0a"
"    {\x0a"
"        t.tm_wday = i;\x0a"
"        strftime_l(buf, countof(buf), \x22\x25""A\x22, \x26t, __loc_);\x0a"
"        mb = mbstate_t();\x0a"
"        const char* bb = buf;\x0a"
"        size_t j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, __loc_);\x0a"
"        if (j == size_t(-1))\x0a"
"            __throw_runtime_error(\x22locale not supported\x22);\x0a"
"        wbe = wbuf + j;\x0a"
"        __weeks_\x5bi\x5d.assign(wbuf, wbe);\x0a"
"        strftime_l(buf, countof(buf), \x22\x25""a\x22, \x26t, __loc_);\x0a"
"        mb = mbstate_t();\x0a"
"        bb = buf;\x0a"
"        j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, __loc_);\x0a"
"        if (j == size_t(-1))\x0a"
"            __throw_runtime_error(\x22locale not supported\x22);\x0a"
"        wbe = wbuf + j;\x0a"
"        __weeks_\x5bi+7\x5d.assign(wbuf, wbe);\x0a"
"    }\x0a"
"    // __months_\x0a"
"    for (int i = 0; i < 12; ++i)\x0a"
"    {\x0a"
"        t.tm_mon = i;\x0a"
"        strftime_l(buf, countof(buf), \x22\x25""B\x22, \x26t, __loc_);\x0a"
"        mb = mbstate_t();\x0a"
"        const char* bb = buf;\x0a"
"        size_t j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, __loc_);\x0a"
"        if (j == size_t(-1))\x0a"
"            __throw_runtime_error(\x22locale not supported\x22);\x0a"
"        wbe = wbuf + j;\x0a"
"        __months_\x5bi\x5d.assign(wbuf, wbe);\x0a"
"        strftime_l(buf, countof(buf), \x22\x25""b\x22, \x26t, __loc_);\x0a"
"        mb = mbstate_t();\x0a"
"        bb = buf;\x0a"
"        j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, __loc_);\x0a"
"        if (j == size_t(-1))\x0a"
"            __throw_runtime_error(\x22locale not supported\x22);\x0a"
"        wbe = wbuf + j;\x0a"
"        __months_\x5bi+12\x5d.assign(wbuf, wbe);\x0a"
"    }\x0a"
"    // __am_pm_\x0a"
"    t.tm_hour = 1;\x0a"
"    strftime_l(buf, countof(buf), \x22\x25p\x22, \x26t, __loc_);\x0a"
"    mb = mbstate_t();\x0a"
"    const char* bb = buf;\x0a"
"    size_t j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, __loc_);\x0a"
"    if (j == size_t(-1))\x0a"
"        __throw_runtime_error(\x22locale not supported\x22);\x0a"
"    wbe = wbuf + j;\x0a"
"    __am_pm_\x5b""0\x5d.assign(wbuf, wbe);\x0a"
"    t.tm_hour = 13;\x0a"
"    strftime_l(buf, countof(buf), \x22\x25p\x22, \x26t, __loc_);\x0a"
"    mb = mbstate_t();\x0a"
"    bb = buf;\x0a"
"    j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, __loc_);\x0a"
"    if (j == size_t(-1))\x0a"
"        __throw_runtime_error(\x22locale not supported\x22);\x0a"
"    wbe = wbuf + j;\x0a"
"    __am_pm_\x5b""1\x5d.assign(wbuf, wbe);\x0a"
"    __c_ = __analyze('c', ct);\x0a"
"    __r_ = __analyze('r', ct);\x0a"
"    __x_ = __analyze('x', ct);\x0a"
"    __X_ = __analyze('X', ct);\x0a"
"}\x0a"
"\x0a"
"template <class CharT>\x0a"
"struct _LIBCPP_HIDDEN __time_get_temp\x0a"
"    \x3a public ctype_byname<CharT>\x0a"
"{\x0a"
"    explicit __time_get_temp(const char* nm)\x0a"
"        \x3a ctype_byname<CharT>(nm, 1) {}\x0a"
"    explicit __time_get_temp(const string\x26 nm)\x0a"
"        \x3a ctype_byname<CharT>(nm, 1) {}\x0a"
"};\x0a"
"\x0a"
"template <>\x0a"
"__time_get_storage<char>\x3a\x3a__time_get_storage(const char* __nm)\x0a"
"    \x3a __time_get(__nm)\x0a"
"{\x0a"
"    const __time_get_temp<char> ct(__nm);\x0a"
"    init(ct);\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"__time_get_storage<char>\x3a\x3a__time_get_storage(const string\x26 __nm)\x0a"
"    \x3a __time_get(__nm)\x0a"
"{\x0a"
"    const __time_get_temp<char> ct(__nm);\x0a"
"    init(ct);\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"__time_get_storage<wchar_t>\x3a\x3a__time_get_storage(const char* __nm)\x0a"
"    \x3a __time_get(__nm)\x0a"
"{\x0a"
"    const __time_get_temp<wchar_t> ct(__nm);\x0a"
"    init(ct);\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"__time_get_storage<wchar_t>\x3a\x3a__time_get_storage(const string\x26 __nm)\x0a"
"    \x3a __time_get(__nm)\x0a"
"{\x0a"
"    const __time_get_temp<wchar_t> ct(__nm);\x0a"
"    init(ct);\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"time_base\x3a\x3a""dateorder\x0a"
"__time_get_storage<char>\x3a\x3a__do_date_order() const\x0a"
"{\x0a"
"    unsigned i;\x0a"
"    for (i = 0; i < __x_.size(); ++i)\x0a"
"        if (__x_\x5bi\x5d == '\x25')\x0a"
"            break;\x0a"
"    ++i;\x0a"
"    switch (__x_\x5bi\x5d)\x0a"
"    {\x0a"
"    case 'y'\x3a\x0a"
"    case 'Y'\x3a\x0a"
"        for (++i; i < __x_.size(); ++i)\x0a"
"            if (__x_\x5bi\x5d == '\x25')\x0a"
"                break;\x0a"
"        if (i == __x_.size())\x0a"
"            break;\x0a"
"        ++i;\x0a"
"        switch (__x_\x5bi\x5d)\x0a"
"        {\x0a"
"        case 'm'\x3a\x0a"
"            for (++i; i < __x_.size(); ++i)\x0a"
"                if (__x_\x5bi\x5d == '\x25')\x0a"
"                    break;\x0a"
"            if (i == __x_.size())\x0a"
"                break;\x0a"
"            ++i;\x0a"
"            if (__x_\x5bi\x5d == 'd')\x0a"
"                return time_base\x3a\x3aymd;\x0a"
"            break;\x0a"
"        case 'd'\x3a\x0a"
"            for (++i; i < __x_.size(); ++i)\x0a"
"                if (__x_\x5bi\x5d == '\x25')\x0a"
"                    break;\x0a"
"            if (i == __x_.size())\x0a"
"                break;\x0a"
"            ++i;\x0a"
"            if (__x_\x5bi\x5d == 'm')\x0a"
"                return time_base\x3a\x3aydm;\x0a"
"            break;\x0a"
"        }\x0a"
"        break;\x0a"
"    case 'm'\x3a\x0a"
"        for (++i; i < __x_.size(); ++i)\x0a"
"            if (__x_\x5bi\x5d == '\x25')\x0a"
"                break;\x0a"
"        if (i == __x_.size())\x0a"
"            break;\x0a"
"        ++i;\x0a"
"        if (__x_\x5bi\x5d == 'd')\x0a"
"        {\x0a"
"            for (++i; i < __x_.size(); ++i)\x0a"
"                if (__x_\x5bi\x5d == '\x25')\x0a"
"                    break;\x0a"
"            if (i == __x_.size())\x0a"
"                break;\x0a"
"            ++i;\x0a"
"            if (__x_\x5bi\x5d == 'y' \x7c\x7c __x_\x5bi\x5d == 'Y')\x0a"
"                return time_base\x3a\x3amdy;\x0a"
"            break;\x0a"
"        }\x0a"
"        break;\x0a"
"    case 'd'\x3a\x0a"
"        for (++i; i < __x_.size(); ++i)\x0a"
"            if (__x_\x5bi\x5d == '\x25')\x0a"
"                break;\x0a"
"        if (i == __x_.size())\x0a"
"            break;\x0a"
"        ++i;\x0a"
"        if (__x_\x5bi\x5d == 'm')\x0a"
"        {\x0a"
"            for (++i; i < __x_.size(); ++i)\x0a"
"                if (__x_\x5bi\x5d == '\x25')\x0a"
"                    break;\x0a"
"            if (i == __x_.size())\x0a"
"                break;\x0a"
"            ++i;\x0a"
"            if (__x_\x5bi\x5d == 'y' \x7c\x7c __x_\x5bi\x5d == 'Y')\x0a"
"                return time_base\x3a\x3a""dmy;\x0a"
"            break;\x0a"
"        }\x0a"
"        break;\x0a"
"    }\x0a"
"    return time_base\x3a\x3ano_order;\x0a"
"}\x0a"
"\x0a"
"template <>\x0a"
"time_base\x3a\x3a""dateorder\x0a"
"__time_get_storage<wchar_t>\x3a\x3a__do_date_order() const\x0a"
"{\x0a"
"    unsigned i;\x0a"
"    for (i = 0; i < __x_.size(); ++i)\x0a"
"        if (__x_\x5bi\x5d == L'\x25')\x0a"
"            break;\x0a"
"    ++i;\x0a"
"    switch (__x_\x5bi\x5d)\x0a"
"    {\x0a"
"    case L'y'\x3a\x0a"
"    case L'Y'\x3a\x0a"
"        for (++i; i < __x_.size(); ++i)\x0a"
"            if (__x_\x5bi\x5d == L'\x25')\x0a"
"                break;\x0a"
"        if (i == __x_.size())\x0a"
"            break;\x0a"
"        ++i;\x0a"
"        switch (__x_\x5bi\x5d)\x0a"
"        {\x0a"
"        case L'm'\x3a\x0a"
"            for (++i; i < __x_.size(); ++i)\x0a"
"                if (__x_\x5bi\x5d == L'\x25')\x0a"
"                    break;\x0a"
"            if (i == __x_.size())\x0a"
"                break;\x0a"
"            ++i;\x0a"
"            if (__x_\x5bi\x5d == L'd')\x0a"
"                return time_base\x3a\x3aymd;\x0a"
"            break;\x0a"
"        case L'd'\x3a\x0a"
"            for (++i; i < __x_.size(); ++i)\x0a"
"                if (__x_\x5bi\x5d == L'\x25')\x0a"
"                    break;\x0a"
"            if (i == __x_.size())\x0a"
"                break;\x0a"
"            ++i;\x0a"
"            if (__x_\x5bi\x5d == L'm')\x0a"
"                return time_base\x3a\x3aydm;\x0a"
"            break;\x0a"
"        }\x0a"
"        break;\x0a"
"    case L'm'\x3a\x0a"
"        for (++i; i < __x_.size(); ++i)\x0a"
"            if (__x_\x5bi\x5d == L'\x25')\x0a"
"                break;\x0a"
"        if (i == __x_.size())\x0a"
"            break;\x0a"
"        ++i;\x0a"
"        if (__x_\x5bi\x5d == L'd')\x0a"
"        {\x0a"
"            for (++i; i < __x_.size(); ++i)\x0a"
"                if (__x_\x5bi\x5d == L'\x25')\x0a"
"                    break;\x0a"
"            if (i == __x_.size())\x0a"
"                break;\x0a"
"            ++i;\x0a"
"            if (__x_\x5bi\x5d == L'y' \x7c\x7c __x_\x5bi\x5d == L'Y')\x0a"
"                return time_base\x3a\x3amdy;\x0a"
"            break;\x0a"
"        }\x0a"
"        break;\x0a"
"    case L'd'\x3a\x0a"
"        for (++i; i < __x_.size(); ++i)\x0a"
"            if (__x_\x5bi\x5d == L'\x25')\x0a"
"                break;\x0a"
"        if (i == __x_.size())\x0a"
"            break;\x0a"
"        ++i;\x0a"
"        if (__x_\x5bi\x5d == L'm')\x0a"
"        {\x0a"
"            for (++i; i < __x_.size(); ++i)\x0a"
"                if (__x_\x5bi\x5d == L'\x25')\x0a"
"                    break;\x0a"
"            if (i == __x_.size())\x0a"
"                break;\x0a"
"            ++i;\x0a"
"            if (__x_\x5bi\x5d == L'y' \x7c\x7c __x_\x5bi\x5d == L'Y')\x0a"
"                return time_base\x3a\x3a""dmy;\x0a"
"            break;\x0a"
"        }\x0a"
"        break;\x0a"
"    }\x0a"
"    return time_base\x3a\x3ano_order;\x0a"
"}\x0a"
"\x0a"
"// time_put\x0a"
"\x0a"
"__time_put\x3a\x3a__time_put(const char* nm)\x0a"
"    \x3a __loc_(newlocale(LC_ALL_MASK, nm, 0))\x0a"
"{\x0a"
"    if (__loc_ == 0)\x0a"
"        __throw_runtime_error(\x22time_put_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + string(nm));\x0a"
"}\x0a"
"\x0a"
"__time_put\x3a\x3a__time_put(const string\x26 nm)\x0a"
"    \x3a __loc_(newlocale(LC_ALL_MASK, nm.c_str(), 0))\x0a"
"{\x0a"
"    if (__loc_ == 0)\x0a"
"        __throw_runtime_error(\x22time_put_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + nm);\x0a"
"}\x0a"
"\x0a"
"__time_put\x3a\x3a\x7e__time_put()\x0a"
"{\x0a"
"    if (__loc_ \x21= _LIBCPP_GET_C_LOCALE)\x0a"
"        freelocale(__loc_);\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__time_put\x3a\x3a__do_put(char* __nb, char*\x26 __ne, const tm* __tm,\x0a"
"                     char __fmt, char __mod) const\x0a"
"{\x0a"
"    char fmt\x5b\x5d = {'\x25', __fmt, __mod, 0};\x0a"
"    if (__mod \x21= 0)\x0a"
"        swap(fmt\x5b""1\x5d, fmt\x5b""2\x5d);\x0a"
"    size_t n = strftime_l(__nb, countof(__nb, __ne), fmt, __tm, __loc_);\x0a"
"    __ne = __nb + n;\x0a"
"}\x0a"
"\x0a"
"void\x0a"
"__time_put\x3a\x3a__do_put(wchar_t* __wb, wchar_t*\x26 __we, const tm* __tm,\x0a"
"                     char __fmt, char __mod) const\x0a"
"{\x0a"
"    char __nar\x5b""100\x5d;\x0a"
"    char* __ne = __nar + 100;\x0a"
"    __do_put(__nar, __ne, __tm, __fmt, __mod);\x0a"
"    mbstate_t mb = {0};\x0a"
"    const char* __nb = __nar;\x0a"
"    size_t j = __libcpp_mbsrtowcs_l(__wb, \x26__nb, countof(__wb, __we), \x26mb, __loc_);\x0a"
"    if (j == size_t(-1))\x0a"
"        __throw_runtime_error(\x22locale not supported\x22);\x0a"
"    __we = __wb + j;\x0a"
"}\x0a"
"\x0a"
"// moneypunct_byname\x0a"
"\x0a"
"template <class charT>\x0a"
"static\x0a"
"void\x0a"
"__init_pat(money_base\x3a\x3apattern\x26 pat, basic_string<charT>\x26 __curr_symbol_,\x0a"
"           bool intl, char cs_precedes, char sep_by_space, char sign_posn,\x0a"
"           charT space_char)\x0a"
"{\x0a"
"    const char sign = static_cast<char>(money_base\x3a\x3asign);\x0a"
"    const char space = static_cast<char>(money_base\x3a\x3aspace);\x0a"
"    const char none = static_cast<char>(money_base\x3a\x3anone);\x0a"
"    const char symbol = static_cast<char>(money_base\x3a\x3asymbol);\x0a"
"    const char value = static_cast<char>(money_base\x3a\x3avalue);\x0a"
"    const bool symbol_contains_sep = intl \x26\x26 __curr_symbol_.size() == 4;\x0a"
"\x0a"
"    // Comments on case branches reflect 'C11 7.11.2.1 The localeconv\x0a"
"    // function'. \x22Space between sign and symbol or value\x22 means that\x0a"
"    // if the sign is adjacent to the symbol, there's a space between\x0a"
"    // them, and otherwise there's a space between the sign and value.\x0a"
"    //\x0a"
"    // C11's localeconv specifies that the fourth character of an\x0a"
"    // international curr_symbol is used to separate the sign and\x0a"
"    // value when sep_by_space says to do so. C++ can't represent\x0a"
"    // that, so we just use a space.  When sep_by_space says to\x0a"
"    // separate the symbol and value-or-sign with a space, we rearrange the\x0a"
"    // curr_symbol to put its spacing character on the correct side of\x0a"
"    // the symbol.\x0a"
"    //\x0a"
"    // We also need to avoid adding an extra space between the sign\x0a"
"    // and value when the currency symbol is suppressed (by not\x0a"
"    // setting showbase).  We match glibc's strfmon by interpreting\x0a"
"    // sep_by_space==1 as \x22omit the space when the currency symbol is\x0a"
"    // absent\x22.\x0a"
"    //\x0a"
"    // Users who want to get this right should use ICU instead.\x0a"
"\x0a"
"    switch (cs_precedes)\x0a"
"    {\x0a"
"    case 0\x3a  // value before curr_symbol\x0a"
"        if (symbol_contains_sep) {\x0a"
"            // Move the separator to before the symbol, to place it\x0a"
"            // between the value and symbol.\x0a"
"            rotate(__curr_symbol_.begin(), __curr_symbol_.begin() + 3,\x0a"
"                   __curr_symbol_.end());\x0a"
"        }\x0a"
"        switch (sign_posn)\x0a"
"        {\x0a"
"        case 0\x3a  // Parentheses surround the quantity and currency symbol.\x0a"
"            pat.field\x5b""0\x5d = sign;\x0a"
"            pat.field\x5b""1\x5d = value;\x0a"
"            pat.field\x5b""2\x5d = none;  // Any space appears in the symbol.\x0a"
"            pat.field\x5b""3\x5d = symbol;\x0a"
"            switch (sep_by_space)\x0a"
"            {\x0a"
"            case 0\x3a  // No space separates the currency symbol and value.\x0a"
"                // This case may have changed between C99 and C11;\x0a"
"                // assume the currency symbol matches the intention.\x0a"
"            case 2\x3a  // Space between sign and currency or value.\x0a"
"                // The \x22sign\x22 is two parentheses, so no space here either.\x0a"
"                return;\x0a"
"            case 1\x3a  // Space between currency-and-sign or currency and value.\x0a"
"                if (\x21symbol_contains_sep) {\x0a"
"                    // We insert the space into the symbol instead of\x0a"
"                    // setting pat.field\x5b""2\x5d=space so that when\x0a"
"                    // showbase is not set, the space goes away too.\x0a"
"                    __curr_symbol_.insert(0, 1, space_char);\x0a"
"                }\x0a"
"                return;\x0a"
"            default\x3a\x0a"
"                break;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 1\x3a  // The sign string precedes the quantity and currency symbol.\x0a"
"            pat.field\x5b""0\x5d = sign;\x0a"
"            pat.field\x5b""3\x5d = symbol;\x0a"
"            switch (sep_by_space)\x0a"
"            {\x0a"
"            case 0\x3a  // No space separates the currency symbol and value.\x0a"
"                pat.field\x5b""1\x5d = value;\x0a"
"                pat.field\x5b""2\x5d = none;\x0a"
"                return;\x0a"
"            case 1\x3a  // Space between currency-and-sign or currency and value.\x0a"
"                pat.field\x5b""1\x5d = value;\x0a"
"                pat.field\x5b""2\x5d = none;\x0a"
"                if (\x21symbol_contains_sep) {\x0a"
"                    // We insert the space into the symbol instead of\x0a"
"                    // setting pat.field\x5b""2\x5d=space so that when\x0a"
"                    // showbase is not set, the space goes away too.\x0a"
"                    __curr_symbol_.insert(0, 1, space_char);\x0a"
"                }\x0a"
"                return;\x0a"
"            case 2\x3a  // Space between sign and currency or value.\x0a"
"                pat.field\x5b""1\x5d = space;\x0a"
"                pat.field\x5b""2\x5d = value;\x0a"
"                if (symbol_contains_sep) {\x0a"
"                    // Remove the separator from the symbol, since it\x0a"
"                    // has already appeared after the sign.\x0a"
"                    __curr_symbol_.erase(__curr_symbol_.begin());\x0a"
"                }\x0a"
"                return;\x0a"
"            default\x3a\x0a"
"                break;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 2\x3a  // The sign string succeeds the quantity and currency symbol.\x0a"
"            pat.field\x5b""0\x5d = value;\x0a"
"            pat.field\x5b""3\x5d = sign;\x0a"
"            switch (sep_by_space)\x0a"
"            {\x0a"
"            case 0\x3a  // No space separates the currency symbol and value.\x0a"
"                pat.field\x5b""1\x5d = none;\x0a"
"                pat.field\x5b""2\x5d = symbol;\x0a"
"                return;\x0a"
"            case 1\x3a  // Space between currency-and-sign or currency and value.\x0a"
"                if (\x21symbol_contains_sep) {\x0a"
"                    // We insert the space into the symbol instead of\x0a"
"                    // setting pat.field\x5b""1\x5d=space so that when\x0a"
"                    // showbase is not set, the space goes away too.\x0a"
"                    __curr_symbol_.insert(0, 1, space_char);\x0a"
"                }\x0a"
"                pat.field\x5b""1\x5d = none;\x0a"
"                pat.field\x5b""2\x5d = symbol;\x0a"
"                return;\x0a"
"            case 2\x3a  // Space between sign and currency or value.\x0a"
"                pat.field\x5b""1\x5d = symbol;\x0a"
"                pat.field\x5b""2\x5d = space;\x0a"
"                if (symbol_contains_sep) {\x0a"
"                    // Remove the separator from the symbol, since it\x0a"
"                    // should not be removed if showbase is absent.\x0a"
"                    __curr_symbol_.erase(__curr_symbol_.begin());\x0a"
"                }\x0a"
"                return;\x0a"
"            default\x3a\x0a"
"                break;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 3\x3a  // The sign string immediately precedes the currency symbol.\x0a"
"            pat.field\x5b""0\x5d = value;\x0a"
"            pat.field\x5b""3\x5d = symbol;\x0a"
"            switch (sep_by_space)\x0a"
"            {\x0a"
"            case 0\x3a  // No space separates the currency symbol and value.\x0a"
"                pat.field\x5b""1\x5d = none;\x0a"
"                pat.field\x5b""2\x5d = sign;\x0a"
"                return;\x0a"
"            case 1\x3a  // Space between currency-and-sign or currency and value.\x0a"
"                pat.field\x5b""1\x5d = space;\x0a"
"                pat.field\x5b""2\x5d = sign;\x0a"
"                if (symbol_contains_sep) {\x0a"
"                    // Remove the separator from the symbol, since it\x0a"
"                    // has already appeared before the sign.\x0a"
"                    __curr_symbol_.erase(__curr_symbol_.begin());\x0a"
"                }\x0a"
"                return;\x0a"
"            case 2\x3a  // Space between sign and currency or value.\x0a"
"                pat.field\x5b""1\x5d = sign;\x0a"
"                pat.field\x5b""2\x5d = none;\x0a"
"                if (\x21symbol_contains_sep) {\x0a"
"                    // We insert the space into the symbol instead of\x0a"
"                    // setting pat.field\x5b""2\x5d=space so that when\x0a"
"                    // showbase is not set, the space goes away too.\x0a"
"                    __curr_symbol_.insert(0, 1, space_char);\x0a"
"                }\x0a"
"                return;\x0a"
"            default\x3a\x0a"
"                break;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 4\x3a  // The sign string immediately succeeds the currency symbol.\x0a"
"            pat.field\x5b""0\x5d = value;\x0a"
"            pat.field\x5b""3\x5d = sign;\x0a"
"            switch (sep_by_space)\x0a"
"            {\x0a"
"            case 0\x3a  // No space separates the currency symbol and value.\x0a"
"                pat.field\x5b""1\x5d = none;\x0a"
"                pat.field\x5b""2\x5d = symbol;\x0a"
"                return;\x0a"
"            case 1\x3a  // Space between currency-and-sign or currency and value.\x0a"
"                pat.field\x5b""1\x5d = none;\x0a"
"                pat.field\x5b""2\x5d = symbol;\x0a"
"                if (\x21symbol_contains_sep) {\x0a"
"                    // We insert the space into the symbol instead of\x0a"
"                    // setting pat.field\x5b""1\x5d=space so that when\x0a"
"                    // showbase is not set, the space goes away too.\x0a"
"                    __curr_symbol_.insert(0, 1, space_char);\x0a"
"                }\x0a"
"                return;\x0a"
"            case 2\x3a  // Space between sign and currency or value.\x0a"
"                pat.field\x5b""1\x5d = symbol;\x0a"
"                pat.field\x5b""2\x5d = space;\x0a"
"                if (symbol_contains_sep) {\x0a"
"                    // Remove the separator from the symbol, since it\x0a"
"                    // should not disappear when showbase is absent.\x0a"
"                    __curr_symbol_.erase(__curr_symbol_.begin());\x0a"
"                }\x0a"
"                return;\x0a"
"            default\x3a\x0a"
"                break;\x0a"
"            }\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            break;\x0a"
"        }\x0a"
"        break;\x0a"
"    case 1\x3a  // curr_symbol before value\x0a"
"        switch (sign_posn)\x0a"
"        {\x0a"
"        case 0\x3a  // Parentheses surround the quantity and currency symbol.\x0a"
"            pat.field\x5b""0\x5d = sign;\x0a"
"            pat.field\x5b""1\x5d = symbol;\x0a"
"            pat.field\x5b""2\x5d = none;  // Any space appears in the symbol.\x0a"
"            pat.field\x5b""3\x5d = value;\x0a"
"            switch (sep_by_space)\x0a"
"            {\x0a"
"            case 0\x3a  // No space separates the currency symbol and value.\x0a"
"                // This case may have changed between C99 and C11;\x0a"
"                // assume the currency symbol matches the intention.\x0a"
"            case 2\x3a  // Space between sign and currency or value.\x0a"
"                // The \x22sign\x22 is two parentheses, so no space here either.\x0a"
"                return;\x0a"
"            case 1\x3a  // Space between currency-and-sign or currency and value.\x0a"
"                if (\x21symbol_contains_sep) {\x0a"
"                    // We insert the space into the symbol instead of\x0a"
"                    // setting pat.field\x5b""2\x5d=space so that when\x0a"
"                    // showbase is not set, the space goes away too.\x0a"
"                    __curr_symbol_.insert(0, 1, space_char);\x0a"
"                }\x0a"
"                return;\x0a"
"            default\x3a\x0a"
"                break;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 1\x3a  // The sign string precedes the quantity and currency symbol.\x0a"
"            pat.field\x5b""0\x5d = sign;\x0a"
"            pat.field\x5b""3\x5d = value;\x0a"
"            switch (sep_by_space)\x0a"
"            {\x0a"
"            case 0\x3a  // No space separates the currency symbol and value.\x0a"
"                pat.field\x5b""1\x5d = symbol;\x0a"
"                pat.field\x5b""2\x5d = none;\x0a"
"                return;\x0a"
"            case 1\x3a  // Space between currency-and-sign or currency and value.\x0a"
"                pat.field\x5b""1\x5d = symbol;\x0a"
"                pat.field\x5b""2\x5d = none;\x0a"
"                if (\x21symbol_contains_sep) {\x0a"
"                    // We insert the space into the symbol instead of\x0a"
"                    // setting pat.field\x5b""2\x5d=space so that when\x0a"
"                    // showbase is not set, the space goes away too.\x0a"
"                    __curr_symbol_.push_back(space_char);\x0a"
"                }\x0a"
"                return;\x0a"
"            case 2\x3a  // Space between sign and currency or value.\x0a"
"                pat.field\x5b""1\x5d = space;\x0a"
"                pat.field\x5b""2\x5d = symbol;\x0a"
"                if (symbol_contains_sep) {\x0a"
"                    // Remove the separator from the symbol, since it\x0a"
"                    // has already appeared after the sign.\x0a"
"                    __curr_symbol_.pop_back();\x0a"
"                }\x0a"
"                return;\x0a"
"            default\x3a\x0a"
"                break;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 2\x3a  // The sign string succeeds the quantity and currency symbol.\x0a"
"            pat.field\x5b""0\x5d = symbol;\x0a"
"            pat.field\x5b""3\x5d = sign;\x0a"
"            switch (sep_by_space)\x0a"
"            {\x0a"
"            case 0\x3a  // No space separates the currency symbol and value.\x0a"
"                pat.field\x5b""1\x5d = none;\x0a"
"                pat.field\x5b""2\x5d = value;\x0a"
"                return;\x0a"
"            case 1\x3a  // Space between currency-and-sign or currency and value.\x0a"
"                pat.field\x5b""1\x5d = none;\x0a"
"                pat.field\x5b""2\x5d = value;\x0a"
"                if (\x21symbol_contains_sep) {\x0a"
"                    // We insert the space into the symbol instead of\x0a"
"                    // setting pat.field\x5b""1\x5d=space so that when\x0a"
"                    // showbase is not set, the space goes away too.\x0a"
"                    __curr_symbol_.push_back(space_char);\x0a"
"                }\x0a"
"                return;\x0a"
"            case 2\x3a  // Space between sign and currency or value.\x0a"
"                pat.field\x5b""1\x5d = value;\x0a"
"                pat.field\x5b""2\x5d = space;\x0a"
"                if (symbol_contains_sep) {\x0a"
"                    // Remove the separator from the symbol, since it\x0a"
"                    // will appear before the sign.\x0a"
"                    __curr_symbol_.pop_back();\x0a"
"                }\x0a"
"                return;\x0a"
"            default\x3a\x0a"
"                break;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 3\x3a  // The sign string immediately precedes the currency symbol.\x0a"
"            pat.field\x5b""0\x5d = sign;\x0a"
"            pat.field\x5b""3\x5d = value;\x0a"
"            switch (sep_by_space)\x0a"
"            {\x0a"
"            case 0\x3a  // No space separates the currency symbol and value.\x0a"
"                pat.field\x5b""1\x5d = symbol;\x0a"
"                pat.field\x5b""2\x5d = none;\x0a"
"                return;\x0a"
"            case 1\x3a  // Space between currency-and-sign or currency and value.\x0a"
"                pat.field\x5b""1\x5d = symbol;\x0a"
"                pat.field\x5b""2\x5d = none;\x0a"
"                if (\x21symbol_contains_sep) {\x0a"
"                    // We insert the space into the symbol instead of\x0a"
"                    // setting pat.field\x5b""2\x5d=space so that when\x0a"
"                    // showbase is not set, the space goes away too.\x0a"
"                    __curr_symbol_.push_back(space_char);\x0a"
"                }\x0a"
"                return;\x0a"
"            case 2\x3a  // Space between sign and currency or value.\x0a"
"                pat.field\x5b""1\x5d = space;\x0a"
"                pat.field\x5b""2\x5d = symbol;\x0a"
"                if (symbol_contains_sep) {\x0a"
"                    // Remove the separator from the symbol, since it\x0a"
"                    // has already appeared after the sign.\x0a"
"                    __curr_symbol_.pop_back();\x0a"
"                }\x0a"
"                return;\x0a"
"            default\x3a\x0a"
"                break;\x0a"
"            }\x0a"
"            break;\x0a"
"        case 4\x3a  // The sign string immediately succeeds the currency symbol.\x0a"
"            pat.field\x5b""0\x5d = symbol;\x0a"
"            pat.field\x5b""3\x5d = value;\x0a"
"            switch (sep_by_space)\x0a"
"            {\x0a"
"            case 0\x3a  // No space separates the currency symbol and value.\x0a"
"                pat.field\x5b""1\x5d = sign;\x0a"
"                pat.field\x5b""2\x5d = none;\x0a"
"                return;\x0a"
"            case 1\x3a  // Space between currency-and-sign or currency and value.\x0a"
"                pat.field\x5b""1\x5d = sign;\x0a"
"                pat.field\x5b""2\x5d = space;\x0a"
"                if (symbol_contains_sep) {\x0a"
"                    // Remove the separator from the symbol, since it\x0a"
"                    // should not disappear when showbase is absent.\x0a"
"                    __curr_symbol_.pop_back();\x0a"
"                }\x0a"
"                return;\x0a"
"            case 2\x3a  // Space between sign and currency or value.\x0a"
"                pat.field\x5b""1\x5d = none;\x0a"
"                pat.field\x5b""2\x5d = sign;\x0a"
"                if (\x21symbol_contains_sep) {\x0a"
"                    // We insert the space into the symbol instead of\x0a"
"                    // setting pat.field\x5b""1\x5d=space so that when\x0a"
"                    // showbase is not set, the space goes away too.\x0a"
"                    __curr_symbol_.push_back(space_char);\x0a"
"                }\x0a"
"                return;\x0a"
"           default\x3a\x0a"
"                break;\x0a"
"            }\x0a"
"            break;\x0a"
"        default\x3a\x0a"
"            break;\x0a"
"        }\x0a"
"        break;\x0a"
"    default\x3a\x0a"
"        break;\x0a"
"    }\x0a"
"    pat.field\x5b""0\x5d = symbol;\x0a"
"    pat.field\x5b""1\x5d = sign;\x0a"
"    pat.field\x5b""2\x5d = none;\x0a"
"    pat.field\x5b""3\x5d = value;\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"void\x0a"
"moneypunct_byname<char, false>\x3a\x3ainit(const char* nm)\x0a"
"{\x0a"
"    typedef moneypunct<char, false> base;\x0a"
"    __libcpp_unique_locale loc(nm);\x0a"
"    if (\x21loc)\x0a"
"        __throw_runtime_error(\x22moneypunct_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + string(nm));\x0a"
"\x0a"
"    lconv* lc = __libcpp_localeconv_l(loc.get());\x0a"
"    if (\x21""checked_string_to_char_convert(__decimal_point_,\x0a"
"                                        lc->mon_decimal_point,\x0a"
"                                        loc.get()))\x0a"
"      __decimal_point_ = base\x3a\x3a""do_decimal_point();\x0a"
"    if (\x21""checked_string_to_char_convert(__thousands_sep_,\x0a"
"                                        lc->mon_thousands_sep,\x0a"
"                                        loc.get()))\x0a"
"      __thousands_sep_ = base\x3a\x3a""do_thousands_sep();\x0a"
"\x0a"
"    __grouping_ = lc->mon_grouping;\x0a"
"    __curr_symbol_ = lc->currency_symbol;\x0a"
"    if (lc->frac_digits \x21= CHAR_MAX)\x0a"
"        __frac_digits_ = lc->frac_digits;\x0a"
"    else\x0a"
"        __frac_digits_ = base\x3a\x3a""do_frac_digits();\x0a"
"    if (lc->p_sign_posn == 0)\x0a"
"        __positive_sign_ = \x22()\x22;\x0a"
"    else\x0a"
"        __positive_sign_ = lc->positive_sign;\x0a"
"    if (lc->n_sign_posn == 0)\x0a"
"        __negative_sign_ = \x22()\x22;\x0a"
"    else\x0a"
"        __negative_sign_ = lc->negative_sign;\x0a"
"    // Assume the positive and negative formats will want spaces in\x0a"
"    // the same places in curr_symbol since there's no way to\x0a"
"    // represent anything else.\x0a"
"    string_type __dummy_curr_symbol = __curr_symbol_;\x0a"
"    __init_pat(__pos_format_, __dummy_curr_symbol, false,\x0a"
"               lc->p_cs_precedes, lc->p_sep_by_space, lc->p_sign_posn, ' ');\x0a"
"    __init_pat(__neg_format_, __curr_symbol_, false,\x0a"
"               lc->n_cs_precedes, lc->n_sep_by_space, lc->n_sign_posn, ' ');\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"void\x0a"
"moneypunct_byname<char, true>\x3a\x3ainit(const char* nm)\x0a"
"{\x0a"
"    typedef moneypunct<char, true> base;\x0a"
"    __libcpp_unique_locale loc(nm);\x0a"
"    if (\x21loc)\x0a"
"        __throw_runtime_error(\x22moneypunct_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + string(nm));\x0a"
"\x0a"
"    lconv* lc = __libcpp_localeconv_l(loc.get());\x0a"
"    if (\x21""checked_string_to_char_convert(__decimal_point_,\x0a"
"                                        lc->mon_decimal_point,\x0a"
"                                        loc.get()))\x0a"
"      __decimal_point_ = base\x3a\x3a""do_decimal_point();\x0a"
"    if (\x21""checked_string_to_char_convert(__thousands_sep_,\x0a"
"                                        lc->mon_thousands_sep,\x0a"
"                                        loc.get()))\x0a"
"      __thousands_sep_ = base\x3a\x3a""do_thousands_sep();\x0a"
"    __grouping_ = lc->mon_grouping;\x0a"
"    __curr_symbol_ = lc->int_curr_symbol;\x0a"
"    if (lc->int_frac_digits \x21= CHAR_MAX)\x0a"
"        __frac_digits_ = lc->int_frac_digits;\x0a"
"    else\x0a"
"        __frac_digits_ = base\x3a\x3a""do_frac_digits();\x0a"
"#if defined(_LIBCPP_MSVCRT) \x7c\x7c defined(__MINGW32__)\x0a"
"    if (lc->p_sign_posn == 0)\x0a"
"#else // _LIBCPP_MSVCRT\x0a"
"    if (lc->int_p_sign_posn == 0)\x0a"
"#endif // \x21_LIBCPP_MSVCRT\x0a"
"        __positive_sign_ = \x22()\x22;\x0a"
"    else\x0a"
"        __positive_sign_ = lc->positive_sign;\x0a"
"#if defined(_LIBCPP_MSVCRT) \x7c\x7c defined(__MINGW32__)\x0a"
"    if(lc->n_sign_posn == 0)\x0a"
"#else // _LIBCPP_MSVCRT\x0a"
"    if (lc->int_n_sign_posn == 0)\x0a"
"#endif // \x21_LIBCPP_MSVCRT\x0a"
"        __negative_sign_ = \x22()\x22;\x0a"
"    else\x0a"
"        __negative_sign_ = lc->negative_sign;\x0a"
"    // Assume the positive and negative formats will want spaces in\x0a"
"    // the same places in curr_symbol since there's no way to\x0a"
"    // represent anything else.\x0a"
"    string_type __dummy_curr_symbol = __curr_symbol_;\x0a"
"#if defined(_LIBCPP_MSVCRT) \x7c\x7c defined(__MINGW32__)\x0a"
"    __init_pat(__pos_format_, __dummy_curr_symbol, true,\x0a"
"               lc->p_cs_precedes, lc->p_sep_by_space, lc->p_sign_posn, ' ');\x0a"
"    __init_pat(__neg_format_, __curr_symbol_, true,\x0a"
"               lc->n_cs_precedes, lc->n_sep_by_space, lc->n_sign_posn, ' ');\x0a"
"#else // _LIBCPP_MSVCRT\x0a"
"    __init_pat(__pos_format_, __dummy_curr_symbol, true,\x0a"
"               lc->int_p_cs_precedes, lc->int_p_sep_by_space,\x0a"
"               lc->int_p_sign_posn, ' ');\x0a"
"    __init_pat(__neg_format_, __curr_symbol_, true,\x0a"
"               lc->int_n_cs_precedes, lc->int_n_sep_by_space,\x0a"
"               lc->int_n_sign_posn, ' ');\x0a"
"#endif // \x21_LIBCPP_MSVCRT\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"void\x0a"
"moneypunct_byname<wchar_t, false>\x3a\x3ainit(const char* nm)\x0a"
"{\x0a"
"    typedef moneypunct<wchar_t, false> base;\x0a"
"    __libcpp_unique_locale loc(nm);\x0a"
"    if (\x21loc)\x0a"
"        __throw_runtime_error(\x22moneypunct_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + string(nm));\x0a"
"    lconv* lc = __libcpp_localeconv_l(loc.get());\x0a"
"    if (\x21""checked_string_to_wchar_convert(__decimal_point_,\x0a"
"                                         lc->mon_decimal_point,\x0a"
"                                         loc.get()))\x0a"
"      __decimal_point_ = base\x3a\x3a""do_decimal_point();\x0a"
"    if (\x21""checked_string_to_wchar_convert(__thousands_sep_,\x0a"
"                                         lc->mon_thousands_sep,\x0a"
"                                         loc.get()))\x0a"
"      __thousands_sep_ = base\x3a\x3a""do_thousands_sep();\x0a"
"    __grouping_ = lc->mon_grouping;\x0a"
"    wchar_t wbuf\x5b""100\x5d;\x0a"
"    mbstate_t mb = {0};\x0a"
"    const char* bb = lc->currency_symbol;\x0a"
"    size_t j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, loc.get());\x0a"
"    if (j == size_t(-1))\x0a"
"        __throw_runtime_error(\x22locale not supported\x22);\x0a"
"    wchar_t* wbe = wbuf + j;\x0a"
"    __curr_symbol_.assign(wbuf, wbe);\x0a"
"    if (lc->frac_digits \x21= CHAR_MAX)\x0a"
"        __frac_digits_ = lc->frac_digits;\x0a"
"    else\x0a"
"        __frac_digits_ = base\x3a\x3a""do_frac_digits();\x0a"
"    if (lc->p_sign_posn == 0)\x0a"
"        __positive_sign_ = L\x22()\x22;\x0a"
"    else\x0a"
"    {\x0a"
"        mb = mbstate_t();\x0a"
"        bb = lc->positive_sign;\x0a"
"        j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, loc.get());\x0a"
"        if (j == size_t(-1))\x0a"
"            __throw_runtime_error(\x22locale not supported\x22);\x0a"
"        wbe = wbuf + j;\x0a"
"        __positive_sign_.assign(wbuf, wbe);\x0a"
"    }\x0a"
"    if (lc->n_sign_posn == 0)\x0a"
"        __negative_sign_ = L\x22()\x22;\x0a"
"    else\x0a"
"    {\x0a"
"        mb = mbstate_t();\x0a"
"        bb = lc->negative_sign;\x0a"
"        j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, loc.get());\x0a"
"        if (j == size_t(-1))\x0a"
"            __throw_runtime_error(\x22locale not supported\x22);\x0a"
"        wbe = wbuf + j;\x0a"
"        __negative_sign_.assign(wbuf, wbe);\x0a"
"    }\x0a"
"    // Assume the positive and negative formats will want spaces in\x0a"
"    // the same places in curr_symbol since there's no way to\x0a"
"    // represent anything else.\x0a"
"    string_type __dummy_curr_symbol = __curr_symbol_;\x0a"
"    __init_pat(__pos_format_, __dummy_curr_symbol, false,\x0a"
"               lc->p_cs_precedes, lc->p_sep_by_space, lc->p_sign_posn, L' ');\x0a"
"    __init_pat(__neg_format_, __curr_symbol_, false,\x0a"
"               lc->n_cs_precedes, lc->n_sep_by_space, lc->n_sign_posn, L' ');\x0a"
"}\x0a"
"\x0a"
"template<>\x0a"
"void\x0a"
"moneypunct_byname<wchar_t, true>\x3a\x3ainit(const char* nm)\x0a"
"{\x0a"
"    typedef moneypunct<wchar_t, true> base;\x0a"
"    __libcpp_unique_locale loc(nm);\x0a"
"    if (\x21loc)\x0a"
"        __throw_runtime_error(\x22moneypunct_byname\x22\x0a"
"                            \x22 failed to construct for \x22 + string(nm));\x0a"
"\x0a"
"    lconv* lc = __libcpp_localeconv_l(loc.get());\x0a"
"    if (\x21""checked_string_to_wchar_convert(__decimal_point_,\x0a"
"                                         lc->mon_decimal_point,\x0a"
"                                         loc.get()))\x0a"
"      __decimal_point_ = base\x3a\x3a""do_decimal_point();\x0a"
"    if (\x21""checked_string_to_wchar_convert(__thousands_sep_,\x0a"
"                                         lc->mon_thousands_sep,\x0a"
"                                         loc.get()))\x0a"
"      __thousands_sep_ = base\x3a\x3a""do_thousands_sep();\x0a"
"    __grouping_ = lc->mon_grouping;\x0a"
"    wchar_t wbuf\x5b""100\x5d;\x0a"
"    mbstate_t mb = {0};\x0a"
"    const char* bb = lc->int_curr_symbol;\x0a"
"    size_t j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, loc.get());\x0a"
"    if (j == size_t(-1))\x0a"
"        __throw_runtime_error(\x22locale not supported\x22);\x0a"
"    wchar_t* wbe = wbuf + j;\x0a"
"    __curr_symbol_.assign(wbuf, wbe);\x0a"
"    if (lc->int_frac_digits \x21= CHAR_MAX)\x0a"
"        __frac_digits_ = lc->int_frac_digits;\x0a"
"    else\x0a"
"        __frac_digits_ = base\x3a\x3a""do_frac_digits();\x0a"
"#if defined(_LIBCPP_MSVCRT) \x7c\x7c defined(__MINGW32__)\x0a"
"    if (lc->p_sign_posn == 0)\x0a"
"#else // _LIBCPP_MSVCRT\x0a"
"    if (lc->int_p_sign_posn == 0)\x0a"
"#endif // \x21_LIBCPP_MSVCRT\x0a"
"        __positive_sign_ = L\x22()\x22;\x0a"
"    else\x0a"
"    {\x0a"
"        mb = mbstate_t();\x0a"
"        bb = lc->positive_sign;\x0a"
"        j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, loc.get());\x0a"
"        if (j == size_t(-1))\x0a"
"            __throw_runtime_error(\x22locale not supported\x22);\x0a"
"        wbe = wbuf + j;\x0a"
"        __positive_sign_.assign(wbuf, wbe);\x0a"
"    }\x0a"
"#if defined(_LIBCPP_MSVCRT) \x7c\x7c defined(__MINGW32__)\x0a"
"    if (lc->n_sign_posn == 0)\x0a"
"#else // _LIBCPP_MSVCRT\x0a"
"    if (lc->int_n_sign_posn == 0)\x0a"
"#endif // \x21_LIBCPP_MSVCRT\x0a"
"        __negative_sign_ = L\x22()\x22;\x0a"
"    else\x0a"
"    {\x0a"
"        mb = mbstate_t();\x0a"
"        bb = lc->negative_sign;\x0a"
"        j = __libcpp_mbsrtowcs_l(wbuf, \x26""bb, countof(wbuf), \x26mb, loc.get());\x0a"
"        if (j == size_t(-1))\x0a"
"            __throw_runtime_error(\x22locale not supported\x22);\x0a"
"        wbe = wbuf + j;\x0a"
"        __negative_sign_.assign(wbuf, wbe);\x0a"
"    }\x0a"
"    // Assume the positive and negative formats will want spaces in\x0a"
"    // the same places in curr_symbol since there's no way to\x0a"
"    // represent anything else.\x0a"
"    string_type __dummy_curr_symbol = __curr_symbol_;\x0a"
"#if defined(_LIBCPP_MSVCRT) \x7c\x7c defined(__MINGW32__)\x0a"
"    __init_pat(__pos_format_, __dummy_curr_symbol, true,\x0a"
"               lc->p_cs_precedes, lc->p_sep_by_space, lc->p_sign_posn, L' ');\x0a"
"    __init_pat(__neg_format_, __curr_symbol_, true,\x0a"
"               lc->n_cs_precedes, lc->n_sep_by_space, lc->n_sign_posn, L' ');\x0a"
"#else // _LIBCPP_MSVCRT\x0a"
"    __init_pat(__pos_format_, __dummy_curr_symbol, true,\x0a"
"               lc->int_p_cs_precedes, lc->int_p_sep_by_space,\x0a"
"               lc->int_p_sign_posn, L' ');\x0a"
"    __init_pat(__neg_format_, __curr_symbol_, true,\x0a"
"               lc->int_n_cs_precedes, lc->int_n_sep_by_space,\x0a"
"               lc->int_n_sign_posn, L' ');\x0a"
"#endif // \x21_LIBCPP_MSVCRT\x0a"
"}\x0a"
"\x0a"
"void __do_nothing(void*) {}\x0a"
"\x0a"
"void __throw_runtime_error(const char* msg)\x0a"
"{\x0a"
"#ifndef _LIBCPP_NO_EXCEPTIONS\x0a"
"    throw runtime_error(msg);\x0a"
"#else\x0a"
"    (void)msg;\x0a"
"    _VSTD\x3a\x3a""abort();\x0a"
"#endif\x0a"
"}\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS collate<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS collate<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS num_get<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS num_get<wchar_t>;\x0a"
"\x0a"
"template struct _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS __num_get<char>;\x0a"
"template struct _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS __num_get<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS num_put<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS num_put<wchar_t>;\x0a"
"\x0a"
"template struct _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS __num_put<char>;\x0a"
"template struct _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS __num_put<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS time_get<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS time_get<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS time_get_byname<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS time_get_byname<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS time_put<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS time_put<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS time_put_byname<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS time_put_byname<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS moneypunct<char, false>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS moneypunct<char, true>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS moneypunct<wchar_t, false>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS moneypunct<wchar_t, true>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS moneypunct_byname<char, false>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS moneypunct_byname<char, true>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS moneypunct_byname<wchar_t, false>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS moneypunct_byname<wchar_t, true>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS money_get<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS money_get<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS __money_get<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS __money_get<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS money_put<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS money_put<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS __money_put<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS __money_put<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS messages<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS messages<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS messages_byname<char>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS messages_byname<wchar_t>;\x0a"
"\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS codecvt_byname<char, char, mbstate_t>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS codecvt_byname<wchar_t, char, mbstate_t>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS codecvt_byname<char16_t, char, mbstate_t>;\x0a"
"template class _LIBCPP_CLASS_TEMPLATE_INSTANTIATION_VIS codecvt_byname<char32_t, char, mbstate_t>;\x0a"
"\x0a"
"_LIBCPP_END_NAMESPACE_STD\x0a"
"", 194128 ); }